-- MySQL dump 10.11
--
-- Host: localhost    Database: nolapro_clean
-- ------------------------------------------------------
-- Server version	5.0.95

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `accounttype`
--

DROP TABLE IF EXISTS `accounttype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `accounttype` (
  `id` int(11) NOT NULL default '0',
  `description` char(30) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `accounttype`
--

LOCK TABLES `accounttype` WRITE;
/*!40000 ALTER TABLE `accounttype` DISABLE KEYS */;
INSERT INTO `accounttype` VALUES (10,'Current Assets'),(11,'Fixed Assets'),(13,'Other Assets'),(21,'Current Liabilities'),(22,'Long Term Liabilities'),(23,'Other Liabilities'),(30,'Equity'),(40,'Retained Earnings'),(50,'Sales'),(60,'Sales Adjustments'),(70,'Cost of Goods Sold'),(80,'Expenses'),(90,'Other Income and Expense');
/*!40000 ALTER TABLE `accounttype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `achcode`
--

DROP TABLE IF EXISTS `achcode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `achcode` (
  `code` char(3) NOT NULL default '',
  `description` char(70) NOT NULL default '',
  UNIQUE KEY `code` (`code`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `achcode`
--

LOCK TABLES `achcode` WRITE;
/*!40000 ALTER TABLE `achcode` DISABLE KEYS */;
INSERT INTO `achcode` VALUES ('C01','Incorrect DFI Account Number'),('C02','Incorrect Transit/Routing Number'),('C03','Incorrect Transit/Routing Number and Incorrect DFI Account Number'),('C04','Incorrect Individual Name'),('C05','Incorrect Transaction Code'),('C06','Incorrect DFI Account Number and Incorrect Transaction Code'),('C07','Incorrect Transit/Routing, DFI Account Number, and Transaction Code'),('C08','Reserved'),('C09','Incorrect Individual Identification Number'),('C10','Incorrect Company Name'),('C11','Incorrect Company Identification'),('C12','Incorrect Company Name and Identification'),('C13','Addenda Format Error'),('C61','Misrouted Notification of Change'),('C62','Incorrect Trace Number'),('C63','Incorrect Company Identification Number'),('C64','Incorrect Individual Identification Number'),('C65','Incorrectly formatted corrected data'),('C66','Incorrect Discretinary Data'),('C67','Routing Number Not From Original Entry Detail Record'),('C68','DFI Account Number Not from Original Entry Detail Record'),('C69','Incorrect Transaction Code'),('R01','Insufficient Funds'),('R02','Account Closed'),('R03','No Account/Unable to Locate Account'),('R04','Invalid Account Number'),('R05','Reserved'),('R06','Returned per ODFIs Request'),('R07','Authorization Revoked by Customer'),('R08','Payment Stopped or Stop Payment on Item'),('R09','Uncollected Funds'),('R10','Customer Advises Not Authorized'),('R11','Check Truncation Entry Return'),('R12','Branch sold to Another OFI'),('R13','ROFI not qualified to participate'),('R14','Representment payee deceased or unable to continue in that capacity'),('R15','Beneficiary of account holder deceased'),('R16','Account frozen'),('R17','File record edit criteria'),('R18','Improper effective entry date'),('R19','Amount field error'),('R20','Non-Transaction Account'),('R21','Invalid company identification'),('R22','Invalid individual IO number'),('R23','Credit entry refused by receiver'),('R24','Duplicate entry'),('R25','Addenda error'),('R26','Mandatory field error'),('R27','Trace number error'),('R28','Routing Number Check Digit Error'),('R29','Corporate customer advises not authorized'),('R30','RDFI not participant in check truncation program'),('R31','Permissible return entry'),('R32','RDFI non-settlement'),('R33','Return of SCK entry'),('R34','Limited Participation DFI'),('R35','Return of Improper debit entry'),('R36','Return of Improper Credit Entry'),('R40','Return of ENR entry by Federal Government Agency (ENR Only)'),('R41','Invalid transaction code (ENR Only)'),('R42','Routing number/check digit error (ENR only)'),('R43','Invalid DFI account number (ENR Only)'),('R44','Invalid Individual ID number (ENR only)'),('R45','Invalid Individual name/company name (ENR only)'),('R46','Invalid representative payee indicator (ENR only)'),('R47','Duplicate Enrollment'),('R50','State Law affecting RCK Acceptance'),('R51','Item is Inelligible, Notice Not Provided, Signature not genuine'),('R52','Stop Payment on Item'),('R61','Misrouted return'),('R62','Incorrect Trace Number'),('R63','Incorrect Dollar Amount'),('R64','Incorrect Individual Identificaton'),('R65','Incorrect transaction code'),('R66','Incorrect Company Identification'),('R67','Duplicate Return'),('R68','Untimely Return'),('R69','Multiple Errors'),('R70','Permissible return entry not accepted'),('R71','Misrouted dishonored return'),('R72','Untimely dishonored return'),('R73','Timely original return'),('R74','Corrected return'),('R80','Cross-border payment coding error'),('R81','Non-Participant in cross-border program'),('R82','Invalid Foreign Receiving DFI Identification'),('R83','Foreign Receiving DFI Unable to Settle');
/*!40000 ALTER TABLE `achcode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `achfile`
--

DROP TABLE IF EXISTS `achfile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `achfile` (
  `id` int(11) NOT NULL auto_increment,
  `filecontents` blob NOT NULL,
  `description` varchar(10) NOT NULL default '',
  `totalcreditamount` decimal(19,4) NOT NULL default '0.0000',
  `totaldebitamount` decimal(19,4) NOT NULL default '0.0000',
  `totalrecords` int(11) NOT NULL default '0',
  `checkacctid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `sent` int(2) NOT NULL default '0',
  `sentdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `effectivedate` date NOT NULL default '0000-00-00',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `entryuserid` (`entryuserid`),
  KEY `checkacctid` (`checkacctid`),
  KEY `canceluserid` (`canceluserid`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `achfile`
--

LOCK TABLES `achfile` WRITE;
/*!40000 ALTER TABLE `achfile` DISABLE KEYS */;
/*!40000 ALTER TABLE `achfile` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `achfiledetail`
--

DROP TABLE IF EXISTS `achfiledetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `achfiledetail` (
  `id` int(11) NOT NULL auto_increment,
  `achfileid` int(11) NOT NULL default '0',
  `premployeeid` int(11) NOT NULL default '0',
  `bankaccountid` int(11) NOT NULL default '0',
  `achcode` char(3) NOT NULL default '',
  `routing` varchar(9) NOT NULL default '',
  `accountnumber` varchar(17) NOT NULL default '',
  `bankname` varchar(100) NOT NULL default '',
  `originalvoucher` varchar(50) NOT NULL default '',
  `recordtype` int(2) NOT NULL default '0',
  `recorddata` varchar(94) NOT NULL default '',
  `transactioncode` char(2) NOT NULL default '',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `name` varchar(100) NOT NULL default '',
  `tracenumber` varchar(15) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `premployeeid` (`premployeeid`),
  KEY `entryuserid` (`entryuserid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `achfileid` (`achfileid`),
  KEY `bankaccountid` (`bankaccountid`),
  KEY `canceluserid` (`canceluserid`),
  KEY `achcode` (`achcode`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `achfiledetail`
--

LOCK TABLES `achfiledetail` WRITE;
/*!40000 ALTER TABLE `achfiledetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `achfiledetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `achfiledownload`
--

DROP TABLE IF EXISTS `achfiledownload`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `achfiledownload` (
  `id` int(11) NOT NULL auto_increment,
  `achfileid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `downloaddate` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `userid` (`userid`),
  KEY `achfileid` (`achfileid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `achfiledownload`
--

LOCK TABLES `achfiledownload` WRITE;
/*!40000 ALTER TABLE `achfiledownload` DISABLE KEYS */;
/*!40000 ALTER TABLE `achfiledownload` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `achseq`
--

DROP TABLE IF EXISTS `achseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `achseq` (
  `id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `achseq`
--

LOCK TABLES `achseq` WRITE;
/*!40000 ALTER TABLE `achseq` DISABLE KEYS */;
INSERT INTO `achseq` VALUES (0);
/*!40000 ALTER TABLE `achseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `achtransaction`
--

DROP TABLE IF EXISTS `achtransaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `achtransaction` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `b2buserid` int(11) NOT NULL default '0',
  `customerbankid` int(11) NOT NULL default '0',
  `checkacctid` int(11) NOT NULL default '0',
  `ccaccountid` int(11) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `tablename` varchar(45) NOT NULL default '',
  `tableid` int(11) NOT NULL default '0',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `routingnumber` varchar(9) NOT NULL default '',
  `accountnumber` varchar(20) NOT NULL default '',
  `accounttype` varchar(20) NOT NULL default '',
  `accountname` varchar(50) NOT NULL default '',
  `bankname` varchar(50) NOT NULL default '',
  `echecktype` varchar(15) NOT NULL default '',
  `checknumber` varchar(20) NOT NULL default '',
  `transactionid` varchar(45) NOT NULL default '',
  `resultcode` char(1) NOT NULL default '',
  `resultreasoncode` int(11) NOT NULL default '0',
  `resultreasontext` varchar(255) NOT NULL default '',
  `returned` int(11) NOT NULL default '0',
  `returncode` char(3) NOT NULL default '',
  `returndate` datetime default NULL,
  `customerip` varchar(25) NOT NULL default '',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `b2buserid` (`b2buserid`),
  KEY `customerbankid` (`customerbankid`),
  KEY `checkacctid` (`checkacctid`),
  KEY `ccaccountid` (`ccaccountid`),
  KEY `glaccountid` (`glaccountid`),
  KEY `companyid` (`companyid`),
  KEY `tablename` (`tablename`),
  KEY `tableid` (`tableid`),
  KEY `transactionid` (`transactionid`),
  KEY `resultcode` (`resultcode`),
  KEY `entrydate` (`entrydate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `achtransaction`
--

LOCK TABLES `achtransaction` WRITE;
/*!40000 ALTER TABLE `achtransaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `achtransaction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `action`
--

DROP TABLE IF EXISTS `action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `action` (
  `id` int(11) NOT NULL default '0',
  `action` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `action`
--

LOCK TABLES `action` WRITE;
/*!40000 ALTER TABLE `action` DISABLE KEYS */;
INSERT INTO `action` VALUES (1,'Completed');
/*!40000 ALTER TABLE `action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `actionseq`
--

DROP TABLE IF EXISTS `actionseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `actionseq` (
  `id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `actionseq`
--

LOCK TABLES `actionseq` WRITE;
/*!40000 ALTER TABLE `actionseq` DISABLE KEYS */;
INSERT INTO `actionseq` VALUES (1);
/*!40000 ALTER TABLE `actionseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `activation`
--

DROP TABLE IF EXISTS `activation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `activation` (
  `id` int(11) NOT NULL auto_increment,
  `email` varchar(255) NOT NULL default '',
  `companyname` varchar(255) NOT NULL default '',
  `servername` varchar(255) NOT NULL default '',
  `ip` varchar(100) NOT NULL default '',
  `platform` varchar(100) default NULL,
  `act_att` int(11) default NULL,
  `osys` varchar(100) default NULL,
  `businesstype` varchar(100) NOT NULL default '',
  `phone` int(25) default NULL,
  `street` varchar(60) default NULL,
  `city` varchar(60) default NULL,
  `state` varchar(60) default NULL,
  `country` varchar(60) default NULL,
  `postal` varchar(25) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `activation`
--

LOCK TABLES `activation` WRITE;
/*!40000 ALTER TABLE `activation` DISABLE KEYS */;
/*!40000 ALTER TABLE `activation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `addedit_control`
--

DROP TABLE IF EXISTS `addedit_control`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `addedit_control` (
  `id` int(11) NOT NULL auto_increment,
  `tablename` varchar(250) NOT NULL,
  `fieldname` varchar(250) NOT NULL,
  `block` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `required` int(11) NOT NULL default '0',
  `defaultvalue` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `tablename` (`tablename`),
  KEY `block` (`block`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `addedit_control`
--

LOCK TABLES `addedit_control` WRITE;
/*!40000 ALTER TABLE `addedit_control` DISABLE KEYS */;
/*!40000 ALTER TABLE `addedit_control` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `address_format`
--

DROP TABLE IF EXISTS `address_format`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `address_format` (
  `address_format_id` int(5) NOT NULL auto_increment,
  `address_format` varchar(128) NOT NULL default '',
  `address_summary` varchar(48) NOT NULL default '',
  PRIMARY KEY  (`address_format_id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `address_format`
--

LOCK TABLES `address_format` WRITE;
/*!40000 ALTER TABLE `address_format` DISABLE KEYS */;
INSERT INTO `address_format` VALUES (1,'$firstname $lastname$cr$streets$cr$city, $postcode$cr$statecomma$country','$city / $country'),(2,'$firstname $lastname$cr$streets$cr$city, $state    $postcode$cr$country','$city, $state / $country'),(3,'$firstname $lastname$cr$streets$cr$city$cr$postcode - $statecomma$country','$city / $country'),(4,'$firstname $lastname$cr$streets$cr$city ($postcode)$cr$country','$postcode / $country');
/*!40000 ALTER TABLE `address_format` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ads`
--

DROP TABLE IF EXISTS `ads`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ads` (
  `location` varchar(45) NOT NULL,
  `html` text,
  `rate` float default '1',
  PRIMARY KEY  (`location`),
  UNIQUE KEY `location_UNIQUE` (`location`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ads`
--

LOCK TABLES `ads` WRITE;
/*!40000 ALTER TABLE `ads` DISABLE KEYS */;
/*!40000 ALTER TABLE `ads` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `airport`
--

DROP TABLE IF EXISTS `airport`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `airport` (
  `id` int(11) NOT NULL auto_increment,
  `vendorid` int(11) NOT NULL default '0',
  `airportcode` varchar(5) NOT NULL default '',
  `airportname` varchar(200) default NULL,
  `pfname` varchar(255) NOT NULL default '',
  `address1` varchar(100) NOT NULL default '',
  `address2` varchar(100) NOT NULL default '',
  `city` varchar(100) NOT NULL default '',
  `state` char(2) NOT NULL default '',
  `zip` varchar(10) NOT NULL default '',
  `description` text NOT NULL,
  `chargefullfee` int(11) NOT NULL default '0',
  `chargeparkingfee` int(11) NOT NULL default '0',
  `chargeairportfee` int(11) NOT NULL default '0',
  `chargefuelfee` int(11) NOT NULL default '0',
  `chargesalestax` int(11) NOT NULL default '0',
  `ta_commission_flat` decimal(12,4) NOT NULL default '0.0000',
  `ta_commission_percent` decimal(12,4) NOT NULL default '0.0000',
  `commission_flat` decimal(12,4) NOT NULL default '0.0000',
  `commission_percent` decimal(12,4) NOT NULL default '0.0000',
  `airport_fee_flat` decimal(12,4) NOT NULL default '0.0000',
  `airport_fee_percent` decimal(12,4) NOT NULL default '0.0000',
  `fuel_charge_flat` decimal(12,4) NOT NULL default '0.0000',
  `salestaxid` int(11) NOT NULL default '0',
  `sales_categoriesid` int(11) NOT NULL default '0',
  `glsalesid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `email` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `vendorid` (`vendorid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `airport`
--

LOCK TABLES `airport` WRITE;
/*!40000 ALTER TABLE `airport` DISABLE KEYS */;
/*!40000 ALTER TABLE `airport` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `airport_category`
--

DROP TABLE IF EXISTS `airport_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `airport_category` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `airport_category`
--

LOCK TABLES `airport_category` WRITE;
/*!40000 ALTER TABLE `airport_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `airport_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `airport_order`
--

DROP TABLE IF EXISTS `airport_order`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `airport_order` (
  `id` int(11) NOT NULL auto_increment,
  `airportid` int(11) NOT NULL default '0',
  `agentid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `departure_date` datetime default NULL,
  `return_date` datetime default NULL,
  `card_type` varchar(10) default NULL,
  `transid` int(11) NOT NULL default '0',
  `encrypted_card` varchar(50) NOT NULL default '',
  `card_last4` varchar(4) default NULL,
  `confirmcode` varchar(15) NOT NULL default '',
  `cancelcode` varchar(15) NOT NULL default '',
  `cancel` int(2) NOT NULL default '0',
  `email` varchar(100) default NULL,
  `firstname` varchar(50) default NULL,
  `lastname` varchar(100) default NULL,
  `address` varchar(200) default NULL,
  `city` varchar(50) default NULL,
  `state` varchar(50) default NULL,
  `zip` varchar(15) default NULL,
  `phone` varchar(50) default NULL,
  `compupark` varchar(100) default NULL,
  `card_expiration` varchar(4) default NULL,
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `status` int(5) NOT NULL default '0',
  `parking_days` int(11) NOT NULL default '0',
  `parking_fee` decimal(10,4) NOT NULL default '0.0000',
  `agent_commission` decimal(12,4) NOT NULL default '0.0000',
  `agent_commission_paid` decimal(12,4) NOT NULL default '0.0000',
  `vendor_commission` decimal(12,4) NOT NULL default '0.0000',
  `vendor_commission_paid` decimal(12,4) NOT NULL default '0.0000',
  `total_charge` decimal(12,4) NOT NULL default '0.0000',
  `agentcode` varchar(50) NOT NULL default '',
  `barcode_file` varchar(50) NOT NULL default '',
  `fuel_charge` decimal(12,4) NOT NULL default '0.0000',
  `service_fee` decimal(12,4) NOT NULL default '0.0000',
  `airport_fee` decimal(12,4) NOT NULL default '0.0000',
  `salestax` decimal(12,4) NOT NULL default '0.0000',
  `salestaxid` int(11) NOT NULL default '0',
  `grand_total` decimal(12,4) NOT NULL default '0.0000',
  `reservation_fee` decimal(12,4) NOT NULL default '0.0000',
  `invoiceid` int(11) NOT NULL default '0',
  `parking_type` char(1) NOT NULL default 'V',
  PRIMARY KEY  (`id`),
  KEY `airportid` (`airportid`),
  KEY `agentid` (`agentid`),
  KEY `customerid` (`customerid`),
  KEY `departure_date` (`departure_date`),
  KEY `transid` (`transid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `airport_order`
--

LOCK TABLES `airport_order` WRITE;
/*!40000 ALTER TABLE `airport_order` DISABLE KEYS */;
/*!40000 ALTER TABLE `airport_order` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `airport_order_details`
--

DROP TABLE IF EXISTS `airport_order_details`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `airport_order_details` (
  `id` int(11) NOT NULL auto_increment,
  `orderid` int(11) NOT NULL default '0',
  `serviceid` int(11) NOT NULL default '0',
  `description` varchar(50) NOT NULL default '',
  `price` decimal(12,4) NOT NULL default '0.0000',
  `cancel` int(2) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `orderid` (`orderid`),
  KEY `serviceid` (`serviceid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `airport_order_details`
--

LOCK TABLES `airport_order_details` WRITE;
/*!40000 ALTER TABLE `airport_order_details` DISABLE KEYS */;
/*!40000 ALTER TABLE `airport_order_details` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `airport_parking`
--

DROP TABLE IF EXISTS `airport_parking`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `airport_parking` (
  `id` int(11) NOT NULL auto_increment,
  `airportid` int(11) NOT NULL default '0',
  `num_days` int(5) NOT NULL default '0',
  `price` decimal(10,4) NOT NULL default '0.0000',
  `price_self_park` decimal(10,4) NOT NULL default '0.0000',
  `airport_fee_flat_charge` decimal(10,4) NOT NULL default '0.0000',
  `airport_fee_percent_charge` decimal(10,4) NOT NULL default '0.0000',
  `flat_commission` decimal(10,4) NOT NULL default '0.0000',
  `percent_commission` decimal(10,4) NOT NULL default '0.0000',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `airportid` (`airportid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `airport_parking`
--

LOCK TABLES `airport_parking` WRITE;
/*!40000 ALTER TABLE `airport_parking` DISABLE KEYS */;
/*!40000 ALTER TABLE `airport_parking` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `airport_service`
--

DROP TABLE IF EXISTS `airport_service`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `airport_service` (
  `id` int(11) NOT NULL auto_increment,
  `airportid` int(11) NOT NULL default '0',
  `serviceid` int(11) NOT NULL default '0',
  `flat_commission` decimal(10,4) NOT NULL default '0.0000',
  `percent_commission` decimal(10,4) NOT NULL default '0.0000',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `price` decimal(12,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`id`),
  KEY `airportid` (`airportid`),
  KEY `cancel` (`cancel`),
  KEY `serviceid` (`serviceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `airport_service`
--

LOCK TABLES `airport_service` WRITE;
/*!40000 ALTER TABLE `airport_service` DISABLE KEYS */;
/*!40000 ALTER TABLE `airport_service` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `amazonsetup`
--

DROP TABLE IF EXISTS `amazonsetup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `amazonsetup` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `companyid` int(11) NOT NULL default '0',
  `sellerid` varchar(128) NOT NULL default '',
  `marketplaceid` varchar(256) NOT NULL default '',
  `developerid` varchar(128) NOT NULL default '',
  `awsaccesskey` varchar(128) NOT NULL default '',
  `secretkey` varchar(128) NOT NULL default '',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `checkacctid` int(11) NOT NULL default '0',
  `salesglacctid` int(11) NOT NULL default '0',
  `salestaxglacctid` int(11) NOT NULL default '0',
  `taxexemptid` int(11) NOT NULL default '0',
  `refundglacctid` int(11) NOT NULL default '0',
  `invoicetermsid` int(11) NOT NULL default '0',
  `salescategoryid` int(11) NOT NULL default '0',
  `pricelevelid` int(11) NOT NULL default '0',
  `defaultshipvia` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='marketplaceid is now potentially a comma-separated list';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `amazonsetup`
--

LOCK TABLES `amazonsetup` WRITE;
/*!40000 ALTER TABLE `amazonsetup` DISABLE KEYS */;
/*!40000 ALTER TABLE `amazonsetup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `apbill`
--

DROP TABLE IF EXISTS `apbill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `apbill` (
  `id` int(11) NOT NULL auto_increment,
  `invoicenumber` varchar(20) NOT NULL default '',
  `cancel` int(11) NOT NULL default '0',
  `complete` int(11) NOT NULL default '0',
  `paynone` int(11) NOT NULL default '0',
  `total` decimal(19,4) NOT NULL default '0.0000',
  `description` varchar(50) default NULL,
  `dateofinvoice` date default NULL,
  `duedate` date default NULL,
  `discountamount` decimal(19,4) NOT NULL default '0.0000',
  `discountdate` date default NULL,
  `vendorid` int(11) NOT NULL default '0',
  `comment` text,
  `gencompanyid` int(11) NOT NULL default '0',
  `wherefrom` int(11) NOT NULL default '1',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `approved_paydate` date default NULL,
  `preapproved_userid` int(11) NOT NULL default '0',
  `preapproved_status` int(5) NOT NULL default '0',
  `preapproved_checkacctid` int(11) NOT NULL default '0',
  `preapproved_amount` decimal(15,6) NOT NULL default '0.000000',
  `preapproved_interest` decimal(15,6) NOT NULL default '0.000000',
  `old_id` varchar(255) default NULL,
  `ccpurchase` int(5) NOT NULL default '0',
  `apglaccountid` int(11) NOT NULL default '0',
  `chargeback` int(5) NOT NULL default '0',
  `recurring` int(5) NOT NULL default '0',
  `payplan_dayofmonth` int(5) NOT NULL default '0',
  `payplan_days` int(11) NOT NULL default '0',
  `payplan_next` date default NULL,
  `payplan_numtimes` int(11) NOT NULL default '0',
  `isretainer` int(5) NOT NULL default '0',
  `retainer_apbillid` int(11) NOT NULL default '0',
  `drawid` int(11) NOT NULL default '0',
  `currency` varchar(10) NOT NULL default 'USD',
  `currate` decimal(22,10) NOT NULL default '1.0000000000',
  `alternate_paytoname` varchar(255) NOT NULL default '',
  `non_negotiable` int(5) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `voucherid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `jobid` int(11) NOT NULL default '0',
  `frommanual` tinyint(4) NOT NULL default '0',
  `invoicetermsid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invoicenumber` (`invoicenumber`),
  KEY `wherefrom` (`wherefrom`),
  KEY `recurring` (`recurring`),
  KEY `drawid` (`drawid`),
  KEY `gltr_costcodeid` (`costcodeid`),
  KEY `voucherid` (`voucherid`),
  KEY `glcategoryid` (`glcategoryid`),
  KEY `jobid` (`jobid`),
  KEY `vendorid` (`vendorid`),
  KEY `gccscp` (`gencompanyid`,`cancel`,`complete`,`preapproved_status`,`preapproved_checkacctid`,`paynone`),
  KEY `dateofinvoice` (`dateofinvoice`),
  KEY `duedate` (`duedate`),
  KEY `discountdate` (`discountdate`),
  KEY `approved_paydate` (`approved_paydate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `apbill`
--

LOCK TABLES `apbill` WRITE;
/*!40000 ALTER TABLE `apbill` DISABLE KEYS */;
/*!40000 ALTER TABLE `apbill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `apbill_approvers`
--

DROP TABLE IF EXISTS `apbill_approvers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `apbill_approvers` (
  `id` int(11) NOT NULL auto_increment,
  `apbillid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `apbillsplitpaymentid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `apbillid_cancel` (`apbillid`,`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `apbill_approvers`
--

LOCK TABLES `apbill_approvers` WRITE;
/*!40000 ALTER TABLE `apbill_approvers` DISABLE KEYS */;
/*!40000 ALTER TABLE `apbill_approvers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `apbilldetail`
--

DROP TABLE IF EXISTS `apbilldetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `apbilldetail` (
  `id` int(11) NOT NULL auto_increment,
  `apbillid` int(11) NOT NULL default '0',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `glaccountid` int(11) NOT NULL default '0',
  `invreceiveid` int(11) NOT NULL default '0',
  `jobid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `description` varchar(100) NOT NULL default '',
  `isretainer` int(5) NOT NULL default '0',
  `currate` decimal(22,10) NOT NULL default '1.0000000000',
  PRIMARY KEY  (`id`),
  KEY `apbillid` (`apbillid`),
  KEY `glaccountid` (`glaccountid`),
  KEY `invreceiveid` (`invreceiveid`),
  KEY `gltr_jobid` (`jobid`),
  KEY `gltr_costcodeid` (`costcodeid`),
  KEY `gltr_categoryid` (`glcategoryid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `apbilldetail`
--

LOCK TABLES `apbilldetail` WRITE;
/*!40000 ALTER TABLE `apbilldetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `apbilldetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `apbillpayment`
--

DROP TABLE IF EXISTS `apbillpayment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `apbillpayment` (
  `id` int(11) NOT NULL auto_increment,
  `apbillid` int(11) NOT NULL default '0',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `interest` decimal(19,4) NOT NULL default '0.0000',
  `checkid` int(11) NOT NULL default '0',
  `checkvoid` int(11) NOT NULL default '0',
  `complete` int(2) NOT NULL default '0',
  `currentvoucherid` int(11) NOT NULL default '0',
  `voidvoucherid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `paymethod` int(11) NOT NULL default '2',
  `old_id` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  KEY `apbillid` (`apbillid`),
  KEY `checkid` (`checkid`),
  KEY `checkvoid` (`checkvoid`),
  KEY `complete` (`complete`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `apbillpayment`
--

LOCK TABLES `apbillpayment` WRITE;
/*!40000 ALTER TABLE `apbillpayment` DISABLE KEYS */;
/*!40000 ALTER TABLE `apbillpayment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `apbillsplitpayment`
--

DROP TABLE IF EXISTS `apbillsplitpayment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `apbillsplitpayment` (
  `id` int(11) NOT NULL auto_increment,
  `apbillid` int(11) NOT NULL default '0',
  `apbillpaymentid` int(11) NOT NULL default '0',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `discountamount` decimal(19,4) NOT NULL default '0.0000',
  `paymentdate` date NOT NULL default '0000-00-00',
  `preapproved_userid` int(11) NOT NULL default '0',
  `preapproved_status` int(11) NOT NULL default '0',
  `preapproved_checkacctid` int(11) NOT NULL default '0',
  `preapproved_amount` decimal(15,6) NOT NULL default '0.000000',
  `preapproved_interest` decimal(15,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`),
  KEY `apbill` (`apbillid`),
  KEY `apbillpayment` (`apbillpaymentid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `apbillsplitpayment`
--

LOCK TABLES `apbillsplitpayment` WRITE;
/*!40000 ALTER TABLE `apbillsplitpayment` DISABLE KEYS */;
/*!40000 ALTER TABLE `apbillsplitpayment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `apbilltaxdetail`
--

DROP TABLE IF EXISTS `apbilltaxdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `apbilltaxdetail` (
  `id` int(11) NOT NULL auto_increment,
  `apbillid` int(11) NOT NULL default '0',
  `taxid` int(11) NOT NULL default '0',
  `taxamount` decimal(19,4) NOT NULL default '0.0000',
  `jobid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `apbillid` (`apbillid`),
  KEY `taxid` (`taxid`),
  KEY `gltr_jobid` (`jobid`),
  KEY `gltr_costcodeid` (`costcodeid`),
  KEY `gltr_categoryid` (`glcategoryid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `apbilltaxdetail`
--

LOCK TABLES `apbilltaxdetail` WRITE;
/*!40000 ALTER TABLE `apbilltaxdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `apbilltaxdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `apcompany`
--

DROP TABLE IF EXISTS `apcompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `apcompany` (
  `id` int(11) NOT NULL default '0',
  `payable` double NOT NULL default '0',
  `interestexpense` double NOT NULL default '0',
  `discount` double NOT NULL default '0',
  `discearn` int(11) NOT NULL default '1',
  `usetransactiondate` int(11) NOT NULL default '0',
  `poformat` int(11) NOT NULL default '0',
  `glcashid` int(11) NOT NULL default '0',
  `glccid` int(11) NOT NULL default '0',
  `glotherid` int(11) NOT NULL default '0',
  `default_po_message` text,
  `glcommissionid` int(11) NOT NULL default '0',
  `default_vendor_termsid` int(11) NOT NULL default '0',
  `must_preapprove` int(5) NOT NULL default '0',
  `which_preapprove_ckdate` int(5) NOT NULL default '0',
  `noshowsell_onpo` int(5) NOT NULL default '0',
  `sellqtyonly_poentry` int(5) NOT NULL default '0',
  `default_checkacctid` int(11) NOT NULL default '0',
  `noboxes_on_po` int(5) NOT NULL default '0',
  `podate` int(5) NOT NULL default '0',
  `suppress_linenum_po` int(5) NOT NULL default '0',
  `sbformat` int(5) NOT NULL default '0',
  `noboxes_on_sb` int(5) NOT NULL default '0',
  `noshowsell_onsb` int(5) NOT NULL default '0',
  `suppress_linenum_sb` int(5) NOT NULL default '0',
  `showgl` int(5) NOT NULL default '0',
  `track_pochanges` int(5) NOT NULL default '0',
  `retainerglacctid` int(11) NOT NULL default '0',
  `retainer_checkacctid` int(11) NOT NULL default '0',
  `chargeback_percent` decimal(5,2) NOT NULL default '0.00',
  `chargeback_revenuegl` int(11) NOT NULL default '0',
  `check_glbudget_NonJobPO` int(5) NOT NULL default '0',
  `requirechecklist` int(11) NOT NULL default '0',
  `ccchargefeeflat` decimal(19,6) NOT NULL default '0.000000',
  `ccchargefeepercent` decimal(6,2) NOT NULL default '0.00',
  `adminexpglaccountid` int(11) NOT NULL default '0',
  `adminsalesglaccountid` int(11) NOT NULL default '0',
  `noshow_prices_on_po` int(5) NOT NULL default '0',
  `feesgl` int(11) NOT NULL default '0',
  `retax_liability` int(11) NOT NULL default '0',
  `retax_escrow` int(11) NOT NULL default '0',
  `retax_expense` int(11) NOT NULL default '0',
  `servicecharges` int(11) NOT NULL default '0',
  `defaultpocouserid` int(11) NOT NULL default '0',
  `adjustx1099` int(11) NOT NULL default '0',
  `adjusty1099` int(11) NOT NULL default '0',
  `updatevendorprice` int(11) NOT NULL default '0',
  `hidesalesordernumber` int(11) NOT NULL default '0',
  `hidePOhtml` int(5) NOT NULL default '0',
  `showinternal_itemcode` int(5) NOT NULL default '0',
  `defaultcostcodeid` int(11) NOT NULL default '0',
  `pochecklistsortorder` char(1) NOT NULL default 'L',
  `po_pdf_fontsize` int(11) NOT NULL default '10',
  `showccbillsinseparatetab` tinyint(1) NOT NULL default '1',
  `po_pdf_columns` text,
  `pochecklist_pdf_columns` text,
  `pochecklist_pdf_pricelevel_id` int(11) NOT NULL default '0',
  `round_preapprove_pay_date` varchar(1) NOT NULL default '0',
  `round_preapprove_dates` varchar(100) NOT NULL default '',
  `round_preapprove_holiday` tinyint(1) NOT NULL default '0',
  `round_preapprove_weekend` tinyint(1) NOT NULL default '0',
  `apbills_approver_count` tinyint(4) NOT NULL default '1',
  `apbills_approver_limit_users` tinyint(1) NOT NULL default '0',
  `apbills_approver_check_initials` tinyint(1) NOT NULL default '0',
  `pochecklist_pdf_cost_method` varchar(1) NOT NULL default 'A',
  `blockjobfields` tinyint(4) NOT NULL default '0',
  `defaultglcategoryid` int(11) NOT NULL default '0',
  `invpoemailtemplateid` int(11) NOT NULL default '0',
  `apbills_approver_notices` tinyint(1) NOT NULL default '0',
  `hidecostcodes` tinyint(1) NOT NULL default '0',
  `defaultqtyreceivedtozero` tinyint(1) NOT NULL default '0',
  `hideendorser` tinyint(4) NOT NULL default '0',
  `pendingcreditsglaccountid` int(11) NOT NULL default '0',
  `dismisspoitemimportpopupwarning` tinyint(1) NOT NULL default '0',
  `forcediscount` tinyint(4) NOT NULL default '0',
  `paymentemailtemplateid` int(11) NOT NULL default '0',
  `emailpaymenttypes` varchar(100) NOT NULL default '',
  `blocknewbillglautofill` tinyint(4) NOT NULL default '0',
  `maxsingleeftamount` decimal(19,4) NOT NULL default '0.0000',
  `showposcashpurchaselink` tinyint(1) NOT NULL default '0',
  `nextvendorcode` int(11) NOT NULL default '1000',
  `dropshipcarrierserviceid` int(11) NOT NULL default '0',
  `allowdiscountoncredits` tinyint(1) NOT NULL default '0',
  `autogenvendorcode` tinyint(1) NOT NULL default '0',
  `maxdailyeftamount` decimal(19,4) NOT NULL default '0.0000',
  `poheaderinventorylocationid` int(11) NOT NULL default '0',
  `poshowmainpagenotesinheader` tinyint(1) NOT NULL default '0',
  `polimititemstoassignedvendorsstock` tinyint(1) NOT NULL default '0',
  `hidepoentryinvgl` tinyint(1) NOT NULL default '0',
  `polimititemstoassignedvendorsnonstock` tinyint(1) NOT NULL default '0',
  `polimititemstoassignedvendorsother` tinyint(1) NOT NULL default '0',
  `addlocationcodetoponumber` tinyint(4) NOT NULL default '0',
  `hidevendoraddinpo` tinyint(1) NOT NULL default '0',
  `pouselastcost` tinyint(4) NOT NULL default '0',
  `blockchangingpovendorterms` tinyint(4) NOT NULL default '0',
  `emailassociatedordersalesmanonreceive` tinyint(1) NOT NULL default '0',
  `fromemailforpo` varchar(255) NOT NULL default '',
  `fromemailforvendorinsurancerequests` varchar(255) NOT NULL default '',
  `glrestockfeeid` int(11) NOT NULL,
  `subtotalsonchecks` tinyint(1) NOT NULL,
  `userscanchangevendorproductcodesduringpoentry` tinyint(1) NOT NULL,
  `adjustpoqtywhenarorderqtychanges` tinyint(1) NOT NULL default '1',
  `adjustpocostwhenarordercostchanges` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `apcompany`
--

LOCK TABLES `apcompany` WRITE;
/*!40000 ALTER TABLE `apcompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `apcompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `apilog`
--

DROP TABLE IF EXISTS `apilog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `apilog` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `action` varchar(255) NOT NULL,
  `entrydate` datetime NOT NULL,
  `data_in` text NOT NULL,
  `data_out` longtext NOT NULL,
  `remoteip` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `apilog`
--

LOCK TABLES `apilog` WRITE;
/*!40000 ALTER TABLE `apilog` DISABLE KEYS */;
/*!40000 ALTER TABLE `apilog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `appointment`
--

DROP TABLE IF EXISTS `appointment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `appointment` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `scheduleid` int(11) NOT NULL default '0',
  `begindate` datetime NOT NULL default '0000-00-00 00:00:00',
  `enddate` datetime NOT NULL default '0000-00-00 00:00:00',
  `title` varchar(200) NOT NULL default '',
  `notes` text NOT NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `vendorid` (`userid`),
  KEY `begindate` (`begindate`),
  KEY `enddate` (`enddate`),
  KEY `scheduleid` (`scheduleid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `appointment`
--

LOCK TABLES `appointment` WRITE;
/*!40000 ALTER TABLE `appointment` DISABLE KEYS */;
/*!40000 ALTER TABLE `appointment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `appointmentcompany`
--

DROP TABLE IF EXISTS `appointmentcompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `appointmentcompany` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `companyid` int(11) NOT NULL default '0',
  `appointmentreminders_lastrun` datetime NOT NULL default '0000-00-00 00:00:00',
  `webhook_key` varchar(32) default NULL,
  `webhook_value` varchar(32) default NULL,
  `donotredirectb2blogintoappointments` tinyint(1) NOT NULL default '0',
  `donotrequirepaymentmethodtobook` tinyint(1) NOT NULL default '0',
  `nopaymentmethodmessage` mediumtext NOT NULL,
  `mincaptureauthamount` decimal(18,6) NOT NULL default '0.000000',
  `requireccauthtobook_amount` decimal(18,6) NOT NULL default '0.000000',
  `requireccauthtobook_amount2` decimal(18,6) NOT NULL default '0.000000',
  `email_intro_subject` tinytext NOT NULL,
  `email_intro_bodyhtml` mediumtext NOT NULL,
  `introserviceid` varchar(200) NOT NULL default '',
  `email_reminder_subject` tinytext NOT NULL,
  `email_reminder_bodyhtml` mediumtext NOT NULL,
  `email_confirmation_adminsubject` tinytext NOT NULL,
  `email_confirmation_subject` tinytext NOT NULL,
  `email_confirmation_bodyhtml` mediumtext NOT NULL,
  `email_cancel_adminsubject` tinytext NOT NULL,
  `email_cancel_subject` tinytext NOT NULL,
  `email_cancel_bodyhtml` mediumtext NOT NULL,
  `email_reschedule_adminsubject` tinytext NOT NULL,
  `email_reschedule_subject` tinytext NOT NULL,
  `email_reschedule_bodyhtml` mediumtext NOT NULL,
  `text_reminder_subject` tinytext NOT NULL,
  `email_newpatient_subject` tinytext NOT NULL,
  `email_newpatient_bodyhtml` mediumtext NOT NULL,
  `generalpatientemail` tinytext NOT NULL,
  `maintenanceplan_alert_appointmentlimit` int(11) NOT NULL default '0',
  `maintenanceplan_alert_daylimit` int(11) NOT NULL default '0',
  `text_reminder_body` mediumtext NOT NULL,
  `adminnotificationemailaddress` tinytext NOT NULL,
  `promptfor3rdpartyform` tinyint(1) NOT NULL default '0',
  `enablemedicalthemeoptions` tinyint(1) NOT NULL default '0',
  `disableemailreminders` tinyint(1) NOT NULL default '0',
  `b2bbookingleaddays` int(11) NOT NULL default '0',
  `newpatientnoticeemailaddress` tinytext NOT NULL,
  `newpatientnoticeserviceids` varchar(200) NOT NULL default '',
  `email_express_subject` tinytext NOT NULL,
  `email_express_bodyhtml` mediumtext NOT NULL,
  `expressserviceid` varchar(200) NOT NULL default '',
  `noshowcron_lastrun` datetime NOT NULL default '0000-00-00 00:00:00',
  `requireccauthtobook_services` varchar(200) NOT NULL default '',
  `requireccauthtobook_services2` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `webhook_key_UNIQUE` (`webhook_key`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Company-specific setup options for appointments - WIP';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `appointmentcompany`
--

LOCK TABLES `appointmentcompany` WRITE;
/*!40000 ALTER TABLE `appointmentcompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `appointmentcompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `appointmentschedule`
--

DROP TABLE IF EXISTS `appointmentschedule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `appointmentschedule` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `startdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `enddate` datetime NOT NULL default '0000-00-00 00:00:00',
  `hostid` int(11) NOT NULL default '0',
  `locationid` int(11) NOT NULL default '0',
  `serviceid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `reserved` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cc` (`companyid`,`cancel`),
  KEY `startdate` (`startdate`),
  KEY `enddate` (`enddate`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `appointmentschedule`
--

LOCK TABLES `appointmentschedule` WRITE;
/*!40000 ALTER TABLE `appointmentschedule` DISABLE KEYS */;
/*!40000 ALTER TABLE `appointmentschedule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `approvalreq`
--

DROP TABLE IF EXISTS `approvalreq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `approvalreq` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `tablename` varchar(100) NOT NULL default '',
  `action` varchar(50) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `recordid` int(11) NOT NULL default '0',
  `mainrecordid` int(11) NOT NULL default '0',
  `prevrecordid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `approvaluserid` int(11) NOT NULL default '0',
  `approvaldate` datetime NOT NULL,
  `pending` int(11) NOT NULL default '1',
  `changeok` int(11) NOT NULL default '0',
  `notes` text NOT NULL,
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `tablename_action` (`tablename`,`action`),
  KEY `recordid` (`recordid`),
  KEY `mainrecordid` (`mainrecordid`),
  KEY `prevrecordid` (`prevrecordid`),
  KEY `entryuserid` (`entryuserid`),
  KEY `approvaluserid` (`approvaluserid`),
  KEY `pending` (`pending`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `approvalreq`
--

LOCK TABLES `approvalreq` WRITE;
/*!40000 ALTER TABLE `approvalreq` DISABLE KEYS */;
/*!40000 ALTER TABLE `approvalreq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `approvalrequser`
--

DROP TABLE IF EXISTS `approvalrequser`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `approvalrequser` (
  `id` int(11) NOT NULL auto_increment,
  `approvalreqid` int(11) NOT NULL default '0',
  `userfromid` int(11) NOT NULL default '0',
  `usertoid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `notes` text,
  PRIMARY KEY  (`id`),
  KEY `approvalreqid` (`approvalreqid`),
  KEY `userfromid` (`userfromid`),
  KEY `usertoid` (`usertoid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `approvalrequser`
--

LOCK TABLES `approvalrequser` WRITE;
/*!40000 ALTER TABLE `approvalrequser` DISABLE KEYS */;
/*!40000 ALTER TABLE `approvalrequser` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `approvalrights`
--

DROP TABLE IF EXISTS `approvalrights`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `approvalrights` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `tablename` varchar(100) NOT NULL default '',
  `action` varchar(50) NOT NULL default '',
  `userid` int(11) NOT NULL default '0',
  `nprightsgroupid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `canapprove` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `tablename_action` (`tablename`,`action`),
  KEY `userid` (`userid`),
  KEY `nprightsgroupid` (`nprightsgroupid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `approvalrights`
--

LOCK TABLES `approvalrights` WRITE;
/*!40000 ALTER TABLE `approvalrights` DISABLE KEYS */;
/*!40000 ALTER TABLE `approvalrights` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arcompany`
--

DROP TABLE IF EXISTS `arcompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arcompany` (
  `id` int(11) NOT NULL default '0',
  `imageurl` varchar(150) default NULL,
  `cash` double NOT NULL default '0',
  `checking` double NOT NULL default '0',
  `interest` double NOT NULL default '0',
  `discount` double NOT NULL default '0',
  `cost` double NOT NULL default '0',
  `inventory` double NOT NULL default '0',
  `shipliability` double NOT NULL default '0',
  `receivables` double NOT NULL default '0',
  `nextinvoicenum` double NOT NULL default '1',
  `servicecharge` decimal(8,2) NOT NULL default '0.00',
  `interestrate` decimal(8,4) NOT NULL default '0.0000',
  `baddebt` double NOT NULL default '0',
  `default_sellunitid` int(11) NOT NULL default '0',
  `default_priceunitid` int(11) NOT NULL default '0',
  `default_sell_per_price` int(11) NOT NULL default '1',
  `default_invoice_message` text,
  `invoiceformat` int(11) NOT NULL default '0',
  `labor_sales_glacctid` int(11) NOT NULL default '0',
  `hrunitid` int(11) NOT NULL default '0',
  `is_employee_labor_taxable` int(2) NOT NULL default '1',
  `depositglacctid` int(11) NOT NULL default '0',
  `refund` int(11) NOT NULL default '0',
  `ccprocessorid` int(11) NOT NULL default '0',
  `b2bccprocessorid` int(11) NOT NULL default '0',
  `docfile` text,
  `default_salescategory_cashreceipts` int(11) NOT NULL default '0',
  `default_salescategory_invoice` int(11) NOT NULL default '0',
  `default_salescategory_fulfillment` int(11) NOT NULL default '0',
  `default_salescategory_service` int(11) NOT NULL default '0',
  `serviceorder_summarize` int(5) NOT NULL default '0',
  `tax_on_shipto` int(5) NOT NULL default '0',
  `tax_on_freight` int(2) NOT NULL default '0',
  `order_base` int(5) NOT NULL default '0',
  `b2b_orders` int(2) NOT NULL default '1',
  `b2b_service` int(2) NOT NULL default '1',
  `tax_how` int(2) NOT NULL default '0',
  `donotapply` int(2) NOT NULL default '0',
  `restockglid` int(11) NOT NULL default '0',
  `restockunitid` int(11) NOT NULL default '0',
  `salesterritories` int(5) NOT NULL default '0',
  `default_statement` int(2) NOT NULL default '0',
  `b2b_commission` int(5) NOT NULL default '0',
  `default_discountmsg` text,
  `b2b_print_orders` int(5) NOT NULL default '0',
  `b2b_pricelist_orders` int(5) NOT NULL default '0',
  `default_invoicetermsid` int(11) NOT NULL default '1',
  `b2b_allow_signup` int(11) NOT NULL default '0',
  `default_customergroupid` int(11) NOT NULL default '0',
  `default_b2b_admin_email` varchar(255) NOT NULL default '',
  `invoicecalc` int(5) NOT NULL default '0',
  `current_or_order` int(5) NOT NULL default '0',
  `default_checkacctid` int(11) NOT NULL default '0',
  `nobarcode_on_invoice` int(5) NOT NULL default '0',
  `picklist_blockheader` int(5) NOT NULL default '0',
  `picklist_blockbarcode` int(5) NOT NULL default '0',
  `picklist_sortorder` int(5) NOT NULL default '0',
  `pickliststyle` int(5) NOT NULL default '0',
  `noboxes_on_invoice` int(5) NOT NULL default '0',
  `comparison_levelid` int(11) NOT NULL default '0',
  `statement_no_prior_balance` int(5) NOT NULL default '0',
  `statement_no_interest_added` int(5) NOT NULL default '0',
  `statement_interest_summary` tinyint(1) NOT NULL default '0',
  `ardate` int(5) NOT NULL default '0',
  `noteatbottom` int(5) NOT NULL default '0',
  `internal_serviceorder` int(5) NOT NULL default '1',
  `internal_fulfillmentorder` int(5) NOT NULL default '1',
  `invoicenumber_override` int(5) NOT NULL default '0',
  `display_profit_pos` int(5) NOT NULL default '0',
  `pos_hide_stats` int(5) NOT NULL default '0',
  `pos_hide_fulfillment` int(5) NOT NULL default '0',
  `pos_hide_discounts` int(5) NOT NULL default '0',
  `pos_default_payment_method` int(5) NOT NULL default '0',
  `pos_default_order_type` int(5) NOT NULL default '0',
  `posreloadpriceswhenlocationchanges` tinyint(1) NOT NULL default '1',
  `display_weights_pos` int(5) NOT NULL default '0',
  `checkforcost` int(5) NOT NULL default '0',
  `bankdepositautoselect` int(11) NOT NULL default '1',
  `salesmanBlock` int(5) NOT NULL default '0',
  `show_salesdata` int(5) NOT NULL default '0',
  `usecurdateforship` int(11) NOT NULL default '0',
  `allowcoinvoice` int(11) NOT NULL default '0',
  `hidegl_pos` int(5) NOT NULL default '0',
  `showaddl_pos` int(5) NOT NULL default '0',
  `revenuerec` text,
  `deferredrevenue` int(11) NOT NULL default '0',
  `mgmtfee_glaccountid` int(11) NOT NULL default '0',
  `latefees` int(11) NOT NULL default '0',
  `petrent` int(11) NOT NULL default '0',
  `lawncare` int(11) NOT NULL default '0',
  `showpriorbalanceoninvoice` int(11) NOT NULL default '0',
  `petdeposit` int(11) NOT NULL default '0',
  `posblockchilditemsearch` int(11) NOT NULL default '0',
  `requireccbillingaddress` int(11) NOT NULL default '0',
  `requirecccardcode` int(11) NOT NULL default '0',
  `ccpaymentinstructions` text,
  `surveyorder` int(11) NOT NULL default '0',
  `surveyinvoice` int(11) NOT NULL default '0',
  `report_on_paid` int(5) NOT NULL default '0',
  `nocostupdate` int(5) NOT NULL default '0',
  `maintenance` int(11) NOT NULL default '0',
  `commissionmethod` varchar(20) default NULL,
  `hideoptions` int(11) NOT NULL default '0',
  `fulfillmentduedays` int(11) NOT NULL default '3',
  `serviceduedays` int(11) NOT NULL default '3',
  `hideinvpagenumber` int(11) NOT NULL default '0',
  `appendendnotes` int(11) NOT NULL default '0',
  `showinvsignature` int(11) NOT NULL default '0',
  `show_discount_on_forms` int(5) NOT NULL default '0',
  `formsize` int(5) NOT NULL default '0',
  `defaulttovendorcost` int(11) NOT NULL default '0',
  `default_order_message` text,
  `purgeordersdays` int(11) NOT NULL default '0',
  `purgeordershow` char(1) NOT NULL default 'U',
  `nocredit` int(11) NOT NULL default '0',
  `nocredit_note` varchar(255) NOT NULL default '',
  `hidequotelineprices` int(11) NOT NULL default '0',
  `defaultquoteprintnote` text,
  `minsalesmargin` decimal(6,2) NOT NULL default '0.00',
  `maxsalesmargin` decimal(6,2) NOT NULL default '0.00',
  `bestprice` int(11) NOT NULL default '0',
  `hideestshipdate` int(11) NOT NULL default '0',
  `default_incomplete_when_ship` int(5) NOT NULL default '0',
  `onlyBOonPrint` int(5) NOT NULL default '0',
  `auto_voucher_number` tinyint(4) NOT NULL default '1',
  `rebategl` int(11) NOT NULL default '0',
  `inventoryusetax` decimal(6,2) NOT NULL default '0.00',
  `full_sized_ship_sold_to_box` tinyint(4) NOT NULL default '0',
  `show_cust_notes_on_srv_edit` int(1) NOT NULL default '0',
  `defaulttostaticcost` int(11) NOT NULL default '0',
  `display_profit_per_line_pos` int(11) NOT NULL default '0',
  `showshiponinvoice` int(11) NOT NULL default '0',
  `usebackgroundinvpdf` int(11) NOT NULL default '0',
  `hideduedate` int(5) NOT NULL default '0',
  `defaultvendorid` int(11) NOT NULL default '0',
  `allowcreditdiscount` tinyint(4) NOT NULL default '0',
  `auto_shipped_email_style` tinyint(4) NOT NULL default '0',
  `showoverrideprice` tinyint(4) NOT NULL default '0',
  `showpackingslipsig` tinyint(4) NOT NULL default '0',
  `pricehistoryautodisplay` tinyint(4) NOT NULL default '1',
  `pricehistorymax` int(11) NOT NULL default '0',
  `showupsshipto` tinyint(4) NOT NULL default '0',
  `hideshipchargeups` tinyint(4) NOT NULL default '0',
  `terms_discount` int(5) NOT NULL default '0',
  `packingslipcount` tinyint(4) NOT NULL default '1',
  `b2b_requireponumber` tinyint(4) NOT NULL default '0',
  `orderduedatefromterms` tinyint(4) default '0',
  `b2b_paymentmethod` int(11) NOT NULL default '5',
  `canadianefttype` char(1) NOT NULL default 'G',
  `invoiceemailtemplateid` int(11) NOT NULL default '0',
  `sold_to_format` mediumtext,
  `ship_to_format` mediumtext,
  `ship_to_pickup_format` mediumtext,
  `requireponumber` tinyint(4) NOT NULL default '0',
  `showinvqtytotal` tinyint(4) NOT NULL default '0',
  `allowdiscountoverride` tinyint(4) NOT NULL default '0',
  `shipchargedefaultoactual` tinyint(1) default '1',
  `barcode_on_confirmation` tinyint(1) NOT NULL default '0',
  `current_or_payplan` tinyint(1) NOT NULL default '0',
  `hidelinetotals` tinyint(1) NOT NULL default '0',
  `hidepriceeach` tinyint(1) NOT NULL default '0',
  `splitdesc` tinyint(4) NOT NULL default '0',
  `picklist_qty_weight` tinyint(1) NOT NULL default '1',
  `picklist_multiprintwarning` tinyint(4) NOT NULL default '0',
  `showbomsubitems` tinyint(4) NOT NULL default '0',
  `reservationfeeglaccountid` int(11) NOT NULL default '0',
  `phonedigittrimnum` int(11) NOT NULL default '1',
  `pos_block_new_customers` tinyint(4) NOT NULL default '0',
  `orderformat` int(11) NOT NULL default '-1',
  `useordernumforponum` tinyint(4) NOT NULL default '0',
  `receiveautopo` tinyint(4) NOT NULL default '0',
  `showorderuser` tinyint(4) NOT NULL default '0',
  `statementmessagewithbankinfo` text,
  `statementmessagewithnobankinfo` text,
  `asmstoreid` varchar(100) NOT NULL default '',
  `asmstorename` varchar(100) NOT NULL default '',
  `showupsshiptopdf` tinyint(4) NOT NULL default '0',
  `showinvoicecustomfields` text,
  `display_linedate_pos` tinyint(4) NOT NULL default '0',
  `createjobwithnewcustomer` tinyint(4) NOT NULL default '0',
  `hideaddjobbuttons` tinyint(4) NOT NULL default '0',
  `useposfornewinvoices` tinyint(4) NOT NULL default '0',
  `invpdfhidelinenumbers` tinyint(4) NOT NULL default '0',
  `invpdfhideunitnames` tinyint(4) NOT NULL default '0',
  `invpdfhideshipto` tinyint(4) NOT NULL default '0',
  `invpdfcustomatshipto` tinyint(4) NOT NULL default '0',
  `invpdfposlabelinvoice` tinyint(4) NOT NULL default '0',
  `invpdfdescbeforeqty` tinyint(4) NOT NULL default '0',
  `hidejobnamecolumn` tinyint(4) NOT NULL default '0',
  `picklistconsolidatedgroup` tinyint(4) NOT NULL default '0',
  `blockinvoiceunpost` tinyint(1) NOT NULL default '0',
  `hideaccruedinterestonpayment` tinyint(1) NOT NULL default '0',
  `hideenterinterestonpayment` tinyint(1) NOT NULL default '0',
  `preventduplicateshipnames` tinyint(1) NOT NULL default '0',
  `b2blockstatus` tinyint(1) NOT NULL default '0',
  `b2bpaymentfee` decimal(19,4) NOT NULL default '0.0000',
  `b2bpaymentfeeispercentage` tinyint(1) NOT NULL default '0',
  `b2bpaymentfeeglid` int(11) NOT NULL default '0',
  `chargebackglid` int(11) NOT NULL default '0',
  `writeoffmax` decimal(19,4) NOT NULL default '-1.0000',
  `writeoffmaxperc` decimal(19,4) NOT NULL default '100.0000',
  `zlienkey` varchar(64) NOT NULL default '',
  `zliensecret` varchar(64) NOT NULL default '',
  `zlienurl` varchar(128) NOT NULL default '',
  `zlienportalurl` varchar(128) NOT NULL default '',
  `defaultinvoicepaymentamounttozero` tinyint(1) NOT NULL default '0',
  `blocksaleswithoutpurchaseby` tinyint(1) NOT NULL default '0',
  `blocknondirectglentryediting` tinyint(1) NOT NULL default '0',
  `blockprofitchangesforstockitems` tinyint(1) NOT NULL default '0',
  `blocknewpoforstocklineitems` tinyint(1) NOT NULL default '0',
  `hidepaymententryafterpos` tinyint(1) NOT NULL default '0',
  `hideposprintuntilafterpayment` tinyint(1) NOT NULL default '0',
  `hideposprintinvoice` tinyint(1) NOT NULL default '0',
  `defaultqtyshippedtozero` tinyint(1) NOT NULL default '0',
  `autoselectsalestax` tinyint(1) NOT NULL default '0',
  `dropshiprequireupload` tinyint(1) NOT NULL default '0',
  `suggestaltlocations` tinyint(1) NOT NULL default '1',
  `ordereditnotices` tinyint(1) NOT NULL default '0',
  `ordereditnoticesadmin` tinyint(1) NOT NULL default '0',
  `jobcreditmarkup` decimal(19,4) NOT NULL default '0.0000',
  `allowzeroqtyonquotes` tinyint(1) NOT NULL default '0',
  `rmanextinvoicenumber` varchar(64) NOT NULL default '',
  `rmareturnpolicy` mediumtext NOT NULL,
  `tax_rounding_detailed` tinyint(1) NOT NULL default '0',
  `jobprelimcreditlimit` decimal(12,6) NOT NULL default '0.000000',
  `billtrust_host` text NOT NULL,
  `billtrust_user` text NOT NULL,
  `billtrust_pass` text NOT NULL,
  `delivery_charge_max_order_total` decimal(19,4) NOT NULL,
  `fuel_charge_max_order_total` decimal(19,4) NOT NULL,
  `delivery_charge_itemid` int(11) NOT NULL,
  `delivery_charge_nontax_itemid` int(11) NOT NULL,
  `fuel_charge_itemid` int(11) NOT NULL,
  `fuel_charge_nontax_itemid` int(11) NOT NULL,
  `our_shipping_method` int(11) NOT NULL,
  `rental_cogs_percentage` decimal(12,6) NOT NULL,
  `forceinventoryitemsforquotetoorder` tinyint(1) NOT NULL default '0',
  `ordernumbering_last_serviceorder` varchar(32) NOT NULL default 'SO-*****0',
  `uspsaddressverify` tinyint(1) NOT NULL default '1',
  `joblinkcontractprelimdates` tinyint(1) NOT NULL default '0',
  `rentalsbillwhen` tinyint(1) NOT NULL default '0' COMMENT '0 = In Advancen1 = In Arrears',
  `invoicealwaysshowsummarybox` tinyint(1) NOT NULL default '0',
  `picklist_bin` tinyint(1) NOT NULL default '1',
  `nextcustomercode` int(11) NOT NULL default '1000',
  `showsiglineonordconf` tinyint(1) NOT NULL default '0',
  `autogencustomercode` tinyint(1) NOT NULL default '0',
  `convertdeferredrevenueandexpensesonjobclose` tinyint(1) NOT NULL default '0',
  `deferredrevenueglid` int(11) NOT NULL default '0',
  `deferredexpenseglid` int(11) NOT NULL default '0',
  `ordernumbering_last_fulfillmentorder` varchar(32) NOT NULL default 'FO-*****0',
  `ordernumbering_last_quote` varchar(32) NOT NULL default 'QT-*****0',
  `paid_on_account_itemid` int(11) NOT NULL,
  `invoicecronimportskipgls` tinyint(1) NOT NULL default '0',
  `arpaymentcronimportskipgls` tinyint(1) NOT NULL default '0',
  `showsalespersononquotes` tinyint(1) NOT NULL default '0',
  `showsiglineonquotes` tinyint(1) NOT NULL default '0',
  `singlecustomeremailperinput` tinyint(1) NOT NULL default '0',
  `foposselectinvtype` tinyint(1) NOT NULL default '0',
  `invoiceheadertext` text NOT NULL,
  `hidetermsoninvoicepdf` tinyint(1) NOT NULL default '0',
  `invoicepaymentinfotext` text NOT NULL,
  `invoiceheadersubtext` text NOT NULL,
  `invoicefooternotes` text NOT NULL,
  `invoiceshiptosubtext` text NOT NULL,
  `backorderdistroonly` tinyint(1) NOT NULL default '0',
  `prelimreplyto` varchar(255) NOT NULL default '',
  `b2buserdetailstemplate` int(11) NOT NULL default '0',
  `prelimtemplate` varchar(200) NOT NULL default '',
  `showautocompletecustomercode` tinyint(1) NOT NULL default '0',
  `minfincharge` decimal(19,4) NOT NULL default '0.0000',
  `invoiceinterest` tinyint(1) NOT NULL default '0',
  `jobsrequirescustomer` tinyint(1) NOT NULL default '0',
  `interestchargemin` decimal(19,4) NOT NULL default '0.0000',
  `invpdfhideitemcodes` tinyint(4) NOT NULL default '0',
  `invpdfhidejobcode` tinyint(4) NOT NULL default '0',
  `invpdfhidejobname` tinyint(4) NOT NULL default '0',
  `invpdfhidecustomernumber` tinyint(4) NOT NULL default '0',
  `blockshipposoverlimit` tinyint(4) NOT NULL default '0',
  `outonrentalglid` int(11) NOT NULL default '0',
  `blockfreeinvsales` tinyint(4) NOT NULL default '0',
  `contrarentalglid` int(11) NOT NULL default '0',
  `contranonstockrentalglid` int(11) NOT NULL default '0',
  `hiderentalnumperiods` tinyint(4) NOT NULL default '0',
  `interestdays` int(11) NOT NULL default '30',
  `paymentonaccountbankaccount` int(11) NOT NULL default '0',
  `blockinvoicenoshipdoc` tinyint(4) NOT NULL default '0',
  `invoicecronimportskipinventory` tinyint(4) NOT NULL default '0',
  `minimumpricelevelid` int(11) NOT NULL default '0',
  `showlocationonpaymentpage` tinyint(1) NOT NULL default '0',
  `defaultbankdepositcheckingaccount` int(11) NOT NULL default '0',
  `defaultbankdepositcostcode` int(11) NOT NULL default '0',
  `picklistshowvendoritemcode` tinyint(1) NOT NULL default '0',
  `dailyclosevarianceid` int(11) NOT NULL default '0',
  `dailyclosevariancemethod` char(1) NOT NULL default 'S',
  `customeraddshowcreditcardlink` tinyint(1) NOT NULL default '0',
  `showcostcodeonpaymentpage` tinyint(1) NOT NULL default '0',
  `hideqtyperprice` tinyint(4) NOT NULL default '0',
  `paymentonaccountalwayscollectconveniencefee` tinyint(1) NOT NULL default '0',
  `hidecarriername` tinyint(4) NOT NULL default '0',
  `stateswithnocountytaxifcitytax` text,
  `rentalcontracttext` text,
  `showpackingslipinvoicenotes` tinyint(1) NOT NULL default '0',
  `paymentplansalesaccountallowanyaccounttype` tinyint(1) NOT NULL default '0',
  `blockrentalcreditforfirstperiod` tinyint(1) NOT NULL default '0',
  `defaultprelimrequestsearchminimumopenamount` decimal(18,6) NOT NULL default '0.000000',
  `blockexpiredquotes` tinyint(1) NOT NULL default '0',
  `defaultcustomercarrierserviceid` int(11) NOT NULL default '0',
  `blockitemsnotforsale` int(11) NOT NULL default '0',
  `nextjobcode` int(11) NOT NULL default '10000',
  `quotemaxexpdays` int(11) NOT NULL default '0',
  `quotedefaultexpdays` int(11) NOT NULL default '30',
  `enterpayments_readonlyinventorylocation` tinyint(1) NOT NULL default '0',
  `lowestcanoverrideprice` tinyint(4) NOT NULL default '0',
  `emailcenterdefaultprivate` tinyint(1) NOT NULL default '0',
  `lockjobcodes` tinyint(1) NOT NULL default '0',
  `ordersmusthaveshiptocityzip` tinyint(1) NOT NULL default '0',
  `defaultorderstostaticcost` tinyint(4) NOT NULL default '0',
  `forcecheckingaccountidforenterpayments` int(11) NOT NULL default '0',
  `forcecheckingaccountidforposfo` int(11) NOT NULL default '0',
  `combinetaxesinvoicepdf` tinyint(4) NOT NULL default '0',
  `showdetailedtotalsonpackingsplip` tinyint(1) NOT NULL default '0',
  `showshipconfirmfo` tinyint(4) NOT NULL default '0',
  `blocknonstockpos` tinyint(1) NOT NULL default '0',
  `forequireshippingzipstateandcity` tinyint(1) NOT NULL default '0',
  `emailorderconfwhenshipping` tinyint(4) NOT NULL default '0',
  `showextravaluesummaryonorderconf` tinyint(1) NOT NULL default '0',
  `defaultorderconfemailtemplateid` int(11) NOT NULL default '0',
  `statementemailheader` varchar(128) NOT NULL default '',
  `showinvoiceterms` tinyint(1) NOT NULL default '0',
  `defaultshowpricesondeliveryconf` tinyint(1) NOT NULL default '0',
  `defaultshowpricesonpackingslip` tinyint(1) NOT NULL default '0',
  `defaultallowordermodifications` tinyint(1) NOT NULL default '0',
  `hidepaymentterms` tinyint(1) default '0',
  `b2bdefaultinventorylocationid` int(11) NOT NULL default '0',
  `allowuserrestockfeeoverride` tinyint(1) NOT NULL default '0',
  `restockfeeistaxed` tinyint(1) NOT NULL default '1',
  `restockfeegroupedontooneline` tinyint(1) NOT NULL default '0',
  `blockordersavewithoutshippingpref` tinyint(1) NOT NULL default '0',
  `defaultjobshippingmethod` int(11) NOT NULL default '0',
  `interestmincustomerbalance` decimal(18,6) NOT NULL default '0.000000',
  `display_unit_of_measure` int(5) NOT NULL default '0',
  `showboqtyonpackingslip` tinyint(1) NOT NULL default '1',
  `requirereasonforardeletions` tinyint(1) NOT NULL default '0',
  `shipqty_on_confirmation` tinyint(1) NOT NULL default '0',
  `hidelinenum_on_confirmation` tinyint(1) NOT NULL default '0',
  `nocredit_invoicetermsid` int(11) NOT NULL default '0',
  `ardeletionnoticesadmin` tinyint(1) NOT NULL default '0',
  `excludeprevshippeditemsonpackingslip` tinyint(1) NOT NULL default '0',
  `showweightwithunnumber` tinyint(1) NOT NULL default '0',
  `substituteinvlocationinfo` tinyint(1) NOT NULL default '0',
  `forceinventoryitemsforallsales` tinyint(1) NOT NULL default '0',
  `blockshiptoeditsonorderentry` tinyint(1) NOT NULL default '0',
  `blockrentalsfornocreditcustomers` tinyint(1) NOT NULL default '0',
  `notifysalespersonnewcustomerswithcredit` tinyint(1) NOT NULL default '0',
  `notifysalespersonfornewjobs` tinyint(1) NOT NULL default '0',
  `notifysalespersonfornewrentalorders` tinyint(4) NOT NULL default '0',
  `emailregionmanagerscustnosales` tinyint(4) NOT NULL default '0',
  `daystoprelim` int(11) NOT NULL default '20',
  `limitedshiptoaddressentry` tinyint(1) NOT NULL default '0',
  `allowshipovercreditwithfulldeposit` tinyint(1) NOT NULL default '0',
  `stateswithshippingtax` text NOT NULL,
  `showsavezeroqtywarning` tinyint(1) NOT NULL default '1',
  `showsavezeropricewarning` tinyint(1) NOT NULL default '1',
  `positemlookuplayout` varchar(16) NOT NULL default '',
  `showitemlookuponorderentryline` varchar(1) NOT NULL default 'A',
  `specialpricingstatic` tinyint(1) NOT NULL default '1',
  `effectivetaxselectblock` tinyint(1) NOT NULL default '1',
  `rentalshipandreturnskipgloutonrentglstock` tinyint(1) NOT NULL default '0',
  `rentalshipandreturnskipgloutonrentglnonstock` tinyint(1) NOT NULL default '0',
  `rentalshipandreturnskipgloutonrentglothercharges` tinyint(1) NOT NULL default '0',
  `rentalstockusescogspercentage` tinyint(1) NOT NULL default '0',
  `rentalnonstockusescogspercentage` tinyint(1) NOT NULL default '0',
  `rentalotherchargesusescogspercentage` tinyint(1) NOT NULL default '0',
  `jobsrequirecitystatezip` tinyint(4) NOT NULL default '0',
  `blockvoideftpayments` tinyint(1) NOT NULL default '0',
  `notebelowordertotal` varchar(100) NOT NULL default '',
  `invoicedeliverybullpinningenabled` tinyint(1) NOT NULL default '0',
  `invoicedeliverybullpinningexcludeafterdays` int(11) NOT NULL default '0',
  `invoicedeliverybullpinningexcludeinvoicesover` decimal(19,4) NOT NULL default '0.0000',
  `invoicedeliverybullpinningexcludecustomersover` decimal(19,4) NOT NULL default '0.0000',
  `invoicedeliverybullpinningexcludelastdayofmonth` tinyint(1) NOT NULL default '0',
  `invoicedeliverybullpinningexcludeallinvoiceswhenanypending` tinyint(1) NOT NULL default '1',
  `shipunreceivedpoaction` tinyint(1) NOT NULL default '0',
  `b2bpaymentfeeglcategoryid` int(11) NOT NULL default '0',
  `rentaldefaultglcategoryid` int(11) NOT NULL default '0',
  `invoicedeliverybullpinningexcludeemail` tinyint(1) NOT NULL default '0',
  `invoicedeliverybullpinningexcludemail` tinyint(1) NOT NULL default '0',
  `invoicedeliverybullpinningexcludefax` tinyint(1) NOT NULL default '0',
  `sendspecialpricelistexpnotice` int(11) NOT NULL default '-1',
  `sendspecialpricelistsummary` tinyint(1) NOT NULL default '0',
  `blocknegqtysales` tinyint(4) default '0',
  `dailydrawerclosecreatebankdepositmode` tinyint(1) NOT NULL default '0',
  `sendnewcustemail` tinyint(4) default '0',
  `refundcreditviacheckslocation` int(11) NOT NULL default '0',
  `bankdepositscanincluderefunds` tinyint(1) NOT NULL default '0',
  `bankdepositsincludeglexpenses` tinyint(1) NOT NULL default '0',
  `blockposforcustomerswithpricingonpacking` tinyint(4) default '0',
  `saveorderentryprogress` int(11) NOT NULL default '120',
  `fromemailforinvoices` varchar(255) NOT NULL default '',
  `fromemailforstatementsaddress` varchar(255) NOT NULL default '',
  `fromemailforprelim` varchar(255) NOT NULL default '',
  `fromemailfororderconfirmation` varchar(255) NOT NULL default '',
  `fromemailforbids` varchar(255) NOT NULL default '',
  `hideagingoncustomerstatements` tinyint(1) NOT NULL default '0',
  `updatecustomerinvoicetermsonsale` tinyint(1) NOT NULL default '1',
  `allowpaymentagainstclosedinvoice` tinyint(1) NOT NULL default '0',
  `showamountandduedateoninvoicefooter` tinyint(1) NOT NULL default '0',
  `groupitemsonorderconfirmation` tinyint(1) NOT NULL default '0',
  `enlargeorderinfotextonorderconfirmation` tinyint(1) default '0',
  `pricehistoryfomode` int(11) NOT NULL default '0',
  `pricehistorydayslimit` int(11) NOT NULL default '0',
  `showinvoicedateonpaymententry` tinyint(1) NOT NULL default '0',
  `hideduedateonpayment` tinyint(1) NOT NULL default '0',
  `showadjustedbalanceonpayment` tinyint(1) NOT NULL default '0',
  `invoiceagingusesduedate` tinyint(1) NOT NULL default '0',
  `invoiceagingexcludecredits` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arcompany`
--

LOCK TABLES `arcompany` WRITE;
/*!40000 ALTER TABLE `arcompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `arcompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ardailyclose`
--

DROP TABLE IF EXISTS `ardailyclose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ardailyclose` (
  `id` int(11) NOT NULL auto_increment,
  `inventorylocationid` int(11) NOT NULL,
  `closedate` date default NULL,
  `actualcash` decimal(19,4) NOT NULL default '0.0000',
  `currencybreakdown` text,
  `currency` varchar(10) default NULL,
  `sys_cash` decimal(19,4) NOT NULL default '0.0000',
  `sys_checks` decimal(19,4) NOT NULL default '0.0000',
  `sys_cc` decimal(19,4) NOT NULL default '0.0000',
  `gl_cash` decimal(19,4) NOT NULL default '0.0000',
  `gl_checks` decimal(19,4) NOT NULL default '0.0000',
  `gl_cc` decimal(19,4) NOT NULL default '0.0000',
  `actualchecks` decimal(19,4) NOT NULL default '0.0000',
  `cashdrawerfloat` decimal(19,4) NOT NULL default '0.0000',
  `depositeamount` decimal(19,4) NOT NULL default '0.0000',
  `actualcc` decimal(19,4) NOT NULL default '0.0000',
  `overshort` decimal(19,4) NOT NULL default '0.0000',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `location` (`inventorylocationid`),
  KEY `closedate` (`closedate`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ardailyclose`
--

LOCK TABLES `ardailyclose` WRITE;
/*!40000 ALTER TABLE `ardailyclose` DISABLE KEYS */;
/*!40000 ALTER TABLE `ardailyclose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `area`
--

DROP TABLE IF EXISTS `area`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `area` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `surveyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `applicationfee` decimal(19,6) NOT NULL default '0.000000',
  `blockfromsignups` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `area`
--

LOCK TABLES `area` WRITE;
/*!40000 ALTER TABLE `area` DISABLE KEYS */;
/*!40000 ALTER TABLE `area` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoice`
--

DROP TABLE IF EXISTS `arinvoice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoice` (
  `id` int(11) NOT NULL auto_increment,
  `invoicenumber` varchar(30) NOT NULL default '',
  `ponumber` varchar(30) default NULL,
  `wherefrom` int(11) NOT NULL default '2',
  `orderid` int(11) NOT NULL default '0',
  `orderbycompanyid` int(11) NOT NULL default '0',
  `shiptocompanyid` int(11) NOT NULL default '0',
  `status` int(11) NOT NULL default '0',
  `customerbillcode` varchar(20) default NULL,
  `shipcost` decimal(19,4) NOT NULL default '0.0000',
  `invoicetotal` decimal(19,4) NOT NULL default '0.0000',
  `invoicetermsid` int(11) NOT NULL default '0',
  `salesmanid` int(11) NOT NULL default '0',
  `invoicedate` date default NULL,
  `duedate` date default NULL,
  `discountdate` date default NULL,
  `discountamount` decimal(19,4) NOT NULL default '0.0000',
  `accruedinterest` decimal(19,4) NOT NULL default '0.0000',
  `datelastinterestcalc` date default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `pricelevelid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `payment_method` varchar(12) default NULL,
  `cc_type` varchar(20) default NULL,
  `cc_owner` varchar(64) default NULL,
  `cc_number` varchar(32) default NULL,
  `cc_expires` varchar(4) default NULL,
  `shipping_method` varchar(32) default NULL,
  `currency` varchar(10) NOT NULL default 'USD',
  `cc_PNREF` varchar(12) default NULL,
  `cc_AUTHCODE` varchar(6) default NULL,
  `transaction_id` varchar(32) default NULL,
  `customers_id` int(5) default NULL,
  `currency_value` decimal(14,6) NOT NULL default '0.000000',
  `servicerepid` int(11) NOT NULL default '0',
  `discountapplied` decimal(19,4) NOT NULL default '0.0000',
  `payplan` int(2) NOT NULL default '0',
  `payplan_period` int(5) NOT NULL default '0',
  `payplan_days` int(11) NOT NULL default '0',
  `payplan_next` date default NULL,
  `payplan_numtimes` int(11) NOT NULL default '0',
  `sales_categoriesid` int(11) NOT NULL default '0',
  `coverage` int(3) NOT NULL default '0',
  `formnumber` varchar(50) default NULL,
  `shiptoattn` varchar(100) default NULL,
  `old_id` varchar(255) default NULL,
  `client_po` varchar(30) default NULL,
  `currate` decimal(22,10) NOT NULL default '1.0000000000',
  `arglaccountid` int(11) NOT NULL default '0',
  `leaseid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `delivered` int(11) NOT NULL default '0',
  `carrierserviceid_preferred` int(11) NOT NULL default '0',
  `taxclassid` int(11) NOT NULL default '0',
  `b2bhidden` tinyint(1) NOT NULL default '0',
  `interestforinvoiceid` int(11) NOT NULL default '0',
  `zlienid` int(11) NOT NULL default '0',
  `billtrustsent` datetime default NULL,
  `faxsent` datetime default NULL,
  `emailsent` datetime default NULL,
  `contactnameid` int(11) NOT NULL default '0',
  `invoicenotificationmethod` varchar(1) NOT NULL default '',
  `jobid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `taxexemptid` int(11) NOT NULL default '0',
  `isacustomerreturn` varchar(1) NOT NULL default '0',
  `priceadjustmentforinvoiceid` int(11) NOT NULL default '0',
  `taxadjustmentforinvoiceid` int(11) NOT NULL default '0',
  `voucherid` int(11) NOT NULL default '0',
  `rental` tinyint(4) NOT NULL default '0',
  `paiddate` datetime default NULL,
  `paymeth` tinyint(1) NOT NULL default '0',
  `rentalconverttosale` tinyint(1) NOT NULL default '0',
  `modifiedfromarinvoiceid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invoicenumber` (`invoicenumber`),
  KEY `ponumber` (`ponumber`),
  KEY `orderbycompanyid` (`orderbycompanyid`),
  KEY `invoicedate` (`invoicedate`),
  KEY `shiptocompanyid` (`shiptocompanyid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `sales_categoriesid` (`sales_categoriesid`),
  KEY `cancel` (`cancel`),
  KEY `canceldate` (`canceldate`),
  KEY `lastchangedate` (`lastchangedate`),
  KEY `payplan` (`payplan`),
  KEY `orderid` (`orderid`),
  KEY `leaseid` (`leaseid`),
  KEY `salesmanid` (`salesmanid`),
  KEY `gltr_costcodeid` (`costcodeid`),
  KEY `jobid` (`jobid`),
  KEY `interestforinvoiceid` (`interestforinvoiceid`),
  KEY `glcategoryid` (`glcategoryid`),
  KEY `dataList` (`gencompanyid`,`status`,`payplan`,`cancel`),
  KEY `aging_report` (`cancel`,`status`,`gencompanyid`,`payplan`,`invoicedate`),
  KEY `billtrustsent` (`billtrustsent`),
  KEY `faxsent` (`faxsent`),
  KEY `emailsent` (`emailsent`),
  KEY `voucherid` (`voucherid`),
  KEY `inventorylocationid` (`inventorylocationid`),
  KEY `rental` (`rental`),
  KEY `activeonjob` (`jobid`,`cancel`),
  KEY `modifiedfromarinvoiceid` (`modifiedfromarinvoiceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoice`
--

LOCK TABLES `arinvoice` WRITE;
/*!40000 ALTER TABLE `arinvoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoice_interest`
--

DROP TABLE IF EXISTS `arinvoice_interest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoice_interest` (
  `id` int(11) NOT NULL auto_increment,
  `invoiceid` int(11) NOT NULL default '0',
  `calcdate` date default NULL,
  `amount` decimal(19,5) NOT NULL default '0.00000',
  `cancel` tinyint(4) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `balance` decimal(19,4) NOT NULL default '0.0000',
  `ratemonths` int(11) NOT NULL default '0',
  `rate` decimal(8,4) default NULL,
  `servicecharge` decimal(19,4) default NULL,
  `interestinvoiceid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `calcdate` (`calcdate`),
  KEY `cancel` (`cancel`),
  KEY `invoiceid` (`invoiceid`),
  KEY `interestinvoiceid` (`interestinvoiceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoice_interest`
--

LOCK TABLES `arinvoice_interest` WRITE;
/*!40000 ALTER TABLE `arinvoice_interest` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoice_interest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicecalculationscache`
--

DROP TABLE IF EXISTS `arinvoicecalculationscache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicecalculationscache` (
  `arinvoiceid` int(11) NOT NULL,
  `total` decimal(19,4) default NULL,
  `paid` decimal(19,4) default NULL,
  `discount` decimal(19,4) default NULL,
  `balance` decimal(19,4) default NULL,
  PRIMARY KEY  (`arinvoiceid`),
  KEY `everything` (`arinvoiceid`,`total`,`paid`,`discount`,`balance`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicecalculationscache`
--

LOCK TABLES `arinvoicecalculationscache` WRITE;
/*!40000 ALTER TABLE `arinvoicecalculationscache` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicecalculationscache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicedelivery`
--

DROP TABLE IF EXISTS `arinvoicedelivery`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicedelivery` (
  `id` int(11) NOT NULL auto_increment,
  `invoiceid` int(11) NOT NULL default '0',
  `deliverydate` date default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invoiceid` (`invoiceid`),
  KEY `entrydate` (`entrydate`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicedelivery`
--

LOCK TABLES `arinvoicedelivery` WRITE;
/*!40000 ALTER TABLE `arinvoicedelivery` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicedelivery` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicedeliverydetail`
--

DROP TABLE IF EXISTS `arinvoicedeliverydetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicedeliverydetail` (
  `id` int(11) NOT NULL auto_increment,
  `arinvoicedeliveryid` int(11) NOT NULL default '0',
  `linenumber` int(11) NOT NULL default '0',
  `description` varchar(100) default NULL,
  `qty` decimal(18,6) NOT NULL default '0.000000',
  `qtyunitnameid` int(11) NOT NULL default '0',
  `note` text,
  PRIMARY KEY  (`id`),
  KEY `arinvoicedeliveryid` (`arinvoicedeliveryid`),
  KEY `linenumber` (`linenumber`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicedeliverydetail`
--

LOCK TABLES `arinvoicedeliverydetail` WRITE;
/*!40000 ALTER TABLE `arinvoicedeliverydetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicedeliverydetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicedetail`
--

DROP TABLE IF EXISTS `arinvoicedetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicedetail` (
  `id` int(11) NOT NULL auto_increment,
  `invoiceid` int(11) NOT NULL default '0',
  `linenumber` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `description` varchar(255) default NULL,
  `qty` decimal(18,6) NOT NULL default '1.000000',
  `qtyunitnameid` int(11) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  `taxflag` int(11) NOT NULL default '0',
  `priceach` decimal(19,6) NOT NULL default '0.000000',
  `priceunitnameid` int(11) NOT NULL default '0',
  `qtyunitperpriceunit` decimal(19,6) NOT NULL default '1.000000',
  `totalprice` decimal(19,4) NOT NULL default '0.0000',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `costeach` decimal(19,6) NOT NULL default '0.000000',
  `costglaccountid` int(11) NOT NULL default '0',
  `main_arinvoicedetailid` int(11) NOT NULL default '0',
  `itemoptionid` int(11) NOT NULL default '0',
  `itemoptiongroupid` int(11) NOT NULL default '0',
  `taxflag2` int(2) NOT NULL default '0',
  `taxflag3` int(2) NOT NULL default '0',
  `taxflagid` int(11) NOT NULL default '0',
  `taxflag2id` int(11) NOT NULL default '0',
  `taxflag3id` int(11) NOT NULL default '0',
  `orig_priceach` decimal(12,5) NOT NULL default '0.00000',
  `discount_amount` decimal(12,5) NOT NULL default '0.00000',
  `discount_percent` decimal(12,5) NOT NULL default '0.00000',
  `old_id` varchar(255) default NULL,
  `pricelevelid` int(11) NOT NULL default '0',
  `price_override` int(5) NOT NULL default '0',
  `extended_price` decimal(19,5) NOT NULL default '0.00000',
  `worktypeid` int(11) NOT NULL default '0',
  `worksubtypeid` int(11) NOT NULL default '0',
  `returnqty` decimal(18,6) NOT NULL default '0.000000',
  `returndetailid` int(11) NOT NULL default '0',
  `discountid` int(11) NOT NULL default '0',
  `discountpercent` decimal(7,2) NOT NULL default '0.00',
  `inventorylocationid` int(11) NOT NULL default '0',
  `linedate` date default NULL,
  `taxclassid` int(11) NOT NULL default '0',
  `partialtaxexemptionid` int(11) NOT NULL default '0',
  `linetype` tinyint(1) NOT NULL default '0',
  `period` char(1) NOT NULL default '',
  `rentalbegindate` date default NULL,
  `itempricespecialdetailid` int(11) NOT NULL default '0',
  `numperiods` decimal(19,6) NOT NULL default '1.000000',
  `arorderdetailid` int(11) NOT NULL default '0',
  `producttypetaxid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invoiceid` (`invoiceid`),
  KEY `linenumber` (`linenumber`),
  KEY `qty` (`qty`),
  KEY `glaccountid` (`glaccountid`),
  KEY `inventorylocationid` (`inventorylocationid`),
  KEY `itemid` (`itemid`),
  KEY `taxclassid` (`taxclassid`),
  KEY `arorderdetailid` (`arorderdetailid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicedetail`
--

LOCK TABLES `arinvoicedetail` WRITE;
/*!40000 ALTER TABLE `arinvoicedetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicedetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicedetailcost`
--

DROP TABLE IF EXISTS `arinvoicedetailcost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicedetailcost` (
  `id` int(11) NOT NULL auto_increment,
  `invoiceid` int(11) NOT NULL default '0',
  `cost` decimal(19,4) NOT NULL default '0.0000',
  `costglaccountid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `itemid` int(11) NOT NULL default '0',
  `locationid` int(11) NOT NULL default '0',
  `arordershipdetailid` int(11) NOT NULL default '0',
  `inventoryglacctid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invoiceid` (`invoiceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicedetailcost`
--

LOCK TABLES `arinvoicedetailcost` WRITE;
/*!40000 ALTER TABLE `arinvoicedetailcost` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicedetailcost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicedetailnotes`
--

DROP TABLE IF EXISTS `arinvoicedetailnotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicedetailnotes` (
  `id` int(11) NOT NULL auto_increment,
  `invoiceid` int(11) NOT NULL default '0',
  `linenumber` int(11) NOT NULL default '0',
  `note` text,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `private` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invoiceid` (`invoiceid`),
  KEY `linenumber` (`linenumber`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicedetailnotes`
--

LOCK TABLES `arinvoicedetailnotes` WRITE;
/*!40000 ALTER TABLE `arinvoicedetailnotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicedetailnotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicedetailpending`
--

DROP TABLE IF EXISTS `arinvoicedetailpending`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicedetailpending` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `unitid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `camallocationid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `description` varchar(100) NOT NULL default '',
  `qty` decimal(18,6) NOT NULL default '1.000000',
  `qtyunitnameid` int(11) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  `taxflag` int(11) NOT NULL default '0',
  `priceach` decimal(19,6) NOT NULL default '0.000000',
  `priceunitnameid` int(11) NOT NULL default '0',
  `qtyunitperpriceunit` decimal(19,6) NOT NULL default '0.000000',
  `totalprice` decimal(19,4) NOT NULL default '0.0000',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `costeach` decimal(19,6) NOT NULL default '0.000000',
  `costglaccountid` int(11) NOT NULL default '0',
  `taxflag2` int(2) NOT NULL default '0',
  `taxflag3` int(2) NOT NULL default '0',
  `taxflagid` int(11) NOT NULL default '0',
  `taxflag2id` int(11) NOT NULL default '0',
  `taxflag3id` int(11) NOT NULL default '0',
  `pricelevelid` int(11) NOT NULL default '0',
  `price_override` int(5) NOT NULL default '0',
  `extended_price` decimal(19,5) NOT NULL default '0.00000',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invoiceid` (`invoiceid`),
  KEY `unitid` (`unitid`),
  KEY `camallocationid` (`camallocationid`),
  KEY `customerid` (`customerid`),
  KEY `qty` (`qty`),
  KEY `glaccountid` (`glaccountid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicedetailpending`
--

LOCK TABLES `arinvoicedetailpending` WRITE;
/*!40000 ALTER TABLE `arinvoicedetailpending` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicedetailpending` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicedetailref`
--

DROP TABLE IF EXISTS `arinvoicedetailref`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicedetailref` (
  `id` int(11) NOT NULL auto_increment,
  `arinvoicedetailid` int(11) NOT NULL,
  `reftable` varchar(64) NOT NULL default '',
  `refid` int(11) NOT NULL,
  `reftag` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `arinvoicedetailid` (`arinvoicedetailid`),
  KEY `ref` (`reftable`,`refid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicedetailref`
--

LOCK TABLES `arinvoicedetailref` WRITE;
/*!40000 ALTER TABLE `arinvoicedetailref` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicedetailref` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicenotes`
--

DROP TABLE IF EXISTS `arinvoicenotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicenotes` (
  `invoiceid` int(11) NOT NULL default '0',
  `note` text,
  `hide` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `linenumber` int(11) NOT NULL default '0',
  `source_noteid` int(11) NOT NULL default '0',
  `id` int(11) NOT NULL auto_increment,
  UNIQUE KEY `id` (`id`),
  KEY `invoiceid` (`invoiceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicenotes`
--

LOCK TABLES `arinvoicenotes` WRITE;
/*!40000 ALTER TABLE `arinvoicenotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicenotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicenotice`
--

DROP TABLE IF EXISTS `arinvoicenotice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicenotice` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `action` varchar(45) NOT NULL default '',
  `tablename` varchar(45) NOT NULL default '',
  `tableid` int(11) default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `action` (`action`),
  KEY `tabledata` (`tablename`,`tableid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicenotice`
--

LOCK TABLES `arinvoicenotice` WRITE;
/*!40000 ALTER TABLE `arinvoicenotice` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicenotice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicenotification`
--

DROP TABLE IF EXISTS `arinvoicenotification`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicenotification` (
  `id` int(11) NOT NULL auto_increment,
  `begindate` date default NULL,
  `enddate` date default NULL,
  `datesent` datetime default NULL,
  `numbersent` int(11) NOT NULL default '0',
  `numberqueued` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `latenotice` varchar(25) NOT NULL default '',
  `dayslate` int(11) default NULL,
  `chargefee` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `datesent` (`datesent`),
  KEY `entryuserid` (`entryuserid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicenotification`
--

LOCK TABLES `arinvoicenotification` WRITE;
/*!40000 ALTER TABLE `arinvoicenotification` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicenotification` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicepaymentdetail`
--

DROP TABLE IF EXISTS `arinvoicepaymentdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicepaymentdetail` (
  `id` int(11) NOT NULL auto_increment,
  `invoiceid` int(11) NOT NULL default '0',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `voucherid` int(11) NOT NULL default '0',
  `datereceived` date default NULL,
  `paymeth` int(11) NOT NULL default '1',
  `interest` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel_userid` int(11) NOT NULL default '0',
  `checkid` varchar(100) default NULL,
  `bankdepositid` int(11) NOT NULL default '0',
  `bankstatement_enddate` date default NULL,
  `old_id` varchar(255) default NULL,
  `refund_paymeth` int(11) NOT NULL default '0',
  `cctransactionid` int(11) NOT NULL default '0',
  `currency` varchar(10) NOT NULL default 'USD',
  `returned` int(11) NOT NULL default '0',
  `feeinvoiceid` int(11) NOT NULL default '0',
  `feeapbillid` int(11) NOT NULL default '0',
  `bankfee_amount` decimal(19,4) NOT NULL default '0.0000',
  `bankfee_glid` int(11) NOT NULL default '0',
  `rnum` varchar(30) NOT NULL default '',
  `tendered` decimal(19,4) NOT NULL default '0.0000',
  `transid` varchar(32) default NULL,
  `orderdepositid` int(11) NOT NULL default '0',
  `jointcheck` tinyint(1) NOT NULL default '0',
  `isb2bpaymentfee` tinyint(1) NOT NULL default '0',
  `isb2bpayment` tinyint(1) NOT NULL default '0',
  `ispaymentonaccount` tinyint(1) NOT NULL default '0',
  `writeoffreasonid` tinyint(1) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `ccterminalid` int(11) NOT NULL default '0',
  `extuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `voucherid` (`voucherid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `paymeth` (`paymeth`),
  KEY `checkid` (`checkid`),
  KEY `bankdepositid` (`bankdepositid`),
  KEY `cancel` (`cancel`),
  KEY `rnum` (`rnum`),
  KEY `interest` (`interest`),
  KEY `datereceived` (`datereceived`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicepaymentdetail`
--

LOCK TABLES `arinvoicepaymentdetail` WRITE;
/*!40000 ALTER TABLE `arinvoicepaymentdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicepaymentdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicepaymentnotes`
--

DROP TABLE IF EXISTS `arinvoicepaymentnotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicepaymentnotes` (
  `id` int(11) NOT NULL auto_increment,
  `voucherid` int(11) NOT NULL default '0',
  `note` text,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `voucherid` (`voucherid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicepaymentnotes`
--

LOCK TABLES `arinvoicepaymentnotes` WRITE;
/*!40000 ALTER TABLE `arinvoicepaymentnotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicepaymentnotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicestdnotes`
--

DROP TABLE IF EXISTS `arinvoicestdnotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicestdnotes` (
  `id` int(11) NOT NULL auto_increment,
  `shortnote` varchar(50) default NULL,
  `full_note` text,
  `sortorder` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `autoselect` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `sortorder` (`sortorder`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicestdnotes`
--

LOCK TABLES `arinvoicestdnotes` WRITE;
/*!40000 ALTER TABLE `arinvoicestdnotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicestdnotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicetaxdetail`
--

DROP TABLE IF EXISTS `arinvoicetaxdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicetaxdetail` (
  `id` int(11) NOT NULL auto_increment,
  `invoiceid` int(11) NOT NULL default '0',
  `taxid` int(11) NOT NULL default '0',
  `partialtaxid` int(11) NOT NULL default '0',
  `taxrate` decimal(12,5) NOT NULL default '0.00000',
  `taxamount` decimal(19,4) NOT NULL default '0.0000',
  `taxcap` decimal(19,4) NOT NULL default '0.0000',
  `taxexemptid` int(11) NOT NULL default '0',
  `taxexemptportion` decimal(12,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`),
  KEY `invoiceid` (`invoiceid`),
  KEY `taxid` (`taxid`),
  KEY `taxexemptid` (`taxexemptid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicetaxdetail`
--

LOCK TABLES `arinvoicetaxdetail` WRITE;
/*!40000 ALTER TABLE `arinvoicetaxdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicetaxdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arinvoicevoucherbatch`
--

DROP TABLE IF EXISTS `arinvoicevoucherbatch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arinvoicevoucherbatch` (
  `id` int(11) NOT NULL auto_increment,
  `invoiceid` int(11) NOT NULL default '0',
  `voucherid` int(11) NOT NULL default '0',
  `batchid` varchar(16) NOT NULL default '',
  `reversed` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invoiceid` (`invoiceid`),
  KEY `voucherid` (`voucherid`),
  KEY `batchid` (`batchid`),
  KEY `reversed` (`reversed`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arinvoicevoucherbatch`
--

LOCK TABLES `arinvoicevoucherbatch` WRITE;
/*!40000 ALTER TABLE `arinvoicevoucherbatch` DISABLE KEYS */;
/*!40000 ALTER TABLE `arinvoicevoucherbatch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorder`
--

DROP TABLE IF EXISTS `arorder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorder` (
  `id` int(11) NOT NULL auto_increment,
  `ordernumber` double NOT NULL default '0',
  `onum` varchar(30) NOT NULL default '',
  `ponumber` varchar(30) default NULL,
  `orderbycompanyid` int(11) NOT NULL default '0',
  `shiptocompanyid` int(11) NOT NULL default '0',
  `status` int(11) NOT NULL default '0',
  `customerbillcode` varchar(20) default NULL,
  `companyid` int(11) NOT NULL default '0',
  `pricelevelid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `duedate` date default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `payment_method` varchar(12) default '',
  `cc_type` varchar(20) default NULL,
  `cc_owner` varchar(64) default NULL,
  `cc_number` varchar(32) default NULL,
  `cc_expires` varchar(7) default NULL,
  `shipping_method` varchar(32) default NULL,
  `orders_date_finished` timestamp NOT NULL default '0000-00-00 00:00:00',
  `currency` varchar(10) NOT NULL default 'USD',
  `cc_PNREF` varchar(12) default NULL,
  `cc_AUTHCODE` varchar(6) default NULL,
  `transaction_id` varchar(32) default NULL,
  `customers_id` int(5) default NULL,
  `shipping_cost` decimal(19,4) NOT NULL default '0.0000',
  `order_weight` decimal(12,2) NOT NULL default '0.00',
  `ordertotal` decimal(19,4) NOT NULL default '0.0000',
  `currency_value` decimal(14,6) default NULL,
  `wherefrom` varchar(100) default '',
  `confirmed_by` varchar(100) default '',
  `confirmed_date` varchar(100) default '',
  `confirmed` varchar(100) default '',
  `paymeth` int(11) NOT NULL default '0',
  `ordertype` int(2) NOT NULL default '0',
  `estimate` decimal(19,4) NOT NULL default '0.0000',
  `deposit` decimal(19,4) NOT NULL default '0.0000',
  `salesmanid` int(11) NOT NULL default '0',
  `sales_categoriesid` int(11) NOT NULL default '0',
  `statusid` int(11) NOT NULL default '0',
  `rma_arorder_returnedid` int(11) NOT NULL default '0',
  `rma_orig_arorderid` int(11) NOT NULL default '0',
  `carrierserviceid_preferred` int(11) NOT NULL default '0',
  `finalship` int(5) NOT NULL default '0',
  `currate` decimal(22,10) NOT NULL default '1.0000000000',
  `arglaccountid` int(11) NOT NULL default '0',
  `defaultworktypeid` int(11) NOT NULL default '0',
  `jobid` int(11) NOT NULL default '0',
  `defaultworksubtypeid` int(11) NOT NULL default '0',
  `stageid` int(11) NOT NULL default '0',
  `edi` int(11) NOT NULL default '0',
  `ediasn` int(11) NOT NULL default '0',
  `ediinvoice` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `dropship` tinyint(1) NOT NULL default '0',
  `unread` tinyint(1) NOT NULL default '0',
  `contactnameid` int(11) NOT NULL default '0',
  `usecontactdetails` tinyint(1) NOT NULL default '0',
  `signaturerequired` tinyint(1) NOT NULL default '0',
  `rentalsbillwhen` tinyint(1) NOT NULL default '0',
  `outsidesalesmargin` int(11) NOT NULL default '0',
  `lastshipdate` datetime default NULL,
  `defaultvendorid` int(11) NOT NULL default '0',
  `shippingnotes` text,
  `revision` int(11) NOT NULL default '0',
  `pickticklastprint` datetime default NULL,
  `pickticknumprint` int(11) NOT NULL default '0',
  `taxclassid` int(11) NOT NULL default '0',
  `taxexemptid` int(11) NOT NULL default '0',
  `clonedquotearorderid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ponumber` (`ponumber`),
  KEY `ordernumber` (`ordernumber`),
  KEY `inventorylocationid` (`inventorylocationid`),
  KEY `companyid` (`companyid`),
  KEY `shiptocompanyid` (`shiptocompanyid`),
  KEY `pricelevelid` (`pricelevelid`),
  KEY `orderbycompanyid` (`orderbycompanyid`),
  KEY `sales_categoriesid` (`sales_categoriesid`),
  KEY `jobid` (`jobid`),
  KEY `stageid` (`stageid`),
  KEY `edi` (`edi`),
  KEY `onum` (`onum`),
  KEY `gltr_costcodeid` (`costcodeid`),
  KEY `glcategoryid` (`glcategoryid`),
  KEY `ccso` (`companyid`,`cancel`,`status`,`ordertype`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorder`
--

LOCK TABLES `arorder` WRITE;
/*!40000 ALTER TABLE `arorder` DISABLE KEYS */;
/*!40000 ALTER TABLE `arorder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorder_deposit`
--

DROP TABLE IF EXISTS `arorder_deposit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorder_deposit` (
  `id` int(11) NOT NULL auto_increment,
  `orderid` int(11) NOT NULL default '0',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `payment_method` int(5) NOT NULL default '0',
  `transaction_id` varchar(32) default NULL,
  `entrydate` date default NULL,
  `cc_type` varchar(20) default NULL,
  `last4ofcard` varchar(4) default NULL,
  `voucherid` int(11) NOT NULL default '0',
  `cancel` int(3) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `bankdepositid` int(11) NOT NULL default '0',
  `cctransactionid` int(11) NOT NULL default '0',
  `checkid` varchar(20) default NULL,
  `bankstatement_enddate` date default NULL,
  `checkacctid` int(11) NOT NULL default '0',
  `currency` varchar(10) NOT NULL default 'USD',
  `returned` int(11) NOT NULL default '0',
  `bankfee_amount` decimal(19,4) NOT NULL default '0.0000',
  `bankfee_glid` int(11) NOT NULL default '0',
  `rnum` varchar(30) NOT NULL default '',
  `tendered` decimal(19,4) NOT NULL default '0.0000',
  `ccterminalid` int(11) NOT NULL default '0',
  `notes` text,
  PRIMARY KEY  (`id`),
  KEY `orderid` (`orderid`),
  KEY `voucherid` (`voucherid`),
  KEY `rnum` (`rnum`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorder_deposit`
--

LOCK TABLES `arorder_deposit` WRITE;
/*!40000 ALTER TABLE `arorder_deposit` DISABLE KEYS */;
/*!40000 ALTER TABLE `arorder_deposit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arordercalculationscache`
--

DROP TABLE IF EXISTS `arordercalculationscache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arordercalculationscache` (
  `arorderid` int(11) NOT NULL,
  `effective_status` tinyint(1) NOT NULL,
  `lastrentalbilldate_data` text NOT NULL,
  `lastbilled` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`arorderid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arordercalculationscache`
--

LOCK TABLES `arordercalculationscache` WRITE;
/*!40000 ALTER TABLE `arordercalculationscache` DISABLE KEYS */;
/*!40000 ALTER TABLE `arordercalculationscache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorderdepositcredit`
--

DROP TABLE IF EXISTS `arorderdepositcredit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorderdepositcredit` (
  `id` int(11) NOT NULL auto_increment,
  `orderdepositid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` tinyint(4) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `orderdepositid` (`orderdepositid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `cancel` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorderdepositcredit`
--

LOCK TABLES `arorderdepositcredit` WRITE;
/*!40000 ALTER TABLE `arorderdepositcredit` DISABLE KEYS */;
/*!40000 ALTER TABLE `arorderdepositcredit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorderdetail`
--

DROP TABLE IF EXISTS `arorderdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorderdetail` (
  `id` int(11) NOT NULL auto_increment,
  `orderid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `linenumber` int(11) NOT NULL default '0',
  `qtyorder` decimal(18,6) NOT NULL default '0.000000',
  `qtyship` decimal(18,6) NOT NULL default '0.000000',
  `qtybill` decimal(18,6) NOT NULL default '0.000000',
  `glaccountid` int(11) NOT NULL default '0',
  `taxflag` int(11) NOT NULL default '0',
  `costeach` decimal(19,6) NOT NULL default '0.000000',
  `priceach` decimal(19,6) NOT NULL default '0.000000',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `products_tax` decimal(7,4) NOT NULL default '0.0000',
  `description` varchar(255) default NULL,
  `saleunitperpriceunit` decimal(19,6) NOT NULL default '1.000000',
  `costglaccountid` int(11) NOT NULL default '0',
  `purchaseunitid` int(11) NOT NULL default '0',
  `priceunitid` int(11) NOT NULL default '0',
  `main_arorderdetailid` int(11) NOT NULL default '0',
  `itemoptiongroupid` int(11) NOT NULL default '0',
  `itemoptionid` int(11) NOT NULL default '0',
  `multioption` int(2) NOT NULL default '0',
  `optionindependent` int(2) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `taxflag2` int(2) NOT NULL default '0',
  `taxflag3` int(2) NOT NULL default '0',
  `taxflagid` int(11) NOT NULL default '0',
  `taxflag2id` int(11) NOT NULL default '0',
  `taxflag3id` int(11) NOT NULL default '0',
  `itemweight` decimal(12,6) NOT NULL default '0.000000',
  `qtyorderprice` double NOT NULL default '0',
  `pricelevelid` int(11) NOT NULL default '0',
  `price_override` int(5) NOT NULL default '0',
  `extended_price` decimal(19,5) NOT NULL default '0.00000',
  `worktypeid` int(11) NOT NULL default '0',
  `worksubtypeid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `discount_percent` decimal(6,2) NOT NULL default '0.00',
  `orig_priceach` decimal(19,6) NOT NULL default '0.000000',
  `linedate` date default NULL,
  `taxclassid` int(11) NOT NULL default '0',
  `transfrominventorylocationid` int(11) NOT NULL default '0',
  `linetype` tinyint(1) NOT NULL default '0',
  `period` char(1) NOT NULL default '',
  `numperiods` decimal(19,6) NOT NULL default '1.000000',
  `partialtaxexemptionid` int(11) NOT NULL default '0',
  `producttypetaxid` int(11) NOT NULL default '0',
  `createpowhenconvertedfrombid` tinyint(1) NOT NULL default '0',
  `ignoretaxexempt` tinyint(1) NOT NULL default '0',
  `itempricespecialdetailid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `orderid` (`orderid`),
  KEY `itemid` (`itemid`),
  KEY `linenumber` (`linenumber`),
  KEY `qtyorder` (`qtyorder`),
  KEY `qtyship` (`qtyship`),
  KEY `qtybill` (`qtybill`),
  KEY `glaccountid` (`glaccountid`),
  KEY `main_arorderdetailid` (`main_arorderdetailid`),
  KEY `itemoptionid` (`itemoptionid`),
  KEY `taxclassid` (`taxclassid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorderdetail`
--

LOCK TABLES `arorderdetail` WRITE;
/*!40000 ALTER TABLE `arorderdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `arorderdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorderdetailforeignnotes`
--

DROP TABLE IF EXISTS `arorderdetailforeignnotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorderdetailforeignnotes` (
  `id` int(11) NOT NULL auto_increment,
  `arorderdetailid` int(11) NOT NULL default '0',
  `tablename` varchar(64) NOT NULL default '',
  `recordid` int(11) NOT NULL default '0',
  `notes` text NOT NULL,
  `cancel` tinyint(1) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `foreignref` (`tablename`,`recordid`),
  KEY `detailid` (`arorderdetailid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorderdetailforeignnotes`
--

LOCK TABLES `arorderdetailforeignnotes` WRITE;
/*!40000 ALTER TABLE `arorderdetailforeignnotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `arorderdetailforeignnotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorderdetailnotes`
--

DROP TABLE IF EXISTS `arorderdetailnotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorderdetailnotes` (
  `id` int(11) NOT NULL auto_increment,
  `orderid` int(11) NOT NULL default '0',
  `linenumber` int(11) NOT NULL default '0',
  `note` text,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `private` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `orderid` (`orderid`),
  KEY `linenumber` (`linenumber`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorderdetailnotes`
--

LOCK TABLES `arorderdetailnotes` WRITE;
/*!40000 ALTER TABLE `arorderdetailnotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `arorderdetailnotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorderdetailseq`
--

DROP TABLE IF EXISTS `arorderdetailseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorderdetailseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorderdetailseq`
--

LOCK TABLES `arorderdetailseq` WRITE;
/*!40000 ALTER TABLE `arorderdetailseq` DISABLE KEYS */;
INSERT INTO `arorderdetailseq` VALUES (0);
/*!40000 ALTER TABLE `arorderdetailseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorderdetailstdnotes`
--

DROP TABLE IF EXISTS `arorderdetailstdnotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorderdetailstdnotes` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(50) default NULL,
  `note` text,
  `sortorder` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `sortorder` (`sortorder`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorderdetailstdnotes`
--

LOCK TABLES `arorderdetailstdnotes` WRITE;
/*!40000 ALTER TABLE `arorderdetailstdnotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `arorderdetailstdnotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arordermarginlog`
--

DROP TABLE IF EXISTS `arordermarginlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arordermarginlog` (
  `id` int(11) NOT NULL auto_increment,
  `orderid` int(11) NOT NULL default '0',
  `totalprice` decimal(19,6) NOT NULL default '0.000000',
  `totalcost` decimal(19,6) NOT NULL default '0.000000',
  `margin` decimal(6,2) NOT NULL default '0.00',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `minmargin` decimal(6,2) NOT NULL default '0.00',
  `maxmargin` decimal(6,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`),
  KEY `orderid` (`orderid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arordermarginlog`
--

LOCK TABLES `arordermarginlog` WRITE;
/*!40000 ALTER TABLE `arordermarginlog` DISABLE KEYS */;
/*!40000 ALTER TABLE `arordermarginlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arordernotes`
--

DROP TABLE IF EXISTS `arordernotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arordernotes` (
  `orderid` int(11) NOT NULL default '0',
  `note` text,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `source_noteid` int(11) NOT NULL default '0',
  `linenumber` int(11) NOT NULL default '0',
  `internal` int(5) NOT NULL default '0',
  `id` int(11) NOT NULL auto_increment,
  UNIQUE KEY `id` (`id`),
  KEY `orderid` (`orderid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arordernotes`
--

LOCK TABLES `arordernotes` WRITE;
/*!40000 ALTER TABLE `arordernotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `arordernotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorderrentalpickup`
--

DROP TABLE IF EXISTS `arorderrentalpickup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorderrentalpickup` (
  `id` int(11) NOT NULL auto_increment,
  `orderid` int(11) NOT NULL default '0',
  `assigneduserid` int(11) NOT NULL default '0',
  `assigneddate` date default NULL,
  `pickedupdate` date default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `status` tinyint(1) NOT NULL default '0' COMMENT '0=open, 1=assigned, 2=picked up, 3=returned/received in warehouse/complete',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `order` (`orderid`),
  KEY `status` (`status`,`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorderrentalpickup`
--

LOCK TABLES `arorderrentalpickup` WRITE;
/*!40000 ALTER TABLE `arorderrentalpickup` DISABLE KEYS */;
/*!40000 ALTER TABLE `arorderrentalpickup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorderrentalpickupdetail`
--

DROP TABLE IF EXISTS `arorderrentalpickupdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorderrentalpickupdetail` (
  `id` int(11) NOT NULL auto_increment,
  `arorderrentalpickupid` int(11) NOT NULL default '0',
  `ordershipdetailid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `quantity` decimal(18,6) NOT NULL default '0.000000',
  `status` tinyint(1) NOT NULL default '0' COMMENT '0=open, 1=assigned, 2=picked up, 3=returned/received in warehouse/complete',
  `arinvoiceid` int(11) NOT NULL default '0',
  `offrentdate` date default NULL,
  `inventorylocationid` int(11) NOT NULL default '0',
  `linenotes` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `parent` (`arorderrentalpickupid`),
  KEY `shipment` (`ordershipdetailid`),
  KEY `arinvoiceid` (`arinvoiceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorderrentalpickupdetail`
--

LOCK TABLES `arorderrentalpickupdetail` WRITE;
/*!40000 ALTER TABLE `arorderrentalpickupdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `arorderrentalpickupdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorderseq`
--

DROP TABLE IF EXISTS `arorderseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorderseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorderseq`
--

LOCK TABLES `arorderseq` WRITE;
/*!40000 ALTER TABLE `arorderseq` DISABLE KEYS */;
INSERT INTO `arorderseq` VALUES (238);
/*!40000 ALTER TABLE `arorderseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arordership`
--

DROP TABLE IF EXISTS `arordership`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arordership` (
  `id` int(11) NOT NULL auto_increment,
  `orderid` int(11) NOT NULL default '0',
  `carrierserviceid` int(11) NOT NULL default '0',
  `shipdate` datetime default NULL,
  `locationid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `shiptoid` int(11) NOT NULL default '0',
  `voucherid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `orderid` (`orderid`),
  KEY `shipdate` (`shipdate`),
  KEY `locationid` (`locationid`),
  KEY `shiptoid` (`shiptoid`),
  KEY `cancel` (`cancel`),
  KEY `carrierserviceid` (`carrierserviceid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `activeorder` (`cancel`,`orderid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arordership`
--

LOCK TABLES `arordership` WRITE;
/*!40000 ALTER TABLE `arordership` DISABLE KEYS */;
/*!40000 ALTER TABLE `arordership` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arordershipdetail`
--

DROP TABLE IF EXISTS `arordershipdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arordershipdetail` (
  `id` int(11) NOT NULL auto_increment,
  `ordershipid` int(11) NOT NULL default '0',
  `orderdetailid` int(11) NOT NULL default '0',
  `shipqty` decimal(18,6) NOT NULL default '0.000000',
  `adjustmentqty` decimal(18,6) NOT NULL default '0.000000',
  `adjustmentqtysansonhand` decimal(18,6) NOT NULL default '0.000000',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `inventoryglacctid` int(11) NOT NULL default '0',
  `costeach` decimal(19,6) NOT NULL default '0.000000',
  `lastrentalbilldate` date default NULL,
  `minrentalbilldate` date default NULL,
  `rentalreturnqty` decimal(18,6) NOT NULL default '0.000000',
  `rentalreturncomplete` tinyint(1) NOT NULL default '0',
  `rentalreturndate` date default NULL,
  `rentalvalue` decimal(19,6) NOT NULL default '0.000000',
  `rentalisoffrent` tinyint(1) NOT NULL default '0',
  `rentaloffrentqty` decimal(19,6) NOT NULL default '0.000000',
  `rentalissold` tinyint(1) NOT NULL default '0',
  `rentalsolddate` date default NULL,
  `rentalsoldqty` decimal(19,6) NOT NULL default '0.000000',
  `rentaloffrentdate` date default NULL,
  PRIMARY KEY  (`id`),
  KEY `orderdetailid` (`orderdetailid`),
  KEY `shipqty` (`shipqty`),
  KEY `ordershipid` (`ordershipid`),
  KEY `entrydate` (`entrydate`),
  KEY `rentalreturncomplete` (`rentalreturncomplete`),
  KEY `lastrentalbilldate` (`lastrentalbilldate`),
  KEY `rentalreturndate` (`rentalreturndate`),
  KEY `rentalissold` (`rentalissold`),
  KEY `rentalsolddate` (`rentalsolddate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arordershipdetail`
--

LOCK TABLES `arordershipdetail` WRITE;
/*!40000 ALTER TABLE `arordershipdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `arordershipdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arordershippackage`
--

DROP TABLE IF EXISTS `arordershippackage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arordershippackage` (
  `id` int(11) NOT NULL auto_increment,
  `ordershipid` int(11) NOT NULL default '0',
  `weight` double NOT NULL default '0',
  `cost` decimal(19,4) NOT NULL default '0.0000',
  `tracknumber` char(50) NOT NULL default '',
  `arinvoiceid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ordershipid` (`ordershipid`),
  KEY `tracknumber` (`tracknumber`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arordershippackage`
--

LOCK TABLES `arordershippackage` WRITE;
/*!40000 ALTER TABLE `arordershippackage` DISABLE KEYS */;
/*!40000 ALTER TABLE `arordershippackage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arordertax`
--

DROP TABLE IF EXISTS `arordertax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arordertax` (
  `id` int(11) NOT NULL auto_increment,
  `orderid` int(11) NOT NULL default '0',
  `taxrateid` int(11) NOT NULL default '0',
  `partialtaxrateid` int(11) NOT NULL default '0',
  `tax` decimal(19,4) NOT NULL default '0.0000',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `taxrate` decimal(12,5) NOT NULL default '0.00000',
  `taxcap` decimal(19,4) NOT NULL default '0.0000',
  `taxexemptid` int(11) NOT NULL default '0',
  `taxexemptportion` decimal(12,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`),
  KEY `orderid` (`orderid`),
  KEY `taxrateid` (`taxrateid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arordertax`
--

LOCK TABLES `arordertax` WRITE;
/*!40000 ALTER TABLE `arordertax` DISABLE KEYS */;
/*!40000 ALTER TABLE `arordertax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arordertrack`
--

DROP TABLE IF EXISTS `arordertrack`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arordertrack` (
  `id` int(11) NOT NULL auto_increment,
  `orderid` int(11) NOT NULL default '0',
  `action` int(11) NOT NULL default '0',
  `trackdate` datetime default NULL,
  `trackuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `orderid` (`orderid`),
  KEY `trackuserid` (`trackuserid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arordertrack`
--

LOCK TABLES `arordertrack` WRITE;
/*!40000 ALTER TABLE `arordertrack` DISABLE KEYS */;
/*!40000 ALTER TABLE `arordertrack` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arorderunsaved`
--

DROP TABLE IF EXISTS `arorderunsaved`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arorderunsaved` (
  `id` int(11) NOT NULL auto_increment,
  `genuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `snapshot` mediumtext NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `user` (`genuserid`,`gencompanyid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arorderunsaved`
--

LOCK TABLES `arorderunsaved` WRITE;
/*!40000 ALTER TABLE `arorderunsaved` DISABLE KEYS */;
/*!40000 ALTER TABLE `arorderunsaved` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arserviceorder_prepaid_time`
--

DROP TABLE IF EXISTS `arserviceorder_prepaid_time`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arserviceorder_prepaid_time` (
  `id` int(11) NOT NULL auto_increment,
  `hours` decimal(12,2) NOT NULL default '0.00',
  `hours_used` decimal(12,2) NOT NULL default '0.00',
  `complete` int(5) NOT NULL default '0',
  `worktypeid` int(11) NOT NULL default '0',
  `orderid` int(11) NOT NULL default '0',
  `rate_per_hour` decimal(16,5) NOT NULL default '0.00000',
  `total_price` decimal(16,5) NOT NULL default '0.00000',
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `workclassid` int(11) NOT NULL default '0',
  `currency` varchar(10) NOT NULL default 'USD',
  PRIMARY KEY  (`id`),
  KEY `orderid` (`orderid`),
  KEY `worktypeid` (`worktypeid`),
  KEY `cancel` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arserviceorder_prepaid_time`
--

LOCK TABLES `arserviceorder_prepaid_time` WRITE;
/*!40000 ALTER TABLE `arserviceorder_prepaid_time` DISABLE KEYS */;
/*!40000 ALTER TABLE `arserviceorder_prepaid_time` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arserviceorder_time`
--

DROP TABLE IF EXISTS `arserviceorder_time`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arserviceorder_time` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `ordered` int(11) NOT NULL default '0',
  `techname` varchar(50) default NULL,
  `hours` decimal(10,2) NOT NULL default '0.00',
  `startdatetime` datetime default NULL,
  `enddatetime` datetime default NULL,
  `rate` decimal(10,4) NOT NULL default '0.0000',
  `totalprice` decimal(10,4) NOT NULL default '0.0000',
  `totalcost` decimal(10,4) NOT NULL default '0.0000',
  `worktypeid` int(11) NOT NULL default '0',
  `worksubtypeid` int(11) NOT NULL default '0',
  `workclassid` int(11) NOT NULL default '0',
  `notes` text,
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `internal_comment` text,
  `costrate` decimal(10,4) NOT NULL default '0.0000',
  `status` int(3) NOT NULL default '0',
  `orderid` int(11) NOT NULL default '0',
  `currency` varchar(10) NOT NULL default 'USD',
  PRIMARY KEY  (`id`),
  KEY `employeeid` (`employeeid`),
  KEY `worktypeid` (`worktypeid`),
  KEY `vendorid` (`vendorid`),
  KEY `ordered` (`ordered`),
  KEY `entrydate` (`entrydate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arserviceorder_time`
--

LOCK TABLES `arserviceorder_time` WRITE;
/*!40000 ALTER TABLE `arserviceorder_time` DISABLE KEYS */;
/*!40000 ALTER TABLE `arserviceorder_time` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `arstatusoptions`
--

DROP TABLE IF EXISTS `arstatusoptions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `arstatusoptions` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(50) default NULL,
  `sortorder` int(5) NOT NULL default '1',
  `complete` tinyint(1) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `sortorder` (`sortorder`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `arstatusoptions`
--

LOCK TABLES `arstatusoptions` WRITE;
/*!40000 ALTER TABLE `arstatusoptions` DISABLE KEYS */;
/*!40000 ALTER TABLE `arstatusoptions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `authorizenetaccounts`
--

DROP TABLE IF EXISTS `authorizenetaccounts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `authorizenetaccounts` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `ccaccountid` int(11) default '0',
  `customerrefid` varchar(45) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `authorizenetaccounts`
--

LOCK TABLES `authorizenetaccounts` WRITE;
/*!40000 ALTER TABLE `authorizenetaccounts` DISABLE KEYS */;
/*!40000 ALTER TABLE `authorizenetaccounts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `autobilllog`
--

DROP TABLE IF EXISTS `autobilllog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `autobilllog` (
  `id` int(11) NOT NULL auto_increment,
  `autobilldate` datetime default NULL,
  `customerid` int(11) NOT NULL default '0',
  `leaseid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `arinvoicepaymentdetailid` int(11) NOT NULL default '0',
  `cctransactionid` int(11) NOT NULL default '0',
  `paymentplanid` int(11) NOT NULL default '0',
  `achtransactionid` int(11) NOT NULL default '0',
  `customerbankid` int(11) NOT NULL default '0',
  `cardused` varchar(50) default NULL,
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `successful` int(11) NOT NULL default '0',
  `message` varchar(255) default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `leaseid` (`leaseid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `arinvoicepaymentdetailid` (`arinvoicepaymentdetailid`),
  KEY `cctransactionid` (`cctransactionid`),
  KEY `paymentplanid` (`paymentplanid`),
  KEY `successful` (`successful`),
  KEY `autobilldate` (`autobilldate`),
  KEY `achtransactionid` (`achtransactionid`),
  KEY `customerbankid` (`customerbankid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `autobilllog`
--

LOCK TABLES `autobilllog` WRITE;
/*!40000 ALTER TABLE `autobilllog` DISABLE KEYS */;
/*!40000 ALTER TABLE `autobilllog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `b2b_access_table`
--

DROP TABLE IF EXISTS `b2b_access_table`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `b2b_access_table` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(255) default NULL,
  `whocan` int(11) NOT NULL default '0',
  `pagelist` text,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `b2b_access_table`
--

LOCK TABLES `b2b_access_table` WRITE;
/*!40000 ALTER TABLE `b2b_access_table` DISABLE KEYS */;
INSERT INTO `b2b_access_table` VALUES (1,'System Adminstrator',1,'*'),(2,'No Access',1,''),(3,'Order Entry - No Item History',1,'indexcust.php,arordadd.php,arordupd.php,arserviceordadd.php,arserviceordupd.php,shipped_detail.php,arordconfirmation.php,arserviceordtickfpdf.php,client_customer.php,arinvoicereppay.php,pay_history'),(4,'Payables',1,'indexcust.php,arinvoicesum.php,arinvoicereppay.php,arinvoiceviewfpdf.php,client_customer.php,pay_history'),(5,'Order Entry - All',1,'indexcust.php,arordadd.php,arordupd.php,arserviceordadd.php,arserviceordupd.php,shipped_detail.php,arordconfirmation.php,arserviceordtickfpdf.php,arordercustitemlst.php,client_customer.php,arinvoicereppay.php,pay_history'),(6,'All Except Users',1,'indexcust.php,arordadd.php,arordupd.php,arserviceordadd.php,arserviceordupd.php,shipped_detail.php,arordconfirmation.php,arserviceordtickfpdf.php,arordercustitemlst.php,arinvoicesum.php,arinvoicereppay.php,arinvoiceviewfpdf.php,arinvoicepay.php,client_customer.php,pay_history'),(7,'Rep',2,'indexvend.php,b2b_commissionreport.php,apvendorbillsrpt.php,rep_orders.php,av_airports_resrpt.php,av_edit_reservation.php,editvendor.php,client_customer.php,pay_history'),(8,'System Administrator',2,'*'),(9,'Payment History',1,'arinvoicereppay.php,client_customer.php,client_customer.php'),(10,'Order Entry - No Item / Payment History',1,'indexcust.php,arordadd.php,arordupd.php,arserviceordadd.php,arserviceordupd.php,shipped_detail.php,arordconfirmation.php,arserviceordtickfpdf.php,client_customer.php,arinvoicereppay.php');
/*!40000 ALTER TABLE `b2b_access_table` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `b2b_user_access_table`
--

DROP TABLE IF EXISTS `b2b_user_access_table`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `b2b_user_access_table` (
  `id` int(11) NOT NULL auto_increment,
  `b2b_access_tableid` int(11) NOT NULL default '0',
  `b2buserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `b2b_access_tableid` (`b2b_access_tableid`),
  KEY `b2buserid` (`b2buserid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `b2b_user_access_table`
--

LOCK TABLES `b2b_user_access_table` WRITE;
/*!40000 ALTER TABLE `b2b_user_access_table` DISABLE KEYS */;
/*!40000 ALTER TABLE `b2b_user_access_table` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `b2bcart`
--

DROP TABLE IF EXISTS `b2bcart`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `b2bcart` (
  `id` int(11) NOT NULL auto_increment,
  `b2buserid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `itemid` int(11) NOT NULL default '0',
  `qty` decimal(18,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`),
  KEY `b2buserid` (`b2buserid`),
  KEY `customerid` (`customerid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `itemid` (`itemid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `b2bcart`
--

LOCK TABLES `b2bcart` WRITE;
/*!40000 ALTER TABLE `b2bcart` DISABLE KEYS */;
/*!40000 ALTER TABLE `b2bcart` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `b2bcompany`
--

DROP TABLE IF EXISTS `b2bcompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `b2bcompany` (
  `companyid` int(11) NOT NULL,
  `customheaderhtml` text,
  `remoteregistration_key` varchar(32) default NULL,
  `remoteregistration_value` varchar(32) default NULL,
  `remoteregistration_usertype` int(11) default '1',
  `remoteregistration_useraccess` int(11) default '6',
  `remoteregistration_customfields` tinytext,
  `remoteregistration_emailsubject` tinytext,
  `remoteregistration_emailbody` text,
  `remoteregistration_failmessage` text,
  PRIMARY KEY  (`companyid`),
  UNIQUE KEY `remoteregistration_key_UNIQUE` (`remoteregistration_key`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Company options for new b2b features - PRIMARY KEY companyid';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `b2bcompany`
--

LOCK TABLES `b2bcompany` WRITE;
/*!40000 ALTER TABLE `b2bcompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `b2bcompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `b2buser`
--

DROP TABLE IF EXISTS `b2buser`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `b2buser` (
  `id` int(11) NOT NULL auto_increment,
  `firstname` varchar(100) default NULL,
  `lastname` varchar(100) default NULL,
  `loginname` varchar(100) NOT NULL default '',
  `password` varchar(255) NOT NULL default '',
  `usertype` int(11) NOT NULL default '0',
  `referenceid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `email` varchar(255) default NULL,
  `resetkey` varchar(255) NOT NULL default '',
  `temppw` int(11) NOT NULL default '0',
  `tempfrontendpw` varchar(64) NOT NULL default '',
  `wpemailconfirmed` varchar(255) NOT NULL default '',
  `wpemailunconfirmed` varchar(255) NOT NULL default '',
  `wpemailhashverifykey` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `usertype` (`usertype`),
  KEY `cancel` (`cancel`),
  KEY `referenceid` (`referenceid`),
  KEY `password` (`password`),
  KEY `loginname` (`loginname`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `b2buser`
--

LOCK TABLES `b2buser` WRITE;
/*!40000 ALTER TABLE `b2buser` DISABLE KEYS */;
/*!40000 ALTER TABLE `b2buser` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bankaccount`
--

DROP TABLE IF EXISTS `bankaccount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bankaccount` (
  `id` int(11) NOT NULL auto_increment,
  `premployeeid` int(11) NOT NULL default '0',
  `accounttype` int(2) NOT NULL default '0',
  `routing` varchar(9) NOT NULL default '',
  `accountnumber` varchar(17) NOT NULL default '',
  `prenote_ok` int(2) NOT NULL default '0',
  `prenote_achfiledetailid` int(11) NOT NULL default '0',
  `contactname` varchar(100) NOT NULL default '',
  `bankname` varchar(100) NOT NULL default '',
  `address` varchar(100) NOT NULL default '',
  `city` varchar(100) NOT NULL default '',
  `state` varchar(100) NOT NULL default '',
  `zip` varchar(15) NOT NULL default '',
  `phone` varchar(20) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `prtype` int(5) NOT NULL default '0',
  `recordid` int(11) NOT NULL default '0',
  `show_employeename` int(5) NOT NULL default '0',
  `show_ss` int(5) NOT NULL default '0',
  `show_dates` int(5) NOT NULL default '0',
  `show_employer` int(5) NOT NULL default '0',
  `include_contribution` int(5) NOT NULL default '0',
  `summary_deposit` int(5) NOT NULL default '0',
  `show_other` varchar(255) default NULL,
  `dd_or_check` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `canceluserid` (`canceluserid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `entryuserid` (`entryuserid`),
  KEY `lastchangeuserid` (`lastchangeuserid`),
  KEY `prenote_achfiledetailid` (`prenote_achfiledetailid`),
  KEY `premployeeid` (`premployeeid`),
  KEY `prtype` (`prtype`),
  KEY `recordid` (`recordid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bankaccount`
--

LOCK TABLES `bankaccount` WRITE;
/*!40000 ALTER TABLE `bankaccount` DISABLE KEYS */;
/*!40000 ALTER TABLE `bankaccount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bankdeposit`
--

DROP TABLE IF EXISTS `bankdeposit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bankdeposit` (
  `id` int(11) NOT NULL auto_increment,
  `cashtotal` decimal(19,4) NOT NULL default '0.0000',
  `checktotal` decimal(19,4) NOT NULL default '0.0000',
  `othertotal` decimal(19,4) NOT NULL default '0.0000',
  `cashout` decimal(19,4) NOT NULL default '0.0000',
  `depositdate` date default NULL,
  `checkaccountid` int(11) NOT NULL default '0',
  `onbankstatement` int(2) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `bankstatement_enddate` date default NULL,
  `voucherid` int(11) NOT NULL default '0',
  `depositdescription` varchar(255) NOT NULL default '',
  `currency` varchar(10) NOT NULL default 'USD',
  `ccdeposit` tinyint(4) NOT NULL default '0',
  `ardailycloseid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `depositdate` (`depositdate`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `checkaccountid` (`checkaccountid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bankdeposit`
--

LOCK TABLES `bankdeposit` WRITE;
/*!40000 ALTER TABLE `bankdeposit` DISABLE KEYS */;
/*!40000 ALTER TABLE `bankdeposit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bankdepositdetail`
--

DROP TABLE IF EXISTS `bankdepositdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bankdepositdetail` (
  `id` int(11) NOT NULL auto_increment,
  `bankdepositid` int(11) NOT NULL default '0',
  `referenceid` int(11) NOT NULL default '0',
  `wherefrom` int(5) NOT NULL default '0',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `deposit_type` int(5) NOT NULL default '0',
  `cancel` int(3) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `deposit_type` (`deposit_type`),
  KEY `referenceid` (`referenceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bankdepositdetail`
--

LOCK TABLES `bankdepositdetail` WRITE;
/*!40000 ALTER TABLE `bankdepositdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `bankdepositdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bankimport`
--

DROP TABLE IF EXISTS `bankimport`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bankimport` (
  `id` int(11) NOT NULL auto_increment,
  `checkaccountid` int(11) default '0',
  `currency` varchar(10) NOT NULL default '',
  `bankid` varchar(10) NOT NULL default '',
  `acctid` varchar(25) NOT NULL default '',
  `startdate` date NOT NULL default '0000-00-00',
  `enddate` date NOT NULL default '0000-00-00',
  `balanceamount` decimal(19,6) NOT NULL default '0.000000',
  `balancedate` date NOT NULL default '0000-00-00',
  `statementdate` date NOT NULL default '0000-00-00',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `checkaccountid` (`checkaccountid`),
  KEY `bankid` (`bankid`),
  KEY `acctid` (`acctid`),
  KEY `balanceamount` (`balanceamount`),
  KEY `balancedate` (`balancedate`),
  KEY `startdate` (`startdate`),
  KEY `enddate` (`enddate`),
  KEY `companyid` (`companyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bankimport`
--

LOCK TABLES `bankimport` WRITE;
/*!40000 ALTER TABLE `bankimport` DISABLE KEYS */;
/*!40000 ALTER TABLE `bankimport` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bankimportdetail`
--

DROP TABLE IF EXISTS `bankimportdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bankimportdetail` (
  `id` int(11) NOT NULL auto_increment,
  `bankimportid` int(11) NOT NULL default '0',
  `bankid` varchar(10) NOT NULL default '',
  `acctid` varchar(25) NOT NULL default '',
  `fitid` varchar(50) NOT NULL default '',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `transtype` varchar(20) NOT NULL default '',
  `checknum` varchar(20) NOT NULL default '',
  `description` varchar(100) NOT NULL default '',
  `memo` varchar(255) NOT NULL default '',
  `dateposted` date NOT NULL default '0000-00-00',
  `tablename` varchar(100) NOT NULL default '',
  `tableid` int(11) NOT NULL default '0',
  `notes` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `bankimportid` (`bankimportid`),
  KEY `bankid` (`bankid`),
  KEY `acctid` (`acctid`),
  KEY `fitid` (`fitid`),
  KEY `dateposted` (`dateposted`),
  KEY `transtype` (`transtype`),
  KEY `relatedtable` (`tablename`,`tableid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bankimportdetail`
--

LOCK TABLES `bankimportdetail` WRITE;
/*!40000 ALTER TABLE `bankimportdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `bankimportdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bankrec`
--

DROP TABLE IF EXISTS `bankrec`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bankrec` (
  `id` int(11) NOT NULL auto_increment,
  `bankendbal` decimal(19,6) NOT NULL default '0.000000',
  `enddate` date default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `bankaccountid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `createuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `servicecharges` decimal(19,6) NOT NULL default '0.000000',
  `servicechargesvoucherid` int(11) NOT NULL default '0',
  `interestearned` decimal(19,6) NOT NULL default '0.000000',
  `interestearnedvoucherid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `bankaccountid` (`bankaccountid`),
  KEY `enddate` (`enddate`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bankrec`
--

LOCK TABLES `bankrec` WRITE;
/*!40000 ALTER TABLE `bankrec` DISABLE KEYS */;
/*!40000 ALTER TABLE `bankrec` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bankstmtgltrans`
--

DROP TABLE IF EXISTS `bankstmtgltrans`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bankstmtgltrans` (
  `id` int(11) NOT NULL auto_increment,
  `gltransactionid` int(11) default '0',
  `bankstmtdate` date default '0000-00-00',
  `checkaccountid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gltransactionid` (`gltransactionid`),
  KEY `bankstmtdate` (`bankstmtdate`),
  KEY `bcg` (`bankstmtdate`,`checkaccountid`,`gltransactionid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bankstmtgltrans`
--

LOCK TABLES `bankstmtgltrans` WRITE;
/*!40000 ALTER TABLE `bankstmtgltrans` DISABLE KEYS */;
/*!40000 ALTER TABLE `bankstmtgltrans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `barcodelabel`
--

DROP TABLE IF EXISTS `barcodelabel`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `barcodelabel` (
  `id` int(11) NOT NULL auto_increment,
  `labelname` varchar(100) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `labelsize_width` int(11) NOT NULL default '0',
  `labelsize_height` int(11) NOT NULL default '0',
  `barcode_left` int(11) NOT NULL default '0',
  `barcode_top` int(11) NOT NULL default '0',
  `itemdescription_yesno` int(5) NOT NULL default '0',
  `itemdescription_left` int(11) NOT NULL default '0',
  `itemdescription_top` int(11) NOT NULL default '0',
  `fixedtext` varchar(100) NOT NULL default '',
  `fixedtext_left` int(11) NOT NULL default '0',
  `fixedtext_top` int(11) NOT NULL default '0',
  `tablename` varchar(50) NOT NULL default 'item',
  `fieldname` varchar(100) NOT NULL default 'itemcode',
  `textsize` int(5) NOT NULL default '8',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `itemcode_yesno` int(5) NOT NULL default '0',
  `itemcode_left` int(11) NOT NULL default '0',
  `itemcode_top` int(11) NOT NULL default '0',
  `barcodetype` varchar(10) NOT NULL default ' ',
  `oneperitem` int(5) NOT NULL default '0',
  `shelf_yesno` int(5) NOT NULL default '0',
  `shelf_top` int(11) NOT NULL default '0',
  `shelf_left` int(11) NOT NULL default '0',
  `ordernumber_yesno` tinyint(4) NOT NULL default '0',
  `ordernumber_top` int(11) NOT NULL default '0',
  `ordernumber_left` int(11) NOT NULL default '0',
  `quantity_yesno` tinyint(4) NOT NULL default '0',
  `quantity_top` int(11) NOT NULL default '0',
  `quantity_left` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `cancel` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `barcodelabel`
--

LOCK TABLES `barcodelabel` WRITE;
/*!40000 ALTER TABLE `barcodelabel` DISABLE KEYS */;
/*!40000 ALTER TABLE `barcodelabel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `barcodelabel_cf`
--

DROP TABLE IF EXISTS `barcodelabel_cf`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `barcodelabel_cf` (
  `id` int(11) NOT NULL auto_increment,
  `barcodelabelid` int(11) NOT NULL default '0',
  `flexfieldid` int(11) NOT NULL default '0',
  `flexfield_yesno` int(5) NOT NULL default '0',
  `flexfield_left` int(11) NOT NULL default '0',
  `flexfield_top` int(11) NOT NULL default '0',
  `flexfielddescription_yesno` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `barcodelabelid` (`barcodelabelid`),
  KEY `flexfieldid` (`flexfieldid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `barcodelabel_cf`
--

LOCK TABLES `barcodelabel_cf` WRITE;
/*!40000 ALTER TABLE `barcodelabel_cf` DISABLE KEYS */;
/*!40000 ALTER TABLE `barcodelabel_cf` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `barcodelabel_price`
--

DROP TABLE IF EXISTS `barcodelabel_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `barcodelabel_price` (
  `id` int(11) NOT NULL auto_increment,
  `barcodelabelid` int(11) NOT NULL default '0',
  `pricelevel` int(11) NOT NULL default '0',
  `price_yesno` int(5) NOT NULL default '0',
  `price_left` int(11) NOT NULL default '0',
  `price_top` int(11) NOT NULL default '0',
  `priceleveldescription_yesno` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `barcodelabelid` (`barcodelabelid`),
  KEY `pricelevel` (`pricelevel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `barcodelabel_price`
--

LOCK TABLES `barcodelabel_price` WRITE;
/*!40000 ALTER TABLE `barcodelabel_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `barcodelabel_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `batchimport`
--

DROP TABLE IF EXISTS `batchimport`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `batchimport` (
  `id` int(11) NOT NULL auto_increment,
  `batchtype` varchar(24) NOT NULL default '',
  `filename` varchar(100) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(4) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `batchtype` (`batchtype`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `entrydate` (`entrydate`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `batchimport`
--

LOCK TABLES `batchimport` WRITE;
/*!40000 ALTER TABLE `batchimport` DISABLE KEYS */;
/*!40000 ALTER TABLE `batchimport` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `batchimportdetail`
--

DROP TABLE IF EXISTS `batchimportdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `batchimportdetail` (
  `id` int(11) NOT NULL auto_increment,
  `batchimportid` int(11) NOT NULL default '0',
  `tablename` varchar(100) NOT NULL default '',
  `tableid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `line` int(11) NOT NULL default '0',
  `message` varchar(255) NOT NULL default '',
  `error` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `batchimportid` (`batchimportid`),
  KEY `tablename` (`tablename`),
  KEY `tableid` (`tableid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `error` (`error`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `batchimportdetail`
--

LOCK TABLES `batchimportdetail` WRITE;
/*!40000 ALTER TABLE `batchimportdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `batchimportdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `binshelflog`
--

DROP TABLE IF EXISTS `binshelflog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `binshelflog` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `bin_shelf` varchar(50) NOT NULL default '',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`),
  KEY `inventorylocationid` (`inventorylocationid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `binshelflog`
--

LOCK TABLES `binshelflog` WRITE;
/*!40000 ALTER TABLE `binshelflog` DISABLE KEYS */;
/*!40000 ALTER TABLE `binshelflog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `building`
--

DROP TABLE IF EXISTS `building`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `building` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(20) NOT NULL default '',
  `name` varchar(100) NOT NULL default '',
  `address1` varchar(100) NOT NULL default '',
  `address2` varchar(100) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  `state` varchar(20) NOT NULL default '',
  `zip` varchar(15) NOT NULL default '',
  `description` text NOT NULL,
  `managementfee` decimal(6,2) NOT NULL default '0.00',
  `latefee` decimal(19,6) NOT NULL default '0.000000',
  `transferfee` decimal(19,6) NOT NULL default '0.000000',
  `petrent` decimal(19,6) NOT NULL default '0.000000',
  `utilitiescharge` varchar(5) NOT NULL default '',
  `electricbasis` decimal(19,6) NOT NULL default '0.000000',
  `waterbasis` decimal(19,6) NOT NULL default '0.000000',
  `gasbasis` decimal(19,6) NOT NULL default '0.000000',
  `buildingtypeid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `areaid` int(11) NOT NULL default '0',
  `firstnotice` int(11) NOT NULL default '0',
  `secondnotice` int(11) NOT NULL default '0',
  `finalnotice` int(11) NOT NULL default '0',
  `asleasetemplateid` varchar(45) NOT NULL default '',
  `asleasetemplateid2` varchar(45) NOT NULL default '',
  `asleasetemplateid4` varchar(45) NOT NULL default '',
  `asleasedocname` varchar(100) NOT NULL default '',
  `docexpirationdays` int(11) NOT NULL default '0',
  `noaddressupdate` int(11) NOT NULL default '0',
  `asguarantordocname` varchar(100) NOT NULL default '',
  `asguarantortemplateid` varchar(45) NOT NULL default '',
  `aspetdocname` varchar(100) NOT NULL default '',
  `aspettemplateid` varchar(45) NOT NULL default '',
  `asterminationdocname` varchar(100) NOT NULL default '',
  `asterminationtemplateid` varchar(45) NOT NULL default '',
  `asterminationtemplateid2` varchar(45) NOT NULL default '',
  `firstinvoicemonths` int(11) NOT NULL default '0',
  `asamendmenttemplateid` varchar(45) NOT NULL default '',
  `asamendmentdocname` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `building`
--

LOCK TABLES `building` WRITE;
/*!40000 ALTER TABLE `building` DISABLE KEYS */;
/*!40000 ALTER TABLE `building` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `buildingagent`
--

DROP TABLE IF EXISTS `buildingagent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `buildingagent` (
  `id` int(11) NOT NULL auto_increment,
  `buildingid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `newleaseflat` decimal(19,6) NOT NULL default '0.000000',
  `newleasepercent` decimal(7,2) NOT NULL default '0.00',
  `renewleaseflat` decimal(19,6) NOT NULL default '0.000000',
  `renewleasepercent` decimal(7,2) NOT NULL default '0.00',
  `30daypercent` decimal(7,2) NOT NULL default '0.00',
  `60daypercent` decimal(7,2) NOT NULL default '0.00',
  `90daypercent` decimal(7,2) NOT NULL default '0.00',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `buildingid` (`buildingid`),
  KEY `userid` (`userid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `buildingagent`
--

LOCK TABLES `buildingagent` WRITE;
/*!40000 ALTER TABLE `buildingagent` DISABLE KEYS */;
/*!40000 ALTER TABLE `buildingagent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `buildingownership`
--

DROP TABLE IF EXISTS `buildingownership`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `buildingownership` (
  `id` int(11) NOT NULL auto_increment,
  `buildingid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `percentownership` decimal(12,2) NOT NULL default '0.00',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `buildingownership`
--

LOCK TABLES `buildingownership` WRITE;
/*!40000 ALTER TABLE `buildingownership` DISABLE KEYS */;
/*!40000 ALTER TABLE `buildingownership` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `buildingtype`
--

DROP TABLE IF EXISTS `buildingtype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `buildingtype` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `companyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `buildingtype`
--

LOCK TABLES `buildingtype` WRITE;
/*!40000 ALTER TABLE `buildingtype` DISABLE KEYS */;
/*!40000 ALTER TABLE `buildingtype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `buildordermaster`
--

DROP TABLE IF EXISTS `buildordermaster`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `buildordermaster` (
  `buildordermasterid` int(11) NOT NULL default '0',
  `final` int(2) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `orderqtyinitial` decimal(18,6) NOT NULL default '0.000000',
  `orderqtyfinal` decimal(18,6) NOT NULL default '0.000000',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `status` int(5) NOT NULL default '0',
  `po_created` int(5) NOT NULL default '0',
  `note` varchar(255) default NULL,
  `autobuild` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`buildordermasterid`),
  KEY `note` (`note`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `buildordermaster`
--

LOCK TABLES `buildordermaster` WRITE;
/*!40000 ALTER TABLE `buildordermaster` DISABLE KEYS */;
/*!40000 ALTER TABLE `buildordermaster` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `buildordermasterseq`
--

DROP TABLE IF EXISTS `buildordermasterseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `buildordermasterseq` (
  `id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `buildordermasterseq`
--

LOCK TABLES `buildordermasterseq` WRITE;
/*!40000 ALTER TABLE `buildordermasterseq` DISABLE KEYS */;
INSERT INTO `buildordermasterseq` VALUES (9);
/*!40000 ALTER TABLE `buildordermasterseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `buildordersub`
--

DROP TABLE IF EXISTS `buildordersub`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `buildordersub` (
  `buildordersubid` int(11) NOT NULL default '0',
  `buildordermasterid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `qtycommitted` decimal(18,6) NOT NULL default '0.000000',
  `qtyused` decimal(18,6) NOT NULL default '0.000000',
  `qtymaster` decimal(18,6) NOT NULL default '-1.000000',
  `final` int(2) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `cancel` int(2) NOT NULL default '0',
  `vendoritemid` int(11) NOT NULL default '0',
  `mfg` varchar(50) default NULL,
  `vordernumber` varchar(30) default NULL,
  `reference_notes` text,
  PRIMARY KEY  (`buildordersubid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `buildordersub`
--

LOCK TABLES `buildordersub` WRITE;
/*!40000 ALTER TABLE `buildordersub` DISABLE KEYS */;
/*!40000 ALTER TABLE `buildordersub` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `buildordersubdetail`
--

DROP TABLE IF EXISTS `buildordersubdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `buildordersubdetail` (
  `id` int(11) NOT NULL auto_increment,
  `buildordersubid` int(11) NOT NULL default '0',
  `vendoritemid` int(11) NOT NULL default '0',
  `mfg` varchar(50) default NULL,
  `vordernumber` varchar(30) default NULL,
  `poqty` decimal(18,6) NOT NULL default '0.000000',
  `invpodetailid` int(11) NOT NULL default '0',
  `qty_commit` decimal(18,6) NOT NULL default '0.000000',
  `qtyused` decimal(18,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`),
  KEY `vendoritemid` (`vendoritemid`),
  KEY `invpodetailid` (`invpodetailid`),
  KEY `buildordersubid` (`buildordersubid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `buildordersubdetail`
--

LOCK TABLES `buildordersubdetail` WRITE;
/*!40000 ALTER TABLE `buildordersubdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `buildordersubdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `buildordersubseq`
--

DROP TABLE IF EXISTS `buildordersubseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `buildordersubseq` (
  `id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `buildordersubseq`
--

LOCK TABLES `buildordersubseq` WRITE;
/*!40000 ALTER TABLE `buildordersubseq` DISABLE KEYS */;
INSERT INTO `buildordersubseq` VALUES (0);
/*!40000 ALTER TABLE `buildordersubseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calcqty`
--

DROP TABLE IF EXISTS `calcqty`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calcqty` (
  `id_calcqty` int(11) NOT NULL default '0',
  `description` varchar(100) NOT NULL default '',
  `formula` varchar(255) NOT NULL default '',
  `id_calctype` int(3) NOT NULL default '0',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_calcqty`),
  UNIQUE KEY `id_calcqty` (`id_calcqty`),
  KEY `description` (`description`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calcqty`
--

LOCK TABLES `calcqty` WRITE;
/*!40000 ALTER TABLE `calcqty` DISABLE KEYS */;
/*!40000 ALTER TABLE `calcqty` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calcqtyseq`
--

DROP TABLE IF EXISTS `calcqtyseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calcqtyseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calcqtyseq`
--

LOCK TABLES `calcqtyseq` WRITE;
/*!40000 ALTER TABLE `calcqtyseq` DISABLE KEYS */;
INSERT INTO `calcqtyseq` VALUES (0);
/*!40000 ALTER TABLE `calcqtyseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calendar`
--

DROP TABLE IF EXISTS `calendar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calendar` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `notes` text NOT NULL,
  `eventdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `reminder` int(11) NOT NULL default '0',
  `tablename` varchar(100) NOT NULL default '',
  `tableid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `eventdate` (`eventdate`),
  KEY `tablename` (`tablename`),
  KEY `tableid` (`tableid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calendar`
--

LOCK TABLES `calendar` WRITE;
/*!40000 ALTER TABLE `calendar` DISABLE KEYS */;
/*!40000 ALTER TABLE `calendar` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calendarlistener`
--

DROP TABLE IF EXISTS `calendarlistener`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calendarlistener` (
  `id` int(11) NOT NULL auto_increment,
  `calendarid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `nprightsgroupid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `calendarid` (`calendarid`),
  KEY `userid` (`userid`),
  KEY `nprightsgroupid` (`nprightsgroupid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calendarlistener`
--

LOCK TABLES `calendarlistener` WRITE;
/*!40000 ALTER TABLE `calendarlistener` DISABLE KEYS */;
/*!40000 ALTER TABLE `calendarlistener` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `camallocation`
--

DROP TABLE IF EXISTS `camallocation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `camallocation` (
  `id` int(11) NOT NULL auto_increment,
  `buildingid` int(11) NOT NULL default '0',
  `description` varchar(100) NOT NULL default '',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `glaccountid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `buildingid` (`buildingid`),
  KEY `glaccountid` (`glaccountid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `camallocation`
--

LOCK TABLES `camallocation` WRITE;
/*!40000 ALTER TABLE `camallocation` DISABLE KEYS */;
/*!40000 ALTER TABLE `camallocation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `carrier`
--

DROP TABLE IF EXISTS `carrier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `carrier` (
  `id` int(11) NOT NULL auto_increment,
  `customernumber` varchar(20) default NULL,
  `trackingurlbase` varchar(150) default NULL,
  `trackingurlvarname` varchar(30) default NULL,
  `description` varchar(100) NOT NULL default '',
  `vendorid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `carrier_upcharge` decimal(5,2) NOT NULL default '0.00',
  `carrier_upcharge_flat` decimal(19,6) NOT NULL default '0.000000',
  `sitelogin` varchar(40) NOT NULL default '',
  `sitepassword` varchar(50) NOT NULL default '',
  `accesskey` varchar(25) NOT NULL default '',
  `usenegotiatedrates` tinyint(4) NOT NULL default '0',
  `maxboxweight` decimal(6,2) NOT NULL default '0.00',
  `shiplength` decimal(7,2) NOT NULL default '0.00',
  `shipwidth` decimal(7,2) NOT NULL default '0.00',
  `shipheight` decimal(7,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`),
  KEY `vendorid` (`vendorid`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `carrier`
--

LOCK TABLES `carrier` WRITE;
/*!40000 ALTER TABLE `carrier` DISABLE KEYS */;
INSERT INTO `carrier` VALUES (1,NULL,NULL,NULL,'UPS',1,0,'0.00','0.000000','','','',0,'0.00','0.00','0.00','0.00'),(2,NULL,NULL,NULL,'UPS',2,0,'0.00','0.000000','','','',0,'0.00','0.00','0.00','0.00');
/*!40000 ALTER TABLE `carrier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `carrierservice`
--

DROP TABLE IF EXISTS `carrierservice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `carrierservice` (
  `id` int(11) NOT NULL auto_increment,
  `carrierid` int(11) NOT NULL default '0',
  `description` varchar(50) NOT NULL default '',
  `abbreviation` varchar(50) default NULL,
  `code` varchar(10) NOT NULL default '',
  `saturdaydelivery` varchar(1) NOT NULL default 'N',
  `methodmarkupflat` decimal(12,4) NOT NULL default '0.0000',
  `allowonpointofsaleorders` tinyint(1) NOT NULL default '1',
  `sortorder` int(11) default NULL,
  `not_on_b2b` int(5) NOT NULL default '0',
  `onquote` int(5) NOT NULL default '0',
  `box1_charge` decimal(19,5) NOT NULL default '0.00000',
  `box_addl` decimal(19,5) NOT NULL default '0.00000',
  `require_shippernum` int(5) NOT NULL default '0',
  `showvalue` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `carrierid` (`carrierid`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `carrierservice`
--

LOCK TABLES `carrierservice` WRITE;
/*!40000 ALTER TABLE `carrierservice` DISABLE KEYS */;
INSERT INTO `carrierservice` VALUES (1,1,'GROUND','GND','','N','0.0000',1,NULL,0,0,'0.00000','0.00000',0,0),(2,2,'GROUND','GND','','N','0.0000',1,NULL,0,0,'0.00000','0.00000',0,0);
/*!40000 ALTER TABLE `carrierservice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cashcount`
--

DROP TABLE IF EXISTS `cashcount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cashcount` (
  `id` int(11) NOT NULL auto_increment,
  `voucherid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `denomination` decimal(19,2) NOT NULL default '0.00',
  `qty` int(11) NOT NULL default '0',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `datereceived` date default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `voucherid` (`voucherid`),
  KEY `customerid` (`customerid`),
  KEY `datereceived` (`datereceived`),
  KEY `companyid` (`companyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cashcount`
--

LOCK TABLES `cashcount` WRITE;
/*!40000 ALTER TABLE `cashcount` DISABLE KEYS */;
/*!40000 ALTER TABLE `cashcount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cashpayment`
--

DROP TABLE IF EXISTS `cashpayment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cashpayment` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `note` varchar(255) default NULL,
  `voucherid` int(11) NOT NULL default '0',
  `taxable_amount` decimal(19,4) NOT NULL default '0.0000',
  `exempt_amount` decimal(19,4) NOT NULL default '0.0000',
  `cost_amount` decimal(19,4) NOT NULL default '0.0000',
  `glaccountsalesid` int(11) NOT NULL default '0',
  `glaccountcostid` int(11) NOT NULL default '0',
  `exemptreasonid` int(11) NOT NULL default '0',
  `payment_type` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `bankdepositid` int(11) NOT NULL default '0',
  `sales_categoriesid` int(11) NOT NULL default '0',
  `bankstatement_enddate` date default NULL,
  `checkacctid` int(11) NOT NULL default '0',
  `checknumber` varchar(30) NOT NULL default '',
  `currency` varchar(10) NOT NULL default 'USD',
  `currate` decimal(22,10) NOT NULL default '1.0000000000',
  `bankfee_amount` decimal(19,4) NOT NULL default '0.0000',
  `bankfee_glid` int(11) NOT NULL default '0',
  `rnum` varchar(30) NOT NULL default '',
  `inventorylocationid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `jobid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `voucherid` (`voucherid`),
  KEY `cancel` (`cancel`),
  KEY `entrydate` (`entrydate`),
  KEY `payment_type` (`payment_type`),
  KEY `sales_categoriesid` (`sales_categoriesid`),
  KEY `rnum` (`rnum`),
  KEY `inventorylocationid` (`inventorylocationid`),
  KEY `gltr_costcodeid` (`costcodeid`),
  KEY `glcategoryid` (`glcategoryid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cashpayment`
--

LOCK TABLES `cashpayment` WRITE;
/*!40000 ALTER TABLE `cashpayment` DISABLE KEYS */;
/*!40000 ALTER TABLE `cashpayment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cashpaymenttax`
--

DROP TABLE IF EXISTS `cashpaymenttax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cashpaymenttax` (
  `id` int(11) NOT NULL auto_increment,
  `cashpaymentid` int(11) NOT NULL default '0',
  `taxid` int(11) NOT NULL default '0',
  `tax` decimal(19,4) NOT NULL default '0.0000',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `taxgroupid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `taxid` (`taxid`),
  KEY `cashpaymentid` (`cashpaymentid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cashpaymenttax`
--

LOCK TABLES `cashpaymenttax` WRITE;
/*!40000 ALTER TABLE `cashpaymenttax` DISABLE KEYS */;
/*!40000 ALTER TABLE `cashpaymenttax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cashtracker`
--

DROP TABLE IF EXISTS `cashtracker`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cashtracker` (
  `id` int(11) NOT NULL auto_increment,
  `tablename` varchar(200) NOT NULL default '',
  `referenceid` int(11) NOT NULL default '0',
  `wherefrom` int(5) NOT NULL default '0',
  `userid_in` int(11) NOT NULL default '0',
  `userid_out` int(11) NOT NULL default '0',
  `date_in` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_out` datetime NOT NULL default '0000-00-00 00:00:00',
  `status` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `amount` decimal(19,5) NOT NULL default '0.00000',
  `bankdepositid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `userid_in` (`userid_in`),
  KEY `userid_out` (`userid_out`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cashtracker`
--

LOCK TABLES `cashtracker` WRITE;
/*!40000 ALTER TABLE `cashtracker` DISABLE KEYS */;
/*!40000 ALTER TABLE `cashtracker` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccaccount`
--

DROP TABLE IF EXISTS `ccaccount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccaccount` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `ccprocessorid` int(11) NOT NULL default '0',
  `checkacctid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccaccount`
--

LOCK TABLES `ccaccount` WRITE;
/*!40000 ALTER TABLE `ccaccount` DISABLE KEYS */;
INSERT INTO `ccaccount` VALUES (1,'Manual',4,0,1,'2006-01-17 16:45:08',1,'2006-01-17 21:45:08',1,0,'0000-00-00 00:00:00',0);
/*!40000 ALTER TABLE `ccaccount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccaccountoption`
--

DROP TABLE IF EXISTS `ccaccountoption`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccaccountoption` (
  `id` int(11) NOT NULL auto_increment,
  `ccprocessorid` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `fieldname` varchar(50) NOT NULL default '',
  `ccvalues` text NOT NULL,
  `ccdefault` varchar(255) NOT NULL default '',
  `cchold` int(2) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=47 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccaccountoption`
--

LOCK TABLES `ccaccountoption` WRITE;
/*!40000 ALTER TABLE `ccaccountoption` DISABLE KEYS */;
INSERT INTO `ccaccountoption` VALUES (1,1,'Login ID','The login ID for your Authorize.net account','x_login','','Test',0),(2,1,'Transaction Key','Transaction key for your account (for security)','x_transaction_key','','Test',1),(3,1,'Check MD5 Hash','Should the MD5 hash be checked?','x_check_hash','TRUE=>Yes~FALSE=>No','FALSE',1),(4,1,'Hash Value','Hash value for the MD5 hash check','x_hash_value','','Test',1),(5,1,'Transaction Mode','Mode used when processing requests','x_test_request','TRUE=>Testing~FALSE=>Production','TRUE',0),(6,1,'Order Transaction Type','Transaction type to use for orders','type','S=>Authorization & Immediate Capture','S',0),(7,1,'Email Customer','Should Authorize.net send an email to the customer?','x_email_customer','TRUE=>Yes~FALSE=>No','FALSE',1),(8,1,'Deliminate Data','Deliminated response from gateway','x_delim_data','TRUE=>True','TRUE',0),(9,1,'Delimination Character','Character used to separate fields','x_delim_char',',=>,',',',0),(10,1,'Encapsulation Character','Character used to encapsulate fields','x_encap_char','|=>|','|',0),(11,1,'Transaction Method','Method used to process requests','x_method','CC=>Credit Card','CC',0),(12,1,'Program Version','','x_version','3.1=>3.1','3.1',0),(13,1,'Relay Response','','x_relay_response','FALSE=>False','FALSE',0),(14,3,'Merchant ID','ID assigned to you by PSiGate','MerchantID','','Test',0),(15,3,'Transaction Mode','Mode to use when processing requests','Result','1=>Always Good~2=>Always Duplicate~3=>Always Decline~0=>Production','1',0),(16,3,'Order Transaction Type','Transaction type to use for orders','type','S=>Sale','S',0),(17,5,'Username','PayPal API Username','username','','',0),(18,5,'Password','PayPal API Password','password','','',0),(19,5,'Certificate File Path','Path to PayPal API certificate in PEM format','certificateFile','','',0),(20,5,'Subject','Optional name of third-party who authorizes transactions','subject','','',0),(21,5,'Environment','PayPal environment to run transactions','environment','live=>Live~sandbox=>Sandbox~beta-sandbox=>Beta-Sandbox','sandbox',0),(22,1,'Shopping Cart Account','Do you want to tie this account with the<br>Authorize.net account set up in the shopping cart?','x_account_tie','sc_authorizenet=>Yes~sc_none=>No','sc_none',0),(23,3,'Shopping Cart Account','Do you want to tie this account with the<br>PSiGate account set up in the shopping cart?','account_tie','sc_psigate=>Yes~sc_none=>No','sc_none',0),(24,5,'Shopping Cart Account','Do you want to tie this account with the<br>PayPal Pro account set up in the shopping cart?','account_tie','sc_paypalpro=>Yes~sc_none=>No','sc_none',0),(26,5,'Order Transaction Type','Transaction type to use for orders','type','A=>Authorization with Delayed Capture','A',0),(27,5,'Additional Authorization %','Additional % to authorize for orders (max 25%)','authorize_extra','0=>0 %~2=>2 %~5=>5 %~10=>10 %~15=>15 %~20=>20 %~25=>25%','10',0),(28,4,'Store Card Info','Retain CC last 4 digits, card name and expiration','validate','0=>No~1=>Yes','0',0),(29,1,'Device Type','Device if using card-present transactions','x_device_type','1=>Unknown~2=>Unattended Terminal~3=>Self Service Terminal~4=>Electronic Cash Register~5=>Personal Computer-Based Terminal~6=>AirPay~7=>Wireless POS~8=>Website~9=>Dial Terminal~10=>Virtual Terminal','5',0),(30,1,'Account Type','Is this a card present (uses scanner) or card not present type of account?','x_card_present','0=>Card Not Present~1=>Card Present','0',0),(31,6,'Source Key','USAePay generated source key','x_login','','Test',0),(32,6,'Check MD5 Hash','Should the MD5 hash be checked?','x_check_hash','TRUE=>Yes~FALSE=>No','FALSE',1),(33,6,'Hash Value','Hash value for the MD5 hash check','x_hash_value','','Test',1),(34,6,'Transaction Mode','Mode used when processing requests','x_test_request','TRUE=>Testing~FALSE=>Production','TRUE',0),(35,6,'Order Transaction Type','Transaction type to use for orders','type','S=>Authorization & Immediate Capture','S',0),(36,6,'Email Customer','Should USA ePay send an email to the customer?','x_email_customer','TRUE=>Yes~FALSE=>No','FALSE',1),(37,6,'Deliminate Data','Deliminated response from gateway','x_delim_data','TRUE=>True','TRUE',0),(38,6,'Delimination Character','Character used to separate fields','x_delim_char',',=>,',',',0),(39,6,'Encapsulation Character','Character used to encapsulate fields','x_encap_char','|=>|','|',0),(40,6,'Transaction Method','Method used to process requests','x_method','CC=>Credit Card','CC',0),(41,6,'Program Version','','x_version','3.1=>3.1','3.1',0),(42,6,'Relay Response','','x_relay_response','FALSE=>False','FALSE',0),(43,6,'Device Type','Device if using card-present transactions','x_device_type','1=>Unknown~2=>Unattended Terminal~3=>Self Service Terminal~4=>Electronic Cash Register~5=>Personal Computer-Based Terminal~6=>AirPay~7=>Wireless POS~8=>Website~9=>Dial Terminal~10=>Virtual Terminal','5',0),(44,6,'Account Type','Is this a card present (uses scanner) or card not present type of account?','x_card_present','0=>Card Not Present~1=>Card Present','0',0),(45,6,'PIN','PIN entered in the USA ePay Merchant Terminal','x_pin','','',0),(46,6,'Source Key Type','','x_sandbox','sandbox=>Sandbox Source Key~production=>Production','production',0);
/*!40000 ALTER TABLE `ccaccountoption` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccaccountsetting`
--

DROP TABLE IF EXISTS `ccaccountsetting`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccaccountsetting` (
  `id` int(11) NOT NULL auto_increment,
  `ccaccountid` int(11) NOT NULL default '0',
  `ccaccountoptionid` int(11) NOT NULL default '0',
  `value` varchar(255) NOT NULL default '',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccaccountsetting`
--

LOCK TABLES `ccaccountsetting` WRITE;
/*!40000 ALTER TABLE `ccaccountsetting` DISABLE KEYS */;
INSERT INTO `ccaccountsetting` VALUES (1,1,28,'0','2006-04-19 16:48:49',1);
/*!40000 ALTER TABLE `ccaccountsetting` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccimportlog`
--

DROP TABLE IF EXISTS `ccimportlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccimportlog` (
  `id` int(11) NOT NULL auto_increment,
  `apbillid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `companyid` int(11) NOT NULL default '0',
  `maincompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `postdate` date default NULL,
  `ccvendorid` int(11) NOT NULL default '0',
  `dnp` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `apbillid` (`apbillid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `companyid` (`companyid`),
  KEY `maincompanyid` (`maincompanyid`),
  KEY `entrydate` (`entrydate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccimportlog`
--

LOCK TABLES `ccimportlog` WRITE;
/*!40000 ALTER TABLE `ccimportlog` DISABLE KEYS */;
/*!40000 ALTER TABLE `ccimportlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccprocessor`
--

DROP TABLE IF EXISTS `ccprocessor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccprocessor` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `modulename` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccprocessor`
--

LOCK TABLES `ccprocessor` WRITE;
/*!40000 ALTER TABLE `ccprocessor` DISABLE KEYS */;
INSERT INTO `ccprocessor` VALUES (1,'Authorize.Net','authorizenet'),(3,'PSiGate','psigate'),(4,'Manual (off line)','manual'),(6,'USA ePay','epay');
/*!40000 ALTER TABLE `ccprocessor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccpurchase`
--

DROP TABLE IF EXISTS `ccpurchase`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccpurchase` (
  `id` int(11) NOT NULL auto_increment,
  `ccvendorid` int(11) NOT NULL default '0',
  `purchasedate` date default NULL,
  `who` varchar(100) default NULL,
  `amount` decimal(19,5) NOT NULL default '0.00000',
  `purpose` varchar(250) default NULL,
  `apbillid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `lastupdatedate` timestamp NULL default NULL,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `purchasefrom` varchar(100) default NULL,
  `invpoid` int(11) NOT NULL default '0',
  `jobid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `currency` varchar(10) NOT NULL default 'USD',
  `currate` decimal(22,10) NOT NULL default '1.0000000000',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ccvendorid` (`ccvendorid`),
  KEY `cancel` (`cancel`),
  KEY `purchasedate` (`purchasedate`),
  KEY `gltr_jobid` (`jobid`),
  KEY `gltr_costcodeid` (`costcodeid`),
  KEY `gltr_categoryid` (`glcategoryid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccpurchase`
--

LOCK TABLES `ccpurchase` WRITE;
/*!40000 ALTER TABLE `ccpurchase` DISABLE KEYS */;
/*!40000 ALTER TABLE `ccpurchase` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccpurchase_detail`
--

DROP TABLE IF EXISTS `ccpurchase_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccpurchase_detail` (
  `id` int(11) NOT NULL auto_increment,
  `ccpurchaseid` int(11) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  `chargetype` int(5) NOT NULL default '0',
  `voucherid` int(11) NOT NULL default '0',
  `amount` decimal(19,5) NOT NULL default '0.00000',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `glcontraid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ccpurchaseid` (`ccpurchaseid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccpurchase_detail`
--

LOCK TABLES `ccpurchase_detail` WRITE;
/*!40000 ALTER TABLE `ccpurchase_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `ccpurchase_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccpurchase_gen`
--

DROP TABLE IF EXISTS `ccpurchase_gen`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccpurchase_gen` (
  `id` int(11) NOT NULL auto_increment,
  `useforpo` int(5) NOT NULL default '0',
  `freight_chargetype` int(11) NOT NULL default '0',
  `tax_chargetype` int(11) NOT NULL default '0',
  `default_po_chargetype` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccpurchase_gen`
--

LOCK TABLES `ccpurchase_gen` WRITE;
/*!40000 ALTER TABLE `ccpurchase_gen` DISABLE KEYS */;
/*!40000 ALTER TABLE `ccpurchase_gen` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccpurchase_type`
--

DROP TABLE IF EXISTS `ccpurchase_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccpurchase_type` (
  `id` int(11) NOT NULL auto_increment,
  `glaccountid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `description` varchar(250) default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `lastupdatedate` datetime default NULL,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `salestaxid` int(11) NOT NULL default '0',
  `glcontraid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `glaccountid` (`glaccountid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccpurchase_type`
--

LOCK TABLES `ccpurchase_type` WRITE;
/*!40000 ALTER TABLE `ccpurchase_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `ccpurchase_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccterminal`
--

DROP TABLE IF EXISTS `ccterminal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccterminal` (
  `id` int(11) NOT NULL auto_increment,
  `inventorylocationid` int(11) NOT NULL default '0',
  `code` varchar(255) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `ip` varchar(45) NOT NULL default '127.0.0.1',
  `port` int(11) NOT NULL default '443',
  `checkedout` tinyint(1) NOT NULL default '0',
  `checkedoutuserid` int(11) NOT NULL default '0',
  `checkacctid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `middleware_devicekey` varchar(255) NOT NULL default '',
  `ccaccountid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `middleware_devicekey_UNIQUE` (`middleware_devicekey`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccterminal`
--

LOCK TABLES `ccterminal` WRITE;
/*!40000 ALTER TABLE `ccterminal` DISABLE KEYS */;
/*!40000 ALTER TABLE `ccterminal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccterminallog`
--

DROP TABLE IF EXISTS `ccterminallog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccterminallog` (
  `id` int(11) NOT NULL auto_increment,
  `ccterminalid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `userid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `resulttxt` varchar(45) NOT NULL default '',
  `requestraw` text NOT NULL,
  `replyraw` text NOT NULL,
  `replyjson` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccterminallog`
--

LOCK TABLES `ccterminallog` WRITE;
/*!40000 ALTER TABLE `ccterminallog` DISABLE KEYS */;
/*!40000 ALTER TABLE `ccterminallog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccterminaluser`
--

DROP TABLE IF EXISTS `ccterminaluser`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccterminaluser` (
  `id` int(11) NOT NULL auto_increment,
  `ccterminalid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `returneddate` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccterminaluser`
--

LOCK TABLES `ccterminaluser` WRITE;
/*!40000 ALTER TABLE `ccterminaluser` DISABLE KEYS */;
/*!40000 ALTER TABLE `ccterminaluser` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cctransaction`
--

DROP TABLE IF EXISTS `cctransaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cctransaction` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `b2buserid` int(11) NOT NULL default '0',
  `ccaccountid` int(11) NOT NULL default '0',
  `referid` int(11) NOT NULL default '0',
  `refertable` varchar(50) NOT NULL default '',
  `transtype` char(1) NOT NULL default '',
  `cardnumber` varchar(50) NOT NULL default '',
  `cardexp` varchar(4) NOT NULL default '',
  `cardtype` varchar(20) NOT NULL default '',
  `cardfirstname` varchar(50) NOT NULL default '',
  `cardlastname` varchar(50) NOT NULL default '',
  `amount` decimal(12,4) NOT NULL default '0.0000',
  `nontaxable` decimal(12,4) NOT NULL default '0.0000',
  `shipping` decimal(12,4) NOT NULL default '0.0000',
  `tax` decimal(12,4) NOT NULL default '0.0000',
  `transid` varchar(30) NOT NULL default '',
  `optionalid` varchar(80) NOT NULL default '',
  `resultcode` char(1) NOT NULL default '',
  `resultreasoncode` int(11) NOT NULL default '0',
  `resultreasontext` varchar(255) NOT NULL default '',
  `authcode` varchar(25) NOT NULL default '',
  `avscode` char(2) NOT NULL default '',
  `cardcode` char(2) NOT NULL default '',
  `customerip` varchar(25) NOT NULL default '',
  `md5hash` varchar(50) NOT NULL default '',
  `customerconfirmation` varchar(20) NOT NULL default '',
  `authopen` int(2) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `authtransid` varchar(30) NOT NULL default '',
  `authorize_extra` int(11) NOT NULL default '0',
  `userdata` varchar(255) NOT NULL default '',
  `billingaddress` varchar(100) NOT NULL default '',
  `billingcity` varchar(50) NOT NULL default '',
  `billingstate` varchar(50) NOT NULL default '',
  `billingzip` varchar(20) NOT NULL default '',
  `cardpresent` int(11) NOT NULL default '0',
  `currency` varchar(10) NOT NULL default 'USD',
  `currate` decimal(22,10) NOT NULL default '1.0000000000',
  PRIMARY KEY  (`id`),
  KEY `referid` (`referid`),
  KEY `ccaccountid` (`ccaccountid`),
  KEY `refertable` (`refertable`),
  KEY `b2buserid` (`b2buserid`),
  KEY `customerconfirmation` (`customerconfirmation`),
  KEY `transid` (`transid`),
  KEY `customerid` (`customerid`),
  KEY `cardtype` (`cardtype`),
  KEY `transtype` (`transtype`),
  KEY `entrydate` (`entrydate`),
  KEY `resultcode` (`resultcode`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cctransaction`
--

LOCK TABLES `cctransaction` WRITE;
/*!40000 ALTER TABLE `cctransaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `cctransaction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ccvendor`
--

DROP TABLE IF EXISTS `ccvendor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ccvendor` (
  `id` int(11) NOT NULL auto_increment,
  `vendorid` int(11) NOT NULL default '0',
  `ccname` varchar(250) default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `lastupdatedate` timestamp NULL default NULL,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `dash_hidden` tinyint(1) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `vendorid` (`vendorid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ccvendor`
--

LOCK TABLES `ccvendor` WRITE;
/*!40000 ALTER TABLE `ccvendor` DISABLE KEYS */;
/*!40000 ALTER TABLE `ccvendor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cfglaccount`
--

DROP TABLE IF EXISTS `cfglaccount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cfglaccount` (
  `id` int(11) NOT NULL auto_increment,
  `cflineid` int(11) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cflineid` (`cflineid`),
  KEY `glaccountid` (`glaccountid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cfglaccount`
--

LOCK TABLES `cfglaccount` WRITE;
/*!40000 ALTER TABLE `cfglaccount` DISABLE KEYS */;
/*!40000 ALTER TABLE `cfglaccount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cfline`
--

DROP TABLE IF EXISTS `cfline`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cfline` (
  `id` int(11) NOT NULL auto_increment,
  `categoryid` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `display_order` int(11) NOT NULL default '0',
  `multiplier` int(11) NOT NULL default '1',
  `companyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `categoryid` (`categoryid`),
  KEY `cancel` (`cancel`),
  KEY `companyid` (`companyid`)
) ENGINE=InnoDB AUTO_INCREMENT=32 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cfline`
--

LOCK TABLES `cfline` WRITE;
/*!40000 ALTER TABLE `cfline` DISABLE KEYS */;
INSERT INTO `cfline` VALUES (1,1,'Rent Paid in Advance',0,1,1,'2009-12-20 17:01:00',1,0,'2009-12-20 23:43:04',1),(2,2,'Depreciation',0,-1,1,'2009-12-20 17:10:18',1,0,'0001-01-01 00:00:00',0),(3,2,'Amortization',0,-1,1,'2009-12-20 18:01:38',1,0,'0001-01-01 00:00:00',0),(4,3,'Cash Out - Nondeductible Asset',0,-1,1,'2009-12-20 18:10:05',1,0,'0001-01-01 00:00:00',0),(5,3,'Net change in accounts receivable',0,-1,1,'2009-12-20 18:15:04',1,0,'0001-01-01 00:00:00',0),(6,3,'Net change in accounts payable and accrued expenses',0,1,1,'2009-12-20 18:19:37',1,0,'0000-00-00 00:00:00',0),(7,4,'Change of Prepaid Expenses',0,-1,1,'2009-12-20 18:22:19',1,0,'0001-01-01 00:00:00',0),(8,4,'Change of Other Current Assets',0,-1,1,'2009-12-20 18:22:46',1,0,'0001-01-01 00:00:00',0),(9,6,'Inventory',0,-1,1,'2009-12-20 18:26:04',1,0,'0001-01-01 00:00:00',0),(10,6,'Property, Plant and Equipment - General',0,-1,1,'2009-12-20 18:37:36',1,0,'0001-01-01 00:00:00',0),(11,6,'Property, Plant and Equipment - Property',0,-1,1,'2009-12-20 18:38:31',1,0,'0001-01-01 00:00:00',0),(12,6,'Land',0,-1,1,'2009-12-20 18:39:11',1,0,'0001-01-01 00:00:00',0),(13,5,'Return of (Made to) Investments Affiliate Companies',0,-1,1,'2009-12-20 18:40:19',1,0,'0001-01-01 00:00:00',0),(14,5,'Repayment of (Loans to) Affiliate Companies',0,-1,1,'2009-12-20 18:41:18',1,0,'0001-01-01 00:00:00',0),(15,5,'Repayment (Issuance) of Notes Receivable - Current, net',0,-1,1,'2009-12-20 18:41:42',1,0,'0001-01-01 00:00:00',0),(16,5,'Repayment (Issuance) of Notes Receivable, net',0,-1,1,'2009-12-20 18:42:13',1,0,'0001-01-01 00:00:00',0),(17,5,'Proceeds from sale of Other Assets - Other Noncurrent, Other Current',0,-1,1,'2009-12-20 18:44:24',1,0,'0001-01-01 00:00:00',0),(18,5,'Deposits and Refundable Deposits',0,-1,1,'2009-12-20 18:45:09',1,0,'0001-01-01 00:00:00',0),(19,7,'Proceeds from (repayment of) principal from long term real estate debt, net',0,1,1,'2009-12-20 18:50:08',1,0,'0000-00-00 00:00:00',0),(20,7,'Proceeds from (repayment of) long term notes',0,1,1,'2009-12-20 18:50:35',1,0,'0000-00-00 00:00:00',0),(21,7,'Proceeds from (repayment of) borrowings from unsecured debt - term and loc',0,1,1,'2009-12-20 18:50:55',1,0,'0000-00-00 00:00:00',0),(22,7,'Cash Out - Nontaxable Income',0,1,1,'2009-12-20 18:51:15',1,0,'0000-00-00 00:00:00',0),(23,7,'Membership Contribution Received',0,1,1,'2009-12-20 18:51:39',1,0,'0000-00-00 00:00:00',0),(24,7,'Membership Disbursements Paid',0,1,1,'2009-12-20 18:52:01',1,0,'0000-00-00 00:00:00',0),(25,7,'Dividends Paid',0,1,1,'2009-12-20 18:52:51',1,0,'0000-00-00 00:00:00',0),(26,8,'STR_BEGINNING_END_OF_PERIOD_ACCOUNTS',0,1,1,'2009-12-20 18:55:50',1,0,'0001-01-01 00:00:00',0),(28,1,'Test Name2',0,1,1,'2009-12-20 23:34:59',1,1,'2009-12-20 23:43:47',1),(29,5,'Proceeds from sale of Property, Plant and Equipment - Property',0,-1,1,'2009-12-22 15:39:40',1,0,'0001-01-01 00:00:00',0),(30,5,'Proceeds from sale of Property, Plant and Equipment - General',0,-1,1,'2009-12-22 15:39:54',1,0,'0001-01-01 00:00:00',0),(31,5,'Proceeds from sale of Land',0,-1,1,'2009-12-22 15:40:05',1,0,'0001-01-01 00:00:00',0);
/*!40000 ALTER TABLE `cfline` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `changedate`
--

DROP TABLE IF EXISTS `changedate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `changedate` (
  `id_changedate` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `id_user` int(11) NOT NULL default '0',
  `olddate` datetime NOT NULL default '0000-00-00 00:00:00',
  `newdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `changedate` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`id_changedate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `changedate`
--

LOCK TABLES `changedate` WRITE;
/*!40000 ALTER TABLE `changedate` DISABLE KEYS */;
/*!40000 ALTER TABLE `changedate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `changedateseq`
--

DROP TABLE IF EXISTS `changedateseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `changedateseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `changedateseq`
--

LOCK TABLES `changedateseq` WRITE;
/*!40000 ALTER TABLE `changedateseq` DISABLE KEYS */;
INSERT INTO `changedateseq` VALUES (0);
/*!40000 ALTER TABLE `changedateseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `chargebackcode`
--

DROP TABLE IF EXISTS `chargebackcode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `chargebackcode` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(64) NOT NULL default '',
  `description` tinytext,
  `glaccountid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `chargebackcode`
--

LOCK TABLES `chargebackcode` WRITE;
/*!40000 ALTER TABLE `chargebackcode` DISABLE KEYS */;
/*!40000 ALTER TABLE `chargebackcode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `checkacct`
--

DROP TABLE IF EXISTS `checkacct`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `checkacct` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(30) default NULL,
  `glaccountid` int(11) NOT NULL default '0',
  `lastchecknumberused` decimal(20,0) default NULL,
  `defaultendorser` varchar(50) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `ap` int(11) NOT NULL default '0',
  `ar` tinyint(1) NOT NULL default '1',
  `pay` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `destination_routing` varchar(9) NOT NULL default '',
  `destination_name` varchar(23) NOT NULL default '',
  `origin_routing` varchar(9) NOT NULL default '',
  `origin_name` varchar(23) NOT NULL default '',
  `company_name` varchar(16) NOT NULL default '',
  `company_identification` varchar(10) NOT NULL default '',
  `send_prenotes` int(2) NOT NULL default '0',
  `accountnumber` varchar(17) NOT NULL default '',
  `fractional_routing` varchar(30) NOT NULL default '',
  `addresscsz` varchar(255) NOT NULL default '',
  `printfullchecks` int(2) NOT NULL default '0',
  `logo` varchar(100) NOT NULL default '',
  `signaturefile` varchar(100) NOT NULL default '',
  `signaturefile2` varchar(100) NOT NULL default '',
  `xadjust` int(11) NOT NULL default '0',
  `yadjust` int(11) NOT NULL default '0',
  `pay_type` int(5) NOT NULL default '2',
  `currency` varchar(10) NOT NULL default 'USD',
  `stubdetails` int(5) NOT NULL default '0',
  `depositrouting` varchar(30) NOT NULL default '',
  `depositformat` int(5) NOT NULL default '0',
  `depositlocation` varchar(255) NOT NULL default '',
  `depositbankaddress` varchar(200) NOT NULL default '',
  `stubformat` int(5) NOT NULL default '0',
  `accountcode` varchar(50) NOT NULL default '',
  `siglines` int(5) NOT NULL default '0',
  `echeckccaccountid` int(11) NOT NULL default '0',
  `specialpayroll` int(5) NOT NULL default '0',
  `dash_hidden` tinyint(1) NOT NULL default '0',
  `filecreationnumber` int(11) NOT NULL default '0',
  `inactive` tinyint(4) NOT NULL default '0',
  `stub_overflow` tinyint(1) NOT NULL default '0',
  `void_date_default_now` tinyint(1) NOT NULL default '0',
  `no_sig_on_manual_checks` tinyint(1) NOT NULL default '0',
  `ccvendorid` int(11) NOT NULL default '0',
  `positive_pay_enabled` tinyint(1) NOT NULL default '0',
  `positive_pay_host` varchar(255) NOT NULL default '',
  `positive_pay_user` varchar(255) NOT NULL default '',
  `positive_pay_private_key` mediumtext NOT NULL,
  `positive_pay_public_key` mediumtext NOT NULL,
  `show_invoice_notes` tinyint(1) NOT NULL default '0',
  `show_invoice_tables` tinyint(1) NOT NULL default '3',
  `show_invoice_origamt` tinyint(1) NOT NULL default '0',
  `show_invoice_disc` tinyint(1) NOT NULL default '0',
  `copy_second_stub` tinyint(1) NOT NULL default '1',
  `positive_pay_sftp` tinyint(1) NOT NULL default '1',
  `payee_name_caps` tinyint(1) NOT NULL default '1',
  `payee_name_font_size` tinyint(4) NOT NULL default '12',
  `hide_second_header` tinyint(1) NOT NULL default '0',
  `hide_discount` tinyint(1) NOT NULL default '0',
  `hide_interest` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `checkacct`
--

LOCK TABLES `checkacct` WRITE;
/*!40000 ALTER TABLE `checkacct` DISABLE KEYS */;
/*!40000 ALTER TABLE `checkacct` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `checklist`
--

DROP TABLE IF EXISTS `checklist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `checklist` (
  `id` int(11) NOT NULL auto_increment,
  `cltype` varchar(15) NOT NULL default '',
  `recordid` int(11) NOT NULL default '0',
  `description` varchar(255) NOT NULL default '',
  `completed` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `cancel` int(11) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `confirmuserids` text NOT NULL,
  `finaluserid` int(11) NOT NULL default '0',
  `finaldate` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `entryuserid` (`entryuserid`),
  KEY `cltype` (`cltype`),
  KEY `completed` (`completed`),
  KEY `cancel` (`cancel`),
  KEY `recordid` (`recordid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `checklist`
--

LOCK TABLES `checklist` WRITE;
/*!40000 ALTER TABLE `checklist` DISABLE KEYS */;
/*!40000 ALTER TABLE `checklist` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `chk`
--

DROP TABLE IF EXISTS `chk`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `chk` (
  `id` int(11) NOT NULL auto_increment,
  `wherefrom` int(11) NOT NULL default '0',
  `paytype` int(11) NOT NULL default '0',
  `checkdate` date default NULL,
  `checkvoid` int(11) NOT NULL default '0',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `checkaccountid` int(11) NOT NULL default '0',
  `checknumber` decimal(15,0) NOT NULL default '0',
  `cashdate` date NOT NULL default '0000-00-00',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `name` varchar(100) default NULL,
  `achfiledetailid` int(11) NOT NULL default '0',
  `commission` int(2) NOT NULL default '0',
  `maincheckid` int(11) NOT NULL default '0',
  `stub_display` varchar(255) NOT NULL default '',
  `currency` varchar(10) NOT NULL default 'USD',
  `voiddate` date default NULL,
  `altname` varchar(255) NOT NULL default '',
  `non_negotiable` int(5) NOT NULL default '0',
  `manual` tinyint(1) NOT NULL default '0',
  `ccapbillid` int(11) NOT NULL default '0',
  `positivepaysent` datetime default '0000-00-00 00:00:00',
  `ccapbilldetailid` int(11) NOT NULL default '0',
  `forcediscount` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `achfiledetailid` (`achfiledetailid`),
  KEY `checkaccountid` (`checkaccountid`),
  KEY `checkvoid` (`checkvoid`),
  KEY `checknumber` (`checknumber`),
  KEY `checkdate` (`checkdate`),
  KEY `cashdate` (`cashdate`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `wherefrom` (`wherefrom`),
  KEY `maincheckid` (`maincheckid`),
  KEY `paytype_ccapbillid` (`paytype`,`ccapbillid`),
  KEY `ccapbilldetailid` (`ccapbilldetailid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `chk`
--

LOCK TABLES `chk` WRITE;
/*!40000 ALTER TABLE `chk` DISABLE KEYS */;
/*!40000 ALTER TABLE `chk` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `chknotes`
--

DROP TABLE IF EXISTS `chknotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `chknotes` (
  `id` int(11) NOT NULL auto_increment,
  `checkid` int(11) NOT NULL default '0',
  `note` text,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `checkid` (`checkid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `chknotes`
--

LOCK TABLES `chknotes` WRITE;
/*!40000 ALTER TABLE `chknotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `chknotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `coinvoice`
--

DROP TABLE IF EXISTS `coinvoice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `coinvoice` (
  `id` int(11) NOT NULL auto_increment,
  `maininvoiceid` int(11) NOT NULL default '0',
  `maincustomerid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `invoicetotal` decimal(19,6) NOT NULL default '0.000000',
  `groupbysales` int(11) NOT NULL default '0',
  `paid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `cancel` int(11) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `notes` text NOT NULL,
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `maininvoiceid` (`maininvoiceid`),
  KEY `maincustomerid` (`maincustomerid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `customerid` (`customerid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `coinvoice`
--

LOCK TABLES `coinvoice` WRITE;
/*!40000 ALTER TABLE `coinvoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `coinvoice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `coinvoicedetail`
--

DROP TABLE IF EXISTS `coinvoicedetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `coinvoicedetail` (
  `id` int(11) NOT NULL auto_increment,
  `coinvoiceid` int(11) NOT NULL default '0',
  `description` varchar(100) NOT NULL default '',
  `origlinenum` int(11) NOT NULL default '0',
  `salesglaccountid` int(11) NOT NULL default '0',
  `origamount` decimal(19,6) NOT NULL default '0.000000',
  `chargedamount` decimal(19,6) NOT NULL default '0.000000',
  `paidamount` decimal(19,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`),
  KEY `coinvoiceid` (`coinvoiceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `coinvoicedetail`
--

LOCK TABLES `coinvoicedetail` WRITE;
/*!40000 ALTER TABLE `coinvoicedetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `coinvoicedetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commission`
--

DROP TABLE IF EXISTS `commission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commission` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `tablename` varchar(50) NOT NULL default '',
  `tableid` int(11) NOT NULL default '0',
  `description` varchar(150) NOT NULL default '',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `commissionflat` decimal(19,6) NOT NULL default '0.000000',
  `commissionpercent` decimal(7,2) NOT NULL default '0.00',
  `commissionbase` decimal(19,6) NOT NULL default '0.000000',
  `status` int(11) NOT NULL default '-1',
  `premplweekid` int(11) NOT NULL default '0',
  `salesmanid` int(11) NOT NULL default '0',
  `employeeid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `orderid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `linenumber` int(11) NOT NULL default '0',
  `commissiondate` date default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `method` varchar(20) NOT NULL default '',
  `currency` varchar(10) NOT NULL default 'USD',
  PRIMARY KEY  (`id`),
  KEY `userid` (`userid`),
  KEY `tablename` (`tablename`),
  KEY `tableid` (`tableid`),
  KEY `status` (`status`),
  KEY `premplweekid` (`premplweekid`),
  KEY `entrydate` (`entrydate`),
  KEY `cancel` (`cancel`),
  KEY `customerid` (`customerid`),
  KEY `employeeid` (`employeeid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `orderid` (`orderid`),
  KEY `salesmanid` (`salesmanid`),
  KEY `vendorid` (`vendorid`),
  KEY `companyid` (`companyid`),
  KEY `method` (`method`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commission`
--

LOCK TABLES `commission` WRITE;
/*!40000 ALTER TABLE `commission` DISABLE KEYS */;
/*!40000 ALTER TABLE `commission` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commissionadjustlatepmt`
--

DROP TABLE IF EXISTS `commissionadjustlatepmt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commissionadjustlatepmt` (
  `id` int(11) NOT NULL auto_increment,
  `leaseid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `origcommissionid` int(11) NOT NULL default '0',
  `commissionid` int(11) NOT NULL default '0',
  `dayslate` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `leaseid` (`leaseid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `origcommissionid` (`origcommissionid`),
  KEY `commissionid` (`commissionid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commissionadjustlatepmt`
--

LOCK TABLES `commissionadjustlatepmt` WRITE;
/*!40000 ALTER TABLE `commissionadjustlatepmt` DISABLE KEYS */;
/*!40000 ALTER TABLE `commissionadjustlatepmt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `compositeitemextras`
--

DROP TABLE IF EXISTS `compositeitemextras`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `compositeitemextras` (
  `id` int(11) NOT NULL auto_increment,
  `compositeitemid` int(11) NOT NULL default '0',
  `amount` decimal(19,5) NOT NULL default '0.00000',
  `glaccountid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `description` varchar(250) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `compositeitemid` (`compositeitemid`),
  KEY `cancel` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `compositeitemextras`
--

LOCK TABLES `compositeitemextras` WRITE;
/*!40000 ALTER TABLE `compositeitemextras` DISABLE KEYS */;
/*!40000 ALTER TABLE `compositeitemextras` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `compositeitemid`
--

DROP TABLE IF EXISTS `compositeitemid`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `compositeitemid` (
  `id` int(11) NOT NULL auto_increment,
  `itemcodeid` int(11) NOT NULL default '0',
  `subitemcodeid` int(11) default NULL,
  `quantity` decimal(18,6) NOT NULL default '0.000000',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `default_itemvendorid` int(11) NOT NULL default '0',
  `mfg` varchar(50) default NULL,
  `vordernumber` varchar(30) default NULL,
  `reference_notes` text,
  `status` int(5) NOT NULL default '0',
  `displayorder` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `itemcodeid` (`itemcodeid`),
  KEY `subitemcodeid` (`subitemcodeid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `compositeitemid`
--

LOCK TABLES `compositeitemid` WRITE;
/*!40000 ALTER TABLE `compositeitemid` DISABLE KEYS */;
/*!40000 ALTER TABLE `compositeitemid` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `configuration`
--

DROP TABLE IF EXISTS `configuration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `configuration` (
  `configuration_id` int(5) NOT NULL auto_increment,
  `configuration_title` varchar(64) NOT NULL default '',
  `configuration_key` varchar(64) NOT NULL default '',
  `configuration_value` varchar(255) NOT NULL default '',
  `configuration_description` varchar(255) NOT NULL default '',
  `configuration_group_id` int(5) NOT NULL default '0',
  `sort_order` int(5) default NULL,
  `last_modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `date_added` timestamp NOT NULL default '0000-00-00 00:00:00',
  `use_function` varchar(32) default NULL,
  `set_function` varchar(255) default NULL,
  PRIMARY KEY  (`configuration_id`)
) ENGINE=MyISAM AUTO_INCREMENT=231 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `configuration`
--

LOCK TABLES `configuration` WRITE;
/*!40000 ALTER TABLE `configuration` DISABLE KEYS */;
INSERT INTO `configuration` VALUES (1,'Installed Shipping Modules','SHIPPING_MODULES','item.php;flat.php;selfpickup.php;ups.php;usps.php','This is automatically updated. No need to edit.',7,1,'2007-03-29 13:24:39','2003-06-10 00:18:15','',NULL),(200,'Store Name','STORE_NAME','NolaPro','The name of my store',1,1,'2003-10-05 18:21:34','2002-01-25 06:25:53','',NULL),(2,'Store Owner','STORE_OWNER','Noguska','The name of my store owner',1,2,'2003-12-19 16:59:42','2002-01-25 06:25:53','',NULL),(3,'E-Mail Address','STORE_OWNER_EMAIL_ADDRESS','admin1@noguska.com','The e-mail address of my store owner',1,3,'2003-12-17 21:29:08','2002-01-25 06:25:53','',NULL),(4,'E-Mail From','EMAIL_FROM','admin1@noguska.com','The e-mail address used in (sent) e-mails',1,4,'2003-09-18 18:23:20','2002-01-25 06:25:53','',NULL),(5,'Country','STORE_COUNTRY','223','The country my store is located in',1,5,'2002-02-11 17:31:58','2002-01-25 06:25:53','tep_get_country_name',NULL),(6,'Expected Sort Order','EXPECTED_PRODUCTS_SORT','DESC','This is the sort order used in the &quot;expected products&quot; box.  It can be either ASC (ascending) or DESC (descending, the default).',1,20,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(7,'Expected Sort Field','EXPECTED_PRODUCTS_FIELD','date_expected','The column to sort by in the &quot;expected products&quot; box.  Can be &quot;products_name&quot; or &quot;date_expected&quot; (the default)',1,30,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(8,'First Name','ENTRY_FIRST_NAME_MIN_LENGTH','1','Minimum length of first name',2,1,'2003-12-17 21:29:28','2002-01-25 06:25:53','',NULL),(9,'Last Name','ENTRY_LAST_NAME_MIN_LENGTH','1','Minimum length of last name',2,2,'2002-03-05 16:54:48','2002-01-25 06:25:53','',NULL),(10,'Date of Birth','ENTRY_DOB_MIN_LENGTH','10','Minimum length of date of birth',2,3,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(11,'E-Mail Address','ENTRY_EMAIL_ADDRESS_MIN_LENGTH','6','Minimum length of e-mail address',2,4,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(12,'Street Address','ENTRY_STREET_ADDRESS_MIN_LENGTH','5','Minimum length of street address',2,5,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(13,'Post Code','ENTRY_POSTCODE_MIN_LENGTH','4','Minimum length of post code',2,6,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(14,'City','ENTRY_CITY_MIN_LENGTH','4','Minimum length of city',2,7,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(15,'State','ENTRY_STATE_MIN_LENGTH','4','Minimum length of state',2,7,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(16,'Telephone Number','ENTRY_TELEPHONE_MIN_LENGTH','3','Minimum length of telephone number',2,8,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(17,'Password','ENTRY_PASSWORD_MIN_LENGTH','5','Minimum length of password',2,9,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(18,'Credit Card Owner Name','CC_OWNER_MIN_LENGTH','3','Minimum length of credit card owner name',2,10,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(19,'Credit Card Number','CC_NUMBER_MIN_LENGTH','10','Minimum length of credit card number',2,11,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(20,'Review Text','REVIEW_TEXT_MIN_LENGTH','25','Minimum length of review text',2,13,'2002-11-10 23:20:59','2002-01-25 06:25:53','',NULL),(21,'Address Book Entries','MAX_ADDRESS_BOOK_ENTRIES','5','Maximum address book entries a customer is allowed to have',3,1,'2003-12-17 21:30:00','2002-01-25 06:25:53','',NULL),(22,'Search Results','MAX_DISPLAY_SEARCH_RESULTS','10','Amount of products to list',3,2,'2002-02-06 23:55:33','2002-01-25 06:25:53','',NULL),(23,'Page Links','MAX_DISPLAY_PAGE_LINKS','5','Number of \'number\' links use for page-sets',3,3,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(24,'Special Products','MAX_DISPLAY_SPECIAL_PRODUCTS','9','Maximum number of products on special to display',3,4,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(25,'New Products','MAX_DISPLAY_NEW_PRODUCTS','6','Maximum number of new products to display in a category',3,5,'2002-10-13 20:58:03','2002-01-25 06:25:53','',NULL),(26,'Products Expected','MAX_DISPLAY_UPCOMING_PRODUCTS','10','Maximum number of products expected to display',3,6,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(27,'Manufacturers List','MAX_DISPLAY_MANUFACTURERS_IN_A_LIST','0','Used in manufacturers box; when the number of manufacturers exceeds this number, a drop-down list will be displayed instead of the default list',3,7,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(28,'Length of Manufacturers Name','MAX_DISPLAY_MANUFACTURER_NAME_LEN','15','Used in manufacturers box; maximum length of manufacturers name to display',3,8,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(29,'New Reviews','MAX_DISPLAY_NEW_REVIEWS','6','Maximum number of new reviews to display',3,9,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(30,'Selection of Random Reviews','MAX_RANDOM_SELECT_REVIEWS','10','How many records to select from to choose one random product review',3,10,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(31,'Selection of Random New Products','MAX_RANDOM_SELECT_NEW','10','How many records to select from to choose one random new product to display',3,11,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(32,'Selection of Products on Special','MAX_RANDOM_SELECT_SPECIALS','10','How many records to select from to choose one random product special to display',3,12,'2002-10-09 03:35:09','2002-01-25 06:25:53','',NULL),(33,'Categories To List Per Row','MAX_DISPLAY_CATEGORIES_PER_ROW','3','How many categories to list per row',3,13,'2002-10-13 20:58:36','2002-01-25 06:25:53','',NULL),(34,'Small Image Width','SMALL_IMAGE_WIDTH','100','The pixel width of small images',4,1,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(35,'Small Image Height','SMALL_IMAGE_HEIGHT','80','The pixel height of small images',4,2,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(36,'Heading Image Width','HEADING_IMAGE_WIDTH','85','The pixel width of heading images',4,3,'2002-02-19 22:12:49','2002-01-25 06:25:53','',NULL),(37,'Heading Image Height','HEADING_IMAGE_HEIGHT','60','The pixel height of heading images',4,4,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(38,'Subcategory Image Width','SUBCATEGORY_IMAGE_WIDTH','100','The pixel width of subcategory images',4,5,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(39,'Subcategory Image Height','SUBCATEGORY_IMAGE_HEIGHT','57','The pixel height of subcategory images',4,6,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(40,'Calculate Image Size','CONFIG_CALCULATE_IMAGE_SIZE','1','Calculate the size of images?',4,7,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(41,'Image Required','IMAGE_REQUIRED','1','Enable to display broken images. Good for development.',4,8,'2002-03-19 17:46:43','2002-01-25 06:25:53','',NULL),(42,'General','FONT_STYLE_MAIN','<font face=\"Verdana, Arial\" size=\"2\" color=\"#000000\">','General font style',5,1,'2002-02-22 03:59:57','2002-01-25 06:25:53','',NULL),(43,'Small Text','FONT_STYLE_SMALL_TEXT','<font face=\"Verdana, Arial\" size=\"1\" color=\"#000000\">','Small Text font style',5,2,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(44,'Navigation Bar','FONT_STYLE_HEADER_NAVIGATION_BAR','<font face=\"Tahoma, Verdana, Arial\" size=\"2\" color=\"#ffffff\">','Header Navigation Bar font style',5,3,'2002-02-22 16:39:47','2002-01-25 06:25:53','',NULL),(45,'Top Bar','FONT_STYLE_TOP_BAR','<font face=\"Tahoma, Verdana, Arial\" size=\"2\"  color=\"#FFFFFF\">','Top Bar font style',5,4,'2002-02-22 16:42:49','2002-01-25 06:25:53','',NULL),(46,'Heading','FONT_STYLE_HEADING','<font face=\"Verdana, Arial\" size=\"4\" color=\"#000000\">','Heading font style',5,5,'2002-02-22 14:39:29','2002-01-25 06:25:53','',NULL),(47,'Sub Bar','FONT_STYLE_SUB_BAR','<font face=\"Verdana, Arial\" size=\"1\" color=\"#000000\">','Sub Bar font style',5,6,'2002-02-22 14:40:26','2002-01-25 06:25:53','',NULL),(48,'Table Heading','FONT_STYLE_TABLE_HEADING','<font face=\"Verdana, Arial\" size=\"2\" color=\"#000000\">','Table Heading font style',5,7,'2002-02-22 14:43:10','2002-01-25 06:25:53','',NULL),(49,'Footer','FONT_STYLE_FOOTER','<font face=\"Tahoma, Verdana, Arial\" size=\"2\" color=\"#ffffff\">','Footer font style',5,8,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(50,'Info-Box Headings','FONT_STYLE_INFO_BOX_HEADING','<font face=\"Tahoma, Verdana, Arial\" size=\"2\" color=\"#FFFFFF\">','Font style for info-box headings',5,9,'2002-02-22 17:10:20','2002-01-25 06:25:53','',NULL),(51,'Info-Box Contents','FONT_STYLE_INFO_BOX_BODY','<font face=\"Verdana, Arial\" size=\"1\">','Font style for info-box contents',5,10,'2002-02-22 16:40:44','2002-01-25 06:25:53','',NULL),(52,'Listing Headings','FONT_STYLE_LIST_BOX_HEADING','<font face=\"Verdana, Arial\" size=\"2\">','Font style for listing box headings',5,11,'2002-02-22 16:41:14','2002-01-25 06:25:53','',NULL),(53,'Listing Contents','FONT_STYLE_LIST_BOX_BODY','<font face=\"Verdana, Arial\" size=\"1\" color=\"#000000\">','Font style for listing box contents',5,12,'2002-02-22 14:53:37','2002-01-25 06:25:53','',NULL),(54,'Account Categories','FONT_STYLE_ACCOUNT_CATEGORY','<font face=\"Verdana, Arial\" size=\"2\" color=\"#aabbdd\">','Account Category font style',5,13,'2002-02-22 14:58:03','2002-01-25 06:25:53','',NULL),(55,'Field Entry','FONT_STYLE_FIELD_ENTRY','<font face=\"Verdana, Arial\" size=\"2\">','Field Entry font style',5,14,'2002-02-22 16:43:37','2002-01-25 06:25:53','',NULL),(56,'Field Value','FONT_STYLE_FIELD_VALUE','<font face=\"Verdana, Arial\" size=\"2\">','Field Value font style',5,15,'2002-02-22 16:44:16','2002-01-25 06:25:53','',NULL),(57,'New Item In Cart','FONT_STYLE_NEW_CART_ITEM','<font face=\"Verdana, Arial\" size=\"1\" color=\"#ff0000\">','Font style for new items added to the cart',5,16,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(58,'Installed Payment Modules','PAYMENT_MODULES','paypal.php;cc.php;cod.php','List of payment module filenames separated by a semi-colon. This is automatically updated. No need to edit. (Example: cc.php;cod.php;paypal.php)',6,0,'2003-12-22 15:58:13','2002-01-25 06:25:53','',NULL),(92,'Inactive Account Timer','MAX_NUMBER_OF_DAYS_WITHOUT_ORDERS_ALLOWED','90','If the customer has not been active for this many days the account is disabled.',3,1,'2003-10-17 18:06:18','2002-02-20 20:25:10','',NULL),(94,'Store Address','STORE_ADDRESS','One OS Suite Way','Store Address',1,5,'2002-11-14 01:41:10','2002-02-20 20:36:58','',NULL),(93,'Store Address City','STORE_ADDRESS_CITY','New York','Store Address City',1,5,'2002-11-10 22:39:38','2002-02-20 20:35:55','',NULL),(63,'Credit Card TP email address','PAYMENT_EMAIL_CC','NONE','If this email address is not NONE then the middle digits of any stored cc numbers will be X-ed out and emailed with the order id.',6,5,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(64,'Shipping Methods to offer to customer','SHIPPING_MODULES','item.php;flat.php;selfpickup.php;ups.php;usps.php','List of shipping module filenames separated by a semi-colon. This is automatically updated. No need to edit. (Example: ups.php;flat.php;item.php)',7,1,'2007-03-29 13:24:45','2002-01-25 06:25:53',NULL,NULL),(65,'Package Tare weight.','SHIPPING_BOX_WEIGHT','3','What is the weight of typical packaging of small to medium packages?',7,2,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(66,'Larger packages - percentage increase.','SHIPPING_BOX_PADDING','10','For 10% enter 10',7,3,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(67,'Handling Fee','SHIPPING_HANDLING','0','Enter the handling fee you may charge.',7,4,'2002-10-09 03:36:36','2002-01-25 06:25:53','',NULL),(68,'Display Product Image','PRODUCT_LIST_IMAGE','1','Do you want to display the Product Image?',8,1,'2002-03-19 17:52:04','2002-01-25 06:25:53','',NULL),(69,'Display Product Manufacturer Name','PRODUCT_LIST_MANUFACTURER','0','Do you want to display the Product Manufacturer Name?',8,2,'2003-08-27 19:13:58','2002-01-25 06:25:53','',NULL),(70,'Display Product Model','PRODUCT_LIST_MODEL','1','Do you want to display the Product Model?',8,3,'2003-12-17 21:31:27','2002-01-25 06:25:53','',NULL),(71,'Display Product Name','PRODUCT_LIST_NAME','1','Do you want to display the Product Name?',8,4,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(72,'Display Product Price','PRODUCT_LIST_PRICE','1','Do you want to display the Product Price',8,5,'2002-03-19 17:43:41','2002-01-25 06:25:53','',NULL),(73,'Display Product Quantity','PRODUCT_LIST_QUANTITY','1','Do you want to display the Product Quantity?',8,6,'2002-03-19 17:40:47','2002-01-25 06:25:53','',NULL),(74,'Display Product Weight','PRODUCT_LIST_WEIGHT','1','Do you want to display the Product Weight?',8,7,'2002-03-19 17:41:08','2002-01-25 06:25:53','',NULL),(75,'Display Buy Now column','PRODUCT_LIST_BUY_NOW','1','Do you want to display the Buy Now column?',8,8,'2002-03-19 17:41:32','2002-01-25 06:25:53','',NULL),(76,'Display Category/Manufacturer Filter (0=disable; 1=enable)','PRODUCT_LIST_FILTER','1','Do you want to display the Category/Manufacturer Filter?',8,9,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(77,'Location of Prev/Next Navigation Bar (1-top, 2-bottom, 3-both)','PREV_NEXT_BAR_LOCATION','2','Sets the location of the Prev/Next Navigation Bar (1-top, 2-bottom, 3-both)',8,10,'2002-03-19 17:44:44','2002-01-25 06:25:53','',NULL),(203,'Enable Item Shipping','SHIPPING_ITEM_ENABLED','1','Do you want to offer per item rate shipping?',7,7,'2003-07-18 20:11:28','2003-07-18 20:11:28',NULL,NULL),(80,'UPS Pickup Method','SHIPPING_UPS_PICKUP','CC','How do you give packages to UPS? CC - Customer Counter, RDP - Daily Pickup, OTP - One Time Pickup, LC - Letter Center, OCA - On Call Air',7,5,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(81,'UPS Packaging?','SHIPPING_UPS_PACKAGE','CP','CP - Your Packaging, ULE - UPS Letter, UT - UPS Tube, UBE - UPS Express Box',7,6,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(82,'Residential Delivery?','SHIPPING_UPS_RES','RES','Quote for Residential (RES) or Commercial Delivery (COM)',7,7,'2003-10-17 18:05:19','2002-01-25 06:25:53',NULL,NULL),(83,'Enter the USPS USERID','SHIPPING_USPS_USERID','NONE','Enter the USPS USERID assigned to you. Register at http://www.uspsprioritymail.com/et_regcert.html and also tell them you are an end user not developer.',7,11,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(85,'Enter the USPS URL of the production Server','SHIPPING_USPS_SERVER','NONE','See above',7,13,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(86,'Enter the Maximum Package Weight you will ship','SHIPPING_MAX_WEIGHT','50','Carriers have a max weight limit for a single package. This is a common one for all.',7,14,'2002-01-25 06:25:53','2002-01-25 06:25:53',NULL,NULL),(87,'Postal Code','STORE_ORIGIN_ZIP','10005','Enter the Postal Code (ZIP) of the Store to be used in shipping quotes.',1,6,'2003-12-18 14:20:52','2002-01-25 06:25:53','',NULL),(88,'Country Code','STORE_ORIGIN_COUNTRY','95991','Enter the &quot;ISO 3166&quot; Country Code of the Store to be used in shipping quotes.  To find your country code, visit the <A HREF=\"http://www.din.de/gremien/nas/nabd/iso3166ma/codlstp1/index.html\" TARGET=\"_blank\">ISO 3166 Maintenance Agency</A>.',1,9,'2002-10-27 18:30:40','2002-01-25 06:25:53','',NULL),(95,'Store Telephone Number','STORE_TELEPHONE','212-123-4567','Store Telephone Number',1,10,'2002-11-10 22:41:38','2002-02-20 20:40:21','',NULL),(96,'Store Fax Number','STORE_FAX','212-345-6789','Store Fax Number',1,11,'2002-11-10 22:42:03','2002-02-20 20:53:57','',NULL),(97,'E-Mail Address for Invoices','STORE_EMAIL_INVOICE','noreply@nolapro.com','Copy of the invoices are send to this mail box',1,4,'2003-12-19 16:59:32','2002-02-20 21:10:17','',NULL),(98,'E-Mail Customer Account Support','EMAIL_CUSTOMER_ACCOUNT_SUPPORT','noreply@ossuite.org','E-Mail box for account creating and disabling',1,4,'2002-11-10 23:39:29','2002-02-20 21:12:37','',NULL),(99,'Tax ID/SSN','ENTRY_TAX_ID_MIN_LENGTH','9','configuration',2,5,'2003-10-17 18:11:23','2002-02-25 19:13:26',NULL,NULL),(100,'Company Name','ENTRY_COMPANY_NAME_MIN_LENGTH','2','Minimum length of company name',2,5,'2002-02-25 19:19:47','2002-02-25 19:19:47',NULL,NULL),(134,'Active ERP Software','ACTIVE_ACCOUNTING_SOFTWARE','1','Active ERP Software Installed',1,6,'2002-11-11 21:28:22','2002-09-03 21:25:03',NULL,NULL),(130,'OS Suite ERP Software','NOLA_ENABLE','1','OS Suite ERP System is running',1,6,'2002-11-11 21:29:16','2002-08-04 22:00:27',NULL,NULL),(204,'Per Item shipping cost','SHIPPING_ITEM_COST','2.50','How much will be charged for each item ordered?',7,8,'2003-07-18 20:11:28','2003-07-18 20:11:28',NULL,NULL),(120,'Store Address State','STORE_ADDRESS_STATE','New York','Store address state',1,5,'2003-12-19 16:59:53','2002-03-20 19:18:11','',NULL),(145,'Allow Credit Card','PAYMENT_SUPPORT_CC','1','Do you want to accept credit card payments?',6,2,'2003-10-17 13:48:24','2002-10-16 23:40:16','',NULL),(113,'Store PayPal Email','STORE_PAYPAL_EMAIL','admin1@noguska.com','PayPal Email account for this store',1,4,'2003-09-18 18:25:47','2002-03-19 15:45:35','',NULL),(206,'Enable Self Pickup','SHIPPING_SELFPICKUP_ENABLED','1','Do you want to offer self-pickup option ?',7,5,'2003-10-17 18:13:58','2003-07-18 20:11:34',NULL,NULL),(159,'Enable FedEx Shipping','SHIPPING_FEDEX_ENABLED','1','Do you want to offer Federal Express (FedEx) shipping?',7,10,'2002-11-21 14:28:01','2002-11-21 14:28:01',NULL,NULL),(127,'Active ERP ID','ACTIVE_COMPANY','1','Active ERP Company for Accounting Purpose',1,6,'2002-11-11 21:30:26','2002-07-24 23:11:51',NULL,NULL),(218,'Enable UPS Shipping','SHIPPING_UPS_ENABLED','1','Do you want to offer UPS shipping?',7,9,'2003-10-05 18:58:39','2003-10-05 18:58:39',NULL,NULL),(151,'Default Price Level','DEFAULT_PRICE_LEVEL','1','Default Price Level for Non-Login Customer',1,6,'2003-11-26 13:41:53','2002-11-10 19:22:11','tep_get_price_level',NULL),(152,'Login Required','LOGIN_REQUIRE','0','Required for customer to Login for browsing products',1,9,'2003-10-17 18:13:25','2002-11-10 19:33:53','',NULL),(222,'Allow PayPal','PAYMENT_SUPPORT_PAYPAL','1','Do you want to accept PayPal payments?',6,3,'2003-12-17 21:33:27','2003-12-17 21:33:27',NULL,NULL),(155,'Sale GL Account','SALE_GL_ACCOUNT','12','Sale General Ledger Account',1,8,'2002-11-10 23:44:24','2002-11-10 23:26:33','tep_get_saleglaccount_id',NULL),(156,'Invoice Term','INVOICE_TERM','1','Default Invoice Term',1,8,'2002-11-10 23:28:03','2002-11-10 23:28:03','tep_get_invoiceterm_id',NULL),(157,'Sale Rep','DEFAULT_SALE_REP','1','Default Sale Rep',1,8,'2002-11-10 23:29:18','2002-11-10 23:29:18','tep_get_saleman_id',NULL),(207,'Self Pick Up Cost','SHIPPING_SELFPICKUP_COST','0.00','What is the Shipping cost? The Handling fee will also be added.',7,6,'2003-12-22 16:01:50','2003-07-18 20:11:34','',NULL),(211,'Flat Cost','SHIPPING_FLAT_COST','5.00','What is the Shipping cost? The Handling fee will also be added.',7,6,'2003-07-18 20:11:38','2003-07-18 20:11:38',NULL,NULL),(210,'Enable Flat Shipping','SHIPPING_FLAT_ENABLED','1','Do you want to offer flat rate shipping?',7,5,'2003-07-18 20:11:38','2003-07-18 20:11:38',NULL,NULL),(223,'PayPal ID','PAYPAL_ID','you@yourbuisness.com','Your buisness ID at PayPal.  Usually the email address you signed up with.  You can create a free PayPal account at http://www.paypal.com.',6,4,'2003-12-17 21:33:27','2003-12-17 21:33:27',NULL,NULL),(221,'','FONT_STYLE_NAVIGATION_BOX_HEADING','<font face=\"Verdana, Arial\" size=\"1\" color=\"#000000\">','',0,NULL,'2003-12-09 23:12:20','0000-00-00 00:00:00',NULL,NULL),(225,'Allow Cash On Delivery (COD)','PAYMENT_SUPPORT_COD','1','Do you want to accept COD (Cash On Delevery) payments?',6,1,'2003-12-22 15:58:13','2003-12-22 15:58:13',NULL,NULL),(226,'Store Address Zip','STORE_ADDRESS_ZIP','44830','Store address zip',1,6,'2004-06-25 18:40:45','2004-06-25 18:40:45','',''),(227,'Default Inventory Location','DEFAULT_INVENTORYLOCATION','1','Default inventory location ID from which to ship products',1,6,'2004-06-25 18:56:27','2004-06-25 18:56:27','',''),(228,'Enable SSL','ENABLE_SSL','0','Whether to use SSL for order checkout.',1,6,'2005-02-28 20:44:03','0000-00-00 00:00:00',NULL,NULL),(229,'Display Email Option When Out of Stock (0=disable; 1=enable)','PRODUCT_LIST_EMAIL_OOS','1','Do you want to show the option to email customers when an item is out of stock?',8,10,'2006-04-24 15:19:48','0000-00-00 00:00:00','',NULL),(230,'Enable USPS Shipping','SHIPPING_USPS_ENABLED','0','Do you want to offer USPS shipping?',7,10,'2007-03-29 13:29:55','2005-08-02 19:26:18',NULL,NULL);
/*!40000 ALTER TABLE `configuration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `configuration_group`
--

DROP TABLE IF EXISTS `configuration_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `configuration_group` (
  `configuration_group_id` int(5) NOT NULL auto_increment,
  `configuration_group_title` varchar(64) NOT NULL default '',
  `configuration_group_description` varchar(255) NOT NULL default '',
  `sort_order` int(5) default NULL,
  PRIMARY KEY  (`configuration_group_id`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `configuration_group`
--

LOCK TABLES `configuration_group` WRITE;
/*!40000 ALTER TABLE `configuration_group` DISABLE KEYS */;
INSERT INTO `configuration_group` VALUES (1,'My Store','General information about my store',1),(2,'Minimum Values','The minimum values for functions / data',2),(3,'Maximum Values','The maximum values for functions / data',3),(6,'Payment Options','Payment options available at my store',6),(7,'Shipping Options','Shipping options available at my store',7),(8,'Product Listing','Product Listingconfiguration options',8);
/*!40000 ALTER TABLE `configuration_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `constructionproject_details`
--

DROP TABLE IF EXISTS `constructionproject_details`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `constructionproject_details` (
  `id` int(11) NOT NULL auto_increment,
  `siteid` int(11) NOT NULL default '0',
  `deal` text,
  `estimated_ground_breaking` date default NULL,
  `land_and_entitlements` text,
  `lande_contacts` text,
  `lande_permits` text,
  `lande_other` text,
  `improvements_description` text,
  `improvements_building_plans` text,
  `improvements_phases` text,
  `improvements_quotes` text,
  `feasibility_mktresearch` text,
  `feasibility_mktplans` text,
  `status` int(5) NOT NULL default '0',
  `address` text,
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `client` varchar(255) NOT NULL default '',
  `projectcode` varchar(20) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `siteid` (`siteid`),
  KEY `cancel` (`cancel`),
  KEY `status` (`status`),
  KEY `projectcode` (`projectcode`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `constructionproject_details`
--

LOCK TABLES `constructionproject_details` WRITE;
/*!40000 ALTER TABLE `constructionproject_details` DISABLE KEYS */;
/*!40000 ALTER TABLE `constructionproject_details` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `constructionproject_details_phase`
--

DROP TABLE IF EXISTS `constructionproject_details_phase`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `constructionproject_details_phase` (
  `id` int(11) NOT NULL auto_increment,
  `project_detailid` int(11) NOT NULL default '0',
  `phasenumber` int(5) NOT NULL default '1',
  `fairmarketvalue` decimal(19,5) NOT NULL default '0.00000',
  `financialrequest` decimal(19,5) NOT NULL default '0.00000',
  `cost_engineering` decimal(19,5) NOT NULL default '0.00000',
  `cost_closing` decimal(19,5) NOT NULL default '0.00000',
  `cost_marketing` decimal(19,5) NOT NULL default '0.00000',
  `cost_general` decimal(19,5) NOT NULL default '0.00000',
  `cost_furniture` decimal(19,5) NOT NULL default '0.00000',
  `cost_excavation` decimal(19,5) NOT NULL default '0.00000',
  `cost_construction_main` decimal(19,5) NOT NULL default '0.00000',
  `cost_construction_amenities` decimal(19,5) NOT NULL default '0.00000',
  `date_estimate` date default NULL,
  `status` int(5) NOT NULL default '0',
  `inflow_gfd` decimal(19,5) NOT NULL default '0.00000',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `estimate_startdate` date default NULL,
  `estimated_enddate` date default NULL,
  `inflow_client` decimal(19,5) default NULL,
  `inflow_rex` decimal(19,5) NOT NULL default '0.00000',
  `outflow_client` decimal(19,5) default NULL,
  `outflow_gfd` decimal(19,5) NOT NULL default '0.00000',
  `cost_interest` decimal(19,5) NOT NULL default '0.00000',
  `cost_architectural` decimal(19,5) NOT NULL default '0.00000',
  `cost_permits` decimal(19,5) NOT NULL default '0.00000',
  `outflow_rex` decimal(19,5) NOT NULL default '0.00000',
  `cost_siteandgeneral` decimal(19,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`),
  KEY `project_detailid` (`project_detailid`),
  KEY `phasenumber` (`phasenumber`),
  KEY `status` (`status`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `constructionproject_details_phase`
--

LOCK TABLES `constructionproject_details_phase` WRITE;
/*!40000 ALTER TABLE `constructionproject_details_phase` DISABLE KEYS */;
/*!40000 ALTER TABLE `constructionproject_details_phase` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contactaddress`
--

DROP TABLE IF EXISTS `contactaddress`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contactaddress` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `contactnameid` int(10) unsigned NOT NULL default '0',
  `tablename` varchar(100) NOT NULL default '',
  `tablerecordid` int(10) unsigned NOT NULL default '0',
  `companyid` int(10) unsigned NOT NULL default '0',
  `entryuserid` int(10) unsigned NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `address1` varchar(200) NOT NULL default '',
  `address2` varchar(200) NOT NULL default '',
  `mailstop` varchar(20) NOT NULL default '',
  `city` varchar(100) NOT NULL default '',
  `state` varchar(50) NOT NULL default '',
  `zip` varchar(15) NOT NULL default '',
  `country` varchar(100) NOT NULL default '',
  `description` text NOT NULL,
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `tablerecordid` (`tablerecordid`),
  KEY `tablename` (`tablename`),
  KEY `contactnameid` (`contactnameid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contactaddress`
--

LOCK TABLES `contactaddress` WRITE;
/*!40000 ALTER TABLE `contactaddress` DISABLE KEYS */;
/*!40000 ALTER TABLE `contactaddress` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contactemail`
--

DROP TABLE IF EXISTS `contactemail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contactemail` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `contactnameid` int(10) unsigned NOT NULL default '0',
  `tablename` varchar(100) NOT NULL default '',
  `tablerecordid` int(10) unsigned NOT NULL default '0',
  `companyid` int(10) unsigned NOT NULL default '0',
  `entryuserid` int(10) unsigned NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `email` varchar(100) NOT NULL default '',
  `description` text NOT NULL,
  `cancel` int(11) NOT NULL default '0',
  `sendstatements` tinyint(1) NOT NULL default '0',
  `sendprelim` tinyint(1) NOT NULL default '0',
  `sendinvoices` tinyint(1) NOT NULL default '0',
  `sendconfs` tinyint(1) NOT NULL default '0',
  `sendquotes` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `tablerecordid` (`tablerecordid`),
  KEY `tablename` (`tablename`),
  KEY `contactnameid` (`contactnameid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contactemail`
--

LOCK TABLES `contactemail` WRITE;
/*!40000 ALTER TABLE `contactemail` DISABLE KEYS */;
/*!40000 ALTER TABLE `contactemail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contactname`
--

DROP TABLE IF EXISTS `contactname`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contactname` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `tablename` varchar(100) NOT NULL default '',
  `tablerecordid` int(10) unsigned NOT NULL default '0',
  `companyid` int(10) unsigned NOT NULL default '0',
  `entryuserid` int(10) unsigned NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `firstname` varchar(100) NOT NULL default '',
  `lastname` varchar(100) NOT NULL default '',
  `description` text NOT NULL,
  `cancel` int(11) NOT NULL default '0',
  `taskstatusid` int(11) NOT NULL default '0',
  `authorizedbuyer` tinyint(1) NOT NULL default '0',
  `inactive` tinyint(4) default '0',
  PRIMARY KEY  (`id`),
  KEY `tablerecordid` (`tablerecordid`),
  KEY `tablename` (`tablename`),
  KEY `taskstatusid` (`taskstatusid`),
  KEY `firstname` (`firstname`),
  KEY `lastname` (`lastname`),
  KEY `cancel` (`cancel`),
  KEY `companyid` (`companyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contactname`
--

LOCK TABLES `contactname` WRITE;
/*!40000 ALTER TABLE `contactname` DISABLE KEYS */;
/*!40000 ALTER TABLE `contactname` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contactphone`
--

DROP TABLE IF EXISTS `contactphone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contactphone` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `contactnameid` int(10) unsigned NOT NULL default '0',
  `tablename` varchar(100) NOT NULL default '',
  `tablerecordid` int(10) unsigned NOT NULL default '0',
  `companyid` int(10) unsigned NOT NULL default '0',
  `entryuserid` int(10) unsigned NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `phone` varchar(100) NOT NULL default '',
  `description` text NOT NULL,
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `tablerecordid` (`tablerecordid`),
  KEY `tablename` (`tablename`),
  KEY `contactnameid` (`contactnameid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contactphone`
--

LOCK TABLES `contactphone` WRITE;
/*!40000 ALTER TABLE `contactphone` DISABLE KEYS */;
/*!40000 ALTER TABLE `contactphone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `costcode`
--

DROP TABLE IF EXISTS `costcode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `costcode` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(20) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `blocksales` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `costcode`
--

LOCK TABLES `costcode` WRITE;
/*!40000 ALTER TABLE `costcode` DISABLE KEYS */;
/*!40000 ALTER TABLE `costcode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `counter`
--

DROP TABLE IF EXISTS `counter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `counter` (
  `startdate` char(8) default NULL,
  `counter` int(12) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `counter`
--

LOCK TABLES `counter` WRITE;
/*!40000 ALTER TABLE `counter` DISABLE KEYS */;
/*!40000 ALTER TABLE `counter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `counter_history`
--

DROP TABLE IF EXISTS `counter_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `counter_history` (
  `month` char(8) default NULL,
  `counter` int(12) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `counter_history`
--

LOCK TABLES `counter_history` WRITE;
/*!40000 ALTER TABLE `counter_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `counter_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `countries`
--

DROP TABLE IF EXISTS `countries`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `countries` (
  `countries_id` int(5) NOT NULL auto_increment,
  `countries_name` varchar(64) NOT NULL default '',
  `countries_iso_code_2` char(2) NOT NULL default '',
  `countries_iso_code_3` char(3) NOT NULL default '',
  `calling_code` char(3) NOT NULL default '',
  `address_format_id` int(5) NOT NULL default '0',
  `langs` tinytext,
  `states` text,
  `continent` varchar(2) NOT NULL default '',
  `decimalplaces` tinyint(4) NOT NULL default '2',
  `unitprice_decimalplaces` tinyint(4) NOT NULL default '2',
  `currency_symbol` varchar(6) NOT NULL default '$',
  `character_encoding` varchar(12) NOT NULL default 'ISO-8859-1',
  `thousandssymbol` varchar(6) NOT NULL default ',',
  `decimalsymbol` varchar(6) NOT NULL default '.',
  `symbolafter` varchar(6) NOT NULL default '',
  `temp` varchar(1) NOT NULL default 'F',
  PRIMARY KEY  (`countries_id`),
  KEY `IDX_COUNTRIES_NAME` (`countries_name`)
) ENGINE=MyISAM AUTO_INCREMENT=276 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `countries`
--

LOCK TABLES `countries` WRITE;
/*!40000 ALTER TABLE `countries` DISABLE KEYS */;
INSERT INTO `countries` VALUES (240,'Afghanistan','AF','AFG','93',0,'pr,dr','Badakhshan,Badghis Province,Farah,Faryab Province,Herat Province,Kabul,Kunduz Province,Or?zg?n Province,Paktia Province,Vel?yat-e [provisional] Khowst,Vel?yat-e [provisional] N?rest?n,Vel?yat-e Baghl?n,Vel?yat-e Balkh,Vel?yat-e B?m??n,Vel?yat-e Ghazn?,Vel?yat-e Ghowr,Vel?yat-e Helmand,Vel?yat-e Jowzj?n,Vel?yat-e Kandah?r,Vel?yat-e K?p?s?,Vel?yat-e Konar,Vel?yat-e Laghm?n,Vel?yat-e Lowgar,Vel?yat-e Nangarh?r,Vel?yat-e N?mr?z,Vel?yat-e Pakt?k?,Vel?yat-e Parv?n,Vel?yat-e Samang?n,Vel?yat-e Sar-e Pol,Vel?yat-e Takh?r,Vel?yat-e Vardak,Zabul Province','AS',2,2,'','','','','',''),(2,'Albania','AL','ALB','355',1,'el','Qarku i Beratit,Qarku i Dibrës,Qarku i Durrësit,Qarku i Elbasanit,Qarku i Fierit,Qarku i Gjirokastrës,Qarku i Korçës,Qarku i Kukësit,Qarku i Lezhës,Qarku i Shkodrës,Qarku i Tiranës,Qarku i Vlorës','EU',2,2,'','','','','',''),(3,'Algeria','DZ','DZA','213',1,'ar,fr','Wilaya d\' Adrar,Wilaya d\' Alger,Wilaya d\' Annaba,Wilaya d\' El Bayadh,Wilaya d\' El Oued,Wilaya d\' El Tarf,Wilaya d\' Illizi,Wilaya d\' Oran,Wilaya d\' Oum el Bouaghi,Wilaya de Aïn Defla,Wilaya de Aïn Temouchent,Wilaya de Batna,Wilaya de Béchar,Wilaya de Bejaïa,Wilaya de Biskra,Wilaya de Blida,Wilaya de Bordj Bou Arréridj,Wilaya de Bouira,Wilaya de Boumerdes,Wilaya de Chlef,Wilaya de Constantine,Wilaya de Djelfa,Wilaya de Ghardaïa,Wilaya de Guelma,Wilaya de Jijel,Wilaya de Khenchela,Wilaya de Laghouat,Wilaya de Mascara,Wilaya de Médéa,Wilaya de Mila,Wilaya de Mostaganem,Wilaya de M\'Sila,Wilaya de Naama,Wilaya de Ouargla,Wilaya de Relizane,Wilaya de Saïda,Wilaya de Sétif,Wilaya de Sidi Bel Abbès,Wilaya de Skikda,Wilaya de Souk Ahras,Wilaya de Tamanghasset,Wilaya de Tébessa,Wilaya de Tiaret,Wilaya de Tindouf,Wilaya de Tipaza,Wilaya de Tissemsilt,Wilaya de Tizi Ouzou,Wilaya de Tlemcen','AF',2,2,'','','','','',''),(5,'Andorra','AD','AND','376',1,'fr,pt','Parròquia d\'Andorra la Vella,Parròquia de Canillo,Parròquia de la Massana,Parròquia de Sant Julià de Lòria,Parròquia d\'Encamp,Parròquia d\'Escaldes-Engordany,Parròquia d\'Ordino','EU',2,2,'','','','','',''),(6,'Angola','AO','AGO','244',1,'pt','Província da Huíla,Província da Lunda Norte,Província da Lunda Sul,Província de Benguela,Província de Cabinda,Província de Luanda,Província de Malanje,Província de Namibe,Província do Bengo,Província do Bié,Província do Cuando Cubango,Província do Cuanza Norte,Província do Cuanza Sul,Província do Cunene,Província do Huambo,Província do Moxico,Província do Uíge,Província do Zaire','AF',2,2,'','','','','',''),(9,'Antigua and Barbuda','AG','ATG','1',1,'en','Barbuda,Parish of Saint George,Parish of Saint John,Parish of Saint Mary,Parish of Saint Paul,Parish of Saint Peter,Parish of Saint Philip','NA',2,2,'','','','','',''),(10,'Argentina','AR','ARG','54',1,'es,en,it,de,fr','Distrito Federal,Provincia de Buenos Aires,Provincia de Catamarca,Provincia de Córdoba,Provincia de Corrientes,Provincia de Entre Ríos,Provincia de Formosa,Provincia de Jujuy,Provincia de La Pampa,Provincia de La Rioja,Provincia de Mendoza,Provincia de Misiones,Provincia de Río Negro,Provincia de Salta,Provincia de San Juan,Provincia de San Luis,Provincia de Santa Cruz,Provincia de Santa Fe,Provincia de Santiago del Estero,Provincia de Tucumán,Provincia del Chaco,Provincia del Chubut,Provincia del Neuquén','SA',2,2,'','','','','',''),(11,'Armenia','AM','ARM','374',1,'ru','Aragatsotni Marz,Ararati Marz,Armaviri Marz,Geghark\'unik\'i Marz,K\'aghak\' Yerevan,Kotayk\'i Marz,Lorru Marz,Shiraki Marz,Syunik\'i Marz,Tavushi Marz,Vayots\' Dzori Marz','AS',2,2,'','','','','',''),(13,'Australia','AU','AUS','61',1,'en','Australian Capital Territory,New South Wales,Northern Territory,Queensland,South Australia,Tasmania,Victoria,Western Australia','OC',2,2,'','','','','',''),(14,'Austria','AT','AUT','43',1,'en','Burgenland,Carinthia,Lower Austria,Salzburg,Styria,Tyrol,Upper Austria,Vienna,Vorarlberg','EU',2,2,'','','','','',''),(15,'Azerbaijan','AZ','AZE','994',1,'ru','Ab?eron Rayonu,A?cab?di Rayonu,A?dam Rayonu,A?da? Rayonu,A?stafa Rayonu,A?su Rayonu,Astara Rayonu,Bak? ?ähäri,Balak?n Rayonu,B?rd? Rayonu,Beyl?qan Rayonu,Bil?suvar Rayonu,C?bray?l Rayonu,C?lilabad Rayonu,Da?k?s?n Rayonu,D?v?çi Rayonu,?li Bayraml? ??h?ri,Füzuli Rayonu,G?d?b?y Rayonu,G?nc? ??h?ri,Goranboy Rayonu,Göyçay Rayonu,Hac?qabul Rayonu,?mi?li Rayonu,?smay?ll? Rayonu,K?lb?c?r Rayonu,Kürd?mir Rayonu,Laç?n Rayonu,L?nk?ran Rayonu,L?nk?ran ??h?ri,Lerik Rayonu,Masall? Rayonu,Ming?cevir ??h?ri,Naftalan ??h?ri,Nakhichevan,Neftçala Rayonu,O?uz Rayonu,Qax Rayonu,Qazax Rayonu,Q?b?l? Rayonu,Qobustan Rayonu,Quba Rayonu,Qubadl? Rayonu,Qusar Rayonu,Saatl? Rayonu,Sabirabad Rayonu,Salyan Rayonu,?amax? Rayonu,Samux Rayonu,??ki Rayonu,??ki ??h?ri,??mkir Rayonu,Siy?z?n Rayonu,Sumqay?t ??h?ri,?u?a Rayonu,?u?a ??h?ri,T?rt?r Rayonu,Tovuz Rayonu,Ucar Rayonu,Xaçmaz Rayonu,Xank?ndi ??h?ri,Xanlar Rayonu,X?z? Rayonu,Xocal? Rayonu,Xocav?nd Rayonu,Yard?ml? Rayonu,Yevlax Rayonu,Yevlax ??h?ri,Zaqatala Rayonu,Z?ngilan Rayonu,Z?rdab Rayonu','AS',2,2,'','','','','',''),(16,'Bahamas','BS','BHS','1',1,'en','Acklins and Crooked Islands District,Bimini District,Cat Island District,Exuma District,Freeport District,Fresh Creek District,Governor\'s Harbour District,Green Turtle Cay District,Harbour Island District,High Rock District,Inagua District,Kemps Bay District,Long Island District,Marsh Harbour District,Mayaguana District,New Providence District,Nichollstown and Berry Islands District,Ragged Island District,Rock Sound District,San Salvador and Rum Cay District,Sandy Point District','NA',2,2,'','','','','',''),(17,'Bahrain','BH','BHR','973',1,'ar,en,ur','Ar Rifa’ and Southern Region,Central Region,Hamad town,Hawar Islands,Hedd,Isa Town,Jidd Haffs,Manama,Muharraq,Northern Region,Sitra,Western Region','AS',3,3,'','','','','',''),(18,'Bangladesh','BD','BGD','880',1,'en','Borishal,Chittagong,Dhaka Division,Khulna Division,R?jsh?hi Division,Sylhet Division','AS',2,2,'','','','','',''),(19,'Barbados','BB','BRB','1',1,'en','Christ Church,Saint Andrew,Saint George,Saint James,Saint John,Saint Joseph,Saint Lucy,Saint Michael,Saint Peter,Saint Philip,Saint Thomas','NA',2,2,'','','','','',''),(20,'Belarus','BY','BLR','375',1,'ru','Brestskaya Voblasts\',Homyel\'skaya Voblasts\',Horad Minsk,Hrodzyenskaya Voblasts\',Mahilyowskaya Voblasts\',Minskaya Voblasts\',Vitsyebskaya Voblasts\'','EU',2,2,'','','','','',''),(21,'Belgium','BE','BEL','32',1,'nl,fr','Flanders,Région de Bruxelles-Capitale,Wallonia','EU',2,2,'','','','','',''),(22,'Belize','BZ','BLZ','501',1,'en,es','Belize District,Cayo District,Corozal District,Orange Walk District,Stann Creek District,Toledo District','NA',2,2,'','','','','',''),(23,'Benin','BJ','BEN','229',1,'fr','Département de l\' Alibori,Département de l\' Atakora,Département de l\' Atlantique,Département de l\' Ouémé,Département de la Donga,Département du Borgou,Département du Collines,Département du Kouffo,Département du Littoral,Département du Mono,Département du Plateau,Département du Zou','AF',2,2,'','','','','',''),(25,'Bhutan','BT','BTN','975',1,'en,zh,th','Bumthang Dzongkhag,Chhukha Dzongkhag,Chirang Dzongkhag,Daga Dzongkhag,Gasa District,Geylegphug Dzongkhag,Ha Dzongkhag,Lhuntshi Dzongkhag,Mongar Dzongkhag,Paro District,Pemagatsel Dzongkhag,Punakha Dzongkhag,Samchi Dzongkhag,Samdrup Jongkhar District,Shemgang Dzongkhag,Tashigang Dzongkhag,Thimphu Dzongkhag,Tongsa Dzongkhag,Wangdi Phodrang Dzongkhag','AS',2,2,'','','','','',''),(26,'Bolivia','BO','BOL','591',1,'es','Departamento de Chuquisaca,Departamento de Cochabamba,Departamento de La Paz,Departamento de Oruro,Departamento de Pando,Departamento de Potosí,Departamento de Santa Cruz,Departamento de Tarija,Departamento del Beni','SA',2,2,'','','','','',''),(27,'Bosnia and Herzegovina','BA','BIH','387',1,'sr,en','Federation of Bosnia and Herzegovina,Republika Srpska','EU',2,2,'','','','','',''),(28,'Botswana','BW','BWA','267',1,'en','Central District,Chobe District,Ghanzi District,Kgalagadi District,Kgatleng District,Kweneng District,North East District,North West District,South East District,Southern District','AF',2,2,'','','','','',''),(30,'Brazil','BR','BRA','55',1,'pt,es,en,fr','Distrito Federal,Estado da Bahia,Estado da Paraíba,Estado de Alagoas,Estado de Espírito Santo,Estado de Goiás,Estado de Mato Grosso,Estado de Mato Grosso do Sul,Estado de Minas Gerais,Estado de Pernambuco,Estado de Rondônia,Estado de Roraima,Estado de Santa Catarina,Estado de São Paulo,Estado de Sergipe,Estado de Tocantins,Estado do Acre,Estado do Amapá,Estado do Amazonas,Estado do Ceará,Estado do Maranhão,Estado do Pará,Estado do Parana,Estado do Piauí,Estado do Rio de Janeiro,Estado do Rio Grande do Norte,Estado do Rio Grande do Sul','SA',2,2,'','','','','',''),(32,'Brunei Darussalam','BN','BRN','673',1,'ms','Belait District,Brunei and Muara District,Temburong District,Tutong District','AS',2,2,'','','','','',''),(33,'Bulgaria','BG','BGR','359',1,'bg,tr','Oblast Blagoevgrad,Oblast Burgas,Oblast Dobrich,Oblast Gabrovo,Oblast Khaskovo,Oblast K?rdzhali,Oblast Kyustendil,Oblast Lovech,Oblast Montana,Oblast Pazardzhik,Oblast Pernik,Oblast Pleven,Oblast Plovdiv,Oblast Razgrad,Oblast Ruse,Oblast Shumen,Oblast Silistra,Oblast Sliven,Oblast Smolyan,Oblast Sofiya,Oblast Sofiya-Grad,Oblast Stara Zagora,Oblast T?rgovishte,Oblast Varna,Oblast Veliko T?rnovo,Oblast Vidin,Oblast Vratsa,Oblast Yambol','EU',2,2,'','','','','',''),(34,'Burkina Faso','BF','BFA','226',1,'fr','Kadiogo,Province d\' Oubritenga,Province de l\' Oudalan,Province de la Bougouriba,Province de la Comoé,Province de la Gnagna,Province de la Komondjari,Province de la Kompienga,Province de la Kossi,Province de la Léraba,Province de la Sissili,Province de la Tapoa,Province des Balé,Province des Banwa,Province du Bam,Province du Bazèga,Province du Boulgou,Province du Boulkiemdé,Province du Ganzourgou,Province du Gourma,Province du Houet,Province du Ioba,Province du Kénédougou,Province du Koulpélogo,Province du Kouritenga,Province du Kourwéogo,Province du Loroum,Province du Mouhoun,Province du Nahouri,Province du Namentenga,Province du Nayala,Province du Noumbiel,Province du Passore,Province du Poni,Province du Sanguié,Province du Sanmatenga,Province du Séno,Province du Soum,Province du Sourou,Province du Tuy,Province du Yagha,Province du Yatenga,Province du Ziro,Province du Zondoma,Province du Zoundwéogo','AF',2,2,'','','','','',''),(35,'Burundi','BI','BDI','257',1,'fr','iProvense ya Bubanza,iProvense ya Bujumbura,iProvense ya Bururi,iProvense ya Cibitoke,iProvense ya Gitega,iProvense ya Karuzi,iProvense ya Kayanza,iProvense ya Kirundo,iProvense ya Muramvya,iProvense ya Muyinga,iProvense ya Mwaro,iProvense ya Rutana,Province de Cankuzo,Province de Makamba,Province de Ngozi,Province de Ruyigi','AF',2,2,'','','','','',''),(36,'Cambodia','KH','KHM','855',1,'fr,en','Khêt Si?mréab-?târ Méanchey,Khétt Bântéay Méan Che?y,Khétt B?tdâmbâng,Khétt Kâmpóng Cham,Khétt Kâmpóng Chhn?ng,Khétt Kâmpóng Spœ,Khétt Kâmpóng Thum,Khétt Kâmpôt,Khétt Kândal,Khétt Kaôh K?ng,Khétt Krâchéh,Khétt Môndôl Kiri,Khétt Po?th?s?t,Khétt Pre?h V?héar,Khétt Prey Vêng,Khétt Rôtân?h Kiri,Khétt Si?m Réab,Khétt Stœ?ng Trêng,Khétt Svay Ri?ng,Khétt Takêv,Kr?ng Phnum Pénh,Kr?ng Pre?h Seihân?','AS',2,2,'','','','','',''),(37,'Cameroon','CM','CMR','237',1,'fr','Adamaoua Province,Centre Province,East Province,Far North Province,Littoral Province,North Province,North-West Province,South Province,South-West Province,West Province','AF',2,2,'','','','','',''),(38,'Canada','CA','CAN','1',1,'en,fr','AB:Alberta,BC:British Columbia,MB:Manitoba,NB:New Brunswick,NL:Newfoundland and Labrador,NT:Northwest Territories,NS:Nova Scotia,NU:Nunavut,ON:Ontario,PE:Prince Edward Island,QC:Quebec,SK:Saskatchewan,YT:Yukon Territory','NA',2,2,'','','','','',''),(39,'Cape Verde','CV','CPV','238',1,'pt','Concelho da Boa Vista,Concelho da Brava,Concelho da Praia,Concelho da Ribeira Grande,Concelho de Santa Catarina,Concelho de Santa Cruz,Concelho de São Domingos,Concelho de São Filipe,Concelho de São Miguel,Concelho de São Nicolau,Concelho de São Vicente,Concelho do Maio,Concelho do Paul,Concelho do Sal,Concelho do Tarrafal,Concelho dos Mosteiros','AF',2,2,'','','','','',''),(41,'Central African Republic','CF','CAF','236',1,'fr','Commune de Bangui,Préfecture de l\' Ombella-Mpoko,Préfecture de l\' Ouham,Préfecture de l\' Ouham-Pendé,Préfecture de la Bamingui-Bangoran,Préfecture de la Basse-Kotto,Préfecture de la Haute-Kotto,Préfecture de la Kémo,Préfecture de la Lobaye,Préfecture de la Mambéré-Kadéï,Préfecture de la Nana-Grébizi,Préfecture de la Nana-Mambéré,Préfecture de la Ouaka,Préfecture de la Sangha-Mbaéré,Préfecture de la Vakaga,Préfecture du Haut-Mbomou,Préfecture du Mbomou','AF',2,2,'','','','','',''),(42,'Chad','TD','TCD','235',1,'fr','Préfecture du Batha,Préfecture du Biltine,Préfecture du Borkou-Ennedi-Tibesti,Préfecture du Chari-Baguirmi,Préfecture du Guéra,Préfecture du Kanem,Préfecture du Lac,Préfecture du Logone Occidental,Préfecture du Logone Oriental,Préfecture du Mayo-Kébbi,Préfecture du Moyen-Chari,Préfecture du Ouaddaï,Préfecture du Salamat,Préfecture du Tandjilé','AF',2,2,'','','','','',''),(43,'Chile','CL','CHL','56',1,'es','Región Aisén del General Carlos Ibáñez del Campo,Región de Antofagasta,Región de Arica y Parinacota,Región de Atacama,Región de Coquimbo,Región de la Araucanía,Región de Los Lagos,Región de Los Ríos,Región de Magallanes y de la Antártica Chilena,Región de Tarapacá,Región de Valparaíso,Región del Biobío,Región del Libertador General Bernardo O\'Higgins,Región del Maule,Región Metropolitana de Santiago','SA',2,2,'','','','','',''),(44,'China','CN','CHN','86',1,'en,zh','Anhui Sheng,Beijing Shi,Chongqing Shi,Fujian,Gansu Sheng,Guangdong Sheng,Guangxi Zhuangzu Zizhiqu,Guizhou Sheng,Hainan Province,Hebei Sheng,Heilongjiang Sheng,Henan Sheng,Hubei,Hunan Province,Inner Mongolia Autonomous Region,Jiangsu Sheng,Jiangxi Sheng,Jilin Sheng,Liaoning Province,Ningxia Huizu Zizhiqu,Qinghai Sheng,Shaanxi Sheng,Shandong Sheng,Shanghai Shi,Shanxi Sheng,Sichuan Sheng,Tianjin Shi,Tibet Autonomous Region,Xinjiang Uygur Zizhiqu,Yunnan Province,Zhejiang Sheng','AS',2,2,'','','','','',''),(47,'Colombia','CO','COL','57',1,'es','Atlántico,Bogota D.C.,Cundinamarca,Departamento de Antioquia,Departamento de Arauca,Departamento de Bolívar,Departamento de Boyacá,Departamento de Caldas,Departamento de Casanare,Departamento de Córdoba,Departamento de La Guajira,Departamento de Nariño,Departamento de Norte de Santander,Departamento de Risaralda,Departamento de Santander,Departamento de Sucre,Departamento de Tolima,Departamento del Amazonas,Departamento del Caquetá,Departamento del Cauca,Departamento del Cesar,Departamento del Chocó,Departamento del Guainía,Departamento del Guaviare,Departamento del Huila,Departamento del Magdalena,Departamento del Meta,Departamento del Putumayo,Departamento del Quindío,Departamento del Valle del Cauca,Departamento del Vaupés,Departamento del Vichada','SA',2,2,'','','','','',''),(48,'Comoros','KM','COM','269',1,'ar,fr','Anjouan,Grande Comore,Mohéli','AF',2,2,'','','','','',''),(49,'Congo','CD','COD','242',1,'fr',' DEMOCRATIC REPUBLIC OF THE\", DEMOCRATIC REPUBLIC OF THE\", DEMOCRATIC REPUBLIC OF THE\", DEMOCRATIC REPUBLIC OF THE\", DEMOCRATIC REPUBLIC OF THE\", DEMOCRATIC REPUBLIC OF THE\", DEMOCRATIC REPUBLIC OF THE\", DEMOCRATIC REPUBLIC OF THE\", DEMOCRATIC REPUBLIC OF THE\", DEMOCRATIC REPUBLIC OF THE\", DEMOCRATIC REPUBLIC OF THE\", DEMOCRATIC REPUBLIC OF THE\"','AF',2,2,'','','','','',''),(51,'Costa Rica','CR','CRI','506',1,'es,en','Provincia de Alajuela,Provincia de Cartago,Provincia de Guanacaste,Provincia de Heredia,Provincia de Limón,Provincia de Puntarenas,Provincia de San José','NA',2,2,'','','','','',''),(52,'Cote D\'Ivoire','CI','CIV','225',1,'fr','Région de l\' Agnéby,Région de la Marahoué,Région de la Vallée du Bandama,Région des Dix-Huit Montagnes,Région des Lacs,Région des Lagunes,Région des Savanes,Région du Bafing,Région du Bas-Sassandra,Région du Denguélé,Région du Fromager,Région du Haut-Sassandra,Région du Moyen-Cavally,Région du Moyen-Comoé,Région du N\'zi-Comoé,Région du Sud-Bandama,Région du Sud-Comoé,Région du Worodougou,Région du Zanzan','AF',2,2,'','','','','',''),(53,'Croatia','HR','HRV','385',1,'en,ru','Bjelovarsko-Bilogorska Županija,Brodsko-Posavska Županija,Dubrova?ko-Neretvanska Županija,Grad Zagreb,Istarska Županija,Karlova?ka Županija,Koprivni?ko-Križeva?ka Županija,Krapinsko-Zagorska Županija,Li?ko-Senjska Županija,Me?imurska Županija,Osje?ko-Baranjska Županija,Požeško-Slavonska Županija,Primorsko-Goranska Županija,Šibensko-Kninska Županija,Sisa?ko-Moslava?ka Županija,Splitsko-Dalmatinska Županija,Varaždinska Županija,Viroviti?ko-Podravska Županija,Vukovarsko-Srijemska Županija,Zadarska Županija,Zagreba?ka Županija','EU',2,2,'','','','','',''),(54,'Cuba','CU','CUB','53',1,'es','Municipio Especial Isla de la Juventud,Provincia de Camagüey,Provincia de Ciego de Ávila,Provincia de Cienfuegos,Provincia de Ciudad de La Habana,Provincia de Guantánamo,Provincia de Holguín,Provincia de La Habana,Provincia de Matanzas,Provincia de Pinar del Río,Provincia de Sancti Spíritus,Provincia de Santiago de Cuba,Provincia de Villa Clara,Provincia Granma,pueto padre','NA',2,2,'','','','','',''),(55,'Cyprus','CY','CYP','357',1,'el','Famagusta District,Kyrenia District,Larnaca District,Limassol District,Nicosia District,Paphos District','AS',2,2,'','','','','',''),(56,'Czech Republic','CZ','CZE','420',1,'ru,de,fr,it,es','Hlavní m?sto Praha,Jiho?eský Kraj,Karlovarský kraj,Kraj Vyso?ina,Královéhradecký kraj,Liberecký kraj,Moravskoslezský kraj,Olomoucký kraj,Pardubický kraj,Plze?ský kraj,South Moravian Region,St?edo?eský kraj,Ústecký kraj,Zlínský kraj','EU',2,2,'','','','','',''),(57,'Denmark','DK','DNK','45',1,'da','Capital Region,Central Jutland,North Jutland,South Denmark,Zealand','EU',2,2,'','','','','',''),(58,'Djibouti','DJ','DJI','253',1,'fr,ar','Région d\' Ali Sabieh,Région d\' Arta,Région d\' Obock,Région de Dikhil,Région de Tadjourah,Ville de Djibouti','AF',2,2,'','','','','',''),(59,'Dominica','DM','DMA','1',1,'en','Saint Andrew,Saint David,Saint George,Saint John,Saint Joseph,Saint Luke,Saint Mark,Saint Patrick,Saint Paul,Saint Peter','NA',2,2,'','','','','',''),(60,'Dominican Republic','DO','DOM','1',1,'es','Distrito Nacional,Provincia de Azua,Provincia de Baoruco,Provincia de Barahona,Provincia de Dajabón,Provincia de El Seíbo,Provincia de Elías Piña,Provincia de Hato Mayor,Provincia de Independencia,Provincia de La Altagracia,Provincia de La Romana,Provincia de La Vega,Provincia de Monseñor Nouel,Provincia de Monte Cristi,Provincia de Monte Plata,Provincia de Pedernales,Provincia de Peravia,Provincia de Puerto Plata,Provincia de Salcedo,Provincia de Samaná,Provincia de San Cristóbal,Provincia de San José de Ocoa,Provincia de San Juan,Provincia de San Pedro de Macorís,Provincia de Santiago,Provincia de Santiago Rodríguez,Provincia de Santo Domingo,Provincia de Valverde,Provincia Duarte,Provincia Espaillat,Provincia María Trinidad Sánchez,Provincia Sánchez Ramírez','NA',2,2,'','','','','',''),(61,'East Timor','TP','TMP','670',1,'pt','East Timor','AS',2,2,'','','','','',''),(62,'Ecuador','EC','ECU','593',1,'es','Provincia de Bolívar,Provincia de Cotopaxi,Provincia de El Oro,Provincia de Esmeraldas,Provincia de Francisco de Orellana,Provincia de Galápagos,Provincia de Imbabura,Provincia de Loja,Provincia de Los Ríos,Provincia de Manabí,Provincia de Morona Santiago,Provincia de Napo,Provincia de Pichincha,Provincia de Sucumbíos,Provincia de Zamora Chinchipe,Provincia del Azuay,Provincia del Cañar,Provincia del Carchi,Provincia del Chimborazo,Provincia del Guayas,Provincia del Pastaza,Provincia del Tungurahua','SA',2,2,'','','','','',''),(63,'Egypt','EG','EGY','20',1,'ar,en','Alexandria,Eastern Province,Mu??faz?at ad Daqahl?yah,Mu??faz?at al Ba?r al A?mar,Mu??faz?at al Bu?ayrah,Mu??faz?at al Fayy?m,Mu??faz?at al Gharb?yah,Mu??faz?at al Ism?`?l?yah,Mu??faz?at al J?zah,Mu??faz?at al Min?f?yah,Mu??faz?at al Miny?,Mu??faz?at al Q?hirah,Mu??faz?at al Qaly?b?yah,Mu??faz?at al W?d? al Jad?d,Mu??faz?at as Suways,Mu??faz?at Asw?n,Mu??faz?at Asy??,Mu??faz?at Ban? Suwayf,Mu??faz?at B?r Sa`?d,Mu??faz?at Dumy??,Mu??faz?at Jan?b S?n?\',Mu??faz?at Kafr ash Shaykh,Mu??faz?at Ma?r??,Mu??faz?at Qin?,Mu??faz?at Sham?l S?n?\',Mu??faz?at S?h?j','AF',2,2,'','','','','',''),(64,'El Salvador','SV','SLV','503',1,'es','Departamento de Ahuachapán,Departamento de Cabañas,Departamento de Chalatenango,Departamento de Cuscatlán,Departamento de La Libertad,Departamento de La Paz,Departamento de La Unión,Departamento de Morazán,Departamento de San Miguel,Departamento de San Salvador,Departamento de San Vicente,Departamento de Santa Ana,Departamento de Sonsonate,Departamento de Usulután','NA',2,2,'','','','','',''),(65,'Equatorial Guinea','GQ','GNQ','240',1,'es','Provincia de Annobón,Provincia de Bioko Norte,Provincia de Bioko Sur,Provincia de Centro Sur,Provincia de Kié-Ntem,Provincia de Litoral,Provincia de Wele-Nzas','AF',2,2,'','','','','',''),(66,'Eritrea','ER','ERI','291',1,'ar','Zoba ?nseba,Zoba Debub,Zoba Debubaw? K\'eyih Bahr?,Zoba Gash Barka,Zoba Ma\'?kel,Zoba Sem?naw? K\'eyih Bahr?','AF',2,2,'','','','','',''),(67,'Estonia','EE','EST','372',1,'et,ru','Harjumaa,Hiiumaa,Ida-Virumaa,Järvamaa,Jõgevamaa,Läänemaa,Lääne-Virumaa,Pärnumaa,Põlvamaa,Raplamaa,Saaremaa,Tartumaa,Valgamaa,Viljandimaa,Võrumaa','EU',2,2,'','','','','',''),(68,'Ethiopia','ET','ETH','251',1,'ar,en','?d?s ?beba ?stedader,?far Kilil,?mara Kilil,B?nshangul Gumuz Kilil,Dir? Dawa ?stedader,Gamb?la Hizboch Kilil,H?rer? Hizb Kilil,Orom?ya Kilil,Sumal? Kilil,Tigray Kilil,Welega Kifle H?ger,YeDebub Bih?roch Bih?reseboch na Hizboch Kilil','AF',2,2,'','','','','',''),(71,'Fiji','FJ','FJI','679',1,'en','Central,Eastern,Northern,Rotuma,Western','OC',2,2,'','','','','',''),(72,'Finland','FI','FIN','358',1,'fi','Åland,Åland ,Eastern Finland,Lapponia,Oulu,Southern Finland,Western Finland','EU',2,2,'','','','','',''),(73,'France','FR','FRA','33',1,'fr','Alsace,Aquitaine,Basse-Normandie,Bourgogne,Brittany,Champagne-Ardenne,Corsica,Franche-Comté,Haute-Normandie,Languedoc-Roussillon,Midi-Pyrénées,Picardie,Poitou-Charentes,Provence-Alpes-Côte d\'Azur,Région Auvergne,Région Centre,Région Île-de-France,Région Limousin,Région Lorraine,Région Nord-Pas-de-Calais,Région Pays de la Loire,Rhône-Alpes','EU',2,2,'','','','','',''),(78,'Gabon','GA','GAB','241',1,'fr','Province de l\' Estuaire,Province de l\' Ogooué-Ivindo,Province de l\' Ogooué-Lolo,Province de l\' Ogooué-Maritime,Province de la Ngounié,Province de la Nyanga,Province du Haut-Ogooué,Province du Moyen-Ogooué,Province du Woleu-Ntem','AF',2,2,'','','','','',''),(79,'Gambia','GM','GMB','220',1,'en','Central River Division,City of Banjul,Lower River Division,North Bank Division,Upper River,Western Division','AF',2,2,'','','','','',''),(80,'Georgia','GE','GEO','995',1,'ru','Abkhazia,Ajaria [provisional],Ch\'khorotsqus Raioni,K\'alak\'i T\'bilisi,Martvilis Raioni,Samegrelo and Zemo Svaneti,Zugdidis Raioni','AS',2,2,'','','','','',''),(81,'Germany','DE','DEU','49',1,'de','Baden-Württemberg,Bavaria,Brandenburg,Hamburg,Hesse,Land Berlin,Land Bremen,Lower Saxony,Mecklenburg-Vorpommern,North Rhine-Westphalia,Rhineland-Palatinate,Saarland,Saxony,Saxony-Anhalt,Schleswig-Holstein,Thuringia','EU',2,2,'','','','','',''),(82,'Ghana','GH','GHA','233',1,'en','Ashanti Region,Brong-Ahafo Region,Central Region,Eastern Region,Greater Accra Region,Northern Region,Upper East Region,Upper West Region,Volta Region,Western Region','AF',2,2,'','','','','',''),(84,'Greece','GR','GRC','30',1,'el,en,fr','Attica,Central Greece,Central Macedonia,Crete,East Macedonia and Thrace,Epirus,Ionian Islands,North Aegean,Peloponnese,South Aegean,Thessaly,West Greece,West Macedonia','EU',2,2,'','','','','',''),(86,'Grenada','GD','GRD','1',1,'en','Saint Andrew,Saint David,Saint George,Saint John,Saint Mark,Saint Patrick','NA',2,2,'','','','','',''),(89,'Guatemala','GT','GTM','502',1,'es','Departamento de Alta Verapaz,Departamento de Baja Verapaz,Departamento de Chimaltenango,Departamento de Chiquimula,Departamento de El Progreso,Departamento de Escuintla,Departamento de Guatemala,Departamento de Huehuetenango,Departamento de Izabal,Departamento de Jalapa,Departamento de Jutiapa,Departamento de Quetzaltenango,Departamento de Retalhuleu,Departamento de Sacatepéquez,Departamento de San Marcos,Departamento de Santa Rosa,Departamento de Sololá,Departamento de Suchitepéquez,Departamento de Totonicapán,Departamento de Zacapa,Departamento del Petén,Departamento del Quiché','NA',2,2,'','','','','',''),(90,'Guinea','GN','GIN','224',1,'fr','Capitale d\'État-Zone Spéciale de Conakry,Préfecture de Beyla,Préfecture de Boffa,Préfecture de Boké,Préfecture de Coyah,Préfecture de Dabola,Préfecture de Dalaba,Préfecture de Dinguiraye,Préfecture de Dubréka,Préfecture de Faranah,Préfecture de Forécariah,Préfecture de Fria,Préfecture de Gaoual,Préfecture de Guékédou,Préfecture de Kankan,Préfecture de Kérouané,Préfecture de Kindia,Préfecture de Kissidougou,Préfecture de Koubia,Préfecture de Koundara,Préfecture de Kouroussa,Préfecture de Labé,Préfecture de Lélouma,Préfecture de Lola,Préfecture de Macenta,Préfecture de Mali,Préfecture de Mamou,Préfecture de Mandiana,Préfecture de Nzérékoré,Préfecture de Pita,Préfecture de Siguiri,Préfecture de Télimélé,Préfecture de Tougué,Préfecture de Yomou','AF',2,2,'','','','','',''),(91,'Guinea-bissau','GW','GNB','245',1,'pt','Bafatá,Biombo,Bissau,Bolama,Cacheu,Gabú,Oio,Quinara,Tombali','AF',2,2,'','','','','',''),(92,'Guyana','GY','GUY','592',1,'en,hi,ur','Barima-Waini Region,Cuyuni-Mazaruni Region,Demerara-Mahaica Region,East Berbice-Corentyne Region,Essequibo Islands-West Demerara Region,Mahaica-Berbice Region,Pomeroon-Supenaam Region,Potaro-Siparuni Region,Upper Demerara-Berbice Region,Upper Takutu-Upper Essequibo Region','SA',2,2,'','','','','',''),(93,'Haiti','HT','HTI','509',1,'fr','Département de l\' Artibonite,Département de l\' Ouest,Département de la Grand\'Anse,Département du Centre,Département du Nord,Département du Nord-Est,Département du Nord-Ouest,Département du Sud,Département du Sud-Est','NA',2,2,'','','','','',''),(95,'Honduras','HN','HND','504',1,'es','Departamento de Atlántida,Departamento de Choluteca,Departamento de Colón,Departamento de Comayagua,Departamento de Copán,Departamento de Cortés,Departamento de El Paraíso,Departamento de Gracias a Dios,Departamento de Intibucá,Departamento de Islas de la Bahía,Departamento de Lempira,Departamento de Ocotepeque,Departamento de Olancho,Departamento de Santa Bárbara,Departamento de Valle,Departamento de Yoro,Departmento de Francisco Morazán,Departmento de La Paz','NA',2,2,'','','','','',''),(97,'Hungary','HU','HUN','36',1,'en,de,ro,ru,it,fr','Bács-Kiskun,Baranya megye,Békés megye,Borsod-Abaúj-Zemplén,Budapest f?város,Csongrád megye,Fejér,Gy?r-Moson-Sopron,Hajdú-Bihar,Heves megye,Jász-Nagykun-Szolnok,Komárom-Esztergom,Nógrád megye,Pest megye,Somogy megye,Szabolcs-Szatmár-Bereg,Tolna megye,Vas,Veszprém megye,Zala','EU',2,2,'','','','','',''),(98,'Iceland','IS','ISL','354',1,'en','Capital Region,East,Northeast,Northwest,South,Southern Peninsula,West,Westfjords','EU',2,2,'','','','','',''),(99,'India','IN','IND','91',1,'hi,en,ur',' Union Territory of Andaman and Nicobar Islands,Bengal,Bih?r State of,Daman and Diu,Goa,Him?chal Pradesh,Laccadives,State of Andhra Pradesh,State of Arun?chal Pradesh,State of Assam,State of Chhatt?sgarh,State of Gujar?t,State of Hary?na,State of Jammu and Kashm?r,State of Jharkhand,State of Karn?taka,State of Kerala,State of Madhya Pradesh,State of Mah?r?shtra,State of Manipur,State of Megh?laya,State of Mizoram,State of N?g?land,State of Orissa,State of Punjab,State of R?jasth?n,State of Sikkim,State of Tamil N?du,State of Tripura,State of Uttar Pradesh,Union Territory of Chand?garh,Union Territory of D?dra and Nagar Haveli,Union Territory of Delhi,Union Territory of Puducherry,Uttarakhand','AS',2,2,'','','','','',''),(100,'Indonesia','ID','IDN','62',1,'en,nl','Bangka-Belitung,Central Java,Central Sulawesi,Daerah Istimewa Aceh,Daerah Istimewa Yogyakarta,Daerah Khusus Ibukota Jakarta Raya,East Java,East Kalimantan,East Nusa Tenggara,Kotamadya Tegal,North Sulawesi,North Sumatra,Propinsi Bali,Propinsi Banten,Propinsi Bengkulu,Propinsi Jambi,Propinsi Kalimantan Tengah,Propinsi Lampung,Propinsi Maluku,Propinsi Maluku Utara,Propinsi Nusa Tenggara Barat,Propinsi Sulawesi Tenggara,Provinsi Gorontalo,Provinsi Irian Jaya Barat,Provinsi Papua,Provinsi Riau,Provinsi Sulawesi Barat,Riau Islands,South Kalimantan,South Sulawesi,South Sumatra,West Java,West Kalimantan,West Sumatra','AS',2,2,'','','','','',''),(101,'Iran','IR','IRN','98',1,'pr,pr,ar,tr',' ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\", ISLAMIC REPUBLIC OF\"','AS',2,2,'','','','','',''),(102,'Iraq','IQ','IRQ','964',1,'ar','Diyala,Mu??faz?at al Anb?r,Mu??faz?at al Ba?rah,Mu??faz?at al Muthanná,Mu??faz?at al Q?dis?yah,Mu??faz?at an Najaf,Mu??faz?at Arb?l,Mu??faz?at as Sulaym?n?yah,Mu??faz?at at Ta\'m?m,Mu??faz?at B?bil,Mu??faz?at Baghd?d,Mu??faz?at Dah?k,Mu??faz?at Dh? Q?r,Mu??faz?at Karbal?\',Mu??faz?at Mays?n,Mu??faz?at N?nawá,Mu??faz?at ?al?? ad D?n,Mu??faz?at W?si?,Ost?n-e D??leh,Ost?n-e Soleym?n?yeh','AS',2,2,'','','','','',''),(103,'Ireland','IE','IRL','353',1,'en','County Carlow,County Cavan,County Clare,County Cork,County Donegal,County Dublin,County Galway,County Kerry,County Kildare,County Kilkenny,County Laois,County Leitrim,County Limerick,County Longford,County Louth,County Mayo,County Meath,County Monaghan,County Offaly,County Roscommon,County Sligo,County Tipperary,County Waterford,County Westmeath,County Wexford,County Wicklow','EU',2,2,'','','','','',''),(104,'Israel','IL','ISR','972',1,'he,ar,en','Central District,Haifa District,Jerusalem District,Northern District,Southern District,Tel Aviv District','AS',2,2,'','','','','',''),(105,'Italy','IT','ITA','39',1,'fr','Abruzzo,Aosta Valley,Apulia,Basilicate,Calabria,Campania,Friuli,Latium,Liguria,Lombardy,Piedmont,Regione Emilia-Romagna,Regione Molise,Sardinia,Sicily,The Marches,Trentino-Alto Adige,Tuscany,Umbria,Veneto','EU',2,2,'','','','','',''),(106,'Jamaica','JM','JAM','1',1,'en','Hanover Parish,Kingston,Parish of Clarendon,Parish of Manchester,Parish of Portland,Parish of Saint Andrew,Parish of Saint Ann,Parish of Saint Catherine,Parish of Saint Elizabeth,Parish of Saint James,Parish of Saint Mary,Parish of Saint Thomas,Parish of Trelawny,Parish of Westmoreland','NA',2,2,'','','','','',''),(107,'Japan','JP','JPN','81',1,'jp','Aichi-ken,Akita-ken,Aomori-ken,Chiba-ken,Ehime,Fukui-ken,Fukuoka-ken,Fukushima-ken,Gifu-ken,Gumma-ken,Hiroshima-ken,Hokkaid?,Hy?go-ken,Ibaraki-ken,Ishikawa-ken,Iwate-ken,Kagawa-ken,Kagoshima-ken,Kanagawa-ken,K?chi-ken,Kumamoto-ken,Ky?to-fu,Mie-ken,Miyagi-ken,Miyazaki-ken,Nagano-ken,Nagasaki-ken,Nara,Niigata-ken,?ita-ken,Okayama-ken,Okinawa-ken,?saka-fu,Saga-ken,Saitama-ken,Shiga-ken,Shimane-ken,Shizuoka-ken,Tochigi-ken,Tokushima-ken,T?ky?-to,Tottori-ken,Toyama-ken,Wakayama-ken,Yamagata-ken,Yamaguchi-ken,Yamanashi-ken','AS',2,2,'','','','','',''),(108,'Jordan','JO','JOR','962',1,'ar,en','Ajlun,Amman,Aqaba,Balqa,Irbid,Jerash,Karak,Ma\'an,Madaba,Mafraq,Tafielah,Zarqa','AS',2,2,'','','','','',''),(109,'Kazakhstan','KZ','KAZ','7',1,'ru','Akmolinskaya Oblast\',Almatinskaya Oblast\',Aqtöbe Oblysy,Atyra? Oblysy,Batys Qazaqstan Oblysy,East Kazakhstan,Gorod Almaty,Gorod Astana,Köksheta? Oblysy,Kostanayskaya Oblast\',Mangghysta? Oblysy,Pavlodar Oblysy,Qaraghandy Oblysy,Qyzylorda Oblysy,Semey Oblysy,Severo-Kazakhstanskaya Oblast\',Taldyqorghan Oblysy,Torghay Oblysy,Yuzhno-Kazakhstanskaya Oblast\',Zhambyl Oblysy,Zhezqazghan Oblysy','AS',2,2,'','','','','',''),(110,'Kenya','KE','KEN','254',1,'en','Central Province,Coast Province,Eastern,Nairobi Area,North Eastern Province,Nyanza Province,Rift Valley Province,Western Province','AF',2,2,'','','','','',''),(111,'Kiribati','KI','KIR','686',1,'en','Gilbert Islands,Line Islands','OC',2,2,'','','','','',''),(112,'Korea (South)','KP','PRK','82',1,'ko',' DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\", DEMOCRATIC PEOPLE\'S REPUBLIC OF\"','AS',2,2,'','','','','',''),(113,'Korea (North)','KR','KOR','850',1,'ko',' REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\", REPUBLIC OF\"','AS',2,2,'','','','','',''),(114,'Kuwait','KW','KWT','965',1,'ar,en','Al Farwaniyah,Mu??faz?at al `??imah,Mu??faz?at al A?mad?,Mu??faz?at ?awall?,Mu??faz?at Jahr?\',Mu??faz?atalWafrah','AS',2,2,'','','','','',''),(115,'Kyrgyzstan','KG','KGZ','996',1,'ru','Batkenskaya Oblast\',Bishkek Shaary,Chuyskaya Oblast\',Jalal-Abad Oblasty,Narynskaya Oblast\',Oshskaya Oblast\',Talasskaya Oblast\',Ysyk-Köl Oblasty','AS',2,2,'','','','','',''),(116,'Laos','LA','LAO','856',1,'fr,en','Kamphèng Nakhon Viangchan,Khétphisét Xaisômboun,Khouèng Attapu,Khouèng Bokéo,Khouèng Bolikhamxai,Khouèng Champasak,Khouèng Houaphan,Khouèng Khammouan,Khouèng Louangnamtha,Khouèng Louangphrabang,Khouèng Oudômxai,Khouèng Phôngsali,Khouèng Salavan,Khouèng Savannakhét,Khouèng Viangchan,Khouèng Xaignabouli,Khouèng Xékong,Khouèng Xiangkhoang','AS',2,2,'','','','','',''),(117,'Latvia','LV','LVA','371',1,'ru','Aizkraukles Rajons,Al?ksnes Rajons,Balvu Rajons,Bauskas Rajons,C?su Rajons,Daugavpils,Daugavpils Rajons,Dobeles Rajons,Gulbenes Rajons,J?kabpils Rajons,Jelgava,Jelgavas Rajons,J?rmala,Kr?slavas Rajons,Kuld?gas Rajons,Liep?ja,Liep?jas Rajons,Limbažu Rajons,Ludzas Rajons,Madonas Rajons,Ogres Rajons,Prei?u Rajons,R?zekne,R?zeknes Rajons,R?ga,R?gas Rajons,Saldus Rajons,Talsu Rajons,Tukuma Rajons,Valkas Rajons,Valmieras Rajons,Ventspils,Ventspils Rajons','EU',2,2,'','','','','',''),(118,'Lebanon','LB','LBN','961',1,'ar,fr,en','Mohafazat Aakâr,Mohafazat Baalbek-Hermel,Mohafazat Béqaa,Mohafazat Beyrouth,Mohafazat Liban-Nord,Mohafazat Liban-Sud,Mohafazat Mont-Liban,Mohafazat Nabatîyé','AS',2,2,'','','','','',''),(119,'Lesotho','LS','LSO','266',1,'en','Berea District,Butha-Buthe District,Leribe District,Mafeteng District,Maseru District,Mohale\'s Hoek District,Mokhotlong District,Qacha\'s Nek District,Quthing District,Thaba-Tseka District','AF',2,2,'','','','','',''),(120,'Liberia','LR','LBR','231',1,'en','Bomi County,Bong County,Gbarpolu County,Grand Bassa County,Grand Cape Mount County,Grand Gedeh County,Grand Kru County,Lofa County,Margibi County,Maryland County,Montserrado County,Nimba County,River Cess County,River Gee County,Sinoe County','AF',2,2,'','','','','',''),(121,'Libya','LY','LBY','218',1,'ar,it','Balad?yat Ajd?biy?,Balad?yat al `Az?z?yah,Balad?yat al `Ujayl?t,Balad?yat al Aby?r,Balad?yat al Bay??\',Balad?yat al F?ti?,Balad?yat al Jabal al Akh?ar,Balad?yat al Jufrah,Balad?yat al Jumayl,Balad?yat al Khums,Balad?yat al Kufrah,Balad?yat al Marj,Balad?yat al Qar?b?ll,Balad?yat al Qubbah,Balad?yat an Nuq?? al Khams,Balad?yat ash Sh??i\',Balad?yat Awb?r?,Balad?yat az Zahr?\',Balad?yat az Z?wiyah,Balad?yat Bangh?z?,Balad?yat Ban? Wal?d,Balad?yat Bin Jaww?d,Balad?yat Darnah,Balad?yat Ghad?mis,Balad?yat Ghary?n,Balad?yat Gh?t,Balad?yat J?d?,Balad?yat J?l?,Balad?yat Janz?r,Balad?yat Mi?r?tah,Balad?yat Mizdah,Balad?yat Murzuq,Balad?yat N?l?t,Balad?yat Qam?nis,Balad?yat Qa?r Bin Ghash?r,Balad?yat Sabh?,Balad?yat ?abr?tah,Balad?yat Sawfajj?n,Balad?yat Sha???t,Balad?yat ?urm?n,Balad?yat Surt,Balad?yat ?ar?bulus,Balad?yat Tarh?nah,Balad?yat ?ubruq,Balad?yat T?krah,Balad?yat Yafran,Balad?yat Zl??an,Balad?yat Zuw?rah','AF',2,2,'','','','','',''),(122,'Liechtenstein','LI','LIE','423',1,'de','Gemeinde Balzers,Gemeinde Eschen,Gemeinde Gamprin,Gemeinde Mauren,Gemeinde Planken,Gemeinde Ruggell,Gemeinde Schaan,Gemeinde Schellenberg,Gemeinde Triesen,Gemeinde Triesenberg,Gemeinde Vaduz','EU',2,2,'','','','','',''),(123,'Lithuania','LT','LTU','370',1,'ru,pl','Alytaus Apskritis,Kauno Apskritis,Klaip?dos Apskritis,Marijampol?s Apskritis,Panev?žio Apskritis,Šiauli? Apskritis,Taurag?s Apskritis,Telši? Apskritis,Utenos Apskritis,Vilniaus Apskritis','EU',2,2,'','','','','',''),(124,'Luxembourg','LU','LUX','352',1,'de','District de Diekirch,District de Grevenmacher,District de Luxembourg','EU',2,2,'','','','','',''),(126,'Macedonia','MK','MKD','389',1,'sr',' THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\", THE FORMER YUGOSLAV REPUBLIC OF\"','EU',2,2,'','','','','',''),(127,'Madagascar','MG','MDG','261',1,'fr','Faritanin\' Antananarivo,Faritanin\' i Fianarantsoa,Faritanin\' i Mahajanga,Faritanin\' i Toamasina,Faritanin\' i Toliara,Faritany d\' Antsiranana','AF',2,2,'','','','','',''),(128,'Malawi','MW','MWI','265',1,'','Balaka District,Blantyre District,Chikwawa District,Chiradzulu District,Chitipa District,Dedza District,Dowa District,Karonga District,Kasungu District,Likoma District,Lilongwe District,Machinga District,Mangochi District,Mchinji District,Mulanje District,Mwanza District,Mzimba District,Nkhata Bay District,Nkhotakota District,Nsanje District,Ntcheu District,Ntchisi District,Phalombe District,Rumphi District,Salima District,Thyolo District,Zomba District','AF',2,2,'','','','','',''),(129,'Malaysia','MY','MYS','60',1,'zh,en','JHR:Johor,KDH:Kedah,KTN:Kelantan,KUL:Federal Territory of Kuala Lumpur,LBN:Federal Territory of Labuan,MLK:Malacca,NSN:Negeri Sembilan,PHG:Pahang,PJY:Federal Territory of Putrajaya,PLS:Perlis,PNG:Putrajaya,PRK:Perak,SBH:Sabah,SGR:Selangor,SRW:Sarawak,TRG:Terengganu','AS',2,2,'','',',','.','','C'),(130,'Maldives','MV','MDV','960',1,'','Alifu Atholhu,Baa Atholhu,Dhaalu Atholhu,Faafu Atholhu,Gaafu Alifu Atholhu,Gaafu Dhaalu Atholhu,Gnyaviyani Atoll,Haa Alifu Atholhu,Haa Dhaalu Atholhu,Laamu Atholhu,Lhaviyani Atholhu,Maale,Meemu Atholhu,Noonu Atholhu,Raa Atholhu,Seenu Atholhu,Shaviyani Atholhu,Thaa Atholhu,Vaavu Atholhu','AS',2,2,'','','','','',''),(131,'Mali','ML','MLI','223',1,'fr','District de Bamako,Région de Gao,Région de Kayes,Région de Kidal,Région de Koulikoro,Région de Mopti,Région de Ségou,Région de Sikasso,Région de Tombouctou','AF',2,2,'','','','','',''),(132,'Malta','MT','MLT','356',1,'en','','EU',2,2,'','','','','',''),(133,'Marshall Islands','MH','MHL','692',1,'','','OC',2,2,'','','','','',''),(135,'Mauritania','MR','MRT','222',1,'fr','Nouakchott District de,Région de Dakhlet Nouadhibou,Région de l\' Adrar,Région de l\' Assaba,Région de l\' Inchiri,Région du Brakna,Région du Gorgol,Région du Guidimaka,Région du Hodh Ech Chargui,Région du Hodh El Gharbi,Région du Tagant,Région du Tiris Zemmour,Région du Trarza','AF',2,2,'','','','','',''),(136,'Mauritius','MU','MUS','230',1,'fr','Agalega Islands,Black River District,Cargados Carajos,Flacq District,Grand Port District,Moka District,Pamplemousses District,Plaines Wilhems District,Port Louis District,Rivière du Rempart District,Rodrigues,Savanne District','AF',2,2,'','','','','',''),(138,'Mexico','MX','MEX','52',1,'es','Aguascalientes,Baja California Sur,Campeche,Chiapas,Chihuahua,Coahuila,Colima,Durango,Estado de Baja California,Estado de México,Estado de Veracruz-Llave,Guanajuato,Guerrero,Hidalgo,Jalisco,Michoacán,Morelos,Nayarit,Nuevo León,Oaxaca,Puebla,Querétaro,Quintana Roo,San Luis Potosí,Sinaloa,Sonora,Tabasco,Tamaulipas,The Federal District,Tlaxcala,Yucatán,Zacatecas','NA',2,2,'','','','','',''),(139,'Micronesia','FM','FSM','691',1,'en',' FEDERATED STATES OF\", FEDERATED STATES OF\", FEDERATED STATES OF\", FEDERATED STATES OF\"','OC',2,2,'','','','','',''),(140,'Moldova','MD','MDA','373',1,'ru','Balti Judetul,Cahul Judetul,Cainari Raionul,Camenca Raionul,Ceadîr-Lunga Raionul,Comrat Raionul,Edinet Judetul,Grigoriopol Raionul,Lapusna Judetul,Municipiul Bender,Municipiul Chi?in?u,Municipul B?l?i,Orhei Judetul,Raionul Anenii Noi,Raionul Basarabeasca,Raionul Briceni,Raionul Cahul,Raionul C?l?ra?i,Raionul Cantemir,Raionul C?u?eni,Raionul Cimi?lia,Raionul Criuleni,Raionul Dondu?eni,Raionul Drochia,Raionul Dub?sari,Raionul Edine?,Raionul F?le?ti,Raionul Flore?ti,Raionul Glodeni,Raionul Hînce?ti,Raionul Ialoveni,Raionul Leova,Raionul Nisporeni,Raionul Ocni?a,Raionul Orhei,Raionul Rezina,Raionul Rî?cani,Raionul Sîngerei,Raionul ?old?ne?ti,Raionul Soroca,Raionul ?tefan-Vod?,Raionul Str??eni,Raionul Taraclia,Raionul Telene?ti,Raionul Ungheni,Rîbnita Raionul,Slobozia Raionul,Soroca Judetul,Tighina Judetul,Tiraspol Municipiul,Ungheni Judetul,Unitate Teritorial? Autonom? G?g?uzia,Unitatea Teritorial? din Stînga Nistrului,Vulcanes Raionul','EU',2,2,'','','','','',''),(141,'Monaco','MC','MCO','377',1,'fr,en,it','Commune de Monaco','EU',2,2,'','','','','',''),(142,'Mongolia','MN','MNG','976',1,'ru','Arhangay Aymag,Bayanhongor Aymag,Bayan-Ölgiy Aymag,Bulgan Aymag,Central Aymag,Darhan Hot (historical),Dzavhan Aymag,East Gobi Aymag,Eastern,Erdenet Hot (historical),Gov?-Altay Aymag,Gov?-Sumber,Hentiy Aymag,Hovd Aymag,Hövsgöl Aymag,Middle Gov?,Selenge Aymag,South Gobi Aimak,South Hangay,Sühbaatar Aymag,Ulaanbaatar Hot,Uvs Aymag,??????-??? ?????,????? ?????','AS',2,2,'','','','','',''),(144,'Morocco','MA','MAR','212',1,'ar','Laâyoune-Boujdour-Sakia El Hamra,Région de Chaouia-Ouardigha,Région de Doukkala-Abda,Région de Fès-Boulemane,Région de Gharb-Chrarda-Beni Hssen,Région de Guelmim-Es Smara,Région de l\' Oriental,Région de Marrakech-Tensift-Al Haouz,Région de Meknès-Tafilalet,Région de Rabat-Salé-Zemmour-Zaër,Région de Souss-Massa-Drâa,Région de Tadla-Azilal,Région de Tanger-Tétouan,Région de Taza-Al Hoceima-Taounate,Région du Grand Casablanca','AF',2,2,'','','','','',''),(145,'Mozambique','MZ','MOZ','258',1,'pt','Cidade de Maputo,Maputo Province,Província de Cabo Delgado,Província de Gaza,Província de Inhambane,Província de Manica,Província de Nampula,Província de Niassa,Província de Sofala,Província de Tete,Província de Zambézia','AF',2,2,'','','','','',''),(146,'Myanmar','MM','MMR','95',1,'','Ayeyarwady Division,Bago Division,Chin State,Kachin State,Kayah State,Kayin State,Magway Division,Mandalay Division,Mon State,Rakhine State,Sagaing Division,Shan State,Tanintharyi Division,Yangon Division','AS',2,2,'','','','','',''),(147,'Namibia','NA','NAM','264',1,'en','Bethanien,Caprivi,Caprivi Oos,Erongo,Hardap,Kaokoland,Karas,Kavango,Khomas,Kunene,Ohangwena,Okavango,Omaheke,Omusati,Oshana,Oshikoto,Otjiwarongo,Otjozondjupa,Outjo,Owambo','AF',2,2,'','','','','',''),(148,'Nauru','NR','NRU','674',1,'en','','OC',2,2,'','','','','',''),(149,'Nepal','NP','NPL','977',1,'','B?gmat? Zone,Bher? Zone,Dhawal?giri Zone,Gandak? Zone,Janakpur Zone,Karn?l? Zone,Kos? Zone,Lumbin? Zone,Mah?k?l? Zone,Mech? Zone,N?r?yan? Zone,R?pt? Zone,Sagarm?th? Zone,Set? Zone','AS',2,2,'','','','','',''),(150,'Netherlands','NL','NLD','31',1,'nl','North Brabant,North Holland,Provincie Drenthe,Provincie Flevoland,Provincie Friesland,Provincie Gelderland,Provincie Groningen,Provincie Limburg,Provincie Overijssel,Provincie Utrecht,Provincie Zeeland,South Holland','EU',2,2,'','','','','',''),(153,'New Zealand','NZ','NZL','64',1,'en','Auckland,Bay of Plenty,Canterbury,Chatham Islands,Gisborne,Hawkes Bay,Marlborough,Nelson,Otago,Southland,Taranaki,Waikato,Wanganui,Wellington,West Coast,Whangarei','OC',2,2,'','','','','',''),(154,'Nicaragua','NI','NIC','505',1,'','Departamento de Boaco,Departamento de Carazo,Departamento de Chinandega,Departamento de Chontales,Departamento de Estelí,Departamento de Granada,Departamento de Jinotega,Departamento de León,Departamento de Madriz,Departamento de Managua,Departamento de Masaya,Departamento de Matagalpa,Departamento de Nueva Segovia,Departamento de Río San Juan,Departamento de Rivas,Región Autónoma Atlántico Norte,Región Autónoma Atlántico Sur','NA',2,2,'','','','','',''),(155,'Niger','NE','NER','227',1,'fr','Département d\' Agadez,Département de Diffa,Département de Dosso,Département de Maradi,Département de Tahoua,Département de Tillabéri,Département de Zinder,Niamey,Niamey Département de','AF',2,2,'','','','','',''),(156,'Nigeria','NG','NGA','234',1,'en','Abia State,Abuja Federal Capital Territory,Adamawa State,Akwa Ibom State,Anambra State,Bauchi State,Bayelsa State,Bendel State,Benue State,Benue-Plateau State,Borno State,Cross River State,Delta State,East-Central State,Ebonyi State,Ekiti State,Ekpoma,Enugu State,Gombe State,Gongola State,Imo State,Jigawa State,Kaduna State,Kano State,Katsina State,Kebbi State,Kogi State,Kwara State,Lagos State,Nassarawa State,Niger State,North-Eastern State,North-Western State,Ogun State,Ondo State,Osun State,Oyo State,Plateau State,Rivers State,Sokoto State,Taraba State,Western State,Yobe State,Zamfara State','AF',2,2,'','','','','',''),(160,'Norway','NO','NOR','47',1,'','Akershus Fylke,Aust-Agder Fylke,Bouvetøya ,Buskerud Fylke,Finnmark Fylke,Hedmark Fylke,Hordaland Fylke,Jan Mayen,Møre og Romsdal Fylke,Nordland Fylke,Nord-Trøndelag Fylke,Oppland Fylke,Oslo Fylke,Østfold,Rogaland Fylke,Sogn og Fjordane Fylke,Sør-Trøndelag Fylke,Telemark Fylke,Troms Fylke,Vest-Agder Fylke,Vestfold Fylke','EU',2,2,'','','','','',''),(161,'Oman','OM','OMN','968',1,'ar,en,ur','Al Min?aqah ad D?khil?yah,Al Min?aqah al Wus?á,Al Min?aqah ash Sharq?yah,Min?aqat al B??inah,Min?aqat az? Z??hirah,Min?aqat Masqa?,Mu??faz?at Z?uf?r','AS',2,2,'','','','','',''),(162,'Pakistan','PK','PAK','92',1,'ur','Azad Kashmir,Balochist?n,Federally Administered Tribal Areas,Isl?m?b?d Capital Territory,North-West Frontier Province,Punjab,Sind','AS',2,2,'','','','','',''),(163,'Palau','PW','PLW','680',1,'en,tl,zh,jp','Hatohobei State,State of Airai,State of Angaur,State of Koror,State of Melekeok,State of Ngaraard,State of Ngarchelong,State of Ngchesar,State of Ngeremlengui,State of Ngiwal,State of Peleliu','OC',2,2,'','','','','',''),(164,'Panama','PA','PAN','507',1,'es,en','Comarca de San Blas,Provincia de Bocas del Toro,Provincia de Chiriquí,Provincia de Coclé,Provincia de Colón,Provincia de Herrera,Provincia de Los Santos,Provincia de Panamá,Provincia de Veraguas,Provincia del Darién','NA',2,2,'','','','','',''),(165,'Papua New Guinea','PG','PNG','675',1,'','Sandaun Province','OC',2,2,'','','','','',''),(166,'Paraguay','PY','PRY','595',1,'es','Asunción,Departamento Central,Departamento de Alto Paraguay,Departamento de Boquerón,Departamento de Caaguazú,Departamento de Caazapá,Departamento de Canindeyú,Departamento de Concepción,Departamento de Itapúa,Departamento de la Cordillera,Departamento de Misiones,Departamento de Ñeembucú,Departamento de Paraguarí,Departamento de Presidente Hayes,Departamento de San Pedro,Departamento del Alto Paraná,Departamento del Amambay,Departamento del Guairá','SA',2,2,'','','','','',''),(167,'Peru','PE','PER','51',1,'es','Departamento de Amazonas,Departamento de Ancash,Departamento de Apurímac,Departamento de Arequipa,Departamento de Ayacucho,Departamento de Cajamarca,Departamento de Cusco,Departamento de Huancavelica,Departamento de Huánuco,Departamento de Ica,Departamento de Junín,Departamento de La Libertad,Departamento de Lambayeque,Departamento de Lima,Departamento de Loreto,Departamento de Madre de Dios,Departamento de Moquegua,Departamento de Pasco,Departamento de Piura,Departamento de Puno,Departamento de San Martín,Departamento de Tacna,Departamento de Tumbes,Departamento de Ucayali,Provincia Constitucional del Callao','SA',2,2,'','','','','',''),(168,'Philippines','PH','PHL','63',1,'tl','Angeles City,Bacolod City,Bago City,Baguio City,Bais City,Batangas City,Butuan City,Cabanatuan City,Cadiz City,Cagayan de Oro City,Calbayog City,Caloocan City,Canlaon City,Cavite City,Cebu City,Chartered City of Cagayan de Oro,Chartered City of Iligan,Chartered City of Marawi,City of Manila,Cotabato City,Dagupan City,Danao City,Dapitan City,Davao City,Dipolog City,Dumaguete City,Eastern Samar,General Santos City,Gingoog City,Iligan City,Iloilo City,Iriga City,La Carlota City,Laoag City,Lapu-Lapu City,Legaspi City,Lipa City,Lucena City,Mandaue City,Marawi City,Mountain Province,Naga City,Northern Samar,Olongapo City,Ormoc City,Oroquieta City,Ozamis City,Pagadian City,Palayan City,Pasay City,Province of  Zamboanga del Sur,Province of Abra,Province of Agusan del Norte,Province of Agusan del Sur,Province of Aklan,Province of Albay,Province of Antique,Province of Aurora,Province of Basilan,Province of Bataan,Province of Batanes,Province of Batangas,Province of Benguet,Province of Bohol,Province of Bukidnon,Province of Bulacan,Province of Cagayan,Province of Camarines Norte,Province of Camarines Sur,Province of Camiguin,Province of Capiz,Province of Catanduanes,Province of Cavite,Province of Cebu,Province of Davao del Norte,Province of Davao del Sur,Province of Davao Oriental,Province of Ifugao,Province of Ilocos Norte,Province of Ilocos Sur,Province of Iloilo,Province of Isabela,Province of Kalinga-Apayao,Province of La Union,Province of Laguna,Province of Lanao del Norte,Province of Lanao del Sur,Province of Leyte,Province of Maguindanao,Province of Marinduque,Province of Masbate,Province of Mindoro Occidental,Province of Mindoro Oriental,Province of Misamis Occidental,Province of Misamis Oriental,Province of Negros Occidental,Province of Negros Oriental,Province of North Cotabato,Province of Nueva Ecija,Province of Nueva Vizcaya,Province of Palawan,Province of Pampanga,Province of Pangasinan,Province of Quezon,Province of Quirino,Province of Rizal,Province of Romblon,Province of Samar,Province of Siquijor,Province of Sorsogon,Province of South Cotabato,Province of Sultan Kudarat,Province of Sulu,Province of Surigao del Norte,Province of Surigao del Sur,Province of Tarlac,Province of Tawi-Tawi,Province of Zambales,Province of Zamboanga del Norte,Puerto Princesa City,Quezon City,Roxas City,San Carlos City,San Jose City,San Pablo City,Silay City,Southern Leyte,Surigao City,Tacloban City,Tagaytay City,Tagbilaran City,Tangub City,Toledo City,Trece Martires City,Zamboanga City','AS',2,2,'','','','','',''),(170,'Poland','PL','POL','48',1,'pl','Greater Poland Voivodeship,Kuyavian-Pomeranian Voivodeship,Lesser Poland Voivodeship,?ód? Voivodeship,Lower Silesian Voivodeship,Lublin Voivodeship,Lubusz Voivodeship,Masovian Voivodeship,Opole Voivodeship,Podlachian Voivodeship,Pomeranian Voivodeship,Silesian Voivodeship,Subcarpathian Voivodeship,?wi?tokrzyskie Voivodeship,Warmian-Masurian Voivodeship,West Pomeranian Voivodeship','EU',2,2,'','','','','',''),(171,'Portugal','PT','PRT','351',1,'pt','Bragança,Distrito da Guarda,Distrito de Aveiro,Distrito de Beja,Distrito de Braga,Distrito de Castelo Branco,Distrito de Coimbra,Distrito de Évora,Distrito de Faro,Distrito de Leiria,Distrito de Portalegre,Distrito de Santarém,Distrito de Setúbal,Distrito de Viana do Castelo,Distrito de Vila Real,Distrito de Viseu,Distrito do Porto,Lisbon,Região Autónoma da Madeira,Região Autónoma dos Açores','EU',2,2,'','','','','',''),(173,'Qatar','QA','QAT','974',1,'','Balad?yat ad Daw?ah,Balad?yat al Ghuwayr?yah,Balad?yat al Jumayl?yah,Balad?yat al Khawr,Balad?yat al Wakrah,Balad?yat ar Rayy?n,Balad?yat Jaray?n al B??inah,Balad?yat Mad?nat ash Sham?l,Balad?yat Umm Sa`?d,Balad?yat Umm ?al?l','AS',2,2,'','','','','',''),(175,'Romania','RO','ROU','40',1,'ro,de','Jude?ul Alba,Jude?ul Arad,Jude?ul Arge?,Jude?ul Bac?u,Jude?ul Bihor,Jude?ul Bistri?a-N?s?ud,Jude?ul Boto?ani,Jude?ul Br?ila,Jude?ul Bra?ov,Jude?ul Buz?u,Jude?ul C?l?ra?i,Jude?ul Cara?-Severin,Jude?ul Cluj,Jude?ul Constan?a,Jude?ul Covasna,Jude?ul Dâmbovi?a,Jude?ul Dolj,Jude?ul Gala?i,Jude?ul Giurgiu,Jude?ul Gorj,Jude?ul Harghita,Jude?ul Hunedoara,Jude?ul Ialomi?a,Jude?ul Ia?i,Jude?ul Ilfov,Jude?ul Mehedin?i,Jude?ul Mure?,Jude?ul Neam?,Jude?ul Olt,Jude?ul Prahova,Jude?ul S?laj,Jude?ul Satu Mare,Jude?ul Sibiu,Jude?ul Suceava,Jude?ul Teleorman,Jude?ul Timi?,Jude?ul Tulcea,Jude?ul Vâlcea,Jude?ul Vaslui,Jude?ul Vrancea,Maramure?,Municipiul Bucure?ti','EU',2,2,'','','','','',''),(176,'Russia','RU','RUS','7',1,'ru','Aginskiy Buryatskiy Avtonomnyy Okrug,Altayskiy Kray,Amurskaya Oblast\',Arkhangelskaya oblast,Astrakhanskaya Oblast\',Belgorodskaya Oblast\',Belgorodskiy Rayon,Borisovskiy Rayon,Bryanskaya Oblast\',Chechnya,Chelyabinskaya Oblast\',Chitinskaya Oblast\',Chukotskiy Avtonomnyy Okrug,Chuvashia,Dagestan,Evenkiyskiy Avtonomnyy Okrug,Irkutskaya Oblast\',Ivanovskaya Oblast’,Jewish Autonomous Oblast,Kabardino-Balkarskaya Respublika,Kaliningradskaya Oblast\',Kaluzhskaya Oblast’,Kamchatskaya Oblast\',Karachayevo-Cherkesskaya Respublika,Kemerovskaya Oblast\',Khabarovsk Krai,Khanty-Mansiyskiy Avtonomnyy Okrug,Kirovskaya Oblast\',Koryakskiy Avtonomnyy Okrug,Kostromskaya Oblast\',Krasnodarskiy Kray,Krasnoyarskiy Kray,Kurganskaya Oblast\',Kurskaya Oblast\',Leningradskaya Oblast\',Lipetskaya Oblast\',Magadanskaya Oblast\',Moscow,Moskovskaya Oblast\',Murmansk Oblast,Nenetskiy Avtonomnyy Okrug,Nizhegorodskaya Oblast’,Novgorodskaya Oblast\',Novosibirskaya Oblast\',Omskaya Oblast\',Orenburgskaya Oblast\',Orlovskaya Oblast\',Penzenskaya Oblast\',Permskaya Oblast’,Permskiy Kray,Primorskiy Kray,Pskovskaya Oblast\',Respublika Adygeya,Respublika Altay,Respublika Bashkortostan,Respublika Buryatiya,Respublika Ingushetiya,Respublika Kalmykiya,Respublika Kareliya,Respublika Khakasiya,Respublika Komi,Respublika Mariy-El,Respublika Mordoviya,Respublika Sakha (Yakutiya),Respublika Severnaya Osetiya-Alaniya,Respublika Tatarstan,Respublika Tyva,Rostovskaya Oblast\',Ryazanskaya Oblast\',Sakhalinskaya Oblast\',Samarskaya Oblast\',Sankt-Peterburg,Saratovskaya Oblast\',Shebekinskiy Rayon,Smolenskaya Oblast\',Stavropol\'skiy Kray,Sverdlovskaya Oblast\',Tambovskaya Oblast\',Taymyrskiy (Dolgano-Nenetskiy) Avtonomnyy Okrug,Tomskaya Oblast\',Tul\'skaya Oblast\',Tverskaya Oblast’,Tyumenskaya Oblast\',Udmurtskaya Respublika,Ul’yanovskaya Oblast’,Ust\'-Ordynskiy Buryatskiy Avtonomnyy Okrug,Vladimirskaya Oblast\',Volgogradskaya Oblast\',Vologodskaya Oblast\',Voronezhskaya Oblast\',Yamalo-Nenetskiy Avtonomnyy Okrug,Yaroslavskaya Oblast\'','AS',2,2,'','','','','',''),(177,'Rwanda','RW','RWA','250',1,'fr','Eastern Province,Kigali City,Northern Province,Préfecture de Kibuye,Préfecture de Kigali,Préfecture de Ruhengeri,Prefegitura ya Butare,Prefegitura ya Byumba,Prefegitura ya Cyangugu,Prefegitura ya Gikongoro,Prefegitura ya Gisenyi,Prefegitura ya Gitarama,Prefegitura ya Kibungo,Southern Province,Western Province','AF',2,2,'','','','','',''),(178,'Saint Kitts and Nevis','KN','KNA','1',1,'','Christ Church Nichola Town,Saint Anne Sandy Point,Saint George Basseterre,Saint George Gingerland,Saint James Windward,Saint John Capesterre,Saint John Figtree,Saint Mary Cayon,Saint Paul Capesterre,Saint Paul Charlestown,Saint Peter Basseterre,Saint Thomas Lowland,Saint Thomas Middle Island,Trinity Palmetto Point','NA',2,2,'','','','','',''),(179,'Saint Lucia','LC','LCA','1',1,'','Quarter of Anse-la-Raye,Quarter of Castries,Quarter of Choiseul,Quarter of Dauphin,Quarter of Dennery,Quarter of Gros-Islet,Quarter of Laborie,Quarter of Micoud,Quarter of Praslin,Quarter of Soufrière,Quarter of Vieux-Fort','NA',2,2,'','','','','',''),(180,'Saint Vincent and the Grenadines','VC','VCT','1',1,'','Grenadines,Parish of Charlotte,Parish of Saint Andrew,Parish of Saint David,Parish of Saint George,Parish of Saint Patrick','NA',2,2,'','','','','',''),(181,'Samoa','WS','WSM','685',1,'en','','OC',2,2,'','','','','',''),(182,'San Marino','SM','SMR','378',1,'it','Castello di Acquaviva,Castello di Borgo Maggiore,Castello di Domagnano,Castello di Faetano,Castello di Fiorentino,Castello di Montegiardino,Castello di San Marino Città,Castello di Serravalle,Chiesanuova','EU',2,2,'','','','','',''),(183,'Sao Tome and Principe','ST','STP','239',1,'','Príncipe,São Tomé','AF',2,2,'','','','','',''),(184,'Saudi Arabia','SA','SAU','966',1,'ar','Al Min?aqah ash Sharq?yah,Min?aqat `As?r,Min?aqat al B??ah,Min?aqat al Jawf,Min?aqat al Mad?nah,Min?aqat al Qa??m,Min?aqat ar Riy??,Min?aqat ??\'il,Min?aqat J?z?n,Min?aqat Makkah,Min?aqat Najr?n,Min?aqat Tab?k,Northern Borders Region','AS',2,2,'','','','','',''),(185,'Senegal','SN','SEN','221',1,'','Kolda Region,Région de Dakar,Région de Diourbel,Région de Fatick,Région de Kaolack,Région de Louga,Région de Matam,Région de Saint-Louis,Région de Tambacounda,Région de Thiès,Région de Ziguinchor','AF',2,2,'','','','','',''),(186,'Seychelles','SC','SYC','248',1,'en,fr','Anse aux Pins,Anse Boileau,Anse Etoile,Anse Louis,Anse Royale,Au Cap,Baie Lazare,Baie Sainte Anne,Beau Vallon,Bel Air,Bel Ombre,Cascade,English River,Glacis,Grand Anse Mahe,Grand Anse Praslin,Inner Islands,Les Mamelles,Mont Buxton,Mont Fleuri,Plaisance,Pointe Larue,Port Glaud,Roche Caiman,Saint Louis,Takamaka','AF',2,2,'','','','','',''),(187,'Sierra Leone','SL','SLE','232',1,'en','Eastern Province,Northern Province,Southern Province,Western Area','AF',2,2,'','','','','',''),(188,'Singapore','SG','SGP','65',4,'en,ms,zh','','AS',2,2,'','','','','',''),(189,'Slovakia','SK','SVK','421',1,'','Banskobystrický Kraj,Bratislavský Kraj,Košický Kraj,Nitriansky Kraj,Prešovský Kraj,Tren?iansky Kraj,Trnavský Kraj,Žilinský Kraj','EU',2,2,'','','','','',''),(190,'Slovenia','SI','SVN','386',1,'si','Bohinj,Ljubljana,Mestna Ob?ina Celje,Mestna Ob?ina Koper-Capodistria,Mestna Ob?ina Kranj,Mestna Ob?ina Maribor,Mestna Ob?ina Murska Sobota,Mestna Ob?ina Nova Gorica,Mestna Ob?ina Novo Mesto,Mestna Ob?ina Ptuj,Mestna Ob?ina Slovenj Gradec,Mestna Ob?ina Velenje,Ob?ina [historical] Cankova-Tišina,Ob?ina [historical] Destrnik-Trnovska Vas,Ob?ina [historical] Hodoš Šalovci,Ob?ina [historical] Lendava,Ob?ina [historical] Podvelka-Ribnica,Ob?ina Ajdovš?ina,Ob?ina Beltinci,Ob?ina Benedikt,Ob?ina Bistrica ob Sotli,Ob?ina Bled,Ob?ina Bloke,Ob?ina Borovnica,Ob?ina Bovec,Ob?ina Braslov?e,Ob?ina Brda,Ob?ina Brežice,Ob?ina Brezovica,Ob?ina Cankova,Ob?ina Cerklje na Gorenjskem,Ob?ina Cerknica,Ob?ina Cerkno,Ob?ina Cerkvenjak,Ob?ina ?renšovci,Ob?ina ?rna na Koroškem,Ob?ina ?rnomelj,Ob?ina Destrnik,Ob?ina Diva?a,Ob?ina Dobje,Ob?ina Dobrepolje,Ob?ina Dobrna,Ob?ina Dobrova-Horjul-Polhov Gradec,Ob?ina Dobrovnik-Dobronak,Ob?ina Dol pri Ljubljani,Ob?ina Dolenjske Toplice,Ob?ina Domžale,Ob?ina Dornava,Ob?ina Dravograd,Ob?ina Duplek,Ob?ina Gorenja Vas-Poljane,Ob?ina Gorišnica,Ob?ina Gornja Radgona,Ob?ina Gornji Grad,Ob?ina Gornji Petrovci,Ob?ina Grad,Ob?ina Grosuplje,Ob?ina Hajdina,Ob?ina Ho?e-Slivnica,Ob?ina Hodoš-Hodos,Ob?ina Horjul,Ob?ina Hrastnik,Ob?ina Hrpelje-Kozina,Ob?ina Idrija,Ob?ina Ig,Ob?ina Ilirska Bistrica,Ob?ina Ivan?na Gorica,Ob?ina Izola-Isola,Ob?ina Jesenice,Ob?ina Jezersko,Ob?ina Juršinci,Ob?ina Kamnik,Ob?ina Kanal,Ob?ina Kidri?evo,Ob?ina Kobarid,Ob?ina Kobilje,Ob?ina Ko?evje,Ob?ina Komen,Ob?ina Komenda,Ob?ina Kostel,Ob?ina Kozje,Ob?ina Kranjska Gora,Ob?ina Križevci,Ob?ina Krško,Ob?ina Kungota,Ob?ina Kuzma,Ob?ina Laško,Ob?ina Lenart,Ob?ina Lendava-Lendva,Ob?ina Litija,Ob?ina Ljubno,Ob?ina Ljutomer,Ob?ina Logatec,Ob?ina Loška Dolina,Ob?ina Loški Potok,Ob?ina Lovrenc na Pohorju,Ob?ina Lu?e,Ob?ina Lukovica,Ob?ina Majšperk,Ob?ina Markovci,Ob?ina Medvode,Ob?ina Mengeš,Ob?ina Metlika,Ob?ina Mežica,Ob?ina Miklavž na Dravskem Polju,Ob?ina Miren-Kostanjevica,Ob?ina Mirna Pe?,Ob?ina Mislinja,Ob?ina Morav?e,Ob?ina MoravskeToplice,Ob?ina Mozirje,Ob?ina Muta,Ob?ina Naklo,Ob?ina Nazarje,Ob?ina Odranci,Ob?ina Oplotnica,Ob?ina Ormož,Ob?ina Osilnica,Ob?ina Pesnica,Ob?ina Piran-Pirano,Ob?ina Pivka,Ob?ina Pod?etrtek,Ob?ina Podlehnik,Ob?ina Podvelka,Ob?ina Polzela,Ob?ina Postojna,Ob?ina Prebold,Ob?ina Preddvor,Ob?ina Prevalje,Ob?ina Puconci,Ob?ina Ra?e-Fram,Ob?ina Rade?e,Ob?ina Radenci,Ob?ina Radlje ob Dravi,Ob?ina Radovljica,Ob?ina Ravne na Koroškem,Ob?ina Razkrižje,Ob?ina Ribnica,Ob?ina Ribnica na Pohorju,Ob?ina Rogaška Slatina,Ob?ina Rogašovci,Ob?ina Rogatec,Ob?ina Ruše,Ob?ina Šalovci,Ob?ina Selnica ob Dravi,Ob?ina Semi?,Ob?ina Šempeter-Vrtojba,Ob?ina Šen?ur,Ob?ina Šentilj,Ob?ina Šentjernej,Ob?ina Šentjur pri Celju,Ob?ina Sevnica,Ob?ina Sežana,Ob?ina Škocjan,Ob?ina Škofja Loka,Ob?ina Škofljica,Ob?ina Slovenska Bistrica,Ob?ina Slovenske Konjice,Ob?ina Šmarje pri Jelšah,Ob?ina Šmartno ob Paki,Ob?ina Šmartno pri Litiji,Ob?ina Sodražica,Ob?ina Sol?ava,Ob?ina Šoštanj,Ob?ina Starše,Ob?ina Štore,Ob?ina Sveta Ana,Ob?ina Sveti Andraž v Slovenskih Goricah,Ob?ina Sveti Jurij,Ob?ina Tabor,Ob?ina Tišina,Ob?ina Tolmin,Ob?ina Trbovlje,Ob?ina Trebnje,Ob?ina Trnovska Vas,Ob?ina Trži?,Ob?ina Trzin,Ob?ina Turniš?e,Ob?ina Velika Polana,Ob?ina Velike Laš?e,Ob?ina Veržej,Ob?ina Videm,Ob?ina Vipava,Ob?ina Vitanje,Ob?ina Vodice,Ob?ina Vojnik,Ob?ina Vransko,Ob?ina Vrhnika,Ob?ina Vuzenica,Ob?ina Zagorje ob Savi,Ob?ina Žalec,Ob?ina Zavr?,Ob?ina Železniki,Ob?ina Žetale,Ob?ina Žiri,Ob?ina Žirovnica,Ob?ina Zre?e,Ob?ina Žužemberk','EU',2,2,'','','','','',''),(191,'Solomon Islands','SB','SLB','677',1,'en','Central Province,Guadalcanal Province,Isabel Province,Makira Province,Malaita Province,Temotu Province,Western Province','OC',2,2,'','','','','',''),(192,'Somalia','SO','SOM','252',1,'ar,en,it','Gobolka Awdal,Gobolka Bakool,Gobolka Banaadir,Gobolka Bari,Gobolka Bay,Gobolka Galguduud,Gobolka Gedo,Gobolka Hiiraan,Gobolka Mudug,Gobolka Nugaal,Gobolka Sanaag,Gobolka Shabeellaha Hoose,Gobolka Sool,Gobolka Togdheer,Gobolka Woqooyi Galbeed,Lower Juba,Middle Juba,Middle Shabele','AF',2,2,'','','','','',''),(193,'South Africa','ZA','ZAF','27',1,'af,en','Free State,Gauteng,Limpopo Province,Mpumalanga,Province of Eastern Cape,Province of KwaZulu-Natal,Province of Northern Cape,Province of North-West,Province of the Western Cape','AF',2,2,'','','','','',''),(195,'Spain','ES','ESP','34',3,'','Andalusia,Aragon,Autonomous Region of Madrid,Autonomous Region of Navarre,Balearic Islands,Basque Country,Canary Islands,Cantabria,Castille and León,Castille-La Mancha,Catalonia,Ceuta,Estremadura,Galicia,La Rioja,Melilla,Principality of Asturias,Region of Murcia,Valencian Community','EU',2,2,'','','','','',''),(196,'Sri Lanka','LK','LKA','94',1,'','Central Province,North Central Province,North Eastern Province,North Western Province,Province of Sabaragamuwa,Province of Uva,Southern Province,Western Province','AS',2,2,'','','','','',''),(199,'Sudan','SD','SDN','249',1,'ar,en','Al Jazirah,Al Qadarif,Al Wil?yah al Istiw?\'?yah,Al Wil?yah al Wus?á,Al Wil?yah ash Sharq?yah,Ba?r al Ghazal Wilayat,Blue Nile,Central Equatoria,Darfur Wilayat,Eastern Equatoria,Khartoum,Kurdufan Wilayat,Lakes,Northern,Red Sea,Unity,Upper Nile,Western Bahr al Ghazal,White Nile,Wil?yat Gharb al Istiw?\'?yah,Wil?yat Gharb D?rf?r,Wil?yat Gharb Kurduf?n,Wil?yat Jan?b D?rf?r,Wil?yat Jan?b Kurduf?n,Wil?yat Junqal?,Wil?yat Kassal?,Wil?yat Nahr an N?l,Wil?yat Sham?l Ba?r al Ghaz?l,Wil?yat Sham?l D?rf?r,Wil?yat Sham?l Kurduf?n,Wil?yat Sinn?r,Wil?yat Warab','AF',2,2,'','','','','',''),(200,'Suriname','SR','SUR','597',1,'nl','Distrikt Brokopondo,Distrikt Commewijne,Distrikt Coronie,Distrikt Marowijne,Distrikt Nickerie,Distrikt Para,Distrikt Paramaribo,Distrikt Saramacca,Distrikt Sipaliwini,Distrikt Wanica','SA',2,2,'','','','','',''),(202,'Swaziland','SZ','SWZ','268',1,'en','Hhohho District,Lubombo District,Manzini District,Shiselweni District','AF',2,2,'','','','','',''),(203,'Sweden','SE','SWE','46',1,'sv','Blekinge Län,Dalarnas Län,Gävleborgs Län,Gotlands Län,Hallands Län,Jämtlands Län,Jönköpings Län,Kalmar Län,Kronobergs Län,Norrbottens Län,Örebro Län,Östergötlands Län,Skåne Län,Södermanlands Län,Stockholms Län,Uppsala Län,Värmlands Län,Västerbottens Län,Västernorrlands Län,Västmanlands Län,Västra Götalands Län','EU',2,2,'','','','','',''),(204,'Switzerland','CH','CHE','41',1,'de,fr','Canton de Fribourg,Canton de Genève,Canton de Neuchâtel,Canton de Vaud,Canton du Jura,Canton du Valais,Cantone Ticino,Kanton Aargau,Kanton Appenzell Ausserrhoden,Kanton Appenzell Innerrhoden,Kanton Basel-Landschaft,Kanton Basel-Stadt,Kanton Bern,Kanton Glarus,Kanton Graubünden,Kanton Luzern,Kanton Nidwalden,Kanton Obwalden,Kanton Schaffhausen,Kanton Schwyz,Kanton Solothurn,Kanton St. Gallen,Kanton Thurgau,Kanton Uri,Kanton Zürich,Kanton Zug','EU',2,2,'','','','','',''),(205,'Syria','SY','SYR','963',1,'','Aleppo,Al-Hasakah,Ar-Raqqah,As-Suwayda,Damascus City,Daraa,Deir ez-Zor,Hama Governorate,Homs,Idlib,Latakia,Quneitra,Rif-dimashq,Tartus','AS',2,2,'','','','','',''),(207,'Tajikistan','TJ','TJK','992',1,'','Gorno-Badakhshan,Kulyabskaya Oblast\',Kurgan-Tyubinskaya Oblast\',Region of Republican Subordination,Viloyati Khatlon,Viloyati Sughd','AS',2,2,'','','','','',''),(208,'Tanzania','TZ','TZA','255',1,'',' UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\", UNITED REPUBLIC OF\"','AF',2,2,'','','','','',''),(209,'Thailand','TH','THA','66',1,'th,en','Bangkok,Changawat Chanthaburi,Changwat Amnat Charoen,Changwat Ang Thong,Changwat Buriram,Changwat Chachoengsao,Changwat Chai Nat,Changwat Chaiyaphum,Changwat Chiang Mai,Changwat Chiang Rai,Changwat Chon Buri,Changwat Chumphon,Changwat Kalasin,Changwat Kamphaeng Phet,Changwat Kanchanaburi,Changwat Khon Kaen,Changwat Krabi,Changwat Lampang,Changwat Lamphun,Changwat Loei,Changwat Lop Buri,Changwat Mae Hong Son,Changwat Maha Sarakham,Changwat Mukdahan,Changwat Nakhon Nayok,Changwat Nakhon Pathom,Changwat Nakhon Phanom,Changwat Nakhon Ratchasima,Changwat Nakhon Sawan,Changwat Nakhon Si Thammarat,Changwat Nan,Changwat Narathiwat,Changwat Nong Bua Lamphu,Changwat Nong Khai,Changwat Nonthaburi,Changwat Pathum Thani,Changwat Pattani,Changwat Phangnga,Changwat Phatthalung,Changwat Phayao,Changwat Phetchabun,Changwat Phetchaburi,Changwat Phichit,Changwat Phitsanulok,Changwat Phra Nakhon,Changwat Phra Nakhon Si Ayutthaya,Changwat Phrae,Changwat Phuket,Changwat Prachin Buri,Changwat Prachuap Khiri Khan,Changwat Ranong,Changwat Ratchaburi,Changwat Rayong,Changwat Roi Et,Changwat Sa Kaeo,Changwat Sakon Nakhon,Changwat Samut Prakan,Changwat Samut Sakhon,Changwat Samut Songkhram,Changwat Sara Buri,Changwat Satun,Changwat Sing Buri,Changwat Sisaket,Changwat Songkhla,Changwat Sukhothai,Changwat Suphan Buri,Changwat Surat Thani,Changwat Surin,Changwat Tak,Changwat Trang,Changwat Trat,Changwat Ubon Ratchathani,Changwat Udon Thani,Changwat Uthai Thani,Changwat Uttaradit,Changwat Yala,Changwat Yasothon','AS',2,2,'','','','','',''),(210,'Togo','TG','TGO','228',1,'','Région Centrale,Région de la Kara,Région des Plateaux,Région des Savanes,Région Maritime','AF',2,2,'','','','','',''),(212,'Tonga','TO','TON','676',1,'en','','OC',2,2,'','','','','',''),(213,'Trinidad and Tobago','TT','TTO','1',1,'en,hi,fr,es,zh','Arima,County of Caroni,County of Mayaro,County of Nariva,County of Saint Andrew,County of Saint David,County of Saint George,County of Saint Patrick,County of Victoria,Port-of-Spain,San Fernando,Ward of Tobago','NA',2,2,'','','','','',''),(214,'Tunisia','TN','TUN','216',1,'ar,fr','Gouvernorat de Ariana,Gouvernorat de Béja,Gouvernorat de Ben Arous,Gouvernorat de Bizerte,Gouvernorat de Gabès,Gouvernorat de Gafsa,Gouvernorat de Jendouba,Gouvernorat de Kairouan,Gouvernorat de Kasserine,Gouvernorat de Kebili,Gouvernorat de Kef,Gouvernorat de la Manouba,Gouvernorat de Mahdia,Gouvernorat de Médenine,Gouvernorat de Monastir,Gouvernorat de Nabeul,Gouvernorat de Sfax,Gouvernorat de Sidi Bou Zid,Gouvernorat de Siliana,Gouvernorat de Sousse,Gouvernorat de Tataouine,Gouvernorat de Tozeur,Gouvernorat de Tunis,Gouvernorat de Zaghouan,Tunis al Janubiyah Wilayat','AF',2,2,'','','','','',''),(215,'Turkey','TR','TUR','90',1,'tr','Adana Province,Ad?yaman,Afyonkarahisar,A?r? Province,Aksaray Province,Amasya Province,Ankara Province,Antalya Province,Ardahan Province,Artvin Province,Ayd?n Province,Bal?kesir Province,Bart?n Province,Batman Province,Bayburt,Bilecik Province,Bingöl Province,Bitlis Province,Bolu Province,Burdur Province,Bursa,Çanakkale Province,Çank?r? Province,Çorum Province,Denizli Province,Diyarbak?r,Düzce,Edirne Province,Elaz??,Erzincan Province,Erzurum Province,Gaziantep Province,Giresun Province,Gümü?hane,Hakkâri Province,Hatay Province,I?d?r Province,Isparta Province,Istanbul,?zmir,Kahramanmara? Province,Karabük,Karaman Province,Kars,Kastamonu Province,Kayseri Province,Kilis Province,K?r?kkale Province,K?rklareli Province,K?r?ehir Province,Kocaeli Province,Konya Province,Kütahya Province,Malatya Province,Manisa Province,Mardin Province,Mersin Province,Mu?la Province,Mu? Province,Nev?ehir,Ni?de,Ordu,Osmaniye Province,Rize,Sakarya Province,Samsun Province,?anl?urfa Province,Siirt Province,Sinop Province,??rnak Province,Sivas Province,Tekirda? Province,Tokat,Trabzon Province,Tunceli Province,U?ak Province,Van Province,Yalova Province,Yozgat Province,Zonguldak','AS',2,2,'','','','','',''),(216,'Turkmenistan','TM','TKM','993',1,'','Ahal Welaýaty,Balkan Welaýaty,Da?oguz Welaýaty,Lebap Welaýaty,Mary Welaýaty','AS',2,2,'','','','','',''),(218,'Tuvalu','TV','TUV','688',1,'en','','OC',2,2,'','','','','',''),(219,'Uganda','UG','UGA','256',1,'en,ar','Apac District,Arua District,Bugiri District,Bundibugyo District,Bushenyi District,Busia District,Busoga Province,Eastern Province,Gulu District,Hoima District,Iganga District,Jinja District,Kabale District,Kabarole District,Kaberamaido District,Kalangala District,Kampala District,Kamuli District,Kamwenge District,Kanungu District,Kapchorwa District,Kasese District,Katakwi District,Kayunga District,Kibale District,Kiboga District,Kisoro District,Kitgum District,Kotido District,Kumi District,Kyenjojo District,Lira District,Luwero District,Masaka District,Masindi District,Mayuge District,Mbale District,Mbarara District,Moroto,Moroto District,Moyo District,Mpigi District,Mubende District,Mukono District,Nakapiripirit District,Nakasongola District,Nebbi District,Nile Province,North Buganda Province,Northern Province,Ntungamo District,Pader District,Pallisa District,Rakai District,Rukungiri District,Sembabule District,Sironko District,Soroti District,Southern Province,Tororo District,Wakiso District,Western Province,Yumbe District','AF',2,2,'','','','','',''),(220,'Ukraine','UA','UKR','380',1,'ru,ro,pl','Avtonomna Respublika Krym,Cherkas\'ka Oblast\',Chernihivs\'ka Oblast\',Chernivets\'ka Oblast\',Dnipropetrovs\'ka Oblast\',Donets\'ka Oblast\',Ivano-Frankivs\'ka Oblast\',Kharkivs\'ka Oblast\',Kherson Oblast,Khmel\'nyts\'ka Oblast\',Kiev Oblast,Kirovohrads\'ka Oblast\',Luhans\'ka Oblast\',L\'vivs\'ka Oblast\',Misto Kyyiv,Misto Sevastopol\',Mykolayivs\'ka Oblast\',Odessa Oblast,Poltava Oblast,Rivnens\'ka Oblast\',Sumy Oblast,Ternopil\'s\'ka Oblast\',Vinnyts\'ka Oblast\',Volyns\'ka Oblast\',Zakarpats\'ka Oblast\',Zaporiz\'ka Oblast\',Zhytomyrs\'ka Oblast\'','EU',2,2,'','','','','',''),(221,'United Arab Emirates','AE','ARE','971',1,'ar,pr,en,hi,ur','`Ajm?n,Ab? Z?aby,Al Fujayrah,Ash Sh?riqah,Dubayy,Ra\'s al Khaymah,Umm al Qaywayn','AS',2,2,'','','','','',''),(222,'United Kingdom','GB','GBR','44',1,'en','England,Northern Ireland,Scotland,Wales','EU',2,2,'','','','','',''),(223,'United States','US','USA','1',2,'en,es','CA:California,AZ:Arizona,AR:Arkansas,AL:Alabama,AK:Alaska,CO:Colorado,CT:Connecticut,DC:Washington DC,DE:Delaware,FL:Florida,GA:Georgia,HI:Hawaii,IA:Iowa,ID:Idaho,IL:Illinois,IN:Indiana,KS:Kansas,KY:Kentucky,LA:Louisiana,MA:Massachusetts,ME:Maine,MI:Michigan,MN:Minnesota,MO:Missouri,MS:Mississippi,MT:Montana,NC:North Carolina,ND:North Dakota,NE:Nebraska,NH:New Hampshire,NJ:New Jersey,NM:New Mexico,NV:Nevada,NY:New York,OH:Ohio,OK:Oklahoma,OR:Oregon,PA:Pennsylvania,PR:Puerto Rico,RI:Rhode Island,SC:South Carolina,SD:South Dakota,TN:Tennessee,TX:Texas,UT:Utah,VA:Virginia,VT:Vermont,WA:Washington,WI:Wisconsin,WV:West Virginia,WY:Wyoming,MD:Maryland','NA',2,2,'','','','','',''),(225,'Uruguay','UY','URY','598',1,'es','Artigas Department,Canelones Department,Cerro Largo Department,Colonia Department,Departamento de Durazno,Departamento de Flores,Departamento de Montevideo,Departamento de Paysandú,Departamento de Río Negro,Departamento de Rivera,Departamento de Rocha,Departamento de Salto,Departamento de San José,Departamento de Tacuarembó,Departamento de Treinta y Tres,Florida Department,Lavalleja Department,Maldonado Department,Soriano Department','SA',2,2,'','','','','',''),(226,'Uzbekistan','UZ','UZB','998',1,'ru','Andijon Viloyati,Buxoro Viloyati,Farg`ona Viloyati,Jizzax Viloyati,Karakalpakstan,Namangan Viloyati,Navoiy Viloyati,Qashqadaryo Viloyati,Samarqand Viloyati,Sirdaryo Viloyati,Surxondaryo Viloyati,Toshkent Shahri,Toshkent Viloyati,Xorazm Viloyati','AS',2,2,'','','','','',''),(227,'Vanuatu','VU','VUT','678',1,'en','Ambrym,Aoba/Maéwo,Éfaté,Épi,Malakula,Malampa Province,Paama,Penama Province,Pentecôte,Sanma Province,Shefa Province,Shepherd,Tafea Province,Torba Province','OC',2,2,'','','','','',''),(228,'Vatican City','VA','VAT','39',1,'','','EU',2,2,'','','','','',''),(229,'Venezuela','VE','VEN','58',1,'es','Dependencias Federales,Distrito Federal,Estado Amazonas,Estado Anzoátegui,Estado Apure,Estado Aragua,Estado Barinas,Estado Bolívar,Estado Carabobo,Estado Cojedes,Estado Falcón,Estado Guárico,Estado Lara,Estado Mérida,Estado Miranda,Estado Monagas,Estado Portuguesa,Estado Sucre,Estado Táchira,Estado Trujillo,Estado Vargas,Estado Yaracuy,Estado Zulia,Isla Margarita,Territorio Federal Delta Amacuro','SA',2,2,'','','','','',''),(230,'Viet Nam','VN','VNM','84',1,'','B?c Thái T?nh,H?i Hung T?nh,Hà B?c T?nh,Minh H?i T?nh,Nam Hà T?nh,Qu?ng Nam-Ðà N?ng T?nh,Sông Bé T?nh,Thành Ph? H?i Phòng,Thành ph? H? Chí Minh,Th? Ðô Hà N?i,T?nh An Giang,T?nh Bà R?a-V?ng Tàu,T?nh B?c Giang,T?nh B?c K?n,T?nh B?c Liêu,T?nh B?c Ninh,T?nh B?n Tre,T?nh Bình Ð?nh,T?nh Bình D??ng,T?nh Bình Ph??c,T?nh Bình Thu?n,T?nh Cà Mau,T?nh C?n Th?,T?nh Cao B?ng,T?nh Ðà N?ng,T?nh Ð?c L?k,T?nh Ð?ng Nai,T?nh Ð?ng Tháp,T?nh Gia Lai,T?nh Hà Giang,T?nh Hà Nam,T?nh Hà Tây,T?nh Hà T?nh,T?nh H?i D??ng,T?nh Hòa Bình,T?nh H?ng Yên,T?nh Khánh Hòa,T?nh Ki?n Giang,T?nh Kon Tum,T?nh Lai Châu,T?nh Lâm Ð?ng,T?nh L?ng S?n,T?nh Lào Cai,T?nh Long An,T?nh Nam Ð?nh,T?nh Ngh? An,T?nh Ninh Bình,T?nh Ninh Thu?n,T?nh Phú Th?,T?nh Phú Yên,T?nh Qu?ng Bình,T?nh Qu?ng Nam,T?nh Qu?ng Ngãi,T?nh Qu?ng Ninh,T?nh Qu?ng Tr?,T?nh Sóc Tr?ng,T?nh S?n La,T?nh Tây Ninh,T?nh Thái Bình,T?nh Thái Nguyên,T?nh Thanh Hóa,T?nh Th?a Thiên-Hu?,T?nh Ti?n Giang,T?nh Trà Vinh,T?nh Tuyên Quang,T?nh V?nh Long,T?nh V?nh Phúc,T?nh Yên Bái,Vinh Phú T?nh','AS',2,2,'','','','','',''),(235,'Yemen','YE','YEM','967',1,'ar','Aden Municipality,Mu??faz?at `Adan,Mu??faz?at Abyan,Mu??faz?at a? ??li`,Mu??faz?at al Bay??\',Mu??faz?at al ?udaydah,Mu??faz?at al Jawf,Mu??faz?at al Mahrah,Mu??faz?at al Ma?w?t,Mu??faz?at ?a?ramawt,Mu??faz?at ?ajjah,Mu??faz?at Ibb,Mu??faz?at La?ij,Mu??faz?at Shabwah,Mu??faz?at Ta`izz,Omran,Qa??\' al ?udaydah','AS',2,2,'','','','','',''),(242,'South Sudan','CX','SCX','211',1,'','','',2,2,'','','','','',''),(241,'Montenegro','CS','SCG','382',1,'','','EU',2,2,'','','','','',''),(238,'Zambia','ZM','ZMB','260',1,'','Central Province,Copperbelt Province,Eastern Province,Luapula Province,Lusaka Province,Northern Province,North-Western Province,Southern Province,Western Province','AF',2,2,'','','','','',''),(239,'Zimbabwe','ZW','ZWE','263',1,'en','Bulawayo Province,Harare Province,Manicaland Province,Mashonaland Central Province,Mashonaland East Province,Mashonaland West Province,Masvingo Province,Matabeleland North Province,Matabeleland South Province,Midlands Province','AF',2,2,'','','','','',''),(243,'Hong Kong','HK','HKG','852',1,'en, zh',NULL,'AS',2,2,'','','','','',''),(245,'Aruba','AW','ABW','297',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(246,'Ascension Island','SH','SHN','247',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(247,'British Indian Ocean Territory','IO','IOT','246',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(248,'Congo- Democratic Republic of the','CD','COD','243',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(249,'Cook Islands','CK','COK','682',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(250,'Falkland Islands','FK','FLK','500',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(251,'Faroe Islands','FO','FRO','298',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(252,'French Guiana','GF','GUF','594',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(253,'French Polynesia','PF','PYF','689',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(254,'French Southern and Antarctic Lands','TF','ATF','262',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(255,'Gibraltar','GI','GIB','350',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(256,'Greenland','GL','GRL','299',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(257,'Guadeloupe','GP','GLP','590',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(258,'Macao','MO','MAC','853',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(259,'Martinique','MQ','MTQ','596',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(260,'Netherlands Antilles','NL','NLD','599',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(261,'New Caledonia','NC','NCL','687',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(262,'Niue','NU','NIU','683',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(263,'Norfolk Island','NF','NFK','672',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(264,'Palestine','PS','PSE','970',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(265,'Pitcairn','PN','PCN','872',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(266,'Reunion','RE','REU','262',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(267,'Saint Helena','SH','SHN','290',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(268,'Saint Pierre and Miquelon','PM','SPM','508',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(269,'Serbia','RS','SRB','381',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(270,'Taiwan','TW','TWN','886',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(271,'Tokelau','TK','TKL','690',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(272,'Tristan da Cunha','SH','SHN','290',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(273,'United States Minor Outlying Islands','UM','UMI','699',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(274,'Wallis and Futuna Islands','WF','WLF','681',0,NULL,NULL,'',2,2,'$','ISO-8859-1',',','.','','F'),(275,'Bermuda ','BM','BMU','1 4',1,'en,pt,es','Devonshire,Hamilton,Paget,Pembroke,Sandys,Smith\'s,Southampton,St George\'s,Warwick,Hamilton,St George\'s','NA',2,2,'','','','','','');
/*!40000 ALTER TABLE `countries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `coupons`
--

DROP TABLE IF EXISTS `coupons`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `coupons` (
  `id` int(11) NOT NULL auto_increment,
  `coupon_code` varchar(50) NOT NULL default '',
  `percent_discount` decimal(6,2) NOT NULL default '0.00',
  `dollars_discount` decimal(19,5) NOT NULL default '0.00000',
  `description` varchar(255) NOT NULL default '',
  `expirationdate` date default NULL,
  `maxdollars` decimal(19,6) NOT NULL default '0.000000',
  `useroverride` int(5) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` date default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `coupons`
--

LOCK TABLES `coupons` WRITE;
/*!40000 ALTER TABLE `coupons` DISABLE KEYS */;
/*!40000 ALTER TABLE `coupons` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `courtfiling`
--

DROP TABLE IF EXISTS `courtfiling`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `courtfiling` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `invoicenumber` varchar(30) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `description` text,
  `datefiled` date default NULL,
  `amountfiled` decimal(19,6) NOT NULL default '0.000000',
  `status` int(11) NOT NULL default '-1',
  `judgmentamount` decimal(19,6) NOT NULL default '0.000000',
  `judgmentdate` date default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `datefiled` (`datefiled`),
  KEY `status` (`status`),
  KEY `judgmentdate` (`judgmentdate`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `courtfiling`
--

LOCK TABLES `courtfiling` WRITE;
/*!40000 ALTER TABLE `courtfiling` DISABLE KEYS */;
/*!40000 ALTER TABLE `courtfiling` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cron`
--

DROP TABLE IF EXISTS `cron`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cron` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(45) default NULL,
  `min` tinytext,
  `hr` tinytext,
  `day` tinytext,
  `month` tinytext,
  `event` mediumtext,
  `lastrun` datetime default NULL,
  `companyid` varchar(45) NOT NULL default '0',
  `cancel` tinyint(4) NOT NULL default '0',
  `lastelapsedtime` float NOT NULL default '0',
  `lastoutput` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cron`
--

LOCK TABLES `cron` WRITE;
/*!40000 ALTER TABLE `cron` DISABLE KEYS */;
/*!40000 ALTER TABLE `cron` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `currencies`
--

DROP TABLE IF EXISTS `currencies`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `currencies` (
  `currencies_id` int(5) NOT NULL auto_increment,
  `title` varchar(32) NOT NULL default '',
  `code` char(3) NOT NULL default '',
  `symbol_left` varchar(12) default NULL,
  `symbol_right` varchar(12) default NULL,
  `decimal_point` char(1) default NULL,
  `thousands_point` char(1) default NULL,
  `decimal_places` char(1) default NULL,
  PRIMARY KEY  (`currencies_id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `currencies`
--

LOCK TABLES `currencies` WRITE;
/*!40000 ALTER TABLE `currencies` DISABLE KEYS */;
INSERT INTO `currencies` VALUES (1,'US Dollar','USD','$','USD','.',',','2'),(2,'EURO','EUR','.','.',',','.','2'),(3,'Peso','PS','.','.','.','.','2');
/*!40000 ALTER TABLE `currencies` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `currency`
--

DROP TABLE IF EXISTS `currency`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `currency` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `code` varchar(10) NOT NULL default '',
  `name` varchar(100) NOT NULL default '',
  `symbolbefore` varchar(10) NOT NULL default '',
  `symbolafter` varchar(10) NOT NULL default '',
  `standard` int(11) NOT NULL default '0',
  `decimalplaces` int(11) NOT NULL default '2',
  `unitdecimalplaces` int(11) NOT NULL default '5',
  `active` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `decimalsymbol` varchar(2) NOT NULL default '.',
  `thousandssymbol` varchar(2) NOT NULL default ',',
  `glaccountid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `code` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=172 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `currency`
--

LOCK TABLES `currency` WRITE;
/*!40000 ALTER TABLE `currency` DISABLE KEYS */;
INSERT INTO `currency` VALUES (1,'AED','United Arab Emirates, Dirhams','','AED',1,2,5,0,0,'.',',',0),(2,'AFN','Afghanistan, Afghanis','','AFN',1,2,5,0,0,'.',',',0),(3,'ALL','Albania, Leke','','ALL',1,2,5,0,0,'.',',',0),(4,'AMD','Armenia, Drams','','AMD',1,2,5,0,0,'.',',',0),(5,'ANG','Netherlands Antilles, Guilders (Florins)','','ANG',1,2,5,0,0,'.',',',0),(6,'AOA','Angola, Kwanza','','AOA',1,2,5,0,0,'.',',',0),(7,'ARS','Argentina, Pesos','','ARS',1,2,5,0,0,'.',',',0),(8,'AUD','Australia, Dollars','','AUD',1,2,5,0,0,'.',',',0),(9,'AWG','Aruba, Guilders (Florins)','','AWG',1,2,5,0,0,'.',',',0),(10,'AZN','Azerbaijan, New Manats','','AZN',1,2,5,0,0,'.',',',0),(11,'BAM','Bosnia and Herzegovina, Convertible Marka','','BAM',1,2,5,0,0,'.',',',0),(12,'BBD','Barbados, Dollars','','BBD',1,2,5,0,0,'.',',',0),(13,'BDT','Bangladesh, Taka','','BDT',1,2,5,0,0,'.',',',0),(14,'BGN','Bulgaria, Leva','','BGN',1,2,5,0,0,'.',',',0),(15,'BHD','Bahrain, Dinars','','BHD',1,2,5,0,0,'.',',',0),(16,'BIF','Burundi, Francs','','BIF',1,2,5,0,0,'.',',',0),(17,'BMD','Bermuda, Dollars','','BMD',1,2,5,0,0,'.',',',0),(18,'BND','Brunei Darussalam, Dollars','','BND',1,2,5,0,0,'.',',',0),(19,'BOB','Bolivia, Bolivianos','','BOB',1,2,5,0,0,'.',',',0),(20,'BRL','Brazil, Brazil Real','','BRL',1,2,5,0,0,'.',',',0),(21,'BSD','Bahamas, Dollars','','BSD',1,2,5,0,0,'.',',',0),(22,'BTN','Bhutan, Ngultrum','','BTN',1,2,5,0,0,'.',',',0),(23,'BWP','Botswana, Pulas','','BWP',1,2,5,0,0,'.',',',0),(24,'BYR','Belarus, Rubles','','BYR',1,2,5,0,0,'.',',',0),(25,'BZD','Belize, Dollars','','BZD',1,2,5,0,0,'.',',',0),(26,'CAD','Canada, Dollars','','CAD',1,2,5,0,0,'.',',',0),(27,'CDF','Congo/Kinshasa, Congolese Francs','','CDF',1,2,5,0,0,'.',',',0),(28,'CHF','Switzerland, Francs','','CHF',1,2,5,0,0,'.',',',0),(29,'CLP','Chile, Pesos','','CLP',1,2,5,0,0,'.',',',0),(30,'CNY','China, Yuan Renminbi','','CNY',1,2,5,0,0,'.',',',0),(31,'COP','Colombia, Pesos','','COP',1,2,5,0,0,'.',',',0),(32,'CRC','Costa Rica, Colones','','CRC',1,2,5,0,0,'.',',',0),(33,'CUP','Cuba, Pesos','','CUP',1,2,5,0,0,'.',',',0),(34,'CVE','Cape Verde, Escudos','','CVE',1,2,5,0,0,'.',',',0),(36,'CZK','Czech Republic, Koruny','','CZK',1,2,5,0,0,'.',',',0),(37,'DJF','Djibouti, Francs','','DJF',1,2,5,0,0,'.',',',0),(38,'DKK','Denmark, Kroner','','DKK',1,2,5,0,0,'.',',',0),(39,'DOP','Dominican Republic, Pesos','','DOP',1,2,5,0,0,'.',',',0),(40,'DZD','Algeria, Algeria Dinars','','DZD',1,2,5,0,0,'.',',',0),(41,'EEK','Estonia, Krooni','','EEK',1,2,5,0,0,'.',',',0),(42,'EGP','Egypt, Pounds','','EGP',1,2,5,0,0,'.',',',0),(43,'ERN','Eritrea, Nakfa','','ERN',1,2,5,0,0,'.',',',0),(44,'ETB','Ethiopia, Birr','','ETB',1,2,5,0,0,'.',',',0),(45,'EUR','Euro Member Countries, Euro','','EUR',1,2,5,1,0,'.',',',0),(46,'FJD','Fiji, Dollars','','FJD',1,2,5,0,0,'.',',',0),(47,'FKP','Falkland Islands (Malvinas), Pounds','','FKP',1,2,5,0,0,'.',',',0),(48,'GBP','United Kingdom, Pounds','','GBP',1,2,5,1,0,'.',',',0),(49,'GEL','Georgia, Lari','','GEL',1,2,5,0,0,'.',',',0),(50,'GGP','Guernsey, Pounds','','GGP',1,2,5,0,0,'.',',',0),(51,'GHS','Ghana, Cedis','','GHS',1,2,5,0,0,'.',',',0),(52,'GIP','Gibraltar, Pounds','','GIP',1,2,5,0,0,'.',',',0),(53,'GMD','Gambia, Dalasi','','GMD',1,2,5,0,0,'.',',',0),(54,'GNF','Guinea, Francs','','GNF',1,2,5,0,0,'.',',',0),(55,'GTQ','Guatemala, Quetzales','','GTQ',1,2,5,0,0,'.',',',0),(56,'GYD','Guyana, Dollars','','GYD',1,2,5,0,0,'.',',',0),(57,'HKD','Hong Kong, Dollars','','HKD',1,2,5,0,0,'.',',',0),(58,'HNL','Honduras, Lempiras','','HNL',1,2,5,0,0,'.',',',0),(59,'HRK','Croatia, Kuna','','HRK',1,2,5,0,0,'.',',',0),(60,'HTG','Haiti, Gourdes','','HTG',1,2,5,0,0,'.',',',0),(61,'HUF','Hungary, Forint','','HUF',1,2,5,0,0,'.',',',0),(62,'IDR','Indonesia, Rupiahs','','IDR',1,2,5,0,0,'.',',',0),(63,'ILS','Israel, New Shekels','','ILS',1,2,5,0,0,'.',',',0),(64,'IMP','Isle of Man, Pounds','','IMP',1,2,5,0,0,'.',',',0),(65,'INR','India, Rupees','','INR',1,2,5,0,0,'.',',',0),(66,'IQD','Iraq, Dinars','','IQD',1,2,5,0,0,'.',',',0),(67,'IRR','Iran, Rials','','IRR',1,2,5,0,0,'.',',',0),(68,'ISK','Iceland, Kronur','','ISK',1,2,5,0,0,'.',',',0),(69,'JEP','Jersey, Pounds','','JEP',1,2,5,0,0,'.',',',0),(70,'JMD','Jamaica, Dollars','','JMD',1,2,5,0,0,'.',',',0),(71,'JOD','Jordan, Dinars','','JOD',1,2,5,0,0,'.',',',0),(72,'JPY','Japan, Yen','','JPY',1,2,5,0,0,'.',',',0),(73,'KES','Kenya, Shillings','','KES',1,2,5,0,0,'.',',',0),(74,'KGS','Kyrgyzstan, Soms','','KGS',1,2,5,0,0,'.',',',0),(75,'KHR','Cambodia, Riels','','KHR',1,2,5,0,0,'.',',',0),(76,'KMF','Comoros, Francs','','KMF',1,2,5,0,0,'.',',',0),(77,'KPW','Korea (North), Won','','KPW',1,2,5,0,0,'.',',',0),(78,'KRW','Korea (South), Won','','KRW',1,2,5,0,0,'.',',',0),(79,'KWD','Kuwait, Dinars','','KWD',1,2,5,0,0,'.',',',0),(80,'KYD','Cayman Islands, Dollars','','KYD',1,2,5,0,0,'.',',',0),(81,'KZT','Kazakhstan, Tenge','','KZT',1,2,5,0,0,'.',',',0),(82,'LAK','Laos, Kips','','LAK',1,2,5,0,0,'.',',',0),(83,'LBP','Lebanon, Pounds','','LBP',1,2,5,0,0,'.',',',0),(84,'LKR','Sri Lanka, Rupees','','LKR',1,2,5,0,0,'.',',',0),(85,'LRD','Liberia, Dollars','','LRD',1,2,5,0,0,'.',',',0),(86,'LSL','Lesotho, Maloti','','LSL',1,2,5,0,0,'.',',',0),(87,'LTL','Lithuania, Litai','','LTL',1,2,5,0,0,'.',',',0),(88,'LVL','Latvia, Lati','','LVL',1,2,5,0,0,'.',',',0),(89,'LYD','Libya, Dinars','','LYD',1,2,5,0,0,'.',',',0),(90,'MAD','Morocco, Dirhams','','MAD',1,2,5,0,0,'.',',',0),(91,'MDL','Moldova, Lei','','MDL',1,2,5,0,0,'.',',',0),(92,'MGA','Madagascar, Ariary','','MGA',1,2,5,0,0,'.',',',0),(93,'MKD','Macedonia, Denars','','MKD',1,2,5,0,0,'.',',',0),(94,'MMK','Myanmar (Burma), Kyats','','MMK',1,2,5,0,0,'.',',',0),(95,'MNT','Mongolia, Tugriks','','MNT',1,2,5,0,0,'.',',',0),(96,'MOP','Macau, Patacas','','MOP',1,2,5,0,0,'.',',',0),(97,'MRO','Mauritania, Ouguiyas','','MRO',1,2,5,0,0,'.',',',0),(99,'MUR','Mauritius, Rupees','','MUR',1,2,5,0,0,'.',',',0),(100,'MVR','Maldives (Maldive Islands), Rufiyaa','','MVR',1,2,5,0,0,'.',',',0),(101,'MWK','Malawi, Kwachas','','MWK',1,2,5,0,0,'.',',',0),(102,'MXN','Mexico, Pesos','','MXN',1,2,5,0,0,'.',',',0),(103,'MYR','Malaysia, Ringgits','','MYR',1,2,5,0,0,'.',',',0),(104,'MZN','Mozambique, Meticais','','MZN',1,2,5,0,0,'.',',',0),(105,'NAD','Namibia, Dollars','','NAD',1,2,5,0,0,'.',',',0),(106,'NGN','Nigeria, Nairas','','NGN',1,2,5,0,0,'.',',',0),(107,'NIO','Nicaragua, Cordobas','','NIO',1,2,5,0,0,'.',',',0),(108,'NOK','Norway, Krone','','NOK',1,2,5,0,0,'.',',',0),(109,'NPR','Nepal, Nepal Rupees','','NPR',1,2,5,0,0,'.',',',0),(110,'NZD','New Zealand, Dollars','','NZD',1,2,5,0,0,'.',',',0),(111,'OMR','Oman, Rials','','OMR',1,2,5,0,0,'.',',',0),(112,'PAB','Panama, Balboa','','PAB',1,2,5,0,0,'.',',',0),(113,'PEN','Peru, Nuevos Soles','','PEN',1,2,5,0,0,'.',',',0),(114,'PGK','Papua New Guinea, Kina','','PGK',1,2,5,0,0,'.',',',0),(115,'PHP','Philippines, Pesos','','PHP',1,2,5,0,0,'.',',',0),(116,'PKR','Pakistan, Rupees','','PKR',1,2,5,0,0,'.',',',0),(117,'PLN','Poland, Zlotych','','PLN',1,2,5,0,0,'.',',',0),(118,'PYG','Paraguay, Guarani','','PYG',1,2,5,0,0,'.',',',0),(119,'QAR','Qatar, Rials','','QAR',1,2,5,0,0,'.',',',0),(120,'RON','Romania, New Lei','','RON',1,2,5,0,0,'.',',',0),(121,'RSD','Serbia, Dinars','','RSD',1,2,5,0,0,'.',',',0),(122,'RUB','Russia, Rubles','','RUB',1,2,5,0,0,'.',',',0),(123,'RWF','Rwanda, Rwanda Francs','','RWF',1,2,5,0,0,'.',',',0),(124,'SAR','Saudi Arabia, Riyals','','SAR',1,2,5,0,0,'.',',',0),(125,'SBD','Solomon Islands, Dollars','','SBD',1,2,5,0,0,'.',',',0),(126,'SCR','Seychelles, Rupees','','SCR',1,2,5,0,0,'.',',',0),(127,'SDG','Sudan, Pounds','','SDG',1,2,5,0,0,'.',',',0),(128,'SEK','Sweden, Kronor','','SEK',1,2,5,0,0,'.',',',0),(129,'SGD','Singapore, Dollars','','SGD',1,2,5,0,0,'.',',',0),(130,'SHP','Saint Helena, Pounds','','SHP',1,2,5,0,0,'.',',',0),(131,'SLL','Sierra Leone, Leones','','SLL',1,2,5,0,0,'.',',',0),(132,'SOS','Somalia, Shillings','','SOS',1,2,5,0,0,'.',',',0),(133,'SPL','Seborga, Luigini','','SPL',1,2,5,0,0,'.',',',0),(134,'SRD','Suriname, Dollars','','SRD',1,2,5,0,0,'.',',',0),(135,'STD','SÃ£o Tome and Principe, Dobras','','STD',1,2,5,0,0,'.',',',0),(136,'SVC','El Salvador, Colones','','SVC',1,2,5,0,0,'.',',',0),(137,'SYP','Syria, Pounds','','SYP',1,2,5,0,0,'.',',',0),(138,'SZL','Swaziland, Emalangeni','','SZL',1,2,5,0,0,'.',',',0),(139,'THB','Thailand, Baht','','THB',1,2,5,0,0,'.',',',0),(140,'TJS','Tajikistan, Somoni','','TJS',1,2,5,0,0,'.',',',0),(141,'TMM','Turkmenistan, Manats','','TMM',1,2,5,0,0,'.',',',0),(142,'TND','Tunisia, Dinars','','TND',1,2,5,0,0,'.',',',0),(143,'TOP','Tonga, Pa\'anga','','TOP',1,2,5,0,0,'.',',',0),(144,'TRY','Turkey, New Lira','','TRY',1,2,5,0,0,'.',',',0),(145,'TTD','Trinidad and Tobago, Dollars','','TTD',1,2,5,0,0,'.',',',0),(146,'TVD','Tuvalu, Tuvalu Dollars','','TVD',1,2,5,0,0,'.',',',0),(147,'TWD','Taiwan, New Dollars','','TWD',1,2,5,0,0,'.',',',0),(148,'TZS','Tanzania, Shillings','','TZS',1,2,5,0,0,'.',',',0),(149,'UAH','Ukraine, Hryvnia','','UAH',1,2,5,0,0,'.',',',0),(150,'UGX','Uganda, Shillings','','UGX',1,2,5,0,0,'.',',',0),(151,'USD','United States of America, Dollars','$','',1,2,3,1,0,'.',',',0),(152,'UYU','Uruguay, Pesos','','UYU',1,2,5,0,0,'.',',',0),(153,'UZS','Uzbekistan, Sums','','UZS',1,2,5,0,0,'.',',',0),(155,'VEF','Venezuela, Bolivares Fuertes','','VEF',1,2,5,0,0,'.',',',0),(156,'VND','Viet Nam, Dong','','VND',1,2,5,0,0,'.',',',0),(157,'VUV','Vanuatu, Vatu','','VUV',1,2,5,0,0,'.',',',0),(158,'WST','Samoa, Tala','','WST',1,2,5,0,0,'.',',',0),(159,'XAF','CommunautÃ© FinanciÃ¨re Africaine BEAC, Francs','','XAF',1,2,5,0,0,'.',',',0),(160,'XAG','Silver, Ounces','','XAG',1,2,5,0,0,'.',',',0),(161,'XAU','Gold, Ounces','','XAU',1,2,5,0,0,'.',',',0),(162,'XCD','East Caribbean Dollars','','XCD',1,2,5,0,0,'.',',',0),(163,'XDR','International Monetary Fund (IMF) Special Drawing Rights','','XDR',1,2,5,0,0,'.',',',0),(164,'XOF','CommunautÃ© FinanciÃ¨re Africaine BCEAO, Francs','','XOF',1,2,5,0,0,'.',',',0),(165,'XPD','Palladium Ounces','','XPD',1,2,5,0,0,'.',',',0),(166,'XPF','Comptoirs FranÃ§ais du Pacifique Francs','','XPF',1,2,5,0,0,'.',',',0),(167,'XPT','Platinum, Ounces','','XPT',1,2,5,0,0,'.',',',0),(168,'YER','Yemen, Rials','','YER',1,2,5,0,0,'.',',',0),(169,'ZAR','South Africa, Rand','','ZAR',1,2,5,0,0,'.',',',0),(170,'ZMK','Zambia, Kwacha','','ZMK',1,2,5,0,0,'.',',',0),(171,'ZWD','Zimbabwe, Zimbabwe Dollars','','ZWD',1,2,5,0,0,'.',',',0);
/*!40000 ALTER TABLE `currency` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `currencydenomination`
--

DROP TABLE IF EXISTS `currencydenomination`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `currencydenomination` (
  `id` int(11) NOT NULL auto_increment,
  `currency` varchar(10) NOT NULL default 'USD',
  `label` varchar(255) NOT NULL default '',
  `value` decimal(19,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`id`),
  KEY `curr` (`currency`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `currencydenomination`
--

LOCK TABLES `currencydenomination` WRITE;
/*!40000 ALTER TABLE `currencydenomination` DISABLE KEYS */;
INSERT INTO `currencydenomination` VALUES (1,'USD','Pennies','0.0100'),(2,'USD','Nickels','0.0500'),(3,'USD','Dimes','0.1000'),(4,'USD','Quarters','0.2500'),(5,'USD','$1','1.0000'),(6,'USD','$5','5.0000'),(7,'USD','$10','10.0000'),(8,'USD','$20','20.0000'),(9,'USD','$50','50.0000'),(10,'USD','$100','100.0000');
/*!40000 ALTER TABLE `currencydenomination` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `currencylog`
--

DROP TABLE IF EXISTS `currencylog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `currencylog` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `curfrom` varchar(10) NOT NULL default '',
  `curto` varchar(10) NOT NULL default '',
  `currate` decimal(22,10) NOT NULL default '1.0000000000',
  `curdate` date NOT NULL default '0000-00-00',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `date_from_to` (`curdate`,`curfrom`,`curto`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `currencylog`
--

LOCK TABLES `currencylog` WRITE;
/*!40000 ALTER TABLE `currencylog` DISABLE KEYS */;
/*!40000 ALTER TABLE `currencylog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer`
--

DROP TABLE IF EXISTS `customer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customer` (
  `id` int(11) NOT NULL auto_increment,
  `taxexemptid` int(11) NOT NULL default '0',
  `creditlimit` double NOT NULL default '0',
  `salesglacctid` int(11) NOT NULL default '0',
  `salesmanid` int(11) NOT NULL default '0',
  `servicerepid` int(11) NOT NULL default '0',
  `invoicetermsid` int(11) NOT NULL default '0',
  `quotecommentid` int(11) NOT NULL default '0',
  `interest` int(11) NOT NULL default '1',
  `billtoattnname` varchar(30) default NULL,
  `quoteattnname` varchar(30) default NULL,
  `chargecode` varchar(30) default NULL,
  `salestaxnum` varchar(30) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `companyname` varchar(100) NOT NULL default '',
  `address1` varchar(100) NOT NULL default '',
  `address2` varchar(100) NOT NULL default '',
  `mailstop` varchar(20) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  `state` varchar(20) NOT NULL default '',
  `zip` varchar(15) NOT NULL default '',
  `country` varchar(20) NOT NULL default '',
  `phone1` varchar(20) NOT NULL default '',
  `phone1comment` varchar(20) NOT NULL default '',
  `phone1type` varchar(8) default NULL,
  `phone2` varchar(20) NOT NULL default '',
  `phone2comment` varchar(20) NOT NULL default '',
  `phone2type` varchar(8) default NULL,
  `phone3` varchar(20) NOT NULL default '',
  `phone3comment` varchar(20) NOT NULL default '',
  `phone3type` varchar(8) default NULL,
  `phone4` varchar(20) NOT NULL default '',
  `phone4comment` varchar(20) NOT NULL default '',
  `phone4type` varchar(8) default NULL,
  `textphone` varchar(20) NOT NULL default '',
  `mobilecarrierid` int(2) NOT NULL default '0',
  `email1` varchar(255) NOT NULL default '',
  `email1comment` varchar(20) NOT NULL default '',
  `email1sendinvoices` tinyint(1) NOT NULL default '1',
  `email1sendconfs` tinyint(1) NOT NULL default '1',
  `email1sendquotes` tinyint(1) NOT NULL default '1',
  `email1prelim` tinyint(1) NOT NULL default '1',
  `email2` varchar(255) NOT NULL default '',
  `email2comment` varchar(20) NOT NULL default '',
  `email2sendinvoices` tinyint(1) NOT NULL default '0',
  `email2sendconfs` tinyint(1) NOT NULL default '0',
  `email2sendquotes` tinyint(1) NOT NULL default '0',
  `email2prelim` tinyint(1) NOT NULL default '0',
  `email1statements` tinyint(1) NOT NULL default '1',
  `email2statements` tinyint(1) NOT NULL default '0',
  `rentalsbillwhen` tinyint(1) NOT NULL default '2',
  `paymeth` int(11) NOT NULL default '0',
  `defaulttopaymentonaccount` tinyint(1) NOT NULL default '0',
  `prelimable` tinyint(1) NOT NULL default '0',
  `on_hold` tinyint(1) NOT NULL default '0',
  `on_hold_date` datetime default NULL,
  `on_hold_userid` int(11) NOT NULL default '0',
  `b2ballowccpay` tinyint(1) NOT NULL default '1',
  `invoicenotificationmethod` varchar(1) NOT NULL default '',
  `statementnotificationmethod` varchar(1) NOT NULL default '',
  `requireponumberonorders` tinyint(1) NOT NULL default '0',
  `allowspecialpricing` tinyint(1) NOT NULL default '0',
  `specialpricingstatic` tinyint(1) NOT NULL default '2',
  `coachname` varchar(100) NOT NULL default '',
  `maintenanceplanactive` tinyint(1) NOT NULL default '0',
  `maintenanceplanstart` varchar(8) default '',
  `maintenanceplanend` varchar(8) default '',
  `maintenanceplancomments` mediumtext NOT NULL,
  `acceptbackorders` tinyint(1) NOT NULL default '0',
  `authorizedbuyersonly` tinyint(1) NOT NULL default '0',
  `exemptdeliverycharge` tinyint(1) NOT NULL default '0',
  `exemptfuelcharge` tinyint(1) NOT NULL default '0',
  `showpricesondeliveryconf` tinyint(1) NOT NULL default '0',
  `deliverysalesonly` tinyint(1) NOT NULL default '0',
  `allowordermodifications` tinyint(1) NOT NULL default '0',
  `jobnumberrequired` tinyint(1) NOT NULL default '0',
  `prelimjobsales` tinyint(1) NOT NULL default '0',
  `toolsonjob` tinyint(1) NOT NULL default '0',
  `shipifincompletejobinfo` tinyint(1) NOT NULL default '0',
  `addressverified` varchar(32) default '',
  `creditapplicationreceived` tinyint(1) NOT NULL default '0',
  `creditapplicationreceiveddate` date default NULL,
  `taxexemptiondate` date default NULL,
  `authorizedbuyer` tinyint(1) NOT NULL default '0',
  `closed` tinyint(1) NOT NULL default '0',
  `closed_date` datetime default NULL,
  `closed_userid` int(11) NOT NULL default '0',
  `interestchargeoptionid` int(11) NOT NULL default '0',
  `b2bnopaymentfee` tinyint(1) NOT NULL default '0',
  `website` varchar(100) NOT NULL default '',
  `federalid` varchar(20) NOT NULL default '',
  `entry_gender` char(1) NOT NULL default '',
  `entry_firstname` varchar(32) NOT NULL default '',
  `entry_lastname` varchar(32) NOT NULL default '',
  `entry_country_id` int(5) NOT NULL default '0',
  `entry_zone_id` int(5) NOT NULL default '0',
  `image` varchar(64) NOT NULL default '',
  `customers_dob` varchar(8) default '',
  `customers_password` varchar(40) default '',
  `customers_promotion_ok` tinyint(1) default '0',
  `customer_price_level` int(11) default NULL,
  `points_earned` decimal(8,2) default '0.00',
  `current_sales_process` int(11) NOT NULL default '0',
  `notes` longtext,
  `default_po` varchar(30) default NULL,
  `customercode` varchar(30) NOT NULL default '',
  `preprint_from_box_labels` int(2) NOT NULL default '0',
  `notify_order` int(2) NOT NULL default '0',
  `notify_ship` int(2) NOT NULL default '0',
  `notify_invoice` int(2) NOT NULL default '0',
  `email_order_acknowledgement` int(2) NOT NULL default '0',
  `email_order_ship` int(2) NOT NULL default '0',
  `email_invoice` int(2) NOT NULL default '0',
  `groupid` int(11) NOT NULL default '0',
  `onlygroupitems_onb2b` int(5) NOT NULL default '0',
  `taxgroupid` int(11) NOT NULL default '0',
  `salescategoryid` int(11) NOT NULL default '0',
  `weather_cf` char(1) default NULL,
  `weather_zip` varchar(20) default NULL,
  `time_zone` varchar(6) default '+00:00',
  `salutation` varchar(20) default NULL,
  `middle_name` varchar(50) default NULL,
  `name_suffix` varchar(20) default NULL,
  `currency` varchar(10) NOT NULL default 'USD',
  `customertypeid` int(11) NOT NULL default '0',
  `appstatus` char(1) NOT NULL default '',
  `areaid` int(11) NOT NULL default '0',
  `coinvoicecustomer` int(11) NOT NULL default '0',
  `nocredit` int(5) NOT NULL default '0',
  `nocredit_note` varchar(255) NOT NULL default '',
  `autobill` int(11) NOT NULL default '0',
  `pricelist_prepaybycc` int(5) NOT NULL default '0',
  `companyname2` varchar(50) NOT NULL default '',
  `auto_shipped_email` tinyint(4) default '0',
  `auto_invoiced_email` tinyint(4) NOT NULL default '0',
  `autosendordercreatedemail` tinyint(1) NOT NULL default '0',
  `bankrouting` varchar(50) default NULL,
  `bankaccountnum` varchar(100) default NULL,
  `service_worktypeid` int(11) NOT NULL default '0',
  `requirestatement` tinyint(4) NOT NULL default '1',
  `invoiceemailtemplateid` int(11) NOT NULL default '0',
  `numinvoicecopies` int(11) NOT NULL default '1',
  `lead` tinyint(1) NOT NULL default '0',
  `timezoneid` int(11) NOT NULL default '0',
  `taskstatusid` int(11) NOT NULL default '0',
  `defaultshiptotaxexemptid` int(11) NOT NULL default '0',
  `defaultshiptotaxexemptappliestopos` tinyint(1) NOT NULL default '0',
  `showpricesonpackingslip` tinyint(1) NOT NULL default '0',
  `sendinterestinvoices` tinyint(1) NOT NULL default '0',
  `appointmentreminderpreference` tinyint(1) NOT NULL default '0',
  `invoicetermsidrevertonhold` int(11) NOT NULL default '0',
  `notallowedtounchecktaxboxesonlineitems` tinyint(1) NOT NULL default '0',
  `nocheckpayment` tinyint(1) NOT NULL default '0',
  `nocreditcardpayment` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `taxexemptid` (`taxexemptid`),
  KEY `salesglacctid` (`salesglacctid`),
  KEY `salesmanid` (`salesmanid`),
  KEY `servicerepid` (`servicerepid`),
  KEY `invoicetermsid` (`invoicetermsid`),
  KEY `quotecommentid` (`quotecommentid`),
  KEY `groupid` (`groupid`),
  KEY `taxgroupid` (`taxgroupid`),
  KEY `taskstatusid` (`taskstatusid`),
  KEY `lead` (`lead`),
  KEY `defaultshiptotaxexemptid` (`defaultshiptotaxexemptid`),
  KEY `zip` (`zip`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer`
--

LOCK TABLES `customer` WRITE;
/*!40000 ALTER TABLE `customer` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_product`
--

DROP TABLE IF EXISTS `customer_product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customer_product` (
  `customers_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL default '0',
  `approved_price` decimal(19,4) NOT NULL default '0.0000',
  `comments` varchar(60) default NULL,
  `last_modified` datetime default NULL,
  PRIMARY KEY  (`customers_id`,`products_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_product`
--

LOCK TABLES `customer_product` WRITE;
/*!40000 ALTER TABLE `customer_product` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_product` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customerbank`
--

DROP TABLE IF EXISTS `customerbank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customerbank` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `routingnumber` varchar(9) NOT NULL default '',
  `accountnumber` varchar(20) NOT NULL default '',
  `accounttype` varchar(20) NOT NULL default '',
  `accountname` varchar(50) NOT NULL default '',
  `bankname` varchar(50) NOT NULL default '',
  `defaultaccount` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customerbank`
--

LOCK TABLES `customerbank` WRITE;
/*!40000 ALTER TABLE `customerbank` DISABLE KEYS */;
/*!40000 ALTER TABLE `customerbank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customergroup`
--

DROP TABLE IF EXISTS `customergroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customergroup` (
  `id` int(11) NOT NULL auto_increment,
  `groupid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `groupid` (`groupid`),
  KEY `customerid` (`customerid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customergroup`
--

LOCK TABLES `customergroup` WRITE;
/*!40000 ALTER TABLE `customergroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `customergroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customeritemdiscount`
--

DROP TABLE IF EXISTS `customeritemdiscount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customeritemdiscount` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `discountpercent` decimal(6,2) NOT NULL default '0.00',
  `discountflat` decimal(19,6) NOT NULL default '0.000000',
  `companyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `notes` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `itemid` (`itemid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customeritemdiscount`
--

LOCK TABLES `customeritemdiscount` WRITE;
/*!40000 ALTER TABLE `customeritemdiscount` DISABLE KEYS */;
/*!40000 ALTER TABLE `customeritemdiscount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customers_basket`
--

DROP TABLE IF EXISTS `customers_basket`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customers_basket` (
  `customers_basket_id` int(5) NOT NULL auto_increment,
  `customers_id` int(5) NOT NULL default '0',
  `products_id` int(5) NOT NULL default '0',
  `inventorylocationid` int(11) default NULL,
  `customers_basket_quantity` int(2) NOT NULL default '0',
  `final_price` decimal(6,2) NOT NULL default '0.00',
  `customers_basket_date_added` varchar(8) default NULL,
  `discount_comment` varchar(60) default NULL,
  `lineitem` int(11) NOT NULL default '0',
  PRIMARY KEY  (`customers_basket_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customers_basket`
--

LOCK TABLES `customers_basket` WRITE;
/*!40000 ALTER TABLE `customers_basket` DISABLE KEYS */;
/*!40000 ALTER TABLE `customers_basket` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customers_basket_attributes`
--

DROP TABLE IF EXISTS `customers_basket_attributes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customers_basket_attributes` (
  `customers_basket_attributes_id` int(5) NOT NULL auto_increment,
  `customers_id` int(5) NOT NULL default '0',
  `products_id` int(5) NOT NULL default '0',
  `products_options_id` int(5) NOT NULL default '0',
  `products_options_value_id` int(5) NOT NULL default '0',
  `lineitem` int(11) NOT NULL default '0',
  `value` varchar(255) NOT NULL default '',
  `iogid` int(11) NOT NULL default '0',
  `ioid` int(11) NOT NULL default '0',
  `selection` int(11) NOT NULL default '0',
  `notes` text NOT NULL,
  PRIMARY KEY  (`customers_basket_attributes_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customers_basket_attributes`
--

LOCK TABLES `customers_basket_attributes` WRITE;
/*!40000 ALTER TABLE `customers_basket_attributes` DISABLE KEYS */;
/*!40000 ALTER TABLE `customers_basket_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customers_info`
--

DROP TABLE IF EXISTS `customers_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customers_info` (
  `customers_info_id` int(5) NOT NULL default '0',
  `customers_info_date_of_last_logon` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `customers_info_number_of_logons` int(5) default NULL,
  `customers_info_date_account_created` timestamp NOT NULL default '0000-00-00 00:00:00',
  `customers_info_date_account_last_modified` timestamp NOT NULL default '0000-00-00 00:00:00',
  `customers_info_last_verify_date` timestamp NOT NULL default '0000-00-00 00:00:00',
  `customers_info_status` char(10) default NULL,
  PRIMARY KEY  (`customers_info_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customers_info`
--

LOCK TABLES `customers_info` WRITE;
/*!40000 ALTER TABLE `customers_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `customers_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customersalestax`
--

DROP TABLE IF EXISTS `customersalestax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customersalestax` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `salestaxid` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `salestaxid` (`salestaxid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customersalestax`
--

LOCK TABLES `customersalestax` WRITE;
/*!40000 ALTER TABLE `customersalestax` DISABLE KEYS */;
/*!40000 ALTER TABLE `customersalestax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customhelp`
--

DROP TABLE IF EXISTS `customhelp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customhelp` (
  `id` int(11) NOT NULL auto_increment,
  `page` varchar(100) NOT NULL default '',
  `filename` varchar(255) NOT NULL default '',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `page` (`page`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customhelp`
--

LOCK TABLES `customhelp` WRITE;
/*!40000 ALTER TABLE `customhelp` DISABLE KEYS */;
/*!40000 ALTER TABLE `customhelp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `db_explanation`
--

DROP TABLE IF EXISTS `db_explanation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `db_explanation` (
  `id_db_explanation` int(11) NOT NULL auto_increment,
  `table_name` varchar(255) NOT NULL default '',
  `field_name` varchar(255) NOT NULL default '',
  `field_length` int(11) NOT NULL default '0',
  `field_type` varchar(255) NOT NULL default 'Integer',
  `field_value` varchar(255) NOT NULL default '',
  `field_explanation` text,
  `field_key_type` varchar(255) NOT NULL default 'none',
  `field_key_table_name` varchar(255) default NULL,
  PRIMARY KEY  (`id_db_explanation`),
  KEY `table_name` (`table_name`),
  KEY `field_name` (`field_name`)
) ENGINE=InnoDB AUTO_INCREMENT=5217 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `db_explanation`
--

LOCK TABLES `db_explanation` WRITE;
/*!40000 ALTER TABLE `db_explanation` DISABLE KEYS */;
INSERT INTO `db_explanation` VALUES (1,'accounttype','id',11,'Integer','10=Assets Current\r\n11=Assets Fixed\r\n13=Other Assets\r\n21=Liabilities Current\r\n22=Liabilities Long-Term\r\n23=Liabilities Other\r\n30=Equity\r\n40=Retained Earnings\r\n50=Sales\r\n60=Sales Adjustments\r\n70=Cost of Goods Sold\r\n80=Expenses\r\n90=Other Income and Expenses','For GL to determine whether the associated accounts are ASSETS, LIABILITIES, etc. These IDs cannot be added to by users.','primary unique','self'),(2,'accounttype','description',30,'Text','any','Explanation of purpose','',''),(3,'achcode','code',3,'Text','','Error Codes returned by ACH transactions','primary',''),(4,'achcode','description',70,'Text','','Complete text of what error code means','',''),(5,'achfile','id',11,'Integer','','','primary','self'),(6,'achfile','filecontents',65535,'X','','copy of file sent','',''),(7,'achfile','description',10,'Text','','','',''),(8,'achfile','totalcreditamount',21,'Numeric','','Credit amount total for file','',''),(9,'achfile','totaldebitamount',21,'Numeric','','Debit amount total for file','',''),(10,'achfile','totalrecords',11,'Integer','','Total number of detail records contained in file','',''),(11,'achfile','checkacctid',11,'Integer','','id of checking account','multiple','checkacct'),(12,'achfile','gencompanyid',11,'Integer','','NolaPro Company','multiple','gencompany'),(13,'achfile','sent',2,'Integer','0,1','1=sent file','',''),(14,'achfile','sentdate',19,'DateTime','','Date file sent','',''),(15,'achfile','effectivedate',10,'Date','','Date ACH transaction to take place','',''),(16,'achfile','entrydate',19,'DateTime','','Date Entered in system','',''),(17,'achfile','entryuserid',11,'Integer','','Who entered','multiple','genuser'),(18,'achfile','cancel',2,'Integer','0,1','1=cancelled','',''),(19,'achfile','canceldate',19,'DateTime','','date cancelled','',''),(20,'achfile','canceluserid',11,'Integer','','who cancelled','multiple','genuser'),(21,'achfiledetail','id',11,'Integer','','','primary','self'),(22,'achfiledetail','achfileid',11,'Integer','','Which achfile record was this detail grouped with','multiple','achfile'),(23,'achfiledetail','premployeeid',11,'Integer','','Payroll employee being paid','multiple','premployee.id'),(24,'achfiledetail','bankaccountid',11,'Integer','','','multiple',''),(25,'achfiledetail','achcode',3,'Text','','return error code from ACH process','multiple',''),(26,'achfiledetail','routing',9,'Text','','','',''),(27,'achfiledetail','accountnumber',17,'Text','','','',''),(28,'achfiledetail','bankname',100,'Text','','','',''),(29,'achfiledetail','originalvoucher',50,'Text','','','',''),(30,'achfiledetail','recordtype',2,'Integer','','','',''),(31,'achfiledetail','recorddata',94,'Text','','','',''),(32,'achfiledetail','transactioncode',2,'Text','','','',''),(33,'achfiledetail','amount',21,'Numeric','','','',''),(34,'achfiledetail','name',100,'Text','','','',''),(35,'achfiledetail','tracenumber',15,'Text','','','',''),(36,'achfiledetail','gencompanyid',11,'Integer','','NolaPro Company','multiple','gencompany.id'),(37,'achfiledetail','entrydate',19,'DateTime','','','',''),(38,'achfiledetail','entryuserid',11,'Integer','','Who entered','multiple','genuser.id'),(39,'achfiledetail','cancel',2,'Integer','','','',''),(40,'achfiledetail','canceldate',19,'DateTime','','','',''),(41,'achfiledetail','canceluserid',11,'Integer','','Who cancelled','multiple','genuser.id'),(42,'achfiledownload','id',11,'Integer','','','primary',''),(43,'achfiledownload','achfileid',11,'Integer','','','multiple',''),(44,'achfiledownload','userid',11,'Integer','','','multiple',''),(45,'achfiledownload','downloaddate',19,'DateTime','','','',''),(46,'action','id',11,'Integer','','','primary',''),(47,'action','action',100,'Text','','','',''),(48,'address_format','address_format_id',5,'Integer','','','primary',''),(49,'address_format','address_format',128,'Text','','','',''),(50,'address_format','address_summary',48,'Text','','','',''),(51,'airport','id',11,'Integer','','','primary',''),(52,'airport','airportcode',5,'Text','','','',''),(53,'airport','airportname',200,'Text','','','',''),(54,'airport','sales_categoriesid',11,'Integer','','','',''),(55,'airport','cancel',2,'Integer','','','multiple',''),(56,'airport','canceldate',19,'DateTime','','','',''),(57,'airport','canceluserid',11,'Integer','','','',''),(58,'airport_category','id',11,'Integer','','','primary',''),(59,'airport_category','name',50,'Text','','','',''),(60,'airport_category','cancel',2,'Integer','','','multiple',''),(61,'airport_category','canceldate',19,'DateTime','','','',''),(62,'airport_category','canceluserid',11,'Integer','','','',''),(63,'airport_order','id',11,'Integer','','','primary',''),(64,'airport_order','airportid',11,'Integer','','','multiple',''),(65,'airport_order','agentid',11,'Integer','','','multiple',''),(66,'airport_order','customerid',11,'Integer','','','multiple',''),(67,'airport_order','entrydate',19,'DateTime','','','',''),(68,'airport_order','departure_date',19,'DateTime','','','multiple',''),(69,'airport_order','return_date',19,'DateTime','','','',''),(70,'airport_order','card_type',10,'Text','','','',''),(71,'airport_order','transid',11,'Integer','','','multiple',''),(72,'airport_order','encrypted_card',50,'Text','','','',''),(73,'airport_order','card_last4',4,'Text','','','',''),(74,'airport_order','confirmcode',15,'Text','','','',''),(75,'airport_order','cancelcode',15,'Text','','','',''),(76,'airport_order','cancel',2,'Integer','','','multiple',''),(77,'airport_order','email',100,'Text','','','',''),(78,'airport_order','firstname',50,'Text','','','',''),(79,'airport_order','lastname',100,'Text','','','',''),(80,'airport_order','address',200,'Text','','','',''),(81,'airport_order','city',50,'Text','','','',''),(82,'airport_order','state',50,'Text','','','',''),(83,'airport_order','zip',15,'Text','','','',''),(84,'airport_order','phone',50,'Text','','','',''),(85,'airport_order','compupark',100,'Text','','','',''),(86,'airport_order','card_expiration',4,'Text','','','',''),(87,'airport_order','canceldate',19,'DateTime','','','',''),(88,'airport_order','canceluserid',11,'Integer','','','',''),(89,'airport_order','status',5,'Integer','','','',''),(90,'airport_order','parking_days',11,'Integer','','','',''),(91,'airport_order','parking_fee',12,'Numeric','','','',''),(92,'airport_order','agent_commission',14,'Numeric','','','',''),(93,'airport_order','vendor_commission',14,'Numeric','','','',''),(94,'airport_order','total_charge',14,'Numeric','','','',''),(95,'airport_order_details','id',11,'Integer','','','primary',''),(96,'airport_order_details','orderid',11,'Integer','','','multiple',''),(97,'airport_order_details','serviceid',11,'Integer','','','multiple',''),(98,'airport_order_details','description',50,'Text','','','',''),(99,'airport_order_details','price',14,'Numeric','','','',''),(100,'airport_order_details','cancel',2,'Integer','','','multiple',''),(101,'airport_parking','id',11,'Integer','','','primary',''),(102,'airport_parking','airportid',11,'Integer','','','multiple',''),(103,'airport_parking','num_days',5,'Integer','','','',''),(104,'airport_parking','price',12,'Numeric','','','',''),(105,'airport_parking','airport_fee_flat_charge',12,'Numeric','','','',''),(106,'airport_parking','airport_fee_percent_charge',12,'Numeric','','','',''),(107,'airport_parking','flat_commission',12,'Numeric','','','',''),(108,'airport_parking','percent_commission',12,'Numeric','','','',''),(109,'airport_parking','cancel',2,'Integer','','','multiple',''),(110,'airport_parking','canceldate',19,'DateTime','','','',''),(111,'airport_parking','canceluserid',11,'Integer','','','',''),(112,'airport_service','id',11,'Integer','','','primary',''),(113,'airport_service','airportid',11,'Integer','','','multiple',''),(114,'airport_service','serviceid',11,'Integer','','','multiple',''),(115,'airport_service','flat_commission',12,'Numeric','','','',''),(116,'airport_service','percent_commission',12,'Numeric','','','',''),(117,'airport_service','cancel',2,'Integer','','','multiple',''),(118,'airport_service','canceldate',19,'DateTime','','','',''),(119,'airport_service','canceluserid',11,'Integer','','','',''),(120,'airport_service','price',14,'Numeric','','','',''),(121,'apbill','id',22,'Numeric','','','primary unique',''),(122,'apbill','invoicenumber',20,'Text','','','multiple',''),(123,'apbill','cancel',11,'Integer','1=cancel\r\n0=open','Flag if cancelled','',''),(124,'apbill','complete',11,'Integer','1=complete\r\n0=not complete','If bill fully paid off','',''),(125,'apbill','paynone',11,'Integer','1=do not pay\r\n0=ok to pay','','',''),(126,'apbill','total',21,'Numeric','','','',''),(127,'apbill','description',50,'Text','','','',''),(128,'apbill','dateofinvoice',10,'Date','','','',''),(129,'apbill','duedate',10,'Date','','','',''),(130,'apbill','discountamount',21,'Numeric','','calculated discount before paid, actual discount after paid','',''),(131,'apbill','discountdate',10,'Date','','Date through which discount is allowed','',''),(132,'apbill','vendorid',22,'Numeric','','','',''),(133,'apbill','comment',65535,'X','','','',''),(134,'apbill','gencompanyid',22,'Numeric','','Internal Company','',''),(135,'apbill','wherefrom',11,'Integer','','integer = what module originated this entry.','multiple',''),(136,'apbill','entrydate',19,'DateTime','','','',''),(137,'apbill','entryuserid',22,'Numeric','','Who entered','',''),(138,'apbill','lastchangedate',19,'DateTime','','','',''),(139,'apbill','lastchangeuserid',22,'Numeric','','','',''),(140,'apbill','canceldate',19,'DateTime','','date cancelled','',''),(141,'apbill','canceluserid',22,'Numeric','','who cancelled','',''),(142,'apbilldetail','id',22,'Numeric','','','primary unique',''),(143,'apbilldetail','apbillid',22,'Numeric','','','multiple',''),(144,'apbilldetail','amount',21,'Numeric','','','',''),(145,'apbilldetail','glaccountid',22,'Numeric','','','multiple',''),(146,'apbilldetail','invreceiveid',22,'Numeric','','','multiple',''),(147,'apbillpayment','id',22,'Numeric','','','primary unique',''),(148,'apbillpayment','apbillid',22,'Numeric','','','multiple',''),(149,'apbillpayment','amount',21,'Numeric','','','',''),(150,'apbillpayment','interest',21,'Numeric','','','',''),(151,'apbillpayment','checkid',22,'Numeric','','','multiple',''),(152,'apbillpayment','checkvoid',11,'Integer','','','multiple',''),(153,'apbillpayment','complete',2,'Integer','','','multiple',''),(154,'apbillpayment','currentvoucherid',11,'Integer','','','',''),(155,'apbillpayment','voidvoucherid',11,'Integer','','','',''),(156,'apbillpayment','entrydate',19,'DateTime','','','',''),(157,'apbillpayment','entryuserid',22,'Numeric','','','',''),(158,'apbillpayment','lastchangedate',19,'DateTime','','','',''),(159,'apbillpayment','lastchangeuserid',22,'Numeric','','','',''),(160,'apbillpayment','paymethod',11,'Integer','','','',''),(161,'apcompany','id',22,'Numeric','','','multiple',''),(162,'apcompany','payable',22,'Numeric','','','',''),(163,'apcompany','interestexpense',22,'Numeric','','','',''),(164,'apcompany','discount',22,'Numeric','','','',''),(165,'apcompany','discearn',11,'Integer','','','',''),(166,'apcompany','usetransactiondate',11,'Integer','','','',''),(167,'apcompany','poformat',11,'Integer','','','',''),(168,'apcompany','glcashid',11,'Integer','','','',''),(169,'apcompany','glccid',11,'Integer','','','',''),(170,'apcompany','glotherid',11,'Integer','','','',''),(171,'apcompany','default_po_message',255,'Text','','','',''),(172,'arcompany','id',22,'Numeric','','','primary unique',''),(173,'arcompany','imageurl',150,'Text','','','',''),(174,'arcompany','cash',22,'Numeric','','','',''),(175,'arcompany','checking',22,'Numeric','','','',''),(176,'arcompany','interest',22,'Numeric','','','',''),(177,'arcompany','discount',22,'Numeric','','','',''),(178,'arcompany','cost',22,'Numeric','','','',''),(179,'arcompany','inventory',22,'Numeric','','','',''),(180,'arcompany','shipliability',22,'Numeric','','','',''),(181,'arcompany','receivables',22,'Numeric','','','',''),(182,'arcompany','nextinvoicenum',22,'Numeric','','','',''),(183,'arcompany','servicecharge',10,'Numeric','','','',''),(184,'arcompany','interestrate',10,'Numeric','','','',''),(185,'arcompany','baddebt',22,'Numeric','','','',''),(186,'arcompany','default_sellunitid',11,'Integer','','','',''),(187,'arcompany','default_priceunitid',11,'Integer','','','',''),(188,'arcompany','default_sell_per_price',11,'Integer','','','',''),(189,'arcompany','default_invoice_message',255,'Text','','','',''),(190,'arcompany','invoiceformat',11,'Integer','','','',''),(191,'arcompany','labor_sales_glacctid',11,'Integer','','','',''),(192,'arcompany','hrunitid',11,'Integer','','','',''),(193,'arcompany','is_employee_labor_taxable',2,'Integer','','','',''),(194,'arcompany','depositglacctid',11,'Integer','','','',''),(195,'arcompany','refund',11,'Integer','','','',''),(196,'arcompany','ccprocessorid',11,'Integer','','','',''),(197,'arcompany','docfile',65535,'X','','','',''),(198,'arcompany','default_salescategory_cashreceipts',11,'Integer','','','',''),(199,'arcompany','default_salescategory_invoice',11,'Integer','','','',''),(200,'arcompany','default_salescategory_fulfillment',11,'Integer','','','',''),(201,'arcompany','default_salescategory_service',11,'Integer','','','',''),(202,'arcompany','serviceorder_summarize',5,'Integer','','','',''),(203,'arcompany','tax_on_shipto',5,'Integer','','','',''),(204,'arinvoice','id',22,'Numeric','','','primary unique',''),(205,'arinvoice','invoicenumber',30,'Text','','','multiple',''),(206,'arinvoice','ponumber',30,'Text','','','multiple',''),(207,'arinvoice','wherefrom',11,'Integer','','','',''),(208,'arinvoice','orderid',22,'Numeric','','','',''),(209,'arinvoice','orderbycompanyid',22,'Numeric','','','multiple',''),(210,'arinvoice','shiptocompanyid',22,'Numeric','','','multiple',''),(211,'arinvoice','status',11,'Integer','','','',''),(212,'arinvoice','customerbillcode',20,'Text','','','',''),(213,'arinvoice','shipcost',21,'Numeric','','','',''),(214,'arinvoice','invoicetotal',21,'Numeric','','','',''),(215,'arinvoice','invoicetermsid',22,'Numeric','','','',''),(216,'arinvoice','salesmanid',22,'Numeric','','','',''),(217,'arinvoice','invoicedate',10,'Date','','','multiple',''),(218,'arinvoice','duedate',10,'Date','','','',''),(219,'arinvoice','discountdate',10,'Date','','','',''),(220,'arinvoice','discountamount',21,'Numeric','','','',''),(221,'arinvoice','accruedinterest',21,'Numeric','','','',''),(222,'arinvoice','datelastinterestcalc',10,'Date','','','',''),(223,'arinvoice','gencompanyid',22,'Numeric','','','multiple',''),(224,'arinvoice','cancel',11,'Integer','','','multiple',''),(225,'arinvoice','canceldate',19,'DateTime','','','multiple',''),(226,'arinvoice','canceluserid',22,'Numeric','','','',''),(227,'arinvoice','entrydate',19,'DateTime','','','',''),(228,'arinvoice','entryuserid',22,'Numeric','','','',''),(229,'arinvoice','lastchangedate',19,'DateTime','','','multiple',''),(230,'arinvoice','lastchangeuserid',22,'Numeric','','','',''),(231,'arinvoice','pricelevelid',22,'Numeric','','','',''),(232,'arinvoice','inventorylocationid',22,'Numeric','','','',''),(233,'arinvoice','payment_method',12,'Text','','','',''),(234,'arinvoice','cc_type',20,'Text','','','',''),(235,'arinvoice','cc_owner',64,'Text','','','',''),(236,'arinvoice','cc_number',32,'Text','','','',''),(237,'arinvoice','cc_expires',4,'Text','','','',''),(238,'arinvoice','shipping_method',32,'Text','','','',''),(239,'arinvoice','currency',3,'Text','','','',''),(240,'arinvoice','cc_PNREF',12,'Text','','','',''),(241,'arinvoice','cc_AUTHCODE',6,'Text','','','',''),(242,'arinvoice','transaction_id',32,'Text','','','',''),(243,'arinvoice','customers_id',5,'Integer','','','',''),(244,'arinvoice','currency_value',16,'Numeric','','','',''),(245,'arinvoice','servicerepid',11,'Integer','','','',''),(246,'arinvoice','discountapplied',21,'Numeric','','','',''),(247,'arinvoice','payplan',2,'Integer','0,1','0=regular invoice\r\n1=payment plan record only (not an actual invoice)','multiple',''),(248,'arinvoice','payplan_period',5,'Integer','','','',''),(249,'arinvoice','payplan_days',11,'Integer','','','',''),(250,'arinvoice','payplan_next',10,'Date','','','',''),(251,'arinvoice','payplan_numtimes',11,'Integer','','','',''),(252,'arinvoice','sales_categoriesid',11,'Integer','','','multiple',''),(253,'arinvoice','coverage',3,'Integer','','','',''),(254,'arinvoicedetail','id',22,'Numeric','','','primary unique',''),(255,'arinvoicedetail','invoiceid',22,'Numeric','','','multiple',''),(256,'arinvoicedetail','linenumber',11,'Integer','','','multiple',''),(257,'arinvoicedetail','itemid',22,'Numeric','','','',''),(258,'arinvoicedetail','description',100,'Text','','','',''),(259,'arinvoicedetail','qty',22,'Numeric','','','multiple',''),(260,'arinvoicedetail','qtyunitnameid',11,'Integer','','','',''),(261,'arinvoicedetail','glaccountid',22,'Numeric','','','multiple',''),(262,'arinvoicedetail','taxflag',11,'Integer','','','',''),(263,'arinvoicedetail','priceach',21,'Numeric','','','',''),(264,'arinvoicedetail','priceunitnameid',11,'Integer','','','',''),(265,'arinvoicedetail','qtyunitperpriceunit',12,'Numeric','','','',''),(266,'arinvoicedetail','totalprice',21,'Numeric','','','',''),(267,'arinvoicedetail','entrydate',19,'DateTime','','','',''),(268,'arinvoicedetail','entryuserid',22,'Numeric','','','',''),(269,'arinvoicedetail','lastchangedate',19,'DateTime','','','',''),(270,'arinvoicedetail','lastchangeuserid',22,'Numeric','','','',''),(271,'arinvoicedetail','costeach',21,'Numeric','','','',''),(272,'arinvoicedetail','costglaccountid',22,'Numeric','','','',''),(273,'arinvoicedetailcost','id',22,'Numeric','','','primary unique',''),(274,'arinvoicedetailcost','invoiceid',22,'Numeric','','','multiple',''),(275,'arinvoicedetailcost','cost',21,'Numeric','','','',''),(276,'arinvoicedetailcost','costglaccountid',22,'Numeric','','','',''),(277,'arinvoicedetailcost','entrydate',19,'DateTime','','','',''),(278,'arinvoicedetailcost','entryuserid',22,'Numeric','','','',''),(279,'arinvoicedetailcost','lastchangedate',19,'DateTime','','','',''),(280,'arinvoicedetailcost','lastchangeuserid',22,'Numeric','','','',''),(281,'arinvoicedetailnotes','id',11,'Integer','','','primary unique',''),(282,'arinvoicedetailnotes','invoiceid',11,'Integer','','','multiple',''),(283,'arinvoicedetailnotes','linenumber',11,'Integer','','','multiple',''),(284,'arinvoicedetailnotes','note',65535,'X','','','',''),(285,'arinvoicedetailnotes','lastchangedate',19,'DateTime','','','',''),(286,'arinvoicedetailnotes','lastchangeuserid',11,'Integer','','','',''),(287,'arinvoicenotes','invoiceid',22,'Numeric','','','multiple',''),(288,'arinvoicenotes','note',65535,'X','','','',''),(289,'arinvoicenotes','hide',11,'Integer','','','',''),(290,'arinvoicenotes','lastchangedate',19,'DateTime','','','',''),(291,'arinvoicenotes','lastchangeuserid',22,'Numeric','','','',''),(292,'arinvoicenotes','linenumber',11,'Integer','','','',''),(293,'arinvoicenotes','source_noteid',11,'Integer','','','',''),(294,'arinvoicenotes','id',11,'Integer','','','primary',''),(295,'arinvoicepaymentdetail','id',22,'Numeric','','','primary unique',''),(296,'arinvoicepaymentdetail','invoiceid',22,'Numeric','','','multiple',''),(297,'arinvoicepaymentdetail','amount',21,'Numeric','','discount stored as negative number','',''),(298,'arinvoicepaymentdetail','voucherid',22,'Numeric','','','multiple',''),(299,'arinvoicepaymentdetail','datereceived',10,'Date','','','',''),(300,'arinvoicepaymentdetail','paymeth',11,'Integer','','','multiple',''),(301,'arinvoicepaymentdetail','interest',11,'Integer','0,1,2,9','0=balance paid\r\n1,9=payment is interest\r\n2=discount amount','',''),(302,'arinvoicepaymentdetail','cancel',2,'Integer','','','multiple',''),(303,'arinvoicepaymentdetail','canceldate',19,'DateTime','','','',''),(304,'arinvoicepaymentdetail','cancel_userid',11,'Integer','','','',''),(305,'arinvoicepaymentdetail','checkid',20,'Text','','','multiple',''),(306,'arinvoicepaymentdetail','bankdepositid',11,'Integer','','','multiple','bankdeposit.id'),(307,'arinvoicepaymentdetail','bankstatement_enddate',10,'Date','','Bank Statement end date for period in which this was marked as cleared through bank.','',''),(308,'arinvoicestdnotes','id',11,'Integer','','','primary',''),(309,'arinvoicestdnotes','shortnote',50,'Text','','','',''),(310,'arinvoicestdnotes','full_note',65535,'X','','','',''),(311,'arinvoicestdnotes','sortorder',5,'Integer','','','multiple',''),(312,'arinvoicestdnotes','gencompanyid',11,'Integer','','','multiple',''),(313,'arinvoicestdnotes','entrydate',10,'Date','','','',''),(314,'arinvoicestdnotes','entryuserid',11,'Integer','','','',''),(315,'arinvoicestdnotes','cancel',2,'Integer','','','multiple',''),(316,'arinvoicestdnotes','canceldate',10,'Date','','','',''),(317,'arinvoicestdnotes','canceluserid',11,'Integer','','','',''),(318,'arinvoicestdnotes','lastupdatedate',19,'DateTime','','','',''),(319,'arinvoicestdnotes','lastupdateuserid',11,'Integer','','','',''),(320,'arinvoicetaxdetail','id',22,'Numeric','','','primary unique',''),(321,'arinvoicetaxdetail','invoiceid',22,'Numeric','','','multiple',''),(322,'arinvoicetaxdetail','taxid',22,'Numeric','','','multiple',''),(323,'arinvoicetaxdetail','taxamount',21,'Numeric','','','',''),(324,'arorder','id',11,'Integer','','','primary',''),(325,'arorder','ordernumber',22,'Numeric','','','multiple',''),(326,'arorder','ponumber',30,'Text','','','multiple',''),(327,'arorder','orderbycompanyid',22,'Numeric','','','multiple',''),(328,'arorder','shiptocompanyid',22,'Numeric','','','multiple',''),(329,'arorder','status',11,'Integer','-2,-1,0,1,2','-1=quote\r\n0=pending\r\n1=shipped\r\n2=billed\r\n-2=unconfirmed (entered by B2B user but not in order queue for filling yet','',''),(330,'arorder','customerbillcode',20,'Text','','','',''),(331,'arorder','companyid',22,'Numeric','','','multiple',''),(332,'arorder','pricelevelid',22,'Numeric','','','multiple',''),(333,'arorder','inventorylocationid',22,'Numeric','','','multiple',''),(334,'arorder','cancel',11,'Integer','1,0','1=cancelled - do not use','',''),(335,'arorder','canceldate',19,'DateTime','','','',''),(336,'arorder','canceluserid',22,'Numeric','','','',''),(337,'arorder','entrydate',19,'DateTime','','','',''),(338,'arorder','entryuserid',22,'Numeric','','','',''),(339,'arorder','duedate',10,'Date','','','',''),(340,'arorder','lastchangedate',19,'DateTime','','','',''),(341,'arorder','lastchangeuserid',22,'Numeric','','','',''),(342,'arorder','payment_method',12,'Text','','','',''),(343,'arorder','cc_type',20,'Text','','','',''),(344,'arorder','cc_owner',64,'Text','','','',''),(345,'arorder','cc_number',32,'Text','','','',''),(346,'arorder','cc_expires',7,'Text','','','',''),(347,'arorder','shipping_method',32,'Text','','','',''),(348,'arorder','orders_date_finished',19,'DateTime','','','',''),(349,'arorder','currency',3,'Text','','','',''),(350,'arorder','cc_PNREF',12,'Text','','','',''),(351,'arorder','cc_AUTHCODE',6,'Text','','','',''),(352,'arorder','transaction_id',32,'Text','','','',''),(353,'arorder','customers_id',5,'Integer','','','',''),(354,'arorder','shipping_cost',21,'Numeric','','','',''),(355,'arorder','order_weight',14,'Numeric','','','',''),(356,'arorder','currency_value',16,'Numeric','','','',''),(357,'arorder','wherefrom',100,'Text','','','',''),(358,'arorder','confirmed_by',100,'Text','','','',''),(359,'arorder','confirmed_date',100,'Text','','','',''),(360,'arorder','confirmed',100,'Text','','','',''),(361,'arorder','paymeth',11,'Integer','','','',''),(362,'arorder','ordertype',2,'Integer','','','',''),(363,'arorder','estimate',21,'Numeric','','','',''),(364,'arorder','deposit',21,'Numeric','','','',''),(365,'arorder','salesmanid',11,'Integer','','','',''),(366,'arorder','sales_categoriesid',11,'Integer','','','multiple',''),(367,'arorder','statusid',11,'Integer','','Process status (per user-entered list of possible statuses).','',''),(368,'arorder_deposit','id',11,'Integer','','','primary unique',''),(369,'arorder_deposit','orderid',11,'Integer','','','multiple',''),(370,'arorder_deposit','amount',21,'Numeric','','','',''),(371,'arorder_deposit','payment_method',5,'Integer','','','',''),(372,'arorder_deposit','transaction_id',32,'Text','','','',''),(373,'arorder_deposit','entrydate',10,'Date','','','',''),(374,'arorder_deposit','cc_type',20,'Text','','','',''),(375,'arorder_deposit','last4ofcard',4,'Text','','','',''),(376,'arorder_deposit','voucherid',11,'Integer','','','multiple',''),(377,'arorder_deposit','cancel',3,'Integer','','','',''),(378,'arorder_deposit','canceldate',10,'Date','','','',''),(379,'arorder_deposit','canceluserid',11,'Integer','','','',''),(380,'arorder_deposit','lastchangedate',19,'DateTime','','','',''),(381,'arorder_deposit','bankdepositid',11,'Integer','','','',''),(382,'arorderdetail','id',22,'Numeric','','','primary unique',''),(383,'arorderdetail','orderid',22,'Numeric','','','multiple',''),(384,'arorderdetail','itemid',22,'Numeric','','','multiple',''),(385,'arorderdetail','linenumber',11,'Integer','','','multiple',''),(386,'arorderdetail','qtyorder',22,'Numeric','','','multiple',''),(387,'arorderdetail','qtyship',22,'Numeric','','','multiple',''),(388,'arorderdetail','qtybill',22,'Numeric','','','multiple',''),(389,'arorderdetail','glaccountid',22,'Numeric','','','multiple',''),(390,'arorderdetail','taxflag',11,'Integer','','','',''),(391,'arorderdetail','costeach',21,'Numeric','','','',''),(392,'arorderdetail','priceach',21,'Numeric','','','',''),(393,'arorderdetail','entrydate',19,'DateTime','','','',''),(394,'arorderdetail','entryuserid',22,'Numeric','','','',''),(395,'arorderdetail','lastchangedate',19,'DateTime','','','',''),(396,'arorderdetail','lastchangeuserid',22,'Numeric','','','',''),(397,'arorderdetail','products_tax',9,'Numeric','','','',''),(398,'arorderdetail','description',255,'Text','','','',''),(399,'arorderdetail','saleunitperpriceunit',12,'Numeric','','','',''),(400,'arorderdetail','costglaccountid',22,'Numeric','','','',''),(401,'arorderdetail','purchaseunitid',11,'Integer','','','',''),(402,'arorderdetail','priceunitid',11,'Integer','','','',''),(403,'arorderdetail','main_arorderdetailid',11,'Integer','','','multiple',''),(404,'arorderdetail','itemoptiongroupid',11,'Integer','','','',''),(405,'arorderdetail','itemoptionid',11,'Integer','','','multiple',''),(406,'arorderdetail','multioption',2,'Integer','','','',''),(407,'arorderdetail','optionindependent',2,'Integer','','','',''),(408,'arorderdetail','inventorylocationid',22,'Numeric','','','',''),(409,'arorderdetailnotes','id',11,'Integer','','','primary unique',''),(410,'arorderdetailnotes','orderid',11,'Integer','','','multiple',''),(411,'arorderdetailnotes','linenumber',11,'Integer','','','multiple',''),(412,'arorderdetailnotes','note',65535,'X','','','',''),(413,'arorderdetailnotes','lastchangedate',19,'DateTime','','','',''),(414,'arorderdetailnotes','lastchangeuserid',11,'Integer','','','',''),(415,'arordernotes','orderid',22,'Numeric','','','multiple',''),(416,'arordernotes','note',65535,'X','','','',''),(417,'arordernotes','lastchangedate',19,'DateTime','','','',''),(418,'arordernotes','lastchangeuserid',22,'Numeric','','','',''),(419,'arordernotes','linenumber',11,'Integer','','','',''),(420,'arordernotes','id',11,'Integer','','','primary',''),(421,'arordernotes','internal',5,'Integer','','','',''),(422,'arordernotes','source_noteid',11,'Integer','','','',''),(423,'arordership','id',22,'Numeric','','','primary unique',''),(424,'arordership','orderid',22,'Numeric','','','multiple',''),(425,'arordership','carrierserviceid',22,'Numeric','','','',''),(426,'arordership','shipdate',19,'DateTime','','','multiple',''),(427,'arordership','locationid',22,'Numeric','','','multiple',''),(428,'arordership','entrydate',19,'DateTime','','','',''),(429,'arordership','entryuserid',22,'Numeric','','','',''),(430,'arordership','lastchangedate',19,'DateTime','','','',''),(431,'arordership','lastchangeuserid',22,'Numeric','','','',''),(432,'arordershipdetail','id',22,'Numeric','','','primary unique',''),(433,'arordershipdetail','ordershipid',22,'Numeric','','','multiple',''),(434,'arordershipdetail','orderdetailid',22,'Numeric','','','multiple',''),(435,'arordershipdetail','shipqty',22,'Numeric','','','multiple',''),(436,'arordershipdetail','entrydate',19,'DateTime','','','',''),(437,'arordershipdetail','entryuserid',22,'Numeric','','','',''),(438,'arordershipdetail','lastchangedate',19,'DateTime','','','',''),(439,'arordershipdetail','lastchangeuserid',22,'Numeric','','','',''),(440,'arordershippackage','id',22,'Numeric','','','primary unique',''),(441,'arordershippackage','ordershipid',22,'Numeric','','','multiple',''),(442,'arordershippackage','weight',22,'Numeric','','','',''),(443,'arordershippackage','cost',21,'Numeric','','','',''),(444,'arordershippackage','tracknumber',50,'Text','','','multiple',''),(445,'arordershippackage','arinvoiceid',22,'Numeric','','','',''),(446,'arordertax','id',22,'Numeric','','','primary unique',''),(447,'arordertax','orderid',22,'Numeric','','','multiple',''),(448,'arordertax','taxrateid',22,'Numeric','','','multiple',''),(449,'arordertax','tax',21,'Numeric','','','',''),(450,'arordertax','entrydate',19,'DateTime','','','',''),(451,'arordertax','entryuserid',22,'Numeric','','','',''),(452,'arordertax','lastchangedate',19,'DateTime','','','',''),(453,'arordertax','lastchangeuserid',22,'Numeric','','','',''),(454,'arordertrack','id',22,'Numeric','','','primary unique',''),(455,'arordertrack','orderid',22,'Numeric','','','multiple',''),(456,'arordertrack','action',11,'Integer','','','',''),(457,'arordertrack','trackdate',19,'DateTime','','','',''),(458,'arordertrack','trackuserid',22,'Numeric','','','multiple',''),(459,'arordertrack','lastchangedate',19,'DateTime','','','',''),(460,'arordertrack','lastchangeuserid',22,'Numeric','','','',''),(461,'arserviceorder_time','id',11,'Integer','','','primary',''),(462,'arserviceorder_time','employeeid',11,'Integer','','','multiple',''),(463,'arserviceorder_time','vendorid',11,'Integer','','','multiple',''),(464,'arserviceorder_time','techname',50,'Text','','','',''),(465,'arserviceorder_time','hours',12,'Numeric','','','',''),(466,'arserviceorder_time','startdatetime',19,'DateTime','','','',''),(467,'arserviceorder_time','enddatetime',19,'DateTime','','','',''),(468,'arserviceorder_time','rate',12,'Numeric','','','',''),(469,'arserviceorder_time','totalprice',12,'Numeric','','','',''),(470,'arserviceorder_time','totalcost',12,'Numeric','','','',''),(471,'arserviceorder_time','worktypeid',11,'Integer','','','multiple',''),(472,'arserviceorder_time','workclassid',11,'Integer','','','',''),(473,'arserviceorder_time','notes',65535,'X','','','',''),(474,'arserviceorder_time','gencompanyid',11,'Integer','','','',''),(475,'arserviceorder_time','entrydate',10,'Date','','','multiple',''),(476,'arserviceorder_time','entryuserid',11,'Integer','','','',''),(477,'arserviceorder_time','cancel',2,'Integer','','','',''),(478,'arserviceorder_time','canceldate',19,'DateTime','','','',''),(479,'arserviceorder_time','canceluserid',11,'Integer','','','',''),(480,'arserviceorder_time','lastchangedate',19,'DateTime','','','',''),(481,'arserviceorder_time','lastchangeuserid',11,'Integer','','','',''),(482,'arserviceorder_time','orderid',11,'Integer','','','',''),(483,'arserviceorder_time','internal_comment',255,'Text','','','',''),(484,'arserviceorder_time','costrate',12,'Numeric','','','',''),(485,'arserviceorder_time','status',3,'Integer','','','',''),(486,'arstatusoptions','id',11,'Integer','','','primary',''),(487,'arstatusoptions','description',50,'Text','','','',''),(488,'arstatusoptions','sortorder',5,'Integer','','','multiple',''),(489,'arstatusoptions','entrydate',19,'DateTime','','','',''),(490,'arstatusoptions','entryuserid',11,'Integer','','','',''),(491,'arstatusoptions','lastchangedate',19,'DateTime','','','',''),(492,'arstatusoptions','lastchangeuserid',11,'Integer','','','',''),(493,'arstatusoptions','cancel',2,'Integer','','','multiple',''),(494,'arstatusoptions','canceldate',19,'DateTime','','','',''),(495,'arstatusoptions','canceluserid',11,'Integer','','','',''),(496,'arstatusoptions','gencompanyid',11,'Integer','','','',''),(497,'bankaccount','id',11,'Integer','','','primary',''),(498,'bankaccount','premployeeid',11,'Integer','','','multiple',''),(499,'bankaccount','accounttype',2,'Integer','','','',''),(500,'bankaccount','routing',9,'Text','','','',''),(501,'bankaccount','accountnumber',17,'Text','','','',''),(502,'bankaccount','prenote_ok',2,'Integer','','','',''),(503,'bankaccount','prenote_achfiledetailid',11,'Integer','','','multiple',''),(504,'bankaccount','contactname',100,'Text','','','',''),(505,'bankaccount','bankname',100,'Text','','','',''),(506,'bankaccount','address',100,'Text','','','',''),(507,'bankaccount','city',100,'Text','','','',''),(508,'bankaccount','state',100,'Text','','','',''),(509,'bankaccount','zip',15,'Text','','','',''),(510,'bankaccount','phone',20,'Text','','','',''),(511,'bankaccount','gencompanyid',11,'Integer','','','multiple',''),(512,'bankaccount','entrydate',19,'DateTime','','','',''),(513,'bankaccount','entryuserid',11,'Integer','','','multiple',''),(514,'bankaccount','lastchangedate',19,'DateTime','','','',''),(515,'bankaccount','lastchangeuserid',11,'Integer','','','multiple',''),(516,'bankaccount','cancel',2,'Integer','','','',''),(517,'bankaccount','canceldate',19,'DateTime','','','',''),(518,'bankaccount','canceluserid',11,'Integer','','','multiple',''),(519,'bankdeposit','id',11,'Integer','','','primary unique',''),(520,'bankdeposit','cashtotal',21,'Numeric','','','',''),(521,'bankdeposit','checktotal',21,'Numeric','','','',''),(522,'bankdeposit','othertotal',21,'Numeric','','','',''),(523,'bankdeposit','cashout',21,'Numeric','','','',''),(524,'bankdeposit','depositdate',10,'Date','','','multiple',''),(525,'bankdeposit','checkaccountid',11,'Integer','','','multiple',''),(526,'bankdeposit','onbankstatement',2,'Integer','','','',''),(527,'bankdeposit','gencompanyid',11,'Integer','','','multiple',''),(528,'bankdeposit','cancel',2,'Integer','','','multiple',''),(529,'bankdeposit','canceldate',19,'DateTime','','','',''),(530,'bankdeposit','canceluserid',11,'Integer','','','',''),(531,'bankdeposit','entrydate',19,'DateTime','','','',''),(532,'bankdeposit','entryuserid',11,'Integer','','','',''),(533,'bankdeposit','lastupdatedate',19,'DateTime','','','',''),(534,'bankdeposit','lastupdateuserid',11,'Integer','','','',''),(535,'bankdeposit','bankstatement_enddate',10,'Date','','','',''),(536,'bankdepositdetail','id',11,'Integer','','','primary unique',''),(537,'bankdepositdetail','bankdepositid',11,'Integer','','','',''),(538,'bankdepositdetail','referenceid',11,'Integer','','','multiple',''),(539,'bankdepositdetail','wherefrom',5,'Integer','','','',''),(540,'bankdepositdetail','amount',21,'Numeric','','','',''),(541,'bankdepositdetail','deposit_type',5,'Integer','','','multiple',''),(542,'bankdepositdetail','cancel',3,'Integer','','','',''),(543,'bankdepositdetail','canceldate',19,'DateTime','','','',''),(544,'bankdepositdetail','canceluserid',11,'Integer','','','',''),(545,'buildordermaster','buildordermasterid',11,'Integer','','','primary',''),(546,'buildordermaster','final',2,'Integer','','','',''),(547,'buildordermaster','itemid',11,'Integer','','','',''),(548,'buildordermaster','orderqtyinitial',22,'Numeric','','','',''),(549,'buildordermaster','orderqtyfinal',22,'Numeric','','','',''),(550,'buildordermaster','entrydate',19,'DateTime','','','',''),(551,'buildordermaster','canceldate',19,'DateTime','','','',''),(552,'buildordermaster','canceluserid',22,'Numeric','','','',''),(553,'buildordermaster','cancel',2,'Integer','','','',''),(554,'buildordermaster','lastchangedate',19,'DateTime','','','',''),(555,'buildordermaster','lastchangeuserid',22,'Numeric','','','',''),(556,'buildordermaster','entryuserid',22,'Numeric','','','',''),(557,'buildordermaster','inventorylocationid',22,'Numeric','','','',''),(558,'buildordersub','buildordersubid',11,'Integer','','','primary',''),(559,'buildordersub','buildordermasterid',11,'Integer','','','',''),(560,'buildordersub','itemid',11,'Integer','','','',''),(561,'buildordersub','qtycommitted',22,'Numeric','','','',''),(562,'buildordersub','qtyused',22,'Numeric','','','',''),(563,'buildordersub','final',2,'Integer','','','',''),(564,'buildordersub','entrydate',19,'DateTime','','','',''),(565,'buildordersub','cancel',2,'Integer','','','',''),(566,'calcqty','id_calcqty',11,'Integer','','','primary unique',''),(567,'calcqty','description',100,'Text','','','multiple',''),(568,'calcqty','formula',255,'Text','','','',''),(569,'calcqty','id_calctype',3,'Integer','','','',''),(570,'calcqty','createdate',19,'DateTime','','','',''),(571,'calcqty','id_user_create',11,'Integer','','','',''),(572,'calcqty','lastrevisedate',19,'DateTime','','','',''),(573,'calcqty','id_user_revise',11,'Integer','','','',''),(574,'calcqty','canceldate',19,'DateTime','','','',''),(575,'calcqty','cancel',11,'Integer','','','',''),(576,'calcqty','gencompanyid',11,'Integer','','','',''),(577,'carrier','id',22,'Numeric','','','primary unique',''),(578,'carrier','customernumber',20,'Text','','','',''),(579,'carrier','trackingurlbase',150,'Text','','','',''),(580,'carrier','trackingurlvarname',30,'Text','','','',''),(581,'carrier','description',100,'Text','','','',''),(582,'carrier','vendorid',22,'Numeric','','','',''),(583,'carrier','cancel',2,'Integer','','','',''),(584,'carrierservice','id',22,'Numeric','','','primary unique',''),(585,'carrierservice','carrierid',22,'Numeric','','','multiple',''),(586,'carrierservice','description',30,'Text','','','',''),(587,'carrierservice','abbreviation',10,'Text','','','',''),(588,'carrierservice','sortorder',11,'Integer','','','',''),(589,'cashpayment','id',11,'Integer','','','primary unique',''),(590,'cashpayment','customerid',11,'Integer','','','multiple',''),(591,'cashpayment','entrydate',10,'Date','','','multiple',''),(592,'cashpayment','entryuserid',11,'Integer','','','',''),(593,'cashpayment','note',255,'Text','','','',''),(594,'cashpayment','voucherid',11,'Integer','','','multiple',''),(595,'cashpayment','taxable_amount',21,'Numeric','','','',''),(596,'cashpayment','exempt_amount',21,'Numeric','','','',''),(597,'cashpayment','cost_amount',21,'Numeric','','','',''),(598,'cashpayment','glaccountsalesid',11,'Integer','','','',''),(599,'cashpayment','glaccountcostid',11,'Integer','','','',''),(600,'cashpayment','exemptreasonid',11,'Integer','','','',''),(601,'cashpayment','payment_type',11,'Integer','','','multiple',''),(602,'cashpayment','gencompanyid',11,'Integer','','','',''),(603,'cashpayment','cancel',2,'Integer','','','multiple',''),(604,'cashpayment','canceldate',19,'DateTime','','','',''),(605,'cashpayment','canceluserid',11,'Integer','','','',''),(606,'cashpayment','lastupdatedate',19,'DateTime','','','',''),(607,'cashpayment','lastupdateuserid',11,'Integer','','','',''),(608,'cashpayment','bankdepositid',11,'Integer','','','',''),(609,'cashpayment','sales_categoriesid',11,'Integer','','','multiple',''),(610,'cashpayment','bankstatement_enddate',10,'Date','','','',''),(611,'cashpaymenttax','id',11,'Integer','','','primary unique',''),(612,'cashpaymenttax','cashpaymentid',11,'Integer','','','multiple',''),(613,'cashpaymenttax','taxid',11,'Integer','','','multiple',''),(614,'cashpaymenttax','tax',21,'Numeric','','','',''),(615,'cashpaymenttax','cancel',2,'Integer','','','',''),(616,'cashpaymenttax','canceldate',19,'DateTime','','','',''),(617,'cashpaymenttax','canceluserid',11,'Integer','','','',''),(618,'ccprocessor','id',11,'Integer','','','primary',''),(619,'ccprocessor','name',100,'Text','','','',''),(620,'ccprocessor','modulename',100,'Text','','','',''),(621,'changedate','id_changedate',11,'Integer','','','primary',''),(622,'changedate','id_printorder',11,'Integer','','','',''),(623,'changedate','id_user',11,'Integer','','','',''),(624,'changedate','olddate',19,'DateTime','','','',''),(625,'changedate','newdate',19,'DateTime','','','',''),(626,'changedate','createdate',19,'DateTime','','','',''),(627,'changedate','changedate',20,'Text','','','',''),(628,'checkacct','id',22,'Numeric','','','primary unique',''),(629,'checkacct','name',30,'Text','','','multiple',''),(630,'checkacct','glaccountid',22,'Numeric','','','',''),(631,'checkacct','lastchecknumberused',21,'Numeric','','','',''),(632,'checkacct','defaultendorser',50,'Text','','','',''),(633,'checkacct','gencompanyid',22,'Numeric','','','',''),(634,'checkacct','ap',11,'Integer','','','',''),(635,'checkacct','pay',11,'Integer','','','',''),(636,'checkacct','cancel',2,'Integer','','','',''),(637,'checkacct','canceldate',10,'Date','','','',''),(638,'checkacct','canceluserid',11,'Integer','','','',''),(639,'checkacct','lastupdatedate',19,'DateTime','','','',''),(640,'checkacct','lastupdateuserid',11,'Integer','','','',''),(641,'checkacct','destination_routing',9,'Text','','','',''),(642,'checkacct','destination_name',23,'Text','','','',''),(643,'checkacct','origin_routing',9,'Text','','','',''),(644,'checkacct','origin_name',23,'Text','','','',''),(645,'checkacct','company_name',16,'Text','','','',''),(646,'checkacct','company_identification',10,'Text','','','',''),(647,'checkacct','send_prenotes',2,'Integer','','','',''),(648,'checkacct','accountnumber',17,'Text','','','',''),(649,'checkacct','fractional_routing',30,'Text','','','',''),(650,'checkacct','addresscsz',255,'Text','','','',''),(651,'checkacct','printfullchecks',2,'Integer','','','',''),(652,'checkacct','logo',100,'Text','','','',''),(653,'checkacct','xadjust',11,'Integer','','','',''),(654,'checkacct','yadjust',11,'Integer','','','',''),(655,'chk','id',22,'Numeric','','','primary unique',''),(656,'chk','wherefrom',11,'Integer','','','multiple',''),(657,'chk','paytype',11,'Integer','','','',''),(658,'chk','checkdate',10,'Date','','','multiple',''),(659,'chk','checkvoid',11,'Integer','','','multiple',''),(660,'chk','amount',21,'Numeric','','','',''),(661,'chk','checkaccountid',22,'Numeric','','','multiple',''),(662,'chk','checknumber',16,'Numeric','','','multiple',''),(663,'chk','cashdate',10,'Date','','','multiple',''),(664,'chk','entrydate',19,'DateTime','','','',''),(665,'chk','entryuserid',22,'Numeric','','','',''),(666,'chk','lastchangedate',19,'DateTime','','','',''),(667,'chk','lastchangeuserid',22,'Numeric','','','',''),(668,'chk','gencompanyid',11,'Integer','','','multiple',''),(669,'chk','name',100,'Text','','','',''),(670,'chk','achfiledetailid',11,'Integer','','','multiple',''),(671,'columnfilter','table_name',100,'Text','','','multiple',''),(672,'columnfilter','column_name',100,'Text','','','multiple',''),(673,'columnfilter','ereg',6,'Integer','','','multiple',''),(674,'columnfilter','pcre',6,'Integer','','','multiple',''),(675,'columnfilter','addtext',6,'Integer','','','multiple',''),(676,'columnfilter','deltext',6,'Integer','','','multiple',''),(677,'columnfilter','casesensitive',6,'Integer','','','multiple',''),(678,'columnfilter','pattern',100,'Text','','','',''),(679,'columnfilter','replacement',100,'Text','','','',''),(680,'columnfilter','applyorder',6,'Integer','','','multiple',''),(681,'columnfilter','applyintodb',6,'Integer','','','multiple',''),(682,'columnfilter','applyoutofdb',6,'Integer','','','multiple',''),(683,'compositeitemid','id',22,'Numeric','','','primary unique',''),(684,'compositeitemid','itemcodeid',22,'Numeric','','','multiple',''),(685,'compositeitemid','subitemcodeid',22,'Numeric','','','multiple',''),(686,'compositeitemid','quantity',22,'Numeric','','','',''),(687,'compositeitemid','cancel',11,'Integer','','','',''),(688,'compositeitemid','canceldate',19,'DateTime','','','',''),(689,'compositeitemid','canceluserid',22,'Numeric','','','',''),(690,'compositeitemid','entrydate',19,'DateTime','','','',''),(691,'compositeitemid','entryuserid',22,'Numeric','','','',''),(692,'compositeitemid','lastchangedate',19,'DateTime','','','',''),(693,'compositeitemid','lastchangeuserid',22,'Numeric','','','',''),(694,'configuration','configuration_id',5,'Integer','','','primary',''),(695,'configuration','configuration_title',64,'Text','','','',''),(696,'configuration','configuration_key',64,'Text','','','',''),(697,'configuration','configuration_value',255,'Text','','','',''),(698,'configuration','configuration_description',255,'Text','','','',''),(699,'configuration','configuration_group_id',5,'Integer','','','',''),(700,'configuration','sort_order',5,'Integer','','','',''),(701,'configuration','last_modified',19,'DateTime','','','',''),(702,'configuration','date_added',19,'DateTime','','','',''),(703,'configuration','use_function',32,'Text','','','',''),(704,'configuration','set_function',255,'Text','','','',''),(705,'configuration_group','configuration_group_id',5,'Integer','','','primary',''),(706,'configuration_group','configuration_group_title',64,'Text','','','',''),(707,'configuration_group','configuration_group_description',255,'Text','','','',''),(708,'configuration_group','sort_order',5,'Integer','','','',''),(709,'contactaddress','id',10,'Integer','','','primary',''),(710,'contactaddress','contactnameid',10,'Integer','','','multiple',''),(711,'contactaddress','tablename',100,'Text','','','multiple',''),(712,'contactaddress','tablerecordid',10,'Integer','','','multiple',''),(713,'contactaddress','companyid',10,'Integer','','','',''),(714,'contactaddress','entryuserid',10,'Integer','','','',''),(715,'contactaddress','entrydate',19,'DateTime','','','',''),(716,'contactaddress','address1',200,'Text','','','',''),(717,'contactaddress','address2',200,'Text','','','',''),(718,'contactaddress','mailstop',20,'Text','','','',''),(719,'contactaddress','city',100,'Text','','','',''),(720,'contactaddress','state',50,'Text','','','',''),(721,'contactaddress','zip',15,'Text','','','',''),(722,'contactaddress','country',100,'Text','','','',''),(723,'contactaddress','description',65535,'X','','','',''),(724,'contactaddress','cancel',11,'Integer','','','',''),(725,'contactemail','id',10,'Integer','','','primary',''),(726,'contactemail','contactnameid',10,'Integer','','','multiple',''),(727,'contactemail','tablename',100,'Text','','','multiple',''),(728,'contactemail','tablerecordid',10,'Integer','','','multiple',''),(729,'contactemail','companyid',10,'Integer','','','',''),(730,'contactemail','entryuserid',10,'Integer','','','',''),(731,'contactemail','entrydate',19,'DateTime','','','',''),(732,'contactemail','email',100,'Text','','','',''),(733,'contactemail','description',65535,'X','','','',''),(734,'contactemail','cancel',11,'Integer','','','',''),(735,'contactname','id',10,'Integer','','','primary',''),(736,'contactname','tablename',100,'Text','','','multiple',''),(737,'contactname','tablerecordid',10,'Integer','','','multiple',''),(738,'contactname','companyid',10,'Integer','','','',''),(739,'contactname','entryuserid',10,'Integer','','','',''),(740,'contactname','entrydate',19,'DateTime','','','',''),(741,'contactname','firstname',100,'Text','','','',''),(742,'contactname','lastname',100,'Text','','','',''),(743,'contactname','description',65535,'X','','','',''),(744,'contactname','cancel',11,'Integer','','','',''),(745,'contactphone','id',10,'Integer','','','primary',''),(746,'contactphone','contactnameid',10,'Integer','','','multiple',''),(747,'contactphone','tablename',100,'Text','','','multiple',''),(748,'contactphone','tablerecordid',10,'Integer','','','multiple',''),(749,'contactphone','companyid',10,'Integer','','','',''),(750,'contactphone','entryuserid',10,'Integer','','','',''),(751,'contactphone','entrydate',19,'DateTime','','','',''),(752,'contactphone','phone',100,'Text','','','',''),(753,'contactphone','description',65535,'X','','','',''),(754,'contactphone','cancel',11,'Integer','','','',''),(755,'counter','startdate',8,'Text','','','',''),(756,'counter','counter',12,'Integer','','','',''),(757,'counter_history','month',8,'Text','','','',''),(758,'counter_history','counter',12,'Integer','','','',''),(759,'countries','countries_id',5,'Integer','','','primary',''),(760,'countries','countries_name',64,'Text','','','multiple',''),(761,'countries','countries_iso_code_2',2,'Text','','','',''),(762,'countries','countries_iso_code_3',3,'Text','','','',''),(763,'countries','address_format_id',5,'Integer','','','',''),(764,'currencies','currencies_id',5,'Integer','','','primary',''),(765,'currencies','title',32,'Text','','','',''),(766,'currencies','code',3,'Text','','','',''),(767,'currencies','symbol_left',12,'Text','','','',''),(768,'currencies','symbol_right',12,'Text','','','',''),(769,'currencies','decimal_point',1,'Text','','','',''),(770,'currencies','thousands_point',1,'Text','','','',''),(771,'currencies','decimal_places',1,'Text','','','',''),(772,'customer','id',22,'Numeric','','','primary unique',''),(773,'customer','taxexemptid',22,'Numeric','','','multiple',''),(774,'customer','creditlimit',22,'Numeric','','','',''),(775,'customer','salesglacctid',22,'Numeric','','','multiple',''),(776,'customer','salesmanid',22,'Numeric','','','multiple',''),(777,'customer','servicerepid',22,'Numeric','','','multiple',''),(778,'customer','invoicetermsid',22,'Numeric','','','multiple',''),(779,'customer','quotecommentid',22,'Numeric','','','multiple',''),(780,'customer','interest',11,'Integer','','','',''),(781,'customer','billtoattnname',30,'Text','','','',''),(782,'customer','quoteattnname',30,'Text','','','',''),(783,'customer','chargecode',30,'Text','','','',''),(784,'customer','salestaxnum',30,'Text','','','',''),(785,'customer','gencompanyid',22,'Numeric','','','',''),(786,'customer','cancel',11,'Integer','','','',''),(787,'customer','canceldate',19,'DateTime','','','',''),(788,'customer','canceluserid',22,'Numeric','','','',''),(789,'customer','entrydate',19,'DateTime','','','',''),(790,'customer','entryuserid',22,'Numeric','','','',''),(791,'customer','lastchangedate',19,'DateTime','','','',''),(792,'customer','lastchangeuserid',22,'Numeric','','','',''),(793,'customer','companyname',35,'Text','','','',''),(794,'customer','address1',100,'Text','','','',''),(795,'customer','address2',100,'Text','','','',''),(796,'customer','mailstop',20,'Text','','','',''),(797,'customer','city',50,'Text','','','',''),(798,'customer','state',20,'Text','','','',''),(799,'customer','zip',15,'Text','','','',''),(800,'customer','country',20,'Text','','','',''),(801,'customer','phone1',20,'Text','','','',''),(802,'customer','phone1comment',20,'Text','','','',''),(803,'customer','phone2',20,'Text','','','',''),(804,'customer','phone2comment',20,'Text','','','',''),(805,'customer','phone3',20,'Text','','','',''),(806,'customer','phone3comment',20,'Text','','','',''),(807,'customer','phone4',20,'Text','','','',''),(808,'customer','phone4comment',20,'Text','','','',''),(809,'customer','email1',50,'Text','','','',''),(810,'customer','email1comment',20,'Text','','','',''),(811,'customer','email2',50,'Text','','','',''),(812,'customer','email2comment',20,'Text','','','',''),(813,'customer','website',100,'Text','','','',''),(814,'customer','federalid',20,'Text','','','',''),(815,'customer','entry_gender',1,'Text','','','',''),(816,'customer','entry_firstname',32,'Text','','','',''),(817,'customer','entry_lastname',32,'Text','','','',''),(818,'customer','entry_country_id',5,'Integer','','','',''),(819,'customer','entry_zone_id',5,'Integer','','','',''),(820,'customer','image',64,'Text','','','',''),(821,'customer','customers_dob',8,'Text','','','',''),(822,'customer','customers_password',40,'Text','','','',''),(823,'customer','customers_promotion_ok',1,'Integer','','','',''),(824,'customer','customer_price_level',11,'Integer','','','',''),(825,'customer','points_earned',10,'Numeric','','','',''),(826,'customer','current_sales_process',11,'Integer','','','',''),(827,'customer','notes',255,'Text','','','',''),(828,'customer','default_po',30,'Text','','','',''),(829,'customer','customercode',30,'Text','','','',''),(830,'customer_product','customers_id',11,'Integer','','','primary',''),(831,'customer_product','products_id',11,'Integer','','','primary',''),(832,'customer_product','approved_price',21,'Numeric','','','',''),(833,'customer_product','comments',60,'Text','','','',''),(834,'customer_product','last_modified',19,'DateTime','','','',''),(835,'customers_basket','customers_basket_id',5,'Integer','','','primary',''),(836,'customers_basket','customers_id',5,'Integer','','','',''),(837,'customers_basket','products_id',5,'Integer','','','',''),(838,'customers_basket','lineitem',11,'Integer','','','',''),(839,'customers_basket','inventorylocationid',22,'Numeric','','','',''),(840,'customers_basket','customers_basket_quantity',2,'Integer','','','',''),(841,'customers_basket','final_price',8,'Numeric','','','',''),(842,'customers_basket','customers_basket_date_added',8,'Text','','','',''),(843,'customers_basket','discount_comment',60,'Text','','','',''),(844,'customers_basket_attributes','customers_basket_attributes_id',5,'Integer','','','primary',''),(845,'customers_basket_attributes','customers_id',5,'Integer','','','',''),(846,'customers_basket_attributes','products_id',5,'Integer','','','',''),(847,'customers_basket_attributes','lineitem',11,'Integer','','','',''),(848,'customers_basket_attributes','value',255,'Text','','','',''),(849,'customers_basket_attributes','iogid',11,'Integer','','','',''),(850,'customers_basket_attributes','ioid',11,'Integer','','','',''),(851,'customers_basket_attributes','selection',11,'Integer','','','',''),(852,'customers_basket_attributes','notes',65535,'X','','','',''),(853,'customers_basket_attributes','products_options_id',5,'Integer','','','',''),(854,'customers_basket_attributes','products_options_value_id',5,'Integer','','','',''),(855,'customers_info','customers_info_id',5,'Integer','','','primary',''),(856,'customers_info','customers_info_date_of_last_logon',19,'DateTime','','','',''),(857,'customers_info','customers_info_number_of_logons',5,'Integer','','','',''),(858,'customers_info','customers_info_date_account_created',19,'DateTime','','','',''),(859,'customers_info','customers_info_date_account_last_modified',19,'DateTime','','','',''),(860,'customers_info','customers_info_last_verify_date',19,'DateTime','','','',''),(861,'customers_info','customers_info_status',10,'Text','','','',''),(862,'customersalestax','id',22,'Numeric','','','primary unique',''),(863,'customersalestax','customerid',22,'Numeric','','','multiple',''),(864,'customersalestax','salestaxid',22,'Numeric','','','multiple',''),(865,'db_explanation','id_db_explanation',11,'Integer','','','primary',''),(866,'db_explanation','table_name',255,'Text','','','multiple',''),(867,'db_explanation','field_name',255,'Text','','','multiple',''),(868,'db_explanation','field_length',11,'Integer','','','',''),(869,'db_explanation','field_type',255,'Text','','','',''),(870,'db_explanation','field_value',255,'Text','','','',''),(871,'db_explanation','field_explanation',65535,'X','','','',''),(872,'db_explanation','field_key_type',255,'Text','','','',''),(873,'db_explanation','field_key_table_name',255,'Text','','','',''),(874,'default_response','id_default_response',11,'Integer','','','primary unique',''),(875,'default_response','id_worksubtype',11,'Integer','','','',''),(876,'default_response','id_question',11,'Integer','','','',''),(877,'default_response','response_id_question_detail',11,'Integer','','','',''),(878,'default_response','response',20,'Text','','','',''),(879,'default_response','createdate',19,'DateTime','','','',''),(880,'default_response','id_user_create',11,'Integer','','','',''),(881,'default_response','lastrevisedate',19,'DateTime','','','',''),(882,'default_response','id_user_revise',11,'Integer','','','',''),(883,'default_response','canceldate',19,'DateTime','','','',''),(884,'default_response','cancel',11,'Integer','','','',''),(885,'docmgmtcategory','id',22,'Numeric','','','primary',''),(886,'docmgmtcategory','name',255,'Text','','','',''),(887,'docmgmtcategory','cancel',11,'Integer','','','',''),(888,'docmgmtdata','id',22,'Numeric','','','primary',''),(889,'docmgmtdata','category',22,'Numeric','','','',''),(890,'docmgmtdata','owner',22,'Numeric','','','multiple',''),(891,'docmgmtdata','realname',255,'Text','','','',''),(892,'docmgmtdata','created',19,'DateTime','','','',''),(893,'docmgmtdata','description',255,'Text','','','',''),(894,'docmgmtdata','itemid',22,'Numeric','','','multiple',''),(895,'docmgmtdata','comment',65535,'X','','','',''),(896,'docmgmtdata','status',22,'Numeric','','','',''),(897,'docmgmtdata','version',10,'Text','','','',''),(898,'docmgmtdata','final',11,'Integer','','','',''),(899,'docmgmtlog','id',22,'Numeric','','','multiple',''),(900,'docmgmtlog','modified_on',19,'DateTime','','','',''),(901,'docmgmtlog','modified_by',22,'Numeric','','','multiple',''),(902,'docmgmtlog','oldversion',10,'Text','','','',''),(903,'docmgmtlog','newversion',10,'Text','','','',''),(904,'docmgmtlog','note',65535,'X','','','',''),(905,'docmgmtperms','fid',22,'Numeric','','','multiple',''),(906,'docmgmtperms','uid',22,'Numeric','','','multiple',''),(907,'docmgmtperms','rights',22,'Numeric','','','multiple',''),(908,'estcostcenter','id',22,'Numeric','','','primary unique',''),(909,'estcostcenter','name',50,'Text','','','',''),(910,'estcostcenter','cctype',11,'Integer','','','',''),(911,'estcostcenter','orderflag',11,'Integer','','','',''),(912,'estcostcenter','cancel',11,'Integer','','','',''),(913,'estcostcentersubtype','id',22,'Numeric','','','primary unique',''),(914,'estcostcentersubtype','name',50,'Text','','','',''),(915,'estcostcentersubtype','costcenterid',22,'Numeric','','','multiple',''),(916,'estcostcentersubtype','orderflag',11,'Integer','','','',''),(917,'estcostcentersubtype','cancel',11,'Integer','','','',''),(918,'estmachine','id',22,'Numeric','','','primary unique',''),(919,'estmachine','name',50,'Text','','','',''),(920,'estmachine','costcentersubtypeid',22,'Numeric','','','multiple',''),(921,'estmachine','costmachperhr',14,'Numeric','','','',''),(922,'estmachine','costoperperhr',14,'Numeric','','','',''),(923,'estmachine','costasstperhr',14,'Numeric','','','',''),(924,'estmachine','factoverhead',5,'Numeric','','','',''),(925,'estmachine','genoverhead',5,'Numeric','','','',''),(926,'estmachine','markup',6,'Numeric','','','',''),(927,'estmachine','orderflag',11,'Integer','','','',''),(928,'estmachine','gencompanyid',22,'Numeric','','','',''),(929,'estmachine','cancel',11,'Integer','','','',''),(930,'estprgeneral','gencompanyid',22,'Numeric','','','primary unique',''),(931,'estprgeneral','onetrimopcostsid',22,'Numeric','','','',''),(932,'estprgeneral','twotrimopcostsid',22,'Numeric','','','',''),(933,'estprgeneral','cutopcostsid',22,'Numeric','','','',''),(934,'estprgeneral','cancel',11,'Integer','','','',''),(935,'estprgeneral','canceldate',19,'DateTime','','','',''),(936,'estprgeneral','canceluserid',22,'Numeric','','','',''),(937,'estprgeneral','entrydate',19,'DateTime','','','',''),(938,'estprgeneral','entryuserid',22,'Numeric','','','',''),(939,'estprgeneral','lastchangedate',19,'DateTime','','','',''),(940,'estprgeneral','lastchangeuserid',22,'Numeric','','','',''),(941,'estprprice','id',22,'Numeric','','','primary unique',''),(942,'estprprice','gencompanyid',22,'Numeric','','','',''),(943,'estprprice','name',50,'Text','','','',''),(944,'estprprice','worktypeid',22,'Numeric','','','',''),(945,'estprprice','estquotestdsizeid',22,'Numeric','','','',''),(946,'estprprice','maxpages',11,'Integer','','','',''),(947,'estprprice','minpages',11,'Integer','','','',''),(948,'estprprice','opoffsetsheet',11,'Integer','','','',''),(949,'estprprice','opoffsetweb',11,'Integer','','','',''),(950,'estprprice','opdigital',11,'Integer','','','',''),(951,'estprprice','opscreen',11,'Integer','','','',''),(952,'estprprice','opflexo',11,'Integer','','','',''),(953,'estprprice','opvended',11,'Integer','','','',''),(954,'estprprice','qtyperbox',6,'Numeric','','','',''),(955,'estprprice','notes',65535,'X','','','',''),(956,'estprprice','prpriceid',22,'Numeric','','','',''),(957,'estprprice','maxstocks',11,'Integer','','','',''),(958,'estprprice','tools',11,'Integer','','','',''),(959,'estprprice','cancel',11,'Integer','','','',''),(960,'estprprice','canceldate',19,'DateTime','','','',''),(961,'estprprice','canceluserid',22,'Numeric','','','',''),(962,'estprprice','entrydate',19,'DateTime','','','',''),(963,'estprprice','entryuserid',22,'Numeric','','','',''),(964,'estprprice','lastchangedate',19,'DateTime','','','',''),(965,'estprprice','lastchangeuserid',22,'Numeric','','','',''),(966,'estprpriceoptioncosts','id',22,'Numeric','','','primary unique',''),(967,'estprpriceoptioncosts','proption',11,'Integer','','','',''),(968,'estprpriceoptioncosts','stocklistid',22,'Numeric','','','',''),(969,'estprpriceoptioncosts','hrsgeneralsetup',8,'Numeric','','','',''),(970,'estprpriceoptioncosts','hrscolorsetup',8,'Numeric','','','',''),(971,'estprpriceoptioncosts','runrate',12,'Numeric','','','',''),(972,'estprpriceoptioncosts','runrate2',12,'Numeric','','','',''),(973,'estprpriceoptioncosts','runrate3',12,'Numeric','','','',''),(974,'estprpriceoptioncosts','runqty',9,'Numeric','','','',''),(975,'estprpriceoptioncosts','runqty2',9,'Numeric','','','',''),(976,'estprpriceoptioncosts','runrateqtytype',11,'Integer','','','',''),(977,'estprpriceoptioncosts','numoperators',11,'Integer','','','',''),(978,'estprpriceoptioncosts','numassistants',11,'Integer','','','',''),(979,'estprpriceoptioncosts','mantomachine',11,'Integer','','','',''),(980,'estprpriceoptioncosts','setupscrap',7,'Numeric','','','',''),(981,'estprpriceoptioncosts','runscrap',7,'Numeric','','','',''),(982,'estprpriceoptioncosts','runscrap2',7,'Numeric','','','',''),(983,'estprpriceoptioncosts','scrapqty',9,'Numeric','','','',''),(984,'estprpriceoptioncosts','registrationslowdown',3,'Numeric','','','',''),(985,'estprpriceoptioncosts','maxinksperpass',11,'Integer','','','',''),(986,'estprpriceoptioncosts','estmachineid',22,'Numeric','','','',''),(987,'estprpriceoptioncostsmaterials','id',22,'Numeric','','','primary unique',''),(988,'estprpriceoptioncostsmaterials','proption',11,'Integer','','','',''),(989,'estprpriceoptioncostsmaterials','stocklistid',22,'Numeric','','','',''),(990,'estprpriceoptioncostsmaterials','itemid',22,'Numeric','','','',''),(991,'estprpriceoptioncostsmaterials','name',30,'Text','','','',''),(992,'estprpriceoptioncostsmaterials','qty',12,'Numeric','','','',''),(993,'estprpriceoptioncostsmaterials','per',11,'Integer','','','',''),(994,'estprpriceoptioncostsmaterials','cost',14,'Numeric','','','',''),(995,'estprpriceoptionprice','id',22,'Numeric','','','primary unique',''),(996,'estprpriceoptionprice','proption',11,'Integer','','','',''),(997,'estprpriceoptionprice','stockusageid',22,'Numeric','','','',''),(998,'estprpriceoptionprice','qty',22,'Numeric','','','',''),(999,'estprpriceoptionprice','amount',12,'Numeric','','','',''),(1000,'estprpriceoptionprice','qtycalchow',11,'Integer','','','',''),(1001,'estprpricestockusage','id',22,'Numeric','','','primary unique',''),(1002,'estprpricestockusage','prpriceid',22,'Numeric','','','',''),(1003,'estprpricestockusage','name',20,'Text','','','',''),(1004,'estprpricestockusage','proptionone',22,'Numeric','','','',''),(1005,'estprpricestockusage','proptiontwo',22,'Numeric','','','',''),(1006,'estprpricestockusage','proptionqty',11,'Numeric','','','',''),(1007,'estprpricestockusage','maxinksfront',11,'Integer','','','',''),(1008,'estprpricestockusage','mininksfront',11,'Integer','','','',''),(1009,'estprpricestockusage','maxinksback',11,'Integer','','','',''),(1010,'estprpricestockusage','mininksback',11,'Integer','','','',''),(1011,'estprpricestockusage','maxpages',11,'Integer','','','',''),(1012,'estprpricestockusage','inkcoveragedefault',11,'Integer','','','',''),(1013,'estprpricestockusage','stockusageid',22,'Numeric','','','',''),(1014,'estprpricestockusagecolors','id',22,'Numeric','','','primary unique',''),(1015,'estprpricestockusagecolors','stocklistid',22,'Numeric','','','',''),(1016,'estprpricestockusagecolors','substockcolorsid',22,'Numeric','','','',''),(1017,'estprpricestockusagestock','id',22,'Numeric','','','primary unique',''),(1018,'estprpricestockusagestock','stockusageid',22,'Numeric','','','',''),(1019,'estprpricestockusagestock','proption',11,'Integer','','','',''),(1020,'estprpricestockusagestock','substockid',22,'Numeric','','','',''),(1021,'estprpricestockusagestock','numberout',11,'Integer','','','',''),(1022,'estprpricestockusagestock','cuts',11,'Integer','','','',''),(1023,'estprpricestockusagestock','width',12,'Numeric','','','',''),(1024,'estprpricestockusagestock','length',12,'Numeric','','','',''),(1025,'estprpricestockusagestock','numberup',11,'Integer','','','',''),(1026,'estprpricestockusagestock','addlchargeperm',12,'Numeric','','','',''),(1027,'estprpricestockusagestock','addlminimum',12,'Numeric','','','',''),(1028,'estprpricetools','id',22,'Numeric','','','primary unique',''),(1029,'estprpricetools','name',30,'Text','','','',''),(1030,'estprpricetools','description',100,'Text','','','',''),(1031,'estprpricetools','locationid',22,'Numeric','','','',''),(1032,'estprpricetools','familyid',22,'Numeric','','','',''),(1033,'estprpricetools','gencompanyid',22,'Numeric','','','',''),(1034,'estprpricetools','firsttimeamount',12,'Numeric','','','',''),(1035,'estprpricetools','timesusedcounter',11,'Integer','','','',''),(1036,'estprpricetools','costperuse',12,'Numeric','','','',''),(1037,'estprpricetools','priceperuse',12,'Numeric','','','',''),(1038,'estprpricetools','costperpresshour',12,'Numeric','','','',''),(1039,'estprpricetools','priceperpresshour',12,'Numeric','','','',''),(1040,'estprpricetools','priceperpressqty',12,'Numeric','','','',''),(1041,'estprpricetools','tooltype',11,'Integer','','','',''),(1042,'estprpricetools','repeatlength',7,'Numeric','','','',''),(1043,'estprpricetools','across',11,'Integer','','','',''),(1044,'estprpricetools','around',11,'Integer','','','',''),(1045,'estprpricetools','cavityshape',30,'Text','','','',''),(1046,'estprpricetools','cavitywidth',30,'Text','','','',''),(1047,'estprpricetools','cavitydepth',30,'Text','','','',''),(1048,'estprpricetools','gap',30,'Text','','','',''),(1049,'estprpricetools','bearerwidth',30,'Text','','','',''),(1050,'estprpricetools','gearpitchratio',11,'Integer','','','',''),(1051,'estprpricetools','teeth',11,'Integer','','','',''),(1052,'estprpricetools','addlsetuphrspress',7,'Numeric','','','',''),(1053,'estprpricetools','value',12,'Numeric','','','',''),(1054,'estprpricetools','cancel',11,'Integer','','','',''),(1055,'estprpricetools','canceldate',19,'DateTime','','','',''),(1056,'estprpricetools','canceluserid',22,'Numeric','','','',''),(1057,'estprpricetools','entrydate',19,'DateTime','','','',''),(1058,'estprpricetools','entryuserid',22,'Numeric','','','',''),(1059,'estprpricetools','lastchangedate',19,'DateTime','','','',''),(1060,'estprpricetools','lastchangeuserid',22,'Numeric','','','',''),(1061,'estquote','id',22,'Numeric','','','primary unique',''),(1062,'estquote','quotenum',22,'Numeric','','','',''),(1063,'estquote','subquotenum',11,'Integer','','','',''),(1064,'estquote','customerid',22,'Numeric','','','multiple',''),(1065,'estquote','ponumber',30,'Text','','','',''),(1066,'estquote','priority',11,'Integer','','','',''),(1067,'estquote','duedate',19,'DateTime','','','',''),(1068,'estquote','worktypeid',22,'Numeric','','','',''),(1069,'estquote','jobname',30,'Text','','','',''),(1070,'estquote','jobdesc',65535,'X','','','',''),(1071,'estquote','attn',30,'Text','','','',''),(1072,'estquote','custtrackingnum',20,'Text','','','',''),(1073,'estquote','custchargecode',30,'Text','','','',''),(1074,'estquote','formnumber',20,'Text','','','',''),(1075,'estquote','itemid',22,'Numeric','','','',''),(1076,'estquote','itemcomposite',11,'Integer','','','',''),(1077,'estquote','prpriceid',22,'Numeric','','','',''),(1078,'estquote','finishwidth',7,'Numeric','','','',''),(1079,'estquote','finishheight',7,'Numeric','','','',''),(1080,'estquote','flatwidth',7,'Numeric','','','',''),(1081,'estquote','flatheight',7,'Numeric','','','',''),(1082,'estquote','numpages',22,'Numeric','','','',''),(1083,'estquote','extuser',22,'Numeric','','','',''),(1084,'estquote','genuser',22,'Numeric','','','',''),(1085,'estquote','gencompanyid',22,'Numeric','','','',''),(1086,'estquote','cancel',11,'Integer','','','',''),(1087,'estquote','canceldate',19,'DateTime','','','',''),(1088,'estquote','canceluserid',22,'Numeric','','','',''),(1089,'estquote','entrydate',19,'DateTime','','','',''),(1090,'estquote','entryuserid',22,'Numeric','','','',''),(1091,'estquote','lastchangedate',19,'DateTime','','','',''),(1092,'estquote','lastchangeuserid',22,'Numeric','','','',''),(1093,'estquotebindery','id',22,'Numeric','','','primary unique',''),(1094,'estquotebindery','name',50,'Text','','','',''),(1095,'estquotebindery','gencompanyid',22,'Numeric','','','',''),(1096,'estquotebindery','cancel',11,'Integer','','','',''),(1097,'estquotebindery','canceldate',19,'DateTime','','','',''),(1098,'estquotebindery','canceluserid',22,'Numeric','','','',''),(1099,'estquotebindery','entrydate',19,'DateTime','','','',''),(1100,'estquotebindery','entryuserid',22,'Numeric','','','',''),(1101,'estquotebindery','lastchangedate',19,'DateTime','','','',''),(1102,'estquotebindery','lastchangeuserid',22,'Numeric','','','',''),(1103,'estquotebindery','composition',2,'Integer','','','',''),(1104,'estquotebindery','packaging',2,'Integer','','','',''),(1105,'estquotebinderyaddl','id',22,'Numeric','','','primary unique',''),(1106,'estquotebinderyaddl','estquotebinderyid',22,'Numeric','','','',''),(1107,'estquotebinderyaddl','name',50,'Text','','','',''),(1108,'estquotebinderyaddl','question',65535,'X','','','',''),(1109,'estquotebinderyaddl','validreply',11,'Integer','','','',''),(1110,'estquotebinderyaddl','cancel',11,'Integer','','','',''),(1111,'estquotebinderyaddl','canceldate',19,'DateTime','','','',''),(1112,'estquotebinderyaddl','canceluserid',22,'Numeric','','','',''),(1113,'estquotebinderyaddl','entrydate',19,'DateTime','','','',''),(1114,'estquotebinderyaddl','entryuserid',22,'Numeric','','','',''),(1115,'estquotebinderyaddl','lastchangedate',19,'DateTime','','','',''),(1116,'estquotebinderyaddl','lastchangeuserid',22,'Numeric','','','',''),(1117,'estquotebinderyaddl','qtyperpkg',6,'Numeric','','','',''),(1118,'estquotebinderyaddl','weightpermpkg',7,'Numeric','','','',''),(1119,'estquotebinderyaddl','turnaround',11,'Integer','','','',''),(1120,'estquotebinderyaddl','tooltip',255,'Text','','','',''),(1121,'estquotebinderyaddl','orderflag',11,'Integer','','','',''),(1122,'estquotebinderyaddl','internalonly',2,'Integer','','','',''),(1123,'estquotebinderyaddl','piecework_base',2,'Integer','','','',''),(1124,'estquotebinderyaddl','piecework_name',20,'Text','','','',''),(1125,'estquotebinderyaddloptions','id',22,'Numeric','','','primary unique',''),(1126,'estquotebinderyaddloptions','binderyaddlid',22,'Numeric','','','multiple',''),(1127,'estquotebinderyaddloptions','prompt',20,'Text','','','',''),(1128,'estquotebinderyaddloptions','numprompt',12,'Numeric','','','',''),(1129,'estquotebinderyaddloptions','orderflag',11,'Integer','','','',''),(1130,'estquotebinderyaddloptionsize','id',22,'Numeric','','','primary unique',''),(1131,'estquotebinderyaddloptionsize','binderyaddlid',22,'Numeric','','','multiple',''),(1132,'estquotebinderyaddloptionsize','binderyaddloptionsid',22,'Numeric','','','',''),(1133,'estquotebinderyaddloptionsize','estquotebinderyaddlsizeid',22,'Numeric','','','',''),(1134,'estquotebinderyaddloptionsize','amountaddl',7,'Numeric','','','',''),(1135,'estquotebinderyaddloptionsize','setupaddl',7,'Numeric','','','',''),(1136,'estquotebinderyaddloptionsize','minimumaddl',7,'Numeric','','','',''),(1137,'estquotebinderyaddlsize','id',22,'Numeric','','','primary unique',''),(1138,'estquotebinderyaddlsize','estquotebinderyaddlid',22,'Numeric','','','',''),(1139,'estquotebinderyaddlsize','estquotestdsizeid',22,'Numeric','','','',''),(1140,'estquotebinderyaddlsize','amount',7,'Numeric','','','',''),(1141,'estquotebinderyaddlsize','setupcharge',7,'Numeric','','','',''),(1142,'estquotebinderyaddlsize','minreply',12,'Numeric','','','',''),(1143,'estquotebinderyaddlsize','maxreply',12,'Numeric','','','',''),(1144,'estquotebinderyaddlsize','minimumcharge',7,'Numeric','','','',''),(1145,'estquotebinderyaddlsize','calculatehow',11,'Integer','','','',''),(1146,'estquotebinderyaddlsize','entrydate',19,'DateTime','','','',''),(1147,'estquotebinderyaddlsize','entryuserid',22,'Numeric','','','',''),(1148,'estquotebinderyaddlsize','lastchangedate',19,'DateTime','','','',''),(1149,'estquotebinderyaddlsize','lastchangeuserid',22,'Numeric','','','',''),(1150,'estquotebinderyaddlsize','maxpass',11,'Integer','','','',''),(1151,'estquotebinderyworktype','estquotebinderyid',22,'Numeric','','','multiple',''),(1152,'estquotebinderyworktype','estquoteworktypeid',22,'Numeric','','','',''),(1153,'estquotefile','id',22,'Numeric','','','primary unique',''),(1154,'estquotefile','quoteid',22,'Numeric','','','',''),(1155,'estquotefile','filename',255,'Text','','','multiple',''),(1156,'estquotegenink','id',22,'Numeric','','','primary unique',''),(1157,'estquotegenink','maxcolors',11,'Integer','','','',''),(1158,'estquotegenink','regcharge',6,'Numeric','','','',''),(1159,'estquotegenink','gencompanyid',22,'Numeric','','','multiple',''),(1160,'estquotegenink','namecov1',20,'Text','','','',''),(1161,'estquotegenink','namecov2',20,'Text','','','',''),(1162,'estquotegenink','namecov3',20,'Text','','','',''),(1163,'estquotegenink','namecov4',20,'Text','','','',''),(1164,'estquotegenink','namecov5',20,'Text','','','',''),(1165,'estquotegenink','namecov6',20,'Text','','','',''),(1166,'estquotegenink','namecov7',20,'Text','','','',''),(1167,'estquotegenink','namecov8',20,'Text','','','',''),(1168,'estquotegenink','namecov9',20,'Text','','','',''),(1169,'estquotegenink','covpct1',4,'Numeric','','','',''),(1170,'estquotegenink','covpct2',4,'Numeric','','','',''),(1171,'estquotegenink','covpct3',4,'Numeric','','','',''),(1172,'estquotegenink','covpct4',4,'Numeric','','','',''),(1173,'estquotegenink','covpct5',4,'Numeric','','','',''),(1174,'estquotegenink','covpct6',4,'Numeric','','','',''),(1175,'estquotegenink','covpct7',4,'Numeric','','','',''),(1176,'estquotegenink','covpct8',4,'Numeric','','','',''),(1177,'estquotegenink','covpct9',4,'Numeric','','','',''),(1178,'estquotegenstock','id',22,'Numeric','','','primary unique',''),(1179,'estquotegenstock','name',30,'Text','','','multiple',''),(1180,'estquotegenstock','gencompanyid',22,'Numeric','','','multiple',''),(1181,'estquotegenstock','cancel',11,'Integer','','','',''),(1182,'estquotegenstock','canceldate',19,'DateTime','','','',''),(1183,'estquotegenstock','canceluserid',22,'Numeric','','','',''),(1184,'estquotegenstock','entrydate',19,'DateTime','','','',''),(1185,'estquotegenstock','entryuserid',22,'Numeric','','','',''),(1186,'estquotegenstock','lastchangedate',19,'DateTime','','','',''),(1187,'estquotegenstock','lastchangeuserid',22,'Numeric','','','',''),(1188,'estquotegenstock','orderflag',11,'Integer','','','',''),(1189,'estquoteink','id',22,'Numeric','','','primary unique',''),(1190,'estquoteink','name',50,'Text','','','multiple',''),(1191,'estquoteink','jobprice',8,'Numeric','','','',''),(1192,'estquoteink','mprice',8,'Numeric','','','',''),(1193,'estquoteink','type',11,'Integer','','','',''),(1194,'estquoteink','gencompanyid',22,'Numeric','','','multiple',''),(1195,'estquoteink','costbased',11,'Integer','','','',''),(1196,'estquoteink','costper',8,'Numeric','','','',''),(1197,'estquoteink','coverage',11,'Integer','','','',''),(1198,'estquotepricelist','id',22,'Numeric','','','primary unique',''),(1199,'estquotepricelist','stdsizeid',22,'Numeric','','','',''),(1200,'estquotepricelist','worktypeid',22,'Numeric','','','',''),(1201,'estquotepricelist','name',50,'Text','','','',''),(1202,'estquotepricelist','cancel',11,'Integer','','','',''),(1203,'estquotepricelist','canceldate',19,'DateTime','','','',''),(1204,'estquotepricelist','canceluserid',22,'Numeric','','','',''),(1205,'estquotepricelist','entrydate',19,'DateTime','','','',''),(1206,'estquotepricelist','entryuserid',22,'Numeric','','','',''),(1207,'estquotepricelist','lastchangeuserid',22,'Numeric','','','',''),(1208,'estquotepricelist','lastchangedate',19,'DateTime','','','',''),(1209,'estquotepricelist','gencompanyid',22,'Numeric','','','',''),(1210,'estquotepricelist','maxinkside1',11,'Integer','','','',''),(1211,'estquotepricelist','maxinkside2',11,'Integer','','','',''),(1212,'estquotepricelist','trimchargepermpercut',10,'Numeric','','','',''),(1213,'estquotepricelist','trimmincharge',10,'Numeric','','','',''),(1214,'estquotepricelist','qtyperbox',6,'Numeric','','','',''),(1215,'estquotepricelist','notes',65535,'X','','','',''),(1216,'estquotepricelist','point2id',22,'Numeric','','','',''),(1217,'estquotepricelistprice','id',22,'Numeric','','','primary unique',''),(1218,'estquotepricelistprice','pricelistid',22,'Numeric','','','',''),(1219,'estquotepricelistprice','quantity',11,'Numeric','','','',''),(1220,'estquotepricelistprice','priceperm',8,'Numeric','','','',''),(1221,'estquotepriceliststock','id',22,'Numeric','','','primary unique',''),(1222,'estquotepriceliststock','pricelistid',22,'Numeric','','','',''),(1223,'estquotepriceliststock','genstockid',22,'Numeric','','','',''),(1224,'estquotepriceliststock','substockid',22,'Numeric','','','',''),(1225,'estquotepriceliststock','addlchargeperm',8,'Numeric','','','',''),(1226,'estquotepriceliststock','addlmincharge',8,'Numeric','','','',''),(1227,'estquotepriceliststock','default_partno',50,'Text','','','',''),(1228,'estquotepriceliststock','default_number_up',11,'Integer','','','',''),(1229,'estquotepriceliststock','default_parts',11,'Integer','','','',''),(1230,'estquotepriceliststockcolors','id',22,'Numeric','','','primary unique',''),(1231,'estquotepriceliststockcolors','priceliststockid',22,'Numeric','','','',''),(1232,'estquotepriceliststockcolors','substockcolorsid',22,'Numeric','','','',''),(1233,'estquotepriceliststockcolors','default_partno',30,'Text','','','',''),(1234,'estquoteqty','id',22,'Numeric','','','primary unique',''),(1235,'estquoteqty','quoteid',22,'Numeric','','','multiple',''),(1236,'estquoteqty','qty',22,'Numeric','','','',''),(1237,'estquotequest','id',22,'Numeric','','','primary unique',''),(1238,'estquotequest','quoteid',22,'Numeric','','','multiple',''),(1239,'estquotequest','questionid',22,'Numeric','','','',''),(1240,'estquotequest','yesno',11,'Integer','','','',''),(1241,'estquotequest','selection',22,'Numeric','','','',''),(1242,'estquotequest','text',50,'Text','','','',''),(1243,'estquotequote','id',22,'Numeric','','','primary unique',''),(1244,'estquotequote','customerid',22,'Numeric','','','multiple',''),(1245,'estquotequote','contactname',50,'Text','','','',''),(1246,'estquotequote','stdsizeid',22,'Numeric','','','',''),(1247,'estquotequote','cwidth',12,'Numeric','','','',''),(1248,'estquotequote','clength',12,'Numeric','','','',''),(1249,'estquotequote','substockid',22,'Numeric','','','',''),(1250,'estquotequote','tightreg1',11,'Integer','','','',''),(1251,'estquotequote','tightreg2',11,'Integer','','','',''),(1252,'estquotequote','gencompanyid',22,'Numeric','','','',''),(1253,'estquotequote','cancel',11,'Integer','','','',''),(1254,'estquotequote','canceldate',19,'DateTime','','','',''),(1255,'estquotequote','canceluserid',22,'Numeric','','','',''),(1256,'estquotequote','entrydate',19,'DateTime','','','',''),(1257,'estquotequote','entryuserid',22,'Numeric','','','',''),(1258,'estquotequote','lastchangedate',19,'DateTime','','','',''),(1259,'estquotequote','lastchangeuserid',22,'Numeric','','','',''),(1260,'estquotequote','description',255,'Text','','','',''),(1261,'estquotequote','substockcolorid',22,'Numeric','','','',''),(1262,'estquotequote','shippingservice',3,'Text','','','',''),(1263,'estquotequote','shippingzipcode',12,'Text','','','',''),(1264,'estquotequote','special',255,'Text','','','',''),(1265,'estquotequote','quotenum',20,'Text','','','',''),(1266,'estquotequote','extuser',22,'Numeric','','','',''),(1267,'estquotequote','genuser',22,'Numeric','','','',''),(1268,'estquotequote','pricelistid',22,'Numeric','','','',''),(1269,'estquotequote','duedate',10,'Date','','','multiple',''),(1270,'estquotequote','finalshipdate',10,'Date','','','multiple',''),(1271,'estquotequote','status',5,'Integer','','','',''),(1272,'estquotequote','billdate',10,'Date','','','',''),(1273,'estquotequote','order_quantity',11,'Integer','','','',''),(1274,'estquotequote','shiptotal',14,'Numeric','','','',''),(1275,'estquotequote','billtotal',14,'Numeric','','','',''),(1276,'estquotequote','orderdate',10,'Date','','','multiple',''),(1277,'estquotequote','instructions',255,'Text','','','',''),(1278,'estquotequote','id_printorder',11,'Integer','','','multiple',''),(1279,'estquotequote','extras',11,'Integer','','','',''),(1280,'estquotequote','numup',11,'Integer','','','',''),(1281,'estquotequote','itemid',11,'Integer','','','multiple',''),(1282,'estquotequote','papername',50,'Text','','','',''),(1283,'estquotequote','paperwidth',14,'Numeric','','','',''),(1284,'estquotequote','paperlength',14,'Numeric','','','',''),(1285,'estquotequote','priority',2,'Integer','','','',''),(1286,'estquotequote','formnumber',50,'Text','','','multiple',''),(1287,'estquotequote','numparts',11,'Integer','','','',''),(1288,'estquotequote','presswidth',14,'Numeric','','','',''),(1289,'estquotequote','presslength',14,'Numeric','','','',''),(1290,'estquotequote','customer_po',30,'Text','','','',''),(1291,'estquotequote','print_how',2,'Integer','','','',''),(1292,'estquotequote','salesglacctid',11,'Integer','','','',''),(1293,'estquotequote','rush_charge',14,'Numeric','','','',''),(1294,'estquotequote','composition_charge',14,'Numeric','','','',''),(1295,'estquotequote','glrush',11,'Integer','','','',''),(1296,'estquotequote','glcomposition',11,'Integer','','','',''),(1297,'estquotequote_instructions','id',11,'Integer','','','primary',''),(1298,'estquotequote_instructions','quoteid',11,'Integer','','','multiple',''),(1299,'estquotequote_instructions','workareaid',11,'Integer','','','multiple',''),(1300,'estquotequote_instructions','instructions',255,'Text','','','',''),(1301,'estquotequote_shipment','id_shipment',11,'Integer','','','primary',''),(1302,'estquotequote_shipment','id_order_shipto',11,'Integer','','','multiple',''),(1303,'estquotequote_shipment','quantity',15,'Integer','','','',''),(1304,'estquotequote_shipment','shipdate',19,'DateTime','','','',''),(1305,'estquotequote_shipment','id_shipmentlog',11,'Integer','','','',''),(1306,'estquotequote_shipment','packslip',2,'Integer','','','',''),(1307,'estquotequote_shipment','boxlabel',2,'Integer','','','',''),(1308,'estquotequote_shipment','logdate',19,'DateTime','','','',''),(1309,'estquotequote_shipment','createdate',10,'Date','','','',''),(1310,'estquotequote_shipment','id_user_create',11,'Integer','','','',''),(1311,'estquotequote_shipment','lastrevisedate',19,'DateTime','','','',''),(1312,'estquotequote_shipment','id_user_revise',11,'Integer','','','',''),(1313,'estquotequote_shipment','canceldate',10,'Date','','','',''),(1314,'estquotequote_shipment','cancel',11,'Integer','','','',''),(1315,'estquotequote_shipment','signfor',255,'Text','','','',''),(1316,'estquotequote_shipment','failed',11,'Integer','','','',''),(1317,'estquotequote_shipment','id_printorder',11,'Integer','','','multiple',''),(1318,'estquotequote_shipment','notes',255,'Text','','','',''),(1319,'estquotequote_shipment','id_order_shipment_group',11,'Integer','','','multiple',''),(1320,'estquotequote_shipment','trackingnum',30,'Text','','','',''),(1321,'estquotequote_shipment','invoiceid',11,'Integer','','','',''),(1322,'estquotequote_shipment','carrierserviceid',11,'Integer','','','',''),(1323,'estquotequote_shipment','freight',14,'Numeric','','','',''),(1324,'estquotequote_shipment','numperbox',11,'Integer','','','',''),(1325,'estquotequote_shipment','numboxes',11,'Integer','','','',''),(1326,'estquotequote_shipment','id_estquoteship',11,'Integer','','','',''),(1327,'estquotequotebindquest','id',22,'Numeric','','','primary unique',''),(1328,'estquotequotebindquest','quoteid',22,'Numeric','','','multiple',''),(1329,'estquotequotebindquest','questionid',22,'Numeric','','','',''),(1330,'estquotequotebindquest','yesno',11,'Integer','','','',''),(1331,'estquotequotebindquest','numbetween',22,'Numeric','','','',''),(1332,'estquotequotebindquest','text',50,'Text','','','',''),(1333,'estquotequoteink','id',22,'Numeric','','','primary unique',''),(1334,'estquotequoteink','quoteid',22,'Numeric','','','multiple',''),(1335,'estquotequoteink','side',11,'Integer','','','',''),(1336,'estquotequoteink','inkid',22,'Numeric','','','',''),(1337,'estquotequoteink','pms',4,'Text','','','',''),(1338,'estquotequotenotes','id',22,'Numeric','','','primary unique',''),(1339,'estquotequotenotes','quotebold',50,'Text','','','',''),(1340,'estquotequotenotes','quotetext',65535,'X','','','',''),(1341,'estquotequotenotes','showwhen',11,'Integer','','','',''),(1342,'estquotequotenotes','orderflag',11,'Integer','','','',''),(1343,'estquotequotenotes','gencompanyid',22,'Numeric','','','',''),(1344,'estquotequotenotes','entrydate',19,'DateTime','','','',''),(1345,'estquotequotenotes','entryuserid',22,'Numeric','','','',''),(1346,'estquotequotenotes','lastchangeuserid',22,'Numeric','','','',''),(1347,'estquotequotenotes','lastchangedate',19,'DateTime','','','',''),(1348,'estquotequoteqty','id',22,'Numeric','','','primary unique',''),(1349,'estquotequoteqty','quoteid',22,'Numeric','','','multiple',''),(1350,'estquotequoteqty','qty',22,'Numeric','','','',''),(1351,'estquotequoteqty','weight',12,'Numeric','','','',''),(1352,'estquotequoteqty','total',12,'Numeric','','','',''),(1353,'estquotequoteqty','shipcost',12,'Numeric','','','',''),(1354,'estquotequoteqty','turnaround',11,'Integer','','','',''),(1355,'estquotequoteqty','mcost',12,'Numeric','','','',''),(1356,'estquotequoteqty','boxes',11,'Integer','','','',''),(1357,'estquotequoteqty','comptotal',22,'Numeric','','','',''),(1358,'estquotequotequest','id',22,'Numeric','','','primary unique',''),(1359,'estquotequotequest','quoteid',22,'Numeric','','','multiple',''),(1360,'estquotequotequest','questionid',22,'Numeric','','','',''),(1361,'estquotequotequest','yesno',11,'Integer','','','',''),(1362,'estquotequotequest','numbetween',22,'Numeric','','','',''),(1363,'estquotequotequest','text',50,'Text','','','',''),(1364,'estquoteship','id',22,'Numeric','','','primary',''),(1365,'estquoteship','id_printorder',22,'Numeric','','','multiple',''),(1366,'estquoteship','shiptoid',22,'Numeric','','','multiple',''),(1367,'estquoteship','carrierserviceid',22,'Numeric','','','multiple',''),(1368,'estquoteship','shipqty',22,'Numeric','','','',''),(1369,'estquoteship','attn',30,'Text','','','',''),(1370,'estquoteship','client_po',30,'Text','','','',''),(1371,'estquoteship','weight',22,'Numeric','','','',''),(1372,'estquoteship','cost',22,'Numeric','','','',''),(1373,'estquoteship','boxes',11,'Integer','','','',''),(1374,'estquoteship','zipcode',12,'Text','','','',''),(1375,'estquoteship','qtyperfullbox',11,'Integer','','','',''),(1376,'estquoteship','packages',11,'Integer','','','',''),(1377,'estquoteship','invoiceid',11,'Integer','','','',''),(1378,'estquoteship','client_name',100,'Text','','','',''),(1379,'estquotestdsize','id',22,'Numeric','','','primary unique',''),(1380,'estquotestdsize','length',12,'Numeric','','','',''),(1381,'estquotestdsize','width',12,'Numeric','','','',''),(1382,'estquotestdsize','gencompanyid',22,'Numeric','','','',''),(1383,'estquotestdsize','orderflag',11,'Integer','','','',''),(1384,'estquotestock','id',22,'Numeric','','','primary unique',''),(1385,'estquotestock','quoteid',22,'Numeric','','','multiple',''),(1386,'estquotestock','stockusageid',22,'Numeric','','','multiple',''),(1387,'estquotestock','stocklistid',22,'Numeric','','','multiple',''),(1388,'estquotestock','flatwidth',7,'Numeric','','','',''),(1389,'estquotestock','flatheight',7,'Numeric','','','',''),(1390,'estquotestock','numpages',22,'Numeric','','','',''),(1391,'estquotestock','notes',65535,'X','','','',''),(1392,'estquotestockink','id',22,'Numeric','','','primary unique',''),(1393,'estquotestockink','quotestockid',22,'Numeric','','','multiple',''),(1394,'estquotestockink','inkid',22,'Numeric','','','multiple',''),(1395,'estquotestockink','side',11,'Integer','','','',''),(1396,'estquotestockink','inknum',11,'Integer','','','',''),(1397,'estquotestockink','coverage',7,'Numeric','','','',''),(1398,'estquotestocktool','id',22,'Numeric','','','primary unique',''),(1399,'estquotestocktool','quotestockid',22,'Numeric','','','multiple',''),(1400,'estquotestocktool','toolid',22,'Numeric','','','multiple',''),(1401,'estquotesubstock','id',22,'Numeric','','','primary unique',''),(1402,'estquotesubstock','estquotegenstockid',22,'Numeric','','','multiple',''),(1403,'estquotesubstock','name',50,'Text','','','multiple',''),(1404,'estquotesubstock','weight',8,'Numeric','','','',''),(1405,'estquotesubstock','turnaround',11,'Integer','','','',''),(1406,'estquotesubstock','orderflag',11,'Integer','','','',''),(1407,'estquotesubstock','parts',11,'Integer','','','',''),(1408,'estquotesubstock','inchesperm',6,'Numeric','','','',''),(1409,'estquotesubstockcolors','id',22,'Numeric','','','primary unique',''),(1410,'estquotesubstockcolors','substockid',22,'Numeric','','','multiple',''),(1411,'estquotesubstockcolors','color',50,'Text','','','multiple',''),(1412,'estquotesubstockcolorsize','id',11,'Integer','','','primary unique',''),(1413,'estquotesubstockcolorsize','substockid',11,'Integer','','','multiple',''),(1414,'estquotesubstockcolorsize','substockcolorid',11,'Integer','','','multiple',''),(1415,'estquotesubstockcolorsize','sizename',20,'Text','','','',''),(1416,'estquotesubstockcolorsize','partno',50,'Text','','','multiple',''),(1417,'estquotesubstockcost','id',22,'Numeric','','','primary unique',''),(1418,'estquotesubstockcost','substockid',22,'Numeric','','','multiple',''),(1419,'estquotesubstockcost','stocktype',11,'Integer','','','',''),(1420,'estquotesubstockcost','length',12,'Numeric','','','multiple',''),(1421,'estquotesubstockcost','width',12,'Numeric','','','multiple',''),(1422,'estquotesubstockcost','cost',12,'Numeric','','','multiple',''),(1423,'estquotesubstockcost','costhow',11,'Integer','','','',''),(1424,'estquotesubstockcost','itemid',22,'Numeric','','','multiple',''),(1425,'estquotesubstocksize','id',11,'Integer','','','primary unique',''),(1426,'estquotesubstocksize','substockid',11,'Integer','','','multiple',''),(1427,'estquotesubstocksize','sizename',20,'Text','','','',''),(1428,'estquotesubstocksize','partno',50,'Text','','','multiple',''),(1429,'estquoteworktype','id',22,'Numeric','','','primary unique',''),(1430,'estquoteworktype','name',50,'Text','','','',''),(1431,'estquoteworktype','turnaroundqty',11,'Numeric','','','',''),(1432,'estquoteworktype','turnarounddaysuptoqty',11,'Integer','','','',''),(1433,'estquoteworktype','turnarounddaysoverqty',11,'Integer','','','',''),(1434,'estquoteworktype','gencompanyid',22,'Numeric','','','',''),(1435,'estquoteworktype','cancel',11,'Integer','','','',''),(1436,'estquoteworktype','canceldate',19,'DateTime','','','',''),(1437,'estquoteworktype','canceluserid',22,'Numeric','','','',''),(1438,'estquoteworktype','entrydate',19,'DateTime','','','',''),(1439,'estquoteworktype','entryuserid',22,'Numeric','','','',''),(1440,'estquoteworktype','lastchangeuserid',22,'Numeric','','','',''),(1441,'estquoteworktype','lastchangedate',19,'DateTime','','','',''),(1442,'estquoteworktype','notes',65535,'X','','','',''),(1443,'estquoteworktype','genworktypeid',22,'Numeric','','','',''),(1444,'estquoteworktype','orderflag',11,'Integer','','','',''),(1445,'estquoteworktypeaddl','id',22,'Numeric','','','primary unique',''),(1446,'estquoteworktypeaddl','worktypeid',22,'Numeric','','','',''),(1447,'estquoteworktypeaddl','question',50,'Text','','','',''),(1448,'estquoteworktypeaddl','validreply',11,'Integer','','','',''),(1449,'estquoteworktypeaddl','minreply',12,'Numeric','','','',''),(1450,'estquoteworktypeaddl','maxreply',12,'Numeric','','','',''),(1451,'estquoteworktypeaddl','askonlyifmtblackink',11,'Integer','','','',''),(1452,'estquoteworktypeaddl','askonlyifmtoneink',11,'Integer','','','',''),(1453,'estquoteworktypeaddl','askonlyminsizelength',12,'Numeric','','','',''),(1454,'estquoteworktypeaddl','askonlyminsizewidth',12,'Numeric','','','',''),(1455,'estquoteworktypeaddl','askonlymaxsizelength',12,'Numeric','','','',''),(1456,'estquoteworktypeaddl','askonlymaxsizewidth',12,'Numeric','','','',''),(1457,'estquoteworktypeaddl','calculatehow',11,'Integer','','','',''),(1458,'estquoteworktypeaddl','cancel',11,'Integer','','','',''),(1459,'estquoteworktypeaddl','canceldate',19,'DateTime','','','',''),(1460,'estquoteworktypeaddl','canceluserid',22,'Numeric','','','',''),(1461,'estquoteworktypeaddl','entrydate',19,'DateTime','','','',''),(1462,'estquoteworktypeaddl','entryuserid',22,'Numeric','','','',''),(1463,'estquoteworktypeaddl','lastchangedate',19,'DateTime','','','',''),(1464,'estquoteworktypeaddl','lastchangeuserid',22,'Numeric','','','',''),(1465,'estquoteworktypeaddl','askonlyifmtoneside',11,'Integer','','','',''),(1466,'estquoteworktypeaddl','amount',7,'Numeric','','','',''),(1467,'estquoteworktypeaddl','askonlyifoneink',11,'Integer','','','',''),(1468,'estquoteworktypeaddl','aboveqty',12,'Numeric','','','',''),(1469,'estquoteworktypegen','id',22,'Numeric','','','primary unique',''),(1470,'estquoteworktypegen','name',50,'Text','','','',''),(1471,'estquoteworktypegen','gencompanyid',22,'Numeric','','','',''),(1472,'estquoteworktypegen','orderflag',11,'Integer','','','',''),(1473,'estquoteworktypegen','cancel',11,'Integer','','','',''),(1474,'estquoteworktypegen','canceldate',19,'DateTime','','','',''),(1475,'estquoteworktypegen','canceluserid',22,'Numeric','','','',''),(1476,'estquoteworktypegen','entrydate',19,'DateTime','','','',''),(1477,'estquoteworktypegen','entryuserid',22,'Numeric','','','',''),(1478,'estquoteworktypegen','lastchangedate',19,'DateTime','','','',''),(1479,'estquoteworktypegen','lastchangeuserid',22,'Numeric','','','',''),(1480,'estquoteworktypestdqty','id',22,'Numeric','','','primary unique',''),(1481,'estquoteworktypestdqty','quantity',11,'Numeric','','','',''),(1482,'estquoteworktypestdqty','worktypeid',22,'Numeric','','','',''),(1483,'extuser','id',22,'Numeric','','','primary unique',''),(1484,'extuser','name',30,'Text','','','',''),(1485,'extuser','password',50,'Text','','','',''),(1486,'extuser','customer',11,'Integer','','','',''),(1487,'extuser','vendor',11,'Integer','','','',''),(1488,'extuser','cancel',11,'Integer','','','',''),(1489,'extuser','stylesheetid',11,'Integer','','','',''),(1490,'extuser','canceldate',19,'DateTime','','','',''),(1491,'extuser','canceluserid',22,'Numeric','','','',''),(1492,'extuser','entrydate',19,'DateTime','','','',''),(1493,'extuser','entryuserid',22,'Numeric','','','',''),(1494,'extuser','lastchangedate',19,'DateTime','','','',''),(1495,'extuser','lastchangeuserid',22,'Numeric','','','',''),(1496,'extuser','deflanguageid',11,'Integer','','','',''),(1497,'extuser','fullname',100,'Text','','','',''),(1498,'family','id_family',11,'Integer','','','primary unique',''),(1499,'family','name',50,'Text','','','',''),(1500,'family','id_workarea',11,'Integer','','','',''),(1501,'family','imptype',3,'Integer','','','',''),(1502,'family','iph',14,'Integer','','','',''),(1503,'family','iphtwo',14,'Integer','','','',''),(1504,'family','clickprice',7,'Numeric','','','',''),(1505,'family','clickpricetwo',7,'Numeric','','','',''),(1506,'family','maximpressionsperday',16,'Numeric','','','',''),(1507,'family','createdate',19,'DateTime','','','',''),(1508,'family','id_user_create',11,'Integer','','','',''),(1509,'family','lastrevisedate',19,'DateTime','','','',''),(1510,'family','id_user_revise',11,'Integer','','','',''),(1511,'family','canceldate',19,'DateTime','','','',''),(1512,'family','cancel',11,'Integer','','','',''),(1513,'family','gencompanyid',11,'Integer','','','',''),(1514,'family','maxwidth',12,'Numeric','','','',''),(1515,'family','maxlength',12,'Numeric','','','',''),(1516,'family','minwidth',12,'Numeric','','','',''),(1517,'family','minlength',12,'Numeric','','','',''),(1518,'family','mincolors',11,'Integer','','','',''),(1519,'family','maxcolors',11,'Integer','','','',''),(1520,'family','maxcolors_two',11,'Integer','','','',''),(1521,'family','maxcolors_one_if_two',11,'Integer','','','',''),(1522,'family','iphunits',3,'Integer','','','',''),(1523,'family_iph','id_family_iph',11,'Integer','','','primary',''),(1524,'family_iph','id_family',11,'Integer','','','multiple',''),(1525,'family_iph','multiplier',7,'Numeric','','','',''),(1526,'family_iph','len',12,'Numeric','','','',''),(1527,'family_iph','wt',12,'Numeric','','','',''),(1528,'family_iph','greater_or_less',1,'Integer','','','',''),(1529,'family_iph','sizeormwt',1,'Integer','','','',''),(1530,'family_iph','price',7,'Numeric','','','',''),(1531,'family_iph','createdate',19,'DateTime','','','',''),(1532,'family_iph','id_user_create',11,'Integer','','','',''),(1533,'family_iph','lastrevisedate',19,'DateTime','','','',''),(1534,'family_iph','id_user_revise',11,'Integer','','','',''),(1535,'family_iph','canceldate',19,'DateTime','','','',''),(1536,'family_iph','cancel',11,'Integer','','','',''),(1537,'family_price','id_family_price',11,'Integer','','','primary unique',''),(1538,'family_price','id_family',11,'Integer','','','multiple',''),(1539,'family_price','qty_over',15,'Integer','','','',''),(1540,'family_price','price_1_sided',17,'Numeric','','','',''),(1541,'family_price','price_2_sided',17,'Numeric','','','',''),(1542,'family_price','createdate',19,'DateTime','','','',''),(1543,'family_price','id_user_create',11,'Integer','','','',''),(1544,'family_price','lastrevisedate',19,'DateTime','','','',''),(1545,'family_price','id_user_revise',11,'Integer','','','',''),(1546,'family_price','canceldate',19,'DateTime','','','',''),(1547,'family_price','cancel',11,'Integer','','','',''),(1548,'filedata','id',11,'Integer','','','primary',''),(1549,'filedata','fileitemid',11,'Integer','','','multiple',''),(1550,'filedata','filedata',65535,'X','','','',''),(1551,'filedefinition','id',11,'Integer','','','primary',''),(1552,'filedefinition','table_name',100,'Text','','','multiple',''),(1553,'filedefinition','file_function',11,'Integer','','','',''),(1554,'filedefinition','notes',65535,'X','','','',''),(1555,'filedefinition','prompt',255,'Text','','','',''),(1556,'filedefinition','upload_limit',11,'Integer','','','',''),(1557,'filedefinition','modaccess',150,'Text','','','',''),(1558,'filedefinition','modbit',20,'Text','','','',''),(1559,'fileitem','id',11,'Integer','','','primary',''),(1560,'fileitem','filedefinitionid',11,'Integer','','','multiple',''),(1561,'fileitem','tablerecordid',11,'Integer','','','multiple',''),(1562,'fileitem','filename',255,'Text','','','',''),(1563,'fileitem','display_type',11,'Integer','','','',''),(1564,'fileitem','datatype',60,'Text','','','',''),(1565,'fileitem','size',20,'Integer','','','',''),(1566,'fileitem','filedate',19,'DateTime','','','',''),(1567,'fileitem','companyid',11,'Integer','','','',''),(1568,'fileitem','entryuserid',11,'Integer','','','multiple',''),(1569,'fileitem','notes',65535,'X','','','',''),(1570,'gencompany','id',11,'Integer','','','primary unique',''),(1571,'gencompany','address1',100,'Text','','','',''),(1572,'gencompany','address2',100,'Text','','','',''),(1573,'gencompany','city',50,'Text','','','',''),(1574,'gencompany','state',20,'Text','','','',''),(1575,'gencompany','zip',15,'Text','','','',''),(1576,'gencompany','country',20,'Text','','','',''),(1577,'gencompany','phone1',20,'Text','','','',''),(1578,'gencompany','phone2',20,'Text','','','',''),(1579,'gencompany','phone3',20,'Text','','','',''),(1580,'gencompany','phone4',20,'Text','','','',''),(1581,'gencompany','email',50,'Text','','','',''),(1582,'gencompany','web',100,'Text','','','',''),(1583,'gencompany','name',50,'Text','','','',''),(1584,'gencompany','active',11,'Integer','','','',''),(1585,'gencompany','graphicurl',200,'Text','','','',''),(1586,'gencompany','graphicurl_big',200,'Text','','','',''),(1587,'gencompany','menucolor',11,'Integer','','','',''),(1588,'gencompany','lastupdateuserid',11,'Integer','','','',''),(1589,'gencompany','lastupdatedate',19,'DateTime','','','',''),(1590,'genmessage','id',22,'Numeric','','','primary unique',''),(1591,'genmessage','userid',22,'Numeric','','','multiple',''),(1592,'genmessage','sourceuserid',22,'Numeric','','','',''),(1593,'genmessage','entrydate',19,'DateTime','','','',''),(1594,'genmessage','readdate',19,'DateTime','','','',''),(1595,'genmessage','message',65535,'X','','','',''),(1596,'genprint','id',11,'Integer','','','',''),(1597,'genprint','special_order_markup',8,'Numeric','','','',''),(1598,'genprint','outside_vended_markup',8,'Numeric','','','',''),(1599,'genprint','qty_unitid',11,'Integer','','','',''),(1600,'genprint','price_unitid',11,'Integer','','','',''),(1601,'genprint','conversion',11,'Integer','','','',''),(1602,'genprint','overdays',5,'Integer','','','',''),(1603,'genprint','first_timeframe',11,'Integer','','','',''),(1604,'genprint','second_timeframe',11,'Integer','','','',''),(1605,'genprint','glrush',11,'Integer','','','',''),(1606,'genprint','glcomposition',11,'Integer','','','',''),(1607,'genstate','id',22,'Numeric','','','primary unique',''),(1608,'genstate','stateinit',3,'Text','','','multiple unique',''),(1609,'genstate','statename',30,'Text','','','',''),(1610,'genstylesheet','id',11,'Integer','','','primary unique',''),(1611,'genstylesheet','name',50,'Text','','',' unique',''),(1612,'genstylesheet','filename',50,'Text','','',' unique',''),(1613,'genuser','id',22,'Numeric','','','primary unique',''),(1614,'genuser','name',50,'Text','','','multiple unique',''),(1615,'genuser','password',64,'Text','','','',''),(1616,'genuser','raccessap',11,'Integer','','','',''),(1617,'genuser','raccessar',11,'Integer','','','',''),(1618,'genuser','raccessgl',11,'Integer','','','',''),(1619,'genuser','raccesspay',11,'Integer','','','',''),(1620,'genuser','raccessinv',11,'Integer','','','',''),(1621,'genuser','raccessest',11,'Integer','','','',''),(1622,'genuser','raccessfix',11,'Integer','','','',''),(1623,'genuser','raccessimp',11,'Integer','','','',''),(1624,'genuser','waccessap',11,'Integer','','','',''),(1625,'genuser','waccessar',11,'Integer','','','',''),(1626,'genuser','waccessgl',11,'Integer','','','',''),(1627,'genuser','waccesspay',11,'Integer','','','',''),(1628,'genuser','waccessinv',11,'Integer','','','',''),(1629,'genuser','waccessest',11,'Integer','','','',''),(1630,'genuser','waccessfix',11,'Integer','','','',''),(1631,'genuser','waccessimp',11,'Integer','','','',''),(1632,'genuser','saccessap',11,'Integer','','','',''),(1633,'genuser','saccessar',11,'Integer','','','',''),(1634,'genuser','saccessgl',11,'Integer','','','',''),(1635,'genuser','saccesspay',11,'Integer','','','',''),(1636,'genuser','saccessinv',11,'Integer','','','',''),(1637,'genuser','saccessest',11,'Integer','','','',''),(1638,'genuser','saccessfix',11,'Integer','','','',''),(1639,'genuser','saccessimp',11,'Integer','','','',''),(1640,'genuser','supervisor',11,'Integer','','','',''),(1641,'genuser','active',11,'Integer','','','',''),(1642,'genuser','stylesheetid',11,'Integer','','','',''),(1643,'genuser','deflanguage',11,'Integer','','','',''),(1644,'genuser','email',100,'Text','','','',''),(1645,'genuser','logon_attempts',4,'Integer','','','',''),(1646,'genuser','firstname',35,'Text','','','',''),(1647,'genuser','lastname',35,'Text','','','',''),(1648,'genuser','cancel',11,'Integer','','','',''),(1649,'genuser','admin',2,'Integer','','','',''),(1650,'genuser','raccesssc',11,'Integer','','','',''),(1651,'genuser','waccesssc',11,'Integer','','','',''),(1652,'genuser','saccesssc',11,'Integer','','','',''),(1653,'genuser','employeeid',11,'Integer','','','',''),(1654,'genusercompany','genuser_id',22,'Numeric','','','',''),(1655,'genusercompany','gencompanyid',11,'Integer','','','',''),(1656,'genusercompany','lasthome',20,'Text','','','',''),(1657,'genusercompany','raccessap',2,'Integer','','','',''),(1658,'genusercompany','raccessar',2,'Integer','','','',''),(1659,'genusercompany','raccessgl',2,'Integer','','','',''),(1660,'genusercompany','raccesspay',2,'Integer','','','',''),(1661,'genusercompany','raccessinv',2,'Integer','','','',''),(1662,'genusercompany','raccessest',2,'Integer','','','',''),(1663,'genusercompany','raccessfix',2,'Integer','','','',''),(1664,'genusercompany','raccessimp',2,'Integer','','','',''),(1665,'genusercompany','raccesssc',2,'Integer','','','',''),(1666,'genusercompany','waccessap',2,'Integer','','','',''),(1667,'genusercompany','waccessar',2,'Integer','','','',''),(1668,'genusercompany','waccessgl',2,'Integer','','','',''),(1669,'genusercompany','waccesspay',2,'Integer','','','',''),(1670,'genusercompany','waccessinv',2,'Integer','','','',''),(1671,'genusercompany','waccessest',2,'Integer','','','',''),(1672,'genusercompany','waccessfix',2,'Integer','','','',''),(1673,'genusercompany','waccessimp',2,'Integer','','','',''),(1674,'genusercompany','waccesssc',2,'Integer','','','',''),(1675,'genusercompany','saccessap',2,'Integer','','','',''),(1676,'genusercompany','saccessar',2,'Integer','','','',''),(1677,'genusercompany','saccessgl',2,'Integer','','','',''),(1678,'genusercompany','saccesspay',2,'Integer','','','',''),(1679,'genusercompany','saccessinv',2,'Integer','','','',''),(1680,'genusercompany','saccessest',2,'Integer','','','',''),(1681,'genusercompany','saccessfix',2,'Integer','','','',''),(1682,'genusercompany','saccessimp',2,'Integer','','','',''),(1683,'genusercompany','saccesssc',2,'Integer','','','',''),(1684,'genusercompany','supervisor',2,'Integer','','','',''),(1685,'genusercompany_temp','genuser_id',22,'Numeric','','','',''),(1686,'genusercompany_temp','gencompanyid',11,'Integer','','','',''),(1687,'genusercompany_temp','raccessap',2,'Integer','','','',''),(1688,'genusercompany_temp','raccessar',2,'Integer','','','',''),(1689,'genusercompany_temp','raccessgl',2,'Integer','','','',''),(1690,'genusercompany_temp','raccesspay',2,'Integer','','','',''),(1691,'genusercompany_temp','raccessinv',2,'Integer','','','',''),(1692,'genusercompany_temp','raccessest',2,'Integer','','','',''),(1693,'genusercompany_temp','raccessfix',2,'Integer','','','',''),(1694,'genusercompany_temp','raccessimp',2,'Integer','','','',''),(1695,'genusercompany_temp','raccesssc',2,'Integer','','','',''),(1696,'genusercompany_temp','waccessap',2,'Integer','','','',''),(1697,'genusercompany_temp','waccessar',2,'Integer','','','',''),(1698,'genusercompany_temp','waccessgl',2,'Integer','','','',''),(1699,'genusercompany_temp','waccesspay',2,'Integer','','','',''),(1700,'genusercompany_temp','waccessinv',2,'Integer','','','',''),(1701,'genusercompany_temp','waccessest',2,'Integer','','','',''),(1702,'genusercompany_temp','waccessfix',2,'Integer','','','',''),(1703,'genusercompany_temp','waccessimp',2,'Integer','','','',''),(1704,'genusercompany_temp','waccesssc',2,'Integer','','','',''),(1705,'genusercompany_temp','saccessap',2,'Integer','','','',''),(1706,'genusercompany_temp','saccessar',2,'Integer','','','',''),(1707,'genusercompany_temp','saccessgl',2,'Integer','','','',''),(1708,'genusercompany_temp','saccesspay',2,'Integer','','','',''),(1709,'genusercompany_temp','saccessinv',2,'Integer','','','',''),(1710,'genusercompany_temp','saccessest',2,'Integer','','','',''),(1711,'genusercompany_temp','saccessfix',2,'Integer','','','',''),(1712,'genusercompany_temp','saccessimp',2,'Integer','','','',''),(1713,'genusercompany_temp','saccesssc',2,'Integer','','','',''),(1714,'genusercompany_temp','supervisor',2,'Integer','','','',''),(1715,'genuserhome','genuser',11,'Integer','','','',''),(1716,'genuserhome','gencompany',11,'Integer','','','',''),(1717,'genuserhome','home',20,'Text','','','',''),(1718,'genuserhome','twothirds',100,'Text','','','',''),(1719,'genuserhome','half1',100,'Text','','','',''),(1720,'genuserhome','half2',100,'Text','','','',''),(1721,'genuserhome','lastlogin',19,'DateTime','','','',''),(1722,'genuserhome','whole',100,'Text','','','',''),(1723,'glaccount','id',22,'Numeric','','','primary unique',''),(1724,'glaccount','name',20,'Text','','','multiple',''),(1725,'glaccount','description',255,'Text','','','',''),(1726,'glaccount','accounttypeid',11,'Integer','','','multiple',''),(1727,'glaccount','companyid',22,'Numeric','','','multiple',''),(1728,'glaccount','summaryaccountid',22,'Numeric','','','multiple',''),(1729,'glaccount','lastchangedate',19,'DateTime','','','',''),(1730,'glaccount','lastchangeuserid',22,'Numeric','','','',''),(1731,'glaccount','cancel',2,'Integer','','','',''),(1732,'glaccount','canceldate',19,'DateTime','','','',''),(1733,'glaccount','canceluserid',11,'Integer','','','',''),(1734,'glbudgets','id',22,'Numeric','','','primary unique',''),(1735,'glbudgets','glaccountid',22,'Numeric','','','multiple',''),(1736,'glbudgets','companyid',22,'Numeric','','','multiple',''),(1737,'glbudgets','budgetyear',11,'Integer','','','multiple',''),(1738,'glbudgets','jan',21,'Numeric','','','',''),(1739,'glbudgets','feb',21,'Numeric','','','',''),(1740,'glbudgets','mar',21,'Numeric','','','',''),(1741,'glbudgets','apr',21,'Numeric','','','',''),(1742,'glbudgets','may',21,'Numeric','','','',''),(1743,'glbudgets','jun',21,'Numeric','','','',''),(1744,'glbudgets','jul',21,'Numeric','','','',''),(1745,'glbudgets','aug',21,'Numeric','','','',''),(1746,'glbudgets','sep',21,'Numeric','','','',''),(1747,'glbudgets','oct',21,'Numeric','','','',''),(1748,'glbudgets','nov',21,'Numeric','','','',''),(1749,'glbudgets','decm',21,'Numeric','','','',''),(1750,'glbudgets','lastchangedate',19,'DateTime','','','',''),(1751,'glbudgets','lastchangeuserid',22,'Numeric','','','',''),(1752,'glbudgets','entrydate',19,'DateTime','','','',''),(1753,'glbudgets','rank',11,'Integer','','','',''),(1754,'glbudgets','cancel',2,'Integer','','','',''),(1755,'glbudgets','budgetname',100,'Text','','','',''),(1756,'glcompany','id',22,'Numeric','','','primary unique',''),(1757,'glcompany','fiscalbeginmonth',11,'Integer','','','',''),(1758,'glpie','id',22,'Numeric','','','primary unique',''),(1759,'glpie','name',30,'Text','','','',''),(1760,'glpie','description',100,'Text','','','',''),(1761,'glpie','begindate',10,'Date','','','',''),(1762,'glpie','findate',10,'Date','','','',''),(1763,'glpie','cancel',11,'Integer','','','',''),(1764,'glpie','canceldate',19,'DateTime','','','',''),(1765,'glpie','canceluserid',22,'Numeric','','','',''),(1766,'glpie','entrydate',19,'DateTime','','','',''),(1767,'glpie','entryuserid',22,'Numeric','','','',''),(1768,'glpie','lastchangedate',19,'DateTime','','','',''),(1769,'glpie','lastchangeuserid',22,'Numeric','','','',''),(1770,'glpieslice','id',22,'Numeric','','','primary unique',''),(1771,'glpieslice','glpieid',22,'Numeric','','','multiple',''),(1772,'glpieslice','name',30,'Text','','','',''),(1773,'glpieslice','begindate',10,'Date','','','',''),(1774,'glpieslice','findate',10,'Date','','','',''),(1775,'glpieslice','lastchangedate',19,'DateTime','','','',''),(1776,'glpieslice','lastchangeuserid',22,'Numeric','','','',''),(1777,'glpieslicedetail','id',22,'Numeric','','','primary unique',''),(1778,'glpieslicedetail','glpiesliceid',22,'Numeric','','','multiple',''),(1779,'glpieslicedetail','glaccountid',22,'Numeric','','','',''),(1780,'glpieslicedetail','companyid',22,'Numeric','','','',''),(1781,'glpieslicedetail','lastchangedate',19,'DateTime','','','',''),(1782,'glpieslicedetail','lastchangeuserid',22,'Numeric','','','',''),(1783,'gltransaction','id',22,'Numeric','','','primary unique',''),(1784,'gltransaction','glaccountid',22,'Numeric','','','multiple',''),(1785,'gltransaction','voucherid',22,'Numeric','','','multiple',''),(1786,'gltransaction','amount',21,'Numeric','','','',''),(1787,'gltransvoucher','id',22,'Numeric','','','primary unique',''),(1788,'gltransvoucher','voucher',50,'Text','','','multiple',''),(1789,'gltransvoucher','description',50,'Text','','','',''),(1790,'gltransvoucher','comments',50,'Text','','','',''),(1791,'gltransvoucher','wherefrom',11,'Integer','','source module','multiple',''),(1792,'gltransvoucher','status',11,'Integer','','0=unposted, 1=posted, 2=auto posted by close year','',''),(1793,'gltransvoucher','cancel',11,'Integer','','1=cancelled, do not include in any gl totals','',''),(1794,'gltransvoucher','companyid',22,'Numeric','','','multiple',''),(1795,'gltransvoucher','standardset',22,'Numeric','','1=recurring ledger set - do not include in any ledger totals','',''),(1796,'gltransvoucher','entrydate',19,'DateTime','','','',''),(1797,'gltransvoucher','posteddate',19,'DateTime','','date on which posting DONE','',''),(1798,'gltransvoucher','post2date',10,'Date','','date posted TO','multiple',''),(1799,'gltransvoucher','canceldate',19,'DateTime','','','',''),(1800,'gltransvoucher','lastchangedate',19,'DateTime','','','',''),(1801,'gltransvoucher','lastchangeuserid',22,'Numeric','','','',''),(1802,'gltransvoucher','entryuserid',22,'Numeric','','','',''),(1803,'gltransvoucher','canceluserid',22,'Numeric','','','',''),(1804,'gltransvoucher','postuserid',22,'Numeric','','who posted','',''),(1805,'gltransvoucher','bankdepositid',11,'Integer','','','',''),(1806,'invbegcount','id',11,'Integer','','','primary',''),(1807,'invbegcount','itemid',11,'Integer','','','',''),(1808,'invbegcount','count',22,'Numeric','','','',''),(1809,'invbegcount','priceach',14,'Numeric','','','',''),(1810,'invbegcount','inventorylocationid',11,'Integer','','','',''),(1811,'invbegcount','status',2,'Integer','','','',''),(1812,'invbegcount','entrydate',19,'DateTime','','','',''),(1813,'invbegcount','entryuserid',11,'Integer','','','',''),(1814,'invbegcount','countunitid',11,'Integer','','','',''),(1815,'invcompany','id',22,'Numeric','','','primary unique',''),(1816,'invcompany','cash',22,'Numeric','','','',''),(1817,'invcompany','sales',22,'Numeric','','','',''),(1818,'invcompany','loss',22,'Numeric','','','',''),(1819,'invcompany','cost',22,'Numeric','','','',''),(1820,'invcompany','freight',22,'Numeric','','','',''),(1821,'invcompany','tax',22,'Numeric','','','',''),(1822,'invcompany','custoritemglacct',11,'Integer','','','',''),(1823,'invcompany','locationid',11,'Integer','','','',''),(1824,'invcompany','default_pricelevelid',11,'Integer','','','',''),(1825,'invcompany','weight_units',10,'Text','','','',''),(1826,'invcompany','category_hierarchy',2,'Integer','','','',''),(1827,'invcount','id',11,'Integer','','','primary',''),(1828,'invcount','itemid',11,'Integer','','','',''),(1829,'invcount','count',11,'Integer','','','',''),(1830,'invcount','countunitid',100,'Text','','','',''),(1831,'invcount','entrydate',19,'DateTime','','','',''),(1832,'invcount','status',2,'Integer','','','',''),(1833,'invcount','inventorylocationid',11,'Integer','','','',''),(1834,'invcount','entryuserid',11,'Integer','','','',''),(1835,'invcount','posteddate',19,'DateTime','','','',''),(1836,'invcount','posteduserid',11,'Integer','','','',''),(1837,'inventorylocation','id',22,'Numeric','','','primary',''),(1838,'inventorylocation','companyname',35,'Text','','','',''),(1839,'inventorylocation','address1',100,'Text','','','',''),(1840,'inventorylocation','address2',100,'Text','','','',''),(1841,'inventorylocation','mailstop',20,'Text','','','',''),(1842,'inventorylocation','city',50,'Text','','','',''),(1843,'inventorylocation','state',20,'Text','','','',''),(1844,'inventorylocation','zip',15,'Text','','','',''),(1845,'inventorylocation','country',20,'Text','','','',''),(1846,'inventorylocation','phone1',20,'Text','','','',''),(1847,'inventorylocation','phone1comment',20,'Text','','','',''),(1848,'inventorylocation','phone2',20,'Text','','','',''),(1849,'inventorylocation','phone2comment',20,'Text','','','',''),(1850,'inventorylocation','phone3',20,'Text','','','',''),(1851,'inventorylocation','phone3comment',20,'Text','','','',''),(1852,'inventorylocation','phone4',20,'Text','','','',''),(1853,'inventorylocation','phone4comment',20,'Text','','','',''),(1854,'inventorylocation','email1',50,'Text','','','',''),(1855,'inventorylocation','email1comment',20,'Text','','','',''),(1856,'inventorylocation','email2',50,'Text','','','',''),(1857,'inventorylocation','email2comment',20,'Text','','','',''),(1858,'inventorylocation','website',100,'Text','','','',''),(1859,'inventorylocation','federalid',20,'Text','','','',''),(1860,'inventorylocation','cancel',11,'Integer','','','',''),(1861,'inventorylocation','canceldate',19,'DateTime','','','',''),(1862,'inventorylocation','canceluserid',22,'Numeric','','','',''),(1863,'inventorylocation','entrydate',19,'DateTime','','','',''),(1864,'inventorylocation','entryuserid',22,'Numeric','','','',''),(1865,'inventorylocation','lastchangedate',19,'DateTime','','','',''),(1866,'inventorylocation','lastchangeuserid',22,'Numeric','','','',''),(1867,'inventorylocation','gencompanyid',11,'Integer','','','',''),(1868,'inventorylocation','printlocation',2,'Integer','','','',''),(1869,'invitemcatseason','id',22,'Numeric','','','primary unique',''),(1870,'invitemcatseason','itemcategoryid',22,'Numeric','','','multiple',''),(1871,'invitemcatseason','seasonname',50,'Text','','','',''),(1872,'invitemcatseason','seasonbegin',11,'Integer','','','',''),(1873,'invitemcatseason','seasonend',11,'Integer','','','',''),(1874,'invitemcatseason','cancel',11,'Integer','','','',''),(1875,'invitemcatseason','canceldate',19,'DateTime','','','',''),(1876,'invitemcatseason','canceluserid',22,'Numeric','','','',''),(1877,'invitemcatseason','entrydate',19,'DateTime','','','',''),(1878,'invitemcatseason','entryuserid',22,'Numeric','','','',''),(1879,'invitemcatseason','lastchangedate',19,'DateTime','','','',''),(1880,'invitemcatseason','lastchangeuserid',22,'Numeric','','','',''),(1881,'invoiceterms','id',22,'Numeric','','','primary unique',''),(1882,'invoiceterms','verbal',30,'Text','','','',''),(1883,'invoiceterms','discountpercent',8,'Numeric','','','',''),(1884,'invoiceterms','discountdays',11,'Integer','','','',''),(1885,'invoiceterms','discountdayofmonth',11,'Integer','','','',''),(1886,'invoiceterms','netduedays',11,'Integer','','','',''),(1887,'invoiceterms','ar',11,'Integer','','','multiple',''),(1888,'invoiceterms','ap',11,'Integer','','','multiple',''),(1889,'invoiceterms','cancel',11,'Integer','','','',''),(1890,'invoiceterms','canceldate',19,'DateTime','','','',''),(1891,'invoiceterms','canceluserid',22,'Numeric','','','',''),(1892,'invoiceterms','entrydate',19,'DateTime','','','',''),(1893,'invoiceterms','entryuserid',22,'Numeric','','','',''),(1894,'invoiceterms','lastchangedate',19,'DateTime','','','',''),(1895,'invoiceterms','lastchangeuserid',22,'Numeric','','','',''),(1896,'invpo','id',22,'Numeric','','','primary unique',''),(1897,'invpo','vendorid',22,'Numeric','','','multiple',''),(1898,'invpo','ponumber',20,'Text','','','multiple',''),(1899,'invpo','duedate',10,'Date','','','',''),(1900,'invpo','locationid',22,'Numeric','','','',''),(1901,'invpo','carrierserviceid',22,'Numeric','','','',''),(1902,'invpo','tracknumber',50,'Text','','','',''),(1903,'invpo','contact',20,'Text','','','',''),(1904,'invpo','requisition',20,'Text','','','',''),(1905,'invpo','ordernumber',20,'Text','','','',''),(1906,'invpo','gencompanyid',22,'Numeric','','','',''),(1907,'invpo','complete',11,'Integer','','','',''),(1908,'invpo','cancel',11,'Integer','','','',''),(1909,'invpo','canceldate',19,'DateTime','','','',''),(1910,'invpo','canceluserid',22,'Numeric','','','',''),(1911,'invpo','entrydate',19,'DateTime','','','',''),(1912,'invpo','entryuserid',22,'Numeric','','','',''),(1913,'invpo','lastchangedate',19,'DateTime','','','',''),(1914,'invpo','status',11,'Integer','','','',''),(1915,'invpo','lastchangeuserid',22,'Numeric','','','',''),(1916,'invpo','notes',255,'Text','','','',''),(1917,'invpo','initials',255,'Text','','','',''),(1918,'invpo','description',255,'Text','','','',''),(1919,'invpo','referenceid',11,'Integer','','','multiple',''),(1920,'invpo','wherefrom',11,'Integer','','','multiple',''),(1921,'invpodetail','id',22,'Numeric','','','primary unique',''),(1922,'invpodetail','invpoid',22,'Numeric','','','multiple',''),(1923,'invpodetail','itemid',22,'Numeric','','','multiple',''),(1924,'invpodetail','itemqty',21,'Numeric','','','',''),(1925,'invpodetail','itemprice',21,'Numeric','','','',''),(1926,'invpodetail','detail_description',255,'Text','','','',''),(1927,'invpodetail','inv_glacct',22,'Numeric','','','',''),(1928,'invpodetail','conversion',14,'Numeric','','','',''),(1929,'invponotes','id',11,'Integer','','','primary',''),(1930,'invponotes','invpoid',11,'Integer','','','multiple',''),(1931,'invponotes','linenumber',11,'Integer','','','multiple',''),(1932,'invponotes','note',65535,'X','','','',''),(1933,'invponotes','entrydate',10,'Date','','','',''),(1934,'invponotes','entryuserid',11,'Integer','','','',''),(1935,'invponotes','lastupdatedate',19,'DateTime','','','',''),(1936,'invponotes','lastupdateuserid',11,'Integer','','','',''),(1937,'invponotes','source_noteid',11,'Integer','','','multiple',''),(1938,'invpoquote','id',22,'Numeric','','','primary unique',''),(1939,'invpoquote','invpoid',22,'Numeric','','','multiple',''),(1940,'invpoquote','vendorid',22,'Numeric','','','multiple',''),(1941,'invpoquote','invpodetailid',22,'Numeric','','','multiple',''),(1942,'invpoquote','itemqty',12,'Numeric','','','',''),(1943,'invpoquote','itemprice',14,'Numeric','','','',''),(1944,'invpostdnotes','id',11,'Integer','','','primary',''),(1945,'invpostdnotes','shortnote',50,'Text','','','',''),(1946,'invpostdnotes','full_note',65535,'X','','','',''),(1947,'invpostdnotes','sortorder',5,'Integer','','','multiple',''),(1948,'invpostdnotes','gencompanyid',11,'Integer','','','multiple',''),(1949,'invpostdnotes','entrydate',10,'Date','','','',''),(1950,'invpostdnotes','entryuserid',11,'Integer','','','',''),(1951,'invpostdnotes','cancel',2,'Integer','','','multiple',''),(1952,'invpostdnotes','canceldate',10,'Date','','','',''),(1953,'invpostdnotes','canceluserid',11,'Integer','','','',''),(1954,'invpostdnotes','lastupdatedate',19,'DateTime','','','',''),(1955,'invpostdnotes','lastupdateuserid',11,'Integer','','','',''),(1956,'invreceive','id',22,'Numeric','','','primary unique',''),(1957,'invreceive','recsource',11,'Integer','','','',''),(1958,'invreceive','invpoid',22,'Numeric','','','multiple',''),(1959,'invreceive','receivedate',19,'DateTime','','','',''),(1960,'invreceive','itemid',22,'Numeric','','','multiple',''),(1961,'invreceive','vendorid',22,'Numeric','','','',''),(1962,'invreceive','locationid',22,'Numeric','','','',''),(1963,'invreceive','itemqty',12,'Numeric','','','',''),(1964,'invreceive','itemprice',21,'Numeric','','','',''),(1965,'invreceive','itemqtyused',12,'Numeric','','','',''),(1966,'invreceive','itemqtydamaged',12,'Numeric','','','',''),(1967,'invreceive','conversion',14,'Numeric','','','',''),(1968,'invreceive','track',30,'Text','','','',''),(1969,'invreceive','receiveunitnameid',22,'Numeric','','','',''),(1970,'invreceive','passtoap',11,'Integer','','','',''),(1971,'invreceive','apbillid',22,'Numeric','','','',''),(1972,'invreceive','gencompanyid',22,'Numeric','','','',''),(1973,'invreceive','cancel',11,'Integer','','','',''),(1974,'invreceive','canceldate',19,'DateTime','','','',''),(1975,'invreceive','canceluserid',22,'Numeric','','','',''),(1976,'invreceive','entrydate',19,'DateTime','','','',''),(1977,'invreceive','entryuserid',22,'Numeric','','','',''),(1978,'invreceive','lastchangedate',19,'DateTime','','','',''),(1979,'invreceive','invpodetailid',11,'Integer','','','',''),(1980,'invreceive','status',2,'Integer','','','',''),(1981,'invreceive','initials',255,'Text','','','',''),(1982,'invreceive','lastchangeuserid',22,'Numeric','','','',''),(1983,'invreceive','recnotes',65535,'X','','','',''),(1984,'item','id',22,'Numeric','','','primary unique',''),(1985,'item','itemcode',30,'Text','','UPC Code or item code - must be unique','multiple',''),(1986,'item','compositeitemyesno',11,'Integer','','','',''),(1987,'item','description',100,'Text','','','',''),(1988,'item','categoryid',22,'Numeric','','','multiple',''),(1989,'item','stockunitnameid',22,'Numeric','','','','unitname.id'),(1990,'item','priceunitnameid',22,'Numeric','','','','unitname.id'),(1991,'item','lbsperpriceunit',22,'Numeric','','','',''),(1992,'item','priceunitsperstockunit',18,'Numeric','','Conversion factor between stocking units and pricing units. On screen might show as 1000 stock units per price unit, but in database it will be stored as 1/1000 or .001','',''),(1993,'item','inventoryglacctid',22,'Numeric','','glaccount.id - for inventory account','multiple','glaccount.id'),(1994,'item','salesglacctid',22,'Numeric','','','',''),(1995,'item','width',22,'Numeric','','','',''),(1996,'item','length',22,'Numeric','','','',''),(1997,'item','mwt',22,'Numeric','','','',''),(1998,'item','cogs',22,'Numeric','','','',''),(1999,'item','cogseffectivedate',19,'DateTime','','','',''),(2000,'item','middlemanprice',22,'Numeric','','','',''),(2001,'item','price',22,'Numeric','','not used','',''),(2002,'item','priceeffectivedate',19,'DateTime','','not used','',''),(2003,'item','status',11,'Integer','','','',''),(2004,'item','id_item_useinstead',100,'Text','','if out or discontinued, use this item.id instead','','item.id'),(2005,'item','invtype',11,'Integer','1,2,3','1=physical\r\n2=POD\r\n3=Finished Goods','',''),(2006,'item','catalogdescription',65535,'X','','','',''),(2007,'item','products_website',255,'Text','','','',''),(2008,'item','catalogsheeturl',200,'Text','','','',''),(2009,'item','graphicurl',200,'Text','','','',''),(2010,'item','companyid',22,'Numeric','','gencompany.id - which company this item is associated with','multiple','gencompany.id'),(2011,'item','cancel',11,'Integer','0,1','1=cancelled','',''),(2012,'item','canceldate',19,'DateTime','','','',''),(2013,'item','canceluserid',22,'Numeric','','','',''),(2014,'item','entrydate',19,'DateTime','','','',''),(2015,'item','entryuserid',22,'Numeric','','','',''),(2016,'item','lastchangedate',19,'DateTime','','','',''),(2017,'item','lastchangeuserid',22,'Numeric','','','',''),(2018,'item','products_quantity',4,'Integer','','','',''),(2019,'item','products_viewed',5,'Integer','','','',''),(2020,'item','products_status',1,'Integer','','','',''),(2021,'item','products_tax_class_id',5,'Integer','','','',''),(2022,'item','products_costprice',10,'Numeric','','','',''),(2023,'item','products_pushup',6,'Numeric','','','',''),(2024,'item','scart',2,'Integer','','','',''),(2025,'item','parentitemid',22,'Numeric','','','multiple',''),(2026,'item','scart_minqtydisplay',11,'Integer','','','',''),(2027,'itemcategory','id',22,'Numeric','','','primary unique',''),(2028,'itemcategory','companyid',22,'Numeric','','','',''),(2029,'itemcategory','name',50,'Text','','','',''),(2030,'itemcategory','invtype',11,'Integer','','','',''),(2031,'itemcategory','cancel',11,'Integer','','','',''),(2032,'itemcategory','canceldate',19,'DateTime','','','',''),(2033,'itemcategory','canceluserid',22,'Numeric','','','',''),(2034,'itemcategory','entrydate',19,'DateTime','','','',''),(2035,'itemcategory','entryuserid',22,'Numeric','','','',''),(2036,'itemcategory','lastchangedate',19,'DateTime','','','',''),(2037,'itemcategory','lastchangeuserid',22,'Numeric','','','',''),(2038,'itemcategory','seasonname1',50,'Text','','','',''),(2039,'itemcategory','seasonname2',50,'Text','','','',''),(2040,'itemcategory','seasonname3',50,'Text','','','',''),(2041,'itemcategory','seasonname4',50,'Text','','','',''),(2042,'itemcategory','seasonbegin1',25,'Text','','','',''),(2043,'itemcategory','seasonbegin2',25,'Text','','','',''),(2044,'itemcategory','seasonbegin3',25,'Text','','','',''),(2045,'itemcategory','seasonbegin4',25,'Text','','','',''),(2046,'itemcategory','seasonend1',25,'Text','','','',''),(2047,'itemcategory','seasonend2',25,'Text','','','',''),(2048,'itemcategory','seasonend3',25,'Text','','','',''),(2049,'itemcategory','seasonend4',25,'Text','','','',''),(2050,'itemcategory','categories_image',64,'Text','','','',''),(2051,'itemcategory','parent_id',5,'Integer','','','',''),(2052,'itemcategory','sort_order',3,'Integer','','','',''),(2053,'itemcategory','is_print_order',11,'Integer','','','',''),(2054,'itemlocation','id',22,'Numeric','','','primary unique',''),(2055,'itemlocation','itemid',22,'Numeric','','','multiple',''),(2056,'itemlocation','inventorylocationid',22,'Numeric','','','multiple',''),(2057,'itemlocation','onhandqty',22,'Numeric','','','',''),(2058,'itemlocation','maxstocklevelseason1',22,'Numeric','','','',''),(2059,'itemlocation','minstocklevelseason1',22,'Numeric','','','',''),(2060,'itemlocation','orderqtyseason1',22,'Numeric','','','',''),(2061,'itemlocation','maxstocklevelseason2',22,'Numeric','','','',''),(2062,'itemlocation','minstocklevelseason2',22,'Numeric','','','',''),(2063,'itemlocation','orderqtyseason2',22,'Numeric','','','',''),(2064,'itemlocation','maxstocklevelseason3',22,'Numeric','','','',''),(2065,'itemlocation','minstocklevelseason3',22,'Numeric','','','',''),(2066,'itemlocation','orderqtyseason3',22,'Numeric','','','',''),(2067,'itemlocation','maxstocklevelseason4',22,'Numeric','','','',''),(2068,'itemlocation','minstocklevelseason4',22,'Numeric','','','',''),(2069,'itemlocation','orderqtyseason4',22,'Numeric','','','',''),(2070,'itemlocation','markupsetid',22,'Numeric','','','multiple',''),(2071,'itemlocation','firstcost',21,'Numeric','','','',''),(2072,'itemlocation','midcost',21,'Numeric','','','',''),(2073,'itemlocation','lastcost',21,'Numeric','','','',''),(2074,'itemlocation','firstqty',22,'Numeric','','','',''),(2075,'itemlocation','midqty',22,'Numeric','','','',''),(2076,'itemlocation','lastqty',22,'Numeric','','','',''),(2077,'itemlocation','cancel',11,'Integer','','','',''),(2078,'itemlocation','canceldate',19,'DateTime','','','',''),(2079,'itemlocation','canceluserid',22,'Numeric','','','',''),(2080,'itemlocation','entrydate',19,'DateTime','','','',''),(2081,'itemlocation','entryuserid',22,'Numeric','','','',''),(2082,'itemlocation','lastchangedate',19,'DateTime','','','',''),(2083,'itemlocation','lastchangeuserid',22,'Numeric','','','',''),(2084,'itemoption','id',11,'Integer','','','primary',''),(2085,'itemoption','itemoptiongroupid',11,'Integer','','','multiple',''),(2086,'itemoption','itemid',11,'Integer','','','multiple',''),(2087,'itemoption','price',14,'Numeric','','','',''),(2088,'itemoption','cost',14,'Numeric','','','',''),(2089,'itemoption','minqty',14,'Numeric','','','',''),(2090,'itemoption','maxqty',14,'Numeric','','','',''),(2091,'itemoption','mainind',2,'Integer','','','',''),(2092,'itemoption','rounding',2,'Integer','','','',''),(2093,'itemoption','name',255,'Text','','','',''),(2094,'itemoption','description',65535,'X','','','',''),(2095,'itemoption','priceunitnameid',11,'Integer','','','multiple',''),(2096,'itemoption','salesunitnameid',11,'Integer','','','multiple',''),(2097,'itemoption','saleunitperpriceunit',9,'Numeric','','','',''),(2098,'itemoption','lbsperpriceunit',22,'Numeric','','','',''),(2099,'itemoption','defaultvalue',14,'Numeric','','','',''),(2100,'itemoption','defaultoption',2,'Integer','','','',''),(2101,'itemoption','displayorder',11,'Integer','','','',''),(2102,'itemoption','taxable',2,'Integer','','','',''),(2103,'itemoption','salesglaccountid',11,'Integer','','','multiple',''),(2104,'itemoption','entrydate',19,'DateTime','','','',''),(2105,'itemoption','entryuserid',11,'Integer','','','',''),(2106,'itemoption','lastchangedate',19,'DateTime','','','',''),(2107,'itemoption','lastchangeuserid',11,'Integer','','','',''),(2108,'itemoption','companyid',11,'Integer','','','',''),(2109,'itemoption','cancel',2,'Integer','','','',''),(2110,'itemoptiongroup','id',11,'Integer','','','primary',''),(2111,'itemoptiongroup','name',255,'Text','','','',''),(2112,'itemoptiongroup','description',65535,'X','','','',''),(2113,'itemoptiongroup','optiontype',8,'Text','','','',''),(2114,'itemoptiongroup','allowblank',2,'Integer','','','',''),(2115,'itemoptiongroup','entrydate',19,'DateTime','','','',''),(2116,'itemoptiongroup','entryuserid',11,'Integer','','','',''),(2117,'itemoptiongroup','lastchangedate',19,'DateTime','','','',''),(2118,'itemoptiongroup','lastchangeuserid',11,'Integer','','','',''),(2119,'itemoptiongroup','companyid',11,'Integer','','','',''),(2120,'itemoptiongroup','cancel',2,'Integer','','','',''),(2121,'itemoptiongroupitem','id',11,'Integer','','','primary',''),(2122,'itemoptiongroupitem','itemoptiongroupid',11,'Integer','','','multiple',''),(2123,'itemoptiongroupitem','itemid',11,'Integer','','','multiple',''),(2124,'itemoptiongroupitem','sortorder',11,'Integer','','','',''),(2125,'itemtransaction','id',11,'Integer','','','primary',''),(2126,'itemtransaction','itemid',11,'Integer','','item in inventory','multiple','item.id'),(2127,'itemtransaction','wherefrom',2,'Integer','1-7','1=arorder\r\n2=shopping cart\r\n3=inventory adjustment (adjust or physical inv. Auto-adjust)\r\n4=inventory move\r\n5=inventory buildorder\r\n6=PO\r\n7=without PO','multiple',''),(2128,'itemtransaction','referenceid',11,'Integer','','id of related table (from wherefrom info). This may not have a value.','',''),(2129,'itemtransaction','locationid',11,'Integer','','location where inventory resides','multiple','inventorylocation.id'),(2130,'itemtransaction','description',100,'Text','','','',''),(2131,'itemtransaction','quantity',21,'Numeric','','quantity of usage units','',''),(2132,'itemtransaction','costpereach',21,'Numeric','','cost per usage unit','',''),(2133,'itemtransaction','trtype',2,'Integer','1-6','1=committed (does not affect on-hand)\r\n2=received/purchased\r\n3=used/sold\r\n4=adjusted\r\n5=balance forward\r\n6=damaged','multiple',''),(2134,'itemtransaction','createdate',19,'DateTime','','date created','multiple',''),(2135,'itemtransaction','createuserid',11,'Integer','','who created','','genuser.id'),(2136,'itemtransaction','cancel',2,'Integer','1,0','1=cancel','multiple',''),(2137,'itemtransaction','canceluserid',11,'Integer','','who cancelled','','genuser.id'),(2138,'itemtransaction','canceldate',19,'DateTime','','date cancelled','',''),(2139,'itemtransaction','id_order_shipment',11,'Integer','','','',''),(2140,'itemtransaction','pricepereach',21,'Numeric','','sell price per usage unit','',''),(2141,'itemvendor','id',22,'Numeric','','','primary unique',''),(2142,'itemvendor','vendorid',22,'Numeric','','','multiple',''),(2143,'itemvendor','itemid',22,'Numeric','','','multiple',''),(2144,'itemvendor','vordernumber',30,'Text','','','',''),(2145,'itemvendor','vitemunitnameid',22,'Numeric','','','',''),(2146,'itemvendor','vitemconversion',14,'Numeric','','','',''),(2147,'itemvendor','vitemcost1',21,'Numeric','','','',''),(2148,'itemvendor','vitemqty1',21,'Numeric','','','',''),(2149,'itemvendor','vitemcost2',21,'Numeric','','','',''),(2150,'itemvendor','vitemqty2',21,'Numeric','','','',''),(2151,'itemvendor','vitemcost3',21,'Numeric','','','',''),(2152,'itemvendor','vitemqty3',21,'Numeric','','','',''),(2153,'itemvendor','vitemcost4',21,'Numeric','','','',''),(2154,'itemvendor','cancel',11,'Integer','','','',''),(2155,'itemvendor','canceldate',19,'DateTime','','','',''),(2156,'itemvendor','canceluserid',22,'Numeric','','','',''),(2157,'itemvendor','entrydate',19,'DateTime','','','',''),(2158,'itemvendor','entryuserid',22,'Numeric','','','',''),(2159,'itemvendor','lastchangedate',19,'DateTime','','','',''),(2160,'itemvendor','lastchangeuserid',22,'Numeric','','','',''),(2161,'lang','id',11,'Integer','','','primary',''),(2162,'lang','name',255,'Text','','','multiple',''),(2163,'lang','en',255,'Text','','','',''),(2164,'lang','de',255,'Text','','','',''),(2165,'lang','es',255,'Text','','','',''),(2166,'lang','ru',255,'Text','','','',''),(2167,'langmatch','id',11,'Integer','','','primary',''),(2168,'langmatch','langid',11,'Integer','','','multiple',''),(2169,'langmatch','page',100,'Text','','','multiple',''),(2170,'languages','languages_id',5,'Integer','','','primary',''),(2171,'languages','name',32,'Text','','','multiple',''),(2172,'languages','code',2,'Text','','','',''),(2173,'languages','image',64,'Text','','','',''),(2174,'languages','directory',32,'Text','','','',''),(2175,'languages','sort_order',3,'Integer','','','',''),(2176,'languages','cancel',11,'Integer','','','',''),(2177,'latereason','id_latereason',11,'Integer','','','primary',''),(2178,'latereason','reason',100,'Text','','','',''),(2179,'latereason','createdate',10,'Date','','','',''),(2180,'latereason','id_user_create',11,'Integer','','','',''),(2181,'latereason','lastrevisedate',19,'DateTime','','','',''),(2182,'latereason','id_user_revise',11,'Integer','','','',''),(2183,'latereason','canceldate',10,'Date','','','',''),(2184,'latereason','cancel',11,'Integer','','','',''),(2185,'latereason','gencompanyid',11,'Integer','','','',''),(2186,'machine','id_machine',11,'Integer','','','primary unique',''),(2187,'machine','id_family',11,'Integer','','','',''),(2188,'machine','name',50,'Text','','','',''),(2189,'machine','serialnumber',50,'Text','','','',''),(2190,'machine','machinecostperhour',12,'Numeric','','','',''),(2191,'machine','laborcostperhour',12,'Numeric','','','',''),(2192,'machine','id_company',11,'Integer','','','',''),(2193,'machine','id_location',11,'Integer','','','',''),(2194,'machine','operatortime',7,'Numeric','','','',''),(2195,'machine','overhead',7,'Numeric','','','',''),(2196,'machine','markup',7,'Numeric','','','',''),(2197,'machine','is_default',1,'Integer','','','',''),(2198,'machine','rolloverpoint',15,'Integer','','','',''),(2199,'machine','createdate',19,'DateTime','','','',''),(2200,'machine','id_user_create',11,'Integer','','','',''),(2201,'machine','lastrevisedate',19,'DateTime','','','',''),(2202,'machine','id_user_revise',11,'Integer','','','',''),(2203,'machine','canceldate',19,'DateTime','','','',''),(2204,'machine','cancel',11,'Integer','','','',''),(2205,'machine','gencompanyid',11,'Integer','','','',''),(2206,'markupset','id',22,'Numeric','','','primary unique',''),(2207,'markupset','description',35,'Text','','','',''),(2208,'markupset','costbased',11,'Integer','','','multiple',''),(2209,'markupset','companyid',22,'Numeric','','','multiple',''),(2210,'markupset','cancel',11,'Integer','','','',''),(2211,'markupset','canceldate',19,'DateTime','','','',''),(2212,'markupset','canceluserid',22,'Numeric','','','',''),(2213,'markupset','entrydate',19,'DateTime','','','',''),(2214,'markupset','entryuserid',22,'Numeric','','','',''),(2215,'markupset','lastchangedate',19,'DateTime','','','',''),(2216,'markupset','lastchangeuserid',22,'Numeric','','','',''),(2217,'markupsetlevel','id',22,'Numeric','','','primary unique',''),(2218,'markupsetlevel','pricelevelid',22,'Numeric','','','multiple',''),(2219,'markupsetlevel','markupsetid',22,'Numeric','','','multiple',''),(2220,'markupsetlevel','markuppercent',8,'Numeric','','','',''),(2221,'markupsetlevel','cancel',11,'Integer','','','',''),(2222,'markupsetlevel','canceldate',19,'DateTime','','','',''),(2223,'markupsetlevel','canceluserid',22,'Numeric','','','',''),(2224,'markupsetlevel','entrydate',19,'DateTime','','','',''),(2225,'markupsetlevel','entryuserid',22,'Numeric','','','',''),(2226,'markupsetlevel','lastchangedate',19,'DateTime','','','',''),(2227,'markupsetlevel','lastchangeuserid',22,'Numeric','','','',''),(2228,'menucategory','id',11,'Integer','','','primary unique',''),(2229,'menucategory','name',50,'Text','','','',''),(2230,'menucategory','orderflag',11,'Integer','','','multiple',''),(2231,'menucategory','menu',11,'Integer','','','',''),(2232,'menucategory','description',65535,'X','','','',''),(2233,'menucategory','accessap',11,'Integer','','','multiple',''),(2234,'menucategory','accessar',11,'Integer','','','multiple',''),(2235,'menucategory','accessgl',11,'Integer','','','multiple',''),(2236,'menucategory','accesspay',11,'Integer','','','multiple',''),(2237,'menucategory','accessinv',11,'Integer','','','multiple',''),(2238,'menucategory','accessest',11,'Integer','','','multiple',''),(2239,'menucategory','accessfix',11,'Integer','','','multiple',''),(2240,'menucategory','accessimp',11,'Integer','','','multiple',''),(2241,'menucategory','setupap',11,'Integer','','','',''),(2242,'menucategory','setupar',11,'Integer','','','',''),(2243,'menucategory','setupgl',11,'Integer','','','',''),(2244,'menucategory','setuppay',11,'Integer','','','',''),(2245,'menucategory','setupinv',11,'Integer','','','',''),(2246,'menucategory','setupest',11,'Integer','','','',''),(2247,'menucategory','setupfix',11,'Integer','','','',''),(2248,'menucategory','setupimp',11,'Integer','','','',''),(2249,'menucategory','supervisor',11,'Integer','','','multiple',''),(2250,'menucategory','nonsupervisor',11,'Integer','','','multiple',''),(2251,'menucategory','extvend',11,'Integer','','','multiple',''),(2252,'menucategory','extcust',11,'Integer','','','multiple',''),(2253,'menucategory','nonext',11,'Integer','','','multiple',''),(2254,'menudata','id',11,'Integer','','','primary',''),(2255,'menudata','menu_name',100,'Text','','','',''),(2256,'menudata','id_menudata',11,'Integer','','','',''),(2257,'menudata','orderflag',5,'Integer','','','',''),(2258,'menudata','menu_action',2,'Integer','','','',''),(2259,'menudata','description',250,'Text','','','',''),(2260,'menudata','accessap',2,'Integer','','','',''),(2261,'menudata','accessar',2,'Integer','','','',''),(2262,'menudata','accessgl',2,'Integer','','','',''),(2263,'menudata','accesspay',2,'Integer','','','',''),(2264,'menudata','accessinv',2,'Integer','','','',''),(2265,'menudata','accessest',2,'Integer','','','',''),(2266,'menudata','accessfix',2,'Integer','','','',''),(2267,'menudata','accessimp',2,'Integer','','','',''),(2268,'menudata','accesssc',2,'Integer','','','',''),(2269,'menudata','setupap',2,'Integer','','','',''),(2270,'menudata','setupar',2,'Integer','','','',''),(2271,'menudata','setupgl',2,'Integer','','','',''),(2272,'menudata','setuppay',2,'Integer','','','',''),(2273,'menudata','setupinv',2,'Integer','','','',''),(2274,'menudata','setupest',2,'Integer','','','',''),(2275,'menudata','setupfix',2,'Integer','','','',''),(2276,'menudata','setupimp',2,'Integer','','','',''),(2277,'menudata','setupsc',2,'Integer','','','',''),(2278,'menudata','supervisor',2,'Integer','','','',''),(2279,'menudata','extvend',2,'Integer','','','',''),(2280,'menudata','extcust',2,'Integer','','','',''),(2281,'menudata','nonext',2,'Integer','','','',''),(2282,'menudata','menu_link',255,'Text','','','',''),(2283,'menudata','languageid',2,'Integer','','','',''),(2284,'menudataorder','id',11,'Integer','','','primary',''),(2285,'menudataorder','menu_name',30,'Text','','','',''),(2286,'menudataorder','id_menudata',11,'Integer','','','',''),(2287,'menudataorder','orderflag',5,'Integer','','','',''),(2288,'menudataorder','menu_action',2,'Integer','','','',''),(2289,'menudataorder','description',250,'Text','','','',''),(2290,'menudataorder','accessap',2,'Integer','','','',''),(2291,'menudataorder','accessar',2,'Integer','','','',''),(2292,'menudataorder','accessgl',2,'Integer','','','',''),(2293,'menudataorder','accesspay',2,'Integer','','','',''),(2294,'menudataorder','accessinv',2,'Integer','','','',''),(2295,'menudataorder','accessest',2,'Integer','','','',''),(2296,'menudataorder','accessfix',2,'Integer','','','',''),(2297,'menudataorder','accessimp',2,'Integer','','','',''),(2298,'menudataorder','setupap',2,'Integer','','','',''),(2299,'menudataorder','setupar',2,'Integer','','','',''),(2300,'menudataorder','setupgl',2,'Integer','','','',''),(2301,'menudataorder','setuppay',2,'Integer','','','',''),(2302,'menudataorder','setupinv',2,'Integer','','','',''),(2303,'menudataorder','setupest',2,'Integer','','','',''),(2304,'menudataorder','setupfix',2,'Integer','','','',''),(2305,'menudataorder','setupimp',2,'Integer','','','',''),(2306,'menudataorder','supervisor',2,'Integer','','','',''),(2307,'menudataorder','extvend',2,'Integer','','','',''),(2308,'menudataorder','extcust',2,'Integer','','','',''),(2309,'menudataorder','nonext',2,'Integer','','','',''),(2310,'menudataorder','menu_link',255,'Text','','','',''),(2311,'menudatavendor','id',11,'Integer','','','primary',''),(2312,'menudatavendor','menu_name',30,'Text','','','',''),(2313,'menudatavendor','id_menudata',11,'Integer','','','',''),(2314,'menudatavendor','orderflag',5,'Integer','','','',''),(2315,'menudatavendor','menu_action',2,'Integer','','','',''),(2316,'menudatavendor','description',250,'Text','','','',''),(2317,'menudatavendor','accessap',2,'Integer','','','',''),(2318,'menudatavendor','accessar',2,'Integer','','','',''),(2319,'menudatavendor','accessgl',2,'Integer','','','',''),(2320,'menudatavendor','accesspay',2,'Integer','','','',''),(2321,'menudatavendor','accessinv',2,'Integer','','','',''),(2322,'menudatavendor','accessest',2,'Integer','','','',''),(2323,'menudatavendor','accessfix',2,'Integer','','','',''),(2324,'menudatavendor','accessimp',2,'Integer','','','',''),(2325,'menudatavendor','setupap',2,'Integer','','','',''),(2326,'menudatavendor','setupar',2,'Integer','','','',''),(2327,'menudatavendor','setupgl',2,'Integer','','','',''),(2328,'menudatavendor','setuppay',2,'Integer','','','',''),(2329,'menudatavendor','setupinv',2,'Integer','','','',''),(2330,'menudatavendor','setupest',2,'Integer','','','',''),(2331,'menudatavendor','setupfix',2,'Integer','','','',''),(2332,'menudatavendor','setupimp',2,'Integer','','','',''),(2333,'menudatavendor','supervisor',2,'Integer','','','',''),(2334,'menudatavendor','extvend',2,'Integer','','','',''),(2335,'menudatavendor','extcust',2,'Integer','','','',''),(2336,'menudatavendor','nonext',2,'Integer','','','',''),(2337,'menudatavendor','menu_link',255,'Text','','','',''),(2338,'menufunction','id',11,'Integer','','','primary unique',''),(2339,'menufunction','menucategoryid',11,'Integer','','','multiple',''),(2340,'menufunction','name',50,'Text','','','',''),(2341,'menufunction','leftimageurl',50,'Text','','','',''),(2342,'menufunction','rightimageurl',50,'Text','','','',''),(2343,'menufunction','link',50,'Text','','','',''),(2344,'menufunction','orderflag',11,'Integer','','','multiple',''),(2345,'menufunction','accessap',11,'Integer','','','multiple',''),(2346,'menufunction','accessar',11,'Integer','','','multiple',''),(2347,'menufunction','accessgl',11,'Integer','','','multiple',''),(2348,'menufunction','accesspay',11,'Integer','','','multiple',''),(2349,'menufunction','accessinv',11,'Integer','','','multiple',''),(2350,'menufunction','accessest',11,'Integer','','','multiple',''),(2351,'menufunction','accessfix',11,'Integer','','','multiple',''),(2352,'menufunction','accessimp',11,'Integer','','','multiple',''),(2353,'menufunction','setupap',11,'Integer','','','',''),(2354,'menufunction','setupar',11,'Integer','','','',''),(2355,'menufunction','setupgl',11,'Integer','','','',''),(2356,'menufunction','setuppay',11,'Integer','','','',''),(2357,'menufunction','setupinv',11,'Integer','','','',''),(2358,'menufunction','setupest',11,'Integer','','','',''),(2359,'menufunction','setupfix',11,'Integer','','','',''),(2360,'menufunction','setupimp',11,'Integer','','','',''),(2361,'menufunction','supervisor',11,'Integer','','','multiple',''),(2362,'menufunction','nonsupervisor',11,'Integer','','','multiple',''),(2363,'menufunction','extvend',11,'Integer','','','multiple',''),(2364,'menufunction','extcust',11,'Integer','','','multiple',''),(2365,'menufunction','nonext',11,'Integer','','','multiple',''),(2366,'menupage','id',11,'Integer','','','primary unique',''),(2367,'menupage','menufunctionid',11,'Integer','','','multiple',''),(2368,'menupage','name',50,'Text','','','',''),(2369,'menupage','orderflag',11,'Integer','','','multiple',''),(2370,'menupage','accessap',11,'Integer','','','multiple',''),(2371,'menupage','accessar',11,'Integer','','','multiple',''),(2372,'menupage','accessgl',11,'Integer','','','multiple',''),(2373,'menupage','accesspay',11,'Integer','','','multiple',''),(2374,'menupage','accessinv',11,'Integer','','','multiple',''),(2375,'menupage','accessest',11,'Integer','','','multiple',''),(2376,'menupage','accessfix',11,'Integer','','','multiple',''),(2377,'menupage','accessimp',11,'Integer','','','multiple',''),(2378,'menupage','setupap',11,'Integer','','','',''),(2379,'menupage','setupar',11,'Integer','','','',''),(2380,'menupage','setupgl',11,'Integer','','','',''),(2381,'menupage','setuppay',11,'Integer','','','',''),(2382,'menupage','setupinv',11,'Integer','','','',''),(2383,'menupage','setupest',11,'Integer','','','',''),(2384,'menupage','setupfix',11,'Integer','','','',''),(2385,'menupage','setupimp',11,'Integer','','','',''),(2386,'menupage','supervisor',11,'Integer','','','multiple',''),(2387,'menupage','nonsupervisor',11,'Integer','','','multiple',''),(2388,'menupage','extvend',11,'Integer','','','multiple',''),(2389,'menupage','extcust',11,'Integer','','','multiple',''),(2390,'menupage','nonext',11,'Integer','','','multiple',''),(2391,'mod_help_categories','id',11,'Integer','','','primary',''),(2392,'mod_help_categories','parent_id',11,'Integer','','','',''),(2393,'mod_help_categories','name',255,'Text','','','',''),(2394,'mod_help_categories','ordering',11,'Integer','','','',''),(2395,'mod_help_related_topics','id',11,'Integer','','','primary',''),(2396,'mod_help_related_topics','topic_id',11,'Integer','','','',''),(2397,'mod_help_related_topics','related_topic_id',11,'Integer','','','',''),(2398,'mod_help_topics','id',11,'Integer','','','primary',''),(2399,'mod_help_topics','parent_id',11,'Integer','','','',''),(2400,'mod_help_topics','topic',255,'Text','','','',''),(2401,'mod_help_topics','helptext',65535,'X','','','',''),(2402,'mod_help_topics','ordering',11,'Integer','','','',''),(2403,'modules','id',11,'Integer','','','primary',''),(2404,'modules','name',255,'Text','','','',''),(2405,'order_actual','id_order_actual',11,'Integer','','','primary unique',''),(2406,'order_actual','id_printorder',11,'Integer','','','multiple',''),(2407,'order_actual','id_family',11,'Integer','','','multiple',''),(2408,'order_actual','print_type',2,'Integer','','','',''),(2409,'order_actual','id_question',11,'Integer','','','',''),(2410,'order_actual','id_question_detail',11,'Integer','','','',''),(2411,'order_actual','id_machine',11,'Integer','','','multiple',''),(2412,'order_actual','id_item',11,'Integer','','','',''),(2413,'order_actual','redo',2,'Integer','','','multiple',''),(2414,'order_actual','actual_time',8,'Numeric','','','',''),(2415,'order_actual','hourlyrate',17,'Numeric','','','',''),(2416,'order_actual','production_quantity',17,'Numeric','','','',''),(2417,'order_actual','production_costperunit',17,'Numeric','','','',''),(2418,'order_actual','actual_matl',17,'Numeric','','','',''),(2419,'order_actual','material_unitcost',17,'Numeric','','','',''),(2420,'order_actual','comments',250,'Text','','','',''),(2421,'order_actual','initials',10,'Text','','','',''),(2422,'order_actual','createdate',19,'DateTime','','','',''),(2423,'order_actual','id_user_create',11,'Integer','','','',''),(2424,'order_actual','lastrevisedate',19,'DateTime','','','',''),(2425,'order_actual','id_user_revise',11,'Integer','','','',''),(2426,'order_actual','canceldate',10,'Date','','','',''),(2427,'order_actual','cancel',1,'Integer','','','',''),(2428,'order_actual','time_eq_actual',12,'Numeric','','','',''),(2429,'order_actual','time_op_actual',12,'Numeric','','','',''),(2430,'order_actual','cost_op_hour',12,'Numeric','','','',''),(2431,'order_actual','cost_eq_hour',12,'Numeric','','','',''),(2432,'order_actual','matl_qty_actual',12,'Numeric','','','',''),(2433,'order_actual','matl_unitcost_actual',12,'Numeric','','','',''),(2434,'order_actual','markup',12,'Numeric','','','',''),(2435,'order_actual','extendedprice',12,'Numeric','','','',''),(2436,'order_actual','overhead',12,'Numeric','','','',''),(2437,'order_actual','Impressions_actual',12,'Numeric','','','',''),(2438,'order_actual','production_priceperunit',14,'Numeric','','','',''),(2439,'order_actual','price_per_hour',14,'Numeric','','','',''),(2440,'order_actual','matl_unitprice_actual',14,'Numeric','','','',''),(2441,'order_actual','iphunit_name',20,'Text','','','',''),(2442,'order_additional','id',11,'Integer','','','primary',''),(2443,'order_additional','id_printorder',11,'Integer','','','',''),(2444,'order_additional','id_gencompany',11,'Integer','','','',''),(2445,'order_additional','description',250,'Text','','','',''),(2446,'order_additional','quantity',15,'Text','','','',''),(2447,'order_additional','price',17,'Numeric','','','',''),(2448,'order_chargenum','id_order_chargenum',11,'Integer','','','primary unique',''),(2449,'order_chargenum','id_printorder',11,'Integer','','','multiple',''),(2450,'order_chargenum','charge_number',15,'Text','','','multiple',''),(2451,'order_chargenum','activity_number',15,'Text','','','',''),(2452,'order_chargenum','subactivity_number',15,'Text','','','',''),(2453,'order_chargenum','percent_of_order',12,'Numeric','','','',''),(2454,'order_chargenum','cancel',1,'Integer','','','',''),(2455,'order_chargenum','canceldate',10,'Date','','','',''),(2456,'order_chargenum','wherefrom',2,'Integer','','','',''),(2457,'order_document','id_order_document',11,'Integer','','','primary',''),(2458,'order_document','id_printorder',11,'Integer','','','multiple',''),(2459,'order_document','docname',255,'Text','','','',''),(2460,'order_document','origdocname',255,'Text','','','',''),(2461,'order_document','cancel',2,'Integer','','','',''),(2462,'order_document','lastrevisedate',19,'DateTime','','','',''),(2463,'order_document','id_temp',11,'Integer','','','',''),(2464,'order_functions','id_order_functions',11,'Integer','','','primary unique',''),(2465,'order_functions','id_printorder',11,'Integer','','','multiple',''),(2466,'order_functions','id_question',11,'Integer','','','multiple',''),(2467,'order_functions','sel_response',100,'Text','','','',''),(2468,'order_functions','text_response',100,'Text','','','',''),(2469,'order_functions','time_est',12,'Numeric','','','',''),(2470,'order_functions','time_est_price',14,'Numeric','','','',''),(2471,'order_functions','time_est_cost',14,'Numeric','','','',''),(2472,'order_functions','materials_est_cost',14,'Numeric','','','',''),(2473,'order_functions','materials_est_price',14,'Numeric','','','',''),(2474,'order_functions','createdate',19,'DateTime','','','',''),(2475,'order_functions','id_user_create',11,'Integer','','','',''),(2476,'order_functions','lastrevisedate',19,'DateTime','','','',''),(2477,'order_functions','id_user_revise',11,'Integer','','','',''),(2478,'order_functions','canceldate',19,'DateTime','','','',''),(2479,'order_functions','cancel',11,'Integer','','','',''),(2480,'order_functions','actual_quantity',17,'Numeric','','','',''),(2481,'order_functions','calc_quantity',17,'Numeric','','','',''),(2482,'order_functions','actual_quantity_materials',17,'Numeric','','','',''),(2483,'order_functions','calc_quantity_materials',17,'Numeric','','','',''),(2484,'order_functions','print_type',1,'Integer','','','',''),(2485,'order_functions','id_order_partnr',11,'Integer','','','',''),(2486,'order_functions','id_item',11,'Integer','','','',''),(2487,'order_functions','id_family',11,'Integer','','','',''),(2488,'order_functions','time_eq_est',12,'Numeric','','','',''),(2489,'order_functions','time_op_est',12,'Numeric','','','',''),(2490,'order_functions','cost_op_hour',12,'Numeric','','','',''),(2491,'order_functions','cost_eq_hour',12,'Numeric','','','',''),(2492,'order_functions','matl_qty_est',12,'Numeric','','','',''),(2493,'order_functions','matl_unitcost_est',12,'Numeric','','','',''),(2494,'order_functions','overhead',6,'Numeric','','','',''),(2495,'order_functions','markup',6,'Numeric','','','',''),(2496,'order_functions','extendedprice',12,'Numeric','','','',''),(2497,'order_functions','Impressions_est',11,'Integer','','','',''),(2498,'order_functions','quote_quantity',11,'Integer','','','',''),(2499,'order_functions','time_actual',14,'Numeric','','','',''),(2500,'order_functions','time_actual_cost',14,'Numeric','','','',''),(2501,'order_functions','time_actual_price',14,'Numeric','','','',''),(2502,'order_functions','materials_actual_price',14,'Numeric','','','',''),(2503,'order_functions','materials_actual_cost',14,'Numeric','','','',''),(2504,'order_functions','production_quantity',14,'Integer','','','',''),(2505,'order_functions','production_priceperunit',14,'Numeric','','','',''),(2506,'order_functions','matl_unitprice_est',14,'Numeric','','','',''),(2507,'order_functions','price_per_hour',14,'Numeric','','','',''),(2508,'order_functions','iphunit_name',20,'Text','','','',''),(2509,'order_partnr','id_order_partnr',11,'Integer','','','primary unique',''),(2510,'order_partnr','id_printorder',11,'Integer','','','multiple',''),(2511,'order_partnr','id_item',11,'Integer','','','multiple',''),(2512,'order_partnr','print_method',3,'Integer','','','',''),(2513,'order_partnr','quantity_est',15,'Numeric','','','',''),(2514,'order_partnr','quantity_scrap_cust',15,'Numeric','','','',''),(2515,'order_partnr','quantity_scrap_xrx',15,'Numeric','','','',''),(2516,'order_partnr','quantity_good_actual',15,'Numeric','','','',''),(2517,'order_partnr','cost_per_salesunit',12,'Numeric','','','',''),(2518,'order_partnr','price_per_salesunit',12,'Numeric','','','',''),(2519,'order_partnr','status',3,'Integer','','','',''),(2520,'order_partnr','description',20,'Text','','','',''),(2521,'order_partnr','number_up',3,'Integer','','','',''),(2522,'order_partnr','pages',5,'Integer','','','',''),(2523,'order_partnr','num_originals',5,'Integer','','','',''),(2524,'order_partnr','sides',1,'Integer','','','',''),(2525,'order_partnr','special_order',50,'Text','','','',''),(2526,'order_partnr','width',12,'Numeric','','','',''),(2527,'order_partnr','length',12,'Numeric','','','',''),(2528,'order_partnr','impressions',15,'Numeric','','','',''),(2529,'order_partnr','num_colors',3,'Integer','','','',''),(2530,'order_partnr','colorlist',100,'Text','','','',''),(2531,'order_partnr','createdate',19,'DateTime','','','',''),(2532,'order_partnr','id_user_create',11,'Integer','','','',''),(2533,'order_partnr','lastrevisedate',19,'DateTime','','','',''),(2534,'order_partnr','id_user_revise',11,'Integer','','','',''),(2535,'order_partnr','canceldate',19,'DateTime','','','',''),(2536,'order_partnr','cancel',11,'Integer','','','',''),(2537,'order_partnr','mwt',8,'Numeric','','','',''),(2538,'order_partnr','press_width',12,'Numeric','','','',''),(2539,'order_partnr','press_length',12,'Numeric','','','',''),(2540,'order_partnr','number_out',3,'Integer','','','',''),(2541,'order_partnr','colorlist_two',100,'Text','','','',''),(2542,'order_partnr','num_colors_two',3,'Integer','','','',''),(2543,'order_partnr','pages_per_sig',5,'Integer','','','',''),(2544,'order_partnr','signatures',5,'Integer','','','',''),(2545,'order_partnr','iphqty',11,'Integer','','','',''),(2546,'order_partnr','iphunit_name',20,'Text','','','',''),(2547,'order_partnr','difficulty',3,'Integer','','','',''),(2548,'order_po','id_order_po',11,'Integer','','','primary unique',''),(2549,'order_po','id_printorder',11,'Integer','','','multiple',''),(2550,'order_po','id_purchase_order',11,'Integer','','','multiple',''),(2551,'order_po','id_workarea',11,'Integer','','','',''),(2552,'order_proof','id_order_proof',11,'Integer','','','primary',''),(2553,'order_proof','sentdate',19,'DateTime','','','',''),(2554,'order_proof','pages',3,'Integer','','','',''),(2555,'order_proof','proof_status',1,'Integer','','','',''),(2556,'order_proof','id_printorder',11,'Integer','','','',''),(2557,'order_proof','responsedate',19,'DateTime','','','',''),(2558,'order_proof','duedate',19,'DateTime','','','',''),(2559,'order_proof','notes',250,'Text','','','',''),(2560,'order_proof','id_user_create',11,'Integer','','','',''),(2561,'order_proof','createdate',19,'DateTime','','','',''),(2562,'order_proof','lastrevisedate',19,'DateTime','','','',''),(2563,'order_proof','id_user_revise',11,'Integer','','','',''),(2564,'order_proof','cancel',11,'Integer','','','',''),(2565,'order_proof','canceldate',19,'DateTime','','','',''),(2566,'order_proof','days_after',11,'Integer','','','',''),(2567,'order_shipment','id_order_shipment',11,'Integer','','','primary unique',''),(2568,'order_shipment','id_order_shipto',11,'Integer','','','multiple',''),(2569,'order_shipment','quantity',15,'Integer','','','',''),(2570,'order_shipment','shipdate',19,'DateTime','','','',''),(2571,'order_shipment','id_order_shipmentlog',11,'Integer','','','',''),(2572,'order_shipment','packslip',2,'Integer','','','',''),(2573,'order_shipment','boxlabel',2,'Integer','','','',''),(2574,'order_shipment','logdate',19,'DateTime','','','',''),(2575,'order_shipment','createdate',10,'Date','','','',''),(2576,'order_shipment','id_user_create',11,'Integer','','','',''),(2577,'order_shipment','lastrevisedate',19,'DateTime','','','',''),(2578,'order_shipment','id_user_revise',11,'Integer','','','',''),(2579,'order_shipment','canceldate',10,'Date','','','',''),(2580,'order_shipment','cancel',11,'Integer','','','',''),(2581,'order_shipment','signfor',255,'Text','','','',''),(2582,'order_shipment','failed',11,'Integer','','','',''),(2583,'order_shipment','id_printorder',11,'Integer','','','',''),(2584,'order_shipment','notes',250,'Text','','','',''),(2585,'order_shipment','id_order_shipment_group',11,'Integer','','','multiple',''),(2586,'order_work','id',11,'Integer','','','primary',''),(2587,'order_work','id_employee',11,'Integer','','','',''),(2588,'order_work','id_printorder',11,'Integer','','','',''),(2589,'order_work','id_family',11,'Integer','','','',''),(2590,'order_work','id_question',11,'Integer','','','',''),(2591,'order_work','id_question_detail',11,'Integer','','','',''),(2592,'order_work','id_machine',11,'Integer','','','',''),(2593,'order_work','id_order_actual',11,'Integer','','','',''),(2594,'order_work','startdatetime',19,'DateTime','','','',''),(2595,'order_work','enddatetime',19,'DateTime','','','',''),(2596,'order_work','elapsedtime',17,'Numeric','','','',''),(2597,'order_work','status',11,'Integer','','','',''),(2598,'orders_products_attributes','orders_products_attributes_id',5,'Integer','','','primary',''),(2599,'orders_products_attributes','orders_id',5,'Integer','','','',''),(2600,'orders_products_attributes','orders_products_id',5,'Integer','','','',''),(2601,'orders_products_attributes','products_options',32,'Text','','','',''),(2602,'orders_products_attributes','products_options_values',32,'Text','','','',''),(2603,'orders_products_attributes','options_values_price',10,'Numeric','','','',''),(2604,'orders_products_attributes','price_prefix',1,'Text','','','',''),(2605,'originals','id_originals',11,'Integer','','','multiple',''),(2606,'originals','name',50,'Text','','','',''),(2607,'payplan_bills','id',11,'Integer','','','primary',''),(2608,'payplan_bills','payplan_invoiceid',11,'Integer','','','multiple',''),(2609,'payplan_bills','invoicedate',10,'Date','','','',''),(2610,'payplan_bills','invoiceid',11,'Integer','','','multiple',''),(2611,'pickupsalestax','id',11,'Integer','','','primary',''),(2612,'pickupsalestax','gencompanyid',11,'Integer','','','multiple',''),(2613,'pickupsalestax','salestaxid',11,'Integer','','','multiple',''),(2614,'practive','id',22,'Numeric','','','primary unique',''),(2615,'practive','employeeid',22,'Numeric','','','',''),(2616,'practive','status',11,'Integer','','','',''),(2617,'practive','statuschangedate',10,'Date','','','',''),(2618,'practive','lastchangedate',19,'DateTime','','','',''),(2619,'practive','lastchangeuserid',22,'Numeric','','','',''),(2620,'prbended','id',22,'Numeric','','','primary unique',''),(2621,'prbended','gencompanyid',22,'Numeric','','','',''),(2622,'prbended','paytype',11,'Integer','','','',''),(2623,'prbended','bendedtype',11,'Integer','','','',''),(2624,'prbended','name',30,'Text','','','multiple',''),(2625,'prbended','howfig',11,'Integer','','','',''),(2626,'prbended','prdedgroupid',22,'Numeric','','','',''),(2627,'prbended','rate',10,'Numeric','','','',''),(2628,'prbended','ceilingperyear',21,'Numeric','','','',''),(2629,'prbended','expenseglacctid',22,'Numeric','','','',''),(2630,'prbended','payableglacctid',22,'Numeric','','','',''),(2631,'prbended','vendorid',22,'Numeric','','','',''),(2632,'prbended','cancel',11,'Integer','','','',''),(2633,'prbended','canceldate',19,'DateTime','','','',''),(2634,'prbended','canceluserid',22,'Numeric','','','',''),(2635,'prbended','entrydate',19,'DateTime','','','',''),(2636,'prbended','entryuserid',22,'Numeric','','','',''),(2637,'prbended','lastchangedate',19,'DateTime','','','',''),(2638,'prbended','lastchangeuserid',22,'Numeric','','','',''),(2639,'prcity','id',22,'Numeric','','','primary unique',''),(2640,'prcity','gencompanyid',22,'Numeric','','','',''),(2641,'prcity','abrev',3,'Text','','','',''),(2642,'prcity','name',30,'Text','','','',''),(2643,'prcity','taxnum',20,'Text','','','',''),(2644,'prcity','deductfed',11,'Integer','','','',''),(2645,'prcity','feddeductmax',21,'Numeric','','','',''),(2646,'prcity','exemptyr1',21,'Numeric','','','',''),(2647,'prcity','exemptyr2',21,'Numeric','','','',''),(2648,'prcity','exemptyr3',21,'Numeric','','','',''),(2649,'prcity','exemptyr4',21,'Numeric','','','',''),(2650,'prcity','glacctid',22,'Numeric','','','',''),(2651,'prcity','vendorid',22,'Numeric','','','',''),(2652,'prcity','maxexemptpercent',7,'Numeric','','','',''),(2653,'prcity','maxexemptyear',21,'Numeric','','','',''),(2654,'prcity','taxcreditexempt1',21,'Numeric','','','',''),(2655,'prcity','taxcreditexempt2',21,'Numeric','','','',''),(2656,'prcity','taxcreditexempt3',21,'Numeric','','','',''),(2657,'prcity','taxcreditexempt4',21,'Numeric','','','',''),(2658,'prcity','cancel',11,'Integer','','','',''),(2659,'prcity','canceldate',19,'DateTime','','','',''),(2660,'prcity','canceluserid',22,'Numeric','','','',''),(2661,'prcity','entrydate',19,'DateTime','','','',''),(2662,'prcity','entryuserid',22,'Numeric','','','',''),(2663,'prcity','lastchangedate',19,'DateTime','','','',''),(2664,'prcity','lastchangeuserid',22,'Numeric','','','',''),(2665,'prcitydetail','id',22,'Numeric','','','primary unique',''),(2666,'prcitydetail','prcityid',22,'Numeric','','','',''),(2667,'prcitydetail','maritalstatus',11,'Integer','','','',''),(2668,'prcitydetail','deductiontable',11,'Integer','','','',''),(2669,'prcitydetail','tax',21,'Numeric','','','',''),(2670,'prcitydetail','percent',10,'Numeric','','','',''),(2671,'prcitydetail','over',21,'Numeric','','','',''),(2672,'prcompany','id',22,'Numeric','','','primary unique',''),(2673,'prcompany','fedtaxnum',15,'Text','','','',''),(2674,'prcompany','w2companyname',35,'Text','','','',''),(2675,'prcompany','w2companyaddress1',100,'Text','','','',''),(2676,'prcompany','w2companyaddress2',100,'Text','','','',''),(2677,'prcompany','w2citystatezip',100,'Text','','','',''),(2678,'prcompany','stateunemplnum',15,'Text','','','',''),(2679,'prcompany','glcheckaccountid',22,'Numeric','','','',''),(2680,'prcompany','glfitpayableid',22,'Numeric','','','',''),(2681,'prcompany','glficapayableid',22,'Numeric','','','',''),(2682,'prcompany','glficaexpenseid',22,'Numeric','','','',''),(2683,'prcompany','glfuipayableid',22,'Numeric','','','',''),(2684,'prcompany','glfuiexpenseid',22,'Numeric','','','',''),(2685,'prcompany','glmedicarepayableid',22,'Numeric','','','',''),(2686,'prcompany','glmedicareexpenseid',22,'Numeric','','','',''),(2687,'prcompany','glsuipayableid',22,'Numeric','','','',''),(2688,'prcompany','glsuiexpenseid',22,'Numeric','','','',''),(2689,'prcompany','glmiscdedpayableid',22,'Numeric','','','',''),(2690,'prcompany','gltaxexemptexpenseid',22,'Numeric','','','',''),(2691,'prcompany','glworkmanscomppayableid',22,'Numeric','','','',''),(2692,'prcompany','glworkmanscompexpenseid',22,'Numeric','','','',''),(2693,'prcompany','post2payables',11,'Integer','','','',''),(2694,'prcompany','checkacctid',22,'Numeric','','','',''),(2695,'prcompany','shift2multiplier',7,'Numeric','','','',''),(2696,'prcompany','shift3multiplier',7,'Numeric','','','',''),(2697,'prcompany','sickleavehrsperyear',7,'Numeric','','','',''),(2698,'prcompany','maxsickleave',9,'Numeric','','','',''),(2699,'prcompany','minwagehr',12,'Numeric','','','',''),(2700,'prcompany','autoprintdeposit',11,'Integer','','','',''),(2701,'prcompany','depositvendorid',22,'Numeric','','','',''),(2702,'prcompany','cancel',11,'Integer','','','',''),(2703,'prcompany','canceldate',19,'DateTime','','','',''),(2704,'prcompany','canceluserid',22,'Numeric','','','',''),(2705,'prcompany','entrydate',19,'DateTime','','','',''),(2706,'prcompany','entryuserid',22,'Numeric','','','',''),(2707,'prcompany','lastchangedate',19,'DateTime','','','',''),(2708,'prcompany','lastchangeuserid',22,'Numeric','','','',''),(2709,'prcompany','fringes',12,'Numeric','','','',''),(2710,'prcompany','default_dd_desc',10,'Text','','','',''),(2711,'prcompany','glpayroll_payableid',11,'Integer','','','',''),(2712,'prcompany','post2endperiod',5,'Integer','','','',''),(2713,'prcompanyperiod','id',22,'Numeric','','','primary unique',''),(2714,'prcompanyperiod','prcompanyid',22,'Numeric','','','multiple',''),(2715,'prcompanyperiod','prperiodid',22,'Numeric','','','multiple',''),(2716,'prcompanyperiod','maxpayhr',21,'Numeric','','','',''),(2717,'prcompanyperiod','maxgross',21,'Numeric','','','',''),(2718,'prcompanyperiod','cancel',11,'Integer','','','',''),(2719,'prdedgroup','id',22,'Numeric','','','primary unique',''),(2720,'prdedgroup','name',30,'Text','','','',''),(2721,'prdedgroup','gencompanyid',22,'Numeric','','','',''),(2722,'prdepositchecks','checkid',22,'Numeric','','','primary',''),(2723,'prdepositchecks','prperiodid',22,'Numeric','','','multiple',''),(2724,'prdepositchecks','periodbegindate',10,'Date','','','',''),(2725,'prdepositchecks','periodenddate',10,'Date','','','',''),(2726,'prdepositchecks','fit',21,'Numeric','','','',''),(2727,'prdepositchecks','fica',21,'Numeric','','','',''),(2728,'prdepositchecks','medicare',21,'Numeric','','','',''),(2729,'prdepositchecks','gencompanyid',22,'Numeric','','','',''),(2730,'prempldeduction','id',22,'Numeric','','','primary unique',''),(2731,'prempldeduction','employeeid',22,'Numeric','','','multiple',''),(2732,'prempldeduction','description',50,'Text','','','',''),(2733,'prempldeduction','amountperperiod',12,'Numeric','','','',''),(2734,'prempldeduction','glaccountid',22,'Numeric','','','',''),(2735,'prempldeduction','periodsremain',11,'Integer','','','',''),(2736,'prempldeduction','cancel',11,'Integer','','','',''),(2737,'prempldeduction','canceldate',19,'DateTime','','','',''),(2738,'prempldeduction','canceluserid',22,'Numeric','','','',''),(2739,'prempldeduction','entrydate',19,'DateTime','','','',''),(2740,'prempldeduction','entryuserid',22,'Numeric','','','',''),(2741,'prempldeduction','lastchangedate',19,'DateTime','','','',''),(2742,'prempldeduction','lastchangeuserid',22,'Numeric','','','',''),(2743,'premployee','id',22,'Numeric','','','primary unique',''),(2744,'premployee','companyid',22,'Numeric','','','',''),(2745,'premployee','firstname',30,'Text','','','',''),(2746,'premployee','lastname',30,'Text','','','',''),(2747,'premployee','ssnumber',20,'Text','','','',''),(2748,'premployee','dateofbirth',10,'Date','','','',''),(2749,'premployee','hiredate',10,'Date','','','',''),(2750,'premployee','terminatedate',10,'Date','','','',''),(2751,'premployee','lastreviewid',22,'Numeric','','','',''),(2752,'premployee','paytype',11,'Integer','','','',''),(2753,'premployee','payperiod',11,'Integer','','','',''),(2754,'premployee','payperperiod',21,'Numeric','','','',''),(2755,'premployee','lastpaychangedate',19,'DateTime','','','',''),(2756,'premployee','glaccountid',22,'Numeric','','','',''),(2757,'premployee','maritalstatus',11,'Integer','','','',''),(2758,'premployee','federalexemptions',11,'Integer','','','',''),(2759,'premployee','extrafitperpayperiod',21,'Numeric','','','',''),(2760,'premployee','extrafitbasedon',11,'Integer','','','',''),(2761,'premployee','eic',11,'Integer','','','',''),(2762,'premployee','prstateid',22,'Numeric','','','',''),(2763,'premployee','stateexemptions',11,'Integer','','','',''),(2764,'premployee','extrasitperpayperiod',21,'Numeric','','','',''),(2765,'premployee','extrasitbasedon',11,'Integer','','','',''),(2766,'premployee','prlocalid',22,'Numeric','','','',''),(2767,'premployee','localexemptions',11,'Integer','','','',''),(2768,'premployee','extralitperpayperiod',21,'Numeric','','','',''),(2769,'premployee','extralitbasedon',11,'Integer','','','',''),(2770,'premployee','prcityid',22,'Numeric','','','',''),(2771,'premployee','cityexemptions',11,'Integer','','','',''),(2772,'premployee','extracitperpayperiod',21,'Numeric','','','',''),(2773,'premployee','extracitbasedon',11,'Integer','','','',''),(2774,'premployee','workmanscomprate',12,'Numeric','','','',''),(2775,'premployee','pensplanid1',22,'Numeric','','','',''),(2776,'premployee','pensplandedamount1',12,'Numeric','','','',''),(2777,'premployee','pensplanbase1',11,'Integer','','','',''),(2778,'premployee','pensplanid2',22,'Numeric','','','',''),(2779,'premployee','pensplandedamount2',12,'Numeric','','','',''),(2780,'premployee','pensplanbase2',11,'Integer','','','',''),(2781,'premployee','vacationhoursaccrued',12,'Numeric','','','',''),(2782,'premployee','sickleavehoursaccrued',12,'Numeric','','','',''),(2783,'premployee','prdedgroupid',65535,'X','','','',''),(2784,'premployee','status',11,'Integer','','','',''),(2785,'premployee','gencompanyid',22,'Numeric','','','',''),(2786,'premployee','cancel',11,'Integer','','','',''),(2787,'premployee','canceldate',19,'DateTime','','','',''),(2788,'premployee','canceluserid',22,'Numeric','','','',''),(2789,'premployee','entrydate',19,'DateTime','','','',''),(2790,'premployee','entryuserid',22,'Numeric','','','',''),(2791,'premployee','lastchangedate',19,'DateTime','','','',''),(2792,'premployee','lastchangeuserid',22,'Numeric','','','',''),(2793,'premployee','image',64,'Text','','','',''),(2794,'premployee','workclassid',11,'Integer','','','',''),(2795,'premployee','direct_deposit',2,'Integer','','','',''),(2796,'premployee','bankaccountid',11,'Integer','','','multiple',''),(2797,'premplreview','id',22,'Numeric','','','primary unique',''),(2798,'premplreview','employeeid',22,'Numeric','','','',''),(2799,'premplreview','evaluatorname',50,'Text','','','',''),(2800,'premplreview','evaldate',10,'Date','','','',''),(2801,'premplreview','premplreviewratingid',22,'Numeric','','','',''),(2802,'premplreview','comments',65535,'X','','','',''),(2803,'premplreview','cancel',11,'Integer','','','',''),(2804,'premplreview','canceldate',19,'DateTime','','','',''),(2805,'premplreview','canceluserid',22,'Numeric','','','',''),(2806,'premplreview','entrydate',19,'DateTime','','','',''),(2807,'premplreview','entryuserid',22,'Numeric','','','',''),(2808,'premplreview','lastchangedate',19,'DateTime','','','',''),(2809,'premplreview','lastchangeuserid',22,'Numeric','','','',''),(2810,'premplreviewrating','id',22,'Numeric','','','primary unique',''),(2811,'premplreviewrating','description',50,'Text','','','',''),(2812,'premplweek','id',22,'Numeric','','','primary unique',''),(2813,'premplweek','employeeid',22,'Numeric','','','',''),(2814,'premplweek','periodbegindate',10,'Date','','','',''),(2815,'premplweek','periodenddate',10,'Date','','','',''),(2816,'premplweek','prperiodid',22,'Numeric','','','',''),(2817,'premplweek','tipspay',21,'Numeric','','','',''),(2818,'premplweek','tipsaswages',21,'Numeric','','','',''),(2819,'premplweek','misctaxablepay',21,'Numeric','','','',''),(2820,'premplweek','misctaxablecomment',30,'Text','','','',''),(2821,'premplweek','miscnontaxablepay',21,'Numeric','','','',''),(2822,'premplweek','miscnontaxablecomment',30,'Text','','','',''),(2823,'premplweek','vacaccrue',7,'Numeric','','','',''),(2824,'premplweek','sickaccrue',7,'Numeric','','','',''),(2825,'premplweek','federaltax',21,'Numeric','','','',''),(2826,'premplweek','ficatax',21,'Numeric','','','',''),(2827,'premplweek','statetax',21,'Numeric','','','',''),(2828,'premplweek','localtax',21,'Numeric','','','',''),(2829,'premplweek','citytax',21,'Numeric','','','',''),(2830,'premplweek','prstateid',22,'Numeric','','','',''),(2831,'premplweek','prcityid',22,'Numeric','','','',''),(2832,'premplweek','prlocalid',22,'Numeric','','','',''),(2833,'premplweek','eiccredit',21,'Numeric','','','',''),(2834,'premplweek','miscdeduction',21,'Numeric','','','',''),(2835,'premplweek','miscdeductioncomment',30,'Text','','','',''),(2836,'premplweek','medicarededuction',21,'Numeric','','','',''),(2837,'premplweek','calculatestatus',11,'Integer','','','',''),(2838,'premplweek','fuitax',21,'Numeric','','','',''),(2839,'premplweek','cficatax',21,'Numeric','','','',''),(2840,'premplweek','cmedicarededuction',21,'Numeric','','','',''),(2841,'premplweek','suitax',21,'Numeric','','','',''),(2842,'premplweek','netpay',21,'Numeric','','','',''),(2843,'premplweek','checkid',22,'Numeric','','','multiple',''),(2844,'premplweek','cancel',11,'Integer','','','multiple',''),(2845,'premplweek','canceldate',19,'DateTime','','','',''),(2846,'premplweek','canceluserid',22,'Numeric','','','',''),(2847,'premplweek','entrydate',19,'DateTime','','','',''),(2848,'premplweek','entryuserid',22,'Numeric','','','',''),(2849,'premplweek','lastchangedate',19,'DateTime','','','',''),(2850,'premplweek','lastchangeuserid',22,'Numeric','','','',''),(2851,'premplweek','depositcheckid',22,'Numeric','','','',''),(2852,'premplweekdeddetail','id',22,'Numeric','','','primary unique',''),(2853,'premplweekdeddetail','premplweekid',22,'Numeric','','','',''),(2854,'premplweekdeddetail','prempldeductionid',22,'Numeric','','','',''),(2855,'premplweekdeddetail','prbendedid',22,'Numeric','','','',''),(2856,'premplweekdeddetail','prpensionid',22,'Numeric','','','',''),(2857,'premplweekdeddetail','amount',21,'Numeric','','','',''),(2858,'premplweekdeddetail','dedtype',11,'Integer','','','',''),(2859,'premplweekpaydetail','id',22,'Numeric','','','primary unique',''),(2860,'premplweekpaydetail','premplweekid',22,'Numeric','','','',''),(2861,'premplweekpaydetail','prpaytypeid',11,'Integer','','','',''),(2862,'premplweekpaydetail','prbendedid',22,'Numeric','','','',''),(2863,'premplweekpaydetail','qty',10,'Numeric','','','',''),(2864,'premplweekpaydetail','rate',10,'Numeric','','','',''),(2865,'premplweekpaydetail','amount',21,'Numeric','','','',''),(2866,'premplweekpaydetail','glaccountid',22,'Numeric','','','',''),(2867,'prfederal','id',22,'Numeric','','','primary unique',''),(2868,'prfederal','maxwagesfica',21,'Numeric','','','',''),(2869,'prfederal','employeeficapercent',10,'Numeric','','','',''),(2870,'prfederal','companyficapercent',10,'Numeric','','','',''),(2871,'prfederal','maxwagesmedicare',21,'Numeric','','','',''),(2872,'prfederal','employeemedicarepercent',10,'Numeric','','','',''),(2873,'prfederal','companymedicarepercent',10,'Numeric','','','',''),(2874,'prfederal','maxwagesfui',21,'Numeric','','','',''),(2875,'prfederal','companyfuipercent',10,'Numeric','','','',''),(2876,'prfederal','eicsinglepercent1',10,'Numeric','','','',''),(2877,'prfederal','eicsingleover1',21,'Numeric','','','',''),(2878,'prfederal','eicsingletax2',21,'Numeric','','','',''),(2879,'prfederal','eicsingleover2',21,'Numeric','','','',''),(2880,'prfederal','eicsingletax3',21,'Numeric','','','',''),(2881,'prfederal','eicsinglepercent3',10,'Numeric','','','',''),(2882,'prfederal','eicsingleover3',21,'Numeric','','','',''),(2883,'prfederal','eicmarriedpercent1',10,'Numeric','','','',''),(2884,'prfederal','eicmarriedover1',21,'Numeric','','','',''),(2885,'prfederal','eicmarriedtax2',21,'Numeric','','','',''),(2886,'prfederal','eicmarriedover2',21,'Numeric','','','',''),(2887,'prfederal','eicmarriedtax3',21,'Numeric','','','',''),(2888,'prfederal','eicmarriedpercent3',10,'Numeric','','','',''),(2889,'prfederal','eicmarriedover3',21,'Numeric','','','',''),(2890,'prfederal','exemptionallow',21,'Numeric','','','',''),(2891,'prfederal','gencompanyid',22,'Numeric','','','multiple',''),(2892,'prfederal','cancel',11,'Integer','','','',''),(2893,'prfederal','canceldate',19,'DateTime','','','',''),(2894,'prfederal','canceluserid',22,'Numeric','','','',''),(2895,'prfederal','entrydate',19,'DateTime','','','',''),(2896,'prfederal','entryuserid',22,'Numeric','','','',''),(2897,'prfederal','lastchangedate',19,'DateTime','','','',''),(2898,'prfederal','lastchangeuserid',22,'Numeric','','','',''),(2899,'prfederaldetail','id',22,'Numeric','','','primary unique',''),(2900,'prfederaldetail','prfederalid',22,'Numeric','','','',''),(2901,'prfederaldetail','maritalstatus',11,'Integer','','','',''),(2902,'prfederaldetail','deductiontable',11,'Integer','','','',''),(2903,'prfederaldetail','tax',21,'Numeric','','','',''),(2904,'prfederaldetail','percent',10,'Numeric','','','',''),(2905,'prfederaldetail','over',21,'Numeric','','','',''),(2906,'pricediscount','id',22,'Numeric','','','primary unique',''),(2907,'pricediscount','itemid',22,'Numeric','','','multiple',''),(2908,'pricediscount','itemlocationid',22,'Numeric','','','multiple',''),(2909,'pricediscount','quantity',14,'Numeric','','','',''),(2910,'pricediscount','discount',8,'Numeric','','','',''),(2911,'pricediscount','cancel',11,'Integer','','','',''),(2912,'pricediscount','canceldate',19,'DateTime','','','',''),(2913,'pricediscount','canceluserid',22,'Numeric','','','',''),(2914,'pricediscount','entrydate',19,'DateTime','','','',''),(2915,'pricediscount','entryuserid',22,'Numeric','','','',''),(2916,'pricediscount','lastchangedate',19,'DateTime','','','',''),(2917,'pricediscount','lastchangeuserid',22,'Numeric','','','',''),(2918,'pricelevel','id',22,'Numeric','','','primary unique',''),(2919,'pricelevel','description',30,'Text','','','',''),(2920,'pricelevel','companyid',22,'Numeric','','','multiple',''),(2921,'pricelevel','cancel',11,'Integer','','','',''),(2922,'pricelevel','canceldate',19,'DateTime','','','',''),(2923,'pricelevel','canceluserid',22,'Numeric','','','',''),(2924,'pricelevel','entrydate',19,'DateTime','','','',''),(2925,'pricelevel','entryuserid',22,'Numeric','','','',''),(2926,'pricelevel','lastchangedate',19,'DateTime','','','',''),(2927,'pricelevel','lastchangeuserid',22,'Numeric','','','',''),(2928,'priceperpriceunit','id',22,'Numeric','','','primary unique',''),(2929,'priceperpriceunit','itemid',22,'Numeric','','','multiple',''),(2930,'priceperpriceunit','itemlocationid',22,'Numeric','','','multiple',''),(2931,'priceperpriceunit','pricelevelid',22,'Numeric','','','multiple',''),(2932,'priceperpriceunit','price',21,'Numeric','','','',''),(2933,'priceperpriceunit','cancel',11,'Integer','','','',''),(2934,'priceperpriceunit','canceldate',19,'DateTime','','','',''),(2935,'priceperpriceunit','canceluserid',22,'Numeric','','','',''),(2936,'priceperpriceunit','entrydate',19,'DateTime','','','',''),(2937,'priceperpriceunit','entryuserid',22,'Numeric','','','',''),(2938,'priceperpriceunit','lastchangedate',19,'DateTime','','','',''),(2939,'priceperpriceunit','lastchangeuserid',22,'Numeric','','','',''),(2940,'print_categories','id',11,'Integer','','','primary',''),(2941,'print_categories','description',50,'Text','','','',''),(2942,'print_categories','glacctid',11,'Integer','','','',''),(2943,'print_categories','entrydate',19,'DateTime','','','',''),(2944,'print_categories','entryuserid',11,'Integer','','','',''),(2945,'print_categories','cancel',2,'Integer','','','',''),(2946,'print_categories','canceldate',19,'DateTime','','','',''),(2947,'print_categories','canceluserid',11,'Integer','','','',''),(2948,'print_categories','lastupdatedate',19,'DateTime','','','',''),(2949,'print_categories','gencompanyid',11,'Integer','','','',''),(2950,'printorder','id_printorder',11,'Integer','','','primary unique',''),(2951,'printorder','id_customer',11,'Integer','','','multiple',''),(2952,'printorder','id_printorder_main',11,'Integer','','','',''),(2953,'printorder','linenum',3,'Integer','','','',''),(2954,'printorder','id_worksubtype',11,'Integer','','','',''),(2955,'printorder','description',250,'Text','','','',''),(2956,'printorder','destination_partnr',30,'Text','','','multiple',''),(2957,'printorder','order_quantity',14,'Integer','','','',''),(2958,'printorder','order_type',2,'Integer','','','',''),(2959,'printorder','vendall',1,'Integer','','','',''),(2960,'printorder','order_class',2,'Integer','','','',''),(2961,'printorder','status',2,'Integer','','','',''),(2962,'printorder','approvedate',19,'DateTime','','','',''),(2963,'printorder','duedate',19,'DateTime','','','',''),(2964,'printorder','finalshipdate',19,'DateTime','','','',''),(2965,'printorder','pricedate',10,'Date','','','',''),(2966,'printorder','createdate',19,'DateTime','','','',''),(2967,'printorder','id_user_create',11,'Integer','','','',''),(2968,'printorder','lastrevisedate',19,'DateTime','','','',''),(2969,'printorder','id_user_revise',11,'Integer','','','',''),(2970,'printorder','canceldate',19,'DateTime','','','',''),(2971,'printorder','cancel',11,'Integer','','','',''),(2972,'printorder','numperunit',5,'Integer','','','',''),(2973,'printorder','totalpages',5,'Integer','','','',''),(2974,'printorder','unitname',10,'Text','','','',''),(2975,'printorder','instructions',65535,'X','','','',''),(2976,'printorder','priority',2,'Integer','','','',''),(2977,'printorder','estimated_price',17,'Numeric','','','',''),(2978,'printorder','estimated_cost',17,'Numeric','','','',''),(2979,'printorder','actual_price',17,'Numeric','','','',''),(2980,'printorder','final_width',12,'Numeric','','','',''),(2981,'printorder','final_length',12,'Numeric','','','',''),(2982,'printorder','who_ok_price',10,'Text','','','',''),(2983,'printorder','id_latereason',11,'Integer','','','',''),(2984,'printorder','enter_initials',3,'Text','','','',''),(2985,'printorder','del_initials',3,'Text','','','',''),(2986,'printorder','bill_sent',2,'Integer','','','',''),(2987,'printorder','bill_month',2,'Text','','','',''),(2988,'printorder','bill_year',4,'Text','','','',''),(2989,'printorder','shiptotal',16,'Numeric','','','',''),(2990,'printorder','vend_est_total',16,'Numeric','','','',''),(2991,'printorder','qc_initials',5,'Text','','','',''),(2992,'printorder','fulldetails',250,'Text','','','',''),(2993,'printorder','pickup',2,'Integer','','','',''),(2994,'printorder','internalorder',2,'Integer','','','',''),(2995,'printorder','mailroom',5,'Text','','','',''),(2996,'printorder','cliententry',11,'Integer','','','',''),(2997,'printorder','id_originals',11,'Integer','','','',''),(2998,'printorder','proof',2,'Integer','','','',''),(2999,'printorder','quote',2,'Integer','','','',''),(3000,'printorder','id_gencompany',11,'Integer','','','',''),(3001,'printorder','customer_po',50,'Text','','','',''),(3002,'printorder','multiquotestatus',11,'Integer','','','',''),(3003,'printorder','notes',255,'Text','','','',''),(3004,'printorder','orientation',20,'Text','','','',''),(3005,'printorder','quotedesc',65535,'X','','','',''),(3006,'printorder_misc','id_printorder',11,'Integer','','','',''),(3007,'printorder_misc','shipqty1',11,'Integer','','','',''),(3008,'printorder_misc','shipdate1',19,'DateTime','','','',''),(3009,'printorder_misc','shipqty2',11,'Integer','','','',''),(3010,'printorder_misc','shipdate2',19,'DateTime','','','',''),(3011,'printorder_misc','shipqty3',11,'Integer','','','',''),(3012,'printorder_misc','shipdate3',19,'DateTime','','','',''),(3013,'printorder_misc','shipqty4',11,'Integer','','','',''),(3014,'printorder_misc','shipdate4',19,'DateTime','','','',''),(3015,'printorder_misc','shipqty5',11,'Integer','','','',''),(3016,'printorder_misc','shipdate5',19,'DateTime','','','',''),(3017,'printorder_misc','orientation',50,'Text','','','',''),(3018,'printorder_misc','quote_desc',65535,'X','','','',''),(3019,'printorder_shipsched','id',11,'Integer','','','primary unique',''),(3020,'printorder_shipsched','id_printorder',11,'Integer','','','multiple',''),(3021,'printorder_shipsched','id_printorder_shipto',11,'Integer','','','multiple',''),(3022,'printorder_shipsched','qty',11,'Integer','','','',''),(3023,'printorder_shipsched','shipdate',10,'Date','','','multiple',''),(3024,'printorder_shipsched','cancel',2,'Integer','','','multiple',''),(3025,'printorder_shipsched','canceldate',19,'DateTime','','','',''),(3026,'printorder_shipsched','canceluserid',11,'Integer','','','',''),(3027,'printorder_shipto','id_printorder_shipto',11,'Integer','','','primary',''),(3028,'printorder_shipto','id_printorder',11,'Integer','','','multiple',''),(3029,'printorder_shipto','attn',50,'Text','','','',''),(3030,'printorder_shipto','quantity',11,'Integer','','','',''),(3031,'printorder_shipto','id_delivery',11,'Integer','','','',''),(3032,'printorder_shipto','id_shipto',11,'Integer','','','',''),(3033,'printorder_shipto','cancel',2,'Integer','','','',''),(3034,'printorder_workarea','id',11,'Integer','','','primary',''),(3035,'printorder_workarea','id_printorder',11,'Integer','','','multiple',''),(3036,'printorder_workarea','id_workarea',11,'Integer','','','multiple',''),(3037,'printorder_workarea','completedate',19,'DateTime','','','',''),(3038,'printorder_workarea','initials',5,'Text','','','',''),(3039,'prlocal','id',22,'Numeric','','','primary unique',''),(3040,'prlocal','gencompanyid',22,'Numeric','','','',''),(3041,'prlocal','abrev',3,'Text','','','',''),(3042,'prlocal','name',30,'Text','','','',''),(3043,'prlocal','taxnum',20,'Text','','','',''),(3044,'prlocal','deductfed',11,'Integer','','','',''),(3045,'prlocal','feddeductmax',21,'Numeric','','','',''),(3046,'prlocal','exemptyr1',21,'Numeric','','','',''),(3047,'prlocal','exemptyr2',21,'Numeric','','','',''),(3048,'prlocal','exemptyr3',21,'Numeric','','','',''),(3049,'prlocal','exemptyr4',21,'Numeric','','','',''),(3050,'prlocal','glacctid',22,'Numeric','','','',''),(3051,'prlocal','vendorid',22,'Numeric','','','',''),(3052,'prlocal','maxexemptpercent',7,'Numeric','','','',''),(3053,'prlocal','maxexemptyear',21,'Numeric','','','',''),(3054,'prlocal','taxcreditexempt1',21,'Numeric','','','',''),(3055,'prlocal','taxcreditexempt2',21,'Numeric','','','',''),(3056,'prlocal','taxcreditexempt3',21,'Numeric','','','',''),(3057,'prlocal','taxcreditexempt4',21,'Numeric','','','',''),(3058,'prlocal','cancel',11,'Integer','','','',''),(3059,'prlocal','canceldate',19,'DateTime','','','',''),(3060,'prlocal','canceluserid',22,'Numeric','','','',''),(3061,'prlocal','entrydate',19,'DateTime','','','',''),(3062,'prlocal','entryuserid',22,'Numeric','','','',''),(3063,'prlocal','lastchangedate',19,'DateTime','','','',''),(3064,'prlocal','lastchangeuserid',22,'Numeric','','','',''),(3065,'prlocaldetail','id',22,'Numeric','','','primary unique',''),(3066,'prlocaldetail','prlocalid',22,'Numeric','','','',''),(3067,'prlocaldetail','maritalstatus',11,'Integer','','','',''),(3068,'prlocaldetail','deductiontable',11,'Integer','','','',''),(3069,'prlocaldetail','tax',21,'Numeric','','','',''),(3070,'prlocaldetail','percent',10,'Numeric','','','',''),(3071,'prlocaldetail','over',21,'Numeric','','','',''),(3072,'products_attributes','products_attributes_id',5,'Integer','','','primary',''),(3073,'products_attributes','products_id',5,'Integer','','','',''),(3074,'products_attributes','options_id',5,'Integer','','','',''),(3075,'products_attributes','options_values_id',5,'Integer','','','',''),(3076,'products_attributes','options_values_price',10,'Numeric','','','',''),(3077,'products_attributes','price_prefix',1,'Text','','','',''),(3078,'products_expected','products_expected_id',5,'Integer','','','primary',''),(3079,'products_expected','products_name',255,'Text','','','',''),(3080,'products_expected','date_expected',8,'Text','','','',''),(3081,'products_options','products_options_id',5,'Integer','','','primary',''),(3082,'products_options','products_options_name',32,'Text','','','',''),(3083,'products_options_values','products_options_values_id',5,'Integer','','','primary',''),(3084,'products_options_values','products_options_values_name',64,'Text','','','',''),(3085,'products_options_values_to_products_options','products_options_values_to_products_options_id',5,'Integer','','','primary',''),(3086,'products_options_values_to_products_options','products_options_id',5,'Integer','','','',''),(3087,'products_options_values_to_products_options','products_options_values_id',5,'Integer','','','',''),(3088,'prpaychange','id',22,'Numeric','','','primary unique',''),(3089,'prpaychange','employeeid',22,'Numeric','','','',''),(3090,'prpaychange','oldpay',21,'Numeric','','','',''),(3091,'prpaychange','newpay',21,'Numeric','','','',''),(3092,'prpaychange','paystartdate',10,'Date','','','',''),(3093,'prpaychange','lastchangedate',19,'DateTime','','','',''),(3094,'prpaychange','lastchangeuserid',22,'Numeric','','','',''),(3095,'prpaytype','id',22,'Numeric','','','primary unique',''),(3096,'prpaytype','name',4,'Text','','','',''),(3097,'prpaytype','description',40,'Text','','','',''),(3098,'prpaytype','multiplier',7,'Numeric','','','',''),(3099,'prpaytype','vacation',11,'Integer','','','',''),(3100,'prpaytype','sick',11,'Integer','','','',''),(3101,'prpaytype','gencompanyid',22,'Numeric','','','',''),(3102,'prpension','id',22,'Numeric','','','primary unique',''),(3103,'prpension','gencompanyid',22,'Numeric','','','',''),(3104,'prpension','name',30,'Text','','','multiple',''),(3105,'prpension','w2plantype',11,'Integer','','','',''),(3106,'prpension','w2plansubtype',1,'Text','','','',''),(3107,'prpension','employercontribhow',11,'Integer','','','',''),(3108,'prpension','employercontribute',10,'Numeric','','','',''),(3109,'prpension','employermaxmatchpercent',10,'Numeric','','','',''),(3110,'prpension','mustbeinplan',11,'Integer','','','',''),(3111,'prpension','calcbasis',11,'Integer','','','',''),(3112,'prpension','prdedgroupid',22,'Numeric','','','',''),(3113,'prpension','paytype',11,'Integer','','','',''),(3114,'prpension','payableglacctid',22,'Numeric','','','',''),(3115,'prpension','expenseglacctid',22,'Numeric','','','',''),(3116,'prpension','federalincometax',11,'Integer','','','',''),(3117,'prpension','stateincometax',11,'Integer','','','',''),(3118,'prpension','localincometax',11,'Integer','','','',''),(3119,'prpension','cityincometax',11,'Integer','','','',''),(3120,'prpension','employeefica',11,'Integer','','','',''),(3121,'prpension','companyfica',11,'Integer','','','',''),(3122,'prpension','fui',11,'Integer','','','',''),(3123,'prpension','sui',11,'Integer','','','',''),(3124,'prpension','workmanscomp',11,'Integer','','','',''),(3125,'prpension','vendorid',22,'Numeric','','','',''),(3126,'prpension','cancel',11,'Integer','','','',''),(3127,'prpension','canceldate',19,'DateTime','','','',''),(3128,'prpension','canceluserid',22,'Numeric','','','',''),(3129,'prpension','entrydate',19,'DateTime','','','',''),(3130,'prpension','entryuserid',22,'Numeric','','','',''),(3131,'prpension','lastchangedate',19,'DateTime','','','',''),(3132,'prpension','lastchangeuserid',22,'Numeric','','','',''),(3133,'prpension','employeronly_percent',14,'Numeric','','','',''),(3134,'prpension','employermaxmatchpercent_uptopercent',14,'Numeric','','','',''),(3135,'prpension','employermaxmatchpercent2',14,'Numeric','','','',''),(3136,'prpension','employermaxmatchpercent2_uptopercent',14,'Numeric','','','',''),(3137,'prperiod','id',22,'Numeric','','','primary unique',''),(3138,'prperiod','numperyear',11,'Integer','','','',''),(3139,'prperiod','name',15,'Text','','','',''),(3140,'prstate','id',22,'Numeric','','','primary unique',''),(3141,'prstate','gencompanyid',22,'Numeric','','','',''),(3142,'prstate','genstateid',22,'Numeric','','','multiple',''),(3143,'prstate','taxnum',20,'Text','','','',''),(3144,'prstate','suipercent',10,'Numeric','','','',''),(3145,'prstate','suimax',12,'Numeric','','','',''),(3146,'prstate','deductfed',11,'Integer','','','',''),(3147,'prstate','feddeductmax',12,'Numeric','','','',''),(3148,'prstate','exemptyr1',21,'Numeric','','','',''),(3149,'prstate','exemptyr2',21,'Numeric','','','',''),(3150,'prstate','exemptyr3',21,'Numeric','','','',''),(3151,'prstate','exemptyr4',21,'Numeric','','','',''),(3152,'prstate','glacctid',22,'Numeric','','','',''),(3153,'prstate','vendorid',22,'Numeric','','','',''),(3154,'prstate','maxexemptpercent',10,'Numeric','','','',''),(3155,'prstate','maxexemptyear',12,'Numeric','','','',''),(3156,'prstate','taxcreditexempt1',12,'Numeric','','','',''),(3157,'prstate','taxcreditexempt2',12,'Numeric','','','',''),(3158,'prstate','taxcreditexempt3',12,'Numeric','','','',''),(3159,'prstate','taxcreditexempt4',12,'Numeric','','','',''),(3160,'prstate','cancel',11,'Integer','','','',''),(3161,'prstate','canceldate',19,'DateTime','','','',''),(3162,'prstate','canceluserid',22,'Numeric','','','',''),(3163,'prstate','entrydate',19,'DateTime','','','',''),(3164,'prstate','entryuserid',22,'Numeric','','','',''),(3165,'prstate','lastchangedate',19,'DateTime','','','',''),(3166,'prstate','lastchangeuserid',22,'Numeric','','','',''),(3167,'prstate','mexemptyr1',21,'Numeric','','','',''),(3168,'prstate','mexemptyr2',21,'Numeric','','','',''),(3169,'prstate','mexemptyr3',21,'Numeric','','','',''),(3170,'prstate','mexemptyr4',21,'Numeric','','','',''),(3171,'prstate','jexemptyr1',21,'Numeric','','','',''),(3172,'prstate','jexemptyr2',21,'Numeric','','','',''),(3173,'prstate','jexemptyr3',21,'Numeric','','','',''),(3174,'prstate','jexemptyr4',21,'Numeric','','','',''),(3175,'prstate','hexemptyr1',21,'Numeric','','','',''),(3176,'prstate','hexemptyr2',21,'Numeric','','','',''),(3177,'prstate','hexemptyr3',21,'Numeric','','','',''),(3178,'prstate','hexemptyr4',21,'Numeric','','','',''),(3179,'prstatedetail','id',22,'Numeric','','','primary unique',''),(3180,'prstatedetail','prstateid',22,'Numeric','','','',''),(3181,'prstatedetail','maritalstatus',11,'Integer','','','',''),(3182,'prstatedetail','deductiontable',11,'Integer','','','',''),(3183,'prstatedetail','tax',12,'Numeric','','','',''),(3184,'prstatedetail','percent',10,'Numeric','','','',''),(3185,'prstatedetail','over',12,'Numeric','','','',''),(3186,'prt_orientation','id',11,'Integer','','','primary unique',''),(3187,'prt_orientation','description',20,'Text','','','',''),(3188,'prtlocation','id',22,'Numeric','','','primary unique',''),(3189,'prtlocation','companyname',35,'Text','','','',''),(3190,'prtlocation','address1',100,'Text','','','',''),(3191,'prtlocation','address2',100,'Text','','','',''),(3192,'prtlocation','mailstop',20,'Text','','','',''),(3193,'prtlocation','city',50,'Text','','','',''),(3194,'prtlocation','state',20,'Text','','','',''),(3195,'prtlocation','zip',15,'Text','','','',''),(3196,'prtlocation','country',20,'Text','','','',''),(3197,'prtlocation','phone1',20,'Text','','','',''),(3198,'prtlocation','phone1comment',20,'Text','','','',''),(3199,'prtlocation','phone2',20,'Text','','','',''),(3200,'prtlocation','phone2comment',20,'Text','','','',''),(3201,'prtlocation','phone3',20,'Text','','','',''),(3202,'prtlocation','phone3comment',20,'Text','','','',''),(3203,'prtlocation','phone4',20,'Text','','','',''),(3204,'prtlocation','phone4comment',20,'Text','','','',''),(3205,'prtlocation','email1',50,'Text','','','',''),(3206,'prtlocation','email1comment',20,'Text','','','',''),(3207,'prtlocation','email2',50,'Text','','','',''),(3208,'prtlocation','email2comment',50,'Text','','','',''),(3209,'prtlocation','website',100,'Text','','','',''),(3210,'prtlocation','federalid',20,'Text','','','',''),(3211,'prtlocation','cancel',2,'Integer','','','',''),(3212,'prtlocation','canceldate',19,'DateTime','','','',''),(3213,'prtlocation','canceluserid',11,'Integer','','','',''),(3214,'prtlocation','entrydate',19,'DateTime','','','',''),(3215,'prtlocation','entryuserid',11,'Integer','','','',''),(3216,'prtlocation','lastchangedate',19,'DateTime','','','',''),(3217,'prtlocation','lastchangeuserid',11,'Integer','','','',''),(3218,'prtlocation','gencompanyid',11,'Integer','','','multiple',''),(3219,'prvacation','id',22,'Numeric','','','primary unique',''),(3220,'prvacation','yrsbeforeaccrue',7,'Numeric','','','',''),(3221,'prvacation','vacdaysperyear',7,'Numeric','','','',''),(3222,'prvacation','maxaccrue',7,'Numeric','','','',''),(3223,'prvacation','gencompanyid',22,'Numeric','','','',''),(3224,'prvacation','cancel',11,'Integer','','','',''),(3225,'prvacation','canceldate',19,'DateTime','','','',''),(3226,'prvacation','canceluserid',22,'Numeric','','','',''),(3227,'prvacation','entrydate',19,'DateTime','','','',''),(3228,'prvacation','entryuserid',22,'Numeric','','','',''),(3229,'prvacation','lastchangedate',19,'DateTime','','','',''),(3230,'prvacation','lastchangeuserid',22,'Numeric','','','',''),(3231,'purchasetype','id_purchasetype',11,'Integer','','','primary unique',''),(3232,'purchasetype','id_company',11,'Integer','','','',''),(3233,'purchasetype','name',20,'Text','','','',''),(3234,'purchasetype','createdate',10,'Date','','','',''),(3235,'purchasetype','id_user_create',11,'Integer','','','',''),(3236,'purchasetype','lastrevisedate',19,'DateTime','','','',''),(3237,'purchasetype','id_user_revise',11,'Integer','','','',''),(3238,'purchasetype','canceldate',10,'Date','','','',''),(3239,'purchasetype','cancel',11,'Integer','','','',''),(3240,'purchasetype','include_in_internal_billing',2,'Integer','','','',''),(3241,'question','id_question',11,'Integer','','','primary unique',''),(3242,'question','id_family',11,'Integer','','','',''),(3243,'question','id_responsetype',11,'Integer','','','',''),(3244,'question','question',100,'Text','','','',''),(3245,'question','unit_of_measure',10,'Text','','','',''),(3246,'question','displayorder',3,'Integer','','','',''),(3247,'question','internalonly',1,'Integer','','','',''),(3248,'question','createdate',19,'DateTime','','','',''),(3249,'question','id_user_create',11,'Integer','','','',''),(3250,'question','lastrevisedate',19,'DateTime','','','',''),(3251,'question','id_user_revise',11,'Integer','','','',''),(3252,'question','canceldate',19,'DateTime','','','',''),(3253,'question','cancel',11,'Integer','','','',''),(3254,'question_calc','id_question_calc',11,'Integer','','','primary unique',''),(3255,'question_calc','id_question',11,'Integer','','','',''),(3256,'question_calc','id_question_detail',11,'Integer','','','',''),(3257,'question_calc','id_calcqty',11,'Integer','','','',''),(3258,'question_calc','oneperjob',2,'Integer','','','',''),(3259,'question_calc','id_item',11,'Integer','','','',''),(3260,'question_calc','materialcost',12,'Numeric','','','',''),(3261,'question_calc','createdate',19,'DateTime','','','',''),(3262,'question_calc','id_user_create',11,'Integer','','','',''),(3263,'question_calc','lastrevisedate',19,'DateTime','','','',''),(3264,'question_calc','id_user_revise',11,'Integer','','','',''),(3265,'question_calc','canceldate',19,'DateTime','','','',''),(3266,'question_calc','materialmarkup',12,'Numeric','','','',''),(3267,'question_calc','cancel',11,'Integer','','','',''),(3268,'question_detail','id_question_detail',11,'Integer','','','primary unique',''),(3269,'question_detail','id_question',11,'Integer','','','',''),(3270,'question_detail','id_family',11,'Integer','','','',''),(3271,'question_detail','selection',100,'Text','','','',''),(3272,'question_detail','displayorder',3,'Integer','','','',''),(3273,'question_detail','createdate',19,'DateTime','','','',''),(3274,'question_detail','id_user_create',11,'Integer','','','',''),(3275,'question_detail','lastrevisedate',19,'DateTime','','','',''),(3276,'question_detail','id_user_revise',11,'Integer','','','',''),(3277,'question_detail','canceldate',19,'DateTime','','','',''),(3278,'question_detail','cancel',11,'Integer','','','',''),(3279,'quotecomment','id',22,'Numeric','','','primary',''),(3280,'quotecomment','comments',100,'Text','','','',''),(3281,'quotecomment','cancel',11,'Integer','','','',''),(3282,'quotecomment','canceldate',19,'DateTime','','','',''),(3283,'quotecomment','canceluserid',22,'Numeric','','','',''),(3284,'quotecomment','entrydate',19,'DateTime','','','',''),(3285,'quotecomment','entryuserid',22,'Numeric','','','',''),(3286,'quotecomment','lastchangedate',19,'DateTime','','','',''),(3287,'quotecomment','lastchangeuserid',22,'Numeric','','','',''),(3288,'quoteemail','id',11,'Integer','','','primary',''),(3289,'quoteemail','lead_time',11,'Integer','','','',''),(3290,'quoteemail','offer',65535,'X','','','',''),(3291,'quoteemail','point1',65535,'X','','','',''),(3292,'quoteemail','point2',65535,'X','','','',''),(3293,'quoteemail','point3',65535,'X','','','',''),(3294,'quoteemail','point4',65535,'X','','','',''),(3295,'quoteemail','point5',65535,'X','','','',''),(3296,'quoteemail','point6',65535,'X','','','',''),(3297,'quoteemail','from_person',65535,'X','','','',''),(3298,'quoteemail','subject',65535,'X','','','',''),(3299,'quoteemail','message',100,'Text','','','',''),(3300,'responsetype','id_responsetype',11,'Integer','','','primary',''),(3301,'responsetype','name',50,'Text','','','',''),(3302,'responsetype','createdate',19,'DateTime','','','',''),(3303,'responsetype','id_user_create',11,'Integer','','','',''),(3304,'responsetype','lastrevisedate',19,'DateTime','','','',''),(3305,'responsetype','id_user_revise',11,'Integer','','','',''),(3306,'responsetype','canceldate',19,'DateTime','','','',''),(3307,'responsetype','cancel',11,'Integer','','','',''),(3308,'reviews','reviews_id',5,'Integer','','','primary',''),(3309,'reviews','reviews_text',65535,'X','','','',''),(3310,'reviews','reviews_rating',1,'Integer','','','',''),(3311,'reviews_extra','reviews_id',5,'Integer','','','',''),(3312,'reviews_extra','products_id',5,'Integer','','','',''),(3313,'reviews_extra','customers_id',5,'Integer','','','',''),(3314,'reviews_extra','date_added',8,'Text','','','',''),(3315,'reviews_extra','reviews_read',5,'Integer','','','',''),(3316,'reviews_extra','reviews_active',2,'Integer','','','',''),(3317,'rma_purchasing','id',11,'Integer','','','primary',''),(3318,'rma_purchasing','rma',30,'Text','','','',''),(3319,'rma_purchasing','ponumber',20,'Text','','','',''),(3320,'rma_purchasing','ordernumber',20,'Text','','','',''),(3321,'rma_purchasing','invoicenumber',20,'Text','','','',''),(3322,'rma_purchasing','invoicedate',19,'DateTime','','','',''),(3323,'rma_purchasing','vendorid',11,'Integer','','','',''),(3324,'rma_purchasing','itemcode',20,'Text','','','',''),(3325,'rma_purchasing','vendorpartnumber',30,'Text','','','',''),(3326,'rma_purchasing','serialnumber',100,'Text','','','',''),(3327,'rma_purchasing','quantity',12,'Numeric','','','',''),(3328,'rma_purchasing','problem',255,'Text','','','',''),(3329,'rma_purchasing','contactname',100,'Text','','','',''),(3330,'rma_purchasing','sentdate',19,'DateTime','','','',''),(3331,'rma_purchasing','expectedreturndate',19,'DateTime','','','',''),(3332,'rma_purchasing','trackingnumber',50,'Text','','','',''),(3333,'rma_purchasing','actionid',11,'Integer','','','',''),(3334,'rma_purchasing','restockingfee',12,'Numeric','','','',''),(3335,'rma_purchasing','completed',2,'Integer','','','',''),(3336,'rma_purchasing','completeddate',100,'Text','','','',''),(3337,'rma_purchasing','address1',100,'Text','','','',''),(3338,'rma_purchasing','address2',100,'Text','','','',''),(3339,'rma_purchasing','city',50,'Text','','','',''),(3340,'rma_purchasing','state',20,'Text','','','',''),(3341,'rma_purchasing','zip',15,'Text','','','',''),(3342,'rma_purchasing','country',20,'Text','','','',''),(3343,'rma_purchasing','shiptoaddress',255,'Text','','','',''),(3344,'rma_purchasing','entrydate',19,'DateTime','','','',''),(3345,'rma_purchasing','companyid',11,'Integer','','','',''),(3346,'rma_purchasing','notes',65535,'X','','','',''),(3347,'rma_purchasing_action','id',11,'Integer','','','primary',''),(3348,'rma_purchasing_action','action',100,'Text','','','',''),(3349,'sales_categories','id',11,'Integer','','','primary',''),(3350,'sales_categories','description',50,'Text','','','',''),(3351,'sales_categories','entrydate',19,'DateTime','','','',''),(3352,'sales_categories','entryuserid',11,'Integer','','','',''),(3353,'sales_categories','cancel',2,'Integer','','','',''),(3354,'sales_categories','canceldate',19,'DateTime','','','',''),(3355,'sales_categories','canceluserid',11,'Integer','','','',''),(3356,'sales_categories','lastupdatedate',19,'DateTime','','','',''),(3357,'sales_categories','gencompanyid',11,'Integer','','','',''),(3358,'salescategory','id',11,'Integer','','','primary',''),(3359,'salescategory','type',100,'Text','','','',''),(3360,'salescategory','description',100,'Text','','','',''),(3361,'salescategory','gencompanyid',22,'Numeric','','','',''),(3362,'salesman','id',22,'Numeric','','','primary unique',''),(3363,'salesman','payrollid',22,'Numeric','','','multiple',''),(3364,'salesman','commissionrate',8,'Numeric','','','',''),(3365,'salesman','commissionbase',11,'Integer','','','',''),(3366,'salesman','servicerep',11,'Integer','','','multiple',''),(3367,'salesman','salesman',11,'Integer','','','multiple',''),(3368,'salesman','gencompanyid',22,'Numeric','','','multiple',''),(3369,'salesman','cancel',11,'Integer','','','',''),(3370,'salesman','canceldate',19,'DateTime','','','',''),(3371,'salesman','canceluserid',22,'Numeric','','','',''),(3372,'salesman','entrydate',19,'DateTime','','','',''),(3373,'salesman','entryuserid',22,'Numeric','','','',''),(3374,'salesman','lastchangedate',19,'DateTime','','','',''),(3375,'salesman','lastchangeuserid',22,'Numeric','','','',''),(3376,'salesman','name',50,'Text','','','',''),(3377,'salesman','address1',100,'Text','','','',''),(3378,'salesman','address2',100,'Text','','','',''),(3379,'salesman','mailstop',20,'Text','','','',''),(3380,'salesman','city',50,'Text','','','',''),(3381,'salesman','state',20,'Text','','','',''),(3382,'salesman','zip',15,'Text','','','',''),(3383,'salesman','country',20,'Text','','','',''),(3384,'salesman','phone1',20,'Text','','','',''),(3385,'salesman','phone1comment',20,'Text','','','',''),(3386,'salesman','phone2',20,'Text','','','',''),(3387,'salesman','phone2comment',20,'Text','','','',''),(3388,'salesman','phone3',20,'Text','','','',''),(3389,'salesman','phone3comment',20,'Text','','','',''),(3390,'salesman','phone4',20,'Text','','','',''),(3391,'salesman','phone4comment',20,'Text','','','',''),(3392,'salesman','email1',50,'Text','','','',''),(3393,'salesman','email2',50,'Text','','','',''),(3394,'salesman','email1comment',20,'Text','','','',''),(3395,'salesman','email2comment',20,'Text','','','',''),(3396,'salesman','federalid',20,'Text','','','',''),(3397,'salesprocess','id',11,'Integer','','','primary',''),(3398,'salesprocess','salesman_id',11,'Integer','','','',''),(3399,'salesprocess','status',11,'Integer','','','',''),(3400,'salesprocess','customer_id',11,'Integer','','','',''),(3401,'salesprocess','contact',100,'Text','','','',''),(3402,'salesprocess','position',100,'Text','','','',''),(3403,'salesprocess','phone',10,'Integer','','','',''),(3404,'salesprocess','email',100,'Text','','','',''),(3405,'salesprocess','salescategory_id',11,'Integer','','','',''),(3406,'salesprocess','quality',11,'Integer','','','',''),(3407,'salesprocess','description',200,'Text','','','',''),(3408,'salesprocess','notes',200,'Text','','','',''),(3409,'salesprocess','estimated_sale',11,'Numeric','','','',''),(3410,'salesprocess','actual_sale',11,'Numeric','','','',''),(3411,'salestax','id',22,'Numeric','','','primary',''),(3412,'salestax','taxname',30,'Text','','','',''),(3413,'salestax','taxrate',9,'Numeric','','','',''),(3414,'salestax','taxbase',11,'Integer','','','',''),(3415,'salestax','glacctid',22,'Numeric','','','',''),(3416,'salestax','cancel',11,'Integer','','','',''),(3417,'salestax','canceldate',19,'DateTime','','','',''),(3418,'salestax','canceluserid',22,'Numeric','','','',''),(3419,'salestax','entrydate',19,'DateTime','','','',''),(3420,'salestax','entryuserid',22,'Numeric','','','',''),(3421,'salestax','lastchangedate',19,'DateTime','','','',''),(3422,'salestax','lastchangeuserid',22,'Numeric','','','',''),(3423,'salestax','taxstate',5,'Text','','','',''),(3424,'salestracker','id',11,'Integer','','','primary',''),(3425,'salestracker','sales_process_id',11,'Integer','','','',''),(3426,'salestracker','action_salesman_id',11,'Integer','','','',''),(3427,'salestracker','action_id',11,'Integer','','','',''),(3428,'salestracker','action_date',19,'DateTime','','','',''),(3429,'salestracker','notes',200,'Text','','','',''),(3430,'salestracker','next_action_salesman_id',11,'Integer','','','',''),(3431,'salestracker','next_action_id',11,'Integer','','','',''),(3432,'salestracker','next_action_date',19,'DateTime','','','',''),(3433,'search_cat','id',11,'Integer','','','primary',''),(3434,'search_cat','name',100,'Text','','','',''),(3435,'search_cat','level',11,'Integer','','','',''),(3436,'search_cat','cancel',11,'Integer','','','',''),(3437,'search_cat','categories_image',64,'Text','','','',''),(3438,'search_cat','companyid',11,'Integer','','','',''),(3439,'search_cat','parentid',11,'Integer','','','multiple',''),(3440,'search_tree','id',11,'Integer','','','primary',''),(3441,'search_tree','itemid',11,'Integer','','','',''),(3442,'search_tree','companyid',11,'Integer','','','',''),(3443,'search_tree','searchcatid',11,'Integer','','','',''),(3444,'serversetup','changedate',100,'Text','','','',''),(3445,'serversetup','definename',100,'Text','','','',''),(3446,'serversetup','id',11,'Integer','','','primary',''),(3447,'serversetup','definevalue',255,'Text','','','',''),(3448,'serversetup','description',100,'Text','','','',''),(3449,'service','id',11,'Integer','','','primary',''),(3450,'service','name',50,'Text','','','',''),(3451,'service','categoryid',11,'Integer','','','multiple',''),(3452,'service','cancel',2,'Integer','','','multiple',''),(3453,'service','canceldate',19,'DateTime','','','',''),(3454,'service','canceluserid',11,'Integer','','','',''),(3455,'service_workclass','id',11,'Integer','','','primary',''),(3456,'service_workclass','name',50,'Text','','','',''),(3457,'service_workclass','gencompanyid',11,'Integer','','','multiple',''),(3458,'service_workclass','entrydate',10,'Date','','','',''),(3459,'service_workclass','entryuserid',11,'Integer','','','',''),(3460,'service_workclass','cancel',2,'Integer','','','multiple',''),(3461,'service_workclass','canceldate',19,'DateTime','','','',''),(3462,'service_workclass','canceluserid',11,'Integer','','','',''),(3463,'service_workclass','lastchangedate',19,'DateTime','','','',''),(3464,'service_workclass','lastchangeuserid',11,'Integer','','','',''),(3465,'service_workclass_rates','id',11,'Integer','','','primary',''),(3466,'service_workclass_rates','service_worktypeid',11,'Integer','','','multiple',''),(3467,'service_workclass_rates','service_workclassid',11,'Integer','','','multiple',''),(3468,'service_workclass_rates','rate',12,'Numeric','','','',''),(3469,'service_workclass_rates','gencompanyid',11,'Integer','','','multiple',''),(3470,'service_workclass_rates','entrydate',10,'Date','','','',''),(3471,'service_workclass_rates','entryuserid',11,'Integer','','','',''),(3472,'service_workclass_rates','cancel',2,'Integer','','','multiple',''),(3473,'service_workclass_rates','canceldate',19,'DateTime','','','',''),(3474,'service_workclass_rates','canceluserid',11,'Integer','','','',''),(3475,'service_workclass_rates','lastchangedate',19,'DateTime','','','',''),(3476,'service_workclass_rates','lastchangeuserid',11,'Integer','','','',''),(3477,'service_worktype','id',11,'Integer','','','primary',''),(3478,'service_worktype','name',50,'Text','','','',''),(3479,'service_worktype','gencompanyid',11,'Integer','','','multiple',''),(3480,'service_worktype','entrydate',10,'Date','','','',''),(3481,'service_worktype','entryuserid',11,'Integer','','','',''),(3482,'service_worktype','cancel',2,'Integer','','','multiple',''),(3483,'service_worktype','canceldate',19,'DateTime','','','',''),(3484,'service_worktype','canceluserid',11,'Integer','','','',''),(3485,'service_worktype','lastchangedate',19,'DateTime','','','',''),(3486,'service_worktype','lastchangeuserid',11,'Integer','','','',''),(3487,'setup','billing',11,'Integer','','','',''),(3488,'setup','inventory',11,'Integer','','','',''),(3489,'setup','payroll',11,'Integer','','','',''),(3490,'setup','payable',11,'Integer','','','',''),(3491,'setup','gencompanyid',11,'Integer','','','',''),(3492,'setup','gl',11,'Integer','','','',''),(3493,'setup','admin',11,'Integer','','','',''),(3494,'setup','id',11,'Integer','','','primary',''),(3495,'shipto','id',22,'Numeric','','','primary unique',''),(3496,'shipto','defaultshipvia',22,'Numeric','','','',''),(3497,'shipto','cancel',11,'Integer','','','',''),(3498,'shipto','canceldate',19,'DateTime','','','',''),(3499,'shipto','canceluserid',22,'Numeric','','','',''),(3500,'shipto','entrydate',19,'DateTime','','','',''),(3501,'shipto','entryuserid',22,'Numeric','','','',''),(3502,'shipto','lastchangedate',19,'DateTime','','','',''),(3503,'shipto','lastchangeuserid',22,'Numeric','','','',''),(3504,'shipto','address1',100,'Text','','','',''),(3505,'shipto','address2',100,'Text','','','',''),(3506,'shipto','mailstop',20,'Text','','','',''),(3507,'shipto','city',50,'Text','','','',''),(3508,'shipto','state',20,'Text','','','',''),(3509,'shipto','zip',15,'Text','','','',''),(3510,'shipto','country',20,'Text','','','',''),(3511,'shipto','phone1',20,'Text','','','',''),(3512,'shipto','phone1comment',20,'Text','','','',''),(3513,'shipto','phone2',20,'Text','','','',''),(3514,'shipto','phone2comment',20,'Text','','','',''),(3515,'shipto','phone3',20,'Text','','','',''),(3516,'shipto','phone3comment',20,'Text','','','',''),(3517,'shipto','phone4',20,'Text','','','',''),(3518,'shipto','phone4comment',20,'Text','','','',''),(3519,'shipto','email1',50,'Text','','','',''),(3520,'shipto','email2',50,'Text','','','',''),(3521,'shipto','email1comment',20,'Text','','','',''),(3522,'shipto','email2comment',20,'Text','','','',''),(3523,'shipto','customerid',11,'Integer','','','multiple',''),(3524,'shipto','shipname',50,'Text','','','',''),(3525,'shipto','entry_firstname',32,'Text','','','',''),(3526,'shipto','entry_lastname',32,'Text','','','',''),(3527,'shipto','entry_country_id',5,'Integer','','','',''),(3528,'shipto','entry_zone_id',5,'Integer','','','',''),(3529,'shipto','dummy_record',1,'Integer','','','',''),(3530,'shipto','taxexemptid',11,'Integer','','','',''),(3531,'shipto','salestaxnum',30,'Text','','','',''),(3532,'shiptosalestax','id',11,'Integer','','','primary',''),(3533,'shiptosalestax','shiptoid',11,'Integer','','','multiple',''),(3534,'shiptosalestax','salestaxid',11,'Integer','','','multiple',''),(3535,'specials','specials_id',5,'Integer','','','primary',''),(3536,'specials','products_id',5,'Integer','','','',''),(3537,'specials','specials_new_products_price',10,'Numeric','','','',''),(3538,'specials','specials_date_added',8,'Text','','','',''),(3539,'specials','pricelevel_id',5,'Integer','','','',''),(3540,'statelist','initials',5,'Text','','','primary unique',''),(3541,'statelist','name',30,'Text','','','multiple unique',''),(3542,'statelist','id',11,'Integer','','','',''),(3543,'std_accounts','id',11,'Integer','','','primary',''),(3544,'std_accounts','industry_code',20,'Text','','','multiple',''),(3545,'std_accounts','industry_name',255,'Text','','','',''),(3546,'std_accounts','account_name',20,'Text','','','',''),(3547,'std_accounts','account_description',255,'Text','','','',''),(3548,'std_accounts','account_type',5,'Integer','','','',''),(3549,'std_accounts','cancel',2,'Integer','','','',''),(3550,'stock_purpose','id_stockpurpose',11,'Integer','','','primary',''),(3551,'stock_purpose','purpose',30,'Text','','','',''),(3552,'stock_purpose','cancel',11,'Integer','','','',''),(3553,'stock_purpose','cancel_date',19,'DateTime','','','',''),(3554,'stock_purpose','cancel_userid',11,'Integer','','','',''),(3555,'stock_purpose','createdate',19,'DateTime','','','',''),(3556,'stock_purpose','create_userid',11,'Integer','','','',''),(3557,'stock_purpose','id_user_create',11,'Integer','','','',''),(3558,'stock_purpose','lastrevisedate',19,'DateTime','','','',''),(3559,'stock_purpose','id_user_revise',11,'Integer','','','',''),(3560,'stock_purpose','gencompanyid',11,'Integer','','','',''),(3561,'stock_purpose','sortorder',11,'Integer','','','',''),(3562,'tax_class','tax_class_id',5,'Integer','','','primary',''),(3563,'tax_class','tax_class_title',32,'Text','','','',''),(3564,'tax_class','tax_class_description',255,'Text','','','',''),(3565,'tax_class','last_modified',19,'DateTime','','','',''),(3566,'tax_class','date_added',19,'DateTime','','','',''),(3567,'tax_rates','tax_rates_id',5,'Integer','','','primary',''),(3568,'tax_rates','tax_zone_id',5,'Integer','','','',''),(3569,'tax_rates','tax_class_id',5,'Integer','','','',''),(3570,'tax_rates','tax_rate',9,'Numeric','','','',''),(3571,'tax_rates','tax_description',255,'Text','','','',''),(3572,'tax_rates','last_modified',19,'DateTime','','','',''),(3573,'tax_rates','date_added',19,'DateTime','','','',''),(3574,'taxexempt','id',22,'Numeric','','','primary',''),(3575,'taxexempt','exemptname',30,'Text','','','',''),(3576,'taxexempt','cancel',11,'Integer','','','',''),(3577,'taxexempt','canceldate',19,'DateTime','','','',''),(3578,'taxexempt','canceluserid',22,'Numeric','','','',''),(3579,'taxexempt','entrydate',19,'DateTime','','','',''),(3580,'taxexempt','entryuserid',22,'Numeric','','','',''),(3581,'taxexempt','lastchangedate',19,'DateTime','','','',''),(3582,'taxexempt','lastchangeuserid',22,'Numeric','','','',''),(3583,'unitname','id',22,'Numeric','','','primary',''),(3584,'unitname','unitname',50,'Text','','','',''),(3585,'unitname','cancel',11,'Integer','','','',''),(3586,'unitname','canceldate',19,'DateTime','','','',''),(3587,'unitname','canceluserid',22,'Numeric','','','',''),(3588,'unitname','entrydate',19,'DateTime','','','',''),(3589,'unitname','entryuserid',22,'Numeric','','','',''),(3590,'unitname','lastchangedate',19,'DateTime','','','',''),(3591,'unitname','lastchangeuserid',22,'Numeric','','','',''),(3592,'vendor','name',30,'Text','','','',''),(3593,'vendor','id',22,'Numeric','','','primary unique',''),(3594,'vendor','orderfromname',30,'Text','','','',''),(3595,'vendor','paytermsid',22,'Numeric','','','',''),(3596,'vendor','paynone',11,'Integer','','','',''),(3597,'vendor','defaultglacctid',22,'Numeric','','','',''),(3598,'vendor','defaultbilldescription',50,'Text','','','',''),(3599,'vendor','customeraccount',20,'Text','','','',''),(3600,'vendor','gencompanyid',22,'Numeric','','','',''),(3601,'vendor','cancel',11,'Integer','','','',''),(3602,'vendor','canceldate',19,'DateTime','','','',''),(3603,'vendor','canceluserid',22,'Numeric','','','',''),(3604,'vendor','entrydate',19,'DateTime','','','',''),(3605,'vendor','entryuserid',22,'Numeric','','','',''),(3606,'vendor','lastchangedate',19,'DateTime','','','',''),(3607,'vendor','lastchangeuserid',22,'Numeric','','','',''),(3608,'vendor','companyname',100,'Text','','','',''),(3609,'vendor','address1',100,'Text','','','',''),(3610,'vendor','address2',100,'Text','','','',''),(3611,'vendor','mailstop',20,'Text','','','',''),(3612,'vendor','city',50,'Text','','','',''),(3613,'vendor','state',20,'Text','','','',''),(3614,'vendor','zip',15,'Text','','','',''),(3615,'vendor','country',20,'Text','','','',''),(3616,'vendor','phone1',20,'Text','','','',''),(3617,'vendor','phone1comment',20,'Text','','','',''),(3618,'vendor','phone2',20,'Text','','','',''),(3619,'vendor','phone2comment',20,'Text','','','',''),(3620,'vendor','phone3',20,'Text','','','',''),(3621,'vendor','phone3comment',20,'Text','','','',''),(3622,'vendor','phone4',20,'Text','','','',''),(3623,'vendor','phone4comment',20,'Text','','','',''),(3624,'vendor','email1',50,'Text','','','',''),(3625,'vendor','email1comment',20,'Text','','','',''),(3626,'vendor','email2',50,'Text','','','',''),(3627,'vendor','email2comment',20,'Text','','','',''),(3628,'vendor','website',100,'Text','','','',''),(3629,'vendor','federalid',20,'Text','','','',''),(3630,'vendor','orderfrom_companyname',100,'Text','','','',''),(3631,'vendor','orderfrom_address1',100,'Text','','','',''),(3632,'vendor','orderfrom_address2',100,'Text','','','',''),(3633,'vendor','orderfrom_mailstop',20,'Text','','','',''),(3634,'vendor','orderfrom_city',50,'Text','','','',''),(3635,'vendor','orderfrom_state',20,'Text','','','',''),(3636,'vendor','orderfrom_zip',15,'Text','','','',''),(3637,'vendor','orderfrom_country',20,'Text','','','',''),(3638,'vendor','image',64,'Text','','','',''),(3639,'vendor','scart',11,'Integer','','','',''),(3640,'vendor','workclassid',11,'Integer','','','multiple',''),(3641,'vendor','default_cost_per_hour',14,'Numeric','','','',''),(3642,'vendor','vendor_code',50,'Text','','','',''),(3643,'vendor','vendor_lead_time',11,'Integer','','','',''),(3644,'vendor','carrierserviceid',11,'Integer','','','',''),(3645,'vendor','noreturns',2,'Integer','','','',''),(3646,'vendor','percent_commission',10,'Numeric','','','',''),(3647,'vendor','flat_commission',14,'Numeric','','','',''),(3648,'vendor','parent_vendorid',11,'Integer','','','multiple',''),(3649,'workarea','id_workarea',11,'Integer','','','primary',''),(3650,'workarea','name',50,'Text','','','',''),(3651,'workarea','createdate',19,'DateTime','','','',''),(3652,'workarea','id_user_create',11,'Integer','','','',''),(3653,'workarea','lastrevisedate',19,'DateTime','','','',''),(3654,'workarea','id_user_revise',11,'Integer','','','',''),(3655,'workarea','canceldate',19,'DateTime','','','',''),(3656,'workarea','cancel',11,'Integer','','','',''),(3657,'workarea','sortorder',11,'Integer','','','',''),(3658,'workarea','print',11,'Integer','','','',''),(3659,'workarea','gencompanyid',11,'Integer','','','',''),(3660,'workarea','ask_instructions',2,'Integer','','','',''),(3661,'worksubtype','id_worksubtype',11,'Integer','','','primary unique',''),(3662,'worksubtype','id_worktype',11,'Integer','','','',''),(3663,'worksubtype','name',100,'Text','','','',''),(3664,'worksubtype','purpose',255,'Text','','','',''),(3665,'worksubtype','num_parts',3,'Integer','','','',''),(3666,'worksubtype','vended',3,'Integer','','','',''),(3667,'worksubtype','createdate',19,'DateTime','','','',''),(3668,'worksubtype','id_user_create',11,'Integer','','','',''),(3669,'worksubtype','lastrevisedate',19,'DateTime','','','',''),(3670,'worksubtype','id_user_revise',11,'Integer','','','',''),(3671,'worksubtype','canceldate',19,'DateTime','','','',''),(3672,'worksubtype','cancel',11,'Integer','','','',''),(3673,'worksubtype_detail','id_worksubtype',11,'Integer','','','primary',''),(3674,'worksubtype_detail','id_category',11,'Integer','','','primary',''),(3675,'worksubtype_detail','id_family',11,'Integer','','','primary',''),(3676,'worksubtype_detail','id_item',11,'Integer','','','primary',''),(3677,'worksubtype_quantity','id_worksubtype_quantity',11,'Integer','','','primary unique',''),(3678,'worksubtype_quantity','id_worksubtype',11,'Integer','','','multiple',''),(3679,'worksubtype_quantity','quantity',14,'Integer','','','',''),(3680,'worksubtype_quantity','days',5,'Integer','','','',''),(3681,'worksubtype_quantity','createdate',19,'DateTime','','','',''),(3682,'worksubtype_quantity','id_user_create',11,'Integer','','','',''),(3683,'worksubtype_quantity','lastrevisedate',19,'DateTime','','','',''),(3684,'worksubtype_quantity','id_user_revise',11,'Integer','','','',''),(3685,'worksubtype_quantity','canceldate',19,'DateTime','','','',''),(3686,'worksubtype_quantity','cancel',11,'Integer','','','',''),(3687,'worktype','id_worktype',11,'Integer','','','primary unique',''),(3688,'worktype','name',50,'Text','','','',''),(3689,'worktype','purpose',255,'Text','','','',''),(3690,'worktype','createdate',19,'DateTime','','','',''),(3691,'worktype','id_user_create',11,'Integer','','','',''),(3692,'worktype','orderflag',3,'Integer','','','',''),(3693,'worktype','lastrevisedate',19,'DateTime','','','',''),(3694,'worktype','id_user_revise',11,'Integer','','','',''),(3695,'worktype','canceldate',19,'DateTime','','','',''),(3696,'worktype','cancel',11,'Integer','','','',''),(3697,'zipcode','zip',10,'Text','','','multiple',''),(3698,'zipcode','state',10,'Text','','','',''),(3699,'zipcode','city',50,'Text','','','',''),(3700,'zipcode','longitude',22,'Numeric','','','',''),(3701,'zipcode','latitude',22,'Numeric','','','',''),(3702,'zones','zone_id',5,'Integer','','','primary',''),(3703,'zones','zone_country_id',5,'Integer','','','',''),(3704,'zones','zone_code',5,'Text','','','',''),(3705,'zones','zone_name',32,'Text','','','',''),(3706,'airport_order','agentcode',50,'Text','','','',''),(3707,'arcompany','tax_on_freight',2,'Integer','','','',''),(3708,'arinvoice','formnumber',50,'Text','','','',''),(3709,'arinvoicedetail','main_arinvoicedetailid',11,'Integer','','','',''),(3710,'arinvoicedetail','itemoptionid',11,'Integer','','','',''),(3711,'arinvoicedetail','itemoptiongroupid',11,'Integer','','','',''),(3712,'arordership','shiptoid',11,'Integer','','','multiple',''),(3713,'b2b_access_table','id',11,'Integer','','','primary',''),(3714,'b2b_access_table','description',255,'Text','','','',''),(3715,'b2b_access_table','whocan',11,'Integer','1,2','1 if customer\r\n2 if vendor','',''),(3716,'b2b_access_table','pagelist',65535,'X','pagelist=* means all access (supervisor)\r\npagelist= means NO access','list of php pages on b2b site that can be accessed. Must be separated by commas.','',''),(3717,'b2b_user_access_table','id',11,'Integer','','','primary',''),(3718,'b2b_user_access_table','b2b_access_tableid',11,'Integer','','','multiple',''),(3719,'b2b_user_access_table','b2buserid',11,'Integer','','','multiple',''),(3720,'b2buser','id',11,'Integer','','','primary',''),(3721,'b2buser','firstname',100,'Text','','','',''),(3722,'b2buser','lastname',100,'Text','','','',''),(3723,'b2buser','loginname',100,'Text','','','multiple',''),(3724,'b2buser','password',255,'Text','','','multiple',''),(3725,'b2buser','usertype',11,'Integer','1 if customer\r\n2 if vendor','Determines what type of menu items will appear and which modules can be accessed by this user.','multiple',''),(3726,'b2buser','referenceid',11,'Integer','','','multiple',''),(3727,'b2buser','cancel',11,'Integer','','','multiple',''),(3728,'b2buser','canceldate',19,'DateTime','','','',''),(3729,'b2buser','canceluserid',11,'Integer','','','',''),(3730,'b2buser','entrydate',19,'DateTime','','','',''),(3731,'b2buser','entryuserid',11,'Integer','','','',''),(3732,'b2buser','lastchangedate',19,'DateTime','','','',''),(3733,'b2buser','lastchangeuserid',11,'Integer','','','',''),(3734,'homepages','id',11,'Integer','','','multiple',''),(3735,'homepages','tabname',200,'Text','','','multiple',''),(3736,'homepages','reportname',200,'Text','','','multiple',''),(3737,'homepages','reportdescription',255,'Text','','','',''),(3738,'homepages','create_interval',12,'Numeric','','','',''),(3739,'homepages','lastupdate',19,'DateTime','','','',''),(3740,'homepages','status',11,'Integer','','','',''),(3741,'homepages','generate_start',19,'DateTime','','','',''),(3742,'homepages','page_html',65535,'X','','','',''),(3743,'homepages','gencompanyid',11,'Integer','','','',''),(3744,'invcompany','default_inventoryglacct',11,'Integer','','','',''),(3745,'itemoption','optioncode',50,'Text','','','',''),(3746,'airport','glsalesid',11,'Integer','','','',''),(3747,'airport_order','agent_commission_paid',14,'Numeric','','','',''),(3748,'airport_order','vendor_commission_paid',14,'Numeric','','','',''),(3749,'airport_order','barcode_file',50,'Text','','','',''),(3750,'apbill','approved_paydate',10,'Date','','','',''),(3751,'apbill','preapproved_userid',11,'Integer','','','',''),(3752,'apbill','preapproved_status',5,'Integer','','','',''),(3753,'apbill','preapproved_checkacctid',11,'Integer','','','',''),(3754,'apbill','preapproved_amount',17,'Numeric','','','',''),(3755,'apbill','preapproved_interest',17,'Numeric','','','',''),(3756,'apbill','old_id',255,'Text','','','',''),(3757,'apbillpayment','old_id',255,'Text','','','',''),(3758,'apbilltaxdetail','id',11,'Integer','','','primary',''),(3759,'apbilltaxdetail','apbillid',11,'Integer','','','multiple',''),(3760,'apbilltaxdetail','taxid',11,'Integer','','','multiple',''),(3761,'apbilltaxdetail','taxamount',21,'Numeric','','','',''),(3762,'apcompany','glcommissionid',11,'Integer','','','',''),(3763,'apcompany','default_vendor_termsid',11,'Integer','','','',''),(3764,'apcompany','must_preapprove',5,'Integer','','','',''),(3765,'apcompany','which_preapprove_ckdate',5,'Integer','','','',''),(3766,'arcompany','order_base',5,'Integer','','','',''),(3767,'arcompany','b2b_orders',2,'Integer','','','',''),(3768,'arcompany','b2b_service',2,'Integer','','','',''),(3769,'arcompany','tax_how',2,'Integer','','','',''),(3770,'arcompany','donotapply',2,'Integer','','','',''),(3771,'arcompany','restockglid',11,'Integer','','','',''),(3772,'arcompany','restockunitid',11,'Integer','','','',''),(3773,'arcompany','salesterritories',5,'Integer','','','',''),(3774,'arcompany','default_statement',2,'Integer','','','',''),(3775,'arcompany','b2b_commission',5,'Integer','','','',''),(3776,'arcompany','default_discountmsg',65535,'X','','','',''),(3777,'arcompany','b2b_print_orders',5,'Integer','','','',''),(3778,'arcompany','b2b_pricelist_orders',5,'Integer','','','',''),(3779,'arinvoice','shiptoattn',100,'Text','','','',''),(3780,'arinvoice','old_id',255,'Text','','','',''),(3781,'arinvoice_interest','id',11,'Integer','','','primary',''),(3782,'arinvoice_interest','invoiceid',11,'Integer','','','',''),(3783,'arinvoice_interest','calcdate',10,'Date','','','multiple',''),(3784,'arinvoice_interest','amount',21,'Numeric','','','',''),(3785,'arinvoicedetail','taxflag2',2,'Integer','','','',''),(3786,'arinvoicedetail','taxflag3',2,'Integer','','','',''),(3787,'arinvoicedetail','taxflagid',11,'Integer','','','',''),(3788,'arinvoicedetail','taxflag2id',11,'Integer','','','',''),(3789,'arinvoicedetail','taxflag3id',11,'Integer','','','',''),(3790,'arinvoicedetail','orig_priceach',14,'Numeric','','','',''),(3791,'arinvoicedetail','discount_amount',14,'Numeric','','','',''),(3792,'arinvoicedetail','discount_percent',14,'Numeric','','','',''),(3793,'arinvoicedetail','old_id',255,'Text','','','',''),(3794,'arinvoicedetailcost','itemid',11,'Integer','','','',''),(3795,'arinvoicedetailcost','locationid',11,'Integer','','','',''),(3796,'arinvoicedetailcost','arordershipdetailid',11,'Integer','','','',''),(3797,'arinvoicedetailcost','inventoryglacctid',11,'Integer','','','',''),(3798,'arinvoicepaymentdetail','old_id',255,'Text','','','',''),(3799,'arorder','rma_arorder_returnedid',11,'Integer','','','',''),(3800,'arorder','rma_orig_arorderid',11,'Integer','','','',''),(3801,'arorder_deposit','cctransactionid',11,'Integer','','','',''),(3802,'arorderdetail','taxflag2',2,'Integer','','','',''),(3803,'arorderdetail','taxflag3',2,'Integer','','','',''),(3804,'arorderdetail','taxflagid',11,'Integer','','','',''),(3805,'arorderdetail','taxflag2id',11,'Integer','','','',''),(3806,'arorderdetail','taxflag3id',11,'Integer','','','',''),(3807,'arorderdetail','itemweight',14,'Numeric','','','',''),(3808,'arorderdetail','qtyorderprice',22,'Numeric','','','',''),(3809,'arordership','voucherid',11,'Integer','','','',''),(3810,'arordershipdetail','inventoryglacctid',11,'Integer','','','',''),(3811,'arordershipdetail','costeach',21,'Numeric','','','',''),(3812,'arordertax','taxrate',14,'Numeric','','','',''),(3813,'arserviceorder_time','ordered',11,'Integer','','','multiple',''),(3814,'b2buser','email',255,'Text','','','',''),(3815,'buildordermaster','status',5,'Integer','','','',''),(3816,'buildordermaster','po_created',5,'Integer','','','',''),(3817,'buildordersub','vendoritemid',11,'Integer','','','',''),(3818,'buildordersub','mfg',50,'Text','','','',''),(3819,'buildordersub','vordernumber',30,'Text','','','',''),(3820,'buildordersub','reference_notes',65535,'X','','','',''),(3821,'buildordersubdetail','id',11,'Integer','','','primary',''),(3822,'buildordersubdetail','buildordersubid',11,'Integer','','','multiple',''),(3823,'buildordersubdetail','vendoritemid',11,'Integer','','','multiple',''),(3824,'buildordersubdetail','mfg',50,'Text','','','',''),(3825,'buildordersubdetail','vordernumber',30,'Text','','','',''),(3826,'buildordersubdetail','poqty',14,'Numeric','','','',''),(3827,'buildordersubdetail','invpodetailid',11,'Integer','','','multiple',''),(3828,'buildordersubdetail','qty_commit',14,'Numeric','','','',''),(3829,'buildordersubdetail','qtyused',14,'Numeric','','','',''),(3830,'cashpaymenttax','taxgroupid',11,'Integer','','','',''),(3831,'ccaccount','id',11,'Integer','','','primary',''),(3832,'ccaccount','name',100,'Text','','','',''),(3833,'ccaccount','ccprocessorid',11,'Integer','','','',''),(3834,'ccaccount','companyid',11,'Integer','','','',''),(3835,'ccaccount','entrydate',19,'DateTime','','','',''),(3836,'ccaccount','entryuserid',11,'Integer','','','',''),(3837,'ccaccount','lastchangedate',19,'DateTime','','','',''),(3838,'ccaccount','lastchangeuserid',11,'Integer','','','',''),(3839,'ccaccount','cancel',2,'Integer','','','',''),(3840,'ccaccount','canceldate',19,'DateTime','','','',''),(3841,'ccaccount','canceluserid',11,'Integer','','','',''),(3842,'ccaccountoption','id',11,'Integer','','','primary',''),(3843,'ccaccountoption','ccprocessorid',11,'Integer','','','',''),(3844,'ccaccountoption','name',255,'Text','','','',''),(3845,'ccaccountoption','description',255,'Text','','','',''),(3846,'ccaccountoption','fieldname',50,'Text','','','',''),(3847,'ccaccountoption','ccvalues',65535,'X','','','',''),(3848,'ccaccountoption','ccdefault',255,'Text','','','',''),(3849,'ccaccountoption','cchold',2,'Integer','','','',''),(3850,'ccaccountsetting','id',11,'Integer','','','primary',''),(3851,'ccaccountsetting','ccaccountid',11,'Integer','','','',''),(3852,'ccaccountsetting','ccaccountoptionid',11,'Integer','','','',''),(3853,'ccaccountsetting','value',255,'Text','','','',''),(3854,'ccaccountsetting','lastchangedate',19,'DateTime','','','',''),(3855,'ccaccountsetting','lastchangeuserid',11,'Integer','','','',''),(3856,'cctransaction','id',11,'Integer','','','primary',''),(3857,'cctransaction','customerid',11,'Integer','','','multiple',''),(3858,'cctransaction','b2buserid',11,'Integer','','','multiple',''),(3859,'cctransaction','ccaccountid',11,'Integer','','','multiple',''),(3860,'cctransaction','referid',11,'Integer','','','multiple',''),(3861,'cctransaction','refertable',50,'Text','','','multiple',''),(3862,'cctransaction','transtype',1,'Text','','','multiple',''),(3863,'cctransaction','cardnumber',50,'Text','','','',''),(3864,'cctransaction','cardexp',4,'Text','','','',''),(3865,'cctransaction','cardtype',20,'Text','','','multiple',''),(3866,'cctransaction','cardfirstname',50,'Text','','','',''),(3867,'cctransaction','cardlastname',50,'Text','','','',''),(3868,'cctransaction','amount',14,'Numeric','','','',''),(3869,'cctransaction','nontaxable',14,'Numeric','','','',''),(3870,'cctransaction','shipping',14,'Numeric','','','',''),(3871,'cctransaction','tax',14,'Numeric','','','',''),(3872,'cctransaction','transid',30,'Text','','','multiple',''),(3873,'cctransaction','optionalid',80,'Text','','','',''),(3874,'cctransaction','resultcode',1,'Text','','','',''),(3875,'cctransaction','resultreasoncode',11,'Integer','','','',''),(3876,'cctransaction','resultreasontext',255,'Text','','','',''),(3877,'cctransaction','authcode',25,'Text','','','',''),(3878,'cctransaction','avscode',2,'Text','','','',''),(3879,'cctransaction','cardcode',2,'Text','','','',''),(3880,'cctransaction','customerip',25,'Text','','','',''),(3881,'cctransaction','md5hash',50,'Text','','','',''),(3882,'cctransaction','customerconfirmation',20,'Text','','','multiple',''),(3883,'cctransaction','authopen',2,'Integer','','','',''),(3884,'cctransaction','entrydate',19,'DateTime','','','multiple',''),(3885,'cctransaction','entryuserid',11,'Integer','','','',''),(3886,'cctransaction','authtransid',30,'Text','','','',''),(3887,'cctransaction','authorize_extra',11,'Integer','','','',''),(3888,'cctransaction','userdata',255,'Text','','','',''),(3889,'checkacct','pay_type',5,'Integer','','','',''),(3890,'chk','commission',2,'Integer','','','',''),(3891,'compositeitemid','default_itemvendorid',11,'Integer','','','',''),(3892,'compositeitemid','mfg',50,'Text','','','',''),(3893,'compositeitemid','vordernumber',30,'Text','','','',''),(3894,'compositeitemid','reference_notes',65535,'X','','','',''),(3895,'compositeitemid','status',5,'Integer','','','',''),(3896,'compositeitemid','displayorder',5,'Integer','','','',''),(3897,'customer','preprint_from_box_labels',2,'Integer','','','',''),(3898,'customer','notify_order',2,'Integer','','','',''),(3899,'customer','notify_ship',2,'Integer','','','',''),(3900,'customer','notify_invoice',2,'Integer','','','',''),(3901,'customer','email_order_acknowledgement',2,'Integer','','','',''),(3902,'customer','email_order_ship',2,'Integer','','','',''),(3903,'customer','email_invoice',2,'Integer','','','',''),(3904,'customer','groupid',11,'Integer','','','multiple',''),(3905,'customer','onlygroupitems_onb2b',5,'Integer','','','',''),(3906,'customer','taxgroupid',11,'Integer','','','multiple',''),(3907,'employeelog','id_employeelog',11,'Integer','','','primary unique',''),(3908,'employeelog','id_employee',11,'Integer','','','',''),(3909,'employeelog','status',3,'Integer','','','',''),(3910,'employeelog','createdate',19,'DateTime','','','',''),(3911,'employeelog','starttime',19,'DateTime','','','',''),(3912,'employeelog','endtime',19,'DateTime','','','',''),(3913,'employeelog','total_time',12,'Numeric','','','',''),(3914,'employeelog','id_employeelogcategory',11,'Integer','','','',''),(3915,'employeelog','notes',100,'Text','','','',''),(3916,'employeelog','cancel',3,'Integer','','','',''),(3917,'employeelogcategory','id',11,'Integer','','','primary unique',''),(3918,'employeelogcategory','name',100,'Text','','','',''),(3919,'employeelogcategory','cancel',3,'Integer','','','',''),(3920,'estquote_deposit','id',11,'Integer','','','primary unique',''),(3921,'estquote_deposit','id_printorder',11,'Integer','','','multiple',''),(3922,'estquote_deposit','amount',14,'Numeric','','','',''),(3923,'estquote_deposit','payment_method',5,'Integer','','','',''),(3924,'estquote_deposit','transaction_id',32,'Text','','','',''),(3925,'estquote_deposit','entrydate',10,'Date','','','',''),(3926,'estquote_deposit','cc_type',20,'Text','','','',''),(3927,'estquote_deposit','last4ofcard',4,'Text','','','',''),(3928,'estquote_deposit','voucherid',11,'Integer','','','multiple',''),(3929,'estquote_deposit','cancel',3,'Integer','','','',''),(3930,'estquote_deposit','canceldate',10,'Date','','','',''),(3931,'estquote_deposit','canceluserid',11,'Integer','','','',''),(3932,'estquote_deposit','lastchangedate',19,'DateTime','','','',''),(3933,'estquote_deposit','bankdepositid',11,'Integer','','','',''),(3934,'estquotebinderyaddl','pieceworkgroupid',11,'Integer','','','',''),(3935,'estquotebinderyaddl','internal_quote',5,'Integer','','','multiple',''),(3936,'estquotebinderyaddl','external_quote',5,'Integer','','','multiple',''),(3937,'estquotebinderyaddl','internal_order',5,'Integer','','','multiple',''),(3938,'estquotebinderyaddl','external_order',5,'Integer','','','multiple',''),(3939,'estquotepieceworkgroup','id',11,'Integer','','','primary',''),(3940,'estquotepieceworkgroup','name',100,'Text','','','',''),(3941,'estquotepieceworkgroup','gencompanyid',11,'Integer','','','',''),(3942,'estquotequote','reprint',11,'Integer','','','',''),(3943,'estquoteship','shiptoname',255,'Text','','','',''),(3944,'estquoteship','shiptoaddress',255,'Text','','','',''),(3945,'estquoteship','shiptoaddress2',255,'Text','','','',''),(3946,'estquoteship','shiptocity',50,'Text','','','',''),(3947,'estquoteship','shiptostate',20,'Text','','','',''),(3948,'estquoteship','shiptozip',15,'Text','','','',''),(3949,'estquoteship','shiptophone',20,'Text','','','',''),(3950,'estquoteship','shipfromname',255,'Text','','','',''),(3951,'estquoteship','shipfromaddress',255,'Text','','','',''),(3952,'estquoteship','shipfromaddress2',255,'Text','','','',''),(3953,'estquoteship','shipfromcity',50,'Text','','','',''),(3954,'estquoteship','shipfromstate',20,'Text','','','',''),(3955,'estquoteship','shipfromzip',15,'Text','','','',''),(3956,'estquoteworktype','tightregrule',5,'Integer','','','',''),(3957,'gencompany','vat_tax',5,'Integer','','','',''),(3958,'genuser','weather_zip',20,'Text','','','',''),(3959,'genuser','cpa',11,'Integer','','','',''),(3960,'genuserhome','whole2',100,'Text','','','',''),(3961,'gl_costcenter','id',11,'Integer','','','primary',''),(3962,'gl_costcenter','description',255,'Text','','','',''),(3963,'gl_costcenter','companyid',11,'Integer','','','',''),(3964,'gl_costcenter','cancel',5,'Integer','','','multiple',''),(3965,'gl_costcenter','canceluserid',11,'Integer','','','',''),(3966,'gl_costcenter','canceldate',19,'DateTime','','','',''),(3967,'gl_costcenter','entrydate',10,'Date','','','',''),(3968,'gl_costcenter','entryuserid',11,'Integer','','','',''),(3969,'gl_summarylevel','id',11,'Integer','','','primary',''),(3970,'gl_summarylevel','description',255,'Text','','','',''),(3971,'gl_summarylevel','companyid',11,'Integer','','','',''),(3972,'gl_summarylevel','cancel',5,'Integer','','','multiple',''),(3973,'gl_summarylevel','canceluserid',11,'Integer','','','',''),(3974,'gl_summarylevel','canceldate',19,'DateTime','','','',''),(3975,'gl_summarylevel','entrydate',10,'Date','','','',''),(3976,'gl_summarylevel','entryuserid',11,'Integer','','','',''),(3977,'gl_summarylevel_account','glaccountid',11,'Integer','','','multiple',''),(3978,'gl_summarylevel_account','gl_summarylevelid',11,'Integer','','','multiple',''),(3979,'gl_summarylevel_account','destination_glaccountid',11,'Integer','','','multiple',''),(3980,'glaccount','costcenterid',11,'Integer','','','multiple',''),(3981,'igroup','id',11,'Integer','','','primary',''),(3982,'igroup','groupname',255,'Text','','','',''),(3983,'igroup','groupcode',20,'Text','','','multiple',''),(3984,'igroup','createdate',19,'DateTime','','','',''),(3985,'igroup','gencompanyid',11,'Integer','','','',''),(3986,'igroup','createuserid',11,'Integer','','','',''),(3987,'igroup','cancel',5,'Integer','','','',''),(3988,'igroup','canceldate',19,'DateTime','','','',''),(3989,'igroup','canceluserid',11,'Integer','','','',''),(3990,'igroup','lastchangedate',19,'DateTime','','','',''),(3991,'igroup','lastchangeuserid',11,'Integer','','','',''),(3992,'invcompany','multi_quantity',5,'Integer','','','',''),(3993,'invnotification','id',11,'Integer','','','primary',''),(3994,'invnotification','itemid',11,'Integer','','','multiple',''),(3995,'invnotification','customerid',11,'Integer','','','multiple',''),(3996,'invnotification','companyid',11,'Integer','','','',''),(3997,'invnotification','email',255,'Text','','','',''),(3998,'invnotification','entrydate',19,'DateTime','','','',''),(3999,'invnotification','sent',2,'Integer','','','',''),(4000,'invnotification','sentdate',19,'DateTime','','','',''),(4001,'invpo','salesordernumber',20,'Text','','','',''),(4002,'invpo','dropship',5,'Integer','','','multiple',''),(4003,'invpo','shiptoid',11,'Integer','','','multiple',''),(4004,'invpo','salesorderid',11,'Integer','','','multiple',''),(4005,'invpodetail','itemvendorid',11,'Integer','','','',''),(4006,'invpodetail','purchaseunitid',11,'Integer','','','',''),(4007,'invpodetail','itempriceqty',21,'Numeric','','','',''),(4008,'invreceive','itempriceqty',14,'Numeric','','','',''),(4009,'item','id_printorder',11,'Integer','','','',''),(4010,'item','taxexempt',2,'Integer','','','',''),(4011,'item_group','itemid',11,'Integer','','','primary',''),(4012,'item_group','groupid',11,'Integer','','','primary',''),(4013,'item_group','price',17,'Numeric','','','',''),(4014,'itemtransaction','itemvendorid',11,'Integer','','','multiple',''),(4015,'itemtransaction','status',5,'Integer','','','multiple',''),(4016,'itemtransaction','withdrawn',14,'Numeric','','','',''),(4017,'itemtransactiondetail','id',11,'Integer','','','primary',''),(4018,'itemtransactiondetail','itemtransactionid',11,'Integer','','','multiple',''),(4019,'itemtransactiondetail','itemtransactionfieldid',11,'Integer','','','multiple',''),(4020,'itemtransactiondetail','itemvalue',255,'Text','','','',''),(4021,'itemtransactionfield','id',11,'Integer','','','primary',''),(4022,'itemtransactionfield','categoryid',11,'Integer','','','multiple',''),(4023,'itemtransactionfield','description',255,'Text','','','',''),(4024,'itemtransactionfield','default_value',255,'Text','','','',''),(4025,'itemtransactionfield','entrytype',5,'Integer','','','',''),(4026,'itemtransactionfield','text_limit',11,'Integer','','','',''),(4027,'itemtransactionfield','gencompanyid',11,'Integer','','','multiple',''),(4028,'itemtransactionfield','entrydate',19,'DateTime','','','',''),(4029,'itemtransactionfield','entryuserid',11,'Integer','','','',''),(4030,'itemtransactionfield','cancel',5,'Integer','','','multiple',''),(4031,'itemtransactionfield','canceluserid',11,'Integer','','','',''),(4032,'itemtransactionfield','canceldate',19,'DateTime','','','',''),(4033,'itemtransactionfield','lastupdatedate',19,'DateTime','','','',''),(4034,'itemtransactionfield','lastupdateuserid',11,'Integer','','','',''),(4035,'itemtransactionfield_selection','id',11,'Integer','','','primary',''),(4036,'itemtransactionfield_selection','itemtransactionfieldid',11,'Integer','','','',''),(4037,'itemtransactionfield_selection','name',255,'Text','','','',''),(4038,'itemtransactionfield_selection','sortorder',5,'Integer','','','multiple',''),(4039,'itemtransactionfield_selection','cancel',5,'Integer','','','multiple',''),(4040,'itemtransactionfield_selection','canceldate',19,'DateTime','','','',''),(4041,'itemtransactionfield_selection','canceluserid',11,'Integer','','','',''),(4042,'itemvendor','mfg',50,'Text','','','',''),(4043,'itemvendor','is_default',5,'Integer','','','',''),(4044,'lang','pt',255,'Text','','','',''),(4045,'lang','jp',255,'Text','','','',''),(4046,'lang','fr',255,'Text','','','',''),(4047,'langcompany','id',11,'Integer','','','primary',''),(4048,'langcompany','gencompanyid',11,'Integer','','','multiple',''),(4049,'langcompany','languages_id',11,'Integer','','','',''),(4050,'langcompany','active',2,'Integer','','','',''),(4051,'langfield','id',11,'Integer','','','primary',''),(4052,'langfield','tablename',255,'Text','','','multiple',''),(4053,'langfield','fieldname',255,'Text','','','multiple',''),(4054,'langfield','recordid',11,'Integer','','','multiple',''),(4055,'langfield','en',65535,'X','','','',''),(4056,'langfield','de',65535,'X','','','',''),(4057,'langfield','es',65535,'X','','','',''),(4058,'langfield','ru',65535,'X','','','',''),(4059,'langfield','jp',65535,'X','','','',''),(4060,'langmatch_b2b','id',11,'Integer','','','primary',''),(4061,'langmatch_b2b','langid',11,'Integer','','','multiple',''),(4062,'langmatch_b2b','page',100,'Text','','','multiple',''),(4063,'link','id',11,'Integer','','','primary',''),(4064,'link','name',25,'Text','','','',''),(4065,'link','url',100,'Text','','','',''),(4066,'link','description',100,'Text','','','',''),(4067,'link','gencompanyid',11,'Text','','','',''),(4068,'link','active',11,'Text','','','',''),(4069,'link','linktype',11,'Text','','','',''),(4070,'menudata','plaintext',11,'Text','','','',''),(4071,'menudata','linktype',11,'Text','','','',''),(4072,'order_partnr','print_type',2,'Integer','','','',''),(4073,'prcity','round_tax',2,'Integer','','','',''),(4074,'prcity','mexemptyr1',21,'Numeric','','','',''),(4075,'prcity','mexemptyr2',21,'Numeric','','','',''),(4076,'prcity','mexemptyr3',21,'Numeric','','','',''),(4077,'prcity','mexemptyr4',21,'Numeric','','','',''),(4078,'prcity','jexemptyr1',21,'Numeric','','','',''),(4079,'prcity','jexemptyr2',21,'Numeric','','','',''),(4080,'prcity','jexemptyr3',21,'Numeric','','','',''),(4081,'prcity','jexemptyr4',21,'Numeric','','','',''),(4082,'prcity','hexemptyr1',21,'Numeric','','','',''),(4083,'prcity','hexemptyr2',21,'Numeric','','','',''),(4084,'prcity','hexemptyr3',21,'Numeric','','','',''),(4085,'prcity','hexemptyr4',21,'Numeric','','','',''),(4086,'prcity','hexemptyr0',21,'Numeric','','','',''),(4087,'prcity','mexemptyr0',21,'Numeric','','','',''),(4088,'prcity','jexemptyr0',21,'Numeric','','','',''),(4089,'prcity','exemptyr0',21,'Numeric','','','',''),(4090,'prcompany','w2extra_top',5,'Integer','','','',''),(4091,'prcompany','w2extra_side',5,'Integer','','','',''),(4092,'premployee','old_id',255,'Text','','','',''),(4093,'printorder','Bindery_completedate',19,'DateTime','','','',''),(4094,'printorder','Bindery_initials',255,'Text','','','',''),(4095,'printorder','Digital_Print_completedate',19,'DateTime','','','',''),(4096,'printorder','Digital_Print_initials',255,'Text','','','',''),(4097,'printorder','Graphics_completedate',19,'DateTime','','','',''),(4098,'printorder','Graphics_initials',10,'Text','','','',''),(4099,'printorder','Outside_Vended_completedate',19,'DateTime','','','',''),(4100,'printorder','Outside_Vended_initials',255,'Text','','','',''),(4101,'printorder','Paper_completedate',19,'DateTime','','','',''),(4102,'printorder','Paper_initials',10,'Text','','','',''),(4103,'printorder','Prepress_completedate',19,'DateTime','','','',''),(4104,'printorder','Prepress_initials',255,'Text','','','',''),(4105,'printorder','Press_completedate',19,'DateTime','','','',''),(4106,'printorder','Press_initials',255,'Text','','','',''),(4107,'printorder','Shipping_completedate',19,'DateTime','','','',''),(4108,'printorder','Shipping_initials',10,'Text','','','',''),(4109,'printorder_shipto','shiptoname',255,'Text','','','',''),(4110,'printorder_shipto','shiptoaddress',255,'Text','','','',''),(4111,'printorder_shipto','shiptoaddress2',255,'Text','','','',''),(4112,'printorder_shipto','shiptocity',50,'Text','','','',''),(4113,'printorder_shipto','shiptostate',20,'Text','','','',''),(4114,'printorder_shipto','shiptozip',15,'Text','','','',''),(4115,'printorder_shipto','shiptophone',20,'Text','','','',''),(4116,'prlocal','round_tax',2,'Integer','','','',''),(4117,'prlocal','mexemptyr1',21,'Numeric','','','',''),(4118,'prlocal','mexemptyr2',21,'Numeric','','','',''),(4119,'prlocal','mexemptyr3',21,'Numeric','','','',''),(4120,'prlocal','mexemptyr4',21,'Numeric','','','',''),(4121,'prlocal','jexemptyr1',21,'Numeric','','','',''),(4122,'prlocal','jexemptyr2',21,'Numeric','','','',''),(4123,'prlocal','jexemptyr3',21,'Numeric','','','',''),(4124,'prlocal','jexemptyr4',21,'Numeric','','','',''),(4125,'prlocal','hexemptyr1',21,'Numeric','','','',''),(4126,'prlocal','hexemptyr2',21,'Numeric','','','',''),(4127,'prlocal','hexemptyr3',21,'Numeric','','','',''),(4128,'prlocal','hexemptyr4',21,'Numeric','','','',''),(4129,'prlocal','hexemptyr0',21,'Numeric','','','',''),(4130,'prlocal','mexemptyr0',21,'Numeric','','','',''),(4131,'prlocal','jexemptyr0',21,'Numeric','','','',''),(4132,'prlocal','exemptyr0',21,'Numeric','','','',''),(4133,'prpension','w2retirementbox',2,'Integer','','','',''),(4134,'prstate','round_tax',2,'Integer','','','',''),(4135,'prstate','hexemptyr0',21,'Numeric','','','',''),(4136,'prstate','mexemptyr0',21,'Numeric','','','',''),(4137,'prstate','jexemptyr0',21,'Numeric','','','',''),(4138,'prstate','exemptyr0',21,'Numeric','','','',''),(4139,'rma_action','id',11,'Integer','','','primary',''),(4140,'rma_action','action',50,'Text','','','',''),(4141,'rma_action','new_order_required',5,'Integer','','','',''),(4142,'rma_action','gencompanyid',11,'Integer','','','',''),(4143,'rma_action','cancel',5,'Integer','','','multiple',''),(4144,'rma_action','canceluserid',11,'Integer','','','',''),(4145,'rma_action','canceldate',19,'DateTime','','','',''),(4146,'rma_action','entrydate',19,'DateTime','','','',''),(4147,'rma_action','entryuserid',11,'Integer','','','',''),(4148,'rma_arorder','id',11,'Integer','','','primary',''),(4149,'rma_arorder','rmanumber',50,'Text','','','multiple',''),(4150,'rma_arorder','orderid',11,'Integer','','','multiple',''),(4151,'rma_arorder','arordershipid',11,'Integer','','','multiple',''),(4152,'rma_arorder','date_issued',10,'Date','','','',''),(4153,'rma_arorder','date_rma_completed',10,'Date','','','',''),(4154,'rma_arorder','status',5,'Integer','','','multiple',''),(4155,'rma_arorder','return_shipping_paid_by',5,'Integer','','','',''),(4156,'rma_arorder','send_willcall',5,'Integer','','','',''),(4157,'rma_arorder','notes',255,'Text','','','',''),(4158,'rma_arorder','createdate',19,'DateTime','','','',''),(4159,'rma_arorder','createuserid',11,'Integer','','','',''),(4160,'rma_arorder','lastupdatedate',19,'DateTime','','','',''),(4161,'rma_arorder','lastupdateuserid',11,'Integer','','','',''),(4162,'rma_arorder','cancel',5,'Integer','','','multiple',''),(4163,'rma_arorder','canceldate',19,'DateTime','','','',''),(4164,'rma_arorder','canceluserid',11,'Integer','','','',''),(4165,'rma_arorder_returned','id',11,'Integer','','','primary',''),(4166,'rma_arorder_returned','rma_arorderid',11,'Integer','','','multiple',''),(4167,'rma_arorder_returned','return_date',10,'Date','','','multiple',''),(4168,'rma_arorder_returned','taxid',11,'Integer','','','',''),(4169,'rma_arorder_returned','taxcredit',21,'Numeric','','','',''),(4170,'rma_arorder_returned','taxid2',11,'Integer','','','',''),(4171,'rma_arorder_returned','taxcredit2',21,'Numeric','','','',''),(4172,'rma_arorder_returned','taxid3',11,'Integer','','','',''),(4173,'rma_arorder_returned','taxcredit3',21,'Numeric','','','',''),(4174,'rma_arorder_returned','shipping_credit',21,'Numeric','','','',''),(4175,'rma_arorder_returned','restock_fee',21,'Numeric','','','',''),(4176,'rma_arorder_returned','total_credit',21,'Numeric','','','',''),(4177,'rma_arorder_returned','invoiceid',11,'Integer','','','',''),(4178,'rma_arorder_returned','voucherid',11,'Integer','','','',''),(4179,'rma_arorder_returned','new_orderid',11,'Integer','','','',''),(4180,'rma_arorder_returned','cancel',5,'Integer','','','multiple',''),(4181,'rma_arorder_returned','canceluserid',11,'Integer','','','',''),(4182,'rma_arorder_returned','canceldate',19,'DateTime','','','',''),(4183,'rma_arorder_returned','entrydate',19,'DateTime','','','',''),(4184,'rma_arorder_returned','entryuserid',11,'Integer','','','',''),(4185,'rma_arorder_returned_extras','id',11,'Integer','','','primary',''),(4186,'rma_arorder_returned_extras','rma_arorder_returnedid',11,'Integer','','','multiple',''),(4187,'rma_arorder_returned_extras','creditamount',21,'Numeric','','','',''),(4188,'rma_arorder_returned_extras','creditdescription',255,'Text','','','',''),(4189,'rma_arorder_returned_extras','creditclass',11,'Integer','','','multiple',''),(4190,'rma_arorderdetail','id',11,'Integer','','','primary',''),(4191,'rma_arorderdetail','rma_arorderid',11,'Integer','','','multiple',''),(4192,'rma_arorderdetail','orderid',11,'Integer','','','multiple',''),(4193,'rma_arorderdetail','arordershipdetailid',11,'Integer','','','multiple',''),(4194,'rma_arorderdetail','qty_to_return',14,'Numeric','','','',''),(4195,'rma_arorderdetail','qty_returned_actual',14,'Numeric','','','',''),(4196,'rma_arorderdetail','order_itemid',11,'Integer','','','',''),(4197,'rma_arorderdetail','order_costeach',21,'Numeric','','','',''),(4198,'rma_arorderdetail','order_priceach',21,'Numeric','','','',''),(4199,'rma_arorderdetail','order_saleunitperpriceunit',14,'Numeric','','','',''),(4200,'rma_arorderdetail','order_cogsglid',11,'Integer','','','',''),(4201,'rma_arorderdetail','order_salesglid',11,'Integer','','','',''),(4202,'rma_arorderdetail','replacement_itemid',11,'Integer','','','',''),(4203,'rma_arorderdetail','replacement_costeach',21,'Numeric','','','',''),(4204,'rma_arorderdetail','replacement_priceach',21,'Numeric','','','',''),(4205,'rma_arorderdetail','replace_saleunitperpriceunit',14,'Numeric','','','',''),(4206,'rma_arorderdetail','replace_cogsglid',11,'Integer','','','',''),(4207,'rma_arorderdetail','replace_salesglid',11,'Integer','','','',''),(4208,'rma_arorderdetail','qty_to_replace',14,'Numeric','','','',''),(4209,'rma_arorderdetail','rma_reasonid',11,'Integer','','','',''),(4210,'rma_arorderdetail','rma_actionid',11,'Integer','','','',''),(4211,'rma_arorderdetail','entrydate',10,'Date','','','',''),(4212,'rma_arorderdetail','entryuserid',11,'Integer','','','',''),(4213,'rma_arorderdetail','canceldate',10,'Date','','','',''),(4214,'rma_arorderdetail','cancel',5,'Integer','','','multiple',''),(4215,'rma_arorderdetail','canceluserid',11,'Integer','','','',''),(4216,'rma_arorderdetail_returned','id',11,'Integer','','','primary',''),(4217,'rma_arorderdetail_returned','rma_arorderdetailid',11,'Integer','','','multiple',''),(4218,'rma_arorderdetail_returned','qty_received',14,'Numeric','','','',''),(4219,'rma_arorderdetail_returned','receive_itemid',11,'Integer','','','',''),(4220,'rma_arorderdetail_returned','costeach',21,'Numeric','','','',''),(4221,'rma_arorderdetail_returned','priceach',21,'Numeric','','','',''),(4222,'rma_arorderdetail_returned','salesglaccountid',11,'Integer','','','',''),(4223,'rma_arorderdetail_returned','costglaccountid',11,'Integer','','','',''),(4224,'rma_arorderdetail_returned','inventoryglaccountid',11,'Integer','','','',''),(4225,'rma_arorderdetail_returned','rma_conditionid',11,'Integer','','','',''),(4226,'rma_arorderdetail_returned','rma_actionid',11,'Integer','','','',''),(4227,'rma_arorderdetail_returned','restock_fee',21,'Numeric','','','',''),(4228,'rma_arorderdetail_returned','total_credit_amount',21,'Numeric','','','',''),(4229,'rma_arorderdetail_returned','replace_qty',14,'Numeric','','','',''),(4230,'rma_arorderdetail_returned','replace_itemid',11,'Integer','','','',''),(4231,'rma_arorderdetail_returned','invoiceid',11,'Integer','','','',''),(4232,'rma_arorderdetail_returned','voucherid',11,'Integer','','','',''),(4233,'rma_arorderdetail_returned','entryuserid',11,'Integer','','','',''),(4234,'rma_arorderdetail_returned','cancel',5,'Integer','','','multiple',''),(4235,'rma_arorderdetail_returned','canceluserid',11,'Integer','','','',''),(4236,'rma_arorderdetail_returned','canceldate',19,'DateTime','','','',''),(4237,'rma_condition','id',11,'Integer','','','primary',''),(4238,'rma_condition','rma_condition',50,'Text','','','',''),(4239,'rma_condition','percent_restock_fee',7,'Numeric','','','',''),(4240,'rma_condition','flat_restock_fee',14,'Numeric','','','',''),(4241,'rma_condition','gencompanyid',11,'Integer','','','',''),(4242,'rma_condition','cancel',5,'Integer','','','multiple',''),(4243,'rma_condition','canceluserid',11,'Integer','','','',''),(4244,'rma_condition','canceldate',19,'DateTime','','','',''),(4245,'rma_condition','entrydate',19,'DateTime','','','',''),(4246,'rma_condition','entryuserid',11,'Integer','','','',''),(4247,'rma_condition','damaged',5,'Integer','','','',''),(4248,'rma_creditclass','id',11,'Integer','','','primary',''),(4249,'rma_creditclass','description',50,'Text','','','',''),(4250,'rma_creditclass','glaccountid',11,'Integer','','','',''),(4251,'rma_creditclass','is_taxable',5,'Integer','','','',''),(4252,'rma_creditclass','gencompanyid',11,'Integer','','','',''),(4253,'rma_creditclass','cancel',5,'Integer','','','multiple',''),(4254,'rma_creditclass','canceluserid',11,'Integer','','','',''),(4255,'rma_creditclass','canceldate',19,'DateTime','','','',''),(4256,'rma_creditclass','entrydate',19,'DateTime','','','',''),(4257,'rma_creditclass','entryuserid',11,'Integer','','','',''),(4258,'rma_reason','id',11,'Integer','','','primary',''),(4259,'rma_reason','reason',50,'Text','','','',''),(4260,'rma_reason','gencompanyid',11,'Integer','','','',''),(4261,'rma_reason','cancel',5,'Integer','','','multiple',''),(4262,'rma_reason','canceluserid',11,'Integer','','','',''),(4263,'rma_reason','canceldate',19,'DateTime','','','',''),(4264,'rma_reason','entrydate',19,'DateTime','','','',''),(4265,'rma_reason','entryuserid',11,'Integer','','','',''),(4266,'salesman','commissionrate2',8,'Numeric','','','',''),(4267,'salesman','vendorid',11,'Integer','','','',''),(4268,'salestax','glacctid_taxpaid',11,'Integer','','','',''),(4269,'std_accounts','glquery',65535,'X','','','',''),(4270,'taxgroup','id',11,'Integer','','','primary',''),(4271,'taxgroup','groupcode',20,'Text','','','multiple',''),(4272,'taxgroup','createdate',19,'DateTime','','','',''),(4273,'taxgroup','gencompanyid',11,'Integer','','','',''),(4274,'taxgroup','createuserid',11,'Integer','','','',''),(4275,'taxgroup','cancel',5,'Integer','','','',''),(4276,'taxgroup','canceldate',19,'DateTime','','','',''),(4277,'taxgroup','canceluserid',11,'Integer','','','',''),(4278,'taxgroup','lastchangedate',19,'DateTime','','','',''),(4279,'taxgroup','lastchangeuserid',11,'Integer','','','',''),(4280,'territory','id',11,'Integer','','','primary',''),(4281,'territory','salesmanid',11,'Integer','','','multiple',''),(4282,'territory','state',5,'Text','','','multiple',''),(4283,'territory','zipcode_begin',12,'Text','','','multiple',''),(4284,'territory','zipcode_end',12,'Text','','','multiple',''),(4285,'territory','gencompanyid',11,'Integer','','','multiple',''),(4286,'territory_distribution','id',11,'Integer','','','primary',''),(4287,'territory_distribution','customerid',11,'Integer','','','multiple',''),(4288,'territory_distribution','commission_type',1,'Text','','','',''),(4289,'territory_distribution','salesmanid',11,'Integer','','','multiple',''),(4290,'territory_distribution','itemid',11,'Integer','','','',''),(4291,'territory_distribution','itemqty',14,'Numeric','','','',''),(4292,'territory_distribution','note',255,'Text','','','',''),(4293,'territory_distribution','sales_order',50,'Text','','','',''),(4294,'territory_distribution','amount',17,'Numeric','','','',''),(4295,'territory_distribution','zipcode',12,'Text','','','',''),(4296,'territory_distribution','commission_amount',17,'Numeric','','','',''),(4297,'territory_distribution','checkid',11,'Integer','','','multiple',''),(4298,'territory_distribution','import_date',10,'Date','','','',''),(4299,'territory_distribution','check_date',10,'Date','','','',''),(4300,'territory_distribution','import_userid',11,'Integer','','','',''),(4301,'territory_distribution','import_filename',255,'Text','','','',''),(4302,'territory_distribution','cancel',5,'Integer','','','multiple',''),(4303,'territory_distribution','canceldate',19,'DateTime','','','',''),(4304,'territory_distribution','canceluserid',11,'Integer','','','',''),(4305,'ups','id',11,'Integer','','','primary',''),(4306,'ups','shiptoid',50,'Text','','','multiple',''),(4307,'ups','orderid',50,'Text','','','multiple',''),(4308,'ups','rate',14,'Numeric','','','',''),(4309,'ups','shipdate',12,'Text','','','',''),(4310,'ups','tracknum',255,'Text','','','multiple',''),(4311,'ups','void',5,'Text','','','',''),(4312,'ups','posted',5,'Integer','','','',''),(4313,'ups','hundredweight',2,'Text','','','',''),(4314,'ups','billableweight',14,'Numeric','','','',''),(4315,'vendor','bankrouting',255,'Text','','','',''),(4316,'vendor','bankaccountnum',255,'Text','','','',''),(4317,'vendor','taxgroupid',11,'Integer','','','multiple',''),(4318,'vendor','vendorgroupid',11,'Integer','','','',''),(4319,'vendor_checkacct','id',11,'Integer','','','primary',''),(4320,'vendor_checkacct','vendorid',11,'Integer','','','multiple',''),(4321,'vendor_checkacct','checkacctid',11,'Integer','','','multiple',''),(4322,'vendor_checkacct','paystatus',5,'Integer','','','',''),(4323,'vendorsalestax','id',11,'Integer','','','primary',''),(4324,'vendorsalestax','vendorid',11,'Integer','','','multiple',''),(4325,'vendorsalestax','salestaxid',11,'Integer','','','multiple',''),(4326,'activation','id',11,'Integer','',NULL,'primary',NULL),(4327,'activation','email',255,'Text','',NULL,'',NULL),(4328,'activation','companyname',255,'Text','',NULL,'',NULL),(4329,'activation','servername',255,'Text','',NULL,'',NULL),(4330,'activation','ip',100,'Text','',NULL,'',NULL),(4331,'activation','platform',100,'Text','',NULL,'',NULL),(4332,'activation','act_att',11,'Integer','',NULL,'',NULL),(4333,'activation','osys',100,'Text','',NULL,'',NULL),(4334,'activation','businesstype',100,'Text','',NULL,'',NULL),(4335,'activation','phone',25,'Integer','',NULL,'',NULL),(4336,'activation','street',60,'Text','',NULL,'',NULL),(4337,'activation','city',60,'Text','',NULL,'',NULL),(4338,'activation','state',60,'Text','',NULL,'',NULL),(4339,'activation','country',60,'Text','',NULL,'',NULL),(4340,'activation','postal',25,'Text','',NULL,'',NULL),(4341,'addedit_control','id',11,'Integer','',NULL,'primary',NULL),(4342,'addedit_control','tablename',250,'Text','',NULL,'multiple',NULL),(4343,'addedit_control','fieldname',250,'Text','',NULL,'',NULL),(4344,'addedit_control','block',5,'Integer','',NULL,'multiple',NULL),(4345,'addedit_control','gencompanyid',11,'Integer','',NULL,'',NULL),(4346,'airport','vendorid',11,'Integer','',NULL,'multiple',NULL),(4347,'airport','pfname',255,'Text','',NULL,'',NULL),(4348,'airport','address1',100,'Text','',NULL,'',NULL),(4349,'airport','address2',100,'Text','',NULL,'',NULL),(4350,'airport','city',100,'Text','',NULL,'',NULL),(4351,'airport','state',2,'Text','',NULL,'',NULL),(4352,'airport','zip',10,'Text','',NULL,'',NULL),(4353,'airport','description',65535,'X','',NULL,'',NULL),(4354,'airport','chargefullfee',11,'Integer','',NULL,'',NULL),(4355,'airport','chargeparkingfee',11,'Integer','',NULL,'',NULL),(4356,'airport','chargeairportfee',11,'Integer','',NULL,'',NULL),(4357,'airport','chargefuelfee',11,'Integer','',NULL,'',NULL),(4358,'airport','chargesalestax',11,'Integer','',NULL,'',NULL),(4359,'airport','ta_commission_flat',14,'Numeric','',NULL,'',NULL),(4360,'airport','ta_commission_percent',14,'Numeric','',NULL,'',NULL),(4361,'airport','commission_flat',14,'Numeric','',NULL,'',NULL),(4362,'airport','commission_percent',14,'Numeric','',NULL,'',NULL),(4363,'airport','airport_fee_flat',14,'Numeric','',NULL,'',NULL),(4364,'airport','airport_fee_percent',14,'Numeric','',NULL,'',NULL),(4365,'airport','fuel_charge_flat',14,'Numeric','',NULL,'',NULL),(4366,'airport','salestaxid',11,'Integer','',NULL,'',NULL),(4367,'airport','email',255,'Text','',NULL,'',NULL),(4368,'airport_order','fuel_charge',14,'Numeric','',NULL,'',NULL),(4369,'airport_order','service_fee',14,'Numeric','',NULL,'',NULL),(4370,'airport_order','airport_fee',14,'Numeric','',NULL,'',NULL),(4371,'airport_order','salestax',14,'Numeric','',NULL,'',NULL),(4372,'airport_order','salestaxid',11,'Integer','',NULL,'',NULL),(4373,'airport_order','grand_total',14,'Numeric','',NULL,'',NULL),(4374,'airport_order','reservation_fee',14,'Numeric','',NULL,'',NULL),(4375,'airport_order','invoiceid',11,'Integer','',NULL,'',NULL),(4376,'airport_order','parking_type',1,'Text','',NULL,'',NULL),(4377,'airport_parking','price_self_park',12,'Numeric','',NULL,'',NULL),(4378,'apbill','ccpurchase',5,'Integer','',NULL,'',NULL),(4379,'apcompany','noshowsell_onpo',5,'Integer','',NULL,'',NULL),(4380,'apcompany','sellqtyonly_poentry',5,'Integer','',NULL,'',NULL),(4381,'apcompany','default_checkacctid',11,'Integer','',NULL,'',NULL),(4382,'apcompany','noboxes_on_po',5,'Integer','',NULL,'',NULL),(4383,'apcompany','podate',5,'Integer','',NULL,'',NULL),(4384,'apcompany','suppress_linenum_po',5,'Integer','',NULL,'',NULL),(4385,'apilog','id',10,'Integer','',NULL,'primary',NULL),(4386,'apilog','userid',11,'Integer','',NULL,'',NULL),(4387,'apilog','companyid',11,'Integer','',NULL,'',NULL),(4388,'apilog','action',255,'Text','',NULL,'',NULL),(4389,'apilog','entrydate',19,'DateTime','',NULL,'',NULL),(4390,'apilog','data_in',65535,'X','',NULL,'',NULL),(4391,'apilog','data_out',-1,'X','',NULL,'',NULL),(4392,'apilog','remoteip',15,'Text','',NULL,'',NULL),(4393,'arcompany','default_invoicetermsid',11,'Integer','',NULL,'',NULL),(4394,'arcompany','b2b_allow_signup',11,'Integer','',NULL,'',NULL),(4395,'arcompany','default_customergroupid',11,'Integer','',NULL,'',NULL),(4396,'arcompany','default_b2b_admin_email',255,'Text','',NULL,'',NULL),(4397,'arcompany','invoicecalc',5,'Integer','',NULL,'',NULL),(4398,'arcompany','current_or_order',5,'Integer','',NULL,'',NULL),(4399,'arcompany','default_checkacctid',11,'Integer','',NULL,'',NULL),(4400,'arcompany','nobarcode_on_invoice',5,'Integer','',NULL,'',NULL),(4401,'arcompany','picklist_blockheader',5,'Integer','',NULL,'',NULL),(4402,'arcompany','picklist_blockbarcode',5,'Integer','',NULL,'',NULL),(4403,'arcompany','picklist_sortorder',5,'Integer','',NULL,'',NULL),(4404,'arcompany','pickliststyle',5,'Integer','',NULL,'',NULL),(4405,'arcompany','noboxes_on_invoice',5,'Integer','',NULL,'',NULL),(4406,'arcompany','comparison_levelid',11,'Integer','',NULL,'',NULL),(4407,'arcompany','statement_no_prior_balance',5,'Integer','',NULL,'',NULL),(4408,'arcompany','statement_no_interest_added',5,'Integer','',NULL,'',NULL),(4409,'arcompany','ardate',5,'Integer','',NULL,'',NULL),(4410,'arcompany','noteatbottom',5,'Integer','',NULL,'',NULL),(4411,'arcompany','internal_serviceorder',5,'Integer','',NULL,'',NULL),(4412,'arcompany','internal_fulfillmentorder',5,'Integer','',NULL,'',NULL),(4413,'arcompany','invoicenumber_override',5,'Integer','',NULL,'',NULL),(4414,'arinvoice','client_po',30,'Text','',NULL,'',NULL),(4415,'arinvoicedetail','pricelevelid',11,'Integer','',NULL,'',NULL),(4416,'arinvoicepaymentdetail','refund_paymeth',11,'Integer','',NULL,'',NULL),(4417,'arinvoicepaymentdetail','cctransactionid',11,'Integer','',NULL,'',NULL),(4418,'arinvoicetaxdetail','taxcap',21,'Numeric','',NULL,'',NULL),(4419,'arorder','carrierserviceid_preferred',11,'Integer','',NULL,'',NULL),(4420,'arorder','finalship',5,'Integer','',NULL,'',NULL),(4421,'arorder_deposit','checkid',20,'Text','',NULL,'',NULL),(4422,'arorder_deposit','bankstatement_enddate',10,'Date','',NULL,'',NULL),(4423,'arorder_deposit','checkacctid',11,'Integer','',NULL,'',NULL),(4424,'arorderdetail','pricelevelid',11,'Integer','',NULL,'',NULL),(4425,'arordership','cancel',5,'Integer','',NULL,'multiple',NULL),(4426,'arordership','canceldate',10,'Date','',NULL,'',NULL),(4427,'arordership','canceluserid',11,'Integer','',NULL,'',NULL),(4428,'arordershippackage','cancel',5,'Integer','',NULL,'multiple',NULL),(4429,'arordershippackage','canceldate',10,'Date','',NULL,'',NULL),(4430,'arordershippackage','canceluserid',11,'Integer','',NULL,'',NULL),(4431,'arordertax','taxcap',21,'Numeric','',NULL,'',NULL),(4432,'arserviceorder_prepaid_time','id',11,'Integer','',NULL,'primary',NULL),(4433,'arserviceorder_prepaid_time','hours',14,'Numeric','',NULL,'',NULL),(4434,'arserviceorder_prepaid_time','hours_used',14,'Numeric','',NULL,'',NULL),(4435,'arserviceorder_prepaid_time','complete',5,'Integer','',NULL,'',NULL),(4436,'arserviceorder_prepaid_time','worktypeid',11,'Integer','',NULL,'multiple',NULL),(4437,'arserviceorder_prepaid_time','orderid',11,'Integer','',NULL,'multiple',NULL),(4438,'arserviceorder_prepaid_time','rate_per_hour',18,'Numeric','',NULL,'',NULL),(4439,'arserviceorder_prepaid_time','total_price',18,'Numeric','',NULL,'',NULL),(4440,'arserviceorder_prepaid_time','entrydate',10,'Date','',NULL,'',NULL),(4441,'arserviceorder_prepaid_time','entryuserid',11,'Integer','',NULL,'',NULL),(4442,'arserviceorder_prepaid_time','lastchangedate',19,'DateTime','',NULL,'',NULL),(4443,'arserviceorder_prepaid_time','lastchangeuserid',11,'Integer','',NULL,'',NULL),(4444,'arserviceorder_prepaid_time','cancel',5,'Integer','',NULL,'multiple',NULL),(4445,'arserviceorder_prepaid_time','canceluserid',11,'Integer','',NULL,'',NULL),(4446,'arserviceorder_prepaid_time','workclassid',11,'Integer','',NULL,'',NULL),(4447,'bankaccount','prtype',5,'Integer','',NULL,'multiple',NULL),(4448,'bankaccount','recordid',11,'Integer','',NULL,'multiple',NULL),(4449,'bankaccount','show_employeename',5,'Integer','',NULL,'',NULL),(4450,'bankaccount','show_ss',5,'Integer','',NULL,'',NULL),(4451,'bankaccount','show_dates',5,'Integer','',NULL,'',NULL),(4452,'bankaccount','show_employer',5,'Integer','',NULL,'',NULL),(4453,'bankaccount','include_contribution',5,'Integer','',NULL,'',NULL),(4454,'bankaccount','summary_deposit',5,'Integer','',NULL,'',NULL),(4455,'bankaccount','show_other',255,'Text','',NULL,'',NULL),(4456,'bankaccount','dd_or_check',5,'Integer','',NULL,'',NULL),(4457,'bankdeposit','voucherid',11,'Integer','',NULL,'',NULL),(4458,'carrierservice','not_on_b2b',5,'Integer','',NULL,'',NULL),(4459,'carrierservice','onquote',5,'Integer','',NULL,'',NULL),(4460,'cashpayment','checkacctid',11,'Integer','',NULL,'',NULL),(4461,'ccaccount','checkacctid',11,'Integer','',NULL,'',NULL),(4462,'ccpurchase','id',11,'Integer','',NULL,'primary',NULL),(4463,'ccpurchase','ccvendorid',11,'Integer','',NULL,'multiple',NULL),(4464,'ccpurchase','purchasedate',10,'Date','',NULL,'multiple',NULL),(4465,'ccpurchase','who',100,'Text','',NULL,'',NULL),(4466,'ccpurchase','amount',21,'Numeric','',NULL,'',NULL),(4467,'ccpurchase','purpose',250,'Text','',NULL,'',NULL),(4468,'ccpurchase','apbillid',11,'Integer','',NULL,'',NULL),(4469,'ccpurchase','cancel',5,'Integer','',NULL,'multiple',NULL),(4470,'ccpurchase','canceluserid',11,'Integer','',NULL,'',NULL),(4471,'ccpurchase','canceldate',19,'DateTime','',NULL,'',NULL),(4472,'ccpurchase','lastupdatedate',19,'DateTime','',NULL,'',NULL),(4473,'ccpurchase','lastupdateuserid',11,'Integer','',NULL,'',NULL),(4474,'ccpurchase','purchasefrom',100,'Text','',NULL,'',NULL),(4475,'ccpurchase','invpoid',11,'Integer','',NULL,'',NULL),(4476,'ccpurchase_detail','id',11,'Integer','',NULL,'primary',NULL),(4477,'ccpurchase_detail','ccpurchaseid',11,'Integer','',NULL,'multiple',NULL),(4478,'ccpurchase_detail','glaccountid',11,'Integer','',NULL,'',NULL),(4479,'ccpurchase_detail','chargetype',5,'Integer','',NULL,'',NULL),(4480,'ccpurchase_detail','voucherid',11,'Integer','',NULL,'',NULL),(4481,'ccpurchase_detail','amount',21,'Numeric','',NULL,'',NULL),(4482,'ccpurchase_detail','cancel',5,'Integer','',NULL,'multiple',NULL),(4483,'ccpurchase_detail','canceldate',10,'Date','',NULL,'',NULL),(4484,'ccpurchase_detail','canceluserid',11,'Integer','',NULL,'',NULL),(4485,'ccpurchase_detail','glcontraid',11,'Integer','',NULL,'',NULL),(4486,'ccpurchase_gen','id',11,'Integer','',NULL,'primary',NULL),(4487,'ccpurchase_gen','useforpo',5,'Integer','',NULL,'',NULL),(4488,'ccpurchase_gen','freight_chargetype',11,'Integer','',NULL,'',NULL),(4489,'ccpurchase_gen','tax_chargetype',11,'Integer','',NULL,'',NULL),(4490,'ccpurchase_gen','default_po_chargetype',11,'Integer','',NULL,'',NULL),(4491,'ccpurchase_type','id',11,'Integer','',NULL,'primary',NULL),(4492,'ccpurchase_type','glaccountid',11,'Integer','',NULL,'multiple',NULL),(4493,'ccpurchase_type','gencompanyid',11,'Integer','',NULL,'',NULL),(4494,'ccpurchase_type','description',250,'Text','',NULL,'',NULL),(4495,'ccpurchase_type','cancel',5,'Integer','',NULL,'multiple',NULL),(4496,'ccpurchase_type','canceluserid',11,'Integer','',NULL,'',NULL),(4497,'ccpurchase_type','canceldate',19,'DateTime','',NULL,'',NULL),(4498,'ccpurchase_type','lastupdatedate',19,'DateTime','',NULL,'',NULL),(4499,'ccpurchase_type','lastupdateuserid',11,'Integer','',NULL,'',NULL),(4500,'ccpurchase_type','salestaxid',11,'Integer','',NULL,'',NULL),(4501,'ccpurchase_type','glcontraid',11,'Integer','',NULL,'',NULL),(4502,'ccvendor','id',11,'Integer','',NULL,'primary',NULL),(4503,'ccvendor','vendorid',11,'Integer','',NULL,'multiple',NULL),(4504,'ccvendor','ccname',250,'Text','',NULL,'',NULL),(4505,'ccvendor','cancel',5,'Integer','',NULL,'multiple',NULL),(4506,'ccvendor','canceluserid',11,'Integer','',NULL,'',NULL),(4507,'ccvendor','canceldate',19,'DateTime','',NULL,'',NULL),(4508,'ccvendor','lastupdatedate',19,'DateTime','',NULL,'',NULL),(4509,'ccvendor','lastupdateuserid',11,'Integer','',NULL,'',NULL),(4510,'chk','maincheckid',11,'Integer','',NULL,'multiple',NULL),(4511,'customer','salescategoryid',11,'Integer','',NULL,'',NULL),(4512,'customer','weather_cf',1,'Text','',NULL,'',NULL),(4513,'customer','weather_zip',20,'Text','',NULL,'',NULL),(4514,'customer','time_zone',6,'Text','',NULL,'',NULL),(4515,'customer','salutation',20,'Text','',NULL,'',NULL),(4516,'customer','middle_name',50,'Text','',NULL,'',NULL),(4517,'customer','name_suffix',20,'Text','',NULL,'',NULL),(4518,'estquotebinderyaddl','printdays',11,'Integer','',NULL,'',NULL),(4519,'estquotepriceliststock','qtyperbox',11,'Integer','',NULL,'',NULL),(4520,'estquotequote','printdate',10,'Date','',NULL,'',NULL),(4521,'estquotequote','calculated_qty',14,'Numeric','',NULL,'',NULL),(4522,'estquotequote','sell_total',14,'Numeric','',NULL,'',NULL),(4523,'estquotequote','calculated_total',16,'Numeric','',NULL,'',NULL),(4524,'estquotequote','previous_id_printorder',11,'Integer','',NULL,'',NULL),(4525,'estquotequote','client_notes',65535,'X','',NULL,'',NULL),(4526,'estquotequoteqty','printdays',11,'Integer','',NULL,'',NULL),(4527,'estquoteship','shipper_number',30,'Text','',NULL,'',NULL),(4528,'estquoteship','billto',20,'Text','',NULL,'',NULL),(4529,'event','id',10,'Integer','',NULL,'primary',NULL),(4530,'event','module',10,'Text','',NULL,'multiple',NULL),(4531,'event','section',50,'Text','',NULL,'multiple',NULL),(4532,'event','action',50,'Text','',NULL,'multiple',NULL),(4533,'event','link',255,'Text','',NULL,'',NULL),(4534,'eventlog','id',10,'Integer','',NULL,'primary',NULL),(4535,'eventlog','companyid',11,'Integer','',NULL,'multiple',NULL),(4536,'eventlog','userid',11,'Integer','',NULL,'multiple',NULL),(4537,'eventlog','extuserid',11,'Integer','',NULL,'multiple',NULL),(4538,'eventlog','module',10,'Text','',NULL,'multiple',NULL),(4539,'eventlog','section',50,'Text','',NULL,'multiple',NULL),(4540,'eventlog','action',50,'Text','',NULL,'multiple',NULL),(4541,'eventlog','eventtable',100,'Text','',NULL,'multiple',NULL),(4542,'eventlog','eventid',10,'Integer','',NULL,'multiple',NULL),(4543,'eventlog','data',65535,'X','',NULL,'',NULL),(4544,'eventlog','entrydate',19,'DateTime','',NULL,'multiple',NULL),(4545,'eventlog','ip',20,'Text','',NULL,'',NULL),(4546,'family','workarea_order',11,'Integer','',NULL,'',NULL),(4547,'family','scrapperplate',11,'Integer','',NULL,'',NULL),(4548,'family','scrappercent',22,'Numeric','',NULL,'',NULL),(4549,'family','minimum_charge',14,'Numeric','',NULL,'',NULL),(4550,'feature','id',10,'Integer','',NULL,'primary',NULL),(4551,'feature','name',45,'Text','',NULL,'',NULL),(4552,'feature','description_short',100,'Text','',NULL,'',NULL),(4553,'feature','description',255,'Text','',NULL,'',NULL),(4554,'feature','display',11,'Integer','',NULL,'',NULL),(4555,'feature','ecomid',11,'Integer','',NULL,'',NULL),(4556,'feature','version',25,'Text','',NULL,'',NULL),(4557,'feature_activation','id',10,'Integer','',NULL,'primary',NULL),(4558,'feature_activation','featureid',10,'Integer','',NULL,'multiple',NULL),(4559,'feature_activation','serial_number',50,'Text','',NULL,'',NULL),(4560,'feature_activation','entrydate',19,'DateTime','',NULL,'',NULL),(4561,'feature_activation','code',50,'Text','',NULL,'',NULL),(4562,'fileitem','b2buserid',11,'Integer','',NULL,'multiple',NULL),(4563,'flexfield','id',10,'Integer','',NULL,'primary',NULL),(4564,'flexfield','tablename',100,'Text','',NULL,'multiple',NULL),(4565,'flexfield','displayname',100,'Text','',NULL,'',NULL),(4566,'flexfield','fieldtype',1,'Text','',NULL,'',NULL),(4567,'flexfield','sortorder',10,'Integer','',NULL,'',NULL),(4568,'flexfield','internalname',100,'Text','',NULL,'multiple',NULL),(4569,'flexfield','defaultvalue',255,'Text','',NULL,'',NULL),(4570,'flexfield','companyid',11,'Integer','',NULL,'',NULL),(4571,'flexfield','readonly',5,'Integer','',NULL,'',NULL),(4572,'flexfield','donotimport',5,'Integer','',NULL,'',NULL),(4573,'flexoption','id',10,'Integer','',NULL,'primary',NULL),(4574,'flexoption','flexfieldid',10,'Integer','',NULL,'multiple',NULL),(4575,'flexoption','name',100,'Text','',NULL,'',NULL),(4576,'flexoption','value',255,'Text','',NULL,'',NULL),(4577,'flexoption','sortorder',10,'Integer','',NULL,'',NULL),(4578,'flextable','id',10,'Integer','',NULL,'primary',NULL),(4579,'flextable','name',100,'Text','',NULL,'',NULL),(4580,'flextable','tablename',100,'Text','',NULL,'',NULL),(4581,'flexvalue','id',10,'Integer','',NULL,'primary',NULL),(4582,'flexvalue','flexfieldid',10,'Integer','',NULL,'multiple',NULL),(4583,'flexvalue','recordid',10,'Integer','',NULL,'multiple',NULL),(4584,'flexvalue','value',255,'Text','',NULL,'',NULL),(4585,'four51trans','id',10,'Integer','',NULL,'primary',NULL),(4586,'four51trans','xmlrequest',65535,'X','',NULL,'',NULL),(4587,'four51trans','xmlresponse',65535,'X','',NULL,'',NULL),(4588,'four51trans','entrydate',19,'DateTime','',NULL,'',NULL),(4589,'four51trans','status',11,'Integer','',NULL,'',NULL),(4590,'four51trans','orderid',11,'Integer','',NULL,'multiple',NULL),(4591,'four51trans','customerid',11,'Integer','',NULL,'multiple',NULL),(4592,'four51trans','transtype',1,'Text','',NULL,'',NULL),(4593,'four51trans','responsetext',255,'Text','',NULL,'',NULL),(4594,'gencompany','ar_email',50,'Text','',NULL,'',NULL),(4595,'gencompany','order_email',50,'Text','',NULL,'',NULL),(4596,'gencompany','ap_email',50,'Text','',NULL,'',NULL),(4597,'gencompany','businesstype',100,'Text','',NULL,'',NULL),(4598,'gencompany','print_only_orders',5,'Integer','',NULL,'',NULL),(4599,'gencompany','arship_shortform',5,'Integer','',NULL,'',NULL),(4600,'genprint','extrafield1_desc',255,'Text','',NULL,'',NULL),(4601,'genprint','extrafield2_desc',255,'Text','',NULL,'',NULL),(4602,'genprint','extrafield3_desc',255,'Text','',NULL,'',NULL),(4603,'genprint','extrafield4_desc',255,'Text','',NULL,'',NULL),(4604,'genprint','jobticket_notes',65535,'X','',NULL,'',NULL),(4605,'genprint','askink',5,'Integer','',NULL,'',NULL),(4606,'genprint','whichinvoicedate',5,'Integer','',NULL,'',NULL),(4607,'genuser','weather_cf',1,'Text','',NULL,'',NULL),(4608,'genuser','menu_style',5,'Integer','',NULL,'',NULL),(4609,'genuser','iconset',10,'Text','',NULL,'',NULL),(4610,'genuser','apikey',50,'Text','',NULL,'',NULL),(4611,'genuser','timeclock_only',5,'Integer','',NULL,'',NULL),(4612,'genuser','ipfilter',255,'Text','',NULL,'',NULL),(4613,'genuser','splashdate',19,'DateTime','',NULL,'',NULL),(4614,'genuser','defaulthomepage',30,'Text','',NULL,'',NULL),(4615,'genusercompany','edit_messages',5,'Integer','',NULL,'',NULL),(4616,'genusercompany','pos_only',11,'Integer','',NULL,'',NULL),(4617,'glaccount','old_id',20,'Text','',NULL,'',NULL),(4618,'hints','id',11,'Integer','',NULL,'primary',NULL),(4619,'hints','notes',65535,'X','',NULL,'',NULL),(4620,'hints','question',255,'Text','',NULL,'',NULL),(4621,'invcompany','costmethod',1,'Text','',NULL,'',NULL),(4622,'invcompany','inventoryvariance',11,'Integer','',NULL,'',NULL),(4623,'invcompany','addglatpo',11,'Integer','',NULL,'',NULL),(4624,'invcompany','distributetaxfreight',11,'Integer','',NULL,'',NULL),(4625,'invcompany','breakdown_scrap',5,'Integer','',NULL,'',NULL),(4626,'invcompany','costadjustglacctid',11,'Integer','',NULL,'',NULL),(4627,'invintercompany','id',11,'Integer','',NULL,'primary',NULL),(4628,'invintercompany','sourcecompanyid',11,'Integer','',NULL,'multiple',NULL),(4629,'invintercompany','othercompanyid',11,'Integer','',NULL,'multiple',NULL),(4630,'invintercompany','customerid',11,'Integer','',NULL,'',NULL),(4631,'invintercompany','vendorid',11,'Integer','',NULL,'',NULL),(4632,'invintercompany','pricelevelid',11,'Integer','',NULL,'',NULL),(4633,'invpo','paytermsid',11,'Integer','',NULL,'',NULL),(4634,'invpo','ccpurchaseid',11,'Integer','',NULL,'multiple',NULL),(4635,'invpodetail','notes',500,'Text','',NULL,'',NULL),(4636,'item','scart_front_page',11,'Integer','',NULL,'',NULL),(4637,'item','caliper',12,'Numeric','',NULL,'',NULL),(4638,'item','upc',255,'Text','',NULL,'',NULL),(4639,'item','author',100,'Text','',NULL,'',NULL),(4640,'item','notes',65535,'X','',NULL,'',NULL),(4641,'itemlocation','wacost',21,'Numeric','',NULL,'',NULL),(4642,'itemlocation','waqty',22,'Numeric','',NULL,'',NULL),(4643,'itemlocation','bin_shelf',50,'Text','',NULL,'',NULL),(4644,'lang','custom',2,'Integer','',NULL,'',NULL),(4645,'lang','ar',255,'Text','',NULL,'',NULL),(4646,'lang','ms',255,'Text','',NULL,'',NULL),(4647,'lang','hi',255,'Text','',NULL,'',NULL),(4648,'lang','th',255,'Text','',NULL,'',NULL),(4649,'lang','tl',255,'Text','',NULL,'',NULL),(4650,'lang','it',255,'Text','',NULL,'',NULL),(4651,'lang','sv',255,'Text','',NULL,'',NULL),(4652,'lang','zh',255,'Text','',NULL,'',NULL),(4653,'lang','el',255,'Text','',NULL,'',NULL),(4654,'lang','he',255,'Text','',NULL,'',NULL),(4655,'lang','ko',255,'Text','',NULL,'',NULL),(4656,'lang','da',255,'Text','',NULL,'',NULL),(4657,'lang','no',255,'Text','',NULL,'',NULL),(4658,'lang','fi',255,'Text','',NULL,'',NULL),(4659,'lang','nl',255,'Text','',NULL,'',NULL),(4660,'lang','ba',255,'Text','',NULL,'',NULL),(4661,'lang','si',255,'Text','',NULL,'',NULL),(4662,'langfield','pt',65535,'X','',NULL,'',NULL),(4663,'langfield','fr',65535,'X','',NULL,'',NULL),(4664,'langfield','zh',65535,'X','',NULL,'',NULL),(4665,'langfield','ar',65535,'X','',NULL,'',NULL),(4666,'langfield','ms',65535,'X','',NULL,'',NULL),(4667,'langfield','hi',65535,'X','',NULL,'',NULL),(4668,'langfield','th',65535,'X','',NULL,'',NULL),(4669,'langfield','tl',65535,'X','',NULL,'',NULL),(4670,'langfield','it',65535,'X','',NULL,'',NULL),(4671,'langfield','sv',65535,'X','',NULL,'',NULL),(4672,'langfield','el',65535,'X','',NULL,'',NULL),(4673,'langfield','he',65535,'X','',NULL,'',NULL),(4674,'langfield','ko',65535,'X','',NULL,'',NULL),(4675,'langfield','da',65535,'X','',NULL,'',NULL),(4676,'langfield','no',65535,'X','',NULL,'',NULL),(4677,'langfield','fi',65535,'X','',NULL,'',NULL),(4678,'langfield','nl',65535,'X','',NULL,'',NULL),(4679,'langfield','ba',65535,'X','',NULL,'',NULL),(4680,'langfield','si',65535,'X','',NULL,'',NULL),(4681,'menudata','gencompanyid',11,'Integer','',NULL,'',NULL),(4682,'menudata','groupname',15,'Text','',NULL,'',NULL),(4683,'menudataxp','id',11,'Integer','',NULL,'primary',NULL),(4684,'menudataxp','menu_name',100,'Text','',NULL,'',NULL),(4685,'menudataxp','id_menudata',11,'Integer','',NULL,'',NULL),(4686,'menudataxp','orderflag',5,'Integer','',NULL,'',NULL),(4687,'menudataxp','menu_action',2,'Integer','',NULL,'',NULL),(4688,'menudataxp','description',250,'Text','',NULL,'',NULL),(4689,'menudataxp','accessap',2,'Integer','',NULL,'',NULL),(4690,'menudataxp','accessar',2,'Integer','',NULL,'',NULL),(4691,'menudataxp','accessgl',2,'Integer','',NULL,'',NULL),(4692,'menudataxp','accesspay',2,'Integer','',NULL,'',NULL),(4693,'menudataxp','accessinv',2,'Integer','',NULL,'',NULL),(4694,'menudataxp','accessest',2,'Integer','',NULL,'',NULL),(4695,'menudataxp','accessfix',2,'Integer','',NULL,'',NULL),(4696,'menudataxp','accessimp',2,'Integer','',NULL,'',NULL),(4697,'menudataxp','accesssc',2,'Integer','',NULL,'',NULL),(4698,'menudataxp','setupap',2,'Integer','',NULL,'',NULL),(4699,'menudataxp','setupar',2,'Integer','',NULL,'',NULL),(4700,'menudataxp','setupgl',2,'Integer','',NULL,'',NULL),(4701,'menudataxp','setuppay',2,'Integer','',NULL,'',NULL),(4702,'menudataxp','setupinv',2,'Integer','',NULL,'',NULL),(4703,'menudataxp','setupest',2,'Integer','',NULL,'',NULL),(4704,'menudataxp','setupfix',2,'Integer','',NULL,'',NULL),(4705,'menudataxp','setupimp',2,'Integer','',NULL,'',NULL),(4706,'menudataxp','setupsc',2,'Integer','',NULL,'',NULL),(4707,'menudataxp','supervisor',2,'Integer','',NULL,'',NULL),(4708,'menudataxp','extvend',2,'Integer','',NULL,'',NULL),(4709,'menudataxp','extcust',2,'Integer','',NULL,'',NULL),(4710,'menudataxp','nonext',2,'Integer','',NULL,'',NULL),(4711,'menudataxp','menu_link',255,'Text','',NULL,'',NULL),(4712,'menudataxp','linktype',11,'Text','',NULL,'',NULL),(4713,'menudataxp','plaintext',11,'Text','',NULL,'',NULL),(4714,'menudataxp','languageid',2,'Integer','',NULL,'',NULL),(4715,'menudataxp','icon',255,'Text','',NULL,'',NULL),(4716,'menudataxp','gencompanyid',11,'Integer','',NULL,'',NULL),(4717,'menudataxp','groupname',15,'Text','',NULL,'',NULL),(4718,'message','messageid',11,'Integer','',NULL,'primary',NULL),(4719,'message','createuserid',11,'Integer','',NULL,'',NULL),(4720,'message','userid',11,'Integer','',NULL,'',NULL),(4721,'message','createdate',19,'DateTime','',NULL,'',NULL),(4722,'message','title',100,'Text','',NULL,'',NULL),(4723,'message','message',65535,'X','',NULL,'',NULL),(4724,'message','homepage',5,'Integer','',NULL,'',NULL),(4725,'message','fontcolor',25,'Text','',NULL,'',NULL),(4726,'message','graphicid',11,'Integer','',NULL,'',NULL),(4727,'message','startdate',19,'DateTime','',NULL,'',NULL),(4728,'message','enddate',19,'DateTime','',NULL,'',NULL),(4729,'message','cancel',5,'Integer','',NULL,'multiple',NULL),(4730,'message','canceluserid',11,'Integer','',NULL,'',NULL),(4731,'message','banner_interval',25,'Text','',NULL,'',NULL),(4732,'message','gencompanyid',11,'Integer','',NULL,'multiple',NULL),(4733,'message_graphic','id',11,'Integer','',NULL,'primary',NULL),(4734,'message_graphic','name',100,'Text','',NULL,'',NULL),(4735,'message_graphic','graphiccategoryid',11,'Integer','',NULL,'',NULL),(4736,'message_graphic','gencompanyid',11,'Integer','',NULL,'multiple',NULL),(4737,'message_graphic','description',100,'Text','',NULL,'',NULL),(4738,'message_graphic','cancel',5,'Integer','',NULL,'',NULL),(4739,'message_graphic','createdate',19,'DateTime','',NULL,'',NULL),(4740,'message_graphic','userid',11,'Integer','',NULL,'',NULL),(4741,'message_graphiccategory','id',11,'Integer','',NULL,'primary',NULL),(4742,'message_graphiccategory','name',100,'Text','',NULL,'',NULL),(4743,'message_graphiccategory','description',100,'Text','',NULL,'',NULL),(4744,'message_graphiccategory','gencompanyid',11,'Integer','',NULL,'multiple',NULL),(4745,'message_graphiccategory','cancel',5,'Integer','',NULL,'multiple',NULL),(4746,'note','id',11,'Integer','',NULL,'primary',NULL),(4747,'note','notetypeid',11,'Integer','',NULL,'multiple',NULL),(4748,'note','recordid',11,'Integer','',NULL,'multiple',NULL),(4749,'note','note',65535,'X','',NULL,'',NULL),(4750,'note','companyid',11,'Integer','',NULL,'multiple',NULL),(4751,'note','entrydate',19,'DateTime','',NULL,'',NULL),(4752,'note','entryuserid',11,'Integer','',NULL,'multiple',NULL),(4753,'note','cancel',11,'Integer','',NULL,'',NULL),(4754,'note','canceldate',19,'DateTime','',NULL,'',NULL),(4755,'note','canceluserid',11,'Integer','',NULL,'',NULL),(4756,'notetype','id',11,'Integer','',NULL,'primary',NULL),(4757,'notetype','code',100,'Text','',NULL,' unique',NULL),(4758,'notetype','title',255,'Text','',NULL,'',NULL),(4759,'notetype','description',65535,'X','',NULL,'',NULL),(4760,'notetype','modaccess',150,'Text','',NULL,'',NULL),(4761,'notetype','modbit',20,'Text','',NULL,'',NULL),(4762,'npdb','id',10,'Integer','',NULL,'primary',NULL),(4763,'npdb','name',150,'Text','',NULL,'',NULL),(4764,'npdb','dbname',50,'Text','',NULL,'',NULL),(4765,'npdb','domainname',255,'Text','',NULL,'',NULL),(4766,'npdb','entrydate',19,'DateTime','',NULL,'',NULL),(4767,'npdb','serialnumber',45,'Text','',NULL,'',NULL),(4768,'npdb','codenumber',45,'Text','',NULL,'',NULL),(4769,'npdb','cancel',11,'Integer','',NULL,'',NULL),(4770,'npdb','canceldate',19,'DateTime','',NULL,'',NULL),(4771,'npdb','masterlicense',16,'Text','',NULL,'',NULL),(4772,'order_actual','invoiceid',11,'Integer','',NULL,'',NULL),(4773,'order_partnr','caliper',12,'Numeric','',NULL,'',NULL),(4774,'order_partnr','order_date',10,'Date','',NULL,'',NULL),(4775,'order_partnr','order_by',11,'Integer','',NULL,'',NULL),(4776,'order_partnr','receive_date',10,'Date','',NULL,'',NULL),(4777,'order_partnr','received_by',11,'Integer','',NULL,'',NULL),(4778,'order_shipment','invoiceid',11,'Integer','',NULL,'',NULL),(4779,'personal_message','id',11,'Integer','',NULL,'primary',NULL),(4780,'personal_message','messageid',11,'Integer','',NULL,'',NULL),(4781,'personal_message','userid',11,'Integer','',NULL,'multiple',NULL),(4782,'personal_message','receiveddate',19,'DateTime','',NULL,'',NULL),(4783,'personal_message','received',5,'Integer','',NULL,'',NULL),(4784,'personal_message','gencompanyid',11,'Integer','',NULL,'',NULL),(4785,'personal_message','cancel',5,'Integer','',NULL,'multiple',NULL),(4786,'piecework_addlrates','id',11,'Integer','',NULL,'primary unique',NULL),(4787,'piecework_addlrates','piecework_functionid',11,'Integer','',NULL,'multiple',NULL),(4788,'piecework_addlrates','piecework_function_detailid',11,'Integer','',NULL,'multiple',NULL),(4789,'piecework_addlrates','rate',17,'Numeric','',NULL,'',NULL),(4790,'piecework_addlrates','sortorder',11,'Integer','',NULL,'',NULL),(4791,'piecework_areas','id',11,'Integer','',NULL,'primary',NULL),(4792,'piecework_areas','name',50,'Text','',NULL,'',NULL),(4793,'piecework_areas','gencompanyid',11,'Integer','',NULL,'multiple',NULL),(4794,'piecework_areas','cancel',5,'Integer','',NULL,'multiple',NULL),(4795,'piecework_areas','canceldate',19,'DateTime','',NULL,'',NULL),(4796,'piecework_areas','canceluserid',11,'Integer','',NULL,'',NULL),(4797,'piecework_areas','entrydate',19,'DateTime','',NULL,'',NULL),(4798,'piecework_areas','entryuserid',11,'Integer','',NULL,'',NULL),(4799,'piecework_areas','lastchangedate',19,'DateTime','',NULL,'',NULL),(4800,'piecework_areas','lastchangeuserid',11,'Integer','',NULL,'',NULL),(4801,'piecework_areas','sortorder',5,'Integer','',NULL,'',NULL),(4802,'piecework_function_detail','id',11,'Integer','',NULL,'primary',NULL),(4803,'piecework_function_detail','id_piecework_functions',11,'Integer','',NULL,'multiple',NULL),(4804,'piecework_function_detail','entrytype',2,'Integer','',NULL,'',NULL),(4805,'piecework_function_detail','rate',17,'Numeric','',NULL,'',NULL),(4806,'piecework_function_detail','minimum',17,'Numeric','',NULL,'',NULL),(4807,'piecework_function_detail','cancel',5,'Integer','',NULL,'multiple',NULL),(4808,'piecework_function_detail','canceldate',19,'DateTime','',NULL,'',NULL),(4809,'piecework_function_detail','canceluserid',11,'Integer','',NULL,'',NULL),(4810,'piecework_function_detail','entrydate',19,'DateTime','',NULL,'',NULL),(4811,'piecework_function_detail','entryuserid',11,'Integer','',NULL,'',NULL),(4812,'piecework_function_detail','lastchangedate',19,'DateTime','',NULL,'',NULL),(4813,'piecework_function_detail','lastchangeuserid',11,'Integer','',NULL,'',NULL),(4814,'piecework_function_detail','sortorder',5,'Integer','',NULL,'',NULL),(4815,'piecework_function_detail','prompt',50,'Text','',NULL,'',NULL),(4816,'piecework_function_detail','dividing_quantity_for_rate',11,'Integer','',NULL,'',NULL),(4817,'piecework_function_detail','user_rate_requires_explanation',5,'Integer','',NULL,'',NULL),(4818,'piecework_function_detail','allow_user_rate',5,'Integer','',NULL,'',NULL),(4819,'piecework_function_detail','calc_how',5,'Integer','',NULL,'',NULL),(4820,'piecework_function_detail_selection','id',11,'Integer','',NULL,'primary',NULL),(4821,'piecework_function_detail_selection','id_piecework_function_detail',11,'Integer','',NULL,'multiple',NULL),(4822,'piecework_function_detail_selection','description',50,'Text','',NULL,'',NULL),(4823,'piecework_function_detail_selection','rate',17,'Numeric','',NULL,'',NULL),(4824,'piecework_function_detail_selection','minimum',17,'Numeric','',NULL,'',NULL),(4825,'piecework_function_detail_selection','cancel',5,'Integer','',NULL,'multiple',NULL),(4826,'piecework_function_detail_selection','canceldate',19,'DateTime','',NULL,'',NULL),(4827,'piecework_function_detail_selection','canceluserid',11,'Integer','',NULL,'',NULL),(4828,'piecework_function_detail_selection','entrydate',19,'DateTime','',NULL,'',NULL),(4829,'piecework_function_detail_selection','entryuserid',11,'Integer','',NULL,'',NULL),(4830,'piecework_function_detail_selection','lastchangedate',19,'DateTime','',NULL,'',NULL),(4831,'piecework_function_detail_selection','lastchangeuserid',11,'Integer','',NULL,'',NULL),(4832,'piecework_function_detail_selection','sortorder',5,'Integer','',NULL,'',NULL),(4833,'piecework_functions','id',11,'Integer','',NULL,'primary',NULL),(4834,'piecework_functions','id_piecework_area',11,'Integer','',NULL,'multiple',NULL),(4835,'piecework_functions','description',50,'Text','',NULL,'',NULL),(4836,'piecework_functions','cancel',5,'Integer','',NULL,'multiple',NULL),(4837,'piecework_functions','canceldate',19,'DateTime','',NULL,'',NULL),(4838,'piecework_functions','canceluserid',11,'Integer','',NULL,'',NULL),(4839,'piecework_functions','entrydate',19,'DateTime','',NULL,'',NULL),(4840,'piecework_functions','entryuserid',11,'Integer','',NULL,'',NULL),(4841,'piecework_functions','lastchangedate',19,'DateTime','',NULL,'',NULL),(4842,'piecework_functions','lastchangeuserid',11,'Integer','',NULL,'',NULL),(4843,'piecework_functions','sortorder',5,'Integer','',NULL,'',NULL),(4844,'piecework_functions','ask_job',5,'Integer','',NULL,'',NULL),(4845,'piecework_functions','allow_nojob',5,'Integer','',NULL,'',NULL),(4846,'piecework_functions','ask_quantity',5,'Integer','',NULL,'',NULL),(4847,'piecework_functions','allow_user_rate',5,'Integer','',NULL,'',NULL),(4848,'piecework_functions','minimum',17,'Numeric','',NULL,'',NULL),(4849,'piecework_functions','user_rate_require_explanation',5,'Integer','',NULL,'',NULL),(4850,'piecework_functions','rate',17,'Numeric','',NULL,'',NULL),(4851,'piecework_functions','dividing_quantity_for_rate',11,'Integer','',NULL,'',NULL),(4852,'pradditionaltax','id',22,'Numeric','',NULL,'primary unique',NULL),(4853,'pradditionaltax','gencompanyid',22,'Numeric','',NULL,'',NULL),(4854,'pradditionaltax','abrev',3,'Text','',NULL,'',NULL),(4855,'pradditionaltax','name',30,'Text','',NULL,'',NULL),(4856,'pradditionaltax','taxnum',20,'Text','',NULL,'',NULL),(4857,'pradditionaltax','deductfed',11,'Integer','',NULL,'',NULL),(4858,'pradditionaltax','feddeductmax',21,'Numeric','',NULL,'',NULL),(4859,'pradditionaltax','exemptyr1',21,'Numeric','',NULL,'',NULL),(4860,'pradditionaltax','exemptyr2',21,'Numeric','',NULL,'',NULL),(4861,'pradditionaltax','exemptyr3',21,'Numeric','',NULL,'',NULL),(4862,'pradditionaltax','exemptyr4',21,'Numeric','',NULL,'',NULL),(4863,'pradditionaltax','glacctid',22,'Numeric','',NULL,'',NULL),(4864,'pradditionaltax','vendorid',22,'Numeric','',NULL,'',NULL),(4865,'pradditionaltax','maxexemptpercent',7,'Numeric','',NULL,'',NULL),(4866,'pradditionaltax','maxexemptyear',21,'Numeric','',NULL,'',NULL),(4867,'pradditionaltax','taxcreditexempt1',21,'Numeric','',NULL,'',NULL),(4868,'pradditionaltax','taxcreditexempt2',21,'Numeric','',NULL,'',NULL),(4869,'pradditionaltax','taxcreditexempt3',21,'Numeric','',NULL,'',NULL),(4870,'pradditionaltax','taxcreditexempt4',21,'Numeric','',NULL,'',NULL),(4871,'pradditionaltax','cancel',11,'Integer','',NULL,'',NULL),(4872,'pradditionaltax','canceldate',19,'DateTime','',NULL,'',NULL),(4873,'pradditionaltax','canceluserid',22,'Numeric','',NULL,'',NULL),(4874,'pradditionaltax','entrydate',19,'DateTime','',NULL,'',NULL),(4875,'pradditionaltax','entryuserid',22,'Numeric','',NULL,'',NULL),(4876,'pradditionaltax','lastchangedate',19,'DateTime','',NULL,'',NULL),(4877,'pradditionaltax','lastchangeuserid',22,'Numeric','',NULL,'',NULL),(4878,'pradditionaltax','round_tax',2,'Integer','',NULL,'',NULL),(4879,'pradditionaltax','mexemptyr1',21,'Numeric','',NULL,'',NULL),(4880,'pradditionaltax','mexemptyr2',21,'Numeric','',NULL,'',NULL),(4881,'pradditionaltax','mexemptyr3',21,'Numeric','',NULL,'',NULL),(4882,'pradditionaltax','mexemptyr4',21,'Numeric','',NULL,'',NULL),(4883,'pradditionaltax','jexemptyr1',21,'Numeric','',NULL,'',NULL),(4884,'pradditionaltax','jexemptyr2',21,'Numeric','',NULL,'',NULL),(4885,'pradditionaltax','jexemptyr3',21,'Numeric','',NULL,'',NULL),(4886,'pradditionaltax','jexemptyr4',21,'Numeric','',NULL,'',NULL),(4887,'pradditionaltax','hexemptyr1',21,'Numeric','',NULL,'',NULL),(4888,'pradditionaltax','hexemptyr2',21,'Numeric','',NULL,'',NULL),(4889,'pradditionaltax','hexemptyr3',21,'Numeric','',NULL,'',NULL),(4890,'pradditionaltax','hexemptyr4',21,'Numeric','',NULL,'',NULL),(4891,'pradditionaltax','hexemptyr0',21,'Numeric','',NULL,'',NULL),(4892,'pradditionaltax','mexemptyr0',21,'Numeric','',NULL,'',NULL),(4893,'pradditionaltax','jexemptyr0',21,'Numeric','',NULL,'',NULL),(4894,'pradditionaltax','exemptyr0',21,'Numeric','',NULL,'',NULL),(4895,'pradditionaltax','taxyear',4,'Integer','',NULL,'',NULL),(4896,'pradditionaltax','mainrec',11,'Integer','',NULL,'',NULL),(4897,'pradditionaltaxdetail','id',22,'Numeric','',NULL,'primary unique',NULL),(4898,'pradditionaltaxdetail','pradditionaltaxid',22,'Numeric','',NULL,'',NULL),(4899,'pradditionaltaxdetail','maritalstatus',11,'Integer','',NULL,'',NULL),(4900,'pradditionaltaxdetail','deductiontable',11,'Integer','',NULL,'',NULL),(4901,'pradditionaltaxdetail','tax',21,'Numeric','',NULL,'',NULL),(4902,'pradditionaltaxdetail','percent',10,'Numeric','',NULL,'',NULL),(4903,'pradditionaltaxdetail','over',21,'Numeric','',NULL,'',NULL),(4904,'prcity','taxyear',4,'Integer','',NULL,'',NULL),(4905,'prcity','mainrec',11,'Integer','',NULL,'',NULL),(4906,'prcompany','extrafield1_desc',255,'Text','',NULL,'',NULL),(4907,'prcompany','extrafield2_desc',255,'Text','',NULL,'',NULL),(4908,'prcompany','wc_vendorid',11,'Integer','',NULL,'',NULL),(4909,'prcompany','totalach',5,'Integer','',NULL,'',NULL),(4910,'prcompany','maxssn_digits',5,'Integer','',NULL,'',NULL),(4911,'prcompany','check_memoline',100,'Text','',NULL,'',NULL),(4912,'prempldeduction','vendorid',11,'Integer','',NULL,'',NULL),(4913,'premployee','extrafield1',255,'Text','',NULL,'',NULL),(4914,'premployee','extrafield2',255,'Text','',NULL,'',NULL),(4915,'premployee','timeclock_piecework',5,'Integer','',NULL,'',NULL),(4916,'premployee','timeclock_shift',5,'Integer','',NULL,'',NULL),(4917,'premployee','pensplanid3',22,'Numeric','',NULL,'',NULL),(4918,'premployee','pensplandedamount3',12,'Numeric','',NULL,'',NULL),(4919,'premployee','pensplanbase3',11,'Integer','',NULL,'',NULL),(4920,'premployee','pensplanid4',22,'Numeric','',NULL,'',NULL),(4921,'premployee','pensplandedamount4',12,'Numeric','',NULL,'',NULL),(4922,'premployee','pensplanbase4',11,'Integer','',NULL,'',NULL),(4923,'premployee','pensplanid5',22,'Numeric','',NULL,'',NULL),(4924,'premployee','pensplandedamount5',12,'Numeric','',NULL,'',NULL),(4925,'premployee','pensplanbase5',11,'Integer','',NULL,'',NULL),(4926,'premployee_addltaxes','id',11,'Integer','',NULL,'primary unique',NULL),(4927,'premployee_addltaxes','employeeid',11,'Integer','',NULL,'multiple',NULL),(4928,'premployee_addltaxes','pradditionaltaxid',11,'Integer','',NULL,'multiple',NULL),(4929,'premployee_addltaxes','exemptions',11,'Integer','',NULL,'',NULL),(4930,'premployee_addltaxes','cancel',5,'Integer','',NULL,'multiple',NULL),(4931,'premployee_addltaxes','canceldate',10,'Date','',NULL,'',NULL),(4932,'premployee_addltaxes','canceluserid',11,'Integer','',NULL,'',NULL),(4933,'premplweekdeddetail','vendorid',11,'Integer','',NULL,'',NULL),(4934,'premplweekdeddetail','bankaccountid',11,'Integer','',NULL,'',NULL),(4935,'premplweekdeddetail','dd_or_check',5,'Integer','',NULL,'',NULL),(4936,'premplweekdeddetail','checkid',11,'Integer','',NULL,'multiple',NULL),(4937,'premplweekpaydetail','categoryid',11,'Integer','',NULL,'',NULL),(4938,'premplweekpaydetail','comment',255,'Text','',NULL,'',NULL),(4939,'prfederal','eicmarriednopercent1',10,'Numeric','',NULL,'',NULL),(4940,'prfederal','eicmarriednoover1',21,'Numeric','',NULL,'',NULL),(4941,'prfederal','eicmarriednotax2',21,'Numeric','',NULL,'',NULL),(4942,'prfederal','eicmarriednoover2',21,'Numeric','',NULL,'',NULL),(4943,'prfederal','eicmarriednotax3',21,'Numeric','',NULL,'',NULL),(4944,'prfederal','eicmarriednopercent3',21,'Numeric','',NULL,'',NULL),(4945,'prfederal','eicmarriednoover3',21,'Numeric','',NULL,'',NULL),(4946,'prfederal','fui_vendorid',11,'Integer','',NULL,'',NULL),(4947,'prfederal','taxyear',4,'Integer','',NULL,'',NULL),(4948,'prfederal','mainrec',11,'Integer','',NULL,'',NULL),(4949,'printorder','reprint',5,'Integer','',NULL,'',NULL),(4950,'printorder','extrafield1',255,'Text','',NULL,'',NULL),(4951,'printorder','extrafield2',255,'Text','',NULL,'',NULL),(4952,'printorder','extrafield3',255,'Text','',NULL,'',NULL),(4953,'printorder','extrafield4',255,'Text','',NULL,'',NULL),(4954,'printorder','contactname',255,'Text','',NULL,'',NULL),(4955,'printorder','contactphone',255,'Text','',NULL,'',NULL),(4956,'printorder_shipto','shipfromname',255,'Text','',NULL,'',NULL),(4957,'printorder_shipto','shipfromaddress',255,'Text','',NULL,'',NULL),(4958,'printorder_shipto','shipfromaddress2',255,'Text','',NULL,'',NULL),(4959,'printorder_shipto','shipfromcity',50,'Text','',NULL,'',NULL),(4960,'printorder_shipto','shipfromstate',20,'Text','',NULL,'',NULL),(4961,'printorder_shipto','shipfromzip',15,'Text','',NULL,'',NULL),(4962,'prlocal','taxyear',4,'Integer','',NULL,'',NULL),(4963,'prlocal','mainrec',11,'Integer','',NULL,'',NULL),(4964,'prntax_category','id',11,'Integer','',NULL,'primary',NULL),(4965,'prntax_category','name',255,'Text','',NULL,'',NULL),(4966,'prntax_category','glaccountid',11,'Integer','',NULL,'multiple',NULL),(4967,'prntax_category','cancel',5,'Integer','',NULL,'multiple',NULL),(4968,'prntax_category','canceldate',10,'Date','',NULL,'',NULL),(4969,'prntax_category','canceluserid',11,'Integer','',NULL,'',NULL),(4970,'prntax_category','entrydate',19,'DateTime','',NULL,'',NULL),(4971,'prntax_category','entryuserid',11,'Integer','',NULL,'',NULL),(4972,'prntax_category','gencompanyid',11,'Integer','',NULL,'multiple',NULL),(4973,'prntax_category','lastupdatedate',19,'DateTime','',NULL,'',NULL),(4974,'prntax_category','lastupdateuserid',11,'Integer','',NULL,'',NULL),(4975,'prntax_category','taxable',5,'Integer','',NULL,'',NULL),(4976,'project','id',11,'Integer','',NULL,'primary',NULL),(4977,'project','vendorid',11,'Integer','',NULL,'multiple',NULL),(4978,'project','projectname',255,'Text','',NULL,'',NULL),(4979,'project','customerid',11,'Integer','',NULL,'multiple',NULL),(4980,'project','project_templateid',11,'Integer','',NULL,'',NULL),(4981,'project','project_total',21,'Numeric','',NULL,'',NULL),(4982,'project','commission1_percent',6,'Numeric','',NULL,'',NULL),(4983,'project','commission1_vendorid',11,'Integer','',NULL,'',NULL),(4984,'project','commission2_percent',6,'Numeric','',NULL,'',NULL),(4985,'project','commission2_vendorid',11,'Integer','',NULL,'',NULL),(4986,'project','salestax1_id',11,'Integer','',NULL,'',NULL),(4987,'project','salestax1_percent',6,'Numeric','',NULL,'',NULL),(4988,'project','salestax1_glacctid',11,'Integer','',NULL,'',NULL),(4989,'project','salestax2_id',11,'Integer','',NULL,'',NULL),(4990,'project','salestax2_percent',6,'Numeric','',NULL,'',NULL),(4991,'project','salestax2_glacctid',11,'Integer','',NULL,'',NULL),(4992,'project','salestax3_id',11,'Integer','',NULL,'',NULL),(4993,'project','salestax3_percent',6,'Numeric','',NULL,'',NULL),(4994,'project','salestax3_glacctid',11,'Integer','',NULL,'',NULL),(4995,'project','othertax_name',20,'Text','',NULL,'',NULL),(4996,'project','othertax_percent',6,'Numeric','',NULL,'',NULL),(4997,'project','othertax_glacctid',11,'Integer','',NULL,'',NULL),(4998,'project','numweeks',5,'Integer','',NULL,'',NULL),(4999,'project','status',5,'Integer','',NULL,'multiple',NULL),(5000,'project','glacctid_income',11,'Integer','',NULL,'',NULL),(5001,'project','glacctid_cogs',11,'Integer','',NULL,'',NULL),(5002,'project','glacctid_commission1',11,'Integer','',NULL,'',NULL),(5003,'project','glacctid_commission2',11,'Integer','',NULL,'',NULL),(5004,'project','cancel',5,'Integer','',NULL,'multiple',NULL),(5005,'project','canceldate',19,'DateTime','',NULL,'',NULL),(5006,'project','canceluserid',11,'Integer','',NULL,'',NULL),(5007,'project','entrydate',19,'DateTime','',NULL,'',NULL),(5008,'project','entryuserid',11,'Integer','',NULL,'',NULL),(5009,'project','lastchangedate',19,'DateTime','',NULL,'',NULL),(5010,'project','lastchangeuserid',11,'Integer','',NULL,'',NULL),(5011,'project','gencompanyid',11,'Integer','',NULL,'multiple',NULL),(5012,'project','voucherid',11,'Integer','',NULL,'',NULL),(5013,'project','othertax_client_percent',12,'Numeric','',NULL,'',NULL),(5014,'project','startdate',10,'Date','',NULL,'',NULL),(5015,'projectdetail','id',11,'Integer','',NULL,'primary',NULL),(5016,'projectdetail','projectid',11,'Integer','',NULL,'multiple',NULL),(5017,'projectdetail','description',255,'Text','',NULL,'',NULL),(5018,'projectdetail','description2',255,'Text','',NULL,'',NULL),(5019,'projectdetail','description3',255,'Text','',NULL,'',NULL),(5020,'projectdetail','amount',21,'Numeric','',NULL,'',NULL),(5021,'projectdetail','percent_of_total',6,'Numeric','',NULL,'',NULL),(5022,'projectdetail','salestax1_amount',21,'Numeric','',NULL,'',NULL),(5023,'projectdetail','salestax2_amount',21,'Numeric','',NULL,'',NULL),(5024,'projectdetail','salestax3_amount',21,'Numeric','',NULL,'',NULL),(5025,'projectdetail','othertax_amount',21,'Numeric','',NULL,'',NULL),(5026,'projectdetail','commission1_checkid',11,'Integer','',NULL,'multiple',NULL),(5027,'projectdetail','commission2_checkid',11,'Integer','',NULL,'multiple',NULL),(5028,'projectdetail','client_checkid',11,'Integer','',NULL,'multiple',NULL),(5029,'projectdetail','invoiceid',11,'Integer','',NULL,'multiple',NULL),(5030,'projectdetail','commission1_apbillid',11,'Integer','',NULL,'',NULL),(5031,'projectdetail','commission2_apbillid',11,'Integer','',NULL,'',NULL),(5032,'projectexpenses','id',11,'Integer','',NULL,'primary',NULL),(5033,'projectexpenses','projectid',11,'Integer','',NULL,'multiple',NULL),(5034,'projectexpenses','amount',21,'Numeric','',NULL,'',NULL),(5035,'projectexpenses','checkid',11,'Integer','',NULL,'multiple',NULL),(5036,'projectgen','id',11,'Integer','',NULL,'primary',NULL),(5037,'projectgen','default_checkacctid',11,'Integer','',NULL,'',NULL),(5038,'projectinvoice','id',11,'Integer','',NULL,'primary',NULL),(5039,'projectinvoice','projectid',11,'Integer','',NULL,'multiple',NULL),(5040,'projectinvoice','projectdetailid',11,'Integer','',NULL,'multiple',NULL),(5041,'projectinvoice','invoiceid',11,'Integer','',NULL,'multiple',NULL),(5042,'projectpayment','id',11,'Integer','',NULL,'primary',NULL),(5043,'projectpayment','checkid',11,'Integer','',NULL,'multiple',NULL),(5044,'projectpayment','projectid',11,'Integer','',NULL,'multiple',NULL),(5045,'projectpayment','projectdetailid',11,'Integer','',NULL,'multiple',NULL),(5046,'projecttemplate','id',11,'Integer','',NULL,'primary',NULL),(5047,'projecttemplate','templatename',255,'Text','',NULL,'',NULL),(5048,'projecttemplate','commission1_percent',6,'Numeric','',NULL,'',NULL),(5049,'projecttemplate','commission1_vendorid',11,'Integer','',NULL,'',NULL),(5050,'projecttemplate','commission2_percent',6,'Numeric','',NULL,'',NULL),(5051,'projecttemplate','commission2_vendorid',11,'Integer','',NULL,'',NULL),(5052,'projecttemplate','salestax1_id',11,'Integer','',NULL,'',NULL),(5053,'projecttemplate','salestax1_percent',6,'Numeric','',NULL,'',NULL),(5054,'projecttemplate','salestax1_glacctid',11,'Integer','',NULL,'',NULL),(5055,'projecttemplate','salestax2_id',11,'Integer','',NULL,'',NULL),(5056,'projecttemplate','salestax2_percent',6,'Numeric','',NULL,'',NULL),(5057,'projecttemplate','salestax2_glacctid',11,'Integer','',NULL,'',NULL),(5058,'projecttemplate','salestax3_id',11,'Integer','',NULL,'',NULL),(5059,'projecttemplate','salestax3_percent',6,'Numeric','',NULL,'',NULL),(5060,'projecttemplate','salestax3_glacctid',11,'Integer','',NULL,'',NULL),(5061,'projecttemplate','othertax_name',20,'Text','',NULL,'',NULL),(5062,'projecttemplate','othertax_percent',6,'Numeric','',NULL,'',NULL),(5063,'projecttemplate','othertax_glacctid',11,'Integer','',NULL,'',NULL),(5064,'projecttemplate','weekly',5,'Integer','',NULL,'',NULL),(5065,'projecttemplate','glacctid_income',11,'Integer','',NULL,'',NULL),(5066,'projecttemplate','glacctid_cogs',11,'Integer','',NULL,'',NULL),(5067,'projecttemplate','glacctid_commission1',11,'Integer','',NULL,'',NULL),(5068,'projecttemplate','glacctid_commission2',11,'Integer','',NULL,'',NULL),(5069,'projecttemplate','cancel',5,'Integer','',NULL,'multiple',NULL),(5070,'projecttemplate','canceldate',19,'DateTime','',NULL,'',NULL),(5071,'projecttemplate','canceluserid',11,'Integer','',NULL,'',NULL),(5072,'projecttemplate','entrydate',19,'DateTime','',NULL,'',NULL),(5073,'projecttemplate','entryuserid',11,'Integer','',NULL,'',NULL),(5074,'projecttemplate','lastchangedate',19,'DateTime','',NULL,'',NULL),(5075,'projecttemplate','lastchangeuserid',11,'Integer','',NULL,'',NULL),(5076,'projecttemplate','gencompanyid',11,'Integer','',NULL,'multiple',NULL),(5077,'projecttemplate','customdays',5,'Integer','',NULL,'',NULL),(5078,'projecttemplate','othertax_client_percent',12,'Numeric','',NULL,'',NULL),(5079,'projecttemplatedetail','id',11,'Integer','',NULL,'primary',NULL),(5080,'projecttemplatedetail','projecttemplateid',11,'Integer','',NULL,'multiple',NULL),(5081,'projecttemplatedetail','description',255,'Text','',NULL,'',NULL),(5082,'projecttemplatedetail','description2',255,'Text','',NULL,'',NULL),(5083,'projecttemplatedetail','description3',255,'Text','',NULL,'',NULL),(5084,'projecttemplatedetail','percent_of_total',6,'Numeric','',NULL,'',NULL),(5085,'prperiod','strname',30,'Text','',NULL,'',NULL),(5086,'prstate','sui_vendorid',11,'Integer','',NULL,'',NULL),(5087,'prstate','taxyear',4,'Integer','',NULL,'',NULL),(5088,'prstate','mainrec',11,'Integer','',NULL,'',NULL),(5089,'qbimport','id',10,'Integer','',NULL,'primary',NULL),(5090,'qbimport','module',45,'Text','',NULL,'',NULL),(5091,'qbimport','status',11,'Integer','',NULL,'',NULL),(5092,'qbimport','numrecords',10,'Integer','',NULL,'',NULL),(5093,'qbimport','entrydate',19,'DateTime','',NULL,'',NULL),(5094,'qbimport','entryuserid',11,'Integer','',NULL,'',NULL),(5095,'qbimport','companyid',11,'Integer','',NULL,'',NULL),(5096,'question','donotshow_on_ticket',5,'Integer','',NULL,'',NULL),(5097,'sales_categories','allow_b2b_display',11,'Integer','',NULL,'',NULL),(5098,'salestax','capamount',16,'Numeric','',NULL,'',NULL),(5099,'salestax','gencompanyid',11,'Integer','',NULL,'',NULL),(5100,'service_worktype','salesglacctid',11,'Integer','',NULL,'',NULL),(5101,'shipto','weather_cf',1,'Text','',NULL,'',NULL),(5102,'shipto','weather_zip',20,'Text','',NULL,'',NULL),(5103,'shipto','time_zone',6,'Text','',NULL,'',NULL),(5104,'survey','id',10,'Integer','',NULL,'primary',NULL),(5105,'survey','name',255,'Text','',NULL,'',NULL),(5106,'survey','entryuserid',10,'Integer','',NULL,'',NULL),(5107,'survey','entrydate',19,'DateTime','',NULL,'',NULL),(5108,'survey','cancel',11,'Integer','',NULL,'',NULL),(5109,'survey','canceluserid',11,'Integer','',NULL,'',NULL),(5110,'survey','canceldate',19,'DateTime','',NULL,'',NULL),(5111,'survey','companyid',10,'Integer','',NULL,'',NULL),(5112,'survey','surveytype',20,'Text','',NULL,'',NULL),(5113,'survey','emailtext',65535,'X','',NULL,'',NULL),(5114,'surveycomplete','id',10,'Integer','',NULL,'primary',NULL),(5115,'surveycomplete','surveyid',10,'Integer','',NULL,'',NULL),(5116,'surveycomplete','customerid',10,'Integer','',NULL,'multiple',NULL),(5117,'surveycomplete','vendorid',10,'Integer','',NULL,'multiple',NULL),(5118,'surveycomplete','entrydate',19,'DateTime','',NULL,'multiple',NULL),(5119,'surveycomplete','ip',20,'Text','',NULL,'',NULL),(5120,'surveycomplete','referenceid',10,'Integer','',NULL,'multiple',NULL),(5121,'surveycomplete','referencetable',50,'Text','',NULL,'',NULL),(5122,'surveycomplete','uniqueid',45,'Text','',NULL,'',NULL),(5123,'tccompany','id',11,'Integer','',NULL,'primary unique',NULL),(5124,'tccompany','general_ip_only',255,'Text','',NULL,'',NULL),(5125,'tccompany','genuser_ip_yesno',5,'Integer','',NULL,'',NULL),(5126,'tccompany','hours_day_overtime',6,'Numeric','',NULL,'',NULL),(5127,'tccompany','hours_week_overtime',7,'Numeric','',NULL,'',NULL),(5128,'tccompany','payweek_beginday',5,'Integer','',NULL,'',NULL),(5129,'tccompany','lunchpaid',5,'Integer','',NULL,'',NULL),(5130,'tccompany','breakpaid',5,'Integer','',NULL,'',NULL),(5131,'tccompany','maxtime_perbreak',6,'Numeric','',NULL,'',NULL),(5132,'tccompany','max_breaks_perday',5,'Integer','',NULL,'',NULL),(5133,'tccompany','allow_comptime',5,'Integer','',NULL,'',NULL),(5134,'tccompany','stpay_prpaytypeid',11,'Integer','',NULL,'',NULL),(5135,'tccompany','ot_prpaytypeid',11,'Integer','',NULL,'',NULL),(5136,'tccompany','maxpaidlunch',17,'Numeric','',NULL,'',NULL),(5137,'tccompany','maxhours',11,'Integer','',NULL,'',NULL),(5138,'tccompany','salaried_all_stpay',5,'Integer','',NULL,'',NULL),(5139,'tccompany','salaried_limit_time',5,'Integer','',NULL,'',NULL),(5140,'tccompany','no_autologout',5,'Integer','',NULL,'',NULL),(5141,'tccompany','no_paydisplay',5,'Integer','',NULL,'',NULL),(5142,'tccompany','norelog_viewtimes',5,'Integer','',NULL,'',NULL),(5143,'tccompany','input_font_size',11,'Integer','',NULL,'',NULL),(5144,'timeclock','id',11,'Integer','',NULL,'primary',NULL),(5145,'timeclock','employeeid',11,'Integer','',NULL,'multiple',NULL),(5146,'timeclock','name',50,'Text','',NULL,'',NULL),(5147,'timeclock','hours',17,'Numeric','',NULL,'',NULL),(5148,'timeclock','quantity',17,'Numeric','',NULL,'',NULL),(5149,'timeclock','rateperhour',17,'Numeric','',NULL,'',NULL),(5150,'timeclock','rateperpiece',17,'Numeric','',NULL,'',NULL),(5151,'timeclock','totalpay',17,'Numeric','',NULL,'',NULL),(5152,'timeclock','jobid',11,'Integer','',NULL,'',NULL),(5153,'timeclock','notes',255,'Text','',NULL,'',NULL),(5154,'timeclock','gencompanyid',11,'Integer','',NULL,'',NULL),(5155,'timeclock','entrydate',19,'DateTime','',NULL,'multiple',NULL),(5156,'timeclock','cancel',5,'Integer','',NULL,'',NULL),(5157,'timeclock','canceldate',19,'DateTime','',NULL,'',NULL),(5158,'timeclock','canceluserid',11,'Integer','',NULL,'',NULL),(5159,'timeclock','lastchangedate',19,'DateTime','',NULL,'',NULL),(5160,'timeclock','lastchangeuserid',11,'Integer','',NULL,'',NULL),(5161,'timeclock','status',5,'Integer','',NULL,'',NULL),(5162,'timeclock','ordertype',5,'Integer','',NULL,'',NULL),(5163,'timeclock','timetype',5,'Integer','',NULL,'',NULL),(5164,'timeclock','piecerate_pricesid',11,'Integer','',NULL,'',NULL),(5165,'timeclock','employee_edited',5,'Integer','',NULL,'',NULL),(5166,'timeclock','employee_edit_datetime',19,'DateTime','',NULL,'',NULL),(5167,'timeclock','management_edited',5,'Integer','',NULL,'',NULL),(5168,'timeclock','management_edited_datetime',19,'DateTime','',NULL,'',NULL),(5169,'timeclock','management_edited_userid',11,'Integer','',NULL,'',NULL),(5170,'timeclock','premplweekid',11,'Integer','',NULL,'',NULL),(5171,'timeclock','description',255,'Text','',NULL,'',NULL),(5172,'timeclock','startdatetime',19,'DateTime','',NULL,'multiple',NULL),(5173,'timeclock','enddatetime',19,'DateTime','',NULL,'',NULL),(5174,'timeclock','ip',50,'Text','',NULL,'',NULL),(5175,'timeclock','ippath',100,'Text','',NULL,'',NULL),(5176,'timeclock','otherid',11,'Integer','',NULL,'',NULL),(5177,'timeclock','comptime',5,'Integer','',NULL,'',NULL),(5178,'timeclock','shift',5,'Integer','',NULL,'',NULL),(5179,'timeclock','unpaid_hours',17,'Numeric','',NULL,'',NULL),(5180,'timeclock','calc_othours',17,'Numeric','',NULL,'',NULL),(5181,'timeclock','calc_sthours',17,'Numeric','',NULL,'',NULL),(5182,'timeclock','calc_otpay',18,'Numeric','',NULL,'',NULL),(5183,'timeclock','calc_stpay',18,'Numeric','',NULL,'',NULL),(5184,'timeclock','piecework_div',11,'Integer','',NULL,'',NULL),(5185,'timeclock','calc_pwpay',21,'Numeric','',NULL,'',NULL),(5186,'timeclock','calc_pwqty',17,'Numeric','',NULL,'',NULL),(5187,'timeclock','pw_minimum',21,'Numeric','',NULL,'',NULL),(5188,'timeclock','calc_pwrate',21,'Numeric','',NULL,'',NULL),(5189,'timeclock','post2date',10,'Date','',NULL,'',NULL),(5190,'timeclock_othertime','id',11,'Integer','',NULL,'primary',NULL),(5191,'timeclock_othertime','note',50,'Text','',NULL,'',NULL),(5192,'timeclock_othertime','sortorder',5,'Integer','',NULL,'multiple',NULL),(5193,'timeclock_othertime','gencompanyid',11,'Integer','',NULL,'multiple',NULL),(5194,'timeclock_othertime','cancel',5,'Integer','',NULL,'multiple',NULL),(5195,'timeclock_othertime','canceluserid',11,'Integer','',NULL,'',NULL),(5196,'timeclock_othertime','canceldate',19,'DateTime','',NULL,'',NULL),(5197,'timeclock_othertime','lastupdatedate',19,'DateTime','',NULL,'',NULL),(5198,'timeclock_othertime','lastupdateuserid',11,'Integer','',NULL,'',NULL),(5199,'timeclock_othertime','paidtime',5,'Integer','',NULL,'',NULL),(5200,'vendor','vendorcode',30,'Text','',NULL,'',NULL),(5201,'vendor','salutation',20,'Text','',NULL,'',NULL),(5202,'vendor','first_name',50,'Text','',NULL,'',NULL),(5203,'vendor','middle_name',50,'Text','',NULL,'',NULL),(5204,'vendor','name_suffix',20,'Text','',NULL,'',NULL),(5205,'vendor','vendortypeid',11,'Integer','',NULL,'multiple',NULL),(5206,'vendortype','id',11,'Integer','',NULL,'primary',NULL),(5207,'vendortype','description',255,'Text','',NULL,'',NULL),(5208,'vendortype','cancel',5,'Integer','',NULL,'multiple',NULL),(5209,'vendortype','canceldate',19,'DateTime','',NULL,'',NULL),(5210,'vendortype','canceluserid',11,'Integer','',NULL,'',NULL),(5211,'vendortype','gencompanyid',11,'Integer','',NULL,'multiple',NULL),(5212,'vendortype','lastupdatedate',19,'DateTime','',NULL,'',NULL),(5213,'wherefrom','id',11,'Integer','',NULL,'primary',NULL),(5214,'wherefrom','module',10,'Text','',NULL,'',NULL),(5215,'wherefrom','name',100,'Text','',NULL,'',NULL),(5216,'worktype','gencompanyid',11,'Integer','',NULL,'',NULL);
/*!40000 ALTER TABLE `db_explanation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `default_response`
--

DROP TABLE IF EXISTS `default_response`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `default_response` (
  `id_default_response` int(11) NOT NULL default '0',
  `id_worksubtype` int(11) NOT NULL default '0',
  `id_question` int(11) NOT NULL default '0',
  `response_id_question_detail` int(11) NOT NULL default '0',
  `response` varchar(20) NOT NULL default '',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_default_response`),
  UNIQUE KEY `id_default_response` (`id_default_response`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `default_response`
--

LOCK TABLES `default_response` WRITE;
/*!40000 ALTER TABLE `default_response` DISABLE KEYS */;
/*!40000 ALTER TABLE `default_response` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `default_responseseq`
--

DROP TABLE IF EXISTS `default_responseseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `default_responseseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `default_responseseq`
--

LOCK TABLES `default_responseseq` WRITE;
/*!40000 ALTER TABLE `default_responseseq` DISABLE KEYS */;
INSERT INTO `default_responseseq` VALUES (0);
/*!40000 ALTER TABLE `default_responseseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `department`
--

DROP TABLE IF EXISTS `department`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `department` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(45) NOT NULL default '',
  `name` varchar(100) NOT NULL default '',
  `glwageexpenseid` int(11) NOT NULL default '0',
  `glficaexpenseid` int(11) NOT NULL default '0',
  `glfuiexpenseid` int(11) NOT NULL default '0',
  `glmedicareexpenseid` int(11) NOT NULL default '0',
  `glsuiexpenseid` int(11) NOT NULL default '0',
  `glworkmanscompexpenseid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `code` (`code`),
  KEY `name` (`name`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `department`
--

LOCK TABLES `department` WRITE;
/*!40000 ALTER TABLE `department` DISABLE KEYS */;
/*!40000 ALTER TABLE `department` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `discount`
--

DROP TABLE IF EXISTS `discount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `discount` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `discountpercent` decimal(6,2) NOT NULL default '0.00',
  `glaccountid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `cancel` int(11) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `companyid` (`companyid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `discount`
--

LOCK TABLES `discount` WRITE;
/*!40000 ALTER TABLE `discount` DISABLE KEYS */;
/*!40000 ALTER TABLE `discount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dnsmxcache`
--

DROP TABLE IF EXISTS `dnsmxcache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dnsmxcache` (
  `id` int(11) NOT NULL auto_increment,
  `hostnamechecksum` int(11) NOT NULL,
  `found` tinyint(1) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `hostname` varchar(255) character set utf8 collate utf8_unicode_ci NOT NULL,
  `mxhostscsv` text character set utf8 collate utf8_unicode_ci,
  `weightcsv` text character set utf8 collate utf8_unicode_ci,
  PRIMARY KEY  (`id`),
  KEY `checksumkey` (`hostnamechecksum`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dnsmxcache`
--

LOCK TABLES `dnsmxcache` WRITE;
/*!40000 ALTER TABLE `dnsmxcache` DISABLE KEYS */;
/*!40000 ALTER TABLE `dnsmxcache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `docmgmtcategory`
--

DROP TABLE IF EXISTS `docmgmtcategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `docmgmtcategory` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(255) NOT NULL default '',
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `docmgmtcategory`
--

LOCK TABLES `docmgmtcategory` WRITE;
/*!40000 ALTER TABLE `docmgmtcategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `docmgmtcategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `docmgmtdata`
--

DROP TABLE IF EXISTS `docmgmtdata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `docmgmtdata` (
  `id` int(11) NOT NULL auto_increment,
  `category` double NOT NULL default '0',
  `owner` double NOT NULL default '0',
  `realname` varchar(255) NOT NULL default '',
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `description` varchar(255) default NULL,
  `itemid` int(11) NOT NULL default '0',
  `comment` text,
  `status` double NOT NULL default '0',
  `version` varchar(10) default NULL,
  `final` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`),
  KEY `owner` (`owner`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `docmgmtdata`
--

LOCK TABLES `docmgmtdata` WRITE;
/*!40000 ALTER TABLE `docmgmtdata` DISABLE KEYS */;
/*!40000 ALTER TABLE `docmgmtdata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `docmgmtlog`
--

DROP TABLE IF EXISTS `docmgmtlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `docmgmtlog` (
  `id` int(11) NOT NULL default '0',
  `modified_on` datetime NOT NULL default '0000-00-00 00:00:00',
  `modified_by` double NOT NULL default '0',
  `oldversion` varchar(10) default NULL,
  `newversion` varchar(10) default NULL,
  `note` text,
  KEY `id` (`id`),
  KEY `modified_by` (`modified_by`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `docmgmtlog`
--

LOCK TABLES `docmgmtlog` WRITE;
/*!40000 ALTER TABLE `docmgmtlog` DISABLE KEYS */;
/*!40000 ALTER TABLE `docmgmtlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `docmgmtperms`
--

DROP TABLE IF EXISTS `docmgmtperms`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `docmgmtperms` (
  `fid` int(11) NOT NULL default '0',
  `uid` int(11) NOT NULL default '0',
  `rights` double NOT NULL default '0',
  KEY `fid` (`fid`),
  KEY `uid` (`uid`),
  KEY `rights` (`rights`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `docmgmtperms`
--

LOCK TABLES `docmgmtperms` WRITE;
/*!40000 ALTER TABLE `docmgmtperms` DISABLE KEYS */;
/*!40000 ALTER TABLE `docmgmtperms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `docsigning`
--

DROP TABLE IF EXISTS `docsigning`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `docsigning` (
  `id` int(11) NOT NULL auto_increment,
  `doctype` varchar(25) NOT NULL default '',
  `templateid` varchar(45) NOT NULL default '',
  `docname` varchar(100) NOT NULL default '',
  `tablename` varchar(45) NOT NULL default '',
  `tableid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `docid` varchar(45) NOT NULL default '',
  `auth` varchar(45) NOT NULL default '',
  `signatory1id` varchar(45) NOT NULL default '',
  `signatory1auth` varchar(45) NOT NULL default '',
  `signatory2id` varchar(45) NOT NULL default '',
  `signatory2auth` varchar(45) NOT NULL default '',
  `signatory3id` varchar(45) NOT NULL default '',
  `signatory3auth` varchar(45) NOT NULL default '',
  `signatory4id` varchar(45) NOT NULL default '',
  `signatory4auth` varchar(45) NOT NULL default '',
  `status` varchar(45) NOT NULL default '',
  `statusdate` datetime default NULL,
  `statusdetail` varchar(50) NOT NULL default '',
  `expirationdate` date default NULL,
  `ordernumber` int(11) NOT NULL default '0',
  `signurl1` varchar(255) NOT NULL default '',
  `signurl2` varchar(255) NOT NULL default '',
  `signurl3` varchar(255) NOT NULL default '',
  `signurl4` varchar(255) NOT NULL default '',
  `viewurl` varchar(255) NOT NULL default '',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `completedate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastlogdate` datetime default NULL,
  `lastlogdetails` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `doctype` (`doctype`),
  KEY `tableinfo` (`tablename`,`tableid`),
  KEY `docinfo` (`docid`,`auth`),
  KEY `status` (`status`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `docsigning`
--

LOCK TABLES `docsigning` WRITE;
/*!40000 ALTER TABLE `docsigning` DISABLE KEYS */;
/*!40000 ALTER TABLE `docsigning` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `draw`
--

DROP TABLE IF EXISTS `draw`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `draw` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `status` int(11) NOT NULL default '0',
  `drawtotal` decimal(19,6) NOT NULL default '0.000000',
  `drawdate` date NOT NULL default '0000-00-00',
  `retainage` decimal(6,2) NOT NULL default '0.00',
  `retainagetotal` decimal(19,6) NOT NULL default '0.000000',
  `customerid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `cancel` int(11) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `jobsondraw` text NOT NULL,
  `changeorderadd` decimal(19,6) NOT NULL default '0.000000',
  `changeorderded` decimal(19,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `status` (`status`),
  KEY `drawdate` (`drawdate`),
  KEY `customerid` (`customerid`),
  KEY `invoiceid` (`invoiceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `draw`
--

LOCK TABLES `draw` WRITE;
/*!40000 ALTER TABLE `draw` DISABLE KEYS */;
/*!40000 ALTER TABLE `draw` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `drawdetail`
--

DROP TABLE IF EXISTS `drawdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `drawdetail` (
  `id` int(11) NOT NULL auto_increment,
  `drawid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`),
  KEY `costcodeid` (`costcodeid`),
  KEY `drawid` (`drawid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `drawdetail`
--

LOCK TABLES `drawdetail` WRITE;
/*!40000 ALTER TABLE `drawdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `drawdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ebaysetup`
--

DROP TABLE IF EXISTS `ebaysetup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ebaysetup` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `ebaystorename` varchar(128) NOT NULL default '',
  `ebayaccountid` varchar(32) NOT NULL default '',
  `companyid` int(11) NOT NULL default '0',
  `token` varchar(1024) NOT NULL default '',
  `tokenexpire` datetime NOT NULL default '0000-00-00 00:00:00',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `salesglacctid` int(11) NOT NULL default '0',
  `salestaxglacctid` int(11) NOT NULL default '0',
  `taxexemptid` int(11) NOT NULL default '0',
  `salescategoryid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `invoicetermsid` int(11) NOT NULL default '0',
  `pricelevelid` int(11) NOT NULL default '0',
  `defaultshipvia` int(11) NOT NULL default '0',
  `currency` varchar(8) NOT NULL default '',
  `stockunitnameid` int(11) NOT NULL default '0',
  `priceunitnameid` int(11) NOT NULL default '0',
  `allowautomaticorderimports` tinyint(1) NOT NULL default '0',
  `automaticorderimport_lastrun` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ebaysetup`
--

LOCK TABLES `ebaysetup` WRITE;
/*!40000 ALTER TABLE `ebaysetup` DISABLE KEYS */;
/*!40000 ALTER TABLE `ebaysetup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eftfile`
--

DROP TABLE IF EXISTS `eftfile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eftfile` (
  `id` int(11) NOT NULL auto_increment,
  `filecontents` mediumtext,
  `efttype` char(1) NOT NULL default 'C',
  `totalamount` decimal(19,4) NOT NULL default '0.0000',
  `totalrecords` int(11) NOT NULL default '0',
  `filecreationnumber` int(11) NOT NULL default '0',
  `checkacctid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `paymentdate` date default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastemaildate` datetime default NULL,
  PRIMARY KEY  (`id`),
  KEY `efttype` (`efttype`),
  KEY `entryuserid` (`entryuserid`),
  KEY `checkacctid` (`checkacctid`),
  KEY `canceluserid` (`canceluserid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `paymentdate` (`paymentdate`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eftfile`
--

LOCK TABLES `eftfile` WRITE;
/*!40000 ALTER TABLE `eftfile` DISABLE KEYS */;
/*!40000 ALTER TABLE `eftfile` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eftfiledetail`
--

DROP TABLE IF EXISTS `eftfiledetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eftfiledetail` (
  `id` int(11) NOT NULL auto_increment,
  `eftfileid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `checkid` int(11) NOT NULL default '0',
  `voucherid` int(11) NOT NULL default '0',
  `recordnumber` int(11) NOT NULL default '0',
  `paymentdate` date default NULL,
  PRIMARY KEY  (`id`),
  KEY `eftfileid` (`eftfileid`),
  KEY `vendorid` (`vendorid`),
  KEY `customerid` (`customerid`),
  KEY `checkid` (`checkid`),
  KEY `voucherid` (`voucherid`),
  KEY `paymentdate` (`paymentdate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eftfiledetail`
--

LOCK TABLES `eftfiledetail` WRITE;
/*!40000 ALTER TABLE `eftfiledetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `eftfiledetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `emailtemplate`
--

DROP TABLE IF EXISTS `emailtemplate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `emailtemplate` (
  `id` int(11) NOT NULL auto_increment,
  `action` varchar(20) NOT NULL default '',
  `name` varchar(200) NOT NULL default '',
  `fromname` varchar(255) NOT NULL default '',
  `fromemail` varchar(255) NOT NULL default '',
  `subject` varchar(255) NOT NULL default '',
  `body` text,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `defaultcc` text,
  `defaultbcc` text,
  `surveyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `action` (`action`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `emailtemplate`
--

LOCK TABLES `emailtemplate` WRITE;
/*!40000 ALTER TABLE `emailtemplate` DISABLE KEYS */;
/*!40000 ALTER TABLE `emailtemplate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `employeelog`
--

DROP TABLE IF EXISTS `employeelog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `employeelog` (
  `id_employeelog` int(11) NOT NULL default '0',
  `id_employee` int(11) NOT NULL default '0',
  `status` int(3) NOT NULL default '0',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `starttime` datetime default NULL,
  `endtime` datetime NOT NULL default '0000-00-00 00:00:00',
  `total_time` decimal(10,2) NOT NULL default '0.00',
  `id_employeelogcategory` int(11) NOT NULL default '0',
  `notes` varchar(100) NOT NULL default '',
  `cancel` int(3) NOT NULL default '0',
  PRIMARY KEY  (`id_employeelog`),
  UNIQUE KEY `id_employeelog` (`id_employeelog`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `employeelog`
--

LOCK TABLES `employeelog` WRITE;
/*!40000 ALTER TABLE `employeelog` DISABLE KEYS */;
/*!40000 ALTER TABLE `employeelog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `employeelogcategory`
--

DROP TABLE IF EXISTS `employeelogcategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `employeelogcategory` (
  `id` int(11) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `cancel` int(3) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `employeelogcategory`
--

LOCK TABLES `employeelogcategory` WRITE;
/*!40000 ALTER TABLE `employeelogcategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `employeelogcategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `employeelogseq`
--

DROP TABLE IF EXISTS `employeelogseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `employeelogseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `employeelogseq`
--

LOCK TABLES `employeelogseq` WRITE;
/*!40000 ALTER TABLE `employeelogseq` DISABLE KEYS */;
/*!40000 ALTER TABLE `employeelogseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `equipment`
--

DROP TABLE IF EXISTS `equipment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `equipment` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(150) NOT NULL default '',
  `description` text NOT NULL,
  `buildingid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `cost` decimal(19,6) NOT NULL default '0.000000',
  `serialnumber` varchar(100) NOT NULL default '',
  `purchasedate` date default NULL,
  `vendorid` int(11) NOT NULL default '0',
  `invpoid` int(11) NOT NULL default '0',
  `signedout` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` varchar(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `buildingid` (`buildingid`),
  KEY `companyid` (`companyid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `equipment`
--

LOCK TABLES `equipment` WRITE;
/*!40000 ALTER TABLE `equipment` DISABLE KEYS */;
/*!40000 ALTER TABLE `equipment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `equipmentsignout`
--

DROP TABLE IF EXISTS `equipmentsignout`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `equipmentsignout` (
  `id` int(11) NOT NULL auto_increment,
  `equipmentid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `workorderid` int(11) NOT NULL default '0',
  `dateout` date NOT NULL default '0000-00-00',
  `datein` date NOT NULL default '0000-00-00',
  `notes` text NOT NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `userid` (`userid`),
  KEY `equipmentid` (`equipmentid`),
  KEY `workorderid` (`workorderid`),
  KEY `dateout` (`dateout`),
  KEY `datein` (`datein`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `equipmentsignout`
--

LOCK TABLES `equipmentsignout` WRITE;
/*!40000 ALTER TABLE `equipmentsignout` DISABLE KEYS */;
/*!40000 ALTER TABLE `equipmentsignout` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estcostcenter`
--

DROP TABLE IF EXISTS `estcostcenter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estcostcenter` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(50) NOT NULL default '',
  `cctype` int(11) NOT NULL default '0',
  `orderflag` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estcostcenter`
--

LOCK TABLES `estcostcenter` WRITE;
/*!40000 ALTER TABLE `estcostcenter` DISABLE KEYS */;
/*!40000 ALTER TABLE `estcostcenter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estcostcentersubtype`
--

DROP TABLE IF EXISTS `estcostcentersubtype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estcostcentersubtype` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(50) NOT NULL default '',
  `costcenterid` int(11) NOT NULL default '0',
  `orderflag` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `costcenterid` (`costcenterid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estcostcentersubtype`
--

LOCK TABLES `estcostcentersubtype` WRITE;
/*!40000 ALTER TABLE `estcostcentersubtype` DISABLE KEYS */;
/*!40000 ALTER TABLE `estcostcentersubtype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estmachine`
--

DROP TABLE IF EXISTS `estmachine`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estmachine` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(50) NOT NULL default '',
  `costcentersubtypeid` int(11) NOT NULL default '0',
  `costmachperhr` decimal(12,2) NOT NULL default '0.00',
  `costoperperhr` decimal(12,2) NOT NULL default '0.00',
  `costasstperhr` decimal(12,2) NOT NULL default '0.00',
  `factoverhead` decimal(3,2) NOT NULL default '0.00',
  `genoverhead` decimal(3,2) NOT NULL default '0.00',
  `markup` decimal(4,2) NOT NULL default '0.00',
  `orderflag` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `costcentersubtypeid` (`costcentersubtypeid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estmachine`
--

LOCK TABLES `estmachine` WRITE;
/*!40000 ALTER TABLE `estmachine` DISABLE KEYS */;
/*!40000 ALTER TABLE `estmachine` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estprgeneral`
--

DROP TABLE IF EXISTS `estprgeneral`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estprgeneral` (
  `gencompanyid` int(11) NOT NULL default '0',
  `onetrimopcostsid` int(11) NOT NULL default '0',
  `twotrimopcostsid` int(11) NOT NULL default '0',
  `cutopcostsid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  PRIMARY KEY  (`gencompanyid`),
  UNIQUE KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estprgeneral`
--

LOCK TABLES `estprgeneral` WRITE;
/*!40000 ALTER TABLE `estprgeneral` DISABLE KEYS */;
/*!40000 ALTER TABLE `estprgeneral` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estprprice`
--

DROP TABLE IF EXISTS `estprprice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estprprice` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `worktypeid` int(11) NOT NULL default '0',
  `estquotestdsizeid` int(11) NOT NULL default '0',
  `maxpages` int(11) NOT NULL default '0',
  `minpages` int(11) NOT NULL default '0',
  `opoffsetsheet` int(11) NOT NULL default '0',
  `opoffsetweb` int(11) NOT NULL default '0',
  `opdigital` int(11) NOT NULL default '0',
  `opscreen` int(11) NOT NULL default '0',
  `opflexo` int(11) NOT NULL default '0',
  `opvended` int(11) NOT NULL default '0',
  `qtyperbox` decimal(5,0) NOT NULL default '0',
  `notes` blob,
  `prpriceid` int(11) NOT NULL default '0',
  `maxstocks` int(11) NOT NULL default '1',
  `tools` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estprprice`
--

LOCK TABLES `estprprice` WRITE;
/*!40000 ALTER TABLE `estprprice` DISABLE KEYS */;
/*!40000 ALTER TABLE `estprprice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estprpriceoptioncosts`
--

DROP TABLE IF EXISTS `estprpriceoptioncosts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estprpriceoptioncosts` (
  `id` int(11) NOT NULL auto_increment,
  `proption` int(11) NOT NULL default '0',
  `stocklistid` int(11) NOT NULL default '0',
  `hrsgeneralsetup` decimal(6,3) NOT NULL default '0.000',
  `hrscolorsetup` decimal(6,3) NOT NULL default '0.000',
  `runrate` decimal(10,2) NOT NULL default '0.00',
  `runrate2` decimal(10,2) NOT NULL default '0.00',
  `runrate3` decimal(10,2) NOT NULL default '0.00',
  `runqty` decimal(8,0) NOT NULL default '0',
  `runqty2` decimal(8,0) NOT NULL default '0',
  `runrateqtytype` int(11) NOT NULL default '0',
  `numoperators` int(11) NOT NULL default '0',
  `numassistants` int(11) NOT NULL default '0',
  `mantomachine` int(11) NOT NULL default '0',
  `setupscrap` decimal(5,2) NOT NULL default '0.00',
  `runscrap` decimal(5,2) NOT NULL default '0.00',
  `runscrap2` decimal(5,2) NOT NULL default '0.00',
  `scrapqty` decimal(8,0) NOT NULL default '0',
  `registrationslowdown` decimal(2,0) NOT NULL default '0',
  `maxinksperpass` int(11) NOT NULL default '1',
  `estmachineid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estprpriceoptioncosts`
--

LOCK TABLES `estprpriceoptioncosts` WRITE;
/*!40000 ALTER TABLE `estprpriceoptioncosts` DISABLE KEYS */;
/*!40000 ALTER TABLE `estprpriceoptioncosts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estprpriceoptioncostsmaterials`
--

DROP TABLE IF EXISTS `estprpriceoptioncostsmaterials`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estprpriceoptioncostsmaterials` (
  `id` int(11) NOT NULL auto_increment,
  `proption` int(11) NOT NULL default '0',
  `stocklistid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `name` char(30) NOT NULL default '',
  `qty` decimal(10,3) NOT NULL default '0.000',
  `per` int(11) NOT NULL default '0',
  `cost` decimal(12,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estprpriceoptioncostsmaterials`
--

LOCK TABLES `estprpriceoptioncostsmaterials` WRITE;
/*!40000 ALTER TABLE `estprpriceoptioncostsmaterials` DISABLE KEYS */;
/*!40000 ALTER TABLE `estprpriceoptioncostsmaterials` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estprpriceoptionprice`
--

DROP TABLE IF EXISTS `estprpriceoptionprice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estprpriceoptionprice` (
  `id` int(11) NOT NULL auto_increment,
  `proption` int(11) NOT NULL default '0',
  `stockusageid` int(11) NOT NULL default '0',
  `qty` double NOT NULL default '0',
  `amount` decimal(10,2) NOT NULL default '0.00',
  `qtycalchow` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estprpriceoptionprice`
--

LOCK TABLES `estprpriceoptionprice` WRITE;
/*!40000 ALTER TABLE `estprpriceoptionprice` DISABLE KEYS */;
/*!40000 ALTER TABLE `estprpriceoptionprice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estprpricestockusage`
--

DROP TABLE IF EXISTS `estprpricestockusage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estprpricestockusage` (
  `id` int(11) NOT NULL auto_increment,
  `prpriceid` int(11) NOT NULL default '0',
  `name` char(20) NOT NULL default '',
  `proptionone` double NOT NULL default '0',
  `proptiontwo` double NOT NULL default '0',
  `proptionqty` decimal(10,0) NOT NULL default '0',
  `maxinksfront` int(11) NOT NULL default '0',
  `mininksfront` int(11) NOT NULL default '0',
  `maxinksback` int(11) NOT NULL default '0',
  `mininksback` int(11) NOT NULL default '0',
  `maxpages` int(11) NOT NULL default '0',
  `inkcoveragedefault` int(11) NOT NULL default '1',
  `stockusageid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estprpricestockusage`
--

LOCK TABLES `estprpricestockusage` WRITE;
/*!40000 ALTER TABLE `estprpricestockusage` DISABLE KEYS */;
/*!40000 ALTER TABLE `estprpricestockusage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estprpricestockusagecolors`
--

DROP TABLE IF EXISTS `estprpricestockusagecolors`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estprpricestockusagecolors` (
  `id` int(11) NOT NULL auto_increment,
  `stocklistid` int(11) NOT NULL default '0',
  `substockcolorsid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estprpricestockusagecolors`
--

LOCK TABLES `estprpricestockusagecolors` WRITE;
/*!40000 ALTER TABLE `estprpricestockusagecolors` DISABLE KEYS */;
/*!40000 ALTER TABLE `estprpricestockusagecolors` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estprpricestockusagestock`
--

DROP TABLE IF EXISTS `estprpricestockusagestock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estprpricestockusagestock` (
  `id` int(11) NOT NULL auto_increment,
  `stockusageid` int(11) NOT NULL default '0',
  `proption` int(11) NOT NULL default '0',
  `substockid` int(11) NOT NULL default '0',
  `numberout` int(11) NOT NULL default '1',
  `cuts` int(11) NOT NULL default '0',
  `width` decimal(10,3) NOT NULL default '0.000',
  `length` decimal(10,3) NOT NULL default '0.000',
  `numberup` int(11) NOT NULL default '1',
  `addlchargeperm` decimal(10,2) NOT NULL default '0.00',
  `addlminimum` decimal(10,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estprpricestockusagestock`
--

LOCK TABLES `estprpricestockusagestock` WRITE;
/*!40000 ALTER TABLE `estprpricestockusagestock` DISABLE KEYS */;
/*!40000 ALTER TABLE `estprpricestockusagestock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estprpricetools`
--

DROP TABLE IF EXISTS `estprpricetools`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estprpricetools` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(30) NOT NULL default '',
  `description` char(100) NOT NULL default '',
  `locationid` int(11) NOT NULL default '0',
  `familyid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `firsttimeamount` decimal(10,2) NOT NULL default '0.00',
  `timesusedcounter` int(11) NOT NULL default '0',
  `costperuse` decimal(10,2) NOT NULL default '0.00',
  `priceperuse` decimal(10,2) NOT NULL default '0.00',
  `costperpresshour` decimal(10,2) NOT NULL default '0.00',
  `priceperpresshour` decimal(10,2) NOT NULL default '0.00',
  `priceperpressqty` decimal(10,2) NOT NULL default '0.00',
  `tooltype` int(11) NOT NULL default '0',
  `repeatlength` decimal(5,3) NOT NULL default '0.000',
  `across` int(11) NOT NULL default '0',
  `around` int(11) NOT NULL default '0',
  `cavityshape` char(30) NOT NULL default '',
  `cavitywidth` char(30) NOT NULL default '',
  `cavitydepth` char(30) NOT NULL default '',
  `gap` char(30) NOT NULL default '',
  `bearerwidth` char(30) NOT NULL default '',
  `gearpitchratio` int(11) NOT NULL default '0',
  `teeth` int(11) NOT NULL default '0',
  `addlsetuphrspress` decimal(5,2) NOT NULL default '0.00',
  `value` decimal(10,2) NOT NULL default '0.00',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estprpricetools`
--

LOCK TABLES `estprpricetools` WRITE;
/*!40000 ALTER TABLE `estprpricetools` DISABLE KEYS */;
/*!40000 ALTER TABLE `estprpricetools` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquote`
--

DROP TABLE IF EXISTS `estquote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquote` (
  `id` int(11) NOT NULL auto_increment,
  `quotenum` double NOT NULL default '0',
  `subquotenum` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `ponumber` varchar(30) default NULL,
  `priority` int(11) NOT NULL default '0',
  `duedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `worktypeid` int(11) NOT NULL default '0',
  `jobname` varchar(30) default NULL,
  `jobdesc` blob,
  `attn` varchar(30) default NULL,
  `custtrackingnum` varchar(20) default NULL,
  `custchargecode` varchar(30) default NULL,
  `formnumber` varchar(20) default NULL,
  `itemid` int(11) NOT NULL default '0',
  `itemcomposite` int(11) NOT NULL default '0',
  `prpriceid` int(11) NOT NULL default '0',
  `finishwidth` decimal(5,4) NOT NULL default '0.0000',
  `finishheight` decimal(5,4) NOT NULL default '0.0000',
  `flatwidth` decimal(5,4) NOT NULL default '0.0000',
  `flatheight` decimal(5,4) NOT NULL default '0.0000',
  `numpages` double NOT NULL default '0',
  `extuser` double NOT NULL default '0',
  `genuser` double NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquote`
--

LOCK TABLES `estquote` WRITE;
/*!40000 ALTER TABLE `estquote` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquote_covercolors`
--

DROP TABLE IF EXISTS `estquote_covercolors`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquote_covercolors` (
  `id` int(11) NOT NULL auto_increment,
  `colorname` varchar(50) NOT NULL default '',
  `cancel` int(5) NOT NULL default '0',
  `sortorder` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `addl_order_charge` decimal(19,5) NOT NULL default '0.00000',
  `addl_each_charge` decimal(19,5) NOT NULL default '0.00000',
  `outin` int(5) NOT NULL default '0',
  `pricelistid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `outin` (`outin`),
  KEY `pricelistid` (`pricelistid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquote_covercolors`
--

LOCK TABLES `estquote_covercolors` WRITE;
/*!40000 ALTER TABLE `estquote_covercolors` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquote_covercolors` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquote_deposit`
--

DROP TABLE IF EXISTS `estquote_deposit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquote_deposit` (
  `id` int(11) NOT NULL auto_increment,
  `id_printorder` int(11) NOT NULL default '0',
  `amount` decimal(12,4) NOT NULL default '0.0000',
  `payment_method` int(5) NOT NULL default '0',
  `transaction_id` varchar(32) default NULL,
  `entrydate` date default NULL,
  `cc_type` varchar(20) default NULL,
  `last4ofcard` varchar(4) default NULL,
  `voucherid` int(11) NOT NULL default '0',
  `cancel` int(3) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `bankdepositid` int(11) NOT NULL default '0',
  `checkid` varchar(20) NOT NULL default '',
  `currency` varchar(10) NOT NULL default 'USD',
  `bankfee_amount` decimal(19,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`),
  KEY `id_printorder` (`id_printorder`),
  KEY `voucherid` (`voucherid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquote_deposit`
--

LOCK TABLES `estquote_deposit` WRITE;
/*!40000 ALTER TABLE `estquote_deposit` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquote_deposit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquoteaddlstock`
--

DROP TABLE IF EXISTS `estquoteaddlstock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquoteaddlstock` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `itemcode` varchar(30) NOT NULL default '',
  `substockqty` int(11) NOT NULL default '0',
  `stockname` varchar(50) default NULL,
  `cancel` int(11) NOT NULL default '0',
  `substocksizeid` int(11) NOT NULL default '0',
  `genstockid` int(11) NOT NULL default '0',
  `substockcolorid` int(11) NOT NULL default '0',
  `substockid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `quoteid` (`quoteid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquoteaddlstock`
--

LOCK TABLES `estquoteaddlstock` WRITE;
/*!40000 ALTER TABLE `estquoteaddlstock` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquoteaddlstock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotebindery`
--

DROP TABLE IF EXISTS `estquotebindery`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotebindery` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `composition` int(2) NOT NULL default '0',
  `packaging` int(2) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotebindery`
--

LOCK TABLES `estquotebindery` WRITE;
/*!40000 ALTER TABLE `estquotebindery` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotebindery` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotebinderyaddl`
--

DROP TABLE IF EXISTS `estquotebinderyaddl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotebinderyaddl` (
  `id` int(11) NOT NULL auto_increment,
  `estquotebinderyid` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `question` blob NOT NULL,
  `validreply` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `qtyperpkg` decimal(5,0) NOT NULL default '1',
  `weightpermpkg` decimal(5,2) NOT NULL default '0.00',
  `turnaround` int(11) NOT NULL default '0',
  `tooltip` varchar(255) NOT NULL default '',
  `orderflag` int(11) NOT NULL default '0',
  `internalonly` int(2) NOT NULL default '0',
  `piecework_base` int(2) NOT NULL default '0',
  `piecework_name` varchar(20) default NULL,
  `pieceworkgroupid` int(11) NOT NULL default '0',
  `internal_quote` int(5) NOT NULL default '0',
  `external_quote` int(5) NOT NULL default '0',
  `internal_order` int(5) NOT NULL default '0',
  `external_order` int(5) NOT NULL default '0',
  `printdays` int(11) NOT NULL default '0',
  `replyGreaterThan` int(9) NOT NULL default '0',
  `replyMultiplyBy` decimal(10,6) NOT NULL default '1.000000',
  `maxTextLength` int(11) NOT NULL default '50',
  `monospace` int(5) NOT NULL default '0',
  `blockdisplay` int(5) NOT NULL default '0',
  `mustselect` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `external_quote` (`external_quote`),
  KEY `internal_order` (`internal_order`),
  KEY `internal_quote` (`internal_quote`),
  KEY `external_order` (`external_order`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotebinderyaddl`
--

LOCK TABLES `estquotebinderyaddl` WRITE;
/*!40000 ALTER TABLE `estquotebinderyaddl` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotebinderyaddl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotebinderyaddloptions`
--

DROP TABLE IF EXISTS `estquotebinderyaddloptions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotebinderyaddloptions` (
  `id` int(11) NOT NULL auto_increment,
  `binderyaddlid` int(11) NOT NULL default '0',
  `prompt` varchar(50) NOT NULL default '',
  `numprompt` decimal(10,2) NOT NULL default '0.00',
  `orderflag` int(11) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `binderyaddlid` (`binderyaddlid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotebinderyaddloptions`
--

LOCK TABLES `estquotebinderyaddloptions` WRITE;
/*!40000 ALTER TABLE `estquotebinderyaddloptions` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotebinderyaddloptions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotebinderyaddloptionsize`
--

DROP TABLE IF EXISTS `estquotebinderyaddloptionsize`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotebinderyaddloptionsize` (
  `id` int(11) NOT NULL auto_increment,
  `binderyaddlid` int(11) NOT NULL default '0',
  `binderyaddloptionsid` int(11) NOT NULL default '0',
  `estquotebinderyaddlsizeid` int(11) NOT NULL default '0',
  `amountaddl` decimal(19,5) NOT NULL default '0.00000',
  `setupaddl` decimal(5,2) NOT NULL default '0.00',
  `minimumaddl` decimal(5,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`),
  KEY `binderyaddlid` (`binderyaddlid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotebinderyaddloptionsize`
--

LOCK TABLES `estquotebinderyaddloptionsize` WRITE;
/*!40000 ALTER TABLE `estquotebinderyaddloptionsize` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotebinderyaddloptionsize` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotebinderyaddlsize`
--

DROP TABLE IF EXISTS `estquotebinderyaddlsize`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotebinderyaddlsize` (
  `id` int(11) NOT NULL auto_increment,
  `estquotebinderyaddlid` int(11) NOT NULL default '0',
  `estquotestdsizeid` int(11) NOT NULL default '0',
  `amount` decimal(5,2) NOT NULL default '0.00',
  `setupcharge` decimal(5,2) NOT NULL default '0.00',
  `minreply` decimal(10,2) NOT NULL default '0.00',
  `maxreply` decimal(10,2) NOT NULL default '0.00',
  `minimumcharge` decimal(5,2) NOT NULL default '0.00',
  `calculatehow` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `maxpass` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotebinderyaddlsize`
--

LOCK TABLES `estquotebinderyaddlsize` WRITE;
/*!40000 ALTER TABLE `estquotebinderyaddlsize` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotebinderyaddlsize` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotebinderyworktype`
--

DROP TABLE IF EXISTS `estquotebinderyworktype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotebinderyworktype` (
  `estquotebinderyid` int(11) NOT NULL default '0',
  `estquoteworktypeid` int(11) NOT NULL default '0',
  KEY `estquotebinderyid` (`estquotebinderyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotebinderyworktype`
--

LOCK TABLES `estquotebinderyworktype` WRITE;
/*!40000 ALTER TABLE `estquotebinderyworktype` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotebinderyworktype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotefile`
--

DROP TABLE IF EXISTS `estquotefile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotefile` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `filename` char(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `filename` (`filename`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotefile`
--

LOCK TABLES `estquotefile` WRITE;
/*!40000 ALTER TABLE `estquotefile` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotefile` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotegenink`
--

DROP TABLE IF EXISTS `estquotegenink`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotegenink` (
  `id` int(11) NOT NULL auto_increment,
  `maxcolors` int(11) NOT NULL default '1',
  `regcharge` decimal(4,2) NOT NULL default '0.00',
  `gencompanyid` int(11) NOT NULL default '0',
  `namecov1` char(20) NOT NULL default '',
  `namecov2` char(20) NOT NULL default '',
  `namecov3` char(20) NOT NULL default '',
  `namecov4` char(20) NOT NULL default '',
  `namecov5` char(20) NOT NULL default '',
  `namecov6` char(20) NOT NULL default '',
  `namecov7` char(20) NOT NULL default '',
  `namecov8` char(20) NOT NULL default '',
  `namecov9` char(20) NOT NULL default '',
  `covpct1` decimal(3,0) NOT NULL default '0',
  `covpct2` decimal(3,0) NOT NULL default '0',
  `covpct3` decimal(3,0) NOT NULL default '0',
  `covpct4` decimal(3,0) NOT NULL default '0',
  `covpct5` decimal(3,0) NOT NULL default '0',
  `covpct6` decimal(3,0) NOT NULL default '0',
  `covpct7` decimal(3,0) NOT NULL default '0',
  `covpct8` decimal(3,0) NOT NULL default '0',
  `covpct9` decimal(3,0) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotegenink`
--

LOCK TABLES `estquotegenink` WRITE;
/*!40000 ALTER TABLE `estquotegenink` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotegenink` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotegenstock`
--

DROP TABLE IF EXISTS `estquotegenstock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotegenstock` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(30) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `orderflag` int(11) NOT NULL default '0',
  `stdsizeid` int(5) NOT NULL default '0',
  `notforb2b` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotegenstock`
--

LOCK TABLES `estquotegenstock` WRITE;
/*!40000 ALTER TABLE `estquotegenstock` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotegenstock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotegenstock_inks`
--

DROP TABLE IF EXISTS `estquotegenstock_inks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotegenstock_inks` (
  `id` int(11) NOT NULL auto_increment,
  `inkid` int(11) NOT NULL default '0',
  `estquotegenstockid` int(11) NOT NULL default '0',
  `sides` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `estquotegenstockid` (`estquotegenstockid`),
  KEY `inkid` (`inkid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotegenstock_inks`
--

LOCK TABLES `estquotegenstock_inks` WRITE;
/*!40000 ALTER TABLE `estquotegenstock_inks` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotegenstock_inks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquoteink`
--

DROP TABLE IF EXISTS `estquoteink`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquoteink` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(50) NOT NULL default '',
  `jobprice` decimal(6,2) NOT NULL default '0.00',
  `mprice` decimal(6,4) NOT NULL default '0.0000',
  `type` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `costbased` int(11) NOT NULL default '0',
  `costper` decimal(6,2) NOT NULL default '0.00',
  `coverage` int(11) NOT NULL default '0',
  `setup` decimal(19,5) NOT NULL default '0.00000',
  `always_setup` int(5) NOT NULL default '0',
  `always_perM` int(5) NOT NULL default '0',
  `inkcountifvirtual` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquoteink`
--

LOCK TABLES `estquoteink` WRITE;
/*!40000 ALTER TABLE `estquoteink` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquoteink` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquoteorderreceived_how`
--

DROP TABLE IF EXISTS `estquoteorderreceived_how`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquoteorderreceived_how` (
  `id` int(11) NOT NULL auto_increment,
  `description` text NOT NULL,
  `cancel` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquoteorderreceived_how`
--

LOCK TABLES `estquoteorderreceived_how` WRITE;
/*!40000 ALTER TABLE `estquoteorderreceived_how` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquoteorderreceived_how` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotepieceworkgroup`
--

DROP TABLE IF EXISTS `estquotepieceworkgroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotepieceworkgroup` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotepieceworkgroup`
--

LOCK TABLES `estquotepieceworkgroup` WRITE;
/*!40000 ALTER TABLE `estquotepieceworkgroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotepieceworkgroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotepricelist`
--

DROP TABLE IF EXISTS `estquotepricelist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotepricelist` (
  `id` int(11) NOT NULL auto_increment,
  `stdsizeid` int(11) NOT NULL default '0',
  `worktypeid` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangeuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `gencompanyid` int(11) NOT NULL default '0',
  `maxinkside1` int(11) NOT NULL default '0',
  `maxinkside2` int(11) NOT NULL default '0',
  `trimchargepermpercut` decimal(8,2) NOT NULL default '0.00',
  `trimmincharge` decimal(8,2) NOT NULL default '0.00',
  `qtyperbox` decimal(5,0) NOT NULL default '0',
  `notes` blob NOT NULL,
  `point2id` int(11) NOT NULL default '0',
  `covereach_blackinandout` decimal(19,5) NOT NULL default '0.00000',
  `covereach_coloroutblackin` decimal(19,5) NOT NULL default '0.00000',
  `covereach_colorinandout` decimal(19,5) NOT NULL default '0.00000',
  `costper_nocover` decimal(19,5) NOT NULL default '0.00000',
  `covereach_colorinblackout` decimal(19,5) NOT NULL default '0.00000',
  `noinkcharge` int(5) NOT NULL default '0',
  `scrap_percent` decimal(5,2) NOT NULL default '0.00',
  `scrap_sheets_max` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotepricelist`
--

LOCK TABLES `estquotepricelist` WRITE;
/*!40000 ALTER TABLE `estquotepricelist` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotepricelist` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotepricelist_specials`
--

DROP TABLE IF EXISTS `estquotepricelist_specials`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotepricelist_specials` (
  `id` int(11) NOT NULL auto_increment,
  `typeofspecialid` int(11) NOT NULL default '0',
  `pricelistid` int(11) NOT NULL default '0',
  `addlcostper` decimal(19,5) NOT NULL default '0.00000',
  `cancel` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `pricelistid` (`pricelistid`),
  KEY `typeofspecialid` (`typeofspecialid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotepricelist_specials`
--

LOCK TABLES `estquotepricelist_specials` WRITE;
/*!40000 ALTER TABLE `estquotepricelist_specials` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotepricelist_specials` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotepricelistprice`
--

DROP TABLE IF EXISTS `estquotepricelistprice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotepricelistprice` (
  `id` int(11) NOT NULL auto_increment,
  `pricelistid` int(11) NOT NULL default '0',
  `quantity` decimal(10,0) NOT NULL default '0',
  `priceperm` decimal(6,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotepricelistprice`
--

LOCK TABLES `estquotepricelistprice` WRITE;
/*!40000 ALTER TABLE `estquotepricelistprice` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotepricelistprice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotepriceliststock`
--

DROP TABLE IF EXISTS `estquotepriceliststock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotepriceliststock` (
  `id` int(11) NOT NULL auto_increment,
  `pricelistid` int(11) NOT NULL default '0',
  `genstockid` int(11) NOT NULL default '0',
  `substockid` int(11) NOT NULL default '0',
  `addlchargeperm` decimal(6,2) NOT NULL default '0.00',
  `addlmincharge` decimal(6,2) NOT NULL default '0.00',
  `default_number_up` int(11) NOT NULL default '1',
  `default_parts` int(11) NOT NULL default '1',
  `default_partno` varchar(50) default NULL,
  `qtyperbox` int(11) NOT NULL default '0',
  `addlchargemult` decimal(10,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotepriceliststock`
--

LOCK TABLES `estquotepriceliststock` WRITE;
/*!40000 ALTER TABLE `estquotepriceliststock` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotepriceliststock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotepriceliststockcolors`
--

DROP TABLE IF EXISTS `estquotepriceliststockcolors`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotepriceliststockcolors` (
  `id` int(11) NOT NULL auto_increment,
  `priceliststockid` int(11) NOT NULL default '0',
  `substockcolorsid` int(11) NOT NULL default '0',
  `default_partno` varchar(30) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotepriceliststockcolors`
--

LOCK TABLES `estquotepriceliststockcolors` WRITE;
/*!40000 ALTER TABLE `estquotepriceliststockcolors` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotepriceliststockcolors` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotepricelistupdatelog`
--

DROP TABLE IF EXISTS `estquotepricelistupdatelog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotepricelistupdatelog` (
  `id` int(11) NOT NULL auto_increment,
  `worktypeid` int(11) NOT NULL default '0',
  `pricelistid` int(11) NOT NULL default '0',
  `multiplier` varchar(50) NOT NULL default '',
  `maxinkside1` varchar(50) default NULL,
  `maxinkside2` varchar(50) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotepricelistupdatelog`
--

LOCK TABLES `estquotepricelistupdatelog` WRITE;
/*!40000 ALTER TABLE `estquotepricelistupdatelog` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotepricelistupdatelog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquoteqty`
--

DROP TABLE IF EXISTS `estquoteqty`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquoteqty` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `qty` double NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `quoteid` (`quoteid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquoteqty`
--

LOCK TABLES `estquoteqty` WRITE;
/*!40000 ALTER TABLE `estquoteqty` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquoteqty` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequest`
--

DROP TABLE IF EXISTS `estquotequest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequest` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `questionid` int(11) NOT NULL default '0',
  `yesno` int(11) NOT NULL default '0',
  `selection` double NOT NULL default '0',
  `text` char(50) default NULL,
  PRIMARY KEY  (`id`),
  KEY `quoteid` (`quoteid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequest`
--

LOCK TABLES `estquotequest` WRITE;
/*!40000 ALTER TABLE `estquotequest` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequote`
--

DROP TABLE IF EXISTS `estquotequote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequote` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `contactname` varchar(50) default NULL,
  `stdsizeid` int(11) NOT NULL default '0',
  `cwidth` decimal(10,3) NOT NULL default '0.000',
  `clength` decimal(10,3) NOT NULL default '0.000',
  `substockid` int(11) NOT NULL default '0',
  `tightreg1` int(11) NOT NULL default '0',
  `tightreg2` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `description` varchar(255) default NULL,
  `substockcolorid` int(11) NOT NULL default '0',
  `shippingservice` char(3) default NULL,
  `shippingzipcode` varchar(12) default NULL,
  `special` varchar(255) default NULL,
  `quotenum` varchar(20) default NULL,
  `extuser` double NOT NULL default '0',
  `genuser` double NOT NULL default '0',
  `pricelistid` int(11) NOT NULL default '0',
  `duedate` date default NULL,
  `finalshipdate` date default NULL,
  `status` int(5) NOT NULL default '0',
  `billdate` date default NULL,
  `order_quantity` int(11) NOT NULL default '0',
  `shiptotal` decimal(12,2) NOT NULL default '0.00',
  `billtotal` decimal(12,2) NOT NULL default '0.00',
  `orderdate` date default NULL,
  `instructions` varchar(255) default NULL,
  `id_printorder` int(11) NOT NULL default '0',
  `extras` int(11) NOT NULL default '0',
  `numup` int(11) NOT NULL default '1',
  `itemid` int(11) NOT NULL default '0',
  `papername` varchar(50) default NULL,
  `paperwidth` decimal(12,3) NOT NULL default '0.000',
  `paperlength` decimal(12,3) NOT NULL default '0.000',
  `priority` int(2) NOT NULL default '0',
  `formnumber` varchar(50) default NULL,
  `numparts` int(11) NOT NULL default '1',
  `salesglacctid` int(11) NOT NULL default '0',
  `presslength` decimal(12,2) NOT NULL default '0.00',
  `presswidth` decimal(12,2) NOT NULL default '0.00',
  `customer_po` varchar(30) default NULL,
  `print_how` int(2) NOT NULL default '0',
  `rush_charge` decimal(12,4) NOT NULL default '0.0000',
  `composition_charge` decimal(12,4) NOT NULL default '0.0000',
  `glrush` int(11) NOT NULL default '0',
  `glcomposition` int(11) NOT NULL default '0',
  `reprint` int(11) NOT NULL default '0',
  `printdate` date default NULL,
  `calculated_qty` decimal(12,5) NOT NULL default '0.00000',
  `sell_total` decimal(12,5) NOT NULL default '0.00000',
  `calculated_total` decimal(14,5) NOT NULL default '0.00000',
  `previous_id_printorder` int(11) NOT NULL default '0',
  `client_notes` text,
  `confirm_date` date default NULL,
  `sigmult` int(11) NOT NULL default '1',
  `parts_separate` int(5) NOT NULL default '0',
  `addparts` int(5) NOT NULL default '0',
  `thispart` int(11) NOT NULL default '0',
  `invoiceto_companyid` int(11) NOT NULL default '0',
  `order_discount_percent` decimal(4,2) NOT NULL default '0.00',
  `preferred_shipdate` date default NULL,
  `receivedate` date default NULL,
  `shipbefore` date default NULL,
  `shipafter` int(5) NOT NULL default '5',
  `orderyear` varchar(4) NOT NULL default '',
  `art_number` varchar(30) NOT NULL default '',
  `reorder` int(5) NOT NULL default '0',
  `ordertaker` varchar(10) NOT NULL default '',
  `problem` int(5) NOT NULL default '0',
  `rush` int(5) NOT NULL default '0',
  `order_sourceid` int(11) NOT NULL default '0',
  `sales_responseid` int(11) NOT NULL default '0',
  `shipnote` varchar(100) NOT NULL default '',
  `ok` int(5) NOT NULL default '0',
  `okdate` date default NULL,
  `topress` int(5) NOT NULL default '0',
  `topressdate` date default NULL,
  `print_what_on_covers` int(5) NOT NULL default '0',
  `rescom` int(5) NOT NULL default '0',
  `couponid` int(11) NOT NULL default '0',
  `coupon_amount` decimal(16,5) NOT NULL default '0.00000',
  `pricepercover` decimal(19,5) NOT NULL default '0.00000',
  `priceperspecialdesign` decimal(19,5) NOT NULL default '0.00000',
  `pricepercolorborder` decimal(19,5) NOT NULL default '0.00000',
  `priceperpremium` decimal(19,5) NOT NULL default '0.00000',
  `priceperstandard` decimal(19,5) NOT NULL default '0.00000',
  `totalpriceperbook` decimal(19,5) NOT NULL default '0.00000',
  `basepriceperbook` decimal(19,5) NOT NULL default '0.00000',
  `totaldiscountamount` decimal(19,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`),
  KEY `duedate` (`duedate`),
  KEY `duedate_2` (`duedate`),
  KEY `customerid` (`customerid`),
  KEY `itemid` (`itemid`),
  KEY `id_printorder` (`id_printorder`),
  KEY `formnumber` (`formnumber`),
  KEY `orderdate` (`orderdate`),
  KEY `finalshipdate` (`finalshipdate`),
  KEY `confirm_date` (`confirm_date`),
  KEY `invoiceto_companyid` (`invoiceto_companyid`),
  KEY `ok` (`ok`),
  KEY `topress` (`topress`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `order_quantity` (`order_quantity`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequote`
--

LOCK TABLES `estquotequote` WRITE;
/*!40000 ALTER TABLE `estquotequote` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequote_covers`
--

DROP TABLE IF EXISTS `estquotequote_covers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequote_covers` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `outside_cover_design_nr` varchar(30) NOT NULL default '',
  `outside_cover_color5id` int(11) NOT NULL default '0',
  `outside_cover_permit_nr` varchar(50) NOT NULL default '',
  `inside_cover_color5id` int(11) NOT NULL default '0',
  `inside_cover_special_print` varchar(100) NOT NULL default '',
  `inside_cover_color1id` int(11) NOT NULL default '0',
  `nocovers` int(5) NOT NULL default '0',
  `nowindow` int(5) NOT NULL default '0',
  `large_diecut` int(5) NOT NULL default '0',
  `outside_cover_color1id` int(11) NOT NULL default '0',
  `outside_cover_color2id` int(11) NOT NULL default '0',
  `outside_cover_color3id` int(11) NOT NULL default '0',
  `outside_cover_color4id` int(11) NOT NULL default '0',
  `outside_custom_color1` varchar(30) NOT NULL default '',
  `outside_custom_color2` varchar(30) NOT NULL default '',
  `inside_cover_color2id` int(11) NOT NULL default '0',
  `inside_cover_color3id` int(11) NOT NULL default '0',
  `inside_cover_color4id` int(11) NOT NULL default '0',
  `inside_custom_color1` varchar(30) NOT NULL default '',
  `inside_custom_color2` varchar(30) NOT NULL default '',
  `covernumber` int(5) NOT NULL default '0',
  `inside_cover_design_nr` varchar(30) NOT NULL default '',
  `covertotal` decimal(19,5) NOT NULL default '0.00000',
  `inhouse_or_custom` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `quoteid` (`quoteid`),
  KEY `covernumber` (`covernumber`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequote_covers`
--

LOCK TABLES `estquotequote_covers` WRITE;
/*!40000 ALTER TABLE `estquotequote_covers` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequote_covers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequote_envelopes`
--

DROP TABLE IF EXISTS `estquotequote_envelopes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequote_envelopes` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `specialdate` date default NULL,
  `line1` varchar(100) NOT NULL default '',
  `line2` varchar(100) NOT NULL default '',
  `line3` varchar(100) NOT NULL default '',
  `dating_type` int(5) default NULL,
  `premium_color` varchar(30) default NULL,
  `border_color` varchar(30) default NULL,
  `custom_color` varchar(30) default NULL,
  `custom_design_nr` varchar(30) default NULL,
  `ink_description` int(5) NOT NULL default '0',
  `ink_name` int(5) NOT NULL default '0',
  `ink_date` int(5) NOT NULL default '0',
  `sortorder` int(11) NOT NULL default '0',
  `costper` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `specialdate` (`specialdate`),
  KEY `quoteid` (`quoteid`),
  KEY `sortorder` (`sortorder`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequote_envelopes`
--

LOCK TABLES `estquotequote_envelopes` WRITE;
/*!40000 ALTER TABLE `estquotequote_envelopes` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequote_envelopes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequote_instructions`
--

DROP TABLE IF EXISTS `estquotequote_instructions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequote_instructions` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `workareaid` int(11) NOT NULL default '0',
  `instructions` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  KEY `workareaid` (`workareaid`),
  KEY `quoteid` (`quoteid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequote_instructions`
--

LOCK TABLES `estquotequote_instructions` WRITE;
/*!40000 ALTER TABLE `estquotequote_instructions` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequote_instructions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequote_items`
--

DROP TABLE IF EXISTS `estquotequote_items`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequote_items` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `qty` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `entrydate` date default NULL,
  `itemtransid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `id_printorder` (`id_printorder`),
  KEY `itemid` (`itemid`),
  KEY `cancel` (`cancel`),
  KEY `itemtransid` (`itemtransid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequote_items`
--

LOCK TABLES `estquotequote_items` WRITE;
/*!40000 ALTER TABLE `estquotequote_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequote_items` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequote_shipment`
--

DROP TABLE IF EXISTS `estquotequote_shipment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequote_shipment` (
  `id_shipment` int(11) NOT NULL default '0',
  `id_order_shipto` int(11) NOT NULL default '0',
  `quantity` int(15) NOT NULL default '0',
  `shipdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_shipmentlog` int(11) NOT NULL default '0',
  `packslip` int(2) NOT NULL default '0',
  `boxlabel` int(2) NOT NULL default '0',
  `logdate` datetime default NULL,
  `createdate` date default NULL,
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` date default NULL,
  `cancel` int(11) NOT NULL default '0',
  `signfor` varchar(255) default NULL,
  `failed` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `notes` varchar(255) default NULL,
  `id_order_shipment_group` int(11) NOT NULL default '0',
  `trackingnum` varchar(30) default NULL,
  `invoiceid` int(11) NOT NULL default '0',
  `freight` decimal(12,2) NOT NULL default '0.00',
  `carrierserviceid` int(11) NOT NULL default '0',
  `numperbox` int(11) NOT NULL default '0',
  `numboxes` int(11) NOT NULL default '0',
  `id_estquoteship` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_shipment`),
  KEY `id_order_shipto` (`id_order_shipto`),
  KEY `id_order_shipment_group` (`id_order_shipment_group`),
  KEY `id_printorder` (`id_printorder`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequote_shipment`
--

LOCK TABLES `estquotequote_shipment` WRITE;
/*!40000 ALTER TABLE `estquotequote_shipment` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequote_shipment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequote_shipmentseq`
--

DROP TABLE IF EXISTS `estquotequote_shipmentseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequote_shipmentseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequote_shipmentseq`
--

LOCK TABLES `estquotequote_shipmentseq` WRITE;
/*!40000 ALTER TABLE `estquotequote_shipmentseq` DISABLE KEYS */;
INSERT INTO `estquotequote_shipmentseq` VALUES (0);
/*!40000 ALTER TABLE `estquotequote_shipmentseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequote_specials`
--

DROP TABLE IF EXISTS `estquotequote_specials`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequote_specials` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `specialdatesid` int(11) NOT NULL default '0',
  `specialdate` date default NULL,
  `line1` varchar(100) NOT NULL default '',
  `line2` varchar(100) NOT NULL default '',
  `line3` varchar(100) NOT NULL default '',
  `dating_type` int(5) default NULL,
  `premium_color` varchar(30) default NULL,
  `border_color` varchar(30) default NULL,
  `custom_color` varchar(30) default NULL,
  `custom_design_nr` varchar(30) default NULL,
  `ink_description` int(5) NOT NULL default '0',
  `ink_name` int(5) NOT NULL default '0',
  `insert_where_if_samedate` int(5) NOT NULL default '0',
  `sequence` int(5) NOT NULL default '0',
  `std` int(5) NOT NULL default '0',
  `thisorlast` int(5) NOT NULL default '0',
  `ink_date` int(5) NOT NULL default '0',
  `repeating` int(5) NOT NULL default '0',
  `eachday` int(5) NOT NULL default '0',
  `costper` decimal(19,5) NOT NULL default '0.00000',
  `costtotal` decimal(19,5) NOT NULL default '0.00000',
  `binderyaddloptionsid` int(11) NOT NULL default '0',
  `binderyid` int(11) NOT NULL default '3',
  PRIMARY KEY  (`id`),
  KEY `quoteid` (`quoteid`),
  KEY `specialdatesid` (`specialdatesid`),
  KEY `std` (`std`),
  KEY `sequence` (`sequence`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequote_specials`
--

LOCK TABLES `estquotequote_specials` WRITE;
/*!40000 ALTER TABLE `estquotequote_specials` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequote_specials` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequotebindquest`
--

DROP TABLE IF EXISTS `estquotequotebindquest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequotebindquest` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `questionid` int(11) NOT NULL default '0',
  `yesno` int(11) NOT NULL default '0',
  `numbetween` double NOT NULL default '0',
  `text` varchar(100) NOT NULL default '',
  `snumbetween` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `quoteid` (`quoteid`),
  KEY `numbetween` (`numbetween`),
  KEY `snumbetween` (`snumbetween`),
  KEY `questionid` (`questionid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequotebindquest`
--

LOCK TABLES `estquotequotebindquest` WRITE;
/*!40000 ALTER TABLE `estquotequotebindquest` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequotebindquest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequoteink`
--

DROP TABLE IF EXISTS `estquotequoteink`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequoteink` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `side` int(11) NOT NULL default '1',
  `inkid` int(11) NOT NULL default '0',
  `pms` char(4) default NULL,
  PRIMARY KEY  (`id`),
  KEY `quoteid` (`quoteid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequoteink`
--

LOCK TABLES `estquotequoteink` WRITE;
/*!40000 ALTER TABLE `estquotequoteink` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequoteink` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequotenotes`
--

DROP TABLE IF EXISTS `estquotequotenotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequotenotes` (
  `id` int(11) NOT NULL auto_increment,
  `quotebold` varchar(50) NOT NULL default '',
  `quotetext` blob NOT NULL,
  `showwhen` int(11) NOT NULL default '0',
  `orderflag` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequotenotes`
--

LOCK TABLES `estquotequotenotes` WRITE;
/*!40000 ALTER TABLE `estquotequotenotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequotenotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequoteqty`
--

DROP TABLE IF EXISTS `estquotequoteqty`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequoteqty` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `qty` double NOT NULL default '0',
  `weight` decimal(10,2) NOT NULL default '0.00',
  `total` decimal(10,2) NOT NULL default '0.00',
  `shipcost` decimal(10,2) NOT NULL default '0.00',
  `turnaround` int(11) NOT NULL default '1',
  `mcost` decimal(10,2) NOT NULL default '0.00',
  `comptotal` double NOT NULL default '0',
  `boxes` int(11) NOT NULL default '0',
  `printdays` int(11) NOT NULL default '0',
  `covers` decimal(19,5) NOT NULL default '0.00000',
  `specials` decimal(19,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`),
  KEY `quoteid` (`quoteid`),
  KEY `qty` (`qty`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequoteqty`
--

LOCK TABLES `estquotequoteqty` WRITE;
/*!40000 ALTER TABLE `estquotequoteqty` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequoteqty` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotequotequest`
--

DROP TABLE IF EXISTS `estquotequotequest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotequotequest` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `questionid` int(11) NOT NULL default '0',
  `yesno` int(11) NOT NULL default '0',
  `numbetween` double NOT NULL default '0',
  `text` char(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `quoteid` (`quoteid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotequotequest`
--

LOCK TABLES `estquotequotequest` WRITE;
/*!40000 ALTER TABLE `estquotequotequest` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotequotequest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotesalescampaign`
--

DROP TABLE IF EXISTS `estquotesalescampaign`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotesalescampaign` (
  `id` int(11) NOT NULL auto_increment,
  `description` text NOT NULL,
  `hide` int(5) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `hide` (`hide`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotesalescampaign`
--

LOCK TABLES `estquotesalescampaign` WRITE;
/*!40000 ALTER TABLE `estquotesalescampaign` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotesalescampaign` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquoteship`
--

DROP TABLE IF EXISTS `estquoteship`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquoteship` (
  `id` int(11) NOT NULL auto_increment,
  `id_printorder` double NOT NULL default '0',
  `shiptoid` int(11) NOT NULL default '0',
  `carrierserviceid` int(11) NOT NULL default '0',
  `shipqty` double NOT NULL default '0',
  `attn` varchar(50) NOT NULL default '',
  `weight` double NOT NULL default '0',
  `cost` double NOT NULL default '0',
  `boxes` int(11) NOT NULL default '0',
  `zipcode` varchar(12) NOT NULL default '0',
  `qtyperfullbox` int(11) NOT NULL default '0',
  `packages` int(11) NOT NULL default '0',
  `client_po` varchar(30) default NULL,
  `invoiceid` int(11) NOT NULL default '0',
  `client_name` varchar(100) default NULL,
  `shiptoname` varchar(255) default NULL,
  `shiptoaddress` varchar(255) default NULL,
  `shiptoaddress2` varchar(255) default NULL,
  `shiptocity` varchar(50) default NULL,
  `shiptostate` varchar(20) default NULL,
  `shiptozip` varchar(15) default NULL,
  `shiptophone` varchar(20) default NULL,
  `shipfromname` varchar(255) default NULL,
  `shipfromaddress` varchar(255) default NULL,
  `shipfromaddress2` varchar(255) default NULL,
  `shipfromcity` varchar(50) default NULL,
  `shipfromstate` varchar(20) default NULL,
  `shipfromzip` varchar(15) default NULL,
  `shipper_number` varchar(30) default NULL,
  `billto` varchar(20) default NULL,
  `shipname2` varchar(50) NOT NULL default '',
  `rescom` int(5) NOT NULL default '0',
  `customer_email` varchar(50) NOT NULL default '',
  `csr_email` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `carrierserviceid` (`carrierserviceid`),
  KEY `shiptoid` (`shiptoid`),
  KEY `id_printorder` (`id_printorder`),
  KEY `invoiceid` (`invoiceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquoteship`
--

LOCK TABLES `estquoteship` WRITE;
/*!40000 ALTER TABLE `estquoteship` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquoteship` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotestdsize`
--

DROP TABLE IF EXISTS `estquotestdsize`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotestdsize` (
  `id` int(11) NOT NULL auto_increment,
  `length` decimal(10,3) NOT NULL default '0.000',
  `width` decimal(10,3) NOT NULL default '0.000',
  `gencompanyid` int(11) NOT NULL default '0',
  `orderflag` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotestdsize`
--

LOCK TABLES `estquotestdsize` WRITE;
/*!40000 ALTER TABLE `estquotestdsize` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotestdsize` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotestock`
--

DROP TABLE IF EXISTS `estquotestock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotestock` (
  `id` int(11) NOT NULL auto_increment,
  `quoteid` int(11) NOT NULL default '0',
  `stockusageid` int(11) NOT NULL default '0',
  `stocklistid` int(11) NOT NULL default '0',
  `flatwidth` decimal(5,4) NOT NULL default '0.0000',
  `flatheight` decimal(5,4) NOT NULL default '0.0000',
  `numpages` double NOT NULL default '0',
  `notes` blob,
  PRIMARY KEY  (`id`),
  KEY `stockusageid` (`stockusageid`),
  KEY `stocklistid` (`stocklistid`),
  KEY `quoteid` (`quoteid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotestock`
--

LOCK TABLES `estquotestock` WRITE;
/*!40000 ALTER TABLE `estquotestock` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotestock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotestockink`
--

DROP TABLE IF EXISTS `estquotestockink`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotestockink` (
  `id` int(11) NOT NULL auto_increment,
  `quotestockid` int(11) NOT NULL default '0',
  `inkid` int(11) NOT NULL default '0',
  `side` int(11) NOT NULL default '1',
  `inknum` int(11) NOT NULL default '0',
  `coverage` decimal(5,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`id`),
  KEY `quotestockid` (`quotestockid`),
  KEY `inkid` (`inkid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotestockink`
--

LOCK TABLES `estquotestockink` WRITE;
/*!40000 ALTER TABLE `estquotestockink` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotestockink` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotestocktool`
--

DROP TABLE IF EXISTS `estquotestocktool`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotestocktool` (
  `id` int(11) NOT NULL auto_increment,
  `quotestockid` int(11) NOT NULL default '0',
  `toolid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `quotestockid` (`quotestockid`),
  KEY `toolid` (`toolid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotestocktool`
--

LOCK TABLES `estquotestocktool` WRITE;
/*!40000 ALTER TABLE `estquotestocktool` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotestocktool` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotesubstock`
--

DROP TABLE IF EXISTS `estquotesubstock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotesubstock` (
  `id` int(11) NOT NULL auto_increment,
  `estquotegenstockid` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `weight` decimal(6,4) NOT NULL default '0.0000',
  `turnaround` int(11) NOT NULL default '0',
  `orderflag` int(11) NOT NULL default '0',
  `parts` int(11) NOT NULL default '1',
  `inchesperm` decimal(4,2) NOT NULL default '0.00',
  `parts_separate` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `estquotegenstockid` (`estquotegenstockid`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotesubstock`
--

LOCK TABLES `estquotesubstock` WRITE;
/*!40000 ALTER TABLE `estquotesubstock` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotesubstock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotesubstockcolors`
--

DROP TABLE IF EXISTS `estquotesubstockcolors`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotesubstockcolors` (
  `id` int(11) NOT NULL auto_increment,
  `substockid` int(11) NOT NULL default '0',
  `color` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `substockid` (`substockid`),
  KEY `color` (`color`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotesubstockcolors`
--

LOCK TABLES `estquotesubstockcolors` WRITE;
/*!40000 ALTER TABLE `estquotesubstockcolors` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotesubstockcolors` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotesubstockcolorsize`
--

DROP TABLE IF EXISTS `estquotesubstockcolorsize`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotesubstockcolorsize` (
  `id` int(11) NOT NULL auto_increment,
  `substockid` int(11) NOT NULL default '0',
  `substockcolorid` int(11) NOT NULL default '0',
  `sizename` varchar(20) default NULL,
  `partno` varchar(50) default NULL,
  PRIMARY KEY  (`id`),
  KEY `substockid` (`substockid`),
  KEY `substockcolorid` (`substockcolorid`),
  KEY `partno` (`partno`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotesubstockcolorsize`
--

LOCK TABLES `estquotesubstockcolorsize` WRITE;
/*!40000 ALTER TABLE `estquotesubstockcolorsize` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotesubstockcolorsize` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotesubstockcost`
--

DROP TABLE IF EXISTS `estquotesubstockcost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotesubstockcost` (
  `id` int(11) NOT NULL auto_increment,
  `substockid` int(11) NOT NULL default '0',
  `stocktype` int(11) NOT NULL default '0',
  `length` decimal(10,4) NOT NULL default '0.0000',
  `width` decimal(10,4) NOT NULL default '0.0000',
  `cost` decimal(10,4) NOT NULL default '0.0000',
  `costhow` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cost` (`cost`),
  KEY `width` (`width`),
  KEY `itemid` (`itemid`),
  KEY `length` (`length`),
  KEY `substockid` (`substockid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotesubstockcost`
--

LOCK TABLES `estquotesubstockcost` WRITE;
/*!40000 ALTER TABLE `estquotesubstockcost` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotesubstockcost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotesubstocksize`
--

DROP TABLE IF EXISTS `estquotesubstocksize`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotesubstocksize` (
  `id` int(11) NOT NULL auto_increment,
  `substockid` int(11) NOT NULL default '0',
  `sizename` varchar(20) default NULL,
  `partno` varchar(50) default NULL,
  `partno2` varchar(50) default NULL,
  `partno3` varchar(50) default NULL,
  `partno4` varchar(50) default NULL,
  `partno5` varchar(50) default NULL,
  `partno6` varchar(50) default NULL,
  `partno7` varchar(50) default NULL,
  `partno8` varchar(50) default NULL,
  `partno9` varchar(50) default NULL,
  `partno10` varchar(50) default NULL,
  PRIMARY KEY  (`id`),
  KEY `substockid` (`substockid`),
  KEY `partno` (`partno`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotesubstocksize`
--

LOCK TABLES `estquotesubstocksize` WRITE;
/*!40000 ALTER TABLE `estquotesubstocksize` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotesubstocksize` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquotetypeofspecial`
--

DROP TABLE IF EXISTS `estquotetypeofspecial`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquotetypeofspecial` (
  `id` int(11) NOT NULL auto_increment,
  `sname` varchar(100) NOT NULL default '',
  `svalue` int(5) NOT NULL default '0',
  `addlcostper` decimal(19,5) NOT NULL default '0.00000',
  `isdefault` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `isdefault` (`isdefault`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquotetypeofspecial`
--

LOCK TABLES `estquotetypeofspecial` WRITE;
/*!40000 ALTER TABLE `estquotetypeofspecial` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquotetypeofspecial` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquoteworktype`
--

DROP TABLE IF EXISTS `estquoteworktype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquoteworktype` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `turnaroundqty` decimal(10,0) NOT NULL default '0',
  `turnarounddaysuptoqty` int(11) NOT NULL default '0',
  `turnarounddaysoverqty` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangeuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `notes` blob NOT NULL,
  `genworktypeid` int(11) NOT NULL default '0',
  `orderflag` int(11) NOT NULL default '0',
  `tightregrule` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquoteworktype`
--

LOCK TABLES `estquoteworktype` WRITE;
/*!40000 ALTER TABLE `estquoteworktype` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquoteworktype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquoteworktypeaddl`
--

DROP TABLE IF EXISTS `estquoteworktypeaddl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquoteworktypeaddl` (
  `id` int(11) NOT NULL auto_increment,
  `worktypeid` int(11) NOT NULL default '0',
  `question` char(50) NOT NULL default '',
  `validreply` int(11) NOT NULL default '0',
  `minreply` decimal(10,2) NOT NULL default '0.00',
  `maxreply` decimal(10,2) NOT NULL default '0.00',
  `askonlyifmtblackink` int(11) NOT NULL default '0',
  `askonlyifmtoneink` int(11) NOT NULL default '0',
  `askonlyminsizelength` decimal(10,2) NOT NULL default '0.00',
  `askonlyminsizewidth` decimal(10,2) NOT NULL default '0.00',
  `askonlymaxsizelength` decimal(10,2) NOT NULL default '0.00',
  `askonlymaxsizewidth` decimal(10,2) NOT NULL default '0.00',
  `calculatehow` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `askonlyifmtoneside` int(11) NOT NULL default '0',
  `amount` decimal(5,2) NOT NULL default '0.00',
  `askonlyifoneink` int(11) NOT NULL default '0',
  `aboveqty` decimal(10,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquoteworktypeaddl`
--

LOCK TABLES `estquoteworktypeaddl` WRITE;
/*!40000 ALTER TABLE `estquoteworktypeaddl` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquoteworktypeaddl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquoteworktypegen`
--

DROP TABLE IF EXISTS `estquoteworktypegen`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquoteworktypegen` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(50) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `orderflag` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquoteworktypegen`
--

LOCK TABLES `estquoteworktypegen` WRITE;
/*!40000 ALTER TABLE `estquoteworktypegen` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquoteworktypegen` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `estquoteworktypestdqty`
--

DROP TABLE IF EXISTS `estquoteworktypestdqty`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `estquoteworktypestdqty` (
  `id` int(11) NOT NULL auto_increment,
  `quantity` decimal(10,0) NOT NULL default '0',
  `worktypeid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `estquoteworktypestdqty`
--

LOCK TABLES `estquoteworktypestdqty` WRITE;
/*!40000 ALTER TABLE `estquoteworktypestdqty` DISABLE KEYS */;
/*!40000 ALTER TABLE `estquoteworktypestdqty` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `event`
--

DROP TABLE IF EXISTS `event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `event` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `module` varchar(10) NOT NULL,
  `section` varchar(50) NOT NULL,
  `action` varchar(50) NOT NULL,
  `link` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `module` (`module`),
  KEY `section` (`section`),
  KEY `action` (`action`),
  KEY `event` (`module`,`section`,`action`)
) ENGINE=MyISAM AUTO_INCREMENT=160 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `event`
--

LOCK TABLES `event` WRITE;
/*!40000 ALTER TABLE `event` DISABLE KEYS */;
INSERT INTO `event` VALUES (1,'ar','order','add','arordpicktick.php?caller=1&ordernumber='),(2,'ar','order','update','arordpicktick.php?caller=1&ordernumber='),(3,'ar','order','quote','arordpicktick.php?caller=1&ordernumber='),(4,'ar','order','delete',''),(5,'ar','order','invoice','arinvoiceview.php?caller=1&invoiceid='),(6,'ar','order','shipment',''),(7,'ar','customer','add','arcustupd.php?customerid='),(8,'ar','customer','update','arcustupd.php?customerid='),(9,'ar','customer','delete',''),(10,'ar','shipto','add',''),(11,'ar','shipto','update',''),(12,'ar','shipto','delete',''),(13,'ar','salescategory','add','adminarsales_category.php?id='),(14,'ar','salescategory','update','adminarsales_category.php?id='),(15,'ar','salescategory','delete',''),(16,'ar','rma','add',''),(17,'ar','rma','update',''),(18,'ar','rma','delete',''),(19,'ar','payment','add',''),(20,'ar','salesterritory','edit',''),(21,'ar','salesperson','add','adminarsalesmanupd.php?id='),(22,'ar','salesperson','update','adminarsalesmanupd.php?id='),(23,'ar','salesperson','delete',''),(24,'ar','carrier','add','adminarcarrierupd.php?carrierid='),(25,'ar','carrier','update','adminarcarrierupd.php?carrierid='),(26,'ar','carrier','delete',''),(27,'ar','carriermethod','add',''),(28,'ar','carriermethod','update',''),(29,'ar','carriermethod','delete',''),(30,'ar','bankdeposit','add','arbankdepositupd.php?bankdepositid='),(31,'ar','bankdeposit','delete',''),(32,'ar','creditcheck','write','checks.php?apbill=1&archeck=1&checknbr='),(33,'ar','invoice','add','arinvoiceview.php?caller=1&invoiceid='),(34,'ar','invoice','update','arinvoiceview.php?caller=1&invoiceid='),(35,'ar','invoice','delete',''),(36,'b2b','payment','add',''),(37,'b2b','order','add','arordpicktick.php?caller=1&ordernumber='),(38,'b2b','customer','update','arcustupd.php?customerid='),(39,'inv','item','add','invitemupd.php?itemid='),(40,'inv','item','update','invitemupd.php?itemid='),(41,'inv','item','delete',''),(42,'inv','item','adjustment',''),(43,'inv','item','transfer',''),(44,'inv','itemvendor','add',''),(45,'inv','itemvendor','update',''),(46,'inv','itemvendor','delete',''),(47,'inv','itemlocation','add',''),(48,'inv','itemlocation','update',''),(49,'inv','itemlocation','delete',''),(50,'gl','voucher','add','gljourupd.php?selectv=1&vid='),(51,'gl','voucher','update','gljourupd.php?selectv=1&vid='),(52,'gl','voucher','delete',''),(53,'gl','voucher','post',''),(54,'gl','voucher','postreverse',''),(55,'gl','year','close',''),(56,'gl','account','add','glacctupd.php?id='),(57,'gl','account','update','glacctupd.php?id='),(58,'gl','account','delete',''),(59,'gl','account','reactivate','glacctupd.php?id='),(60,'gl','bank','reconcile',''),(61,'pr','employee','add','premployeeupd.php?employeeid='),(62,'pr','employee','update','premployeeupd.php?employeeid='),(63,'pr','period','calculate',''),(64,'pr','check','edit',''),(65,'pr','check','write',''),(66,'pr','hours','add',''),(67,'pr','employeededuction','add',''),(68,'pr','employeededuction','update',''),(69,'pr','employeededuction','delete',''),(70,'pr','generaldeduction','add',''),(71,'pr','generaldeduction','update',''),(72,'pr','generaldeduction','delete',''),(73,'pr','generalbenefit','add',''),(74,'pr','generalbenefit','update',''),(75,'pr','generalbenefit','delete',''),(76,'pr','generalfactors','update',''),(77,'pr','companycontribution','add',''),(78,'pr','companycontribution','update',''),(79,'pr','companycontribution','delete',''),(80,'pr','pension','add',''),(81,'pr','pension','update',''),(82,'pr','pension','delete',''),(83,'ap','bill','add','apbillupd.php?apbillid='),(84,'ap','bill','update','apbillupd.php?apbillid='),(85,'ap','bill','delete',''),(86,'ap','manualcheck','write','checks.php?apbill=1&checknbr='),(87,'ap','commissioncheck','write','checks.php?apbill=1&checknbr='),(88,'ap','preapprovedcheck','write','checks.php?apbill=1&checknbr='),(89,'ap','check','write','checks.php?apbill=1&checknbr='),(90,'ap','check','cashed',''),(91,'ap','check','uncashed',''),(92,'ap','check','void','checks.php?apbill=1&checknbr='),(93,'ap','vendor','add','apvendupd.php?id='),(94,'ap','vendor','update','apvendupd.php?id='),(95,'ap','vendor','delete',''),(96,'ap','po','add','invpoupd.php?invpoid='),(97,'ap','po','update','invpoupd.php?invpoid='),(98,'ap','po','delete',''),(99,'ap','po','receive','invporecv.php?submit=1&invpoid='),(100,'ap','po','passtoap',''),(101,'ap','withoutpo','receive',''),(102,'admin','user','add','genuserupd.php?id='),(103,'admin','user','update','genuserupd.php?id='),(104,'admin','user','delete',''),(105,'admin','company','add','gencompanyupd.php?id='),(106,'admin','company','update','gencompanyupd.php?id='),(107,'admin','company','delete',''),(108,'admin','emailcenter','send',''),(109,'admin','user','login','genuserupd.php?id='),(110,'ar','paymentplan','add','arpayplanupd.php?invoiceid='),(111,'ar','paymentplan','update','arpayplanupd.php?invoiceid='),(112,'ar','paymentplan','delete',''),(113,'ar','paymentplan','post','arinvoiceview.php?caller=1&invoiceid='),(114,'ar','order','serviceticketpdf',''),(115,'inv','inventorylocation','add','admininvlocationupd.php?id='),(116,'inv','inventorylocation','update','admininvlocationupd.php?id='),(117,'inv','inventorylocation','delete',''),(118,'ar','invoice','printpdf',''),(119,'admin','user','logout','genuserupd.php?id='),(120,'admin','nolog','loginpage',''),(121,'admin','import','customers',''),(122,'admin','import','employees',''),(123,'admin','import','gltotals',''),(124,'admin','import','itemcategories',''),(125,'admin','import','items',''),(126,'admin','import','vendors',''),(127,'ar','nolog','invoicebutton',''),(128,'ar','nolog','invoicereprintbutton',''),(129,'ar','nolog','serviceorderbutton',''),(130,'ar','nolog','pospmt',''),(131,'inv','nolog','price',''),(132,'ar','order','printpdf',''),(133,'ap','po','printpdf',''),(134,'ap','bill','printpdf',''),(135,'ar','receipt','printpdf',''),(136,'inv','nolog','onhand',''),(137,'inv','prices','edit',''),(138,'ap','eft','download',''),(139,'ar','eft','download',''),(140,'ar','order','magentoimport',''),(141,'admin','department','add','department.php?cmd=edit&departmentid='),(142,'admin','department','update','department.php?cmd=edit&departmentid='),(143,'admin','department','delete',''),(144,'pr','prworkerscomp','add','prworkerscomp.php?cmd=edit&prworkerscompid='),(145,'pr','prworkerscomp','update','prworkerscomp.php?cmd=edit&prworkerscompid='),(146,'pr','prworkerscomp','delete',''),(147,'admin','taxclass','add','taxclass.php?cmd=edit&taxclassid='),(148,'admin','taxclass','update','taxclass.php?cmd=edit&taxclassid='),(149,'admin','taxclass','delete',''),(150,'ar','appointment','book','!/index.php?/appointments/reportCustomerHistory/?&customerid='),(151,'ar','appointment','unbook','!/index.php?/appointments/reportCustomerHistory/?&customerid='),(152,'ar','appointment','servicechange','!/index.php?/appointments/reportCustomerHistory/?&customerid='),(153,'ar','appointment','schedulecreate',''),(154,'ar','appointment','schedulecancel',''),(155,'ar','appointment','hostchange',''),(156,'ar','appointment','reserve',''),(157,'ar','appointment','unreserve',''),(158,'ar','appointment','checkin',''),(159,'b2b','user','login','');
/*!40000 ALTER TABLE `event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eventlog`
--

DROP TABLE IF EXISTS `eventlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eventlog` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `companyid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `extuserid` int(11) NOT NULL default '0',
  `module` varchar(10) NOT NULL,
  `section` varchar(50) NOT NULL,
  `action` varchar(50) NOT NULL,
  `eventtable` varchar(100) default NULL,
  `eventid` int(10) unsigned default NULL,
  `data` text NOT NULL,
  `entrydate` datetime NOT NULL,
  `ip` varchar(20) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `companyid` (`companyid`),
  KEY `userid` (`userid`),
  KEY `extuserid` (`extuserid`),
  KEY `entrydate` (`entrydate`),
  KEY `module` (`module`),
  KEY `section` (`section`),
  KEY `action` (`action`),
  KEY `eventtable` (`eventtable`),
  KEY `eventid` (`eventid`),
  KEY `event` (`module`,`section`,`action`)
) ENGINE=MyISAM AUTO_INCREMENT=91 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eventlog`
--

LOCK TABLES `eventlog` WRITE;
/*!40000 ALTER TABLE `eventlog` DISABLE KEYS */;
INSERT INTO `eventlog` VALUES (35,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-03-20 13:38:35','127.0.0.1'),(36,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-03-30 14:15:36','192.168.1.231'),(37,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-04-11 15:22:58','192.168.1.234'),(38,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-04-20 13:15:31','192.168.1.233'),(39,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-05-01 15:25:09','192.168.1.231'),(40,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-05-13 14:11:12','192.168.1.59'),(41,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-05-17 20:25:53','192.168.1.232'),(42,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-05-21 14:42:05','192.168.1.232'),(43,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-05-26 16:40:24','192.168.1.232'),(44,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-05-28 13:43:24','192.168.1.232'),(45,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-06-09 15:27:45','192.168.1.231'),(46,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-06-15 09:28:48','192.168.1.231'),(47,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-06-23 14:34:12','192.168.1.231'),(48,0,1,0,'admin','user','logout','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-07-06 12:25:08','192.168.1.231'),(49,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-07-09 09:14:35','192.168.1.232'),(50,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-07-21 15:48:44','192.168.1.232'),(51,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-08-03 10:18:38','192.168.1.231'),(52,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-08-04 14:25:32','192.168.1.231'),(53,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-08-10 14:57:09','192.168.1.231'),(54,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-08-12 14:32:57','192.168.1.231'),(55,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-08-31 10:44:57','192.168.1.232'),(56,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-09-10 14:33:37','192.168.1.231'),(57,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-09-22 11:51:29','127.0.0.1'),(58,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-09-23 12:11:06','127.0.0.1'),(59,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-09-29 11:05:15','192.168.1.231'),(60,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-10-12 15:42:06','192.168.1.234'),(61,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-10-22 10:38:29','127.0.0.1'),(62,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-10-22 13:11:59','192.168.1.232'),(63,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-11-09 14:02:47','127.0.0.1'),(64,0,1,0,'admin','user','logout','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-11-09 14:13:22','127.0.0.1'),(65,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2009-12-23 20:29:18','192.168.1.231'),(66,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-01-07 09:41:55','192.168.1.231'),(67,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-02-02 13:52:46','192.168.1.232'),(68,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-02-15 11:43:17','192.168.1.232'),(69,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-02-22 14:58:57','192.168.1.232'),(70,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-03-24 10:50:24','192.168.1.232'),(71,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-04-05 09:38:34','192.168.1.231'),(72,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-04-21 14:38:54','192.168.1.231'),(73,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-05-19 11:26:39','192.168.1.231'),(74,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-05-24 11:22:30','192.168.1.231'),(75,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-06-22 14:41:02','192.168.1.231'),(76,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-07-07 15:55:53','192.168.1.231'),(77,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-07-09 09:54:04','192.168.1.231'),(78,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-07-20 15:03:20','192.168.1.232'),(79,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-07-22 14:09:10','192.168.1.231'),(80,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-08-23 12:05:09','192.168.1.231'),(81,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-09-01 12:18:18','192.168.1.232'),(82,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-10-15 14:48:17','192.168.1.233'),(83,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-10-25 15:25:39','192.168.1.233'),(84,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-11-10 14:26:12','192.168.1.232'),(85,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-11-30 14:53:19','192.168.1.231'),(86,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-12-15 12:59:52','192.168.1.231'),(87,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2010-12-27 11:08:58','192.168.1.231'),(88,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2011-01-10 15:11:43','192.168.1.232'),(89,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2011-01-21 14:54:20','192.168.1.232'),(90,0,1,0,'admin','user','login','genuser',1,'a:1:{s:8:\"username\";s:5:\"admin\";}','2011-06-28 17:08:11','127.0.0.1');
/*!40000 ALTER TABLE `eventlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eventlogdetails`
--

DROP TABLE IF EXISTS `eventlogdetails`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eventlogdetails` (
  `id` int(11) NOT NULL auto_increment,
  `eventlogid` int(11) NOT NULL default '0',
  `reftable` varchar(100) NOT NULL default '',
  `reffield` varchar(100) NOT NULL default '',
  `oldvalue` varchar(255) default '',
  `newvalue` varchar(255) default '',
  PRIMARY KEY  (`id`),
  KEY `eventlogid` (`eventlogid`),
  KEY `ref` (`reftable`,`reffield`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eventlogdetails`
--

LOCK TABLES `eventlogdetails` WRITE;
/*!40000 ALTER TABLE `eventlogdetails` DISABLE KEYS */;
/*!40000 ALTER TABLE `eventlogdetails` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `extuser`
--

DROP TABLE IF EXISTS `extuser`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `extuser` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `password` varchar(50) NOT NULL default '',
  `customer` int(11) NOT NULL default '0',
  `vendor` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `stylesheetid` int(11) NOT NULL default '1',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `deflanguageid` int(11) NOT NULL default '1',
  `fullname` varchar(100) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `extuser`
--

LOCK TABLES `extuser` WRITE;
/*!40000 ALTER TABLE `extuser` DISABLE KEYS */;
/*!40000 ALTER TABLE `extuser` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `family`
--

DROP TABLE IF EXISTS `family`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `family` (
  `id_family` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `id_workarea` int(11) NOT NULL default '5',
  `imptype` int(3) NOT NULL default '0',
  `iph` int(14) NOT NULL default '0',
  `iphtwo` int(14) NOT NULL default '0',
  `clickprice` decimal(5,3) NOT NULL default '0.000',
  `clickpricetwo` decimal(5,3) NOT NULL default '0.000',
  `maximpressionsperday` decimal(14,2) NOT NULL default '0.00',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `maxwidth` decimal(10,3) NOT NULL default '0.000',
  `maxlength` decimal(10,3) NOT NULL default '0.000',
  `minwidth` decimal(10,3) NOT NULL default '0.000',
  `minlength` decimal(10,3) NOT NULL default '0.000',
  `mincolors` int(11) NOT NULL default '0',
  `maxcolors` int(11) NOT NULL default '0',
  `maxcolors_two` int(11) NOT NULL default '0',
  `maxcolors_one_if_two` int(11) NOT NULL default '0',
  `iphunits` int(3) NOT NULL default '0',
  `workarea_order` int(11) NOT NULL default '0',
  `scrapperplate` int(11) NOT NULL default '0',
  `scrappercent` double NOT NULL default '0',
  `minimum_charge` decimal(12,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id_family`),
  UNIQUE KEY `id_family` (`id_family`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `family`
--

LOCK TABLES `family` WRITE;
/*!40000 ALTER TABLE `family` DISABLE KEYS */;
/*!40000 ALTER TABLE `family` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `family_detailseq`
--

DROP TABLE IF EXISTS `family_detailseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `family_detailseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `family_detailseq`
--

LOCK TABLES `family_detailseq` WRITE;
/*!40000 ALTER TABLE `family_detailseq` DISABLE KEYS */;
INSERT INTO `family_detailseq` VALUES (0);
/*!40000 ALTER TABLE `family_detailseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `family_iph`
--

DROP TABLE IF EXISTS `family_iph`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `family_iph` (
  `id_family_iph` int(11) NOT NULL default '0',
  `id_family` int(11) NOT NULL default '0',
  `multiplier` decimal(5,2) NOT NULL default '1.00',
  `len` decimal(10,2) NOT NULL default '0.00',
  `wt` decimal(10,2) NOT NULL default '0.00',
  `greater_or_less` int(1) NOT NULL default '2',
  `sizeormwt` int(1) NOT NULL default '1',
  `price` decimal(5,3) NOT NULL default '0.000',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_family_iph`),
  KEY `id_family` (`id_family`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `family_iph`
--

LOCK TABLES `family_iph` WRITE;
/*!40000 ALTER TABLE `family_iph` DISABLE KEYS */;
/*!40000 ALTER TABLE `family_iph` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `family_iphseq`
--

DROP TABLE IF EXISTS `family_iphseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `family_iphseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `family_iphseq`
--

LOCK TABLES `family_iphseq` WRITE;
/*!40000 ALTER TABLE `family_iphseq` DISABLE KEYS */;
INSERT INTO `family_iphseq` VALUES (0);
/*!40000 ALTER TABLE `family_iphseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `family_price`
--

DROP TABLE IF EXISTS `family_price`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `family_price` (
  `id_family_price` int(11) NOT NULL default '0',
  `id_family` int(11) NOT NULL default '0',
  `qty_over` decimal(18,6) NOT NULL default '0.000000',
  `price_1_sided` decimal(15,2) NOT NULL default '0.00',
  `price_2_sided` decimal(15,2) NOT NULL default '0.00',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_family_price`),
  UNIQUE KEY `id_family_price` (`id_family_price`),
  KEY `id_family` (`id_family`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `family_price`
--

LOCK TABLES `family_price` WRITE;
/*!40000 ALTER TABLE `family_price` DISABLE KEYS */;
/*!40000 ALTER TABLE `family_price` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `family_priceseq`
--

DROP TABLE IF EXISTS `family_priceseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `family_priceseq` (
  `id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `family_priceseq`
--

LOCK TABLES `family_priceseq` WRITE;
/*!40000 ALTER TABLE `family_priceseq` DISABLE KEYS */;
INSERT INTO `family_priceseq` VALUES (0);
/*!40000 ALTER TABLE `family_priceseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `familyseq`
--

DROP TABLE IF EXISTS `familyseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `familyseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `familyseq`
--

LOCK TABLES `familyseq` WRITE;
/*!40000 ALTER TABLE `familyseq` DISABLE KEYS */;
INSERT INTO `familyseq` VALUES (0);
/*!40000 ALTER TABLE `familyseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `faxlog`
--

DROP TABLE IF EXISTS `faxlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `faxlog` (
  `id` int(11) NOT NULL auto_increment,
  `status` varchar(16) NOT NULL default '',
  `faxnumber` varchar(32) NOT NULL default '',
  `api_id` varchar(16) NOT NULL default '',
  `api_provider` varchar(16) NOT NULL default '',
  `reftable` varchar(32) NOT NULL default '',
  `refid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `lastupdated` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `Active` (`cancel`,`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `faxlog`
--

LOCK TABLES `faxlog` WRITE;
/*!40000 ALTER TABLE `faxlog` DISABLE KEYS */;
/*!40000 ALTER TABLE `faxlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `feature`
--

DROP TABLE IF EXISTS `feature`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `feature` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(45) NOT NULL default '',
  `description_short` varchar(100) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `display` int(11) NOT NULL default '0',
  `ecomid` int(11) NOT NULL default '0',
  `featurecategoryid` int(11) NOT NULL default '0',
  `featurecategoryid2` int(11) NOT NULL default '0',
  `version` varchar(25) NOT NULL default '',
  `es` varchar(45) default NULL,
  `af` varchar(45) default NULL,
  `zh` varchar(45) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=392 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `feature`
--

LOCK TABLES `feature` WRITE;
/*!40000 ALTER TABLE `feature` DISABLE KEYS */;
INSERT INTO `feature` VALUES (1,'ordernotes','Order Notes','Adds an unlimited number of dated internal notes to orders.',1,46,1,0,'4.0.2986','Notas Ordenes','Bestelling Notas','????'),(2,'12monthP&L','12-month Profit & Loss','Profit and loss statement for the previous 12-month period.',1,43,7,0,'4.0.2986','Estado de Resultados 12 Meses','12-maande Wins & Verlies Staat','?????'),(3,'POnote','Purchase Order Notes','Adds an unlimited number of dated internal notes about purchase orders',1,48,1,0,'4.0.2986','Notas Órdenes de Compra','Aankoop Bestelling Notas','??????'),(4,'invoicenote','Invoice Notes','Adds an unlimited number of dated internal notes for invoices.',1,47,3,0,'4.0.2986','Notas Factura','Faktuur Notas','????'),(5,'vendornote','Vendor Notes','Adds an unlimited number of dated internal notes about vendors.',1,49,5,0,'4.0.2986','Notas Suplidor','Verskaffer Notas','?????'),(6,'billnote','Payables Notes','Adds an unlimited number of dated internal notes for AP bills.',1,50,1,0,'4.0.2986','Notas Cuentas por Pagar','Uitgawes Notas','?????'),(7,'employeenote','Employee Notes','Adds an unlimited number of dated internal notes about employees.',1,51,6,0,'4.0.2986','Notas Empleados','Werknemer Notas','????'),(8,'timezone','Customer Weather/Time  *Free*','Allows you to view of client time and weather conditions when entering/updating orders or invoices, viewing customer account information, or for particular client \"ship-to\" locations.',1,42,12,0,'4.0.2986',NULL,NULL,NULL),(9,'baddebt','Bad Debt Write-Off Support','This features adds a bad debt write-off function that shows up as \"written off\" during viewing of invoices, on payment reports, and other applicable system areas.',1,41,3,0,'4.0.2986','Ayuda Cuentas Incobrables','Swak Skulde Afskryf Ondersteuningsfunksie','??????'),(10,'fedtax_update','US Federal Tax Tables','US federal tax table updates for 2008 to the present.',1,40,6,0,'4.0.2986','Tables de Impuestos Federales Estadounidenses','VSA Federale Belastingtabelle','??????'),(11,'branding','Site Branding','Places your own logo on the login page and on the footer of all pages in NolaPro for a more personalized experience.',1,44,8,0,'4.0.2986','Creación de Valor de Marco','Webwerf Handelsmerk','????'),(12,'customernote','Customer Notes','Adds an unlimited number of dated internal notes about customers.',1,52,3,0,'4.0.2986','Notas Clientes','Kliënte Notas','????'),(13,'b2bitemgraphics','B2B Item Graphics','Displays product images on the B2B site.',1,45,8,0,'4.0.2986','N2N Gráficas de Items','B2B Item Grafieke','?????????'),(14,'StatementOption','Abbreviated Statement Format  *Free*','Adds the options to select whether to block display of Prior Balance and Interest Added columns on customer statements.',1,53,12,0,'4.0.2996',NULL,NULL,NULL),(15,'customcode','Custom Code Hooks','Provides a way for you to add your own custom PHP code that can be activated to run during NolaPro certain events (i.e., when customers, orders or invoices are added).',1,58,8,0,'4.0.3065','Ganchos de Códigos Personaliados','Aangepade Kode Kramme','???????'),(16,'activitymonitor','User Activity Monitor','Administrative module for tracking and viewing of user activities.  For example, view a history of when customers, vendors, orders, invoices, GL entries and payroll data were added or modified, who made such changes, and when it was done.',1,56,8,0,'4.0.3065','Monitor de Actividad de Usuario','Monitor Gebruiker Aktiwiteite','??????'),(17,'ArSumByShipto','Invoice Summary Options','Two additional formats to summarize invoices by customers to show with/without details and includes the option to display subtotals by shipto locations.',1,57,3,0,'4.0.3065','Resumen Opciones Facturación','Faktuur Opsommingsopsies','??????'),(18,'Printshop_std','NolaPrint - Standard Version','Commercial print industry estimating system featuring quoting, estimating, tracking and billing of printing orders.',1,55,13,0,'4.0.3131',NULL,NULL,NULL),(19,'Printshop_pricelist','NolaPrint - Price List Version','Commercial print industry estimating system featuring quoting, estimating, tracking and billing of printing orders - based on price list.',1,55,13,0,'4.0.3131',NULL,NULL,NULL),(20,'flexfields','Custom Fields','Provides the ability to add your own customizable fields for customers, vendors, employees, items, orders, invoices and AP bills.',1,59,8,0,'4.0.3131','Campos Personalizados','Aangepasde Velde','?????'),(21,'dailyreport','Daily Accounting Summary','Administrative Financial Report showing checking balances, receivables aging totals, payments received, orders completed, and payables aging all on a single page.',1,60,7,0,'4.0.3131','Sumario de Contabilidad Cotidiana','Daaglikse Rekening Opsomming','??????'),(22,'api','NolaPro API','Provides access to the NolaPro API which allows you to build your own applications that integrate with NolaPro.',1,101,8,0,'','NolaPro API','NolaPro API','NolaPro??????'),(23,'PO_EXTRAS','Extra PO Formatting Options','Allows selection of removing boxes from around ship-to and vendor, changing of date format for display on PO, etc.',0,0,0,0,'',NULL,NULL,NULL),(24,'AR_EXTRAS','Date Format Options for Invoice and Statement','Allows changing of date format for display on Invoice and Statement.',0,0,0,0,'',NULL,NULL,NULL),(25,'timeclock','Employee Time Tracking','Timeclock system for employees to punch in/out for work, lunch, breaks, etc. and posts this time directly into payroll, along with reporting of the tracked time.',1,80,6,0,'40.3396','Rastreo de Tiempo de Empleados','Werknemer Tydsporing','??????'),(26,'piecework','Employee Piecework Tracking','Requires the Time Tracking add-on. Provides employee piecework tracking in a production environment and has reports to display money accrued and ways to relate that to clock-in hours from the time tracking module to give an equivalent hourly rate paid.',0,0,0,0,'0',NULL,NULL,NULL),(27,'oscom','osCommerce Integration (all versions)','Sends orders from your osCommerce online store directly into NolaPro.',1,187,10,0,'4.0.4596',NULL,NULL,NULL),(28,'ipaccess','IP Access Control','Allows you to restrict access to NolaPro based on a user\'s IP address. Filtering process can assign acceptable IP addresses that apply to all users or just to specific users.',1,71,8,0,'4.0.3261','IP Control de Acceso','IV (\"IP\") Toegangsbeheer','???????'),(29,'hostingmanager','Hosting Manager','Allows you to host and administer multiple NolaPro customer sites from one installation and multiple but separate databases.  With this plug-in, you will be able to resell NolaPro hosting to your clients at your own prices.',1,82,8,12,'4.0.3396','Administrador de Hospedaje (Versión d NolaPro','Gasheer Bestuurder (NolaPro Herverkoopte Weer','?????NolaPro ?????'),(30,'hosteddb','Hosting Manager - Client Authorization','Generates 1 client license for a new database in the NolaPro hosting manager.',1,83,8,12,'','Administrador de Hospedaje - Autorización de ','Gasheer Bestuurder - Klient Magtiging','????-?????'),(31,'message','Internal Messaging','Provides a way to display messages to other selected NolaPro users.  Supports graphics and also contains reports confirm if/when the messages were viewed.',1,81,8,0,'4.0.3396','Mensajería Internal','Interne Boodskappe','????'),(32,'CCPurchases','Credit Card Tracking','Track and reconcile credit card purchases in Payables.',1,87,5,0,'4.0.3562','Seguimiento Tarjeta de Crédito','Kredietkaart Sporing','?????'),(33,'MergeCust','Customer Account Merging Tool','Lets you merge customer records including all associated orders, payments, invoices, etc. when duplicate accounts have been inadvertently created.',1,86,1,0,'4.0.3475','Herramienta Consolidar Clientes','Kliënterekening Samesmelingsfunksie','????????'),(34,'OrderEntry','Order Entry Access Rights','Allows user rights to be set so they only have access to Order Entry functions.',1,88,8,0,'4.0.3600','Derecho de Acceso Para Llenar Ordenes','Bestellingsinskrywings Toegangsregte','????????'),(35,'CustControl','Customer Page Customizer','Allows user to set which fields will display for input on customer add and edit screens.',1,89,1,0,'4.0.3666','Personalizar Pagina Clientes','Kliënteblad  Aanpasser','??????'),(36,'ExtraPension','Expanded Pension Plans','Add up to three additional pension plans per employee (standard version has two plans).',1,90,6,0,'4.0.3666','Planes Expandidos de Pensión','Uitgebreide Pensioenplanne','???????'),(37,'ItemControl','Inventory Page Customizer','Allows user to set which fields will display for input on item add and edit screens.',1,91,4,0,'4.0.3686','Personalizar Página Inventario','Inventaris Blad Aanpasser','??????'),(38,'VendControl','Vendor Page Customizer','Allow user to set which fields will display for input on vendor add and edit screens.',1,95,5,0,'4.0.3804','Personalizar Pagina Suplidor','Verskaffer Bladsy Aanpasser','??????'),(39,'systemsettings','Premium System Settings','Adds system settings to allow a default home page other than Help, to turn off the login splash page and to remove marketing options from the Help home page (Add-ons, Hosting, Manuals, Support).',1,96,8,0,'4.0.3919','Configuración de Sistema Premium','Premium Sisteem Verstellings','??????'),(40,'lang_es','User Language - Spanish (Full Translation)','Allows users to select Spanish as the display language in NolaPro.',0,185,11,0,'4.0.4470',NULL,NULL,NULL),(41,'qbimport','QuickBooks(TM) Converter (US)','Allows you to export data from QuickBooks and import it into NolaPro via Admin -> Imports -> QuickBooks',1,97,8,0,'4.0.3946','Convertidor de Quickbooks (TM)(US)','QuickBooks(TM) Omskepper (US)','QuickBooks???????????'),(42,'invbkdn','Inventory Item Breakdown','Subdivide a parent item into other inventory items using the item family relationship (ex. for breaking down steel or lumber); the process transfers costs from the main item to sub-items.',1,98,4,0,'4.0.4055','Desglose artículo Inventario','Inventaris Item Ontleding','??????'),(43,'invoicenumber','Invoice Number Override','Override invoice number from orders; useful if you are entering invoices from a paper-based system where the invoice numbers are pre-printed.',1,99,3,0,'4.0.4055','Invalidación Numero factura','Faktuur Nommer Ignoreer','??????'),(44,'combinepayroll','Combine Payrolls for Taxes','Allow another check to sum with prior period for taxes, then just apply the difference.',1,230,6,0,'4.0.5893','Combinar Nominas para Impuestos','Kombineer Loonrol vir Belasting','???????'),(45,'survey','Survey Manager','Create surveys; email survey links from order, invoice, customer and vendor screens; view results with a detailed reporting tool',1,100,8,0,'4.0.4127','Administrador de Encuestas','Opname Bestuurder','????'),(46,'ItemSalesHistory','Inventory Sales History Report','A detailed report that offers several subtotalling and summarizing options to view inventory item sales history.',1,102,4,0,'4.0.4200','Reporte Historia Venta Articulo Inventario','Inventaris Verkoopsgeskiedenis Verslag','????????'),(47,'companytimezone','Company Time Zones','Allows you to set a different time zone for each of your NolaPro companies.',1,104,8,0,'4.0.4215','Zonas Horario de la Empresa','Besigheid Tydsones','????'),(48,'ItemVendorCopy','Item Vendor Copy','Copy item vendor information from one vendor to another.',0,0,0,0,'',NULL,NULL,NULL),(49,'multicurrency','Multi-Currency Module','Lets you use more than one currency in NolaPro for orders, invoices, POs, AP bills, etc.',1,103,8,0,'5.0.7649','Modulo de Multi-Divisa','Multi-Geldeenheid','??????????'),(50,'scartfreeship','Expanded Free Shipping Options for Shopping Cart','Allows you to set minimum order amount, price level and shipping method criteria when offering free shipping in the shopping cart module.',0,106,8,0,'4.0.4410','Opciones de Envio Gratis','Gratis Versendingsopsie vir Winkeltrollie','?????????'),(51,'lang_ar','User Language - Arabic (Incomplete Translation)','Allows users to select Arabic as the display language in NolaPro',0,188,11,0,'4.0.4470',NULL,NULL,NULL),(52,'lang_zh','User Language - Chinese (Incomplete Translation)','Allows users to select Chinese as the display language in NolaPro',0,162,11,0,'4.0.4470',NULL,NULL,NULL),(53,'lang_da','User Language - Danish (Incomplete Translation)','Allows users to select Danish as the display language in NolaPro',0,163,11,0,'4.0.4470',NULL,NULL,NULL),(54,'lang_nl','User Language - Dutch (Incomplete Translation)','Allows users to select Dutch as the display language in NolaPro',0,164,11,0,'4.0.4470',NULL,NULL,NULL),(55,'lang_et','User Language - Estonian (Incomplete Translation)','Allows users to select Estonian as the display language in NolaPro',0,165,11,0,'4.0.4470',NULL,NULL,NULL),(56,'lang_tl','User Language - Filipino (Incomplete Translation)','Allows users to select Filipino as the display language in NolaPro',0,166,11,0,'4.0.4470',NULL,NULL,NULL),(57,'lang_fi','User Language - Finnish (Incomplete Translation)','Allows users to select Finnish as the display language in NolaPro',0,167,11,0,'4.0.4470',NULL,NULL,NULL),(58,'lang_fr','User Language - French (Incomplete Translation)','Allows users to select French as the display language in NolaPro',0,168,11,0,'4.0.4470',NULL,NULL,NULL),(59,'lang_de','User Language - German (Incomplete Translation)','Allows users to select German as the display language in NolaPro',0,169,11,0,'4.0.4470',NULL,NULL,NULL),(60,'lang_el','User Language - Greek (Incomplete Translation)','Allows users to select Greek as the display language in NolaPro',0,170,11,0,'4.0.4470',NULL,NULL,NULL),(61,'lang_he','User Language - Hebrew (Incomplete Translation)','Allows users to select Hebrew as the display language in NolaPro',0,171,11,0,'4.0.4470',NULL,NULL,NULL),(62,'lang_hi','User Language - Hindi (Incomplete Translation)','Allows users to select Hindi as the display language in NolaPro',0,172,11,0,'4.0.4470',NULL,NULL,NULL),(63,'lang_ba','User Language - Indonesian (Incomplete Translation)','Allows users to select Indonesian as the display language in NolaPro',0,173,11,0,'4.0.4470',NULL,NULL,NULL),(64,'lang_it','User Language - Italian (Incomplete Translation)','Allows users to select Italian as the display language in NolaPro',0,174,11,0,'4.0.4470',NULL,NULL,NULL),(65,'lang_jp','User Language - Japanese (Incomplete Translation)','Allows users to select Japanese as the display language in NolaPro',0,175,11,0,'4.0.4470',NULL,NULL,NULL),(66,'lang_ko','User Language - Korean (Incomplete Translation)','Allows users to select Korean as the display language in NolaPro',0,176,11,0,'4.0.4470',NULL,NULL,NULL),(67,'lang_ms','User Language - Malay (Incomplete Translation)','Allows users to select Malay as the display language in NolaPro',0,177,11,0,'4.0.4470',NULL,NULL,NULL),(68,'lang_no','User Language - Norwegian (Incomplete Translation)','Allows users to select Norwegian as the display language in NolaPro',0,178,11,0,'4.0.4470',NULL,NULL,NULL),(69,'lang_pt','User Language - Portuguese (Incomplete Translation)','Allows users to select Portuguese as the display language in NolaPro',0,179,11,0,'4.0.4470',NULL,NULL,NULL),(70,'lang_ro','User Language - Romanian (Incomplete Translation)','Allows users to select Romanian as the display language in NolaPro',0,180,11,0,'4.0.4470',NULL,NULL,NULL),(71,'lang_ru','User Language - Russian (Incomplete Translation)','Allows users to select Russian as the display language in NolaPro',0,181,11,0,'4.0.4470',NULL,NULL,NULL),(72,'lang_si','User Language - Slovenian (Incomplete Translation)','Allows users to select Slovenian as the display language in NolaPro',0,182,11,0,'4.0.4470',NULL,NULL,NULL),(73,'lang_sv','User Language - Swedish (Incomplete Translation)','Allows users to select Swedish as the display language in NolaPro',0,183,11,0,'4.0.4470',NULL,NULL,NULL),(74,'lang_th','User Language - Thai (Incomplete Translation)','Allows users to select Thai as the display language in NolaPro',0,184,11,0,'4.0.4470',NULL,NULL,NULL),(75,'ItemActualCost','Inventory Actual Item Costs','Withdraw from Inventory at actual cost regardless of how many purchases exist in inventory.',1,193,4,0,'4.0.4663','Costo Actual de Items de Inventario','Inventaris Werklike Item Kostes','????????'),(76,'lang_af','User Language - Afrikaans (Incomplete Translation)','Allows users to select Afrikaans as the display language in NolaPro',0,189,11,0,'4.0.4610',NULL,NULL,NULL),(77,'lang_vi','User Language - Vietnamese (Full Translation)','Allows users to select Vietnamese as the display language in NolaPro',0,192,11,0,'4.0.4663',NULL,NULL,NULL),(78,'lang_sr','User Language - Serbian (Incomplete Translation)','Allows users to select Serbian as the display language in NolaPro',1,191,11,0,'4.0.4663',NULL,NULL,NULL),(79,'multiarap','Multiple AR/AP GL Accounts','Allows you to define more than one Accounts Receivable and Accounts Payable account for use when creating orders, invoices and AP Bills.',1,194,7,0,'4.0.4663','Cuentas Multiples CC/CP','Veelvuldige RO/RB Rekeninge','??????/??????'),(80,'blockarreports','Block AR Reports','Allows you to block AR reports (Billing & Orders) for users that have AR read access.',1,239,3,0,'4.0.7245',NULL,NULL,NULL),(81,'construction','Construction','Construction Company',0,0,0,0,'',NULL,NULL,NULL),(82,'salesmanBlock','Limit Salesman Access','Block sales personnel from seeing any orders/invoices/customers other than their own.',1,201,1,0,'4.0.4775','Limitar Acceso Vendedor','Beperk Verkoopspersoon Toegang','????????'),(83,'userrights','Advanced User Rights','Advanced control of pages users are able to access.',1,206,8,0,'4.0.4878','Derechos de Usuarios Avanzados','Gevorderde Gebruikersregte','??????'),(84,'processstages','Process Stages','Add user-definable stages for processing purchase orders and fulfillment orders.',0,0,0,0,'',NULL,NULL,NULL),(85,'lang_ur','User Language - Urdu (Incomplete Translation)','Allows users to select Urdu as the display language in NolaPro',0,208,11,0,'4.0.4986',NULL,NULL,NULL),(86,'lang_pl','User Language - Polish (Incomplete Translation)','Allows users to select Polish as the display language in NolaPro',1,207,11,0,'4.0.4986',NULL,NULL,NULL),(87,'custitemdiscounts','Customer Item Discounts','Create flat or percent item discounts for specific customers.',1,209,4,0,'4.0.4986','Descuento Articulo por Cliente','Kliënt Item Kortings','??????'),(88,'soextrafields','Service Order Extra Fields','Allows you to define additional fields for service orders and develop a custom work details page for each service order.',1,210,1,0,'4.0.4986','Campos Adicionales Ordenes Servicio','Diensbestelling Ekstra Velde','???????'),(89,'googlebase','Google Base Inventory Synchronization','Sync your NolaPro items with your Google Base account.',0,0,0,0,'',NULL,NULL,NULL),(90,'edititemprices','Item Prices - Mass Edit','Provides a page where you can set prices for multiple items and price levels all in one place.',1,212,4,0,'4.0.5042','Edición Masiva Precio Artículos Inventario','Item Pryse - Massa Redigering','????-????'),(91,'servicePF','Pro Forma Invoice for Service Order','Run a pro forma invoice prior to actually being ready to make an invoice for a service order -- shows all hours, etc.',1,240,1,0,'4.0.7245',NULL,NULL,NULL),(92,'ExportItems','Export Inventory Items','Export Items in same format as CSV Import file.',1,218,4,0,'4.0.5226','Exportar Articulo Inventario','Uitvoer van Inventaris Items','??????'),(93,'adminloginany','Admin Tool (Login as any User)','Allows the admin user to automatically log in as any user.',0,0,0,0,'',NULL,NULL,NULL),(94,'depositslip','Bank Deposit Slip PDF','Allow PDF Deposit Slip printing.',1,216,3,0,'4.0.5207','Hoja de Deposito PDF','Bank Depositostrokkie PDF','??????PDF???'),(95,'cashflowreport','Cash Flow Report Rex','A configurable Statement of Cash Flows Report.',0,217,0,0,'0',NULL,NULL,NULL),(96,'cashtracker','Track Movement of Cash Receipts','Track Movement of Cash Receipts from Person to Person.',0,0,0,0,'',NULL,NULL,NULL),(97,'bankimport','Bank Statement Import (OFX)','Import transactions from your bank account in OFX format.',1,220,7,0,'4.0.5333','Importar Transacciones Bancarias (Formato OFX','Bank Transaksies Invoer (OFX Formaat)','???????OFX???'),(98,'postemplate','POS Tax Groups','Create POS Tax Groups that can be assigned to users as tax/location to use when creating a POS sale.',1,223,3,0,'4.0.5451','Grupos Impuestos Punto de Venta','PVV (Punt van Verkope) Belasting Groepe','?????'),(99,'lang_bg','User Language - Bulgarian (Incomplete Translation)','Allows users to select Bulgarian as the display language in NolaPro',0,221,11,0,'4.0.5355',NULL,NULL,NULL),(100,'itemreturns','Invoice Item Returns','Allow return of inventory items when on invoices generated by POS, etc.',1,224,3,0,'4.0.5451','Factura Artículos devueltos','Faktuur Item Retoere','??????'),(101,'discounts','Invoice Discounts','Set up discounts that can be applied to entire invoices.',0,0,0,0,'',NULL,NULL,NULL),(102,'coinvoice','Co-Invoicing','Allow other customers to share responsibility for an invoice.',0,0,0,0,'',NULL,NULL,NULL),(103,'invcopyprice','Copy Inventory Pricing','Copy Inventory Item Pricing from one location to another (or all other) location.',1,222,4,0,'4.0.5431','Duplica Precio Inventario','Kopieër Inventaris Prysberekening','??????'),(104,'ccscanner','Credit Card Scanner Integration','Allows you to use an attached credit card scanning device when submitting credit card payments',1,225,3,0,'4.0.5720','Integración de Escáner de Tarjetas de Crédito','Kredietkaart Skandeerder Integrasie','????????'),(105,'smallinvoice','Small POS Invoices','Invoice option for an 8.5 x 5.5 inch size limited to 7 items.',1,227,3,0,'4.0.5720','Facturas de Pequeños PDV','Kleiner PVV (Punt van Verkope) Fakture','???????'),(106,'lang_tr','User Language - Turkish (Incomplete Translation)','Allows users to select Turkish as the display language in NolaPro',0,226,11,0,'4.0.5720',NULL,NULL,NULL),(107,'mc2xreceipt','Official Receipt for MyCare2x Integration','This is a private add-on -- not available on the store',0,0,0,0,'',NULL,NULL,NULL),(108,'stubcheckstub','Checks: Stub-Check-Stub','Checks allow a new format of \"stub-check-stub\".',1,229,5,0,'4.0.5760','Talonario Cheque Talonario','Tjekteenblad','????'),(109,'receipt','Payment Receipts','Standard \"receipt-size\" PDF for printing to a dedicated receipt printer. Perfect for POS payments.',1,238,3,0,'4.0.7245',NULL,NULL,NULL),(110,'userlocations','Tie User to Specific Locations','Tie User to Specific Locations.',1,233,3,0,'4.0.5967',NULL,NULL,NULL),(111,'empglid','Employee-Specific Tax Expense for GL','Employee-specific Tax Expense for GL.',1,231,6,0,'4.0.5893','Gastos de Impuestos para LM especificamente P','Werknemer-spesifieke Belasting Uitgawe vir AG','???????????'),(112,'mc2xcashcount','Record Currency Counts with Payments','This is a private add-on -- not available on the store',0,0,0,0,'',NULL,NULL,NULL),(113,'shipbarcode','Print Shipto ID on Order Ticket','Print Shipto Record ID on Order Ticket - for use with shipping programs like Worldship.',1,232,1,0,'4.0.5956',NULL,NULL,NULL),(114,'barcodelabel','Custom Design Barcode Labels','Create custom barcode lables using custom fields such as size, color and design. The Custom Fields Add-On is required.',1,235,4,0,'4.0.6199','Diseño Personalizado de Etiquetas de Códigos ','Ontwerp Aangepasde Strepieskode Etikette','?????????'),(115,'lang_pr','User Language - Persian (Incomplete Translation)','Allows users to select Persian as the display language in NolaPro.',1,236,11,0,'4.0.6312',NULL,NULL,NULL),(116,'payrollcheck','Special Payroll Check Format','Turns on a special Payroll Check format.',1,237,6,0,'4.0.6434','Formato Especial Para Cheques de Nomina','Spesiale Loonrol Tjekformaat','????????'),(117,'archiveinvoices','Archive Invoices','Archive old invoices and related records; GL entries are summarized by month or year.',0,0,0,0,'4.0.6587',NULL,NULL,NULL),(118,'tcadocrequest','TCA Doc Request Report','A list of TCA doc requests',0,0,0,0,'',NULL,NULL,NULL),(119,'tabularLogHours','Log Payroll Time in Tabular Format','Allow logging of Payroll Time in tabular format.',1,241,6,0,'4.0.7245',NULL,NULL,NULL),(120,'vtiger','vtiger CRM Integration','Adds custom fields to NolaPro so that vtiger CRM info can be imported using the vtiger Add-On.',1,252,10,0,'5.0.7857',NULL,NULL,NULL),(121,'payroll','Payroll System','Installs the full Payroll System.',1,242,6,0,'4.0.7245','Sistema de Nomina',NULL,NULL),(122,'inventory','Inventory and Ordering System','Installs the Inventory and Ordering System with Point of Sale, Service Orders and Fulfillment Orders.',1,243,1,4,'4.0.7245','Sistema de Inventario y Ordenes',NULL,NULL),(123,'b2b','B2B System','Installs the Business-to-Business (B2B) System for allowing clients access to place order, make payments, etc.',1,244,1,0,'4.0.7245','Sistema B2B',NULL,NULL),(124,'cashbasetaxrpt','Cash Basis Sales Tax Report','View only invoices PAID in a given month on the sales tax report',1,246,3,0,'5.0.7413',NULL,NULL,NULL),(125,'disablecostcorrect','Disable Cost Auto-Correction when Ship/Close Orders','Custom Only Display=0',0,245,1,0,'5.0.8475',NULL,NULL,NULL),(126,'onepagecheck','Special Check Size with GL on stub','Special Check Size with GL on stub',1,279,5,0,'5.0.8475',NULL,NULL,NULL),(127,'expandeddata','Expanded Data Allowance','Allows you to have more customers, vendors, items and employees along with the ability to add more than one company',1,247,8,0,'5.0.7750',NULL,NULL,NULL),(128,'cashflow','Cash Flow Report','Cash Flow Report',1,217,7,0,'5.0.7809',NULL,NULL,NULL),(129,'catitemdel','Delete Inventory By Category','Delete Inventory by Category',1,250,4,0,'5.0.7809',NULL,NULL,NULL),(130,'item12mo','12 Month History of Customer Sales or Units Sold','12 Month History of Customer Sales or Inventory Units Sold',1,249,4,0,'5.0.7809',NULL,NULL,NULL),(132,'orderptcalc','Calculate Item Reorder Point, Min and Max ','Calculate Item Reorder Point, Min and Max',1,251,4,0,'5.0.7809',NULL,NULL,NULL),(133,'unlimiteddata','Unlimited Data Allowance','Allows unlimited customers, vendors, items, companies and employees',0,0,0,0,'5.0.7842',NULL,NULL,NULL),(134,'smallinvoice2','Strip Printer Style Invoice ','Display=0, not an add-on',0,278,3,0,'5.0.8475',NULL,NULL,NULL),(135,'BOMImport','Import BOM Definitions and Build Orders ','Import BOM Definitions and Build Orders',1,282,12,0,'5.0.8500',NULL,NULL,NULL),(136,'smallinvoice3','A4 Half-size Invoice ','Display=0, not an add-on',0,254,3,0,'5.0.8475',NULL,NULL,NULL),(137,'irs1099','IRS 1099-MISC','Allows printing 1099-MISC forms for vendors',1,253,5,0,'5.0.8044',NULL,NULL,NULL),(138,'3dcart','3dcart Order Import','Import orders from a 3dcart store',1,255,10,0,'5.0.8108',NULL,NULL,NULL),(139,'negInvVal','Negative Quantities on Inventory Valuation ','Allow Negative Quantities to display on Inventory Valuation',1,256,4,0,'5.0.8108',NULL,NULL,NULL),(140,'picktickpdf','Direct Pick Ticket PDF from Order Entry','Direct Print of Pick Ticket PDF from final Order Entry Screen',1,277,1,0,'5.0.8475',NULL,NULL,NULL),(141,'commissions','Commissions','Calculate commissions on invoices',1,257,3,0,'5.0.8193',NULL,NULL,NULL),(142,'EmailOnConfirm','Order Confirmation - Include emails','For Fulfillment Order Confirmation, show email for both order by and ship to',1,258,12,0,'5.0.8272',NULL,NULL,NULL),(143,'hideitemoptionsshipinv','Hide Item Options In Shipping & Invoicing','Turning on this option in AR Setup will block item options from being displayed on fulfillment order shipping and invoicing screens',1,276,1,0,'5.0.8475',NULL,NULL,NULL),(144,'overrideorderdate','Override Item Order Date','Override the default current date used when creating or editing item orders',1,281,1,0,'5.0.8500',NULL,NULL,NULL),(145,'EmailCenter','Email Center','Email Center',1,260,8,0,'5.0.8355',NULL,NULL,NULL),(146,'NonInvoicedSales','Non-Invoiced Sales','Non-Invoiced Sales',1,261,3,0,'5.0.8355',NULL,NULL,NULL),(147,'CalculateInterest','Calculate Interest on Invoices','Calculate Interest on Invoices',1,262,12,0,'5.0.8355',NULL,NULL,NULL),(148,'GLBudgets','General Ledger Budgets','Create GL Budgets and run Variance Reports',1,263,7,0,'5.0.8355',NULL,NULL,NULL),(149,'GLSummarize','General Ledger Summarization','Summarize GL Accounts to Create Custom Reports',1,264,7,0,'5.0.8355',NULL,NULL,NULL),(150,'GLRecurring','Recurring Ledger Entries','Recurring Ledger Entries',1,265,7,0,'5.0.8355',NULL,NULL,NULL),(151,'Exports','Misc. Exports','Misc. Exports',1,271,12,0,'5.0.8355',NULL,NULL,NULL),(152,'LangEditor','Language Editor','Edit Text from Anywhere in the program',1,266,12,0,'5.0.8355',NULL,NULL,NULL),(153,'HomePageRefresh','Home Page Refresh Times','Edit times between recalculate Home Page reports',1,267,12,0,'5.0.8355',NULL,NULL,NULL),(154,'CustomerGroups','Create Customer Groups','Create Customer Groups',1,268,1,0,'5.0.8355',NULL,NULL,NULL),(155,'InvoiceEndNotes','Invoice End Notes','Notes to add to end of Invoice',1,269,12,0,'5.0.8355',NULL,NULL,NULL),(156,'VendorType','Vendor Types','Ability to assign a type to each vendor',1,270,12,0,'5.0.8355',NULL,NULL,NULL),(157,'GLCostCenter','GL Cost Center','Assign Cost Centers to GL Accounts to enhance reporting',1,280,7,0,'5.0.8500',NULL,NULL,NULL),(158,'CashRequire','Payables Cash Requirements Report','Payables Cash Requirements Report',1,259,5,0,'5.0.8355',NULL,NULL,NULL),(159,'sidebarhide','Hide Sidebar','Allows you to toggle the left-hand sidebar area (Shortcuts, Help, etc) so it can be hidden to give more room for the application when needed',1,273,12,0,'5.0.8355',NULL,NULL,NULL),(160,'defaultduedate','Default Due Date','Allows you to set the number of days beyond the current date you\'d like the due date for service and fulfillment orders to default to',1,272,12,0,'5.0.8355',NULL,NULL,NULL),(161,'pay_finchg','Finance Charge For Payments','Provides a way to include a finance charge when entering in payments received',1,283,12,0,'5.0.8500',NULL,NULL,NULL),(162,'ediprocessing','EDI Processing - Custom','EDI Processing - Custom Only DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(163,'a4_statement','A4 Open Item Statement','A4 Open Item Statement',0,0,0,0,'',NULL,NULL,NULL),(164,'discOnForms','Show Discount Column on AR Forms','Show Discount Column on AR Forms',1,275,12,0,'5.0.8475',NULL,NULL,NULL),(165,'invoiceaddressbottom','Show Invoice Address at Bottom','Show the invoice address at the bottom with other adjustments - Custom Only DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(166,'oneWrite','OneWrite Customization','OneWrite Customization',0,0,0,0,'',NULL,NULL,NULL),(167,'defaulttovendorcost','Default Inventory Costs To Vendor Pricing','With this customization on all inventory costs for orders will pull the cost from the vendor pricing set up for the item  DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(168,'blockifnostock','Block Orders If No Stock','Block certain users from placing orders if not enough stock is available',1,300,1,0,'5.0.9241',NULL,NULL,NULL),(169,'blocksalesmanchange','Block Salesperson Changes','Block sales personnel from changing the sales person on orders',1,299,1,0,'5.0.9241',NULL,NULL,NULL),(170,'userseries','Per-User Numbering','Alternate configurable numbering system for orders, invoices and receipts that increments on a per-user per-company basis  DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(171,'usershippingrights','User Shipping Rights','Block users or user groups from shipping certain items or categories of items  DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(172,'purgeorders','Purge Open Orders','Purge open fulfillment orders if no shipments have been made after a certain number of days. Purge by putting in unconfirmed status or by deleting. DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(173,'userpaymentcollection','User Payment Collection','Enter payments amounts that user\'s have collected (cash, checks, etc) and match against the payment amounts recorded by the system DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(174,'glTransImport','Import GL Transactions','Import GL Transactions',1,285,7,0,'5.0.8656',NULL,NULL,NULL),(175,'cloneorders','Clone Quotes & Orders','Make duplicates of existing fulfillment quotes and orders',1,284,1,0,'5.0.8657',NULL,NULL,NULL),(176,'pricelevelmarkdowns','Price Level Markdowns','Create price levels that are markdowns of other existing price levels (10% Off Retail price level for example)',1,286,4,0,'5.0.8693',NULL,NULL,NULL),(177,'salesmandefaults','Default Values For Sales Personnel','Set up a default sales account and default bank account for sales people DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(178,'customenterpayments','Custom Enter Payments Page','Custom page for entering payments DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(179,'itemcostadjustapbill','Item Cost Adjustments Using AP Bills','Adjust the cost of items received on PO by the amount of a separate AP Bill on the Inventory Cost Adjustments page ',1,287,4,0,'5.0.8714',NULL,NULL,NULL),(180,'convertordertoquote','Convert Order To Quote','Convert a fulfillment order back into a quote. Performing this action will release committed inventory.',1,288,1,0,'5.0.8714',NULL,NULL,NULL),(181,'showothercostock','Show Stock Level From Other Companies','Show stock levels from other companies on the Item Reorder List report',1,289,4,0,'5.0.8714',NULL,NULL,NULL),(182,'poreturns','Purchase Order Returns','Provides a way to manage returning items received on PO back to vendor',1,290,5,0,'5.0.8909',NULL,NULL,NULL),(183,'colortemplates','Change Colors','Allows you to change the system color layout to something other than the default blue on a system wide, per company or per user basis',1,291,8,0,'5.0.8909',NULL,NULL,NULL),(184,'genusercheckacct','User Bank Account Assignment','Assign users to certain bank accounts so that they can only see their assigned bank accounts throughout the system',1,292,8,0,'5.0.8909',NULL,NULL,NULL),(185,'custommanualchecks','Custom Manual Checks Page','Custom page for writing manual checks DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(186,'blockbackdating','Block AR/AP Backdating','Prevent certain users from being able to backdate AP and AR transactions or post to prior periods ',1,294,3,5,'5.0.9112',NULL,NULL,NULL),(187,'glcostcodes','Cost Codes for AR/AP','Allows you to assign cost codes to invoices and bills and then filter the Profit & Loss statement by cost code',1,295,3,5,'5.0.9112',NULL,NULL,NULL),(188,'updatevendorprice','Update Vendor Prices from POs','This add-on will allow you to update vendor prices for items based on the price entered when converting POs to AP bills. Toggle this feature on or off at Admin -> Setup - Payables -> General Setup -> Update Vendor Prices From Received PO Prices',1,296,5,0,'5.0.9112',NULL,NULL,NULL),(189,'autocompletedelay','Auto-Complete Delay Override','Set on a per-user basis the amount of time in milliseconds until auto-complete boxes look for information. Setting a higher number than the default of 400 can be helpful for slower typers.',1,297,12,0,'5.0.9112',NULL,NULL,NULL),(190,'removeads','Remove Advertising','Remove ads that may be displayed with some free distributions.  If you do not see ads in the program (header, sidebar, or footer), you do not need to purchase this add-on.',1,293,8,0,'5.0.9112',NULL,NULL,NULL),(191,'ExpenseReport','Expense Report','Expense Report DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(192,'invcotransfer','Intercompany Item Transfers','Transfer inventory items between different companies inside the program',1,303,4,0,'5.0.9241',NULL,NULL,NULL),(193,'gltransactioninfo','GL Transaction Descriptions','Allows you to enter descriptions for each line in a GL journal set in addition to the main description',1,302,7,0,'5.0.9241',NULL,NULL,NULL),(194,'salesmarginblock','Sales Margin Invoice Blocking','Prevent fulfillment orders from being invoiced if the total order amount falls outside a sales margin range that you define.  Override these orders through a margin execption report.',1,301,1,0,'5.0.9241',NULL,NULL,NULL),(195,'posmultiplier','Multiply All Quantities in POS/FO','Provides a box where you can enter a number and have all quantities on the entire POS order or Fulfillment Order multiplied by that amount DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(196,'BOMExtras','Extra Charges for Build Orders','Extra Charges for Build Orders',1,304,4,0,'5.0.9389',NULL,NULL,NULL),(197,'itempricecategory','Item Prices - Category Edit','Adjust prices for all items in a specific category by a percentage or flat amount',1,305,4,0,'5.0.9495',NULL,NULL,NULL),(198,'poreqshipdate','PO Requested Ship Dates','For each line in a PO add a requested ship by date that will display in printouts',1,306,5,0,'5.0.9495',NULL,NULL,NULL),(199,'doccenter','Document Center','Upload unassigned Order and AP Bill documents and create orders or AP bills from the documents  DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(200,'prosperaddonpack','Prosper Add-On Pack','The Prosper Add-On Pack includes the Inventory, Payroll & B2b add-ons',1,307,8,0,'5.0.9506',NULL,NULL,NULL),(201,'discountaddonpack','Discount Add-On Pack','With this purchase you will receive all items listed below and save about 50% off of the regular price versus buying them separately. <br><br>Future Add-Ons are not included and will need to be purchased separately.<br><br>Add-ons include:<br><br><b>Order',1,219,8,0,'5.0.9509',NULL,NULL,NULL),(202,'blockPriorPost','Block Posting To Closed Period','Block Posting to Closed General Ledger Period',0,316,7,0,'5.0.9725',NULL,NULL,NULL),(204,'doublewindow','Invoice Format for use with Double Window Envelope','Invoice Format for use with Double Window Envelope',1,321,3,0,'5.0.9725',NULL,NULL,NULL),(205,'glbalCompare','GL Balance - Add Period Comparison','GL Balance - add Period Comparison',1,317,7,0,'5.0.9725',NULL,NULL,NULL),(206,'941taxliability','941 Schedule B Weekly Report','941 Schedule B Weekly Report',1,318,6,0,'5.0.9725',NULL,NULL,NULL),(207,'deliverynotes','Invoice Delivery Tracking','Manage deliveries after invoice creation. DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(208,'serviceship','Service Orders - Allow Shipping','Service Orders - allow shipping',1,319,1,0,'5.0.9725',NULL,NULL,NULL),(209,'supportlivestart','\"Getting Started\" Live Training Session','',1,309,14,0,'',NULL,NULL,NULL),(210,'supportcustconsulting','Customization Consulting','',1,308,14,0,'',NULL,NULL,NULL),(211,'supportonephone','Live Phone Help - 1 Incident','',1,310,14,0,'',NULL,NULL,NULL),(212,'supportdigitalmanaging','Managing Your Business with NolaPro (Digital)','',1,314,14,0,'',NULL,NULL,NULL),(213,'supportdigitalmanual','NolaPro Manuals (Digital)','',1,315,14,0,'',NULL,NULL,NULL),(214,'supportemailone','Unlimited Email Support (1 Contact)','',1,312,14,0,'',NULL,NULL,NULL),(215,'supportemailcomp','Unlimited Email Support (Company)','',1,313,14,0,'',NULL,NULL,NULL),(216,'rebatepayx','Rebate/Discounts Applied To Invoice At Payment','Allows you to apply rebates/discounts to an invoice at time of payment',1,320,3,0,'5.0.9725',NULL,NULL,NULL),(217,'posupdateprices','Update Pricing For POS & Fulfillment Orders','Allows you to click a button to update the pricing for fulfillment quotes, fulfillment orders and POS orders',1,322,1,0,'5.0.9828',NULL,NULL,NULL),(218,'itemvendorstatus','Custom Item Vendor Status Report','Custom Item Vendor Status Report DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(219,'bomautoship','BOM Auto-Create During Shipping','Automatically create BOM (composite) items when shipping if component pieces are available',1,323,4,0,'5.0.9828',NULL,NULL,NULL),(220,'usshipquote','United Stationers Shipping Quote','Shipping Quotes for United Stationers DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(221,'hidedonate','Hides the donation button','',0,0,0,0,'5.0.9824',NULL,NULL,NULL),(222,'inventoryusetax','Inventory Use Tax','Record an inventory use tax percent for your locality and display the use tax in the Sales Profitability report',1,348,3,0,'5.0.10241',NULL,NULL,NULL),(223,'bravoproforma','Custom FO Pro Forma Invoice ','Custom pro forma invoice for fulfillment orders DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(224,'pack_orders','Discount Pack - Orders','',1,343,1,0,'',NULL,NULL,NULL),(225,'pack_billing','Discount Pack - Billing','',1,342,3,0,'',NULL,NULL,NULL),(226,'pack_inventory','Discount Pack - Inventory','',1,341,4,0,'',NULL,NULL,NULL),(227,'pack_payables','Discount Pack - Payables','',1,340,5,0,'',NULL,NULL,NULL),(228,'pack_payroll','Discount Pack - Payroll','',1,339,6,0,'',NULL,NULL,NULL),(229,'pack_ledger','Discount Pack - Ledger','',1,338,7,0,'',NULL,NULL,NULL),(230,'pack_admin','Discount Pack - Admin','',1,337,8,0,'',NULL,NULL,NULL),(231,'changecustomer','Change Customer for Invoices and Service Orders','Allows you to change the customer on invoices and service orders after they have been created.',1,336,1,0,'5.0.9923',NULL,NULL,NULL),(232,'pricehistory','Customer/Vendor Price History','View previous prices paid for items on Quote, Fulfillment Order, POS order and Purchase Order pages',1,335,4,0,'5.0.9923',NULL,NULL,NULL),(233,'defaulttostaticcost','Default Item Costs to Static Cost','Activating this feature will set all item costs to the Static Cost set up for each item rather than using the costs based on purchases and adjustments DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(234,'emailtemplates','Email Templates','Create email templates that can be used when emailing out quotes, order confirmations and invoices',1,345,8,0,'5.0.10014',NULL,NULL,NULL),(235,'blockminpm','Block Price Changes Below Profit Margin','Allows you to set a minimum profit margin per item and then turn on a user setting to prevent users from changing prices below the set level on the POS and Fulfillment order pages.',1,344,4,0,'5.0.10014',NULL,NULL,NULL),(236,'maxPurch','Item Reorder List use Maximum Stock Level not Minimum','Item Reorder List use Maximum Stock Level not Minimum',1,347,4,0,'5.0.10173',NULL,NULL,NULL),(237,'authorizenetcim','Authorize.net Customer Information Manager (CIM)','Store credit cards through Authorize.net\'s CIM system and apply towards order deposits or invoice payments',1,346,3,0,'5.0.10173',NULL,NULL,NULL),(238,'arordervendor','Fulfillment Order Vendor Selection','Set vendors for fulfillment order line items DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(239,'poaccept','PO Line Item Accept','Add an Accepted yes/no box for each line in a purchase order  DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(240,'serialnuminnotes','Require Serial Number','Set up inventory items to require that a serial number be added when shipping or making a POS sale. The serial numbers are appended to the line item order notes. DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(241,'superior','Superior Carbonless Papers','Superior Carbonless Papers',0,0,0,0,'',NULL,NULL,NULL),(242,'fuisui','FUI/SUI (or FUTA/SUTA) Report','FUI/SUI Report',0,0,0,0,'',NULL,NULL,NULL),(243,'usaepaycd','USA ePay Credit Card Storage','Store customer credit cards securely with USA ePay\'s Customer Database tool and run charges against those cards for invoices and order deposits',1,0,0,0,'',NULL,NULL,NULL),(244,'EOMPlusX','Invoice Term: EOM Plus X days','Invoice Term: EOM Plus X days',0,0,0,0,'',NULL,NULL,NULL),(245,'payTypeExclude','Allow Pay Type to be excluded from Hours Worked Calculation','Allow Pay Type to be excluded from Hours Worked Calculation',0,0,0,0,'',NULL,NULL,NULL),(246,'aiproducts','Custom A&I Products Integration','Customer Integration with A&I Products to send over order info DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(247,'groupship','Allow Group Fully Ship Fulfillment Orders','Allow Group Fully Ship Fulfillment Orders',0,0,0,0,'',NULL,NULL,NULL),(248,'eftcanada','Canadian EFT Payments','Generate EFT files formatted to Canadian banking standards to pay vendors or receive money from customers',0,0,0,0,'',NULL,NULL,NULL),(249,'itemstatusvalue','Item Values on Item Status Report','See inventory values in the Item Status report for on-hand and available quantities based on the current item cost',0,0,0,0,'',NULL,NULL,NULL),(250,'oscommanualimport','osCommerce Manual Import','Manually import osCommerce orders DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(251,'usaepayeft','ACH/EFT Processing Via USA ePay','Includes ACH/EFT processing to pay vendors and receive money from customers using USA ePay',1,0,0,0,'',NULL,NULL,NULL),(252,'pm','Property Management','Property Management System DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(253,'positemcategorytax','Item Category POS Sales Taxes','Set sales taxes for POS orders based on the item category DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(254,'detailedarstatement','Custom Detailed AR Statement','Customized Detailed AR Statement DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(255,'authnettransimport','Authorize.net Transaction Import','Import transactions from Authorize.net to aid bank reconciliation DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(256,'user_limit_10','Expanded User Limit (10)','Increase the user limit to 10 users',0,349,8,0,'5.0.10718',NULL,NULL,NULL),(257,'user_limit_25','Expanded User Limit (25)','Increase the user limit to 25 users',0,350,8,0,'5.0.10718',NULL,NULL,NULL),(258,'user_limit_50','Expanded User Limit (50)','Increase the user limit to 50 users',0,351,8,0,'5.0.10718',NULL,NULL,NULL),(259,'user_limit_100','Expanded User Limit (100)','Increase the user limit to 100 users',0,352,8,0,'5.0.10718',NULL,NULL,NULL),(260,'custrequirestatement','Customer Requires Statement','Adds an option to the customer account to require a statement.  If unchecked the customer will not be included when batch printing or emailing statements.  DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(261,'intercompanygl','Intercompany GL Entries','Create GL entries for more than one company at a time',1,353,7,0,'5.0.10786',NULL,NULL,NULL),(262,'userpaymentmethods','Limit User Payment Methods','Limit the types of payment methods users are allowed to accept',1,354,8,0,'5.0.10808',NULL,NULL,NULL),(263,'sumarglpmt','Group AR Payment GL Entries','Groups GL entries together by GL account when more than one invoice is paid rather than having individual entries for the amount of each paid invoice. DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(264,'hotelusage','Hotel Statistics & GL Reporting','Provides a way to record daily totals for rooms available, rooms rented and total room revenue for reporting on the Profit & Loss Statement',1,0,0,0,'',NULL,NULL,NULL),(265,'customsimplestatement','Custom Simple Statement','Customized simple AR statement format with PO # on same line as Invoice # DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(266,'deletionreport','Deletion Report','View deleted data for customers, quotes, orders, invoices, vendors, purchase orders, vendor bills, journal entries and bank deposits and see who deleted the entries and when',1,0,0,0,'',NULL,NULL,NULL),(267,'itemcust','Assign Customer to Item','Assign Customer to Item',0,0,0,0,'',NULL,NULL,NULL),(268,'zencart','Zen Cart Integration','Sends orders from your Zen Cart online store directly into NolaPro.',1,355,10,0,'5.0.11043',NULL,NULL,NULL),(269,'numinvoicecopies','Customer Invoice Copies','Set a default number of invoice copies to automatically generate on a per-customer basis.  Does not apply when emailing invoices.',1,357,3,0,'',NULL,NULL,NULL),(203,'canadianpayroll','Canadian Payroll','Provides support for processing payroll in Canada',1,0,0,0,'',NULL,NULL,NULL),(270,'rpr','RPR Custom Imports','Customized imports and processing for RPR DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(271,'mobile_pos','Mobile POS','Allows a user to be created with a UI designed for a mobile environment.',1,358,1,0,'5.0.11132',NULL,NULL,NULL),(272,'mobile_pos_ssic','Mobile POS (SSIC)','Specific Mobile POS settings for just SSIC',0,0,3,0,'5.0.11132',NULL,NULL,NULL),(273,'itempaymentplans','Item Selection On Payment Plans','Allows items to be selected on a payment plan but does not affect stock levels',1,359,5,0,'5.0.1147',NULL,NULL,NULL),(274,'warehouselocationhistory','Location Within Warehouse History','Tracks when the Location Within Warehouse is changed for items and will display a history of changes on the Add/Edit Pricing & Location page',1,360,4,0,'',NULL,NULL,NULL),(275,'vendormultigl','Multiple Default Vendor GL Accounts','Allows you to have multiple default GL accounts for vendors, so when an AP Bill is created you don\'t need to select all the usual accounts for the vendor as they will be pre-selected',1,361,5,0,'',NULL,NULL,NULL),(276,'persiandateselect','Persian Date Select','Allows dates to be selected with a Persian calendar.',1,362,8,0,'5.0.11223',NULL,NULL,NULL),(277,'separatestmtbyshipto','Break Out AR Statements By Ship To Address','Allows you to view AR statements broken down by ship-to location',1,363,3,0,'',NULL,NULL,NULL),(278,'importposlineitems','Import FO/POS Line Items','Provides a way to upload a CSV file with item codes, quantities and prices when creating fulfillment or POS orders',1,364,1,0,'',NULL,NULL,NULL),(279,'multicustomerpayments','Split Single Payment Between Multiple Customers','Allows you to apply a single payment to more than one customer.  Useful if you bill entities separately, but receive a single check from a corporation to pay invoices for all entities.',1,365,3,0,'',NULL,NULL,NULL),(280,'blockoverseasorders','Block Items From Shipping Outside USA','Set up items which are not allowed to be added to fulfillment orders if the ship-to country is outside the US  DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(281,'checkdigitalsignature','Digital Signature For Checks','Upload a signature file for printing on AP and payroll checks',1,366,5,6,'',NULL,NULL,NULL),(282,'mage','Magento Integration','Magento Integration',0,0,10,0,'5.0.11326',NULL,NULL,NULL),(283,'rtmed','RealTime Med','RealTime Med Custom',0,0,0,0,'5.0.11372',NULL,NULL,NULL),(284,'itemclone','Clone Items','Make duplicates of existing items.',1,367,4,0,'5.0.11380',NULL,NULL,NULL),(285,'purchase_proposal','Purchase Proposal','Allows a PO to be saved as a Purchase Proposal',1,368,5,0,'5.0.11402',NULL,NULL,NULL),(286,'task','CRM/VRM/Tasks Tools','CRM/VRM/Tasks Tools',1,370,10,0,'5.0.11442',NULL,NULL,NULL),(287,'belarus_picklist','Custom Picklist PDF Style For Belarus','Custom Picklist PDF Style For Belarus.  Provides extra header room for first page to show shipto & order number under barcode.  Aligned to print to specific sticker paper. \r\nInvoice Auto-Email label will show under Sold-To box if user has this setting ena',0,0,0,0,'5.0.11481',NULL,NULL,NULL),(288,'leads','Track Customer & Vendor Leads','Allows for tracking of customers and vendors as a lead.',0,0,0,0,'5.0.11542','Permite el seguimiento de clientes y proveedo','',''),(289,'calc_discount_btn','Enter Payment Calc Discount Button','Added a button to the Enter Payments screen that sets the discount field to total minus paid.',0,0,0,0,'5.0.11545',NULL,NULL,NULL),(290,'order_revisions','Order/Quote Revision History','Saves a PDF copy of the quote/order after each save with a revision number.',0,0,0,0,'5.0.11610','',NULL,NULL),(291,'limit_add_companies','Increase Company Limit','Increases the allowed number of companies for this subscription.',0,0,0,0,'5.0.11785',NULL,NULL,NULL),(292,'limit_add_users','Increase User Limit','Increases the allowed number of users for this subscription.',0,0,0,0,'5.0.11785',NULL,NULL,NULL),(293,'limit_add_customers','Increase Customer Limit','Increases the allowed number of customers for this subscription.',0,0,0,0,'5.0.11785',NULL,NULL,NULL),(294,'limit_add_vendors','Increase Vendor Limit','Increases the allowed number of vendors for this subscription.',0,0,0,0,'5.0.11785',NULL,NULL,NULL),(295,'limit_add_transactions','Increase Transaction Limit','Increases the allowed number of transactions for this subscription.',0,0,0,0,'5.0.11785',NULL,NULL,NULL),(296,'limit_add_employess','Increase Employee Limit','Increases the allowed number of employees for this subscription.',0,0,0,0,'5.0.11785',NULL,NULL,NULL),(297,'limit_add_items','Increase Item Limit','Increases the allowed number of items for this subscription.',0,0,0,0,'5.0.11785',NULL,NULL,NULL),(298,'report_builder','Custom Report Builder','Custom Report Builder',0,0,0,0,'5.0.11800',NULL,NULL,NULL),(299,'invoicepdfref','Invoice PDF Ref.','Replaces the word Invoice with Ref. at the top of the invoice PDF DISPLAY=0',0,0,0,0,'',NULL,NULL,NULL),(300,'autofopo','Auto-Generate POs From FOs','Automatically create and receive POs from the fulfillment order page. Also includes the ability to auto-ship the order after PO creation and receipt.',1,0,0,0,'',NULL,NULL,NULL),(301,'hide_inactive_quick_item','Hide Inactive Items from Quick Item Search','Hide Inactive Items from Quick Item Search',0,0,0,0,'5.0.12029',NULL,NULL,NULL),(302,'hide_inactive_item','Hide Inactive Items from Item Search','Hide Inactive Items from Standard Item Searches',0,0,0,0,'5.0.12068',NULL,NULL,NULL),(303,'statementbankmessage','AR Statement Bank Info Message','Add a message to AR statments for when customers have bank info entered and when they don\'t.',1,0,0,0,'',NULL,NULL,NULL),(304,'advancedshippingmanager','AdvancedShippingManager.com Quotes','Get shipping quotes from AdvancedShippingManager.com for fulfillment and POS orders.',0,0,0,0,'',NULL,NULL,NULL),(305,'pacplumbing_pickticket','Special Pickticket Format for Pacplumbing','Special Pickticket Format for Pacplumbing',0,0,0,0,'5.0.12211',NULL,NULL,NULL),(306,'taxclasses','Tax Classes','Create tax classes assignable to items and order/invoice line items. Display sales tax report broken down by tax class.',0,0,0,0,'',NULL,NULL,NULL),(307,'itemvendorcompare','Compare Vendor Prices Button','Adds a compare vendor prices button to the bottom of the item edit page and quick-inventory window.',1,369,5,0,'5.0.12316','Comparar precios de proveedores Botón','Vergelyk Vendor Pryse Button','&#20379;&#24212;&#21830;&#27604;&#36739;&#202'),(308,'3dcart_belarus','3dCart for Belarus','Specific customization for Belarus\' 3dCart usage. (Checkout Questions)',0,0,0,0,'5.0.12323',NULL,NULL,NULL),(309,'invcsvcostedit','Update Inventory Costs & Quantities With Export/Import Tool','Use the Item Export/Import Edit Tool to update costs and quantities. GL entries will be made automatically to account for the change in value.',0,0,0,0,'',NULL,NULL,NULL),(310,'loghourstaxoverride','Log Hours Tax Override','Override which taxes apply for a pay period during log hours ',0,0,0,0,'5.0.12461',NULL,NULL,NULL),(311,'disc_invcat_to_cxgroup','Inventory Categories Discounts','Adds the ability to set discounts by Customer-Group/Inventory-Category combination.   After activation, you can modify these discount groupings under the Item Category edit page.',0,0,0,0,'5.0.12462',NULL,NULL,NULL),(312,'contractorsupply','Contractor Supply','Provides contractor supply industry utilities',0,0,0,0,'5.0.12500',NULL,NULL,NULL),(313,'vendor_certificates','Vendor Certificates','Manage Vendor Certificates.  Adds ability to require valid certificates from vendors before purchase orders can be created.',0,0,0,0,'5.0.12538',NULL,NULL,NULL),(314,'monthly_archive','Monthly Document Archive','Archive copies of reports as PDFs at the end of each month. Reports include: AR Aging - Detail, AR Aging - Summary, Accounts Overdue, Summary of Invoices, Payment Report, AP Aging - Detail & AP Aging - Summary',0,0,0,0,'',NULL,NULL,NULL),(315,'invoice_total_in_words','Display Invoice Total In Words','Display Invoice Total In Words',0,0,0,0,'5.0.12609',NULL,NULL,NULL),(316,'customerholds','Customer Holds','Allow a customer to be set to on hold',0,0,0,0,'5.0.12615',NULL,NULL,NULL),(317,'directexpensepayments','Direct Expense Payments','Create direct expense payment GL entries',0,0,0,0,'5.0.12617',NULL,NULL,NULL),(318,'addressverify','Verify Addresses','Shows if a customers address is valid. (US Only)',0,0,0,0,'5.0.12651',NULL,NULL,NULL),(319,'writeoffs','Customer Invoice Write Offs','Customer Invoice Write Offs',0,0,0,0,'5.0.12663',NULL,NULL,NULL),(320,'archargeback','Customer Invoice Charge Backs','When entering a payment, you can now select an amount to charge back.  This will reduce the invoice total by the charge-back amount and open a new invoice with the charge-back amount.',0,0,0,0,'5.0.12668',NULL,NULL,NULL),(321,'arjointchecks','Joint Checks Flag for Payment Entry','Adds a Joint Check checkbox to Billing -> Enter Payments',0,0,0,0,'5.0.12669',NULL,NULL,NULL),(322,'customerletters','Send/Print Customer Letters','Send/Print Customer Letters (Mail Template Add-on Required)',0,0,0,0,'5.0.12670',NULL,NULL,NULL),(323,'directarpayments','Direct AR Payments','Create direct AR payment GL entries',0,0,0,0,'5.0.12716',NULL,NULL,NULL),(324,'importemployeeexpenses','Import Employee Expenses','Import Employee Expenses and create AP Bills to pay employees as vendors',0,0,0,0,'5.0.12742',NULL,NULL,NULL),(326,'glcategories','GL Categories for AR/AP','Allows you to assign GL categories to invoices and bills and then filter the Profit & Loss statement by category',0,0,0,0,'',NULL,NULL,NULL),(325,'fax','Fax Invoices & Statements','Fax customer statements and invoices',0,0,0,0,'5.0.12764',NULL,NULL,NULL),(327,'autoimport','Auto Import','Allows the system to be set up to import CSV files from /uploads/imports/arinvoice/{for-company-id}/ and /uploads/imports/gltransaction/{for-company-id}/',0,0,0,0,'5.0.12778',NULL,NULL,NULL),(328,'importlog','Import Log Report','Enables the import log report.',0,0,0,0,'5.0.12781',NULL,NULL,NULL),(329,'dynamicwebtwain','Dynamic Web TWAIN','Scanning Integration with Dynamic Web TWAIN',0,0,0,0,'5.0.12838',NULL,NULL,NULL),(330,'positive_pay','Positive Pay','Sends written checks to Positive Pay',0,0,0,0,'5.0.12865',NULL,NULL,NULL),(331,'order_val','Printing Order Value','Report of the value of pending orders for NolaPrint',0,0,0,0,'',NULL,NULL,NULL),(332,'zlien','ZLien','Sync with zlien`s cloud-based platform for lien rights & lien waivers',0,0,0,0,'5.0.12943',NULL,NULL,NULL),(333,'omr','Optical Mark Recognition','Enables OMR printing marks during certain print actions',0,0,0,0,'5.0.12983',NULL,NULL,NULL),(334,'importinvoicechanges','Import Invoice Changes','Import customer & job changes on an invoice (CSV)',0,0,0,0,'5.0.13092',NULL,NULL,NULL),(335,'glfunds','Fund Accounting','Fund Accounting',0,0,0,0,'',NULL,NULL,NULL),(336,'noinvoiceglhistory','No Invoice GL History','Do not keep a GL history of invoice edits',0,0,0,0,'',NULL,NULL,NULL),(337,'autopostgl','Automatically Post GL Entries','Automatically set the status of all new GL entries as posted (won\'t post into closed years or months)',0,0,0,0,'',NULL,NULL,NULL),(338,'oldinvoicepage','Old Invoice Page','Classic Invoice Edit Page',0,0,0,0,'5.0.13352',NULL,NULL,NULL),(339,'poseditinvoicepage','Edit Invoices on POS','Edit Invoice with the POS Page',0,0,0,0,'5.0.13354',NULL,NULL,NULL),(340,'alwaysshowautoadd','Always Show Auto Add','Always show the add option next to the auto-complete boxes',0,0,0,0,'5.0.13373',NULL,NULL,NULL),(341,'checkedit','Edit Checks','Edit AP Checks',0,0,0,0,'5.0.13387',NULL,NULL,NULL),(342,'itemdescriptiononly','Item Description Only','Only show item description for pdf generation if line item is not from inventory (allowing notes, blank space, etc in between line items)',0,0,0,0,'5.0.13387',NULL,NULL,NULL),(343,'editbankdeposit','Edit Bank Deposits','Edit Bank Deposits',0,0,0,0,'5.0.13395',NULL,NULL,NULL),(344,'blindship','Add Blind Ship to Orders page','Add Blind Ship option to Ship To form on the Order page',0,0,0,0,'5.0.13396',NULL,NULL,NULL),(345,'manualcheckfirstpageinfo','Custom First Page Manual Check Info','Custom first page manual check entry boxes',0,0,0,0,'',NULL,NULL,NULL),(346,'inquiriestab','Inquiries Tab','(NP6-UI Only) An additional main menu tab that provides immediate access to various data. All displayed information is read only.',0,0,0,0,'5.0.13440',NULL,NULL,NULL),(347,'invzone','Warehouse Zones','Warehouse Zones',0,0,0,0,'5.0.13444',NULL,NULL,NULL),(348,'itempricesspecial','Special Sales Pricing','Set specific item prices by customer or job (Jobs requires add-on)',0,0,0,0,'5.0.13453',NULL,NULL,NULL),(349,'invadjustmentrequests','Inventory Adjustment Requests','Create requests to users to verify inventory counts.',0,0,0,0,'5.0.13465',NULL,NULL,NULL),(350,'dcreorder','Distribution Center Reordering','Stock Replenishment via Distribution Centers',0,0,0,0,'5.0.13482',NULL,NULL,NULL),(351,'patient_import','Custom Patient Customer Import','Custom Patient / Customer import - special handling of private information from import file.',0,0,0,0,'5.0.13542',NULL,NULL,NULL),(352,'b2b_appointments','B2B Appointments','B2B Appointment Scheduler',0,0,0,0,'5.0.13547',NULL,NULL,NULL),(353,'cx_copy_pick_tickets','Customers Pick Tickets','Double prints pick-tickets. One without order notes and one with.',0,0,0,0,'5.0.13644',NULL,NULL,NULL),(354,'rentals','Rental Orders & Invoicing','Adds the capability to create and invoice Rental Orders via the existing POS/FO page',0,0,0,0,'5.0.13654',NULL,NULL,NULL),(355,'shopify','Shopify Integration','Private App Integration with a Shopify store',0,0,0,0,'5.0.13815',NULL,NULL,NULL),(356,'priceoverriderequests','Price Override Requests','Prices for stocked items cannot be changed except by changing the price level unless an override request is initiated.  Users must be assigned rights to approve these price override requests.',0,0,0,0,'5.0.13830',NULL,NULL,NULL),(357,'paxterminal','CC Payment Terminals','CC Payment Terminals',0,0,0,0,'5.0.13876',NULL,NULL,NULL),(358,'maillog','Mail Log','Mail Log',0,0,0,0,'',NULL,NULL,NULL),(359,'cloneserviceorders','Clone Service Orders','Clone Service Orders, option for copying time records.',0,0,0,0,'5.0.13940',NULL,NULL,NULL),(360,'apvariancereport','AP Variance Report','Report to track differences between the AP module and related GL entries',0,0,0,0,'5.0.13954',NULL,NULL,NULL),(361,'hubconstruction','Special Behaviors for Hub Construction','Special Behaviors for Hub Construction',0,0,0,0,'5.0.13962',NULL,NULL,NULL),(362,'ebay','Ebay Integration','Ebay Integration',0,0,0,0,'5.0.13969',NULL,NULL,NULL),(363,'b2b_remoteregistration','B2B Remote Registration','Allow B2B user registration from a remote website',0,0,0,0,'5.0.13992',NULL,NULL,NULL),(364,'membershiptracker','Membership Status Tracker','Track changes to customer membership changes including detailed report',0,0,0,0,'5.0.14075',NULL,NULL,NULL),(365,'motorstate','Motorstate Features','Import Item Information provided by Motorstate',0,0,0,0,'5.0.14133',NULL,NULL,NULL),(366,'billtrust','Billtrust','Exports for Billtrust',0,0,0,0,'5.0.14151',NULL,NULL,NULL),(367,'customcustomerlist','Customizable Customer List','Customize selection, sorting, display, and output fields (including custom fields)',0,0,0,0,'5.0.14246',NULL,NULL,NULL),(368,'ordernumbering','Custom Order Numbering Schemes','Individualize numbering schemes for Service Orders, Fulfillment Orders, and Quotes per company.',0,0,0,0,'5.0.14322',NULL,NULL,NULL),(369,'amazon','Amazon Integration','Integrate with Amazon Seller Central',0,0,0,0,'5.0.14412',NULL,NULL,NULL),(370,'invoiceslockedbydate','Invoice Locks By Date','Locks Invoices so that cannot be editted after the Invoice Date',0,0,0,0,'5.0.14675',NULL,NULL,NULL),(371,'recurringbilling','Recurring Billing, Customer Subscriptions','Recurring Billing is an enhanced replacement for Payment Plans. Easy automation of invoicing and potential to collect payments from USAePay Customer Database feature.',0,0,0,0,'5.0.14821',NULL,NULL,NULL),(372,'paymentonaccount','Customer Payment On Account','Enable customer payments to On Account, with option set per-customer.',0,0,0,0,'5.0.14851',NULL,NULL,NULL),(373,'invoicepicklist','Invoice Pick List','Invoice pick list print option shown after POS.',0,0,0,0,'5.0.14940',NULL,NULL,NULL),(374,'cxstatementremitformat','Customer Statement Remittance Format','Customer Statements will print with a Remittance Amount line and a tear away header.',0,0,0,0,'5.0.15206',NULL,NULL,NULL),(375,'emaildailysalesreport','E-Mail Daily Sales Report','Users can be set to receive a daily e-mail containing a list of invoices.  A maximum sales margin for invoices to send can be set.',0,0,0,0,'5.0.15434',NULL,NULL,NULL),(376,'cxstatementconstructionformat','Customer Statement Format: Show PO and Client Project Number instead of Invoice Amt and Payments','',0,0,0,0,'5.0.15451',NULL,NULL,NULL),(377,'filesystemdbondisk','Store Uploaded Files On Disk','Store uploaded file attachments on disk instead of inside the database.',0,0,0,0,'5.0.15650',NULL,NULL,NULL),(378,'lastpocost','Last Cost From Purcahses Only','The Last Cost will be based on Purchase Order pricing only.',0,0,0,0,'5.0.16019',NULL,NULL,NULL),(379,'companywidewacost','Weighted Average Cost Company Wide','Item weighted averages costs will use company wide averages.',0,0,0,0,'5.0.16065',NULL,NULL,NULL),(380,'serialnuminnotesreceiving','Require Serial Number When Receiving Items','Set up inventory items to require that a serial number be added when receiving a Purchase Order. The serial numbers are appended to the receiving notes.',0,0,0,0,'5.0.16163',NULL,NULL,NULL),(381,'hideitemcategorycolumn','Hide the Item Category Column on Inventory Item Table','Hide the Item Category Column on the Inventory Item Table',0,0,4,0,'5.0.16287',NULL,NULL,NULL),(382,'customertaxsetupreport','Customer Tax Setup Report','Report to show Customer tax settings for the default company tax exempt status, company ship-to tax exempt status, and primary sales tax district',0,0,3,0,'5.0.16358',NULL,NULL,NULL),(383,'paperproofmylarrequest','Custom Paper Proof / Mylar Request Form for Limitless Enterprises','Custom Paper Proof / Mylar Request Form for Limitless Enterprises. Accessible from Orders Page.',0,0,1,0,'5.0.16565',NULL,NULL,NULL),(384,'arordercontactdetails','Use Contact Details for Orders','Will Use the selected Contact for Bill-to information for Orders and Quotes.',0,0,1,0,'5.0.16850',NULL,NULL,NULL),(385,'setglpostdateonpotoap','Set GL Post Date on PO to AP','Allows the user to define the GLs post date for the transactions created by completing the PO to AP process',0,0,0,0,'',NULL,NULL,NULL),(386,'multiauthnetccaccounts','Multiple Authorize.net CC Accounts for one company.','Allows the use of multiple Authorize.net CC Accounts for one company.',0,0,3,0,'5.0.16888',NULL,NULL,NULL),(387,'saveorderentryprogress','Save order entry progress for new orders','Allows the user to restore an order that was not yet saved',0,0,0,0,'5.0.16924',NULL,NULL,NULL),(388,'salescategoriescheckacct','Set Default Checking Account(s) for Sales Categories','Set default Checking Account(s) for Sales Categories when entering payments for invoices.',0,0,3,0,'5.0.16934',NULL,NULL,NULL),(389,'salestaxreuters','Use Sales Taxes From Reuters Import File','Use Sales Taxes From Reuters Import File.  This is use for places that have county/city rate that vary depending on city-county combinations.',0,0,0,0,'5.0.16958',NULL,NULL,NULL),(390,'salescategoriesglaccts','Set Default GL Accounts For Sales Categories','Set default GL Accounts for use with Sales Categories. These GL Accounts will be used instead of general company defaults when this feature is activated.',0,0,3,0,'5.0.16966',NULL,NULL,NULL),(391,'jbncustomcommissions','JBN Custom Commissions','Custom Commissions for JBN Consulting.',0,0,5,0,'5.0.17020',NULL,NULL,NULL);
/*!40000 ALTER TABLE `feature` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `feature_activation`
--

DROP TABLE IF EXISTS `feature_activation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `feature_activation` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `featureid` int(10) unsigned NOT NULL default '0',
  `serial_number` varchar(50) NOT NULL,
  `entrydate` datetime NOT NULL,
  `code` varchar(50) NOT NULL,
  `disabled` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `featureid` (`featureid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `feature_activation`
--

LOCK TABLES `feature_activation` WRITE;
/*!40000 ALTER TABLE `feature_activation` DISABLE KEYS */;
/*!40000 ALTER TABLE `feature_activation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `featurecategory`
--

DROP TABLE IF EXISTS `featurecategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `featurecategory` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `featurecategory`
--

LOCK TABLES `featurecategory` WRITE;
/*!40000 ALTER TABLE `featurecategory` DISABLE KEYS */;
INSERT INTO `featurecategory` VALUES (1,'Orders'),(2,'Notes'),(3,'Billing'),(4,'Inventory'),(5,'Payables'),(6,'Payroll'),(7,'Ledger'),(8,'Admin'),(9,'Plug-Ins'),(10,'eCommerce Apps'),(11,'Language Packs'),(12,'Freebies'),(13,'NolaPrint');
/*!40000 ALTER TABLE `featurecategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `filecategory`
--

DROP TABLE IF EXISTS `filecategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filecategory` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `active` (`gencompanyid`,`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filecategory`
--

LOCK TABLES `filecategory` WRITE;
/*!40000 ALTER TABLE `filecategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `filecategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `filedata`
--

DROP TABLE IF EXISTS `filedata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filedata` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `fileitemid` int(11) unsigned NOT NULL default '0',
  `filedata` blob NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `fileitemid` (`fileitemid`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filedata`
--

LOCK TABLES `filedata` WRITE;
/*!40000 ALTER TABLE `filedata` DISABLE KEYS */;
INSERT INTO `filedata` VALUES (1,1,'\0JFIF\0\0H\0H\0\0\0C\0\0C\0\0n\"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0	\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0CgYwq&>xK(}{h<uE\"lل+0{ZC&RTPk#Uܝ\"pеRUhqF6%@ICu.ۑe`@()nA>p\ndYHF\"ֶPXhnzcѡ͗h@lЦhآVQ 6{Ƣ;C\nl]}>:rDm Kt9Bh:ʕJ4LO$8AʨG-E啫J\\m*KRVr5hqHmMR@q铗!IKPb$K׎ג0	Me2$56{\\صvnqXC\\ߎRczl(rF>r\rEdj2/g_>&~$ӧ޴E7rg.˲[5ٵc8mOAN9!\"{΀p%Ǟ!Mu݂T}6RAz֘Nun;u2/V6m\"t1Wan\\ߒljN*(,w:~0V2S]zn}3dT<yPGR,BC֒2#FܵXk{ymln7=iUj@UFn5xъժ3u?lR^ڙɿm+?wqݪ{M8\'o\0ZyyZ\ZК3xmRA2ʝ6bKؐ5*Ul}!Uo=͵ɢ.76b֊J)~:Wtwp~\0Cv5T[wǽv#j=JUO{v\"Ve{sfxiũHL[q3ZTIa6ƽ0l^3yhOi\"ZrTgYmRيm.\'{=\ZF{j͂D0xiQv/Uͧ9ˍe}c_dsZk65H/`N%H}\\ax<%HCkU0\"uVmL+\rH;8P=5#o1Ӣ˷J\0@5וS\\\'691?џPݶJIǑz\n9е2itYAc\0QP{dS΀8S)]Y{vy#)WN-fU)5f?zߑ|jLrD)㲖3_Zn\Z٫B	uS1B{U8ZJ7pRMV$Z:>EARw\"@ʩ9IRsT ft-5jE}QB6#:Vօ#!(Q[:r\0ɲ:9xtЪxa2[Z5\rw`8_捀A[4Ƨ­<S]\'EݵF\0:j,=V՚a5Ntq2ݐ1Q;g]-EZäǕ:$u֚\"$([,\\iA,˪9yh>l{+AfE-N>R	4;:-hqHT;W1JJYkL*XezdQǖQ{#2EArTx0I*0ج`i;*7ă\Z~ۏ.l5?%fIa%w\0/\0\0\0\0\0!1\"#$ 23A%04@\0\0S狎H_Ց7x~˦~Rnyu)ᄗ\0E8@lP̤g\'xO.rFr&2Kd7=903JĆ뙢Bcf~C`]E\'W߉`Ln!6ITf]Yo|dIӫ(d#D\\g`񓷪N]D/fk\0cweHh,@W\'&p\0dr_DvO@#p?$(˷N>S/7Ku#p̦K\'boWU\0ҪNȟ3(d#!A#Hy#PQ\0rc؟.&v7I#sq3;;0rVb(b-dM((eMn\\_!4sDiR-tg/?t#LBo/QE$S8AF&̞b>H@Xz},Y,\Z>^9ăzBB4\"N?iU3gN9JgAJv@Sض$V,bH	&(F)E\rjHU≅ۑ(Q{vٿǳ/ra_T]vipdΞ3c#x12/va0H-A0LQdD?R	E	\"6\0B;\ng`@	L(ʉZǩbOvChvI>>fI[\'}Ey\rY:䡘㚳/{;}3\")D9XA;fL\09\\N#f>]cn¢~yh۔ \0zƟܚݷ-9>G4c;JŘcEW+KQ[iS\0/d=rMϐ-])Q1\\\\FWr|wkp;D&L y_hƴx\'V0\0x~y]:ǟC,7FASgP8F{\"Ѯ,P\rrA(Q&gQv<o0ҘOM۳vBVi]8(xR2V\0;1rHzڦ[<._	[\\97\\,rbj9\ZcRXzqkU&\0+_/Yn?xj4C)^R~?q>8SIXleG|6~̴m.\0	Coٓi5\rZXhn8c.3ӓi38-^,x\"D\Z$>myF_4Jݟ\nR*6mǜ-~bW|n=lJ(/36z^C;9TMVmĨg^&2\"51v)jH-/fN\0s@o?g]A7׼\\arv[JhFmxtzfX|&Nq;t0c䥴jP9bp*ޫV+O~F\'>>NoT9l?\rO3ggdŨ`SiU=y\',6;\\ӵ\Z|^05q73~>ĉ#FAOwg/{zBh}0h7E+$|`)`u⥏^%&6d`4Hr+ILO}kl\"ʮz9@\n}<SXMJ!`IF\"!?g7Xwi*x<lb,\ZQ\\طS+\Z161\03{7>䷯?Mλ<G0IX(-6dbm{j-0֫-ۺEf \0#ZڭGl9aؕ%,r/ã⫊ٜ$~VNL?6Y5S5ƥϟbrK9c$XJKT9,h0M|-lMqTX.V%2~Ql㿆q M׳;ug&ۃC\0rv۠ɹtIs5fZzkz$59c5;Xמ}jKm[	ïSlF-[٭jLKsQ\0^Ox4ܦBZY}:VRqG	/guXkSV4#L.X[\0?xFp}W1&}[;nAjS|+vYC?</ٽ&%73r\"O%oayZJ煩+ԩt*,4OA-]~w\ZcRUsHs᳖0p&n\\É*yxKXZeq7HFJ,|`#N6MJ6G(DHq\\hbF&u>6%2>qL12$EDJTqidfѲ\rxC\Z|l.MR[um̞_\r\Z\\I\Z/|OqNˍn#frljzh|8Ϗk~2Ik4I!L,Шd$$0BرF5\'H5.<IK2vf/$ɑ}O_?PK{xϸ@m#&O;(\'^ɼI+F&G0գK58 q1$c/Sp~bo-]3\"Gj>ZA㫲V*նN\n&ֵd1W4Gu+n?V!&u~e~bRDq@9)?W,Ⱦ,\naMU7I\"a_ߏf;;E#6ᢙ	FDݙq&dȋ(8mRp2r3\"=S&_$8M\'FdzCdn֊.~ڷRkMNꑜ_XkbijuQi\03dݲe:\n-5zu)əN?D݇;?gSӌ qau/!&8a\\An?~3QGPN<rG/)t\0q>yKi$y|29F5?cy)7\\! F_C\ZQ_`%%HP+q̚*j.\"!M\\xf^\0jsܥOF⣐G&uQ0yYޤo\\Awx@7+]p3&o\0{yoe)tH/atdp(\'9~BiML3NX\05\0	\0\0\0\0\0\0! 13\"#2ABQSCRacqb\0?^ABMB`X-Bn9Hk ,7Dv]YLj#eɂ<\"`B֡`[pX7mR)T5*g9ӸE]cu\rRSW?Txdg9FÄ!rVʓU`m6}Ӷuc9hBd-\\nFCt>+?zVtq:\'	ԬbYޫ=WJٹJBeҎ\"Cwls\0io!V?#lR)TBq,^_}fj4XFԀx5Z4Qdi𶬍FyQ#c}\ni~j?WzkT!c>\'ǲ\'g\\t E$/f4,0	*c5O&4Ġܶ.\Zo5M|TטC_$CI,\\⹐4{K$15GA^M~޿\nYs&\"\"Y]-3fD]&D7%eC#7Cr?`rK)CT歙ՆoeQvN3]WJGpnX7*Skdgrdv9Sj~і5E=%WuH`c%%]Yd冡.Ц	-j1	{SCS\0N@qQ#C*lu#/,>)b.2]\rъn9H p\nwo*ps/._ܶp[U\'x\\D;Z,b	!hX-E7CtZ\"9Z²MEL؜_T`fAw?715`Z-7rJ֬Mdn)83LH8b,BRh/\0:\0\0\0\0\0\0\0!A1 \"#2Q03CRSaq$Bc\0?$w}rqodIE/@\\E{;4XYD,X<SNw%oBCw]k;ٟ-qn-ΟD[{\"\\E0G]eQު6$U4z\'C歆|5\'6*y/V\0J;ڟmo~G$Q~ϪhџRC#Z,i10zMnXlfBֆK\0>2o}y\0V7)KEc\Z^c5^WMȦM%\rZ(0sU[rΔ\"FkT?콠מAoJb\0Zַ\\\0`1%fg[lUu./EK^I`.\Z`u `mz{\Zk*jڈߵGW	\0(w>;tNvq<E)0I.Lb̓$K1|R$A0EB\nWwئZ8ho9K2WJ&Bywe;DMfh2ICB(IboS)\0ǈp.O}Rم~s4a۟\n-Z(8--IvZrB4MlM(9X?y̶̟;.Dʀ06U+jS<lFw~\"2Ě\"f_\"DŻB|E<ALD兓8X=pWܚMS=8hax!ওQ!>xDZgV:~!|t,q\\=V,,ԲbHv.@hEٳA\0K\0;B\nakWg\nioy>E	T[zKߋWgeL[UǅFaDYe>ۚ\"[>!	j>IrE-8WmXBeqD\\_~TSm\rʫjSICcڀ5-nd2}s޺qn$ȓyod^\0D\\-|^;rMe܏/ܜd\"~#2/\0X\0\0\0\0!1\"AQa2q#BR3br CScs$4D%06@Pdt\0\0?3\'	D`#:f*̚Gyqڎco dWdWW$8\\-e\"N&*CZd$*KZ1R)(Z\'=ԥd\"O^1/IJ;K֠@뎢_lmnM\0<u)\\񋂆U	>%QJF/suqvtJA_hPq֖Z[Hw\'(n%Y[~ۯqext>5PvZo8UL&{WovK^WM\Z\na\nw~^5*4JḦxZ~mT4ʫw[3*cur+xa-X#\\bEkZC([\'FԮ9H{κVb9k6!kMOg톬\'|W]aOzƃZNgI%*Ov]#ߨS\'2MyӄS5K \nVI3Ѩ?ϣ\nuԨn	4IU|`Q7#1\n\nRsu9\"8;hnl76P{%;x:K\\*`Oe\r\'jk;/}K||P^u5IJ|x^\ZS+EɱX\"Pr\'uh&\\ =X飄?z/}#t;)QZ\0\"|u9\nr1UywA\0@7Te-@@(I8V{Q-h5थG3H)Ru%<\\zcBp9{ =`i!>N16j85κeF,%4ʾ\"=u)<BKNPEniEq	]T<pR2\n\nׇX]My=iSۄ]ij;זPIzԢqvRB3WS\nz:Q/!U8S^\r[tE,ePp82l}/Ҽ۩^DͣK5R0Q*ZQ_5UFv;K\\B)0(e	R|`4{G_|gF4Њ/>ui\\rb%k<[AOxA6%_Xa*r.p\n	i1Pzj(r\ZM#%[RaJ8d5vf\"@gjj0\rUQ\08]TG\nuԓ8=aiTj\'bA5bi}c\\biz>ϲ.˿UUtn#umP=P|GĆR@>1<ddt%Lh\'p4vÎ+fz],.P!\"1	qtP	$H%=inm^ʠyÉ(vin+\Z*RE!^QnVW]Ӗ-s/)Mt-U6UXϻRu9iTa%E`ͪJ$\nBhשKX$c\n(72փ擟(#T6yG)U))1B\nS>s<#*w11\ZO:O~S0fcX\n\nIBTfe6}auV0\"1P* \0q5K|<Q\nCo(Bn=\rTo1}GdgNcRaOK\ZuT):-o#qH./+U튤&R9w*ԏn<n[i=aO,}ۭ6.ʭ/V[wc1Be^fu^QR9)9Rq`Wݩ\\08h0JK;ǖAj4MtB7\\;࢖9~6m[>xDn)n7\ZW\"Ả xm\nME)T٣޸bvYɕLK˼o6SUZ\'8mR.~}]6p]b in\"7&G~0eʴmPzDLsIQaHIRV텄r	Mq1R2ާK\nd|8(£(Ts씀=<1JAGRI8Sh\"B\rW?BCE*L7i٨㕻Bh(O^-MxstӎNi\00gKwO}>i}\Z\ni\\5/&Ϙ[):7X7OSa_ooy*xBq͛mj\0Q<*7ZՉ{\Z!j˂4Kip!^[i(fe%<\nX=6kD<an*.LBR3= 5/8B7rl{rfmj^l)Í%?T8P}$C<s)ir6I<Vm6orRSTva=10=ͤi j{\"YRR**4H2EV8^[4ܫqBRBR7	\0fTNBg\ZTVGv0N86mAks{il*BR	7e8᪈w^[-«PQ\r{-VlZ\0-I(O|4y\rEGR[Τv\neĠE$!,pZ\nD־uxp%59)EJS*8rx}b\"b]f9FwF$\0&eWhQi$tlD-k!)|h\'!׃ΡC0[Za8Ol{i|m@y=\nX9_\0H&Fjjm[*jm7+Ǥh6t~{NaGm(i3>ގmlAhS%qdƚR[2-K2?V4Nb㒢aZeKw\nǉ,n3sex+W85N[b\0x>W+6@=D?\"0\0wת1Ueq!Ĭ)5#\rzDҐځq+	١v>!V8UqU\0Aqمj/P!\noSRmWѷdLC\ZǌrB+G-kowC\r?82<\"dn,\n6pulÈ(uTVo\'EdKlU^w~*Ux]4{TɞV%h0NbkOBPI-[\"Sf[Ghw\ZGޚܦвĺ^Iwg[)DԠ.u&R(mk~rQܘqF!/bܟDĤmnԌ*:G,%g3O:(ũt%XڬhcbYז\r(٩)w51VXei@#	S:sHxcDm5qČrI-j$@o}RV)^4p(\n.>	?ffyê[ȥJiG+uIĒS/\\qm\nf>\'pS&t(z8LX8\'!\Zܛ\npӳ9_ҏ`#t-M!O\n)^PFm8L)+hpNa5$*Z8I[IG1CT@ҷJEzaM26|[ѡBquZF~y䴂A.M0L3O.SRQ\"Yuw\"LȰܻyձ%Қg%Cgi_X_w@\Zh:UhJT9k)OYԵKR}_BKYk[!ɹAvNZISZ-5Qt5&݋(qD~Rvd[amh1*JHZ5Oi7\Z\rIms\0(HV(|M[O>mi*W>Oz;GJMF&^A-Sap<ļ\'|#GInZUr⻼1T*4%J˙|ڰRi5v}{,*\'ryǤI1Uw0Z\r46j=.P%j+i({a*\r&P6ghoBvi\ZT2V:qRH	PȀiMc%aૐ\\VFtA)k\'l{9)O:R4vA%NWu5yl}ΕRTTZ`HL6x6i@Tg	Ю>78e.#R4HB%BRC\0?FHnYODgRj\Z@	0Cr_)M(jV@ﲄD~ڑjT@H͹Q	\rz~DHP6߷8i\nK-A7Jfq)&Vbb~B[Q\'-Oaޖ\0Bi\Z?G<rkBe4[l%UiaJύ\'([:LYR)\Z_O>\\mW6Z}2J.!KuARR̘|\"@Y몇͹=Ŧk\0PVE=\r7jnyf8h7ڛZߺOdS*Ϝ,N pW(I8n8Qjp\\=j!Q\nʒL=bu\nK/HWJDM>T\0\Zq	-)nL>\r̔Zq-!k몏\Z*zgCg4Khsq%![|J0?9Թ\nO!%etRԚ?[dt\r|3Ju[1uqe+-r=+N\":GՉ{Hܜx[CJcƍ	\'idϛrbH*R)\rP<9KcP||![(6\nRpr2=qcyM}hV\r^]pq^Ȫ$gZe,474~\0˾6:2u) !iQp:7BlJnxI)\'s\nL(7w\"=Ak\rn6ẜ\01ԯ~}޺<a)dҮMy]\nҖmMr=+;td)7V]m6풡$:¾y[EGh5&ZyCqsc촔]hJ3cJr.\r_qnRم(XةjmƗiի%iG).%^-\r)\r7RH::eɊ\"WcJ\\}ܥ\0 ϔ99SMdZvWoqF)\"Ɩ2ٓkd\n)<RXDABV(H^vO葛\\m%	}QKmlRXSLUM62^[	Pb\0~gJL%Mwl9v3tttʤ\'.5PI\r|MjS1ߚAp:Z=҄[Jml `Jg\\o8Y()W\0ie+6[aP:\Zݯ]<[:o%oՃܥ~Nͮcʝ][\rEWԸ[Gf$0[nI%<6UhzblB*m$GEikq\0<uZT:BaUh\'΃φ1qu\'{i=%6?H\"}Hi?$;SZwɐ &1<uƓw\nS|^,J#Hg	@e~@IJrJJpEο(>)ZC:FPa)AvPi`})_܏IF]JT^6AZm[(TI39ܥ=wWc`3IVvSìlO F\0eŬ8Ru	r?BFF\ncu>0He	;.ÈuĢy⭛nWoe&Z=neji7~pA3Jr+]ũBDRsld-)\0S0\raNzr8!(OlgUδE}\r1:*_O08E`&A]k^@ڡƐ\n\\k$j_Qow9{ և-%JTE*::vn]rl<ڭvnʄNIJյ\nIUaQQ]x=i;+:Fk%^Ҽ(O=Д:1kdRbR$E8)Ft٩=Xg<!$[i~\r\0(V:_GNΖʛqe{vOy	6+y+i2ZdGN#TZܓnFZJ_h!auuNGp\\ޖRJ yni4?+ȉaW_/ˋOcn4d%%\Zgn\Zs1Z\07G)#R\n4>PSJEV=azdZkb4(}qs剠fQWʁM.SEyOiP)6+6!LkmO)	cSOc\ZEu;WTmjCMRHq7uJ;WX}TqPjiOɒauvY;2.NȂq0K؆h#5-^e9\"Mw/*P\nF 6y@4uԢ3gCuP8q;4釲-;%X\0cٮQ_\"қL-tJRTr;R}T<`$%C쮲(ju9LTVԀF њ^yF\0)ښOG_U8@v%-)=KnNI549\0+V֒RTRo)Mx/JBʐLɭDb_-7_C3=[%噜8&\Z+#6t֔j˜CZ^Eˡy.2o$Ь S.0CO*ӭl/,}sF6ܞ6l[X^[ IZ˖.cwjJ,Z`6R6մ?7`kX==8B21.UT(;m	G[4Q$gx| gHׯa{#UH\r6U%(n@c@N\nwCUB[J\n>\nm9[)K\\IBƊ2-*YڟqZqM)e(MFwH7QIG{j5\n\nӘ!IaHk]`{!F$u[´{L(۱k*< {K?@.Pݗ]xKzs,6Z=c:j㗪`U\Zjǰj^8}!>!48}qCEB{cZzVEL##QƔ$}qRwSJOvg𼿫)Hm.c f!`x	q2[J8B-XB\n] l0\'ȧC\'q̢<\"b]լ6VuZnA)Jvre`enj_weԲHvm0{uPCU\"h$RUvy}?B쟄)\Z{6N){WM8хN\0ZkN4˔d|!GvL8.]X1֘B]ny*]c 	@\n54ϡz(lb8UyT\r\"¤e-SuAUQܠJS\rM5隞cZrۭJ)+mIr9nꅰGw\rI U¯Mp\ZkNSi[H\0\0\rJ	8nO\nARk{\0B>u?dUChmpR5gbDcx~R	!X*8.	\0>q=LW\0%\n%hyP8Q]Pꡲ6i^j;WW~n\rAr]EK?=l7W@p񇷫[~1)Ȱ(oW8J{C|c*}DV7ڠu!OihlEn5δ疧TAJr	9م6kE 2\n\rV:\0rb?~wN?ϫՇc6?UªnUO}\rcc#\0`O=/\0=;}*WՏ\0\'\0\0\0\0\0\0!1AQaq \0\0?!1S\0p,Ք\\3fHjv1Jzi(p@r\"4G2N;\0\0FA\0̵Ѷ\0;z	hs\Z_} k-!sd^Yo_CP\n\r9НX|/o%K6\Zj}\'X,a u=Fgʍo&;\np-7_giǣ1Dg59:Z\Zc#h3$B<.C_km/`|ss\rhӲY0.	g-yLG5oh5\'?OԶo0ا{L.ª`wu7M\ZY{,k{-]wô[zY+cqL4:Kz\0o!<Z4JSw`֯\'4Ne`/S1mܚ@{ԩF:)t&ǔvq\nVSq9\rN>?0n\"KCP)Z:q@ܒjhgBh\n#=_Q	AIݔcs0Z5\Z{\0CR?&`U|!rM}iІX+`51 4Ƹ惀+䎏/S\0g^Z7:}Dx:5ѻ/p\\I}EBipT6v.[t\r^aaHQLbeOFVR+4¯\\n1-ltpI2E}WxM{NZ\0:DArgķ^r=>~aBq(~\'\'	x\n:0|/pa60J7Նtl{CHMhwPfwşh|W2L>TUt5C0٥SVߐ~n0\ZN,,\0\raײ2ƚ\0h}TXN۵籇Rcu+KYm>h|#CB3P-ig.\'7pe9{xŃl%+d͖f>\r呮3JaNUuZɗY:K]\Zj::̆^#\r96fy\"Sk$\\Ut&8|#sW[ТNfr?4ㄍaG}F²מ#-cͯ9So01rbln +xDX%k\rсS-!\0s>BFc+.:LoU>5\Z<@->2&\"N\\	oVMY̅ӫVif{	*\0א_RJ\0VA],Ks^\"YpO\\>2EF\nߢurG*7Jl)MggD:8ʌDL{Ǥ?j޽\\6<ҷBsðFGw0\'FXMU2~GZ1DA)Vv\0J]a\"~MDjK;yuMU8\\w%5R\"/-5<P:2ĪYB}ߩnR<{\"95zhec0Vfu:~5Z*@:u,:n`зzEKwIN5鹅xeod1Rd&fNa*ı	^?#Jš_s\\$y/IR\03+,3e! \0Z@:/+SPl0?;jZ/Q\\Z&t8ʳS|@[-x\06/v)bl\0fpoqFq`\0At@ai>#wy<_)I,83:L\n\\TD\rɠ[++P#d1|\'kWseh4Lvs$G~bU\Zvz\rWxl|oie,Dx݆G:%;7BN	9\0.o+boM(MfE[Ǳr-KJr[[`~CFFG\0Ck_IőOy|\\(,,.ZsS~ ɴԠŅ`?e+`~S̹9ľA\'UIz4wnm|˛ǎ&URU<:=HeB,\\tFuѕ[a$Vg|gw;	D\\]FJVwV[Gk,XjleLTS_]UE*Xѷ\0iA<&%ih(\0fW@Q/HvUNU.A`\0Y:q:ҙbu;ZV3D{@Np:%z\ZUЛjY}f	@:qHbmt\0u.x-O/q\0UeCg8\nh~gA.,Nl#{x%Xr\0mOeR_&krA\'KfQZLYg\ZYe&-\"bqGKoq+,5Yu9o61P94\0#\0ŗ\Z@R)*P;>\\p\rA4o[G.5wr\0*9\r.IouVĺ	g$c&!_ԯL\nP`\n\r~\0Xxdl*M\'6[>5p̨zkwKPQFd/DJSz	bt77i\"F\rޙ,=ҨE7#if,	3v֗%+bqAN]\"k2eez=kK([ƫW{&+\ZV+j\nTSi	Fn$ԩ<P܈\rQҸNVd_+\0TPg\r)]wk\0QQ˜C\'q_*(G\0e\r0F9{r\"7sW9Lf<K䠹zhp-R.㋁	|)2ՓBKbK3 K?_K5OlBE?D!Yr\"VڔoH<f2+OWpM|6;;\\Î<٧, hpDE5jгY\r2x\\\"w/`mEc~<@BzA.9C2E{}j\\7K\nש5fOW9Ke<.	x;<^!$糊N:ʟxu%țnˁ*nZ }mXBui;oc[\r\"9番v-\\A˼RѐP4aRx*! IG[xyۈW@u\\wt3V~ݩɢ(.D\0erjv\0kMDi*:\0ȉrSqN ]JѣRv\nU+y~{uF,~MzQoCSa~b*-Ak,T;\0-sY,d.54HQZg\0ʰO\r\\aiVi*n@c\0b-R-Wnb]Z&௑^aU#\Zæefaebb&R[-ӣ~k]{`6փC1Jmke5=#/w%a==}ut48PY&j?Gl9\rAMj0_^_S\'G`FecBs0?.DxG2泆MO^{+ݺ;-4xc:B(ԶogKDPtl\ry밈30|u\\0QW?]sG\n^ڙ\n.*8׈2%9},s?Y,rc$4)#]0VΨoG0q-=0_!iKO\rq)(MF\nÿۈ:{jRx\rq	_$ѩаtgK,vIr?Oӎ;pv~/Cl%1g(H	YCܨ(Nz0fsJUaIj\n4Tg]w`;q3]Z{8pՂOW4\0!-T}S \'G NF\"8X-	bfWwo5Ul\\̴A>/F]8IRr\0Z)`:]*tWZ\rs\0.peGU)ihtr\n!f\n.a\r3@q	V5|<QʭT1խP62Syow@w;C	xNvl8f\0֥{J& \ZHgS=A(R77\\v㿈9	TgEfxk٪z$)(Q6f-I:,`gV	G\'79۰t/(#!O1utY}<0ZM+(Wn9`]\"S笤ĕ3gkfzJ&g,aD:ץ(Ϋ<E+oYHB@/\Z\n],8y#zFE&gRCv`^D觮{ɱvELh-[)O6\r=8o/f-☗!n\rt=AwܻF>\r撬߷Ce\\_U7`&FG0c=g%QЛDs,4Pkuۼjg`CP\rCN@U-zu9/Ĭ\Z놧J \0p22oOEȳFW?hW\nƠN}wqp\rΝ\0?(teP4ih(k\07䅟4rbMz^7×\\jmx+0,a*-FHתu8O\rȿlX\"aZvQI%2?*#2Pw#@5[5ֻbI5Z\r*\rG̺,N()Hf#QߑGY0xk.\Z4<M+[Ew7Ģ׆謝T e%&ꮉ򗡸p@1OʀvO5W&TKj\ZP(YlzoP*V%%9]q a884\r({Xznxm{K1l\':\n)ZtSD5?ᝫAү\r!G<-Oǖyfx͢z0N`!\0ξ~/]b&x\'?Pxd8I~)bOƃ!ָ+VSIhlz~Nc+:S΄҂bԩ$NYjX]5̀9^(ij-.Bo=(nȪ+CD0}|jmǪ>\0MyN2>dM9_6NP<Ŷ`r_1bS7ܮt5u%Woڎƍ<oiF$/Jec8 7읤?*cq/i4tXy\'!5[u)FO~ZB%칸V:\n|2yh;{c(9>9Anea5\\ԳJ%C_(\0rfƞ´ۏUCmW/-p˖d2oeE}&	BG^\0PCP={IP=Rwk˵AnK~\nJ\0@t\0wЛ\0C)\r\'c݈ӟ*HY]-%e|3mwQ=KR\0#+Rk![/]꯳)X̃oZo\0S.n,v3s7+1t\n~0g5lf^R+WQz5S։kT*TDZ?#`Xո.ZKTE ʧ-f2U9@\r^\Z+ksaV\r3+\ni\nǷml\r\Zb`W#C/\ZJj\Za?,51Un^*|]HScZ7{cC\0#Z,ql?|1#FGwVqxĺCB8Ņ.nq{KL)Gm䈌+Qfune=XTj\0\0\0\0\0\0X\rD4T$/nqp<05P$Lן@]\0bݘE\0w ^#p((Aik\Z]sx|=c}Md\0_ŠRF\Zo\0>Kl1<eLjӊHnc>1QYo<_.ZPkPdɎ%FJ6R6%&VӜ曐IBGr\0,bAQKHa=#$\0zRsTPDem~8%-b=RqXc4\0\'\0\0\0\0\0\0\0\0\01!qAQa \0?GBBe!|d/BH_r2,ypZrmlh\rM*:43RF@{!#	!u!|rH_	!|b,պ!BH_BUQ\rqU\0_g؃\n) *\0( N@کyD4\\lm#\Zy0\Z-bj	龛&aRHp*v	\0B=+񐺐2!\0\\nfVE٠HBXy愪ͮiڏĖ~4Z/M. ׷8]N]Q8\0ߢ8Fy2-HH(FA\"\0TG,~h,|=?`\n6Tm݂6wW4u`\0?Ḫz!y\0ֵ GY(A ;ڨTx@ќPB̵\"XE=\'$]n1!Uډ8AYVi!Q	dvat$ibg2SBud*p8}\n\0@A>/ёy!\0¨aHut((1tIz7-~N>\n~hJZp!Ȥ$\0{Whz1/ٖD&f3 NV`_.&YgUġ2De2BCX \"KUFڠ\01n@t(we\Z (X#C:H\0a*z[QJz\Z!!J xBFfP\0Ŷڠ0ް\". {QjD\0SO(z\"D̈>.$j*ne␺2BH_!|d/ 1R_?4TtJ玪 o&Crnd>GH_,RBD	!|$/RH_!E*A\\?QPj͕+z\\n69mJ@6\0Hv\0(\0\0\0\0\0\0\0!1AQaq 0\0?Gu\0d<p#h\09kG4~vx~rI̛~.OfDwHE\Zu0xdǶk:fnPD9=OtVOS\r4QҴ^tqȫ\"mEC8xM\0v<VRżPA\0}T1r\\	P	c/_$A\\֭(Be61P,遳oRI&3~Taӯl@^wG&`ΊP?iIBCr(>Bfd-ޣ\"KOM8	]\0۟\\smﶉ?W#/!f7FcN$;LPWGǸ5ٗ@ŷ?~(c\0u`>Cǿ<4vx<Vv <T2ۙzU\'nIxz	#\\%*RV	~2njPґipmdopIKO!#ϵi#z|pFJUؐ\0	\rIRXBb<Q&H9gΔAO@u5s~k?ƛnYfK!sSOS|QYݯCBb!CX-2;x<W`xӑw٤څQf\"R+\'^P)̎\Z\\$̎qFI]Ϙ\\ӛJćJ2t}rO|RD|iDmDߑY=O:ק\r?vOIVeZ`D?!QjA	[ΤEg>U_nv\'6PasQrlz,ö4xK:w&7#9\"YHϣ.g+FbB\0K	R!m[4sVn8|ny!7*TrjБ6_o\0`\0\"0Xer~OZ\Z8h%h\0&Jmft)Ye+ŻԈ:Dqm~SC\ZkLM3&-07b$\n!4Kq%	`JrݚW־du\0_U+ǯ\Z8hV:8u2;xzQ F_[7c_W	&	:4G\nv\"2sטLjfcJdxW\0\'\0\0\0\0!\01AQaq \0\0?z޿x\"ҧOz킁\\g!>\'$\r:@\'DP(\'X=2\0c\rWΓ	R#gH!K/	K8ɭL=]#[?y8*Hɳ\riW#`\n*ar@r}`C7-nd36uiF	& ϱ1Al\'Ϸ	#!vo|wSy2K<D^2S	6JPˇhx7ӒfǓ\rL4\'Ӎ7e\n\\Ln,`nwzDtKA6c`zp:z<~K!H\nܷ݉J}WeK͡cffc\"P`\"xUxuVN!\0$֚{ӠNTyeL}`B7g֞qCB18w=~KUt̩Z4-͎bca\0C\0bAJ%\r\n\\pL,7e`\\$Sm`c%\0J78C@5 u7ڀk1!Ayi0Bȱ֋F-gP\\XLi$]/\"u7bD\ntr\0ГGVY+2~r`{.AX\'~D:㄄)45:WB\nk-,aɐ@|:Ρ=\'$T\'B-Qx?YaO\r|L	j>0iqs^؄\'k|\04k?*D\0PKN|R\r`H9W#<<}J21rGՀ\'׉ߙ_*\0\0m:Q:\\QG\"}8ف ,\'$J}fǓCF:U\"H*&hx>~:6NO7Ǟ0)K IRT*t\0I+NT5׽x  m2IdA&\Za[HJe0GsMx\"~\\@~shx>- ݆![t4wX+P͸\n`,X}aH≽{\Z}ۯ}ixlԔlӛ_7\0kxE\03H>)(A\nTCIj\"l՛LI֎@+͹50%+#jВC%-\"EhqnJmW_DE$(2:0M2Yn.f\05s\Z:\nN t^b~vp&`,x\\uтn\0R4ҸS=Skd\0WQĴdS7Zԋ;ӽ	t/-!ӎ`Z+MetD\0d.w	?!;]嗏$w\0)\0\ZfeBa&/وfj(LfiF&8H H l#y*i 	ϛH;_j,Ml{F>RD4v=3c+spY3a<qΖ;nF$Iu.O~4I9!aUOb-C$==%(I0GMca#ϗ|@=Ƈ@	N+J|#ST㆛4bՆe6WF\0`?ZD!4pk+x|L}b)ߡOlj\']{	d\ro=;5H{/r懃Ru7%22O1YΏ<b\"Q\03BX5eq&1x}sgewuw6|}h˾!לMAz3I` q\Z&uZ3Rc5%\'D%,&\r\Z6=\r#1(H4	,fK\0F]nU	lşgLU!6He\n61(v3H{{}#dhw`\\\'RĢRε޺s\n([\r%hq\nh!2DcYfcLsN=\n&H!g.bf]ArbCԎj`X5=\"^{bA})ԧ1}BLtY<\"[=As߇_/5Y>\'p`O\n]$%BlYɉ_*\0Jt״bl{2x;8B3N66},TGe0%\'\'8<#@ˠ:DHDKH|dV \\ۆ\nscw`vAIyDwF8Ag/_={=$r`8δtW\rdĤ\0DyV3J4lvu(%!dT#RBJ	JGwNI\0n\\4Fբ0۬RX9.ˀE#sM6Ad\0!HH@d\\$&5aFBq@V\0Tzd?!g/(&xsOV)S@Z!\\sVFHAk\0s\0ȱX89B:8ʐ%i]57\0G9RŤZ;S\0E5J$^u`=&)r1!u(՜^E)`>H:iq޾ndF\ZGҠkZy׼vs-La+6|b\rF:lqc2SǗA\"]kHN$I17C O<p|26o9+_|n]̽u\r0)jz17f}`HXx\\8U|]5_M1\Z,d7%w3(n{@Q}%{\0\'`Gqj|߉f\r d}g $\')X-uZ5\'U?dB6\n\nEKP!ԒN0J%PwM5)%w?ݑs:g\0yKbN3V(J%+-4r;Ȣ^[`@n\'@t8X8l|d)WE\'wnI?%) \nDE\\bqg/>I:H%DƻX&Nf1А$4hp`؈\n[e8M{7\Z=`1+$oJ\rOVN\\Shr/]+PРcBv`GӷSfPZg\Z~ȉ^OP\np\'7Vmvo.<_?J\"jSOl4\0ݨї\00/Hf^o\'aؤu?FB4EH*n.r$N\0?CJi4-./᩼.DEBX` 7F3Y1yj=d!PΤ~rl0b=tȴQ4#K!H-=-5\0gc\0A,I[9wX#<?ܠͷW\"iK\\K\n\'1|N#`3?Sǎ98C\'L5tO\n\"9]up\"B Mz\nVad%)$7Г=,!E\0kvDTfxCcEH)Po8\n\n<I$P>#IG݁:_$My?n쌧Ax(P-/̾\\EiJN9/6Κ+ۀ%\\KU]1.Wt\r<1N33  \n@\"i9mcc#d`&$Y^SgL6ˈ2?z\0SIUf>e2w:Z9re*rlVJ/#\0\0Eʤåq\0#5!dpQBo^Y78\':bܐ6ӫ\rS85D\"r2pDI	)xNHBoˍm`9cqqa\'\Z%%j#, `1L|`]hAbMҎQ1n(\\IqVsb{cuVH7Ϭ넬X9yrwKd;Ŀs\0͉@\0+{ecKȘ8A%ޓϕ,~*-x>D~c\'Zea\Z-h,fxdoo#J(ZN4eE~x9l{bnLi\'5DQf*fX5FU\ne\'4f,oMIz1H9D$B=vk!ցir@\\Y$C\ZY	<h6! R#g-Ģ)W=2h#1^@o>/IZnQX!i2fuw$oڿ?R,)Ԧzi1&&3\Zd떆{?!I>s(A&Nʈ(w$DؑkZ(uβPaLC最Mk<%n8sA6pxwTJƺA8dX(H#αFUF^Ǳ\nWndzw@]]8g(ey\ZP\n	8U\0AY~IbuPɬSGldxy#ՒPea0)Vtu°i=`(pzA,>ӉC#&UCAkEc]do>Vq-2+~-,,]8/!Cy*nQ%BbpowX\"H#N,A̳0z`I\rr` J`./C\nЗ5s$Nn?|a!*a\\D`<>@\0\0J W(uAxs|Ǘ;(H	ep#cdBnNH&ԁ=c)ڌ!a$$h5e\0N]sXp9S\n,H;3]Q36 5{)|/>c\Z8xnF@o>1kJf9m/~YY\ZJE΀{ǪRq:R+|Y`	YA\0j0ӓg`^fdB)&&nkj0  ba]5#c۸#C=^owcL22\0r9|bh׉H72@{ĖZ80Y`X\0J,S0J\r8_HBXJ^×\n\'- 9\ZFKL?#\\T!.irz\"s+0_;h\n,n2\rThǘF#\02qQOGop-<dpr\"<&`+˔E;b&&ڬqq?qI⁖P!\rIDE%mO1;<u$MD\nlF,J$\'/HBƎ_[&B s=Ao`*\\s\\6O\01Σ=S\0Nw0Og\0Z\\@)>{ɹ1M04&Hb%IR}cuz)jЂC\0y-$g?ra:阈fX=&gDAFy˜뜫GʕQ	d 93=E#$_?	JĎPc\"c.pp$9kj1pTM\n-VxGyK!!A|9.(g\'m\'F`q|q[竺5K^\0`qK.$I<T`BT񆲈Iw`\"/(EN.5xO|20]aM`:\njR93D:Rm=-oYR_9P!XĬF\".Փx+Ѷ\"8 1W^)e7і\\82BȝK`ud~32D]\nc*w]m`:眎ޑ},weS$PKF&k~0RxZ$\\5l(a-H\'ipBI;{W9Ty;MVpO/\":0@8қ<&arYWC9@m̷&Y3A ~Iv{0j%}t#\00dcL^pߙ\n\0{LYu<%>\r8c:nU:dh}-mrĜv0c3\08cd`q3ick*reOy:=!E(Yr؏3ҋ\0x}j?y\0sZw}G$n9Qc4.u)&Dw1:ι#G|4}MځSY$_96=_Pã@Skfp_&F.	\0.	U^=M\n9ORfɊ;eDy+dE\rטS}b4.\0p[wx\ZA~8\08D-n)e  \nw!̑PvP|D6HxcZ	9l-ZnrB\0\"0j%U ϼ/#4xA:x :KkB,9fpYओ\0xgKFH	a:L#>ΞMVD$<b`\'^2ہ79\\̌\'W>%Fly>\0~VU]cQ\"Z|`X\"DN6e҈\'dD$\"\'8M*Xn;Pbo0{(Eٱ>Cmtf2w\Zkc>(EtX]x㢢Zje(CF\ZtcO\nE4M55=\'ȉG$sDlw;\n=gӟHD k@ k1$qt;8H$P;`pP)t麅;U-#Ӆ7{1Q@T!ƈ\"xp9ǲ&DpG7HeS76Wۛ9qV`q}\Z[$pԅ|\\0X ;㟱@@ik3cꏼ[H˩~X1xȫ,EY06tkPh~*юY&\nuj<s͈y6_Kr74/	zK:ƣ]F1[~0Zc bΥRKaG\nM$YxT\0VM198\"a1Lgܶ `9q\"^Ӊ 6*&>p\nPƋcbSP\rPSW\0i2Se9\"2<&r|XɱU#$ڢ)8HFM>KX^;f,aw\0&G-Ϭyؚ[+i1zY`(|`Ao6@.s\rqdLCs˜d)Wrfn	an3Ǵb6|=$_ly>D\n`,9I.MTaۄXA >:=^-4/[͏\'@\0Һs\0I)@9zxESEA(Th4x``U}L_8q$x\0\'<N\Z	6NR^\"pd\0BEf5Hm$eKw\0u4<XV`#DŊ&{d/~!\n!Q\r\0e S6۠9B\"x]dS>>(DJuezeX(TiB+T5;ǦY	8f\0rXh(C4k\0oVDX$2@J\"d{@.\0GH\ZEaZQBR9 MP%U5E\0䍙haŕ˃Vx\0|OI:.N	nD!@ʓe/P-rI,\Zhq6x#A2MM^(ԟywRHa`H<Wj\"\0-%b[GA-sZvgv<8cY9\0^v)	)(wItn.i*$=1YQ{#\0D;n?S˻;dtCAC\r	vsRyݿiˋ	21/}ۜiN<٤x{$d6J;(uCɕw9.P\\?V=fn]a[\0Azv2d͏\':feS\rw7$e^sӾuT=\0JcW0E\'P0~\0r\rx9zaiA.\'^&:A̡p<߻U>9W/c9\rȑ,-됆\nPHrX4CQiU>\\}aM%.si !3x@Ǎ<>K9oX\"C~,֗JNi`71h\'7!y\0ӬeM\nH]+^V\npƞNbNu: Z@K\r_%褞I*6 ((1YKCƻoBH\rFɩ0h.M\nFמgQC\rʞ.26$^!(׷e(\"%Dyk\0r)\'\0NnYvkHJ=%\n\"=\0\'d!b@$I\'C`Ć#N,5זOLsI\0	jOH뀏CÂ!yQX2d)M\rcP4ON>^WĿwF&.cA$(&F\\TsF)\0=jS;JD4L`ڏy\\ƌV,MxH%ly>@C-ѕZȞ$=b`fj䥍n0}o?͏\'AI$ra\' BABq2C?8g/_	B&X$\0L	L\'m#;%t\nx<\0)o_BY`.`\'./ 0W	\r:x[εu\nJ\nQ2:hY=͘ EѿTs\"#|A\0Z	#*8<d5Tf=ٳ[1υH\'@!	_<&($\rMnmK9 888T,J\0 Xc`@\Zpd֜JSrzbRaTG=P)θ7B\"Ix4dtPK	p#\01a(X,\0خŬ>0u$A#\\.x}`JN\rZ|uIH<LV&d(%bÿlP]N\"Do{CavPف1Ư5\"ę\"A5%\\L8\nr֒RDj@S\\8\rBD[9+Y!6`wB+\0-;\0P[rdq5,}9b@!=\0&~j|ϯ٭׾ĕC+:}ĘMv!bIly>c(u0a²Gh^lI͏\'H!7$ g/_֧֠\rӷWI2Df\n6?*2l|r!A))RYf5|\0\"	K59ktC3C0=*8D(kb):osR*$=ot@BB :\\V5BaR42 4:Ą#Et&Ұ)PVXo\"f\nؔM%&ς952bCmT`R!sxkST)&\"RlOr!3dY!$:`c%r!Me4c'),(3,3,'%PDF-1.3\n3 0 obj\n<</Type /Page\n/Parent 1 0 R\n/Resources 2 0 R\n/Contents 4 0 R>>\nendobj\n4 0 obj\n<</Filter /FlateDecode /Length 19>>\nstream\nx3R235W(\0\nendstream\nendobj\n1 0 obj\n<</Type /Pages\n/Kids [3 0 R ]\n/Count 1\n/MediaBox [0 0 612.00 792.00]\n>>\nendobj\n2 0 obj\n<<\n/ProcSet [/PDF /Text /ImageB /ImageC /ImageI]\n/Font <<\n>>\n/XObject <<\n>>\n>>\nendobj\n5 0 obj\n<<\n/Producer (FPDF 1.6)\n/CreationDate (D:20120711083435)\n>>\nendobj\n6 0 obj\n<<\n/Type /Catalog\n/Pages 1 0 R\n/OpenAction [3 0 R /FitH null]\n/PageLayout /OneColumn\n>>\nendobj\nxref\n0 7\n0000000000 65535 f \n0000000175 00000 n \n0000000262 00000 n \n0000000009 00000 n \n0000000087 00000 n \n0000000356 00000 n \n0000000431 00000 n \ntrailer\n<<\n/Size 7\n/Root 6 0 R\n/Info 5 0 R\n>>\nstartxref\n534\n%%EOF\n');
/*!40000 ALTER TABLE `filedata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `filedefinition`
--

DROP TABLE IF EXISTS `filedefinition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filedefinition` (
  `id` int(11) NOT NULL auto_increment,
  `table_name` varchar(100) default NULL,
  `file_function` int(11) NOT NULL default '0',
  `notes` text,
  `prompt` varchar(255) default NULL,
  `upload_limit` int(11) NOT NULL default '0',
  `modaccess` varchar(150) NOT NULL default '',
  `modbit` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `table_name` (`table_name`)
) ENGINE=InnoDB AUTO_INCREMENT=58 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filedefinition`
--

LOCK TABLES `filedefinition` WRITE;
/*!40000 ALTER TABLE `filedefinition` DISABLE KEYS */;
INSERT INTO `filedefinition` VALUES (1,'sales_categories',0,'Graphic to print on invoice when this sales category is assigned to the job','STR_GRAPHIC_FOR_INVOICE',1,'ar,public','011'),(2,'itemoptiongroup',0,'Graphic for a group of item options.','STR_GRAPHIC_FOR_OPTION_GROUP',1,'inv,public','011'),(3,'itemoption',0,'Graphic for a specific item option.','STR_GRAPHIC_FOR_OPTION',1,'inv,public','011'),(4,'genuser',0,'Checks this user has printed.','STR_CHECK',0,'ap,ar,gl,inv,sc,pr,est,pricelist,pm','011'),(5,'customer',0,'Files associated with a particular customer.','STR_FILES_FOR_CUSTOMER',0,'ar,pm','011'),(6,'vendor',0,'files for Vendors','STR_VENDOR_FILES',0,'ap,inv','011'),(7,'arorder',0,'files relating to orders','STR_ORDER_FILES',0,'ar,inv','011'),(8,'arinvoice',0,'files for Invoices','STR_INVOICE_FILES',0,'ar,pm','011'),(9,'apbills',0,'files for Vendor Bills','STR_VENDOR_BILL_FILES',0,'ap','011'),(10,'invpo',0,'Files for Purchase Orders','STR_PURCHASE_ORDER_FILES',0,'ap,inv','011'),(11,'item',0,'Files for Inventory Items','STR_INVENTORY_ITEM_FILES',0,'inv','011'),(12,'itemvendor',0,'Files for Inventory Item Suppliers','STR_INVENTORY_ITEM_SUPPLIER_FILES',0,'inv','011'),(13,'premployee',0,'Files for Employees','STR_EMPLOYEE_FILES',0,'pr','011'),(14,'salesman',0,'Files for Sales Persons','STR_SALES_PERSON_FILES',0,'ar','011'),(15,'gencompany',0,'B2B Login Graphic','STR_B2B_LOGIN_GRAPHIC',1,'public,admin','011'),(16,'gencompany',0,'B2B Company Header Graphic','STR_B2B_COMPANY_HEADER_GRAPHIC',1,'public,admin','11'),(17,'gencompany',0,'B2B Print Logo','STR_B2B_COMPANY_PRINT_LOGO',1,'public,admin','11'),(18,'b2buser',0,'B2B printouts','STR_B2B_PRINTOUTS',0,'public','111'),(19,'igroup',0,'Graphic attached to the customer group.','STR_GRAPHIC_FOR_CUSTOMER_GROUP',1,'ar,public','011'),(20,'gencompany',0,'Background PDF file to use for invoices.','STR_BACKGROUND_PDF_FILE_FOR_EMAILED_INVOICES',1,'ar,public','011'),(21,'estquotequote',0,'Artwork for Print Orders for Pricelist Nolaprint','STR_CURRENT_ARTWORK_ON_FILE_AND_UPLOADED_POS',0,'public,admin','111'),(22,'estquotequote',0,'Internal Job Documents (Filled-in Job Tickets, Customer PO)','STR_INTERNAL_JOB_DOCUMENTS',0,'public,admin','011'),(23,'gencompany',0,'Custom logo for login page','STR_CUSTOM_LOGO_FOR_LOGIN_PAGE',1,'public,admin','011'),(24,'gencompany',0,'Custom logo for footer','STR_CUSTOM_LOGO_FOR_FOOTER',1,'public, admin','011'),(25,'message_graphic',0,'Message Graphic','STR_MESSAGE_GRAPHIC',1,'public','111'),(26,'gencompany',0,'Background PDF file to use for invoices after page one.','STR_BACKGROUND_PDF_FILE_FOR_EMAILED_INVOICES_AFTER_PAGE_ONE',1,'ar,public','011'),(27,'survey',0,'Header for Survey page','STR_SURVEY_HEADER_GRAPHIC',1,'public, admin','011'),(28,'building',0,'Lease Docs for Buildings','STR_LEASE_PDF_FILES',0,'public,admin','111'),(29,'project',0,'Project Details','STR_PROJECT_DOCUMENTS',0,'ap,pm','111'),(30,'building',0,'Property Documents','STR_PROPERTY_DOCUMENTS',0,'ar,pm','111'),(31,'unit',0,'Unit Documents','STR_UNIT_DOCUMENTS',0,'ar,pm','111'),(32,'lease',0,'Uploaded Lease Documents','STR_LEASE_DOCUMENTS',0,'ar,pm','011'),(33,'job',0,'Job Douments','STR_JOB_DOCUMENTS',0,'ap,pm','111'),(34,'loans',0,'Loan Douments','STR_LOAN_DOCUMENTS',0,'ap,pm','111'),(35,'courtfiling',0,'Court Filing Documents','STR_COURT_FILING_DOCUMENTS',0,'ar,pm','111'),(36,'building',0,'General Tenant Info Documents','STR_GENERAL_TENANT_INFO_DOCUMENTS',0,'public, admin','111'),(37,'bankrec',0,'Bank Reconciliation Documents','STR_BANK_RECONCILIATION_DOCUMENTS',0,'gl','011'),(38,'prreimburse',0,'Reimbursement Attachments','STR_REIMBURSEMENT_RECEIPTS',0,'public,admin','111'),(39,'estquotequotebindquest',0,'File to Upload for Number Selection','STR_NUMBER_LISTS',1,'ar,pricelist,est','011'),(40,'ccpurchase',0,'Files for CC purchases','STR_CREDIT_CARD_PURCHASE_DOCUMENTS',0,'ap','011'),(41,'gltransvoucher',0,'Journal Entry Documents','STR_JOURNAL_ENTRY_DOCUMENTS',0,'gl','111'),(42,'arinvoicepaymentdetail',0,'Customer Payment Attachments','STR_CUSTOMER_PAYMENT_ATTACHMENTS',0,'ar','011'),(43,'survey',0,'Survey Email Attachment','STR_SURVEY_EMAIL_ATTACHMENT',1,'public,admin','011'),(44,'checkacct',0,'Checking Account Files','STR_CHECKING_ACCOUNT_FILES',0,'ap','011'),(45,'vendor',0,'Uploaded Statements For Vendors','STR_VENDOR_STATEMENTS',0,'ap','011'),(46,'emailtemplate',0,'Email Template Attachments','STR_EMAIL_TEMPLATE_ATTACHMENTS',0,'ap,ar,pm','011'),(47,'gencompany',0,'Quote Attachments For PDF','STR_QUOTE_ATTACHMENTS',0,'ar','011'),(48,'gencompany',0,'Order Attachments For PDF','STR_ORDER_ATTACHMENTS',0,'ar','011'),(49,'gencompany',0,'Invoice Attachments For PDF','STR_INVOICE_ATTACHMENTS',0,'ar','011'),(50,'bankdeposit',0,'Bank Deposit Documents','STR_BANK_DEPOSIT_DOCUMENTS',0,'ap,gl','011'),(51,'customer',0,'Customer Profile Picture (Before)','STR_CUSTOMER_BEFORE_PICTURE',1,'ar','011'),(52,'customer',0,'Customer Profile Picture (After)','STR_CUSTOMER_AFTER_PICTURE',1,'ar','011'),(53,'arordership',0,'Order Shipment Documents','STR_SHIPMENT_DOCUMENTS',0,'ar','011'),(54,'waiver',0,'Files for Waivers','STR_WAIVER_FILES',0,'ar','011'),(55,'workorder',0,'Tenant Work Order Attachments','STR_TENANT_WORK_ORDER_ATTACHMENTS',5,'ar','011'),(56,'workorder',0,'Internal Work Order Attachments','STR_INTERNAL_WORK_ORDER_ATTACHMENTS',0,'ar','011'),(57,'invreceivemain',0,'PO Receipt Documents','STR_PO_RECEIPT_DOCUMENTS',0,'ap','011');
/*!40000 ALTER TABLE `filedefinition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fileitem`
--

DROP TABLE IF EXISTS `fileitem`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fileitem` (
  `id` int(11) NOT NULL auto_increment,
  `filedefinitionid` int(11) NOT NULL default '0',
  `tablerecordid` int(11) NOT NULL default '0',
  `filename` varchar(255) default NULL,
  `display_type` int(11) NOT NULL default '0',
  `datatype` varchar(60) NOT NULL default 'application/octet-stream',
  `size` bigint(20) unsigned NOT NULL default '1024',
  `filedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `companyid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `b2buserid` int(11) NOT NULL default '0',
  `notes` text NOT NULL,
  `filecategoryid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `filedefinitionid` (`filedefinitionid`),
  KEY `tablerecordid` (`tablerecordid`),
  KEY `b2buserid` (`b2buserid`),
  KEY `entryuserid` (`entryuserid`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fileitem`
--

LOCK TABLES `fileitem` WRITE;
/*!40000 ALTER TABLE `fileitem` DISABLE KEYS */;
INSERT INTO `fileitem` VALUES (1,15,1,'partnerlogin.jpg',0,'image/pjpeg',35315,'2006-01-24 14:04:36',1,1,0,'Business to Business portal main login banner',0),(3,4,1,'statement_usr1.pdf',0,'application/pdf',749,'2012-07-11 08:34:38',1,1,0,'Attached is your Statement ',0);
/*!40000 ALTER TABLE `fileitem` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fileitemattachment`
--

DROP TABLE IF EXISTS `fileitemattachment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fileitemattachment` (
  `id` int(11) NOT NULL auto_increment,
  `filedefinitionid` int(11) NOT NULL default '0',
  `tablerecordid` int(11) NOT NULL default '0',
  `fileitemid` int(11) NOT NULL default '0',
  `sortorder` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `filedefinitionid` (`filedefinitionid`),
  KEY `tablerecordid` (`tablerecordid`),
  KEY `fileitemid` (`fileitemid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fileitemattachment`
--

LOCK TABLES `fileitemattachment` WRITE;
/*!40000 ALTER TABLE `fileitemattachment` DISABLE KEYS */;
/*!40000 ALTER TABLE `fileitemattachment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fileitemattachmentdefault`
--

DROP TABLE IF EXISTS `fileitemattachmentdefault`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fileitemattachmentdefault` (
  `id` int(11) NOT NULL auto_increment,
  `filedefinitionid` int(11) NOT NULL default '0',
  `tablerecordid` int(11) NOT NULL default '0',
  `fileitemid` int(11) NOT NULL default '0',
  `sortorder` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `filedefinitionid` (`filedefinitionid`),
  KEY `fileitemid` (`fileitemid`),
  KEY `tablerecordid` (`tablerecordid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fileitemattachmentdefault`
--

LOCK TABLES `fileitemattachmentdefault` WRITE;
/*!40000 ALTER TABLE `fileitemattachmentdefault` DISABLE KEYS */;
/*!40000 ALTER TABLE `fileitemattachmentdefault` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flexfield`
--

DROP TABLE IF EXISTS `flexfield`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flexfield` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `tablename` varchar(100) NOT NULL,
  `displayname` text NOT NULL,
  `fieldtype` enum('T','S','C','D','H','R','A','I') NOT NULL default 'T',
  `sortorder` int(10) unsigned NOT NULL default '0',
  `internalname` varchar(100) NOT NULL,
  `defaultvalue` varchar(255) NOT NULL,
  `companyid` int(11) NOT NULL default '0',
  `readonly` int(5) NOT NULL default '0',
  `donotimport` int(5) NOT NULL default '0',
  `rowabove` int(11) NOT NULL default '0',
  `cellwidth` int(11) NOT NULL default '0',
  `titlelocation` varchar(10) NOT NULL default '',
  `tbsize` int(11) NOT NULL default '0',
  `linkfield` varchar(50) NOT NULL default '',
  `required` int(11) NOT NULL default '0',
  `pagelink` varchar(200) NOT NULL default '',
  `pagelinktitle` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `tablename` (`tablename`),
  KEY `internalname` (`internalname`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flexfield`
--

LOCK TABLES `flexfield` WRITE;
/*!40000 ALTER TABLE `flexfield` DISABLE KEYS */;
/*!40000 ALTER TABLE `flexfield` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flexoption`
--

DROP TABLE IF EXISTS `flexoption`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flexoption` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `flexfieldid` int(10) unsigned NOT NULL default '0',
  `name` text,
  `value` varchar(255) NOT NULL,
  `sortorder` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `flexfieldid` (`flexfieldid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flexoption`
--

LOCK TABLES `flexoption` WRITE;
/*!40000 ALTER TABLE `flexoption` DISABLE KEYS */;
/*!40000 ALTER TABLE `flexoption` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flextable`
--

DROP TABLE IF EXISTS `flextable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flextable` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  `tablename` varchar(100) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=31 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flextable`
--

LOCK TABLES `flextable` WRITE;
/*!40000 ALTER TABLE `flextable` DISABLE KEYS */;
INSERT INTO `flextable` VALUES (1,'Customer','customer'),(2,'Item','item'),(3,'Order','arorder'),(4,'Invoice','arinvoice'),(5,'Vendor','vendor'),(6,'AP Bill','apbill'),(7,'Employee','premployee'),(8,'Shipment','arordership'),(9,'Ship-To','shipto'),(10,'Print-Pricelist-Order','estquotequote'),(11,'Inventory Locations','inventorylocation'),(12,'GL Account','glaccount'),(13,'Company','gencompany'),(14,'User','genuser'),(15,'Service Order Work Details','soworkdetails'),(16,'Service Order Extra Fields','soextra'),(17,'PO Checklist','checklistpo'),(18,'SB Checklist','checklistsb'),(19,'Year-End Checklist','checklistye'),(20,'Quarter-End Checklist','checklistqe'),(21,'Month-End Checklist','checklistme'),(22,'Building','building'),(23,'Unit','unit'),(24,'Move In Checklist','checklistmi'),(25,'Move Out Checklist','checklistmo'),(26,'Communications','communications'),(27,'Item Category','itemcategory'),(28,'Sales Tax','salestax'),(29,'Accounts Receivable Payment Detail','arinvoicepaymentdetail'),(30,'Job','job');
/*!40000 ALTER TABLE `flextable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flexvalue`
--

DROP TABLE IF EXISTS `flexvalue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flexvalue` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `flexfieldid` int(10) unsigned NOT NULL default '0',
  `recordid` int(10) unsigned NOT NULL default '0',
  `value` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `flexfieldid` (`flexfieldid`),
  KEY `recordid` (`recordid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flexvalue`
--

LOCK TABLES `flexvalue` WRITE;
/*!40000 ALTER TABLE `flexvalue` DISABLE KEYS */;
/*!40000 ALTER TABLE `flexvalue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `four51trans`
--

DROP TABLE IF EXISTS `four51trans`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `four51trans` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `xmlrequest` text NOT NULL,
  `xmlresponse` text NOT NULL,
  `entrydate` datetime NOT NULL,
  `status` int(11) NOT NULL default '500',
  `orderid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `transtype` enum('O','S') NOT NULL default 'O',
  `responsetext` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `orderid` (`orderid`),
  KEY `customerid` (`customerid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `four51trans`
--

LOCK TABLES `four51trans` WRITE;
/*!40000 ALTER TABLE `four51trans` DISABLE KEYS */;
/*!40000 ALTER TABLE `four51trans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `freightburden`
--

DROP TABLE IF EXISTS `freightburden`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `freightburden` (
  `id` int(11) NOT NULL auto_increment,
  `inventorylocationid1` int(11) NOT NULL default '0',
  `inventorylocationid2` int(11) NOT NULL default '0',
  `percent` decimal(19,4) NOT NULL default '0.0000',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastupdatedate` datetime NOT NULL,
  `lastupdateuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `inventorylocationid1` (`inventorylocationid1`,`cancel`),
  KEY `inventorylocationid2` (`inventorylocationid2`,`cancel`),
  KEY `active` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `freightburden`
--

LOCK TABLES `freightburden` WRITE;
/*!40000 ALTER TABLE `freightburden` DISABLE KEYS */;
/*!40000 ALTER TABLE `freightburden` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gencompany`
--

DROP TABLE IF EXISTS `gencompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gencompany` (
  `id` int(11) NOT NULL auto_increment,
  `address1` varchar(100) default NULL,
  `address2` varchar(100) default NULL,
  `city` varchar(50) default NULL,
  `state` varchar(20) default NULL,
  `zip` varchar(15) default NULL,
  `country` varchar(20) default NULL,
  `phone1` varchar(20) default NULL,
  `phone2` varchar(20) default NULL,
  `phone3` varchar(20) default NULL,
  `phone4` varchar(20) default NULL,
  `email` varchar(50) default NULL,
  `ar_email` varchar(50) NOT NULL default '',
  `order_email` varchar(50) NOT NULL default '',
  `ap_email` varchar(50) NOT NULL default '',
  `web` varchar(100) default NULL,
  `name` varchar(50) default NULL,
  `dba` varchar(50) NOT NULL default '',
  `active` int(11) default '1',
  `menucolor` int(11) NOT NULL default '0',
  `graphicurl` varchar(200) default '',
  `graphicurl_big` varchar(200) default '',
  `lastupdateuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `vat_tax` int(5) default '0',
  `businesstype` varchar(100) NOT NULL default '',
  `print_only_orders` int(5) NOT NULL default '0',
  `arship_shortform` int(5) NOT NULL default '0',
  `timezoneid` int(11) NOT NULL default '0',
  `currency` varchar(10) NOT NULL default 'USD',
  `isconstruction` int(5) NOT NULL default '0',
  `companycode` varchar(50) NOT NULL default '',
  `clientllc` int(5) NOT NULL default '0',
  `defaultbarcodelabelid` int(11) NOT NULL default '0',
  `defaultorderbarcodelabelid` int(11) NOT NULL default '0',
  `ui_style` mediumtext,
  `pdf_font` varchar(45) NOT NULL default '',
  `faxsettings` mediumtext,
  `importnotices` mediumtext,
  `autopostglimports` tinyint(1) NOT NULL default '0',
  `glgroupdebitcreditcolumn` tinyint(1) NOT NULL default '1',
  `gledithidecostcodes` tinyint(1) NOT NULL default '0',
  `showautocompleteidboxes` int(11) NOT NULL default '0',
  `showsetupmenu` int(11) NOT NULL default '1',
  `setupfirstrun` int(11) NOT NULL default '1',
  `weather_zip` varchar(20) NOT NULL default '',
  `weather_cf` char(1) NOT NULL default 'F',
  `hideweather` int(5) NOT NULL default '0',
  `css_style_index` tinyint(4) NOT NULL default '-1',
  `glrequirecostcode` tinyint(4) NOT NULL default '0',
  `glrequireglcategory` tinyint(4) NOT NULL default '0',
  `alloweditingnotedates` tinyint(4) NOT NULL default '0',
  `usegljourupdhv` tinyint(4) NOT NULL default '0',
  `qrfontsize` decimal(8,3) NOT NULL default '9.000',
  `qrprintoneperline` tinyint(1) NOT NULL default '0',
  `qrprintpaperwidth` decimal(8,3) NOT NULL default '612.000',
  `qrprintpaperheight` decimal(8,3) NOT NULL default '792.000',
  `qrprintmargintop` decimal(8,3) NOT NULL default '72.000',
  `qrprintmarginbottom` decimal(8,3) NOT NULL default '72.000',
  `qrprintmarginleft` decimal(8,3) NOT NULL default '72.000',
  `qrprintmarginright` decimal(8,3) NOT NULL default '72.000',
  `qrprintpaddingtop` decimal(8,3) NOT NULL default '0.000',
  `qrprintpaddingbottom` decimal(8,3) NOT NULL default '0.000',
  `qrprintpaddingleft` decimal(8,3) NOT NULL default '0.000',
  `qrprintpaddingright` decimal(8,3) NOT NULL default '0.000',
  `blockeditingcodes` tinyint(4) NOT NULL default '0',
  `timereportcostaccess` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gencompany`
--

LOCK TABLES `gencompany` WRITE;
/*!40000 ALTER TABLE `gencompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `gencompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gencounty`
--

DROP TABLE IF EXISTS `gencounty`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gencounty` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(45) NOT NULL default '',
  `state` varchar(5) NOT NULL default '',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` varchar(45) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastchangeuserid` varchar(45) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='User-defined county list by state.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gencounty`
--

LOCK TABLES `gencounty` WRITE;
/*!40000 ALTER TABLE `gencounty` DISABLE KEYS */;
/*!40000 ALTER TABLE `gencounty` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `genmessage`
--

DROP TABLE IF EXISTS `genmessage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `genmessage` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `sourceuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `readdate` datetime NOT NULL default '0001-01-01 00:00:00',
  `message` blob NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `userid` (`userid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `genmessage`
--

LOCK TABLES `genmessage` WRITE;
/*!40000 ALTER TABLE `genmessage` DISABLE KEYS */;
/*!40000 ALTER TABLE `genmessage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `genprint`
--

DROP TABLE IF EXISTS `genprint`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `genprint` (
  `id` int(11) NOT NULL default '0',
  `special_order_markup` decimal(6,3) NOT NULL default '0.000',
  `outside_vended_markup` decimal(6,3) NOT NULL default '0.000',
  `qty_unitid` int(11) NOT NULL default '0',
  `price_unitid` int(11) NOT NULL default '0',
  `conversion` int(11) NOT NULL default '1',
  `overdays` int(5) NOT NULL default '30',
  `first_timeframe` int(11) NOT NULL default '24',
  `second_timeframe` int(11) NOT NULL default '80',
  `glrush` int(11) NOT NULL default '0',
  `glcomposition` int(11) NOT NULL default '0',
  `extrafield1_desc` varchar(255) default NULL,
  `extrafield2_desc` varchar(255) default NULL,
  `extrafield3_desc` varchar(255) default NULL,
  `extrafield4_desc` varchar(255) default NULL,
  `jobticket_notes` text,
  `askink` int(5) NOT NULL default '1',
  `whichinvoicedate` int(5) NOT NULL default '0',
  `inventory_markup` decimal(9,3) NOT NULL default '0.000',
  `showdollars_onpendinglist` int(5) NOT NULL default '0',
  `fromWho` int(5) NOT NULL default '0',
  `boxlabel` int(5) NOT NULL default '0',
  `displayweightmax` int(11) NOT NULL default '0',
  `displayweightmsg` text,
  `jobtick1` varchar(100) NOT NULL default '',
  `jobtick2` varchar(100) NOT NULL default '',
  `jobtick3` varchar(100) NOT NULL default '',
  `jobtick4` varchar(100) NOT NULL default '',
  `envitemid` int(11) NOT NULL default '0',
  `envfactor` decimal(19,4) NOT NULL default '0.0000',
  `covitemid` int(11) NOT NULL default '0',
  `covfactor` decimal(19,4) NOT NULL default '0.0000',
  `extra1_confirm` varchar(100) default NULL,
  `extra2_confirm` varchar(100) default NULL,
  `extra3_confirm` varchar(100) default NULL,
  `extra4_confirm` varchar(100) default NULL,
  `extra5_confirm` varchar(100) default NULL,
  `quoteDateChg` int(5) NOT NULL default '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `genprint`
--

LOCK TABLES `genprint` WRITE;
/*!40000 ALTER TABLE `genprint` DISABLE KEYS */;
/*!40000 ALTER TABLE `genprint` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `genstate`
--

DROP TABLE IF EXISTS `genstate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `genstate` (
  `id` int(11) NOT NULL auto_increment,
  `stateinit` char(3) NOT NULL default '',
  `statename` char(30) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `stateinit` (`stateinit`),
  KEY `stateinit_2` (`stateinit`)
) ENGINE=MyISAM AUTO_INCREMENT=66 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `genstate`
--

LOCK TABLES `genstate` WRITE;
/*!40000 ALTER TABLE `genstate` DISABLE KEYS */;
INSERT INTO `genstate` VALUES (1,'AL','Alabama'),(2,'AK','Alaska'),(3,'AZ','Arizona'),(4,'AR','Arkansas'),(5,'CA','California'),(6,'CO','Colorado'),(7,'CT','Connecticut'),(8,'DE','Delaware'),(9,'FL','Florida'),(10,'GA','Georgia'),(11,'HI','Hawaii'),(12,'ID','Idaho'),(13,'IL','Illinois'),(14,'IN','Indiana'),(15,'IA','Iowa'),(16,'KS','Kansas'),(17,'ME','Maine'),(18,'MD','Maryland'),(19,'MA','Massachusetts'),(20,'MI','Michigan'),(21,'MN','Minnesota'),(22,'MS','Mississippi'),(23,'MO','Missouri'),(24,'MT','Montana'),(25,'NE','Nebraska'),(26,'NV','Nevada'),(27,'NH','New Hampshire'),(28,'NJ','New Jersey'),(29,'NM','New Mexico'),(30,'NY','New York'),(31,'NC','North Carolina'),(32,'ND','North Dakota'),(33,'OH','Ohio'),(34,'OK','Oklahoma'),(35,'OR','Oregon'),(36,'PA','Pennsylvania'),(37,'RI','Rhode Island'),(38,'SC','South Carolina'),(39,'SD','South Dakota'),(40,'TN','Tennessee'),(41,'TX','Texas'),(42,'UT','Utah'),(43,'VT','Vermont'),(44,'VA','Virginia'),(45,'WA','Washington'),(46,'DC','Washington, DC'),(47,'WV','West Virginia'),(48,'WI','Wisconsin'),(49,'WY','Wyoming'),(50,'KY','Kentucky'),(51,'LA','Louisiana'),(52,'PR','Puerto Rico'),(53,'NF','Newfoundland'),(54,'NS','Nova Scotia'),(55,'ON','Ontario'),(56,'PE','Prince Edward Island'),(57,'PQ','Quebec'),(58,'SK','Saskatchewan'),(59,'NT','Northwest Territories'),(60,'YT','Yukon Terrirory'),(61,'BC','British Columbia'),(62,'NB','New Brunswick'),(63,'MB','Manitoba'),(64,'AB','Alberta'),(65,'NU','Nunavut');
/*!40000 ALTER TABLE `genstate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `genstylesheet`
--

DROP TABLE IF EXISTS `genstylesheet`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `genstylesheet` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(50) NOT NULL default '',
  `filename` char(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `filename` (`filename`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `genstylesheet`
--

LOCK TABLES `genstylesheet` WRITE;
/*!40000 ALTER TABLE `genstylesheet` DISABLE KEYS */;
INSERT INTO `genstylesheet` VALUES (1,'Blue Heaven','blueheaven'),(2,'Blue and White','bluish'),(3,'Earth Tones','earthtones'),(4,'Black and White','bw'),(5,'Cool Gray','coolgray'),(6,'Unix Terminal','unixterm'),(7,'Hot Tomato','tomato');
/*!40000 ALTER TABLE `genstylesheet` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `genuser`
--

DROP TABLE IF EXISTS `genuser`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `genuser` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `password` varchar(128) default NULL,
  `raccessap` int(11) NOT NULL default '0',
  `raccessar` int(11) NOT NULL default '0',
  `raccessgl` int(11) NOT NULL default '0',
  `raccesspay` int(11) NOT NULL default '0',
  `raccessinv` int(11) NOT NULL default '0',
  `raccessest` int(11) NOT NULL default '0',
  `raccessfix` int(11) NOT NULL default '0',
  `raccessimp` int(11) NOT NULL default '0',
  `waccessap` int(11) NOT NULL default '0',
  `waccessar` int(11) NOT NULL default '0',
  `waccessgl` int(11) NOT NULL default '0',
  `waccesspay` int(11) NOT NULL default '0',
  `waccessinv` int(11) NOT NULL default '0',
  `waccessest` int(11) NOT NULL default '0',
  `waccessfix` int(11) NOT NULL default '0',
  `waccessimp` int(11) NOT NULL default '0',
  `saccessap` int(11) NOT NULL default '0',
  `saccessar` int(11) NOT NULL default '0',
  `saccessgl` int(11) NOT NULL default '0',
  `saccesspay` int(11) NOT NULL default '0',
  `saccessinv` int(11) NOT NULL default '0',
  `saccessest` int(11) NOT NULL default '0',
  `saccessfix` int(11) NOT NULL default '0',
  `saccessimp` int(11) NOT NULL default '0',
  `supervisor` int(11) NOT NULL default '0',
  `active` int(11) NOT NULL default '0',
  `stylesheetid` int(11) NOT NULL default '1',
  `deflanguage` int(11) NOT NULL default '1',
  `email` varchar(100) NOT NULL default '',
  `logon_attempts` tinyint(4) NOT NULL default '0',
  `firstname` varchar(35) default NULL,
  `lastname` varchar(35) default NULL,
  `cancel` int(11) default '0',
  `admin` int(2) NOT NULL default '0',
  `raccesssc` int(11) NOT NULL default '0',
  `waccesssc` int(11) NOT NULL default '0',
  `saccesssc` int(11) NOT NULL default '0',
  `pmaccess` int(11) NOT NULL default '0',
  `pmadmin` int(11) NOT NULL default '0',
  `employeeid` int(11) NOT NULL default '0',
  `weather_zip` varchar(20) default NULL,
  `cpa` int(11) NOT NULL default '0',
  `weather_cf` char(1) default 'F',
  `menu_style` int(5) NOT NULL default '0',
  `iconset` varchar(10) NOT NULL default 'deflt',
  `apikey` varchar(50) default NULL,
  `timeclock_only` int(5) NOT NULL default '0',
  `ipfilter` varchar(255) NOT NULL default '',
  `splashdate` datetime default NULL,
  `defaulthomepage` varchar(30) NOT NULL default '',
  `timeclock_blockviewlogins` int(5) NOT NULL default '0',
  `phone` varchar(25) NOT NULL default '',
  `emailsignature` text,
  `sysadmin` int(11) NOT NULL default '0',
  `css_style_index` tinyint(4) NOT NULL default '-1',
  `autocompletedelay` int(11) NOT NULL default '400',
  `blockinvcotransfer` int(11) NOT NULL default '0',
  `blockapbilledit` tinyint(4) NOT NULL default '0',
  `ui_style` mediumtext,
  `np5_legacy_mode` tinyint(1) NOT NULL default '0',
  `slow_cpu` tinyint(1) NOT NULL default '0',
  `mobile_pos` tinyint(4) default '0',
  `mobile_pos_companyid` int(11) default '1',
  `mobile_pos_locationid` int(11) default '-1',
  `blockinvcsvcostedit` tinyint(4) NOT NULL default '0',
  `user_settings` mediumtext,
  `default_gencompanyid` int(11) NOT NULL default '0',
  `canchangejobitemuser` tinyint(4) NOT NULL default '0',
  `blockjoblaborrates` tinyint(4) NOT NULL default '0',
  `allowemaillogin` tinyint(4) NOT NULL default '0',
  `datatablesnoautoload` tinyint(1) NOT NULL default '0',
  `sendoverpaymentnotices` tinyint(1) NOT NULL default '0',
  `bankdeposituserentriesonly` tinyint(1) NOT NULL default '0',
  `passwordsetdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `datatablesuserfilter` tinyint(1) NOT NULL default '0',
  `isbuyer` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `name_2` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `genuser`
--

LOCK TABLES `genuser` WRITE;
/*!40000 ALTER TABLE `genuser` DISABLE KEYS */;
INSERT INTO `genuser` VALUES (1,'admin','pass',1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,'',1,'Admin','',0,1,0,1,1,0,0,0,NULL,1,'F',1,'3d',NULL,0,'','2017-07-26 13:59:05','',0,'','',0,-1,400,0,0,NULL,0,0,0,1,-1,0,NULL,0,0,0,1,0,0,0,'0000-00-00 00:00:00',0,0);
/*!40000 ALTER TABLE `genuser` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `genusercheckacct`
--

DROP TABLE IF EXISTS `genusercheckacct`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `genusercheckacct` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `checkacctid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `userid` (`userid`),
  KEY `checkacctid` (`checkacctid`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `genusercheckacct`
--

LOCK TABLES `genusercheckacct` WRITE;
/*!40000 ALTER TABLE `genusercheckacct` DISABLE KEYS */;
/*!40000 ALTER TABLE `genusercheckacct` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `genusercompany`
--

DROP TABLE IF EXISTS `genusercompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `genusercompany` (
  `genuser_id` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `lasthome` varchar(20) NOT NULL default '',
  `raccessap` int(2) NOT NULL default '0',
  `raccessar` int(2) NOT NULL default '0',
  `raccessgl` int(2) NOT NULL default '0',
  `raccesspay` int(2) NOT NULL default '0',
  `raccessinv` int(2) NOT NULL default '0',
  `raccessest` int(2) NOT NULL default '0',
  `raccessfix` int(2) NOT NULL default '0',
  `raccessimp` int(2) NOT NULL default '0',
  `raccesssc` int(2) NOT NULL default '0',
  `waccessap` int(2) NOT NULL default '0',
  `waccessar` int(2) NOT NULL default '0',
  `waccessgl` int(2) NOT NULL default '0',
  `waccesspay` int(2) NOT NULL default '0',
  `waccessinv` int(2) NOT NULL default '0',
  `waccessest` int(2) NOT NULL default '0',
  `waccessfix` int(2) NOT NULL default '0',
  `waccessimp` int(2) NOT NULL default '0',
  `waccesssc` int(2) NOT NULL default '0',
  `saccessap` int(2) NOT NULL default '0',
  `saccessar` int(2) NOT NULL default '0',
  `saccessgl` int(2) NOT NULL default '0',
  `saccesspay` int(2) NOT NULL default '0',
  `saccessinv` int(2) NOT NULL default '0',
  `saccessest` int(2) NOT NULL default '0',
  `saccessfix` int(2) NOT NULL default '0',
  `saccessimp` int(2) NOT NULL default '0',
  `saccesssc` int(2) NOT NULL default '0',
  `supervisor` int(2) NOT NULL default '0',
  `edit_messages` int(5) NOT NULL default '0',
  `pos_only` int(11) NOT NULL default '0',
  `salesmanid` int(11) NOT NULL default '0',
  `blockarreports` int(11) NOT NULL default '0',
  `nprightsgroupid` int(11) NOT NULL default '0',
  `postaxgroupid` int(11) NOT NULL default '0',
  `invlocations` varchar(255) NOT NULL default '',
  `blockordersave` int(5) NOT NULL default '0',
  `blockpospricing` int(11) NOT NULL default '0',
  `onlycustomeredittab` int(11) NOT NULL default '0',
  `blockifnostock` int(11) NOT NULL default '0',
  `blockbackdating` int(11) NOT NULL default '0',
  `blockcustomercreditedit` int(11) NOT NULL default '0',
  `blockminpm` int(11) NOT NULL default '0',
  `blockposdescription` tinyint(4) NOT NULL default '0',
  `blockposcost` tinyint(4) NOT NULL default '0',
  `blockcostonreports` tinyint(4) NOT NULL default '0',
  `blockcost` tinyint(4) NOT NULL default '0',
  `blockaddllineitemoptions` tinyint(1) NOT NULL default '0',
  `blockcustomeredit` tinyint(1) NOT NULL default '0',
  `usecompanywriteoffvalues` tinyint(1) NOT NULL default '1',
  `writeoffmax` decimal(19,4) NOT NULL default '0.0000',
  `writeoffmaxperc` decimal(19,4) NOT NULL default '0.0000',
  `hideorderprofitexpectnonstock` tinyint(1) NOT NULL default '0',
  `paymeths` varchar(20) NOT NULL default '',
  `onlyproposals` tinyint(1) NOT NULL default '0',
  `apbill_approver` tinyint(1) NOT NULL default '0',
  `blockinvoiceheaderedit` tinyint(1) NOT NULL default '0',
  `canoverrideprice` tinyint(1) NOT NULL default '0',
  `canviewvendorbankinfo` tinyint(4) NOT NULL default '0',
  `fohidecustomeroverdue` tinyint(1) NOT NULL default '0',
  `fohideglinfo` tinyint(1) NOT NULL default '0',
  `paymentsdailyclosemanagement` tinyint(1) NOT NULL default '0',
  `canviewcustomerbankinfo` tinyint(4) NOT NULL default '0',
  `blockstockitempo` tinyint(4) NOT NULL default '0',
  `blockitembinedit` tinyint(1) NOT NULL default '0',
  `emaildailysalesreport` tinyint(1) NOT NULL default '0',
  `emaildailysalesreportmaxmargin` decimal(19,4) NOT NULL default '100.0000',
  `emailownposonrec` tinyint(1) NOT NULL default '0',
  `blockstockitemcreate` tinyint(4) NOT NULL default '0',
  `blockotherchargespo` tinyint(4) NOT NULL default '0',
  `blockstockedit` tinyint(1) NOT NULL default '0',
  `blocknonstockedit` tinyint(1) NOT NULL default '0',
  `blockotherchargesedit` tinyint(1) NOT NULL default '0',
  `canalwaysunpostinvoices` tinyint(4) NOT NULL default '0',
  `canviewjobprelimablesettings` tinyint(4) NOT NULL default '0',
  `canalwayschangepovendorterms` tinyint(4) NOT NULL default '0',
  `blockissuecredit` tinyint(4) NOT NULL default '0',
  `invstatusdetailpricelevels` tinyint(1) NOT NULL default '0',
  `maxpoamount` decimal(19,4) NOT NULL default '0.0000',
  `allowbuyernotesedit` tinyint(1) NOT NULL default '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `genusercompany`
--

LOCK TABLES `genusercompany` WRITE;
/*!40000 ALTER TABLE `genusercompany` DISABLE KEYS */;
INSERT INTO `genusercompany` VALUES (1,1,'',1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,'',0,0,0,0,0,0,0,0,0,0,0,0,0,1,'0.0000','0.0000',0,'',0,0,0,0,0,0,0,0,0,0,0,0,'100.0000',0,0,0,0,0,0,0,0,0,0,0,'0.0000',0);
/*!40000 ALTER TABLE `genusercompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `genusercompany_temp`
--

DROP TABLE IF EXISTS `genusercompany_temp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `genusercompany_temp` (
  `genuser_id` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `raccessap` int(2) NOT NULL default '0',
  `raccessar` int(2) NOT NULL default '0',
  `raccessgl` int(2) NOT NULL default '0',
  `raccesspay` int(2) NOT NULL default '0',
  `raccessinv` int(2) NOT NULL default '0',
  `raccessest` int(2) NOT NULL default '0',
  `raccessfix` int(2) NOT NULL default '0',
  `raccessimp` int(2) NOT NULL default '0',
  `raccesssc` int(2) NOT NULL default '0',
  `waccessap` int(2) NOT NULL default '0',
  `waccessar` int(2) NOT NULL default '0',
  `waccessgl` int(2) NOT NULL default '0',
  `waccesspay` int(2) NOT NULL default '0',
  `waccessinv` int(2) NOT NULL default '0',
  `waccessest` int(2) NOT NULL default '0',
  `waccessfix` int(2) NOT NULL default '0',
  `waccessimp` int(2) NOT NULL default '0',
  `waccesssc` int(2) NOT NULL default '0',
  `saccessap` int(2) NOT NULL default '0',
  `saccessar` int(2) NOT NULL default '0',
  `saccessgl` int(2) NOT NULL default '0',
  `saccesspay` int(2) NOT NULL default '0',
  `saccessinv` int(2) NOT NULL default '0',
  `saccessest` int(2) NOT NULL default '0',
  `saccessfix` int(2) NOT NULL default '0',
  `saccessimp` int(2) NOT NULL default '0',
  `saccesssc` int(2) NOT NULL default '0',
  `supervisor` int(2) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `genusercompany_temp`
--

LOCK TABLES `genusercompany_temp` WRITE;
/*!40000 ALTER TABLE `genusercompany_temp` DISABLE KEYS */;
INSERT INTO `genusercompany_temp` VALUES (1,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1),(2,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1,1,1,1,1,0,0,0,1,1);
/*!40000 ALTER TABLE `genusercompany_temp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `genuserhome`
--

DROP TABLE IF EXISTS `genuserhome`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `genuserhome` (
  `genuser` int(11) NOT NULL default '0',
  `gencompany` int(11) NOT NULL default '0',
  `home` varchar(20) NOT NULL default '',
  `reports` text,
  `twothirds` varchar(100) NOT NULL default '',
  `half1` varchar(100) NOT NULL default '',
  `half2` varchar(100) NOT NULL default '',
  `whole` varchar(100) NOT NULL default '',
  `lastlogin` datetime NOT NULL default '0000-00-00 00:00:00',
  `whole2` varchar(100) default NULL,
  KEY `key` (`genuser`,`gencompany`,`home`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `genuserhome`
--

LOCK TABLES `genuserhome` WRITE;
/*!40000 ALTER TABLE `genuserhome` DISABLE KEYS */;
INSERT INTO `genuserhome` VALUES (1,0,'orders',NULL,'open_orders_due_dates','recently_shipped_items','recently_shipped_orders','performance_statistics_30','2019-08-14 19:09:37',NULL),(1,0,'orders',NULL,'open_orders_due_dates','recently_shipped_items','recently_shipped_orders','performance_statistics_30','2019-08-14 19:09:37',NULL);
/*!40000 ALTER TABLE `genuserhome` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gl_costcenter`
--

DROP TABLE IF EXISTS `gl_costcenter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gl_costcenter` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(255) default NULL,
  `companyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gl_costcenter`
--

LOCK TABLES `gl_costcenter` WRITE;
/*!40000 ALTER TABLE `gl_costcenter` DISABLE KEYS */;
/*!40000 ALTER TABLE `gl_costcenter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gl_summarylevel`
--

DROP TABLE IF EXISTS `gl_summarylevel`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gl_summarylevel` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(255) default NULL,
  `companyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gl_summarylevel`
--

LOCK TABLES `gl_summarylevel` WRITE;
/*!40000 ALTER TABLE `gl_summarylevel` DISABLE KEYS */;
/*!40000 ALTER TABLE `gl_summarylevel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gl_summarylevel_account`
--

DROP TABLE IF EXISTS `gl_summarylevel_account`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gl_summarylevel_account` (
  `glaccountid` int(11) NOT NULL default '0',
  `gl_summarylevelid` int(11) NOT NULL default '0',
  `destination_glaccountid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`glaccountid`,`gl_summarylevelid`),
  KEY `glaccountid` (`glaccountid`),
  KEY `gl_summarylevelid` (`gl_summarylevelid`),
  KEY `destination_glaccountid` (`destination_glaccountid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gl_summarylevel_account`
--

LOCK TABLES `gl_summarylevel_account` WRITE;
/*!40000 ALTER TABLE `gl_summarylevel_account` DISABLE KEYS */;
/*!40000 ALTER TABLE `gl_summarylevel_account` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glaccount`
--

DROP TABLE IF EXISTS `glaccount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glaccount` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(20) NOT NULL default '',
  `description` varchar(255) default NULL,
  `accounttypeid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `summaryaccountid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `costcenterid` int(11) NOT NULL default '0',
  `old_id` varchar(20) default NULL,
  `accountsubtypeid` varchar(10) NOT NULL default '',
  `block_journal` int(5) NOT NULL default '0',
  `defaultcostcodeid` int(11) NOT NULL default '0',
  `defaultglcategoryid` int(11) NOT NULL default '0',
  `hascostcodes` tinyint(1) NOT NULL default '1',
  `hasglcategories` tinyint(1) NOT NULL default '1',
  `allowedcostcodes` text,
  `allowedglcategories` text,
  PRIMARY KEY  (`id`),
  KEY `name` (`name`),
  KEY `accounttypeid` (`accounttypeid`),
  KEY `companyid` (`companyid`),
  KEY `summaryaccountid` (`summaryaccountid`),
  KEY `costcenterid` (`costcenterid`),
  KEY `block_journal` (`block_journal`),
  KEY `hascostcodes` (`hascostcodes`),
  KEY `hasglcategories` (`hasglcategories`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glaccount`
--

LOCK TABLES `glaccount` WRITE;
/*!40000 ALTER TABLE `glaccount` DISABLE KEYS */;
/*!40000 ALTER TABLE `glaccount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glbudgets`
--

DROP TABLE IF EXISTS `glbudgets`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glbudgets` (
  `id` int(11) NOT NULL auto_increment,
  `glaccountid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `budgetyear` int(11) NOT NULL default '0',
  `jan` decimal(19,4) NOT NULL default '0.0000',
  `feb` decimal(19,4) NOT NULL default '0.0000',
  `mar` decimal(19,4) NOT NULL default '0.0000',
  `apr` decimal(19,4) NOT NULL default '0.0000',
  `may` decimal(19,4) NOT NULL default '0.0000',
  `jun` decimal(19,4) NOT NULL default '0.0000',
  `jul` decimal(19,4) NOT NULL default '0.0000',
  `aug` decimal(19,4) NOT NULL default '0.0000',
  `sep` decimal(19,4) NOT NULL default '0.0000',
  `oct` decimal(19,4) NOT NULL default '0.0000',
  `nov` decimal(19,4) NOT NULL default '0.0000',
  `decm` decimal(19,4) NOT NULL default '0.0000',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `rank` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `budgetname` varchar(100) NOT NULL default '',
  `status` int(11) NOT NULL default '1',
  `sign` int(11) NOT NULL default '-1',
  `parentglbudgetid` int(11) NOT NULL default '0',
  `childglbudgetid` int(11) NOT NULL default '0',
  `mainglbudgetid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `glaccountid` (`glaccountid`),
  KEY `budgetyear` (`budgetyear`),
  KEY `companyid` (`companyid`),
  KEY `budgetname` (`budgetname`),
  KEY `yrc` (`budgetyear`,`rank`,`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glbudgets`
--

LOCK TABLES `glbudgets` WRITE;
/*!40000 ALTER TABLE `glbudgets` DISABLE KEYS */;
/*!40000 ALTER TABLE `glbudgets` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glcategory`
--

DROP TABLE IF EXISTS `glcategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glcategory` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(20) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `glcategorytypeid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glcategory`
--

LOCK TABLES `glcategory` WRITE;
/*!40000 ALTER TABLE `glcategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `glcategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glcategorytype`
--

DROP TABLE IF EXISTS `glcategorytype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glcategorytype` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(255) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glcategorytype`
--

LOCK TABLES `glcategorytype` WRITE;
/*!40000 ALTER TABLE `glcategorytype` DISABLE KEYS */;
/*!40000 ALTER TABLE `glcategorytype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glcloselog`
--

DROP TABLE IF EXISTS `glcloselog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glcloselog` (
  `id` int(11) NOT NULL auto_increment,
  `closedate` date default NULL,
  `closeuserid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `yearend` int(5) NOT NULL default '0',
  `voucherid` int(11) NOT NULL default '0',
  `taj` int(5) NOT NULL default '0',
  `splitbycostcode` tinyint(4) NOT NULL default '0',
  `splitbyglcategory` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `closedate` (`closedate`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glcloselog`
--

LOCK TABLES `glcloselog` WRITE;
/*!40000 ALTER TABLE `glcloselog` DISABLE KEYS */;
/*!40000 ALTER TABLE `glcloselog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glclosemonthlog`
--

DROP TABLE IF EXISTS `glclosemonthlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glclosemonthlog` (
  `id` int(11) NOT NULL auto_increment,
  `closedate` date default NULL,
  `status` tinyint(4) NOT NULL default '0',
  `laststatusdate` datetime default NULL,
  `laststatususerid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `closedap` tinyint(4) NOT NULL default '0',
  `closedar` tinyint(4) NOT NULL default '0',
  `closedinv` tinyint(4) NOT NULL default '0',
  `closedpay` tinyint(4) NOT NULL default '0',
  `closedgl` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `closedate` (`closedate`,`cancel`,`gencompanyid`),
  KEY `status` (`status`,`cancel`,`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glclosemonthlog`
--

LOCK TABLES `glclosemonthlog` WRITE;
/*!40000 ALTER TABLE `glclosemonthlog` DISABLE KEYS */;
/*!40000 ALTER TABLE `glclosemonthlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glcompany`
--

DROP TABLE IF EXISTS `glcompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glcompany` (
  `id` int(11) NOT NULL default '0',
  `fiscalbeginmonth` int(11) NOT NULL default '1',
  `lastgltransactionid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glcompany`
--

LOCK TABLES `glcompany` WRITE;
/*!40000 ALTER TABLE `glcompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `glcompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glexpensetype`
--

DROP TABLE IF EXISTS `glexpensetype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glexpensetype` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `glaccountid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `type` char(1) NOT NULL default 'E',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glexpensetype`
--

LOCK TABLES `glexpensetype` WRITE;
/*!40000 ALTER TABLE `glexpensetype` DISABLE KEYS */;
/*!40000 ALTER TABLE `glexpensetype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glincometype`
--

DROP TABLE IF EXISTS `glincometype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glincometype` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `glaccountid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glincometype`
--

LOCK TABLES `glincometype` WRITE;
/*!40000 ALTER TABLE `glincometype` DISABLE KEYS */;
/*!40000 ALTER TABLE `glincometype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glpie`
--

DROP TABLE IF EXISTS `glpie`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glpie` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(30) NOT NULL default '',
  `description` char(100) default NULL,
  `begindate` date default NULL,
  `findate` date default NULL,
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glpie`
--

LOCK TABLES `glpie` WRITE;
/*!40000 ALTER TABLE `glpie` DISABLE KEYS */;
/*!40000 ALTER TABLE `glpie` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glpieslice`
--

DROP TABLE IF EXISTS `glpieslice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glpieslice` (
  `id` int(11) NOT NULL auto_increment,
  `glpieid` int(11) NOT NULL default '0',
  `name` char(30) default NULL,
  `begindate` date default NULL,
  `findate` date default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `glpieid` (`glpieid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glpieslice`
--

LOCK TABLES `glpieslice` WRITE;
/*!40000 ALTER TABLE `glpieslice` DISABLE KEYS */;
/*!40000 ALTER TABLE `glpieslice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `glpieslicedetail`
--

DROP TABLE IF EXISTS `glpieslicedetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `glpieslicedetail` (
  `id` int(11) NOT NULL auto_increment,
  `glpiesliceid` int(11) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `glpiesliceid` (`glpiesliceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `glpieslicedetail`
--

LOCK TABLES `glpieslicedetail` WRITE;
/*!40000 ALTER TABLE `glpieslicedetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `glpieslicedetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gltransaction`
--

DROP TABLE IF EXISTS `gltransaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gltransaction` (
  `id` int(11) NOT NULL auto_increment,
  `glaccountid` int(11) NOT NULL default '0',
  `voucherid` int(11) default NULL,
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `currency` varchar(10) NOT NULL default 'USD',
  `jobid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `transdesc` varchar(50) default NULL,
  `departmentid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `glaccountid` (`glaccountid`),
  KEY `voucherid` (`voucherid`),
  KEY `gltr_jobid` (`jobid`),
  KEY `gltr_costcodeid` (`costcodeid`),
  KEY `gltr_categoryid` (`glcategoryid`),
  KEY `departmentid` (`departmentid`),
  KEY `summable` (`glaccountid`,`voucherid`,`amount`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gltransaction`
--

LOCK TABLES `gltransaction` WRITE;
/*!40000 ALTER TABLE `gltransaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `gltransaction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gltransidgeneral`
--

DROP TABLE IF EXISTS `gltransidgeneral`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gltransidgeneral` (
  `id` int(11) NOT NULL default '1',
  `jobRequired` int(5) NOT NULL default '0',
  `costcodeRequired` int(5) NOT NULL default '0',
  `categoryRequired` int(5) NOT NULL default '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gltransidgeneral`
--

LOCK TABLES `gltransidgeneral` WRITE;
/*!40000 ALTER TABLE `gltransidgeneral` DISABLE KEYS */;
/*!40000 ALTER TABLE `gltransidgeneral` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gltransvoucher`
--

DROP TABLE IF EXISTS `gltransvoucher`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gltransvoucher` (
  `id` int(11) NOT NULL auto_increment,
  `voucher` varchar(50) default NULL,
  `description` varchar(50) NOT NULL default '',
  `comments` varchar(50) NOT NULL default '',
  `wherefrom` int(11) NOT NULL default '0',
  `status` int(11) default '0',
  `cancel` int(11) default '0',
  `companyid` int(11) NOT NULL default '0',
  `standardset` double NOT NULL default '0',
  `standardsetperiodtype` tinyint(1) NOT NULL default '0',
  `standardsetperiodvalue` smallint(6) NOT NULL default '0',
  `standardsetperiodstarts` date default NULL,
  `standardsetperiodends` date default NULL,
  `standardsetperiodendscount` smallint(6) NOT NULL default '0',
  `standardsetposthow` tinyint(1) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `posteddate` datetime default NULL,
  `post2date` date NOT NULL default '0000-00-00',
  `canceldate` datetime default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `entryuserid` int(11) default NULL,
  `canceluserid` int(11) default NULL,
  `postuserid` int(11) default NULL,
  `bankdepositid` int(11) NOT NULL default '0',
  `referencetable` varchar(255) NOT NULL default '',
  `referenceid` int(11) NOT NULL default '0',
  `taj` int(5) NOT NULL default '0',
  `cancelsvoucherid` int(11) NOT NULL default '0',
  `canceledbyvoucherid` int(11) NOT NULL default '0',
  `reversesvoucherid` int(11) NOT NULL default '0',
  `reversedbyvoucherid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `wherefrom` (`wherefrom`),
  KEY `companyid` (`companyid`),
  KEY `post2date` (`post2date`),
  KEY `voucher` (`voucher`),
  KEY `cancel` (`cancel`),
  KEY `status` (`status`),
  KEY `taj` (`taj`),
  KEY `standardset` (`standardset`),
  KEY `entrydate` (`entrydate`),
  KEY `bankdepositid` (`bankdepositid`),
  KEY `reference` (`referencetable`,`referenceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gltransvoucher`
--

LOCK TABLES `gltransvoucher` WRITE;
/*!40000 ALTER TABLE `gltransvoucher` DISABLE KEYS */;
/*!40000 ALTER TABLE `gltransvoucher` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gltransvouchergroup`
--

DROP TABLE IF EXISTS `gltransvouchergroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gltransvouchergroup` (
  `id` int(11) NOT NULL auto_increment,
  `mainvoucherid` int(11) NOT NULL default '0',
  `voucherid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mainvoucherid` (`mainvoucherid`),
  KEY `voucherid` (`voucherid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gltransvouchergroup`
--

LOCK TABLES `gltransvouchergroup` WRITE;
/*!40000 ALTER TABLE `gltransvouchergroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `gltransvouchergroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hints`
--

DROP TABLE IF EXISTS `hints`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hints` (
  `id` int(11) NOT NULL auto_increment,
  `notes` text,
  `question` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `hints`
--

LOCK TABLES `hints` WRITE;
/*!40000 ALTER TABLE `hints` DISABLE KEYS */;
INSERT INTO `hints` VALUES (1,'STR_HINT1','STR_HINT1Q'),(2,'STR_HINT2','STR_HINT2Q'),(3,'STR_HINT3','STR_HINT3Q'),(4,'STR_HINT4','STR_HINT4Q');
/*!40000 ALTER TABLE `hints` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `holidays`
--

DROP TABLE IF EXISTS `holidays`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `holidays` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(64) default NULL,
  `month` tinyint(2) NOT NULL default '0',
  `day` tinyint(2) NOT NULL default '0',
  `date_by_day_day` varchar(8) NOT NULL default '',
  `date_by_day_val` tinyint(1) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceluserid` int(11) default NULL,
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `holidays`
--

LOCK TABLES `holidays` WRITE;
/*!40000 ALTER TABLE `holidays` DISABLE KEYS */;
INSERT INTO `holidays` VALUES (1,'New Year Day',1,1,'',0,0,NULL,'0000-00-00 00:00:00'),(2,'Independence Day',7,4,'',0,0,NULL,'0000-00-00 00:00:00'),(3,'Labor Day',9,0,'Monday',1,0,NULL,'0000-00-00 00:00:00'),(4,'Thanksgiving Day',11,0,'Thursday',4,0,NULL,'0000-00-00 00:00:00'),(5,'Christmas Day',12,25,'',0,0,NULL,'0000-00-00 00:00:00');
/*!40000 ALTER TABLE `holidays` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `homepages`
--

DROP TABLE IF EXISTS `homepages`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `homepages` (
  `id` int(11) NOT NULL auto_increment,
  `tabname` varchar(200) NOT NULL default '',
  `reportname` varchar(200) default NULL,
  `reportdescription` varchar(255) default NULL,
  `create_interval` decimal(11,0) NOT NULL default '30',
  `lastupdate` datetime default NULL,
  `status` int(11) NOT NULL default '0',
  `generate_start` datetime default NULL,
  `page_html` mediumtext,
  `gencompanyid` int(11) NOT NULL default '1',
  KEY `id` (`id`),
  KEY `reportname` (`reportname`),
  KEY `tabname` (`tabname`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `homepages`
--

LOCK TABLES `homepages` WRITE;
/*!40000 ALTER TABLE `homepages` DISABLE KEYS */;
/*!40000 ALTER TABLE `homepages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hotelusage`
--

DROP TABLE IF EXISTS `hotelusage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hotelusage` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `usagedate` date default NULL,
  `roomsrented` int(11) NOT NULL default '0',
  `roomsavailable` int(11) NOT NULL default '0',
  `roomrevenue` decimal(19,6) NOT NULL default '0.000000',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `usagedate` (`usagedate`),
  KEY `entrydate` (`entrydate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `hotelusage`
--

LOCK TABLES `hotelusage` WRITE;
/*!40000 ALTER TABLE `hotelusage` DISABLE KEYS */;
/*!40000 ALTER TABLE `hotelusage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hpreport`
--

DROP TABLE IF EXISTS `hpreport`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hpreport` (
  `id` int(11) NOT NULL auto_increment,
  `module` char(3) NOT NULL default '',
  `reporttype` int(11) NOT NULL default '1',
  `code` varchar(100) NOT NULL default '',
  `title` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `module` (`module`),
  KEY `reporttype` (`reporttype`),
  KEY `code` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=154 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `hpreport`
--

LOCK TABLES `hpreport` WRITE;
/*!40000 ALTER TABLE `hpreport` DISABLE KEYS */;
INSERT INTO `hpreport` VALUES (1,'AR',1,'recent_payments','STR_RECENT_PAYMENTS_ONE_WEEK'),(2,'AR',1,'recent_payments_month','STR_RECENT_PAYMENTS_ONE_MONTH'),(3,'AR',2,'pending_sales_overview','STR_PENDING_SALES_OVERVIEW'),(4,'AR',2,'recent_sales_actions','STR_RECENT_SALES_ACTIONS'),(5,'AR',2,'sales_actions_needed_today','STR_SALES_ACTIONS_NEEDED_TODAY'),(6,'AR',2,'topdollar_customers_month','STR_TOP_10_CUSTOMERS_1_MONTH'),(7,'AR',2,'topdollar_customers_year','STR_TOP_10_CUSTOMERS_1_YEAR'),(8,'AR',2,'overcredit_customers','STR_CUSTOMERS_OVER_CREDITLIMIT'),(9,'AR',2,'aging_summary','STR_AGING_SUMMARY'),(10,'AR',2,'most_overdue','STR_MOST_OVERDUE'),(11,'AR',2,'recent_customers','STR_10_MOST_RECENTLY_ADDED_CUSTOMERS'),(12,'AR',3,'invoices_due_dates','STR_INVOICES_DUE_DATES'),(13,'AR',3,'invoice_volume_7day','STR_INVOICE_VOLUME_ONE_WEEK'),(14,'AR',3,'arinvoice_volume_8week','STR_INVOICE_VOLUME_8_WEEK'),(15,'AR',3,'arinvoice_volume_12month','STR_INVOICE_VOLUME_12_MONTH'),(16,'ORD',1,'performance_statistics_15','STR_PERFORMANCE_STATISTICS_15_DAYS'),(17,'ORD',1,'performance_statistics_30','STR_PERFORMANCE_STATISTICS_30_DAYS'),(18,'ORD',1,'performance_statistics_60','STR_PERFORMANCE_STATISTICS_60_DAYS'),(19,'ORD',1,'performance_statistics_90','STR_PERFORMANCE_STATISTICS_90_DAYS'),(20,'ORD',1,'arorder_volume_7day','STR_ORDER_VOLUME_7_DAY'),(21,'ORD',1,'arorder_volume_8week','STR_ORDER_VOLUME_8_WEEK'),(22,'ORD',1,'arorder_volume_12month','STR_ORDER_VOLUME_12_MONTH'),(23,'ORD',2,'recently_shipped_items','STR_RECENTLY_SHIPPED_ITEMS'),(24,'ORD',2,'recently_shipped_orders','STR_RECENTLY_SHIPPED_ORDERS'),(25,'ORD',2,'recently_received_orders','STR_RECENTLY_RECEIVED_ORDERS'),(26,'ORD',2,'recently_added_customers','STR_RECENTLY_ADDED_CUSTOMERS'),(27,'ORD',2,'over_estimate_orders','STR_ORDERS_NEAR_OR_OVER_ESTIMATE'),(28,'ORD',3,'open_orders_due_dates','STR_OPEN_ORDERS_DUE_DATES'),(29,'ORD',3,'open_orders_all','STR_OPEN_ORDERS_ALL'),(30,'ORD',3,'open_orders_mine','STR_MY_OPEN_ORDERS'),(31,'ORD',3,'topdollar_customers_month','STR_TOP_10_CUSTOMERS_30_DAYS'),(32,'ORD',3,'topdollar_customers_year','STR_TOP_10_CUSTOMERS_YEAR'),(33,'ORD',3,'topsales_items_month','STR_TOP_10_ITEMS_30_DAYS'),(34,'ORD',3,'topsales_items_year','STR_TOP_10_ITEMS_YEAR'),(35,'ORD',3,'profitability_items_30day','STR_TOP_10_PROFIT_ITEM_30DAYS'),(36,'ORD',3,'profitability_items_year','STR_TOP_10_PROFIT_ITEM_YEAR'),(37,'ORD',3,'profitability_customers_month','STR_TOP_10_PROFIT_CUSTOMERS_MONTH'),(38,'ORD',3,'profitability_customers_year','STR_TOP_10_PROFIT_CUSTOMERS_YEAR'),(39,'ORD',3,'service_order_workers_on_jobs','STR_CURRENTLY_WORKING_ON_SERVICE_ORDERS'),(40,'INV',1,'inventory_adjustments','STR_RECENT_INVENTORY_ADJUSTMENTS'),(41,'INV',1,'inventory_category_usage_30day','STR_INVENTORY_USAGE_BY_CATEGORY_30_DAYS'),(42,'INV',1,'inventory_category_usage_year','STR_INVENTORY_USAGE_BY_CATEGORY_1_YEAR'),(43,'INV',2,'items_below_reorder','STR_ITEM_REORDER_LIST'),(44,'INV',2,'pending_po','STR_PENDING_PURCHASE_ORDERS'),(45,'INV',2,'pending_build_order','STR_PENDING_BUILD_ORDERS'),(46,'INV',2,'receipts_with_po','STR_RECEIPTS_WITH_PO'),(47,'INV',2,'receipts_without_po','STR_RECEIPTS_WITHOUT_PO'),(48,'INV',3,'topsales_items_month','STR_TOP_10_ITEMS_30_DAYS'),(49,'INV',3,'topsales_items_year','STR_TOP_10_ITEMS_YEAR'),(50,'INV',3,'profitability_items_30day','STR_TOP_10_PROFIT_ITEM_30DAYS'),(51,'INV',3,'profitability_items_year','STR_TOP_10_PROFIT_ITEM_YEAR'),(52,'INV',3,'new_items','STR_NEW_INVENTORY_ITEMS'),(53,'AP',1,'bills_volume_7day','STR_BILLS_VOLUME_7_DAY'),(54,'AP',1,'bills_volume_8week','STR_BILLS_VOLUME_8_WEEK'),(55,'AP',1,'bills_volume_12month','STR_BILLS_VOLUME_12_MONTH'),(56,'AP',1,'pending_po','STR_PENDING_PO'),(57,'AP',1,'pending_po_item','STR_PENDING_ITEMS_ON_PO'),(58,'AP',2,'topdollar_vendors_month','STR_TOP_DOLLAR_VENDORS_MONTH'),(59,'AP',2,'topdollar_vendors_year','STR_TOP_DOLLAR_VENDORS_YEAR'),(60,'AP',2,'recent_bills','STR_RECENT_BILLS_RECEIVED'),(61,'AP',2,'recent_checks_week','STR_CHECKS_WRITTEN_ONE_WEEK'),(62,'AP',2,'recent_checks_month','STR_CHECKS_WRITTEN_ONE_MONTH'),(63,'AP',3,'bills_due_dates','STR_BILLS_OVERDUE_DUE_SOON_DUE_LATER'),(64,'PAY',1,'payroll_by_week','STR_PAYROLL_THIS_MONTH'),(65,'PAY',1,'payroll_by_month','STR_PAYROLL_BY_MONTH_FOR_YEAR'),(66,'PAY',1,'payroll_by_quarter','STR_PAYROLL_BY_QUARTER_FOR_YEAR'),(67,'PAY',2,'paychanges','STR_RECENT_PAY_RATE_CHANGES'),(68,'PAY',2,'recent_layoffs','STR_RECENT_LAYOFFS'),(69,'PAY',2,'employee_counts','STR_EMPLOYEE_COUNTS'),(70,'PAY',3,'birthdays','STR_BIRTHDAYS_IN_NEXT_MONTH'),(71,'PAY',3,'recent_reviews','STR_RECENT_REVIEWS_7_DAYS'),(72,'GL',1,'bar_profit_12month','STR_PROFIT_12_MONTH'),(73,'GL',1,'bar_profit_5year','STR_PROFIT_5_YEAR'),(74,'GL',2,'sales_7day','STR_SALES_7_DAYS'),(75,'GL',2,'sales_12month','STR_SALES_12_MONTH'),(76,'GL',2,'sales_8week','STR_SALES_8_WEEK'),(77,'GL',2,'glrepincome','STR_INCOME_SUMMARY'),(78,'GL',3,'recent_journal','STR_JOURNAL_ENTRIES_7_DAYS'),(79,'SUM',2,'sum_profit_loss','STR_PROFIT_AND_LOSS'),(80,'SUM',2,'sum_income_expenses','STR_INCOME_AND_EXPENSES'),(82,'CAR',2,'topsales_items_year','STR_TOP_10_ITEMS_YEAR'),(83,'CAR',2,'topsales_items_month','STR_TOP_10_ITEMS_MONTH'),(84,'CAR',2,'topdollar_customers_year','STR_TOP_10_CUSTOMERS_YEAR'),(85,'CAR',2,'topdollar_customers_month','STR_TOP_TEN_CUSTOMERS'),(86,'CAR',2,'top_states_year','STR_TOP_10_SALES_STATES_YEAR'),(87,'CAR',2,'top_states_month','STR_TOP_10_SALES_STATES_MONTH'),(88,'CAR',2,'recently_shipped_orders','STR_RECENTLY_SHIPPED_ORDERS'),(89,'CAR',2,'recently_shipped_items','STR_RECENTLY_SHIPPED_ITEMS'),(90,'CAR',2,'recently_received_orders','STR_RECENTLY_RECEIVED_ORDERS'),(91,'CAR',2,'recently_added_customers','STR_RECENTLY_ADDED_CUSTOMERS'),(92,'CAR',2,'profitability_items_year','STR_TOP_10_PROFIT_ITEMS_YEAR'),(93,'CAR',2,'profitability_items_30day','STR_TOP_10_PROFIT_ITEMS_MONTH'),(94,'CAR',2,'profitability_customers_year','STR_TOP_10_PROFIT_CUSTOMERS_YEAR'),(95,'CAR',2,'profitability_customers_month','STR_TOP_10_PROFIT_CUSTOMERS_MONTH'),(96,'CAR',2,'products_viewed','STR_PRODUCTS_VIEWED'),(97,'CAR',2,'products_on_sale','STR_PRODUCTS_ON_SALE'),(98,'CAR',1,'performance_statistics_90','STR_PERFORMANCE_STATS_FOR_PAST_90_DAYS'),(99,'CAR',1,'performance_statistics_60','STR_PERFORMANCE_STATS_FOR_PAST_60_DAYS'),(100,'CAR',1,'performance_statistics_30','STR_PERFORMANCE_STATS_FOR_PAST_30_DAYS'),(101,'CAR',1,'performance_statistics_15','STR_PERFORMANCE_STATS_FOR_PAST_15_DAYS'),(102,'CAR',2,'open_orders_due_dates','STR_OPEN_ORDERS_NEARING_DUE_DATE'),(103,'CAR',2,'open_orders_all','STR_OPEN_ORDERS_ALL'),(104,'CAR',1,'inventory_category_usage_year','STR_INVENTORY_USAGE_BY_CATEGORY_YEAR'),(105,'CAR',1,'inventory_category_usage_30day','STR_INVENTORY_USAGE_BY_CATEGORY_30_DAY'),(106,'CAR',1,'arorder_volume_12month','STR_ORDER_VOLUME_12_MONTH'),(107,'CAR',1,'arorder_volume_8week','STR_ORDER_VOLUME_8_WEEK'),(108,'CAR',1,'arorder_volume_7day','STR_ORDER_VOLUME_7_DAY'),(109,'PRT',1,'est_shop_loading','STR_SHOP_LOADING'),(110,'PRT',1,'order_volume_month','STR_PRINT_ORDER_VOLUME_REPORT_ONE_MONTH'),(111,'PRT',1,'order_volume_week','STR_PRINT_ORDER_VOLUME_REPORT'),(112,'PRT',1,'order_volume_year','STR_PRINT_ORDER_VOLUME_REPORT_ONE_YEAR'),(113,'PRT',2,'print_orders_due_dates','STR_OPEN_PRINT_ORDERS_NEARING_DUE_DATE'),(114,'PRT',2,'print_orders_pending','STR_OPEN_PRINT_ORDERS'),(115,'PRT',2,'print_orders_unconfirmed','STR_UNCONFIRMED_PRINT_ORDERS'),(116,'PRT',2,'profitability_customers_month','STR_TOP_10_PROFIT_CUSTOMERS_MONTH'),(117,'PRT',2,'profitability_customers_year','STR_TOP_10_PROFIT_CUSTOMERS_YEAR'),(118,'PRT',2,'profitability_order_month','STR_TOP_10_PROFIT_ORDERS_MONTH'),(119,'PRT',2,'proofs_pending','STR_PENDING_PROOFS'),(120,'PRT',2,'recent_quotes','STR_RECENT_QUOTES'),(121,'PRT',2,'recent_quotes_pending','STR_PENDING_QUOTES'),(122,'PRT',2,'recently_shipped_orders','STR_ORDERS_SHIPPED_ONE_WEEK'),(123,'PRT',2,'topdollar_customers_month','STR_TOP_TEN_PRINT_CUSTOMERS'),(124,'PRT',2,'topdollar_customers_year','STR_TOP_10_PRINT_CUSTOMERS_YEAR'),(125,'PRT',2,'upcoming_stock_needs','STR_UPCOMING_STOCK_NEEDS'),(126,'PRT',2,'won_lost_quotes','STR_WON_LOST_RATIO'),(127,'PL',2,'pl_recent_quotes','STR_RECENT_QUOTES'),(128,'PL',2,'obs_month','STR_OBS_VOLUME_REPORT_ONE_MONTH'),(129,'PL',2,'obs_quarter','STR_OBS_VOLUME_REPORT_ONE_QUARTER'),(130,'PL',2,'obs_week','STR_OBS_VOLUME_REPORT_ONE_WEEK'),(131,'PL',2,'obs_year','STR_OBS_VOLUME_REPORT_ONE_YEAR'),(132,'PL',2,'pl_order_volume_month','STR_PRINT_ORDER_VOLUME_REPORT_ONE_MONTH'),(133,'PL',2,'pl_order_volume_week','STR_PRINT_ORDER_VOLUME_REPORT'),(134,'PL',2,'pl_order_volume_year','STR_PRINT_ORDER_VOLUME_REPORT_ONE_YEAR'),(135,'PL',1,'pl_performance_statistics_15','STR_PERFORMANCE_STATS_FOR_PAST_15_DAYS'),(136,'PL',1,'pl_performance_statistics_30','STR_PERFORMANCE_STATS_FOR_PAST_30_DAYS'),(137,'PL',1,'pl_performance_statistics_60','STR_PERFORMANCE_STATS_FOR_PAST_60_DAYS'),(138,'PL',1,'pl_performance_statistics_90','STR_PERFORMANCE_STATS_FOR_PAST_90_DAYS'),(139,'PL',2,'pl_print_orders_due_dates','STR_OPEN_PRINT_ORDERS_NEARING_DUE_DATE'),(140,'PL',2,'pl_print_orders_pending','STR_OPEN_PRINT_ORDERS'),(141,'PL',2,'pl_print_orders_unconfirmed','STR_UNCONFIRMED_PRINT_ORDERS'),(142,'PL',2,'profitability_customers_month','STR_TOP_10_PROFIT_CUSTOMERS_MONTH'),(143,'PL',2,'pl_recent_quotes_pending','STR_PENDING_QUOTES'),(144,'PL',2,'pl_recently_shipped_orders','STR_ORDERS_SHIPPED_ONE_WEEK'),(145,'PL',2,'pl_upcoming_stock_needs','STR_UPCOMING_STOCK_NEEDS'),(146,'PL',2,'print_orders_due_dates','STR_OPEN_PRINT_ORDERS_NEARING_DUE_DATE'),(147,'PL',2,'profitability_customers_year','STR_TOP_10_PROFIT_CUSTOMERS_YEAR'),(148,'PL',2,'profitability_orders_month','STR_TOP_10_PROFIT_ORDERS_MONTH'),(149,'PL',2,'recent_customers','STR_10_NEWEST_CUSTOMERS'),(150,'PL',2,'topdollar_customers_month','STR_TOP_TEN_PRINT_CUSTOMERS_30_DAYS'),(151,'PL',2,'topdollar_customers_year','STR_TOP_10_PRINT_CUSTOMERS_YEAR'),(152,'PL',2,'topdollar_customers_year_wide','STR_TOP_50_PRINT_CUSTOMERS_YEAR'),(153,'AP',2,'unapproved_apbills','STR_UNAPPROVED_VENDOR_BILLS');
/*!40000 ALTER TABLE `hpreport` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hpreportgroup`
--

DROP TABLE IF EXISTS `hpreportgroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hpreportgroup` (
  `id` int(11) NOT NULL auto_increment,
  `hpreportid` int(11) NOT NULL default '0',
  `nprightsgroupid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `hpreportid` (`hpreportid`),
  KEY `nprightsgroupid` (`nprightsgroupid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `hpreportgroup`
--

LOCK TABLES `hpreportgroup` WRITE;
/*!40000 ALTER TABLE `hpreportgroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `hpreportgroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `igroup`
--

DROP TABLE IF EXISTS `igroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `igroup` (
  `id` int(11) NOT NULL auto_increment,
  `groupname` varchar(255) default NULL,
  `groupcode` varchar(20) default NULL,
  `createdate` datetime default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `createuserid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `multiplier` decimal(5,2) NOT NULL default '1.00',
  PRIMARY KEY  (`id`),
  KEY `groupcode` (`groupcode`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `igroup`
--

LOCK TABLES `igroup` WRITE;
/*!40000 ALTER TABLE `igroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `igroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `interestchargeoption`
--

DROP TABLE IF EXISTS `interestchargeoption`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `interestchargeoption` (
  `id` int(11) NOT NULL auto_increment,
  `rate` decimal(19,4) NOT NULL default '0.0000',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `interestchargeoption`
--

LOCK TABLES `interestchargeoption` WRITE;
/*!40000 ALTER TABLE `interestchargeoption` DISABLE KEYS */;
/*!40000 ALTER TABLE `interestchargeoption` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invadjustmenttype`
--

DROP TABLE IF EXISTS `invadjustmenttype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invadjustmenttype` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(255) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `glaccountid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `active` (`cancel`,`gencompanyid`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invadjustmenttype`
--

LOCK TABLES `invadjustmenttype` WRITE;
/*!40000 ALTER TABLE `invadjustmenttype` DISABLE KEYS */;
INSERT INTO `invadjustmenttype` VALUES (1,'DMG','Damaged Material',0,0,0,0,NULL,NULL,-1,1),(2,'EXP','Expired Material',0,0,0,0,NULL,NULL,-1,1),(3,'TRF','Transfer Variance',0,0,0,0,NULL,NULL,-1,1),(4,'CYC','Cycle Count Variance',0,0,0,0,NULL,NULL,-1,1),(5,'ADJ','Count Adjustment',0,0,0,0,NULL,NULL,-1,1);
/*!40000 ALTER TABLE `invadjustmenttype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invadjustmenttypeitem`
--

DROP TABLE IF EXISTS `invadjustmenttypeitem`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invadjustmenttypeitem` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `invadjustmenttypeid` int(11) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `lookup` (`itemid`,`invadjustmenttypeid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invadjustmenttypeitem`
--

LOCK TABLES `invadjustmenttypeitem` WRITE;
/*!40000 ALTER TABLE `invadjustmenttypeitem` DISABLE KEYS */;
/*!40000 ALTER TABLE `invadjustmenttypeitem` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invadjustmenttypeitemcategory`
--

DROP TABLE IF EXISTS `invadjustmenttypeitemcategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invadjustmenttypeitemcategory` (
  `id` int(11) NOT NULL auto_increment,
  `itemcategoryid` int(11) NOT NULL default '0',
  `invadjustmenttypeid` int(11) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  `inventorytype` char(1) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `lookup` (`itemcategoryid`,`invadjustmenttypeid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invadjustmenttypeitemcategory`
--

LOCK TABLES `invadjustmenttypeitemcategory` WRITE;
/*!40000 ALTER TABLE `invadjustmenttypeitemcategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `invadjustmenttypeitemcategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invbegcount`
--

DROP TABLE IF EXISTS `invbegcount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invbegcount` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `count` double default '0',
  `priceach` decimal(20,6) NOT NULL default '0.000000',
  `inventorylocationid` int(11) NOT NULL default '0',
  `status` int(2) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `countunitid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invbegcount`
--

LOCK TABLES `invbegcount` WRITE;
/*!40000 ALTER TABLE `invbegcount` DISABLE KEYS */;
/*!40000 ALTER TABLE `invbegcount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invbin`
--

DROP TABLE IF EXISTS `invbin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invbin` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(255) default NULL,
  `description` text,
  `invzoneid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `code_comp` (`code`,`gencompanyid`),
  KEY `ref` (`invzoneid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invbin`
--

LOCK TABLES `invbin` WRITE;
/*!40000 ALTER TABLE `invbin` DISABLE KEYS */;
/*!40000 ALTER TABLE `invbin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invbinitem`
--

DROP TABLE IF EXISTS `invbinitem`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invbinitem` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) default '0',
  `inventorylocationid` int(11) default '0',
  `invbinid` int(11) default '0',
  `sortorder` int(11) default '0',
  PRIMARY KEY  (`id`),
  KEY `item_location` (`itemid`,`inventorylocationid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invbinitem`
--

LOCK TABLES `invbinitem` WRITE;
/*!40000 ALTER TABLE `invbinitem` DISABLE KEYS */;
/*!40000 ALTER TABLE `invbinitem` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcompany`
--

DROP TABLE IF EXISTS `invcompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcompany` (
  `id` int(11) NOT NULL default '0',
  `cash` double NOT NULL default '0',
  `sales` double NOT NULL default '0',
  `loss` double NOT NULL default '0',
  `cost` double NOT NULL default '0',
  `freight` double NOT NULL default '0',
  `tax` double NOT NULL default '0',
  `custoritemglacct` int(11) NOT NULL default '0',
  `locationid` int(11) NOT NULL default '0',
  `default_pricelevelid` int(11) NOT NULL default '0',
  `default_rentalpricelevelid` int(11) NOT NULL default '0',
  `weight_units` varchar(10) NOT NULL default 'lbs',
  `category_hierarchy` int(2) NOT NULL default '1',
  `default_inventoryglacct` int(11) NOT NULL default '0',
  `multi_quantity` int(5) NOT NULL default '0',
  `costmethod` char(1) NOT NULL default 'F',
  `inventoryvariance` int(11) NOT NULL default '0',
  `addglatpo` int(11) NOT NULL default '0',
  `distributetaxfreight` int(11) NOT NULL default '0',
  `breakdown_scrap` int(5) NOT NULL default '0',
  `costadjustglacctid` int(11) NOT NULL default '0',
  `googlebasedevkey` varchar(200) NOT NULL default '',
  `blockifnostockmethod` char(1) NOT NULL default 'A',
  `blockifnostocktype` varchar(5) NOT NULL default 'FPS',
  `invcotransferglaccountid` int(11) NOT NULL default '0',
  `max_purch_suggestion` int(5) NOT NULL default '0',
  `othercostockdefault` text,
  `itemlookupvendor` tinyint(4) NOT NULL default '0',
  `showoptioninvstatus` tinyint(4) NOT NULL default '0',
  `backdate_unreceive` tinyint(1) NOT NULL default '0',
  `costmethodphysical` char(1) NOT NULL default '',
  `remoteusesonhand` tinyint(4) NOT NULL default '0',
  `autobuildbomlimited` tinyint(1) NOT NULL default '1',
  `reorderdcmonthssales` int(11) NOT NULL default '0',
  `reordernondcmonthssales` int(11) NOT NULL default '0',
  `invcotransferburdenglaccountid` int(11) NOT NULL default '0',
  `invcotransfertransitglaccountid` int(11) NOT NULL default '0',
  `physicalinventorylockdown` tinyint(1) NOT NULL default '0',
  `accruedpurchasesglid` int(11) NOT NULL default '0',
  `invcotransferpostmethod` tinyint(1) NOT NULL default '0',
  `invcotransferallowmultiloc` tinyint(1) NOT NULL default '1',
  `defaultrentalinventorylocationid` int(11) NOT NULL default '0',
  `invcountbatchcycleinvadjustmenttypeid` int(11) NOT NULL default '0',
  `invcountbatchphysinvadjustmenttypeid` int(11) NOT NULL default '0',
  `onlyallowtransfersfromdc` tinyint(1) NOT NULL default '0',
  `autoshowbarcodepopupfornewitems` tinyint(1) NOT NULL default '1',
  `emailnewitemnoticesto` text NOT NULL,
  `newitemrequirevendor` tinyint(1) NOT NULL default '0',
  `newitemrequirecategory` tinyint(1) NOT NULL default '0',
  `stockitemrequireitemlocationprice` tinyint(1) NOT NULL default '0',
  `adjustmentsrequirecomments` tinyint(1) NOT NULL default '0',
  `emailnewitemnoticesstockonly` tinyint(1) NOT NULL default '0',
  `ignorespacesitemsearchbox` tinyint(4) NOT NULL default '0',
  `invcotransferassignedblockedit` tinyint(4) NOT NULL default '0',
  `emailminmaxchanges` text NOT NULL,
  `requireuniquevendorproductcodes` tinyint(1) NOT NULL default '1',
  `emailcyclecountsummaries` text NOT NULL,
  `emailphysicalcountsummaries` text NOT NULL,
  `requireemailpostcycle` tinyint(1) NOT NULL default '0',
  `requireemailpostphysical` tinyint(1) NOT NULL default '0',
  `requireemailpostcycleemails` text NOT NULL,
  `requireemailpostphysicalemails` text NOT NULL,
  `locationwacostsame` tinyint(4) NOT NULL default '0',
  `invcotransferblockstock` tinyint(1) NOT NULL default '0',
  `invcotransferblocknonstock` tinyint(1) NOT NULL default '0',
  `invcotransferblockothercharges` tinyint(1) NOT NULL default '0',
  `senditemspecialpricechangenotices` tinyint(1) NOT NULL default '0',
  `transfervarianceinvadjustmenttypeid` int(11) NOT NULL default '0',
  `sendcountitemaddednotice` tinyint(1) NOT NULL default '0',
  `sendtransfernoticestoentryuser` tinyint(1) NOT NULL default '0',
  `invcotransfertitles` tinyint(1) NOT NULL default '0',
  `itemsinvoicingusesglsetupwhen` tinyint(1) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcompany`
--

LOCK TABLES `invcompany` WRITE;
/*!40000 ALTER TABLE `invcompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcotransfer`
--

DROP TABLE IF EXISTS `invcotransfer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcotransfer` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) default NULL,
  `comment` text,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastpostdate` datetime default NULL,
  `gencompanyidfrom` int(11) NOT NULL default '0',
  `gencompanyidto` int(11) NOT NULL default '0',
  `inventorylocationidfrom` int(11) NOT NULL default '0',
  `inventorylocationidto` int(11) NOT NULL default '0',
  `duedate` date default NULL,
  `orderid` int(11) NOT NULL default '0',
  `assigneddate` datetime default NULL,
  `assigneduserid` int(11) NOT NULL default '0',
  `accepteddate` datetime default NULL,
  `pickcompleteddate` datetime default NULL,
  `shippeddate` datetime default NULL,
  `shippeduserid` int(11) NOT NULL default '0',
  `showcommitted` tinyint(1) NOT NULL default '0',
  `writtenby` int(11) NOT NULL default '0',
  `printedbyuserid` int(11) NOT NULL default '0',
  `printeddate` datetime default NULL,
  `receiveddate` datetime default NULL,
  `receiveduserid` int(11) NOT NULL default '0',
  `invzoneid` int(11) NOT NULL default '0',
  `status` tinyint(1) NOT NULL default '0' COMMENT '0=new/unassigned, 1=assigned, 2=accepted, 3=picked, 4=shipped, 5=received/completed',
  `invcotransfertitleid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `entrydate` (`entrydate`),
  KEY `lastpostdate` (`lastpostdate`),
  KEY `assigneduserid` (`assigneduserid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcotransfer`
--

LOCK TABLES `invcotransfer` WRITE;
/*!40000 ALTER TABLE `invcotransfer` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcotransfer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcotransferdetail`
--

DROP TABLE IF EXISTS `invcotransferdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcotransferdetail` (
  `id` int(11) NOT NULL auto_increment,
  `invcotransferid` int(11) NOT NULL default '0',
  `linenumber` int(11) NOT NULL default '0',
  `itemcode` varchar(30) default NULL,
  `description` varchar(100) default NULL,
  `itemidto` int(11) NOT NULL default '0',
  `itemidfrom` int(11) NOT NULL default '0',
  `quantity` decimal(18,6) NOT NULL default '0.000000',
  `picked` decimal(18,6) NOT NULL default '0.000000',
  `received` decimal(18,6) NOT NULL default '0.000000',
  `stockunitnameid` int(11) NOT NULL default '0',
  `gencompanyidfrom` int(11) NOT NULL default '0',
  `gencompanyidto` int(11) NOT NULL default '0',
  `inventorylocationidfrom` int(11) NOT NULL default '0',
  `inventorylocationidto` int(11) NOT NULL default '0',
  `comment` text,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `posted` int(11) NOT NULL default '0',
  `postdate` datetime default NULL,
  `postuserid` int(11) NOT NULL default '0',
  `invglaccountidfrom` int(11) NOT NULL default '0',
  `invglaccountidto` int(11) NOT NULL default '0',
  `offsetglaccountidfrom` int(11) NOT NULL default '0',
  `offsetglaccountidto` int(11) NOT NULL default '0',
  `onhandfrom` decimal(19,5) NOT NULL default '0.00000',
  `onhandto` decimal(19,5) NOT NULL default '0.00000',
  `availablefrom` decimal(19,5) NOT NULL default '0.00000',
  `availableto` decimal(19,5) NOT NULL default '0.00000',
  `costeach` decimal(19,6) NOT NULL default '0.000000',
  `quantityordered` decimal(19,6) NOT NULL default '0.000000',
  `itemweight` decimal(19,6) NOT NULL default '0.000000',
  `status` tinyint(1) NOT NULL default '0' COMMENT '0=new/unassigned, 1=assigned, 2=accepted, 3=picked, 4=shipped, 5=received/completed',
  `orderid` int(11) NOT NULL default '0',
  `shippingcontainer` varchar(255) NOT NULL default '',
  `adjustmenttype` varchar(16) NOT NULL default '',
  `adjustmenttoqty` decimal(19,6) NOT NULL default '0.000000',
  `adjustmentfromqty` decimal(19,6) NOT NULL default '0.000000',
  `adjustmentuserid` int(11) NOT NULL default '0',
  `adjustmentdate` datetime default NULL,
  `addedwhenreceiving` tinyint(1) NOT NULL default '0',
  `arorderdetailid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invcotransferid` (`invcotransferid`),
  KEY `itemcode` (`itemcode`),
  KEY `entrydate` (`entrydate`),
  KEY `posted` (`postdate`),
  KEY `postdate` (`postdate`),
  KEY `cancel` (`cancel`),
  KEY `itemModelOnInvcotransferQtyTo` (`itemidto`,`inventorylocationidto`,`status`,`cancel`,`invcotransferid`,`picked`),
  KEY `itemModelOnInvcotransferQtyFrom` (`itemidfrom`,`inventorylocationidfrom`,`status`,`cancel`,`invcotransferid`,`picked`),
  KEY `orderid` (`orderid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcotransferdetail`
--

LOCK TABLES `invcotransferdetail` WRITE;
/*!40000 ALTER TABLE `invcotransferdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcotransferdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcotransfershiprecv`
--

DROP TABLE IF EXISTS `invcotransfershiprecv`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcotransfershiprecv` (
  `id` int(11) NOT NULL auto_increment,
  `invcotransferid` int(11) NOT NULL default '0',
  `stagingareaidfrom` int(11) NOT NULL default '0',
  `statingareaidto` int(11) NOT NULL default '0',
  `shippeddate` datetime default NULL,
  `receiveddate` datetime default NULL,
  `receivedbyuserid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `cancel` tinyint(1) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  PRIMARY KEY  (`id`),
  KEY `transferid` (`invcotransferid`,`cancel`),
  KEY `active` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcotransfershiprecv`
--

LOCK TABLES `invcotransfershiprecv` WRITE;
/*!40000 ALTER TABLE `invcotransfershiprecv` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcotransfershiprecv` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcotransfershiprecvdetail`
--

DROP TABLE IF EXISTS `invcotransfershiprecvdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcotransfershiprecvdetail` (
  `id` int(11) NOT NULL auto_increment,
  `invcotransfershiprecvid` int(11) NOT NULL default '0',
  `invcotransferdetailid` int(11) NOT NULL default '0',
  `quantityshipped` decimal(18,6) NOT NULL default '0.000000',
  `quantityreceived` decimal(18,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`),
  KEY `invcotransfershiprecvidx` (`invcotransfershiprecvid`),
  KEY `invcotransferdetailidx` (`invcotransferdetailid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcotransfershiprecvdetail`
--

LOCK TABLES `invcotransfershiprecvdetail` WRITE;
/*!40000 ALTER TABLE `invcotransfershiprecvdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcotransfershiprecvdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcotransfertitle`
--

DROP TABLE IF EXISTS `invcotransfertitle`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcotransfertitle` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` varchar(45) NOT NULL default '0',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcotransfertitle`
--

LOCK TABLES `invcotransfertitle` WRITE;
/*!40000 ALTER TABLE `invcotransfertitle` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcotransfertitle` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcount`
--

DROP TABLE IF EXISTS `invcount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcount` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `count` decimal(18,6) NOT NULL default '0.000000',
  `countunitid` varchar(100) NOT NULL default '0',
  `entrydate` datetime default '0000-00-00 00:00:00',
  `status` int(2) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `posteddate` datetime default '0000-00-00 00:00:00',
  `posteduserid` int(11) NOT NULL default '0',
  `noglpost` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcount`
--

LOCK TABLES `invcount` WRITE;
/*!40000 ALTER TABLE `invcount` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcountbatch`
--

DROP TABLE IF EXISTS `invcountbatch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcountbatch` (
  `id` int(11) NOT NULL auto_increment,
  `invadjustmenttypeid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `genuserid` int(11) NOT NULL default '0',
  `assigneddate` datetime default NULL,
  `accepted` tinyint(1) NOT NULL default '0',
  `accepteddate` datetime default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `complete` tinyint(1) NOT NULL default '0',
  `completedate` datetime default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `posted` tinyint(1) NOT NULL default '0',
  `posteddate` datetime default NULL,
  `posteduserid` int(11) NOT NULL default '0',
  `notes` mediumtext NOT NULL,
  `invzoneid` int(11) NOT NULL default '0',
  `invtype` char(1) NOT NULL default '',
  `only_uncounted` tinyint(1) NOT NULL default '0',
  `only_onhand` tinyint(1) NOT NULL default '0',
  `type` tinyint(4) NOT NULL default '0',
  `rentals` int(11) NOT NULL default '-1',
  `pagesize` int(11) NOT NULL default '20',
  `minvalue` decimal(19,6) NOT NULL default '0.000000',
  `period` tinyint(4) NOT NULL default '3',
  `noglpost` tinyint(1) NOT NULL default '0',
  `criteria` varchar(5) NOT NULL default 'cost',
  PRIMARY KEY  (`id`),
  KEY `user` (`genuserid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcountbatch`
--

LOCK TABLES `invcountbatch` WRITE;
/*!40000 ALTER TABLE `invcountbatch` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcountbatch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcountbatchdetail`
--

DROP TABLE IF EXISTS `invcountbatchdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcountbatchdetail` (
  `id` int(11) NOT NULL auto_increment,
  `invcountbatchid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `count` decimal(19,6) NOT NULL default '0.000000',
  `countset` tinyint(1) NOT NULL default '0',
  `onhand` decimal(19,6) NOT NULL default '0.000000',
  `intransit` decimal(19,6) NOT NULL default '0.000000',
  `countentrydate` datetime default NULL,
  `countentryuserid` int(11) NOT NULL default '0',
  `variancerecount` tinyint(1) NOT NULL default '0',
  `invbinid` int(11) NOT NULL default '0',
  `processqueueid` int(11) NOT NULL default '0',
  `status` tinyint(1) NOT NULL default '0',
  `assigned_userid` int(11) NOT NULL default '0',
  `assigned_date` datetime default NULL,
  `assignedby_userid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `parent` (`invcountbatchid`),
  KEY `parrentWithItemid` (`invcountbatchid`,`itemid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcountbatchdetail`
--

LOCK TABLES `invcountbatchdetail` WRITE;
/*!40000 ALTER TABLE `invcountbatchdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcountbatchdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcountbatchitemhistorystatscache`
--

DROP TABLE IF EXISTS `invcountbatchitemhistorystatscache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcountbatchitemhistorystatscache` (
  `itemid` int(11) NOT NULL,
  `inventorylocationid` int(11) NOT NULL,
  `price_sum` decimal(19,4) NOT NULL,
  `cost_sum` decimal(19,4) NOT NULL,
  PRIMARY KEY  (`itemid`,`inventorylocationid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcountbatchitemhistorystatscache`
--

LOCK TABLES `invcountbatchitemhistorystatscache` WRITE;
/*!40000 ALTER TABLE `invcountbatchitemhistorystatscache` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcountbatchitemhistorystatscache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcountbatchlivecountcache`
--

DROP TABLE IF EXISTS `invcountbatchlivecountcache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcountbatchlivecountcache` (
  `id` int(11) NOT NULL auto_increment,
  `invcountbatchid` int(11) NOT NULL default '0',
  `settingshash` int(11) NOT NULL default '0',
  `html` text,
  `entrydate` datetime default NULL,
  PRIMARY KEY  (`id`),
  KEY `batchid` (`invcountbatchid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcountbatchlivecountcache`
--

LOCK TABLES `invcountbatchlivecountcache` WRITE;
/*!40000 ALTER TABLE `invcountbatchlivecountcache` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcountbatchlivecountcache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcountbatchlog`
--

DROP TABLE IF EXISTS `invcountbatchlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcountbatchlog` (
  `id` int(11) NOT NULL auto_increment,
  `invcountbatchid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `action` varchar(8) NOT NULL default '',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `processqueueid` int(11) NOT NULL default '0',
  `data` mediumtext,
  PRIMARY KEY  (`id`),
  KEY `batchid` (`invcountbatchid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcountbatchlog`
--

LOCK TABLES `invcountbatchlog` WRITE;
/*!40000 ALTER TABLE `invcountbatchlog` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcountbatchlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invcountbatchpostlog`
--

DROP TABLE IF EXISTS `invcountbatchpostlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invcountbatchpostlog` (
  `id` int(11) NOT NULL auto_increment,
  `invcountbatchid` int(11) NOT NULL default '0',
  `thead` mediumtext NOT NULL,
  `tbody` mediumtext NOT NULL,
  `subject` tinytext NOT NULL,
  `sentto` varchar(255) NOT NULL default '',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `costofmissinggoods` decimal(19,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`id`),
  KEY `batchid` (`invcountbatchid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invcountbatchpostlog`
--

LOCK TABLES `invcountbatchpostlog` WRITE;
/*!40000 ALTER TABLE `invcountbatchpostlog` DISABLE KEYS */;
/*!40000 ALTER TABLE `invcountbatchpostlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventorylocation`
--

DROP TABLE IF EXISTS `inventorylocation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `inventorylocation` (
  `id` int(11) NOT NULL auto_increment,
  `companyname` char(35) NOT NULL default '',
  `address1` char(100) default NULL,
  `address2` char(100) default NULL,
  `mailstop` char(20) default NULL,
  `city` char(50) default NULL,
  `state` char(20) default NULL,
  `zip` char(15) default NULL,
  `county` varchar(50) NOT NULL default '',
  `countyid` varchar(25) default NULL,
  `blockfromitemreorderlist` tinyint(1) NOT NULL default '0',
  `blockfromcountmanagement` tinyint(1) NOT NULL default '0',
  `territoryregionid` int(11) NOT NULL default '0',
  `defaultccaccountid` int(11) NOT NULL default '0',
  `emailphysicalcount` varchar(255) NOT NULL default '',
  `emailcyclecount` varchar(255) NOT NULL default '',
  `graphicurl_big` varchar(200) default '',
  `graphicurl` varchar(200) default '',
  `country` char(20) default NULL,
  `phone1` char(20) default NULL,
  `phone1comment` char(20) default NULL,
  `phone2` char(20) default NULL,
  `phone2comment` char(20) default NULL,
  `phone3` char(20) default NULL,
  `phone3comment` char(20) default NULL,
  `phone4` char(20) default NULL,
  `phone4comment` char(20) default NULL,
  `email1` char(50) default NULL,
  `email1comment` char(20) default NULL,
  `email2` char(50) default NULL,
  `email2comment` char(20) default NULL,
  `website` char(100) default NULL,
  `federalid` char(20) default NULL,
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `printlocation` int(2) NOT NULL default '0',
  `freighttax` int(5) NOT NULL default '0',
  `argl` int(11) NOT NULL default '0',
  `locationcode` varchar(20) NOT NULL default '',
  `defaultcostcodeid` int(11) NOT NULL default '0',
  `distributioncenter` tinyint(1) NOT NULL default '0',
  `distributioncenterrentals` tinyint(1) NOT NULL default '0',
  `emailtransferpurchaserequest` varchar(255) NOT NULL default '',
  `defaultcheckacctid` int(11) NOT NULL default '0',
  `ardailyclosedepositseperateamex` tinyint(1) NOT NULL default '0',
  `ardailyclosedepositseperatevisa` tinyint(1) NOT NULL default '0',
  `ardailyclosecashdrawerfloatglid` int(11) NOT NULL default '0',
  `ardailyclosedefaultdepositcheckacctid` int(11) NOT NULL default '0',
  `excludefromphysicalcounts` tinyint(1) NOT NULL default '0',
  `ardailyclosedepositseperatemc` tinyint(1) NOT NULL default '0',
  `ardailyclosedepositseperatediscover` tinyint(1) NOT NULL default '0',
  `ardailyclosedepositseperateccother` tinyint(1) NOT NULL default '0',
  `emailtransfernotice` varchar(255) NOT NULL default '',
  `dcinventorylocationid` int(11) NOT NULL default '0',
  `dcrentalsinventorylocationid` int(11) NOT NULL default '0',
  `usewalkintaxesforordersinstate` tinyint(4) NOT NULL default '0',
  `notaxesforordersoutsidestate` tinyint(4) NOT NULL default '0',
  `salesregionid` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`),
  KEY `compactive` (`cancel`,`gencompanyid`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventorylocation`
--

LOCK TABLES `inventorylocation` WRITE;
/*!40000 ALTER TABLE `inventorylocation` DISABLE KEYS */;
INSERT INTO `inventorylocation` VALUES (1,'default location','','',NULL,'','','','',NULL,0,0,0,0,'','','','','','',NULL,'',NULL,'',NULL,'',NULL,'',NULL,NULL,NULL,'',NULL,0,NULL,NULL,NULL,NULL,'2007-09-21 14:19:40',NULL,1,1,0,0,'',0,0,0,'',0,0,0,0,0,0,0,0,0,'',0,0,0,0,0);
/*!40000 ALTER TABLE `inventorylocation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventorylocationseq`
--

DROP TABLE IF EXISTS `inventorylocationseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `inventorylocationseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventorylocationseq`
--

LOCK TABLES `inventorylocationseq` WRITE;
/*!40000 ALTER TABLE `inventorylocationseq` DISABLE KEYS */;
INSERT INTO `inventorylocationseq` VALUES (1);
/*!40000 ALTER TABLE `inventorylocationseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invintercompany`
--

DROP TABLE IF EXISTS `invintercompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invintercompany` (
  `id` int(11) NOT NULL auto_increment,
  `sourcecompanyid` int(11) NOT NULL default '0',
  `othercompanyid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `pricelevelid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `sourcecompanyid` (`sourcecompanyid`),
  KEY `othercompanyid` (`othercompanyid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invintercompany`
--

LOCK TABLES `invintercompany` WRITE;
/*!40000 ALTER TABLE `invintercompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `invintercompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invitemcatseason`
--

DROP TABLE IF EXISTS `invitemcatseason`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invitemcatseason` (
  `id` int(11) NOT NULL auto_increment,
  `itemcategoryid` int(11) NOT NULL default '0',
  `seasonname` char(50) default NULL,
  `seasonbegin` int(11) NOT NULL default '0',
  `seasonend` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `itemcategoryid` (`itemcategoryid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invitemcatseason`
--

LOCK TABLES `invitemcatseason` WRITE;
/*!40000 ALTER TABLE `invitemcatseason` DISABLE KEYS */;
/*!40000 ALTER TABLE `invitemcatseason` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invnotification`
--

DROP TABLE IF EXISTS `invnotification`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invnotification` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `email` varchar(255) NOT NULL default '',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `sent` int(2) NOT NULL default '0',
  `sentdate` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`),
  KEY `customerid` (`customerid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invnotification`
--

LOCK TABLES `invnotification` WRITE;
/*!40000 ALTER TABLE `invnotification` DISABLE KEYS */;
/*!40000 ALTER TABLE `invnotification` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoiceterms`
--

DROP TABLE IF EXISTS `invoiceterms`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invoiceterms` (
  `id` int(11) NOT NULL auto_increment,
  `verbal` char(30) default NULL,
  `discountpercent` decimal(6,3) NOT NULL default '0.000',
  `discountdays` int(11) NOT NULL default '0',
  `discountdayofmonth` int(11) NOT NULL default '0',
  `netduedays` int(11) NOT NULL default '0',
  `ar` int(11) NOT NULL default '0',
  `ap` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `netduedayfollowing` int(5) NOT NULL default '0',
  `discountdayfollowing` int(11) NOT NULL default '0',
  `endofmonth` int(5) NOT NULL default '0',
  `endofmonthDiscount` int(5) NOT NULL default '0',
  `dayofmonthprox` int(5) NOT NULL default '0',
  `monthcloseday` int(5) NOT NULL default '0',
  `netdueday2following` int(5) NOT NULL default '0',
  `monthsdiscount` int(5) NOT NULL default '0',
  `monthsdue` int(5) NOT NULL default '0',
  `preapproved_paydate` varchar(15) NOT NULL default '',
  `cashondelivery` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ar` (`ar`),
  KEY `ap` (`ap`)
) ENGINE=InnoDB AUTO_INCREMENT=22 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invoiceterms`
--

LOCK TABLES `invoiceterms` WRITE;
/*!40000 ALTER TABLE `invoiceterms` DISABLE KEYS */;
INSERT INTO `invoiceterms` VALUES (2,'As Agreed','0.000',0,0,0,1,0,0,NULL,NULL,NULL,NULL,'2013-02-21 14:13:52',NULL,0,0,0,0,0,0,0,0,0,'',0),(3,'C.O.D.','0.000',0,0,0,1,0,0,NULL,NULL,NULL,NULL,'2013-02-21 14:13:52',NULL,0,0,0,0,0,0,0,0,0,'',0),(4,'Cash','0.000',0,0,0,1,0,0,NULL,NULL,NULL,NULL,'2013-02-21 14:13:52',NULL,0,0,0,0,0,0,0,0,0,'',0),(5,'Credit Card','0.000',0,0,0,1,0,0,NULL,NULL,NULL,NULL,'2013-02-21 14:13:52',NULL,0,0,0,0,0,0,0,0,0,'',0),(6,'Net 10 Days','0.000',0,0,10,1,0,0,NULL,NULL,NULL,NULL,'2013-02-21 14:13:52',NULL,0,0,0,0,0,0,0,0,0,'',0),(7,'Net 15 Days','0.000',0,0,15,1,0,0,NULL,NULL,NULL,NULL,'2013-02-21 14:13:52',NULL,0,0,0,0,0,0,0,0,0,'',0),(8,'Net 30 Days','0.000',0,0,30,1,0,0,NULL,NULL,NULL,NULL,'2013-04-11 14:27:02',NULL,0,0,0,0,0,0,0,0,0,'',0),(9,'2% NET 10','2.000',0,0,10,1,0,0,NULL,NULL,NULL,NULL,'2013-04-11 14:27:02',NULL,0,0,0,0,0,0,0,0,0,'',0),(10,'2% NET 15','2.000',0,0,15,1,0,0,NULL,NULL,NULL,NULL,'2013-04-11 14:27:02',NULL,0,0,0,0,0,0,0,0,0,'',0),(11,'2% NET 30','2.000',0,0,30,1,0,0,NULL,NULL,NULL,NULL,'2013-04-11 14:27:02',NULL,0,0,0,0,0,0,0,0,0,'',0),(12,'PayPal','0.000',0,0,0,1,0,0,NULL,NULL,NULL,NULL,'2013-02-21 14:13:52',NULL,0,0,0,0,0,0,0,0,0,'',0),(13,'Prepaid','0.000',0,0,0,1,0,0,NULL,NULL,NULL,NULL,'2013-02-21 14:13:52',NULL,0,0,0,0,0,0,0,0,0,'',0),(14,'Upon Receipt','0.000',0,0,0,1,0,0,NULL,NULL,NULL,NULL,'2013-02-21 14:13:52',NULL,0,0,0,0,0,0,0,0,0,'',0),(15,'Net 10 Days','0.000',0,0,10,0,1,0,NULL,NULL,'2004-08-10 15:47:24',1,'2036-07-23 16:33:16',1,0,0,0,0,0,0,0,0,0,'',0),(17,'Net 15 Days','0.000',0,0,15,0,1,0,NULL,NULL,'2004-08-10 15:48:19',1,'2036-07-23 16:34:11',1,0,0,0,0,0,0,0,0,0,'',0),(18,'Net 20 Days','0.000',0,0,20,0,1,0,NULL,NULL,'2004-08-10 15:48:45',1,'2036-07-23 16:34:37',1,0,0,0,0,0,0,0,0,0,'',0),(19,'Net 25 Days','0.000',0,0,25,0,1,0,NULL,NULL,'2004-08-10 15:48:55',1,'2036-07-23 16:34:47',1,0,0,0,0,0,0,0,0,0,'',0),(20,'Net 30 Days','0.000',0,0,30,0,1,0,NULL,NULL,'2004-08-17 15:29:41',1,'2036-07-30 16:15:33',1,0,0,0,0,0,0,0,0,0,'',0),(21,'Upon Receipt','0.000',0,0,0,0,1,0,NULL,NULL,'2005-06-09 11:40:44',1,'2005-06-09 15:40:44',1,0,0,0,0,0,0,0,0,0,'',0);
/*!40000 ALTER TABLE `invoiceterms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoicetext`
--

DROP TABLE IF EXISTS `invoicetext`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invoicetext` (
  `id` int(11) NOT NULL default '0',
  `textleft1` varchar(100) NOT NULL default '',
  `textleft2` varchar(100) NOT NULL default '',
  `textleft3` varchar(100) NOT NULL default '',
  `textleft4` varchar(100) NOT NULL default '',
  `textleft5` varchar(100) NOT NULL default '',
  `textrt1` varchar(100) NOT NULL default '',
  `textrt2` varchar(100) NOT NULL default '',
  `textrt3` varchar(100) NOT NULL default '',
  `textrt4` varchar(100) NOT NULL default '',
  `textrt5` varchar(100) NOT NULL default '',
  `textcenter` varchar(100) NOT NULL default '',
  `textwebsite` varchar(150) NOT NULL default '',
  `textundertotal` varchar(100) NOT NULL default '',
  `textundertotal2` varchar(100) NOT NULL default '',
  `textrt6` varchar(100) NOT NULL default '',
  `textqtyunitcol` varchar(20) NOT NULL default '',
  `textunderstatement` varchar(100) NOT NULL default ''
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invoicetext`
--

LOCK TABLES `invoicetext` WRITE;
/*!40000 ALTER TABLE `invoicetext` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoicetext` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invpo`
--

DROP TABLE IF EXISTS `invpo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invpo` (
  `id` int(11) NOT NULL auto_increment,
  `vendorid` int(11) NOT NULL default '0',
  `ponumber` varchar(20) NOT NULL default '',
  `duedate` date default NULL,
  `locationid` int(11) NOT NULL default '0',
  `carrierserviceid` int(11) default NULL,
  `tracknumber` varchar(50) default NULL,
  `contact` varchar(20) default NULL,
  `requisition` varchar(22) default NULL,
  `ordernumber` varchar(20) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `complete` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `referenceid` int(11) NOT NULL default '0',
  `notes` text,
  `initials` varchar(255) default '',
  `status` int(11) default '0',
  `description` varchar(255) default '',
  `wherefrom` int(11) NOT NULL default '0',
  `salesordernumber` varchar(20) default NULL,
  `dropship` int(5) NOT NULL default '0',
  `shiptoid` int(11) NOT NULL default '0',
  `salesorderid` int(11) NOT NULL default '0',
  `paytermsid` int(11) NOT NULL default '0',
  `ccpurchaseid` int(11) NOT NULL default '0',
  `potype` int(5) NOT NULL default '0',
  `stageid` int(11) NOT NULL default '0',
  `sb` int(5) NOT NULL default '0',
  `recipient_userid` int(11) NOT NULL default '0',
  `jobid` int(11) NOT NULL default '0',
  `totaltax` decimal(19,5) NOT NULL default '0.00000',
  `main_invpoid` int(11) NOT NULL default '0',
  `prior_invpoid` int(11) NOT NULL default '0',
  `retainage` decimal(12,2) NOT NULL default '0.00',
  `fob` char(2) NOT NULL default '',
  `chargeback` int(5) NOT NULL default '0',
  `chargeback_vendorid` int(5) NOT NULL default '0',
  `chargeback_invpoid` int(5) NOT NULL default '0',
  `chargeback_percent` decimal(5,2) NOT NULL default '0.00',
  `pototal` decimal(19,6) NOT NULL default '0.000000',
  `currency` varchar(10) NOT NULL default 'USD',
  `currate` decimal(22,10) NOT NULL default '1.0000000000',
  `taxrate` decimal(6,2) NOT NULL default '0.00',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `vendor_orderfromid` int(11) NOT NULL default '0',
  `rtvnumber` varchar(45) NOT NULL default '',
  `headernote` text NOT NULL,
  `return_from_invpoid` int(11) NOT NULL default '0',
  `donotupdatelastpocost` tinyint(1) NOT NULL default '0',
  `address1` varchar(100) NOT NULL default '',
  `address2` varchar(100) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  `state` varchar(20) NOT NULL default '',
  `zip` varchar(15) NOT NULL default '',
  `shipname` varchar(50) NOT NULL default '',
  `customerdropshiptoid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ponumber` (`ponumber`),
  KEY `referenceid` (`referenceid`),
  KEY `vendorid` (`vendorid`),
  KEY `wherefrom` (`wherefrom`),
  KEY `dropship` (`dropship`),
  KEY `salesorderid` (`salesorderid`),
  KEY `shiptoid` (`shiptoid`),
  KEY `ccpurchaseid` (`ccpurchaseid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `main_invpoid` (`main_invpoid`),
  KEY `prior_invpoid` (`prior_invpoid`),
  KEY `main_gltr_jobid` (`jobid`),
  KEY `potype` (`potype`),
  KEY `sb` (`sb`),
  KEY `cancel` (`cancel`),
  KEY `complete` (`complete`),
  KEY `status` (`status`),
  KEY `stageid` (`stageid`),
  KEY `locationid` (`locationid`),
  KEY `duedate` (`duedate`),
  KEY `carrierserviceid` (`carrierserviceid`),
  KEY `entrydate` (`entrydate`),
  KEY `gltr_costcodeid` (`costcodeid`),
  KEY `glcategoryid` (`glcategoryid`),
  KEY `pototal` (`pototal`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invpo`
--

LOCK TABLES `invpo` WRITE;
/*!40000 ALTER TABLE `invpo` DISABLE KEYS */;
/*!40000 ALTER TABLE `invpo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invpodetail`
--

DROP TABLE IF EXISTS `invpodetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invpodetail` (
  `id` int(11) NOT NULL auto_increment,
  `invpoid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `itemqty` decimal(18,6) NOT NULL default '0.000000',
  `itemprice` decimal(19,6) NOT NULL default '0.000000',
  `detail_description` varchar(255) default NULL,
  `linenumber` int(11) NOT NULL default '0',
  `inv_glacct` double NOT NULL default '0',
  `conversion` decimal(12,6) NOT NULL default '1.000000',
  `itemvendorid` int(11) NOT NULL default '0',
  `purchaseunitid` int(11) NOT NULL default '0',
  `itempriceqty` decimal(19,5) NOT NULL default '0.00000',
  `notes` varchar(500) default NULL,
  `jobid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `taxable` int(5) NOT NULL default '0',
  `detailrow` int(11) NOT NULL default '0',
  `tax` decimal(19,6) NOT NULL default '0.000000',
  `reqshipdate` date default NULL,
  `accepted` tinyint(4) NOT NULL default '0',
  `arorderdetailid` int(11) NOT NULL default '0',
  `donotupdatelastpocost` tinyint(1) NOT NULL default '0',
  `linetype` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invpoid` (`invpoid`),
  KEY `itemid` (`itemid`),
  KEY `gltr_jobid` (`jobid`),
  KEY `gltr_costcodeid` (`costcodeid`),
  KEY `gltr_categoryid` (`glcategoryid`),
  KEY `itemvendorid` (`itemvendorid`),
  KEY `purchaseunitid` (`purchaseunitid`),
  KEY `arorderdetailid` (`arorderdetailid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invpodetail`
--

LOCK TABLES `invpodetail` WRITE;
/*!40000 ALTER TABLE `invpodetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `invpodetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invpodetailreturn`
--

DROP TABLE IF EXISTS `invpodetailreturn`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invpodetailreturn` (
  `id` int(11) NOT NULL auto_increment,
  `originvpodetailid` int(11) NOT NULL default '0',
  `returninvpodetailid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `originvpodetailid` (`originvpodetailid`),
  KEY `returninvpodetailid` (`returninvpodetailid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invpodetailreturn`
--

LOCK TABLES `invpodetailreturn` WRITE;
/*!40000 ALTER TABLE `invpodetailreturn` DISABLE KEYS */;
/*!40000 ALTER TABLE `invpodetailreturn` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invponotes`
--

DROP TABLE IF EXISTS `invponotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invponotes` (
  `id` int(11) NOT NULL auto_increment,
  `invpoid` int(11) NOT NULL default '0',
  `linenumber` int(11) NOT NULL default '0',
  `note` text,
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `source_noteid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invpoid` (`invpoid`),
  KEY `linenumber` (`linenumber`),
  KEY `source_noteid` (`source_noteid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invponotes`
--

LOCK TABLES `invponotes` WRITE;
/*!40000 ALTER TABLE `invponotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `invponotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invpoquote`
--

DROP TABLE IF EXISTS `invpoquote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invpoquote` (
  `id` int(11) NOT NULL auto_increment,
  `invpoid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `invpodetailid` int(11) NOT NULL default '0',
  `itemqty` decimal(18,6) NOT NULL default '0.000000',
  `itemprice` decimal(12,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`),
  KEY `invpoid` (`invpoid`),
  KEY `vendorid` (`vendorid`),
  KEY `invpodetailid` (`invpodetailid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invpoquote`
--

LOCK TABLES `invpoquote` WRITE;
/*!40000 ALTER TABLE `invpoquote` DISABLE KEYS */;
/*!40000 ALTER TABLE `invpoquote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invporeturn`
--

DROP TABLE IF EXISTS `invporeturn`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invporeturn` (
  `id` int(11) NOT NULL auto_increment,
  `originvpoid` int(11) NOT NULL default '0',
  `returninvpoid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `originvpoid` (`originvpoid`),
  KEY `returninvpoid` (`returninvpoid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invporeturn`
--

LOCK TABLES `invporeturn` WRITE;
/*!40000 ALTER TABLE `invporeturn` DISABLE KEYS */;
/*!40000 ALTER TABLE `invporeturn` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invpostdnotes`
--

DROP TABLE IF EXISTS `invpostdnotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invpostdnotes` (
  `id` int(11) NOT NULL auto_increment,
  `shortnote` varchar(50) default NULL,
  `full_note` text,
  `sortorder` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `sortorder` (`sortorder`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invpostdnotes`
--

LOCK TABLES `invpostdnotes` WRITE;
/*!40000 ALTER TABLE `invpostdnotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `invpostdnotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invreceive`
--

DROP TABLE IF EXISTS `invreceive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invreceive` (
  `id` int(11) NOT NULL auto_increment,
  `invreceivemainid` int(11) NOT NULL default '0',
  `recsource` int(11) NOT NULL default '0',
  `invpoid` int(11) NOT NULL default '0',
  `receivedate` datetime default NULL,
  `itemid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `locationid` int(11) NOT NULL default '0',
  `itemqty` decimal(18,6) default '0.000000',
  `itemprice` decimal(19,6) NOT NULL default '0.000000',
  `itemqtyused` decimal(18,6) default '0.000000',
  `itemqtydamaged` decimal(18,6) default '0.000000',
  `conversion` decimal(12,6) NOT NULL default '1.000000',
  `track` varchar(30) default NULL,
  `receiveunitnameid` int(11) NOT NULL default '0',
  `passtoap` int(11) NOT NULL default '0',
  `apbillid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `invpodetailid` int(11) NOT NULL default '0',
  `lastchangeuserid` int(11) default NULL,
  `status` int(2) NOT NULL default '0',
  `initials` varchar(255) default '',
  `recnotes` text,
  `itempriceqty` decimal(12,6) NOT NULL default '0.000000',
  `jobid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `currency` varchar(10) NOT NULL default 'USD',
  `currate` decimal(22,10) NOT NULL default '1.0000000000',
  `voucherid` int(11) NOT NULL default '0',
  `accruedvoucherid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`),
  KEY `invpoid` (`invpoid`),
  KEY `voucherid` (`voucherid`),
  KEY `vendorid` (`vendorid`),
  KEY `locationid` (`locationid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `cancel` (`cancel`),
  KEY `invreceivemainid` (`invreceivemainid`),
  KEY `invpodetailid` (`invpodetailid`),
  KEY `apbillid` (`apbillid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invreceive`
--

LOCK TABLES `invreceive` WRITE;
/*!40000 ALTER TABLE `invreceive` DISABLE KEYS */;
/*!40000 ALTER TABLE `invreceive` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invreceivemain`
--

DROP TABLE IF EXISTS `invreceivemain`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invreceivemain` (
  `id` int(11) NOT NULL auto_increment,
  `invpoid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `receivedate` datetime default NULL,
  `inventorylocationid` int(11) NOT NULL default '0',
  `stagingareaid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `invpoid` (`invpoid`),
  KEY `vendorid` (`vendorid`),
  KEY `receivedate` (`receivedate`),
  KEY `inventorylocationid` (`inventorylocationid`),
  KEY `stagingareaid` (`stagingareaid`),
  KEY `cancelco` (`cancel`,`gencompanyid`),
  KEY `entrydate` (`entrydate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invreceivemain`
--

LOCK TABLES `invreceivemain` WRITE;
/*!40000 ALTER TABLE `invreceivemain` DISABLE KEYS */;
/*!40000 ALTER TABLE `invreceivemain` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invreceiveseq`
--

DROP TABLE IF EXISTS `invreceiveseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invreceiveseq` (
  `id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invreceiveseq`
--

LOCK TABLES `invreceiveseq` WRITE;
/*!40000 ALTER TABLE `invreceiveseq` DISABLE KEYS */;
/*!40000 ALTER TABLE `invreceiveseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invrecieveseq`
--

DROP TABLE IF EXISTS `invrecieveseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invrecieveseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invrecieveseq`
--

LOCK TABLES `invrecieveseq` WRITE;
/*!40000 ALTER TABLE `invrecieveseq` DISABLE KEYS */;
/*!40000 ALTER TABLE `invrecieveseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invserialnumber`
--

DROP TABLE IF EXISTS `invserialnumber`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invserialnumber` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `serialnumber` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `serialnumber` (`serialnumber`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invserialnumber`
--

LOCK TABLES `invserialnumber` WRITE;
/*!40000 ALTER TABLE `invserialnumber` DISABLE KEYS */;
/*!40000 ALTER TABLE `invserialnumber` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invserialnumbertransaction`
--

DROP TABLE IF EXISTS `invserialnumbertransaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invserialnumbertransaction` (
  `id` int(11) NOT NULL auto_increment,
  `invserialnumberid` int(11) NOT NULL default '0',
  `reftable` varchar(64) NOT NULL default '',
  `refid` int(11) NOT NULL default '0',
  `reftag` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  PRIMARY KEY  (`id`),
  KEY `serialnumberid` (`invserialnumberid`),
  KEY `ref` (`reftable`,`refid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invserialnumbertransaction`
--

LOCK TABLES `invserialnumbertransaction` WRITE;
/*!40000 ALTER TABLE `invserialnumbertransaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `invserialnumbertransaction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invtransfer`
--

DROP TABLE IF EXISTS `invtransfer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invtransfer` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `costeach` decimal(19,6) NOT NULL default '0.000000',
  `gencompanyid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `onhand` decimal(19,6) NOT NULL default '0.000000',
  `onhandchecked` int(11) NOT NULL default '0',
  `description` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`),
  KEY `inventorylocationid` (`inventorylocationid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `entrydate` (`entrydate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invtransfer`
--

LOCK TABLES `invtransfer` WRITE;
/*!40000 ALTER TABLE `invtransfer` DISABLE KEYS */;
/*!40000 ALTER TABLE `invtransfer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invzone`
--

DROP TABLE IF EXISTS `invzone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invzone` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(255) default NULL,
  `description` text,
  `inventorylocationid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `code_comp` (`code`,`gencompanyid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invzone`
--

LOCK TABLES `invzone` WRITE;
/*!40000 ALTER TABLE `invzone` DISABLE KEYS */;
/*!40000 ALTER TABLE `invzone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `irs1099`
--

DROP TABLE IF EXISTS `irs1099`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `irs1099` (
  `id` int(11) NOT NULL auto_increment,
  `taxyear` int(11) NOT NULL default '0',
  `line` varchar(10) default NULL,
  `description` varchar(255) default NULL,
  `fieldtype` char(1) default NULL,
  PRIMARY KEY  (`id`),
  KEY `taxyearline` (`taxyear`,`line`)
) ENGINE=InnoDB AUTO_INCREMENT=23 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `irs1099`
--

LOCK TABLES `irs1099` WRITE;
/*!40000 ALTER TABLE `irs1099` DISABLE KEYS */;
INSERT INTO `irs1099` VALUES (1,2010,'1','Rents','T'),(2,2010,'2','Royalties','T'),(3,2010,'3','Other income','T'),(4,2010,'4','Federal income tax withheld','T'),(5,2010,'5','Fishing boat proceeds','T'),(6,2010,'6','Medical and health care payments','T'),(7,2010,'7','Nonemployee compensation','T'),(8,2010,'8','Substitute payments in lieu of','T'),(9,2010,'9','Payer made direct sales of','C'),(10,2010,'10','Crop insurance proceeds','T'),(11,2010,'11','Foreign tax paid','T'),(12,2010,'12','Foreign country or US possession','T'),(13,2010,'13','Excess golden parachute','T'),(14,2010,'14','Gross proceeds paid to','T'),(15,2010,'15a','Section 409A deferrals','T'),(16,2010,'15b','Section 409A income','T'),(17,2010,'16','State tax withheld','T'),(18,2010,'17','State/Payer\'s state no.','T'),(19,2010,'18','State income','T'),(20,2010,'16-2','State 2 tax withheld','T'),(21,2010,'17-2','State/Payer\'s state 2 no.','T'),(22,2010,'18-2','State 2 income','T');
/*!40000 ALTER TABLE `irs1099` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `irs1099vendor`
--

DROP TABLE IF EXISTS `irs1099vendor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `irs1099vendor` (
  `id` int(11) NOT NULL auto_increment,
  `taxyear` int(11) NOT NULL default '0',
  `line` varchar(10) default NULL,
  `vendorid` int(11) NOT NULL default '0',
  `linevalue` varchar(50) default NULL,
  PRIMARY KEY  (`id`),
  KEY `taxyearline` (`taxyear`,`line`),
  KEY `vendorid` (`vendorid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `irs1099vendor`
--

LOCK TABLES `irs1099vendor` WRITE;
/*!40000 ALTER TABLE `irs1099vendor` DISABLE KEYS */;
/*!40000 ALTER TABLE `irs1099vendor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item`
--

DROP TABLE IF EXISTS `item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item` (
  `id` int(11) NOT NULL auto_increment,
  `itemcode` varchar(30) default NULL,
  `compositeitemyesno` int(11) NOT NULL default '0',
  `description` varchar(100) NOT NULL default '',
  `categoryid` int(11) NOT NULL default '0',
  `stockunitnameid` int(11) NOT NULL default '0',
  `priceunitnameid` int(11) NOT NULL default '0',
  `lbsperpriceunit` double NOT NULL default '0',
  `priceunitsperstockunit` decimal(19,10) NOT NULL default '0.0000000000',
  `stockunitsperpriceunit` decimal(19,6) NOT NULL default '0.000000',
  `inventoryglacctid` int(11) NOT NULL default '0',
  `salesglacctid` int(11) NOT NULL default '0',
  `width` double default '0',
  `length` double default '0',
  `mwt` double default '0',
  `cogs` double default '0',
  `cogseffectivedate` datetime default '0000-00-00 00:00:00',
  `middlemanprice` double default '0',
  `price` double default '0',
  `priceeffectivedate` datetime default '0000-00-00 00:00:00',
  `status` int(11) default '0',
  `id_item_useinstead` varchar(100) default '',
  `invtype` int(11) default '0',
  `inventorytype` char(1) NOT NULL default 'S',
  `catalogdescription` text,
  `products_website` varchar(255) NOT NULL default '',
  `catalogsheeturl` varchar(200) default NULL,
  `graphicurl` varchar(200) default NULL,
  `pdffile` varchar(200) NOT NULL default '',
  `videofile` varchar(200) NOT NULL default '',
  `soundfile` varchar(200) NOT NULL default '',
  `companyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `products_quantity` int(4) default '0',
  `products_viewed` int(5) default '0',
  `products_status` tinyint(1) default '0',
  `products_tax_class_id` int(5) default '0',
  `products_costprice` decimal(8,2) default '0.00',
  `products_pushup` decimal(4,2) default '0.00',
  `scart` int(2) NOT NULL default '0',
  `scart_front_page` int(11) NOT NULL default '0',
  `parentitemid` int(11) NOT NULL default '0',
  `scart_minqtydisplay` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `taxexempt` int(2) NOT NULL default '0',
  `caliper` decimal(10,4) NOT NULL default '0.0000',
  `upc` varchar(255) default NULL,
  `author` varchar(100) default NULL,
  `notes` text,
  `b2b_block` int(5) NOT NULL default '0',
  `pos_block` int(5) NOT NULL default '0',
  `gbaseid` varchar(100) NOT NULL default '',
  `gbasedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `commissionflat` decimal(19,6) NOT NULL default '0.000000',
  `commissionpercent` decimal(7,2) NOT NULL default '0.00',
  `staticcost` decimal(19,5) NOT NULL default '0.00000',
  `minpm` decimal(6,2) NOT NULL default '0.00',
  `restockdate` date default NULL,
  `customerid` int(11) NOT NULL default '0',
  `mobile_pos` tinyint(2) default '0' COMMENT '-1 = Hide\n 0 = Default (use item-category settings)\n 1 = Always Show',
  `listonebay` tinyint(1) NOT NULL default '0',
  `shipsbyitself` tinyint(4) NOT NULL default '0',
  `shiplength` decimal(7,2) NOT NULL default '0.00',
  `shipwidth` decimal(7,2) NOT NULL default '0.00',
  `shipheight` decimal(7,2) NOT NULL default '0.00',
  `notforsale` tinyint(4) NOT NULL default '0',
  `last3dcartstockupdate` datetime default NULL,
  `taxclassid` int(11) NOT NULL default '0',
  `shippingmarkup` decimal(19,6) NOT NULL default '0.000000',
  `rental` tinyint(4) NOT NULL default '0',
  `rental_d` tinyint(1) NOT NULL default '1',
  `rental_w` tinyint(1) NOT NULL default '1',
  `transfershortglaccountid` int(11) NOT NULL default '0',
  `unnumber` varchar(255) NOT NULL default '',
  `pickernotes` text,
  `rentalconverttosalear` int(11) NOT NULL default '0',
  `rentalconverttosalecogs` int(11) NOT NULL default '0',
  `returnsglaccountid` int(11) NOT NULL default '0',
  `nochargeglaccountid` int(11) NOT NULL default '0',
  `rebateglaccountid` int(11) NOT NULL default '0',
  `accruedpurchasesglid` int(11) NOT NULL default '0',
  `internalbuynotes` text,
  `internalsellnotes` text,
  `expiredays` int(11) NOT NULL default '0',
  `rental_m` tinyint(1) NOT NULL default '1',
  `defaultlinenote` text,
  `lockpricecost` tinyint(1) NOT NULL default '0',
  `commoditycode` varchar(10) NOT NULL default '',
  `prelimable` tinyint(1) NOT NULL default '1',
  `buyeruserid` int(11) NOT NULL default '0',
  `allownegqtysalesoverride` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `companyid` (`companyid`),
  KEY `inventoryglacctid` (`inventoryglacctid`),
  KEY `itemcode` (`itemcode`),
  KEY `categoryid` (`categoryid`),
  KEY `parentitemid` (`parentitemid`),
  KEY `b2b_block` (`b2b_block`),
  KEY `pos_block` (`pos_block`),
  KEY `customerid` (`customerid`),
  KEY `cancel_status` (`cancel`,`status`),
  KEY `inventorytype` (`inventorytype`),
  KEY `rental` (`rental`),
  KEY `upc` (`upc`),
  KEY `buyeruserid` (`buyeruserid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item`
--

LOCK TABLES `item` WRITE;
/*!40000 ALTER TABLE `item` DISABLE KEYS */;
/*!40000 ALTER TABLE `item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item_group`
--

DROP TABLE IF EXISTS `item_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item_group` (
  `itemid` int(11) NOT NULL default '0',
  `groupid` int(11) NOT NULL default '0',
  `price` decimal(15,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`itemid`,`groupid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item_group`
--

LOCK TABLES `item_group` WRITE;
/*!40000 ALTER TABLE `item_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `item_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item_image`
--

DROP TABLE IF EXISTS `item_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item_image` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL,
  `name` tinytext,
  `label` text,
  `data` longblob,
  `use_as_base` tinyint(1) default NULL,
  `use_as_small` tinyint(1) default NULL,
  `use_as_thumbnail` tinyint(1) default NULL,
  `width` int(11) default NULL,
  `height` int(11) default NULL,
  `mime` tinytext,
  `exclude` tinyint(1) default NULL,
  `order` int(11) NOT NULL default '0',
  `mageid` int(11) default NULL,
  `magestoreid` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `item` (`itemid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item_image`
--

LOCK TABLES `item_image` WRITE;
/*!40000 ALTER TABLE `item_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `item_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item_image_mage`
--

DROP TABLE IF EXISTS `item_image_mage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item_image_mage` (
  `id` int(11) NOT NULL auto_increment,
  `item_image_id` int(11) default NULL,
  `magestore_id` int(11) default NULL,
  `mage_image_id` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item_image_mage`
--

LOCK TABLES `item_image_mage` WRITE;
/*!40000 ALTER TABLE `item_image_mage` DISABLE KEYS */;
/*!40000 ALTER TABLE `item_image_mage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemcategory`
--

DROP TABLE IF EXISTS `itemcategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemcategory` (
  `id` int(11) NOT NULL auto_increment,
  `companyid` int(11) NOT NULL default '0',
  `name` varchar(50) default NULL,
  `invtype` int(11) NOT NULL default '1',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `seasonname1` varchar(50) default NULL,
  `seasonname2` varchar(50) default NULL,
  `seasonname3` varchar(50) default NULL,
  `seasonname4` varchar(50) default NULL,
  `seasonbegin1` varchar(25) default NULL,
  `seasonbegin2` varchar(25) default NULL,
  `seasonbegin3` varchar(25) default NULL,
  `seasonbegin4` varchar(25) default NULL,
  `seasonend1` varchar(25) default NULL,
  `seasonend2` varchar(25) default NULL,
  `seasonend3` varchar(25) default NULL,
  `seasonend4` varchar(25) default NULL,
  `categories_image` varchar(64) default NULL,
  `parent_id` int(5) default '0',
  `is_print_order` int(11) default '0',
  `sort_order` int(3) default NULL,
  `salestaxid` int(11) NOT NULL default '0',
  `mobile_pos` tinyint(1) default '1',
  `rental` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemcategory`
--

LOCK TABLES `itemcategory` WRITE;
/*!40000 ALTER TABLE `itemcategory` DISABLE KEYS */;
INSERT INTO `itemcategory` VALUES (1,1,'standard',1,0,NULL,NULL,NULL,NULL,'2005-03-08 15:08:39',NULL,'all',NULL,NULL,NULL,'1',NULL,NULL,NULL,'12',NULL,NULL,NULL,NULL,0,0,NULL,0,1,0),(2,0,'standard',1,0,NULL,NULL,NULL,NULL,'2007-11-08 21:45:58',NULL,'all',NULL,NULL,NULL,'1',NULL,NULL,NULL,'12',NULL,NULL,NULL,NULL,0,0,NULL,0,1,0);
/*!40000 ALTER TABLE `itemcategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemcategorydiscounts`
--

DROP TABLE IF EXISTS `itemcategorydiscounts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemcategorydiscounts` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(45) NOT NULL default '',
  `pricelevelid` int(11) NOT NULL default '0',
  `markdownpercent` double NOT NULL default '0',
  `itemcategorymatch` varchar(45) NOT NULL default '',
  `companyid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `entrydate` date NOT NULL default '0000-00-00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` date NOT NULL default '0000-00-00',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `canceldate` date NOT NULL default '0000-00-00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Adjust Price Level discount by Item Category';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemcategorydiscounts`
--

LOCK TABLES `itemcategorydiscounts` WRITE;
/*!40000 ALTER TABLE `itemcategorydiscounts` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemcategorydiscounts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemcategorygl`
--

DROP TABLE IF EXISTS `itemcategorygl`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemcategorygl` (
  `id` int(11) NOT NULL auto_increment,
  `itemcategoryid` int(11) NOT NULL default '0',
  `nonstock` tinyint(1) NOT NULL default '0',
  `inventoryglacctid` int(11) NOT NULL default '0',
  `salesglaccountid` int(11) NOT NULL default '0',
  `costglaccountid` int(11) NOT NULL default '0',
  `accruedpurchasesglid` int(11) NOT NULL default '0',
  `returnsglaccountid` int(11) NOT NULL default '0',
  `nochargeglaccountid` int(11) NOT NULL default '0',
  `rebateglaccountid` int(11) NOT NULL default '0',
  `transfershortglaccountid` int(11) NOT NULL default '0',
  `rentalconverttosalear` int(11) NOT NULL default '0',
  `rentalconverttosalecogs` int(11) NOT NULL default '0',
  `inventorytype` char(1) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `itemcatid` (`itemcategoryid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemcategorygl`
--

LOCK TABLES `itemcategorygl` WRITE;
/*!40000 ALTER TABLE `itemcategorygl` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemcategorygl` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemcattocustomergroupdiscount`
--

DROP TABLE IF EXISTS `itemcattocustomergroupdiscount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemcattocustomergroupdiscount` (
  `id` int(11) NOT NULL auto_increment,
  `itemcategory_id` int(11) NOT NULL,
  `igroup_id` int(11) NOT NULL,
  `discount` decimal(19,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemcattocustomergroupdiscount`
--

LOCK TABLES `itemcattocustomergroupdiscount` WRITE;
/*!40000 ALTER TABLE `itemcattocustomergroupdiscount` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemcattocustomergroupdiscount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemlocation`
--

DROP TABLE IF EXISTS `itemlocation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemlocation` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `onhandqty` decimal(18,6) NOT NULL default '0.000000',
  `maxstocklevelseason1` decimal(18,6) NOT NULL default '0.000000',
  `minstocklevelseason1` decimal(18,6) NOT NULL default '0.000000',
  `orderqtyseason1` decimal(18,6) NOT NULL default '0.000000',
  `maxstocklevelseason2` decimal(18,6) NOT NULL default '0.000000',
  `minstocklevelseason2` decimal(18,6) NOT NULL default '0.000000',
  `orderqtyseason2` decimal(18,6) NOT NULL default '0.000000',
  `maxstocklevelseason3` decimal(18,6) NOT NULL default '0.000000',
  `minstocklevelseason3` decimal(18,6) NOT NULL default '0.000000',
  `orderqtyseason3` decimal(18,6) NOT NULL default '0.000000',
  `maxstocklevelseason4` decimal(18,6) NOT NULL default '0.000000',
  `minstocklevelseason4` decimal(18,6) NOT NULL default '0.000000',
  `orderqtyseason4` decimal(18,6) NOT NULL default '0.000000',
  `markupsetid` int(11) NOT NULL default '0',
  `firstcost` decimal(19,6) NOT NULL default '0.000000',
  `midcost` decimal(19,6) NOT NULL default '0.000000',
  `lastcost` decimal(19,6) NOT NULL default '0.000000',
  `wacost` decimal(19,6) NOT NULL default '0.000000',
  `firstqty` decimal(18,6) NOT NULL default '0.000000',
  `midqty` decimal(18,6) NOT NULL default '0.000000',
  `lastqty` decimal(18,6) NOT NULL default '0.000000',
  `waqty` decimal(18,6) NOT NULL default '0.000000',
  `lastpocost` decimal(18,6) NOT NULL default '0.000000',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `bin_shelf` varchar(64) default NULL,
  `lastcounted` datetime default NULL,
  `purchaseremotely` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `markupsetid` (`markupsetid`),
  KEY `itemid` (`itemid`),
  KEY `inventorylocationid` (`inventorylocationid`),
  KEY `bin_shelf` (`bin_shelf`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemlocation`
--

LOCK TABLES `itemlocation` WRITE;
/*!40000 ALTER TABLE `itemlocation` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemlocation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemoption`
--

DROP TABLE IF EXISTS `itemoption`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemoption` (
  `id` int(11) NOT NULL auto_increment,
  `itemoptiongroupid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `optioncode` varchar(50) NOT NULL default '',
  `price` decimal(12,6) NOT NULL default '0.000000',
  `cost` decimal(12,6) NOT NULL default '0.000000',
  `minqty` decimal(18,6) NOT NULL default '1.000000',
  `maxqty` decimal(18,6) NOT NULL default '1.000000',
  `mainind` int(2) NOT NULL default '0',
  `rounding` int(2) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `priceunitnameid` int(11) NOT NULL default '0',
  `salesunitnameid` int(11) NOT NULL default '0',
  `saleunitperpriceunit` decimal(7,2) NOT NULL default '1.00',
  `lbsperpriceunit` double NOT NULL default '0',
  `defaultvalue` decimal(12,6) NOT NULL default '1.000000',
  `defaultoption` int(2) NOT NULL default '0',
  `displayorder` int(11) NOT NULL default '0',
  `taxable` int(2) NOT NULL default '0',
  `salesglaccountid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`),
  KEY `priceunitnameid` (`priceunitnameid`),
  KEY `salesunitnameid` (`salesunitnameid`),
  KEY `salesglaccountid` (`salesglaccountid`),
  KEY `itemoptiongroupid` (`itemoptiongroupid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemoption`
--

LOCK TABLES `itemoption` WRITE;
/*!40000 ALTER TABLE `itemoption` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemoption` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemoptiongroup`
--

DROP TABLE IF EXISTS `itemoptiongroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemoptiongroup` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `optiontype` enum('select','radio','checkbox','text') NOT NULL default 'select',
  `allowblank` int(2) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `default` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemoptiongroup`
--

LOCK TABLES `itemoptiongroup` WRITE;
/*!40000 ALTER TABLE `itemoptiongroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemoptiongroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemoptiongroupitem`
--

DROP TABLE IF EXISTS `itemoptiongroupitem`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemoptiongroupitem` (
  `id` int(11) NOT NULL auto_increment,
  `itemoptiongroupid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `sortorder` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`),
  KEY `itemoptiongroupid` (`itemoptiongroupid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemoptiongroupitem`
--

LOCK TABLES `itemoptiongroupitem` WRITE;
/*!40000 ALTER TABLE `itemoptiongroupitem` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemoptiongroupitem` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itempricespecial`
--

DROP TABLE IF EXISTS `itempricespecial`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itempricespecial` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `jobid` int(11) NOT NULL default '0',
  `description` text NOT NULL,
  `inventorylocationid` int(11) NOT NULL default '0',
  `begindate` datetime default NULL,
  `enddate` datetime default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `static` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `customer` (`customerid`,`cancel`),
  KEY `job` (`jobid`,`cancel`),
  KEY `location` (`inventorylocationid`,`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itempricespecial`
--

LOCK TABLES `itempricespecial` WRITE;
/*!40000 ALTER TABLE `itempricespecial` DISABLE KEYS */;
/*!40000 ALTER TABLE `itempricespecial` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itempricespecialchange`
--

DROP TABLE IF EXISTS `itempricespecialchange`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itempricespecialchange` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `itempricespecialid` int(11) NOT NULL default '0',
  `staticcostold` decimal(18,6) default NULL,
  `staticcostnew` decimal(18,6) default NULL,
  `priceold` decimal(18,6) default NULL,
  `pricenew` decimal(18,6) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itempricespecialchange`
--

LOCK TABLES `itempricespecialchange` WRITE;
/*!40000 ALTER TABLE `itempricespecialchange` DISABLE KEYS */;
/*!40000 ALTER TABLE `itempricespecialchange` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itempricespecialdetail`
--

DROP TABLE IF EXISTS `itempricespecialdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itempricespecialdetail` (
  `id` int(11) NOT NULL auto_increment,
  `itempricespecialid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `price` decimal(18,6) NOT NULL default '0.000000',
  `margin` decimal(18,6) NOT NULL default '0.000000',
  `mincost` decimal(18,6) NOT NULL default '0.000000',
  `notes` varchar(255) NOT NULL default '',
  `begindate` date default NULL,
  `enddate` date default NULL,
  PRIMARY KEY  (`id`),
  KEY `specific` (`itempricespecialid`,`itemid`),
  KEY `itempricespecial` (`itempricespecialid`),
  KEY `funcinvitemprice` (`itemid`,`begindate`,`enddate`,`itempricespecialid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itempricespecialdetail`
--

LOCK TABLES `itempricespecialdetail` WRITE;
/*!40000 ALTER TABLE `itempricespecialdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `itempricespecialdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemproducttypetax`
--

DROP TABLE IF EXISTS `itemproducttypetax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemproducttypetax` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `producttypetaxid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `item` (`itemid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemproducttypetax`
--

LOCK TABLES `itemproducttypetax` WRITE;
/*!40000 ALTER TABLE `itemproducttypetax` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemproducttypetax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemseq`
--

DROP TABLE IF EXISTS `itemseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemseq`
--

LOCK TABLES `itemseq` WRITE;
/*!40000 ALTER TABLE `itemseq` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemstaticcosthistory`
--

DROP TABLE IF EXISTS `itemstaticcosthistory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemstaticcosthistory` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `staticcost` decimal(19,5) default NULL,
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemstaticcosthistory`
--

LOCK TABLES `itemstaticcosthistory` WRITE;
/*!40000 ALTER TABLE `itemstaticcosthistory` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemstaticcosthistory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemtransaction`
--

DROP TABLE IF EXISTS `itemtransaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemtransaction` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `wherefrom` int(2) NOT NULL default '0',
  `referenceid` int(11) NOT NULL default '0',
  `locationid` int(11) NOT NULL default '0',
  `description` varchar(100) NOT NULL default '0',
  `quantity` decimal(18,6) NOT NULL default '0.000000',
  `costpereach` decimal(19,6) NOT NULL default '0.000000',
  `trtype` int(2) NOT NULL default '0',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `createuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default '0000-00-00 00:00:00',
  `id_order_shipment` int(11) default '0',
  `pricepereach` decimal(19,6) NOT NULL default '0.000000',
  `itemvendorid` int(11) NOT NULL default '0',
  `status` int(5) NOT NULL default '0',
  `withdrawn` decimal(12,5) NOT NULL default '0.00000',
  `first_costeach` decimal(19,6) NOT NULL default '0.000000',
  `last_costeach` decimal(19,6) NOT NULL default '0.000000',
  `wtd_costeach` decimal(19,6) NOT NULL default '0.000000',
  `mid_costeach` decimal(19,6) NOT NULL default '0.000000',
  `orig_transid` int(11) NOT NULL default '0',
  `jobid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `invadjustmenttypeid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `trtype` (`trtype`),
  KEY `itemid` (`itemid`),
  KEY `wherefrom` (`wherefrom`),
  KEY `locationid` (`locationid`),
  KEY `createdate` (`createdate`),
  KEY `cancel` (`cancel`),
  KEY `itemvendorid` (`itemvendorid`),
  KEY `status` (`status`),
  KEY `referenceid` (`referenceid`),
  KEY `ilstc` (`itemid`,`locationid`,`status`,`trtype`,`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemtransaction`
--

LOCK TABLES `itemtransaction` WRITE;
/*!40000 ALTER TABLE `itemtransaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemtransaction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemtransactiondetail`
--

DROP TABLE IF EXISTS `itemtransactiondetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemtransactiondetail` (
  `id` int(11) NOT NULL auto_increment,
  `itemtransactionid` int(11) NOT NULL default '0',
  `itemtransactionfieldid` int(11) NOT NULL default '0',
  `itemvalue` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  KEY `itemtransactionid` (`itemtransactionid`),
  KEY `itemtransactionfieldid` (`itemtransactionfieldid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemtransactiondetail`
--

LOCK TABLES `itemtransactiondetail` WRITE;
/*!40000 ALTER TABLE `itemtransactiondetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemtransactiondetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemtransactionfield`
--

DROP TABLE IF EXISTS `itemtransactionfield`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemtransactionfield` (
  `id` int(11) NOT NULL auto_increment,
  `categoryid` int(11) NOT NULL default '0',
  `description` varchar(255) default NULL,
  `default_value` varchar(255) default NULL,
  `entrytype` int(5) NOT NULL default '0',
  `text_limit` int(11) NOT NULL default '20',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `categoryid` (`categoryid`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemtransactionfield`
--

LOCK TABLES `itemtransactionfield` WRITE;
/*!40000 ALTER TABLE `itemtransactionfield` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemtransactionfield` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemtransactionfield_selection`
--

DROP TABLE IF EXISTS `itemtransactionfield_selection`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemtransactionfield_selection` (
  `id` int(11) NOT NULL auto_increment,
  `itemtransactionfieldid` int(11) NOT NULL default '0',
  `name` varchar(255) default NULL,
  `sortorder` int(5) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `sortorder` (`sortorder`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemtransactionfield_selection`
--

LOCK TABLES `itemtransactionfield_selection` WRITE;
/*!40000 ALTER TABLE `itemtransactionfield_selection` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemtransactionfield_selection` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemtransactionref`
--

DROP TABLE IF EXISTS `itemtransactionref`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemtransactionref` (
  `id` int(11) NOT NULL auto_increment,
  `itemtransactionid` int(11) NOT NULL default '0',
  `reftable` varchar(64) NOT NULL default '',
  `refid` int(11) NOT NULL default '0',
  `reftag` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ref` (`refid`,`reftable`),
  KEY `itemtransactionid` (`itemtransactionid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemtransactionref`
--

LOCK TABLES `itemtransactionref` WRITE;
/*!40000 ALTER TABLE `itemtransactionref` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemtransactionref` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemtransactionseq`
--

DROP TABLE IF EXISTS `itemtransactionseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemtransactionseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemtransactionseq`
--

LOCK TABLES `itemtransactionseq` WRITE;
/*!40000 ALTER TABLE `itemtransactionseq` DISABLE KEYS */;
INSERT INTO `itemtransactionseq` VALUES (0);
/*!40000 ALTER TABLE `itemtransactionseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `itemvendor`
--

DROP TABLE IF EXISTS `itemvendor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `itemvendor` (
  `id` int(11) NOT NULL auto_increment,
  `vendorid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `vordernumber` varchar(30) NOT NULL default '',
  `vitemunitnameid` int(11) NOT NULL default '0',
  `vitemconversion` decimal(12,6) NOT NULL default '1.000000',
  `vitemcost1` decimal(19,5) NOT NULL default '0.00000',
  `vitemqty1` decimal(18,6) NOT NULL default '0.000000',
  `vitemcost2` decimal(19,5) NOT NULL default '0.00000',
  `vitemqty2` decimal(18,6) NOT NULL default '0.000000',
  `vitemcost3` decimal(19,5) NOT NULL default '0.00000',
  `vitemqty3` decimal(18,6) NOT NULL default '0.000000',
  `vitemcost4` decimal(19,5) NOT NULL default '0.00000',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `mfg` varchar(50) default NULL,
  `is_default` int(5) NOT NULL default '0',
  `freightpercent` decimal(8,2) NOT NULL default '0.00',
  `upc` varchar(255) NOT NULL default '',
  `leadtimedays` int(11) NOT NULL default '0',
  `notes` text,
  `bestbuy` decimal(18,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`),
  KEY `vendorid` (`vendorid`),
  KEY `vio` (`vendorid`,`itemid`,`vordernumber`),
  KEY `vordernumber` (`vordernumber`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `itemvendor`
--

LOCK TABLES `itemvendor` WRITE;
/*!40000 ALTER TABLE `itemvendor` DISABLE KEYS */;
/*!40000 ALTER TABLE `itemvendor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `job`
--

DROP TABLE IF EXISTS `job`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `job` (
  `id` int(11) NOT NULL auto_increment,
  `jobcode` varchar(20) NOT NULL default '',
  `jobname` varchar(255) NOT NULL default '',
  `customerid` int(11) NOT NULL default '0',
  `prelimable` tinyint(1) NOT NULL default '0',
  `contractnumber` varchar(24) NOT NULL default '',
  `ponum` varchar(24) NOT NULL default '',
  `defaultshipvia` int(11) NOT NULL default '0',
  `contactname` varchar(100) NOT NULL default '',
  `contacttitle` varchar(32) NOT NULL default '',
  `apn` varchar(32) NOT NULL default '',
  `estpurchase` decimal(19,6) NOT NULL default '0.000000',
  `numjobyears` int(11) NOT NULL default '0',
  `prelimstatus` varchar(100) NOT NULL default '',
  `prelimdate` date default NULL,
  `prelimfirstinvoicedate` date default NULL,
  `prelimcounty` varchar(24) NOT NULL default '',
  `permitcontact` varchar(100) NOT NULL default '',
  `prelimnotes` text NOT NULL,
  `prelimcreditlimit` decimal(19,6) NOT NULL default '0.000000',
  `jobtype` int(11) NOT NULL default '0',
  `closed` tinyint(1) NOT NULL default '0',
  `closeduserid` int(11) NOT NULL default '0',
  `closeddate` datetime default NULL,
  `taskstatusid` int(11) NOT NULL default '0',
  `prelimestimate` decimal(19,6) NOT NULL default '0.000000',
  `prelimamount` decimal(19,6) NOT NULL default '0.000000',
  `productionsalesmanid` int(11) NOT NULL default '0',
  `sitesalesmanid` int(11) NOT NULL default '0',
  `deferredvoucherid` int(11) NOT NULL default '0',
  `taxexemptid` int(11) NOT NULL default '0',
  `address1` varchar(100) NOT NULL default '',
  `address2` varchar(100) NOT NULL default '',
  `city` varchar(255) NOT NULL default '',
  `state` varchar(50) NOT NULL default '',
  `zip` varchar(20) NOT NULL default '',
  `country` varchar(20) NOT NULL default '',
  `addressverified` varchar(32) NOT NULL default '',
  `description` text,
  `status` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `owner_companyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `zlienid` int(11) NOT NULL default '0',
  `latitude` decimal(19,6) default NULL,
  `longitude` decimal(19,6) default NULL,
  `isconstructionjob` int(5) NOT NULL default '0',
  `bankname` varchar(100) NOT NULL default '',
  `bankcontact_name` varchar(100) NOT NULL default '',
  `bankcontact_email` varchar(255) NOT NULL default '',
  `bankinspector_name` varchar(100) NOT NULL default '',
  `bankinspector_email` varchar(255) NOT NULL default '',
  `msproject_jobname` varchar(100) NOT NULL default '',
  `region` varchar(100) NOT NULL default '',
  `isexternalclient` int(5) NOT NULL default '0',
  `sitecode` varchar(100) NOT NULL default '',
  `riskinsurance_underwriter` varchar(255) NOT NULL default '',
  `riskinsurance_amount` decimal(19,6) NOT NULL default '0.000000',
  `riskinsurance_expiration` date default NULL,
  `siteid` int(11) NOT NULL default '0',
  `projectid` int(11) NOT NULL default '0',
  `architectvendorid` int(11) NOT NULL default '0',
  `clientprojectnumber` varchar(100) default NULL,
  `contractdate` date default NULL,
  `inactive` tinyint(4) NOT NULL default '0',
  `unincorporated` tinyint(4) NOT NULL default '0',
  `zlienhirepartyrole` varchar(32) NOT NULL default 'Subcontractor',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `status` (`status`),
  KEY `projectid` (`projectid`),
  KEY `customerid` (`customerid`),
  KEY `productionsalesmanid` (`productionsalesmanid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `jobcode` (`jobcode`),
  KEY `clientprojectnumber` (`clientprojectnumber`),
  KEY `gcic` (`gencompanyid`,`cancel`,`inactive`,`closed`),
  KEY `entrydate` (`entrydate`),
  KEY `compactive` (`gencompanyid`,`cancel`,`inactive`),
  KEY `zip` (`zip`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `job`
--

LOCK TABLES `job` WRITE;
/*!40000 ALTER TABLE `job` DISABLE KEYS */;
/*!40000 ALTER TABLE `job` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `jobbudget`
--

DROP TABLE IF EXISTS `jobbudget`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `jobbudget` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `jobid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `budgettype` char(1) NOT NULL default '',
  `budgetdate` date NOT NULL default '0000-00-00',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `origamount` decimal(19,6) NOT NULL default '0.000000',
  `status` int(11) NOT NULL default '0',
  `notes` text NOT NULL,
  `parentjobbudgetid` int(10) unsigned NOT NULL default '0',
  `childjobbudgetid` int(11) NOT NULL default '0',
  `mainjobbudgetid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `approvaldate` datetime NOT NULL,
  `approvaluserid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gltr_categoryid` (`glcategoryid`),
  KEY `gltr_costcodeid` (`costcodeid`),
  KEY `budgetdate` (`budgetdate`),
  KEY `status` (`status`),
  KEY `parentjobbudgetid` (`parentjobbudgetid`),
  KEY `jbt` (`jobid`,`budgettype`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `jobbudget`
--

LOCK TABLES `jobbudget` WRITE;
/*!40000 ALTER TABLE `jobbudget` DISABLE KEYS */;
/*!40000 ALTER TABLE `jobbudget` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `jobchangelog`
--

DROP TABLE IF EXISTS `jobchangelog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `jobchangelog` (
  `id` int(11) NOT NULL auto_increment,
  `jobid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `oldvalues` mediumtext NOT NULL,
  `newvalues` mediumtext NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `jobid` (`jobid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `jobchangelog`
--

LOCK TABLES `jobchangelog` WRITE;
/*!40000 ALTER TABLE `jobchangelog` DISABLE KEYS */;
/*!40000 ALTER TABLE `jobchangelog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `jobitem`
--

DROP TABLE IF EXISTS `jobitem`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `jobitem` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `jobid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `orderid` int(11) NOT NULL default '0',
  `ordershipid` int(11) NOT NULL default '0',
  `ordershipdetailid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `voucherid` int(11) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  `quantity` decimal(18,6) NOT NULL default '0.000000',
  `costeach` decimal(19,6) NOT NULL default '0.000000',
  `transactiondate` date default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(4) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `cancelvoucherid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`),
  KEY `jobid` (`jobid`),
  KEY `costcodeid` (`costcodeid`),
  KEY `glcategoryid` (`glcategoryid`),
  KEY `orderid` (`orderid`),
  KEY `ordershipid` (`ordershipid`),
  KEY `ordershipdetailid` (`ordershipdetailid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `voucherid` (`voucherid`),
  KEY `transactiondate` (`transactiondate`),
  KEY `cg` (`cancel`,`gencompanyid`),
  KEY `inventorylocationid` (`inventorylocationid`),
  KEY `glaccountid` (`glaccountid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `jobitem`
--

LOCK TABLES `jobitem` WRITE;
/*!40000 ALTER TABLE `jobitem` DISABLE KEYS */;
/*!40000 ALTER TABLE `jobitem` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `jobitemtransaction`
--

DROP TABLE IF EXISTS `jobitemtransaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `jobitemtransaction` (
  `id` int(11) NOT NULL auto_increment,
  `jobitemid` int(11) NOT NULL default '0',
  `itemtransactionid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `jobitemid` (`jobitemid`),
  KEY `itemtransactionid` (`itemtransactionid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `jobitemtransaction`
--

LOCK TABLES `jobitemtransaction` WRITE;
/*!40000 ALTER TABLE `jobitemtransaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `jobitemtransaction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `jobtype`
--

DROP TABLE IF EXISTS `jobtype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `jobtype` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `jobtype`
--

LOCK TABLES `jobtype` WRITE;
/*!40000 ALTER TABLE `jobtype` DISABLE KEYS */;
/*!40000 ALTER TABLE `jobtype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lang`
--

DROP TABLE IF EXISTS `lang`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `lang` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=20267 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `lang`
--

LOCK TABLES `lang` WRITE;
/*!40000 ALTER TABLE `lang` DISABLE KEYS */;
INSERT INTO `lang` VALUES (1,'STR_TEXT'),(2,'STR_1DA'),(3,'STR_1ST'),(4,'STR_2DA'),(5,'STR_3DS'),(6,'STR_85_X_11'),(7,'STR_85_X_11_EQUIV'),(8,'STR_941'),(9,'STR_A_CARRIER'),(10,'STR_A_CATASTROPHIC_FAILURE_HAS_OCCURED'),(11,'STR_A_FISCAL_YEAR_BEGIN_MONTH'),(12,'STR_A_MASSIVE_ERROR_HAS_OCCURED'),(13,'STR_A_MASSIVE_FATAL_ERROR_HAS_OCCURED'),(14,'STR_A_MASSIVE_FATAL_ERROR_SUB'),(15,'STR_A_SEVERE_MASSIVE_ERROR'),(16,'STR_AA_DESCRIPTION'),(17,'STR_ABBREVIATION'),(18,'STR_ABOUT_NOLA_PRO'),(19,'STR_ABOUT_THIS_SOFTWARE'),(20,'STR_ACCOUNT'),(21,'STR_ACCOUNT_ACTIVITY_FOR'),(22,'STR_ACCOUNT_ADD'),(23,'STR_ACCOUNT_ADDED_SUCCESSFULLY'),(24,'STR_ACCOUNT_ALREADY_EXISTS_IN_THIS_PIE_SLICE'),(25,'STR_ACCOUNT_BALANCE'),(26,'STR_ACCOUNT_DELETED_SUCCESSFULLY'),(27,'STR_ACCOUNT_DESCRIPTION'),(28,'STR_ACCOUNT_NAME'),(29,'STR_ACCOUNT_NO'),(30,'STR_ACCOUNT_NUMBER'),(31,'STR_ACCOUNT_TO_BUDGET'),(32,'STR_ACCOUNT_TYPE'),(33,'STR_ACCOUNT_TYPE_ADD'),(34,'STR_ACCOUNT_TYPE_ADDED_SUCCESSFULLY'),(35,'STR_ACCOUNT_TYPE_DELETED_SUCCESSFULLY'),(36,'STR_ACCOUNT_TYPE_UPDATE'),(37,'STR_ACCOUNT_TYPE_UPDATED_SUCCESSFULLY'),(38,'STR_ACCOUNT_UPDATE'),(39,'STR_ACCOUNT_UPDATED_SUCCESSFULLY'),(40,'STR_ACCOUNTS_PAYABLE'),(41,'STR_ACCOUNTS_PAYABLE2'),(42,'STR_ACCOUNTS_RECEIVABLE'),(43,'STR_ACT_CUSTOMER'),(44,'STR_ACT_EMPLOYEE'),(45,'STR_ACT_INVENTORY'),(46,'STR_ACT_VENDOR'),(47,'STR_ACTION'),(48,'STR_ACTION_ADDED_SUCCESSFULLY'),(49,'STR_ACTION_CAP'),(50,'STR_ACTION_DELETED_SUCCESSFULLY'),(51,'STR_ACTION_SAVED_SUCCESSFULLY'),(52,'STR_ACTIVATE'),(53,'STR_ACTIVATE_DELETED_LOCATION'),(54,'STR_ACTIVATE_VENDOR_FOR_THIS_ITEM'),(55,'STR_ACTIVE'),(56,'STR_ACTIVITY_REPORT_FOR'),(57,'STR_ACTUAL'),(58,'STR_ACTUAL_MASTER_ITEMS_PRODUCED'),(59,'STR_ADD'),(60,'STR_ADD_A_BUDGET'),(61,'STR_ADD_A_NEW_EMPLOYEE'),(62,'STR_ADD_A_RELATED_TOPIC'),(63,'STR_ADD_ANOTHER_ACCOUNT'),(64,'STR_ADD_ANOTHER_ACTION'),(65,'STR_ADD_ANOTHER_CATEGORY'),(66,'STR_ADD_ANOTHER_EMPLOYEE'),(67,'STR_ADD_ANOTHER_ENTRY'),(68,'STR_ADD_ANOTHER_INVOICE'),(69,'STR_ADD_ANOTHER_ITEM'),(70,'STR_ADD_ANOTHER_LOCATION'),(71,'STR_ADD_ANOTHER_ORDER'),(72,'STR_ADD_ANOTHER_VOUCHER'),(73,'STR_ADD_BUDGET'),(74,'STR_ADD_COMPANY_NOW'),(75,'STR_ADD_COMPANY_NOW2'),(76,'STR_ADD_COST_OF_GOODS'),(77,'STR_ADD_DOCUMENT'),(78,'STR_ADD_EDIT_ANOTHER_USER_FOR_THIS_COMPANY'),(79,'STR_ADD_INVENTORY_PO'),(80,'STR_ADD_INVOICE'),(81,'STR_ADD_ITEMS'),(82,'STR_ADD_LINE_ITEM_TO_INVOICE'),(83,'STR_ADD_LINE_ITEM_TO_ORDER'),(84,'STR_ADD_LINE_ITEM_TO_PO'),(85,'STR_ADD_LINES'),(86,'STR_ADD_MONEY'),(87,'STR_ADD_NEW'),(88,'STR_ADD_NEW_ACTION'),(89,'STR_ADD_NEW_BINDERY_FUNCTION'),(90,'STR_ADD_NEW_BINDERY_TYPE'),(91,'STR_ADD_NEW_BUILD_ORDERS'),(92,'STR_ADD_NEW_CARRIER'),(93,'STR_ADD_NEW_CATEGORY'),(94,'STR_ADD_NEW_CHECKING_ACCOUNT'),(95,'STR_ADD_NEW_COMPANY'),(96,'STR_ADD_NEW_COST_CENTER'),(97,'STR_ADD_NEW_CUSTOMER'),(98,'STR_ADD_NEW_DEDUCTION_GROUP'),(99,'STR_ADD_NEW_DETAIL'),(100,'STR_ADD_NEW_DETAIL_WORK_TYPE'),(101,'STR_ADD_NEW_EMPLOYEE'),(102,'STR_ADD_NEW_EMPLOYEE_REVIEW'),(103,'STR_ADD_NEW_GENERAL_WORK_TYPE'),(104,'STR_ADD_NEW_GL_ACCOUNT'),(105,'STR_ADD_NEW_GL_ACCOUNT_TYPE'),(106,'STR_ADD_NEW_INK'),(107,'STR_ADD_NEW_INVENTORY_MARKUP'),(108,'STR_ADD_NEW_INVENTORY_PRICE_LEVEL'),(109,'STR_ADD_NEW_INVOICE_TERMS'),(110,'STR_ADD_NEW_ITEM'),(111,'STR_ADD_NEW_ITEM_CATEGORY'),(112,'STR_ADD_NEW_ITEM_VENDOR_SAVE_CHANGES'),(113,'STR_ADD_NEW_LOCATION'),(114,'STR_ADD_NEW_MACHINE'),(115,'STR_ADD_NEW_MACHINE_FAMILY'),(116,'STR_ADD_NEW_METHOD'),(117,'STR_ADD_NEW_OPERATION'),(118,'STR_ADD_NEW_PAYMENT_TERMS'),(119,'STR_ADD_NEW_PAYMENT_TYPE'),(120,'STR_ADD_NEW_PIE'),(121,'STR_ADD_NEW_PLAN'),(122,'STR_ADD_NEW_PRESS_TOOL'),(123,'STR_ADD_NEW_PRICE_LIST'),(124,'STR_ADD_NEW_PRICE_LIST_STOCK'),(125,'STR_ADD_NEW_PRICE_LIST_STOCK_USAGE'),(126,'STR_ADD_NEW_PRICE_LIST_STOCK_USAGE_STOCK_LIST'),(127,'STR_ADD_NEW_PURCHASE_ORDER'),(128,'STR_ADD_NEW_QUESTION'),(129,'STR_ADD_NEW_QUOTE_COMMENT'),(130,'STR_ADD_NEW_QUOTE_NOTE'),(131,'STR_ADD_NEW_QUOTE_REVISION'),(132,'STR_ADD_NEW_REVIEW_RATING'),(133,'STR_ADD_NEW_SALES_ACTION'),(134,'STR_ADD_NEW_SALES_CATEGORY'),(135,'STR_ADD_NEW_SALES_PERSON'),(136,'STR_ADD_NEW_SALES_PROCESS'),(137,'STR_ADD_NEW_SALES_TAX'),(138,'STR_ADD_NEW_SALES_TRACKING_ENTRY'),(139,'STR_ADD_NEW_STANDARD_SIZE'),(140,'STR_ADD_NEW_STOCK'),(141,'STR_ADD_NEW_SUBGROUP'),(142,'STR_ADD_NEW_TAX_EXEMPTION'),(143,'STR_ADD_NEW_UNIT_NAME'),(144,'STR_ADD_NEW_USER'),(145,'STR_ADD_NEW_VENDOR'),(146,'STR_ADD_NEW_VENDOR_TERMS'),(147,'STR_ADD_NEW_WORK_TYPE'),(148,'STR_ADD_QUOTE'),(149,'STR_ADD_REMOVE'),(150,'STR_ADD_REMOVE_SELECTED_COMPONENT'),(151,'STR_ADD_ROW'),(152,'STR_ADD_SALES_PERSON'),(153,'STR_ADD_SALESPERSON'),(154,'STR_ADD_SALESPERSON_DATA'),(155,'STR_ADD_SALESTAX'),(156,'STR_ADD_SAVE'),(157,'STR_ADD_SERVICE_REP'),(158,'STR_ADD_SUPPLIER'),(159,'STR_ADD_TO_DOCUMENT_MANAGER'),(160,'STR_ADD_TRACKING'),(161,'STR_ADD_UPDATE'),(162,'STR_ADD_UPDATE_ANOTHER_BINDERY_FUNCTION'),(163,'STR_ADD_UPDATE_ANOTHER_LOCATION_FOR_ITEM'),(164,'STR_ADD_UPDATE_ANOTHER_VENDOR_SAME_ITEM'),(165,'STR_ADD_UPDATE_CHARGES_FOR_THIS_BINDERY_FUNCTION'),(166,'STR_ADD_UPDATE_COMPONENT_LIST_FOR_ITEM'),(167,'STR_ADD_UPDATE_DIFFERENT_CUSTOMER'),(168,'STR_ADD_UPDATE_LOCATION_FOR_ITEM'),(169,'STR_ADD_UPDATE_MACHINE_LIST'),(170,'STR_ADD_UPDATE_SELECT_LIST_FOR_THIS_BINDERY_FUNCTION'),(171,'STR_ADD_UPDATE_SUBGROUPS'),(172,'STR_ADD_USER_DISABLED_IN_DEMO_MODE'),(173,'STR_ADD_USER_LOGIN_RIGHTS'),(174,'STR_ADDED_INVENTORY_ITEM_LOCATION_SUCCESSFULLY'),(175,'STR_ADDED_OK'),(176,'STR_ADDED_SUCCESSFULLY'),(177,'STR_ADDEDIT_COMPONENT'),(178,'STR_ADDEDIT_LOCATION'),(179,'STR_ADDITIONAL_CHARGE_MINIMUM'),(180,'STR_ADDITIONAL_CHARGE_PER_M'),(181,'STR_ADDITIONAL_HRS_PRESS_SETUP'),(182,'STR_ADDITIONAL_LBS_PER_M'),(183,'STR_ADDL_ASSISTANTS'),(184,'STR_ADDL_OPERATORS'),(185,'STR_ADDRESS'),(186,'STR_ADJUSTED_QUANTITY'),(187,'STR_ADJUSTMENT'),(188,'STR_ADJUSTMENTS'),(189,'STR_ADMIN_SETUP'),(190,'STR_ADMINISTRATION'),(191,'STR_AFTER_HOURS'),(192,'STR_AFTER_HOURS_PHONE'),(193,'STR_AGING_BY'),(194,'STR_AGING_BY_INVOICE_DATE'),(195,'STR_AGING_REPORT'),(196,'STR_AIREQ'),(197,'STR_ALL'),(198,'STR_ALL_ACCOUNTS'),(199,'STR_ALL_ACCOUNTS_PAYABLE'),(200,'STR_ALL_ADMIN'),(201,'STR_ALL_BILLING'),(202,'STR_ALL_COMPANIES'),(203,'STR_ALL_COMPANIES_TOGETHER'),(204,'STR_ALL_EMPLOYEES'),(205,'STR_ALL_EMPLOYEES_ENTERED'),(206,'STR_ALL_GL'),(207,'STR_ALL_IN_GROUP'),(208,'STR_ALL_INV'),(209,'STR_ALL_LOCATIONS'),(210,'STR_ALL_MEMBERS_OF_PIE_CHART'),(211,'STR_ALL_ORDERS'),(212,'STR_ALL_OVERDUE'),(213,'STR_ALL_PAY'),(214,'STR_ALL_PAY_GROUP'),(215,'STR_ALL_PAYROLL'),(216,'STR_ALL_SUB_TYPES'),(217,'STR_ALL_SUBSTOCKS'),(218,'STR_ALL_UNBILLED'),(219,'STR_ALLOW'),(220,'STR_ALLOWED_TO_ACCRUE'),(221,'STR_ALREADY_ASSEMBLED'),(222,'STR_ALREADY_EXISTS'),(223,'STR_ALREADY_INSTALLED'),(224,'STR_ALTERATIONS'),(225,'STR_ALWAYS_SHOW'),(226,'STR_AMOUNT'),(227,'STR_AMOUNT_ENCLOSED'),(228,'STR_AMOUNT_EXTRA_PER_JOB'),(229,'STR_AMOUNT_FOR_1_EXEMPTION'),(230,'STR_AMOUNT_FOR_2_EXEMPTIONS'),(231,'STR_AMOUNT_FOR_3_EXEMPTIONS'),(232,'STR_AMOUNT_PAID'),(233,'STR_AMOUNT_PER_EXEMPTION_FOR_2'),(234,'STR_AMOUNT_PER_EXEMPTION_FOR_3'),(235,'STR_AMOUNT_PER_EXEMPTION_FOR_4_AND_UP'),(236,'STR_AMOUNT_PER_M'),(237,'STR_AMOUNT_PER_M_PER_PART'),(238,'STR_AMOUNT_PER_M_PER_SIDE'),(239,'STR_AMOUNT_TO_CHARGE'),(240,'STR_AMOUNT_X_ANSWER'),(241,'STR_AMOUNT_X_COSTS'),(242,'STR_AMOUNT_X_M_85'),(243,'STR_AMOUNT_X_M_PER_ANSWER'),(244,'STR_AMOUNT_X_M_PER_NUMBER_UP'),(245,'STR_AMT_1_WEEK_MONTH'),(246,'STR_AN_ERROR_HAS_PREVENTED'),(247,'STR_AN_INTERNAL_CATASTROPHY_HAS_OCCURED'),(248,'STR_AN_INTERNAL_COULD'),(249,'STR_AN_INTERNAL_DELETE'),(250,'STR_AND'),(251,'STR_AND_IF_LARGER_THAN'),(252,'STR_AND_IF_SMALLER_THAN'),(253,'STR_AND_IF_USING_MORE_THAN_BLACK_INK'),(254,'STR_AND_IF_USING_MORE_THAN_ONE_INK'),(255,'STR_AND_IF_USING_MORE_THAN_ONE_SIDE'),(256,'STR_AND_MONTH'),(257,'STR_ANNUAL_EXEMPTION_ALLOWANCE'),(258,'STR_ANOTHER_SHIP_QTY_PRINT'),(259,'STR_ANY_SOURCE'),(260,'STR_ANYONE'),(261,'STR_ANYTHING'),(262,'STR_AP'),(263,'STR_AP_AGING_REPORT'),(264,'STR_AP_BILL_LIST'),(265,'STR_AP_CHECK_LIST'),(266,'STR_AP_CHECKING'),(267,'STR_AP_DETAIL_AGING_REPORT'),(268,'STR_AP_STANDARD_GL_ACCOUNTS'),(269,'STR_APAY'),(270,'STR_APCOMPANY_INSERT_FAILED'),(271,'STR_APCOMPANY_UPDATE_FAILED'),(272,'STR_APPLY_DISCOUNTS'),(273,'STR_APPLY_INTEREST'),(274,'STR_APPLY_PAYMENT'),(275,'STR_APRIL'),(276,'STR_AR_CALCULATE_INTEREST'),(277,'STR_AR_COMPANY_INSERT_FAILED'),(278,'STR_AR_COMPANY_OPTIONS'),(279,'STR_AR_COMPANY_UPDATE_FAILED'),(280,'STR_AR_INVOICE'),(281,'STR_AR_INVOICE_PAYMENT'),(282,'STR_AR_INVOICE_PAYMENT_HISTORY'),(283,'STR_AR_INVOICE_REVERSAL'),(284,'STR_AR_INVOICE_SALES_TAX'),(285,'STR_AR_STANDARD_GL_ACCOUNTS'),(286,'STR_ARABIC'),(287,'STR_ARE_YOU_SURE'),(288,'STR_ARE_YOU_SURE_FINALIZE'),(289,'STR_ARE_YOU_SURE_YOU_WANT_TO'),(290,'STR_ARE_YOU_SURE_YOU_WANT_TO_CHECKS'),(291,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE'),(292,'STR_AREC'),(293,'STR_ASK_ONLY_IF_LARGER_THAN'),(294,'STR_ASK_ONLY_IF_SMALLER_THAN'),(295,'STR_ASK_ONLY_IF_USING_MORE_THAN_ONE_INK'),(296,'STR_ASK_ONLY_IF_USING_MORE_THAN_ONE_SIDE'),(297,'STR_ASK_ONLY_IF_USING_NON_BLACK_INK'),(298,'STR_ASK_ONLY_IF_USING_ONE_INK'),(299,'STR_ASK_QUESTION'),(300,'STR_ASSIGN'),(301,'STR_ASSIGN_MATERIALS'),(302,'STR_AT'),(303,'STR_AT_LEAST_ONE_USER_MUST_HAVE_MODIFY_RIGHTS'),(304,'STR_AT_LEAST_ONE_USER_MUST_HAVE_VIEW_RIGHTS'),(305,'STR_ATTACH_ANOTHER_FILE'),(306,'STR_ATTN'),(307,'STR_ATTN_TO'),(308,'STR_AUGUST'),(309,'STR_AUTHOR'),(310,'STR_AUTHOR_COMMENT'),(311,'STR_AUTO_PRINT_DEPOSIT_CHECK'),(312,'STR_AVAILABLE_ASSEMBLED'),(313,'STR_AVERAGE'),(314,'STR_AVG_MARKUP_PECENTAGE'),(315,'STR_BACK'),(316,'STR_BACK_TO_ADMIN_MENU'),(317,'STR_BACK_TO_CHOOSE_DIFFERENT_ACCOUNT_TYPE'),(318,'STR_BACK_TO_CHOOSE_DIFFERENT_SALESMAN_NAME'),(319,'STR_BACK_TO_EDIT'),(320,'STR_BACK_TO_MAILBOX'),(321,'STR_BACK_TO_PHYSICAL'),(322,'STR_BACK_TO_PHYSICIAL'),(323,'STR_BAD_LOCALE'),(324,'STR_BAD_TAX_TYPE'),(325,'STR_BALANCE'),(326,'STR_BALANCE_DUE'),(327,'STR_BALANCE_SHEET_FOR'),(328,'STR_BASE'),(329,'STR_BASIS_FOR_CALCULATION'),(330,'STR_BEARER_TO_BEARER_WIDTH'),(331,'STR_BECAUSE_OF_SOME_UNFORTUNATE'),(332,'STR_BEGIN'),(333,'STR_BEGIN_DATE'),(334,'STR_BEGIN_DATE_OF_CHECKS'),(335,'STR_BEGIN_DATE_OF_INVOICE'),(336,'STR_BEGIN_DUE_DATE'),(337,'STR_BEGIN_PERIOD'),(338,'STR_BEGIN_YR_MO'),(339,'STR_BEGINNING_BALANCE'),(340,'STR_BEGINNING_CHECK_NUMBER'),(341,'STR_BEGINNING_EVALUATION_DATE'),(342,'STR_BEGINNING_MONTH'),(343,'STR_BENEFITS_UPDATED_SUCCESSFULLY'),(344,'STR_BEYOND_DISCOUNT_PERIOD'),(345,'STR_BILL_ADD'),(346,'STR_BILL_ADDED_SUCCESSFULLY'),(347,'STR_BILL_DELETED_SUCCESSFULLY'),(348,'STR_BILL_ID_NUMBER'),(349,'STR_BILL_ON_HOLD'),(350,'STR_BILL_SETUP'),(351,'STR_BILL_TO_ATTN'),(352,'STR_BILL_UPDATE'),(353,'STR_BILL_UPDATED_SUCCESSFULLY'),(354,'STR_BILL_WITH_THIS_INVOICE_NUMBER_ALREADY_ENTERED'),(355,'STR_BILLED'),(356,'STR_BILLED_YTD'),(357,'STR_BILLION'),(358,'STR_BINDERY_FUNCTION'),(359,'STR_BINDERY_FUNCTION_ADDED_SUCCESSFULLY'),(360,'STR_BINDERY_FUNCTION_DELETED_SUCCESSFULLY'),(361,'STR_BINDERY_FUNCTION_NOT_FOUND'),(362,'STR_BINDERY_FUNCTION_SIZE_ADDED_SUCCESSFULLY'),(363,'STR_BINDERY_FUNCTION_SIZE_DELETED_SUCCESSFULLY'),(364,'STR_BINDERY_FUNCTION_SIZE_UPDATED_SUCCESSFULLY'),(365,'STR_BINDERY_FUNCTION_UPDATED_SUCCESSFULLY'),(366,'STR_BINDERY_FUNCTIONS_ADD'),(367,'STR_BINDERY_FUNCTIONS_PRICING_UPDATE'),(368,'STR_BINDERY_FUNCTIONS_SELECTION_LIST_UPDATE'),(369,'STR_BINDERY_FUNCTIONS_UPDATE'),(370,'STR_BINDERY_NAME'),(371,'STR_BINDERY_PRICE_LIST_UPDATE'),(372,'STR_BINDERY_TYPE'),(373,'STR_BINDERY_TYPE_ADD'),(374,'STR_BINDERY_TYPE_ADDED_SUCCESSFULLY'),(375,'STR_BINDERY_TYPE_DELETED_SUCCESSFULLY'),(376,'STR_BINDERY_TYPE_NOT_FOUND'),(377,'STR_BINDERY_TYPE_UPDATED_SUCCESSFULLY'),(378,'STR_BINDERY_WORK_TYPE_DELETED_SUCCESSFULLY'),(379,'STR_BIRTHDAY'),(380,'STR_BLACK'),(381,'STR_BOLD_INTRO_PORTION_OF_NOTE'),(382,'STR_BOM'),(383,'STR_BOX_11_NONQUALIFIED_PLAN'),(384,'STR_BOX_12_NONQUALIFIED_PLAN'),(385,'STR_BOX_13_QUALIFIED_PLAN'),(386,'STR_BOX_14_QUALIFIED_PLAN'),(387,'STR_BOXES'),(388,'STR_BROWSE'),(389,'STR_BUDGET'),(390,'STR_BUDGET_ADD_UPDATE'),(391,'STR_BUDGET_ADDED_SUCCESSFULLY'),(392,'STR_BUDGET_COULD_NOT_BE_FOUND'),(393,'STR_BUDGET_DELETED_SUCCESSFULLY'),(394,'STR_BUDGET_EDITED_SUCCESSFULLY'),(395,'STR_BUDGET_FOR_YEAR'),(396,'STR_BUDGET_LIST_BY_ACCOUNT_FOR'),(397,'STR_BUDGET_NAME'),(398,'STR_BUDGET_TO_EDIT_DELETE'),(399,'STR_BUDGET_VARIANCE_STATEMENT_FOR'),(400,'STR_BUILD'),(401,'STR_BUILD_ITEM'),(402,'STR_BUILD_ORDER'),(403,'STR_BUILD_ORDER_SUCCESSFULLY_DELETED'),(404,'STR_BUILD_ORDER_SUCCESSFULLY_FINALIZED'),(405,'STR_BUT_CUTTER'),(406,'STR_BY'),(407,'STR_BYTES'),(408,'STR_CALCULATE'),(409,'STR_CALCULATE_HOW'),(410,'STR_CALCULATE_PRICES'),(411,'STR_CALCULATE_QUOTE'),(412,'STR_CALCULATED'),(413,'STR_CALCULATION_DATA'),(414,'STR_CAN_BE_LEFT_BLANK'),(415,'STR_CAN_USE_MACHINE_TOOLS'),(416,'STR_CANCEL'),(417,'STR_CANCEL_ADD_AND_RETURN_TO_SELECTION'),(418,'STR_CANCEL_ADD_RETURN_TO_SELECTION'),(419,'STR_CANCEL_ALL_COUNTS'),(420,'STR_CANCEL_CHANGES_PRINT_TICKET'),(421,'STR_CANNOT_ADD_BUDGETS'),(422,'STR_CANNOT_CONTINUE'),(423,'STR_CANNOT_CREATE_TABLE'),(424,'STR_CANNOT_CREATE_TABLE_FIELDS'),(425,'STR_CANNOT_ENTER_TWO_INKS'),(426,'STR_CANNOT_FIND_GENERAL_WORK_TYPE'),(427,'STR_CANNOT_FIND_PRICE_LIST_STOCK'),(428,'STR_CANNOT_FIND_SUBGROUP_SELECTED'),(429,'STR_CANNOT_FIND_WORK_TYPE'),(430,'STR_CANNOT_OPEN_FILE_FOR_WRITING'),(431,'STR_CANNOT_SELECT_COLORS'),(432,'STR_CANNOT_WRITE_TO_FILE'),(433,'STR_CARDTYPE'),(434,'STR_CARRIER'),(435,'STR_CARRIER_ADDED_SUCCESSFULLY'),(436,'STR_CARRIER_ALREADY_EXISTS'),(437,'STR_CARRIER_DELETED_SUCCESSFULLY'),(438,'STR_CARRIER_INFO'),(439,'STR_CARRIER_METHOD'),(440,'STR_CARRIER_NAME'),(441,'STR_CARRIER_SERVICE'),(442,'STR_CARRIER_SERVICE2'),(443,'STR_CARRIER_UPDATE'),(444,'STR_CARRIER_UPDATED_SUCCESSFULLY'),(445,'STR_CASH'),(446,'STR_CASHED'),(447,'STR_CASHED_DATE'),(448,'STR_CASHED_DATE_ONLY'),(449,'STR_CATALOG'),(450,'STR_CATEGORIES2'),(451,'STR_CATEGORY'),(452,'STR_CATEGORY_ADDED_SUCCESSFULLY'),(453,'STR_CATEGORY_ALREADY_EXISTS'),(454,'STR_CATEGORY_ALREADY_EXISTS_BY_THAT_NAME'),(455,'STR_CATEGORY_DELETED_SUCCESSFULLY'),(456,'STR_CATEGORY_EDIT'),(457,'STR_CATEGORY_NAME'),(458,'STR_CATEGORY_NOT_FOUND'),(459,'STR_CATEGORY_SAVED_SUCCESSFULLY'),(460,'STR_CATEGORY_UPDATED_SUCCESSFULLY'),(461,'STR_CAVITY_DEPTH'),(462,'STR_CAVITY_SHAPE'),(463,'STR_CAVITY_WIDTH'),(464,'STR_CC_OWNER'),(465,'STR_CENTS'),(466,'STR_CHANGE_PAGE_SIZE'),(467,'STR_CHANGE_SELECTIONS'),(468,'STR_CHANGE_SHIP_TO'),(469,'STR_CHANGE_THE_ENCRYPTION_KEY'),(470,'STR_CHANGE_THE_PASSWORD'),(471,'STR_CHANGED_TO'),(472,'STR_CHARGE_CODE'),(473,'STR_CHARGE_FOR_TIGHT_REGISTRATION'),(474,'STR_CHARGE_INTEREST'),(475,'STR_CHARGES_AND_CREDITS'),(476,'STR_CHARGES_FOR_SIZE_UP_TO'),(477,'STR_CHARGES_UP_TO_WHAT_SIZE'),(478,'STR_CHART_OF_ACCOUNTS_FOR'),(479,'STR_CHECK'),(480,'STR_CHECK_ABBR'),(481,'STR_CHECK_ACCOUNT'),(482,'STR_CHECK_ACCT'),(483,'STR_CHECK_ACCT_UPDATE_FAILED'),(484,'STR_CHECK_DATE'),(485,'STR_CHECK_DOCUMENT_BACK_IN'),(486,'STR_CHECK_DOCUMENT_IN'),(487,'STR_CHECK_DOCUMENT_OUT'),(488,'STR_CHECK_ENDORSER'),(489,'STR_CHECK_IF_IN_BALANCE'),(490,'STR_CHECK_INFO'),(491,'STR_CHECK_NUMBER'),(492,'STR_CHECK_NUMBER2'),(493,'STR_CHECK_OUT_IN_ORDER_NUMBER'),(494,'STR_CHECK_OUT_ORDER'),(495,'STR_CHECK_SUMMARY'),(496,'STR_CHECK_TO_UNCASH'),(497,'STR_CHECK_TO_UNVOID'),(498,'STR_CHECK_UPDATE_FAILED'),(499,'STR_CHECK_VOID'),(500,'STR_CHECK_WRITING'),(501,'STR_CHECKDATE_BEFORE_TODAY'),(502,'STR_CHECKED_OUT'),(503,'STR_CHECKING'),(504,'STR_CHECKING_ACCOUNT'),(505,'STR_CHECKING_ACCOUNT_ADD'),(506,'STR_CHECKING_ACCOUNT_ADDED_SUCCESSFULLY'),(507,'STR_CHECKING_ACCOUNT_ALREADY_EXISTS'),(508,'STR_CHECKING_ACCOUNT_DATE_CHECK_NUMBER'),(509,'STR_CHECKING_ACCOUNT_DELETED_SUCCESSFULLY'),(510,'STR_CHECKING_ACCOUNT_UPDATE'),(511,'STR_CHECKING_ACCOUNT_UPDATED_SUCCESSFULLY'),(512,'STR_CHECKING_ACCT'),(513,'STR_CHECKS'),(514,'STR_CHECKS_ALREADY_WRITTEN'),(515,'STR_CHECKS_MARKED_AS_CASHED'),(516,'STR_CHECKS_MARKED_AS_UNCASHED'),(517,'STR_CHECKS_PRINTED_SUCCESSFULLY'),(518,'STR_CHECKS_UNVOIDED_SUCCESSFULLY'),(519,'STR_CHECKS_VOIDED_SUCCESSFULLY'),(520,'STR_CHECKS_WRITTEN_SUCCESSFULLY'),(521,'STR_CHOOSE_BY_DATE'),(522,'STR_CHOOSE_BY_MONTH'),(523,'STR_CHOOSE_YOUR_COMPANY'),(524,'STR_CITY'),(525,'STR_CITY_EXEMPTIONS'),(526,'STR_CITY_INCOME_TAX'),(527,'STR_CITY_TAX'),(528,'STR_CITY_TAX2'),(529,'STR_CLICK_BELOW_TO_REVERSE'),(530,'STR_CLICK_BELOW_TO_REVERSE_DATE'),(531,'STR_CLICK_BUTTON_TO_DOWNLOAD_YOUR_REPORT'),(532,'STR_CLICK_HERE'),(533,'STR_CLICK_HERE_TO_EXPORT_A_REPORT_TO_MS_EXCEL'),(534,'STR_CLICK_HERE_TO_RETURN_BUDGET_ADD_UPDATE'),(535,'STR_CLICK_HERE_TO_UPDATE_OR_ADD_MORE_BUDGETS'),(536,'STR_CLICK_HERE_TO_VIEW_DETAILS'),(537,'STR_CLICK_HERE_TO_VIEW_THE_CSV_LIST_OF_VENDORS'),(538,'STR_CLICK_HERE_TO_VIEW_TRANSACTIONS'),(539,'STR_CLICK_TO_SEE_DETAILS'),(540,'STR_CLICK_TO_VIEW'),(541,'STR_CLOSE'),(542,'STR_CLOSE_WINDOW'),(543,'STR_CLOSED'),(544,'STR_CO_FICA_TAX'),(545,'STR_CO_FUI_TAX'),(546,'STR_CO_MEDICARE'),(547,'STR_CO_SUI_TAX'),(548,'STR_CODE'),(549,'STR_COGS'),(550,'STR_COLOR'),(551,'STR_COLOR_BLUE'),(552,'STR_COLOR_BROWN'),(553,'STR_COLOR_CREME'),(554,'STR_COLOR_GRAY'),(555,'STR_COLOR_GREEN'),(556,'STR_COLOR_ORANGE'),(557,'STR_COLOR_PINK'),(558,'STR_COLOR_PURPLE'),(559,'STR_COLOR_RED'),(560,'STR_COLOR_YELLOW'),(561,'STR_COLORS'),(562,'STR_COLORS_ARE_WITHIN'),(563,'STR_COM_AMOUNT'),(564,'STR_COM_AMOUNT2'),(565,'STR_COM_OPTION'),(566,'STR_COMMENT'),(567,'STR_COMMENTS'),(568,'STR_COMMENTS_ONLY'),(569,'STR_COMMISSION_BASE'),(570,'STR_COMMISSION_DATA'),(571,'STR_COMMISSION_RATE'),(572,'STR_COMMITTED'),(573,'STR_COMPANY'),(574,'STR_COMPANY_ADD'),(575,'STR_COMPANY_ADDED_SUCCESSFULLY'),(576,'STR_COMPANY_CONTRIBUTIONS'),(577,'STR_COMPANY_CONTRIBUTIONS_UPDATED_SUCCESSFULLY'),(578,'STR_COMPANY_DELETED_SUCCESSFULLY'),(579,'STR_COMPANY_DIV'),(580,'STR_COMPANY_FICA_MEDICARE'),(581,'STR_COMPANY_NAME'),(582,'STR_COMPANY_NOT_FOUND'),(583,'STR_COMPANY_OPTIONS_CHANGED_SUCCESSFULLY'),(584,'STR_COMPANY_UPDATE'),(585,'STR_COMPANY_UPDATE_CANNOT'),(586,'STR_COMPANY_UPDATED_SUCCESSFULLY'),(587,'STR_COMPANY_USER'),(588,'STR_COMPARE_TO'),(589,'STR_COMPARE_TO_OTHER_PERIOD'),(590,'STR_COMPARED_TO'),(591,'STR_COMPLETE'),(592,'STR_COMPLETE_BILL'),(593,'STR_COMPLETE_INVOICE'),(594,'STR_COMPLETE_PAYMENT'),(595,'STR_COMPLETE_PO'),(596,'STR_COMPLETED'),(597,'STR_COMPONENT_ITEM'),(598,'STR_COMPONENT_ITEMS_ALREADY_SELECTED'),(599,'STR_COMPOSITE'),(600,'STR_COMPOSITE_ITEM'),(601,'STR_COMPOSITE_ITEM_COMPONENT_LIST_FOR'),(602,'STR_COMPOSITE_ITEM_SEARCH'),(603,'STR_COMPOSITE_ITEM_SUCH_AS'),(604,'STR_CONFIRM'),(605,'STR_CONTACT'),(606,'STR_CONTACT_NAME'),(607,'STR_CONTINUE'),(608,'STR_CONTINUE_AND_SAVE'),(609,'STR_CONTINUE_BROWSING'),(610,'STR_COPY'),(611,'STR_COPY_BUDGET_DATA_FROM'),(612,'STR_COPY_NOW'),(613,'STR_COPY_STOCK_SELECTIONS'),(614,'STR_COPY_STOCKS_AND_UPCHARGES'),(615,'STR_COPYRIGHT'),(616,'STR_COST'),(617,'STR_COST_ASSISTANT_PER_HOUR'),(618,'STR_COST_BASED_ON'),(619,'STR_COST_CENTER'),(620,'STR_COST_CENTER_ADD'),(621,'STR_COST_CENTER_ADDED_SUCCESSFULLY'),(622,'STR_COST_CENTER_DELETED_SUCCESSFULLY'),(623,'STR_COST_CENTER_FAMILY_ADDED_SUCCESSFULLY'),(624,'STR_COST_CENTER_FAMILY_UPDATED_SUCCESSFULLY'),(625,'STR_COST_CENTER_MACHINE_FAMILY'),(626,'STR_COST_CENTER_MACHINE_FAMILY_ADD'),(627,'STR_COST_CENTER_MACHINE_FAMILY_DELETED_SUCCESSFULLY'),(628,'STR_COST_CENTER_MACHINE_FAMILY_NOT_FOUND'),(629,'STR_COST_CENTER_MACHINE_FAMILY_UPDATE'),(630,'STR_COST_CENTER_NOT_FOUND'),(631,'STR_COST_CENTER_TYPE'),(632,'STR_COST_CENTER_UPDATE'),(633,'STR_COST_CENTER_UPDATED_SUCCESSFULLY'),(634,'STR_COST_EACH'),(635,'STR_COST_GL_ACCOUNT'),(636,'STR_COST_MACHINE_PER_HOUR'),(637,'STR_COST_OF_GOODS'),(638,'STR_COST_OF_GOODS_SOLD'),(639,'STR_COST_OPERATOR_PER_HOUR'),(640,'STR_COST_PER_PRESS_QTY'),(641,'STR_COST_PER_UNIT'),(642,'STR_COST_PER_USE'),(643,'STR_COULD_NOT_CONNECT'),(644,'STR_COULD_NOT_DELETE'),(645,'STR_COULD_NOT_FIND_BILL'),(646,'STR_COULD_NOT_FIND_LOCATION_NAME'),(647,'STR_COULD_NOT_FIND_MARKUP_SET'),(648,'STR_COULD_NOT_FIND_PIE'),(649,'STR_COULD_NOT_FIND_STOCK_TO_EDIT'),(650,'STR_COULD_NOT_FIND_STOCK_USAGE'),(651,'STR_COULD_NOT_POST'),(652,'STR_COULD_NOT_UNPOST'),(653,'STR_COULD_NOT_UPDATE'),(654,'STR_COULD_NOT_UPDATE_BECAUSE'),(655,'STR_COULD_NOT_WRITE_TO_FILE'),(656,'STR_COULDNT_READ_MENU'),(657,'STR_COULDNT_READ_USER'),(658,'STR_COUNT'),(659,'STR_COUNTRY'),(660,'STR_COVERAGE'),(661,'STR_COVERS_WHICH_WORKERS'),(662,'STR_CR'),(663,'STR_CREATE_NEW'),(664,'STR_CREATE_OVERPAYMENT'),(665,'STR_CREATE_REPORT'),(666,'STR_CREATE_REPORT_ENTER_COUNTS'),(667,'STR_CREATE_STANDARD_QUANTITY_LIST_FOR_PRICE_LISTS'),(668,'STR_CREATED_ON'),(669,'STR_CREATOR'),(670,'STR_CREDIT'),(671,'STR_CREDIT_ACCOUNT'),(672,'STR_CREDIT_BALANCE'),(673,'STR_CREDIT_CARD'),(674,'STR_CREDIT_FOR_1_EXEMPTION'),(675,'STR_CREDIT_LIMIT'),(676,'STR_CREDIT_PER_EXEMPTION_FOR_2'),(677,'STR_CREDIT_PER_EXEMPTION_FOR_3'),(678,'STR_CREDIT_PER_EXEMPTION_FOR_4_AND_UP'),(679,'STR_CREDITCARD_TYPE'),(680,'STR_CREDITS_USED'),(681,'STR_CSV_LIST'),(682,'STR_CUR_AMOUNT'),(683,'STR_CURRENT'),(684,'STR_CURRENT_BALANCE'),(685,'STR_CURRENT_COUNT'),(686,'STR_CURRENT_COUNTS_SAVED_CLICK_BELOW_TO_POST'),(687,'STR_CURRENT_FISCAL_YEAR_TO_DATE'),(688,'STR_CURRENT_INTEREST'),(689,'STR_CURRENT_ITEMS'),(690,'STR_CURRENT_PAGE'),(691,'STR_CURRENT_TOTAL'),(692,'STR_CURRENTLY_CHECKED_OUT_TO'),(693,'STR_CUST'),(694,'STR_CUSTCOMPANYID_INVALID'),(695,'STR_CUSTOM'),(696,'STR_CUSTOM_PMS'),(697,'STR_CUSTOMER'),(698,'STR_CUSTOMER_ACCOUNT'),(699,'STR_CUSTOMER_ADD'),(700,'STR_CUSTOMER_ADDED_SUCCESSFULLY'),(701,'STR_CUSTOMER_AMOUNT_TO_CHARGE'),(702,'STR_CUSTOMER_BILL_CODE'),(703,'STR_CUSTOMER_CHARGES'),(704,'STR_CUSTOMER_COMPANY_NAME'),(705,'STR_CUSTOMER_DELETED_SUCCESSFULLY'),(706,'STR_CUSTOMER_EDIT'),(707,'STR_CUSTOMER_EXTERNAL_USER_UPDATE'),(708,'STR_CUSTOMER_FILE_COLUMN_FORMAT'),(709,'STR_CUSTOMER_HISTORY'),(710,'STR_CUSTOMER_LIST'),(711,'STR_CUSTOMER_LIST_MAIN_LOCATION'),(712,'STR_CUSTOMER_LIST_SHIPTO_LOCATION'),(713,'STR_CUSTOMER_LOOKUP'),(714,'STR_CUSTOMER_MINIMUM_CHARGE'),(715,'STR_CUSTOMER_NO'),(716,'STR_CUSTOMER_NOT_FOUND'),(717,'STR_CUSTOMER_NUMBER'),(718,'STR_CUSTOMER_PRICE_CALCULATED_HOW'),(719,'STR_CUSTOMER_SERVICE'),(720,'STR_CUSTOMER_SERVICE_PHONE'),(721,'STR_CUSTOMER_SETUP_CHARGE'),(722,'STR_CUSTOMER_SHIPTO'),(723,'STR_CUSTOMER_SHIPTO_ADDED_SUCCESSFULLY'),(724,'STR_CUSTOMER_SHIPTO_DELETED_SUCCESSFULLY'),(725,'STR_CUSTOMER_SHIPTO_NOT_FOUND'),(726,'STR_CUSTOMER_SHIPTO_UPDATE_FOR'),(727,'STR_CUSTOMER_SHIPTO_UPDATED_SUCCESSFULLY'),(728,'STR_CUSTOMER_TOTAL'),(729,'STR_CUSTOMER_TRACKING_NUMBER'),(730,'STR_CUSTOMER_UPDATE'),(731,'STR_CUSTOMER_UPDATED_SUCCESSFULLY'),(732,'STR_CUSTOMERC'),(733,'STR_CUSTOMERID_OR_INVOICEID'),(734,'STR_CUSTOMERS_IMPORTED'),(735,'STR_CUTS'),(736,'STR_DATABASE_INVAILD'),(737,'STR_DATE'),(738,'STR_DATE_AND_TIME'),(739,'STR_DATE_CREATED'),(740,'STR_DATE_ENTERED'),(741,'STR_DATE_OF_BIRTH'),(742,'STR_DATE_OF_INVOICE'),(743,'STR_DATE_POSTED_TO'),(744,'STR_DATE_RECEIVED'),(745,'STR_DATE_SUBMITTED'),(746,'STR_DATE_TIME'),(747,'STR_DATED'),(748,'STR_DATES_NOT_USED_FOR_OPEN_ONLY'),(749,'STR_DAY'),(750,'STR_DAYS_REMAINING'),(751,'STR_DAYS_YEAR'),(752,'STR_DB_CHECKING_SYSTEM_TABLES'),(753,'STR_DB_CUR'),(754,'STR_DB_CUR2'),(755,'STR_DB_DATABASE_UPDATED'),(756,'STR_DB_ERROR_ADDING_COLUMN'),(757,'STR_DB_ERROR_CHANGING_COLUMN'),(758,'STR_DB_ERROR_CHANGING_TABLE_TYPE'),(759,'STR_DB_ERROR_CREATING_NEW_TABLE'),(760,'STR_DB_ERROR_DROPPING_TABLE'),(761,'STR_DB_ERROR_GETTING_DEFAULT_VALUES'),(762,'STR_DB_ERROR_GETTING_TABLE_CREATE'),(763,'STR_DB_ERROR_INSERTING_DEFAULT_VALUES'),(764,'STR_DB_ERROR_ITEMLISTED'),(765,'STR_DB_ERROR_RETRIEVING_COLUMNS'),(766,'STR_DB_ERROR_RETRIEVING_ORIGINAL_TABLES'),(767,'STR_DB_ERROR_RETRIEVING_TEMPORARY_TABLES'),(768,'STR_DB_FILE_NOT_FOUND'),(769,'STR_DB_IS_BEING_UPDATED'),(770,'STR_DB_LOC'),(771,'STR_DB_NO_NEW_UPDATES'),(772,'STR_DB_PASS'),(773,'STR_DB_TEMP_DATABASE_DELETED'),(774,'STR_DB_TOOL'),(775,'STR_DB_USER'),(776,'STR_DEBIT'),(777,'STR_DEBIT_ACCOUNT'),(778,'STR_DECEMBER'),(779,'STR_DED_GROUP'),(780,'STR_DEDUCT_FEDERAL_TAX_FIRST'),(781,'STR_DEDUCTION'),(782,'STR_DEDUCTION_ALLOWANCE_TABLE'),(783,'STR_DEDUCTION_AMOUNT'),(784,'STR_DEDUCTION_GROUP'),(785,'STR_DEDUCTION_GROUP_ADDED_SUCCESSFULLY'),(786,'STR_DEDUCTION_GROUP_DELETED_SUCCESSFULLY'),(787,'STR_DEDUCTION_GROUP_UPDATED_SUCCESSFULLY'),(788,'STR_DEDUCTION_INFO'),(789,'STR_DEDUCTION_UPDATED_SUCCESSFULLY'),(790,'STR_DEDUCTIONS'),(791,'STR_DEFAULT_BILL_DESCRIPTION'),(792,'STR_DEFAULT_CHECKING_ACCOUNT'),(793,'STR_DEFAULT_COVERAGE_FOR_INK'),(794,'STR_DEFAULT_ENDORSER'),(795,'STR_DEFAULT_GL_ACCOUNT'),(796,'STR_DEFAULT_LOCATION'),(797,'STR_DEFAULT_PRICELEVEL'),(798,'STR_DEFAULT_SHIP_METHOD'),(799,'STR_DELETE'),(800,'STR_DELETE_ACTION'),(801,'STR_DELETE_BUILD_ORDER'),(802,'STR_DELETE_CATEGORY'),(803,'STR_DELETE_DED'),(804,'STR_DELETE_DETAIL_LINE'),(805,'STR_DELETE_DOCUMENT'),(806,'STR_DELETE_ENTRY'),(807,'STR_DELETE_FAILED'),(808,'STR_DELETE_INVOICE_TERMS'),(809,'STR_DELETE_LOCATION_INFORMATION'),(810,'STR_DELETE_PAYMENT_TERMS'),(811,'STR_DELETE_PIE'),(812,'STR_DELETE_PRICING_THIS_PART'),(813,'STR_DELETE_QUOTE_REVISION'),(814,'STR_DELETE_SLICE'),(815,'STR_DELETE_SUBGROUP'),(816,'STR_DELETE_THIS_ACCOUNT'),(817,'STR_DELETE_THIS_ACCOUNT_TYPE'),(818,'STR_DELETE_THIS_BILL'),(819,'STR_DELETE_THIS_BINDERY_FUNCTION'),(820,'STR_DELETE_THIS_BINDERY_FUNCTION_SIZE_PRICING'),(821,'STR_DELETE_THIS_BINDERY_TYPE'),(822,'STR_DELETE_THIS_CARRIER'),(823,'STR_DELETE_THIS_CATEGORY'),(824,'STR_DELETE_THIS_COMPANY'),(825,'STR_DELETE_THIS_COST_CENTER'),(826,'STR_DELETE_THIS_COST_CENTER_MACHINE_FAMILY'),(827,'STR_DELETE_THIS_CUSTOMER'),(828,'STR_DELETE_THIS_DEDUCTION_GROUP'),(829,'STR_DELETE_THIS_INK'),(830,'STR_DELETE_THIS_INVOICE'),(831,'STR_DELETE_THIS_ITEM_CATEGORY'),(832,'STR_DELETE_THIS_LOCATION'),(833,'STR_DELETE_THIS_MACHINE'),(834,'STR_DELETE_THIS_MARKUP_SET'),(835,'STR_DELETE_THIS_METHOD'),(836,'STR_DELETE_THIS_NOTE'),(837,'STR_DELETE_THIS_OPERATION'),(838,'STR_DELETE_THIS_PART'),(839,'STR_DELETE_THIS_PAYMENT_TYPE'),(840,'STR_DELETE_THIS_PLAN'),(841,'STR_DELETE_THIS_PO'),(842,'STR_DELETE_THIS_PRESS_TOOL'),(843,'STR_DELETE_THIS_PRICE_LEVEL'),(844,'STR_DELETE_THIS_PRICE_LIST'),(845,'STR_DELETE_THIS_PRICE_LIST_STOCK'),(846,'STR_DELETE_THIS_QUESTION'),(847,'STR_DELETE_THIS_QUOTE_COMMENT'),(848,'STR_DELETE_THIS_REVIEW'),(849,'STR_DELETE_THIS_REVIEW_RATING'),(850,'STR_DELETE_THIS_SALES_TAX'),(851,'STR_DELETE_THIS_SALESPERSON'),(852,'STR_DELETE_THIS_SHIP_TO_ADDRESS'),(853,'STR_DELETE_THIS_SHIPTO_LOCATION'),(854,'STR_DELETE_THIS_STANDARD_SIZE'),(855,'STR_DELETE_THIS_TAX_EXEMPTION'),(856,'STR_DELETE_THIS_TAX_TYPE'),(857,'STR_DELETE_THIS_UNIT_NAME'),(858,'STR_DELETE_THIS_USER'),(859,'STR_DELETE_THIS_USER_FROM_EXTERNAL_ACCESS'),(860,'STR_DELETE_THIS_VENDOR'),(861,'STR_DELETE_THIS_VOUCHER'),(862,'STR_DELETE_THIS_WORK_TYPE'),(863,'STR_DELETE_VENDOR_FOR_THIS_ITEM'),(864,'STR_DELETED_SUCCESSFULLY'),(865,'STR_DELIVERY'),(866,'STR_DEMO_MODE'),(867,'STR_DEPOSIT_CHECK'),(868,'STR_DEPOSIT_CHECK_VOID_MESSAGE'),(869,'STR_DESCRIPTION'),(870,'STR_DESCRIPTION_FOR_PRODUCT_CATALOG'),(871,'STR_DESCRIPTION_OF_CONTENTS'),(872,'STR_DESCRIPTIONC'),(873,'STR_DESCRIPTIONS_ONLY'),(874,'STR_DETAIL'),(875,'STR_DETAIL_WORK_TYPE'),(876,'STR_DETAIL_WORK_TYPE_ADD_FOR_GEN_WORK_TYPE'),(877,'STR_DETAIL_WORK_TYPE_ADDED_SUCCESSFULLY'),(878,'STR_DETAIL_WORK_TYPE_DELETED_SUCCESSFULLY'),(879,'STR_DETAIL_WORK_TYPE_UPDATED_SUCCESSFULLY'),(880,'STR_DID_NOT_GET_A_NEW_VOUCHER_ID'),(881,'STR_DIE'),(882,'STR_DIFFERENCE'),(883,'STR_DIFFERENT_CUSTOMER'),(884,'STR_DIFFERENT_SHIPTO'),(885,'STR_DIGITAL'),(886,'STR_DISCOUNT'),(887,'STR_DISCOUNT_ACCOUNT'),(888,'STR_DISCOUNT_AFTER_DUEDATE'),(889,'STR_DISCOUNT_AGING_REPORT'),(890,'STR_DISCOUNT_AMOUNT'),(891,'STR_DISCOUNT_CUTOFF_DATE'),(892,'STR_DISCOUNT_DATE'),(893,'STR_DISCOUNT_DAY_OF_MONTH_PROX'),(894,'STR_DISCOUNT_DAYS'),(895,'STR_DISCOUNT_EARNED'),(896,'STR_DISCOUNT_GIVEN'),(897,'STR_DISCOUNT_LOST'),(898,'STR_DISCOUNT_PERCENT'),(899,'STR_DISCOUNT_TAKEN'),(900,'STR_DISCOUNTS_TAKEN'),(901,'STR_DISPLAY_CALENDAR'),(902,'STR_DISPLAY_ORDER'),(903,'STR_DISPLAY_QUESTION'),(904,'STR_DISTRIBUTION'),(905,'STR_DO_NOT_COPY_NOW'),(906,'STR_DO_NOT_SHOW_INVOICES_ENTERED_IN_LAST'),(907,'STR_DOCUMENT'),(908,'STR_DOCUMENT_CHECK_IN'),(909,'STR_DOCUMENT_CREATED_ON'),(910,'STR_DOCUMENT_HAS_BEEN_MARKED_AS_FINAL'),(911,'STR_DOCUMENT_LISTING'),(912,'STR_DOCUMENT_MANAGER'),(913,'STR_DOCUMENT_MANAGER_CATEGORY_ADD'),(914,'STR_DOCUMENT_MANAGER_CATEGORY_UPDATE'),(915,'STR_DOCUMENT_NOT_FOUND_OR_ALREADY_CHECKED_OUT'),(916,'STR_DOCUMENT_PROPERTIES'),(917,'STR_DOCUMENT_REVISION_HISTORY'),(918,'STR_DOCUMENT_SUCCESSFULLY_ADDED'),(919,'STR_DOCUMENT_SUCCESSFULLY_CHECKED_IN'),(920,'STR_DOCUMENT_SUCCESSFULLY_DELETED'),(921,'STR_DOCUMENT_SUCCESSFULLY_UPDATED'),(922,'STR_DOCUMENTS_CHECKED_OUT_TO_YOU'),(923,'STR_DOCUMENTS_CURRENTLY_CHECKED_OUT_TO_YOU'),(924,'STR_DOES_NOT_USE_OTHER_PRICE_LIST'),(925,'STR_DOESNT_EXIST'),(926,'STR_DOLLAR_AMOUNT'),(927,'STR_DOLLARS'),(928,'STR_DOLLARS_AND'),(929,'STR_DOWNLOAD_ACCOUNT_LIST'),(930,'STR_DOWNLOAD_HERE'),(931,'STR_DUE'),(932,'STR_DUE_DATE'),(933,'STR_DUE_DATE_TIME'),(934,'STR_DUE_DATEC'),(935,'STR_DUE_TIME'),(936,'STR_DUPE_ACCOUNT_TYPE'),(937,'STR_DUPLICATE_SORTORDER_FOR'),(938,'STR_EACH'),(939,'STR_EARLY'),(940,'STR_EARNED_INCOME_CREDIT'),(941,'STR_EDIT'),(942,'STR_EDIT_ACTION'),(943,'STR_EDIT_AN_EXISTING_GL_ACCOUNT'),(944,'STR_EDIT_ANOTHER_ACCOUNT'),(945,'STR_EDIT_ANOTHER_EMPLOYEE'),(946,'STR_EDIT_ANOTHER_GL_ACCOUNT'),(947,'STR_EDIT_ANOTHER_SALES_PROCESS'),(948,'STR_EDIT_ANOTHER_SALESMAN'),(949,'STR_EDIT_ANOTHER_VOUCHER'),(950,'STR_EDIT_BUDGET'),(951,'STR_EDIT_BUILD_ORDER'),(952,'STR_EDIT_BUILD_ORDERS'),(953,'STR_EDIT_CATEGORY'),(954,'STR_EDIT_CURRENT_EMPLOYEES'),(955,'STR_EDIT_DELETE_A_BUDGET'),(956,'STR_EDIT_DOCUMENT_PROPERTIES'),(957,'STR_EDIT_EXISTING_ACTION'),(958,'STR_EDIT_EXISTING_CATEGORY'),(959,'STR_EDIT_FINALIZE_BUILD_ORDER'),(960,'STR_EDIT_OPERATION'),(961,'STR_EDIT_PO_NUMBER'),(962,'STR_EDIT_SALESPERSON_DATA'),(963,'STR_EDIT_SALES_PROCESS'),(964,'STR_EDIT_SELECTED_COMPANY'),(965,'STR_EDIT_SELECTED_USER'),(966,'STR_EDIT_SELECTION'),(967,'STR_EDIT_SHIPTO'),(968,'STR_EDIT_SLICE_DETAILS'),(969,'STR_EDIT_USER_LOGIN_RIGHTS'),(970,'STR_EDIT_VENDORS_FOR_ITEM'),(971,'STR_EDIT_VOUCHER'),(972,'STR_EDIT_WHICH_INFORMATION'),(973,'STR_EIC'),(974,'STR_EIC_CREDIT'),(975,'STR_EIC_MARRIED'),(976,'STR_EIC_SINGLE'),(977,'STR_EIGHT'),(978,'STR_EIGHTEEN'),(979,'STR_EIGHTY'),(980,'STR_ELEVEN'),(981,'STR_EMAIL'),(982,'STR_EMAIL_ADDRESS'),(983,'STR_EMAIL_DESCRIPTION'),(984,'STR_EMAIL_ONE'),(985,'STR_EMAIL_QUOTE'),(986,'STR_EMAIL_SENT_TO'),(987,'STR_EMAIL_TO_CUSTOMER'),(988,'STR_EMAIL_TWO'),(989,'STR_EMPLOYEE'),(990,'STR_EMPLOYEE_ACTIVE_STATUS_CHANGED_SUCCESSFULLY'),(991,'STR_EMPLOYEE_ADDED_SUCCESSFULLY'),(992,'STR_EMPLOYEE_CURRENTLY_INACTIVE'),(993,'STR_EMPLOYEE_DEDUCTIONS'),(994,'STR_EMPLOYEE_FICA_MEDICARE'),(995,'STR_EMPLOYEE_HOURS_ADDED_SUCCESSFULLY'),(996,'STR_EMPLOYEE_LIST'),(997,'STR_EMPLOYEE_MUST_PARTICIPATE'),(998,'STR_EMPLOYEE_NOT_FOUND'),(999,'STR_EMPLOYEE_RATING_ADD'),(1000,'STR_EMPLOYEE_RATING_UPDATE'),(1001,'STR_EMPLOYEE_REVIEW_ADD'),(1002,'STR_EMPLOYEE_REVIEW_ADDED_SUCCESSFULLY'),(1003,'STR_EMPLOYEE_REVIEW_DELETED_SUCCESSFULLY'),(1004,'STR_EMPLOYEE_REVIEW_NOT_FOUND'),(1005,'STR_EMPLOYEE_REVIEW_UPDATE'),(1006,'STR_EMPLOYEE_REVIEW_UPDATED_SUCCESSFULLY'),(1007,'STR_EMPLOYEE_SELECTION'),(1008,'STR_EMPLOYEE_TERMINATED_SUCCESSFULLY'),(1009,'STR_EMPLOYEE_UPDATED_SUCCESSFULLY'),(1010,'STR_EMPLOYER_CONTRIBUTES_HOW'),(1011,'STR_EMPLOYER_CONTRIBUTION'),(1012,'STR_ENCOUNTERED_AN_ERROR_IN_STEP'),(1013,'STR_END'),(1014,'STR_END_DATE'),(1015,'STR_END_DATE_OF_CHECKS'),(1016,'STR_END_DATE_OF_INVOICE'),(1017,'STR_END_DUE_DATE'),(1018,'STR_END_ONEWORD'),(1019,'STR_END_PERIOD'),(1020,'STR_END_SELECTIONS'),(1021,'STR_END_YR_MO'),(1022,'STR_ENDING_BALANCE'),(1023,'STR_ENDING_EVALUATION_DATE'),(1024,'STR_ENDING_MONTH'),(1025,'STR_ENDORSER'),(1026,'STR_ENGLISH'),(1027,'STR_ENTER_COMPOSITE_ITEMS_NOW'),(1028,'STR_ENTER_COST_OF_GOODS'),(1029,'STR_ENTER_MORE_HOURS'),(1030,'STR_ENTER_TIME_MATERIALS'),(1031,'STR_ENTERED'),(1032,'STR_ENTERED_BY'),(1033,'STR_ENTERPRISE_BUSINESS'),(1034,'STR_ENTIRE_QUANTITY_NOT_YET_SHIPPED'),(1035,'STR_ENTRY_CONFLICTS_WITH_ACCOUNT'),(1036,'STR_ENTRY_DATE'),(1037,'STR_ENTRY_FROM'),(1038,'STR_ENTRY_INSERT'),(1039,'STR_EQUIP'),(1040,'STR_EQUITY'),(1041,'STR_ERR_VOUCH1'),(1042,'STR_ERR_VOUCH2'),(1043,'STR_ERR_VOUCH3'),(1044,'STR_ERR_VOUCH4'),(1045,'STR_ERR_VOUCH5'),(1046,'STR_ERR_VOUCH6'),(1047,'STR_ERROR'),(1048,'STR_ERROR_ADDING_ACCOUNT'),(1049,'STR_ERROR_ADDING_ACCOUNT_DUPE'),(1050,'STR_ERROR_ADDING_ACCOUNT_DUPE_D'),(1051,'STR_ERROR_ADDING_ACCOUNT_TYPE'),(1052,'STR_ERROR_ADDING_BILL'),(1053,'STR_ERROR_ADDING_BILL_DETAIL'),(1054,'STR_ERROR_ADDING_BILL_DETAILS'),(1055,'STR_ERROR_ADDING_BINDERY_FUNCTION'),(1056,'STR_ERROR_ADDING_BINDERY_FUNCTION_SIZE'),(1057,'STR_ERROR_ADDING_BINDERY_OPTION_LIST_ITEM'),(1058,'STR_ERROR_ADDING_BINDERY_TYPE'),(1059,'STR_ERROR_ADDING_BINDERY_WORK_TYPE'),(1060,'STR_ERROR_ADDING_CARRIER'),(1061,'STR_ERROR_ADDING_CATEGORY_DUPE'),(1062,'STR_ERROR_ADDING_CHECK'),(1063,'STR_ERROR_ADDING_CHECK_OUT_IN_INFO'),(1064,'STR_ERROR_ADDING_CHECKING_ACCOUNT'),(1065,'STR_ERROR_ADDING_COLOR'),(1066,'STR_ERROR_ADDING_COMPANY'),(1067,'STR_ERROR_ADDING_COMPANY_DUPE'),(1068,'STR_ERROR_ADDING_COST_CENTER'),(1069,'STR_ERROR_ADDING_COST_CENTER_FAMILY'),(1070,'STR_ERROR_ADDING_CUSTOMER'),(1071,'STR_ERROR_ADDING_CUSTOMER_SHIPTO'),(1072,'STR_ERROR_ADDING_DEDUCTION_GROUP'),(1073,'STR_ERROR_ADDING_DETAIL_WORK_TYPE'),(1074,'STR_ERROR_ADDING_EMPLOYEE'),(1075,'STR_ERROR_ADDING_EMPLOYEE_REVIEW'),(1076,'STR_ERROR_ADDING_GENERAL_CUTTING_INFO'),(1077,'STR_ERROR_ADDING_GENERAL_WORK_TYPE'),(1078,'STR_ERROR_ADDING_GL_PIE_SLICE_DETAIL'),(1079,'STR_ERROR_ADDING_GL_TRANSACTION'),(1080,'STR_ERROR_ADDING_GL_TRANSACTION_DETAILS'),(1081,'STR_ERROR_ADDING_GL_TRANSACTION_DETAILS_BILL'),(1082,'STR_ERROR_ADDING_GL_TRANSVOUCHER_RECORD'),(1083,'STR_ERROR_ADDING_GL_TRANSVOUCHER_RECORD_BILL'),(1084,'STR_ERROR_ADDING_GL_TRANSVOUCHER_RECORD_EMPLOYEE'),(1085,'STR_ERROR_ADDING_GL_VOUCHER'),(1086,'STR_ERROR_ADDING_GL_VOUCHER_RECORD'),(1087,'STR_ERROR_ADDING_INK'),(1088,'STR_ERROR_ADDING_INK_INFO'),(1089,'STR_ERROR_ADDING_INVENTORY_LOCATION'),(1090,'STR_ERROR_ADDING_INVOICE_TERMS'),(1091,'STR_ERROR_ADDING_ITEM'),(1092,'STR_ERROR_ADDING_ITEM_CATEGORY'),(1093,'STR_ERROR_ADDING_ITEM_COMPOSITE'),(1094,'STR_ERROR_ADDING_ITEM_LOCATION'),(1095,'STR_ERROR_ADDING_ITEM_LOCATION_PRICING'),(1096,'STR_ERROR_ADDING_ITEM_LOCATION_PRICING_DISCOUNTS'),(1097,'STR_ERROR_ADDING_MACHINE'),(1098,'STR_ERROR_ADDING_MARKUP_SET_FOR_LEVEL'),(1099,'STR_ERROR_ADDING_NONPRINT_OPERATION_SIZE'),(1100,'STR_ERROR_ADDING_NONPRINTING_MATERIAL'),(1101,'STR_ERROR_ADDING_NONPRINTING_PRICE_LIST'),(1102,'STR_ERROR_ADDING_NONPRINTING_PRICE_LIST_OPERATION'),(1103,'STR_ERROR_ADDING_NOTES_FOR_QUOTE'),(1104,'STR_ERROR_ADDING_OPTION_SIZE_PRICING_INFO'),(1105,'STR_ERROR_ADDING_PAY_TYPE'),(1106,'STR_ERROR_ADDING_PAYMENT'),(1107,'STR_ERROR_ADDING_PRICE_LEVEL'),(1108,'STR_ERROR_ADDING_PRICE_LIST'),(1109,'STR_ERROR_ADDING_PRICE_LIST_STOCK'),(1110,'STR_ERROR_ADDING_PRICE_LIST_STOCK_USAGE'),(1111,'STR_ERROR_ADDING_PRICE_LIST_STOCK_USAGE_STOCK_LIST'),(1112,'STR_ERROR_ADDING_PRINT_LOCATION'),(1113,'STR_ERROR_ADDING_QUOTE'),(1114,'STR_ERROR_ADDING_QUOTE_COMMENT'),(1115,'STR_ERROR_ADDING_RECEIPT_FOR_THIS_ITEM'),(1116,'STR_ERROR_ADDING_REVIEW_RATING'),(1117,'STR_ERROR_ADDING_SALES_PERSONNEL'),(1118,'STR_ERROR_ADDING_SALES_TAX'),(1119,'STR_ERROR_ADDING_SHIPPING_METHOD'),(1120,'STR_ERROR_ADDING_STANDARD_MARKUP_SET'),(1121,'STR_ERROR_ADDING_STANDARD_SIZE'),(1122,'STR_ERROR_ADDING_STOCK'),(1123,'STR_ERROR_ADDING_SUBGROUP'),(1124,'STR_ERROR_ADDING_TAX_EXEMPTION'),(1125,'STR_ERROR_ADDING_TRACKING_INFO'),(1126,'STR_ERROR_ADDING_UNIT_NAME'),(1127,'STR_ERROR_ADDING_USER'),(1128,'STR_ERROR_ADDING_USER_DUPE'),(1129,'STR_ERROR_ADDING_VENDOR'),(1130,'STR_ERROR_ADDING_VENDOR_ITEM_INFORMATION'),(1131,'STR_ERROR_ADDING_VENDOR_TERMS'),(1132,'STR_ERROR_ADDING_VOUCHER_DETAIL_TO_MAIN_DATABASE'),(1133,'STR_ERROR_ADDING_VOUCHER_INFO_TO_MAIN_DATABASE'),(1134,'STR_ERROR_ADDING_VOUCHER_TO_MAIN_DATABASE'),(1135,'STR_ERROR_ADDING_WORK_TYPE'),(1136,'STR_ERROR_ADDING_WORK_TYPE_ADDL_INFO'),(1137,'STR_ERROR_BEGINNING_YEAR'),(1138,'STR_ERROR_COULD_NOT_POST_VOUCHER'),(1139,'STR_ERROR_CREATING_INVOICE_FOR'),(1140,'STR_ERROR_CREATING_PAYABLES'),(1141,'STR_ERROR_CREATING_TABLE_GLTRANSACTION'),(1142,'STR_ERROR_CREATING_TABLE_VOUCHER'),(1143,'STR_ERROR_DELETING'),(1144,'STR_ERROR_DELETING_ACCOUNT'),(1145,'STR_ERROR_DELETING_ACCOUNT_TYPE'),(1146,'STR_ERROR_DELETING_BILL'),(1147,'STR_ERROR_DELETING_BILL_DETAIL'),(1148,'STR_ERROR_DELETING_BINDERY_FUNCTION'),(1149,'STR_ERROR_DELETING_BINDERY_FUNCTION_SIZE'),(1150,'STR_ERROR_DELETING_BINDERY_OPTION_LIST_ITEM'),(1151,'STR_ERROR_DELETING_BINDERY_TYPE'),(1152,'STR_ERROR_DELETING_BINDERY_WORK_TYPE'),(1153,'STR_ERROR_DELETING_CARRIER'),(1154,'STR_ERROR_DELETING_CHECK'),(1155,'STR_ERROR_DELETING_CHECKING_ACCOUNT'),(1156,'STR_ERROR_DELETING_COLOR'),(1157,'STR_ERROR_DELETING_COMPANY'),(1158,'STR_ERROR_DELETING_COST_CENTER'),(1159,'STR_ERROR_DELETING_COST_CENTER_MACHINE_FAMILY'),(1160,'STR_ERROR_DELETING_CUSTOMER'),(1161,'STR_ERROR_DELETING_CUSTOMER_SHIPTO'),(1162,'STR_ERROR_DELETING_DEDUCTION_GROUP'),(1163,'STR_ERROR_DELETING_DETAIL_WORK_TYPE'),(1164,'STR_ERROR_DELETING_EMPLOYEE_REVIEW'),(1165,'STR_ERROR_DELETING_GENERAL_WORK_TYPE'),(1166,'STR_ERROR_DELETING_GL_PIE'),(1167,'STR_ERROR_DELETING_GL_PIE_SLICE'),(1168,'STR_ERROR_DELETING_GL_PIE_SLICE_DETAIL'),(1169,'STR_ERROR_DELETING_GL_TRANSACTIONS'),(1170,'STR_ERROR_DELETING_GL_TRANSVOUCHER'),(1171,'STR_ERROR_DELETING_INK'),(1172,'STR_ERROR_DELETING_INVENTORY_LOCATION'),(1173,'STR_ERROR_DELETING_INVENTORY_PO'),(1174,'STR_ERROR_DELETING_INVOICE'),(1175,'STR_ERROR_DELETING_INVOICE_TERMS'),(1176,'STR_ERROR_DELETING_ITEM_CATEGORY'),(1177,'STR_ERROR_DELETING_ITEM_VENDOR_INFORMATION'),(1178,'STR_ERROR_DELETING_MACHINE'),(1179,'STR_ERROR_DELETING_MARKUP_SET'),(1180,'STR_ERROR_DELETING_MARKUP_SET_FOR_LEVEL'),(1181,'STR_ERROR_DELETING_NONPRINT_OPERATION_SIZE'),(1182,'STR_ERROR_DELETING_NONPRINTING_MATERIAL'),(1183,'STR_ERROR_DELETING_NONPRINTING_PRICE_LIST'),(1184,'STR_ERROR_DELETING_NONPRINTING_PRICE_LIST_OPERATION'),(1185,'STR_ERROR_DELETING_ORDER'),(1186,'STR_ERROR_DELETING_PAY_TYPE'),(1187,'STR_ERROR_DELETING_PRESS_TOOL'),(1188,'STR_ERROR_DELETING_PRICE_LEVEL'),(1189,'STR_ERROR_DELETING_PRICE_LIST'),(1190,'STR_ERROR_DELETING_PRICE_LIST_PART_PRICING'),(1191,'STR_ERROR_DELETING_PRICE_LIST_STOCK'),(1192,'STR_ERROR_DELETING_PRICE_LIST_STOCK_USAGE'),(1193,'STR_ERROR_DELETING_PRICE_LIST_STOCK_USAGE_PRICING'),(1194,'STR_ERROR_DELETING_PRICE_LIST_STOCK_USAGE_STOCK_LIST'),(1195,'STR_ERROR_DELETING_PRINT_LOCATION'),(1196,'STR_ERROR_DELETING_QUOTE'),(1197,'STR_ERROR_DELETING_QUOTE_COMMENT'),(1198,'STR_ERROR_DELETING_QUOTE_NOTES'),(1199,'STR_ERROR_DELETING_REVIEW_RATING'),(1200,'STR_ERROR_DELETING_SALES_PERSONNEL'),(1201,'STR_ERROR_DELETING_SALES_TAX'),(1202,'STR_ERROR_DELETING_SHIPPING_METHOD'),(1203,'STR_ERROR_DELETING_STANDARD_QUANTITY'),(1204,'STR_ERROR_DELETING_SUBGROUP'),(1205,'STR_ERROR_DELETING_TAX_EXEMPTION'),(1206,'STR_ERROR_DELETING_UNIT_NAME'),(1207,'STR_ERROR_DELETING_USER'),(1208,'STR_ERROR_DELETING_VENDOR'),(1209,'STR_ERROR_DELETING_WORK_TYPE'),(1210,'STR_ERROR_DELETING_WORK_TYPE_QUESTION'),(1211,'STR_ERROR_DISCOUNT_VENDOR'),(1212,'STR_ERROR_DROPPING_TABLE_GLTRANSACTION'),(1213,'STR_ERROR_DROPPING_TABLE_VOUCHER'),(1214,'STR_ERROR_FINALIZING_ORDER'),(1215,'STR_ERROR_FINALIZING_ORDER_SUB'),(1216,'STR_ERROR_FISCAL_BEGIN_DATE'),(1217,'STR_ERROR_INSERTING_INV_PO_DETAIL'),(1218,'STR_ERROR_INSERTING_INVENTORY_PO'),(1219,'STR_ERROR_INSERTING_INVOICE'),(1220,'STR_ERROR_INSERTING_INVOICE_DETAILS'),(1221,'STR_ERROR_INSERTING_INVOICE_NOTE'),(1222,'STR_ERROR_INSERTING_INVOICE_TAX_DETAILS'),(1223,'STR_ERROR_INSERTING_ORDER_NOTES'),(1224,'STR_ERROR_LOCATION_EXISTS'),(1225,'STR_ERROR_MESSAGE'),(1226,'STR_ERROR_POSTING_VOUCHER'),(1227,'STR_ERROR_RECEIVE_RECORD'),(1228,'STR_ERROR_RETRIEVING_BUDGET'),(1229,'STR_ERROR_RETRIEVING_BUILD_ORDER'),(1230,'STR_ERROR_RETRIEVING_CUSTOMERS'),(1231,'STR_ERROR_RETRIEVING_FINALIZED_BUILDORDER_INFO'),(1232,'STR_ERROR_RETRIEVING_GL_ACCOUNTS'),(1233,'STR_ERROR_RETRIEVING_INVENTORY_LOCATIONS'),(1234,'STR_ERROR_RETRIEVING_ITEM_ORDERS'),(1235,'STR_ERROR_RETRIEVING_LINE_ITEMS'),(1236,'STR_ERROR_RETRIEVING_MAX_CODE_LENGTH'),(1237,'STR_ERROR_RETRIEVING_SUBCOMPONENT_ITEMS'),(1238,'STR_ERROR_RETRIEVING_VENDOR_INFORMATION'),(1239,'STR_ERROR_RETRIEVING_VENDORS'),(1240,'STR_ERROR_RETRIEVING_VOUCHER_INFORMATION_FROM_MAIN_DATABASE'),(1241,'STR_ERROR_SEARCHING_FOR_VENDORID'),(1242,'STR_ERROR_TOO_MANY_LINE_ITEMS'),(1243,'STR_ERROR_UPDATING_ACCOUNT'),(1244,'STR_ERROR_UPDATING_ACCOUNT_TYPE'),(1245,'STR_ERROR_UPDATING_ADDING_MARKUP_SET_FOR_LEVEL'),(1246,'STR_ERROR_UPDATING_BILL'),(1247,'STR_ERROR_UPDATING_BILL_DETAIL'),(1248,'STR_ERROR_UPDATING_BILL_PAYMENT'),(1249,'STR_ERROR_UPDATING_BINDERY_FUNCTION'),(1250,'STR_ERROR_UPDATING_BINDERY_FUNCTION_SIZE'),(1251,'STR_ERROR_UPDATING_BINDERY_OPTION_LIST_ITEM'),(1252,'STR_ERROR_UPDATING_BINDERY_TYPE'),(1253,'STR_ERROR_UPDATING_BUDGET_FOR_YEAR'),(1254,'STR_ERROR_UPDATING_CARRIER'),(1255,'STR_ERROR_UPDATING_CHECK'),(1256,'STR_ERROR_UPDATING_CHECKING_ACCOUNT'),(1257,'STR_ERROR_UPDATING_COLOR'),(1258,'STR_ERROR_UPDATING_COMPANY'),(1259,'STR_ERROR_UPDATING_COMPOSITE'),(1260,'STR_ERROR_UPDATING_COMPOSITE_SUB_ITEM_ON_HAND_QUANTITY'),(1261,'STR_ERROR_UPDATING_COST_CENTER'),(1262,'STR_ERROR_UPDATING_COST_CENTER_FAMILY'),(1263,'STR_ERROR_UPDATING_CUSTOMER'),(1264,'STR_ERROR_UPDATING_CUSTOMER_SHIPTO'),(1265,'STR_ERROR_UPDATING_DEDUCTION_GROUP'),(1266,'STR_ERROR_UPDATING_DETAIL_WORK_TYPE'),(1267,'STR_ERROR_UPDATING_EMPLOYEE'),(1268,'STR_ERROR_UPDATING_EMPLOYEE_REVIEW'),(1269,'STR_ERROR_UPDATING_GENERAL_CUTTING_INFO'),(1270,'STR_ERROR_UPDATING_GENERAL_WORK_TYPE'),(1271,'STR_ERROR_UPDATING_GL_PIE'),(1272,'STR_ERROR_UPDATING_GL_PIE_SLICE'),(1273,'STR_ERROR_UPDATING_GL_PIE_SLICE_DETAIL'),(1274,'STR_ERROR_UPDATING_INK'),(1275,'STR_ERROR_UPDATING_INK_INFO'),(1276,'STR_ERROR_UPDATING_INVENTORY_PO'),(1277,'STR_ERROR_UPDATING_INVENTORY_PO_DETAILS'),(1278,'STR_ERROR_UPDATING_INVOICE'),(1279,'STR_ERROR_UPDATING_INVOICE_TERMS'),(1280,'STR_ERROR_UPDATING_ITEM'),(1281,'STR_ERROR_UPDATING_ITEM_CATEGORY'),(1282,'STR_ERROR_UPDATING_ITEM_COMPOSITE'),(1283,'STR_ERROR_UPDATING_ITEM_LOCATION'),(1284,'STR_ERROR_UPDATING_ITEM_LOCATION_COST'),(1285,'STR_ERROR_UPDATING_ITEM_ON_HAND_QUANTITY'),(1286,'STR_ERROR_UPDATING_MACHINE'),(1287,'STR_ERROR_UPDATING_NONPRINTING_MATERIAL'),(1288,'STR_ERROR_UPDATING_NONPRINTING_OPERATION'),(1289,'STR_ERROR_UPDATING_NONPRINTING_PRICE_LIST'),(1290,'STR_ERROR_UPDATING_NONPRINTING_PRICE_LIST_OPERATION'),(1291,'STR_ERROR_UPDATING_OPTION_SIZE_PRICING_INFO'),(1292,'STR_ERROR_UPDATING_PAY_TYPE'),(1293,'STR_ERROR_UPDATING_PO'),(1294,'STR_ERROR_UPDATING_PRBENDED'),(1295,'STR_ERROR_UPDATING_PRCOMPANY'),(1296,'STR_ERROR_UPDATING_PRESS_TOOL'),(1297,'STR_ERROR_UPDATING_PRICE_LEVEL'),(1298,'STR_ERROR_UPDATING_PRICE_LIST'),(1299,'STR_ERROR_UPDATING_PRICE_LIST_STOCK'),(1300,'STR_ERROR_UPDATING_PRICE_LIST_STOCK_USAGE'),(1301,'STR_ERROR_UPDATING_PRICE_LIST_STOCK_USAGE_STOCK_LIST'),(1302,'STR_ERROR_UPDATING_PRPENSION'),(1303,'STR_ERROR_UPDATING_PRVACATION'),(1304,'STR_ERROR_UPDATING_QUOTE'),(1305,'STR_ERROR_UPDATING_QUOTE_COMMENT'),(1306,'STR_ERROR_UPDATING_QUOTE_NOTES'),(1307,'STR_ERROR_UPDATING_RECEIPT_FOR_THIS_ITEM'),(1308,'STR_ERROR_UPDATING_RECEIVE_ERROR'),(1309,'STR_ERROR_UPDATING_REVIEW_RATING'),(1310,'STR_ERROR_UPDATING_SALES_PERSONNEL'),(1311,'STR_ERROR_UPDATING_SALES_TAX'),(1312,'STR_ERROR_UPDATING_SHIPPING_METHOD'),(1313,'STR_ERROR_UPDATING_STANDARD_MARKUP_SET'),(1314,'STR_ERROR_UPDATING_STANDARD_QUANTITY'),(1315,'STR_ERROR_UPDATING_STANDARD_SIZE'),(1316,'STR_ERROR_UPDATING_STOCK'),(1317,'STR_ERROR_UPDATING_SUBGROUP'),(1318,'STR_ERROR_UPDATING_TAX_EXEMPTION'),(1319,'STR_ERROR_UPDATING_UNIT_NAME'),(1320,'STR_ERROR_UPDATING_USER'),(1321,'STR_ERROR_UPDATING_USER_RIGHTS'),(1322,'STR_ERROR_UPDATING_VENDOR'),(1323,'STR_ERROR_UPDATING_VENDOR_ITEM_INFORMATION'),(1324,'STR_ERROR_UPDATING_VENDOR_TERMS'),(1325,'STR_ERROR_UPDATING_WORK_TYPE'),(1326,'STR_ERROR_UPDATING_WORK_TYPE_ADDL_INFO'),(1327,'STR_ERROR_VENDOR'),(1328,'STR_ERROR_VENDOR_ITEM_ALREADY_EXISTS'),(1329,'STR_ERROR_VENDOR_NOT_FOUND'),(1330,'STR_ERROR_VENDOR_NOT_FOUND_OR'),(1331,'STR_ERROR_VOIDING_CHECK'),(1332,'STR_ERROR_VOUCHER_ID_NOT_PASSED'),(1333,'STR_ERROR_WHEN_COPYING'),(1334,'STR_ERROR_WHEN_COPYING_UPLOADED'),(1335,'STR_EST_AMOUNT'),(1336,'STR_EST_AMOUNT2'),(1337,'STR_ESTIMATED'),(1338,'STR_ESTIMATED_SHIPPING'),(1339,'STR_ESTIMATING'),(1340,'STR_ESTIMATING_QUOTE_ADD'),(1341,'STR_ESTIMATING_QUOTE_UPDATE'),(1342,'STR_ESTQUOTEPRICELISTPRICE_INSERT_FAILED'),(1343,'STR_EVALUATION_DATE'),(1344,'STR_EVALUATOR'),(1345,'STR_EVALUATOR_NAME'),(1346,'STR_EX_REASON'),(1347,'STR_EXCELLENT'),(1348,'STR_EXEMPT'),(1349,'STR_EXEMPT_SALES'),(1350,'STR_EXEMPT_SHIPPING'),(1351,'STR_EXEMPTION_BEFORE_TAX_CALCULATED'),(1352,'STR_EXEMPTIONS'),(1353,'STR_EXPENSES'),(1354,'STR_EXPORT'),(1355,'STR_EXPORT_ACCOUNTS'),(1356,'STR_EXPORT_REPORT'),(1357,'STR_EXTENDED_PRICE'),(1358,'STR_EXTERNAL'),(1359,'STR_EXTERNAL_USER_ALREADY_EXISTS'),(1360,'STR_EXTLOGON_PASSED_BUT'),(1361,'STR_EXTRA_CIT_BASED_ON'),(1362,'STR_EXTRA_CIT_PER_PAY_PERIOD'),(1363,'STR_EXTRA_FIT_BASED_ON'),(1364,'STR_EXTRA_FIT_PER_PAY_PERIOD'),(1365,'STR_EXTRA_LIT_BASED_ON'),(1366,'STR_EXTRA_LIT_PER_PAY_PERIOD'),(1367,'STR_EXTRA_SIT_BASED_ON'),(1368,'STR_EXTRA_SIT_PER_PAY_PERIOD'),(1369,'STR_FACTORY_OVERHEAD_PERCENT'),(1370,'STR_FAILED_NO_PERMISSION'),(1371,'STR_FAILED_TO_BALANCE'),(1372,'STR_FAIR'),(1373,'STR_FAX'),(1374,'STR_FEATURES'),(1375,'STR_FEBRUARY'),(1376,'STR_FED'),(1377,'STR_FED_TAX'),(1378,'STR_FED_TAX2'),(1379,'STR_FEDERAL'),(1380,'STR_FEDERAL_EXEMPTIONS'),(1381,'STR_FEDERAL_ID'),(1382,'STR_FEDERAL_ID_NUMBER'),(1383,'STR_FEDERAL_INCOME_TAX'),(1384,'STR_FEDERAL_INCOME_TAX_PAYABLE'),(1385,'STR_FEDERAL_TAX'),(1386,'STR_FEDERAL_TAX_ID'),(1387,'STR_FEDERAL_TAX_PERCENT'),(1388,'STR_FEDERAL_UNEMPLOYMENT_INSURANCE'),(1389,'STR_FEDERAL_UNEMPLOYMENT_TAX'),(1390,'STR_FEDERAL_UNEMPLOYMENT_TAX_EXPENSE'),(1391,'STR_FEDERAL_UNEMPLOYMENT_TAX_PAYABLE'),(1392,'STR_FEDERAL_WH'),(1393,'STR_FEET_LENGTH'),(1394,'STR_FICA'),(1395,'STR_FICA_COMPANY_EXPENSE'),(1396,'STR_FICA_PAYABLE'),(1397,'STR_FICA_TAX'),(1398,'STR_FICA_WAGES'),(1399,'STR_FICA_WH'),(1400,'STR_FIFTEEN'),(1401,'STR_FIFTY'),(1402,'STR_FILE_COULD_NOT_BE_OPENED'),(1403,'STR_FILE_MUST_NOT_BE'),(1404,'STR_FILE_NOT_FOUND'),(1405,'STR_FILE_SIZE'),(1406,'STR_FILENAMES_ONLY'),(1407,'STR_FILES_REMOVED'),(1408,'STR_FILL_COMPLETED'),(1409,'STR_FILL_IN_FIELDS'),(1410,'STR_FILL_ORDER_START_STOP'),(1411,'STR_FINAL'),(1412,'STR_FINAL_QTY'),(1413,'STR_FINAL_QTY_X_PAGES'),(1414,'STR_FINAL_QTY_X_PAGES_X_SIDES'),(1415,'STR_FINAL_QTY_X_PARTS'),(1416,'STR_FINAL_QTY_X_SIDES_X_PARTS'),(1417,'STR_FINAL_REVISION'),(1418,'STR_FINAL_SHIPMENT'),(1419,'STR_FINAL_TOTALS'),(1420,'STR_FINALIZE_BUILD_ORDER'),(1421,'STR_FINALIZED_BUILD_ORDERS_REPORT'),(1422,'STR_FINISH'),(1423,'STR_FINISH_ADD'),(1424,'STR_FINISHED_GOODS'),(1425,'STR_FINISHED_SIZE'),(1426,'STR_FINISHING_SELECTION'),(1427,'STR_FIRST'),(1428,'STR_FIRST_COST'),(1429,'STR_FIRST_NAME'),(1430,'STR_FIRST_READ_ON'),(1431,'STR_FIRST_USE_CHARGE'),(1432,'STR_FISCAL'),(1433,'STR_FISCAL_BEGIN_MONTH'),(1434,'STR_FISCAL_YEAR'),(1435,'STR_FISCAL_YEAR_BEGIN'),(1436,'STR_FISCAL_YEAR_BEGINS_ON'),(1437,'STR_FISCAL_YEAR_MONTH'),(1438,'STR_FISCAL_YEAR_MONTH_PERIOD'),(1439,'STR_FIT'),(1440,'STR_FIVE'),(1441,'STR_FIXED_ASSETS'),(1442,'STR_FIXED_DOLLAR_AMOUNT'),(1443,'STR_FLAT_PERCENTAGE'),(1444,'STR_FLAT_SIZE'),(1445,'STR_FLEXO'),(1446,'STR_FOR'),(1447,'STR_FOR_ALL_LOCATIONS'),(1448,'STR_FOR_CARRIER'),(1449,'STR_FOR_INVOICES_DUE'),(1450,'STR_FOR_LOCATION'),(1451,'STR_FOR_PRICE_LEVEL'),(1452,'STR_FOR_WORK_TYPE'),(1453,'STR_FOR_YEAR'),(1454,'STR_FORGET_YOUR_PASSWORD'),(1455,'STR_FORM_IS_NOT_BALANCED'),(1456,'STR_FORM_NUMBER'),(1457,'STR_FORMAT_SETUP'),(1458,'STR_FORTY'),(1459,'STR_FOUND_THESE_CATEGORIES'),(1460,'STR_FOUND_THESE_TOPICS'),(1461,'STR_FOUR'),(1462,'STR_FOURTEEN'),(1463,'STR_FREIGHT'),(1464,'STR_FREIGHT_CHARGES'),(1465,'STR_FREIGHT_EXPENSE'),(1466,'STR_FRENCH'),(1467,'STR_FROM'),(1468,'STR_FROM_BEING_IN_BALANCE'),(1469,'STR_FROM_DATE'),(1470,'STR_FUI'),(1471,'STR_FUI_TAX'),(1472,'STR_FULL_DESCRIPTION'),(1473,'STR_GALLON'),(1474,'STR_GAP_BETWEEN_CAVITIES'),(1475,'STR_GEAR_PITCH_RATIO'),(1476,'STR_GENERAL'),(1477,'STR_GENERAL_CUTTING_INFO_ADDED_SUCCESSFULLY'),(1478,'STR_GENERAL_CUTTING_INFO_UPDATED_SUCCESSFULLY'),(1479,'STR_GENERAL_CUTTING_INFORMATION'),(1480,'STR_GENERAL_INFO'),(1481,'STR_GENERAL_INK_INFO'),(1482,'STR_GENERAL_LEDGER'),(1483,'STR_GENERAL_LEDGER_ACCOUNT'),(1484,'STR_GENERAL_LEDGER_ACCOUNT_BY_MONTH_FOR'),(1485,'STR_GENERAL_LEDGER_ACCOUNT_TYPE'),(1486,'STR_GENERAL_LEDGER_ACCOUNTS_FOR_POSTING'),(1487,'STR_GENERAL_LEDGER_PIE_CHART'),(1488,'STR_GENERAL_LEDGER_PIE_CHART_DEFINITION'),(1489,'STR_GENERAL_LEDGER_PIE_SLICE'),(1490,'STR_GENERAL_OVERHEAD_PERCENT'),(1491,'STR_GENERAL_PO_INFO'),(1492,'STR_GENERAL_WORK_TYPE'),(1493,'STR_GENERAL_WORK_TYPE_ADDED_SUCCESSFULLY'),(1494,'STR_GENERAL_WORK_TYPE_DELETED_SUCCESSFULLY'),(1495,'STR_GENERAL_WORK_TYPE_NOT_FOUND'),(1496,'STR_GENERAL_WORK_TYPE_UPDATED_SUCCESSFULLY'),(1497,'STR_GET_FINALIZED_BUILD_ORDERS'),(1498,'STR_GIVE_FREIGHT_ESTIMATE'),(1499,'STR_GL_ACCOUNT'),(1500,'STR_GL_ACCOUNT_NOT_FOUND'),(1501,'STR_GL_ACCOUNT_TYPE_DELETED_SUCCESSFULLY'),(1502,'STR_GL_ACCOUNTS_DETAIL'),(1503,'STR_GL_COGS_ACCOUNT'),(1504,'STR_GL_COMPANY_OPTIONS'),(1505,'STR_GL_ENTRIES_FOR_THIS_CHECK_NOT_FOUND'),(1506,'STR_GL_EXPENSE_ACCOUNT'),(1507,'STR_GL_EXPENSE_ACCOUNT_FOR_COMPANY_PORTION'),(1508,'STR_GL_INVENTORY_ACCOUNT'),(1509,'STR_GL_JOURNAL_ADD'),(1510,'STR_GL_JOURNAL_UPDATE'),(1511,'STR_GL_MENU'),(1512,'STR_GL_PAYABLE_ACCOUNT'),(1513,'STR_GL_PIE_DELETED_SUCCESSFULLY'),(1514,'STR_GL_PIE_SLICE_DELETED_SUCCESSFULLY'),(1515,'STR_GL_PIE_SLICE_DETAIL_DELETED_SUCCESSFULLY'),(1516,'STR_GL_PIE_UPDATED_SUCCESSFULLY'),(1517,'STR_GL_POST'),(1518,'STR_GL_REVERSE_POST'),(1519,'STR_GL_SALES_ACCOUNT'),(1520,'STR_GL_SUMMARY'),(1521,'STR_GL_TRANSACTION_BACKOUT_FAILED'),(1522,'STR_GL_TRANSACTION_VOUCHER_BACKOUT_FAILED'),(1523,'STR_GL2'),(1524,'STR_GND'),(1525,'STR_GO_BACK'),(1526,'STR_GO_BACK_TO_EDIT'),(1527,'STR_GO_SHOPPING'),(1528,'STR_GO_TO_CARRIER_SELECTION'),(1529,'STR_GO_TO_DETAILS'),(1530,'STR_GOOD'),(1531,'STR_GOTO_COMPANY'),(1532,'STR_GRAND_TOTALS_FOR_ALL_LISTED'),(1533,'STR_GRAPHIC'),(1534,'STR_GRAPHICS'),(1535,'STR_GROSS'),(1536,'STR_GROSS_PAY'),(1537,'STR_GROSS_PAY_PER_YEAR'),(1538,'STR_GROSS_PER_YEAR'),(1539,'STR_GROSS_PROFIT'),(1540,'STR_GROUP'),(1541,'STR_GROUP_TO_INCLUDE'),(1542,'STR_GRP'),(1543,'STR_HAPPY_JULY_4TH'),(1544,'STR_HAPPY_NEW_YEAR'),(1545,'STR_HEAD_OF_HOUSEHOLD'),(1546,'STR_HELP'),(1547,'STR_HELP_MODULE_IS_NOT_INSTALLED'),(1548,'STR_HELP_MODULES_INSERTED_INTO_MODULES_TABLE'),(1549,'STR_HELP_SETUP'),(1550,'STR_HELP_TEXT'),(1551,'STR_HIDE_COSTCENTER_BREAKDOWN'),(1552,'STR_HIDE_COSTS'),(1553,'STR_HIDE_PICTURES'),(1554,'STR_HIDE_WHEN_PRINTING'),(1555,'STR_HIGH'),(1556,'STR_HIRE_DATE'),(1557,'STR_HISTORY'),(1558,'STR_HOLD'),(1559,'STR_HOME'),(1560,'STR_HOST'),(1561,'STR_HOURLY'),(1562,'STR_HOURLY_SALARY'),(1563,'STR_HOURLY_WAGES'),(1564,'STR_HOURS'),(1565,'STR_HOURS_ADDL_SETUP'),(1566,'STR_HOURS_CALCULATED_SUCCESSFULLY'),(1567,'STR_HOURS_PAID'),(1568,'STR_HOURS_SETUP'),(1569,'STR_HOURS_SETUP_GENERAL'),(1570,'STR_HOURS_WORKED'),(1571,'STR_HOW_DID_YOU_ARRIVE_HERE'),(1572,'STR_HOW_DID_YOU_GET_HERE'),(1573,'STR_HOW_FIGURED'),(1574,'STR_HRLY'),(1575,'STR_HRS'),(1576,'STR_HRS_SETUP'),(1577,'STR_HUNDRED'),(1578,'STR_ID'),(1579,'STR_ID_HAS_NO_MATCH_IN_FILE'),(1580,'STR_IF_ANY_INVOICE_OLDER'),(1581,'STR_IF_BOX_13_QUALIFIED_PLAN_LETTER_FOR_W2_PRINT'),(1582,'STR_IF_CC_ENTER_NUMBER'),(1583,'STR_IF_CC_EXPIRATION'),(1584,'STR_IF_NEEDED'),(1585,'STR_IF_NOLA_NOT_INSTALLED'),(1586,'STR_IF_NOT_INVENTORY_ITEM'),(1587,'STR_IMAGE'),(1588,'STR_IMAGE_URL'),(1589,'STR_IMMEDIATE'),(1590,'STR_IMPORT_ACCOUNTS'),(1591,'STR_IMPOSITION'),(1592,'STR_IMPRESSIONS'),(1593,'STR_IN_ORER_TO_USE_NOLA'),(1594,'STR_IN_PHPINI'),(1595,'STR_IN_STEP'),(1596,'STR_IN_UNIT'),(1597,'STR_IN_USE'),(1598,'STR_INACTIVE'),(1599,'STR_INCLUDE'),(1600,'STR_INCLUDE_PRIOR_INTEREST'),(1601,'STR_INCLUDE_VOIDS'),(1602,'STR_INCLUDED'),(1603,'STR_INCOME_STATEMENT_FOR'),(1604,'STR_INCOMPLETE_DATA'),(1605,'STR_INDONESIAN'),(1606,'STR_INFO'),(1607,'STR_INFO_BELOW_FOR_PRINT'),(1608,'STR_INITIAL_QTY'),(1609,'STR_INITIAL_SETUP_COMPLETED'),(1610,'STR_INK'),(1611,'STR_INK_ADD'),(1612,'STR_INK_ADDED_SUCCESSFULLY'),(1613,'STR_INK_COVERAGE_NAME'),(1614,'STR_INK_DELETED_SUCCESSFULLY'),(1615,'STR_INK_INFO_ADDED_SUCCESSFULLY'),(1616,'STR_INK_INFO_UPDATED_SUCCESSFULLY'),(1617,'STR_INK_NOT_FOUND'),(1618,'STR_INK_SIDE'),(1619,'STR_INK_UPDATE'),(1620,'STR_INK_UPDATED_SUCCESSFULLY'),(1621,'STR_INSERT_ENTRY'),(1622,'STR_INSERT_FAILED'),(1623,'STR_INSERT_NEW_INVENTORY_COUNT'),(1624,'STR_INSTALL'),(1625,'STR_INTEREST'),(1626,'STR_INTEREST_APPLIED_SUCCESSFULLY'),(1627,'STR_INTEREST_EXPENSE'),(1628,'STR_INTEREST_INCOME'),(1629,'STR_INTEREST_PAID'),(1630,'STR_INTERNAL_COSTS'),(1631,'STR_INTERNAL_SERVER_ERROR'),(1632,'STR_INTERNET'),(1633,'STR_INV_SETUP'),(1634,'STR_INVALID_ENTUSERID'),(1635,'STR_INVALID_EXTUSERID'),(1636,'STR_INVALID_OPERATION'),(1637,'STR_INVALID_PIE_ID'),(1638,'STR_INVALID_SLICE'),(1639,'STR_INVENTORY'),(1640,'STR_INVENTORY_ADJUSTMENT'),(1641,'STR_INVENTORY_CODE'),(1642,'STR_INVENTORY_FILE_ATTACHMENT_MAINTAINENCE'),(1643,'STR_INVENTORY_HAS_BEEN_POSTED'),(1644,'STR_INVENTORY_ITEM'),(1645,'STR_INVENTORY_ITEM_ACTIVITY_LISTS'),(1646,'STR_INVENTORY_ITEM_UNIT'),(1647,'STR_INVENTORY_LOCATION'),(1648,'STR_INVENTORY_LOCATION_ADD'),(1649,'STR_INVENTORY_LOCATION_ADDED_SUCCESSFULLY'),(1650,'STR_INVENTORY_LOCATION_DELETED_SUCCESSFULLY'),(1651,'STR_INVENTORY_LOCATION_NAME'),(1652,'STR_INVENTORY_LOCATION_NOT_FOUND'),(1653,'STR_INVENTORY_LOCATION_UPDATE'),(1654,'STR_INVENTORY_LOCATION_UPDATED_SUCCESSFULLY'),(1655,'STR_INVENTORY_LOSS'),(1656,'STR_INVENTORY_PICKLIST'),(1657,'STR_INVENTORY_PLANT_LOCATION_UPDATE'),(1658,'STR_INVENTORY_PO_LIST'),(1659,'STR_INVENTORY_PO_NUMBER'),(1660,'STR_INVENTORY_PO_NUMBER_NOT_FOUND'),(1661,'STR_INVENTORY_PO_PASS'),(1662,'STR_INVENTORY_PO_UPDATED_SUCCESSFULLY'),(1663,'STR_INVENTORY_STANDARD_GL_ACCOUNTS'),(1664,'STR_INVENTORY_STATS'),(1665,'STR_INVENTORY_TRANSACTION_LIST_FOR'),(1666,'STR_INVENTORY_TYPE'),(1667,'STR_INVENTORY_UNIT_NAME'),(1668,'STR_INVOICE'),(1669,'STR_INVOICE_ADD'),(1670,'STR_INVOICE_ADDED_SUCCESSFULLY'),(1671,'STR_INVOICE_BEGIN_DATE'),(1672,'STR_INVOICE_DATE'),(1673,'STR_INVOICE_DELETED_SUCCESSFULLY'),(1674,'STR_INVOICE_END_DATE'),(1675,'STR_INVOICE_ENTER_COST_OF_GOODS'),(1676,'STR_INVOICE_INTEREST_RATE'),(1677,'STR_INVOICE_NOT_FOUND'),(1678,'STR_INVOICE_NUMBER'),(1679,'STR_INVOICE_NUMBER_NOT_PASSED'),(1680,'STR_INVOICE_PAST_DUE_SERVICE_CHARGE'),(1681,'STR_INVOICE_PAYMENT_ADDED_SUCCESSFULLY'),(1682,'STR_INVOICE_PAYMENTS'),(1683,'STR_INVOICE_STATEMENTS'),(1684,'STR_INVOICE_SUMMARY'),(1685,'STR_INVOICE_TERMS'),(1686,'STR_INVOICE_TERMS_ADD'),(1687,'STR_INVOICE_TERMS_ADDED_SUCCESSFULLY'),(1688,'STR_INVOICE_TERMS_ALREADY_EXIST'),(1689,'STR_INVOICE_TERMS_DELETED_SUCCESSFULLY'),(1690,'STR_INVOICE_TERMS_UPDATE'),(1691,'STR_INVOICE_TERMS_UPDATED_SUCCESSFULLY'),(1692,'STR_INVOICE_TOTAL'),(1693,'STR_INVOICE_UPDATE'),(1694,'STR_INVOICE_UPDATED_SUCCESSFULLY'),(1695,'STR_INVOICE_WAS_CREATED'),(1696,'STR_ITEM'),(1697,'STR_ITEM_ADD'),(1698,'STR_ITEM_ADDED_SUCCESSFULLY'),(1699,'STR_ITEM_ALREADY_EXISTS'),(1700,'STR_ITEM_BARCODE'),(1701,'STR_ITEM_CAT'),(1702,'STR_ITEM_CAT_SEARCH'),(1703,'STR_ITEM_CATEGORY'),(1704,'STR_ITEM_CATEGORY_ADDED_SUCCESSFULLY'),(1705,'STR_ITEM_CATEGORY_DELETED_SUCCESSFULLY'),(1706,'STR_ITEM_CATEGORY_LIST'),(1707,'STR_ITEM_CATEGORY_UPDATE'),(1708,'STR_ITEM_CATEGORY_UPDATED_SUCCESSFULLY'),(1709,'STR_ITEM_CODE'),(1710,'STR_ITEM_CODEC'),(1711,'STR_ITEM_DELETED'),(1712,'STR_ITEM_DELETED_SUCCESSFULLY'),(1713,'STR_ITEM_DESCRIPTION'),(1714,'STR_ITEM_DETAILS'),(1715,'STR_ITEM_IMAGE'),(1716,'STR_ITEM_LIST'),(1717,'STR_ITEM_LIST_PHYSICAL'),(1718,'STR_ITEM_LIST_USAGE'),(1719,'STR_ITEM_LIST_VALUATION'),(1720,'STR_ITEM_LOCATION_ADD_FOR'),(1721,'STR_ITEM_LOCATION_ADD_UPDATE_FOR'),(1722,'STR_ITEM_LOCATION_ALREADY_EXISTS'),(1723,'STR_ITEM_LOCATION_UPDATED_SUCCESSFULLY'),(1724,'STR_ITEM_LOOKUP'),(1725,'STR_ITEM_NAME'),(1726,'STR_ITEM_NOT_FOUND'),(1727,'STR_ITEM_NUMBER'),(1728,'STR_ITEM_REACTIVATE'),(1729,'STR_ITEM_REACTIVATED_SUCCESSFULLY'),(1730,'STR_ITEM_RECEIVE_CANCEL_FAILED'),(1731,'STR_ITEM_SEARCH'),(1732,'STR_ITEM_STATUS'),(1733,'STR_ITEM_TO_ADD_REMOVE'),(1734,'STR_ITEM_UPDATE'),(1735,'STR_ITEM_UPDATED_SUCCESSFULLY'),(1736,'STR_ITEM_VENDOR_INFORMATION_DELETED_SUCCESSFULLY'),(1737,'STR_ITEM_VENDOR_UPDATE_ADDED'),(1738,'STR_ITEM_WEIGHT_UNITS'),(1739,'STR_ITEMC'),(1740,'STR_ITEMS'),(1741,'STR_JANUARY'),(1742,'STR_JOB_DESCRIPTION'),(1743,'STR_JOB_NAME'),(1744,'STR_JOBDETAILS'),(1745,'STR_JOURNAL_LISTING_FOR'),(1746,'STR_JOURNAL_VOUCHER'),(1747,'STR_JULY'),(1748,'STR_JUMP_TO_GL_ACCOUNT_EDIT_SCREEN'),(1749,'STR_JUNE'),(1750,'STR_LABELS'),(1751,'STR_LABOR'),(1752,'STR_LANGUAGE'),(1753,'STR_LAST'),(1754,'STR_LAST_ACTION'),(1755,'STR_LAST_CHECK_NUMBER_USED'),(1756,'STR_LAST_COST'),(1757,'STR_LAST_MESSAGE'),(1758,'STR_LAST_NAME'),(1759,'STR_LATE'),(1760,'STR_LATE_REASON'),(1761,'STR_LAY_OFF'),(1762,'STR_LB'),(1763,'STR_LBS'),(1764,'STR_LEAD_QUALITY'),(1765,'STR_LENGTH'),(1766,'STR_LEVEL'),(1767,'STR_LEVEL_ONE'),(1768,'STR_LEVEL_THREE'),(1769,'STR_LEVEL_TWO'),(1770,'STR_LINE'),(1771,'STR_LINE_ITEM_DETAIL'),(1772,'STR_LINE_ITEMS'),(1773,'STR_LINE_ITEMS_IN_ORDER_NUMBER'),(1774,'STR_LINE_ITEMS_IN_PO_NUMBER'),(1775,'STR_LINE_NUMBER'),(1776,'STR_LIST'),(1777,'STR_LIST_ALL_UNBILLED'),(1778,'STR_LIST_NAME'),(1779,'STR_LIST_ONLY_UNBILLED_COMPLETED_ORDERS'),(1780,'STR_LIST_SORT_BY'),(1781,'STR_LN'),(1782,'STR_LOCAL'),(1783,'STR_LOCAL_EXEMPTIONS'),(1784,'STR_LOCAL_INCOME_TAX'),(1785,'STR_LOCAL_TAX'),(1786,'STR_LOCAL_TAX2'),(1787,'STR_LOCAL_WAGES'),(1788,'STR_LOCATION'),(1789,'STR_LOCATION_NAME'),(1790,'STR_LOG_HOURS'),(1791,'STR_LOG_OUT_OF_SYSTEM'),(1792,'STR_LOGIN_FAILED'),(1793,'STR_LOGON_ACCESS'),(1794,'STR_LOGOUT'),(1795,'STR_LOST'),(1796,'STR_LOT'),(1797,'STR_LOW'),(1798,'STR_M'),(1799,'STR_MACHINE'),(1800,'STR_MACHINE_ADD'),(1801,'STR_MACHINE_ADDED_SUCCESSFULLY'),(1802,'STR_MACHINE_DELETED_SUCCESSFULLY'),(1803,'STR_MACHINE_FAMILY'),(1804,'STR_MACHINE_FAMILY_SELECTION'),(1805,'STR_MACHINE_LIST_ADD_UPDATE'),(1806,'STR_MACHINE_LIST_UPDATE'),(1807,'STR_MACHINE_NOT_FOUND'),(1808,'STR_MACHINE_UPDATED_SUCCESSFULLY'),(1809,'STR_MADE_CHANGES'),(1810,'STR_MAIL_STOP'),(1811,'STR_MAILING_LABELS_CUSTOMER_LOCATIONS_PAGE'),(1812,'STR_MAILING_LABELS_ORDER_FROM'),(1813,'STR_MAILING_LABELS_PAY_TO'),(1814,'STR_MAILING_LABELS_SHIP_TO_LOCATIONS_PAGE'),(1815,'STR_MAIN_OFFICE_PHONE'),(1816,'STR_MAKE_INTO_AN_ORDER'),(1817,'STR_MAKE_NEW_QUOTE'),(1818,'STR_MAKE_ORDER_FROM_SAME_AS_ABOVE'),(1819,'STR_MAKE_PAYMENT_EQUAL'),(1820,'STR_MANAGE_BUILD_ORDERS'),(1821,'STR_MARCH'),(1822,'STR_MARITAL_STATUS'),(1823,'STR_MARK_QUOTE_AS_LOST'),(1824,'STR_MARKUP'),(1825,'STR_MARKUP_BASED_ON'),(1826,'STR_MARKUP_OUTSIDE_VENDED'),(1827,'STR_MARKUP_PERCENT'),(1828,'STR_MARKUP_SET'),(1829,'STR_MARKUP_SET_DELETED'),(1830,'STR_MARKUP_SET_DELETED_SUCCESSFULLY'),(1831,'STR_MARKUP_SET_DESCRIPTION'),(1832,'STR_MARKUP_SET_FOR_LEVEL_ADDED_SUCCESSFULLY'),(1833,'STR_MARKUP_SET_FOR_LEVEL_UPDATED_SUCCESSFULLY'),(1834,'STR_MARKUP_SPECIAL_ORDER'),(1835,'STR_MARRIED_JOINT'),(1836,'STR_MARRIED_SEPARATE'),(1837,'STR_MASTER'),(1838,'STR_MASTER_ITEM'),(1839,'STR_MATCHES_FOUND'),(1840,'STR_MATCHING_PERCENTAGE'),(1841,'STR_MATERIAL'),(1842,'STR_MATERIALS_CONSUMED_WHENEVER'),(1843,'STR_MATERIALS_CONSUMED_WHENEVER_THIS_OPERATION_USED'),(1844,'STR_MATERIALS_ONLY'),(1845,'STR_MATERIALS_USED_FOR'),(1846,'STR_MAX'),(1847,'STR_MAX_AMOUNT'),(1848,'STR_MAX_EXEMPTION'),(1849,'STR_MAX_EXEMPTION_AMOUNT_PER_YEAR'),(1850,'STR_MAX_INKS_BACK'),(1851,'STR_MAX_INKS_FRONT'),(1852,'STR_MAX_INKS_PER_PASS'),(1853,'STR_MAX_LIMITS'),(1854,'STR_MAX_MASTER_ITEMS_POSSIBLE'),(1855,'STR_MAX_NO_COLORS'),(1856,'STR_MAX_NO_PAGES'),(1857,'STR_MAX_NO_STOCKS'),(1858,'STR_MAX_RUN_RATE'),(1859,'STR_MAX_STOCK_LEVEL'),(1860,'STR_MAX_SUI_PER_YEAR'),(1861,'STR_MAX_VACATION_DAYS'),(1862,'STR_MAX_WAGES'),(1863,'STR_MAXIMUM'),(1864,'STR_MAXIMUM_FEDERAL_TAX_TO_DEDUCT'),(1865,'STR_MAXIMUM_GROSS_PAY_FOR'),(1866,'STR_MAXIMUM_PAY_HOUR_FOR'),(1867,'STR_MAXIMUM_PERCENT_MATCHED_BY_EMPLOYER'),(1868,'STR_MAXIMUM_QTY_PER_PASS'),(1869,'STR_MAXIMUM_SICK_LEAVE_ALLOWED_TO_ACCRUE'),(1870,'STR_MAXIMUM_VALID_ENTRY_BY_USER'),(1871,'STR_MAY'),(1872,'STR_MEDICARE'),(1873,'STR_MEDICARE_DEDUCTION'),(1874,'STR_MEDICARE_EXPENSE'),(1875,'STR_MEDICARE_PAYABLE'),(1876,'STR_MEDICARE_WAGES'),(1877,'STR_MEDICARE_WH'),(1878,'STR_MENU_COLOR'),(1879,'STR_MERRY_CHRISTMAS'),(1880,'STR_MESSAGE'),(1881,'STR_MESSAGE_CENTER'),(1882,'STR_MESSAGE_NOT_FOUND'),(1883,'STR_MESSAGE_SENT_TO'),(1884,'STR_METHOD'),(1885,'STR_MID'),(1886,'STR_MIDCOST'),(1887,'STR_MILLION'),(1888,'STR_MIN'),(1889,'STR_MIN_CHARGE'),(1890,'STR_MIN_INKS_BACK'),(1891,'STR_MIN_INKS_FRONT'),(1892,'STR_MIN_NO_PAGES'),(1893,'STR_MIN_STOCK_LEVEL'),(1894,'STR_MINIMUM'),(1895,'STR_MINIMUM_CHARGE'),(1896,'STR_MINIMUM_VALID_ENTRY_BY_USER'),(1897,'STR_MINIMUM_WAGE'),(1898,'STR_MISC_DEDUCTION'),(1899,'STR_MISC_DEDUCTION_PAYABLE'),(1900,'STR_MISC_DEDUCTIONS'),(1901,'STR_MISC_DEDUCTIONS2'),(1902,'STR_MISC_NONTAXABLE'),(1903,'STR_MISC_NONTAXABLE_PAY'),(1904,'STR_MISC_NONTAXABLE2'),(1905,'STR_MISC_TAX_EXEMPT_PAY_EXPENSE'),(1906,'STR_MISC_TAXABLE'),(1907,'STR_MISC_TAXABLE_PAY'),(1908,'STR_MISC_TAXABLE2'),(1909,'STR_MODIFIED_ON'),(1910,'STR_MODIFY'),(1911,'STR_MODULE'),(1912,'STR_MODULE_ACCESS'),(1913,'STR_MONTH'),(1914,'STR_MONTHLY_FOR_THE_YEAR'),(1915,'STR_MONTHLY_REPORT'),(1916,'STR_MONTHS_OF_THE_YEAR'),(1917,'STR_MORE_THAN_ONE_INK'),(1918,'STR_MOVE_BACK'),(1919,'STR_MOVE_CATEGORY'),(1920,'STR_MOVE_FORWARD'),(1921,'STR_MOVE_THIS_TOPIC_UNDER'),(1922,'STR_MSI'),(1923,'STR_MULTICOMPANY'),(1924,'STR_MULTIPLIER'),(1925,'STR_MULTIPLIER_FOR_SECOND_SHIFT'),(1926,'STR_MULTIPLIER_FOR_THIRD_SHIFT'),(1927,'STR_MUST_ENTER_WORK_TYPES_FIRST'),(1928,'STR_MUST_HAVE_A_VENDOR'),(1929,'STR_MUST_HAVE_ENTRY'),(1930,'STR_MUST_HAVE_VENDOR'),(1931,'STR_MUST_VEND'),(1932,'STR_MWT'),(1933,'STR_N'),(1934,'STR_NA'),(1935,'STR_NAME'),(1936,'STR_NAME_OF_FAMILY_OF_MACHINES'),(1937,'STR_NAME_PASSWORD_EXISTS'),(1938,'STR_NEED_TO_CHANGE_IMAGE'),(1939,'STR_NEEDED'),(1940,'STR_NEEDED_TOTAL'),(1941,'STR_NET_DUE'),(1942,'STR_NET_DUE_DAYS'),(1943,'STR_NET_DUE_TOTAL'),(1944,'STR_NET_INCOME'),(1945,'STR_NET_PAY'),(1946,'STR_NET_PAY2'),(1947,'STR_NEW_ADJUSTED_TAXES'),(1948,'STR_NEW_BUILD_ORDER'),(1949,'STR_NEW_COUNT'),(1950,'STR_NEW_INTEREST'),(1951,'STR_NEW_ITEM_COUNT'),(1952,'STR_NEW_ITEM_COUNT_TOTAL'),(1953,'STR_NEW_ITEM_SAME_VENDOR'),(1954,'STR_NEW_LIST_GENERATED'),(1955,'STR_NEW_MESSAGES'),(1956,'STR_NEW_MESSAGES_IN_YOUR_INBOX'),(1957,'STR_NEW_ORDER_MSG1'),(1958,'STR_NEW_ORDER_MSG2'),(1959,'STR_NEW_REPORT'),(1960,'STR_NEW_SELECTION_ITEM'),(1961,'STR_NEW_VENDOR'),(1962,'STR_NEW_VERSION'),(1963,'STR_NEXT'),(1964,'STR_NEXT_EMPLOYEE'),(1965,'STR_NEXT_INVOICE_NUMBER'),(1966,'STR_NEXT_SALES_ACTION'),(1967,'STR_NEXT_SALESMAN'),(1968,'STR_NEXT_SCHEDULED_DATE'),(1969,'STR_NEXT_SCREEN'),(1970,'STR_NINE'),(1971,'STR_NINETEEN'),(1972,'STR_NINETY'),(1973,'STR_NO'),(1974,'STR_NO_ACCESS'),(1975,'STR_NO_ACCOUNT_SELECTED'),(1976,'STR_NO_ADDL_CHARGE'),(1977,'STR_NO_AGING_BILLS_FOUND'),(1978,'STR_NO_AGING_INVOICES_FOUND'),(1979,'STR_NO_AUTHOR_COMMENTS_AVAILABLE'),(1980,'STR_NO_AUTOMATIC_PRICING'),(1981,'STR_NO_BUDGETS_FOUND'),(1982,'STR_NO_BUDGETS_SET'),(1983,'STR_NO_CALCULATED_UNPAID_HOURS_FOUND'),(1984,'STR_NO_CITY_TAXES_DEFINED'),(1985,'STR_NO_COLORS_ENTERED_FOR_THIS_STOCK'),(1986,'STR_NO_COMPANIES_FOUND'),(1987,'STR_NO_COMPOSITE_ITEMS_FOUND'),(1988,'STR_NO_CONTRIBUTION'),(1989,'STR_NO_COST_CENTER_FAMILY_SELECTED'),(1990,'STR_NO_COST_CENTER_SELECTED'),(1991,'STR_NO_CUSTOMERS_FOUND'),(1992,'STR_NO_DASHES'),(1993,'STR_NO_DATA_FOUND'),(1994,'STR_NO_DESCRIPTION_AVAILABLE'),(1995,'STR_NO_EMPLOYEE'),(1996,'STR_NO_EMPLOYEES_FOUND'),(1997,'STR_NO_ENTRIES_FOUND'),(1998,'STR_NO_ENTRIES_FOUND_MATCHING_CRITERIA'),(1999,'STR_NO_ENTRIES_MATCH_THE_ACTIVITY_PERIOD_TO_REPORT'),(2000,'STR_NO_ENTRIES_MATCH_THE_SPECIFIED_CRITERIA_TO_REPORT'),(2001,'STR_NO_FINALIZED_BUILD_ORDERS_FOUND'),(2002,'STR_NO_GL_ACCT'),(2003,'STR_NO_GL_JOURNAL_ENTRIES_FOUND'),(2004,'STR_NO_INFORMATION_AVAILABLE'),(2005,'STR_NO_INKS_FOUND'),(2006,'STR_NO_INVENTORY_LOCATIONS_FOUND'),(2007,'STR_NO_ITEM_CATEGORIES_FOUND'),(2008,'STR_NO_ITEMS_FOUND'),(2009,'STR_NO_ITEMS_SELECTED'),(2010,'STR_NO_LOCAL_TAXES_DEFINED'),(2011,'STR_NO_LOCATION'),(2012,'STR_NO_LOCATIONS_IN_FILE'),(2013,'STR_NO_MACHINES_FOUND'),(2014,'STR_NO_MATCHING_BILLS_FOUND'),(2015,'STR_NO_MATCHING_BUDGETS_FOUND'),(2016,'STR_NO_MATCHING_CHECKS_FOUND'),(2017,'STR_NO_MATCHING_CUSTOMER_FOUND'),(2018,'STR_NO_MATCHING_CUSTOMERS_FOUND'),(2019,'STR_NO_MATCHING_GL_ACCOUNTS_FOUND'),(2020,'STR_NO_MATCHING_INVOICE_PAYMENTS_FOUND'),(2021,'STR_NO_MATCHING_INVOICES_FOUND'),(2022,'STR_NO_MATCHING_ITEMS_FOUND'),(2023,'STR_NO_MATCHING_OPEN_BUILD_ORDER'),(2024,'STR_NO_MATCHING_ORDERS_FOUND'),(2025,'STR_NO_MATCHING_PO_FOUND'),(2026,'STR_NO_MATCHING_PO_ITEMS_FOUND'),(2027,'STR_NO_MATCHING_POS_FOUND'),(2028,'STR_NO_MATCHING_QUOTES_FOUND'),(2029,'STR_NO_MATCHING_SHIPMENTS_FOUND'),(2030,'STR_NO_MATCHING_SHIPTO_ADDRESSES_FOUND'),(2031,'STR_NO_MATCHING_VENDORS_FOUND'),(2032,'STR_NO_OPEN_ITEMS_FOUND'),(2033,'STR_NO_OPEN_ORDERS_FOUND'),(2034,'STR_NO_ORDERS_FOUND'),(2035,'STR_NO_PASSWORD'),(2036,'STR_NO_PAY_TYPES_SET'),(2037,'STR_NO_PAYROLL_CHECKS_FOUND'),(2038,'STR_NO_PAYROLL_FOUND_FOR_PERIOD'),(2039,'STR_NO_PHYSICAL_FOUND'),(2040,'STR_NO_PRICE_LEVELS_FOUND'),(2041,'STR_NO_PRICE_LIST_SPECIFIED'),(2042,'STR_NO_PRICE_LISTS_FOUND'),(2043,'STR_NO_RECEIPTS_FOUND'),(2044,'STR_NO_RECORDS_FOUND'),(2045,'STR_NO_RECORDS_POSTED'),(2046,'STR_NO_REVIEWS_MATCH_SEARCH'),(2047,'STR_NO_RIGHTS_TO_COMPANY'),(2048,'STR_NO_SELECTION_HAS_BEEN_MADE'),(2049,'STR_NO_STATE_TAXES_DEFINED'),(2050,'STR_NO_STOCKS_FOUND'),(2051,'STR_NO_TAX_SELECTED'),(2052,'STR_NO_TAXES_FOUND'),(2053,'STR_NO_TOPIC_ID_OR_NAME_GIVEN'),(2054,'STR_NO_UNBILLED_HOURS'),(2055,'STR_NO_UNPAID_HOURS_FOUND'),(2056,'STR_NO_UNPOSTED_MATCHES_FOUND'),(2057,'STR_NO_USED_ID_FOUND'),(2058,'STR_NO_USER_ACCESS'),(2059,'STR_NO_USER_ID'),(2060,'STR_NO_VALID_BILLS_SELECTED'),(2061,'STR_NO_VALID_MARKUP_CODES_FOUND'),(2062,'STR_NO_VENDOR_FOUND_FOR_CARRIER'),(2063,'STR_NO_VENDORS_FOUND'),(2064,'STR_NO_VENDORS_IN_FILE'),(2065,'STR_NO_VOUCHER_SELECTED'),(2066,'STR_NO_VOUCHERS_MATCH'),(2067,'STR_NO_WORK_TYPES_FOUND'),(2068,'STR_NOLA_EMAIL_FROM'),(2069,'STR_NOLA_SOFTWARE'),(2070,'STR_NONE'),(2071,'STR_NONE_SELECTED'),(2072,'STR_NONPRINT_OPERATION_SIZE_ADDED_SUCCESSFULLY'),(2073,'STR_NONPRINT_OPERATION_SIZE_DELETED_SUCCESSFULLY'),(2074,'STR_NONPRINTING_OPERATION'),(2075,'STR_NONPRINTING_OPERATION_SELECTION_LIST_UPDATE'),(2076,'STR_NONPRINTING_OPERATION_SIZE_UPDATED_SUCCESSFULLY'),(2077,'STR_NONPRINTING_PRICE_LIST'),(2078,'STR_NONPRINTING_PRICE_LIST_ADD'),(2079,'STR_NONPRINTING_PRICE_LIST_ADDED_SUCCESSFULLY'),(2080,'STR_NONPRINTING_PRICE_LIST_DELETED_SUCCESSFULLY'),(2081,'STR_NONPRINTING_PRICE_LIST_NOT_FOUND'),(2082,'STR_NONPRINTING_PRICE_LIST_OPERATION_ADDED_SUCCESSFULLY'),(2083,'STR_NONPRINTING_PRICE_LIST_OPERATION_DELETED_SUCCESSFULLY'),(2084,'STR_NONPRINTING_PRICE_LIST_OPERATION_UPDATED_SUCCESSFULLY'),(2085,'STR_NONPRINTING_PRICE_LIST_OPERATIONS'),(2086,'STR_NONPRINTING_PRICE_LIST_UPDATE'),(2087,'STR_NONPRINTING_PRICE_LIST_UPDATED_SUCCESSFULLY'),(2088,'STR_NONPRINTING_PRICING_UPDAT'),(2089,'STR_NONPRINTING_PRICING_UPDATE'),(2090,'STR_NORMAL'),(2091,'STR_NOSHOW_FIRSTLINE'),(2092,'STR_NOT_ALL_FIELDS_ARE_VALID'),(2093,'STR_NOT_EXEMPT'),(2094,'STR_NOT_FOUND'),(2095,'STR_NOT_INCLUDED'),(2096,'STR_NOT_INSTALLED_CANNOT_UNINSTALL'),(2097,'STR_NOT_SELECTED'),(2098,'STR_NOT_UPDATED'),(2099,'STR_NOTE'),(2100,'STR_NOTE_FOR_REVISION_LOG'),(2101,'STR_NOTE_IF_USING_MARKUP'),(2102,'STR_NOTE_TO_DOWNLOAD'),(2103,'STR_NOTES'),(2104,'STR_NOTES_FOR_QUOTE'),(2105,'STR_NOTES_TO_SHOW_ON_QUOTE'),(2106,'STR_NOVEMBER'),(2107,'STR_NUM_ASSISTANTS'),(2108,'STR_NUM_OPERATORS'),(2109,'STR_NUMBER'),(2110,'STR_NUMBER_ACROSS'),(2111,'STR_NUMBER_AROUND'),(2112,'STR_NUMBER_BETWEEN'),(2113,'STR_NUMBER_EMPLOYEES'),(2114,'STR_NUMBER_LINE_ITEMS'),(2115,'STR_NUMBER_OF'),(2116,'STR_NUMBER_OF_BOXES_TO_SHIP'),(2117,'STR_NUMBER_OF_PAGES'),(2118,'STR_NUMBER_OF_PAGES_ON_SCREEN'),(2119,'STR_NUMBER_OF_PARTS'),(2120,'STR_NUMBER_OF_PERIODS'),(2121,'STR_NUMBER_OF_POSSIBLE_PARTS'),(2122,'STR_NUMBER_OF_TEETH'),(2123,'STR_NUMBER_OUT'),(2124,'STR_NUMBER_PACKAGES'),(2125,'STR_NUMBER_UP'),(2126,'STR_NUMERIC'),(2127,'STR_NUMERIC_MONTH'),(2128,'STR_OBJECT_MUST_BE'),(2129,'STR_OCTOBER'),(2130,'STR_OF_SALES_ITEMS'),(2131,'STR_OF_WAGES_ON_ANNUAL_EARNINGS_OVER'),(2132,'STR_OFFSET_SHEET'),(2133,'STR_OFFSET_WEB'),(2134,'STR_OK_TO_USE'),(2135,'STR_OLD_VERSION'),(2136,'STR_ON'),(2137,'STR_ON_HAND'),(2138,'STR_ON_QUANTITIES_OVER'),(2139,'STR_ON_SCREEN_VENDOR_LIST'),(2140,'STR_ON_TIME'),(2141,'STR_ON_WAGES_OVER'),(2142,'STR_ONCE_THE_DOCUMENT'),(2143,'STR_ONE'),(2144,'STR_ONE_INK_ONLY'),(2145,'STR_ONE_TRIM'),(2146,'STR_ONLY_HOURLY'),(2147,'STR_ONLY_IF_NOT_ALREADY_ENTERED_AS_USER'),(2148,'STR_ONLY_ON_QUANTITIES_ABOVE'),(2149,'STR_ONLY_SALARY'),(2150,'STR_ONLY_UNBILLED_COMPLETED_ORDERS'),(2151,'STR_OPEN'),(2152,'STR_OPEN_ITEM_LIST_FOR'),(2153,'STR_OPEN_ITEMS'),(2154,'STR_OPEN_NO_SHIPMENTS'),(2155,'STR_OPEN_ORDERS'),(2156,'STR_OPEN_ORDERS_ONLY'),(2157,'STR_OPERATING_PROFIT'),(2158,'STR_OPERATOR'),(2159,'STR_OPTION'),(2160,'STR_OPTIONAL'),(2161,'STR_OPTIONAL_SETUP'),(2162,'STR_OR'),(2163,'STR_OR_ADD_ANOTHER_BELOW'),(2164,'STR_OR_REPRINT'),(2165,'STR_ORDER'),(2166,'STR_ORDER_ADD'),(2167,'STR_ORDER_ADD_LINE'),(2168,'STR_ORDER_ADDED_SUCCESSFULLY'),(2169,'STR_ORDER_ALREADY_CHECKED_IN_OR_OUT'),(2170,'STR_ORDER_BY'),(2171,'STR_ORDER_BYC'),(2172,'STR_ORDER_CHECKIN_CHECKOUT'),(2173,'STR_ORDER_COMPANY'),(2174,'STR_ORDER_FROM_ADDRESS'),(2175,'STR_ORDER_FROM_COMPANY_INFO'),(2176,'STR_ORDER_FROM_EMAIL'),(2177,'STR_ORDER_FROM_PHONE'),(2178,'STR_ORDER_FROM_VENDOR'),(2179,'STR_ORDER_LIST'),(2180,'STR_ORDER_LIST_FOR_SHIPMENTS'),(2181,'STR_ORDER_LIST_TO_SELECT'),(2182,'STR_ORDER_NUMBER'),(2183,'STR_ORDER_NUMBER_NOT_PASSED'),(2184,'STR_ORDER_NUMBERC'),(2185,'STR_ORDER_NUMBERCC'),(2186,'STR_ORDER_QTY'),(2187,'STR_ORDER_QTY_IN'),(2188,'STR_ORDER_SHIPPED_FAILED'),(2189,'STR_ORDER_SHIPPED_SUCCESSFULLY'),(2190,'STR_ORDER_STATUS_LIST'),(2191,'STR_ORDER_SUCCESSFULLY_CHECKED_IN_OR_OUT'),(2192,'STR_ORDER_TOTAL'),(2193,'STR_ORDER_TRACKED_SUCCESSFULLY'),(2194,'STR_ORDER_UPDATE'),(2195,'STR_ORDER_UPDATED_SUCCESSFULLY'),(2196,'STR_ORDER2'),(2197,'STR_ORDERBY'),(2198,'STR_ORDERC'),(2199,'STR_ORDERED'),(2200,'STR_ORDERS'),(2201,'STR_ORDERS_RECEIVED_FOR_PERIOD'),(2202,'STR_ORDERS_SHIPPED_FOR_PERIOD'),(2203,'STR_ORDERS_TO_INVOICES'),(2204,'STR_ORDERS_TRANSFERRED_TO_INVOICES'),(2205,'STR_ORDERTYPE'),(2206,'STR_ORIGINAL'),(2207,'STR_ORIGINAL_PAYMENT'),(2208,'STR_OTHER'),(2209,'STR_OTHER_CUTTING'),(2210,'STR_OTHER_INCOME_AND_EXPENSE'),(2211,'STR_OVER_ABOVE_QTY'),(2212,'STR_OVER_ABOVE_QUANTITIES'),(2213,'STR_OVER_MAX_PAY'),(2214,'STR_OVERHEAD'),(2215,'STR_OVERPAYMENT'),(2216,'STR_OVERPAYMENT_DESCRIPTION'),(2217,'STR_OWNED_BY'),(2218,'STR_OWNER'),(2219,'STR_PACKAGE_NUMBER'),(2220,'STR_PACKAGES'),(2221,'STR_PACKING_LIST'),(2222,'STR_PAGE'),(2223,'STR_PAGE_SIZE'),(2224,'STR_PAGES'),(2225,'STR_PAID'),(2226,'STR_PAID_YTD'),(2227,'STR_PAPER'),(2228,'STR_PART'),(2229,'STR_PART_NAME'),(2230,'STR_PART_NUMBER'),(2231,'STR_PARTIAL'),(2232,'STR_PARTIAL_SHIPMENT'),(2233,'STR_PARTIALLY_COMPLETE'),(2234,'STR_PASSWORD'),(2235,'STR_PASSWORD_IS_BLANK'),(2236,'STR_PASSWORD_NOT_CONFIRMED'),(2237,'STR_PASSWORDS_DO_NOT_MATCH'),(2238,'STR_PAY'),(2239,'STR_PAY_BILLS'),(2240,'STR_PAY_INVOICE'),(2241,'STR_PAY_NONE'),(2242,'STR_PAY_PER_HOUR_PERIOD'),(2243,'STR_PAY_PERIOD'),(2244,'STR_PAY_RATE'),(2245,'STR_PAY_TERMS_ALREADY_EXIST'),(2246,'STR_PAY_TO_ADDRESS'),(2247,'STR_PAY_TO_COMPANY_INFO'),(2248,'STR_PAY_TO_EMAIL'),(2249,'STR_PAY_TO_PHONE'),(2250,'STR_PAY_TO_VENDOR'),(2251,'STR_PAY_TYPE'),(2252,'STR_PAY_TYPE_ADDED_SUCCESSFULLY'),(2253,'STR_PAY_TYPE_ALREADY_EXISTS'),(2254,'STR_PAY_TYPE_DELETED_SUCCESSFULLY'),(2255,'STR_PAY_TYPE_RATING_DELETED_SUCCESSFULLY'),(2256,'STR_PAY_TYPE_RATING_UPDATED_SUCCESSFULLY'),(2257,'STR_PAY_TYPE_UPDATED_SUCCESSFULLY'),(2258,'STR_PAYABLES'),(2259,'STR_PAYMENT_INVOICE'),(2260,'STR_PAYMENT_METHOD'),(2261,'STR_PAYMENT_RECEIVED'),(2262,'STR_PAYMENT_TERMS'),(2263,'STR_PAYMENT_TERMS_ADD'),(2264,'STR_PAYMENT_TERMS_DELETED_SUCCESSFULLY'),(2265,'STR_PAYMENT_TERMS_UPDATE'),(2266,'STR_PAYMENT_TYPE'),(2267,'STR_PAYMENTS'),(2268,'STR_PAYOPTION'),(2269,'STR_PAYOPTION_VALUE'),(2270,'STR_PAYROLL'),(2271,'STR_PAYROLL_BENEFITS_AND_DEDUCTIONS_GENERAL_DATA'),(2272,'STR_PAYROLL_CALCULATE_HOURS'),(2273,'STR_PAYROLL_COMPANY_CONTRIBUTIONS'),(2274,'STR_PAYROLL_DEDUCTION_GROUP_ADD'),(2275,'STR_PAYROLL_DEDUCTION_GROUP_UPDATE'),(2276,'STR_PAYROLL_EMPLOYEE_ADD'),(2277,'STR_PAYROLL_EMPLOYEE_UPDATE'),(2278,'STR_PAYROLL_GENERAL_BENEFITS_PAY'),(2279,'STR_PAYROLL_GENERAL_DEDUCTIONS'),(2280,'STR_PAYROLL_LOG_HOURS'),(2281,'STR_PAYROLL_PAY_TYPE_ADD'),(2282,'STR_PAYROLL_PAY_TYPE_UPDATE'),(2283,'STR_PAYROLL_PENSION_CAFETERIA_SAVINGS_PLAN'),(2284,'STR_PAYROLL_SETUP'),(2285,'STR_PAYROLL_STANDARD_GL_ACCOUNTS'),(2286,'STR_PAYROLL_TAX_ADD_GENERAL_INFO'),(2287,'STR_PAYROLL_TAX_DEPOSIT'),(2288,'STR_PAYROLL_TAX_TABLES'),(2289,'STR_PAYROLL_TAX_UPDATE_GENERAL_INFO'),(2290,'STR_PDF'),(2291,'STR_PEN_PLAN'),(2292,'STR_PENDING'),(2293,'STR_PENDING_ONLY'),(2294,'STR_PENSION_ADDED_SUCCESSFULLY'),(2295,'STR_PENSION_SAVINGS_PLANS'),(2296,'STR_PENSION_UPDATED_SUCCESSFULLY'),(2297,'STR_PER'),(2298,'STR_PER_HOUR_OVER_LAST_QTY'),(2299,'STR_PER_HOUR_UP_TO_QTY'),(2300,'STR_PER_LB'),(2301,'STR_PER_M'),(2302,'STR_PER_M_TO_JOB'),(2303,'STR_PER_PURCHASE_UNIT'),(2304,'STR_PER_WHAT_QTY'),(2305,'STR_PERCENT_MACHINE_TIME'),(2306,'STR_PERCENT_MAN_TIME_PER_MACHINE_TIME'),(2307,'STR_PERCENT_SCRAP_SETUP'),(2308,'STR_PERCENT_SLOWDOWN_FOR_REGISTRATION'),(2309,'STR_PERCENT_SLOWDOWN_TIGHT_REGISTRATION'),(2310,'STR_PERCENTAGE_COVERAGE'),(2311,'STR_PERCENTAGE_OF_PAY'),(2312,'STR_PERCENTAGE_OF_WAGES'),(2313,'STR_PERFORATOR'),(2314,'STR_PERFORMANCE_STATISTICS_LIST_FOR'),(2315,'STR_PERIOD'),(2316,'STR_PERIOD_BEGIN_DATE'),(2317,'STR_PERIOD_END_DATE'),(2318,'STR_PERIOD_MONTH'),(2319,'STR_PERIOD_NOT_FOUND'),(2320,'STR_PERIOD_YTD'),(2321,'STR_PERIODS'),(2322,'STR_PERSIAN'),(2323,'STR_PERSON'),(2324,'STR_PHONE'),(2325,'STR_PHONE_COMMENT'),(2326,'STR_PHONE_DESCRIPTION'),(2327,'STR_PHONE_FOUR'),(2328,'STR_PHONE_NUMBER'),(2329,'STR_PHONE_ONE'),(2330,'STR_PHONE_THREE'),(2331,'STR_PHONE_TWO'),(2332,'STR_PHP_CONFIGURATION'),(2333,'STR_PHYSICAL'),(2334,'STR_PICK_LIST'),(2335,'STR_PICK_MONTH'),(2336,'STR_PICK_SLICE'),(2337,'STR_PICTURE'),(2338,'STR_PIE_CHART_TO_EDIT_PRINT'),(2339,'STR_PIE_DESCRIPTION'),(2340,'STR_PIE_NAME'),(2341,'STR_PIE_SUCCESSFULLY_DELETED'),(2342,'STR_PLAN_NAME'),(2343,'STR_PLAN_ONE'),(2344,'STR_PLAN_TWO'),(2345,'STR_PLANT_LOCATION'),(2346,'STR_PLEASE'),(2347,'STR_PLEASE_CHECK_AND_CONFIRM_YOUR_DATA'),(2348,'STR_PLEASE_ENTER'),(2349,'STR_PLEASE_FILL_OUT_ALL_REQUIRED_FIELDS'),(2350,'STR_PLEASE_GO_BACK_AND_CHECK_YOUR_DATA'),(2351,'STR_PLEASE_INCLUDE_SOCIAL_SECURITY'),(2352,'STR_PLEASE_REMIT_TO'),(2353,'STR_PLEASE_SELECT_STOCK_TYPE_ABOVE'),(2354,'STR_PLEASE_SPECIFY_A_COST'),(2355,'STR_PLEASE_SPECIFY_THE_DELIMINAR_CHARACTER'),(2356,'STR_PLEASE_VALIDATE_THIS_FIELD'),(2357,'STR_PLUS'),(2358,'STR_PLUS_TAX'),(2359,'STR_PMS'),(2360,'STR_PMS_NO'),(2361,'STR_PO'),(2362,'STR_PO_DETAILS_UPDATED_SUCCESSFULLY'),(2363,'STR_PO_NUMBER'),(2364,'STR_PO_NUMBERC'),(2365,'STR_PO_RECEIVED_SUCCESSFULLY'),(2366,'STR_PO_UPDATED_SUCCESSFULLY'),(2367,'STR_POD'),(2368,'STR_POOR'),(2369,'STR_PORTUGUESE'),(2370,'STR_POSITION'),(2371,'STR_POST'),(2372,'STR_POST_FROM'),(2373,'STR_POST_NOW'),(2374,'STR_POST_PRINT_THIS_INVOICE'),(2375,'STR_POST_TO_PAYABLES'),(2376,'STR_POSTAL_CODE'),(2377,'STR_POSTED'),(2378,'STR_POSTED_VOUCHER_SUCCESSFULLY'),(2379,'STR_PRBENDED_INSERT_FAILED'),(2380,'STR_PRDEPOSITCHECK_INSERT_FAILED'),(2381,'STR_PREEMPLWEEK_INSERT_FAILED'),(2382,'STR_PREEMPLWEEK_UPDATE_FAILED'),(2383,'STR_PREEMPLWEEK_VACATION'),(2384,'STR_PREFERRED_MACHINE'),(2385,'STR_PREFERRED_PRINT_OPTION'),(2386,'STR_PREFLIGHT'),(2387,'STR_PREMPLDEDUCTION_UPDATE_FAILED'),(2388,'STR_PREMPLOYEE_UPDATE_FAILED'),(2389,'STR_PREMPLWEEKDEDDETAIL_UPDATE_FAILED'),(2390,'STR_PREPAID'),(2391,'STR_PREPRESS'),(2392,'STR_PRESS_QTY'),(2393,'STR_PRESS_QTY_X_COLORS'),(2394,'STR_PRESS_QTY_X_SIDES'),(2395,'STR_PRESS_TOOL_DELETED_SUCCESSFULLY'),(2396,'STR_PRESS_TOOL_NOT_FOUND'),(2397,'STR_PRESS_TOOL_UPDATED_SUCCESSFULLY'),(2398,'STR_PRESS_TOOLS_ADD'),(2399,'STR_PRESS_TOOLS_UPDATE'),(2400,'STR_PREVIEW'),(2401,'STR_PREVIOUS'),(2402,'STR_PREVIOUS_SHIPMENTS'),(2403,'STR_PREVIOUSLY'),(2404,'STR_PRICE'),(2405,'STR_PRICE_LEVEL'),(2406,'STR_PRICE_LEVEL_ADD'),(2407,'STR_PRICE_LEVEL_ADDED_SUCCESSFULLY'),(2408,'STR_PRICE_LEVEL_ALREADY_EXISTS'),(2409,'STR_PRICE_LEVEL_DELETED_SUCCESSFULLY'),(2410,'STR_PRICE_LEVEL_DESCRIPTION'),(2411,'STR_PRICE_LEVEL_DESCRIPTION_INVALID'),(2412,'STR_PRICE_LEVEL_LIST'),(2413,'STR_PRICE_LEVEL_UPDATE'),(2414,'STR_PRICE_LEVEL_UPDATED_SUCCESSFULLY'),(2415,'STR_PRICE_LIST'),(2416,'STR_PRICE_LIST_ADD'),(2417,'STR_PRICE_LIST_ADDED_SUCCESSFULLY'),(2418,'STR_PRICE_LIST_DELETED_SUCCESSFULLY'),(2419,'STR_PRICE_LIST_NAME'),(2420,'STR_PRICE_LIST_NOT_FOUND'),(2421,'STR_PRICE_LIST_PART_PRICING'),(2422,'STR_PRICE_LIST_PART_PRICING_DELETED_SUCCESSFULLY'),(2423,'STR_PRICE_LIST_PART_PRICING_UPDATED_SUCCESSFULLY'),(2424,'STR_PRICE_LIST_PART_UPDATE'),(2425,'STR_PRICE_LIST_STOCK_ADD'),(2426,'STR_PRICE_LIST_STOCK_ADDED_SUCCESSFULLY'),(2427,'STR_PRICE_LIST_STOCK_COLOR_SELECTIONS'),(2428,'STR_PRICE_LIST_STOCK_DELETED_SUCCESSFULLY'),(2429,'STR_PRICE_LIST_STOCK_NOT_FOUND'),(2430,'STR_PRICE_LIST_STOCK_UPDATE'),(2431,'STR_PRICE_LIST_STOCK_UPDATED_SUCCESSFULLY'),(2432,'STR_PRICE_LIST_STOCK_USAGE_ADD'),(2433,'STR_PRICE_LIST_STOCK_USAGE_ADDED_SUCCESSFULLY'),(2434,'STR_PRICE_LIST_STOCK_USAGE_DELETED_SUCCESSFULLY'),(2435,'STR_PRICE_LIST_STOCK_USAGE_NOT_FOUND'),(2436,'STR_PRICE_LIST_STOCK_USAGE_PRICING'),(2437,'STR_PRICE_LIST_STOCK_USAGE_PRICING_DELETED_SUCCESSFULLY'),(2438,'STR_PRICE_LIST_STOCK_USAGE_PRICING_UPDATED_SUCCESSFULLY'),(2439,'STR_PRICE_LIST_STOCK_USAGE_STOCK_LIST_ADD'),(2440,'STR_PRICE_LIST_STOCK_USAGE_STOCK_LIST_ADDED_SUCCESSFULLY'),(2441,'STR_PRICE_LIST_STOCK_USAGE_STOCK_LIST_DELETED_SUCCESSFULLY'),(2442,'STR_PRICE_LIST_STOCK_USAGE_STOCK_LIST_UPDATE'),(2443,'STR_PRICE_LIST_STOCK_USAGE_STOCK_LIST_UPDATED_SUCCESSFULLY'),(2444,'STR_PRICE_LIST_STOCK_USAGE_UPDATED_SUCCESSFULLY'),(2445,'STR_PRICE_LIST_UPDATE'),(2446,'STR_PRICE_LIST_UPDATED_SUCCESSFULLY'),(2447,'STR_PRICE_PER_JOB'),(2448,'STR_PRICE_PER_M'),(2449,'STR_PRICE_PER_PRESS_HOUR'),(2450,'STR_PRICE_PER_PRESS_QUANTITY'),(2451,'STR_PRICE_PER_UNIT'),(2452,'STR_PRICE_PER_USE'),(2453,'STR_PRICE_UNIT'),(2454,'STR_PRICE_UNIT_FOR_INVOICE'),(2455,'STR_PRICEUNIT'),(2456,'STR_PRICING_LEVEL'),(2457,'STR_PRINCIPAL'),(2458,'STR_PRINCIPAL_DUE'),(2459,'STR_PRINT'),(2460,'STR_PRINT_941S'),(2461,'STR_PRINT_ALL_CHECKS'),(2462,'STR_PRINT_CHECK'),(2463,'STR_PRINT_CHECKS'),(2464,'STR_PRINT_INVOICE'),(2465,'STR_PRINT_JOB_TICKET'),(2466,'STR_PRINT_LOCATION'),(2467,'STR_PRINT_LOCATION_ADD'),(2468,'STR_PRINT_LOCATION_DELETED_SUCCESSFULLY'),(2469,'STR_PRINT_OPTION'),(2470,'STR_PRINT_OPTIONS'),(2471,'STR_PRINT_ORDER_TICKET'),(2472,'STR_PRINT_PDF_CHECKS'),(2473,'STR_PRINT_PDF_INVOICE'),(2474,'STR_PRINT_PLANT_LOCATION_UPDATE'),(2475,'STR_PRINT_PROCESS'),(2476,'STR_PRINT_QTY'),(2477,'STR_PRINT_QTY_LENGTH_TOTAL'),(2478,'STR_PRINT_QTY_X_COLORS'),(2479,'STR_PRINT_QTY_X_SIDES'),(2480,'STR_PRINT_QUOTE'),(2481,'STR_PRINT_THIS_PACKING_LIST'),(2482,'STR_PRINT_THIS_PO'),(2483,'STR_PRINT_W2S'),(2484,'STR_PRINT_WIDTH'),(2485,'STR_PRINTING_QUOTE'),(2486,'STR_PRINTING_QUOTE_EMAIL'),(2487,'STR_PRINTSHOP'),(2488,'STR_PRIORITY'),(2489,'STR_PROCESS_ADDED_SUCCESSFULLY'),(2490,'STR_PROCESS_DELETED_SUCCESSFULLY'),(2491,'STR_PROCESS_EXISTING'),(2492,'STR_PROCESS_EXISTING2'),(2493,'STR_PROCESS_SAVED_SUCCESSFULLY'),(2494,'STR_PROFIT'),(2495,'STR_PROFIT_AND_LOSS_STATEMENT_FOR'),(2496,'STR_PROFIT_FROM_SALE_ONLY'),(2497,'STR_PROOF'),(2498,'STR_PROPTION'),(2499,'STR_PRPRICE_ID_NOT_PASSED'),(2500,'STR_PULLS_FROM_INVENTORY'),(2501,'STR_PURCHASE_ORDER'),(2502,'STR_PURCHASE_ORDER_NUMBER'),(2503,'STR_PURCHASE_UNIT'),(2504,'STR_PURPOSE'),(2505,'STR_PURPOSE_EXPLANATION'),(2506,'STR_PW_TEXT'),(2507,'STR_QC'),(2508,'STR_QTY'),(2509,'STR_QTY_AVAILABLE'),(2510,'STR_QTY_BO'),(2511,'STR_QTY_COMMITTED'),(2512,'STR_QTY_COMMITTED_OPEN'),(2513,'STR_QTY_COMMITTED_SUB'),(2514,'STR_QTY_COMMITTED_TOTAL'),(2515,'STR_QTY_ON_HAND'),(2516,'STR_QTY_ON_ORDER'),(2517,'STR_QTY_ORD'),(2518,'STR_QTY_PER_PACK'),(2519,'STR_QTY_PER_PACKAGE'),(2520,'STR_QTY_PURCHASED'),(2521,'STR_QTY_RETURNED'),(2522,'STR_QTY_SOLD'),(2523,'STR_QTY_TO_SHIP'),(2524,'STR_QTY_UNIT'),(2525,'STR_QTY_UNIT_FOR_INVOICE'),(2526,'STR_QTY_UNIT_PER'),(2527,'STR_QTY_UNITS_PER_PRICE_UNIT'),(2528,'STR_QTY_USED'),(2529,'STR_QUANTITY'),(2530,'STR_QUANTITY_BACKORDERED'),(2531,'STR_QUANTITY_ORDERED'),(2532,'STR_QUANTITY_PER_BOX_FOR_SHIPPING'),(2533,'STR_QUANTITY_REQUIRED'),(2534,'STR_QUANTITY_SHIPPED'),(2535,'STR_QUARTER'),(2536,'STR_QUARTERLY_REPORT'),(2537,'STR_QUERY_FAILED'),(2538,'STR_QUESTIO'),(2539,'STR_QUESTION'),(2540,'STR_QUOTE'),(2541,'STR_QUOTE_ADDED_SUCCESSFULLY'),(2542,'STR_QUOTE_ATTN'),(2543,'STR_QUOTE_COMMENT'),(2544,'STR_QUOTE_COMMENT_ADD'),(2545,'STR_QUOTE_COMMENT_ADDED_SUCCESSFULLY'),(2546,'STR_QUOTE_COMMENT_ALREADY_EXISTS'),(2547,'STR_QUOTE_COMMENT_DELETED_SUCCESSFULLY'),(2548,'STR_QUOTE_COMMENT_UPDATE'),(2549,'STR_QUOTE_COMMENT_UPDATED_SUCCESSFULLY'),(2550,'STR_QUOTE_COMPLETE'),(2551,'STR_QUOTE_DELETED_SUCCESSFULLY'),(2552,'STR_QUOTE_ID_NOT_PASSED'),(2553,'STR_QUOTE_NOT_FOUND'),(2554,'STR_QUOTE_NOTE'),(2555,'STR_QUOTE_NOTE_NOT_FOUND'),(2556,'STR_QUOTE_NOTES_ADD'),(2557,'STR_QUOTE_NOTES_ADDED_SUCCESSFULLY'),(2558,'STR_QUOTE_NOTES_DELETED_SUCCESSFULLY'),(2559,'STR_QUOTE_NOTES_UPDATE'),(2560,'STR_QUOTE_NOTES_UPDATED_SUCCESSFULLY'),(2561,'STR_QUOTE_NUMBER'),(2562,'STR_QUOTE_PROVIDED_BY'),(2563,'STR_QUOTE2'),(2564,'STR_QUOTED_BY'),(2565,'STR_RATE'),(2566,'STR_RATE_RUN'),(2567,'STR_RATE_SCALE'),(2568,'STR_RATE_TIMES_INCHES_HT'),(2569,'STR_RATE_TIMES_LENGTH'),(2570,'STR_RATE_TIMES_ONE'),(2571,'STR_RATE_TIMES_PRESS_QTY'),(2572,'STR_RATE_TIMES_QTY_PER_M'),(2573,'STR_RATE_TIMES_QTY_PER_NUMBERUP'),(2574,'STR_RATE_TIMES_QTY_PER_REPLY'),(2575,'STR_RATE_TIMES_QTY_TIMES_PARTS_PER_M'),(2576,'STR_RATE_TIMES_QTY_TIMES_SIDES_PER_M'),(2577,'STR_RATE_TIMES_REPLY'),(2578,'STR_RATING'),(2579,'STR_RATING_ALREADY_EXISTS_BY_THAT_NAME'),(2580,'STR_REACHED_PAGE'),(2581,'STR_READ'),(2582,'STR_READ_MESSAGES'),(2583,'STR_REASON'),(2584,'STR_RECALCULATE'),(2585,'STR_RECEIPT_FOR_THIS_ITEM_ALREADY_IN_FILE'),(2586,'STR_RECEIVABLES'),(2587,'STR_RECEIVE_NO_PO_LIST'),(2588,'STR_RECEIVE_PO'),(2589,'STR_RECEIVED'),(2590,'STR_RECEIVED_ORDERS'),(2591,'STR_RECEIVER'),(2592,'STR_RECHECK'),(2593,'STR_RECORD_COUNT'),(2594,'STR_RECORDS_WERE_POSTED_SUCCESSFULLY'),(2595,'STR_RECV_DATE'),(2596,'STR_RECV_PO'),(2597,'STR_RECV_UNIT'),(2598,'STR_REDRAW'),(2599,'STR_REDRAW_EXPLANATION'),(2600,'STR_REDRAW_TEXT'),(2601,'STR_REFERENCE'),(2602,'STR_REGULAR_DAILY_PICKUP'),(2603,'STR_RELATED_ITEM'),(2604,'STR_RELATED_ITEM_CODE'),(2605,'STR_RELATED_TOPICS'),(2606,'STR_REMAINING'),(2607,'STR_REMEMBER_THAT'),(2608,'STR_REMOVE_FILES'),(2609,'STR_RENAMED'),(2610,'STR_REPEAT_LENGTH'),(2611,'STR_REPLY'),(2612,'STR_REPORT'),(2613,'STR_REPORT_ON_MODULE'),(2614,'STR_REPORT_YEAR'),(2615,'STR_REPRINT'),(2616,'STR_REQUESTED_BY'),(2617,'STR_REQUIRED_INFO_NOT_PASSED'),(2618,'STR_REQUIRED_INVOICE'),(2619,'STR_REQUIRED_NONINVENTORY'),(2620,'STR_REQUISITION_NUMBER'),(2621,'STR_REQUISITION_NUMBERC'),(2622,'STR_RESET'),(2623,'STR_RESET_VALUES'),(2624,'STR_RESPONSETYPE'),(2625,'STR_RESPONSETYPE_VALUES'),(2626,'STR_RESULTS'),(2627,'STR_RESULTS_PER_PAGE'),(2628,'STR_RETURN'),(2629,'STR_RETURN_FROM_CHECKOUT'),(2630,'STR_RETURN_ORDER_FROM_CHECKOUT'),(2631,'STR_RETURN_TO_DETAIL_SELECTION'),(2632,'STR_RETURN_TO_DETAIL_WORK_TYPE'),(2633,'STR_RETURN_TO_OPERATION_SIZE_PRICING'),(2634,'STR_RETURN_TO_PART_SELECTION'),(2635,'STR_RETURN_TO_SELECTION'),(2636,'STR_RETURN_TO_SUB_STOCK_EDIT'),(2637,'STR_RETURN_TO_UPDATE_TOOLS'),(2638,'STR_RETURNED'),(2639,'STR_REVERSE_ALL_VOUCHERS_POSTED_ON_A_SPECIFIC_DATE'),(2640,'STR_REVERSE_ALL_VOUCHERS_POSTED_TO_A_SPECIFIC_MONTH'),(2641,'STR_REVERSE_POST'),(2642,'STR_REVIEW_AND_POST'),(2643,'STR_REVIEW_AND_PROCESS_INVENTORY'),(2644,'STR_REVIEW_BUILD_ORDERS'),(2645,'STR_REVIEW_PRICES'),(2646,'STR_REVIEW_RATING_ADDED_SUCCESSFULLY'),(2647,'STR_REVIEW_RATING_DELETED_SUCCESSFULLY'),(2648,'STR_REVIEW_RATING_UPDATED_SUCCESSFULLY'),(2649,'STR_REVISION_HISTORY'),(2650,'STR_RIGHTS'),(2651,'STR_RMA_PURCHASING'),(2652,'STR_ROLL'),(2653,'STR_ROLL_SHEET_EA'),(2654,'STR_ROOT'),(2655,'STR_RUN_ANOTHER_REPORT'),(2656,'STR_RUN_DATE'),(2657,'STR_RUN_ON'),(2658,'STR_RUN_RATE'),(2659,'STR_RUN_RATE_APPLIED_TO'),(2660,'STR_RUN_TIME_CALCULATED_HOW'),(2661,'STR_RUSH'),(2662,'STR_SAL'),(2663,'STR_SALARY'),(2664,'STR_SALES'),(2665,'STR_SALES_ACCOUNT'),(2666,'STR_SALES_ACTION'),(2667,'STR_SALES_ACTION_EDIT'),(2668,'STR_SALES_ACTION_REPORT'),(2669,'STR_SALES_ACTIONS'),(2670,'STR_SALES_AMOUNT'),(2671,'STR_SALES_CATEGORIES'),(2672,'STR_SALES_CATEGORY_EDIT'),(2673,'STR_SALES_GL_ACCOUNT'),(2674,'STR_SALES_OVERVIEW_REPORT'),(2675,'STR_SALES_PER'),(2676,'STR_SALES_PERSON'),(2677,'STR_SALES_PERSONNEL_ADD'),(2678,'STR_SALES_PERSONNEL_ADDED_SUCCESSFULLY'),(2679,'STR_SALES_PERSONNEL_DELETED_SUCCESSFULLY'),(2680,'STR_SALES_PERSONNEL_UPDATE'),(2681,'STR_SALES_PERSONNEL_UPDATED_SUCCESSFULLY'),(2682,'STR_SALES_PRICE'),(2683,'STR_SALES_PROCESS'),(2684,'STR_SALES_PROCESS_EDIT'),(2685,'STR_SALES_STATUS'),(2686,'STR_SALES_TAX'),(2687,'STR_SALES_TAX_ADD'),(2688,'STR_SALES_TAX_ADDED_SUCCESSFULLY'),(2689,'STR_SALES_TAX_DELETED_SUCCESSFULLY'),(2690,'STR_SALES_TAX_DISTRICT'),(2691,'STR_SALES_TAX_ID'),(2692,'STR_SALES_TAX_NAME_ALREADY_EXISTS'),(2693,'STR_SALES_TAX_UPDATE'),(2694,'STR_SALES_TAX_UPDATED_SUCCESSFULLY'),(2695,'STR_SALES_TRACKER'),(2696,'STR_SALES_UNIT'),(2697,'STR_SALES_YEAR_TO_DATE'),(2698,'STR_SALESMAN'),(2699,'STR_SALESMAN_DUPE'),(2700,'STR_SALESPERSON'),(2701,'STR_SALEUNIT'),(2702,'STR_SAVE'),(2703,'STR_SAVE_ADD_ACTION'),(2704,'STR_SAVE_ADD_CATEGORY'),(2705,'STR_SAVE_ADD_PROCESS'),(2706,'STR_SAVE_AND_POST_COUNTS_ENTERED'),(2707,'STR_SAVE_AND_REDISPLAY'),(2708,'STR_SAVE_BUDGET_INFO'),(2709,'STR_SAVE_BUILD_ORDER'),(2710,'STR_SAVE_CHANGES'),(2711,'STR_SAVE_CHANGES_ADD_ADDL'),(2712,'STR_SAVE_CHANGES_MAKE_ROOM'),(2713,'STR_SAVE_DATA'),(2714,'STR_SAVE_DETAILS'),(2715,'STR_SAVE_EDIT_ACTION'),(2716,'STR_SAVE_EDIT_CATEGORY'),(2717,'STR_SAVE_EDIT_PROCESS'),(2718,'STR_SAVE_ENTRY'),(2719,'STR_SAVE_INVOICE'),(2720,'STR_SAVE_LOCATION'),(2721,'STR_SAVE_NEW_DETAIL'),(2722,'STR_SAVE_NEW_INVENTORY_COUNT'),(2723,'STR_SAVE_PIE'),(2724,'STR_SAVE_QUOTE'),(2725,'STR_SAVE_SHIPPING_INFO'),(2726,'STR_SAVE_UPDATE_LOCATION'),(2727,'STR_SB_COMPANY_LIMIT'),(2728,'STR_SB_CUST_LIMIT'),(2729,'STR_SB_EMP_LIMIT'),(2730,'STR_SB_INV_LIMIT'),(2731,'STR_SB_LIMIT1'),(2732,'STR_SB_LIMIT2'),(2733,'STR_SB_LIMIT3'),(2734,'STR_SB_LIMIT4'),(2735,'STR_SB_VEND_LIMIT'),(2736,'STR_SCRAP'),(2737,'STR_SCREEN'),(2738,'STR_SEARCH'),(2739,'STR_SEARCH_AGAIN'),(2740,'STR_SEARCH_CATEGORY'),(2741,'STR_SEARCH_FOR_ITEM_NAME'),(2742,'STR_SEARCH_FOR_ITEM_NAME_BEGIN'),(2743,'STR_SEARCH_FOR_ITEM_NUMBER'),(2744,'STR_SEARCH_FOR_ITEM_NUMBER_BEGIN'),(2745,'STR_SEARCH_FOR_ORDER_TO_SHIP'),(2746,'STR_SEARCH_FOR_SHIPPED_ORDER_TO_VIEW'),(2747,'STR_SEARCH_QUOTES'),(2748,'STR_SEARCH_TERM'),(2749,'STR_SEASON'),(2750,'STR_SECOND'),(2751,'STR_SELECT'),(2752,'STR_SELECT_ACTION_TO_EDIT'),(2753,'STR_SELECT_AGAIN_TO_REMOVE_FROM_LIST'),(2754,'STR_SELECT_ANOTHER_ACTION_TO_EDIT'),(2755,'STR_SELECT_ANOTHER_CATEGORY_TO_EDIT'),(2756,'STR_SELECT_ANOTHER_COMPANY'),(2757,'STR_SELECT_ANOTHER_ITEM'),(2758,'STR_SELECT_ANOTHER_PROCESS_TO_EDIT'),(2759,'STR_SELECT_ANOTHER_SHIPTO_LOCATION'),(2760,'STR_SELECT_ANOTHER_USER'),(2761,'STR_SELECT_BUDGET_TO_USE'),(2762,'STR_SELECT_CUSTOMER'),(2763,'STR_SELECT_CUSTOMER_FILE'),(2764,'STR_SELECT_EXISTING_USER'),(2765,'STR_SELECT_FILE'),(2766,'STR_SELECT_GROUP_TO_CREATE_INVOICE'),(2767,'STR_SELECT_ITEM'),(2768,'STR_SELECT_ITEM_OR_DATE_RANGE_TO_PURGE'),(2769,'STR_SELECT_MARKUP_SET'),(2770,'STR_SELECT_NEW_COST_CENTER'),(2771,'STR_SELECT_OPEN_BUILD_ORDER'),(2772,'STR_SELECT_PAGE'),(2773,'STR_SELECT_PAY_PERIOD'),(2774,'STR_SELECT_PAY_PERIOD_DATES'),(2775,'STR_SELECT_PLAN'),(2776,'STR_SELECT_SALES_PROCESS_TO_EDIT'),(2777,'STR_SELECT_SPECIFIC_COLORS'),(2778,'STR_SELECT_SUPPLIER'),(2779,'STR_SELECT_THE_COMPANY'),(2780,'STR_SELECT_TOOL_TO_EDIT'),(2781,'STR_SELECT_VENDOR'),(2782,'STR_SELECTED'),(2783,'STR_SELECTED_PERIOD'),(2784,'STR_SELECTION'),(2785,'STR_SELECTION_PLUS_OTHER'),(2786,'STR_SELECTION_W_ENTRY_BOX'),(2787,'STR_SELL_PRICE'),(2788,'STR_SEND_EMAIL'),(2789,'STR_SEND_MESSAGE'),(2790,'STR_SEND_NEW_MESSAGE'),(2791,'STR_SEND_ORDERS_TO_INVOICING'),(2792,'STR_SEND_QUOTE'),(2793,'STR_SEND_REPLY'),(2794,'STR_SENDER'),(2795,'STR_SENT'),(2796,'STR_SENT_MESSAGES'),(2797,'STR_SENT_ON'),(2798,'STR_SEPTEMBER'),(2799,'STR_SERVER_SETUP'),(2800,'STR_SERVER_SETUP_OK'),(2801,'STR_SERVICE'),(2802,'STR_SERVICE_CHARGE'),(2803,'STR_SERVICE_REP'),(2804,'STR_SET_DEFAULTS'),(2805,'STR_SETUP'),(2806,'STR_SETUP_CHARGE'),(2807,'STR_SETUP_COMPLETED'),(2808,'STR_SEVEN'),(2809,'STR_SEVENTEEN'),(2810,'STR_SEVENTY'),(2811,'STR_SHEET'),(2812,'STR_SHIFT'),(2813,'STR_SHIP'),(2814,'STR_SHIP_CARE'),(2815,'STR_SHIP_CARE2'),(2816,'STR_SHIP_DATE'),(2817,'STR_SHIP_FROM'),(2818,'STR_SHIP_QTY'),(2819,'STR_SHIP_TO'),(2820,'STR_SHIP_TO_ADD'),(2821,'STR_SHIP_TO_ADDRESS'),(2822,'STR_SHIP_TO_ADDRESS_LOOKUP'),(2823,'STR_SHIP_TO_CITY'),(2824,'STR_SHIP_TO_COMPANY'),(2825,'STR_SHIP_TO_STATE'),(2826,'STR_SHIP_TO_ZIP_CODE'),(2827,'STR_SHIPPED'),(2828,'STR_SHIPPED_FROM'),(2829,'STR_SHIPPED_ITEM_LIST_FOR'),(2830,'STR_SHIPPED_ONLY'),(2831,'STR_SHIPPED_ORDER_LIST_FOR'),(2832,'STR_SHIPPED_TOTALS'),(2833,'STR_SHIPPING'),(2834,'STR_SHIPPING_CARRIER_ADD'),(2835,'STR_SHIPPING_COST'),(2836,'STR_SHIPPING_DATE'),(2837,'STR_SHIPPING_LIABILITY'),(2838,'STR_SHIPPING_METHOD'),(2839,'STR_SHIPPING_METHOD_ADDED_SUCCESSFULLY'),(2840,'STR_SHIPPING_METHOD_DELETED_SUCCESSFULLY'),(2841,'STR_SHIPPING_METHOD_UPDATE'),(2842,'STR_SHIPPING_METHOD_UPDATED_SUCCESSFULLY'),(2843,'STR_SHIPPING_TYPE'),(2844,'STR_SHIPTO_LOCATION'),(2845,'STR_SHIPTO_LOCATIONS'),(2846,'STR_SHOPPING'),(2847,'STR_SHOPPING_CART'),(2848,'STR_SHOPPING_CART_DISPLAY'),(2849,'STR_SHOW'),(2850,'STR_SHOW_ALL'),(2851,'STR_SHOW_ALL_ENTRIES'),(2852,'STR_SHOW_BY_CURRENT_MONTH'),(2853,'STR_SHOW_BY_CURRENT_QUARTER'),(2854,'STR_SHOW_COSTCENTER_BREAKDOWN'),(2855,'STR_SHOW_COSTS'),(2856,'STR_SHOW_CURRENT'),(2857,'STR_SHOW_CURRENT_MONTH'),(2858,'STR_SHOW_DETAILS'),(2859,'STR_SHOW_FIRSTLINE'),(2860,'STR_SHOW_INVOICES'),(2861,'STR_SHOW_LIST'),(2862,'STR_SHOW_ON_QUOTE_WHEN'),(2863,'STR_SHOW_ONLY_CASHED'),(2864,'STR_SHOW_ONLY_NON_CASHED'),(2865,'STR_SHOW_PAYMENTS_ENTERED_DURING_LAST'),(2866,'STR_SHOW_PENDING'),(2867,'STR_SHOW_PICTURES'),(2868,'STR_SHOW_POSTED_ENTRIES_ONLY'),(2869,'STR_SHOW_POSTED_ONLY'),(2870,'STR_SHOW_RECEIVED'),(2871,'STR_SHOW_UNPOSTED_ENTRIES_ONLY'),(2872,'STR_SHOW_UNPOSTED_ONLY'),(2873,'STR_SHOWING_LISTING'),(2874,'STR_SHOWN'),(2875,'STR_SICK'),(2876,'STR_SICK_LEAVE_HOURS_ACCRUED'),(2877,'STR_SICK_LEAVE_HOURS_ALLOWED_PER_YEAR'),(2878,'STR_SIDE_1'),(2879,'STR_SIDE_2'),(2880,'STR_SIDE_ONE'),(2881,'STR_SIDE_TWO'),(2882,'STR_SINGLE'),(2883,'STR_SIX'),(2884,'STR_SIXTEEN'),(2885,'STR_SIXTY'),(2886,'STR_SIZE'),(2887,'STR_SIZE_NOT_FOUND'),(2888,'STR_SLICE'),(2889,'STR_SLICE_BEGIN_DATE'),(2890,'STR_SLICE_DESCRIPTION'),(2891,'STR_SLICE_END_DATE'),(2892,'STR_SLICE_NAME'),(2893,'STR_SLICE_TO_EDIT'),(2894,'STR_SLITTER'),(2895,'STR_SLSM'),(2896,'STR_SMALL_BUSINESS'),(2897,'STR_SOCIAL_MUST_BE_9'),(2898,'STR_SOCIAL_SECURITY'),(2899,'STR_SOLD'),(2900,'STR_SORRY_THE'),(2901,'STR_SORT_BY'),(2902,'STR_SORT_ORDER'),(2903,'STR_SORT_ORDER_FOR_DISPLAY'),(2904,'STR_SORT_PRIORITY'),(2905,'STR_SORTORDER'),(2906,'STR_SORTORDER_EXPLANATION'),(2907,'STR_SOURCE'),(2908,'STR_SPANISH'),(2909,'STR_SPECIAL_NOTES'),(2910,'STR_SPECIFIC_COMPANY'),(2911,'STR_SPECIFIC_GL_ACCOUNT'),(2912,'STR_SPECIFY_COST_WEIGHT_PER_PACKAGE'),(2913,'STR_SQ_IN_COVERAGE_PER_UNIT'),(2914,'STR_SSN'),(2915,'STR_ST_GL'),(2916,'STR_ST_HOURS'),(2917,'STR_ST_PAY'),(2918,'STR_STAND_MARKUP'),(2919,'STR_STANDARD_GL_ACCOUNTS_NOT_SET_UP_FOR_PAYROLL'),(2920,'STR_STANDARD_MARKUP_SET_ADD'),(2921,'STR_STANDARD_MARKUP_SET_ALREADY_EXISTS'),(2922,'STR_STANDARD_MARKUP_SET_LIST'),(2923,'STR_STANDARD_MARKUP_SET_UPDATE'),(2924,'STR_STANDARD_SIZE_ADD'),(2925,'STR_STANDARD_SIZE_ADDED_SUCCESSFULLY'),(2926,'STR_STANDARD_SIZE_DELETED_SUCCESSFULLY'),(2927,'STR_STANDARD_SIZE_UPDATE'),(2928,'STR_STANDARD_SIZE_UPDATED_SUCCESSFULLY'),(2929,'STR_STANDARD_UPDATE_SUCCESSFUL'),(2930,'STR_STARRED_ENTRIES'),(2931,'STR_START_FILLING_ORDER'),(2932,'STR_START_FILLING_ORDER_NUMBER'),(2933,'STR_STARTED_FILL'),(2934,'STR_STARTING_QUANTITY'),(2935,'STR_STAT'),(2936,'STR_STATE'),(2937,'STR_STATE_EXEMPTIONS'),(2938,'STR_STATE_INCOME_TAX'),(2939,'STR_STATE_TAX'),(2940,'STR_STATE_TAX2'),(2941,'STR_STATE_UNEMPLOYMENT_ID'),(2942,'STR_STATE_UNEMPLOYMENT_TAX'),(2943,'STR_STATE_UNEMPLOYMENT_TAX_EXPENSE'),(2944,'STR_STATE_UNEMPLOYMENT_TAX_PAYABLE'),(2945,'STR_STATE_WAGES'),(2946,'STR_STATEMENT_FROM'),(2947,'STR_STATISTICS'),(2948,'STR_STATUS'),(2949,'STR_STD_COLOR'),(2950,'STR_STOCK'),(2951,'STR_STOCK_ADD'),(2952,'STR_STOCK_ADDED_SUCCESSFULLY'),(2953,'STR_STOCK_COLOR_LIST'),(2954,'STR_STOCK_COLORS_UPDATED_SUCCESSFULLY'),(2955,'STR_STOCK_COST_UPDATE'),(2956,'STR_STOCK_LIST'),(2957,'STR_STOCK_NAME'),(2958,'STR_STOCK_PURPOSE'),(2959,'STR_STOCK_TYPE'),(2960,'STR_STOCK_UNITS'),(2961,'STR_STOCK_UPDATE_ADD_SUBGROUPS'),(2962,'STR_STOCK_UPDATED_SUCCESSFULLY'),(2963,'STR_STOCKDETAILS'),(2964,'STR_STOCKING_LEVELS_IN'),(2965,'STR_STOCKUSAGEID_NOT_PASSED'),(2966,'STR_STOP_FILLING_ORDER'),(2967,'STR_STOP_FILLING_ORDER_NUMBER'),(2968,'STR_STR_TOOLS'),(2969,'STR_STREET'),(2970,'STR_STYLE'),(2971,'STR_SUB'),(2972,'STR_SUB_GROUP_NAME'),(2973,'STR_SUB_STOCK'),(2974,'STR_SUBGROUP_NAME'),(2975,'STR_SUBMIT'),(2976,'STR_SUBMIT_CHANGES'),(2977,'STR_SUBTOTAL'),(2978,'STR_SUBTOTALS'),(2979,'STR_SUCCESSFULLY'),(2980,'STR_SUI'),(2981,'STR_SUI_TAX'),(2982,'STR_SUM'),(2983,'STR_SUMMARIZE_TO_ACCOUNT'),(2984,'STR_SUMMARIZED'),(2985,'STR_SUMMARY'),(2986,'STR_SUMMARY_TOTALS_BY_INVOICE'),(2987,'STR_SUPERVISOR'),(2988,'STR_TABLE_MOD_HELP_CATEGORIES_CREATED'),(2989,'STR_TABLE_MOD_HELP_RELATED_TOPICS_CREATED'),(2990,'STR_TABLE_MOD_HELP_TOPICS_CREATED'),(2991,'STR_TABLE_MOD_WEBSHOP_CATEGORIES_REMOVED'),(2992,'STR_TABLE_MOD_WEBSHOP_CUSTOMERS_REMOVED'),(2993,'STR_TABLE_MOD_WEBSHOP_ORDER_ITEMS_REMOVED'),(2994,'STR_TABLE_MOD_WEBSHOP_ORDERS_REMOVED'),(2995,'STR_TABLE_MOD_WEBSHOP_PRODUCTS_REMOVED'),(2996,'STR_TABLE_MOD_WEBSHOP_SUB_CATEGORIES_REMOVED'),(2997,'STR_TARGET_QUANTITY_OF'),(2998,'STR_TAX'),(2999,'STR_TAX_ADDED_SUCCESSFULLY'),(3000,'STR_TAX_AMOUNT'),(3001,'STR_TAX_BASE'),(3002,'STR_TAX_CHECK_INSERT_FAILED'),(3003,'STR_TAX_CREDITS_AFTER_TAX_CALCULATED'),(3004,'STR_TAX_DELETED_SUCCESSFULLY'),(3005,'STR_TAX_EXEMPTION'),(3006,'STR_TAX_EXEMPTION_ADD'),(3007,'STR_TAX_EXEMPTION_ADDED_SUCCESSFULLY'),(3008,'STR_TAX_EXEMPTION_DELETED_SUCCESSFULLY'),(3009,'STR_TAX_EXEMPTION_NAME_ALREADY_EXISTS'),(3010,'STR_TAX_EXEMPTION_REASON'),(3011,'STR_TAX_EXEMPTION_UPDATE'),(3012,'STR_TAX_EXEMPTION_UPDATED_SUCCESSFULLY'),(3013,'STR_TAX_FOR_ANNUAL_EARNINGS_OVER'),(3014,'STR_TAX_INFO'),(3015,'STR_TAX_LESS'),(3016,'STR_TAX_NAME'),(3017,'STR_TAX_NOT_FOUND'),(3018,'STR_TAX_NUMBER_FOR_W2'),(3019,'STR_TAX_PAID_EXPENSE'),(3020,'STR_TAX_PERCENT'),(3021,'STR_TAX_QUESTION'),(3022,'STR_TAX_RATE'),(3023,'STR_TAX_TABLES_UPDATED_SUCCESSFULLY'),(3024,'STR_TAX_TYPE'),(3025,'STR_TAX_TYPE_DELETED_SUCCESSFULLY'),(3026,'STR_TAX_TYPE_NOT_FOUND'),(3027,'STR_TAX_TYPE_UDPATED_SUCCESSFULLY'),(3028,'STR_TAX_UPDATED_SUCCESSFULLY'),(3029,'STR_TAX_WITHHELD'),(3030,'STR_TAXABLE'),(3031,'STR_TAXABLE_PAY'),(3032,'STR_TAXABLE_PAY_TAX'),(3033,'STR_TEN'),(3034,'STR_TERMINATE'),(3035,'STR_TERMS'),(3036,'STR_TEXT_PORTION_OF_NOTE'),(3037,'STR_THANK_YOU'),(3038,'STR_THANK_YOU_FOR_REQUESTING_A_PRINTING_QUOTE'),(3039,'STR_THE_ACCOUNTS_WERE_ADDED_SUCCESSFULLY'),(3040,'STR_THE_FRAMEWORK_IS_NOT_INSTALLED'),(3041,'STR_THE_TRANSACTION_COULD_NOT_BE_COMMITTED'),(3042,'STR_THEN_NEXT'),(3043,'STR_THEN_SHOW_LIST'),(3044,'STR_THERE_ARE_NO_MASTER_ITEMS'),(3045,'STR_THERE_IS_NO_MATCHING_ITEM'),(3046,'STR_THERE_WAS_AN_ERROR'),(3047,'STR_THERE_WERE_NO_RECORDS_INSERTED'),(3048,'STR_THIRD'),(3049,'STR_THIRTEEN'),(3050,'STR_THIRTY'),(3051,'STR_THIS_BUDGET_HAS_ALREADY_BEEN_DELETED'),(3052,'STR_THIS_DOCUMENT_HAS_BEEN_FINALIZED'),(3053,'STR_THIS_DOCUMENT_IS_AVAILABLE'),(3054,'STR_THIS_DOCUMENT_IS_CURRENTLY_CHECKED_OUT'),(3055,'STR_THIS_EMPLOYEE'),(3056,'STR_THIS_FILETYPE_IS_NOT_SUPPORTED'),(3057,'STR_THIS_INVOICE_HAS_BEEN_POSTED'),(3058,'STR_THIS_ORDER_HAS_BEEN_FULFILLED'),(3059,'STR_THIS_ORDER_HAS_BEEN_FULLY_SHIPPED'),(3060,'STR_THIS_ORDER_HAS_THE_FOLLOWING_SHIPMENTS'),(3061,'STR_THIS_PERIOD'),(3062,'STR_THOUSAND'),(3063,'STR_THREE'),(3064,'STR_TIGHT_REGISTRATION'),(3065,'STR_TIGHT_REGISTRATION_ON_SIDE'),(3066,'STR_TIMES_USED'),(3067,'STR_TIPS'),(3068,'STR_TIPS_AS_WAGES'),(3069,'STR_TIPS_AS_WAGES2'),(3070,'STR_TITLE'),(3071,'STR_TITLE_OF_REQUEST'),(3072,'STR_TO'),(3073,'STR_TO_BEGIN_DOWNLOADING'),(3074,'STR_TO_CHECK_OUT'),(3075,'STR_TO_CONTINUE'),(3076,'STR_TO_DATE'),(3077,'STR_TO_DELETE'),(3078,'STR_TO_JOB'),(3079,'STR_TO_THIS_SAME'),(3080,'STR_TO_UNPOST'),(3081,'STR_TOOL_NAME'),(3082,'STR_TOOL_PLANT_LOCATION'),(3083,'STR_TOOL_TYPE'),(3084,'STR_TOOLTIP'),(3085,'STR_TOPIC_MOVED'),(3086,'STR_TOPIC_REMOVED'),(3087,'STR_TOPIC_UPDATED'),(3088,'STR_TOT_GL'),(3089,'STR_TOT_MULTICOMPANY'),(3090,'STR_TOTAL'),(3091,'STR_TOTAL_ALL_CASHED_CHECKS'),(3092,'STR_TOTAL_ALL_CHECKS'),(3093,'STR_TOTAL_ALL_PENDING_CHECKS'),(3094,'STR_TOTAL_ALL_VALID_CHECKS'),(3095,'STR_TOTAL_ALL_VOIDED_CHECKS'),(3096,'STR_TOTAL_ASSETS'),(3097,'STR_TOTAL_COST'),(3098,'STR_TOTAL_DED'),(3099,'STR_TOTAL_DEPOSITS'),(3100,'STR_TOTAL_EQUITY'),(3101,'STR_TOTAL_FOR'),(3102,'STR_TOTAL_FOR_ALL'),(3103,'STR_TOTAL_IN_GROUP'),(3104,'STR_TOTAL_INTEREST'),(3105,'STR_TOTAL_LIABILITIES'),(3106,'STR_TOTAL_MISC_DEDUCTIONS'),(3107,'STR_TOTAL_NUMBER_INVOICES'),(3108,'STR_TOTAL_PAGES'),(3109,'STR_TOTAL_PAY_OVER_MAX'),(3110,'STR_TOTAL_POS_RECEIVED'),(3111,'STR_TOTAL_PRICE'),(3112,'STR_TOTAL_PRICE_EXCEEDS_CUSTOMER_CREDIT_LIMIT'),(3113,'STR_TOTAL_SALARY_DEFAULT'),(3114,'STR_TOTAL_SALE'),(3115,'STR_TOTAL_SALES'),(3116,'STR_TOTAL_WAGES'),(3117,'STR_TOTALING'),(3118,'STR_TOTALS'),(3119,'STR_TOTALS_FOR'),(3120,'STR_TOTALS_FOR_ACCOUNT'),(3121,'STR_TOTALS_FOR_DATE'),(3122,'STR_TOTALS_FOR_THE_DATE_OF'),(3123,'STR_TOTALS_FOR_VOUCHER'),(3124,'STR_TOTALSC'),(3125,'STR_TRACKING_ENTRY_ADDED_SUCCESSFULLY'),(3126,'STR_TRACKING_NUMBER'),(3127,'STR_TRACKING_NUMBER_VARIABLE'),(3128,'STR_TRACKING_URL'),(3129,'STR_TRANSACTION_DATE'),(3130,'STR_TRIAL_BALANCE'),(3131,'STR_TRIM_CHARGE_M_CUT'),(3132,'STR_TRIM_CHARGE_MINIMUM'),(3133,'STR_TRIM_CHARGE_MINIMUM_CUT'),(3134,'STR_TRY_AGAIN'),(3135,'STR_TT_CSVLIST'),(3136,'STR_TT_CSVLIST_2'),(3137,'STR_TT_CUSTLISTMAIN'),(3138,'STR_TT_CUSTLISTSHIP'),(3139,'STR_TT_LOC'),(3140,'STR_TT_MAIL_LABELS_ORDER_FROM'),(3141,'STR_TT_MAIL_LABELS_PAY_TO'),(3142,'STR_TT_MAILLISTCUST'),(3143,'STR_TT_MAILLISTSHIP'),(3144,'STR_TT_PASS'),(3145,'STR_TT_PLANT'),(3146,'STR_TT_USER'),(3147,'STR_TT_VENDOR_LIST'),(3148,'STR_TURN_AROUND_DAYS'),(3149,'STR_TURN_AROUND_DAYS_OVER_QUANTITY'),(3150,'STR_TURN_AROUND_DAYS_UP_TO_QUANTITY'),(3151,'STR_TURNAROUND'),(3152,'STR_TWELVE'),(3153,'STR_TWENTY'),(3154,'STR_TWO'),(3155,'STR_TWO_TRIMS'),(3156,'STR_TYPE'),(3157,'STR_TYPE_OF_ACCOUNT'),(3158,'STR_TYPE2'),(3159,'STR_UNABLE_TO_RETRIEVE_LIST_OF_BUDGETS'),(3160,'STR_UNABLE_TO_REVERSE_VOUCHERS'),(3161,'STR_UNABLE_TO_SELECT_DATABASE'),(3162,'STR_UNBILLED_ORDERS'),(3163,'STR_UNDER'),(3164,'STR_UNDETERMINED'),(3165,'STR_UNIT'),(3166,'STR_UNIT_NAME_ADD'),(3167,'STR_UNIT_NAME_ADDED_SUCCESSFULLY'),(3168,'STR_UNIT_NAME_ALREADY_EXISTS'),(3169,'STR_UNIT_NAME_DELETED_SUCCESSFULLY'),(3170,'STR_UNIT_NAME_UPDATE'),(3171,'STR_UNIT_NAME_UPDATED_SUCCESSFULLY'),(3172,'STR_UNIT_PRICE'),(3173,'STR_UNIT_SIZE'),(3174,'STR_UNKNOWN_ACTION'),(3175,'STR_UNLIMITED'),(3176,'STR_UNPAID'),(3177,'STR_UNPOST'),(3178,'STR_UNPOST_INVOICE'),(3179,'STR_UNPOSTED'),(3180,'STR_UNPOSTED_SUCCESSFULLY'),(3181,'STR_UNRECEIVE_COMPLETE'),(3182,'STR_UNRECEIVE_THIS_ITEM'),(3183,'STR_UP_TO'),(3184,'STR_UP_TO_QTY'),(3185,'STR_UP_TO_THIS_QUANTITY'),(3186,'STR_UPDATE'),(3187,'STR_UPDATE_A_DIFFERENT_CUSTOMER'),(3188,'STR_UPDATE_A_LOCATION'),(3189,'STR_UPDATE_ACCOUNT_BUDGET'),(3190,'STR_UPDATE_ADD_MACHINE_FAMILIES'),(3191,'STR_UPDATE_AN_ACCOUNT_BUDGET'),(3192,'STR_UPDATE_ANOTHER_ITEM'),(3193,'STR_UPDATE_BINDERY_FUNCTIONS_FOR_THIS_TYPE'),(3194,'STR_UPDATE_CARRIER_METHOD'),(3195,'STR_UPDATE_COLOR_LIST'),(3196,'STR_UPDATE_COSTS'),(3197,'STR_UPDATE_COSTS_AND_PRICING'),(3198,'STR_UPDATE_CUSTOMER_PRICING'),(3199,'STR_UPDATE_DELETED_SUCCESSFULLY'),(3200,'STR_UPDATE_DETAIL_WORK_TYPE_INFO'),(3201,'STR_UPDATE_DOCUMENT_PROPERTIES'),(3202,'STR_UPDATE_FAILED'),(3203,'STR_UPDATE_GENERAL_PO_NUMBER'),(3204,'STR_UPDATE_GENERAL_VOUCHER_INFORMATION'),(3205,'STR_UPDATE_INVENTORY_PO'),(3206,'STR_UPDATE_JOB_PARTS_FOR_THE_PRICE_LIST'),(3207,'STR_UPDATE_LOCATION'),(3208,'STR_UPDATE_OPERATION'),(3209,'STR_UPDATE_OPERATIONS'),(3210,'STR_UPDATE_ORDER'),(3211,'STR_UPDATE_PO'),(3212,'STR_UPDATE_PO_DETAILS'),(3213,'STR_UPDATE_PRICE_TABLE_FOR_THE_PRICE_LIST'),(3214,'STR_UPDATE_QUOTE_REVISION'),(3215,'STR_UPDATE_SELECTIONS'),(3216,'STR_UPDATE_SHIPTO_ADDRESSES'),(3217,'STR_UPDATE_STOCK_COLORS'),(3218,'STR_UPDATE_STOCK_LIST_FOR_THIS_PART'),(3219,'STR_UPDATE_STOCK_PRICE_LIST_FOR_THIS_PART'),(3220,'STR_UPDATE_STOCKS_FOR_THE_PRICE_LIST'),(3221,'STR_UPDATE_SUCCESSFUL'),(3222,'STR_UPDATE_TABLE'),(3223,'STR_UPDATE_TAX_TABLES'),(3224,'STR_UPDATE_USER_DISABLED_IN_DEMO_MODE'),(3225,'STR_UPDATED_SUCCESSFULLY'),(3226,'STR_UPDATING_FILE'),(3227,'STR_UPLOADED_FILE_CANNOT_BE_EMPTY'),(3228,'STR_UPS_GROUND'),(3229,'STR_UPS_NEXT'),(3230,'STR_UPS_SECOND'),(3231,'STR_UPS_THIRD'),(3232,'STR_URDU'),(3233,'STR_URL_FILE_FOR_CSV_FORMAT'),(3234,'STR_URL_FILE_FOR_PRODUCT_GRAPHIC'),(3235,'STR_URL_FILE_FOR_PRODUCT_SHEET'),(3236,'STR_URL_FILE_TO_ATTACH'),(3237,'STR_US'),(3238,'STR_USAGE'),(3239,'STR_USAGE_UNIT'),(3240,'STR_USAGES_UNITS_PER_PRICE_UNIT'),(3241,'STR_USE_ORDER_RECEIVE'),(3242,'STR_USE_PRICES_STOCKS_FROM_OTHER_PRICE_LIST'),(3243,'STR_USE_PRICES_STOCKS_FROM_PRICE_LIST'),(3244,'STR_USE_RIGHT_CLICK'),(3245,'STR_USE_STOCK_INFO_FROM_OTHER_USAGE_ENTRY'),(3246,'STR_USE_TRANSACTION_DATE'),(3247,'STR_USE_WITH_WORK_TYPE'),(3248,'STR_USED'),(3249,'STR_USED_PER'),(3250,'STR_USED_QTY'),(3251,'STR_USED_TOTALS'),(3252,'STR_USER'),(3253,'STR_USER_ADD'),(3254,'STR_USER_ADDED_SUCCESSFULLY'),(3255,'STR_USER_DELETED_SUCCESSFULLY'),(3256,'STR_USER_NAME'),(3257,'STR_USER_NAME_ADDED_SUCCESSFULLY'),(3258,'STR_USER_NAME_DELETED_SUCCESSFULLY'),(3259,'STR_USER_NAME_UPDATED_SUCCESSFULLY'),(3260,'STR_USER_PROMPT'),(3261,'STR_USER_RIGHTS_ADDED_SUCCESSFULLY'),(3262,'STR_USER_RIGHTS_UPDATED_SUCCESSFULLY'),(3263,'STR_USER_UPDATE'),(3264,'STR_USER_UPDATED_SUCCESSFULLY'),(3265,'STR_USERID_NOT_FOUND'),(3266,'STR_VACATION'),(3267,'STR_VACATION_HOURS_ACCRUED'),(3268,'STR_VALID_REPLY'),(3269,'STR_VALUE'),(3270,'STR_VALUE_AT'),(3271,'STR_VARIANCE'),(3272,'STR_VENDCOMPANYID_INVALID'),(3273,'STR_VENDED'),(3274,'STR_VENDOR'),(3275,'STR_VENDOR_ADD'),(3276,'STR_VENDOR_ADDED_SUCCESSFULLY'),(3277,'STR_VENDOR_ALREADY_EXISTS'),(3278,'STR_VENDOR_COMPANY_NAME'),(3279,'STR_VENDOR_DATA_NOT_FOUND'),(3280,'STR_VENDOR_DATE_CHECK_NUMBER'),(3281,'STR_VENDOR_DELETED_SUCCESSFULLY'),(3282,'STR_VENDOR_EXTERNAL_USER_UPDATE'),(3283,'STR_VENDOR_FOR_PAYROLL_DEPOSIT_CHECK'),(3284,'STR_VENDOR_INFO_FOR'),(3285,'STR_VENDOR_ITEM_DELETED'),(3286,'STR_VENDOR_ITEM_IS_UPDATED'),(3287,'STR_VENDOR_LIST'),(3288,'STR_VENDOR_LISTS_AND_LABELS'),(3289,'STR_VENDOR_LOGIN_USER'),(3290,'STR_VENDOR_LOOKUP'),(3291,'STR_VENDOR_MAINT'),(3292,'STR_VENDOR_NAME'),(3293,'STR_VENDOR_NOT_ADDED'),(3294,'STR_VENDOR_NOT_FOUND'),(3295,'STR_VENDOR_NUMBER'),(3296,'STR_VENDOR_NUMBER_SUPPLIER'),(3297,'STR_VENDOR_ORDER_NUMBER'),(3298,'STR_VENDOR_PRODUCT_CODE'),(3299,'STR_VENDOR_TERMS'),(3300,'STR_VENDOR_TERMS_ADD'),(3301,'STR_VENDOR_TERMS_ADDED_SUCCESSFULLY'),(3302,'STR_VENDOR_TERMS_ALREADY_EXIST'),(3303,'STR_VENDOR_TERMS_DELETED_SUCCESSFULLY'),(3304,'STR_VENDOR_TERMS_NEW'),(3305,'STR_VENDOR_TERMS_UPDATE'),(3306,'STR_VENDOR_TERMS_UPDATED_SUCCESSFULLY'),(3307,'STR_VENDOR_UPDATE'),(3308,'STR_VENDOR_UPDATED_SUCCESSFULLY'),(3309,'STR_VERBAL'),(3310,'STR_VERIFY'),(3311,'STR_VERIFYP'),(3312,'STR_VERSION'),(3313,'STR_VERSION_A'),(3314,'STR_VERSION_B'),(3315,'STR_VERSION_C'),(3316,'STR_VERSION_D'),(3317,'STR_VERSION_INFO'),(3318,'STR_VERSION_INFO_TXT'),(3319,'STR_VIEW'),(3320,'STR_VIEW_DOCUMENT'),(3321,'STR_VIEW_FINALIZED_BUILD_ORDERS_CREATED_BETWEEN'),(3322,'STR_VIEW_HISTORY'),(3323,'STR_VIEW_PRICING'),(3324,'STR_VOID'),(3325,'STR_VOID_CALCULATIONS'),(3326,'STR_VOID_CALCULATIONS_AND_PAY_DATA'),(3327,'STR_VOID_CHECK'),(3328,'STR_VOID_CHECK_AND_CALCULATIONS'),(3329,'STR_VOID_CHECK_CALCULATIONS_AND_PAY_DATA'),(3330,'STR_VOIDED_CHECKS_MARKED'),(3331,'STR_VOIDED_SUCCESSFULLY'),(3332,'STR_VOUCH_OK'),(3333,'STR_VOUCHER'),(3334,'STR_VOUCHER_ADDED_SUCCESSFULLY'),(3335,'STR_VOUCHER_COMPLETE'),(3336,'STR_VOUCHER_DATE'),(3337,'STR_VOUCHER_DELETED_SUCCESSFULLY'),(3338,'STR_VOUCHER_DETAIL_ADDED_SUCCESSFULLY'),(3339,'STR_VOUCHER_DID_NOT_BALANCE'),(3340,'STR_VOUCHER_NOT_IN_BALANCE'),(3341,'STR_VOUCHER_NUMBER'),(3342,'STR_VOUCHER_UPDATED_SUCCESSFULLY'),(3343,'STR_VOUCHERS'),(3344,'STR_VOUCHERS_POSTED_OK'),(3345,'STR_VOUCHERS_REVERSED_OK'),(3346,'STR_W2'),(3347,'STR_W2_ADDRESS_1'),(3348,'STR_W2_ADDRESS_2'),(3349,'STR_W2_CITY_STATE_AND_ZIP'),(3350,'STR_W2_COMPANY_NAME'),(3351,'STR_W2_USE_WHAT_BOX_FOR_PLAN'),(3352,'STR_WAGES'),(3353,'STR_WAITING'),(3354,'STR_WEB_ADDRESS'),(3355,'STR_WEB_SITE'),(3356,'STR_WEBSHOP_REMOVED_FROM_TABLE_MODULES'),(3357,'STR_WEBSHOP_SETUP'),(3358,'STR_WEEK'),(3359,'STR_WEEKLY_AMT'),(3360,'STR_WEIGHT'),(3361,'STR_WEIGHT_PER_M_85_11_SHEETS'),(3362,'STR_WEIGHT_PER_PRICE_UNIT'),(3363,'STR_WELCOME'),(3364,'STR_WHATNOW'),(3365,'STR_WHEN_INACTIVE_REPLACE_WITH'),(3366,'STR_WHERE_ANSWER_IS_A_NUMBER_BETWEEN'),(3367,'STR_WHERE_ANSWER_IS_TEXT'),(3368,'STR_WHERE_ANSWER_IS_YES_OR_NO'),(3369,'STR_WHICH_GL_ACCT'),(3370,'STR_WHICH_TAXES_ARE_CALCULATED_ON_WAGES_REDUCED_BY_PENSION_AMOUNTS'),(3371,'STR_WHILE_ADDING_ORDER'),(3372,'STR_WHO_SHOULD_BE_GIVEN'),(3373,'STR_WIDTH'),(3374,'STR_WIDTH_LENGTH'),(3375,'STR_WIDTH_X_LENGTH'),(3376,'STR_WILL_ONLY_BE_USED'),(3377,'STR_WITH_HEADERS'),(3378,'STR_WITH_TURNAROUND_OF'),(3379,'STR_WITHIN_DISCOUNT_PERIOD'),(3380,'STR_WORK_DAYS'),(3381,'STR_WORK_TYPE'),(3382,'STR_WORK_TYPE_ADD'),(3383,'STR_WORK_TYPE_ADDED_SUCCESSFULLY'),(3384,'STR_WORK_TYPE_DELETED_SUCCESSFULLY'),(3385,'STR_WORK_TYPE_NOT_FOUND'),(3386,'STR_WORK_TYPE_QUESTION'),(3387,'STR_WORK_TYPE_QUESTION_ADDED_SUCCESSFULLY'),(3388,'STR_WORK_TYPE_QUESTION_DELETED_SUCCESSFULLY'),(3389,'STR_WORK_TYPE_QUESTION_UPDATED_SUCCESSFULLY'),(3390,'STR_WORK_TYPE_STANDARD_SIZE_LIST'),(3391,'STR_WORK_TYPE_UPDATE'),(3392,'STR_WORK_TYPE_UPDATED_SUCCESSFULLY'),(3393,'STR_WORK_TYPES'),(3394,'STR_WORKAREA'),(3395,'STR_WORKAREA_ADD'),(3396,'STR_WORKAREA_ALREADY'),(3397,'STR_WORKAREA_ASSIGN'),(3398,'STR_WORKAREA_UPDATE'),(3399,'STR_WORKAREAS'),(3400,'STR_WORKAREAS_VALUES'),(3401,'STR_WORKK_DAYS'),(3402,'STR_WORKMANS_COMP'),(3403,'STR_WORKMANS_COMP_EXPENSE'),(3404,'STR_WORKMANS_COMP_PAYABLE'),(3405,'STR_WORKMANS_COMP_RATE'),(3406,'STR_WORKSUBTYPES_VENDED_ALL'),(3407,'STR_WORKSUBTYPES_VENDED_NONE'),(3408,'STR_WORKSUBTYPES_VENDED_OPTIONAL'),(3409,'STR_WORKSUBTYPES_VENDED_PARTIAL'),(3410,'STR_WRITE'),(3411,'STR_WRITE_DEPOSIT_CHECK'),(3412,'STR_X'),(3413,'STR_X_ANSWER_TO_JOB'),(3414,'STR_Y'),(3415,'STR_YEAR'),(3416,'STR_YEAR_MONTH'),(3417,'STR_YEAR_MONTH_POST_INTO'),(3418,'STR_YEAR_QUARTER'),(3419,'STR_YEARLY_CEILING'),(3420,'STR_YEARS_BEFORE'),(3421,'STR_YES'),(3422,'STR_YES_NO'),(3423,'STR_YET_TO_APPLY'),(3424,'STR_YOU_DO_NOT'),(3425,'STR_YOU_MUST_ALLOW_MODIFY'),(3426,'STR_YOU_MUST_ALLOW_VIEW'),(3427,'STR_YOU_MUST_HAVE'),(3428,'STR_YOU_SHOULD_AUTOMATICALLY'),(3429,'STR_YOUR_SHIPMENT_IS_BEING_PROCESSED'),(3430,'STR_YOURE_TRYING_TO_SWAP'),(3431,'STR_ZERO'),(3432,'STR_ZIP'),(3433,'STR_INTERVAL_FOR_SEARCH'),(3434,'STR_START_DATE'),(3435,'STR_IN'),(3436,'STR_OUT'),(3437,'STR_WHO_CREATED'),(3438,'STR_PURCHASE'),(3439,'STR_SALES_USE'),(3440,'STR_ON_HAND_BEGIN'),(3441,'STR_ADJUSTED'),(3442,'STR_ON_HAND_END'),(3443,'STR_PROPERTIES'),(3444,'STR_RANGE'),(3445,'STR_PWO'),(3446,'STR_STOREROOM_FORMS'),(3447,'STR_DISPLAY_CHARACTERISTICS'),(3448,'STR_INVENTORY_ITEM_ACTIVITY_REPORT'),(3449,'STR_SD_ED_ERROR'),(3450,'STR_UNKNOWN'),(3451,'STR_FOR_PERIOD_FROM'),(3452,'STR_ADD_ATTACHMENT'),(3453,'STR_ADD_TO_LIST'),(3454,'STR_ARE_YOU_SURE_YOU_WANT_TO_GO_BACK'),(3455,'STR_ATTACHMENTS'),(3456,'STR_BCC'),(3457,'STR_CC'),(3458,'STR_CUSTOMERS'),(3459,'STR_CURRENT_SELECTIONS'),(3460,'STR_DEFAULT_DELIVERY'),(3461,'STR_EMAIL_CENTER'),(3462,'STR_EMAIL_CENTER_DESC'),(3463,'STR_EMAIL_ERROR'),(3464,'STR_EMAIL_PICKER'),(3465,'STR_EMAIL_SENT'),(3466,'STR_EMAIL_SEPARATE_WITH'),(3467,'STR_EMPLOYEES'),(3468,'STR_IF_PROMOTIONS_OK'),(3469,'STR_INCLUDE_INACTIVE'),(3470,'STR_ORDER_FROM'),(3471,'STR_PAY_TO'),(3472,'STR_PROMOTIONS_OK'),(3473,'STR_SALESMEN'),(3474,'STR_SEARCH_BY_EMAIL'),(3475,'STR_SEARCH_BY_SSN'),(3476,'STR_SEND_BACK_EMAILS'),(3477,'STR_SUBJECT'),(3478,'STR_USE'),(3479,'STR_USERS'),(3480,'STR_VENDORS'),(3481,'STR_GET_SHIPPING_QUOTE'),(3482,'STR_UPS_NAME'),(3483,'STR_UPS_GND'),(3484,'STR_UPS_1DM'),(3485,'STR_UPS_1DA'),(3486,'STR_UPS_1DP'),(3487,'STR_UPS_2DM'),(3488,'STR_UPS_3DS'),(3489,'STR_UPS_STD'),(3490,'STR_UPS_XPR'),(3491,'STR_UPS_XDM'),(3492,'STR_UPS_XPD'),(3493,'STR_UPS_RDP'),(3494,'STR_UPS_OCA'),(3495,'STR_UPS_OTP'),(3496,'STR_UPS_LC'),(3497,'STR_UPS_CC'),(3498,'STR_UPS_COMMERCIAL'),(3499,'STR_UPS_RESIDENTIAL'),(3500,'STR_PER_ITEM'),(3501,'STR_FLAT_RATE'),(3502,'STR_ORDER_DETAILS'),(3503,'STR_NUM_ITEMS'),(3504,'STR_NUM_BOXES'),(3505,'STR_FROM_ZIPCODE'),(3506,'STR_TO_ZIPCODE'),(3507,'STR_SHIPPING_QUOTE'),(3508,'STR_SEND_BACK_SHIPPING_QUOTE'),(3509,'STR_ADD_BOXES'),(3510,'STR_WEIGHT_PER_BOX'),(3511,'STR_SPLIT'),(3512,'STR_GET_QUOTE'),(3513,'STR_BELOW_ENTRIES'),(3514,'STR_ACCOUNT_FILE_COLUMN_FORMAT'),(3515,'STR_QUESTIONS'),(3516,'STR_INTERNALONLY'),(3517,'STR_ACCOUNT_IMPORT_WARNING_MESSAGE'),(3518,'STR_IMPORT_STANDARD_ACCOUNT_SET'),(3519,'STR_CHART_OF_ACCOUNTS'),(3520,'STR_'),(3521,'STR_LANGUAGE_EDITOR'),(3522,'STR_QTY_RECEIVED'),(3523,'STR_ACCOUNT_ACTIVITY'),(3524,'STR_ACCOUNT_TYPES'),(3525,'STR_ADD_LISTS_OF_EXTERNAL_CUSTOMER_USERS'),(3526,'STR_ADD_NEW_PAYROLL_TAX_DISTRICT'),(3527,'STR_ADD_NEW_TAXES'),(3528,'STR_ADD_OR_UPDATE_CUSTOMER_INFORMATION'),(3529,'STR_ADD_UPDATE_BUDGETS'),(3530,'STR_ADD_UPDATE_CUSTOMER'),(3531,'STR_ADD_UPDATE_EMPLOYEE'),(3532,'STR_ADD_UPDATE_EMPLOYEE_INFORMATION'),(3533,'STR_ADMIN'),(3534,'STR_ADMIN_DATABASE'),(3535,'STR_ADMINISTRATION_TOOLS_USER_RIGHTS'),(3536,'STR_AGING_DETAIL_REPORT'),(3537,'STR_AGING_DETAILS'),(3538,'STR_AGING_SUMMARY_REPORT'),(3539,'STR_AMOUNTS_PAID_BY_EMPLOYER'),(3540,'STR_ASSIGN_CATEGORIES'),(3541,'STR_BALANCE_SHEET'),(3542,'STR_BASIC_SETUP_FUNCTIONS_FOR_RECEIVABLES'),(3543,'STR_BENEFITS_PAY_FOR_GROUP'),(3544,'STR_BILLING'),(3545,'STR_BIRTHDAY_LIST'),(3546,'STR_BOM_LIST'),(3547,'STR_BUDGET_LIST'),(3548,'STR_BUDGET_VARIANCE'),(3549,'STR_CALCULATE_ALL_PAY_AND_TAXES_FOR_PERIOD'),(3550,'STR_CALCULATE_INTEREST'),(3551,'STR_CALCULATE_INTEREST_ON_OVERDUE_INVOICES'),(3552,'STR_CALCULATE_NEW_SCHEDULE'),(3553,'STR_CALCULATE_PAY_TAXES'),(3554,'STR_CALCULATE_SCHEDULE'),(3555,'STR_CATEGORY_LISTS'),(3556,'STR_CHANGE_THE_NAMES_USED_FOR_ACCOUNT_TYPES'),(3557,'STR_CHANGE_YOUR_COMPANY_FISCAL_YEAR_BEGIN'),(3558,'STR_CHART_OF_ACCOUNTS_LIST'),(3559,'STR_CHECK_IN_OUT_ORDERS'),(3560,'STR_CHECK_SUMMARY_MULTIPLE_PERIODS'),(3561,'STR_CHECK_SUMMARY_ONE_PERIOD'),(3562,'STR_CHECKING_ACCOUNTS'),(3563,'STR_CLOSED_PRINT_ORDERS'),(3564,'STR_COMPANY_DIVISIONS'),(3565,'STR_COMPANY_LOGO_NAME_ETC'),(3566,'STR_COMPANY_OPTIONS'),(3567,'STR_COMPLETED_PO_TO_AP'),(3568,'STR_CONFIRM_ORDERS_AS_OK'),(3569,'STR_CONFIRM_PRT'),(3570,'STR_CONFIRM_PRT_ORDERS'),(3571,'STR_CREATE_A_BALANCE_SHEET'),(3572,'STR_CREATE_A_NEW_INVOICE'),(3573,'STR_CREATE_A_NEW_PURCHASE_ORDER'),(3574,'STR_CREATE_GENERAL_LEDGER_JOURNAL_ENTRIES'),(3575,'STR_CREATE_INVOICES_FROM_SHIPPED_OR_COMPLETED_ORDERS'),(3576,'STR_CREATE_PRINT_PIE_CHARTS'),(3577,'STR_CUSTOMER_LOGIN_USERS'),(3578,'STR_DEDUCTION_FOR_GROUP'),(3579,'STR_DEDUCTION_GROUPS'),(3580,'STR_DETAIL_AGING'),(3581,'STR_DISCOUNT_AGING'),(3582,'STR_DOCUMENT_CATEGORIES'),(3583,'STR_EDIT_CHART_OF_ACCOUNTS'),(3584,'STR_EDIT_GENERAL_LEDGER_CHART_OF_ACCOUNTS_LIST'),(3585,'STR_EDIT_GENERAL_LEDGER_JOURNAL_ENTRIES'),(3586,'STR_EDIT_JOURNAL_ENTRIES'),(3587,'STR_EDIT_ORDERS'),(3588,'STR_EDIT_PRINT_ORDERS'),(3589,'STR_EMPLOYEE_ENTRY_UPDATE_WRITE_CHECKS_REPORTS'),(3590,'STR_EMPLOYEE_PAY_BY_MONTH'),(3591,'STR_EMPLOYEE_PAY_BY_QUARTER'),(3592,'STR_EMPLOYEE_PAY_BY_WEEK'),(3593,'STR_EMPLOYEE_PHONE_LIST'),(3594,'STR_ENTER_A_NEW_BILL_INTO_PAYABLES'),(3595,'STR_ENTER_EMAIL'),(3596,'STR_ENTER_GENERAL_MARKUPS'),(3597,'STR_ENTER_HOURS_WORKED_AND_MISC_PAY_DEDUCTIONS_FOR_EMPLOYEES'),(3598,'STR_ENTER_NEW_ORDERS'),(3599,'STR_ENTER_NEW_SHIPMENT'),(3600,'STR_ENTER_PAYMENTS'),(3601,'STR_ENTER_PAYMENTS_RECEIVED'),(3602,'STR_ENTER_SHIPMENTS_OF_ORDERS'),(3603,'STR_ENTER_UNITS_LOCATIONS_CATEGORIES_ETC'),(3604,'STR_ENTER_UPDATE_ACCESS_INFORMATION_FOR_VENDORS_ALLOWED_ACCESS_TO_VENDOR_SPECIFIC_INFORMATION'),(3605,'STR_ENTER_UPDATE_AN_EXISTING_PAYABLES_BILL'),(3606,'STR_ENTER_UPDATE_CARRIERS_AND_SHIPMENT_METHODS'),(3607,'STR_ENTER_UPDATE_CATEGORIES_OF_ITEMS'),(3608,'STR_ENTER_UPDATE_CHECKING_ACCOUNTS_USED_FOR_PAYABLES'),(3609,'STR_ENTER_UPDATE_CHECKING_ACCOUNTS_USED_FOR_PAYROLL'),(3610,'STR_ENTER_UPDATE_COMPANIES_COVERED_BY_SYSTEM'),(3611,'STR_ENTER_UPDATE_COMPONENT_LIST_FOR_BILL_OF_MATERIALS_INVENTORY_ITEMS'),(3612,'STR_ENTER_UPDATE_GENERAL_LEDGER_BUDGETS'),(3613,'STR_ENTER_UPDATE_GL_ACCOUNTS_USED_FOR_RECEIVABLES'),(3614,'STR_ENTER_UPDATE_PENSION_HEALTH_OTHER_PLAN'),(3615,'STR_ENTER_UPDATE_PRICING_LEVELS_FOR_INVENTORY_SALES'),(3616,'STR_ENTER_UPDATE_SALES_ACTIONS'),(3617,'STR_ENTER_UPDATE_SALES_CATEGORIES'),(3618,'STR_ENTER_UPDATE_SALES_PERSONNEL'),(3619,'STR_ENTER_UPDATE_STANDARD_GL_ACCOUNTS_USED_BY_PAYABLES'),(3620,'STR_ENTER_UPDATE_STANDARD_GL_ACCOUNTS_USED_BY_PAYROLL'),(3621,'STR_ENTER_UPDATE_STANDARD_PAYMENT_TERMS_FOR_INVOICES'),(3622,'STR_ENTER_UPDATE_STANDARD_TERMS_EXTENDED_BY_VENDORS_FOR_PAYMENT_OF_INVOICES'),(3623,'STR_ENTER_UPDATE_TAX_TABLE_INFORMATION'),(3624,'STR_ENTER_UPDATE_TAX_TABLES'),(3625,'STR_ENTER_UPDATE_TAXES_DEDUCTIONS_PENSION_PLANS_ETC'),(3626,'STR_ENTER_UPDATE_USER_LIST'),(3627,'STR_ENTER_UPDATE_VENDOR_DATA'),(3628,'STR_ENTER_UPDATE_VENDOR_TERMS_CHECKING_ACCOUNT_INFO_GL_ACCOUNTS_FOR_TIE_INS'),(3629,'STR_ENTER_WORK_AREA'),(3630,'STR_ENTRY_UPDATE_OF_SUPPLIER_INFORMATION_FOR_SPECIFIC_ITEMS'),(3631,'STR_EXPORT_GENERAL_LEDGER_ACCOUNTS_LIST'),(3632,'STR_GENERAL_BENEFITS_PAY'),(3633,'STR_GENERAL_DEDUCTIONS'),(3634,'STR_GENERAL_FACTORS'),(3635,'STR_GENERAL_INFO_LIST'),(3636,'STR_GENERAL_LEDGER_ACCOUNT_ACTIVITY_REPORT'),(3637,'STR_GENERAL_LEDGER_BUDGET_VARIANCE_REPORT'),(3638,'STR_GENERAL_LEDGER_JOURNAL_REPORTS'),(3639,'STR_GENERAL_LEDGER_POST_JOURNALS_FROM_ANY_SOURCE'),(3640,'STR_GENERAL_PAYROLL_INFORMATION'),(3641,'STR_GO_TO_SHOPPING_CART'),(3642,'STR_GROUP_WRITE_CHECKS_BY_DATE'),(3643,'STR_IMPORT_CUSTOMER_LIST_INTO_NOLAPRO'),(3644,'STR_IMPORT_CUSTOMERS'),(3645,'STR_IMPORT_GENERAL_LEDGER_ACCOUNTS_LIST'),(3646,'STR_INVENTORY_ADJUSTMENTS'),(3647,'STR_INVENTORY_ENTRY_UPDATE_REPORTS'),(3648,'STR_INVENTORY_ITEM_BILL_OF_MATERIALS_LIST'),(3649,'STR_INVENTORY_ITEM_DETAIL_HISTORY_REPORTS'),(3650,'STR_INVENTORY_ITEM_DISTRIBUTION_LIST'),(3651,'STR_INVENTORY_ITEM_ENTRY_UPDATE'),(3652,'STR_INVENTORY_ITEM_PRICE_ENTRY'),(3653,'STR_INVENTORY_ITEM_STATUS_REPORT'),(3654,'STR_INVENTORY_ITEM_SUMMARY_LISTS'),(3655,'STR_INVENTORY_ITEM_USAGE_REPORTS'),(3656,'STR_INVENTORY_UNITS'),(3657,'STR_INVENTORY_VALUATION'),(3658,'STR_INVENTORY_VALUATION_REPORT'),(3659,'STR_INVOICING_PAYMENTS_RECEIVED_SALES_TAX_REPORTS'),(3660,'STR_ITEM_ACTIVITY'),(3661,'STR_ITEM_CATEGORIES'),(3662,'STR_ITEM_DETAIL_HISTORY'),(3663,'STR_ITEM_DISTRIBUTION'),(3664,'STR_ITEM_MAINTENANCE'),(3665,'STR_ITEM_PRICES'),(3666,'STR_ITEM_SUMMARIES'),(3667,'STR_ITEM_SUPPLIERS'),(3668,'STR_ITEM_USAGE_HISTORY'),(3669,'STR_ITEMS_SHIPPED'),(3670,'STR_JOURNAL_ENTRY_BALANCE_SHEET'),(3671,'STR_JOURNAL_REPORTS'),(3672,'STR_LEDGER'),(3673,'STR_LIST_CLOSED_PRINT_ORDERS'),(3674,'STR_LIST_CUSTOMERS'),(3675,'STR_LIST_ITEM_CATEGORIES'),(3676,'STR_LIST_ITEMS_RECEIVED'),(3677,'STR_LIST_ITEMS_RECEIVED_INTO_INVENTORY'),(3678,'STR_LIST_OF_EMPLOYEE_BIRTHDAYS'),(3679,'STR_LIST_OF_EMPLOYEE_GENERAL_INFORMATION'),(3680,'STR_LIST_OF_EMPLOYEE_PAY_BY_MONTH'),(3681,'STR_LIST_OF_EMPLOYEE_PAY_BY_QUARTER'),(3682,'STR_LIST_OF_EMPLOYEE_PAY_BY_WEEK'),(3683,'STR_LIST_OF_EMPLOYEE_PHONE_NUMBERS'),(3684,'STR_LIST_OF_EMPLOYEES_WITH_NAME_AND_ADDRESS_AND_PHONE'),(3685,'STR_LIST_ONHOLD_PRINT_ORDERS'),(3686,'STR_LIST_OVERDUE_PRINT_ORDERS'),(3687,'STR_LIST_PENDING_PRINT_ORDERS'),(3688,'STR_LIST_PRINT_ORDERS'),(3689,'STR_LIST_QUOTES'),(3690,'STR_LIST_SHIPPED_PRINT_ORDERS'),(3691,'STR_LISTS'),(3692,'STR_LISTS_AND_EXPORTS_OF_CUSTOMER_DATA'),(3693,'STR_LISTS_OF_CHECKS'),(3694,'STR_LISTS_OF_CHECKS_WRITTEN'),(3695,'STR_LISTS_OF_ITEMS_SHIPPED'),(3696,'STR_LISTS_OF_OPEN_ITEMS_ON_ORDERS'),(3697,'STR_LISTS_OF_OPEN_PENDING_ORDERS'),(3698,'STR_LISTS_OF_PAYABLES'),(3699,'STR_LISTS_OF_PRICING_LEVELS_FOR_INVENTORY_SALES'),(3700,'STR_LISTS_OF_SHIPPED_ORDERS'),(3701,'STR_LISTS_OF_STANDARD_MARKUP_SETS'),(3702,'STR_MARKUPS_LIST'),(3703,'STR_MY_PIE_CHARTS'),(3704,'STR_NAME_ADDRESS_PHONE_LIST'),(3705,'STR_NEW_JOURNAL_ENTRIES'),(3706,'STR_NEW_ORDER'),(3707,'STR_NEW_PRINT_ORDER'),(3708,'STR_NEW_PURCHASE_ORDER'),(3709,'STR_NEW_VENDOR_BILL'),(3710,'STR_ON_TIME_STATISTICS'),(3711,'STR_ON_TIME_STATS'),(3712,'STR_ONHOLD_PRINT_ORDERS'),(3713,'STR_OPEN_ITEMS_ON_ORDERS'),(3714,'STR_ORDER_LISTS_OPEN_ORDERS_SHIPPED_ORDERS_BACKORDERS'),(3715,'STR_ORDER_PROCESSING_FILL_SHIP_TRACK'),(3716,'STR_ORDER_PROCESSING_STATUS'),(3717,'STR_ORDER_TRACKING_LISTS_FILLING_STATISTICS'),(3718,'STR_ORDERS_INVOICES'),(3719,'STR_ORDERS_SHIPPED'),(3720,'STR_OUT_TO_PROOF'),(3721,'STR_OUT_TO_PROOF_DETAILS'),(3722,'STR_OVERDUE_PRINT_ORDERS'),(3723,'STR_OVERRIDE_SCHEDULE'),(3724,'STR_OVERRIDE_SCHEDULE_ACTION'),(3725,'STR_PASS_COMPLETED_PURCHASE_ORDER_INFORMATION_INTO_PAYABLES_MATCH_TO_BILLS_RECEIVED'),(3726,'STR_PAY_TYPES'),(3727,'STR_PAYABLES_DETAIL_AGING_REPORT'),(3728,'STR_PAYABLES_DISCOUNT_AGING_REPORT'),(3729,'STR_PAYABLES_ENTRY_UPDATE_WRITE_CHECK_REQUESTS_REPORTS'),(3730,'STR_PAYABLES_LISTS'),(3731,'STR_PAYABLES_SUMMARY_AGING_REPORT'),(3732,'STR_PAYMENT_REPORTS'),(3733,'STR_PAYMENTS_RECEIVED_REPORTS_BANK_DEPOSIT_RECONCILIATION'),(3734,'STR_PAYROLL_CHECK_SUMMARY_FOR_MULTIPLE_PERIODS'),(3735,'STR_PAYROLL_CHECK_SUMMARY_FOR_ONE_PAY_PERIOD'),(3736,'STR_PAYROLL_DEDUCTION_GROUPS'),(3737,'STR_PAYROLL_PAY_TYPES'),(3738,'STR_PENDING_PRINT_ORDERS'),(3739,'STR_PENSION_PLANS'),(3740,'STR_PERFORMANCE_STATISTICS'),(3741,'STR_PHYSICAL_INVENTORY'),(3742,'STR_PHYSICAL_INVENTORY_ENTRY'),(3743,'STR_PLANT_LOCATIONS'),(3744,'STR_PLANT_LOCATIONS_WHERE_INVENTORY_IS_KEPT'),(3745,'STR_PO_LISTS'),(3746,'STR_POST_JOURNALS_NOW'),(3747,'STR_PRICING_LEVELS'),(3748,'STR_PRINT_941'),(3749,'STR_PRINT_941_INFORMATION'),(3750,'STR_PRINT_A_PROFIT_AND_LOSS_STATEMENT'),(3751,'STR_PRINT_DEFAULT_RESPONSES'),(3752,'STR_PRINT_FAMILY_CALCULATIONS'),(3753,'STR_PRINT_FORMULAS'),(3754,'STR_PRINT_GENERAL_LEDGER_BUDGET_LIST'),(3755,'STR_PRINT_GENERAL_LEDGER_CHART_OF_ACCOUNTS_LIST'),(3756,'STR_PRINT_LATE_DELIVERY_REASONS'),(3757,'STR_PRINT_LISTS_OF_PURCHASE_ORDERS'),(3758,'STR_PRINT_LISTS_OR_LABELS_OF_VENDORS'),(3759,'STR_PRINT_LOCATIONS'),(3760,'STR_PRINT_MACHINE_FAMILIES'),(3761,'STR_PRINT_MACHINES'),(3762,'STR_PRINT_ORDER'),(3763,'STR_PRINT_ORDER_DETAIL'),(3764,'STR_PRINT_ORDER_LISTS'),(3765,'STR_PRINT_ORDER_NEW'),(3766,'STR_PRINT_ORDER_PROCESSING'),(3767,'STR_PRINT_ORDER_SETUP'),(3768,'STR_PRINT_ORDER_SETUP_MENU'),(3769,'STR_PRINT_PROCESSING'),(3770,'STR_PRINT_QUOTE_LONG'),(3771,'STR_PRINT_SCHEDULE'),(3772,'STR_PRINT_SCHEDULE_REPORTS'),(3773,'STR_PRINT_STATEMENTS'),(3774,'STR_PRINT_STOCK_PURPOSE'),(3775,'STR_PRINT_W2_INFORMATION'),(3776,'STR_PRINT_WORKTYPES'),(3777,'STR_PROCESSING'),(3778,'STR_PROFIT_AND_LOSS_STATEMENT'),(3779,'STR_PROOF_HISTORY'),(3780,'STR_PROOF_LIST'),(3781,'STR_PROOF_PROCESS'),(3782,'STR_PROOF_PROCESS_DETAILS'),(3783,'STR_PURCHASE_ORDER_ENTRY_UPDATE_PRINT_POS_RECEIVE_GOODS_REPORTS'),(3784,'STR_PURCHASING'),(3785,'STR_PURGE_OLD_FILES'),(3786,'STR_PURGE_OUT_OF_DATE_ITEM_ATTACHMENT_FILES'),(3787,'STR_QUOTE_COMMENT_TABLE'),(3788,'STR_QUOTE_LISTS'),(3789,'STR_RATING_SCALE_FOR_REVIEWS'),(3790,'STR_RECEIVE_ITEMS_INTO_INVENTORY_FOR_WHICH_PURCHASE_ORDER_WAS_CREATED'),(3791,'STR_RECEIVE_ITEMS_INTO_INVENTORY_THAT_DID_NOT_HAVE_A_PURCHASE_ORDER_CREATED'),(3792,'STR_RECEIVE_ITEMS_ON_PO'),(3793,'STR_RECEIVE_WITHOUT_PO'),(3794,'STR_REDO'),(3795,'STR_REDO_REPORT'),(3796,'STR_REGULAR_DEDUCTIONS_TO_BE_TAKEN_FROM_EMPLOYEE_PAY'),(3797,'STR_REPORTS'),(3798,'STR_REPORTS_DETAIL'),(3799,'STR_REPRINT_PRINT_TICKET'),(3800,'STR_REPRINT_TICKET'),(3801,'STR_REVERSE_GENERAL_LEDGER_POST_ACTION'),(3802,'STR_REVERSE_JOURNAL_POSTINGS'),(3803,'STR_REVIEW_COSTS'),(3804,'STR_REVIEW_COSTS_LONG'),(3805,'STR_SALES_ACTIONS_MENU'),(3806,'STR_SALES_CATEGORIES_MENU'),(3807,'STR_SALES_PERSONNEL'),(3808,'STR_SALES_PROCESS_MENU'),(3809,'STR_SALES_TAX_EXEMPTION_REASONS'),(3810,'STR_SALES_TAX_RATES_AND_NAMES'),(3811,'STR_SALES_TAX_REPORT'),(3812,'STR_SALES_TAXES'),(3813,'STR_SCHEDULING'),(3814,'STR_SCHEDULING_REPORTS'),(3815,'STR_SET_FISCAL_YEAR'),(3816,'STR_SET_PREFERENCES'),(3817,'STR_SET_THE_FISCAL_YEAR'),(3818,'STR_SET_UP_RATING_SCALE'),(3819,'STR_SETUP_EMAIL'),(3820,'STR_SETUP_FUNCTIONS_FOR_GL'),(3821,'STR_SETUP_FUNCTIONS_FOR_INVENTORY'),(3822,'STR_SETUP_FUNCTIONS_FOR_PAYABLES'),(3823,'STR_SETUP_FUNCTIONS_FOR_PAYROLL'),(3824,'STR_SETUP_FUNCTIONS_FOR_RECEIVABLES'),(3825,'STR_SETUP_GENERAL'),(3826,'STR_SETUP_MACHINE_CALCULATIONS'),(3827,'STR_SETUP_MACHINE_FAMILIES'),(3828,'STR_SETUP_PRINT_DEFAULT_RESPONSES'),(3829,'STR_SETUP_PRINT_FORMULAS'),(3830,'STR_SETUP_PRINT_LATE_DELIVERY_REASONS'),(3831,'STR_SETUP_PRINT_LOCATIONS'),(3832,'STR_SETUP_PRINT_MACHINES'),(3833,'STR_SETUP_PRINT_STOCK_PURPOSE'),(3834,'STR_SETUP_PRINT_WORKTYPES'),(3835,'STR_SETUP_WORK_AREA'),(3836,'STR_SHIPPED_PRINT_ORDERS'),(3837,'STR_SHIPPING_CARRIER_METHODS'),(3838,'STR_SHOP_LOADING'),(3839,'STR_SHOP_LOADING_REPORTS'),(3840,'STR_SHOPPING_ADMINISTRATION'),(3841,'STR_SHOPPING_CART_AND_ADMINISTRATION_OF_CART_PREFERENCES'),(3842,'STR_STANDARD_COMMENTS_TO_USE_ON_QUOTES'),(3843,'STR_STANDARD_GL_ACCOUNT'),(3844,'STR_STANDARD_GL_ACCOUNTS'),(3845,'STR_STANDARD_MARKUP'),(3846,'STR_STANDARD_MARKUP_SETS_FOR_AUTO_MARKING_UP_INVENTORY'),(3847,'STR_STATEMENTS'),(3848,'STR_STATUS_OF_PENDING_ORDERS'),(3849,'STR_STOCK_NEEDS'),(3850,'STR_STOCK_NEEDS_REPORTS'),(3851,'STR_SUMMARY_AGING'),(3852,'STR_SUMMARY_LISTS_OF_INVOICES'),(3853,'STR_SUMMARY_OF_INVOICES'),(3854,'STR_TAX_EXEMPTION_REASONS'),(3855,'STR_TIME_AND_MATERIAL'),(3856,'STR_TIME_AND_MATERIAL_DETAILS'),(3857,'STR_TRACK_FULFILLMENT_PROCESSES'),(3858,'STR_UNIT_NAMES_FOR_ITEMS_SOLD'),(3859,'STR_UNITS_OF_MEASURE_FOR_STOCKING_AND_PURCHASING_INVENTORY'),(3860,'STR_UPDATE_ADD_PO'),(3861,'STR_UPDATE_AN_EXISTING_PURCHASE_ORDER'),(3862,'STR_UPDATE_AN_INVOICE'),(3863,'STR_UPDATE_INVOICE'),(3864,'STR_USERS_AND_RIGHTS'),(3865,'STR_VARIANCE_REPORT'),(3866,'STR_VENDOR_ENTRY_UPDATE_REPORTS'),(3867,'STR_VENDOR_LISTS_LABELS'),(3868,'STR_VENDOR_LOGIN_USERS'),(3869,'STR_VENDOR_MAINTENANCE'),(3870,'STR_VIEW_CANCEL_CHECKS'),(3871,'STR_VIEW_CANCEL_PAYABLES_CHECKS_WRITTEN'),(3872,'STR_VIEW_CHANGE_BILLS'),(3873,'STR_VIEW_CHANGE_ORDER'),(3874,'STR_VIEW_CHANGE_ORDERS'),(3875,'STR_VIEW_CUSTOMER_ACCOUNT'),(3876,'STR_VIEW_CUSTOMER_ACCOUNT_STATUS'),(3877,'STR_VIEW_OR_CHANGE_PAYROLL_TAX_DISTRICTS'),(3878,'STR_VIEW_ORDERS_SHIPPED'),(3879,'STR_VIEW_SHIPPED_ORDERS'),(3880,'STR_VIEW_UPDATE_TAX'),(3881,'STR_VOLUME_REPORT'),(3882,'STR_VOLUME_RPT'),(3883,'STR_WIP'),(3884,'STR_WIP_REPORTS'),(3885,'STR_WRITE_AN_EMPLOYEE_PERFORMANCE_REVIEW'),(3886,'STR_WRITE_CHECKS'),(3887,'STR_WRITE_CHECKS_BY_DATE'),(3888,'STR_WRITE_CHECKS_FOR_SPECIFIC_BILLS_OR_MAKE_PARTIAL_PAYMENTS'),(3889,'STR_WRITE_CHECKS_SPECIFIED'),(3890,'STR_WRITE_EMPLOYEE_REVIEW'),(3891,'STR_WRITE_PAYROLL_CHECKS'),(3892,'STR_EMPLOYEE_ACTIVITY'),(3893,'STR_EMPLOYEE_ACTIVITY_REPORTS'),(3894,'STR_TEXT_FOR_JON'),(3895,'STR_TEXT_FOR_DONOVON'),(3896,'STR_ERROR_DELETING_STANDARD_SIZE'),(3897,'STR_QUOTE_NOTES_ONE_COLOR'),(3898,'STR_QUOTE_NOTES_TWO_COLOR'),(3899,'STR_QUOTE_NOTES'),(3900,'STR_CLICK_TO_REFRESH'),(3901,'STR_FROM_PHYSICAL_INVENTORY'),(3902,'STR_DATABASE'),(3903,'STR_SERVER'),(3904,'STR_BILLED_PRINT_ORDERS'),(3905,'STR_EXTRAS'),(3906,'STR_PRESS_SIZE'),(3907,'STR_VIEW_STATUS'),(3908,'STR_ACCOUNT_OVERDUE'),(3909,'STR_WORK_AND_TURN'),(3910,'STR_WORK_AND_FLOP'),(3911,'STR_PRINT_HOW'),(3912,'STR_JOB_NUMBER'),(3913,'STR_SOLD_TO'),(3914,'STR_FORM'),(3915,'STR_ARTWORK'),(3916,'STR_CAMERA_READY'),(3917,'STR_INSTRUCTIONS'),(3918,'STR_TYPESETTER'),(3919,'STR_TIME_INVOLVED'),(3920,'STR_TOTAL_TIME_INVOLVED'),(3921,'STR_PRESS'),(3922,'STR_SHEETS'),(3923,'STR_SIDES'),(3924,'STR_PIECE_WORK'),(3925,'STR_PRESS_OPERATOR_INITIALS'),(3926,'STR_REMARKS'),(3927,'STR_PACKAGING_NOTE'),(3928,'STR_WORTH'),(3929,'STR_COMPOSITION'),(3930,'STR_CUSTOMER_NOTES'),(3931,'STR_PACKAGING'),(3932,'STR_BINDERY'),(3933,'STR_OVER_CREDITLIMIT'),(3934,'STR_COMPOSITION_PRICE_LIST_UPDATE'),(3935,'STR_ADD_NEW_COMPOSITION_TYPE'),(3936,'STR_COMPOSITION_NAME'),(3937,'STR_COMPOSITION_TYPE'),(3938,'STR_UPDATE_COMPOSITION_FUNCTIONS_FOR_THIS_TYPE'),(3939,'STR_COMPOSITION_FUNCTIONS_UPDATE'),(3940,'STR_COMPOSITION_FUNCTION'),(3941,'STR_COMPOSITION_FUNCTIONS_ADD'),(3942,'STR_ADD_UPDATE_CHARGES_FOR_THIS_COMPOSITION_FUNCTION'),(3943,'STR_ADD_UPDATE_SELECT_LIST_FOR_THIS_COMPOSITION_FUNCTION'),(3944,'STR_COMPOSITION_FUNCTIONS_PRICING_UPDATE'),(3945,'STR_COMPOSITION_FUNCTIONS_SELECTION_LIST_UPDATE'),(3946,'STR_PRICE_PER_HOUR'),(3947,'STR_COST_PER_HOUR'),(3948,'STR_TIME'),(3949,'STR_MATERIALS'),(3950,'STR_EXTENDED'),(3951,'STR_INCLUDED_IN_PRICES'),(3952,'STR_DUEDATE_HISTORY'),(3953,'STR_WHEN'),(3954,'STR_CUSTOMER_PO'),(3955,'STR_ASK_INSTRUCTIONS'),(3956,'STR_ADD_SHIPTO'),(3957,'STR_SPECIAL_ORDER'),(3958,'STR_DAYS_OVER'),(3959,'STR_PRINTING_CATEGORY_UPDATE'),(3960,'STR_PRINTING_CATEGORY_ADD'),(3961,'STR_SALES_CATEGORY'),(3962,'STR_ADD_NEW_PRINT_ORDER'),(3963,'STR_PRINT_BOX_LABEL'),(3964,'STR_PRINT_PACKING_SLIP'),(3965,'STR_UPDATE_INVENTORY_SIZES'),(3966,'STR_STOCK_SIZE_LIST'),(3967,'STR_ASSIGN_NEW_ACTION'),(3968,'STR_COMPLETED_ACTION'),(3969,'STR_CUSTOMERS_SALES'),(3970,'STR_CUSTOMERS_NO_SALES'),(3971,'STR_SAVE_AS_NEW_ENTRY'),(3972,'STR_SAVE_AS_CHANGES'),(3973,'STR_THIS_IS_A_TEST_CONSTANT'),(3974,'STR_THIS_IS_A_TEST_CONSTANT2'),(3975,'STR_THIS_IS_A_TEST_CONSTANT3'),(3976,'STR_THIS_IS_A_TEST_CONSTANT4'),(3977,'STR_NUMBER_OF_ORIGINALS'),(3978,'STR_ORIGINALS_SUBMITTED_HOW'),(3979,'STR_NUMBER_OUT_OF_STOCK'),(3980,'STR_NUMBER_OF_COLORS'),(3981,'STR_COLOR_LIST'),(3982,'STR_ADD_STOCK'),(3983,'STR_ORIGINALS_THIS_PART'),(3984,'STR_STANDARD_SIZES'),(3985,'STR_INKS_ADD_UPDATE'),(3986,'STR_INK_INFO'),(3987,'STR_BINDERY_PRICES'),(3988,'STR_PRINT_ORDER_PRICELIST'),(3989,'STR_COMPOSITION_PRICES'),(3990,'STR_NEW_QUOTE'),(3991,'STR_ADD_EMAIL'),(3992,'STR_NO_RIGHTS'),(3993,'STR_CANNOT_FIND_STOCK'),(3994,'STR_ERROR_ADDING'),(3995,'STR_ERROR_UPDATING'),(3996,'STR_DELETE_THIS_WORKTYPE'),(3997,'STR_3'),(3998,'STR_ADD_NEW_WORKAREA'),(3999,'STR_CHECK_NUMBER_ALREADY_ISSUED'),(4000,'STR_BILL_UPDATE_FAILED'),(4001,'STR_ADD_UPDATE_SHIPTO_ADDRESSES'),(4002,'STR_12'),(4003,'STR_6'),(4004,'STR_9'),(4005,'STR_CONTINUED'),(4006,'STR_NO_SHIPMENTS_FOUND'),(4007,'STR_SHIPMENT_LIST'),(4008,'STR_ORDER_UPDATE_FAILED'),(4009,'STR_PRINT_TICKET'),(4010,'STR_DELETE_THIS_NON'),(4011,'STR_SAVE_CHANGES_SAVE_ADDL'),(4012,'STR_ADD_NEW_NON'),(4013,'STR_UPDATE_NON'),(4014,'STR_ERROR_CREATING_INVOICE'),(4015,'STR_TOOLS'),(4016,'STR_ADD_CUSTOMER'),(4017,'STR_LOOKUP'),(4018,'STR_INVENTORY_CATEGORY'),(4019,'STR_ADD_NEW_SLICE'),(4020,'STR_NEW_PIE'),(4021,'STR_BALANCE_FORWARD'),(4022,'STR_INVENTORY_MOVE'),(4023,'STR_PAD_LEFT'),(4024,'STR_TEST_STRING'),(4025,'STR_ERROR_READING_LANGUAGE'),(4026,'STR_LIST_BILLED_PRINT_ORDERS'),(4027,'STR_INCHES_HEIGHT_PER_1'),(4028,'STR_ERROR_UPDATING_SUMMARY_ACCOUNT_ID'),(4029,'STR_FIRST_PERIOD'),(4030,'STR_SECOND_PERIOD'),(4031,'STR_PLACE_ON_HOLD'),(4032,'STR_REMOVE_ON_HOLD'),(4033,'STR_PRINT_SALES_CATEGORIES'),(4034,'STR_QUOTE_NOTES_MENU'),(4035,'STR_0_NOT_SUMMARIZED'),(4036,'STR_120_PLUS_DAYS'),(4037,'STR_30_DAYS'),(4038,'STR_30_DAY_TRIAL'),(4039,'STR_60_DAYS'),(4040,'STR_90_DAYS'),(4041,'STR_INCHES_HEIGHT_PER_1000_SHEETS'),(4042,'STR_RECENTLY_SHIPPED_ITEMS'),(4043,'STR_GOOD_AFTERNOON'),(4044,'STR_GOOD_EVENING'),(4045,'STR_GOOD_MORNING'),(4046,'STR_CUSTOMIZE'),(4047,'STR_VIEW_SHIPPED_ITEMS_REPORT'),(4048,'STR_NOLAPRO'),(4049,'STR_VIEW_SHIPPED_ORDERS_REPORT'),(4050,'STR_VIEW_OPEN_ORDERS_REPORT'),(4051,'STR_VIEW_PERFORMANCE_STATS_REPORT'),(4052,'STR_OPEN_ORDERS_NEARING_DUE_DATE'),(4053,'STR_OPEN_ORDERS_OVER_DUE_DATE'),(4054,'STR_RECENTLY_SHIPPED_ORDERS'),(4055,'STR_PERFORMANCE_STATS_FOR_PAST_30_DAYS'),(4056,'STR_OPEN_ORDERS_DUE_DATES'),(4057,'STR_PERFORMANCE_STATISTICS_15_DAYS'),(4058,'STR_PERFORMANCE_STATISTICS_30_DAYS'),(4059,'STR_PERFORMANCE_STATISTICS_60_DAYS'),(4060,'STR_PERFORMANCE_STATISTICS_90_DAYS'),(4061,'STR_PERFORMANCE_STATS_FOR_PAST_15_DAYS'),(4062,'STR_PERFORMANCE_STATS_FOR_PAST_60_DAYS'),(4063,'STR_PERFORMANCE_STATS_FOR_PAST_90_DAYS'),(4064,'STR_UPCOMING_STOCK_NEEDS'),(4065,'STR_DESC'),(4066,'STR_OPEN_PRINT_ORDERS_NEARING_DUE_DATE'),(4067,'STR_OPEN_PRINT_ORDERS_OVER_DUE_DATE'),(4068,'STR_VIEW_OVERDUE_ORDERS_REPORT'),(4069,'STR_NO_QUOTES_FOUND'),(4070,'STR_ORDER_DATE'),(4071,'STR_RECENT_QUOTES'),(4072,'STR_VIEW_QUOTES_REPORT'),(4073,'STR_PRINT_ORDERS_DUE_DATES'),(4074,'STR_NO_STOCK_NEEDS_FOUND'),(4075,'STR_ONHAND'),(4076,'STR_VIEW_STOCK_NEEDS_REPORT'),(4077,'STR_PENDING_SALES_OVERVIEW'),(4078,'STR_RECENT_SALES_ACTIONS'),(4079,'STR_INVOICES_NEARING_DUE_DATE'),(4080,'STR_INVOICES_OVER_DUE_DATE'),(4081,'STR_NO_INVOICES_FOUND'),(4082,'STR_VIEW_SUMMARY_OF_INVOICES_REPORT'),(4083,'STR_ESTIMATE'),(4084,'STR_LEAD'),(4085,'STR_NO_PENDING_SALES_FOUND'),(4086,'STR_VIEW_SALES_OVERVIEW_REPORT'),(4087,'STR_NO_PAYMENTS_FOUND'),(4088,'STR_RECENT_PAYMENTS'),(4089,'STR_VIEW_PAYMENT_HISTORY_REPORT'),(4090,'STR_NO_SALES_ACTIONS_FOUND'),(4091,'STR_VIEW_SALES_ACTION_REPORT'),(4092,'STR_INVOICES_DUE_DATES'),(4093,'STR_NEW_PRINT_ORDER_SHORT'),(4094,'STR_PRINT_ORDER_NEW_SHORT'),(4095,'STR_PRINTING'),(4096,'STR_SAVE_FOR_LATER_REVIEW'),(4097,'STR_DETAIL_BY_COSTCENTER'),(4098,'STR_DETAIL_BY_ORDER'),(4099,'STR_SELECT_REPORT_TYPE'),(4100,'STR_SUMMARY_BY_COSTCENTER'),(4101,'STR_SUMMARY_BY_ORDER'),(4102,'STR_NUMBER_PER_UNIT'),(4103,'STR_LEAD_TRACKING'),(4104,'STR_SETUP_FUNCTIONS_FOR_LEAD_TRACKING'),(4105,'STR_BUDGETS'),(4106,'STR_GRAND_TOTAL'),(4107,'STR_NON_INVENTORY'),(4108,'STR_MAX_CHARS'),(4109,'STR_WEBSITE'),(4110,'STR_CUSTOMER_LISTS'),(4111,'STR_HOUSE'),(4112,'STR_PICK_VENDOR_AS_CARRIER'),(4113,'STR_TAKEN'),(4114,'STR_PIECES'),(4115,'STR_ACTION_HISTORY'),(4116,'STR_NO_MATCHES_TO_THOSE_SEARCH_OPTIONS'),(4117,'STR_SELECT_ANOTHER_CATEGORY'),(4118,'STR_PRIOR_INTEREST'),(4119,'STR_CLICK_ON_INVOICE_TO_EDIT'),(4120,'STR_UNBILLED_COMPLETED_INVENTORY_ORDERS'),(4121,'STR_UNBILLED_INVENTORY_ORDERS'),(4122,'STR_IMPRESSIONS_PLUS_SCRAP'),(4123,'STR_PIECEWORK_BASE'),(4124,'STR_PIECEWORK_NAME'),(4125,'STR_SHEETS_PLUS_SCRAP'),(4126,'STR_VIA'),(4127,'STR_ALL_ACTIVITY'),(4128,'STR_INFORMATION_FOR'),(4129,'STR_ACTION_DATE'),(4130,'STR_ITEMCODE'),(4131,'STR_ENTER'),(4132,'STR_ENTER_UPDATE_BILL_OF_MATERIALS_INVENTORY_ITEMS'),(4133,'STR_LIST_BUILD_ORDERS'),(4134,'STR_LIST_FOR_BILL_OF_MATERIALS_INVENTORY_ITEMS'),(4135,'STR_ENTER_UPDATE_BUILD_ORDERS'),(4136,'STR_PRIVATE'),(4137,'STR_RECIPIENTS_DO_NOT_SEE'),(4138,'STR_INVOICE_DATES'),(4139,'STR_PAYROLL_CHECK_NOTE'),(4140,'STR_DELETE_PRODUCT_GRAPHIC'),(4141,'STR_DELETE_PRODUCT_SHEET'),(4142,'STR_AND_UP'),(4143,'STR_BASE_COST_PER'),(4144,'STR_COST_PER'),(4145,'STR_ITEMS_RECEIVED_OK'),(4146,'STR_UP_TO_THIS_QUANTITY_OF'),(4147,'STR_VENDOR_NOT_CURRENTLY_SETUP_AS_SUPPLIER_FOR_THIS_ITEM'),(4148,'STR_THIS_MAY_TAKE_A_FEW_MINUTES'),(4149,'STR_NO_PAYMENT_RECORDS_FOUND'),(4150,'STR_SINCE_LAST_LOGOUT'),(4151,'STR_NEW_CUSTOMERS'),(4152,'STR_NEW_ORDERS'),(4153,'STR_SHIPPED_ORDERS'),(4154,'STR_RECENTLY_RECEIVED_ORDERS'),(4155,'STR_OPEN_ORDERS_ALL'),(4156,'STR_7_DAYS'),(4157,'STR_RECEIVE_DATE'),(4158,'STR_ALL_OPEN_ORDERS'),(4159,'STR_RECENTLY_ADDED_CUSTOMERS'),(4160,'STR_ADD_DATE'),(4161,'STR_VIEW_CUSTOMER_LIST'),(4162,'STR_COMPLETED_ORDERS'),(4163,'STR_DOLLARS_COMPLETED'),(4164,'STR_FULFILLMENT_ORDER_VOLUME_REPORT'),(4165,'STR_INVOICED_ORDERS'),(4166,'STR_NUMBER_ORDERS'),(4167,'STR_FULFILLMENT_ORDER_VOLUME_DETAIL'),(4168,'STR_FULFILLMENT_ORDER_VOLUME_DETAILS'),(4169,'STR_INVOICED'),(4170,'STR_BINDERY_QUANTITY'),(4171,'STR_BINDERY_QUANTITY_EXPLANATION'),(4172,'STR_IMPRESSIONS_EXPLANATION'),(4173,'STR_ORDER_QUANTITY'),(4174,'STR_PRESS_QUANTITY'),(4175,'STR_PRESS_QUANTITY_EXPLANATION'),(4176,'STR_SPLIT_SHIP'),(4177,'STR_7_DAY'),(4178,'STR_VIEW_VOLUME_REPORT'),(4179,'STR_ORDER_VOLUME_12_MONTH'),(4180,'STR_ORDER_VOLUME_7_DAY'),(4181,'STR_ORDER_VOLUME_8_WEEK'),(4182,'STR_TOP_TEN_CUSTOMERS'),(4183,'STR_VIEW_INVOICE_SUMMARY_REPORT'),(4184,'STR_TOP_10_CUSTOMERS_30_DAYS'),(4185,'STR_TOP_10_CUSTOMERS_YEAR'),(4186,'STR_DOLLAR_SALES'),(4187,'STR_QUANTITY_SOLD'),(4188,'STR_TOP_10_ITEMS_MONTH'),(4189,'STR_VIEW_ITEM_ACTIVITY_REPORT'),(4190,'STR_TOP_10_ITEMS_30_DAYS'),(4191,'STR_TOP_10_ITEMS_YEAR'),(4192,'STR_COST_TOTAL'),(4193,'STR_PERCENT_PROFIT'),(4194,'STR_PRICE_TOTAL'),(4195,'STR_TOP_10_PROFIT_ITEMS_MONTH'),(4196,'STR_TOP_10_PROFIT_ITEMS_YEAR'),(4197,'STR_TOP_10_PROFIT_ITEM_30DAYS'),(4198,'STR_TOP_10_PROFIT_ITEM_YEAR'),(4199,'STR_BINDERY_NOTE'),(4200,'STR_TOP_10_PROFIT_CUSTOMERS_MONTH'),(4201,'STR_TOP_10_PROFIT_CUSTOMERS_YEAR'),(4202,'STR_FAMILY_NAME'),(4203,'STR_IPH'),(4204,'STR_MACHINE_FAMILIES'),(4205,'STR_MAXIMUM_COLORS'),(4206,'STR_MAX_AND_MINIMUM_VALUES_FOR_PRINT_OPERATIONS'),(4207,'STR_MINIMUM_COLORS'),(4208,'STR_MINUMUM_SHEET_SIZE'),(4209,'STR_NOTE_USE_ONLY_THIS_LINE_IF_NOT_PRINTING_OPERATION'),(4210,'STR_ONE_SIDED'),(4211,'STR_OVER'),(4212,'STR_PRICE_BREAKS_FOR_THIS_FAMILY'),(4213,'STR_QTY_THEN_PRICE_IS'),(4214,'STR_SELECT_FAMILY'),(4215,'STR_SELLING_PRICE_PER_SHEET_PRODUCTION_IF_APPLICABLE'),(4216,'STR_TWO_SIDED'),(4217,'STR_TWO_SIDED_IF_APPLY'),(4218,'STR_ADD_MACHINE_FAMILY'),(4219,'STR_BELOW_ONLY_NEEDED_FOR_PRINT_OR_DIGITAL_WORKAREAS'),(4220,'STR_GREATER_OR_LESS_THAN'),(4221,'STR_GREATER_THAN'),(4222,'STR_LESS_THAN'),(4223,'STR_MAX_IMPRESSIONS_PER_DAY'),(4224,'STR_MULTIPLY_NORMAL_IPH_BY'),(4225,'STR_MULTIPLY_NORMAL_PRICE_BY'),(4226,'STR_NEW_IPH'),(4227,'STR_NEW_PRICE_BREAK'),(4228,'STR_UPDATE_MACHINE_FAMILY'),(4229,'STR_WEIGHT_OR_WIDTH'),(4230,'STR_WHEN_SIZE_SLASH_MWT'),(4231,'STR_INTERNAL_ONLY'),(4232,'STR_RESPONSE_TYPE'),(4233,'STR_SELECTION_LIST'),(4234,'STR_ADD_NEW_CALCULATION'),(4235,'STR_CALCULATIONS'),(4236,'STR_CALCULATION_QUANTITY'),(4237,'STR_EDITING_CALCULATIONS'),(4238,'STR_ERROR_INVALID_COMMAND'),(4239,'STR_FAMILY'),(4240,'STR_FAMILY_NOT_FOUND'),(4241,'STR_FAMILY_QUESTION_CALCULATIONS'),(4242,'STR_MARKUP_MULTIPLIER'),(4243,'STR_MATERIALS_COST'),(4244,'STR_NOTHING_ADDED'),(4245,'STR_NOTHING_UPDATED'),(4246,'STR_NO_QUESTIONS_EDIT_MACHINE_FAMILIES_TO_ADD_THEM'),(4247,'STR_ONCE_PER_JOB'),(4248,'STR_ON_MATERIALS_ONLY'),(4249,'STR_UPDATE_QUESTION_CALCULATIONS'),(4250,'STR_MARKUP_PRICE'),(4251,'STR_ADD_MACHINE_DETAILS'),(4252,'STR_DEFAULT_MACHINE_THIS_FAMILY'),(4253,'STR_LABOR_COST_PER_HOUR'),(4254,'STR_MACHINES'),(4255,'STR_MACHINE_ADDED'),(4256,'STR_MACHINE_COST_PER_HOUR'),(4257,'STR_MACHINE_LACKS_ID_MACHINE'),(4258,'STR_MACHINE_NAME'),(4259,'STR_MACHINE_UPDATED'),(4260,'STR_MUST_BE_AN_INTEGER'),(4261,'STR_MUST_BE_A_POSITIVE_NUMBER_OR_ZERO'),(4262,'STR_MUST_BE_NUMERIC'),(4263,'STR_OPERATOR_TIME'),(4264,'STR_OPERATOR_TIME_TO_MACHINE_TIME'),(4265,'STR_REQUIRED'),(4266,'STR_SELECT_MACHINE'),(4267,'STR_SERIAL_NUMBER'),(4268,'STR_SHOULD_BE_1_TO_100'),(4269,'STR_SHOULD_BE_ZERO_OR_GREATER'),(4270,'STR_UPDATE_MACHINE_DETAILS'),(4271,'STR_UPDATE_MACHINE_INFORMATION'),(4272,'STR_ADD_A_NEW_SUBTYPE'),(4273,'STR_ADD_A_NEW_WORK_TYPE'),(4274,'STR_ADD_WORKTYPE'),(4275,'STR_ADD_WORK_TYPE_DETAILS'),(4276,'STR_CAN_BE_SUBCONTRACTED'),(4277,'STR_CATEGORIES_OF_PAPER_INVENTORY_MATERIALS_THIS_SUBTYPE_CAN_USE'),(4278,'STR_DEL'),(4279,'STR_DESCRIPTION_IS_MISSING_IN_SUBTYPE'),(4280,'STR_EDITING'),(4281,'STR_FAMILY_FUNCTIONS_THIS_SUBTYPE_CAN_USE'),(4282,'STR_ITEM_WAS_NOT_FOUND_WITH_PART_NUMBER'),(4283,'STR_NAME_IS_MISSING_IN_SUBTYPE'),(4284,'STR_NAME_NOT_GIVEN'),(4285,'STR_PART_NO'),(4286,'STR_QUANTITY_IS_MISSING_IN_SUBTYPE'),(4287,'STR_SELECT_A_WORKTYPE'),(4288,'STR_SPECIFIC_INVENTORY_MATERIALS_THIS_SUBTYPE_CAN_USE'),(4289,'STR_SUBTYPE'),(4290,'STR_SUBTYPE_NAME'),(4291,'STR_SUB_TYPE'),(4292,'STR_UPDATE_WORKTYPE'),(4293,'STR_UPDATE_WORK_TYPE_DETAILS'),(4294,'STR_UPDATE_WORK_TYPE_INFORMATION'),(4295,'STR_UP_TO_QUANTITY'),(4296,'STR_USUAL_DAYS_TO_COMPLETE'),(4297,'STR_USUAL_NUMBER_OF_JOB_PARTS'),(4298,'STR_WORKTYPE'),(4299,'STR_WORKTYPE_LACKS_ID_WORKTYPE'),(4300,'STR_DEFAULT_RESPONSE'),(4301,'STR_DEFAULT_RESPONSES_FOR_WORKTYPES'),(4302,'STR_NO_SELECTIONS_FOUND'),(4303,'STR_SELECT_WORK_SUBTYPE'),(4304,'STR_CALCULATION_TYPE'),(4305,'STR_DIVIDE_BY_IPH'),(4306,'STR_FORMULA'),(4307,'STR_FORMULA_ADDED'),(4308,'STR_FORMULA_DELETED'),(4309,'STR_FORMULA_MANAGEMENT_FOR_CALCULATIONS'),(4310,'STR_FORMULA_UPDATED'),(4311,'STR_FOR_CALCULATIONS_OF_ONCE_PER_JOB_SELECT_ONLY_Q11_OR_Q10_IN_THE_FORMULA'),(4312,'STR_JOB_QUANTITY'),(4313,'STR_NO_FORMULAS_DEFINED'),(4314,'STR_NUMBER_OF_SIDES'),(4315,'STR_NUMBER_UP_ON_SHEET'),(4316,'STR_NUMERIC_ANSWER'),(4317,'STR_OTHER_TIME'),(4318,'STR_PAPER_LENGTH'),(4319,'STR_PAPER_WIDTH'),(4320,'STR_QUANTITY_EACH_PART_STOCK'),(4321,'STR_RESULT_IS_HOURS'),(4322,'STR_RUN_TIME'),(4323,'STR_SELECT_A_FORMULA_TO_UPDATE'),(4324,'STR_SHORTHAND_FOR_USE_IN_FORMULA'),(4325,'STR_TEST_THIS'),(4326,'STR_UNABLE_TO_FIND'),(4327,'STR_CALCULATION'),(4328,'STR_INVALID_CALCULATION'),(4329,'STR_RESULT'),(4330,'STR_SHORTHAND'),(4331,'STR_SPECIFY_THE_CALCULATION_HERE'),(4332,'STR_TEST_CALCULATION'),(4333,'STR_UNABLE_TO_FIND_FORMULA'),(4334,'STR_VALUE_FOR_TEST_COMPUTATION'),(4335,'STR_ALSO_OFFER'),(4336,'STR_LEAD_TIME'),(4337,'STR_POINT_FIVE'),(4338,'STR_POINT_FOUR'),(4339,'STR_POINT_ONE'),(4340,'STR_POINT_SIX'),(4341,'STR_POINT_THREE'),(4342,'STR_POINT_TWO'),(4343,'STR_SETUP_FOR_EMAIL_AND_PDF_QUOTES'),(4344,'STR_GENERAL_MARKUP_INFORMATION'),(4345,'STR_WORK_AREA_PURPOSE_ASSIGNMENT'),(4346,'STR_ERROR_DURING_UPDATE'),(4347,'STR_ERROR_ADDING_LATE_REASON'),(4348,'STR_LATE_REASON_ADD'),(4349,'STR_STOCK_PURPOSE_ADD'),(4350,'STR_AMOUNTS'),(4351,'STR_NO_ORDERS_MATCH_CRITERIA'),(4352,'STR_PERCENT_OF_IMPRESSIONS'),(4353,'STR_PERCENT_OF_ORDERS'),(4354,'STR_PRICE_DATE'),(4355,'STR_PRINTSHOP_ONTIME_STATISTICS'),(4356,'STR_PRINTSHOP_STATISTICS_FOR_DATES'),(4357,'STR_SELECT_ORDER_STATUS'),(4358,'STR_STARTING_DATE'),(4359,'STR_STARTING_DATE_IS_GREATER_THAN_ENDING_DATE_ASSUMING_LAST_MONTH_FOR_DATE_RANGE'),(4360,'STR_ACCEPTED_OK'),(4361,'STR_ANY_OR_ALL'),(4362,'STR_CHOOSE_ORDER_PROOF_STATUS'),(4363,'STR_DATE_DUE'),(4364,'STR_DATE_SENT'),(4365,'STR_FOR_ALL_ITEMS'),(4366,'STR_FOR_ITEMS_ACCEPTED_AND_COMPLETED'),(4367,'STR_FOR_ITEMS_RECEIVED_NEEDING_REVISION'),(4368,'STR_FOR_ITEMS_SENT_AND_STILL_PENDING'),(4369,'STR_NEEDS_REVISION'),(4370,'STR_PROOF_HISTORY_LIST'),(4371,'STR_PROOF_HISTORY_REPORT'),(4372,'STR_RESPONSE_DATE'),(4373,'STR_SENT_OR_PENDING'),(4374,'STR_SENT_PENDING'),(4375,'STR_ACT'),(4376,'STR_DATES'),(4377,'STR_EST'),(4378,'STR_SELECT_A_FINISHED_DATE_RANGE'),(4379,'STR_VARIANCES'),(4380,'STR_INVENTORY_REORDER_LIST'),(4381,'STR_ITEM_REORDER_LIST'),(4382,'STR_QUANTITY_BELOW_REORDER'),(4383,'STR_QUANTITY_COMMITTED'),(4384,'STR_QUANTITY_IN_STOCK'),(4385,'STR_QUANTITY_ON_ORDER'),(4386,'STR_REORDER_LEVEL'),(4387,'STR_TOTAL_ITEMS'),(4388,'STR_DAILY_PRINT_ORDER_VOLUME_REPORT'),(4389,'STR_NO_ACTIVITY_FOR'),(4390,'STR_NO_ACTIVITY_FOR_CURRENT_MONTH'),(4391,'STR_NUMBER_OF_ORDERS'),(4392,'STR_OK_TO_BILL'),(4393,'STR_PRINT_ORDER_DAILY_VOLUME_REPORT'),(4394,'STR_SELECT_A_MONTH_AND_YEAR'),(4395,'STR_AA_DOLLARS'),(4396,'STR_AA_QTY'),(4397,'STR_EXPLANATION'),(4398,'STR_INTERNAL_DOLLARS'),(4399,'STR_INTERNAL_QTY'),(4400,'STR_MATERIAL_REDO'),(4401,'STR_MATERIAL_REDO_STATISTICS'),(4402,'STR_PRODUCTION_QUANTITY_REDO'),(4403,'STR_PRODUCTION_REDO_STATISTICS'),(4404,'STR_REDO_STATS'),(4405,'STR_REDO_STATS_FOR_PERIOD'),(4406,'STR_TIME_REDO'),(4407,'STR_TIME_REDO_STATISTICS'),(4408,'STR_AA'),(4409,'STR_ALTERATION'),(4410,'STR_AMOUNT_TO_BILL'),(4411,'STR_CHANGES_NOT_SAVED_ORDER_ALREADY_CLOSED'),(4412,'STR_DETAIL_LIST_OF_ACTUAL_TIME_AND_MATERIALS_FOR_ORDER'),(4413,'STR_EXTENDED_COST'),(4414,'STR_INTERNAL'),(4415,'STR_UNIT_COST'),(4416,'STR_DATE_IN'),(4417,'STR_STOCK_NEEDS_REPORT'),(4418,'STR_WORK_IN_PROCESS'),(4419,'STR_ACTUAL_PRICE'),(4420,'STR_AMOUNT_BILLED'),(4421,'STR_ARE_YOU_SURE_YOU_WANT_TO_BILL_THIS_ORDER_FOR'),(4422,'STR_AUTHOR_ALTERATIONS'),(4423,'STR_BILLED_ON'),(4424,'STR_BILLING_BY'),(4425,'STR_CANCEL_ENTRY'),(4426,'STR_CLICK_HERE_TO_CHANGE_DUE_DATE'),(4427,'STR_CLICK_HERE_TO_CHANGE_THE_FINAL_SHIP_DATE_FOR_THIS_ORDER'),(4428,'STR_CLICK_HERE_TO_HIDE_WORK_NOT_CURRENTLY_ON_THIS_ORDER_FOR'),(4429,'STR_CLICK_HERE_TO_SHOW_WORK_NOT_CURRENTLY_ON_THIS_ORDER_FOR'),(4430,'STR_COMPLETED_EMPLOYEE_NUMBER'),(4431,'STR_DATE_CHANGE_MUST_BE_WITHIN_5_DAYS_OF_THE_ORIGINAL_DATE_PLEASE'),(4432,'STR_DATE_TIME_COMPLETED'),(4433,'STR_DESCRIPTION_OF_WORK'),(4434,'STR_DOLLARS_PER_UNIT'),(4435,'STR_EDIT_DATE'),(4436,'STR_EMP_NUMBER'),(4437,'STR_EQUAL_ESTIMATED'),(4438,'STR_ESTIMATED_COST'),(4439,'STR_ESTIMATED_PRICE'),(4440,'STR_FILL'),(4441,'STR_FINAL_SHIP_DATE'),(4442,'STR_HRLY_RATE'),(4443,'STR_IMPRESSIONS_CALCULATOR'),(4444,'STR_MAKE_ACTUALS'),(4445,'STR_NOT_STOCK_VENDED_OR_CLOSED'),(4446,'STR_OK_BY'),(4447,'STR_PLEASE_SAVE_OR_CANCEL_YOUR_CHANGES'),(4448,'STR_PRINT_ORDER_LOOKUP'),(4449,'STR_PROOF_STATUS'),(4450,'STR_RETURNED_OK'),(4451,'STR_RETURNED_REVISE'),(4452,'STR_SAVE_WITH_NO_TOTAL_PRICE'),(4453,'STR_SELECT_DIFFERENT_ORDER'),(4454,'STR_SELECT_ORDER_FOR_TIME_AND_MATERIALS_ENTRY'),(4455,'STR_SHIP_TO_NAME'),(4456,'STR_SPECIFY_LATE_DELIVERY_REASON'),(4457,'STR_START'),(4458,'STR_STOCK_SELECTED'),(4459,'STR_STOP'),(4460,'STR_TO_BILL'),(4461,'STR_UPDATES_CANCELLED_ERROR_IN_STEP'),(4462,'STR_YOUR_ORDER_HAS_BEEN_SHIPPED'),(4463,'STR_YOU_HAVE_NOT_ENTERED_A_QUANTITY'),(4464,'STR_BY_CHECKING_THIS_BOX_I_CERTIFY_THAT_THE_CUSTOMER_HAS_BEEN_CONTACTED_ABOUT_THIS_CHANGE'),(4465,'STR_CHANGE_DATE'),(4466,'STR_ENTER_NEW_DATE_IN_EXACTLY_THE_SAME_FORMAT_AS_OLD_DATE'),(4467,'STR_ERROR_RETRIEVING_ORDER_INFORMATION'),(4468,'STR_IN_ORDER_TO_CHANGE_THE_DATE_YOU_MUST_ENTER_YOUR_LOGIN_NAME_AND_PASSWORD_AND_CHECK_THE_BOX_BELOW'),(4469,'STR_LOGIN_NAME'),(4470,'STR_MAKE_SURE_YOUR_USERNAME_AND_PASSWORD_ARE_CORRECT'),(4471,'STR_NEW_DUE_DATE'),(4472,'STR_NEW_DUE_TIME'),(4473,'STR_OLD_DUE_DATE_AND_TIME'),(4474,'STR_YOU'),(4475,'STR_YOU_ARE_NOT_AUTHORIZED_TO_MAKE_THIS_CHANGE'),(4476,'STR_YOU_MUST_CHECK_THE_BOX_BELOW_TO_CONTINUE'),(4477,'STR_YOU_MUST_FILL_IN_A_NEW_TIME'),(4478,'STR_ORIGINALS'),(4479,'STR_PRINT_ORDER_NOT_FOUND'),(4480,'STR_YOU_HAVE_ENTERED_AN_INVALID_DATE_AND_TIME'),(4481,'STR_CUSTOMER_NAME'),(4482,'STR_DAYS_TO_COMPLETE_AFTER_APPROVAL'),(4483,'STR_DAYS_TO_COMPLETE_ORDER_AFTER_APPROVAL'),(4484,'STR_ENTER_NEW_PROOF_INFO_FOR_PRINT_ORDER'),(4485,'STR_ERROR_CREATING_OUT_TO_PROOF'),(4486,'STR_FAX_NUMBER'),(4487,'STR_GRAPHICS_FAX_FORM'),(4488,'STR_GRAPHICS_TEAM_MEMBER_WHO_CREATED_THIS_PROOF'),(4489,'STR_IF_ANYTHING_IS_MISSING_OR_DISTORTED_IN_THIS_TRANSMISSION_PLEASE_CONTACT'),(4490,'STR_IF_THEY_ARE_TO_YOUR_SATISFACTION_SIGN_THE_PROOF_SHEET_BELOW_AND_RETURN_VIA_MAIL_OR_FAX'),(4491,'STR_IF_YOU_NEED_CHANGES_OR_CORRECTIONS_PLEASE_FAX_US_BACK_OR_GIVE_US_A_CALL'),(4492,'STR_ORDER_FOR_PROOF_SEND_OR_RETURN'),(4493,'STR_ORDER_PROOF_NUMBER'),(4494,'STR_OUT_TO_PROOF_CREATED_SUCCESSFULLY'),(4495,'STR_OUT_TO_PROOF_PRINT_FORM'),(4496,'STR_PLEASE_MAKE_THIS_A_PRIORITY_TO_ENSURE_THAT_WE_MEET_YOUR_REQUIRED_DUE_DATE'),(4497,'STR_PLEASE_PROOFREAD_THE_FOLLOWING_PAGES'),(4498,'STR_PLEASE_SIGN_AND_DATE_THIS_PROOF_SHEET_AND_RETURN_IT_TO'),(4499,'STR_PRINT_FAX_PROOF_FOR_ORDER'),(4500,'STR_PRINT_ORDER_NUMBER'),(4501,'STR_PROCEED_WITH_ORDER'),(4502,'STR_PROOF_CREATE_DATE'),(4503,'STR_PROOF_DUE_DATE'),(4504,'STR_PROOF_NOTES'),(4505,'STR_PROOF_NUMBER_SENT_DATE'),(4506,'STR_PROOF_OK_AS_IS'),(4507,'STR_PROOF_RESPONSE_DATE'),(4508,'STR_PROOF_SHEET'),(4509,'STR_PROOF_STATUS_LEVEL'),(4510,'STR_REVISIONS_NEEDED'),(4511,'STR_SEND_ANOTHER_PROOF'),(4512,'STR_SENT_AND_PENDING'),(4513,'STR_SIGNATURE'),(4514,'STR_UNABLE_TO_CREATE_PDF_FILE'),(4515,'STR_WE_CANNOT_PRINT_YOUR_JOB_UNTIL_WE_HAVE_RECEIVED_THIS_SIGNED_FORM'),(4516,'STR_YOUR_JOB_CANNOT_BE_PRINTED_UNTIL_THE_APPROPRIATE_BOX_IS_CHECKED_AND_SIGNED'),(4517,'STR_INCORRECT_PASSWORD_FOR'),(4518,'STR_SELECT_EMPLOYEES_FOR_THIS_JOB'),(4519,'STR_THE_FOLLOWING_EMPLOYEES_HAVE_BEEN_ADDED'),(4520,'STR_THIS_USER_IS_ALREADY_ON_THIS_JOB'),(4521,'STR_THIS_USER_IS_CURRENTLY_LOGGED_IN'),(4522,'STR_TIME_AND_MATERIALS_ENTRY_FOR_ORDER'),(4523,'STR_PENDING_BUILD_ORDERS'),(4524,'STR_PENDING_PURCHASE_ORDERS'),(4525,'STR_RECEIPTS_WITHOUT_PO'),(4526,'STR_RECEIPTS_WITH_PO'),(4527,'STR_RECENT_INVENTORY_ADJUSTMENTS'),(4528,'STR_TOTAL_ADJUSTMENTS'),(4529,'STR_INVENTORY_USAGE_BY_CATEGORY'),(4530,'STR_LAST_TRANSACTION'),(4531,'STR_TRANSACTIONS'),(4532,'STR_IN_STOCK'),(4533,'STR_NO_PO'),(4534,'STR_VIEW_ITEM_REORDER_LIST'),(4535,'STR_NEW_INVENTORY_ITEMS'),(4536,'STR_TOTAL_NEW_ITEMS'),(4537,'STR_VIEW_ITEM_LIST'),(4538,'STR_BO_NUMBER'),(4539,'STR_NO_BUILD_ORDERS_FOUND'),(4540,'STR_TOTAL_PENDING_BUILD_ORDERS'),(4541,'STR_VIEW_BUILD_ORDERS'),(4542,'STR_NO_POS_FOUND'),(4543,'STR_TOTAL_PENDING_POS'),(4544,'STR_VIEW_INVENTORY_PO_LIST'),(4545,'STR_INVENTORY_RECEIPTS_WITHOUT_PO'),(4546,'STR_RECEIVED_DATE'),(4547,'STR_TOTAL_RECEIPTS'),(4548,'STR_VIEW_RECEIVE_NO_PO_LIST'),(4549,'STR_INVENTORY_RECEIPTS_WITH_PO'),(4550,'STR_NEW_BUILD_ORDERS'),(4551,'STR_NEW_ITEMS'),(4552,'STR_NEW_PURCHASE_ORDERS'),(4553,'STR_PURCHASE_ORDERS_RECEIVED'),(4554,'STR_VIEW_ITEM_USAGE_REPORT'),(4555,'STR_PO_DESCRIPTION'),(4556,'STR_PROOF_NO_LONGER_EXISTS'),(4557,'STR_PROOF_PROCESSING_FOR_ORDER'),(4558,'STR_PROOF_UPDATED_SUCCESSFULLY'),(4559,'STR_RETURNED_PROOF'),(4560,'STR_CLICK_TO_VIEW_PACKING_SLIP'),(4561,'STR_DISPLAY_FROM_ADDRESS_USING'),(4562,'STR_DRIVER'),(4563,'STR_ORDER_COMPLETE'),(4564,'STR_OUR_ORDER'),(4565,'STR_PACKING_SLIP'),(4566,'STR_PRINT_PACKING_SLIP_FOR_ORDER'),(4567,'STR_RECEIVED_BY'),(4568,'STR_SHIPPED_VIA'),(4569,'STR_STANDARD_DELIVERY'),(4570,'STR_YOUR_ORDER_PO'),(4571,'STR_BOX_LABELS'),(4572,'STR_CLICK_ALL_TO_SHIP_REMAINING_QTY'),(4573,'STR_HAS_ALREADY_BEEN_SHIPPED'),(4574,'STR_IS_A_NEGATIVE_NUMBER'),(4575,'STR_IS_NOT_READY_FOR_SHIPPING'),(4576,'STR_IS_TOO_LARGE'),(4577,'STR_NEW_SHIPMENT_FOR_ORDER_NUMBER'),(4578,'STR_ORDER_FOR_SHIPMENT'),(4579,'STR_ORDER_SHIPPED'),(4580,'STR_ORDER_SHIPPING'),(4581,'STR_PRESS_OK_TO_CONFIRM_IF_AMOUNT_IS_CORRECT'),(4582,'STR_PREVIOUS_SHIPMENT_DETAILS'),(4583,'STR_QTY_TO_SEND'),(4584,'STR_SET_TO_DEFAULT'),(4585,'STR_STARTING_QTY'),(4586,'STR_THE_ENTIRE_QUANTITY_FOR_THIS_ORDER_HAS_BEEN_SHIPPED'),(4587,'STR_THE_QUANTITY_TO_SEND_HAS_BEEN_SET_TO'),(4588,'STR_THE_QUANTITY_TO_SEND_HAS_BEEN_SET_TO_THE_QUANTITY_REMAINING'),(4589,'STR_THE_QUANTITY_TO_SEND_HAS_BEEN_SET_TO_ZERO'),(4590,'STR_THE_VALUE_YOU_ENTERED'),(4591,'STR_YOUR_ORDER_DID_NOT_SHIP_CORRECTLY'),(4592,'STR_PRICING'),(4593,'STR_STOCK_DETAILS'),(4594,'STR_CHECK_ALL_ORDERS_TO_BE_INVOICED'),(4595,'STR_COMPLETE_DATE'),(4596,'STR_REVIEW'),(4597,'STR_TAXES'),(4598,'STR_THE_FOLLOWING_ORDERS_WERE_INVOICED'),(4599,'STR_ABBREVIATION_LEGEND'),(4600,'STR_BLUE'),(4601,'STR_COMPLETION_STEPS'),(4602,'STR_DETAILS'),(4603,'STR_GREEN'),(4604,'STR_GREY'),(4605,'STR_HOURS_AGO'),(4606,'STR_MORE_THAN'),(4607,'STR_NOT_NEEDED_THIS_ORDER'),(4608,'STR_OK'),(4609,'STR_ORDERS_RECEIVED'),(4610,'STR_PRICES'),(4611,'STR_REVISE'),(4612,'STR_T_AND_M'),(4613,'STR_WITH_RUSH_STATUS'),(4614,'STR_WORK_AREA_COLOR_LEGEND'),(4615,'STR_DID_NOT_WORK'),(4616,'STR_OVERDUE_ORDERS'),(4617,'STR_SELECT_REPORT_CUT_OFF_DATE'),(4618,'STR_CLICK_ON_ORDER_NUMBER_TO_REMOVE_FROM_ONHOLD_STATUS'),(4619,'STR_ON_HOLD_ORDERS'),(4620,'STR_BEGIN_FINISH_DATE'),(4621,'STR_END_FINISH_DATE'),(4622,'STR_FOR_ORDERS_OK_TO_BILL'),(4623,'STR_OK_TO_BILL_DATE'),(4624,'STR_BEGIN_SHIP_DATE'),(4625,'STR_END_SHIP_DATE'),(4626,'STR_TOTAL_ON_HAND'),(4627,'STR_BEGIN_QUOTE_DATE'),(4628,'STR_CHANGE_PRICES'),(4629,'STR_CHANGE_QUOTED_PRICES'),(4630,'STR_CLICK_ON_QUOTE_NUMBER_TO_CONVERT_TO_ORDER'),(4631,'STR_CONVERT_QUOTE'),(4632,'STR_CREATE_DATE'),(4633,'STR_CUSTOMER_PHONE'),(4634,'STR_END_QUOTE_DATE'),(4635,'STR_MULTI_QUOTE_STATUS'),(4636,'STR_NON_SELECTED'),(4637,'STR_NOT_USED'),(4638,'STR_QUOTE_LIST'),(4639,'STR_REVISE_DATE'),(4640,'STR_TO_ORDER'),(4641,'STR_WON'),(4642,'STR_ADDITIONAL_CHARGES'),(4643,'STR_ADD_THIS_ITEM'),(4644,'STR_CHANGES_ALL_PRICES'),(4645,'STR_CHANGE_PRICE_TO'),(4646,'STR_CURRENT_PRICE'),(4647,'STR_DISCOUNT_TO_APPLY'),(4648,'STR_ORDER_PRICE_BREAKDOWN'),(4649,'STR_PRODUCT_OR_WORK'),(4650,'STR_QUOTE_PRICE_BREAKDOWN'),(4651,'STR_RECALCULATE_PRICES'),(4652,'STR_REVERSE_RECALCULATE'),(4653,'STR_REVIEW_ORDER_COSTS'),(4654,'STR_SELECT_ORDER_TO_REVIEW'),(4655,'STR_TOTAL_VENDED_OUTSIDE_ESTIMATE'),(4656,'STR_TO_ALL_PRICES'),(4657,'STR_WORK_AREA'),(4658,'STR_ACTUAL_COST'),(4659,'STR_CLICK_HERE_TO_SEND_AND_PRINT_QUOTE'),(4660,'STR_DESCTIPTION'),(4661,'STR_NO_EMAILS_HAVE_BEEN_ENTERED_YET'),(4662,'STR_QUOTED_PRICE'),(4663,'STR_SELECT_ORDER'),(4664,'STR_SEND_QUOTE_FROM_THIS_EMAIL_ADDRESS'),(4665,'STR_SEND_QUOTE_TO_THIS_EMAIL_ADDRESS'),(4666,'STR_THIS_QUOTE_WILL_BE_EMAILED_TO'),(4667,'STR_UNITS'),(4668,'STR_VALUED_CUSTOMER'),(4669,'STR_ANY_DELAYS_IN_APPROVAL_COULD_DELAY_THE_SHIP_DATE'),(4670,'STR_AUTHORIZED_SIGNATURE'),(4671,'STR_DAYS_BASED_ON_THE_CUSTOMER_APPROVING_THE_PROOF_WITHIN_24_HOURS'),(4672,'STR_DID_YOU_KNOW_WE_ALSO_OFFER'),(4673,'STR_DISCOUNTS_DO_NOT_APPLY_WHEN_PAYING_WITH_CREDIT_CARD'),(4674,'STR_FOR_90_DAYS'),(4675,'STR_LEAD_TIME_IS'),(4676,'STR_PART_NUMBER_NAME'),(4677,'STR_PLEASE_SIGN_THIS_FORM_AND_FAX_BACK_TO_US_AT'),(4678,'STR_PRINT_NAME'),(4679,'STR_QUOTE_VALID'),(4680,'STR_SALES_REP'),(4681,'STR_SEND_ELECTRONIC_ARTWORK_TO'),(4682,'STR_THANK_YOU_FOR_ALLOWING_US_TO_BE_OF_SERVICE'),(4683,'STR_THE_FOLLOWING_NUMBER_MUST_APPEAR_ON_ALL_QUOTE_RELATED_CORRESPONDENCE'),(4684,'STR_TODAYS_DATE'),(4685,'STR_TOLL_FREE'),(4686,'STR_WE_LOOK_FORWARD_TO_PRODUCING_THIS_ORDER_FOR_YOU'),(4687,'STR_WE_NOW_ACCEPT_VISA_MASTERCARD_AMERICAN_EXPRESS_AND_DISCOVER'),(4688,'STR_YOU_CAN_USE_THIS_QUOTE_FORM_AS_YOUR_PURCHASE_ORDER'),(4689,'STR_CLICK_ON_JOB_NUMBER_TO_CONFIRM_ORDER'),(4690,'STR_CONTACT_PHONE'),(4691,'STR_SUBMIT_DATE'),(4692,'STR_UNCONFIRMED_PRINT_ORDERS'),(4693,'STR_COST_SALES'),(4694,'STR_PURCHASES'),(4695,'STR_QTY_ADJUSTED'),(4696,'STR_UNITS_SOLD'),(4697,'STR_CANCEL_FAILED'),(4698,'STR_CHANGE_OPEN_ORDER'),(4699,'STR_INITIALS'),(4700,'STR_MUST_ENTER_INITIALS_AND_REASON'),(4701,'STR_MUST_ENTER_REASON'),(4702,'STR_ORDER_CANCELLED'),(4703,'STR_ORDER_INFORMATION_RETRIEVED'),(4704,'STR_ORDER_NOT_ACTIVE'),(4705,'STR_ORDER_PLACED_ON_HOLD'),(4706,'STR_ORDER_REMOVED_FROM_ON_HOLD'),(4707,'STR_PLACE_ON_HOLD_ORDER'),(4708,'STR_QUOTE_CONVERTED_TO_ORDER'),(4709,'STR_REASON_FOR_DELETING'),(4710,'STR_REASON_FOR_PLACING_ON_HOLD'),(4711,'STR_RETURN_TO_SELECTION_DO_NOT_PLACE_ON_HOLD'),(4712,'STR_SELECT_WHICH_QUANTITY_TO_CONVERT_TO_ORDER'),(4713,'STR_ACTIVITY'),(4714,'STR_CLICK_FOR_PRINTABLE_VERSION'),(4715,'STR_CLICK_TO_RETURN'),(4716,'STR_DATE_OUT'),(4717,'STR_DATE_TIME_IN'),(4718,'STR_ERROR_RETRIEVING_ORIGINALS'),(4719,'STR_INPUT_BY'),(4720,'STR_MAILSTOP'),(4721,'STR_NEW'),(4722,'STR_NOTIFY'),(4723,'STR_ORIGINALS_SUBMITTED_BY'),(4724,'STR_PICKUP_ORIGINALS'),(4725,'STR_PRINTED'),(4726,'STR_PRINT_PDF_FORMAT'),(4727,'STR_PRODUCTION_INSTRUCTIONS'),(4728,'STR_REPRINT_AS_IS'),(4729,'STR_REVISED'),(4730,'STR_ROUTING'),(4731,'STR_RUSH_ROUTING'),(4732,'STR_SHIP_FROM_INVENTORY_STOCK'),(4733,'STR_SPECIAL_INSTRUCTIONS'),(4734,'STR_SPECIAL_NOTE'),(4735,'STR_STOCK_PART'),(4736,'STR_STOCK_SIZE'),(4737,'STR_SUB_ACTIVITY'),(4738,'STR_TOTAL_ORIGINALS'),(4739,'STR_WHEN_EACH_DEPARTMENT_COMPLETES_TASKS'),(4740,'STR_PRINT_ITEMS_CATEGORY'),(4741,'STR_CATEGORY_LEVEL'),(4742,'STR_CURRENT_SEARCH_CATEGORIES_AND_LEVELS'),(4743,'STR_SEARCH_CATEGORY_NAME'),(4744,'STR_SEARCH_CATEGORY_ADD'),(4745,'STR_ADDING_NEW'),(4746,'STR_ADDITIONAL_FOR_QUOTE_BELOW'),(4747,'STR_ADDITIONAL_QUANTITIES_FOR_QUOTES'),(4748,'STR_BOOKS'),(4749,'STR_CALCULATE_AND_SAVE_AS_QUOTE'),(4750,'STR_CANCEL_CHANGES_MADE'),(4751,'STR_CANCEL_ENTRIES'),(4752,'STR_CHANGING_TO_NEW_AS_PRIOR_ORDER_NOT_FOUND'),(4753,'STR_CHANGING_TO_NEW_ORDER_AS_POD_ITEM_NOT_FOUND'),(4754,'STR_CHANGING_TO_REPRINT_WITH_CHANGES_AS_POD_ITEM_ALREADY_CREATED'),(4755,'STR_CHECK_ALL_APPROPRIATE'),(4756,'STR_CLIENT_HAS_REQUESTED_A_QUOTE'),(4757,'STR_CONFIRMING'),(4758,'STR_CUSTOMER_SELECTION'),(4759,'STR_CUSTOM_PRINT_ORDER'),(4760,'STR_DATE_TO_SHIP'),(4761,'STR_DELETE_ORDER'),(4762,'STR_DELIVERY_INFO'),(4763,'STR_DELIVERY_QUANTITY_DOES_NOT_MATCH_ORDER_QUANTITY'),(4764,'STR_DELIVER_HOW'),(4765,'STR_DELIVER_TO_NAME'),(4766,'STR_DESCRIPTION_ON_QUOTE'),(4767,'STR_EMAIL_FOR_NOTIFICATION'),(4768,'STR_ENTER_FORM_NUMBER'),(4769,'STR_ENTER_POD_NUMBER'),(4770,'STR_FACE_DOWN'),(4771,'STR_FACE_UP'),(4772,'STR_FINAL_INSTRUCTIONS'),(4773,'STR_FORM_NAME'),(4774,'STR_FORM_NAME_ORDER'),(4775,'STR_FOR_JOB_TICKET'),(4776,'STR_FROM_STOCK'),(4777,'STR_FULL_DETAILS'),(4778,'STR_GENERAL_JOB_INFO'),(4779,'STR_JOB_DETAILS'),(4780,'STR_LEAVE_BLANK_FOR_PRINT_SIZE_EQUAL_STOCK_SIZE'),(4781,'STR_LOOKUP_POD'),(4782,'STR_LOOKUP_PRIOR_ORDER'),(4783,'STR_MISSING_OR_BAD_INFO_FLAGGED_IN_RED'),(4784,'STR_MUST_CONTAIN_ADDRESS'),(4785,'STR_MUST_HAVE_AT_LEAST_ONE_DELIVERY_ADDRESS'),(4786,'STR_NOT_PRINTED'),(4787,'STR_NO_OF_COLORS'),(4788,'STR_NO_OF_ORIGINALS'),(4789,'STR_OF'),(4790,'STR_ONE_AND_TWO_SIDED'),(4791,'STR_ORDER_BY_INFO'),(4792,'STR_ORDER_QUANTITY_1'),(4793,'STR_ORDER_TYPE'),(4794,'STR_PACKS'),(4795,'STR_PADS'),(4796,'STR_PAGE_ORIENTATION'),(4797,'STR_PLACE_PRINT_ORDER'),(4798,'STR_POD_ORDER'),(4799,'STR_PRICE_PER_SHEET'),(4800,'STR_PRINT_SHEET_SIZE'),(4801,'STR_PRINT_SIDES'),(4802,'STR_REAMS'),(4803,'STR_RELEASE_INFORMATION'),(4804,'STR_REPRINT_OR_NEW'),(4805,'STR_REPRINT_WITH_CHANGES'),(4806,'STR_REQUEST_FOR_PROOF'),(4807,'STR_REQUEST_FOR_QUOTE'),(4808,'STR_REVIEWING'),(4809,'STR_REVISING'),(4810,'STR_SAVE_ORDER_CHANGES_NO_RECALCULATE'),(4811,'STR_SAVE_ORDER_CHANGES_WITH_RECALCULATE'),(4812,'STR_SAVE_ORDER_FOR_LATER_REVIEW'),(4813,'STR_SAVE_ORDER_IN_ACTIVE_ORDER_FILE'),(4814,'STR_SETS'),(4815,'STR_SET_BOOK_PAD'),(4816,'STR_SHEETS_PER_UNIT'),(4817,'STR_SHEET_SIZE'),(4818,'STR_SPECIAL_ORDER_SECTION'),(4819,'STR_STOCK_PURPOSE_PART'),(4820,'STR_TIME_DUE'),(4821,'STR_TYPE_OF_ORDER'),(4822,'STR_UNABLE_TO_GET_COUNTS_OF_WORKTYPES'),(4823,'STR_VENDED_OUTSIDE'),(4824,'STR_WORK_TYPE_DESCRIPTION'),(4825,'STR_YOUR_ORDER_IS_BEING_PROCESSED'),(4826,'STR_YOU_NEED_TO_SELECT_A_WORKTYPE'),(4827,'STR_YOU_NEED_TO_SELECT_A_WORK_TYPE'),(4828,'STR_ADDITIONAL_QUANTITIES_FOR_QUOTE'),(4829,'STR_ADD_COLOR'),(4830,'STR_ADD_NEW_PART'),(4831,'STR_CHANGING_TO_NEW_AS_ITEM_ORDER_NOT_FOUND'),(4832,'STR_CHANGING_TO_REPRINT_WITH_CHANGES_AS_ITEM_ORDER_EXISTS_ALREADY'),(4833,'STR_CUSTOMERS_MATCHED_ENTRY_TRY_AGAIN'),(4834,'STR_DELETE_THIS_DELIVERY_ADDRESS'),(4835,'STR_EDITED_BY'),(4836,'STR_ERROR_DURING_UPDATE_IN_STEP'),(4837,'STR_FIRST_SELECT_A_WORK_TYPE_FROM_THE_DROP_DOWN'),(4838,'STR_FOR_ORDER_TICKET'),(4839,'STR_NO_ORDER_QUANTITY'),(4840,'STR_ORDER_BY_AND_TYPE'),(4841,'STR_ORDER_INFORMATION_SAVED'),(4842,'STR_ORDER_LOOKUP'),(4843,'STR_ORDER_QUANTITY_ONE_'),(4844,'STR_POD_NUMBER'),(4845,'STR_REPRINT_ORDER_NUMBER'),(4846,'STR_THEN_SELECT_A_DETAIL_TYPE_FROM_THE_DETAIL_LIST'),(4847,'STR_THIS_BOX_WILL_ALWAYS_CONTAIN_A_FULL_DESCRIPTION_OF_THE_CHOICE_YOU_HAVE_MADE'),(4848,'STR_TO_SEE_THIS_HELP_AGAIN_RESELECT_THE_TOP_OPTION_UNDER_WORK_TYPE'),(4849,'STR_MISSING_DUE_DATE'),(4850,'STR_ORDER_DELETED'),(4851,'STR_AWAITING_CUSTOMER_REVIEW'),(4852,'STR_AWAITING_INTERNAL_REVIEW'),(4853,'STR_FINAL_SHIPPED'),(4854,'STR_PRICED_COMPLETE'),(4855,'STR_PRINT_ORDER_PICKER'),(4856,'STR_QUOTED'),(4857,'STR_QUOTES'),(4858,'STR_SELECT_SPECIFICS_FOR_PRINT_ORDER_SEARCH'),(4859,'STR_THE_STARTING_CREATION_DATE_IS_EQUAL_TO_OR_LATER_THAN_THE_ENDING_DATE'),(4860,'STR_THE_STARTING_DUE_DATE_IS_EQUAL_TO_OR_LATER_THAN_THE_ENDING_DATE'),(4861,'STR_UNCONFIRMED'),(4862,'STR_ITEM_ADJUSTED'),(4863,'STR_INVENTORY_ORDER_PICKLIST'),(4864,'STR_NR'),(4865,'STR_ORDER_NOTES'),(4866,'STR_TOTAL_LINE_ITEMS_ON_ORDER_NUMBER'),(4867,'STR_TO_SHIP'),(4868,'STR_ORDER_QUANTITY_ONE'),(4869,'STR_NEW_QUOTES'),(4870,'STR_TOTAL_UNCONFIRMED_OR_ON_HOLD_ORDERS'),(4871,'STR_ARE_YOU_SURE_DELETE'),(4872,'STR_PENDING_ORDERS_REPORT'),(4873,'STR_OPEN_PRINT_ORDERS'),(4874,'STR_PENDING_ORDERS'),(4875,'STR_STOCKS_ON_LIST'),(4876,'STR_ONE_MONTH'),(4877,'STR_QUOTE_DATE'),(4878,'STR_TOTAL_QUOTES_ONE_MONTH'),(4879,'STR_ORDERS_SHIPPED_ONE_WEEK'),(4880,'STR_LOST_QUOTE'),(4881,'STR_QUOTE_LOST'),(4882,'STR_QUOTE_MARKED_AS_LOST'),(4883,'STR_REASON_FOR_LOSING_ORDER'),(4884,'STR_UNCONFIRMED_ORDERS'),(4885,'STR_UNCONFIRMED_ORDERS_REPORT'),(4886,'STR_PENDING_QUOTES'),(4887,'STR_TOTAL_QUOTES'),(4888,'STR_RECENT_QUOTES_ONE_MONTH'),(4889,'STR_DESCR'),(4890,'STR_PENDING_PROOFS'),(4891,'STR_DUE_BACK'),(4892,'STR_NO_PROOFS_OUT'),(4893,'STR_PROOFS_OUT'),(4894,'STR_PROOFS_PENDING_REPORT'),(4895,'STR_NO_ACTIVITY_FOR_WEEK'),(4896,'STR_PRINT_ORDER_VOLUME_REPORT'),(4897,'STR_PRINT_VOLUME_REPORT'),(4898,'STR_ORDER_VOLUME_ONE_WEEK'),(4899,'STR_COULD_NOT_LOOK_UP_ITEM'),(4900,'STR_RECEIVE_LOCATION'),(4901,'STR_TRACKING_NUMBER_BOL_OR_OTHER'),(4902,'STR_ORDER_VOLUME_ONE_MONTH'),(4903,'STR_NO_ACTIVITY_FOR_MONTH'),(4904,'STR_PRINT_ORDER_VOLUME_REPORT_ONE_MONTH'),(4905,'STR_WEEK_OF'),(4906,'STR_NO_ACTIVITY_FOR_YEAR'),(4907,'STR_PRINT_ORDER_VOLUME_REPORT_ONE_YEAR'),(4908,'STR_ORDER_VOLUME_ONE_YEAR'),(4909,'STR_TOP_DOLLAR_CUSTOMERS_30_DAYS'),(4910,'STR_TOP_DOLLAR_CUSTOMERS_ONE_YEAR'),(4911,'STR_VIEW_CLOSED_ORDERS_REPORT'),(4912,'STR_TOP_TEN_PRINT_CUSTOMERS'),(4913,'STR_TOP_10_PRINT_CUSTOMERS_YEAR'),(4914,'STR_TOP_10_PROFIT_ORDERS_MONTH'),(4915,'STR_NO_DATA'),(4916,'STR_SHOP_LOADING_REPORT'),(4917,'STR_NUM_ORDERS'),(4918,'STR_WON_LOST_QUOTE_RATIO'),(4919,'STR_WON_LOST_RATIO'),(4920,'STR_VIEW_SHOP_LOADING_REPORT'),(4921,'STR_ORDER_QUANTITY_DIVIDED_BY_NUMERIC_ANSWER'),(4922,'STR_PRESS_QUANTITY_DIVIDED_BY_NUMERIC_ANSWER'),(4923,'STR_PRESS_SZ'),(4924,'STR_NEW_CREDIT_MEMOS'),(4925,'STR_NEW_INVOICES'),(4926,'STR_NEW_PAYMENTS'),(4927,'STR_NEW_SALES_ACTIONS'),(4928,'STR_RECENT_PAYMENTS_ONE_MONTH'),(4929,'STR_RECENT_PAYMENTS_ONE_WEEK'),(4930,'STR_ONE_WEEK'),(4931,'STR_SALES_ACTIONS_NEEDED_TODAY'),(4932,'STR_ACTION_TIME'),(4933,'STR_NUMBER_INVOICES'),(4934,'STR_ONE_YEAR'),(4935,'STR_CUSTOMERS_OVER_CREDITLIMIT'),(4936,'STR_GROUP_TOTAL'),(4937,'STR_INVOICE_TOTALS'),(4938,'STR_AGING_SUMMARY'),(4939,'STR_VIEW_AGING_REPORT'),(4940,'STR_INVOICES'),(4941,'STR_INVOICE_VOLUME_REPORT'),(4942,'STR_NUMBER_PAYMENTS'),(4943,'STR_VIEW_INVOICE_SUMMARY'),(4944,'STR_INVOICE_VOLUME_ONE_WEEK'),(4945,'STR_12_MONTH'),(4946,'STR_8_WEEK'),(4947,'STR_INVOICE_VOLUME_12_MONTH'),(4948,'STR_INVOICE_VOLUME_8_WEEK'),(4949,'STR_MOST_OVERDUE'),(4950,'STR_DAYS_FROM_INVOICE'),(4951,'STR_NEW_BILLS'),(4952,'STR_NEW_CHECKS_WRITTEN'),(4953,'STR_NEW_PO'),(4954,'STR_NEW_VENDORS'),(4955,'STR_BILLS_DUE_LATER'),(4956,'STR_BILLS_DUE_SOON'),(4957,'STR_PAST_DUE_BILLS'),(4958,'STR_VIEW_PAYABLES_LIST'),(4959,'STR_BILLS_VOLUME_REPORT'),(4960,'STR_TOP_DOLLAR_VENDORS_MONTH'),(4961,'STR_TOP_DOLLAR_VENDORS_YEAR'),(4962,'STR_TOP_TEN_VENDORS'),(4963,'STR_1_YEAR'),(4964,'STR_BILLS_VOLUME_12_MONTH'),(4965,'STR_BILLS_VOLUME_7_DAY'),(4966,'STR_BILLS_VOLUME_8_WEEK'),(4967,'STR_RECENT_BILLS_RECEIVED'),(4968,'STR_CHECKS_WRITTEN_ONE_MONTH'),(4969,'STR_CHECKS_WRITTEN_ONE_WEEK'),(4970,'STR_1_MONTH'),(4971,'STR_RECENT_CHECKS_WRITTEN'),(4972,'STR_TOTAL_CHECKS'),(4973,'STR_DAYS'),(4974,'STR_TOTAL_INVOICES'),(4975,'STR_URL_FILE_FOR_LARGE_LOGO'),(4976,'STR_URL_FILE_FOR_SMALL_LOGO'),(4977,'STR_NO_PO_FOUND'),(4978,'STR_PENDING_ITEMS_ON_PO'),(4979,'STR_PO_DATE'),(4980,'STR_REQ'),(4981,'STR_VIEW_PO_LIST'),(4982,'STR_FROM_PO'),(4983,'STR_RECEIVE_INTO_INVENTORY_ONE_WEEK'),(4984,'STR_AP_AGING_SUMMARY'),(4985,'STR_OVERDUE_SOON_LATER'),(4986,'STR_RECEIVE_INTO_INVENTORY'),(4987,'STR_PENDING_PO'),(4988,'STR_BIRTHDAYS_IN_NEXT_MONTH'),(4989,'STR_NO_BIRTHDAYS_FOUND'),(4990,'STR_VIEW_BIRTHDAYS_LIST'),(4991,'STR_RECENT_LAYOFFS'),(4992,'STR_RECENT_PAY_RATE_CHANGES'),(4993,'STR_DATE_OF_CHANGE'),(4994,'STR_NEW_RATE'),(4995,'STR_NO_CHANGES_FOUND'),(4996,'STR_PAY_RATE_CHANGES_ONE_WEEK'),(4997,'STR_VIEW_EMPLOYEE_LIST'),(4998,'STR_NO_PAY_FOUND'),(4999,'STR_DATE_OF_LAYOFF'),(5000,'STR_NO_LAYOFFS_FOUND'),(5001,'STR_LAID_OFF'),(5002,'STR_NEW_HIRES'),(5003,'STR_PAY_RATE_CHANGES'),(5004,'STR_PAYROLL_BY_MONTH_FOR_YEAR'),(5005,'STR_PAYROLL_BY_QUARTER_FOR_YEAR'),(5006,'STR_PAYROLL_THIS_MONTH'),(5007,'STR_COUNTS_OF_ACTIVE_EMPLOYEES'),(5008,'STR_SALARIED'),(5009,'STR_EMPLOYEE_COUNTS'),(5010,'STR_OLD_RATE'),(5011,'STR_DATE_OF_REVIEW'),(5012,'STR_NO_REVIEWS_FOUND'),(5013,'STR_REVIEWER'),(5014,'STR_RECENT_REVIEWS_7_DAYS'),(5015,'STR_ALL_CUSTOMERS'),(5016,'STR_CURRENT_IMAGE'),(5017,'STR_ONLY_SELECT_IF_CHANGING_IMAGE'),(5018,'STR_ADD_EDIT_A_CARRIER'),(5019,'STR_MAKE_CURRENT_VENDOR_A_CARRIER'),(5020,'STR_SALES_7_DAYS'),(5021,'STR_RECENT_JOURNAL_ENTRIES'),(5022,'STR_VIEW_JOURNALS'),(5023,'STR_SALES_REPORT'),(5024,'STR_VIEW_ACCOUNT_ACTIVITY'),(5025,'STR_JOURNAL_ENTRIES_7_DAYS'),(5026,'STR_TOTAL_ACCOUNTS'),(5027,'STR_PROFIT_REPORT'),(5028,'STR_UNITS_IN_THOUSANDS'),(5029,'STR_SALES_12_MONTH'),(5030,'STR_SALES_8_WEEK'),(5031,'STR_PROFIT_12_MONTH'),(5032,'STR_DOLLARS_IN_THOUSANDS'),(5033,'STR_VIEW_PROFIT_AND_LOSS_STATEMENT'),(5034,'STR_DATABASE_STATS'),(5035,'STR_CHANGING_THIS_FIELD_CAN_RESULT_IN_LOSS_OF_DATA_PROCEED_WITH_CAUTION'),(5036,'STR_DELETE_LARGE_GRAPHIC'),(5037,'STR_DELETE_SMALL_GRAPHIC'),(5038,'STR_BILLED_ORDERS'),(5039,'STR_CURRENT_MONTH'),(5040,'STR_DAILY_VOLUME_REPORT'),(5041,'STR_DOLLARS_INVOICED'),(5042,'STR_ERROR_WHEN_COPYING_BIG_FILE_TO_CLIENT_PAGE'),(5043,'STR_BEGIN_ACTION_DATE'),(5044,'STR_END_ACTION_DATE'),(5045,'STR_PRODUCTS_VIEWED'),(5046,'STR_TIMES_VIEWED'),(5047,'STR_VIEW_PRODUCTS_VIEWED_REPORT'),(5048,'STR_TOP_10_SALES_STATES_MONTH'),(5049,'STR_TOP_10_SALES_STATES_YEAR'),(5050,'STR_VIEW_ORDER_VOLUME_REPORT'),(5051,'STR_CHECK_ALL_ORDERS_TO_INVOICE'),(5052,'STR_QTY_TO_BILL'),(5053,'STR_COMPLETED_ORDERS_ON'),(5054,'STR_DATE_COMPLETE'),(5055,'STR_DATE_INVOICED'),(5056,'STR_INVOICED_ORDERS_ON'),(5057,'STR_RECEIVED_ORDERS_ON'),(5058,'STR_LATE_PRINT_ORDERS'),(5059,'STR_SELECT_A_DUE_DATE_CUTOFF'),(5060,'STR_EDIT_ORDER'),(5061,'STR_JOB_TYPE'),(5062,'STR_CLICK_ALL_TO_ADD_REMAINING_QTY'),(5063,'STR_NEW_SHIPMENT_FOR_ORDER'),(5064,'STR_PRESS_OK_TO_CONFIRM_THAT_THIS_IS_CORRECT'),(5065,'STR_QUANTITY_TO_SEND'),(5066,'STR_REMAIN'),(5067,'STR_SELECT_A_SHIPPING_DESTINATION'),(5068,'STR_STARTING'),(5069,'STR_THE_QUANTITY_TO_SEND_HAS_BEEN_SET_TO_REMAINING_QUANTITY'),(5070,'STR_WARNING'),(5071,'STR_ERROR_WHEN_COPYING_FILE_TO_CLIENT_PAGE'),(5072,'STR_EXTRA'),(5073,'STR_INITIAL_COMPANY_SETUP'),(5074,'STR_CANCELLED'),(5075,'STR_BEGIN_ORDER_DUE_DATE'),(5076,'STR_BEGIN_ORDER_ENTRY_DATE'),(5077,'STR_CLICK_TO_PRINT_QUOTE'),(5078,'STR_CLICK_TO_PRINT_TICKET'),(5079,'STR_END_ORDER_DUE_DATE'),(5080,'STR_END_ORDER_ENTRY_DATE'),(5081,'STR_JOB'),(5082,'STR_JOB_OR_QUOTE_SEARCH'),(5083,'STR_NO_MATCHING_QUOTES_OR_ORDERS_FOUND'),(5084,'STR_QUOTE_OR_JOB_SEARCH_LIST'),(5085,'STR_PRICELIST'),(5086,'STR_BOX'),(5087,'STR_CLICK_TO_VIEW_BOX_LABELS'),(5088,'STR_PRINT_BOX_LABELS_FOR_ORDER'),(5089,'STR_BOX_LABEL'),(5090,'STR_LN_NUM'),(5091,'STR_CONTENTS'),(5092,'STR_NUMBER_OF_LABELS_TO_PRINT'),(5093,'STR_DISPLAY_FROM_ADDRESS_FOR'),(5094,'STR_YOUR_ORDER'),(5095,'STR_APPROVED'),(5096,'STR_ART_DEPARTMENT'),(5097,'STR_ART_SUPPLIED'),(5098,'STR_CHANGES_PROBLEMS_NOTES'),(5099,'STR_COLOR_COPY'),(5100,'STR_CUSTOMER_ORDER'),(5101,'STR_DATE_SHIPPED'),(5102,'STR_INSP'),(5103,'STR_JOB_RECEIVED'),(5104,'STR_MASTER_SHEET_SIZE'),(5105,'STR_MESH'),(5106,'STR_NUM_OF_PARTS_IN_STOCK'),(5107,'STR_NUM_OF_PRESS_SHEETS'),(5108,'STR_NUM_UP'),(5109,'STR_ORDER_DIE_NUM_UP'),(5110,'STR_ORDER_RECEIVED'),(5111,'STR_ORDER_STATUS'),(5112,'STR_ORIENTATION'),(5113,'STR_PACK_LIST_NUM'),(5114,'STR_PRESS_SHEET_SIZE'),(5115,'STR_PRINTING_TYPE'),(5116,'STR_PRODUCTION_SCHEDULING'),(5117,'STR_PRODUCTION_STEPS_IN_ORDER'),(5118,'STR_PROOF_TO_CUSTOMER'),(5119,'STR_QTY_ORDERED'),(5120,'STR_QTY_SHIPPED'),(5121,'STR_SHIP_BY'),(5122,'STR_STEP'),(5123,'STR_STOCK_HERE'),(5124,'STR_STOCK_ORDERED'),(5125,'STR_SUBSTRATE'),(5126,'STR_ADD_NEW_PO_OR_UPDATE_AN_EXISTING_PURCHASE_ORDER'),(5127,'STR_ADD_UPDATE_BILLS'),(5128,'STR_ADD_UPDATE_PO'),(5129,'STR_ENTER_OR_UPDATE_AN_EXISTING_PAYABLES_BILL'),(5130,'STR_YOU_ARE_NOT_AUTHORIZED_TO_BE_HERE'),(5131,'STR_ADD_UPDATE_INVOICE'),(5132,'STR_ADD_UPDATE_ORDER'),(5133,'STR_UPDATE_ORDERS'),(5134,'STR_ADD_UPDATE_JOURNAL_ENTRIES'),(5135,'STR_ORIGINAL_PRICE'),(5136,'STR_PRODUCTS_ON_SALE'),(5137,'STR_SALE_PRICE'),(5138,'STR_VIEW_PRODUCTS_ON_SALE'),(5139,'STR_ERROR_ADDING_GL_TRANSVOUCHER'),(5140,'STR_FOR_CHECK'),(5141,'STR_ERROR_ADDING_RECORD'),(5142,'STR_ERROR_UPDATING_RECORD'),(5143,'STR_INTEREST_UPDATE_FAILED'),(5144,'STR_AR_INVOICE_PAYMENT_MAKE_ALL_LANGUAGES_SAME'),(5145,'STR_AR_INVOICE_MAKE_ALL_LANGUAGES_SAME'),(5146,'STR_AR_INVOICE_REVERSAL_MAKE_ALL_LANGUAGES_SAME'),(5147,'STR_BY_CHECKING_THIS_BOX_I_CERTIFY_THAT'),(5148,'STR_ERROR_UPDATING_DATE_CHANGE'),(5149,'STR_ERROR_VALIDATING_USER'),(5150,'STR_IN_ORDER_TO_CHANGE_THE_DUE_DATE_YOU_MUST_ENTER_YOUR_USERNAME_AND_PASSWORD_AND_CHECK_THE_BOX_BELOW'),(5151,'STR_ORIGINAL_DUE_DATE'),(5152,'STR_THE_CUSTOMER_HAS_BEEN_CONTACTED_ABOUT_THIS_CHANGE'),(5153,'STR_ERROR_UPDATING_PRICES_NO_ACTION_TAKEN'),(5154,'STR_CANCELLED_BY'),(5155,'STR_YOU_DO_NOT_HAVE_PERMISSION_TO_EDIT_HELP'),(5156,'STR_EDIT_HELP_PAGES'),(5157,'STR_HELP_EDIT'),(5158,'STR_THERE_IS_NO_ACTIVITY'),(5159,'STR_THERE_IS_NO_ORDER_ACTIVITY'),(5160,'STR_THIS_ORDER_HAS_BEEN_CHECKED_OUT'),(5161,'STR_THIS_ORDER_IS_BEING_FILLED'),(5162,'STR_CUSTOMER_QUOTE'),(5163,'STR_ESTIMATED_SHIPPING_TO_ZIP_CODE'),(5164,'STR_SIDE'),(5165,'STR_THIS_QUOTE_PROVIDED_BY'),(5166,'STR_WITH_A_TURNAROUND_OF'),(5167,'STR_QTY_BILLED'),(5168,'STR_THE_FOLLOWING_ORDERS_WERE_COMPLETED_BETWEEN'),(5169,'STR_VIEW_SHIPMENTS'),(5170,'STR_VOUCHER_UPDATE_FAILED'),(5171,'STR_ITEM_ADJUSTMENT_FAILED'),(5172,'STR_SPECIFY_A_NON_BLANK_VALUE'),(5173,'STR_UNABLE_TO_FIND_ITEM_WITH_ID'),(5174,'STR_ITEMS_MUST_HAVE_A_CATEGORY'),(5175,'STR_ITEM_LOCATION_ADDED_SUCCESSFULLY'),(5176,'STR_NO_DEFAULT_GL_ACCOUNT_SELECTED_COULD_NOT_MAKE_GL_ENTRIES'),(5177,'STR_RECEIVE_ITEMS_INTO_INVENTORY'),(5178,'STR_PO_COMPLETE'),(5179,'STR_TRACKING'),(5180,'STR_LIST_ITEMS'),(5181,'STR_CHANGES_WERE_SUCCESSFUL'),(5182,'STR_TO_CHANGE_THE_DATABASE_INFORMATION'),(5183,'STR_MAX_SIZE_BIG'),(5184,'STR_MAX_SIZE_LARGE'),(5185,'STR_MAX_SIZE_SMALL'),(5186,'STR_MAX_SMALL_BIG'),(5187,'STR_ORIGINAL_SHIP_FROM'),(5188,'STR_SAME'),(5189,'STR_CHECK_FAILED_ON_VOID'),(5190,'STR_CHECK_NUMBER_CHANGE_FAILED'),(5191,'STR_CHECK_WRITING_FAILED'),(5192,'STR_ADD_A_NEW_MACHINE_FAMILY'),(5193,'STR_ADD_MACHINE_FAMILY_DETAILS'),(5194,'STR_UPDATE_MACHINE_FAMILY_DETAIL'),(5195,'STR_UPDATE_MACHINE_FAMILY_INFORMATION'),(5196,'STR_CLICK_TO_DELETE'),(5197,'STR_LATE_REASONS'),(5198,'STR_LATE_REASON_ALREADY_EXISTS_WITH_THAT_NAME'),(5199,'STR_ABOUT'),(5200,'STR_BY_NOGUSKA_LLC'),(5201,'STR_DB_UPDATE'),(5202,'STR_ALREADY_CALCULATED'),(5203,'STR_ARE_YOU_SURE_YOU_WISH_TO_DELETE_THIS'),(5204,'STR_ARE_YOU_SURE_YOU_WISH_TO_UNPOST_THIS'),(5205,'STR_DELETED'),(5206,'STR_ACTIVATE_THIS_ACCOUNT'),(5207,'STR_ARE_YOU_SURE_YOU_WISH_TO_REACTIVATE_THIS'),(5208,'STR_ADD_A_NEW_PO'),(5209,'STR_ADD_A_NEW_PO_FROM_BID'),(5210,'STR_ADD_CUSTOM_PO_DETAILS'),(5211,'STR_ADD_PO_DETAILS'),(5212,'STR_UPDATE_CUSTOM_PO_DETAILS'),(5213,'STR_UPDATE_PO_INFORMATION'),(5214,'STR_ERROR_DURING_DELETE'),(5215,'STR_ENTER_SHIPMENTS'),(5216,'STR_FOR_ORDER_NUMBER'),(5217,'STR_IF_MULTIPLE_PKGS'),(5218,'STR_INPUT_OR_SEARCH'),(5219,'STR_NUM_PKGS'),(5220,'STR_PRINTORDER_LOOKUP'),(5221,'STR_QTY_PER_PKG'),(5222,'STR_QTY_REMAIN'),(5223,'STR_QTY_SENT'),(5224,'STR_SHIPPING_FOR_ORDER_NUMBER'),(5225,'STR_SHIPTO'),(5226,'STR_CURRENT_DUE_DATE'),(5227,'STR_ACCOUNT_ACTIVATED_SUCCESSFULLY'),(5228,'STR_ACCOUNT_ALREADY_EXISTS_REACTIVATING'),(5229,'STR_ERROR_ACTIVATING_ACCOUNT'),(5230,'STR_CHECK_IN_OUT'),(5231,'STR_CUSTOMER_ADD_UPDATE'),(5232,'STR_CUSTOMER_LOGIN_ACCESS'),(5233,'STR_FILL_START_STOP'),(5234,'STR_NEW_SHIPMENT'),(5235,'STR_ORDER_ENTRY'),(5236,'STR_PROCESSING_STATUS'),(5237,'STR_UNAVAILABLE'),(5238,'STR_VIEW_SHIPPED'),(5239,'STR_RANK'),(5240,'STR_TOP_SELLING_ITEMS'),(5241,'STR_VIEW_ITEM_DETAIL_HISTORY_REPORT'),(5242,'STR_BILLS_OVERDUE_DUE_SOON_DUE_LATER'),(5243,'STR_PG'),(5244,'STR_CHANGING_TO_MOST_RECENT_MONTH'),(5245,'STR_NUM_IMPRESSIONS'),(5246,'STR_PCT_IMPRESSIONS'),(5247,'STR_PCT_ORDERS'),(5248,'STR_PRINT_ON_TIME_STATISTICS'),(5249,'STR_PRINT_ORDER_STATISTICS_FOR'),(5250,'STR_STARTING_DATE_AFTER_END_DATE'),(5251,'STR_TOTAL_ITEM'),(5252,'STR_BILLED_DATE_RANGE'),(5253,'STR_CLICK_TO_VIEW_SHIPMENTS'),(5254,'STR_CLOSED_ORDER_REPORT'),(5255,'STR_FINISHED_DATE_RANGE'),(5256,'STR_FINISH_DATE'),(5257,'STR_THE_FOLLOWING_ORDERS_WERE_COMPLETED_FROM'),(5258,'STR_ORDER_DESCRIPTION'),(5259,'STR_UNCONFIRMED_PRINT_SHOP_ORDERS'),(5260,'STR_CANNOT_DELETE_THE_DEFAULT_INVENTORY_LOCATION_MUST_CHANGE_DEFAULT_FIRST'),(5261,'STR_PERFORMANCE_STATS_15DAYS'),(5262,'STR_PERFORMANCE_STATS_30DAYS'),(5263,'STR_PERFORMANCE_STATS_60DAYS'),(5264,'STR_PERFORMANCE_STATS_90DAYS'),(5265,'STR_DIRECT_DEPOSIT_FORM_PRINTOUT'),(5266,'STR_DIRECTION_DEPOSIT_AUTHORIZATION_FORM'),(5267,'STR_DIRECT_DEPOSIT_AUTH'),(5268,'STR_REQUIRED_ENTRY'),(5269,'STR_THIS_TAX_ENTERED_ALREADY_NOT_SAVING'),(5270,'STR_PO_ALREADY_EXISTS'),(5271,'STR_IMPORT'),(5272,'STR_DEFAULT_DIRECT_DEPOSIT_TRANSACTION_DESCRIPTION'),(5273,'STR_AS_IT_APPEARS_ON_ACH_CONTRACT'),(5274,'STR_COMPANY_IDENTIFICATION'),(5275,'STR_DIRECT_DEPOSIT_INFORMATION'),(5276,'STR_IMMEDIATE_DESTINATION_NAME'),(5277,'STR_IMMEDIATE_DESTINATION_ROUTING_NUMBER'),(5278,'STR_IMMEDIATE_ORIGIN_NAME'),(5279,'STR_IMMEDIATE_ORIGIN_ROUTING_NUMBER'),(5280,'STR_SEND_PRENOTES'),(5281,'STR_ADD_SP'),(5282,'STR_FACTORY_ORDER'),(5283,'STR_MAXIMUM_SHEET_SIZE'),(5284,'STR_MINIMUM_SHEET_SIZE'),(5285,'STR_PAYROLL_HOME_PAGE'),(5286,'STR_DATABASE_INFORMATION'),(5287,'STR_HELP_ADD_UPDATE'),(5288,'STR_USER_RIGHTS'),(5289,'STR_VERSION_INFORMATION'),(5290,'STR_NO_RATINGS'),(5291,'STR_ARE_YOU_SURE_YOU_WISH_TO_DELETE_CARRIER_AND_VENDOR'),(5292,'STR_ARE_YOU_SURE_YOU_WISH_TO_DELETE_JUST_CARRIER'),(5293,'STR_DELETE_CARRIER_AND_VENDOR'),(5294,'STR_DELETE_CARRIER_BUT_SAVE_VENDOR'),(5295,'STR_ARE_YOU_SURE_VENDOR_TO_CARRIER'),(5296,'STR_RECENT_ACCOUNTS_ENTERED'),(5297,'STR_ADD_GL_ACCOUNT'),(5298,'STR_CUSTOM_FREQUENCY_DAYS'),(5299,'STR_DAILY'),(5300,'STR_ERROR_INSERTING_PAYPLAN'),(5301,'STR_ERROR_UPDATING_PAYPLAN'),(5302,'STR_FIRST_PAYMENT_DATE'),(5303,'STR_FREQUENCY'),(5304,'STR_MONTHLY'),(5305,'STR_NUMBER_OF_TIMES_TO_INVOICE'),(5306,'STR_PAYMENT_PLAN_ADD'),(5307,'STR_PLAN_INVOICE_NUMBER'),(5308,'STR_QUARTERLY'),(5309,'STR_WEEKLY'),(5310,'STR_YEARLY'),(5311,'STR_CLICK_ON_PAYMENT_PLAN_INVOICE_TO_EDIT'),(5312,'STR_CUSTOM_DAYS'),(5313,'STR_ERROR_DELETING_PAYMENT_PLAN'),(5314,'STR_FIRST_PAYMENT_INVOICE_DATE'),(5315,'STR_INVOICES_GENERATED'),(5316,'STR_NEXT_PAYMENT_DUE'),(5317,'STR_NEXT_PAYMENT_DUE_DATE'),(5318,'STR_NUMBER_OF_TIMES'),(5319,'STR_PAYMENT_PLAN_DELETED_SUCCESSFULLY'),(5320,'STR_PAYMENT_PLAN_UPDATE'),(5321,'STR_PAYPLAN_INVOICE_NUMBER'),(5322,'STR_PAYPLAN_NUMBER'),(5323,'STR_TOTAL_PLAN_AMOUNT'),(5324,'STR_ADD_UPDATE_PAYMENT_PLAN'),(5325,'STR_CREATE_A_NEW_PAYMENT_PLAN'),(5326,'STR_UPDATE_A_PAYMENT_PLAN'),(5327,'STR_ERROR_INSERTING_PAYPLAN_DETAILS'),(5328,'STR_PAYMENT_PLAN_LIST'),(5329,'STR_NEXT_DUE_DATE'),(5330,'STR_NO_MATCHING_PAYMENT_PLAN_FOUND'),(5331,'STR_NUM_TIMES_INVOICED'),(5332,'STR_PLAN_NUMBER'),(5333,'STR_SHOW_PLANS'),(5334,'STR_SUMMARY_TOTALS_BY_PLAN'),(5335,'STR_TIMES_REMAINING'),(5336,'STR_TOTAL_PAYMENT_PLANS'),(5337,'STR_TOTAL_PER_TIME'),(5338,'STR_TOTAL_REMAINING'),(5339,'STR_INCLUDE_WHICH'),(5340,'STR_PAYMENT_NUMBER'),(5341,'STR_PAYMENT_PLAN'),(5342,'STR_PAYMENT_PLAN_INVOICES_TO_BE_PRINTED'),(5343,'STR_POST_PAYMENT_PLANS'),(5344,'STR_POST_PLANS_DUE_THROUGH'),(5345,'STR_UPDATED_BY_ANOTHER_USER_AFTER_YOU_STARTED_CHANGES'),(5346,'STR_CREATE_AND_EDIT_GENERAL_LEDGER_JOURNAL_ENTRIES'),(5347,'STR_CREATE_AND_UPDATE_NEW_INVOICES'),(5348,'STR_ENTER_AND_UPDATE_NEW_ORDERS'),(5349,'STR_SUMMARY_LISTS_OF_INVOICES_AGING_DETAIL_REPORT'),(5350,'STR_MODIFY_DISPLAY_TEXT'),(5351,'STR_AR_INVOICE_PAYMENT_VOID'),(5352,'STR_UNABLE_TO_VOID'),(5353,'STR_VOID_SELECTIONS'),(5354,'STR_BY_INVOICE_NUMBER'),(5355,'STR_BY_PAYMENT'),(5356,'STR_VOID_PAYMENTS'),(5357,'STR_VOID_PAYMENTS_ENTERED'),(5358,'STR_CASHOPTION'),(5359,'STR_CASHOPTION_VALUE'),(5360,'STR_COST_OF_GOODS_AMOUNT'),(5361,'STR_ERROR_INSERTING_NON_INVOICE_PAYMENT'),(5362,'STR_ERROR_IN_STEP'),(5363,'STR_EXEMPT_REASON'),(5364,'STR_GL_COST_OF_GOODS_SOLD'),(5365,'STR_PAID_HOW'),(5366,'STR_PAYMENT_DATE'),(5367,'STR_SALES_WITHOUT_INVOICE'),(5368,'STR_SALES_WITHOUT_INVOICE_ADD'),(5369,'STR_TAXABLE_SALE_AMOUNT'),(5370,'STR_TAX_EXEMPT_SALE_AMOUNT'),(5371,'STR_WILL_NOT_PROCESS_CREDIT_CARD_PAYMENTS'),(5372,'STR_CREATE_UPDATE_A_NEW_PAYMENT_PLAN'),(5373,'STR_THIS_SALES_RECEIPT_ALREADY_IN_DATABASE'),(5374,'STR_BEGIN_PAYMENT_DATE'),(5375,'STR_CLICK_ON_SALES_RECEIPT_ID_TO_EDIT'),(5376,'STR_END_PAYMENT_DATE'),(5377,'STR_NON_INVOICED_SALES'),(5378,'STR_VOIDED'),(5379,'STR_OR_UPDATED_BY_ANOTHER_USER_WHILE_BEING_EDITED'),(5380,'STR_ENTER_SALES_RECEIPTS_WHEN_NO_INVOICE'),(5381,'STR_NON_INVOICED_SALES_REPORT'),(5382,'STR_CLICK_TO_EDIT'),(5383,'STR_REPORT_OF_SALES_RECEIPTS_WITHOUT_INVOICES'),(5384,'STR_ALL_IN_RANGE'),(5385,'STR_MISC_RECEIPTS'),(5386,'STR_BAD_DEBT'),(5387,'STR_BAD_DEBT_WRITEOFF'),(5388,'STR_REFUNDED_CREDIT'),(5389,'STR_LINE_ITEM_DESCRIPTION'),(5390,'STR_CHECK_CREATION_FAILED'),(5391,'STR_BEFORE_DISCOUNT'),(5392,'STR_ENTER_MANUAL_CHECK'),(5393,'STR_ERROR_CREATING_CHECK'),(5394,'STR_MANUAL_CHECK_CREATED_SUCCESSFULLY'),(5395,'STR_WRITE_CHECK'),(5396,'STR_MANUAL_CHECKS'),(5397,'STR_WRITE_CHECKS_MANUALLY_WITHOUT_FIRST_ENTERING_BILL'),(5398,'STR_BAD_TRANSACTION_CODE'),(5399,'STR_ACH_FILE_ID'),(5400,'STR_ACH_REPORT'),(5401,'STR_AMOUNT_RANGE'),(5402,'STR_BANK'),(5403,'STR_CREATED_BY'),(5404,'STR_DATE_DOWNLOADED'),(5405,'STR_DATE_TO_USE'),(5406,'STR_DISPLAY'),(5407,'STR_DOWNLOAD'),(5408,'STR_DOWNLOAD_HISTORY'),(5409,'STR_EFFECTIVE_DATE'),(5410,'STR_EMPLOYEE_ID'),(5411,'STR_ERROR_WHILE_PROCESSING_CHECK_SEARCH_OPTIONS'),(5412,'STR_FILES_FOUND'),(5413,'STR_FILE_CONTENTS'),(5414,'STR_FILE_CREATION_DATE'),(5415,'STR_ROUTING_NUMBER'),(5416,'STR_SEARCH_OPTIONS'),(5417,'STR_SEARCH_RESULTS'),(5418,'STR_TOTAL_CREDITS'),(5419,'STR_TOTAL_DEBITS'),(5420,'STR_TOTAL_RECORDS'),(5421,'STR_TRACE_NUMBER'),(5422,'STR_TRANSACTION_TYPE'),(5423,'STR_VIEW_FILE_CONTENTS'),(5424,'STR_CANCELED'),(5425,'STR_DISPLAY_TRANSACTIONS'),(5426,'STR_SHOW_CANCELED'),(5427,'STR_ACCOUNT_INFO_SAVED_SUCCESSFULLY'),(5428,'STR_ACH_FILE_DATE'),(5429,'STR_ACH_FILE_NUMBER'),(5430,'STR_BANK_ACCOUNT'),(5431,'STR_BANK_ACCOUNT_ADD_UPDATE'),(5432,'STR_BANK_ACCOUNT_DELETED_SUCCESSFULLY'),(5433,'STR_BANK_ACCOUNT_NUMBER'),(5434,'STR_BANK_ACCOUNT_TYPE'),(5435,'STR_BANK_ADDRESS'),(5436,'STR_BANK_CITY'),(5437,'STR_BANK_CONTACT_NAME'),(5438,'STR_BANK_INFO_CANCELED'),(5439,'STR_BANK_NAME'),(5440,'STR_BANK_PHONE'),(5441,'STR_BANK_ROUTING_NUMBER'),(5442,'STR_BANK_STATE'),(5443,'STR_BANK_ZIP'),(5444,'STR_DEFAULT_ACCOUNT'),(5445,'STR_NO_BANK_ACCOUNTS_ENTERED'),(5446,'STR_PRENOTE_DETAILS'),(5447,'STR_PRENOTE_OK'),(5448,'STR_ROUTING_MUST_BE_9_DIGITS'),(5449,'STR_SAVINGS'),(5450,'STR_SET_AS_DEFAULT'),(5451,'STR_YOU_MUST_ENTER_ROUTING_AND_ACCOUNT'),(5452,'STR_BANK_INFORMATION'),(5453,'STR_DIRECT_DEPOSIT'),(5454,'STR_DIRECT_DEPOSIT_NOTIFICATION'),(5455,'STR_SHOW_CANCELED_FILES'),(5456,'STR_CLICK_TO_VIEW_INVOICE'),(5457,'STR_CUSTOMER_NUM'),(5458,'STR_TOTAL_DUE'),(5459,'STR_CONTINUED_ON_NEXT_PAGE'),(5460,'STR_CREATE_DIRECT_DEPOSIT_FILE'),(5461,'STR_DIRECT_DEPOSIT_CANNOT_BE_USED'),(5462,'STR_DIRECT_DEPOSIT_TRANSACTION_DESCRIPTION'),(5463,'STR_DOWNLOAD_DIRECT_DEPOSIT_FILE'),(5464,'STR_PRINT_DIRECT_DEPOSIT_STUBS'),(5465,'STR_YOU_MUST_ENTER_A_DD_DESCRIPTION'),(5466,'STR_PRINT_ENTIRE_GROUP_OF_INVOICES'),(5467,'STR_REPRINT_INVOICES'),(5468,'STR_REPRINT_SPECIFIC_OR_GROUPS_OF_INVOICES'),(5469,'STR_BEGIN_INVOICE_DATE'),(5470,'STR_END_INVOICE_DATE'),(5471,'STR_INVOICE_NUMBER_RANGE'),(5472,'STR_INVOICE_REPRINT'),(5473,'STR_INVOICE_REPRINT_SELECTION'),(5474,'STR_PRINT_ALL_INVOICES_IN_GROUP'),(5475,'STR_CLICK_TO_PRINT'),(5476,'STR_NO_DETAIL_ENTRIES'),(5477,'STR_CUSTOMER_PICKUP'),(5478,'STR_DELIVER_TO'),(5479,'STR_DEPOSIT_WITH_ORDER'),(5480,'STR_ESTIMATE_GIVEN'),(5481,'STR_ORDER_TICKET'),(5482,'STR_SERVICE_NEEDED'),(5483,'STR_SERVICE_ORDER_ADD'),(5484,'STR_ITEM_NOTES'),(5485,'STR_LEAVE_BLANK_IF_NOT_FROM_INVENTORY'),(5486,'STR_FULFILLMENT_ORDERS'),(5487,'STR_ORDER_VOLUME_REPORT'),(5488,'STR_SERVICE_ORDERS'),(5489,'STR_SERVICE_ORDER_REPORT'),(5490,'STR_SERVICE_ORDER_VOLUME_DETAILS'),(5491,'STR_FULFILLMENT_ORDER'),(5492,'STR_SERVICE_ORDER'),(5493,'STR_FULFILLMENT'),(5494,'STR_POINT_OF_SALE'),(5495,'STR_OH'),(5496,'STR_ADD_UPDATE_FULFILLMENT_ORDER'),(5497,'STR_ADD_UPDATE_SERVICE_ORDER'),(5498,'STR_ENTER_AND_UPDATE_NEW_FULFILLMENT_ORDERS'),(5499,'STR_ENTER_AND_UPDATE_NEW_SERVICE_ORDERS'),(5500,'STR_CUSTOMER_MENU_DESC'),(5501,'STR_FRINGES_PERCENT_ADDON_SERVICE_ORDER'),(5502,'STR_FULFILLMENT_ORDER_ADD'),(5503,'STR_ADD_MORE_LINES'),(5504,'STR_FULFILLMENT_ORDER_UPDATE'),(5505,'STR_MORE_LINES'),(5506,'STR_SERVICE_CLASS'),(5507,'STR_SERVICE_CLASS_ALREADY_EXISTS_BY_THAT_NAME'),(5508,'STR_SERVICE_CLASS_UPDATE'),(5509,'STR_SERVICE_TYPE'),(5510,'STR_HOURLY_RATE'),(5511,'STR_MUST_ENTER_SERVICE_TYPES_AND_SERVICE_CLASSES_FIRST'),(5512,'STR_SERVICE_RATES_UPDATE'),(5513,'STR_SERVICE_TYPE_ALREADY_EXISTS_BY_THAT_NAME'),(5514,'STR_SERVICE_TYPE_UPDATE'),(5515,'STR_ENTER_SERVICE_ORDER_CLASSES_OF_LABOR'),(5516,'STR_ENTER_SERVICE_ORDER_TYPES_OF_WORK'),(5517,'STR_LABOR_RATES_FOR_SERVICE_ORDER_TYPES_AND_CLASSES'),(5518,'STR_SERVICE_CLASSES'),(5519,'STR_SERVICE_ORDER_LABOR_RATES'),(5520,'STR_SERVICE_TYPES'),(5521,'STR_CALCULATOR'),(5522,'STR_PATIENTS'),(5523,'STR_PATIENT_MENU_DESC'),(5524,'STR_BELOW_REORDER'),(5525,'STR_ON_PO'),(5526,'STR_QUANTITIES'),(5527,'STR_SUGGESTED_ORDER'),(5528,'STR_ORDER_NOW'),(5529,'STR_ASSIGN_SORT_ORDER_TO_CARRIERS_AND_METHODS'),(5530,'STR_CARRIER_AND_METHOD_DISPLAY_ORDER'),(5531,'STR_ASSIGN_DISPLAY_ORDER'),(5532,'STR_INVOICE_DEFAULT_MESSAGE'),(5533,'STR_INVOICE_DEFAULT_PRICE_UNIT'),(5534,'STR_INVOICE_DEFAULT_SELL_UNIT'),(5535,'STR_INVOICE_DEFAULT_SELL_UNITS_PER_PRICE_UNIT'),(5536,'STR_CLIENT_PO'),(5537,'STR_DEFAULT_COST_PER_HOUR'),(5538,'STR_FILL_IN_ONLY_IF_VENDOR_USED_AS_CONTRACTOR_FOR_SERVICE_ORDER_WORK'),(5539,'STR_NOT_A_CONTRACTOR'),(5540,'STR_NOT_A_SERVICE_WORKER'),(5541,'STR_SERVICE_WORKER_CLASS'),(5542,'STR_VIEW_DIRECT_DEPOSIT_STUB'),(5543,'STR_VOID_TRANSACTION'),(5544,'STR_CHECK_WRITTEN_SUCCESSFULLY'),(5545,'STR_DEPOSIT_CHECK_ALREADY_CREATED'),(5546,'STR_ERROR_OCCURRED_WHILE_WRITING_CHECK'),(5547,'STR_WRITE_PAYROLL_DEPOSIT_CHECK'),(5548,'STR_CANCELLATION_METHOD_NOT_RECOGNIZED'),(5549,'STR_CHOOSE_METHOD_OF_CANCELLATION'),(5550,'STR_DIRECT_DEPOSIT_TRANSACTION_VOID'),(5551,'STR_DIRECT_DEPOSIT_TRANSACTION_VOID_EXPLANATION_1'),(5552,'STR_DIRECT_DEPOSIT_TRANSACTION_VOID_EXPLANATION_2'),(5553,'STR_DIRECT_DEPOSIT_TRANSACTION_VOID_EXPLANATION_3'),(5554,'STR_DIRECT_DEPOSIT_TRANSACTION_VOID_EXPLANATION_4'),(5555,'STR_ERROR_OCCURRED_DURING_TRANSACTION_PROCESSING'),(5556,'STR_OPTIONAL_ASSIGN_ERROR_CODE'),(5557,'STR_TRANSACTION_CHANGES_MADE_SUCCESSFULLY'),(5558,'STR_VOID_ALL_TRANSACTIONS_AND_CALCULATIONS_IN_THIS_FILE'),(5559,'STR_VOID_ALL_TRANSACTIONS_CALCULATIONS_AND_PAY_DATA_IN_THIS_FILE'),(5560,'STR_VOID_THIS_TRANSACTION_AND_CALCULATIONS_ONLY'),(5561,'STR_VOID_THIS_TRANSACTION_CALCULATIONS_AND_PAY_DATA_ONLY'),(5562,'STR_DIRECT_DEPOSIT_FILES'),(5563,'STR_VIEW_AND_DOWNLOAD_DIRECT_DEPOSIT_FILES'),(5564,'STR_FILE_ID'),(5565,'STR_COULD_NOT_FIND_RECORD'),(5566,'STR_INVOICE_FORMAT'),(5567,'STR_STANDARD_PRINT'),(5568,'STR_SUPRESS_HEADER_FOR_PREPRINT'),(5569,'STR_YOUR_PO'),(5570,'STR_ANY'),(5571,'STR_AUTO_INSERTED'),(5572,'STR_INSERT_SUCCESSFUL'),(5573,'STR_ITEMS_NEEDING_REORDER'),(5574,'STR_MUST_SELECT_SPECIFIC_VENDOR'),(5575,'STR_OUR_ITEM_CODE'),(5576,'STR_REPORT_FORMAT'),(5577,'STR_VENDOR_PO_SUGGESTION'),(5578,'STR_ERROR_DURING_INSERT'),(5579,'STR_IN_SELL_UNITS'),(5580,'STR_DUE_BY'),(5581,'STR_SHIP_VIA'),(5582,'STR_TO_NAME'),(5583,'STR_CLIENT'),(5584,'STR_PKGS'),(5585,'STR_INCLUDED_IN_DEPOSIT_CHECK'),(5586,'STR_NOT_INCLUDED_IN_DEPOSIT_CHECK'),(5587,'STR_SERVICE_ORDER_UPDATE'),(5588,'STR_WORK_ORDER'),(5589,'STR_SERVICE_NOTES'),(5590,'STR_DEPOSIT_PAID_WITH_ORDER'),(5591,'STR_BO_QTY'),(5592,'STR_COLOR_LIST_SIDE_ONE'),(5593,'STR_COLOR_LIST_SIDE_TWO'),(5594,'STR_NO_OF_COLORS_SIDE_ONE'),(5595,'STR_NO_OF_COLORS_SIDE_TWO'),(5596,'STR_NO_OF_PAGES'),(5597,'STR_WORK_TURN'),(5598,'STR_IPH_UNITS'),(5599,'STR_LINEAR_FEET'),(5600,'STR_MAXIMUM_COLORS_ONE_SIDED_PRINTING'),(5601,'STR_MAXIMUM_COLORS_SIDE_ONE_WHEN_TWO_SIDED_PRINTING'),(5602,'STR_MAXIMUM_COLORS_SIDE_TWO_WHEN_TWO_SIDED_PRINTING'),(5603,'STR_MINIMUM_COLORS_THIS_PRESS'),(5604,'STR_SQ_FEET'),(5605,'STR_NO_OF_SIGNATURES'),(5606,'STR_PAGES_PER_SIGNATURE'),(5607,'STR_NUMBER_OF_COLORS_SIDE_ONE'),(5608,'STR_NUMBER_OF_COLORS_SIDE_TWO'),(5609,'STR_PAGES_PER_SIG'),(5610,'STR_SIGNATURES'),(5611,'STR_ADD_PARTS'),(5612,'STR_CURRENT_WORK_FOR_SERVICE_ORDERS'),(5613,'STR_E'),(5614,'STR_START_STOP'),(5615,'STR_TIME_ENTRY_FOR_SERVICE_ORDERS'),(5616,'STR_V'),(5617,'STR_WORKER'),(5618,'STR_AUTOMATIC_BY_CLOSE_YEAR'),(5619,'STR_CLOSED_SUCCESSFULLY'),(5620,'STR_CLOSE_PERIOD'),(5621,'STR_CLOSE_YEAR_FOR'),(5622,'STR_MUST_CREATE_A_RETAINED_EARNINGS_TYPE_ACCOUNT'),(5623,'STR_CLOSE_YEAR'),(5624,'STR_INVOICE_FORMAT_UNITPRICE'),(5625,'STR_SUPPRESS_UNIT_PRICE_COLUMN'),(5626,'STR_ISTAXABLE_SERVICE_LABOR'),(5627,'STR_SERVICESALES_LABOR'),(5628,'STR_ALL_USERS'),(5629,'STR_MY_WORK_ONLY'),(5630,'STR_SERVICE_ORDER_TIME_TRACKER'),(5631,'STR_SPECIFIC_ORDER'),(5632,'STR_POST_TIME_TO_ORDER'),(5633,'STR_RATE_PER_HOUR'),(5634,'STR_SAVE_CHANGES_BEFORE_SELECTING_NEW_ORDER'),(5635,'STR_SERVICE_ORDER_TIME_EDITOR'),(5636,'STR_TOTAL_LABOR_CHARGES'),(5637,'STR_WORK_FOR_SERVICE_ORDERS'),(5638,'STR_CREATE_INVOICE'),(5639,'STR_EDIT_SERVICE_ORDER_TIME_AND_POST'),(5640,'STR_EDIT_TIME'),(5641,'STR_FULFILLMENT_ORDER_PROCESSING'),(5642,'STR_LOG_HOURS_ON_SERVICE_ORDERS'),(5643,'STR_LOG_TIME'),(5644,'STR_SERVICE_ORDER_PROCESSING'),(5645,'STR_VIEW_ORDER_DETAILS'),(5646,'STR_NO_UNBILLED'),(5647,'STR_PRINT_INVOICES'),(5648,'STR_NO_LOCATION_SPECIFIED'),(5649,'STR_SERVICE_REQUESTED'),(5650,'STR_ADD_LABOR_TIME_TO_ORDER'),(5651,'STR_EDIT_POST_UNPOSTED_HOURS'),(5652,'STR_INVOICE_NOW'),(5653,'STR_SAVE_CHANGES_BEFORE_CLICKING'),(5654,'STR_THIS_ORDER_HAS_BEEN_COMPLETED'),(5655,'STR_VIEW_LABOR_TIME'),(5656,'STR_SERVICE_ORDER_TIME_VIEWER'),(5657,'STR_ACCOUNT_LOOKUP'),(5658,'STR_SORT_BY_ACCOUNT_NUMBER'),(5659,'STR_SORT_BY_DESCRIPTION'),(5660,'STR_LITE'),(5661,'STR_CUSTOMER_DEPOSITS'),(5662,'STR_UNIT_NAME_FOR_LABOR_HOURS'),(5663,'STR_SERVICE_ORDER_DEPOSIT'),(5664,'STR_NO_WORK_IN_PROGRESS'),(5665,'STR_SERVICE_ORDER_LOG_TIME'),(5666,'STR_START_TIME'),(5667,'STR_WORKERS_CURRENTLY_LOGGED'),(5668,'STR_CURRENTLY_WORKING_ON_SERVICE_ORDERS'),(5669,'STR_SERVICE_ORDER_ADD_DEPOSIT'),(5670,'STR_ADD_DEPOSIT'),(5671,'STR_PAID_ON_DEPOSIT'),(5672,'STR_ORDERS_NEAR_OR_OVER_ESTIMATE'),(5673,'STR_CHARGES_TODATE'),(5674,'STR_NO_ORDERS_NEAR_OR_OVER_ESTIMATE'),(5675,'STR_OPEN_ORDER_LIST'),(5676,'STR_SERVICE_ORDERS_NEAR_OR_OVER_ESTIMATE'),(5677,'STR_ORDERS_OVER_ESTIMATE'),(5678,'STR_VIEW_COMPLETED_ORDER_DETAILS_SHIPPED'),(5679,'STR_OVER_ESTIMATE_ORDERS_LIST'),(5680,'STR_UNPOSTED_VOUCHERS_PRIOR_TO_YEAR_END'),(5681,'STR_YOU_HAVE'),(5682,'STR_EMAIL_INVOICE'),(5683,'STR_ATTACHED_IS_YOUR_INVOICE'),(5684,'STR_EMAIL_TYPE'),(5685,'STR_NEW_EMAIL'),(5686,'STR_SELECT_EMAIL_ADDRESSES_TO_SEND_TO'),(5687,'STR_SEND_EMAIL_TO_THIS_ADDRESS'),(5688,'STR_SALES_REFUNDS'),(5689,'STR_REFUND'),(5690,'STR_AMOUNT_OF_REFUND_CHECK'),(5691,'STR_INCLUDE_IN_CHECK'),(5692,'STR_REFUND_AMOUNT'),(5693,'STR_REFUND_CREDIT'),(5694,'STR_REFUND_CREDIT_BY_CHECK'),(5695,'STR_WRITE_CHECK_FOR_CREDIT_BALANCE'),(5696,'STR_WRITE_CHECK_TO_CANCEL_CREDIT_BALANCE_ON_CUSTOMER_ACCOUNT'),(5697,'STR_EMAIL_COMMENT'),(5698,'STR_SELECT_VENDOR_FILE'),(5699,'STR_VENDORS_IMPORTED'),(5700,'STR_VENDOR_FILE_COLUMN_FORMAT'),(5701,'STR_VERBAL_TERMS'),(5702,'STR_IMPORT_VENDORS'),(5703,'STR_IMPORT_VENDOR_LIST_INTO_NOLAPRO'),(5704,'STR_TO_UNCASH_CHECK_ENTER_CHECK_NUMBER'),(5705,'STR_CONTRIBUTION'),(5706,'STR_MEDICARE_TAX'),(5707,'STR_MISC'),(5708,'STR_MISC_NON_TAXABLE_PAY'),(5709,'STR_NO_ACTIVE_EMPLOYEES'),(5710,'STR_PAYROLL_EMPLOYEE_PAY_AND_DEDUCTIONS_UPDATE'),(5711,'STR_HIDE_VOUCHERS'),(5712,'STR_SHOW_VOUCHERS'),(5713,'STR_UNPOSTED_VOUCHERS'),(5714,'STR_MUST_BE_ZERO_TO_DELETE'),(5715,'STR_EIC_TAX'),(5716,'STR_ADD_UPDATE_EMPLOYEE_PAY_AND_DEDUCTION_INFORMATION'),(5717,'STR_ADD_UPDATE_EMPLOYEE_PAY_DED'),(5718,'STR_CLICK_TO_SHIP'),(5719,'STR_CLICK_TO_VIEW_PDF'),(5720,'STR_CUSOTMER_NO'),(5721,'STR_ITEM_NO'),(5722,'STR_PRINT_HTML_VERSION'),(5723,'STR_SHIP_TO_SOLD_TO'),(5724,'STR_UPGRADE'),(5725,'STR_CC_PROCESSOR'),(5726,'STR_NONE_MANUAL'),(5727,'STR_DEFAULT_PRICE_LEVEL'),(5728,'STR_PRINT_QUOTE_FOR_ORDER'),(5729,'STR_COST_PER_SHEET'),(5730,'STR_SERVICE_ORDER_TIME_REPORT'),(5731,'STR_SHOW_NOTES'),(5732,'STR_SPECIFIC_WORKER'),(5733,'STR_TIME_REPORT'),(5734,'STR_TIME_REPORT_FOR_SERVICE_ORDER_WORK'),(5735,'STR_DIFFICULT'),(5736,'STR_DIFFICULT_PRINT_EXPLANATION'),(5737,'STR_EASY'),(5738,'STR_EASY_PRINT_EXPLANATION'),(5739,'STR_NORMAL_PRINT_EXPLANATION'),(5740,'STR_PRESS_DIFFICULTY'),(5741,'STR_DIFFICULT_PRINT'),(5742,'STR_EASY_PRINT'),(5743,'STR_NORMAL_PRINT'),(5744,'STR_ORIENTATION_TYPE'),(5745,'STR_ORIENTATION_TYPES'),(5746,'STR_ENTRY_ALREADY_EXISTS'),(5747,'STR_ERROR_ADDING_ENTRY'),(5748,'STR_ORIENTATION_TYPE_ADD'),(5749,'STR_PRINT_ORIENTATION_TYPE'),(5750,'STR_PRINT_STANDARD_WORKTYPES'),(5751,'STR_SETUP_ORIENTATION_TYPE'),(5752,'STR_SETUP_PRINT_STANDARD_WORKTYPES'),(5753,'STR_YTD'),(5754,'STR_SHIPMENT_RELEASE_DATES'),(5755,'STR_SELECT_WHICH_QUANTITY'),(5756,'STR_TO_MAKE_INTO_ORDER'),(5757,'STR_CHARGE_INTEREST_0_EQUALS_NO'),(5758,'STR_DEFAULT_PRICE_LEVEL_DESCRIPTION'),(5759,'STR_DEFAULT_SHIP_VIA'),(5760,'STR_GL_SALES_ACCOUNT_DESCRIPTION'),(5761,'STR_SALESMAN_NAME'),(5762,'STR_SALES_TAX_NAME'),(5763,'STR_SERVICEREP_NAME'),(5764,'STR_SHIPTO_FIRSTNAME'),(5765,'STR_SHIPTO_LASTNAME'),(5766,'STR_THE_FOLLOWING_CUSTOMERS_ALREADY_EXIST_IN_SYSTEM'),(5767,'STR_SCHEDULED_SHIPMENTS_DUE'),(5768,'STR_STANDARD_SHIPPING'),(5769,'STR_PURCHASE_ORDER_FORMAT'),(5770,'STR_NON_PO_ONLY'),(5771,'STR_PO_ONLY'),(5772,'STR_PURCHASES_RECEIVED_LIST'),(5773,'STR_TEXT_IN_NOTES'),(5774,'STR_WHICH_RECEIPTS'),(5775,'STR_INVENTORY_PO_RECEIVE'),(5776,'STR_IMPORT_MY_ACCOUNTS'),(5777,'STR_INDUSTRY_STANDARD_ACCOUNT_SETS'),(5778,'STR_IMPORT_ACCOUNTS_INTO_STANDARD_INDUSTRY_TABLE'),(5779,'STR_IMPORT_INDUSTRY_STANDARD_ACCOUNTS_INTO_SETUP_TABLE'),(5780,'STR_INDUSTRY_CODE'),(5781,'STR_INDUSTRY_DESCRIPTION'),(5782,'STR_IMPORT_MY_ACCOUNT_LIST'),(5783,'STR_RECURRING_GL_JOURNAL_ENTRIES_ADD'),(5784,'STR_ERROR_DURING_POST'),(5785,'STR_LAST_POSTED_DATE'),(5786,'STR_NO_MATCHES_FOUND'),(5787,'STR_POSTED_SUCCESSFULLY'),(5788,'STR_POST_RECURRING_JOURNAL_ENTRIES'),(5789,'STR_GL_RECURRING_JOURNAL_ENTRIES_UPDATE'),(5790,'STR_LAST_POSTED_ON'),(5791,'STR_NO_RECURRING_VOUCHER_SELECTED'),(5792,'STR_RECURRING_VOUCHER'),(5793,'STR_UPDATE_RECURRING_VOUCHER_INFORMATION'),(5794,'STR_WORD_IN_DESCRIPTION'),(5795,'STR_ADD_UPDATE_RECURRING_ENTRIES'),(5796,'STR_ENTER_UPDATE_RECURRING_ENTRIES'),(5797,'STR_POST_RECURRING_ENTRIES'),(5798,'STR_POST_RECURRING_LEDGER_ENTRIES'),(5799,'STR_RECURRING_LEDGER_ENTRIES'),(5800,'STR_BEGINNING_BALANCE_INVOICE_ADD'),(5801,'STR_ORIGINAL_INVOICE_DATE'),(5802,'STR_WILL_NOT_AFFECT_GL'),(5803,'STR_BEGINNING_BALANCE_OFFSET_ENTRY'),(5804,'STR_ADD_BEGINNING_BALANCES'),(5805,'STR_ENTER_BEGINNING_BALANCE_INVOICES_FOR_STATUP_ONLY'),(5806,'STR_BEGINNING_BALANCES_SAVED_CLICK_BELOW_TO_APPLY'),(5807,'STR_BEGINNING_INVENTORY_BALANCES'),(5808,'STR_CREATE_WORKSHEET_ENTER_COUNTS'),(5809,'STR_ITEM_BEGINNING_BALANCES'),(5810,'STR_REVIEW_AND_APPLY'),(5811,'STR_APPLY'),(5812,'STR_NO_BEGINNING_BALANCES_FOUND'),(5813,'STR_RECORDS_WERE_APPLIED_SUCCESSFULLY'),(5814,'STR_RECORDS_WERE_UPDATED_SUCCESSFULLY'),(5815,'STR_REVIEW_AND_APPLY_BEGINNING_BALANCE_ENTRIES'),(5816,'STR_DEFAULT_PO'),(5817,'STR_BEGINNING_BALANCES'),(5818,'STR_ENTER_BEGINNING_ONHAND_FOR_INVENTORY'),(5819,'STR_COST_PER_STOCK_UNIT'),(5820,'STR_ENTER_ACCOUNTS_MANUALLY'),(5821,'STR_PROMOS_OK_0_EQUALS_NO'),(5822,'STR_CURRENT_ACTIVE_ACCOUNTS'),(5823,'STR_NO_ACCOUNTS_ASSIGNED_YET'),(5824,'STR_SCROLL_DOWN'),(5825,'STR_CLICK_HERE_TO_VIEW_STANDARD_ACCOUNTS'),(5826,'STR_CATEGORIES'),(5827,'STR_SUB_CATS'),(5828,'STR_VIEW_ALL'),(5829,'STR_VIEW_CATEGORIES'),(5830,'STR_STANDARD_ACCOUNT_LAYOUTS'),(5831,'STR_CATEGORY_HAS_CHILDREN_CANNOT_DELETE'),(5832,'STR_CREATE_NEW_CATEGORY'),(5833,'STR_ERROR_ADDING_CATEGORY'),(5834,'STR_ERROR_UPDATING_CATEGORY'),(5835,'STR_SEARCH_CATEGORY_ADD_UPDATE'),(5836,'STR_SEARCH_CATEGORY_PARENT_SELECTION_MESSAGE'),(5837,'STR_VIEW_STANDARD_ACCOUNT_SETS'),(5838,'STR_BANK_DEPOSIT_ADD'),(5839,'STR_DEPOSIT_DATE'),(5840,'STR_GENERAL_LEDGER_ENTRIES'),(5841,'STR_NON_INVOICE_PAYMENTS'),(5842,'STR_BANK_DEPOSIT_ADD_UPDATE'),(5843,'STR_CASH_WITHDRAWAL'),(5844,'STR_DEPOSIT_FROM_PETTY_CASH'),(5845,'STR_TOTAL_DEPOSIT'),(5846,'STR_QUOTE_PRINT'),(5847,'STR_SAVE_AS_QUOTE'),(5848,'STR_FULFILLMENT_ORDER_QUOTES'),(5849,'STR_QUOTE_TOTAL'),(5850,'STR_CLOSED_ORDERS_ONLY'),(5851,'STR_CONVERT_TO_ORDER'),(5852,'STR_PENDING_FULFILLMENT_ORDER_QUOTES'),(5853,'STR_PENDING_FULFILLMENT_QUOTES'),(5854,'STR_NEW_FULFILLMENT_QUOTES'),(5855,'STR_CATEGORY_USAGE'),(5856,'STR_HIERARCHY'),(5857,'STR_PARALLEL_LABELS'),(5858,'STR_ITEM_FAMILY'),(5859,'STR_BANK_DEPOSIT_ID'),(5860,'STR_DEPOSIT_ALREADY_SUBMITTED'),(5861,'STR_LESS_CASH_RECEIVED'),(5862,'STR_PRINT_DEPOSIT_SLIP'),(5863,'STR_SUB_TOTAL'),(5864,'STR_COD'),(5865,'STR_OPEN_ACCOUNT'),(5866,'STR_PAYPAL'),(5867,'STR_ALREADY_DELETED_OR_CLEARED_THROUGH_BANK'),(5868,'STR_BANK_DEPOSIT_HISTORY'),(5869,'STR_BEGIN_DEPOSIT_DATE'),(5870,'STR_DELETE_SUCCESSFUL'),(5871,'STR_DEPOSIT_ID'),(5872,'STR_DEPOSIT_NOT_FOUND'),(5873,'STR_END_DEPOSIT_DATE'),(5874,'STR_NO_MATCHING_RECORDS_FOUND'),(5875,'STR_ON_BANK_STATEMENT'),(5876,'STR_RECORD_NOT_FOUND'),(5877,'STR_CANNOT_CHANGE'),(5878,'STR_DEPOSITED'),(5879,'STR_CREATE_OR_UPDATE_BANK_DEPOSITS'),(5880,'STR_PRODUCT_WEBSITE'),(5881,'STR_REMEMBER_HTTP'),(5882,'STR_ACH'),(5883,'STR_ACH_DEPOSITS_PENDING'),(5884,'STR_ADJUSTED_BANK_BALANCE'),(5885,'STR_AMOUNT_TO_RECONCILE'),(5886,'STR_BANK_STATEMENT_ENDING_BALANCE'),(5887,'STR_BANK_STATEMENT_RECONCILIATION'),(5888,'STR_BANK_STATEMENT_RECONCILIATION_WORKSHEET'),(5889,'STR_COMPUTER_BALANCE'),(5890,'STR_DEPOSITS_PENDING'),(5891,'STR_END_BANKSTATEMENT_DATE'),(5892,'STR_ON_STATEMENT_YES_NO'),(5893,'STR_RECEIPTS_NOT_DEPOSITED'),(5894,'STR_REMAINING_ACH_DEPOSITS_NOT_ON_STATEMENT'),(5895,'STR_REMAINING_DEPOSITS_NOT_ON_STATEMENT'),(5896,'STR_TOTAL_UNCASHED_CHECKS_AND_ACH_PAYMENTS'),(5897,'STR_UNCASHED_CHECKS_AND_ACH_PAYMENTS'),(5898,'STR_BANK_RECONCILIATION'),(5899,'STR_BANK_RECONCILIATION_WORKSHEET'),(5900,'STR_ACCT'),(5901,'STR_DEPOSIT_TO'),(5902,'STR_CHECKNUMBER'),(5903,'STR_QTY_PENDING'),(5904,'STR_IMPORT_NEW_INCOME_RECORDS'),(5905,'STR_SERVICE_ORDERS_OVER_ESTIMATE'),(5906,'STR_SERVICE_ORDER_EDIT_POST_TIME'),(5907,'STR_SERVICE_ORDER_SETUPS'),(5908,'STR_MIN_DISPLAY_QUANTITY'),(5909,'STR_MIN_DISPLAY_QUANTITY_DESCRIPTION'),(5910,'STR_CC_FIRSTNAME'),(5911,'STR_CC_HOLD_EXPLANATION'),(5912,'STR_CC_LASTNAME'),(5913,'STR_PLEASE_ENTER_CREDIT_CARD_EXPIRATION_MONTH'),(5914,'STR_PLEASE_ENTER_CREDIT_CARD_EXPIRATION_YEAR'),(5915,'STR_PLEASE_ENTER_CREDIT_CARD_FIRSTNAME'),(5916,'STR_PLEASE_ENTER_CREDIT_CARD_LASTNAME'),(5917,'STR_PLEASE_ENTER_CREDIT_CARD_NUMBER'),(5918,'STR_PROCESS_CREDIT_CARD'),(5919,'STR_CC_TRANSACTIONID'),(5920,'STR_ERROR_PROCESSING_PAYMENT'),(5921,'STR_FROM_MANUAL_PROCESS'),(5922,'STR_FULFILLMENT_ORDER_DEPOSIT'),(5923,'STR_PAYMENT_METHOD_CHANGED'),(5924,'STR_RUN_CREDIT_CARD_TRANSACTION'),(5925,'STR_TRANSACTION_NOT_PROCESSED'),(5926,'STR_TRANSACTION_SUCCESSFUL'),(5927,'STR_CREDIT_CARD_PAYMENT_OPTIONS'),(5928,'STR_SET_UP_CREDIT_CARD_PROCESSING'),(5929,'STR_CLICK_BELOW_TO_ENTER_NOW'),(5930,'STR_GO'),(5931,'STR_INVOICE_TERMS_IS_MISSING'),(5932,'STR_DEPOSIT_CC_HOLD_EXPLANATION'),(5933,'STR_NO_WORK_FOUND_FOR_SERVICE_ORDER'),(5934,'STR_PAID_TO_DATE'),(5935,'STR_PAYMENT_DETAIL'),(5936,'STR_BACK_TO_ORDER_UPDATE'),(5937,'STR_AHS_DATA_IMPORT'),(5938,'STR_AHS_DATA_IMPORT_DESC'),(5939,'STR_BANK_ADDRESS_CSZ'),(5940,'STR_BLANK_CHECK_STOCK'),(5941,'STR_CHECK_PRINTING'),(5942,'STR_DETAILED_BANK_INFO'),(5943,'STR_FOR_DIRECT_DEPOSIT_AND_CHECK_PRINTING'),(5944,'STR_FRACTIONAL_ROUTING_NUMBER'),(5945,'STR_PREPRINTED_CHECK_STOCK'),(5946,'STR_ACCOUNT_NUMBER_REQUIRED'),(5947,'STR_BANK_ADDRESS_REQUIRED'),(5948,'STR_BLANK_CHECKS_DIMENSIONS'),(5949,'STR_BLANK_CHECKS_USE_FORMS'),(5950,'STR_CHECK_LOGO'),(5951,'STR_DELETE_LOGO'),(5952,'STR_FRACTIONAL_ROUTING_NUMBER_REQUIRED'),(5953,'STR_MUST_BE_JPEG_OR_PNG_FORMAT'),(5954,'STR_PREPRINTS_USE_DELUXE_FORM'),(5955,'STR_ROUTING_NUMBER_REQUIRED'),(5956,'STR_AR_FILE_UPLOAD_INFO'),(5957,'STR_NO_COMPANY_FOUND'),(5958,'STR_PATH_AND_FILE_NAME_FOR_IMPORT_FILE'),(5959,'STR_CHECK_TITLE_AMOUNT'),(5960,'STR_CHECK_TITLE_DATE'),(5961,'STR_CHECK_TITLE_ORDER_OF'),(5962,'STR_CHECK_TITLE_PAY'),(5963,'STR_CHECK_TITLE_TO_THE'),(5964,'STR_NO_FILENAME_AND_PATH_ENTERED'),(5965,'STR_DETAIL_REPORT'),(5966,'STR_RECEIVED_ORDER_LIST_FOR'),(5967,'STR_LISTS_OF_ORDERS_RECEIVED'),(5968,'STR_ORDER_PROFITABILITY_REPORT'),(5969,'STR_INCOME_STATEMENT'),(5970,'STR_VIEW_INCOME_STATEMENT'),(5971,'STR_INCOME_SUMMARY'),(5972,'STR_DEFAULT_CATEGORY_FOR_FULFILLMENT_ORDERS'),(5973,'STR_DEFAULT_CATEGORY_FOR_INVOICES'),(5974,'STR_DEFAULT_CATEGORY_FOR_SALES_RECEIPTS_WITHOUT_INVOICE'),(5975,'STR_DEFAULT_CATEGORY_FOR_SERVICE_ORDERS'),(5976,'STR_SALES_CATEGORY_UPDATE'),(5977,'STR_SALES_CATEGORY_ADD'),(5978,'STR_ADJ_COST'),(5979,'STR_ADJ_INVOICE_AMT'),(5980,'STR_DEPOSITS'),(5981,'STR_FULFILLMENT_ORDERS_ONLY'),(5982,'STR_LABOR_BILLED'),(5983,'STR_LABOR_COST'),(5984,'STR_NET_PROFIT'),(5985,'STR_ONLY'),(5986,'STR_OTHER_BILLED'),(5987,'STR_OTHER_COST'),(5988,'STR_RECEIPTS_WITHOUT_INVOICE'),(5989,'STR_SALES_PROFITABILITY_REPORT'),(5990,'STR_SELECT_GROUP'),(5991,'STR_SELECT_SALES_CATEGORY'),(5992,'STR_SERVICE_ORDERS_ONLY'),(5993,'STR_TOTAL_PAYMENTS_RECEIVED_FROM_ORDERS'),(5994,'STR_ADD_NEW_STATE'),(5995,'STR_DELETE_STATE'),(5996,'STR_EDIT_STATE'),(5997,'STR_SAVE_ADD_STATE'),(5998,'STR_SELECT_ANOTHER_STATE'),(5999,'STR_STATE_DELETED_SUCCESSFULLY'),(6000,'STR_STATE_SAVED_SUCCESSFULLY'),(6001,'STR_STATE_ADDED_SUCCESSFULLY'),(6002,'STR_STATE_UC'),(6003,'STR_STATE_ADD_UPDATE'),(6004,'STR_STATE_ADD_UPDATE_TEXT'),(6005,'STR_PRINT_ALL_CHECKS_IN_LIST'),(6006,'STR_DATE_ALWAYS_USED_IF_UNPOSTED_ONLY'),(6007,'STR_POSTED_ON'),(6008,'STR_POSTED_ON_DATE'),(6009,'STR_POSTED_TO'),(6010,'STR_POSTED_TO_DATE'),(6011,'STR_USE_WHICH_DATES'),(6012,'STR_FULFILLMENT_ORDER_ENTRY'),(6013,'STR_VIDEO_EXPLANATION'),(6014,'STR_VOID_DATE'),(6015,'STR_COVERS'),(6016,'STR_THROUGH'),(6017,'STR_DISPLAY_COVERAGE_END_WITH_DUE_DATE_OF_INVOICE'),(6018,'STR_DISPLAY_COVERAGE_START_WITH_DUE_DATE_OF_INVOICE'),(6019,'STR_DO_NOT_DISPLAY_COVERAGE'),(6020,'STR_INCLUDE_COVERAGE_PERIOD'),(6021,'STR_SHOW_COVERAGE_PERIOD'),(6022,'STR_INCLUDE_NON_INVOICE_PAYMENTS'),(6023,'STR_BLANK_CHECK_ADJUSTMENT'),(6024,'STR_CHECK_ADJUSTMENTS_EXPLANATION'),(6025,'STR_HORIZONTAL_ADJUST'),(6026,'STR_REQUIRED_FOR_DIRECT_DEPOSIT'),(6027,'STR_VERTICAL_ADJUST'),(6028,'STR_CHECK_ADJUSTMENTS_EXPLANATION2'),(6029,'STR_NAME_AND_ADDRESS_LEFT_SIDE'),(6030,'STR_BACK_TO_ORDER'),(6031,'STR_BACK_TO_SEARCH'),(6032,'STR_CLICK_HERE_FOR_ONLINE_HELP'),(6033,'STR_TEXT_BASED_HELP'),(6034,'STR_TRAINING_VIDEOS'),(6035,'STR_ORDER_STATUS_OPTIONS_ADD'),(6036,'STR_ADD_NEW_STATUS_OPTION'),(6037,'STR_DELETE_STATUS_OPTION'),(6038,'STR_ORDER_STATUS_OPTIONS_UPDATE'),(6039,'STR_UNIT_DECIMALS'),(6040,'STR_INTERNAL_NOTE'),(6041,'STR_PRICE_TABLE_FOR_THE_PRICE_LIST'),(6042,'STR_CURRENT_STATUS'),(6043,'STR_PRIVATE_NOTES'),(6044,'STR_ERROR_ADDING_ORDER_STATUS_OPTION'),(6045,'STR_STATUS_DESCRIPTION'),(6046,'STR_SERVICE_ORDER_STATUS_OPTIONS'),(6047,'STR_STATUS_OPTIONS_FOR_SERVICE_ORDERS'),(6048,'STR_CASH_PAYMENT'),(6049,'STR_CREDIT_CARD_PAYMENT'),(6050,'STR_ACH_EFT_PAYMENT'),(6051,'STR_CREDITCARD_PAYMENT'),(6052,'STR_PAY_HOW'),(6053,'STR_CREDITCARD'),(6054,'STR_EFT'),(6055,'STR_PO_NUMBER_CHANGED_DUE_TO_CONFLICT'),(6056,'STR_NO_POST_TO_PO'),(6057,'STR_ATTACHED_IS_ORDER'),(6058,'STR_EMAIL_ORDER'),(6059,'STR_AP_INVOICES_IMPORTED'),(6060,'STR_TOTAL_LABOR'),(6061,'STR_KEEP_DETAIL_NO_NAMES'),(6062,'STR_KEEP_DETAIL_SHOW_NAMES'),(6063,'STR_MAXIMUM_SUMMARIZE'),(6064,'STR_SERVICE_ORDER_SUMMARY_LEVEL'),(6065,'STR_CREDIT_AMOUNT'),(6066,'STR_DEBIT_AMOUNT'),(6067,'STR_GL_ACCOUNT_FILE_COLUMN_FORMAT'),(6068,'STR_SELECT_GL_BALANCES_FILE'),(6069,'STR_PREPRINTED_CHECK_STOCK_STYLE2'),(6070,'STR_IMPORT_GL_TOTALS'),(6071,'STR_RETURN_CHECK'),(6072,'STR_CHECK_RETURNED'),(6073,'STR_RETURNED_CHECK'),(6074,'STR_UNABLE_TO_MARK_RETURNED'),(6075,'STR_BREAK'),(6076,'STR_CALIPER'),(6077,'STR_COAST_PAPER_ITEM_FILE_COLUMN_FORMAT'),(6078,'STR_GRAIN'),(6079,'STR_HEIGHT'),(6080,'STR_LIST_WHEN_SEARCHING'),(6081,'STR_PAPER_FILE_IMPORTED'),(6082,'STR_PIECES_IN_SET'),(6083,'STR_QUICKPRINTADJ'),(6084,'STR_SELECT_COAST_PAPER_FILE'),(6085,'STR_SETTINGS'),(6086,'STR_SHEETS_PER_CARTON'),(6087,'STR_SHEETS_PER_PACKAGE'),(6088,'STR_SHEETS_PER_SKID'),(6089,'STR_STANDARDJ'),(6090,'STR_STOCKTYPE'),(6091,'STR_USE_PRICE_BREAKS'),(6092,'STR_WEIGHTTYPE'),(6093,'STR_IMPORT_COAST_PAPER_INVENTORY_FILES'),(6094,'STR_IMPORT_COAST_PAPER_INVENTORY_FILES_GENERATED_USING_FRANKLIN_EXPORT_FORMAT'),(6095,'STR_PURCHASE_ORDER_DEFAULT_MESSAGE'),(6096,'STR_ERROR_ADDING_NOTES_FOR_INVOICES'),(6097,'STR_INVOICE_NOTES_ADD'),(6098,'STR_INVOICE_NOTES_ADDED_SUCCESSFULLY'),(6099,'STR_SELECTION_NAME_FOR_NOTE'),(6100,'STR_ADD_NEW_NOTE'),(6101,'STR_ERROR_DELETING_NOTES'),(6102,'STR_ERROR_UPDATING_INVOICE_NOTES'),(6103,'STR_INVOICE_NOTE'),(6104,'STR_INVOICE_NOTES_UPDATE'),(6105,'STR_INVOICE_NOTES_UPDATED_SUCCESSFULLY'),(6106,'STR_NOTES_DELETED_SUCCESSFULLY'),(6107,'STR_ERROR_ADDING_NOTES'),(6108,'STR_NOTES_ADDED_SUCCESSFULLY'),(6109,'STR_PO_NOTES_ADD'),(6110,'STR_ERROR_UPDATING_NOTES'),(6111,'STR_NOTES_UPDATED_SUCCESSFULLY'),(6112,'STR_PO_NOTES_UPDATE'),(6113,'STR_GL_SALES_ACCOUNT_FOR_COMPOSITION'),(6114,'STR_GL_SALES_ACCOUNT_FOR_RUSH_CHARGES'),(6115,'STR_EDIT_TEXT'),(6116,'STR_ENTRY_NAME'),(6117,'STR_NOTES_TO_PRINT_ON_PAGES_FOLLOWING_MAIN_INVOICE'),(6118,'STR_ORDER_AFTER_INVOICE'),(6119,'STR_EDIT_INVOICE_NOTE_TEXT'),(6120,'STR_EDIT_PURCHASE_ORDER_NOTE_TEXT'),(6121,'STR_CLIENT_NAME'),(6122,'STR_NOTES_TO_PRINT_ON_PAGES_FOLLOWING_MAIN_PURCHASE_ORDER'),(6123,'STR_ORDER_AFTER_PO'),(6124,'STR_ENTER_STANDARD_NOTES_TO_BE_SELECTED_FOR_PRINT_ON_PAGES_FOLLOWING_MAIN_PO'),(6125,'STR_INVOICE_NOTES'),(6126,'STR_PO_STANDARD_NOTES'),(6127,'STR_REPRINT_SHIP'),(6128,'STR_REPRINT_SHIPPING_DOCUMENTS'),(6129,'STR_SELECTABLE_NOTES_FOR_PAGES_FOLLOWING_INVOICE'),(6130,'STR_MAIN_PAGE_NOTE'),(6131,'STR_SELECT_AP_INVOICE_FILE'),(6132,'STR_ADDITIONAL_HOURS_ENTRY_THIS_EMPLOYEE'),(6133,'STR_CHECK_NUMBER_LOWER_THAN_LAST_NUMBER_USED'),(6134,'STR_CHECK_NUMBER_SELECTED_IS_LOWER_THAN_LAST_NUMBER_USED'),(6135,'STR_SKIPS_IN_CHECK_NUMBERING'),(6136,'STR_QUOTE_TO'),(6137,'STR_CHECK_NUMBERS_SKIPPED_DURING_RUN'),(6138,'STR_ORDER_AMOUNT'),(6139,'STR_REMAINING_AMOUNT'),(6140,'STR_DEFAULT_SHIPPING_METHOD'),(6141,'STR_VENDOR_CODE'),(6142,'STR_VENDOR_LEAD_TIME'),(6143,'STR_ACCOUNTED_FOR_ON_BANK_DEPOSIT'),(6144,'STR_BILL_PAYMENT'),(6145,'STR_CUSTOMER_DEPOSIT'),(6146,'STR_ENTERED_DIRECTLY_INTO_GENERAL_LEDGER'),(6147,'STR_INVENTORY_RECEIPT'),(6148,'STR_INVOICE_ENTRY'),(6149,'STR_INVOICE_PAYMENT'),(6150,'STR_PAYROLL_CHECK'),(6151,'STR_PAYROLL_TAX_DEPOSIT_CHECK'),(6152,'STR_UNPOST_THIS_VOUCHER'),(6153,'STR_VENDOR_INVOICE'),(6154,'STR_VOUCHER_DETAIL'),(6155,'STR_WITHOUT_PO'),(6156,'STR_CHECK_FOR_YES'),(6157,'STR_ONLY_USED_IF_TAXING_ON_SHIPTO_ADDRESS'),(6158,'STR_TAX_SHIPTO'),(6159,'STR_ADDITIONAL_CHARGE'),(6160,'STR_ADDITIONAL_DESCRIPTION'),(6161,'STR_TRACKING_NUMBERS'),(6162,'STR_CUSTOMER_SEARCH_INFORMATION'),(6163,'STR_ENTER_PART_OR_ALL_OF_ANY_KNOWN_INFORMATION_FOR_SEARCH'),(6164,'STR_ZIP_CODE'),(6165,'STR_CHECK_ALL'),(6166,'STR_FILE'),(6167,'STR_FILES_DELETED_SUCCESSFULLY'),(6168,'STR_FILES_UPLOADED'),(6169,'STR_FILES_UPLOADED_TO_DATE'),(6170,'STR_FILES_WITH_ERRORS'),(6171,'STR_LIMIT'),(6172,'STR_NO_FILES_WERE_SELECTED'),(6173,'STR_VIEW_UPLOAD_DELETE'),(6174,'STR_YOU_MUST_DELETE_A_FILE_BEFORE_UPLOADING_A_NEW_ONE'),(6175,'STR_NO_FILE_DEFINITION_HAS_BEEN_SET'),(6176,'STR_UPLOAD_FILES'),(6177,'STR_AP_ADJUSTMENT'),(6178,'STR_AMT_PER_PAY_PERIOD'),(6179,'STR_EMPLOYER_FLAT_RATE_AMOUNT'),(6180,'STR_EMPLOYER_PERCENT_IN_ADDITION_TO_MATCHES'),(6181,'STR_FROM_ABOVE_UP_TO_PERCENT'),(6182,'STR_PERCENT_MATCHED_BY_EMPLOYER'),(6183,'STR_UP_TO_EMPLOYEE_PERCENT'),(6184,'STR_AMOUNT_FOR_EXEMPTION_2'),(6185,'STR_AMOUNT_FOR_EXEMPTION_3'),(6186,'STR_AMOUNT_PER_EXEMPTION_OVER_3'),(6187,'STR_CREDIT_FOR_EXEMPTION_2'),(6188,'STR_CREDIT_FOR_EXEMPTION_3'),(6189,'STR_CREDIT_PER_EXEMPTION_OVER_3'),(6190,'STR_MARRIED_FILING_JOINT'),(6191,'STR_MARRIED_FILING_SEPARATE'),(6192,'STR_CHECK_AMOUNT'),(6193,'STR_FROM_NUMBER'),(6194,'STR_DATE_CANCELLED'),(6195,'STR_END_OF_PERIOD_DATE'),(6196,'STR_PRIOR_CLOSINGS'),(6197,'STR_WHO'),(6198,'STR_BAD_DATE'),(6199,'STR_NO_RETURNS_ACCEPTED'),(6200,'STR_PAYROLL_PAYABLE'),(6201,'STR_POST_TO_PERIOD_END_DATE_FOR_EXPENSE_AND_CHECK_DATE_FOR_CHECK_AMOUNT'),(6202,'STR_ADD_NEW_CONTACT'),(6203,'STR_CONTACT_ADDRESS'),(6204,'STR_CONTACT_ADDRESS_DESC'),(6205,'STR_CONTACT_DESC'),(6206,'STR_CONTACT_EMAIL'),(6207,'STR_CONTACT_EMAIL_DESC'),(6208,'STR_CONTACT_PHONE_DESC'),(6209,'STR_CONTACT_UPDATED_SUCCESSFULLY'),(6210,'STR_DELETE_ADDRESS'),(6211,'STR_DELETE_EMAIL'),(6212,'STR_DELETE_PHONE'),(6213,'STR_FIRSTNAME'),(6214,'STR_GENERAL_CONTACT_INFORMATION'),(6215,'STR_LASTNAME'),(6216,'STR_NEW_CONTACT'),(6217,'STR_SELECT_CONTACT'),(6218,'STR_NO_TABLE_INFO_HAS_BEEN_GIVEN'),(6219,'STR_UPDATE_CONTACT_INFO'),(6220,'STR_CONTACT_ADDRESSES'),(6221,'STR_CONTACT_EMAILS'),(6222,'STR_CONTACT_PHONE_NUMBERS'),(6223,'STR_OTHER_CONTACTS'),(6224,'STR_CONTACT_INFO'),(6225,'STR_ADDITIONAL_CONTACT_INFO'),(6226,'STR_DAMAGED'),(6227,'STR_QTY_DAMAGED'),(6228,'STR_CUSTOMER_CODE'),(6229,'STR_SHOW_PROFIT'),(6230,'STR_PROCESSED_HOW'),(6231,'STR_W_X_L'),(6232,'STR_NONPRINT'),(6233,'STR_NAME_AND_ADDRESS_RIGHT_SIDE_WITH_LOGO'),(6234,'STR_MAIN'),(6235,'STR_NONPRINT_STOCK_PROCESS'),(6236,'STR_NON_PRINTED'),(6237,'STR_ADJUSTMENT_AMOUNT'),(6238,'STR_CREATED_SUCCESSFULLY'),(6239,'STR_CHANGED_CHECK_DATE_FROM'),(6240,'STR_CHANGED_INVOICE_DATE_FROM'),(6241,'STR_ALL_CATEGORIES_NO_SEPARATION'),(6242,'STR_ALL_GROUP_BY_SALES_CATEGORY'),(6243,'STR_STATEMENT_FORMAT'),(6244,'STR_STATEMENT_PERIOD_BEGIN_DATE'),(6245,'STR_STATEMENT_PERIOD_END_DATE'),(6246,'STR_CLICK_TO_VIEW_PICKTICKET'),(6247,'STR_ITEMS_ON_ORDER'),(6248,'STR_ITEM_CODE_AND_DESCRIPTION'),(6249,'STR_PICKTICKET_FOR'),(6250,'STR_ATTACHED_IS_YOUR_STATEMENT'),(6251,'STR_BALANCE_FOR'),(6252,'STR_CLICK_TO_VIEW_STATEMENT'),(6253,'STR_EMAIL_STATEMENT'),(6254,'STR_ENCLOSED'),(6255,'STR_PAID_THIS_PERIOD'),(6256,'STR_PAID_TOTAL'),(6257,'STR_STATEMENT'),(6258,'STR_STATEMENT_FOR'),(6259,'STR_TO_CAPS'),(6260,'STR_SUMMARIZE_TO'),(6261,'STR_VENDOR_AGENT_ADD'),(6262,'STR_VENDOR_AGENT_NOT_ADDED'),(6263,'STR_AGENT_NUMBER'),(6264,'STR_VENDOR_AGENT_UPDATE'),(6265,'STR_AGENT_CODE'),(6266,'STR_AGENT_FOR_WHAT_VENDOR'),(6267,'STR_AGENT_FOR_WHAT_VENDOR_RESELLER'),(6268,'STR_AGENT_INFO'),(6269,'STR_FILL_IN_ONLY_IF_RESELLER'),(6270,'STR_FLAT_COMMISSION'),(6271,'STR_PERCENT_COMMISSION'),(6272,'STR_ENTER_UPDATE_VENDOR_AGENT_DATA'),(6273,'STR_PRINT_LISTS_OR_LABELS_OF_VENDOR_AGENTS'),(6274,'STR_VENDOR_AGENT_MAINTENANCE'),(6275,'STR_VENDOR__AGENT_LISTS_LABELS'),(6276,'STR_AGENT_SITE_AND_ADMINISTRATION_OF_AIRPORT_VALET_DATA'),(6277,'STR_AIRPORT'),(6278,'STR_AIRPORTS_ADD_UPDATE'),(6279,'STR_AIRPORT_PARKING_FEES'),(6280,'STR_AIRPORT_SERVICES'),(6281,'STR_AIRPORT_SERVICES_FEES'),(6282,'STR_AIRPORT_VALET_SETUP'),(6283,'STR_GO_TO_AGENT_SITE'),(6284,'STR_SETUPS_FOR_AIRPORT_VALET_SERVICES_AND_RATES'),(6285,'STR_AIRPORT_CODE'),(6286,'STR_AIRPORT_CODE_ALREADY_EXISTS'),(6287,'STR_AIRPORT_NAME'),(6288,'STR_AIRPORT_UPDATE'),(6289,'STR_FOR_ANOTHER_RECORD'),(6290,'STR_AIRPORT_ADD'),(6291,'STR_AIRPORT_ALREADY_EXISTS'),(6292,'STR_ERROR_ADDING_AIRPORT'),(6293,'STR_SERVICE_CATEGORY'),(6294,'STR_AIRPORT_SERVICE_TYPE_UPDATE'),(6295,'STR_ACTIVE_THIS_AIRPORT'),(6296,'STR_AIRPORT_SERVICES_UPDATE'),(6297,'STR_AIRPORT_SERVICES_CATEGORY_UPDATE'),(6298,'STR_AIRPORT_SERVICE'),(6299,'STR_AIRPORT_SERVICES_ADD'),(6300,'STR_AIRPORT_SERVICE_CATEGORIES'),(6301,'STR_AIRPORT_SERVICE_TYPES'),(6302,'STR_SERVICE_CATEGORIES'),(6303,'STR_AIRPORT_FEE_FLAT_CHARGE'),(6304,'STR_AIRPORT_FEE_PERCENT_CHARGE'),(6305,'STR_PARKING_FEES'),(6306,'STR_SERVICE_FEES'),(6307,'STR_CONFIRMATION'),(6308,'STR_EMAIL_CONFIRMATION'),(6309,'STR_ATTACHED_IS_YOUR_ORDER_CONFIRMATION'),(6310,'STR_CLICK_TO_VIEW_ORDER_CONFIRMATION'),(6311,'STR_ORDER_CONFIRMATION'),(6312,'STR_ORDER_UNIT_SIZE'),(6313,'STR_PRICE_UNIT_SIZE'),(6314,'STR_AVAILABLE'),(6315,'STR_INTEREST_DUE'),(6316,'STR_CUSTOMER_BALANCE_HISTORY'),(6317,'STR_CUSTOMER_ACTIVITY_HISTORY'),(6318,'STR_PAYMENT'),(6319,'STR_VOUCHER_OR_INVOICE'),(6320,'STR_INVOICE_TOTAL_HDR'),(6321,'STR_SERVICE_CHARGE_HDR'),(6322,'STR_TOTAL_INTEREST_HDR'),(6323,'STR_NEW_INTEREST_HDR'),(6324,'STR_ADD_NEW_OPTION'),(6325,'STR_ADD_NEW_OPTION_GROUP'),(6326,'STR_CHECKBOX'),(6327,'STR_COST_PER_SALES_UNIT'),(6328,'STR_CURRENT_OPTIONS'),(6329,'STR_DEFAULT_MUST_BE_IN_THE_MIN_TO_MAX_RANGE'),(6330,'STR_DEFAULT_OPTION_FOR_GROUP'),(6331,'STR_DEFAULT_QTY_IF_INDEPENDENT'),(6332,'STR_DEFAULT_QTY_PER_MAIN_ITEM_IF_DEPENDENT'),(6333,'STR_DEPENDENT_ON_MAIN_ITEM_QTY'),(6334,'STR_EDIT_OPTIONS'),(6335,'STR_EDIT_OPTION_GROUP'),(6336,'STR_FIND_ITEM'),(6337,'STR_ITEMOPTIONGROUP_SAVED_SUCCESSFULLY'),(6338,'STR_ITEMOPTION_SAVED_SUCCESSFULLY'),(6339,'STR_MANDATORY'),(6340,'STR_MAX_MUST_BE_GREATER_OR_EQUAL_TO_MIN'),(6341,'STR_MAX_QTY'),(6342,'STR_MIN_QTY'),(6343,'STR_NEW_OPTION'),(6344,'STR_NEW_OPTION_FROM_COPY'),(6345,'STR_NEW_OPTION_GROUP'),(6346,'STR_NONTAXABLE'),(6347,'STR_NO_ROUNDING'),(6348,'STR_OPTION_GROUP'),(6349,'STR_PRICING_UNIT'),(6350,'STR_QTY_ROUNDING'),(6351,'STR_RADIO'),(6352,'STR_REMOVE_ITEM'),(6353,'STR_ROUND_DOWN_TO_WHOLE_QTY'),(6354,'STR_ROUND_UP_TO_WHOLE_QTY'),(6355,'STR_SALES_UNITS_PER_PRICE_UNIT'),(6356,'STR_SELECT_OPTION'),(6357,'STR_SELECT_OPTION_GROUP'),(6358,'STR_USE_ITEM'),(6359,'STR_USE_ITEM_INFO'),(6360,'STR_VALUE_MUST_BE_IN_THE_MIN_MAX_RANGE'),(6361,'STR_YOU_MUST_ENTER_A_NAME'),(6362,'STR_AGENT_LOOKUP'),(6363,'STR_AGENT_NAME'),(6364,'STR_VENDOR_SEARCH_INFORMATION'),(6365,'STR_VENDOR_SUPPLIER_LOOKUP'),(6366,'STR_ITEM_NAME_OR_CODE'),(6367,'STR_ENTER_ITEM_SEARCH_INFORMATION'),(6368,'STR_GENERAL_CATEGORY'),(6369,'STR_SHOPPING_CART_ITEM'),(6370,'STR_OPEN_SELECTION'),(6371,'STR_UNITS_MATCH_BUT_RATIO_IS_NOT_1'),(6372,'STR_ADD_UPDATE_OPTIONS'),(6373,'STR_ITEM_OPTION_GROUPS'),(6374,'STR_NO_GL_ACCOUNT_SELECTED_FOR_AMOUNT'),(6375,'STR_GL_ACCOUNTS_NOT_ENTERED'),(6376,'STR_EDIT_DATABASE_EXPLANATIONS'),(6377,'STR_EDIT_INFORMATION_FOR_TABLE'),(6378,'STR_FIELD'),(6379,'STR_FIELD_LENGTH'),(6380,'STR_FIELD_NAME'),(6381,'STR_FIELD_TYPE'),(6382,'STR_KEY_POINTS_TO_TABLE'),(6383,'STR_KEY_TYPE'),(6384,'STR_TABLE'),(6385,'STR_TABLE_NAME'),(6386,'STR_VALUES_ALLOWED'),(6387,'STR_INFORMATION_FOR_TABLE'),(6388,'STR_LIST_DATABASE_EXPLANATIONS'),(6389,'STR_DATABASE_EXPLANATION'),(6390,'STR_IF_CREDIT_DEBIT_SHOULD_BE_ZERO'),(6391,'STR_IF_DEBIT_CREDIT_SHOULD_BE_ZERO'),(6392,'STR_MUST_BE_NAMED_EXACTLY_AS_EXISTING_GL_ACCT'),(6393,'STR_AVG'),(6394,'STR_CUSTOMER_ITEM_HISTORY_FOR'),(6395,'STR_CUSTOMER_ORDER_HISTORY_FOR'),(6396,'STR_ITEM_CUSTOMER_ORDER_HISTORY_FOR'),(6397,'STR_ADD_LISTS_OF_B2B_VENDOR_USERS'),(6398,'STR_ADD_LISTS_OF_EXTERNAL_B2B_CUSTOMER_USERS'),(6399,'STR_B2B_SITE'),(6400,'STR_CUSTOMER_B2B_LOGIN_USERS'),(6401,'STR_CUSTOMER_ORDER_HISTORY'),(6402,'STR_ITEM_ORDER_HISTORY'),(6403,'STR_MODIFY_B2B_SITE_INFORMATION'),(6404,'STR_VENDOR_B2B_LOGIN_USERS'),(6405,'STR_ITEM_OPTIONS'),(6406,'STR_COMPANY_FOR_SHOPPING_CART'),(6407,'STR_ITEMOPTIONGROUP_ADD_UPDATE'),(6408,'STR_ITEM_OPTION_GROUPS_SAVED_SUCCESSFULLY'),(6409,'STR_OPTIONS_FOR'),(6410,'STR_OPTIONS_FOR_ITEMS_ADD_UPDATE'),(6411,'STR_ITEM_CODE_ITEM_ID'),(6412,'STR_ITEMOPTION_ADD_UPDATE'),(6413,'STR_OPTION_CODE'),(6414,'STR_CUSTOMER_PURCHASE_HISTORY'),(6415,'STR_ITEM_PURCHASE_HISTORY'),(6416,'STR_IS_FREIGHT_TAXABLE'),(6417,'STR_EMPLOYEE_CHECK_ALREADY_WRITTEN_FOR_THIS_PERIOD'),(6418,'STR_MUST_VOID_CHECK_BEFORE_MAKING_CHANGES'),(6419,'STR_B2B_SITE_GRAPHICS'),(6420,'STR_CUSTOMER_B2B_USER_UPDATE'),(6421,'STR_DELETE_THIS_USER_FROM_B2B_ACCESS'),(6422,'STR_VENDOR_B2B_USER_UPDATE'),(6423,'STR_STANDARD_PRINT_WITH_LONG_ITEM_CODES'),(6424,'STR_DEFAULT_INVENTORY_ACCOUNT'),(6425,'STR_WORK_ORDER_NUMBER'),(6426,'STR_DELETE_ALL_COUNTS'),(6427,'STR_QTY_UNITS_PER_PRICE_UNIT2'),(6428,'STR_PREPRINT_OPTION_TWO'),(6429,'STR_CREDITS_APPLIED'),(6430,'STR_CREDIT_APPLIED'),(6431,'STR_OVERPAYMENT_APPLIED'),(6432,'STR_CACHE_LENGTH'),(6433,'STR_CACHE_LENGTHS_UPDATED_SUCCESSFULLY'),(6434,'STR_LAST_UPDATED'),(6435,'STR_MINUTES'),(6436,'STR_SET_REPORT_CACHE_TIMES'),(6437,'STR_HOMEPAGE_REPORT_CACHING'),(6438,'STR_RECENT_EMPLOYEE_REVIEWS'),(6439,'STR_INCLUDE_NON'),(6440,'STR_NON_INVOICED_PAYMENTS_REPORT'),(6441,'STR_DESTINATION'),(6442,'STR_TRACKING_INFO'),(6443,'STR_QUICK_ITEM_LOOKUP'),(6444,'STR_ON_ORDER'),(6445,'STR_AVAILABLE_ABBR'),(6446,'STR_COMMITTED_ABBR'),(6447,'STR_ON_HAND_ABBR'),(6448,'STR_ON_ORDER_ABBR'),(6449,'STR_COMMISSION_EXPENSE'),(6450,'STR_PAY_AGENT'),(6451,'STR_VIEW_BILLS'),(6452,'STR_PAY_VENDOR'),(6453,'STR_ACCESS_RIGHTS_UPDATE_FAILED'),(6454,'STR_SHIPPING_ESTIMATE'),(6455,'STR_NO_UNCONFIRMED_ORDERS_FOUND'),(6456,'STR_ADDITIONAL_DEPOSIT'),(6457,'STR_JOB_ALREADY_SAVED'),(6458,'STR_PRICELIST_ORDER_DEPOSIT'),(6459,'STR_PRIOR_DEPOSIT'),(6460,'STR_BEGIN_QUOTE_ENTRY_DATE'),(6461,'STR_END_QUOTE_ENTRY_DATE'),(6462,'STR_PRINTSHOP_LIST'),(6463,'STR_CUSTOMER_BY_VOLUME'),(6464,'STR_VIEW_CUSTOMERS_BY_VOLUME'),(6465,'STR_CUSTOMERS_BY_SALES'),(6466,'STR_ALL_FIELDS_REQUIRED'),(6467,'STR_DO_NOT_USE_ORDER_NUMBER_AS_BASE_FOR_INVOICE_NUMBER'),(6468,'STR_ACCOUNT_RANGE_BEGIN'),(6469,'STR_ACCOUNT_RANGE_END'),(6470,'STR_GRAND_TOTALS_FOR_ALL_PAGES'),(6471,'STR_GRAND_TOTALS_FOR_THIS_PAGE'),(6472,'STR_IN_GROUP'),(6473,'STR_TOTALS_FOR_ALL_PAGES'),(6474,'STR_TOTALS_FOR_THIS_PAGE'),(6475,'STR_EFT_OR_ACH_PAYMENT_NOT_CHECK'),(6476,'STR_NOT_A_VALID_CHECK'),(6477,'STR_BEGIN_TIME'),(6478,'STR_END_TIME'),(6479,'STR_MINS'),(6480,'STR_ADD_EDIT_ANOTHER_USER'),(6481,'STR_NOT_AUTHORIZED'),(6482,'STR_PRE_CONFIRMATION'),(6483,'STR_NO_MATCHING_PURCHASES_FOUND'),(6484,'STR_PURCHASE_HISTORY'),(6485,'STR_OR_DATE_SERVICE_REQUESTED'),(6486,'STR_ADD_EDIT_USERS'),(6487,'STR_SERVICE_REQUEST'),(6488,'STR_CLICK_TO_CONFIRM'),(6489,'STR_LISTS_AND_CONFIRM_ORDERS_ENTERED_BY_B2B_USERS'),(6490,'STR_ALLOW_FULFILLMENT_ORDERS_ON_B2B_SITE'),(6491,'STR_ALLOW_SERVICE_ORDERS_ON_B2B_SITE'),(6492,'STR_CONFIRMING_ORDER'),(6493,'STR_SERVICE_TICKET'),(6494,'STR_ACCESS_LEVEL'),(6495,'STR_IS_THIS_AN_AGENCY'),(6496,'STR_EFT_ACH'),(6497,'STR_PAYMENT_RECORD'),(6498,'STR_PRINT_ALL_IN_LIST'),(6499,'STR_CASH_PAYMENT_NOT_CHECK'),(6500,'STR_CREDITCARD_PAYMENT_NOT_CHECK'),(6501,'STR_ADD_LINK_TRACKING_ENTRY'),(6502,'STR_ADD_NEW_LINK'),(6503,'STR_EDIT_ANOTHER_LINK'),(6504,'STR_EDIT_LINK'),(6505,'STR_LINK'),(6506,'STR_LINK_ADDED_SUCCESSFULLY'),(6507,'STR_LINK_SAVED_SUCCESSFULLY'),(6508,'STR_SELECT_LINK_TO_EDIT'),(6509,'STR_URL'),(6510,'STR_LINK_DELETED_SUCCESSFULLY'),(6511,'STR_EXISTING_LINKS'),(6512,'STR_NO_LINKS_YET_INSERTED'),(6513,'STR_AGENCY_NAME'),(6514,'STR_AGENT'),(6515,'STR_BILLS_AND_PAYMENTS_FOR'),(6516,'STR_PAYMENT_REPORT'),(6517,'STR_PURCHASE_ORDER_STATUS'),(6518,'STR_SHIP_PO'),(6519,'STR_SHIP_PO_OR_ADD_NOTES'),(6520,'STR_LINK_ADD_UPDATE'),(6521,'STR_LINK_ADD_UPDATE_TEXT'),(6522,'STR_EXTERNAL_LINKS'),(6523,'STR_LINKS'),(6524,'STR_MY_PIE_CHARTS_DESC'),(6525,'STR_PARENT_VENDOR'),(6526,'STR_ON_SCREEN_VENDORAGENT_LIST'),(6527,'STR_TT_VENDORAGENT_LIST'),(6528,'STR_BILL_ADD_BEGINNING_BALANCE'),(6529,'STR_ART_SET'),(6530,'STR_DBL_CHECK'),(6531,'STR_DRILLING'),(6532,'STR_GLUING'),(6533,'STR_NR_PACKS'),(6534,'STR_PILES'),(6535,'STR_SAMPLES'),(6536,'STR_WRAPPING'),(6537,'STR_BEGIN_BILLS'),(6538,'STR_ENTER_BEGINNING_BALANCE_VENDOR_BILLS'),(6539,'STR_ERROR_UPDATING_LANGUAGES_FOR_COMPANY'),(6540,'STR_SELECT_LANGUAGES_FOR_DATA_ENTRY'),(6541,'STR_REVENUE_ENTRY'),(6542,'STR_SETUP_PROFIT_CENTERS'),(6543,'STR_SETUP_REVENUE_INPUT_COLUMNS'),(6544,'STR_SETUP_REVENUE_SHEET_ACCOUNTS'),(6545,'STR_FMS_SETUP'),(6546,'STR_AR_ENTRY'),(6547,'STR_SETUP_VARIABLES'),(6548,'STR_TED_REPORT'),(6549,'STR_WAGE_ENTRY'),(6550,'STR_PAYMENT_CHECKING_ACCOUNT_ADD'),(6551,'STR_PAYMENT_CHECKING_ACCOUNT_UPDATE'),(6552,'STR_BILLS_MUST_BE_PREAPPROVED_BEFORE_PAYMENT'),(6553,'STR_DEFAULT_PAYMENT_TERMS'),(6554,'STR_ONLY_APPLIES_IF_PREAPPROVING_PAYMENT'),(6555,'STR_USE_CUTOFF_APPROVAL_DATE'),(6556,'STR_USE_PREAPPROVAL_DATE'),(6557,'STR_USE_PREAPPROVAL_DATE_AS_CHECK_DATE'),(6558,'STR_GROUP_CODE'),(6559,'STR_VENDOR_GROUPS_ADD'),(6560,'STR_ADD_NEW_GROUP'),(6561,'STR_DELETE_CUSTOMER_GROUP'),(6562,'STR_VENDOR_GROUP'),(6563,'STR_VENDOR_GROUPS_UPDATE'),(6564,'STR_APPLY_TAX_CREDITS_TO_AMOUNTS'),(6565,'STR_CHECK_IF_YES'),(6566,'STR_DELETE_THIS_ENTRY'),(6567,'STR_FLAT_AMOUNT_RESTOCK_FEE_WHEN_RETURNED_IN_THIS_CONDITION'),(6568,'STR_PERCENT_RESTOCK_FEE_WHEN_RETURNED_IN_THIS_CONDITION'),(6569,'STR_POST_TO_DAMAGED_WHEN_RETURNED_IN_THIS_CONDITION'),(6570,'STR_POST_TO_WHAT_GL_ACCOUNT'),(6571,'STR_RMA_ACTIONS'),(6572,'STR_RMA_ACTION_NAME'),(6573,'STR_RMA_CONDITIONS'),(6574,'STR_RMA_CONDITION_NAME'),(6575,'STR_RMA_CREDIT_DESCRIPTION'),(6576,'STR_RMA_CREDIT_DESCTIPTION'),(6577,'STR_RMA_MISC_CREDITS'),(6578,'STR_RMA_REASONS'),(6579,'STR_RMA_REASON_NAME'),(6580,'STR_RMA_SETUPS'),(6581,'STR_WILL_THIS_ACTION_CAUSE_A_NEW_ORDER_TO_BE_GENERATED'),(6582,'STR_SUCCESS'),(6583,'STR_ALLOW_COMMISSIONS_REPORTS_ON_B2B_SITE'),(6584,'STR_ARE_SALES_COMMISSIONS_TERRITORY_BASED'),(6585,'STR_ASSUME_EACH_ITEM_IS_TAXABLE_OR_NON_TAXABLE_FOR_ALL_TAXES_FOR_CUSTOMER'),(6586,'STR_BE_CAREFUL_CHANGING_METHOD_AFTER_INVOICES_AND_ORDERS_ALREADY_ENTERED_MAY_MESS_UP_TAX_REPORTS_AND_INVOICES'),(6587,'STR_DEFAULT_STATEMENT_FORMAT'),(6588,'STR_DO_NOT_AUTO_APPLY_PAYMENTS_TO_OLDEST_INVOICES'),(6589,'STR_HOW_TO_APPLY_TAXES_ON_INVOICE_ORDER_ITEMS'),(6590,'STR_NO_SALES_TAXES_EVER'),(6591,'STR_ORDER_BY_ADDRESS'),(6592,'STR_SALES_TAX_DISTRICT_FOR_WALKINS'),(6593,'STR_SELECT_WHICH_TAXES_APPLY_TO_EACH_ITEM'),(6594,'STR_SHOW_UNIT_PRICE_AND_PRICE_QTY'),(6595,'STR_SIMPLIFIED_FORMAT'),(6596,'STR_STANDARD_FORMAT'),(6597,'STR_TAX_WHO'),(6598,'STR_UNIT_NAME_FOR_RESTOCK_FEES'),(6599,'STR_LIABILITY_TYPE_ACCOUNT'),(6600,'STR_RESTOCK_FEES'),(6601,'STR_CUSTOMER_GROUPS_ADD'),(6602,'STR_CUSTOMER_GROUP'),(6603,'STR_CUSTOMER_GROUPS_UPDATE'),(6604,'STR_ASSIGN_TERRITORY'),(6605,'STR_NO_GL_ACCOUNT_ENTERED'),(6606,'STR_CREDIT_CARD_PROCESSING_SETUP'),(6607,'STR_AMOUNT_PER_M_PER_SIDE_PER_PART'),(6608,'STR_FISCAL_START_MONTH_CHANGED_SUCCESSFULLY'),(6609,'STR_SET_FISCAL_START_MONTH'),(6610,'STR_ENTER_PRICE_OR_SELL_QUANTITY_AND_CALCULATE_OTHER'),(6611,'STR_ENTER_PRICE_QUANTITY_BUT_DISPLAY_SELL_QUANTITY'),(6612,'STR_ENTER_PRICE_QUANTITY_ONLY'),(6613,'STR_ENTER_SELL_QUANTITY_BUT_DISPLAY_PRICE_QUANTITY'),(6614,'STR_ENTER_SELL_QUANTITY_ONLY'),(6615,'STR_WHICH_ENTRY_QUANTITY'),(6616,'STR_CLICK_TO_HIDE_DELETED'),(6617,'STR_CLICK_TO_SHOW_DELETED'),(6618,'STR_NOT_ALL_ROWS_WITH_DATA_HAVE_A_GL_ACCOUNT_SELECTED'),(6619,'STR_FICA_TAXABLE_PAY'),(6620,'STR_DEDUCTION_GROUP_ADD'),(6621,'STR_DEDUCTION_GROUP_UPDATE'),(6622,'STR_REVIEW_RATING_SCALE_ADD'),(6623,'STR_REVIEW_RATING_SCALE_UPDATE'),(6624,'STR_FOR_SERVICE_ORDER_COSTS'),(6625,'STR_POST_TO_PERIOD_END_DATE'),(6626,'STR_W2_ADJUST_SIDE_WHEN_PRINT'),(6627,'STR_W2_ADJUST_TOP_WHEN_PRINT'),(6628,'STR_PAY_TYPE_ADD'),(6629,'STR_PAY_TYPE_UPDATE'),(6630,'STR_BOX_12_QUALIFIED_PLAN'),(6631,'STR_CHECK_RETIREMENT_BOX_ON_W2_PRINT'),(6632,'STR_IF_QUALIFIED_PLAN_LETTER_FOR_W2_PRINT'),(6633,'STR_MISSING_GL_ACCOUNT'),(6634,'STR_WORKERS_COMPENSATION'),(6635,'STR_AMOUNT_FOR_NO_EXEMPTION'),(6636,'STR_ROUND_TAX_DOLLARS'),(6637,'STR_TAX_TYPE_ADD'),(6638,'STR_REPORT_LAST_UPDATED'),(6639,'STR_ACCESS_YOUR_NOLAPROCOM_ACCOUNT_HERE'),(6640,'STR_CHARACTER_ENCODING'),(6641,'STR_CLICK_HERE_TO_GET_YOUR_NOLAEZ_LICENSE'),(6642,'STR_ENTER_YOUR_LICENSE_STRING_HERE'),(6643,'STR_HAVE_YOUR_NOLAEZ_SERIAL_NUMBER_HANDY'),(6644,'STR_LICENSE_DATABASE_INFORMATION'),(6645,'STR_TYPICAL_LOCATIONS'),(6646,'STR_APPROVE_BILLS_FOR_PAYMENT'),(6647,'STR_CREDIT_CARD_ACH_AND_EFT_PAYMENT_SELECTIONS_ARE_FOR_REFERENCE_ONLY'),(6648,'STR_DATE_TO_PAY'),(6649,'STR_DEFAULT_PAY_DATE'),(6650,'STR_EDIT_UNPAID_APPROVED'),(6651,'STR_EXTRA_INTEREST'),(6652,'STR_HOLD_BILL'),(6653,'STR_LEAVE_BLANK_TO_USE_BILL_DUE_DATE'),(6654,'STR_NO_AUTOMATIC_PROCESSING_WILL_TAKE_PLACE'),(6655,'STR_PAYMENT_DATE_WHEN_EDITING'),(6656,'STR_PAY_AMOUNT'),(6657,'STR_PAY_BY'),(6658,'STR_SHOW_ON_HOLD_ONLY'),(6659,'STR_TOTAL_EXCLUDES_ONHOLD_AMOUNTS'),(6660,'STR_INVOICE_NUMBER_ALREADY_EXISTS'),(6661,'STR_PAYABLES_LIST'),(6662,'STR_PENDING_POS'),(6663,'STR_PENDING_PO_TOTALS'),(6664,'STR_POS_RECEIVED_BUT_NOT_IN_PAYABLES_YET'),(6665,'STR_RECEIVED_PO_TOTALS'),(6666,'STR_SHOW_PENDING_POS'),(6667,'STR_SHOW_RECEIVED_POS_NOT_YET_IN_AP'),(6668,'STR_TO_SEE_ALL_OPEN_DO_NOT_SELECT_DATE_RANGES'),(6669,'STR_AS_OF'),(6670,'STR_PREAPPROVE_BILLS'),(6671,'STR_WRITE_CHECKS_FOR_PREAPPROVED'),(6672,'STR_ALL_PAYMENT_DATES_THROUGH'),(6673,'STR_APPROVED_AMOUNT'),(6674,'STR_APPROVED_INTEREST'),(6675,'STR_CHECK_TO_PAY_ON_OLD_ONLY'),(6676,'STR_IF_CHECK_ACCOUNT'),(6677,'STR_PAYMENT_CHECKING_ACCOUNT'),(6678,'STR_TOTAL_TO_PAY'),(6679,'STR_WILL_IGNORE_PAYMENT_DATE_IF_CHECKED'),(6680,'STR_WRITE_CHECKS_FOR_PREAPPROVED_BILLS'),(6681,'STR_NO_MATCHING_OPEN_BILLS_FOUND'),(6682,'STR_AMOUNT_DUE'),(6683,'STR_BASE_REPORT_ON_WHICH_DATE'),(6684,'STR_CASH_REQUIREMENTS_REPORT'),(6685,'STR_CASH_REQUIREMENTS_REPORT_DETAILS'),(6686,'STR_CLICK_TO_EDIT_APPROVAL'),(6687,'STR_FOR_ACCOUNT'),(6688,'STR_PLANNED_PAYMENT_DATE'),(6689,'STR_UP_THRU_WEEK'),(6690,'STR_USING_DUE_DATE'),(6691,'STR_USING_PAYMENT_DATE'),(6692,'STR_WEEK_BEGIN'),(6693,'STR_WEEK_BEGIN_DATES'),(6694,'STR_VENDOR_AGENT_LIST'),(6695,'STR_REF'),(6696,'STR_NO_GL_SALES_ACCOUNT_ENTERED'),(6697,'STR_CARD_TYPE'),(6698,'STR_COLUMNS_TO_DISPLAY'),(6699,'STR_CREDIT_CARD_TRANSACTION_REPORT'),(6700,'STR_REPORT_FILTERS'),(6701,'STR_NO_INVOICE_TERMS_SELECTED'),(6702,'STR_COGS_ACCOUNT'),(6703,'STR_COGS_AMOUNT'),(6704,'STR_INVENTORY_ACCOUNT'),(6705,'STR_INVENTORY_GL_ACCOUNT'),(6706,'STR_SHIPPED_TO'),(6707,'STR_SHIP_FROM_LOCATION'),(6708,'STR_WARNING_MAKING_CHANGES_BELOW_COULD_CAUSE_PROBLEMS_UNLESS_YOU_ARE_SURE_YOU_KNOW_WHAT_YOU_ARE_DOING'),(6709,'STR_ERROR_WITH_INTEREST_FIXING_FILES_REFRESH_SCREEN'),(6710,'STR_TOTAL_PAID'),(6711,'STR_ACCRUED_INTEREST'),(6712,'STR_ERROR_ADDING_INTEREST'),(6713,'STR_ERROR_UPDATING_CC_TRANSACTION_RECORD'),(6714,'STR_INTEREST_INCLUDED'),(6715,'STR_ONLY_SHOW_IF_OVER_XX_DAYS'),(6716,'STR_AMOUNTS_DO_NOT_INCLUDE_ACCRUED_INTEREST'),(6717,'STR_AVERAGE_DAYS_TO_PAY'),(6718,'STR_FIRST_INVOICE'),(6719,'STR_LATEST_INVOICE'),(6720,'STR_LATEST_PAYMENT'),(6721,'STR_PAST_DUE'),(6722,'STR_BEGIN_PAYMENT'),(6723,'STR_END_PAYMENT'),(6724,'STR_SELECT_SALESPERSON'),(6725,'STR_SELECT_SERVICE_REP'),(6726,'STR_TOTAL_ONLY'),(6727,'STR_VIEW_PRINT_STATEMENTS'),(6728,'STR_FOR_SALESMAN'),(6729,'STR_FOR_SERVICE_REP'),(6730,'STR_PENDING_OR_TAKEN'),(6731,'STR_SPECIFIC_SALES_PERSON'),(6732,'STR_SPECIFIC_SERVICE_REP'),(6733,'STR_CHECK_COGS_WHEN_CHANGING_QUANTITY_FOR_ORDER_ITEM'),(6734,'STR_OR_LINE_ITEM_NOTES'),(6735,'STR_SHIP_NOTIFICATION'),(6736,'STR_DISCOUNT_APPLIED'),(6737,'STR_REFUNDED'),(6738,'STR_REFUND_CHECK'),(6739,'STR_OUR_ORDER_NUMBER'),(6740,'STR_REP'),(6741,'STR_SALES_RECEIPT'),(6742,'STR_NO_SHIPTO_ADDRESS_FOUND'),(6743,'STR_AUTHORIZATION_CODE'),(6744,'STR_IF_CC_CARD_CODE'),(6745,'STR_IF_REQUIRED'),(6746,'STR_AMOUNT_IS_HIGHER_THAN_AUTHORIZED'),(6747,'STR_CANNOT_DO_DELAYED_CAPTURE'),(6748,'STR_ERROR_CODE'),(6749,'STR_ORIGINAL_AMOUNT'),(6750,'STR_ORIGINAL_TRANSACTION_ID'),(6751,'STR_PREVIOUSLY_CAPTURED'),(6752,'STR_REDUCING_TRANSACTION_AMOUNT'),(6753,'STR_THIS_TRANSACTION'),(6754,'STR_ORDERS_UNCONFIRMED'),(6755,'STR_CUSTOMER_ITEM_HISTORY'),(6756,'STR_EXCLUDING_SHIPPING_AND_TAX'),(6757,'STR_LABOR_TOTAL'),(6758,'STR_COLOR_BLACK'),(6759,'STR_NOT'),(6760,'STR_COMPLETED_ONLY'),(6761,'STR_NO_MATCHING_RMAS_FOUND'),(6762,'STR_RECEIVED_QTY'),(6763,'STR_RMAC'),(6764,'STR_RMA_DATE'),(6765,'STR_RMA_LIST'),(6766,'STR_RMA_LIST_FOR'),(6767,'STR_RMA_NUMBER'),(6768,'STR_RMA_QTY'),(6769,'STR_ATTACHED_IS_YOUR_QUOTE'),(6770,'STR_SHIPMENT'),(6771,'STR_AVAIL'),(6772,'STR_IF_SELECTING_ALL_ORDERS_MUST_ALSO_ENTER_SOME_OTHER_SEARCH_CRITERIA'),(6773,'STR_OPT'),(6774,'STR_AMOUNT_TENDERED'),(6775,'STR_CHANGE_DUE'),(6776,'STR_CHARGE_AMOUNT'),(6777,'STR_COUNTER_SALE'),(6778,'STR_CUSTOMER_ADDRESS'),(6779,'STR_CUSTOMER_CITY'),(6780,'STR_CUSTOMER_STATE'),(6781,'STR_CUSTOMER_ZIP'),(6782,'STR_ERROR_DURING_SAVE'),(6783,'STR_NEW_SALE'),(6784,'STR_ORDER_TOTAL_INCLUDING_TAX'),(6785,'STR_OR_NEW_CUSTOMER_INFORMATION_OR_EDIT_AFTER_LOOKUP'),(6786,'STR_PAID_BY_CREDITCARD'),(6787,'STR_PAID_CASH'),(6788,'STR_PAID_CHECK'),(6789,'STR_SALESTAX'),(6790,'STR_SEARCH_EXISTING_CUSTOMER'),(6791,'STR_TRANSACTION_APPROVAL_CODE'),(6792,'STR_VERIFICATION'),(6793,'STR_ACTION_EXPECTED'),(6794,'STR_CREATE_RMA'),(6795,'STR_NO_ACTION_HAS_BEEN_SELECTED_ON_LINE'),(6796,'STR_NO_REASON_FOR_RETURN_HAS_BEEN_ENTERED_ON_LINE'),(6797,'STR_NO_SHIPMENT_FOUND'),(6798,'STR_QUANTITY_ENTERED_IS_LESS_THAN_ZERO'),(6799,'STR_QUANTITY_ENTERED_IS_MORE_THAN_QUANTITY_SHIPPED_LESS_PRIOR_RMAS'),(6800,'STR_QUANTITY_PRIOR_RMA'),(6801,'STR_QUANTITY_THIS_RMA'),(6802,'STR_REASON_FOR_RETURN'),(6803,'STR_REPLACEMENT_ITEM'),(6804,'STR_UNSUCCESSFUL'),(6805,'STR_ACTION_TO_TAKE'),(6806,'STR_CONDITION'),(6807,'STR_CREDIT_CLASS'),(6808,'STR_CREDIT_FOR_RMA_NUMBER'),(6809,'STR_DESCRIPTION_MISC_CREDIT'),(6810,'STR_FROM_ORDER'),(6811,'STR_ISSUED_FOR_ORDER_NUMBER'),(6812,'STR_IS_THIS_RMA_NOW_COMPLETE'),(6813,'STR_ITEM_ACTUALLY_RETURNED'),(6814,'STR_NO_CONDITION_HAS_BEEN_SELECTED_ON_LINE'),(6815,'STR_PRINT_CREDIT'),(6816,'STR_PRINT_PICK_TICKET_AND_OR_CONFIRMATION'),(6817,'STR_QUANTITY_ENTERED_IS_LESS_THAN_ALLOWED'),(6818,'STR_QUANTITY_ENTERED_IS_MORE_THAN_QUANTITY_EXPECTED'),(6819,'STR_QUANTITY_ON_RMA'),(6820,'STR_QUANTITY_TO_REPLACE_OR_RESEND'),(6821,'STR_RECEIVED_TODATE'),(6822,'STR_RECEIVE_RMA'),(6823,'STR_REPLACEMENT_RESHIP_FOR_ITEM'),(6824,'STR_RESEND_REPLACEMENT_RMA_NUMBER'),(6825,'STR_RESTOCKING_FEE'),(6826,'STR_RMA'),(6827,'STR_VIEW_RMAS'),(6828,'STR_EDIT_RMA'),(6829,'STR_CLASS'),(6830,'STR_CREATE_NEW_RMA'),(6831,'STR_EXTRA_CHARGES'),(6832,'STR_LINE_ITEMS_IN_SHIPMENT'),(6833,'STR_QUANTITY_RMA'),(6834,'STR_RECEIVE_ITEMS_ON_THIS_RMA'),(6835,'STR_SHIPMENT_ID'),(6836,'STR_SAVE_AND_CONFIRM'),(6837,'STR_THIS_ORDER_IS_UNCONFIRMED'),(6838,'STR_INVOICE_AMT'),(6839,'STR_OVER_90_DAYS'),(6840,'STR_INTEREST_ADDED'),(6841,'STR_NEW_BALANCE'),(6842,'STR_PRIOR_BALANCE'),(6843,'STR_AGENT_AGENCY_COMMISSION_REPORT'),(6844,'STR_COMPLETE_TOTAL'),(6845,'STR_OPEN_TOTAL'),(6846,'STR_ALREADY_IN_USE'),(6847,'STR_CHECKING_FOR_EXISTING_ITEM_CODE'),(6848,'STR_OK_TO_USE_ITEM_CODE'),(6849,'STR_VOIDED_CHECK'),(6850,'STR_COUNTS_DELETED'),(6851,'STR_COMMISSION_AMOUNT'),(6852,'STR_COMMISSION_REPORT'),(6853,'STR_DELIVERY_ZIP'),(6854,'STR_FOR_THE_PERIOD'),(6855,'STR_IMPORT_DATE'),(6856,'STR_NO_COMMISSIONS_FOUND'),(6857,'STR_NO_VENDORS_SELECTED'),(6858,'STR_ORDER_AMT'),(6859,'STR_PAY_COMMISSIONS'),(6860,'STR_PRINT_PDF_FOR_ALL_AFFILIATES'),(6861,'STR_SELLER'),(6862,'STR_DELETE_EXISTING_ORDER'),(6863,'STR_COMBINE_ALL_FOR_ORDER'),(6864,'STR_EMAIL_SHIP_NOTICE'),(6865,'STR_EMAIL_SHIP_NOTIFICATION'),(6866,'STR_PER_HOUR'),(6867,'STR_SEND_ENTIRE_GROUP_OF_CHECKMARKED_EMAILS'),(6868,'STR_AVERAGE_TURNAROUND_DAYS'),(6869,'STR_NO_EMAIL_ADDRESS'),(6870,'STR_NONE_QUOTED'),(6871,'STR_OUR_QUOTE'),(6872,'STR_PLUS_COMPOSITION'),(6873,'STR_PLUS_EST_SHIPPING'),(6874,'STR_PRICE_M'),(6875,'STR_PRINT_TOTAL'),(6876,'STR_TURNAROUND_TIME'),(6877,'STR_NO_FROM_ADDRESS_FOUND'),(6878,'STR_EDIT_FROM_ADDRESS'),(6879,'STR_EMAIL_ACKNOWLEDGEMENT'),(6880,'STR_NEW_ORDER_SAME_CUSTOMER_AND_SHIPTO'),(6881,'STR_NEW_ORDER_SAME_INFO'),(6882,'STR_QTY_PER_FULL_BOX'),(6883,'STR_REPRINT_ORDER'),(6884,'STR_ERROR_DURING_RETRIEVE'),(6885,'STR_ESTIMATED_TO_SHIP_ON_OR_BEFORE'),(6886,'STR_ORDER_ACKNOWLEDGEMENT'),(6887,'STR_ORDER_NOT_FOUND'),(6888,'STR_OUR_JOB'),(6889,'STR_PLUS_SHIPPING'),(6890,'STR_PRINTING_ORDER_ACKNOWLEDGEMENT_EMAIL'),(6891,'STR_SEND_ACKNOWLEDGEMENT'),(6892,'STR_SHIPPING_TO'),(6893,'STR_THANK_YOU_FOR_YOUR_ORDER_WE_APPRECIATE_YOUR_BUSINESS'),(6894,'STR_TOTAL_QUANTITY'),(6895,'STR_CLICK_ON_TRACKING_NUMBER_TO_TRACK_YOUR_PACKAGE'),(6896,'STR_HAS_BEEN_SHIPPED_ON'),(6897,'STR_ORDER_SHIPMENT_NOTIFICATION'),(6898,'STR_SEND_NOTIFICATION'),(6899,'STR_SHIPMENTS_DATE'),(6900,'STR_SHIPMENT_NOTIFICATION'),(6901,'STR_THE_TRACKING_NUMBERS_ARE'),(6902,'STR_PIECEWORK_GROUP'),(6903,'STR_SHOW_ON_EXTERNAL_ORDER'),(6904,'STR_SHOW_ON_EXTERNAL_QUOTE'),(6905,'STR_SHOW_ON_INTERNAL_ORDER'),(6906,'STR_SHOW_ON_INTERNAL_QUOTE'),(6907,'STR_ACTUAL_FROM'),(6908,'STR_DEFAULT_CUSTOMER_FROM'),(6909,'STR_FROM_ADDRESS'),(6910,'STR_FROM_CITY'),(6911,'STR_FROM_NAME'),(6912,'STR_FROM_STATE'),(6913,'STR_FROM_ZIP'),(6914,'STR_INVALID_JOB_NUMBER'),(6915,'STR_USE_DEFAULTS'),(6916,'STR_CHANGE_QTY_PER_BOX'),(6917,'STR_QTY_PER_BOX'),(6918,'STR_DELETE_THIS_ORDER'),(6919,'STR_EST_SHIP_DATE'),(6920,'STR_ORDER_ACKN'),(6921,'STR_SEND_ORDER_ACKNOWLEDGEMENT'),(6922,'STR_COPY_QUOTE'),(6923,'STR_EDIT_JOB'),(6924,'STR_REPRINT_OR_COPY_JOB'),(6925,'STR_SEND_SHIPMENT_ACKNOWLEDGEMENT'),(6926,'STR_SHIP_ACKN'),(6927,'STR_PIECEWORK_GROUP_ALREADY_EXISTS_BY_THAT_NAME'),(6928,'STR_BLACK_IMP'),(6929,'STR_COLOR_IMP'),(6930,'STR_MULTI_COLOR_IMP'),(6931,'STR_NR_ORDERS'),(6932,'STR_PENDING_WORK_REPORT'),(6933,'STR_SORT'),(6934,'STR_NUMBER_PER_BOX'),(6935,'STR_NUM_PER_BOX'),(6936,'STR_CLICK_HERE_C'),(6937,'STR_YOU_SHOULD_AUTOMATICALLY_BE_FORWARDED_TO_LIST'),(6938,'STR_DESCRIPTION_INVALID'),(6939,'STR_GENERAL_LEDGER_SUMMARY_LEVEL_ADD'),(6940,'STR_SUMMARY_LEVEL_DESCRIPTION'),(6941,'STR_GENERAL_LEDGER_SUMMARY_LEVEL_UPDATE'),(6942,'STR_CLICK_TO_HIDE_DELETED_ACCOUNTS'),(6943,'STR_CLICK_TO_SHOW_DELETED_ACCOUNTS'),(6944,'STR_STANDARD'),(6945,'STR_TOTALS_FOR_YEAR'),(6946,'STR_COST_CENTER_ALREADY_EXISTS'),(6947,'STR_COST_CENTER_DESCRIPTION'),(6948,'STR_GENERAL_LEDGER_COST_CENTER_ADD'),(6949,'STR_GENERAL_LEDGER_COST_CENTER_UPDATE'),(6950,'STR_PIE_CHARTS'),(6951,'STR_NET_CHANGE'),(6952,'STR_SPECIFIC_GL_COST_CENTER'),(6953,'STR_INCLUDES_UNPOSTED_ENTRIES'),(6954,'STR_SUMMARY_LEVEL'),(6955,'STR_DETAILED_TRIAL_BALANCE_SHEET'),(6956,'STR_END_BALANCE'),(6957,'STR_GL_COST_CENTER'),(6958,'STR_INCLUDE_ALL_COMPANIES_TOGETHER'),(6959,'STR_ONLY_WORKS_IF_ALL_COMPANIES_HAVE_SAME_FISCAL_YEAR'),(6960,'STR_COST_RECEIPT'),(6961,'STR_IMPORT_TRANSACTIONS'),(6962,'STR_PAID_BY'),(6963,'STR_PAID_TO'),(6964,'STR_TRANSACTION_ID'),(6965,'STR_TRANSFER_DATE'),(6966,'STR_TRANSFER_TYPE'),(6967,'STR_UNABLE_TO_UPDATE_TRY_AGAIN'),(6968,'STR_IMPORT_BALANCES'),(6969,'STR_DISTRIBUTOR_FILE_IMPORT'),(6970,'STR_DISTRIBUTOR_SALES_FILE_COLUMN_FORMAT'),(6971,'STR_ENTRIES_IMPORTED'),(6972,'STR_FIX_PROBLEMS_AND_TRY_AGAIN'),(6973,'STR_NOTE2'),(6974,'STR_NO_FILES_UPLOADED_DUE_TO_ERRORS'),(6975,'STR_SELECT_CUSTOMER_WHOSE_FILE_IS_TO_BE_IMPORTED'),(6976,'STR_SELECT_DISTRIBUTOR_SHIP_FILE'),(6977,'STR_BILL_DATE'),(6978,'STR_GL_ACCOUNT_NUMBER'),(6979,'STR_VENDOR_BILLS_FILE_COLUMN_FORMAT'),(6980,'STR_URL_FILE_FOR_CSV_FORMAT_GL'),(6981,'STR_AVERAGE_COST_EACH'),(6982,'STR_DEFAULT_VENDOR_NAME'),(6983,'STR_IMPORT_ITEMS'),(6984,'STR_ITEM_FILE_COLUMN_FORMAT'),(6985,'STR_LAST_COST_EACH'),(6986,'STR_MANUFACTURER'),(6987,'STR_MONETARY_COLUMNS_SHOULD_NOT_CONTAIN_MONETARY_SYMBOL'),(6988,'STR_PRICE_EACH'),(6989,'STR_PRICE_UNITS_PER_STOCK_UNIT'),(6990,'STR_PRICE_UNIT_NAME'),(6991,'STR_REFERENCE_ID'),(6992,'STR_REMOVE_QUOTE_MARKS_FROM_WITHIN_TEXT_FIELDS'),(6993,'STR_REPLACE_COMMAS_WITHIN_TEXT_WITH_TILDE'),(6994,'STR_STOCK_UNIT_NAME'),(6995,'STR_SUCCESSFUL'),(6996,'STR_TAXABLE_Y_N'),(6997,'STR_URL_FILE_FOR_CSV_FORMAT_ITEMS'),(6998,'STR_URL_FILE_FOR_CSV_FORMAT_V'),(6999,'STR_ACTIVITY_REPORT'),(7000,'STR_INCLUDE_ITEMS_WITH_NO_ACTIVITY_IN_PERIOD'),(7001,'STR_CHECK_FOR_DUPLICATION'),(7002,'STR_ITEMCODE_NOT_ENTERED'),(7003,'STR_ITEM_IS_TAX_EXEMPT'),(7004,'STR_GROUP_NAME'),(7005,'STR_INCLUDE_THIS_ITEM_IN_THIS_GROUP'),(7006,'STR_ITEM_CUSTOMER_GROUP_ASSIGNMENT'),(7007,'STR_SPECIAL_PRICE'),(7008,'STR_BILL_OF_MATERIALS_ITEM_LIST'),(7009,'STR_VENDOR_ITEM_PRICES'),(7010,'STR_VENDOR_PRICES'),(7011,'STR_ADD_OPTION_GROUPS'),(7012,'STR_ASSIGN_OPTIONS'),(7013,'STR_CREATE_BEGIN_DATE'),(7014,'STR_CREATE_DATE_RANGE'),(7015,'STR_CREATE_END_DATE'),(7016,'STR_INDEFINITE'),(7017,'STR_INVENTORY_NOTIFICATION_REQUESTS'),(7018,'STR_NOT_SENT'),(7019,'STR_RECORDS_RETURNED'),(7020,'STR_SENT_BEGIN_DATE'),(7021,'STR_SENT_DATE'),(7022,'STR_SENT_DATE_RANGE'),(7023,'STR_SENT_END_DATE'),(7024,'STR_SYSTEM_START'),(7025,'STR_ADD_PO'),(7026,'STR_GL_ACCOUNT_MUST_NOT_BE_EMPTY'),(7027,'STR_PRICE_PER_PURCHASE_UNIT'),(7028,'STR_PURCHASE_UNITS'),(7029,'STR_INVOICE_ENTER_VENDOR_CONFIGURATION'),(7030,'STR_PURCHASE_SIZE'),(7031,'STR_PARTIAL_TEXT_IN_PODETAIL_NOTES'),(7032,'STR_SALES_ORDER_NUMBER'),(7033,'STR_NOTE_THAT_DAMAGED_ITEM_QUANTITY_SHOULD_BE_INCLUDED_IN_RECEIVE_QUANTITY'),(7034,'STR_PASS_TO_AP'),(7035,'STR_B2B'),(7036,'STR_CALCULATE_TAXES_BASED_ON_WHAT_PERIOD'),(7037,'STR_IN_WHAT_YEAR_WILL_THIS_PERIOD_BE_PAID'),(7038,'STR_CO'),(7039,'STR_CHANGE_GROUPING'),(7040,'STR_GROUP_BY_MONTH'),(7041,'STR_GROUP_BY_QUARTER'),(7042,'STR_GROUP_BY_YEAR'),(7043,'STR_HOLD_CONTROL_SHIFT'),(7044,'STR_INDIVIDUAL_PAY_PERIODS'),(7045,'STR_SELECT_GROUPING'),(7046,'STR_USES_DATE_PAID'),(7047,'STR_USES_END_OF_PERIOD_DATE'),(7048,'STR_NET_PAY_IS_NEGATIVE'),(7049,'STR_ADDRESS_PHONE'),(7050,'STR_EMP_LENGTH'),(7051,'STR_HIREDATE'),(7052,'STR_PAY_BY_MONTH'),(7053,'STR_PAY_BY_QUARTER'),(7054,'STR_PAY_BY_WEEK'),(7055,'STR_SENIORITY'),(7056,'STR_DATE_LAST_CHANGED'),(7057,'STR_EMPLOYEE_CHECK_EDIT'),(7058,'STR_SENT_TO'),(7059,'STR_CLICK_TO_VIEW_W2'),(7060,'STR_PRINT_W2'),(7061,'STR_ENTERED_AFTER'),(7062,'STR_IS_CUSTOMER'),(7063,'STR_RECENT_CUSTOMERS'),(7064,'STR_SHOW_CUSTOMERS_ENTERED_AFTER'),(7065,'STR_BEGIN_ZIP_CODE'),(7066,'STR_END_ZIP_CODE'),(7067,'STR_ERROR_DURING_SAVE_OR_CONFLICTING_DATA'),(7068,'STR_OR_STATE_ABBREV'),(7069,'STR_TERRITORY'),(7070,'STR_ZIP_ASSIGNED_TO'),(7071,'STR_INTERNAL_WORK'),(7072,'STR_LOG_NEW_TIME'),(7073,'STR_INTERNAL_TIME_EDITOR'),(7074,'STR_SAVE_CHANGES_BEFORE_SELECTING_NEW_DATES'),(7075,'STR_SHOW_VOID'),(7076,'STR_MINUS_ONE_FOR_INTERNAL_WORK_ONLY'),(7077,'STR_TOTAL_ALL_LABOR_CHARGES'),(7078,'STR_TOTAL_BILLABLE_LABOR_CHARGES'),(7079,'STR_TOTAL_INTERNAL_LABOR_CHARGES'),(7080,'STR_QUANTITY_EACH_PART_NON_PRINTED'),(7081,'STR_USER_BARCODE_LIST'),(7082,'STR_ADD_TERMS'),(7083,'STR_BANK_ACCOUNT_NUMBER_FOR_ACH_OR_EFT_PAYMENTS'),(7084,'STR_BANK_ROUTING_FOR_ACH_OR_EFT_PAYMENTS'),(7085,'STR_CONSUMPTION_VAT_TAX_GROUP'),(7086,'STR_ERROR_ADDING_VENDOR_PAYMENT_DATA'),(7087,'STR_FOR_CHECK_PRINTING'),(7088,'STR_INVNOTIFICATION_MESSAGE'),(7089,'STR_INVNOTIFICATION_SUBJECT'),(7090,'STR_PAYMENT_TYPES_ALLOWED'),(7091,'STR_PREPRINTED_CHECK_STOCK_STYLE3'),(7092,'STR_COMMISSION_RATE_SALES_BY_THIS_SALESPERSON'),(7093,'STR_COMMISSION_RATE_SALES_TO_THIS_SALESPERSONS_TERRITORY'),(7094,'STR_EMAIL_NOTIFY_WHEN'),(7095,'STR_GL_ACCOUNT_FOR_TAX_COLLECTED'),(7096,'STR_GL_ACCOUNT_FOR_TAX_PAID'),(7097,'STR_ONLY_SHOW_ITEMS_IN_GROUP_ON_B2B_SITE'),(7098,'STR_SELECT_EITHER_AN_EMPLOYEE_OR_A_VENDOR_NOT_BOTH'),(7099,'STR_USE_PREPRINT_FROM_FOR_BOX_LABELS'),(7100,'STR_ACCOUNT_NUMBER_IS_INVALID'),(7101,'STR_AUTHORIZATION'),(7102,'STR_CAPTURE_ONLY'),(7103,'STR_CARD_EXPIRATION_DATE_IS_INVALID'),(7104,'STR_CARD_TYPE_NOT_RECOGNIZED'),(7105,'STR_DENIED'),(7106,'STR_NEW_ACCOUNT_FOR'),(7107,'STR_PRIOR_AUTHORIZATION_CAPTURE'),(7108,'STR_SALE'),(7109,'STR_VOID_TRANS'),(7110,'STR_SECURITY_WARNING_MD5_HASH_FROM_AUTHORIZE_DOES_NOT_MATCH'),(7111,'STR_ACCOUNTS'),(7112,'STR_ADD_NEW_ACCOUNT'),(7113,'STR_AVAILABLE_PROCESSORS'),(7114,'STR_AVS_CODE'),(7115,'STR_B2B_USER'),(7116,'STR_CARD_CODE'),(7117,'STR_CARD_EXP'),(7118,'STR_CARD_FIRSTNAME'),(7119,'STR_CARD_LASTNAME'),(7120,'STR_CARD_NUMBER'),(7121,'STR_CREDIT_CARD_TRANSACTIONS'),(7122,'STR_CUSTOMER_IP'),(7123,'STR_ERROR_WITH_ACCOUNT_SETUP_PROCESSOR_DOES_NOT_EXIST'),(7124,'STR_EXTRA_AUTH_PERCENT'),(7125,'STR_INTERNAL_USER'),(7126,'STR_OPT_ID'),(7127,'STR_ORIGINAL_TRANS_ID'),(7128,'STR_RESULT_MESSAGE'),(7129,'STR_TRANS_DATE'),(7130,'STR_TRANS_ID'),(7131,'STR_TRANS_TYPE'),(7132,'STR_ADD_EDIT_GENERAL_LEDGER_COST_CENTERS'),(7133,'STR_ADD_EDIT_SUMMARY_LEVEL_DESCRIPTIONS'),(7134,'STR_ADD_UPDATE_ITEM'),(7135,'STR_CASH_REQUIREMENTS'),(7136,'STR_COMMISSION_CHECKS'),(7137,'STR_COMPANY_ADD_UPDATE'),(7138,'STR_CREATE_A_COUNTER_SALE'),(7139,'STR_CREATE_A_DETAILED_TRIAL_BALANCE_SHEET'),(7140,'STR_CREATE_EDIT_RECEIVE_RMAS'),(7141,'STR_CUSTOMER_GROUPS'),(7142,'STR_CUSTOMER_GROUPS_FOR_INVENTORY_ITEMS'),(7143,'STR_DETAILED_TRIAL_BALANCE'),(7144,'STR_EDIT_INTERNAL_WORK_TIME'),(7145,'STR_EDIT_REPRINT_COPY_PRINT_ORDERS'),(7146,'STR_EMPLOYEE_SENIORITY'),(7147,'STR_ENTER_PIECEWORK_GROUPS'),(7148,'STR_ENTER_UPDATE_PAYMENT_OR_CHECKING_ACCOUNTS_USED_FOR_PAYABLES'),(7149,'STR_GL_COST_CENTERS'),(7150,'STR_GL_SUMMARY_LEVELS'),(7151,'STR_IMPORT_DISTRIBUTION'),(7152,'STR_IMPORT_DISTRIBUTOR_CSV_FILES_FOR_COMMISSIONS'),(7153,'STR_IMPORT_INVENTORY_ITEMS'),(7154,'STR_IMPORT_INVENTORY_ITEMS_FROM_CSV_FILE'),(7155,'STR_INVENTORY_ITEM_VENDOR_PRICES'),(7156,'STR_ITEM_ADJUSTMENTS'),(7157,'STR_ITEM_OPTION_GROUPS_DESC'),(7158,'STR_ITEM_VENDOR_PRICES'),(7159,'STR_LIST_OF_EMPLOYEE_SENIORITY'),(7160,'STR_LIST_PENDING_AND_COMPLETED_RMAS'),(7161,'STR_NOTIFICATION_REQUESTS'),(7162,'STR_ORDERS_INVOICES_QUICK'),(7163,'STR_ORDERS_OPEN'),(7164,'STR_PAYMENT_CHECKING_ACCOUNTS'),(7165,'STR_PENDING_WORK'),(7166,'STR_PENDING_WORK_BY_AREA'),(7167,'STR_PIECEWORK_GROUPS'),(7168,'STR_POS_ORDERS'),(7169,'STR_PO_NOTES'),(7170,'STR_QUOTE_ENTRY_AND_SEARCH'),(7171,'STR_RECENTLY_ENTERED_CUSTOMERS_LIST'),(7172,'STR_RMA_CONDITIONS_REASONS_ACTIONS'),(7173,'STR_RMA_LISTS'),(7174,'STR_RMA_SETUP'),(7175,'STR_SEARCH_PRINT_ORDERS'),(7176,'STR_USER_ADD_UPDATE'),(7177,'STR_WRITE_COMMISSION_CHECKS_FROM_DISTRIBUTOR_SALES_OR_VIEW_REPORT'),(7178,'STR_LEAVE_BLANK_FOR_NO_DISPLAY'),(7179,'STR_ZIP_CODE_FOR_HOME_PAGE_WEATHER'),(7180,'STR_ADDITIONAL_SUMMARY_LEVELS'),(7181,'STR_STANDARD_SUMMARIZE_TO_ACCOUNT'),(7182,'STR_NOT_DROP_SHIPPED'),(7183,'STR_SALES_ORDER_IF_DROP_SHIP'),(7184,'STR_COST_PER_USAGE_UNIT'),(7185,'STR_DROP_DOWN_BOX'),(7186,'STR_ERROR_ENCOUNTERED_DATA_REVERTED'),(7187,'STR_ERROR_NUMBER'),(7188,'STR_EXAMPLE'),(7189,'STR_FURTHER_SETUP'),(7190,'STR_QUICK_SETUP'),(7191,'STR_REQUIRED_CHECKING_ACCOUNT_INFO'),(7192,'STR_REQUIRED_INFORMATION_MISSING'),(7193,'STR_REQUIRED_SALES_TAX_INFO'),(7194,'STR_SETUP_COMPLETE'),(7195,'STR_WHAT_IS_YOUR_COMPANY_NAME'),(7196,'STR_WEATHER_FOR'),(7197,'STR_ACCRUED'),(7198,'STR_AMOUNT_TO_PAY_MUST_NOT_BE_GREATER_THAN_BALANCE'),(7199,'STR_MAKE_PAYMENT'),(7200,'STR_PAYMENT_AMOUNT_CANNOT_BE_NEGATIVE'),(7201,'STR_PAY_NOW'),(7202,'STR_B2B_REFERENCE'),(7203,'STR_PAYMENT_HISTORY'),(7204,'STR_INVOICE_HISTORY'),(7205,'STR_ADDED_WHEN_SHIP'),(7206,'STR_NO_ITEMS_AVAILABLE'),(7207,'STR_REFRESH_SCREEN_AFTER_ADDING_NEW_SHIP_TO'),(7208,'STR_SHIPPING_WILL_BE_ADDED_AT_TIME_OF_SHIPPING'),(7209,'STR_CARD'),(7210,'STR_CONFIRMATION_CODE'),(7211,'STR_PAYMENT_HAS_BEEN_APPLIED_TO_YOUR_ACCOUNT'),(7212,'STR_PLEASE_PRINT_THIS_CONFIRMATION_FOR_YOUR_RECORDS'),(7213,'STR_REQUEST_SERVICE'),(7214,'STR_EIC_MARRIED_SPOUSE_IS_FILING_CERTIFICATE'),(7215,'STR_EIC_MARRIED_SPOUSE_NOT_FILING_CERTIFICATE'),(7216,'STR_MARRIED_SPOUSE_HAS_CERTIFICATE'),(7217,'STR_MARRIED_SPOUSE_WITHOUT_CERTIFICATE'),(7218,'STR_NEW_ORDER_SAME__SHIPTO'),(7219,'STR_QUOTE_SEARCH'),(7220,'STR_SHIP_ACKNOWLEDGEMENT'),(7221,'STR_SEARCH_JOBS'),(7222,'STR_NO_REPORT'),(7223,'STR_ALLOW_PRICELIST_PRINT_ORDERS_ON_B2B_SITE'),(7224,'STR_ALLOW_PRINT_ORDERS_ON_B2B_SITE'),(7225,'STR_CONSUMPTION_VAT_TAX_GROUPS_ADD_UPDATE'),(7226,'STR_CONSUMPTION_VAT_TAX_GROUPS_GROUPS_ADD'),(7227,'STR_CONSUMPTION_VAT_TAX_GROUPS_GROUP'),(7228,'STR_CONSUMPTION_VAT_TAX_GROUPS_UPDATE'),(7229,'STR_SIDE_TWO_TIGHT_REGISTRATION_SIDE_TWO_ONLY_WHEN_MORE_THAN_ONE_INK_ON_SIDE_TWO'),(7230,'STR_ADDITIONALTAX'),(7231,'STR_TAX_GROUP'),(7232,'STR_CONSUMPTION_VAT_TAX'),(7233,'STR_DISTRICT'),(7234,'STR_NET_TAX'),(7235,'STR_TAX_CHARGED'),(7236,'STR_TAX_PAID'),(7237,'STR_TOTAL_CHARGED'),(7238,'STR_VAT_CONSUMPTION_TAX_REPORT'),(7239,'STR_USE_SIMPLE_STATEMENT'),(7240,'STR_WILL_IGNORE_BEGIN_AND_END_DATES'),(7241,'STR_SHIP_INVOICE_DATE'),(7242,'STR_ADD_COMPONENT'),(7243,'STR_AFTER'),(7244,'STR_ALREADY_HAS_DEFINITIION_IMPORTING_NOW_WILL_UPDATE'),(7245,'STR_BACK_TO_SELECTION'),(7246,'STR_BEFORE'),(7247,'STR_BILL_OF_MATERIALS_ENTRY_UPDATE'),(7248,'STR_CHANGE_STATUS'),(7249,'STR_ERROR_UPDATING_DATABASE'),(7250,'STR_FAILED'),(7251,'STR_HAS_BEEN_REVISED'),(7252,'STR_IMPORTING_BOM'),(7253,'STR_IMPORT_BOM'),(7254,'STR_IMPORT_DATA'),(7255,'STR_IMPORT_FILE_COLUMN_FORMAT'),(7256,'STR_IS_ALREADY_A_COMPONENT_OF'),(7257,'STR_ITEM_NOT_IN_INVENTORY'),(7258,'STR_LN_NR'),(7259,'STR_MFG'),(7260,'STR_MOVE_DOWN'),(7261,'STR_MOVE_UP'),(7262,'STR_PART_REFERENCE_DATA'),(7263,'STR_REFERENCE_NOTES'),(7264,'STR_SELECT_BOM_ITEM'),(7265,'STR_TO_ADD_NEW_BOM_ITEM_USE_ITEM_ENTRY_UPDATE_AND_CHECK_COMPOSITE_ITEM_YES_BOX'),(7266,'STR_UP'),(7267,'STR_URL_FILE_FOR_TEXT_TAB_DELIMITED_FORMAT'),(7268,'STR_VENDOR_PART_NUMBER'),(7269,'STR_VENDOR_PURCHASE_NUMBER'),(7270,'STR_BILL_OF_MATERIALS_DEFINITION_LIST'),(7271,'STR_NO_COMMISSION_GL_ACCOUNT_IS_SET_IN_PAYABLES_SETUP'),(7272,'STR_OLD_ID_IF_QB'),(7273,'STR_CREATE_INVOICE_PAYMENT'),(7274,'STR_CREATE_PAYABLE'),(7275,'STR_JOURNAL_ENTRY'),(7276,'STR_ASSET_GL_ACCOUNT'),(7277,'STR_BACK_ORDERED'),(7278,'STR_BASE_PRICE'),(7279,'STR_CLASS_NO_HIERARCHY'),(7280,'STR_CLEAR_FILE_DATA_BEFORE_IMPORT'),(7281,'STR_COPY_SO_DESCR'),(7282,'STR_COSTING_METHOD'),(7283,'STR_DELIMITER'),(7284,'STR_DEPARTMENT'),(7285,'STR_DEPARTMENT_NO_HIERARCHY'),(7286,'STR_DETAILED_DESCRIPTION'),(7287,'STR_DISPLAY_NAME'),(7288,'STR_DISTRIB_PRICE'),(7289,'STR_DROP_SHIP_ITEM'),(7290,'STR_EMPLOYEE_PRICE'),(7291,'STR_EXPENSE_GL_ACCOUNT'),(7292,'STR_FEATURED_ITEM'),(7293,'STR_FEED_DESCRIPTION'),(7294,'STR_FEED_NAME'),(7295,'STR_FORMULA_CURRENCY'),(7296,'STR_FORMULA_DATE'),(7297,'STR_FORMULA_DATE_TIME'),(7298,'STR_FORMULA_NUMERIC'),(7299,'STR_FORMULA_PERCENT'),(7300,'STR_FORMULA_TEXT'),(7301,'STR_FROOGLE_PRODUCT_FEED'),(7302,'STR_INCOME_GL_ACCOUNT'),(7303,'STR_INTERNAL_ID'),(7304,'STR_IS_AVAILABLE'),(7305,'STR_ITEM_URL'),(7306,'STR_LAST_MODIFIED'),(7307,'STR_LAST_QUANTITY_AVAILABLE_CHANGE'),(7308,'STR_LIABILITY_ACCOUNT'),(7309,'STR_MINIMUM_QUANTITY'),(7310,'STR_MPN'),(7311,'STR_NEXTAG_CATEGORY'),(7312,'STR_NEXTAG_PRODUCT_FEED'),(7313,'STR_ONLINE'),(7314,'STR_ONLINE_CUSTOMER_PRICE'),(7315,'STR_ONLINE_DESCRIPTION'),(7316,'STR_ONLINE_NAME'),(7317,'STR_ONLINE_PRICE'),(7318,'STR_OVERALL_QTY_PRICING_TYPE'),(7319,'STR_PREFERRED_STOCK_LEVEL'),(7320,'STR_PREFERRED_VENDOR'),(7321,'STR_PRICING_GROUP'),(7322,'STR_PURCHASE_DESCRIPTION'),(7323,'STR_PURCHASE_PRICE'),(7324,'STR_QUANTITY_PRICING_SCHEDULE'),(7325,'STR_REORDER_POINT'),(7326,'STR_RETAIL_PRICE'),(7327,'STR_SALE_UNIT'),(7328,'STR_SERIAL_LOT_NUMBER'),(7329,'STR_SHIPPING_RATE'),(7330,'STR_SHOPPING_COM_CATEGORY'),(7331,'STR_SHOPPING_COM_PRODUCT_FEED'),(7332,'STR_SHOPZILLA_CATEGORY_ID'),(7333,'STR_SHOPZILLA_PRODUCT_FEED'),(7334,'STR_SPECIAL_ORDER_ITEM'),(7335,'STR_SPONSORSHIP_PRICE'),(7336,'STR_STARRED_FIELDS_ARE_IMPORTED'),(7337,'STR_STOCK_DESCRIPTION'),(7338,'STR_STOCK_UNIT'),(7339,'STR_STORE_DISPLAY_IMAGE'),(7340,'STR_STORE_DISPLAY_THUMBNAIL'),(7341,'STR_STORE_SPECIAL'),(7342,'STR_THUMBNAIL_URL'),(7343,'STR_TOTAL_VALUE'),(7344,'STR_UNITS_TYPE'),(7345,'STR_USE_MARGINAL_RATES'),(7346,'STR_WEIGHT_UNITS'),(7347,'STR_BILL_TO'),(7348,'STR_CUSTOMER_JOB'),(7349,'STR_IMPORT_SALES'),(7350,'STR_IMPORT_SALES_BY_CUSTOMER'),(7351,'STR_MEMO'),(7352,'STR_SERIAL_LOT'),(7353,'STR_TOTAL_REVENUE'),(7354,'STR_IMPORT_QB_BILL_PAYMENTS'),(7355,'STR_IMPORT_QB_VENDOR_BILLS_PAYMENTS'),(7356,'STR_PAYMENTS_IMPORTED'),(7357,'STR_QB_BILLS_LINK_FILE_COLUMN_FORMAT'),(7358,'STR_QB_BILLS_PAYMENT_FILE_COLUMN_FORMAT'),(7359,'STR_THE_FOLLOWING_PAYMENTS_HAD_IMPORT_PROBLEMS_IN_SYSTEM'),(7360,'STR_BILLS_IMPORTED'),(7361,'STR_FULL_IMPORT'),(7362,'STR_FULL_INCLUDES_DELETE'),(7363,'STR_IMPORT_QB_BILLS'),(7364,'STR_IMPORT_QB_VENDOR_BILLS'),(7365,'STR_PARTIAL_NO_DELETE'),(7366,'STR_QB_BILLS_EXPENSE_DETAIL_FILE_COLUMN_FORMAT'),(7367,'STR_QB_BILLS_FILE_COLUMN_FORMAT'),(7368,'STR_QB_BILLS_ITEM_DETAIL_FILE_COLUMN_FORMAT'),(7369,'STR_THE_FOLLOWING_BILLS_HAD_IMPORT_PROBLEMS_IN_SYSTEM'),(7370,'STR_IMPORTED'),(7371,'STR_IMPORT_QB_CREDIT_MEMO'),(7372,'STR_QB_CREDITMEMO_DETAIL_FILE_COLUMN_FORMAT'),(7373,'STR_QB_CREDITMEMO_FILE_COLUMN_FORMAT'),(7374,'STR_THE_FOLLOWING_HAD_IMPORT_PROBLEMS_IN_SYSTEM'),(7375,'STR_IMPORT_QB_CREDITMEMO'),(7376,'STR_IMPORT_QB_CREDITMEMO_PAYMENTS'),(7377,'STR_QB_CREDITMEMO_PAYMENT_LINK_FILE_COLUMN_FORMAT'),(7378,'STR_IMPORT_QB_CUSTOMERS'),(7379,'STR_IMPORT_QB_EMPLOYEES'),(7380,'STR_IMPORT_QB_EMPLOYEE_PAY'),(7381,'STR_QB_EMPLOYEE_FILE_COLUMN_FORMAT'),(7382,'STR_QB_EMPLOYEE_PAY_FILE_COLUMN_FORMAT'),(7383,'STR_IMPORT_QB_INVOICES'),(7384,'STR_IMPORT_QB_INVOICE_PAYMENTS'),(7385,'STR_QB_INVOICES_PAYMENT_LINK_FILE_COLUMN_FORMAT'),(7386,'STR_INVOICES_IMPORTED'),(7387,'STR_QB_INVOICES_DETAIL_FILE_COLUMN_FORMAT'),(7388,'STR_QB_INVOICE_FILE_COLUMN_FORMAT'),(7389,'STR_THE_FOLLOWING_INVOICES_HAD_IMPORT_PROBLEMS_IN_SYSTEM'),(7390,'STR_IMPORT_ITEMS_FROM_QB_EXPORT'),(7391,'STR_SELECT_FILE_PART_A'),(7392,'STR_SELECT_FILE_PART_B'),(7393,'STR_IMPORT_QB_VENDORS'),(7394,'STR_VENDOR_QB_FILE_COLUMN_FORMAT'),(7395,'STR_WITHDRAWN'),(7396,'STR_AUTO_INSERTED_FOR_BOM_ORDER'),(7397,'STR_CLICK_HERE_TO_PRINT_ALL_IN_GROUP'),(7398,'STR_FOR_BUILD_ORDER'),(7399,'STR_NO_PO_CREATED_FOR_BUILD_ORDER'),(7400,'STR_ONCE_POS_ARE_ISSUED_ORDER_CANNOT_BE_ALTERED'),(7401,'STR_PO_FOR_BUILD_ORDER'),(7402,'STR_PO_FROM_BUILD_ORDER'),(7403,'STR_SELECT_BUILD_ORDER_TO_CREATE_PO'),(7404,'STR_COMPLETED_TODATE'),(7405,'STR_DISTRIBUTED'),(7406,'STR_FILL_BUILD_ORDER'),(7407,'STR_NOT_ALL_DISTRIBUTED'),(7408,'STR_PO_CREATED_CANNOT_EDIT'),(7409,'STR_ADD_VENDOR'),(7410,'STR_COMMIT_DETAILS'),(7411,'STR_MFG_BRAND'),(7412,'STR_NO_VENDOR_ASSIGNED_TO_THIS_ITEM'),(7413,'STR_PO_ISSUED'),(7414,'STR_PO_PENDING'),(7415,'STR_QTY_FOR_NEW_PO'),(7416,'STR_QTY_TO_COMMIT'),(7417,'STR_TOTAL_NOT_YET_DECIDED'),(7418,'STR_TOTAL_QTY_NEEDED'),(7419,'STR_VENDOR_ORDERNUMBER'),(7420,'STR_BUILD_ORDER_NUMBER'),(7421,'STR_EXPECTED_USE'),(7422,'STR_NEW_ACTUAL_MASTER_ITEMS_PRODUCED'),(7423,'STR_ORDER_NOW_COMPLETE'),(7424,'STR_PENDING_PO_THIS_ORDER'),(7425,'STR_BUILD_ORDERS_REPORT'),(7426,'STR_ERROR_RETRIEVING_BUILDORDER_INFO'),(7427,'STR_INCLUDE_WHICH_GROUP'),(7428,'STR_CATEGORY_APPLIES_TO'),(7429,'STR_EDIT_SELECT_BOX_OPTIONS'),(7430,'STR_ENTRY_TYPE'),(7431,'STR_IF_ENTRY_TYPE_IS_TEXT_LIMIT_INPUT_CHARACTERS_TO'),(7432,'STR_ITEM_TRANSACTION_DETAIL_FIELDS'),(7433,'STR_ITEM_TRANSACTION_FIELD'),(7434,'STR_SELECTION_NAME'),(7435,'STR_SELECT_BOX'),(7436,'STR_ITEM_TRANSACTION_DETAIL_FIELD'),(7437,'STR_ITEM_TRANSACTION_DETAIL_FIELD_ADD'),(7438,'STR_ACTIVATE_DELETED_ENTRY'),(7439,'STR_ADD_NEW_PURCHASE_SIZE_OR_BRAND'),(7440,'STR_IS_DEFAULT'),(7441,'STR_MANUFACTURER_OR_BRAND'),(7442,'STR_CANNOT_COMPLETE_THERE_ARE_UNDISTRIBUTED_QUANTITIES'),(7443,'STR_DISTRIBUTE'),(7444,'STR_NOT_ALL_DISTRIBUTED_CANNOT_EXIT'),(7445,'STR_QTY_GOOD'),(7446,'STR_RECEIVED_DETAILS'),(7447,'STR_TOTAL_NOT_YET_DISTRIBUTED'),(7448,'STR_HAS_NO_PAYMENT_TERMS_ENTERED'),(7449,'STR_CHECK_ADJUSTMENT'),(7450,'STR_ADD_UPDATE_BOM_DEFINITIONS'),(7451,'STR_CREATE_PO_FOR_BUILD_ORDERS'),(7452,'STR_INVENTORY_ITEM_BILL_OF_MATERIALS_DEFINITION_LIST'),(7453,'STR_LIST_BOM_DEFINITIONS'),(7454,'STR_PO_FOR_BUILD_ORDERS'),(7455,'STR_TRACKING_FIELDS_FOR_INVENTORY_FLOW'),(7456,'STR_TRACKING_SETUP'),(7457,'STR_CHECK_TO_TREAT_TAXES_AS_VAT_TAX'),(7458,'STR_CPA'),(7459,'STR_VAT_OR_CONSUMPTION_TAXES_ARE_USED_OUTSIDE_UNITED_STATES'),(7460,'STR_USED_FOR_BUILD_ORDER_NUMBER'),(7461,'STR_EXTRA_FIELD1_FOR_EMPLOYEE'),(7462,'STR_EXTRA_FIELD2_FOR_EMPLOYEE'),(7463,'STR_NONTAXABLE_PAY_CATEGORY'),(7464,'STR_ADDITIONAL_TAX'),(7465,'STR_EXTRA_FIELD_1'),(7466,'STR_EXTRA_FIELD_2'),(7467,'STR_SHOULD_BE_DEDUCTED'),(7468,'STR_NON_TAXABLE_PAY_OR_REIMBURSEMENTS'),(7469,'STR_PRINT_ORDER_CONFIRMATION'),(7470,'STR_ORDER_SEARCH'),(7471,'STR_PLACE_REORDER'),(7472,'STR_SHIP_ACK'),(7473,'STR_YOUR_PO_NUMBER'),(7474,'STR_CURRENT_ORDERS'),(7475,'STR_VIEW_PRINT'),(7476,'STR_OPEN_FULFILLMENT_QUOTES'),(7477,'STR_ALLOW_CUSTOMERS_TO_SIGN_UP_ON_B2B_SITE'),(7478,'STR_DEFAULT_CUSTOMER_GROUP'),(7479,'STR_DEFAULT_CUSTOMER_TERMS'),(7480,'STR_EMAIL_FOR_B2B_ORDER_NOTIFICATIONS'),(7481,'STR_DISPLAY_IN_B2B_SIGNUPS'),(7482,'STR_LOCAL_INCOME_AND_ADDITIONAL_TAX'),(7483,'STR_CHANGE_AP_BILL_POSTING_TO_INVOICE_OR_PAYMENT_DATE'),(7484,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_THE_SELECTED_CUSTOMERS'),(7485,'STR_CUSTOMERS_DELETED_SUCCESSFULLY'),(7486,'STR_CUSTOMERS_WITH_NO_INVOICES_AFTER'),(7487,'STR_ERROR_DELETING_CUSTOMER_RECORDS'),(7488,'STR_IGNORE_IF_BALANCE_DUE'),(7489,'STR_INACTIVE_CUSTOMERS'),(7490,'STR_LAST_INVOICE'),(7491,'STR_LAST_INVOICE_DATE'),(7492,'STR_NO_INVOICES_SINCE'),(7493,'STR_NEW_B2B_FULFILLMENT_ORDER'),(7494,'STR_B2B_FULFILLMENT_ORDER_PAYMENT_RECEIVED'),(7495,'STR_A_USER_WITH_THIS_EMAIL_LOGIN_ALREADY_EXISTS'),(7496,'STR_B2B_SIGNUP'),(7497,'STR_B2B_SIGNUP_CATEGORY'),(7498,'STR_CONFIRM_EMAIL'),(7499,'STR_CONFIRM_PASSWORD'),(7500,'STR_EMAIL_ADDRESSES_DO_NOT_MATCH'),(7501,'STR_IF_A_BUSINESS'),(7502,'STR_MISSING_FIELD'),(7503,'STR_NOLAPRO_B2B_SIGNUP'),(7504,'STR_SIGNUP_NOT_ALLOWED_FOR_THIS_COMPANY'),(7505,'STR_YOUR_ACCOUNT_HAS_BEEN_SUCCESSFULLY_CREATED'),(7506,'STR_YOU_WILL_NOW_BE_REDIRECTED_TO_THE_LOGIN_PAGE'),(7507,'STR_B2B_SIGNUP_GROUP'),(7508,'STR_10_MOST_RECENTLY_ADDED_CUSTOMERS'),(7509,'STR_10_NEWEST_CUSTOMERS'),(7510,'STR_DATE_ADDED'),(7511,'STR_VIEW_NEW_CUSTOMERS'),(7512,'STR_OBS_TOTAL'),(7513,'STR_OBS_VOLUME_REPORT_ONE_MONTH'),(7514,'STR_NO_ACTIVITY_FOR_QUAARTER'),(7515,'STR_OBS_VOLUME_REPORT'),(7516,'STR_OBS_VOLUME_REPORT_ONE_QUARTER'),(7517,'STR_QUARTER_BEGIN'),(7518,'STR_OBS_VOLUME_REPORT_ONE_WEEK'),(7519,'STR_OBS_VOLUME_REPORT_ONE_YEAR'),(7520,'STR_TOP_50_PRINT_CUSTOMERS_YEAR'),(7521,'STR_OBS_REPORT_ONE_MONTH'),(7522,'STR_OBS_REPORT_ONE_QUARTER'),(7523,'STR_OBS_REPORT_ONE_WEEK'),(7524,'STR_OBS_REPORT_ONE_YEAR'),(7525,'STR_TOP_50_PRINT_CUSTOMERS_ONE_YEAR'),(7526,'STR_LATEST_TRAINING_VIDEOS'),(7527,'STR_EXTRA_DESCRIPTION_FIELD_FOR_ORDER'),(7528,'STR_QUALITY_CONTROL_TEXT_FOR_JOB_TICKET'),(7529,'STR_BANK_DEPOSIT'),(7530,'STR_BANK_DEPOSIT_REVERSE'),(7531,'STR_EDIT_QUOTE'),(7532,'STR_VIEW_PRINTABLE_QUOTE'),(7533,'STR_VIEW_REGULAR_QUOTE'),(7534,'STR_ESTIMATED_BY'),(7535,'STR_FOR_30_DAYS'),(7536,'STR_ALL_OPEN_JOBS'),(7537,'STR_INCLUDE_WHAT_GROUPS_IN_REPORT'),(7538,'STR_JOB_DATE_DUE'),(7539,'STR_JOB_ORDER_NUMBER'),(7540,'STR_ONLY_JOBS_WITH_STOCK_NEEDING_TO_BE_ORDERED'),(7541,'STR_ONLY_JOBS_WITH_STOCK_ORDERED_BUT_NOT_RECEIVED'),(7542,'STR_ONLY_JOBS_WITH_STOCK_RECEIVED_BUT_STILL_NOT_COMPLETED'),(7543,'STR_PARENT_SIZE'),(7544,'STR_CHANGE_STATUS_TO'),(7545,'STR_STOCK_NEEDS_STATUS_UPDATE'),(7546,'STR_QUOTE_RETRIEVED'),(7547,'STR_OVERHEAD_PERCENT'),(7548,'STR_ASSIGN_ORDER'),(7549,'STR_NO_TIME_ON_TICKET'),(7550,'STR_PAPER_SCRAP_PERCENT_RUN_SCRAP'),(7551,'STR_PRESS_PAPER_SCRAP_PER_PLATE'),(7552,'STR_FAMILY_DISPLAY_ORDER_FOR_TICKETS'),(7553,'STR_CALIPER_OF_STOCK'),(7554,'STR_FINISHED_LENGTH'),(7555,'STR_FINISHED_WIDTH'),(7556,'STR_CLOSE_NOW'),(7557,'STR_CLOSE_OPEN_PRINT_ORDERS'),(7558,'STR_CLOSE_PENDING_PRINT_ORDERS'),(7559,'STR_UPDATE_COMPLETE'),(7560,'STR_COMPLETE_JOBS'),(7561,'STR_MARK_JOBS_AS_COMPLETED'),(7562,'STR_CONVERSION'),(7563,'STR_CONVERSIONS'),(7564,'STR_PURCHASE_CONVERSION'),(7565,'STR_NO_TAX_TYPE_SELECTED_FOR_TAXABLE_AMOUNTS_OR_TAX'),(7566,'STR_TAX_CAP'),(7567,'STR_WILL_ONLY_WORK_IF_USING'),(7568,'STR_INVENTORY_ITEM_CONVERSIONS'),(7569,'STR_ITEM_CONVERSIONS'),(7570,'STR_VENDOR_TERMS_THIS_PO'),(7571,'STR_AIRPORT_PARKING_FACILITY'),(7572,'STR_AIRPORT_PARKING_FACILITY_FEES'),(7573,'STR_AIRPORT_PARKING_FACILITY_SERVICES_UPDATE'),(7574,'STR_AIRPORT_FEE_FLAT'),(7575,'STR_AIRPORT_FEE_PERCENT'),(7576,'STR_AIRPORT_PARKING_FACILITY_UPDATE'),(7577,'STR_CHARGE_AIRPORT_FEE'),(7578,'STR_CHARGE_FUEL_FEE'),(7579,'STR_CHARGE_PARKING_FEE'),(7580,'STR_CHARGE_SALES_TAX'),(7581,'STR_FUEL_CHARGE'),(7582,'STR_PARKING_FACILITY_NAME'),(7583,'STR_SALES_COMMISSION_FLAT'),(7584,'STR_SALES_COMMISSION_PERCENT'),(7585,'STR_AIRPORT_PARKING_FACILITY_ADD'),(7586,'STR_SHOW_PURCHASE_QUANTITY_ONLY_ON_PO'),(7587,'STR_CLONE_PO'),(7588,'STR_AIRPORT_ACCESS'),(7589,'STR_AIRPORT_PARKING_FACILITY_RESERVATION_REPORT'),(7590,'STR_ARRIVAL_BEGIN_DATE'),(7591,'STR_ARRIVAL_DATE'),(7592,'STR_ARRIVAL_END_DATE'),(7593,'STR_AUTO_SERVICE_FEE'),(7594,'STR_DEPARTURE_BEGIN_DATE'),(7595,'STR_DEPARTURE_DATE'),(7596,'STR_DEPARTURE_END_DATE'),(7597,'STR_FACILITY'),(7598,'STR_INCLUDE_CANCELED'),(7599,'STR_PARKING_DAYS'),(7600,'STR_PARKING_FACILITY'),(7601,'STR_PARKING_FEE'),(7602,'STR_RESERVATIONS'),(7603,'STR_RESERVATION_NUMBER'),(7604,'STR_RES_FEE'),(7605,'STR_CATALOG_DESDESCRIPTION'),(7606,'STR_GRAPHIC_URL'),(7607,'STR_QUANTITY_ON_HAND'),(7608,'STR_ALTERING_SELL_UNITS_FOR_INVENTORY_ITEM_CAN_BREAK_INVENTORY_COUNTS'),(7609,'STR_RESERVATION_REPORT'),(7610,'STR_ASK_INK_COLOR_DESCRIPTIONS_ON_STOCK_PAGE'),(7611,'STR_USER_IN_THIS_COMPANY'),(7612,'STR_CLICK_ON_LINK_TO_TRACK'),(7613,'STR_REQUOTE_ORDER'),(7614,'STR_VIEW_PRINT_INVOICE'),(7615,'STR_5_YEARS'),(7616,'STR_PROFIT_5_YEAR'),(7617,'STR_CHANGING_SALES_ORDER_WILL_REPLACE_PREVIOUS_SALES_ORDER_ENTRIES'),(7618,'STR_PO_NUMBER_WILL_BE_ASSIGNED_IF_NOT_ENTERED'),(7619,'STR_PRINT_ALL_AP_CHECKS_IN_GROUP'),(7620,'STR_PRINT_ALL_AR_CHECKS_IN_GROUP'),(7621,'STR_DELETED_ITEM_NAME_OR_CODE'),(7622,'STR_CHECK_ALREADY_WRITTEN'),(7623,'STR_CREATE_PO'),(7624,'STR_DROP_SHIP_PO'),(7625,'STR_OTHER_ITEM_DESCRIPTION'),(7626,'STR_TA_COMMISSION_FLAT'),(7627,'STR_TA_COMMISSION_PERCENT'),(7628,'STR_PAYMENTS_MUST_DELETED_BEFORE_INVOICE'),(7629,'STR_CREDITCARD_NOT_CHECK'),(7630,'STR_NOT_CHECK'),(7631,'STR_HELP_WITH_CUTOUTS'),(7632,'STR_PARENT_SHEET_SIZE'),(7633,'STR_CHANGE_AP_BILL_POSTING_TO_INVOICE'),(7634,'STR_NO_TRANSACTIONS_BEYOND_END_DATE'),(7635,'STR_CHANGE_AR_BILL_POSTING_TO_PAYMENT_DATE'),(7636,'STR_PRINT_DAYS'),(7637,'STR_PER_FULL_BOX'),(7638,'STR_QTY_PER_BOX_ZERO_EQUALS_USE_MAIN_STOCK_QTY'),(7639,'STR_IF_DEFAULT_NOT_SET_FIRST_LOCATION_AND_PRICE_LEVEL_WILL_BE_USED'),(7640,'STR_SET_DEFAULT_LOCATION_AND_DEFAULT_PRICE_LEVEL_IN_INVENTORY_SETUP'),(7641,'STR_CHANGE_AP_CHK_DATE_TO_INVOICE_DATE'),(7642,'STR_CHECK_DUEDATE_AFTER_CONVERTING'),(7643,'STR_PRINT_BY'),(7644,'STR_COMPARISON_YEAR_MONTH'),(7645,'STR_STANDARD_BALANCE_SHEET'),(7646,'STR_CATEGORY_ID'),(7647,'STR_IMPORT_ITEM_CATEGORIES'),(7648,'STR_ITEM_CATEGORY_FILE_COLUMN_FORMAT'),(7649,'STR_SEASON_FOUR_BEGIN_MONTH_NUMBER'),(7650,'STR_SEASON_FOUR_END_MONTH_NUMBER'),(7651,'STR_SEASON_FOUR_NAME'),(7652,'STR_SEASON_ONE_BEGIN_MONTH_NUMBER'),(7653,'STR_SEASON_ONE_END_MONTH_NUMBER'),(7654,'STR_SEASON_ONE_NAME'),(7655,'STR_SEASON_THREE_BEGIN_MONTH_NUMBER'),(7656,'STR_SEASON_THREE_END_MONTH_NUMBER'),(7657,'STR_SEASON_THREE_NAME'),(7658,'STR_SEASON_TWO_BEGIN_MONTH_NUMBER'),(7659,'STR_SEASON_TWO_END_MONTH_NUMBER'),(7660,'STR_SEASON_TWO_NAME'),(7661,'STR_URL_FILE_FOR_CSV_FORMAT_ITEM_CATEGORIES'),(7662,'STR_1_EQUALS_YES'),(7663,'STR_FIELD_SEPARATOR'),(7664,'STR_FRONT_PAGE'),(7665,'STR_ON_SHOPPING_CART'),(7666,'STR_PRICE_AT_LEVEL'),(7667,'STR_TEXT_DELIMITER'),(7668,'STR_UPC_CODE_OR_ISBN_NUMBER'),(7669,'STR_UPC_OR_ISBN'),(7670,'STR_IMPORT_INVENTORY_CATEGORIES'),(7671,'STR_IMPORT_INVENTORY_CATEGORIES_FROM_FILE'),(7672,'STR_CHECK_TO_INVOICE_USING_ORDER_DATE_RATHER_THAN_CURRENT_DATE'),(7673,'STR_PAYMENT_DESCRIPTION'),(7674,'STR_REPORT_AS_OF'),(7675,'STR_EXCLUDE_VOIDED_PAYMENTS'),(7676,'STR_ORDER_DEPOSITS'),(7677,'STR_TOTAL_CUSTOMER_DEPOSITS'),(7678,'STR_OPEN_CREDITS_ONLY'),(7679,'STR_ABANDONED'),(7680,'STR_INCLUDE_WHICH_INVOICES'),(7681,'STR_SHOW_ONLY_ABANDONED_INCOMPLETE_INVOICES'),(7682,'STR_SHOW_ONLY_DELETED_INVOICES'),(7683,'STR_INTERNAL_NOTES'),(7684,'STR_OLD_JOB'),(7685,'STR_DOCUMENTS'),(7686,'STR_NEW_JOB_NUMBER'),(7687,'STR_OLD_JOB_NUMBER'),(7688,'STR_JOB_GRAPHICS'),(7689,'STR_JOB_INFO'),(7690,'STR_CUSTOM_QUOTE'),(7691,'STR_USER_RIGHTS_INSERT_FAILED'),(7692,'STR_PLACE_ORDER'),(7693,'STR_SHIP_TO_ADD_OR_EDIT'),(7694,'STR_CALL_CUSTOMER_SERVICE_FOR_PRICING'),(7695,'STR_CONTACT_CUSTOMER_SERVICE_FOR_NEW_QUOTE'),(7696,'STR_NOTE_TO_SEARCH_YOU_ONLY_NEED_TO_ENTER_FILTER_DATA_FOR_AREAS_DESIRED'),(7697,'STR_PREPRINTED_CHECK_STOCK_STYLE4'),(7698,'STR_SALES_ACTIONS_ADD_UPDATE'),(7699,'STR_LAST_PO_NUMBER_USED_NUMBERS_ONLY'),(7700,'STR_PO_ENTRY_ONLY_ENTER_SELL_QUANTITY'),(7701,'STR_COMPANY_SALESTAX_OPTIONS'),(7702,'STR_BUSINESS_TO_BUSINESS_SITE'),(7703,'STR_CALCULATE_EXTENDED_PRICE_ON_PRICE_UNITS'),(7704,'STR_CALCULATE_EXTENDED_PRICE_ON_SELL_UNITS'),(7705,'STR_FULFILLMENT_AND_SERVICE_ORDERS'),(7706,'STR_GENERAL_SALESTAX_INFO'),(7707,'STR_INVOICE_CALCULATION_METHOD'),(7708,'STR_PAYMENT_BANK_ACCOUNT'),(7709,'STR_PAYMENT_ACTION'),(7710,'STR_MISC_TAXABLE_PAY_CATEGORY'),(7711,'STR_WORKMANS_COMP_VENDOR'),(7712,'STR_WORKMANS_COMP_VENDOR_LOOKUP'),(7713,'STR_EDIT_CHECK_OR_DEPOSIT_INFORMATION_FOR_VENDOR'),(7714,'STR_FUI_VENDOR'),(7715,'STR_FUI_VENDOR_LOOKUP'),(7716,'STR_INCOME_TAX_VENDOR'),(7717,'STR_SUI_VENDOR'),(7718,'STR_SUI_VENDOR_LOOKUP'),(7719,'STR_CHECKS_GENERATED_PRESS_VIEW_CHECKS_TO_PRINT_AND_FINISH_PROCESSING'),(7720,'STR_BANK_DEPOSIT_UPDATE'),(7721,'STR_ACCOUNT_DEPOSITED_TO'),(7722,'STR_AMOUNT_OF_REFUND'),(7723,'STR_CREATE_REFUND'),(7724,'STR_ERROR_CREATING_REFUND'),(7725,'STR_INCLUDE_IN_REFUND'),(7726,'STR_REFUND_CREATED_SUCCESSFULLY'),(7727,'STR_CANNOT_VOID_CREDITCARD_TRANSACTIONS'),(7728,'STR_ORDER_DEPOSIT_VOID'),(7729,'STR_TO_VOID_A_PROCESSED_CREDIT_CARD_YOU_NEED_TO_ISSUE_A_CREDIT'),(7730,'STR_PAST_DUE_ONLY'),(7731,'STR_ARE_YOU_SURE_YOU_WISH_TO_UNDELETE_THIS'),(7732,'STR_UNDELETE'),(7733,'STR_UNDELETE_THIS_INVOICE'),(7734,'STR_PRICE_SIZE'),(7735,'STR_QTY_SIZE'),(7736,'STR_LIST_ALL_UNBILLED_AND_SELECT_WHICH_TO_INVOICE'),(7737,'STR_LIST_ONLY_UNBILLED_COMPLETED_ORDERS_AND_SELECT_WHICH_TO_INVOICE'),(7738,'STR_CHECK_NUMBER_IF_PAID_BY_CHECK'),(7739,'STR_TODAY'),(7740,'STR_CLICK_TO_GROUP_BY_DAY'),(7741,'STR_CANCELLED_ONLY'),(7742,'STR_SHOW_CANCELLED_SHIPMENTS_ONLY'),(7743,'STR_COMPLETED_ORDER_LIST_FOR'),(7744,'STR_ORDERS_COMPLETED'),(7745,'STR_FINAL_SHIP'),(7746,'STR_PARTIAL_SHIP'),(7747,'STR_SHIPPED_BUT_NOT_BILLED_FULFILLMENT_ORDERS'),(7748,'STR_ORDERS_BILLED_BUT_NOT_PAID'),(7749,'STR_CANCEL_SHIPMENT'),(7750,'STR_DELETE_THIS_SHIPMENT'),(7751,'STR_PACKING_LISTS'),(7752,'STR_RMA_ISSUED'),(7753,'STR_SHIPMENT_VOIDED'),(7754,'STR_VOID_SHIPMENT'),(7755,'STR_PAYMENT_DETAIL_FOR_INVOICE'),(7756,'STR_TOTAL_INVOICE_PAYMENTS_RECEIVED'),(7757,'STR_SERVICE_CLASS_ADD'),(7758,'STR_PICK_TICKET'),(7759,'STR_TOTAL_PAYMENTS'),(7760,'STR_SERVICE_TYPE_ADD'),(7761,'STR_SELF_PARK_PRICE'),(7762,'STR_VALET_PRICE'),(7763,'STR_BANK_INFO_ONLY_REQUIRED_FOR_DIRECT_DEPOSIT'),(7764,'STR_DO_NOTHING'),(7765,'STR_EMPLOYEE_NAME'),(7766,'STR_EMPLOYEE_SS'),(7767,'STR_EMPLOYER_NAME'),(7768,'STR_FEDERAL_FUI_TAX'),(7769,'STR_INCLUDE_COMPANY_CONTRIBUTION_IN_PAYMENT'),(7770,'STR_INCLUDE_WHICH_IN_DESCRIPTION'),(7771,'STR_OTHER_TEXT'),(7772,'STR_PASS_TO_PAYABLES'),(7773,'STR_PAY_DATE'),(7774,'STR_WORKMANS_COMP_TAX'),(7775,'STR_ARE_YOU_SURE_YOU_WISH_TO_DELETE_THIS_COMPANY'),(7776,'STR_UNBALANCED_JOURNAL_ENTRIES'),(7777,'STR_SHIPTO_ATTN_FIRSTNAME'),(7778,'STR_SHIPTO_ATTN_LASTNAME'),(7779,'STR_BIWEEKLY'),(7780,'STR_DATE_LAST_PAY_CHANGE'),(7781,'STR_EMPLOYEES_IMPORTED'),(7782,'STR_EMPLOYEE_CODE'),(7783,'STR_EMPLOYEE_FILE_COLUMN_FORMAT'),(7784,'STR_FIRST_NAME_AND_MIDDLE_INITIAL'),(7785,'STR_IMPORT_EMPLOYEES'),(7786,'STR_OR_PER_PERIOD_IF_SALARY_EMPLOYEE'),(7787,'STR_PAY_PER_HOUR'),(7788,'STR_RELEASE_DATE'),(7789,'STR_SELECT_EMPLOYEE_FILE'),(7790,'STR_SEMIMONTHLY'),(7791,'STR_SOCIAL_SECURITY_NUMBER'),(7792,'STR_STATE_INITIALS_FOR_STATE_TAX'),(7793,'STR_BLANK_FIELD'),(7794,'STR_AVG_PRICE'),(7795,'STR_REMOVED_DISALLOWED_CHARACTERS'),(7796,'STR_SHOPPING_CART_FRONT_PAGE'),(7797,'STR_NO_BUILD_ORDERS_NEEDING_PO'),(7798,'STR_MUST_RECEIVE_PO_BEFORE_FILL'),(7799,'STR_SEARCH_CATEGORY_UPDATE'),(7800,'STR_FOR_CUSTOMER_ORDER'),(7801,'STR_ALL_ACTIVITY_DETAILS'),(7802,'STR_AVAILABLE_DETAILS'),(7803,'STR_COMMITTED_DETAILS'),(7804,'STR_ON_HAND_DETAILS'),(7805,'STR_RECEIVED_INTO_INVENTORY_DETAILS'),(7806,'STR_GROSS_ALL_PAY'),(7807,'STR_GROSS_ALL_PAY_PER_YEAR'),(7808,'STR_GROSS_TAXABLE'),(7809,'STR_GROSS_TAXABLE_PAY'),(7810,'STR_GROSS_TAXABLE_PAY_PER_YEAR'),(7811,'STR_GROSS_TAXABLE_PER_YEAR'),(7812,'STR_PAY_HISTORY'),(7813,'STR_BY_CHECK_DATE'),(7814,'STR_BY_END_OF_PERIOD_DATE'),(7815,'STR_DATE_PAID'),(7816,'STR_TOTAL_ALL_PERIODS'),(7817,'STR_WHICH_DATE'),(7818,'STR_TERMINATE_DATE'),(7819,'STR_CHANGE_ORDER_PRICE'),(7820,'STR_INVENTORY_ITEM_CODE'),(7821,'STR_OUT_TO_PROOF_PRINT_OFF_FORM'),(7822,'STR_PURCHASE_REQUEST_ENTRY_OR_UPDATE'),(7823,'STR_TOTAL_ALL'),(7824,'STR_WORKMANS_COMP_AMT'),(7825,'STR_WORKMANS_COMP_REPORT'),(7826,'STR_SALES_CATEGORIES_ADD_UPDATE'),(7827,'STR_SALES_PROCESS_ADD_UPDATE'),(7828,'STR_SALES_TRACKER_ENTRY_INSERT'),(7829,'STR_HOURS_ENTERED_BUT_NO_ORDER'),(7830,'STR_HOURS_ENTERED_BUT_NO_WORKER_FOR_ORDER'),(7831,'STR_HOURS_ENTERED_BUT_NO_WORKTYPE_FOR_ORDER'),(7832,'STR_TIME_DROPPED'),(7833,'STR_SAVE_CHANGES_BEFORE_SELECTING_NEW_DATES_OR_WORKER'),(7834,'STR_BILLABLE_ONLY'),(7835,'STR_BY_DATE'),(7836,'STR_BY_ORDER'),(7837,'STR_BY_WORKER'),(7838,'STR_BY_WORKTYPE'),(7839,'STR_SELECT_SORT_ORDER'),(7840,'STR_SHOW_BILLABLE_ONLY'),(7841,'STR_DELETE_GRAPHIC'),(7842,'STR_941S'),(7843,'STR_ACTIONS'),(7844,'STR_ACTIVITY_HISTORY'),(7845,'STR_ADD_BILL_OF_MATERIALS_INVENTORY_ITEMS'),(7846,'STR_ADD_CUSTOMER_INFORMATION'),(7847,'STR_ADD_EMPLOYEE_INFORMATION'),(7848,'STR_ADD_NEW_FULFILLMENT_ORDER'),(7849,'STR_ADD_NEW_SERVICE_ORDERS'),(7850,'STR_ADJUST_ITEM_QUANTITIES'),(7851,'STR_ADMIN_SETUP_TOOLS'),(7852,'STR_B2B_USERS'),(7853,'STR_BALANCE_HISTORY'),(7854,'STR_BILLED_NOT_PAID'),(7855,'STR_BIRTHDAYS'),(7856,'STR_CALCULATE_AND_CHECKS'),(7857,'STR_CARRIER_METHODS'),(7858,'STR_CLOSED_ORDERS'),(7859,'STR_CREATE_A_BALANCE_SHEET_IN_DEBIT_CREDIT_FORMAT'),(7860,'STR_CREATE_A_NEW_VENDOR_BILL'),(7861,'STR_CREATE_BANK_DEPOSITS'),(7862,'STR_CREATE_EDIT_INVOICE'),(7863,'STR_CREDIT_CARD_OPTIONS'),(7864,'STR_CUSTOMER_INFORMATION'),(7865,'STR_DIRECT_DEPOSITS'),(7866,'STR_EDIT_BANK_DEPOSIT'),(7867,'STR_EDIT_BILLS'),(7868,'STR_EDIT_CUSTOMER'),(7869,'STR_EDIT_CUSTOMER_INFORMATION'),(7870,'STR_EDIT_DEFINITIONS'),(7871,'STR_EDIT_EMPLOYEE'),(7872,'STR_EDIT_FULFILLMENT_ORDER'),(7873,'STR_EDIT_INTERNAL_WORK'),(7874,'STR_EDIT_INVOICE'),(7875,'STR_EDIT_ITEMS'),(7876,'STR_EDIT_PLAN'),(7877,'STR_EDIT_PO'),(7878,'STR_EDIT_RECURRING_ENTRIES'),(7879,'STR_EDIT_SERVICE_ORDERS'),(7880,'STR_EDIT_VENDOR'),(7881,'STR_EMPLOYEE_PAY_DED'),(7882,'STR_ENTER_AND_UPDATE_SERVICE_ORDERS'),(7883,'STR_ENTER_NEW_VENDOR_DATA'),(7884,'STR_ENTER_RECURRING_ENTRIES'),(7885,'STR_ENTER_UPDATE_TAXES_TABLES'),(7886,'STR_FULFILLMENT_ORDERS_SHIPPED_BUT_NOT_BILLED'),(7887,'STR_FULFILLMENT_QUOTES'),(7888,'STR_GO_TO_AGENT_SITE_AND_RESERVATION_REPORT'),(7889,'STR_IMPORTS'),(7890,'STR_JOURNAL_ENTRIES'),(7891,'STR_LICENSE_INFO'),(7892,'STR_LISTS_OF_COMPLETED_ORDERS'),(7893,'STR_LIST_DEFINITIONS'),(7894,'STR_LIST_PAYMENT_PLANS'),(7895,'STR_LIST_PLANS'),(7896,'STR_LOG_HOURS_CALCULATE_ALL_PAY_AND_TAXES_FOR_PERIOD'),(7897,'STR_MISC_SALES'),(7898,'STR_NAME_ADDRESS_PHONE'),(7899,'STR_NEW_BANK_DEPOSIT'),(7900,'STR_NEW_BILL'),(7901,'STR_NEW_CUSTOMER'),(7902,'STR_NEW_EMPLOYEE'),(7903,'STR_NEW_GL_ACCOUNTS'),(7904,'STR_NEW_INVOICE'),(7905,'STR_NEW_PAYMENT_PLAN'),(7906,'STR_NEW_PLAN'),(7907,'STR_NEW_RECURRING_ENTRIES'),(7908,'STR_ONHOLD_ORDERS'),(7909,'STR_ORDER_BILLED_BUT_NOT_PAID'),(7910,'STR_OVER_ESTIMATE'),(7911,'STR_PAYMENT_PLANS'),(7912,'STR_PAY_SUMMARY'),(7913,'STR_PERIODIC_REPORTS'),(7914,'STR_PHONE_LIST'),(7915,'STR_PHYSICAL_INVENTORY_CREATE_PO'),(7916,'STR_POST_PLANS'),(7917,'STR_PROCESS'),(7918,'STR_PROCESS_RMAS'),(7919,'STR_PROCESS_STATUS'),(7920,'STR_QUARTERLY_AND_ANNUAL_REPORTS'),(7921,'STR_QUOTE_COMMENTS'),(7922,'STR_RMAS'),(7923,'STR_SALES_OVERVIEW'),(7924,'STR_SERVICE_LABOR_RATES'),(7925,'STR_SERVICE_SETUP'),(7926,'STR_SERVICE_STATUS_OPTIONS'),(7927,'STR_SETUP_FOR_SERVICE_ORDERS'),(7928,'STR_SETUP_FUNCTIONS_FOR_SERVICE_ORDERS'),(7929,'STR_SETUP_LEAD_TRACKING'),(7930,'STR_SETUP_RECEIVABLES'),(7931,'STR_SETUP_SERVICE'),(7932,'STR_SHIPMENTS_DUE'),(7933,'STR_SHIPPED_NOT_BILLED'),(7934,'STR_SHIPPING_SETUP'),(7935,'STR_SHIP_ORDER'),(7936,'STR_TAX_EXEMPTIONS'),(7937,'STR_TAX_TABLES'),(7938,'STR_UNBALANCED'),(7939,'STR_UPDATE_AN_EXISTING_PAYABLES_BILL'),(7940,'STR_UPDATE_BANK_DEPOSITS'),(7941,'STR_UPDATE_EMPLOYEE_INFORMATION'),(7942,'STR_UPDATE_EXISTING_PAYMENT_PLAN'),(7943,'STR_UPDATE_INVOICES'),(7944,'STR_UPDATE_RECURRING_ENTRIES'),(7945,'STR_UPDATE_VENDOR_DATA'),(7946,'STR_VENDOR_BILLS'),(7947,'STR_VIEW_ACCOUNT'),(7948,'STR_VIEW_ACCOUNT_DATA'),(7949,'STR_W2S'),(7950,'STR_AP_EMAIL'),(7951,'STR_AR_EMAIL'),(7952,'STR_CELSIUS'),(7953,'STR_CENTIGRADE_OR_FAHRENHEIT'),(7954,'STR_FAHRENHEIT'),(7955,'STR_FLIRTY'),(7956,'STR_FOR_NON_US_LOCATIONS_USE_LINK'),(7957,'STR_ICON_GROUP_FOR_XP_STYLE_MENU'),(7958,'STR_MENU_STYLE'),(7959,'STR_NOLAPRO_CLASSIC'),(7960,'STR_ORDER_EMAIL'),(7961,'STR_PEOPLE'),(7962,'STR_PLAYFUL'),(7963,'STR_SERIOUS'),(7964,'STR_TEMPERATURE_DISPLAY'),(7965,'STR_US_ZIP_CODE_OR_YAHOO_LOCATION_CODE_FOR_HOME_PAGE_WEATHER'),(7966,'STR_WHEN_VIEWING_YOUR_LOCAL_WEATHER_USE_MAIN_PART_OF_HTML'),(7967,'STR_XP_STYLE_WITH_HEADER_ACROSS_FULL_WIDTH'),(7968,'STR_XP_STYLE_WITH_SIDE_MENU_FULL_HEIGHT'),(7969,'STR_YOUR_CODE_IN_EXAMPLE_IS'),(7970,'STR_CLICK_HERE_TO_USE_SEQUENCE_NUMBER'),(7971,'STR_EDIT_MY_INFO'),(7972,'STR_INFO_SAVED_SUCCESSFULLY'),(7973,'STR_LOGIN'),(7974,'STR_AGENT_ID'),(7975,'STR_AGENT_ID_IATA_OR_TIDS'),(7976,'STR_REVSHARE_AGENT_SIGNUP'),(7977,'STR_USE_TODAY_AS_TRANSACTION_DATE'),(7978,'STR_MAILING_LABELS_SHIP_TO_LOCATIONS_WHERE_MATCHES_CUSTOMER_NAME'),(7979,'STR_BILL_TO_ATTN_NAME'),(7980,'STR_CUSTOMER_CONTACT_NAME'),(7981,'STR_LABEL_PRINTING'),(7982,'STR_PRINT_GROUP'),(7983,'STR_QUOTE_TO_ATTN_NAME'),(7984,'STR_SELECT_CHOICE_OF_ATTENTION_TO_NAME'),(7985,'STR_SHIP_TO_ATTN_NAME'),(7986,'STR_TOO_MANY_IN_FILE_MUST_PRINT_BY_GROUP'),(7987,'STR_PAGE_OF_ORDER_FROM_LABELS_THIS_VENDOR'),(7988,'STR_PAGE_OF_PAYTO_LABELS_THIS_VENDOR'),(7989,'STR_COULD_NOT_UNDELETE'),(7990,'STR_ORDER_UNITS'),(7991,'STR_PRICE_UNITS'),(7992,'STR_CLASSIC'),(7993,'STR_ONLY_WITH_CLASSIC_STYLE'),(7994,'STR_ONLY_WITH_XP_STYLES'),(7995,'STR_TO_MAKE_CHANGES'),(7996,'STR_CLOSE_INVOICES_PAID_IN_FULL'),(7997,'STR_SUMMARY_TOTAL_BY_CUSTOMER'),(7998,'STR_WORKTYPE1'),(7999,'STR_COULD_NOT_FIND_UNVOIDED_SHIPMENT_REQUESTED'),(8000,'STR_SHIPMENT_VOIDED_SUCCESSFULLY'),(8001,'STR_MUST_HAVE_COMPANY_NAME'),(8002,'STR_NO_LABOR_SALES_ACCOUNT'),(8003,'STR_BILL_OF_MATERIALS_DEFINITION_ENTRY_UPDATE'),(8004,'STR_BLANK_FORM'),(8005,'STR_EDITING_WILL_REOPEN'),(8006,'STR_IF_PO_COMPLETE'),(8007,'STR_DEPOSIT_CHECK_CANNOT_BE_WRITTEN_BECAUSE_NO_VENDOR_ASSIGNED'),(8008,'STR_LIST_OF_CHECKS'),(8009,'STR_CALIFORNIA'),(8010,'STR_DEFAULT'),(8011,'STR_FLORIDA'),(8012,'STR_ICON_GROUP'),(8013,'STR_MUST_LOGOUT_FOR_CHANGES_TO_TAKE_AFFECT'),(8014,'STR_OKLAHOMA'),(8015,'STR_VERMONT'),(8016,'STR_XP_STYLE'),(8017,'STR_PO_NOTE'),(8018,'STR_SELECT_DETAIL_LEVEL'),(8019,'STR_HINTS_TIPS'),(8020,'STR_THE_NOLAPRO_DIRECTORY_MUST_BE_WRITABLE_BY_APACHE_IN_ORDER_FOR_THE_UPDATE_TO_CONTINUE'),(8021,'STR_CLICK_TO_BEGIN_DB_UPDATE'),(8022,'STR_NOLAPRO_IS_BEING_UPDATED'),(8023,'STR_CHECK_OUT_RESOURCES_BELOW'),(8024,'STR_EMAIL_SUPPORT'),(8025,'STR_HELP_IS_AVAILABLE_AT_THE_BOTTOM_OF_EACH_PAGE'),(8026,'STR_NOLAPRO_FAQ'),(8027,'STR_NOLAPRO_FORUM'),(8028,'STR_BY_DEFAULT_START_WITH_ADDITIONAL_ORDER_OPTIONS_WINDOW_OPEN'),(8029,'STR_CONTACT_NOGUSKA'),(8030,'STR_MY_INFO'),(8031,'STR_HOMEPAGE_CACHING'),(8032,'STR_IMPORT_INVENTORY_CATEGORIES_FROM_CSV_FILE'),(8033,'STR_CLOSE_SELECTED_SMALL_BALANCE_INVOICES'),(8034,'STR_INVOICE_ADJUSTMENT'),(8035,'STR_CLOSE_CHECKED_INVOICES'),(8036,'STR_CLOSE_YES_NO'),(8037,'STR_SMALL_BALANCE'),(8038,'STR_PARKING_FACILITY_ADDRESS'),(8039,'STR_PARKING_FACILITY_CITY'),(8040,'STR_PARKING_FACILITY_STATE'),(8041,'STR_PARKING_FACILITY_ZIP'),(8042,'STR_MY_SETTINGS'),(8043,'STR_CLICK_TO_VIEW_CONFIRMATION'),(8044,'STR_YOU_HAVE_VIOLATED_THE_TERMS_OF_THE_LICENSE_AGREEMENT'),(8045,'STR_YOU_MAY_NOT_ALTER_ANY_NOLAPRO_LOGOS'),(8046,'STR_ART_AND_PO'),(8047,'STR_LOGO_BRANDING'),(8048,'STR_ENTRY_BEGIN_DATE'),(8049,'STR_ENTRY_END_DATE'),(8050,'STR_ORDER_ACKNOWLEDGEMENT_NOTES'),(8051,'STR_APPLY_ONLY_TO_THIS_COMPANY'),(8052,'STR_SET_SHOPPING_CART_PASSWORD'),(8053,'STR_SHOPPING_CART_LOGIN_IS_EMAIL_ONE'),(8054,'STR_WHICH_COMPANIES'),(8055,'STR_SHIPPING_PREFERENCE'),(8056,'STR_OVERPAYMENT_ORDER'),(8057,'STR_LEAVE_BLANK_TO_USE_SALES_STD_LABOR_OR_CUSTOMER'),(8058,'STR_LEAVE_BLANK_TO_USE_STD_LABOR_OR_CUSTOMER'),(8059,'STR_ASSIGN_ACCOUNT_SUMMARIZATION'),(8060,'STR_CANNOT_DO_NESTED_SUMMARIZATION'),(8061,'STR_SEE_HELP_SCREEN_FOR_FULL_EXPLANATION'),(8062,'STR_DELETE_LINE'),(8063,'STR_WHO_CHANGED'),(8064,'STR_BILLABLE'),(8065,'STR_ASSIGN_SUMMARIZATION'),(8066,'STR_REFUND_ISSUED'),(8067,'STR_MARKED_FINAL'),(8068,'STR_ORDER_IS_COMPLETE'),(8069,'STR_ORDER_MARKED_AS_FINAL_SHIP'),(8070,'STR_RETURN_TO_ORDER'),(8071,'STR_DROP_SHIP_TO_CUSTOMER_SHIPTO_ADDRESS'),(8072,'STR_FOR_SALES_ORDER'),(8073,'STR_IF_FOR_SALES_ORDER_SHOULD_DROP_SHIP'),(8074,'STR_NOT_FOR_SALES_ORDER'),(8075,'STR_YES_DROP_SHIP_TO_CUSTOMER_SHIPTO_ADDRESS'),(8076,'STR_COPY_TO_YEAR_SELECTED'),(8077,'STR_FROM_YEAR'),(8078,'STR_TAX_TYPE_ALREADY_EXISTS_EDIT_USING_TAX_TYPE_UPDATE'),(8079,'STR_TAX_YEAR'),(8080,'STR_YEAR_ENTERED_NOT_VALID'),(8081,'STR_ACTUAL_EXCEEDS_HOURS_ORDERED'),(8082,'STR_AMOUNT_ORDERED'),(8083,'STR_AMOUNT_REMAINING'),(8084,'STR_HOURS_ORDERED'),(8085,'STR_HOURS_REMAINING'),(8086,'STR_HOURS_USED'),(8087,'STR_LESS_THAN_TEN_PERCENT_REMAINING'),(8088,'STR_ORDERS_NEAR_OR_OVER_TIME_ORDERED'),(8089,'STR_SERVICE_ORDERS_TIME_ORDERED_VERSUS_REMAINING'),(8090,'STR_WORKCLASS'),(8091,'STR_ORDERED_HOURS'),(8092,'STR_TIME_ORDERED'),(8093,'STR_WORK_CLASS'),(8094,'STR_ACTUAL_TIME'),(8095,'STR_ADD_TIME_ORDERED_TO_ORDER'),(8096,'STR_COPY_TAX_TABLE_DATA'),(8097,'STR_INITIATE_NEW_YEAR_FAILED'),(8098,'STR_INITIATE_NEW_YEAR_SUCCESSFUL'),(8099,'STR_TAX_YEAR_TO_CREATE'),(8100,'STR_UPDATE_FEDERAL_TAX_TABLES_FOR_YEAR_SELECTED'),(8101,'STR_HOURS_ENTERED_BUT_NO_WORKCLASS_FOR_ORDER'),(8102,'STR_PREPAID_HOURS'),(8103,'STR_PREPAID_TIME_ENTRY_FOR_SERVICE_ORDER'),(8104,'STR_START_NEW_YEAR'),(8105,'STR_START_NEW_YEAR_FOR_TAXES'),(8106,'STR_NO_SPECIFIC_VENDOR'),(8107,'STR_PO_AMT'),(8108,'STR_PO_CREATED_CANNOT_EDIT_PO_AMOUNTS'),(8109,'STR_DEFAULT_VENDOR'),(8110,'STR_QTY_ON_PO'),(8111,'STR_REQUEST_PO'),(8112,'STR_BACKORDERS'),(8113,'STR_LISTS_OF_BACK_ORDERS'),(8114,'STR_NO_RECORDID_SENT'),(8115,'STR_YOU_MUST_SPECIFY_A_NOTE_TYPE'),(8116,'STR_ERROR_ADDING_NOTE'),(8117,'STR_NOTE_ADDED_SUCCESSFULLY'),(8118,'STR_NOTE_DELETED_SUCCESSFULLY'),(8119,'STR_THE_NOTE_TYPE_DOES_NOT_EXIST'),(8120,'STR_VIEW_ADD_DELETE'),(8121,'STR_DOWNLOAD_BACKUP_COPY_OF_DATABASE'),(8122,'STR_SHIPPING_CHARGE'),(8123,'STR_ERROR_CREATING_DB_BACKUP_FILE'),(8124,'STR_SERVICE_SETUPS_NOT_COMPLETE'),(8125,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_THIS'),(8126,'STR_SHIP_NOW'),(8127,'STR_BACK_ORDERS'),(8128,'STR_NO_BACK_ORDERS_FOUND'),(8129,'STR_NO_BARCODE_ON_INVOICE'),(8130,'STR_BACKORDERED_ITEM_LIST_FOR'),(8131,'STR_ITEMS_ON_BACKORDER'),(8132,'STR_NO_BACKORDERED_ITEMS_FOUND'),(8133,'STR_APACHE_VERSION'),(8134,'STR_CAN_YOU_PROVIDE_ACCESS'),(8135,'STR_COMPANY_INFORMATION'),(8136,'STR_CREDIT_CARD_INFORMATION'),(8137,'STR_CUSTOMER_SUPPORT_REQUEST_FORM'),(8138,'STR_DESCRIPTION_OF_PROBLEM'),(8139,'STR_ELSEWHERE'),(8140,'STR_EMERGENCY'),(8141,'STR_FORM_SUBMITTED'),(8142,'STR_HOSTED_BY'),(8143,'STR_MYSQL_VERSION'),(8144,'STR_NOGUSKA'),(8145,'STR_NOTE_IF_VALUE_ADDED_PLAN'),(8146,'STR_PHP_VERSION'),(8147,'STR_SERVER_INFORMATION'),(8148,'STR_SERVER_OPERATING_SYSTEM'),(8149,'STR_SERVER_VERSION'),(8150,'STR_STANDARD_NORMAL_OPERATING_HRS'),(8151,'STR_SUCH_AS_LINUX_WINDOWS2000'),(8152,'STR_TYPE_OF_HELP_REQUESTED'),(8153,'STR_BACKORDER_ITEMS'),(8154,'STR_LISTS_OF_BACK_ORDERED_ITEMS'),(8155,'STR_ITEMS_BACKORDERED'),(8156,'STR_LET_NOGUSKA_HOST_YOUR_NOLAPRO_SOLUTION'),(8157,'STR_ORDER_NOLAPRO_MANUALS_CLICK_ON_PICTURE'),(8158,'STR_CHECK_TO_BLOCK_BARCODE_ON_PICK_TICKET'),(8159,'STR_CHECK_TO_BLOCK_HEADER_ON_PICK_TICKET'),(8160,'STR_ENTRY_ORDER'),(8161,'STR_ITEMCODE_ORDER'),(8162,'STR_SORT_ORDER_FOR_ITEMS_ON_FULFILLMENT_PICK_TICKET'),(8163,'STR_FROM_ITEM'),(8164,'STR_FROM_ITEM_CODE'),(8165,'STR_INVENTORY_TRANSFER'),(8166,'STR_INVENTORY_TRANSFERS'),(8167,'STR_ITEM_TRANSFERRED'),(8168,'STR_ITEM_TRANSFER_FAILED'),(8169,'STR_QUANTITY_IN'),(8170,'STR_QUANTITY_OUT'),(8171,'STR_TO_ITEM'),(8172,'STR_TO_ITEM_CODE'),(8173,'STR_INVENTORY_ITEM_TRANSFERS'),(8174,'STR_ITEM_TRANSFERS'),(8175,'STR_CHECK_TO_BLOCK_ITEM_BARCODE_ON_PICK_TICKET'),(8176,'STR_CORRECT_ONHAND_QUANTITIES_FROM_COMPLETED_SERVICE_ORDERS'),(8177,'STR_CHECK_OUT_THE_QUICK_START_GUIDE'),(8178,'STR_ALTERNATE_STYLE_ONE'),(8179,'STR_COMPARISON_PRICELEVEL'),(8180,'STR_FULFILLMENT_ORDER_PICK_LIST_STYLE'),(8181,'STR_NO_BOXES_ON_INVOICE_SHIPTO_SOLDTO_ETC'),(8182,'STR_SHOW_UNIT_PRICE_AND_COMPARISON_PRICE'),(8183,'STR_NOT_USED_FOR_CREDIT_CARDS'),(8184,'STR_LOCATION_WITHIN_WAREHOUSE'),(8185,'STR_BIN_SHELF'),(8186,'STR_BLOCK_EXISTING_QUANTITIES'),(8187,'STR_DISPLAY_BIN_SHELF_LOCATION_COLUMN'),(8188,'STR_DISPLAY_CATEGORY_COLUMN'),(8189,'STR_SAVE_CHANGES_BEFORE_RECEIVE_OR_CLONE'),(8190,'STR_BUSINESS_TYPE'),(8191,'STR_ORDER_NOLAPRO_SUPPORT_PLANS'),(8192,'STR_EXCLUDE_BAD_DEBT_WRITEOFFS'),(8193,'STR_SHOW_ONLY_BAD_DEBT_WRITEOFFS'),(8194,'STR_DEFAULT_PAYMENT_ACCOUNT'),(8195,'STR_EXCLUDE_DIRECT_DEPOSIT_ENTRY_FOR_WITHDRAWAL_FROM_COMPANY_ACCOUNT'),(8196,'STR_DELETED_CUSTOMER'),(8197,'STR_REACTIVATE'),(8198,'STR_AMOUNT_WRITE_OFF'),(8199,'STR_AR_INVOICE_BAD_DEBT_MAKE_ALL_LANGUAGES_SAME'),(8200,'STR_BAD_DEBT_ACCOUNT_MUST_BE_SET_IN_BILLING_SETUP_STANDARD_ACCOUNTS'),(8201,'STR_BAD_DEBT_ENTRY'),(8202,'STR_COMPLETE_WRITE_OFF'),(8203,'STR_DATE_WRITTEN_OFF'),(8204,'STR_ERROR_ADDING_BAD_DEBT'),(8205,'STR_INVOICE_BAD_DEBT_ADDED_SUCCESSFULLY'),(8206,'STR_MAKE_EQUAL'),(8207,'STR_NOT_FULLY_APPLIED'),(8208,'STR_SELECTED_FOR_WRITE_OFF'),(8209,'STR_WRITE_OFF_NOTE'),(8210,'STR_WRITE_OFF_TOTAL'),(8211,'STR_YET_TO_SELECT'),(8212,'STR_WRITE_OFF_BAD_DEBT'),(8213,'STR_DEPOSIT_PAID'),(8214,'STR_ORDERS_TOTAL'),(8215,'STR_BAD_DEBT_WRITE_OFF'),(8216,'STR_WRITTEN_OFF'),(8217,'STR_ADD_RMA'),(8218,'STR_RMA_PENDING'),(8219,'STR_RMA_TOTAL'),(8220,'STR_VIEW_EDIT_RECEIVE_RMA'),(8221,'STR_STATEMENT_AS_OF'),(8222,'STR_STATEMENT_DATE'),(8223,'STR_ACTIVATE_ADDITIONAL_FEATURES'),(8224,'STR_ACTIVATE_FEATURE'),(8225,'STR_BUY_NOW'),(8226,'STR_ERROR_ACTIVATING_FEATURE'),(8227,'STR_FEATURE'),(8228,'STR_FEATURE_SUCCESSFULLY_ACTIVATED'),(8229,'STR_FINALIZE_INSTALLATION'),(8230,'STR_12_MONTH_PROFIT_AND_LOSS'),(8231,'STR_12_MONTH_PROFIT_AND_LOSS_STATEMENT'),(8232,'STR_THIS_IS_AN_ADD_ON_FEATURE_REQUIRING_ACTIVATION'),(8233,'STR_LEAVE_ZERO_TO_AUTO_ASSIGN'),(8234,'STR_INCLUDE_WHICH_ITEMS'),(8235,'STR_ITEMS_WITH_NO_COST'),(8236,'STR_ITEMS_WITH_NO_SUPPLIER'),(8237,'STR_NO_COST_OR_SUPPLIER'),(8238,'STR_DEPOSIT_AMOUNT_LESS_THAN_CHECK'),(8239,'STR_WRITE_DEPOSIT_CHECK_FOR'),(8240,'STR_CENTIGRADE'),(8241,'STR_HOURS_AHEAD_OR_BEHIND'),(8242,'STR_SEE_HELP_FOR_EXPLANATION'),(8243,'STR_WEATHER_CODE'),(8244,'STR_WEATHER_DEGREE_TYPE'),(8245,'STR_12_MONTH_P_AND_L'),(8246,'STR_ADD_ON_MANAGER'),(8247,'STR_ASSIGN_LOGO_FOR_LOGON_PAGE_AND_FOOTERS'),(8248,'STR_BRANDING'),(8249,'STR_IMPORT_EMPLOYEES_INTO_NOLAPRO'),(8250,'STR_INCOMPLETE_ITEMS'),(8251,'STR_ITEMS_WITH_EITHER_NO_COST_OR_NO_SUPPLIER'),(8252,'STR_PRINT_A_12_MONTH_PROFIT_AND_LOSS_STATEMENT'),(8253,'STR_PURCHASE_AND_MANAGE_ADD_ONS'),(8254,'STR_ADD_ON_FEATURE_AVAILABLE'),(8255,'STR_HOURS_AHEAD'),(8256,'STR_HOURS_BEHIND'),(8257,'STR_NO_DIFFERENCE'),(8258,'STR_EMPLOYEE_NOTES'),(8259,'STR_PAYABLES_BILL_NOTES'),(8260,'STR_VENDOR_NOTES'),(8261,'STR_CUSTOMIZE_NOLAPRO_WITH_GREAT_ADD_ON_FEATURES'),(8262,'STR_ADD_AN_ITEM'),(8263,'STR_USE_THIS_TO_ORDER_THE_SAME_ITEM_WITH_DIFFERENT_OPTIONS_IF_AVAILABLE'),(8264,'STR_NO_INTEREST_ADDED_COLUMN_ON_STATEMENT'),(8265,'STR_NO_PRIOR_BALANCE_COLUMN_ON_STATEMENT'),(8266,'STR_SUMMARY_BY_CUSTOMER_AND_SHIPTO_AND_INVOICE'),(8267,'STR_SUMMARY_TOTAL_BY_CUSTOMER_AND_SHIPTO'),(8268,'STR_BACK_TO_BEGINNING_BALANCES'),(8269,'STR_B2B_PRINT_USERS'),(8270,'STR_DATA'),(8271,'STR_DATE_RANGE'),(8272,'STR_EVENT'),(8273,'STR_IP'),(8274,'STR_NOLAPRO_ACTIVITY_MONITOR'),(8275,'STR_SECTION'),(8276,'STR_SHOW_DATA'),(8277,'STR_ADDITIONAL_FIELDS_EDITOR'),(8278,'STR_ADD_FIELD'),(8279,'STR_ADD_FIELD_FOR'),(8280,'STR_ADD_OPTION'),(8281,'STR_ADD_UPDATE_FIELDS_FOR'),(8282,'STR_CURRENT_FIELDS_FOR'),(8283,'STR_EDIT_FIELD_FOR'),(8284,'STR_ERROR_ADDING_FIELD'),(8285,'STR_ERROR_ADDING_OPTION'),(8286,'STR_ERROR_DELETING_OPTION'),(8287,'STR_FIELD_DEFAULT'),(8288,'STR_FIELD_TITLE'),(8289,'STR_MUST_HAVE_A_FIELD_TITLE'),(8290,'STR_OPTIONS'),(8291,'STR_REVIEW_PRICES_AND_PRINT_QUOTE'),(8292,'STR_EST_VIEW_DUE_DATE_CHANGE_HISTORY'),(8293,'STR_NOLAPRO_ACTIVITY'),(8294,'STR_NOLAPRO_UPDATE'),(8295,'STR_ERROR_DELETING_FIELDS'),(8296,'STR_ERROR_INSERTING_FIELD_VALUES'),(8297,'STR_YOU_MUST_ENTER_A_NUMBER_UP_ON_SHEET'),(8298,'STR_YOU_MUST_SELECT_A_COMPANY'),(8299,'STR_YOU_MUST_SELECT_A_QUANTITY'),(8300,'STR_YOU_MUST_SELECT_A_SIZE'),(8301,'STR_YOU_MUST_SELECT_A_STOCK_TYPE'),(8302,'STR_PROFITS_FROM_SALE_ONLY'),(8303,'STR_BY_SHIPTO_ADDRESS_SHOW_INVOICES'),(8304,'STR_SUMMARY_BY_SHIPTO_ADDRESS'),(8305,'STR_INTER_COMPANY_INVENTORY_TRANSFERS'),(8306,'STR_ONLY_ONE_COMPANY_DEFINED'),(8307,'STR_TO_COMPANY'),(8308,'STR_CUSTOM_FIELDS_EDITOR'),(8309,'STR_ERROR_DELETING_FIELD'),(8310,'STR_ERROR_DELETING_VALUE'),(8311,'STR_ERROR_SAVING_FIELD'),(8312,'STR_INVENTORY_INTERCOMPANY_TRANSFER_SETUP'),(8313,'STR_OTHER_COMPANY'),(8314,'STR_USE_CUSTOMER_WHEN_CREATING_A_PO_IN_THIS_COMPANY_AND_THEN_CREATING_A_MATCHING_FULFILLMENT_ORDER_IN_OTHER_COMPANY'),(8315,'STR_USE_VENDOR_WHEN_CREATING_AN_ORDER_IN_THIS_COMPANY_AND_THEN_CREATING_A_MATCHING_PO_IN_OTHER_COMPANY'),(8316,'STR_CANCEL_DATE'),(8317,'STR_VOIDED_INVOICES_ONLY'),(8318,'STR_VOIDED_ORDERS'),(8319,'STR_ONLY_IMPRESSIONS_LESS_THAN'),(8320,'STR_ITEM_IN_COMPANY'),(8321,'STR_ITEM_TO_TRANSFER'),(8322,'STR_MOVING_FROM'),(8323,'STR_NOTE_THIS_PROCESS_CREATES_AN_INVOICE_IN_FROM_COMPANY_AND_A_PAYABLE_IN_TO_COMPANY'),(8324,'STR_TRANSFER_TO_COMPANY'),(8325,'STR_ADJUSTMENT_DATE'),(8326,'STR_LISTS_OF_VOIDED_ORDERS'),(8327,'STR_NO_FULFILLMENT_OR_SERVICE_ORDERS'),(8328,'STR_ONLY_SHOW_PRINT_ORDERS'),(8329,'STR_SHORT_CUSTOMER_SHIPTO_SCREEN'),(8330,'STR_ERROR_COULD_NOT_SAVE_DATA'),(8331,'STR_TOTAL_IMPRESSIONS'),(8332,'STR_31_TO_45'),(8333,'STR_31_TO_60'),(8334,'STR_46_TO_60'),(8335,'STR_61_TO_90'),(8336,'STR_DAILY_REPORT'),(8337,'STR_DAY_REPORT_FOR'),(8338,'STR_LESS_TAX'),(8339,'STR_OVER_90'),(8340,'STR_PAYMENTS_RECEIVED'),(8341,'STR_CREATE_ORDER_FROM_PO'),(8342,'STR_CREATING_ORDER_FOR'),(8343,'STR_ITEM_CODE_FOR_ORDER'),(8344,'STR_LOCATION_TO_SHIP_FROM'),(8345,'STR_OUR_ITEM_DESCRIPTION'),(8346,'STR_CREATE_ORDER'),(8347,'STR_CREATE_ORDER_FOR_WHAT_COMPANY'),(8348,'STR_FOR_INTERCOMPANY_TRANSFERS'),(8349,'STR_AMOUNT_OF_INVOICES'),(8350,'STR_NUMBER_OF_INVOICES'),(8351,'STR_DAILY_REPORT_OF_BALANCES'),(8352,'STR_API_LOG_VIEWER'),(8353,'STR_COMPANY_ID'),(8354,'STR_USER_ID'),(8355,'STR_DATA_IN'),(8356,'STR_DATA_OUT'),(8357,'STR_MOST_RECENT'),(8358,'STR_NO_TAX'),(8359,'STR_SUPPLIER'),(8360,'STR_QUARTER_AVERAGE'),(8361,'STR_NO_ACTIVITY'),(8362,'STR_OBS_REPORT'),(8363,'STR_AND_IF_USING_MORE_THAN_ONE_INK_ON_A_SIDE'),(8364,'STR_NO_COMPOSITION_QUOTED'),(8365,'STR_ADD_SPLIT_SHIP'),(8366,'STR_SHIPPER_NUMBER'),(8367,'STR_JOB_HAS_BEEN_DELETED'),(8368,'STR_NO_COMPOSITION_ON_ORDER'),(8369,'STR_CONFIRMED'),(8370,'STR_NO_BOXES_ON_PO_SHIPTO_VENDOR_ETC'),(8371,'STR_PURCHASE_ORDER_DATE_FORMAT'),(8372,'STR_INVOICE_AND_STATEMENT_DATE_FORMAT'),(8373,'STR_AMT_ENCLOSED'),(8374,'STR_ERROR_ADDING_DATA'),(8375,'STR_PIECEWORK_FUNCTION'),(8376,'STR_TIMECLOCK_PIECEWORK_FUNCTIONS_ADD'),(8377,'STR_PIECEWORK_ACTION'),(8378,'STR_TIMECLOCK_PIECEWORK_ACTIONS_UPDATE'),(8379,'STR_PIECEWORK_AREA'),(8380,'STR_TIMECLOCK_PIECEWORK_AREA_ADD'),(8381,'STR_FUNCTIONS'),(8382,'STR_TIMECLOCK_PIECEWORK_AREAS_UPDATE'),(8383,'STR_TIMECLOCK_PIECEWORK_FUNCTIONS_UPDATE'),(8384,'STR_PIECEWORK_TRACK_ON_TIMECLOCK'),(8385,'STR_TIMECLOCK_SHIFT'),(8386,'STR_POST_APPROVED_TIMECLOCK_ENTRIES'),(8387,'STR_POST_FAILED'),(8388,'STR_ASTERISK_EQUALS_APPROVED'),(8389,'STR_BASE_PAY'),(8390,'STR_EDIT_TIMECLOCK_ENTRIES'),(8391,'STR_HOURS_OVERTIME'),(8392,'STR_HOURS_REGULAR'),(8393,'STR_LUNCH'),(8394,'STR_NON_PIECEWORK_EMPLOYEES_ONLY'),(8395,'STR_ORIG_HOURS'),(8396,'STR_OVERTIME_PAY'),(8397,'STR_PIECEWORK_EMPLOYEES_ONLY'),(8398,'STR_REGULAR_PAY'),(8399,'STR_TIMECLOCK_GROUP'),(8400,'STR_TOTAL_HOURS'),(8401,'STR_TOTAL_PAY'),(8402,'STR_WORKING'),(8403,'STR_ALLOW_COMP_TIME'),(8404,'STR_CHANGED_SUCCESSFULLY'),(8405,'STR_HOURS_PER_DAY_BEFORE_OVERTIME'),(8406,'STR_HOURS_PER_WEEK_BEFORE_OVERTIME'),(8407,'STR_IF_MORE_THAN_ONE_SEPARATE_BY_COMMAS'),(8408,'STR_IS_BREAK_TIME_PAID'),(8409,'STR_IS_LUNCH_TIME_PAID'),(8410,'STR_LEAVE_BLANK_IF_NO_RESTRICTION'),(8411,'STR_LIMIT_ACCESS_BY_USER_IP'),(8412,'STR_LIMIT_IP_TO_ONLY_THIS'),(8413,'STR_MAX_PAID_BREAKS_PER_DAY'),(8414,'STR_MAX_PAID_TIME_ACCRUED_PER_BREAK'),(8415,'STR_MAX_TIME_PAID_FOR_LUNCH_PER_DAY'),(8416,'STR_MONDAY'),(8417,'STR_MOVING_WORK_TO_ANOTHER_PAY_DAY'),(8418,'STR_OVERTIME_PAY_USE'),(8419,'STR_PAY_WEEK_BEGINS_ON'),(8420,'STR_REGULAR_PAY_USE'),(8421,'STR_SUNDAY'),(8422,'STR_TIMECLOCK_GENERAL_SETUP'),(8423,'STR_IS_THIS_PAID_TIME'),(8424,'STR_OTHER_TIME_NAME'),(8425,'STR_TIMECLOCK_OTHER_TIME'),(8426,'STR_TIMECLOCK_OTHER_TIME_UPDATE'),(8427,'STR_TIMECLOCK_OTHER_TIME_ADD'),(8428,'STR_NOT_AT_WORK'),(8429,'STR_TIMECLOCK_VIEW_EMPLOYEE_STATUS'),(8430,'STR_BACK_TO_SUMMARY'),(8431,'STR_BASE_RATE'),(8432,'STR_OT'),(8433,'STR_RUN_REPORT'),(8434,'STR_ST'),(8435,'STR_TIMECLOCK_REPORT'),(8436,'STR_TIME_SUMMARY_REPORT'),(8437,'STR_UNPAID_HOURS'),(8438,'STR_UNPAID_TIME'),(8439,'STR_APPROVE_TIMECLOCK_TIMES_AND_PAY'),(8440,'STR_APPROVE_TIMES'),(8441,'STR_CURRENT_STATUS_OF_EMPLOYEES'),(8442,'STR_ENTER_UPDATE_GENERAL_SETUP_FACTORS'),(8443,'STR_ENTER_UPDATE_TIMECLOCK_PIECEWORK_RATES_AND_INFORMATION'),(8444,'STR_OTHER_TIME_CATEGORIES_TO_TRACK'),(8445,'STR_SETUP_TIMECLOCK'),(8446,'STR_TIMECLOCK_PIECEWORK'),(8447,'STR_TIMECLOCK_PROCESSING'),(8448,'STR_TIMECLOCK_REPORTS'),(8449,'STR_TIME_SUMMARY'),(8450,'STR_ENTER_UPDATE_OTHER_TIME_CATEGORIES'),(8451,'STR_ENTER_UPDATE_PIECEWORK_RATES_AND_INFORMATION'),(8452,'STR_TIMECLOCK_SETUP'),(8453,'STR_TIMECLOCK_LOGIN_ONLY'),(8454,'STR_PROVINCE'),(8455,'STR_REQUIRED_COMPANY_INFO'),(8456,'STR_CHANGE_EMPLOYEE'),(8457,'STR_GO_TO_LUNCH'),(8458,'STR_LEAVE_WORK'),(8459,'STR_PIECEWORK'),(8460,'STR_RETURN_FROM'),(8461,'STR_RETURN_FROM_BREAK'),(8462,'STR_RETURN_FROM_LUNCH'),(8463,'STR_STARTED_BREAK'),(8464,'STR_STARTED_LUNCH'),(8465,'STR_STARTED_OTHER'),(8466,'STR_STARTED_WORK'),(8467,'STR_START_BREAK'),(8468,'STR_START_WORK'),(8469,'STR_VIEW_MY_TIMES'),(8470,'STR_USE_WHICH_DATE_FOR_CALCULATING_DAYS_OVER'),(8471,'STR_POSTED_ENTRIES'),(8472,'STR_UNDEFINED'),(8473,'STR_UNPOSTED_ENTRIES'),(8474,'STR_TIMECLOCK_PIECEWORK_ACTIONS_SELECTION_ITEMS'),(8475,'STR_ALLOW_USER_ENTERED_RATE'),(8476,'STR_BASE_QUANTITY_TIMES_RATE_IF_YES'),(8477,'STR_DEFAULT_RATE'),(8478,'STR_DIVIDE_QUANTITY_BY_WHAT_BEFORE_APPLYING_RATE'),(8479,'STR_IF_INPUT_TYPE_IS_YES_NO'),(8480,'STR_IF_USER_RATE_REQUIRE_EXPLANATION'),(8481,'STR_INPUT_TYPE'),(8482,'STR_MINIMUM_PAY'),(8483,'STR_RADIO_BOX_CHOICES'),(8484,'STR_RADIO_BOX_CHOICES_PLUS_QUANTITY'),(8485,'STR_SELECTION_PLUS_QUANTITY'),(8486,'STR_TIMECLOCK_PIECEWORK_ACTIONS_ADD'),(8487,'STR_USE_ONE_TIMES_RATE_IF_YES'),(8488,'STR_ADDITIONAL_RATES'),(8489,'STR_SELECTION_ITEMS'),(8490,'STR_TIMECLOCK_PIECEWORK_FUNCTIONS_ADDITIONAL_RATES'),(8491,'STR_ALLOW_NO_JOB_NUMBER'),(8492,'STR_ASK_FOR_JOB_NUMBER'),(8493,'STR_ASK_QUANTITY_THIS_FUNCTION'),(8494,'STR_CHECK_DO_NOT'),(8495,'STR_CHECK_IF_DO_NOT'),(8496,'STR_DO_NOT_AUTO_EXIT_LOGIN_AFTER_STARTING_OR_ENDING_WORK'),(8497,'STR_DO_NOT_DISPLAY_PAY_ON_EMPLOYEE_VIEW_SCREEN'),(8498,'STR_SALARIED_EMPLOYEES_USE_REGULAR_PAY_FOR_OVERTIME'),(8499,'STR_SALARIED_LIMIT_ALL_TIME_TO_STANDARD_HOURS'),(8500,'STR_THROW_OUT_TIME_ONE_SESSION_IF_GREATER_THAN'),(8501,'STR_AVG_PER_HOUR'),(8502,'STR_OTHER_PAY_REASON'),(8503,'STR_PIECEWORK_TOTALS'),(8504,'STR_VIEW_STATUS_ALL_EMPLOYEES'),(8505,'STR_JOB_NUMBER_REQUIRED'),(8506,'STR_OTHER_RATE'),(8507,'STR_OTHER_RATE_REQUIRES_EXPLANATION'),(8508,'STR_SAVED'),(8509,'STR_ALLOWED_IP_ADDRESSES'),(8510,'STR_ALL_USERS_CAN_ACCESS_NOLAPRO_FROM_THESE_IP_ADDRESSES'),(8511,'STR_ERROR_PROCESSING_QUERY'),(8512,'STR_FILTERING_OPTIONS_FOR_ALL_USERS'),(8513,'STR_IP_ACCESS_MANAGER'),(8514,'STR_IP_ENTRY_EXPLANATION'),(8515,'STR_IP_LOGIN_FILTERING_STATUS'),(8516,'STR_OFF'),(8517,'STR_PER_USER_FILTERING_OPTIONS'),(8518,'STR_UPDATE_BASE_HOURLY_PAY'),(8519,'STR_BACK_NO_SAVE'),(8520,'STR_BAD_END_DATE_TIME_ENTERED'),(8521,'STR_NEW_END_DATE_TIME_CANNOT_BE_AFTER_CURRENT_END_DATE_TIME'),(8522,'STR_ACTUAL_END_DATE'),(8523,'STR_ACTUAL_END_HOUR'),(8524,'STR_ACTUAL_END_MINUTE'),(8525,'STR_HOURS_ELAPSED_EXCEEDS'),(8526,'STR_EDIT_UNAPPROVED'),(8527,'STR_TIME_AND_JOB_TRACKING_SYSTEM'),(8528,'STR_ARE_YOU_SURE_YOU_WANT_TO_ADD_A_NEW_DATABASE'),(8529,'STR_COULD_NOT_CREATE_NEW_DATABASE'),(8530,'STR_CURRENT_HOSTED_SITES'),(8531,'STR_DATABASE_NAME'),(8532,'STR_DB_NAME'),(8533,'STR_DOMAIN_NAME'),(8534,'STR_ERROR_ACTIVATING_DATABASE'),(8535,'STR_ERROR_CANCELLING_CUSTOMER'),(8536,'STR_ERROR_CREATING_B2B_UPLOADS_DIRECTORY'),(8537,'STR_ERROR_CREATING_UPLOADS_DIRECTORY'),(8538,'STR_HOSTED_CUSTOMER_UPDATED_SUCCESSFULLY'),(8539,'STR_NEW_DATABASE_ADDED_SUCCESSFULLY'),(8540,'STR_NOLAPRO_HOSTING_MANAGER'),(8541,'STR_SERIAL_NUMBER_DATABASE_NAME_AND_DOMAIN_NAME_MUST_BE_FILLED_OUT'),(8542,'STR_THE_DATABASE_NAME_CANNOT_CONTAIN_SPECIAL_CHARACTERS'),(8543,'STR_THIS_DATABASE_NAME_ALREADY_EXISTS'),(8544,'STR_MIDDLE_NAME'),(8545,'STR_SALUTATION'),(8546,'STR_SUFFIX'),(8547,'STR_INVENTORY_ADJUSTMENT_GL_ACCOUNT'),(8548,'STR_NAME_SUFFIX'),(8549,'STR_ADD_OR_EDIT'),(8550,'STR_ADD_NEW_GRAPHIC'),(8551,'STR_MESSAGE_GRAPHIC'),(8552,'STR_MESSAGE_GRAPHIC_UPDATE'),(8553,'STR_MESSAGE_GRAPHIC_CATEGORY'),(8554,'STR_MESSAGE_GRAPHIC_CATEGORY_UPDATE'),(8555,'STR_GRAPHIC_CATEGORY_DESCRIPTION'),(8556,'STR_GRAPHIC_CATEGORY_NAME'),(8557,'STR_MESSAGE_GRAPHIC_CATEGORY_ADD'),(8558,'STR_MESSAGE_GRAPHIC_ADD'),(8559,'STR_CANNOT_RETRIEVE'),(8560,'STR_CREATE_EDIT_AND_DELETE_MESSAGES'),(8561,'STR_CREATE_NEW_MESSAGE'),(8562,'STR_CURRENT_ACTIVE_MESSAGES'),(8563,'STR_ERROR_COPYING_MESSAGE'),(8564,'STR_ERROR_DELETING_MESSAGE'),(8565,'STR_ERROR_INSERTING'),(8566,'STR_ERROR_INSERTING_FOR'),(8567,'STR_FONT_COLOR'),(8568,'STR_GENERAL_MESSAGES_ARE_DISPLAYED_ON_EVERYONES_HOMEPAGE'),(8569,'STR_HOLD_DOWN_THE_CTRL_KEY_OR_SHIFT_KEY_TO_SELECT_MORE_THAN_ONE_PERSON'),(8570,'STR_MESSAGE_BODY'),(8571,'STR_MESSAGE_TYPE'),(8572,'STR_NO_MESSAGE_SELECTED'),(8573,'STR_ORANGE'),(8574,'STR_PERSONAL'),(8575,'STR_PERSONAL_MESSAGES_ARE_ONLY_FOR_SPECIFIC_RECIPIENTS'),(8576,'STR_POST_DATES'),(8577,'STR_PURPLE'),(8578,'STR_RECIPIENTS'),(8579,'STR_RED'),(8580,'STR_SAVED_SUCCESSFULLY'),(8581,'STR_SELECT_GRAPHIC'),(8582,'STR_UNABLE_TO_RETRIEVE_DATA'),(8583,'STR_UNABLE_TO_RETRIEVE_MESSAGE'),(8584,'STR_UNABLE_TO_RETRIEVE_MESSAGES'),(8585,'STR_UNABLE_TO_RETRIEVE_RECIPIENTS'),(8586,'STR_USER_MESSAGES'),(8587,'STR_CLICK_ON_A_GRAPHIC_TO_ADD_IT_TO_YOUR_MESSAGE'),(8588,'STR_MESSAGE_GRAPHICS'),(8589,'STR_SELECT_A_GRAPHIC'),(8590,'STR_UNABLE_TO_RETRIEVE_GRAPHICS'),(8591,'STR_DATE_SEEN'),(8592,'STR_MESSAGE_TITLE'),(8593,'STR_POST_BEGIN_DATE'),(8594,'STR_POST_END_DATE'),(8595,'STR_WHO_HAS_SEEN'),(8596,'STR_MESSAGES'),(8597,'STR_MESSAGE_FOR_YOU'),(8598,'STR_ALLOWED_TO_CREATE_MESSAGES'),(8599,'STR_HOSTING_MANAGER'),(8600,'STR_HELP10_DESCR'),(8601,'STR_HELP10_TITLE'),(8602,'STR_HELP1_DESCR'),(8603,'STR_HELP1_TITLE'),(8604,'STR_HELP2_DESCR'),(8605,'STR_HELP2_TITLE'),(8606,'STR_HELP3_DESCR'),(8607,'STR_HELP3_TITLE'),(8608,'STR_HELP4_DESCR'),(8609,'STR_HELP4_TITLE'),(8610,'STR_HELP5_DESCR'),(8611,'STR_HELP5_TITLE'),(8612,'STR_HELP6_DESCR'),(8613,'STR_HELP6_TITLE'),(8614,'STR_HELP7_DESCR'),(8615,'STR_HELP7_TITLE'),(8616,'STR_HELP8_DESCR'),(8617,'STR_NOTE_THAT_2'),(8618,'STR_HELP8_TITLE'),(8619,'STR_HELP9_DESCR'),(8620,'STR_HELP9_TITLE'),(8621,'STR_ADD_CATEGORY'),(8622,'STR_YOU_MUST_FIRST_CREATE_A_MESSAGE_CATEGORY'),(8623,'STR_ADD_NEW_MESSAGE'),(8624,'STR_GET_MESSAGES'),(8625,'STR_CLIENT_NOTES'),(8626,'STR_COPY_FAILED'),(8627,'STR_COPY_OF'),(8628,'STR_MESSAGE_CATEGORIES'),(8629,'STR_API_KEY'),(8630,'STR_API_KEY_MANAGEMENT'),(8631,'STR_API_USERID'),(8632,'STR_GENERATE_NEW_API_KEY'),(8633,'STR_REMOVE_API_KEY'),(8634,'STR_CAN_LEAVE_BLANK_IF_TAX_TYPE_SELECTED'),(8635,'STR_CREDIT_CARD_PURCHASE_TYPE_ADD'),(8636,'STR_CREDIT_CARD_PURCHASE_TYPE_DESCRIPTION'),(8637,'STR_GL_EXPENSE_OR_COST_OF_GOODS_SOLD_ACCOUNT'),(8638,'STR_GL_PAYABLES_CONTRA_ACCOUNT'),(8639,'STR_IF_TYPE_IS_TAX'),(8640,'STR_MAY_BE_SAME_AS_ACCOUNTS_PAYABLE'),(8641,'STR_NOT_APPLICABLE'),(8642,'STR_CREDIT_CARD_PURCHASE_TYPE'),(8643,'STR_CREDIT_CARD_PURCHASE_TYPE_UPDATE'),(8644,'STR_CREDIT_CARD_NAME_OR_DESCRIPTION'),(8645,'STR_CREDIT_CARD_VENDOR_ADD'),(8646,'STR_CREDIT_CARD_VENDOR_UPDATE'),(8647,'STR_CHARGE_TYPE'),(8648,'STR_CREDIT_CARD_PURCHASES_ADD'),(8649,'STR_PURCHASE_BY'),(8650,'STR_PURCHASE_DATE'),(8651,'STR_PURCHASE_FROM'),(8652,'STR_TOTAL_DOES_NOT_MATCH_SUM_OF_DISTRIBUTIONS'),(8653,'STR_CREDIT_CARD_PURCHASES'),(8654,'STR_WHO_CHARGED'),(8655,'STR_ALL_ORDERS_INVOICES_PAYMENTS_ETC_FOR_THESE_CUSTOMERS_WILL_BE_ASSOCIATED_WITH_THE_ABOVE_CUSTOMER_AFTER_MERGE'),(8656,'STR_CUSTOMER_RECORD_MERGE'),(8657,'STR_CUSTOM_FIELDS_FROM_MERGED_RECORDS'),(8658,'STR_EDITS_MADE_TO_FIELDS_BELOW_WILL_NOT_BE_SAVED'),(8659,'STR_MAKE_CHANGES_TO_THIS_RECORD_ONLY'),(8660,'STR_MERGE'),(8661,'STR_MERGED_CUSTOMER'),(8662,'STR_MERGE_WAS_NOT_SUCCESSFULL'),(8663,'STR_MERGING_CUSTOMER_RECORDS_INTO_THIS_CUSTOMER_RECORD'),(8664,'STR_MERGING_FROM_THESE_CUSTOMER_RECORDS_INTO_CUSTOMER_SELECTED_ABOVE'),(8665,'STR_SKIP_CUSTOMER_MERGE_AND_GO_TO_SHIPTO_MERGE'),(8666,'STR_ALL_ORDERS_INVOICES_ETC_FOR_THESE_SHIPTO_RECORDS_WILL_BE_ASSOCIATED_WITH_THE_ABOVE_SHIPTO_AFTER_MERGE'),(8667,'STR_FROM_SHIPTO'),(8668,'STR_MERGING_FROM_THESE_SHIPTO_RECORDS_INTO_SHIPTO_SELECTED_ABOVE'),(8669,'STR_MERGING_SHIPTO_RECORDS_INTO_THIS_SHIPTO_RECORD'),(8670,'STR_DESCRIPTION_ANY_PART'),(8671,'STR_VOUCHER_ANY_PART'),(8672,'STR_AVG_PER_HR'),(8673,'STR_ACCOUNT_DETAILS'),(8674,'STR_ADDITIONAL_ORDER_OPTIONS'),(8675,'STR_ADD_A_LINE'),(8676,'STR_ATTENTION'),(8677,'STR_MIDDLE'),(8678,'STR_NEW_LINE_ITEM'),(8679,'STR_NEW_SHIP_TO'),(8680,'STR_ORDER_ADD_UPDATE'),(8681,'STR_OVERDUE'),(8682,'STR_SEARCH_FOR_CUSTOMER'),(8683,'STR_CHECK_REQUIRE'),(8684,'STR_REQUIRE_RE_LOGIN_ON_EMPLOYEE_VIEW_SCREEN'),(8685,'STR_PIECEWORK_EXTRA_FOR_OVERTIME'),(8686,'STR_IF_STATE_NOT_ON_LIST'),(8687,'STR_MERGE_CUSTOMERS'),(8688,'STR_MERGE_MULTIPLE_CUSTOMER_RECORDS'),(8689,'STR_MERGE_CUSTOMERS_WITH_MULTIPLE_RECORDS'),(8690,'STR_LINE_NOTE'),(8691,'STR_AVERAGE_PIECEWORK_PAY_PER_HOUR'),(8692,'STR_AVG_HOURLY'),(8693,'STR_PIECEWORK_OVERTIME'),(8694,'STR_CHECK_IF_ON_BILL'),(8695,'STR_CREDIT_CARD_BILL_ADD'),(8696,'STR_CUSTOMER_PASSWORD_HAS_BEEN_ENTERED'),(8697,'STR_NO_PASSWORD_ENTERED'),(8698,'STR_CREDIT_CARD_PURCHASES_ON_THIS_BILL'),(8699,'STR_OTHER_CHARGES_ON_BILL'),(8700,'STR_TOTAL_OTHER'),(8701,'STR_TOTAL_SELECTED'),(8702,'STR_BILL'),(8703,'STR_BILL_NOT_FOUND'),(8704,'STR_CREDIT_CARD_BILL_UPDATE'),(8705,'STR_REVERSE'),(8706,'STR_CREDIT_CARD_PURCHASES_LIST'),(8707,'STR_NOT_ON_BILL'),(8708,'STR_ON_BILL'),(8709,'STR_POSTED_TO_BILL'),(8710,'STR_PURCHASED_FROM'),(8711,'STR_SHOW_ONLY_VOIDS'),(8712,'STR_WHO_PURCHASED'),(8713,'STR_ASSIGN_WHICH_CC_PURCHASES_ARE_ON_BILL'),(8714,'STR_CC_CHARGE_TYPE'),(8715,'STR_CREDITCARD_PURCHASES'),(8716,'STR_CREDITCARD_PURCHASE_TRACKING'),(8717,'STR_EDIT_CC_BILLS'),(8718,'STR_ENTER_CC_BILLS'),(8719,'STR_ENTER_UPDATE_CC_CARDS'),(8720,'STR_ENTER_UPDATE_PURCHASES'),(8721,'STR_LISTS_OF_CC_PURCHASES'),(8722,'STR_LIST_CC_PURCHASES'),(8723,'STR_CC_CARDS'),(8724,'STR_CC_CHARGE_TYPES'),(8725,'STR_CC_PURCHASES'),(8726,'STR_CHARGE_TYPES'),(8727,'STR_NEW_CC_BILLS'),(8728,'STR_PURPOSE_USED_FOR'),(8729,'STR_ARE_YOU_SURE_YOU_WANT_TO_MERGE_THESE_CUSTOMERS'),(8730,'STR_CUSTOMER_ID'),(8731,'STR_SKIP_CUSTOMER_MERGE_AND_GO_TO_SHIPTO_MERGE_FOR_THIS_CUSTOMER'),(8732,'STR_VIEW_SHIPTO'),(8733,'STR_VIEW_PIECEWORK'),(8734,'STR_PIECEWORK_JOB_DETAILS'),(8735,'STR_PIECEWORK_CONFLICT_REPORT'),(8736,'STR_PW_OT'),(8737,'STR_CUSTOMER_PASSWORD'),(8738,'STR_EMAIL_TWO_DESCRIPTION'),(8739,'STR_LAST_CHANGE_DATE'),(8740,'STR_PHONE_FOUR_DESCRIPTION'),(8741,'STR_PHONE_ONE_DESCRIPTION'),(8742,'STR_PHONE_THREE_DESCRIPTION'),(8743,'STR_PHONE_TWO_DESCRIPTION'),(8744,'STR_SALES_TAX_REC_ID'),(8745,'STR_USE_PASSWORD_FROM_CUSTOMER'),(8746,'STR_USE_THIS_PASSWORD'),(8747,'STR_PIECEWORK_CONFLICTS'),(8748,'STR_TOTAL_ALL_PAY'),(8749,'STR_HOURLY_WAGE_TOTAL'),(8750,'STR_TOTAL_TIME_WORKED'),(8751,'STR_OTHER_NONTAXABLE_PAY'),(8752,'STR_OTHER_TAXABLE_PAY'),(8753,'STR_ADD_ON_AND_PLUG_IN'),(8754,'STR_PURCHASE_AND_MANAGE_ADD_ONS_AND_PLUG_INS'),(8755,'STR_PREPAID_BY_CREDITCARD'),(8756,'STR_DO_NOT_SHOW_ON_QUOTE_ENTRY'),(8757,'STR_ORDERS_ONLY'),(8758,'STR_RETURN_TO_MAIN_SCREEN_TO_VIEW_TIMES'),(8759,'STR_CLICK_HERE_TO_ADD_NOW'),(8760,'STR_CREDIT_CARD_GENERAL_INFO'),(8761,'STR_DEFAULT_PO_PURCHASE_TYPE'),(8762,'STR_NO_CHARGE_TYPES_HAVE_BEEN_ENTERED_YET'),(8763,'STR_PO_FREIGHT_PURCHASE_TYPE'),(8764,'STR_PO_TAX_PURCHASE_TYPE'),(8765,'STR_USE_CREDIT_CARD_TRACKING_FOR_PO_PAYMENT'),(8766,'STR_SHOW_NOTES_AT_BOTTOM'),(8767,'STR_MAX_DIGITS_SSN'),(8768,'STR_CONVERT_TO_SERVICE_ORDER'),(8769,'STR_PREPAID_BY_CREDIT_CARD'),(8770,'STR_CREATED_A_PAYMENT_ALREADY'),(8771,'STR_NO_CREDIT_CARD_PURCHASE_PROVIDERS_ENTERED'),(8772,'STR_PONUMBER'),(8773,'STR_PO_PAY_BY_CREDIT_CARD'),(8774,'STR_RECORD_PAYMENT'),(8775,'STR_TOTAL_PAYMENT'),(8776,'STR_VAT_TAX'),(8777,'STR_CC_GENERAL'),(8778,'STR_SOCIAL_MUST_BE'),(8779,'STR_THIS_JOB_RECENTLY_LOGGED_FOR_THIS_FUNCTION'),(8780,'STR_TOTAL_QTY'),(8781,'STR_DO_NOT_IMPORT_FIELD'),(8782,'STR_HEADING_ONLY'),(8783,'STR_RADIO_BOX_SELECTION'),(8784,'STR_READ_ONLY'),(8785,'STR_COLOR_SMOKE'),(8786,'STR_INTERNAL_CUSTOM_FIELDS_CANNOT_BE_DELETED'),(8787,'STR_ALLOW_FULFILLMENT_ORDERS'),(8788,'STR_ALLOW_SERVICE_ORDERS'),(8789,'STR_CONTROL_CUSTOMER_PAGE'),(8790,'STR_CANNOT_BLOCK'),(8791,'STR_CHECK_TO_BLOCK_FROM_INPUT_SCREENS'),(8792,'STR_COLUMN_NAME'),(8793,'STR_CUSTOMER_PAGE_CONTROL'),(8794,'STR_PLAN_FIVE'),(8795,'STR_PLAN_FOUR'),(8796,'STR_PLAN_THREE'),(8797,'STR_ADDRESS_2'),(8798,'STR_CLICK_CANCEL_TO_NOT_SAVE_AGAIN'),(8799,'STR_CLICK_OK_TO_SAVE_SECOND_ENTRY'),(8800,'STR_CUSTOMER_PAGE_CUSTOMIZER'),(8801,'STR_FINALIZE_ORDER_TYPE_CHANGES'),(8802,'STR_ITEM_PAGE_CUSTOMIZER'),(8803,'STR_INVOICE_TERMS_FILTER'),(8804,'STR_LIST_FILTERS'),(8805,'STR_PRICE_LEVEL_FILTER'),(8806,'STR_FONT_SIZE_FOR_ENTRY_BOXES'),(8807,'STR_FIFO'),(8808,'STR_INVENTORY_COST_METHOD'),(8809,'STR_LIFO'),(8810,'STR_WEIGHTED_AVERAGE'),(8811,'STR_EXCLUDE_VENDOR_AND_BILLS_MARKED_NOT_TO_PAY'),(8812,'STR_CUSTOMERS_WITH_ORDERS_SINCE'),(8813,'STR_ONLY_SHOW_CUSTOMERS_WHO_APPROVE_OF_PROMOTIONS'),(8814,'STR_ONLY_SHOW_CUSTOMERS_WITH_ORDERS_SINCE'),(8815,'STR_ORDER_DATE_FILTER'),(8816,'STR_PROMOTIONS_OK_FILTER'),(8817,'STR_WEIGHTED_AVG'),(8818,'STR_WEIGHTED_AVERAGE_COST'),(8819,'STR_DATA_ENTERED'),(8820,'STR_CANNOT_COMPLETE_IMPORT'),(8821,'STR_GL_ACCOUNTS'),(8822,'STR_GL_TRANSACTIONS'),(8823,'STR_MODULES'),(8824,'STR_PRICE_LEVELS'),(8825,'STR_QUICKBOOKS_EXPORT_FILE_DOES_NOT_EXIST'),(8826,'STR_QUICKBOOKS_EXPORT_FILE_IS_NOT_IN_XML_FORMAT'),(8827,'STR_QUICKBOOKS_FILE_EXPORT_STATUS'),(8828,'STR_QUICKBOOKS_IMPORT'),(8829,'STR_SALES_REPS'),(8830,'STR_ARE_YOU_SURE_YOU_WANT_TO_IMPORT_QUICKBOOKS_RECORDS_INTO_NOLAPRO'),(8831,'STR_STATUS_PAGE'),(8832,'STR_VIEW_RECORDS'),(8833,'STR_BILL_ADDRESS'),(8834,'STR_CUSTOMER_RECORDS_TO_IMPORT'),(8835,'STR_FIRST_MIDDLE_LAST'),(8836,'STR_SHIP_ADDRESS'),(8837,'STR_ALT_PHONE'),(8838,'STR_BIRTHDATE'),(8839,'STR_CELL_PHONE'),(8840,'STR_EMPLOYEE_RECORDS_TO_IMPORT'),(8841,'STR_EMPLOYEE_TYPE'),(8842,'STR_EXPENSE_ACCOUNT'),(8843,'STR_SICK_HOURS_ACCRUED'),(8844,'STR_ERROR_IMPORTING_RECORDS_INTO_NOLAPRO'),(8845,'STR_RECORDS_FOUND'),(8846,'STR_RECORDS_IMPORTED_SUCCESSFULLY'),(8847,'STR_BEFORE_PROCEEDING_PLEASE_UPDATE_DEFAULT_GL_ACCOUNTS_BELOW'),(8848,'STR_GL_ACCOUNT_RECORDS_TO_IMPORT'),(8849,'STR_NOLAPRO_MODULE'),(8850,'STR_NOLAPRO_TYPE'),(8851,'STR_QUICKBOOKS_TYPE'),(8852,'STR_SUMMARY_ACCOUNT'),(8853,'STR_CATALOG_DESCRIPTION'),(8854,'STR_INV_ACCOUNT'),(8855,'STR_ITEM_RECORDS_TO_IMPORT'),(8856,'STR_PRICE_LEVEL_RECORDS_TO_IMPORT'),(8857,'STR_SALES_REP_RECORDS_TO_IMPORT'),(8858,'STR_TERMS_RECORDS_TO_IMPORT'),(8859,'STR_TAX_ID'),(8860,'STR_VENDOR_RECORDS_TO_IMPORT'),(8861,'STR_POST_DATE'),(8862,'STR_BILLS'),(8863,'STR_DONE'),(8864,'STR_READY'),(8865,'STR_BILL_RECORDS_TO_IMPORT'),(8866,'STR_COULD_NOT_FIND_VENDOR'),(8867,'STR_FIRST_LINE'),(8868,'STR_RECORDS_FOR_THIS_MODULE_HAVE_ALREADY_BEEN_IMPORTED'),(8869,'STR_COULD_NOT_FIND_CUSTOMER'),(8870,'STR_INVOICE_RECORDS_TO_IMPORT'),(8871,'STR_SALES_TAX_RECORDS_TO_IMPORT'),(8872,'STR_VENDOR_PAGE_CUSTOMIZER'),(8873,'STR_ATTACHED_IS_YOUR_ORDER_ACKNOWLEDGEMENT'),(8874,'STR_YOUR_CUSTOMERS_PO'),(8875,'STR_AN_ERROR_OCCURRED'),(8876,'STR_PLEASE_MAKE_ANY_ADJUSTMENTS_REQUIRED_BY_THE_ERROR_MESSAGE_AND_RUN_THE_NOLAPRO_QUICKBOOKS_CONVERTER_AGAIN'),(8877,'STR_ERROR_CHECKING_CUSTOM_FIELDS'),(8878,'STR_ERROR_CREATING_CUSTOM_FIELDS'),(8879,'STR_ALLOW_THIS_PAYMENT_TYPE'),(8880,'STR_DEFAULT_EXPENSE_GL_ACCOUNT'),(8881,'STR_ORDER_FROM_ADDRESS_2'),(8882,'STR_ORDER_FROM_CITY'),(8883,'STR_ORDER_FROM_COMPANY_NAME'),(8884,'STR_ORDER_FROM_COUNTRY'),(8885,'STR_ORDER_FROM_EMAIL_DESCRIPTION'),(8886,'STR_ORDER_FROM_MAIL_STOP'),(8887,'STR_ORDER_FROM_PHONE_DESCRIPTION'),(8888,'STR_ORDER_FROM_POSTAL_CODE'),(8889,'STR_ORDER_FROM_STATE'),(8890,'STR_PRINT_OR_EMAIL_THIS_INVOICE'),(8891,'STR_CLICK_TO_ADD'),(8892,'STR_VENDOR_TYPE_DELETED_SUCCESSFULLY'),(8893,'STR_VENDOR_TYPE_UPDATE'),(8894,'STR_VENDOR_TYPE_ADD'),(8895,'STR_CLIENT_LOOKUP'),(8896,'STR_PROJECT_ADD'),(8897,'STR_PROJECT_NAME'),(8898,'STR_PROJECT_TEMPLATE'),(8899,'STR_VENDOR_TYPE'),(8900,'STR_ENTER_UPDATE_TYPES_OF_VENDORS'),(8901,'STR_VENDOR_TYPES'),(8902,'STR_CONFIRM_TO_DELETE_LINE'),(8903,'STR_CUSTOMER_CUSTOM_FIELDS'),(8904,'STR_DISC_PERCENT'),(8905,'STR_GL_SALES_ACCOUNT_MUST_BE_SET'),(8906,'STR_THE_SYSTEM_WILL_CREATE_AN_INVOICE_FOR_THIS_SALE'),(8907,'STR_THE_SYSTEM_WILL_CREATE_A_FULFILLMENT_ORDER_AND_NO_INVOICE'),(8908,'STR_YOU_MUST_ENTER_A_COMPANY_NAME_OR_FIRST_AND_LAST_NAME'),(8909,'STR_ERROR_SAVING_PAYMENT'),(8910,'STR_PAYMENT_SAVED_SUCCESSFULLY'),(8911,'STR_ADD_PAYMENT'),(8912,'STR_PAYMENT_AMOUNT'),(8913,'STR_SAVE_PAYMENT'),(8914,'STR_YOU_MUST_ENTER_AN_AMOUNT'),(8915,'STR_YOU_MUST_ENTER_A_CHECK_NUMBER'),(8916,'STR_YOU_MUST_ENTER_A_VOUCHER'),(8917,'STR_ERROR_SAVING_ORDER'),(8918,'STR_ORDER_SAVED_SUCCESSFULLY'),(8919,'STR_PROJECT_TYPE'),(8920,'STR_BILLED_MONTHLY'),(8921,'STR_BILLED_WEEKLY'),(8922,'STR_BILLING_STAGES'),(8923,'STR_BILL_IN_FIXED_STAGES'),(8924,'STR_COMMISSION_GL_ACCOUNT'),(8925,'STR_COMMISSION_PERCENT'),(8926,'STR_COST_OF_SALES_GL_ACCOUNT'),(8927,'STR_CUSTOM_BILLING_FREQUENCY'),(8928,'STR_DEFAULT_AGENT_FOR_COMMISSION'),(8929,'STR_DESCRIPTION_OF_PROJECT_TYPE'),(8930,'STR_IF_CUSTOM_BILLING_FREQUENCY_BILL_EVERY_HOW_MANY_DAYS'),(8931,'STR_OTHER_CHARGE_GL_ACCOUNT'),(8932,'STR_OTHER_CHARGE_NAME'),(8933,'STR_OTHER_CHARGE_PERCENT'),(8934,'STR_PROJECT_TYPE_ADD'),(8935,'STR_AVG_COST'),(8936,'STR_ERROR_EXECUTING_QUERY'),(8937,'STR_ITEM_VENDOR_LIST'),(8938,'STR_MID_COST'),(8939,'STR_VENDOR_RANGE'),(8940,'STR_INVENTORY_ITEM_VENDORS'),(8941,'STR_ESTIMATED_SHIP_DATE'),(8942,'STR_ISSUE_DATE'),(8943,'STR_ADD_ANOTHER'),(8944,'STR_COMMISSIONABLE_AGENT_1'),(8945,'STR_COMMISSIONABLE_AGENT_2'),(8946,'STR_DEFAULT_AGENT_NAME'),(8947,'STR_DESCRIPTION_FOR_BILLING'),(8948,'STR_FIXED_STAGES'),(8949,'STR_PERCENT_OF_CONTRACT'),(8950,'STR_PERIODIC_BILLING_DETERMINED_BY_LENGTH_OF_PROJECT'),(8951,'STR_PROJECT_TYPE_EDIT'),(8952,'STR_PROJECT_TYPE_NAME'),(8953,'STR_EMAIL_DIRECT_DEPOSIT_STUBS'),(8954,'STR_DIRECT_DEPOSIT_EMAIL_RESULT'),(8955,'STR_EMAIL_DIRECT_DEPOSIT_NOTIFICATIONS'),(8956,'STR_NO_ID_HAS_BEEN_SET'),(8957,'STR_IF_PROJECT_TYPE_NOT_FIXED_STAGES_THEN_NUMBER_OF_BILLING_PERIODS'),(8958,'STR_PERCENT'),(8959,'STR_PROJECT'),(8960,'STR_PROJECT_ADDED_SUCCESSFULLY'),(8961,'STR_PROJECT_NUMBER'),(8962,'STR_PROJECT_TOTAL_VALUE'),(8963,'STR_WHILE_ADDING'),(8964,'STR_PAYMENT_ID'),(8965,'STR_COULD_NOT_FIND_EMAIL_ADDRESS_FOR'),(8966,'STR_DIRECT_DEPOSIT_DATE'),(8967,'STR_EMAIL_SENT_SUCCESSFULLY_FOR'),(8968,'STR_ERROR_GETTING_EMAIL_ADDRESS'),(8969,'STR_FAILED_SENDING_EMAIL_FOR'),(8970,'STR_FAILED_TO_GET_DIRECT_DEPOSIT_STUB'),(8971,'STR_YOUR_DIRECT_DEPOSIT_NOTIFICATION_IS_ATTACHED'),(8972,'STR_ADD_INV_GL_ENTRIES'),(8973,'STR_ADD_TAX_AND_FREIGHT_FROM_PO_AP_BILL_TO_ITEM_COST'),(8974,'STR_DISTRIBUTE_TAX_AND_FREIGHT'),(8975,'STR_INVENTORY_VARIANCE'),(8976,'STR_WHEN_CONVERTING_PO_TO_AP_BILL'),(8977,'STR_WHEN_RECEIVING_PO'),(8978,'STR_DEFAULT_TO_HELP_HOME_PAGE'),(8979,'STR_DONT_SHOW_MARKETING_ITEMS'),(8980,'STR_HELP_PAGE_MARKETING'),(8981,'STR_HIDE_SPLASH_PAGE'),(8982,'STR_LET_USER_SELECT'),(8983,'STR_LOGIN_HOME_PAGE'),(8984,'STR_LOGIN_SPLASH_PAGE'),(8985,'STR_ONLY_FOR_ADMIN_USER'),(8986,'STR_SETTINGS_SAVED_SUCCESSFULLY'),(8987,'STR_SHOW_MARKETING_ITEMS'),(8988,'STR_SHOW_SPLASH_PAGE'),(8989,'STR_SYSTEM_SETTINGS'),(8990,'STR_ORDER_WEIGHT'),(8991,'STR_OPEN_ORDER_WEIGHT_VIEW'),(8992,'STR_SHIP_CITY'),(8993,'STR_SHIP_NAME'),(8994,'STR_SHIP_STATE'),(8995,'STR_SHIP_ZIP'),(8996,'STR_PO_RECEIPT'),(8997,'STR_ADD_ITEM_FAMILY_MEMBERS'),(8998,'STR_FAMILY_ITEMS'),(8999,'STR_ADD_ITEMS_TO_ORDER'),(9000,'STR_NO_ITEM_ID_HAS_BEEN_SET'),(9001,'STR_BILLED_EVERY'),(9002,'STR_CONTRACT_TOTAL'),(9003,'STR_DO_NOT_USE_FOR_SEARCH'),(9004,'STR_ENTER_SEARCH_INFO_FOR_PROJECT_LOOKUP'),(9005,'STR_PROJECT_UPDATE'),(9006,'STR_PROJECT_UPDATED_SUCCESSFULLY'),(9007,'STR_REVERSAL'),(9008,'STR_COULD_NOT_ADD_VENDOR'),(9009,'STR_COULD_NOT_ADD_NEW_CUSTOMER'),(9010,'STR_COULD_NOT_ADD_NEW_CUSTOMER_SHIPTO'),(9011,'STR_LAST_VISITED_HOME_PAGE'),(9012,'STR_DEFAULT_HOMEPAGE'),(9013,'STR_PRICE_LEVEL_BREAKDOWN'),(9014,'STR_HINT1'),(9015,'STR_HINT2'),(9016,'STR_HINT3'),(9017,'STR_HINT4'),(9018,'STR_HINT5'),(9019,'STR_HINT6'),(9020,'STR_HINT7'),(9021,'STR_HINT8'),(9022,'STR_HINT9'),(9023,'STR_ANSWER'),(9024,'STR_HINT1Q'),(9025,'STR_HINT2Q'),(9026,'STR_HINT3Q'),(9027,'STR_HINT4Q'),(9028,'STR_HINT5Q'),(9029,'STR_HINT6Q'),(9030,'STR_HINT7Q'),(9031,'STR_HINT8Q'),(9032,'STR_HINT9Q'),(9033,'STR_DEFAULT_ALTER_COSTS_ACCOUNT'),(9034,'STR_OTHER_CHARGE_PERCENT_CLIENT'),(9035,'STR_MONTH_APR'),(9036,'STR_MONTH_AUG'),(9037,'STR_MONTH_DEC'),(9038,'STR_MONTH_FEB'),(9039,'STR_MONTH_JAN'),(9040,'STR_MONTH_JUL'),(9041,'STR_MONTH_JUN'),(9042,'STR_MONTH_MAR'),(9043,'STR_MONTH_MAY'),(9044,'STR_MONTH_NOV'),(9045,'STR_MONTH_OCT'),(9046,'STR_MONTH_SEP'),(9047,'STR_IT_CAN_BE'),(9048,'STR_NOTE_THAT_THIS_PLUG_IN_IS_NOT_INCLUDED_AUTOMATICALLY_WITH_THE_STANDARD_NOLAPRO_HOSTING_SERVICE'),(9049,'STR_PURCHASED_HERE'),(9050,'STR_YOU_HAVE_NOT_YET_PURCHASED_THE_EMPLOYEE_TIME_TRACKING_PLUG_IN'),(9051,'STR_CLICK_HERE_FOR_MORE_INFO_ABOUT_THE_NOLAPRO_TIME_TRACKING_SYSTEM_PLUGIN'),(9052,'STR_NOTE_THAT_CUSTMERS_CHOOSING_THE_ON_DEMAND_HOSTING_SOLUCTION_WILL_RECEIVE_ALL_PREMIUM_ADDONS_AT_NO_ADDITIONAL_COST'),(9053,'STR_DAY_FRI'),(9054,'STR_DAY_MON'),(9055,'STR_DAY_SAT'),(9056,'STR_DAY_SUN'),(9057,'STR_DAY_THU'),(9058,'STR_DAY_TUE'),(9059,'STR_DAY_WED'),(9060,'STR_TODAY_IS'),(9061,'STR_B2B_COMPANY_HEADER_GRAPHIC'),(9062,'STR_B2B_COMPANY_PRINT_LOGO'),(9063,'STR_B2B_LOGIN_GRAPHIC'),(9064,'STR_B2B_PRINTOUTS'),(9065,'STR_BACKGROUND_PDF_FILE_FOR_EMAILED_INVOICES'),(9066,'STR_CURRENT_ARTWORK_ON_FILE_AND_UPLOADED_POS'),(9067,'STR_CUSTOM_LOGO_FOR_FOOTER'),(9068,'STR_CUSTOM_LOGO_FOR_LOGIN_PAGE'),(9069,'STR_EMPLOYEE_FILES'),(9070,'STR_FILES_FOR_CUSTOMER'),(9071,'STR_GRAPHIC_FOR_CUSTOMER_GROUP'),(9072,'STR_GRAPHIC_FOR_INVOICE'),(9073,'STR_GRAPHIC_FOR_OPTION'),(9074,'STR_GRAPHIC_FOR_OPTION_GROUP'),(9075,'STR_INTERNAL_JOB_DOCUMENTS'),(9076,'STR_INVENTORY_ITEM_FILES'),(9077,'STR_INVENTORY_ITEM_SUPPLIER_FILES'),(9078,'STR_INVOICE_FILES'),(9079,'STR_ORDER_FILES'),(9080,'STR_PURCHASE_ORDER_FILES'),(9081,'STR_SALES_PERSON_FILES'),(9082,'STR_VENDOR_BILL_FILES'),(9083,'STR_VENDOR_FILES'),(9084,'STR_FIRST_BILLING_DATE_IF_KNOWN'),(9085,'STR_PROJECT_INVOICE'),(9086,'STR_QUICKBOOKS'),(9087,'STR_BIWEEKLY_PERIOD'),(9088,'STR_MONTHLY_PERIOD'),(9089,'STR_SEMIMONTHLY_PERIOD'),(9090,'STR_WEEKLY_PERIOD'),(9091,'STR_INVENTORY_BREAKDOWN_POST_SCRAP_TO_SUBITEMS'),(9092,'STR_COST_PER_PIECE'),(9093,'STR_INVENTORY_BREAKDOWN'),(9094,'STR_ITEM_BREAKDOWN_FAILED'),(9095,'STR_ITEM_BROKEN_DOWN_SUCCESSFULLY'),(9096,'STR_PIECE'),(9097,'STR_QUANTITY_CREATED'),(9098,'STR_QUANTITY_USED'),(9099,'STR_WEIGHT_PER_PIECE'),(9100,'STR_TURN_OFF_AUTO_UNIT_CONVERSION_FOR_QUANTITY_RECEIVED'),(9101,'STR_INVOICE_NEXT_NOW'),(9102,'STR_LAST_INVOICE_NUMBER'),(9103,'STR_NEXT_ITEM_TO_BE_INVOICED'),(9104,'STR_HINT'),(9105,'STR_INVENTORY_ITEM_BREAKDOWN_INTO_SUBCOMPONENTS'),(9106,'STR_ITEM_BREAKDOWN'),(9107,'STR_GL_ACCOUNT_FOR_COST_DIFFERENCE'),(9108,'STR_INVENTORY_ALTER_COSTS'),(9109,'STR_QUANTITY_TO_CHANGE'),(9110,'STR_TOTAL_COST_TO_ADD_OR_SUBTRACT_FROM_ITEMS'),(9111,'STR_ITEM_ALTER_COSTS'),(9112,'STR_ITEM_BREAKDOWN_SCRAP'),(9113,'STR_POST_SCRAP_AS_A_SEPARATE_GL_ENTRY'),(9114,'STR_SPREAD_SCRAP_COST_TO_OTHER_ITEMS_BASED_ON_WEIGHT'),(9115,'STR_DEFAULT_COST_ADJUSTMENT_ACCOUNT'),(9116,'STR_AN_ITEM_AND_A_GL_ACCOUNT_MUST_BE_CHOSEN'),(9117,'STR_INVENTORY_COST_ADJUSTMENTS'),(9118,'STR_ITEM_ADJUSTED_SUCCESSFULLY'),(9119,'STR_NUM_ITEMS_AFFECTED'),(9120,'STR_QUANTITY_TO_CHANGE_AND_TOTAL_COST_MUST_NOT_BE_ZERO'),(9121,'STR_QUANTITY_TO_CHANGE_CANNOT_BE_GREATER_THAN_QUANTITY_ON_HAND'),(9122,'STR_QUANTITY_TO_CHANGE_MUST_BE_GREATER_THAN_ZERO'),(9123,'STR_ITEM_COST_ADJUSTMENTS'),(9124,'STR_BACKGROUND_PDF_FILE_FOR_EMAILED_INVOICES_AFTER_PAGE_ONE'),(9125,'STR_TURN_OFF_AUTO_UNIT_CONVERSION_FOR_QTY_BOXES'),(9126,'STR_COULD_NOT_FIND_REQUESTED_ORDER'),(9127,'STR_ERROR_RETRIEVING_ORDER'),(9128,'STR_GET_ORDER'),(9129,'STR_THE_QUANTITY_ORDERED_CANNOT_BE_LESS_THAN_THE_QUANTITY_ALREADY_SHIPPED'),(9130,'STR_YOU_WILL_LOSE_ANY_UNSAVED_CHANGES'),(9131,'STR_FIND_ORDERS'),(9132,'STR_CANNOT_DELETE_LINE_BECAUSE_ITEM_HAS_SHIPMENTS'),(9133,'STR_ORDER_HAS_BEEN_BILLED'),(9134,'STR_ORDER_PARTIALLY_SHIPPED'),(9135,'STR_SEARCH_BY_ORDER_NUMBER_OR_CUSTOMER_NAME'),(9136,'STR_CLIENT_CHECK'),(9137,'STR_INVOICE_AMOUNT'),(9138,'STR_NOT_BILLED'),(9139,'STR_DELETE_QUOTE'),(9140,'STR_UNCONFIRMED_ORDER'),(9141,'STR_DEPOSIT_SAVED_SUCCESSFULLY'),(9142,'STR_ERROR_SAVING_DEPOSIT'),(9143,'STR_ORDER_DEPOSIT'),(9144,'STR_BACK_TO_QUOTE'),(9145,'STR_CANNOT_DELETE_ORDER_ORDER_HAS_BEEN_SHIPPED_OR_BILLED'),(9146,'STR_CANNOT_DELETE_ORDER_ORDER_HAS_DEPOSIT_ATTACHED'),(9147,'STR_ORDER_DELETED_SUCCESSFULLY'),(9148,'STR_CUSTOM_FIELDS_FROM_UNWANTED_CUSTOMER_RECORDS'),(9149,'STR_MASTER_CUSTOMER'),(9150,'STR_MERGE_CUSTOMER_RECORDS_INTO_THIS_MASTER_CUSTOMER_RECORD'),(9151,'STR_MERGE_FROM_THESE_UNWANTED_CUSTOMER_RECORDS_INTO_THE_MASTER_CUSTOMER_SELECTED_ABOVE'),(9152,'STR_UNWANTED_CUSTOMER'),(9153,'STR_MERGE_FROM_THESE_SHIPTO_RECORDS_INTO_SHIPTO_SELECTED_ABOVE'),(9154,'STR_MERGE_SHIPTO_RECORDS_INTO_THIS_SHIPTO_RECORD'),(9155,'STR_SUPPRESS_LINE_NUMBER_ON_PO'),(9156,'STR_AVG_ORDERS_PER_DAY'),(9157,'STR_AVG_SALES_AMOUNT_PER_DAY'),(9158,'STR_AVG_SALE_AMOUNT'),(9159,'STR_COGS_GL_ACCOUNT'),(9160,'STR_PARENT_ITEMCODE_FOR_ITEM_FAMILY'),(9161,'STR_STOCK_UNITS_PER_PURCHASE_UNIT'),(9162,'STR_VENDOR_PURCHASE_UNIT'),(9163,'STR_ENTER_SEARCH_INFO_FOR_ACTIVITY'),(9164,'STR_ALLOW_OVERRIDE_OF_INVOICE_NUMBER'),(9165,'STR_INVOICE_NUMBER_TO_USE'),(9166,'STR_INVOICE_NUMBER_TO_USE_FOR_ORDER'),(9167,'STR_LEAVE_NUMBER_BLANK_FOR_COMPUTER_TO_ASSIGN_NUMBER_AUTOMATICALLY'),(9168,'STR_POS_ONLY'),(9169,'STR_YOU_MUST_ENTER_SOME_SEARCH_CRITERIA_FIRST'),(9170,'STR_POS_PAGE'),(9171,'STR_POS_SYSTEM'),(9172,'STR_LEAVE_BLANK_TO_AUTO_ASSIGN'),(9173,'STR_INVOICE_NUMBER_ALREADY_IN_USE_SO_CHANGED_TO'),(9174,'STR_POS_ACCESS_ONLY'),(9175,'STR_SPECIAL_ACCESS_RIGHTS'),(9176,'STR_MEMO_LINE_FOR_ALL_PAY_CHECKS'),(9177,'STR_BASE_AMOUNT'),(9178,'STR_CLIENT_CHECKS'),(9179,'STR_COMMISSION'),(9180,'STR_GST_ON_COMMISSION'),(9181,'STR_PAID_INVOICES'),(9182,'STR_TAX_AND_WGC_FRINGES'),(9183,'STR_UNPAID_INVOICES'),(9184,'STR_WGC_DEDUCTION'),(9185,'STR_MARKETING_FUND_REPORT'),(9186,'STR_COMBINE_WITH_OTHER_PERIOD_FOR_TAX_CALCULATIONS'),(9187,'STR_DO_NOT_COMBINE'),(9188,'STR_ADD_NEW_SURVEY'),(9189,'STR_ADD_QUESTION'),(9190,'STR_ADD_QUESTION_FOR'),(9191,'STR_ADD_UPDATE_QUESTIONS_FOR_SURVEY'),(9192,'STR_CREATE_A_NEW_SURVEY'),(9193,'STR_CURRENT_QUESTIONS_FOR'),(9194,'STR_ERROR_ADDING_NEW_SURVEY'),(9195,'STR_GENERATE_A_URL'),(9196,'STR_HEADING'),(9197,'STR_SURVEY_ADDED_SUCCESSFULLY'),(9198,'STR_SURVEY_MANAGER'),(9199,'STR_SURVEY_NAME'),(9200,'STR_SURVEY_UPDATED_SUCCESSFULLY'),(9201,'STR_TEXT_AREA'),(9202,'STR_YOU_MUST_ENTER_A_NAME_FOR_THE_SURVEY'),(9203,'STR_CREATE_URL'),(9204,'STR_DO_YOU_WANT_TO_LIMIT_THE_NUMBER_OF_SURVEYS_THAT_CAN_BE_TAKEN_WITH_THIS_URL'),(9205,'STR_GENERATE_SURVEY_URL'),(9206,'STR_INVOICE_ID'),(9207,'STR_INVOICE_NUMBER_OR_CUSTOMER_NAME'),(9208,'STR_MAKE_LINK_UNIQUE'),(9209,'STR_NO_SURVEY_ID_SET'),(9210,'STR_ORDER_NUMBER_OR_CUSTOMER_NAME'),(9211,'STR_PICK_A_SURVEY_RECIPIENT_BELOW_OR_LEAVE_BLANK'),(9212,'STR_SO_THIS_URL_CAN_ONLY_BE_USED_FOR_ONE_SURVEY'),(9213,'STR_SURVEY_URL'),(9214,'STR_URL_GENERATED_SUCCESSFULLY'),(9215,'STR_ERROR_RETRIEVING_SURVEY'),(9216,'STR_ERROR_SAVING_SURVEY'),(9217,'STR_ERROR_SAVING_YOUR_INFORMATION'),(9218,'STR_SURVEY_LINK_IS_INVALID'),(9219,'STR_SURVEY_NOT_FOUND'),(9220,'STR_SURVEY_VALIDATION_FAILED'),(9221,'STR_THIS_SURVEY_HAS_ALREADY_BEEN_COMPLETED'),(9222,'STR_YOUR_INFORMATION_HAS_BEEN_SAVED_SUCCESSFULLY'),(9223,'STR_YOU_MAY_NOW_CLOSE_THIS_PAGE'),(9224,'STR_EMAILED_TO'),(9225,'STR_SURVEY'),(9226,'STR_SURVEY_EMAILED'),(9227,'STR_SURVEY_REQUEST'),(9228,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_THIS_SURVEY'),(9229,'STR_DEFAULT_EMAIL_TEXT'),(9230,'STR_SURVEY_DELETED_SUCCESSFULLY'),(9231,'STR_SURVEY_TYPE'),(9232,'STR_VIEW_RESULTS'),(9233,'STR_COMPLETION_ID'),(9234,'STR_DATE_COMPLETED'),(9235,'STR_SURVEY_COMPLETION_ID'),(9236,'STR_SURVEY_REPORTS'),(9237,'STR_TOTAL_SURVEYS_COMPLETED'),(9238,'STR_TYPE_ID'),(9239,'STR_VIEW_SURVEY'),(9240,'STR_EMAIL_SURVEY'),(9241,'STR_SELECT_SURVEY'),(9242,'STR_DEFAULT_CHECK_ACCOUNT_FOR_CLIENT_PAYMENTS'),(9243,'STR_PROJECT_DEFAULTS'),(9244,'STR_SURVEYS'),(9245,'STR_SURVEY_HEADER_GRAPHIC'),(9246,'STR_BASE_URL'),(9247,'STR_MULTIPLY_CHARGES_BY'),(9248,'STR_INVOICE_EMAILED'),(9249,'STR_ORDER_EMAILED'),(9250,'STR_QUOTE_EMAILED'),(9251,'STR_SERVICE_ORDER_EMAILED'),(9252,'STR_STATEMENT_EMAILED'),(9253,'STR_BREAKDOWN_GROUP'),(9254,'STR_TRUST_TRANSFER_ACCOUNT'),(9255,'STR_COMPANY_ADD_NOT_SUCCESSFUL'),(9256,'STR_SHOW_NEW_LIST'),(9257,'STR_BARCODE_LIST'),(9258,'STR_INCLUDE_USERS_ALL_COMPANIES'),(9259,'STR_NO_RIGHTS_2'),(9260,'STR_CHECK_TO_INCLUDE_COLUMN_FOR_THIS_ON_REPORT'),(9261,'STR_DETAILED_REPORT'),(9262,'STR_FILTER_VALUES'),(9263,'STR_INVENTORY_SALES_HISTORY'),(9264,'STR_INVENTORY_SALES_HISTORY_FOR'),(9265,'STR_NO_MATCHING_SALES_FOUND'),(9266,'STR_PROFIT_AMOUNT'),(9267,'STR_PROFIT_PERCENT'),(9268,'STR_PROFIT_PERCENTAGE'),(9269,'STR_REPORT_DETAIL'),(9270,'STR_REPORT_PREFERENCES'),(9271,'STR_SALE_VALUE'),(9272,'STR_SORT_REPORT_BY'),(9273,'STR_SUBTOTAL_BY'),(9274,'STR_SUMMARY_ONLY'),(9275,'STR_TOTAL_FOR_REPORT'),(9276,'STR_LEAVE_BLANK_IF_CUSTOMER_PICKUP'),(9277,'STR_IS_LESS_THAN_WEIGHT_OF_SUB_PARTS_OF'),(9278,'STR_ORIGINAL_QUANTITY_MUST_HAVE_A_VALUE'),(9279,'STR_TOTAL_STARTING_WEIGHT'),(9280,'STR_PREFER_CLASSIC_POS_CLICK_HERE'),(9281,'STR_INVENTORY_HISTORY'),(9282,'STR_NOT_TIED_TO_SALES_PERSON'),(9283,'STR_USER_IS_THIS_SALES_PERSON'),(9284,'STR_MY_OPEN_ORDERS'),(9285,'STR_VIEW_MY_OPEN_ORDERS_REPORT'),(9286,'STR_MY_ORDERS'),(9287,'STR_EMAIL_SIMPLE_STATEMENT'),(9288,'STR_PRINT_SIMPLE_STATEMENT'),(9289,'STR_45_DAYS'),(9290,'STR_ERROR_IMPORTING_CUSTOMER'),(9291,'STR_ERROR_IMPORTING_ERRORS'),(9292,'STR_IMPORT_ORDERS'),(9293,'STR_MAIN_ORDER_FILE'),(9294,'STR_ORDERS_IMPORTED_SUCCESSFULLY'),(9295,'STR_ORDER_DETAILS_FILE'),(9296,'STR_THE_MAIN_ORDER_FILE_IS_NOT_IN_THE_PROPER_FORMAT'),(9297,'STR_THE_ORDER_DETAILS_FILE_IS_NOT_IN_THE_PROPER_FORMAT'),(9298,'STR_UPLOAD_ORDER_FILES'),(9299,'STR_YOU_MUST_SUBMIT_AN_ORDER_DETAILS_FILE'),(9300,'STR_YOU_MUST_SUBMIT_A_MAIN_ORDER_FILE'),(9301,'STR_SALESMAN_OPEN_ORDERS'),(9302,'STR_VIEW_SALESMAN_OPEN_ORDERS_REPORT'),(9303,'STR_OPEN_ORDERS_SALESMAN'),(9304,'STR_DISPLAY_PROFIT_ON_POS_PAGE'),(9305,'STR_COMPANY_TIME_ZONE'),(9306,'STR_USE_SYSTEM_TIME'),(9307,'STR_ERROR_ADDING_ITEMS'),(9308,'STR_IMPORT_ITEMS_FROM_UPC_FILE'),(9309,'STR_INVALID_UPC_FILE_SUBMITTED'),(9310,'STR_UPC_FILE'),(9311,'STR_UPLOAD_UPC_FILE'),(9312,'STR_YOU_MUST_SUBMIT_A_UPC_FILE'),(9313,'STR_NO_ITEMS_PASSED_IN'),(9314,'STR_INCLUDE_ONLY_ON_HAND_ITEMS'),(9315,'STR_BARCODES_GENERATED_SUCCESSFULLY'),(9316,'STR_CREATE_BARCODES'),(9317,'STR_NUMBER_OF_BARCODES'),(9318,'STR_PRINT_BARCODES'),(9319,'STR_GENERAL_PAYABLES'),(9320,'STR_GENERAL_RECEIVABLES'),(9321,'STR_FULFILLMENT_ORDER_MODE'),(9322,'STR_POINT_OF_SALE_MODE'),(9323,'STR_DEFAULT_PAYMENT_METHOD'),(9324,'STR_DISPLAY_PROFIT'),(9325,'STR_DISPLAY_WEIGHTS'),(9326,'STR_HIDE_DISCOUNTS_ENTRY'),(9327,'STR_HIDE_INVENTORY_STATS'),(9328,'STR_HIDE_POS_FULFILLMENT_MODE_SWITCH'),(9329,'STR_INVOICE_USING_ORDER_DATE_RATHER_THAN_CURRENT_DATE'),(9330,'STR_POS_FULFILLMENT_ORDER_PAGE'),(9331,'STR_DYNAMIC_ORDER_PAGE'),(9332,'STR_TOTAL_COST_ADJUSTMENT'),(9333,'STR_COPY_ALL_ITEM_VENDOR_INFORMATION_FROM_VENDOR_ONE_TO_VENDOR_TWO'),(9334,'STR_COPY_DATA'),(9335,'STR_UPDATE_SINGLE_ITEM_VENDOR'),(9336,'STR_VENDOR_ONE'),(9337,'STR_VENDOR_TWO'),(9338,'STR_ADD_NEW_CURRENCY'),(9339,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_THIS_CURRENCY'),(9340,'STR_CANNOT_ADD_CURRENCY'),(9341,'STR_CURRENCY'),(9342,'STR_CURRENCY_ADDED_SUCCESSFULLY'),(9343,'STR_CURRENCY_ADD_UPDATE'),(9344,'STR_CURRENCY_CODE_IS_ALREADY_IN_USE'),(9345,'STR_CURRENCY_DELETED_SUCCESSFULLY'),(9346,'STR_CURRENCY_UPDATED_SUCCESSFULLY'),(9347,'STR_DECIMAL_PLACES'),(9348,'STR_ERROR_ADDING_CURRENCY'),(9349,'STR_ERROR_DELETING_CURRENCY'),(9350,'STR_ERROR_LOOKING_UP_CURRENCY'),(9351,'STR_ERROR_UPDATING_CURRENCY'),(9352,'STR_SYMBOL_AFTER_AMOUNT'),(9353,'STR_SYMBOL_BEFORE_AMOUNT'),(9354,'STR_UNIT_DECIMAL_PLACES'),(9355,'STR_YOU_MUST_ENTER_A_CODE'),(9356,'STR_ADD_EDIT_ACTIVATE_CURRENCIES'),(9357,'STR_BASE_CURRENCY'),(9358,'STR_SAVE_GENERAL_INVOICE_INFO'),(9359,'STR_THIS_INVOICE_HAS_ALREADY_BEEN_POSTED'),(9360,'STR_THIS_WILL_ONLY_SAVE_THE_GENERAL_INVOICE_INFO_CONTAINED_ABOVE'),(9361,'STR_YOU_MUST_UNPOST_FIRST_IF_YOU_WANT_TO_SAVE_LINE_ITEM_CHANGES'),(9362,'STR_INVENTORY_REALIGNMENT'),(9363,'STR_PO_UPDATE_FAILED'),(9364,'STR_CANADIAN_CURRENCY'),(9365,'STR_SHOW_WHICH'),(9366,'STR_US_CURRENCY'),(9367,'STR_ORDERED_TIME_ENTRY_FOR_SERVICE_ORDER'),(9368,'STR_CREDITS_REPORT'),(9369,'STR_INVOICE_SUMMARY_REPORT'),(9370,'STR_CREDITS_LIST'),(9371,'STR_CHECK_TO_PAY_ON_HOLD_ONLY'),(9372,'STR_BLOCK_USAGE_ON_B2B_ORDERS'),(9373,'STR_BLOCK_USAGE_ON_POS_ORDERS'),(9374,'STR_BLOCK_ON_B2B_ORDERS'),(9375,'STR_BLOCK_ON_POS_ORDERS'),(9376,'STR_BANK_AUTHORIZATION_CODE'),(9377,'STR_BILLING_ADDRESS'),(9378,'STR_BILLING_CITY'),(9379,'STR_BILLING_STATE'),(9380,'STR_BILLING_ZIP'),(9381,'STR_RECORD_ID'),(9382,'STR_ADD_FREE_SHIPPING_OPTION'),(9383,'STR_FREE_SHIPPING_OPTIONS'),(9384,'STR_FREE_SHIPPING_OPTION_DELETED_SUCCESSFULLY'),(9385,'STR_FREE_SHIPPING_OPTION_SET_UP_SUCCESSFULLY'),(9386,'STR_FREE_SHIPPING_OVER'),(9387,'STR_FREE_SHIPPING_OVER_AMOUNT'),(9388,'STR_SHIP_METHODS'),(9389,'STR_TITLE_CANNOT_BE_BLANK'),(9390,'STR_JOBS'),(9391,'STR_JOB_SEARCH'),(9392,'STR_NEW_JOB'),(9393,'STR_EXEMPT_WAGES_PER_YEAR'),(9394,'STR_TAXABLE_PAY_LESS_INCOME_TAX'),(9395,'STR_TAXABLE_PAY_LESS_SS_TAX'),(9396,'STR_EXEMPT_WAGES_YEAR'),(9397,'STR_ADD_FICA_PAID_TO_INCOME_TAX_EXEMPTION'),(9398,'STR_NON_US_ONLY'),(9399,'STR_ANNUAL_FEDERAL_EXEMPTION'),(9400,'STR_ONLY_ENTER_IF_IGNORING_EXEMPTION_COUNT'),(9401,'STR_DECIMAL_SYMBOL'),(9402,'STR_THOUSANDS_SEPARATOR'),(9403,'STR_CREDIT_CARD_CHARGE_COULD_NOT_BE_VOIDED'),(9404,'STR_CREDIT_CARD_CHARGE_SUCCESSFULLY_REVERSED'),(9405,'STR_CREDIT_CARD_CHARGE_SUCCESSFULLY_VOIDED'),(9406,'STR_PLEASE_MANUALLY_VOID_THE_CREDIT_CARD_CHARGE_OUTSIDE_OF_NOLAPRO'),(9407,'STR_THE_TRANSACTION_SET_IS_NOT_BALANCED'),(9408,'STR_INVOICE_VIEW_CANCEL'),(9409,'STR_APPLY_FICA_MAX_PER_PERIOD_NOT_YEAR'),(9410,'STR_TIMECLOCK_BLOCK_VIEW_OF_OTHER_LOGINS'),(9411,'STR_CURRENCY_TRADING_ACCOUNT'),(9412,'STR_YOU_MUST_ENTER_A_TRADING_ACCOUNT'),(9413,'STR_CURRENCY_RATES_UPDATED_SUCCESSFULLY'),(9414,'STR_CURRENCY_RATE_MANAGER'),(9415,'STR_HISTORICAL_CURRENCY_RATES'),(9416,'STR_STORED_CONVERSION_RATES'),(9417,'STR_YOU_CAN_USE_THE_FOLLOWING_LINK_TO_GET_HISTORICAL_CURRENCY_CONVERSION_RATES'),(9418,'STR_INVOICE_FILE'),(9419,'STR_SELECT_INVOICE_FILE'),(9420,'STR_THE_INVOICE_FILE_IS_NOT_IN_THE_PROPER_FORMAT'),(9421,'STR_YOU_MUST_SUBMIT_AN_INVOICE_FILE'),(9422,'STR_NET_DUE_DATE_ON_FOLLOWING_MONTH'),(9423,'STR_NO_RATE_AVAILABLE'),(9424,'STR_DEMO_ACCOUNTS_LOG_IN_WITH'),(9425,'STR_WEB_BASED_BUSINESS_MANAGEMENT'),(9426,'STR_SYSTEM_LANGUAGE'),(9427,'STR_ALL_FIELDS_ARE_REQUIRED'),(9428,'STR_PLEASE_TRY_AGAIN'),(9429,'STR_DO_NOT_ALLOW_SHIP_IF_MISSING_COSTS_ON_FULFILLMENT_ORDER'),(9430,'STR_DEFAULT_CATEGORY_FOR_OSCOMMERCE_ORDERS'),(9431,'STR_DEFAULT_VALUES_SAVED_SUCCESSFULLY'),(9432,'STR_ERROR_SAVING_DEFAULT_VALUES'),(9433,'STR_OSCOMMERCE_INTEGRATION_DEFAULTS'),(9434,'STR_NOLAPRO_API_LOGGING'),(9435,'STR_SHIPMENT_CANCELLED_DUE_TO_ITEM_WITH_NO_COST'),(9436,'STR_OSCOMMERCE_INTEGRATION'),(9437,'STR_DEFAULT_PRICE_UNIT'),(9438,'STR_DEFAULT_SALES_CATEGORY'),(9439,'STR_DEFAULT_SELL_UNIT'),(9440,'STR_GL_ACCOUNT_COMPANY_FIX'),(9441,'STR_PROCESS_THIS_ORDER'),(9442,'STR_API_KEY'),(9443,'STR_AVAILABLE_API_ACCOUNTS'),(9444,'STR_OSCOM_ADMIN_LOGIN'),(9445,'STR_OSCOM_ADMIN_PASSWORD'),(9446,'STR_OSCOM_ADMIN_URL'),(9447,'STR_OSCOM_DATABASE_HOST_NAME'),(9448,'STR_OSCOM_DATABASE_NAME'),(9449,'STR_OSCOM_DATABASE_PASSWORD'),(9450,'STR_OSCOM_DATABASE_USER_NAME'),(9451,'STR_DEFAULT_CURRENCY'),(9452,'STR_ALL_MONETARY_AMOUNTS_IN_THIS_SECTION_EXPRESSED_IN'),(9453,'STR_COMMISSION_INCOME'),(9454,'STR_TRUST_PAYABLES'),(9455,'STR_ASSIGN_A_BANK_ACCOUNT_IN_THIS_CURRENCY_TO_A_CC_ACCOUNT_IN_THE_CC_ACCOUNT_SETUP_AREA'),(9456,'STR_CANNOT_PROCESS_CREDIT_CARD_TRANSACTION'),(9457,'STR_CANNOT_PROCESS_PAYMENT'),(9458,'STR_NO_BANK_ACCOUNTS_EXIST_FOR_THIS_CURRENCY'),(9459,'STR_NO_CC_ACCOUNTS_EXIST_FOR_THIS_CURRENCY'),(9460,'STR_PROJECT_TOTAL'),(9461,'STR_INVOICE_SUMMARY_BY_STATE'),(9462,'STR_SUMMARY_OF_INVOICES_BY_STATE'),(9463,'STR_CANNOT_USE_THIS_FUNCTION_WHEN_USING_ACTUAL_ITEM_PRICES_PLUG_IN'),(9464,'STR_VERIFY_AND_CORRECT_ITEM_BALANCES'),(9465,'STR_BEGIN_PERIOD_USING_WEIGHTED_AVG'),(9466,'STR_END_PERIOD_USING_WEIGHTED_AVG'),(9467,'STR_INVOICES_BY_STATE'),(9468,'STR_VERIFY_INVENTORY'),(9469,'STR_AUTO_SELECT_PAYMENTS_ON_BANK_DEPOSIT_ADD_PAGE'),(9470,'STR_INVENTORY_SUCCESSFULLY_VERIFIED'),(9471,'STR_ITEMS_FROM_THIS_PURCHASE_ALREADY_SOLD_CANNOT_UNRECEIVE'),(9472,'STR_PASSED_TO_PAYABLES_DELETE_BILL_FIRST'),(9473,'STR_COULD_NOT_FIND_MATCH'),(9474,'STR_GL_AMOUNT'),(9475,'STR_ITEM_TRACKER_REPORT'),(9476,'STR_MIGHT_BE_IN_THIS_VOUCHER'),(9477,'STR_TO_GL_ACCOUNT'),(9478,'STR_ACCOUNT_SUBTYPE'),(9479,'STR_ADJUSTMENTS_OR_BREAKDOWNS'),(9480,'STR_GL_INVENTORY_ACCOUNT_FOR_GL_INVENTORY_REPORT_OPTION'),(9481,'STR_GL_INVENTORY_REPORT'),(9482,'STR_ORDER_BY_ACTION'),(9483,'STR_ORDER_BY_ITEM'),(9484,'STR_REPORT_TYPE'),(9485,'STR_SALE_USE'),(9486,'STR_TRACKING_REPORT_FOR'),(9487,'STR_BLOCK_AR_REPORTS'),(9488,'STR_IF_USER_HAS_AR_READ_RIGHTS'),(9489,'STR_LEAVE_BLANK_FOR_ALL_STATES'),(9490,'STR_SUMMARY_REPORT'),(9491,'STR_VENDOR_BILL'),(9492,'STR_COST_CODE'),(9493,'STR_SETUP_CATEGORIES_AS_TRANSACTION_IDENTIFIERS'),(9494,'STR_SETUP_COST_CODES_AS_TRANSACTION_IDENTIFIERS'),(9495,'STR_SETUP_TRANSACTION_ID'),(9496,'STR_SETUP_TRANSACTION_IDENTIFIERS'),(9497,'STR_USE_JOB_AS_TRANSACTION_IDENTIFIER'),(9498,'STR_COST_TYPES'),(9499,'STR_SETUP_CATEGORY_COST_TYPES'),(9500,'STR_CATEGORIES_FOR_TRANSACTION_IDENTIFIER'),(9501,'STR_CATEGORY_DESCRIPTION'),(9502,'STR_CATEGORY_TRANSACTION_IDENTIFIER'),(9503,'STR_COST_TYPE'),(9504,'STR_PRINT_LIST'),(9505,'STR_CATEGORY_TRANSACTION_IDENTIFIER_COST_TYPES'),(9506,'STR_COST_TYPE_DESCRIPTION'),(9507,'STR_COST_CODES_FOR_TRANSACTION_IDENTIFIER'),(9508,'STR_COST_CODE_DESCRIPTION'),(9509,'STR_COST_CODE_TRANSACTION_IDENTIFIER'),(9510,'STR_GENERAL_INFORMATION_ABOUT_TRANSACTION_IDENTIFIERS'),(9511,'STR_IS_CATEGORY_A_REQUIRED_ENTRY_FIELD'),(9512,'STR_IS_COST_CODE_A_REQUIRED_ENTRY_FIELD'),(9513,'STR_IS_JOB_A_REQUIRED_ENTRY_FIELD'),(9514,'STR_YES_ALWAYS'),(9515,'STR_GENERAL_INFORMATION_FOR_TRANSACTION_IDENTIFIER'),(9516,'STR_BLOCK_SALESMAN_FROM_SEEING_ORDERS_AND_CUSTOMERS_OTHER_THAN_OWN'),(9517,'STR_SALESMAN_MUST_BE_ATTACHED_TO_SPECIFIC_USER'),(9518,'STR_SHOW_SALESPERSON_CONTACT_INFO_ON_CONFIRMATION_AND_PICK_LIST'),(9519,'STR_NEGATIVE_ADJUSTMENTS_WILL_IGNORE_ENTERED_TOTAL_COST_AND_USE_ACTUAL_COST_INSTEAD'),(9520,'STR_LAST_USED_ORDER_NUMBER'),(9521,'STR_SET_NEXT_ORDER_NUMBER'),(9522,'STR_DICOUNT_DATE_ON_FOLLOWING_MONTH'),(9523,'STR_DEFAULT_WORK_TYPE'),(9524,'STR_ADD_SERVICE_SUBTYPES_FOR'),(9525,'STR_ADD_SUBTYPE'),(9526,'STR_ERROR_SAVING_SUBTYPE'),(9527,'STR_MUST_HAVE_A_SUBTYPE_NAME'),(9528,'STR_SERVICE_SUBTYPES'),(9529,'STR_SERVICE_SUBTYPES_ADD_UPDATE'),(9530,'STR_SERVICE_SUBTYPE_DELETED_SUCCESSFULLY'),(9531,'STR_SERVICE_SUBTYPE_NAME'),(9532,'STR_SERVICE_SUBTYPE_SAVED_SUCCESSFULLY'),(9533,'STR_YOU_MUST_FIRST_ENTER_A_SERVICE_TYPE'),(9534,'STR_BUILDING'),(9535,'STR_BUILDINGS_ADD'),(9536,'STR_BUILDINGS_DELETE'),(9537,'STR_BUILDINGS_UPDATE'),(9538,'STR_BUILDING_ADDED_FAILURE'),(9539,'STR_BUILDING_ADDED_SUCCESSFULLY'),(9540,'STR_BUILDING_DELETED_FAILURE'),(9541,'STR_BUILDING_DELETED_SUCCESSFULLY'),(9542,'STR_BUILDING_TYPE'),(9543,'STR_BUILDING_UPDATED_FAILURE'),(9544,'STR_BUILDING_UPDATED_SUCCESSFULLY'),(9545,'STR_DELETE_BUILDING'),(9546,'STR_LEASING_AGENT'),(9547,'STR_MANAGEMENT_FEE'),(9548,'STR_OVERAGE_CAP'),(9549,'STR_PLEASE_INCLUDE_BUILDING_TYPE'),(9550,'STR_PLEASE_INCLUDE_LEASING_AGENT'),(9551,'STR_PLEASE_INCLUDE_NAME'),(9552,'STR_PLEASE_INCLUDE_UTILITIES_CHARGE'),(9553,'STR_UTILITIES_CHARGE'),(9554,'STR_BUILDING_OWNERSHIP'),(9555,'STR_BUILDING_OWNERSHIPS_ADD'),(9556,'STR_BUILDING_OWNERSHIPS_DELETE'),(9557,'STR_BUILDING_OWNERSHIPS_UPDATE'),(9558,'STR_BUILDING_OWNERSHIP_ADDED_FAILURE'),(9559,'STR_BUILDING_OWNERSHIP_ADDED_SUCCESSFULLY'),(9560,'STR_BUILDING_OWNERSHIP_DELETED_FAILURE'),(9561,'STR_BUILDING_OWNERSHIP_DELETED_SUCCESSFULLY'),(9562,'STR_BUILDING_OWNERSHIP_UPDATED_FAILURE'),(9563,'STR_BUILDING_OWNERSHIP_UPDATED_SUCCESSFULLY'),(9564,'STR_CURRENT_OWNERSHIP'),(9565,'STR_PERCENT_OWNERSHIP'),(9566,'STR_PERCENT_OWNERSHIP_OVER_100_PERCENT'),(9567,'STR_PLEASE_INCLUDE_BUILDING'),(9568,'STR_PLEASE_INCLUDE_COMPANY'),(9569,'STR_PLEASE_INCLUDE_PERCENT_OWNERSHIP'),(9570,'STR_BUILDING_TYPES_ADD'),(9571,'STR_BUILDING_TYPES_DELETE'),(9572,'STR_BUILDING_TYPES_UPDATE'),(9573,'STR_BUILDING_TYPE_ADDED_FAILURE'),(9574,'STR_BUILDING_TYPE_ADDED_SUCCESSFULLY'),(9575,'STR_BUILDING_TYPE_ATTACHED_TO_BUILDING'),(9576,'STR_BUILDING_TYPE_DELETED_FAILURE'),(9577,'STR_BUILDING_TYPE_DELETED_SUCCESSFULLY'),(9578,'STR_BUILDING_TYPE_UPDATED_FAILURE'),(9579,'STR_BUILDING_TYPE_UPDATED_SUCCESSFULLY'),(9580,'STR_ACADEMIC_YEAR'),(9581,'STR_PLEASE_INCLUDE_RENT_PERIOD'),(9582,'STR_RENT_AMOUNT'),(9583,'STR_RENT_PERIOD'),(9584,'STR_SEMESTER'),(9585,'STR_SEMI_MONTHLY'),(9586,'STR_SEMI_YEARLY'),(9587,'STR_SUBNAME'),(9588,'STR_UNITS_ADD'),(9589,'STR_UNITS_DELETE'),(9590,'STR_UNITS_UPDATE'),(9591,'STR_UNIT_ADDED_FAILURE'),(9592,'STR_UNIT_ADDED_SUCCESSFULLY'),(9593,'STR_UNIT_DELETED_FAILURE'),(9594,'STR_UNIT_DELETED_SUCCESSFULLY'),(9595,'STR_UNIT_UPDATED_FAILURE'),(9596,'STR_UNIT_UPDATED_SUCCESSFULLY'),(9597,'STR_BY_WORK_TYPE'),(9598,'STR_FILTER_BY_WORK_TYPE'),(9599,'STR_BILL_INTO_HOW_MANY_EQUAL_PARTS'),(9600,'STR_ALL_SORT_BY_CATEGORY'),(9601,'STR_ADVANCED_USER_RIGHTS'),(9602,'STR_GROUP_RIGHT_REMOVED_FOR_THIS_USER'),(9603,'STR_NEW_RIGHT_NOT_AVAILABLE_TO_THE_GROUP'),(9604,'STR_NO_USER_ID_SET'),(9605,'STR_SET_DEFAULT_GROUP_ACCESS'),(9606,'STR_YOU_MUST_ENTER_A_RIGHTS_GROUP_FIRST'),(9607,'STR_GROUP_RIGHTS_SAVED_SUCCESSFULLY'),(9608,'STR_NEW_GROUP'),(9609,'STR_USER_RIGHTS_GROUPS'),(9610,'STR_YOU_MUST_ENTER_A_GROUP_NAME'),(9611,'STR_ADVANCED_RIGHTS'),(9612,'STR_POS'),(9613,'STR_CHECKS_GENERATED_PRESS_PRINT_TO_FINISH_PROCESSING'),(9614,'STR_ALL_ACCOUNTS_SPECIFIC_JOB'),(9615,'STR_EDIT_ALL_ACCOUNTS'),(9616,'STR_EDIT_THIS_ACCOUNT'),(9617,'STR_UPDATE_JOB_BUDGET'),(9618,'STR_DELETE_THIS_RECURRING_VOUCHER'),(9619,'STR_EDIT_RECURRING_LEDGER_ENTRIES'),(9620,'STR_OR_REQUIRED_JOB_NOT_SELECTED'),(9621,'STR_COSTCODE'),(9622,'STR_JOB_CODE'),(9623,'STR_ADDRESS_LINE_1'),(9624,'STR_ADDRESS_LINE_2'),(9625,'STR_DISPLAY_WITH_ROW_ABOVE'),(9626,'STR_FIELD_SAVED_SUCCESSFULLY'),(9627,'STR_LEFT'),(9628,'STR_LINKED_WITH'),(9629,'STR_LINK_TO_CUSTOMER_FIELD'),(9630,'STR_PHONE_ONE_COMMENT'),(9631,'STR_PHONE_TWO_COMMENT'),(9632,'STR_TITLE_LOCATION'),(9633,'STR_TOP'),(9634,'STR_WIDTH_PERCENT'),(9635,'STR_NUMBER_PLUS_SELECT'),(9636,'STR_YOU_MUST_BE_A_SUPERVISOR_TO_EDIT_USER_RIGHTS'),(9637,'STR_CONFIRM_FORM_SUBMISSION'),(9638,'STR_PLEASE_COMPLETE_REQUIRED_FIELD'),(9639,'STR_PLEASE_ENTER_A_PASSWORD'),(9640,'STR_PLEASE_ENTER_A_USERNAME'),(9641,'STR_THE_USERNAME_OR_PASSWORD_WAS_INCORRECT'),(9642,'STR_USERNAME'),(9643,'STR_YOU_HAVE_BEEN_LOGGED_OUT'),(9644,'STR_BACKGROUND_CHECKS'),(9645,'STR_LATE_PAYMENTS'),(9646,'STR_LEASES'),(9647,'STR_MANAGE_TENANTS'),(9648,'STR_PLEASE_LOG_IN'),(9649,'STR_PROPERTY_AVAILABILITY'),(9650,'STR_PROPERTY_LIST'),(9651,'STR_PROPERTY_MANAGEMENT_SYSTEM'),(9652,'STR_PROPERTY_OCCUPATION'),(9653,'STR_PROSPECTS'),(9654,'STR_QUESTIONNAIRES'),(9655,'STR_REQUEST_MAINTENANCE'),(9656,'STR_TENANTS'),(9657,'STR_PO_UNRECEIVE'),(9658,'STR_FOR_INVOICES_CREATED'),(9659,'STR_ACCOUNT_CREATED_LOGIN_NOW'),(9660,'STR_NEW_ACCOUNT'),(9661,'STR_RESET_PASSWORD'),(9662,'STR_ACCOUNT_CREATION_HELP'),(9663,'STR_ACCOUNT_CREATION_HELP_EMAIL_ADDRESS'),(9664,'STR_ACCOUNT_CREATION_HELP_PASSWORD'),(9665,'STR_AN_ACCOUNT_ALREADY_EXISTS'),(9666,'STR_CONTACT_INFORMATION'),(9667,'STR_CONTACT_INFORMATION_HELP'),(9668,'STR_CONTACT_INFORMATION_HELP_MIDDLE_NAME'),(9669,'STR_CREATE_NEW_TENANT_ACCOUNT_DESCRIPTION'),(9670,'STR_CREATE_TENANT_ACCOUNT'),(9671,'STR_LOGIN_INFORMATION'),(9672,'STR_PLEASE_CONFIRM_PASSWORD'),(9673,'STR_PLEASE_INCLUDE_ADDRESS'),(9674,'STR_PLEASE_INCLUDE_CITY'),(9675,'STR_PLEASE_INCLUDE_EMAIL_ADDRESS'),(9676,'STR_PLEASE_INCLUDE_FIRST_NAME'),(9677,'STR_PLEASE_INCLUDE_LAST_NAME'),(9678,'STR_PLEASE_INCLUDE_PASSWORD'),(9679,'STR_PLEASE_INCLUDE_PHONE'),(9680,'STR_PLEASE_INCLUDE_STATE'),(9681,'STR_PLEASE_INCLUDE_ZIP'),(9682,'STR_EMAIL_ADDRESS_NOT_FOUND'),(9683,'STR_EMAIL_BODY1'),(9684,'STR_EMAIL_BODY2'),(9685,'STR_ENTER_EMAIL_ADDRESS'),(9686,'STR_ENTER_NEW_PASSWORD'),(9687,'STR_FURTHER_INSTRUCTIONS'),(9688,'STR_PLEASE_ENTER_AN_EMAIL_ADDRESS'),(9689,'STR_RESET_YOUR_ACCOUNT_PASSWORD'),(9690,'STR_YOUR_PASSWORD_HAS_BEEN_RESET'),(9691,'STR_AMOUNT_LINE'),(9692,'STR_EXCEEDS_MONTHTODATE_BUDGET'),(9693,'STR_EXCEEDS_YEARTODATE_BUDGET'),(9694,'STR_EXCEEDS_MONTH_BUDGET'),(9695,'STR_EXCEEDS_YEAR_BUDGET'),(9696,'STR_BUDGET_UPDATE'),(9697,'STR_GL_ACCOUNT_SELECTED_NOT_FOUND'),(9698,'STR_ADD_JOB_PO'),(9699,'STR_UPDATE_JOB_PO'),(9700,'STR_CREATE_A_NEW_JOB_PURCHASE_ORDER'),(9701,'STR_EDIT_JOB_PO'),(9702,'STR_NEW_JOB_PURCHASE_ORDER'),(9703,'STR_UPDATE_AN_EXISTING_JOB_PURCHASE_ORDER'),(9704,'STR_ALL_TYPES'),(9705,'STR_JOB_TYPE_ONLY'),(9706,'STR_STANDARD_TYPE_ONLY'),(9707,'STR_WHICH_TYPES_OF_PO'),(9708,'STR_MATERIALS_PO'),(9709,'STR_PO_PURPOSE'),(9710,'STR_SUBCONTRACT_PO'),(9711,'STR_NO_BOXES_ON_SB_SHIPTO_VENDOR_ETC'),(9712,'STR_SHOW_PURCHASE_QUANTITY_ONLY_ON_SB'),(9713,'STR_STANDARD_PURCHASE_ORDERS'),(9714,'STR_SUBCONTRACT_ORDERS'),(9715,'STR_SUBCONTRACT_ORDER_FORMAT'),(9716,'STR_SUPPRESS_LINE_NUMBER_ON_SB'),(9717,'STR_PRODUCTION_MANAGER'),(9718,'STR_SITE_MANAGER'),(9719,'STR_SUBCONTRACT_PURCHASE_ORDER'),(9720,'STR_SHOW_GL_ACCOUNT_FOR_LINE_ITEMS_ON_STANDARD_PO_AND_SB'),(9721,'STR_JOB_ADDRESS'),(9722,'STR_SUBCONTRACT'),(9723,'STR_LEASE_APPLICATIONS'),(9724,'STR_SELECT_LEASE_APPLICATION'),(9725,'STR_ADD_LEASE'),(9726,'STR_DEPOSIT_AMOUNT'),(9727,'STR_EDIT_LEASE'),(9728,'STR_INCLUDE_A_DEPOSIT_AMOUNT'),(9729,'STR_INCLUDE_A_PET_DEPOSIT'),(9730,'STR_INCLUDE_A_RENT_AMOUNT'),(9731,'STR_INCLUDE_A_RESERVATION_FEE'),(9732,'STR_LEASES_INSTRUCTIONS'),(9733,'STR_LEASE_ADDED_SUCCESSFULLY'),(9734,'STR_LEASE_BEGIN_DATE'),(9735,'STR_LEASE_DELETED_SUCCESSFULLY'),(9736,'STR_LEASE_END_DATE'),(9737,'STR_LEASE_HELP'),(9738,'STR_LEASE_HELP_INSTRUCTIONS'),(9739,'STR_LEASE_INFORMATION'),(9740,'STR_LEASE_UPDATED_SUCCESSFULLY'),(9741,'STR_NO_LEASES_FOUND'),(9742,'STR_NO_UNITS_FOUND'),(9743,'STR_PET_DEPOSIT'),(9744,'STR_PLEASE_SELECT_AN_END_DATE'),(9745,'STR_PLEASE_SELECT_A_BEGIN_DATE'),(9746,'STR_PLEASE_SELECT_A_BUILDING'),(9747,'STR_PLEASE_SELECT_A_TENANT'),(9748,'STR_PLEASE_SELECT_A_UNIT'),(9749,'STR_RESERVATION_FEE'),(9750,'STR_TENANT'),(9751,'STR_MANAGE_PROSPECTS'),(9752,'STR_MANAGE_PROSPECTS_INSTRUCTIONS'),(9753,'STR_NAME_SEARCH'),(9754,'STR_PREFFERED_AREA'),(9755,'STR_VIEW_APPLICATION'),(9756,'STR_APPLICATION_TYPE'),(9757,'STR_CURRENTLY_SAVED_AS_PROSPECT'),(9758,'STR_CURRENT_APPLICATIONS'),(9759,'STR_CURRENT_LEASES'),(9760,'STR_MANAGE_TENANTS_INSTRUCTIONS'),(9761,'STR_PREFERRED_AREA'),(9762,'STR_TENANT_INFORMATION'),(9763,'STR_TENANT_INFORMATION_HELP'),(9764,'STR_TENANT_INFORMATION_HELP_CHANGING_EMAIL_ADDRESS'),(9765,'STR_TENANT_INFORMATION_HELP_MIDDLE_NAME'),(9766,'STR_TENANT_UPDATED_SUCCESSFULLY'),(9767,'STR_PLEASE_SELECT_PREFERRED_AREA'),(9768,'STR_VIEW_APPLICATION_INSTRUCTIONS'),(9769,'STR_YOU_DO_NOT_HAVE_ACCESS_TO_THIS_FILE'),(9770,'STR_AREA'),(9771,'STR_AREAS_ADD'),(9772,'STR_AREAS_DELETE'),(9773,'STR_AREAS_UPDATE'),(9774,'STR_AREA_ADDED_FAILURE'),(9775,'STR_AREA_ADDED_SUCCESSFULLY'),(9776,'STR_AREA_ATTACHED_TO_BUILDING'),(9777,'STR_AREA_DELETED_FAILURE'),(9778,'STR_AREA_DELETED_SUCCESSFULLY'),(9779,'STR_AREA_UPDATED_FAILURE'),(9780,'STR_AREA_UPDATED_SUCCESSFULLY'),(9781,'STR_DELETE_AREA'),(9782,'STR_AREA_ADD'),(9783,'STR_LEASE_PDF_FILES'),(9784,'STR_PLEASE_SELECT_DATES_THAT_DONT_OVERLAP_WITH_AN_EXISTING_LEASE'),(9785,'STR_SEARCH_LEASES'),(9786,'STR_NO_TENANTS_FOUND'),(9787,'STR_SEARCH_TENANTS'),(9788,'STR_AVAILABILITY_DATE'),(9789,'STR_NO_RESULTS_FOUND'),(9790,'STR_PROPERTY_AVAILABILITY_INSTRUCTIONS'),(9791,'STR_SEARCH_PROPERTIES'),(9792,'STR_BUILDING_OCCUPATION'),(9793,'STR_DAYS_OCCUPIED'),(9794,'STR_PERCENT_OCCUPATION'),(9795,'STR_PROPERTY_OCCUPATION_INSTRUCTIONS'),(9796,'STR_UNIT_OCCUPATION'),(9797,'STR_ADD_STAGE'),(9798,'STR_ALLOWED'),(9799,'STR_ALLOWS_ACTIONS'),(9800,'STR_AUTHORIZED_GROUPS'),(9801,'STR_AUTHORIZED_USERS'),(9802,'STR_AUTOMATIC_TRIGGER'),(9803,'STR_DATA_SAVED_SUCCESSFULLY'),(9804,'STR_ERROR_DELETING_RECORD'),(9805,'STR_ERROR_UPDATING_DATA'),(9806,'STR_PREVENTS_ACTIONS'),(9807,'STR_RECORD_DELETED_SUCCESSFULLY'),(9808,'STR_SELECT_MODULE'),(9809,'STR_STAGE_SETUP'),(9810,'STR_ADD_DISCOUNT'),(9811,'STR_A_DISCOUNT_FOR_THIS_ITEM_AND_CUSTOMER_ALREADY_EXISTS'),(9812,'STR_CUSTOMER_ITEM_DISCOUNTS'),(9813,'STR_DISCOUNT_DELETED_SUCCESSFULLY'),(9814,'STR_DISCOUNT_SAVED_SUCCESSFULLY'),(9815,'STR_FLAT_DISCOUNT'),(9816,'STR_PERCENT_DISCOUNT'),(9817,'STR_SEARCH_DISCOUNTS'),(9818,'STR_YOU_MUST_CHOOSE_AN_ITEM'),(9819,'STR_YOU_MUST_CHOOSE_A_CUSTOMER'),(9820,'STR_YOU_MUST_SET_A_DISCOUNT'),(9821,'STR_EDIT_WORK_DETAILS'),(9822,'STR_SERVICE_ORDER_WORK_DETAILS'),(9823,'STR_WORK_DETAILS_UPDATED_SUCCESSFULLY'),(9824,'STR_PROCESS_STAGE'),(9825,'STR_STAGE'),(9826,'STR_PROCESS_STAGES'),(9827,'STR_YOU_MUST_SPECIFY_A_STAGE_TYPE'),(9828,'STR_ACTION_BLOCKED'),(9829,'STR_AUTOMATED_CHANGE'),(9830,'STR_DELETE_PO'),(9831,'STR_ERROR_CHANGING_STAGE'),(9832,'STR_ERROR_DELETING_NOTE'),(9833,'STR_NEW_STAGE'),(9834,'STR_OLD_STAGE'),(9835,'STR_PURCHASE_ORDERS'),(9836,'STR_STAGE_CHANGED_SUCCESSFULLY'),(9837,'STR_STAGE_DELETED_SUCCESSFULLY'),(9838,'STR_SUBCONTRACT_POS'),(9839,'STR_THE_STAGE_TYPE_DOES_NOT_EXIST'),(9840,'STR_YOU_DO_NOT_HAVE_ACCESS_TO_SET_THIS_STAGE'),(9841,'STR_ADD_APPOINTMENT'),(9842,'STR_APPOINTMENTS'),(9843,'STR_APPOINTMENTS_INSTRUCTIONS'),(9844,'STR_APPOINTMENT_ADDED_SUCCESSFULLY'),(9845,'STR_APPOINTMENT_DELETED_SUCCESSFULLY'),(9846,'STR_APPOINTMENT_HELP'),(9847,'STR_APPOINTMENT_HELP_INSTRUCTIONS'),(9848,'STR_APPOINTMENT_INFORMATION'),(9849,'STR_APPOINTMENT_UPDATED_SUCCESSFULLY'),(9850,'STR_CLICK_HERE_TO_EXPORT_THE_APPOINTMENT_TO_YOUR_CALENDAR'),(9851,'STR_NO_APPOINTMENTS_FOUND'),(9852,'STR_PLEASE_INCLUDE_AN_END_DATE'),(9853,'STR_PLEASE_INCLUDE_A_BEGIN_DATE'),(9854,'STR_PLEASE_INCLUDE_A_TITLE'),(9855,'STR_PROSPECT'),(9856,'STR_SEARCH_APPOINTMENTS'),(9857,'STR_INCLUDE_A_RENT_PERIOD'),(9858,'STR_NUMBER_OF_PAYMENTS'),(9859,'STR_ADD_PROSPECT'),(9860,'STR_CONTACT_INFORMATION_HELP_CHANGING_EMAIL_ADDRESS'),(9861,'STR_CURRENT_APPOINTMENTS'),(9862,'STR_CREATE_NEW_PROSPECT_ACCOUNT_DESCRIPTION'),(9863,'STR_CREATE_PROSPECT_ACCOUNT'),(9864,'STR_PROSPECT_ACCOUNT_CREATED_SUCCESSFULLY'),(9865,'STR_ADD_EDIT_APPOINTMENTS'),(9866,'STR_APPLICATION'),(9867,'STR_PLEASE_INCLUDE_AN_APPLICATION'),(9868,'STR_DELETE_LEASE'),(9869,'STR_LEASE_DELETED_FAILURE'),(9870,'STR_UPLOAD_NEW_LEASE'),(9871,'STR_PRINT_LEASE'),(9872,'STR_TRACK_PO_CHANGES'),(9873,'STR_CONSTRUCTION_JOB_ADD'),(9874,'STR_JOB_ADDED_SUCCESSFULLY'),(9875,'STR_JOB_NOT_ADDED'),(9876,'STR_NOT_OWNED_BY_ASSOCIATED_COMPANY'),(9877,'STR_OWNER_COMPANY'),(9878,'STR_JOB_DELETED_SUCCESSFULLY'),(9879,'STR_JOB_UPDATE'),(9880,'STR_CHANGE_REQUEST'),(9881,'STR_JOB_ID'),(9882,'STR_SHOW_ALL_CHANGE_ORDERS'),(9883,'STR_BUDGET_ONLY'),(9884,'STR_CHANGE_REQUEST_AWAITING_APPROVAL'),(9885,'STR_ADD_NEW_CONSTRUCTION_JOB'),(9886,'STR_CONSTRUCTION_JOBS'),(9887,'STR_EDIT_CONSTRUCTION_JOBS'),(9888,'STR_ENTER_AND_UPDATE_CONSTRUCTION_JOBS'),(9889,'STR_DESTINATION_POINT'),(9890,'STR_ESTIMATE_ONLY'),(9891,'STR_FOB_POINT'),(9892,'STR_RETAINAGE_PERCENT'),(9893,'STR_SHIPPING_POINT'),(9894,'STR_DEVELOPER_KEY_SAVED_SUCCESSFULLY'),(9895,'STR_EDIT_DEVELOPER_KEY'),(9896,'STR_ERROR_PROCESSING_ITEM'),(9897,'STR_GOOGLE_BASE_DEVELOPER_KEY'),(9898,'STR_NO_RECORDS_UPDATED'),(9899,'STR_RECENTLY_MODIFIED_OR_ADDED'),(9900,'STR_SYNCHRONIZATION_DEFAULTS'),(9901,'STR_SYNC_ITEMS'),(9902,'STR_SYNC_ITEMS_WITH_GOOGLE_BASE'),(9903,'STR_PLEASE_SIGN_IN_TO_YOUR_GOOGLE_BASE_ACCOUNT'),(9904,'STR_THIS_BILL_HAS_BEEN_PREAPPROVED_EDITING_WILL_CANCEL_PREAPPROVAL'),(9905,'STR_CHANGE_CATEGORY_ASSIGNED_TO_ITEMS'),(9906,'STR_CHANGE_ITEMS_WITH_CATEGORY'),(9907,'STR_ITEMS_ASSOCIATED_WITH_THIS_CATEGORY'),(9908,'STR_MOVE'),(9909,'STR_TO_THIS_CATEGORY'),(9910,'STR_GOOGLE_BASE_INTEGRATION'),(9911,'STR_ADD_LEASE_INSTRUCTIONS'),(9912,'STR_CURRENT_TENANT'),(9913,'STR_NEW_TENANT'),(9914,'STR_SELECT_TENANT'),(9915,'STR_SELECT_TENANT_DESCRIPTION'),(9916,'STR_SELECT_UNIT'),(9917,'STR_SELECT_UNIT_INSTRUCTIONS'),(9918,'STR_MOVE_IN'),(9919,'STR_GO_TO'),(9920,'STR_ITEMS_PER_PAGE'),(9921,'STR_ITEM_PRICES_MASS_EDIT'),(9922,'STR_PRICES_UPDATED_SUCCESSFULLY'),(9923,'STR_BATCH_SIZE'),(9924,'STR_ATTACHED_IS_YOUR_PROFORMA_INVOICE'),(9925,'STR_CLICK_TO_VIEW_PROFORMA_INVOICE'),(9926,'STR_EMAIL_PROFORMA_INVOICE'),(9927,'STR_PROFORMA_INVOICE'),(9928,'STR_PRO_FORMA_INVOICE'),(9929,'STR_CLICK_TO_CONTINUE'),(9930,'STR_ERROR_FILE_NOT_WRITABLE'),(9931,'STR_ERROR_OPENING_FILE'),(9932,'STR_EXPORT_FILE_GENERATED'),(9933,'STR_EXPORT_ITEMS'),(9934,'STR_LOCAL_CSV_FILENAME_FOR_EXPORT'),(9935,'STR_NOT_WRITTEN'),(9936,'STR_CLICK_TO_DOWNLOAD_ITEM_EXPORT_FILE'),(9937,'STR_CATEGORYNAME'),(9938,'STR_COPY_TO_TEXT_PROGRAM'),(9939,'STR_IMPORT_INTO_EXCEL_WITH_BAR_SEPARATOR_SELECTED'),(9940,'STR_SAVE_AS_TXT_FILE'),(9941,'STR_TO_CAPTURE_HEADERS_SHOWN_BELOW'),(9942,'STR_VENDOR_PRICE_PER_STOCK_UNIT'),(9943,'STR_EXPORTS'),(9944,'STR_SICK_LEAVE_HOURS_REMAINING'),(9945,'STR_VACATION_HOURS_REMAINING'),(9946,'STR_APPLIES_TO_ALL_COMPANIES'),(9947,'STR_APPROVAL_SETUP'),(9948,'STR_GROUPS_THAT_CAN_APPROVE_THIS_ACTION'),(9949,'STR_GROUPS_THAT_MUST_GET_APPROVAL_FOR_THIS_ACTION'),(9950,'STR_USERS_WHO_CAN_APPROVE_THIS_ACTION'),(9951,'STR_USERS_WHO_MUST_GET_APPROVAL_FOR_THIS_ACTION'),(9952,'STR_USE_SAME_ACCOUNT_AS_COGS_TO_NEGATE_ACTION_TO_INVENTORY_ACCOUNT'),(9953,'STR_BANK_CONTACT_EMAIL'),(9954,'STR_BANK_INSPECTOR_EMAIL'),(9955,'STR_BANK_INSPECTOR_NAME'),(9956,'STR_BUDGET_REFERENCE'),(9957,'STR_CHECK_GENERAL_LEDGER_BUDGETS'),(9958,'STR_CHECK_JOB_BUDGETS'),(9959,'STR_DO_NOT_CHECK_BUDGETS'),(9960,'STR_JOB_ADD'),(9961,'STR_MSPROJECT_JOB_NAME'),(9962,'STR_REGION'),(9963,'STR_RISK_INSURANCE_AMOUNT'),(9964,'STR_RISK_INSURANCE_EXPIRATION_DATE'),(9965,'STR_RISK_INSURANCE_UNDERWRITER'),(9966,'STR_SITE_CODE'),(9967,'STR_ADD_JOB_BUDGET'),(9968,'STR_CATEGORY_REQUIRED'),(9969,'STR_COST_CODE_REQUIRED'),(9970,'STR_JOB_CODE_REQUIRED'),(9971,'STR_WHEN_JOB_SPECIFIED_MUST_FILL_IN_COSTCODE_AND_CATEGORY'),(9972,'STR_ALWAYS_IF_JOB_SELECTED'),(9973,'STR_COMMITMENT_DATA_IMPORTED_SUCCESSFULLY'),(9974,'STR_COULD_NOT_FIND_CATEGORY'),(9975,'STR_COULD_NOT_FIND_COST_CODE'),(9976,'STR_EXCEL_FILE'),(9977,'STR_IMPORT_JOB_BUDGETS_AND_COMMITMENTS'),(9978,'STR_JOB_BUDGET_DATA_ALREADY_EXISTS_SKIPPING'),(9979,'STR_JOB_BUDGET_DATA_IMPORTED_SUCCESSFULLY'),(9980,'STR_JOB_CODE_NOT_SET'),(9981,'STR_JOB_NOT_FOUND'),(9982,'STR_SELECT_JOB_EXCEL_FILE'),(9983,'STR_THE_EXCEL_FILE_IS_NOT_IN_THE_PROPER_FORMAT'),(9984,'STR_YOU_MUST_SUBMIT_AN_EXCEL_FILE'),(9985,'STR_APPROVAL_NOTES'),(9986,'STR_APPROVAL_REQUEST_APPROVED_SUCCESSFULLY'),(9987,'STR_APPROVAL_REQUEST_DENIED_SUCCESSFULLY'),(9988,'STR_APPROVE_OR_DENY_BEFORE_MAKING_ANY_CHANGES'),(9989,'STR_APPROVE_PO'),(9990,'STR_AWAITING_APPROVAL'),(9991,'STR_ERROR_DENYING_APPROVAL_REQUEST'),(9992,'STR_PO_NEEDS_APPROVAL'),(9993,'STR_REQUEST_DATE'),(9994,'STR_SAVE_BLOCKED'),(9995,'STR_JOB_BUDGET_ADD'),(9996,'STR_JOB_BUDGET_ADDED_SUCCESSFULLY'),(9997,'STR_JOB_BUDGET_ALREADY_EXISTS_FOR_THIS_JOB'),(9998,'STR_NO_JOB_SELECTED'),(9999,'STR_HAS_REVISION'),(10000,'STR_JOB_BUDGET_UPDATE'),(10001,'STR_NEW_AMOUNT'),(10002,'STR_WAITING_FOR_APPROVAL'),(10003,'STR_APPROVAL_REQUEST_SENT'),(10004,'STR_APPROVED_BY'),(10005,'STR_APPROVED_ON'),(10006,'STR_CHANGE_REQUEST_RESPONSE_SENT'),(10007,'STR_CHANGE_REQUEST_SENT'),(10008,'STR_DENIED_BY'),(10009,'STR_DENIED_ON'),(10010,'STR_NEW_APPROVAL_REQUEST'),(10011,'STR_YOUR_CHANGE_REQUEST_HAS_BEEN_APPROVED'),(10012,'STR_YOUR_CHANGE_REQUEST_HAS_BEEN_DENIED'),(10013,'STR_IS_THIS_A_CONSTRUCTION_COMPANY'),(10014,'STR_B2B_YOUR_CUSTOMERS_PO'),(10015,'STR_B2B_YOUR_PO'),(10016,'STR_CHARGEBACK_PERCENTAGE_UPCHARGE'),(10017,'STR_CHARGEBACK_REVENUE_ACCOUNT'),(10018,'STR_RETAINER_BANK_ACCOUNT'),(10019,'STR_RETAINER_HELD_ACCOUNT'),(10020,'STR_DEAL'),(10021,'STR_GROUND_BREAKING_DATE'),(10022,'STR_SITE_ADD'),(10023,'STR_SITE_ADDED_SUCCESSFULLY'),(10024,'STR_SITE_ALREADY_EXISTS'),(10025,'STR_SITE_NAME'),(10026,'STR_SITE_NOT_ADDED'),(10027,'STR_SITE_DELETED_SUCCESSFULLY'),(10028,'STR_SITE_UPDATE'),(10029,'STR_ADD_CHARGEBACK_JOB_PO'),(10030,'STR_PERCENT_UPCHARGE'),(10031,'STR_VENDOR_RESPONSIBLE'),(10032,'STR_CLICK_TO_VIEW_PO_BEFORE_CHANGES'),(10033,'STR_FOB_DESTINATION'),(10034,'STR_FOB_SHIP_POINT'),(10035,'STR_ADD_NEW_CONSTRUCTION_SITE'),(10036,'STR_CREATE_A_NEW_CHARGEBACK_PURCHASE_ORDER'),(10037,'STR_CREATE_A_NEW_JOB_CHARGEBACK_PURCHASE_ORDER'),(10038,'STR_EDIT_CONSTRUCTION_SITES'),(10039,'STR_EDIT_SITE'),(10040,'STR_NEW_CHARGEBACK'),(10041,'STR_NEW_JOB_CHARGEBACK'),(10042,'STR_NEW_SITE'),(10043,'STR_CHECK_GL_BUDGETS_FOR_NON_JOB_PO_OR_SB'),(10044,'STR_ADD_NOTE_CATEGORY'),(10045,'STR_CURRENT_NOTE_CATEGORIES'),(10046,'STR_NOTE_CATEGORIES'),(10047,'STR_NOTE_CATEGORY_DELETED_SUCCESSFULLY'),(10048,'STR_NOTE_CATEGORY_SAVED_SUCCESSFULLY'),(10049,'STR_NOTE_TYPES'),(10050,'STR_YOU_MUST_ENTER_A_CATEGORY_NAME'),(10051,'STR_CATEGORY_MUST_NOT_BE_EMPTY'),(10052,'STR_CATEGORY_MUST_NOT_BE_EMPTY_WHEN_JOB_SPECIFIED'),(10053,'STR_COSTCODE_MUST_NOT_BE_EMPTY'),(10054,'STR_COSTCODE_MUST_NOT_BE_EMPTY_WHEN_JOB_SPECIFIED'),(10055,'STR_JOB_MUST_NOT_BE_EMPTY'),(10056,'STR_COPY_JOB_PO_SB_FROM_OTHER_JOB'),(10057,'STR_YOU_MUST_ENTER_A_GL_ACCOUNT'),(10058,'STR_MULTICOMPANY_GL_JOURNAL_ADD'),(10059,'STR_SELECT_SECOND_COMPANY'),(10060,'STR_USER_DOES_NOT_HAVE_ACCESS_IN_MORE_THAN_ONE_COMPANY'),(10061,'STR_BUDGET_YEAR_NOT_SET'),(10062,'STR_COULD_BUDGET_NAME_NOT_SET'),(10063,'STR_COULD_NOT_FIND_GL_ACCOUNT'),(10064,'STR_GL_BUDGET_DATA_IMPORTED_SUCCESSFULLY'),(10065,'STR_IMPORT_GL_BUDGETS'),(10066,'STR_SELECT_GL_BUDGET_EXCEL_FILE'),(10067,'STR_CHARGEBACK_AMOUNT'),(10068,'STR_IS_OVER_BUDGET'),(10069,'STR_IS_OVER_BUDGET_FOR_MONTH'),(10070,'STR_IS_OVER_BUDGET_FOR_YEAR'),(10071,'STR_AP_BILL_ALREADY_CREATED_FOR_THIS_CHARGEBACK_PO_MUST_DELETE_BILL_FIRST_BEFORE_DELETING_CHARGEBACK_PO'),(10072,'STR_GO_TO_NEXT_PAGE_TO_APPROVE'),(10073,'STR_NEW_PO_WAITING_APPROVAL'),(10074,'STR_PO_NEEDS_APPROVAL_BEFORE_CHANGES'),(10075,'STR_BUDGET_DATE'),(10076,'STR_JOB_BUDGET'),(10077,'STR_YOU_MUST_ENTER_A_JOB'),(10078,'STR_ADD_NOTES'),(10079,'STR_APPROVE'),(10080,'STR_BEGIN_BUDGET_DATE'),(10081,'STR_DENY'),(10082,'STR_END_BUDGET_DATE'),(10083,'STR_HAS_PENDING_REVISION'),(10084,'STR_SHOW_PRIOR_VERSIONS'),(10085,'STR_COPY_TO_JOB'),(10086,'STR_CREATE_BUDGETS_ALSO'),(10087,'STR_JOB_COPIED_SUCCESSFULLY'),(10088,'STR_JOB_PO_SB_COPY'),(10089,'STR_JOB_TO_COPY_FROM'),(10090,'STR_NOT_COPIED'),(10091,'STR_USE_CURRENT_PO_SB_DETAIL_PRICING'),(10092,'STR_JOB_BUDGETS'),(10093,'STR_NOTE_CATEGORY'),(10094,'STR_BUDGET_NAME_NOT_SET'),(10095,'STR_NO_USER_SELECTED'),(10096,'STR_SWITCHING_USERS_PLEASE_WAIT'),(10097,'STR_LOG_IN_AS'),(10098,'STR_PRODUCT_PDF_PREVIEW'),(10099,'STR_PRODUCT_SOUND_FILE'),(10100,'STR_PRODUCT_VIDEO_FILE'),(10101,'STR_DELETE_PRODUCT_PDF_PREVIEW'),(10102,'STR_DELETE_PRODUCT_SOUND_FILE'),(10103,'STR_DELETE_PRODUCT_VIDEO_FILE'),(10104,'STR_SICK_LEAVE_USED'),(10105,'STR_VACATION_USED'),(10106,'STR_ERROR_LOCATING_CHECKING_ACCOUNT'),(10107,'STR_PROFIT_YEAR_TO_DATE'),(10108,'STR_TOTAL_PROFIT'),(10109,'STR_DEFAULT_VALUES'),(10110,'STR_INVOICE_FORMATTING'),(10111,'STR_POS_AND_FULFILLMENT_QUICK_ORDERS'),(10112,'STR_STATEMENT_FORMATTING'),(10113,'STR_FIFTEENTH_OF_MONTH'),(10114,'STR_FIRST_DAY_OF_MONTH'),(10115,'STR_IF_MONTHLY_PLAN_PAY_ON_WHAT_DAY'),(10116,'STR_NUMBER_OF_TIMES_TO_MAKE_PAYMENTS'),(10117,'STR_RECURRING_PAYABLE_ADD'),(10118,'STR_TENTH_OF_MONTH'),(10119,'STR_TWENTIETH_OF_MONTH'),(10120,'STR_ENTERED_BETWEEN'),(10121,'STR_SHOW_CUSTOMERS_ENTERED_BETWEEN'),(10122,'STR_SHOW_ONLY_CUSTOMERS_WITH_SALES'),(10123,'STR_LIST_RECENT_CUSTOMERS'),(10124,'STR_REQUIRE_COMPLETED_CHECKLIST_BEFORE_PAYMENT'),(10125,'STR_MENU_LINK'),(10126,'STR_ADD_OWNERSHIP'),(10127,'STR_COMPANY_OWNER'),(10128,'STR_OWNERSHIP'),(10129,'STR_OWNERSHIP_PERCENT'),(10130,'STR_OWNERSHIP_RECORD_SAVED_SUCCESSFULLY'),(10131,'STR_OWNS'),(10132,'STR_THE_PERCENT_OF_OWNERSHIP_MUST_BE_GREATER_THAN_0'),(10133,'STR_TOTAL_OWNERSHIP_MAY_NOT_EXCEED_100_PERCENT'),(10134,'STR_USER_OWNER'),(10135,'STR_YOU_CANNOT_SELECT_BOTH_A_COMPANY_AND_USER_AS_AN_OWNER_HERE'),(10136,'STR_YOU_MUST_SELECT_EITHER_A_USER_OR_COMPANY_AS_AN_OWNER'),(10137,'STR_PO_SB'),(10138,'STR_PO_SB_CHECKLIST'),(10139,'STR_CHECKLIST'),(10140,'STR_CHECKLIST_SAVED_SUCCESSFULLY'),(10141,'STR_CHECKLIST_TYPE_NOT_SET'),(10142,'STR_ERROR_NO_RECORD_ID_SENT'),(10143,'STR_OK_TO_PROCEED'),(10144,'STR_REQUIREMENT'),(10145,'STR_APPROVE_CHANGE'),(10146,'STR_GL_BUDGET'),(10147,'STR_GL_BUDGET_NEEDS_APPROVAL'),(10148,'STR_CHECKLIST_TYPE'),(10149,'STR_COMPLETED_BY'),(10150,'STR_GL_CHECKLISTS'),(10151,'STR_MONTH_END'),(10152,'STR_Q'),(10153,'STR_QUARTER_END'),(10154,'STR_RECENT_GL_CHECKLISTS'),(10155,'STR_YEAR_END'),(10156,'STR_NET'),(10157,'STR_TOTAL_DEBITS_FOR'),(10158,'STR_TOTAL_DEBITS_FOR_ALL_OTHER_COMPANIES'),(10159,'STR_APPROVAL_REQUEST_FAILED'),(10160,'STR_TIMECLOCK_MANAGER'),(10161,'STR_APPROVE_REIMBURSEMENTS'),(10162,'STR_APPROVE_REIMBURSEMENT_REQUESTS'),(10163,'STR_ERROR_APPROVALS_NOT_SAVED'),(10164,'STR_CHECK_IF_APPROVAL_REQUIRED'),(10165,'STR_CHECK_IF_CAN_SELECT'),(10166,'STR_DEFAULT_CATEGORY_FOR_TIMECLOCK_LABOR_HOURS'),(10167,'STR_MANAGER_PREAPPROVAL_REQUIRED'),(10168,'STR_DEFAULT_RETAINER_PERCENT'),(10169,'STR_GL_BUDGETS'),(10170,'STR_APPROVE_HOURS'),(10171,'STR_ERROR_TIME_NOT_SAVED'),(10172,'STR_OT_HOURS'),(10173,'STR_WORK_DATE'),(10174,'STR_TIME_NOT_SAVED_ERROR_IN_LINE'),(10175,'STR_TOTAL_OT_PAY'),(10176,'STR_TOTAL_ST_PAY'),(10177,'STR_DATA_NOT_SAVED_ERROR_IN_LINE'),(10178,'STR_REIMBURSEMENTS'),(10179,'STR_REIMBURSEMENT_REQUEST'),(10180,'STR_MANAGER_PAGE'),(10181,'STR_REQUEST_REIMBURSEMENT'),(10182,'STR_STARTED_JOB'),(10183,'STR_STARTED_WORK_ORDER'),(10184,'STR_START_NEW_WORK'),(10185,'STR_APPROVE_TIME_OFF_REQUESTS'),(10186,'STR_ENTER_HOURS'),(10187,'STR_ENTER_REIMBURSEMENTS'),(10188,'STR_ENTER_TIME_OFF_REQUESTS'),(10189,'STR_SHOW_TIME_OFF_SCHEDULE'),(10190,'STR_BILL_VIEW'),(10191,'STR_RETAINAGE'),(10192,'STR_ORDERED_BY'),(10193,'STR_SHOW_LINE_DETAILS_ON_STUB'),(10194,'STR_CAPITAL_EXPENDITURES'),(10195,'STR_CASH_AND_CASH_EQUIVALENTS'),(10196,'STR_CASH_FLOW_FROM_USED_FOR_FINANCING_ACTIVITIES'),(10197,'STR_CASH_FLOW_FROM_USED_FOR_INVESTING_ACTIVITIES'),(10198,'STR_CASH_FLOW_FROM_USED_FOR_OPERATIONS'),(10199,'STR_CASH_FLOW_REPORT_LINE_ADDED_FAILURE'),(10200,'STR_CASH_FLOW_REPORT_LINE_ADDED_SUCCESSFULLY'),(10201,'STR_CASH_FLOW_REPORT_LINE_DELETED_FAILURE'),(10202,'STR_CASH_FLOW_REPORT_LINE_DELETED_SUCCESSFULLY'),(10203,'STR_CASH_FLOW_REPORT_LINE_UPDATED_FAILURE'),(10204,'STR_CASH_FLOW_REPORT_LINE_UPDATED_SUCCESSFULLY'),(10205,'STR_CURRENT_GL_ACCOUNTS'),(10206,'STR_GENERAL_LEDGER_CASH_FLOW_REPORT_SETUP'),(10207,'STR_ITEMS_IN_INCOME_NOT_AFFECTING_CASH'),(10208,'STR_NET_CASH_FROM_USED_FOR_WORKING_CAPITAL'),(10209,'STR_NET_CHANGE_IN_OTHER_OPERATING_ASSETS_AND_LIABILITIES'),(10210,'STR_PLEASE_INCLUDE_CATEGORY'),(10211,'STR_PLEASE_INCLUDE_GL_ACCOUNTS'),(10212,'STR_CASH_FROM_USED_FOR_WORKING_CAPITAL'),(10213,'STR_DECREASE_INCREASE_IN_CASH_AND_CASH_EQUIVALENTS'),(10214,'STR_STATEMENT_OF_CASH_FLOWS'),(10215,'STR_YEAR_TO_DATE'),(10216,'STR_COULD_NOT_FIND'),(10217,'STR_IMPORT_MS_PROJECT_DATA'),(10218,'STR_MS_PROJECT_FILE'),(10219,'STR_PO_SB_UPDATES'),(10220,'STR_RECORDS_UPDATED_SUCCESSFULLY'),(10221,'STR_SELECT_MS_PROJECT_FILE'),(10222,'STR_TOTAL_MS_PROJECT_RECORDS'),(10223,'STR_ALL_MY_COMPANIES'),(10224,'STR_BALANCE_SHEET_BY_OWNER'),(10225,'STR_MY_BALANCE_SHEET'),(10226,'STR_NO_OWNERSHIP_CREATED_FOR_THIS_COMPANY'),(10227,'STR_SHOW_ALL_COMPANIES_OWNED_BY_THIS_COMPANY'),(10228,'STR_SHOW_ALL_OWNERS_FOR_THIS_COMPANY'),(10229,'STR_WHICH_COMPANY'),(10230,'STR_WHICH_REPORT'),(10231,'STR_YOU_HAVE_NO_OWNERSHIP_IN_ANY_COMPANY'),(10232,'STR_CREATE_GENERAL_LEDGER_MULTICOMPANY_JOURNAL_ENTRIES'),(10233,'STR_MULTICOMPANY_JOURNAL_ENTRIES'),(10234,'STR_OWNERSHIP_BALANCE_SHEET'),(10235,'STR_COMPANY_CODE'),(10236,'STR_BLOCK_FROM_JOURNAL_ENTRY_SELECTIONS'),(10237,'STR_CHECK_TO_BLOCK'),(10238,'STR_EXPIRATION'),(10239,'STR_MY_PROFIT_AND_LOSS_STATEMENT'),(10240,'STR_PROFIT_AND_LOSS_STATEMENT_BY_OWNER'),(10241,'STR_JOB_BUDGET_REPORT'),(10242,'STR_MY_PROFIT_AND_LOSS'),(10243,'STR_OWNER_PROFIT_AND_LOSS_STATEMENT'),(10244,'STR_PRINT_A_PROFIT_AND_LOSS_STATEMENT_BY_OWNER'),(10245,'STR_ADMINISTRATIVE_FEE_EXPENSE_ACCOUNT'),(10246,'STR_ADMINISTRATIVE_FEE_FLAT'),(10247,'STR_ADMINISTRATIVE_FEE_PERCENT'),(10248,'STR_ADMINISTRATIVE_FEE_SALES_ACCOUNT'),(10249,'STR_CC_CHARGE_IMPORT_OPTIONS'),(10250,'STR_RETAINER_AMOUNTS_ONLY'),(10251,'STR_SHOW_RETAINER_ONLY'),(10252,'STR_CLICK_TO_VIEW_TICKET'),(10253,'STR_DEPOSIT'),(10254,'STR_DEPOSIT_DETAIL'),(10255,'STR_DEPOSIT_TICKET'),(10256,'STR_ADMINISTRATIVE_FEE'),(10257,'STR_BUILDING_EXP_CODE'),(10258,'STR_CC_CHARGES'),(10259,'STR_CC_CHARGES_IMPORTED_SUCCESSFULLY'),(10260,'STR_CONFIRM_CC_CHARGES_TO_IMPORT'),(10261,'STR_CREDIT_CARD_COMPANY_VENDOR'),(10262,'STR_DO_NOT_PAY_ENTRIES'),(10263,'STR_DO_NOT_PAY_TOTAL'),(10264,'STR_GRAND_TOTAL_NOT_PAID_TO_IMPORT'),(10265,'STR_GRAND_TOTAL_PAID_TO_IMPORT'),(10266,'STR_IMPORT_CREDIT_CARD_CHARGES'),(10267,'STR_SELECT_CC_CHARGES_EXCEL_FILE'),(10268,'STR_YOU_MUST_ENTER_A_GL_ACCOUNT_FOR_ALL_LINES'),(10269,'STR_YOU_MUST_SELECT_A_VENDOR'),(10270,'STR_YOU_MUST_SET_AN_ADMINISTRATIVE_FEE_EXPENSE_ACCOUNT'),(10271,'STR_BLANK_STOCK_USING_MICR_INK'),(10272,'STR_DEPOSIT_BANK_CITY_STATE_ZIP'),(10273,'STR_DEPOSIT_ROUTING_TRANSIT_NUMBER'),(10274,'STR_DEPOSIT_STORE_OR_LOCATION'),(10275,'STR_DEPOSIT_STYLE'),(10276,'STR_FOR_DEPOSIT_SLIPS'),(10277,'STR_HTML_DEPOSIT_SLIP'),(10278,'STR_PREPRINTED_DEPOSIT_SLIP'),(10279,'STR_CASH_FLOW_REPORT_SETUP'),(10280,'STR_THIS_PAYEMENT_CAN_ONLY_BE_EDITED_BY'),(10281,'STR_REMINDER'),(10282,'STR_CASH_INFLOW_PERCENT_CLIENT'),(10283,'STR_CASH_INFLOW_PERCENT_GFD'),(10284,'STR_CASH_INFLOW_PERCENT_REX'),(10285,'STR_CASH_OUTFLOW_PERCENT_CLIENT'),(10286,'STR_CASH_OUTFLOW_PERCENT_GFD'),(10287,'STR_COST_CLOSING'),(10288,'STR_COST_CONSTRUCTION_MAIN_BUILDINGS'),(10289,'STR_COST_CONSTRUCTION_SITE_AMENITIES'),(10290,'STR_COST_ENGINEERING'),(10291,'STR_COST_EXCAVATION'),(10292,'STR_COST_FURNITURE'),(10293,'STR_COST_GENERAL'),(10294,'STR_COST_MARKETING'),(10295,'STR_ESTIMATED_END_DATE'),(10296,'STR_ESTIMATED_GROUNDBREAKING_DATE'),(10297,'STR_ESTIMATED_START_DATE'),(10298,'STR_FAIR_MARKET_VALUE'),(10299,'STR_FEASIBILITY_MARKET_PLANS'),(10300,'STR_FEASIBILITY_MARKET_RESEARCH'),(10301,'STR_FINANCIAL_REQUEST'),(10302,'STR_IMPROVEMENTS'),(10303,'STR_IMPROVEMENTS_BUILDING_PLANS'),(10304,'STR_IMPROVEMENTS_PHASES_DESCRIPTION'),(10305,'STR_IMPROVEMENTS_QUOTES_RECEIVED'),(10306,'STR_LAND_AND_ENTITLEMENTS'),(10307,'STR_LAND_AND_ENTITLEMENTS_OTHER'),(10308,'STR_LAND_AND_ENTITLEMENTS_PERMITS'),(10309,'STR_LAND_AND_ENTITLEMENT_CONTACTS'),(10310,'STR_PHASE_FOUR'),(10311,'STR_PHASE_ONE'),(10312,'STR_PHASE_THREE'),(10313,'STR_PHASE_TWO'),(10314,'STR_PROJECT_DETAILS_ADD'),(10315,'STR_ALL_OWNERS'),(10316,'STR_ESTIMATED_GROUND_BREAKING'),(10317,'STR_NOT_ASSOCIATED_COMPANY'),(10318,'STR_PENDING_AND_PRELIMINARY'),(10319,'STR_PRELIMINARY'),(10320,'STR_PROJECT_DETAILS_ATTACHMENTS'),(10321,'STR_PROJECT_DETAILS_UPDATE'),(10322,'STR_SELECT_WHICH_STATUS_TO_VIEW'),(10323,'STR_WHILE_UPDATING'),(10324,'STR_APPROVED_BUDGET_CHANGES'),(10325,'STR_APPROVED_CHANGE_ORDERS'),(10326,'STR_COST_TO_DATE'),(10327,'STR_JOB_VARIANCE'),(10328,'STR_JOB_VARIANCE_REPORT'),(10329,'STR_NET_COMMITTED_SB_PO'),(10330,'STR_ORIGINAL_ESTIMATE'),(10331,'STR_ORIGINAL_SB_PO'),(10332,'STR_REMAINING_TO_COMMIT'),(10333,'STR_TOTAL_NET_ESTIMATE'),(10334,'STR_ADD_NEW_DRAW'),(10335,'STR_ADD_UPDATE_DRAWS'),(10336,'STR_AP_BILLS_TO_INCLUDE'),(10337,'STR_BALANCE_TO_FINISH'),(10338,'STR_DRAW_STATUS'),(10339,'STR_DRAW_UPDATED_SUCCESSFULLY'),(10340,'STR_PERCENT_COMPLETE'),(10341,'STR_SCHEDULED_VALUE'),(10342,'STR_SELECT_DRAW'),(10343,'STR_UPDATE_DRAW'),(10344,'STR_WORK_COMPLETED_PREVIOUSLY'),(10345,'STR_WORK_COMPLETED_THIS_PERIOD'),(10346,'STR_BEGINNING_END_OF_PERIOD_ACCOUNTS'),(10347,'STR_REVERSE_SIGN'),(10348,'STR_CASH_AND_CASH_EQUIVALENTS_BEGINNING_OF_PERIOD'),(10349,'STR_CASH_AND_CASH_EQUIVALENTS_END_OF_PERIOD'),(10350,'STR_CASH_FLOW_REPORT_FOR_THIS_COMPANY'),(10351,'STR_MY_COMPANIES'),(10352,'STR_SHOW_COMPANIES_OWNED_BY_THIS_COMPANY'),(10353,'STR_BUILDING_SALES_ADD'),(10354,'STR_FORECASTED_DATE'),(10355,'STR_LOAN_CURTAILMENT'),(10356,'STR_NET_CARRYING_VALUE'),(10357,'STR_NUMBER_OF_UNITS'),(10358,'STR_PERCENT_CLOSING_COSTS'),(10359,'STR_BUILDING_SALES_UPDATE'),(10360,'STR_CASH_FROM_SALE'),(10361,'STR_ENTER_SEARCH_INFO_FOR_LOOKUP'),(10362,'STR_SHORT_DESCRIPTION'),(10363,'STR_TAXABLE_INCOME_FROM_SALE'),(10364,'STR_TEXT_IN_DESCRIPTION'),(10365,'STR_ADD_NEW_PROJECT_PIPELINE_DETAILS'),(10366,'STR_EDIT_CONSTRUCTION_PROJECT_DETAILS'),(10367,'STR_EDIT_PROJECT_DETAILS'),(10368,'STR_MY_STATEMENT_OF_CASH_FLOWS'),(10369,'STR_NEW_PROJECT_DETAILS'),(10370,'STR_DO_NOT_SHOW_PRICES_ON_PO'),(10371,'STR_FINISHED_UPDATING_INVOICES'),(10372,'STR_ASSIGN_USERS_AND_GROUPS'),(10373,'STR_BUSINESS_LICENSE'),(10374,'STR_CERTIFICATE_OF_INSURANCE'),(10375,'STR_PLEASE_INCLUDE_USERS_OR_GROUPS'),(10376,'STR_SUBCONTRACTOR_AGREEMENT_OR_SIGNED_CONTRACT'),(10377,'STR_VENDOR_REQUIREMENT_NOTIFICATIONS'),(10378,'STR_VENDOR_REQUIREMENT_NOTIFICATIONS_ADDED_FAILURE'),(10379,'STR_VENDOR_REQUIREMENT_NOTIFICATIONS_ADDED_SUCCESSFULLY'),(10380,'STR_W9'),(10381,'STR_WAIVER_OF_LIENS'),(10382,'STR_WORKMANS_COMP_INSURANCE_CERTIFICATE'),(10383,'STR_EXPIRED'),(10384,'STR_EXPIRES'),(10385,'STR_IGNORED'),(10386,'STR_MISSING'),(10387,'STR_BEFORE_EVENT'),(10388,'STR_HOUR'),(10389,'STR_IGNORE_EXPIRATION'),(10390,'STR_PLEASE_INCLUDE_BEGIN_DATE'),(10391,'STR_PLEASE_INCLUDE_END_DATE'),(10392,'STR_PLEASE_INCLUDE_REQUIREMENT_TYPE'),(10393,'STR_PLEASE_INCLUDE_VENDOR'),(10394,'STR_VENDOR_REQUIREMENTS'),(10395,'STR_VENDOR_REQUIREMENT_ADDED_FAILURE'),(10396,'STR_VENDOR_REQUIREMENT_ADDED_SUCCESSFULLY'),(10397,'STR_VENDOR_REQUIREMENT_DELETED_FAILURE'),(10398,'STR_VENDOR_REQUIREMENT_DELETED_SUCCESSFULLY'),(10399,'STR_VENDOR_REQUIREMENT_RENEWED_FAILURE'),(10400,'STR_VENDOR_REQUIREMENT_RENEWED_SUCCESSFULLY'),(10401,'STR_VENDOR_REQUIREMENT_UPDATED_FAILURE'),(10402,'STR_VENDOR_REQUIREMENT_UPDATED_SUCCESSFULLY'),(10403,'STR_ADD_VENDOR_REQUIREMENT'),(10404,'STR_RENEW'),(10405,'STR_CASH_RECEIPTS'),(10406,'STR_NON_INVOICE_PAYMENT'),(10407,'STR_ACCEPT'),(10408,'STR_ACCEPT_OR_REJECT_CASH_TRANSFERRED_TO_ME'),(10409,'STR_ACTION_STEP'),(10410,'STR_CASH_TRANSFERS'),(10411,'STR_DATE_TRANSFERRED'),(10412,'STR_RECEIVED_FROM'),(10413,'STR_REJECT'),(10414,'STR_TOTAL_IN_LIST'),(10415,'STR_TRANSFERRED_TO'),(10416,'STR_TRANSFER_ACCEPTED'),(10417,'STR_TRANSFER_MY_CASH_TO_ANOTHER_PERSON'),(10418,'STR_TRANSFER_PENDING'),(10419,'STR_TRANSFER_REJECTED'),(10420,'STR_VIEW_ALL_CASH_TRANSFERS'),(10421,'STR_VIEW_MY_CASH_ACCEPTED'),(10422,'STR_VIEW_MY_CASH_TRANSFERS'),(10423,'STR_VIEW_REJECTED_TRANSFERS_FR0M_ME'),(10424,'STR_WHAT_ACTION'),(10425,'STR_ADD_NEW_COST_LINE'),(10426,'STR_DRAW_DATE'),(10427,'STR_JOBS_ON_DRAW'),(10428,'STR_NO_BILLS_FOUND'),(10429,'STR_YOU_MUST_ENTER_A_DATE'),(10430,'STR_TRANSFER_OR_RECEIVE_CASH_TRANSFERS'),(10431,'STR_ATTEMPTING_TO_USE_EXISTING_DATABASE'),(10432,'STR_CANNOT_USE_MAIN_DATABASE'),(10433,'STR_COULD_NOT_CONNECT_TO_DATABASE'),(10434,'STR_COULLD_NOT_CONNECT_TO_EXISTING_DATABASE'),(10435,'STR_DIRECT_GL_PAYMENT_ENTRIES'),(10436,'STR_TOTAL_DIRECT_GL_PAYMENT_ENTRIES'),(10437,'STR_CREATE_JOURNAL_ENTRY_FROM_BANK_IMPORT'),(10438,'STR_JOURNAL_ENTRY_ADDED_SUCCESSFULLY'),(10439,'STR_SAVE_FAILED_DUE_TO_MISSING_INFO'),(10440,'STR_YOU_MUST_ENTER_A_DESCRIPTION'),(10441,'STR_YOU_MUST_ENTER_A_MONTH_TO_POST'),(10442,'STR_YOU_MUST_ENTER_A_YEAR_TO_POST'),(10443,'STR_ADD_GL'),(10444,'STR_BANK_ID'),(10445,'STR_BANK_IMPORT_DATA_DELETED_SUCCESSFULLY'),(10446,'STR_BANK_IMPORT_DATA_UPDATED_SUCCESSFULLY'),(10447,'STR_BANK_RECORDS_IMPORTED_SUCCESSFULLY'),(10448,'STR_COULD_NOT_READ_UPLOADED_FILE'),(10449,'STR_END_STATEMENT_DATE'),(10450,'STR_GL_ENTRY'),(10451,'STR_GL_VOUCHER'),(10452,'STR_IMPORTED_STATEMENTS'),(10453,'STR_BEGIN_DELETION_DATE'),(10454,'STR_DELETION_DATE'),(10455,'STR_DELETION_REPORT'),(10456,'STR_IMPORT_NEW'),(10457,'STR_NO_NEW_RECORDS_ADDED'),(10458,'STR_OFX_FILE'),(10459,'STR_SELECT_BANK_OFX_FILE'),(10460,'STR_THIS_FILE_HAS_ALREADY_BEEN_UPLOADED'),(10461,'STR_THIS_TRANSACTION_ALREADY_EXISTS'),(10462,'STR_UNLINK'),(10463,'STR_YOU_MUST_ENTER_AN_END_STATEMENT_DATE'),(10464,'STR_YOU_MUST_SET_AN_END_STATEMENT_DATE'),(10465,'STR_YOU_MUST_SUBMIT_AN_OFX_FILE'),(10466,'STR_ADDITIONAL_POS_TAX_GROUPS'),(10467,'STR_CLICK_TO_ADD_OR_UPDATE'),(10468,'STR_POS_TAX_GROUPS'),(10469,'STR_POS_SALES_TAX_GROUPS_ADD'),(10470,'STR_TAX_GROUP_NAME'),(10471,'STR_POS_SALES_TAX_GROUPS_UPDATE'),(10472,'STR_DIRECTORY_DOES_NOT_EXIST'),(10473,'STR_ERROR_IMPORTING_ORDERS'),(10474,'STR_SELECT_INVOICE_FILES_TO_IMPORT'),(10475,'STR_YOU_MUST_SELECT_AN_INVOICE_FILE'),(10476,'STR_POS_TAX_GROUP_FOR_THIS_USER'),(10477,'STR_USE_STANDARD_WALK_IN_TAXES'),(10478,'STR_CURRENT_FILE'),(10479,'STR_CUSTOM_HELP'),(10480,'STR_CUSTOM_HELP_DELETED_FAILURE'),(10481,'STR_CUSTOM_HELP_DELETED_SUCCESSFULLY'),(10482,'STR_CUSTOM_HELP_UPDATED_FAILURE'),(10483,'STR_CUSTOM_HELP_UPDATED_SUCCESSFULLY'),(10484,'STR_PLEASE_INCLUDE_FILE'),(10485,'STR_PLEASE_UPLOAD_A_VALID_FILE'),(10486,'STR_REPLACEMENT_FILE'),(10487,'STR_CONSTRUCTION'),(10488,'STR_HOME_TAB_REPORTS'),(10489,'STR_HOME_TAB_REPORTS_UPDATED_FAILURE'),(10490,'STR_HOME_TAB_REPORTS_UPDATED_SUCCESSFULLY'),(10491,'STR_PLEASE_INCLUDE_REPORTS'),(10492,'STR_PROPERTY_MANAGEMENT'),(10493,'STR_VENDOR_REQUIREMENT_EXPIRATION'),(10494,'STR_COULD_NOT_FIND_DRAW_EXCEL_FILE'),(10495,'STR_DOWNLOAD_DRAW_SHEET'),(10496,'STR_DRAW_ID_NOT_SET'),(10497,'STR_EXPORT_TO_EXCEL'),(10498,'STR_YOU_MUST_SELECT_A_CUSTOMER'),(10499,'STR_AREA_ADD_UPDATE'),(10500,'STR_BUILDING_ADD_UPDATE'),(10501,'STR_BUILDING_TYPE_ADD_UPDATE'),(10502,'STR_DRAW_ADD_UPDATE'),(10503,'STR_LEASE_APPLICATION_SURVEY_TOOL'),(10504,'STR_PROPERTY_MANAGEMENT_TOOLS'),(10505,'STR_UNIT_ADD_UPDATE'),(10506,'STR_ADDITIONAL_HELP'),(10507,'STR_EDIT_HELP'),(10508,'STR_CALENDAR'),(10509,'STR_ADD_CALENDAR_EVENT'),(10510,'STR_ADD_TO_CALENDARS'),(10511,'STR_CALENDAR_EVENT'),(10512,'STR_CALENDAR_EVENT_ADDED_FAILURE'),(10513,'STR_CALENDAR_EVENT_ADDED_SUCCESSFULLY'),(10514,'STR_CALENDAR_EVENT_DELETED_FAILURE'),(10515,'STR_CALENDAR_EVENT_DELETED_SUCCESSFULLY'),(10516,'STR_CALENDAR_EVENT_UPDATED_FAILURE'),(10517,'STR_CALENDAR_EVENT_UPDATED_SUCCESSFULLY'),(10518,'STR_EVENT_DATE'),(10519,'STR_EVENT_TIME'),(10520,'STR_FRIDAY'),(10521,'STR_PLEASE_INCLUDE_EVENT_DATE'),(10522,'STR_PLEASE_INCLUDE_REMINDER'),(10523,'STR_SATURDAY'),(10524,'STR_THURSDAY'),(10525,'STR_TUESDAY'),(10526,'STR_WEDNESDAY'),(10527,'STR_INVENTORY_USAGE_BY_CATEGORY_1_YEAR'),(10528,'STR_INVENTORY_USAGE_BY_CATEGORY_30_DAYS'),(10529,'STR_REQUEST_TIME_OFF'),(10530,'STR_VIEW_TIME_OFF_REQUESTS'),(10531,'STR_ALL_TIME_OFF_REQUESTS'),(10532,'STR_DATA_NOT_SAVED'),(10533,'STR_DECISION_NOTES'),(10534,'STR_MANAGER'),(10535,'STR_MY_TIME_OFF_REQUESTS'),(10536,'STR_PLEASE_INCLUDE_EMPLOYEE'),(10537,'STR_PLEASE_INCLUDE_TYPE'),(10538,'STR_TIME_OFF_REQUEST'),(10539,'STR_PERSONAL_TIME'),(10540,'STR_SICK_TIME'),(10541,'STR_EQUIPMENT'),(10542,'STR_EQUIPMENT_ADD'),(10543,'STR_EQUIPMENT_ADDED_FAILURE'),(10544,'STR_EQUIPMENT_ADDED_SUCCESSFULLY'),(10545,'STR_EQUIPMENT_DELETE'),(10546,'STR_EQUIPMENT_DELETED_FAILURE'),(10547,'STR_EQUIPMENT_DELETED_SUCCESSFULLY'),(10548,'STR_EQUIPMENT_UPDATE'),(10549,'STR_EQUIPMENT_UPDATED_FAILURE'),(10550,'STR_EQUIPMENT_UPDATED_SUCCESSFULLY'),(10551,'STR_EQUIPMENT_ADD_UPDATE'),(10552,'STR_BUILDING_DOCUMENTS'),(10553,'STR_UNIT_DOCUMENTS'),(10554,'STR_PRINT_PO'),(10555,'STR_PROSPECT_DETAILS'),(10556,'STR_SCREENING'),(10557,'STR_SCREENING_INSTRUCTIONS'),(10558,'STR_TENANT_DETAILS'),(10559,'STR_AVAILABLE_UNITS'),(10560,'STR_APPOINTMENT'),(10561,'STR_COMMUNICATIONS'),(10562,'STR_INVOICING'),(10563,'STR_MAINTENANCE'),(10564,'STR_MARKETING_PLAN'),(10565,'STR_MOVE_IN_OUT_WIZARD'),(10566,'STR_NEW_LEASE_AND_PAYMENT_DETAIL'),(10567,'STR_PROPERTY_DETAILS'),(10568,'STR_TENANT_LEDGER'),(10569,'STR_HIDE_GL_INPUTS_ON_POS_SCREEN'),(10570,'STR_ONLY_WORKS_IF_DEFAULT_GL_ACCOUNTS_ARE_SET'),(10571,'STR_DISCOUNT_ADD_UPDATE'),(10572,'STR_DISCOUNTS'),(10573,'STR_CLICK_ON_INVOICE_TO_CREATE_CREDIT_MEMO'),(10574,'STR_CREATE_RETURN'),(10575,'STR_ENTER_SEARCH_FILTER_VALUES'),(10576,'STR_NO_MATCH_FOUND'),(10577,'STR_RETURNS'),(10578,'STR_CREATE_CREDIT_MEMO'),(10579,'STR_ERROR_CREATING_CREDIT_MEMO'),(10580,'STR_QUANTITY_RETURNED'),(10581,'STR_CO_INVOICE'),(10582,'STR_DISCOUNTS_WILL_BE_APPLIED_AFTER_SAVING'),(10583,'STR_THIS_INVOICE_HAS_RETURNED_ITEMS'),(10584,'STR_YOU_CANNOT_CHANGE_UNLESS_CREDIT_MEMO_IS_CANCELLED_FIRST'),(10585,'STR_ALL_OTHER_LOCATIONS'),(10586,'STR_COPY_ITEM_PRICING_FROM_THIS_INVENTORY_LOCATION'),(10587,'STR_INVENTORY_PRICE_COPY'),(10588,'STR_PRICES_COPIED'),(10589,'STR_PRICE_COPY_FAILED'),(10590,'STR_TO_THIS_INVENTORY_LOCATION'),(10591,'STR_SHOW_ONLY_CUSTOMERS_WITH_NO_SALES'),(10592,'STR_COPY_ITEM_PRICES_TO_OTHER_LOCATION'),(10593,'STR_COPY_PRICING'),(10594,'STR_INVOICE_DISCOUNTS'),(10595,'STR_ITEM_RETURNS'),(10596,'STR_SELECT_ITEMS_FROM_INVOICES_BEING_RETURND_AND_CREATE_CREDIT_MEMO'),(10597,'STR_ALLOW_CO_INVOICING'),(10598,'STR_ACTUAL_REMAINING'),(10599,'STR_CHARGED'),(10600,'STR_CHARGED_REMAINING'),(10601,'STR_CO_INVOICES_UPDATED_SUCCESSFULLY'),(10602,'STR_CO_INVOICE_CUSTOMERS'),(10603,'STR_CO_INVOICE_EDIT'),(10604,'STR_GROUP_LINES_BY_SALES_ACCOUNT'),(10605,'STR_KEEP_ORIGINAL_LINE_ITEMS'),(10606,'STR_NO_CUSTOMERS_SELECTED'),(10607,'STR_NO_RECORD_ID_SET'),(10608,'STR_SET_UP_AT_LEAST_ONE_CUSTOMER_AS_A_CO_INVOICE_CUSTOMER'),(10609,'STR_SHOW_ACTUAL_PAID'),(10610,'STR_TRANSFER_METHOD'),(10611,'STR_YOU_MUST_SELECT_A_CUSTOMER_TO_CO_INVOICE'),(10612,'STR_YOU_MUST_UNPOST_THE_ORIGINAL_INVOICE_TO_ADD_NEW_INVOICES'),(10613,'STR_CUSTOM_DISCOUNT'),(10614,'STR_CO_INVOICE_INFO'),(10615,'STR_CO_INVOICE_CUSTOMER'),(10616,'STR_APPLY_TO_ORDER'),(10617,'STR_CREDIT_AVAILABLE'),(10618,'STR_HOW_TO_PROCESS'),(10619,'STR_LEAVE_BLANK_IF_NOT_SCANNING'),(10620,'STR_MANUALLY_ENTER'),(10621,'STR_SCAN_CARD'),(10622,'STR_TRACK_DATA'),(10623,'STR_MUST_SELECT_SPECIFIC_LOCATION'),(10624,'STR_UNIT_NAME_CHOICE_OR_CATEGORY_MISSING_FROM_ITEM_TRY_SAVING_MAIN_ITEM_DATA_FIRST'),(10625,'STR_DASHBOARD_REPORTS'),(10626,'STR_DASHBOARD_REPORTS_UPDATED_FAILURE'),(10627,'STR_DASHBOARD_REPORTS_UPDATED_SUCCESSFULLY'),(10628,'STR_CASH_INFLOW_CLIENT'),(10629,'STR_CASH_INFLOW_GFD'),(10630,'STR_CASH_INFLOW_REX'),(10631,'STR_CASH_OUTFLOW_CLIENT'),(10632,'STR_CASH_OUTFLOW_GFD'),(10633,'STR_COST_ARCHITECTURAL'),(10634,'STR_COST_INSPECTIONS_PERMITS'),(10635,'STR_COST_INTEREST'),(10636,'STR_HARD_COSTS'),(10637,'STR_INFLOW_AND_OUTFLOW'),(10638,'STR_PROJECT_CODE'),(10639,'STR_REMAINING_TOTAL_MUST_BE_ZERO_TO_EXIT'),(10640,'STR_SCHEDULE'),(10641,'STR_SOFT_COSTS'),(10642,'STR_AMORTIZATION_PERIODS'),(10643,'STR_DEBT_SERVICE_COVERAGE_DSC'),(10644,'STR_FIXED'),(10645,'STR_FLOATING'),(10646,'STR_GL_ACCOUNT_FOR_INTEREST_WHEN_IN_SERVICE'),(10647,'STR_GL_ACCOUNT_FOR_INTEREST_WHILE_UNDER_CONSTRUCTION'),(10648,'STR_GL_ACCOUNT_FOR_PRINCIPAL'),(10649,'STR_INTEREST_AND_PRINCIPAL'),(10650,'STR_INTEREST_DAYS_PER_YEAR'),(10651,'STR_INTEREST_ONLY'),(10652,'STR_INTEREST_PERCENT_PER_MONTH'),(10653,'STR_INTEREST_TYPE'),(10654,'STR_IN_SERVICE'),(10655,'STR_LOAN_ADD'),(10656,'STR_LOAN_ADDED_SUCCESSFULLY'),(10657,'STR_LOAN_ALREADY_EXISTS'),(10658,'STR_LOAN_DETAILS'),(10659,'STR_LOAN_NOT_ADDED'),(10660,'STR_LOAN_NUMBER'),(10661,'STR_LOAN_ORIGINATION_DATE'),(10662,'STR_LOAN_TO_VALUE_LTV'),(10663,'STR_MONTHLY_INTEREST_AMOUNT'),(10664,'STR_MONTHLY_PRINCIPAL_AMOUNT'),(10665,'STR_NET_CARRYING_BALANCE'),(10666,'STR_ORIGINAL_LOAN_BALANCE'),(10667,'STR_PAYMENT_DAY_OF_MONTH'),(10668,'STR_TERMS_DETAILS'),(10669,'STR_UNDER_CONSTRUCTION'),(10670,'STR_ADD_PAYMENTS'),(10671,'STR_ADD_SALE'),(10672,'STR_BILL_STATUS'),(10673,'STR_LOAN_CURTAILMENT_AMOUNT'),(10674,'STR_LOAN_DELETED_SUCCESSFULLY'),(10675,'STR_LOAN_PAYMENTS'),(10676,'STR_LOAN_UPDATE'),(10677,'STR_SALES_DETAIL'),(10678,'STR_SALE_DATE'),(10679,'STR_WRITEOFF_AMOUNT'),(10680,'STR_CHECK_IF_THESE_SHOULD_SHOW'),(10681,'STR_SHOW_ZERO_ACTIVITY_ACCOUNTS'),(10682,'STR_BILLS_TO_BE_CREATED_FOR_PAYMENTS'),(10683,'STR_LOAN_BILL_ADD'),(10684,'STR_LOAN_PAYMENT_FOR_LOAN'),(10685,'STR_OK_TO_CREATE'),(10686,'STR_PREVIOUSLY_CREATED_BILLS_FOR_PAYMENT'),(10687,'STR_VENDOR_MUST_BE_ASSIGNED_BEFORE_CREATING_PAYMENTS'),(10688,'STR_LOAN_BILL_UPDATE'),(10689,'STR_LOAN_SALES_ADD'),(10690,'STR_PREVIOUS_SALES'),(10691,'STR_SALE_ADDED_SUCCESSFULLY'),(10692,'STR_DELETE_THIS_SALE_RECORD'),(10693,'STR_LOAN_SALES_EDIT'),(10694,'STR_SALE_UPDATED_SUCCESSFULLY'),(10695,'STR_ADD_BUILDING'),(10696,'STR_AGENTS'),(10697,'STR_AGENTS_ADDED_FAILURE'),(10698,'STR_AGENTS_ADDED_SUCCESSFULLY'),(10699,'STR_AGENTS_DELETED_FAILURE'),(10700,'STR_AGENTS_DELETED_SUCCESSFULLY'),(10701,'STR_AGENTS_UPDATED_FAILURE'),(10702,'STR_AGENTS_UPDATED_SUCCESSFULLY'),(10703,'STR_BUILDINGS_FOR'),(10704,'STR_FLAT'),(10705,'STR_LATE_PERCENTAGE'),(10706,'STR_NEW_LEASE'),(10707,'STR_NEW_LEASE_FLAT'),(10708,'STR_NEW_LEASE_PERCENT'),(10709,'STR_OVER_30_DAYS'),(10710,'STR_OVER_30_DAYS_LATE_PERCENTAGE'),(10711,'STR_OVER_60_DAYS'),(10712,'STR_OVER_60_DAYS_LATE_PERCENTAGE'),(10713,'STR_OVER_90_DAYS_LATE_PERCENTAGE'),(10714,'STR_RENEW_LEASE'),(10715,'STR_RENEW_LEASE_FLAT'),(10716,'STR_RENEW_LEASE_PERCENT'),(10717,'STR_THIS_AGENT_ALREADY_HAS_AN_ASSOCIATION_WITH_THIS_BUILDING'),(10718,'STR_CURRENT_ONSITE_DOT_COM_SETUPS'),(10719,'STR_NOLAPRO_USER'),(10720,'STR_ONSITE_DOT_COM_ORIGINATOR_ID'),(10721,'STR_ONSITE_DOT_COM_PASSWORD'),(10722,'STR_ONSITE_DOT_COM_PROPERTY_ID'),(10723,'STR_ONSITE_DOT_COM_SETUP_ADD'),(10724,'STR_ONSITE_DOT_COM_SETUP_ADDED_FAILURE'),(10725,'STR_ONSITE_DOT_COM_SETUP_ADDED_SUCCESSFULLY'),(10726,'STR_ONSITE_DOT_COM_SETUP_DELETE'),(10727,'STR_ONSITE_DOT_COM_SETUP_DELETED_FAILURE'),(10728,'STR_ONSITE_DOT_COM_SETUP_DELETED_SUCCESSFULLY'),(10729,'STR_ONSITE_DOT_COM_SETUP_UPDATE'),(10730,'STR_ONSITE_DOT_COM_SETUP_UPDATED_FAILURE'),(10731,'STR_ONSITE_DOT_COM_SETUP_UPDATED_SUCCESSFULLY'),(10732,'STR_ONSITE_DOT_COM_USERNAME'),(10733,'STR_PLEASE_INCLUDE_NOLAPRO_USER'),(10734,'STR_PLEASE_INCLUDE_ONSITE_DOT_COM_ORIGINATOR_ID'),(10735,'STR_PLEASE_INCLUDE_ONSITE_DOT_COM_PASSWORD'),(10736,'STR_PLEASE_INCLUDE_ONSITE_DOT_COM_PROPERTY_ID'),(10737,'STR_PLEASE_INCLUDE_ONSITE_DOT_COM_USERNAME'),(10738,'STR_THIS_USER_ALREADY_HAS_AN_ONSITE_DOT_COM_SETUP'),(10739,'STR_UNDER_REPAIR'),(10740,'STR_WORK_ORDER_NOTIFICATIONS'),(10741,'STR_WORK_ORDER_NOTIFICATIONS_ADDED_FAILURE'),(10742,'STR_WORK_ORDER_NOTIFICATIONS_ADDED_SUCCESSFULLY'),(10743,'STR_TAXABLE_INCOME'),(10744,'STR_ONSITE_DOT_COM_SETUP'),(10745,'STR_PORTAL'),(10746,'STR_WORK_ORDERS'),(10747,'STR_PROPERTY_MANAGEMENT_PORTAL_ACCESS'),(10748,'STR_ADDITIONAL_INFORMATION'),(10749,'STR_ADD_SCREENING'),(10750,'STR_ANNUAL_INCOME'),(10751,'STR_BIRTH_DATE'),(10752,'STR_CURRENT_SCREENINGS'),(10753,'STR_DECISION'),(10754,'STR_EDIT_PROSPECT'),(10755,'STR_ERROR_DESCRIPTION'),(10756,'STR_ERROR_RESPONSE_FROM_ONSITE_DOT_COM'),(10757,'STR_MONTHLY_RENT'),(10758,'STR_ON_SITE_DOT_COM_RESPONSE'),(10759,'STR_PLEASE_INCLUDE_MONTHLY_RENT'),(10760,'STR_PROSPECT_READY_FOR_SCREENING'),(10761,'STR_REPORT_ID'),(10762,'STR_SCORE'),(10763,'STR_SCREENING_ADDED_SUCCESSFULLY'),(10764,'STR_SCREENING_DATE'),(10765,'STR_SCREENING_UPDATED_SUCCESSFULLY'),(10766,'STR_SEARCH_PROSPECTS'),(10767,'STR_THIS_PROSPECT_IS_MISSING_THE_FOLLOWING_INFORMATION_REQUIRED_FOR_SCREENING'),(10768,'STR_UPDATE_SCREENING'),(10769,'STR_VIEW_ERROR'),(10770,'STR_VIEW_SCREENING'),(10771,'STR_CREATE_LEASE'),(10772,'STR_HALF_HEIGHT_LIMIT_SEVEN_ITEMS_IGNORES_OTHER_FORMAT_OPTIONS'),(10773,'STR_DIRECT_GL_PAYMENT_ENTRIES_NOT_ON_STATEMENT'),(10774,'STR_DIRECT_GL_RECEIPTS'),(10775,'STR_DEBT'),(10776,'STR_BILLING_ADDRESS_IS_IGNORED_FOR_CARD_PRESENT_TRANSACTIONS'),(10777,'STR_DATE_CONFIRMED'),(10778,'STR_PENDING_WORK_DETAIL'),(10779,'STR_ADD_SYSTEM_DOCUMENT'),(10780,'STR_FINANCING'),(10781,'STR_GFD'),(10782,'STR_LOAN_CONTRIBUTION_CLIENT'),(10783,'STR_LOAN_CONTRIBUTION_GFD'),(10784,'STR_LOAN_CONTRIBUTION_REX'),(10785,'STR_LTV'),(10786,'STR_NET_FINANCING'),(10787,'STR_REMAINDER'),(10788,'STR_REMAINING_CASH_USAGES'),(10789,'STR_REX'),(10790,'STR_SITE_AND_GENERAL'),(10791,'STR_TOTAL_CASH_USAGES'),(10792,'STR_TOTAL_HARD_COSTS'),(10793,'STR_TOTAL_SOFT_COSTS'),(10794,'STR_BILL_INVOICE_NUMBER'),(10795,'STR_FILENAME'),(10796,'STR_FILE_BROWSER'),(10797,'STR_NO_FILES_FOUND'),(10798,'STR_UPLOADED_BY'),(10799,'STR_USER_GROUP'),(10800,'STR_DOWNLOAD_PAYROLL_DATA'),(10801,'STR_SIGNED_OUT'),(10802,'STR_SIGNED_OUT_BY'),(10803,'STR_SIGN_IN_THIS_PIECE_OF_EQUIPMENT'),(10804,'STR_SIGN_OUT_THIS_PIECE_OF_EQUIPMENT'),(10805,'STR_VIEW_PO'),(10806,'STR_EQUIPMENT_SIGNED_IN_FAILURE'),(10807,'STR_EQUIPMENT_SIGNED_IN_SUCCESSFULLY'),(10808,'STR_EQUIPMENT_SIGNED_OUT_FAILURE'),(10809,'STR_EQUIPMENT_SIGNED_OUT_SUCCESSFULLY'),(10810,'STR_EQUIPMENT_SIGN_IN'),(10811,'STR_EQUIPMENT_SIGN_OUT'),(10812,'STR_MUST_SIGN_IN_THIS_PIECE_OF_EQUIPMENT'),(10813,'STR_PLEASE_INCLUDE_EQUIPMENT'),(10814,'STR_SIGN_IN'),(10815,'STR_SIGN_OUT'),(10816,'STR_BEGIN_DATE_OUT'),(10817,'STR_CURRENTLY_OUT'),(10818,'STR_END_DATE_OUT'),(10819,'STR_EQUIPMENT_SIGNED_OUT'),(10820,'STR_ASSESSMENT_AMOUNT'),(10821,'STR_ASSESSMENT_DATE'),(10822,'STR_ASSOCIATED_BILL_DOES_NOT_HAVE_MATCHING_GL_ACCOUNT'),(10823,'STR_BUILDING_PROPERTY_TAX_ADD'),(10824,'STR_BUILDING_PROPERTY_TAX_DELETE'),(10825,'STR_BUILDING_PROPERTY_TAX_UPDATE'),(10826,'STR_BUILDING_TAX_DELETED_FAILURE'),(10827,'STR_BUILDING_TAX_DELETED_SUCCESSFULLY'),(10828,'STR_BUILDING_TAX_UPDATED_FAILURE'),(10829,'STR_BUILDING_TAX_UPDATED_SUCCESSFULLY'),(10830,'STR_EARLY_AMOUNT'),(10831,'STR_HOW_TAX_IS_CALCULATED'),(10832,'STR_LATE_AMOUNT'),(10833,'STR_LATE_IF_PAID_AFTER'),(10834,'STR_NAME_ON_BILL'),(10835,'STR_ONTIME_AMOUNT'),(10836,'STR_PAY_BEFORE_FOR_EARLY'),(10837,'STR_PAY_TO_VENDOR_NAME'),(10838,'STR_PLEASE_INCLUDE_TAX_TYPE'),(10839,'STR_PROPERTY_TAXES_FOR_BUILDING'),(10840,'STR_TAX_PAYMENTS'),(10841,'STR_PROPERTY_TAX_TYPE'),(10842,'STR_PROPERTY_TAX_TYPES_ADD'),(10843,'STR_PROPERTY_TAX_TYPES_DELETE'),(10844,'STR_PROPERTY_TAX_TYPES_UPDATE'),(10845,'STR_PROPERTY_TAX_TYPE_ADDED_SUCCESSFULLY'),(10846,'STR_PROPERTY_TAX_TYPE_ATTACHED_TO_TAX_ENTRY'),(10847,'STR_PROPERTY_TAX_TYPE_DELETED_FAILURE'),(10848,'STR_PROPERTY_TAX_TYPE_DELETED_SUCCESSFULLY'),(10849,'STR_PROPERTY_TAX_TYPE_UPDATED_FAILURE'),(10850,'STR_PROPERTY_TAX_TYPE_UPDATED_SUCCESSFULLY'),(10851,'STR_PROPERTY_TYPE_ADDED_FAILURE'),(10852,'STR_ACADEMIC_YEAR_LEASE'),(10853,'STR_MONTHS_AFTER_INVOICE_DATE'),(10854,'STR_PERCENT_REVENUE'),(10855,'STR_REVENUE_RECOGNITION'),(10856,'STR_REVENUE_RECOGNITION_SAVED_SUCCESSFULLY'),(10857,'STR_SEMESTER_LEASE'),(10858,'STR_THE_TOTAL_PERCENT_FOR_ACADEMIC_YEAR_MUST_EQUAL_100'),(10859,'STR_THE_TOTAL_PERCENT_FOR_SEMESTER_MUST_EQUAL_100'),(10860,'STR_ASSIGNED_TO'),(10861,'STR_ASSIGN_TO'),(10862,'STR_BEGIN_ENTRY_DATE'),(10863,'STR_CHARGE_TO'),(10864,'STR_CURRENT_ONLY'),(10865,'STR_CURRENT_WORK_ORDERS'),(10866,'STR_DENIED_REASON'),(10867,'STR_END_ENTRY_DATE'),(10868,'STR_EQUIPMENT_FOR_THIS_WORK_ORDER'),(10869,'STR_IMPROVEMENT'),(10870,'STR_ISSUE'),(10871,'STR_IS_NOW_ACTIVE'),(10872,'STR_MODERATE'),(10873,'STR_NEW_JOB_ADDED_FAILURE'),(10874,'STR_NEW_JOB_ADDED_SUCCESSFULLY'),(10875,'STR_NO_ONE'),(10876,'STR_NO_WORK_ORDERS_FOUND'),(10877,'STR_PLEASE_INCLUDE_ESTIMATED_END_DATE'),(10878,'STR_PLEASE_INCLUDE_OTHER_COMPANY_TO_CHARGE_TO'),(10879,'STR_PLEASE_INCLUDE_START_DATE'),(10880,'STR_PREVENTIVE'),(10881,'STR_REPAIRS'),(10882,'STR_RESOLUTION'),(10883,'STR_SIGN_OUT_EQUIPMENT'),(10884,'STR_SUBMITTED_FOR_APPROVAL'),(10885,'STR_TENANT_AVAILABILITY'),(10886,'STR_TENANT_DESCRIPTION'),(10887,'STR_TERMINATED'),(10888,'STR_URGENT'),(10889,'STR_WARRANTY_WORK'),(10890,'STR_WORK_ORDER_ACTIVE'),(10891,'STR_WORK_ORDER_ADD'),(10892,'STR_WORK_ORDER_ADDED_FAILURE'),(10893,'STR_WORK_ORDER_ADDED_SUCCESSFULLY'),(10894,'STR_WORK_ORDER_DELETE'),(10895,'STR_WORK_ORDER_DELETED_FAILURE'),(10896,'STR_WORK_ORDER_DELETED_SUCCESSFULLY'),(10897,'STR_WORK_ORDER_UPDATE'),(10898,'STR_WORK_ORDER_UPDATED_FAILURE'),(10899,'STR_WORK_ORDER_UPDATED_SUCCESSFULLY'),(10900,'STR_YOU_CAN_NOT_APPROVE_THIS_WORK_ORDER'),(10901,'STR_YOU_CAN_NOT_DENY_THIS_WORK_ORDER'),(10902,'STR_ENTER_1099_IF_EXEMPT_SUBCONTRACTOR'),(10903,'STR_REAL_ESTATE_BUILDING_TAX'),(10904,'STR_REAL_ESTATE_TAX_TYPES'),(10905,'STR_WORK_ORDERS_ADD_UPDATE'),(10906,'STR_LEASE_DOCUMENTS'),(10907,'STR_EMAIL_SIGNATURE'),(10908,'STR_ADD_MAINTENANCE_REQUEST'),(10909,'STR_AVAILABILITY'),(10910,'STR_CURRENT_MAINTENANCE_REQUESTS'),(10911,'STR_FIX_DATE'),(10912,'STR_MAINTENANCE_REQUEST'),(10913,'STR_MAINTENANCE_REQUEST_ADDED_SUCCESSFULLY'),(10914,'STR_MAINTENANCE_REQUEST_DELETED_SUCCESSFULLY'),(10915,'STR_NO_MAINTENANCE_REQUESTS_FOUND'),(10916,'STR_PLEASE_INCLUDE_PROBLEM'),(10917,'STR_PROBLEM'),(10918,'STR_REQUEST_MAINTENANCE_HELP'),(10919,'STR_REQUEST_MAINTENANCE_HELP_INSTRUCTIONS'),(10920,'STR_REQUEST_MAINTENANCE_INSTRUCTIONS'),(10921,'STR_DEFERRED_REVENUE'),(10922,'STR_SYSTEM_DOCUMENT_REMOVED'),(10923,'STR_LATE_FEE'),(10924,'STR_PET_RENT'),(10925,'STR_TRANSFER_FEE'),(10926,'STR_BUILDING_TAX_ADDED_FAILURE'),(10927,'STR_BUILDING_TAX_ADDED_SUCCESSFULLY'),(10928,'STR_BILL_CREATED'),(10929,'STR_BUILDING_PROPERTY_TAX_ADD_TO_PAYABLES'),(10930,'STR_BUILDING_PROPERTY_TAX_REPORT'),(10931,'STR_SENT_TO_PAYABLES'),(10932,'STR_SHOW_WHICH_GROUPS'),(10933,'STR_YEAR_FOR_AMOUNTS'),(10934,'STR_ADD_MATERIALS_AND_OTHER_CHARGES'),(10935,'STR_BEGIN_ESTIMATED_END_DATE'),(10936,'STR_CUSTOMER_TO_INVOICE_MUST_BE_SET'),(10937,'STR_EMPLOYEE_TIME'),(10938,'STR_END_ESTIMATED_END_DATE'),(10939,'STR_EST_END_DATE'),(10940,'STR_GRAND_TOTALS'),(10941,'STR_MARKUP_PERCENTAGE'),(10942,'STR_MATERIALS_AND_OTHER_CHARGES'),(10943,'STR_STAFF_HOURS'),(10944,'STR_TOTAL_WORK_ORDER_COST'),(10945,'STR_WORK_ORDER_MUST_BE_APPROVED_BEFORE_DETAILS_CAN_BE_ADDED'),(10946,'STR_MONTHS'),(10947,'STR_SEMESTERS'),(10948,'STR_WEEKS'),(10949,'STR_100_PERCENT_ON_DUE_DATE'),(10950,'STR_ADD_LEASE_INVOICES'),(10951,'STR_ADD_LEASE_INVOICES_INSTRUCTIONS'),(10952,'STR_CO_TENANT'),(10953,'STR_CREATE_INVOICES_FOR_LEASE'),(10954,'STR_DEFERRED_REVENUE_ACCOUNT'),(10955,'STR_GENERATE_INVOICES'),(10956,'STR_INVOICES_FOR_THIS_LEASE'),(10957,'STR_LEASES_ADDED_SUCCESSFULLY'),(10958,'STR_LEASE_CHARGE'),(10959,'STR_LEASE_PAYMENT'),(10960,'STR_LEASE_TERM'),(10961,'STR_MOVE_OUT'),(10962,'STR_NO_LEASE_ID_IS_SET'),(10963,'STR_PRORATED_AMOUNT'),(10964,'STR_PRORATED_RENT'),(10965,'STR_REPEATED_FOR_SECOND_PAYMENT'),(10966,'STR_RESERVATION_FEE_ACCOUNT'),(10967,'STR_REVENUE_ACCOUNT'),(10968,'STR_REVIEW_LEASE'),(10969,'STR_SCHEDULED_INVOICES'),(10970,'STR_SECURITY_DEPOSIT'),(10971,'STR_SECURITY_DEPOSIT_ACCOUNT'),(10972,'STR_TERM_TYPE'),(10973,'STR_TOTAL_LEASE_PAYMENTS'),(10974,'STR_YOU_MUST_SELECT_A_DEFERRED_REVENUE_GL_ACCOUNT'),(10975,'STR_YOU_MUST_SELECT_A_DEPOSIT_GL_ACCOUNT'),(10976,'STR_YOU_MUST_SELECT_A_RESERVATION_FEE_GL_ACCOUNT'),(10977,'STR_YOU_MUST_SELECT_A_REVENUE_GL_ACCOUNT'),(10978,'STR_LEASE_PAYMENTS'),(10979,'STR_LEASE_PAYMENT_INSTRUCTIONS'),(10980,'STR_THE_INITIAL_LEASE_HAS_ALREADY_BEEN_PAID'),(10981,'STR_OVERAGE_CAP_AMT'),(10982,'STR_ADD_INVOICES'),(10983,'STR_LAST_ACTIVITY'),(10984,'STR_MOVE_IN_DELETED_SUCCESSFULLY'),(10985,'STR_MOVE_IN_WIZARD'),(10986,'STR_MOVE_IN_WIZARD_INSTRUCTIONS'),(10987,'STR_NEW_MOVE_IN'),(10988,'STR_READY_TO'),(10989,'STR_REMOVE'),(10990,'STR_STARTED'),(10991,'STR_LEASE'),(10992,'STR_NO_LEASE_FILE_UPLOADED_FOR_THIS_PROPERTY'),(10993,'STR_JOB_LIST'),(10994,'STR_ADD_REMINDER'),(10995,'STR_REMINDERS'),(10996,'STR_USE_THIS'),(10997,'STR_CREATE_NOW'),(10998,'STR_AMOUNT_TO_INVOICE'),(10999,'STR_MOVE_PO_AND_TIME_DATA_TO_SERVICE_ORDER'),(11000,'STR_PO_AND_TIME_DATA_MOVED_FAILURE'),(11001,'STR_PO_AND_TIME_DATA_MOVED_SUCCESSFULLY'),(11002,'STR_THIS_WORK_ORDER_HAS_ALREADY_BEEN_MOVED'),(11003,'STR_YOU_MUST_CREATE_A_MATERIALS_AND_OTHER_CHARGES_SERVICE_ORDER_FIRST'),(11004,'STR_LOAN_UPDATE_AND_PAY'),(11005,'STR_JOB_DOCUMENTS'),(11006,'STR_LOAN_DOCUMENTS'),(11007,'STR_LEASE_REVIEW'),(11008,'STR_BACK_TO_LEASE'),(11009,'STR_NO_INVOICES_HAVE_BEEN_MADE_YET'),(11010,'STR_VIEW_INVOICES'),(11011,'STR_BACKGROUND_SCREENING'),(11012,'STR_EMAIL_TENANT'),(11013,'STR_OVER_DUE'),(11014,'STR_RECENT_INVOICES'),(11015,'STR_RECENT_WORK_ORDERS'),(11016,'STR_VIEW_CHECKLIST'),(11017,'STR_MOVE_OUT_WIZARD'),(11018,'STR_MOVE_IN_CHECKLIST'),(11019,'STR_MANAGEMENT_FEES_ACCOUNT'),(11020,'STR_MANAGEMENT_FEES_INCOME'),(11021,'STR_BILLED_TO'),(11022,'STR_CREATE_INVOICES'),(11023,'STR_EXPENSE_GL'),(11024,'STR_EXTRA_CHARGE'),(11025,'STR_FEE_PERCENT'),(11026,'STR_INVOICE_CREATION_FAILED'),(11027,'STR_MANAGEMENT_FEES'),(11028,'STR_MANAGEMENT_FEES_REPORT'),(11029,'STR_MANAGEMENT_FEES_THROUGH'),(11030,'STR_NO_BUILDINGS_FOUND'),(11031,'STR_PAYMENTS_PRIOR_TO'),(11032,'STR_TOTAL_FEE'),(11033,'STR_ELECTRIC_RATE_BASIS'),(11034,'STR_GAS_RATE_BASIS'),(11035,'STR_WATER_RATE_BASIS'),(11036,'STR_CALCULATE_COMMISSIONS'),(11037,'STR_COMMISSIONS'),(11038,'STR_COMMISSIONS_CALCULATED_FAILURE'),(11039,'STR_COMMISSIONS_CALCULATED_SUCCESSFULLY'),(11040,'STR_COMMISSION_FLAT'),(11041,'STR_COMMISSION_PERCENTAGE'),(11042,'STR_EARNED'),(11043,'STR_NO_QUALIFYING_COMMISSIONS_FOUND'),(11044,'STR_UNEARNED'),(11045,'STR_SQUARE_FEET'),(11046,'STR_SB'),(11047,'STR_BILL_MANAGEMENT_FEES'),(11048,'STR_FAILED_TO_GET_INVOICE_PDF'),(11049,'STR_FAILED_TO_SEND'),(11050,'STR_PLEASE_PAY_BY'),(11051,'STR_YOUR_LATEST_INVOICE_IS_ATTACHED'),(11052,'STR_EXPORT_MONTH'),(11053,'STR_CAM_ALLOCATION_CHARGES'),(11054,'STR_CAM_ALLOCATION_DETAILS'),(11055,'STR_NO_CAM_ALLOCATION_ID_SET'),(11056,'STR_SQ_FT'),(11057,'STR_ADD_CAM_ALLOCATION_CHARGES'),(11058,'STR_ADD_CHARGE'),(11059,'STR_ADD_CHARGES'),(11060,'STR_ADD_TENANT_CHARGES'),(11061,'STR_ADD_TENANT_UTILITY_AND_OTHER_CHARGES'),(11062,'STR_AMT_THIS_PERIOD'),(11063,'STR_AMT_TO_ALLOCATE'),(11064,'STR_CAM_ALLOCATION_CHARGES_ADDED_SUCCESSFULLY'),(11065,'STR_CAM_ALLOCATION_DETAIL'),(11066,'STR_CAM_CHARGES_DELETED_SUCCESSFULLY'),(11067,'STR_CAM_DESCRIPTION'),(11068,'STR_CHARGE_ADDED_SUCCESSFULLY'),(11069,'STR_CHARGE_DELETED_SUCCESSFULLY'),(11070,'STR_ELECTRIC'),(11071,'STR_GAS'),(11072,'STR_INVOICE_EXTRA_CHARGES'),(11073,'STR_LAST_READING'),(11074,'STR_METERED_UTILITY'),(11075,'STR_NEW_METER_READING'),(11076,'STR_PENDING_EXTRA_CHARGES'),(11077,'STR_PREVIOUS_CAM_ALLOCATION_CHARGES'),(11078,'STR_RATE_BASIS'),(11079,'STR_UNIT_BREAKDOWN'),(11080,'STR_UTILITIES'),(11081,'STR_WATER'),(11082,'STR_YOU_MUST_SELECT_A_BUILDING'),(11083,'STR_YOU_MUST_SELECT_A_TENANT'),(11084,'STR_CHARGES_INVOICED_SUCCESSFULLY'),(11085,'STR_EXTRA_INVOICE_CHARGES'),(11086,'STR_GET_CHARGES'),(11087,'STR_INCLUDE_INVOICED'),(11088,'STR_NO_PENDING_CHARGES_FOUND'),(11089,'STR_POST_INVOICE_EXTRA_CHARGES'),(11090,'STR_POST_PENDING_CHARGES'),(11091,'STR_SEARCH_FOR_CHARGES'),(11092,'STR_BEGIN_RANGE'),(11093,'STR_END_RANGE'),(11094,'STR_INVOICES_SENT'),(11095,'STR_INVOICE_NOTIFICATIONS'),(11096,'STR_NUM_SENT'),(11097,'STR_PREVIOUS_NOTIFICATIONS'),(11098,'STR_SELECT_INVOICE_DUE_DATE_RANGE'),(11099,'STR_SEND_INVOICE_NOTIFICATIONS'),(11100,'STR_SENT_BY'),(11101,'STR_YOU_MUST_ENTER_AN_END_DATE'),(11102,'STR_YOU_MUST_ENTER_A_BEGIN_DATE'),(11103,'STR_ADD_INVOICE_CHARGES'),(11104,'STR_SEND_NOTIFICATIONS_AND_ADD_EXTRA_CHARGES'),(11105,'STR_EDIT_CUSTOMERS'),(11106,'STR_CUSTOMER_INFO_UPDATED_SUCCESSFULLY'),(11107,'STR_GO_TO_PAGE'),(11108,'STR_NO_CREDIT_TERMS'),(11109,'STR_REASON_FOR_NO_TERMS'),(11110,'STR_YOU_MUST_ENTER_A_PRICE_LEVEL'),(11111,'STR_YOU_MUST_ENTER_INVOICE_TERMS'),(11112,'STR_GL_ACCOUNT_FOR_WRITEOFF'),(11113,'STR_THIS_ORDER_MUST_BE_PREPAID_BEFORE_SHIPPING'),(11114,'STR_THIS_ORDER_CANNOT_BE_INVOICED_UNTIL_PAID'),(11115,'STR_ACTIVE_AND_INACTIVE'),(11116,'STR_ACTIVE_ONLY'),(11117,'STR_ALL_ITEMS'),(11118,'STR_INACTIVE_ONLY'),(11119,'STR_ONLY_NON_SHOPPING_CART_ITEMS'),(11120,'STR_ONLY_SHOPPING_CART_ITEMS'),(11121,'STR_SHOW_WHICH_SHOPPING_CART_ITEMS'),(11122,'STR_NO_CREDIT_ALLOWED'),(11123,'STR_NO_CREDIT_EXPLANATION'),(11124,'STR_NO_CREDIT_EXTENDED'),(11125,'STR_REAL_ESTATE_TAX_ESCROW'),(11126,'STR_REAL_ESTATE_TAX_EXPENSE'),(11127,'STR_REAL_ESTATE_TAX_LIABILITY'),(11128,'STR_LEASE_EXPIRATIONS'),(11129,'STR_PROPERY_DETAILS'),(11130,'STR_RENT_ROLL'),(11131,'STR_RESCINDED_OR_TERMINATED_LEASES'),(11132,'STR_IS_THIS_A_CLIENT_COMPANY'),(11133,'STR_LEASE_NOTES'),(11134,'STR_ADD_CREDIT_CARD'),(11135,'STR_CREDIT_CARDS'),(11136,'STR_CREDIT_CARDS_INSTRUCTIONS'),(11137,'STR_CREDIT_CARD_ADDED_SUCCESSFULLY'),(11138,'STR_CREDIT_CARD_DELETED_SUCCESSFULLY'),(11139,'STR_CREDIT_CARD_EXPIRATION_DATE_OUT_OF_RANGE'),(11140,'STR_CREDIT_CARD_HELP'),(11141,'STR_CREDIT_CARD_HELP_INSTRUCTIONS'),(11142,'STR_CREDIT_CARD_NUMBER'),(11143,'STR_CREDIT_CARD_ORDER_SAVED_SUCCESSFULLY'),(11144,'STR_CREDIT_CARD_TYPE_NOT_RECOGNIZED'),(11145,'STR_EXPIRATION_MONTH'),(11146,'STR_EXPIRATION_YEAR'),(11147,'STR_GUARANTOR_CARD'),(11148,'STR_NAME_ON_CARD'),(11149,'STR_NO_CREDIT_CARDS_FOUND'),(11150,'STR_PLEASE_INCLUDE_AN_EXPIRATION_MONTH'),(11151,'STR_PLEASE_INCLUDE_AN_EXPIRATION_YEAR'),(11152,'STR_PLEASE_INCLUDE_A_NAME_ON_CARD'),(11153,'STR_PLEASE_INCLUDE_A_TENANT'),(11154,'STR_PLEASE_INCLUDE_A_VALID_CREDIT_CARD_NUMBER'),(11155,'STR_SAVE_ORDER'),(11156,'STR_INVOICES_ADDED_SUCCESSFULLY'),(11157,'STR_ERROR_DELETING_LEASE'),(11158,'STR_RESCIND'),(11159,'STR_RESCIND_NOT_ALLOWED'),(11160,'STR_MOVE_OUT_DELETED_SUCCESSFULLY'),(11161,'STR_MOVE_OUT_WIZARD_INSTRUCTIONS'),(11162,'STR_NEW_MOVE_OUT'),(11163,'STR_PROCESS_MOVE_OUT'),(11164,'STR_SELECT_MOVE_OUT_TYPE'),(11165,'STR_DEPOSIT_CREDIT'),(11166,'STR_DEPOSIT_REFUND'),(11167,'STR_DEPOSIT_REMAINDER'),(11168,'STR_DEPOSIT_RETAINED'),(11169,'STR_DEPOSIT_REVENUE'),(11170,'STR_DEPOSIT_REVENUE_ACCOUNT'),(11171,'STR_LEASE_RENEWAL'),(11172,'STR_LEASE_RENEWED_SUCCESSFULLY'),(11173,'STR_LEASE_TERMINATED_SUCCESSFULLY'),(11174,'STR_PET_DEPOSIT_CREDIT'),(11175,'STR_PET_DEPOSIT_REFUND'),(11176,'STR_PET_DEPOSIT_REMAINDER'),(11177,'STR_PROCESS_LEASE'),(11178,'STR_SECURITY_DEPOSIT_REFUND'),(11179,'STR_SELECT_TYPE'),(11180,'STR_TERM'),(11181,'STR_TERMINATE_LEASE'),(11182,'STR_TRANSFER_LEASE'),(11183,'STR_SELECT_LEASE'),(11184,'STR_TENANT_INVOICES_INSTRUCTIONS'),(11185,'STR_MOVE_IN_DATE'),(11186,'STR_MOVE_OUT_DATE'),(11187,'STR_NO_LEASE_FOUND'),(11188,'STR_PRORATED_DAYS'),(11189,'STR_RECENT_LEASES'),(11190,'STR_RENT'),(11191,'STR_TENANT_LEASES_INSTRUCTIONS'),(11192,'STR_DAYS_LATE'),(11193,'STR_TENANT_PAYMENTS_INSTRUCTIONS'),(11194,'STR_LEASE_AMOUNT'),(11195,'STR_VIEW_LEASES'),(11196,'STR_VIEW_PAYMENTS'),(11197,'STR_MOVE_OUT_CHECKLIST'),(11198,'STR_MONTHLY_REAL_ESTATE_TAX'),(11199,'STR_TAX_ESCROW_AMOUNT'),(11200,'STR_TAX_EXPENSE'),(11201,'STR_TAX_FOR_ESCROW'),(11202,'STR_TAX_LIABILITY'),(11203,'STR_TAX_TO_ESCROW'),(11204,'STR_MANAGEMENT_FEES_PAID'),(11205,'STR_MANAGEMENT_FEES_PAID_LIST'),(11206,'STR_COULD_NOT_FIND_PAYROLL_EXCEL_FILE'),(11207,'STR_DOWNLOAD_PAYROLL_SHEET'),(11208,'STR_EXPORT_PAYROLL_DATA_FOR_PROCESSOR'),(11209,'STR_NO_PAYROLLS_FOUND'),(11210,'STR_AUTO'),(11211,'STR_AUTO_BILLING_COMPLETED_SUCCESSFULLY'),(11212,'STR_BILLING_FAILURE'),(11213,'STR_CREDIT_CARD_IS_EXPIRED'),(11214,'STR_FAILED_ATTEMPTS'),(11215,'STR_INVOICE_AUTO_BILLING'),(11216,'STR_INVOICE_PAID_SUCCESSFULLY'),(11217,'STR_LEASE_AUTO_BILLING'),(11218,'STR_LEASE_AUTO_BILLING_RESULTS'),(11219,'STR_NO_AVAILABLE_CREDIT_CARDS'),(11220,'STR_NUMBER_SUCCESSFUL'),(11221,'STR_PAID_SUCCESSFULLY'),(11222,'STR_RUN_AUTO_BILLING'),(11223,'STR_THIS_COMPANY_IS_NOT_CONFIGURED_TO_PROCESS_CREDIT_CARDS'),(11224,'STR_TOTAL_BILLED'),(11225,'STR_TOTAL_CUSTOMERS'),(11226,'STR_AMOUNT_FILED'),(11227,'STR_COURT_FILINGS'),(11228,'STR_DATE_FILED'),(11229,'STR_FILING_TITLE'),(11230,'STR_JUDGEMENT_DATE'),(11231,'STR_JUDGMENT_AMOUNT'),(11232,'STR_REASON_FOR_FILING'),(11233,'STR_RECEIVED_JUDGEMENT'),(11234,'STR_EQUIPMENT_INVENTORY'),(11235,'STR_GUARANTOR'),(11236,'STR_GUARANTOR_BILLING_ADDRESS'),(11237,'STR_GUARANTOR_INFO'),(11238,'STR_INVOICE_CHARGES_BREAKDOWN'),(11239,'STR_OUTSTANDING'),(11240,'STR_PAID_AMOUNT'),(11241,'STR_TOTAL_INVOICED'),(11242,'STR_UPCOMING_MOVE_INS_AND_MOVE_OUTS'),(11243,'STR_FIELDS'),(11244,'STR_GL_WAS_VOIDED'),(11245,'STR_REAL_ESTATE_TAX_PAID'),(11246,'STR_RENT_EARNED'),(11247,'STR_RENT_RECEIVED'),(11248,'STR_RENT_ROLL_AS_OF'),(11249,'STR_DEPOSIT_GL_ACCOUNT'),(11250,'STR_DEPOSIT_RETAINED_VOUCHER'),(11251,'STR_DEPOSIT_RETURNED_INVOICE'),(11252,'STR_PET_DEPOSIT_RETAINED'),(11253,'STR_PET_DEPOSIT_RETURNED'),(11254,'STR_SECURITY_DEPOSIT_RECONCILIATIONS'),(11255,'STR_SECURITY_DEPOSIT_RETAINED'),(11256,'STR_SECURITY_DEPOSIT_RETURNED'),(11257,'STR_AVAILABLE_LEASES'),(11258,'STR_NOT_LEASED'),(11259,'STR_PERCENTAGE_NOT_LEASED'),(11260,'STR_PERCENTAGE_RATIFIED_LEASES'),(11261,'STR_PERCENTAGE_RESERVED_LEASES'),(11262,'STR_PERCENTAGE_SIGNED_LEASES'),(11263,'STR_PERCENTAGE_TOTAL_LEASED'),(11264,'STR_PLEASE_INCLUDE_A_DATE'),(11265,'STR_RATIFIED_LEASES'),(11266,'STR_RESERVED_LEASES'),(11267,'STR_SIGNED_LEASES'),(11268,'STR_SIGNED_LEASES_AS_OF'),(11269,'STR_TOTAL_LEASED'),(11270,'STR_ANTICIPATED_GRADUATION_DATE'),(11271,'STR_CURRENT_CLASS'),(11272,'STR_STUDENT_CLASS'),(11273,'STR_ENDED'),(11274,'STR_RENEWED'),(11275,'STR_TENANT_PERFORMANCE_SUMMARY'),(11276,'STR_TRANSFERRED'),(11277,'STR_RESCINDED'),(11278,'STR_RESCINDED_ONLY'),(11279,'STR_TERMINATED_ONLY'),(11280,'STR_UTILITY_INVOICING'),(11281,'STR_DAYS_OPEN'),(11282,'STR_TOTAL_CHARGES'),(11283,'STR_AVERAGE_TIME_OPEN'),(11284,'STR_CLIENTS'),(11285,'STR_OTHER_COMPANIES'),(11286,'STR_WORK_ORDER_STATS'),(11287,'STR_WORK_ORDER_STATS_AS_OF'),(11288,'STR_COMPANY_TIMECLOCK_WORK_FOR'),(11289,'STR_MAINTENANCE_INVENTORY'),(11290,'STR_UNIT_AVAILABILITY'),(11291,'STR_COURT_FILING_DOCUMENTS'),(11292,'STR_CARD_EXPIRATION'),(11293,'STR_CARD_FIRST_NAME'),(11294,'STR_CARD_LAST_NAME'),(11295,'STR_MAKE_PAYMENT_INSTRUCTIONS'),(11296,'STR_NO_CURRENT_INVOICES'),(11297,'STR_NO_PAYMENT_AMOUNT_SET'),(11298,'STR_OPEN_INVOICES'),(11299,'STR_PAYMENT_ADDED_SUCCESSFULLY'),(11300,'STR_YOU_MUST_ENTER_AN_EXPIRATION_MONTH'),(11301,'STR_YOU_MUST_ENTER_AN_EXPIRATION_YEAR'),(11302,'STR_YOU_MUST_ENTER_A_BILLING_ADDRESS'),(11303,'STR_YOU_MUST_ENTER_A_BILLING_CITY'),(11304,'STR_YOU_MUST_ENTER_A_BILLING_STATE'),(11305,'STR_YOU_MUST_ENTER_A_BILLING_ZIP'),(11306,'STR_YOU_MUST_ENTER_A_CARD_CODE'),(11307,'STR_YOU_MUST_ENTER_A_CREDIT_CARD_NUMBER'),(11308,'STR_YOU_MUST_ENTER_A_FIRST_NAME'),(11309,'STR_YOU_MUST_ENTER_A_LAST_NAME'),(11310,'STR_YOU_MUST_ENTER_A_PAYMENT_AMOUNT'),(11311,'STR_ADD_COURT_FILING'),(11312,'STR_AMOUNT_FILED_FOR'),(11313,'STR_COURT_FILINGS_INSTRUCTIONS'),(11314,'STR_COURT_FILING_ADDED_SUCCESSFULLY'),(11315,'STR_COURT_FILING_DELETED_SUCCESSFULLY'),(11316,'STR_COURT_FILING_INFORMATION'),(11317,'STR_COURT_FILING_INFORMATION_HELP'),(11318,'STR_COURT_FILING_INFORMATION_HELP_REQUIRED_FIELDS'),(11319,'STR_COURT_FILING_UPDATED_SUCCESSFULLY'),(11320,'STR_JUDGMENT_DATE'),(11321,'STR_NO_COURT_FILINGS_FOUND'),(11322,'STR_OUTCOME_OF_FILING'),(11323,'STR_PLEASE_INCLUDE_A_DATE_FILED'),(11324,'STR_PLEASE_INCLUDE_A_FILING_TITLE'),(11325,'STR_PLEASE_INCLUDE_A_REASON_FOR_FILING'),(11326,'STR_THE_INVOICE_NUMBER_COULD_NOT_BE_FOUND'),(11327,'STR_PLEASE_INCLUDE_AN_ADDRESS'),(11328,'STR_PLEASE_INCLUDE_A_CITY'),(11329,'STR_PLEASE_INCLUDE_A_STATE'),(11330,'STR_PLEASE_INCLUDE_A_ZIP'),(11331,'STR_AUTO_BILL'),(11332,'STR_NEW_UNIT'),(11333,'STR_LEASE_TRANSFERRED_SUCCESSFULLY'),(11334,'STR_TERMINATION_DATE'),(11335,'STR_TRANSFER_DATE_MUST_BE_BEFORE_OR_ON_LEASE_END_DATE'),(11336,'STR_TRANSFER_DATE_MUST_BE_ON_OR_AFTER_LEASE_BEGIN_DATE'),(11337,'STR_YOU_MUST_SELECT_A_TRANSFER_DATE'),(11338,'STR_YOU_MUST_SELECT_A_UNIT'),(11339,'STR_ATTACH_INVOICE'),(11340,'STR_PENDING_APPROVAL'),(11341,'STR_REQUEST_CHANGE'),(11342,'STR_SPECIFIC_LOCATION_WITHIN_WAREHOUSE'),(11343,'STR_CHECK_IN_MIDDLE_ONE_STUB_ABOVE_AND_ONE_STUB_BELOW'),(11344,'STR_CHECK_ON_TOP_TWO_STUBS_FOLLOW'),(11345,'STR_STUB_ARRANGEMENT'),(11346,'STR_DB_ERROR_ADDING_INDEX'),(11347,'STR_DB_ERROR_GETTING_INDEXES'),(11348,'STR_DATES_ARE_FOR'),(11349,'STR_DATE_FIRST_INVOICE'),(11350,'STR_ENTERED_INTO_SYSTEM'),(11351,'STR_FIRST_INVOICE_BETWEEN'),(11352,'STR_OR_FIRST_INVOICE_BETWEEN'),(11353,'STR_SHOW_ONLY_LEASE_INVOICES'),(11354,'STR_ARCHITECT'),(11355,'STR_CLIENT_PROJECT_NUMBER'),(11356,'STR_CONTRACT_DATE'),(11357,'STR_BUDGET_AMOUNT_DOES_NOT_MATCH_COMMITMENT_AMOUNT'),(11358,'STR_COMMITMENT'),(11359,'STR_NO_DATA_HAS_BEEN_SAVED'),(11360,'STR_SHOW_ONLY_CHANGE_ORDERS'),(11361,'STR_LEASING_RECAP'),(11362,'STR_MOVING_AVG'),(11363,'STR_AR_RENT'),(11364,'STR_KNOWLEDGE_BASE'),(11365,'STR_TENANT_LOGIN'),(11366,'STR_WELCOME_MESSAGE_FOR_PROSPECTS'),(11367,'STR_MARKUP_PAPER_INVENTORY_PRICE'),(11368,'STR_CHECKING_THIS_OPTION_ENABLES_TIME_CHECKING'),(11369,'STR_USE_ENTRY_DATE_NOT_INVOICE_DATE'),(11370,'STR_BODY'),(11371,'STR_EMAIL_ACTION'),(11372,'STR_EMAIL_TEMPLATES'),(11373,'STR_EMAIL_TEMPLATE_ADDED_FAILURE'),(11374,'STR_EMAIL_TEMPLATE_ADDED_SUCCESSFULLY'),(11375,'STR_EMAIL_TEMPLATE_DELETED_FAILURE'),(11376,'STR_EMAIL_TEMPLATE_DELETED_SUCCESSFULLY'),(11377,'STR_FROM_EMAIL'),(11378,'STR_PLEASE_INCLUDE_FROM_EMAIL'),(11379,'STR_PLEASE_INCLUDE_FROM_NAME'),(11380,'STR_PLEASE_INCLUDE_SUBJECT'),(11381,'STR_PLEASE_INCLUDE_TEMPLATE_NAME'),(11382,'STR_TEMPLATE_NAME'),(11383,'STR_AIR_CONDITIONING'),(11384,'STR_BATHS'),(11385,'STR_BEDS'),(11386,'STR_CARPET'),(11387,'STR_DEN'),(11388,'STR_DISHWASHER'),(11389,'STR_DISPOSAL'),(11390,'STR_DRAPES'),(11391,'STR_DRYER'),(11392,'STR_FIREPLACE'),(11393,'STR_FURNISHED'),(11394,'STR_REFRIGERATOR'),(11395,'STR_STOVE'),(11396,'STR_WASHER'),(11397,'STR_WASHER_DRYER_HOOKUP'),(11398,'STR_PROSPECT_APPROVED'),(11399,'STR_PROSPECT_DENIED'),(11400,'STR_TENANT_APPLICATION_SUBMITTED'),(11401,'STR_TENANT_LEASE_COMPLETE'),(11402,'STR_TENANT_SIGNED_UP'),(11403,'STR_PROPERTY_MANAGEMENT_PORTAL_ADMIN'),(11404,'STR_CREDIT_CARD_UPDATED_SUCCESSFULLY'),(11405,'STR_YOU_DO_NOT_HAVE_ACCESS_TO_THIS_CREDIT_CARD'),(11406,'STR_PRINT_RECEIPT'),(11407,'STR_NO_TAX_ON_FREIGHT_THIS_LOCATION'),(11408,'STR_TAX_FREIGHT'),(11409,'STR_TAX_FREIGHT_THIS_LOCATION'),(11410,'STR_USE_RECEIVABLES_SETTING'),(11411,'STR_WORK_ORDER_NOT_FOUND'),(11412,'STR_DEPOSIT_ADJUSTMENT'),(11413,'STR_LEASE_HAS_BEEN_CANCELED'),(11414,'STR_RESERVATION_FEE_TRANSFER'),(11415,'STR_CHECK_FOR_PAYMENT'),(11416,'STR_CURRENT_RENT'),(11417,'STR_ORIGINAL_RENT'),(11418,'STR_RENT_AMOUNT_IS_TOO_LOW'),(11419,'STR_REQUIRES_ADMIN_USER'),(11420,'STR_PROCESS_PAYMENT'),(11421,'STR_EMPLOYEE_SPECIFIC_GL_ACCOUNTS_FOR_COMPANY_TAX_EXPENSES'),(11422,'STR_FEDERAL_UNEMPLOYMENT_EXPENSE'),(11423,'STR_IF_NONE_ENTERED_SYSTEM_WILL_USE_DEFAULTS'),(11424,'STR_MEDICARE_COMPANY_EXPENSE'),(11425,'STR_STATE_UNEMPLOYMENT_EXPENSE'),(11426,'STR_LOCATIONS_ALLOWED'),(11427,'STR_CASH_COUNT'),(11428,'STR_CARD_MEMBER_AGREEMENT_TEXT'),(11429,'STR_CASHIER'),(11430,'STR_NO_ID_SET'),(11431,'STR_PAYMENT_NOT_FOUND'),(11432,'STR_PAYMENT_RECEIPT'),(11433,'STR_RECEIPT'),(11434,'STR_AMOUNT_ENTERED_DOES_NOT_MATCH_PAYMENT_AMOUNT'),(11435,'STR_COULD_NOT_FIND_PAYMENT'),(11436,'STR_TOTAL_RECEIVED'),(11437,'STR_COLLECTION_REPORT'),(11438,'STR_OFFICIAL_RECEIPT_FROM'),(11439,'STR_OFFICIAL_RECEIPT_TO'),(11440,'STR_PRINT_REPORT'),(11441,'STR_REPORT_DATE'),(11442,'STR_TIMECLOCK'),(11443,'STR_PLACING_ORDER_ON_HOLD'),(11444,'STR_ADJUST'),(11445,'STR_SPECIFIC_PO_ONLY'),(11446,'STR_IS_THIS_DEFAULT_SHIPTO_ADDRESS'),(11447,'STR_GL_RECEIVABLES_THIS_LOCATION'),(11448,'STR_LEAVE_BLANK_IF_USING_STANDARD_RECEIVABLES'),(11449,'STR_NOT_USED_WITH_PRINT_JOBS'),(11450,'STR_CURRENT_PRINT_ORDERS'),(11451,'STR_CANNOT_FIND_RECORDS_PROBABLY_INCOMPLETE_TABLES'),(11452,'STR_ERROR_DURING_READ'),(11453,'STR_ORIGINALS_FOR_PRINT_ORDER'),(11454,'STR_ADD_ANOTHER_SHIPTO_DESTINATION'),(11455,'STR_ADD_NEW_SHIPTO'),(11456,'STR_ADD_NEW_SHIP_TO_ADDRESS'),(11457,'STR_CONTINUE_TO_NEXT_PAGE'),(11458,'STR_DELIVERY_HOW'),(11459,'STR_DELIVERY_TO_NAME'),(11460,'STR_DUE_DATE_HAS_ALREADY_PASSED'),(11461,'STR_FOR_QUESTIONS_PLEASE_CALL'),(11462,'STR_MISSING_ORDER_QUANTITY'),(11463,'STR_MISSING_STATUS'),(11464,'STR_MUST_ENTER_A_PRIOR_PRINT_ORDER'),(11465,'STR_PRIOR_ORDER_NUMBER'),(11466,'STR_PRIOR_PRINT_ORDER_DOES_NOT_EXIST'),(11467,'STR_SUBMITTED_BY'),(11468,'STR_TITLE_OF_ORDER'),(11469,'STR_DETAILS_FOR_PRINT_ORDER'),(11470,'STR_USER_ACTIVITY_MONITOR'),(11471,'STR_GENERAL_SETUP'),(11472,'STR_MAKE_CREDIT_CARD_PAYMENT'),(11473,'STR_PREPAY_BY_CREDIT_CARD'),(11474,'STR_LATE_FEES_INCOME'),(11475,'STR_ADD_THESE_FIELDS_TO_YOUR_MESSAGE_TO_HAVE_THEM_FILLED_IN_DYNAMICALLY'),(11476,'STR_AVAILABLE_FIELDS'),(11477,'STR_DELETE_TEMPLATE'),(11478,'STR_NO_PROPERTIES_FOUND'),(11479,'STR_PROPERTY'),(11480,'STR_ADD_PROPERTY'),(11481,'STR_PLEASE_INCLUDE_PROPERTY'),(11482,'STR_PROPERTIES_FOR'),(11483,'STR_THIS_AGENT_ALREADY_HAS_AN_ASSOCIATION_WITH_THIS_PROPERTY'),(11484,'STR_APPLICATION_FEE'),(11485,'STR_AREA_ATTACHED_TO_PROPERTY'),(11486,'STR_ASSURESIGN_CONTEXT_IDENTIFIER'),(11487,'STR_ASSURESIGN_SETUP'),(11488,'STR_ASSURESIGN_USER_ID'),(11489,'STR_CONFIGURATION_UPDATED_SUCCESSFULLY'),(11490,'STR_FINAL_LATE_NOTICE'),(11491,'STR_FIRST_LATE_NOTICE'),(11492,'STR_GUARANTOR_NOTIFIED'),(11493,'STR_LATE_FEE_ADDED'),(11494,'STR_LATE_NOTICES_SENT_SUCCESSFULLY'),(11495,'STR_LEASE_AUTO_BILLING_DETAILS'),(11496,'STR_SECOND_LATE_NOTICE'),(11497,'STR_DELETE_PROPERTY'),(11498,'STR_DOCUMENT_DAYS_TO_EXPIRATION'),(11499,'STR_FINAL_LATE_NOTICE_DAYS'),(11500,'STR_FIRST_LATE_NOTICE_DAYS'),(11501,'STR_LEASE_DOCUMENT_NAME'),(11502,'STR_LEASE_TEMPLATE_ID'),(11503,'STR_PLEASE_INCLUDE_PROPERTY_TYPE'),(11504,'STR_PROPERTIES_ADD'),(11505,'STR_PROPERTIES_DELETE'),(11506,'STR_PROPERTIES_UPDATE'),(11507,'STR_PROPERTY_ADDED_FAILURE'),(11508,'STR_PROPERTY_ADDED_SUCCESSFULLY'),(11509,'STR_PROPERTY_DELETED_FAILURE'),(11510,'STR_PROPERTY_DELETED_SUCCESSFULLY'),(11511,'STR_PROPERTY_TYPE'),(11512,'STR_PROPERTY_UPDATED_FAILURE'),(11513,'STR_PROPERTY_UPDATED_SUCCESSFULLY'),(11514,'STR_SECOND_LATE_NOTICE_DAYS'),(11515,'STR_PROPERTY_OWNERSHIP'),(11516,'STR_PROPERTY_OWNERSHIPS_ADD'),(11517,'STR_PROPERTY_OWNERSHIPS_DELETE'),(11518,'STR_PROPERTY_OWNERSHIPS_UPDATE'),(11519,'STR_PROPERTY_OWNERSHIP_ADDED_FAILURE'),(11520,'STR_PROPERTY_OWNERSHIP_ADDED_SUCCESSFULLY'),(11521,'STR_PROPERTY_OWNERSHIP_DELETED_FAILURE'),(11522,'STR_PROPERTY_OWNERSHIP_DELETED_SUCCESSFULLY'),(11523,'STR_PROPERTY_OWNERSHIP_UPDATED_FAILURE'),(11524,'STR_PROPERTY_OWNERSHIP_UPDATED_SUCCESSFULLY'),(11525,'STR_PROPERTY_TYPES_ADD'),(11526,'STR_PROPERTY_TYPES_DELETE'),(11527,'STR_PROPERTY_TYPES_UPDATE'),(11528,'STR_PROPERTY_TYPE_ADDED_SUCCESSFULLY'),(11529,'STR_PROPERTY_TYPE_ATTACHED_TO_PROPERTY'),(11530,'STR_PROPERTY_TYPE_DELETED_FAILURE'),(11531,'STR_PROPERTY_TYPE_DELETED_SUCCESSFULLY'),(11532,'STR_PROPERTY_TYPE_UPDATED_FAILURE'),(11533,'STR_PROPERTY_TYPE_UPDATED_SUCCESSFULLY'),(11534,'STR_12_MONTH_MOVING_AVG'),(11535,'STR_SELECT_ALL'),(11536,'STR_PROPERTY_PROPERTY_TAX_ADD_TO_PAYABLES'),(11537,'STR_PROPERTY_TAX_ADDED_FAILURE'),(11538,'STR_PROPERTY_TAX_ADDED_SUCCESSFULLY'),(11539,'STR_PROPERTY_TAXES_FOR'),(11540,'STR_PROPERTY_TAX_ADD'),(11541,'STR_PROPERTY_TAX_DELETE'),(11542,'STR_PROPERTY_TAX_DELETED_FAILURE'),(11543,'STR_PROPERTY_TAX_DELETED_SUCCESSFULLY'),(11544,'STR_PROPERTY_TAX_UPDATE'),(11545,'STR_PROPERTY_TAX_UPDATED_FAILURE'),(11546,'STR_PROPERTY_TAX_UPDATED_SUCCESSFULLY'),(11547,'STR_PROPERTY_TAXES_FOR_PROPERTY'),(11548,'STR_PROPERTY_TAX_ADD_TO_PAYABLES'),(11549,'STR_PROPERTY_TAX_REPORT'),(11550,'STR_SEND_EMAILS'),(11551,'STR_SEND_EMAIL_TO_SELECTED_USERS'),(11552,'STR_PROPERTY_SALES_ADD'),(11553,'STR_PROPERTY_SALES_UPDATE'),(11554,'STR_PM_DASHBOARD'),(11555,'STR_PROPERTY_ADD_UPDATE'),(11556,'STR_PROPERTY_TYPE_ADD_UPDATE'),(11557,'STR_REAL_ESTATE_PROPERTY_TAX'),(11558,'STR_GENERAL_TENANT_INFO_DOCUMENTS'),(11559,'STR_PROPERTY_DOCUMENTS'),(11560,'STR_CLIENT_EMAIL'),(11561,'STR_CLIENT_PHONE'),(11562,'STR_INVOICE_DUE_DATE'),(11563,'STR_INVOICE_DUE_MONTH'),(11564,'STR_INVOICE_DUE_YEAR'),(11565,'STR_INVOICE_NOTIFICATION'),(11566,'STR_TENANT_FIRST_NAME'),(11567,'STR_TENANT_LAST_NAME'),(11568,'STR_TENANT_MAINTENANCE_REQUEST_SUBMITTED'),(11569,'STR__INVOICE'),(11570,'STR_AUTOMATICALLY_CHARGE_INVOICE_ON_DUE_DATE'),(11571,'STR_PAYMENT_PREFERENCES_SAVED_SUCCESSFULLY'),(11572,'STR_RECURRING_PAYMENTS'),(11573,'STR_SAVE_PAYMENT_PREFERENCES'),(11574,'STR_YOU_MUST_SELECT_A_PROPERTY'),(11575,'STR_LEASE_APPLICATION_FEE'),(11576,'STR_NEW_APPLICANT'),(11577,'STR_SELECT_CARD'),(11578,'STR_STORED_CREDIT_CARD'),(11579,'STR_COMPLETE_APPLICATION'),(11580,'STR_SEARCH_AVAILABLE_UNITS'),(11581,'STR_COMMUNICATIONS_AND_NOTES'),(11582,'STR_COMMUNICATIONS_AND_NOTES_INSTRUCTIONS'),(11583,'STR_SEARCH_COMMUNICATIONS'),(11584,'STR_SEARCH_COMMUNICATIONS_AND_NOTES'),(11585,'STR_LEASE_SIGNED'),(11586,'STR_SIGNED_LEASE'),(11587,'STR_SIGN_LEASE_ADD_INVOICES'),(11588,'STR_UNSIGNED_LEASE'),(11589,'STR_THE_INITIAL_LEASE_HAS_BEEN_PAID'),(11590,'STR_DRAFT_LEASE'),(11591,'STR_DRAFT_LEASE_INSTRUCTIONS'),(11592,'STR_PLEASE_SELECT_A_PROPERTY'),(11593,'STR_POPULATE_LEASE'),(11594,'STR_SELECT_PROSPECT'),(11595,'STR_SUBMIT_SCREENING'),(11596,'STR_DRAFT_A_LEASE'),(11597,'STR_NEXT_TENANT'),(11598,'STR_SET_APPOINTMENT'),(11599,'STR_LEASE_SIGNING_DELETED_SUCCESSFULLY'),(11600,'STR_LEASE_SIGNING_WIZARD'),(11601,'STR_LEASE_SIGNING_WIZARD_INSTRUCTIONS'),(11602,'STR_LEASE_MODIFICATION'),(11603,'STR_LEASE_MODIFICATION_DELETED_SUCCESSFULLY'),(11604,'STR_LEASE_MODIFICATION_INSTRUCTIONS'),(11605,'STR_NEW_LEASE_MODIFICATION'),(11606,'STR_SELECT_MODIFICATION'),(11607,'STR_CURRENT_PROSPECT'),(11608,'STR_SELECT_PROSPECT_DESCRIPTION'),(11609,'STR_COMPLETED_SURVEYS'),(11610,'STR_PENDING_SURVEY_REQUESTS'),(11611,'STR_TENANT_SURVEYS'),(11612,'STR_TENANT_SURVEY_INSTRUCTIONS'),(11613,'STR_LEASE_SUMMARY'),(11614,'STR_LEASE_SUMMARY_INSTRUCTIONS'),(11615,'STR_PRORATED_RANGE'),(11616,'STR_COMMUNICATIONS_INSTRUCTIONS'),(11617,'STR_ACTIVE_PROSPECTS'),(11618,'STR_AR'),(11619,'STR_NO_MOVE_INS_FOUND'),(11620,'STR_OPEN_MAINTENANCE_REQUESTS'),(11621,'STR_RECENT_COMMUNICATIONS'),(11622,'STR_UPCOMING_APPOINTMENTS_AND_SHOWINGS'),(11623,'STR_UPCOMING_EXPIRATIONS'),(11624,'STR_UPCOMING_MOVE_INS'),(11625,'STR_VIEW_ACTIVE_PROSPECTS'),(11626,'STR_VIEW_APPOINTMENTS'),(11627,'STR_VIEW_AVAILABILITY'),(11628,'STR_VIEW_COMMUNICATIONS'),(11629,'STR_VIEW_EXPIRATIONS'),(11630,'STR_VIEW_MAINTENANCE_REQUESTS'),(11631,'STR_VIEW_MOVE_INS'),(11632,'STR_VIEW__AVAILABILITY'),(11633,'STR_GENERAL_INFO_AND_PROCEDURES_DOCUMENTS'),(11634,'STR_LEASES_AND_DOCUMENTATION'),(11635,'STR_RECENT_MAINTENANCE_REQUESTS'),(11636,'STR_ACTIVE_TENANT'),(11637,'STR_LEASE_INFO'),(11638,'STR_LEASE_SIGNING'),(11639,'STR_MANAGE_CREDIT_CARDS'),(11640,'STR_TENANT_SUMMARY'),(11641,'STR_SIGN_LEASE'),(11642,'STR_DEFAULT_TO_HOME_PAGE'),(11643,'STR_RIGHTS_GROUP_DELETED_SUCCESSFULLY'),(11644,'STR_FORECAST_DATE'),(11645,'STR_REPORT_FOR_THIS_COMPANY'),(11646,'STR_ERROR_PROCESSING_REQUEST'),(11647,'STR_ERROR_SUBMITTING_DOCUMENT_REQUEST'),(11648,'STR_NO_DOCUMENT_SET'),(11649,'STR_NO_SIGNATORIES_RETURNED'),(11650,'STR_DOCUMENT_SIGNING'),(11651,'STR_DOCUMENT_SIGNING_INSTRUCTIONS'),(11652,'STR_DOCUMENT_NOT_FOUND'),(11653,'STR_DOCUMENT_SIGNING_UPDATE'),(11654,'STR_DOCUMENT_SIGNING_UPDATED_SUCCESSFULLY'),(11655,'STR_ADD_LEASE_SIGNING_REQUEST'),(11656,'STR_DELETE_LEASE_SIGNING_REQUEST'),(11657,'STR_DOCUMENT_SIGNING_REQUEST_DELETED_SUCCESSFULLY'),(11658,'STR_DOCUMENT_SIGNING_REQUEST_SUBMITTED_SUCCESSFULLY'),(11659,'STR_ERROR_DELETING_DOCUMENT_SIGNING_REQUEST'),(11660,'STR_ERROR_SUBMITTING_DOCUMENT_SIGNING_REQUEST'),(11661,'STR_ERROR_UPDATING_DOCUMENT_SIGNING_STATUS'),(11662,'STR_EXPIRATION_DATE'),(11663,'STR_LAST_UPDATE'),(11664,'STR_LEASE_SIGNING_REQUESTS'),(11665,'STR_SIGNER_1'),(11666,'STR_SIGNER_2'),(11667,'STR_SIGNING_LINK'),(11668,'STR_UPDATE_STATUS'),(11669,'STR_CO_TENANT_EMAIL'),(11670,'STR_PENDING_DOCUMENT_SIGNING_REQUESTS'),(11671,'STR_SIGN'),(11672,'STR_TENANT_1_SIGN'),(11673,'STR_TENANT_2_SIGN'),(11674,'STR_LAWN_CARE'),(11675,'STR_ACH_DEPOSIT'),(11676,'STR_CHECK_OR_DEPOSIT_ID'),(11677,'STR_CHECK_REGISTER'),(11678,'STR_GL'),(11679,'STR_SUBTRACT'),(11680,'STR_VOID_AMOUNT'),(11681,'STR_CATEGORY_AND_COST_CODE'),(11682,'STR_COMMITTED_COST_VARIANCE'),(11683,'STR_BILLED_AMOUNT'),(11684,'STR_INVENTORY_PO_STATUS'),(11685,'STR_SHOW_COMPLETE'),(11686,'STR_LEASE_TEMPLATE_ID_2_SIGNERS'),(11687,'STR_LEASE_TEMPLATE_ID_3_SIGNERS'),(11688,'STR_DOUBLE_SIGNATURE_LINE'),(11689,'STR_HOW_MANY_LINES_FOR_SIGNATURES_ON_CHECK'),(11690,'STR_SINGLE_SIGNATURE_LINE'),(11691,'STR_PO_STATUS'),(11692,'STR_PRINT_STATUS_OF_PURCHASE_ORDERS'),(11693,'STR_FALL_RENT'),(11694,'STR_LAWN_CARE_ACCOUNT'),(11695,'STR_PET_RENT_ACCOUNT'),(11696,'STR_SPRING_RENT'),(11697,'STR_AMENDMENT'),(11698,'STR_AMENDMENT_DATE'),(11699,'STR_AMEND_LEASE'),(11700,'STR_LEASE_AMENDED_SUCCESSFULLY'),(11701,'STR_RENEWAL'),(11702,'STR_THIS_WILL_CANCEL_OPEN_UNPAID_INVOICES_AND_CREATE_A_NEW_LEASE'),(11703,'STR_THIS_WILL_NOT_CANCEL_ANY_OPEN_INVOICES'),(11704,'STR_TRANSFER'),(11705,'STR_PREPRINT_OPTION_THREE'),(11706,'STR_SHOW_ONLY_JOB_RELATED_ENTRIES'),(11707,'STR_VIEW_BY_INVENTORY_LOCATION'),(11708,'STR_SHOW_REMAINING_TAX'),(11709,'STR_TAX_BALANCE'),(11710,'STR_ADD_NEW_LABEL'),(11711,'STR_BARCODE_POSITION_ON_LABEL_IN_POINTS'),(11712,'STR_CUSTOM_FIELD'),(11713,'STR_DESCRIPTION_POSITION_ON_LABEL_IN_POINTS'),(11714,'STR_FIXED_TEXT_POSITION_ON_LABEL_IN_POINTS'),(11715,'STR_FIXED_TEXT_TO_PRINT_ALL_LABELS'),(11716,'STR_FONT_SIZE_IN_POINTS'),(11717,'STR_FROM_LEFT'),(11718,'STR_FROM_TOP'),(11719,'STR_INCLUDE_ON_BARCODE'),(11720,'STR_INVENTORY_BARCODE'),(11721,'STR_LABEL_NAME'),(11722,'STR_LABEL_SIZE_IN_POINTS'),(11723,'STR_SELECT_A_LABEL'),(11724,'STR_SHOW_DESCRIPTION_OF_ITEM'),(11725,'STR_SHOW_FIELD_NAME'),(11726,'STR_SHOW_LEVEL_NAME'),(11727,'STR_BARCODE_LABELS'),(11728,'STR_CLICK_TO_VIEW_LABELS'),(11729,'STR_AND_NUMBER_ENTERED_GREATER_THAN'),(11730,'STR_IF_VALID_REPLY_IS_NUMBER'),(11731,'STR_MULTIPLY_QUANTITY_CALCULATION_BY'),(11732,'STR_PRINT_BARCODE_LABELS'),(11733,'STR_PRINT_LABEL'),(11734,'STR_PRINT_LABELS'),(11735,'STR_MUST_PICK_SPECIFIC_EMPLOYEE'),(11736,'STR_ONLY_SHOW_IF_HOURLY_AVERAGE_EXCEEDS'),(11737,'STR_AVG_FOR'),(11738,'STR_HIDE_SHIP_TO_ON_INVOICE'),(11739,'STR_SHOW_PRIOR_BALANCE_ON_INVOICE'),(11740,'STR_CHECK_NUMBER_IF_CHECK'),(11741,'STR_NUMBER_ALREADY_IN_USE'),(11742,'STR_PAYMENTS_ENTERED_BY'),(11743,'STR_PAST_DUE_FROM_INVOICE'),(11744,'STR_AMT'),(11745,'STR_NET_COMMITTED_PO_SB'),(11746,'STR_ORIGINAL_PO_SB'),(11747,'STR_WITH_PENDING'),(11748,'STR_COST_AS_OF'),(11749,'STR_COST_CODE_AND_CATEGORY'),(11750,'STR_GRAND_TOTAL_ALL_JOBS'),(11751,'STR_SELECT_JOB'),(11752,'STR_CHANGES'),(11753,'STR_ORIGINAL_PO'),(11754,'STR_YET_TO_INVOICE'),(11755,'STR_APPROVED_CHANGES'),(11756,'STR_NEW_TOTAL'),(11757,'STR_ORIGINAL_TOTAL'),(11758,'STR_DONT_UPDATE_TENANT_ADDRESS_WITH_NEW_LEASE'),(11759,'STR_OTHER_RENT'),(11760,'STR_PET_DEPOSIT_GL_ACCOUNT'),(11761,'STR_SEND'),(11762,'STR_PET_DEPOSIT_ACCOUNT'),(11763,'STR_LEASE_HAS_BEEN_AMENDED'),(11764,'STR_LEASE_HAS_BEEN_RENEWED'),(11765,'STR_LEASE_HAS_BEEN_TERMINATED'),(11766,'STR_LEASE_HAS_BEEN_TRANSFERRED'),(11767,'STR_CURRENT_ADDRESS'),(11768,'STR_PERMANENT_ADDRESS'),(11769,'STR_SAME_AS_PERMANENT'),(11770,'STR_GRAND_TOTAL_ALL_TAX_DISTRICTS_TAXABLE_EXEMPT'),(11771,'STR_ONLY_INVOICES_WITH_TAX'),(11772,'STR_MUST_HAVE_FROM_AND_TO_ADDRESSES'),(11773,'STR_BLOCK_CHILD_ITEMS_FROM_ITEM_LOOKUP'),(11774,'STR_AMOUNT_TO_REFUND'),(11775,'STR_AMOUNT_TO_REFUND_EXCEEDS_CREDIT_AMOUNT'),(11776,'STR_SELECT_A_LOCATION'),(11777,'STR_SHOW_DOLLARS_ON_PENDING_ORDER_LIST'),(11778,'STR_PAYMENTS_NOT_YET_ON_BANK_DEPOSIT'),(11779,'STR_EMPLOYER'),(11780,'STR_NT_PAY'),(11781,'STR_PERIOD_BEGINNING'),(11782,'STR_PERIOD_ENDING'),(11783,'STR_SS_NUMBER'),(11784,'STR_ONLY_FOR_CHECK_ON_TOP_CHECKS'),(11785,'STR_USE_SPECIAL_FORMAT_FOR_PAYROLL_CHECKS'),(11786,'STR_EXPORT_VENDORS'),(11787,'STR_CREDIT_CARD_PAYMENT_INSTRUCTIONS'),(11788,'STR_HALF_HEIGHT_LIMIT_SEVEN_ITEMS_NO_LINES_IGNORES_OTHER_FORMAT_OPTIONS'),(11789,'STR_REQUIRE_CC_BILLING_ADDRESS'),(11790,'STR_REQUIRE_CC_CARD_CODE'),(11791,'STR_CC_CARD_CODE'),(11792,'STR_YOU_MUST_ENTER'),(11793,'STR_THE_NOTE_DOES_NOT_EXIST'),(11794,'STR_SHOW_ITEM_CODE'),(11795,'STR_ITEM_CODE_POSITION_ON_LABEL_IN_POINTS'),(11796,'STR_BARCODE_TYPE'),(11797,'STR_ARCHIVED_INVOICES_LOG'),(11798,'STR_ARCHIVE_INVOICES'),(11799,'STR_ARCHIVE_PAID_INVOICES_IN_THE_DATE_RANGE_BELOW'),(11800,'STR_ARE_YOU_SURE_YOU_WANT_TO_ARCHIVE_INVOICES_IN_THE_FOLLOWING_RANGE'),(11801,'STR_BATCH_ID'),(11802,'STR_INVOICES_ARCHIVED'),(11803,'STR_INVOICES_ARCHIVED_SUCCESSFULLY'),(11804,'STR_SUMMARIZE_GL_ENTRIES_BY'),(11805,'STR_SEND_SURVEY_WHEN_FULFILLMENT_ORDER_CREATED'),(11806,'STR_SEND_SURVEY_WHEN_POS_INVOICE_CREATED'),(11807,'STR_BIN_SHELF_POSITION_ON_LABEL_IN_POINTS'),(11808,'STR_ONLY_PRINT_ONE_LABEL_PER_ITEM'),(11809,'STR_SHOW_BIN_SHELF'),(11810,'STR_INSERT_CODE'),(11811,'STR_SURVEY_SENT_SUCCESSFULLY'),(11812,'STR_DOCTOR_REQUEST_REPORT'),(11813,'STR_NOTIFICATION_SENT'),(11814,'STR_REQUESTS_FROM'),(11815,'STR_DO_NOT_HAVE_PERMISSION_TO_SAVE'),(11816,'STR_ALL_COST_CENTERS'),(11817,'STR_WHICH_COST_CENTER'),(11818,'STR_PAYROLL_COST_CENTER_ADD'),(11819,'STR_PAYROLL_COST_CENTER_UPDATE'),(11820,'STR_COST_CENTERS'),(11821,'STR_ENTER_HOURS_IN_TABULAR_FORM'),(11822,'STR_LOG_HOURS_SIMPLE'),(11823,'STR_PAYROLL_COST_CENTER'),(11824,'STR_BLOCK_ORDER_SAVE_ORDER_AND_CONVERT_FROM_QUOTE'),(11825,'STR_PERIOD_START_DAY'),(11826,'STR_PERIOD_START_DAY_SECOND_PAY_PERIOD'),(11827,'STR_ACCRUED_VACATION'),(11828,'STR_SICK_LEAVE'),(11829,'STR_CITY_WITHHOLDING'),(11830,'STR_EMPLOYEE_INFO'),(11831,'STR_EMPLOYEE_PAYROLL_SUMMARY_REPORT'),(11832,'STR_FEDERAL_TAXABLE_WAGES'),(11833,'STR_FEDERAL_WITHHOLDING'),(11834,'STR_LOCAL_WITHHOLDING'),(11835,'STR_MEDICARE_WITHHOLDING'),(11836,'STR_OTHER_DEDUCTIONS_ADDITIIONS'),(11837,'STR_PRETAX_DEDUCTION'),(11838,'STR_SOC_SEC_WITHHOLDING'),(11839,'STR_STATE_WITHHOLDING'),(11840,'STR_EMPLOYEE_PAY_SUMMARY'),(11841,'STR_B2B_WEB_PORTAL'),(11842,'STR_BANK_DEPOSITS'),(11843,'STR_CONTACTS'),(11844,'STR_CONTACTS_MENU_DESC'),(11845,'STR_CREDITCARD_BILLS'),(11846,'STR_CUSTOMER_ACCOUNTS'),(11847,'STR_EDIT_SALES_PERSONNEL'),(11848,'STR_EDIT_TAX_TYPE'),(11849,'STR_EDIT_VENDOR_BILL'),(11850,'STR_IMPORTS_EXPORTS'),(11851,'STR_IMPORT_QUICKBOOKS_FILES'),(11852,'STR_ITEM_ORDERS'),(11853,'STR_ITEM_SHIPMENTS'),(11854,'STR_NEW_EDIT_BUDGET'),(11855,'STR_NEW_EDIT_ORDER'),(11856,'STR_NEW_SALES_PERSONNEL'),(11857,'STR_NEW_TAX_TYPE'),(11858,'STR_PRICELIST_PRINTING'),(11859,'STR_SITE_BRANDING'),(11860,'STR_VTIGER_CRM'),(11861,'STR_CARRIER_SERVICE_ID'),(11862,'STR_FOR_LINKS'),(11863,'STR_CONFIRM_DATE'),(11864,'STR_REASON_DETAILS'),(11865,'STR_AR_INVOICE_PAYMENT_RETURNED'),(11866,'STR_COMPOSITIION'),(11867,'STR_COSTS_ARE_IN_BASE_CURRENCY_NOT_INVOICE_CURRENCY'),(11868,'STR_FILES'),(11869,'STR_GENERAL_NOTES'),(11870,'STR_GET_SUPPORT'),(11871,'STR_IF_A_QUOTE_DOES_NOT_APPEAR_IN_THIS_BOX_THEN_EITHER_THE_ENTRY_FORM_IS_INCOMPLETE_OR_A_QUOTE_CANNOT_BE_GENERATED_FOR_THE_SELECTED_OPTIONS'),(11872,'STR_IF_YOU_NOTICE_ANYTHING_IN_THE_BELOW_SPECS_THAT_ARE_INCORRECT_PLEASE_CALL'),(11873,'STR_IMMEDIATELY_AND_REFER_TO_THE_ABOVE_JOB_NUMBER'),(11874,'STR_KNOWLEDGEBASE'),(11875,'STR_LOG_OUT'),(11876,'STR_MAKE_CHANGES_NEW_QUOTE_NUMBER'),(11877,'STR_MAKE_CHANGES_SAME_QUOTE_NUMBER'),(11878,'STR_MUST_MATCH_SHORT_DESCRIPTION_OR_SYMBOL_IN_SETUP'),(11879,'STR_NEED_HELP'),(11880,'STR_NEW_QUOTE_SAME_CUSTOMER'),(11881,'STR_NO_CHECKING_ACCOUNT_SELECTED'),(11882,'STR_PAID_DATE'),(11883,'STR_PMS_NUMBER'),(11884,'STR_PRINTING_NEW_QUOTE_BASED_ON_QUOTE'),(11885,'STR_PRINT_QUOTE_WITH_SPECS'),(11886,'STR_QUICK_LINKS'),(11887,'STR_RECENT_ORDRERS'),(11888,'STR_RECENT_SHIPMENTS'),(11889,'STR_RUSH_CHARGE'),(11890,'STR_SHOW_AUTO_COMPLETE_ID_BOXES'),(11891,'STR_TAXABLE_AMOUNT'),(11892,'STR_THE_FOLLOSING_IS_A_DESCRIPTION_OF_YOUR_ORDER'),(11893,'STR_USE_PO_PROCESS_IF_VENDOR_NOT_USING_CURRENCY'),(11894,'STR_VIEW_ALL_TIPS'),(11895,'STR_VIEW_ALL_TRANSACTIONS_FOR_BANK_DEPOSIT'),(11896,'STR_VIEW_CUSTOMER'),(11897,'STR_VIEW_CUSTOMER_INFORMATION'),(11898,'STR_VIEW_ORIGINAL_VOUCHER'),(11899,'STR_VIEW_OR_EDIT_CONVERSION_RATES'),(11900,'STR_VIEW_TEXT_HELP'),(11901,'STR_VIEW_VIDEO_HELP'),(11902,'STR_YOU_MUST_ENTER_A_QUANTITY'),(11903,'STR_DASHBOARD'),(11904,'STR_SHORTCUTS'),(11905,'STR_EDIT_NON_INVOICED_SALES'),(11906,'STR_NEW_NON_INVOICED_SALES'),(11907,'STR_BANK_SERVICE_CHARGES'),(11908,'STR_AMOUNT_SALES'),(11909,'STR_DEPOSIT_DESCRIPTION'),(11910,'STR_ACH_DEPOSITS_ON_STATEMENT'),(11911,'STR_ADD_NEW_ENTRY'),(11912,'STR_CHECKS_AND_ACH_PAYMENTS_ON_STATEMENT'),(11913,'STR_DEPOSITS_ON_STATEMENT'),(11914,'STR_DIRECT_GL_PAYMENT_ENTRIES_ON_STATEMENT'),(11915,'STR_DIRECT_GL_RECEIPTS_NOT_ON_STATEMENT'),(11916,'STR_DIRECT_GL_RECEIPTS_ON_STATEMENT'),(11917,'STR_DIRECT_GL_RECEIPT_ENTRIES'),(11918,'STR_ENTRY_ADDED_SUCCESSFULLY'),(11919,'STR_INTEREST_EARNED'),(11920,'STR_NEW_GL_ENTRY'),(11921,'STR_PLEASE_ENTER_AN_ACCOUNT'),(11922,'STR_PLEASE_ENTER_AN_AMOUNT'),(11923,'STR_PLEASE_ENTER_A_DATE'),(11924,'STR_PLEASE_ENTER_A_DEFAULT_BANK_SERVICE_CHARGES_ACCOUNT'),(11925,'STR_PLEASE_ENTER_A_DEFAULT_INTEREST_INCOME_ACCOUNT'),(11926,'STR_PLEASE_ENTER_A_DESCRIPTION'),(11927,'STR_SERVICE_CHARGES'),(11928,'STR_MANAGE_HOSTED_ACCOUNT'),(11929,'STR_ACTIVATE2'),(11930,'STR_GET_INVOICES'),(11931,'STR_PICK_WHICH_CURRENCY_INVOICES_YOU_WANT_TO_SHOW_IN_BELOW_LIST'),(11932,'STR_ALL_PAYMENTS_ALONG_WITH_CREDITS_APPLIED_IN_THE_GIVEN_DATE_RANGE'),(11933,'STR_ALL_PENDIING_INVOICES_AND_CREDITS_ARE_DISPLAYED_ALONG_WITH_INVOICES_PAID_IN_THE_GIVEN_DATE_RANGE'),(11934,'STR_OR_PAID'),(11935,'STR_IN_THE_RANGE'),(11936,'STR_CLICK_HERE_TO_REMOVE_THIS_FILE'),(11937,'STR_COULD_NOT_LOCATE_RECORD_FOR_FILE_TO_DELETE'),(11938,'STR_ERROR_REMOVING_FILE'),(11939,'STR_ERROR_RETRIEVING_FILE_NAME_FOR_DELETION'),(11940,'STR_ERROR_RETRIEVING_UPLOADED_DOCUMENTS'),(11941,'STR_FILE_ADDED_SUCCESSFULLY'),(11942,'STR_UNABLE_TO_INSERT_NEW_FILE_RECORD'),(11943,'STR_YOU_MUST_SELECT_A_FILE_TO_UPLOAD'),(11944,'STR_ALL_PENDING_AND_ACTIVE_ORDERS_ARE_DISPLAYED_ALONG_WITH_ORDERS_FINALIZED_IN_THE_GIVEN_DATE_RANGE'),(11945,'STR_GET_ORDERS'),(11946,'STR_CONVERT_TO_ORDER_VIEW_COPY'),(11947,'STR_CURRENT_INVOICES_OR_MAKE_PAYMENTS_OR_INVOICE_HISTORY'),(11948,'STR_CURRENT_ORDER_LIST'),(11949,'STR_ENTER_ORDERS'),(11950,'STR_ENTER_PRINT_ORDERS'),(11951,'STR_ENTER_QUOTE_FOR_PRINT_ORDER'),(11952,'STR_ENTER_QUOTE_INFO'),(11953,'STR_REORDER'),(11954,'STR_REPRINT_VIEW_COPY_ORDERS'),(11955,'STR_REQUEST_SERVICE_CALL'),(11956,'STR_SEARCH_ORDERS'),(11957,'STR_TO_CHANGE_EXISTING_ORDERS_PLEASE_CALL'),(11958,'STR_TO_CHANGE_EXISTING_REQUESTS_PLEASE_CALL'),(11959,'STR_TO_MAKE_AN_ORDER_FROM_A_QUOTE_USE_QUOTE_SEARCH_FROM_STATUS_PAGE'),(11960,'STR_CHECK_CURRENT_RESERVATIONS'),(11961,'STR_CURRENT_STATUS_OF_YOUR_ORDERS'),(11962,'STR_EDIT_YOUR_CONTACT_DETAILS'),(11963,'STR_EDIT_YOUR_NAME_ADDRESS_EMAIL_ETC'),(11964,'STR_ENTER_PRINT_ORDER'),(11965,'STR_MAKE_PAYMENTS_TO_OUTSTANDING_INVOICES'),(11966,'STR_PARKING_RESERVATSIONS'),(11967,'STR_PLACE_NEW_ORDER'),(11968,'STR_REVIEW_YOUR_PAYMENT_HISTORY'),(11969,'STR_REVIEW_YOUR_PURCHASE_HISTORY'),(11970,'STR_UPDATE_PO_SHIPPING'),(11971,'STR_UPDATE_SHIPPING_INFO_ON_PO'),(11972,'STR_PURCHASE_TYPES'),(11973,'STR_EDIT_PURCHASE_ORDER'),(11974,'STR_EDIT_TAX_TABLE'),(11975,'STR_NEW_TAX_TABLE'),(11976,'STR_EDIT_GL_ACCOUNTS'),(11977,'STR_IMPORT_INVENTORY_CATEGORIES_LONG'),(11978,'STR_SALES_CATEGORIES_FILTER'),(11979,'STR_YOU_MUST_ENTER_A_SALES_CATEGORY'),(11980,'STR_SETUP_TO_DO'),(11981,'STR_INVENTORY_ITEMS'),(11982,'STR_HOMEPAGE_REFRESH_TIMES'),(11983,'STR_ADD_SALES_PERSONNEL'),(11984,'STR_CALCULATED_TOTAL_FOR_NEW_QUANTITY'),(11985,'STR_CITY_MARITAL_STATUS'),(11986,'STR_CLICK_HERE_FOR_DATABASE_EXPLANATION'),(11987,'STR_COMPANY_NEW'),(11988,'STR_EDIT_CC_PURCHASE_TYPE'),(11989,'STR_EDIT_COMPANY'),(11990,'STR_EDIT_CREDIT_CARD'),(11991,'STR_EDIT_CREDIT_CARD_PURCHASES'),(11992,'STR_EDIT_MESSAGE_CATEGORY'),(11993,'STR_EDIT_MESSAGE_GRAPHIC'),(11994,'STR_EDIT_NOTE_CATEGORIES'),(11995,'STR_EDIT_USER'),(11996,'STR_HOMEPAGE_REFRESH'),(11997,'STR_LOCAL_MARITAL_STATUS'),(11998,'STR_MARITAL_STATUS_ADDL_TAX'),(11999,'STR_MARRIED'),(12000,'STR_NEW_CC_PURCHASE_TYPE'),(12001,'STR_NEW_CREDIT_CARD'),(12002,'STR_NEW_CREDIT_CARD_PURCHASES'),(12003,'STR_NEW_EDIT_STATE'),(12004,'STR_NEW_EDIT_STATE_TEXT'),(12005,'STR_NEW_MESSAGE_CATEGORY'),(12006,'STR_NEW_MESSAGE_GRAPHIC'),(12007,'STR_NEW_NOTE_CATEGORY'),(12008,'STR_NEW_STATE'),(12009,'STR_NEW_USER'),(12010,'STR_PURCHASE_TOTAL'),(12011,'STR_REFRESH_LENGTH'),(12012,'STR_REFRESH_TIMES_UPDATED_SUCCESSFULLY'),(12013,'STR_SALES_TOTAL'),(12014,'STR_SOLD_TOTAL'),(12015,'STR_SPECIAL_PRICING_USED_CALCULATED_TOTAL'),(12016,'STR_SPECIAL_PRICING_USED_FOR_QUANTITY'),(12017,'STR_STATE_MARITAL_STATUS'),(12018,'STR_TOTAL_CHARGE'),(12019,'STR_NEW_EDIT_USER'),(12020,'STR_EDIT_VIEW_CUSTOMER'),(12021,'STR_GL_ACCOUNT_FOR_SDI_PAYABLE'),(12022,'STR_ON_ANNUAL_WAGES_OVER'),(12023,'STR_SDI_AMOUNT'),(12024,'STR_SDI_FLAT_ANNUAL_AMOUNT'),(12025,'STR_SDI_PERCENT'),(12026,'STR_TAX_IS_THIS_PERCENTAGE_OF_FEDERAL_TAX'),(12027,'STR_AMOUNT_COMPLETED'),(12028,'STR_AMOUNT_INVOICED'),(12029,'STR_DELETE_THIS_ADDRESS'),(12030,'STR_HOLD_FOR_LATER'),(12031,'STR_ORDER_QUANTITY_AND_SHIP_QUANTITY_MUST_EQUAL'),(12032,'STR_IMPORT_STATE_TAX_DATA'),(12033,'STR_IMPORT_SUCCESSFUL'),(12034,'STR_SDI'),(12035,'STR_STATE_SDI'),(12036,'STR_AMOUNT_PER_UNIT'),(12037,'STR_JOB_ENTERED_ON'),(12038,'STR_COST_USED'),(12039,'STR_AMOUNTS_IN_THOUSANDS'),(12040,'STR_NO_MESSAGES'),(12041,'STR_ACTIVATE_ADDONS'),(12042,'STR_SOCIAL_SECURITY_GOVT_ID'),(12043,'STR_ALREADY_ADDED'),(12044,'STR_UNABLE_TO_RETRIEVE_PERSONAL_MESSAGE_RECORDS'),(12045,'STR_NO_MATCHING_QUOTES_OR_JOBS_FOUND'),(12046,'STR_CLICK_ON_JOB_ID_TO_CONFIRM_ORDER'),(12047,'STR_NO_UNCONFIRMED_ITEMS_FOUND'),(12048,'STR_ACTIVATION_SUCCESSFUL'),(12049,'STR_ADD_ON'),(12050,'STR_ADD_ON_PURCHASING_NOT_AVAILABLE_AT_THIS_TIME'),(12051,'STR_BILLING_COUNTRY'),(12052,'STR_CC_NUMBER'),(12053,'STR_CONFIRMATION_NUMBER'),(12054,'STR_CONFIRM_PURCHASE'),(12055,'STR_ECOMMERCE_APPS'),(12056,'STR_ERROR_RETRIEVING_PRICING'),(12057,'STR_ERROR_RETRIEVING_PURCHASE_CONFIRMATION'),(12058,'STR_ERROR_SAVING_CARD'),(12059,'STR_FREEBIES'),(12060,'STR_GET_ADD_ONS'),(12061,'STR_LANGUAGE_PACKS'),(12062,'STR_PLEASE_PRINT_THIS_PAGE_FOR_YOUR_RECORDS'),(12063,'STR_PLUG_INS'),(12064,'STR_PRICING_IS_OUT_OF_DATE'),(12065,'STR_PURCHASE_ADD_ONS'),(12066,'STR_PURCHASE_ADD_ONS_AND_PLUG_INS'),(12067,'STR_PURCHASE_CONFIRMATION_IS_OUT_OF_DATE'),(12068,'STR_SELECT_ADD_ONS_TO_PURCHASE'),(12069,'STR_STORED_CARD'),(12070,'STR_USE_OTHER_CARD'),(12071,'STR_USE_STORED_CREDIT_CARD'),(12072,'STR_YOUR_CARD_WILL_NOT_BE_CHARGED_FOR_FREE_ORDERS'),(12073,'STR_FROM_MONTH'),(12074,'STR_TO_MONTH'),(12075,'STR_CHECKING_THIS_BOX_WILL_CAUSE_NO_GL_ENTRIES_TO_BE_RECORDED_FOR_INVENTORY'),(12076,'STR_CHECKING_THIS_BOX_WILL_LEAVE_A_GL_ENTRY_IN_INVENTORY_VARIANCE_THAT_MAY_NEED_TO_BE_ADJUSTED'),(12077,'STR_NO_POSTING_FOR_PAYABLES_WILL_TAKE_PLACE'),(12078,'STR_CLICK_TO_OPEN'),(12079,'STR_CHANGES_CANCELLED'),(12080,'STR_ADD_ONS'),(12081,'STR_NOT_INVOICE_DATE'),(12082,'STR_USE_ENTRY_DATE'),(12083,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_THIS_ORDER'),(12084,'STR_BIRTH_DATE_AFTER_TODAY'),(12085,'STR_BIRTH_DATE_IS_AFTER_HIRE_DATE'),(12086,'STR_CLICK_TO_TOGGLE_OPEN_OR_CLOSE'),(12087,'STR_DO_NOT_APPLY_WHEN_SPECIAL_PAY_PERIOD_USED_FOR_CALCULATIONS'),(12088,'STR_INVALID_IMAGE_TYPE'),(12089,'STR_MUST_SELECT_A_VENDOR'),(12090,'STR_NO_ORDER_SELECTED_TRY_AGAIN'),(12091,'STR_NO_WORK_FOUND_FOR_PERIOD'),(12092,'STR_SHOW_COLUMN_ON_REPORT'),(12093,'STR_SHOW_INACTIVE'),(12094,'STR_THIS_PICTURE_TYPE_IS_NOT_SUPPORTED'),(12095,'STR_VIEW_BY_SALES_CATEGORY'),(12096,'STR_WILL_AUTO_FILL_IF_INVENTORY'),(12097,'STR_REFRESH'),(12098,'STR_MERGE_SUCCESSFULL'),(12099,'STR_ERROR_FILE_TYPE_UPLOADED_IS_NOT_ALLOWED'),(12100,'STR_COMPANY_WEB_SITE'),(12101,'STR_MY_COMPANY_INFORMATION'),(12102,'STR_MY_EMAIL'),(12103,'STR_MY_FIRST_NAME'),(12104,'STR_MY_LAST_NAME'),(12105,'STR_MY_LOGIN_NAME'),(12106,'STR_MY_PERSONAL_INFORMATION'),(12107,'STR_ARE_YOU_SURE_YOU_WANT_TO_CREATE_A_NEW_QUOTE'),(12108,'STR_NUM_PACKAGES'),(12109,'STR_UPS_2ND_DAY_BLUE'),(12110,'STR_UPS_THIRD_DAY_ORANGE'),(12111,'STR_USE_NEXT_DAY_RED'),(12112,'STR_INK_SIDE_1'),(12113,'STR_INK_SIDE_2'),(12114,'STR_PMS_NUM'),(12115,'STR_PRINTING_NEW_ORDER_BASED_ON_QUOTE'),(12116,'STR_HAS_BEEN_CONFIRMED_CALL_CUSTOMER_SERVICE_TO_DELETE'),(12117,'STR_FORM_NUM'),(12118,'STR_THE_FOLLOWING_IS_A_DESCRIPTION_OF_YOUR_ORDER'),(12119,'STR_B2B_CUSTOMER_REQUEST'),(12120,'STR_CLICK_HERE_TO_VIEW_MORE_ORDER_DETAILS_FOR_THIS_ORDER'),(12121,'STR_CLICK_HERE_TO_VIEW_SHIPPING_DETAILS_FOR_THIS_ORDER'),(12122,'STR_OR_EMAIL'),(12123,'STR_1_AND_2_SIDED'),(12124,'STR_1_SIDED'),(12125,'STR_2_SIDED'),(12126,'STR_BLACK_AND_WHITE'),(12127,'STR_CLICK_BELOW_TO_SAVE_YOUR_PRINT_ORDER'),(12128,'STR_COLOR_AND_B_W'),(12129,'STR_FINISHED_SIZE_OF_PIECE'),(12130,'STR_FULL_COLOR'),(12131,'STR_GRAPHIC_DESIGN_JOBS_IE_POSTERS_AND_REVISIONS_COULD_TAKE_5_DAYS_OR_LONGER'),(12132,'STR_IF_NOT_SURE_ABOUT_WHAT_TO_SELECT'),(12133,'STR_IF_THE_ORDER_STATUS_IS_NEW_OR_REVISED_A_LINK_WILL_APPEAR_ON_THE_NEXT_PAGE'),(12134,'STR_ONE_COLOR'),(12135,'STR_PAPER_NUMBER'),(12136,'STR_RETURN_TO_PREVIOUS_PAGE'),(12137,'STR_SAVE_PRINT_ORDER'),(12138,'STR_SOMEONE_WILL_CONTACT_YOU_WITHIN_24_HOURS'),(12139,'STR_SO_YOU_CAN_PRINT_A_COVER_SHEET_TO_ACCOMPANY_THE_ORIGINALS'),(12140,'STR_ATTACHED_FILES'),(12141,'STR_CLICK_HERE_TO_MAKE_A_COVER_SHEET_FOR_YOUR_ORIGINALS'),(12142,'STR_ENTER_ORDER_TICKET_NUMBER'),(12143,'STR_NUMBER_COLORS'),(12144,'STR_ORDER_NUMBR'),(12145,'STR_ROOM'),(12146,'STR_CLICK_HERE_TO_VIEW_MORE_DETAILS_FOR_THIS_ORDER'),(12147,'STR_CUSTOMER_REQUEST_FROOM'),(12148,'STR_ERROR_RETRIEVING_RECENT_ORDER_INFO'),(12149,'STR_CLICK_HERE_TO_MAKE_A_COVERSHEET_FOR_YOUR_ORIGINALS'),(12150,'STR_CONTACT_US'),(12151,'STR_BILLS_AND_PAYMENTS'),(12152,'STR_BILL_AND_PAYMENT_HISTORY'),(12153,'STR_RECENT_BILLS'),(12154,'STR_ALL_OPEN'),(12155,'STR_BY_CATEGORY_THEN_BY_SALESMAN'),(12156,'STR_BY_SALESMAN'),(12157,'STR_DO_NOT_SHOW_SUBTOTALS'),(12158,'STR_OPEN_ORDER_SUMMARY'),(12159,'STR_SHOW_LINE_ITEM_DETAIL'),(12160,'STR_TOTAL_FOR_CATEGORY'),(12161,'STR_TOTAL_FOR_SALESMAN'),(12162,'STR_WHICH_ORDERS'),(12163,'STR_SUMMARY_OPEN_ORDERS'),(12164,'STR_SENT_CAP'),(12165,'STR_BUILD_ORDER_DEFINITIONS'),(12166,'STR_EMPLOYEE_BIRTHDAYS'),(12167,'STR_EMPLOYEE_GENERAL_INFORMATION'),(12168,'STR_ITEMS_RECEIVED'),(12169,'STR_SALES_PROFITABILITY'),(12170,'STR_SHIPPING_CARRIER_SETUP'),(12171,'STR_STATUS_OF_EMPLOYEES'),(12172,'STR_SHIPPING_CARRIERS'),(12173,'STR_NEW_SHIPPING_METHOD'),(12174,'STR_DATABASE_INFO'),(12175,'STR_OSCOMMERCE'),(12176,'STR_GENERAL_SETUP_INVENTORY'),(12177,'STR_GENERAL_SETUP_AR'),(12178,'STR_ACTIVE_ADDONS'),(12179,'STR_GL_ACCOUNTS_COPIED'),(12180,'STR_ITEM_VALUATION'),(12181,'STR_TO_CAP'),(12182,'STR_ADD_A_BANK_ACCOUNT'),(12183,'STR_CONFIGURE_PAYROLL_TAX_TYPES'),(12184,'STR_SETUP_BILLING_GL_ACCOUNTS'),(12185,'STR_SETUP_PAYABLES_GL_ACCOUNTS'),(12186,'STR_SET_UP_INVENTORY_GL_ACCOUNTS'),(12187,'STR_SET_UP_PAYROLL_GL_ACCOUNTS'),(12188,'STR_ADD_NEW_USER_GROUP'),(12189,'STR_ADD_NEW_USER_RIGHTS_GROUP'),(12190,'STR_CANNOT_DELETE_ADMIN'),(12191,'STR_CHECKS_GENERATED_CLICK_TO_PRINT'),(12192,'STR_EDIT_SHIPPING_CARRIER'),(12193,'STR_EMPLOYEE_HAS_NO_DATA_FOR_THIS_PERIOD'),(12194,'STR_ERROR_INSERTING_PLAN'),(12195,'STR_IMPORT_EMPLOYEES_SUCCESSFUL'),(12196,'STR_LIST_RECEIPTS'),(12197,'STR_MUST_ENTER_SERVICE_TYPES_AND_CLASSES_BEFORE_ENTERING_RATES'),(12198,'STR_MUST_LOG_HOURS_BEFORE_MAKING_CHANGES'),(12199,'STR_NO_ITEM_CODE_ENTERED'),(12200,'STR_NO_NON_INVOICE_PAYMENTS_FOUND'),(12201,'STR_NO_USERS_EXIST_FOR_THIS_COMPANY_SELECT_ADD_TO_CREATE_ONE'),(12202,'STR_PLAN_ADDED_SUCCESSFULLY'),(12203,'STR_PLAN_UPDATED_SUCCESSFULLY'),(12204,'STR_QTY_PER_MASTER'),(12205,'STR_SUB_ITEM_CODE'),(12206,'STR_SUB_ITEM_NAME'),(12207,'STR_THE_DELIMITER_SHOULD_BE_ONE_CHARACTER_LONG'),(12208,'STR_UPDATE_STATE_TAX_TABLES_FOR_YEAR_SELECTED'),(12209,'STR_USER_RIGHTS_GROUP'),(12210,'STR_VENDOR_HOLD'),(12211,'STR_YOU_CANNOT_USE_NUMBERS_OR_LETTERS_AS_DELIMITER_CHARACTER'),(12212,'STR_GENERAL_SETUP_FOR_PAYABLES'),(12213,'STR_GENERAL_SETUP_PAYROLL'),(12214,'STR_INVENTORY_PROPERTIES'),(12215,'STR_ITEMS_BACKORDERED_FOR'),(12216,'STR_ITEM_ORDER_HISTORY_FOR'),(12217,'STR_ITEM_SHIPMENTS_FOR'),(12218,'STR_RATING_SCALE_ADD'),(12219,'STR_RATING_SCALE_UPDATE'),(12220,'STR_SERVICE_ORDER_VOLUME_REPORT'),(12221,'STR_TOTAL_COMMITTED'),(12222,'STR_YOU_MUST_ENTER_BOTH_A_FROM_AND_TO_ITEM'),(12223,'STR_AP_PAYABLES_AGING_DETAILS'),(12224,'STR_BANK_RECONCILIATION_DOCUMENTS'),(12225,'STR_CASH_REQUIREMENTS_DETAILS'),(12226,'STR_DOCTOR_REQUEST_FORM'),(12227,'STR_LIST_CREDIT_CARD_PURCHASES'),(12228,'STR_PAYABLES_AGING_DETAILS'),(12229,'STR_PAYABLES_AGING_SUMMARY'),(12230,'STR_PAYABLES_DISCOUNT_AGING'),(12231,'STR_PLEASE_PROCEED_ONLY_IF_YOU_ARE_ON_A_SECURE_INTERNAL_NETWORK'),(12232,'STR_PRINT_AR_REFUND_CHECKS_IN_GROUP'),(12233,'STR_PROFIT_AND_LOSS'),(12234,'STR_RECEIVABLES_AGING'),(12235,'STR_RECEIVABLES_AGING_DETAILS'),(12236,'STR_THE_FROM_AND_TO_QUANTITIES_MUST_MATCH'),(12237,'STR_UNABLE_TO_VOID_CC_PAYMENT'),(12238,'STR_VAT_TAX_REPORT'),(12239,'STR_WE_STRONGLY_RECOMMEND_THAT_YOU_UPGRADE_YOUR_CONNECTION_TO_USE_SSL_HTTPS'),(12240,'STR_YOUR_CURRENT_CONNECTION_DOES_NOT_USE_SSL_HTTPS'),(12241,'STR_CREATE_INVENTORY_CATEGORIES'),(12242,'STR_TIP_1'),(12243,'STR_TIP_10'),(12244,'STR_TIP_100'),(12245,'STR_TIP_101'),(12246,'STR_TIP_102'),(12247,'STR_TIP_103'),(12248,'STR_TIP_104'),(12249,'STR_TIP_105'),(12250,'STR_TIP_106'),(12251,'STR_TIP_107'),(12252,'STR_TIP_108'),(12253,'STR_TIP_109'),(12254,'STR_TIP_11'),(12255,'STR_TIP_110'),(12256,'STR_TIP_111'),(12257,'STR_TIP_112'),(12258,'STR_TIP_113'),(12259,'STR_TIP_114'),(12260,'STR_TIP_115'),(12261,'STR_TIP_116'),(12262,'STR_TIP_117'),(12263,'STR_TIP_118'),(12264,'STR_TIP_119'),(12265,'STR_TIP_12'),(12266,'STR_TIP_120'),(12267,'STR_TIP_121'),(12268,'STR_TIP_122'),(12269,'STR_TIP_123'),(12270,'STR_TIP_124'),(12271,'STR_TIP_125'),(12272,'STR_TIP_126'),(12273,'STR_TIP_127'),(12274,'STR_TIP_128'),(12275,'STR_TIP_129'),(12276,'STR_TIP_13'),(12277,'STR_TIP_130'),(12278,'STR_TIP_131'),(12279,'STR_TIP_132'),(12280,'STR_TIP_133'),(12281,'STR_TIP_134'),(12282,'STR_TIP_135'),(12283,'STR_TIP_136'),(12284,'STR_TIP_137'),(12285,'STR_TIP_138'),(12286,'STR_TIP_139'),(12287,'STR_TIP_14'),(12288,'STR_TIP_140'),(12289,'STR_TIP_141'),(12290,'STR_TIP_142'),(12291,'STR_TIP_143'),(12292,'STR_TIP_144'),(12293,'STR_TIP_145'),(12294,'STR_TIP_146'),(12295,'STR_TIP_147'),(12296,'STR_TIP_148'),(12297,'STR_TIP_149'),(12298,'STR_TIP_15'),(12299,'STR_TIP_150'),(12300,'STR_TIP_151'),(12301,'STR_TIP_152'),(12302,'STR_TIP_153'),(12303,'STR_TIP_154'),(12304,'STR_TIP_155'),(12305,'STR_TIP_156'),(12306,'STR_TIP_157'),(12307,'STR_TIP_158'),(12308,'STR_TIP_159'),(12309,'STR_TIP_16'),(12310,'STR_TIP_160'),(12311,'STR_TIP_161'),(12312,'STR_TIP_162'),(12313,'STR_TIP_163'),(12314,'STR_TIP_164'),(12315,'STR_TIP_165'),(12316,'STR_TIP_166'),(12317,'STR_TIP_167'),(12318,'STR_TIP_168'),(12319,'STR_TIP_169'),(12320,'STR_TIP_17'),(12321,'STR_TIP_170'),(12322,'STR_TIP_171'),(12323,'STR_TIP_172'),(12324,'STR_TIP_173'),(12325,'STR_TIP_174'),(12326,'STR_TIP_175'),(12327,'STR_TIP_176'),(12328,'STR_TIP_177'),(12329,'STR_TIP_178'),(12330,'STR_TIP_179'),(12331,'STR_TIP_18'),(12332,'STR_TIP_180'),(12333,'STR_TIP_181'),(12334,'STR_TIP_182'),(12335,'STR_TIP_183'),(12336,'STR_TIP_184'),(12337,'STR_TIP_185'),(12338,'STR_TIP_186'),(12339,'STR_TIP_187'),(12340,'STR_TIP_188'),(12341,'STR_TIP_189'),(12342,'STR_TIP_19'),(12343,'STR_TIP_190'),(12344,'STR_TIP_191'),(12345,'STR_TIP_192'),(12346,'STR_TIP_193'),(12347,'STR_TIP_194'),(12348,'STR_TIP_195'),(12349,'STR_TIP_196'),(12350,'STR_TIP_197'),(12351,'STR_TIP_198'),(12352,'STR_TIP_199'),(12353,'STR_TIP_2'),(12354,'STR_TIP_20'),(12355,'STR_TIP_200'),(12356,'STR_TIP_201'),(12357,'STR_TIP_202'),(12358,'STR_TIP_203'),(12359,'STR_TIP_204'),(12360,'STR_TIP_205'),(12361,'STR_TIP_206'),(12362,'STR_TIP_207'),(12363,'STR_TIP_208'),(12364,'STR_TIP_209'),(12365,'STR_TIP_21'),(12366,'STR_TIP_210'),(12367,'STR_TIP_211'),(12368,'STR_TIP_212'),(12369,'STR_TIP_213'),(12370,'STR_TIP_214'),(12371,'STR_TIP_215'),(12372,'STR_TIP_216'),(12373,'STR_TIP_217'),(12374,'STR_TIP_218'),(12375,'STR_TIP_219'),(12376,'STR_TIP_22'),(12377,'STR_TIP_220'),(12378,'STR_TIP_221'),(12379,'STR_TIP_222'),(12380,'STR_TIP_223'),(12381,'STR_TIP_224'),(12382,'STR_TIP_225'),(12383,'STR_TIP_226'),(12384,'STR_TIP_227'),(12385,'STR_TIP_228'),(12386,'STR_TIP_229'),(12387,'STR_TIP_23'),(12388,'STR_TIP_230'),(12389,'STR_TIP_231'),(12390,'STR_TIP_232'),(12391,'STR_TIP_233'),(12392,'STR_TIP_234'),(12393,'STR_TIP_235'),(12394,'STR_TIP_236'),(12395,'STR_TIP_237'),(12396,'STR_TIP_238'),(12397,'STR_TIP_239'),(12398,'STR_TIP_24'),(12399,'STR_TIP_240'),(12400,'STR_TIP_241'),(12401,'STR_TIP_242'),(12402,'STR_TIP_243'),(12403,'STR_TIP_244'),(12404,'STR_TIP_245'),(12405,'STR_TIP_246'),(12406,'STR_TIP_247'),(12407,'STR_TIP_248'),(12408,'STR_TIP_249'),(12409,'STR_TIP_25'),(12410,'STR_TIP_250'),(12411,'STR_TIP_251'),(12412,'STR_TIP_252'),(12413,'STR_TIP_253'),(12414,'STR_TIP_254'),(12415,'STR_TIP_255'),(12416,'STR_TIP_256'),(12417,'STR_TIP_257'),(12418,'STR_TIP_258'),(12419,'STR_TIP_259'),(12420,'STR_TIP_26'),(12421,'STR_TIP_260'),(12422,'STR_TIP_261'),(12423,'STR_TIP_262'),(12424,'STR_TIP_263'),(12425,'STR_TIP_264'),(12426,'STR_TIP_265'),(12427,'STR_TIP_266'),(12428,'STR_TIP_267'),(12429,'STR_TIP_268'),(12430,'STR_TIP_269'),(12431,'STR_TIP_27'),(12432,'STR_TIP_270'),(12433,'STR_TIP_271'),(12434,'STR_TIP_272'),(12435,'STR_TIP_273'),(12436,'STR_TIP_274'),(12437,'STR_TIP_275'),(12438,'STR_TIP_276'),(12439,'STR_TIP_277'),(12440,'STR_TIP_278'),(12441,'STR_TIP_279'),(12442,'STR_TIP_28'),(12443,'STR_TIP_280'),(12444,'STR_TIP_281'),(12445,'STR_TIP_282'),(12446,'STR_TIP_283'),(12447,'STR_TIP_284'),(12448,'STR_TIP_285'),(12449,'STR_TIP_286'),(12450,'STR_TIP_287'),(12451,'STR_TIP_288'),(12452,'STR_TIP_289'),(12453,'STR_TIP_29'),(12454,'STR_TIP_290'),(12455,'STR_TIP_291'),(12456,'STR_TIP_292'),(12457,'STR_TIP_293'),(12458,'STR_TIP_294'),(12459,'STR_TIP_295'),(12460,'STR_TIP_296'),(12461,'STR_TIP_297'),(12462,'STR_TIP_298'),(12463,'STR_TIP_299'),(12464,'STR_TIP_3'),(12465,'STR_TIP_30'),(12466,'STR_TIP_300'),(12467,'STR_TIP_301'),(12468,'STR_TIP_302'),(12469,'STR_TIP_303'),(12470,'STR_TIP_304'),(12471,'STR_TIP_305'),(12472,'STR_TIP_306'),(12473,'STR_TIP_307'),(12474,'STR_TIP_308'),(12475,'STR_TIP_309'),(12476,'STR_TIP_31'),(12477,'STR_TIP_310'),(12478,'STR_TIP_311'),(12479,'STR_TIP_312'),(12480,'STR_TIP_313'),(12481,'STR_TIP_314'),(12482,'STR_TIP_315'),(12483,'STR_TIP_316'),(12484,'STR_TIP_317'),(12485,'STR_TIP_318'),(12486,'STR_TIP_319'),(12487,'STR_TIP_32'),(12488,'STR_TIP_320'),(12489,'STR_TIP_321'),(12490,'STR_TIP_322'),(12491,'STR_TIP_323'),(12492,'STR_TIP_324'),(12493,'STR_TIP_325'),(12494,'STR_TIP_326'),(12495,'STR_TIP_327'),(12496,'STR_TIP_328'),(12497,'STR_TIP_329'),(12498,'STR_TIP_33'),(12499,'STR_TIP_330'),(12500,'STR_TIP_331'),(12501,'STR_TIP_332'),(12502,'STR_TIP_333'),(12503,'STR_TIP_334'),(12504,'STR_TIP_335'),(12505,'STR_TIP_336'),(12506,'STR_TIP_337'),(12507,'STR_TIP_338'),(12508,'STR_TIP_339'),(12509,'STR_TIP_34'),(12510,'STR_TIP_340'),(12511,'STR_TIP_341'),(12512,'STR_TIP_342'),(12513,'STR_TIP_343'),(12514,'STR_TIP_344'),(12515,'STR_TIP_345'),(12516,'STR_TIP_346'),(12517,'STR_TIP_347'),(12518,'STR_TIP_348'),(12519,'STR_TIP_349'),(12520,'STR_TIP_35'),(12521,'STR_TIP_350'),(12522,'STR_TIP_351'),(12523,'STR_TIP_352'),(12524,'STR_TIP_353'),(12525,'STR_TIP_354'),(12526,'STR_TIP_355'),(12527,'STR_TIP_356'),(12528,'STR_TIP_357'),(12529,'STR_TIP_358'),(12530,'STR_TIP_359'),(12531,'STR_TIP_36'),(12532,'STR_TIP_360'),(12533,'STR_TIP_361'),(12534,'STR_TIP_362'),(12535,'STR_TIP_363'),(12536,'STR_TIP_364'),(12537,'STR_TIP_365'),(12538,'STR_TIP_366'),(12539,'STR_TIP_367'),(12540,'STR_TIP_368'),(12541,'STR_TIP_369'),(12542,'STR_TIP_37'),(12543,'STR_TIP_370'),(12544,'STR_TIP_371'),(12545,'STR_TIP_372'),(12546,'STR_TIP_373'),(12547,'STR_TIP_374'),(12548,'STR_TIP_375'),(12549,'STR_TIP_376'),(12550,'STR_TIP_377'),(12551,'STR_TIP_378'),(12552,'STR_TIP_379'),(12553,'STR_TIP_38'),(12554,'STR_TIP_380'),(12555,'STR_TIP_381'),(12556,'STR_TIP_382'),(12557,'STR_TIP_383'),(12558,'STR_TIP_384'),(12559,'STR_TIP_385'),(12560,'STR_TIP_386'),(12561,'STR_TIP_387'),(12562,'STR_TIP_388'),(12563,'STR_TIP_389'),(12564,'STR_TIP_39'),(12565,'STR_TIP_390'),(12566,'STR_TIP_391'),(12567,'STR_TIP_392'),(12568,'STR_TIP_393'),(12569,'STR_TIP_394'),(12570,'STR_TIP_395'),(12571,'STR_TIP_396'),(12572,'STR_TIP_397'),(12573,'STR_TIP_398'),(12574,'STR_TIP_399'),(12575,'STR_TIP_4'),(12576,'STR_TIP_40'),(12577,'STR_TIP_400'),(12578,'STR_TIP_41'),(12579,'STR_TIP_42'),(12580,'STR_TIP_43'),(12581,'STR_TIP_44'),(12582,'STR_TIP_45'),(12583,'STR_TIP_46'),(12584,'STR_TIP_47'),(12585,'STR_TIP_48'),(12586,'STR_TIP_49'),(12587,'STR_TIP_5'),(12588,'STR_TIP_50'),(12589,'STR_TIP_51'),(12590,'STR_TIP_52'),(12591,'STR_TIP_53'),(12592,'STR_TIP_54'),(12593,'STR_TIP_55'),(12594,'STR_TIP_56'),(12595,'STR_TIP_57'),(12596,'STR_TIP_58'),(12597,'STR_TIP_59'),(12598,'STR_TIP_6'),(12599,'STR_TIP_60'),(12600,'STR_TIP_61'),(12601,'STR_TIP_62'),(12602,'STR_TIP_63'),(12603,'STR_TIP_64'),(12604,'STR_TIP_65'),(12605,'STR_TIP_66'),(12606,'STR_TIP_67'),(12607,'STR_TIP_68'),(12608,'STR_TIP_69'),(12609,'STR_TIP_7'),(12610,'STR_TIP_70'),(12611,'STR_TIP_71'),(12612,'STR_TIP_72'),(12613,'STR_TIP_73'),(12614,'STR_TIP_74'),(12615,'STR_TIP_75'),(12616,'STR_TIP_76'),(12617,'STR_TIP_77'),(12618,'STR_TIP_78'),(12619,'STR_TIP_79'),(12620,'STR_TIP_8'),(12621,'STR_TIP_80'),(12622,'STR_TIP_81'),(12623,'STR_TIP_82'),(12624,'STR_TIP_83'),(12625,'STR_TIP_84'),(12626,'STR_TIP_85'),(12627,'STR_TIP_86'),(12628,'STR_TIP_87'),(12629,'STR_TIP_88'),(12630,'STR_TIP_89'),(12631,'STR_TIP_9'),(12632,'STR_TIP_90'),(12633,'STR_TIP_91'),(12634,'STR_TIP_92'),(12635,'STR_TIP_93'),(12636,'STR_TIP_94'),(12637,'STR_TIP_95'),(12638,'STR_TIP_96'),(12639,'STR_TIP_97'),(12640,'STR_TIP_98'),(12641,'STR_TIP_99'),(12642,'STR_CUSTOMIZE_IT'),(12643,'STR_AM0UNT'),(12644,'STR_ADD_MODIFY_PAYMENT_INFORMATION'),(12645,'STR_ADD_MODIFY_SUBSCRIPTION'),(12646,'STR_ADD_A_NEW_SUBSCRIPTION'),(12647,'STR_ADD_NEW_SUBSCRIPTION'),(12648,'STR_ARE_YOU_SURE_YOU_WANT_TO_CANCEL_THIS_SUBSCRIPTION'),(12649,'STR_ARE_YOU_SURE_YOU_WANT_TO_MODIFY_YOUR_SUBSCRIPTION'),(12650,'STR_A_SUBSCRIPTION_ALREADY_EXISTS'),(12651,'STR_BEGINS'),(12652,'STR_CHANGE_SUBSCRIPTION'),(12653,'STR_CHANGE_YOUR_SUBSCRIPTION'),(12654,'STR_CURRENT_SUBSCRIPTION'),(12655,'STR_ERROR_READING_SUBSCRIPTION'),(12656,'STR_REDIRECTING_TO_PAYMENT_PAGE'),(12657,'STR_SELECT_SUBSCRIPTION'),(12658,'STR_SUBSCRIPTION_ADDED_SUCCESSFULLY'),(12659,'STR_SUBSCRIPTION_CANCELED_SUCCESSFULLY'),(12660,'STR_ARE_YOU_SURE_YOU_WANT_TO_REPLACE_THE_EXISTING_CARD_WITH_A_NEW_ONE'),(12661,'STR_ERROR_GETTING_CC_INFO'),(12662,'STR_ERROR_GETTING_CC_PARAMETERS'),(12663,'STR_ERROR_SAVING_CC_INFO'),(12664,'STR_ERROR_VOIDING_TEST_CC_TRANSACTION'),(12665,'STR_NEW_CARD'),(12666,'STR_NOT_ABLE_TO_ADD_PAYMENT_METHODS_AT_THIS_TIME'),(12667,'STR_PAYMENT_INFO_SAVED_SUCCESSFULLY'),(12668,'STR_PAYMENT_INFO_UPDATED_SUCCESSFULLY'),(12669,'STR_CURRENT_PAYMENT_METHOD'),(12670,'STR_RECENT_PAYMENT_TRANSACTIONS'),(12671,'STR_SUMMARY_INFORMATION'),(12672,'STR_YOU_CURRENTLY_HAVE_NO_ACTIVE_SUBSCRIPTIONS'),(12673,'STR_GET_HELP'),(12674,'STR_NOLAPRO_WEBSITE'),(12675,'STR_SUPPORT_OPTIONS'),(12676,'STR_SUPPORT_SITE'),(12677,'STR_TEXT_HELP'),(12678,'STR_SEE_ADDONS'),(12679,'STR_APPLY_ACTIVATION_CODES'),(12680,'STR_ADD_TIME_AND_MATERIALS_ENTRY'),(12681,'STR_ADVANCED_ORDER_SEARCH'),(12682,'STR_BUILD_ORDERS'),(12683,'STR_CLICK_HERE_TO_SET_UP_A_HOSTED_ACCOUNT'),(12684,'STR_HIDE_WEATHER_DISPLAY_ON_PAGES'),(12685,'STR_MANAGE_SUBSCRIPTION'),(12686,'STR_NO_MATCHING_ORDERS'),(12687,'STR_SALES_UNIT_ADD'),(12688,'STR_SALES_UNIT_UPDATE'),(12689,'STR_SHOP_LOADING_FOR'),(12690,'STR_SUBSCRIPTION_MANAGEMENT_NOT_AVAILABLE_AT_THIS_TIME'),(12691,'STR_BIN_SHELF_LOCATION'),(12692,'STR_SHOW_INVOICE_STATUS'),(12693,'STR_FUTURE'),(12694,'STR_SUBSCRIPTIONS'),(12695,'STR_ERROR_GETTING_CUSTOMER_INFORMATION'),(12696,'STR_ERROR_UPDATING_CUSTOMER_INFORMATION'),(12697,'STR_NR_PACKAGES'),(12698,'STR_PMS_NR'),(12699,'STR_QUOTE_NR'),(12700,'STR_YOU_MUST_CLICK_SAVE_QUOTE_TO_KEEP_CHANGES'),(12701,'STR_CUSTOMER_NR'),(12702,'STR_PASSWORD_CREATED_DURING_SIGNUP'),(12703,'STR_QUICK_HELP'),(12704,'STR_ONLY_WHEN_MORE_THAN_ONE_INK_ON_SIDE_TWO'),(12705,'STR_SIDE_TWO_TIGHT_REGISTRATION'),(12706,'STR_PRINTSHOP_PERFORMANCE_STATISTICS'),(12707,'STR_PRINTSHOP_PERFORMANCE_STATISTICS_FOR_DATES'),(12708,'STR_NO_ACTUAL_DATA_FOUND'),(12709,'STR_QUESTION_LACKS_NAME'),(12710,'STR_QUESTION_LACKS_RESPONSE_TYPE'),(12711,'STR_ANOTHER_DELIVERY_ADDRESS'),(12712,'STR_ERROR_READING_FILE'),(12713,'STR_AVAILABLE_SUBSCRIPTIONS'),(12714,'STR_BILLING_PERIODS_PER_YEAR'),(12715,'STR_SUBSCRIPTION'),(12716,'STR_CASH_BASIS_TAX_REPORTING'),(12717,'STR_DO_NOT_UPDATE_COSTS_DURING_SHIPPING_OF_FULFILLMENT_ORDER'),(12718,'STR_WARNING_THIS_MIGHT_MESS_UP_INVENTORY_COSTS_FOR_GL'),(12719,'STR_CASH_BASIS_REPORT'),(12720,'STR_EXEMPT_AMOUNT'),(12721,'STR_SHOW_ITEM_DESCRIPTION'),(12722,'STR_VIEW_INVOICE'),(12723,'STR_INTERNAL_MESSAGES'),(12724,'STR_POSTED_BETWEEN'),(12725,'STR_THE_FOLLOWING_USER_PRIVILEGES_ARE_NEEDED_TO_PROCEED'),(12726,'STR_BY_CHECKING_THIS_BOX_I_CERTIFY_THAT_I_HAVE_READ_AND_UNDERSTAND_THE_INFORMATION_CONTAINED_IN_THIS_MESSAGE'),(12727,'STR_INVALID_VENDOR'),(12728,'STR_SIGS_POSSIBLE'),(12729,'STR_NUMBER_OF_SIGS'),(12730,'STR_SHIP_TO_EDIT'),(12731,'STR_SIGS'),(12732,'STR_MAXIMUM_NUMBER_OF_CUSTOMERS_HAS_BEEN_EXCEEDED'),(12733,'STR_CALCULATED_TOTAL'),(12734,'STR_SPECIAL_PRICING_USED'),(12735,'STR_YOU_HAVE_EXCEEDED_THE_LIMIT_ALLOWED'),(12736,'STR_MAXIMUM_CUSTOMERS_EXCEEDED_NOT_ALL_IMPORTED'),(12737,'STR_MAXIMUM_ITEMS_EXCEEDED_NOT_ALL_IMPORTED'),(12738,'STR_MAXIMUM_NUMBER_OF_ITEMS_HAS_BEEN_EXCEEDED'),(12739,'STR_ADDITIONAL_BOXES'),(12740,'STR_FIRST_BOX'),(12741,'STR_IF_NOT_AUTO_LOOKUP_USE_TABLE_BELOW_FOR_PRICING'),(12742,'STR_CHECK_IF_NO_DROP_FOR_SAME_COLOR'),(12743,'STR_ALLOW_DUPLICATE_PO'),(12744,'STR_BOTH_SIDES'),(12745,'STR_DELETE_THIS_STOCK'),(12746,'STR_INKS_USED_THIS_STOCK'),(12747,'STR_SIDE_ONE_ONLY'),(12748,'STR_SIDE_TWO_ONLY'),(12749,'STR_DOWNLOAD_EXPORT_ZIP_FILE'),(12750,'STR_ERROR_UPLOADING_FILE'),(12751,'STR_EXPORT_MAY_TAKE_A_FEW_MINUTES'),(12752,'STR_EXPORT_REQUEST_HAS_BEEN_SUBMITTED'),(12753,'STR_EXPORT_ZIP_FILE'),(12754,'STR_FEATURE_NOT_AVAILABLE'),(12755,'STR_FILE_TYPE_NOT_ALLOWED'),(12756,'STR_FILE_UPLOADED_SUCCESSFULLY'),(12757,'STR_FILE_UPLOAD_FAILED'),(12758,'STR_GO_TO_IMPORT_PAGE'),(12759,'STR_NO_EXPORT_FILE_AVAILABLE_FOR_DOWNLOAD_YET'),(12760,'STR_PENDING_EXPORT_REQUESTS'),(12761,'STR_PLEASE_ACTIVATE_THE_ZIP_PHP_EXTENSION_BEFORE_USING_THIS_TOOL'),(12762,'STR_QUICKBOOKS_EXPORT'),(12763,'STR_SUBMIT_EXPORT_REQUEST_TO_QUICKBOOKS_WEB_CONNECTOR'),(12764,'STR_UPLOAD'),(12765,'STR_UPLOAD_AN_EXISTING_EXPORT_ZIP_FILE'),(12766,'STR_ERROR_WORKING_WITH_THIS_ZIP_FILE'),(12767,'STR_PLEASE_ADD_A_BANK_ACCOUNT_FIRST'),(12768,'STR_PLEASE_UPLOAD_AN_EXPORT_FILE_OR_BEGIN_THE_EXPORT_PROCESS_FIRST'),(12769,'STR_THERE_IS_NO_EXPORT_FILE_TO_WORK_WITH'),(12770,'STR_YOUR_QUICKBOOKS_COMPANY_MAY_NOT_CONTAIN_THIS_DATA'),(12771,'STR_EXPORT_QUICKBOOKS_DATA'),(12772,'STR_EXISTING_TRANSACTIONS_UPDATED_SUCCESSFULLY'),(12773,'STR_THIS_STEP_CANNOT_BE_UNDONE'),(12774,'STR_UPDATE_ALL_EXISTING_TRANSACTIONS_WITH_THIS_CURRENCY'),(12775,'STR_CURRENCY_NEW_EDIT'),(12776,'STR_CURRENCY_RATES'),(12777,'STR_NO_RECORDS_MATCHED_CRITERIA'),(12778,'STR_SELECT_A_PART_NUMBER'),(12779,'STR_YOU_WILL_NOW_BE_TAKEN_TO_A_DIFFERENT_SITE_OUTSIDE_OF'),(12780,'STR_MUST_CREATE_SOME_WORK_TYPES_BEFORE_CREATING_PRICE_LISTS'),(12781,'STR_ALTERNATE_PAY_TO_NAME'),(12782,'STR_LEAVE_BLANK_IF_PAY_TO_IS_VENDOR_NAME'),(12783,'STR_NON_NEGOTIABLE'),(12784,'STR_CLICK_TO_VIEW_CHECKS'),(12785,'STR_NOT_NEGOTIABLE'),(12786,'STR_MINUTES_COMPOSITION'),(12787,'STR_MODIFY_PRICE_LISTS_BY_PERCENTAGE'),(12788,'STR_MINUS_ONE_ENTRY_HERE_EQUALS_APPLY_TO_ANY_INKS_ON_SIDE_0NE'),(12789,'STR_MINUS_ONE_ENTRY_HERE_EQUALS_APPLY_TO_ANY_INKS_ON_SIDE_TWO'),(12790,'STR_MULTIPLY_ALL_PRICES_BY_THIS_AMOUNT'),(12791,'STR_ONLY_MULTIPLY_IF_MAX_INKS_SIDE_ONE_THIS_NUMBER'),(12792,'STR_ONLY_MULTIPLY_IF_MAX_INKS_SIDE_TWO_THIS_NUMBER'),(12793,'STR_STOCK_UPDATE_BY_PERCENTAGE'),(12794,'STR_PREPRINTED_ONE_PER_PAGE'),(12795,'STR_PERCENT_TO_ADD_TO_RETURNED_VALUE'),(12796,'STR_ZERO_MEANS_ADD_NOTHING_25_MEANS_ADD_25_PERCENT'),(12797,'STR_PRICE_MULTIPLIER'),(12798,'STR_TOTALLING'),(12799,'STR_ANSWER_X_M_QUANTITY'),(12800,'STR_THIS_FEATURE_IS_NOT_AVAILABLE_FOR_HOSTED_CUSTOMERS'),(12801,'STR_ITEMS_IN_TAXABLE_INCOME_NOT_AFFECTING_CASH'),(12802,'STR_CASH_FLOW_DEFINITION'),(12803,'STR_CASH_FLOW_REPORT'),(12804,'STR_CREATE_CASH_FLOW_REPORT_DEFINITION'),(12805,'STR_ALWAYS_USE_THIS_SIZE'),(12806,'STR_BEGIN_SALES_DATE'),(12807,'STR_INVENTORY_REORDER_POINT_CALCULATION'),(12808,'STR_NUMBER_OF_MONTHS_FOR_MAXIMUM_ON_HAND'),(12809,'STR_NUMBER_OF_MONTHS_FOR_MINIMUM_ON_HAND'),(12810,'STR_NUMBER_OF_MONTHS_FOR_REORDER_QUANTITY'),(12811,'STR_PROCESS_COMPLETE'),(12812,'STR_CUSTOMER_REPORT_OF_SALES_TOTALS'),(12813,'STR_INVENTORY_12_MONTH_CUSTOMER_SALES_HISTORY_FOR'),(12814,'STR_INVENTORY_12_MONTH_UNIT_SALES_HISTORY_FOR'),(12815,'STR_INVENTORY_SALES_12_MONTH'),(12816,'STR_ITEM_REPORT_OF_UNITS_SOLD'),(12817,'STR_CANCEL_OR_REMOVE'),(12818,'STR_ITEM_REMOVE_BY_CATEGORY'),(12819,'STR_MAKE_CHANGES'),(12820,'STR_REMOVE_PHYSICALLY'),(12821,'STR_PO_CHECK_LIST'),(12822,'STR_PO_CHECKLIST_FOR_PO'),(12823,'STR_PRODUCT_NUMBER'),(12824,'STR_QUANTITY_RECEIVED'),(12825,'STR_PRINT_CHECKLIST'),(12826,'STR_12_MONTH_SALES'),(12827,'STR_CALCULATE_ORDER_POINTS'),(12828,'STR_DELETE_ITEMS'),(12829,'STR_DELETE_ITEMS_BY_CATEGORY'),(12830,'STR_TRILLION'),(12831,'STR_YOU_MUST_ENTER_AN_INVOICE_NUMBER'),(12832,'STR_YOU_MUST_ENTER_A_VENDOR_OR_PO_NUMBER'),(12833,'STR_CHANGE_YOUR_PASSWORD'),(12834,'STR_CHECK_SYSTEM_SETTINGS'),(12835,'STR_REVIEW_INVOICE_OPTIONS'),(12836,'STR_LOG_IN'),(12837,'STR_ALLOW_SYSTEM_ADMINISTRATOR_LOGINS'),(12838,'STR_ADD_GL_ACCOUNT_TO_THIS_ITEM'),(12839,'STR_SET_UP_CASH_FLOW_REPORT'),(12840,'STR_FAILED_LOGIN'),(12841,'STR_MINUTES_TO_WAIT'),(12842,'STR_ONE_TIME_FEE'),(12843,'STR_EXPORT_DATA_FROM_QUICKBOOKS'),(12844,'STR_PLEASE_ASSIGN_A_SERVICE_WORKER_CLASS_TO_AT_LEAST_ONE_EMPLOYEE_OR_VENDOR'),(12845,'STR_PLEASE_SET_UP_AT_LEAST_ONE_SERVICE_TYPE_AND_ONE_SERVICE_CLASS'),(12846,'STR_INVOICE_END_NOTES'),(12847,'STR_PO_END_NOTES'),(12848,'STR_SETUP_ADMIN'),(12849,'STR_ADD_ON_MENU_LISTING'),(12850,'STR_BANK_STATEMENT_PRIOR_ENDING_BALANCE'),(12851,'STR_SEE_ATTACHMENT'),(12852,'STR_DICOUNT_DATE_END_OF_MONTH'),(12853,'STR_NET_DUE_DATE_END_OF_MONTH'),(12854,'STR_ADD_CLIENT_BALANCES'),(12855,'STR_ADD_COMPANY_LOGOS'),(12856,'STR_ADD_LABOR_RATES'),(12857,'STR_ADD_LOCATIONS'),(12858,'STR_ADD_SERVICE_CLASSES'),(12859,'STR_ADD_STATUS_LEVELS'),(12860,'STR_ADD_TYPES_OF_SERVICES'),(12861,'STR_BILL_START_BALANCES'),(12862,'STR_CREDIT_CARD_SETUP'),(12863,'STR_GL_BEGINNING_BALANCES'),(12864,'STR_ITEM_PRICE_LEVELS'),(12865,'STR_PAY_BENEFITS'),(12866,'STR_PAY_FACTORS'),(12867,'STR_PRICE_MARKUP_SETS'),(12868,'STR_SET_ADVANCED_OPTIONS'),(12869,'STR_SET_COMPANY_ADDRESS'),(12870,'STR_SET_RETURN_POLICY'),(12871,'STR_SET_SALES_TAXES_1'),(12872,'STR_SET_SALES_TAXES_2'),(12873,'STR_SET_UNIT_NAMES'),(12874,'STR_START_NEW_TAX_YEAR'),(12875,'STR_1099_ADJUST_SIDE_WHEN_PRINTING'),(12876,'STR_1099_ADJUST_TOP_WHEN_PRINTING'),(12877,'STR_INVOICE_TEXT'),(12878,'STR_TEXT_FOR_TOP_CENTER_OF_INVOICE'),(12879,'STR_TEXT_FOR_TOP_LEFT_OF_INVOICE'),(12880,'STR_TEXT_FOR_TOP_RIGHT_OF_INVOICE'),(12881,'STR_TEXT_FOR_UNDER_INVOICE_TOTAL'),(12882,'STR_WEBSITE_TEXT_FOR_BOTTOM_CENTER_OF_INVOICE'),(12883,'STR_FEDERAL_GOVERNMENT'),(12884,'STR_KIND_OF_EMPLOYER'),(12885,'STR_NONE_APPLY'),(12886,'STR_STATE_AND_LOCAL_GOVERNMENT_EMPLOYER'),(12887,'STR_STATE_AND_LOCAL_TAX_EXEMPT_EMPLOYER'),(12888,'STR_TAX_EXEMPT_EMPLOYER'),(12889,'STR_ADDRESS_1'),(12890,'STR_ONLINE_REPORTING_SETUP_PAYROLL'),(12891,'STR_PHONE_EXTENSION'),(12892,'STR_TWO_LETTER'),(12893,'STR_IRS_1099'),(12894,'STR_NO_DATA_SENT'),(12895,'STR_RECORDS_SAVED_SUCCESSFULLY'),(12896,'STR_VENDORS_MUST_HAVE_RECEIVES_1099_OPTION_CHECKED_TO_SHOW_IN_THIS_LIST'),(12897,'STR_VIEW_REPORT_AND_PRINT'),(12898,'STR_EDIT_AND_THEN_SAVE_YOUR_1099_DATA_FIRST'),(12899,'STR_NO_1099_DATA_FOUND'),(12900,'STR_NO_TAX_YEAR_SET'),(12901,'STR_FILE_COLUMN_FORMAT'),(12902,'STR_IMPORT_BOM_DEFINITIONS'),(12903,'STR_IMPORT_FAILED'),(12904,'STR_MASTER_ITEM_CODE'),(12905,'STR_SUB_ITEM_QUANTITY_USED_PER_FINAL_PIECE'),(12906,'STR_IMPORT_BOM_ORDERS'),(12907,'STR_MASTER_QUANTITY_TO_MAKE'),(12908,'STR_SUB_ITEM_QUANTITY_TO_BE_USED'),(12909,'STR_VIEW_SUMMARY'),(12910,'STR_ARE_YOU_SURE_YOU_WANT_TO_FILE_ELECTRONICALLY'),(12911,'STR_CHECK_ELECTRONIC_FILING_STATUS'),(12912,'STR_FILE_ELECTRONICALLY'),(12913,'STR_AN_ERROR_HAS_OCCURRED'),(12914,'STR_ELECTRONIC_FILING_NOT_AVAILABLE_AT_THIS_TIME'),(12915,'STR_FILE_W2_ELECTRONICALLY'),(12916,'STR_YOU_MUST_HAVE_THE_PHP_SOAP_EXTENSION_TO_USE_THIS_FEATURE'),(12917,'STR_DISCOUNT_DATE_END_OF_MONTH'),(12918,'STR_DISCOUNT_DATE_ON_FOLLOWING_MONTH'),(12919,'STR_NET_DAY_OF_MONTH_PROX'),(12920,'STR_RECEIVES_1099'),(12921,'STR_IMPORT_BUILD_ORDERS'),(12922,'STR_INVOICE_TEXT_FOR_SPECIAL_INVOICE_FORM'),(12923,'STR_3DCART_SETUP'),(12924,'STR_STORE_URL'),(12925,'STR_TEXT_FOR_QTY_AND_UNIT_COLUMN_HEAD'),(12926,'STR_3DCART_INTEGRATION'),(12927,'STR_3DCART_ORDER_ID'),(12928,'STR_ADJUST_3DCART_SETTINGS'),(12929,'STR_AN_ERROR_OCCURRED_WHILE_IMPORTING'),(12930,'STR_COULD_NOT_IMPORT_ORDERS'),(12931,'STR_FROM_INVOICE_NUMBER'),(12932,'STR_NO_ORDERS_SELECTED_FOR_IMPORT'),(12933,'STR_NO_ORDERS_WERE_IMPORTED'),(12934,'STR_ONLY_100_ORDERS_CAN_BE_BROUGHT_IN_AT_ONE_TIME'),(12935,'STR_PLEASE_ADJUST_3DCART_SETTINGS_FIRST'),(12936,'STR_PLEASE_VERIFY_YOUR_ORDERS'),(12937,'STR_SET_AN_INVOICE_NUMBER_TO_GET_ORDERS_FROM_THAT_INVOICE_NUMBER_ON'),(12938,'STR_JOB_ENTRY_STATS_LIST'),(12939,'STR_ORDER_ENTRY_PERSON'),(12940,'STR_ORDER_ENTRY_STATS'),(12941,'STR_ADD_EMPLOYEE_TIME_TRACKING'),(12942,'STR_ADD_ORDER_AND_INVENTORY_TRACKING'),(12943,'STR_ADD_PAYROLL_SUITE'),(12944,'STR_UPGRADE_FEATURES'),(12945,'STR_CLOUD_UPGRADE_FEATURES'),(12946,'STR_ADD_MULTICURRENCY'),(12947,'STR_ORDER_ALREADY_IMPORTED_PREVIOUSLY'),(12948,'STR_PLEASE_VERIFY_YOUR_IMPORTED_ORDERS'),(12949,'STR_IMPORT_3DCART_ORDERS'),(12950,'STR_INCLUDE_ONLY_ON_HAND_ITEMS_EVEN_IF_NEGATIVE'),(12951,'STR_CHECK_FOR_FREE_UPDATE'),(12952,'STR_LINUX_FREE_UPDATE'),(12953,'STR_MOST_RECENT_VERSION'),(12954,'STR_WINDOWS_FREE_UPDATE'),(12955,'STR_YOUR_CURRENT_VERSION'),(12956,'STR_YOUR_OPERATING_SYSTEM'),(12957,'STR_YOUR_VERSION_IS_CURRENT'),(12958,'STR_NOLAPRO_UPDATES'),(12959,'STR_DEFAULT_COMMISSION_METHOD'),(12960,'STR_PLEASE_GO_BACK_CLICK_EDIT_TO_VERIFY_YOUR_DATA_AND_THEN_SAVE_FIRST_BEFORE_PRINTING_FORMS'),(12961,'STR_BY_INVOICE_TOTAL_LESS_TAX_AND_SHIPPING'),(12962,'STR_COMMISSIONS_UPDATED_SUCCESSFULLY'),(12963,'STR_COMMISSION_DATE'),(12964,'STR_DO_NOT_PAY'),(12965,'STR_FILTER_BY_STATUS'),(12966,'STR_MARK_THE_COMMISSION_PAID_WHEN_THE_SALES_PERSON_HAS_BEEN_PAID'),(12967,'STR_PAYMENT_HAS_BEEN_RECEIVED_FOR_THE_INVOICE'),(12968,'STR_PER_INVOICED_INVENTORY_ITEM'),(12969,'STR_THE_COMMISSION_RATE_FOR_THE_SALES_PERSON_IS_USED'),(12970,'STR_THE_INVOICE_HAS_NOT_YET_BEEN_PAID'),(12971,'STR_THE_ITEMS_ON_THE_INVOICE_MUST_HAVE_A_COMMISSION_AMOUNT_SET'),(12972,'STR_THIS_COMMISSION_SHOULD_NOT_BE_PAID_AND_IS_NOT_INCLUDED_IN_TOTALS'),(12973,'STR_VIEW_COMMISSIONS'),(12974,'STR_ITEM_FLAT_COMMISSION'),(12975,'STR_ITEM_PERCENT_COMMISSION'),(12976,'STR_GET_UPDATES'),(12977,'STR_UPDATES'),(12978,'STR_BLOCK_GOOGLE_LOGINS'),(12979,'STR_BE_SURE_THE_EMAIL_ADDRESS_ON_YOUR_USER_ACCOUNT_IS_A_VALID_GOOGLE_ACCOUNT'),(12980,'STR_ERROR_LOGGING_IN'),(12981,'STR_GOOGLE_LOGIN_FAILED'),(12982,'STR_BY_DEFAULT_GOOGLE_ACCOUNT_LOGINS_ARE_PERMITTED'),(12983,'STR_THIS_CAN_BE_TURNED_OFF_IN_ADMIN_SETUP_ADMIN_SYSTEM_SETTINGS'),(12984,'STR_HOLD_CONTROL_KEY_TO_SELECT_MULTIPLE_COMPANIES'),(12985,'STR_INCLUDE_WHICH_COMPANIES'),(12986,'STR_ONLY_WORKS_IF_SELECTED_COMPANIES_HAVE_SAME_FISCAL_YEAR'),(12987,'STR_SELECTED_COMPANIES'),(12988,'STR_STANDARD_END_OF_MONTH'),(12989,'STR_VENDOR_CLOSES_MONTH_ON_WHAT_DAY'),(12990,'STR_CATEGORIES_TO_EXPORT'),(12991,'STR_CHOOSE_FIELDS_TO_EXPORT'),(12992,'STR_CUSTOM_FIELDS'),(12993,'STR_EXPORT_2_YEAR_SALES_HISTORY'),(12994,'STR_EXPORT_COSTS'),(12995,'STR_EXPORT_ON_HAND_LEVELS'),(12996,'STR_EXPORT_OPTIONS'),(12997,'STR_EXPORT_PRICING'),(12998,'STR_EXPORT_VENDOR_INFO'),(12999,'STR_FILE_TO_IMPORT_MUST_HAVE_BEEN_CREATED_FROM_AN_EXPORT_MADE_BY_THIS_SAME_TOOL'),(13000,'STR_IMPORT_PRIOR_INVENTORY_EXPORT_FILE'),(13001,'STR_INVENTORY_DATA_IMPORTED_SUCCESSFULLY'),(13002,'STR_INVENTORY_EXPORT_IMPORT_EDIT_TOOL'),(13003,'STR_INVENTORY_LOCATIONS_TO_EXPORT'),(13004,'STR_MODIFIED_EXPORT_FILE'),(13005,'STR_ON_HAND_LEVELS_AND_COSTS_CANNOT_BE_UPDATED_WITH_THIS_TOOL'),(13006,'STR_PLEASE_USE_CAUTION_WITH_THIS_IMPORT_AS_CHANGES_CANNOT_BE_UNDONE'),(13007,'STR_PLEASE_USE_THE_ITEM_COST_ADJUSTMENT_TOOL_TO_UPDATE_COSTS'),(13008,'STR_PLEASE_USE_THE_PHYSICAL_INVENTORY_TOOL_TO_UPDATE_ON_HAND_LEVELS'),(13009,'STR_THE_FILE_IS_NOT_IN_THE_RIGHT_FORMAT'),(13010,'STR_USE_THIS_TOOL_TO_EXPORT_YOUR_INVENTORY_DATA_IN_CSV_FORMAT_MAKE_CHANGES_AND_REIMPORT'),(13011,'STR_YOU_MUST_SUBMIT_A_FILE'),(13012,'STR_FIRST_QTY'),(13013,'STR_LAST_QTY'),(13014,'STR_MID_QTY'),(13015,'STR_NUMBER_STOCK_UNIT_PER_PURCHASE_UNIT'),(13016,'STR_VENDOR_COST'),(13017,'STR_VENDOR_ID'),(13018,'STR_WTD_AVG_COST'),(13019,'STR_WTD_AVG_QTY'),(13020,'STR_YTD_AMT'),(13021,'STR_YTD_QTY'),(13022,'STR_EXPORT_IMPORT_EDIT_TOOL'),(13023,'STR_FULFILLMENT_ORDER_DEFAULT_DAYS_TO_DUE_DATE'),(13024,'STR_HIDE_ITEM_OPTIONS_IN_SHIPPING_AND_INVOICING'),(13025,'STR_SERVICE_ORDER_DEFAULT_DAYS_TO_DUE_DATE'),(13026,'STR_ADD_UPDATE_DIFFERENT_VENDOR'),(13027,'STR_CREATE_POS_INVOICE'),(13028,'STR_ERROR_PROCESSING_EDI_INVOICES'),(13029,'STR_EXPORTED_EDI_ORDERS'),(13030,'STR_EXPORT_EDI_INVOICES'),(13031,'STR_INVOICES_EXPORTED'),(13032,'STR_NO_FILES_CREATED_AT_THIS_TIME'),(13033,'STR_DISABLED'),(13034,'STR_DISABLE_ADD_ON'),(13035,'STR_REACTIVATE_ADD_ON'),(13036,'STR_VIEW_ACCOUNT_BALANCES'),(13037,'STR_ERROR_PROCESSING_EDI_ORDERS'),(13038,'STR_IMPORT_EDI_ORDERS'),(13039,'STR_NEW_EDI_ORDERS'),(13040,'STR_NO_FILES_TO_READ_IN_AT_THIS_TIME'),(13041,'STR_THE_ORDER_FILE_IS_NOT_IN_THE_CORRECT_FORMAT'),(13042,'STR_LEAVE_THE_TOP_TWO_ROWS_FROM_THE_EXPORT_FILE_AS_IS'),(13043,'STR_PROCESS_STAGES_BARCODE_LIST'),(13044,'STR_BARCODE_INPUT_VIEW'),(13045,'STR_INVALID_STAGE_ENTERED'),(13046,'STR_NEW_STAGE_ID'),(13047,'STR_PLEASE_ENTER_AN_ORDER_NUMBER'),(13048,'STR_PLEASE_ENTER_A_STAGE_ID'),(13049,'STR_SCAN_BARCODE'),(13050,'STR_STANDARD_INPUT_VIEW'),(13051,'STR_VIEW_STAGE_BARCODE_LIST'),(13052,'STR_EDIT_EXISTING_ACCOUNT'),(13053,'STR_THIS_ADD_ON_HAS_BEEN_DISABLED'),(13054,'STR_IN_THOUSANDS'),(13055,'STR_IF_YOU_ARE_NOT_AUTOMATICALLY_LOGGED_OUT_IN_A_FEW_SECONDS_PLEASE_LOG_OUT_AND_BACK_IN'),(13056,'STR_NO_SETUP_NEEDED_IN_THIS_AREA'),(13057,'STR_HIDE_PAGE_NUMBERS'),(13058,'STR_NO_EXTRA_QTY_DISPLAYED'),(13059,'STR_SHOW_CUSTOMER_SIGNATURE_LINE'),(13060,'STR_SHOW_DISCOUNTS_ON_FORM'),(13061,'STR_SHOW_END_NOTES_ON_MAIN_INVOICE'),(13062,'STR_TEXT_FOR_UNDER_STATEMENT_PAGE_NUMBER'),(13063,'STR_FINANCE_PERCENT'),(13064,'STR_GL_FOR_FEE'),(13065,'STR_YOU_MUST_ENTER_A_GL_ACCOUNT_FOR_THE_FEE'),(13066,'STR_FEE'),(13067,'STR_FINANCE_AMOUNT'),(13068,'STR_FINANCE_CHARGE'),(13069,'STR_INV'),(13070,'STR_ERROR_PROCESSING_EDI_SHIPMENTS'),(13071,'STR_EXPORTED_EDI_SHIPMENTS'),(13072,'STR_EXPORT_EDI_ASN'),(13073,'STR_SHIPMENTS_EXPORTED'),(13074,'STR_EXPORTED_EDI_INVOICES'),(13075,'STR_NOTES_TO_PRINT_ON_FOLLOWING_PAGES'),(13076,'STR_FINANCE_CHARGE_FOR_PAYMENT'),(13077,'STR_BILL_AMOUNT'),(13078,'STR_BILL_INVOICE'),(13079,'STR_INVOICES_FROM'),(13080,'STR_SUBMIT_TIME'),(13081,'STR_TCA_INVOICE_REPORT'),(13082,'STR_CANNOT_CHANGE_POS_PRICES'),(13083,'STR_ACCOUNT_OPEN_DATE'),(13084,'STR_CUSTOMER_SIGNATURE'),(13085,'STR_REP_NAME'),(13086,'STR_REP_SIGNATURE'),(13087,'STR_TAX_NUMBER'),(13088,'STR_CAN_ONLY_VIEW_EDIT_TAB_ON_CUSTOMER_PAGE'),(13089,'STR_HELP11_DESCR'),(13090,'STR_HELP11_TITLE'),(13091,'STR_HELP12_DESCR'),(13092,'STR_HELP12_TITLE'),(13093,'STR_A4'),(13094,'STR_DEFAULT_ITEM_COSTS_TO_VENDOR_PRICING'),(13095,'STR_INVOICE_AND_STATEMENT_PAPER_SIZE'),(13096,'STR_LETTER'),(13097,'STR_DATE_LAST_YEAR'),(13098,'STR_DATE_THIS_YEAR'),(13099,'STR_NEW_YEAR'),(13100,'STR_TYPICAL_DATES'),(13101,'STR_UPDATE_UNSUCCESSFUL'),(13102,'STR_DEFAULT_FROM_FOR_SHIP_DOCUMENTS_IS_OUR_COMPANY'),(13103,'STR_TYPICAL_DATES_USE_WITH_WORK_TYPE'),(13104,'STR_UNCHECKED_SHIPS_FROM_ORDERBY_CUSTOMER'),(13105,'STR_VAT_NO'),(13106,'STR_CANNOT_SHIP_MORE_THAN_ALLOWED'),(13107,'STR_THERE_IS_NOT_ENOUGH_INVENTORY_AVAILABLE'),(13108,'STR_DISCOUNTED_TOTAL'),(13109,'STR_BILL_TO_CUSTOMER_NOT_FOUND'),(13110,'STR_BILL_TO_LOOKUP'),(13111,'STR_BILL_TO_NAME'),(13112,'STR_DATE_ORDER_RECEIVED'),(13113,'STR_ERROR_DURING_CREATION_OF_SHIP_RECORDS'),(13114,'STR_PREFERRED_SHIPDATE'),(13115,'STR_PRINT_DATE'),(13116,'STR_SHIPAFTER'),(13117,'STR_SHIPBEFORE'),(13118,'STR_ATTACH_FILE'),(13119,'STR_ANSWER_X_ORDER_TOTAL_DIVIDED_BY_100'),(13120,'STR_INVOICE_NUMBER_POSTFIX'),(13121,'STR_INVOICE_NUMBER_PREFIX'),(13122,'STR_INVOICE_PADDING'),(13123,'STR_NEXT_ORDER_NUMBER'),(13124,'STR_NEXT_RECEIPT_NUMBER'),(13125,'STR_ORDER_NUMBER_POSTFIX'),(13126,'STR_ORDER_NUMBER_PREFIX'),(13127,'STR_ORDER_PADDING'),(13128,'STR_RECEIPT_NUMBER_POSTFIX'),(13129,'STR_RECEIPT_NUMBER_PREFIX'),(13130,'STR_RECEIPT_PADDING'),(13131,'STR_TEXT_TO_APPEAR_AFTER_INVOICE_NUMBER'),(13132,'STR_TEXT_TO_APPEAR_AFTER_ORDER_NUMBER'),(13133,'STR_TEXT_TO_APPEAR_AFTER_RECEIPT_NUMBER'),(13134,'STR_TEXT_TO_APPEAR_BEFORE_INVOICE_NUMBER'),(13135,'STR_TEXT_TO_APPEAR_BEFORE_ORDER_NUMBER'),(13136,'STR_TEXT_TO_APPEAR_BEFORE_RECEIPT_NUMBER'),(13137,'STR_USER_SEQUENCES_FOR_THIS_COMPANY'),(13138,'STR_VIEW_DATA'),(13139,'STR_FILE_941_ELECTRONICALLY'),(13140,'STR_NOT_ALLOWED_TO_CHANGE_SALESPERSON_ON_ORDERS'),(13141,'STR_TYPICAL_DATES_LIST'),(13142,'STR_NUMBER_LISTS'),(13143,'STR_CANNOT_PLACE_ORDERS_IF_NO_STOCK_AVAILABLE'),(13144,'STR_ART'),(13145,'STR_DEFAULT_ORDER_NOTE'),(13146,'STR_ELECTRONIC_PAYROLL_FILING_SETUP'),(13147,'STR_QUANTITY_REMAINING'),(13148,'STR_MARK_UNCONFIRMED'),(13149,'STR_PURGE_FULFILLMENT_ORDERS_HOW'),(13150,'STR_PURGE_FULFILLMENT_ORDERS_IF_OPEN_THIS_MANY_DAYS_OR_MORE'),(13151,'STR_ARE_YOU_SURE_YOU_WANT_TO_PURGE_THESE_ORDERS'),(13152,'STR_DAYS_OPEN_TO_PURGE'),(13153,'STR_GET_LIST_OF_ORDERS'),(13154,'STR_ORDERS_PURGED_SUCCESSFULLY'),(13155,'STR_PURGE'),(13156,'STR_PURGE_HOW'),(13157,'STR_PURGE_OPEN_FULFILLMENT_ORDERS'),(13158,'STR_PURGE_ORDERS'),(13159,'STR_SHIPPING_BLOCKED'),(13160,'STR_ART_NUMBER'),(13161,'STR_IS_RUSH_ORDER'),(13162,'STR_ORDER_TAKEN_BY'),(13163,'STR_ORDER_YEAR'),(13164,'STR_PREFERRED_SHIP_DATE'),(13165,'STR_PROBLEM_ORDER'),(13166,'STR_SHIP_AFTER'),(13167,'STR_SHIP_BEFORE'),(13168,'STR_IF_TEXT_IS_SELECTED_ABOVE_MAXIMUM_NUMBER_OF_CHARACTERS_ALLOWED'),(13169,'STR_ADD_ITEM_TO_LIST'),(13170,'STR_PLEASE_ADD_A_RIGHTS_GROUP_FIRST_THEN_COME_BACK'),(13171,'STR_PLEASE_ADD_A_USER_FIRST_THEN_COME_BACK'),(13172,'STR_PLEASE_SELECT_AN_OPTION_BELOW'),(13173,'STR_SELECT_USER'),(13174,'STR_SET_RIGHTS_FOR_A_GROUP'),(13175,'STR_SET_RIGHTS_FOR_A_SINGLE_USER'),(13176,'STR_SHIPPING_RIGHTS_UPDATED_SUCCESSFULLY'),(13177,'STR_THIS_GROUP_CANNOT_SHIP_ITEMS_FROM_THE_FOLLOWING_CATEGORIES'),(13178,'STR_THIS_USER_CANNOT_SHIP_ITEMS_FROM_THE_FOLLOWING_CATEGORIES'),(13179,'STR_THIS_USER_CANNOT_SHIP_THE_FOLLOWING_INDIVIDUAL_ITEMS'),(13180,'STR_USER_SHIPPING_RIGHTS'),(13181,'STR_YOU_MUST_HAVE_ADVANCED_USERS_RIGHTS_TO_SET_GROUP_RIGHTS'),(13182,'STR_PURGE_FULFILLMENT_ORDERS'),(13183,'STR_TBD'),(13184,'STR_BRUTE_PWD_RESET_LOCKOUT'),(13185,'STR_PASSWORD_RESET_EMAIL'),(13186,'STR_PASSWORD_RESET_EMAIL_FAILED'),(13187,'STR_PASSWORD_TOO_SHORT'),(13188,'STR_PASSWORD_RESET_EMAIL_MESSAGE'),(13189,'STR_ADDITIONAL_CHARGE_PER_EACH'),(13190,'STR_ADDL_CHARGE_PER_ORDER'),(13191,'STR_COLOR_NAME'),(13192,'STR_COVER_COLORS'),(13193,'STR_CUSTOM_INSIDE_COLORS'),(13194,'STR_CUSTOM_OUTSIDE_COLORS'),(13195,'STR_DELETE_THIS_ROW'),(13196,'STR_INSIDE_COVERS'),(13197,'STR_OUTSIDE_COVERS'),(13198,'STR_ADD_CHARGE_PER_PIECE'),(13199,'STR_TYPE_OF_SPECIALS'),(13200,'STR_FINANCE_FLAT_FEE'),(13201,'STR_APPROVED_DATE'),(13202,'STR_APPROVE_AMOUNTS'),(13203,'STR_CASH_ACTUAL'),(13204,'STR_CASH_AMOUNT_RECEIVED_FROM_USER'),(13205,'STR_CASH_DIFFERENCE'),(13206,'STR_CC_ACTUAL'),(13207,'STR_CC_AMOUNT_REPORTED_BY_USER'),(13208,'STR_CC_DIFFERENCE'),(13209,'STR_CHECK_ACTUAL'),(13210,'STR_CHECK_AMOUNT_RECEIVED_FROM_USER'),(13211,'STR_CHECK_DIFFERENCE'),(13212,'STR_COLLECTED_BY'),(13213,'STR_COLLECT_PAYMENTS'),(13214,'STR_OTHER_ACTUAL'),(13215,'STR_OTHER_AMOUNT_REPORTED_BY_USER'),(13216,'STR_OTHER_DIFFERENCE'),(13217,'STR_PLEASE_SELECT_A_PAYMENT_DATE'),(13218,'STR_PLEASE_SELECT_A_USER'),(13219,'STR_USER_PAYMENT_COLLECTION'),(13220,'STR_VIEW_PRIOR_PAYMENTS_COLLECTED'),(13221,'STR_CLONE_ORDER'),(13222,'STR_ORDER_CLONED_SUCCESSFULLY'),(13223,'STR_QUOTE_CLONED_SUCCESSFULLY'),(13224,'STR_ARE_YOU_SURE_YOU_WANT_TO_CLONE_THIS'),(13225,'STR_CLONE'),(13226,'STR_SHIP_LATER'),(13227,'STR_SHIP_XX_DAYS_AFTER_APPROVAL'),(13228,'STR_COPY_TO_OTHER'),(13229,'STR_COVER_NUMBER'),(13230,'STR_CUSTOM_COLOR_1_NAME'),(13231,'STR_CUSTOM_COLOR_2_NAME'),(13232,'STR_ENTER_SPECIALS'),(13233,'STR_ERROR_DURING_SAVE_RETURN_TO_ORDER'),(13234,'STR_INSIDE_DESIGN_NR'),(13235,'STR_NO_COVER'),(13236,'STR_NO_WINDOW'),(13237,'STR_OUTSIDE_DESIGN_NR'),(13238,'STR_PERMIT_NR'),(13239,'STR_QUANTITY_OF_BOOKS_IN_FINAL_SET_CANNOT_BE_ZERO'),(13240,'STR_RETURN_TO_EDIT'),(13241,'STR_RETURN_TO_ORDER_ENTRY'),(13242,'STR_SPECIALS_ENTRY'),(13243,'STR_AFTER_REGULAR_SUNDAY'),(13244,'STR_BEFORE_REGULAR_SUNDAY'),(13245,'STR_CUSTOM_DESCRIPTION'),(13246,'STR_DATE_SELECTION'),(13247,'STR_DESIGN_NR'),(13248,'STR_FIRST_SUNDAY'),(13249,'STR_FOURTH_SUNDAY'),(13250,'STR_INK_DATE'),(13251,'STR_LAST_SUNDAY'),(13252,'STR_NO_REPEAT'),(13253,'STR_PLACEMENT'),(13254,'STR_REMOVE_LINE'),(13255,'STR_REPEATS'),(13256,'STR_SECOND_SUNDAY'),(13257,'STR_SEQUENCE'),(13258,'STR_SPECIFIC_DAY_OF_MONTH'),(13259,'STR_THIRD_SUNDAY'),(13260,'STR_DISABLE'),(13261,'STR_ERROR_ADDING_TRANSACTION_FOR_VOUCHER'),(13262,'STR_GL_TRANSACTION_FILE_COLUMN_FORMAT'),(13263,'STR_IF_CREDIT_AMOUNT_SHOULD_BE_NEGATIVE'),(13264,'STR_IMPORT_GL_TRANSACTIONS'),(13265,'STR_NOT_AVAILABLE'),(13266,'STR_SUM_OF_DEBITS_AND_CREDIT_NOT_EQUAL'),(13267,'STR_UPLOAD_SUCCESSFUL'),(13268,'STR_VOUCHER_NAME'),(13269,'STR_MARKDOWN'),(13270,'STR_MARKDOWN_BASED_ON'),(13271,'STR_MARKDOWN_PERCENT'),(13272,'STR_NO_PRICE_LEVELS_AVAILABLE'),(13273,'STR_CLONE_QUOTE'),(13274,'STR_MAXIMUM_SALES_MARGIN_ALLOWED'),(13275,'STR_MINIMUM_SALES_MARGIN_ALLOWED'),(13276,'STR_DEFAULT_NO_CREDIT_ALLOWED_NOTE'),(13277,'STR_NEW_CUSTOMERS_DEFAULT_TO_NO_CREDIT_ALLOWED'),(13278,'STR_LOOK_AT_QUANTITY_AVAILABLE'),(13279,'STR_LOOK_AT_QUANTITY_ON_HAND'),(13280,'STR_WHEN_BLOCKING_ORDERS_FOR_NO_STOCK'),(13281,'STR_PERMANENTLY_HIDE_SIDEBAR'),(13282,'STR_CUSTOMER_PAYMENT'),(13283,'STR_DIRECT_GL_PAYMENT'),(13284,'STR_DO_NOT_APPLY_PAYMENT_TO_EXISTING_INVOICES'),(13285,'STR_GL_PAYMENT'),(13286,'STR_PLEASE_ENTER_A_CUSTOMER'),(13287,'STR_PLEASE_ENTER_A_GL_ACCOUNT'),(13288,'STR_PLEASE_ENTER_A_VENDOR'),(13289,'STR_VENDOR_PAYMENT'),(13290,'STR_IF_PAID_BY'),(13291,'STR_ORDER_ADD_ONS'),(13292,'STR_ADJUST_SINGLE_ITEM'),(13293,'STR_AGAINST_ITEMS_RECEIVED_ON_PO'),(13294,'STR_APPLY_TOTAL_FROM_AP_BILL'),(13295,'STR_AP_BILL'),(13296,'STR_AP_BILL_ADJUSTMENT'),(13297,'STR_COST_ADJUSTMENT'),(13298,'STR_COST_AND_COST_OFFSET_MUST_SUM_TO_0'),(13299,'STR_COST_CANNOT_BE_0'),(13300,'STR_COST_OFFSET'),(13301,'STR_NO_GL_ACCOUNT_SET'),(13302,'STR_NO_RECEIPTS_FOUND_FOR_THIS_PO'),(13303,'STR_OR_A_BILL_AND_PO_MUST_BE_SELECTED'),(13304,'STR_YOU_MUST_ENTER_THE_NUMBER_OF_ITEMS_AFFECTED_IF_A_COST_IS_SET'),(13305,'STR_ALSO_VIEW_STOCK_FROM'),(13306,'STR_PRINT_BARCODE'),(13307,'STR_ARE_YOU_SURE_YOU_WANT_TO_CONVERT_THIS_ORDER_TO_A_QUOTE'),(13308,'STR_CONVERT_TO_QUOTE'),(13309,'STR_DEFAULT_BANK_ACCOUNT'),(13310,'STR_COST_PER_COVER_WHEN_BLACK_IN_AND_OUT'),(13311,'STR_COST_PER_COVER_WHEN_COLOR_INSIDE_BLACK_OUTSIDE'),(13312,'STR_COST_PER_COVER_WHEN_COLOR_IN_AND_OUT'),(13313,'STR_COST_PER_COVER_WHEN_COLOR_OUTSIDE_BLACK_INSIDE'),(13314,'STR_COST_PER_EACH_WHEN_NO_COVER'),(13315,'STR_ORDER_RECEIVED_METHODS'),(13316,'STR_HIDE_FROM_DROP_DOWN'),(13317,'STR_SALES_CAMPAIGNS'),(13318,'STR_ORDER_RECEIVED_HOW'),(13319,'STR_SALES_CAMPAIGN'),(13320,'STR_SPECIALS'),(13321,'STR_DISTRIBUTION_FREQUENCY_NOT_SELECTED'),(13322,'STR_INHOUSE_OR'),(13323,'STR_EXCLUDE_DATE_FROM_MAIN'),(13324,'STR_MISSING_OR_INVALID_BEGIN_OR_END_DATE'),(13325,'STR_QUANTITY_PREVIOUSLY_RECEIVED'),(13326,'STR_SIGNUP'),(13327,'STR_30_DAYS_FREE'),(13328,'STR_AGREE_TO_TERMS_OF_SERVICE'),(13329,'STR_CREATE_A_HOSTED_ACCOUNT'),(13330,'STR_CREATE_MY_SITE'),(13331,'STR_DIFFERENT_IMAGE'),(13332,'STR_INPUT_THE_BOLD_SECURITY_IMAGE_TEXT'),(13333,'STR_I_HAVE_READ_AND_AGREE_TO_THE_TERMS_OF_SERVICE'),(13334,'STR_LOADING'),(13335,'STR_ONLY_LETTERS_AND_NUMBERS_MAXIMUM_OF_16'),(13336,'STR_PER_MONTH'),(13337,'STR_PER_QUARTER'),(13338,'STR_PER_YEAR'),(13339,'STR_PLEASE_DO_NOT_REFRESH_THE_PAGE'),(13340,'STR_SUBSCRIPTION_TYPE'),(13341,'STR_PLEASE_ENTER_A_COMPANY_NAME'),(13342,'STR_PLEASE_ENTER_THE_SECURITY_IMAGE_CODE'),(13343,'STR_PLEASE_ENTER_YOUR_EMAIL'),(13344,'STR_PLEASE_ENTER_YOUR_FIRST_NAME'),(13345,'STR_PLEASE_ENTER_YOUR_LAST_NAME'),(13346,'STR_PLEASE_LOG_IN_WITH_THE_USERNAME_ADMIN_AND_THE_PASSWORD_YOU_JUST_CREATED'),(13347,'STR_THE_SECURITY_CODE_ENTERED_WAS_INCORRECT'),(13348,'STR_THIS_SITE_NAME_IS_NOT_ALLOWED'),(13349,'STR_YOUR_HOSTED_SITE_HAS_BEEN_CREATED_SUCCESSFULLY'),(13350,'STR_YOU_MUST_ENTER_A_PASSWORD_AND_THE_PASSWORD_AND_PASSWORD_CONFIRMATION_BOXES_MUST_MATCH'),(13351,'STR_YOU_MUST_HAVE_AT_LEAST_ONE_LETTER_IN_THE_SITE_NAME'),(13352,'STR_SECURITY_IMAGE'),(13353,'STR_OVERRIDE_PRICE'),(13354,'STR_IF_VIRTUAL_INK'),(13355,'STR_NUMBER_OF_ACTUAL_INKS_REPRESENTED'),(13356,'STR_FULFILLMENT_ORDERS_POS_ORDERS_AND_SHIPMENTS'),(13357,'STR_IF_NO_STOCK_BLOCK'),(13358,'STR_POS_ORDERS_AND_SHIPMENTS'),(13359,'STR_BOX_AND_FROM_TO_SEPARATE'),(13360,'STR_BOX_LABEL_FORMAT'),(13361,'STR_MESSAGE_IF_WEIGHT_OVER_MAX'),(13362,'STR_WEIGHT_OVER_DISPLAY_MESSAGE'),(13363,'STR_CREATE_NEW_CREDIT'),(13364,'STR_PLEASE_ENTER_A_PAY_TO'),(13365,'STR_REFERENCE_NUMBER'),(13366,'STR_REFUND_METHOD'),(13367,'STR_USE_EXISTING_CREDIT'),(13368,'STR_INCLUDES_COMPOSITIION'),(13369,'STR_INCLUDES_DISCOUNT_PERCENT'),(13370,'STR_INCLUDES_RUSH_CHARGE'),(13371,'STR_REMOVE_WEEKLY_ENVELOPE'),(13372,'STR_AFTER_APPROVAL'),(13373,'STR_DETAILS_FOR_JOB'),(13374,'STR_PREMIUM_SPECIALS'),(13375,'STR_IF_TEXT_USE_MONOSPACE_FONT_FOR_INPUT'),(13376,'STR_LABEL_TYPE'),(13377,'STR_LOCAL_SHIPMENT_LABEL'),(13378,'STR_NAME_OF_FORM'),(13379,'STR_NUMBERING'),(13380,'STR_STANDARD_LABEL'),(13381,'STR_SPECIALS_CHARGES'),(13382,'STR_PRINT_ALL_LABELS_FOR_ORDER'),(13383,'STR_CURRENCY_CODE'),(13384,'STR_BE_SURE_ITEM_IS_SET_UP_FOR_THIS_LOCATION'),(13385,'STR_CANNOT_TRANSFER_SAME_ITEM_TO_SAME_LOCATION'),(13386,'STR_FROM_INVENTORY_LOCATION'),(13387,'STR_NO_LOCATIONS_FOUND'),(13388,'STR_NUMBER_OF_TO_UNITS_PER_FROM_UNIT'),(13389,'STR_TO_INVENTORY_LOCATION'),(13390,'STR_TRANSFER_SETUP'),(13391,'STR_UNIT_CONVERSION'),(13392,'STR_VIEW_TRANSFER_REPORT'),(13393,'STR_CREATE_RETURN_PO'),(13394,'STR_DIRECTIVE'),(13395,'STR_NOTHING_RECEIVED'),(13396,'STR_NO_ITEMS_SELECTED_TO_RETURN'),(13397,'STR_PLEASE_SELECT_A_PO'),(13398,'STR_PREVIOUS_RETURN_POS'),(13399,'STR_QTY_PREVIOUSLY_RETURNED'),(13400,'STR_QTY_TO_RETURN'),(13401,'STR_REPLACEMENT'),(13402,'STR_RETURN_AND_REQUEST_CREDIT'),(13403,'STR_RETURN_AND_REQUEST_REPLACEMENT'),(13404,'STR_RETURN_PO_CREATED_SUCCESSFULLY'),(13405,'STR_RETURN_RECEIVED_PO'),(13406,'STR_ITEM_TRANSFER_REPORT'),(13407,'STR_PREPRINTED_CHECK_STOCK_STYLE5'),(13408,'STR_PREPRINTED_CHECK_STOCK_STYLE6'),(13409,'STR_ALL_BANK_ACCOUNTS'),(13410,'STR_BANK_ACCOUNTS_ALLOWED'),(13411,'STR_TYPE_OF_SPECIAL'),(13412,'STR_BOOK_PRICE_DETAIL'),(13413,'STR_ESTIMATED_SHIP'),(13414,'STR_REGULAR_ENVELOPES'),(13415,'STR_AMOUNT_X_ORDER_TOTAL_DIVIDED_BY_100'),(13416,'STR_UPDATE_VENDOR_PRICES_AT_PO_TO_AP'),(13417,'STR_DEFAULT_QUOTE_PRINTOUT_NOTE'),(13418,'STR_HIDE_LINE_ITEM_TOTAL_ON_QUOTES'),(13419,'STR_COVER_SCRAP_PERCENT'),(13420,'STR_MAX_SHEETS_SCRAP_COVER'),(13421,'STR_CHECK_FOR_UPDATES'),(13422,'STR_VIEW_BILL'),(13423,'STR_VENDOR_ACTIVITY_HISTORY'),(13424,'STR_HIDE_EXISTING_INVOICES'),(13425,'STR_ONLY_PAID_INVOICES_CAN_HAVE_A_CREDIT_MEMO_CREATED'),(13426,'STR_TO_RETURN_STOCK_FOR_UNPAID_INVOICES_UNPOST_AND_DELETE_THE_INVOICE_AFTER_CLICKING_THE_EDIT_BUTTON'),(13427,'STR_CANNOT_DELETE_ORDER_ORDER_HAS_BEEN_SHIPPED_BILLED_CANCELED_OR_NOT_FOUND'),(13428,'STR_DELETE_QUOTES'),(13429,'STR_NO_QUOTES_WERE_SELECTED'),(13430,'STR_QUOTES_DELETED_SUCCESSFULLY'),(13431,'STR_DELETE_SELECTED_QUOTES'),(13432,'STR_SELECT_DESELECT_ALL_FOR_DELETION'),(13433,'STR_CUSTOMER_SERVICE_REP'),(13434,'STR_GENERATED'),(13435,'STR_BACK_TO_SHIPPING'),(13436,'STR_COVER'),(13437,'STR_CUSTOM_DESIGN'),(13438,'STR_DETAILS_FOR_QUOTE'),(13439,'STR_IMMEDIATELY_AND_REFER_TO_THE_ABOVE_QUOTE_NUMBER'),(13440,'STR_INHOUSE_DESIGN'),(13441,'STR_INSIDE_COLOR'),(13442,'STR_OUTSIDE_COLOR'),(13443,'STR_THE_FOLLOWING_IS_A_DESCRIPTION_OF_YOUR_QUOTE'),(13444,'STR_SHIP_NOTE'),(13445,'STR_EXPORT_PRINT_FILE'),(13446,'STR_BOOK_DETAIL'),(13447,'STR_COVER_IMPRESSIONS'),(13448,'STR_DESCRIPTION_OF_ORDER'),(13449,'STR_ORDER_TAKER'),(13450,'STR_NO_CHARGE_FOR_INKS_THIS_PRICELIST'),(13451,'STR_CUSTOMER_INVOICE'),(13452,'STR_MANUAL_GL_ENTRY'),(13453,'STR_BACK_DATING_TRANSACTIONS_IS_NOT_ALLOWED'),(13454,'STR_EXPENSE_REPORT'),(13455,'STR_EXPENSE_REPORT_FOR'),(13456,'STR_NUM'),(13457,'STR_TOTAL_FOR_EXPENSES_VOID'),(13458,'STR_VOIDS'),(13459,'STR_COST_CODES'),(13460,'STR_VIEW_LIST'),(13461,'STR_ERROR_UPDATING_VENDOR_QUANTITY_PRICING'),(13462,'STR_FROM_TO'),(13463,'STR_ON_HAND_AFTER'),(13464,'STR_PREVIOUS_ON_HAND'),(13465,'STR_FILES_ARE_READY_TO_IMPORT'),(13466,'STR_IMPORT_A_QUICKBOOKS_FILE_ABOVE_OR_USE_THE_MANUAL_EXPORT_PROCESS_BY_CLICKING_THIS_LINK'),(13467,'STR_IMPORT_FROM_ANOTHER_QBW'),(13468,'STR_IMPORT_FROM_QBW'),(13469,'STR_PLEASE_ACTIVATE_THE_CURL_EXTENSION_BEFORE_CONVERTING_FROM_QBW'),(13470,'STR_QUICKBOOKS_MANUAL_EXPORT'),(13471,'STR_SENDING'),(13472,'STR_THE_CONVERSION_PROCESS_MAY_TAKE_SEVERAL_MINUTES_TO_COMPLETE'),(13473,'STR_YOUR_QUICKBOOKS_COMPANY_FILE_WILL_BE_REMOVED_FROM_OUR_SERVERS_IMMEDIATELY_AFTER_CONVERSION'),(13474,'STR_GENERAL_LEDGER_EXPENSE_REPORT'),(13475,'STR_CANNOT_BACKDATE_AR_AP_TRANSACTIONS_OR_POST_TO_PRIOR_PERIODS'),(13476,'STR_CANNOT_CHANGE_CUSTOMER_CREDIT_SETTINGS'),(13477,'STR_DEFAULT_AUTOCOMPLETE_DELAY_IN_MILLISECONDS'),(13478,'STR_BACKDATING_TRANSACTIONS_IS_NOT_ALLOWED'),(13479,'STR_DEFAULT_COST_CODE'),(13480,'STR_DOWNLOAD_PDF'),(13481,'STR_PLEASE_WAIT_WHILE_YOUR_PDF_IS_PREPARED'),(13482,'STR_YOUR_PDF_IS_BEING_PREPARED'),(13483,'STR_DEFAULT_INTERCOMPANY_TRANSFER_OFFSET_ACCOUNT'),(13484,'STR_MARGIN'),(13485,'STR_ORDER_IS_OUTSIDE_MARGIN_RANGE'),(13486,'STR_SHIP_AMOUNT'),(13487,'STR_ALLOW_INVOICING'),(13488,'STR_ALLOW_INVOICING_FOR_SELECTED_ORDERS'),(13489,'STR_MARGIN_EXCEPTION_REPORT'),(13490,'STR_ONLY_SHIPPED_ITEMS_ARE_INCLUDED'),(13491,'STR_ORDERS_MARKED_SUCCESSFULLY'),(13492,'STR_ORDERS_OUTSIDE_THE_MARGIN_RANGE'),(13493,'STR_ORDERS_WITH_DEPOSITS_ALREADY_ARE_NOT_INCLUDED'),(13494,'STR_VALUE_OF_ALL_SHIPMENTS'),(13495,'STR_COLOR_BORDER_FILE'),(13496,'STR_SPECIAL_DESIGN_FILE'),(13497,'STR_STANDARD_FILE'),(13498,'STR_TO_OPEN'),(13499,'STR_ADD_ITEM_TO_TRANSFER'),(13500,'STR_DEFAULT_FROM_COMPANY'),(13501,'STR_DEFAULT_FROM_INVENTORY_LOCATION'),(13502,'STR_DEFAULT_TO_COMPANY'),(13503,'STR_DEFAULT_TO_INVENTORY_LOCATION'),(13504,'STR_FROM_AVAILABLE'),(13505,'STR_FROM_COMPANY'),(13506,'STR_FROM_ON_HAND'),(13507,'STR_INTERCOMPANY_ITEM_TRANSFERS'),(13508,'STR_ITEM_DOES_NOT_EXIST_AT_THIS_LOCATION'),(13509,'STR_ITEM_NOT_AT_THIS_LOCATION'),(13510,'STR_LAST_POST_DATE'),(13511,'STR_LINES_TRANSFERRED'),(13512,'STR_NO_TRANSFERS_HAVE_BEEN_CREATED'),(13513,'STR_PLEASE_MAKE_SURE_ALL_COMPANIES_HAVE_SOMETHING_ENTERED_FOR_THE_FOLLOWING_ACCOUNT_IN_INVENTORY_GENERAL_SETUP'),(13514,'STR_PRIOR_TRANSFERS'),(13515,'STR_SELECT_TRANSFER'),(13516,'STR_TRANSFER_LIST'),(13517,'STR_TRANSFER_TITLE'),(13518,'STR_TRANSFER_UPDATED_SUCCESSFULLY'),(13519,'STR_CANNOT_PERFORM_INTERCOMPANY_ITEM_TRANSFERS'),(13520,'STR_BACKING_UP_INSTALLATION_THIS_MAY_TAKE_A_FEW_MOMENTS'),(13521,'STR_BACKUP_COMPLETE'),(13522,'STR_CLICK_HERE_TO_TRY_AGAIN'),(13523,'STR_CONNECTION_FAILED_TRY_AGAIN'),(13524,'STR_DIRECTORY_WRITE_FAILED'),(13525,'STR_DOWNLOADING_FILES_THIS_MAY_TAKE_A_FEW_MOMENTS'),(13526,'STR_DOWNLOAD_COMPLETE'),(13527,'STR_DOWNLOAD_FAILED'),(13528,'STR_DOWNLOAD_ITEM_IMPORT_HEADER_FILE'),(13529,'STR_DO_NOT_IMPORT_WITH_HEADER_ROW_PRESENT'),(13530,'STR_EXTRACTING_FILES'),(13531,'STR_EXTRACT_COMPLETE'),(13532,'STR_FAILED_TO_READ_ZIP_FILE'),(13533,'STR_GROSS_PROFIT_PER'),(13534,'STR_GROSS_PROFIT_YTD'),(13535,'STR_HTACCESS_WRITE_FAILED'),(13536,'STR_INDEX_WRITE_FAILED'),(13537,'STR_IN_ZIP_WRITE_FAILED'),(13538,'STR_I_AUTHORIZE_NOLAPRO_TO_CHARGE_MY_PAYMENT_METHOD_ON_FILE_FOR_THIS_TRANSACTION'),(13539,'STR_MULTIPLY'),(13540,'STR_MULTIPLY_ALL_QUANTITIES_BY'),(13541,'STR_NET_INCOME_PER'),(13542,'STR_NET_INCOME_YTD'),(13543,'STR_OPERATING_PROFIT_PER'),(13544,'STR_OPERATING_PROFIT_YTD'),(13545,'STR_PLEASE_755_CHMOD'),(13546,'STR_PLEASE_CHMOD_THESE_FILE_TO_777'),(13547,'STR_PLEASE_CONFIRM_THESE_FILE_PERMISSIONS'),(13548,'STR_READWRITE_CHECK_FAILED'),(13549,'STR_RUNNING_INSTALL_SCRIPT'),(13550,'STR_SQL_WRITE_FAILED_PLEASE_ENSURE_THAT_EXEC_IS_ALLOWED_IN_YOUR_PHP_CONFIGURATION'),(13551,'STR_TOTAL_SALES_PER'),(13552,'STR_TOTAL_SALES_YTD'),(13553,'STR_TO_DOWNLOAD'),(13554,'STR_UPGRADE_COMPLETE_CLICK_HERE_TO_REFRESH'),(13555,'STR_UPGRADE_FOR_NOLAPRO_IS_AVAILABLE_CLICK_HERE_TO_UPDATE'),(13556,'STR_WRITE_FAILED'),(13557,'STR_WRITE_FAILED_CANNOT_CREATE_BACKUP_PLEASE_CHECK_YOUR_READWRITE_PERMMISIONS'),(13558,'STR_YOU_HAVE_NOT_YET_PURCHASED_THE_INVENTORY_PLUG_IN'),(13559,'STR_YOU_MUST_AUTHORIZE_THE_PAYMENT'),(13560,'STR_ZIP_WRITE_FAILED'),(13561,'STR_CANNOT_CONVERT_ITEM_CODE_TO_BARCODE_ITEM_CODE_CANNOT_CONTAIN'),(13562,'STR_ADD_EXTRA_CHARGES'),(13563,'STR_SHOW_SUBTOTAL'),(13564,'STR_SALESPERSON_TOTAL'),(13565,'STR_BY_SALESPERSON'),(13566,'STR_KEYWORD_IN_LINE_DESCRIPTION_OR_NOTES'),(13567,'STR_WILL_USE_LOWEST_PRICE_BETWEEN_STANDARD_AND_CUSTOMER_GROUP'),(13568,'STR_ALWAYS_USE_BEST_PRICE'),(13569,'STR_LAST_MONTH'),(13570,'STR_LAST_3_MONTHS'),(13571,'STR_ALL_COVERS'),(13572,'STR_AMOUNT_EACH_FINISHED_PIECE'),(13573,'STR_CHECK_TO_APPROVE'),(13574,'STR_DELETE_THIS_LINE'),(13575,'STR_EDIT_BOM_EXTRAS'),(13576,'STR_INCOME'),(13577,'STR_INCOME_ORIGIN'),(13578,'STR_LOSS'),(13579,'STR_PENDING_ORDERS_NOT_APPROVED'),(13580,'STR_PRINT_NAMES_AND_ADDRESSES'),(13581,'STR_PRINT_NAMES_ONLY'),(13582,'STR_PRINT_WHAT_ON_COVERS'),(13583,'STR_UNAPPROVED_PENDING_ORDERS'),(13584,'STR_EXPENSE_ORIGIN'),(13585,'STR_YOU_MUST_HAVE_THE_PHP_OPENSSL_EXTENSION_TO_USE_THIS_FEATURE'),(13586,'STR_LAST_12_MONTHS'),(13587,'STR_CONNOT_CONVERT_ITEM_CODE_TO_BARCODE_ITEM_CODE_CANNOT_CONTAIN'),(13588,'STR_SALES_ADJUSTMENTS_TOTAL'),(13589,'STR_PRIVACY_POLICY'),(13590,'STR_ITEMS_PROCESSED'),(13591,'STR_MONTH_AVG'),(13592,'STR_TOTAL_MONTHS'),(13593,'STR_DEFAULT_QUANTITY'),(13594,'STR_INPUT_SECURITY_IMAGE'),(13595,'STR_REGISTER'),(13596,'STR_FLAT_AMOUNT_CHANGE'),(13597,'STR_ITEM_PRICES_CATEGORY_EDIT'),(13598,'STR_PERCENT_CHANGE'),(13599,'STR_PLEASE_ENTER_AN_ADJUSTMENT_PERCENT_OR_AMOUNT'),(13600,'STR_PRICING_UPDATED_SUCCESSFULLY'),(13601,'STR_SELECT_CATEGORIES'),(13602,'STR_SELECT_PRICE_LEVELS'),(13603,'STR_UPDATE_PRICING'),(13604,'STR_AT_LEAST_ONE_CATEGORY_MUST_BE_SELECTED'),(13605,'STR_AT_LEAST_ONE_PRICE_LEVEL_MUST_BE_SELECTED'),(13606,'STR_APPROVED_ORDERS_NOT_SENT_TO_PRESS'),(13607,'STR_ALL_QTY_BILLED'),(13608,'STR_CANNOT_INVOICE_ORDER'),(13609,'STR_CANNOT_INVOICE_ORDER_WITH_STATUS'),(13610,'STR_CONVERT_BACK_TO_QUOTE'),(13611,'STR_INVOICE_FOR_THIS_ORDER_ALREADY_EXISTS'),(13612,'STR_SHOW_ON_DASHBOARD'),(13613,'STR_DOCUMENT_CENTER'),(13614,'STR_EXISTING_UNASSIGNED_DOCUMENTS'),(13615,'STR_UPLOAD_NEW_DOCUMENTS'),(13616,'STR_REQUESTED_SHIP_DATE'),(13617,'STR_CREATE'),(13618,'STR_30_DAYS_FREE_THEN'),(13619,'STR_AUTOMATIC_UPDATES'),(13620,'STR_BILLING_AR'),(13621,'STR_COMPANY_BOOK_SETS_ALLOWED'),(13622,'STR_COMPARE_VERSIONS'),(13623,'STR_CONTACTS_DATABASE'),(13624,'STR_CUSTOMERS_ALLOWED'),(13625,'STR_EMPLOYEES_ALLOWED'),(13626,'STR_FREE_30_DAY_EMAIL_SUPPORT'),(13627,'STR_GENERAL_LEDGER_GL'),(13628,'STR_INVENTORY_ALLOWED'),(13629,'STR_INVENTORY_TRACKING'),(13630,'STR_MONTHLY_RATE'),(13631,'STR_NIGHTLY_BACKUPS'),(13632,'STR_PAYABLES_AP'),(13633,'STR_PAYROLL_MODULE'),(13634,'STR_POINT_OF_SALE_POS'),(13635,'STR_PROFESSIONAL_AUDITING'),(13636,'STR_SERVICE_AND_ITEM_ORDERS'),(13637,'STR_VENDORS_ALLOWED'),(13638,'STR_EASY_BOOKKEEPING'),(13639,'STR_INDEPTH_ACCOUNTING'),(13640,'STR_HIDE_ESTIMATED_SHIP_DATE_ON_ORDER_CONFIRMATION'),(13641,'STR_LOG_IN_WITH_A_GOOGLE_ACCOUNT'),(13642,'STR_THIS_SITE_DOES_NOT_EXIST'),(13643,'STR_FORGOT_YOUR_PASSWORD'),(13644,'STR_YOU_MUST_BE_LOGGED_IN_TO_SEARCH'),(13645,'STR_MISSING_PASSWORD'),(13646,'STR_MISSING_SITE_NAME'),(13647,'STR_MISSING_USER_NAME'),(13648,'STR_THIS_SITE_DOES_NOT_EXISTS'),(13649,'STR_BASIC_BOOKKEEPING'),(13650,'STR_ADVANCED_BOOKKEEPING'),(13651,'STR_PRODUCT_COMPARISON'),(13652,'STR_DEFAULT_ACTION_WHEN_SHIPPING'),(13653,'STR_DEFAULT_TO_COMPLETE_WHEN_ALL_ITEMS_SHIPPED'),(13654,'STR_DEFAULT_TO_INCOMPLETE_ALWAYS'),(13655,'STR_SHOW_ALL_ITEMS_INCLUDING_ALREADY_SHIPPED'),(13656,'STR_SHOW_ONLY_ITEMS_TO_BE_SHIPPED'),(13657,'STR_SHOW_WHAT_ON_PICK_TICKETS'),(13658,'STR_JOB_TICKET_BOTTOM_TEXT'),(13659,'STR_CREDIT_NOTE'),(13660,'STR_COMMERCIAL'),(13661,'STR_COMMERCIAL_OR_RESIDENTIAL'),(13662,'STR_RESIDENTIAL'),(13663,'STR_SAVINGS_COUPON'),(13664,'STR_COUPON'),(13665,'STR_NOT_INCLUDED_IN_ABOVE_QUOTE'),(13666,'STR_RESIDENTIAL_DELIVERY'),(13667,'STR_DISCOUNT_COUPON'),(13668,'STR_DISCOUNT_TOTAL'),(13669,'STR_NO_PRINT_ON_ANY_OUTPUTS'),(13670,'STR_ALLOW_USER_OVERRIDE_OF_AMOUNT'),(13671,'STR_COUPON_CODE'),(13672,'STR_DESCRIPTION_OF_OFFER'),(13673,'STR_MAX_DISCOUNT_AMOUNT'),(13674,'STR_PRINT_COUPONS_ADD'),(13675,'STR_COUPONS'),(13676,'STR_DISCOUNT_COUPON_UPDATE'),(13677,'STR_AND_ONE_OF'),(13678,'STR_CLICK_TO_RELEASE_TO_PRESS'),(13679,'STR_SHOW_ALL_ADD_ONS'),(13680,'STR_SHOW_ONLY_ACTIVE'),(13681,'STR_SHOW_ONLY_INACTIVE'),(13682,'STR_SHOW_ONLY_PURCHASED'),(13683,'STR_SHOW_ONLY_UNPURCHASED'),(13684,'STR_END_YEAR'),(13685,'STR_IS_THIS_END_OF_YEAR_CLOSE'),(13686,'STR_VOUCHERS_SKIPPED_AS_DATED_BEFORE_LAST_CLOSE_DATE'),(13687,'STR_DATES_SUCCESSFULLY_UPDATED'),(13688,'STR_JOURNALS_ENTRIES_PRIOR_TO_MOST_RECENT_CLOSE_DATE'),(13689,'STR_ORIGINAL_DATE'),(13690,'STR_SAVE_NEW_DATES'),(13691,'STR_UPDATES_FAILED'),(13692,'STR_VENDOR_ITEM_NUMBER'),(13693,'STR_EXPORT_COSTS_AND_STOCKING_LEVELS'),(13694,'STR_SEASON1_MAX'),(13695,'STR_SEASON1_MIN'),(13696,'STR_SEASON1_NAME'),(13697,'STR_SEASON1_ORDER_QTY'),(13698,'STR_SEASON2_MAX'),(13699,'STR_SEASON2_MIN'),(13700,'STR_SEASON2_NAME'),(13701,'STR_SEASON2_ORDER_QTY'),(13702,'STR_SEASON3_MAX'),(13703,'STR_SEASON3_MIN'),(13704,'STR_SEASON3_NAME'),(13705,'STR_SEASON3_ORDER_QTY'),(13706,'STR_SEASON4_MAX'),(13707,'STR_SEASON4_MIN'),(13708,'STR_SEASON4_NAME'),(13709,'STR_SEASON4_ORDER_QTY'),(13710,'STR_ADMIN_USERNAME'),(13711,'STR_ADDITIONAL_SEARCH_FILTERS'),(13712,'STR_ADVANCED_OPTIONS'),(13713,'STR_CLICK_RECREATE_MENU_AFTER_YOU_HAVE_MADE_CHANGES_TO_WORDS_IN_THE_MENU_'),(13714,'STR_DEFINITION'),(13715,'STR_EXPORT_TRANSLATION'),(13716,'STR_GET_DEFINITIONS'),(13717,'STR_HIDE'),(13718,'STR_INTERNAL_PHRASE'),(13719,'STR_ONLY_LOOK_FOR_SEARCH_TERMS_IN_THE_PAGES_SELECTED_BELOW'),(13720,'STR_PAGE_MATCHES'),(13721,'STR_RECREATE_MENU'),(13722,'STR_RETURNS_ONLY_BLANK_DEFINITIONS_FOR_YOUR_LANGUAGE'),(13723,'STR_SEARCH_FOR_THE_TERM_ABOVE_IN_EITHER_THE_INTERNAL_PHRASE_OR_DEFINITION'),(13724,'STR_SEARCH_TERM_MUST_BE_IN_DEFINITION'),(13725,'STR_SEARCH_TERM_MUST_BE_IN_INTERNAL_PHRASE'),(13726,'STR_SHOWS_ALL_PAGES_A_WORD_OR_PHRASE_APPEARS_ON'),(13727,'STR_SHOW_ONLY_BLANKS'),(13728,'STR_WORDS_AND_PHRASES'),(13729,'STR_CORRECT_JOURNAL_DATES'),(13730,'STR_DISCOUNT_COUPONS'),(13731,'STR_CLICK_TO_SHOW'),(13732,'STR_CANADA_PENSION_PLAN'),(13733,'STR_CANADIAN_EMPLOYMENT_INSURANCE'),(13734,'STR_EI'),(13735,'STR_EI_VENDOR'),(13736,'STR_EI_VENDOR_LOOKUP'),(13737,'STR_PROVINCIAL'),(13738,'STR_EI_TAX'),(13739,'STR_FEDERAL_EI_TAX'),(13740,'STR_UPDATE_PROVIDENCE_TAX_TABLES_FOR_YEAR_SELECTED'),(13741,'STR_CO_EI_TAX'),(13742,'STR_CPP_WITHHOLDING'),(13743,'STR_AMOUNT_OWING'),(13744,'STR_AMOUNT_PAID_FOR'),(13745,'STR_BALANCES_ON_LAST_STATEMENT'),(13746,'STR_CPP_CONTRIBUTIONS'),(13747,'STR_CURRENT_BALANCES'),(13748,'STR_CURRENT_PAYMENT'),(13749,'STR_EI_PREMIUMS'),(13750,'STR_END_OF_REMITTING_PERIOD_FOR_WHICH_DEDUCTIONS_WERE_WITHHELD'),(13751,'STR_EXPLANATION_OF_CHANGES'),(13752,'STR_GROSS_PAYROLL'),(13753,'STR_GROSS_PAYROLL_IN_REMITTING_PERIOD_DOLLARS_ONLY'),(13754,'STR_NO_OF_EMPLOYEES_IN_LAST_PAY_PERIOD'),(13755,'STR_PD7A'),(13756,'STR_TAX_DEDUCTIONS'),(13757,'STR_PRINT_PD7A_INFORMATION'),(13758,'STR_BILLING_COST'),(13759,'STR_COMPANIES_ALLOWED'),(13760,'STR_PRODUCT_DETAILS'),(13761,'STR_DOUBLE_WINDOW_FORMAT'),(13762,'STR_BCC_ALL_EMAILS_TO'),(13763,'STR_CLICK_HERE_TO_VIEW_ALL'),(13764,'STR_MAX_NUMBER_OF_RECORDS_ARE_SHOWN'),(13765,'STR_INVOICE_AND_EMAIL_WHEN_SHIPPED_TO'),(13766,'STR_NEVER'),(13767,'STR_ONLY_COMPLETE_SHIPMMENTS'),(13768,'STR_PARTIAL_AND_FULL_SHIPMENTS'),(13769,'STR_CHANGE_STATUS_TO_NOT_DELIVERED'),(13770,'STR_DELIVERIES'),(13771,'STR_DELIVERY_ADDED_SUCCESSFULLY'),(13772,'STR_DELIVERY_DATE'),(13773,'STR_DELIVERY_DELETED_SUCCESSFULLY'),(13774,'STR_DELIVERY_ID'),(13775,'STR_DELIVERY_NOTES'),(13776,'STR_ENTERED_ON'),(13777,'STR_MORE_DELIVERIES_NEEDED'),(13778,'STR_NO_QUANTITIES_ENTERED'),(13779,'STR_PRINTING_NOT_AVAILABLE'),(13780,'STR_PRIOR_DELIVERED'),(13781,'STR_QTY_THIS_DELIVERY'),(13782,'STR_SAVE_DELIVERY'),(13783,'STR_STATUS_CHANGED_SUCCESSFULLY'),(13784,'STR_DELIVERIES_COMPLETED'),(13785,'STR_DELIVERIES_PENDING'),(13786,'STR_DELIVERED'),(13787,'STR_DELIVERY_STATUS'),(13788,'STR_NOT_DELIVERED'),(13789,'STR_DELIVERY_NOTE'),(13790,'STR_AR_NOTIFICATIONS'),(13791,'STR_CLICK_EACH_NOTIFICATION_TO_VIEW_DETAILS'),(13792,'STR_INVOICES_NOT_PAID'),(13793,'STR_INVOICES_WITH_PENDING_DELIVERIES'),(13794,'STR_ADDON_PURCHASING_IS_NOT_ENABLED_FOR_THIS_ACCOUNT_PLEASE_CONTACT_YOUR_ACCOUNT_PROVIDER_FOR_MORE_DETAILS'),(13795,'STR_CLICK_THE_NAME_TO_SEE_THE_DESCRIPTION_OR_TO_ACTIVATE'),(13796,'STR_FREE_ADDONS'),(13797,'STR_MANUALS_AND_SUPPORT'),(13798,'STR_941_SCHEDULE_B_WEEKLY'),(13799,'STR_CALENDAR_YEAR'),(13800,'STR_EIN'),(13801,'STR_SCHEDULE_B_DATA_FOR_941'),(13802,'STR_SCHEDULE_B_FOR_941'),(13803,'STR_TOTAL_FOR_QUARTER'),(13804,'STR_ADD_WEBSITE'),(13805,'STR_DO_NOT_SHOW_SALES_ORDER_NUMBER_ON_PO'),(13806,'STR_REBATE'),(13807,'STR_FILE_MISSING'),(13808,'STR_DISCOUNT_OR_REBATE'),(13809,'STR_FULL_INCLUDES_DELETE_AND_DELETES_BUILD_ORDERS'),(13810,'STR_ESTIMATED_SALES'),(13811,'STR_ITEM_VENDOR_STATUS'),(13812,'STR_LAST_YEAR_PURCHASED'),(13813,'STR_LOCATION_IN_WAREHOUSE'),(13814,'STR_ON_HAND_QTY'),(13815,'STR_ON_ORDER_PLUS_AVAILABLE'),(13816,'STR_ON_ORDER_QTY'),(13817,'STR_OVER_UNDER'),(13818,'STR_PROFIT_MARGIN'),(13819,'STR_VENDOR_CASE_PACK'),(13820,'STR_UPDATE_ALL_ITEMS_WITH_CURRENT_PRICES'),(13821,'STR_UPDATE_PRICES'),(13822,'STR_COMMON_CAUSE_OF_THIS_IS_NO_ITEM_BY_THIS_ID_FOR_LOCATION'),(13823,'STR_COULD_NOT_REDUCE_INVENTORY_FOR_ITEM'),(13824,'STR_LOCATION_DOES_NOT_EXIST'),(13825,'STR_THIS_ITEM_DOES_NOT_EXIST'),(13826,'STR_AUTO_GENERATE_VOUCHER_NUMBER'),(13827,'STR_NEW_CREDIT_CARD_PURCHASE'),(13828,'STR_PO_EMAILED'),(13829,'STR_NOTES_REPORT'),(13830,'STR_NOTE_KEYWORD'),(13831,'STR_NOTE_TYPE'),(13832,'STR_SHOW_FULL_NOTE'),(13833,'STR_WORKSTEP'),(13834,'STR_WORKSTEPS_ADD'),(13835,'STR_MINIMUM_AMOUNT_PAID_FOR_YEAR_TO_INCLUDE'),(13836,'STR_CUSTOMER_AND_INVOICE'),(13837,'STR_EMAIL_INVOICES'),(13838,'STR_INVOICES_HAVE_BEEN_EMAILED'),(13839,'STR_INVOICES_WILL_BE_EMAILED'),(13840,'STR_INVOICES_WILL_NOT_BE_EMAILED'),(13841,'STR_YOU_HAVE_CHOSEN_NOT_TO_AUTOMATICALLY_EMAIL_INVOICES'),(13842,'STR_ORDERS_COMPLETED_IN'),(13843,'STR_COMPLETION'),(13844,'STR_OK_TO_PRINT'),(13845,'STR_RELEASED_TO_PRESS'),(13846,'STR_APPROVED_ORDERS_NOT_BILLED'),(13847,'STR_EDIT_PRESS_STOCK'),(13848,'STR_RELEASED'),(13849,'STR_ERROR_UPDATING_FILE'),(13850,'STR_STOCK_FOR_PRESS'),(13851,'STR_WORKSTEPS_UPDATE'),(13852,'STR_FOR_ENVELOPES_THIS_WILL_AUTO_FILL_DO_NOT_MAKE_AN_ENTRY'),(13853,'STR_CANCEL_ORDER'),(13854,'STR_PRINT_ORDER_DETAILS'),(13855,'STR_EDIT_UNCONFIRMED'),(13856,'STR_THE_LANGUAGE_EDITOR_IS_NOT_AVAILABLE'),(13857,'STR_HIDE_DONATE_BUTTON'),(13858,'STR_ADDITIONS'),(13859,'STR_EXPECTED_BALANCE'),(13860,'STR_SUBTRACTIONS'),(13861,'STR_CHANGE'),(13862,'STR_TENDERED'),(13863,'STR_BOM_AUTO_BUILD'),(13864,'STR_GET_UNITED_STATIONERS_QUOTE'),(13865,'STR_YOU_MUST_SELECT_A_DEFAULT_INVENTORY_LOCATION'),(13866,'STR_FREIGHT_PERCENT'),(13867,'STR_USED_WITH_VENDOR_COST_PRICE_MARKUPS'),(13868,'STR_NEAREST_10_CENTS'),(13869,'STR_NEAREST_25_CENTS'),(13870,'STR_NEAREST_5_CENTS'),(13871,'STR_NEAREST_5_WHOLE_CURRENCY_UNIT'),(13872,'STR_NEAREST_99_CENTS'),(13873,'STR_NEAREST_9_AND_99_CENTS'),(13874,'STR_NEAREST_9_WHOLE_CURRENCY_UNIT'),(13875,'STR_NEAREST_WHOLE_CURRENCY_UNIT'),(13876,'STR_ROUND_PRICE_UP_TO'),(13877,'STR_ADDITIONAL_NOTES'),(13878,'STR_SEND_EDI_ASN'),(13879,'STR_SEND_EDI_INVOICE'),(13880,'STR_CLICK_HERE_TO_ACCESS_YOUR_SURVEY'),(13881,'STR_A_SURVEY_HAS_BEEN_COMPLETED'),(13882,'STR_ENTER_WORK_STEPS'),(13883,'STR_OK_ORDERS'),(13884,'STR_RELEASE_TO_PRESS'),(13885,'STR_SETUP_WORK_STEPS'),(13886,'STR_CREDIT_CARD_PURCHASE_DOCUMENTS'),(13887,'STR_DONATE'),(13888,'STR_WORKSTEPS'),(13889,'STR_AFRICA'),(13890,'STR_ANTARCTICA'),(13891,'STR_ASIA'),(13892,'STR_EUROPE'),(13893,'STR_NORTH_AMERICA'),(13894,'STR_OCEANIA'),(13895,'STR_SELECT_YOUR_COUNTRY'),(13896,'STR_SOUTH_AMERICA'),(13897,'STR_USERNAME_TOO_SHORT'),(13898,'STR_DISCOUNT_OF'),(13899,'STR_NO_ORDERS_SELECTED'),(13900,'STR_PER_ORDER'),(13901,'STR_PRINTED_MATTER_CONSISTING_OF'),(13902,'STR_INVENTORY_USE_TAX'),(13903,'STR_REPLY_TO'),(13904,'STR_COVER_INVENTORY_STOCK'),(13905,'STR_ENVELOPE_INVENTORY_STOCK'),(13906,'STR_POUNDS_PER_THOUSAND_CUTOFFS_FOR_COVERS'),(13907,'STR_POUNDS_PER_THOUSAND_CUTOFFS_FOR_ENVELOPES'),(13908,'STR_PAYMENT_NOTES'),(13909,'STR_PAYMENT_VOUCHER'),(13910,'STR_URL_FILE_FOR_LOGO'),(13911,'STR_CHANGE_CUSTOMER'),(13912,'STR_CURRENT_CUSTOMER'),(13913,'STR_CUSTOMER_CHANGED_SUCCESSFULLY'),(13914,'STR_ERROR_ADDING_INVOICE_NOTES'),(13915,'STR_PLEASE_PUT_ACCOUNT_NUMBER_ON_CHECK'),(13916,'STR_INVENTORY_COST'),(13917,'STR_NUMBER_POSTED'),(13918,'STR_PAYMENT_PLANS_HAVE_BEEN_POSTED'),(13919,'STR_PRICE_DETAIL'),(13920,'STR_ENVELOPES'),(13921,'STR_ENVELOPES_PER_BOOK'),(13922,'STR_REGULAR'),(13923,'STR_CLICK_HERE_TO_UPGRADE_TO_PROSPER'),(13924,'STR_DISCOUNT_BUNDLES'),(13925,'STR_ECOMMERCE_AND_CRM'),(13926,'STR_UPGRADE_TO_PROSPER'),(13927,'STR_MASS_EDIT_FAILED_TO_BALANCE'),(13928,'STR_DEFAULT_ITEM_COSTS_TO_STATIC_COST'),(13929,'STR_DISPLAY_PROFIT_PER_LINE_ITEM'),(13930,'STR_CAN_BE_USED_AS_MARKUP_BASIS'),(13931,'STR_NOT_AFFECTED_BY_INVENTORY_ACTIVITY'),(13932,'STR_STATIC_COST'),(13933,'STR_PRICE_HISTORY'),(13934,'STR_VENDOR_ITEM_PRICE_HISTORY'),(13935,'STR_CLICK_A_PRICE_TO_USE_IT_ON_THE_CURRENT_PO'),(13936,'STR_DEFAULT_PRICE'),(13937,'STR_NO_PREVIOUS_PURCHASES'),(13938,'STR_NO_VENDOR_SELECTED'),(13939,'STR_CUSTOMER_ITEM_PRICE_HISTORY'),(13940,'STR_CLICK_A_PRICE_TO_USE_IT_ON_THE_CURRENT_ORDER'),(13941,'STR_NO_CUSTOMER_SELECTED'),(13942,'STR_EDIT_EXISTING_CARRIER'),(13943,'STR_MAKE_VENDOR_A_CARRIER'),(13944,'STR_SHOW_SHIPMENT_INFO'),(13945,'STR_USE_BACKGROUND_PDF_FOR_STANDARD_PRINTS'),(13946,'STR_ADD_NEW_EMAIL_TEMPLATE'),(13947,'STR_SELECT_A_TEMPLATE_TYPE'),(13948,'STR_TEMPLATE'),(13949,'STR_TEMPLATE_TYPE'),(13950,'STR_YOU_MUST_ENTER_A_TEMPLATE_NAME'),(13951,'STR_SELECT_AN_EMAIL_TEMPLATE'),(13952,'STR_CUSTOMERS_WITH_ORDERS_OR_INVOICES_SINCE'),(13953,'STR_CUSTOMER_DATA_IMPORTED_SUCCESSFULLY'),(13954,'STR_CUSTOMER_EXPORT_IMPORT_EDIT_TOOL'),(13955,'STR_EXPORT_SHIP_TO_INFO'),(13956,'STR_IMPORT_PRIOR_CUSTOMER_EXPORT_FILE'),(13957,'STR_USE_THIS_TOOL_TO_EXPORT_YOUR_CUSTOMER_DATA_IN_CSV_FORMAT_MAKE_CHANGES_AND_REIMPORT'),(13958,'STR_EMAIL_ONE_DESCRIPTION'),(13959,'STR_PHONE_FOUR_COMMENT'),(13960,'STR_PHONE_THREE_COMMENT'),(13961,'STR_SHIP_TO_ID'),(13962,'STR_COVER_FILE'),(13963,'STR_POST_TO_MONTH_INVALID'),(13964,'STR_MINIMUM_PROFIT_MARGIN_FOR_PRICE_CHANGE_BLOCKING'),(13965,'STR_USED_IN_CONJUNCTION_WITH_USER_SETTING_TO_BLOCK_PRICE_CHANGES_BELOW_A_MINIMUM_PROFIT_MARGIN'),(13966,'STR_YOU_ARE_NOT_AUTHORIZED_TO_CHANGE_THE_PRICE_TO_THIS_AMOUNT'),(13967,'STR_SECURITY_WARNING_MD5_HASH_FROM_USA_EPAY_DOES_NOT_MATCH'),(13968,'STR_SETUP_WIZARD'),(13969,'STR_COMPANY_NAME_OR_FIRST_AND_LAST_NAME_IF_NO_COMPANY'),(13970,'STR_CUSTOMER_FIRST_NAME'),(13971,'STR_CUSTOMER_LAST_NAME'),(13972,'STR_INVOICE_DUE_DAY'),(13973,'STR_ORDER_DAY'),(13974,'STR_ORDER_DUE_DATE'),(13975,'STR_ORDER_DUE_DAY'),(13976,'STR_ORDER_DUE_MONTH'),(13977,'STR_ORDER_DUE_YEAR'),(13978,'STR_ORDER_MONTH'),(13979,'STR_QUOTE_DAY'),(13980,'STR_QUOTE_EXPIRES_DATE'),(13981,'STR_QUOTE_EXPIRES_DAY'),(13982,'STR_QUOTE_EXPIRES_MONTH'),(13983,'STR_QUOTE_EXPIRES_YEAR'),(13984,'STR_QUOTE_MONTH'),(13985,'STR_QUOTE_YEAR'),(13986,'STR_CANNOT_CHANGE_POS_PRICES_BELOW_MINIMUM_ITEM_PROFIT_MARGIN'),(13987,'STR_AUTO_BUILD'),(13988,'STR_AUTO_BUILD_ORDER'),(13989,'STR_CHARACTERS'),(13990,'STR_ACCESS_TO_EACH_MODULE_IS_GRANTED_ON_THREE_LEVELS'),(13991,'STR_IGNORE'),(13992,'STR_MORE_INFORMATION'),(13993,'STR_YOU_NEED_TO_INDICATE_THE_MODULE_ACCESS_LEVEL_CLICK_HERE_TO_EXPLAIN_MODULE_ACCESS'),(13994,'STR_BASIC'),(13995,'STR_FORMATTING'),(13996,'STR_BLOCK_HEADER_ON_PICK_TICKET'),(13997,'STR_BLOCK_ITEM_BARCODE_ON_PICK_TICKET'),(13998,'STR_DEFAULTS'),(13999,'STR_INVOICING_AND_ORDERING'),(14000,'STR_SALES_COMMISSIONS_TERRITORY_BASED'),(14001,'STR_ADVANCED'),(14002,'STR_MAXIMUM_PAY'),(14003,'STR_APPEARANCE'),(14004,'STR_BEHAVIOR'),(14005,'STR_HIDE_ADVANCED_OPTIONS'),(14006,'STR_USE_GOOGLE_TRANSLATE_FOR_B2B'),(14007,'STR_RESELLER'),(14008,'STR_ADDITIONAL_INFO'),(14009,'STR_RESTOCK_DATE'),(14010,'STR_DISPLAY_COMPANY_INFO'),(14011,'STR_DISPLAY_INVENTORY_LOCATION_INFO'),(14012,'STR_GENERATED_ON'),(14013,'STR_HEADER_PREFERENCES'),(14014,'STR_ITEM_CODE_RANGE'),(14015,'STR_ITEM_PRICE_LIST'),(14016,'STR_PRODUCTS_FROM_THIS_VENDOR'),(14017,'STR_SHOW_DATE'),(14018,'STR_SHOW_PAGE_NUMBERS'),(14019,'STR_SHOW_PRICE_LEVEL'),(14020,'STR_SHOW_PRICING_UNITS'),(14021,'STR_DEFAULT_VENDOR_PAYMENT_TYPE_ALLOWED'),(14022,'STR_RECOMMENDED'),(14023,'STR_SIGN_UP_TO_ACCEPT_CREDIT_CARD_PAYMENTS'),(14024,'STR_GENERAL_ACCESS'),(14025,'STR_ADDITIONAL_CHARACTERISTICS'),(14026,'STR_ADD_TO_CART'),(14027,'STR_CART_UPDATED_SUCCESSFULLY'),(14028,'STR_ITEM_DETAIL'),(14029,'STR_ITEM_INFO'),(14030,'STR_KEYWORD'),(14031,'STR_PLEASE_SELECT_A_CATEGORY_OR_ENTER_A_KEYWORD'),(14032,'STR_QUANTITY_AVAILABLE'),(14033,'STR_START_AN_ORDER'),(14034,'STR_UPDATE_CART'),(14035,'STR_SEARCH_FOR_ITEMS'),(14036,'STR_ETA'),(14037,'STR_SHOW_FULL_SIZED_SHIP_SOLD_TO_BOX'),(14038,'STR_USE_MAX_STOCKING_LEVEL_TO_DETERMINE_ORDER_QTY'),(14039,'STR_MANUAL_PAYMENTS'),(14040,'STR_MANUAL_PAYMENT_CREATED_SUCCESSFULLY'),(14041,'STR_PRINT_ORDER_DEPOSITS'),(14042,'STR_COMPANY_OR_PERSON_NAME'),(14043,'STR_EXCLUDE_NO_CREDIT_CUSTOMERS'),(14044,'STR_SALES_CATEGORY_THEN_COMPANY_ID'),(14045,'STR_SORT_ORDER_FOR_STATEMENTS'),(14046,'STR_HIDE_ITEMS_WITH_NO_ORDER_NOW_VALUE'),(14047,'STR_ENTER_PAYMENT_WITHOUT_FIRST_ENTERING_BILL'),(14048,'STR_SELECT_NONE'),(14049,'STR_HIDE_DUE_DATE_ON_INVOICE'),(14050,'STR_AUTHORIZE_NET_CIM'),(14051,'STR_COULD_NOT_FIND_AUTHORIZE_NET_TRANSACTION_KEY'),(14052,'STR_ERROR_CONNECTING_TO_AUTHORIZE_NET'),(14053,'STR_NO_CUSTOMER_ID_SET'),(14054,'STR_PLEASE_CHECK_ACCOUNT_SETUP'),(14055,'STR_ADD_EDIT_STORED_CREDIT_CARDS'),(14056,'STR_USE_STORED_CARD'),(14057,'STR_ALIGN_CENTER'),(14058,'STR_ALIGN_LEFT'),(14059,'STR_ALIGN_RIGHT'),(14060,'STR_BOLD'),(14061,'STR_FONT_SIZE'),(14062,'STR_ITALIC'),(14063,'STR_LIST_ITEM'),(14064,'STR_ORDERED_LIST'),(14065,'STR_TEXT_COLOR'),(14066,'STR_UNORDED_LIST'),(14067,'STR_YOUR_TRANSLATION_IS_PENDING_APPROVAL_BY_ONE_OF_OUR_ADMINISTRATOR'),(14068,'STR_CALCULATE_DISCOUNT'),(14069,'STR_DISCOUNT_CURRENT_ORDER_BY'),(14070,'STR_NO_SAVED_PAYMENT_ACCOUNTS'),(14071,'STR_AN_NDMS_SUPPORT_MEMBER_WILL_CONTACT_YOU'),(14072,'STR_CC_PROCESSOR_SUBTITLE_AUTHNET'),(14073,'STR_CC_PROCESSOR_SUBTITLE_EPAY'),(14074,'STR_CC_PROCESSOR_SUBTITLE_MANUAL'),(14075,'STR_CC_PROCESSOR_SUBTITLE_PSIGATE'),(14076,'STR_CC_WARNING_BOTH_PRESENT_AND_NOT_PRESSENT_RECOMMENED'),(14077,'STR_I_ALREADY_HAVE_A_PROCESSOR'),(14078,'STR_SIGN_UP'),(14079,'STR_A_PASSWORD_STRENGTH_OF_2_OR_MORE_IS_REQUIRED'),(14080,'STR_PASSWORD_STRENGTH'),(14081,'STR_CONTACT_NOTES'),(14082,'STR_CLICK_NOTE_TO_EXPAND'),(14083,'STR_DEFAULT_VENDOR_FOR_ORDERS'),(14084,'STR_SHOW_CUSTOMER_NOTES_ON_SERVICE_ORDER_EDIT_SCREEN'),(14085,'STR_ACCEPTED'),(14086,'STR_CLICK_ON_A_MATCHINTG_CUSTOMER'),(14087,'STR_CREATE_NEW_CUSTOMER_WITH_POSSIBLE_MATCHING_DATA'),(14088,'STR_IGNORE_MATCHES_ABOVE_AND_CREATE_NEW_CUSTOMER_RECORD'),(14089,'STR_NO_DUPLICATES_FOUND'),(14090,'STR_POSSIBLE_CUSTOMER_DUPLICATES'),(14091,'STR_ADD_EMAIL_TEMPLATE'),(14092,'STR_EMAIL_TEMPLATE'),(14093,'STR_NO_EMAIL_TEMPLATE_HAS_BEEN_SELECTED'),(14094,'STR_POSSIBLE_DUPLICATE_CUSTOMER_FOUND'),(14095,'STR_CANNOT_CHANGE_DESCRIPTION_FOR_POS_FO_ORDERS'),(14096,'STR_CANNOT_VIEW_COST_FOR_POS_FO_ORDERS'),(14097,'STR_ALLOW_DISCOUNTS_FOR_CREDIT_INVOICES_ON_PAYMENT_PAGE'),(14098,'STR_DISCOUNTS_ENTRY'),(14099,'STR_HIDE_ONLY_WHOLE_ORDER_DISCOUNTS_ENTRY'),(14100,'STR_SHOW_DISCOUNTS_ENTRY'),(14101,'STR_DEFAULT_COMPANIES_TO_VIEW_STOCK_FROM'),(14102,'STR_CLICK_TO_SELECT_OR_DESELECT_ALL_CC_ENTRIES_FOR_THIS_DAY'),(14103,'STR_DAILY_TOTAL'),(14104,'STR_ITEM_SERIAL_NUMBERS'),(14105,'STR_PLEASE_ENTER_SERIAL_NUMBERS'),(14106,'STR_ALL_SERIAL_NUMBER_BOXES_MUST_BE_FILLED_IN'),(14107,'STR_THE_FOLLOWING_LINES_NEED_SERIAL_NUMBERS'),(14108,'STR_SHOW_POSSIBLE_LINKS_FOR_THIS_MONTH_ONLY'),(14109,'STR_INCLUDE_ONLY_NEGATIVE_ON_HAND_ITEMS'),(14110,'STR_SHOW_OVERRIDE_PRICE_TEXT_IF_PRICE_OVERRIDDEN'),(14111,'STR_INCLUDE_VENDOR_PRODUCT_CODE_IN_ITEM_SEARCH_BOX'),(14112,'STR_SHOW_SIGNATURE_LINE_ON_PACKING_SLIP'),(14113,'STR_EMAIL_SMTP'),(14114,'STR_RECEIVED_IN_GOOD_CONDITION_BY'),(14115,'STR_SIGNED'),(14116,'STR_BILL_CONTINUOUSLY'),(14117,'STR_PORT'),(14118,'STR_SECURE'),(14119,'STR_SMTP_ENABLED'),(14120,'STR_SMTP_REQUIRES_AUTH'),(14121,'STR_AVAILABLE_QTY'),(14122,'STR_NO_ORDERS_HAVE_BEEN_SELECTED'),(14123,'STR_PRINT_SELECTED'),(14124,'STR_PRINT_SELECTED_CONFIRMATION'),(14125,'STR_AUTOMATICALLY_SHOW_PRICE_HISTORY_PAGE_WHEN_ORDERING'),(14126,'STR_AUTO_EMAIL_WHEN_SHIPPED_STYLE'),(14127,'STR_MAX_PRICE_HISTORY_RECORDS_TO_SHOW'),(14128,'STR_SMALL'),(14129,'STR_SHOW_UPS_ACCOUNT_BOXES_ON_SHIP_TO_EDIT'),(14130,'STR_FILE_IRS_1099_MISC_ELECTRONICALLY'),(14131,'STR_SHOW_WEIGHT'),(14132,'STR_SEND_ALL_UNBILLED_3DCART_ORDERS_TO_INVOICING'),(14133,'STR_ADD_PACKAGE'),(14134,'STR_UPS_ACCOUNT_NUMBER'),(14135,'STR_UPS_ACCOUNT_TYPE'),(14136,'STR_1099S'),(14137,'STR_CONSIGNEE_BILLED'),(14138,'STR_SHIPPER'),(14139,'STR_THIRD_PARTY'),(14140,'STR_CANNOT_VIEW_COST_ON_SUMMARY_OF_INVOICES_AND_INVENTORY_SALES_HISTORY_REPORTS'),(14141,'STR_HIDE_SHIPPING_CHARGE_BOXES_IF_UPS_RECEIVER_THIRD_PARTY_OR_CONSIGNEE_CHOSEN'),(14142,'STR_SHOW_TERMS_DISCOUNT_AMOUNT_IN_TOTALS'),(14143,'STR_TERMS_DISCOUNT'),(14144,'STR_DEFAULT_NUMBER_OF_PACKING_SLIP_COPIES'),(14145,'STR_MEDICARE_PERCENT_EMPLOYEE'),(14146,'STR_AN_ERROR_OCCURRED_SO_THE_ORDER_WAS_NOT_SUBMITTED'),(14147,'STR_A_AND_I_PRODUCTS_TRANSFER'),(14148,'STR_NO_ORDER_NUMBER_SENT'),(14149,'STR_UPLOADED_FILE_SUCCESSFULLY'),(14150,'STR_ADD_NEW_CARD'),(14151,'STR_CARD_NOT_ADDED'),(14152,'STR_CARD_WAS_NOT_DELETED'),(14153,'STR_COULD_NOT_FIND_USA_EPAY_SOURCE_KEY'),(14154,'STR_ERROR_CONNECTING_TO_USA_EPAY'),(14155,'STR_PAYMENT_METHOD_ADDED_SUCCESSFULLY'),(14156,'STR_PAYMENT_METHOD_DELETED_SUCCESSFULLY'),(14157,'STR_USA_EPAY_CUSTOMER_DATABASE'),(14158,'STR_VIEW_BY_SALES_PERSON'),(14159,'STR_YOU_MUST_SELECT_A_CUSTOMER_TO_EMAIL'),(14160,'STR_MAKE_A_AND_I_PRODUCTS_PO'),(14161,'STR_START_A_PO'),(14162,'STR_EXCESS_EARNINGS'),(14163,'STR_FUTA'),(14164,'STR_FUTA_REPORT'),(14165,'STR_FUTA_TAX'),(14166,'STR_TAXABLE_EARNINGS'),(14167,'STR_WAGES_PAID'),(14168,'STR_SUTA'),(14169,'STR_SUTA_REPORT'),(14170,'STR_SUTA_TAX'),(14171,'STR_MINIMUM_SALES'),(14172,'STR_NET_DUE_DATE_END_OF_MONTH_PLUS'),(14173,'STR_EXCLUDE_FROM_HOURS_WORKED'),(14174,'STR_LAST_4'),(14175,'STR_STORED_CREDIT_CARDS'),(14176,'STR_DO_NOT_SHOW_HTML_PO_VERSION_OPTION'),(14177,'STR_SHOW_INTERNAL_ITEMCODE_ON_PO'),(14178,'STR_SHIP_CHECKED'),(14179,'STR_PO_LIST'),(14180,'STR_OUR_CODE'),(14181,'STR_GROUP_SHIP_ORDERS'),(14182,'STR_EFT_REPORT'),(14183,'STR_FILE_CREATION_NUMBER'),(14184,'STR_NUMBER_OF_RECORDS'),(14185,'STR_TOTAL_AMOUNT'),(14186,'STR_API_KEY_IN_NPIMPORT_FILE'),(14187,'STR_LAST_ORDER_NUMBER_IMPORTED'),(14188,'STR_LOCATION_OF_THE_NPIMPORT_FILE'),(14189,'STR_MANUAL_IMPORT_SETTINGS'),(14190,'STR_MIN_20_CHARS'),(14191,'STR_OSCOM_IMPORT_URL'),(14192,'STR_DOWNLOAD_EFT_FILE'),(14193,'STR_NO_BANK_INFO'),(14194,'STR_CREATE_EFT_FILE'),(14195,'STR_DUE_DATE_ON_OR_BEFORE'),(14196,'STR_EFT_FILE_HAS_BEEN_CREATED'),(14197,'STR_ENTER_EFT_PAYMENTS'),(14198,'STR_NO_PAYMENTS_SELECTED'),(14199,'STR_PRINT_PAID_INVOICES'),(14200,'STR_ADDITIONAL_LINE_ITEMS_IN_THE_SAME_BILL_ONLY_NEED_THE_VENDOR_NAME_AND_THE_INVOICE_NUMBER'),(14201,'STR_BILL_COLUMNS'),(14202,'STR_BILL_CSV_FILE'),(14203,'STR_COLUMN'),(14204,'STR_DEFAULTS_TO_CURRENT_DATE_IF_NOT_SET'),(14205,'STR_DESCRIPTION_FOR_THE_ENTIRE_BILL'),(14206,'STR_DOWNLOAD_IMPORT_TEMPLATE'),(14207,'STR_IF_NOT_SET_A_DATE_BASED_ON_TERMS_IS_USED'),(14208,'STR_INVOICE_NUMBER_ALREADY_USED'),(14209,'STR_LINE_ITEM_AMOUNT'),(14210,'STR_LINE_ITEM_GL_ACCOUNT_NUMBER'),(14211,'STR_MUST_HAVE_INVOICE_NUMBER_VENDOR_NAME_AMOUNT_AND_VALID_ACCOUNT_NUMBER'),(14212,'STR_ONLY_SET_IF_UPDATING_EXISTING_VENDORS'),(14213,'STR_PLEASE_DOWNLOAD_THE_IMPORT_TEMPLATE'),(14214,'STR_RECOMMENDED_FOR_NEW_VENDORS'),(14215,'STR_SET_IF_PAY_TO_AND_ORDER_FROM_ARE_DIFFERENT'),(14216,'STR_SKIPPING_ROW'),(14217,'STR_USES_VENDOR_DEFAULT_IF_NOT_SET'),(14218,'STR_USE_THE_IMPORT_TEMPLATE_ABOVE_TO_MAKE_YOUR_FILE'),(14219,'STR_VENDOR_BILL_IMPORT'),(14220,'STR_ADDITIONAL_LINE_ITEMS_IN_THE_SAME_INVOICE_ONLY_NEED_THE_COMPANY_NAME_OR_FIRST_AND_LAST_NAME_AND_THE_INVOICE_NUMBER'),(14221,'STR_CAN_BE_COMPANY_NAME_OR_FIRST_AND_LAST_NAME'),(14222,'STR_INVOICE_COLUMNS'),(14223,'STR_INVOICE_CSV_FILE'),(14224,'STR_INVOICE_IMPORT'),(14225,'STR_MUST_HAVE_INVOICE_NUMBER_AND_COMPANY_NAME_OR_FIRST_AND_LAST_NAME'),(14226,'STR_NAME_OF_THE_INVENTORY_LOCATION'),(14227,'STR_NAME_OF_THE_SALESPERSON'),(14228,'STR_NAME_OF_THE_SALES_CATEGORY'),(14229,'STR_NAME_OF_THE_TAX_IN_THE_SYSTEM'),(14230,'STR_ONLY_SET_IF_UPDATING_EXISTING_CUSTOMERS'),(14231,'STR_PRINT_IMPORTED_INVOICES'),(14232,'STR_RECOMMENDED_FOR_NEW_CUSTOMERS'),(14233,'STR_REQUIRED_UNLESS_COMPANY_NAME_IS_SET'),(14234,'STR_REQUIRED_UNLESS_FIRST_AND_LAST_NAME_ARE_SET'),(14235,'STR_SHIPPING_CHARGE_FOR_THE_WHOLE_ORDER'),(14236,'STR_USES_CUSTOMER_DEFAULT_IF_NOT_SET'),(14237,'STR_USES_DEFAULT_FROM_INVENTORY_IF_NOT_SET'),(14238,'STR_USES_DEFAULT_IF_NOT_SET'),(14239,'STR_ADJUST_OSCOMMERCE_SETTINGS'),(14240,'STR_IMPORT_ORDERS_SINCE_ORDER_NUMBER'),(14241,'STR_IMPORT_OSCOMMERCE_ORDERS'),(14242,'STR_MISMATCHED_API_KEY'),(14243,'STR_NO_NEW_ORDERS_FOUND'),(14244,'STR_OSCOMMERCE_ORDER'),(14245,'STR_PLEASE_ENTER_THE_OSCOM_IMPORT_URL'),(14246,'STR_VERIFY_YOU_HAVE_THE_CORRECT_URL_ENTERED'),(14247,'STR_A_AND_I_PRODUCTS_ON_HAND'),(14248,'STR_GET_A_AND_I_PRODUCTS_ON_HAND_LEVEL'),(14249,'STR_AVAILABLE_VALUE'),(14250,'STR_ITEM_COST'),(14251,'STR_MUST_SELECT_LOCATION'),(14252,'STR_ON_HAND_VALUE'),(14253,'STR_DIFFERENCE_IN_CALCULATED_COST'),(14254,'STR_A_AND_I_LEVEL'),(14255,'STR_NO_PRODUCT_FOUND_FOR_VENDOR'),(14256,'STR_CHECK_VOUCHER_ALREADY_CANCELED'),(14257,'STR_DEFAULT_SERVICE_WORK_TYPE'),(14258,'STR_IMPORT_INVOICES'),(14259,'STR_IMPORT_INVOICES_FROM_CSV_FILE'),(14260,'STR_IMPORT_VENDOR_BILLS'),(14261,'STR_IMPORT_VENDOR_BILLS_FROM_CSV_FILE'),(14262,'STR_AUTOCOMPLETE_PLACEHOLDER'),(14263,'STR_PLEASE_ENTER_A_PO_NUMBER'),(14264,'STR_DEFAULT_FULFILLMENT_ORDER_PAYMENT_METHOD_ON_B2B_SITE'),(14265,'STR_REQUIRE_A_PO_NUMBER_FOR_ORDER_ENTRY_ON_B2B_SITE'),(14266,'STR_LINE_ITEM_CSV_FILE'),(14267,'STR_SHOW_ORDER_VALUE_ON_ORDER_TICKET'),(14268,'STR_CLICK_PRINT_TO_SEND_EFT_PAYMENTS_TO_USA_EPAY_FOR_PROCESSING'),(14269,'STR_SEND_EFT_INFO_TO_USA_EPAY'),(14270,'STR_PAYMENT_ALREADY_SUBMITTED'),(14271,'STR_SET_WALK_IN_SALES_TAXES_FIRST'),(14272,'STR_NO_AVAILABLE_BANK_ACCOUNTS'),(14273,'STR_PROCESS_AUTO_BILLING'),(14274,'STR_THIS_COMPANY_IS_NOT_CONFIGURED_TO_PROCESS_ACH_TRANSACTIONS'),(14275,'STR_AMOUNT_SUCCESSFULLY_CHARGED'),(14276,'STR_AUTO_BILLING_REPORT'),(14277,'STR_BATCH'),(14278,'STR_PLEASE_SELECT_A_BATCH_OR_ENTER_A_CONFIRMATION_NUMBER'),(14279,'STR_SELECT_BATCH'),(14280,'STR_AMENDMENT_DOCUMENT_NAME'),(14281,'STR_AMENDMENT_TEMPLATE_ID'),(14282,'STR_GUARANTOR_DOCUMENT_NAME'),(14283,'STR_GUARANTOR_TEMPLATE_ID'),(14284,'STR_LEASE_TEMPLATE_ID_4_SIGNERS'),(14285,'STR_MONTHLY_PET_FEE'),(14286,'STR_MONTHS_BEFORE_MOVE_IN_DATE_FIRST_INVOICE_DUE'),(14287,'STR_PET_DOCUMENT_NAME'),(14288,'STR_PET_TEMPLATE_ID'),(14289,'STR_TERMINATION_DOCUMENT_NAME'),(14290,'STR_TERMINATION_TEMPLATE_ID_2_SIGNERS'),(14291,'STR_TERMINATION_TEMPLATE_ID_3_SIGNERS'),(14292,'STR_ARE_YOU_SURE_YOU_WANT_TO_TEST_ALL_CREDIT_CARDS_IN_ALL_COMPANIES'),(14293,'STR_CREDIT_CARD_MONTHLY_TEST_RESULTS'),(14294,'STR_CREDIT_CARD_TESTS_HAVE_COMPLETED'),(14295,'STR_CREDIT_CARD_TEST_RESULT_DETAILS'),(14296,'STR_FAILURES'),(14297,'STR_SUCCESSES'),(14298,'STR_TEST_CREDIT_CARDS'),(14299,'STR_TOTAL_CARDS'),(14300,'STR_VIEW_BATCH_RESULTS'),(14301,'STR_YOU_FIRST_MUST_SELECT_A_BATCH'),(14302,'STR_ALL_BUILDINGS'),(14303,'STR_GROUP_BY_UNIT_TYPE'),(14304,'STR_INCLUDE_OPEN_UNITS'),(14305,'STR_INCLUDE_UNSIGNED'),(14306,'STR_LEASE_START'),(14307,'STR_UNIT_TYPE'),(14308,'STR_CLEANING_DAMAGE_RELIEF'),(14309,'STR_CLEANING_DAMAGE_RELIEF_GL_ACCOUNT'),(14310,'STR_CLEANING_DAMAGE_RELIEF_RECONCILIATIONS'),(14311,'STR_CLEANING_DAMAGE_RELIEF_RETAINED'),(14312,'STR_CLEANING_DAMAGE_RELIEF_RETAINED_VOUCHER'),(14313,'STR_CLEANING_DAMAGE_RELIEF_RETURNED'),(14314,'STR_CLEANING_DAMAGE_RELIEF_RETURNED_INVOICE'),(14315,'STR_INITIAL_PET_FEE'),(14316,'STR_INITIAL_PET_FEE_GL_ACCOUNT'),(14317,'STR_INITIAL_PET_FEE_RETAINED'),(14318,'STR_INITIAL_PET_FEE_RETURNED'),(14319,'STR_AUTO_BILLING'),(14320,'STR_CLASS_OF_TENANT'),(14321,'STR_DATE_SIGNED'),(14322,'STR_END_DATE_OF_LEASE'),(14323,'STR_SIGNED_LEASES_MONTHLY'),(14324,'STR_START_DATE_OF_LEASE'),(14325,'STR_START_DATE_OF_LEASES'),(14326,'STR_ACTIVE_LEASE_AS_OF'),(14327,'STR_CURRENT_CITY'),(14328,'STR_CURRENT_STATE'),(14329,'STR_CURRENT_ZIP'),(14330,'STR_PERMANENT_CITY'),(14331,'STR_PERMANENT_STATE'),(14332,'STR_PERMANENT_ZIP'),(14333,'STR_SEND_EMAIL_TO_SELECTED'),(14334,'STR_SEND_GUARANTOR_EMAIL'),(14335,'STR_SEND_GUARANTOR_EMAILS'),(14336,'STR_UTILITY_AND_LATE_FEE_INVOICING'),(14337,'STR_TENANT_EMAIL'),(14338,'STR_TENANT_PHONE'),(14339,'STR_THE_FOLLOWING_WORK_ORDER_HAS_BEEN_APPROVED'),(14340,'STR_THE_FOLLOWING_WORK_ORDER_HAS_BEEN_DENIED'),(14341,'STR_DELETE_WORK_TYPE'),(14342,'STR_WORK_TYPE_ADD_FAILURE'),(14343,'STR_WORK_TYPE_DELETE'),(14344,'STR_WORK_TYPE_DELETED_FAILURE'),(14345,'STR_WORK_TYPE_UPDATE_FAILURE'),(14346,'STR_POTENTIALS_PIPELINE'),(14347,'STR_SETUP_PROPERTY_MANAGEMENT'),(14348,'STR_WORK_TYPE_ADD_UPDATE'),(14349,'STR_NO_DATA_HAS_BEEN_SET'),(14350,'STR_ORDER_DUE_DATE_BASED_ON_INVOICE_TERMS'),(14351,'STR_ORDER_NUMBER_POSITION_ON_LABEL_IN_POINTS'),(14352,'STR_QUANTITY_POSITION_ON_LABEL_IN_POINTS'),(14353,'STR_SHOW_ORDER_NUMBER'),(14354,'STR_SHOW_QUANTITY'),(14355,'STR_NEW_MANUAL_PAYMENT'),(14356,'STR_NEW_PO_TO_AP'),(14357,'STR_EMAIL_STATEMENTS_TO_ALL_MATCHING_CUSTOMERS'),(14358,'STR_EMAIL_STATEMENTS'),(14359,'STR_NO_EMAIL'),(14360,'STR_STATEMENT_EMAIL_PROGRESS'),(14361,'STR_SHIPPING_NOTES'),(14362,'STR_CANADIAN_EFT_FORMAT'),(14363,'STR_CIBC'),(14364,'STR_BEGINNING_DATE'),(14365,'STR_CLOSING_BALANCE'),(14366,'STR_CLOSING_DATE'),(14367,'STR_CLOSING_TOTALS'),(14368,'STR_CONTACT_NUMBER'),(14369,'STR_PO_CHECKLIST_SORT_ORDER'),(14370,'STR_AMERICAN_EXPRESS_TRANSFER'),(14371,'STR_AMEX_TRANSFER_ENTRY'),(14372,'STR_AUTHORIZENET_TRANSACTION_FILE'),(14373,'STR_IMPORT_AUTHORIZENET_TRANSACTIONS'),(14374,'STR_NO_REFERENCE_FOUND'),(14375,'STR_NO_REFERENCE_FOUND_TOTAL'),(14376,'STR_OTHER_CARD_TOTAL'),(14377,'STR_OTHER_CARD_TRANSFER'),(14378,'STR_OTHER_CARD_TRANSFER_ENTRY'),(14379,'STR_PLEASE_ENTER_A_FROM_GL_ACCOUNT'),(14380,'STR_PLEASE_ENTER_A_TO_GL_ACCOUNT'),(14381,'STR_PLEASE_ENTER_A_TRANSFER_DATE'),(14382,'STR_REFERENCE_FOUND_TOTAL'),(14383,'STR_SETTLEMENT_DATE'),(14384,'STR_TAB_DELIMITED'),(14385,'STR_TRANSACTION_INFO_PROCESSED_SUCCESSFULLY'),(14386,'STR_ASSIGN_PROPERTY_MANAGEMENT_PORTAL_ACCESS_TO_USERS_FIRST'),(14387,'STR_NEW_LEASE_FLAT_COMMISSION'),(14388,'STR_NEW_LEASE_PERCENT_COMMISSION'),(14389,'STR_OVER_30_DAYS_LATE_PERCENTAGE_COMMISSION_REDUCTION'),(14390,'STR_OVER_60_DAYS_LATE_PERCENTAGE_COMMISSION_REDUCTION'),(14391,'STR_OVER_90_DAYS_LATE_PERCENTAGE_COMMISSION_REDUCTION'),(14392,'STR_RENEW_LEASE_FLAT_COMMISSION'),(14393,'STR_RENEW_LEASE_PERCENT_COMMISSION'),(14394,'STR_CREATE_AN_APPLICATION_CUSTOMER_SURVEY'),(14395,'STR_APPEND'),(14396,'STR_MODE'),(14397,'STR_REPLACE'),(14398,'STR_STATES'),(14399,'STR_STATES_NEED_INITAILS_UPDATED'),(14400,'STR_BUSINESS_CHECKING'),(14401,'STR_FINAL_NOTICE'),(14402,'STR_FIRST_NOTICE'),(14403,'STR_SECOND_NOTICE'),(14404,'STR_ACCOUNT_NUMBERS_MUST_MATCH'),(14405,'STR_ADD_BANK_ACCOUNT'),(14406,'STR_BANK_ACCOUNTS'),(14407,'STR_BANK_ACCOUNTS_INSTRUCTIONS'),(14408,'STR_BANK_ACCOUNT_ADDED_SUCCESSFULLY'),(14409,'STR_BANK_ACCOUNT_HELP'),(14410,'STR_BANK_ACCOUNT_HELP_INSTRUCTIONS'),(14411,'STR_BANK_ACCOUNT_UPDATED_SUCCESSFULLY'),(14412,'STR_CONFIRM_ACCOUNT_NUMBER'),(14413,'STR_NAME_ON_ACCOUNT'),(14414,'STR_NOT_A_VALID_ROUTING_NUMBER'),(14415,'STR_NO_BANK_ACCOUNTS_FOUND'),(14416,'STR_THE_ROUTING_NUMBER_MUST_BE_9_DIGITS'),(14417,'STR_YOU_DO_NOT_HAVE_ACCESS_TO_THIS_BANK_ACCOUNT'),(14418,'STR_YOU_MUST_ENTER_AN_ACCOUNT_NUMBER'),(14419,'STR_YOU_MUST_ENTER_A_BANK_NAME'),(14420,'STR_YOU_MUST_ENTER_THE_NAME_ON_THE_ACCOUNT'),(14421,'STR_CHARGES_DELETED_SUCCESSFULLY'),(14422,'STR_DELETE_CHARGES'),(14423,'STR_DELETE_SELECTED_CHARGES'),(14424,'STR_ASSESS_LATE_FEE'),(14425,'STR_FEE_ASSESSED'),(14426,'STR_INVOICE_NOTIFICATIONS_AND_LATE_FEES'),(14427,'STR_LATE_FEE_ASSESSMENT'),(14428,'STR_LATE_NOTICE'),(14429,'STR_LATE_NOTICE_TEMPLATE'),(14430,'STR_AFTER_PAYING_THE_APPLICATION_FEE_YOU_WILL_BE_ABLE_COMPLETE_YOUR_APPLICATION'),(14431,'STR_AR_INVOICE_PREPAYMENT'),(14432,'STR_SELECT_ACCOUNT'),(14433,'STR_STORED_BANK_ACCOUNTS'),(14434,'STR_THIS_COMPANY_IS_NOT_SET_UP_TO_PROCESS_ACH_PAYMENTS'),(14435,'STR_ADD_AMENDMENT_SIGNING_REQUEST'),(14436,'STR_ADD_GUARANTOR_SIGNING_REQUEST'),(14437,'STR_ADD_PET_SIGNING_REQUEST'),(14438,'STR_ADD_TERMINATION_SIGNING_REQUEST'),(14439,'STR_CLEANING_DAMAGE_RELIEF_ACCOUNT'),(14440,'STR_CLEANING_DAMAGE_RELIEF_ADJUSTMENT'),(14441,'STR_CO_TENANT_2'),(14442,'STR_INITIAL_PET_FEE_ACCOUNT'),(14443,'STR_MONTHLY_PET_FEE_ACCOUNT'),(14444,'STR_PRE_PAYMENT'),(14445,'STR_SIGNER_3'),(14446,'STR_YOU_MUST_SELECT_A_CLEANING_DAMAGE_RELIEF_GL_ACCOUNT'),(14447,'STR_CO_TENANT_2_EMAIL'),(14448,'STR_INCLUDE_AN_INITIAL_PET_FEE'),(14449,'STR_INCLUDE_A_CLEANING_DAMAGE_RELIEF_AMOUNT'),(14450,'STR_PLEASE_SELECT_A_MOVE_IN_DATE'),(14451,'STR_PRE_PAYMENT_AMOUNT'),(14452,'STR_PRE_PAYMENT_DATE'),(14453,'STR_APP_SUBMITTED'),(14454,'STR_INCLUED_TERMINATED'),(14455,'STR_LAST_COM'),(14456,'STR_LAST_COM_DATE'),(14457,'STR_NEXT_COM_DATE'),(14458,'STR_NEXT_COM_TYPE'),(14459,'STR_ROOMMATES'),(14460,'STR_REQUESTED_ROOMMATES'),(14461,'STR_ROOMMATE_1'),(14462,'STR_ROOMMATE_2'),(14463,'STR_ROOMMATE_3'),(14464,'STR_FINALIZE'),(14465,'STR_SIGNING_STATUS'),(14466,'STR_CLEANING_DAMAGE_RELIEF_REFUND'),(14467,'STR_CLEANING_DAMAGE_RELIEF_REMAINDER'),(14468,'STR_CLEANING_DAMAGE_RELIEF_REVENUE'),(14469,'STR_CLEANING_DAMAGE_RELIEF_REVENUE_ACCOUNT'),(14470,'STR_INITIAL_PET_FEE_REFUND'),(14471,'STR_INITIAL_PET_FEE_REMAINDER'),(14472,'STR_CREATE_NEW_APPLICANT_ACCOUNT'),(14473,'STR_CREATE_NEW_APPLICANT_ACCOUNT_DESCRIPTION'),(14474,'STR_PROCEED_TO_APPLICATION'),(14475,'STR_AVAILABILITY_BEGIN_DATE'),(14476,'STR_AVAILABILITY_END_DATE'),(14477,'STR_PASSWORD_MUST_BE_AT_LEAST_8_CHARACTERS'),(14478,'STR_SET_NEW_PASSWORD'),(14479,'STR_SET_PASSWORD'),(14480,'STR_COMPLETED_DOCUMENT_REQUESTS'),(14481,'STR_DOCUMENT_REQUESTS'),(14482,'STR_PENDING_DOCUMENT_REQUESTS'),(14483,'STR_TENANT_3_SIGN'),(14484,'STR_MY_DOCUMENTS'),(14485,'STR_TENANT_PROFILE'),(14486,'STR_TENANT_PROFILE_INSTRUCTIONS'),(14487,'STR_MANAGE_BANK_ACCOUNTS'),(14488,'STR_PROFILE_AND_DOCUMENTS'),(14489,'STR_UPDATE_3DCART_SHIPPING_STATUS_AUTOMATICALLY'),(14490,'STR_EMAIL_REMITTANCES'),(14491,'STR_3DCART_SHIPPING_STATUS_UPDATED'),(14492,'STR_ERROR_UPDATING_3DCART_SHIPPING_STATUS'),(14493,'STR_THERE_WAS_AN_ISSUE_UPDATING_THE_3DCART_SHIPPING_STATUS'),(14494,'STR_3DCART_ORDER'),(14495,'STR_PLEASE_ENTER_A_TRACKING_NUMBER'),(14496,'STR_PROCESS_SHIPMENTS'),(14497,'STR_SHIP_3DCART_ORDERS'),(14498,'STR_EFT_PAYMENT'),(14499,'STR_REMITTANCE'),(14500,'STR_REMITTANCE_EMAILED'),(14501,'STR_REMITTANCE_EMAIL_PROGRESS'),(14502,'STR_MAXIMUM_NUMBER_OF_USERS_HAS_BEEN_EXCEEDED'),(14503,'STR_SB_USER_LIMIT'),(14504,'STR_CUSTOMER_3_YEAR_HISTORY'),(14505,'STR_YTD_SALES'),(14506,'STR_ON_XFER'),(14507,'STR_RECENT_ITEMS'),(14508,'STR_RECENT_VENDORS'),(14509,'STR_PRODUCT_REGISTRATION_AND_INITIAL_COMPANY_SETUP'),(14510,'STR_REPORTS_SELECTED'),(14511,'STR_SHOW_REPORTS'),(14512,'STR_TOP_TEN_PRINT_CUSTOMERS_30_DAYS'),(14513,'STR_INVENTORY_USAGE_BY_CATEGORY_30_DAY'),(14514,'STR_INVENTORY_USAGE_BY_CATEGORY_YEAR'),(14515,'STR_INCOME_AND_EXPENSES'),(14516,'STR_ACCOUNTING'),(14517,'STR_YTD_SALES_QTY'),(14518,'STR_REQUIRE_STATEMENT'),(14519,'STR_REMITTANCE_FOR_INVOICE'),(14520,'STR_INTERCOMPANY_ENTRY'),(14521,'STR_CANNOT_VIEW_INVENTORY_COSTS'),(14522,'STR_EXCLUDE_DELETED_ACCOUNTS'),(14523,'STR_SEARCH_FOR_BIN_SHELF_LOCATION'),(14524,'STR_WAREHOUSE_LOCATION'),(14525,'STR_AND_AUTO_EMAIL'),(14526,'STR_EMAIL_WHEN_INVOICED'),(14527,'STR_STATEMENT_DAY'),(14528,'STR_STATEMENT_MONTH'),(14529,'STR_STATEMENT_YEAR'),(14530,'STR_ALL_METHODS'),(14531,'STR_PAYMENT_METHODS_ALLOWED'),(14532,'STR_NOTE_SAVED_SUCCESSFULLY'),(14533,'STR_ORDER_LINE_ITEM_NOTES'),(14534,'STR_PLEASE_ENTER_A_NOTE'),(14535,'STR_PLEASE_ENTER_A_TITLE'),(14536,'STR_SELECT_DEFAULT_NOTE'),(14537,'STR_AVERAGE_RATE'),(14538,'STR_HOTEL_USAGE'),(14539,'STR_HOTEL_USAGE_STATISTICS'),(14540,'STR_HOTEL_USAGE_UPDATED_SUCCESSFULLY'),(14541,'STR_OCCUPANCY'),(14542,'STR_ROOMS_AVAILABLE'),(14543,'STR_ROOMS_RENTED'),(14544,'STR_TOTAL_ROOM_REVENUE'),(14545,'STR_EDIT_INTEREST_CHARGES'),(14546,'STR_CALCULATED_INTEREST'),(14547,'STR_CALCULATION_BEGIN_DATE'),(14548,'STR_CALCULATION_DATE'),(14549,'STR_CALCULATION_END_DATE'),(14550,'STR_INTEREST_ADJUSTMENTS'),(14551,'STR_INTEREST_CHARGES_UPDATED_SUCCESSFULLY'),(14552,'STR_INVOICE_PLUS_INTEREST'),(14553,'STR_SEARCH_OPEN_INVOICES'),(14554,'STR_NOT_AUTHORIZED_TO_VOID_PAYMENTS'),(14555,'STR_VOID_PAYMENT'),(14556,'STR_INVOICE_EMAILED_SUCCESSFULLY'),(14557,'STR_NO_SHIPPING___TAX'),(14558,'STR_NO_SIGNATURE_REQUIRED'),(14559,'STR_SITE'),(14560,'STR_SHOW_CUSTOMER_WHEN_RELEVANT'),(14561,'STR_AVERAGE_DAILY_RATE'),(14562,'STR_COMBINE_COMPANY_DATA'),(14563,'STR_DISPLAY_COMPANIES_SEPARATELY'),(14564,'STR_HOTEL_STATISTICS'),(14565,'STR_MULTI_COMPANY_DISPLAY'),(14566,'STR_PER_RR'),(14567,'STR_SUBTOTAL_EXPENSES_BY_COST_CENTER'),(14568,'STR_TOTAL_RENTED_ROOMS'),(14569,'STR_VERIFY_GL_SETUP'),(14570,'STR_FREIGHT_GL_ACCOUNT'),(14571,'STR_CLICK_TO_ADD_DEFAULT_LINE_NOTE'),(14572,'STR_SET_DEFAULT_NOTES_FOR_ORDER_LINE_ITEMS'),(14573,'STR_ACCOUNT_BELONGS_TO_OTHER_COMPANY'),(14574,'STR_DELETED_ACCOUNT'),(14575,'STR_NOT_SET'),(14576,'STR_REASSIGN_DELETED_ACCOUNTS'),(14577,'STR_SETTING'),(14578,'STR_YOUR_LEDGER_SETUP_HAS_ERRORS'),(14579,'STR_ACCOUNT_LIST'),(14580,'STR_ADD_EMPLOYEE'),(14581,'STR_ADD_SELECTED'),(14582,'STR_ALL_ENTRIES_UNFILTERED'),(14583,'STR_ALL_PAGES_FROM_SEARCH'),(14584,'STR_A_LONGER_PASSWORD_WOULD_BE_MORE_SECURE'),(14585,'STR_BACKGROUND'),(14586,'STR_BANK_DEPOSIT_LIST'),(14587,'STR_BORDER'),(14588,'STR_BROWN'),(14589,'STR_CC_BILL_LIST'),(14590,'STR_CC_PURCHASE_LIST'),(14591,'STR_CHANGE_SEARCH'),(14592,'STR_CHECK_LIST'),(14593,'STR_CREDIT_APPLIED_TO_ORDER'),(14594,'STR_CREDIT_CANCELED_FOR_ORDER'),(14595,'STR_CREDIT_CARD_BILLS'),(14596,'STR_CURRENTLY_SHOWN_PAGE'),(14597,'STR_DASHBOARD_REPORT'),(14598,'STR_DEFAULT_AUTOMATED_INVOICE_EMAIL_TEMPLATE'),(14599,'STR_EDIT_BANK_RECONCILIATIONS'),(14600,'STR_ENTRIES'),(14601,'STR_EXCLUDE_VOID'),(14602,'STR_EXPENSES_HOME'),(14603,'STR_FILTERED_FROM'),(14604,'STR_FIRS_TLINE'),(14605,'STR_GET_CHROME'),(14606,'STR_HEADER'),(14607,'STR_HIGHLIGHT'),(14608,'STR_HIGHLIGHT_TEXT'),(14609,'STR_HOMEBOARD_REPORTS'),(14610,'STR_IE_IS_OLD_UPDATE_NOTICE'),(14611,'STR_INCLUDE_DELETED'),(14612,'STR_INCOME_HOME'),(14613,'STR_INHERIT'),(14614,'STR_INNER_BORDER'),(14615,'STR_INTERFACE'),(14616,'STR_INVENTORY_HOME'),(14617,'STR_INVOICE_LIST'),(14618,'STR_JOURNAL_ENTRY_LIST'),(14619,'STR_LEDGER_HOME'),(14620,'STR_MARGIN_EXCEPTION'),(14621,'STR_MEMORY_LIMIT_PREVENTING_FURTURE_ROWS'),(14622,'STR_NEW_ITEM'),(14623,'STR_NO_LOWERCASE_CHARACTERS_FOUND'),(14624,'STR_NO_NUMBER_CHARACTERS_FOUND'),(14625,'STR_NO_SYMBOLS_FOUND'),(14626,'STR_NO_UPPERCASE_CHARACTERS_FOUND'),(14627,'STR_ORDER_LIST_'),(14628,'STR_PASSWORD_IS_TOO_SHORT_MUST_BE_SEVEN_CHAR_LONG'),(14629,'STR_PASSWORD_STRENGTH_IS_TOO_LOW'),(14630,'STR_PAYMENT_LIST'),(14631,'STR_PAYROLL_HOME'),(14632,'STR_RECURRING_ENTRIES'),(14633,'STR_RECURRING_ENTRY_LIST'),(14634,'STR_REPORT_TABLE'),(14635,'STR_SALES_PERSONNEL_LIST'),(14636,'STR_SAVE_AS'),(14637,'STR_SIDE_MENU'),(14638,'STR_SPREADSHEET'),(14639,'STR_SUB_GROUP_BACKGROUND'),(14640,'STR_SUB_GROUP_TEXT'),(14641,'STR_SUB_HEADER'),(14642,'STR_SUB_TASKBAR_BACKGROUND'),(14643,'STR_SUB_TASKBAR_TEXT'),(14644,'STR_SYSTEM'),(14645,'STR_TIMECLOCK_LIST'),(14646,'STR_TOO_MANY_ENTRIES_TO_SHOW'),(14647,'STR_TOP_MENU'),(14648,'STR_UI_STYLE'),(14649,'STR_USE_COMPANY_STYLE'),(14650,'STR_USE_SYSTEM_STYLE'),(14651,'STR_VENDOR_BILL_LIST'),(14652,'STR_WEBPAGE'),(14653,'STR_WE_RECOMMEND_THE_CHROME_BROWSER'),(14654,'STR_YOUR_BROWSER_IS_OUTDATED_AND_MAY_NOT_FUNCTION_PROPERLY_WITH_THIS_SOFTWARE'),(14655,'STR_REDIRECTING'),(14656,'STR_ENABLE_ADVANCED_API_TO_UPDATE_3DCART_STATUS'),(14657,'STR_STATUS_NOT_AVAILABLE'),(14658,'STR_PHONE_2'),(14659,'STR_3DCART_INVOICE_NUM'),(14660,'STR_ERROR_UPDATING_STATUS'),(14661,'STR_STATUS_UPDATED_SUCCESSFULLY'),(14662,'STR_CUSTOMER_START_DATE'),(14663,'STR_EDIT_IN_SPREADSHEET_PROGRAM'),(14664,'STR_EXPORT_CUSTOMER_DATA'),(14665,'STR_IMPORT_CUSTOMER_EXPORT_FILE'),(14666,'STR_IMPORT_MODIFIED_DATA'),(14667,'STR_UNCHECK_ALL'),(14668,'STR_ALL_DESCRIPTIONS'),(14669,'STR_NO_ORDERS_FOR_OVER_ONE_YEAR'),(14670,'STR_NO_ORDER_FOR_YEAR'),(14671,'STR_ONLY_THIS_DESCRIPTION'),(14672,'STR_SPECIFIC_ORDER_TAKER'),(14673,'STR_BACK_TO_CUSTOMER'),(14674,'STR_BACK_TO_DETAILS'),(14675,'STR_PENDING_CSR_ORDERS'),(14676,'STR_PENDING_ENVELOPE_IMPRESSIONS'),(14677,'STR_STANDARD_JOB_DESCRIPTION_ADD'),(14678,'STR_ERROR_INSERTING_VENDOR'),(14679,'STR_PASSWORDS_MUST_MATCH'),(14680,'STR_YOU_MUST_ENTER_A_PASSWORD'),(14681,'STR_DUPLICATE_MATCHES_FOUND'),(14682,'STR_MATCHES'),(14683,'STR_EXPORT_INVENTORY_DATA'),(14684,'STR_TIP_'),(14685,'STR_COPY_ADDRESS_TO_SHIP_TO'),(14686,'STR_COPY_TO_SHIP_TO'),(14687,'STR_CARD_IS_PRESENT'),(14688,'STR_PROCESSOR'),(14689,'STR_ACCOUNT_NUMBER_FOR_ACH_OR_EFT_PAYMENTS'),(14690,'STR_BILL_TO_ATTENTION'),(14691,'STR_COPY_ADDRESS_CHANGE_TO_DEFAULT_SHIP_TO'),(14692,'STR_IF_STATE_UNLISTED'),(14693,'STR_OFFICE'),(14694,'STR_QUOTE_ATTENTION'),(14695,'STR_SEND_INVOICE'),(14696,'STR_CSR_REPORT'),(14697,'STR_ENVELOPES_TO_PRINT'),(14698,'STR_NO_ORDERS_THIS_YEAR'),(14699,'STR_STANDARD_JOB_DESCRIPTIONS'),(14700,'STR_ADDITIONAL_SETUP_OPTIONS'),(14701,'STR_COPY_VENDORS_FROM_CURRENT_COMPANY'),(14702,'STR_CREATE_A_NEW_USER_ACCOUNT'),(14703,'STR_DEFAULT_ITEM_BARCODE_LABEL'),(14704,'STR_DEFAULT_ITEM_BARCODE_LABEL_FOR_ORDERS'),(14705,'STR_SINCE_YOUR_LAST_VISIT'),(14706,'STR_INVOICE_NUM'),(14707,'STR_INVOICE_VOLUME_1_YEAR'),(14708,'STR_PAYMENT_NUM'),(14709,'STR_INVOICE_VOLUME_1_WEEK'),(14710,'STR_TOP_10_CUSTOMERS_1_MONTH'),(14711,'STR_TOP_10_CUSTOMERS_1_YEAR'),(14712,'STR_INVOICES_NEARING_OR_OVER_DUE_DATE'),(14713,'STR_RECENT_PAYMENTS_1_WEEK'),(14714,'STR_INVENTORY_RECEIPTS_WITHOUT_PO_1_MONTH'),(14715,'STR_INVENTORY_RECEIPTS_WITH_PO_1_MONTH'),(14716,'STR_INVENTORY_USAGE_BY_CATEGORY_1_MONTH'),(14717,'STR_NEW_INVENTORY_ITEMS_1_MONTH'),(14718,'STR_RECENT_INVENTORY_ADJUSTMENTS_1_MONTH'),(14719,'STR_TOP_10_ITEMS_1_MONTH'),(14720,'STR_TOP_10_PROFIT_ITEMS_1_MONTH'),(14721,'STR_RECENT_INVENTORY_ADJUSTMENTS_30_DAYS'),(14722,'STR_NEW_INVENTORY_ITEMS_30_DAYS'),(14723,'STR_TOP_10_PROFIT_ITEMS'),(14724,'STR_INVENTORY_RECEIPTS_WITH_PO_30_DAYS'),(14725,'STR_INVENTORY_RECEIPTS_WITHOUT_PO_30_DAYS'),(14726,'STR_TOP_10_ITEMS'),(14727,'STR_PROFIT_1_YEAR'),(14728,'STR_JOURNAL_ENTRIES_1_WEEK'),(14729,'STR_SALES_1_WEEK'),(14730,'STR_SALES_1_YEAR'),(14731,'STR_SALES_8_WEEKS'),(14732,'STR_ORDER_VOLUME_1_YEAR'),(14733,'STR_ORDER_VOLUME_1_WEEK'),(14734,'STR_RECENTLY_ADDED_CUSTOMERS_30_DAYS'),(14735,'STR_RECENTLY_RECEIVED_ORDERS_7_DAYS'),(14736,'STR_RECENTLY_SHIPPED_ITEMS_30_DAYS'),(14737,'STR_RECENTLY_SHIPPED_ORDERS_30_DAYS'),(14738,'STR_TOP_10_CUSTOMERS'),(14739,'STR_ORDERS_NEAR_OR_OVER_DUE_DATE'),(14740,'STR_OPEN_QUOTES'),(14741,'STR_BILLS_VOLUME_1_YEAR'),(14742,'STR_BILLS_VOLUME_1_WEEK'),(14743,'STR_RECENT_CHECKS_WRITTEN_1_MONTH'),(14744,'STR_RECENT_CHECKS_WRITTEN_1_WEEK'),(14745,'STR_TOP_DOLLAR_VENDORS_1_MONTH'),(14746,'STR_TOP_DOLLAR_VENDORS_1_YEAR'),(14747,'STR_TOP_DOLLAR_VENDORS'),(14748,'STR_RECENT_PAY_RATE_CHANGES_1_WEEK'),(14749,'STR_RECENT_REVIEWS_1_WEEK'),(14750,'STR_TOP_TEN_PRINT_CUSTOMERS_1_MONTH'),(14751,'STR_ORDER_VOLUME_8_WEEKS'),(14752,'STR_TOP_10_ITEMS_1_YEAR'),(14753,'STR_TOP_10_PROFIT_CUSTOMERS_1_MONTH'),(14754,'STR_TOP_10_PROFIT_CUSTOMERS_1_YEAR'),(14755,'STR_TOP_10_PROFIT_ITEMS_1_YEAR'),(14756,'STR_TOP_10_SALES_STATES_1_MONTH'),(14757,'STR_TOP_10_SALES_STATES_1_YEAR'),(14758,'STR_ADD_BILL'),(14759,'STR_BILL_DUE_SOON'),(14760,'STR_IMPORT_BANK_STATEMENTS'),(14761,'STR_DELETION_USER'),(14762,'STR_END_DELETION_DATE'),(14763,'STR_IDENTIFIER'),(14764,'STR_VENDOR_REACTIVATED'),(14765,'STR_SHIP_ID'),(14766,'STR_VIEW_ORDER'),(14767,'STR_INVOICE_BALANCE'),(14768,'STR_UNINVOICED_VALUE'),(14769,'STR_SHIP_TO_BOX'),(14770,'STR_SOLD_TO_BOX'),(14771,'STR_VARIABLES'),(14772,'STR_SHOW_INVENTORY_STATUS_FOR_ITEM_OPTIONS'),(14773,'STR_INCLUDE_CREDIT_MEMOS'),(14774,'STR_3DCART_STATUS'),(14775,'STR_SET_3DCART_STATUS_TO_PROCESSING'),(14776,'STR_SET_3DCART_STATUS_TO_PROCESSING_FOR_SELECTED'),(14777,'STR_ACTION_ABORTED'),(14778,'STR_ACTIVE_COMPANY_CHANGED'),(14779,'STR_MAKE_ALL_MONTHS_SAME_AS_FIRST_MONTH'),(14780,'STR_INCLUDE_DELETED_ACCOUNTS'),(14781,'STR_ONLY_FOR_SPECIFIC_CUSTOMER'),(14782,'STR_EMAIL_ONE_COMMENT'),(14783,'STR_EMAIL_TWO_COMMENT'),(14784,'STR_FULL_NAME'),(14785,'STR_TRANSLATION_ACCURACY_NOTICE'),(14786,'STR_TRANSLATION_INCORRECT_ASSIST_NOTICE'),(14787,'STR_TRANSLATION_GUIDE'),(14788,'STR_UPDATE_3DCART_PRICES_AUTOMATICALLY'),(14789,'STR_REQUIRE_PO_NUMBER_FOR_ORDERS'),(14790,'STR_ZEN_CART'),(14791,'STR_PRICE_UPDATES_HAVE_BEEN_SENT_FOR_BACKGROUND_PROCESSING'),(14792,'STR_UPDATE_3DCART_PRICES'),(14793,'STR_YOU_MUST_ENTER_A_PO_NUMBER'),(14794,'STR_FISCAL_YEAR_TOTAL'),(14795,'STR_VIEW_CUSTOMER_DETAILS'),(14796,'STR_NUMBER_OF_INVOICE_COPIES'),(14797,'STR_ZEN_CART_INTEGRATION_DEFAULTS'),(14798,'STR_GT_30_DAYS'),(14799,'STR_SHOW_LINE_FOR_TOTAL_QUANTITY_ON_INVOICE'),(14800,'STR_ADDITIONAL_LINE_ITEMS_IN_THE_SAME_INVOICE_ONLY_NEED_THE_CUSTOMER_ID_OR_COMPANY_NAME_OR_FIRST_AND_LAST_NAME_AND_THE_INVOICE_NUMBER'),(14801,'STR_CUSTOMER_ID_NOT_FOUND_AND_NAME_INFO_NOT_PROVIDED'),(14802,'STR_MUST_HAVE_INVOICE_NUMBER_AND_CUSTOMER_ID_OR_COMPANY_NAME_OR_FIRST_AND_LAST_NAME'),(14803,'STR_REQUIRED_UNLESS_COMPANY_NAME_OR_FIRST_AND_LAST_NAME_ARE_SET'),(14804,'STR_REQUIRED_UNLESS_CUSTOMER_ID_OR_COMPANY_NAME_IS_SET'),(14805,'STR_REQUIRED_UNLESS_CUSTOMER_ID_OR_FIRST_AND_LAST_NAME_ARE_SET'),(14806,'STR_COULD_NOT_FIND_UNIT'),(14807,'STR_IMPORT_REVENUE'),(14808,'STR_RECORD_APPEARS_TO_HAVE_ALREADY_BEEN_IMPORTED'),(14809,'STR_SELECT_REVENUE_EXCEL_FILE'),(14810,'STR_A_BATCH_HAS_NOT_BEEN_STARTED_YET'),(14811,'STR_RECORD_INFO_NOT_SET'),(14812,'STR_GT_90_DAYS'),(14813,'STR_GT_60_DAYS'),(14814,'STR_CONDITIONS'),(14815,'STR_DATE_GENERAL'),(14816,'STR_DATE_ISO'),(14817,'STR_DATE_US'),(14818,'STR_EQUALS'),(14819,'STR_JOIN'),(14820,'STR_LIKE'),(14821,'STR_NOT_EQUAL'),(14822,'STR_NOT_LIKE'),(14823,'STR_QUERY_ERROR'),(14824,'STR_RUN'),(14825,'STR_SQL'),(14826,'STR_SQL_AND'),(14827,'STR_SQL_OR'),(14828,'STR_SQL_XOR'),(14829,'STR_WARN_EXIT_NO_SAVE'),(14830,'STR_MOBILE_POS'),(14831,'STR_MAIN_MENU'),(14832,'STR_ADD_ITEM'),(14833,'STR_ADD_CONDITION'),(14834,'STR_ADD_GROUP'),(14835,'STR_DRAG_LINK_HERE'),(14836,'STR_FORMAT'),(14837,'STR_GROUP_BY'),(14838,'STR_SELECT_FIELD'),(14839,'STR_SET_AS_SELECT_FROM'),(14840,'STR_SHOW_SUB_GROUP_TOTALS'),(14841,'STR_STATIC'),(14842,'STR_USER_INPUT'),(14843,'STR_SELECT_FROM'),(14844,'STR_SELECT_VALUES'),(14845,'STR_AUTO_FIX'),(14846,'STR_INVALID_TABLE_JOINING'),(14847,'STR_TABLES_NEED_JOINED'),(14848,'STR_QUERY'),(14849,'STR_QUERY_ADD'),(14850,'STR_NAV_AWAY_FROM_UI_WARNING'),(14851,'STR_PREPARING_LAYOUT'),(14852,'STR_3DCART_ITEM_IDS_LAST_RETRIEVED'),(14853,'STR_3DCART_ITEM_IDS_RETRIEVED_SUCCESSFULLY'),(14854,'STR_ENABLE_ADVANCED_API_TO_SHIP_3DCART_ORDERS'),(14855,'STR_GET_3DCART_ITEM_IDS'),(14856,'STR_GET_3DCART_ITEM_IDS_TO_ALLOW_LINKING_TO_3DCART_PRODUCT_PAGE'),(14857,'STR_NOT_ABLE_TO_RETRIEVE_ITEMS'),(14858,'STR_CUSTOMERS_SHOW_ON_MOBILE_POS'),(14859,'STR_AP_BILL_PMT'),(14860,'STR_BATCH_DATE'),(14861,'STR_BATCH_REPORT'),(14862,'STR_BATCH_TYPE'),(14863,'STR_CUSTOMER_SLASH_VENDOR'),(14864,'STR_HIDE_JMR'),(14865,'STR_HIDE_OWNERS'),(14866,'STR_HIDE_RPR'),(14867,'STR_INACTIVE_UNIT'),(14868,'STR_INVOICE_PMT'),(14869,'STR_LIMIT_OUTPUT'),(14870,'STR_NO_BATCHES_FOUND'),(14871,'STR_RECORD_TYPE'),(14872,'STR_REVENUE'),(14873,'STR_SHOW_RECORD_TYPES'),(14874,'STR_3DCART_ORDERS_IN_PROCESSING_STATUS'),(14875,'STR_NOT_ABLE_TO_RETRIEVE_ORDERS_IN_PROCESSING_STATUS'),(14876,'STR_NO_ORDERS_FOUND_IN_THE_PROCESSING_STATUS'),(14877,'STR_NO_SHIPMENTS_SELECTED'),(14878,'STR_SHIPMENT_INFO_SENT_TO_3DCART'),(14879,'STR_CREATE_NEW_ORDER'),(14880,'STR_CURRENTLY_DUE'),(14881,'STR_ADRESS_1'),(14882,'STR_ADRESS_2'),(14883,'STR_CITY_STATE_AND_ZIP'),(14884,'STR_NO_ORDERS'),(14885,'STR_NO_ORDERS_SINCE'),(14886,'STR_USER_LIST'),(14887,'STR_CANNOT_ADD_ENTRY_TO_CLOSED_YEAR'),(14888,'STR_CANNOT_UNPOST_VOUCHERS_FROM_A_CLOSED_YEAR'),(14889,'STR_UNPOST_VOUCHERS_POSTED_ON'),(14890,'STR_ACCOUNTS_RECEIVABLE_GL_ACCOUNT'),(14891,'STR_COULD_NOT_FIND_CUSTOMER_SO_NO_INVOICE_CREATED'),(14892,'STR_EXPENSES_IMPORTED_SUCCESSFULLY'),(14893,'STR_IMPORT_EXPENSES'),(14894,'STR_SELECT_EXPENSE_EXCEL_FILE'),(14895,'STR_UNIT_IS_INACTIVE'),(14896,'STR_VIEW_BATCH_DETAILS'),(14897,'STR_IMPORTED_REVENUE_DATA'),(14898,'STR_VIEW_3DCART_PRODUCT_PAGE'),(14899,'STR_SHOW_IN_MOBILE_POS'),(14900,'STR_USE_ITEM_CATEGORY_SETTING'),(14901,'STR_SHOW_ON_MOBILE_POS'),(14902,'STR_BASED_ON_AVERAGE_SALES_OVER_PAST_YEAR'),(14903,'STR_IGNORED_ITEMS'),(14904,'STR_IGNORE_IF_CURRENT_SUPPLY_IS_OVER'),(14905,'STR_NO_SALES_HISTORY_AVAILABLE'),(14906,'STR_SALES_FORECAST_BASED_ON'),(14907,'STR_SHOW_ONLY_ITEMS_WITH_A_LOCATION_WITHIN_WAREHOUSE_ASSIGNED'),(14908,'STR_USAGE_FORECAST'),(14909,'STR_CHANGED_BY'),(14910,'STR_LOCATION_WITHIN_WAREHOUSE_HISTORY'),(14911,'STR_USED_UNTIL'),(14912,'STR_VIEW_PAST_LOCATIONS_WITHIN_WAREHOUSE'),(14913,'STR_RECEIVE'),(14914,'STR_YOU_MUST_ENTER_AN_EMAIL_ADDRESS'),(14915,'STR_YOU_MUST_ENTER_A_PHONE_NUMBER'),(14916,'STR_SAVE_TO_ADD_MORE_LINES'),(14917,'STR_PHP_CURL_REQUIRED'),(14918,'STR_ADD_NEW_DEFAULT_GL_ACCOUNT'),(14919,'STR_DEFAULT_COMPANY_LOCATION'),(14920,'STR_USER_IS_MOBILE_POS_ACCESS_ONLY'),(14921,'STR_AUTO_CHARGE_INVOICE_ON_DUE_DATE'),(14922,'STR_LEASE_APPLICATION'),(14923,'STR_ACTIVE_TENANTS'),(14924,'STR_OUT_OF_STOCK'),(14925,'STR_ALLOW_DISCOUNT_OVERRIDE_WHEN_ENTERING_PAYMENTS'),(14926,'STR_IF_NO_SHIP_CHARGE_ON_ORDER_USE_ACTUAL_SHIP_CHARGE_FOR_INVOICE'),(14927,'STR_SEPARATE_BY_SHIP_TO'),(14928,'STR_ERROR_PROCESSING_FILE'),(14929,'STR_FILE_MUST_BE_IN_CSV_FORMAT'),(14930,'STR_FILE_MUST_BE_LESS_THAN_4_MB'),(14931,'STR_THE_FOLLOWING_LINE_CANNOT_SHIP_OVERSEAS'),(14932,'STR_UPLOAD_LINE_ITEM_CSV_FILE'),(14933,'STR_DELETE_SIGNATURE'),(14934,'STR_SIGNATURE_FILE'),(14935,'STR_ADDED_ITEM'),(14936,'STR_API_ACCOUNT'),(14937,'STR_API_USER'),(14938,'STR_IMPORTING'),(14939,'STR_MAGENTO_IMAGE_CATALOG'),(14940,'STR_MAGENTO_INVENTORY'),(14941,'STR_MAGENTO_STORE'),(14942,'STR_SENDING_IMAGE'),(14943,'STR_SITE_BASE_URL'),(14944,'STR_SYNC_INVENTORY'),(14945,'STR_SYNC_INVENTORY_IMAGES'),(14946,'STR_UPDATED'),(14947,'STR_UPDATED_ITEM'),(14948,'STR_DESRIPTION'),(14949,'STR_LINK_TO_AP_CONTACTS'),(14950,'STR_LINK_TO_AR_CONTACTS'),(14951,'STR_TASK'),(14952,'STR_TASKS'),(14953,'STR_TASK_ACTION'),(14954,'STR_TASK_ACTIONS'),(14955,'STR_TASK_STATUS'),(14956,'STR_TASK_STATUSES'),(14957,'STR_CONNECTING'),(14958,'STR_EXPORTING'),(14959,'STR_RECEIVED_PRODUCT_LIST'),(14960,'STR_DMGD'),(14961,'STR_RECVD'),(14962,'STR_RTRND'),(14963,'STR_SHOW_HIDE_PO_INFO'),(14964,'STR_USE_OTHER_COST_IF_SELECTED_IS_0'),(14965,'STR_BASE_IMAGE'),(14966,'STR_EXCLUDE'),(14967,'STR_LABEL'),(14968,'STR_MAGENTO_CATALOG_IMAGES'),(14969,'STR_NO_IMAGE'),(14970,'STR_SMALL_IMAGE'),(14971,'STR_THUMBNAIL'),(14972,'STR_QTY_REMAINING'),(14973,'STR_SHOW_HIDE_ORDER_DETAILS'),(14974,'STR_MAGENTO'),(14975,'STR_MAGENTO_INTEGRATION'),(14976,'STR_IMPORT_COMPLETE'),(14977,'STR_MULTIPLE'),(14978,'STR_ADDING'),(14979,'STR_FILE_IS_CORRUPT'),(14980,'STR_SYNC'),(14981,'STR_UPDATING'),(14982,'STR_VENDOR_PURCHASE_ORDERS'),(14983,'STR_CONTACT_FILE_COLUMN_FORMAT'),(14984,'STR_IMPORT_FROM_CSV_FILE'),(14985,'STR_REFERENCE_NAME'),(14986,'STR_PLEASE_SELECT_A_VENDOR'),(14987,'STR_BILL_PAY'),(14988,'STR_BACKDATE_UNRECEIVING_INVENTORY'),(14989,'STR_ADD_PAYMENTS_FOR_ALL_SELECTED'),(14990,'STR_BANK_BALANCE'),(14991,'STR_BILL_NUMBER'),(14992,'STR_PAYMENTS_SAVED_SUCCESSFULLY'),(14993,'STR_PAY_BILLS_FOR_CLIENTS'),(14994,'STR_RPR_INVOICE_NUMBER'),(14995,'STR_SELECTED_AMOUNT'),(14996,'STR_INCLUDE_LEADS'),(14997,'STR_LEADS'),(14998,'STR_ALL_TAX_DISTRICTS'),(14999,'STR_IF_IMPORTING_FOR_VENDORS_WITH_A_CURRENCY_OTHER_THAN_THE_BASE_CURRENCY_AUTOMATIC_RATES_WILL_BE_USED_UNLESS_MANUALLY_ENTERED'),(15000,'STR_PLEASE_SET_A_CURRENCY_TRADING_ACCOUNT_AND_TRY_AGAIN'),(15001,'STR_PLEASE_UPDATE_CONVERSION_AND_TRY_AGAIN'),(15002,'STR_SET_CURRENCY_CONVERSION_RATES'),(15003,'STR_LIST_ON_EBAY'),(15004,'STR_NEW_PURCHASE_PROPOSAL'),(15005,'STR_PURCHASE_PROPOSAL'),(15006,'STR_SAVE_AS_PROPOSAL'),(15007,'STR_PURCHASE_PROPOSAL_CHECKLIST'),(15008,'STR_PROPOSAL'),(15009,'STR_SHOW_PROPOSALS'),(15010,'STR_CONVERT_TO_PROPOSAL'),(15011,'STR_CONVERT_TO_PURCHASE_ORDER'),(15012,'STR_EDIT_PURCHASE_PROPOSAL'),(15013,'STR_PURCHASE_ORDER_CONVERTED_TO_A_PROPOSAL'),(15014,'STR_PURCHASE_PROPOSAL_CONVERTED_TO_AN_ORDER'),(15015,'STR_UPDATE_PURCHASE_PROPOSAL'),(15016,'STR_SEARCH_LEADS'),(15017,'STR_SAVE_NEW_CUSTOMER_AS_A_LEAD'),(15018,'STR_ASSIGN_USERS'),(15019,'STR_ASSIGN_USER_GROUPS'),(15020,'STR_AUTO_ASSIGN_CONTACTS'),(15021,'STR_BEGIN_ZIP_RANGE'),(15022,'STR_CONTACTS_ARE_EXCLUSIVE'),(15023,'STR_CONTACT_LINKING'),(15024,'STR_END_ZIP_RANGE'),(15025,'STR_FILTERS'),(15026,'STR_IGNORE_STATUSES'),(15027,'STR_LEADS_ONLY'),(15028,'STR_NON_LEADS_ONLY'),(15029,'STR_PLEASE_ADD_A_TASK'),(15030,'STR_TASK_DELETED_SUCESSFULLY'),(15031,'STR_TASK_INFO_SAVED_SUCESSFULLY'),(15032,'STR_TASK_NEW_EDIT'),(15033,'STR_USER_ASSIGNMENT'),(15034,'STR_TASK_ACTION_DELETED_SUCESSFULLY'),(15035,'STR_TASK_ACTION_NEW_EDIT'),(15036,'STR_TASK_ACTION_SAVED_SUCESSFULLY'),(15037,'STR_TASK_STATUS_DELETED_SUCESSFULLY'),(15038,'STR_TASK_STATUS_NEW_EDIT'),(15039,'STR_TASK_STATUS_SAVED_SUCESSFULLY'),(15040,'STR_ACTIVITY_DELETED_SUCESSFULLY'),(15041,'STR_ADD_ACTIVITY'),(15042,'STR_ADD_ACTIVITY_FOR_DIFFERENT_CUSTOMER'),(15043,'STR_ADD_ACTIVITY_FOR_DIFFERENT_VENDOR'),(15044,'STR_ADD_NEW_ACTIVITY'),(15045,'STR_ADD_NEW_ACTIVITY_FOR_TASK'),(15046,'STR_AMOUNT_CONFIDENCE'),(15047,'STR_CONTACT_AUTOMATICALLY_ASSIGNED'),(15048,'STR_CURRENT_ACTION'),(15049,'STR_ESTIMATED_PURCHASE_AMOUNT'),(15050,'STR_ESTIMATED_SALES_AMOUNT'),(15051,'STR_EXCLUSIVE_CONTACT_HAS_ALREADY_BEEN_ASSIGNED'),(15052,'STR_FILTER_LIST'),(15053,'STR_LAST_ACTION_BEGIN'),(15054,'STR_LAST_ACTION_DATE'),(15055,'STR_LAST_ACTION_END'),(15056,'STR_LAST_NOTE'),(15057,'STR_LAST_NOTES'),(15058,'STR_MY_ACTIVITY'),(15059,'STR_NEW_ACTIVITY'),(15060,'STR_NEXT_ACTION'),(15061,'STR_NEXT_ACTION_BEGIN'),(15062,'STR_NEXT_ACTION_DATE'),(15063,'STR_NEXT_ACTION_END'),(15064,'STR_NO_CONTACT'),(15065,'STR_NO_CUSTOMERS_AVAILABLE_FOR_ASSIGNMENT'),(15066,'STR_NO_TASKS_ASSIGNED'),(15067,'STR_NO_VENDORS_AVAILABLE_FOR_ASSIGNMENT'),(15068,'STR_PURCHASE_AMOUNT_CONFIDENCE'),(15069,'STR_SALES_AMOUNT_CONFIDENCE'),(15070,'STR_VIEW_ACTIVITY'),(15071,'STR_YOU_HAVE_BEEN_ASSIGNED_THE_FOLLOWING_CONTACT'),(15072,'STR_MONTHS_FOR_PROX_CALCULATION'),(15073,'STR_MONTHS_FOR_PROX_CALCULATION_OF_DISCOUNT_DATE'),(15074,'STR_MONTHS_FOR_PROX_CALCULATION_OF_DUE_DATE'),(15075,'STR_TIME_ZONE'),(15076,'STR_USE_COMPANY_TIMEZONE'),(15077,'STR_VENDOR_IS_A_LEAD'),(15078,'STR_CUSTOMER_IS_A_LEAD'),(15079,'STR_IS_LEAD'),(15080,'STR_IMPORT_CUSTOMERS_CONTACTS'),(15081,'STR_IMPORT_VENDORS_CONTACTS'),(15082,'STR_POS_BY_VENDOR'),(15083,'STR_CAN_ONLY_CREATE_PURCHASE_PROPOSALS_NOT_POS'),(15084,'STR_UPDATING_MAGENTO'),(15085,'STR_ALL_ACTIVITY_FOR_CONTACT'),(15086,'STR_ALL_ACTIVITY_FOR_CUSTOMER'),(15087,'STR_ALL_ACTIVITY_FOR_VENDOR'),(15088,'STR_JUST_THIS_TASK_AND_CONTACT'),(15089,'STR_JUST_THIS_TASK_AND_CUSTOMER'),(15090,'STR_JUST_THIS_TASK_AND_VENDOR'),(15091,'STR_NO_HISTORY_DATA_FOUND'),(15092,'STR_PLEASE_CREATE_A_TASK_ACTION'),(15093,'STR_PLEASE_CREATE_A_TASK_STATUS'),(15094,'STR_ACCOUNT_HISTORY'),(15095,'STR_SHOW_BARCODE_ON_ORDER_CONFIRMATION'),(15096,'STR_ADJUST_MAGENTO_SETTINGS'),(15097,'STR_ERROR_RETRIEVING_ORDERS'),(15098,'STR_FROM_ORDER_NUMBER'),(15099,'STR_IMPORT_MAGENTO_ORDERS'),(15100,'STR_ONLY_200_ORDERS_CAN_BE_BROUGHT_IN_AT_ONE_TIME'),(15101,'STR_ORDER_NUM'),(15102,'STR_SET_AN_ORDER_NUMBER_TO_GET_ORDERS_FROM_THAT_ORDER_NUMBER_ON'),(15103,'STR_SET_STAGE'),(15104,'STR_CURRENT_STAGE'),(15105,'STR_PREVIOUS_STAGE'),(15106,'STR_DOTMED_ITEM_EXPORT'),(15107,'STR_ACTUAL_SHIPPING'),(15108,'STR_ACTUAL_WEIGHT'),(15109,'STR_BEGIN_ORDER_DATE'),(15110,'STR_END_ORDER_DATE'),(15111,'STR_EST_SHIPPING'),(15112,'STR_EST_WEIGHT'),(15113,'STR_SHIPPING_DIFFERENCE'),(15114,'STR_SHIPPING_ESTIMATES_VS_ACTUALS'),(15115,'STR_SHIP_METHOD'),(15116,'STR_WEIGHT_DIFFERENCE'),(15117,'STR_YOU_MUST_ENTER_GL_ACCOUNTS_AND_AMOUNTS_THAT_OFFSET_THE_TRANSACTION_TOTAL'),(15118,'STR_EXPORT_DOTMED_ITEMS'),(15119,'STR_EMAIL_CUSTOMERS'),(15120,'STR_INVOICES_WITH_ITEMS'),(15121,'STR_AUTOMATICALLY_RETRIEVED_ORDER'),(15122,'STR_COULD_NOT_FIND_STORE'),(15123,'STR_MAGENTO_ORDER'),(15124,'STR_INSERT_ITEM'),(15125,'STR_3DCART_SITE_DELETED_SUCCESSFULLY'),(15126,'STR_INVOICE_USING_CURRENT_DATE_RATHER_THAN_PAYMENT_PLAN_DATE'),(15127,'STR_COST_METHOD_FOR_PHYSICAL_INVENTORY'),(15128,'STR_BEGIN_DISCOUNT_DATE'),(15129,'STR_DISCOUNT_DATES'),(15130,'STR_END_DISCOUNT_DATE'),(15131,'STR_CALC'),(15132,'STR_ADD_LOGIN_INFO_BY_EDITING_CARRIER'),(15133,'STR_DIMENSIONS'),(15134,'STR_L_X_W_X_H'),(15135,'STR_USING_GENERIC_QUOTING_TOOL'),(15136,'STR_USING_YOUR_UPS_CREDENTIALS'),(15137,'STR_INCHES'),(15138,'STR_ITEM_SHIPS_BY_ITSELF'),(15139,'STR_SHIPPING_DIMENSIONS'),(15140,'STR_ADD_NEW_IMAGE'),(15141,'STR_ACCESS_KEY'),(15142,'STR_CARRIER_SITE_LOGIN'),(15143,'STR_CARRIER_SITE_PASSWORD'),(15144,'STR_DEFAULT_SHIPPING_DIMENSIONS'),(15145,'STR_ENTER_NEW_PASSWORD_TO_CHANGE'),(15146,'STR_FLAT_AMOUNT_TO_ADD_TO_QUOTE'),(15147,'STR_MAX_BOX_WEIGHT'),(15148,'STR_NEW_PACKAGE_CALCULATED_AFTER_THIS_WEIGHT'),(15149,'STR_PERCENT_TO_ADD_TO_QUOTE'),(15150,'STR_OPEN_IN_NEW_TAB'),(15151,'STR_SHIPPING_HEIGHT'),(15152,'STR_SHIPPING_LENGTH'),(15153,'STR_SHIPPING_WIDTH'),(15154,'STR_UPS_2DA'),(15155,'STR_SHOW_CUSTOMER_OR_VENDOR_WHEN_RELEVANT'),(15156,'STR_AGING'),(15157,'STR_3DCART_EXTENDED_DESCRIPTIONS_RETRIEVED_SUCCESSFULLY'),(15158,'STR_3DCART_NOT_FOR_SALE_SETTINGS_RETRIEVED_SUCCESSFULLY'),(15159,'STR_IMPORT_EXTENDED_DESCRIPTIONS_FROM_THIS_3DCART_STORE'),(15160,'STR_IMPORT_EXTENDED_DESCRIPTIONS_IF_NOT_CURRENTLY_SET'),(15161,'STR_IMPORT_NOT_FOR_SALE_SETTINGS_FROM_THIS_3DCART_STORE'),(15162,'STR_UPDATE_3DCART_EXTENDED_DESCRIPTIONS_AUTOMATICALLY'),(15163,'STR_UPDATE_3DCART_NOT_FOR_SALE_SETTINGS_AUTOMATICALLY'),(15164,'STR_HIDE_LINE_TOTALS'),(15165,'STR_HIDE_PRICE_EACH'),(15166,'STR_SHOW_QUANTITY_WEIGHT'),(15167,'STR_SPLIT_THE_ITEM_CODE_AND_DESCRIPTION'),(15168,'STR_CANNOT_SEARCH_BY_BOTH_VENDOR_AND_CUSTOMER'),(15169,'STR_INCLUDE_NON_INVENTORY_ITEMS'),(15170,'STR_SEARCH_NON_INVENTORY_DESCRIPTION'),(15171,'STR_CLICK_TO_SHOW_BILLED_AND_CLOSED'),(15172,'STR_COMPLETE_WITH_NO_SHIPMENTS'),(15173,'STR_INVOICES_FOR_ORDER'),(15174,'STR_MARK_ORDER_COMPLETE'),(15175,'STR_ORDER_HAS_BEEN_MARKED_COMPLETE'),(15176,'STR_ORDER_IS_NOT_FULLY_BILLED'),(15177,'STR_ORDER_IS_NOT_FULLY_SHIPPED'),(15178,'STR_NUMBER_OF_UPDATES_SENT'),(15179,'STR_UPDATING_NOT_FOR_SALE_SETTINGS_AT_3DCART'),(15180,'STR_UPDATING_PRODUCT_DESCRIPTIONS_AT_3DCART'),(15181,'STR_NOT_FOR_SALE'),(15182,'STR_NOT_FOR_SALE_ONLY'),(15183,'STR_BETA_INTERFACE'),(15184,'STR_NP6_INTERFACE'),(15185,'STR_USER_MUST_LOGOUT'),(15186,'STR_LAST_UPDATED_ITEM'),(15187,'STR_STOCK_LEVEL_UPDATES_SENT_FOR_BACKGROUND_PROCESSING'),(15188,'STR_UPDATE_3DCART_STOCK_LEVELS_AUTOMATICALLY'),(15189,'STR_UPDATE_STOCK_LEVELS_FOR_THIS_3DCART_STORE'),(15190,'STR_VIEW_LAST_UPDATED_ITEM'),(15191,'STR_LAST_3DCART_STOCK_UPDATE'),(15192,'STR_PENDING_MOVE_INS_OUTS'),(15193,'STR_EXPERIMENTAL'),(15194,'STR_SHOW_BOM_SUB_ITEMS_ON_PICK_LIST_AND_ORDER_CONFIRMATION'),(15195,'STR_SHOW_WARNING_IF_PRINTED_MORE_THAN_ONCE'),(15196,'STR_AVAILABLE_QUANTITY'),(15197,'STR_ON_HAND_QUANTITY'),(15198,'STR_REMOTE_UPDATES_USE'),(15199,'STR_PROPERTY_MANAGEMENT_WORK_ORDERS_GO_TO_COMPANY'),(15200,'STR_VIEW_EDIT_VENDOR'),(15201,'STR_ACCOUNT_OPEN'),(15202,'STR_VIEW_EDIT_CUSTOMER'),(15203,'STR_LAST_PRINTED'),(15204,'STR_PRINT_AGAIN'),(15205,'STR_THE_FOLLOWING_ORDERS_HAVE_BEEN_PRINTED_PREVIOUSLY'),(15206,'STR_TIMES_PRINTED'),(15207,'STR_A_AND_I_ORDER'),(15208,'STR_GET_A_AND_I_TRACKING_NUMBERS'),(15209,'STR_TRACKING_NUMBER_NOT_FOUND'),(15210,'STR_BATCHES'),(15211,'STR_ITEMS_HAVE_BEEN_SENT_FOR_PROCESSING'),(15212,'STR_LOG_FILES'),(15213,'STR_START_UPDATES'),(15214,'STR_UPDATE_3DCART_WITH_A_AND_I_PRODUCTS_LEVELS'),(15215,'STR_TASK_ACTIVITY'),(15216,'STR_A_AND_I_PRODUCTS_3DCART_UPDATE'),(15217,'STR_ACH_EFT'),(15218,'STR_BILL_PAYMENTS'),(15219,'STR_BILL_PMT'),(15220,'STR_CLEARED'),(15221,'STR_ORDERING'),(15222,'STR_PARTIALLY_SHIPPED'),(15223,'STR_SHOW_NEXT_50'),(15224,'STR_REPORT_BUILDER'),(15225,'STR_ELAPSED_TIME'),(15226,'STR_ELAPSED'),(15227,'STR_NOT_CLOCKED_IN'),(15228,'STR_IMPORT_SHORT_DESCRIPTIONS_FROM_THIS_3DCART_STORE'),(15229,'STR_IMPORT_SHORT_DESCRIPTIONS_IF_NOT_CURRENTLY_SET'),(15230,'STR_UPDATE_3DCART_CUSTOMER_INFO_AUTOMATICALLY'),(15231,'STR_UPDATE_3DCART_SHORT_DESCRIPTIONS_AUTOMATICALLY'),(15232,'STR_LEADING_PHONE_DIGITS_TO_REMOVE_WHEN_PASSED_IN_URL'),(15233,'STR_CUSTOMER_NOT_FOUND_FOR_PHONE_NUMBER'),(15234,'STR_EXPORT_5_YEAR_SALES_HISTORY'),(15235,'STR_EXPORT_SALES_HISTORY_RANGE'),(15236,'STR_SALES_BEGIN_DATE'),(15237,'STR_SALES_END_DATE'),(15238,'STR_UPDATING_SHORT_DESCRIPTIONS_AT_3DCART'),(15239,'STR_FEATURES_EXPIRED'),(15240,'STR_FEATURES_WILL_SOON_EXPIRE'),(15241,'STR_NOTICE'),(15242,'STR_ICON'),(15243,'STR_REPORT_GROUP'),(15244,'STR_COMPANIES'),(15245,'STR_LICENSE'),(15246,'STR_A_CUSTOMER_OR_VENDOR_CAN_ONLY_BE_ASSIGNED_TO_ONE_USER_UNDER_THIS_TASK_IF_CHECKED'),(15247,'STR_CUSTOMERS_OR_VENDORS_WILL_BE_AUTOMATICALLY_ASSIGNED_TO_USERS_BASED_ON_THE_SEARCH_FILTERS_BELOW'),(15248,'STR_NEW_CUSTOMER_ACTIVITY'),(15249,'STR_NEW_VENDOR_ACTIVITY'),(15250,'STR_CELL'),(15251,'STR_OVER_TRANSACTION_LIMIT_NOTICE'),(15252,'STR_NEW_FULFILLMENT_QUOTE_ORDER'),(15253,'STR_NEW_PAYMENT'),(15254,'STR_NEW_SERVICE_ORDER'),(15255,'STR_SEARCH_DESCRIPTION'),(15256,'STR_VIEW_EDIT_ORDER'),(15257,'STR_TIME_SAVED_SUCCESSFULLY'),(15258,'STR_INCLUDE_ALL_MISSED_NEXT_ACTIONS'),(15259,'STR_SHOW_ALL_RECENT_AND_UPCOMING_NEXT_ACTIONS'),(15260,'STR_JUST_CRM_ACTIVITY'),(15261,'STR_VRM_ACTIVITY'),(15262,'STR_DATE_AND_TIME_GENERAL'),(15263,'STR_DATE_AND_TIME_ISO'),(15264,'STR_DATE_AND_TIME_US'),(15265,'STR_SELECT_A_FROM_TABLE'),(15266,'STR_FIREDAY'),(15267,'STR_WEEK_STARTS_ON'),(15268,'STR_WENDESDAY'),(15269,'STR_CHANGE_SITE'),(15270,'STR_CURRENT_COMPANY_ID'),(15271,'STR_CURRENT_USER_ID'),(15272,'STR_SHOW_TOTALS'),(15273,'STR_NO_SELECT_MADE'),(15274,'STR_REPORT_INCLUDES_BOTH_DELETE_AND_ACTIVE_DATA'),(15275,'STR_REPORT_INCLUDES_DATA_FROM_MULTIPLE_COMPANIES'),(15276,'STR_TABLES_WITH_CANCEL_FIELD_UNCHECKED'),(15277,'STR_TABLES_WITH_COMPANY_ID_FIELD_UNCHECKED'),(15278,'STR_3DCART_WEIGHTS_RETRIEVED_SUCCESSFULLY'),(15279,'STR_IMPORT_WEIGHTS_FROM_THIS_3DCART_STORE'),(15280,'STR_IMPORT_WEIGHTS_IF_NOT_CURRENTLY_SET'),(15281,'STR_UPDATE_3DCART_PRODUCT_NAMES_AUTOMATICALLY'),(15282,'STR_UPDATE_3DCART_WEIGHTS_AUTOMATICALLY'),(15283,'STR_BLOCK_ADDING_AND_EDITING_CUSTOMERS_ON_FULFILLMENT_AND_POS_ORDERS'),(15284,'STR_ORDER_FORMAT'),(15285,'STR_SAME_AS_INVOICE'),(15286,'STR_BLOCK_INVOICES_PAST_END_DATE'),(15287,'STR_HAS_A_PAST_ORDER_OF'),(15288,'STR_ACTIVATE_CODE'),(15289,'STR_MANAGE_FEATURES'),(15290,'STR_MY_SUBSCRIPTION'),(15291,'STR_NEW_SUBSCRIPTION_FEE'),(15292,'STR_NO_PURCHASES'),(15293,'STR_TRIAL_ENDS'),(15294,'STR_TRIAL_EXPIRED'),(15295,'STR_DATA_ALLOWANCE'),(15296,'STR_RENEWS'),(15297,'STR_END_TRIAL'),(15298,'STR_INVALID_VALUE'),(15299,'STR_MO'),(15300,'STR_SUBSCRIPTION_CHANGES'),(15301,'STR_MANAGE_SUBSCRIPTION_FEATURES'),(15302,'STR_NO_ACTIVE_SUBSCRIPTION_FOUND'),(15303,'STR_SUBSCRIPTION_FEE'),(15304,'STR_UPDATING_PRODUCT_NAMES_AT_3DCART'),(15305,'STR_UPDATING_WEIGHTS_AT_3DCART'),(15306,'STR_3DCART_PRODUCT_PAGE'),(15307,'STR_CONFIRMATIONS'),(15308,'STR_ITEM_COSTS_MASS_EDIT'),(15309,'STR_MOBILE_POS_REQUIRES_INVENTORY_ADDON'),(15310,'STR_INCREASE_LIMIT'),(15311,'STR_TRANSACTIONS_SINCE'),(15312,'STR_TRANSACTION_LIMIT'),(15313,'STR_COSTS_UPDATED_SUCCESSFULLY'),(15314,'STR_WARNING_THIS_METHOD_OF_EDITING_COSTS_WILL_NOT_POST_CHANGES_TO_GL'),(15315,'STR_CHANGES_SAVED'),(15316,'STR_LEAVE_BLANK_FOR_NO_CHANGE'),(15317,'STR_SET_LOCATION'),(15318,'STR_SET_QTY_ON_HAND'),(15319,'STR_LINE_TOTAL'),(15320,'STR_PO_TABLE_FORMAT'),(15321,'STR_QUANTITY_PRICE'),(15322,'STR_SHOW_PURCHASE_QUANTITY_ONLY_ON_PO_CHECKLIST'),(15323,'STR_SUPPRESS_LINE_NUMBER_ON_PO_CHECKLIST'),(15324,'STR_DEFAULT_VENDOR_FOR_POS'),(15325,'STR_RECEIVE_AUTO_POS_BY_DEFAULT'),(15326,'STR_SHOW_ORDER_ACCEPTED_BY_USER'),(15327,'STR_USE_ORDER_NUMBER_FOR_PO_NUMBER_IN_AUTO_POS'),(15328,'STR_SHIP_TO_COUNTY'),(15329,'STR_ORDER_ACCEPTED_BY'),(15330,'STR_UPDATE_SUBSCRIPTION_BILLING'),(15331,'STR_I_AUTHORIZE_NOLAPRO_TO_CHARGE_MY_PAYMENT_METHOD_ON_FILE_FOR_THIS_SUBSCRIPTION'),(15332,'STR_SUBSCRIPTION_UPDATED'),(15333,'STR_ENTER_BILLING_INFORMATION'),(15334,'STR_INVALID_LOCATION_ID'),(15335,'STR_INVALID_VENDOR_ID'),(15336,'STR_INVENTORY_DATA_IMPORTED_PARTIALLY'),(15337,'STR_MULTIPLE_ITEMS_FOUND'),(15338,'STR_NO_ORDER_ID'),(15339,'STR_NO_VENDOR_ID'),(15340,'STR_PO_NUMBER_ALREADY_USED'),(15341,'STR_AUTO_CREATE_PO'),(15342,'STR_AUTO_RECEIVE_PO'),(15343,'STR_AUTO_SHIP_ORDER'),(15344,'STR_CREATING_SHIPMENT'),(15345,'STR_ERROR_CREATING_PO'),(15346,'STR_ERROR_CREATING_SHIPMENT'),(15347,'STR_SHIPMENTS_EXIST'),(15348,'STR_VIEW_SHIPMENT'),(15349,'STR_COUNTY'),(15350,'STR_BACKUP_SKIPPED'),(15351,'STR_ALIGN'),(15352,'STR_VISIBLE'),(15353,'STR_LEAVE_BLANK_IF_SAME_AS_LOGIN'),(15354,'STR_CREATED'),(15355,'STR_MOBILE_LOCATION_MANAGE'),(15356,'STR_PROCESS_PAYROLL'),(15357,'STR_ADVANCED_SHIPPING_MANAGER_STORE_ID'),(15358,'STR_ADVANCED_SHIPPING_MANAGER_STORE_NAME'),(15359,'STR_STATEMENT_MESSAGE_IF_BANK_INFO_EXISTS'),(15360,'STR_STATEMENT_MESSAGE_IF_NO_BANK_INFO_EXISTS'),(15361,'STR_PLEASE_ENABLE_CLASSIC_SMTP_FOR_GOOGLE'),(15362,'STR_INVENTORY_COUNT_DECIMALS'),(15363,'STR_UNDO'),(15364,'STR_ADVANCED_SHIPPING_MANAGER_QUOTES'),(15365,'STR_CLICK_RATE_TO_SELECT'),(15366,'STR_INACTIVE_ITEM_NAME_OR_CODE'),(15367,'STR_ACCOUNTS_TABLE'),(15368,'STR_BANK_DEPOSITS_TABLE'),(15369,'STR_BUDGETS_TABLE'),(15370,'STR_CHECKS_TABLE'),(15371,'STR_CREDIT_CARD_PURCHASES_TABLE'),(15372,'STR_CUSTOMER_TABLE'),(15373,'STR_EMPLOYEE_TABLE'),(15374,'STR_INVOICES_TABLE'),(15375,'STR_ITEMS_TABLE'),(15376,'STR_JOURNAL_ENTRIES_TABLE'),(15377,'STR_ORDERS_TABLE'),(15378,'STR_PAYMENTS_TABLE'),(15379,'STR_PAYMENT_PLANS_TABLE'),(15380,'STR_PURCHASE_ORDERS_TABLE'),(15381,'STR_SALES_PERSONNEL_TABLE'),(15382,'STR_TIMECLOCK_TABLE'),(15383,'STR_VENDOR_BILLS_TABLE'),(15384,'STR_VENDOR_TABLE'),(15385,'STR_SLOW_CPU_MODE'),(15386,'STR_TO_ENSURE_A_CORRECT_PRINT_PLEASE_USE_PRINT_FROM_THE_LINKS_MENU'),(15387,'STR_SHOW_UPS_ACCOUNT_ON_INVOICE_PDF_IF_SET'),(15388,'STR_FREIGHT_CHARGES_BILLED_TO_UPS'),(15389,'STR_DEPARTMENTS'),(15390,'STR_WORKERS_COMP_CODES'),(15391,'STR_INVOICE_MUST_BE_POSTED_TO_MAKE_PAYMENT'),(15392,'STR_HIDE_SSN_LAST_4_FROM_CHECK'),(15393,'STR_SOCIAL_SECURITY_EXPENSE'),(15394,'STR_SOCIAL_SECURITY_PAYABLE'),(15395,'STR_COMPANY_SS_MEDICARE'),(15396,'STR_EMPLOYEE_SS_MEDICARE'),(15397,'STR_DISPLAY_TRAILING_ZEROS'),(15398,'STR_ARE_YOU_SURE_YOU_WISH_TO_DELETE_DUPLICATE_TAXES'),(15399,'STR_DELETE_DUPLICATE_TAXES'),(15400,'STR_REMOVED'),(15401,'STR_REMOVE_DUPLICATE_TAXES'),(15402,'STR_INCOMPLETE'),(15403,'STR_CURRENT_DEPARTMENTS'),(15404,'STR_DEPARTMENT_CODE'),(15405,'STR_DEPARTMENT_NAME'),(15406,'STR_FEDERAL_UNEMPLOYMENT_INSURANCE_EXPENSE'),(15407,'STR_GENERAL_LEDGER_DEFAULLTS'),(15408,'STR_NO_DEPARTMENTS_EXIST'),(15409,'STR_PLEASE_ENTER_A_DEPARTMENT_NAME'),(15410,'STR_SAVE_FAILED'),(15411,'STR_STATE_UNEMPLOYMENT_INSURANCE_EXPENSE'),(15412,'STR_WAGE_EXPENSE'),(15413,'STR_WORKERS_COMP_EXPENSE'),(15414,'STR_ARE_YOU_SURE_YOU_WANT_TO_POST_OUT_OF_PERIOD'),(15415,'STR_SS'),(15416,'STR_CO_SS_TAX'),(15417,'STR_SS_TAX'),(15418,'STR_SHOW_ONLY_TOTALS'),(15419,'STR_DEDUCTIONS_TO_DATE'),(15420,'STR_DEDUCTION_METHOD'),(15421,'STR_MAXIMUM_AMOUNT'),(15422,'STR_NO_DEDUCTIONS'),(15423,'STR_PERIODS_REMAINING'),(15424,'STR_WORKERS_COMP_CODE'),(15425,'STR_EMPLOYEE_REVIEW'),(15426,'STR_ADD_TIME'),(15427,'STR_ADDITIONAL_TAXES'),(15428,'STR_ADVANCED_EIC_PAYMENTS'),(15429,'STR_AGE'),(15430,'STR_ALLOCATED_TIPS'),(15431,'STR_BENEFITS'),(15432,'STR_CITY_EXTRA'),(15433,'STR_CITY_INFO_THROUGH'),(15434,'STR_CITY_STATUS'),(15435,'STR_D'),(15436,'STR_DEDUCTIONS_AND_PENSIONS'),(15437,'STR_DEDUCTIONS_DETAIL'),(15438,'STR_DEDUCTIONS_LIST'),(15439,'STR_DEDUCTIONS_SUMMARY'),(15440,'STR_DEDUCTIONS_THROUGH'),(15441,'STR_DEDUCTION_MAX'),(15442,'STR_DEPARTMENT_LIST'),(15443,'STR_DEPARTMENT_SUMMARY'),(15444,'STR_DEPARTMENT_WAGES_SUMMARY'),(15445,'STR_EMPLOYEE_DETAIL'),(15446,'STR_EMPLOYEE_TAX_WITHHOLDING_SUMMARY'),(15447,'STR_EXEMPT_WAGES'),(15448,'STR_FEDERAL_INFO_THROUGH'),(15449,'STR_FEDERAL_TAXES_WITHHELD'),(15450,'STR_FEDERAL_UNEMPLOYMENT_TAXES'),(15451,'STR_FED_EXEMPTIONS'),(15452,'STR_FED_EXTRA'),(15453,'STR_FED_STATUS'),(15454,'STR_FED_WITHHELD'),(15455,'STR_FUI_GL'),(15456,'STR_FUI_WAGES'),(15457,'STR_GRAND_TOTALS_THROUGH'),(15458,'STR_GROSS_WAGES'),(15459,'STR_HIRE_LENGTH'),(15460,'STR_HOURS_AND_WAGES'),(15461,'STR_INCLUDE_COLUMNS_FOR'),(15462,'STR_LOCALITY'),(15463,'STR_LOCAL_EXTRA'),(15464,'STR_LOCAL_INFO_THROUGH'),(15465,'STR_LOCAL_STATUS'),(15466,'STR_MEDICARE_GL'),(15467,'STR_MEDICARE_TAXES_WITHHELD'),(15468,'STR_MED_WAGES'),(15469,'STR_MED_WITHHELD'),(15470,'STR_MOS'),(15471,'STR_MTD'),(15472,'STR_MTD_AMOUNT'),(15473,'STR_MTD_AMT'),(15474,'STR_MTD_EXCESS'),(15475,'STR_MTD_HOURS'),(15476,'STR_MTD_TAX'),(15477,'STR_MTD_TAXABLE'),(15478,'STR_MTD_WAGES'),(15479,'STR_ONLY_INCLUDE_PAID_PERIODS'),(15480,'STR_PAYABLE_GL'),(15481,'STR_PAYROLL_INFO'),(15482,'STR_PAY_THROUGH'),(15483,'STR_PERIODS_INCLUDED'),(15484,'STR_QTD'),(15485,'STR_QTD_AMOUNT'),(15486,'STR_QTD_AMT'),(15487,'STR_QTD_EXCESS'),(15488,'STR_QTD_HOURS'),(15489,'STR_QTD_TAX'),(15490,'STR_QTD_TAXABLE'),(15491,'STR_QTD_WAGES'),(15492,'STR_RANGE_HOURS'),(15493,'STR_RANGE_TAX'),(15494,'STR_RANGE_WAGES'),(15495,'STR_SHELTERED_FROM'),(15496,'STR_SOCIAL_SECURITY_GL'),(15497,'STR_SS_TAX_WITHHELD'),(15498,'STR_SS_TIPS'),(15499,'STR_SS_WAGES'),(15500,'STR_SS_WITHHELD'),(15501,'STR_STATE_EXTRA'),(15502,'STR_STATE_INFO_THROUGH'),(15503,'STR_STATE_STATUS'),(15504,'STR_STATE_TAX_WITHHELD'),(15505,'STR_STATE_UNEMPLOYMENT_TAXES'),(15506,'STR_SUI_GL'),(15507,'STR_SUI_WAGES'),(15508,'STR_WAGE_GL'),(15509,'STR_WITHHELD'),(15510,'STR_WORKERS_COMP'),(15511,'STR_WORKERS_COMPENSATION_DETAIL'),(15512,'STR_WORKERS_COMPENSATION_SUMMARY'),(15513,'STR_WORKERS_COMP_GL'),(15514,'STR_YRS'),(15515,'STR_YTD_AMOUNT'),(15516,'STR_YTD_EXCESS'),(15517,'STR_YTD_HOURS'),(15518,'STR_YTD_MAX'),(15519,'STR_YTD_TAX'),(15520,'STR_YTD_TAXABLE'),(15521,'STR_YTD_WAGES'),(15522,'STR_CURRENT_WORKERS_COMP_CODES'),(15523,'STR_NO_WORKERS_COMP_ENTRIES_EXIST'),(15524,'STR_PLEASE_ENTER_A_CODE'),(15525,'STR_SOCIAL_SECURITY_TAX'),(15526,'STR_DATABASE_BUILD'),(15527,'STR_DATABASE_VERSION_DOES_NOT_MATCH_SOFTWARE'),(15528,'STR_DOWNLOAD_UPDATE_PACKAGE'),(15529,'STR_DO_NOT_SHOW_AGAIN'),(15530,'STR_IT_IS_RECOMMENED_THAT_YOU_PERFORM_A_MANUAL_UPDATE'),(15531,'STR_SOFTWARE_BUILD'),(15532,'STR_NO_PERIODS_IN_DATE_RANGE'),(15533,'STR_IT_IS_RECOMMENDED_THAT_YOU_PERFORM_A_MANUAL_UPDATE'),(15534,'STR_AS_ORDERED'),(15535,'STR_PO_CHECKLIST_TABLE_FORMAT'),(15536,'STR_DISPLAY_LINE_ITEM_DATE_BOX'),(15537,'STR_SHOW_CUSTOM_FIELDS_BEFORE_NOTES'),(15538,'STR_TAX_CLASSES'),(15539,'STR_DEFAULT_TAX_CLASS'),(15540,'STR_BREAK_OUT_BY_TAX_CLASS'),(15541,'STR_CLASS_AMOUNT'),(15542,'STR_CLASS_TOTAL'),(15543,'STR_NO_TAX_CLASS_ASSIGNED'),(15544,'STR_TAX_CLASS'),(15545,'STR_UNABLE_TO_AUTO_BUILD_ALL_OF_ITEM'),(15546,'STR_SHIP_ANOTHER_ORDER'),(15547,'STR_CURRENT_TAX_CLASSES'),(15548,'STR_NON_TAXABLE'),(15549,'STR_NO_TAX_CLASSES_EXIST'),(15550,'STR_PLEASE_ENTER_A_NAME'),(15551,'STR_UNABLE_TO_MAKE_ALL'),(15552,'STR_INCORRECT_FILE_TYPE'),(15553,'STR_ADD_JOB'),(15554,'STR_CREATE_NEW_JOB_WITH_EACH_NEW_CUSTOMER'),(15555,'STR_ADD_NEW_JOB'),(15556,'STR_CUSTOMER_OR_INVOICE_NOT_FOUND'),(15557,'STR_ENTER_PAYMENT'),(15558,'STR_FAILED_TO_ENTER'),(15559,'STR_IMPORT_INVOICES_FROM_QUICKBOOKS_CSV_EXPORT'),(15560,'STR_IMPORT_PAYMENTS_FROM_QUICKBOOKS_CUSTOMER_BALANCE_DETAIL_CSV_EXPORT'),(15561,'STR_NEW_PAYMENTS_ENTERED'),(15562,'STR_NO_OPEN_INVOICES_FOUND_TO_APPLY_PAYMENT_TO'),(15563,'STR_PAYMENT_RECORD_SKIPPED'),(15564,'STR_COMPARE_VENDOR_PRICING'),(15565,'STR_NEW_COST'),(15566,'STR_NEW_QUANTITY'),(15567,'STR_BANK_INSURANCE_AND_ARCHITECT'),(15568,'STR_CANNOT_PERFORM_DELETION_THERE_ARE_EXISTING_PO_SB_RECEIPTS'),(15569,'STR_DELETE_ALL_PO_SB_AND_JOB_BUDGET_DATA_FOR_JOB'),(15570,'STR_JOB_INACTIVE'),(15571,'STR_NUMBER_OF_JOB_BUDGET_ENTRIES_DELETED'),(15572,'STR_NUMBER_OF_POS_SBS_DELETED'),(15573,'STR_PO_SB_AND_JOB_BUDGET_DATA_HAS_BEEN_REMOVED_FOR_THIS_JOB'),(15574,'STR_REMOVE_THE_ABOVE_RECEIPTS_FIRST_THEN_TRY_AGAIN'),(15575,'STR_THIS_WILL_DELETE_ALL_PO_SB_AND_JOB_BUDGET_DATA_FOR_THIS_JOB'),(15576,'STR_SELECT_COST_CODE'),(15577,'STR_REVISION_NUMBER'),(15578,'STR_ARE_YOU_SURE_YOU_WISH_TO_ACTIVATE_THIS'),(15579,'STR_CHANGES_CAN_ONLY_BE_SAVED_AFTER_ACTIVATING'),(15580,'STR_DEV_CO'),(15581,'STR_FEASIBILITY'),(15582,'STR_LOAN_CONTRIBUTION_DEV_CO'),(15583,'STR_LOAN_CONTRIBUTION_PARENT'),(15584,'STR_PARENT'),(15585,'STR_PROJECT_NEW_EDIT'),(15586,'STR_PLEASE_ENTER_A_SITE_CODE'),(15587,'STR_PLEASE_ENTER_A_SITE_NAME'),(15588,'STR_SELECT_SITE'),(15589,'STR_SITE_NEW_EDIT'),(15590,'STR_JOBS_TABLE'),(15591,'STR_PROJECT_DOCUMENTS'),(15592,'STR_ONE_OF_THE_FOLLOWING_PERMISSIONS_ARE_NEEDED'),(15593,'STR_PREMISSIONS_TABLE_IS_CORRUPT'),(15594,'STR_REQUIRED_PERMISSIONS_NOT_FOUND'),(15595,'STR_CANNOT_EDIT_ITEM_COSTS_AND_QUANTITIES_WITH_EXPORT_IMPORT_TOOL'),(15596,'STR_PLEASE_CREATE_A_SITE'),(15597,'STR_BILLED_ITEMS'),(15598,'STR_COSTS'),(15599,'STR_COSTS_TOTAL'),(15600,'STR_INVOICES_TOTAL'),(15601,'STR_PURCHASE_ORDERS_TOTAL'),(15602,'STR_SET_PO_NUMBER_FROM_QUESTION_WITH_ID'),(15603,'STR_HIDE_ADD_JOB_BUTTONS'),(15604,'STR_USE_POS_FOR_ALL_NEW_INVOICES'),(15605,'STR_AUTO_BUILD_BOM_LIMITED_BY_COMPONENTS'),(15606,'STR_CLEAR_SICK_HOURS_EACH_YEAR'),(15607,'STR_CLEAR_VACATION_HOURS_EACH_YEAR'),(15608,'STR_RETAIN_EARNED_IN_LAST_MONTH'),(15609,'STR_SICK_AND_VACATION_COUNT_YEAR_BEGINS'),(15610,'STR_VACATION_AND_SICK_LEAVE_BENEFITS'),(15611,'STR_PAY_TO_NAME_FOR_CHECKS'),(15612,'STR_IF_DIFFERENT_FROM_ABOVE'),(15613,'STR_BLOCK_SICK_ACCRUAL'),(15614,'STR_BLOCK_VACATION_ACCRUAL'),(15615,'STR_LOGIN_RIGHTS'),(15616,'STR_MAXIMUM_TAXABLE_WAGES_PER_EMPLOYEE'),(15617,'STR_TAX_DUE'),(15618,'STR_SUBMIT_ORDER'),(15619,'STR_ITEM_BILLED_HISTORY'),(15620,'STR_MISSING_ID'),(15621,'STR_VENDOR_ITEMS'),(15622,'STR_HIDE_LINE_NUMBERS'),(15623,'STR_HIDE_SHIP_TO_INFO'),(15624,'STR_HIDE_UNIT_NAMES'),(15625,'STR_LABEL_POS_PRINTOUT_AS_INVOICE_INSTEAD_OF_SALES_RECEIPT'),(15626,'STR_SHOW_CUSTOM_FIELDS_SELECTED_BELOW_IN_SHIP_TO_AREA'),(15627,'STR_SHOW_DESCRIPTION_COLUMN_BEFORE_QUANTITY_COLUMN'),(15628,'STR_PRINT_CONSOLIDATED_PICK_LIST'),(15629,'STR_PRINT_SELECTED_CONSOLIDATED_PICK_LIST'),(15630,'STR_PRINT_SELECTED_PICK_LIST'),(15631,'STR_INVENTORY_PICK_LIST'),(15632,'STR_CONSOLIDATED_PICK_LIST'),(15633,'STR_INVENTORY_ORDER_PICK_LIST'),(15634,'STR_SAVE_TO_BOM_DEFINITION'),(15635,'STR_SICK_HOURS_EXCEED_AVAILABLE_SICK_TIME'),(15636,'STR_VACATION_HOURS_EXCEED_AVAILABLE_VACATION_TIME'),(15637,'STR_RETRY'),(15638,'STR_JOB_COSTS_TOTAL'),(15639,'STR_LABOR_COSTS_TOTAL'),(15640,'STR_VENDOR_COSTS_TOTAL'),(15641,'STR_LABOR_COSTS'),(15642,'STR_SCALE'),(15643,'STR_ALWAYS_ROUND_DOWN'),(15644,'STR_ALWAYS_ROUND_UP'),(15645,'STR_ONLY_SPECIFIC_USERS'),(15646,'STR_REQUIRED_NUMBER_OF_APPROVERS_PER_BILL'),(15647,'STR_ROUND_DEFAULT_PAY_DATE_ON_PREAPPROVED'),(15648,'STR_ROUND_NEAREST'),(15649,'STR_ROUND_TO_AFTER_HOLIDAY'),(15650,'STR_ROUND_TO_AFTER_WEEKEND'),(15651,'STR_ROUND_TO_DATES'),(15652,'STR_STANDARD_ACCESS'),(15653,'STR_USA_HOLIDAYS_ONLY'),(15654,'STR_WHO_CAN_APPROVE_BILLS'),(15655,'STR_HIDE_JOB_NAME_COLUMN_IN_JOBS_TABLE'),(15656,'STR_HIDE_SHIFT_BOXES_WHEN_LOGGING_HOURS'),(15657,'STR_OVERTIME'),(15658,'STR_OVERTIME_DEDUCTS_FROM_STRAIGHT_TIME_WHEN_LOGGING_HOURS'),(15659,'STR_PLEASE_SELECT_OVERTIME'),(15660,'STR_PLEASE_SELECT_STRAIGHT_TIME'),(15661,'STR_SCALE_HOURS'),(15662,'STR_SHOW_DATE_BOXES_WHEN_LOGGING_HOURS'),(15663,'STR_STRAIGHT_TIME'),(15664,'STR_CLEANING_UP'),(15665,'STR_COMPARING_DATABASE_STRUCTURE'),(15666,'STR_CREATING_TEMPORARY_TABLE'),(15667,'STR_LEGACY_DB_UPDATE_CHECK'),(15668,'STR_PERPARING_DB_FOR_UPDATE'),(15669,'STR_READING_DB_UPDATE_FILE'),(15670,'STR_STARTING_DB_UPDATE'),(15671,'STR_UPDATING_LANGUAGE_TEXT'),(15672,'STR_UPDATING_TABLE'),(15673,'STR_EDIT_ITEM_CATEGORY_DISCOUNTS'),(15674,'STR_PAYROLL_VOID'),(15675,'STR_CALCULATIONS_VOIDED_SUCCESSFULLY'),(15676,'STR_CHANGE_CALCULATIONS_FOR_JUST_THIS_PAY_PERIOD'),(15677,'STR_DATE_IS_OUTSIDE_PAY_PERIOD'),(15678,'STR_EDITING_NOT_ALLOWED'),(15679,'STR_GO_TO_EMPLOYEE'),(15680,'STR_HOURS_ENTERED'),(15681,'STR_JOB_COST_RATE'),(15682,'STR_NO_CHANGE'),(15683,'STR_NO_FEDERAL_FUTA_SOCIAL_SECURITY_MEDICARE_TAXES'),(15684,'STR_NO_FEDERAL_FUTA_TAXES'),(15685,'STR_NO_FEDERAL_SOCIAL_SECURITY_MEDICARE_TAXES'),(15686,'STR_NO_INCOME_TAXES'),(15687,'STR_NO_INCOME_UNEMPLOYMENT_TAXES'),(15688,'STR_NO_TAXES'),(15689,'STR_OFFSET'),(15690,'STR_PREVIOUS_EMPLOYEE'),(15691,'STR_PREVIOUS_PERIODS'),(15692,'STR_SET_DEFAULT_HOURS'),(15693,'STR_TAXES_HAVE_BEEN_CALCULATED'),(15694,'STR_CAN_APPROVE_BILLS_FOR_PAYMENT'),(15695,'STR_TOTAL_COSTS'),(15696,'STR_SHOW_APPROVERS_INITIALS_ON_CHECK_STUB'),(15697,'STR_HIDE_GL_ACCOUNTS_WHEN_LOGGING_HOURS'),(15698,'STR_ATTACHMENT'),(15699,'STR_APPROVAL_STATUS'),(15700,'STR_UNAPPROVED_VENDOR_BILLS'),(15701,'STR_VENDOR_CERT_REQUIRED_EXPLANATION'),(15702,'STR_EMPLOYEE_DEDUCTION_TYPES'),(15703,'STR_VENDOR_CERTIFICATE_COMPLIANCE'),(15704,'STR_VENDOR_CERTIFICATE_TYPES'),(15705,'STR_CERTIFICATE_BROKER'),(15706,'STR_CERTIFICATE_DETAILS'),(15707,'STR_CERTIFICATE_FILES'),(15708,'STR_CERTIFICATE_NOTICE_EMAIL'),(15709,'STR_CERTIFICATE_TYPE_DETAILS'),(15710,'STR_EMAIL_NOTICE'),(15711,'STR_MISSING_CERTIFICATE'),(15712,'STR_UPLOADED'),(15713,'STR_VENDOR_CERTIFICATE'),(15714,'STR_VENDOR_CERTIFICATE_TYPE'),(15715,'STR_ADD_NEW_FILE'),(15716,'STR_UPLOADING'),(15717,'STR_CONSOLIDATED_PICK_LIST_STYLE'),(15718,'STR_GROUP_ITEMS_TOGETHER'),(15719,'STR_SEPARATE_LINE_FOR_EACH_ORDER_ITEM'),(15720,'STR_ROUND_FEDERAL_WITHHOLDING_TO_NEAREST_WHOLE_NUMBER'),(15721,'STR_THIS_VENDOR_DOES_NOT_HAVE_A_VALID_CERTIFICATE'),(15722,'STR_ADD_CERTIFICATE'),(15723,'STR_BROKER'),(15724,'STR_CERTIFICATES'),(15725,'STR_VENDOR_CERTIFICATES'),(15726,'STR_ORDERS_INCLUDED'),(15727,'STR_ADD_ADDIONAL_CHECK_PAGES_AS_VOID'),(15728,'STR_ADD_ADDITIONAL_CHECK_PAGES_AS_VOID'),(15729,'STR_CHECK_STUB_INVOICE_LIST_OVERFLOW'),(15730,'STR_CHECK_VOID_DATE'),(15731,'STR_CURRENT_DATE'),(15732,'STR_DEFAULT_ORDER_FROM'),(15733,'STR_DO_NOT_WRITE_CHECK'),(15734,'STR_LIST_OVERFLOWS_AT_MORE_THAN_45_INVOICES'),(15735,'STR_PREFERED_PAYMENT_ACCOUNT'),(15736,'STR_PREFERED_PAYMENT_CARD'),(15737,'STR_PREFERED_PAYMENT_METHOD'),(15738,'STR_DO_NOT_INCLUDE_DIGITAL_SIGNATURE_ON_MANUAL_CHECKS'),(15739,'STR_DEFAULT_COMPANY'),(15740,'STR_CURRENT_EMPLOYEE_DEDUCTION_TYPES'),(15741,'STR_EMPLOYEE_DEDUCTION_TYPE'),(15742,'STR_NO_EMPLOYEE_DEDUCTION_TYPES_EXIST'),(15743,'STR_YTD_VENDOR_PAYMENTS'),(15744,'STR_PAYMENTS_LAST_12_MONTHS'),(15745,'STR_PAYMENTS_LAST_YEAR'),(15746,'STR_PAYMENTS_YTD'),(15747,'STR_WHICH_TAXES_ARE_NOT_CALCULATED_ON_PENSION_AMOUNT'),(15748,'STR_ARCHIVED_REPORTS'),(15749,'STR_ARCHIVE_MONTHLY'),(15750,'STR_ARCHIVE_NOW'),(15751,'STR_REVIEW_ARCHIVED_REPORTS'),(15752,'STR_ACCOUNTS_OVERDUE'),(15753,'STR_CHARGE_BACK_CODE'),(15754,'STR_CHARGE_BACK_CODES'),(15755,'STR_ACCOUNT_CLOSED'),(15756,'STR_CREDIT_APPLICATION_ON_FILE'),(15757,'STR_CREDIT_HOLD_REPORT'),(15758,'STR_CUSTOMER_CREDIT_LIMIT_REPORT'),(15759,'STR_CUSTOMER_PRELIMABLE'),(15760,'STR_DATE_CLOSED'),(15761,'STR_DATE_ON_HOLD'),(15762,'STR_FIRST_SALES_DATE'),(15763,'STR_LAST_DATE_OF_CONTACT'),(15764,'STR_NOTE_ENTRY_DATE'),(15765,'STR_ON_HOLD_DATE'),(15766,'STR_ON_HOLD_Y_N'),(15767,'STR_PERCENT_OF_BALANCE_PAST_DUE'),(15768,'STR_PRELIMABLE'),(15769,'STR_SHOW_LAST_CONTACT_NOTE'),(15770,'STR_SHOW_NUMBER_OF_ACCOUNTS'),(15771,'STR_TOTAL_BALANCE'),(15772,'STR_TOTAL_PAST_DUE'),(15773,'STR_A_AND_I_COMPLETED_PO_TO_AP'),(15774,'STR_DIRECT_EXPENSE_PAYMENTS'),(15775,'STR_DIRECT_EXPENSE_TYPES'),(15776,'STR_WRITE_OFF_REASONS'),(15777,'STR_GL_ACCONT'),(15778,'STR_WRITE_OFF_REASON'),(15779,'STR_FILE_NAME'),(15780,'STR_3DCART_ITEMS_IMPORTED_SUCCESSFULLY'),(15781,'STR_3DCART_SHIPPING_MARKUPS_RETRIEVED_SUCCESSFULLY'),(15782,'STR_3DCART_SHIPS_BY_ITSELF_SETTINGS_RETRIEVED_SUCCESSFULLY'),(15783,'STR_IMPORT_ITEMS_FROM_THIS_3DCART_STORE_IF_NOT_IN_THIS_SYSTEM'),(15784,'STR_IMPORT_SHIPPING_MARKUPS_FROM_THIS_3DCART_STORE'),(15785,'STR_IMPORT_SHIPS_BY_ITSELF_SETTINGS_FROM_THIS_3DCART_STORE'),(15786,'STR_UPDATE_3DCART_SHIPPING_MARKUPS_AUTOMATICALLY'),(15787,'STR_UPDATE_3DCART_SHIPS_BY_ITSELF_SETTINGS_AUTOMATICALLY'),(15788,'STR_BLOCK_UNPOSTING_INVOICES'),(15789,'STR_HIDE_ACCRUED_INTEREST_ON_PAYMENT_PAGE'),(15790,'STR_HIDE_INTEREST_ENTRY_ON_PAYMENT_PAGE'),(15791,'STR_HIDE_ACCRUED_VACATION_AND_SICK_HOURS_FROM_PAYROLL_CHECK'),(15792,'STR_CUSTOMER_ON_JOB_IS_NOT_THE_SAME_AS_ON_INVOICE'),(15793,'STR_UNPOSTING_OF_INVOICES_IS_NOT_ALLOWED'),(15794,'STR_WRITE_OFF_AMOUNT'),(15795,'STR_DAYS_OVERDUE'),(15796,'STR_HIDE_CUSTOMER_CONTACT_INFO'),(15797,'STR_JOB_PRELIMABLE'),(15798,'STR_HIDE_THIS_INVOICE_ON_B2B'),(15799,'STR_INVOICE_VOUCHER_MISSING'),(15800,'STR_NO_REVERSING_ENTRY_MADE'),(15801,'STR_ITEM_MARKUP'),(15802,'STR_TOTAL_REFLECTS_NEGOTIATED_RATES'),(15803,'STR_EMPTY'),(15804,'STR_INVALID_ACCOUNT_TYPE'),(15805,'STR_ADD_DIRECT_EXPENSE_TYPES'),(15806,'STR_CREDIT_GL_ACCOUNT'),(15807,'STR_DEBIT_GL_ACCOUNT'),(15808,'STR_DIRECT_EXPENSE_TYPE'),(15809,'STR_ENTRY_SAVED_SUCCESSFULLY'),(15810,'STR_NO_ACCOUNT_SET_FOR_BANK'),(15811,'STR_NO_ACCOUNT_SET_FOR_EXPENSE_TYPE'),(15812,'STR_NO_AMOUNT_SET'),(15813,'STR_NO_DIRECT_EXPENSE_TYPES_EXIST'),(15814,'STR_RECENT_DIRECT_EXPENSE_PAYMENTS'),(15815,'STR_CURRENT_DIRECT_EXPENSE_TYPES'),(15816,'STR_DATE_POSTED'),(15817,'STR_DIRECT_EXPENSE_PAYMENT'),(15818,'STR_ENTRY_DETAILS'),(15819,'STR_JOURNAL_ENTRY_ID_NUMBER'),(15820,'STR_JOURNAL_ENTRY_NOT_FOUND'),(15821,'STR_NOT_POSTED'),(15822,'STR_TAX_ADJUSTING_JOURNAL_ENTRY'),(15823,'STR_UPDATING_VARIOUS_ITEM_SETTINGS_AT_3DCART'),(15824,'STR_FLAT_AMOUNT'),(15825,'STR_SHIPPING_MARKUP'),(15826,'STR_A_AND_I_INVOICE_TOTAL'),(15827,'STR_CREATE_AP_BILLS'),(15828,'STR_ITEM_NOT_FOUND_ON_INVOICE'),(15829,'STR_MATCH_FOUND'),(15830,'STR_NEW_BILLS_ADDED_SUCCESSFULLY'),(15831,'STR_NO_MATCH'),(15832,'STR_NO_NEW_BILLS_ADDED'),(15833,'STR_PRICE_CHANGED_FROM'),(15834,'STR_QTY_CHANGED_FROM'),(15835,'STR_RETRIEVING'),(15836,'STR_SHOW_ON_AGING_REPORT'),(15837,'STR_ACCEPT_BACK_ORDERS'),(15838,'STR_ALLOW_ORDER_MODIFICATIONS'),(15839,'STR_ALLOW_SPECIAL_PRICING'),(15840,'STR_AUTHORIZED_BUYERS_ONLY'),(15841,'STR_CREDIT_APPLICATION_RECEIVED'),(15842,'STR_DATE_CREDIT_APPLICATION_ON_FILE'),(15843,'STR_DATE_TAX_EXEMPTION_ON_FILE'),(15844,'STR_DELIVERY_SALES_ONLY'),(15845,'STR_EXEMPT_DELIVERY_CHARGE'),(15846,'STR_EXEMPT_FUEL_CHARGE'),(15847,'STR_NOT_VERIFIED'),(15848,'STR_OK_TOOLS_ON_JOB_ACCOUNTS'),(15849,'STR_OK_TO_SHIP_IF_INCOMPLETE_JOB_INFO'),(15850,'STR_ON_HOLD'),(15851,'STR_PRELIM_JOB_SALES'),(15852,'STR_SHOW_PRICES_ON_DELIVERY_CONFIRMATION'),(15853,'STR_USE_NEGOTIATED_RATES'),(15854,'STR_VERIFIED'),(15855,'STR_JOURNAL_ENTRY_DOCUMENTS'),(15856,'STR_CANNOT_UPDATE_INVOICE_HEADER_INFO'),(15857,'STR_PRINT_PDF_FONT'),(15858,'STR_UPLOAD_PDF_FONT'),(15859,'STR_DEFAULT_REPLY_TO_ADDRESS'),(15860,'STR_DEFAULT_REPLY_TO_NAME'),(15861,'STR_ARCHIVED_STATEMENTS'),(15862,'STR_EMAIL_NEW_STATEMENT'),(15863,'STR_CHARGEBACK_CODE'),(15864,'STR_CHARGEBACK_CODES'),(15865,'STR_EMAILED_LETTER'),(15866,'STR_MAIL_TEMPLATES'),(15867,'STR_PRINTED_LETTER'),(15868,'STR_INTEREST_CHARGE_OPTION'),(15869,'STR_INTEREST_CHARGE_OPTIONS'),(15870,'STR_INTEREST_RATE'),(15871,'STR_JOB_TYPES'),(15872,'STR_DIRECT_AR_PAYMENTS'),(15873,'STR_DIRECT_AR_PAYMENT_TYPES'),(15874,'STR_SEE_CUSTOMER_PAGE'),(15875,'STR_CUSTOMER_SALES_INFO'),(15876,'STR_JOB_ADDED'),(15877,'STR_JOB_CLOSED'),(15878,'STR_JOB_SALES_INFO'),(15879,'STR_LAST_PAYMENT'),(15880,'STR_LAST_SALE'),(15881,'STR_NOT_PRELIMABLE'),(15882,'STR_HIDE_JOB_FIELDS'),(15883,'STR_APPLY_TO_CURRENT_INVOICE'),(15884,'STR_CHARGE_INTEREST_HOW'),(15885,'STR_CREATE_NEW_INVOICE'),(15886,'STR_JOBS_MUST_HAVE_CUSTOMER_SET'),(15887,'STR_MAX_PERCENTAGE'),(15888,'STR_MINIMUM_FINANCE_FEE'),(15889,'STR_SHOW_CUSTOMER_CODE_IN_AUTO_COMPLETE_BOXES'),(15890,'STR_SHOW_INTEREST_SUMMARY_ON_STATEMENT'),(15891,'STR_WRITEOFFS'),(15892,'STR_CHARGEBACK'),(15893,'STR_MAIL_TEMPLATE_DELETED_FAILURE'),(15894,'STR_MAIL_TEMPLATE_DELETED_SUCCESSFULLY'),(15895,'STR_AP_BILLS_PAID_WITH_THIS_CARD'),(15896,'STR_VIEW_NEW_BILL'),(15897,'STR_ACCOUNT_ON_HOLD'),(15898,'STR_LETTERS'),(15899,'STR_STATEMENTS_'),(15900,'STR_INVOICE_INTEREST'),(15901,'STR_IS_JOINT_CHECK'),(15902,'STR_NO_CHARGE_BACK_CODES_FOUND'),(15903,'STR_WRITEOFF_ABOVE_MAX_ALLOWED_VALUE'),(15904,'STR_INTEREST_CHARGES_CALCULATED_BASED_ON'),(15905,'STR_INTEREST_LAST_CALCULATED_ON'),(15906,'STR_GENERAL_LEDGER_DEFAULTS'),(15907,'STR_ADD_DIRECT_AR_PAYMENT_TYPES'),(15908,'STR_DIRECT_AR_PAYMENT_TYPE'),(15909,'STR_NO_ACCOUNT_SET_FOR_AR_PAYMENT_TYPE'),(15910,'STR_NO_DIRECT_AR_PAYMENT_TYPES_EXIST'),(15911,'STR_RECENT_DIRECT_AR_PAYMENTS'),(15912,'STR_CURRENT_DIRECT_AR_PAYMENT_TYPES'),(15913,'STR_APN'),(15914,'STR_CONTACT_TITLE'),(15915,'STR_CONTRACT_NUMBER'),(15916,'STR_CUSTOMER_REQUIRED'),(15917,'STR_NUM_JOB_YEARS'),(15918,'STR_PERMIT_CONTRACT'),(15919,'STR_FINANCE_CHARGE_FOR_PAYMENT_UNDER_MINIMUM'),(15920,'STR_PAYMENT_NOTICE_EMAILED'),(15921,'STR_COMPANY_DEFAULT'),(15922,'STR_AUTHORIZED_BUYER'),(15923,'STR_CUSTOMER_PAYMENT_ATTACHMENTS'),(15924,'STR_ACH_EFT_OTHER'),(15925,'STR_AP_PAYMENT'),(15926,'STR_GENERAL_MESSAGE'),(15927,'STR_INVOICES_PAID'),(15928,'STR_PAYMENT_DAY'),(15929,'STR_PAYMENT_MONTH'),(15930,'STR_PAYMENT_YEAR'),(15931,'STR_VENDOR_FIRST_NAME'),(15932,'STR_VENDOR_LAST_NAME'),(15933,'STR_CUSTOMER_LETTERS'),(15934,'STR_FULL_INCLUDES_DELETE_ACTIVE_COMPANY'),(15935,'STR_CONVENIENCE_FEE'),(15936,'STR_DATABASE_VERSION_MAY_BE_OUTDATED'),(15937,'STR_IF_THIS_PROBLEM_CONTINUES_PLEASE_PERFORM_A_MANUAL_UPDATE'),(15938,'STR_CUSTOMER_STATEMENTS'),(15939,'STR_FAX_SENT'),(15940,'STR_MANUAL_ENTRY'),(15941,'STR_SEND_FAILED'),(15942,'STR_SEND_FAX_TO'),(15943,'STR_ENTRYDATE'),(15944,'STR_ERRORS'),(15945,'STR_IMPORT_LOG'),(15946,'STR_LAST_POSTED'),(15947,'STR_RECURRING_VOUCHER_POST_TO_DATES'),(15948,'STR_ADVANCED_JOB_SEARCH'),(15949,'STR_CLOSED_BY'),(15950,'STR_CONTRACT_DATE_BEGIN'),(15951,'STR_CONTRACT_DATE_END'),(15952,'STR_JOB_CLOSED_DATE_BEGIN'),(15953,'STR_JOB_CLOSED_DATE_END'),(15954,'STR_JOB_ENTRY_DATE_BEGIN'),(15955,'STR_JOB_ENTRY_DATE_END'),(15956,'STR_RISK_INSURANCE_EXPIRATION_DATE_BEGIN'),(15957,'STR_RISK_INSURANCE_EXPIRATION_DATE_END'),(15958,'STR_ARCHIVE'),(15959,'STR_GL_CATEGORIES'),(15960,'STR_IMPORT_CC_PURCHASES'),(15961,'STR_IMPORT_EMPLOYEE_EXPENSES'),(15962,'STR_NEW_REVERSING_JOURNAL_ENTRY'),(15963,'STR_UNPOST_JOURNAL_ENTRIES'),(15964,'STR_API_APPLICATION_KEY'),(15965,'STR_API_APPLICATION_SECRET'),(15966,'STR_LOGIN_EXT'),(15967,'STR_LOGIN_PHONE'),(15968,'STR_RINGCENTRAL_FAX_SERVICE'),(15969,'STR_MANUALLY_AS_NEEDED'),(15970,'STR_ENTRY_USER'),(15971,'STR_IMPORT_BATCH'),(15972,'STR_IMPORTED_RECORDS'),(15973,'STR_EMAIL_IMPORT_NOTICES_TO'),(15974,'STR_MANUAL_ENTRIES'),(15975,'STR_ONE_EMAIL_PER_LINE'),(15976,'STR_FAX_NOT_SET'),(15977,'STR_JOB_SALES'),(15978,'STR_PRELIM_CREDIT_LIMIT'),(15979,'STR_CHILD_ENTRIES'),(15980,'STR_VIEW_PARENT'),(15981,'STR_SYNC_CANCEL_STATUS_OF_EXISTING_ORDERS'),(15982,'STR_UPDATE_3DCART_CANCEL_STATUS_AUTOMATICALLY'),(15983,'STR_UPDATE_3DCART_SHIPPING_FEE_AUTOMATICALLY'),(15984,'STR_UPDATE_3DCART_SHIPPING_PREFERENCE_AUTOMATICALLY'),(15985,'STR_LEAVE_BLANK_TO_USE_CC_GL_ACCOUNT'),(15986,'STR_DEFAULT_GL_CATEGORY'),(15987,'STR_ALLOW_ORDER_STATUS_PAGE_ON_B2B_SITE'),(15988,'STR_CONVENIENCE_FEE_ACCOUNT'),(15989,'STR_MINIMUM_INTEREST_CHARGE'),(15990,'STR_PREVENT_DUPLICATE_SHIPNAMES'),(15991,'STR_GL_CATEGORY'),(15992,'STR_CHECK_CARD_SETUP'),(15993,'STR_GL_CC_LIABILITY_ACCOUNT_MISSING_FOR_LINE'),(15994,'STR_GL_EXPENSE_ACCOUNT_MISSING_FOR_LINE'),(15995,'STR_PLEASE_ENTER_AN_ACCOUNT_OR_CHARGE_TYPE_FOR_LINE'),(15996,'STR_SEND_FAX'),(15997,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_ALL_EXISTING_ACCOUNTS'),(15998,'STR_BUDGET_SAVED_SUCCESSFULLY'),(15999,'STR_ERROR_SAVING_BUDGET_DATA'),(16000,'STR_MAKE_ALL_MONTHS_SAME'),(16001,'STR_NO_BUDGETS_HAVE_BEEN_CREATED'),(16002,'STR_PLEASE_ENTER_A_BUDGET_NAME'),(16003,'STR_PLEASE_ENTER_A_FISCAL_BEGIN_YEAR'),(16004,'STR_RANK_IS_INVALID'),(16005,'STR_SAVE_BUDGET'),(16006,'STR_YEAR_IS_OUT_OF_RANGE'),(16007,'STR_BY_COUNT'),(16008,'STR_EVERY_X_DAYS'),(16009,'STR_EVERY_X_MONTHS'),(16010,'STR_EVERY_X_WEEKS'),(16011,'STR_EVERY_X_YEARS'),(16012,'STR_POST_ALL_ENTRIES'),(16013,'STR_POST_INDIVIDUAL_ENTRIES'),(16014,'STR_RECURRING_ENDS'),(16015,'STR_RECURRING_PERIOD'),(16016,'STR_RECURRING_POSTS_HOW'),(16017,'STR_RECURRING_STARTS_ON'),(16018,'STR_LAST_POSTED_TO_DATE'),(16019,'STR_CREATE_A_STANDARD_JOURNAL_ENTRY_INSTEAD'),(16020,'STR_REVERSING_ENTRY'),(16021,'STR_REVERSING_TRANSACTION_DATE'),(16022,'STR_ALREADY_CANCELED_BY'),(16023,'STR_CANCELS_VOUCHER_ID'),(16024,'STR_CANNOT_PREFORM_ACTION'),(16025,'STR_CREATED_CANCELING_ENTRY'),(16026,'STR_CREATES_NEW_CANCELING_ENTRY'),(16027,'STR_DELETE_CANCELING_ENTRY_FIRST'),(16028,'STR_DELETE_THIS_ENTRY_AND_MAKE_CHANGES_TO_THE_ORIGNAL_VOUCHER'),(16029,'STR_THIS_VOUCHER_CANNOT_BE_EDITED'),(16030,'STR_TO_MODIFY'),(16031,'STR_VIEW_VOUCHER_CANCELED_BY_THIS_VOUCHER'),(16032,'STR_VIEW_VOUCHER_THIS_VOUCHER_IS_CANCELED_BY'),(16033,'STR_VOUCHER_IS_RECURRING'),(16034,'STR_ALL_UNPOSTED_JOURNALS_WILL_POST_TO_MONTH_OF_ENTRY'),(16035,'STR_MANUAL'),(16036,'STR_SELECTED_UNPOSTED_JOURNALS_WILL_POST_TO_MONTH_OF_ENTRY'),(16037,'STR_SELECT_MODE'),(16038,'STR_UNPOST_ALL_VOUCHERS_POSTED_TO_A_SPECIFIC_MONTH'),(16039,'STR_COST_CODE_NOT_FOUND'),(16040,'STR_DO_NOT_CREATE_GL_TRANSACTIONS'),(16041,'STR_GL_CATEGORY_NOT_FOUND'),(16042,'STR_CARD_NOT_FOUND_FOR_VENDOR'),(16043,'STR_CC_PURCHASES_COLUMNS'),(16044,'STR_CC_PURCHASES_CSV_FILE'),(16045,'STR_CC_PURCHASES_IMPORTED'),(16046,'STR_DATE_NOT_RECOGNIZED'),(16047,'STR_GL_ACCOUNT_NOT_SET_FOR_CARD'),(16048,'STR_ID_FOR_THE_CC_VENDOR'),(16049,'STR_MERCHANT'),(16050,'STR_MUST_HAVE_VENDOR_NUMBER_PAYMENT_DATE_PAYMENT_AMOUNT_EXPENSE_GL_ACCOUNT_AND_MERCHANT_NAME'),(16051,'STR_PURCHASE_ALREADY_IN_SYSTEM'),(16052,'STR_PURCHASE_ID'),(16053,'STR_VENDOR_NUMBER_INFO'),(16054,'STR_EMPLOYEE_EXPENSE_COLUMNS'),(16055,'STR_EMPLOYEE_EXPENSE_CSV_FILE'),(16056,'STR_MUST_HAVE_VENDOR_NUMBER_PAYMENT_DATE_PAYMENT_AMOUNT_EXPENSE_GL_ACCOUNT_AND_BUSINESS_PURPOSE'),(16057,'STR_VENDOR_ID_NOT_FOUND'),(16058,'STR_Y_N'),(16059,'STR_BUDGET_DATA_IMPORTED'),(16060,'STR_BUDTET_YEAR_NOT_VALID'),(16061,'STR_GL_BUDGET_COLUMNS'),(16062,'STR_GL_BUDGET_CSV_FILE'),(16063,'STR_MUST_HAVE_BUDGET_YEAR_BUDGET_NAME_AND_GL_ACCOUNT'),(16064,'STR_ALL_ENTRIES_IN_RECURRING_POSTS_AT_ONCE'),(16065,'STR_RECURRING_COUNT'),(16066,'STR_RECURRING_PREIOD'),(16067,'STR_RECURRING_START_DATE'),(16068,'STR_REVERSING_DATE'),(16069,'STR_COST_GL_ACCOUNT_NUMBER'),(16070,'STR_SALES_GL_ACCOUNT_NUMBER'),(16071,'STR_INCLUDE_ONLY_ITEMS_CURRENTLY_ON_HAND'),(16072,'STR_OK_TOOLS_ON_JOB'),(16073,'STR_ADD_MISSING_TAXES_TO_CUSTOMER'),(16074,'STR_REMOVE_NON_MATCHING_TAXES_FROM_ORDER'),(16075,'STR_THE_SALES_TAX_SETUP_FOR_THIS_CUSTOMER_DOESNT_MATCH_THE_ORDER'),(16076,'STR_CANNOT_EDIT'),(16077,'STR_REVERSED_BY_VOUCHER'),(16078,'STR_REVERSES_VOUCHER'),(16079,'STR_B2B_CONVENIENCE_FEE'),(16080,'STR_ERROR_ADDING_SHIP_TO_DUPE_NAME'),(16081,'STR_IMPORT_NOTICE'),(16082,'STR_ALL_ACTIVITY_FOR_JOB'),(16083,'STR_PREVENT_DUPLICATE_SHIP_NAMES'),(16084,'STR_BUDGET_YEAR_NOT_VALID'),(16085,'STR_JOBCODE'),(16086,'STR_JOBNAME'),(16087,'STR_PRELIM_DATE'),(16088,'STR_CHECKING_ACCOUNT_NOT_FOUND'),(16089,'STR_ERROR_SAVING'),(16090,'STR_IMPORT_VENDOR_PAYMENTS'),(16091,'STR_MISSING_CHECKING_ACCOUNT'),(16092,'STR_MISSING_INVOICE_NUMBER'),(16093,'STR_IMPORT_CUSTOMER_PAYMENTS'),(16094,'STR_FAX_LOG'),(16095,'STR_SELECT_MONTH'),(16096,'STR_BALANCE_SHEET_TRIAL'),(16097,'STR_CONNECTION_FAILED'),(16098,'STR_EMAILED_JOB_PRELIM_REQUEST'),(16099,'STR_EMAILS'),(16100,'STR_FAXED_JOB_PRELIM_REQUEST'),(16101,'STR_IMPORT_JOBS'),(16102,'STR_JOB_PRELIM_INFORMATION_RECEIVED'),(16103,'STR_MAIL_SENT'),(16104,'STR_PHONES'),(16105,'STR_PRELIM_CONTACT'),(16106,'STR_PRELIM_COUNTY'),(16107,'STR_PRELIM_INFO_REQUEST'),(16108,'STR_PRELIM_INSTRUCTIONS'),(16109,'STR_PRELIM_STATUS'),(16110,'STR_PRELIM_TEMPLATE_NOT_SET'),(16111,'STR_PRINTED_JOB_PRELIM_REQUEST'),(16112,'STR_RECORD_RECEIPT_OF_INFO'),(16113,'STR_SCAN'),(16114,'STR_SEND_PRELIM_INFO_REQUEST'),(16115,'STR_TRANSMIT_TO_ZLIEN'),(16116,'STR_CLOSE_MONTH'),(16117,'STR_POSITIVE_PAY'),(16118,'STR_ALREADY_DISABLED'),(16119,'STR_ALREADY_ENABLED'),(16120,'STR_CHECKING_BANK_ACCOUNT_NUMBER_NOT_SET'),(16121,'STR_DISABLE_AUTO_SENDING'),(16122,'STR_DO_NOT_SEND'),(16123,'STR_ENABLED'),(16124,'STR_ENABLE_AUTO_SENDING'),(16125,'STR_ERROR_SENDING'),(16126,'STR_HOST_NOT_SET'),(16127,'STR_NOTHING_TO_SEND'),(16128,'STR_PASSWORD_NOT_SET'),(16129,'STR_POSITIVE_PAY_CHECKS'),(16130,'STR_POSITIVE_PAY_DISABLED'),(16131,'STR_REVIEW_POSITIVE_PAY_CHECKS'),(16132,'STR_SEND_ALL_TO_POSITIVE_PAY'),(16133,'STR_SEND_PENDING_CHECKS'),(16134,'STR_SENT_TO_POSITIVE_PAY'),(16135,'STR_TRANSFER_FAILED'),(16136,'STR_USER_NOT_SET'),(16137,'STR_PAD_RIGHT'),(16138,'STR_DO_NOT_CREATE_GL_ENTRIES'),(16139,'STR_QUEUED'),(16140,'STR_IMPORT_COMPLETED'),(16141,'STR_IMPORT_COMPLETED_WITH_ERRORS'),(16142,'STR_NOTHING_TO_IMPORT'),(16143,'STR_DOWNLOAD_TEMPLATE'),(16144,'STR_FILE_FORMAT'),(16145,'STR_IMPORT_FROM_FILE'),(16146,'STR_ONE_PER_LINE'),(16147,'STR_PRELIM_REQUEST_TEMPLATE'),(16148,'STR_TOO_MANY_RECORDS_TO_DISPLAY'),(16149,'STR_ALL_AMEX'),(16150,'STR_ALL_CC'),(16151,'STR_ALL_DISCOVER'),(16152,'STR_ALL_MASTERCARD'),(16153,'STR_ALL_VISA'),(16154,'STR_COULD_NOT_FIND_ASSET_ACCOUNT_FOR_DEPOSIT_GL_ENTRY'),(16155,'STR_INCOMING'),(16156,'STR_INCOMING_AMOUNT_DOES_NOT_MATCH_OUTGOING'),(16157,'STR_MAKE_CREDIT_CARD_DEPOSIT'),(16158,'STR_NO_DESCRIPTION'),(16159,'STR_OUTGOING'),(16160,'STR_PLEASE_CHANGE_THE_DEPOSIT_ACCOUNT_TO_AN_ASSET_TYPE_ACCOUNT'),(16161,'STR_CREDIT_CARD_DEPOSIT'),(16162,'STR_NOT_NEEDED_FOR_MANUAL_PROCESSING'),(16163,'STR_ONLY_NEEDED_IF_NO_CARD_NUMBER_ENTERED'),(16164,'STR_ORDER_TO_INVOICE'),(16165,'STR_HAS_COST_CODES'),(16166,'STR_HAS_GL_CATEGORIES'),(16167,'STR_BE_SURE_TO_POST_ANY_UNPOSTED_TRANSACTION_SETS_BEFORE_SAVING'),(16168,'STR_BLOCK_ALL_BUT_DIRECT_GL_ENTRIES'),(16169,'STR_BLOCK_ALL_POSTING'),(16170,'STR_GET_MONTH_INFO'),(16171,'STR_LAST_STATUS_DATE'),(16172,'STR_LAST_USER'),(16173,'STR_MONTH_OPEN'),(16174,'STR_MONTH_STATUS_REPORT'),(16175,'STR_NO_TRANSACTIONS_FOUND_IN_THE_GIVEN_DATE_RANGE'),(16176,'STR_POSTED_CREDITS'),(16177,'STR_POSTED_DEBITS'),(16178,'STR_POSTING_STATUS'),(16179,'STR_TRANSACTION_SETS'),(16180,'STR_UNPOSTED_TRANSACTION_SETS'),(16181,'STR_DIRECT_GL_ENTRIES_OK'),(16182,'STR_MUST_BE_AFTER'),(16183,'STR_NOT_IN_THESE_MONTHS'),(16184,'STR_POST_TO_AN_OPEN_PERIOD_OR_USE_AUTO_POST'),(16185,'STR_CANNOT_UNPOST_VOUCHERS_FROM_A_CLOSED_MONTH'),(16186,'STR_THE_FILE_MUST_CONTAIN_THE_HEADER_ROW'),(16187,'STR_VALUE_PENDING_PRINT_ORDERS'),(16188,'STR_ENABLE_POSITIVE_PAY'),(16189,'STR_LIST_VALUE_PENDING_PRINT_ORDERS'),(16190,'STR_VALUE_PENDING_ORDERS'),(16191,'STR_SHOULD_NOT_INCLUDE'),(16192,'STR_KEY_NOT_SET'),(16193,'STR_API_LOGGING'),(16194,'STR_REQUIRE_HASH_FOR_API'),(16195,'STR_ACCOUNT_MUST_BE_SAVED_BEFORE_POSITIVE_PAY_SETUP'),(16196,'STR_DOWNLOAD_PUBLIC_KEY'),(16197,'STR_GENERATE_NEW_PRIVATE_KEY'),(16198,'STR_GENERATING_A_NEW_PRIVATE_KEY_WILL_BREAK_ALL_EXISTING_PUBLIC_KEYS'),(16199,'STR_NEW_PRIVATE_KEY_CREATED'),(16200,'STR_VENDOR_ID_CODE_OR_NAME_MUST_BE_SET'),(16201,'STR_DOESNT_MATCH_ANY_INVOICE_FOR_VENDOR'),(16202,'STR_MATCHES_MULIPLE_INVOICES'),(16203,'STR_VENDOR_ID_GIVEN_DOESNT_MATCH_VENDOR_NAME_OR_CODE'),(16204,'STR_INVOICE_DOESNT_MATCH_CUSTOMER_CODE'),(16205,'STR_INVOICE_DOESNT_MATCH_CUSTOMER_ID'),(16206,'STR_INVOICE_DOESNT_MATCH_CUSTOMER_NAME'),(16207,'STR_MUST_MATCH_CUSTOMER_ON_INVOICE_IF_SET'),(16208,'STR_NO_CUSTOMER_FOUND_FOR_INVOICE'),(16209,'STR_TRY'),(16210,'STR_VALUE_OF_PENDING_ORDERS'),(16211,'STR_PRODUCT_KEY'),(16212,'STR_LINES'),(16213,'STR_FILE_CAN_NOT_BE_MOVED'),(16214,'STR_SKIPPED'),(16215,'STR_CUSTOMER_PAYMENTS'),(16216,'STR_VENDOR_PAYMENTS'),(16217,'STR_ACCOUNT_NUMBERS_DO_NOT_MATCH'),(16218,'STR_BANK_ACCOUNT_EFT'),(16219,'STR_CONFIRM_BANK_ACCOUNT_NUMBER'),(16220,'STR_ERROR_SUBMITTING_EFT_PAYMENT'),(16221,'STR_NO_PAYMENT_METHODS_AVAILABLE'),(16222,'STR_PLEASE_ENTER_AN_ACCOUNT_NUMBER'),(16223,'STR_PLEASE_ENTER_A_ROUTING_NUMBER'),(16224,'STR_B2B_ALLOW_CC_PAYMENTS'),(16225,'STR_API_LOGIN_FAILED'),(16226,'STR_ERROR_SEDNING'),(16227,'STR_ZLIEN'),(16228,'STR_API_SECRET'),(16229,'STR_API_URL'),(16230,'STR_JOB_SENT_TO_ZLIEN'),(16231,'STR_RETRANSMIT_TO_ZLIEN'),(16232,'STR_PAYMENT_METHOD_NOT_AVAILABLE'),(16233,'STR_CUSTOMER_STATMENT'),(16234,'STR_REVIEW_YOUR_CUSTOMER_STATMENT'),(16235,'STR_CUSTOMER_STATEMENT'),(16236,'STR_REVIEW_YOUR_CUSTOMER_STATEMENT'),(16237,'STR_MAIL'),(16238,'STR_PREFERRED_INVOICE_NOTIFICATION_METHOD'),(16239,'STR_PULL'),(16240,'STR_PREFERRED_NOTIFICATION_METHOD'),(16241,'STR_SEND_NOTICE'),(16242,'STR_INVOICE_IS_MARKED_AS_DO_NOT_SEND'),(16243,'STR_INVOICE_IS_MARKED_AS_PULL'),(16244,'STR_SEND_NOTICES'),(16245,'STR_ADDON_REQUIRED'),(16246,'STR_ADD_MULTIPLE_CUSTOMER_B2B_USERS'),(16247,'STR_NEW_CUSTOMER_B2B_USER'),(16248,'STR_NEW_VENDOR_B2B_USER'),(16249,'STR_CREATED_AFTER'),(16250,'STR_CREATED_BEFORE'),(16251,'STR_SELECT_CUSTOMERS'),(16252,'STR_NO_EXISTING_B2B_USER'),(16253,'STR_CREATE_USERS'),(16254,'STR_NEW_B2B_USERS'),(16255,'STR_NO_EMAIL_ADDRESS_FOUND'),(16256,'STR_CREATE_USERS_WITH_ACCESS_LEVEL'),(16257,'STR_EMAIL_LOGIN_DETAILS_TO_USERS'),(16258,'STR_YOUR_B2B_USER_IS_READY'),(16259,'STR_ADD_MULTIPLE_VENDOR_B2B_USERS'),(16260,'STR_USER_DETAILS_EMAIL_TEMPLATE'),(16261,'STR_EMAIL_A_PASSWORD_RESET'),(16262,'STR_B2B_LOGIN_DETAILS'),(16263,'STR_END_LOGIN_LINK_TEXT'),(16264,'STR_LINK_TO_LOGIN'),(16265,'STR_START_LOGIN_LINK_TEXT'),(16266,'STR_MAX_FILE_SIZE'),(16267,'STR_TRANSACTION_DESCRIPTION'),(16268,'STR_VOUCHER_DESCRIPTION'),(16269,'STR_BATCH_SEND_PRILIM_REQUESTS'),(16270,'STR_DIRECTORY_MUST_BE_WRITABLE'),(16271,'STR_ONLY_JOBS_WITH_NO_EXISTING_REPLIM_REQUESTS'),(16272,'STR_BATCH_SEND_JOB_PRILIM_REQUESTS'),(16273,'STR_EMAIL_FAX_NUM'),(16274,'STR_SEND_BY'),(16275,'STR_SEND_PRELIM_REQUESTS'),(16276,'STR_EXCLUDE_INVOICES_MARKED_AS'),(16277,'STR_PREFERED_METHOD'),(16278,'STR_ACCESS_DENIED'),(16279,'STR_LOGIN_INCORRECT'),(16280,'STR_COMMERCIAL_AP_BILLS'),(16281,'STR_REVIEW_COMMERCIAL_AP_BILLS'),(16282,'STR_SEND_ALL_TO_COMMERCIAL_AP'),(16283,'STR_PLEASE_REFRESH_THIS_PAGE'),(16284,'STR_REPORT_CACHE_HAS_EXPIRED'),(16285,'STR_OUT_OF_DATE'),(16286,'STR_SEND_PENDING_BILLS'),(16287,'STR_SENT_COMMERCIAL_AP'),(16288,'STR_REVIEW_COMMERCIAL_AP_CC_PAYMENTS'),(16289,'STR_SEND_ALL_PENDING_CC_PAYMENTS'),(16290,'STR_SEND_PENDING_CC_PAYMENTS'),(16291,'STR_COMMERCIAL_AP'),(16292,'STR_COMMERICAL_AP'),(16293,'STR_PURCHASE_ORDER_EMAIL_TEMPLATE'),(16294,'STR_POST_ENTRIES'),(16295,'STR_DEFAULT_IMPORTED_GL_TRANSACTIONS_POSTING'),(16296,'STR_DISABLE_AUTO_POST'),(16297,'STR_ENABLE_AUTO_POST'),(16298,'STR_NO_STATEMENT_AVAILABLE'),(16299,'STR_PRODUCT_INFO'),(16300,'STR_PRODUCT_SHEET'),(16301,'STR_INVALID_PASSWORD'),(16302,'STR_SET_A_NEW_PASSWORD'),(16303,'STR_CUSTOMER_OR_JOB_MUST_BE_SET'),(16304,'STR_DOES_NOT_MATCH_CUSTOMER'),(16305,'STR_IMPORT_INFORMATION'),(16306,'STR_IMPORT_INVOICE_CUSTOMER_AND_JOB_CHANGES'),(16307,'STR_BREAK_OUT_BY_COST_CODE'),(16308,'STR_BREAK_OUT_BY_GL_CATEGORY'),(16309,'STR_GENERATE_RECURRING_ENTRIES'),(16310,'STR_A_JOB_WITH_BY_THIS_CODE_ALREADY_EXISTS'),(16311,'STR_MULTIPLE_ENTRIES_CAN_BE_SEPARATED_WITH_COMMAS'),(16312,'STR_REQUIRED_AND_MUST_BE_UNIQUE'),(16313,'STR_IMPORT_INVOICE_CHANGES'),(16314,'STR_ANY_VALUE'),(16315,'STR_FALSE'),(16316,'STR_FIRST_AND_LAST_NAME'),(16317,'STR_NUMBER_EXPECTED'),(16318,'STR_SHOW_MORE'),(16319,'STR_SHOW_STATE_LIST'),(16320,'STR_TRUE'),(16321,'STR_YOU_MUST_SELECT_A_GL_ACCOUNT_OR_COST_CODE_OR_GL_CATEGORY'),(16322,'STR_SEND_EMAIL_NOTICES_WHEN_BILL_APPROVED'),(16323,'STR_PAYDATE'),(16324,'STR_VENDOR_BILLS_HAVE_BEEN_APPROVED_FOR_PAYMENT'),(16325,'STR_PO_RECEIPTS_ON_THIS_BILL'),(16326,'STR_BILLING_POSTAL_CODE_IF_NO_SHIP_TO'),(16327,'STR_SHIP_TO_POSTAL_CODE'),(16328,'STR_STR_SHOW_SHIP_TO_POSTAL_CODE'),(16329,'STR_SORT_BY_ZIP_CODE'),(16330,'STR_NO_VALUE_SELECTED'),(16331,'STR_AP_CLOSED'),(16332,'STR_AR_CLOSED'),(16333,'STR_DIRECT_GL_CLOSED'),(16334,'STR_INVENTORY_CLOSED'),(16335,'STR_PARTIALLY_CLOSED'),(16336,'STR_PAYROLL_CLOSED'),(16337,'STR_GENERATE_NOW'),(16338,'STR_GENERATED_SUCCESSFULLY'),(16339,'STR_GENERATE_REVERSE_ENTRY'),(16340,'STR_LAST_DATE_GENERATED'),(16341,'STR_LAST_TRANSACTION_DATE'),(16342,'STR_BLOCKED_MODULES'),(16343,'STR_UNABLE_TO_UNPOST_VOUCHERS'),(16344,'STR_VOUCHERS_UNPOSTED_OK'),(16345,'STR_MUST_HAVE_A_VENDOR_ID_OR_VENDOR_CODE_OR_VENDOR_NAME'),(16346,'STR_MUST_HAVE_INVOICE_NUMBER_AND_VENDOR_ID_OR_VENDOR_CODE_OR_VENDOR_NAME_AND_AMOUNT_AND_VALID_ACCOUNT_NUMBER'),(16347,'STR_NEEDS_TO_BE_A_CODE'),(16348,'STR_ADDITIONAL_LINE_ITEMS_IN_THE_SAME_INVOICE_ONLY_NEED_THE_CUSTOMER_ID_OR_CUSTOMER_CODE_OR_COMPANY_NAME_OR_FIRST_AND_LAST_NAME_AND_THE_INVOICE_NUMBER'),(16349,'STR_MUST_HAVE_A_CUSTOMER_ID_OR_CUSTOMER_CODE_OR_COMPANY_NAME_OR_FIRST_AND_LAST_NAME'),(16350,'STR_MUST_HAVE_INVOICE_NUMBER_AND_CUSTOMER_ID_OR_CUSTOMER_CODE_OR_COMPANY_NAME_OR_FIRST_AND_LAST_NAME'),(16351,'STR_A_JOB_WITH_BY_THIS_NAME_ALREADY_EXISTS'),(16352,'STR_A_JOB_WITH_FOR_THIS_CUSTOMER_ALREADY_EXISTS'),(16353,'STR_A_JOB_WITH_THIS_PROJECT_NUMBER_ALREADY_EXISTS'),(16354,'STR_A_JOB_WITH_WITH_THIS_ADDRESS_ALREADY_EXISTS'),(16355,'STR_JOB_CLOSED_DATE'),(16356,'STR_LATTITUDE'),(16357,'STR_LONGITUDE'),(16358,'STR_PRELIMABLE_DATE'),(16359,'STR_GENERATE_RECURRING_LEDGER_ENTRIES'),(16360,'STR_OVER_PHP_MAX_INPUT_VARS'),(16361,'STR_PLEASE_ENTER_A_VALUE_FOR'),(16362,'STR_SHOW_SHIP_TO_POSTAL_CODE'),(16363,'STR_A_JOB_FOR_THIS_CUSTOMER_ALREADY_EXISTS'),(16364,'STR_A_JOB_WITH_THIS_ADDRESS_ALREADY_EXISTS'),(16365,'STR_A_JOB_WITH_THIS_CODE_ALREADY_EXISTS'),(16366,'STR_A_JOB_WITH_THIS_NAME_ALREADY_EXISTS'),(16367,'STR_YOU_MUST_BE_A_SUPERVISOR_TO_ACCESS_THIS_PAGE'),(16368,'STR_JOB_NOT_MARKED_AS_ZLIEN_READY'),(16369,'STR_MAIL_SENT_WITH_ERRORS'),(16370,'STR_NOTHING_SELECTED'),(16371,'STR_PRUNE_IMPORTS_AFTER_X_DAYS'),(16372,'STR_PENDING_PAYMENT'),(16373,'STR_PENDING_PAYMENTS'),(16374,'STR_OVERDUE_INVOICE'),(16375,'STR_OVERDUE_INVOICES'),(16376,'STR_PENDING_INVOICE'),(16377,'STR_PENDING_INVOICES'),(16378,'STR_CLEAR_SEARCH'),(16379,'STR_HIDE_TAB'),(16380,'STR_SHOW_TAB'),(16381,'STR_UPDATE_3DCART_HOLD_STATUS_AUTOMATICALLY'),(16382,'STR_PRELIM_REQUEST_REPLY_TO'),(16383,'STR_SHOW_INTERNAL_NOTES'),(16384,'STR_ZLIEN_READY'),(16385,'STR_DEFINE_NAME'),(16386,'STR_EDIT_SERVICE_ORDER'),(16387,'STR_EDIT_ITEM'),(16388,'STR_TESTING_SOMETHING_HERE'),(16389,'STR_LICENSE_COULD_NOT_BE_VERIFIED_CHECK_INTERNET_ACCESS'),(16390,'STR_LICENSE_TERMINATED'),(16391,'STR_JOB_NOTES'),(16392,'STR_ADD_NOTE'),(16393,'STR_SAVING'),(16394,'STR_HIDE_AP_COST_CODE_FIELDS'),(16395,'STR_HIDE_PAYMENT_ENTRY_AFTER_POS'),(16396,'STR_POS_ENTRY_SAVED'),(16397,'STR_LINE_DATE'),(16398,'STR_EDIT_DEBIT_AND_CREDIT_AS_ONE_COLUMN'),(16399,'STR_HIDE_COST_CODES_ON_JOURNAL_ENTRY_PAGES'),(16400,'STR_RECENT_ACTIVITY'),(16401,'STR_FUND_DETAILS'),(16402,'STR_FUND_SUMMARY'),(16403,'STR_PAST'),(16404,'STR_HIGH_VOLUME'),(16405,'STR_ENTRIES_FROM_PRIOR_MONTHS'),(16406,'STR_NO_DATA_SET'),(16407,'STR_TOTAL_NOT_SELECTED'),(16408,'STR_DISBURSEMENTS_OUT'),(16409,'STR_FUND'),(16410,'STR_RECEIPTS_IN'),(16411,'STR_FUNDS_TO_INCLUDE'),(16412,'STR_ADDITIONAL_INVOICE_OPTIONS'),(16413,'STR_ERROR_RETRIEVING_INVOICE'),(16414,'STR_INVOICE_DETAILS'),(16415,'STR_INVOICE_IS_PAID'),(16416,'STR_VIEW_SELECT_ENTRIES'),(16417,'STR_PAYMENTS_ADDED'),(16418,'STR_SURVEY_EMAIL_ATTACHMENT'),(16419,'STR_COMPANY_PERMISSIONS'),(16420,'STR_CHECK_INFORMATION'),(16421,'STR_CHECK_NOT_FOUND'),(16422,'STR_CHECK_SAVED'),(16423,'STR_EDIT_CHECK'),(16424,'STR_ERROR_SAVING_CHECK'),(16425,'STR_ONLY_AP_CHECK_CAN_BE_EDITTED'),(16426,'STR_TO_EDIT_THIS_CHECK_YOU_MUST_VOID_AND_RECREATE'),(16427,'STR_ACCOUNT_NUM'),(16428,'STR_BALANCE_SHEET_CATEGORIZED'),(16429,'STR_NO_GROUPING'),(16430,'STR_SUB_TOTAL_BY'),(16431,'STR_UNASSIGNED'),(16432,'STR_COST_SUMMARY'),(16433,'STR_VENDOR_CERTIFICATES_EXPIRING'),(16434,'STR_CERTIFICATE_NAME'),(16435,'STR_CERTIFICATE_TYPE'),(16436,'STR_SHOW_CERTIFICATES_EXPIRING_BEFORE'),(16437,'STR_BALANCE_REMAINING'),(16438,'STR_DIRECT_DOWNLOAD_LINK'),(16439,'STR_YOUR_DOWNLOAD_SHOULD_BEGIN_MOMENTARILY'),(16440,'STR_DEFAULT_QUANTITY_RECEIVED_TO_ZERO'),(16441,'STR_HIDE_CHECK_ENDORSER_BOXES'),(16442,'STR_DEFAULT_QUANTITY_SHIPPED_TO_ZERO'),(16443,'STR_EDIT_FAILED'),(16444,'STR_A_NEW_SHIPMENT_WAS_CREATED_AFTER_YOU_HAD_SELECTED_TO_SHIP'),(16445,'STR_POSSIBLE_DOUBLE_DATA_SUBMISSION_PREVENTED'),(16446,'STR_SHIPMENT_PROCESSING_CANCELED'),(16447,'STR_ESTIMATED_DELIVERY'),(16448,'STR_VOUCHER_HAS_BEEN_POSTED'),(16449,'STR_VOUCHER_IS_IN_A_CLOSED_PERIOD'),(16450,'STR_UNBALANCED_BY'),(16451,'STR_ENTITY'),(16452,'STR_JOB_COST_SUMMARY'),(16453,'STR_PLEASE_SELECT_A_JOB'),(16454,'STR_T_PAY'),(16455,'STR_DATA_UPDATED_SUCCESSFULLY'),(16456,'STR_SAVE_COST_CODE_AND_JOB_CHANGES_FOR_HOURS'),(16457,'STR_BLIND_SHIP'),(16458,'STR_THIS_BANK_DEPOSIT_HAS_BEEN_CLEARED_ON_BANK_STATEMENT'),(16459,'STR_ONLY_AP_CHECKS_CAN_BE_EDITED'),(16460,'STR_AUTO_SELECT'),(16461,'STR_THIS_DEPOSIT_HAS_BEEN_INCLUDED_IN_A_BANK_RECONCILIATION_MONTH'),(16462,'STR_YOU_MUST_UNCHECK_IT_FROM_THE_BANK_RECONCILIATION_PAGE_IN_ORDER_TO_EDIT'),(16463,'STR_CONTINUING_WILL_CAUSE_THE_FOLLOWING_BINS_TO_BECOME_UNLINKED_FROM_THESE_ITEMS'),(16464,'STR_RECORD_DELETED'),(16465,'STR_WAREHOUSE_BIN'),(16466,'STR_WAREHOUSE_BIN_BY_THIS_CODE_ALREADY_EXISTS'),(16467,'STR_WAREHOUSE_BIN_CODE_MUST_BE_SET'),(16468,'STR_WAREHOUSE_ZONE'),(16469,'STR_CONTINUING_WILL_CAUSE_THE_FOLLOWING_BINS_TO_BECOME_UNLINKED_FROM_THIS_ZONE'),(16470,'STR_WAREHOUSE_ZONE_BY_THIS_CODE_ALREADY_EXISTS'),(16471,'STR_WAREHOUSE_ZONE_CODE_MUST_BE_SET'),(16472,'STR_BEGIN_AND_END_DATE_MUST_BE_SET'),(16473,'STR_NO_DEFAULT_LOCATION_SET'),(16474,'STR_NO_DEFAULT_PRICE_LEVEL_SET'),(16475,'STR_SPECIAL_SALES_PRICING'),(16476,'STR_STANDARD_PRICE'),(16477,'STR_INQUIRIES'),(16478,'STR_INTERBRANCH_TRANSFERS'),(16479,'STR_POS_SALE'),(16480,'STR_SALES_INVOICE'),(16481,'STR_SALES_QUOTE'),(16482,'STR_WAREHOUSE_BINS'),(16483,'STR_WAREHOUSE_ZONES'),(16484,'STR_FUND_NAME'),(16485,'STR_BIN_LOCATIONS'),(16486,'STR_NO_BINS_AVAIBLE_FOR_THIS_LOCATION'),(16487,'STR_PRIMARY_BIN'),(16488,'STR_JOB_HISTORY'),(16489,'STR_JOB_SUMMARY'),(16490,'STR_LABOR_OVERHEAD'),(16491,'STR_LABOR_TIME'),(16492,'STR_SOURCES'),(16493,'STR_TOTAL_LABOR_COSTS'),(16494,'STR_TOTAL_VENDOR_COSTS'),(16495,'STR_VENDOR_BILL_PAYMENTS'),(16496,'STR_GROSS_PAY_PLUS_NONTAXABLE'),(16497,'STR_GROSS_PAY_PLUS_NONTAXABLE_PER_YEAR'),(16498,'STR_CITY_WAGES'),(16499,'STR_FED_WAGES'),(16500,'STR_GROSS_PAY_THROUGH'),(16501,'STR_STATE_WITHHELD'),(16502,'STR_TAXABLE_WAGES'),(16503,'STR_CANNOT_READ_RECORD'),(16504,'STR_COULD_NOT_BE_ADDED'),(16505,'STR_COULD_NOT_BE_UPDATED'),(16506,'STR_FORM_INCOMPLETE'),(16507,'STR_CANNOT_READ_FILE'),(16508,'STR_CUSTOM_FIELDS_ADDON_REQUIRED'),(16509,'STR_FREIGHT_BURDEN'),(16510,'STR_FRIEGHT_BURDEN'),(16511,'STR_INCLUDE_YEAR_END_ADJUSTING_ENTRIES'),(16512,'STR_INVENOTRY_ADJUSTMENT_REQUEST_TYPE'),(16513,'STR_INVENOTRY_ADJUSTMENT_REQUEST_TYPE_BY_THIS_CODE_ALREADY_EXISTS'),(16514,'STR_INVENOTRY_ADJUSTMENT_REQUEST_TYPE_CODE_MUST_BE_SET'),(16515,'STR_CREATE_TRANSFER'),(16516,'STR_DEFAULT_INTERCOMPANY_TRANSFER_OFFSET_ACCOUNT_MUST_BE_SET'),(16517,'STR_INTERCOMPANY_ITEM_TRANSFER_PRINT'),(16518,'STR_INVENTORY_GL_ACCOUNT_MUST_BE_ASSIGNED_ON_ITEM_OR_DEFAULT_ACCOUNT_ASSIGNED_IN_INVENTORY_SETUP'),(16519,'STR_NUM_MONTHS_SALES_FOR_REORDER_QTY'),(16520,'STR_NUM_MONTHS_TO_REPLENISH'),(16521,'STR_REPLENISHMENT'),(16522,'STR_REPLENISHMENT_TRANSFERS'),(16523,'STR_TRANSFER_SAVED'),(16524,'STR_ACCEPTED_DATE'),(16525,'STR_ADJUSTMENT_TYPE'),(16526,'STR_ASSIGNED'),(16527,'STR_ASSIGNED_DATE'),(16528,'STR_COUNTED'),(16529,'STR_COUNT_TYPE'),(16530,'STR_DATE_ASSIGNED'),(16531,'STR_ITEMS_COUNTED'),(16532,'STR_LAST_UPDATED_BY'),(16533,'STR_PERCENT_COUNTED'),(16534,'STR_REQUEST_TYPE'),(16535,'STR_STOCK_CHECK_REQUEST'),(16536,'STR_STOCK_CHECK_REQUESTS'),(16537,'STR_STOCK_CHECK_REQUEST_STATUS'),(16538,'STR_VARIANCE_VALUE_AMT'),(16539,'STR_VARIANCE_VALUE_PERCENT'),(16540,'STR_ADD_EDIT_COUNTY'),(16541,'STR_APPOINTMENT_SCHEDULER'),(16542,'STR_COUNT_MANAGEMENT'),(16543,'STR_CUSTOMER_HIPAA_IMPORT'),(16544,'STR_IMPORT_SALESMAN_TERRITORIES'),(16545,'STR_IMPORT_SALES_TAX'),(16546,'STR_IMPORT_VENDOR_ORDER_FROMS'),(16547,'STR_INTERCOMPANY_TRANSFER_FREIGHT_BURDEN'),(16548,'STR_INVENTORY_ADJUSTMENT_REQUEST_TYPES'),(16549,'STR_NEW_STOCK_CHECK_REQUEST'),(16550,'STR_STAGING_AREAS'),(16551,'STR_STAGING_AREA'),(16552,'STR_ACCOUNT_TYPE_WRONG'),(16553,'STR_COUNT_NOT_FIND_ACCOUNT_BY_NAME'),(16554,'STR_COUNT_NOT_FIND_CHECKING_ACCOUNT_BY_NAME'),(16555,'STR_COUNT_NOT_FIND_SHIPPING_METHOD_BY_NAME'),(16556,'STR_MATCHES_MULIPLE_VENDORS'),(16557,'STR_POSTAL_CODE_OR_STATE_REQUIRED'),(16558,'STR_SALESMAN_ID'),(16559,'STR_SALESMAN_ID_OR_NAME_MUST_BE_SET'),(16560,'STR_STATE_CODE'),(16561,'STR_VENDOR_COMPANY_NAME_OR_LAST_NAME_MUST_BE_SET'),(16562,'STR_BANK_ROUNTING_NUMBER'),(16563,'STR_DEFAULT_PAY_METHOD'),(16564,'STR_VENDOR_CODE_MUST_BE_SET'),(16565,'STR_BLANK'),(16566,'STR_NO_TYPE_SET'),(16567,'STR_APPOINTMENTS_BOOKED'),(16568,'STR_APPOINTMENTS_OPEN'),(16569,'STR_APPOINTMENTS_TODAY'),(16570,'STR_APPOINTMENTS_TOTAL'),(16571,'STR_APPOINTMENT_LENGTH'),(16572,'STR_APPOINTMENT_LIST_FOR'),(16573,'STR_APPOINTMENT_LOCATION'),(16574,'STR_APPOINTMENT_NAME'),(16575,'STR_APPOINTMENT_SUMMARY'),(16576,'STR_B2B_APPOINTMENT_SCHEDULER'),(16577,'STR_CREATE_APPOINTMENT_OPENINGS'),(16578,'STR_DELETE_OPEN_APPOINTMENT'),(16579,'STR_NEXT_FUTURE_APPOINTMENT'),(16580,'STR_PICK_A_DATE_TO_VIEW_AND_EDIT_APPOINTMENTS'),(16581,'STR_SHOW_SUMMARY'),(16582,'STR_UNBOOK_APPOINTMENT'),(16583,'STR_ADD_NEW_COUNTY'),(16584,'STR_COUNTY_NAME'),(16585,'STR_PARENT_STATE'),(16586,'STR_YOU_MUST_ENTER_A_COUNTY_NAME'),(16587,'STR_YOU_MUST_SELECT_A_STATE'),(16588,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_THIS_COUNTY'),(16589,'STR_DELETE_COUNTY'),(16590,'STR_EDIT_CUSTOM_COUNTY'),(16591,'STR_CONSIDER_ADDING_A_NEW_COUNTY'),(16592,'STR_EDIT_COUNTY'),(16593,'STR_YOUR_SELECTION_IS_A_SYSTEM_VALUE_AND_CANNOT_BE_CHANGED'),(16594,'STR_YOU_MUST_COMPLETE_THE_FORM_TO_CONTINUE'),(16595,'STR_CUSTOMERS_ADDED'),(16596,'STR_CUSTOMERS_SKIPPED'),(16597,'STR_CUSTOMERS_UPDATED'),(16598,'STR_LINES_READ'),(16599,'STR_ALTERNATE_PHONE'),(16600,'STR_CSV_IMPORT_FILE'),(16601,'STR_MOBILE_PHONE_CARRIER'),(16602,'STR_MOBILE_PHONE_NUMBER'),(16603,'STR_SELECT_INVOICE_TERMS'),(16604,'STR_STATE_ABBREVIATION'),(16605,'STR_STREET_ADDRESS'),(16606,'STR_ADD_EDIT'),(16607,'STR_AVG_SALES_PER_MONTH'),(16608,'STR_CURRENT_SUPPLY'),(16609,'STR_NO_PRIMARY_BIN_ASSIGNED'),(16610,'STR_QTY_ON_TRANSFER'),(16611,'STR_REPLENISH_STOCK_FROM_DISTRIBUTION_CENTER'),(16612,'STR_SUGGESTED'),(16613,'STR_TRANSFER_QTY'),(16614,'STR_ZONE'),(16615,'STR_CITIES_ADDED'),(16616,'STR_CITIES_UPDATED'),(16617,'STR_COUNTIES_ADDED'),(16618,'STR_COUNTIES_UPDATED'),(16619,'STR_STATES_ADDED'),(16620,'STR_STATES_UPDATED'),(16621,'STR_ARE_YOU_SURE_YOU_WANT_TO_UPDATE_YOUR_SALES_TAX_RECORDS'),(16622,'STR_CITY_NAME'),(16623,'STR_CITY_SALES_TAX_MULTIPLIER'),(16624,'STR_CITY_USE_TAX_MULTIPLIER'),(16625,'STR_COUNTY_SALES_TAX_MULTIPLIER'),(16626,'STR_COUNTY_USE_TAX_MULTIPLIER'),(16627,'STR_SALES_TAX_IMPORT'),(16628,'STR_STATE_SALES_TAX_MULTIPLIER'),(16629,'STR_STATE_USE_TAX_MULTIPLIER'),(16630,'STR_THOMSON_REUTERS_TAB_FILE'),(16631,'STR_EXISTING_DATA'),(16632,'STR_KEEP_EXISTING_DATA'),(16633,'STR_PURGE_ALL_EXISTING_DATA'),(16634,'STR_PURGE_EXISTING_DATA_FOR_VENDORS_IN_IMPORT'),(16635,'STR_PENDING_VENDOR_CREDITS'),(16636,'STR_AUTO_SELECT_SALES_TAX_FROM_SHIP_TO'),(16637,'STR_ON_FULFILLMENT_AND_POS_ORDERS'),(16638,'STR_ALLOW_BACK_ORDER_ONLY_FROM_DISTRIBUTION_CENTERS'),(16639,'STR_AUTOMATICALLY_SELECT_SALES_TAX_FROM_SHIP_TO_ON_FULFILLMENT_AND_POS_ORDERS'),(16640,'STR_FINAL_DROP_SHIPMENT_REQUIRES_POD'),(16641,'STR_SUGGEST_ALTERNATIVE_PURCHASE_LOCATIONS_WHEN_QTY_NOT_AVAILABLE'),(16642,'STR_PARTIAL_TAX_EXEMPTION'),(16643,'STR_TAX_RATE_PERCENT'),(16644,'STR_DISTRIBUTION_CENTER_NUM_MONTHS_SALES_FOR_REORDER_CALCULATION'),(16645,'STR_INTERBRANCH_TRANSFER_BURDEN_PERCENTAGE_GL_ACCOUNT'),(16646,'STR_INTERCOMPANY_ITEM_TRANSFERS_ALLOW_MULTIPLE_LOCATIONS'),(16647,'STR_INTERCOMPANY_ITEM_TRANSFERS_POSTING'),(16648,'STR_INVENTORY_IN_TRANSIT_GL_ACCOUNT'),(16649,'STR_NONDISTRIBUTION_CENTER_NUM_MONTHS_SALES_FOR_REORDER_CALCULATION'),(16650,'STR_POST_BY_LINE'),(16651,'STR_POST_BY_SHIPPPING_AND_RECEIVING'),(16652,'STR_B2B_USER_LOGIN'),(16653,'STR_LOGIN_AS_THIS_USER'),(16654,'STR_CANNOT_SAVE_AS_ORDER_COMPLETE'),(16655,'STR_NO_POD_FILE_ATTACHED_TO_ORDER'),(16656,'STR_DROP_SHIP'),(16657,'STR_ARCHIVE_AND_SAVE'),(16658,'STR_CLOSED_BY_COST_CODE'),(16659,'STR_CLOSED_BY_GL_CATEGORY'),(16660,'STR_CLOSE_ACCOUNTS_BY_COST_CODE'),(16661,'STR_CLOSE_ACCOUNTS_BY_GL_CATEGORY'),(16662,'STR_DATE_CANCELED'),(16663,'STR_13TH_PERIOD_ENTRY'),(16664,'STR_TAX_ADJUSTING_ENTRY'),(16665,'STR_YEAR_END_ADJUSTING_ENTRY'),(16666,'STR_13TH_PERIOD_ENTRIES'),(16667,'STR_TAX_ADJUSTING_ENTRIES'),(16668,'STR_WITH_YEAR_END_ADJUSTING_ENTRIES'),(16669,'STR_NON_STOCK'),(16670,'STR_OTHER_CHARGE'),(16671,'STR_OTHER_CHARGES'),(16672,'STR_TRANSFER_BETWEEN_LOCATIONS'),(16673,'STR_TRANSFER_DETAILS'),(16674,'STR_NON_STOCKED'),(16675,'STR_RENTAL'),(16676,'STR_STOCKED'),(16677,'STR_0_FOR_NO_MAX'),(16678,'STR_0_FOR_NO_MIN'),(16679,'STR_AVG_QTY_PER_MONTH'),(16680,'STR_CREATED_PURCHASE_ORDER'),(16681,'STR_CREATE_PURCHASE_ORDER'),(16682,'STR_DISTRIBUTION_CENTERS'),(16683,'STR_INVENTORY_LOCATIONS'),(16684,'STR_MAX_ON_HAND'),(16685,'STR_MIN_ON_HAND'),(16686,'STR_MY_VENDORS'),(16687,'STR_NUM_MONTHS_SALES_FOR_MAXIMUM_ON_HAND'),(16688,'STR_NUM_MONTHS_SALES_FOR_MINIMUM_ON_HAND'),(16689,'STR_NUM_MONTHS_SALES_FOR_REORDER_QUANTITY'),(16690,'STR_IS_DEFAULT_ITEM_VENDOR'),(16691,'STR_NUMBER_OF_DAYS'),(16692,'STR_QUOTE_LEAD_TIME'),(16693,'STR_SETTING_THIS_VENDOR_AS_THE_DEFAULT_FOR_THIS_ITEM_WILL_REMOVE_ANY_OTHER_DEFAULT_VENDORS_FOR_THIS_ITEM'),(16694,'STR_VENDOR_UPC'),(16695,'STR_RTV_NUMBER'),(16696,'STR_BACK_ORDER'),(16697,'STR_CANNOT_CHANGE_THIS_ORDER_TO_DROP_SHIP'),(16698,'STR_CURRENT_LOCATION'),(16699,'STR_ORDER_HAS_SHIPMENTS_OF_NON_DROP_SHIP_ITEMS'),(16700,'STR_ORDER_QUANTITY_NOT_AVAILABLE_AT_LOCATION'),(16701,'STR_REDUCE_ORDER_QUANTITY'),(16702,'STR_THE_FOLLOWING_NON_DROP_SHIP_ITEMS_TO_BE_REMOVED'),(16703,'STR_VOUCHER_ID'),(16704,'STR_PRIMARY_BUYER'),(16705,'STR_IF_COUNTY_NOT_ON_LIST'),(16706,'STR_UPDATE_ACTION'),(16707,'STR_REQUIRE_COST_CODES_IF_GL_ACCOUNT_HAS_COST_CODES'),(16708,'STR_REQUIRE_GL_CATEGORY_IF_GL_ACCOUNT_HAS_GL_CATEGORIES'),(16709,'STR_DISTRIBUTION_CENTER'),(16710,'STR_IS_DISTRIBUTION_CENTER'),(16711,'STR_CHECKED_IN'),(16712,'STR_CHECK_IN'),(16713,'STR_CHECK_IN_NOW'),(16714,'STR_CHECK_IN_TIME'),(16715,'STR_SAVE_NOTES'),(16716,'STR_UPDATE_NOTES'),(16717,'STR_COULD_NOT_FIND_GL_ACCOUNT_BY_NAME'),(16718,'STR_PATIENT_IMPORT'),(16719,'STR_FILL_DAY'),(16720,'STR_LAST_APPOINTMENT'),(16721,'STR_PLEASE_777_CHMOD'),(16722,'STR_ALL_APPOINTMENTS'),(16723,'STR_BOOK_THIS_APPOINTMENT'),(16724,'STR_COMMAND_NOT_FOUND'),(16725,'STR_CONFIRM_APPOINTMENT_TIME'),(16726,'STR_FEATURE_NOT_ENABLED'),(16727,'STR_NEXT_APPOINTMENT'),(16728,'STR_NO_UPCOMING_APPOINTMENT'),(16729,'STR_OPEN_APPOINTMENTS_FOR'),(16730,'STR_SELECT_A_DATE_TO_VIEW_OPEN_APPOINTMENTS'),(16731,'STR_WHERE'),(16732,'STR_SCHEDULE_AN_APPOINTMENT'),(16733,'STR_SELECT_DATE'),(16734,'STR_INVENTORY_ADJUSTMENT_REQUEST_TYPE'),(16735,'STR_INVENTORY_ADJUSTMENT_REQUEST_TYPE_BY_THIS_CODE_ALREADY_EXISTS'),(16736,'STR_INVENTORY_ADJUSTMENT_REQUEST_TYPE_CODE_MUST_BE_SET'),(16737,'STR_POST_BY_SHIPPING_AND_RECEIVING'),(16738,'STR_LOG_IN_AS_THIS_USER'),(16739,'STR_INCLUDE_QUOTES'),(16740,'STR_ARE_YOU_SURE_YOU_WANT_TO_CANCEL_YOUR_UPCOMING_APPOINTMENT'),(16741,'STR_CANCELLATION_WINDOW_CLOSED'),(16742,'STR_CANCEL_THIS_APPOINTMENT'),(16743,'STR_RECORDS_UPDATED'),(16744,'STR_SELECT_SERVICE'),(16745,'STR_WITH'),(16746,'STR_YOU_WILL_RECEIVE_AN_EMAIL_SHORTLY_AS_CONFIRMATION'),(16747,'STR_YOU_WILL_RECEIVE_AN_EMAIL_SHORTLY_WITH_YOUR_APPOINTMENT_DETAILS'),(16748,'STR_STORED_PAYMENT_METHODS'),(16749,'STR_YOU_MUST_PROVIDE_A_PAYMENT_METHOD_TO_BOOK_AN_APPOINTMENT'),(16750,'STR_I_HAVE_THE_AUTHORITY_TO_AUTHORIZE_AND_DO_AUTHORIZE_THE_ABOVE_BANK_ACCOUNT_TO_BE_DEBITED_FOR_THE_LISTED_AMOUNT'),(16751,'STR_YOU_MUST_AUTHORIZE_THIS_TRANSACTION'),(16752,'STR_BANK_REC_DATE'),(16753,'STR_PAID_ON_INVOICE'),(16754,'STR_REF_NUMBER'),(16755,'STR_CUSTOMER_MUST_BE_SET'),(16756,'STR_IMPORT_CUSTOMER_SHIP_TOS'),(16757,'STR_ASSIGNED_USER'),(16758,'STR_DUE_DATE_END'),(16759,'STR_DUE_DATE_START'),(16760,'STR_ENTRY_DATE_END'),(16761,'STR_ENTRY_DATE_START'),(16762,'STR_FROM____SUPPLIER'),(16763,'STR_ITEM_TRANSFER_MANAGEMENT'),(16764,'STR_NOBODY'),(16765,'STR_NO_ACTIVE_TRANSFERS_ASSIGNED_TO_USER'),(16766,'STR_NUM_ITEMS_PICKED'),(16767,'STR_PICKED'),(16768,'STR_PRINT_PICK_TICKET'),(16769,'STR_TO___REQUESTER'),(16770,'STR_TRANSFERS_ASSIGNED_TO'),(16771,'STR_INTERCOMPANY_ITEM_TRANSFER_SHIPMENT'),(16772,'STR_SHIPMENT_DATE'),(16773,'STR_IMPORT_CUSTOMER_INVOICES'),(16774,'STR_IMPORT_CUSTOMER_INVOICE_CHANGES'),(16775,'STR_IMPORT_DISTRIBUTOR_SALES'),(16776,'STR_IMPORT_PATIENT_INFO'),(16777,'STR_ITEM_CATEGORY_DISCOUNTS'),(16778,'STR_NEW_RENTAL_ORDER'),(16779,'STR_NEW_RENTAL_QUOTE'),(16780,'STR_PRINT_PICKING_TICKETS'),(16781,'STR_RENTAL_ORDERS'),(16782,'STR_RENTAL_QUOTES'),(16783,'STR_TRANSFERS'),(16784,'STR_CUSTOMER_SALES_TAX_UPDATED'),(16785,'STR_RENTAL_ORDER'),(16786,'STR_NEW_UNASSIGNED'),(16787,'STR_RECEIVED_COMPLETED'),(16788,'STR_BURDEN'),(16789,'STR_CANNONT_PROCESS_TRANSFER'),(16790,'STR_DEFAULT_INVENTORY_ACCOUNT_MUST_BE_SET'),(16791,'STR_INTERBRANCH_TRANSFER_BURDEN_PERCENTAGE_GL_ACCOUNT_MUST_BE_SET'),(16792,'STR_ITEM_NOT_SET'),(16793,'STR_LOCATION_NOT_SET'),(16794,'STR_MULIPLE_LOCATION_COMBINATIONS'),(16795,'STR_DISCHARGED'),(16796,'STR_HALF_PROGRAM_JOINED'),(16797,'STR_JOINED'),(16798,'STR_MEMBERSHIP_SUMMARY'),(16799,'STR_NOT_JOINED'),(16800,'STR_NO_SHOW'),(16801,'STR_PROFESSIONAL_COURTESY'),(16802,'STR_SIGNUP_DATE'),(16803,'STR_TOTAL_MEMBERS'),(16804,'STR_REFERRAL_SUMMARY'),(16805,'STR_MEMBERSHIP_REPORT'),(16806,'STR_REFERRAL_REPORT'),(16807,'STR_SELECT_DATE_RANGE'),(16808,'STR_SELECT_REPORT_OPTIONS'),(16809,'STR_APPOINTMENT_HOST'),(16810,'STR_APPOINTMENT_SERVICE'),(16811,'STR_CHANGE_SERVICE_TYPE'),(16812,'STR_PRINTER_FRIENDLY_SUMMARY'),(16813,'STR_REPEAT'),(16814,'STR_PURGE_EXISTING_DATA_FOR_CUSTOMERS_IN_IMPORT'),(16815,'STR_PRIMARY_LOCATION'),(16816,'STR_STREET_ADDRESS_LINE_2'),(16817,'STR_DELETE_EXISTING'),(16818,'STR_DELETE_THIS_DISCOUNT'),(16819,'STR_DISCOUNT_NAME'),(16820,'STR_EDIT_ITEM_CATEGORY_DISCOUNTS_PER_PRICE_LEVEL'),(16821,'STR_ITEM_CATEGORY_MATCH_TERM'),(16822,'STR_MATCHING_ITEM_CATEGORIES'),(16823,'STR_THE_FOLLOWING_DISCOUNT_WILL_BE_DELETED'),(16824,'STR_USE_PERCENT_CHARACTER_AS_A_WILDCARD_MATCH'),(16825,'STR_RENTAL_QUOTE'),(16826,'STR_ACCOUNT_DELETED'),(16827,'STR_ACCOUNT_MISSING'),(16828,'STR_ACCEPT_SUGGESTED_TAXES'),(16829,'STR_CURRENT_SALES_TAX'),(16830,'STR_CUSTOMER_RECORD'),(16831,'STR_MAXIMUM_OF_3_TAX_RATES_PER_CUSTOMER_OR_SHIP_TO_RECORD'),(16832,'STR_SALES_TAX_CONFLICT'),(16833,'STR_SALES_TAX_PREFERENCE'),(16834,'STR_SELECTION_LIMIT_EXCEEDED'),(16835,'STR_SHIP_TO_RECORD'),(16836,'STR_SUGGESTED_SALES_TAX'),(16837,'STR_TAX_ORDER_BY_ADDRESS'),(16838,'STR_TAX_SHIP_TO'),(16839,'STR_THIS_ACTION_WILL_REMOVE_SET_TAXES_FOR_THIS_CUSTOMER'),(16840,'STR_USE_SELECTED_TAXES'),(16841,'STR_WILL_BE_UPDATED'),(16842,'STR_BOX_10_DEPENDENT_CARE_BENEFITS'),(16843,'STR_PAYMENT_AFTER_DISCOUNT'),(16844,'STR_RECENT_ORDERS'),(16845,'STR_OVERRIDES'),(16846,'STR_RENTAL_ORDER_DEPOSIT'),(16847,'STR_RENTAL_ORDER_NUMBER'),(16848,'STR_RENTAL_ORDERS_ONLY'),(16849,'STR_ALL_RECORDS_COULD_NOT_BE_DISPLAYED'),(16850,'STR_RENTAL_ORDER_QUOTES'),(16851,'STR_HIDE_ACCOUNTS_WITH_NO_ACTIVITY'),(16852,'STR_CARD_NOT_FOUND_FOR_VENDOR_ID'),(16853,'STR_CODE_FOR_THE_CC_VENDOR'),(16854,'STR_ID_OR_CODE_REQUIRED'),(16855,'STR_MUST_HAVE_VENDOR_ID_OR_CODE_PAYMENT_DATE_PAYMENT_AMOUNT_EXPENSE_GL_ACCOUNT_AND_MERCHANT_NAME'),(16856,'STR_VENDOR_ID_INFO'),(16857,'STR_MUST_HAVE_VENDOR_ID_OR_CODE_PAYMENT_DATE_PAYMENT_AMOUNT_EXPENSE_GL_ACCOUNT_AND_BUSINESS_PURPOSE'),(16858,'STR_PRICE_PER_DAY_AT_LEVEL'),(16859,'STR_PRICE_PER_MONTH_AT_LEVEL'),(16860,'STR_PRICE_PER_WEEK__AT_LEVEL'),(16861,'STR_EDIT_ITEM_LOCATION'),(16862,'STR_INTERCOMPANY_TRANSFER'),(16863,'STR_PLEASE_CHANGE_YOUR_ACTIVE_COMPANY_TO_EDIT_THIS'),(16864,'STR_PRINT_POSTED_ENTRIES'),(16865,'STR_PRIOR_SHIPMENTS'),(16866,'STR_SHIPPED_BY'),(16867,'STR_TRANSFER_UPDATE_PARTIALLY_SUCCESSFUL'),(16868,'STR_PER_DAY'),(16869,'STR_PER_WEEK'),(16870,'STR_PRICE_PER_DAY'),(16871,'STR_PRICE_PER_MONTH'),(16872,'STR_PRICE_PER_WEEK'),(16873,'STR_RECEIPT_FAILED'),(16874,'STR_RECEIVED_NO_PO'),(16875,'STR_RECEIPT_BATCH_ID'),(16876,'STR_DEFAULT_PRICING'),(16877,'STR_YOU_MUST_ENTER_A_VENDOR_PO_NUMBER_OR_RECEIPT_BATCH_ID'),(16878,'STR_OVER_COMMIT_QTY'),(16879,'STR_PURCHASE_FROM_VENDOR'),(16880,'STR_RENTAL_QUOTE_NUMBER'),(16881,'STR_SELL_FROM'),(16882,'STR_THIS_POPUP_CAN_BE_DISABLED_UNDER'),(16883,'STR_TRANSFER_FROM'),(16884,'STR_WAIT_ON_BACKORDER'),(16885,'STR_ALREADY_SHIPPED'),(16886,'STR_CREATED_FOR_SALES_ORDER'),(16887,'STR_ERROR_SAVING_AN_ORDER_THAT_CONTAINS_AN_ITEM_TRANSFER'),(16888,'STR_NO_CHANGES_MADE_TO_TRANSFER'),(16889,'STR_THIS_ORDER_HAS_MULTIPLE_TRANSFERS_ASSIGNED'),(16890,'STR_TRIED_TO_CREATE_A_PO_FOR_AN_ITEM_WITHOUT_A_VENDOR'),(16891,'STR_WILL_NOT_BE_CHANGED'),(16892,'STR_INVOICE_LIST_OVERFLOWS_AT_MORE_THAN'),(16893,'STR_ITEM_CATEGORY_DISCOUNTS_FOR_PRICE_LEVELS'),(16894,'STR_FOR_INSUFFICIENT_QTY'),(16895,'STR_TRANSFER_INVENTORY_FROM'),(16896,'STR_SHOW_ITEM_SEARCH_ICON_IN_HEADER'),(16897,'STR_CANNOT_PROCESS_TRANSFER'),(16898,'STR_MULTIPLE_LOCATION_COMBINATIONS'),(16899,'STR_IMPORT_CUSTOMER_CONTACTS'),(16900,'STR_IMPORT_VENDOR_CONTACTS'),(16901,'STR_DISMISS_PO_ITEM_IMPORT_POPUP_WARNING'),(16902,'STR_VENDOR_ADDRESS'),(16903,'STR_DISMISS'),(16904,'STR_ITEMS_SKIPPED_DURING_IMPORT'),(16905,'STR_PLEASE_VERIFY_YOUR_ITEM_CODES'),(16906,'STR_THE_FOLLOWING_ITEMS_COULD_NOT_BE_IMPORTED'),(16907,'STR_CHARGE_TYPE_NOT_SET_FOR'),(16908,'STR_CHANGING_THIS_ORDER_TO_DROP_SHIP_WILL_MAKE_THE_FOLLOWING_CHANGES'),(16909,'STR_HIDE_2ND_STUB_HEADER'),(16910,'STR_HIDE_DISCOUNT_TOTAL'),(16911,'STR_HIDE_INTEREST_TOTAL'),(16912,'STR_SHOW_BILL_COMMENTS_ON_STUB'),(16913,'STR_ENDING'),(16914,'STR_CUSTOMER_CONTACTS'),(16915,'STR_CUSTOMER_ID_CODE_OR_NAME_MUST_BE_SET'),(16916,'STR_VENDOR_CONTACTS'),(16917,'STR_CUSTOMER_APPOINTMENTS'),(16918,'STR_NEW_BANK_RECONCILIATION'),(16919,'STR_ACTUAL_APPOINTMENTS'),(16920,'STR_ALL_DATES'),(16921,'STR_APPOINTMENT_HISTORY_FOR'),(16922,'STR_CANCELLATIONS_OR_RESCHEDULES'),(16923,'STR_MISSED'),(16924,'STR_MISSED_APPOINTMENTS'),(16925,'STR_TOTAL_BOOKINGS'),(16926,'STR_CUSTOMER_APPOINTMENT_REPORT_OPTIONS'),(16927,'STR_GENERATE_REPORT'),(16928,'STR_YOU_MUST_SELECT_A_CUSTOMER_TO_PROCEED'),(16929,'STR_APPROVED_BILLS_REPORT'),(16930,'STR_APPROVED_BILLS'),(16931,'STR_PAYMENT_TOTAL'),(16932,'STR_DEFAULT_LINE_NOTE'),(16933,'STR_CONVERT_SELECTED'),(16934,'STR_CONVERT_TO_PO'),(16935,'STR_ORDER_LINE_NUM'),(16936,'STR_PO_PROPOSAL_MANAGEMENT'),(16937,'STR_PROPOSALS_CONVERTED'),(16938,'STR_PROPOSAL_CONVERTED'),(16939,'STR_PROPOSAL_NUM'),(16940,'STR_SELECTED_PROPOSALS'),(16941,'STR_NO_FEDERAL_INCOME_TAXES'),(16942,'STR_ENABLE_COMMERCIAL_AP'),(16943,'STR_MAX_INVOICES'),(16944,'STR_NUMBER_OF_INVOICE_SECTIONS_ON_STUB'),(16945,'STR_NUM_SECTIONS'),(16946,'STR_SHOW_INVOICE_COMMENTS_ON_STUB'),(16947,'STR_SHOW_INVOICE_DISCOUNTS_ON_STUB'),(16948,'STR_NEW_INTERCOMPANY_JOURNAL_ENTRY'),(16949,'STR_SHOPIFY_SETUP'),(16950,'STR_REQUIRED_FEATURE_NOT_FOUND'),(16951,'STR_STORE_CONFIGURATION_DELETED'),(16952,'STR_STORE_CONFIGURATION_SAVED'),(16953,'STR_ALL_HOSTS'),(16954,'STR_ARE_YOU_SURE_YOU_WANT_TO_CONTINUE'),(16955,'STR_FILTER'),(16956,'STR_NOTE_CONFLICT'),(16957,'STR_NOTE_HAS_CHANGED_SINCE_LAST_REFRESH'),(16958,'STR_THEIRS'),(16959,'STR_YOURS'),(16960,'STR_YOU_HAVE_UNSAVED_CHANGES'),(16961,'STR_AUTOMATICALLY_SYNC_CUSTOMERS'),(16962,'STR_AUTOMATICALLY_SYNC_ITEMS'),(16963,'STR_AUTOMATICALLY_SYNC_ITEM_TAGS'),(16964,'STR_AUTOMATICALLY_SYNC_ORDERS'),(16965,'STR_AUTOMATICALLY_SYNC_PAYMENTS'),(16966,'STR_AUTOMATICALLY_SYNC_SHIPPING'),(16967,'STR_BEFORE_ATTEMPTING_TO_EDIT_YOUR_CREDENTIALS'),(16968,'STR_CHECK_FOR_MISSING_DATA'),(16969,'STR_CLICK_HERE_FOR_HELP'),(16970,'STR_CLICK_OK_TO_OPEN_THE_LINK_IN_A_NEW_WINDOW_FOR_VERIFICATION'),(16971,'STR_COULD_NOT_CONNECT_WITH_PROVIDED_INFORMATION'),(16972,'STR_CUSTOMER_CREATION'),(16973,'STR_CUSTOMER_DELETION'),(16974,'STR_CUSTOMER_DISABLE'),(16975,'STR_CUSTOMER_ENABLE'),(16976,'STR_EDIT_CREDENTIALS'),(16977,'STR_EVENT_LIST'),(16978,'STR_FOR_SHOPIFY_TO_AUTOMATICALLY_SEND_DATA_TO_YOUR_APPLICATION_YOU_MUST_ADD_YOUR_WEBHOOK_URL_TO_THE_SHOPIFY_EVENTS_LISTED_BELOW'),(16979,'STR_INTEGRATION_OPTIONS'),(16980,'STR_MAKE_SURE_THE_URL_BELOW_POINTS_TO_YOUR_SHOPIFY_STORE'),(16981,'STR_ORDER_CANCELLATION'),(16982,'STR_ORDER_CREATION'),(16983,'STR_ORDER_DELETION'),(16984,'STR_ORDER_FULFILLMENT'),(16985,'STR_ORDER_PAYMENT'),(16986,'STR_PLAN'),(16987,'STR_PRODUCT_CREATION'),(16988,'STR_PRODUCT_DELETION'),(16989,'STR_PRODUCT_UPDATE'),(16990,'STR_SAVE_OPTIONS'),(16991,'STR_SHARED_SECRET'),(16992,'STR_SHOPIFY_HAS_AN_API_USAGE_LIMIT'),(16993,'STR_SHOPIFY_INTEGRATION_MANAGER'),(16994,'STR_STORE_INFO'),(16995,'STR_STORE_NAME'),(16996,'STR_USE_SHOPIFY_PAYMENTS'),(16997,'STR_USE_SHOPIFY_SHIPPING_QUOTES'),(16998,'STR_VERIFY_STORE_URL'),(16999,'STR_YOUR_WEBHOOK_URL'),(17000,'STR_LINK_TO_YOUR_SHOPIFY_STORE'),(17001,'STR_APPLY_DISCOUNTS_EVEN_IF_PAST_DISCOUNT_DATE'),(17002,'STR_DISCOUNT_FILTER'),(17003,'STR_FORCE_DISCOUNTS'),(17004,'STR_NO_EFT_DATA_SENT_AS_VENDOR_DOES_NOT_HAVE_BANK_INFO'),(17005,'STR_SHOW_ALL_BILLS'),(17006,'STR_SHOW_ONLY_BILLS_WITH_PAY_DATES_AFTER_DISCOUNT_DATES'),(17007,'STR_SHOW_ONLY_BILLS_WITH_PAY_DATES_ON_OR_BEFORE_DISCOUNT_DATES'),(17008,'STR_COLOR_CODE'),(17009,'STR_DEFAULT_LENGTH'),(17010,'STR_LOCK_PRICE_AND_COST_DURING_SALE'),(17011,'STR_NO_PAY_FOR_SELECTED_PERIODS'),(17012,'STR_SHOW_EMPLOYEES_WITH_NO_PAY'),(17013,'STR_NO_PAY_FOR_SELECTED_PERIOD'),(17014,'STR_BLOCK_DEDUCTIONS'),(17015,'STR_FORCE_DISCOUNTS_TO_BE_TAKEN'),(17016,'STR_TAKE_DISCOUNT_EVEN_IF_PAYING_AFTER_DISCOUNT_DATE'),(17017,'STR_SHOW_ONLY_BILLS_WITHOUT_DISCOUNTS'),(17018,'STR_SHOW_ONLY_BILLS_WITH_DISCOUNTS'),(17019,'STR_BATCH_SEND_JOB_PRELIM_REQUESTS'),(17020,'STR_ONLY_JOBS_WITH_NO_EXISTING_PRELIM_REQUESTS'),(17021,'STR_PREFERRED_METHOD'),(17022,'STR_PRICE_OVERRIDE_REQUEST'),(17023,'STR_PRICE_OVERRIDE_REQUESTS'),(17024,'STR_DECLINE'),(17025,'STR_REQUESTED'),(17026,'STR_SET_PRICE'),(17027,'STR_THIS_REQUEST_CANNOT_BE_MODIFIED'),(17028,'STR_THIS_REQUEST_HAS_ALREADY_BEEN_APPROVED'),(17029,'STR_THIS_REQUEST_HAS_ALREADY_BEEN_DENIED'),(17030,'STR_THIS_REQUEST_HAS_BEEN_APPROVED'),(17031,'STR_THIS_REQUEST_HAS_BEEN_DENIED'),(17032,'STR_INITIAL_CONSULT'),(17033,'STR_TOTAL_STATUS_CHANGES'),(17034,'STR_AUTO_REFRESH_IN'),(17035,'STR_AUTO_REFRESH_PREFERENCE'),(17036,'STR_DO_NOT_AUTO_REFRESH'),(17037,'STR_ENABLE_AUTO_REFRESH'),(17038,'STR_EVERY_10_MINUTES'),(17039,'STR_EVERY_15_MINUTES'),(17040,'STR_EVERY_20_MINUTES'),(17041,'STR_EVERY_5_MINUTES'),(17042,'STR_FOR_CUSTOMER'),(17043,'STR_FOR_ITEM'),(17044,'STR_REQUESTED_PRICE'),(17045,'STR_REQUESTED_TIME'),(17046,'STR_REQUESTED_USER'),(17047,'STR_CUSTOMER_NOT_SET'),(17048,'STR_PENDING_PRICE_REQUESTS_HAVE_BEEN_APPLIED'),(17049,'STR_REQUEST_AUTHORIZATION'),(17050,'STR_REQUEST_PRICE'),(17051,'STR_REQUEST_PRICE_CHANGE'),(17052,'STR_NOTICES'),(17053,'STR_ALLOW_EDITING_NOTE_DATES'),(17054,'STR_CAN_OVERRIDE_FOPOS_PRICES'),(17055,'STR_USER_RIGHTS_FOR_COMPANY'),(17056,'STR_APPOINTMENT_ON'),(17057,'STR_APPOINTMENT_TO_CANCEL'),(17058,'STR_ARE_YOU_SURE_YOU_WANT_TO_RESCHEDULE_THIS_APPOINTMENT'),(17059,'STR_AVAILABLE_APPOINTMENTS'),(17060,'STR_CHANGE_APPOINTMENT'),(17061,'STR_I_WANT_TO'),(17062,'STR_KEEP'),(17063,'STR_RESCHEDULE'),(17064,'STR_IF_ALREADY_SET'),(17065,'STR_CHECK_TOTAL'),(17066,'STR_CHECK_TOTAL_IS_NEGATIVE_SO_REMOVING_BILLS_FROM_CHECK_RUN'),(17067,'STR_ORIG_AMT'),(17068,'STR_MORE_OPTIONS'),(17069,'STR_SHOW_INVOICE_ORIGINAL_AMOUNT'),(17070,'STR_CHECKING_ACCOUNT_FILES'),(17071,'STR_VENDOR_STATEMENTS'),(17072,'STR_ADJUST_FIREWALL_FOR_TERMINALS_IP'),(17073,'STR_CC_TERMINAL'),(17074,'STR_CHECKING_ACCOUNT_NOT_SET_FOR_CC_TERMINAL'),(17075,'STR_DECLINED'),(17076,'STR_IP_ADDRESS'),(17077,'STR_CREDIT_CARD_TERMINALS_HISTORY'),(17078,'STR_TERMINAL'),(17079,'STR_MAIL_LOG'),(17080,'STR_MAIL_LOG_ENTRY'),(17081,'STR_MAIL_LOG_OPEN'),(17082,'STR_SHOW_ONLY_FAILED'),(17083,'STR_CREDIT_CARD_TERMINALS'),(17084,'STR_CERTIFICATE_EXPIRED_EMAIL'),(17085,'STR_CERTIFICATE_EXPIRING_SOON_EMAIL'),(17086,'STR_CERTIFICATE_MISSING_EMAIL'),(17087,'STR_EMAIL_TEMPLATE_NOT_SET_ON_CERTIFICATE_TYPE'),(17088,'STR_EXPIRATION_DATE_NO_SET'),(17089,'STR_SEND_EMAILS_TO_ALL'),(17090,'STR_SEND_SELECTED_EMAILS'),(17091,'STR_CHANGE_APPOINTMENT_HOST'),(17092,'STR_NO_CREDIT_CARD_TERMINALS_FOUND'),(17093,'STR_SHOW_TERMINALS_FROM_OTHER_LOCATIONS'),(17094,'STR_DETACH'),(17095,'STR_NO_CC_TERMINAL_SELECTED'),(17096,'STR_ONLY_SMTP_EMAILS_WILL_LOG_MESSAGE_SENT'),(17097,'STR_DEFAULT_PAYMENT_EMAIL_TEMPLATE'),(17098,'STR_SEND_EMAILS_FOR_WHICH_PAYMENT_TYPES'),(17099,'STR_ALLOW_ZERO_QUANTITY_ON_QUOTES'),(17100,'STR_DOWNLOAD_NOT_ALLOWED'),(17101,'STR_MUST_HAVE_CUSTOMER_BANK_INFO_RIGHTS'),(17102,'STR_MUST_HAVE_VENDOR_BANK_INFO_RIGHTS'),(17103,'STR_NOT_ALLOWED'),(17104,'STR_PRINT_BATCH'),(17105,'STR_PRINT_AP_BATCH'),(17106,'STR_AN_ERROR_OCCOURED_DURING_CONNECTION'),(17107,'STR_CHARGE'),(17108,'STR_COLLECTION_PAYMENT_FROM_TERMINAL'),(17109,'STR_COLLECT_PAYMENT'),(17110,'STR_PLEASE_CHECK_WITH_YOUR_CC_PROCESSOR_IF_THE_TRANSACTION_WAS_APPROVED'),(17111,'STR_SELECT_A_CC_TERMINAL'),(17112,'STR_WAITING_ON_PAYMENT'),(17113,'STR_TRANSACTION_FAILED'),(17114,'STR_TRANSACTION_NUMBER'),(17115,'STR_BILLING_CYCLE_DATE'),(17116,'STR_MANUAL_CREDIT_CARD_PROCESSING'),(17117,'STR_TERMINAL_CREDIT_CARD_PROCESSING'),(17118,'STR_MUST_HAVE_VENDOR_BANK_INFO_RIGHTS_TO_VIEW_OR_MODIFY'),(17119,'STR_MUST_HAVE_CUSTOMER_BANK_INFO_RIGHTS_TO_VIEW_OR_MODIFY'),(17120,'STR_CAN_VIEW_AND_EDIT_CUSTOMER_BANK_INFO'),(17121,'STR_CAN_VIEW_AND_EDIT_VENDOR_BANK_INFO'),(17122,'STR_AN_ERROR_OCCURRED_DURING_CONNECTION'),(17123,'STR_COLLECT_PAYMENT_FROM_TERMINAL'),(17124,'STR_PLEASE_CHECK_WITH_YOUR_CC_PROCESSOR_TO_SEE_IF_THE_TRANSACTION_WAS_APPROVED'),(17125,'STR_ARE_YOU_SURE_YOU_WANT_TO_RESCHEDULE_YOUR_APPOINTMENT'),(17126,'STR_CHANGE_THIS_APPOINTMENT'),(17127,'STR_CHANGE_YOUR_APPOINTMENT'),(17128,'STR_MY_APPOINTMENT_ON'),(17129,'STR_INVALID_REQUEST'),(17130,'STR_SERVICE_ORDER_CLONED_SUCCESSFULLY'),(17131,'STR_CLONE_SERVICE_ORDER'),(17132,'STR_CLONE_WITHOUT_TIME'),(17133,'STR_CLONE_WITH_TIME_RECORDS'),(17134,'STR_SELECT_ACTION'),(17135,'STR_AP_VARIANCE'),(17136,'STR_ORDER_CHANGED'),(17137,'STR_ORDER_CHANGED_BY_USER'),(17138,'STR_ORDER_DELETED_BY_USER'),(17139,'STR_SEND_EMAIL_TO_ADMINS_WHEN_FULFILLMENT_ORDER_IS_MODIFIED'),(17140,'STR_SEND_EMAIL_TO_SALESPERSON_WHEN_FULFILLMENT_ORDER_IS_MODIFIED'),(17141,'STR_ALSO_THE_DATE_RANGE_WILL_BE_CHANGED_TO_COVER_WHOLE_MONTHS'),(17142,'STR_AP_VARIANCE_TRACKER'),(17143,'STR_BILL_DISC_PMT_DIFF'),(17144,'STR_BILL_GL_ENTRIES'),(17145,'STR_DIFFERENCE_EXISTS'),(17146,'STR_END_PERIOD_BALANCE'),(17147,'STR_GL_ENTRIES_TO_AP_FROM_THE_AP_MODULE_BUT_NO_REFERENCE'),(17148,'STR_GL_ENTRIES_TO_AP_OUTSIDE_THE_AP_MODULE'),(17149,'STR_GL_NET_AP'),(17150,'STR_GL_VALUES'),(17151,'STR_IF_UNCHECKED_POST_DATE_WILL_BE_USED_FOR_POSTED_TRANSACTIONS'),(17152,'STR_PAYMENT_GL_ENTRIES'),(17153,'STR_PERIOD_NET_ACTIVITY'),(17154,'STR_SIGN_FLIPPED'),(17155,'STR_TOTAL_BILLS'),(17156,'STR_TOTAL_BILLS_OPEN'),(17157,'STR_TOTAL_BILL_DETAILS'),(17158,'STR_TOTAL_DISCOUNTS'),(17159,'STR_TOTAL_GL_BILLS'),(17160,'STR_TOTAL_GL_PAYMENTS'),(17161,'STR_USE_ONLY_ENTRY_DATE'),(17162,'STR_SHOW_AP_DETAILS'),(17163,'STR_GL_ACCOUNT_DEPOSITED_TO'),(17164,'STR_BANK_RECONCILIATIONS_TABLE'),(17165,'STR_PRELIM_AMOUNT'),(17166,'STR_PRELIM_ESTIMATE'),(17167,'STR_SALES_TAX_CODE'),(17168,'STR_SALES_TAX_NOT_FOUND'),(17169,'STR_AP_IMPORT_FROM_EBAY_AS_BUYER'),(17170,'STR_AR_IMPORT_FROM_EBAY_AS_SELLER'),(17171,'STR_CREATE_MULTIPLE_RMAS'),(17172,'STR_EBAY_SETUP'),(17173,'STR_EMPLOYEE_CERTIFICATE_TYPES'),(17174,'STR_QR_DOCUMENT_SCANNER'),(17175,'STR_ITEMS_ON_RETURN'),(17176,'STR_RETURN_QTY'),(17177,'STR_RMA_NUM'),(17178,'STR_GENERATE_QR_CODE'),(17179,'STR_EMPLOYEE_CERTIFICATE'),(17180,'STR_EMPLOYEE_CERTIFICATE_TYPE'),(17181,'STR_IMPORT_VENDOR'),(17182,'STR_EMPLOYEE_CERTIFICATES'),(17183,'STR_DUPLICATE_LINE_REMOVED'),(17184,'STR_QUANITY'),(17185,'STR_RMA_ACTION'),(17186,'STR_RMA_CONDITION'),(17187,'STR_RMA_REASON'),(17188,'STR_CREATED_RMAS'),(17189,'STR_RECORD'),(17190,'STR_ATTACH_TO'),(17191,'STR_REVIEW_UPLOADS'),(17192,'STR_NEXT_RMA_NUMBER'),(17193,'STR_RMA_RETURN_POLICY'),(17194,'STR_RMA_SETTINGS'),(17195,'STR_BASED_ON_PRELIM_AMOUNT'),(17196,'STR_HIDE_ITEM_CODES'),(17197,'STR_HIDE_JOB_CODE'),(17198,'STR_JOB_CREDIT_LIMIT_MARKUP'),(17199,'STR_BILL_TOTAL'),(17200,'STR_SHOW_ONLY_ENTRIES_WITH_DIFFERENCES'),(17201,'STR_TOTAL_BILLS_DATED_INSIDE_THIS_PERIOD_BUT_POSTED_OUTSIDE_THIS_PERIOD'),(17202,'STR_TOTAL_BILLS_DATED_OUTSIDE_THIS_PERIOD_BUT_POSTED_INSIDE_THIS_PERIOD'),(17203,'STR_TOTAL_BILLS_NET'),(17204,'STR_TOTAL_PAYMENTS_DATED_INSIDE_THIS_PERIOD_BUT_POSTED_OUTSIDE_THIS_PERIOD'),(17205,'STR_TOTAL_PAYMENTS_DATED_OUTSIDE_THIS_PERIOD_BUT_POSTED_INSIDE_THIS_PERIOD'),(17206,'STR_TOTAL_PAYMENTS_NET'),(17207,'STR_SHOW_COST_CODES_FOR_DIRECT_GL_ENTRIES'),(17208,'STR_SHOW_GL_CATEGORIES_FOR_DIRECT_GL_ENTRIES'),(17209,'STR_INCLUDE_CUSTOMER_NOTES'),(17210,'STR_AN_EMPLOYEE_WITH_THIS_SOCIAL_SECURITY_NUMBER_ALREADY_EXISTS'),(17211,'STR_2ND_STUB_IS_A_COPY'),(17212,'STR_ALWAYS_PAY_ON_WHICH_DATE'),(17213,'STR_USE_DEFAULT_DATES'),(17214,'STR_SEND_CONFIRMATIONS'),(17215,'STR_SEND_QUOTES'),(17216,'STR_HIDE_CUSTOMER_OVERDUE_NOTICE'),(17217,'STR_ADD_THIS_OPTION_GROUP_TO_ALL_ITEMS'),(17218,'STR_DEFAULT_OPTION_GROUP_FOR_ALL_NEW_ITEMS'),(17219,'STR_REMOVE_THIS_OPTION_GROUP_FROM_ALL_ITEMS'),(17220,'STR_EXPIRED_CERTIFICATES'),(17221,'STR_CERTIFICATE'),(17222,'STR_HIDE_CUSTOMER_NUMBER'),(17223,'STR_SHOW_COST_CODE_AS_SEPARATE_COLUMN'),(17224,'STR_CREATED_INVOICES'),(17225,'STR_NO_INVOICE_CREATED'),(17226,'STR_SHIP_AND_INVOICE_ALL'),(17227,'STR_SHIP_AND_INVOICE_SELECTED'),(17228,'STR_SHIP_MULTIPLE_ORDERS'),(17229,'STR_CRM_TASKS'),(17230,'STR_CRM_TASK_ACTIVITY'),(17231,'STR_CUSTOMER_SHIP_TOS'),(17232,'STR_EMPLOYEE_EXPENSES'),(17233,'STR_ITEM_LOCATION_DETAILS'),(17234,'STR_ITEM_SEARCH_CATEGORIES'),(17235,'STR_TERRITORIES'),(17236,'STR_VENDOR_ORDER_FROMS'),(17237,'STR_WAREHOUSE_BIN_ITEMS'),(17238,'STR_BILLTRUST'),(17239,'STR_EXPORT_BALANCES'),(17240,'STR_EXPORT_INVOICES'),(17241,'STR_EXPORT_CUSTOMER_BALANCES'),(17242,'STR_ACCOUNT_CONFIGURATION_SAVED'),(17243,'STR_ACCOUNT_ERROR'),(17244,'STR_ACCOUT_CONFIGURATION_DELETED'),(17245,'STR_NOT_ENOUGH_SEARCH_DATA'),(17246,'STR_PREV'),(17247,'STR_REDIRECTING_TO_ADMIN'),(17248,'STR_SEARCH_ERROR'),(17249,'STR_FILE_CATEGORY'),(17250,'STR_ALREADY_IN_SYSTEM'),(17251,'STR_ATTACH_TO_SUB_CODE'),(17252,'STR_CUSTOMER_CODE_IF_FOR_FOR_JOB'),(17253,'STR_FILE_LOCATION'),(17254,'STR_FILE_LOCATION_MUST_BE_SET'),(17255,'STR_IMPORT_FILES'),(17256,'STR_INVALID'),(17257,'STR_RESOLVES_TO_MULTIPLE_RECORDS'),(17258,'STR_UNSUPPORTED'),(17259,'STR_ALREADY_EXISTS_AT_LOCATION'),(17260,'STR_BIN'),(17261,'STR_BIN_CODE'),(17262,'STR_IMPORT_WAREHOUSE_BIN'),(17263,'STR_NOT_FOUND_FOR_LOCATION'),(17264,'STR_IMPORT_WAREHOUSE_BIN_ITEMS'),(17265,'STR_IS_PRIMARY'),(17266,'STR_IMPORT_INVENTORY_TRANSFERS'),(17267,'STR_INVENTORY_LOCATION_FROM'),(17268,'STR_INVENTORY_LOCATION_TO'),(17269,'STR_IMPORT_INVENTORY_PURCHASE_ORDERS'),(17270,'STR_IS_PROPOSAL'),(17271,'STR_IMPORT_WAREHOUSE_ZONE'),(17272,'STR_ZONE_CODE'),(17273,'STR_ZONE_CODE_MUST_BE_SET'),(17274,'STR_IMPORT_MOTORSTATE_ITEM_CHANGES'),(17275,'STR_IMPORT_ITEM_LOCATION_DETAILS'),(17276,'STR_MAX_STOCK'),(17277,'STR_MIN_STOCK'),(17278,'STR_SET_COST'),(17279,'STR_SET_ON_HAND'),(17280,'STR_IMPORT_SPECIAL_SALES_PRICING'),(17281,'STR_NOT_FOUND_FOR_CUSTOMER'),(17282,'STR_IMPORT_ITEM_ACTIVITY'),(17283,'STR_UNUSED'),(17284,'STR_CREATION_DATE'),(17285,'STR_FILE_CATEGORIES'),(17286,'STR_IMPORT_CRM_TASKS'),(17287,'STR_IMPORT_CRM_TASK_ACTIVITY'),(17288,'STR_IMPORT_ITEM_SEARCH_CATEGORIES'),(17289,'STR_ITEM_TRANSFER'),(17290,'STR_MEMBERSHIP_STATUS_REPORT'),(17291,'STR_REFERRAL_SOURCE_REPORT'),(17292,'STR_SHOPIFY_IMPORT'),(17293,'STR_DOWNLOAD_FOR_MANUAL_SENDING'),(17294,'STR_LOG'),(17295,'STR_LIST_OF_USERNAMES_SEPARATED_BY_TILDE'),(17296,'STR_LIST_OF_USER_GROUPS_SEPARATED_BY_TILDE'),(17297,'STR_MODULE_MUST_BE_EITHER'),(17298,'STR_TASK_NAME'),(17299,'STR_TASK_NAME_IS_REQURED'),(17300,'STR_BOTH_CUSTOMER_AND_VENDOR_CANNOT_BE_SET'),(17301,'STR_CUSTOMER_OR_VENDOR_CODE_MUST_BE_SET'),(17302,'STR_NEXT_TASK_ACTION'),(17303,'STR_NEXT_TASK_ACTION_DATE'),(17304,'STR_SALES_MOUNT_CONFIDENCE_PERC'),(17305,'STR_WRONG_MODULE_TYPE'),(17306,'STR_REQUIRED_FOR'),(17307,'STR_SFTP'),(17308,'STR_DUE_AND_PAYABLE_ON_OR_BEFORE'),(17309,'STR_EBAY_CUSTOMER'),(17310,'STR_EBAY_CUSTOMER_EMAIL'),(17311,'STR_EBAY_CUSTOMER_PHONE'),(17312,'STR_EBAY_ID'),(17313,'STR_SHOPIFY_ADDRESS_PHONE'),(17314,'STR_SHOPIFY_CUSTOMER_CREATED'),(17315,'STR_SHOPIFY_CUSTOMER_EMAIL'),(17316,'STR_SHOPIFY_CUSTOMER_PHONE'),(17317,'STR_SHOPIFY_DEFAULT_ADDRESS_PHONE'),(17318,'STR_SHOPIFY_ID'),(17319,'STR_SHOPIFY_ITEM_CREATED'),(17320,'STR_SHOPIFY_SHIPPING_ADDRESS_PHONE'),(17321,'STR_SHOPIFY_TRACKING_NUMBER'),(17322,'STR_ERROR_LOG'),(17323,'STR_IMPORT_ERRORS'),(17324,'STR_MORE_ERRORS_CAN_BE_REVIEWED_IN_THE_IMPORT_LOG'),(17325,'STR_ALL_STATUSES'),(17326,'STR_DATE_SET'),(17327,'STR_MEMBERSHIP_STATUS'),(17328,'STR_REFERRER'),(17329,'STR_ACCOUNT_ID'),(17330,'STR_ACCOUNT_INFO'),(17331,'STR_ACCOUNT_NICKNAME'),(17332,'STR_ACCOUNT_STATUS'),(17333,'STR_ALLOW_AUTOMATIC_ORDER_IMPORTS'),(17334,'STR_CLOSE_THE_EBAY_WINDOW_AFTER_AUTHORIZING'),(17335,'STR_DEFAULT_INVENTORY_LOCATION'),(17336,'STR_DEFAULT_INVOICE_TERMS'),(17337,'STR_DEFAULT_ITEM_PRICE_UNIT'),(17338,'STR_DEFAULT_ITEM_USAGE_UNIT'),(17339,'STR_DEFAULT_SALES_ACCOUNT'),(17340,'STR_DEFAULT_SALES_TAX_ACCOUNT'),(17341,'STR_DEFAULT_TAX_EXEMPTION_IF_EXEMPT'),(17342,'STR_EBAY_INTEGRATION_MANAGER'),(17343,'STR_GETTING_TOKEN_FROM_EBAY'),(17344,'STR_LINK_TO_YOUR_EBAY_ACCOUNT'),(17345,'STR_NAME_CANNOT_BE_EMPTY'),(17346,'STR_PLEASE_WAIT'),(17347,'STR_RENEW_TOKEN_NOW'),(17348,'STR_TAKE_ME_TO_EBAY'),(17349,'STR_TOKEN_EXPIRES'),(17350,'STR_TO_AUTHORIZE_ACCESS_TO_YOUR_EBAY_ACCOUNT_YOU_MUST_LEAVE_THIS_PAGE_AND_SIGN_IN_AT_EBAY'),(17351,'STR_UPDATE_NICKNAME'),(17352,'STR_YOUR_STORE_LOGO'),(17353,'STR_ACCESS_TOKEN'),(17354,'STR_GET_ACCESS_TOKEN'),(17355,'STR_SELECT_EBAY_ACCOUNT'),(17356,'STR_DAYS_TO_LOOK_BACK'),(17357,'STR_EBAY_ACCOUNT'),(17358,'STR_IMPORT_ORDERS_FROM_EBAY'),(17359,'STR_ORDERS_PER_PAGE'),(17360,'STR_SHOW_ORDERS_FROM'),(17361,'STR_SHOW_ORDERS_TO'),(17362,'STR_SPECIFY_ORDER_NUMBERS'),(17363,'STR_IMPORT_SELECTED_ORDERS'),(17364,'STR_OR_SPECIFY_ORDER_NUMBERS'),(17365,'STR_SEARCH_SETTINGS'),(17366,'STR_SHIPMENTS'),(17367,'STR_DEFAULT_REFUND_ACCOUNT'),(17368,'STR_DO_NOT_CLOSE_THIS_PAGE'),(17369,'STR_ERROR_CREATING_WEBHOOKS'),(17370,'STR_STORE_DOMAIN'),(17371,'STR_VERIFYING_WEBHOOKS'),(17372,'STR_WEBHOOKS'),(17373,'STR_WEBHOOKS_ESTABLISHED'),(17374,'STR_ADD_NEW_STORE'),(17375,'STR_SELECT_SHOPIFY_STORE'),(17376,'STR_IMPORT_SELECTED_CUSTOMERS'),(17377,'STR_IMPORT_SHOPIFY_CUSTOMERS'),(17378,'STR_OR_SPECIFIC_IDS'),(17379,'STR_PER_PAGE'),(17380,'STR_PLEASE_WAIT_WHILE_YOUR_DATA_IS_IMPORTED'),(17381,'STR_TOTAL_SPENT'),(17382,'STR_IMPORT_SELECTED_ITEMS'),(17383,'STR_IMPORT_SHOPIFY_ITEMS'),(17384,'STR_ITEM_CODE_SKU'),(17385,'STR_IMPORT_SHOPIFY_ORDERS'),(17386,'STR_IMPORT_SELECTED_QUOTES'),(17387,'STR_IMPORT_SHOPIFY_QUOTES'),(17388,'STR_IMPORT_SOURCE'),(17389,'STR_SELECT_SHOPIFY_IMPORT_TASK'),(17390,'STR_SHOPIFY_STORE'),(17391,'STR_BLOCK_GL_AUTO_FILL_FOR_NEW_BILLS'),(17392,'STR_COMBINE_LINE_ITEM_TAX_BEFORE_ROUNDING'),(17393,'STR_ROUND_EACH_LINE_ITEM_TAX_INDIVIDUALLY'),(17394,'STR_TAX_ROUNDING'),(17395,'STR_DISPLAY_SALES_PERSON_INFO_IN_QUOTES_HEADER'),(17396,'STR_DISPLAY_SIGNATURE_LINE_IN_QUOTES_FOOTER'),(17397,'STR_FTP_HOST'),(17398,'STR_FTP_PASSWORD'),(17399,'STR_FTP_USER'),(17400,'STR_INVOICE_ATTACHMENTS'),(17401,'STR_ORDER_ATTACHMENTS'),(17402,'STR_PENDING_DOCUMENTS'),(17403,'STR_QUOTE_ATTACHMENTS'),(17404,'STR_UPLOAD_NEW_PENDING_DOCUMENTS'),(17405,'STR_NEW_FULFILLMENT_ORDER'),(17406,'STR_ASSIGN_INVOICE_ATTACHMENTS'),(17407,'STR_AUTHORIZED_AND_ACCEPTED_BY'),(17408,'STR_DATE_OF_ACCEPTANCE'),(17409,'STR_PURCHASE_ORDER_NUM_OR_PROJECT_REFERENCE'),(17410,'STR_UPS_USG'),(17411,'STR_UPS_USL'),(17412,'STR_LAST_SHIPMENT'),(17413,'STR_SET_ATTACHMENTS'),(17414,'STR_SOFT_CLOSE'),(17415,'STR_SOFT_CLOSINGS'),(17416,'STR_DUE_DATE_NOT_RECOGNIZED'),(17417,'STR_INVOICE_DATE_NOT_RECOGNIZED'),(17418,'STR_PAYMENT_DATE_NOT_RECOGNIZED'),(17419,'STR_ACCOUNT_CLOSED_DATE'),(17420,'STR_EACH_VOUCHER_CAN_ONLY_HAVE_ONE_CURRENCY'),(17421,'STR_MARK_AS_ACCEPTED'),(17422,'STR_COMMITTED_QTY'),(17423,'STR_ASSIGN_ORDER_ATTACHMENTS'),(17424,'STR_ASSIGN_QUOTE_ATTACHMENTS'),(17425,'STR_VENDOR_PRICING'),(17426,'STR_CAPITALIZE_PAYEE_NAME'),(17427,'STR_DELIVERY_MODE'),(17428,'STR_PAYEE_NAME_FONT_SIZE'),(17429,'STR_SYSTEM_WILL_DELIVER_FILE_DIRECTLY_TO_BANK'),(17430,'STR_YOU_MUST_GENERATE_DOWNLOAD__SEND_FILE_MANUALLY'),(17431,'STR_LOCATIONS_WHERE_INVENTORY_IS_KEPT'),(17432,'STR_ATTACH'),(17433,'STR_DEFAULT_ATTACHMENT'),(17434,'STR_UPLOADED_FOR_THIS_INVOICE'),(17435,'STR_UPLOADED_FOR_THIS_ORDER'),(17436,'STR_UPLOADED_FOR_THIS_QUOTE'),(17437,'STR_ACCOUNT_CONFIGURATION_DELETED'),(17438,'STR_CUSTOMER_CODE_IF_FOR_JOB'),(17439,'STR_TASK_NAME_IS_REQUIRED'),(17440,'STR_SALES_AMOUNT_CONFIDENCE_PERC'),(17441,'STR_INACTIVE_VENDORS'),(17442,'STR_PRODUCT_TYPE_TAXES'),(17443,'STR_PRODUCT_TYPE_TAX'),(17444,'STR_CERTIFICATE_NOT_COMPLIANT_EMAIL'),(17445,'STR_DELETE_ALL'),(17446,'STR_DELETE_SELECTED'),(17447,'STR_INACTIVE_SINCE'),(17448,'STR_IS_NOT_COMPLIANT'),(17449,'STR_VENDORS_INACTIVE_SINCE'),(17450,'STR_DELIVERY_CHARGE'),(17451,'STR_APPLY_CHANGE'),(17452,'STR_SUGGESTED_CHANGES'),(17453,'STR_UPDATE_3DCART_WAREHOUSE_BIN_AUTOMATICALLY'),(17454,'STR_AUTO_IMPORT_CUSTOMER_PAYMENTS_DO_NOT_CREATE_GL_TRANSACTIONS'),(17455,'STR_AUTO_IMPORT_INVOICES_DO_NOT_CREATE_GL_TRANSACTIONS'),(17456,'STR_DELIVERY_CHARGE_ITEM_CODE'),(17457,'STR_DELIVERY_CHARGE_MAXIMUM_ORDER_TOTAL'),(17458,'STR_FORCE_SINGLE_CUSTOMER_EMAIL_PER_INPUT'),(17459,'STR_FUEL_CHARGE_ITEM_CODE'),(17460,'STR_FUEL_CHARGE_MAXIMUM_ORDER_TOTAL'),(17461,'STR_OUR_TRUCK_SHIPPING_METHOD'),(17462,'STR_PAID_ON_ACCOUNT_ITEM_CODE'),(17463,'STR_SELECT_INVENTORY_TYPE_FOR_FOPOS_PAGE'),(17464,'STR_STOCKED_RENTAL_COST_PERCENTAGE'),(17465,'STR_CHECK_TOTAL_IS_NEGATIVE_OR_0_SO_REMOVING_BILLS_FROM_CHECK_RUN'),(17466,'STR_COMMODITY_CODE'),(17467,'STR_CUSTOMIZABLE_CUSTOMER_LIST'),(17468,'STR_ADMIN_EMAIL_SUBJECT'),(17469,'STR_ADMIN_NOTIFICATION_EMAIL_ADDRESS'),(17470,'STR_APPOINTMENT_DATE_AND_TIME'),(17471,'STR_APPOINTMENT_HOST_NAME'),(17472,'STR_APPOINTMENT_LOCATION_NAME'),(17473,'STR_APPOINTMENT_SERVICE_NAME'),(17474,'STR_CUSTOMERS_FULL_NAME'),(17475,'STR_DISABLE_EMAIL_REMINDERS'),(17476,'STR_DO_NOT_REDIRECT_B2B_LOGIN_TO_APPOINTMENTS'),(17477,'STR_DO_NOT_REQUIRE_PAYMENT_METHOD_TO_BOOK'),(17478,'STR_EDIT_EMAIL_TEMPLATE'),(17479,'STR_EMAIL_SUBJECT'),(17480,'STR_EMAIL_TEMPLATE_HELP'),(17481,'STR_NO_CHANGES'),(17482,'STR_NO_PAYMENT_METHOD_MESSAGE'),(17483,'STR_PREVIOUS_APPOINTMENT_INFORMATION'),(17484,'STR_SELECT_TEMPLATE'),(17485,'STR_TEMPLATE_ERROR'),(17486,'STR_PAYPAL_PAYMENT_ACCOUNT'),(17487,'STR_MAX_DAILY_EFT_TRANSACTION_AMOUNT'),(17488,'STR_MAX_SINGLE_EFT_TRANSACTION_AMOUNT'),(17489,'STR_PLACE_LINK_WITH_TEMPLATE_FIELD'),(17490,'STR_TRANSACTIONS_WILL_NOT_BE_SENT_IF_OVER_LIMIT'),(17491,'STR_EFT_TRANSACTIONS_OVER_MAX_AMOUNT'),(17492,'STR_AUTHORIZED_BUYERS'),(17493,'STR_UNAUTHORIZED_BUYERS'),(17494,'STR_UNAUTHORIZED_BUYER'),(17495,'STR_INVOICE_IMPORTED_WITH_NOT_FOUND_JOB_CODE'),(17496,'STR_PURCHASED_BY_CONTACT'),(17497,'STR_PURCHASED_BY'),(17498,'STR_METHOD_MARKUP_FLAT'),(17499,'STR_INVOICE_IMPORTED_BUT_JOB_CODE_NOT_FOUND'),(17500,'STR_PO_NUM'),(17501,'STR_CAPABILITIES'),(17502,'STR_CC_PROCESSOR_NOT_SET_FOR_CC_TERMINAL'),(17503,'STR_CHECKING_ACCOUNT_NOT_SET_FOR_CC_PROCESSOR'),(17504,'STR_CONTACTLESS'),(17505,'STR_DEBIT_MSR'),(17506,'STR_DEVICE_KEY'),(17507,'STR_EMV'),(17508,'STR_FIRMWARE'),(17509,'STR_MAKE'),(17510,'STR_MODEL'),(17511,'STR_NEW_CASTLES_TERMINAL'),(17512,'STR_NEW_PAX_TERMINAL'),(17513,'STR_NEW_TERMINAL'),(17514,'STR_PAIRING_CODE'),(17515,'STR_SELECT_CC_PROCESSOR'),(17516,'STR_SERIAL'),(17517,'STR_SIGNATURE_CAPTURE'),(17518,'STR_SWIPE'),(17519,'STR_TERMINAL_IS_IN_USE_BY_USER'),(17520,'STR_TIMEOUT'),(17521,'STR_TIP_ADJUSTMENTS'),(17522,'STR_ADDRESS_FIELDS'),(17523,'STR_ADDRESS_VERIFIED'),(17524,'STR_AREA_ID'),(17525,'STR_B2B_ALLOW_CC_PAY'),(17526,'STR_B2B_NO_PAYMENT_FEE'),(17527,'STR_BILLING_FIELDS'),(17528,'STR_CANCEL_USER_ID'),(17529,'STR_CLOSED_DATE'),(17530,'STR_CLOSED_USER_ID'),(17531,'STR_COMPANY_NAME_2'),(17532,'STR_CONTACT_FIELDS'),(17533,'STR_CURRENT_SALES_PROCESS'),(17534,'STR_CUSTOMER_TYPE_ID'),(17535,'STR_EMAIL_1'),(17536,'STR_EMAIL_1_COMMENT'),(17537,'STR_EMAIL_2'),(17538,'STR_EMAIL_2_COMMENT'),(17539,'STR_ENTRY_USER_ID'),(17540,'STR_GROUP_ID'),(17541,'STR_INVOICE_TERMS_ID'),(17542,'STR_LAST_CHANGE_USER_ID'),(17543,'STR_NAME_FIELDS'),(17544,'STR_NO_CREDIT'),(17545,'STR_NO_CREDIT_NOTE'),(17546,'STR_ON_HOLD_USER_ID'),(17547,'STR_PHONE_1'),(17548,'STR_PHONE_1_COMMENT'),(17549,'STR_PHONE_1_TYPE'),(17550,'STR_PHONE_2_COMMENT'),(17551,'STR_PHONE_2_TYPE'),(17552,'STR_PHONE_3'),(17553,'STR_PHONE_3_COMMENT'),(17554,'STR_PHONE_3_TYPE'),(17555,'STR_PHONE_4'),(17556,'STR_PHONE_4_COMMENT'),(17557,'STR_PHONE_4_TYPE'),(17558,'STR_POINTS_EARNED'),(17559,'STR_PROMOTIONS_ACCEPTED'),(17560,'STR_SALES_CATEGORY_ID'),(17561,'STR_SALES_GL_ACCOUNT_ID'),(17562,'STR_SERVICE_REP_ID'),(17563,'STR_SERVICE_WORK_TYPE_ID'),(17564,'STR_SYSTEM_FIELDS'),(17565,'STR_TAX_EXEMPTION_DATE'),(17566,'STR_TAX_EXEMPT_ID'),(17567,'STR_TAX_GROUP_ID'),(17568,'STR_TEMPERATURE_UNIT'),(17569,'STR_TIME_ZONE_ID'),(17570,'STR_WEATHER_ZIP'),(17571,'STR_IMPORTED_GL_ENTRIES_FROM_ANZIO'),(17572,'STR_DIRECT_CASH_PAYMENTS'),(17573,'STR_MASS_UPDATE'),(17574,'STR_EDIT_VENDOR_SETTINGS'),(17575,'STR_CLAIM'),(17576,'STR_CUSTOM_CUSTOMER_LIST'),(17577,'STR_DISPLAY_OPTIONS'),(17578,'STR_FIELD_SELECTION'),(17579,'STR_NO_SPACE_BETWEEN_ROWS'),(17580,'STR_PLAIN_TABLE_DISPLAY'),(17581,'STR_SEARCH_CRITERIA'),(17582,'STR_SORT_DESCENDING'),(17583,'STR_TEST'),(17584,'STR_DO_NOT_IMPORT_ITEM_CATEGORIES'),(17585,'STR_SHOW_PURCHASE_FROM_CASH_DRAWER_LINK_ON_POS'),(17586,'STR_HIDE_INVOICE_TERMS'),(17587,'STR_INVOICE_HEADER_BOTTOM_MESSAGE'),(17588,'STR_INVOICE_HEADER_TOP_MESSAGE'),(17589,'STR_ONLY_ALLOW_INVENTORY_ITEMS_WHEN_CONVERTING_QUOTE_TO_ORDER'),(17590,'STR_PAGE_FOOTER_TEXT'),(17591,'STR_SHIP_TO_SUB_TEXT'),(17592,'STR_SOLD_TO_SUB_TEXT'),(17593,'STR_GL_POST_DATE'),(17594,'STR_USE_GL_POST_DATE'),(17595,'STR_SKIPPING_SENDING_EFT_TRANSACTION_OVER_ALLOWED_AMOUNT'),(17596,'STR_SKIPPING_SENDING_EFT_TRANSACTION_OVER_ALLOWED_DAILY_MAXIMUM'),(17597,'STR_TRANSACTIONS_WILL_NOT_BE_SENT_IF_OVER_DAILY_LIMIT'),(17598,'STR_EFT_TRANSACTIONS_TOTAL_IS_OVER_THE_DAILY_LIMIT'),(17599,'STR_MAX_AMOUNT_ALLOWED'),(17600,'STR_PRIOR_TOTAL'),(17601,'STR_SKIPPING_EFT_PAYMENTS'),(17602,'STR_THIS_BATCH_TOTAL'),(17603,'STR_NOT_POSTED_YET'),(17604,'STR_SHOW_ONLY_NEVER_CASHED'),(17605,'STR_SHOW_ONLY_NOT_YET_CASHED_OR_CASHED_AFTER_PERIOD'),(17606,'STR_INCOMING_TRANSFERS_NOT_ON_STATEMENT'),(17607,'STR_INCOMING_TRANSFERS_ON_STATEMENT'),(17608,'STR_FREIGHT_COST'),(17609,'STR_GL_CASH_ACCOUNT_MUST_BE_SET'),(17610,'STR_RECENT_DIRECT_CASH_PAYMENTS'),(17611,'STR_BOTH'),(17612,'STR_EXPENSE'),(17613,'STR_COST_CODE_REQUIRED_BUT_NOT_FOUND'),(17614,'STR_GL_CATEGORY_REQUIRED_BUT_NOT_FOUND'),(17615,'STR_ADDITIONAL_OPTIONS'),(17616,'STR_ALERT'),(17617,'STR_ALL_WRITE_IN_ITEMS_MUST_BE_CONVERTED_TO_INVENTORY_ITEMS_BEFORE_YOU_CAN_CONVERT_THIS_QUOTE_TO_AN_ORDER'),(17618,'STR_MAKE_NEW_ITEM'),(17619,'STR_PAY_FOR_SOMETHING_FROM_CASH_DRAWER'),(17620,'STR_MAX_YEARLY_DEDUCTION_AMOUNT'),(17621,'STR_ENTRIES_MISSING_DEPARTMENT_OR_WC'),(17622,'STR_VIEW_ENTRIES_MISSING_DEPARTMENT_OR_WC'),(17623,'STR_A_DELETED_VENDOR_EXISTS_WITH_THIS_VENDOR_CODE'),(17624,'STR_A_VENDOR_ALREADY_EXISTS_FOR_VENDOR_CODE'),(17625,'STR_INGORE'),(17626,'STR_REACTIVE_VENDOR'),(17627,'STR_INCOMING_TRANSFERS'),(17628,'STR_PRELIMS'),(17629,'STR_SOLD_AT'),(17630,'STR_HIDE_GL_INFO_ON_ORDER_PAGE'),(17631,'STR_ONLY_ASSIGNED_LOCATION'),(17632,'STR_PAYMENTS_DAILY_CLOSE_MANAGEMENT'),(17633,'STR_APPOINTMENT_DATE'),(17634,'STR_APPOINTMENT_TIME'),(17635,'STR_PATIENT_NAME'),(17636,'STR_PHONE_ALTERNATE'),(17637,'STR_SETTINGS_UPDATED'),(17638,'STR_UPDATE_FAILURE'),(17639,'STR_ACTUAL_CASH'),(17640,'STR_ACTUAL_CC'),(17641,'STR_ACTUAL_CHECKS'),(17642,'STR_BALANCED'),(17643,'STR_CHECKING_ACCOUNT_NOT_SET_ON_DEFAULT_CC_PROCESSOR'),(17644,'STR_COST_CODE_NOT_SET_FOR_THIS_INVENTORY_LOCATION'),(17645,'STR_DAILY_DRAWER_CLOSE'),(17646,'STR_DAILY_DRAWER_CLOSE_LOG'),(17647,'STR_FLOAT_AMOUNT'),(17648,'STR_GL_ACCOUNT_NOT_SET_IN_CC_PROCESSOR_SETUP'),(17649,'STR_GL_ACCOUNT_NOT_SET_ON_DEFAULT_CHECKING_ACCOUNT'),(17650,'STR_GL_CASH_TOTAL'),(17651,'STR_GL_CC_TOTAL'),(17652,'STR_GL_CHECKS_TOTAL'),(17653,'STR_NEW_DAILY_CLOSE'),(17654,'STR_NO_DEFAULT_CC_PROCESSOR_SET'),(17655,'STR_NO_DEFAULT_CHECKING_ACCOUNT_SET'),(17656,'STR_OVERSHORT'),(17657,'STR_SHORT'),(17658,'STR_SYSTEM_CASH'),(17659,'STR_SYSTEM_CASH_TOTAL'),(17660,'STR_SYSTEM_CC'),(17661,'STR_SYSTEM_CC_TOTAL'),(17662,'STR_SYSTEM_CHECKS'),(17663,'STR_SYSTEM_CHECKS_TOTAL'),(17664,'STR_CUSTOM_ORDER_NUMBERING'),(17665,'STR_DAILY_CLOSE'),(17666,'STR_DEFINE_ORDER_NUMBERING'),(17667,'STR_PREFIX'),(17668,'STR_PREVIOUS_ORDER_NUMBERS_SHOWN__PERIOD__THE_NEXT_ORDER_WILL_INCREASE_THE_APPROPRIATE_NUMBER_BY_1'),(17669,'STR_ACTUAL_CASH_APPEARS_TO_BE_INCORRECT'),(17670,'STR_DEPOSIT_APPEARS_TO_BE_INCORRECT'),(17671,'STR_EXPECTD_VALUE'),(17672,'STR_DIRECT_CASH_EXPENSES'),(17673,'STR_LAST_DRAWER_FLOAT'),(17674,'STR_SYSTEM_CASH_TOTAL_SUMMARY'),(17675,'STR_SYSTEM_CHECKS_TOTAL_SUMMARY'),(17676,'STR_CREDIT_CARD_TERMINAL_LOG'),(17677,'STR_REACTIVATE_VENDOR'),(17678,'STR_EXPECTED_VALUE'),(17679,'STR_STORE_SETUP_ADDED_SUCCESSFULLY'),(17680,'STR_ALL_ENTRIES_ARE_ALREADY_ON_AN_EXISTING_DEPOSIT'),(17681,'STR_BANK_DEPOSITS_CREATED'),(17682,'STR_BANK_DEPOSIT_CREATED'),(17683,'STR_CARD_HOLDER'),(17684,'STR_ENTRIES_NOT_FOUND_IN_SYSTEM'),(17685,'STR_SOME_ENTRIES_ARE_ALREADY_ON_AN_EXISTING_DEPOSIT'),(17686,'STR_MOTORSTATE_ITEM_CHANGES'),(17687,'STR_SEND_STATEMENTS'),(17688,'STR_WAIVERS'),(17689,'STR_AMAZON_SETUP'),(17690,'STR_IMPORT_USAEPAY_BATCH_CC_DEPOSIT'),(17691,'STR_IMPORT_VENDOR_CERTIFICATES'),(17692,'STR_JOB_WAIVER_TYPES'),(17693,'STR_MASS_INSURANCE_UPDATE'),(17694,'STR_MASS_VENDOR_UPDATE'),(17695,'STR_BROKER_EMAIL'),(17696,'STR_BROKER_NAME'),(17697,'STR_BROKER_PHONE'),(17698,'STR_CERTIFICATE_CANNOT_BE_ASSIGNED_TO_MULTIPLE_TYPES'),(17699,'STR_CERTIFICATE_EXPIRES_DATE_MUST_BE_ASSIGNED'),(17700,'STR_CERTIFICATE_TYPE_MUST_BE_ASSIGNED'),(17701,'STR_IS_TYPE_OF'),(17702,'STR_VENDOR_EMAIL'),(17703,'STR_VENDOR_HAS_NO_CERTIFICATES'),(17704,'STR_ACTIVE_AND_EXPIRED'),(17705,'STR_ADD_WAIVER'),(17706,'STR_DATE_ISSUED'),(17707,'STR_DATE_THROUGH'),(17708,'STR_EXCEPTIONS'),(17709,'STR_JOB_WAIVER'),(17710,'STR_ONLY_ACTIVE'),(17711,'STR_WAIVER_TYPE'),(17712,'STR_JOB_WAIVER_TYPE'),(17713,'STR_ERROR_RESTORING'),(17714,'STR_RECORD_RESTORED'),(17715,'STR_RESTORE'),(17716,'STR_ACCOUNT_SETUP_ALREADY_EXISTS'),(17717,'STR_AUSTRALIA'),(17718,'STR_BRAZIL'),(17719,'STR_CANADA'),(17720,'STR_CHINA'),(17721,'STR_FRANCE'),(17722,'STR_GERMANY'),(17723,'STR_INDIA'),(17724,'STR_ITALY'),(17725,'STR_JAPAN'),(17726,'STR_MEXICO'),(17727,'STR_SPAIN'),(17728,'STR_UNITED_KINGDOM'),(17729,'STR_UNITED_STATES'),(17730,'STR_AWS_ACCESS_KEY'),(17731,'STR_DEVELOPER_ID'),(17732,'STR_SECRET_KEY'),(17733,'STR_SELECT_YOUR_MARKETPLACE'),(17734,'STR_SELLER_ID'),(17735,'STR_YOU_MUST_SET_A_DEFAULT_SALES_TAX_ACCOUNT'),(17736,'STR_LINK_TO_YOUR_AMAZON_STORE'),(17737,'STR_SELECT_AMAZON_STORE'),(17738,'STR_DEFERRED_EXPENSES'),(17739,'STR_NOTHING_DEFERRED'),(17740,'STR_CONVERT_DEFERRED_REVENUE_AND_EXPENSES_WHEN_CLOSING_JOBS'),(17741,'STR_PORTAL_URL'),(17742,'STR_VERIFY_ADDRESSES_VIA_USPS'),(17743,'STR_SYSTEM_USER'),(17744,'STR_CUSTOMER_GROUP_FILTER'),(17745,'STR_GL_SALES_OR_LIABILITY_ACCOUNT'),(17746,'STR_DISPLAYED_IN_THE_ORDER_ENTRIES_WENT_INTO_THE_DATABASE'),(17747,'STR_SORT_BY_TRANSACTION_ID'),(17748,'STR_SEND_INVOICES'),(17749,'STR_SEND_PRELIMS'),(17750,'STR_COST_CODE_NOT_ALLOWED_FOR_THIS_ACCOUNT'),(17751,'STR_GL_CATEGORY_NOT_ALLOWED_FOR_THIS_ACCOUNT'),(17752,'STR_GL_COGS_OR_ASSET_ACCOUNT'),(17753,'STR_A_JOB_WITH_THIS_ADDRESS_ALREADY_EXISTS_FOR_ANOTHER_CUSTOMER'),(17754,'STR_A_JOB_WITH_THIS_ADDRESS_ALREADY_EXISTS_FOR_THIS_CUSTOMER'),(17755,'STR_CLICK_HERE_TO_ASSIGN_DEFAULTS'),(17756,'STR_CONVERT_DEFERRED_EXPENSES_TO'),(17757,'STR_CONVERT_DEFERRED_REVENUE_TO'),(17758,'STR_DEFERRED_CONVERSION_FOR_JOB'),(17759,'STR_DEFERRED_CONVERSION_TRANSACTION_DATE'),(17760,'STR_DEFERRED_CONVERSION_VOUCHER'),(17761,'STR_ERROR_IN_DEFERRED_ACCOUNT_SETUP'),(17762,'STR_REV_DEFERRED_CONVERSION_FOR_JOB'),(17763,'STR_ALL_DEDUCTIONS'),(17764,'STR_BEGIN_SLASH_END_DATES'),(17765,'STR_MANDATORY_DEDUCTIONS'),(17766,'STR_PERCENT_OF_GROSS'),(17767,'STR_PERCENT_OF_NET'),(17768,'STR_TAXES_AND_RETIREMENT'),(17769,'STR_PRELIM_REQUEST'),(17770,'STR_ALLOWED_COST_CODES'),(17771,'STR_ALLOWED_GL_CATEGORIES'),(17772,'STR_LEAVE_BLANK_FOR_ALL'),(17773,'STR_CLICK_THE_RENEW_SESSION_BUTTON_TO_CONTINUE_YOUR_WORK'),(17774,'STR_LOGOUT_WARNING'),(17775,'STR_LOG_OUT_NOW'),(17776,'STR_RENEW_SESSION'),(17777,'STR_TIME_REMAINING'),(17778,'STR_YOUR_SESSION_IS_INACTIVE_AND_WILL_BE_LOGGED_OUT'),(17779,'STR_BANK_DEPOSIT_DOCUMENTS'),(17780,'STR_ORDER_NUMBERS'),(17781,'STR_POSSIBLE_DUPLICATE_CUSTOMER'),(17782,'STR_SICK_AND_VACATION_TIME_LIABILITY'),(17783,'STR_SICK_AVAILABLE'),(17784,'STR_SICK_LIABILITY'),(17785,'STR_SICK_LIMIT'),(17786,'STR_VACACTION_LIABILITY'),(17787,'STR_VACATION_AVAILABLE'),(17788,'STR_VACATION_LIMIT'),(17789,'STR_CLIENT_PROJECT_NUM'),(17790,'STR_ITEM_COSTS_TOTAL'),(17791,'STR_TOTAL_OPEN'),(17792,'STR_ADD_JOB_COST_ITEMS'),(17793,'STR_ERROR_DELETING_JOB_ITEM'),(17794,'STR_ERROR_DELETING_RECORDS'),(17795,'STR_ERROR_SAVING_JOB_ITEM'),(17796,'STR_ERROR_UPDATING_VOUCHER'),(17797,'STR_INVALID_FORM_OR_FORM_HAS_ALREADY_BEEN_SUBMITTED'),(17798,'STR_INVALID_ID'),(17799,'STR_JOB_ITEM'),(17800,'STR_JOB_ITEM_DELETED_SUCCESSFULLY'),(17801,'STR_JOB_ITEM_SAVED_SUCCESSFULLY'),(17802,'STR_RECORD_ALREADY_DELETED'),(17803,'STR_UPDATING_NOT_AVAILABLE'),(17804,'STR_COUNTIES'),(17805,'STR_INSURANCE_EMAIL'),(17806,'STR_INSURANCE_PHONE'),(17807,'STR_ISSUED_BY'),(17808,'STR_PRINT_ALL'),(17809,'STR_YOU_MUST_ENTER_A_VALID_QUANTITY'),(17810,'STR_YOU_MUST_SELECT_AN_ITEM'),(17811,'STR_YOU_MUST_SELECT_AN_ORDER'),(17812,'STR_YOU_MUST_SELECT_A_JOB'),(17813,'STR_YOU_MUST_SET_A_TRANSACTION_DATE'),(17814,'STR_API_MODE'),(17815,'STR_CHOOSE_IMPORT_PREFERENCE'),(17816,'STR_CONFIRM_ACTION'),(17817,'STR_IMPORT_ALL'),(17818,'STR_IMPORT_ALL_EXCEPT_NONSEARCHABLE'),(17819,'STR_GENERATE_VENDOR_CODE_FOR_NEW_VENDORS'),(17820,'STR_GENERATE_CUSTOMER_CODE_FOR_NEW_CUSTOMERS'),(17821,'STR_LINK_PRELIM_DATE_AND_CONTRACT_DATE'),(17822,'STR_CASH_PAYMENT_NOT_FOUND'),(17823,'STR_HAS_NO_VOUCHER'),(17824,'STR_INCOMING_VALUE'),(17825,'STR_JOINT_CHECK'),(17826,'STR_OUTGOING_VALUE'),(17827,'STR_VOUCHER_DOES_NOT_EXIST'),(17828,'STR_VOUCHER_HAS_NO_TRANSACTIONS'),(17829,'STR_VOUCHER_TRANSACTIONS_ARE_UNBALANCED'),(17830,'STR_VOUCHER_TRANSACTIONS_DOES_NOT_HAVE_PROPER_ACCOUNT_TYPE'),(17831,'STR_VOUCHER_TRANSACTIONS_HAS_NO_AMOUNT'),(17832,'STR_VOUCHER_TRANSACTIONS_HAVE_MISMATCHED_CURRENCY'),(17833,'STR_WRONG_COMPANY'),(17834,'STR_CUSTOMER_NOT_ADDED'),(17835,'STR_COULD_NOT_LOCATE_ANY_INVOICES_THAT_MATCH_THE_GIVEN_INVOICE_NUMBER'),(17836,'STR_COULD_NOT_LOCATE_ANY_INVOICES_THAT_MATCH_THE_GIVEN_INVOICE_NUMBER_AND_PO_NUMBER'),(17837,'STR_COULD_NOT_LOCATE_ANY_INVOICES_THAT_MATCH_THE_GIVEN_PO_NUMBER'),(17838,'STR_DATE_RECEIVED_MUST_BE_SET'),(17839,'STR_PAYMENT_METHOD_MUST_BE_SET'),(17840,'STR_PLEASE_ENTER_ONE_OF_THE_FOLLOWING'),(17841,'STR_SELECT_ALL_INVOICE_FOR_CUSTOMER'),(17842,'STR_VOUCHER_MUST_BE_SET'),(17843,'STR_VOUCHER_NUMBER_MUST_BE_SET'),(17844,'STR_UNBILLED_RENTAL_ORDERS'),(17845,'STR_ANOTHER_USER_HAS_RECENTLY_MADE_A_CHANGE_TO_THIS_ORDER'),(17846,'STR_ORVERWRITE_CHANGES'),(17847,'STR_PO_PONUMBER'),(17848,'STR_ADD_NEW_LINE'),(17849,'STR_EDITING_SESSION_HAS_EXPIRED'),(17850,'STR_GL_ACCOUNT_NOT_SET_FOR_TRANSACTION'),(17851,'STR_FAILED_TO_RESOLVE_GL_ACCOUNT_BY_NAME'),(17852,'STR_TOTAL_ITEM_COSTS'),(17853,'STR_JOB_COST_ITEMS_FOR_ORDER'),(17854,'STR_SEE_SHIPMENT'),(17855,'STR_DEFAULT_TO_HOURS_OF_PREVIOUS_PAY_PERIOD'),(17856,'STR_A_VENDOR_ALREADY_EXISTS_WITH_THIS_VENDOR_CODE'),(17857,'STR_INSURANCE'),(17858,'STR_LEAVE_BLANK_TO_AUTO_GENERATE'),(17859,'STR_A_CUSTOMER_ALREADY_EXISTS_WITH_THIS_CUSTOMER_CODE'),(17860,'STR_QUICK_BARCODE_SEARCH'),(17861,'STR_BARCODE_LABEL_FOR_ITEM_NUMBER'),(17862,'STR_BARCODE_LABEL_FOR_ORDER_NUMBER'),(17863,'STR_BARCODE_LABEL_FOR_PO_NUMBER'),(17864,'STR_CHECK_PERMISSIONS_OF_YOUR_INCLUDES_DIRECTORY'),(17865,'STR_ERROR_DOWNLOADING_LIBRARIES'),(17866,'STR_GENERATING_PDF'),(17867,'STR_NO_RESULTS'),(17868,'STR_CREDIT_CARD_TERMINAL'),(17869,'STR_CANNOT_VIEW_JOB_COST_LABOR_RATES'),(17870,'STR_CAN_CHANGE_USER_WHEN_ADDING_JOB_COST_ITEMS'),(17871,'STR_SHOW_BARCODE_SEARCH_ICON_IN_HEADER'),(17872,'STR_VACATION_LIABILITY'),(17873,'STR_VOUCHER_TRANSACTION_DOES_NOT_HAVE_PROPER_ACCOUNT_TYPE'),(17874,'STR_VOUCHER_TRANSACTION_HAS_NO_AMOUNT'),(17875,'STR_SELECT_ALL_INVOICES_FOR_CUSTOMER'),(17876,'STR_OVERWRITE_CHANGES'),(17877,'STR_TOO_MANY_INVOICES_SELECTED_TO_PRINT'),(17878,'STR_ARE_YOU_SURE_YOU_WOULD_LIKE_TO_INVOICE_ALL'),(17879,'STR_AT_LEAST_ONE_RENTAL_PERIOD_MUST_BE_INCLUDED'),(17880,'STR_COULD_NOT_CREATE_INVOICES'),(17881,'STR_ENTRY_HAS_BEEN_MARKED_AS_RETURNED_BUT_HAS_AN_INVALID_RETURN_DATE'),(17882,'STR_GENERATE_INVOICES_FOR_BILLABLE_RENTALS'),(17883,'STR_INCLUDE_RENTAL_PERIODS'),(17884,'STR_INVOICE_ALL'),(17885,'STR_INVOICE_RENTALS'),(17886,'STR_INVOICE_SELECTED'),(17887,'STR_JOB_INVOICES'),(17888,'STR_LAST_BILLED'),(17889,'STR_NUM_PERIODS'),(17890,'STR_ORDER_HAS_UNBILLED_SHIPMENTS'),(17891,'STR_QUANITITY'),(17892,'STR_RENTAL_STATUS'),(17893,'STR_SHIPMENT_NUM'),(17894,'STR_THIS_ORDER_WAS_TO_BE_BILLED_IN_ADVANCE_BUT_NO_INVOICES_EXISTS'),(17895,'STR_THROUGH_DATE'),(17896,'STR_WILL_BE_BILLED_THRU'),(17897,'STR_YOU_MAY_NEED_TO_BILL_THIS_RENTAL_AGAIN'),(17898,'STR_DELETED_BY'),(17899,'STR_LAST_MODIFED'),(17900,'STR_PICKED_UP_DATE'),(17901,'STR_PICKUP_FROM'),(17902,'STR_PICKUP_REQUEST_SHEET'),(17903,'STR_RENTAL_ENDS'),(17904,'STR_RENTAL_PICKUP'),(17905,'STR_RENTAL_PICKUP_DETAILS'),(17906,'STR_RENTAL_PICKUP_REQUEST'),(17907,'STR_RENTAL_SHIPMENTS'),(17908,'STR_RENTAL_STARTED'),(17909,'STR_RENTED_TO'),(17910,'STR_RETURN_ITEMS_TO'),(17911,'STR_SEARCH_RENTAL_ORDERS'),(17912,'STR_SHIPMENT_CREATED'),(17913,'STR_ASSIGNED_DATE_RANGE'),(17914,'STR_ASSIGNED_ON'),(17915,'STR_CREATE_A_PRICKUP_REQUEST_FIRST'),(17916,'STR_NEW_PICKUP'),(17917,'STR_RENTALS'),(17918,'STR_SHIPMENT_DATE_RANGE'),(17919,'STR_ITEM_LOCATION_STATS'),(17920,'STR_AND_ALL_ITEMS_LOCKED_BY_THIS_PROCESS_WILL_BE_UNLOCKED'),(17921,'STR_CLICK_POST_IF_YOU_ARE_SURE_YOU_ARE_READY_TO_FINALIZE_THE_PHYSICAL_INVENTORY_PROCESS'),(17922,'STR_COUNTS_ENTERED'),(17923,'STR_COUNTS_ENTERED_WILL_BE_POSTED'),(17924,'STR_DELETE_UNPOSTED_COUNTS'),(17925,'STR_ERROR_POSTING_INVENTORY_ADJUSTMENTS'),(17926,'STR_FINALIZING_THIS_PROCESSES_CANNOT_BE_UNDONE'),(17927,'STR_FINISH_AND_POST_COUNTS'),(17928,'STR_IN_HYPHEN_PROGRESS_RECORDS_WILL_BE_DISCARDED'),(17929,'STR_NO_CHANGES_HAVE_BEEN_MADE'),(17930,'STR_PHYSICAL_INVENTORY_ADJUSTMENT'),(17931,'STR_POST_COUNTS'),(17932,'STR_POST_PHYSICAL_INVENTORY_COUNTS'),(17933,'STR_REVIEW_SLASH_CONTINUE_OPEN_COUNTS'),(17934,'STR_SEARCH_SLASH_ENTER_COUNTS'),(17935,'STR_THE_PHYSICAL_INVENTORY_PROCESS_WILL_FINALIZE'),(17936,'STR_THIS_MEANS'),(17937,'STR_TOTAL_ITEMS_IN_PROCESS'),(17938,'STR_BUDGET_TOTAL'),(17939,'STR_CANNOT_SEND_JOB_NOT_MARKED_AS_PRELIMABLE'),(17940,'STR_CHECK_NUM'),(17941,'STR_EXPORT_JOBS_TO_ZLIEN'),(17942,'STR_INCLUDE_JOBS_PREVIOUSLY_SENT_TO_ZLIEN'),(17943,'STR_JOB_ACCOUNT_OPEN_ITEM_DETAILS'),(17944,'STR_JOB_FAILED_TO_SEND'),(17945,'STR_SEND_ALL'),(17946,'STR_SEND_SELECTED'),(17947,'STR_ADD_JOB_BUDGET_ENTRY'),(17948,'STR_BUDGET_TYPE'),(17949,'STR_ERROR_DELETING_JOB_BUDGET'),(17950,'STR_ERROR_SAVING_JOB_BUDGET'),(17951,'STR_IMPORT_JOB_BUDGET_DATA'),(17952,'STR_JOB_BUDGET_DELETED_SUCCESSFULLY'),(17953,'STR_JOB_BUDGET_HAS_BEEN_DELETED'),(17954,'STR_JOB_BUDGET_SAVED_SUCCESSFULLY'),(17955,'STR_JOB_BUDGET_VARIANCE'),(17956,'STR_ITEM_COSTS'),(17957,'STR_AMAZON_ORDERS'),(17958,'STR_IMPORT_JOB_BUDGETS'),(17959,'STR_RENTAL_PICKUPS'),(17960,'STR_WAIVER_SEARCH'),(17961,'STR_COMPLIANT'),(17962,'STR_AMAZON_ID'),(17963,'STR_IMPORTED_FROM_AMAZON'),(17964,'STR_INVENTORY_LOCKDOWN'),(17965,'STR_THIS_ACTION_CANNOT_BE_COMPLETED_BECAUSE_THE_PHYSICAL_INVENTORY_PROCESS_IS_IN_PROGRESS'),(17966,'STR_TRY_AGAIN_AFTER_THE_PHYSICAL_INVENTORY_COUNTS_HAVE_BEEN_POSTED'),(17967,'STR_IN_ADVANCE'),(17968,'STR_IN_ARREARS'),(17969,'STR_PICKED_UP'),(17970,'STR_AMAZON_INTEGRATION_MANAGER'),(17971,'STR_IMPORT_AMAZON_ORDERS'),(17972,'STR_LOAD_MORE_RESULTS'),(17973,'STR_B2B_BOOKING_LEAD_DAYS'),(17974,'STR_HIGHER_NUMBERS_FURTHER_INCREASE_THIS_LEAD_TIME'),(17975,'STR_ONE_MEANS_TO_ALLOW_BOOKING_ON_THE_PRECEDING_DAY'),(17976,'STR_ZERO_MEANS_TO_ALLOW_SAME_DAY_BOOKING'),(17977,'STR_QTY_TO_COLLECT'),(17978,'STR_RENTAL_SHIPMENT_DETAILS'),(17979,'STR_SEARCH_BY_APPOINTMENT_DATE'),(17980,'STR_LOAD'),(17981,'STR_OLD'),(17982,'STR_NEW_INVENTORY_COUNT'),(17983,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_YOUR_PHYSICAL_INVENTORY_PROGRESS'),(17984,'STR_DELETE_ALL_RECORDS'),(17985,'STR_DISPLAY_EXISTING_QUANTITIES'),(17986,'STR_DO_NOT_DELETE_ANYTHING'),(17987,'STR_ITEM_COUNTS_IN_PROGRESS'),(17988,'STR_LOCK_ALL_MATCHING_ITEMS'),(17989,'STR_SELECT_WHICH_ITEMS_TO_LOCK'),(17990,'STR_THIS_ACTION_WILL_UNLOCK_ANY_ITEMS_THAT_ARE_CURRENTLY_LOCKED_BY_THIS_PROCESS'),(17991,'STR_SET_PRICE_LEVEL_FROM_TAGS'),(17992,'STR_SET_SALES_CATEGORY_FROM_TAGS'),(17993,'STR_UPLOAD_ITEM_HTML_AND_IMAGES'),(17994,'STR_NEXT_VENDOR_CODE'),(17995,'STR_ALWAYS_SHOW_BOX_ON_INVOICE_SUMMARY'),(17996,'STR_NEXT_CUSTOMER_CODE'),(17997,'STR_PRELIM_REQUEST_EMAIL_OPTIONS'),(17998,'STR_RENTAL_BILLING'),(17999,'STR_SHOW_BIN_LOCATION'),(18000,'STR_BLOCK_ITEM_ACTIVITY_DURING_PHYSICAL_INVENTORY'),(18001,'STR_SHOW_ONLY_MY_ENTRIES'),(18002,'STR_NEW_OVERPAYMENT'),(18003,'STR_NEW_OVERPAYMENT_FROM'),(18004,'STR_LIST_OF_LOCKED_ITEMS'),(18005,'STR_LOCKED_ITEMS_ARE_BLOCKING_THIS_ACTION'),(18006,'STR_MAKE_ADJUSTMENTS_OR_RETRY_AFTER_INVENTORY_FINALIZED'),(18007,'STR_NEXT_BILL_DATE'),(18008,'STR_NO_BILLABLE_ENTRIES'),(18009,'STR_RENTAL_BEGAN'),(18010,'STR_RENTAL_ITEMS'),(18011,'STR_CANNOT_DO_PARTIAL_LINE_SHIPMENTS_ON_RENTAL_ORDERS'),(18012,'STR_MAKE_QUANTITY_ADJUSTMENTS_OR_RETRY_AFTER_INVENTORY_FINALIZED'),(18013,'STR_RENTAL_PERIODS'),(18014,'STR_VIEW_OTHER_LOCATIONS'),(18015,'STR_GENERAL_BUDGET'),(18016,'STR_ITEM_BUDGET'),(18017,'STR_ITEM_VARIANCE'),(18018,'STR_LABOR_BUDGET'),(18019,'STR_LABOR_VARIANCE'),(18020,'STR_TOTAL_BUDGET'),(18021,'STR_TOTAL_VARIANCE'),(18022,'STR_VENDOR_BILL_BUDGET'),(18023,'STR_VENDOR_BILL_COSTS'),(18024,'STR_VENDOR_BILL_VARIANCE'),(18025,'STR_BUDGET_MARGIN'),(18026,'STR_MARGIN_VARIANCE'),(18027,'STR_SHOW_COST_CODE_AND_GL_CATEGORY_AS_SEPARATE_COLUMNS'),(18028,'STR_BILL_RENTAL_WHEN'),(18029,'STR_CONVERT_TO_RENTAL_ORDER'),(18030,'STR_NON_PRELIMABLE_ITEMS'),(18031,'STR_REMOVE_ITEMS'),(18032,'STR_SIGNATURE_REQUIRED'),(18033,'STR_UNLINK_JOB_FROM_ORDER'),(18034,'STR_CUSTOMER_AFTER_PICTURE'),(18035,'STR_CUSTOMER_BEFORE_PICTURE'),(18036,'STR_ALLOW_LOGIN_USING_EMAIL_ADDRESS'),(18037,'STR_ALWAYS_USE_HIGH_VOLUME_EDIT_PAGE_FOR_JOURNAL_ENTRIES'),(18038,'STR_DO_NOT_AUTO_LOAD_UI_TABLES'),(18039,'STR_LIMIT_ACCESS_TO_ONLY_ENTRIES_CREATED_BY_THIS_USER'),(18040,'STR_USER_RECEIVES_OVERPAYMENT_NOTICES'),(18041,'STR_ACCEPT_SELF_SIGNED_CERTIFICATES'),(18042,'STR_DO_NOT_VERIFY_PEER_NAME'),(18043,'STR_FULL_SERVER_VALIDATION'),(18044,'STR_RELAXED'),(18045,'STR_SECURITY_VERIFICATION'),(18046,'STR_WILL_BE_BILLED_THROUGH'),(18047,'STR_CREATE_A_PICKUP_REQUEST_FIRST'),(18048,'STR_COMMITTED_FOR_ORDER'),(18049,'STR_BUILDING_RECORD_SET'),(18050,'STR_COMPARE_AS_OF_DATE'),(18051,'STR_COUNTING'),(18052,'STR_CUSTOMER_DOES_NOT_EXIST'),(18053,'STR_CUSTOMER_TOTALS'),(18054,'STR_GL_POSTED_TO_DATE'),(18055,'STR_PROCESSING_RECORDS'),(18056,'STR_SHOW_GL_POSTED_TO_DATE'),(18057,'STR_PERCENT_AT__OVER_THE_LIMIT'),(18058,'STR_NON_RENTALS'),(18059,'STR_CANNOT_SEND_JOB_TO_ZLIEN'),(18060,'STR_JOBS_OVER_LIMIT'),(18061,'STR_JOBS_OVER_PRELIM_CREDIT_LIMIT'),(18062,'STR_JOB_NOT_MARKED_AS_PRELIMABLE'),(18063,'STR_OPEN_AMOUNT'),(18064,'STR_ERROR_CREATING_CATEGORY_AT_3DCART'),(18065,'STR_ERROR_EXPORTING_CATEGORIES_TO_3DCART'),(18066,'STR_ERROR_UPDATING_PRODUCT_CATEGORY'),(18067,'STR_EXPORT_SEARCH_CATEGORIES_3DCART_PRODUCT_CATEGORIES_TO_THIS_3DCART_STORE'),(18068,'STR_FINISHED_EXPORTING_CATEGORY_INFO_TO_3DCART'),(18069,'STR_FINISHED_IMPORTING_CATEGORY_INFO_FROM_3DCART'),(18070,'STR_IMPORT_SEARCH_CATEGORIES_3DCART_PRODUCT_CATEGORIES_FROM_THIS_3DCART_STORE'),(18071,'STR_ITEMS_SENT'),(18072,'STR_NEW_CATEGORIES'),(18073,'STR_NEW_ITEM_CATEGORY_LINKS'),(18074,'STR_OPTION_ONLY_AVAILABLE_WITH_REST_API'),(18075,'STR_DISPLAY_SIGNATURE_LINE_IN_ORDER_CONFIRMATION_FOOTER'),(18076,'STR_DO_NOT_ALLOW_SHIPPING_IF_MISSING_COSTS_ON_FULFILLMENT_ORDER'),(18077,'STR_DO_NOT_ALLOW_SHIPPING_OR_POS_SALE_IF_SHIPMENT_OR_SALE_GOES_OVER_CREDIT_LIMIT'),(18078,'STR_ACCOUNTS_PAYABLE_ENTRIES_RELATED_TO_BILL'),(18079,'STR_GL_ENTRIES_THAT_HIT_AP_MORE_THAN_ONCE_IN_THE_SAME_SET'),(18080,'STR_TOTAL_DELETED_BILLS_INSIDE_THIS_PERIOD_BUT_POSTED_OUTSIDE_THIS_PERIOD'),(18081,'STR_TOTAL_DELETED_BILLS_OUTSIDE_THIS_PERIOD_BUT_POSTED_INSIDE_THIS_PERIOD'),(18082,'STR_CANNOT_PRINT_ORDER_CONFIRMATION_UNTIL_ALL_QTY_IS_SHIPPED'),(18083,'STR_LAST_SHIP_DATE'),(18084,'STR_PICK_QTY'),(18085,'STR_AMOUNT_OVER_CREDIT_LIMIT'),(18086,'STR_THIS_SHIPMENT_PUTS_CUSTOMER_OVER_CREDIT_LIMIT'),(18087,'STR_VALUE_OF_OUTSTANDING_BALANCE'),(18088,'STR_VALUE_OF_SHIPMENT'),(18089,'STR_VALUE_OF_SHIPMENT_PLUS_OUTSTANDING_BALANCE'),(18090,'STR_CACHING_LANGUAGE_FILES'),(18091,'STR_ARCHIVE_AS_OF_DATE'),(18092,'STR_ACCOUNT_REQUIRES_A_COST_CODE'),(18093,'STR_ACCOUNT_REQUIRES_A_GL_CATEGORY'),(18094,'STR_AP_GL_ACCOUNT_NOT_ALLOWED'),(18095,'STR_LIST_OF_ALLOWED_PERIODS'),(18096,'STR_NO_CHARGE'),(18097,'STR_SEASONS'),(18098,'STR_CUSTOMER_IS_OVER_CREDIT_LIMIT'),(18099,'STR_MAX_ALLOWED_TAXES_ON_A_SINGLE_LINE_IS_3'),(18100,'STR_CHANGED_FROM'),(18101,'STR_CUSTOMER_INVOICEING'),(18102,'STR_INVOICE_UPDATE_BY_USER'),(18103,'STR_RECOMMITTED_FOR_ORDER'),(18104,'STR_USED_FOR_ORDER'),(18105,'STR_CURRENT_VALUE'),(18106,'STR_DEFAULT_VALUE'),(18107,'STR_THE_DEFAULT_SETTINGS_FOR_THE_SELECTED_ITEM_CATEGORY_DOES_NOT_MATCH_THE_CURRECT_VALUES'),(18108,'STR_APPOINTMENT_BECAME_UNAVAILABLE'),(18109,'STR_PLEASE_SELECT_A_DIFFERENT_APPOINTMENT_TIME_OR_CONTACT_US_FOR_ASSISTANCE'),(18110,'STR_USE_THE_CALENDAR_TO_SELECT_A_DATE'),(18111,'STR_AMOUNT_TO_AUTHORIZE'),(18112,'STR_APPOINTMENT_DETAILS'),(18113,'STR_AUTHORIZATION_DENIED'),(18114,'STR_AUTHORIZATION_DETAILS'),(18115,'STR_AUTHORIZATION_SUCCESS'),(18116,'STR_AUTHORIZE_MY_CARD_AND_BOOK_THIS_APPOINTMENT'),(18117,'STR_CARD_TO_USE'),(18118,'STR_CLICK_HERE_TO_PROCEED_TO_YOUR_APPOINTMENT_SUMMARY'),(18119,'STR_CLICK_HERE_TO_VIEW_MORE_APPOINTMENT_TIMES'),(18120,'STR_IMPORTANT'),(18121,'STR_NO_APPOINTMENT_INFORMATION_FOUND_AUTH_MESSAGE'),(18122,'STR_PAYMENT_AUTHORIZATION_REQUIRED'),(18123,'STR_PLEASE_REVIEW_AND_CONFIRM_THE_FOLLOWING_DETAILS'),(18124,'STR_PROCESSING_ERROR'),(18125,'STR_YOUR_CARD_AUTHORIZATION_HAS_BEEN_APPROVED_BUT_YOUR_APPOINTMENT_TIME_WAS_SINCE_RESERVED_BY_AN_ADMINISTRATOR'),(18126,'STR_APPOINTMENT_NO_SHOW_FEE'),(18127,'STR_ONLY_APPLIES_IF_REQUIRING_PAYMENT_METHOD_TO_BOOK'),(18128,'STR_REQUIRE_CC_AUTH_TO_BOOK_AMOUNT'),(18129,'STR_APPOINTMENT_MERGE'),(18130,'STR_FORCE_ALL_APPOINTMENT_DATA_TO_THE_MASTER_CUSTOMER'),(18131,'STR_COMBINE_THIS_AMOUNT_IN_THE_LINE_ABOVE_OR_REMOVE_THIS_LINE'),(18132,'STR_LINE_IS_THE_SAME_AS_THE_ONE_ABOVE'),(18133,'STR_CUSTOMER_INVOICING'),(18134,'STR_DOB'),(18135,'STR_GENDER'),(18136,'STR_THE_DEFAULT_SETTINGS_FOR_THE_SELECTED_ITEM_CATEGORY_DOES_NOT_MATCH_THE_CURRENT_VALUES'),(18137,'STR_THE_DEFAULT_SETTINGS_FOR_THE_SELECTED_ITEM_CATEGORY_DO_NOT_MATCH_THE_CURRENT_VALUES'),(18138,'STR_YOUR_CARD_AUTHORIZATION_HAS_BEEN_APPROVED_BUT_YOUR_APPOINTMENT_TIME_HAS_SINCE_BEEN_RESERVED_BY_AN_ADMINISTRATOR'),(18139,'STR_COMPLETED_PURCHASE_ORDERS_NOT_SENT_TO_AP'),(18140,'STR_OVERDUE_ORDERS_WAITING_ON_PO'),(18141,'STR_CREDIT_FROM'),(18142,'STR_INVOICE_PICK_LIST'),(18143,'STR_RENTAL_PERIOD_CHANGED'),(18144,'STR_ONLY_USED_IF_NEW_ITEM'),(18145,'STR_PERIOD_COUNT'),(18146,'STR_RENTAL_PERIOD'),(18147,'STR_SHIPPABLE_ORDERS_WITH_RECEIVED_PO'),(18148,'STR_BEGIN_SHIPMENT'),(18149,'STR_EFFECTIVE_SHIPPED'),(18150,'STR_ORDERS_DUE_DATE'),(18151,'STR_PENDING_PURCHASE_ORDER'),(18152,'STR_PREVIOUS_REDUCTION'),(18153,'STR_PRINT_PACKING_SLIPS'),(18154,'STR_REDUCE_BY'),(18155,'STR_RETURN_QTY_TO_ON_HAND'),(18156,'STR_ROUTE'),(18157,'STR_SHIPMENT_ADJUSTMENT'),(18158,'STR_SHIPPING_ROUTE'),(18159,'STR_SHIP_BY_ROUTE'),(18160,'STR_EMAILS_SENT'),(18161,'STR_ERROR_SENDING_EMAIL'),(18162,'STR_EXPORT_BILLTRUST_BALANCES'),(18163,'STR_EXPORT_BILLTRUST_INVOICES'),(18164,'STR_FAXES_SENT'),(18165,'STR_FAX_INVOICES'),(18166,'STR_INVOICE_DELIVERY'),(18167,'STR_CHECK_YOUR_DEVICE_AND_INTERNET_CONNECTION'),(18168,'STR_TERMINAL_DID_NOT_RESPOND'),(18169,'STR_CONTAINER'),(18170,'STR_FOR_ORDER'),(18171,'STR_NO_TRANSFERS_FOUND'),(18172,'STR_PICK'),(18173,'STR_PICK_TRANSFER'),(18174,'STR_RECEIVE_TRANSFER'),(18175,'STR_REQUEST'),(18176,'STR_SHIPPING_CONTAINER'),(18177,'STR_THIS_TRANSFER_HAS_BEEN_RECEIVED'),(18178,'STR_THIS_TRANSFER_HAS_BEEN_SHIPPED'),(18179,'STR_THIS_TRANSFER_HAS_NOT_BEEN_SHIPPED'),(18180,'STR_THIS_TRANSFER_IS_DELETED'),(18181,'STR_TRANSFER_TO'),(18182,'STR_ASSIGN_STOCK_CHECK_REQUEST'),(18183,'STR_ASSIGN_TO_USER'),(18184,'STR_CLEAR_ALL_LAST_COUNT_DATES'),(18185,'STR_COST_OF_GOODS_FROM_SALES'),(18186,'STR_CYCLE'),(18187,'STR_ENTER_COUNTS'),(18188,'STR_INVENTORY_COUNT'),(18189,'STR_LAST_COUNTED'),(18190,'STR_MARK_AS_COUNT_COMPLETED'),(18191,'STR_NEW_EDIT'),(18192,'STR_NEW_INVENTORY_COUNT_CREATED'),(18193,'STR_REVIEW_ACTIVE_INVENTORY_COUNTS'),(18194,'STR_SHELF_BIN'),(18195,'STR_SHOW_ONLY_ON_HAND_ITEMS'),(18196,'STR_SHOW_ONLY_UNCOUNTED'),(18197,'STR_SHOW_X_DAY_COGS'),(18198,'STR_UNCOUNTED'),(18199,'STR_UNZONED'),(18200,'STR_ZONES'),(18201,'STR_COST_RECEIVED'),(18202,'STR_COST_UNRECEIVED'),(18203,'STR_UNSHIPPED_ORDERS_THAT_HAVE_QTY_RECEIVED_FROM_PO'),(18204,'STR_ACCOUNT_NOT_FOUND'),(18205,'STR_ACCRUED_PURCHASES'),(18206,'STR_FIELD_REQUIRED'),(18207,'STR_TRANSFER_SHORT'),(18208,'STR_ENTER_STOCK_COUNTS'),(18209,'STR_MANAGE_PLANS'),(18210,'STR_MANAGE_SUBSCRIPTIONS'),(18211,'STR_MANUAL_PROCESSING'),(18212,'STR_PAYMENT_ON_ACCOUNT_ENTRY'),(18213,'STR_PICK_MY_TRANSFERS'),(18214,'STR_RECEIVE_TRANSFERS'),(18215,'STR_SHIPPING_ROUTES'),(18216,'STR_CURRENT_PASSWORD_IS_WRONG'),(18217,'STR_NEW_PASSWORDS_DO_NOT_MATCH'),(18218,'STR_NEW_PASSWORD_CANNOT_MATCH_CURRENT_PASSWORD'),(18219,'STR_PASSWORD_SET_SUCCESSFULLY'),(18220,'STR_YOU_ARE_REQUIRED_TO_SET_A_NEW_PASSWORD'),(18221,'STR_ABOVE_FIELDS_REQUIRED'),(18222,'STR_PAYMENT_ON_ACCOUNT'),(18223,'STR_CONFIGURATION'),(18224,'STR_DAY_PEREN_S'),(18225,'STR_MONTH_PEREN_S'),(18226,'STR_PERIOD_LENGTH'),(18227,'STR_RECURRING_BILLING_PLAN'),(18228,'STR_WEEK_PEREN_S'),(18229,'STR_YEAR_PEREN_S'),(18230,'STR_ZIP_CODES'),(18231,'STR_INCLUDE_ALL_VENDORS'),(18232,'STR_LEGEND'),(18233,'STR_PAYMENTS_IN_PERIOD'),(18234,'STR_NEW_INVENTORY_TRANSFER'),(18235,'STR_REMAINING_AVAILABLE'),(18236,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_THIS_RECORD'),(18237,'STR_NO_EMAIL_FOR_INVOICE_FOR_CUSTOMER'),(18238,'STR_NO_FAX_NUMBER_FOR_CUSTOMER'),(18239,'STR_RENTAL_RETURN'),(18240,'STR_RENTAL_RETURN_REV'),(18241,'STR_CANNOT_CREATE_SHIPMENT_ADJUSTMENT'),(18242,'STR_EFFECTIVE_SHIPPED_CANNOT_BE_NEGATIVE'),(18243,'STR_QTY_SHIPPED_CANNOT_BE_GREATER_THAN_QTY_ORDERED'),(18244,'STR_THIS_SHIPMENT_HAS_ALREADY_BEEN_INVOICED'),(18245,'STR_REQUIRED_FIELD_NOT_SET'),(18246,'STR_ALL_ZONES_COUNTED'),(18247,'STR_STATS'),(18248,'STR_ADJUST_THIS_SHIPMENT'),(18249,'STR_CONFIRM_NEW_PASSWORD'),(18250,'STR_CURRENT_PASSWORD'),(18251,'STR_NEW_PASSWORD'),(18252,'STR_DROP_SHIP_DEFAULT_SHIPPING_METHOD'),(18253,'STR_AUTO_IMPORT_INVOICES_DO_NOT_CHANGE_INVENTORY_LEVELS'),(18254,'STR_BLOCK_INVOICING_SHIPMENTS_WITHOUT_DOCUMENT_ATTACHED'),(18255,'STR_BLOCK_SALES_OF_ITEMS_WITH_NO_PRICE'),(18256,'STR_CONVENIENCE_FEE_AS_PERCENTAGE_NOT_FLAT_FEE'),(18257,'STR_DAYS_AFTER_INVOICE_DATE_TO_CHARGE_INTEREST'),(18258,'STR_HIDE_THE_NUMBER_OF_PERIODS_FOR_RENTAL_ORDERS'),(18259,'STR_NONTAXABLE_SALES'),(18260,'STR_POA_BANK_ACCOUNT'),(18261,'STR_TAXABLE_SALES'),(18262,'STR_CONTRA_RENTAL'),(18263,'STR_OUT_ON_RENTAL'),(18264,'STR_USE_WALK_IN_TAXES_FOR_SERVICE_ORDERS'),(18265,'STR_BOTH_BY_USING_ACCRUED'),(18266,'STR_DEFAULT_INVENTORY_LOCATION_FOR_RENTAL_TRANSFERS'),(18267,'STR_BOX_14_OTHER'),(18268,'STR_USER_PASSWORD_EXPIRE_DAYS'),(18269,'STR_CAN_ONLY_CLEAR_ENTRIES_ALREADY_DESIGNATED_FOR_THIS_ACCOUNT'),(18270,'STR_DEPOSIT_TO_BANK_ACCOUNT'),(18271,'STR_FROM_SLASH_TO'),(18272,'STR_TRANSACTIONS_FROM_BANK_ACCOUNT'),(18273,'STR_EXCLUDE_NON_STOCK_ITEMS'),(18274,'STR_NEEDS_DOC'),(18275,'STR_TOTAL_SHIPMENT_VALUE'),(18276,'STR_PRICE_MUST_BE_SET'),(18277,'STR_CUSTOMER_EDIT_RESTRICTIONS'),(18278,'STR_DEFAULT_TO_PAYMENT_ON_ACCOUNT'),(18279,'STR_DO_NOT_CHANGE_INVENTORY_LEVELS'),(18280,'STR_ADD_LINE'),(18281,'STR_ADJUSTMENT_COST'),(18282,'STR_ADJUSTMENT_GL_ACCOUNT'),(18283,'STR_ADJUSTMENT_QTY'),(18284,'STR_ITEMS_ADJUSTED_SUCCESSFULLY'),(18285,'STR_ITEM_ADJUSTMENT'),(18286,'STR_ITEM_ADJUSTMENTS_FAILED'),(18287,'STR_NO_DEFAULT_INVENTORY_ACCOUNT_SET'),(18288,'STR_NO_DEFAULT_INVENTORY_LOSS_ACCOUNT_SET'),(18289,'STR_PLEASE_ENTER_AN_ADJUSTMENT_DATE'),(18290,'STR_PLEASE_ENTER_AN_ADJUSTMENT_GL_ACCOUNT'),(18291,'STR_PLEASE_ENTER_AN_ITEM'),(18292,'STR_SELECT_AN_ITEM_AND_CLICK_ADD_LINE'),(18293,'STR_SKIPPING'),(18294,'STR_TOTAL_ADJUSTMENT_COST'),(18295,'STR_PLEASE_INPUT_CATEGORY_FOR_GL_ACCOUNTS'),(18296,'STR_CREATE_NEW_ENTRY'),(18297,'STR_NO_SAVE_CONFIGURATION_ONLY'),(18298,'STR_RERENTAL'),(18299,'STR_WOULD_YOU_LIKE_TO_COPY_THESE_DEFAULTS_TO_ALL_MATCHING_EXISTING_ITEMS'),(18300,'STR_YES_SAVE_AND_COPY_DEFAULTS'),(18301,'STR_NO_DISTRIBUTION_CENTER_ASSIGNED'),(18302,'STR_NO_PURCHASE_ORDER_CREATED'),(18303,'STR_ORDER_TO_DC'),(18304,'STR_ORDER_TO_DISTRIBUTION_CENTER'),(18305,'STR_CANNOT_ENTER_MORE_QTY_THAN_WHAT_IS_ORDERED'),(18306,'STR_CUSTOMER_WILL_PICKUP'),(18307,'STR_EXTENSIVE'),(18308,'STR_FASTER'),(18309,'STR_ITEM_LOOKUP_METHOD'),(18310,'STR_QUICK'),(18311,'STR_SEARCH_EXACT_MATCHES_ONLY_FOR_ITEM_CODE_OR_UPC'),(18312,'STR_SEARCH_WITHIN_ITEM_CODE_DESCRIPTION_UPC_VENDOR_PRODUCT_CODE'),(18313,'STR_SLOWER'),(18314,'STR_EXCLUDE_THIS_VENDOR'),(18315,'STR_VENDOR_PAYMENTS_REPORT'),(18316,'STR_DEFAULT_SHIP_TO_TAX_EXEMPTION'),(18317,'STR_ON_ACCOUNT_NOT_ALLOWED_WHEN_CREDIT_DISABLED'),(18318,'STR_TAXES_WILL_BE_AUTO_SELECTED_BASED_ON_THESE_DETAILS'),(18319,'STR_THESE_SELECTED_TAXES_MAY_BE_OVERRIDDEN_BY_THE_TAXES_THAT_APPLY_TO_THE_ENTERED_SHIP_TO_ADDRESS'),(18320,'STR_UPDATE_CURRENT_SHIP_TO_TAX_EXEMPTIONS_WITH_DEFAULT'),(18321,'STR_SHIPMENT_DOCUMENTS'),(18322,'STR_CUSTOMER_PICK_UP'),(18323,'STR_ON_ACCOUNT'),(18324,'STR_BLOCK_CUSTOMER_EDITING'),(18325,'STR_BLOCK_ORDER_ENTRY_ADDITIONAL_LINE_ITEM_OPTIONS'),(18326,'STR_SHOW_NOTES_ON_ORDER_DATATABLE_BY_DEFAULT'),(18327,'STR_CHARGE_NO_TAXES_FOR_ORDERS_IF_SHIP_TO_IS_OUTSIDE_THIS_STATE'),(18328,'STR_EMAIL_TRANSFER_NOTICES'),(18329,'STR_USE_WALK_IN_TAXES_FOR_ORDERS_IF_SHIP_TO_IS_IN_THIS_STATE'),(18330,'STR_CATEGORY_ITEMS'),(18331,'STR_SET_DEFAULTS_FOR_ALL'),(18332,'STR_SET_DEFAULTS_THIS_ITEM_ONLY'),(18333,'STR_TAXES_NOT_FOUND_FOR_CUSTOMER'),(18334,'STR_TAXES_NOT_FOUND_FOR_SHIP_TO'),(18335,'STR_WALK_IN_TAXES_NOT_FOUND'),(18336,'STR_CUSTOMER_WILL_PICK_UP'),(18337,'STR_SHIPMENT_SEARCH'),(18338,'STR_SHIPMENT_SEARCH_RESULTS'),(18339,'STR_ARE_YOU_SURE_WANT_TO_CLEAR_ALL_COUNT_DATES'),(18340,'STR_COST_OF_MISSING_GOODS'),(18341,'STR_EXPECTED'),(18342,'STR_INVENTORY_COUNT_ADJUSTMENT'),(18343,'STR_MARK_AS_COMPLETE'),(18344,'STR_PARTIALLY_ASSIGNED'),(18345,'STR_POST_ON_HAND_ADJUSTMENTS'),(18346,'STR_ADJUST_SHIPMENT'),(18347,'STR_REVIEW_AND_POST_COUNTS'),(18348,'STR_COST_OF_GOODS_VARIANCE'),(18349,'STR_DEFAULT_TO_MY_USER_AND_LOCATION_ON_UI_TABLES'),(18350,'STR_IN_TRANSIT'),(18351,'STR_MUST_BE_IN_TRANSIT'),(18352,'STR_QTY_REQUESTED'),(18353,'STR_SHIPPED_BY_USER'),(18354,'STR_SKIPPING_LINE'),(18355,'STR_WILL_DEFAULT_TO_CURRENT_DATE'),(18356,'STR_WILL_DEFAULT_TO_CURRENT_USER'),(18357,'STR_WILL_DEFAULT_TO_ITEM_SETTINGS'),(18358,'STR_WILL_DEFAULT_TO_VENDOR_SETTINGS'),(18359,'STR_DEFAULT_INVOICE_PAYMENT_AMOUNT_TO_ZERO'),(18360,'STR_IS_RENTAL_DISTRIBUTION_CENTER'),(18361,'STR_RENTAL_DISTRIBUTION_CENTER'),(18362,'STR_RESTRICTED_ACCESS'),(18363,'STR_THIS_PAGE_IS_NOT_AVAILABLE_TO_B2B_USERS'),(18364,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_THIS_CONTACT'),(18365,'STR_DELETE_THIS_CONTACT'),(18366,'STR_SAVE_CONTACT'),(18367,'STR_SELECT_A_CONTACT_TO_EDIT'),(18368,'STR_THIS_ACTION_WILL_REMOVE_ALL_DATA_SHOWN_ON_THIS_PAGE'),(18369,'STR_B2B_USER_UPDATED_SUCCESSFULLY'),(18370,'STR_B2B_USER_UPDATE_FAILED'),(18371,'STR_CANNOT_ACCEPT_LOGIN_CREDENTIALS'),(18372,'STR_CUSTOMER_INFORMATION_UPDATED_SUCCESSFULLY'),(18373,'STR_CUSTOMER_UPDATE_FAILED'),(18374,'STR_EDIT_CONTACTS'),(18375,'STR_NO_PRELIM'),(18376,'STR_OFF_RENT'),(18377,'STR_RENTAL_RETURNED'),(18378,'STR_TO_BE_PICKED'),(18379,'STR_PO_RECEIPTS'),(18380,'STR_RECEIPT_DATE'),(18381,'STR_RECEIPT_ID'),(18382,'STR_OUT_ON_RENT_ITEMS'),(18383,'STR_OPEN_AMOUNT_GREATER_THAN'),(18384,'STR_OPEN_BALANCE'),(18385,'STR_COLLECT_CONVENIENCE_FEE'),(18386,'STR_ALLOW_CUSTOMER_CREDIT'),(18387,'STR_CREATE_NEW_PLAN_TEMPLATE'),(18388,'STR_DISABLE_AUTOMATIC_BILLING'),(18389,'STR_EDIT_SUBSCRIPTION'),(18390,'STR_ERROR_PROCESSING_FIRST_PERIOD'),(18391,'STR_ERROR_PROCESSING_SUBSCRIPTION'),(18392,'STR_FIRST_PERIOD_PROCESSED'),(18393,'STR_HOW_MANY_PERIODS_ARE_A_TRIAL'),(18394,'STR_INVOICE_TEMPLATE'),(18395,'STR_MANUAL_PROCESSING_ONLY'),(18396,'STR_MANUAL_PROCESSING_WILL_INVOICE_ALL_PERIODS_DUE_BY_THE_SPECIFIED_DATE'),(18397,'STR_NEW_SUBSCRIPTION'),(18398,'STR_PAY_INVOICES_WITH_CREDIT_WHEN_AVAILABLE'),(18399,'STR_PERIOD_LIMIT'),(18400,'STR_PROCESSING_ABORTED'),(18401,'STR_PROCESSING_COMPLETE'),(18402,'STR_PROCESS_SELECTION'),(18403,'STR_RECURRING_BILLING_PLAN_INVOICE'),(18404,'STR_RECURRING_BILLING_PLAN_SUBSCRIPTION'),(18405,'STR_REMAINING_BALANCE'),(18406,'STR_REVIEW_INVOICE_DETAILS'),(18407,'STR_SUBSCRIPTION_ID'),(18408,'STR_TOTAL_PER_INVOICE'),(18409,'STR_TRIAL_PERIOD_LENGTH'),(18410,'STR_TRIAL_PERIOD_PRICE'),(18411,'STR_ZERO_MEANS_UNLIMITED'),(18412,'STR_QUANITY_NEEDED'),(18413,'STR_STOCK_PURCHASE_REQUEST'),(18414,'STR_SUBSCRIPTION_TRIAL_PERIOD'),(18415,'STR_DELETE_CHECKIN'),(18416,'STR_ADD_REMOVE_ITEM'),(18417,'STR_ITEM_ADDED'),(18418,'STR_ITEM_ALREADY_SELECTED'),(18419,'STR_ITEM_IS_NOT_CURRENTLY_SELECTED'),(18420,'STR_ITEM_REMOVED'),(18421,'STR_NUMBER_OF_ITEMS_SELECTED'),(18422,'STR_LOOKUP_ITEM'),(18423,'STR_COLLECT'),(18424,'STR_ARE_YOU_SURE_YOU_WANT_TO_PROCEED'),(18425,'STR_INVOICE_TOTAL_CANNOT_BE_ZERO'),(18426,'STR_IS_INCOMPLETE_AND_WILL_BE_DELETED'),(18427,'STR_IS_INCOMPLETE_AND_WILL_BE_IGNORED'),(18428,'STR_RECURRING_BILLING_PLAN_INVOICE_TEMPLATE'),(18429,'STR_WILL_BE_DELETED'),(18430,'STR_YOU_MUST_ENTER_A_PLAN_NUMBER'),(18431,'STR_YOU_MUST_SELECT_A_DEFAULT_PRICE_LEVEL'),(18432,'STR_YOU_MUST_SELECT_A_LOCATION'),(18433,'STR_YOU_MUST_SELECT_A_SALES_CATEGORY'),(18434,'STR_YOU_MUST_SELECT_A_SALES_GL_ACCOUNT'),(18435,'STR_YOU_MUST_SELECT_INVOICE_TERMS'),(18436,'STR_COUNTY_RATE_IS_INCLUDED_IN_CITY_RATE_AND_BOTH_REPORTED_UNDER_CITY'),(18437,'STR_STATES_WITH_NO_COUNTY_TAX_IF_THERE_IS_A_CITY_TAX'),(18438,'STR_BLOCK_ITEM_PROFIT_CHANGES_FOR_STOCK_ITEMS'),(18439,'STR_BLOCK_SALES_WITHOUT_A_PURCHASED_BY_CONTACT_ASSIGNED'),(18440,'STR_BLOCK_WHEN_LINE_ITEM_IS_STOCK'),(18441,'STR_ATTACHMENT_REQUIRED'),(18442,'STR_CLICK_TO_REPAIR'),(18443,'STR_EXEMPTION_TYPE'),(18444,'STR_NO_DISTRICT_ASSIGNED_TO_LINE_ITEMS'),(18445,'STR_OUT_OF_STATE_SALE'),(18446,'STR_PARTIAL_EXEMPTION_PERCENT'),(18447,'STR_PARTIAL_EXEMPTION_TYPE'),(18448,'STR_PERCENT_PAID'),(18449,'STR_SHIP_COUNTY'),(18450,'STR_SHIP_POSTAL_CODE'),(18451,'STR_SOLD_FROM_STATE'),(18452,'STR_TAX_DETAIL_REPAIR_COMPLETE'),(18453,'STR_TAX_DISTRICT'),(18454,'STR_TAX_DISTRICT_TOTALS'),(18455,'STR_TAX_TOTAL'),(18456,'STR_USE_WHICH_DATE'),(18457,'STR_A_RENTAL_ORDER_CAN_ONLY_HAVE_ONE_SHIPMENT'),(18458,'STR_YOU_HAVE_ENTERED_A_PARTIAL_QUANTITY_TO_SHIP'),(18459,'STR_FILE_MUST_BE_WRITABLE'),(18460,'STR_ITEM_RENTAL_TYPE'),(18461,'STR_NON_RENTALS_ONLY'),(18462,'STR_RENTALS_ONLY'),(18463,'STR_ARE_YOU_SURE_YOU_WANT_TO_COPY_PRICING_TO_ALL_LOCATIONS'),(18464,'STR_COPY_PRICING_TO_ALL_LOCATIONS'),(18465,'STR_REQUIRED_FIELD'),(18466,'STR_EMAIL_STOCK_PURCHASE_REQUEST'),(18467,'STR_CANNOT_PROCESS_A_DAY_ALREADY_CLOSED'),(18468,'STR_CREATED_BANK_DEPOSIT'),(18469,'STR_DAILY_CLOSE_OVER'),(18470,'STR_DAILY_CLOSE_SHORT'),(18471,'STR_ERROR_CREATING_BANK_DEPOSIT'),(18472,'STR_FAILED_TO_CREATE_OVER_OR_SHORT_VARIANCE_GL_ENTRY'),(18473,'STR_GL_CASH'),(18474,'STR_GL_CC'),(18475,'STR_GL_CHECKS'),(18476,'STR_INVENTORY_LOCATION_MUST_HAVE_A_DEFAULT_CHECKING_ACCOUNT_ASSIGNED'),(18477,'STR_LAST_CLOSE_DATE'),(18478,'STR_LAST_FLOAT'),(18479,'STR_AVG_LINES_PER_INVOICE'),(18480,'STR_AVG_SALES_PER_INVOICE'),(18481,'STR_CREATED_CREDIT_MEMO'),(18482,'STR_CREATED_NEW_INVOICE'),(18483,'STR_CREATED_TAX_AJUSTEMENT'),(18484,'STR_CREDIT_MEMO'),(18485,'STR_CREDIT_MEMOS'),(18486,'STR_DAILY_SALES_INQUIRY'),(18487,'STR_FIRST_RENTALS'),(18488,'STR_GROSS_MARGIN'),(18489,'STR_INVOICE_ACTIVITY'),(18490,'STR_INVOICE_MUST_BE_UNPOSTED'),(18491,'STR_ISSUE_PRICE_ADJUSTMENT_CREDIT'),(18492,'STR_ISSUE_SIMPLE_CREDIT'),(18493,'STR_ISSUE_TAX_ADJUSTMENT'),(18494,'STR_NOTHING_TO_SAVE'),(18495,'STR_PAYMENT_TYPES_BY_LOCATION'),(18496,'STR_PRICE_ADJUSTMENT'),(18497,'STR_RETURNED_GOODS'),(18498,'STR_SALES_AND_MARGIN_BY_SHIPPING_AND_BRANCH'),(18499,'STR_SAVE_CREDIT_MEMO'),(18500,'STR_SAVE_TAX_ADJUSTMENT'),(18501,'STR_VOIDED_INVOICES'),(18502,'STR_EXTENDED_SALE_PRICE'),(18503,'STR_OUT_ON_RENT'),(18504,'STR_RENTAL_LAST_BILL_DATE'),(18505,'STR_RENTAL_QTY_RETURNED'),(18506,'STR_RENTAL_RETURN_DATE'),(18507,'STR_SHIPPED_DATE'),(18508,'STR_UNIT_SALE_PRICE'),(18509,'STR_EXPORT_BILLTRUST_STATEMENT'),(18510,'STR_CHECK_FOR_NEXT_UPDATE'),(18511,'STR_GENERATE_CUSTOMER_STATMENTS'),(18512,'STR_NO_OPEN_INVOICES_FOUND'),(18513,'STR_REMITTANCE_AMOUNT'),(18514,'STR_TO_INSURE_PROPER_CREDIT_PLEASE_DETACH_AT_PERFORATION_AND_RETURN_TOP_PORTION_WITH_YOUR_REMITTANCE'),(18515,'STR_BIN_ITEMS'),(18516,'STR_INVENTORY_LOCATION_MUST_BE_SET'),(18517,'STR_PICKER_TRANSFER'),(18518,'STR_SHIPPER_TRANSFER'),(18519,'STR_FROM_LOCATION'),(18520,'STR_SHOW_ONLY_UNFULFILLABLE_QUANTITIES'),(18521,'STR_TO_LOCATION'),(18522,'STR_ASSIGN_ZONE'),(18523,'STR_CURRENT_ZONE'),(18524,'STR_ZONE_BINS'),(18525,'STR_BACKORDERED_STOCK'),(18526,'STR_NO_DEFAULT_VENDOR'),(18527,'STR_QUANITY_BACKORDERED'),(18528,'STR_SET_COST_EACH'),(18529,'STR_SHOW_ONLY_NEEDING_REORDERED'),(18530,'STR_IMPORT_ITEM_VENDOR_DETAILS'),(18531,'STR_OVER_QTY'),(18532,'STR_UP_TO_THIS_QTY'),(18533,'STR_REGION_MANAGEMENT'),(18534,'STR_REQUESTS_AT_OR_ABOVE_MINIMUM'),(18535,'STR_REQUESTS_BELOW_MINIMUM'),(18536,'STR_PROCEED'),(18537,'STR_THIS_ACTION_MAY_COLLECT_PAYMENT'),(18538,'STR_ADDITIONAL_SOFTWARE_REQUIRED'),(18539,'STR_IMAGEMAGICK_HAS_NO_SUPPORTED_FORMATS'),(18540,'STR_IMAGEMAGIC_VERSION_SHOULD_MATCH_PHP_EXTENTION_VERSION'),(18541,'STR_NO_NEW_INVOICE'),(18542,'STR_PHP_IS_UNABLE_TO_EXECUTE_SHELL_COMMANDS'),(18543,'STR_PHP_MUST_HAVE_ACCESS_TO'),(18544,'STR_SHIPMENT_ALREADY_INVOICED'),(18545,'STR_EDIT_REGION'),(18546,'STR_REGION_MANAGER'),(18547,'STR_REGION_NAME'),(18548,'STR_SELECT_REGION'),(18549,'STR_TERRITORY_CODE'),(18550,'STR_TERRITORY_NAME'),(18551,'STR_TERRITORY_REGION_MANAGEMENT'),(18552,'STR_THIS_ACTION_WILL_DELETE_EXISTING_RECORDS_FOR_THIS_COMPANY'),(18553,'STR_THIS_CODE_IS_USED_TO_GENERATE_TERRITORY_CODES'),(18554,'STR_QUANTITY_NEEDED'),(18555,'STR_AUTHORIZATION_SERVICES'),(18556,'STR_SYSTEM_CHECKS_GL_SUMMARY'),(18557,'STR_VIEW_VOUCHER_DETAILS'),(18558,'STR_CASH_ENTERED'),(18559,'STR_CC_ENTERED'),(18560,'STR_CHECKS_ENTERED'),(18561,'STR_CLOSE_DATE'),(18562,'STR_DAILY_CLOSE_LOG'),(18563,'STR_PRICE_ADJUSMENT_CREDITS'),(18564,'STR_CONTRACTOR'),(18565,'STR_EXEMPTION'),(18566,'STR_CREDIT_TYPE'),(18567,'STR_ENTER_PRICE_ADJUSTMENT_DETAILS'),(18568,'STR_ENTER_RETURN_DETAILS'),(18569,'STR_ENTER_TAX_ADJUSTMENT_DETAILS'),(18570,'STR_HIDE_THIS_CREDIT_MEMO_ON_B2B'),(18571,'STR_ISSUE_CREDIT'),(18572,'STR_POLICY_ADJUSTMENT'),(18573,'STR_SIMPLE_CREDIT'),(18574,'STR_TAX_ADJUSTMENT'),(18575,'STR_CREDIT_TOTAL'),(18576,'STR_NEW_UNIT_PRICE'),(18577,'STR_CURRENT_TAXES'),(18578,'STR_CURRENT_TAXES_TOTAL'),(18579,'STR_NEW_TAXES'),(18580,'STR_NEW_TAXES_TOTAL'),(18581,'STR_ASSIGNED_PRIMARY'),(18582,'STR_NOT_ASSIGNED'),(18583,'STR_THIS_BIN'),(18584,'STR_LOOK_UP_ITEM'),(18585,'STR_NON_PRELIM_BAL'),(18586,'STR_NON_PRELIM_BALANCE'),(18587,'STR_NON_PRELIM_LIMIT'),(18588,'STR_PRELIM_BAL'),(18589,'STR_PRELIM_BALANCE'),(18590,'STR_PRELIM_LIMIT'),(18591,'STR_AMOUNT_BELOW_MINIMUM'),(18592,'STR_MINIMUM_PRICE'),(18593,'STR_PERCENT_BELOW_MINIMUM'),(18594,'STR_ADD_INVENTORY_LOCATION_CODE_TO_END_OF_PO_NUMBERS'),(18595,'STR_HIDE_VENDOR_ADD_IN_PO_PROCESS'),(18596,'STR_LOCATION_FOR_PO_HEADER'),(18597,'STR_SHOW_MAIN_PAGE_NOTE_IN_PO_HEADER'),(18598,'STR_USE_COMPANY_INFO'),(18599,'STR_YOU_DO_NOT_CURRENTLY_HAVE_ANY_LOCATION_CODES_ENTERED'),(18600,'STR_ALWAYS_COLLECT_CONVENIENCE_FEE'),(18601,'STR_BLOCK_NON_DIRECT_GL_ENTRY_EDITING'),(18602,'STR_CALCULATE_BASED_ON_LEDGER_TOTAL'),(18603,'STR_CALCULATE_BASED_ON_SYSTEM_TOTAL'),(18604,'STR_DAILY_CLOSE_OVER_SHORT_METHOD'),(18605,'STR_DEFAULT_BANK_DEPOSIT_ACCOUNT'),(18606,'STR_DEFAULT_BANK_DEPOSIT_COST_CODE'),(18607,'STR_HIDE_CARRIER_NAME_AND_SHOW_ONLY_SERVICE'),(18608,'STR_HIDE_QTY_SLASH_PRICE_BOX'),(18609,'STR_MINIMUM_PRICE_LEVEL'),(18610,'STR_SHOW_COST_CODE_OPTIONS_ON_PAYMENT_PAGE'),(18611,'STR_SHOW_CREDIT_CARD_ADD_LINK_AFTER_CUSTOMER_ADD'),(18612,'STR_SHOW_INVENTORY_LOCATION_OPTIONS_ON_PAYMENT_PAGE'),(18613,'STR_SHOW_VENDOR_ITEM_CODE'),(18614,'STR_DAILY_CLOSE_OVER_SHORT'),(18615,'STR_CONTRACTOR_EXEMPTION'),(18616,'STR_PRELIMABLE_MATERIALS_EXEMPT'),(18617,'STR_DEFAULT_RENTAL_PRICE_LEVEL'),(18618,'STR_ONLY_ALLOW_TRANSFERS_FROM_DISTRIBUTION_CENTER'),(18619,'STR_STOCK_CHECK_REQUEST_DEFAULT_CYCLE_COUNT_ADJUSTMENT_TYPE'),(18620,'STR_STOCK_CHECK_REQUEST_DEFAULT_PHYSICAL_COUNT_ADJUSTMENT_TYPE'),(18621,'STR_BILL_DETAILS_UPDATED_SUCCESSFULLY'),(18622,'STR_RELATED_GL_ENTRIES_UPDATED_SUCCESSFULLY'),(18623,'STR_LAST_CALCULATED'),(18624,'STR_OVERPAYMENT_INVOICE'),(18625,'STR_ONLY_NON_PRELIMABLE'),(18626,'STR_ONLY_PRELIMABLE'),(18627,'STR_DOWNLOAD_ALL_RESULTS'),(18628,'STR_INTEREST_CHARGES'),(18629,'STR_MUST_CANCEL_DEPOSIT_FIRST'),(18630,'STR_ON_BANK_DEPOSIT'),(18631,'STR_UN_NUMBER'),(18632,'STR_THIS_SHIPMENT_PUTS_THE_JOB_OVER_THE_CREDIT_LIMIT'),(18633,'STR_SHIPMENTS_FOR'),(18634,'STR_CANNOT_PRINT_DELETED_ORDER'),(18635,'STR_ALWAYS'),(18636,'STR_BLOCK_ON_ACCOUNT_PAYMENT_METHOD'),(18637,'STR_CUSTOMER_ADD_RESTRICTIONS'),(18638,'STR_FROM_ORDER_ENTRY'),(18639,'STR_LOCK_ALLOW_ORDER_MODIFICATIONS'),(18640,'STR_LOCK_AUTHORIZED_BUYERS'),(18641,'STR_LOCK_BACK_ORDERS'),(18642,'STR_LOCK_BANK_INFO'),(18643,'STR_LOCK_CONTACTS'),(18644,'STR_LOCK_CREDIT_APPLICATION_RECEIVED'),(18645,'STR_LOCK_CUSTOMER_CREDIT'),(18646,'STR_LOCK_DELIVERY_SALES_ONLY'),(18647,'STR_LOCK_EXEMPT_DELIVERY_CHARGE'),(18648,'STR_LOCK_EXEMPT_FUEL_CHARGE'),(18649,'STR_LOCK_GENERAL'),(18650,'STR_LOCK_INVOICE_TERMS'),(18651,'STR_LOCK_JOB_NUMBER_REQUIRED'),(18652,'STR_LOCK_OK_TOOLS_ON_JOB_ACCOUNTS'),(18653,'STR_LOCK_OK_TO_SHIP_IF_INCOMPLETE_JOB_INFO'),(18654,'STR_LOCK_ORDER_FROM'),(18655,'STR_LOCK_PAYMENT'),(18656,'STR_LOCK_PAY_TO'),(18657,'STR_LOCK_PRELIM_JOB_SALES'),(18658,'STR_LOCK_PRICE_LEVEL'),(18659,'STR_LOCK_SALES_GL'),(18660,'STR_LOCK_SALES_PERSON'),(18661,'STR_LOCK_SALES_REP'),(18662,'STR_LOCK_SHOW_PRICES_ON_DELIVERY_CONFIRMATION'),(18663,'STR_LOCK_SPECIAL_PRICING'),(18664,'STR_LOCK_VENDOR_TERMS'),(18665,'STR_VENDOR_EDIT_RESTRICTIONS'),(18666,'STR_ADD_DIRECT_CASH_PAYMENT_TYPES'),(18667,'STR_NO_DIRECT_CASH_PAYMENT_TYPES_EXIST'),(18668,'STR_CLICK_HERE_TO_VIEW_INSTEAD'),(18669,'STR_EDITING_NON_DIRECT_GL_ENTRIES_IS_FORBIDDEN_BY_COMPANY_CONFIGURATION'),(18670,'STR_SHOW_PRICES_ON_PACKING_SLIP'),(18671,'STR_UPDATE_EXISTING_CUSTOMER_RECORD_WHEN_CUSTOMER_CODE_MATCHES'),(18672,'STR_INTERNAL_BUYING_NOTES'),(18673,'STR_INTERNAL_SELLING_NOTES'),(18674,'STR_NUMBER_OF_MONTHS_TO_EXPIRE'),(18675,'STR_FOR_PERIOD'),(18676,'STR_HAZARDOUS_MATERIALS'),(18677,'STR_VENDOR_REQUIRED_FOR_NON_STOCK_ITEMS'),(18678,'STR_NEXT_PAGE'),(18679,'STR_PREVIOUS_PAGE'),(18680,'STR_RECEIPT_LINE_ID'),(18681,'STR_SHOW_ONLY_RECEIPTS_NOT_PASSED_TO_AP'),(18682,'STR_PO_LINE_NOTE'),(18683,'STR_RECEIVING_NOTES'),(18684,'STR_ADD_MISC_GL_ENTRY'),(18685,'STR_FOR_MISC_ENTRY_NUM'),(18686,'STR_CANNOT_CREATE_PO_FOR_ITEM'),(18687,'STR_JOB_CREDIT_LIMIT'),(18688,'STR_JOB_IS_OVER_CREDIT_LIMIT'),(18689,'STR_NOT_ALLOWED_TO_SELECT_PRICE_LEVEL'),(18690,'STR_NO_VENDOR'),(18691,'STR_PRICE_IS_BELOW_MINIMUM_ALLOWED'),(18692,'STR_UNCHECK_CREATE_PO_OR_EDIT_ITEMS_TO_PROCEED'),(18693,'STR_RESTRICTED'),(18694,'STR_YOU_MUST_SET_A_GL_ACCOUNT_FOR_THIS_CHECKING_ACCOUNT'),(18695,'STR_CANNOT_CREATE_DEPOSIT_FOR_BOTH_CASH_AND_CC_AT_SAME_TIME'),(18696,'STR_CHECKING_ACCOUNT_MUST_HAVE_A_LEDGER_ACCOUNT_ASSIGNED'),(18697,'STR_CUSTOMER_CREDIT_LIMIT'),(18698,'STR_CANNOT_SET_TO_MINIMUM_PRICE_LEVEL_AND_NOT_ALLOWED_TO_REQUEST_PRICE_OVERRIDES'),(18699,'STR_CANNOT_SET_TO_MINIMUM_PRICE_LEVEL_BUT_CAN_REQUEST_PRICE_OVERRIDES'),(18700,'STR_CAN_SET_BELOW_MINIMUM_PRICE_LEVEL_ON_ALL_ORDERS_AND_APPROVE_BELOW_MINIMUM'),(18701,'STR_CAN_SET_TO_MINIMUM_PRICE_LEVEL_ON_ALL_ORDERS_APPROVE_TO_MINIMUM_AND_REQUEST_BELOW'),(18702,'STR_CAN_SET_TO_MINIMUM_PRICE_LEVEL_ON_OWN_ORDERS_AND_REQUEST_BELOW'),(18703,'STR_FOPOS_PRICE_OVERRIDES'),(18704,'STR_MAXIMUM_WRITE_OFF_ALLOWED'),(18705,'STR_MAXIMUM_WRITE_OFF_PERCENTAGE'),(18706,'STR_USE_COMPANY_WRITE_OFF_SETTINGS'),(18707,'STR_AMERICAN_EXPRESS'),(18708,'STR_CREATE_SEPARATE_DEPOSITS_FOR_THESE_CC_TYPES'),(18709,'STR_DAILY_CLOSE_BANK_DEPOSIT'),(18710,'STR_DISCOVER'),(18711,'STR_MASTER_CARD'),(18712,'STR_VISA'),(18713,'STR_ALLOW_USER_SUBSTITUTE_REPLY_TO'),(18714,'STR_CREATED_TAX_ADJUSTMENT'),(18715,'STR_GENERATE_CUSTOMER_STATEMENTS'),(18716,'STR_QUANTITY_BACK_ORDERED'),(18717,'STR_IMAGEMAGIC_VERSION_SHOULD_MATCH_PHP_EXTENSION_VERSION'),(18718,'STR_PRICE_ADJUSTMENT_CREDITS'),(18719,'STR_MASTERCARD'),(18720,'STR_DAYS_WITH_OPENINGS_ARE_HIGHLIGHTED'),(18721,'STR_IF_YOU_WOULD_LIKE_TO_SELECT_A_DIFFERENT_SERVICE_PLEASE_CHANGE_YOUR_SELECTION_ABOVE'),(18722,'STR_NO_AVAILABLE_APPOINTMENTS_FOR_THE_SELECTED_SERVICE'),(18723,'STR_PLEASE_SELECT_ANOTHER_DATE_USING_THE_CALENDAR_ABOVE'),(18724,'STR_PLEASE_SELECT_ANOTHER_DATE_USING_THE_CALENDAR_ON_THE_LEFT'),(18725,'STR_CONVERT_TO_SALE___DAMAGED'),(18726,'STR_NO_UNBILLIED'),(18727,'STR_2ND_TRUCK_NEEDED'),(18728,'STR_FINAL_PICKUP'),(18729,'STR_OFF_RENT_DATE'),(18730,'STR_PARTIAL_PICKUP'),(18731,'STR_QTY_RENTED'),(18732,'STR_RECORD_ALREADY_EXISTS'),(18733,'STR_EXACT_ITEM_CODE_REQUIRED'),(18734,'STR_ITEM_COUNT_STATUS'),(18735,'STR_PENDING_COUNT'),(18736,'STR_ATTACH_FILES'),(18737,'STR_ALL_UNITS_ARE_IN_POINTS'),(18738,'STR_BOTTOM'),(18739,'STR_PAGE_HEIGHT'),(18740,'STR_PAGE_MARGIN'),(18741,'STR_PAGE_WIDTH'),(18742,'STR_PRINT_ONE_QR_CODE_PER_LINE'),(18743,'STR_QR_CODE_PADDING'),(18744,'STR_QR_PRINTER_SETUP'),(18745,'STR_RIGHT'),(18746,'STR_SET_AS_0_FOR_CONTINUOUS_FEED'),(18747,'STR_COUNT_ADJUSTMENT'),(18748,'STR_CYCLE_COUNT_VARIANCE'),(18749,'STR_DAMAGED_MATERIAL'),(18750,'STR_EXPIRED_MATERIAL'),(18751,'STR_TRANSFER_VARIANCE'),(18752,'STR_TAX_ADJUSTMENTS_NOT_SHOWN_IN_TOTAL'),(18753,'STR_BIN_CODE_MISSING'),(18754,'STR_DELETE_FROM_THIS_BIN'),(18755,'STR_KEEP_IN_THIS_BIN'),(18756,'STR_PRIMARY'),(18757,'STR_UNKNOWN_ZONE'),(18758,'STR_INTERNAL_BUYER_NOTE'),(18759,'STR_PRINT_PROOF_OF_DELIVER'),(18760,'STR_YOU_MUST_ATTACH_A_FILE_BEFORE_SAVING'),(18761,'STR_QR_CODE'),(18762,'STR_ALLOW_ON_POS'),(18763,'STR_NEXT_JOB_CODE'),(18764,'STR_READ_ONLY_INVENTORY_LOCATION_ON_PAYMENT_PAGE'),(18765,'STR_RENTAL_CONTRACT_TEXT'),(18766,'STR_SHOW_INVOICE_PAGE_FOOTER_TEXT_ON_PACKING_SLIP'),(18767,'STR_HIDE_THIS_OPTION_WHEN_CREATING_A_NEW_CUSTOMER_FROM_POS'),(18768,'STR_EMAIL_NEW_ITEM_NOTICES_TO'),(18769,'STR_SHOW_BARCODE_POPUP_AFTER_CREATING_A_NEW_ITEM'),(18770,'STR_STOCK_TYPE_ITEMS_ONLY'),(18771,'STR_RENTAL_PACKING_SLIP'),(18772,'STR_INTERNAL_SALES_NOTE'),(18773,'STR_HIDE_BANK_INSURANCE_ARCHITECT_SECTION'),(18774,'STR_HIDE_INVOICING_SECTION'),(18775,'STR_JOB_ADD_RESTRICTIONS'),(18776,'STR_BUYER'),(18777,'STR_MUST_HAVE_BUYER_USER_RIGHT'),(18778,'STR_DUPLICATE_ITEM_CODE_FOUND'),(18779,'STR_ERROR_CHECKING_FOR_DUPLICATE_ITEM_CODES'),(18780,'STR_FOUND_A_VENDOR_PRODUCT_CODE_THAT_MATCHES_THIS_ITEM_CODE'),(18781,'STR_VENDOR_PRODUCT'),(18782,'STR_CLICK_FOR_INTERNAL_SALES_NOTE'),(18783,'STR_YOU_DO_NOT_HAVE_RIGHTS_TO_ADD_STOCK_ITEMS_TO_POS'),(18784,'STR_PRINT_QR_CODE'),(18785,'STR_CLEAR'),(18786,'STR_APPLIES_TO_POS_AND_PICKUP'),(18787,'STR_BLOCK_ACCESS_TO_EDIT_ITEMS_BIN_LOCATION'),(18788,'STR_BLOCK_EDITING_OF_CUSTOMER_VENDOR_AND_ITEM_CODES'),(18789,'STR_CANNOT_CREATE_NEW_STOCK_ITEMS'),(18790,'STR_CANNOT_CREATE_POS_FOR_STOCK_ITEMS'),(18791,'STR_EXPECT_FOR_NON_STOCK_ITEMS'),(18792,'STR_HIDE_ORDER_PROFIT'),(18793,'STR_USER_IS_A_BUYER'),(18794,'STR_EXPIRE_DAYS'),(18795,'STR_BLOCK_ACCESS_TO_EDIT_ITEM_BIN_LOCATIONS'),(18796,'STR_EXCEPT_FOR_NON_STOCK_ITEMS'),(18797,'STR_DAILY_SALES_REPORT'),(18798,'STR_FINAL_RETURN_CREDIT_FOR_THIS_ITEM_FROM_ORDER'),(18799,'STR_INVOICE_LINE_NOTE'),(18800,'STR_ORIGINAL_PERIODS'),(18801,'STR_PERIODS_ADJUSTED'),(18802,'STR_SALES_MARGIN'),(18803,'STR_CHECK_CC_PROCESSOR_SETTINGS'),(18804,'STR_SOURCE_KEY_NOT_FOUND'),(18805,'STR_ARE_YOU_SURE_YOU_WANT_TO_MARK_THEM_ALL_AS_SHIPPED'),(18806,'STR_THERE_ARE_MULIPLE_TRANSFERS'),(18807,'STR_COST_OF_SALES'),(18808,'STR_MINIMUM_SALES_CRITERIA_VALUE'),(18809,'STR_PERIOD_TO_MONITOR'),(18810,'STR_SALES_CRITERIA'),(18811,'STR_BARCODE_MASS_PRINT'),(18812,'STR_TOTAL_AMOUNT_TO_COLLECT'),(18813,'STR_INTRODUCTION'),(18814,'STR_INTRODUCTORY_SERVICE'),(18815,'STR_NOTE_NOT_SAVED'),(18816,'STR_SERVER_ERROR'),(18817,'STR_CLEAR_QUEUE'),(18818,'STR_DELETE_ROW'),(18819,'STR_PRINT_QUEUE'),(18820,'STR_SELECT_ITEMS_FOR_BARCODE_PRINT'),(18821,'STR_BLOCK_RENTAL_CREDIT_FOR_FIRST_PERIOD'),(18822,'STR_DEFAULT_DAYS_IN_THE_FUTURE'),(18823,'STR_DEFAULT_PRELIM_REQUEST_SEARCH_MIN_OPEN_AMOUNT'),(18824,'STR_MAX_DAYS_IN_THE_FUTURE'),(18825,'STR_SET_0_FOR_NO_LIMIT'),(18826,'STR_VOID_CREDIT'),(18827,'STR_THIS_QUOTE_HAS_EXPIRED'),(18828,'STR_EXEMPT_PERCENT'),(18829,'STR_CANNOT_CREATE_PURCHASE_ORDERS_FOR_STOCK_ITEMS'),(18830,'STR_EMAIL_THIS_USER_A_DAILY_LIST_OF_SALES'),(18831,'STR_ONLY_EMAIL_INVOICES_WITH_A_SALES_MARGIN_UNDER'),(18832,'STR_THIS_VALUE_NEEDS_SAVED'),(18833,'STR_THERE_ARE_MULTIPLE_TRANSFERS'),(18834,'STR_FINAL_RETURN_INVOICE_FOR_THIS_ITEM_FROM_ORDER'),(18835,'STR_ALL_RETURNED'),(18836,'STR_ASSIGN_BY_ZONE'),(18837,'STR_LIST_INVOICES'),(18838,'STR_PAYMENT_PLAN_INVOICES'),(18839,'STR_WHICH_PERIOD'),(18840,'STR_PHP_IS_MISSING_IMAGICK_EXTENSION'),(18841,'STR_RECEIVED_PURCHASE_ORDER'),(18842,'STR_PRINT_SELECTION'),(18843,'STR_CAN_ONLY_PURCHASE_FROM_ASSIGNED_VENDORS'),(18844,'STR_IF_PRICING_IS_UPDATED_THE_QUOTE_CAN_BE_UNLOCKED'),(18845,'STR_LOCK_EXPIRED_QUOTES'),(18846,'STR_PREVENTS_CONVERSION_TO_ORDER__SAVING_AND_CHANGES_TO_EXPIRES_DATE'),(18847,'STR_LOGIN_FAILURES_UNTIL_BAN'),(18848,'STR_CHECK_VENDORS_PAYMENT_TYPES_ALLOWED'),(18849,'STR_YOU_MUST_ENTER_A_DATE_OF_INVOICE'),(18850,'STR_YOU_MUST_ENTER_A_VENDOR'),(18851,'STR_IF_A_RENTAL_INVOICE'),(18852,'STR_NUMBER_OF_RENTAL_PERIODS'),(18853,'STR_RENTAL_PERIOD_BEGIN_DATE_FOR_THE_PERIOD_BEING_INVOICED'),(18854,'STR_ERROR_CHECKING_FOR_DUPLICATE_VENDOR_CODES'),(18855,'STR_NUMBER_PER_PURCHASE_UNIT'),(18856,'STR_UP_TO_THIS_QUANITITY_OF_PURCHASE_UNITS'),(18857,'STR_VENDOR_PRODUCT_CODE_ALREADY_EXISTS_FOR_ITEM'),(18858,'STR_APPLY_TO_ALL_INVENTORY_LOCATIONS'),(18859,'STR_CREATE_RETURN_PO_FOR_DAMAGED_ITEMS'),(18860,'STR_ITEM_UNRECEIVE'),(18861,'STR_QUANTITY_DAMAGED'),(18862,'STR_SHOW_ONLY_RECEIPTS_WITH_DAMAGED_ITEMS'),(18863,'STR_CANNOT_MARK_COMPLETE'),(18864,'STR_PO_TOTAL_DOES_NOT_MATCH_PREPAID_BY_CC_TOTAL'),(18865,'STR_ASSIGN_NOW'),(18866,'STR_ITEM_NOT_FOUND_BY_ID'),(18867,'STR_MUST_BE_ASSIGNED_TO_VENDOR'),(18868,'STR_SKIPPING_VENDOR_UPDATE'),(18869,'STR_THE_TOTAL_PAYMENT_MUST_EQUAL_THE_PO_TOTAL'),(18870,'STR_YOU_MUST_SAVE_TO_APPLY_THIS_SETTING'),(18871,'STR_PURCHASE_ORDER_NOTES'),(18872,'STR_TRANFER_NOTES'),(18873,'STR_EMAIL_THIS_USER_WHEN_A_PURCHASE_ORDER_CREATED_BY_THIS_USER_IS_RECEIVED'),(18874,'STR_LAST_CHANGED_BY'),(18875,'STR_UP_TO_THIS_QUANTITY_OF_PURCHASE_UNITS'),(18876,'STR_TRANSFER_NOTES'),(18877,'STR_PAYMENT_NOTE'),(18878,'STR_PAYMENT_NOTE_FOR_INVOICE'),(18879,'STR_ERROR_MAKING_SUB_DIRECTORY_TO_SAVE_UPLOADED_FILE_TO_DISK'),(18880,'STR_ERROR_SAVING_UPLOADED_FILE_TO_DISK'),(18881,'STR_ERROR_SETTING_UP_FILE_UPLOAD_DISK_STORAGE'),(18882,'STR_REVERTING_TO_DATABASE_STORAGE'),(18883,'STR_SAVING_FILE_TO_DATABASE_INSTEAD'),(18884,'STR_UNABLE_TO_CREATE_DIRECTORY'),(18885,'STR_CC_ACCOUNT'),(18886,'STR_CHECKING_ACCOUNT_IS_ASSIGNED_TO_A_GL_ACCOUNT_WITH_NO_COSTCODES_ALLOWED'),(18887,'STR_THIS_GL_ACCOUNT_IS_USED_BY_A_CC_ACCOUNT'),(18888,'STR_CONTINUED_BILLING'),(18889,'STR_CONTINUED_RENTALS'),(18890,'STR_HIDE_CUSTOMER_SUB_TOTALS'),(18891,'STR_INCLUDE_NON_STOCK_RENTALS'),(18892,'STR_NEVER_BILLED_BEFORE'),(18893,'STR_RENTAL_BILLING_TYPE'),(18894,'STR_SHOW_PO_NUMBER'),(18895,'STR_AMOUNT_APPLIED'),(18896,'STR_COST_CODE_MUST_BE_CONSISTENT_FOR_ALL_LINES_OF_SAME_PAYMENT'),(18897,'STR_SHIPMENTS_TABLE'),(18898,'STR_OVER_CREDIT_LIMIT'),(18899,'STR_UNSET'),(18900,'STR_EMPLOYEE_FILTERS'),(18901,'STR_SICK_AND_VACATION_LIABILITY'),(18902,'STR_ERROR_SAVING_FILE_TO_DISK'),(18903,'STR_FINISHED_CONVERTING_FILES'),(18904,'STR_NO_RECORDS_TO_UPDATE'),(18905,'STR_BLOCK_POSTING'),(18906,'STR_STANDARD_SUMMARIZATION'),(18907,'STR_ADDED_WHEN_RECEIVING'),(18908,'STR_CANNOT_ADD_ITEM_TO_COUNT'),(18909,'STR_INVENTORY_COUNT_ID'),(18910,'STR_FIRST_SALE'),(18911,'STR_INCLUDE_NUMBER_OF_MONTHS_FOR_SALES_AVERAGES'),(18912,'STR_ITEMS_BY_BUYER'),(18913,'STR_LAST_RECEIVED_DATE'),(18914,'STR_LAST_SALE_DATE'),(18915,'STR_REPORT_ON_ONLY_DEFAULT_VENDOR_FOR_ITEMS'),(18916,'STR_SALES_AVERAGE'),(18917,'STR_SHOW_ONLY_ITEMS_WITH_A_NEGATIVE_AVAILABLE_COUNT'),(18918,'STR_VENDOR_ITEM_CODE'),(18919,'STR_DONT_SHOW_NON_PRELIMED_JOBS'),(18920,'STR_ONLY_SHOW_JOBS_OVER_X_DAYS_SINCE_1ST_SALE'),(18921,'STR_GENERATE_INVOICES_FOR_RENTALS'),(18922,'STR_VIEW_ACOUNT_ACTIVITY'),(18923,'STR_CREDIT_CARDS_GL_SUMMARY'),(18924,'STR_RECORDS'),(18925,'STR_ITEM_DOESNT_MATCH_THIS_INVENTORY_COUNTS_FILTERS'),(18926,'STR_CLICK_TO_OPEN_FILES'),(18927,'STR_CLICK_TO_OPEN_HISTORY'),(18928,'STR_PATIENT_FILES'),(18929,'STR_PATIENT_HISTORY'),(18930,'STR_ALWAYS_USE_LAST_COST_AND_NOT_VENDOR_PRICING'),(18931,'STR_PO_ENTRY_HIDE_GL_ACCOUNT_FIELD'),(18932,'STR_ALLOW_ANY_ACCOUNT_TYPE_FOR_PAYMENT_PLAN_SALES_ACCOUNT'),(18933,'STR_BLOCK_NOT_FOR_SALE_ITEM_SELECTION_ON_ORDERS'),(18934,'STR_DEFAULT_EMAIL_CENTER_TO_PRIVATE_EMAILS'),(18935,'STR_DEFAULT_ITEM_COSTS_ON_ORDERS_TO_STATIC_COST_BUT_OVERRIDE_DURING_SHIPPING'),(18936,'STR_LOCK_JOB_CODES'),(18937,'STR_LOWEST_PRICE_OVERRIDE_LEVEL_FOR_QUOTES'),(18938,'STR_ORDERS_MUST_HAVE_A_SHIP_TO_CITY_AND_ZIP_SET'),(18939,'STR_USERS_WITH_OVERRIDE_LEVELS_BELOW_THIS_WILL_BE_UPGRADED_TO_THIS_LEVEL_FOR_QUOTES_MINUS_APPROVAL_ABILITY'),(18940,'STR_ARE_YOU_SURE_YOU_WANT_TO_SEND_A_GROUP_EMAIL_INSTEAD_OF_PRIVATE'),(18941,'STR_CONFIRMATION_REQUIRED'),(18942,'STR_IGNORE_SPACES_IN_ITEM_SEARCH_BOX'),(18943,'STR_REQUIRE_CATEGORY_FOR_NEW_ITEMS'),(18944,'STR_REQUIRE_COMMENTS_ON_ITEM_ADJUSTMENTS'),(18945,'STR_REQUIRE_ITEM_LOCATION_PRICE_FOR_STOCK_ITEMS'),(18946,'STR_REQUIRE_VENDOR_FOR_NEW_ITEMS'),(18947,'STR_ALSO_APPLIES_TO_PASSWORD_RESET_FAILURES'),(18948,'STR_ARE_YOU_SURE_YOU_WANT_TO_PURGE_ALL_PASSWORD_RESET_FAILURES'),(18949,'STR_BEGIN_CONVERTING_FILES'),(18950,'STR_BEGIN_CONVERTING_FILES_AGAIN'),(18951,'STR_CONVERSION_HAS_STARTED'),(18952,'STR_CONVERT_UPLOADED_FILES_FROM_DB_TO_DISK'),(18953,'STR_FILES_WILL_NOT_BE_DELETED_FROM_DB_WHEN_DONE'),(18954,'STR_NUM_FILES_IN_DB'),(18955,'STR_PURGE_PASSWORD_RESET_FAILURES'),(18956,'STR_THIS_ACTION_WILL_ALLOW_FURTHER_PASSWORD_RESET_ATTEMPTS_IMMEDIATELY'),(18957,'STR_HAS_A_BLOCKED_ACCOUNT'),(18958,'STR_ADJUSTMENT_COMMENTS_REQUIRED'),(18959,'STR_DEFAULT_VENDOR_COST_REQUIRED'),(18960,'STR_DEFAULT_VENDOR_REQUIRED'),(18961,'STR_IF_COST_UNKNOWN_REMOVE_VENDOR_TO_PROCEED'),(18962,'STR_COPY_PRICING_TO_ALL_AVAILABLE_LOCATIONS'),(18963,'STR_YOU_MUST_COMPLETE_AT_LEAST_ONE_PRICE_LEVEL'),(18964,'STR_ORIGINAL_COST'),(18965,'STR_ORIGINAL_MARGIN'),(18966,'STR_SHOW_MARGIN'),(18967,'STR_YOU_DO_NOT_HAVE_RIGHTS_TO_ADD_OTHER_CHARGES_ITEMS_TO_POS'),(18968,'STR_BLOCKED_ACCOUNT'),(18969,'STR_WHEN_CONVERTED_TO_ORDER'),(18970,'STR_CANNOT_ADD_EDIT_ITEMS_WITH_INVENTORY_TYPE'),(18971,'STR_CANNOT_CREATE_POS_FOR_OTHER_CHARGES_ITEMS'),(18972,'STR_CANNOT_CREATE_PURCHASE_ORDERS_FOR_OTHER_CHARGES_ITEMS'),(18973,'STR_BLOCK_POSTING_TO_THIS_ACCOUNT'),(18974,'STR_META_MENU'),(18975,'STR_SHIPMENT_META_MENU'),(18976,'STR_DAILY_CLOSE_DRAWER_FLOAT_ACCOUNT'),(18977,'STR_DEFAULT_DEPOSIT_BANK_ACCOUNT'),(18978,'STR_CHECKING_ACCOUNT_IS_ASSIGNED_TO_A_GL_ACCOUNT_WITH_NO_COST_CODES_ALLOWED'),(18979,'STR_PRINT_NEW_STATEMENT'),(18980,'STR_CANNOT_UNPOST_INVOICE_THAT_HAS_RETURNS'),(18981,'STR_CANNOT_UNPOST_PAID_INVOICE'),(18982,'STR_CONVERTED_TO_SALE'),(18983,'STR_FIND_BILL_THROUGH_DATE'),(18984,'STR_LIMIT_GENERATED_BILL_THROUGH_DATE_TO'),(18985,'STR_MIN_BILL_DATE'),(18986,'STR_NO_MATCHING_TAXES_FOUND'),(18987,'STR_PAYMENT_TYPES_BY_COST_CODE'),(18988,'STR_POS_PICK_LIST'),(18989,'STR_RECALCULATE_MISSING_TAXES'),(18990,'STR_RECALCULATE_TAXES'),(18991,'STR_REPORT_BY'),(18992,'STR_SALES_AND_MARGIN_BY_SHIPPING_AND_COST_CODE'),(18993,'STR_SALES_AND_MARGIN_BY_SHIPPING_AND_LOCATION'),(18994,'STR_TAX_EXEMPT'),(18995,'STR_THIS_IS_NOT_A_FILTER'),(18996,'STR_THIS_SETTING_WILL_SET_A_MAX_VALUE_GENERATED_FOR_THE_COLUMN'),(18997,'STR_UNPOST_NOW'),(18998,'STR_ORDER_CONFIRMATION_FOR_ORDER'),(18999,'STR_YOUR_ORDER_CONFIRMATION_IS_ATTACHED_FOR_ORDER'),(19000,'STR_CANNOT_PROCESS_MORE_QTY_THAN_SHIPPED'),(19001,'STR_MINIMUM_BILLING_DATE'),(19002,'STR_NO_RENTAL_PERIOD_SET'),(19003,'STR_QUANITY_REDUCED'),(19004,'STR_RETURN_TO_BRANCH'),(19005,'STR_BACK_ORDER_VALUE'),(19006,'STR_NOT_RETURNED_TO_ON_HAND'),(19007,'STR_RETURNED_TO_ON_HAND'),(19008,'STR_SHIP_TAX'),(19009,'STR_SHIP_VALUE'),(19010,'STR_UNINVOICED_SHIPMENT_TOTALS'),(19011,'STR_BILLTRUST_INVOICE_SEND_LOG'),(19012,'STR_BILLTRUST_SENT'),(19013,'STR_DISABLE_AUTO_INVOICE_SENDING'),(19014,'STR_ENABLE_AUTO_INVOICE_SENDING'),(19015,'STR_FAILED_TO_SEND_FILE_TO_BILLTRUST'),(19016,'STR_INVOICES_SENT_TO_BILLTRUST'),(19017,'STR_INVOICE_LAST_MODIFIED'),(19018,'STR_SEND_STATMENTS_TO_BILLTRUST'),(19019,'STR_TOTALS_ARE_CURRENT_AND_MAY_NOT_REFLECT_VALUES_AT_THE_TIME_OF_SENDING'),(19020,'STR_APPLY_CHANGES'),(19021,'STR_CREATE_NEW_SHIP_TO_WITH_THE_BELOW_VALUES'),(19022,'STR_CURRENT_COMITTED_QTY'),(19023,'STR_CURRENT_SHIP_METHOD'),(19024,'STR_JOB_CREATED_DATE'),(19025,'STR_LEAVE_AS_IS'),(19026,'STR_NEW_ADDRESS'),(19027,'STR_NEW_SHIP_METHOD'),(19028,'STR_NON_PRELIMABLE_JOBS_ASSIGNED_TO_PRELIMABLE_CUSTOMERS'),(19029,'STR_NO_VALUE'),(19030,'STR_ON_TRANSFER_QTY'),(19031,'STR_SET_ITEM_CATEGORY'),(19032,'STR_SHIPPED_OUT'),(19033,'STR_SHIPPING_METHOD_NOT_FOUND'),(19034,'STR_SHIP_TO_NOT_FOUND'),(19035,'STR_TRANSACTION'),(19036,'STR_TRANSACTION_DETAILS'),(19037,'STR_TRANSFER_SPLIT_FROM'),(19038,'STR_UNFULFILLED_ORDER_QTY'),(19039,'STR_WILL_CALL'),(19040,'STR_OVERWRITE'),(19041,'STR_DELETED_TRANFER'),(19042,'STR_DELETE_TRANFER'),(19043,'STR_MULTIPLE_LOCATION'),(19044,'STR_ON_TRANSFER'),(19045,'STR_PICKER_TRANSFER_TO'),(19046,'STR_QTY_COMITTED_BEFORE'),(19047,'STR_QTY_COMITTED_NOW'),(19048,'STR_RESTORED_TRANFER'),(19049,'STR_RESTORE_TRANFER'),(19050,'STR_REVALIDATE_ALL_TRANFER_ITEM_COMITTED_RECORDS'),(19051,'STR_SHIPPER_TRANSFER_TO'),(19052,'STR_TRANSFER_DOES_NOT_CONTAIN_MULITIPLE_ZONES'),(19053,'STR_TRANSFER_NOT_FOUND'),(19054,'STR_CONFIRMED_AS_OK_LEAVING_VARIANCE_AS_ADDITIONAL_STOCK'),(19055,'STR_CONFIRMED_AS_OK_LEAVING_VARIANCE_AS_LOST_STOCK'),(19056,'STR_CONFIRM_AS_OK_LEAVING_VARIANCE_AS_ADDITIONAL_STOCK'),(19057,'STR_CONFIRM_AS_OK_LEAVING_VARIANCE_AS_LOST_STOCK'),(19058,'STR_EXCLUDE_COMPLETED_TRANSFERS'),(19059,'STR_EXCLUDE_ENTRIES_ALREADY_HANDLED'),(19060,'STR_INCREASE_STOCK_QTY_BY_VARIANCE_AT'),(19061,'STR_ONLY_SHOW_ENTRIES_WITH_A_VARIANCE'),(19062,'STR_PICKED_QTY'),(19063,'STR_REDUCED_STOCK_QTY_BY_VARIANCE_AT'),(19064,'STR_REDUCE_STOCK_QTY_BY_VARIANCE_AT'),(19065,'STR_ON_FLOOR'),(19066,'STR_OVERWRITE_ASSIGNED_USER_IF_ALREADY_SET'),(19067,'STR_UNASSIGN'),(19068,'STR_UNASSIGN_USERS'),(19069,'STR_COST_AT_SHIPMENT'),(19070,'STR_COST_METHOD'),(19071,'STR_CURRENT_COST_VALUE'),(19072,'STR_LAST_BILL_DATE'),(19073,'STR_NO_ITEM_ID_ASSIGNED'),(19074,'STR_NO_ITEM_SET'),(19075,'STR_NO_LOCATION_SET'),(19076,'STR_ON_RENT'),(19077,'STR_OUT_ON_RENT_ITEMS_DETAIL'),(19078,'STR_RENTAL_VALUE'),(19079,'STR_RENTAL_VALUE_AT_TIME_OF_SHIPMENT'),(19080,'STR_UNINVOICED_SHIPMENTS_BY_LOCATION'),(19081,'STR_THE_UPLOADED_FILE_EXCEEDS_THE_SERVER_LIMITS'),(19082,'STR_UPLOAD_FAILED'),(19083,'STR_APPLY_TAXES_TO_THIS_CREDIT'),(19084,'STR_SET_LAST_BILLED_DATE'),(19085,'STR_RELATED_VENDOR_BILLS'),(19086,'STR_SET_LAST_COST'),(19087,'STR_SHOW_NEXT_PAGE'),(19088,'STR_THERE_ARE_MORE_PRELIMS_THAT_CAN_BE_SENT'),(19089,'STR_SHIPMENT_HAS_BEEN_INVOICED'),(19090,'STR_SHIPMENT_HAS_BEEN_VOIDED'),(19091,'STR_AUTOMATICALLY_EMAIL_ORDER_CONFIRMATION_WHEN_SHIPPING'),(19092,'STR_BLOCK_NON_STOCK_ITEM_SALES_ON_POS'),(19093,'STR_BLOCK_UNPOSTING_INVOICES_AFTER_INVOICE_DATE'),(19094,'STR_COMBINE_TAXES_TO_ONE_LINE'),(19095,'STR_DEFAULT_CREDIT_CARD_ACCOUNT'),(19096,'STR_DEFAULT_CREDIT_CARD_ACCOUNT_FOR_B2B'),(19097,'STR_DEFAULT_ORDER_CONFIRMATION_EMAIL_TEMPLATE'),(19098,'STR_DEFAULT_QUANTITY_TO_SHIP'),(19099,'STR_DISPLAY_TOTAL_DETAILS_ON_PACKING_SLIP'),(19100,'STR_FORCE_CHECKING_ACCOUNT_FOR_PAYMENTS'),(19101,'STR_INVOICE_UNPOSTING'),(19102,'STR_SHOW_SHIPPING_PREFERENCE_CONFIRMATION_BEFORE_SAVING_ORDER'),(19103,'STR_FEDERAL_TAX_ID_REQUIRED_TO_SAVE'),(19104,'STR_ALL_CREDITS'),(19105,'STR_CREDITS'),(19106,'STR_FIRST_RENTAL_INVOICES'),(19107,'STR_IGNORE_RETURNS'),(19108,'STR_LOOK_AT_VOID_DATE_NOT_INVOICE_DATE'),(19109,'STR_NO_CREDITS'),(19110,'STR_NO_CREDIT_INVOICES'),(19111,'STR_ONLY_CONTINUING_SLASH_ADDITIONAL_RENTAL_INVOICES'),(19112,'STR_ONLY_FIRST_RENTAL_INVOICES'),(19113,'STR_ONLY_RENTAL_INVOICES'),(19114,'STR_OTHER_SHIP_METHOD'),(19115,'STR_USING_VOID_DATE'),(19116,'STR_THIS_INVOICE_IS_PAID'),(19117,'STR_YOU_DO_NOT_HAVE_RIGHTS_TO_PREFORM_THIS_ACTION'),(19118,'STR_ENTRY_DATE_BEGIN'),(19119,'STR_ORDER_APPEARS_TO_BE_COMPLETE_BUT_IS_NOT_MARKED_AS_COMPLETE'),(19120,'STR_ORDER_APPEARS_TO_BE_INCOMPLETE_BUT_IS_MARKED_AS_COMPLETE'),(19121,'STR_SHIPPING_MORE_QTY_THAN_ON_ORDER'),(19122,'STR_SHIPMENT_ADJUSTMENTS'),(19123,'STR_CLEARING_RELEASE_CACHE'),(19124,'STR_DESTROYING_TEMP_TABLES'),(19125,'STR_PHASE'),(19126,'STR_REMOVING_DATABASE_UPDATE_FILE'),(19127,'STR_SPLIT_TRANSFER_BY_ZONE'),(19128,'STR_TRANSFER_COMPLETE'),(19129,'STR_COMPANY_WIDE'),(19130,'STR_LAST_PO_COST'),(19131,'STR_ALL_EXCEPT_DISTRIBUTION_CENTERS'),(19132,'STR_ALL_LOCATIONS_EXCEPT_DISTRIBUTION_CENTERS'),(19133,'STR_ALL_MY_VENDORS'),(19134,'STR_BELOW_MIN'),(19135,'STR_BUYER_NOTES'),(19136,'STR_HIDE_INTERNAL_BUYER_NOTES'),(19137,'STR_INCLUDE_ITEMS_WITH_ZERO_MINIMUM_QUANTITY'),(19138,'STR_INCLUDE_RENTAL_ITEMS'),(19139,'STR_ITEM_BUYER'),(19140,'STR_MAX_LEVEL'),(19141,'STR_MIN_LEVEL'),(19142,'STR_ORDER_TO'),(19143,'STR_AT_LOCATION'),(19144,'STR_COMPANY_AVERAGE'),(19145,'STR_LOCATION_AVERAGE'),(19146,'STR_DO_NOT_UPDATE_LAST_PO_COST'),(19147,'STR_ITEM_TRANSACTION'),(19148,'STR_TRANSFER_IN'),(19149,'STR_TRANSFER_OUT'),(19150,'STR_CANNOT_SWITCH_TO_POS_WITH_NON_STOCK_ITEMS'),(19151,'STR_NON_STOCK_ITEMS_NOT_ALLOWED_ON_POS'),(19152,'STR_SHIPPING_PREFERENCE_FOR_THIS_ORDER'),(19153,'STR_CHECK_INVOICE_FOR_PAYMENT'),(19154,'STR_PAYMENT_MAY_NOT_HAVE_SAVED'),(19155,'STR_CASH_ON_DELIVERY'),(19156,'STR_SHIP_TO_EXEMPTION_ALSO_APPLIES_TO_POS_AND_PICKUP'),(19157,'STR_SAVE_NOT_PERMITTED'),(19158,'STR_SYSTEM_IS_READONLY'),(19159,'STR_CAN_ALWAYS_UNPOST_INVOICES_REGARDLESS_OF_COMPANY_BLOCK_UNPOST_SETTING'),(19160,'STR_QUANTITY_REDUCED'),(19161,'STR_SEND_STATEMENTS_TO_BILLTRUST'),(19162,'STR_CURRENT_COMMITTED_QTY'),(19163,'STR_DELETED_TRANSFER'),(19164,'STR_DELETE_TRANSFER'),(19165,'STR_MULTIPLE_LOCATIONS'),(19166,'STR_QTY_COMMITTED_BEFORE'),(19167,'STR_QTY_COMMITTED_NOW'),(19168,'STR_RESTORED_TRANSFER'),(19169,'STR_RESTORE_TRANSFER'),(19170,'STR_REVALIDATE_ALL_TRANSFER_ITEM_COMMITTED_RECORDS'),(19171,'STR_TRANSFER_DOES_NOT_CONTAIN_MULTIPLE_ZONES'),(19172,'STR_ARCHIVED'),(19173,'STR_CREATED_DATE'),(19174,'STR_EMAILED'),(19175,'STR_EXCLUDE_ZERO_BALANCE_INVOICES'),(19176,'STR_FAX_NEW_STATEMENT'),(19177,'STR_FAX_SENT_TO'),(19178,'STR_GENERATE_NEW_STATEMENT'),(19179,'STR_EXCLUDE_INVOICES_AFTER'),(19180,'STR_HOURLY_INVOICE_ACTIVITY'),(19181,'STR_JOB_PRELIM'),(19182,'STR_PLEASE_SEE_ATTACHED_FILE'),(19183,'STR_CUSTOMER_BILLTRUST_STATEMENTS'),(19184,'STR_SENT_BILLTRUST_STATEMENT_DETAILS'),(19185,'STR_ADD_ITEMS_TO_BIN'),(19186,'STR_ADD_ITEM_TO_BIN'),(19187,'STR_CURRENT_BINS'),(19188,'STR_ITEM_TO_ADD'),(19189,'STR_MAKE_PRIMARY_BIN'),(19190,'STR_NO_BINS_ZONE_OR_LOCATION_SET'),(19191,'STR_NO_NEW_ITEMS_ADDED_YET'),(19192,'STR_WAREHOUSE_BIN_LABELS'),(19193,'STR_COULD_NOT_FIND_ITEM_AT_LOCATION'),(19194,'STR_DATA_NOT_SET'),(19195,'STR_ITEM_ALREADY_EXISTS_AT_THIS_LOCATION_AND_BIN'),(19196,'STR_FROM_LOCATION_ON_HAND_WILL_GO_NEGATIVE_IF_MARKED'),(19197,'STR_NO_ZONE_OR_LOCATION_SET'),(19198,'STR_WAREHOUSE_ZONE_LABELS'),(19199,'STR_JOB_PRELIM_REQUEST_RECEIVED'),(19200,'STR_ONLY_JOBS_WITH_NO_EXISTING_PRELIM_REQUEST_RECEIVED'),(19201,'STR_ONLY_JOBS_WITH_NO_EXISTING_PRELIM_REQUEST_SENT'),(19202,'STR_ONLY_SHOW_JOBS_WITH_OPEN_AMOUNTS_OVER'),(19203,'STR_ONLY_SHOW_JOBS_WITH_PRELIM_AMOUNTS_OVER'),(19204,'STR_INVOICE_DELETED'),(19205,'STR_REPLACEMENT_FOR_INVOICE'),(19206,'STR_RESTOCK_FEE'),(19207,'STR_INTEREST_FOR_INVOICE'),(19208,'STR_INVOICE_PAYMENT_VOID'),(19209,'STR_DEPOSIT_VOID_FOR_ORDER'),(19210,'STR_CANNOT_INVOICE_CANCELED_SHIPMENT'),(19211,'STR_INVOICE_DELETED_BY_USER'),(19212,'STR_RECALCULATING_TAXES'),(19213,'STR_DELETE_INVOICE'),(19214,'STR_EXPLANATION_REQUIRED'),(19215,'STR_REASON_FOR_DELETION'),(19216,'STR_PAYMENT_VOIDED_BY_USER'),(19217,'STR_DEPOSIT_VOIDED_BY_USER'),(19218,'STR_BIN_LABELS'),(19219,'STR_ZONE_LABELS'),(19220,'STR_PRINT_PROOF_OF_DELIVERY'),(19221,'STR_CURRENT_COST'),(19222,'STR_DIFF_FROM_MINIMUM'),(19223,'STR_PERCENT_DIFF_FROM_MINIMUM'),(19224,'STR_EMAIL_ASSOCIATED_ORDER_SALESMAN_ON_RECEIVE'),(19225,'STR_ALLOW_USERS_TO_SET_CUSTOM_RESTOCK_FEE'),(19226,'STR_GROUP_RESTOCK_FEES_AS_A_SINGLE_INVOICE_LINE'),(19227,'STR_RESTOCK_FEE_IS_TAXED'),(19228,'STR_THIS_IS_THE_DEFAULT_CONDITION'),(19229,'STR_B2B_PAYMENT_LOCATION'),(19230,'STR_CREATE_NEW_INTEREST_INVOICE_FOR_EACH_CUSTOMER'),(19231,'STR_CREATE_NEW_INTEREST_INVOICE_FOR_EACH_INVOICE'),(19232,'STR_DEFAULT_JOB_SHIPPING_METHOD'),(19233,'STR_FULFILLMENT_ORDER_SHIP_TO_ADDRESSES_REQUIRES_CITY_STATE_AND_ZIP'),(19234,'STR_HIDE_POS_PRINT_INVOICE_BUTTON'),(19235,'STR_HIDE_POS_PRINT_OPTIONS_UNTIL_AFTER_PAYMENT'),(19236,'STR_JOB_CREDIT_LIMIT_DEFAULT'),(19237,'STR_ONLY_CHARGE_INTEREST_TO_CUSTOMERS_WITH_A_BALANCE_OVER'),(19238,'STR_RELOAD_PRICES_WHEN_SALES_LOCATION_CHANGES'),(19239,'STR_REQUIRE_EXPLANATION_TO_DELETE_ORDERS_INVOICES_AND_PAYMENTS'),(19240,'STR_REQUIRE_SHIPPING_PREFERENCE'),(19241,'STR_SHOW_EXTRA_VALUE_SUMMARY_ON_ORDER_CONFIRMATION'),(19242,'STR_STATEMENT_HEADER_EMAIL'),(19243,'STR_USE_COMPANY_DEFAULT'),(19244,'STR_USE_CUSTOMER_DEFAULT'),(19245,'STR_INTERCOMPANY_ITEM_TRANSFERS_BLOCK_EDIT_ONCE_ASSIGNED'),(19246,'STR_BEGIN_TRANSACTION_DATE'),(19247,'STR_CASH_PAYMENTS'),(19248,'STR_CHECK_PAYMENTS'),(19249,'STR_DEPOSIT_INFO'),(19250,'STR_END_TRANSACTION_DATE'),(19251,'STR_HIDE_CASH_PAYMENTS'),(19252,'STR_LOCK_BEGIN_AND_END_DATES'),(19253,'STR_OTHER_PAYMENTS'),(19254,'STR_MULTIPLIED_BY_A_MONTHLY_RATE_OF'),(19255,'STR_ONLY_ONE_A_SINGLE_MONTH_WILL_BE_CHARGED'),(19256,'STR_SKIP_PREVIOUS_MONTHS_INTEREST_CHARGES'),(19257,'STR_VOID_REASON'),(19258,'STR_VOID_REASON_REQUIRED'),(19259,'STR_FLAT_FEE'),(19260,'STR_PERCENTAGE'),(19261,'STR_RECENTAGE'),(19262,'STR_RESTOCK_FEE_METHOD'),(19263,'STR_SET_ALL_RESTOCK_FEE_DETAILS'),(19264,'STR_CALCULATING'),(19265,'STR_NO_FAX'),(19266,'STR_SEND_CUSTOMER_STATEMENTS'),(19267,'STR_DELETE_REASON'),(19268,'STR_YOU_DO_NOT_HAVE_RIGHTS_TO_PERFORM_THIS_ACTION'),(19269,'STR_SHIPMENT_IS_CANCELED'),(19270,'STR_ASSIGN_ACCOUNT_TO_THIS_COMPANY'),(19271,'STR_CHANGES_REQUIRED'),(19272,'STR_COST_CENTERS_CANNOT_BE_USED_WITH_GL_ACCOUNTS_FOR_ALL_COMPANIES'),(19273,'STR_CREATE_NEW_ACCOUNT'),(19274,'STR_REMOVE_COST_CENTER'),(19275,'STR_FROM_AND_TO_LOCATIONS_CANNOT_BE_THE_SAME'),(19276,'STR_YOU_MUST_SELECT_A_FROM_LOCATION'),(19277,'STR_YOU_MUST_SELECT_A_TO_LOCATION'),(19278,'STR_YOUR_USER_DOES_NOT_HAVE_RIGHTS_TO_CREATE_STOCK_ITEMS'),(19279,'STR_MISSING_SHIP_TO'),(19280,'STR_DEFAULT_TO'),(19281,'STR_PREFERRED_STATEMENT_NOTIFICATION_METHOD'),(19282,'STR_FULFILLMENT_ORDER_SHIP_TO_ADDRESSES_REQUIRE_CITY_STATE_AND_ZIP'),(19283,'STR_ONLY_ONE_MONTH_WILL_BE_CHARGED'),(19284,'STR_ASSIGNED_INVOICE_TERMS'),(19285,'STR_EXPECTED_VALUES'),(19286,'STR_FIND_MISMATCHED'),(19287,'STR_INVOICES_WITH_TERMS_NOT_MATCHING_CUSTOMER'),(19288,'STR_UNINCORPORATED_AREA'),(19289,'STR_ID_NOT_FOUND'),(19290,'STR_MASS_SHIP'),(19291,'STR_TRANSFERS_SHIPPED'),(19292,'STR_COUNTED_COGS'),(19293,'STR_ENTRIES_COUNTED'),(19294,'STR_ENTRIES_PENDING_REVIEW'),(19295,'STR_ON_HAND_COGS'),(19296,'STR_TOTAL_ENTRIES'),(19297,'STR_VIEW_ACTIVE_COUNTS'),(19298,'STR_INCLUDE_MESSAGE'),(19299,'STR_BINS'),(19300,'STR_SPLIT_TRANSFERS_BY_ZONE'),(19301,'STR_TRANSFER_IDS'),(19302,'STR_NO_BIN_ASSIGNED'),(19303,'STR_DONT_SHIP_SLASH_NEXT'),(19304,'STR_SHIP_SLASH_NEXT'),(19305,'STR_HIDE_PAYMENT_TERMS_ON_ORDER_CONFIRMATION'),(19306,'STR_SHOW_INVOICE_TERMS_ON_ORDER_CONFIRMATION'),(19307,'STR_MONTHLY_FINANCE_CHARGE'),(19308,'STR_CANNOT_CREATE_A_RETURN_AGAINST_INTEREST_INVOICE'),(19309,'STR_PRINT_STATEMENTS_THAT_WOULD_BE_SENT_TO_BILLTRUST'),(19310,'STR_ONLY_INTEREST_INVOICES'),(19311,'STR_ADD_PENSION_PLAN'),(19312,'STR_PLAN_NUM'),(19313,'STR_CALI_PROP_65_NOTICE'),(19314,'STR_PAYMENT_DETAILS'),(19315,'STR_PAYMNET'),(19316,'STR_REF_NUM'),(19317,'STR_BLOCK'),(19318,'STR_PAGE_CUSTOMIZER'),(19319,'STR_PHOHE'),(19320,'STR_PICKER_NOTES'),(19321,'STR_SHOW_INVOICE_TERMS'),(19322,'STR_BASED_ON_TERRITORY'),(19323,'STR_CALCULATE_SALES_METHOD'),(19324,'STR_CHANGES_IN_SALES'),(19325,'STR_CREDIT_ALLOWED_CUSTOMERS'),(19326,'STR_CUSTOMER_TAX_DETAILS'),(19327,'STR_DECREASE_IN_SALES'),(19328,'STR_DEFAULT_TAX_EXEMPTION'),(19329,'STR_INCREASE_IN_SALES'),(19330,'STR_PRIOR_12345_MONTHS_OF_SALES'),(19331,'STR_RECENT_12345_MONTHS_OF_SALES'),(19332,'STR_REPORT_ON'),(19333,'STR_SALES_CHANGES_ANALYSIS'),(19334,'STR_SALES_DIFFERENCE_PERIOD'),(19335,'STR_SALES_DOLLARS'),(19336,'STR_SALES_TAX_1_DISTRICT'),(19337,'STR_SHIP_TO_TAX_EXEMPTION'),(19338,'STR_SHOW_RECORDS_WITH_A_DIFFERENCE'),(19339,'STR_EVENT_LOG'),(19340,'STR_EVENT_REF'),(19341,'STR_EVENT_TABLE'),(19342,'STR_LABEL_SIZE'),(19343,'STR_PRINT_ITEM_BARCODES'),(19344,'STR_PRINT_ITEM_LIST'),(19345,'STR_SERIAL_NUMBERS'),(19346,'STR_SN'),(19347,'STR_CURRENT_ON_FLOOR'),(19348,'STR_POST_ALL_ON_HAND_ADJUSTMENTS'),(19349,'STR_PRINT_VARIANCES'),(19350,'STR_RECOUNT'),(19351,'STR_RECOUNT_ALL_VARIANCES'),(19352,'STR_SAVE_SELECTED'),(19353,'STR_ZONE_OR_BIN'),(19354,'STR_NO_NOTES'),(19355,'STR_ON_PURCHASE_ORDER'),(19356,'STR_SHOW_ITEM_SUBTOTALS'),(19357,'STR_EXCESS'),(19358,'STR_EXCESS_QTY'),(19359,'STR_EXCESS_TOTAL'),(19360,'STR_EXCLUDE_RENTALS'),(19361,'STR_INCLUDE_RENTALS'),(19362,'STR_LAST_SOLD'),(19363,'STR_ONLY_ITEMS_WITH_A_SELF_LIFE'),(19364,'STR_OVERSTOCK_REPORT'),(19365,'STR_SHOW_AVG_SALES_SINCE'),(19366,'STR_SHOW_ONLY_RENTALS'),(19367,'STR_NO_CUSTOMER_OR_JOB_SELECTED'),(19368,'STR_PRICING_WILL_APPLY_TO_ALL'),(19369,'STR_CUSTOMER_TAX_SETUP_REPORT'),(19370,'STR_MANAGE_TERRITORIES'),(19371,'STR_OVERSTOCK'),(19372,'STR_ADD_TERRITORY_TO_REGION'),(19373,'STR_COULD_NOT_FIND_TERRITORY_REGION'),(19374,'STR_CURRENT_REGION'),(19375,'STR_DELETE_EXISTING_DATA'),(19376,'STR_ERROR_ADDING_TERRITORY'),(19377,'STR_NEW_TERRITORIES'),(19378,'STR_NO_NEW_TERRITORIES_ADDED_YET'),(19379,'STR_NO_TERRITORY_SET'),(19380,'STR_REGION_TERRITORIES'),(19381,'STR_TERRITORY_ADDED_SUCCESSFULLY'),(19382,'STR_TERRITORY_ALREADY_ASSIGNED_TO_THIS_REGION'),(19383,'STR_TERRITORY_TO_ADD'),(19384,'STR_INTEREST_PAYMENT'),(19385,'STR_NON_INTEREST_PAYMENT'),(19386,'STR_IN_ADVANCE_RENTALS_WILL_BILL_FULL_PERIOD'),(19387,'STR_KEY'),(19388,'STR_EDIT_PICKED_QTY'),(19389,'STR_QTY_PICKED'),(19390,'STR_ENTER_SERIAL_NUMBER'),(19391,'STR_NO_BINS_FOUND'),(19392,'STR_BARCODE_FORMAT'),(19393,'STR_BARCODE_PRINTER'),(19394,'STR_PRINT_MODE'),(19395,'STR_STANDARD_PRINTER'),(19396,'STR_SET_NEW_MAXIMUM'),(19397,'STR_SET_NEW_MINIMUM'),(19398,'STR_DELETE_FROM_THIS_REGION'),(19399,'STR_KEEP_IN_THIS_REGION'),(19400,'STR_ZIPCODE'),(19401,'STR_SET'),(19402,'STR_SET_ZIPCODE'),(19403,'STR_VERIFYING_ADDRESS'),(19404,'STR_VERIFYING_SHIP_TO_ADDRESS'),(19405,'STR_DEFAULT_ALLOW_ORDER_MODIFICATIONS'),(19406,'STR_DEFAULT_NO_CREDIT_ALLOWED_TERMS'),(19407,'STR_DEFAULT_SHOW_PRICES_ON_DELIVERY_CONFIRMATION'),(19408,'STR_DEFAULT_SHOW_PRICES_ON_PACKING_SLIP'),(19409,'STR_DISPLAY_UNIT_OF_MEASURE'),(19410,'STR_EXCLUDE_PREVIOUSLY_SHIPPED_ITEMS_FROM_PACKING_SLIP'),(19411,'STR_HIDE_LINE_NUMBER_ON_ORDER_CONFIRMATION'),(19412,'STR_NOTIFY_SALES_PERSON_FOR_NEW_CUSTOMERS_WITH_CREDIT'),(19413,'STR_NOTIFY_SALES_PERSON_FOR_NEW_JOBS'),(19414,'STR_SEND_EMAIL_TO_ADMINS_WHEN_ORDERS_INVOICES_OR_PAYMENTS_DELETED'),(19415,'STR_SHOW_QUANTITY_BACKORDERED_ON_PACKING_SLIP'),(19416,'STR_SHOW_SHIPPED_QUANTITY_ON_ORDER_CONFIRMATION'),(19417,'STR_SHOW_WEIGHT_WITH_UN_NUMBER'),(19418,'STR_USE_INVENTORY_LOCATION_INFO_INSTEAD_OF_COMPANY_INFO'),(19419,'STR_BANK_ROUTING'),(19420,'STR_BANK_ROUTING_AND_ACCOUNT_NUMBER_MUST_BE_SET'),(19421,'STR_EMAILS_FOR_INVOICES'),(19422,'STR_EMAILS_NOT_FOR_INVOICES'),(19423,'STR_RETURN_TO_LOCATION'),(19424,'STR_SOLD_FROM_LOCATION'),(19425,'STR_AVG_XFERS_PER_MONTH'),(19426,'STR_MIN_AVG_SALES_PER_MONTH'),(19427,'STR_PURCHASE_REMOTELY'),(19428,'STR_YTD_PURCHASES'),(19429,'STR_BREAK_OUT_BY_LOCATION'),(19430,'STR_SORT_BY_QUANTITY'),(19431,'STR_KEYWORD_IN_ITEM_CODE'),(19432,'STR_HIDE_NON_STOCKED_ITEMS'),(19433,'STR_HIDE_VENDORS'),(19434,'STR_NON_STOCKED_ITEMS'),(19435,'STR_SHOW_NON_STOCKED_ITEMS'),(19436,'STR_SHOW_VENDORS'),(19437,'STR_ANY_DEPOSIT'),(19438,'STR_FULL_DEPOSIT'),(19439,'STR_NO_DEPOSIT'),(19440,'STR_CANNOT_BE_IMPORTED'),(19441,'STR_EXPORT_CONTACTS'),(19442,'STR_NO_COST_CODE'),(19443,'STR_NO_GL_CATEGORY'),(19444,'STR_USE_ONLY_DEFAULT_VENDORS'),(19445,'STR_ADD_PO_NUMBER_TO_DESCRIPTION'),(19446,'STR_ADDED'),(19447,'STR_ADDED_BY'),(19448,'STR_SALES_TERRITORY'),(19449,'STR_ARE_YOU_SURE_THE_QTY_SHOULD_BE_ZERO'),(19450,'STR_CUSTOMER_ON_HOLD'),(19451,'STR_NO_CREDIT_ALLOWED_FOR_THIS_CUSTOMER'),(19452,'STR_PRINT_CONFIRMATION'),(19453,'STR_PRINT_PAPER_PROOF_MYLAR_REQUEST'),(19454,'STR_PRINT_PICK_LIST'),(19455,'STR_QTY_MUST_BE_NUMERIC'),(19456,'STR_CUSTOMER_ADDED'),(19457,'STR_DEFAULT_FOR_CUSTOMERS_ON_HOLD'),(19458,'STR_EMAIL_WHEN_ORDER_CREATED'),(19459,'STR_SEND_INTEREST_INVOICES'),(19460,'STR_NEW_PENDING_ORDER_NUMBER'),(19461,'STR_NEW_PENDING_RENTAL_ORDER_NUMBER'),(19462,'STR_SEND_ORDER_CONFIRMATIONS'),(19463,'STR_WAIVER_FILES'),(19464,'STR_USERS_FIRST_AND_LAST_NAME'),(19465,'STR_BLOCK_LOCATION_FROM_COUNT_MANAGEMENT'),(19466,'STR_BLOCK_LOCATION_FROM_ITEM_REORDER_LIST'),(19467,'STR_EXCLUDE_THIS_LOCATION_FROM_PHYSICAL_INVENTORY_COUNTS'),(19468,'STR_SALES_REGION'),(19469,'STR_ONLY_ITEMS_WITH_A_SHELF_LIFE'),(19470,'STR_QTY_VARIANCE'),(19471,'STR_TRANSFER_FILL_RATE_ANALYSIS'),(19472,'STR_BLOCK_RENTALS_FOR_CUSTOMERS_MARKED_AS_NO_CREDIT'),(19473,'STR_DO_NOT_ALLOW_SHIP_TO_ADDRESS_EDITS_ON_ORDERS'),(19474,'STR_REQUIRE_INVENTORY_ITEM_FOR_ALL_SALES'),(19475,'STR_ALL_LINES_MUST_HAVE_AN_ITEM_ASSIGNED'),(19476,'STR_RENTALS_NOT_ALLLOWED_FOR_CUSTOMERS_MARKED_AS_NO_CREDIT'),(19477,'STR_RENTALS_NOT_ALLOWED_FOR_CUSTOMERS_MARKED_AS_NO_CREDIT'),(19478,'STR_APPOINTMENT_NOTIFICATION_METHOD'),(19479,'STR_MOBILE_CARRIER'),(19480,'STR_MY_PREFERENCES'),(19481,'STR_NO_MOBILE_CARRIER_SELECTED'),(19482,'STR_PLEASE_SELECT_A_MOBILE_CARRIER'),(19483,'STR_REMINDER_PHONE'),(19484,'STR_TEXT_MESSAGE'),(19485,'STR_CUSTOMERS_WITH_NO_SALES_LAST'),(19486,'STR_ASSIGNED_BINS'),(19487,'STR_COUNT_ID'),(19488,'STR_ITEM_BINS_SAVED'),(19489,'STR_OTHER_BINS'),(19490,'STR_RECOUNT_VARIANCES'),(19491,'STR_TOGGLE_CHECK_ALL'),(19492,'STR_VIEW_ASSIGNED_BINS_FOR_LOCATION'),(19493,'STR_ITEM_MIN_AND_MAX_CHANGES'),(19494,'STR_NEW_VALUE'),(19495,'STR_CLICK_TO_READ_BARCODE'),(19496,'STR_CHANGE_ITEMS_ASSIGNED_BINS'),(19497,'STR_IGNORE_ALL'),(19498,'STR_NEW_ITEMS_HAVE_BEEN_ADDED_TO_THIS_LIST'),(19499,'STR_SELECT_ITEM_AND_LOCATION'),(19500,'STR_BINS_WITH_A_VARIANCE_OVER'),(19501,'STR_ITEMS_WITH_A_VARIANCE_OVER'),(19502,'STR_RECOUNT_BY'),(19503,'STR_BLOCK_CHANGING_PO_VENDOR_TERMS'),(19504,'STR_EMAIL_REGIONAL_SALES_MANAGER_EACH_DAY_LIST_OF_CUSTOMERS_WITH_NO_SALES_IN_LAST_90_DAYS'),(19505,'STR_SEND_EMAIL_TO_SALESPERSON_FOR_NEW_RENTAL_ORDERS'),(19506,'STR_EMAIL_MIN_MAX_CHANGE_NOTICES_TO'),(19507,'STR_SELECT_SPECIFIC_INVOICES_TO_PRINT'),(19508,'STR_CREATE_SHIP_TO_FROM_CURRENT_JOB'),(19509,'STR_LAST_CHANGED'),(19510,'STR_RENTAL_ORDER_ADDED'),(19511,'STR_HOURS_TRAILING_DECIMALS'),(19512,'STR_EMAIL_FOR_3DCART_LOGIN'),(19513,'STR_CAN_ALWAYS_CHANGE_PO_VENDOR_TERMS_REGARDLESS_OF_COMPANY_SETTING'),(19514,'STR_CAN_VIEW_AND_EDIT_JOB_PRELIMABLE_SETTINGS'),(19515,'STR_HIDDEN_TO_ALL_USERS'),(19516,'STR_TIME_REPORT_COST_ACCESS'),(19517,'STR_VISIBLE_TO_ALL_USERS'),(19518,'STR_VISIBLE_TO_USERS_WITH_PAYROLL_ACCESS'),(19519,'STR_MAX_CHANGED'),(19520,'STR_MIN_CHANGED'),(19521,'STR_EMAIL_SALESMAN_WEEKLY_A_OPEN_ORDER_SUMMARY'),(19522,'STR_EMAIL_SALESMAN_WEEKLY_AN_OPEN_ORDER_SUMMARY'),(19523,'STR_ERROR_DELETING_AUTHORIZENET_CUSTOMER_PROFILE'),(19524,'STR_RECORDS_DELETED_SUCCESSFULLY'),(19525,'STR_BIN_ID'),(19526,'STR_SAVE_AND_CHANGE_WAREHOUSE_BIN'),(19527,'STR_BAR_CODE'),(19528,'STR_DELETE_ALL_BINS'),(19529,'STR_PRINT_BARCODE_COMMANDS'),(19530,'STR_PRINT_BIN_CODES'),(19531,'STR_QUICK_ITEM_BIN_MAINTENANCE'),(19532,'STR_QUICK_ITEM_BIN_MAINTENANCE_COMMANDS'),(19533,'STR_RESTART'),(19534,'STR_DELETE_TRANSFERS'),(19535,'STR_COUNTED_BY'),(19536,'STR_CURRENT_TIME'),(19537,'STR_DO_NOT_POST_TO_GL'),(19538,'STR_INVENTORY_CYCLE_COUNT_POSTED'),(19539,'STR_INVENTORY_CYCLE_COUNT_SUMMARY'),(19540,'STR_INVENTORY_PHYSICAL_COUNT_POSTED'),(19541,'STR_INVENTORY_PHYSICAL_COUNT_SUMMARY'),(19542,'STR_INVENTORY_ZONES'),(19543,'STR_ITEMS_PENDING_VARIANCE_RECOUNT'),(19544,'STR_NEW_ON_HAND'),(19545,'STR_POSTED_BY'),(19546,'STR_REVIEW_ACTIVE_INVENTORY_COUNT'),(19547,'STR_ZONE_BIN_OR_ITEM'),(19548,'STR_AUTHORIZENET_CIM_CARD_REPORT'),(19549,'STR_MANAGE_ALTERNATIVE_ZIP_CODES'),(19550,'STR_IMPORT_CITIES_WITHOUT_TAX_RATES'),(19551,'STR_ACCOUNTS_WITHOUT_STORED_CARDS'),(19552,'STR_ACCOUNTS_WITH_STORED_CARDS'),(19553,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_THE_SELECTED_AUTHORIZENET_ACCOUNTS'),(19554,'STR_DELETE_SELECTED_AUTHORIZENET_ACCOUNTS_WITHOUT_STORED_CARD'),(19555,'STR_DELETE_SELECTED_AUTHORIZENET_ACCOUNTS_WITH_STORED_CARD'),(19556,'STR_SELECT_OR_SCAN_AN_ITEM_TO_BEGIN'),(19557,'STR_SELECT_OR_SCAN_A_BIN_TO_ASSIGN'),(19558,'STR_INVENTORY_BINS'),(19559,'STR_BIN_COUNTED'),(19560,'STR_ENTERING_COUNTS_FOR_ITEMS_IN_BIN'),(19561,'STR_ALL_ENTRIES_IN_THIS_BIN_HAVE_ALREADY_BEEN_COUNTED'),(19562,'STR_ALL_ITEMS_IN_CURRENT_BIN_HAVE_NOT_BEEN_MARKED_AS_COUNTED'),(19563,'STR_ARE_YOU_SURE_YOU_WANT_TO_CHANGE_BINS'),(19564,'STR_CURRENT_BIN'),(19565,'STR_ITEM_OR_BIN_NOT_FOUND'),(19566,'STR_VIEW_ALL_BINS'),(19567,'STR_ONLY_RENTALS'),(19568,'STR_NEW_ZIP_CODE'),(19569,'STR_IGNORE_3DCART_TAXES_AND_REASSIGN_BASED_ON_SYSTEM_SETUP'),(19570,'STR_MATCH_AGAINST_TAXES_IN_SYSTEM_BASED_ON_RATE'),(19571,'STR_TAX_METHOD'),(19572,'STR_DAYS_TO_PRELIM'),(19573,'STR_LIMIT_SHIP_TO_ENTRY_TO_ONLY_KNOWN_CITIES_AND_ZIP_CODES'),(19574,'STR_EMAIL_CYCLE_COUNT_COMPLETE_SUMMARIES_TO'),(19575,'STR_EMAIL_PHYSICAL_COUNT_COMPLETE_SUMMARIES_TO'),(19576,'STR_CREATE_PROFILE'),(19577,'STR_CUSTOMER_DOES_NOT_HAVE_AN_AUTHORIZE_NET_PROFILE'),(19578,'STR_CANNOT_CHARGE_INTEREST_WHEN_CUSTOMER_TOTAL_IS_A_CREDIT'),(19579,'STR_INTEREST_CHARGED'),(19580,'STR_INTEREST_INVOICE_NUMBER'),(19581,'STR_NEW_INTEREST_TOTAL'),(19582,'STR_EXEMPT_SALES_IN_DISTRICT'),(19583,'STR_EXEMPT_SALES_TOTAL'),(19584,'STR_TAXABLE_SALES_IN_DISTRICT'),(19585,'STR_TOTAL_RATE'),(19586,'STR_TOTAL_SALES_IN_DISTRICT'),(19587,'STR_EXCLUDE_CASH_CUSTOMERS'),(19588,'STR_AMOUNT_NEEDED_TO_MAKE_THIS_SHIPMENT'),(19589,'STR_THIS_ORDERS_DEPOSIT_HAS_BEEN_APPLIED_TO_OTHER_ORDERS_OR_INVOICES'),(19590,'STR_FIRST_INVOICE_DATE'),(19591,'STR_CONTINUE_UNSAVED_ORDER'),(19592,'STR_EMAIL_CYCLE_COUNT_COMPLETE_SUMMARY'),(19593,'STR_EMAIL_PHYSICAL_COUNT_COMPLETE_SUMMARY'),(19594,'STR_CCACCOUNT'),(19595,'STR_ACTION_REQUIRED'),(19596,'STR_ALL_BINS'),(19597,'STR_ASSIGNED_BINS_ON_THIS_COUNT_ARE_NOT_VALID'),(19598,'STR_BIN_OR_ITEM'),(19599,'STR_CANNOT_ADD_ITEM'),(19600,'STR_CANNOT_CREATE_NEW_COUNT_UNTIL_CURRENT_PHYSICAL_COUNT_IS_COMPLETED'),(19601,'STR_CLICK_TO_RESEND'),(19602,'STR_COMPLETING'),(19603,'STR_COUNT_ENTRIES'),(19604,'STR_DUPLICATE_COUNT_ENTRIES'),(19605,'STR_EMAILING'),(19606,'STR_ENTRIES_MARKED_FOR_RECOUNT'),(19607,'STR_ENTRY_WAS_MODIFED'),(19608,'STR_INVALID_BIN'),(19609,'STR_INVALID_BINS_FOR_ITEMS_ON_COUNT'),(19610,'STR_MISSING_BIN'),(19611,'STR_MISSING_BINS_FOR_ITEMS_ON_COUNT'),(19612,'STR_OLD_ON_HAND'),(19613,'STR_PHYSICAL_COUNT_READY_TO_BE_POSTED'),(19614,'STR_PHYSICAL_CYCLE_READY_TO_BE_POSTED'),(19615,'STR_POSTING'),(19616,'STR_RESET_ENTERED_COUNTS_OF_OTHER_BINS'),(19617,'STR_SHOW_MORE_RESULTS'),(19618,'STR_THIS_ITEM_IS_ALREADY_PART_OF_INVENTORY_COUNT'),(19619,'STR_THIS_ITEM_WAS_ALREADY_RECOUNTED'),(19620,'STR_VARIANCE_RECOUNT'),(19621,'STR_AVERAGE_COST'),(19622,'STR_AVERAGE_COST_HISTORY'),(19623,'STR_RUNNING_QTY'),(19624,'STR_RUNNING_VALUE'),(19625,'STR_TRANSACTION_COST'),(19626,'STR_TRANSACTION_QTY'),(19627,'STR_CUSTOM_COMMISSIONS'),(19628,'STR_ITEM_AVG_COST_HISTORY'),(19629,'STR_AUTHORIZATION_SERVICES_2'),(19630,'STR_MINIMUM_BOOK_AMOUNT_FOR_AUTH'),(19631,'STR_REQUIRE_CC_AUTH_TO_BOOK_AMOUNT_2'),(19632,'STR_AUTHORIZE_CREDIT_CARD'),(19633,'STR_BOOK'),(19634,'STR_STORED_CARDS'),(19635,'STR_WITHOUT_STORED_CARDS'),(19636,'STR_ALL_FOUND_ITEMS_ARE_ALREADY_SELECTED'),(19637,'STR_BEGIN_AND_END_RANGE_MUST_BE_SET'),(19638,'STR_ITEMS_SELECTED'),(19639,'STR_NO_ITEMS_FOUND_IN_RANGE'),(19640,'STR_ITEM_MUST_BE_SET'),(19641,'STR_LOCATION_MUST_BE_SET'),(19642,'STR_ARE_YOU_SURE_YOU_WANT_TO_RESEND_THIS_CONFIRMATION_EMAIL'),(19643,'STR_SET_AVERAGE_COST'),(19644,'STR_SELECTED_STATES_ONLY'),(19645,'STR_ALLOW_SHIPMENT_OF_ORDER_WITH_DEPOSIT_IN_FULL'),(19646,'STR_DEFAULT_CHECKING_ACCOUNTS'),(19647,'STR_DEFAULT_COST_OF_GOODS_SOLD_GL_ACCOUNT'),(19648,'STR_DEFAULT_SALES_GL_ACCOUNT'),(19649,'STR_ALLOWED_ON_JOBS'),(19650,'STR_REQUIRE_EMAIL_CONFIRMATION_TO_POST_CYCLE_COUNTS'),(19651,'STR_REQUIRE_EMAIL_CONFIRMATION_TO_POST_PHYSICAL_COUNTS'),(19652,'STR_REQUIRE_UNIQUE_VENDOR_PRODUCT_CODES'),(19653,'STR_SEND_CONFIRMATIONS_TO'),(19654,'STR_USE_SAME_AVERAGE_COST_FOR_ALL_LOCATIONS'),(19655,'STR_INCLUDE_VOIDED_INVOICES'),(19656,'STR_NON_RENTAL'),(19657,'STR_DEPOSIT_IN_FULL_REQUIRED_WHEN_CREDIT_NOT_AVAILABLE'),(19658,'STR_DEPOSIT_REQUIRED'),(19659,'STR_SHIPMENT_DECLINED'),(19660,'STR_ADD_EXTRA_TO_COMMISSION_TOTAL'),(19661,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_THIS_COMMISSION'),(19662,'STR_ASSISTANT'),(19663,'STR_ASSISTANT_NOT_FOUND'),(19664,'STR_ASSISTANT_TOTAL'),(19665,'STR_CALCULATE_ASSISTANT_COMMISSIONS'),(19666,'STR_COMMISSIONS_FOR'),(19667,'STR_COMMISSIONS_SAVED_SUCCESSFULY'),(19668,'STR_COMMISSION_FOR_THESE_SETTINGS_ALREADY_EXISTS'),(19669,'STR_CURRENT_COMMISSION_ITEMS'),(19670,'STR_DEFAULT_ITEMS'),(19671,'STR_DRIVER_ASSISTANT_COMMISSION'),(19672,'STR_DRIVER_COMMISSION'),(19673,'STR_DRIVER_TOTAL'),(19674,'STR_DRIVER_TOTAL_MUST_BE_A_NUMBER'),(19675,'STR_ERROR_SAVING_COMMISSIONS'),(19676,'STR_INVOICE_STATUS'),(19677,'STR_ITEM_COMMISSION_DELETED_SUCCESSFULLY'),(19678,'STR_ITEM_COMMISSION_SETTINGS_ADDED_SUCCESSFULLY'),(19679,'STR_ITEM_OPTION_CHOICE'),(19680,'STR_ITEM_OPTION_GROUP'),(19681,'STR_MANAGE_ITEMS'),(19682,'STR_NO_ITEM_SELECTED'),(19683,'STR_SET_COMMISSION_ITEMS'),(19684,'STR_SET_DEFAULT_COMMISSION_ITEMS'),(19685,'STR_SET_DEFAULT_ITEM_COMMISSION_SETTINGS_HERE'),(19686,'STR_ARE_YOU_SURE_THE_PRICE_SHOULD_BE_ZERO'),(19687,'STR_REQUIRES'),(19688,'STR_ENTRY_WAS_MODIFIED'),(19689,'STR_COMMISSIONS_SAVED_SUCCESSFULLY'),(19690,'STR_DISCOUNT_AVAILABLE'),(19691,'STR_SHOW_DISCOUNT_AVAILABLE'),(19692,'STR_AS_OF_DATE'),(19693,'STR_DEFAULT_PO_FONT_SIZE'),(19694,'STR_PO_IS_OVER_YOUR_ALLOWED_LIMIT'),(19695,'STR_SHOW_COST_CODE'),(19696,'STR_SHOW_GL_ACCOUNT'),(19697,'STR_SHOW_GL_CATEGORY'),(19698,'STR_PO_RECEIPT_BATCH'),(19699,'STR_PO_RECEIPT_DOCUMENTS'),(19700,'STR_MAX_PO_AMOUNT'),(19701,'STR_MAKE_PAYMENT_ON_SELECTED_INVOICES'),(19702,'STR_PRINT_SELECTED_INVOICES'),(19703,'STR_PRINT_SELECTED_PODS'),(19704,'STR_PLEASE_CHECK_YOUR_EMAIL_FOR_INSTRUCTIONS_ON_HOW_TO_COMPLETE_YOUR_PASSWORD_RESET'),(19705,'STR_PLEASE_CHECK_YOUR_EMAIL_FOR_NEW_PASSWORD'),(19706,'STR_SEND_RESET_EMAIL'),(19707,'STR_YOUR_PASSWORD_HAS_BEEN_RESET_SUCCESSFULLY'),(19708,'STR_CLICK_HERE_TO_LOGIN'),(19709,'STR_CLICK_HERE_TO_RESET_YOUR_PASSWORD'),(19710,'STR_FORGOTTEN_PASSWORD_RESET'),(19711,'STR_HI'),(19712,'STR_IF_YOU_DID_NOT_REQUEST_A_PASSWORD_RESET_PLEASE_IGNORE_THIS_EMAIL'),(19713,'STR_PASSWORD_RESET'),(19714,'STR_TEMPORARY_PASSWORD'),(19715,'STR_YOU_RECENTLY_REQUESTED_TO_RESET_YOUR_PASSWORD_FOR_YOUR_ACCOUNT'),(19716,'STR_SALES_ONLY'),(19717,'STR_THIS_INVOICE_DATE_WILL_BE_SET_ON_ALL_GENERATED_INVOICES'),(19718,'STR_CREDIT_LIMIT_OVER'),(19719,'STR_CANNOT_SAVE_WHEN_UNASSINGED_ENTRIES_EXIST'),(19720,'STR_NEW_ON_HAND_VALUATION'),(19721,'STR_NOT_ALL_ENTRIES_ASSIGNED'),(19722,'STR_NOT_COMPLETE'),(19723,'STR_UNASSIGNED_ENTRIES'),(19724,'STR_ITEM_AND_COST_CODE'),(19725,'STR_ITEM_AND_LOCATION'),(19726,'STR_ITEM_ONLY'),(19727,'STR_TRANSFERED_IN'),(19728,'STR_TRANSFERED_OUT'),(19729,'STR_CUSTOMER_DEFAULT'),(19730,'STR_MIN_COST'),(19731,'STR_ITEM_COST_CHANGED_BY'),(19732,'STR_ITEM_SPECIAL_PRICING_CHANGED'),(19733,'STR_NEW_PRICE'),(19734,'STR_NEW_PROFIT_MARGIN'),(19735,'STR_OLD_PRICE'),(19736,'STR_OLD_PROFIT_MARGIN'),(19737,'STR_SPECIAL_PRICING_CHANGED_BY'),(19738,'STR_SALES_OVER_20_DAYS'),(19739,'STR_A_DEFAULT_INVENTORY_LOCATION_MUST_BE_SET'),(19740,'STR_A_DEFAULT_PRICE_LEVEL_MUST_BE_SET'),(19741,'STR_MUST_HAVE_ACCESS_TO_EACH_GROUP_BELOW'),(19742,'STR_OVER_OR_EQUAL_TO'),(19743,'STR_UNDER_OR_EQUAL_TO'),(19744,'STR_CREATED_FROM_QUOTE'),(19745,'STR_FIXED_MARGIN'),(19746,'STR_FIXED_PRICE'),(19747,'STR_ADMIN_NEW_PATIENT'),(19748,'STR_ADMIN_NEW_PATIENT_NOTIFICATION_EMAIL_ADDRESS'),(19749,'STR_ADMIN_NEW_PATIENT_NOTIFICATION_SERVICE_TYPE'),(19750,'STR_GENERAL_PATIENT_EMAIL'),(19751,'STR_AUTHORIZE_CREDIT_CARD_ERROR'),(19752,'STR_CHECK_CUSTOMER_ID_AND_CUSTOMER_NUMBERS'),(19753,'STR_CHECK_CUSTOMER_USA_EPAY_SETTINGS'),(19754,'STR_ERROR_BOOKING_APPOINTMENT'),(19755,'STR_NO_CARD_ON_FILE'),(19756,'STR_AUTO_IMPORT'),(19757,'STR_DO_NOT_SHOW'),(19758,'STR_GENERAL_ENTRY'),(19759,'STR_ORDER_LINE_ITEM_LOOKUP'),(19760,'STR_SHOW_UNDER_ADDITIONAL_OPTIONS'),(19761,'STR_SHOW_WARNING_WHEN_SAVING_A_LINE_WITH_ZERO_PRICE'),(19762,'STR_SHOW_WARNING_WHEN_SAVING_A_LINE_WITH_ZERO_QTY'),(19763,'STR_SPECIAL_SALES_PRICING_METHOD'),(19764,'STR_USE_PAGINATED_ITEM_LOOKUP_LAYOUT'),(19765,'STR_BLOCK_TRANSFERS_FOR_INVENTORY_TYPES'),(19766,'STR_EMAIL_ITEM_SPECIAL_PRICING_CHANGES'),(19767,'STR_SENDS_NOTICE_OF_PRICE_CHANGES_TO_PRICE_LIST_ENTRY_USER'),(19768,'STR_ALLOW_B2BUSERS_TO_RESET_PASSWORD'),(19769,'STR_EMAILS_DO_NOT_MATCH'),(19770,'STR_EMAIL_NOT_VALID'),(19771,'STR_PAYMENT_MUST_BE_GREATER_THAN_ZERO'),(19772,'STR_COST_ACCOUNT_TOTAL'),(19773,'STR_SALES_ACCOUNT_TOTAL'),(19774,'STR_SHOW_COST_ACCOUNT_TOTAL'),(19775,'STR_SHOW_SALES_ACCOUNT_TOTAL'),(19776,'STR_THIS_SHIPMENT_PUTS_THE_JOB_OVER_THE_NON_PRELIMABLE_CREDIT_LIMIT'),(19777,'STR_THIS_SHIPMENT_PUTS_THE_JOB_OVER_THE_PRELIMABLE_CREDIT_LIMIT'),(19778,'STR_NOT_ALLOWED_FOR_SALES'),(19779,'STR_ADDITIONAL_FIELDS'),(19780,'STR_ITEM_VENDOR'),(19781,'STR_ARE_YOU_SURE_YOU_WANT_TO_DELETE_THIS_INVOICE'),(19782,'STR_CONVERT_TO_SPECIAL_SALES_PRICING'),(19783,'STR_COST_CODE_NOT_ALLOWED_FOR_SALES'),(19784,'STR_MISSING_SALES_PRICING'),(19785,'STR_CONVERT_BOTH_RENTALS_AND_NONRENTALS'),(19786,'STR_CONVERT_NONRENTALS_ONLY'),(19787,'STR_CONVERT_RENTALS_ONLY'),(19788,'STR_CREATED_SPECIAL_ITEM_PRICE_LIST'),(19789,'STR_ERROR_CONVERTING'),(19790,'STR_EXISTING_PRICE_LIST_ALREADY_CONTAINS_THIS_ITEM'),(19791,'STR_ITEMS_MUST_BE_SET_AND_INCLUDE_PRICING'),(19792,'STR_NOTHING_TO_CONVERT'),(19793,'STR_SEPARATE_ORDERS'),(19794,'STR_THIS_QUOTE_HAS_BOTH_RENTAL_AND_NON_RENTAL_ITEMS'),(19795,'STR_CANNOT_ISSUE_CUSTOMER_CREDIT'),(19796,'STR_UNBALANCED_ENTRY_SET'),(19797,'STR_CANNOT_SAVE_WHEN_UNASSIGNED_ENTRIES_EXIST'),(19798,'STR_TRANSFERRED_IN'),(19799,'STR_TRANSFERRED_OUT'),(19800,'STR_PLEASE_CHECK_YOUR_EMAIL_TO_VERFIY_LOGIN_CREDENTIALS'),(19801,'STR_CLICK_HERE_TO_VERIFY_EMAIL_ADDRESS'),(19802,'STR_IF_YOU_DID_NOT_REQUEST_THIS_VERIFICATION_PLEASE_IGNORE_THIS_EMAIL'),(19803,'STR_VERIFY_WORDPRESS_LOGIN'),(19804,'STR_YOU_RECENTLY_TRIED_TO_ACCESS_NOLAPRO_WITH_COMPASSFATLOSS_CREDENTIALS'),(19805,'STR_LOGGING_IN'),(19806,'STR_ADDED_MISSING_RECORDS'),(19807,'STR_CANNOT_ADD_ITEMS_TO_COMPLETED_COUNT'),(19808,'STR_FIND_AND_ADD_MISSING_ITEMS'),(19809,'STR_NO_MISSING_RECORDS_FOUND'),(19810,'STR_PHYSICAL_COUNTS_ONLY'),(19811,'STR_FIRST_RENTAL_STARTED'),(19812,'STR_INCLUDE_CUSTOMER_NAME'),(19813,'STR_INCLUDE_FIRST_RENTAL_DATE'),(19814,'STR_INCLUDE_NUMBER_OF_MONTHS_OF_HISTORY'),(19815,'STR_INCLUDE_ORDER_NUMBER'),(19816,'STR_ITEM_AND_ORDER'),(19817,'STR_LAST_RECEIVED'),(19818,'STR_QTY_BALANCE'),(19819,'STR_CACHED_ON_HAND_DIFFERENCE'),(19820,'STR_COST_DIFFERENCE'),(19821,'STR_DIFFERENCES_IN_CACHED_ON_HAND_RECORDS'),(19822,'STR_QTY_DIFFERENCE'),(19823,'STR_REBUILD_CACHE_VALUES'),(19824,'STR_APPLIES_TO_ALL_LOCATIONS'),(19825,'STR_VENDOR_PRODUCT_CODE_MUST_BE_SET'),(19826,'STR_EMAIL_REGION_MANAGER_NEW_SLASH_CONVERTED_QUOTES'),(19827,'STR_MIN_QUOTE_AMOUNT_FOR_EMAIL'),(19828,'STR_CREDIT_CARD_DENIED'),(19829,'STR_CREDIT_CARD_ERROR'),(19830,'STR_CREDIT_CARD_PROCESSING_ERROR'),(19831,'STR_JOB_DELETED'),(19832,'STR_APPLIES_TO_ORDER_ENTRY_AND_POS'),(19833,'STR_BLOCK_EMAIL_EDITS_FOR_3DCART_CUSTOMERS'),(19834,'STR_UPDATE_3DCART_ON_ORDER_LEVELS_AUTOMATICALLY'),(19835,'STR_SHOW_CC_BILLS_IN_SEPARATE_TAB'),(19836,'STR_WILL_BE_INCLUDED_IN_VENDOR_BILLS_TAB_IF_NOT_CHECKED'),(19837,'STR_BLOCK_OUTDATED_TAX_SELECTION'),(19838,'STR_BLOCK_WHEN_NEWER_TAX_EXISTS_WITH_SAME_NAME'),(19839,'STR_BLOCK_WHEN_NEWER_TAX_EXISTS_WITH_SAME_NAME_OR_SAME_CITY_STATE_AND_COUNTY'),(19840,'STR_DO_NOT_BLOCK'),(19841,'STR_BASED_ON_RENTAL_PRICE'),(19842,'STR_DO_NOT_CREATE_ON_RENT_LEDGER_TRANSACTIONS_WHEN_SHIPPING_AND_RECEIVING_INVENTORY_TYPES'),(19843,'STR_JOBS_MUST_HAVE_CITY_STATE_ZIP_SET'),(19844,'STR_RENTAL_COST_PERCENTAGE'),(19845,'STR_USED_BY'),(19846,'STR_TRANSFER_VARIANCE_ADJUSTMENT_TYPE'),(19847,'STR_INCLUDE_CREDIT_BALANCE_CUSTOMERS'),(19848,'STR_INVOICE_AR_ACCOUNT_TOTAL'),(19849,'STR_PMT_AR_ACCOUNT_TOTAL'),(19850,'STR_SHOW_INVOICE_AR_ACCOUNT_TOTAL'),(19851,'STR_SHOW_PAYMENT_AR_ACCOUNT_TOTAL'),(19852,'STR_MONTHLY_SALES_AVG_LAST_12'),(19853,'STR_CANNOT_USE_VALUE'),(19854,'STR_MINIMUM_ORDER_NUMBER'),(19855,'STR_PREPARING_DB_FOR_UPDATE'),(19856,'STR_ADD_EDIT_SHIPPING_ROUTES'),(19857,'STR_CAN_EDIT_MIN_MAX_WHEN_NOT_ALLOWED_TO_EDIT_ITEM'),(19858,'STR_EDIT_AVG_COST'),(19859,'STR_CITY_STATE_ZIP_REQUIRED'),(19860,'STR_CANNOT_CREATE_CUSTOMER_PICKUP_SALE_FOR_DELIVERY_ONLY_CUSTOMER'),(19861,'STR_CANNOT_CREATE_POS_SALES_FOR_DELIVERY_ONLY_CUSTOMER'),(19862,'STR_THE_ORDER_WILL_BE_DELETED'),(19863,'STR_YOU_HAVE_OPENED_AN_EXISTING_ORDER_AND_CHOOSE_TO_SAVE_AS_POINT_OF_SALE'),(19864,'STR_CONVERTED'),(19865,'STR_CONVERTED_BY'),(19866,'STR_SENDING_SURVEY'),(19867,'STR_COACH'),(19868,'STR_SHOW_PRICE_LEVELS_ON_ITEM_STATUS_DETAILS_PAGE'),(19869,'STR_ADDRESS1'),(19870,'STR_ADDRESS2'),(19871,'STR_DELETED_BY_USER'),(19872,'STR_DELETED_DATE'),(19873,'STR_JOB_CLOSED_BY'),(19874,'STR_LAST_CHANGED_DATE'),(19875,'STR_YOU_HAVE_OPENED_AN_EXISTING_ORDER_AND_CHOSEN_TO_SAVE_AS_POINT_OF_SALE'),(19876,'STR_PLEASE_CHECK_YOUR_EMAIL_TO_VERIFY_LOGIN_CREDENTIALS'),(19877,'STR_WRITE_OFF'),(19878,'STR_BAD_WRITE_OFF'),(19879,'STR_RENTAL_DOCS'),(19880,'STR_INVOICE_DOCUMENT'),(19881,'STR_ORDER_DOCUMENT'),(19882,'STR_RENTAL_ORDER_HISTORY'),(19883,'STR_NEW_DAILY_DRAWER_CLOSE'),(19884,'STR_LAST_NOTE_USER'),(19885,'STR_ASSIGNED_TO_PO'),(19886,'STR_SELECT_ORDER_LINE'),(19887,'STR_PICKUP_STATUS'),(19888,'STR_B2B_USER_ACTIVITY'),(19889,'STR_B2B_USER_PAYMENTS'),(19890,'STR_EVENTS_END'),(19891,'STR_EVENTS_START'),(19892,'STR_INVOICE_COUNT'),(19893,'STR_SALES_TERRITORIES'),(19894,'STR_BULLPINNING_INVOICES'),(19895,'STR_MERGING_PAGES'),(19896,'STR_PRINT_PDF'),(19897,'STR_PROFITABILITY_REPORT'),(19898,'STR_FAXES'),(19899,'STR_FREIGHT_BURDON'),(19900,'STR_FROM_LOCATION_AVAILABLE_WILL_GO_NEGATIVE_IF_MARKED'),(19901,'STR_INCLUDE_UNPRINTED'),(19902,'STR_MASS_ASSIGN'),(19903,'STR_SALES_ORDER'),(19904,'STR_SPLIT_BY_ZONE_AND_SAVE'),(19905,'STR_TRANSFER_DELETED'),(19906,'STR_TRANSFER_RECEIVED'),(19907,'STR_TRANSFER_SHIPPED'),(19908,'STR_WRITTEN_BY'),(19909,'STR_CONFIRM_AS_OK_KEEPING_SENT_QTY_EQUAL_TO_RECEIVED_QTY'),(19910,'STR_REMOVED_SENT_QTY_TRANSACTIONS'),(19911,'STR_REMOVE_SENT_QTY_TRANSACTIONS'),(19912,'STR_A_NEW_ITEM_WAS_ADDED_TO_COUNT_ID'),(19913,'STR_CANNOT_ADD_ITEMS'),(19914,'STR_CANNOT_ADD_ITEMS_TO_LOCATION'),(19915,'STR_LOCATION_COUNT_COMPLETED'),(19916,'STR_NEW_ITEMS_WERE_ADDED_TO_COUNT_ID'),(19917,'STR_PLEASE_COUNT_BEFORE_POSTING'),(19918,'STR_COST_RECEIVED_NOT_SENT'),(19919,'STR_PARTAIL'),(19920,'STR_CHANGE_USED_SERIAL_NUMBER'),(19921,'STR_EDIT_ORDER_SERIAL_NUMBERS'),(19922,'STR_LINE_QTY'),(19923,'STR_LAST_RECEIVED_QUANTITY'),(19924,'STR_ON_TRANSFER_IN'),(19925,'STR_ON_TRANSFER_OUT'),(19926,'STR_CACHED_VALUE'),(19927,'STR_CALCULATED_QTY'),(19928,'STR_CALCULATED_VALUE'),(19929,'STR_CURRENT_QTY'),(19930,'STR_DIFFERENCES_IN_CACHED_ITEM_BIN_RECORDS'),(19931,'STR_ACTIVE_SPECIAL_SALES_PRICING'),(19932,'STR_AVG_PROFIT_MARGIN'),(19933,'STR_CUSTOMER_SUMMARY'),(19934,'STR_EXPIRING_SOON_SPECIAL_SALES_PRICING'),(19935,'STR_INCLUDE_EXPIRED'),(19936,'STR_PRICE_SOLD_AT'),(19937,'STR_PRINT_WITHOUT_COST_AND_MARGIN'),(19938,'STR_PRINT_WITHOUT_COST_AND_MARGIN_AND_STANDARD_PRICING'),(19939,'STR_SPECIAL_PRICE_LIST_ID'),(19940,'STR_SPECIAL_PRICING'),(19941,'STR_SPECIAL_SALES_PRICING_USAGE'),(19942,'STR_WEEKLY_SPECIAL_SALES_PRICING_SUMMARY'),(19943,'STR_CHANGE_USED_SERIAL_NUMBERS'),(19944,'STR_MANAGE_REGIONS'),(19945,'STR_PROCESS_QUEUE'),(19946,'STR_REGION_SALES_BY_CUSTOMER'),(19947,'STR_REGION_SALES_SUMMARY'),(19948,'STR_TERRITORY_ACCOUNT_PERFORMANCE'),(19949,'STR_TERRITORY_CUSTOMER_SALES_ANALYSIS'),(19950,'STR_TERRITORY_ITEM_SALES'),(19951,'STR_THIS_REQUEST_IS_DELETED'),(19952,'STR_PROCESS_STARTED'),(19953,'STR_RUN_WHEN'),(19954,'STR_RSM'),(19955,'STR_MANAGE_SALES_REGIONS'),(19956,'STR_NEW_REGION'),(19957,'STR_NO_REGION_ASSIGNED'),(19958,'STR_REGION_SALES_DETAILS_FOR'),(19959,'STR_REGION_SALES_SUMMARY_FOR'),(19960,'STR_REGION_TOTAL'),(19961,'STR_SALES_REGION_HAS_BEEN_DELETED'),(19962,'STR_SALES_REGION_WITH_THIS_CODE_ALREADY_EXISTS'),(19963,'STR_TOTAL_FOR_TERRITORY'),(19964,'STR_ADD_ZIP_TO_TERRITORY'),(19965,'STR_AVG_MARGIN'),(19966,'STR_AVG_PROFIT'),(19967,'STR_CURRENT_TERRITORY'),(19968,'STR_EDIT_TERRITORY'),(19969,'STR_MANAGE_SALES_TERRITORIES'),(19970,'STR_NEW_TERRITORY'),(19971,'STR_NEW_ZIP_CODES'),(19972,'STR_NOT_ASSIGNED_A_TERRITORY'),(19973,'STR_NO_NEW_ZIP_CODES_ADDED_YET'),(19974,'STR_NO_ZIP_SET'),(19975,'STR_PLEASE_SELECT_A_TERRITORY'),(19976,'STR_REGION_CODE'),(19977,'STR_SALES_TERRITORY_HAS_BEEN_DELETED'),(19978,'STR_SALES_TERRITORY_WITH_THIS_CODE_ALREADY_EXISTS'),(19979,'STR_SELECT_TERRITORY'),(19980,'STR_TERRITORY_ITEM_SALES_FOR'),(19981,'STR_TERRITORY_SALES_FOR'),(19982,'STR_TERRITORY_ZIP_CODES'),(19983,'STR_THIS_SALESPERSON'),(19984,'STR_YEAR_COSTS'),(19985,'STR_YEAR_MARGIN'),(19986,'STR_YEAR_SALES'),(19987,'STR_ZIP_ADDED_SUCCESSFULLY'),(19988,'STR_ZIP_ALREADY_ASSIGNED_TO_A_TERRITORY'),(19989,'STR_ZIP_CODE_TO_ADD'),(19990,'STR_WHEN_CONVERTING_PO_TO_AP_BILLRY'),(19991,'STR_WHEN_RECEIVING_POS_BASED_ON_WEIGHT'),(19992,'STR_NEVERND_SHIPMENTS'),(19993,'STR_BULLPINNING_ENABLED'),(19994,'STR_EXCLUDE_AFTER_DAYS'),(19995,'STR_EXCLUDE_CUSTOMERS_WITH_INVOICES_TOTALING_OVER'),(19996,'STR_SET_AS_ZERO_TO_DISABLE'),(19997,'STR_EXCLUDE_INVOICES_WITH_TOTAL_OVER'),(19998,'STR_EXCLUDE_ALL_ON_LAST_DAY_OF_MONTH'),(19999,'STR_EXCLUDE_ALL_INVOICES_FOR_CUSTOMER_WHEN_CUSTOMER_HAS_ANY_INVOICES_TO_BE_SENT'),(20000,'STR_EXCLUDE_DELIVERY_TYPES'),(20001,'STR_SEND_NOTICE_WHEN_ITEM_ADDED_TO_COUNT'),(20002,'STR_SENDS_TO_INVENOTRY_LOCATION_CONTACT'),(20003,'STR_SEND_TRANFER_NOTICES_TO_ENTRY_USER'),(20004,'STR_EMAIL_TEMPLATE_MUST_BE_SET'),(20005,'STR_EMAIL_PURCHASE_ORDERS_FROM_ADDRESS'),(20006,'STR_EMAIL_VENDOR_CERTIFICATE_REQUESTS_FROM_ADDRESS'),(20007,'STR_MGMT_EXPENSE_FEE'),(20008,'STR_ALLOW_DISCOUNTS_ON_CREDITS'),(20009,'STR_PO_RETURN_RESTOCK_FEE'),(20010,'STR_FAX_FAILED'),(20011,'STR_SEND_FAXES'),(20012,'STR_GROUP_RIGHTS'),(20013,'STR_UPDATED_BY'),(20014,'STR_ALL_CONVERTED_TO_SALE'),(20015,'STR_NOT_RETURNED'),(20016,'STR_NEW_CUSTOMER_ADDED'),(20017,'STR_DNS_NOT_FOUND'),(20018,'STR_INVALID_EMAIL_ADDRESS'),(20019,'STR_MX_NOT_FOUND'),(20020,'STR_MISSING_DISCOUNT_PAYMENT'),(20021,'STR_MISSING_PAYMENT'),(20022,'STR_OVER_DISCOUNT_PAYMENT'),(20023,'STR_OVER_PAYMENT'),(20024,'STR_EXPRESS'),(20025,'STR_EXPRESS_SERVICE'),(20026,'STR_MAINTENANCE_PLAN_ALERT_APPOINTMENT_LIMIT'),(20027,'STR_MAINTENANCE_PLAN_ALERT_DAY_LIMIT'),(20028,'STR_AN_ERROR_HAS_OCCURRED_BOOKING_THIS_APPOINTMENT'),(20029,'STR_ASSIGN_MEMBERSHIP_COACHES'),(20030,'STR_IS_READY_FOR_MAINTENANCE_PLAN'),(20031,'STR_READY_FOR_MAINTENANCE_PLAN'),(20032,'STR_SET_START_DATE'),(20033,'STR_ITEM_RETURNED'),(20034,'STR_PRINT_INVOICES_THROUGH'),(20035,'STR_CHARGECODE'),(20036,'STR_ASSIGN_COACHES_TO_MEMBERS'),(20037,'STR_JOIN_DATE'),(20038,'STR_PATIENT'),(20039,'STR_UPDATE_WAS_NOT_SUCCESSFUL'),(20040,'STR_SELECT_OR_TRANSFER_TO_EDIT'),(20041,'STR_REQUESTED_MARGIN'),(20042,'STR_SEARCH_MENU'),(20043,'STR_AFFECTS_CHECKS_ONLY'),(20044,'STR_ALLOW_NEW_PAYMENTS_AGAINST_PAID_COMPLETE_INVOICES'),(20045,'STR_BANK_DEPOSITS_CAN_INCLUDE_REFUNDS'),(20046,'STR_BANK_DEPOSITS_INCLUDE_DIRECT_CASH_PAYMENTS'),(20047,'STR_BLOCK_POS_FOR_CUSTOMERS_MARKED_AS'),(20048,'STR_BLOCK_SAVING_NEGATIVE_QUANTITY_SALES'),(20049,'STR_BLOCK_SHIPMENT'),(20050,'STR_CAN_SELECT_OTHER_CUSTOMER_INVOICES'),(20051,'STR_CONVENIENCE_FEE_GL_CATEGORY'),(20052,'STR_DAILY_DRAWER_CLOSE_CREATES_BANK_DEPOSIT'),(20053,'STR_DEFAULT_GL_CATEGORY_FOR_RENTALS'),(20054,'STR_EFT_PAYMENTS_CANNOT_BE_MADE_VOID'),(20055,'STR_EMAIL_INVOICES_FROM_ADDRESS'),(20056,'STR_EMAIL_ORDER_CONFIRMATIONS_FROM_ADDRESS'),(20057,'STR_EMAIL_PRELIM_REQUESTS_FROM_ADDRESS'),(20058,'STR_EMAIL_QUOTES_FROM_ADDRESS'),(20059,'STR_EMAIL_STATEMENTS_FROM_ADDRESS'),(20060,'STR_ENABLED_BY_DEFAULT'),(20061,'STR_HIDE_AGING_ON_STATEMENT'),(20062,'STR_HIDE_JOB_NAME'),(20063,'STR_NOTE_BELOW_ORDER_TOTAL'),(20064,'STR_NO_ACTION'),(20065,'STR_NUMBER_OF_DAYS_TO_SEND_BEFORE_EXPIRED'),(20066,'STR_SAVE_ORDER_ENTRY_DELAY_IN_SECONDS'),(20067,'STR_SEND_NEW_CUSTOMER_EMAIL_TO_REGION_MGR_AND_TERRITORY_SALESMAN'),(20068,'STR_SEND_SPECIAL_PRICING_EXPIRING_SOON_NOTICE'),(20069,'STR_SEND_SPECIAL_PRICING_WEEKLY_SUMMARIES'),(20070,'STR_SENT_TO_CUSTOMERS_SALESPERSON'),(20071,'STR_SET_CUSTOMER_INVOICE_TERMS_FROM_LAST_SALE'),(20072,'STR_SHIPPING_ITEMS_FROM_UNRECIEVED_PO_ACTION'),(20073,'STR_SHOW_PRICING_ON_PACKING_SLIP'),(20074,'STR_WARN_USER'),(20075,'STR_VERIFY_EMAIL_DNS_BEFORE_SENDING'),(20076,'STR_SPLIT_PAYMENT'),(20077,'STR_SPLIT_PAYMENT_IS_UNBALANCED'),(20078,'STR_SPLIT_PAYMENT_PARTS'),(20079,'STR_GL_ENTRIES_TO_AP_FROM_THE_AP_MODULE_BUT_GL_ENTRY_MANUALLY_DELETED'),(20080,'STR_CAN_ONLY_CLEAR_ENTRIES_ALREADY_DESIGNATED_FOR_THIS_ACCOUNT_UNLESS_A_DIRECT_AR_PAYMENT'),(20081,'STR_ALL_INVOICES'),(20082,'STR_PROFITABILITY'),(20083,'STR_CREATE_UNAPPLIED_PAYMENT'),(20084,'STR_APPLY_WRITE_OFF_TO_OLDEST_INVOICES'),(20085,'STR_INVOICE_WRITE_OFF_ADDED_SUCCESSFULLY'),(20086,'STR_WRITE_OFF_ACCOUNT_MUST_BE_SET_IN_BILLING_SETUP_STANDARD_ACCOUNTS'),(20087,'STR_ADD_INVOICE_TO_PAYMENT_LIST'),(20088,'STR_APPLY_PAYMENT_TO_OLDEST_INVOICES'),(20089,'STR_INVOICE_ALREADY_LISTED'),(20090,'STR_VOIDING_EFT_PAYMENT_IS_NOT_ALLOWED'),(20091,'STR_EXCLUDE_WRITE_OFFS'),(20092,'STR_SHOW_ONLY_ORDER_DEPOSITS'),(20093,'STR_SHOW_ONLY_WRITE_OFFS'),(20094,'STR_CUSTOMER_SALESPERSON'),(20095,'STR_AVG_SALES_QTY_PER_MONTH'),(20096,'STR_AVG_XFERS_QTY_PER_MONTH'),(20097,'STR_END_SALES_DATE'),(20098,'STR_PRIMARY_VENDOR'),(20099,'STR_ITEM_REPORT_OF_PROFIT_PERCENT_AVG'),(20100,'STR_ITEM_REPORT_OF_PROFIT_TOTAL'),(20101,'STR_ITEM_REPORT_OF_QTY_SOLD'),(20102,'STR_ITEM_REPORT_OF_SALES_TOTAL'),(20103,'STR_CLICK_TO_VIEW_ORDER_ACKNOWLEDGMENT'),(20104,'STR_INVENTORY_ON_OPEN_ORDERS_FOR'),(20105,'STR_INVENTORY_ON_OPEN_QUOTES_FOR'),(20106,'STR_TOTAL_ORDERED'),(20107,'STR_TOTAL_SHIPPED'),(20108,'STR_PRINT_CUSTOMER_INVENTORY_ON_ORDER'),(20109,'STR_QTY_AT_DC'),(20110,'STR_PRINT_CUSTOMER_INVENTORY_ON_QUOTES'),(20111,'STR_DO_YOU_WANT_TO_RECEIVE_THIS_ITEM_FIRST'),(20112,'STR_NOT_ALL_ITEMS_HAVE_BEEN_RECEIVED_YET'),(20113,'STR_REMAINING_DEPOSIT'),(20114,'STR_VALUE_OF_THIS_SHIPMENT'),(20115,'STR_BOX_IS_OVER_MAX_CARRIER_RATE'),(20116,'STR_BANK_GL_ACCOUNT_NOT_ALLOWED_THIS_COST_CODE'),(20117,'STR_BANK_GL_ACCOUNT_NOT_ALLOWED_THIS_GL_CATEGORY'),(20118,'STR_BANK_GL_ACCOUNT_REQUIRES_A_COST_CODE'),(20119,'STR_BANK_GL_ACCOUNT_REQUIRES_A_GL_CATEGORY'),(20120,'STR_SALES_ENTRIES_OUTSIDE_INVOICING'),(20121,'STR_SPECIAL_FILTERING'),(20122,'STR_ARE_YOU_SURE_YOU_WANT_TO_SAVE_AS_COMMITTED'),(20123,'STR_NOT_COMMITTED'),(20124,'STR_PICK_COMPLETED'),(20125,'STR_TRANSFER_MUST_HAVE_AT_LEAST_ONE_ITEM'),(20126,'STR_INTERNAL_BUY_NOTES'),(20127,'STR_IS_THIS_ITEM_HAZARDOUS_MATERIAL'),(20128,'STR_RENTAL_CONVERSION_COST_OF_GOODS'),(20129,'STR_RENTAL_CONVERSION_TO_SALES'),(20130,'STR_ZERO_MOVEMENT_ITEMS_ONLY'),(20131,'STR_ALL_ITEM_PAGES_WILL_BE_AFFECTED'),(20132,'STR_ANY_UNSAVED_CHANGES_WILL_BE_LOST'),(20133,'STR_INCREASE_ALL_BY_PERCENT'),(20134,'STR_INCREASE_PRICES_BY'),(20135,'STR_UPDATED_ITEMS'),(20136,'STR_BEST_BUY'),(20137,'STR_A_RECENT_OPEN_PO_ALREADY_EXISTS_FOR_THIS_ITEM_AND_VENDOR'),(20138,'STR_A_RECENT_OPEN_PO_WITH_STOCK_ITEMS_ALREADY_EXISTS_FOR_THIS_VENDOR'),(20139,'STR_CURRENT_LINE'),(20140,'STR_FOR_ORDER_LINE'),(20141,'STR_KEEP_VALUES_AS_IS'),(20142,'STR_SELECTED_LINE'),(20143,'STR_SELECTED_LINE_DO_NOT_MATCH_THE_ENTERED_LINE_DETAILS'),(20144,'STR_SELECT_AN_ORDER_LINE'),(20145,'STR_SET_VALUES_FROM_ORDER_LINE'),(20146,'STR_RECEIVED_SHORT'),(20147,'STR_COST_CODE_MUST_BE_SET_FOR_MISC_ENTRY_NUM'),(20148,'STR_GL_CATEGORY_MUST_BE_SET_FOR_MISC_ENTRY_NUM'),(20149,'STR_VENDOR_BILL_DISCOUNT_TOTAL_DOES_NOT_MATCH_PAYMENTS_TOTAL'),(20150,'STR_VENDOR_BILL_TOTAL_DOES_NOT_MATCH_PAYMENTS_TOTAL'),(20151,'STR_CUSTOMER_ROLE'),(20152,'STR_CANNOT_SAVE_ORDER_WHEN_QTY_IS_NEGATIVE'),(20153,'STR_CUSTOMER_POS_BLOCKED'),(20154,'STR_OVER_CUSTOMER_CREDIT_LIMIT'),(20155,'STR_OVER_JOB_CREDITLIMIT'),(20156,'STR_PRICING_ENDS'),(20157,'STR_PRINT_ACKNOWLEDGMENT'),(20158,'STR_SPECIAL_ITEM_PRICING'),(20159,'STR_CANNOT_ADD_PAYMENT_TO_DELETED_INVOICE'),(20160,'STR_CANNOT_ADD_PAYMENT_TO_DELETED_ORDER'),(20161,'STR_AR_INVOICE_WRITE_OFF'),(20162,'STR_ERROR_ADDING_WRITE_OFF'),(20163,'STR_MAINTENANCE_PLAN'),(20164,'STR_ORDER_ACKNOWLEDGMENT'),(20165,'STR_DEACTIVATE'),(20166,'STR_SHOW_INACTIVE_CONTACTS'),(20167,'STR_COLUMN_TEXT_SIZE'),(20168,'STR_SPECIAL_SALES_PRICING_EXPIRED'),(20169,'STR_CAN_EDIT_BUYER_NOTES'),(20170,'STR_IF_USER_IS_NOT_A_BUYER'),(20171,'STR_HEADER_NOTES'),(20172,'STR_USE_ADDRESS_ON_ORDER'),(20173,'STR_USE_A_DIFFERENT_ADDRESS'),(20174,'STR_USE_CUSTOM_ADDRESS'),(20175,'STR_JOB_CONTACTNAME'),(20176,'STR_JOB_PHONE'),(20177,'STR_BULLPENNING_INVOICES'),(20178,'STR_SENDS_TO_INVENTORY_LOCATION_CONTACT'),(20179,'STR_SEND_TRANSFER_NOTICES_TO_ENTRY_USER'),(20180,'STR_SHIPPING_ITEMS_FROM_UNRECEIVED_PO_ACTION'),(20181,'STR_VOIDING_EFT_PAYMENTS_IS_NOT_ALLOWED'),(20182,'STR_SELECTED_LINES_DO_NOT_MATCH_THE_ENTERED_LINE_DETAILS'),(20183,'STR_OVER_JOB_CREDIT_LIMIT'),(20184,'STR_SHOW_SUBTOTALS_ON_CHECKS'),(20185,'STR_ID_END'),(20186,'STR_ID_START'),(20187,'STR_GL_SALES_AMOUNT'),(20188,'STR_GL_SALES_AMOUNT_FROM_CANCELED_INVOICES_IN_OTHER_PERIODS'),(20189,'STR_GL_SALES_AMOUNT_FROM_INVOICE_EDITING_NOT_TIED_TO_MAIN_INVOICE_VOUCHER'),(20190,'STR_GL_SALES_AMOUNT_NOT_FROM_INVOICING'),(20191,'STR_GL_SALES_ENTRIES_FROM_CANCELED_INVOICES_IN_OTHER_PERIODS'),(20192,'STR_GL_SALES_ENTRIES_FROM_INVOICE_EDITING_NOT_TIED_TO_MAIN_INVOICE_VOUCHER'),(20193,'STR_GL_SALES_ENTRIES_NOT_FROM_INVOICING'),(20194,'STR_INVOICES_POSTED_TO_MONTH'),(20195,'STR_INVOICE_MAY_BE_POSTED_TO_A_DIFFERENT_MONTH_THAN_THESE_ENTRIES_OCCURRED'),(20196,'STR_INVOICE_NON_SALES_ACCOUNT_TOTAL'),(20197,'STR_INVOICE_POST_DATE'),(20198,'STR_INVOICE_SUBTOTAL'),(20199,'STR_INVOICE_SUBTOTAL_LESS_NON_SALES'),(20200,'STR_LESS'),(20201,'STR_NON_SALES_ACCOUNT_LINE_ITEMS'),(20202,'STR_RECONCILIATION_SUMMARY'),(20203,'STR_SALES_RECONCILIATION'),(20204,'STR_SHOW_HIDE_INVOICES'),(20205,'STR_SHOW_HIDE_TRANSACTIONS'),(20206,'STR_UPDATED_FROM'),(20207,'STR_HIDE_ZERO_BALANCE_LINES'),(20208,'STR_TRANSFER_TITLES'),(20209,'STR_SHOW_MONTHS_OF_EXCESS_QTY'),(20210,'STR_USERS_CAN_CHANGE_VENDOR_PRODUCT_CODES_DURING_PO_ENTRY'),(20211,'STR_TRANFER_TITLES'),(20212,'STR_USER_CAN_ENTER_ANY_TITLE'),(20213,'STR_FROM_APPOVED_LIST_ONLY'),(20214,'STR_ITEM_INVOICING_USES_ACCOUNTS_SET'),(20215,'STR_AT_TIME_OF_ORDER_ENTRY'),(20216,'STR_AT_TIME_OF_INVOICING'),(20217,'STR_VENDOR_PROFITABILITY_DETAILS'),(20218,'STR_DUPLICATE_REQUEST'),(20219,'STR_DUPLICATE'),(20220,'STR_REMOVE_DUPLICATES_BEFORE_SAVING'),(20221,'STR_DO_NOT_SHOW_PRICING_ON_PACKING_SLIP'),(20222,'STR_ENLARGE_ORDER_INFO_TEXT_ON_ORDER_CONFIRMATION'),(20223,'STR_EXCLUDE_CREDITS_FROM_INVOICE_AGING'),(20224,'STR_GROUP_ITEMS_ON_ORDER_CONFIRMATION'),(20225,'STR_HIDE_DUE_DATE_ON_PAYMENT_PAGE'),(20226,'STR_INVOICE_AGING_USES_WHICH_DATE'),(20227,'STR_PRICE_HISTORY_FOR_ORDERS'),(20228,'STR_PRICE_HISTORY_LENGTH'),(20229,'STR_SHOW_ADJUSTED_BALANCE_ON_PAYMENT_PAGE'),(20230,'STR_SHOW_AMOUNT_AND_DUE_DATE_IN_BOTTOM_LEFT_OF_FOOTER'),(20231,'STR_SHOW_DATE_ON_PAYMENT_PAGE'),(20232,'STR_SHOW_INVOICED_PRICES'),(20233,'STR_SHOW_ORDER_PRICES'),(20234,'STR_ADJUSTED_BALANCE'),(20235,'STR_COMPARE_TO_LAST_12_MONTHS_SALES'),(20236,'STR_PREVIOUS_YEAR'),(20237,'STR_ARE_YOU_SURE_YOU_WANT_TO_CREATE_PURCHASE_ORDERS_FOR_THE_SELECTED'),(20238,'STR_CREATED_TRANSFER'),(20239,'STR_CREATE_PURCHASE_ORDERS_FOR_SELECTED'),(20240,'STR_CREATE_TRANSFERS_FROM_DC_FOR_SELECTED'),(20241,'STR_SELECT_TO_CREATE_PO'),(20242,'STR_SELECT_TO_CREATE_PO_OR_TRANSFER'),(20243,'STR_SELECT_TO_CREATE_TRANSFER'),(20244,'STR_SELECT_TO_PRINT'),(20245,'STR_DELETE_THIS_NON_PRINTING_OPERATION_SIZE_PRICING'),(20246,'STR_ADD_NEW_NON_PRINTING_PRICE_LIST'),(20247,'STR_DELETE_THIS_NON_PRINTING_PRICE_LIST'),(20248,'STR_DISABLE_COST_CODE_SLASH_GL_CATEGORY_VALIDATION'),(20249,'STR_COST_CODE_SLASH_GL_CATEGORY_VALIDATION_DISABLED'),(20250,'STR_ALLOW_NEGATIVE_QUANTITY_SALES'),(20251,'STR_CHANGE_VENDOR_PRODUCT_CODE'),(20252,'STR_DO_NOT_SHOW_PRICES_ON_PACKING_SLIP'),(20253,'STR_CANNOT_SAVE_INVOICE_AS_IT_HAS_BEEN_DELETED_OR_MODIFIED'),(20254,'STR_SYSTEM_IS_BUSY'),(20255,'STR_OTHER_VOUCHERS_FOR_THIS_INVOICE'),(20256,'STR_IMPORT_TO_CONTINUE'),(20257,'STR_PRESS_NEXT_TO_CONTINUE'),(20258,'STR_SAVE_TO_CONTINUE'),(20259,'STR_NO_TOOLS_ALLOWED_ON_JOBS'),(20260,'STR_LAST_PO_RECEIVED_DATE'),(20261,'STR_LAST_TRANSFER_RECEIVED_DATE'),(20262,'STR_ADJUST_QTY_ON_PO_WHEN_CUSTOMER_ORDER_QTY_CHANGES'),(20263,'STR_ADJUST_COST_ON_PO_WHEN_CUSTOMER_ORDER_COST_CHANGES'),(20264,'STR_NOT_ALLOWED_TO_UNCHECK_TAX_BOXES_ON_LINE_ITEMS'),(20265,'STR_NO_CHECK_PAYMENT'),(20266,'STR_NO_CREDIT_CARD_PAYMENT');
/*!40000 ALTER TABLE `lang` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `langcompany`
--

DROP TABLE IF EXISTS `langcompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `langcompany` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `active` int(2) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `langcompany`
--

LOCK TABLES `langcompany` WRITE;
/*!40000 ALTER TABLE `langcompany` DISABLE KEYS */;
INSERT INTO `langcompany` VALUES (1,1,1,1),(2,1,3,1);
/*!40000 ALTER TABLE `langcompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `langdef`
--

DROP TABLE IF EXISTS `langdef`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `langdef` (
  `id` int(11) NOT NULL auto_increment,
  `langid` int(11) NOT NULL default '0',
  `langcode` char(2) NOT NULL default '',
  `textvalue` varchar(255) NOT NULL default '',
  `custom` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `langidcode` (`langid`,`langcode`)
) ENGINE=InnoDB AUTO_INCREMENT=606408 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `langdef`
--

LOCK TABLES `langdef` WRITE;
/*!40000 ALTER TABLE `langdef` DISABLE KEYS */;
INSERT INTO `langdef` VALUES (1,1,'is','',0),(2,1,'dr','Ù…ØªÙ† ',0),(3,1,'pr','Ù…ØªÙ† ',0),(4,1,'tr','Metin',0),(5,1,'pl','Tekst',0),(6,1,'bg','Ð¢ÐµÐºÑÑ‚',0),(7,1,'ur','Ù…ØªÙ†',0),(8,1,'sr','Ð¢ÐµÐºÑÑ‚',0),(9,1,'vi','VÄƒn báº£n',0),(10,1,'af','Teks',0),(11,1,'ro','Textul',0),(12,1,'et','Teksti',0),(13,1,'si','Besedilo',0),(14,1,'ba','Teks',0),(15,1,'nl','Tekst',0),(16,1,'fi','Teksti',0),(17,1,'no','Tekst',0),(18,1,'da','Tekst',0),(19,1,'ko','í…ìŠ¤íŠ¸',0),(20,1,'he','×˜×§×¡×˜',0),(21,1,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿',0),(22,1,'zh','æ–‡æœ¬\r\n',0),(23,1,'sv','Text',0),(24,1,'it','Testo',0),(25,1,'tl','',0),(26,1,'th','Text',0),(27,1,'hi','à¤ªà¤¾à¤ ',0),(28,1,'ms','Teks',0),(29,1,'ar','Ù†Øµ',0),(30,1,'fr','Texte',0),(31,1,'jp','Text',0),(32,1,'pt','Texto',0),(33,1,'ru','Ð¢ÐµÐºÑÑ‚',0),(34,1,'es','Texto',0),(35,1,'de','Text',0),(36,1,'en','Text',0),(37,2,'is','',0),(38,2,'dr','1Ø±ÙˆØ²',0),(39,2,'pr','1Ø±ÙˆØ²',0),(40,2,'tr','1DA',0),(41,2,'pl','1DA',0),(42,2,'bg','1DA',0),(43,2,'ur','Ø§ÛŒÚ© Ø¯Ù†',0),(44,2,'sr','1Ð”Ð',0),(45,2,'vi','1DA',0),(46,2,'af','1DA',0),(47,2,'ro','1DA',0),(48,2,'et','1DA',0),(49,2,'si','1DA',0),(50,2,'ba','1DA',0),(51,2,'nl','1DA',0),(52,2,'fi','1DA',0),(53,2,'no','1DA',0),(54,2,'da','1DA',0),(55,2,'ko','1DA',0),(56,2,'he','1DA',0),(57,2,'el','1DA',0),(58,2,'zh','1å¤©\r\n',0),(59,2,'sv','1DA',0),(60,2,'it','Matrice Unidimensionale',0),(61,2,'tl','',0),(62,2,'th','1DA',0),(63,2,'hi','1DA',0),(64,2,'ms','1DA',0),(65,2,'ar','1DA',0),(66,2,'fr','1DA',0),(67,2,'jp','1DA',0),(68,2,'pt','1DA',0),(69,2,'ru','1DA',0),(70,2,'es','1DA',0),(71,2,'de','1DA',0),(72,2,'en','1DA',0),(73,3,'is','',0),(74,3,'dr','Ø§ÙˆÙ„ÛŒÙ†',0),(75,3,'pr','Ø§ÙˆÙ„ÛŒÙ†',0),(76,3,'tr','1.',0),(77,3,'pl','1.',0),(78,3,'bg','1.',0),(79,3,'ur','Ù¾Ú¾Ù„Ø§',0),(80,3,'sr','1',0),(81,3,'vi','1st',0),(82,3,'af','1ste',0),(83,3,'ro','Primul',0),(84,3,'et','1ne',0),(85,3,'si','1.vi',0),(86,3,'ba','Pertama',0),(87,3,'nl','1e',0),(88,3,'fi','1.',0),(89,3,'no','fÃ¸rste',0),(90,3,'da','1.',0),(91,3,'ko','1',0),(92,3,'he','1',0),(93,3,'el','1.',0),(94,3,'zh','ç¬¬ä¸€',0),(95,3,'sv','1:a',0),(96,3,'it','1Â°',0),(97,3,'tl','',0),(98,3,'th','1ST',0),(99,3,'hi','1st',0),(100,3,'ms','1',0),(101,3,'ar','Ø§Ù„Ø£ÙˆÙ„',0),(102,3,'fr','1er',0),(103,3,'jp','1st',0),(104,3,'pt','1.',0),(105,3,'ru','1-Ð¹',0),(106,3,'es','1ero',0),(107,3,'de','Erste(r)',0),(108,3,'en','1st',0),(109,4,'is','',0),(110,4,'dr','2Ø±ÙˆØ²',0),(111,4,'pr','2Ø±ÙˆØ²',0),(112,4,'tr','2DA',0),(113,4,'pl','2DA',0),(114,4,'bg','2DA',0),(115,4,'ur','Ø¯Ùˆ Ø¯Ù†',0),(116,4,'sr','2Ð”Ð',0),(117,4,'vi','2DA',0),(118,4,'af','2DA',0),(119,4,'ro','2DA',0),(120,4,'et','2DA',0),(121,4,'si','2DA',0),(122,4,'ba','2DA',0),(123,4,'nl','2DA',0),(124,4,'fi','2DA',0),(125,4,'no','2DA',0),(126,4,'da','2DA',0),(127,4,'ko','2DA',0),(128,4,'he','2DA',0),(129,4,'el','2DA',0),(130,4,'zh','2å¤©\r\n',0),(131,4,'sv','2DA',0),(132,4,'it','Matrice Bidimensionale',0),(133,4,'tl','',0),(134,4,'th','2DA',0),(135,4,'hi','2DA',0),(136,4,'ms','2DA',0),(137,4,'ar','2DA',0),(138,4,'fr','2DA',0),(139,4,'jp','2DA',0),(140,4,'pt','2DA',0),(141,4,'ru','2DA',0),(142,4,'es','2DA',0),(143,4,'de','2DA',0),(144,4,'en','2DA',0),(145,5,'is','',0),(146,5,'dr','3 Ø±ÙˆØ²',0),(147,5,'pr','3 Ø±ÙˆØ²',0),(148,5,'tr','3DS',0),(149,5,'pl','3DS',0),(150,5,'bg','3DS',0),(151,5,'ur','ØªÛŒÙ† Ø¯Ù†',0),(152,5,'sr','3Ð”Ð¡',0),(153,5,'vi','3DS',0),(154,5,'af','3DS',0),(155,5,'ro','3DS',0),(156,5,'et','3DS',0),(157,5,'si','3DS',0),(158,5,'ba','3DS',0),(159,5,'nl','3DS',0),(160,5,'fi','3DS',0),(161,5,'no','3DS',0),(162,5,'da','3DS',0),(163,5,'ko','3DS',0),(164,5,'he','3DS',0),(165,5,'el','3DS',0),(166,5,'zh','ä¸‰å¤©',0),(167,5,'sv','3DS',0),(168,5,'it','Matrici Tridimensionale',0),(169,5,'tl','',0),(170,5,'th','3DS',0),(171,5,'hi','3DS',0),(172,5,'ms','3DS',0),(173,5,'ar','3DS',0),(174,5,'fr','3DS',0),(175,5,'jp','3DS',0),(176,5,'pt','3DS',0),(177,5,'ru','3DS',0),(178,5,'es','3DS',0),(179,5,'de','3DS',0),(180,5,'en','3DS',0),(181,6,'is','',0),(182,6,'dr','8.5x11 Ù…Ø¹Ø§Ø¯Ù„ ØµÙØ­Ø§Øª x Ù…Ù‚Ø¯Ø§Ø±',0),(183,6,'pr','8.5x11 Ù…Ø¹Ø§Ø¯Ù„ ØµÙØ­Ø§Øª x Ù…Ù‚Ø¯Ø§Ø±',0),(184,6,'tr','8.5x11 equiv yaprak x miktar',0),(185,6,'pl','8.5x11 equiv arkuszy x iloÅ›Ä‡',0),(186,6,'bg','8.5x11 ÐµÐºÐ² Ð»Ð¸ÑÑ‚Ð¾Ð²Ðµ x ÐºÐ¾Ð»',0),(187,6,'ur','85 x 11',0),(188,6,'sr','8.5 x11 ÐµqÑƒÐ¸Ð² Ð»Ð¸ÑÑ‚Ð¾Ð²Ð° x ÐšÐ¾Ð»',0),(189,6,'vi','8.5x11 equiv sheets x qty',0),(190,6,'af','8.5x11 soortgelyke blaaie x hoev.',0),(191,6,'ro','8.5x11 echiv. pag. x cant.',0),(192,6,'et','8.5x11 ekvivalent lehte x kogus',0),(193,6,'si','8.5x11 equiv listov x koliÄina',0),(194,6,'ba','Kertas Uk.8,5x11 x jumlah',0),(195,6,'nl','8.5x11 equiv bladen x aantal',0),(196,6,'fi','8.5x11 equiv levyt x kpl',0),(197,6,'no','8.5x11 equiv ark x antall',0),(198,6,'da','8.5x11 equiv ark x antal',0),(199,6,'ko','8.5 x 11 equiv ì‹œíŠ¸ x ìˆ˜ëŸ‰',0),(200,6,'he','×›×ž×•×ª ×©×œ x 8.5 x11 equiv ×’×œ×™×•× ×•×ª',0),(201,6,'el','8.5x11 equiv Ï†ÏÎ»Î»Î± x qty',0),(202,6,'zh','8.5x11 ç­‰æ•ˆå¼  Ã— æ•°é‡\r\n',0),(203,6,'sv','8,5x11 motsv. blad x kvant.',0),(204,6,'it','equivalente fogli 8.5x11 x quantitÃ ',0),(205,6,'tl','',0),(206,6,'th','8.5 X 11',0),(207,6,'hi','8.5 x11 equiv à¤šà¤¾à¤¦à¤°à¥‡à¤‚ à¤à¤•à¥à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(208,6,'ms','8.5x11 equiv cadar x qty',0),(209,6,'ar','8.5 x11 equiv Ø£ÙˆØ±Ø§Ù‚ x Ø§Ù„ÙƒÙ…ÙŠØ©',0),(210,6,'fr','8.5x11 Papiers Ã©quiv. x qtÃ©',0),(211,6,'jp','8.5x11 equiv sheets x qty',0),(212,6,'pt','8.5 X11 equiv folhas x Qtde',0),(213,6,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð»Ð¸ÑÑ‚Ð¾Ð² equiv x 8.5x11',0),(214,6,'es','8.5x11 hojas y cant.',0),(215,6,'de','8.5 Equiv BlÃ¤tter X Menge',0),(216,6,'en','8.5x11 equiv sheets x qty',0),(217,7,'is','',0),(218,7,'dr','8.5x11 Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¹Ø§Ø¯Ù„',0),(219,7,'pr','8.5x11 Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¹Ø§Ø¯Ù„',0),(220,7,'tr','8.5x11 equiv Mkt.',0),(221,7,'pl','8.5x11 equiv iloÅ›Ä‡',0),(222,7,'bg','8.5x11 ÐµÐºÐ² ÐºÐ¾Ð»',0),(223,7,'ur','85 x 11 Ø¨Ø±Ø§Ø¨Ø± Ù…Ù‚Ø¯Ø§Ø±',0),(224,7,'sr','8.5 x11 ÐµqÑƒÐ¸Ð² ÐšÐ¾Ð».',0),(225,7,'vi','8.5x11 equiv qty',0),(226,7,'af','8.5x11 soortgelyke hoev.',0),(227,7,'ro','8.5x11 echiv. cant.',0),(228,7,'et','8.5x11 ekvivalent kogus',0),(229,7,'si','8.5x11 equiv kol',0),(230,7,'ba','Jumlah 8,5x11',0),(231,7,'nl','8.5x11 equiv qty',0),(232,7,'fi','8.5x11 equiv mÃ¤Ã¤rÃ¤',0),(233,7,'no','8.5x11 equiv Ant',0),(234,7,'da','8.5x11 equiv qty',0),(235,7,'ko','8.5 x 11 equiv ìˆ˜ëŸ‰',0),(236,7,'he','×›×ž×•×ª equiv 8.5 x11',0),(237,7,'el','8.5x11 equiv qty',0),(238,7,'zh','8.5x11 åŒç­‰æ•°é‡\r\n',0),(239,7,'sv','8,5x11 motsv. kvantitet',0),(240,7,'it','quantitÃ  equivalente 8.5x11',0),(241,7,'tl','',0),(242,7,'th','8.5x11 equiv qty',0),(243,7,'hi','8.5 x11 equiv à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(244,7,'ms','8.5x11 equiv qty',0),(245,7,'ar','qty equiv 8.5 x11',0),(246,7,'fr','8.5x11 qtÃ© Ã©quiv.',0),(247,7,'jp','8.5x11 equiv qty',0),(248,7,'pt','8.5 X11 equiv qty',0),(249,7,'ru','8.5x11 equiv ÑˆÑ‚',0),(250,7,'es','8.5x11 cant.',0),(251,7,'de','8.5 Equiv qty',0),(252,7,'en','8.5x11 equiv qty',0),(253,8,'is','',0),(254,8,'dr','941',0),(255,8,'pr','941',0),(256,8,'tr','941',0),(257,8,'pl','941',0),(258,8,'bg','941',0),(259,8,'ur','Ù†Ùˆ Ø³Ùˆ Ø§Ú©ØªØ§Ù„ÛŒØ³',0),(260,8,'sr','941',0),(261,8,'vi','941',0),(262,8,'af','941',0),(263,8,'ro','941',0),(264,8,'et','941',0),(265,8,'si','941',0),(266,8,'ba','941',0),(267,8,'nl','941',0),(268,8,'fi','941',0),(269,8,'no','941',0),(270,8,'da','941',0),(271,8,'ko','941',0),(272,8,'he','941',0),(273,8,'el','941',0),(274,8,'zh','941',0),(275,8,'sv','941',0),(276,8,'it','941',0),(277,8,'tl','',0),(278,8,'th','941',0),(279,8,'hi','941',0),(280,8,'ms','941',0),(281,8,'ar','941',0),(282,8,'fr','941',0),(283,8,'jp','941',0),(284,8,'pt','941',0),(285,8,'ru','941',0),(286,8,'es','941',0),(287,8,'de','941',0),(288,8,'en','941',0),(289,9,'is','',0),(290,9,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(291,9,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(292,9,'tr','Zaten bu adda bir taÅŸÄ±yÄ±cÄ± olduÄŸunu.<br>',0),(293,9,'pl','Jest juÅ¼ przewoÅºnika z tÄ… nazwÄ…<br>',0),(294,9,'bg','Ð¢Ð°Ð¼ Ðµ Ð²ÐµÑ‡Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ Ñ Ñ‚Ð¾Ð²Ð° Ð¸Ð¼Ðµ<br>',0),(295,9,'ur','Ø§Ø³ Ù†Ø§Ù… Ø³Û’ Ø§ÛŒÚ© ÚˆØ³Ú© Ù¾ÛÙ„Û’ ÛÛŒ ÛÛ’<br>',0),(296,9,'sr','ÐÐ¾ÑÐ¸Ð»Ð°Ñ† ÑÐ° Ñ‚Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸<br>',0),(297,9,'vi','ÄÃ£ cÃ³ má»™t HÃ£ng Váº­n Chuyá»ƒn cÃ³ tÃªn nÃ y',0),(298,9,'af','Daar is reeds \'n draer met daardie naam<br>',0),(299,9,'ro','ExistÄƒ deja un transportator cu acest nume<br>',0),(300,9,'et','Vedaja nimi on juba olemas<br>',0),(301,9,'si','Prevoznik s tem imenom Å¾e obstaja<br>',0),(302,9,'ba','Sudah ada pembawa dengan nama<br>',0),(303,9,'nl','Er is al een drager met die naam<br>',0),(304,9,'fi','On jo samanniminen harjoittaja<br>',0),(305,9,'no','Det finnes allerede en Carrier med navnet<br>',0),(306,9,'da','Der er allerede en transportÃ¸r med navnet<br>',0),(307,9,'ko','ì´ë¯¸ ê·¸ ì´ë¦„ìœ¼ë¡œ ìºë¦¬ì–´<br>',0),(308,9,'he','×™×© ×›×‘×¨ × ×©× ×¢× ×”×©× ×›×–×”<br>',0),(309,9,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î­Î½Î±Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±Ï‚ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±<br>',0),(310,9,'zh','å·²ç»æœ‰ä¸€ä¸ªæœ‰æ­¤åç§°çš„æ‰¿è¿äºº\r\n',0),(311,9,'sv','Det finns redan en transportÃ¶r med namnet<br>',0),(312,9,'it','C\'Ã¨ giÃ  un vettore con quel nome<br>',0),(313,9,'tl','',0),(314,9,'th','&#3609;&#3637;&#3656;&#3588;&#3639;&#3629;&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3607;&#3637;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;<br>',0),(315,9,'hi','à¤µà¤¹à¤¾à¤ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤¸ à¤¨à¤¾à¤® à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤µà¤¾à¤¹à¤• à¤¹à¥ˆ<br>',0),(316,9,'ms','Sudah ada sebuah pesawat dengan nama itu<br>',0),(317,9,'ar','Ù‡Ù†Ø§Ùƒ Ø¨Ø§Ù„ÙØ¹Ù„ Ù†Ø§Ù‚Ù„ Ø¨Ù‡Ø°Ø§ Ø§Ù„Ø§Ø³Ù…<br>',0),(318,9,'fr','Il y a dÃ©jÃ  un transporteur avec ce nom<br>',0),(319,9,'jp','å?Œã?˜å??å‰?ã?®ã‚­ãƒ£ãƒªã‚¢ã?Œæ—¢å­˜ã?—ã?¾ã?™<br>',0),(320,9,'pt','JÃ¡ existe um portador com esse nome<br>',0),(321,9,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº Ñ Ñ‚Ð°ÐºÐ¸Ð¼ Ð¸Ð¼ÐµÐ½ÐµÐ¼ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚<br>',0),(322,9,'es','Ya hay un transportador con este nombre<br>',0),(323,9,'de','Ein TrÃ¤ger mit diesem Namen ist bereits vorhanden<br>',0),(324,9,'en','There is already a Carrier with that name<br>',0),(325,10,'is','',0),(326,10,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ù†Ù‚Øµ Ø¬Ø¯ÙŠ Ø±ÙˆÙŠ Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª Ùˆ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ù†ÙŠØ³Øª',0),(327,10,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ù†Ù‚Øµ Ø¬Ø¯ÙŠ Ø±ÙˆÙŠ Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª Ùˆ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ù†ÙŠØ³Øª',0),(328,10,'tr','Geri dÃ¶nÃ¼lemez bir hata oluÅŸtu.  Mali yÄ±lÄ±n baÅŸlamasÄ± ay alÄ±namÄ±yor.',0),(329,10,'pl','Katastrofalny bÅ‚Ä…d wystÄ…piÅ‚.  Nie moÅ¼na pobraÄ‡ rok obrachunkowy rozpoczyna siÄ™ miesiÄ…c.',0),(330,10,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð°Ð»Ð° Ðµ Ð¿Ð¾Ð²Ñ€ÐµÐ´Ð° Ñ ÐºÐ°Ñ‚Ð°ÑÑ‚Ñ€Ð¾Ñ„Ð°Ð»Ð½Ð¸.  ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð¼ÐµÑÐµÑ†.',0),(331,10,'ur','Ù…ÛŒÚº Ù…Ú©Ù…Ù„ Ù†Ø§Ú©Ø§Ù…ÛŒ ÙˆØ§Ù‚Ø¹ ÛÙˆØ§ ÛÛ’ Û”  Ø¨Ø§Ø² Ú¯ÛŒØ± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Ù†Û’ Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ú©Ø§ Ø¢ØºØ§Ø² Ù…Ø§Û Û”',0),(332,10,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ ÐºÐ°Ñ‚Ð°ÑÑ‚Ñ€Ð¾Ñ„Ñƒ.  ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¼ÐµÑÐµÑ†Ð° Ð¿Ð¾Ñ‡ÐµÑ‚Ð¸.',0),(333,10,'vi','ChÆ°Æ¡ng trÃ¬nh bá»‹ lá»—i. KhÃ´ng thá»ƒ láº¥y sá»‘ liá»‡u cá»§a thÃ¡ng báº¯t Ä‘áº§u nÄƒm tÃ i chÃ­nh',0),(334,10,'af','\'n Katestrofiese terugslag het ontstaan. Nie instaat om fisiese jaar beginmaand te herwin.',0),(335,10,'ro','Un eÅŸec catastrofalÄƒ a apÄƒrut.  Imposibil de regÄƒsit anul fiscal incepe luna.',0),(336,10,'et','Ilmnenud on Katastroofini viiva rikke.  Ei saa tuua majandusaasta algab kuu.',0),(337,10,'si','PriÅ¡lo je do katastrofalno okvaro.  Ni mogoÄe pridobiti poslovnega leta zaÄeli mesec.',0),(338,10,'ba','Kegagalan bencana telah terjadi.  Mampu mengambil tahun fiskal mulai bulan.',0),(339,10,'nl','Een onherstelbare fout is opgetreden.  Niet in staat om op te halen het fiscale jaar beginnen maand.',0),(340,10,'fi','Katastrofaalinen virhe.  Ei voi noutaa tilikauden alkaa kuukauden.',0),(341,10,'no','Det oppstod en katastrofal feil.  Kan ikke hente regnskapsÃ¥ret begynner mÃ¥ned.',0),(342,10,'da','Der opstod en katastrofal fejl.  Kunne ikke hente regnskabsÃ¥ret starter mÃ¥ned.',0),(343,10,'ko','ì¹˜ëª…ì ì¸ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.  ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤ íšŒê³„ ì—°ë„ì˜ ë‹¬ ì‹œìž‘.',0),(344,10,'he','×”×ª×¨×—×© ×›×©×œ ×§×˜×¡×˜×¨×•×¤×œ×™.  ××™×Ÿ ××¤×©×¨×•×ª ×œ××—×–×¨ ×©× ×ª ×”×›×¡×¤×™× ×ž×ª×—×™×œ×” ×‘×—×•×“×©.',0),(345,10,'el','ÎœÎ¹Î± ÎºÎ±Ï„Î±ÏƒÏ„ÏÎ¿Ï†Î¹ÎºÎ® Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î± Î­Ï‡ÎµÎ¹ ÏƒÏ…Î¼Î²ÎµÎ¯.  Î”Ï…Î½Î±Ï„ÏŒ Î½Î± Î±Î½Î±ÎºÏ„Î®ÏƒÎµÎ¹ Ï„Î¿ Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚ Î±ÏÏ‡Î¯Î¶Î¿Ï…Î½ Ï„Î¿ Î¼Î®Î½Î±.',0),(346,10,'zh','å‘ç”Ÿã€‚æ— æ³•æ£€ç´¢è´¢æ”¿å¹´åº¦å¼€å§‹æœˆä»½.ä¸€ä¸ªä¸¥é‡çš„é”™è¯¯å‘ç”Ÿ\r\n',0),(347,10,'sv','Ett oÃ¥terkalleligt fel har intrÃ¤ffat.  Det gick inte att hÃ¤mta rÃ¤kenskapsÃ¥ret bÃ¶rjar mÃ¥nad.',0),(348,10,'it','Si Ã¨ verificato un guasto catastrofico.  Impossibile recuperare l\'anno fiscale inizio mese.',0),(349,10,'tl','',0),(350,10,'th','&#3648;&#3585;&#3636;&#3604;&#3588;&#3623;&#3634;&#3617;&#3627;&#3634;&#3618;&#3609;&#3632;&#3629;&#3633;&#3609;&#3651;&#3627;&#3597;&#3656;&#3627;&#3621;&#3623;&#3591;&#3586;&#3638;&#3657;&#3609; &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#',0),(351,10,'hi','à¤à¤• à¤µà¤¿à¤ªà¤¤à¥à¤¤à¤¿à¤ªà¥‚à¤°à¥à¤£ à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤¹à¥à¤ˆà¥¤  à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥ à¤µà¤¿à¤¤à¥à¤¤ à¤µà¤°à¥à¤· à¤¶à¥à¤°à¥‚ à¤¹à¥‹ à¤®à¤¹à¥€à¤¨à¥‡à¥¤',0),(352,10,'ms','Kegagalan yang membawa bencana berlaku.  Tidak dapat mendapat semula tahun fiskal mula bulan.',0),(353,10,'ar','Ø­Ø¯Ø« Ø¹Ø·Ù„ ÙƒØ§Ø±Ø«ÙŠ.  ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ ØªØ¨Ø¯Ø£ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© ÙÙŠ Ø§Ù„Ø´Ù‡Ø±.',0),(354,10,'fr','Une panne catastrophique.  Impossible de rÃ©cupÃ©rer l\'exercice commencer mois.',0),(355,10,'jp','è‡´å‘½çš„ã‚¨ãƒ©ãƒ¼ã?Œç™ºç”Ÿã?„ã?Ÿã?—ã?¾ã?—ã?Ÿã€‚ä¼šè¨ˆå¹´åº¦é–‹å§‹ã?¤ã??ã?Œå?Žé›†ã?§ã??ã?¾ã?›ã‚“',0),(356,10,'pt','Ocorreu uma falha catastrÃ³fica.  NÃ£o Ã© possÃ­vel recuperar o exercÃ­cio comeÃ§ar mÃªs.',0),(357,10,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð° Ñ„Ð°Ñ‚Ð°Ð»ÑŒÐ½Ð°Ñ Ð¾ÑˆÐ¸Ð±ÐºÐ°.  ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´ Ð½Ð°Ñ‡Ð¸Ð½Ð°ÐµÑ‚ÑÑ Ð¼ÐµÑÑÑ†.',0),(358,10,'es','Una falla catÃ¡strofe ha sucedido. No se puede recuperar el mes de Comienzo de ejercicio',0),(359,10,'de','Ein schwerwiegender Fehler ist aufgetreten.  Konnte nicht abgerufen werden das GeschÃ¤ftsjahr beginnen Monat.',0),(360,10,'en','A catastrophic failure has occurred.  Unable to retrieve the fiscal year begin month.',0),(361,11,'is','',0),(362,11,'dr','ÙŠÙƒ Ù…Ø§Ù‡  Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ Ù…Ø§Ù„ÙŠ  Ø¨Ø±Ø§ÙŠ  Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ù…Ø´Ø®Øµ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(363,11,'pr','ÙŠÙƒ Ù…Ø§Ù‡  Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ Ù…Ø§Ù„ÙŠ  Ø¨Ø±Ø§ÙŠ  Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ù…Ø´Ø®Øµ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(364,11,'tr','Mali yÄ±l baÅŸlayan ay deÄŸil bu ÅŸirket iÃ§in koymak.  BÃ¼tÃ§e liste devam edilemiyor.',0),(365,11,'pl','Rok obrachunkowy rozpoczyna miesiÄ…c nie zostaÅ‚a ustawiona dla tej firmy.  Nie moÅ¼na kontynuowaÄ‡ listÄ™ budÅ¼etu.',0),(366,11,'bg','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð¼ÐµÑÐµÑ† Ð½Ðµ Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°.  ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸ Ð±ÑŽÐ´Ð¶ÐµÑ‚ ÑÐ¿Ð¸ÑÑŠÐº.',0),(367,11,'ur','Ø§ÛŒÚ© Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ú©Ø§ Ø¢ØºØ§Ø² Ù…Ø§Û ÛÛ’ Ú¯ÛŒØ§ Ø³ÛŒÙ¹ Ù†ÛÛŒÚº Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„Ø¦Û’ Û”  Ø¨Ø¬Ù¹ ÙÛØ±Ø³Øª Ø¬Ø§Ø±ÛŒ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(368,11,'sr','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¿Ð¾Ñ‡ÐµÑ‚Ð¸ Ð¼ÐµÑÐµÑ†Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½ Ð·Ð° Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ.  ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ð¸ Ð±ÑƒÑŸÐµÑ‚ Ð»Ð¸ÑÑ‚Ðµ.',0),(369,11,'vi','ThÃ¡ng báº¯t Ä‘áº§u nÄƒm tÃ i chÃ­nh chÆ°a Ä‘Æ°á»£c setup cho cÃ´ng ty nÃ y. KhÃ´ng thá»ƒ tiáº¿p tá»¥c danh sÃ¡ch ngÃ¢n sÃ¡ch.',0),(370,11,'af','\'n Fisiese jaar beginmaand is nie gestel vir hierdie onderneming.  Onmoontlik om voort te gaan met begrotingslys.',0),(371,11,'ro','O anul fiscal incepe luni nu a fost stabilit pentru aceastÄƒ companie.  Imposibilitatea de a continua lista de buget.',0),(372,11,'et','Majandusaasta algab kuu ei mÃ¤Ã¤ra selle firma.  Ei saa jÃ¤tkata eelarve nimekirja.',0),(373,11,'si','Poslovno leto zaÄeli mesec niste nastavili za to podjetje.  Mogel nadaljevati proraÄuna seznam.',0),(374,11,'ba','Tahun fiskal mulai bulan tidak telah ditetapkan untuk perusahaan ini.  Tidak dapat melanjutkan daftar anggaran.',0),(375,11,'nl','Het fiscale jaar beginnen maand niet is ingesteld voor dit bedrijf.  Kan niet blijven begroting lijst.',0),(376,11,'fi','Tilikausi alkaa kuukauden ei ole mÃ¤Ã¤ritetty tÃ¤lle yritykselle.  Ei voi jatkaa budjetti luetteloon.',0),(377,11,'no','RegnskapsÃ¥ret begynner mÃ¥ned er ikke angitt for dette selskapet.  Kan ikke fortsette budsjett listen.',0),(378,11,'da','Et regnskabsÃ¥r starter mÃ¥ned er ikke blevet angivet for dette selskab.  Stand til at fortsÃ¦tte budgettet liste.',0),(379,11,'ko','íšŒê³„ ì—°ë„ ì‹œìž‘ ë‹¬ì´ì´ íšŒì‚¬ì— ëŒ€ í•œ ì„¤ì • ë˜ì§€ ì•Šì•˜ìŠµë‹ˆë‹¤.  ì˜ˆì‚° ëª©ë¡ ê³„ì† ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(380,11,'he','×©× ×ª ×›×¡×¤×™× ×œ×”×ª×—×™×œ ×—×•×“×© ×œ× ×”×•×’×“×¨ ×¢×‘×•×¨ ×—×‘×¨×” ×–×•.  ××™×Ÿ ××¤×©×¨×•×ª ×œ×”×ž×©×™×š ××ª ×”×¨×©×™×ž×” ×ª×§×¦×™×‘.',0),(381,11,'el','ÎˆÎ½Î± Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚ Î±ÏÏ‡Î¯Î¶Î¿Ï…Î½ Î¼Î®Î½Î± Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î®.  Î£Îµ Î¸Î­ÏƒÎ· Î½Î± ÏƒÏ…Î½ÎµÏ‡Î¯ÏƒÎµÎ¹ Ï„Î·Î½ Î»Î¯ÏƒÏ„Î± Ï„Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï.',0),(382,11,'zh','ä¼šè®¡å¹´åº¦å¼€å§‹ä¸€ä¸ªæœˆæœ‰æ²¡æœ‰ä¸ºè¿™å®¶å…¬å¸æˆç«‹ã€‚æ— æ³•ç»§ç»­çš„é¢„ç®—æ¸…å•',0),(383,11,'sv','Ett rÃ¤kenskapsÃ¥r bÃ¶rjar mÃ¥nad har inte stÃ¤llts in fÃ¶r det hÃ¤r fÃ¶retaget.  Det gÃ¥r inte att fortsÃ¤tta budget lista.',0),(384,11,'it','Non hai impostato un mese d\'inizio dell\'anno fiscale. Non Ã¨ possibile generare il bilancio.',0),(385,11,'tl','',0),(386,11,'th','&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3605;&#3633;&#3657;&#3591;&#3611;&#3637;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3586;&#3629;&#3591;&#3',0),(387,11,'hi','à¤à¤• à¤µà¤¿à¤¤à¥à¤¤à¥€à¤¯ à¤µà¤°à¥à¤· à¤¶à¥à¤°à¥‚ à¤¹à¥‹ à¤®à¤¾à¤¹ à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤  à¤¬à¤œà¤Ÿ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤œà¤¾à¤°à¥€ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥à¥',0),(388,11,'ms','Tahun fiskal mula bulan tidak disetkan untuk Syarikat ini.  Tidak dapat meneruskan senarai bajet.',0),(389,11,'ar','ØªØ¨Ø¯Ø£ Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø´Ù‡Ø± Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©.  ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ù…ØªØ§Ø¨Ø¹Ø© Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©.',0),(390,11,'fr','Commencer un exercice mois n\'a pas Ã©tÃ© dÃ©finie pour cette sociÃ©tÃ©.  Impossible de continuer la liste de budget.',0),(391,11,'jp','ä¼šè¨ˆå¹´åº¦é–‹å§‹æœˆã?Œè¨­å®šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“ã€‚äºˆç®—ãƒªã‚¹ãƒˆç¶™ç¶šã?§ã??ã?¾ã?›ã‚“',0),(392,11,'pt','ComeÃ§ar um ano fiscal mÃªs nÃ£o tem sido definida para esta empresa.  NÃ£o Ã© possÃ­vel continuar a lista de orÃ§amento.',0),(393,11,'ru','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´ Ð½Ð°Ñ‡Ð¸Ð½Ð°ÐµÑ‚ÑÑ Ð¼ÐµÑÑÑ† Ð½Ðµ Ð±Ñ‹Ð»Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¾ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸.  ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°.',0),(394,11,'es','El mes de Comienzo de ejercicio no ha sido fijado para esta empresa. No se puede continuar la lista de presupuesto',0),(395,11,'de','Ein GeschÃ¤ftsjahr beginnen Monat fÃ¼r diese Firma nicht festgelegt wurde.  Budget Liste fortsetzen konnte nicht gestartet werden.',0),(396,11,'en','A fiscal year begin month has not been set for this company.  Unable to continue budget list.',0),(397,12,'is','',0),(398,12,'dr','.Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ù…ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ Ù†ÙŠØ³Øª',0),(399,12,'pr','ÙŠÙƒ Ø®Ø·Ø§ÙŠ Ø¨Ø²Ø±Ú¯ Ø±ÙˆÙŠ Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª.Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ù…ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ Ù†ÙŠØ³Øª',0),(400,12,'tr','BÃ¼yÃ¼k bir hata oluÅŸtu. Kabul edilen miktarlar alÄ±namÄ±yor.',0),(401,12,'pl','Ogromny bÅ‚Ä…d. Nie moÅ¼na pobraÄ‡ iloÅ›ci popeÅ‚nionych.',0),(402,12,'bg','ÐœÐ°ÑÐ¸Ð²Ð½Ð° Ð³Ñ€ÐµÑˆÐºÐ°. ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð¸Ð·Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸.',0),(403,12,'ur','Ø§ÛŒÚ© Ø¨Ú‘Û’ Ù¾ÛŒÙ…Ø§Ù†Û’ Ù¾Ø± Ù†Ù‚Øµ ÛÙˆ Ú¯ÛŒØ§ Û” Ù…Ù‚Ø¯Ø§Ø± Ú©Ø§ Ø§Ø±ØªÚ©Ø§Ø¨ Ú©ÛŒØ§ Ø¨Ø§Ø²Ú¯ÛŒØ± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(404,12,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð³Ñ€ÐµÑˆÐºÐµ Ñƒ ÐœÐ°ÑÐ¸Ð². ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ Ð¿Ð¾Ñ‡Ð¸Ð½Ð¸Ð»Ð¸.',0),(405,12,'vi','ChÆ°Æ¡ng trÃ¬nh bá»‹ lá»—i. KhÃ´ng thá»ƒ láº¥y sá»‘ lÆ°á»£ng Ä‘Ã£ cam káº¿t.',0),(406,12,'af','\'n Massiewe fatale fout het ontstaan. Kan nie hoeveelhede toevertrou herwin.',0),(407,12,'ro','A apÄƒrut o eroare de masiv. Imposibil de regÄƒsit cantitÄƒÈ›ile comise.',0),(408,12,'et','On tohutu viga. Ei saa tuua koguste toime.',0),(409,12,'si','PriÅ¡lo je do velike napake. KoliÄine, ki so storjena ni mogoÄe pridobiti.',0),(410,12,'ba','Terjadi kesalahan besar. Tidak dapat mengambil jumlah yang berkomitmen.',0),(411,12,'nl','Een enorme fout er is opgetreden. Kan niet achterhalen hoeveelheden begaan.',0),(412,12,'fi','Valtava virhe. Ei voi noutaa mÃ¤Ã¤rÃ¤t sitoutunut.',0),(413,12,'no','En stor feil har oppstÃ¥tt. Kan ikke hente antall begÃ¥tt.',0),(414,12,'da','Der opstod en massiv. Kan ikke hente mÃ¦ngder begÃ¥et.',0),(415,12,'ko','ê±° ëŒ€ í•œ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤. íˆ¬ìž… ìˆ˜ëŸ‰ì„ ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(416,12,'he','××™×¨×¢×” ×©×’×™××ª ×ž×¡×™×‘×™×ª. ××™×Ÿ ××¤×©×¨×•×ª ×œ××—×–×¨ ×”×›×ž×•×™×•×ª ×©×‘×•×¦×¢×•.',0),(417,12,'el','ÎˆÎ½Î± Ï„ÎµÏÎ¬ÏƒÏ„Î¹Î¿ ÏƒÏ†Î¬Î»Î¼Î±. Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î½Î±ÎºÏ„Î®ÏƒÎµÎ¹ Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚ Ï€Î¿Ï… Î´Î¹Î±Ï€ÏÎ¬Ï„Ï„Î¿Î½Ï„Î±Î¹.',0),(418,12,'zh','ä¸€ä¸ªå·¨å¤§çš„é”™è¯¯ã€‚æ— æ³•æ£€ç´¢æ‰€æ‰¿è¯ºçš„é‡ã€‚\r\n',0),(419,12,'sv','En massiv fel har uppstÃ¥tt. Kan inte hÃ¤mta kvantiteter begÃ¥tt.',0),(420,12,'it','Per un incommensurabile errore, non Ã¨ possibile visualizzare le quantitÃ  richieste.',0),(421,12,'tl','',0),(422,12,'th','&#3648;&#3585;&#3636;&#3604;&#3588;&#3623;&#3634;&#3617;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3586;&#3638;&#3657;&#3609; &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3611;&#3619;&#',0),(423,12,'hi','à¤à¤• à¤¬à¤¡à¤¼à¥‡ à¤ªà¥ˆà¤®à¤¾à¤¨à¥‡ à¤ªà¤° à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤¹à¥à¤ˆà¥¤ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾à¥¤',0),(424,12,'ms','Satu ralat yang besar-besaran telah berlaku. Tidak dapat membuka kuantiti yang komited.',0),(425,12,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ ÙˆØ§Ø³Ø¹Ø© Ø§Ù„Ù†Ø·Ø§Ù‚. Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ø³ØªØ±Ø¯Ø§Ø¯ ÙƒÙ…ÙŠØ§Øª Ø§Ù„Ù…Ø±ØªÙƒØ¨Ø©.',0),(426,12,'fr','Une erreur massive s\'est produite. Ne peut pas rÃ©cupÃ©rer des quantitÃ©s engagÃ©es.',0),(427,12,'jp','å¤§ã??ã?ªã‚¨ãƒ©ãƒ¼ã?Œèµ·ã?“ã‚Šã?¾ã?—ã?Ÿã€‚æ•°é‡?ã‚’å®šã‚?ã‚‰ã‚Œã?Ÿæ•°é‡?ã‚’å?Žé›†ã?§ã??ã?¾ã?›ã‚“ã€‚',0),(428,12,'pt','Ocorreu um erro enorme. NÃ£o Ã© possÃ­vel recuperar quantidades comprometidas.',0),(429,12,'ru','ÐœÐ°ÑÑÐ¸Ð²Ð½Ñ‹Ðµ Ð¾ÑˆÐ¸Ð±ÐºÐ°. ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ñ….',0),(430,12,'es','Un error masivo ha ocurrido. No se puede recuperar cantidades compometidas',0),(431,12,'de','Ein massiver Fehler ist aufgetreten. Mengen kÃ¶nnen nicht abgerufen werden.',0),(432,12,'en','A massive error has occurred. Cannot retrieve quantities committed.',0),(433,13,'is','',0),(434,13,'dr','.Ø®Ø·Ø§ Ø¯Ø± Ø®ÙˆØ§Ù†Ø¯Ù† ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø³Ø§Ø®Øª  Ø¨Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯)',0),(435,13,'pr','ÙŠÙƒ Ø®Ø·Ø§ÙŠ ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡ Ø¬Ø¯ÙŠ Ø±ÙˆÙŠ Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª .Ø®Ø·Ø§ Ø¯Ø± Ø®ÙˆØ§Ù†Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª  Ø¨Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯)',0),(436,13,'tr','BÃ¼yÃ¼k, Ã¶nemli bir hata oluÅŸtu. AÃ§Ä±k okuma hatasÄ± sipariÅŸleri oluÅŸturun.',0),(437,13,'pl','WystÄ…piÅ‚ bÅ‚Ä…d krytyczny ogromne. BÅ‚Ä…d podczas odczytywania otwartej tworzenia zamÃ³wienia.',0),(438,13,'bg','ÐœÐ°ÑÐ¸Ð²Ð½Ð° Ñ„Ð°Ñ‚Ð°Ð»Ð½Ð° Ð³Ñ€ÐµÑˆÐºÐ°. Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ñ‡ÐµÑ‚ÐµÐ½Ðµ Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð° Ð¸Ð·Ð³Ñ€Ð°Ð´Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸.',0),(439,13,'ur','Ø§ÛŒÚ© Ø¨Ú‘Û’ Ù¾ÛŒÙ…Ø§Ù†Û’ Ù¾Ø± Ù…ÛÙ„Ú© ØºÙ„Ø·ÛŒ ÙˆØ§Ù‚Ø¹ ÛÙˆØ¦ÛŒ ÛÛ’ Û” Ú©Ú¾Ù„Û’ ÛÙˆØ¦Û’ Ù…Ø·Ø§Ù„Ø¹Û Ù…ÛŒÚº Ù†Ù‚Øµ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ¹Ù…ÛŒØ±.',0),(440,13,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð¼Ð°ÑÐ¸Ð²Ð½Ðµ Ñ„Ð°Ñ‚Ð°Ð»Ð½Ðµ Ð³Ñ€ÐµÑˆÐºÐµ. Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ñ‡Ð¸Ñ‚Ð°ÑšÑƒ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð° Ð¸Ð·Ð³Ñ€Ð°Ð´Ð¸Ñ‚Ð¸ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ.',0),(441,13,'vi','ChÆ°Æ¡ng trÃ¬nh bá»‹ lá»—i. KhÃ´ng Ä‘á»c Ä‘Æ°á»£c Ä‘Æ¡n hÃ ng xÃ¢y dá»±ng má»Ÿ.',0),(442,13,'af','\'n Massiewe fatale fout het ontstaan. ',0),(443,13,'ro','A apÄƒrut o eroare fatalÄƒ masive. Eroare la citirea deschis construi comenzi.',0),(444,13,'et','Massiivne parandamatu tÃµrge ilmnes. Lugemise avatud ehitada tellimusi.',0),(445,13,'si','A massive usodna napaka. Napaka pri branju odprta zgradiÅ¡ naroÄila.',0),(446,13,'ba','Kesalahan fatal besar telah terjadi. Kesalahan membaca terbuka membangun perintah.',0),(447,13,'nl','Een massale fatale fout is opgetreden. Fout bij het lezen open bouwen bestellingen.',0),(448,13,'fi','Massiivinen kohtalokas virhe on tapahtunut. Virhe luettaessa auki rakentaa tilaukset.',0),(449,13,'no','En massiv fatal feil har oppstÃ¥tt. Feil under lesing av Ã¥pne bygge bestillinger.',0),(450,13,'da','En massiv fatal fejl er opstÃ¥et. Fejl ved lÃ¦sning af Ã¥bne bygge ordrer.',0),(451,13,'ko','ê±° ëŒ€ í•œ ì¹˜ëª…ì ì¸ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤. ì˜¤í”ˆ ì½ê¸° ì˜¤ë¥˜ ë¹Œë“œ ìˆœì„œ.',0),(452,13,'he','××™×¨×¢×” ×©×’×™××” ×ž×›×¨×¢×ª ×ž×¡×™×‘×™×ª. ×©×’×™××” ×‘×§×¨×™××ª ×¤×ª×•×— ×œ×‘× ×•×ª ×”×–×ž× ×•×ª.',0),(453,13,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ Î­Î½Î± Ï„ÎµÏÎ¬ÏƒÏ„Î¹Î¿ Î»Î¬Î¸Î¿Ï‚. Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬Î³Î½Ï‰ÏƒÎ· Î±Î½Î¿Î¹ÎºÏ„Î® Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚.',0),(454,13,'zh','ä¸€ä¸ªå·¨å¤§çš„è‡´å‘½é”™è¯¯ã€‚å»ºç«‹å¼€æ”¾çš„é”™è¯¯è¯»å–å‘½ä»¤..\r\n',0),(455,13,'sv','En massiv allvarligt fel har intrÃ¤ffat. Fel vid lÃ¤sning av Ã¶ppna bygga order.',0),(456,13,'it','Errore fatale nella lettura degli ordini di costruzione aperti.',0),(457,13,'tl','',0),(458,13,'th','&#3648;&#3585;&#3636;&#3604;&#3588;&#3623;&#3634;&#3617;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3619;&#3657;&#3634;&#3618;&#3649;&#3619;&#3591;&#3586;&#3638;&#3657;&#3609; &#3586;&#3603;&#3632;&#3585;&#3635;&#3621;&#3633;&#3591;&#3629;&#3656;&#',0),(459,13,'hi','à¤à¤• à¤¬à¤¡à¤¼à¥‡ à¤ªà¥ˆà¤®à¤¾à¤¨à¥‡ à¤ªà¤° à¤—à¤‚à¤­à¥€à¤° à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤¹à¥à¤ˆà¥¤ à¤–à¥à¤²à¤¾ à¤ªà¤¢à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£à¥¤',0),(460,13,'ms','Ralat mati secara besar-besaran telah berlaku. Ralat membaca terbuka membina pesanan.',0),(461,13,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ ÙØ§Ø¯Ø­ Ø¶Ø®Ù…Ø©. Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ù‚Ø±Ø§Ø¡Ø© Ù…ÙØªÙˆØ­Ø© Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø±.',0),(462,13,'fr','Une Ã©norme erreur irrÃ©cupÃ©rable est survenue. Erreur de lecture ouvert crÃ©er des ordres.',0),(463,13,'jp','å¤§ã??ã?ªè‡´å‘½çš„ã?ªã‚¨ãƒ©ãƒ¼ã?Œèµ·ã?“ã‚Šã?¾ã?—ã?Ÿã€‚ã‚ªãƒ¼ãƒ—ãƒ³çµ„ã?¿ç«‹ã?¦æ³¨æ–‡ã?®èª­ã?¿è¾¼ã?¿ã‚¨ãƒ©ãƒ¼ã€‚',0),(464,13,'pt','Ocorreu um erro fatal maciÃ§o. Erro de leitura aberta ordens de construÃ§Ã£o.',0),(465,13,'ru','ÐœÐ°ÑÑÐ¸Ð²Ð½Ñ‹Ðµ ÐÐµÑƒÑÑ‚Ñ€Ð°Ð½Ð¸Ð¼Ð°Ñ Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð°. ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ñ‡Ñ‚ÐµÐ½Ð¸Ð¸ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ð¾Ð³Ð¾ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹.',0),(466,13,'es','Un error fatal masivo ha ocurrido. Error leyendo pedidos de construcciÃ³n abiertos',0),(467,13,'de','Ein massiver schwerwiegender Fehler ist aufgetreten. Fehler beim Lesen der offenen erstellen Bestellungen.',0),(468,13,'en','A massive fatal error has occurred. Error reading open build orders.',0),(469,14,'is','',0),(470,14,'dr','.Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø¬Ù†Ø³Ù‡Ø§ÙŠ ÙØ±Ø¹ÙŠ   Ù†ÙŠØ³Øª',0),(471,14,'pr','ÙŠÙƒ Ø®Ø·Ø§ÙŠ Ø¨Ø²Ø±Ú¯ Ø±ÙˆÙŠ Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª.Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ±Ø¹ÙŠ   Ù†ÙŠØ³Øª',0),(472,14,'tr','BÃ¼yÃ¼k, Ã¶nemli bir hata oluÅŸtu. Alt bileÅŸen Ã¶ÄŸeleri alÄ±namadÄ±.',0),(473,14,'pl','WystÄ…piÅ‚ bÅ‚Ä…d krytyczny ogromne. Nie moÅ¼na pobraÄ‡ sub-element elementÃ³w.',0),(474,14,'bg','ÐœÐ°ÑÐ¸Ð²Ð½Ð° Ñ„Ð°Ñ‚Ð°Ð»Ð½Ð° Ð³Ñ€ÐµÑˆÐºÐ°. ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ Ð¿Ð¾Ð´-ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸.',0),(475,14,'ur','Ø§ÛŒÚ© Ø¨Ú‘Û’ Ù¾ÛŒÙ…Ø§Ù†Û’ Ù¾Ø± Ù…ÛÙ„Ú© ØºÙ„Ø·ÛŒ ÙˆØ§Ù‚Ø¹ ÛÙˆØ¦ÛŒ ÛÛ’ Û” Ø°ÛŒÙ„ÛŒ Ø·ÙˆØ± Ù¾Ø± Ú©Ø±Ø§ÛŒÛ Ú©ÙˆÙ…Ù¾ÙˆÙ†ÛŒÙ†Ù¹ Ø¢Ø¦Ù¹Ù… Ú©ÛŒ Ø¨Ø§Ø²ÛŒØ§ÙØª Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(476,14,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð¼Ð°ÑÐ¸Ð²Ð½Ðµ Ñ„Ð°Ñ‚Ð°Ð»Ð½Ðµ Ð³Ñ€ÐµÑˆÐºÐµ. ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ ÑÑƒÐ±-ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð° ÑÑ‚Ð°Ð²ÐºÐµ.',0),(477,14,'vi','ChÆ°Æ¡ng trÃ¬nh bá»‹ lá»—i. KhÃ´ng láº¥y Ä‘Æ°á»£c cÃ¡c thanh pháº§n phá»¥ cá»§a danh má»¥c.',0),(478,14,'af','\'N massiewe fatale fout het voorgekom. Kon nie sub komponent items herwin nie.',0),(479,14,'ro','A apÄƒrut o eroare fatalÄƒ masive. Putea prelua sub-componenta elemente.',0),(480,14,'et','Massiivne parandamatu tÃµrge ilmnes. Sahara osa Ã¼ksusi ei saanud tuua.',0),(481,14,'si','A massive usodna napaka. Sub-komponenta elementov ni bilo mogoÄe pridobiti.',0),(482,14,'ba','Kesalahan fatal besar telah terjadi. Tidak dapat mengambil item sub-komponen.',0),(483,14,'nl','Een massale fatale fout is opgetreden. Kon niet sub component items ophalen.',0),(484,14,'fi','Massiivinen kohtalokas virhe on tapahtunut. Alikomponentin kohteita ei voitu hakea.',0),(485,14,'no','En massiv fatal feil har oppstÃ¥tt. Kan ikke hente sub-komponent elementer.',0),(486,14,'da','En massiv fatal fejl er opstÃ¥et. Kunne ikke hente sub komponent elementer.',0),(487,14,'ko','ê±° ëŒ€ í•œ ì¹˜ëª…ì ì¸ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤. í•˜ìœ„ êµ¬ì„± ìš”ì†Œ í•­ëª©ì„ ê²€ìƒ‰ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(488,14,'he','××™×¨×¢×” ×©×’×™××” ×ž×›×¨×¢×ª ×ž×¡×™×‘×™×ª. ×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ××—×–×¨ ×¤×¨×™×˜×™× ×ª×ª ×¨×›×™×‘×™×.',0),(489,14,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ Î­Î½Î± Ï„ÎµÏÎ¬ÏƒÏ„Î¹Î¿ Î»Î¬Î¸Î¿Ï‚. Î”ÎµÎ½ Î®Ï„Î±Î½ Î´Ï…Î½Î±Ï„Î® Î· Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï„Î¿Ï… Ï…Ï€Î¿-ÏƒÏ…Î½Î¹ÏƒÏ„ÏŽÏƒÎ± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±.',0),(490,14,'zh','ä¸€ä¸ªå·¨å¤§çš„è‡´å‘½é”™è¯¯ã€‚æ— æ³•æ£€ç´¢å­ç»„ä»¶é¡¹ç›®\r\n',0),(491,14,'sv','En massiv allvarligt fel har intrÃ¤ffat. Det gick inte att hÃ¤mta delprojekt objekt.',0),(492,14,'it','Errore fatale: non Ã¨ possibile leggere gli oggetti sottocomponenti.',0),(493,14,'tl','',0),(494,14,'th','&#3648;&#3585;&#3636;&#3604;&#3588;&#3623;&#3634;&#3617;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3619;&#3657;&#3634;&#3618;&#3649;&#3619;&#3591;&#3586;&#3638;&#3657;&#3609; &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3615;&#',0),(495,14,'hi','à¤à¤• à¤¬à¤¡à¤¼à¥‡ à¤ªà¥ˆà¤®à¤¾à¤¨à¥‡ à¤ªà¤° à¤—à¤‚à¤­à¥€à¤° à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤¹à¥à¤ˆà¥¤ à¤‰à¤ª-à¤˜à¤Ÿà¤• à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾à¥¤',0),(496,14,'ms','Ralat mati secara besar-besaran telah berlaku. Tidak dapat mendapatkan semula item-item sub komponen.',0),(497,14,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ ÙØ§Ø¯Ø­ Ø¶Ø®Ù…Ø©. Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…ÙƒÙˆÙ† Ø§Ù„ÙØ±Ø¹ÙŠ.',0),(498,14,'fr','Une Ã©norme erreur irrÃ©cupÃ©rable est survenue. Pas pu rÃ©cupÃ©rer des Ã©lÃ©ments du sous-composant.',0),(499,14,'jp','å¤§ã??ã?ªè‡´å‘½çš„ã?ªã‚¨ãƒ©ãƒ¼ã?Œèµ·ã?“ã‚Šã?¾ã?—ã?Ÿã€‚ã‚µãƒ–ã‚³ãƒ³ãƒ?ãƒ¼ãƒ?ãƒ³ãƒˆå“?ç›®ã?Œå?Žé›†ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿã€‚',0),(500,14,'pt','Ocorreu um erro fatal maciÃ§o. NÃ£o foi possÃ­vel recuperar itens subcomponente.',0),(501,14,'ru','ÐœÐ°ÑÑÐ¸Ð²Ð½Ñ‹Ðµ ÐÐµÑƒÑÑ‚Ñ€Ð°Ð½Ð¸Ð¼Ð°Ñ Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð°. ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´-ÑÐ¾ÑÑ‚Ð°Ð²Ð»ÑÑŽÑ‰ÐµÐ¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð².',0),(502,14,'es','Un error fatal masivo ha ocurrido. No se podÃ­a recuperar items de sub-componente',0),(503,14,'de','Ein massiver schwerwiegender Fehler ist aufgetreten. Unterkomponente Elemente konnten nicht abgerufen werden.',0),(504,14,'en','A massive fatal error has occurred. Could not retrieve sub-component items.',0),(505,15,'is','',0),(506,15,'dr','. Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ø²Ù…Ø§Ù†ÙŠ  Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ù†ÙŠØ³Øª',0),(507,15,'pr','Ù†Ù‚Øµ Ø¬Ø¯ÙŠ Ø¯Ø± Ø³Ø±ÙˆØ± Ø±ÙˆÙŠ Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª. Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ø²Ù…Ø§Ù†ÙŠ  Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ù†ÙŠØ³Øª',0),(508,15,'tr','Ciddi, bÃ¼yÃ¼k bir baÅŸarÄ±sÄ±zlÄ±k meydana geldi.  BÃ¼tÃ§eler, seÃ§ilen dÃ¶nem iÃ§in alÄ±namadÄ±.',0),(509,15,'pl','PowaÅ¼ne ogromny bÅ‚Ä…d wystÄ…piÅ‚.  Nie moÅ¼na pobraÄ‡ budÅ¼etÃ³w dla wybranego okresu.',0),(510,15,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð°Ð»Ð° Ðµ Ñ‚ÐµÐ¶ÐºÐ° Ð¾Ð³Ñ€Ð¾Ð¼ÐµÐ½ Ð¿Ñ€Ð¾Ð²Ð°Ð».  ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸ Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð¾Ñ‚ Ð²Ñ€ÐµÐ¼Ðµ.',0),(511,15,'ur','Ú©Ø³ÛŒ Ø´Ø¯ÛŒØ¯ Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©ÛŒ Ø¨Ú‘Û’ Ù¾ÛŒÙ…Ø§Ù†Û’ Ù¾Ø± ÙˆØ§Ù‚Ø¹ ÛÙˆØ§ ÛÛ’ Û”  ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) Ù…Ø¯Øª Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ø¨Ø§Ø²ÛŒØ§ÙØª Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(512,15,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð¾Ð·Ð±Ð¸Ñ™Ð½Ðµ Ñ˜Ðµ Ð¿Ñ€Ð¾Ð¿Ð°Ð¾.  ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ Ð±ÑƒÑŸÐµÑ‚Ðµ Ð·Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸ Ð²Ñ€ÐµÐ¼ÐµÐ½ÑÐºÐ¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´.',0),(513,15,'vi','ChÆ°Æ¡ng trÃ¬nh bá»‹ lá»—i. KhÃ´ng thá»ƒ láº¥y ngÃ¢n sÃ¡ch trong thá»i gian Ä‘Ã£ chá»n',0),(514,15,'af','\'N ernstige massiewe faling het voorgekom.  Kon nie begrotings vir geselekteerde tydperk herwin nie.',0),(515,15,'ro','A apÄƒrut un eÅŸec masiv severÄƒ.  Putea prelua bugetele pentru intervalul de timp selectat.',0),(516,15,'et','Ilmnenud on tÃµsine lÃ¤bikukkumist.  Valitud perioodi eelarved ei saanud tuua.',0),(517,15,'si','PriÅ¡lo je do hudo velik neuspeh.  ProraÄuna ni bilo mogoÄe pridobiti za izbrano Äasovno obdobje.',0),(518,15,'ba','Kegagalan besar-besaran parah telah terjadi.  Tidak dapat mengambil anggaran untuk jangka waktu yang dipilih.',0),(519,15,'nl','Een ernstige enorme fout is opgetreden.  Kon niet ophalen van budgetten voor geselecteerde tijdsperiode.',0),(520,15,'fi','Vaikea valtava epÃ¤onnistuminen on tapahtunut.  Valitulla aikavÃ¤lillÃ¤ talousarvioiden ei voitu hakea.',0),(521,15,'no','Det oppstod en alvorlig massiv fiasko.  Kan ikke hente budsjetter for valgte tidsperioden.',0),(522,15,'da','Der opstod en alvorlig massive svigt.  Kunne ikke hente budgetter for valgte tidsperiode.',0),(523,15,'ko','ì‹¬í•œ ëŒ€ê·œëª¨ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.  ì„ íƒí•œ ê¸°ê°„ì— ëŒ€ í•œ ì˜ˆì‚°ì„ ê²€ìƒ‰ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(524,15,'he','×”×ª×¨×—×© ×›×©×œ ×—×ž×•×¨ ×ž×¡×™×‘×™×ª.  ×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ××—×–×¨ ×ª×§×¦×™×‘×™× ×¢×‘×•×¨ ×¤×¨×§ ×–×ž×Ÿ × ×‘×—×¨.',0),(525,15,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ Î¼Î¹Î± ÏƒÎ¿Î²Î±ÏÎ® Ï„ÎµÏÎ¬ÏƒÏ„Î¹Î± Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±.  Î”ÎµÎ½ Î®Ï„Î±Î½ Î´Ï…Î½Î±Ï„Î® Î· Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ Î³Î¹Î± Ï„Î·Î½ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï‡ÏÎ¿Î½Î¹ÎºÎ® Ï€ÎµÏÎ¯Î¿Î´Î¿.',0),(526,15,'zh','ä¸€ä¸ªä¸¥é‡çš„å¤§è§„æ¨¡å‡ºçŽ°æ•…éšœã€‚æ— æ³•æ£€ç´¢é€‰å®šçš„æ—¶é—´é¢„ç®—ã€‚\r\n',0),(527,15,'sv','En svÃ¥r massiv misslyckande har intrÃ¤ffat.  Gick inte att hÃ¤mta budgetar fÃ¶r vald tidsperiod.',0),(528,15,'it','Errore grave: non Ã¨ possibile visualizzare i budget per il lasso temporale selezionato.',0),(529,15,'tl','',0),(530,15,'th','&#3648;&#3585;&#3636;&#3604;&#3588;&#3623;&#3634;&#3617;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;&#3629;&#3618;&#3656;&#3634;&#3591;&#3619;&#3640;&#3609;&#3649;&#3619;&#3591;&#3586;&#3638;&#3657;&#3609; &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#',0),(531,15,'hi','à¤à¤• à¤—à¤‚à¤­à¥€à¤° à¤­à¤¾à¤°à¥€ à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤¹à¥à¤ˆà¥¤  à¤šà¤¯à¤¨à¤¿à¤¤ à¤¸à¤®à¤¯ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤œà¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤²à¤¾ à¤¸à¤•à¤¾à¥¤',0),(532,15,'ms','Kegagalan besar-besaran yang teruk telah berlaku.  Tidak dapat mendapatkan semula belanjawan untuk tempoh masa yang dipilih.',0),(533,15,'ar','Ø­Ø¯Ø« Ø¹Ø·Ù„ Ø¶Ø®Ù…Ø© Ø´Ø¯ÙŠØ¯Ø©.  ØªØ¹Ø°Ø± Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ù„ÙØªØ±Ø© Ù…Ø­Ø¯Ø¯Ø© Ù…Ù† Ø§Ù„ÙˆÙ‚Øª.',0),(534,15,'fr','Un grave Ã©chec massif s\'est produite.  Pas pu rÃ©cupÃ©rer les budgets pour la pÃ©riode sÃ©lectionnÃ©e.',0),(535,15,'jp','å¤§ã??ã?ªè‡´å‘½çš„ã?ªã‚¨ãƒ©ãƒ¼ã?Œèµ·ã?“ã‚Šã?¾ã?—ã?Ÿã€‚å®šã‚?ã‚‰ã‚Œã?ŸæœŸé–“ã?®äºˆç®—ã?Œå?Žé›†ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿã€‚',0),(536,15,'pt','OcorrÃªncia de uma falha grave maciÃ§a.  NÃ£o foi possÃ­vel recuperar os orÃ§amentos por perÃ­odo de tempo selecionado.',0),(537,15,'ru','Ð¢ÑÐ¶ÐµÐ»Ñ‹Ðµ Ð¼Ð°ÑÑÐ¸Ð²Ð½Ñ‹Ðµ ÑÐ±Ð¾Ð¹.  ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ñ‹ Ð´Ð»Ñ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸.',0),(538,15,'es','Un fallo severo y masivo ha ocurrido. No se podÃ­a recuperar presupuestos para los perÃ­odos de tiempo seleccionados',0),(539,15,'de','Ein schwerer massiver Fehler aufgetreten.  Budgets fÃ¼r ausgewÃ¤hlten Zeitraum konnte nicht abgerufen werden.',0),(540,15,'en','A severe massive failure has occurred.  Could not retrieve budgets for selected time period.',0),(541,16,'is','',0),(542,16,'dr','AA ØªÙØµÛŒÙ„',0),(543,16,'pr','AA Ø´Ø±Ø­',0),(544,16,'tr','AA aÃ§Ä±klamasÄ±',0),(545,16,'pl','AA opis',0),(546,16,'bg','ÐÐ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(547,16,'ur','ÚˆØ¨Ù„ Ø§Û’ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(548,16,'sr','ÐÐ Ð¾Ð¿Ð¸Ñ',0),(549,16,'vi','Diá»…n Giáº£i AA',0),(550,16,'af','AA Beskrywing',0),(551,16,'ro','AA Descriere',0),(552,16,'et','AA Kirjeldus',0),(553,16,'si','AA opis',0),(554,16,'ba','Keterangan AA',0),(555,16,'nl','AA beschrijving',0),(556,16,'fi','AA kuvaus',0),(557,16,'no','AA beskrivelse',0),(558,16,'da','AA beskrivelse',0),(559,16,'ko','ê¸ˆì£¼ ëª¨ìž„ ì„¤ëª…',0),(560,16,'he','×ª×™××•×¨ AA',0),(561,16,'el','Î‘Î‘ Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® ',0),(562,16,'zh','AAæè¿°',0),(563,16,'sv','AA Beskrivning',0),(564,16,'it','AA Descrizione',0),(565,16,'tl','',0),(566,16,'th','AA DESCRIPTION',0),(567,16,'hi','à¤. à¤. à¤µà¤¿à¤µà¤°à¤£',0),(568,16,'ms','Keterangan AA',0),(569,16,'ar','ÙˆØµÙ AA',0),(570,16,'fr','Decsription AA',0),(571,16,'jp','ä½œè€…äº¤ä»£',0),(572,16,'pt','AA DescriÃ§Ã£o',0),(573,16,'ru','ÐÐ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(574,16,'es','AA DescripciÃ³n',0),(575,16,'de','AA Beschreibung',0),(576,16,'en','AA Description',0),(577,17,'is','',0),(578,17,'dr','Ø§Ø®ØªØµØ§Ø±ÛŒ',0),(579,17,'pr','Ø§Ø®ØªØµØ§Ø±ÛŒ',0),(580,17,'tr','KÄ±saltma',0),(581,17,'pl','SkrÃ³t',0),(582,17,'bg','Ð¡ÑŠÐºÑ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ',0),(583,17,'ur','Ù…Ø®ØªØµØ±',0),(584,17,'sr','Ð¡ÐºÑ€Ð°Ñ›ÐµÐ½Ð¸Ñ†Ð°',0),(585,17,'vi','Viáº¿t Táº¯t',0),(586,17,'af','Afkorting',0),(587,17,'ro','Abreviere',0),(588,17,'et','LÃ¼hend',0),(589,17,'si','Kratica',0),(590,17,'ba','Singkatan',0),(591,17,'nl','Afkorting',0),(592,17,'fi','Lyhenne',0),(593,17,'no','Forkortelse',0),(594,17,'da','Forkortelse',0),(595,17,'ko','ì•½ì–´',0),(596,17,'he','×§×™×¦×•×¨',0),(597,17,'el','Î£Ï…Î½Ï„Î¿Î¼Î¿Î³ÏÎ±Ï†Î¯Î±',0),(598,17,'zh','ç¼©å†™\r\n',0),(599,17,'sv','FÃ¶rkortning',0),(600,17,'it','Abbreviazione',0),(601,17,'tl','',0),(602,17,'th','à¸„à¸³à¸¢à¹ˆà¸­',0),(603,17,'hi','à¤¸à¤‚à¤•à¥à¤·à¤¿à¤ªà¥à¤¤ à¤¨à¤¾à¤®',0),(604,17,'ms','Singkatan',0),(605,17,'ar','Ø§Ù„Ø¥Ø®ØªØµØ§Ø±',0),(606,17,'fr','AbrÃ©viation',0),(607,17,'jp','çœ?ç•¥å½¢',0),(608,17,'pt','Abreviatura',0),(609,17,'ru','ÐÐ±Ð±Ñ€ÐµÐ²Ð¸Ð°Ñ‚ÑƒÑ€Ð°',0),(610,17,'es','Abreviatura',0),(611,17,'de','AbkÃ¼rzung',0),(612,17,'en','Abbreviation',0),(613,18,'is','',0),(614,18,'dr','NolaPro ',0),(615,18,'pr','Ø¯Ø±Ø¨Ø§Ø±Ù‡ NolaPro ',0),(616,18,'tr','YaklaÅŸÄ±k NolaPro',0),(617,18,'pl','OkoÅ‚o NolaPro',0),(618,18,'bg','ÐžÐºÐ¾Ð»Ð¾ NolaPro',0),(619,18,'ur','Ù†ÙˆÙ„Ø§ Ù¾Ø±Ùˆ Ú©Û’ Ù…ØªØ¹Ù„Ù‚',0),(620,18,'sr','ÐžÐºÐ¾ NolaPro',0),(621,18,'vi','Vá» NolaPro',0),(622,18,'af','Omtrent Nola Pro',0),(623,18,'ro','Despre NolaPro',0),(624,18,'et','Umbes NolaPro',0),(625,18,'si','PribliÅ¾no NolaPro',0),(626,18,'ba','Tentang NolaPro',0),(627,18,'nl','Over NolaPro',0),(628,18,'fi','Tietoja NolaProsta',0),(629,18,'no','Om NolaPro',0),(630,18,'da','Omkring NolaPro',0),(631,18,'ko','ì•½ NolaPro',0),(632,18,'he','NolaPro ××•×“×•×ª',0),(633,18,'el','Î£Ï‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î¿ NolaPro',0),(634,18,'zh','å…³äºŽNolaPro',0),(635,18,'sv','Ca NolaPro',0),(636,18,'it','Informazioni riguardo NolaPro',0),(637,18,'tl','',0),(638,18,'th','&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610; NolaPro',0),(639,18,'hi','à¤•à¥‡ à¤¬à¤¾à¤°à¥‡ à¤®à¥‡à¤‚ NolaPro',0),(640,18,'ms','Kira-kira NolaPro',0),(641,18,'ar','Ø­ÙˆØ§Ù„ÙŠ NolaPro',0),(642,18,'fr','Ã€ Propos de NolaPro',0),(643,18,'jp','ï¼®ï½?ï½Œï½?ï¼?ï¼°ï½’ï½?ã?«ã?¤ã?„ã?¦',0),(644,18,'pt','Cerca de NolaPro',0),(645,18,'ru','Ðž NolaPro',0),(646,18,'es','Acerca de NolaPro',0),(647,18,'de','Ãœber NolaPro',0),(648,18,'en','About NolaPro',0),(649,19,'is','',0),(650,19,'dr','Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±',0),(651,19,'pr','Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±',0),(652,19,'tr','Bu yazÄ±lÄ±m hakkÄ±nda',0),(653,19,'pl','O tym oprogramowaniu',0),(654,19,'bg','Ð—Ð° Ñ‚Ð¾Ð·Ð¸ ÑÐ¾Ñ„Ñ‚ÑƒÐµÑ€',0),(655,19,'ur','Ø§Ø³ Ø³ÙˆÙÙ¹ ÙˆÛŒØ± Ú©Û’ Ù…ØªØ¹Ù„Ù‚',0),(656,19,'sr','Ðž Ð¾Ð²Ð¾Ð¼ ÑÐ¾Ñ„Ñ‚Ð²ÐµÑ€Ñƒ',0),(657,19,'vi','Vá» Pháº§n Má»m NÃ y',0),(658,19,'af','Omtrent hierdie Sagteware',0),(659,19,'ro','Despre Acest Soft',0),(660,19,'et','Selle tarkvara kohta',0),(661,19,'si','PribliÅ¾no to Software',0),(662,19,'ba','Tentang Program Ini',0),(663,19,'nl','Over deze software',0),(664,19,'fi','Tietoja tÃ¤stÃ¤ ohjelmasta',0),(665,19,'no','Om denne programvaren',0),(666,19,'da','Om denne Software',0),(667,19,'ko','ì´ ì†Œí”„íŠ¸ì›¨ì–´ì— ëŒ€ í•œ',0),(668,19,'he','××•×“×•×ª ×ª×•×›× ×” ×–×•',0),(669,19,'el','Î£Ï‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î¿ Ï€Î±ÏÏŽÎ½ Î ÏÏŒÎ³ÏÎ±Î¼Î¼Î±  ',0),(670,19,'zh','å…³äºŽæ­¤è½¯ä»¶',0),(671,19,'sv','Om denna mjukvara',0),(672,19,'it','Informazioni riguardo questo software',0),(673,19,'tl','',0),(674,19,'th','à¹€à¸à¸µà¹ˆà¸¢à¸§à¸à¸±à¸šà¸‹à¸­à¸Ÿà¸—à¹Œà¹à¸§à¸£à¹Œà¸™à¸µà¹‰',0),(675,19,'hi','à¤‡à¤¸ à¤¸à¥‰à¤«à¤¼à¥à¤Ÿà¤µà¥‡à¤¯à¤° à¤•à¥‡ à¤¬à¤¾à¤°à¥‡ à¤®à¥‡à¤‚',0),(676,19,'ms','Tentang perisian ini',0),(677,19,'ar','Ø­ÙˆÙ„ Ù‡Ø°Ø§ Ø§Ù„Ø¨Ø±Ù†Ø§Ù…Ø¬',0),(678,19,'fr','Ã€ Propos de ce Logiciel',0),(679,19,'jp','ã?“ã?®ã‚½ãƒ•ãƒˆã‚¦ã‚§ã‚¢ã?«ã?¤ã?„ã?¦',0),(680,19,'pt','Sobre este Software',0),(681,19,'ru','ÐžÐ± ÑÑ‚Ð¾Ð¼ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ð½Ð¾Ð¼ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ð¸',0),(682,19,'es','Acerca de este Software',0),(683,19,'de','Ãœber dieses Programm',0),(684,19,'en','About This Software',0),(685,20,'is','',0),(686,20,'dr','Ø­Ø³Ø§Ø¨ ',0),(687,20,'pr','Ø­Ø³Ø§Ø¨ ',0),(688,20,'tr','Hesap',0),(689,20,'pl','Konto',0),(690,20,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ°',0),(691,20,'ur','Ú©Ú¾Ø§ØªÛ',0),(692,20,'sr','Ð Ð°Ñ‡ÑƒÐ½',0),(693,20,'vi','TÃ i khoáº£n',0),(694,20,'af','Rekening',0),(695,20,'ro','Cont',0),(696,20,'et','Konto',0),(697,20,'si','RaÄun',0),(698,20,'ba','Akun',0),(699,20,'nl','Rekening',0),(700,20,'fi','Tili',0),(701,20,'no','Konto',0),(702,20,'da','Konto',0),(703,20,'ko','ê³„ì •',0),(704,20,'he','×—×©×‘×•×Ÿ',0),(705,20,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(706,20,'zh','å¸æˆ·',0),(707,20,'sv','Konto',0),(708,20,'it','Conto',0),(709,20,'tl','',0),(710,20,'th','à¸Šà¸·à¹ˆà¸­à¸šà¸±à¸à¸Šà¸µ',0),(711,20,'hi','à¤–à¤¾à¤¤à¤¾',0),(712,20,'ms','Akaun',0),(713,20,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨',0),(714,20,'fr','Compte',0),(715,20,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(716,20,'pt','Conta',0),(717,20,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(718,20,'es','Cuenta',0),(719,20,'de','Konto',0),(720,20,'en','Account',0),(721,21,'is','',0),(722,21,'dr','ÙØ¹Ø§Ù„ÙŠØª Ø­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÙŠ ',0),(723,21,'pr','ÙØ¹Ø§Ù„ÙŠØª Ø­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÙŠ ',0),(724,21,'tr','Hesap etkinliÄŸi iÃ§in',0),(725,21,'pl','AktywnoÅ›Ä‡ konta na',0),(726,21,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ Ð·Ð°',0),(727,21,'ur','Ø§Ú©Ø§ÙˆÙ†Ù¹ Ú©ÛŒ Ú©Ø§Ø±ÙˆØ§Ø¡Û’ Ú©ÛŒÙ„Ø¡Û’',0),(728,21,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð·Ð°',0),(729,21,'vi','Hoáº¡t Äá»™ng TK cho',0),(730,21,'af','Rekening Aktiwiteit vir',0),(731,21,'ro','Activitate cont pentru',0),(732,21,'et','Konto tegevus:',0),(733,21,'si','Dejavnost raÄuna za',0),(734,21,'ba','Aktivitas Akun untuk',0),(735,21,'nl','Accountactiviteit voor',0),(736,21,'fi','Huomioon toimintaa',0),(737,21,'no','Kontoaktivitet for',0),(738,21,'da','Kontoaktivitet for',0),(739,21,'ko','ê³„ì • í™œë™ì— ëŒ€ í•œ',0),(740,21,'he','×—×©×‘×•×Ÿ ×œ×¤×¢×™×œ×•×ª',0),(741,21,'el','Î”ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î³Î¹Î±',0),(742,21,'zh','å¸æˆ·æ´»åŠ¨çš„\r\n',0),(743,21,'sv','Kontoaktivitet fÃ¶r',0),(744,21,'it','AttivitÃ  del profilo per',0),(745,21,'tl','',0),(746,21,'th','&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(747,21,'hi','à¤–à¤¾à¤¤à¤¾ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤',0),(748,21,'ms','Aktiviti akaun bagi',0),(749,21,'ar','Ù†Ø´Ø§Ø· Ø§Ù„Ø­Ø³Ø§Ø¨',0),(750,21,'fr','ActivitÃ© du compte de',0),(751,21,'jp','ï½žã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆæ´»å‹•',0),(752,21,'pt','Atividade da conta para',0),(753,21,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ð° Ð´Ð»Ñ',0),(754,21,'es','Actividad de Cuenta para',0),(755,21,'de','KontenaktivitÃ¤t fÃ¼r',0),(756,21,'en','Account Activity for',0),(757,22,'is','',0),(758,22,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ ',0),(759,22,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ ',0),(760,22,'tr','Hesap Ekle',0),(761,22,'pl','Dodaj konto',0),(762,22,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(763,22,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(764,22,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(765,22,'vi','ThÃªm TK',0),(766,22,'af','Rekening Bygevoeg',0),(767,22,'ro','Adauga cont',0),(768,22,'et','Konto lisamine',0),(769,22,'si','Dodaj raÄun',0),(770,22,'ba','Penambahan Akun',0),(771,22,'nl','Account toevoegen',0),(772,22,'fi','Tilin lisÃ¤Ã¤minen',0),(773,22,'no','Konto legge',0),(774,22,'da','Konto tilfÃ¸je',0),(775,22,'ko','ê³„ì • ì¶”ê°€',0),(776,22,'he','×”×•×¡×¤×ª ×—×©×‘×•×Ÿ',0),(777,22,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(778,22,'zh','å¸æˆ·æ·»åŠ ',0),(779,22,'sv','LÃ¤gg till konto',0),(780,22,'it','Aggiungi profilo',0),(781,22,'tl','',0),(782,22,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(783,22,'hi','à¤–à¤¾à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(784,22,'ms','Menambah akaun',0),(785,22,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨',0),(786,22,'fr','Ajouter un compte',0),(787,22,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆè¿½åŠ ',0),(788,22,'pt','Adicionar conta',0),(789,22,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(790,22,'es','Agregar Cuenta',0),(791,22,'de','Konto hinzufÃ¼gen',0),(792,22,'en','Account Add',0),(793,23,'is','',0),(794,23,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(795,23,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(796,23,'tr','Hesap baÅŸarÄ±yla eklendi',0),(797,23,'pl','Konto pomyÅ›lnie dodane',0),(798,23,'bg','ÐŸÑ€ÐµÐ´Ð²Ð¸Ð´ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(799,23,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ø´Ø¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(800,23,'sr','Ð Ð°Ñ‡ÑƒÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(801,23,'vi','ThÃªm TK ThÃ nh CÃ´ng',0),(802,23,'af','Rekening Suksesvol Bygevoeg',0),(803,23,'ro','Cont adaugat cu succes',0),(804,23,'et','Konto lisamine Ãµnnestus',0),(805,23,'si','RaÄun uspeÅ¡no dodan',0),(806,23,'ba','Akun berhasil ditambahkan',0),(807,23,'nl','Account met succes toegevoegd',0),(808,23,'fi','Tilin lisÃ¤Ã¤minen onnistui',0),(809,23,'no','Kontoen ble lagt til',0),(810,23,'da','Konto tilfÃ¸jet',0),(811,23,'ko','ê³„ì •ì„ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(812,23,'he','×—×©×‘×•×Ÿ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(813,23,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Ï€ÏÎ¿ÏƒÏ„Î¯Î¸ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(814,23,'zh','å¸æˆ·æ·»åŠ æˆåŠŸ',0),(815,23,'sv','Konto lagts',0),(816,23,'it','Profilo aggiunto correttamente',0),(817,23,'tl','',0),(818,23,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(819,23,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(820,23,'ms','Akaun yang berjaya menambah',0),(821,23,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(822,23,'fr','Compte ajoutÃ© avec succÃ¨s',0),(823,23,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆè¿½åŠ æˆ?åŠŸ',0),(824,23,'pt','Conta adicionada com sucesso',0),(825,23,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(826,23,'es','Cuenta agregada satisfactoriamente',0),(827,23,'de','Konto erfolgreich hinzugefÃ¼gt',0),(828,23,'en','Account added successfully',0),(829,24,'is','',0),(830,24,'dr','Ø­Ø³Ø§Ø¨ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±Ø¯Ø± Ø§ÙŠÙ† Ø¨Ø®Ø´ Ù†Ù…ÙˆØ¯Ø§Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(831,24,'pr','Ø­Ø³Ø§Ø¨ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±Ø¯Ø± Ø§ÙŠÙ† Ø¨Ø®Ø´ Ù†Ù…ÙˆØ¯Ø§Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(832,24,'tr','Bu pasta dilimi iÃ§inde zaten bir hesap oluÅŸturulmuÅŸ',0),(833,24,'pl','Konto juÅ¼ istnieje w ten wycinek',0),(834,24,'bg','Ð’ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð² Ñ‚Ð¾Ð·Ð¸ ÐºÑ€ÑŠÐ³Ð¾Ð²',0),(835,24,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø³ Ù¾Ø§Ø¦ÛŒ Ù‚Ø§Ø´ Ù…ÛŒÚº Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(836,24,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ñƒ Ð¾Ð²Ð°Ñ˜ ÐºÐ¾Ð¼Ð°Ð´ Ð¿Ð¸Ñ‚Ðµ',0),(837,24,'vi','TK Ä‘Ã£ tá»“n táº¡i',0),(838,24,'af','Rekening bestaan reeds in hierdie Sirkeldiagram skyf',0),(839,24,'ro','Cont deja existent',0),(840,24,'et','Konto on juba olemas see pirukas viil',0),(841,24,'si','RaÄun Å¾e obstaja v tem rezina tortnega grafikona',0),(842,24,'ba','Akun telah ada dalam bagian ini',0),(843,24,'nl','Account bestaat al in deze cirkelsegment',0),(844,24,'fi','Tili on jo olemassa ympyrÃ¤kaavion sektori',0),(845,24,'no','Kontoen finnes allerede i denne sektor',0),(846,24,'da','Kontoen findes allerede i denne cirkeludsnit',0),(847,24,'ko','ê³„ì •ì— ì´ë¯¸ ìžˆëŠ”ì´ ì›í˜• ì¡°ê°',0),(848,24,'he','×—×©×‘×•×Ÿ ×§×™×™× ×›×‘×¨ ×–×” ×¤×¨×•×¡×ª ×¢×•×’×”',0),(849,24,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ Ï€Î¯Ï„Î±',0),(850,24,'zh','å¸æˆ·å·²ç»å­˜åœ¨äºŽæ­¤æ‰‡å½¢åŒº\r\n',0),(851,24,'sv','Konto finns redan i denna cirkelsektor',0),(852,24,'it','Il profilo esiste giÃ  in questa porzione del grafico',0),(853,24,'tl','',0),(854,24,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3626;&#3656;&#3623;&#3609;&#3609;&#3637;&#3657;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(855,24,'hi','à¤–à¤¾à¤¤à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤¸ à¤ªà¤¾à¤‡ à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤®à¥‡à¤‚ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(856,24,'ms','Akaun yang sudah wujud di slice pai ini',0),(857,24,'ar','Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„ ÙÙŠ Ù‡Ø°Ù‡ Ø´Ø±ÙŠØ­Ø© Ø§Ù„ØªØ®Ø·ÙŠØ· Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠ',0),(858,24,'fr','Compte dÃ©jÃ  existant dans cette part',0),(859,24,'jp','ã?“ã?®ãƒ‘ã‚¤ã‚¹ãƒ©ã‚¤ã‚¹ã?«ã?™ã?§ã?«ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?Œå­˜åœ¨ã?—ã?¾ã?™ã€‚',0),(860,24,'pt','Conta jÃ¡ existe esta fatia de torta',0),(861,24,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð² ÑÑ‚Ð¾Ñ‚ ÑÐµÐºÑ‚Ð¾Ñ€ ÐºÑ€ÑƒÐ³Ð¾Ð²Ð¾Ð¹ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¼Ñ‹',0),(862,24,'es','Cuenta ya existe en esta porciÃ³n de torta',0),(863,24,'de','Konto existiert bereits in diesem Kreissegment',0),(864,24,'en','Account already exists in this pie slice',0),(865,25,'is','',0),(866,25,'dr','(Ù„ÛŒØ¬Ø±)',0),(867,25,'pr','Ù…Ø§Ù†Ø¯Ù‡ Ø­Ø³Ø§Ø¨ (Ø¯ÙØªØ±Ú©Ù„)',0),(868,25,'tr','Hesap bakiyesi',0),(869,25,'pl','Saldo konta',0),(870,25,'bg','Ð¡Ð°Ð»Ð´Ð¾',0),(871,25,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…ÛŒØ²Ø§Ù†',0),(872,25,'sr','Ð¡Ñ‚Ð°ÑšÐµ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ñƒ',0),(873,25,'vi','DÆ° Ná»£ TK',0),(874,25,'af','Rekeningbalans',0),(875,25,'ro','Balanta cont',0),(876,25,'et','Konto saldo',0),(877,25,'si','Stanje na raÄunu',0),(878,25,'ba','Saldo Akun',0),(879,25,'nl','Rekening van de betalingsbalans',0),(880,25,'fi','Tilin saldo',0),(881,25,'no','Saldo',0),(882,25,'da','Saldo',0),(883,25,'ko','ê³„ì • ìž”ì•¡',0),(884,25,'he','×ž××–×Ÿ ×—×©×‘×•×Ÿ',0),(885,25,'el','Î¥Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(886,25,'zh','å¸æˆ·ç»“ä½™',0),(887,25,'sv','Kontosaldo',0),(888,25,'it','Saldo del conto',0),(889,25,'tl','',0),(890,25,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(891,25,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿',0),(892,25,'ms','Baki akaun',0),(893,25,'ar','Ø±ØµÙŠØ¯ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(894,25,'fr','Solde du Compte',0),(895,25,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒ?ãƒ©ãƒ³ã‚¹',0),(896,25,'pt','Saldo da conta',0),(897,25,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ ÑÑ‡ÐµÑ‚Ð°',0),(898,25,'es','Cuenta Balance',0),(899,25,'de','Kontostand',0),(900,25,'en','Account Balance',0),(901,26,'is','',0),(902,26,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(903,26,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(904,26,'tr','Hesap baÅŸarÄ±yla silindi',0),(905,26,'pl','Konto usuniÄ™te pomyÅ›lnie',0),(906,26,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(907,26,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ø´Ø¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(908,26,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(909,26,'vi','Há»§y TK ThÃ nh CÃ´ng ',0),(910,26,'af','Rekening Suksesvol Verwyder',0),(911,26,'ro','Cont sters cu succes',0),(912,26,'et','Konto kustutati edukalt',0),(913,26,'si','RaÄun je izbrisan uspeÅ¡no',0),(914,26,'ba','Akun Berhasil Dihapus',0),(915,26,'nl','Account met succes verwijderd',0),(916,26,'fi','Tili poistettu',0),(917,26,'no','Konto slettet',0),(918,26,'da','Konto slettet',0),(919,26,'ko','ê³„ì •ì„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ',0),(920,26,'he','×”×—×©×‘×•×Ÿ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(921,26,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(922,26,'zh','å¸æˆ·åˆ é™¤æˆåŠŸ\r\n',0),(923,26,'sv','Konto raderades',0),(924,26,'it','Il profilo Ã¨ stato rimosso correttamente.',0),(925,26,'tl','',0),(926,26,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(927,26,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(928,26,'ms','Akaun dihapuskan dengan jayanya',0),(929,26,'ar','Ø­Ø°Ù Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(930,26,'fr','Compte SupprimÃ© avec SuccÃ¨s',0),(931,26,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆæ¶ˆåŽ»æˆ?åŠŸ',0),(932,26,'pt','Conta excluÃ­da com sucesso',0),(933,26,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(934,26,'es','Cuenta Eliminada Satisfactoriamente',0),(935,26,'de','Konto erfolgreich gelÃ¶scht',0),(936,26,'en','Account Deleted Successfully',0),(937,27,'is','',0),(938,27,'dr','Ø´Ø±Ø­ Ø­Ø³Ø§Ø¨ ',0),(939,27,'pr','Ø´Ø±Ø­ Ø­Ø³Ø§Ø¨ ',0),(940,27,'tr','Hesap aÃ§Ä±klamasÄ±',0),(941,27,'pl','Opis konta',0),(942,27,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð¿Ð°Ñ€Ñ‚Ð½ÑŒÐ¾Ñ€',0),(943,27,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(944,27,'sr','ÐžÐ¿Ð¸Ñ Ð¿Ð¾ÑÐ»Ð¾Ð²Ð½Ð¾Ð³ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð°',0),(945,27,'vi','Diá»…n Giáº£i TK',0),(946,27,'af','Rekening Beskrywing',0),(947,27,'ro','Descriere cont',0),(948,27,'et','Konto kirjeldus',0),(949,27,'si','Opis konta',0),(950,27,'ba','Keterangan Akun',0),(951,27,'nl','Accountbeschrijving',0),(952,27,'fi','Tilin kuvaus',0),(953,27,'no','Konto beskrivelse',0),(954,27,'da','Kontobeskrivelse',0),(955,27,'ko','ê³„ì • ì„¤ëª…',0),(956,27,'he','×ª×™××•×¨ ×—×©×‘×•×Ÿ',0),(957,27,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(958,27,'zh','å¸æˆ·è¯´æ˜Ž\r\n',0),(959,27,'sv','Konto Beskrivning',0),(960,27,'it','Descrizione del conto',0),(961,27,'tl','',0),(962,27,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(963,27,'hi','à¤–à¤¾à¤¤à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(964,27,'ms','Keterangan akaun',0),(965,27,'ar','ÙˆØµÙ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(966,27,'fr','Description du compte',0),(967,27,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®èª¬æ˜Ž',0),(968,27,'pt','DescriÃ§Ã£o da conta',0),(969,27,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(970,27,'es','DescripciÃ³n de Cuenta',0),(971,27,'de','Kontenbeschreibung',0),(972,27,'en','Account Description',0),(973,28,'is','',0),(974,28,'dr','Ù†Ø§Ù… Ø­Ø³Ø§Ø¨ ',0),(975,28,'pr','Ù†Ø§Ù… Ø­Ø³Ø§Ø¨ ',0),(976,28,'tr','Hesap adÄ±',0),(977,28,'pl','Nazwa konta',0),(978,28,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(979,28,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ø§Ù…',0),(980,28,'sr','ÐÐ°Ð·Ð¸Ð² Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(981,28,'vi','TÃªn TK',0),(982,28,'af','Rekening Naam',0),(983,28,'ro','Nume cont',0),(984,28,'et','Konto nimi',0),(985,28,'si','Ime raÄuna',0),(986,28,'ba','Nama Akun',0),(987,28,'nl','Accountnaam',0),(988,28,'fi','Tilin nimi',0),(989,28,'no','Kontonavn',0),(990,28,'da','Kontonavn',0),(991,28,'ko','ê³„ì • ì´ë¦„',0),(992,28,'he','×©× ×—×©×‘×•×Ÿ',0),(993,28,'el','ÎŒÎ½Î¿Î¼Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(994,28,'zh','å¸æˆ·åç§°\r\n',0),(995,28,'sv','Kontonamn',0),(996,28,'it','Nome profilo',0),(997,28,'tl','',0),(998,28,'th','&#3594;&#3639;&#3656;&#3629;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(999,28,'hi','à¤–à¤¾à¤¤à¤¾ à¤¨à¤¾à¤®',0),(1000,28,'ms','Nama akaun',0),(1001,28,'ar','Ø¥Ø³Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(1002,28,'fr','Nom du compte',0),(1003,28,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆå??',0),(1004,28,'pt','Nome da conta',0),(1005,28,'ru','Ð˜Ð¼Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(1006,28,'es','Nombre de Cuenta',0),(1007,28,'de','Account-Name',0),(1008,28,'en','Account Name',0),(1009,29,'is','',0),(1010,29,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨',0),(1011,29,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨',0),(1012,29,'tr','Hesap #',0),(1013,29,'pl','Konto #',0),(1014,29,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° #',0),(1015,29,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø±',0),(1016,29,'sr','Ð Ð°Ñ‡ÑƒÐ½',0),(1017,29,'vi','TK Sá»‘',0),(1018,29,'af','Rekening #',0),(1019,29,'ro','Cont #',0),(1020,29,'et','Konto #',0),(1021,29,'si','RaÄun #',0),(1022,29,'ba','Akun %',0),(1023,29,'nl','Account #',0),(1024,29,'fi','Huomioon #',0),(1025,29,'no','Konto #',0),(1026,29,'da','Konto #',0),(1027,29,'ko','# ê³„ì •',0),(1028,29,'he','# ×—×©×‘×•×Ÿ',0),(1029,29,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ #',0),(1030,29,'zh','å¸å·',0),(1031,29,'sv','Kontonummer',0),(1032,29,'it','# profilo',0),(1033,29,'tl','',0),(1034,29,'th','&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(1035,29,'hi','à¤–à¤¾à¤¤à¥‡ à¤®à¥‡à¤‚ #',0),(1036,29,'ms','Akaun #',0),(1037,29,'ar','Ø­Ø³Ø§Ø¨ #',0),(1038,29,'fr','Compte #',0),(1039,29,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå?·',0),(1040,29,'pt','# De conta',0),(1041,29,'ru','Ð¡Ñ‡ÐµÑ‚ #',0),(1042,29,'es','Cuenta #',0),(1043,29,'de','Konto #',0),(1044,29,'en','Account #',0),(1045,30,'is','',0),(1046,30,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨',0),(1047,30,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨',0),(1048,30,'tr','Hesap numarasÄ±',0),(1049,30,'pl','Numer konta',0),(1050,30,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(1051,30,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø±',0),(1052,30,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(1053,30,'vi','Sá»‘ TK',0),(1054,30,'af','Rekeningnommer',0),(1055,30,'ro','Numar cont',0),(1056,30,'et','Konto Number',0),(1057,30,'si','Å tevilka raÄuna',0),(1058,30,'ba','Nomor Akun',0),(1059,30,'nl','Rekeningnummer',0),(1060,30,'fi','Tilin numero',0),(1061,30,'no','Kontonummeret',0),(1062,30,'da','Kontonummer',0),(1063,30,'ko','ê³„ì¢Œ ë²ˆí˜¸',0),(1064,30,'he','×ž×¡×¤×¨ ×—×©×‘×•×Ÿ',0),(1065,30,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(1066,30,'zh','å¸æˆ·å·ç ',0),(1067,30,'sv','Kontonummer',0),(1068,30,'it','Numero profilo',0),(1069,30,'tl','',0),(1070,30,'th','&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(1071,30,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(1072,30,'ms','Nombor akaun',0),(1073,30,'ar','Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(1074,30,'fr','NumÃ©ro de compte',0),(1075,30,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå?·',0),(1076,30,'pt','NÃºmero de conta',0),(1077,30,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°',0),(1078,30,'es','Cuenta NÃºmero',0),(1079,30,'de','Kontonummer',0),(1080,30,'en','Account Number',0),(1081,31,'is','',0),(1082,31,'dr','Ø­Ø³Ø§Ø¨ Ø¬Ù‡Øª Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(1083,31,'pr','Ø­Ø³Ø§Ø¨ Ø¬Ù‡Øª Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(1084,31,'tr','BÃ¼tÃ§e iÃ§in hesap',0),(1085,31,'pl','Konto budÅ¼etu',0),(1086,31,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° ÐºÑŠÐ¼ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(1087,31,'ur','Ø¨Ø¬Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(1088,31,'sr','ÐÐ°Ð»Ð¾Ð³ Ñƒ Ð±ÑƒÑŸÐµÑ‚',0),(1089,31,'vi','TK NgÃ¢n SÃ¡ch',0),(1090,31,'af','Rekening na Begroting',0),(1091,31,'ro','Cont la Buget',0),(1092,31,'et','Eelarve moodustab',0),(1093,31,'si','RaÄun za proraÄun',0),(1094,31,'ba','Akun ke Neraca',0),(1095,31,'nl','Rekening wordt gehouden met de begroting',0),(1096,31,'fi','Huomioon talousarvion',0),(1097,31,'no','Konto til budsjett',0),(1098,31,'da','Kontoen til Budget',0),(1099,31,'ko','ì˜ˆì‚° ê³„ì •',0),(1100,31,'he','×—×©×‘×•×Ÿ ×œ×ª×§×¦×™×‘',0),(1101,31,'el','Î¥Ï€ÏŒÏˆÎ· ÏƒÏ„Î¿Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ',0),(1102,31,'zh','å¸æˆ·é¢„ç®—\r\n',0),(1103,31,'sv','HÃ¤nsyn till Budget',0),(1104,31,'it','Conto di bilancio',0),(1105,31,'tl','',0),(1106,31,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(1107,31,'hi','à¤¬à¤œà¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¤¾à¤¤à¤¾',0),(1108,31,'ms','Akaun bajet',0),(1109,31,'ar','Ø­Ø³Ø§Ø¨ Ù„Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(1110,31,'fr','Compte pour budget',0),(1111,31,'jp','äºˆç®—ã‚’ç«‹ã?¦ã‚‹ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(1112,31,'pt','Conta para orÃ§amento',0),(1113,31,'ru','Ð¡Ñ‡ÐµÑ‚ Ð² Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(1114,31,'es','Cuenta de Presupuesto',0),(1115,31,'de','Konto zum Haushalt',0),(1116,31,'en','Account to Budget',0),(1117,32,'is','',0),(1118,32,'dr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ ',0),(1119,32,'pr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ ',0),(1120,32,'tr','Hesap tÃ¼rÃ¼',0),(1121,32,'pl','Typ konta',0),(1122,32,'bg','Ð¢Ð¸Ð¿ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(1123,32,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(1124,32,'sr','Ð¢Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(1125,32,'vi','Loáº¡i TK',0),(1126,32,'af','Rekening Tipe',0),(1127,32,'ro','Tip de cont',0),(1128,32,'et','Konto tÃ¼Ã¼p',0),(1129,32,'si','Vrsta konta',0),(1130,32,'ba','Tipe Akun',0),(1131,32,'nl','Accounttype',0),(1132,32,'fi','Tilin tyyppi',0),(1133,32,'no','Kontotype',0),(1134,32,'da','Kontotype',0),(1135,32,'ko','ê³„ì • ìœ í˜•',0),(1136,32,'he','×¡×•×’ ×—×©×‘×•×Ÿ',0),(1137,32,'el','Î¤ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(1138,32,'zh','å¸æˆ·ç±»åž‹',0),(1139,32,'sv','Kontotyp',0),(1140,32,'it','Tipo di account',0),(1141,32,'tl','',0),(1142,32,'th','&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(1143,32,'hi','à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(1144,32,'ms','Jenis akaun',0),(1145,32,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(1146,32,'fr','Type de Compte',0),(1147,32,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—',0),(1148,32,'pt','Tipo de conta',0),(1149,32,'ru','Ð¢Ð¸Ð¿ ÑÑ‡ÐµÑ‚Ð°',0),(1150,32,'es','Tipo de Cuenta',0),(1151,32,'de','Kontotyp',0),(1152,32,'en','Account Type',0),(1153,33,'is','',0),(1154,33,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨',0),(1155,33,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨',0),(1156,33,'tr','Hesap tÃ¼rÃ¼ Ekle',0),(1157,33,'pl','DodaÄ‡ typ konta',0),(1158,33,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(1159,33,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(1160,33,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ‚Ð¸Ð¿Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(1161,33,'vi','ThÃªm Loáº¡i TK',0),(1162,33,'af','Voeg Rekening Tipe by',0),(1163,33,'ro','Adauga tip de cont ',0),(1164,33,'et','Konto liik lisamiseks',0),(1165,33,'si','Vrsta raÄuna dodamo',0),(1166,33,'ba','Menambah Tipe Akun',0),(1167,33,'nl','Accounttype toevoegen',0),(1168,33,'fi','Tilityyppi lisÃ¤Ã¤',0),(1169,33,'no','Kontotypen legge',0),(1170,33,'da','Kontotypen tilfÃ¸je',0),(1171,33,'ko','ê³„ì • ìœ í˜• ì¶”ê°€',0),(1172,33,'he','×”×•×¡×£ ×¡×•×’ ×—×©×‘×•×Ÿ',0),(1173,33,'el','Î¤ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(1174,33,'zh','æ·»åŠ å¸æˆ·ç±»åž‹',0),(1175,33,'sv','Typ lÃ¤gga till',0),(1176,33,'it','Aggiungi tipo di conto',0),(1177,33,'tl','',0),(1178,33,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3609;&#3636;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(1179,33,'hi','à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(1180,33,'ms','Tambah jenis akaun',0),(1181,33,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨',0),(1182,33,'fr','Type de compte Ã  ajouter',0),(1183,33,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—è¿½åŠ ',0),(1184,33,'pt','Adicionar o tipo de conta',0),(1185,33,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(1186,33,'es','Agregar Tipo de Cuenta',0),(1187,33,'de','Kontotyp hinzufÃ¼gen',0),(1188,33,'en','Account Type Add',0),(1189,34,'is','',0),(1190,34,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(1191,34,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(1192,34,'tr','Hesap tÃ¼rÃ¼ baÅŸarÄ±yla eklendi',0),(1193,34,'pl','PomyÅ›lnie dodano typ konta',0),(1194,34,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(1195,34,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù… Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(1196,34,'sr','Ð¢Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(1197,34,'vi','ThÃªm Loáº¡i TK thÃ nh cÃ´ng',0),(1198,34,'af','Rekening Tipe suksesvol bygevoeg',0),(1199,34,'ro','Tip de cont adaugat cu succes',0),(1200,34,'et','Lisatud konto tÃ¼Ã¼p',0),(1201,34,'si','UspeÅ¡no dodana Vrsta raÄuna',0),(1202,34,'ba','Tipe Akun Berhasil Ditambahkan',0),(1203,34,'nl','Accounttype toegevoegd',0),(1204,34,'fi','Tilityyppi lisÃ¤Ã¤minen onnistui',0),(1205,34,'no','Kontotypen lagt',0),(1206,34,'da','Kontotypen tilfÃ¸jet',0),(1207,34,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ê³„ì • ìœ í˜•',0),(1208,34,'he','×¡×•×’ ×—×©×‘×•×Ÿ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(1209,34,'el','Î¤ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(1210,34,'zh','å¸æˆ·ç±»åž‹æ·»åŠ æˆåŠŸ',0),(1211,34,'sv','Kontotyp som lagts',0),(1212,34,'it','Tipo di account aggiunto con successo',0),(1213,34,'tl','',0),(1214,34,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3609;&#3636;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(1215,34,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(1216,34,'ms','Jenis akaun yang berjaya menambah',0),(1217,34,'ar','Ø£Ø¶ÙŠÙ Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(1218,34,'fr','Type de compte ajoutÃ© avec succÃ¨s',0),(1219,34,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—è¿½åŠ æˆ?åŠŸ',0),(1220,34,'pt','Tipo de conta adicionado com sucesso',0),(1221,34,'ru','Ð¢Ð¸Ð¿ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(1222,34,'es','Tipo de Cuenta agregado satisfactoriamente',0),(1223,34,'de','Kontotyp erfolgreich hinzugefÃ¼gt',0),(1224,34,'en','Account Type added successfully',0),(1225,35,'is','',0),(1226,35,'dr','Ø­Ø°Ù Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(1227,35,'pr','Ø­Ø°Ù Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(1228,35,'tr','Hesap tÃ¼rÃ¼ baÅŸarÄ±yla silindi',0),(1229,35,'pl','Typ konta usuniÄ™te pomyÅ›lnie',0),(1230,35,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(1231,35,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù‚Ø³Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(1232,35,'sr','Ð¢Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(1233,35,'vi','XÃ³a Loáº¡i TK thÃ nh cÃ´ng',0),(1234,35,'af','Rekening Tipe suksesvol geskrap',0),(1235,35,'ro','Tip de cont sters cu succes ',0),(1236,35,'et','KontotÃ¼Ã¼p kustutati edukalt',0),(1237,35,'si','Vrsta konta uspeÅ¡no izbrisana',0),(1238,35,'ba','Tipe Akun Berhasil Dihapus',0),(1239,35,'nl','Accounttype verwijderd',0),(1240,35,'fi','Tilityyppi poistettu',0),(1241,35,'no','Kontotypen ble slettet',0),(1242,35,'da','Kontotypen slettet',0),(1243,35,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ê³„ì • ìœ í˜•',0),(1244,35,'he','×¡×•×’ ×”×—×©×‘×•×Ÿ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(1245,35,'el','Î¤ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(1246,35,'zh','å¸æˆ·ç±»åž‹åˆ é™¤æˆåŠŸ',0),(1247,35,'sv','Typ av konto raderades',0),(1248,35,'it','Tipo di account eliminato con successo',0),(1249,35,'tl','',0),(1250,35,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3594;&#3609;&#3636;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(1251,35,'hi','à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(1252,35,'ms','Jenis akaun yang dihapuskan dengan jayanya',0),(1253,35,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(1254,35,'fr','Type de compte supprimÃ© avec succÃ¨s ',0),(1255,35,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—æ¶ˆåŽ»æˆ?åŠŸ',0),(1256,35,'pt','Tipo de conta apagado com sucesso',0),(1257,35,'ru','Ð¢Ð¸Ð¿ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(1258,35,'es','Tipo de Cuenta eliminado satisfactoriamente',0),(1259,35,'de','Kontotyp erfolgreich gelÃ¶scht',0),(1260,35,'en','Account Type deleted successfully',0),(1261,36,'is','',0),(1262,36,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨',0),(1263,36,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨',0),(1264,36,'tr','Hesap tÃ¼rÃ¼ gÃ¼ncelleÅŸtirme',0),(1265,36,'pl','Konta typu Update',0),(1266,36,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð²Ð¸Ð´ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(1267,36,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(1268,36,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ð¸Ð¿Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(1269,36,'vi','Cáº­p Nháº­t Loáº¡i TK',0),(1270,36,'af','Rekening Tipe opdateer',0),(1271,36,'ro','Actualizare tip de cont',0),(1272,36,'et','Konto tÃ¼Ã¼bi uuendus',0),(1273,36,'si','Posodobitev raÄuna je vrsta',0),(1274,36,'ba','Pembaharuan Tipe Akun',0),(1275,36,'nl','Account Type Update',0),(1276,36,'fi','Tyypin pÃ¤ivitys',0),(1277,36,'no','Typen oppdatering',0),(1278,36,'da','Konto Type opdatering',0),(1279,36,'ko','ê³„ì • ìœ í˜• ì—…ë°ì´íŠ¸',0),(1280,36,'he','×¢×“×›×•×Ÿ ×¡×•×’ ×—×©×‘×•×Ÿ',0),(1281,36,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(1282,36,'zh','å¸æˆ·ç±»åž‹æ›´æ–°',0),(1283,36,'sv','Konto typ uppdatering',0),(1284,36,'it','Aggiornamento tipo conto',0),(1285,36,'tl','',0),(1286,36,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3594;&#3609;&#3636;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(1287,36,'hi','à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(1288,36,'ms','Kemaskini jenis akaun',0),(1289,36,'ar','ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(1290,36,'fr','Mise Ã  jour de type de compte',0),(1291,36,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—ã‚’æ›´æ–°',0),(1292,36,'pt','ActualizaÃ§Ã£o do tipo de conta',0),(1293,36,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð° ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(1294,36,'es','Actualizar Tipo de Cuenta',0),(1295,36,'de','Typ Kontoaktualisierung',0),(1296,36,'en','Account Type Update',0),(1297,37,'is','',0),(1298,37,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(1299,37,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(1300,37,'tr','Hesap tÃ¼rÃ¼ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(1301,37,'pl','Typ konta pomyÅ›lnie zaktualizowana',0),(1302,37,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(1303,37,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(1304,37,'sr','Ð¢Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(1305,37,'vi','Cáº­p Nháº­t Loáº¡i TK thÃ nh cÃ´ng',0),(1306,37,'af','Rekening Tipe suksesvol opgedateer',0),(1307,37,'ro','Actualizare tip de cont reusita',0),(1308,37,'et','VÃ¤rskendatud kontotÃ¼Ã¼p',0),(1309,37,'si','Vrsta konta uspeÅ¡no posodobljena',0),(1310,37,'ba','Tipe Akun Berhasil Diperbaharui',0),(1311,37,'nl','Accounttype bijgewerkt',0),(1312,37,'fi','PÃ¤ivitetty tilityyppi',0),(1313,37,'no','Kontotypen oppdatert',0),(1314,37,'da','Kontotypen opdateret',0),(1315,37,'ko','ê³„ì • ìœ í˜•ì„ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(1316,37,'he','×¡×•×’ ×”×—×©×‘×•×Ÿ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(1317,37,'el','Î¤ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(1318,37,'zh','å¸æˆ·ç±»åž‹æ›´æ–°æˆåŠŸ',0),(1319,37,'sv','Kontotyp som uppdaterats',0),(1320,37,'it','Tipo di account aggiornato con successo',0),(1321,37,'tl','',0),(1322,37,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3594;&#3609;&#3636;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(1323,37,'hi','à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(1324,37,'ms','Jenis akaun yang berjaya dikemas kini',0),(1325,37,'ar','Ø­Ø¯Ù‘Ø« Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(1326,37,'fr','Mise Ã  jour de type de compte rÃ©ussie',0),(1327,37,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—æ›´æ–°æˆ?åŠŸ',0),(1328,37,'pt','Tipo de conta atualizado com sucesso',0),(1329,37,'ru','Ð¢Ð¸Ð¿ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(1330,37,'es','Tipo de Cuenta actualizada satisfactoriamente',0),(1331,37,'de','Kontotyp erfolgreich aktualisiert',0),(1332,37,'en','Account Type updated successfully',0),(1333,38,'is','',0),(1334,38,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨',0),(1335,38,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨',0),(1336,38,'tr','Hesap gÃ¼ncelleÅŸtirme',0),(1337,38,'pl','Aktualizacja konta',0),(1338,38,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð°',0),(1339,38,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(1340,38,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(1341,38,'vi','Cáº­p Nháº­t TK',0),(1342,38,'af','Rekening Opdateer',0),(1343,38,'ro','Actualizare cont',0),(1344,38,'et','Konto vÃ¤rskendamine',0),(1345,38,'si','Posodobitev raÄuna',0),(1346,38,'ba','Akun Diperbaharui',0),(1347,38,'nl','Account bijwerken',0),(1348,38,'fi','PÃ¤ivitys',0),(1349,38,'no','Oppdatering',0),(1350,38,'da','Konto opdatering',0),(1351,38,'ko','ê³„ì • ì—…ë°ì´íŠ¸',0),(1352,38,'he','×¢×“×›×•×Ÿ ×—×©×‘×•×Ÿ',0),(1353,38,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(1354,38,'zh','å¸æˆ·æ›´æ–°',0),(1355,38,'sv','Konto uppdatering',0),(1356,38,'it','Aggiornamento del conto',0),(1357,38,'tl','',0),(1358,38,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(1359,38,'hi','à¤–à¤¾à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(1360,38,'ms','Kemaskini akaun',0),(1361,38,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø­Ø³Ø§Ø¨',0),(1362,38,'fr','Mise Ã  jour de compte',0),(1363,38,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’æ›´æ–°',0),(1364,38,'pt','AtualizaÃ§Ã£o de conta',0),(1365,38,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(1366,38,'es','Actualizar Cuenta',0),(1367,38,'de','Kontoaktualisierung',0),(1368,38,'en','Account Update',0),(1369,39,'is','',0),(1370,39,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(1371,39,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(1372,39,'tr','Hesap baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(1373,39,'pl','Konto pomyÅ›lnie zaktualizowana',0),(1374,39,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(1375,39,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(1376,39,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(1377,39,'vi','Cáº­p Nháº­t TK thÃ nh cÃ´ng',0),(1378,39,'af','Rekening suksesvol opdateer',0),(1379,39,'ro','Actualizare cont reusita',0),(1380,39,'et','Konto vÃ¤rskendamine Ãµnnestus',0),(1381,39,'si','RaÄun uspeÅ¡no posodobljena',0),(1382,39,'ba','Akun Berhasil Diperbaharui',0),(1383,39,'nl','Rekening met succes bijgewerkt',0),(1384,39,'fi','Tilin pÃ¤ivittÃ¤minen onnistui',0),(1385,39,'no','Kontoen oppdatert',0),(1386,39,'da','Konto opdateret',0),(1387,39,'ko','ê³„ì •ì´ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´ íŠ¸',0),(1388,39,'he','×”×—×©×‘×•×Ÿ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(1389,39,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(1390,39,'zh','å¸æˆ·æ›´æ–°æˆåŠŸ',0),(1391,39,'sv','Konto uppdaterats',0),(1392,39,'it','Conto aggiornato con successo',0),(1393,39,'tl','',0),(1394,39,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(1395,39,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(1396,39,'ms','Akaun yang berjaya dikemas kini',0),(1397,39,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(1398,39,'fr','Mise Ã  Jour de Compte RÃ©ussi',0),(1399,39,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆæ›´æ–°æˆ?åŠŸ',0),(1400,39,'pt','Conta atualizada com sucesso',0),(1401,39,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(1402,39,'es','Cuenta actualizada satisfactoriamente',0),(1403,39,'de','Konto erfolgreich aktualisiert',0),(1404,39,'en','Account updated successfully',0),(1405,40,'is','',0),(1406,40,'dr','(Ø¨Ø§Ù‚ÛŒØ§Øª)',0),(1407,40,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(1408,40,'tr','BorÃ§ hesaplarÄ±',0),(1409,40,'pl','Rozrachunki z dostawcami',0),(1410,40,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(1411,40,'ur','ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ú©Ú¾Ø§ØªÛ’',0),(1412,40,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(1413,40,'vi','TK Pháº£i Tráº£',0),(1414,40,'af','Uitgawes (Rekeninge Betaalbaar)',0),(1415,40,'ro','Conturi Plati',0),(1416,40,'et','Tasumata arved',0),(1417,40,'si','Obveznosti do dobav.',0),(1418,40,'ba','Akun Hutang',0),(1419,40,'nl','Crediteuren',0),(1420,40,'fi','Ostovelat',0),(1421,40,'no','LeverandÃ¸rer',0),(1422,40,'da','Kreditor',0),(1423,40,'ko','ê³„ì • ì§€ê¸‰',0),(1424,40,'he','×—×©×‘×•× ×•×ª ×–×›××™×',0),(1425,40,'el','Î Î»Î·ÏÏ‰Ï„Î­Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(1426,40,'zh','æ”¯ä»˜å¸å·',0),(1427,40,'sv','LeverantÃ¶rsskulder',0),(1428,40,'it','ContabilitÃ  fornitori',0),(1429,40,'tl','',0),(1430,40,'th','&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(1431,40,'hi','à¤²à¥‡à¤–à¤¾ à¤¦à¥‡à¤¯',0),(1432,40,'ms','Akaun belum bayar',0),(1433,40,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯Ø§Ø¦Ù†Ø©',0),(1434,40,'fr','Comptes Payables',0),(1435,40,'jp','è²·æŽ›é‡‘',0),(1436,40,'pt','Contas a pagar',0),(1437,40,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ',0),(1438,40,'es','Cuentas por Pagar',0),(1439,40,'de','Bezahlbare Konten',0),(1440,40,'en','Accounts Payable',0),(1441,41,'is','',0),(1442,41,'dr','- Ù†ØµØ¨',0),(1443,41,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ- Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ',0),(1444,41,'tr','Accts Ã¶denecek<br>Kurulum',0),(1445,41,'pl','Accts pÅ‚atne<br>Instalacji',0),(1446,41,'bg','Accts Ð¿Ð»Ð°Ñ‚Ð¸Ð¼Ð¸<br>ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(1447,41,'ur','ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ú©Ú¾Ø§ØªÛ’ Û²',0),(1448,41,'sr','ÐÑ†Ñ†Ñ‚Ñ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°<br>ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(1449,41,'vi','TK Pháº£i Tráº£Setup',0),(1450,41,'af','Uitgawes (Rekeninge Betaalbaar)<br>Opstelling',0),(1451,41,'ro','Conturi Plati<br>Setari',0),(1452,41,'et','Accts makstakse<br>Seadistamine',0),(1453,41,'si','Accts obveznosti<br>Nastavitev',0),(1454,41,'ba','Setup Akun<br>Hutang',0),(1455,41,'nl','Accts te betalen<br>Setup',0),(1456,41,'fi','Maalari<br>Asetukset',0),(1457,41,'no','Accts betales<br>Installasjonsprogrammet',0),(1458,41,'da','Accts skal betales<br>OpsÃ¦tning',0),(1459,41,'ko','Accts ì§€ê¸‰<br>ì„¤ì¹˜',0),(1460,41,'he','Accts ×œ×ª×©×œ×•×<br>×ª×•×›× ×™×ª ×”×”×ª×§× ×”',0),(1461,41,'el','Accts Ï€Î»Î·ÏÏ‰Ï„Î­Î¿Î¹<br>Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ (Setup)',0),(1462,41,'zh','æ”¯ä»˜å¸å·å»ºç«‹',0),(1463,41,'sv','Accts betalas<br>Setup',0),(1464,41,'it','Crediti v / Payable<br>Programma di installazione',0),(1465,41,'tl','',0),(1466,41,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(1467,41,'hi','Accts à¤¦à¥‡à¤¯<br>à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(1468,41,'ms','Accts yang kena dibayar<br>Persediaan',0),(1469,41,'ar','Accts Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹<br>Ø¨Ø±Ù†Ø§Ù…Ø¬ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(1470,41,'fr','Cmpts Payables<br>Installation',0),(1471,41,'jp','è²·æŽ›é‡‘<br>è¨­å®š',0),(1472,41,'pt','Pagar accts<br>InstalaÃ§Ã£o',0),(1473,41,'ru','Accts ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ<br>ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(1474,41,'es','Cuentas por Pagar<br>ConfiguraciÃ³n',0),(1475,41,'de','Bezahlbare Konten<br>Einrichtung',0),(1476,41,'en','Accts Payable<br>Setup',0),(1477,42,'is','',0),(1478,42,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ',0),(1479,42,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ',0),(1480,42,'tr','Alacak hesaplarÄ±',0),(1481,42,'pl','Rozrachunki z odbiorcami',0),(1482,42,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ',0),(1483,42,'ur','Ù…ØµÙˆÙ„ ÛÙˆÙ†Û’ ÙˆØ§Ù„Û’ Ú©Ú¾Ø§ØªÛ’',0),(1484,42,'sr','ÐšÐ¾Ð½Ñ‚Ð° Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(1485,42,'vi','TK Pháº£i Thu',0),(1486,42,'af','Inkomste (Rekeninge Ontvangbaar)',0),(1487,42,'ro','Conturi Incasari',0),(1488,42,'et','Laekumata arved',0),(1489,42,'si','Saldakonti kupcev',0),(1490,42,'ba','Akun Piutang',0),(1491,42,'nl','Debiteuren',0),(1492,42,'fi','Myyntisaamiset',0),(1493,42,'no','Fordringer',0),(1494,42,'da','Tilgodehavender',0),(1495,42,'ko','ê³„ì • ë¯¸ìˆ˜ê¸ˆ',0),(1496,42,'he','×—×©×‘×•× ×•×ª ×—×™×™×‘×™×',0),(1497,42,'el','Î•Î¹ÏƒÏ€ÏÎ±ÎºÏ„Î­Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(1498,42,'zh','åº”æ”¶è´¦æ¬¾\r\n',0),(1499,42,'sv','Kundreskontra',0),(1500,42,'it','ContabilitÃ  clienti',0),(1501,42,'tl','',0),(1502,42,'th','&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(1503,42,'hi','à¤•à¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¯ à¤šà¥€à¤œà¤¼à¥‡à¤‚ à¤–à¤¾à¤¤à¥‡',0),(1504,42,'ms','Akaun belum terima',0),(1505,42,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(1506,42,'fr','Comptes Recevables',0),(1507,42,'jp','å£²æŽ›é‡‘',0),(1508,42,'pt','Contas a receber',0),(1509,42,'ru','Ð”ÐµÐ±Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ',0),(1510,42,'es','Cuentas por Cobrar',0),(1511,42,'de','Forderungen aus Lieferungen',0),(1512,42,'en','Accounts Receivable',0),(1513,43,'is','',0),(1514,43,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ÙØ¹Ø§Ù„',0),(1515,43,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ÙØ¹Ø§Ù„',0),(1516,43,'tr','Aktif mÃ¼ÅŸteri',0),(1517,43,'pl','Aktywnych klientÃ³w',0),(1518,43,'bg','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(1519,43,'ur','ÙØ¹Ø§Ù„ ØµØ§Ø±ÙÛŒÙ†',0),(1520,43,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ ÐºÑƒÐ¿Ñ†Ð¸',0),(1521,43,'vi','KÃ­ch Hoáº¡t KhÃ¡ch HÃ ng',0),(1522,43,'af','Aktiewe Klante/KliÃ«nte',0),(1523,43,'ro','Clienti activi',0),(1524,43,'et','Aktiivne Klient',0),(1525,43,'si','Aktivni uporabniki',0),(1526,43,'ba','Pelanggan Aktif',0),(1527,43,'nl','Actieve klanten',0),(1528,43,'fi','Aktiivisten asiakkaiden',0),(1529,43,'no','Aktive kunder',0),(1530,43,'da','Aktive gÃ¦ster',0),(1531,43,'ko','ì ê·¹ì ì¸ ê³ ê°',0),(1532,43,'he','×œ×§×•×—×•×ª ×¤×¢×™×œ×™×',0),(1533,43,'el','Î•Î½ÎµÏÎ³Î¿ÏÏ‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(1534,43,'zh','æ´»èºçš„å®¢æˆ·\r\n',0),(1535,43,'sv','Aktiva kunder',0),(1536,43,'it','Clienti attivi',0),(1537,43,'tl','',0),(1538,43,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(1539,43,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(1540,43,'ms','Pelanggan-pelanggan aktif',0),(1541,43,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ù†Ø´Ø·Ø©',0),(1542,43,'fr','Clients Actifs',0),(1543,43,'jp','ç?¾å½¹ã?®é¡§å®¢',0),(1544,43,'pt','Clientes ativos',0),(1545,43,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹',0),(1546,43,'es','Clientes Activos',0),(1547,43,'de','Aktive Kunden',0),(1548,43,'en','Active Customers',0),(1549,44,'is','',0),(1550,44,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ÙØ¹Ø§Ù„',0),(1551,44,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ÙØ¹Ø§Ù„',0),(1552,44,'tr','Aktif Ã§alÄ±ÅŸanlar',0),(1553,44,'pl','Aktywni pracownicy',0),(1554,44,'bg','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(1555,44,'ur','Ø²ÛŒØ± Ø¹Ù…Ù„ Ù…Ù„Ø§Ø²Ù…ÛŒÙ†',0),(1556,44,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸Ñ… Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(1557,44,'vi','KÃ­ch Hoáº¡t NhÃ¢n ViÃªn',0),(1558,44,'af','Aktiewe Werknemers',0),(1559,44,'ro','Angajati activi',0),(1560,44,'et','Aktiivsed tÃ¶Ã¶tajad',0),(1561,44,'si','Aktivno zaposleni',0),(1562,44,'ba','Karyawan Aktif',0),(1563,44,'nl','Actieve medewerkers',0),(1564,44,'fi','Aktiivisimpia tyÃ¶ntekijÃ¶itÃ¤',0),(1565,44,'no','Aktive ansatte',0),(1566,44,'da','Aktive medarbejdere',0),(1567,44,'ko','í™œì„± ì§ì›',0),(1568,44,'he','×¢×•×‘×“×™× ×¤×¢×™×œ×™×',0),(1569,44,'el','Î•Î½ÎµÏÎ³ÏŽÎ½ Ï…Ï€Î±Î»Î»Î®Î»Ï‰Î½',0),(1570,44,'zh','æ´»èºçš„èŒå“¡\r\n',0),(1571,44,'sv','Aktiva anstÃ¤llda',0),(1572,44,'it','Collaboratori attivi',0),(1573,44,'tl','',0),(1574,44,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(1575,44,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚',0),(1576,44,'ms','Kakitangan aktif',0),(1577,44,'ar','Ø§Ù„Ù…ÙˆØ¸ÙÙˆÙ† Ø§Ù„Ø¹Ø§Ù…Ù„ÙˆÙ†',0),(1578,44,'fr','EmployÃ©es Actifs',0),(1579,44,'jp','ç?¾å½¹ã?®å¾“æ¥­å“¡',0),(1580,44,'pt','Empregados ativos',0),(1581,44,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¸',0),(1582,44,'es','Empleados Activos',0),(1583,44,'de','Aktive Mitarbeiter',0),(1584,44,'en','Active Employees',0),(1585,45,'is','',0),(1586,45,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ ',0),(1587,45,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ ',0),(1588,45,'tr','Etkin stok maddeleri',0),(1589,45,'pl','Aktywne zapasÃ³w',0),(1590,45,'bg','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸Ñ‚Ðµ ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(1591,45,'ur','Ø²ÛŒØ± Ø¹Ù…Ù„ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡',0),(1592,45,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(1593,45,'vi','KÃ­ch Hoáº¡t HÃ ng HÃ³a',0),(1594,45,'af','Aktiewe Voorraad Items',0),(1595,45,'ro','Articole de inventar active',0),(1596,45,'et','Aktiivne laokaupade',0),(1597,45,'si','Aktivna zaloga artiklov',0),(1598,45,'ba','Item Inventori Aktif',0),(1599,45,'nl','Actieve voorraadartikelen',0),(1600,45,'fi','Aktiivinen varastonimikkeiden',0),(1601,45,'no','Aktive lagervarer',0),(1602,45,'da','Aktive lagervarer',0),(1603,45,'ko','í™œë™ì ì¸ ìž¬ê³  ëª©ë¡ í’ˆëª©',0),(1604,45,'he','×¤×¨×™×˜×™ ×ž×œ××™ ×¤×¢×™×œ×™×',0),(1605,45,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ ÎµÎ½ÎµÏÎ³ÏŒ',0),(1606,45,'zh','èƒ½åŠ¨åº“å­˜é¡¹ç›®\r\n',0),(1607,45,'sv','Aktiva lagerartiklar',0),(1608,45,'it','Articoli di magazzino attivo',0),(1609,45,'tl','',0),(1610,45,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(1611,45,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(1612,45,'ms','Item-item inventori aktif',0),(1613,45,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù†Ø´Ø·Ø© Ù…Ù† Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(1614,45,'fr','Inventaires Actifs',0),(1615,45,'jp','ç?¾å½¹ã?®åœ¨åº«å“?ç›®',0),(1616,45,'pt','Itens de inventÃ¡rio de ativos',0),(1617,45,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ Ñ‚Ð¾Ð²Ð°Ñ€Ð½Ð¾-Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ñ… Ñ†ÐµÐ½Ð½Ð¾ÑÑ‚ÐµÐ¹',0),(1618,45,'es','Items de Inventario Activos',0),(1619,45,'de','Aktive Lagerartikel',0),(1620,45,'en','Active Inventory Items',0),(1621,46,'is','',0),(1622,46,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ÙØ¹Ø§Ù„',0),(1623,46,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ÙØ¹Ø§Ù„',0),(1624,46,'tr','Etkin satÄ±cÄ±lar',0),(1625,46,'pl','Aktywnych dostawcÃ³w',0),(1626,46,'bg','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(1627,46,'ur','Ø²ÛŒØ± Ø¹Ù…Ù„ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº',0),(1628,46,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(1629,46,'vi','KÃ­ch Hoáº¡t NgÆ°á»i BÃ¡n',0),(1630,46,'af','Aktiewe Verskaffers',0),(1631,46,'ro','Furnizor activ',0),(1632,46,'et','Aktiveeri tarnija',0),(1633,46,'si','Aktivno prodajalci',0),(1634,46,'ba','Pemasok Aktif',0),(1635,46,'nl','Actieve leveranciers',0),(1636,46,'fi','Aktiivisten toimittajien',0),(1637,46,'no','Aktive leverandÃ¸rer',0),(1638,46,'da','Aktive leverandÃ¸rer',0),(1639,46,'ko','í™œì„± ê³µê¸‰ ì—…ì²´',0),(1640,46,'he','×¡×¤×§×™× ×¤×¢×™×œ×™×',0),(1641,46,'el','Î•Î½ÎµÏÎ³ÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚',0),(1642,46,'zh','æ´»è·ƒä¾›åº”å•†\r\n',0),(1643,46,'sv','Aktiva leverantÃ¶rer',0),(1644,46,'it','Fornitori attivi',0),(1645,46,'tl','',0),(1646,46,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(1647,46,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(1648,46,'ms','Vendor yang aktif',0),(1649,46,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙˆÙ† Ø§Ù„Ù†Ø´Ø·ÙˆÙ†',0),(1650,46,'fr','Fournisseurs Actifs',0),(1651,46,'jp','ç?¾å½¹ã?®æ¥­è€…',0),(1652,46,'pt','Fornecedores ativos',0),(1653,46,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸',0),(1654,46,'es','Proveedores Activos',0),(1655,46,'de','Aktive Anbieter',0),(1656,46,'en','Active Vendors',0),(1657,47,'is','',0),(1658,47,'dr','ÙØ¹Ø§Ù„ÙŠØª ',0),(1659,47,'pr','ÙØ¹Ø§Ù„ÙŠØª ',0),(1660,47,'tr','Eylem',0),(1661,47,'pl','DziaÅ‚ania',0),(1662,47,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(1663,47,'ur','Ø¹Ù…Ù„',0),(1664,47,'sr','ÐÐºÑ†Ð¸Ñ˜Ð°',0),(1665,47,'vi','HÃ nh Äá»™ng',0),(1666,47,'af','Aksie',0),(1667,47,'ro','Actiune',0),(1668,47,'et','Tegevus',0),(1669,47,'si','Dejanje',0),(1670,47,'ba','Tindakan',0),(1671,47,'nl','Actie',0),(1672,47,'fi','TehtÃ¤vÃ¤',0),(1673,47,'no','Handlingen',0),(1674,47,'da','Handling',0),(1675,47,'ko','ì•¡ì…˜',0),(1676,47,'he','×¤×¢×•×œ×”',0),(1677,47,'el','Î”ÏÎ¬ÏƒÎ·',0),(1678,47,'zh','åŠ¨ä½œ',0),(1679,47,'sv','Ã…tgÃ¤rd',0),(1680,47,'it','Azione',0),(1681,47,'tl','',0),(1682,47,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(1683,47,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(1684,47,'ms','Tindakan',0),(1685,47,'ar','Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(1686,47,'fr','Action',0),(1687,47,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(1688,47,'pt','AÃ§Ã£o',0),(1689,47,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(1690,47,'es','AcciÃ³n',0),(1691,47,'de','Aktion',0),(1692,47,'en','Action',0),(1693,48,'is','',0),(1694,48,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(1695,48,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(1696,48,'tr','Eylem baÅŸarÄ±yla eklendi',0),(1697,48,'pl','Akcja dodane pomyÅ›lnie',0),(1698,48,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(1699,48,'ur','Ø¹Ù…Ù„ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(1700,48,'sr','Ð Ð°Ð´ÑšÐ° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(1701,48,'vi','HÃ nh Ä‘á»™ng thÃªm vÃ o thÃ ng cÃ´ng',0),(1702,48,'af','Aksie Suksesvol Bygevoeg',0),(1703,48,'ro','Actiune adaugata cu succes',0),(1704,48,'et','Lisatud meetme',0),(1705,48,'si','Dejanje, ki doda uspeÅ¡no',0),(1706,48,'ba','Berhasil ditambahkan',0),(1707,48,'nl','Optreden toegevoegd',0),(1708,48,'fi','TehtÃ¤vÃ¤ lisÃ¤tty',0),(1709,48,'no','Handlingen ble lagt til',0),(1710,48,'da','Handling tilfÃ¸jet',0),(1711,48,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ìž‘ì—…',0),(1712,48,'he','×”×¤×¢×•×œ×” × ×•×¡×¤×” ×‘×”×¦×œ×—×”',0),(1713,48,'el','Î”ÏÎ¬ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(1714,48,'zh','åŠ¨ä½œæˆåŠŸæ·»åŠ \r\n',0),(1715,48,'sv','Ã…tgÃ¤rder lagts',0),(1716,48,'it','Azione aggiunta correttamente',0),(1717,48,'tl','',0),(1718,48,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(1719,48,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(1720,48,'ms','Tindakan yang berjaya menambah',0),(1721,48,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„Ø¹Ù…Ù„ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(1722,48,'fr','Ajout d\'Action RÃ©ussi',0),(1723,48,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³è¿½åŠ æˆ?åŠŸ',0),(1724,48,'pt','AÃ§Ã£o adicionada com sucesso',0),(1725,48,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾',0),(1726,48,'es','AcciÃ³n agregada satisfactoriamente',0),(1727,48,'de','Aktion erfolgreich hinzugefÃ¼gt',0),(1728,48,'en','Action added successfully',0),(1729,49,'is','',0),(1730,49,'dr','ÙØ¹Ø§Ù„ÙŠØª',0),(1731,49,'pr','ÙØ¹Ø§Ù„ÙŠØª',0),(1732,49,'tr','EYLEM',0),(1733,49,'pl','DZIAÅANIA',0),(1734,49,'bg','Ð”Ð•Ð™Ð¡Ð¢Ð’Ð˜Ð•',0),(1735,49,'ur','Ø¹Ù…Ù„',0),(1736,49,'sr','ÐÐšÐ¦Ð˜ÐˆÐ',0),(1737,49,'vi','HÃ€NH Äá»˜NG',0),(1738,49,'af','AKSIE',0),(1739,49,'ro','ACTIUNE',0),(1740,49,'et','TEGEVUS',0),(1741,49,'si','DEJANJE',0),(1742,49,'ba','Tindakan',0),(1743,49,'nl','ACTIE',0),(1744,49,'fi','TOIMINTA',0),(1745,49,'no','HANDLINGEN',0),(1746,49,'da','HANDLING',0),(1747,49,'ko','ì•¡ì…˜',0),(1748,49,'he','×¤×¢×•×œ×”',0),(1749,49,'el','Î”Î¡Î†Î£Î—',0),(1750,49,'zh','åŠ¨ä½œ\r\n',0),(1751,49,'sv','Ã…TGÃ„RD',0),(1752,49,'it','Azione',0),(1753,49,'tl','',0),(1754,49,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(1755,49,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(1756,49,'ms','TINDAKAN',0),(1757,49,'ar','Ø¹Ù…Ù„',0),(1758,49,'fr','Action',0),(1759,49,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(1760,49,'pt','AÃ‡ÃƒO',0),(1761,49,'ru','Ð”Ð•Ð™Ð¡Ð¢Ð’Ð˜Ð•',0),(1762,49,'es','ACCION',0),(1763,49,'de','AKTION',0),(1764,49,'en','ACTION',0),(1765,50,'is','',0),(1766,50,'dr','Ø­Ø°Ù ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(1767,50,'pr','Ø­Ø°Ù ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(1768,50,'tr','Eylem baÅŸarÄ±yla silindi',0),(1769,50,'pl','Akcja przesâ”‚anie',0),(1770,50,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(1771,50,'ur','Ø¹Ù…Ù„ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(1772,50,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(1773,50,'vi','HÃ nh Ä‘á»™ng xÃ³a bá» thÃ nh cÃ´ng',0),(1774,50,'af','Aksie Suksesvol Verwyder',0),(1775,50,'ro','Actiune stearsa cu succes',0),(1776,50,'et','Tegevus kustutati edukalt',0),(1777,50,'si','Dejanje uspeÅ¡no izbrisana',0),(1778,50,'ba','Pelaksanaan berhasil dihapus',0),(1779,50,'nl','Actie succesvol verwijderd',0),(1780,50,'fi','TehtÃ¤vÃ¤ poistettu',0),(1781,50,'no','Handlingen ble slettet',0),(1782,50,'da','Handling slettet',0),(1783,50,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ìž‘ì—…',0),(1784,50,'he','×”×¤×¢×•×œ×” × ×ž×—×§×” ×‘×”×¦×œ×—×”',0),(1785,50,'el','Î”ÏÎ¬ÏƒÎ· Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(1786,50,'zh','åŠ¨ä½œæˆåŠŸåˆ é™¤\r\n',0),(1787,50,'sv','Ã…tgÃ¤rd raderades',0),(1788,50,'it','Azione cancellata correttamente',0),(1789,50,'tl','',0),(1790,50,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(1791,50,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(1792,50,'ms','Tindakan dihapuskan dengan jayanya',0),(1793,50,'ar','Ø­Ø°ÙØª Ø§Ù„Ø¹Ù…Ù„ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(1794,50,'fr','Supprime Action RÃ©ussi',0),(1795,50,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³æ¶ˆåŽ»æˆ?åŠŸ',0),(1796,50,'pt','AÃ§Ã£o apagada com sucesso',0),(1797,50,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾',0),(1798,50,'es','AcciÃ³n eliminada satisfactoriamente',0),(1799,50,'de','Aktion erfolgreich gelÃ¶scht',0),(1800,50,'en','Action deleted successfully',0),(1801,51,'is','',0),(1802,51,'dr','ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(1803,51,'pr','ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(1804,51,'tr','Eylem baÅŸarÄ±yla kaydedildi',0),(1805,51,'pl','DziaÅ‚ania zapisane',0),(1806,51,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(1807,51,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ø¹Ù…Ù„',0),(1808,51,'sr','Ð Ð°Ð´ÑšÐ° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(1809,51,'vi','HÃ nh Ä‘á»™ng save thÃ nh cÃ´ng',0),(1810,51,'af','Aksie Suksesvol Gestoor',0),(1811,51,'ro','Actiune salvata cu succes',0),(1812,51,'et','Tegevus salvestati edukalt',0),(1813,51,'si','Dejanje, ki je uspeÅ¡no shranjen',0),(1814,51,'ba','Tindakan berhasil disimpan',0),(1815,51,'nl','Actie succesvol opgeslagen',0),(1816,51,'fi','TehtÃ¤vÃ¤ tallennettu',0),(1817,51,'no','Handlingen lagret',0),(1818,51,'da','Handling gemt med succes',0),(1819,51,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” ìž‘ì—…',0),(1820,51,'he','×”×¤×¢×•×œ×” × ×©×ž×¨×” ×‘×”×¦×œ×—×”',0),(1821,51,'el','Î”ÏÎ¬ÏƒÎ· Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(1822,51,'zh','åŠ¨ä½œå‚¨å­˜æˆåŠŸ\r\n',0),(1823,51,'sv','Ã…tgÃ¤rder som sparats',0),(1824,51,'it','Azione salvata correttamente',0),(1825,51,'tl','',0),(1826,51,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(1827,51,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(1828,51,'ms','Tindakan yang berjaya disimpan',0),(1829,51,'ar','Ø­ÙØ¸Øª Ø§Ù„Ø¹Ù…Ù„ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(1830,51,'fr','Action Sauvegarder',0),(1831,51,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ä¿?å­˜æˆ?åŠŸ',0),(1832,51,'pt','AÃ§Ã£o com sucesso',0),(1833,51,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¾',0),(1834,51,'es','AcciÃ³n grabada satisfactoriamente',0),(1835,51,'de','Aktion erfolgreich gespeichert',0),(1836,51,'en','Action saved successfully',0),(1837,52,'is','',0),(1838,52,'dr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§ÙŠ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(1839,52,'pr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§ÙŠ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(1840,52,'tr','SilinmiÅŸ Ã¶ÄŸeyi etkinleÅŸtirmek',0),(1841,52,'pl','AktywowaÄ‡ usuniÄ™tych elementÃ³w',0),(1842,52,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(1843,52,'ur','Ø­Ø°Ù Ø´Ø¯Û Ø¢Ø¦Ù¹Ù… Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(1844,52,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(1845,52,'vi','KÃ­ch Hoáº¡t Danh Má»¥c ÄÃ£ XÃ³a',0),(1846,52,'af','Aktiveer Verwyderde Item',0),(1847,52,'ro','Activeaza articol sters',0),(1848,52,'et','Kustutatud Ã¼ksuse aktiveerimine',0),(1849,52,'si','Aktiviranje izbrisanega elementa',0),(1850,52,'ba','Mengaktifkan Penghapusan Item',0),(1851,52,'nl','Activeer',0),(1852,52,'fi','Aktivoi poistettu kohde',0),(1853,52,'no','Aktivere slettet element',0),(1854,52,'da','Aktivere slettet emne',0),(1855,52,'ko','ì‚­ì œ ëœ í•­ëª©ì„ í™œì„±í™”',0),(1856,52,'he','×”×¤×¢×œ ×¤×¨×™×˜×™× ×©× ×ž×—×§×•',0),(1857,52,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î¿ Î´Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(1858,52,'zh','å·²åˆ é™¤çš„é¡¹ç›®å¯åŠ¨\r\n',0),(1859,52,'sv','Aktivera borttagna objekt',0),(1860,52,'it','Attivare elemento cancellato',0),(1861,52,'tl','',0),(1862,52,'th','&#3648;&#3611;&#3636;&#3604;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3652;&#3629;&#3648;&#3607;&#3655;&#3617;',0),(1863,52,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤†à¤‡à¤Ÿà¤® à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¤¨à¤¾',0),(1864,52,'ms','Aktifkan Item Dihapuskan',0),(1865,52,'ar','Ø¥Ø³ØªØ±Ø¬Ø§Ø¹ Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ù…Ø­Ø°ÙˆÙ',0),(1866,52,'fr','Activer des Ã©lÃ©ments supprimÃ©s',0),(1867,52,'jp','æ¶ˆåŽ»æ¸ˆã?®å“?ç›®ã‚’èµ·å‹•',0),(1868,52,'pt','Ativar o Item excluÃ­do',0),(1869,52,'ru','ÐÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð½Ñ‹Ñ… ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(1870,52,'es','Activar Item Eliminado',0),(1871,52,'de','GelÃ¶schtes Element aktivieren',0),(1872,52,'en','Activate Deleted Item',0),(1873,53,'is','',0),(1874,53,'dr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­Ù„ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(1875,53,'pr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­Ù„ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(1876,53,'tr','Silinen konum bilgilerini etkinleÅŸtirin',0),(1877,53,'pl','AktywowaÄ‡ Informacje o lokalizacji usuniÄ™te',0),(1878,53,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(1879,53,'ur','Ø­Ø°Ù Ú©Ø±Ø¯Û Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(1880,53,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(1881,53,'vi','KÃ­ch Hoáº¡t Vá»‹ TrÃ­ ThÃ´ng Tin ÄÃ£ XÃ³a ',0),(1882,53,'af','Aktiveer Geskrapte Liggingsinformasie',0),(1883,53,'ro','Activeaza informaitie locatie stearsa',0),(1884,53,'et','Aktiveeri kustutatud asukohateabe',0),(1885,53,'si','Aktiviranje izbrisani mesta informacije',0),(1886,53,'ba','Mengaktifkan Penghapusan Informasi Lokasi',0),(1887,53,'nl','Activeer verwijderde locatie',0),(1888,53,'fi','Aktivoi poistetut sijaintitiedot',0),(1889,53,'no','Aktivere slettede stedsinformasjon',0),(1890,53,'da','Aktivere slettede oplysninger',0),(1891,53,'ko','ì‚­ì œ ëœ ìœ„ì¹˜ ì •ë³´ë¥¼ í™œì„±í™”',0),(1892,53,'he','×œ×”×¤×¢×™×œ ××ª ×ž×™×“×¢ ×”×ž×™×§×•× ×©× ×ž×—×§',0),(1893,53,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î´Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î¿Ï…',0),(1894,53,'zh','æ¿€æ´»åˆ é™¤çš„ä½ç½®ä¿¡æ¯\r\n',0),(1895,53,'sv','Aktivera borttagna platsinformation',0),(1896,53,'it','Attiva posizione cancellata',0),(1897,53,'tl','',0),(1898,53,'th','&#3648;&#3611;&#3636;&#3604;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(1899,53,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(1900,53,'ms','Aktifkan maklumat lokasi dihapuskan',0),(1901,53,'ar','Ø¥Ø³ØªØ±Ø¬Ø§Ø¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø­Ø°ÙˆÙ',0),(1902,53,'fr','Activer Information sur les lieux SupprimÃ© ',0),(1903,53,'jp','æ¶ˆåŽ»æ¸ˆã?¿ã?®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³æƒ…å ±ã‚’ã‚’èµ·å‹•',0),(1904,53,'pt','Ativar informaÃ§Ãµes de localizaÃ§Ã£o excluÃ­dos',0),(1905,53,'ru','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð£Ð´Ð°Ð»ÐµÐ½Ð½ÑƒÑŽ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ðž ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¸',0),(1906,53,'es','Activar InformaciÃ³n de UbicaciÃ³n Eliminada',0),(1907,53,'de','GelÃ¶schte Standortinformationen zu aktivieren',0),(1908,53,'en','Activate Deleted Location Information',0),(1909,54,'is','',0),(1910,54,'dr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§\r\n\r\n\r\n',0),(1911,54,'pr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§\r\n\r\n\r\n',0),(1912,54,'tr','Bu Ã¶ÄŸe iÃ§in tedarikÃ§i etkinleÅŸtir',0),(1913,54,'pl','Aktywuj dostawcÃ³w dla tego przedmiotu',0),(1914,54,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(1915,54,'ur','Ø§Ø³ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ ÙˆÛŒÙ†ÚˆØ± Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(1916,54,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(1917,54,'vi','KÃ­ch Hoáº¡t NgÆ°á»i BÃ¡n cho Danh Má»¥c nÃ y',0),(1918,54,'af','Aktiveer Verskaffer vir hierdie Item',0),(1919,54,'ro','Activeaza furnizor pentru acest produs',0),(1920,54,'et','Aktiveeri hankija selle kauba kohta',0),(1921,54,'si','Aktiviranje dobavitelja za ta element',0),(1922,54,'ba','Mengaktifkan Pemasok untuk Item ini',0),(1923,54,'nl','Activeer verkoper voor dit item',0),(1924,54,'fi','Aktivoi nimikkeen toimittaja',0),(1925,54,'no','Aktivere leverandÃ¸r for denne varen',0),(1926,54,'da','Aktivere kreditoren for denne vare',0),(1927,54,'ko','ì´ í•­ëª©ì— ëŒ€ í•œ ê³µê¸‰ ì—…ì²´ë¥¼ í™œì„±í™”',0),(1928,54,'he','×”×¤×¢×œ ×¡×¤×§ ×¢×‘×•×¨ ×¤×¨×™×˜ ×–×”',0),(1929,54,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï€Ï‰Î»Î·Ï„Î® Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(1930,54,'zh','ä¸ºè¿™ä¸ªé¡¹ç›®å¯åŠ¨ä¾›åº”å•†\r\n',0),(1931,54,'sv','Aktivera leverantÃ¶r fÃ¶r objektet',0),(1932,54,'it','Attiva un venditore per questo oggetto',0),(1933,54,'tl','',0),(1934,54,'th','&#3648;&#3611;&#3636;&#3604;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3609;&#3637;&#3657;',0),(1935,54,'hi','à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(1936,54,'ms','Aktifkan penjual untuk Item ini',0),(1937,54,'ar','ØªÙØ¹ÙŠÙ„ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ù„Ù‡Ø°Ø§ Ø§Ù„ØµÙ†Ù',0),(1938,54,'fr','Activer vendeur pour cet article',0),(1939,54,'jp','ã?“ã?®å“?ç›®æ¥­è€…ã‚’èµ·å‹•',0),(1940,54,'pt','Ativar o fornecedor para este Item',0),(1941,54,'ru','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(1942,54,'es','Activar Proveedor para este item',0),(1943,54,'de','Anbieter fÃ¼r dieses Element zu aktivieren',0),(1944,54,'en','Activate Vendor for this Item',0),(1945,55,'is','',0),(1946,55,'dr','ÙØ¹Ø§Ù„',0),(1947,55,'pr','ÙØ¹Ø§Ù„',0),(1948,55,'tr','Etkin',0),(1949,55,'pl','Aktywne',0),(1950,55,'bg','ÐÐºÑ‚Ð¸Ð²ÐµÐ½',0),(1951,55,'ur','Ø²ÛŒØ± Ø¹Ù…Ù„',0),(1952,55,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸',0),(1953,55,'vi','KÃ­ch Hoáº¡t',0),(1954,55,'af','Aktief',0),(1955,55,'ro','Activ',0),(1956,55,'et','Aktiivne',0),(1957,55,'si','Aktivno',0),(1958,55,'ba','Aktif',0),(1959,55,'nl','Actieve',0),(1960,55,'fi','Aktiivinen',0),(1961,55,'no','Aktiv',0),(1962,55,'da','Aktive',0),(1963,55,'ko','í™œì„±',0),(1964,55,'he','×¤×¢×™×œ',0),(1965,55,'el','Î•Î½ÎµÏÎ³ÏŒ',0),(1966,55,'zh','æ´»è·ƒ\r\n',0),(1967,55,'sv','Aktiva',0),(1968,55,'it','Attivo',0),(1969,55,'tl','',0),(1970,55,'th','&#3607;&#3635;&#3591;&#3634;&#3609;',0),(1971,55,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯',0),(1972,55,'ms','Aktif',0),(1973,55,'ar','Ù†Ø´Ø·',0),(1974,55,'fr','Active',0),(1975,55,'jp','ç?¾å½¹',0),(1976,55,'pt','Ativo',0),(1977,55,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ',0),(1978,55,'es','Activo',0),(1979,55,'de','Aktive',0),(1980,55,'en','Active',0),(1981,56,'is','',0),(1982,56,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ ',0),(1983,56,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ ',0),(1984,56,'tr','Faaliyet Raporu',0),(1985,56,'pl','Sprawozdanie z dziaÅ‚alnoÅ›ci za',0),(1986,56,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð·Ð°',0),(1987,56,'ur','Ú©Û’ Ù„Ø¦Û’ Ø³Ø±Ú¯Ø±Ù…ÛŒÙˆÚº Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(1988,56,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð°',0),(1989,56,'vi','BÃ¡o CÃ¡o Hoáº¡t Äá»™ng cho',0),(1990,56,'af','Aktiwiteitsverslag vir',0),(1991,56,'ro','Raport de activitate pentru',0),(1992,56,'et','Tegevuste aruanne:',0),(1993,56,'si','PoroÄilo o dejavnostih za',0),(1994,56,'ba','Laporan Aktifitas untuk',0),(1995,56,'nl','Activiteitenverslag voor',0),(1996,56,'fi','Toimintakertomus',0),(1997,56,'no','Aktivitetsrapport for',0),(1998,56,'da','Aktivitetsrapport for',0),(1999,56,'ko','ì— ëŒ€ í•œ í™œë™ ë³´ê³ ì„œ',0),(2000,56,'he','×“×•×— ×¤×¢×™×œ×•×ª',0),(2001,56,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï„Î®Ï„Ï‰Î½ Î³Î¹Î±',0),(2002,56,'zh','æ´»åŠ¨æŠ¥å‘Š\r\n',0),(2003,56,'sv','Verksamhetsrapport.',0),(2004,56,'it','Rapporto di attivitÃ  per',0),(2005,56,'tl','',0),(2006,56,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3607;&#3635;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(2007,56,'hi','à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤',0),(2008,56,'ms','Laporan aktiviti bagi',0),(2009,56,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù†Ø´Ø§Ø·',0),(2010,56,'fr','Rapport d\'activitÃ© pour',0),(2011,56,'jp','ï½žã?®æ´»å‹•ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(2012,56,'pt','RelatÃ³rio de atividade para',0),(2013,56,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð°',0),(2014,56,'es','Reporte de Actividad para',0),(2015,56,'de','TÃ¤tigkeitsbericht',0),(2016,56,'en','Activity Report for',0),(2017,57,'is','',0),(2018,57,'dr','ÙˆØ§Ù‚Ø¹ÙŠ',0),(2019,57,'pr','ÙˆØ§Ù‚Ø¹ÙŠ',0),(2020,57,'tr','GerÃ§ek',0),(2021,57,'pl','Rzeczywiste',0),(2022,57,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ',0),(2023,57,'ur','Ø§ØµÙ„',0),(2024,57,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð¸',0),(2025,57,'vi','Thá»±c táº¿',0),(2026,57,'af','Werklike',0),(2027,57,'ro','Actual',0),(2028,57,'et','Tegelik',0),(2029,57,'si','Dejanski',0),(2030,57,'ba','Aktual',0),(2031,57,'nl','Werkelijke',0),(2032,57,'fi','Todellinen',0),(2033,57,'no','Faktiske',0),(2034,57,'da','Faktiske',0),(2035,57,'ko','ì‹¤ì œ',0),(2036,57,'he','×‘×¤×•×¢×œ',0),(2037,57,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ®',0),(2038,57,'zh','å®žé™…\r\n',0),(2039,57,'sv','Faktiska',0),(2040,57,'it','Attuale',0),(2041,57,'tl','',0),(2042,57,'th','&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3604;&#3586;&#3638;&#3657;&#3609;&#3592;&#3619;&#3636;&#3591;',0),(2043,57,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤•',0),(2044,57,'ms','Sebenar',0),(2045,57,'ar','Ø§Ù„ÙØ¹Ù„ÙŠ',0),(2046,57,'fr','Actuel\r\n',0),(2047,57,'jp','å®Ÿéš›',0),(2048,57,'pt','Real',0),(2049,57,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ',0),(2050,57,'es','Actual',0),(2051,57,'de','TatsÃ¤chliche',0),(2052,57,'en','Actual',0),(2053,58,'is','',0),(2054,58,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ØªÙˆÙ„ÙŠØ¯ Ø´Ø¯Ù‡ ÙØ¹Ù„ÙŠ',0),(2055,58,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ØªÙˆÙ„ÙŠØ¯ Ø´Ø¯Ù‡ ÙØ¹Ù„ÙŠ',0),(2056,58,'tr','AsÄ±l Ana maddeler Ã¼retilen',0),(2057,58,'pl','Rzeczywiste elementy wzorcowe produkowane',0),(2058,58,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ð¼Ð°Ð¹ÑÑ‚Ð¾Ñ€ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸, Ð¿Ñ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð¸',0),(2059,58,'ur','Ø§ØµÙ„ Ù…Ø§Ø³Ù¹Ø± Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ù¾ÛŒØ¯Ø§ÙˆØ§Ø±',0),(2060,58,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð¸Ñ… Ð³Ð¾ÑÐ¿Ð¾Ð´Ð°Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð¸Ñ…',0),(2061,58,'vi','Danh Má»¥c Chá»§ Sáº£n Xuáº¥t Thá»±c Táº¿',0),(2062,58,'af','Werklike Hoofitems Geproduseer',0),(2063,58,'ro','Articole de baza produse actual\n',0),(2064,58,'et','Tegelik kapten Ã¼ksuste toodetud',0),(2065,58,'si','Dejanski glavni elementi, ki',0),(2066,58,'ba','Aktual Item Induk dibuat',0),(2067,58,'nl','Werkelijke stramienitems geproduceerd',0),(2068,58,'fi','Todellinen mestari nimikkeet tuotettu',0),(2069,58,'no','Faktiske malobjekter produsert',0),(2070,58,'da','Faktiske masterelementer produceret',0),(2071,58,'ko','ì‹¤ì œ ë§ˆìŠ¤í„° ì œí’ˆ ìƒì‚°',0),(2072,58,'he','×”×¤×™×§ ×‘×¤×•×¢×œ ×¤×¨×™×˜×™ ×ž××¡×˜×¨',0),(2073,58,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÏŽÎ½ Î±Î½Ï„Î¹ÎºÎµÎ¹Î¼Î­Î½Ï‰Î½ Ï€ÏÏŒÏ„Ï…Ï€Î·Ï‚ ÏƒÎµÎ»Î¯Î´Î±Ï‚ Ï€Î¿Ï… Ï€Î±ÏÎ¬Î³ÎµÏ„Î±Î¹',0),(2074,58,'zh','å®žé™…ç”Ÿäº§çš„ä¸»é¡¹\r\n',0),(2075,58,'sv','Faktiska mallobjekt produceras',0),(2076,58,'it','Articoli reali Master prodotto',0),(2077,58,'tl','',0),(2078,58,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3621;&#3633;&#3585;&#3607;&#3637;&#3656;&#3612;&#3621;&#3636;&#3605;&#3592;&#3619;&#3636;&#3591;',0),(2079,58,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤—à¥à¤°à¥ à¤µà¤¸à¥à¤¤à¥à¤“à¤‚ à¤•à¤¾ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¨ à¤•à¤¿à¤¯à¤¾',0),(2080,58,'ms','Item-item induk yang sebenar dihasilkan.',0),(2081,58,'ar','Ø¥Ù†ØªØ§Ø¬ Ø§Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ø§Ù„ÙØ¹Ù„ÙŠØ©',0),(2082,58,'fr','Objets rÃ©els Principal produits',0),(2083,58,'jp','å®Ÿãƒžã‚¹ã‚¿ãƒ¼å“?ç›®ã?Œä½œæˆ?ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(2084,58,'pt','Real Master itens produzidos',0),(2085,58,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¼Ð°ÑÑ‚ÐµÑ€ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð°',0),(2086,58,'es','Items Maestro Actualmente Producidos',0),(2087,58,'de','TatsÃ¤chliche Master Artikel produziert',0),(2088,58,'en','Actual Master Items Produced',0),(2089,59,'is','',0),(2090,59,'dr','Ø§ÙØ²ÙˆØ¯Ù† ',0),(2091,59,'pr','Ø§ÙØ²ÙˆØ¯Ù† ',0),(2092,59,'tr','Ekle',0),(2093,59,'pl','Dodaj',0),(2094,59,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(2095,59,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2096,59,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ',0),(2097,59,'vi','ThÃªm',0),(2098,59,'af','Voeg by',0),(2099,59,'ro','Adauga',0),(2100,59,'et','Lisa',0),(2101,59,'si','Dodaj',0),(2102,59,'ba','Tambah',0),(2103,59,'nl','Toevoegen',0),(2104,59,'fi','LisÃ¤Ã¤',0),(2105,59,'no','Legge til',0),(2106,59,'da','TilfÃ¸je',0),(2107,59,'ko','ì¶”ê°€',0),(2108,59,'he','×”×•×¡×£',0),(2109,59,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ',0),(2110,59,'zh','æ–°å¢ž\r\n',0),(2111,59,'sv','LÃ¤gg till',0),(2112,59,'it','Aggiungi',0),(2113,59,'tl','',0),(2114,59,'th','&#3648;&#3614;&#3636;&#3656;&#3617;',0),(2115,59,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2116,59,'ms','Tambah',0),(2117,59,'ar','Ø¥Ø¶Ø§ÙØ©',0),(2118,59,'fr','Ajouter',0),(2119,59,'jp','è¿½åŠ ',0),(2120,59,'pt','Adicionar',0),(2121,59,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(2122,59,'es','Agregar',0),(2123,59,'de','HinzufÃ¼gen',0),(2124,59,'en','Add',0),(2125,60,'is','',0),(2126,60,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ Ø¨ÙˆØ¯Ø¬Ù‡',0),(2127,60,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ Ø¨ÙˆØ¯Ø¬Ù‡',0),(2128,60,'tr','Bir bÃ¼tÃ§e Ekle',0),(2129,60,'pl','DodaÄ‡ budÅ¼et',0),(2130,60,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(2131,60,'ur','Ø§ÛŒÚ© Ø¨Ø¬Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2132,60,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð±ÑƒÑŸÐµÑ‚',0),(2133,60,'vi','ThÃªm 1 NgÃ¢n SÃ¡ch',0),(2134,60,'af','Voeg \'n Begroting by',0),(2135,60,'ro','Adauga un buget',0),(2136,60,'et','Lisada eelarve',0),(2137,60,'si','Dodaj proraÄun',0),(2138,60,'ba','Tambahkan anggaran',0),(2139,60,'nl','Toevoegen van een begroting',0),(2140,60,'fi','LisÃ¤Ã¤ budjetti',0),(2141,60,'no','Legge til et budsjett',0),(2142,60,'da','TilfÃ¸je et Budget',0),(2143,60,'ko','ì˜ˆì‚° ì¶”ê°€',0),(2144,60,'he','×”×•×¡×£ ×ª×§×¦×™×‘',0),(2145,60,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î­Î½Î±Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ',0),(2146,60,'zh','å¢žåŠ ä¸€ä¸ªé¢„ç®—\r\n',0),(2147,60,'sv','LÃ¤gga till en Budget',0),(2148,60,'it','Aggiungere un bilancio',0),(2149,60,'tl','',0),(2150,60,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(2151,60,'hi','à¤à¤• à¤¬à¤œà¤Ÿ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2152,60,'ms','Tambah bajet',0),(2153,60,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(2154,60,'fr','Ajouter un Budget',0),(2155,60,'jp','äºˆç®—ã‚’è¿½åŠ ',0),(2156,60,'pt','Adicionar um orÃ§amento',0),(2157,60,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(2158,60,'es','Agregar un Presupuesto',0),(2159,60,'de','FÃ¼gen Sie ein Budget',0),(2160,60,'en','Add a Budget',0),(2161,61,'is','',0),(2162,61,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(2163,61,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(2164,61,'tr','Yeni bir eleman eklemek',0),(2165,61,'pl','Dodawanie nowego pracownika',0),(2166,61,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(2167,61,'ur','Ø§ÛŒÚ© Ù†ÛŒÙˆ Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2168,61,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(2169,61,'vi','ThÃªm 1 NhÃ¢n ViÃªn Má»›i',0),(2170,61,'af','\'n Nuwe Werknemer Byvoeg',0),(2171,61,'ro','Adauga un nou angajat',0),(2172,61,'et','Lisa uus tÃ¶Ã¶taja',0),(2173,61,'si','Dodate novega zaposlenega',0),(2174,61,'ba','Tambahkan karyawan baru',0),(2175,61,'nl','Een nieuwe medewerker toevoegen',0),(2176,61,'fi','Voit lisÃ¤tÃ¤ uuden tyÃ¶ntekijÃ¤n',0),(2177,61,'no','Legge til en ny ansatt',0),(2178,61,'da','TilfÃ¸je en ny medarbejder',0),(2179,61,'ko','ìƒˆ ì§ì› ì¶”ê°€',0),(2180,61,'he','×”×•×¡×£ ×¢×•×‘×“ ×—×“×©',0),(2181,61,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÎ½ÏŒÏ‚ Î½Î­Î¿Ï… Ï…Ï€Î±Î»Î»Î®Î»Î¿Ï…',0),(2182,61,'zh','å¢žåŠ ä¸€ä½æ–°é›‡å‘˜\r\n\r\n',0),(2183,61,'sv','LÃ¤gga till en ny medarbetare',0),(2184,61,'it','Aggiungere un nuovo dipendente',0),(2185,61,'tl','',0),(2186,61,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(2187,61,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤à¤• à¤¨à¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(2188,61,'ms','Menambah pekerja baru',0),(2189,61,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ¸Ù Ø¬Ø¯ÙŠØ¯',0),(2190,61,'fr','Ajouter un Nouveau EmployÃ©',0),(2191,61,'jp','æ–°è¦?å¾“æ¥­å“¡ã‚’è¿½åŠ ',0),(2192,61,'pt','Adicionar um novo funcionÃ¡rio',0),(2193,61,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ð³Ð¾ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(2194,61,'es','Agregar un Nuevo Empleado',0),(2195,61,'de','HinzufÃ¼gen eines neuen Mitarbeiters',0),(2196,61,'en','Add a New Employee',0),(2197,62,'is','',0),(2198,62,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ Ù…ÙˆØ¶ÙˆØ¹ Ù…Ø±ØªØ¨Ø·',0),(2199,62,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ Ù…ÙˆØ¶ÙˆØ¹ Ù…Ø±ØªØ¨Ø·',0),(2200,62,'tr','Ä°lgili bir konu ekleme',0),(2201,62,'pl','Dodaj temat pokrewny',0),(2202,62,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ²ÑŠÑ€Ð·Ð°Ð½ Ñ‚ÐµÐ¼Ð°',0),(2203,62,'ur','Ù…ØªØ¹Ù„Ù‚Û Ù…ÙˆØ¶ÙˆØ¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2204,62,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ€Ð¾Ð´Ð½Ð¾Ñ˜ Ñ‚ÐµÐ¼Ð¸',0),(2205,62,'vi','ThÃªm 1 Chá»§ Äá» LiÃªn Quan',0),(2206,62,'af','Voeg \'n Nuwe Verwante Onderwerp by',0),(2207,62,'ro','Adauga un subiect corelat',0),(2208,62,'et','Lisa Related teema',0),(2209,62,'si','Dodaj sorodno temo',0),(2210,62,'ba','Menambahkan topik terkait',0),(2211,62,'nl','Een verwant onderwerp toevoegen',0),(2212,62,'fi','LisÃ¤Ã¤ aiheesta',0),(2213,62,'no','Legge til et beslektet emne',0),(2214,62,'da','TilfÃ¸je et relateret emne',0),(2215,62,'ko','ê´€ë ¨ëœ í•­ëª© ì¶”ê°€',0),(2216,62,'he','×”×•×¡×£ × ×•×©× ×ž×§×•×©×¨',0),(2217,62,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î­Î½Î± ÏƒÏ‡ÎµÏ„Î¹ÎºÏŒ Î¸Î­Î¼Î±',0),(2218,62,'zh','å¢žåŠ ç›¸å…³ä¸»é¢˜\r\n',0),(2219,62,'sv','LÃ¤gga till ett nÃ¤rliggande Ã¤mne',0),(2220,62,'it','Aggiungi un argomento correlato',0),(2221,62,'tl','',0),(2222,62,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591;',0),(2223,62,'hi','à¤•à¤¿à¤¸à¥€ à¤¸à¤‚à¤¬à¤‚à¤§à¤¿à¤¤ à¤µà¤¿à¤·à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2224,62,'ms','Tambah satu topik berkaitan',0),(2225,62,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ¶ÙˆØ¹ Ø°Ø§Øª ØµÙ„Ø©',0),(2226,62,'fr','Ajouter un sujet liÃ©',0),(2227,62,'jp','é–¢ä¿‚é¡Œç›®ã‚’è¿½åŠ ',0),(2228,62,'pt','Adicionar um tÃ³pico relacionado',0),(2229,62,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¼ÐµÐ¶Ð½Ð¾Ð¹ Ñ‚ÐµÐ¼Ñ‹',0),(2230,62,'es','Agregar un TÃ³pico Relacionado',0),(2231,62,'de','Ein verwandtes Thema hinzufÃ¼gen',0),(2232,62,'en','Add a Related Topic',0),(2233,63,'is','',0),(2234,63,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¯ÙŠÚ¯Ø± ',0),(2235,63,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¯ÙŠÚ¯Ø± ',0),(2236,63,'tr','BaÅŸka bir hesap ekle',0),(2237,63,'pl','Dodaj kolejne konto',0),(2238,63,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(2239,63,'ur','Ø¯ÙˆØ³Ø±Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2240,63,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(2241,63,'vi','ThÃªm TK KhÃ¡c',0),(2242,63,'af','Voeg \'n Ander Rekening By',0),(2243,63,'ro','Adauga alt cont',0),(2244,63,'et','Uue konto lisamiseks',0),(2245,63,'si','Dodaj drug raÄun',0),(2246,63,'ba','Tambah Akun Lain',0),(2247,63,'nl','Een andere Account toevoegen',0),(2248,63,'fi','LisÃ¤Ã¤ toinen tili',0),(2249,63,'no','Legge til en annen konto',0),(2250,63,'da','TilfÃ¸je en anden konto',0),(2251,63,'ko','ë‹¤ë¥¸ ê³„ì • ì¶”ê°€',0),(2252,63,'he','×”×•×¡×£ ×¢×•×“ ×—×©×‘×•×Ÿ',0),(2253,63,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¬Î»Î»Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(2254,63,'zh','å¢žåŠ ä¸€ä¸ªå¸æˆ·\r\n',0),(2255,63,'sv','LÃ¤gga till ett annat konto',0),(2256,63,'it','Aggiungi un altro Account',0),(2257,63,'tl','',0),(2258,63,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;&#3629;&#3639;&#3656;&#3609;',0),(2259,63,'hi','à¤•à¥‹à¤ˆ à¤…à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2260,63,'ms','Menambah akaun lain',0),(2261,63,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨ Ø¢Ø®Ø±',0),(2262,63,'fr','Ajouter un Autre Compte',0),(2263,63,'jp','ä»–ã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¿½åŠ ',0),(2264,63,'pt','Adicionar outra conta',0),(2265,63,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³ÑƒÑŽ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(2266,63,'es','Agregar Otra Cuenta',0),(2267,63,'de','FÃ¼gen Sie ein anderes Konto',0),(2268,63,'en','Add Another Account',0),(2269,64,'is','',0),(2270,64,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ø¯ÙŠÚ¯Ø± ',0),(2271,64,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ø¯ÙŠÚ¯Ø± ',0),(2272,64,'tr','BaÅŸka bir eylem ekleme',0),(2273,64,'pl','Dodaj innÄ… akcjÄ™',0),(2274,64,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(2275,64,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± Ú©Ø§Ø±Ø±ÙˆØ§Ø¦ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2276,64,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ñƒ Ñ€Ð°Ð´ÑšÑƒ',0),(2277,64,'vi','ThÃªm HÃ nh Äá»™ng KhÃ¡c',0),(2278,64,'af','Voeg \'n Ander Aksie By',0),(2279,64,'ro','Adauga alta activitate',0),(2280,64,'et','MÃµne muu toimingu lisamine',0),(2281,64,'si','Dodajte drugo dejanje',0),(2282,64,'ba','Tambah Tindakan Lain',0),(2283,64,'nl','Een andere actie toevoegen',0),(2284,64,'fi','LisÃ¤tÃ¤ toisen toiminnon',0),(2285,64,'no','Legge til en annen handling',0),(2286,64,'da','TilfÃ¸je en anden handling',0),(2287,64,'ko','ë‹¤ë¥¸ ìž‘ì—… ì¶”ê°€',0),(2288,64,'he','×”×•×¡×£ ×¤×¢×•×œ×” × ×•×¡×¤×ª',0),(2289,64,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î¬Î»Î»Î· ÎµÎ½Î­ÏÎ³ÎµÎ¹Î±',0),(2290,64,'zh','å¢žåŠ å¦ä¸€ä¸ªåŠ¨ä½œ\r\n',0),(2291,64,'sv','LÃ¤gga till en annan Ã¥tgÃ¤rd',0),(2292,64,'it','Aggiungere un\'altra azione',0),(2293,64,'tl','',0),(2294,64,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3629;&#3639;&#3656;&#3609;',0),(2295,64,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2296,64,'ms','Tambah satu lagi tindakan',0),(2297,64,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø¬Ø±Ø§Ø¡ Ø¢Ø®Ø±',0),(2298,64,'fr','Ajouter un Autre Action',0),(2299,64,'jp','ä»–ã?®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ',0),(2300,64,'pt','Adicionar outra aÃ§Ã£o',0),(2301,64,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(2302,64,'es','Agregar Otra AcciÃ³n',0),(2303,64,'de','FÃ¼gen Sie eine andere Aktion',0),(2304,64,'en','Add Another Action',0),(2305,65,'is','',0),(2306,65,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ø¯ÙŠÚ¯Ø±',0),(2307,65,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ø¯ÙŠÚ¯Ø±',0),(2308,65,'tr','BaÅŸka bir Kategori Ekle',0),(2309,65,'pl','Dodaj innÄ… kategoriÄ™',0),(2310,65,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(2311,65,'ur','Ø§ÛŒÚ© Ù‚Ø³Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2312,65,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(2313,65,'vi','ThÃªm PhÃ¢n Loáº¡i KhÃ¡c',0),(2314,65,'af','Voeg \'n Ander Kategorie By',0),(2315,65,'ro','Adauga alta categorie',0),(2316,65,'et','Teise kategooria lisamine',0),(2317,65,'si','Dodaj drugo kategorijo',0),(2318,65,'ba','Tambah Kategori Lain',0),(2319,65,'nl','Een andere categorie toevoegen',0),(2320,65,'fi','LisÃ¤Ã¤ toinen luokka',0),(2321,65,'no','Legge til en annen kategori',0),(2322,65,'da','TilfÃ¸je en anden kategori',0),(2323,65,'ko','ë‹¤ë¥¸ ë²”ì£¼ ì¶”ê°€',0),(2324,65,'he','×”×•×¡×£ ×¢×•×“ ×§×˜×’×•×¨×™×”',0),(2325,65,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î¬Î»Î»Î· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(2326,65,'zh','å¢žåŠ å…¶å®ƒç±»åˆ«\r\n',0),(2327,65,'sv','LÃ¤gga till en annan kategori',0),(2328,65,'it','Aggiungere un\'altra categoria',0),(2329,65,'tl','',0),(2330,65,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3629;&#3639;&#3656;&#3609;',0),(2331,65,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2332,65,'ms','Menambah satu lagi kategori',0),(2333,65,'ar','Ø¥Ø¶Ø§ÙØ© ØªØµÙ†ÙŠÙ Ø¢Ø®Ø±',0),(2334,65,'fr','Ajouter une Autre Compagnie',0),(2335,65,'jp','ä»–ã?®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’è¿½åŠ ',0),(2336,65,'pt','Adicionar outra categoria',0),(2337,65,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³ÑƒÑŽ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(2338,65,'es','Agregar Otra CategorÃ­a',0),(2339,65,'de','Eine weitere Kategorie hinzufÃ¼gen',0),(2340,65,'en','Add Another Category',0),(2341,66,'is','',0),(2342,66,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯ÙŠÚ¯Ø±',0),(2343,66,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯ÙŠÚ¯Ø±',0),(2344,66,'tr','BaÅŸka bir Ã§alÄ±ÅŸan eklemek',0),(2345,66,'pl','DodaÄ‡ innego pracownika',0),(2346,66,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(2347,66,'ur','Ø§ÛŒÚ© Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2348,66,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ˜Ð¾Ñˆ Ñ˜ÐµÐ´Ð½Ð¾Ð³ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(2349,66,'vi','ThÃªm NhÃ¢n ViÃªn KhÃ¡c',0),(2350,66,'af','Voeg \'n Ander Werknemer By',0),(2351,66,'ro','Adauga alt angajat',0),(2352,66,'et','Lisa uus tÃ¶Ã¶taja',0),(2353,66,'si','Dodajanje drugega zaposlenega',0),(2354,66,'ba','Tambah Karyawan Lain',0),(2355,66,'nl','Een andere werknemer toevoegen',0),(2356,66,'fi','LisÃ¤Ã¤ toinen tyÃ¶ntekijÃ¤',0),(2357,66,'no','Legge til en annen ansatt',0),(2358,66,'da','TilfÃ¸je en anden medarbejder',0),(2359,66,'ko','ë‹¤ë¥¸ ì§ì›ì„ ì¶”ê°€',0),(2360,66,'he','×”×•×¡×£ ×¢×•×“ ×¢×•×‘×“',0),(2361,66,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î¬Î»Î»Î¿Î½ Ï…Ï€Î¬Î»Î»Î·Î»Î¿',0),(2362,66,'zh','å¢žåŠ å¦ä¸€ä½é›‡å‘˜\r\n',0),(2363,66,'sv','LÃ¤gga till en annan anstÃ¤lld',0),(2364,66,'it','Aggiungere un altro dipendente',0),(2365,66,'tl','',0),(2366,66,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(2367,66,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤à¤• à¤”à¤° à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(2368,66,'ms','Tambah pekerja lagi',0),(2369,66,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ¸Ù Ø¢Ø®Ø±',0),(2370,66,'fr','Ajouter un Autre EmployÃ©',0),(2371,66,'jp','ä»–ã?®å¾“æ¥­å“¡ã‚’è¿½åŠ ',0),(2372,66,'pt','Adicionar outro empregado',0),(2373,66,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð³Ð¾ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(2374,66,'es','Agregar Otro Empleado',0),(2375,66,'de','Ein weiterer Mitarbeiter hinzufÃ¼gen',0),(2376,66,'en','Add Another Employee',0),(2377,67,'is','',0),(2378,67,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ø¯ÙŠÚ¯Ø± ',0),(2379,67,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ø¯ÙŠÚ¯Ø± ',0),(2380,67,'tr','BaÅŸka bir girdi ekleyin',0),(2381,67,'pl','Dodaj kolejny wpis',0),(2382,67,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ð·Ð°Ð¿Ð¸Ñ',0),(2383,67,'ur','Ø§ÛŒÚ© Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(2384,67,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(2385,67,'vi','ThÃªm Entry KhÃ¡c',0),(2386,67,'af','Voeg \'n Ander Inskrywing By',0),(2387,67,'ro','Adauga alta intrare',0),(2388,67,'et','MÃµne muu kirje lisamine',0),(2389,67,'si','Dodaj drug vnos',0),(2390,67,'ba','Tambahkan entri lain',0),(2391,67,'nl','Een andere vermelding toevoegen',0),(2392,67,'fi','LisÃ¤Ã¤ tietueita',0),(2393,67,'no','Legge til en annen oppfÃ¸ring',0),(2394,67,'da','TilfÃ¸je en anden post',0),(2395,67,'ko','ë‹¤ë¥¸ í•­ëª© ì¶”ê°€',0),(2396,67,'he','×”×•×¡×£ ×¨×™×©×•× × ×•×¡×£',0),(2397,67,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î¬Î»Î»Î· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·',0),(2398,67,'zh','å¢žåŠ å¦ä¸€ä¸ªåˆ†å½•\r\n',0),(2399,67,'sv','LÃ¤gga till en annan post',0),(2400,67,'it','Aggiungere un\'altra voce',0),(2401,67,'tl','',0),(2402,67,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3636;&#3607;&#3608;&#3636;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3629;&#3639;&#3656;&#3609;',0),(2403,67,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2404,67,'ms','Tambah kemasukan yang lain',0),(2405,67,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø¯Ø®Ø§Ù„ Ø¢Ø®Ø±',0),(2406,67,'fr','Ajouter un Autre EntrÃ©e',0),(2407,67,'jp','ä»–ã?®è¨˜å¸³ã‚’è¿½åŠ ',0),(2408,67,'pt','Adicionar outra entrada',0),(2409,67,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐµÑ‰Ðµ Ð¾Ð´Ð½Ñƒ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(2410,67,'es','Agregar Otra Entidad',0),(2411,67,'de','Einen weiteren Eintrag hinzufÃ¼gen',0),(2412,67,'en','Add Another Entry',0),(2413,68,'is','',0),(2414,68,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ± Ø¯ÙŠÚ¯Ø± ',0),(2415,68,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ± Ø¯ÙŠÚ¯Ø± ',0),(2416,68,'tr','BaÅŸka bir fatura Ekle',0),(2417,68,'pl','Dodawanie innej faktury',0),(2418,68,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÑ‚Ðµ Ð´Ñ€ÑƒÐ³Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(2419,68,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2420,68,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(2421,68,'vi','ThÃªm HÃ³a ÄÆ¡n KhÃ¡c',0),(2422,68,'af','Voeg \'n Ander Faktuur By',0),(2423,68,'ro','Adauga alta factura',0),(2424,68,'et','Lisa veel Ã¼ks arve',0),(2425,68,'si','Dodaj drug raÄun',0),(2426,68,'ba','Tambahkan lain faktur',0),(2427,68,'nl','Nog een factuur toevoegen',0),(2428,68,'fi','LisÃ¤Ã¤ toinen lasku',0),(2429,68,'no','Legge til en faktura',0),(2430,68,'da','TilfÃ¸je en anden faktura',0),(2431,68,'ko','ë‹¤ë¥¸ ì†¡ìž¥ ì¶”ê°€',0),(2432,68,'he','×”×•×¡×£ ×¢×•×“ ×—×©×‘×•× ×™×ª',0),(2433,68,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¬Î»Î»Î¿ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(2434,68,'zh','å¢žåŠ å¦ä¸€ä¸ªå‘ç¥¨\r\n',0),(2435,68,'sv','LÃ¤gga till en annan faktura',0),(2436,68,'it','Aggiungere un\'altra fattura',0),(2437,68,'tl','',0),(2438,68,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3629;&#3639;&#3656;&#3609;',0),(2439,68,'hi','à¤à¤• à¤”à¤° à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2440,68,'ms','Tambah satu lagi invois',0),(2441,68,'ar','Ø¥Ø¶Ø§ÙØ© ÙØ§ØªÙˆØ±Ø© Ø£Ø®Ø±Ù‰',0),(2442,68,'fr','Ajouter une Autre Facture',0),(2443,68,'jp','ä»–ã?®è«‹æ±‚æ›¸ã‚’è¿½åŠ ',0),(2444,68,'pt','Adicionar outra factura',0),(2445,68,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð¹ Ð¡Ñ‡ÐµÑ‚',0),(2446,68,'es','Agregar Otra Factura',0),(2447,68,'de','FÃ¼gen Sie eine weitere Rechnung',0),(2448,68,'en','Add Another Invoice',0),(2449,69,'is','',0),(2450,69,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙŠÚ¯Ø± ',0),(2451,69,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙŠÚ¯Ø± ',0),(2452,69,'tr','BaÅŸka bir Ã¶ÄŸe ekleme',0),(2453,69,'pl','Dodaj inny element',0),(2454,69,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(2455,69,'ur','Ú©Ø³ÛŒ Ø§ÙˆØ± Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2456,69,'sr','Ð”Ð¾Ð´Ð°Ð»Ð¸ Ñ˜Ð¾Ñˆ Ñ˜ÐµÐ´Ð½Ñƒ',0),(2457,69,'vi','ThÃªm Danh Má»¥c KhÃ¡c',0),(2458,69,'af','Voeg \'n Ander Item By',0),(2459,69,'ro','Adauga alt articol',0),(2460,69,'et','Lisa jÃ¤rgmine toode',0),(2461,69,'si','Dodati Å¡e en element',0),(2462,69,'ba','Tambahkan Item lain',0),(2463,69,'nl','Een ander Item toevoegen',0),(2464,69,'fi','LisÃ¤Ã¤ uusi kohde',0),(2465,69,'no','Legge til et annet element',0),(2466,69,'da','TilfÃ¸je et andet element',0),(2467,69,'ko','ë‹¤ë¥¸ í•­ëª© ì¶”ê°€',0),(2468,69,'he','×”×•×¡×£ ×¤×¨×™×˜ × ×•×¡×£',0),(2469,69,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î­Î½Î± Î¬Î»Î»Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(2470,69,'zh','å¢žåŠ å¦ä¸€ä¸ªé¡¹ç›®\r\n',0),(2471,69,'sv','LÃ¤gga till ett annat objekt',0),(2472,69,'it','Aggiungere un altro elemento',0),(2473,69,'tl','',0),(2474,69,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3629;&#3639;&#3656;&#3609;',0),(2475,69,'hi','à¤à¤• à¤”à¤° à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2476,69,'ms','Tambah Item lain',0),(2477,69,'ar','Ø¥Ø¶Ø§ÙØ© ØµÙ†Ù Ø¢Ø®Ø±',0),(2478,69,'fr','Ajouter un Autre Article',0),(2479,69,'jp','ä»–ã?®å“?ç›®ã‚’è¿½åŠ ',0),(2480,69,'pt','Adicionar outro Item',0),(2481,69,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð¹ Ð¢Ð¾Ð²Ð°Ñ€',0),(2482,69,'es','Agregar Otro item',0),(2483,69,'de','Ein weiteres Element hinzufÃ¼gen',0),(2484,69,'en','Add Another Item',0),(2485,70,'is','',0),(2486,70,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ø¯ÙŠÚ¯Ø± ',0),(2487,70,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ø¯ÙŠÚ¯Ø± ',0),(2488,70,'tr','BaÅŸka bir konumu ekle',0),(2489,70,'pl','DodaÄ‡ innej lokalizacji',0),(2490,70,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð¾ Ð¼ÑÑÑ‚Ð¾',0),(2491,70,'ur','Ø¯ÙˆØ³Ø±Ø§ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2492,70,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(2493,70,'vi','ThÃªm Vá»‹ TrÃ­ KhÃ¡c',0),(2494,70,'af','Voeg \'n Ander Ligging By',0),(2495,70,'ro','Adauga alt sediu',0),(2496,70,'et','Teise koha lisamine',0),(2497,70,'si','Dodaj drugo mesto',0),(2498,70,'ba','Tambahkan lokasi lain',0),(2499,70,'nl','Toevoegen van een andere locatie',0),(2500,70,'fi','LisÃ¤Ã¤ toiseen paikkaan',0),(2501,70,'no','Legge til en annen plassering',0),(2502,70,'da','TilfÃ¸je et andet sted',0),(2503,70,'ko','ë‹¤ë¥¸ ìœ„ì¹˜ ì¶”ê°€',0),(2504,70,'he','×”×•×¡×£ ×ž×™×§×•× × ×•×¡×£',0),(2505,70,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î¬Î»Î»Î· Î¸Î­ÏƒÎ·',0),(2506,70,'zh','å¢žåŠ å¦ä¸€ä¸ªä½ç½®\r\n',0),(2507,70,'sv','LÃ¤gga till en annan plats',0),(2508,70,'it','Aggiungere un\'altra posizione',0),(2509,70,'tl','',0),(2510,70,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3635;&#3649;&#3627;&#3609;&#3656;&#3591;&#3629;&#3639;&#3656;&#3609;',0),(2511,70,'hi','à¤•à¥‹à¤ˆ à¤…à¤¨à¥à¤¯ à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2512,70,'ms','Tambah lokasi lain',0),(2513,70,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹ Ø¢Ø®Ø±',0),(2514,70,'fr','Ajouter un Autre Emplacement',0),(2515,70,'jp','ä»–ã?®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ',0),(2516,70,'pt','Adicionar outra localizaÃ§Ã£o',0),(2517,70,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ðµ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(2518,70,'es','Agregar Otra UbicaciÃ³n',0),(2519,70,'de','FÃ¼gen Sie einen anderen Speicherort',0),(2520,70,'en','Add Another Location',0),(2521,71,'is','',0),(2522,71,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø¯ÙŠÚ¯Ø± ',0),(2523,71,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø¯ÙŠÚ¯Ø± ',0),(2524,71,'tr','BaÅŸka bir dÃ¼zen Ekle',0),(2525,71,'pl','DodaÄ‡ innej kolejnoÅ›ci',0),(2526,71,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ñ€ÐµÐ´',0),(2527,71,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± Ø­Ú©Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2528,71,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(2529,71,'vi','ThÃªm ÄÆ¡n Äáº·t HÃ ng KhÃ¡c',0),(2530,71,'af','Voeg \'n Ander Bestelling By',0),(2531,71,'ro','Adauga alta comanda',0),(2532,71,'et','Lisa uus tellimus',0),(2533,71,'si','Dodaj Å¡e eno naroÄilo',0),(2534,71,'ba','Tambahkan perintah lain',0),(2535,71,'nl','Toevoegen van een andere orde',0),(2536,71,'fi','LisÃ¤Ã¤ toinen tilaus',0),(2537,71,'no','Legge til en annen ordre',0),(2538,71,'da','TilfÃ¸je en anden ordre',0),(2539,71,'ko','ë‹¤ë¥¸ ìˆœì„œë¥¼ ì¶”ê°€',0),(2540,71,'he','×”×•×¡×£ ×”×–×ž× ×” × ×•×¡×¤×ª',0),(2541,71,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î¬Î»Î»Î· Î´Î¹Î¬Ï„Î±Î¾Î·',0),(2542,71,'zh','å¢žåŠ å…¶ä»–è®¢å•\r\n',0),(2543,71,'sv','LÃ¤gga till en annan ordning',0),(2544,71,'it','Aggiungere un altro ordine',0),(2545,71,'tl','',0),(2546,71,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3639;&#3656;&#3609;',0),(2547,71,'hi','à¤à¤• à¤”à¤° à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2548,71,'ms','Tambah pesanan lagi',0),(2549,71,'ar','Ø¥Ø¶Ø§ÙØ© Ø·Ù„Ø¨ÙŠØ© Ø£Ø®Ø±Ù‰',0),(2550,71,'fr','Ajouter une Autre Commande',0),(2551,71,'jp','ä»–ã?®æ³¨æ–‡ã‚’è¿½åŠ ',0),(2552,71,'pt','Adicionar outra ordem',0),(2553,71,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð¹ Ð—Ð°ÐºÐ°Ð·',0),(2554,71,'es','Agregar Otro Pedido',0),(2555,71,'de','FÃ¼gen Sie einen weiteren Auftrag',0),(2556,71,'en','Add Another Order',0),(2557,72,'is','',0),(2558,72,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ  Ø¯ÙŠÚ¯Ø± ',0),(2559,72,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ  Ø¯ÙŠÚ¯Ø± ',0),(2560,72,'tr','BaÅŸka bir fiÅŸ Ekle',0),(2561,72,'pl','Dodaj kolejny kupon',0),(2562,72,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(2563,72,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± ÙˆØ§Ø¤Ú†Ø± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2564,72,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(2565,72,'vi','ThÃªm Phiáº¿u Mua KhÃ¡c',0),(2566,72,'af','\'n Ander Bewysstuk Byvoeg',0),(2567,72,'ro','Adauga alt voucher',0),(2568,72,'et','Lisage veel Ã¼ks kanne',0),(2569,72,'si','Dodajte Å¡e en kupon',0),(2570,72,'ba','Menambahkan Voucher lain',0),(2571,72,'nl','Toevoegen van een andere Voucher',0),(2572,72,'fi','LisÃ¤tÃ¤ toisen tositteen',0),(2573,72,'no','Legge til en annen kupong',0),(2574,72,'da','TilfÃ¸je en anden Voucher',0),(2575,72,'ko','ë‹¤ë¥¸ ë°”ìš°ì²˜ ì¶”ê°€',0),(2576,72,'he','×”×•×¡×£ ×¢×•×“ ×©×•×‘×¨',0),(2577,72,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î­Î½Î± Î¬Î»Î»Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(2578,72,'zh','å¢žåŠ å¦ä¸€ä¸ªæ”¯ä»˜å‡­è¯\r\n',0),(2579,72,'sv','LÃ¤gga till en annan verifikation',0),(2580,72,'it','Aggiungi un altro buono',0),(2581,72,'tl','',0),(2582,72,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3629;&#3639;&#3656;&#3609;',0),(2583,72,'hi','à¤à¤• à¤”à¤° à¤µà¤¾à¤‰à¤šà¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2584,72,'ms','Tambah satu lagi baucar yang',0),(2585,72,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø³ÙŠÙ…Ø© Ø£Ø®Ø±Ù‰',0),(2586,72,'fr','Ajouter une Autre piÃ¨ce justificative \r\n',0),(2587,72,'jp','ä¼?ç¥¨ã‚’è¿½åŠ ',0),(2588,72,'pt','Adicionar outro Voucher',0),(2589,72,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐµÑ‰Ðµ Ð¾Ð´Ð¸Ð½ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(2590,72,'es','Agregar Otro Recibo',0),(2591,72,'de','FÃ¼gen Sie einen anderen Gutschein',0),(2592,72,'en','Add Another Voucher',0),(2593,73,'is','',0),(2594,73,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(2595,73,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(2596,73,'tr','BÃ¼tÃ§e Ekle',0),(2597,73,'pl','DodaÄ‡ budÅ¼etu',0),(2598,73,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(2599,73,'ur','Ø¨Ø¬Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2600,73,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð±ÑƒÑŸÐµÑ‚Ð°',0),(2601,73,'vi','ThÃªm NgÃ¢n SÃ¡ch',0),(2602,73,'af','Voeg \'n Begroting by',0),(2603,73,'ro','Adauga Buget',0),(2604,73,'et','Lisada eelarvesse',0),(2605,73,'si','Dodaj proraÄuna',0),(2606,73,'ba','Tambahkan anggaran',0),(2607,73,'nl','Begroting toevoegen',0),(2608,73,'fi','LisÃ¤Ã¤ budjetti',0),(2609,73,'no','Legg til budsjett',0),(2610,73,'da','TilfÃ¸je Budget',0),(2611,73,'ko','ì˜ˆì‚° ì¶”ê°€',0),(2612,73,'he','×”×•×¡×£ ×ª×§×¦×™×‘',0),(2613,73,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(2614,73,'zh','å¢žåŠ é¢„ç®—\r\n',0),(2615,73,'sv','LÃ¤gg till Budget',0),(2616,73,'it','Aggiungi bilancio',0),(2617,73,'tl','',0),(2618,73,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(2619,73,'hi','à¤¬à¤œà¤Ÿ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2620,73,'ms','Tambah bajet',0),(2621,73,'ar','Ø£Ø¶Ù Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(2622,73,'fr','Ajouter Budget',0),(2623,73,'jp','äºˆç®—ã‚’è¿½åŠ ',0),(2624,73,'pt','Adicionar orÃ§amento',0),(2625,73,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(2626,73,'es','Agregar Presupuesto',0),(2627,73,'de','Haushalt hinzufÃ¼gen',0),(2628,73,'en','Add Budget',0),(2629,74,'is','',0),(2630,74,'dr','Ø§ÙƒÙ†ÙˆÙ† Ø´Ø±ÙƒØª Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ',0),(2631,74,'pr','Ø§ÙƒÙ†ÙˆÙ† Ø´Ø±ÙƒØª Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ',0),(2632,74,'tr','Åžimdi firma ekle',0),(2633,74,'pl','Teraz Dodaj firmÄ™',0),(2634,74,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ñ„Ð¸Ñ€Ð¼Ð° ÑÐµÐ³Ð°',0),(2635,74,'ur','Ù†Ø¡ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Ø±ÛŒÚº',0),(2636,74,'sr','Ð¡Ð°Ð´Ð° Ð”Ð¾Ð´Ð°Ñ˜ Ñ„Ð¸Ñ€Ð¼Ñƒ',0),(2637,74,'vi','ThÃªm CÃ´ng Ty Ngay',0),(2638,74,'af','Voeg Onderneming Nou by',0),(2639,74,'ro','Adauga acum firma',0),(2640,74,'et','Lisa ettevÃµte nÃ¼Ã¼d',0),(2641,74,'si','Dodaj podjetje zdaj',0),(2642,74,'ba','Tambahkan perusahaan sekarang',0),(2643,74,'nl','Toevoegen bedrijf nu',0),(2644,74,'fi','LisÃ¤Ã¤ yritys nyt',0),(2645,74,'no','Legge til selskapet nÃ¥',0),(2646,74,'da','TilfÃ¸j virksomhed nu',0),(2647,74,'ko','ì§€ê¸ˆ íšŒì‚¬ë¥¼ ì¶”ê°€',0),(2648,74,'he','×”×•×¡×£ ×—×‘×¨×” ×›×¢×ª',0),(2649,74,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Ï„ÏŽÏÎ±',0),(2650,74,'zh','å¢žåŠ å…¬å¸\r\n',0),(2651,74,'sv','LÃ¤gg fÃ¶retaget nu',0),(2652,74,'it','Aggiungi azienda ora',0),(2653,74,'tl','',0),(2654,74,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3648;&#3604;&#3637;&#3659;&#3618;&#3623;&#3609;&#3637;&#3657;',0),(2655,74,'hi','à¤…à¤¬ à¤•à¤‚à¤ªà¤¨à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2656,74,'ms','Menambah Syarikat kini',0),(2657,74,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙƒØ© Ø§Ù„Ø¢Ù†',0),(2658,74,'fr','Ajouter Compagnie Maintenant',0),(2659,74,'jp','ä»Šã€?ä¼šç¤¾ã‚’è¿½åŠ ',0),(2660,74,'pt','Adicionar empresa agora',0),(2661,74,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ Ð¡ÐµÐ¹Ñ‡Ð°Ñ',0),(2662,74,'es','Agregar CompaÃ±Ã­a Ahora',0),(2663,74,'de','Firma jetzt hinzufÃ¼gen',0),(2664,74,'en','Add Company Now',0),(2665,75,'is','',0),(2666,75,'dr',' Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø±Ø§ Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÙŠØ¯ ',0),(2667,75,'pr',' Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø±Ø§ Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÙŠØ¯ ',0),(2668,75,'tr','Tertibat Ã¼stÃ¼nde-e doÄŸru devam etmek',0),(2669,75,'pl','PrzejdÅº do konfiguracji',0),(2670,75,'bg','ÐŸÑ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸ Ð´Ð° Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ñ‰Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð°',0),(2671,75,'ur','Ù†Ø¡ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Ø±ÛŒÚº Û²',0),(2672,75,'sr','ÐŸÑ€ÐµÑ’Ð¸Ñ‚Ðµ Ð½Ð° ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(2673,75,'vi','Tiáº¿p tá»¥c Setup',0),(2674,75,'af','Voltooi tot en met Opstelling',0),(2675,75,'ro','Adauga acum firma2',0),(2676,75,'et','JÃ¤tka seadistamist',0),(2677,75,'si','Nadaljujte namestitveni program',0),(2678,75,'ba','Lanjutkan ke Setup',0),(2679,75,'nl','Gaat u verder met Setup',0),(2680,75,'fi','Jatka asennusta',0),(2681,75,'no','Fortsett installasjonen',0),(2682,75,'da','FortsÃ¦tte til opsÃ¦tning',0),(2683,75,'ko','ì„¤ì¹˜ ê³„ì†',0),(2684,75,'he','×”×ž×©×š ×œ×”×ª×§× ×”',0),(2685,75,'el','Î£Ï…Î½ÎµÏ‡Î¯ÏƒÎµÏ„Îµ Î¼Îµ Ï„Î·Î½ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(2686,75,'zh','ç»§ç»­æ‰§è¡Œå®‰è£…\r\n',0),(2687,75,'sv','FortsÃ¤tt till Setup',0),(2688,75,'it','Proseguire per installazione',0),(2689,75,'tl','',0),(2690,75,'th','&#3605;&#3656;&#3629;&#3652;&#3611;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;',0),(2691,75,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤ªà¤° à¤†à¤—à¥‡ à¤¬à¤¢à¤¼à¥‡à¤‚',0),(2692,75,'ms','Teruskan perjalanan ke persediaan',0),(2693,75,'ar','Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(2694,75,'fr','Continuez sur l\'installation',0),(2695,75,'jp','è¨­å®šã?¸é€²ã‚€',0),(2696,75,'pt','Continue para instalaÃ§Ã£o',0),(2697,75,'ru','ÐŸÑ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÑŒ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÑƒ',0),(2698,75,'es','Continuar para Ajustar',0),(2699,75,'de','Fahren Sie mit Setup',0),(2700,75,'en','Continue on to Setup',0),(2701,76,'is','',0),(2702,76,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(2703,76,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(2704,76,'tr','MalÄ±n maliyeti Ekle',0),(2705,76,'pl','DodaÄ‡ koszt towarÃ³w',0),(2706,76,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð½Ð° ÑÑ‚Ð¾ÐºÐ¸Ñ‚Ðµ',0),(2707,76,'ur','Ø³Ø§Ù…Ø§Ù† Ú©ÛŒ Ù„Ø§Ú¯Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2708,76,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ñ€Ð¾Ð±Ðµ',0),(2709,76,'vi','ThÃªm giÃ¡ thÃ nh HÃ ng HÃ³a',0),(2710,76,'af','Voeg Aankoopbedrag by ',0),(2711,76,'ro','Adauga costul produselor',0),(2712,76,'et','Lisada kauba maksumusest',0),(2713,76,'si','Provizijo blagom',0),(2714,76,'ba','Menambahkan biaya barang',0),(2715,76,'nl','Toevoegen van de kosten van goederen',0),(2716,76,'fi','LisÃ¤Ã¤ tuotteiden kustannukset',0),(2717,76,'no','Legge til varekost',0),(2718,76,'da','TilfÃ¸je vareforbrug',0),(2719,76,'ko','ìƒí’ˆì˜ ë¹„ìš©ì„ ì¶”ê°€',0),(2720,76,'he','×”×•×¡×£ ××ª ×¢×œ×•×ª ×”×¡×—×•×¨×”',0),(2721,76,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ ÎšÎŸÎ£Î¤ÎŸÎ£ Î Î©Î›Î—Î˜Î•ÎÎ¤Î©Î',0),(2722,76,'zh','å¢žåŠ å•†å“æˆæœ¬\r\n',0),(2723,76,'sv','LÃ¤gg till kostnaden fÃ¶r varor',0),(2724,76,'it','Aggiungere il costo dei beni',0),(2725,76,'tl','',0),(2726,76,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(2727,76,'hi','à¤®à¤¾à¤² à¤•à¥€ à¤²à¤¾à¤—à¤¤ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2728,76,'ms','Tambah kos barangan',0),(2729,76,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(2730,76,'fr','Ajouter coÃ»t des marchandises \r\n',0),(2731,76,'jp','å•†å“?åŽŸä¾¡ã‚’è¿½åŠ ',0),(2732,76,'pt','Adicionar o custo das mercadorias',0),(2733,76,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(2734,76,'es','Agregar Costo de Bienes',0),(2735,76,'de','Warenaufwand hinzufÃ¼gen',0),(2736,76,'en','Add Cost of Goods',0),(2737,77,'is','',0),(2738,77,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ ',0),(2739,77,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ ',0),(2740,77,'tr','Belge Ekle',0),(2741,77,'pl','Dodaj dokument',0),(2742,77,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(2743,77,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2744,77,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(2745,77,'vi','ThÃªm TÃ i Liá»‡u',0),(2746,77,'af','Voeg \'n Dokument by',0),(2747,77,'ro','Adauga document',0),(2748,77,'et','Lisa dokument',0),(2749,77,'si','Dodaj dokument',0),(2750,77,'ba','Tambahkan dokumen',0),(2751,77,'nl','Document toevoegen',0),(2752,77,'fi','LisÃ¤Ã¤ asiakirja',0),(2753,77,'no','Legge dokumentet',0),(2754,77,'da','TilfÃ¸je dokument',0),(2755,77,'ko','ë¬¸ì„œ ì¶”ê°€',0),(2756,77,'he','×”×•×¡×£ ×ž×¡×ž×š',0),(2757,77,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î­Î³Î³ÏÎ±Ï†Î¿',0),(2758,77,'zh','å¢žåŠ æ–‡ä»¶\r\n',0),(2759,77,'sv','LÃ¤gga till dokument',0),(2760,77,'it','Aggiungi documento',0),(2761,77,'tl','',0),(2762,77,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(2763,77,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2764,77,'ms','Tambah dokumen',0),(2765,77,'ar','Ø£Ø¶Ù Ù…Ø³ØªÙ†Ø¯',0),(2766,77,'fr','Ajouter Document',0),(2767,77,'jp','æ–‡æ›¸ã‚’è¿½åŠ ',0),(2768,77,'pt','Adicionar documento',0),(2769,77,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(2770,77,'es','Agregar Documento',0),(2771,77,'de','Dokument hinzufÃ¼gen',0),(2772,77,'en','Add Document',0),(2773,78,'is','',0),(2774,78,'dr','/ Ø§ØµÙ„Ø§Ø­  ÛŒÙˆØ²Ø± Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(2775,78,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø±Ø¨Ø± Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(2776,78,'tr','Bu ÅŸirket iÃ§in baÅŸka bir kullanÄ±cÄ± Ekle/DÃ¼zenle',0),(2777,78,'pl','Dodawanie/edycja innego uÅ¼ytkownika do tej firmy',0),(2778,78,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°',0),(2779,78,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/Ú©ÙˆØ¦ÛŒ Ø¯ÙˆØ³Ø±Ø§ ØµØ§Ø±Ù Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„ÛŒÛ’ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(2780,78,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð´Ñ€ÑƒÐ³Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð·Ð° Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(2781,78,'vi','ThÃªm/Sá»­a NgÆ°á»i Sá»­ Dá»¥ng KhÃ¡c cho cÃ´ng ty nÃ y',0),(2782,78,'af','Gebruiker vir hierdie onderneming Byvoeg/Redigeer',0),(2783,78,'ro','Aduaga/modifica alt utilizator pentru aceasta firma',0),(2784,78,'et','Lisa/Muuda uus kasutaja selle ettevÃµtte jaoks',0),(2785,78,'si','Dodaj/Uredi drug uporabnik za to podjetje',0),(2786,78,'ba','Menambah/mengedit pengguna lain untuk perusahaan ini',0),(2787,78,'nl','Een andere gebruiker toevoegen/bewerken voor dit bedrijf',0),(2788,78,'fi','LisÃ¤Ã¤ tai Muokkaa toinen kÃ¤yttÃ¤jÃ¤ tÃ¤mÃ¤n yrityksen',0),(2789,78,'no','Legge til eller redigere en annen bruker firmaet',0),(2790,78,'da','TilfÃ¸je eller redigere en anden bruger for dette selskab',0),(2791,78,'ko','ì´ íšŒì‚¬ì— ëŒ€ í•œ ë‹¤ë¥¸ ì‚¬ìš©ìžë¥¼ ì¶”ê°€/íŽ¸ì§‘',0),(2792,78,'he','×”×•×¡×£/×¢×¨×•×š ×ž×©×ª×ž×© × ×•×¡×£ ×¢×‘×•×¨ ×—×‘×¨×” ×–×•',0),(2793,78,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÎ½ÏŒÏ‚ Î¬Î»Î»Î¿Ï… Ï‡ÏÎ®ÏƒÏ„Î· Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î®',0),(2794,78,'zh','å¢žåŠ /ç¼–è¾‘è¿™å®¶å…¬å¸çš„å¦ä¸€ä¸ªç”¨æˆ·\r\n',0),(2795,78,'sv','LÃ¤gg till/redigera en annan anvÃ¤ndare fÃ¶r det hÃ¤r fÃ¶retaget',0),(2796,78,'it','Aggiungere o modificare un altro utente per questa azienda',0),(2797,78,'tl','',0),(2798,78,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3629;&#3639;&#3656;&#3609;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3609;&#3637;&#3657;',0),(2799,78,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¨à¥à¤¯ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(2800,78,'ms','Tambah/edit pengguna lain untuk Syarikat ini',0),(2801,78,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ù…Ø³ØªØ®Ø¯Ù… Ø¢Ø®Ø± Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(2802,78,'fr','Ajouter/Modifier un Autre UsagÃ© pour cette Compagnie',0),(2803,78,'jp','ã?“ã?®ä¼šç¤¾ã?®æ–°ã?Ÿã?ªãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’è¿½åŠ /ç·¨é›†',0),(2804,78,'pt','Adicionar/editar outro usuÃ¡rio para esta empresa',0),(2805,78,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¾Ð³Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ',0),(2806,78,'es','Agregar/Editar otro usuario para esta compaÃ±Ã­a',0),(2807,78,'de','HinzufÃ¼gen/Bearbeiten von einem anderen Benutzer fÃ¼r diese Firma',0),(2808,78,'en','Add/edit another user for this company',0),(2809,79,'is','',0),(2810,79,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(2811,79,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(2812,79,'tr','PO Ekle',0),(2813,79,'pl','DodaÄ‡ PO',0),(2814,79,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° PO',0),(2815,79,'ur','Ù¾Ùˆ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2816,79,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ ÐŸÐž',0),(2817,79,'vi','ThÃªm ÄÆ¡n Mua HÃ ng',0),(2818,79,'af','AN Byvoeg',0),(2819,79,'ro','Adauga comanda furnizor',0),(2820,79,'et','Lisada PO',0),(2821,79,'si','Dodajte PO',0),(2822,79,'ba','Tambahkan PO',0),(2823,79,'nl','PO toevoegen',0),(2824,79,'fi','LisÃ¤Ã¤ PO',0),(2825,79,'no','Legge PO',0),(2826,79,'da','TilfÃ¸je PO',0),(2827,79,'ko','í¬',0),(2828,79,'he','×œ×”×•×¡×™×£ ×¤×•',0),(2829,79,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ PO',0),(2830,79,'zh','å¢žåŠ åº«å­˜è®¢å•\r\n',0),(2831,79,'sv','LÃ¤gg till PO',0),(2832,79,'it','Aggiungi PO',0),(2833,79,'tl','',0),(2834,79,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(2835,79,'hi','PO à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2836,79,'ms','Tambah PO',0),(2837,79,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ùˆ',0),(2838,79,'fr','Ajouter Bon de Commande',0),(2839,79,'jp','POã‚’è¿½åŠ ',0),(2840,79,'pt','Adicionar PO',0),(2841,79,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ PO',0),(2842,79,'es','Agregar OC',0),(2843,79,'de','FÃ¼gen Sie PO',0),(2844,79,'en','Add PO',0),(2845,80,'is','',0),(2846,80,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ± Ø¬Ø¯ÙŠØ¯ ',0),(2847,80,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ± Ø¬Ø¯ÙŠØ¯ ',0),(2848,80,'tr','Yeni fatura Ekle',0),(2849,80,'pl','Dodaj nowÄ… fakturÄ™',0),(2850,80,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(2851,80,'ur','Ù†Ø¦Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2852,80,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(2853,80,'vi','ThÃªm HÃ³a ÄÆ¡n Má»›i',0),(2854,80,'af','Nuwe Faktuur Byvoeg',0),(2855,80,'ro','Adauga factura',0),(2856,80,'et','Lisa uus arve',0),(2857,80,'si','Dodaj nov raÄun',0),(2858,80,'ba','Membuat Faktur Baru',0),(2859,80,'nl','Factuur toevoegen',0),(2860,80,'fi','LisÃ¤Ã¤ uusi lasku',0),(2861,80,'no','Legge til ny faktura',0),(2862,80,'da','TilfÃ¸j ny faktura',0),(2863,80,'ko','ìƒˆ ì†¡ìž¥ ì¶”ê°€',0),(2864,80,'he','×”×•×¡×£ ×—×©×‘×•× ×™×ª ×—×“×©×”',0),(2865,80,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(2866,80,'zh','å¢žåŠ å‘ç¥¨\r\n',0),(2867,80,'sv','LÃ¤gg till ny faktura',0),(2868,80,'it','Aggiungi nuova fattura',0),(2869,80,'tl','',0),(2870,80,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(2871,80,'hi','à¤¨à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2872,80,'ms','Tambah invois baru',0),(2873,80,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯Ø©',0),(2874,80,'fr','Ajouter Nouvelle Facture',0),(2875,80,'jp','æ–°è¦?è«‹æ±‚æ›¸ã‚’è¿½åŠ ',0),(2876,80,'pt','Adicionar nova fatura',0),(2877,80,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ Ð¡Ñ‡ÐµÑ‚',0),(2878,80,'es','Agregar Nueva Factura',0),(2879,80,'de','FÃ¼gen Sie neue Rechnung',0),(2880,80,'en','Add New Invoice',0),(2881,81,'is','',0),(2882,81,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(2883,81,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(2884,81,'tr','Yeni Ã¶ÄŸe',0),(2885,81,'pl','Nowy element',0),(2886,81,'bg','ÐÐ¾Ð² ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(2887,81,'ur','Ù†Ø¦ÛŒ Ø´Û’',0),(2888,81,'sr','ÐÐ¾Ð²Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(2889,81,'vi','ThÃªm Danh Má»¥c Má»›i',0),(2890,81,'af','Nuwe Item Byvoeg',0),(2891,81,'ro','Adauga articol nou',0),(2892,81,'et','Lisa uus toode',0),(2893,81,'si','Nov element',0),(2894,81,'ba','Item baru',0),(2895,81,'nl','Nieuw Item',0),(2896,81,'fi','Uusi kohde',0),(2897,81,'no','Nytt element',0),(2898,81,'da','Nyt element',0),(2899,81,'ko','ìƒˆ í•­ëª©',0),(2900,81,'he','×”×•×¡×£ ×¤×¨×™×˜ ×—×“×©',0),(2901,81,'el','ÎÎ­Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(2902,81,'zh','å¢žåŠ é …ç›®\r\n',0),(2903,81,'sv','Nytt objekt',0),(2904,81,'it','Nuovo elemento',0),(2905,81,'tl','',0),(2906,81,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(2907,81,'hi','à¤¨à¤ à¤†à¤‡à¤Ÿà¤®',0),(2908,81,'ms','Perkara baru',0),(2909,81,'ar','Ø¥Ø¶Ø§ÙØ© ØµÙ†Ù Ø¬Ø¯ÙŠØ¯',0),(2910,81,'fr','Ajouter Nouvelle Item',0),(2911,81,'jp','æ–°è¦?å“?ç›®ã‚’è¿½åŠ ',0),(2912,81,'pt','Novo Item',0),(2913,81,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ Ð¢Ð¾Ð²Ð°Ñ€',0),(2914,81,'es','Agregar Nuevo item',0),(2915,81,'de','Neues Element',0),(2916,81,'en','New Item',0),(2917,82,'is','',0),(2918,82,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø± ÙƒØ§Ù„Ø§ Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(2919,82,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø± ÙƒØ§Ù„Ø§ Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(2920,82,'tr','Fatura iÃ§in satÄ±r Ã¶ÄŸesi Ekle',0),(2921,82,'pl','Dodawanie pozycji na fakturze',0),(2922,82,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÑŠÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(2923,82,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ Ù„Ø§Ø¦Ù† Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2924,82,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(2925,82,'vi','ThÃªm DÃ²ng Cho HÃ³a ÄÆ¡n',0),(2926,82,'af','Lynitem vir Faktuur Byvoeg',0),(2927,82,'ro','Adauga rand la factura',0),(2928,82,'et','Lisa rida arvele',0),(2929,82,'si','Dodati vrstiÄne postavke za raÄun',0),(2930,82,'ba','Tambahkan Item baris ke faktur',0),(2931,82,'nl','Regel aan factuur toevoegen',0),(2932,82,'fi','LisÃ¤Ã¤ rivinimike laskuun',0),(2933,82,'no','Legge til linjeelementet for fakturaen',0),(2934,82,'da','TilfÃ¸je linjeelement til faktura',0),(2935,82,'ko','ì†¡ìž¥ ì¤„ í•­ëª©ì„ ì¶”ê°€',0),(2936,82,'he','×”×•×¡×£ ×©×•×¨×ª ×¤×¨×™×˜ ×œ×—×©×‘×•× ×™×ª',0),(2937,82,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚ Ï€ÏÎ¿Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(2938,82,'zh','å¢žåŠ é¡¹ç›®è‡³å‘ç¥¨\r\n',0),(2939,82,'sv','LÃ¤gga till radartikeln i faktura',0),(2940,82,'it','Aggiungi elemento pubblicitario per fattura',0),(2941,82,'tl','',0),(2942,82,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(2943,82,'hi','à¤²à¤¾à¤‡à¤¨ à¤†à¤‡à¤Ÿà¤® à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2944,82,'ms','Tambah baris butiran invois',0),(2945,82,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¯ Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(2946,82,'fr','Ajouter Items a une Facture',0),(2947,82,'jp','å“?ç›®å??ã‚’è«‹æ±‚æ›¸ã?«è¿½åŠ ',0),(2948,82,'pt','Adicionar Item de linha de factura',0),(2949,82,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÑÑ‚Ñ€Ð¾ÐºÐ¸ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(2950,82,'es','Agregar LÃ­nea de item a la Factura',0),(2951,82,'de','Rechnung Posten hinzufÃ¼gen',0),(2952,82,'en','Add Line Item to Invoice',0),(2953,83,'is','',0),(2954,83,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø± ÙƒØ§Ù„Ø§ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(2955,83,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø± ÙƒØ§Ù„Ø§ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(2956,83,'tr','SatÄ±r Ã¶ÄŸesi sipariÅŸine Ekle',0),(2957,83,'pl','Dodawanie pozycji do zamÃ³wienia',0),(2958,83,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÑŠÐ¼ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(2959,83,'ur','Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù„Ø§Ø¦Ù† Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2960,83,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð° Ñƒ Ñ€ÐµÐ´',0),(2961,83,'vi','ThÃªm DÃ²ng HÃ ng Cho ÄÆ¡n Äáº·t HÃ ng',0),(2962,83,'af','Lynitem vir Bestelling Byvoeg',0),(2963,83,'ro','Adauga rand la comanda primita',0),(2964,83,'et','Lisa rida tellimusele',0),(2965,83,'si','Dodati vrstiÄne postavke za naroÄilo',0),(2966,83,'ba','Tambahkan Item baris pesanan',0),(2967,83,'nl','Line Item toevoegen aan bestelling',0),(2968,83,'fi','LisÃ¤Ã¤ nimike tilaukseen',0),(2969,83,'no','Legge linjeelement til ordre',0),(2970,83,'da','TilfÃ¸je linjeelement til ordre',0),(2971,83,'ko','ì£¼ë¬¸ ë¼ì¸ í•­ëª© ì¶”ê°€',0),(2972,83,'he','×”×•×¡×£ ×©×•×¨×ª ×¤×¨×™×˜ ×œ×”×–×ž× ×”',0),(2973,83,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î·',0),(2974,83,'zh','å¢žåŠ é¡¹ç›®è‡³è®¢å•\r\n',0),(2975,83,'sv','LÃ¤gg till radartikeln pÃ¥ Order',0),(2976,83,'it','Aggiungere la voce all\'ordine',0),(2977,83,'tl','',0),(2978,83,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(2979,83,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(2980,83,'ms','Tambah Item baris untuk perintah',0),(2981,83,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¯ Ø¥Ù„Ù‰ Ø£Ù…Ø±',0),(2982,83,'fr','Ajouter Ligne a une Commande',0),(2983,83,'jp','å“?ç›®å??ã‚’æ³¨æ–‡ã?«è¿½åŠ ',0),(2984,83,'pt','Adicionar Item de linha de ordem',0),(2985,83,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸ÑŽ Ð² Ð·Ð°ÐºÐ°Ð·',0),(2986,83,'es','Agregar LÃ­nea de item al Pedido',0),(2987,83,'de','FÃ¼gen Sie Artikel bei Bestellung',0),(2988,83,'en','Add Line Item to Order',0),(2989,84,'is','',0),(2990,84,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø± ÙƒØ§Ù„Ø§ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(2991,84,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø± ÙƒØ§Ù„Ø§ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(2992,84,'tr','PO iÃ§in satÄ±r Ã¶ÄŸesi Ekle',0),(2993,84,'pl','Dodawanie pozycji do PO',0),(2994,84,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÑŠÐ¼ PO',0),(2995,84,'ur','Ù¾Ùˆ Ú©Û’ Ù„Ø¦Û’ Ù„Ø§Ø¦Ù† Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(2996,84,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð° ÐŸÐž',0),(2997,84,'vi','ThÃªm DÃ²ng Cho ÄÆ¡n Äáº·t HÃ ng',0),(2998,84,'af','Lynitem vir AN Byvoeg',0),(2999,84,'ro','Adauga rand la comanda furnizor',0),(3000,84,'et','Lisa rida ostutellimusele',0),(3001,84,'si','Dodati vrstiÄne postavke PO',0),(3002,84,'ba','Tambahkan Item baris PO',0),(3003,84,'nl','Line Item toevoegen aan PO',0),(3004,84,'fi','LisÃ¤Ã¤ rivinimike PO',0),(3005,84,'no','Legge til linjeelementet PO',0),(3006,84,'da','TilfÃ¸je linjeelement til PO',0),(3007,84,'ko','í¬ ë¼ì¸ í•­ëª© ì¶”ê°€',0),(3008,84,'he','×”×•×¡×¤×ª ×¤×¨×™×˜ ×©×•×¨×” ×¤×•',0),(3009,84,'el','Î‘Ï…Î¾Î¬Î½Ï‰ Î±Î½Î¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(3010,84,'zh','å¢žåŠ é¡¹ç›®è‡³è®¢å•\r\n',0),(3011,84,'sv','LÃ¤gga till radartikeln i PO',0),(3012,84,'it','Aggiungi elemento pubblicitario al PO',0),(3013,84,'tl','',0),(3014,84,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(3015,84,'hi','à¤•à¥‹ à¤ªà¥‹ à¤²à¤¾à¤‡à¤¨ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3016,84,'ms','Tambah Line Item ke PO',0),(3017,84,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¯ Ø¥Ù„Ù‰ Ø¨Ùˆ',0),(3018,84,'fr','Ajouter Ligne a un Bon de Commande',0),(3019,84,'jp','ãƒ©ã‚¤ãƒ³å“?ç›®ã‚’POã?«è¿½åŠ ',0),(3020,84,'pt','Adicionar Item de linha para PO',0),(3021,84,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾ÐºÐ¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ PO',0),(3022,84,'es','Agregar LÃ­nea de item a OC',0),(3023,84,'de','PO Posten hinzufÃ¼gen',0),(3024,84,'en','Add Line Item to PO',0),(3025,85,'is','',0),(3026,85,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø±Ù‡Ø§ÙŠ Ø¨ÙŠØ´ØªØ± Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯Ù‰ ',0),(3027,85,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø±Ù‡Ø§ÙŠ Ø¨ÙŠØ´ØªØ± Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯Ù‰ ',0),(3028,85,'tr','Daha fazla giriÅŸ satÄ±rlarÄ± ekleyin',0),(3029,85,'pl','DodaÄ‡ wiÄ™cej danych wejÅ›ciowych linii',0),(3030,85,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÑ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð²Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ‚Ðµ Ð»Ð¸Ð½Ð¸Ð¸',0),(3031,85,'ur','Ø§Ù† Ù¾Ù¹ Ù„Ø§Ø¦Ù†ÙˆÚº Ø³Û’ Ø²ÛŒØ§Ø¯Û Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3032,85,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ñ˜Ð¾Ñˆ ÑƒÐ»Ð°Ð·Ð½Ð¸Ñ… Ð»Ð¸Ð½Ð¸Ñ˜Ð°',0),(3033,85,'vi','ThÃªm DÃ²ng ',0),(3034,85,'af','Meer Invoerlyne Byvoeg',0),(3035,85,'ro','Adauga mai multe randuri',0),(3036,85,'et','Lisa ridu',0),(3037,85,'si','Dodaj veÄ vhodnih linij',0),(3038,85,'ba','Tambahkan lebih masukan baris',0),(3039,85,'nl','Meer Input lijnen toevoegen',0),(3040,85,'fi','LisÃ¤Ã¤ enemmÃ¤n sÃ¤hkÃ¶verkossa',0),(3041,85,'no','Legge til flere Input linjer',0),(3042,85,'da','TilfÃ¸je mere Input linjer',0),(3043,85,'ko','ë” ìž…ë ¥ëœ ë¼ì¸ ì¶”ê°€',0),(3044,85,'he','×”×•×¡×£ ×©×•×¨×•×ª ×§×œ×˜ × ×•×¡×¤×•×ª',0),(3045,85,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Î³ÏÎ±Î¼Î¼Î­Ï‚ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(3046,85,'zh','å¢žåŠ æ›´å¤šçš„è¾“å…¥çº¿\r\n',0),(3047,85,'sv','LÃ¤gga till mer ingÃ¥ende linjer',0),(3048,85,'it','Aggiungere piÃ¹ linee di ingresso',0),(3049,85,'tl','',0),(3050,85,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;',0),(3051,85,'hi','à¤…à¤§à¤¿à¤• à¤‡à¤¨à¤ªà¥à¤Ÿ à¤²à¤¾à¤‡à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3052,85,'ms','Tambah lebih Input garisan',0),(3053,85,'ar','Ø¥Ø¶Ø§ÙØ© ØµÙÙˆÙ Ø¥Ø¯Ø®Ø§Ù„',0),(3054,85,'fr','Ajouter Lignes',0),(3055,85,'jp','ã?•ã‚‰ã?«å…¥åŠ›ãƒ©ã‚¤ãƒ³ã‚’è¿½åŠ ',0),(3056,85,'pt','Adicionar mais linhas de entrada',0),(3057,85,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð±Ð¾Ð»ÑŒÑˆÐµ Ð²Ñ…Ð¾Ð´Ð½Ñ‹Ñ… Ð»Ð¸Ð½Ð¸Ð¹',0),(3058,85,'es','Agregar mÃ¡s LÃ­neas de Entrada',0),(3059,85,'de','FÃ¼gen Sie mehr Eingabezeilen',0),(3060,85,'en','Add More Input Lines',0),(3061,86,'is','',0),(3062,86,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾ÙˆÙ„',0),(3063,86,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾ÙˆÙ„',0),(3064,86,'tr','Ekle $',0),(3065,86,'pl','Dodaj $',0),(3066,86,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ $',0),(3067,86,'ur','$ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3068,86,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ $',0),(3069,86,'vi','ThÃªm $',0),(3070,86,'af','$ Byvoeg',0),(3071,86,'ro','Adauga Lei',0),(3072,86,'et','Lisada $',0),(3073,86,'si','Dodaj $',0),(3074,86,'ba','Tambahkan $',0),(3075,86,'nl','$ Toevoegen',0),(3076,86,'fi','LisÃ¤Ã¤ $',0),(3077,86,'no','Legge til $',0),(3078,86,'da','TilfÃ¸j $',0),(3079,86,'ko','$ ì¶”ê°€',0),(3080,86,'he','â‚ª ×”×•×¡×£',0),(3081,86,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ $',0),(3082,86,'zh','åŠ é’±\r\n',0),(3083,86,'sv','LÃ¤gg till $',0),(3084,86,'it','Aggiungi $',0),(3085,86,'tl','',0),(3086,86,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3591;&#3636;&#3609;',0),(3087,86,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¤¾ $',0),(3088,86,'ms','Tambah $',0),(3089,86,'ar','Ø¥Ø¶Ø§ÙØ© $',0),(3090,86,'fr','Ajouter $',0),(3091,86,'jp','ï¼„ã‚’è¿½åŠ ',0),(3092,86,'pt','Adicionar $',0),(3093,86,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ $',0),(3094,86,'es','Agregar $',0),(3095,86,'de','FÃ¼gen Sie $',0),(3096,86,'en','Add $',0),(3097,87,'is','',0),(3098,87,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø¯ÙŠØ¯',0),(3099,87,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø¯ÙŠØ¯',0),(3100,87,'tr','Yeni ekle',0),(3101,87,'pl','Dodaj nowe',0),(3102,87,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²',0),(3103,87,'ur','Ù†ÛŒØ§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3104,87,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³',0),(3105,87,'vi','ThÃªm Má»›i',0),(3106,87,'af','Nuwe Byvoeg',0),(3107,87,'ro','Adauga nou',0),(3108,87,'et','Lisa uus',0),(3109,87,'si','Dodati novo',0),(3110,87,'ba','Tambah baru',0),(3111,87,'nl','Nieuwe toevoegen',0),(3112,87,'fi','LisÃ¤Ã¤ uusi',0),(3113,87,'no','Legge til nye',0),(3114,87,'da','TilfÃ¸j ny',0),(3115,87,'ko','ìƒˆë¡œ ì¶”ê°€',0),(3116,87,'he','×”×•×¡×£ ×—×“×©',0),(3117,87,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Ï‰Î½',0),(3118,87,'zh','å¢žåŠ æ–°\r\n',0),(3119,87,'sv','LÃ¤gga till nya',0),(3120,87,'it','Aggiungere nuovi',0),(3121,87,'tl','',0),(3122,87,'th','&#3648;&#3614;&#3636;&#3656;&#3617;',0),(3123,87,'hi','à¤¨à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3124,87,'ms','Tambah baru',0),(3125,87,'ar','Ø£Ø¶Ù Ø¬Ø¯ÙŠØ¯',0),(3126,87,'fr','Ajouter Nouveau',0),(3127,87,'jp','æ–°è¿½åŠ ',0),(3128,87,'pt','Adicionar novo',0),(3129,87,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ðµ',0),(3130,87,'es','Agregar Nuevo',0),(3131,87,'de','FÃ¼gen neuer hinzu',0),(3132,87,'en','Add New',0),(3133,88,'is','',0),(3134,88,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ø¬Ø¯ÙŠØ¯ ',0),(3135,88,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ø¬Ø¯ÙŠØ¯ ',0),(3136,88,'tr','Yeni bir eylem ekleme',0),(3137,88,'pl','Dodaj nowÄ… akcjÄ™',0),(3138,88,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(3139,88,'ur','Ù†ÛŒØ§ Ø¹Ù…Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3140,88,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ Ñ€Ð°Ð´ÑšÑƒ',0),(3141,88,'vi','ThÃªm HÃ nh Äá»™ng Má»›i',0),(3142,88,'af','Nuwe Aksie Byvoeg',0),(3143,88,'ro','Adauga activitate noua',0),(3144,88,'et','Lisa uus tegevus',0),(3145,88,'si','Dodati novo dejanje',0),(3146,88,'ba','Menambahkan tindakan baru',0),(3147,88,'nl','Nieuwe actie toevoegen',0),(3148,88,'fi','LisÃ¤Ã¤ uusi tehtÃ¤vÃ¤',0),(3149,88,'no','Legge til nye aksjonen',0),(3150,88,'da','TilfÃ¸je nye handling',0),(3151,88,'ko','ìƒˆ ìž‘ì—… ì¶”ê°€',0),(3152,88,'he','×”×•×¡×£ ×¤×¢×•×œ×” ×—×“×©×”',0),(3153,88,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î´ÏÎ¬ÏƒÎ·',0),(3154,88,'zh','å¢žåŠ æ–°åŠ¨ä½œ\r\n',0),(3155,88,'sv','LÃ¤gg till ny Ã¥tgÃ¤rd',0),(3156,88,'it','Aggiungi nuova azione',0),(3157,88,'tl','',0),(3158,88,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(3159,88,'hi','à¤¨à¤ˆ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3160,88,'ms','Menambah tindakan baru',0),(3161,88,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù…Ù„ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(3162,88,'fr','Ajouter Nouvelle Action',0),(3163,88,'jp','æ–°è¦?ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ',0),(3164,88,'pt','Adicionar nova aÃ§Ã£o',0),(3165,88,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(3166,88,'es','Agregar Nueva AcciÃ³n',0),(3167,88,'de','FÃ¼gen Sie neue Aktion',0),(3168,88,'en','Add New Action',0),(3169,89,'is','',0),(3170,89,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ§Ø¨Ø¹  Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª ',0),(3171,89,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ§Ø¨Ø¹  Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª ',0),(3172,89,'tr','Yeni baÄŸlayÄ±cÄ± iÅŸlev ekleme',0),(3173,89,'pl','Dodanie nowych funkcji introligatornia',0),(3174,89,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(3175,89,'ur','Ù†Ø¦Û’ Ø¨Ø§Ù†ÚˆØ±ÛŒ ØªÙ‚Ø±ÛŒØ¨ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3176,89,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸Ñ… Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð‘Ð¸Ð½Ð´ÐµÑ€y',0),(3177,89,'vi','ThÃªm ChÃºc NÄƒng ÄÃ³ng GÃ¡y Má»›i',0),(3178,89,'af','Nuwe \"Bindery\" Funksie Byvoeg',0),(3179,89,'ro','Adauga functionalitate noua',0),(3180,89,'et','Lisage uus Kirjansitomo funktsioon',0),(3181,89,'si','Dodajte novo funkcijo Knjigoveznica',0),(3182,89,'ba','Tambahkan fungsi Bindery baru',0),(3183,89,'nl','Voeg nieuwe Bindery functie',0),(3184,89,'fi','LisÃ¤Ã¤ uusi Bindery-toiminto',0),(3185,89,'no','Legg nye Bindery-funksjonen',0),(3186,89,'da','TilfÃ¸je nye Bindery funktion',0),(3187,89,'ko','ìƒˆ ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ ì¶”ê°€',0),(3188,89,'he','×”×•×¡×¤×ª ×¤×•× ×§×¦×™×” ×—×“×©×” ×ž×¡×•×’ Bindery',0),(3189,89,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Bindery',0),(3190,89,'zh','å¢žåŠ æ–°çš„è£…è®¢åŠŸèƒ½\r\n',0),(3191,89,'sv','LÃ¤gg till nya Bindery-funktionen',0),(3192,89,'it','Aggiungi nuova funzione della legatoria',0),(3193,89,'tl','',0),(3194,89,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3656;&#3609;&#3649;&#3615;&#3657;&#3617;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(3195,89,'hi','à¤¨à¤ˆ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3196,89,'ms','Menambah fungsi Bindery baru',0),(3197,89,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ¸ÙŠÙØ© Ø¬Ø¯ÙŠØ¯Ø© ÙÙŠ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(3198,89,'fr','Ajoutez la nouvelle fonction de faÃ§onnage',0),(3199,89,'jp','æ–°è¦?ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚’è¿½åŠ ',0),(3200,89,'pt','Adicione a nova funÃ§Ã£o de Bindery',0),(3201,89,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ñ„ÑƒÐ½ÐºÑ†Ð¸ÑŽ Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ',0),(3202,89,'es','Agregar Nueva FunciÃ³n EncuadernaciÃ³n',0),(3203,89,'de','FÃ¼gen Sie neue Bindery-Funktion',0),(3204,89,'en','Add New Bindery Function',0),(3205,90,'is','',0),(3206,90,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª  Ø¬Ø¯ÙŠØ¯ ',0),(3207,90,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª  Ø¬Ø¯ÙŠØ¯ ',0),(3208,90,'tr','Yeni baÄŸlayÄ±cÄ± tÃ¼rÃ¼ Ekle',0),(3209,90,'pl','DodaÄ‡ nowy typ wiÄ…zaÅ„',0),(3210,90,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ‚Ð¸Ð¿',0),(3211,90,'ur','Ù†Ø¦Û’ Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3212,90,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ Ð²Ñ€ÑÑ‚Ñƒ Ð‘Ð¸Ð½Ð´ÐµÑ€y',0),(3213,90,'vi','ThÃªm Loáº¡i ÄÃ³ng GÃ¡y Má»›i',0),(3214,90,'af','Voeg nuwe Bindery tipe',0),(3215,90,'ro','Adauga nou tip de functionalitate',0),(3216,90,'et','Lisage uus Kirjansitomo tÃ¼Ã¼p',0),(3217,90,'si','Dodati novo vrsto vezi',0),(3218,90,'ba','Menambahkan jenis Bindery baru',0),(3219,90,'nl','Nieuwe Bindery Type toevoegen',0),(3220,90,'fi','LisÃ¤Ã¤ uusi Bindery tyyppi',0),(3221,90,'no','Legge ny Bindery-Type',0),(3222,90,'da','TilfÃ¸je nye Bindery Type',0),(3223,90,'ko','ìƒˆ ë°”ì¸ë”ë¦¬ í˜•ì‹ ì¶”ê°€',0),(3224,90,'he','×”×•×¡×¤×ª ×¡×•×’ ×—×“×© ×ž×¡×•×’ Bindery',0),(3225,90,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï„ÏÏ€Î¿Ï… Bindery',0),(3226,90,'zh','å¢žåŠ æ–°çš„è£…è®¢å½¢å¼\r\n',0),(3227,90,'sv','LÃ¤gga till ny Bindery typ',0),(3228,90,'it','Aggiungi nuovo tipo della legatoria',0),(3229,90,'tl','',0),(3230,90,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3649;&#3615;&#3657;&#3617;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(3231,90,'hi','à¤¨à¤ˆ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3232,90,'ms','Tambah jenis Bindery baru',0),(3233,90,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø¬Ø¯ÙŠØ¯ Ù…Ù† Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(3234,90,'fr','Ajout d\'un nouveau Type de Bindery',0),(3235,90,'jp','æ–°è¦?ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚¿ã‚¤ãƒ—ã‚’è¿½åŠ ',0),(3236,90,'pt','Adicionar o novo tipo de Bindery',0),(3237,90,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ‚Ð¸Ð¿ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð”',0),(3238,90,'es','Agregar Nuevo Tipo EncuadernaciÃ³n',0),(3239,90,'de','FÃ¼gen neuer Bindery-Typ hinzu',0),(3240,90,'en','Add New Bindery Type',0),(3241,91,'is','',0),(3242,91,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯',0),(3243,91,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯',0),(3244,91,'tr','Yeni yapÄ± sipariÅŸler eklemek',0),(3245,91,'pl','DodaÄ‡ nowy Build zamÃ³wienia',0),(3246,91,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(3247,91,'ur','Ù†Ø¦ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3248,91,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(3249,91,'vi','ThÃªm ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(3250,91,'af','Voeg Nuwe Geboude bestellings By',0),(3251,91,'ro','Adauga comanda noua',0),(3252,91,'et','Lisada uued ehitada tellimused',0),(3253,91,'si','Dodajanje novih naroÄil graditi',0),(3254,91,'ba','Buat Pesanan Baru',0),(3255,91,'nl','Toevoegen van nieuwe Build Orders',0),(3256,91,'fi','LisÃ¤Ã¤ uusia rakentaa tilauksia',0),(3257,91,'no','Legge til nye bygge bestillinger',0),(3258,91,'da','TilfÃ¸je nye bygge ordrer',0),(3259,91,'ko','ìƒˆë¡œìš´ ë¹Œë“œ ëª…ë ¹ ì¶”ê°€',0),(3260,91,'he','×”×•×¡×£ ×”×•×¨××•×ª ×‘× ×™×” ×—×“×©×•×ª',0),(3261,91,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(3262,91,'zh','å¢žåŠ æ–°çš„ç”Ÿæˆè®¢å•\r\n',0),(3263,91,'sv','LÃ¤gga till nya bygga order',0),(3264,91,'it','Aggiungi nuova compilazione ordini',0),(3265,91,'tl','',0),(3266,91,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(3267,91,'hi','à¤¨à¤¯à¤¾ à¤¬à¤¨à¤¾à¤à¤ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3268,91,'ms','Tambah baru membina pesanan',0),(3269,91,'ar','Ø¥Ø¶Ø§ÙØ© Ø£ÙˆØ§Ù…Ø± Ø¨Ù†Ø§Ø¡ Ø¬Ø¯ÙŠØ¯Ø©',0),(3270,91,'fr','Ajouter Nouvelle Version de Commandes',0),(3271,91,'jp','æ–°è¦?çµ„ç«‹æ³¨æ–‡ã‚’è¿½åŠ ',0),(3272,91,'pt','Adicionar novas ordens de construÃ§Ã£o',0),(3273,91,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ ÑÐ±Ð¾Ñ€ÐºÐ¸',0),(3274,91,'es','Agregar Nuevos Ordenes de ConstrucciÃ³n',0),(3275,91,'de','Neue Build-Bestellungen hinzufÃ¼gen',0),(3276,91,'en','Add New Build Orders',0),(3277,92,'is','',0),(3278,92,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(3279,92,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(3280,92,'tr','Yeni taÅŸÄ±yÄ±cÄ± Ekle',0),(3281,92,'pl','DodaÄ‡ nowy przewoÅºnik',0),(3282,92,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð½Ð¾ÑÐ¸Ñ‚ÐµÐ»',0),(3283,92,'ur','Ù†Ø¦Û’ Ú©ÛŒØ±ÛŒØ¦Ø± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3284,92,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð¾Ð¿ÐµÑ€Ð°Ñ‚ÐµÑ€Ð°',0),(3285,92,'vi','ThÃªm HÃ£ng Váº­n Chuyá»ƒn Má»›i',0),(3286,92,'af','Nuwe Karweier Byvoeg',0),(3287,92,'ro','Adauga Transportator nou',0),(3288,92,'et','Lisage uus vedaja',0),(3289,92,'si','Dodajanje novega prevoznika',0),(3290,92,'ba','Menambahkan baru pembawa',0),(3291,92,'nl','Toevoegen van nieuwe drager',0),(3292,92,'fi','LisÃ¤Ã¤ uusi operaattori',0),(3293,92,'no','Legge til nye operatÃ¸ren',0),(3294,92,'da','TilfÃ¸je nye luftfartsselskab',0),(3295,92,'ko','ìƒˆë¡œìš´ ìš´ë°˜ëŒ€ë¥¼ ì¶”ê°€',0),(3296,92,'he','×”×•×¡×£ ×—×‘×¨×ª ×©×œ×™×—×•×™×•×ª ×—×“×©×” ',0),(3297,92,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(3298,92,'zh','å¢žåŠ æ–°æ‰¿è¿å•†\r\n',0),(3299,92,'sv','LÃ¤gg till ny bÃ¤rare',0),(3300,92,'it','Aggiungi nuovo elemento portante',0),(3301,92,'tl','',0),(3302,92,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(3303,92,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¨à¤ à¤µà¤¾à¤¹à¤•',0),(3304,92,'ms','Tambah Carrier baru',0),(3305,92,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙƒØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(3306,92,'fr','Ajouter Nouveau Transporteur',0),(3307,92,'jp','æ–°è¦?ç™ºé€?æ¥­è€…ã‚’è¿½åŠ ',0),(3308,92,'pt','Adicionar nova operadora',0),(3309,92,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ð³Ð¾ ÐšÑƒÑ€ÑŒÐµÑ€Ð°',0),(3310,92,'es','Agregar Nuevo Transportista',0),(3311,92,'de','FÃ¼gen Sie neue FÃ¶rdermaschine',0),(3312,92,'en','Add New Carrier',0),(3313,93,'is','',0),(3314,93,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯ ',0),(3315,93,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯ ',0),(3316,93,'tr','Yeni Kategori Ekle',0),(3317,93,'pl','Dodaj nowÄ… kategoriÄ™',0),(3318,93,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(3319,93,'ur','Ù†Ø¦Û’ Ø²Ù…Ø±Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(3320,93,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(3321,93,'vi','ThÃªm PhÃ¢n Loáº¡i Má»›i',0),(3322,93,'af','Nuwe Kategorie Byvoeg',0),(3323,93,'ro','Adauga Categorie noua',0),(3324,93,'et','Lisa uus kategooria',0),(3325,93,'si','Dodajte novo kategorijo',0),(3326,93,'ba','Tambahkan kategori baru',0),(3327,93,'nl','Nieuwe categorie toevoegen',0),(3328,93,'fi','LisÃ¤Ã¤ uusi luokka',0),(3329,93,'no','Legge til ny kategori',0),(3330,93,'da','TilfÃ¸j ny kategori',0),(3331,93,'ko','ìƒˆ ë²”ì£¼ ì¶”ê°€',0),(3332,93,'he','×”×•×¡×£ ×§×˜×’×•×¨×™×” ×—×“×©×”',0),(3333,93,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(3334,93,'zh','å¢žåŠ æ–°åˆ†ç±»\r\n',0),(3335,93,'sv','LÃ¤gg till ny kategori',0),(3336,93,'it','Aggiungi nuova categoria',0),(3337,93,'tl','',0),(3338,93,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;',0),(3339,93,'hi','à¤¨à¤ˆ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3340,93,'ms','Menambah kategori baru',0),(3341,93,'ar','Ø¥Ø¶Ø§ÙØ© ØªØµÙ†ÙŠÙ Ø¬Ø¯ÙŠØ¯',0),(3342,93,'fr','Ajouter Nouvelle Categorie',0),(3343,93,'jp','æ–°è¦?ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’è¿½åŠ ',0),(3344,93,'pt','Adicionar nova categoria',0),(3345,93,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²ÑƒÑŽ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(3346,93,'es','Agregar Nueva CategorÃ­a',0),(3347,93,'de','Neue Kategorie hinzufÃ¼gen',0),(3348,93,'en','Add New Category',0),(3349,94,'is','',0),(3350,94,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰ Ø¬Ø¯ÙŠØ¯ ',0),(3351,94,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰ Ø¬Ø¯ÙŠØ¯ ',0),(3352,94,'tr','Yeni Ã§ek hesabÄ± ekleme',0),(3353,94,'pl','Dodaj nowe konto bankowe',0),(3354,94,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(3355,94,'ur','Ù†Ø¦Û’ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3356,94,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(3357,94,'vi','ThÃªm TK SÃ©c Má»›i',0),(3358,94,'af','Nuwe Kontroleringsrekening Byvoeg',0),(3359,94,'ro','Adauga cont curent nou',0),(3360,94,'et','Lisada uue pangakonto',0),(3361,94,'si','Dodaj nov banÄni raÄun',0),(3362,94,'ba','Menambahkan rekening baru',0),(3363,94,'nl','Toevoegen van nieuwe betaalrekening',0),(3364,94,'fi','LisÃ¤Ã¤ uusi pankkitililtÃ¤si',0),(3365,94,'no','Legge til nye brukskonto',0),(3366,94,'da','TilfÃ¸je nye checkkonto',0),(3367,94,'ko','ìƒˆë¡œìš´ ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œë¥¼ ì¶”ê°€',0),(3368,94,'he','×”×•×¡×£ ×—×©×‘×•×Ÿ ×‘× ×§ ×—×“×©',0),(3369,94,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Î±Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(3370,94,'zh','å¢žåŠ æ–°æ”¯ç¥¨å¸æˆ·\r\n',0),(3371,94,'sv','LÃ¤gg till nya checkkonto',0),(3372,94,'it','Aggiungi nuovo conto corrente',0),(3373,94,'tl','',0),(3374,94,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(3375,94,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤¨à¤ à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(3376,94,'ms','Tambah baru akaun memeriksa',0),(3377,94,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(3378,94,'fr','Ajouter Nouveu Compte de Cheques',0),(3379,94,'jp','æ–°è¦?å½“åº§é ?é‡‘ã‚’è¿½åŠ ',0),(3380,94,'pt','Adicionar nova conta',0),(3381,94,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚',0),(3382,94,'es','Agregar Nueva Cuenta de Chequeo',0),(3383,94,'de','FÃ¼gen Sie neue Girokonto',0),(3384,94,'en','Add New Checking Account',0),(3385,95,'is','',0),(3386,95,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª Ø¬Ø¯ÙŠØ¯ ',0),(3387,95,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª Ø¬Ø¯ÙŠØ¯ ',0),(3388,95,'tr','Yeni Firma Ekle',0),(3389,95,'pl','Dodaj nowÄ… firmÄ™',0),(3390,95,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(3391,95,'ur','Ù†Ø¦ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3392,95,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(3393,95,'vi','ThÃªm CÃ´ng Ty Má»›i',0),(3394,95,'af','Nuwe Onderneming Byvoeg',0),(3395,95,'ro','Adauga companie noua',0),(3396,95,'et','Lisa uus ettevÃµte',0),(3397,95,'si','Dodajanje nove druÅ¾be',0),(3398,95,'ba','Tambahkan perusahaan baru',0),(3399,95,'nl','Toevoegen nieuw bedrijf',0),(3400,95,'fi','LisÃ¤Ã¤ uusi yritys',0),(3401,95,'no','Legge til nytt selskap',0),(3402,95,'da','TilfÃ¸je nye selskab',0),(3403,95,'ko','ìƒˆ íšŒì‚¬ë¥¼ ì¶”ê°€',0),(3404,95,'he','×”×•×¡×£ ×—×‘×¨×” ×—×“×©×”',0),(3405,95,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î±Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(3406,95,'zh','å¢žåŠ æ–°å…¬å¸\r\n',0),(3407,95,'sv','LÃ¤gg till nytt fÃ¶retag',0),(3408,95,'it','Aggiungi nuova societÃ ',0),(3409,95,'tl','',0),(3410,95,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(3411,95,'hi','à¤¨à¤ˆ à¤•à¤‚à¤ªà¤¨à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3412,95,'ms','Tambah syarikat baru',0),(3413,95,'ar','Ø£Ø¶Ù Ø´Ø±ÙƒØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(3414,95,'fr','Ajouter Nouvelle Compagnie',0),(3415,95,'jp','æ–°ã?Ÿã?ªä¼šç¤¾ã‚’è¿½åŠ ',0),(3416,95,'pt','Adicionar nova empresa',0),(3417,95,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²ÑƒÑŽ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ',0),(3418,95,'es','Agregar Nueva CompaÃ±Ã­a',0),(3419,95,'de','Neue Firma hinzufÃ¼gen',0),(3420,95,'en','Add New Company',0),(3421,96,'is','',0),(3422,96,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯',0),(3423,96,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯',0),(3424,96,'tr','Yeni maliyet merkezi',0),(3425,96,'pl','Nowe centrum kosztÃ³w',0),(3426,96,'bg','ÐÐ¾Ð² Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(3427,96,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ù…Ø±Ú©Ø²',0),(3428,96,'sr','ÐÐ¾Ð²Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(3429,96,'vi','ThÃªm Cost Center Má»›i',0),(3430,96,'af','Nuwe Koste Sentrum Byvoeg',0),(3431,96,'ro','Noul centru de Cost',0),(3432,96,'et','Uus Kulukeskus',0),(3433,96,'si','Nove stroÅ¡kovno srediÅ¡Äe',0),(3434,96,'ba','Pusat biaya baru',0),(3435,96,'nl','Nieuwe kostenplaats',0),(3436,96,'fi','Uusi kustannuspaikka',0),(3437,96,'no','Nye kostsenter',0),(3438,96,'da','Nye omkostningssted',0),(3439,96,'ko','ìƒˆë¡œìš´ ë¹„ìš© ì„¼í„°',0),(3440,96,'he','×”×•×¡×£ ×ž×¨×›×– ×¢×œ×•×ª ×—×“×©',0),(3441,96,'el','ÎÎ­Î¿ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(3442,96,'zh','å¢žåŠ æ–°çš„æˆæœ¬ä¸­å¿ƒ\r\n',0),(3443,96,'sv','Nya kostnadsstÃ¤lle',0),(3444,96,'it','Nuovo centro di costo',0),(3445,96,'tl','',0),(3446,96,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;',0),(3447,96,'hi','à¤¨à¤ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(3448,96,'ms','Pusat kos baru',0),(3449,96,'ar','Ø£Ø¶Ø§ÙØ© Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© Ø¬Ø¯ÙŠØ¯',0),(3450,96,'fr','Nouveau centre de coÃ»t',0),(3451,96,'jp','æ–°è¦?ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã‚’è¿½åŠ ',0),(3452,96,'pt','Novo centro de custo',0),(3453,96,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ†ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(3454,96,'es','Agregar Nuevo Centro de Costo',0),(3455,96,'de','Neue Kostenstelle',0),(3456,96,'en','New Cost Center',0),(3457,97,'is','',0),(3458,97,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(3459,97,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(3460,97,'tr','Yeni mÃ¼ÅŸteri Ekle',0),(3461,97,'pl','Dodawanie nowego klienta',0),(3462,97,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(3463,97,'ur','Ù†Ø¦Û’ Ú¯Ø§ÛÚ©ÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3464,97,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð°',0),(3465,97,'vi','ThÃªm KhÃ¡ch HÃ ng Má»›i',0),(3466,97,'af','Nuwe Klant/KliÃ«nt Byvoeg',0),(3467,97,'ro','Adauga Client nou',0),(3468,97,'et','Lisa uus klient',0),(3469,97,'si','Dodajanje novega kupca',0),(3470,97,'ba','Tambah pelanggan baru',0),(3471,97,'nl','Toevoegen van nieuwe klant',0),(3472,97,'fi','LisÃ¤Ã¤ uusi asiakas',0),(3473,97,'no','Legge ny kunde',0),(3474,97,'da','TilfÃ¸j ny kunde',0),(3475,97,'ko','ìƒˆ ê³ ê° ì¶”ê°€',0),(3476,97,'he','×”×•×¡×£ ×œ×§×•×— ×—×“×©',0),(3477,97,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(3478,97,'zh','å¢žåŠ æ–°å®¢æˆ·\r\n',0),(3479,97,'sv','LÃ¤gg till ny kund',0),(3480,97,'it','Aggiungi nuovo cliente',0),(3481,97,'tl','',0),(3482,97,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(3483,97,'hi','à¤¨à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(3484,97,'ms','Menambahkan pelanggan baru',0),(3485,97,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù…ÙŠÙ„ Ø¬Ø¯ÙŠØ¯',0),(3486,97,'fr','Ajouter nouveau client',0),(3487,97,'jp','æ–°è¦?é¡§å®¢ã‚’è¿½åŠ ',0),(3488,97,'pt','Adicionar novo cliente',0),(3489,97,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ð³Ð¾ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(3490,97,'es','Agregar Nuevo Cliente',0),(3491,97,'de','Neuen Kunden anlegen',0),(3492,97,'en','Add New Customer',0),(3493,98,'is','',0),(3494,98,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ØªØ®ÙÙŠÙ Ø¬Ø¯ÙŠØ¯ ',0),(3495,98,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ØªØ®ÙÙŠÙ Ø¬Ø¯ÙŠØ¯ ',0),(3496,98,'tr','Yeni bir kesinti grubu',0),(3497,98,'pl','Nowa grupa odliczenia',0),(3498,98,'bg','ÐÐ¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð·Ð° Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(3499,98,'ur','Ù†ÛŒØ§ ÛÙˆÙ†Û’Ùˆ Ú¯Ø±ÙˆÙ¾',0),(3500,98,'sr','ÐÐ¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð°',0),(3501,98,'vi','ThÃªm NhÃ³m Giáº£m Trá»« Má»›i',0),(3502,98,'af','Nuwe Aftrekkingsgroep Byvoeg',0),(3503,98,'ro','Adauga Grup de reduceri nou',0),(3504,98,'et','Uue mahaarvamist rÃ¼hma',0),(3505,98,'si','Novi odbitek skupine',0),(3506,98,'ba','Grup pemotongan baru',0),(3507,98,'nl','Nieuwe aftrek groep',0),(3508,98,'fi','Uusi vÃ¤hennys ryhmÃ¤',0),(3509,98,'no','Ny fradrag gruppe',0),(3510,98,'da','Nye fradrag gruppe',0),(3511,98,'ko','ìƒˆë¡œìš´ ê³µì œ ê·¸ë£¹',0),(3512,98,'he','×§×‘×•×¦×ª × ×™×›×•×™ ×—×“×©×”',0),(3513,98,'el','ÎÎ­Î± Î¿Î¼Î¬Î´Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(3514,98,'zh','æ–°å¢žçš„æ‰£é™¤é¡¹ç›®ç»„',0),(3515,98,'sv','Nya avdrag grupp',0),(3516,98,'it','Nuovo gruppo di deduzione',0),(3517,98,'tl','',0),(3518,98,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(3519,98,'hi','à¤¨à¤ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(3520,98,'ms','Kumpulan potongan baru',0),(3521,98,'ar','ÙØ±ÙŠÙ‚ Ø®ØµÙ… Ø¬Ø¯ÙŠØ¯',0),(3522,98,'fr','Nouveau groupe de dÃ©duction',0),(3523,98,'jp','æ–°è¦?æŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ ',0),(3524,98,'pt','Novo grupo de deduÃ§Ã£o',0),(3525,98,'ru','ÐÐ¾Ð²Ð°Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ð° Ð²Ñ‹Ñ‡ÐµÑ‚',0),(3526,98,'es','Agregar Nuevo Grupo DeducciÃ³n',0),(3527,98,'de','Neue Gruppe zum Abzug',0),(3528,98,'en','New Deduction Group',0),(3529,99,'is','',0),(3530,99,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ø¬Ø¯ÙŠØ¯ ',0),(3531,99,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ø¬Ø¯ÙŠØ¯ ',0),(3532,99,'tr','Yeni bilgi Ekle',0),(3533,99,'pl','Dodaj nowy element',0),(3534,99,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð² Ð´ÐµÑ‚Ð°Ð¹Ð»',0),(3535,99,'ur','Ù†Ø¦ÛŒ ØªÙØµÛŒÙ„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3536,99,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð´ÐµÑ‚Ð°Ñ™',0),(3537,99,'vi','ThÃªm Chi Tiáº¿t Má»›i',0),(3538,99,'af','Nuwe Detail Byvoeg',0),(3539,99,'ro','Adauga detaliu nou',0),(3540,99,'et','Lisa uued andmed',0),(3541,99,'si','Dodajte nove podrobnosti',0),(3542,99,'ba','Tambahkan Detail baru',0),(3543,99,'nl','Nieuwe info toevoegen',0),(3544,99,'fi','LisÃ¤tÃ¤ uusia yksityiskohtia',0),(3545,99,'no','Legger til nye detaljer',0),(3546,99,'da','TilfÃ¸je nye detaljer',0),(3547,99,'ko','ìƒˆë¡œìš´ ì„¸ë¶€ ì •ë³´ ì¶”ê°€',0),(3548,99,'he','×”×•×¡×£ ×¤×¨×˜ ×—×“×©',0),(3549,99,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(3550,99,'zh','å¢žåŠ æ–°çš„ç»†èŠ‚\r\n',0),(3551,99,'sv','LÃ¤gga till nya Detaljer',0),(3552,99,'it','Aggiungere nuovi dettagli',0),(3553,99,'tl','',0),(3554,99,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(3555,99,'hi','à¤¨à¤ˆ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3556,99,'ms','Tambah butiran baru',0),(3557,99,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ø¬Ø¯ÙŠØ¯Ø©',0),(3558,99,'fr','Ajouter nouveau dÃ©tail',0),(3559,99,'jp','æ–°è¦?è©³ç´°ã‚’è¿½åŠ ',0),(3560,99,'pt','Adicionar novo detalhe',0),(3561,99,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(3562,99,'es','Agregar Nuevo Detalle',0),(3563,99,'de','Neue Details hinzufÃ¼gen',0),(3564,99,'en','Add New Detail',0),(3565,100,'is','',0),(3566,100,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(3567,100,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(3568,100,'tr','Yeni ayrÄ±ntÄ± Ã§alÄ±ÅŸma tÃ¼rÃ¼ Ekle',0),(3569,100,'pl','DodaÄ‡ nowy typ pracy wszystko',0),(3570,100,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿',0),(3571,100,'ur','Ù†Ø¦ÛŒ ØªÙØµÛŒÙ„ Ú©Ø§Ù… Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3572,100,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸Ñ… Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð° Ð´ÐµÑ‚Ð°Ñ™',0),(3573,100,'vi','ThÃªm Chi Tiáº¿t Má»›i Cho Loáº¡i CÃ´ng Viá»‡c',0),(3574,100,'af','Nuwe Detail Werktipe Byvoeg',0),(3575,100,'ro','Adauga noul tip de munca de detaliu',0),(3576,100,'et','Lisada uus Detail tÃ¶Ã¶ tÃ¼Ã¼p',0),(3577,100,'si','Dodajanje nove vrste dela podrobnosti',0),(3578,100,'ba','Menambahkan jenis pekerjaan Detail baru',0),(3579,100,'nl','Toevoegen van nieuwe Detail werksoort',0),(3580,100,'fi','LisÃ¤Ã¤ uusi yksityiskohta tyÃ¶n tyyppi',0),(3581,100,'no','Legge til nye detaljer arbeidstype',0),(3582,100,'da','TilfÃ¸je nye detaljer arbejdstype',0),(3583,100,'ko','ìƒˆë¡œìš´ ì„¸ë¶€ ìž‘ì—… ìœ í˜• ì¶”ê°€',0),(3584,100,'he','×”×•×¡×¤×ª ×¡×•×’ ×—×“×© ×©×œ ×¢×‘×•×“×” ×ž×¤×•×¨×˜',0),(3585,100,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï„ÏÏ€Î¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(3586,100,'zh','å¢žåŠ æ–°çš„ç»†èŠ‚å·¥ä½œç±»åˆ«\r\n',0),(3587,100,'sv','LÃ¤gga till ny detalj arbetstyp',0),(3588,100,'it','Aggiungi nuovo tipo di lavoro di dettaglio',0),(3589,100,'tl','',0),(3590,100,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3591;&#3634;&#3609;&#3594;&#3609;&#3636;&#3604;',0),(3591,100,'hi','à¤¨à¤¯à¤¾ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3592,100,'ms','Tambah jenis kerja terperinci baru',0),(3593,100,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø¬Ø¯ÙŠØ¯ Ù…Ù† Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(3594,100,'fr','Ajouter le nouveau Type de travail de dÃ©tail',0),(3595,100,'jp','æ–°è¦?ä»•äº‹å†…å®¹è©³ç´°ã‚’è¿½åŠ ',0),(3596,100,'pt','Adicionar o novo tipo de trabalho de detalhe',0),(3597,100,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ðµ Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð¢Ð¸Ð¿Ð° Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(3598,100,'es','Agregar Nuevo Tipo de Detalle del Trabajo',0),(3599,100,'de','FÃ¼gen Sie neue Detail Arbeitstyp',0),(3600,100,'en','Add New Detail Work Type',0),(3601,101,'is','',0),(3602,101,'dr',' Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(3603,101,'pr',' Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(3604,101,'tr','Yeni eleman eklemek',0),(3605,101,'pl','Dodawanie nowego pracownika',0),(3606,101,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(3607,101,'ur','Ù†ÛŒÙˆ Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3608,101,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(3609,101,'vi','ThÃªm NhÃ¢n ViÃªn Má»›i',0),(3610,101,'af','Nuwe Werknemer Byvoeg',0),(3611,101,'ro','Adauga angajat nou',0),(3612,101,'et','Lisa uus tÃ¶Ã¶taja',0),(3613,101,'si','Dodate novega zaposlenega',0),(3614,101,'ba','Tambahkan karyawan baru',0),(3615,101,'nl','Toevoegen nieuwe medewerker',0),(3616,101,'fi','LisÃ¤Ã¤ uusi tyÃ¶ntekijÃ¤',0),(3617,101,'no','Legg til nye ansatte',0),(3618,101,'da','TilfÃ¸je nye medarbejder',0),(3619,101,'ko','ìƒˆ ì§ì› ì¶”ê°€',0),(3620,101,'he','×”×•×¡×£ ×¢×•×‘×“ ×—×“×©',0),(3621,101,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Ï…Ï€Î¬Î»Î»Î·Î»Î¿',0),(3622,101,'zh','å¢žåŠ æ–°å‘˜å·¥\r\n',0),(3623,101,'sv','LÃ¤gg till ny medarbetare',0),(3624,101,'it','Aggiungi nuovo dipendente',0),(3625,101,'tl','',0),(3626,101,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(3627,101,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤¨à¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(3628,101,'ms','Menambah pekerja baru',0),(3629,101,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ¸Ù Ø¬Ø¯ÙŠØ¯',0),(3630,101,'fr','Ajouter nouvel employÃ©',0),(3631,101,'jp','æ–°è¦?å¾“æ¥­å“¡ã‚’è¿½åŠ ',0),(3632,101,'pt','Adicionar novo empregado',0),(3633,101,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ð³Ð¾ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(3634,101,'es','Agregar Nuevo Empleado',0),(3635,101,'de','FÃ¼gen neuen Mitarbeiter hinzu',0),(3636,101,'en','Add New Employee',0),(3637,102,'is','',0),(3638,102,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(3639,102,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(3640,102,'tr','Yeni Ã§alÄ±ÅŸanÄ± gÃ¶zden ekle',0),(3641,102,'pl','Dodaj recenzjÄ™ nowego pracownika',0),(3642,102,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(3643,102,'ur','Ù†ÛŒÙˆ Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3644,102,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(3645,102,'vi','ThÃªm ÄÃ¡nh GiÃ¡ NhÃ¢n ViÃªn Má»›i',0),(3646,102,'af','Nuwe Werknemer Oorsig Byvoeg',0),(3647,102,'ro','Adauga Descriere angajat',0),(3648,102,'et','Lisa uus tÃ¶Ã¶taja iseloomustus',0),(3649,102,'si','Dodajte nov pregled zaposlenih',0),(3650,102,'ba','Tambahkan Review karyawan baru',0),(3651,102,'nl','Nieuwe medewerker toevoegen',0),(3652,102,'fi','LisÃ¤Ã¤ uusi tyÃ¶ntekijÃ¤ tarkastelu',0),(3653,102,'no','Legge til nye medarbeider vurdering',0),(3654,102,'da','TilfÃ¸je nye medarbejder anmeldelse',0),(3655,102,'ko','ìƒˆ ì§ì› ê²€í† ë¥¼ ì¶”ê°€',0),(3656,102,'he','×”×•×¡×£ ×‘×™×§×•×¨×ª ×¢×•×‘×“ ×—×“×©',0),(3657,102,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ ÎºÏÎ¹Ï„Î¹ÎºÎ®Ï‚',0),(3658,102,'zh','å¢žåŠ æ–°å‘˜å·¥å›žé¡¾\r\n',0),(3659,102,'sv','LÃ¤gg till nya medarbetare recension',0),(3660,102,'it','Aggiungi nuova recensione dipendente',0),(3661,102,'tl','',0),(3662,102,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(3663,102,'hi','à¤¨à¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3664,102,'ms','Tambah baru pekerja kajian',0),(3665,102,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ø³ØªØ¹Ø±Ø§Ø¶ Ø¬Ø¯ÙŠØ¯ Ù„Ù„Ù…ÙˆØ¸Ù',0),(3666,102,'fr','Ajouter votre avis nouveau employÃ©',0),(3667,102,'jp','æ–°è¦?å¾“æ¥­å“¡å¯©æŸ»ã‚’è¿½åŠ ',0),(3668,102,'pt','Adicionar um novo empregado',0),(3669,102,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±Ð·Ð¾Ñ€ Ð½Ð¾Ð²Ñ‹Ñ… ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(3670,102,'es','Agregar Nueva RevisiÃ³n de Empleado',0),(3671,102,'de','Neue Mitarbeiter-Bericht hinzufÃ¼gen',0),(3672,102,'en','Add New Employee Review',0),(3673,103,'is','',0),(3674,103,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¹Ù…ÙˆÙ…ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(3675,103,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¹Ù…ÙˆÙ…ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(3676,103,'tr','Yeni genel iÅŸ tÃ¼rÃ¼ Ekle',0),(3677,103,'pl','DodaÄ‡ nowy typ pracy ogÃ³lne',0),(3678,103,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¾Ð±Ñ‰ Ð²Ð¸Ð´ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(3679,103,'ur','Ù†Ø¦Û’ Ø¬Ù†Ø±Ù„ Ú©Ø§Ù… Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3680,103,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸Ñ… Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð° Ð“ÐµÐ½ÐµÑ€Ð°Ð»',0),(3681,103,'vi','ThÃªm Loáº¡i CÃ´ng Viá»‡c Tá»•ng Há»£p Má»›i',0),(3682,103,'af','Nuwe Algemene Werktipe Byvoeg',0),(3683,103,'ro','Adauga noul tip de muncÄƒ General',0),(3684,103,'et','Lisage uus Ã¼ldine tÃ¶Ã¶ tÃ¼Ã¼p',0),(3685,103,'si','Dodajanje nove vrste dela sploÅ¡ne',0),(3686,103,'ba','Menambahkan baru jenis pekerjaan umum',0),(3687,103,'nl','Toevoegen van nieuwe algemene werksoort',0),(3688,103,'fi','LisÃ¤Ã¤ uusi yleinen tyÃ¶n tyyppi',0),(3689,103,'no','Legge til nye generelle arbeidstype',0),(3690,103,'da','TilfÃ¸je nye generelle arbejde Type',0),(3691,103,'ko','ìƒˆë¡œìš´ ì¼ë°˜ ìž‘ì—… ìœ í˜• ì¶”ê°€',0),(3692,103,'he','×”×•×¡×¤×ª ×¡×•×’ ×—×“×© ×©×œ ×¢×‘×•×“×” ×›×œ×œ×™',0),(3693,103,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Î³ÎµÎ½Î¹ÎºÎ¿Ï Ï„ÏÏ€Î¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(3694,103,'zh','å¢žåŠ æ–°çš„æ€»ä½“å·¥ä½œç±»åž‹\r\n',0),(3695,103,'sv','LÃ¤gg till nya allmÃ¤nna arbete typ',0),(3696,103,'it','Aggiungere il nuovo tipo di lavoro generale',0),(3697,103,'tl','',0),(3698,103,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(3699,103,'hi','à¤¨à¤ˆ à¤œà¤¨à¤°à¤² à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3700,103,'ms','Tambah jenis kerja Agung baru',0),(3701,103,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø¬Ø¯ÙŠØ¯ Ù…Ù† Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù…',0),(3702,103,'fr','Ajouter le nouveau Type de travail gÃ©nÃ©ral',0),(3703,103,'jp','æ–°è¦?ä¸€èˆ¬ä»•äº‹å†…å®¹ã‚’è¿½åŠ ',0),(3704,103,'pt','Adicionar o novo tipo de trabalho geral',0),(3705,103,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(3706,103,'es','Agregar Nuevo Tipo General de Trabajo',0),(3707,103,'de','FÃ¼gen Sie neue General-Arbeitstyp',0),(3708,103,'en','Add New General Work Type',0),(3709,104,'is','',0),(3710,104,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ Ø¯ÙØªØ± ÙƒÙ„ ',0),(3711,104,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ Ø¯ÙØªØ± ÙƒÙ„ ',0),(3712,104,'tr','Yeni GL hesabÄ± ekleme',0),(3713,104,'pl','Dodaj nowe konto GL',0),(3714,104,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð·Ð° GL',0),(3715,104,'ur','Ø¬ÛŒØ¬Û’ Ú©Û’ Ù†Ø¦Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3716,104,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð“Ð›',0),(3717,104,'vi','ThÃªm TK Sá»• CÃ¡i Tá»•ng Há»£p Má»›i',0),(3718,104,'af','Nuwe AG Rekening Byvoeg',0),(3719,104,'ro','Adauga cont nou',0),(3720,104,'et','Lisa uus PR konto',0),(3721,104,'si','Dodaj nov raÄun GL',0),(3722,104,'ba','Tambahkan akun baru GL',0),(3723,104,'nl','Nieuwe GL-Account toevoegen',0),(3724,104,'fi','LisÃ¤Ã¤ uusi GL tili',0),(3725,104,'no','Legge til ny GL-konto',0),(3726,104,'da','TilfÃ¸je nye GL konto',0),(3727,104,'ko','ìƒˆë¡œìš´ GL ê³„ì • ì¶”ê°€',0),(3728,104,'he','×œ×”×•×¡×™×£ ×—×©×‘×•×Ÿ ×—×“×© GL',0),(3729,104,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(3730,104,'zh','å¢žåŠ æ–°æ€»å¸å¸æˆ·\r\n',0),(3731,104,'sv','LÃ¤gg till nytt GL konto',0),(3732,104,'it','Aggiungi nuovo Account GL',0),(3733,104,'tl','',0),(3734,104,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(3735,104,'hi','à¤¨à¤ˆ GL à¤–à¤¾à¤¤à¥‡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3736,104,'ms','Menambah akaun GL baru',0),(3737,104,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨ Ø£Ø³ØªØ§Ø° Ø¹Ø§Ù… Ø¬Ø¯ÙŠØ¯',0),(3738,104,'fr','Ajouter nouveau compte GL',0),(3739,104,'jp','æ–°ã?Ÿã?ªGLã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¿½åŠ ',0),(3740,104,'pt','Adicionar nova conta GL',0),(3741,104,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL',0),(3742,104,'es','Agregar Nueva Cuenta Contable',0),(3743,104,'de','Neues GL-Konto hinzufÃ¼gen',0),(3744,104,'en','Add New GL Account',0),(3745,105,'is','',0),(3746,105,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ Ø¯ÙØªØ± ÙƒÙ„ ',0),(3747,105,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ Ø¯ÙØªØ± ÙƒÙ„ ',0),(3748,105,'tr','Yeni GL hesap tÃ¼rÃ¼ Ekle',0),(3749,105,'pl','DodaÄ‡ nowy typ konta GL',0),(3750,105,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ñ‚Ð¸Ð¿ GL',0),(3751,105,'ur','Ù†Ø¦Û’ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3752,105,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð²Ñ€ÑÑ‚Ðµ ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð›',0),(3753,105,'vi','ThÃªm Loáº¡i TK Sá»• CÃ¡i Tá»•ng Há»£p Má»›i',0),(3754,105,'af','Nuwe AG Rekeningtipe Byvoeg',0),(3755,105,'ro','Adauga noul tip de cont GL',0),(3756,105,'et','Lisa uus PR kontotÃ¼Ã¼p',0),(3757,105,'si','Dodati novo vrsto raÄuna GL',0),(3758,105,'ba','Menambahkan baru GL jenis akun',0),(3759,105,'nl','Toevoegen van nieuwe GL accounttype',0),(3760,105,'fi','LisÃ¤Ã¤ uusi GL-tilityyppi',0),(3761,105,'no','Legg til ny GL-kontotype',0),(3762,105,'da','TilfÃ¸je nye GL kontotype',0),(3763,105,'ko','ìƒˆë¡œìš´ GL ê³„ì • ìœ í˜• ì¶”ê°€',0),(3764,105,'he','×”×•×¡×¤×ª ×¡×•×’ ×—×“×© ×©×œ ×—×©×‘×•×Ÿ GL',0),(3765,105,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï„ÏÏ€Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï GL',0),(3766,105,'zh','åŠ æ–°çš„æ€»å¸å¸æˆ·ç±»åž‹\r\n',0),(3767,105,'sv','LÃ¤gg till nya GL-kontotyp',0),(3768,105,'it','Aggiungere il nuovo tipo di Account GL',0),(3769,105,'tl','',0),(3770,105,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(3771,105,'hi','à¤¨à¤ˆ GL à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3772,105,'ms','Tambah jenis akaun GL baru',0),(3773,105,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ Ù„Ù„Ø£Ø³ØªØ§Ø° Ø¹Ø§Ù…',0),(3774,105,'fr','Ajout d\'un nouveau Type de compte GL',0),(3775,105,'jp','æ–°è¦?ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—ã‚’è¿½åŠ ',0),(3776,105,'pt','Adicionar o novo tipo de conta GL',0),(3777,105,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ‚Ð¸Ð¿ ÑÑ‡ÐµÑ‚Ð° GL',0),(3778,105,'es','Agregar Nuevo tipo de Cuenta LM',0),(3779,105,'de','HinzufÃ¼gen von neuen GL-Kontotyp',0),(3780,105,'en','Add New GL Account Type',0),(3781,106,'is','',0),(3782,106,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠÙ†Ùƒ Ø¬Ø¯ÙŠØ¯ ',0),(3783,106,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠÙ†Ùƒ Ø¬Ø¯ÙŠØ¯ ',0),(3784,106,'tr','Yeni mÃ¼rekkep ekleme',0),(3785,106,'pl','DodaÄ‡ nowy atrament',0),(3786,106,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾',0),(3787,106,'ur','Ù†Ø¦Û’ Ø§Ù†Ú© Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3788,106,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿ÐµÑ€Ð¾Ð¼',0),(3789,106,'vi','ThÃªm Má»±c Má»›i',0),(3790,106,'af','Nuwe Ink Byvoeg',0),(3791,106,'ro','Adauga noi cernealÄƒ',0),(3792,106,'et','Lisage uus tint',0),(3793,106,'si','Dodajte novo Ärnilo',0),(3794,106,'ba','Menambahkan baru tinta',0),(3795,106,'nl','Nieuwe inkt toevoegen',0),(3796,106,'fi','LisÃ¤Ã¤ uusi muste',0),(3797,106,'no','Legg til ny blekkfarge',0),(3798,106,'da','TilfÃ¸je nye blÃ¦k',0),(3799,106,'ko','ìƒˆ ìž‰í¬ ì¶”ê°€',0),(3800,106,'he','×œ×”×•×¡×™×£ ×“×™×• ×—×“×©',0),(3801,106,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Î¼ÎµÎ»Î¬Î½Î¹',0),(3802,106,'zh','å¢žåŠ æ–°å¢¨æ°´\r\n',0),(3803,106,'sv','LÃ¤gg till ny tryckfÃ¤rg',0),(3804,106,'it','Aggiungi nuovo inchiostro',0),(3805,106,'tl','',0),(3806,106,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3638;&#3585;',0),(3807,106,'hi','à¤¨à¤ˆ à¤‡à¤‚à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3808,106,'ms','Tambah dakwat baru',0),(3809,106,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø¨Ø± Ø¬Ø¯ÙŠØ¯',0),(3810,106,'fr','Ajoutez la nouvelle entrÃ©e manuscrite',0),(3811,106,'jp','æ–°è¦?ã‚¤ãƒ³ã‚¯ã‚’è¿½åŠ ',0),(3812,106,'pt','Adicionar nova tinta',0),(3813,106,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð½Ð¾Ð²Ñ‹Ðµ ÐºÑ€Ð°ÑÐºÐ¸',0),(3814,106,'es','Agregar Nueva Tinta',0),(3815,106,'de','FÃ¼gen Sie neue Druckfarbe',0),(3816,106,'en','Add New Ink',0),(3817,107,'is','',0),(3818,107,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(3819,107,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(3820,107,'tr','Yeni stok biÃ§imlendirme ekleme',0),(3821,107,'pl','DodaÄ‡ nowy spis znacznikÃ³w',0),(3822,107,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÑÐºÐ»Ð°Ð´ Ð·Ð° Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(3823,107,'ur','Ù†Ø¦Û’ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3824,107,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸Ñ… Ð·Ð°Ð»Ð¸Ñ…Ð° Ð½Ð°Ð·Ð½Ð°ÐºÐµ',0),(3825,107,'vi','ThÃªm Má»©c Cá»™ng ThÃªm Má»›i Cho HÃ ng HÃ³a',0),(3826,107,'af','Nuwe Voorraad Prysverhoging Byvoeg',0),(3827,107,'ro','Adauga nou inventar Markup',0),(3828,107,'et','Lisada uue lao mÃ¤rgistus',0),(3829,107,'si','Dodajte nove zaloge Markup',0),(3830,107,'ba','Menambahkan baru Markup persediaan',0),(3831,107,'nl','Nieuwe inventaris aantekeningen toevoegen',0),(3832,107,'fi','LisÃ¤tÃ¤ uuden varaston merkintÃ¶jÃ¤',0),(3833,107,'no','Legge til nye lager markering',0),(3834,107,'da','TilfÃ¸je nye opgÃ¸relse Markup',0),(3835,107,'ko','ìƒˆë¡œìš´ ì¸ë²¤í† ë¦¬ íƒœê·¸ ì¶”ê°€',0),(3836,107,'he','×”×•×¡×¤×ª ×¡×™×ž×•×Ÿ ×ž×œ××™ ×—×“×©',0),(3837,107,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î±Ï€Î¿Î³ÏÎ±Ï†Î® ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(3838,107,'zh','å¢žåŠ æ–°çš„æ¸…å•æ ‡è®°\r\n',0),(3839,107,'sv','LÃ¤gga till nya lager Markup',0),(3840,107,'it','Aggiungi nuovo inventario Markup',0),(3841,107,'tl','',0),(3842,107,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(3843,107,'hi','à¤¨à¤ˆ à¤¸à¥‚à¤šà¥€ à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤œà¥‹à¤¡à¤¼',0),(3844,107,'ms','Tambah baru inventori penanda',0),(3845,107,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙˆØµÙŠÙ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(3846,107,'fr','Ajouter la nouvelle marque de l\'inventaire',0),(3847,107,'jp','æ–°è¦?åœ¨åº«å€¤ä¸Šã?’ã‚’è¿½åŠ ',0),(3848,107,'pt','Adicionar nova marcaÃ§Ã£o de inventÃ¡rio',0),(3849,107,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð½Ð¾Ð²ÑƒÑŽ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÑƒ, Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(3850,107,'es','Agregar Nuevo Inventario de Marcas',0),(3851,107,'de','FÃ¼gen Sie neue Inventar-Markup',0),(3852,107,'en','Add New Inventory Markup',0),(3853,108,'is','',0),(3854,108,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(3855,108,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(3856,108,'tr','Yeni Stok fiyat dÃ¼zeyi ekleme',0),(3857,108,'pl','DodaÄ‡ nowy poziom cen zapasÃ³w',0),(3858,108,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÑÐºÐ»Ð°Ð´ Ñ†ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾',0),(3859,108,'ur','Ù†Ø¦ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3860,108,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð½Ð¸Ð²Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð° Ñ†ÐµÐ½Ð°',0),(3861,108,'vi','ThÃªm Cáº¥p Äá»™ GiÃ¡ Má»›i Cho HÃ ng HÃ³a',0),(3862,108,'af','Nuwe Voorraad Prysverhoging Byvoeg',0),(3863,108,'ro','Adauga nivel nou de preturi',0),(3864,108,'et','Lisage uus varude tase',0),(3865,108,'si','Dodajte nove zaloge raven cen',0),(3866,108,'ba','Menambahkan tingkat harga persediaan baru',0),(3867,108,'nl','Toevoegen van nieuwe voorraad prijsniveau',0),(3868,108,'fi','LisÃ¤Ã¤minen uuden varaston hintataso',0),(3869,108,'no','Legge til nye lager prisnivÃ¥',0),(3870,108,'da','TilfÃ¸j nyt lager prisniveau',0),(3871,108,'ko','ìƒˆë¡œìš´ ì¸ë²¤í† ë¦¬ ê°€ê²© ìˆ˜ì¤€ ì¶”ê°€',0),(3872,108,'he','×œ×”×•×¡×™×£ ×¨×ž×” ×—×“×©×” ×©×œ ×ž×—×™×¨ ×”×ž×œ××™',0),(3873,108,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(3874,108,'zh','å¢žåŠ æ–°çš„åº“å­˜ä»·æ ¼',0),(3875,108,'sv','LÃ¤gga till pris lagernivÃ¥',0),(3876,108,'it','Aggiungi nuovo livello dei prezzi di inventario',0),(3877,108,'tl','',0),(3878,108,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(3879,108,'hi','à¤¨à¤ˆ à¤¸à¥‚à¤šà¥€ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(3880,108,'ms','Menambah tahap harga inventori baru',0),(3881,108,'ar','Ø¥Ø¶Ø§ÙØ© Ø¬Ø¯ÙŠØ¯Ø© Ù„Ù…Ø³ØªÙˆÙ‰ Ø³Ø¹Ø± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(3882,108,'fr','Ajouter le nouveau niveau de prix de l\'inventaire',0),(3883,108,'jp','æ–°è¦?åœ¨åº«ä¾¡æ ¼æ°´æº–ã‚’è¿½åŠ ',0),(3884,108,'pt','Adicionar novo nÃ­vel de preÃ§o de inventÃ¡rio',0),(3885,108,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ñ†ÐµÐ½ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(3886,108,'es','Agregar Nuevo Nivel de Precios de Inventario',0),(3887,108,'de','FÃ¼gen Sie neue Inventar-Preisniveau',0),(3888,108,'en','Add New Inventory Price Level',0),(3889,109,'is','',0),(3890,109,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· Ø¬Ø¯ÙŠØ¯ ÙØ§ÙƒØªÙˆØ± ',0),(3891,109,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· Ø¬Ø¯ÙŠØ¯ ÙØ§ÙƒØªÙˆØ± ',0),(3892,109,'tr','Yeni fatura koÅŸullarÄ± ekleme',0),(3893,109,'pl','Dodaj nowe warunki faktury',0),(3894,109,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(3895,109,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ù†Ø¦ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3896,109,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ ÑƒÑÐ»Ð¾Ð²Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(3897,109,'vi','ThÃªm Äiá»u Khoáº£n HÃ³a ÄÆ¡n Má»›i ',0),(3898,109,'af','Nuwe Faktuur Terme Byvoeg',0),(3899,109,'ro','Adauga termeni noi factura',0),(3900,109,'et','Lisa uusi maksetingimusi',0),(3901,109,'si','Dodajte nove pogoje raÄuna',0),(3902,109,'ba','Tambahkan istilah baru faktur',0),(3903,109,'nl','Factuur voorwaarden toevoegen',0),(3904,109,'fi','LisÃ¤Ã¤ uusi lasku termejÃ¤',0),(3905,109,'no','Legge til nye faktureringsvilkÃ¥r',0),(3906,109,'da','TilfÃ¸j ny faktura vilkÃ¥r',0),(3907,109,'ko','ìƒˆ ì†¡ìž¥ ìš©ì–´ ì¶”ê°€',0),(3908,109,'he','×”×•×¡×£ ×ª× ××™ ×—×©×‘×•× ×™×ª ×—×“×©×™×',0),(3909,109,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î½Î­Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(3910,109,'zh','å¢žåŠ æ–°å‘ç¥¨æ¡æ¬¾\r\n',0),(3911,109,'sv','LÃ¤gg till ny faktura villkor',0),(3912,109,'it','Aggiungere nuovi termini di fattura',0),(3913,109,'tl','',0),(3914,109,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(3915,109,'hi','à¤¨à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¤¿à¤¯à¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3916,109,'ms','Tambah terma-terma invois yang baru',0),(3917,109,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙˆØ· Ø¬Ø¯ÙŠØ¯Ø© Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(3918,109,'fr','Ajouter des nouvelles conditions de facturation',0),(3919,109,'jp','æ–°è¦?è«‹æ±‚æ?¡ä»¶ã‚’è¿½åŠ ',0),(3920,109,'pt','Adicionar novos termos de factura',0),(3921,109,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð° Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ñ‹',0),(3922,109,'es','Agregar Nuevos TÃ©rminos de Factura',0),(3923,109,'de','FÃ¼gen Sie neue Begriffe in Rechnung',0),(3924,109,'en','Add New Invoice Terms',0),(3925,110,'is','',0),(3926,110,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(3927,110,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(3928,110,'tr','Yeni Ã–ÄŸe Ekle',0),(3929,110,'pl','Dodaj nowy element',0),(3930,110,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(3931,110,'ur','Ù†Ø¦ÛŒ Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(3932,110,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(3933,110,'vi','ThÃªm Má»¥c Má»›i',0),(3934,110,'af','Nuwe Item Byvoeg',0),(3935,110,'ro','Adauga Articol Nou',0),(3936,110,'et','Lisa uus toode',0),(3937,110,'si','Dodaj nov element',0),(3938,110,'ba','Menambah Item baru',0),(3939,110,'nl','Nieuw Item toevoegen',0),(3940,110,'fi','LisÃ¤Ã¤ uusi kohde',0),(3941,110,'no','Legg til nytt element',0),(3942,110,'da','TilfÃ¸j nyt element',0),(3943,110,'ko','ìƒˆ í•­ëª© ì¶”ê°€',0),(3944,110,'he','×”×•×¡×£ ×¤×¨×™×˜ ×—×“×©',0),(3945,110,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(3946,110,'zh','å¢žåŠ æ–°é¡¹\r\n',0),(3947,110,'sv','LÃ¤gga till nya objekt',0),(3948,110,'it','Aggiungi nuovo elemento',0),(3949,110,'tl','',0),(3950,110,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(3951,110,'hi','à¤¨à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3952,110,'ms','Tambah Item baru',0),(3953,110,'ar','Ø¥Ø¶Ø§ÙØ© ØµÙ†Ù Ø¬Ø¯ÙŠØ¯',0),(3954,110,'fr','Ajouter un nouvel Ã©lÃ©ment',0),(3955,110,'jp','æ–°è¦?å“?ç›®ã‚’è¿½åŠ ',0),(3956,110,'pt','Adicionar Novo Item',0),(3957,110,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ Ð¢Ð¾Ð²Ð°Ñ€',0),(3958,110,'es','Agregar Nuevo item',0),(3959,110,'de','Neues Element hinzufÃ¼gen',0),(3960,110,'en','Add New Item',0),(3961,111,'is','',0),(3962,111,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯',0),(3963,111,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯',0),(3964,111,'tr','Yeni Madde Kategori ekleme',0),(3965,111,'pl','Dodawanie nowych kategorii zapasu',0),(3966,111,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(3967,111,'ur','Ù†Ø¦ÛŒ Ø´Û’ Ø²Ù…Ø±Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(3968,111,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(3969,111,'vi','ThÃªm PhÃ¢n Loáº¡i Danh Má»¥c Má»›i',0),(3970,111,'af','Nuwe item kategorie Byvoeg',0),(3971,111,'ro','Adauga Categorie noua articole',0),(3972,111,'et','Lisa uus tootekategooria',0),(3973,111,'si','Dodaj nov element Kategorija',0),(3974,111,'ba','Tambahkan kategori barang baru',0),(3975,111,'nl','Toevoegen van nieuwe artikelcategorie',0),(3976,111,'fi','LisÃ¤Ã¤ uusi nimikeluokka',0),(3977,111,'no','Legg til ny varekategori',0),(3978,111,'da','TilfÃ¸je nye varekategori',0),(3979,111,'ko','ìƒˆë¡œìš´ í•­ëª© ë²”ì£¼ ì¶”ê°€',0),(3980,111,'he','×”×•×¡×£ ×§×˜×’×•×¨×™×™×ª ×¤×¨×™×˜×™× ×—×“×©×”',0),(3981,111,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ¹Î´ÏŽÎ½',0),(3982,111,'zh','å¢žåŠ æ–°çš„é¡¹ç›®ç±»åˆ«\r\n',0),(3983,111,'sv','LÃ¤gg till ny artikelkategori',0),(3984,111,'it','Aggiungi nuova voce categoria',0),(3985,111,'tl','',0),(3986,111,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(3987,111,'hi','à¤¨à¤ à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(3988,111,'ms','Tambah Kategori item baru',0),(3989,111,'ar','Ø¥Ø¶Ø§ÙØ© ØªØµÙ†ÙŠÙ Ø¬Ø¯ÙŠØ¯ Ù„Ù„ØµÙ†Ù',0),(3990,111,'fr','Ajouter le nouveau point catÃ©gorie',0),(3991,111,'jp','æ–°è¦?å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’è¿½åŠ ',0),(3992,111,'pt','Adicionar novo item de categoria',0),(3993,111,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²ÑƒÑŽ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(3994,111,'es','Agregar Nuevo item CategorÃ­a',0),(3995,111,'de','Neue Artikelkategorie hinzufÃ¼gen',0),(3996,111,'en','Add New item category',0),(3997,112,'is','',0),(3998,112,'dr','/ Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª ',0),(3999,112,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ / Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª ',0),(4000,112,'tr','Yeni madde satÄ±cÄ±/Kaydet deÄŸiÅŸiklikleri Ekle',0),(4001,112,'pl','Dodaj nowy element dostawcy/Zapisz zmiany',0),(4002,112,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº/Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ',0),(4003,112,'ur','Ù†Ø¦ÛŒ Ø´Û’ ÙˆÛŒÙ†ÚˆØ±/Ù…Ø­ÙÙˆØ¸ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4004,112,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°/Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(4005,112,'vi','ThÃªm Danh Má»¥c Má»›i Cho NgÆ°á»i BÃ¡n/Save Thay Äá»•i',0),(4006,112,'af','Nuwe Item Verskaffer/Stoor Veranderinge Byvoeg',0),(4007,112,'ro','AdÄƒugaÅ£i un element nou furnizor de salvaÅ£i modificÄƒrile',0),(4008,112,'et','Lisada uue kauba hankija/Salvesta muudatused',0),(4009,112,'si','Dodaj nov artikel dobavitelja/Shrani spremembe',0),(4010,112,'ba','Menambahkan baru Item Vendor/Simpan perubahan',0),(4011,112,'nl','Toevoegen van nieuwe Item leverancier/sparen veranderingen',0),(4012,112,'fi','LisÃ¤tÃ¤ uuden nimikkeen toimittajan/Tallenna muutokset',0),(4013,112,'no','Legg til ny leverandÃ¸r/lagre endringer',0),(4014,112,'da','TilfÃ¸je nye vare kreditor/Gem Ã¦ndringer',0),(4015,112,'ko','ìƒˆ í•­ëª© ê³µê¸‰ ì—…ì²´/ì €ìž¥ ë³€ê²½ ë‚´ìš©ì— ì¶”ê°€',0),(4016,112,'he','×”×•×¡×£ ×¡×¤×§ ×¤×¨×™×˜ ×—×“×©/×©×ž×•×¨ ×©×™× ×•×™×™×',0),(4017,112,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î½Î­ÎµÏ‚ Î±Î»Î»Î±Î³Î­Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®/Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(4018,112,'zh','å¢žåŠ æ–°é¡¹ç›®ä¾›åº”å•†/ä¿å­˜æ›´æ”¹\r\n',0),(4019,112,'sv','LÃ¤gga till nya objekt leverantÃ¶r/spara Ã¤ndringar',0),(4020,112,'it','Aggiungi nuovo elemento Vendor/Salva modifiche',0),(4021,112,'tl','',0),(4022,112,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;/&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(4023,112,'hi','à¤¨à¤ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾/à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4024,112,'ms','Tambah baru butiran penjual/simpan perubahan',0),(4025,112,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ±Ù‘Ø¯ Ø¬Ø¯ÙŠØ¯ Ù„Ù„ØµÙ†Ù/ ØªØ®Ø²ÙŠÙ† Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(4026,112,'fr','Ajouter le nouvel Ã©lÃ©ment du vendeur/Save change',0),(4027,112,'jp','æ–°è¦?å“?ç›®æ¥­è€…ã?®è¿½åŠ /å¤‰æ›´ã?®ä¿?å­˜',0),(4028,112,'pt','Adicionar Novo Item fornecedor/salvar alteraÃ§Ãµes',0),(4029,112,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ð³Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¢Ð¾Ð²Ð°Ñ€Ð°/Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(4030,112,'es','Agregar Nuevo Item Proveedor / Guardar Cambios',0),(4031,112,'de','FÃ¼gen Sie neue Lieferanten/Speichern Ã„nderungen',0),(4032,112,'en','Add New Item Vendor/Save Changes',0),(4033,113,'is','',0),(4034,113,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ø¬Ø¯ÙŠØ¯ ',0),(4035,113,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ø¬Ø¯ÙŠØ¯ ',0),(4036,113,'tr','Yeni konumu ekle',0),(4037,113,'pl','Dodaj nowÄ… lokalizacjÄ™',0),(4038,113,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(4039,113,'ur','Ù†ÛŒØ§ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4040,113,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(4041,113,'vi','ThÃªm Vá»‹ TrÃ­ Má»›i',0),(4042,113,'af','Nuwe Ligging Byvoeg',0),(4043,113,'ro','Adauga locatie noua',0),(4044,113,'et','Lisa uus asukoht',0),(4045,113,'si','Dodaj novo mesto',0),(4046,113,'ba','Tambahkan lokasi baru',0),(4047,113,'nl','Nieuwe locatie toevoegen',0),(4048,113,'fi','LisÃ¤Ã¤ uusi sijainti',0),(4049,113,'no','Legg til ny plassering',0),(4050,113,'da','TilfÃ¸j ny placering',0),(4051,113,'ko','ìƒˆ ìœ„ì¹˜ ì¶”ê°€',0),(4052,113,'he','×”×•×¡×£ ×ž×™×§×•× ×—×“×©',0),(4053,113,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î¸Î­ÏƒÎ·',0),(4054,113,'zh','å¢žåŠ æ–°ä½ç½®\r\n',0),(4055,113,'sv','LÃ¤gg till ny plats',0),(4056,113,'it','Aggiungi nuova posizione',0),(4057,113,'tl','',0),(4058,113,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;',0),(4059,113,'hi','à¤¨à¤¯à¤¾ à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4060,113,'ms','Menambah lokasi baru',0),(4061,113,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹ Ø¬Ø¯ÙŠØ¯',0),(4062,113,'fr','Ajouter le nouvel emplacement',0),(4063,113,'jp','æ–°è¦?ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ',0),(4064,113,'pt','Adicionar novo local',0),(4065,113,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ðµ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(4066,113,'es','Agregar Nueva UbicaciÃ³n',0),(4067,113,'de','Neuen Speicherort hinzufÃ¼gen',0),(4068,113,'en','Add New Location',0),(4069,114,'is','',0),(4070,114,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ø´ÙŠÙ† Ø¬Ø¯ÙŠØ¯ ',0),(4071,114,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ø´ÙŠÙ† Ø¬Ø¯ÙŠØ¯ ',0),(4072,114,'tr','Yeni makine ekleme',0),(4073,114,'pl','Dodaj nowÄ… maszynÄ™',0),(4074,114,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(4075,114,'ur','Ù†Ø¦ÛŒ Ù…Ø´ÛŒÙ† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4076,114,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ðµ',0),(4077,114,'vi','ThÃªm MÃ¡y Má»›i',0),(4078,114,'af','Nuwe Masjien Byvoeg',0),(4079,114,'ro','Adauga masina noua',0),(4080,114,'et','Lisa uus masin',0),(4081,114,'si','Dodajte novo stroj',0),(4082,114,'ba','Tambahkan mesin baru',0),(4083,114,'nl','Nieuwe Machine toevoegen',0),(4084,114,'fi','LisÃ¤Ã¤ uusi kone',0),(4085,114,'no','Legg til ny maskin',0),(4086,114,'da','TilfÃ¸je nye maskine',0),(4087,114,'ko','ìƒˆ ì»´í“¨í„° ì¶”ê°€',0),(4088,114,'he','×”×•×¡×£ ×ž×›×©×™×¨ ×—×“×©',0),(4089,114,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î¼Î·Ï‡Î±Î½Î®',0),(4090,114,'zh','å¢žåŠ æ–°æœº\r\n',0),(4091,114,'sv','LÃ¤gg till ny maskin',0),(4092,114,'it','Aggiungi nuova macchina',0),(4093,114,'tl','',0),(4094,114,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(4095,114,'hi','à¤¨à¤ˆ à¤®à¤¶à¥€à¤¨ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4096,114,'ms','Menambah Mesin baru',0),(4097,114,'ar','Ø¥Ø¶Ø§ÙØ© Ø¬Ù‡Ø§Ø² Ø¬Ø¯ÙŠØ¯',0),(4098,114,'fr','Ajouter la nouvelle Machine',0),(4099,114,'jp','æ–°è¦?æ©Ÿæ¢°ã‚’è¿½åŠ ',0),(4100,114,'pt','Adicionar nova mÃ¡quina',0),(4101,114,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹',0),(4102,114,'es','Agregar Nueva MÃ¡quina',0),(4103,114,'de','FÃ¼gen Sie neue Maschine',0),(4104,114,'en','Add New Machine',0),(4105,115,'is','',0),(4106,115,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† Ø¬Ø¯ÙŠØ¯',0),(4107,115,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† Ø¬Ø¯ÙŠØ¯',0),(4108,115,'tr','Yeni makine aile eklemek',0),(4109,115,'pl','Dodaj nowe maszyny rodziny',0),(4110,115,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(4111,115,'ur','Ù†Ø¦ÛŒ Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4112,115,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ñƒ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(4113,115,'vi','ThÃªm DÃ²ng MÃ¡y Gia ÄÃ¬nh Má»›i',0),(4114,115,'af','Voeg nuwe masjien familie',0),(4115,115,'ro','Adauga masina de familie noua',0),(4116,115,'et','Lisa uus masin perele',0),(4117,115,'si','Dodajte novo stroj druÅ¾ino',0),(4118,115,'ba','Tambahkan keluarga mesin baru',0),(4119,115,'nl','Toevoegen van nieuwe Machine familie',0),(4120,115,'fi','LisÃ¤Ã¤ uusi kone perhe',0),(4121,115,'no','Legge til nye maskin familien',0),(4122,115,'da','TilfÃ¸je nye maskine familie',0),(4123,115,'ko','ìƒˆë¡œìš´ ê¸°ê³„ ê°€ì¡± ì¶”ê°€',0),(4124,115,'he','×”×•×¡×£ ×ž×©×¤×—×ª ×ž×›×©×™×¨×™× ×—×“×©×”',0),(4125,115,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î¼Î·Ï‡Î±Î½Î® Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±',0),(4126,115,'zh','å¢žåŠ æ–°æœºç³»åˆ—\r\n',0),(4127,115,'sv','LÃ¤gg till ny maskin familj',0),(4128,115,'it','Aggiungere la nuova famiglia di macchina',0),(4129,115,'tl','',0),(4130,115,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(4131,115,'hi','à¤¨à¤ˆ à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4132,115,'ms','Tambah keluarga Mesin baru',0),(4133,115,'ar','Ø¥Ø¶Ø§ÙØ© Ø¬Ø¯ÙŠØ¯Ø© Ø¢Ù„Ø© Ø§Ù„Ø£Ø³Ø±Ø©',0),(4134,115,'fr','Ajouter la nouvelle famille de Machine',0),(4135,115,'jp','æ–°è¦?æ©Ÿæ¢°ç³»çµ±ã‚’è¿½åŠ ',0),(4136,115,'pt','Adicionar a nova famÃ­lia de mÃ¡quina',0),(4137,115,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ ÑÐµÐ¼ÑŒÐ¸',0),(4138,115,'es','Agregar Nueva Familia de MÃ¡quina',0),(4139,115,'de','FÃ¼gen Sie neue Maschine-Familie',0),(4140,115,'en','Add New Machine Family',0),(4141,116,'is','',0),(4142,116,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø±ÙˆØ´ Ø¬Ø¯ÙŠØ¯ ',0),(4143,116,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø±ÙˆØ´ Ø¬Ø¯ÙŠØ¯ ',0),(4144,116,'tr','Yeni bir yÃ¶ntem ekleme',0),(4145,116,'pl','Dodaj nowÄ… metodÄ™',0),(4146,116,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¼ÐµÑ‚Ð¾Ð´',0),(4147,116,'ur','Ø§ÛŒÚ© Ù†Ø¦Û’ Ø·Ø±ÛŒÙ‚Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4148,116,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð½Ð°Ñ‡Ð¸Ð½',0),(4149,116,'vi','ThÃªm PhÆ°Æ¡ng Thá»©c Má»›i',0),(4150,116,'af','\'n Nuwe Metode Byvoeg',0),(4151,116,'ro','Adauga modul nou',0),(4152,116,'et','Lisa uus meetod',0),(4153,116,'si','Dodati novo metodo',0),(4154,116,'ba','Menambahkan metode baru',0),(4155,116,'nl','Een nieuwe methode toevoegen',0),(4156,116,'fi','LisÃ¤Ã¤ uusi menetelmÃ¤',0),(4157,116,'no','Legge til en ny metode',0),(4158,116,'da','TilfÃ¸je en ny metode',0),(4159,116,'ko','ìƒˆ ë©”ì„œë“œ ì¶”ê°€',0),(4160,116,'he','×”×•×¡×£ ×©×™×˜×” ×—×“×©×”',0),(4161,116,'el','Î ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Î¹Î± Î½Î­Î± Î¼Î­Î¸Î¿Î´Î¿',0),(4162,116,'zh','å¢žåŠ ä¸€ä¸ªæ–°æ–¹æ³•\r\n',0),(4163,116,'sv','LÃ¤gga till en ny metod',0),(4164,116,'it','Aggiungere un nuovo metodo',0),(4165,116,'tl','',0),(4166,116,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;',0),(4167,116,'hi','à¤à¤• à¤¨à¤ˆ à¤µà¤¿à¤§à¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4168,116,'ms','Menambah kaedah baru',0),(4169,116,'ar','Ø£Ø¶Ù Ø·Ø±ÙŠÙ‚Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(4170,116,'fr','Ajoutez une nouvelle mÃ©thode',0),(4171,116,'jp','æ–°è¦?æ–¹æ³•ã‚’è¿½åŠ ',0),(4172,116,'pt','Adicionar um novo mÃ©todo',0),(4173,116,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¼ÐµÑ‚Ð¾Ð´',0),(4174,116,'es','Agregar un Nuevo MÃ©todo',0),(4175,116,'de','FÃ¼gen Sie eine neue Methode',0),(4176,116,'en','Add a New Method',0),(4177,117,'is','',0),(4178,117,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¹Ù…Ù„ÙŠØ§Øª Ø¬Ø¯ÙŠØ¯ ',0),(4179,117,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¹Ù…Ù„ÙŠØ§Øª Ø¬Ø¯ÙŠØ¯ ',0),(4180,117,'tr','Yeni iÅŸlem ekleme',0),(4181,117,'pl','Dodaj nowÄ… operacjÄ™',0),(4182,117,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ',0),(4183,117,'ur','Ù†ÛŒØ§ Ø¢Ù¾Ø±ÛŒØ´Ù† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4184,117,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(4185,117,'vi','ThÃªm Hoáº¡t Äá»™ng Má»›i',0),(4186,117,'af','Voeg nuwe bewerking',0),(4187,117,'ro','Adauga operatie noua',0),(4188,117,'et','Lisa uus tegevus',0),(4189,117,'si','Nov postopek dodajanja',0),(4190,117,'ba','Menambahkan baru operasi',0),(4191,117,'nl','Nieuwe transactie toevoegen',0),(4192,117,'fi','LisÃ¤Ã¤ uusi toiminto',0),(4193,117,'no','Legg til ny operasjon',0),(4194,117,'da','TilfÃ¸j ny Operation',0),(4195,117,'ko','ìƒˆ ìž‘ì—… ì¶”ê°€',0),(4196,117,'he','×”×•×¡×£ ×¤×¢×•×œ×” ×—×“×©×”',0),(4197,117,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(4198,117,'zh','å¢žåŠ æ–°çš„æ“ä½œ\r\n',0),(4199,117,'sv','LÃ¤gg till ny Operation',0),(4200,117,'it','Aggiungi nuova operazione',0),(4201,117,'tl','',0),(4202,117,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3591;&#3634;&#3609;',0),(4203,117,'hi','à¤¨à¤¯à¤¾ à¤…à¤­à¤¿à¤¯à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4204,117,'ms','Menambah operasi baru',0),(4205,117,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù…Ù„ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(4206,117,'fr','Ajouter nouvelle opÃ©ration',0),(4207,117,'jp','æ–°è¦?ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ',0),(4208,117,'pt','Adicionar nova operaÃ§Ã£o',0),(4209,117,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(4210,117,'es','Agregar Nueva OperaciÃ³n',0),(4211,117,'de','FÃ¼gen neuer Betrieb hinzu',0),(4212,117,'en','Add New Operation',0),(4213,118,'is','',0),(4214,118,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(4215,118,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(4216,118,'tr','Yeni Ã¶deme koÅŸullarÄ± ekleme',0),(4217,118,'pl','Dodawanie nowych terminÃ³w pÅ‚atnoÅ›ci',0),(4218,118,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(4219,118,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù†Ø¦ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4220,118,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(4221,118,'vi','ThÃªm Äiá»u Khoáº£n Thanh ToÃ¡n Má»›i',0),(4222,118,'af','Nuwe Betalingsterme Byvoeg',0),(4223,118,'ro','Agauga termen de plata nou',0),(4224,118,'et','Lisa uusi makse tingimusi',0),(4225,118,'si','Dodaj nov PlaÄilni pogoji',0),(4226,118,'ba','Menambahkan syarat-syarat pembayaran baru',0),(4227,118,'nl','Toevoegen van nieuwe betalingsvoorwaarden',0),(4228,118,'fi','LisÃ¤Ã¤ uusi maksuehdot',0),(4229,118,'no','Legge til nye betalingsbetingelser',0),(4230,118,'da','TilfÃ¸je nye betalingsbetingelser',0),(4231,118,'ko','ìƒˆë¡œìš´ ì§€ë¶ˆ ì¡°ê±´ ì¶”ê°€',0),(4232,118,'he','×”×•×¡×£ ×ª× ××™ ×ª×©×œ×•× ×—×“×©×™×',0),(4233,118,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î½Î­Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(4234,118,'zh','å¢žåŠ æ–°çš„æ”¯ä»˜æ¡æ¬¾\r\n',0),(4235,118,'sv','LÃ¤gg till nya betalningsvillkor',0),(4236,118,'it','Aggiungere nuovi termini di pagamento',0),(4237,118,'tl','',0),(4238,118,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(4239,118,'hi','à¤¨à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4240,118,'ms','Tambah terma-terma pembayaran yang baru',0),(4241,118,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙˆØ· Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(4242,118,'fr','Ajouter des nouvelles conditions de paiement',0),(4243,118,'jp','æ–°è¦?æ”¯æ‰•ã?„æ?¡ä»¶ã‚’è¿½åŠ ',0),(4244,118,'pt','Adicionar novos termos de pagamento',0),(4245,118,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(4246,118,'es','Agregar Nuevos TÃ©rminos de Pago',0),(4247,118,'de','FÃ¼gen Sie neue Zahlungsbedingungen',0),(4248,118,'en','Add New Payment Terms',0),(4249,119,'is','',0),(4250,119,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(4251,119,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(4252,119,'tr','Yeni Ã¶deme tipi Ekle',0),(4253,119,'pl','DodaÄ‡ nowy typ pÅ‚atnoÅ›ci',0),(4254,119,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð²Ð¸Ð´ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(4255,119,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù†Ø¦ÛŒ Ù‚Ø³Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4256,119,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸Ñ… Ð²Ñ€ÑÑ‚Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(4257,119,'vi','ThÃªm Loáº¡i Thanh ToÃ¡n Má»›i',0),(4258,119,'af','Nuwe Betalingstipe Byvoeg',0),(4259,119,'ro','Adauga noul tip de platÄƒ',0),(4260,119,'et','Lisa uus maks tÃ¼Ã¼p',0),(4261,119,'si','Dodati novo vrsto plaÄila',0),(4262,119,'ba','Menambahkan baru jenis pembayaran',0),(4263,119,'nl','Nieuwe betalingstype toevoegen',0),(4264,119,'fi','LisÃ¤Ã¤ uusi maksutapa',0),(4265,119,'no','Legge til nye betalingstypen',0),(4266,119,'da','TilfÃ¸j ny betalingsform',0),(4267,119,'ko','ìƒˆë¡œìš´ ê²°ì œ ìœ í˜• ì¶”ê°€',0),(4268,119,'he','×”×•×¡×£ ×¡×•×’ ×ª×©×œ×•× ×—×“×©',0),(4269,119,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï„ÏÏ€Î¿Ï… Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(4270,119,'zh','å¢žåŠ æ–°çš„ä»˜æ¬¾æ–¹å¼\r\n',0),(4271,119,'sv','LÃ¤gga till ny betalningstyp',0),(4272,119,'it','Aggiungere il nuovo tipo di pagamento',0),(4273,119,'tl','',0),(4274,119,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(4275,119,'hi','à¤¨à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4276,119,'ms','Tambah jenis pembayaran baru',0),(4277,119,'ar','Ø¥Ø¶Ø§ÙØ© Ø¬Ø¯ÙŠØ¯Ø© Ù…Ù† Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹',0),(4278,119,'fr','Ajout d\'un nouveau Type de paiement',0),(4279,119,'jp','æ–°è¦?æ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—ã‚’è¿½åŠ ',0),(4280,119,'pt','Adicionar o novo tipo de pagamento',0),(4281,119,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ Ð¢Ð¸Ð¿ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(4282,119,'es','Agregar Nuevo Tipo de Pago',0),(4283,119,'de','Neue Zahlungsart hinzufÃ¼gen',0),(4284,119,'en','Add New Payment Type',0),(4285,120,'is','',0),(4286,120,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ ',0),(4287,120,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ ',0),(4288,120,'tr','Yeni pasta',0),(4289,120,'pl','Nowy koÅ‚owy',0),(4290,120,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ð°Ð¹',0),(4291,120,'ur','Ù†Ø¦Û’ Ù¾Ø§Ø¦ÛŒ',0),(4292,120,'sr','ÐÐ¾Ð²Ð¸ ÐºÑ€ÑƒÐ¶Ð½Ð¸',0),(4293,120,'vi','Pie Má»›i',0),(4294,120,'af','Nuwe Sirkeldiagram',0),(4295,120,'ro','Noi Pie',0),(4296,120,'et','Uus sektordiagramm',0),(4297,120,'si','Nov Pie',0),(4298,120,'ba','Baru Pie',0),(4299,120,'nl','Nieuwe Pie',0),(4300,120,'fi','Uusi Pie',0),(4301,120,'no','Nye Pie',0),(4302,120,'da','Nye Pie',0),(4303,120,'ko','ìƒˆë¡œìš´ íŒŒì´',0),(4304,120,'he','×ª×¨×©×™× ×¢×•×’×” ×—×“×©',0),(4305,120,'el','ÎÎ­Î± Ï€Î¯Ï„Î±',0),(4306,120,'zh','æ–°æ‰‡å½¢å›¾\r\n',0),(4307,120,'sv','Nya paj',0),(4308,120,'it','Nuova torta',0),(4309,120,'tl','',0),(4310,120,'th','&#3648;&#3614;&#3636;&#3656;&#3617; Pie ',0),(4311,120,'hi','à¤¨à¤ˆ à¤ªà¤¾à¤ˆ',0),(4312,120,'ms','Pai baru',0),(4313,120,'ar','Ù…Ø®Ø·Ø· Ø¯Ø§Ø¦Ø±ÙŠ Ø¬Ø¯ÙŠØ¯',0),(4314,120,'fr','Nouvelle tarte',0),(4315,120,'jp','æ–°è¦?ãƒ‘ã‚¤',0),(4316,120,'pt','Torta de Nova',0),(4317,120,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¸Ñ€Ð¾Ð³',0),(4318,120,'es','Nueva Pastel',0),(4319,120,'de','Neue Pie',0),(4320,120,'en','New Pie',0),(4321,121,'is','',0),(4322,121,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø·Ø±Ø­ Ø¬Ø¯ÙŠØ¯ ',0),(4323,121,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø·Ø±Ø­ Ø¬Ø¯ÙŠØ¯ ',0),(4324,121,'tr','Yeni Plan ekleme',0),(4325,121,'pl','DodaÄ‡ nowy Plan',0),(4326,121,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¿Ð»Ð°Ð½',0),(4327,121,'ur','Ù†Ø¦ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4328,121,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ ÐŸÐ»Ð°Ð½',0),(4329,121,'vi','ThÃªm Káº¿ Hoáº¡ch Má»›i',0),(4330,121,'af','Nuwe Plan Byvoeg',0),(4331,121,'ro','Adauga noul Plan',0),(4332,121,'et','Lisa uus gaafik',0),(4333,121,'si','Dodaj nov naÄrt',0),(4334,121,'ba','Tambahkan rencana baru',0),(4335,121,'nl','Toevoegen van nieuwe Plan',0),(4336,121,'fi','LisÃ¤Ã¤ uusi suunnitelma',0),(4337,121,'no','Legg til ny Plan',0),(4338,121,'da','TilfÃ¸j ny Plan',0),(4339,121,'ko','ìƒˆë¡œìš´ ê³„íšì„ ì¶”ê°€',0),(4340,121,'he','×”×•×¡×£ ×ª×›× ×™×ª ×—×“×©×”',0),(4341,121,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ ÏƒÏ‡Î­Î´Î¹Î¿',0),(4342,121,'zh','å¢žåŠ æ–°è®¡åˆ’\r\n',0),(4343,121,'sv','LÃ¤gg till ny Plan',0),(4344,121,'it','Aggiungi nuovo piano',0),(4345,121,'tl','',0),(4346,121,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3649;&#3612;&#3609;&#3591;&#3634;&#3609;',0),(4347,121,'hi','à¤¨à¤ˆ à¤¯à¥‹à¤œà¤¨à¤¾ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4348,121,'ms','Tambah pelan baru',0),(4349,121,'ar','Ø¥Ø¶Ø§ÙØ© Ø®Ø·Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(4350,121,'fr','Ajouter nouveau Plan',0),(4351,121,'jp','æ–°è¦?ãƒ—ãƒ©ãƒ³ã‚’è¿½åŠ ',0),(4352,121,'pt','Adicionar novo plano',0),(4353,121,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ ÐŸÐ»Ð°Ð½',0),(4354,121,'es','Agregar Nuevo Plan',0),(4355,121,'de','FÃ¼gen neuen Plan hinzu',0),(4356,121,'en','Add New Plan',0),(4357,122,'is','',0),(4358,122,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ Ø¬Ø¯ÙŠØ¯',0),(4359,122,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ Ø¬Ø¯ÙŠØ¯',0),(4360,122,'tr','Yeni basÄ±n araÃ§ ekle',0),(4361,122,'pl','Dodaj nowe narzÄ™dzie',0),(4362,122,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ñ€ÐµÑÐ°Ñ‚Ð°',0),(4363,122,'ur','Ù¾Ø±ÛŒØ³ Ú©Û’ Ù†Ø¦Û’ Ø¢Ù„Û’ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4364,122,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð°Ð»Ð°Ñ‚ÐºÐµ Ð·Ð° Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ',0),(4365,122,'vi','ThÃªm CÃ´ng Cá»¥ In Má»›i',0),(4366,122,'af','Voeg nuwe Press instrument',0),(4367,122,'ro','AdÄƒuga nou instrument de presÄƒ',0),(4368,122,'et','Lisage uus stants',0),(4369,122,'si','Dodajte novo orodje za tisk',0),(4370,122,'ba','Menambahkan baru alat tekan',0),(4371,122,'nl','Nieuwe pers gereedschap toevoegen',0),(4372,122,'fi','LisÃ¤Ã¤ uusi puristustyÃ¶kalu',0),(4373,122,'no','Legge til nye trykk verktÃ¸yet',0),(4374,122,'da','TilfÃ¸je nye Press vÃ¦rktÃ¸j',0),(4375,122,'ko','ìƒˆë¡œìš´ ì••ë°• ë„êµ¬ ì¶”ê°€',0),(4376,122,'he','×œ×”×•×¡×™×£ ×›×œ×™ ×—×“×© ×©×œ ×¢×™×ª×•× ×•×ª',0),(4377,122,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ Ï„ÏÏ€Î¿Ï…',0),(4378,122,'zh','å¢žåŠ æ–°çš„æ–°é—»å·¥å…·\r\n',0),(4379,122,'sv','LÃ¤gg till ny Press verktyg',0),(4380,122,'it','Aggiungere il nuovo strumento di stampa',0),(4381,122,'tl','',0),(4382,122,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;&#3611;&#3640;&#3656;&#3617;&#3585;&#3604;',0),(4383,122,'hi','à¤¨à¤¯à¤¾ à¤ªà¥à¤°à¥‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4384,122,'ms','Menambah alat Seluar baru',0),(4385,122,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ø¯Ø§Ø© Ø¬Ø¯ÙŠØ¯Ø© Ù„Ù„ØµØ­Ø§ÙØ©',0),(4386,122,'fr','Ajouter le nouvel outil de presse',0),(4387,122,'jp','æ–°è¦?ãƒ—ãƒ¬ã‚¹ãƒ„ãƒ¼ãƒ«ã‚’è¿½åŠ ',0),(4388,122,'pt','Adicionar nova ferramenta de imprensa',0),(4389,122,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¿Ñ€ÐµÑÑ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚',0),(4390,122,'es','Agregar Nueva Herramienta de Prensa',0),(4391,122,'de','FÃ¼gen Sie neue Einpress-Hilfe',0),(4392,122,'en','Add New Press Tool',0),(4393,123,'is','',0),(4394,123,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ ',0),(4395,123,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ ',0),(4396,123,'tr','Yeni fiyat listesi ekleme',0),(4397,123,'pl','DodaÄ‡ nowy Cennik',0),(4398,123,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(4399,123,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4400,123,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(4401,123,'vi','ThÃªm Báº£ng GiÃ¡ Má»›i',0),(4402,123,'af','Nuwe Pryslys Byvoeg',0),(4403,123,'ro','Adauga lista de preturi',0),(4404,123,'et','Lisa uus hindadenimekiri',0),(4405,123,'si','Dodaj nov cenik',0),(4406,123,'ba','Tambahkan daftar harga baru',0),(4407,123,'nl','Nieuwe prijslijst toevoegen',0),(4408,123,'fi','LisÃ¤Ã¤ uuden hinnaston',0),(4409,123,'no','Legge til nye prisliste',0),(4410,123,'da','TilfÃ¸je nye prisliste',0),(4411,123,'ko','ìƒˆë¡œìš´ ê°€ê²© ëª©ë¡ ì¶”ê°€',0),(4412,123,'he','×”×•×¡×£ ×ž×—×™×¨×•×Ÿ ×—×“×©',0),(4413,123,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎÎ­Î¿Ï‚ Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎœÎ±Î¶Î¹ÎºÏŽÎ½ SMS',0),(4414,123,'zh','å¢žåŠ æ–°çš„ä»·æ ¼è¡¨\r\n',0),(4415,123,'sv','LÃ¤gg till ny prislista',0),(4416,123,'it','Aggiungere il nuovo listino prezzi',0),(4417,123,'tl','',0),(4418,123,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(4419,123,'hi','à¤¨à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4420,123,'ms','Tambah senarai harga baru',0),(4421,123,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(4422,123,'fr','Ajouter la nouvelle liste de prix',0),(4423,123,'jp','æ–°è¦?ä¾¡æ ¼è¡¨ã‚’è¿½åŠ ',0),(4424,123,'pt','Adicionar nova lista de preÃ§os',0),(4425,123,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(4426,123,'es','Agregar Nueva Lista de Precio',0),(4427,123,'de','FÃ¼gen Sie neue Preisliste',0),(4428,123,'en','Add New Price List',0),(4429,124,'is','',0),(4430,124,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(4431,124,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(4432,124,'tr','Yeni fiyat listesi stok Ekle',0),(4433,124,'pl','DodaÄ‡ nowy cena lista zapasÃ³w',0),(4434,124,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð²Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð²',0),(4435,124,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4436,124,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð° Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð° Ñ€Ð¾Ð±Ð°',0),(4437,124,'vi','ThÃªm Báº£ng GiÃ¡ Má»›i Cho HÃ ng ',0),(4438,124,'af','Nuwe Voorraad Pryslys Byvoeg',0),(4439,124,'ro','Adauga nou Pret lista stoc',0),(4440,124,'et','Lisage uus hind nimekirja Stock',0),(4441,124,'si','Dodajte nove cene seznam zalog',0),(4442,124,'ba','Tambahkan saham daftar harga baru',0),(4443,124,'nl','Voeg nieuwe prijs lijst voorraad',0),(4444,124,'fi','LisÃ¤Ã¤ uusi hinta luetteloon kalusto',0),(4445,124,'no','Legg nye pris liste lager',0),(4446,124,'da','TilfÃ¸j ny pris liste lager',0),(4447,124,'ko','ìƒˆë¡œìš´ ê°€ê²© ëª©ë¡ ì‚¬ì§„ ì¶”ê°€',0),(4448,124,'he','×”×•×¡×£ ×ž×œ××™ ×—×“×© ×©×œ ×¨×©×™×ž×ª ×ž×—×™×¨',0),(4449,124,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï…Î»Î¹ÎºÎ¿Ï Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½',0),(4450,124,'zh','å¢žåŠ æ–°çš„è‚¡ç¥¨ä»·æ ¼è¡¨',0),(4451,124,'sv','LÃ¤gg till ny pris lista materiel',0),(4452,124,'it','Aggiungi nuovo prezzo lista Stock',0),(4453,124,'tl','',0),(4454,124,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;',0),(4455,124,'hi','à¤¨à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4456,124,'ms','Tambah stok senarai harga baru',0),(4457,124,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø£Ø³Ù‡Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(4458,124,'fr','Ajouter nouveau Stock de liste de prix',0),(4459,124,'jp','æ–°è¦?ä¾¡æ ¼è¡¨ã?®ã‚¹ãƒˆãƒƒã‚¯ã‚’è¿½åŠ ',0),(4460,124,'pt','Adicionar novo estoque de lista de preÃ§o',0),(4461,124,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐ¾Ðº Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹',0),(4462,124,'es','Agregar Nueva Lista de Precio con Existencia',0),(4463,124,'de','FÃ¼gen Sie neuer Preis-Liste-Aktien hinzu',0),(4464,124,'en','Add New Price List Stock',0),(4465,125,'is','',0),(4466,125,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(4467,125,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(4468,125,'tr','Yeni fiyat listesi stok kullanÄ±mÄ± Ekle',0),(4469,125,'pl','Dodaj nowe ceny listy czas uÅ¼ytkowania',0),(4470,125,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ',0),(4471,125,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4472,125,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸Ñ… Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ',0),(4473,125,'vi','ThÃªm Báº£ng GiÃ¡ Má»›i Cho HÃ ng ÄÃ£ DÃ¹ng',0),(4474,125,'af','Nuwe Gebruikte Voorraad Pryslys Byvoeg',0),(4475,125,'ro','Adauga folosirea noilor Pret lista stoc',0),(4476,125,'et','Lisage uus hind nimekirja varude kasutamine',0),(4477,125,'si','Dodajte nove cene seznam zalog navada',0),(4478,125,'ba','Menambahkan baru harga daftar saham penggunaan',0),(4479,125,'nl','Toevoegen van nieuwe prijs lijst voorraad gebruik',0),(4480,125,'fi','LisÃ¤Ã¤ uusi hinta luetteloon kaluston kÃ¤yttÃ¶',0),(4481,125,'no','Legg til ny pris listen lagerforbruket',0),(4482,125,'da','TilfÃ¸j ny pris liste Stock skik',0),(4483,125,'ko','ìƒˆë¡œìš´ ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš© ì¶”ê°€',0),(4484,125,'he','×”×•×¡×£ ×—×“×© ×ž×—×™×¨ ×”×©×™×ž×•×© ×¨×©×™×ž×ª ×ž×œ××™',0),(4485,125,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î· Î½Î­Î± Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎ·',0),(4486,125,'zh','å¢žåŠ æ–°çš„è‚¡ç¥¨ä»·æ ¼è¡¨çš„ä½¿ç”¨\r\n',0),(4487,125,'sv','LÃ¤gg till ny pris lista lageranvÃ¤ndningen',0),(4488,125,'it','Aggiungi nuovo prezzo elenco uso magazzino',0),(4489,125,'tl','',0),(4490,125,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;',0),(4491,125,'hi','à¤¨à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4492,125,'ms','Tambah baru harga senarai stok penggunaan',0),(4493,125,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù…',0),(4494,125,'fr','Ajouter la nouvelle liste de prix utilisation Stock',0),(4495,125,'jp','æ–°è¦?ä¾¡æ ¼è¡¨ã?®ã‚¹ãƒˆãƒƒã‚¯ä½¿ç”¨æ³•ã‚’è¿½åŠ ',0),(4496,125,'pt','Adicionar novo uso estoque lista de preÃ§o',0),(4497,125,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐ¾Ðº Ð°ÐºÑ†Ð¸Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(4498,125,'es','Agregar Nueva Lista de Precio con uso de Existencia',0),(4499,125,'de','FÃ¼gen Sie neuer Preis Liste hat Verwendung hinzu',0),(4500,125,'en','Add New Price List Stock Usage',0),(4501,126,'is','',0),(4502,126,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(4503,126,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(4504,126,'tr','Yeni fiyat listesi stok kullanÄ±mÄ± Stok Listesi Ekle',0),(4505,126,'pl','DodaÄ‡ nowe listy towarowej zuÅ¼ycie zapasÃ³w Cennik',0),(4506,126,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² ÑÑŠÑÑ‚Ð°Ð² ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(4507,126,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ø³Ù¹Ø§Ú© Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4508,126,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(4509,126,'vi','ThÃªm Báº£ng GiÃ¡ Má»›i Cho Danh SÃ¡ch HÃ ng ÄÃ£ DÃ¹ng',0),(4510,126,'af','Nuwe Gebruikte Voorraad Pryslys Voorraadlys',0),(4511,126,'ro','Adauga noi Pret lista stoc utilizare stoc listÄƒ',0),(4512,126,'et','Lisa loetelu varude kasutamine varude hinnakiri',0),(4513,126,'si','Dodajte nov seznam zalog uporabe zalog cenik',0),(4514,126,'ba','Menambahkan baru harga saham penggunaan saham daftar',0),(4515,126,'nl','Nieuwe prijs lijst voorraad gebruik voorraad lijst toevoegen',0),(4516,126,'fi','LisÃ¤Ã¤ uuden luettelon kaluston kÃ¤yttÃ¶ varastossa hinnaston',0),(4517,126,'no','Legge til nye listen lagerforbruket lager prisliste',0),(4518,126,'da','TilfÃ¸j ny pris liste Stock skik lagerlisten',0),(4519,126,'ko','ìƒˆë¡œìš´ ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš© ìž¬ê³  ëª©ë¡ ì¶”ê°€',0),(4520,126,'he','×”×•×¡×£ ×¨×©×™×ž×” ×ž×—×™×¨ ×—×“×© ×¨×©×™×ž×ª ×©×™×ž×•×© ×ž× ×™×•×ª ×ž× ×™×•×ª',0),(4521,126,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Ï„Î¹Î¼Î® Î¼ÎµÏ„Î¿Ï‡Î®Ï‚ Ï‡ÏÎ®ÏƒÎ·Ï‚ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î»Î¯ÏƒÏ„Î±Ï‚',0),(4522,126,'zh','å¢žåŠ æ–°çš„ä»·æ ¼è¡¨åº“å­˜ä½¿ç”¨åº“å­˜åˆ—è¡¨\r\n',0),(4523,126,'sv','LÃ¤gg till ny lista lageranvÃ¤ndningen lager prislista',0),(4524,126,'it','Aggiungere nuovo listino lista Stock di magazzino uso',0),(4525,126,'tl','',0),(4526,126,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;',0),(4527,126,'hi','à¤¨à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥‚à¤šà¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4528,126,'ms','Tambah harga senarai penggunaan Stok Stok senarai baru',0),(4529,126,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(4530,126,'fr','Ajouter nouvelle liste utilisation Stock Stock liste de prix',0),(4531,126,'jp','æ–°è¦?ä¾¡æ ¼è¡¨ã?®ã‚¹ãƒˆãƒƒã‚¯ä½¿ç”¨æ³•ã?®ã‚¹ãƒˆãƒƒã‚¯ãƒªã‚¹ãƒˆã‚’è¿½åŠ ',0),(4532,126,'pt','Adicionar nova lista uso estoque estoque lista de preÃ§os',0),(4533,126,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº ÑˆÑ‚Ð¾ÐºÐ° Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² ÐŸÑ€ÐµÐ¹ÑÐºÑƒÑ€Ð°Ð½Ñ‚',0),(4534,126,'es','Agregar Nueva Lista de Precios de la Lista de uso de Existencias de la lista de Existencias',0),(4535,126,'de','FÃ¼gen Sie neuer Preis Liste Lager Lager Einsatzliste hinzu',0),(4536,126,'en','Add New Price List Stock Usage Stock List',0),(4537,127,'is','',0),(4538,127,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(4539,127,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(4540,127,'tr','Yeni satÄ±nalma sipariÅŸine Ekle',0),(4541,127,'pl','Dodaj nowe zamÃ³wienie zakupu',0),(4542,127,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(4543,127,'ur','Ù†Ø¦ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4544,127,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(4545,127,'vi','ThÃªm ÄÆ¡n Mua HÃ ng Má»›i',0),(4546,127,'af','Nuwe Aankoopbestelling Byvoeg',0),(4547,127,'ro','Adauga noua ordine de cumpÄƒrare',0),(4548,127,'et','Lisa uus ostutellimus',0),(4549,127,'si','Dodajte novo naroÄilnico',0),(4550,127,'ba','Menambahkan baru Order Pembelian',0),(4551,127,'nl','Toevoegen van nieuwe inkooporder',0),(4552,127,'fi','LisÃ¤Ã¤ uusi ostotilaus',0),(4553,127,'no','Legg til ny bestilling',0),(4554,127,'da','TilfÃ¸je nye indkÃ¸bsordre',0),(4555,127,'ko','ìƒˆë¡œìš´ ì£¼ë¬¸ì„œ ì¶”ê°€',0),(4556,127,'he','×”×•×¡×£ ×”×–×ž× ×ª ×¨×›×™×©×” ×—×“×©×”',0),(4557,127,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(4558,127,'zh','å¢žåŠ æ–°çš„é‡‡è´­è®¢å•\r\n',0),(4559,127,'sv','LÃ¤gg till ny inkÃ¶psorder',0),(4560,127,'it','Aggiungi nuovo ordine di acquisto',0),(4561,127,'tl','',0),(4562,127,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(4563,127,'hi','à¤¨à¤ˆ à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4564,127,'ms','Tambah pesanan pembelian baru',0),(4565,127,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù…Ø± Ø´Ø±Ø§Ø¡ Ø¬Ø¯ÙŠØ¯',0),(4566,127,'fr','Ajouter le nouveau bon de commande',0),(4567,127,'jp','æ–°ã?Ÿã?«ç™ºæ³¨æ›¸ã‚’è¿½åŠ ',0),(4568,127,'pt','Adicionar nova ordem de compra',0),(4569,127,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(4570,127,'es','Agregar Nuevo Pedido de Compra',0),(4571,127,'de','Neue Bestellung hinzufÃ¼gen',0),(4572,127,'en','Add New Purchase Order',0),(4573,128,'is','',0),(4574,128,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙˆØ§Ù„ Ø¬Ø¯ÙŠØ¯ ',0),(4575,128,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙˆØ§Ù„ Ø¬Ø¯ÙŠØ¯ ',0),(4576,128,'tr','Yeni soru ekleyin',0),(4577,128,'pl','Dodaj nowe pytanie',0),(4578,128,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð² Ð²ÑŠÐ¿Ñ€Ð¾Ñ',0),(4579,128,'ur','Ù†ÛŒØ§ Ø³ÙˆØ§Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4580,128,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¾ Ð¿Ð¸Ñ‚Ð°ÑšÐµ',0),(4581,128,'vi','ThÃªm CÃ¢u Há»i Má»›i',0),(4582,128,'af','Nuwe Vraag Byvoeg',0),(4583,128,'ro','Adauga intrebare noua',0),(4584,128,'et','Lisa uus kÃ¼simus',0),(4585,128,'si','Dodajte novo vpraÅ¡anje',0),(4586,128,'ba','Menambahkan pertanyaan baru',0),(4587,128,'nl','Nieuwe vraag toe te voegen',0),(4588,128,'fi','LisÃ¤Ã¤ uusi kysymys',0),(4589,128,'no','Legge til nye spÃ¸rsmÃ¥l',0),(4590,128,'da','TilfÃ¸je nye spÃ¸rgsmÃ¥l',0),(4591,128,'ko','ìƒˆ ì§ˆë¬¸ ì¶”ê°€',0),(4592,128,'he','×”×•×¡×£ ×©××œ×” ×—×“×©×”',0),(4593,128,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÎµÏÏŽÏ„Î·ÏƒÎ·',0),(4594,128,'zh','å¢žåŠ æ–°é—®é¢˜\r\n',0),(4595,128,'sv','LÃ¤gg till ny frÃ¥ga',0),(4596,128,'it','Aggiungi nuova domanda',0),(4597,128,'tl','',0),(4598,128,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3606;&#3634;&#3617;',0),(4599,128,'hi','à¤¨à¤ à¤¸à¤µà¤¾à¤² à¤œà¥‹à¤¡à¤¼',0),(4600,128,'ms','Tambah soalan baru',0),(4601,128,'ar','Ø¥Ø¶Ø§ÙØ© Ø³Ø¤Ø§Ù„ Ø¬Ø¯ÙŠØ¯',0),(4602,128,'fr','Ajouter nouvelle Question',0),(4603,128,'jp','æ–°è¦?è³ªå•?ã‚’è¿½åŠ ',0),(4604,128,'pt','Adicionar nova pergunta',0),(4605,128,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ Ð’Ð¾Ð¿Ñ€Ð¾Ñ',0),(4606,128,'es','Agregar Nueva Pregunta',0),(4607,128,'de','Neue Frage hinzufÃ¼gen',0),(4608,128,'en','Add New Question',0),(4609,129,'is','',0),(4610,129,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø¸Ø±Ø§Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(4611,129,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø¸Ø±Ø§Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(4612,129,'tr','Yeni tÄ±rnak yorum ekle',0),(4613,129,'pl','Dodaj nowy cytat komentarz',0),(4614,129,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(4615,129,'ur','Ù†ÛŒØ§ ØªØ¨ØµØ±Û Ø´Ø§Ù…Ù„ Ø¯ÙŠÙƒÚ¾ÙŠÚº:',0),(4616,129,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(4617,129,'vi','ThÃªm ChÃº ThÃ­ch Má»›i Cho BÃ¡o GiÃ¡',0),(4618,129,'af','Nuwe Kwotasie Kommentaar Byvoeg',0),(4619,129,'ro','AdÄƒuga noi citat comentariu',0),(4620,129,'et','Lisa uus kommentaar Quote',0),(4621,129,'si','Dodati novo ponudbo komentar',0),(4622,129,'ba','Tambah baru kutipan komentar',0),(4623,129,'nl','Citaat nieuwe reactie toevoegen',0),(4624,129,'fi','LisÃ¤Ã¤ uusi tarjoustuote kommentti',0),(4625,129,'no','Legge til nye tilbud kommentar',0),(4626,129,'da','TilfÃ¸j ny kÃ¸bsrekvisition kommentar',0),(4627,129,'ko','ìƒˆë¡œìš´ ì¸ìš© ì½”ë©˜íŠ¸ ì¶”ê°€',0),(4628,129,'he','×”×•×¡×£ ×”×¢×¨×” ×—×“×©×” ×œ×”×¦×¢×ª ×ž×—×™×¨',0),(4629,129,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(4630,129,'zh','å¢žåŠ æ–°çš„æŠ¥ä»·è¯„è®º\r\n',0),(4631,129,'sv','LÃ¤gg till ny citera kommentar',0),(4632,129,'it','Aggiungi nuovo preventivo commento',0),(4633,129,'tl','',0),(4634,129,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3588;&#3623;&#3634;&#3617;&#3648;&#3627;&#3655;&#3609;',0),(4635,129,'hi','à¤¨à¤¯à¤¾ à¤•à¥‹à¤Ÿ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4636,129,'ms','Tambah baru petikan komen',0),(4637,129,'ar','Ø¥Ø¶Ø§ÙØ© ØªØ¹Ù‚ÙŠØ¨ Ø¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ Ø¬Ø¯ÙŠØ¯',0),(4638,129,'fr','Ajouter un nouveau devis commentaire',0),(4639,129,'jp','æ–°è¦?è¦‹ç©?ã‚‚ã‚Šã‚³ãƒ¡ãƒ³ãƒˆã‚’è¿½åŠ ',0),(4640,129,'pt','Adicionar novo citar comentÃ¡rio',0),(4641,129,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹',0),(4642,129,'es','Agregar Nuevo Comentario a la CotizaciÃ³n',0),(4643,129,'de','Neues Zitat Kommentar hinzufÃ¼gen',0),(4644,129,'en','Add New Quote Comment',0),(4645,130,'is','',0),(4646,130,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¬Ø¯ÙŠØ¯',0),(4647,130,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¬Ø¯ÙŠØ¯',0),(4648,130,'tr','Yeni tÄ±rnak ekle Not',0),(4649,130,'pl','Dodaj nowy cytat Uwaga',0),(4650,130,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð²Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(4651,130,'ur','Ù†ÛŒØ§ Ø¯ÙŠÙƒÚ¾ÙŠÚº Ù†ÙˆÙ¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(4652,130,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(4653,130,'vi','ThÃªm Ghi ChÃº Má»›i Cho BÃ¡o GiÃ¡',0),(4654,130,'af','Nuwe Kwotasie Nota Byvoeg',0),(4655,130,'ro','AdÄƒuga noi citat NotÄƒ',0),(4656,130,'et','Lisa uus pakkumine ja MÃ¤rkus',0),(4657,130,'si','Dodati novo ponudbo Opomba',0),(4658,130,'ba','Tambah baru kutipan catatan',0),(4659,130,'nl','Citaat nieuwe notitie toevoegen',0),(4660,130,'fi','LisÃ¤Ã¤ uusi tarjoustuote Huomautus',0),(4661,130,'no','Legge til nye tilbud merknad',0),(4662,130,'da','TilfÃ¸j ny kÃ¸bsrekvisition BemÃ¦rk',0),(4663,130,'ko','ìƒˆë¡œìš´ ì¸ìš© ë©”ëª¨ ì¶”ê°€',0),(4664,130,'he','×”×•×¡×£ ×”×¢×¨×” ×—×“×©×” ×œ×”×¦×¢×ª ×ž×—×™×¨',0),(4665,130,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(4666,130,'zh','å¢žåŠ æ–°çš„æŠ¥ä»·è¯´æ˜Ž\r\n',0),(4667,130,'sv','LÃ¤gga till nya citat Obs',0),(4668,130,'it','Aggiungi nuovo citazione nota',0),(4669,130,'tl','',0),(4670,130,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(4671,130,'hi','à¤¨à¤¯à¤¾ à¤•à¥‹à¤Ÿ à¤¨à¥‹à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4672,130,'ms','Tambah baru petikan Nota',0),(4673,130,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø© Ø¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ Ø¬Ø¯ÙŠØ¯Ø©',0),(4674,130,'fr','Ajouter un nouveau devis Note',0),(4675,130,'jp','æ–°è¦?è¦‹ç©?ã‚‚ã‚Šãƒ¡ãƒ¢ã‚’è¿½åŠ ',0),(4676,130,'pt','Adicionar novo citaÃ§Ã£o nota',0),(4677,130,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñƒ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(4678,130,'es','Agregar Nueva Nota a la CotizaciÃ³n',0),(4679,130,'de','Neues Zitat Notiz hinzufÃ¼gen',0),(4680,130,'en','Add New Quote Note',0),(4681,131,'is','',0),(4682,131,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¬Ø¯ÙŠØ¯',0),(4683,131,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¬Ø¯ÙŠØ¯',0),(4684,131,'tr','Yeni gÃ¶zden geÃ§irme tÄ±rnak ekle',0),(4685,131,'pl','Dodaj nowy cytat zmiana',0),(4686,131,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð²Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ',0),(4687,131,'ur','Ù†ÛŒØ§ Ø§Ù‚ØªØ¨Ø§Ø³ Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4688,131,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ñƒ',0),(4689,131,'vi','Sá»­a Láº¡i BÃ¡o GiÃ¡ Má»›i',0),(4690,131,'af','Nuwe Kwotasie Nota Hersiening Byvoeg',0),(4691,131,'ro','AdÄƒuga noi citat revizuire',0),(4692,131,'et','Lisa tsitaat uus redaktsioon',0),(4693,131,'si','Dodati novo ponudbo revizije',0),(4694,131,'ba','Tambah baru kutipan revisi',0),(4695,131,'nl','Toevoegen van nieuwe citaat herziening',0),(4696,131,'fi','LisÃ¤Ã¤ uusi tarjoustuote tarkistaminen',0),(4697,131,'no','Legge til nye tilbud revisjon',0),(4698,131,'da','TilfÃ¸j ny kÃ¸bsrekvisition Revision',0),(4699,131,'ko','ê²¬ì  ìˆ˜ì • ìƒˆë¡œ ì¶”ê°€',0),(4700,131,'he','×”×•×¡×£ ×’×¨×¡×ª ×”×¦×¢×ª ×ž×—×™×¨ ×—×“×©×”',0),(4701,131,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Ï‰Î½ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(4702,131,'zh','å¢žåŠ æ–°çš„æŠ¥ä»·ä¿®è®¢\r\n',0),(4703,131,'sv','LÃ¤gg till ny offert Revision',0),(4704,131,'it','Aggiungi nuovo preventivo Revisione',0),(4705,131,'tl','',0),(4706,131,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(4707,131,'hi','à¤¨à¤¯à¤¾ à¤•à¥‹à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨',0),(4708,131,'ms','Tambah baru petikan semakan',0),(4709,131,'ar','Ø¥Ø¶Ø§ÙØ© ØªØ¹Ø¯ÙŠÙ„ Ø¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ Ø¬Ø¯ÙŠØ¯',0),(4710,131,'fr','Ajouter un nouveau devis rÃ©vision',0),(4711,131,'jp','æ–°è¦?è¦‹ç©?ã‚‚ã‚Šä¿®æ­£ã‚’è¿½åŠ ',0),(4712,131,'pt','Adicionar novo citaÃ§Ã£o revisÃ£o',0),(4713,131,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñƒ Ñ€ÐµÐ´Ð°ÐºÑ†Ð¸Ñ',0),(4714,131,'es','Agregar Nueva RevisiÃ³n de Nota a la CotizaciÃ³n',0),(4715,131,'de','FÃ¼gen Sie neue Zitat Revision',0),(4716,131,'en','Add New Quote Revision',0),(4717,132,'is','',0),(4718,132,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(4719,132,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(4720,132,'tr','Yeni gÃ¶zden geÃ§irme derecelendirme Ekle',0),(4721,132,'pl','Dodaj nowy PrzeglÄ…d Ocena',0),(4722,132,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(4723,132,'ur','Ù†Ø¦Û’ Ø±ÛŒÙˆÛŒÙˆ Ú©ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4724,132,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³ Ð·Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(4725,132,'vi','ÄÃ¡nh GiÃ¡ Má»›i',0),(4726,132,'af','Voeg nuwe oorsig gradering',0),(4727,132,'ro','Adauga noi de Rating de revizuire',0),(4728,132,'et','Lisa uus hinnang',0),(4729,132,'si','Dodajte nov pregled ocena',0),(4730,132,'ba','Menambahkan Rating Review baru',0),(4731,132,'nl','Voeg nieuwe beoordeling Rating',0),(4732,132,'fi','LisÃ¤Ã¤ uusi tarkastelu Luokitus',0),(4733,132,'no','Legg til ny vurdering vurdering',0),(4734,132,'da','TilfÃ¸je nye anmeldelse Rating',0),(4735,132,'ko','ìƒˆë¡œìš´ ê²€í†  ë“±ê¸‰ ì¶”ê°€',0),(4736,132,'he','×”×•×¡×£ ×“×™×¨×•×’ ×¡×§×™×¨×” ×—×“×©×”',0),(4737,132,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Î²Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î±Ï‚',0),(4738,132,'zh','å¢žåŠ æ–°è¯„è®ºè¯„çº§\r\n',0),(4739,132,'sv','LÃ¤gga till ny granskning betyg',0),(4740,132,'it','Aggiungi nuova recensione Voto',0),(4741,132,'tl','',0),(4742,132,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3629;&#3633;&#3605;&#3619;&#3634;',0),(4743,132,'hi','à¤¨à¤ˆ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤¦à¤°à¥à¤œà¤¼à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4744,132,'ms','Tambah baru kajian penilaian',0),(4745,132,'ar','Ø¥Ø¶Ø§ÙØ© ØªØµÙ†ÙŠÙ Ø§Ø³ØªØ¹Ø±Ø§Ø¶ Ø¬Ø¯ÙŠØ¯',0),(4746,132,'fr','Ajouter nouveau prix |',0),(4747,132,'jp','æ–°è¦?å¯©æŸ»è©•ä¾¡ã‚’è¿½åŠ ',0),(4748,132,'pt','Adicionar nova revisÃ£o de classificaÃ§Ã£o',0),(4749,132,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ð·Ñ‹Ð²',0),(4750,132,'es','Agregar nueva CalificaciÃ³n a la RevisiÃ³n',0),(4751,132,'de','Neue Review Bewertung hinzufÃ¼gen',0),(4752,132,'en','Add New Review Rating',0),(4753,133,'is','',0),(4754,133,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª ÙØ±ÙˆØ´ Ø¬Ø¯ÙŠØ¯ ',0),(4755,133,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª ÙØ±ÙˆØ´ Ø¬Ø¯ÙŠØ¯ ',0),(4756,133,'tr','Yeni satÄ±ÅŸ eylem Ekle',0),(4757,133,'pl','Dodaj nowÄ… akcjÄ™ sprzedaÅ¼y',0),(4758,133,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(4759,133,'ur','Ù†Ø¦ÛŒ ÙØ±ÙˆØ®Øª Ú©Û’ Ø¹Ù…Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4760,133,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(4761,133,'vi','ThÃªm HÃ nh Äá»™ng Sale Má»›i',0),(4762,133,'af','Nuwe Verkoopsaksie Byvoeg',0),(4763,133,'ro','Adauga noua acÅ£iune vÃ¢nzÄƒri',0),(4764,133,'et','Uute mÃ¼Ã¼gi toimingu lisamine',0),(4765,133,'si','Dodajte nove prodajne akcije',0),(4766,133,'ba','Menambahkan tindakan penjualan baru',0),(4767,133,'nl','Nieuwe verkoop actie toevoegen',0),(4768,133,'fi','LisÃ¤Ã¤ uusi myynti toiminto',0),(4769,133,'no','Legge nye salg',0),(4770,133,'da','TilfÃ¸je nye salg handling',0),(4771,133,'ko','ìƒˆë¡œìš´ íŒë§¤ ìž‘ì—… ì¶”ê°€',0),(4772,133,'he','×”×•×¡×£ ×¤×¢×•×œ×ª ×ž×›×™×¨×•×ª ×—×“×©×”',0),(4773,133,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î´ÏÎ¬ÏƒÎ· Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(4774,133,'zh','å¢žåŠ æ–°çš„é”€å”®åŠ¨ä½œ\r\n',0),(4775,133,'sv','LÃ¤gg till ny fÃ¶rsÃ¤ljning Ã¥tgÃ¤rd',0),(4776,133,'it','Aggiungi nuova azione di vendita',0),(4777,133,'tl','',0),(4778,133,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(4779,133,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4780,133,'ms','Menambah tindakan jualan baru',0),(4781,133,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø¬Ø±Ø§Ø¡ Ù…Ø¨ÙŠØ¹Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(4782,133,'fr','Ajouter Nouvelle Action vente',0),(4783,133,'jp','æ–°è¦?ã‚»ãƒ¼ãƒ«ã‚¹ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ',0),(4784,133,'pt','Adicionar nova aÃ§Ã£o de vendas',0),(4785,133,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(4786,133,'es','Agregar Nueva AcciÃ³n de Ventas',0),(4787,133,'de','FÃ¼gen Sie neue Verkaufs-Aktion',0),(4788,133,'en','Add New Sales Action',0),(4789,134,'is','',0),(4790,134,'dr','(Ø­Ø±Ø§Ø¬) Ø¬Ø¯ÙŠØ¯ ',0),(4791,134,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´ (Ø­Ø±Ø§Ø¬) Ø¬Ø¯ÙŠØ¯ ',0),(4792,134,'tr','Yeni satÄ±ÅŸ kategori ekleme',0),(4793,134,'pl','Dodawanie nowych kategorii sprzedaÅ¼y',0),(4794,134,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(4795,134,'ur','ÙØ±ÙˆØ®Øª Ú©Û’ Ù†Ø¦Û’ Ø²Ù…Ø±Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(4796,134,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(4797,134,'vi','ThÃªm PhÃ¢n Loáº¡i Sales Má»›i',0),(4798,134,'af','Nuwe Verkoopskategorie Byvoeg',0),(4799,134,'ro','Adauga Categorie vanzari',0),(4800,134,'et','Lisa uus mÃ¼Ã¼gikategooria',0),(4801,134,'si','Dodajte nove prodajne Kategorija',0),(4802,134,'ba','Tambahkan kategori penjualan baru',0),(4803,134,'nl','Nieuwe verkoop categorie toevoegen',0),(4804,134,'fi','LisÃ¤Ã¤ uusi myynti luokka',0),(4805,134,'no','Legge til nye salg kategori',0),(4806,134,'da','TilfÃ¸je nye salgskategori',0),(4807,134,'ko','ìƒˆë¡œìš´ íŒë§¤ ì¹´í…Œê³ ë¦¬ ì¶”ê°€',0),(4808,134,'he','×”×•×¡×£ ×§×˜×’×•×¨×™×™×ª ×ž×›×™×¨×•×ª ×—×“×©×”',0),(4809,134,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(4810,134,'zh','å¢žåŠ æ–°çš„é”€å”®ç±»åˆ«\r\n',0),(4811,134,'sv','LÃ¤gg till nya fÃ¶rsÃ¤ljningskategori',0),(4812,134,'it','Aggiungi nuova categoria Sales',0),(4813,134,'tl','',0),(4814,134,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(4815,134,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4816,134,'ms','Tambah Kategori jualan baru',0),(4817,134,'ar','Ø¥Ø¶Ø§ÙØ© ØªØµÙ†ÙŠÙ Ø¬Ø¯ÙŠØ¯ Ù„Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(4818,134,'fr','Ajouter nouvelle catÃ©gorie vente',0),(4819,134,'jp','æ–°è¦?ã‚»ãƒ¼ãƒ«ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’è¿½åŠ ',0),(4820,134,'pt','Adicionar nova categoria vendas',0),(4821,134,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²ÑƒÑŽ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(4822,134,'es','Agregar Nueva CategorÃ­a de Ventas',0),(4823,134,'de','Neue Sales-Kategorie hinzufÃ¼gen',0),(4824,134,'en','Add New Sales Category',0),(4825,135,'is','',0),(4826,135,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(4827,135,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(4828,135,'tr','Yeni bir satÄ±ÅŸ kiÅŸi ekleme',0),(4829,135,'pl','Dodaj nowÄ… osobÄ™ sprzedaÅ¼y',0),(4830,135,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð»Ð¸Ñ†Ðµ',0),(4831,135,'ur','Ù†Ø¦ÛŒ ÙØ±ÙˆØ®Øª Ø´Ø®Øµ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4832,135,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¾ÑÐ¾Ð±Ð°',0),(4833,135,'vi','ThÃªm NhÃ¢n ViÃªn Kinh Doanh Má»›i',0),(4834,135,'af','Nuwe Verkoopspersoon Byvoeg',0),(4835,135,'ro','Adauga noua persoanÄƒ de vÃ¢nzÄƒri',0),(4836,135,'et','Lisa uus mÃ¼Ã¼gimees',0),(4837,135,'si','Dodaj nov prodajalec',0),(4838,135,'ba','Menambahkan orang penjualan yang baru',0),(4839,135,'nl','Nieuwe verkoop persoon toevoegen',0),(4840,135,'fi','LisÃ¤Ã¤ uusi myyjÃ¤',0),(4841,135,'no','Legge til nye selger',0),(4842,135,'da','TilfÃ¸je nye salg Person',0),(4843,135,'ko','ìƒˆë¡œìš´ íŒë§¤ ì‚¬ëžŒ ì¶”ê°€',0),(4844,135,'he','×”×•×¡×£ ××™×© ×ž×›×™×¨×•×ª ×—×“×©',0),(4845,135,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î½Î­Î¿ Ï€ÏÏŒÏƒÏ‰Ï€Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(4846,135,'zh','å¢žåŠ æ–°çš„é”€å”®äººå“¡\r\n',0),(4847,135,'sv','LÃ¤gg till nya sÃ¤ljare',0),(4848,135,'it','Aggiungi nuova persona di vendite',0),(4849,135,'tl','',0),(4850,135,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(4851,135,'hi','à¤¨à¤ à¤µà¤¿à¤•à¥à¤°à¤¯à¤•à¤°à¥à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4852,135,'ms','Menambah orang jualan baru',0),(4853,135,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø®Øµ Ù…Ø¨ÙŠØ¹Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(4854,135,'fr','Ajouter Nouvelle vendeuse',0),(4855,135,'jp','æ–°è¦?ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…ã‚’è¿½åŠ ',0),(4856,135,'pt','Adicionar novo vendedor',0),(4857,135,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ð³Ð¾ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(4858,135,'es','Agregar Nuevo Vendedor',0),(4859,135,'de','FÃ¼gen neuer Vertriebsmitarbeiter hinzu',0),(4860,135,'en','Add New Sales Person',0),(4861,136,'is','',0),(4862,136,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ Ø¬Ø¯ÙŠØ¯',0),(4863,136,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ Ø¬Ø¯ÙŠØ¯',0),(4864,136,'tr','Yeni satÄ±ÅŸ iÅŸlemi Ekle',0),(4865,136,'pl','Dodawanie nowego procesu sprzedaÅ¼y',0),(4866,136,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(4867,136,'ur','Ù†Ø¦ÛŒ ÙØ±ÙˆØ®Øª Ú©Û’ Ø¹Ù…Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4868,136,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð³ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ°',0),(4869,136,'vi','ThÃªm Quy TrÃ¬nh BÃ¡n HÃ ng Má»›i',0),(4870,136,'af','Nuwe Verkoops Proses Byvoeg',0),(4871,136,'ro','Adauga nou proces de vÃ¢nzÄƒri',0),(4872,136,'et','Lisa uus mÃ¼Ã¼giprotsess',0),(4873,136,'si','Dodaj nov prodajni proces',0),(4874,136,'ba','Menambahkan baru proses penjualan',0),(4875,136,'nl','Toevoegen van nieuwe verkoopproces',0),(4876,136,'fi','LisÃ¤Ã¤ uusi myyntiprosessin',0),(4877,136,'no','Legge til nye salgsprosess',0),(4878,136,'da','TilfÃ¸je nye salgsproces',0),(4879,136,'ko','ìƒˆë¡œìš´ ì˜ì—… í”„ë¡œì„¸ìŠ¤ ì¶”ê°€',0),(4880,136,'he','×œ×”×•×¡×™×£ ×ª×”×œ×™×š ×ž×›×™×¨×•×ª ×—×“×©',0),(4881,136,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(4882,136,'zh','å¢žåŠ æ–°çš„é”€å”®è¿‡ç¨‹\r\n',0),(4883,136,'sv','LÃ¤gg till ny fÃ¶rsÃ¤ljningsprocess',0),(4884,136,'it','Aggiungere il nuovo processo di vendita',0),(4885,136,'tl','',0),(4886,136,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(4887,136,'hi','à¤¨à¤ˆ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥€ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4888,136,'ms','Menambah proses jualan baru',0),(4889,136,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù…Ù„ÙŠØ© Ù…Ø¨ÙŠØ¹Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(4890,136,'fr','Ajouter le nouveau processus de vente',0),(4891,136,'jp','æ–°è¦?ã‚»ãƒ¼ãƒ«ã‚¹æ‰‹é †ã‚’è¿½åŠ ',0),(4892,136,'pt','Adicionar novo processo de vendas',0),(4893,136,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ ÐŸÑ€Ð¾Ñ†ÐµÑÑ ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸',0),(4894,136,'es','Agregar Nuevo Procedimiento de Ventas',0),(4895,136,'de','FÃ¼gen neues Sales-Prozess hinzu',0),(4896,136,'en','Add New Sales Process',0),(4897,137,'is','',0),(4898,137,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¬Ø¯ÙŠØ¯',0),(4899,137,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¬Ø¯ÙŠØ¯',0),(4900,137,'tr','Yeni satÄ±ÅŸ vergisi',0),(4901,137,'pl','Nowy podatek',0),(4902,137,'bg','ÐÐ¾Ð² Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(4903,137,'ur','Ù†Ø¦Û’ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³',0),(4904,137,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(4905,137,'vi','ThÃªm Thuáº¿ BÃ¡n HÃ ng Má»›i',0),(4906,137,'af','Nuwe Verkoopsbelasting Byvoeg',0),(4907,137,'ro','Adauga taxa vanzari',0),(4908,137,'et','Lisa uus mÃ¼Ã¼gimaks',0),(4909,137,'si','Nov prometni davek',0),(4910,137,'ba','Pajak penjualan baru',0),(4911,137,'nl','Nieuwe Sales Tax',0),(4912,137,'fi','Uusi arvonlisÃ¤vero',0),(4913,137,'no','Nye mva',0),(4914,137,'da','Nye moms',0),(4915,137,'ko','ìƒˆë¡œìš´ íŒë§¤ ì„¸ê¸ˆ',0),(4916,137,'he','×”×•×¡×£ ×ž×¡ ×ž×›×™×¨×•×ª ×—×“×©',0),(4917,137,'el','ÎÎ­Î¿ Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(4918,137,'zh','å¢žåŠ æ–°çš„é”€å”®ç¨Ž\r\n',0),(4919,137,'sv','Ny moms',0),(4920,137,'it','Nuova imposta sulle vendite',0),(4921,137,'tl','',0),(4922,137,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(4923,137,'hi','à¤¨à¤ˆ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°',0),(4924,137,'ms','Baru cukai jualan',0),(4925,137,'ar','Ø¶Ø±ÙŠØ¨Ø© Ù…Ø¨ÙŠØ¹Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(4926,137,'fr','Nouvelle taxe de vente',0),(4927,137,'jp','æ–°è¦?å£²ä¸Šç¨Žã‚’è¿½åŠ ',0),(4928,137,'pt','Novo imposto sobre vendas',0),(4929,137,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ ÐÐ°Ð»Ð¾Ð³ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(4930,137,'es','Agregar Nuevo IVA ',0),(4931,137,'de','Neue Mehrwertsteuer',0),(4932,137,'en','New Sales Tax',0),(4933,138,'is','',0),(4934,138,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙØ±ÙˆØ´ Ø¬Ø¯ÙŠØ¯ ',0),(4935,138,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙØ±ÙˆØ´ Ø¬Ø¯ÙŠØ¯ ',0),(4936,138,'tr','Yeni satÄ±ÅŸ izleme giriÅŸi Ekle',0),(4937,138,'pl','Dodaj nowe sprzedaÅ¼y Å›ledzenia wpisu',0),(4938,138,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(4939,138,'ur','Ù†Ø¦ÛŒ ÙØ±ÙˆØ®Øª Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø³Ø±Ø§Øº Ø±Ø§Û Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4940,138,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ñ€Ð°Ñ›ÐµÑšÐ°',0),(4941,138,'vi','ThÃªm Entry Theo DÃµi Kinh Doanh Má»›i',0),(4942,138,'af','Voeg nuwe verkope dop inskrywing',0),(4943,138,'ro','Adauga noi vÃ¢nzÄƒri intrÄƒrii de urmÄƒrire',0),(4944,138,'et','Lisada uue mÃ¼Ã¼gi jÃ¤lgimise kanne',0),(4945,138,'si','Dodajte nove prodaje sledenje vnos',0),(4946,138,'ba','Menambahkan pelacakan entri penjualan yang baru',0),(4947,138,'nl','De verkoop van de nieuwe Tracking Entry toevoegen',0),(4948,138,'fi','LisÃ¤Ã¤ uusi myynti seurantatapahtuma',0),(4949,138,'no','Legge til nye Salet oppfÃ¸ring',0),(4950,138,'da','TilfÃ¸je nye salg sporing post',0),(4951,138,'ko','ìƒˆë¡œìš´ íŒë§¤ ì¶”ì  í•­ëª© ì¶”ê°€',0),(4952,138,'he','×œ×”×•×¡×™×£ ×ž×›×™×¨×•×ª ×—×“×©×™× ×ž×¢×§×‘ ×›× ×™×¡×”',0),(4953,138,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ Î¹Ï‡Î½Î·Î»Î±ÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î±Ï‚',0),(4954,138,'zh','å¢žåŠ æ–°çš„é”€å”®è·Ÿè¸ªæ¡ç›®\r\n',0),(4955,138,'sv','LÃ¤gg till ny fÃ¶rsÃ¤ljning spÃ¥rning post',0),(4956,138,'it','Aggiungere nuove vendite voce verifica',0),(4957,138,'tl','',0),(4958,138,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(4959,138,'hi','à¤¨à¤ˆ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4960,138,'ms','Menambah jualan baru menjejaki kemasukan',0),(4961,138,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¨ÙŠØ¹Ø§Øª Ø¬Ø¯ÙŠØ¯Ø© ØªØªØ¨Ø¹ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(4962,138,'fr','Ajouter lâ€™entrÃ©e de suivi des ventes nouvelles',0),(4963,138,'jp','æ–°è¦?ã‚»ãƒ¼ãƒ«ã‚¹æ´»å‹•å…¥åŠ›ã‚’è¿½åŠ ',0),(4964,138,'pt','Adicionar novas vendas entrada de controle',0),(4965,138,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(4966,138,'es','Agregar Nueva Entrada para Seguir la pista a las Ventas',0),(4967,138,'de','FÃ¼gen Sie neue Sales Tracking-Eintrag hinzu',0),(4968,138,'en','Add New Sales Tracking Entry',0),(4969,139,'is','',0),(4970,139,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(4971,139,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(4972,139,'tr','Yeni standart boyutu ekleme',0),(4973,139,'pl','DodaÄ‡ nowy rozmiar standardowy',0),(4974,139,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(4975,139,'ur','Ù†Ø¦ÛŒ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø³Ø§Ø¦Ø² Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(4976,139,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ðµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(4977,139,'vi','ThÃªm KÃ­ch Cá»¡ Chuáº©n Má»›i',0),(4978,139,'af','Nuwe Standaardgrootte Byvoeg',0),(4979,139,'ro','Adauga noi dimensiuni Standard',0),(4980,139,'et','Lisa uus standardmÃµÃµt',0),(4981,139,'si','Dodajanje novih standardnih velikosti',0),(4982,139,'ba','Menambahkan baru standar ukuran',0),(4983,139,'nl','Nieuw standaard formaat toevoegen',0),(4984,139,'fi','LisÃ¤Ã¤ uusi vakiokoko',0),(4985,139,'no','Legge til ny Standard stÃ¸rrelse',0),(4986,139,'da','TilfÃ¸je nye Standard stÃ¸rrelse',0),(4987,139,'ko','ìƒˆë¡œìš´ í‘œì¤€ í¬ê¸° ì¶”ê°€',0),(4988,139,'he','×”×•×¡×£ ×—×“×© ×‘×’×•×“×œ ×¡×˜× ×“×¨×˜×™',0),(4989,139,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚',0),(4990,139,'zh','å¢žåŠ æ–°çš„æ ‡å‡†å°ºå¯¸\r\n',0),(4991,139,'sv','LÃ¤gg till ny Standard storlek',0),(4992,139,'it','Aggiungi nuovo formato Standard',0),(4993,139,'tl','',0),(4994,139,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3609;&#3634;&#3604;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(4995,139,'hi','à¤¨à¤ à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(4996,139,'ms','Menambah saiz Standard yang baru',0),(4997,139,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø¬Ù… Ù‚ÙŠØ§Ø³ÙŠ Ø¬Ø¯ÙŠØ¯',0),(4998,139,'fr','Ajouter nouveau format Standard',0),(4999,139,'jp','æ–°è¦?æ¨™æº–ã‚µã‚¤ã‚ºã‚’è¿½åŠ ',0),(5000,139,'pt','Adicionar novo tamanho padrÃ£o',0),(5001,139,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð Ð°Ð·Ð¼ÐµÑ€',0),(5002,139,'es','Agregar Nuevo TamaÃ±o EstÃ¡ndar',0),(5003,139,'de','FÃ¼gen Sie neue StandardgrÃ¶ÃŸe',0),(5004,139,'en','Add New Standard Size',0),(5005,140,'is','',0),(5006,140,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¨Ø§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(5007,140,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¨Ø§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(5008,140,'tr','Yeni stok Ekle',0),(5009,140,'pl','Dodawanie nowych akcji',0),(5010,140,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÑÐºÐ»Ð°Ð´',0),(5011,140,'ur','Ù†ÛŒØ§ Ø§Ø³Ù¹Ø§Ú© Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5012,140,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ñƒ',0),(5013,140,'vi','ThÃªm HÃ ng Má»›i',0),(5014,140,'af','Nuwe Voorraad Byvoeg',0),(5015,140,'ro','AdÄƒugaÅ£i stoc nou',0),(5016,140,'et','Lisage uus Stock',0),(5017,140,'si','Dodajte nove zaloge',0),(5018,140,'ba','Tambahkan saham baru',0),(5019,140,'nl','Voeg nieuwe voorraad',0),(5020,140,'fi','LisÃ¤Ã¤ uusi kalusto',0),(5021,140,'no','Legg nye lager',0),(5022,140,'da','TilfÃ¸j nyt materiel',0),(5023,140,'ko','ìƒˆ ì‚¬ì§„ ì¶”ê°€',0),(5024,140,'he','×”×•×¡×£ ×ž×œ××™ ×—×“×©',0),(5025,140,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï…Î»Î¹ÎºÎ¿Ï',0),(5026,140,'zh','å¢žåŠ æ–°çš„è‚¡ç¥¨\r\n',0),(5027,140,'sv','LÃ¤gga till nya lager',0),(5028,140,'it','Aggiungi nuovo Stock',0),(5029,140,'tl','',0),(5030,140,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3605;&#3655;&#3629;&#3585;',0),(5031,140,'hi','à¤¨à¤ à¤¶à¥‡à¤¯à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5032,140,'ms','Menambah stok baru',0),(5033,140,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(5034,140,'fr','Ajouter le nouveau Stock',0),(5035,140,'jp','æ–°è¦?ã‚¹ãƒˆãƒƒã‚¯ã‚’è¿½åŠ ',0),(5036,140,'pt','Adicionar novo Stock',0),(5037,140,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ‚Ð¾Ð²Ð°Ñ€',0),(5038,140,'es','Agregar Nuevo Stock',0),(5039,140,'de','FÃ¼gen neuen Aktien hinzu',0),(5040,140,'en','Add New Stock',0),(5041,141,'is','',0),(5042,141,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯',0),(5043,141,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯',0),(5044,141,'tr','Yeni alt grup ekleme',0),(5045,141,'pl','Dodaj nowÄ… podgrupÄ™',0),(5046,141,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð°',0),(5047,141,'ur','Ù†Ø¦Û’ Ø³Ø¨Ú¯Ø±ÙˆÙ¾ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5048,141,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ñƒ',0),(5049,141,'vi','ThÃªm NhÃ³m Phá»¥ Má»›i',0),(5050,141,'af','Nuwe Sub-Groep Byvoeg',0),(5051,141,'ro','Adauga noi subgrup',0),(5052,141,'et','Lisa uus alagrupp',0),(5053,141,'si','Dodajte nove podskupine',0),(5054,141,'ba','Menambahkan baru subgrup',0),(5055,141,'nl','Toevoegen van nieuwe subgroep',0),(5056,141,'fi','LisÃ¤Ã¤ uusi aliryhmÃ¤',0),(5057,141,'no','Legge til nye undergruppe',0),(5058,141,'da','TilfÃ¸je nye undergruppe',0),(5059,141,'ko','ìƒˆë¡œìš´ í•˜ìœ„ ê·¸ë£¹ ì¶”ê°€',0),(5060,141,'he','×”×•×¡×£ ×§×‘×•×¦×ª ×ž×©× ×” ×—×“×©×”',0),(5061,141,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Ï…Ï€Î¿Î¿Î¼Î¬Î´Î±',0),(5062,141,'zh','å¢žåŠ æ–°çš„åˆ†ç»„\r\n',0),(5063,141,'sv','LÃ¤gg till ny undergrupp',0),(5064,141,'it','Aggiungi nuovo sottogruppo',0),(5065,141,'tl','',0),(5066,141,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(5067,141,'hi','à¤¨à¤ˆ à¤‰à¤ªà¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5068,141,'ms','Tambah baru subkumpulan',0),(5069,141,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø© ÙØ±Ø¹ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(5070,141,'fr','Ajouter nouveau sous-groupe',0),(5071,141,'jp','æ–°è¦?ã‚µãƒ–ã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ ',0),(5072,141,'pt','Adicionar novo subgrupo',0),(5073,141,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(5074,141,'es','Agregar Nuevo Subgrupo',0),(5075,141,'de','FÃ¼gen Sie neue Untergruppe',0),(5076,141,'en','Add New Subgroup',0),(5077,142,'is','',0),(5078,142,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(5079,142,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(5080,142,'tr','Yeni vergi muafiyeti',0),(5081,142,'pl','Nowe zwolnienie z podatku',0),(5082,142,'bg','ÐÐ¾Ð²Ð¸ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº',0),(5083,142,'ur','Ù†Ø¦Û’ Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(5084,142,'sr','ÐÐ¾Ð²Ð¸ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½Ð¾Ð³ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(5085,142,'vi','ThÃªmm Loáº¡i Thuáº¿ ÄÆ°á»£c Miá»…n Má»›i',0),(5086,142,'af','Nuwe Belastingvrystelling Byvoeg',0),(5087,142,'ro','Scutirea de impozit nou',0),(5088,142,'et','Lisa uus maksuvabastus',0),(5089,142,'si','Nove davÄne oprostitve',0),(5090,142,'ba','Pembebasan pajak baru',0),(5091,142,'nl','Nieuwe fiscale vrijstelling',0),(5092,142,'fi','Uusi verovapautus',0),(5093,142,'no','Nye skattefritak',0),(5094,142,'da','Nye skattefrihed',0),(5095,142,'ko','ìƒˆë¡œìš´ ì„¸ê¸ˆ ë©´ì œ',0),(5096,142,'he','×¤×˜×•×¨ ×ž×ž×¡ ×—×“×©',0),(5097,142,'el','ÎÎ­Î± Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Î±Ï€Î±Î»Î»Î±Î³Î®',0),(5098,142,'zh','å¢žåŠ æ–°çš„å…ç¨Žé¢\r\n',0),(5099,142,'sv','Nya skattebefrielse',0),(5100,142,'it','Nuova esenzione fiscale',0),(5101,142,'tl','',0),(5102,142,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(5103,142,'hi','à¤¨à¤¯à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤›à¥‚à¤Ÿ',0),(5104,142,'ms','Pengecualian cukai baru',0),(5105,142,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø¹ÙØ§Ø¡ Ø¶Ø±ÙŠØ¨ÙŠ Ø¬Ø¯ÙŠØ¯',0),(5106,142,'fr','Nouvelle dÃ©fiscalisation',0),(5107,142,'jp','æ–°è¦?èª²ç¨ŽæŽ§é™¤ã‚’è¿½åŠ ',0),(5108,142,'pt','Nova isenÃ§Ã£o de imposto',0),(5109,142,'ru','ÐÐ¾Ð²Ð¾Ðµ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(5110,142,'es','Agregar Nueva ExenciÃ³n',0),(5111,142,'de','Neue Steuerbefreiung',0),(5112,142,'en','New Tax Exemption',0),(5113,143,'is','',0),(5114,143,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(5115,143,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(5116,143,'tr','Yeni birim adÄ± Ekle',0),(5117,143,'pl','Dodaj nowÄ… nazwÄ™ jednostki',0),(5118,143,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð¸Ð¼Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(5119,143,'ur','ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ù†ÛŒØ§ Ù†Ø§Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5120,143,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¾ Ð¸Ð¼Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(5121,143,'vi','ThÃªm TÃªn ÄÆ¡n Vá»‹ Má»›i',0),(5122,143,'af','Nuwe Eenheidnaam Byvoeg',0),(5123,143,'ro','Adauga unitate noua',0),(5124,143,'et','Lisa uus Ã¼hikunimetus',0),(5125,143,'si','Dodajte novo enoto ime',0),(5126,143,'ba','Tambahkan nama Unit baru',0),(5127,143,'nl','Nieuwe eenheid naam toevoegen',0),(5128,143,'fi','LisÃ¤Ã¤ uuden yksikÃ¶n nimi',0),(5129,143,'no','Legge til nye navn',0),(5130,143,'da','TilfÃ¸j ny enhed navn',0),(5131,143,'ko','ìƒˆ ìž¥ì¹˜ ì´ë¦„ì„ ì¶”ê°€í•©ë‹ˆë‹¤',0),(5132,143,'he','×”×•×¡×£ ×©× ×™×—×™×“×” ×—×“×©',0),(5133,143,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ ÏŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î±',0),(5134,143,'zh','å¢žåŠ æ–°å•ä½åç§°\r\n',0),(5135,143,'sv','LÃ¤gg till ny enhet namn',0),(5136,143,'it','Aggiungi nuovo nome unitÃ ',0),(5137,143,'tl','',0),(5138,143,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3634;&#3618;',0),(5139,143,'hi','à¤¨à¤ˆ à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤¨à¤¾à¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5140,143,'ms','Tambah nama Unit baru',0),(5141,143,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(5142,143,'fr','Ajouter le nouveau nom de l\'unitÃ©',0),(5143,143,'jp','æ–°è¦?å?˜ä½?å??ã‚’è¿½åŠ ',0),(5144,143,'pt','Adicione o novo nome da unidade',0),(5145,143,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð³Ð¾ Ð±Ð»Ð¾ÐºÐ° Ð¸Ð¼ÐµÐ½Ð¸',0),(5146,143,'es','Agregar Nuevo Nombre de Unidad',0),(5147,143,'de','Neue Unit-Namen hinzufÃ¼gen',0),(5148,143,'en','Add New Unit Name',0),(5149,144,'is','',0),(5150,144,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø± Ø¬Ø¯ÙŠØ¯',0),(5151,144,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø± Ø¬Ø¯ÙŠØ¯',0),(5152,144,'tr','Yeni KullanÄ±cÄ± Ekle',0),(5153,144,'pl','Dodaj nowego uÅ¼ytkownika',0),(5154,144,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(5155,144,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº Ù†ÛŒØ§ ØµØ§Ø±Ù',0),(5156,144,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(5157,144,'vi','ThÃªm NgÆ°á»i Sá»­ Dá»¥ng Má»›i',0),(5158,144,'af','Nuwe Gebruiker Byvoeg',0),(5159,144,'ro','Adauga utilizator nou',0),(5160,144,'et','Lisa uus kasutaja',0),(5161,144,'si','Dodaj novega uporabnika',0),(5162,144,'ba','Menambahkan pengguna baru',0),(5163,144,'nl','Nieuwe gebruiker toevoegen',0),(5164,144,'fi','LisÃ¤Ã¤ uusi kÃ¤yttÃ¤jÃ¤',0),(5165,144,'no','Legg til ny bruker',0),(5166,144,'da','TilfÃ¸j ny bruger',0),(5167,144,'ko','ìƒˆ ì‚¬ìš©ìž ì¶”ê°€',0),(5168,144,'he','×”×•×¡×£ ×ž×©×ª×ž×© ×—×“×©',0),(5169,144,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï‡ÏÎ®ÏƒÏ„Î·',0),(5170,144,'zh','å¢žåŠ æ–°ç”¨æˆ·\r\n',0),(5171,144,'sv','LÃ¤gg till ny anvÃ¤ndare',0),(5172,144,'it','Aggiungi nuovo utente',0),(5173,144,'tl','',0),(5174,144,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(5175,144,'hi','à¤¨à¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5176,144,'ms','Menambah pengguna baru',0),(5177,144,'ar','Ø£Ø¶Ù Ù…Ø³ØªØ®Ø¯Ù… Ø¬Ø¯ÙŠØ¯',0),(5178,144,'fr','Ajouter un nouvel utilisateur',0),(5179,144,'jp','æ–°ã?Ÿã?ªãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’è¿½åŠ ',0),(5180,144,'pt','Adicionar novo usuÃ¡rio',0),(5181,144,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ð³Ð¾ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(5182,144,'es','Agregar Nuevo Usuario',0),(5183,144,'de','Neuen Benutzer hinzufÃ¼gen',0),(5184,144,'en','Add New User',0),(5185,145,'is','',0),(5186,145,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯',0),(5187,145,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯',0),(5188,145,'tr','Yeni tedarikÃ§i Ekle',0),(5189,145,'pl','Dodawanie nowego dostawcy',0),(5190,145,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(5191,145,'ur','Ù†Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5192,145,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸Ñ… Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(5193,145,'vi','ThÃªm NgÆ°á»i BÃ¡n Má»›i',0),(5194,145,'af','Nuwe Verskaffer Byvoeg',0),(5195,145,'ro','Adauga vanzator nou',0),(5196,145,'et','Lisa uus hakija',0),(5197,145,'si','Dodaj nov prodajalec',0),(5198,145,'ba','Menambahkan baru Vendor',0),(5199,145,'nl','Toevoegen van nieuwe leverancier',0),(5200,145,'fi','LisÃ¤Ã¤ uusi toimittaja',0),(5201,145,'no','Legg til ny leverandÃ¸r',0),(5202,145,'da','TilfÃ¸j ny leverandÃ¸r',0),(5203,145,'ko','ìƒˆ ê³µê¸‰ ì—…ì²´ ì¶”ê°€',0),(5204,145,'he','×”×•×¡×£ ×¡×¤×§ ×—×“×©',0),(5205,145,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(5206,145,'zh','å¢žåŠ æ–°ä¾›åº”å•†\r\n',0),(5207,145,'sv','LÃ¤gga till ny leverantÃ¶r',0),(5208,145,'it','Aggiungere nuovo fornitore',0),(5209,145,'tl','',0),(5210,145,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(5211,145,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5212,145,'ms','Tambah penjual baru',0),(5213,145,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ±Ù‘Ø¯ Ø¬Ø¯ÙŠØ¯',0),(5214,145,'fr','Ajoutez le nouveau fournisseur',0),(5215,145,'jp','æ–°è¦?æ¥­è€…ã‚’è¿½åŠ ',0),(5216,145,'pt','Adicionar novo fornecedor',0),(5217,145,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ð³Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(5218,145,'es','Agregar Nuevo Proveedor',0),(5219,145,'de','Neue Lieferanten hinzufÃ¼gen',0),(5220,145,'en','Add New Vendor',0),(5221,146,'is','',0),(5222,146,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯',0),(5223,146,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯',0),(5224,146,'tr','Yeni satÄ±cÄ± aÃ§Ä±sÄ±ndan',0),(5225,146,'pl','Nowych warunkÃ³w dostawcy',0),(5226,146,'bg','ÐÐ¾Ð²Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(5227,146,'ur','Ù†Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø·',0),(5228,146,'sr','ÐÐ¾Ð²Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(5229,146,'vi','ThÃªm Äiá»u Khoáº£n BÃ¡n HÃ ng Má»›i',0),(5230,146,'af','Nuwe Verskaffer Terme Byvoeg',0),(5231,146,'ro','Noul furnizor de termeni',0),(5232,146,'et','Lisa uus tarnetingimus',0),(5233,146,'si','Novi pogoji dobavitelja',0),(5234,146,'ba','Istilah Vendor baru',0),(5235,146,'nl','Nieuwe leverancier voorwaarden',0),(5236,146,'fi','Uudet toimittajan ehdot',0),(5237,146,'no','Ny leverandÃ¸r-vilkÃ¥r',0),(5238,146,'da','Ny leverandÃ¸r vilkÃ¥r',0),(5239,146,'ko','ìƒˆë¡œìš´ ê³µê¸‰ ì—…ì²´ ì¡°ê±´',0),(5240,146,'he','×”×•×¡×£ ×ª× ××™ ×¡×¤×§ ×—×“×©×™×',0),(5241,146,'el','ÎÎ­Î¿Î¹ ÏŒÏÎ¿Î¹ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(5242,146,'zh','å¢žåŠ æ–°çš„ä¾›åº”å•†æ¡æ¬¾\r\n',0),(5243,146,'sv','Nya villkor fÃ¶r leverantÃ¶r',0),(5244,146,'it','Nuovi termini di fornitore',0),(5245,146,'tl','',0),(5246,146,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(5247,146,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤°à¥à¤¤à¥‹à¤‚',0),(5248,146,'ms','Terma-terma penjual yang baru',0),(5249,146,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ù…ÙˆØ±Ù‘Ø¯ Ø¬Ø¯ÙŠØ¯Ø©',0),(5250,146,'fr','Nouvelles conditions de paiement du fournisseur',0),(5251,146,'jp','æ¥­è€…ã?®æ?¡ä»¶ã‚’è¿½åŠ ',0),(5252,146,'pt','Novos termos de fornecedor',0),(5253,146,'ru','ÐÐ¾Ð²Ñ‹Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(5254,146,'es','Agregar Nuevos TÃ©rminos de Proveedor',0),(5255,146,'de','Neuer Lieferant-Begriffe',0),(5256,146,'en','New Vendor Terms',0),(5257,147,'is','',0),(5258,147,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(5259,147,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(5260,147,'tr','Yeni iÅŸ tÃ¼rÃ¼ Ekle',0),(5261,147,'pl','DodaÄ‡ nowy typ pracy',0),(5262,147,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(5263,147,'ur','Ù†ÛŒØ§ Ú©Ø§Ù… Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5264,147,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸Ñ… Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(5265,147,'vi','ThÃªm Loáº¡i CÃ´ng Viá»‡c Má»›i',0),(5266,147,'af','Nuwe Werk Tipe Byvoeg',0),(5267,147,'ro','Adauga noul tip de munca',0),(5268,147,'et','Lisage uus tÃ¶Ã¶ tÃ¼Ã¼p',0),(5269,147,'si','Dodajanje nove vrste dela',0),(5270,147,'ba','Menambahkan baru jenis pekerjaan',0),(5271,147,'nl','Toevoegen van nieuwe werksoort',0),(5272,147,'fi','LisÃ¤Ã¤ uusi TyÃ¶tyyppi',0),(5273,147,'no','Legge til nye arbeidstype',0),(5274,147,'da','TilfÃ¸je nye arbejdstype',0),(5275,147,'ko','ìƒˆ ìž‘ì—… ìœ í˜• ì¶”ê°€',0),(5276,147,'he','×”×•×¡×£ ×¡×•×’ ×¢×‘×•×“×” ×—×“×©',0),(5277,147,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï„ÏÏ€Î¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(5278,147,'zh','å¢žåŠ æ–°çš„å·¥ä½œç±»åž‹\r\n',0),(5279,147,'sv','LÃ¤gg till nytt arbetstyp',0),(5280,147,'it','Aggiungere il nuovo tipo di lavoro',0),(5281,147,'tl','',0),(5282,147,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(5283,147,'hi','à¤¨à¤¯à¤¾ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5284,147,'ms','Tambah jenis kerja baru',0),(5285,147,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø¬Ø¯ÙŠØ¯ Ù…Ù† Ø§Ù„Ø¹Ù…Ù„',0),(5286,147,'fr','Ajouter le nouveau Type de travail',0),(5287,147,'jp','æ–°è¦?ä»•äº‹å†…å®¹ã‚’è¿½åŠ ',0),(5288,147,'pt','Adicionar o novo tipo de trabalho',0),(5289,147,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(5290,147,'es','Agregar Nuevo Tipo de Trabajo',0),(5291,147,'de','FÃ¼gen neuer Arbeitstyp hinzu',0),(5292,147,'en','Add New Work Type',0),(5293,148,'is','',0),(5294,148,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(5295,148,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(5296,148,'tr','AlÄ±ntÄ± Ekle',0),(5297,148,'pl','Dodaj ofertÄ™',0),(5298,148,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(5299,148,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5300,148,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(5301,148,'vi','ThÃªm BÃ¡o GiÃ¡',0),(5302,148,'af','Kwotasie Byvoeg',0),(5303,148,'ro','Adauga citat',0),(5304,148,'et','Lisa tsitaat',0),(5305,148,'si','Dodaj ponudbo',0),(5306,148,'ba','Menambahkan kutipan',0),(5307,148,'nl','Aanhalingstekens toevoegen',0),(5308,148,'fi','LisÃ¤Ã¤ lainaus',0),(5309,148,'no','Legge til sitat',0),(5310,148,'da','TilfÃ¸je tilbud',0),(5311,148,'ko','ê²¬ì  ì¶”ê°€',0),(5312,148,'he','×”×•×¡×£ ×”×¦×¢×ª ×ž×—×™×¨',0),(5313,148,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(5314,148,'zh','å¢žåŠ æŠ¥ä»·\r\n',0),(5315,148,'sv','LÃ¤gga till en offert',0),(5316,148,'it','Aggiungi citazione',0),(5317,148,'tl','',0),(5318,148,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;',0),(5319,148,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£ à¤šà¤¿à¤¹à¥à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5320,148,'ms','Tambah Quote',0),(5321,148,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ',0),(5322,148,'fr','Ajouter citation',0),(5323,148,'jp','è¦‹ç©?ã‚‚ã‚Šã‚’è¿½åŠ ',0),(5324,148,'pt','Adicionar citaÃ§Ã£o',0),(5325,148,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñƒ',0),(5326,148,'es','Agregar CotizaciÃ³n',0),(5327,148,'de','Zitat hinzufÃ¼gen',0),(5328,148,'en','Add Quote',0),(5329,149,'is','',0),(5330,149,'dr','/  Ø­Ø°Ù ',0),(5331,149,'pr','Ø§ÙØ²ÙˆØ¯Ù† /  Ø­Ø°Ù ',0),(5332,149,'tr','Ekle/KaldÄ±r',0),(5333,149,'pl','Dodaj/UsuÅ„',0),(5334,149,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ Ð½Ð°',0),(5335,149,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ÛÙ¹Ø§Ø¦ÛŒÚº',0),(5336,149,'sr','Ð”Ð¾Ð´Ð°Ñ˜/ÑƒÐºÐ»Ð¾Ð½Ð¸',0),(5337,149,'vi','ThÃªm/XÃ³a',0),(5338,149,'af','Byvoeg/Verwyder',0),(5339,149,'ro','AdÄƒugare/eliminare',0),(5340,149,'et','Lisa/Eemalda',0),(5341,149,'si','PoveÄati/premestitev',0),(5342,149,'ba','Tambah/Hapus',0),(5343,149,'nl','Toevoegen/verwijderen',0),(5344,149,'fi','LisÃ¤Ã¤ tai poista',0),(5345,149,'no','Legg til/fjern',0),(5346,149,'da','TilfÃ¸j/Fjern',0),(5347,149,'ko','ì¶”ê°€/ì œê±°',0),(5348,149,'he','×”×•×¡×£/×”×¡×¨',0),(5349,149,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎºÎ±Ï„Î¬ÏÎ³Î·ÏƒÎ·',0),(5350,149,'zh','å¢žåŠ /åˆ é™¤\r\n',0),(5351,149,'sv','LÃ¤gg till/ta bort',0),(5352,149,'it','Aggiungi/Rimuovi',0),(5353,149,'tl','',0),(5354,149,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3621;&#3610;',0),(5355,149,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚',0),(5356,149,'ms','Tambah/Alih Keluar',0),(5357,149,'ar','Ø¥Ø¶Ø§ÙØ©/Ø­Ø°Ù',0),(5358,149,'fr','Ajouter/supprimer',0),(5359,149,'jp','è¿½åŠ /æ¶ˆåŽ»',0),(5360,149,'pt','Adicionar/remover',0),(5361,149,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð£Ð±Ñ€Ð°Ñ‚ÑŒ',0),(5362,149,'es','Agregar/Eliminar',0),(5363,149,'de','HinzufÃ¼gen/entfernen',0),(5364,149,'en','Add/Remove',0),(5365,150,'is','',0),(5366,150,'dr','/ Ø­Ø°Ù Ø§Ø¬Ø²Ø§Ø¡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(5367,150,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø­Ø°Ù Ø§Ø¬Ø²Ø§Ø¡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(5368,150,'tr','SeÃ§ili bileÅŸen ekleme/kaldÄ±rma',0),(5369,150,'pl','Dodaj/UsuÅ„ wybrany element',0),(5370,150,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚',0),(5371,150,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ÛÙ¹Ø§Ø¦ÛŒÚº Ø¬Ø²Ùˆ Ù…Ù†ØªØ®Ø¨',0),(5372,150,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /Ð£ÐºÐ»Ð¾Ð½Ð¸ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ðµ',0),(5373,150,'vi','ThÃªm/XÃ³a CÃ¡c ThÃ nh Pháº§n ÄÃ£ Chá»n',0),(5374,150,'af','Geselekteerde Komponent Byvoeg/Verwyder',0),(5375,150,'ro','AdÄƒugare/eliminare componente selectate',0),(5376,150,'et','Lisa/Eemalda valitud komponendi',0),(5377,150,'si','Dodaj/Odstrani izbrane komponente',0),(5378,150,'ba','Tambah/Hapus dipilih komponen',0),(5379,150,'nl','Geselecteerde Component toevoegen/verwijderen',0),(5380,150,'fi','LisÃ¤Ã¤/Poista valitun osan',0),(5381,150,'no','Legg til/fjern valgte komponenten',0),(5382,150,'da','TilfÃ¸j/Fjern markerede komponent',0),(5383,150,'ko','ì„ íƒí•œ êµ¬ì„± ìš”ì†Œ ì¶”ê°€/ì œê±°',0),(5384,150,'he','×”×•×¡×¤×”/×”×¡×¨×” ×©×œ ×”×¨×›×™×‘ ×©× ×‘×—×¨',0),(5385,150,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎºÎ±Ï„Î¬ÏÎ³Î·ÏƒÎ· Ï„Î¿Ï… ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(5386,150,'zh','å¢žåŠ /åˆ é™¤æ‰€é€‰ç»„ä»¶\r\n',0),(5387,150,'sv','LÃ¤gg till/ta bort valda komponenten',0),(5388,150,'it','Aggiungere o rimuovere un componente selezionato',0),(5389,150,'tl','',0),(5390,150,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3621;&#3610; &#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(5391,150,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤˜à¤Ÿà¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚',0),(5392,150,'ms','Tambah/Alih keluar komponen terpilih',0),(5393,150,'ar','Ø¥Ø¶Ø§ÙØ©/Ø­Ø°Ù Ø§Ù„Ù…ÙƒÙˆÙ‘Ù†Ø© Ø§Ù„Ù…Ø­Ø¯Ù‘Ø¯Ø©',0),(5394,150,'fr','Ajouter/supprimer des composant sÃ©lectionnÃ©',0),(5395,150,'jp','é?¸æŠžã?•ã‚Œã?Ÿã‚³ãƒ³ãƒ?ãƒ¼ãƒ?ãƒ³ãƒˆã‚’è¿½åŠ /æ¶ˆåŽ»',0),(5396,150,'pt','Adicionar ou remover o componente selecionado',0),(5397,150,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð£Ð±Ñ€Ð°Ñ‚ÑŒ Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ð¹ ÐšÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚',0),(5398,150,'es','Agregar/Eliminar Componente Selccionado',0),(5399,150,'de','AusgewÃ¤hlte Komponente hinzufÃ¼gen/entfernen',0),(5400,150,'en','Add/Remove Selected Component',0),(5401,151,'is','',0),(5402,151,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø±Ø¯ÙŠÙ',0),(5403,151,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø±Ø¯ÙŠÙ',0),(5404,151,'tr','SatÄ±r Ekle',0),(5405,151,'pl','Dodaj wiersz',0),(5406,151,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€ÐµÐ´',0),(5407,151,'ur','ØµÙ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(5408,151,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ€ÐµÐ´Ð°',0),(5409,151,'vi','ThÃªm DÃ²ng',0),(5410,151,'af','Ry Byvoeg',0),(5411,151,'ro','Adauga rÃ¢nd',0),(5412,151,'et','Rea lisamine',0),(5413,151,'si','Dodaj vrstico',0),(5414,151,'ba','Tambahkan baris',0),(5415,151,'nl','Rij toevoegen',0),(5416,151,'fi','LisÃ¤Ã¤ rivi',0),(5417,151,'no','Legge til rad',0),(5418,151,'da','TilfÃ¸j rÃ¦kke',0),(5419,151,'ko','í–‰ ì¶”ê°€',0),(5420,151,'he','×”×•×¡×£ ×©×•×¨×”',0),(5421,151,'el','Î ÏÎ¿ÏƒÎ¸.',0),(5422,151,'zh','å¢žåŠ è¡Œ\r\n',0),(5423,151,'sv','LÃ¤gg till rad',0),(5424,151,'it','Aggiungere la riga',0),(5425,151,'tl','',0),(5426,151,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3649;&#3606;&#3623;',0),(5427,151,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5428,151,'ms','Tambah berturut-turut',0),(5429,151,'ar','Ø¥Ø¶Ø§ÙØ© ØµÙ',0),(5430,151,'fr','Ajout de ligne',0),(5431,151,'jp','æ¨ªã?®åˆ—ã‚’è¿½åŠ ',0),(5432,151,'pt','Adicionar linha',0),(5433,151,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾ÐºÑƒ',0),(5434,151,'es','Agregar fila',0),(5435,151,'de','Zeile hinzufÃ¼gen',0),(5436,151,'en','Add row',0),(5437,152,'is','',0),(5438,152,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(5439,152,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(5440,152,'tr','SatÄ±ÅŸ kiÅŸi ekleme',0),(5441,152,'pl','Dodaj osobÄ™ sprzedaÅ¼y',0),(5442,152,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»Ð¸Ñ†Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(5443,152,'ur','Ø³ÛŒÙ„Ø² Ø´Ø®Øµ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5444,152,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¾ÑÐ¾Ð±Ð°',0),(5445,152,'vi','ThÃªm NhÃ¢n ViÃªn Kinh Doanh',0),(5446,152,'af','Verkoopspersoon Byvoeg',0),(5447,152,'ro','Adauga persoanÄƒ de vÃ¢nzÄƒri',0),(5448,152,'et','Lisa mÃ¼Ã¼gimees',0),(5449,152,'si','Dodaj pultom',0),(5450,152,'ba','Menambahkan orang penjualan',0),(5451,152,'nl','Verkoop persoon toevoegen',0),(5452,152,'fi','LisÃ¤Ã¤ myyjÃ¤',0),(5453,152,'no','Legge til selger',0),(5454,152,'da','TilfÃ¸je salg Person',0),(5455,152,'ko','ì˜ì—… ì§ì›ì„ ì¶”ê°€',0),(5456,152,'he','×”×•×¡×£ ××™×© ×ž×›×™×¨×•×ª',0),(5457,152,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï€ÏÏŒÏƒÏ‰Ï€Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(5458,152,'zh','å¢žåŠ é”€å”®äººå‘˜\r\n',0),(5459,152,'sv','LÃ¤gg till sÃ¤ljare',0),(5460,152,'it','Aggiungi persona di vendite',0),(5461,152,'tl','',0),(5462,152,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(5463,152,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5464,152,'ms','Menambah orang jualan',0),(5465,152,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù†Ø¯ÙˆØ¨ Ù…Ø¨ÙŠØ¹Ø§Øª',0),(5466,152,'fr','Ajouter Sales Person',0),(5467,152,'jp','ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…ã‚’è¿½åŠ ',0),(5468,152,'pt','Adicionar a pessoa de vendas',0),(5469,152,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°Ð¼',0),(5470,152,'es','Agregar Vendedor',0),(5471,152,'de','Vertriebsmitarbeiter hinzufÃ¼gen',0),(5472,152,'en','Add Sales Person',0),(5473,153,'is','',0),(5474,153,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(5475,153,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(5476,153,'tr','SatÄ±cÄ± Ekle',0),(5477,153,'pl','DodaÄ‡ sprzedawca',0),(5478,153,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡',0),(5479,153,'ur','Ø¨Ù†Ø§Ú©Ø± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5480,153,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(5481,153,'vi','ThÃªm NhÃ¢n ViÃªn Kinh Doanh',0),(5482,153,'af','Verkoopspersoon Byvoeg',0),(5483,153,'ro','Adauga vanzator',0),(5484,153,'et','Lisa mÃ¼Ã¼gimees',0),(5485,153,'si','Dodaj prodajalec',0),(5486,153,'ba','Tambahkan Salesman',0),(5487,153,'nl','Verkoper toevoegen',0),(5488,153,'fi','LisÃ¤Ã¤ myyjÃ¤',0),(5489,153,'no','Legge til selger',0),(5490,153,'da','TilfÃ¸je sÃ¦lger',0),(5491,153,'ko','ì„¸ì¼ì¦ˆ ë§¨ì„ ì¶”ê°€',0),(5492,153,'he','×”×•×¡×£ ××™×© ×ž×›×™×¨×•×ª',0),(5493,153,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€Ï‰Î»Î·Ï„Î®Ï‚',0),(5494,153,'zh','å¢žåŠ æŽ¨é”€å‘˜\r\n',0),(5495,153,'sv','LÃ¤gg till sÃ¤ljare',0),(5496,153,'it','Aggiungi venditore',0),(5497,153,'tl','',0),(5498,153,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(5499,153,'hi','à¤¸à¥‡à¤²à¥à¤¸à¤®à¥‡à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5500,153,'ms','Tambah jurujual',0),(5501,153,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ø§Ø¦Ø¹',0),(5502,153,'fr','Ajouter vendeur',0),(5503,153,'jp','ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…ã‚’è¿½åŠ ',0),(5504,153,'pt','Adicionar vendedor',0),(5505,153,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(5506,153,'es','Agregar Vendedor',0),(5507,153,'de','VerkÃ¤ufer hinzufÃ¼gen',0),(5508,153,'en','Add Salesman',0),(5509,154,'is','',0),(5510,154,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(5511,154,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(5512,154,'tr','Komisyonu verisi eklemek',0),(5513,154,'pl','Dodawanie danych Komisji',0),(5514,154,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð´Ð°Ð½Ð½Ð¸',0),(5515,154,'ur','Ú©Ù…ÛŒØ´Ù† Ú©ÙˆØ§Ø¦Ù Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5516,154,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð°',0),(5517,154,'vi','ThÃªm Dá»¯ Liá»‡u Vá» Hoa Há»“ng',0),(5518,154,'af','Komissiedata Byvoeg',0),(5519,154,'ro','Adauga Comisiei date',0),(5520,154,'et','Komisjonile andmete lisamine',0),(5521,154,'si','Dodajanje podatkov Komisiji',0),(5522,154,'ba','Menambahkan Data komisi',0),(5523,154,'nl','Commissie gegevens toevoegen',0),(5524,154,'fi','LisÃ¤Ã¤ komissiolle tiedot',0),(5525,154,'no','Legge til provisjonsdata',0),(5526,154,'da','TilfÃ¸je Kommissionen Data',0),(5527,154,'ko','ìœ„ì›íšŒ ë°ì´í„° ì¶”ê°€',0),(5528,154,'he','×œ×”×•×¡×™×£ × ×ª×•× ×™× ×”× ×¦×™×‘×•×ª',0),(5529,154,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(5530,154,'zh','å¢žåŠ ä½£é‡‘æ•°æ®\r\n',0),(5531,154,'sv','LÃ¤gg till kommissionens uppgifter',0),(5532,154,'it','Aggiungere dati Commissione',0),(5533,154,'tl','',0),(5534,154,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(5535,154,'hi','à¤†à¤¯à¥‹à¤— à¤¡à¥‡à¤Ÿà¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5536,154,'ms','Menambah Data Suruhanjaya',0),(5537,154,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨ÙŠØ§Ù†Ø§Øª Ø¹Ù…ÙˆÙ„Ø§Øª',0),(5538,154,'fr','Ajouter des donnÃ©es de la Commission',0),(5539,154,'jp','ã‚³ãƒŸãƒƒã‚·ãƒ§ãƒ³ãƒ‡ãƒ¼ã‚¿ã‚’è¿½åŠ ',0),(5540,154,'pt','Adicionar dados de ComissÃ£o',0),(5541,154,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ðµ ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(5542,154,'es','Agregar Datos de Comisiones',0),(5543,154,'de','Kommission Daten hinzufÃ¼gen',0),(5544,154,'en','Add Commission Data',0),(5545,155,'is','',0),(5546,155,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ùˆ Ù†Ø±Ø® Ø¬Ø¯ÙŠØ¯ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(5547,155,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ùˆ Ù†Ø±Ø® Ø¬Ø¯ÙŠØ¯ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(5548,155,'tr','Yeni satÄ±ÅŸ vergisi tÃ¼rÃ¼ ve hÄ±zÄ± ekleyin',0),(5549,155,'pl','DodaÄ‡ nowy typ podatku i stopy',0),(5550,155,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿ Ð¸ ÑÐºÐ¾Ñ€Ð¾ÑÑ‚',0),(5551,155,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù†Ø¦ÛŒ Ù‚Ø³Ù… Ø§ÙˆØ± Ø´Ø±Ø­ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5552,155,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ñ‚Ð¸Ð¿ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¸ ÑÑ‚Ð¾Ð¿Ð°',0),(5553,155,'vi','ThÃªm Loáº¡i Thuáº¿ BÃ¡n HÃ ng Má»›i vÃ  Biá»ƒu Thuáº¿',0),(5554,155,'af','Nuwe Verkoopsbelastingtipe en Koers Byvoeg',0),(5555,155,'ro','Adauga noul tip de impozitul pe vÃ¢nzÄƒri ÅŸi rata',0),(5556,155,'et','Lisa uus mÃ¼Ã¼gimaksu liik ja mÃ¤Ã¤r',0),(5557,155,'si','Dodati novo vrsto prometnega davka in stopnja',0),(5558,155,'ba','Menambahkan jenis pajak penjualan baru dan tingkat',0),(5559,155,'nl','Voeg nieuwe Sales Tax Type en tarief',0),(5560,155,'fi','LisÃ¤Ã¤ uusi arvonlisÃ¤veron tyyppi ja mÃ¤Ã¤rÃ¤',0),(5561,155,'no','Legg til ny mva-Type og hastighet',0),(5562,155,'da','TilfÃ¸je nye moms Type og sats',0),(5563,155,'ko','ìƒˆë¡œìš´ íŒë§¤ ì„¸ê¸ˆ ìœ í˜• ë° ë¹„ìœ¨ì„ ì¶”ê°€',0),(5564,155,'he','×”×•×¡×£ ×¡×•×’ ×”×ž×¢ ×ž ×”×—×“×© ×•×©×™×¢×•×¨',0),(5565,155,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï„ÏÏ€Î¿Ï… Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎºÎ±Î¹ Ï„Î¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(5566,155,'zh','å¢žåŠ æ–°çš„é”€å”®ç¨Žç±»åž‹å’Œæ¯”çŽ‡\r\n',0),(5567,155,'sv','LÃ¤gg till ny moms typ och hastighet',0),(5568,155,'it','Aggiungi tasso e nuovo tipo di imposta sulle vendite',0),(5569,155,'tl','',0),(5570,155,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3609;&#3636;&#3604;&#3649;&#3621;&#3632;&#3629;&#3633;&#3605;&#3619;&#3634; &#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;&#3652;&#3627;&#3617;&#3656;',0),(5571,155,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤¨à¤ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤”à¤° à¤¦à¤°',0),(5572,155,'ms','Tambah jenis cukai jualan yang baru dan kadar',0),(5573,155,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø¬Ø¯ÙŠØ¯ Ù…Ù† Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§ØªØŒ ÙˆÙ…Ø¹Ø¯Ù„',0),(5574,155,'fr','Ajouter le taux et le nouveau Type de taxe de vente',0),(5575,155,'jp','æ–°è¦?å£²ä¸Šç¨Žã?¨ç¨ŽçŽ‡ã‚’è¿½åŠ ',0),(5576,155,'pt','Adicionar o novo tipo de imposto sobre vendas e taxa',0),(5577,155,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶, ÑÑ‚Ð°Ð²ÐºÐ°',0),(5578,155,'es','Agregar Nuevo Tipo y Tasa de IVA',0),(5579,155,'de','FÃ¼gen Sie neue Umsatzsteuer-Typ und Rate',0),(5580,155,'en','Add New Sales Tax Type and Rate',0),(5581,156,'is','',0),(5582,156,'dr','/ Ø°Ø®ÙŠØ±Ù‡ ',0),(5583,156,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø°Ø®ÙŠØ±Ù‡ ',0),(5584,156,'tr','Ekle/Kaydet',0),(5585,156,'pl','DodaÄ‡ Zapisz',0),(5586,156,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð·Ð°Ð¿Ð¸Ñ',0),(5587,156,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(5588,156,'sr','/ Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜',0),(5589,156,'vi','ThÃªm/lÆ°u',0),(5590,156,'af','Byvoeg/Stoor',0),(5591,156,'ro','Adauga/Save',0),(5592,156,'et','Lisa/Salvesta',0),(5593,156,'si','Dodaj shrani',0),(5594,156,'ba','Tambahkan Simpan',0),(5595,156,'nl','Toevoegen/opslaan',0),(5596,156,'fi','LisÃ¤Ã¤/Tallenna',0),(5597,156,'no','Legge til/lagre',0),(5598,156,'da','TilfÃ¸je/Gem',0),(5599,156,'ko','ì¶”ê°€/ì €ìž¥',0),(5600,156,'he','×”×•×¡×£/×©×ž×•×¨',0),(5601,156,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ/Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·',0),(5602,156,'zh','å¢žåŠ /ä¿å­˜\r\n',0),(5603,156,'sv','LÃ¤gga till/spara',0),(5604,156,'it','Aggiungi/Salva',0),(5605,156,'tl','',0),(5606,156,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;',0),(5607,156,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(5608,156,'ms','Menambah/Simpan',0),(5609,156,'ar','Ø¥Ø¶Ø§ÙØ©/Ø§Ù„Ø­ÙØ¸',0),(5610,156,'fr','Ajouter/enregistrer',0),(5611,156,'jp','è¿½åŠ /ä¿?å­˜',0),(5612,156,'pt','Adicionar/salvar',0),(5613,156,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ',0),(5614,156,'es','Agregar/Guardar',0),(5615,156,'de','HinzufÃ¼gen/speichern',0),(5616,156,'en','Add/Save',0),(5617,157,'is','',0),(5618,157,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(5619,157,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(5620,157,'tr','Hizmet Rep Ekle',0),(5621,157,'pl','Dodawanie usÅ‚ugi Rep',0),(5622,157,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»',0),(5623,157,'ur','Ø®Ø¯Ù…Øª Ø¬Ù…ÛÙˆØ±ÛŒÛ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5624,157,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¾Ð¿ÐµÑ€Ð°Ñ‚ÐµÑ€Ð°',0),(5625,157,'vi','ThÃªm NhÃ¢n ViÃªn Phá»¥c Vá»¥',0),(5626,157,'af','Diens Verteenwoordiger Byvoeg',0),(5627,157,'ro','Adauga Service Rep',0),(5628,157,'et','Lisada teenuse Rep',0),(5629,157,'si','Dodaj Rep storitve',0),(5630,157,'ba','Tambahkan Service Rep',0),(5631,157,'nl','Service Rep toevoegen',0),(5632,157,'fi','LisÃ¤Ã¤ palvelun edustaja',0),(5633,157,'no','Legg Service Rep',0),(5634,157,'da','TilfÃ¸je Service Rep',0),(5635,157,'ko','ì¶”ê°€ ì„œë¹„ìŠ¤ ë‹´ë‹¹ìž',0),(5636,157,'he','×”×•×¡×¤×ª × ×¦×™×’ ×©×™×¨×•×ª',0),(5637,157,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï…Ï†Î¬ÏƒÎ¼Î±Ï„ÏŒÏ‚ ÏƒÎ±Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±',0),(5638,157,'zh','å¢žåŠ æœåŠ¡ä»£è¡¨\r\n',0),(5639,157,'sv','LÃ¤gga till tjÃ¤nst Rep',0),(5640,157,'it','Aggiungi servizio Rep',0),(5641,157,'tl','',0),(5642,157,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619; Rep',0),(5643,157,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5644,157,'ms','Tambah wakil Perkhidmatan',0),(5645,157,'ar','Ø£Ø¶Ù Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ø®Ø¯Ù…Ø©',0),(5646,157,'fr','Ajouter Service Rep',0),(5647,157,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ä»£è¡¨ã‚’è¿½åŠ ',0),(5648,157,'pt','Adicionar serviÃ§o Rep',0),(5649,157,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð£ÑÐ»ÑƒÐ³Ð¸ Ñ€ÐµÑÐ¿',0),(5650,157,'es','Agregar Rep de Servicio',0),(5651,157,'de','Service Rep hinzufÃ¼gen',0),(5652,157,'en','Add Service Rep',0),(5653,158,'is','',0),(5654,158,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ',0),(5655,158,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ',0),(5656,158,'tr','Bu Ã¶ÄŸe iÃ§in yeni tedarikÃ§i Ekle',0),(5657,158,'pl','DodaÄ‡ nowy sprzedawca dla przedmiotu',0),(5658,158,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð·Ð° Ñ‚Ð¾Ð·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(5659,158,'ur','Ø§Ø³ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5660,158,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸Ñ… Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(5661,158,'vi','ThÃªm NgÆ°á»i BÃ¡n Cho Danh Má»¥c nÃ y',0),(5662,158,'af','Voeg nuwe handelaar vir hierdie Item',0),(5663,158,'ro','Adauga furnizor nou pentru acest element',0),(5664,158,'et','Lisage uus hankija selle kauba kohta',0),(5665,158,'si','Dodajanje novega dobavitelja za ta element',0),(5666,158,'ba','Menambahkan baru Vendor untuk Item ini',0),(5667,158,'nl','Toevoegen van nieuwe leverancier voor dit Item',0),(5668,158,'fi','LisÃ¤Ã¤ uusi toimittaja tÃ¤lle kohteelle',0),(5669,158,'no','Legg til ny leverandÃ¸r for denne varen',0),(5670,158,'da','TilfÃ¸je nye leverandÃ¸r for denne vare',0),(5671,158,'ko','ì´ í•­ëª©ì— ëŒ€ í•œ ìƒˆë¡œìš´ ê³µê¸‰ ì—…ì²´ë¥¼ ì¶”ê°€',0),(5672,158,'he','×œ×”×•×¡×™×£ ×¡×¤×§ ×—×“×© ×¢×‘×•×¨ ×¤×¨×™×˜ ×–×”',0),(5673,158,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î³Î¹Î± Ï„Î¿ ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ ÎµÎ¯Î´Î¿Ï‚',0),(5674,158,'zh','å¢žåŠ é€™ä¸ªé¡¹ç›®çš„æ–°ä¾›åº”å•†\r\n',0),(5675,158,'sv','LÃ¤gg till ny leverantÃ¶r fÃ¶r objektet',0),(5676,158,'it','Aggiungi nuovo fornitore per questo elemento',0),(5677,158,'tl','',0),(5678,158,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;',0),(5679,158,'hi','à¤¨à¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5680,158,'ms','Tambah penjual baru untuk Item ini',0),(5681,158,'ar','Ø¥Ø¶Ø§ÙØ© \"Ù…ÙˆØ±Ø¯ Ø¬Ø¯ÙŠØ¯\" Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¨Ù†Ø¯',0),(5682,158,'fr','Ajoutez le nouveau fournisseur pour cet article',0),(5683,158,'jp','ã?“ã?®å“?ç›®ã?®æ–°è¦?æ¥­è€…ã‚’è¿½åŠ ',0),(5684,158,'pt','Adicionar novos fornecedores para este Item',0),(5685,158,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ð¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(5686,158,'es','Agregar Nuevo Proveedor para este Item',0),(5687,158,'de','Neuer Hersteller fÃ¼r dieses Produkt hinzufÃ¼gen',0),(5688,158,'en','Add New Vendor for this Item',0),(5689,159,'is','',0),(5690,159,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡ Ù…Ø¯ÙŠØ± Ø³Ù†Ø¯ ',0),(5691,159,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡ Ù…Ø¯ÙŠØ± Ø³Ù†Ø¯ ',0),(5692,159,'tr','Belge yÃ¶neticisine Ekle',0),(5693,159,'pl','Dodaj do dokumentu dyrektor',0),(5694,159,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ ÐºÑŠÐ¼ Ð´Ð¸ÑÐ¿ÐµÑ‡ÐµÑ€Ð° Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(5695,159,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Û’ Ù…Ù†ØªØ¸Ù… Ù…ÛŒÚº Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5696,159,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ñƒ ÐœÐµÐ½Ð°ÑŸÐµÑ€ Ð·Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(5697,159,'vi','ThÃªm vÃ o Quáº£n LÃ½ TÃ i Liá»‡u ',0),(5698,159,'af','Byvoeging tot Dokument Bestuurder',0),(5699,159,'ro','Adauga la Document Manager',0),(5700,159,'et','Lisada dokument Manager',0),(5701,159,'si','Dodajte dokumentu Manager',0),(5702,159,'ba','Tambahkan ke dokumen Manager',0),(5703,159,'nl','Toevoegen aan Document Manager',0),(5704,159,'fi','LisÃ¤Ã¤ asiakirjan hallintaan',0),(5705,159,'no','Legge til dokumentbehandling',0),(5706,159,'da','TilfÃ¸je til dokument Manager',0),(5707,159,'ko','ë¬¸ì„œ ê´€ë¦¬ìžì— ì¶”ê°€',0),(5708,159,'he','×œ×”×•×¡×™×£ ××ª ×”×ž×¡×ž×š ×ž× ×”×œ',0),(5709,159,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÏƒÏ„Î¿ Î­Î³Î³ÏÎ±Ï†Î¿ Î´Î¹Î±Ï‡ÎµÎ¹ÏÎ¹ÏƒÏ„Î®',0),(5710,159,'zh','å¢žåŠ åˆ°æ–‡ä»¶ç®¡ç†å™¨\r\n',0),(5711,159,'sv','LÃ¤gg till Document Manager',0),(5712,159,'it','Aggiungi a Document Manager',0),(5713,159,'tl','',0),(5714,159,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3652;&#3611;&#3607;&#3637;&#3656;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;',0),(5715,159,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤• à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5716,159,'ms','Menambah kepada Pengurus dokumen',0),(5717,159,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª',0),(5718,159,'fr','Ajouter au gestionnaire de Document',0),(5719,159,'jp','æ–‡æ›¸ãƒžãƒ?ãƒ¼ã‚¸ãƒ£ãƒ¼ã?«è¿½åŠ ',0),(5720,159,'pt','Adicionar ao Gerenciador de documentos',0),(5721,159,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð² Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¼ÐµÐ½ÐµÐ´Ð¶ÐµÑ€',0),(5722,159,'es','Agregar al Supervisor de Documentos',0),(5723,159,'de','FÃ¼gen zum Dokument-Manager hinzu',0),(5724,159,'en','Add to Document Manager',0),(5725,160,'is','',0),(5726,160,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙØ¹Ø§Ù„ÙŠØª ÙØ±ÙˆØ´ ',0),(5727,160,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙØ¹Ø§Ù„ÙŠØª ÙØ±ÙˆØ´ ',0),(5728,160,'tr','SatÄ±ÅŸ bir eylem ekleme',0),(5729,160,'pl','Dodaj akcjÄ™ sprzedaÅ¼y',0),(5730,160,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(5731,160,'ur','Ø³ÛŒÙ„Ø² Ø¹Ù…Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(5732,160,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(5733,160,'vi','ThÃªm HÃ nh Äá»™ng BÃ¡n HÃ ng',0),(5734,160,'af','Verkoopsaksie Byvoeg',0),(5735,160,'ro','Adauga vÃ¢nzÄƒri de acÅ£iune',0),(5736,160,'et','MÃ¼Ã¼gi toimingu lisamine',0),(5737,160,'si','Dodaj prodajne akcije',0),(5738,160,'ba','Tambahkan aksi penjualan',0),(5739,160,'nl','Verkoop actie toevoegen',0),(5740,160,'fi','LisÃ¤Ã¤ myynti-toiminto',0),(5741,160,'no','Legge salg',0),(5742,160,'da','TilfÃ¸je salg handling',0),(5743,160,'ko','íŒë§¤ ìž‘ì—… ì¶”ê°€',0),(5744,160,'he','×”×•×¡×£ ×¤×¢×•×œ×” ×ž×›×™×¨×•×ª',0),(5745,160,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎµÎ½Î­ÏÎ³ÎµÎ¹Î±',0),(5746,160,'zh','å¢žåŠ é”€å”®è¡Œä¸º\r\n',0),(5747,160,'sv','LÃ¤gga till fÃ¶rsÃ¤ljning Ã¥tgÃ¤rd',0),(5748,160,'it','Aggiungere l\'azione di vendita',0),(5749,160,'tl','',0),(5750,160,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(5751,160,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(5752,160,'ms','Menambah jualan tindakan',0),(5753,160,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù…Ù„ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(5754,160,'fr','Ajouter vente Action',0),(5755,160,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ',0),(5756,160,'pt','Adicionar aÃ§Ã£o de vendas',0),(5757,160,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(5758,160,'es','Agregar AcciÃ³n de Ventas',0),(5759,160,'de','Verkauf Aktion hinzufÃ¼gen',0),(5760,160,'en','Add Sales Action',0),(5761,161,'is','',0),(5762,161,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ',0),(5763,161,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ',0),(5764,161,'tr','Ekle/GÃ¼ncelle',0),(5765,161,'pl','Dodaj/Aktualizuj',0),(5766,161,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(5767,161,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(5768,161,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(5769,161,'vi','ThÃªm/Cáº­p Nháº­t',0),(5770,161,'af','Byvoeg/Opdateer',0),(5771,161,'ro','AdÄƒugaÅ£i/actualizaÅ£i',0),(5772,161,'et','Lisamine/uuendamine',0),(5773,161,'si','Dodaj/posodobi',0),(5774,161,'ba','Menambahkan Update',0),(5775,161,'nl','Toevoegen/bijwerken',0),(5776,161,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤',0),(5777,161,'no','Legg til/Oppdater',0),(5778,161,'da','TilfÃ¸j/opdater',0),(5779,161,'ko','ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(5780,161,'he','×”×•×¡×£/×¢×“×›×Ÿ',0),(5781,161,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(5782,161,'zh','å¢žåŠ /æ›´æ–°\r\n',0),(5783,161,'sv','LÃ¤gg till/uppdatera',0),(5784,161,'it','Aggiungere o aggiornare',0),(5785,161,'tl','',0),(5786,161,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(5787,161,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(5788,161,'ms','Tambah/Kemaskini',0),(5789,161,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(5790,161,'fr','Ajouter/mettre Ã  jour',0),(5791,161,'jp','è¿½åŠ /æ›´æ–°',0),(5792,161,'pt','Adicionar/atualizar',0),(5793,161,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(5794,161,'es','Agregar/Actualizar',0),(5795,161,'de','HinzufÃ¼gen/aktualisieren',0),(5796,161,'en','Add/Update',0),(5797,162,'is','',0),(5798,162,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ØªØ§Ø¨Ø¹ Ø¯ÙŠÚ¯Ø± Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(5799,162,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªØ§Ø¨Ø¹ Ø¯ÙŠÚ¯Ø± Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(5800,162,'tr','BaÅŸka bir baÄŸlayÄ±cÄ± iÅŸlev Ekle/GÃ¼ncelle',0),(5801,162,'pl','Dodaj/Aktualizuj innej funkcji introligatornia',0),(5802,162,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð° ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(5803,162,'ur','Ø§ÛŒÚ© Ø¨Ø§Ù†ÚˆØ±ÛŒ ØªÙ‚Ø±ÛŒØ¨ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(5804,162,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ñ€ÑƒÐ³Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ Ð‘Ð¸Ð½Ð´ÐµÑ€y',0),(5805,162,'vi','ThÃªm/Cáº­p Nháº­t Má»™t Chá»©c NÄƒng ÄÃ³ng SÃ¡cj KhÃ¡c',0),(5806,162,'af','Voeg/opdatering ander Bindery funksie',0),(5807,162,'ro','AdÄƒugaÅ£i/actualizaÅ£i o altÄƒ funcÅ£ie de legatorie',0),(5808,162,'et','Muu Kirjansitomo funktsiooni lisamine/uuendamine',0),(5809,162,'si','Dodaj/posodobi drugo funkcijo Knjigoveznica',0),(5810,162,'ba','Tambahkan/Perbarui fungsi Bindery lain',0),(5811,162,'nl','Een andere Bindery functie toevoegen/bijwerken',0),(5812,162,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ Bindery liimatuilla',0),(5813,162,'no','Legg til/Oppdater en annen Bindery-funksjon',0),(5814,162,'da','TilfÃ¸j/Opdater en anden Bindery funktion',0),(5815,162,'ko','ë‹¤ë¥¸ ë°”ì¸ë”ë¦¬ ê¸°ëŠ¥ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(5816,162,'he','×”×•×¡×£/×¢×“×›×Ÿ ×¤×•× ×§×¦×™×” ××—×¨×ª ×ž×¡×•×’ Bindery',0),(5817,162,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÎµ Î¼Î¹Î± Î¬Î»Î»Î· Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Ï„Î¿Ï… Bindery',0),(5818,162,'zh','å¢žåŠ /æ›´æ–°å…¶ä»–è£…è®¢åŠŸèƒ½\r\n',0),(5819,162,'sv','LÃ¤gg till/uppdatera en annan Bindery funktion',0),(5820,162,'it','Aggiungere o aggiornare un\'altra funzione della legatoria',0),(5821,162,'tl','',0),(5822,162,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(5823,162,'hi','à¤à¤• à¤”à¤° à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(5824,162,'ms','Tambah/Kemaskini lain Bindery fungsi',0),(5825,162,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø£Ø®Ø±Ù‰',0),(5826,162,'fr','Ajouter/mettre Ã  jour une autre fonction de faÃ§onnage',0),(5827,162,'jp','æ–°ã?Ÿã?ªãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚’è¿½åŠ /æ›´æ–°',0),(5828,162,'pt','Adicionar/atualizar outra funÃ§Ã£o Bindery',0),(5829,162,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ',0),(5830,162,'es','Agregar/Actualizar Otra FunciÃ³n de EncuadernaciÃ³n',0),(5831,162,'de','Eine andere Bindery-Funktion hinzufÃ¼gen/aktualisieren',0),(5832,162,'en','Add/Update Another Bindery Function',0),(5833,163,'is','',0),(5834,163,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù…Ø­Ù„ Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ Ø¬Ù†Ø³',0),(5835,163,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„ Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(5836,163,'tr','Eklemek Ã¶ÄŸe iÃ§in baÅŸka bir konum gÃ¼ncelleme',0),(5837,163,'pl','DodaÄ‡ zaktualizowaÄ‡ innej lokalizacji elementu',0),(5838,163,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð¾ Ð¼ÑÑÑ‚Ð¾ Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(5839,163,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ø³ÛŒ Ø¯ÙˆØ³Ø±Û’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(5840,163,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ð¸ Ð´Ñ€ÑƒÐ³Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»',0),(5841,163,'vi','ThÃªm/Cáº­p Nháº­t Vá»‹ TrÃ­ KhÃ¡c Cho Danh Má»¥c',0),(5842,163,'af','Byvoeg/Opdateer \'n Ander Ligging vir Item',0),(5843,163,'ro','Adauga actualiza o altÄƒ locaÅ£ie pentru articol',0),(5844,163,'et','Lisamine uuendada kauba mujale',0),(5845,163,'si','Dodaj posodobiti drugo mesto za artikel',0),(5846,163,'ba','Tambahkan memperbarui lokasi lain untuk Item',0),(5847,163,'nl','Voeg een andere locatie voor object bijwerken',0),(5848,163,'fi','LisÃ¤Ã¤ pÃ¤ivitettÃ¤vÃ¤ toisen kohteen',0),(5849,163,'no','Legge til oppdatere et annet sted For vare',0),(5850,163,'da','TilfÃ¸je opdatere en anden placering For vare',0),(5851,163,'ko','ì¶”ê°€ ì—…ë°ì´íŠ¸ í•­ëª©ì— ëŒ€ í•œ ë‹¤ë¥¸ ìœ„ì¹˜',0),(5852,163,'he','×”×•×¡×¤×ª ×¢×“×›×•×Ÿ ×ž×™×§×•× ××—×¨ ×¢×‘×•×¨ ×¤×¨×™×˜',0),(5853,163,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Î¼Î¹Î± Î¬Î»Î»Î· Î¸Î­ÏƒÎ· Î³Î¹Î± Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(5854,163,'zh','å¢žåŠ åˆ†é¡¹å¦ä¸€ä¸ªä½ç½®æ›´æ–°\r\n',0),(5855,163,'sv','LÃ¤gg till uppdatera en annan plats fÃ¶r artikeln',0),(5856,163,'it','Aggiungere un\'altra posizione per voce di aggiornamento',0),(5857,163,'tl','',0),(5858,163,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3629;&#3639;&#3656;&#3609;',0),(5859,163,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤‡à¤Ÿà¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(5860,163,'ms','Tambah mengemaskini lokasi yang lain bagi perkara',0),(5861,163,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù…ÙˆÙ‚Ø¹ Ø¢Ø®Ø± Ù„Ù„ØµÙ†Ù',0),(5862,163,'fr','Ajouter mise Ã  jour d\'un autre emplacement pour l\'article',0),(5863,163,'jp','æ–°ã?Ÿã?ªå“?ç›®ã?®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ /æ›´æ–°',0),(5864,163,'pt','Adicionar atualizar outro local para Item',0),(5865,163,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ðµ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(5866,163,'es','Agregar/Actualizar Otra Lugar para el Item',0),(5867,163,'de','FÃ¼gen Sie einen anderen Speicherort fÃ¼r Element aktualisieren',0),(5868,163,'en','Add Update Another Location For Item',0),(5869,164,'is','',0),(5870,164,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ Ø¬Ù†Ø³ Ù…Ø´Ø§Ø¨Ù‡',0),(5871,164,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡',0),(5872,164,'tr','BaÅŸka bir satÄ±cÄ± Ekle/GÃ¼ncelle aynÄ± Ã¶ÄŸe',0),(5873,164,'pl','Dodaj/zaktualizuj innego dostawcy sam element',0),(5874,164,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÑŠÑ‰Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(5875,164,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº Ø§ÛŒÚ© ÛÛŒ Ø´Û’',0),(5876,164,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸ÑÑ‚Ð¾Ð³ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(5877,164,'vi','ThÃªm/Cáº­p Nháº­t NgÆ°á»i BÃ¡n KhÃ¡c Cho CÃ¹ng Danh Má»¥c',0),(5878,164,'af','\'n Ander Verskaffer vir Dieselfde Item Byvoeg/Opdateer',0),(5879,164,'ro','AdÄƒugaÅ£i/actualizaÅ£i un alt furnizor acelaÅŸi articol',0),(5880,164,'et','Lisa/uuenda teine tarnija samal tootel',0),(5881,164,'si','Dodaj/posodobi dobavitelja isti element',0),(5882,164,'ba','Tambahkan/Perbarui Vendor lain Item sama',0),(5883,164,'nl','Toevoegen/bijwerken van een andere leverancier hetzelfde Item',0),(5884,164,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ toiseen toimittajaan saman kohteen',0),(5885,164,'no','Legg til/Oppdater en annen leverandÃ¸r samme element',0),(5886,164,'da','TilfÃ¸j/Opdater en anden sÃ¦lger samme vare',0),(5887,164,'ko','ë‹¤ë¥¸ ê³µê¸‰ ì—…ì²´ ì¶”ê°€/ì—…ë°ì´íŠ¸ ê°™ì€ í•­ëª©',0),(5888,164,'he','×”×•×¡×£/×¢×“×›×Ÿ ×¡×¤×§ ××—×¨ ×‘××•×ª×• ×¤×¨×™×˜',0),(5889,164,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÎµ Î¬Î»Î»Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î¯Î´Î¹Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(5890,164,'zh','å¢žåŠ /æ›´æ–°å¦ä¸€ä¸ªä¾›åº”å•†çš„åŒä¸€é¡¹ç›®\r\n',0),(5891,164,'sv','LÃ¤gg till/uppdatera en annan leverantÃ¶r samma objekt',0),(5892,164,'it','Aggiungere o aggiornare un altro fornitore stesso elemento',0),(5893,164,'tl','',0),(5894,164,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3627;&#3657;&#3648;&#3627;&#3617;&#3639;&#3629;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3629;&#3639;&',0),(5895,164,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤à¤• à¤¹à¥€ à¤†à¤‡à¤Ÿà¤®',0),(5896,164,'ms','Tambah/Kemaskini penjual lain perkara sama',0),(5897,164,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù…ÙˆØ±Ù‘Ø¯ Ù„Ù†ÙØ³ Ø§Ù„ØµÙ†Ù',0),(5898,164,'fr','Ajouter/mettre Ã  jour un autre vendeur mÃªme point',0),(5899,164,'jp','å?Œã?˜å“?ç›®ã?«å¯¾ã?—ã?¦ä»–ã?®æ¥­è€…ã‚’è¿½åŠ /æ›´æ–°',0),(5900,164,'pt','Adicionar/actualizar um outro vendedor mesmo Item',0),(5901,164,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð³Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° ÐžÐ´Ð¸Ð½Ð°ÐºÐ¾Ð²Ð¾Ð³Ð¾ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(5902,164,'es','Agregar/Actualizar Otro Proveedor del Mismo Item',0),(5903,164,'de','HinzufÃ¼gen oder Aktualisieren eines anderen Herstellers dasselbe Element',0),(5904,164,'en','Add/Update Another Vendor Same Item',0),(5905,165,'is','',0),(5906,165,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ§Ø¨Ø¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(5907,165,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ§Ø¨Ø¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(5908,165,'tr','Bu baÄŸlayÄ±cÄ± iÅŸlev iÃ§in ekleme/gÃ¼ncelleÅŸtirme Ã¼cretleri',0),(5909,165,'pl','DodaÄ‡ aktualizacji opÅ‚aty za ta funkcja introligatornia',0),(5910,165,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°ÐºÑÐ¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(5911,165,'ur','Ø§Ø³ Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº Ú†Ø§Ø±Ø¬Ø²',0),(5912,165,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ð°Ð¼Ð° Ð·Ð° Ð¾Ð²Ñƒ Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ',0),(5913,165,'vi','ThÃªm/Cáº­p Nháº­t Chi PhÃ­ Cho Chá»©c NÄƒng ÄÃ³ng SÃ¡ch nÃ y',0),(5914,165,'af','Voeg/Update heffings vir hierdie Bindery funksie',0),(5915,165,'ro','AdÄƒugaÅ£i/actualizaÅ£i taxele pentru aceastÄƒ funcÅ£ie de legatorie',0),(5916,165,'et','Lisa/vÃ¤rskenda tasu Kirjansitomo funktsioon',0),(5917,165,'si','Dodaj/posodobi stroÅ¡kov za to funkcijo Knjigoveznica',0),(5918,165,'ba','Biaya menambahkan Update untuk fungsi Bindery ini',0),(5919,165,'nl','Toevoegen/bijwerken kosten voor deze Bindery-functie',0),(5920,165,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ perittÃ¤vÃ¤t Bindery-toiminto',0),(5921,165,'no','Legg til/Oppdater kostnader for denne bindingen funksjonen',0),(5922,165,'da','TilfÃ¸j/opdater afgifter for denne Bindery funktion',0),(5923,165,'ko','ì´ ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ì— ëŒ€ í•œ ì¶”ê°€/ì—…ë°ì´íŠ¸ ë¹„ìš©',0),(5924,165,'he','×”×•×¡×£/×¢×“×›×Ÿ ×—×™×•×‘×™× ×¢×‘×•×¨ ×¤×•× ×§×¦×™×” ×–×• Bindery',0),(5925,165,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏ€Î¹Î²Î±ÏÏÎ½ÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î· ÏƒÏ…Î½Î¬ÏÏ„Î·ÏƒÎ· Î±Ï…Ï„Î® Bindery',0),(5926,165,'zh','å¢žåŠ /æ›´æ–°æ­¤è£…è®¢åŠŸèƒ½æ”¶è´¹\r\n',0),(5927,165,'sv','LÃ¤gg till/uppdatera avgifter fÃ¶r Bindery funktionen',0),(5928,165,'it','Aggiungere o aggiornare spese per questa funzione della legatoria',0),(5929,165,'tl','',0),(5930,165,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3586;&#3629;&#3591;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(5931,165,'hi','à¤‡à¤¸ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤­à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(5932,165,'ms','Caj Tambah/Kemaskini bagi fungsi Bindery ini',0),(5933,165,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« \"Ø±Ø³ÙˆÙ…\" Ù„Ù‡Ø°Ù‡ \"Ø§Ù„Ø¯Ø§Ù„Ø© ÙÙŠ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª\"',0),(5934,165,'fr','Ajouter/mettre Ã  jour les frais pour cette fonction de faÃ§onnage',0),(5935,165,'jp','æ–°ã?Ÿã?ªãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã?®è«‹æ±‚ã‚’è¿½åŠ /æ›´æ–°',0),(5936,165,'pt','Adicionar/atualizar acusaÃ§Ãµes para esta funÃ§Ã£o de Bindery',0),(5937,165,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ',0),(5938,165,'es','Agregar/Actualizar Cargos para esta FunciÃ³n de CposiciÃ³n',0),(5939,165,'de','HinzufÃ¼gen/aktualisieren GebÃ¼hren fÃ¼r diese Bindery-Funktion',0),(5940,165,'en','Add/Update Charges for this Bindery Function',0),(5941,166,'is','',0),(5942,166,'dr','/ Ø§ØµÙ„Ø§Ø­  Ù„ÙŠØ³Øª Ø§Ø¬Ø²Ø§Ø¡ Ø¨Ø±Ø§ÙŠ Ø¬Ù†Ø³ ',0),(5943,166,'pr','Ø§ÙØ²ÙˆØ¯Ù† / ÙˆÙŠØ±Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø§Ø¬Ø²Ø§Ø¡ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(5944,166,'tr','BileÅŸen Listesi Ekle/DÃ¼zenle',0),(5945,166,'pl','Dodawanie/Edycja listy komponentÃ³w',0),(5946,166,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¸',0),(5947,166,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/Ø¬Ø²Ùˆ ÙÛØ±Ø³Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(5948,166,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¸',0),(5949,166,'vi','ThÃªm/Cáº­p Nháº­t Danh SÃ¡ch ThÃ nh Pháº§n',0),(5950,166,'af','Komponent Lys Byvoeg/Redigeer ',0),(5951,166,'ro','AdÄƒugare/Editare listÄƒ de componente',0),(5952,166,'et','Komponentide loendisse lisamine vÃµi redigeerimine',0),(5953,166,'si','Dodaj/Uredi seznam komponent',0),(5954,166,'ba','Menambah/mengedit daftar komponen',0),(5955,166,'nl','Component lijst toevoegen/bewerken',0),(5956,166,'fi','LisÃ¤Ã¤ tai Muokkaa komponenttiluettelo',0),(5957,166,'no','Legg til/Rediger komponentoversikt',0),(5958,166,'da','TilfÃ¸j/redigÃ©r komponentliste',0),(5959,166,'ko','êµ¬ì„± ìš”ì†Œ ëª©ë¡ ì¶”ê°€/íŽ¸ì§‘',0),(5960,166,'he','×”×•×¡×¤×”/×¢×¨×™×›×” ×©×œ ×¨×©×™×ž×ª ×¨×›×™×‘×™×',0),(5961,166,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î£Ï…Î½Î±ÏÎ¼Î¿Î»Î¿Î³Î·Î¼Î¬Ï„Ï‰Î½',0),(5962,166,'zh','å¢žåŠ /ç¼–è¾‘å…ƒä»¶æ¸…å•\r\n',0),(5963,166,'sv','LÃ¤gg till/redigera komponentlista',0),(5964,166,'it','Aggiungere o modificare l\'elenco dei componenti',0),(5965,166,'tl','',0),(5966,166,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(5967,166,'hi','à¤˜à¤Ÿà¤• à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(5968,166,'ms','Tambah/Edit Senarai komponen',0),(5969,166,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙƒÙˆÙ‘Ù†Ø§Øª',0),(5970,166,'fr','Ajouter/modifier la liste des composants',0),(5971,166,'jp','å“?ç›®ã?®éƒ¨å“?ãƒªã‚¹ãƒˆã‚’è¿½åŠ /æ›´æ–°',0),(5972,166,'pt','Adicionar/editar lista de componente',0),(5973,166,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐšÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¾Ð²',0),(5974,166,'es','Agregar/Actualizar Lista de Componentes',0),(5975,166,'de','Komponentenliste hinzufÃ¼gen/bearbeiten',0),(5976,166,'en','Add/Edit Component List',0),(5977,167,'is','',0),(5978,167,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø± Ù…ØªÙØ§ÙˆØª ',0),(5979,167,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø± Ù…ØªÙØ§ÙˆØª ',0),(5980,167,'tr','FarklÄ± bir mÃ¼ÅŸteri Ekle/GÃ¼ncelle',0),(5981,167,'pl','Dodaj/Aktualizuj inny klient',0),(5982,167,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚, Ñ€Ð°Ð·Ð»Ð¸Ñ‡ÐµÐ½',0),(5983,167,'ur','Ø§ÛŒÚ© Ù…Ø®ØªÙ„Ù Ú¯Ø§ÛÚ© Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(5984,167,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÑƒÐ¿Ñ†Ð° Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð¸Ñ‚Ð¾Ð³',0),(5985,167,'vi','ThÃªm/Cáº­p Nháº­t 1 KhÃ¡ch HÃ ng KhÃ¡c',0),(5986,167,'af','\'n Ander Klant/KliÃ«nt Byvoeg/Opdateer ',0),(5987,167,'ro','AdÄƒugaÅ£i/actualizaÅ£i un client diferit',0),(5988,167,'et','Lisa/Uuenda teist klienti',0),(5989,167,'si','Dodaj/posodobi drugemu kupcu',0),(5990,167,'ba','Tambahkan/Perbarui Pelanggan yang berbeda',0),(5991,167,'nl','Een andere klant toevoegen/bijwerken',0),(5992,167,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ asiakkaalle',0),(5993,167,'no','Legg til/Oppdater en annen kunde',0),(5994,167,'da','TilfÃ¸j/Opdater en anden kunde',0),(5995,167,'ko','ë‹¤ë¥¸ ê³ ê°ì„ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(5996,167,'he','×”×•×¡×£/×¢×“×›×Ÿ ×œ×§×•×— ×©×•× ×”',0),(5997,167,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î­Î½Î± Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(5998,167,'zh','å¢žåŠ /æ›´æ–°ä¸åŒçš„å®¢æˆ·\r\n',0),(5999,167,'sv','LÃ¤gg till/uppdatera en annan kund',0),(6000,167,'it','Aggiungere/aggiornare un cliente diverso',0),(6001,167,'tl','',0),(6002,167,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3649;&#3605;&#3585;&#3605;&#3656;&#3634;&#3591;&#3585;&#3633;&#3609;',0),(6003,167,'hi','à¤à¤• à¤…à¤²à¤— à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(6004,167,'ms','Tambah/Kemaskini pelanggan yang berbeza',0),(6005,167,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø²Ø¨ÙˆÙ† Ù…Ø®ØªÙ„Ù',0),(6006,167,'fr','Ajouter/mettre Ã  jour un autre client',0),(6007,167,'jp','é?•ã?†é¡§å®¢ã?®è¿½åŠ /æ›´æ–°',0),(6008,167,'pt','Adicionar/atualizar um cliente diferente',0),(6009,167,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð³Ð¾ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(6010,167,'es','Agregar/Actualizar un Cliente Diferente',0),(6011,167,'de','Einen anderen Kunden hinzufÃ¼gen/aktualisieren',0),(6012,167,'en','Add/Update a Different Customer',0),(6013,168,'is','',0),(6014,168,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† / Ø§ØµÙ„Ø§Ø­  Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ùˆ Ù…Ø­Ù„ Ø¬Ù†Ø³',0),(6015,168,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ / ÙˆÙŠØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ùˆ Ù…Ø­Ù„ ÙƒØ§Ù„Ø§',0),(6016,168,'tr','Ekle/DÃ¼zenle fiyatlandÄ±rma & konumu',0),(6017,168,'pl','Dodawanie/edycja cen & lokalizacji',0),(6018,168,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ & Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(6019,168,'ur','& Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ¯ÙˆÛŒÙ† Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(6020,168,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ° & Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(6021,168,'vi','ThÃªm/Cáº­p Nháº­t GiÃ¡ & Vá»‹ TrÃ­',0),(6022,168,'af','Byvoeg/Redigeer Prysberekening & Ligging',0),(6023,168,'ro','AdÄƒugare/Editare preturi & locaÅ£ie',0),(6024,168,'et','Lisa/Uuenda hindu ja asukohti',0),(6025,168,'si','Dodaj/Uredi cenitev & mesto',0),(6026,168,'ba','Tambahkan Edit harga &amp; lokasi',0),(6027,168,'nl','Toevoegen/bewerken prijzen & locatie',0),(6028,168,'fi','LisÃ¤Ã¤ tai Muokkaa hinnoittelu & sijainti',0),(6029,168,'no','Legg til/Rediger priser & plassering',0),(6030,168,'da','TilfÃ¸j/redigÃ©r prissÃ¦tning & placering',0),(6031,168,'ko','ì¶”ê°€/íŽ¸ì§‘ ê°€ê²© & ìœ„ì¹˜',0),(6032,168,'he','×”×•×¡×¤×”/×¢×¨×™×›×” ×©×œ ×ª×ž×—×•×¨ & ×ž×™×§×•×',0),(6033,168,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· & Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(6034,168,'zh','å¢žåŠ /ç¼–è¾‘å®šä»·å’Œåœ°ç‚¹\r\n',0),(6035,168,'sv','LÃ¤gg till/redigera prissÃ¤ttning & lÃ¤ge',0),(6036,168,'it','Aggiungi/modifica dei prezzi & posizione',0),(6037,168,'tl','',0),(6038,168,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3588;&#3634;&#3649;&#3621;&#3632;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(6039,168,'hi','& à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(6040,168,'ms','Tambah/Edit harga & lokasi',0),(6041,168,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø§Ù„ØªØ³Ø¹ÙŠØ± Ùˆ Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(6042,168,'fr','Ajouter/modifier des prix & emplacement',0),(6043,168,'jp','å“?ç›®ã?®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ /æ›´æ–°',0),(6044,168,'pt','Adicionar/editar preÃ§os & localizaÃ§Ã£o',0),(6045,168,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‹ & Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(6046,168,'es','Agregar/Editar Precios y UbicaciÃ³n',0),(6047,168,'de','HinzufÃ¼gen/Bearbeiten Preise & Lage',0),(6048,168,'en','Add/Edit Pricing & Location',0),(6049,169,'is','',0),(6050,169,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù„ÙŠØ³Øª Ù…Ø§Ø´ÙŠÙ† ',0),(6051,169,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù…Ø§Ø´ÙŠÙ† ',0),(6052,169,'tr','Makine listesi ekleyin/gÃ¼ncelleyin',0),(6053,169,'pl','Dodaj/Aktualizuj listÄ™ maszyn',0),(6054,169,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(6055,169,'ur','Ù…Ø´ÛŒÙ† Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(6056,169,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(6057,169,'vi','ThÃªm/Cáº­p Nháº­t Danh SÃ¡ch MÃ¡y MÃ³c',0),(6058,169,'af','Masjienlys Byvoeg/Opdateer',0),(6059,169,'ro','AdÄƒugaÅ£i/actualizaÅ£i lista Machine',0),(6060,169,'et','Masin nimekirja lisamine/uuendamine',0),(6061,169,'si','Dodaj/posodobi seznam stroj',0),(6062,169,'ba','Daftar mesin menambahkan Update',0),(6063,169,'nl','Machine lijst toevoegen/bijwerken',0),(6064,169,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ valittujen koneiden tiedot',0),(6065,169,'no','Legg til/Oppdater maskinen liste',0),(6066,169,'da','TilfÃ¸j/opdater maskine liste',0),(6067,169,'ko','ì»´í“¨í„° ëª©ë¡ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(6068,169,'he','×”×•×¡×£/×¢×“×›×Ÿ ×¨×©×™×ž×ª ×ž×›×•× ×•×ª',0),(6069,169,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î± Î¼Î·Ï‡Î±Î½Î®',0),(6070,169,'zh','å¢žåŠ /æ›´æ–°æœºåˆ—è¡¨\r\n',0),(6071,169,'sv','LÃ¤gg till/uppdatera maskin lista',0),(6072,169,'it','Aggiungere o aggiornare la lista di macchina',0),(6073,169,'tl','',0),(6074,169,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(6075,169,'hi','à¤®à¤¶à¥€à¤¨ à¤¸à¥‚à¤šà¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(6076,169,'ms','Tambah/Kemaskini senarai Mesin',0),(6077,169,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ù‡Ø§Ø²',0),(6078,169,'fr','Ajouter/mettre Ã  jour liste de Machine',0),(6079,169,'jp','æ©Ÿæ¢°ãƒªã‚¹ãƒˆã‚’è¿½åŠ /æ›´æ–°',0),(6080,169,'pt','Adicionar/atualizar lista de mÃ¡quina',0),(6081,169,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¼Ð°ÑˆÐ¸Ð½',0),(6082,169,'es','Agregar/Actualizar Lista de Maquinas',0),(6083,169,'de','Rechnerliste hinzufÃ¼gen/aktualisieren',0),(6084,169,'en','Add/Update Machine List',0),(6085,170,'is','',0),(6086,170,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø§Ù†ØªØ®Ø§Ø¨   Ù„ÙŠØ³Øª Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ§Ø¨Ø¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(6087,170,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†ØªØ®Ø§Ø¨   Ù„ÙŠØ³Øª Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ§Ø¨Ø¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(6088,170,'tr','Bu baÄŸlayÄ±cÄ± iÅŸlev iÃ§in ekleme/gÃ¼ncelleÅŸtirme seÃ§in listesi',0),(6089,170,'pl','DodaÄ‡ aktualizacji wybierz listy dla tej funkcji introligatornia',0),(6090,170,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð·Ð° Ñ‚Ð°Ð·Ð¸ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(6091,170,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº ÙÛØ±Ø³Øª Ø§Ø³ Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ú©Û’ Ù„ÛŒÛ’',0),(6092,170,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð»Ð¸ÑÑ‚Ðµ Ð·Ð° Ð¾Ð²Ñƒ Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ',0),(6093,170,'vi','ThÃªm/Cáº­p Nháº­t Danh SÃ¡ch ÄÃ£ Chá»n cho Chá»©c NÄƒng ÄÃ³ng SÃ¡ch',0),(6094,170,'af','Voeg/werk kies lys vir hierdie Bindery funksie',0),(6095,170,'ro','AdÄƒugaÅ£i/actualizaÅ£i selectaÅ£i listÄƒ pentru aceastÄƒ funcÅ£ie de legatorie',0),(6096,170,'et','Lisa/vÃ¤rskenda valige loendist Kirjansitomo funktsioon',0),(6097,170,'si','Dodaj/posodobi izberite seznam za to funkcijo Knjigoveznica',0),(6098,170,'ba','Menambahkan Update pilih daftar untuk fungsi Bindery ini',0),(6099,170,'nl','Toevoegen/bijwerken Selecteer lijst voor deze Bindery-functie',0),(6100,170,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ Valitse luettelosta Bindery-toiminto',0),(6101,170,'no','Legg til/Oppdater Velg listen for denne bindingen funksjonen',0),(6102,170,'da','TilfÃ¸j/opdater VÃ¦lg liste for denne Bindery funktion',0),(6103,170,'ko','ì´ ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ì— ëŒ€ í•œ ì¶”ê°€/ì—…ë°ì´íŠ¸ë¥¼ ì„ íƒ ëª©ë¡',0),(6104,170,'he','×‘×¨×©×™×ž×” ×‘×—×¨ ×”×•×¡×¤×”/×¢×“×›×•×Ÿ ×¢×‘×•×¨ ×¤×•× ×§×¦×™×” ×–×• Bindery',0),(6105,170,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î± ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î³Î¹Î± Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Bindery',0),(6106,170,'zh','å¢žåŠ /æ›´æ–°æœ¬è£…è®¢åŠŸèƒ½çš„é€‰æ‹©ç›®å½•\r\n',0),(6107,170,'sv','LÃ¤gg till/uppdatera VÃ¤lj lista fÃ¶r denna Bindery-funktion',0),(6108,170,'it','Aggiungi/Aggiorna lista selezionare per questa funzione della legatoria',0),(6109,170,'tl','',0),(6110,170,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3586;&#3629;&#3591;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&',0),(6111,170,'hi','à¤‡à¤¸ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤¸à¥‚à¤šà¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(6112,170,'ms','Senarai pilih Tambah/Kemaskini untuk fungsi Bindery ini',0),(6113,170,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø¯Ø¯ Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù„Ù‡Ø°Ù‡ \"Ø§Ù„Ø¯Ø§Ù„Ø© ÙÙŠ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª\"',0),(6114,170,'fr','Liste de sÃ©lectionner Ajouter/mettre Ã  jour pour cette fonction de faÃ§onnage',0),(6115,170,'jp','ã?“ã?®ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã?®ã‚»ãƒ¬ã‚¯ãƒˆãƒªã‚¹ãƒˆã‚’è¿½åŠ /æ›´æ–°',0),(6116,170,'pt','Selecione lista de adicionar/atualizar para esta funÃ§Ã£o de Bindery',0),(6117,170,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº Ð²Ñ‹Ð±Ð¾Ñ€Ð° Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ',0),(6118,170,'es','Agregar/Actualizar Lista de SelecciÃ³n para esta FunciÃ³n de EncuadernaciÃ³n',0),(6119,170,'de','HinzufÃ¼gen/Aktualisieren wÃ¤hlen Sie Liste fÃ¼r diese Bindery-Funktion',0),(6120,170,'en','Add/Update Select List for this Bindery Function',0),(6121,171,'is','',0),(6122,171,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(6123,171,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(6124,171,'tr','Alt Gruplar Ekle/GÃ¼ncelle',0),(6125,171,'pl','Dodaj/Aktualizuj podgrupy',0),(6126,171,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð¸',0),(6127,171,'ur','Ø³Ø¨Ú¯Ø±Ø§ÛŒÙ¾Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(6128,171,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð°',0),(6129,171,'vi','ThÃªm/Cáº­p Nháº­t NhÃ³m Phá»¥',0),(6130,171,'af','Sub-groepe Byvoeg/Opdateer',0),(6131,171,'ro','AdÄƒugaÅ£i/actualizaÅ£i subgrupe',0),(6132,171,'et','Lisa/vÃ¤rskenda alarÃ¼hmad',0),(6133,171,'si','Dodaj/posodobi podskupine',0),(6134,171,'ba','Tambahkan/Perbarui subkumpulan',0),(6135,171,'nl','Subgroepen toevoegen/bijwerken',0),(6136,171,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ alaryhmÃ¤t',0),(6137,171,'no','Legg til/Oppdater undergrupper',0),(6138,171,'da','TilfÃ¸j/opdater undergrupper',0),(6139,171,'ko','í•˜ìœ„ ê·¸ë£¹ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(6140,171,'he','×”×•×¡×£/×¢×“×›×Ÿ ×§×‘×•×¦×•×ª ×ž×©× ×”',0),(6141,171,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÎµ Ï…Ï€Î¿Î¿Î¼Î¬Î´ÎµÏ‚',0),(6142,171,'zh','å¢žåŠ /æ›´æ–°å­ç¾¤\r\n',0),(6143,171,'sv','LÃ¤gg till/uppdatera undergrupper',0),(6144,171,'it','Aggiungere o aggiornare i sottogruppi',0),(6145,171,'tl','',0),(6146,171,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(6147,171,'hi','à¤‰à¤ªà¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(6148,171,'ms','Tambah/Kemaskini subkumpulan',0),(6149,171,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„ÙØ±Ø¹ÙŠØ©',0),(6150,171,'fr','Ajouter/mettre Ã  jour des sous-groupes',0),(6151,171,'jp','ã‚µãƒ–ã‚°ãƒ«ãƒ¼ãƒ—ã?®è¿½åŠ /æ›´æ–°',0),(6152,171,'pt','Adicionar/atualizar subgrupos',0),(6153,171,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð¿',0),(6154,171,'es','Agregar/Actualizar Subgrupos',0),(6155,171,'de','Untergruppen hinzufÃ¼gen/aktualisieren',0),(6156,171,'en','Add/Update Subgroups',0),(6157,172,'is','',0),(6158,172,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø±ÙŠ ÙƒÙ‡ Ø¯Ø± Ù†Ù…ÙˆÙ†Ù‡ Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ ÙØ§Ù‚Ø¯ ØµÙ„Ø§Ø­ÙŠØª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(6159,172,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø±ÙŠ ÙƒÙ‡ Ø¯Ø± Ù†Ù…ÙˆÙ†Ù‡ Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ ÙØ§Ù‚Ø¯ ØµÙ„Ø§Ø­ÙŠØª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(6160,172,'tr','Demo modunda devre dÄ±ÅŸÄ± kullanÄ±cÄ± ekle',0),(6161,172,'pl','Dodaj uÅ¼ytkownika wyÅ‚Ä…czone w trybie Demo',0),(6162,172,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ», Ð·Ð°Ð±Ñ€Ð°Ð½ÐµÐ½Ð¸ Ð² Ð´ÐµÐ¼Ð¾ Ñ€ÐµÐ¶Ð¸Ð¼',0),(6163,172,'ur','ÚˆÛŒÙ…Ùˆ Ù…ÙˆÚˆ Ù…ÛŒÚº Ù†Ø§Ø§ÛÙ„ ØµØ§Ø±Ù Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(6164,172,'sr','Ð”Ð¾Ð´Ð°Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¾Ð½ÐµÐ¼Ð¾Ð³ÑƒÑ›ÐµÐ½Ðµ Ñƒ Ð”ÐµÐ¼Ð¾ ÐœÐ¾Ð´',0),(6165,172,'vi','ThÃªm NgÆ°á»i Sá»­ Dá»¥ng KhÃ´ng Hoáº¡t Äá»™ng Khi Demo',0),(6166,172,'af','Byvoeging van Gebruiker wat buitewerking gestel is in Demo modus ',0),(6167,172,'ro','Functie dezactivata in regimul DEMO',0),(6168,172,'et','Lisa kasutaja keelanud demoreÅ¾iimis',0),(6169,172,'si','Dodajanje uporabnika v Demo naÄinu onemogoÄena',0),(6170,172,'ba','Tambah Pengguna dinonaktifkan dalam Demo mode',0),(6171,172,'nl','Toevoegen gebruiker uitgeschakeld in de Demo mode',0),(6172,172,'fi','LisÃ¤Ã¤ kÃ¤yttÃ¤jÃ¤ liikuntaesteinen kotona mielenosoitus moodi',0),(6173,172,'no','Legge til bruker deaktivert i Demo-modus',0),(6174,172,'da','TilfÃ¸je brugeren deaktiveret i Demo-tilstand',0),(6175,172,'ko','ë°ëª¨ ëª¨ë“œì—ì„œ ì‚¬ìš© í•˜ì§€ ì•Šë„ë¡ ì„¤ì • í•˜ëŠ” ì‚¬ìš©ìž ì¶”ê°€',0),(6176,172,'he','×”×•×¡×¤×ª ×ž×©×ª×ž×© ×–×ž×™× ×” ×‘×ž×¦×‘ ×”×“×’×ž×”',0),(6177,172,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î· Î±Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î· ÏƒÎµ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± ÎµÏ€Î¯Î´ÎµÎ¹Î¾Î·Ï‚',0),(6178,172,'zh','å¢žåŠ æ¼”ç¤ºæ¨¡å¼ä¸­çš„ç”¨æˆ·ç¦ç”¨\r\n',0),(6179,172,'sv','LÃ¤gg till anvÃ¤ndaren inaktiverat i Demo-lÃ¤ge',0),(6180,172,'it','Aggiungi utente disattivato in modalitÃ  Demo',0),(6181,172,'tl','',0),(6182,172,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;&#3651;&#3609;&#3650;&#3627;&#3617;&#3604; Demo',0),(6183,172,'hi','à¤¡à¥‡à¤®à¥‹ à¤®à¥‹à¤¡ à¤®à¥‡à¤‚ à¤…à¤•à¥à¤·à¤® à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(6184,172,'ms','Tambah pengguna Kurang Upaya dalam mod Demo',0),(6185,172,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø³ØªØ®Ø¯Ù… Ù…Ø¹Ø·Ù„Ø© ÙÙŠ Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¹Ø±Ø¶',0),(6186,172,'fr','Ajouter utilisateur dÃ©sactivÃ© en mode dÃ©mo',0),(6187,172,'jp','ãƒ‡ãƒ¢ãƒ³ã‚¹ãƒˆãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ãƒ¢ãƒ¼ãƒ‰ã?§ç„¡åŠ¹ã?«ã?ªã?£ã?Ÿãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’è¿½åŠ ',0),(6188,172,'pt','Adicionar usuÃ¡rio desabilitado em modo de demonstraÃ§Ã£o',0),(6189,172,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð¾Ñ‚ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ Ð² Ð´ÐµÐ¼Ð¾-Ñ€ÐµÐ¶Ð¸Ð¼Ðµ',0),(6190,172,'es','Agregar deshabiltado por el Usuario en el modo de Demo',0),(6191,172,'de','FÃ¼gen Sie Benutzer im Demo-Modus deaktiviert',0),(6192,172,'en','Add User disabled in Demo mode',0),(6193,173,'is','',0),(6194,173,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù‚ÙˆÙ‚ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(6195,173,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù‚ÙˆÙ‚ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(6196,173,'tr','Ã‡alÄ±ÅŸan iÃ§in oturum aÃ§ma haklarÄ± Ekle',0),(6197,173,'pl','DodaÄ‡ praw logowania dla pracownika',0),(6198,173,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð²Ñ…Ð¾Ð´ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(6199,173,'ur','Ù„Ø§Ú¯ Ø§Ù† Ú©Û’ Ø­Ù‚ÙˆÙ‚ Ú©Û’ Ù„Ø¦Û’ Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(6200,173,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð·Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(6201,173,'vi','ThÃªm Quyá»n ÄÄƒng Nháº­p Cho NhÃ¢n ViÃªn',0),(6202,173,'af','Aantekenregte vir Werknemer Byvoeg',0),(6203,173,'ro','Adauga Login drepturile pentru angajat',0),(6204,173,'et','Lisage Login Ãµiguste tÃ¶Ã¶taja',0),(6205,173,'si','Dodaj prijava pravic za delavca',0),(6206,173,'ba','Menambahkan Login hak untuk karyawan',0),(6207,173,'nl','Toevoegen Login rechten voor werknemers',0),(6208,173,'fi','LisÃ¤Ã¤ Kirjaudu oikeudet tyÃ¶ntekijÃ¤n',0),(6209,173,'no','Legge til logikk rettigheter for ansatte',0),(6210,173,'da','TilfÃ¸je Login rettigheder for medarbejder',0),(6211,173,'ko','ì§ì›ì— ëŒ€ í•œ ë¡œê·¸ì¸ ê¶Œí•œì„ ì¶”ê°€í•©ë‹ˆë‹¤',0),(6212,173,'he','×”×•×¡×¤×ª ×›× ×™×¡×” ×–×›×•×™×•×ª ×œ×¢×•×‘×“',0),(6213,173,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ Î³Î¹Î± ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿',0),(6214,173,'zh','å¢žåŠ é›‡å‘˜ç™»å½•æƒé™\r\n',0),(6215,173,'sv','LÃ¤gg till logga in rÃ¤ttigheter fÃ¶r medarbetare',0),(6216,173,'it','Aggiungere i diritti di accesso per dipendente',0),(6217,173,'tl','',0),(6218,173,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3626;&#3635;&#3627;&#3619;&#3633;&#3',0),(6219,173,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(6220,173,'ms','Menambah hak log masuk untuk pekerja',0),(6221,173,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ù‚ÙˆÙ‚ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ù„Ù„Ù…ÙˆØ¸Ù',0),(6222,173,'fr','Ajouter les droits de connexion pour employÃ©',0),(6223,173,'jp','å¾“æ¥­å“¡ã?®ãƒ­ã‚°ã‚¤ãƒ³æ¨©é™?ã‚’è¿½åŠ ',0),(6224,173,'pt','Adicionar direitos de Login para funcionÃ¡rios',0),(6225,173,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð°Ð²Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ð´Ð»Ñ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(6226,173,'es','Agregar Derechos de Login para Empleado',0),(6227,173,'de','Login-Rechte fÃ¼r Mitarbeiter hinzufÃ¼gen',0),(6228,173,'en','Add Login Rights for Employee',0),(6229,174,'is','',0),(6230,174,'dr','Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(6231,174,'pr','Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(6232,174,'tr','Envanter madde yerleÅŸimi baÅŸarÄ±yla eklendi.',0),(6233,174,'pl','PomyÅ›lnie dodano element Magazyn.',0),(6234,174,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¼ÑÑÑ‚Ð¾ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(6235,174,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Û”',0),(6236,174,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°.',0),(6237,174,'vi','ThÃªm Äá»‹a Äiá»ƒm HÃ ng HÃ³a thÃ nh cÃ´ng',0),(6238,174,'af','Bygevoegde inventaris items lokasie was susksesvol.',0),(6239,174,'ro','Locatie articole inventar adaugata cu suuces',0),(6240,174,'et','Lisatud lao kauba asukoha.',0),(6241,174,'si','UspeÅ¡no dodani lokacijo zaloge artikla.',0),(6242,174,'ba','Lokasi Item Inventori berhasil ditambahkan',0),(6243,174,'nl','De locatie van het item van de voorraad worden toegevoegd.',0),(6244,174,'fi','Nimikkeen varastosijainnin lisÃ¤ttiin.',0),(6245,174,'no','Lagt til element lagerlokasjon.',0),(6246,174,'da','TilfÃ¸jet lager varelokation.',0),(6247,174,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ìœ„ì¹˜ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í–ˆìŠµë‹ˆë‹¤.',0),(6248,174,'he','× ×•×¡×£ ×‘×”×¦×œ×—×” ×ž×™×§×•× ×¤×¨×™×˜ ×ž×œ××™.',0),(6249,174,'el','Î ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Î¸Î­ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚.',0),(6250,174,'zh','é™„åŠ åº“å­˜é¡¹ç›®å®šä½æˆåŠŸ\r\n',0),(6251,174,'sv','Lagts till lagerstÃ¤lle artikeln.',0),(6252,174,'it','Posizione oggetto inventario aggiunta correttamente.',0),(6253,174,'tl','',0),(6254,174,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3649;&#3621;&#3657;&#3623;',0),(6255,174,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(6256,174,'ms','Berjaya menambah lokasi item inventori.',0),(6257,174,'ar','Ø£Ø¶ÙŠÙ Ù…ÙˆÙ‚Ø¹ ØµÙ†Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¨Ù†Ø¬Ø§Ø­',0),(6258,174,'fr','Ajouter Inventaire Item Emplacement RÃ©ussi',0),(6259,174,'jp','åœ¨åº«å“?ç›®ã?®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã‚’ç„¡äº‹è¿½åŠ ã?—ã?¾ã?—ã?Ÿ',0),(6260,174,'pt','LocalizaÃ§Ã£o de inventÃ¡rio item adicionado com Ãªxito.',0),(6261,174,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸.',0),(6262,174,'es','Se agregÃ³ ubicaciÃ³n de item de inventario satisfactoriamente',0),(6263,174,'de','Inventar Artikelstandort erfolgreich hinzugefÃ¼gt.',0),(6264,174,'en','Added inventory item location successfully.',0),(6265,175,'is','',0),(6266,175,'dr','Ø§ÙØ²ÙˆØ¯Ù‡ Ø´Ø¯  Ø¨Ù„Ù‡',0),(6267,175,'pr','Ø§ÙØ²ÙˆØ¯Ù‡ Ø´Ø¯  Ø¨Ù„Ù‡',0),(6268,175,'tr','Tamam eklendi',0),(6269,175,'pl','Dodano OK',0),(6270,175,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÐ½Ð¾ ÐžÐš',0),(6271,175,'ur','Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ù¹Ú¾ÛŒÚ© ÛÛ’',0),(6272,175,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð¾',0),(6273,175,'vi','ThÃªm vÃ o OK',0),(6274,175,'af','Bygewerk',0),(6275,175,'ro','Adaugat OK',0),(6276,175,'et','Lisatud OK',0),(6277,175,'si','Doda OK',0),(6278,175,'ba','Penambahan OK',0),(6279,175,'nl','Toegevoegde OK',0),(6280,175,'fi','LisÃ¤tty OK',0),(6281,175,'no','Ekstra OK',0),(6282,175,'da','TilfÃ¸jet OK',0),(6283,175,'ko','ì¶”ê°€ í™•ì¸',0),(6284,175,'he','× ×•×¡×£ ×‘×”×¦×œ×—×”',0),(6285,175,'el','Î ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ OK',0),(6286,175,'zh','å¢žåŠ æ‰¹å‡†\r\n',0),(6287,175,'sv','La OK',0),(6288,175,'it','Aggiunto Ok',0),(6289,175,'tl','',0),(6290,175,'th','&#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(6291,175,'hi','à¤ à¥€à¤• à¤¹à¥ˆ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾',0),(6292,175,'ms','Ditambah OK',0),(6293,175,'ar','Ù†Ø¬Ø­Øª Ø§Ù„Ø¥Ø¶Ø§ÙØ©',0),(6294,175,'fr','Ajouter OK',0),(6295,175,'jp','è¿½åŠ OK',0),(6296,175,'pt','OK adicionado',0),(6297,175,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾ ÐžÐš',0),(6298,175,'es','Agregado Bien',0),(6299,175,'de','OK hinzugefÃ¼gt',0),(6300,175,'en','Added OK',0),(6301,176,'is','',0),(6302,176,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙØ²ÙˆØ¯Ù‡ Ø´Ø¯',0),(6303,176,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙØ²ÙˆØ¯Ù‡ Ø´Ø¯',0),(6304,176,'tr','BaÅŸarÄ±yla eklendi.',0),(6305,176,'pl','Dodane pomyÅ›lnie.',0),(6306,176,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(6307,176,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(6308,176,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(6309,176,'vi','ThÃªm vÃ o thÃ nh cÃ´ng',0),(6310,176,'af','Suksesvol bygevoeg.',0),(6311,176,'ro','Adaugat cu succes',0),(6312,176,'et','Lisatud.',0),(6313,176,'si','UspeÅ¡no dodana.',0),(6314,176,'ba','Berhasil ditambahkan',0),(6315,176,'nl','Met succes toegevoegd.',0),(6316,176,'fi','LisÃ¤Ã¤minen onnistui.',0),(6317,176,'no','Lagt til.',0),(6318,176,'da','TilfÃ¸jet.',0),(6319,176,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í–ˆìŠµë‹ˆë‹¤.',0),(6320,176,'he','.×”×•×¡×£ ×‘×”×¦×œ×—×”',0),(6321,176,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(6322,176,'zh','æ·»åŠ æˆåŠŸã€‚\r\n',0),(6323,176,'sv','Lagts till.',0),(6324,176,'it','Aggiunto correttamente.',0),(6325,176,'tl','',0),(6326,176,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(6327,176,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(6328,176,'ms','Berjaya menambah.',0),(6329,176,'ar','Ù†Ø¬Ø­Øª Ø§Ù„Ø¥Ø¶Ø§ÙØ©.',0),(6330,176,'fr','Ajout RÃ©ussi',0),(6331,176,'jp','è¿½åŠ ã?«æˆ?åŠŸ',0),(6332,176,'pt','Adicionado com sucesso.',0),(6333,176,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾.',0),(6334,176,'es','Agregado satisfactoriamente.',0),(6335,176,'de','Erfolgreich hinzugefÃ¼gt.',0),(6336,176,'en','Added successfully.',0),(6337,177,'is','',0),(6338,177,'dr','/ Ø§ØµÙ„Ø§Ø­  Ø§Ø¬Ø²Ø§Ø¡',0),(6339,177,'pr','Ø§ÙØ²ÙˆØ¯Ù† / ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø¬Ø²Ø§Ø¡',0),(6340,177,'tr','BileÅŸeni Ekle/DÃ¼zenle',0),(6341,177,'pl','Dodaj/Edytuj element',0),(6342,177,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚',0),(6343,177,'ur','Ø¬Ø²Ùˆ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(6344,177,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¸',0),(6345,177,'vi','ThÃªm/Sá»­a Chá»¯a ThÃ nh Pháº§n',0),(6346,177,'af','Komponent Byvoeg/Redigeer',0),(6347,177,'ro','Adauga/Editeaza Componenta',0),(6348,177,'et','Lisa/muud komponenti',0),(6349,177,'si','Dodaj/Uredi komponento',0),(6350,177,'ba','Tambah/Koreksi Komponen',0),(6351,177,'nl','Component toevoegen/bewerken',0),(6352,177,'fi','Osan lisÃ¤Ã¤minen tai muokkaaminen',0),(6353,177,'no','Legg til/Rediger komponent',0),(6354,177,'da','TilfÃ¸j/redigÃ©r komponent',0),(6355,177,'ko','êµ¬ì„± ìš”ì†Œ ì¶”ê°€/íŽ¸ì§‘',0),(6356,177,'he','×”×•×¡×£/×¢×¨×•×š ×¨×›×™×‘',0),(6357,177,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(6358,177,'zh','æ–°å¢ž/ç¼–è¾‘å…ƒä»¶\r\n',0),(6359,177,'sv','LÃ¤gg till/redigera komponent',0),(6360,177,'it','Aggiungi/Modifica componente',0),(6361,177,'tl','',0),(6362,177,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(6363,177,'hi','à¤˜à¤Ÿà¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(6364,177,'ms','Tambah/Edit komponen',0),(6365,177,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ù…ÙƒÙˆÙ‘Ù†Ø§Øª',0),(6366,177,'fr','Ajouter/Modifier Composant',0),(6367,177,'jp','éƒ¨å“?ã‚’è¿½åŠ /ç·¨é›†',0),(6368,177,'pt','Adicionar/editar componente',0),(6369,177,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐšÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚ ',0),(6370,177,'es','Agregar/Editar Componente',0),(6371,177,'de','Komponente hinzufÃ¼gen/bearbeiten',0),(6372,177,'en','Add/Edit Component',0),(6373,178,'is','',0),(6374,178,'dr','/ Ø§ØµÙ„Ø§Ø­  Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ùˆ Ù…Ø­Ù„',0),(6375,178,'pr','Ø§ÙØ²ÙˆØ¯Ù† / ÙˆÙŠØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ùˆ Ù…Ø­Ù„',0),(6376,178,'tr','Ekle/DÃ¼zenle fiyatlandÄ±rma & konumu',0),(6377,178,'pl','Dodawanie/edycja cen & lokalizacji',0),(6378,178,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ & Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(6379,178,'ur','& Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ¯ÙˆÛŒÙ† Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(6380,178,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ° & Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(6381,178,'vi','ThÃªm/Sá»­a Chá»¯a GiÃ¡ & Vá»‹ TrÃ­',0),(6382,178,'af','Prys en Ligging Byvoeg/Redigeer',0),(6383,178,'ro','Adauga/Editeaza Pret & Localizare',0),(6384,178,'et','Lisa/muuda hinda ja asukohta',0),(6385,178,'si','Dodaj/Uredi cenitev & mesto',0),(6386,178,'ba','Tambah/Edit Harga & Lokasi',0),(6387,178,'nl','Toevoegen/bewerken prijzen & locatie',0),(6388,178,'fi','LisÃ¤Ã¤ tai Muokkaa hinnoittelu & sijainti',0),(6389,178,'no','Legg til/Rediger priser & plassering',0),(6390,178,'da','TilfÃ¸j/redigÃ©r prissÃ¦tning & placering',0),(6391,178,'ko','ì¶”ê°€/íŽ¸ì§‘ ê°€ê²© & ìœ„ì¹˜',0),(6392,178,'he','×”×•×¡×¤×”/×¢×¨×™×›×” ×©×œ ×ª×ž×—×•×¨ & ×ž×™×§×•×',0),(6393,178,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· & Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(6394,178,'zh','æ–°å¢ž/ç¼–è¾‘å®šä»·å’Œåœ°ç‚¹\r\n',0),(6395,178,'sv','LÃ¤gg till/redigera prissÃ¤ttning & lÃ¤ge',0),(6396,178,'it','Aggiungi/modifica prezzo & posizione',0),(6397,178,'tl','',0),(6398,178,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3619;&#3634;&#3588;&#3634;&#3649;&#3621;&#3632;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(6399,178,'hi','& à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(6400,178,'ms','Tambah/Edit harga & lokasi',0),(6401,178,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ø§Ù„ØªØ³Ø¹ÙŠØ± ÙˆØ§Ù„Ù…ÙˆÙ‚Ø¹',0),(6402,178,'fr','Ajouter/Modifier Prix et Emplacement',0),(6403,178,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³è¿½åŠ /ç·¨é›†',0),(6404,178,'pt','Adicionar/editar preÃ§os & localizaÃ§Ã£o',0),(6405,178,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‹ & Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(6406,178,'es','Agregar/Editar Precio & UbicaciÃ³n',0),(6407,178,'de','HinzufÃ¼gen/Bearbeiten Preise & Lage',0),(6408,178,'en','Add/Edit Pricing & Location',0),(6409,179,'is','',0),(6410,179,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙŠ',0),(6411,179,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙŠ',0),(6412,179,'tr','Addl ÅŸarj Minimum',0),(6413,179,'pl','Minimalna opÅ‚ata Addl',0),(6414,179,'bg','Addl Ñ‚Ð°ÐºÑÐ° Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼',0),(6415,179,'ur','Ø§Ø¯Ø¯Ù„ Ú†Ø§Ø±Ø¬ Ú©Ù… Ø§Ø² Ú©Ù…',0),(6416,179,'sr','ÐÐ´Ð´Ð» Ð¿ÑƒÑšÐµÑšÐµ ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼',0),(6417,179,'vi','PhÃ­ Tá»‘i Thiá»ƒu Cá»™ng ThÃªm',0),(6418,179,'af','Min. Addisionele Heffing',0),(6419,179,'ro','Cost aditional minimum',0),(6420,179,'et','Addl tasu vÃ¤hemalt',0),(6421,179,'si','Minimalno pokvariti se naboj',0),(6422,179,'ba','Biaya Tambahan Minimum',0),(6423,179,'nl','Addl gratis Minimum',0),(6424,179,'fi','Addl ilmaiseksi vÃ¤hintÃ¤Ã¤n',0),(6425,179,'no','Addl kostnad Minimum',0),(6426,179,'da','Addl afgift Minimum',0),(6427,179,'ko','Addl ì¶©ì „ ìµœì†Œ',0),(6428,179,'he','×ž×™× ×™×ž×•× ×”×˜×¢×™× ×” Addl',0),(6429,179,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î· Ï‡ÏÎ­Ï‰ÏƒÎ· addl',0),(6430,179,'zh','æœ€ä½Žé™„åŠ è´¹',0),(6431,179,'sv','Addl avgift minst',0),(6432,179,'it','Aliquota addizionale minima',0),(6433,179,'tl','',0),(6434,179,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(6435,179,'hi','à¤…à¤ªà¤° à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤®',0),(6436,179,'ms','Sekurang-kurangnya caj Addl',0),(6437,179,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† ØªÙ‡Ù…Ø© Ø¥Ø¶Ø§ÙÙŠØ©',0),(6438,179,'fr','Charges SupplÃ©mentaire Minimum',0),(6439,179,'jp','æœ€å°?è¿½åŠ æ–™é‡‘',0),(6440,179,'pt','Addl carga mÃ­nima',0),(6441,179,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð·Ð°Ñ€ÑÐ´ Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼',0),(6442,179,'es','MÃ­nimo Cargo Adicional',0),(6443,179,'de','Addl kostenlos Minimum',0),(6444,179,'en','Addl Charge Minimum',0),(6445,180,'is','',0),(6446,180,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙŠ Ù‡Ø± Ø¯Ù‚ÙŠÙ‚Ù‡ ',0),(6447,180,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙŠ Ù‡Ø± Ø¯Ù‚ÙŠÙ‚Ù‡ ',0),(6448,180,'tr','Addl. yetkili / M',0),(6449,180,'pl','Addl. opÅ‚aty / M',0),(6450,180,'bg','Addl. Ñ‚Ð°ÐºÑÐ° / M',0),(6451,180,'ur','ÙÛŒØ³ Ø§Ø¯Ø¯Ù„. / M',0),(6452,180,'sr','ÐŸÑƒÑšÐµÑšÐµ ÐÐ´Ð´Ð». / Ðœ',0),(6453,180,'vi','PhÃ­ CÃ´ng ThÃªm / M',0),(6454,180,'af','Min. Add. Heffing per m.',0),(6455,180,'ro','Cost aditional / M ',0),(6456,180,'et','Addl. tasuta / M',0),(6457,180,'si','Pokvariti se. brezplaÄno / M',0),(6458,180,'ba','Biaya Tambahan per M',0),(6459,180,'nl','Addl. gratis / M',0),(6460,180,'fi','Addl ilmaiseksi / M',0),(6461,180,'no','Addl. Charge / M',0),(6462,180,'da','Addl. afgift / M',0),(6463,180,'ko','Addl. ì¶©ì „ / M',0),(6464,180,'he','Addl. ×ª×©×œ×•× / M',0),(6465,180,'el','Addl. Î· Ï‡ÏÎ­Ï‰ÏƒÎ· / M',0),(6466,180,'zh','æ¯å€‹æœˆçš„é™„åŠ è´¹',0),(6467,180,'sv','Addl. avgift / M',0),(6468,180,'it','Aliquota addizionale / mese',0),(6469,180,'tl','',0),(6470,180,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;/M',0),(6471,180,'hi','à¤…à¤ªà¤° à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ / M',0),(6472,180,'ms','Addl. caj / M',0),(6473,180,'ar','Ø£. Ø§Ù„Ù…Ø³Ø¤ÙˆÙ„/M',0),(6474,180,'fr','Charges SupplÃ©mentaires / M',0),(6475,180,'jp','è¿½åŠ æ–™é‡‘/M',0),(6476,180,'pt','Addl. carga / M',0),(6477,180,'ru','ÐŸÑ€Ð¸ÑÑ‚Ð°Ð²Ð½Ð¾Ð¹. Ð·Ð°Ñ€ÑÐ´Ð° / Ðœ',0),(6478,180,'es','Cargo Adicional / M',0),(6479,180,'de','Addl. kostenlos / M',0),(6480,180,'en','Addl. Charge / M',0),(6481,181,'is','',0),(6482,181,'dr','Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ  Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾',0),(6483,181,'pr','Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ  Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾',0),(6484,181,'tr','Ek gÃ¶nderilen basÄ±n kurulum',0),(6485,181,'pl','Dodatkowe godziny naciÅ›nij przycisk Setup',0),(6486,181,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Hrs ÐŸÑ€ÐµÑ',0),(6487,181,'ur','Ø§Ø¶Ø§ÙÛŒ Ú¯Ú¾Ù†Ù¹Û’ Ù¾Ø±ÛŒØ³ Ø³ÛŒÙ¹ Ø§Ù¾',0),(6488,181,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ð¸Ñ… Ñ‡ Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ',0),(6489,181,'vi','Setup Giá» In áº¤n Cá»™ng ThÃªm ',0),(6490,181,'af','Addisionele Druk Ure Opgestel',0),(6491,181,'ro','Ore suplimentare apasa setup',0),(6492,181,'et','TÃ¤iendav tundi kasutajaliides',0),(6493,181,'si','Dodatno Hrs pritisnite Setup',0),(6494,181,'ba','Setup jam lembur',0),(6495,181,'nl','Extra uur druk op Setup',0),(6496,181,'fi','LisÃ¤ksi Hrs painamalla Setup',0),(6497,181,'no','Ekstra timer trykk Setup',0),(6498,181,'da','Ekstra timer Tryk pÃ¥ Setup',0),(6499,181,'ko','ì¶”ê°€ ì‹œê°„ ë³´ë„ ì„¤ì¹˜',0),(6500,181,'he','×”×”×ª×§× ×” ×œ×—×¥ ×¢×œ ×©×¢×•×ª × ×•×¡×¤×•×ª',0),(6501,181,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ ÏŽÏÎµÏ‚ Ï„ÏÏ€Î¿Ï… ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(6502,181,'zh','æŒ‰è¨­å®šåŠ ç­è²»ç”¨',0),(6503,181,'sv','Ytterligare timmar tryck pÃ¥ Setup',0),(6504,181,'it','Ore addizionale premi setup',0),(6505,181,'tl','',0),(6506,181,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591; &#3585;&#3604;&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;',0),(6507,181,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ Hrs à¤ªà¥à¤°à¥‡à¤¸ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(6508,181,'ms','Persediaan tambahan jam Seluar',0),(6509,181,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„ØµØ­Ø§ÙØ© Ø³Ø§Ø¹Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ©',0),(6510,181,'fr','Heures additionelles pour Organisation de Presse',0),(6511,181,'jp','è¿½åŠ ãƒ—ãƒ¬ã‚¹æ™‚é–“ã?®è¨­å®š',0),(6512,181,'pt','ConfiguraÃ§Ã£o adicional Hrs de imprensa',0),(6513,181,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ñ‡Ð°ÑÐ¾Ð² Ð¿Ñ€ÐµÑÑ',0),(6514,181,'es','Horas Adicionales de ConfiguraciÃ³n de Prensa',0),(6515,181,'de','ZusÃ¤tzliche Stunden Presse Setup',0),(6516,181,'en','Additional Hrs Press Setup',0),(6517,182,'is','',0),(6518,182,'dr','... 8.5 * 11 Ù‡Ø± ÙƒÙŠÙ„Ùˆ Ú¯Ø±Ù…',0),(6519,182,'pr','Ù¾ÙˆÙ†Ø¯ Ø§Ø¶Ø§ÙÙŠ Ø¯Ø±Ù‡Ø± Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡... 8.5 * 11 Ù‡Ø± ÙƒÙŠÙ„Ùˆ Ú¯Ø±Ù…',0),(6520,182,'tr','Ek lbs/M 8.5x11 pkgs',0),(6521,182,'pl','Pkgs 8.5x11 dodatkowe kg/M',0),(6522,182,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ lbs/M 8.5x11 pkgs',0),(6523,182,'ur','Ø§Ø¶Ø§ÙÛŒ Ù¾ÙˆÙ†Úˆ/M 8.5x11 Ù¾Ú©Ú¯Ø³',0),(6524,182,'sr','ÐŸÐºÐ³Ñ 8.5 x11 Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÐºÐ³/Ðœ',0),(6525,182,'vi','GÃ³i Cá»™ng ThÃªm lbs/M 8.5x11',0),(6526,182,'af','Addisionele pond/M 8.5x11 pkgs',0),(6527,182,'ro','Suplimentar kg/pachet',0),(6528,182,'et','TÃ¤iendav lbs/M 8.5x11 pkgs',0),(6529,182,'si','Dodatne lbs/M 8.5x11 pkgs',0),(6530,182,'ba','Penambahan lbs/m',0),(6531,182,'nl','Extra lbs/M 8.5x11 pkgs',0),(6532,182,'fi','LisÃ¤ksi kg/M 8.5x11 pakettien',0),(6533,182,'no','Ekstra kg/M 8.5x11 pkgs',0),(6534,182,'da','Yderligere lbs/M 8.5x11 pkgs',0),(6535,182,'ko','ì¶”ê°€ íŒŒìš´ë“œ/M 8.5 x 11 pkgs',0),(6536,182,'he','Pkgs 8.5 x11 × ×•×¡×¤×™× ×œ×™×‘×¨×•×ª/M',0),(6537,182,'el','Pkgs 8.5x11 Ï€ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Î»Î¯Î²ÏÎµÏ‚/M',0),(6538,182,'zh','å¢žåŠ  LBS åƒå 8.5x11åŒ…',0),(6539,182,'sv','Ytterligare lbs/M 8.5x11 pkgs',0),(6540,182,'it','Peso addizionale/M pacchi 8.5x11',0),(6541,182,'tl','',0),(6542,182,'th','Additional lbs/M 8.5x11 pkgs',0),(6543,182,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤à¤²à¤¬à¥€à¤à¤¸/M 8.5 x11 pkgs',0),(6544,182,'ms','Kg/M tambahan 8.5x11 pkgs',0),(6545,182,'ar','Ø¨ÙƒØ¬Ø³ 8.5 x11 Ø¥Ø¶Ø§ÙÙŠØ© Ø±Ø·Ù„/M',0),(6546,182,'fr','Additionelle lvrs/M 8.5 X 11 pks.',0),(6547,182,'jp','è¿½åŠ ãƒ?ãƒ³ãƒ‰/M 8.5x11ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸',0),(6548,182,'pt','Adicionais lbs/M 8.5 X11 pkgs',0),(6549,182,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ñ„ÑƒÐ½Ñ‚Ð¾Ð²/Ðœ 8.5x11 pkgs',0),(6550,182,'es','Paquetes Lbs/M Adicional 8.5x11',0),(6551,182,'de','ZusÃ¤tzliche lbs/M 8.5 pkgs',0),(6552,182,'en','Additional lbs/M 8.5x11 pkgs',0),(6553,183,'is','',0),(6554,183,'dr','Ø¯Ø³ØªÙŠØ§Ø±Ø§Ù† Ø§Ø¶Ø§ÙÙŠ ',0),(6555,183,'pr','Ø¯Ø³ØªÙŠØ§Ø±Ø§Ù† Ø§Ø¶Ø§ÙÙŠ ',0),(6556,183,'tr','Addl.Assistants',0),(6557,183,'pl','Addl.Assistants',0),(6558,183,'bg','Addl.Assistants',0),(6559,183,'ur','Addl.Assistants',0),(6560,183,'sr','ÐÐ´Ð´Ð».ÐÑÑÐ¸ÑÑ‚Ð°Ð½Ñ‚Ñ',0),(6561,183,'vi','Trá»£ GiÃºp ThÃªm',0),(6562,183,'af','Add. Assistente',0),(6563,183,'ro','Asistenti Addl.',0),(6564,183,'et','Addl.Assistants',0),(6565,183,'si','Addl.Assistants',0),(6566,183,'ba','Banruan Tambahan',0),(6567,183,'nl','Addl.Assistants',0),(6568,183,'fi','Addl.Assistants',0),(6569,183,'no','Addl.Assistants',0),(6570,183,'da','Addl.Assistants',0),(6571,183,'ko','Addl.Assistants',0),(6572,183,'he','Addl.Assistants',0),(6573,183,'el','Addl.Assistants',0),(6574,183,'zh','æ›´å¤šå¸®åŠ©',0),(6575,183,'sv','Addl.Assistants',0),(6576,183,'it','Addl.Assistants',0),(6577,183,'tl','',0),(6578,183,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3594;&#3656;&#3623;&#3618;',0),(6579,183,'hi','Addl.Assistants',0),(6580,183,'ms','Addl.Assistants',0),(6581,183,'ar','Addl.Assistants',0),(6582,183,'fr','Assitants Additionelles',0),(6583,183,'jp','è¿½åŠ ã‚¢ã‚·ã‚¹ã‚¿ãƒ³ãƒˆ',0),(6584,183,'pt','Addl.Assistants',0),(6585,183,'ru','Addl.Assistants',0),(6586,183,'es','Asistentes Adicionales',0),(6587,183,'de','Addl.Assistants',0),(6588,183,'en','Addl.Assistants',0),(6589,184,'is','',0),(6590,184,'dr','Ø§Ù¾Ø±Ø§ØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ ',0),(6591,184,'pr','Ø§Ù¾Ø±Ø§ØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ ',0),(6592,184,'tr','Addl.Operators',0),(6593,184,'pl','Addl.Operators',0),(6594,184,'bg','Addl.Operators',0),(6595,184,'ur','Addl.Operators',0),(6596,184,'sr','ÐÐ´Ð´Ð».ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ñ',0),(6597,184,'vi','Äiá»u HÃ nh ThÃªm',0),(6598,184,'af','Add. Operateurs',0),(6599,184,'ro','Operatori Addl.',0),(6600,184,'et','Addl.Operators',0),(6601,184,'si','Addl.Operators',0),(6602,184,'ba','Operator Tambahan',0),(6603,184,'nl','Addl.Operators',0),(6604,184,'fi','Addl.Operators',0),(6605,184,'no','Addl.Operators',0),(6606,184,'da','Addl.Operators',0),(6607,184,'ko','Addl.Operators',0),(6608,184,'he','Addl.Operators',0),(6609,184,'el','Addl.Operators',0),(6610,184,'zh','å¢žåŠ æ“ä½œè€…\r\n',0),(6611,184,'sv','Addl.Operators',0),(6612,184,'it','Addl.Operators',0),(6613,184,'tl','',0),(6614,184,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3591;&#3634;&#3609;',0),(6615,184,'hi','Addl.Operators',0),(6616,184,'ms','Addl.Operators',0),(6617,184,'ar','Addl.Operators',0),(6618,184,'fr','Operateurs Additionelles',0),(6619,184,'jp','è¿½åŠ ã‚ªãƒšãƒ¬ãƒ¼ã‚¿ãƒ¼',0),(6620,184,'pt','Addl.Operators',0),(6621,184,'ru','Addl.Operators',0),(6622,184,'es','Operadores Adicionales',0),(6623,184,'de','Addl.Operators',0),(6624,184,'en','Addl.Operators',0),(6625,185,'is','',0),(6626,185,'dr','Ø¢Ø¯Ø±Ø³',0),(6627,185,'pr','Ø¢Ø¯Ø±Ø³',0),(6628,185,'tr','Adres',0),(6629,185,'pl','Adres',0),(6630,185,'bg','ÐÐ´Ñ€ÐµÑ',0),(6631,185,'ur','Ù¾ØªØ§',0),(6632,185,'sr','ÐÐ´Ñ€ÐµÑÐ°',0),(6633,185,'vi','Äá»‹a Chá»‰',0),(6634,185,'af','Adres',0),(6635,185,'ro','Adresa',0),(6636,185,'et','Aadress',0),(6637,185,'si','Naslov',0),(6638,185,'ba','Alamat',0),(6639,185,'nl','Adres',0),(6640,185,'fi','Osoite',0),(6641,185,'no','Adresse',0),(6642,185,'da','Adresse',0),(6643,185,'ko','ì£¼ì†Œ',0),(6644,185,'he','×›×ª×•×‘×ª',0),(6645,185,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(6646,185,'zh','åœ°å€\r\n',0),(6647,185,'sv','Adress',0),(6648,185,'it','Indirizzo',0),(6649,185,'tl','',0),(6650,185,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(6651,185,'hi','à¤ªà¤¤à¥‡',0),(6652,185,'ms','Alamat',0),(6653,185,'ar','Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(6654,185,'fr','Adresse',0),(6655,185,'jp','ä½?æ‰€',0),(6656,185,'pt','EndereÃ§o',0),(6657,185,'ru','ÐÐ´Ñ€ÐµÑ',0),(6658,185,'es','DirecciÃ³n',0),(6659,185,'de','Adresse',0),(6660,185,'en','Address',0),(6661,186,'is','',0),(6662,186,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡',0),(6663,186,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡',0),(6664,186,'tr','DÃ¼zeltilen miktarÄ±',0),(6665,186,'pl','Skorygowana iloÅ›Ä‡',0),(6666,186,'bg','ÐšÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(6667,186,'ur','Ø¨Ù†Û’ Ù…Ù‚Ø¯Ø§Ø±',0),(6668,186,'sr','ÐšÐ¾Ñ€Ð¸Ð³Ð¾Ð²Ð°Ð½Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(6669,186,'vi','Sá»­a Äá»•i Sá»‘ LÆ°á»£ng',0),(6670,186,'af','Reggestelde Hoeveelhede',0),(6671,186,'ro','Ajustate cantitatea',0),(6672,186,'et','Kohandatud kogus',0),(6673,186,'si','Prilagojena koliÄina',0),(6674,186,'ba','Kuantitas yang disesuaikan',0),(6675,186,'nl','Gecorrigeerde hoeveelheid',0),(6676,186,'fi','Oikaistu mÃ¤Ã¤rÃ¤',0),(6677,186,'no','Justerte antallet',0),(6678,186,'da','Indstillede mÃ¦ngde',0),(6679,186,'ko','ì¡°ì •ëœ ìˆ˜ëŸ‰',0),(6680,186,'he','×›×ž×•×ª ×ž× ×•×›×™ ×¢×•× ×ª×™×•×ª',0),(6681,186,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(6682,186,'zh','è°ƒæ•´åŽçš„æ•°é‡\r\n',0),(6683,186,'sv','Justerade kvantiteten',0),(6684,186,'it','QuantitÃ  rettificato',0),(6685,186,'tl','',0),(6686,186,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3649;&#3621;&#3657;&#3623;',0),(6687,186,'hi','à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(6688,186,'ms','Kuantiti yang diselaraskan',0),(6689,186,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¹Ø¯Ù„Ø©',0),(6690,186,'fr','QuantitÃ© ajustÃ©e',0),(6691,186,'jp','èª¿æ•´æ¸ˆæ•°é‡?',0),(6692,186,'pt','Quantidade ajustada',0),(6693,186,'ru','Ð¡ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(6694,186,'es','Ajustado la Cantidad',0),(6695,186,'de','Angepasste Menge',0),(6696,186,'en','Adjusted Quantity',0),(6697,187,'is','',0),(6698,187,'dr','(ØªØ³ÙˆÙŠÙ‡',0),(6699,187,'pr','Ø§ØµÙ„Ø§Ø­Ø§Øª (ØªØ³ÙˆÙŠÙ‡',0),(6700,187,'tr','Ayarlama',0),(6701,187,'pl','Regulacja',0),(6702,187,'bg','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ',0),(6703,187,'ur','Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(6704,187,'sr','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ð°',0),(6705,187,'vi','Sá»­a Äá»•i',0),(6706,187,'af','Regstelling',0),(6707,187,'ro','Ajustare',0),(6708,187,'et','Korrigeerimine',0),(6709,187,'si','Prilagoditev',0),(6710,187,'ba','Penyesuaian',0),(6711,187,'nl','Aanpassing',0),(6712,187,'fi','SÃ¤Ã¤tÃ¶',0),(6713,187,'no','Justering',0),(6714,187,'da','Justering',0),(6715,187,'ko','ì¡°ì •',0),(6716,187,'he','×”×ª××ž×ª',0),(6717,187,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®',0),(6718,187,'zh','è°ƒæ•´\r\n',0),(6719,187,'sv','Justering',0),(6720,187,'it','Regolazione',0),(6721,187,'tl','',0),(6722,187,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(6723,187,'hi','à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(6724,187,'ms','Pelarasan',0),(6725,187,'ar','ØªØ¹Ø¯ÙŠÙ„',0),(6726,187,'fr','Ajustement',0),(6727,187,'jp','èª¿æ•´',0),(6728,187,'pt','Ajuste',0),(6729,187,'ru','Ð ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²ÐºÐ°',0),(6730,187,'es','Ajuste',0),(6731,187,'de','Anpassung',0),(6732,187,'en','Adjustment',0),(6733,188,'is','',0),(6734,188,'dr','ØªØ¹Ø¯ÙŠÙ„Ø§Øª',0),(6735,188,'pr','ØªØ¹Ø¯ÙŠÙ„Ø§Øª',0),(6736,188,'tr','Ayarlamalar',0),(6737,188,'pl','Korekty',0),(6738,188,'bg','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸',0),(6739,188,'ur','Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(6740,188,'sr','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(6741,188,'vi','CÃ¡c Sá»­a Äá»•i',0),(6742,188,'af','Regstellings',0),(6743,188,'ro','AjustÄƒri',0),(6744,188,'et','Korrigeerimine',0),(6745,188,'si','Prilagoditve',0),(6746,188,'ba','Penyesuaian',0),(6747,188,'nl','Aanpassingen',0),(6748,188,'fi','Oikaisut',0),(6749,188,'no','Justeringer',0),(6750,188,'da','Justeringer',0),(6751,188,'ko','ì¡°ì •',0),(6752,188,'he','×”×ª××ž×•×ª',0),(6753,188,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚',0),(6754,188,'zh','è°ƒæ•´\r\n',0),(6755,188,'sv','Justeringar',0),(6756,188,'it','Regolazioni',0),(6757,188,'tl','',0),(6758,188,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(6759,188,'hi','à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(6760,188,'ms','Pelarasan',0),(6761,188,'ar','ØªØ¹Ø¯ÙŠÙ„Ø§Øª',0),(6762,188,'fr','Ajustements',0),(6763,188,'jp','èª¿æ•´',0),(6764,188,'pt','Ajustes',0),(6765,188,'ru','ÐšÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(6766,188,'es','Ajustes',0),(6767,188,'de','Anpassungen',0),(6768,188,'en','Adjustments',0),(6769,189,'is','',0),(6770,189,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§Ø¬Ø±Ø§ÙŠÙŠ ',0),(6771,189,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§Ø¬Ø±Ø§ÙŠÙŠ ',0),(6772,189,'tr','YÃ¶netici Kurulumu',0),(6773,189,'pl','Admin instalacji',0),(6774,189,'bg','Admin Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(6775,189,'ur','Ø§ÛŒÚˆÙ…Ù† Ø³ÛŒÙ¹ Ø§Ù¾',0),(6776,189,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð°Ð´Ð¼Ð¸Ð½',0),(6777,189,'vi','Setup Quáº£n Trá»‹',0),(6778,189,'af','Admin Opstelling',0),(6779,189,'ro','Setari administrare',0),(6780,189,'et','Haldusseaded',0),(6781,189,'si','Admin Setup',0),(6782,189,'ba','Admin Setup',0),(6783,189,'nl','Admin Setup',0),(6784,189,'fi','Admin asetukset',0),(6785,189,'no','Installasjonsprogrammet for admin.',0),(6786,189,'da','Admin installation',0),(6787,189,'ko','ê´€ë¦¬ìž ì„¤ì¹˜',0),(6788,189,'he','×”×’×“×¨×•×ª ×ž× ×”×œ×™×•×ª',0),(6789,189,'el','Admin Setup',0),(6790,189,'zh','ç®¡ç†è®¾ç½®\r\n',0),(6791,189,'sv','Admin Setup',0),(6792,189,'it','admin Setup',0),(6793,189,'tl','',0),(6794,189,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;',0),(6795,189,'hi','à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(6796,189,'ms','Persediaan Admin',0),(6797,189,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø´Ø±Ù',0),(6798,189,'fr','Admin Setup',0),(6799,189,'jp','ç®¡ç?†<br>è¨­å®š',0),(6800,189,'pt','ConfiguraÃ§Ã£o de admin',0),(6801,189,'ru','ÐÐ´Ð¼Ð¸Ð½ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(6802,189,'es','Admin ConfiguraciÃ³n',0),(6803,189,'de','Admin-Setup',0),(6804,189,'en','Admin Setup',0),(6805,190,'is','',0),(6806,190,'dr','Ù…Ø¯ÙŠØ±ÙŠØª',0),(6807,190,'pr','Ù…Ø¯ÙŠØ±ÙŠØª',0),(6808,190,'tr','YÃ¶netim',0),(6809,190,'pl','Administracja',0),(6810,190,'bg','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(6811,190,'ur','Ø§Ù†ØªØ¸Ø§Ù…ÛŒÛ',0),(6812,190,'sr','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ð°',0),(6813,190,'vi','Quáº£n Trá»‹',0),(6814,190,'af','Administrasie',0),(6815,190,'ro','Administrare',0),(6816,190,'et','Administratsioon',0),(6817,190,'si','Uprava',0),(6818,190,'ba','Administrasi',0),(6819,190,'nl','Administratie',0),(6820,190,'fi','Hallinto',0),(6821,190,'no','Administrasjon',0),(6822,190,'da','Administration',0),(6823,190,'ko','ê´€ë¦¬',0),(6824,190,'he','× ×™×”×•×œ',0),(6825,190,'el','Î”Î¹Î¿Î¯ÎºÎ·ÏƒÎ·',0),(6826,190,'zh','ç®¡ç†\r\n',0),(6827,190,'sv','Administration',0),(6828,190,'it','Amministrazione',0),(6829,190,'tl','',0),(6830,190,'th','&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3627;&#3634;&#3619;',0),(6831,190,'hi','à¤ªà¥à¤°à¤¶à¤¾à¤¸à¤¨',0),(6832,190,'ms','Pentadbiran',0),(6833,190,'ar','Ø§Ù„Ø¥Ø¯Ø§Ø±Ø©',0),(6834,190,'fr','Administration',0),(6835,190,'jp','ç®¡ç?†',0),(6836,190,'pt','AdministraÃ§Ã£o',0),(6837,190,'ru','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(6838,190,'es','AdministraciÃ³n',0),(6839,190,'de','Verwaltung',0),(6840,190,'en','Administration',0),(6841,191,'is','',0),(6842,191,'dr','Ø¨Ø¹Ø¯ Ø§Ø² Ø³Ø§Ø¹Ø§Øª ',0),(6843,191,'pr','Ø¨Ø¹Ø¯ Ø§Ø² Ø³Ø§Ø¹Ø§Øª ',0),(6844,191,'tr','Saat sonra',0),(6845,191,'pl','Po godzinach',0),(6846,191,'bg','Ð¡Ð»ÐµÐ´ Ñ‡Ð°ÑÐ°',0),(6847,191,'ur','Ú¯Ú¾Ù†Ù¹Û’ Ú©Û’ Ø¨Ø¹Ø¯',0),(6848,191,'sr','ÐÐ°ÐºÐ¾Ð½ Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(6849,191,'vi','Sau Giá»',0),(6850,191,'af','Na-Ure',0),(6851,191,'ro','DupÄƒ ore',0),(6852,191,'et','PÃ¤rast tundi',0),(6853,191,'si','Po urah',0),(6854,191,'ba','Setelah jam',0),(6855,191,'nl','Na uren',0),(6856,191,'fi','Tunnin kuluttua',0),(6857,191,'no','Etter timer',0),(6858,191,'da','Efter timer',0),(6859,191,'ko','ì‹œê°„ í›„',0),(6860,191,'he','××—×¨×™ ×©×¢×•×ª ×”×¢×‘×•×“×”',0),(6861,191,'el','ÎœÎµÏ„Î¬ Î±Ï€ÏŒ ÏŽÏÎµÏ‚',0),(6862,191,'zh','ä¸‹ç­åŽ\r\n',0),(6863,191,'sv','Efter timmar',0),(6864,191,'it','Dopo ore',0),(6865,191,'tl','',0),(6866,191,'th','&#3627;&#3621;&#3633;&#3591;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(6867,191,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦',0),(6868,191,'ms','Selepas waktu',0),(6869,191,'ar','Ø¨Ø¹Ø¯ Ø§Ù„Ø¯ÙˆØ§Ù…',0),(6870,191,'fr','AprÃ¨s les heures',0),(6871,191,'jp','æ™‚é–“å¤–',0),(6872,191,'pt','Depois de horas',0),(6873,191,'ru','ÐŸÐ¾ÑÐ»Ðµ Ñ‡Ð°ÑÐ°',0),(6874,191,'es','DespuÃ©s de Horas de Trabajo',0),(6875,191,'de','Nach Stunden',0),(6876,191,'en','After Hours',0),(6877,192,'is','',0),(6878,192,'dr','Ø¨Ø¹Ø¯ Ø§Ø² Ø³Ø§Ø¹Ø§Øª ØªÙ„ÙÙ† ',0),(6879,192,'pr','Ø¨Ø¹Ø¯ Ø§Ø² Ø³Ø§Ø¹Ø§Øª ØªÙ„ÙÙ† ',0),(6880,192,'tr','Saat telefon sonra',0),(6881,192,'pl','Po godzinach telefonu',0),(6882,192,'bg','Ð¡Ð»ÐµÐ´ Ñ‡Ð°ÑÐ° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(6883,192,'ur','ÙÙˆÙ† Ú¯Ú¾Ù†Ù¹Û’ Ú©Û’ Ø¨Ø¹Ø¯',0),(6884,192,'sr','ÐÐ°ÐºÐ¾Ð½ ÑÐ°Ñ‚Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(6885,192,'vi','Sau Giá» Ä‘iá»‡n thoáº¡i',0),(6886,192,'af','Na-Ure Telefoon',0),(6887,192,'ro','DupÄƒ ore de telefon',0),(6888,192,'et','PÃ¤rast tundi telefoni',0),(6889,192,'si','Po urah telefon',0),(6890,192,'ba','Setelah jam telepon',0),(6891,192,'nl','Na uren telefoon',0),(6892,192,'fi','Kun tuntia Puhelin',0),(6893,192,'no','Etter timers',0),(6894,192,'da','Efter timer telefon',0),(6895,192,'ko','ì‹œê°„ ì „í™” í›„',0),(6896,192,'he','×œ××—×¨ ×©×¢×•×ª ×˜×œ×¤×•×Ÿ',0),(6897,192,'el','ÎœÎµÏ„Î¬ Î±Ï€ÏŒ ÏŽÏÎµÏ‚ Ï„Î·Î»Î­Ï†Ï‰Î½Î¿',0),(6898,192,'zh','ä¸‹ç­åŽç”µè¯\r\n',0),(6899,192,'sv','Efter timmar telefon',0),(6900,192,'it','Dopo ore di telefono',0),(6901,192,'tl','',0),(6902,192,'th','&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;&#3627;&#3621;&#3633;&#3591;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(6903,192,'hi','à¤˜à¤‚à¤Ÿà¥‹à¤‚ à¤«à¥‹à¤¨ à¤•à¥‡ à¤¬à¤¾à¤¦',0),(6904,192,'ms','Selepas jam telefon',0),(6905,192,'ar','Ù‡Ø§ØªÙ Ù…Ø§Ø¨Ø¹Ø¯ Ø§Ù„Ø¯ÙˆØ§Ù…',0),(6906,192,'fr','AprÃ¨s les heures de tÃ©lÃ©phone',0),(6907,192,'jp','æ™‚é–“å¤–é›»è©±',0),(6908,192,'pt','ApÃ³s horas de telefone',0),(6909,192,'ru','ÐŸÐ¾ÑÐ»Ðµ Ñ‡Ð°ÑÐ¾Ð² Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(6910,192,'es','NÃºmero TelefÃ³nica DespuÃ©s de Horas Laborales',0),(6911,192,'de','Nach Stunden Telefon',0),(6912,192,'en','After Hours Phone',0),(6913,193,'is','',0),(6914,193,'dr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ  Ø¨ÙˆØ³ÙŠÙ„Ù‡',0),(6915,193,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ  Ø¨ÙˆØ³ÙŠÙ„Ù‡',0),(6916,193,'tr','YaÅŸlandÄ±rÄ±lma',0),(6917,193,'pl','Starzenie siÄ™ przez',0),(6918,193,'bg','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡Ð²Ð°Ð½Ðµ Ñ',0),(6919,193,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø®Ø³ØªÛ',0),(6920,193,'sr','Ð”Ð¾ÑÐ¿ÐµÐ²Ð°ÑšÐµ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ',0),(6921,193,'vi','Tuá»•i Ná»£ Theo theo',0),(6922,193,'af','Ouderdom Per',0),(6923,193,'ro','ÃŽmbÄƒtrÃ¢nire de',0),(6924,193,'et','Aegumisaruande alus',0),(6925,193,'si','Pregled po',0),(6926,193,'ba','Penuaan oleh',0),(6927,193,'nl','Veroudering door',0),(6928,193,'fi','Tilanne per',0),(6929,193,'no','Aldring av',0),(6930,193,'da','Ã†ldning af',0),(6931,193,'ko','ì— ì˜í•´ ë…¸í™”',0),(6932,193,'he','×”×–×“×§× ×•×ª ×¢×œ ×™×“×™',0),(6933,193,'el','Î•Î½Î·Î»Î¹ÎºÎ¯Ï‰ÏƒÎ· Î±Î½Î¬',0),(6934,193,'zh','æ ¹æ®å¹´åº¦æŽ’åº\r\n',0),(6935,193,'sv','Ã…ldrande av',0),(6936,193,'it','Invecchiamento di',0),(6937,193,'tl','',0),(6938,193,'th','&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3650;&#3604;&#3618;',0),(6939,193,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(6940,193,'ms','Penuaan oleh',0),(6941,193,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© Ù‚Ø¨Ù„',0),(6942,193,'fr','Vieillissement en',0),(6943,193,'jp','ï½žã?¾ã?§ã?®ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°',0),(6944,193,'pt','Envelhecimento por',0),(6945,193,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ',0),(6946,193,'es','AntigÃ¼edad por',0),(6947,193,'de','Alterung von',0),(6948,193,'en','Aging by',0),(6949,194,'is','',0),(6950,194,'dr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ  Ø¨ÙˆØ³ÙŠÙ„Ù‡ ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ±',0),(6951,194,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ  Ø¨ÙˆØ³ÙŠÙ„Ù‡ ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ±',0),(6952,194,'tr','YaÅŸlanma fatura tarihine gÃ¶re',0),(6953,194,'pl','Starzenie siÄ™ od daty wystawienia faktury',0),(6954,194,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð¿Ð¾ Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(6955,194,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø®Ø³ØªÛ',0),(6956,194,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ Ð¿Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(6957,194,'vi','Tuá»•i Ná»£ theo  NgÃ y HÃ³a ÄÆ¡n',0),(6958,194,'af','Ouderdom Per Faktuurdatum',0),(6959,194,'ro','ÃŽmbÄƒtrÃ¢nire de data facturii',0),(6960,194,'et','Vananemine arve kuupÃ¤eva jÃ¤rgi',0),(6961,194,'si','Aging po datumu raÄuna',0),(6962,194,'ba','Aging oleh tanggal faktur',0),(6963,194,'nl','Veroudering door factuurdatum',0),(6964,194,'fi','IkÃ¤Ã¤ntyminen laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n perusteella',0),(6965,194,'no','Aldring av fakturadatoen',0),(6966,194,'da','Ã†ldning af fakturadatoen',0),(6967,194,'ko','ì†¡ìž¥ ë‚ ì§œì— ì˜í•´ ë…¸í™”',0),(6968,194,'he','×”×–×“×§× ×•×ª ×œ×¤×™ ×ª××¨×™×š ×—×©×‘×•× ×™×ª',0),(6969,194,'el','Î“Î®ÏÎ±Î½ÏƒÎ· Î±Ï€ÏŒ Î—Î¼/Î½Î¯Î± Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(6970,194,'zh','æ ¹æ®å‘ç¥¨æ—¥æœŸæŽ’åº\r\n',0),(6971,194,'sv','Ã…ldrande av fakturadatum',0),(6972,194,'it','Invecchiamento da Data fattura',0),(6973,194,'tl','',0),(6974,194,'th','&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3650;&#3604;&#3618;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(6975,194,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡',0),(6976,194,'ms','Penuaan mengikut tarikh invois',0),(6977,194,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© Ø­Ø³Ø¨ ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(6978,194,'fr','Vieillissement de la Date de la facture',0),(6979,194,'jp','è«‹æ±‚æ›¸æ—¥ä»˜é †',0),(6980,194,'pt','Envelhecimento por data de factura',0),(6981,194,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ Ð¿Ð¾ Ð´Ð°Ñ‚Ðµ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(6982,194,'es','AntigÃ¼edad por Fecha de Factura',0),(6983,194,'de','Alterung von Rechnungsdatum',0),(6984,194,'en','Aging By Invoice Date',0),(6985,195,'is','',0),(6986,195,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ ',0),(6987,195,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ ',0),(6988,195,'tr','YaÅŸlanma - Ã–zeti',0),(6989,195,'pl','Starzenie siÄ™ - podsumowanie',0),(6990,195,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ - Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(6991,195,'ur','Ø®Ø³ØªÛ - Ø®Ù„Ø§ØµÛ',0),(6992,195,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ - Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(6993,195,'vi','BÃ¡o CÃ¡o Tuá»•i Ná»£',0),(6994,195,'af','Ouderdomsverslag',0),(6995,195,'ro','ÃŽmbÄƒtrÃ¢nirea - Scurta descriere',0),(6996,195,'et','Vananemine - KokkuvÃµte',0),(6997,195,'si','Staranje - Povzetek',0),(6998,195,'ba','Penuaan - ringkasan',0),(6999,195,'nl','Veroudering - samenvatting',0),(7000,195,'fi','IkÃ¤Ã¤ntyminen - Yhteenveto',0),(7001,195,'no','Aldring - Sammendrag',0),(7002,195,'da','Aldring - ResumÃ©',0),(7003,195,'ko','ë…¸í™”-ìš”ì•½',0),(7004,195,'he','×”×–×“×§× ×•×ª - ×ª×§×¦×™×¨',0),(7005,195,'el','Î“Î®ÏÎ±Î½ÏƒÎ· - Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(7006,195,'zh','æ¬ æ•°åˆ†æžæŠ¥è¡¨\r\n',0),(7007,195,'sv','Ã…ldrande - Sammanfattning',0),(7008,195,'it','Invecchiamento - Sommario',0),(7009,195,'tl','',0),(7010,195,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(7011,195,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ - à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(7012,195,'ms','Penuaan - ringkasan',0),(7013,195,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©-Ù…Ù„Ø®Øµ',0),(7014,195,'fr','Vieillissement - RÃ©sumÃ©',0),(7015,195,'jp','è€?åŒ–å ±å‘Š',0),(7016,195,'pt','Envelhecimento - Resumo',0),(7017,195,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ - Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(7018,195,'es','Informe de AntigÃ¼edad',0),(7019,195,'de','Aging - Zusammenfassung',0),(7020,195,'en','Aging - Summary',0),(7021,196,'is','',0),(7022,196,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù†ÙŠØ§Ø² Ø¨Ù‡ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù† Ø¯Ø§Ø±Ø¯ ',0),(7023,196,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù†ÙŠØ§Ø² Ø¨Ù‡ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù† Ø¯Ø§Ø±Ø¯ ',0),(7024,196,'tr','Kurulum ihtiyacÄ± tamamlandÄ±',0),(7025,196,'pl','Instalator musi zakoÅ„czone',0),(7026,196,'bg','Ð˜Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ñ‰Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸ Ð½ÑƒÐ¶Ð´Ð¸',0),(7027,196,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ù…Ú©Ù…Ù„ Ø¶Ø±ÙˆØ±ÛŒØ§Øª',0),(7028,196,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð¾Ð²Ñ€ÑˆÐ¸Ñ‚Ð¸',0),(7029,196,'vi','Setup cáº§n hoÃ n táº¥t',0),(7030,196,'af','Die opstelling is voltooi moet',0),(7031,196,'ro','Programul de instalare trebuie completat',0),(7032,196,'et','Seadistamine tuleb eelnevalt lÃµpetada',0),(7033,196,'si','Potrebe dokonÄala',0),(7034,196,'ba','Setup kebutuhan selesai',0),(7035,196,'nl','Setup nodig heeft voltooid',0),(7036,196,'fi','Asennus on valmis',0),(7037,196,'no','MÃ¥ fullfÃ¸re installasjonen',0),(7038,196,'da','Setup behov afsluttet',0),(7039,196,'ko','ì„¤ì¹˜ê°€ ì™„ë£Œ í•„ìš”',0),(7040,196,'he','×”×”×ª×§× ×” ×¦×¨×™×š ×œ×”×©×œ×™×',0),(7041,196,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï‡ÏÎµÎ¹Î¬Î¶ÎµÏ„Î±Î¹ Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(7042,196,'zh','å®‰è£…ç¨‹åºéœ€è¦å®Œæˆ\r\n',0),(7043,196,'sv','Installationen behÃ¶ver fÃ¤rdig',0),(7044,196,'it','Installazione completata ha bisogno',0),(7045,196,'tl','',0),(7046,196,'th','&#3592;&#3635;&#3648;&#3611;&#3655;&#3609;&#3605;&#3657;&#3629;&#3591;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3651;&#3627;&#3657;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(7047,196,'hi','à¤œà¤°à¥‚à¤°à¤¤ à¤ªà¥‚à¤°à¤¾ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(7048,196,'ms','Persediaan yang perlu dilengkapkan',0),(7049,196,'ar','ÙŠØ­ØªØ§Ø¬ Ø¥ÙƒÙ…Ø§Ù„ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(7050,196,'fr','Installation terminÃ©e a besoin',0),(7051,196,'jp','è¨­å®šå¿…è¦?äº‹é …ã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(7052,196,'pt','InstalaÃ§Ã£o concluÃ­da precisa',0),(7053,196,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ÑÑ‚ÐµÐ¹ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°',0),(7054,196,'es','ConfiguraciÃ³n Necesita Completar',0),(7055,196,'de','Setup muss abgeschlossen',0),(7056,196,'en','Setup needs completed',0),(7057,197,'is','',0),(7058,197,'dr','Ù‡Ù…Ù‡',0),(7059,197,'pr','Ù‡Ù…Ù‡',0),(7060,197,'tr','TÃ¼m',0),(7061,197,'pl','Wszystkie',0),(7062,197,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸',0),(7063,197,'ur','ØªÙ…Ø§Ù…',0),(7064,197,'sr','Ð¡Ð²Ðµ',0),(7065,197,'vi','Táº¥t Cáº£',0),(7066,197,'af','Alle',0),(7067,197,'ro','Toate',0),(7068,197,'et','KÃµik',0),(7069,197,'si','Vse',0),(7070,197,'ba','Semua',0),(7071,197,'nl','Alle',0),(7072,197,'fi','Kaikki',0),(7073,197,'no','Alle',0),(7074,197,'da','Alle',0),(7075,197,'ko','ëª¨ë“ ',0),(7076,197,'he','×”×›×œ',0),(7077,197,'el','ÎŒÎ»Î±',0),(7078,197,'zh','å…¨éƒ¨',0),(7079,197,'sv','Alla',0),(7080,197,'it','Tutti',0),(7081,197,'tl','',0),(7082,197,'th','&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7083,197,'hi','à¤¸à¤­à¥€',0),(7084,197,'ms','Semua',0),(7085,197,'ar','Ø§Ù„Ø¬Ù…ÙŠØ¹',0),(7086,197,'fr','Tous les',0),(7087,197,'jp','å…¨ã?¦',0),(7088,197,'pt','Todos os',0),(7089,197,'ru','Ð’ÑÐµ',0),(7090,197,'es','Todo',0),(7091,197,'de','Alle',0),(7092,197,'en','All',0),(7093,198,'is','',0),(7094,198,'dr','Ù‡Ù…Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§',0),(7095,198,'pr','Ù‡Ù…Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§',0),(7096,198,'tr','TÃ¼m hesaplar',0),(7097,198,'pl','Wszystkie konta',0),(7098,198,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸',0),(7099,198,'ur','ØªÙ…Ø§Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(7100,198,'sr','Ð¡Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(7101,198,'vi','Táº¥t Cáº£ CÃ¡c TK',0),(7102,198,'af','Alle Rekeninge',0),(7103,198,'ro','Toate conturile',0),(7104,198,'et','KÃµik kontod',0),(7105,198,'si','Vsi raÄuni',0),(7106,198,'ba','Semua account',0),(7107,198,'nl','Alle Accounts',0),(7108,198,'fi','Kaikki tilit',0),(7109,198,'no','Alle kontoer',0),(7110,198,'da','Alle konti',0),(7111,198,'ko','ëª¨ë“  ê³„ì •',0),(7112,198,'he','×›×œ ×”×—×©×‘×•× ×•×ª',0),(7113,198,'el','ÎŒÎ»Î¿Î¹ Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(7114,198,'zh','æ‰€æœ‰å¸æˆ·\r\n',0),(7115,198,'sv','Alla konton',0),(7116,198,'it','Tutti gli account',0),(7117,198,'tl','',0),(7118,198,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7119,198,'hi','à¤¸à¤­à¥€ à¤–à¤¾à¤¤à¥‡',0),(7120,198,'ms','Semua akaun',0),(7121,198,'ar','ÙƒØ§ÙØ© Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(7122,198,'fr','Tous les comptes',0),(7123,198,'jp','å…¨ã?¦ã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(7124,198,'pt','Todas as contas',0),(7125,198,'ru','Ð’ÑÐµ ÑÑ‡ÐµÑ‚Ð°',0),(7126,198,'es','Todas las Cuentas',0),(7127,198,'de','Alle Konten',0),(7128,198,'en','All Accounts',0),(7129,199,'is','',0),(7130,199,'dr','Ù‡Ù…Ù‡ Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(7131,199,'pr','Ù‡Ù…Ù‡ Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(7132,199,'tr','TÃ¼m borÃ§ hesaplarÄ± bÃ¶lÃ¼mleri tamamlanmÄ±ÅŸtÄ±r',0),(7133,199,'pl','Wszystkie konta pÅ‚atne odcinki zostaÅ‚y zakoÅ„czone',0),(7134,199,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸ ÑÐµÐºÑ†Ð¸Ð¸ ÑÐ° Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð¸Ð»Ð¸',0),(7135,199,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ ØªÙ…Ø§Ù… Ø´Ø¹Ø¨ÙˆÚº Ú©Ùˆ Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(7136,199,'sr','Ð¡Ð²Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° ÑÐµÐºÑ†Ð¸Ñ˜Ðµ ÑÑƒ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½Ð¸',0),(7137,199,'vi','Táº¥t Cáº£ CÃ¡c Má»¥c Trong TK Pháº£i Tráº£ Ä‘Ã£ hoÃ n táº¥t',0),(7138,199,'af','Alle Rekeninge Betaalbare afdelings is voltooi',0),(7139,199,'ro','Au fost finalizate toate secÅ£iunile conturi de plÄƒtit',0),(7140,199,'et','KÃµik makstavad osad on tÃ¤idetud',0),(7141,199,'si','So bile opravljene vse obveznosti odsekov',0),(7142,199,'ba','Semua account dibayar bagian telah selesai',0),(7143,199,'nl','Alle crediteuren secties zijn afgerond',0),(7144,199,'fi','Ostoreskontra kaiki on suoritettu',0),(7145,199,'no','Alle leverandÃ¸rgjeld inndelingene er fullfÃ¸rt',0),(7146,199,'da','Alle kreditorer sektioner er afsluttet',0),(7147,199,'ko','ëª¨ë“  ê³„ì • ì„¹ì…˜ ì™„ë£Œ',0),(7148,199,'he','×”×•×©×œ×ž×• ×›×œ ×”×ž×§×˜×¢×™× ×—×©×‘×•× ×•×ª ×–×›××™×',0),(7149,199,'el','ÎˆÏ‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ ÏŒÎ»Î± Ï„Î± Ï„Î¼Î®Î¼Î±Ï„Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ Ï€Î»Î·ÏÏ‰Ï„Î­Î¿Î¹',0),(7150,199,'zh','æ‰€æœ‰åº”ä»˜å¸æ¬¾é¡¹å·²å®Œæˆ\r\n',0),(7151,199,'sv','Alla leverantÃ¶rsreskontra sektioner har slutfÃ¶rts',0),(7152,199,'it','Sono state completate tutte le sezioni di contabilitÃ  fornitori',0),(7153,199,'tl','',0),(7154,199,'th','&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(7155,199,'hi','à¤¸à¤­à¥€ à¤–à¤¾à¤¤à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤¨à¥à¤­à¤¾à¤— à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(7156,199,'ms','Semua bahagian akaun pemiutang telah selesai',0),(7157,199,'ar','ÙˆÙ‚Ø¯ Ø£Ù†Ø¬Ø²Øª Ø¬Ù…ÙŠØ¹ Ø£Ù‚Ø³Ø§Ù… \"Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯Ø§Ø¦Ù†Ø©\"',0),(7158,199,'fr','Toutes les sections crÃ©diteurs ont Ã©tÃ© complÃ©tÃ©es',0),(7159,199,'jp','å…¨ã?¦ã?®è²·æŽ›é‡‘åŒºåˆ†ã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(7160,199,'pt','Completaram-se todas as seÃ§Ãµes de contas a pagar',0),(7161,199,'ru','Ð’ÑÐµ ÑÑ‡ÐµÑ‚Ð° Ðº Ð¾Ð¿Ð»Ð°Ñ‚Ðµ ÑÐµÐºÑ†Ð¸Ð¸ Ð±Ñ‹Ð»Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹',0),(7162,199,'es','Todas las Secciones de Proveedores han sido completadas',0),(7163,199,'de','Alle Accounts Payable Abschnitte sind abgeschlossen',0),(7164,199,'en','All Accounts Payable sections have been completed',0),(7165,200,'is','',0),(7166,200,'dr','ØªÙ…Ø§Ù… Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ Ù…Ø¯ÙŠØ±ÙŠØªÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(7167,200,'pr','ØªÙ…Ø§Ù… Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ Ù…Ø¯ÙŠØ±ÙŠØªÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(7168,200,'tr','TÃ¼m idari bÃ¶lÃ¼mleri tamamlanmÄ±ÅŸtÄ±r',0),(7169,200,'pl','Wszystkie dziaÅ‚y administracyjne zostaÅ‚y zakoÅ„czone',0),(7170,200,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð¸ ÑÐµÐºÑ†Ð¸Ð¸ ÑÐ° Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð¸Ð»Ð¸',0),(7171,200,'ur','ØªÙ…Ø§Ù… Ø§Ù†ØªØ¸Ø§Ù…ÛŒ Ø´Ø¹Ø¨Û Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(7172,200,'sr','Ð¡Ð²Ðµ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ðµ ÑÐµÐºÑ†Ð¸Ñ˜Ðµ ÑÑƒ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½Ð¸',0),(7173,200,'vi','Táº¥t Cáº£ CÃ¡c Má»¥c Quáº£n Trá»‹ Ä‘Ã£ hoÃ n táº¥t',0),(7174,200,'af','Alle Administratiewe afdelings is voltooi',0),(7175,200,'ro','Toate secÅ£iunile Administrative au fost completate',0),(7176,200,'et','KÃµik haldus osad tÃ¤idetud',0),(7177,200,'si','ZakljuÄeni vsi upravni oddelki',0),(7178,200,'ba','Semua bagian administrasi telah selesai',0),(7179,200,'nl','Alle administratieve secties zijn afgerond',0),(7180,200,'fi','Kaikki hallinnolliset osastot on suoritettu',0),(7181,200,'no','Alle Administrative inndelinger er fullfÃ¸rt',0),(7182,200,'da','Alle Administrative sektioner er afsluttet',0),(7183,200,'ko','ëª¨ë“  ê´€ë¦¬ ì„¹ì…˜ ì™„ë£Œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(7184,200,'he','×›×œ ×”×ž×§×˜×¢×™× ×ž×™× ×”×œ×™ ×”×•×©×œ×ž×•',0),(7185,200,'el','ÎˆÏ‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ ÏŒÎ»Î± Ï„Î± Î´Î¹Î¿Î¹ÎºÎ·Ï„Î¹ÎºÎ¬ Ï„Î¼Î®Î¼Î±Ï„Î±',0),(7186,200,'zh','æ‰€æœ‰ç®¡ç†é¡¹å·²ç»å®Œæˆ\r\n',0),(7187,200,'sv','Alla administrativa sektioner har slutfÃ¶rts',0),(7188,200,'it','Sono state completate tutte le sezioni amministrative',0),(7189,200,'tl','',0),(7190,200,'th','&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3627;&#3634;&#3619;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(7191,200,'hi','à¤¸à¤­à¥€ à¤ªà¥à¤°à¤¶à¤¾à¤¸à¤¨à¤¿à¤• à¤…à¤¨à¥à¤­à¤¾à¤— à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(7192,200,'ms','Semua Bahagian Pentadbiran telah selesai',0),(7193,200,'ar','ÙˆÙ‚Ø¯ Ø£Ù†Ø¬Ø²Øª Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø£Ù‚Ø³Ø§Ù… Ø§Ù„Ø¥Ø¯Ø§Ø±ÙŠØ©',0),(7194,200,'fr','Toutes les sections administratives sont terminÃ©es',0),(7195,200,'jp','å…¨ã?¦ã?®ç®¡ç?†åŒºåˆ†ã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(7196,200,'pt','Todas as seÃ§Ãµes administrativas foram concluÃ­das',0),(7197,200,'ru','Ð‘Ñ‹Ð»Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹ Ð²ÑÐµ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð¾Ð¹ ÑÐµÐºÑ†Ð¸Ð¸',0),(7198,200,'es','Todas las Secciones Administrativas han sido completadas',0),(7199,200,'de','Allen Administrative Bereichen sind abgeschlossen',0),(7200,200,'en','All Administrative sections have been completed',0),(7201,201,'is','',0),(7202,201,'dr','ØªÙ…Ø§Ù… Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(7203,201,'pr','ØªÙ…Ø§Ù… Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(7204,201,'tr','TÃ¼m fatura bÃ¶lÃ¼mleri tamamlanmÄ±ÅŸtÄ±r',0),(7205,201,'pl','Wszystkie sekcje rozliczenia zostaÅ‚y zakoÅ„czone',0),(7206,201,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ ÑÐµÐºÑ†Ð¸Ð¸ ÑÐ° Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð¸Ð»Ð¸',0),(7207,201,'ur','Ø¨Ù„Ù†Ú¯ Ú©Û’ ØªÙ…Ø§Ù… Ø´Ø¹Ø¨ÙˆÚº Ú©Ùˆ Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(7208,201,'sr','Ð¡Ð²Ð¸Ð¼ ÑÐµÐºÑ‚Ð¾Ñ€Ð¸Ð¼Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ ÑÑƒ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½Ð¸',0),(7209,201,'vi','Táº¥t Cáº£ CÃ¡c Má»¥c Thanh ToÃ¡n Ä‘Ã£ hoÃ n táº¥t',0),(7210,201,'af','Alle Inkomste afdelings is voltooi',0),(7211,201,'ro','Toate secÅ£iunile de facturare au fost finalizate',0),(7212,201,'et','KÃµik arved osad on tÃ¤idetud',0),(7213,201,'si','Vsi oddelki zaraÄunavanje zakljuÄene',0),(7214,201,'ba','Semua bagian penagihan telah selesai',0),(7215,201,'nl','Alle secties van de facturering zijn voltooid',0),(7216,201,'fi','Kaikki laskutus osat on tehty valmiiksi',0),(7217,201,'no','Alle fakturering deler er fullfÃ¸rt',0),(7218,201,'da','Alle fakturering sektioner er afsluttet',0),(7219,201,'ko','ëª¨ë“  ê²°ì œ ì„¹ì…˜ ì™„ë£Œ',0),(7220,201,'he','×›×œ ×ž×§×˜×¢×™ ×—×™×•×‘ ×”×•×©×œ×ž×•',0),(7221,201,'el','ÎˆÏ‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ ÏŒÎ»Î± Ï„Î± Ï„Î¼Î®Î¼Î±Ï„Î± Ï„Î·Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(7222,201,'zh','æ‰€æœ‰å¼€ç¥¨é¡¹å·²å®Œæˆ\r\n',0),(7223,201,'sv','Alla fakturering sektioner har slutfÃ¶rts',0),(7224,201,'it','Sono state completate tutte le sezioni di fatturazione',0),(7225,201,'tl','',0),(7226,201,'th','&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(7227,201,'hi','à¤¸à¤­à¥€ à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤…à¤¨à¥à¤­à¤¾à¤— à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(7228,201,'ms','Semua bil bahagian telah selesai',0),(7229,201,'ar','ÙˆÙ‚Ø¯ Ø£Ù†Ø¬Ø²Øª Ø¬Ù…ÙŠØ¹ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ù‚Ø§Ø·Ø¹',0),(7230,201,'fr','Toutes les sections de facturation ont Ã©tÃ© complÃ©tÃ©es',0),(7231,201,'jp','å…¨ã?¦ã?®è«‹æ±‚åŒºåˆ†ã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(7232,201,'pt','Completaram-se todas as seÃ§Ãµes de faturamento',0),(7233,201,'ru','Ð’ÑÐµ ÑÐµÐºÑ†Ð¸Ð¸ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³Ð° Ð±Ñ‹Ð»Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹',0),(7234,201,'es','Todas las secciones de Clientes han sido completadas',0),(7235,201,'de','Alle Abschnitte der Abrechnung sind abgeschlossen',0),(7236,201,'en','All Billing sections have been completed',0),(7237,202,'is','',0),(7238,202,'dr','Ù‡Ù…Ù‡ Ø´Ø±ÙƒØª Ù‡Ø§',0),(7239,202,'pr','Ù‡Ù…Ù‡ Ø´Ø±ÙƒØª Ù‡Ø§',0),(7240,202,'tr','TÃ¼m ÅŸirketler',0),(7241,202,'pl','Wszystkich firm',0),(7242,202,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(7243,202,'ur','ØªÙ…Ø§Ù… Ú©Ù…Ù¾Ù†ÛŒØ§Úº',0),(7244,202,'sr','Ð¡Ð²Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(7245,202,'vi','Táº¥t Cáº£ CÃ¡c CÃ´ng Ty',0),(7246,202,'af','Alle Ondernemings',0),(7247,202,'ro','Toate companiile',0),(7248,202,'et','KÃµik ettevÃµtted',0),(7249,202,'si','Vsa podjetja',0),(7250,202,'ba','Semua perusahaan',0),(7251,202,'nl','Alle bedrijven',0),(7252,202,'fi','Kaikki yritykset',0),(7253,202,'no','Alle selskaper',0),(7254,202,'da','Alle virksomheder',0),(7255,202,'ko','ëª¨ë“  íšŒì‚¬',0),(7256,202,'he','×›×œ ×”×—×‘×¨×•×ª',0),(7257,202,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚',0),(7258,202,'zh','æ‰€æœ‰å…¬å¸\r\n',0),(7259,202,'sv','Alla fÃ¶retag',0),(7260,202,'it','Tutte le aziende',0),(7261,202,'tl','',0),(7262,202,'th','&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7263,202,'hi','à¤¸à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¤¾à¤‚',0),(7264,202,'ms','Semua syarikat',0),(7265,202,'ar','ÙƒÙ„ Ø§Ù„Ø´Ø±ÙƒØ§Øª',0),(7266,202,'fr','Toutes les sociÃ©tÃ©s',0),(7267,202,'jp','å…¨ã?¦ã?®ä¼šç¤¾',0),(7268,202,'pt','Todas as empresas',0),(7269,202,'ru','Ð’ÑÐµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(7270,202,'es','Todas las Empresas',0),(7271,202,'de','Alle Firmen',0),(7272,202,'en','All Companies',0),(7273,203,'is','',0),(7274,203,'dr','Ù‡Ù…Ù‡ Ø´Ø±ÙƒØª Ù‡Ø§ Ø¨Ø§ Ù‡Ù… ',0),(7275,203,'pr','Ù‡Ù…Ù‡ Ø´Ø±ÙƒØª Ù‡Ø§ Ø¨Ø§ Ù‡Ù… ',0),(7276,203,'tr','<b>TÃ¼m</b> Åžirketler birlikte',0),(7277,203,'pl','<b>Wszystkie</b> Firm razem',0),(7278,203,'bg','<b>Ð’ÑÐ¸Ñ‡ÐºÐ¸</b> Ð¤Ð¸Ñ€Ð¼Ð¸ Ð·Ð°ÐµÐ´Ð½Ð¾',0),(7279,203,'ur','<b>ØªÙ…Ø§Ù…</b> Ú©Ù…Ù¾Ù†ÛŒØ§Úº Ù…Ù„ Ú©Ø±',0),(7280,203,'sr','<b>Ð¡Ð²Ðµ</b> ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð·Ð°Ñ˜ÐµÐ´Ð½Ð¾',0),(7281,203,'vi','Táº¥t Cáº£ CÃ¡c CÃ´ng Ty CÃ™NG NHAU',0),(7282,203,'af','ALLE Ondernemings TESAME',0),(7283,203,'ro','<b>Toate</b> Companii Ã®mpreunÄƒ',0),(7284,203,'et','<b>KÃµik</b> EttevÃµtted kokku',0),(7285,203,'si','<b>Vse</b> Podjetja, ki skupaj',0),(7286,203,'ba','<b>Semua</b> Perusahaan bersama-sama',0),(7287,203,'nl','<b>Alle</b> Bedrijven samen',0),(7288,203,'fi','<b>Kaikki</b> Yritykset yhdessÃ¤',0),(7289,203,'no','<b>Alle</b> Selskaper sammen',0),(7290,203,'da','<b>Alle</b> Virksomheder sammen',0),(7291,203,'ko','<b>ëª¨ë“ </b> ê¸°ì—…ì´ í•¨ê»˜',0),(7292,203,'he','<b>×›×œ</b> ×—×‘×¨×•×ª ×‘×™×—×“',0),(7293,203,'el','<b>ÎŒÎ»Î±</b> Î•Ï„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Ï€Î¿Ï… Î¼Î±Î¶Î¯',0),(7294,203,'zh','å…¨å…¬å¸æ€»\r\n',0),(7295,203,'sv','<b>Alla</b> FÃ¶retag tillsammans',0),(7296,203,'it','<b>Tutti</b> Aziende insieme',0),(7297,203,'tl','',0),(7298,203,'th','&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3604;&#3657;&#3623;&#3618;&#3585;&#3633;&#3609;',0),(7299,203,'hi','<b>à¤¸à¤­à¥€</b> à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤à¤• à¤¸à¤¾à¤¥',0),(7300,203,'ms','<b>Semua</b> Syarikat-syarikat yang bersama-sama',0),(7301,203,'ar','<b>Ø¬Ù…ÙŠØ¹</b> Ø§Ù„Ø´Ø±ÙƒØ§Øª Ù…Ø¹Ø§',0),(7302,203,'fr','<b>Tous les</b> Ensemble de sociÃ©tÃ©s',0),(7303,203,'jp','å…¨ä¼šç¤¾çº?ã‚?',0),(7304,203,'pt','<b>Todos os</b> Empresas juntas',0),(7305,203,'ru','Ð’ÑÐµ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð’ÐœÐ•Ð¡Ð¢Ð•',0),(7306,203,'es','Todas las Empresas JUNTAS',0),(7307,203,'de','<b>Alle</b> Firmen zusammen',0),(7308,203,'en','<b>All</b> Companies Together',0),(7309,204,'is','',0),(7310,204,'dr','Ù‡Ù…Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(7311,204,'pr','Ù‡Ù…Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(7312,204,'tr','TÃ¼m Ã§alÄ±ÅŸanlarÄ±n',0),(7313,204,'pl','Wszystkich pracownikÃ³w',0),(7314,204,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(7315,204,'ur','ØªÙ…Ø§Ù… Ù…Ù„Ø§Ø²Ù…ÛŒÙ†',0),(7316,204,'sr','Ð¡Ð²Ð¸ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸',0),(7317,204,'vi','Táº¥t Cáº£ NhÃ¢n ViÃªn',0),(7318,204,'af','Alle Werknemer',0),(7319,204,'ro','ToÅ£i angajaÅ£ii',0),(7320,204,'et','KÃµik tÃ¶Ã¶tajad',0),(7321,204,'si','Vsi zaposleni',0),(7322,204,'ba','Semua karyawan',0),(7323,204,'nl','Alle medewerkers',0),(7324,204,'fi','Kaikki tyÃ¶ntekijÃ¤t',0),(7325,204,'no','Alle ansatte',0),(7326,204,'da','Alle medarbejdere',0),(7327,204,'ko','ëª¨ë“  ì§ì›',0),(7328,204,'he','×›×œ ×”×¢×•×‘×“×™×',0),(7329,204,'el','ÎŒÎ»Î¿Î¹ Î¿Î¹ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Î¹',0),(7330,204,'zh','æ‰€æœ‰å‘˜å·¥\r\n',0),(7331,204,'sv','Alla anstÃ¤llda',0),(7332,204,'it','Tutti i dipendenti',0),(7333,204,'tl','',0),(7334,204,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7335,204,'hi','à¤¸à¤­à¥€ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚',0),(7336,204,'ms','Semua kakitangan',0),(7337,204,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(7338,204,'fr','Tous les employÃ©s',0),(7339,204,'jp','å…¨ã?¦ã?®å¾“æ¥­å“¡',0),(7340,204,'pt','Todos os funcionÃ¡rios',0),(7341,204,'ru','Ð’ÑÐµ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¸',0),(7342,204,'es','Todos los Empleados',0),(7343,204,'de','Alle Mitarbeiter',0),(7344,204,'en','All Employees',0),(7345,205,'is','',0),(7346,205,'dr','Ù‡Ù…Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø«Ø¨Øª Ø´Ø¯ ',0),(7347,205,'pr','Ù‡Ù…Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø«Ø¨Øª Ø´Ø¯ ',0),(7348,205,'tr','TÃ¼m Ã§alÄ±ÅŸanlarÄ±n girdi.',0),(7349,205,'pl','Wszystkich pracownikÃ³w wprowadzone.',0),(7350,205,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸ ÑÐ° Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸.',0),(7351,205,'ur','ØªÙ…Ø§Ù… Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ ÛÛ’ Û”',0),(7352,205,'sr','Ð¡Ð²Ð¸ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÑÑƒ ÑƒÐ½ÐµÑ‚Ðµ.',0),(7353,205,'vi','Táº¥t Cáº£ NhÃ¢n ViÃªn ÄÃ£ Cáº­p Nháº­t',0),(7354,205,'af','Alle Werknemers Ingevoer',0),(7355,205,'ro','ToÅ£i angajaÅ£ii au intrat.',0),(7356,205,'et','KÃµik tÃ¶Ã¶tajad sisestatud',0),(7357,205,'si','Vse delavce vnesli.',0),(7358,205,'ba','Semua karyawan yang masuk.',0),(7359,205,'nl','Alle medewerkers ingevoerd.',0),(7360,205,'fi','Kaikkia tyÃ¶ntekijÃ¶itÃ¤ tuli.',0),(7361,205,'no','Alle ansatte som er angitt.',0),(7362,205,'da','Alle medarbejdere ind.',0),(7363,205,'ko','ëª¨ë“  ì§ì› ìž…ë ¥ í•œìž…ë‹ˆë‹¤.',0),(7364,205,'he','×›×œ ×”×¢×•×‘×“×™× ×©×”×•×–×Ÿ.',0),(7365,205,'el','ÎŒÎ»Î¿Î¹ Î¿Î¹ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Î¹ Ï€Î¿Ï… Ï„Î­Î¸Î·ÎºÎµ.',0),(7366,205,'zh','æ‰€æœ‰å‘˜å·¥è¿›å…¥',0),(7367,205,'sv','Alla anstÃ¤llda in.',0),(7368,205,'it','Tutti i dipendenti iscritti.',0),(7369,205,'tl','',0),(7370,205,'th','&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7371,205,'hi','à¤¸à¤­à¥€ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾à¥¤',0),(7372,205,'ms','Semua kakitangan yang dimasukkan.',0),(7373,205,'ar','Ø¯Ø®Ù„Øª ÙƒÙ„ Ù…Ù† Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†.',0),(7374,205,'fr','Tous les employÃ©s inscrits.',0),(7375,205,'jp','å…¨ã?¦ã?®å¾“æ¥­å“¡ã?Œå…¥åŠ›ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(7376,205,'pt','Todos os funcionÃ¡rios que entraram.',0),(7377,205,'ru','Ð’ÑÐµ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¸ Ð’Ð²ÐµÐ´ÐµÐ½Ñ‹.',0),(7378,205,'es','Todos los Empleados Entrados',0),(7379,205,'de','Alle Mitarbeiter eingegeben.',0),(7380,205,'en','All Employees Entered.',0),(7381,206,'is','',0),(7382,206,'dr','Ù‡Ù…Ù‡ Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(7383,206,'pr','Ù‡Ù…Ù‡ Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(7384,206,'tr','TÃ¼m genel muhasebe bÃ¶lÃ¼mleri tamamlanmÄ±ÅŸtÄ±r',0),(7385,206,'pl','Wszystkie ksiÄ™gi gÅ‚Ã³wnej czÄ™Å›ci zostaÅ‚y zakoÅ„czone',0),(7386,206,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ ÑÐµÐºÑ†Ð¸Ð¸ ÑÐ° Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð¸Ð»Ð¸',0),(7387,206,'ur','ØªÙ…Ø§Ù… Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø´Ø¹Ø¨Û Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(7388,206,'sr','Ð¡Ð²Ð° Ð³Ð»Ð°Ð²Ð½Ð° ÐºÑšÐ¸Ð³Ð° ÑÐµÐºÑ†Ð¸Ñ˜Ðµ ÑÑƒ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½Ð¸',0),(7389,206,'vi','Táº¥t Cáº£ CÃ¡c Má»¥c Cá»§a BÃ¡o CÃ¡o Tá»•ng Há»£p Ä‘Ã£ hoÃ n táº¥t',0),(7390,206,'af','Alle Algemene Grootboek-afdelings is voltooi',0),(7391,206,'ro','Toate secÅ£iunile de contabilitate au fost finalizate',0),(7392,206,'et','KÃµik pearaamatu osad tÃ¤idetud',0),(7393,206,'si','ZakljuÄeni vsi oddelki aplikacijskim',0),(7394,206,'ba','Semua bagian General Ledger telah selesai',0),(7395,206,'nl','Alle grootboek secties zijn afgerond',0),(7396,206,'fi','Kaikki pÃ¤Ã¤kirjanpidon osat on tehty valmiiksi',0),(7397,206,'no','Alle finans deler er fullfÃ¸rt',0),(7398,206,'da','Alle General Ledger sektioner er afsluttet',0),(7399,206,'ko','ëª¨ë“  ì´ê³„ì • ì›ìž¥ ì„¹ì…˜ ì™„ë£Œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(7400,206,'he','×”×•×©×œ×ž×• ×›×œ ×”×ž×§×˜×¢×™× ×”×¡×¤×¨ ×”×¨××©×™',0),(7401,206,'el','ÎˆÏ‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ ÏŒÎ»Î± Ï„Î± Ï„Î¼Î®Î¼Î±Ï„Î± Î³ÎµÎ½Î¹ÎºÎ®Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚',0),(7402,206,'zh','æ‰€æœ‰æ€»å¸é¡¹å·²å®Œæˆ\r\n',0),(7403,206,'sv','Alla huvudbok sektioner har slutfÃ¶rts',0),(7404,206,'it','Sono state completate tutte le sezioni di contabilitÃ  generale',0),(7405,206,'tl','',0),(7406,206,'th','&#3607;&#3640;&#3585;&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591; GL &#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(7407,206,'hi','à¤¸à¤­à¥€ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤µà¤°à¥à¤—à¥‹à¤‚ à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(7408,206,'ms','Semua Lejar Am bahagian telah selesai',0),(7409,206,'ar','ÙˆÙ‚Ø¯ Ø£Ù†Ø¬Ø²Øª Ø¬Ù…ÙŠØ¹ Ù…Ù‚Ø§Ø·Ø¹ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(7410,206,'fr','Toutes les sections de la comptabilitÃ© gÃ©nÃ©rale sont terminÃ©es',0),(7411,206,'jp','å…¨ã?¦ã?®ç·?å‹˜å®šå…ƒå¸³åŒºåˆ†ã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(7412,206,'pt','Todas as seÃ§Ãµes do General Ledger foram concluÃ­das',0),(7413,206,'ru','Ð‘Ñ‹Ð»Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹ Ð²ÑÐµ ÑÐµÐºÑ†Ð¸Ð¸ Ð“Ðš',0),(7414,206,'es','Todas las Secciones del Libro Mayor han sido completadas',0),(7415,206,'de','Allen Bereichen der Finanzbuchhaltung sind abgeschlossen',0),(7416,206,'en','All General Ledger sections have been completed',0),(7417,207,'is','',0),(7418,207,'dr','Ù‡Ù…Ù‡ Ø¨Ù‡ Ø·ÙˆØ± Ú¯Ø±ÙˆÙ‡ÙŠ ',0),(7419,207,'pr','Ù‡Ù…Ù‡ Ø¨Ù‡ Ø·ÙˆØ± Ú¯Ø±ÙˆÙ‡ÙŠ ',0),(7420,207,'tr','TÃ¼m grup',0),(7421,207,'pl','W grupie',0),(7422,207,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¾ Ð² Ð³Ñ€ÑƒÐ¿Ð°',0),(7423,207,'ur','Ù…ÛŒÚº ØªÙ…Ø§Ù… Ú¯Ø±ÙˆÙ¾',0),(7424,207,'sr','Ð¡Ð²Ð¸ Ñƒ Ð³Ñ€ÑƒÐ¿Ñƒ',0),(7425,207,'vi','Táº¥t Cáº£ Trong PhÃ¢n NhÃ³m',0),(7426,207,'af','Almal In Groep',0),(7427,207,'ro','Toate Ã®n grup',0),(7428,207,'et','KÃµik jaotises',0),(7429,207,'si','Vse v skupini',0),(7430,207,'ba','Semua dalam grup',0),(7431,207,'nl','All-in-groep',0),(7432,207,'fi','Kaikki ryhmÃ¤ssÃ¤',0),(7433,207,'no','Alle i gruppen',0),(7434,207,'da','Alle i gruppen',0),(7435,207,'ko','ê·¸ë£¹ì— ìžˆëŠ” ëª¨ë“ ',0),(7436,207,'he','×”×›×œ ×‘×§×‘×•×¦×”',0),(7437,207,'el','ÎŸÎ¼Î¬Î´Î±',0),(7438,207,'zh','æ‰€æœ‰ç»„\r\n',0),(7439,207,'sv','Alla i gruppen',0),(7440,207,'it','Tutti In gruppo',0),(7441,207,'tl','',0),(7442,207,'th','&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(7443,207,'hi','à¤¸à¤­à¥€ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚',0),(7444,207,'ms','Semua dalam Kumpulan',0),(7445,207,'ar','ÙƒÙ„ Ø´ÙŠØ¡ ÙÙŠ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(7446,207,'fr','Tous en groupe',0),(7447,207,'jp','ã‚°ãƒ«ãƒ¼ãƒ—å†…ã?™ã?¹ã?¦',0),(7448,207,'pt','Todos em grupo',0),(7449,207,'ru','Ð’ÑÐµ Ð² Ð³Ñ€ÑƒÐ¿Ð¿Ðµ',0),(7450,207,'es','Todos en el Grupo',0),(7451,207,'de','Alle In Gruppe',0),(7452,207,'en','All In Group',0),(7453,208,'is','',0),(7454,208,'dr','Ù‡Ù…Ù‡ Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(7455,208,'pr','Ù‡Ù…Ù‡ Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(7456,208,'tr','TÃ¼m stok bÃ¶lÃ¼mleri tamamlanmÄ±ÅŸtÄ±r',0),(7457,208,'pl','Wszystkie czÄ™Å›ci zapasÃ³w zostaÅ‚y zakoÅ„czone',0),(7458,208,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´ ÑÐ° Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð¸Ð»Ð¸',0),(7459,208,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ ØªÙ…Ø§Ù… Ø´Ø¹Ø¨ÙˆÚº Ú©Ùˆ Ù…Ú©Ù…Ù„ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(7460,208,'sr','Ð¡Ð²Ðµ Ð·Ð°Ð»Ð¸Ñ…Ðµ ÑÐµÐºÑ†Ð¸Ñ˜Ðµ ÑÑƒ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½Ð¸',0),(7461,208,'vi','Táº¥t Cáº£ CÃ¡c Má»¥c HÃ ng HÃ³a Ä‘Ã£ hoÃ n táº¥t',0),(7462,208,'af','Alle voorraad afdelings afgehandel is',0),(7463,208,'ro','Toate secÅ£iunile de inventar au fost finalizate',0),(7464,208,'et','KÃµik varude osad tÃ¤idetud',0),(7465,208,'si','Vsi oddelki zaloge so bile opravljene',0),(7466,208,'ba','Semua bagian persediaan telah selesai',0),(7467,208,'nl','Alle voorraad secties zijn afgerond',0),(7468,208,'fi','Kaikki luettelon kohdat on tÃ¤ytetty',0),(7469,208,'no','Alle lager deler er fullfÃ¸rt',0),(7470,208,'da','Alle lager sektioner er afsluttet',0),(7471,208,'ko','ëª¨ë“  ì¸ë²¤í† ë¦¬ ì„¹ì…˜ ì™„ë£Œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(7472,208,'he','×›×œ ×”×ž×œ××™ ×”×ž×“×•×¨×™× ×›×‘×¨ ×”×•×©×œ×ž×”',0),(7473,208,'el','ÎˆÏ‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ ÏŒÎ»Î± Ï„Î± Ï„Î¼Î®Î¼Î±Ï„Î± Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(7474,208,'zh','æ‰€æœ‰åº“å­˜é¡¹å·²å®Œæˆ\r\n',0),(7475,208,'sv','Alla lager sektioner har slutfÃ¶rts',0),(7476,208,'it','Sono state completate tutte le sezioni di inventario',0),(7477,208,'tl','',0),(7478,208,'th','&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3626;&#3617;&#3610;&#3',0),(7479,208,'hi','à¤¸à¤­à¥€ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤µà¤°à¥à¤—à¥‹à¤‚ à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(7480,208,'ms','Semua inventori bahagian telah selesai',0),(7481,208,'ar','ÙˆÙ‚Ø¯ Ø£Ù†Ø¬Ø²Øª Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ù…Ù‚Ø§Ø·Ø¹',0),(7482,208,'fr','Toutes les sections de l\'inventaire ont Ã©tÃ© remplies',0),(7483,208,'jp','å…¨ã?¦ã?®åœ¨åº«åŒºåˆ†ã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(7484,208,'pt','Todas as seÃ§Ãµes de inventÃ¡rio foram concluÃ­das',0),(7485,208,'ru','Ð‘Ñ‹Ð»Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹ Ð²ÑÐµ ÑÐµÐºÑ†Ð¸Ð¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(7486,208,'es','Todas las secciones de Inventario han sido completadas',0),(7487,208,'de','Alle Inventar-Abschnitte sind abgeschlossen',0),(7488,208,'en','All Inventory sections have been completed',0),(7489,209,'is','',0),(7490,209,'dr','Ù‡Ù…Ù‡ Ù…Ø­Ù„ Ù‡Ø§',0),(7491,209,'pr','Ù‡Ù…Ù‡ Ù…Ø­Ù„ Ù‡Ø§',0),(7492,209,'tr','TÃ¼m konumlar',0),(7493,209,'pl','Wszystkie lokalizacje',0),(7494,209,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(7495,209,'ur','ØªÙ…Ø§Ù… Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(7496,209,'sr','Ð¡Ð²Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(7497,209,'vi','Táº¥t Cáº£ CÃ¡c Vá»‹ TrÃ­',0),(7498,209,'af','Alle Liggings',0),(7499,209,'ro','Toate locaÅ£iile',0),(7500,209,'et','KÃµik asukohad',0),(7501,209,'si','Vse lokacije',0),(7502,209,'ba','Semua lokasi',0),(7503,209,'nl','Alle locaties',0),(7504,209,'fi','Kaikki sijainnit',0),(7505,209,'no','Alle steder',0),(7506,209,'da','Alle steder',0),(7507,209,'ko','ëª¨ë“  ìœ„ì¹˜',0),(7508,209,'he','×›×œ ×”×ž×™×§×•×ž×™×',0),(7509,209,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚',0),(7510,209,'zh','æ‰€æœ‰åœ°ç‚¹\r\n',0),(7511,209,'sv','Alla platser',0),(7512,209,'it','Tutte le sedi',0),(7513,209,'tl','',0),(7514,209,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7515,209,'hi','à¤¸à¤­à¥€ à¤¸à¥à¤¥à¤¾à¤¨',0),(7516,209,'ms','Semua lokasi',0),(7517,209,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…ÙˆØ§Ù‚Ø¹',0),(7518,209,'fr','Tous les emplacements',0),(7519,209,'jp','å…¨ã?¦ã?®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(7520,209,'pt','Todos os locais',0),(7521,209,'ru','Ð’ÑÐµ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(7522,209,'es','Todas Ubicaciones',0),(7523,209,'de','Alle Standorte',0),(7524,209,'en','All Locations',0),(7525,210,'is','',0),(7526,210,'dr','= 0  Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ú¯Ø±Ø§Ù Ø±Ø³Ù… ÙƒÙ†Ø¯',0),(7527,210,'pr','Ù‡Ù…Ù‡ Ø¨Ø®Ø´ Ù‡Ø§ÙŠ Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ = 0  Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ù†Ù…ÙˆØ¯Ø§Ø± Ø±Ø³Ù… ÙƒÙ†Ø¯',0),(7528,210,'tr','Pasta grafiÄŸin tÃ¼m Ã¼yeler = 0, grafik oluÅŸturulamÄ±yor.',0),(7529,210,'pl','Wszystkie elementy wykresu koÅ‚owego = 0, nie moÅ¼na utworzyÄ‡ wykres.',0),(7530,210,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ñ‡Ð»ÐµÐ½Ð¾Ð²Ðµ Ð½Ð° ÐºÑ€ÑŠÐ³Ð¾Ð²Ð° Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð° = 0, Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°.',0),(7531,210,'ur','Ù¾Ø§Ø¦ÛŒ Ú†Ø§Ø±Ù¹ Ú©Û’ ØªÙ…Ø§Ù… Ø§Ø±Ú©Ø§Ù† Ú©ÛŒ = 0, Ù…Ø®Ø·Ø· Ø¨Ù†Ø§ Ø³Ú©ØªØ§ ÛÛ’ Û”',0),(7532,210,'sr','Ð¡Ð²Ð¸ Ñ‡Ð»Ð°Ð½Ð¾Ð²Ð¸ ÐºÑ€ÑƒÐ¶Ð½Ð¸ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ¾Ð½ = 0, Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ¾Ð½.',0),(7533,210,'vi','Táº¥t Cáº£ Thanh ViÃªn cá»§a biá»ƒu Ä‘á»“ pie = 0, khÃ´ng thá»ƒ táº¡o biá»ƒu Ä‘á»“',0),(7534,210,'af','Alle lede van sirkeldiagram grafiek = 0, kan nie grafiek skep',0),(7535,210,'ro','ToÅ£i membrii de diagramÄƒ radialÄƒ = 0, nu se poate crea graficul.',0),(7536,210,'et','KÃµigi liikmete sektordiagrammi = 0, ei saa luua graafik.',0),(7537,210,'si','Vsi Älani tortni grafikon = 0, ne morem ustvariti DirectShow grafa.',0),(7538,210,'ba','Semua anggota pie chart = 0, tidak dapat membuat grafik.',0),(7539,210,'nl','Alle leden van cirkeldiagram = 0, kan niet leiden tot grafiek.',0),(7540,210,'fi','Kaikkien jÃ¤senten ympyrÃ¤kaavio = 0, ei voi luoda kaavio.',0),(7541,210,'no','Alle medlemmer av sektordiagram = 0, kan ikke opprette grafen.',0),(7542,210,'da','Alle medlemmer af cirkeldiagram = 0, kan ikke oprettes en graf.',0),(7543,210,'ko','ì›í˜• ì°¨íŠ¸ì˜ ëª¨ë“  êµ¬ì„±ì› = 0, ê·¸ëž˜í”„ë¥¼ ë§Œë“¤ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(7544,210,'he','×›×œ ×—×‘×¨×™ ×ª×¨×©×™× ×”×¢×•×’×” = 0, ××™×Ÿ ××¤×©×¨×•×ª ×œ×™×¦×•×¨ ×’×¨×£.',0),(7545,210,'el','ÎŒÎ»Î± Ï„Î± Î¼Î­Î»Î· Ï„Î¿Ï… Î³ÏÎ¬Ï†Î·Î¼Î± Ï€Î¯Ï„Î±Ï‚ = 0, Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Ï„Î· Î³ÏÎ±Ï†Î¹ÎºÎ® Ï€Î±ÏÎ¬ÏƒÏ„Î±ÏƒÎ·.',0),(7546,210,'zh','é¦…é¥¼å›¾=0ï¼Œæ‰€æœ‰æˆå‘˜ä¸èƒ½åˆ›å»ºå›¾è¡¨ã€‚\r\n',0),(7547,210,'sv','Alla medlemmar i cirkeldiagrammet = 0 kan inte skapa diagram.',0),(7548,210,'it','Tutti i membri del grafico a torta = 0, non Ã¨ possibile creare un grafico.',0),(7549,210,'tl','',0),(7550,210,'th','&#3626;&#3617;&#3634;&#3594;&#3636;&#3585;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3649;&#3612;&#3609;&#3616;&#3641;&#3617;&#3636;&#3623;&#3591;&#3585;&#3621;&#3617; = 0, &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#36',0),(7551,210,'hi','à¤ªà¤¾à¤‡ à¤šà¤¾à¤°à¥à¤Ÿ à¤•à¥‡ à¤¸à¤­à¥€ à¤¸à¤¦à¤¸à¥à¤¯ = 0, à¤—à¥à¤°à¤¾à¤« à¤¬à¤¨à¤¾ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾à¥¤',0),(7552,210,'ms','Semua ahli-ahli bulatan = 0, tidak boleh membuat graf.',0),(7553,210,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø£Ø¹Ø¶Ø§Ø¡ ÙÙŠ ØªØ®Ø·ÙŠØ· Ø¯Ø§Ø¦Ø±ÙŠ = 0, Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø±Ø³Ù… Ø§Ù„Ø¨ÙŠØ§Ù†ÙŠ.',0),(7554,210,'fr','Tous les membres de camembert = 0, impossible de crÃ©er le graphique.',0),(7555,210,'jp','ãƒ‘ã‚¤ãƒ?ãƒ£ãƒ¼ãƒˆã?®å…¨ã?¦ã?®ãƒ¡ãƒ³ãƒ?ãƒ¼ï¼?ï¼?ã€?ã‚°ãƒ©ãƒ•ã‚’ä½œæˆ?ã?§ã??ã?¾ã?›ã‚“',0),(7556,210,'pt','Todos os membros do grÃ¡fico de pizza = 0, nÃ£o Ã© possÃ­vel criar o grÃ¡fico.',0),(7557,210,'ru','Ð’ÑÐµ Ñ‡Ð»ÐµÐ½Ñ‹ ÑÐµÐºÑ‚Ð¾Ñ€Ð½Ð¾Ð¹ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¼Ñ‹ = 0, Ð½ÐµÐ»ÑŒÐ·Ñ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ð³Ñ€Ð°Ñ„.',0),(7558,210,'es','Todos los miembros de la grÃ¡fica de Pie = 0, no se puede crear la grÃ¡fica',0),(7559,210,'de','Alle Mitglieder des Kreisdiagramms = 0, Graph kann nicht erstellt werden.',0),(7560,210,'en','All members of pie chart = 0, cannot create graph.',0),(7561,211,'is','',0),(7562,211,'dr','Ù‡Ù…Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(7563,211,'pr','Ù‡Ù…Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(7564,211,'tr','TÃ¼m sipariÅŸler',0),(7565,211,'pl','Wszystkie zamÃ³wienia',0),(7566,211,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(7567,211,'ur','ØªÙ…Ø§Ù… Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(7568,211,'sr','Ð¡Ð²Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(7569,211,'vi','Táº¥t Cáº£ ÄÆ¡n Äáº·t HÃ ng',0),(7570,211,'af','Alle Bestellings',0),(7571,211,'ro','Toate comenzile',0),(7572,211,'et','KÃµik tellimused',0),(7573,211,'si','Vsa naroÄila',0),(7574,211,'ba','Semua Pesanan',0),(7575,211,'nl','Alle bestellingen',0),(7576,211,'fi','Kaikki tilaukset',0),(7577,211,'no','Alle bestillinger',0),(7578,211,'da','Alle ordrer',0),(7579,211,'ko','ëª¨ë“  ì£¼ë¬¸',0),(7580,211,'he','×›×œ ×”×”×–×ž× ×•×ª',0),(7581,211,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(7582,211,'zh','æ‰€æœ‰è®¢å•\r\n',0),(7583,211,'sv','Alla bestÃ¤llningar',0),(7584,211,'it','Ordini Tutti',0),(7585,211,'tl','',0),(7586,211,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7587,211,'hi','à¤¸à¤­à¥€ à¤†à¤¦à¥‡à¤¶',0),(7588,211,'ms','Semua pesanan',0),(7589,211,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø·Ù„Ø¨ÙŠØ§Øª',0),(7590,211,'fr','Tous les commandes',0),(7591,211,'jp','å…¨ã?¦ã?®æ³¨æ–‡',0),(7592,211,'pt','Todas as encomendas',0),(7593,211,'ru','Ð’ÑÐµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(7594,211,'es','Todo los Pedidos',0),(7595,211,'de','Alle Bestellungen',0),(7596,211,'en','All Orders',0),(7597,212,'is','',0),(7598,212,'dr','ØªÙ…Ø§Ù… Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡ Ù‡Ø§',0),(7599,212,'pr','ØªÙ…Ø§Ù… Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡ Ù‡Ø§',0),(7600,212,'tr','TÃ¼m vadesi geÃ§miÅŸ',0),(7601,212,'pl','Wszystkie zalegÅ‚e',0),(7602,212,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°ÐºÑŠÑÐ½ÐµÐ»Ð¸',0),(7603,212,'ur','Ø³Ø¨ Ù…ÙˆØ®Ø±',0),(7604,212,'sr','Ð¡Ð²Ðµ ÑÐ° Ð¿Ñ€ÐµÐºÐ¾Ñ€Ð°Ñ‡ÐµÐ½Ð¸Ð¼ Ñ€Ð¾ÐºÐ¾Ð¼',0),(7605,212,'vi','Táº¥t Cáº£ Giao Dá»‹ch QuÃ¡ Háº¡n',0),(7606,212,'af','Alle Agterstalliges',0),(7607,212,'ro','Toate restante',0),(7608,212,'et','Klassitingimuste',0),(7609,212,'si','Vse zapadle',0),(7610,212,'ba','Semua tertunda',0),(7611,212,'nl','Alle achterstallige',0),(7612,212,'fi','Kaikki luokitusehdot',0),(7613,212,'no','Alle forfalte',0),(7614,212,'da','Alle forsÃ¸mte',0),(7615,212,'ko','ëª¨ë“  ì—°ì²´',0),(7616,212,'he','×›×œ ××™×—×•×¨',0),(7617,212,'el','ÎšÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ¿ÏÎ¼ÎµÎ½Î¿Ï…Ï‚',0),(7618,212,'zh','æ‰€æœ‰è¿‡æœŸ\r\n',0),(7619,212,'sv','Alla fÃ¶rfallna',0),(7620,212,'it','Tutti in ritardo',0),(7621,212,'tl','',0),(7622,212,'th','&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7623,212,'hi','à¤¸à¤¬ à¤¸à¥‡ à¤…à¤ªà¥‡à¤•à¥à¤·à¤¿à¤¤',0),(7624,212,'ms','Semua tunggakan',0),(7625,212,'ar','ØªØ£Ø®Ø±Øª ÙÙŠ ØªÙ‚Ø¯ÙŠÙ… Ø¬Ù…ÙŠØ¹',0),(7626,212,'fr','Tout en retard',0),(7627,212,'jp','å…¨ã?¦ã?®å»¶æ»ž',0),(7628,212,'pt','Tudo atrasado',0),(7629,212,'ru','Ð’ÑÐµ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ',0),(7630,212,'es','Todo Vencido',0),(7631,212,'de','Alle Ã¼berfÃ¤lligen',0),(7632,212,'en','All Overdue',0),(7633,213,'is','',0),(7634,213,'dr','Ù‡Ù…Ù‡ Ø­Ù‚ÙˆÙ‚ ',0),(7635,213,'pr','Ù‡Ù…Ù‡ Ø­Ù‚ÙˆÙ‚ ',0),(7636,213,'tr','TÃ¼m Ã¶deme',0),(7637,213,'pl','Wszystkie pÅ‚atnoÅ›ci',0),(7638,213,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(7639,213,'ur','ØªÙ…Ø§Ù… ØªÙ†Ø®ÙˆØ§Û',0),(7640,213,'sr','Ð¡Ð²Ðµ Ð¿Ð»Ð°Ñ‚Ðµ',0),(7641,213,'vi','Táº¥t Cáº£ Thanh ToÃ¡n',0),(7642,213,'af','Al betaal',0),(7643,213,'ro','Toate plata',0),(7644,213,'et','KÃµik maksta',0),(7645,213,'si','Vse plaÄati',0),(7646,213,'ba','Semua Pay',0),(7647,213,'nl','Alle Pay',0),(7648,213,'fi','Kaikki Pay',0),(7649,213,'no','Alle Pay',0),(7650,213,'da','Alle betaler',0),(7651,213,'ko','ëª¨ë“  ì§€ë¶ˆ',0),(7652,213,'he','×›×•×œ× ×• × ×©×œ×',0),(7653,213,'el','Î Î»Î·ÏÏŽÏƒÎ¿Ï…Î¼Îµ ÏŒÎ»Î¿Î¹',0),(7654,213,'zh','æ‰€æœ‰æ”¯ä»˜\r\n',0),(7655,213,'sv','Alla betala',0),(7656,213,'it','Pagano tutti',0),(7657,213,'tl','',0),(7658,213,'th','&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7659,213,'hi','à¤¸à¤¬ à¤ªà¥‡',0),(7660,213,'ms','Membayar semua',0),(7661,213,'ar','Ø¯ÙØ¹ Ø¬Ù…ÙŠØ¹',0),(7662,213,'fr','Tous les Pay',0),(7663,213,'jp','å…¨ã?¦ã?®æ”¯æ‰•ã?„',0),(7664,213,'pt','Todos pagam',0),(7665,213,'ru','Ð’ÑÐµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(7666,213,'es','Todo Pago',0),(7667,213,'de','Alle Zahlen',0),(7668,213,'en','All Pay',0),(7669,214,'is','',0),(7670,214,'dr','Ù‡Ù…Ù‡ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ ',0),(7671,214,'pr','Ù‡Ù…Ù‡ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ ',0),(7672,214,'tr','Ã–demek tÃ¼m gruplar',0),(7673,214,'pl','ZapÅ‚aciÄ‡ wszystkie grupy',0),(7674,214,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð³Ñ€ÑƒÐ¿Ð¸',0),(7675,214,'ur','ØªÙ…Ø§Ù… Ú¯Ø±ÙˆÙ¾ÙˆÚº Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(7676,214,'sr','Ð¡Ð²Ð¸ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð³Ñ€ÑƒÐ¿Ðµ',0),(7677,214,'vi','Táº¥t Cáº£ CÃ¡c NhÃ³m Thanh ToÃ¡n',0),(7678,214,'af','Alle Loon Groepe',0),(7679,214,'ro','Toate plÄƒteascÄƒ grupuri',0),(7680,214,'et','KÃµik maksma rÃ¼hmad',0),(7681,214,'si','PlaÄati vse skupine',0),(7682,214,'ba','Semua membayar kelompok',0),(7683,214,'nl','Alle betalen groepen',0),(7684,214,'fi','Kaikki maksaa vÃ¤estÃ¶ryhmien',0),(7685,214,'no','Alle betale grupper',0),(7686,214,'da','Alle betale grupper',0),(7687,214,'ko','ëª¨ë“  ê·¸ë£¹ì„ ì§€ë¶ˆ',0),(7688,214,'he','×ž×©×œ×ž×™× ×›×œ ×§×‘×•×¦×•×ª',0),(7689,214,'el','ÎŒÎ»Î¿Î¹ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Î¿Î¼Î¬Î´ÎµÏ‚',0),(7690,214,'zh','æ‰€æœ‰æ”¯ä»˜ç»„\r\n',0),(7691,214,'sv','Alla betalar grupper',0),(7692,214,'it','Tutti pagare gruppi',0),(7693,214,'tl','',0),(7694,214,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7695,214,'hi','à¤¸à¤­à¥€ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(7696,214,'ms','Semua membayar Kumpulan',0),(7697,214,'ar','Ø¯ÙØ¹ ÙƒØ§ÙØ© Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø§Øª',0),(7698,214,'fr','Tous les groupes de paye',0),(7699,214,'jp','å…¨ã?¦ã?®æ”¯æ‰•ã?„ã‚°ãƒ«ãƒ¼ãƒ—',0),(7700,214,'pt','Todos pagarem grupos',0),(7701,214,'ru','Ð’ÑÐµ Ð¿Ð»Ð°Ñ‚ÑÑ‚ Ð³Ñ€ÑƒÐ¿Ð¿',0),(7702,214,'es','Todo los Grupos de Nomina',0),(7703,214,'de','Alle bezahlen Gruppen',0),(7704,214,'en','All Pay Groups',0),(7705,215,'is','',0),(7706,215,'dr','Ù‡Ù…Ù‡ ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ø·Ø±ÙŠÙ‚',0),(7707,215,'pr','Ù‡Ù…Ù‡ ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ø·Ø±ÙŠÙ‚',0),(7708,215,'tr','TÃ¼m bordro bÃ¶lÃ¼mleri tamamlanmÄ±ÅŸtÄ±r',0),(7709,215,'pl','Wszystkie czÄ™Å›ci wynagrodzenia zostaÅ‚y zakoÅ„czone',0),(7710,215,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ ÑÐµÐºÑ†Ð¸Ð¸ ÑÐ° Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð¸Ð»Ð¸',0),(7711,215,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©Û’ ØªÙ…Ø§Ù… Ø­ØµÛ’ Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(7712,215,'sr','Ð¡Ð²Ðµ ÑÐµÐºÑ†Ð¸Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ ÑÑƒ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½Ð¸',0),(7713,215,'vi','Táº¥t Cáº£ cÃ¡c má»¥c cá»§a Báº£ng LÆ°Æ¡ng Ä‘Ã£ hoÃ n táº¥t',0),(7714,215,'af','Alle Loonrol afdelings is voltooi',0),(7715,215,'ro','Toate secÅ£iunile de salarizare au fost finalizate',0),(7716,215,'et','KÃµik palga osad tÃ¤idetud',0),(7717,215,'si','Vse dele izplaÄane plaÄe so bile opravljene',0),(7718,215,'ba','Semua bagian penggajian telah selesai',0),(7719,215,'nl','Alle loonlijst secties zijn afgerond',0),(7720,215,'fi','Palkanlaskennan kaiki on suoritettu',0),(7721,215,'no','Alle lÃ¸nn deler er fullfÃ¸rt',0),(7722,215,'da','Alle lÃ¸nningslisten sektioner er afsluttet',0),(7723,215,'ko','ëª¨ë“  ê¸‰ì—¬ ì„¹ì…˜ ì™„ë£Œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(7724,215,'he','×›×œ ×”×ž×§×˜×¢×™× ×ž×©×›×•×¨×•×ª ×”×•×©×œ×ž×•',0),(7725,215,'el','ÎˆÏ‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ ÏŒÎ»Î± Ï„Î± Ï„Î¼Î®Î¼Î±Ï„Î± Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(7726,215,'zh','æ‰€æœ‰è–ªé‡‘é¡¹å·²å®Œæˆ\r\n',0),(7727,215,'sv','Alla lÃ¶ner sektioner har slutfÃ¶rts',0),(7728,215,'it','Sono state completate tutte le sezioni del libro paga',0),(7729,215,'tl','',0),(7730,215,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(7731,215,'hi','à¤¸à¤­à¥€ à¤ªà¥‡à¤°à¥‹à¤² à¤µà¤°à¥à¤—à¥‹à¤‚ à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(7732,215,'ms','Semua gaji bahagian telah selesai',0),(7733,215,'ar','ÙˆÙ‚Ø¯ Ø£Ù†Ø¬Ø²Øª Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø§Ù„Ù…Ù‚Ø§Ø·Ø¹',0),(7734,215,'fr','Toutes les sections de paie ont Ã©tÃ© complÃ©tÃ©es',0),(7735,215,'jp','å…¨ã?¦ã?®çµ¦ä¸ŽåŒºåˆ†ã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(7736,215,'pt','Completaram-se todas as seÃ§Ãµes de folha de pagamento',0),(7737,215,'ru','Ð’ÑÐµ Ð§Ð°ÑÑ‚Ð¸ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð¾Ð¹ Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹',0),(7738,215,'es','Todas las secciones de Nomina han sido completados',0),(7739,215,'de','Allen Bereichen der Abrechnung sind abgeschlossen',0),(7740,215,'en','All Payroll sections have been completed',0),(7741,216,'is','',0),(7742,216,'dr','Ù‡Ù…Ù‡ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(7743,216,'pr','Ù‡Ù…Ù‡ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(7744,216,'tr','TÃ¼m alt tÃ¼rleri',0),(7745,216,'pl','Pod wszystkie typy',0),(7746,216,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(7747,216,'ur','ØªÙ…Ø§Ù… Ø§Ù‚Ø³Ø§Ù… Ø³Ø¨ Ø²ÛŒØ±ÙˆÛ',0),(7748,216,'sr','Ð¡ÑƒÐ± ÑÐ²Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸',0),(7749,216,'vi','Táº¥t Cáº£ CÃ¡c Loáº¡i Phá»¥',0),(7750,216,'af','Alle Sub-Tipes',0),(7751,216,'ro','Toate Sub-tipurile',0),(7752,216,'et','KÃµik Sub tÃ¼Ã¼bid',0),(7753,216,'si','Vse Sub vrste',0),(7754,216,'ba','Semua Sub jenis',0),(7755,216,'nl','Alle Sub typen',0),(7756,216,'fi','Kaikki Sub tyypit',0),(7757,216,'no','Alle Sub typer',0),(7758,216,'da','Alle Sub-typer',0),(7759,216,'ko','ëª¨ë“  í•˜ìœ„ ìœ í˜•',0),(7760,216,'he','×¡××‘ ×›×œ ×¡×•×’×™',0),(7761,216,'el','ÎŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÎµÏ€Î¹Î¼Î­ÏÎ¿Ï…Ï‚ Ï„ÏÏ€Î¿Ï…Ï‚',0),(7762,216,'zh','æ‰€æœ‰å­ç±»åž‹\r\n',0),(7763,216,'sv','NÃ¤r alla sub-pixels typer',0),(7764,216,'it','Tutti Sub tipi',0),(7765,216,'tl','',0),(7766,216,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7767,216,'hi','à¤¸à¤­à¥€ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤‰à¤ª',0),(7768,216,'ms','Semua Sub jenis',0),(7769,216,'ar','Ø§Ù„ÙØ±Ø¹ÙŠØ© ÙƒØ§ÙØ© Ø£Ù†ÙˆØ§Ø¹',0),(7770,216,'fr','Les sous Types',0),(7771,216,'jp','å…¨ã?¦ã?®ã‚µãƒ–ã‚¿ã‚¤ãƒ—',0),(7772,216,'pt','Todos Sub tipos',0),(7773,216,'ru','Ð’ÑÐµ ÑÑƒÐ±-Ñ‚Ð¸Ð¿Ñ‹',0),(7774,216,'es','Todos los SubTipos',0),(7775,216,'de','Alle Subpixel Typen',0),(7776,216,'en','All Sub Types',0),(7777,217,'is','',0),(7778,217,'dr','Ù‡Ù…Ù‡ Ø§Ù†Ø¨Ø§Ø±Ù‡Ø§ÙŠ ÙØ±Ø¹ÙŠ',0),(7779,217,'pr','Ù‡Ù…Ù‡ Ø§Ù†Ø¨Ø§Ø±Ù‡Ø§ÙŠ ÙØ±Ø¹ÙŠ',0),(7780,217,'tr','TÃ¼m Substocks',0),(7781,217,'pl','Wszystkie Substocks',0),(7782,217,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Substocks',0),(7783,217,'ur','Ø³Ø¨ Ø³Ø¨Ø³Ù¹Ø§Ú©Ø³',0),(7784,217,'sr','Ð¡Ð²Ðµ Ð¡ÑƒÐ±ÑÑ‚Ð¾Ñ†ÐºÑ',0),(7785,217,'vi','Táº¥t Cáº£ CÃ¡c Máº·t HÃ ng Phá»¥',0),(7786,217,'af','Alle Sub-voorrade',0),(7787,217,'ro','Toate Substocks',0),(7788,217,'et','KÃµik Substocks',0),(7789,217,'si','Vse Substocks',0),(7790,217,'ba','Semua Substocks',0),(7791,217,'nl','Alle Substocks',0),(7792,217,'fi','Kaikki Substocks',0),(7793,217,'no','Alle Substocks',0),(7794,217,'da','Alle Substocks',0),(7795,217,'ko','ëª¨ë“  Substocks',0),(7796,217,'he','×›×œ Substocks',0),(7797,217,'el','ÎŒÎ»Î± Substocks',0),(7798,217,'zh','æ‰€æœ‰Substocks\r\n',0),(7799,217,'sv','Alla Substocks',0),(7800,217,'it','Tutti i Substocks',0),(7801,217,'tl','',0),(7802,217,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3618;&#3656;&#3629;&#3618;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3657;&#3634;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(7803,217,'hi','à¤¸à¤­à¥€ Substocks',0),(7804,217,'ms','Semua Substocks',0),(7805,217,'ar','Ø³ÙˆØ¨Ø³ØªÙˆÙƒØ³ Ø¬Ù…ÙŠØ¹',0),(7806,217,'fr','Tous les sous-stocks',0),(7807,217,'jp','å…¨ã?¦ã?®ã‚µãƒ–ã‚¹ãƒˆãƒƒã‚¯',0),(7808,217,'pt','Todos os Substocks',0),(7809,217,'ru','Ð’ÑÐµ Substocks',0),(7810,217,'es','Todos los Sub Articulos de Inventario',0),(7811,217,'de','Alle Substocks',0),(7812,217,'en','All Substocks',0),(7813,218,'is','',0),(7814,218,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù‡Ù…Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡  Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù† ',0),(7815,218,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù‡Ù…Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡  Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù† ',0),(7816,218,'tr','Faturalama iÃ§in faturalandÄ±rÄ±lmamÄ±ÅŸ tÃ¼m sipariÅŸleri gÃ¶nderme',0),(7817,218,'pl','WyÅ›lij wszystkie zleceÅ„ nieopÅ‚aconych do fakturowania',0),(7818,218,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Unbilled Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(7819,218,'ur','ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„ Ú©Û’ ØªÙ…Ø§Ù… Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯ Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬',0),(7820,218,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ ÑÐ²Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° Ð£Ð½Ð±Ð¸Ð»Ð»ÐµÐ´ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(7821,218,'vi','Gá»­i Táº¥t Cáº£ CÃ¡c ÄÆ¡n HÃ ng ChÆ°a Xuáº¥t HÃ³a ÄÆ¡n Sang BÃªn HÃ³a ÄÆ¡n',0),(7822,218,'af','Alles Ongefaktuurerd',0),(7823,218,'ro','Trimite toate comenzile Unbilled pentru facturare',0),(7824,218,'et','Saada kÃµik arvete koostamisele, millel veel arvet pole',0),(7825,218,'si','PoÅ¡lji vse Unbilled nalogi, fakturiranje',0),(7826,218,'ba','Mengirimkan semua pesanan yang belum ditagih ke faktur',0),(7827,218,'nl','Alle nog niet gefactureerde Orders verzenden facturering',0),(7828,218,'fi','LÃ¤hettÃ¤Ã¤ kaikki Unbilled tilaukset laskutukseen',0),(7829,218,'no','Send alle fakturert ordre til fakturering',0),(7830,218,'da','Send alle faktureret ordrer til fakturering',0),(7831,218,'ko','ëª¨ë“  ë° ì£¼ë¬¸ ì¸ë³´ì´ìŠ¤ ë³´ë‚´ê¸°',0),(7832,218,'he','×œ×©×œ×•×— ××ª ×›×œ ×”×”×–×ž× ×•×ª Unbilled ×œ×”×¤×§×ª ×—×©×‘×•× ×™×ª',0),(7833,218,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Î±Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î· ÏƒÏ„Î·Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(7834,218,'zh','å‘é€æ‰€æœ‰æœªå…¥è´¦è®¢å•ä»¥å¼€å…·å‘ç¥¨\r\n',0),(7835,218,'sv','Skicka alla relaterade order fÃ¶r fakturering',0),(7836,218,'it','Inviare tutte le attivitÃ  non ancora fatturati ordini alla fatturazione',0),(7837,218,'tl','',0),(7838,218,'th','&#3626;&#3656;&#3591;&#3588;&#3635;&#3626;&#3633;&#3657;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3649;&#3626;&#3604;&#3591;&#3610;&#3',0),(7839,218,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ Unbilled à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œà¥‡à¤‚',0),(7840,218,'ms','Menghantar semua pesanan lepas kepada invois',0),(7841,218,'ar','Ø¥Ø±Ø³Ø§Ù„ ÙƒØ§ÙØ© Ø§Ù„Ø·Ù„Ø¨Ø§Øª ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø© Ù„Ù„ÙÙˆØªØ±Ø©',0),(7842,218,'fr','Envoyer toutes les commandes non facturÃ©es Ã  la facturation',0),(7843,218,'jp','å…¨ã?¦ã?®æœªè«‹æ±‚ã?®æ³¨æ–‡ã‚’è«‹æ±‚',0),(7844,218,'pt','Enviar todas as encomendas nÃ£o faturadas para facturaÃ§Ã£o',0),(7845,218,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð½ÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð´Ð»Ñ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(7846,218,'es','Mandar Todos los Pedidos no Facturados a FacturaciÃ³n',0),(7847,218,'de','Senden Sie alle noch nicht fakturierte AuftrÃ¤ge bis zur Fakturierung',0),(7848,218,'en','Send All Unbilled Orders to Invoicing',0),(7849,219,'is','',0),(7850,219,'dr','Ù…Ø¬Ø§Ø²',0),(7851,219,'pr','Ù…Ø¬Ø§Ø²',0),(7852,219,'tr','Ä°zin ver',0),(7853,219,'pl','PozwalajÄ…',0),(7854,219,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸',0),(7855,219,'ur','Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(7856,219,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸',0),(7857,219,'vi','Cho PhÃ©p',0),(7858,219,'af','Toelaat',0),(7859,219,'ro','Permite',0),(7860,219,'et','Luba',0),(7861,219,'si','OmogoÄajo',0),(7862,219,'ba','Memungkinkan',0),(7863,219,'nl','Toestaan',0),(7864,219,'fi','Salli',0),(7865,219,'no','Tillate',0),(7866,219,'da','Tillad',0),(7867,219,'ko','í—ˆìš©',0),(7868,219,'he','××¤×©×¨',0),(7869,219,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½',0),(7870,219,'zh','å…è®¸\r\n',0),(7871,219,'sv','TillÃ¥ta',0),(7872,219,'it','Consentire',0),(7873,219,'tl','',0),(7874,219,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(7875,219,'hi','à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(7876,219,'ms','Membenarkan',0),(7877,219,'ar','ÙŠØ³Ù…Ø­',0),(7878,219,'fr','Permettre',0),(7879,219,'jp','æ®‹é‡?',0),(7880,219,'pt','Permitir',0),(7881,219,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ',0),(7882,219,'es','Permitir',0),(7883,219,'de','ErmÃ¶glichen',0),(7884,219,'en','Allow',0),(7885,220,'is','',0),(7886,220,'dr','( Ø¬Ù…Ø¹ Ø´Ø¯Ù†)',0),(7887,220,'pr','Ù…Ø¬Ø§Ø² Ø¬Ù‡Øª Ø§ÙØ²Ø§ÙŠØ´ ÙŠØ§ÙØªÙ†( Ø¬Ù…Ø¹ Ø´Ø¯Ù†)',0),(7888,220,'tr','Tahakkuk etmeye izin',0),(7889,220,'pl','MoÅ¼liwoÅ›Ä‡ naliczania',0),(7890,220,'bg','ÐœÐ¾Ð³Ð°Ñ‚ Ð´Ð° ÑÐµ Ð½Ð°Ñ‚Ñ€ÑƒÐ¿Ð²Ð°Ñ‚',0),(7891,220,'ur','Ø§Ù¹Ú¾Ù†Ø§ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(7892,220,'sr','Ð”Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾ Ð´Ð° Ð¾ÑÑ‚Ð²Ð°Ñ€ÑƒÑ˜ÐµÑ‚Ðµ',0),(7893,220,'vi','Cho PhÃ©p Tá»•ng Cá»™ng',0),(7894,220,'af','Ophoping Toegelaat',0),(7895,220,'ro','Permisiunea de a acumula',0),(7896,220,'et','Lubatud lisanduma',0),(7897,220,'si','Dovoljeno nastajale',0),(7898,220,'ba','Diizinkan untuk bertambah',0),(7899,220,'nl','Kunnen toenemen',0),(7900,220,'fi','Voi kertyÃ¤',0),(7901,220,'no','Tillatt Ã¥ akkumulere',0),(7902,220,'da','Lov til at opsamle',0),(7903,220,'ko','ë°œìƒ ìˆ˜',0),(7904,220,'he','×ž×•×ª×¨ ×¦×‘×•×¨',0),(7905,220,'el','Î¤Î· Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„Î± Î½Î± Ï„ÏÎ­Ï‡Î¿Ï…Î½',0),(7906,220,'zh','å…è®¸ç´¯ç§¯\r\n',0),(7907,220,'sv','TillÃ¥tet att Periodisera',0),(7908,220,'it','Permesso di accumulare',0),(7909,220,'tl','',0),(7910,220,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(7911,220,'hi','à¤®à¤¿à¤²à¤¨à¥‡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(7912,220,'ms','Dibenarkan untuk terakru',0),(7913,220,'ar','ÙŠØ³Ù…Ø­ Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(7914,220,'fr','A permis d\'accumuler des',0),(7915,220,'jp','å¢—åŠ è¨±å?¯',0),(7916,220,'pt','Permitido acumular',0),(7917,220,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾ ÐÐ°ÐºÐ°Ð¿Ð»Ð¸Ð²Ð°Ñ‚ÑŒÑÑ ',0),(7918,220,'es','Permitido Acumular',0),(7919,220,'de','Auflaufen durften',0),(7920,220,'en','Allowed to accrue',0),(7921,221,'is','',0),(7922,221,'dr','(ÙØ±Ø§Ù‡Ù… Ø´Ø¯Ù‡ )',0),(7923,221,'pr','Ù‚Ø¨Ù„Ø§ Ø¨Ø§ Ù‡Ù… Ø¬Ù…Ø¹ Ø´Ø¯Ù‡ (ÙØ±Ø§Ù‡Ù… Ø´Ø¯Ù‡ )',0),(7924,221,'tr','Zaten montajÄ±',0),(7925,221,'pl','Montowalem juz',0),(7926,221,'bg','Ð’ÐµÑ‡Ðµ ÑÐ³Ð»Ð¾Ð±ÐµÐ½Ð¸',0),(7927,221,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ú©Û’ ÛØ§Úº Ø¬Ù…Ø¹ ÛÙˆÚ¯Ø¦Û’',0),(7928,221,'sr','Ð’ÐµÑ› Ñ˜Ðµ Ð¾ÐºÑƒÐ¿Ð¸Ð¾',0),(7929,221,'vi','ÄÃ£ Táº­p Há»£p',0),(7930,221,'af','Reeds vergader',0),(7931,221,'ro','Deja asamblate',0),(7932,221,'et','Juba kokku pandud',0),(7933,221,'si','Å½e sestavil',0),(7934,221,'ba','Sudah berkumpul',0),(7935,221,'nl','Reeds gemonteerd',0),(7936,221,'fi','Koottuna',0),(7937,221,'no','Allerede montert',0),(7938,221,'da','Allerede samlet',0),(7939,221,'ko','ì´ë¯¸ ì¡°ë¦½',0),(7940,221,'he','×›×‘×¨ ×”×ª××¡×¤×•',0),(7941,221,'el','Î‰Î´Î· ÏƒÏ…Î½Î±ÏÎ¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î¿',0),(7942,221,'zh','å·²ç»„è£…\r\n',0),(7943,221,'sv','Redan har monterats',0),(7944,221,'it','GiÃ  assemblati',0),(7945,221,'tl','',0),(7946,221,'th','&#3619;&#3623;&#3610;&#3619;&#3623;&#3617;&#3648;&#3626;&#3619;&#3655;&#3592;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(7947,221,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤•à¤Ÿà¥à¤ à¤¾ à¤•à¤¿à¤¯à¤¾',0),(7948,221,'ms','Sudah dipasang',0),(7949,221,'ar','Ø³Ø¨Ù‚ ØªØ¬Ù…ÙŠØ¹Ù‡Ø§',0),(7950,221,'fr','DÃ©jÃ  assemblÃ©',0),(7951,221,'jp','æ—¢ã?«æ§‹ç¯‰ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(7952,221,'pt','JÃ¡ montado',0),(7953,221,'ru','Ð£Ð¶Ðµ ÑÐ¾Ð±Ñ€Ð°Ð½',0),(7954,221,'es','Ya Congregado',0),(7955,221,'de','Bereits montiert',0),(7956,221,'en','Already Assembled',0),(7957,222,'is','',0),(7958,222,'dr','.',0),(7959,222,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ .',0),(7960,222,'tr','zaten var.',0),(7961,222,'pl','juÅ¼ istnieje.',0),(7962,222,'bg','Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°.',0),(7963,222,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Û”',0),(7964,222,'sr','Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(7965,222,'vi','Ä‘Ã£ tá»“n táº¡i',0),(7966,222,'af','bestaan alreeds.',0),(7967,222,'ro','existÄƒ deja.',0),(7968,222,'et','on juba olemas.',0),(7969,222,'si','Å¾e obstaja.',0),(7970,222,'ba','sudah ada.',0),(7971,222,'nl','Er bestaat al.',0),(7972,222,'fi','on jo olemassa.',0),(7973,222,'no','finnes allerede.',0),(7974,222,'da','der findes allerede.',0),(7975,222,'ko','ì´ë¯¸ ì¡´ìž¬í•©ë‹ˆë‹¤.',0),(7976,222,'he','×›×‘×¨ ×§×™×™×',0),(7977,222,'el','Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·.',0),(7978,222,'zh','å·²ç»å­˜åœ¨ã€‚\r\n',0),(7979,222,'sv','Det finns redan.',0),(7980,222,'it','esiste giÃ .',0),(7981,222,'tl','',0),(7982,222,'th','&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(7983,222,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆà¥¤',0),(7984,222,'ms','telah wujud.',0),(7985,222,'ar','Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹.',0),(7986,222,'fr','existe dÃ©jÃ .',0),(7987,222,'jp','æ—¢å­˜ã?—ã?¾ã?™',0),(7988,222,'pt','JÃ¡ existe.',0),(7989,222,'ru','ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚.',0),(7990,222,'es','Ya Existe',0),(7991,222,'de','bereits vorhanden ist.',0),(7992,222,'en','already exists.',0),(7993,223,'is','',0),(7994,223,'dr','Ù‚Ø¨Ù„Ø§ Ù†ØµØ¨ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(7995,223,'pr','Ù‚Ø¨Ù„Ø§ Ù†ØµØ¨ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(7996,223,'tr','Zaten yÃ¼klÃ¼',0),(7997,223,'pl','JuÅ¼ zainstalowany',0),(7998,223,'bg','Ð’ÐµÑ‡Ðµ Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½',0),(7999,223,'ur','Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ù†ØµØ¨',0),(8000,223,'sr','Ð’ÐµÑ› Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½',0),(8001,223,'vi','ÄÃ£ cÃ i Ä‘áº·t',0),(8002,223,'af','Alreeds geinstalleer',0),(8003,223,'ro','Deja instalat',0),(8004,223,'et','Juba paigaldatud',0),(8005,223,'si','Å½e nameÅ¡Äen',0),(8006,223,'ba','Sudah diinstal',0),(8007,223,'nl','Al geÃ¯nstalleerd',0),(8008,223,'fi','Jo asennettu',0),(8009,223,'no','Installert',0),(8010,223,'da','Allerede er installeret',0),(8011,223,'ko','ì´ë¯¸ ì„¤ì¹˜ ë˜ì–´',0),(8012,223,'he','×›×‘×¨ ×ž×•×ª×§×Ÿ',0),(8013,223,'el','Î‰Î´Î· ÎµÎ³ÎºÎ±Ï„Î±ÏƒÏ„Î±Î¸ÎµÎ¯',0),(8014,223,'zh','å·²å®‰è£…\r\n',0),(8015,223,'sv','Redan installerat',0),(8016,223,'it','GiÃ  installato',0),(8017,223,'tl','',0),(8018,223,'th','&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(8019,223,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¸à¥à¤¥à¤¾à¤ªà¤¿à¤¤',0),(8020,223,'ms','Telah dipasang',0),(8021,223,'ar','Ù…Ø«Ø¨ØªØ© Ø¨Ø§Ù„ÙØ¹Ù„',0),(8022,223,'fr','DÃ©jÃ  installÃ©',0),(8023,223,'jp','æ—¢ã?«ã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(8024,223,'pt','JÃ¡ instalado',0),(8025,223,'ru','Ð˜ÑƒÐ¶Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¾',0),(8026,223,'es','Ya Instalado',0),(8027,223,'de','Bereits installiert',0),(8028,223,'en','Already installed',0),(8029,224,'is','',0),(8030,224,'dr','ØªØºÙŠÙŠØ±Ø§Øª ',0),(8031,224,'pr','ØªØºÙŠÙŠØ±Ø§Øª ',0),(8032,224,'tr','DeÄŸiÅŸiklikler',0),(8033,224,'pl','Zmiany',0),(8034,224,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸',0),(8035,224,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ',0),(8036,224,'sr','ÐŸÑ€ÐµÐ¿Ñ€Ð°Ð²ÐºÐµ',0),(8037,224,'vi','CÃ¡c Chá»‰nh Sá»­a',0),(8038,224,'af','Veranderings',0),(8039,224,'ro','ModificÄƒri',0),(8040,224,'et','Ãœmberehitus',0),(8041,224,'si','Spremembe',0),(8042,224,'ba','Perubahan',0),(8043,224,'nl','Wijzigingen',0),(8044,224,'fi','Muutokset',0),(8045,224,'no','Endringer',0),(8046,224,'da','Ã†ndringer',0),(8047,224,'ko','ë³€ê²½',0),(8048,224,'he','×©×™× ×•×™×™×',0),(8049,224,'el','ÎœÎµÏ„Î±Î²Î¿Î»Î­Ï‚',0),(8050,224,'zh','æ”¹å»º\r\n',0),(8051,224,'sv','FÃ¶rÃ¤ndringar',0),(8052,224,'it','Alterazioni',0),(8053,224,'tl','',0),(8054,224,'th','&#3585;&#3634;&#3619;&#3604;&#3633;&#3604;&#3649;&#3611;&#3621;&#3591;',0),(8055,224,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(8056,224,'ms','Pengubahsuaian',0),(8057,224,'ar','Ø§Ù„ØªØ¹Ø¯ÙŠÙ„Ø§Øª',0),(8058,224,'fr','AltÃ©rations',0),(8059,224,'jp','å¤‰æ›´',0),(8060,224,'pt','AlteraÃ§Ãµes',0),(8061,224,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(8062,224,'es','Alteraciones',0),(8063,224,'de','Ã„nderungen',0),(8064,224,'en','Alterations',0),(8065,225,'is','',0),(8066,225,'dr','Ù‡Ù…ÙŠØ´Ù‡ Ù†Ø´Ø§Ù† Ø¨Ø¯Ù‡ÙŠØ¯',0),(8067,225,'pr','Ù‡Ù…ÙŠØ´Ù‡ Ù†Ø´Ø§Ù† Ø¨Ø¯Ù‡ÙŠØ¯',0),(8068,225,'tr','Her zaman gÃ¶ster',0),(8069,225,'pl','Zawsze pokazuj',0),(8070,225,'bg','Ð’Ð¸Ð½Ð°Ð³Ð¸ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð¹',0),(8071,225,'ur','ÛÙ…ÛŒØ´Û Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(8072,225,'sr','Ð£Ð²Ð¸Ñ˜ÐµÐº Ð¿Ð¾ÐºÐ°Ð¶Ð¸',0),(8073,225,'vi','LuÃ´n Hiá»ƒn Thá»‹',0),(8074,225,'af','Wys Altyd',0),(8075,225,'ro','Arata mereu',0),(8076,225,'et','Kuva alati',0),(8077,225,'si','Vedno PokaÅ¾i',0),(8078,225,'ba','Selalu Tampilkan',0),(8079,225,'nl','Altijd laten zien',0),(8080,225,'fi','NÃ¤ytÃ¤ aina',0),(8081,225,'no','Vis alltid',0),(8082,225,'da','Vis altid',0),(8083,225,'ko','í•­ìƒ í‘œì‹œ',0),(8084,225,'he','×”×¦×’ ×ª×ž×™×“',0),(8085,225,'el','ÎÎ± ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ Ï€Î¬Î½Ï„Î±',0),(8086,225,'zh','å§‹ç»ˆæ˜¾ç¤º\r\n',0),(8087,225,'sv','Visa alltid',0),(8088,225,'it','Mostrano sempre',0),(8089,225,'tl','',0),(8090,225,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3626;&#3617;&#3629;',0),(8091,225,'hi','à¤¹à¤®à¥‡à¤¶à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(8092,225,'ms','Sentiasa menunjukkan',0),(8093,225,'ar','ØªØ¸Ù‡Ø± Ø¯Ø§Ø¦Ù…Ø§Ù‹',0),(8094,225,'fr','Toujours afficher',0),(8095,225,'jp','å¸¸ã?«è¡¨ç¤º',0),(8096,225,'pt','Sempre mostrar',0),(8097,225,'ru','Ð’ÑÐµÐ³Ð´Ð° ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ',0),(8098,225,'es','Siempre Mostrar',0),(8099,225,'de','Immer anzeigen',0),(8100,225,'en','Always Show',0),(8101,226,'is','',0),(8102,226,'dr','Ù…Ù‚Ø¯Ø§Ø± ',0),(8103,226,'pr','Ù…Ù‚Ø¯Ø§Ø± ',0),(8104,226,'tr','Tutar',0),(8105,226,'pl','Kwota',0),(8106,226,'bg','Ð¡ÑƒÐ¼Ð°',0),(8107,226,'ur','Ù…Ù‚Ø¯Ø§Ø±',0),(8108,226,'sr','Ð˜Ð·Ð½Ð¾Ñ',0),(8109,226,'vi','Sá»‘ LÆ°á»£ng',0),(8110,226,'af','Bedrag',0),(8111,226,'ro','Suma',0),(8112,226,'et','Summa',0),(8113,226,'si','Znesek',0),(8114,226,'ba','Jumlah',0),(8115,226,'nl','Bedrag',0),(8116,226,'fi','MÃ¤Ã¤rÃ¤',0),(8117,226,'no','BelÃ¸p',0),(8118,226,'da','BelÃ¸b',0),(8119,226,'ko','ê¸ˆì•¡',0),(8120,226,'he','×¡×›×•×',0),(8121,226,'el','Î Î¿ÏƒÏŒ',0),(8122,226,'zh','é‡‘é¢\r\n',0),(8123,226,'sv','Belopp',0),(8124,226,'it','Importo',0),(8125,226,'tl','',0),(8126,226,'th','&#3592;&#3635;&#3609;&#3623;&#3609;',0),(8127,226,'hi','à¤°à¤¾à¤¶à¤¿',0),(8128,226,'ms','Jumlah',0),(8129,226,'ar','Ø§Ù„Ù…Ø¨Ù„Øº',0),(8130,226,'fr','Montant',0),(8131,226,'jp','é‡‘é¡?',0),(8132,226,'pt','Quantidade',0),(8133,226,'ru','Ð¡ÑƒÐ¼Ð¼Ð°',0),(8134,226,'es','Cantidad',0),(8135,226,'de','Betrag',0),(8136,226,'en','Amount',0),(8137,227,'is','',0),(8138,227,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡ ',0),(8139,227,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡ ',0),(8140,227,'tr','KapatÄ±lan tutar',0),(8141,227,'pl','Kwota ujÄ™ta',0),(8142,227,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸',0),(8143,227,'ur','Ù…Ù†Ø³Ù„Ú© Ø±Ù‚Ù…',0),(8144,227,'sr','Ð˜Ð·Ð½Ð¾Ñ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ð°Ð»Ð°Ð·Ð¸ Ð¸Ð·Ð¼ÐµÑ’Ñƒ',0),(8145,227,'vi','Sá»‘ Tiá»n KÃ¨m Theo',0),(8146,227,'af','Bedrag Ingesluit',0),(8147,227,'ro','Suma Ã®nchise',0),(8148,227,'et','Suletud summa',0),(8149,227,'si','Znesek zaprtih',0),(8150,227,'ba','Jumlah tertutup',0),(8151,227,'nl','Bijgevoegd bedrag',0),(8152,227,'fi','MÃ¤Ã¤rÃ¤ suljettu',0),(8153,227,'no','BelÃ¸p vedlagt',0),(8154,227,'da','Vedlagt belÃ¸b',0),(8155,227,'ko','ë™ë´‰ í•˜ëŠ” ê¸ˆì•¡',0),(8156,227,'he','×”×¡×›×•× ×”×ž×¦×•×¨×£',0),(8157,227,'el','Î Î¿ÏƒÏŒ Ï€Î¿Ï… ÎµÏƒÏ‰ÎºÎ»ÎµÎ¯ÎµÏ„Î±Î¹',0),(8158,227,'zh','é‡‘é¢å°é—­\r\n',0),(8159,227,'sv','Belopp som omges',0),(8160,227,'it','Acconti',0),(8161,227,'tl','',0),(8162,227,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3611;&#3636;&#3604;',0),(8163,227,'hi','à¤¸à¤‚à¤²à¤—à¥à¤¨ à¤°à¤¾à¤¶à¤¿',0),(8164,227,'ms','Jumlah yang disertakan',0),(8165,227,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø±ÙÙ‚',0),(8166,227,'fr','Montant inclus',0),(8167,227,'jp','å?Œå°?é‡‘é¡?',0),(8168,227,'pt','Montante colocado',0),(8169,227,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ',0),(8170,227,'es','Cantidad Incluida',0),(8171,227,'de','Den Scheckbetrag',0),(8172,227,'en','Amount Enclosed',0),(8173,228,'is','',0),(8174,228,'dr','(Ø§Ø¶Ø§ÙÙŠ) Ø´ØºÙ„',0),(8175,228,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡ (Ø§Ø¶Ø§ÙÙŠ) Ø´ØºÙ„',0),(8176,228,'tr','Ekstra miktar / iÅŸ',0),(8177,228,'pl','Kwoty dodatkowych / praca',0),(8178,228,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´ Ð² Ñ€Ð°Ð·Ð¼ÐµÑ€ / Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(8179,228,'ur','Ø§Ø¶Ø§ÙÛŒ Ø±Ù‚Ù… / Ø¬Ø§Ø¨',0),(8180,228,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ð¾ / Ð¿Ð¾ÑÐ°Ð¾',0),(8181,228,'vi','Sá»‘ Tiá»n DÆ° / Job',0),(8182,228,'af','Bedrag Bykomend / Werkstuk',0),(8183,228,'ro','Suma suplimentarÄƒ / de locuri de muncÄƒ',0),(8184,228,'et','Summa ekstra / amet',0),(8185,228,'si','Znesek dodatno / delo',0),(8186,228,'ba','Jumlah tambahan / Job',0),(8187,228,'nl','Aantal Extra / baan',0),(8188,228,'fi','MÃ¤Ã¤rÃ¤ ylimÃ¤Ã¤rÃ¤istÃ¤ / tyÃ¶paikka',0),(8189,228,'no','Antall ekstra / jobb',0),(8190,228,'da','BelÃ¸b ekstra / Job',0),(8191,228,'ko','ì¶”ê°€ ê¸ˆì•¡/ì§ì—…',0),(8192,228,'he','×¡×›×•× × ×•×¡×£ / ×ª×¤×§×™×“',0),(8193,228,'el','Î Î¿ÏƒÏŒ Î­Î¾Ï„ÏÎ± / ÎµÏÎ³Î±Ïƒ',0),(8194,228,'zh','é¢å¤–é‡‘é¢/èŒä½\r\n',0),(8195,228,'sv','InnebÃ¤ra Extra / jobb',0),(8196,228,'it','L\'importo supplementare / lavoro',0),(8197,228,'tl','',0),(8198,228,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;/&#3591;&#3634;&#3609;',0),(8199,228,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤°à¤¾à¤¶à¤¿ / à¤…à¤¯à¥à¤¯à¥‚à¤¬',0),(8200,228,'ms','Jumlah tambahan / kerja',0),(8201,228,'ar','Ù…Ø¨Ù„Øº Ø¥Ø¶Ø§ÙÙŠ/ÙˆØ¸ÙŠÙØ©',0),(8202,228,'fr','Le montant supplÃ©mentaire / emploi',0),(8203,228,'jp','è¿½åŠ æ–™é‡‘/ä»•äº‹',0),(8204,228,'pt','Valor Extra / trabalho',0),(8205,228,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… / Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(8206,228,'es','Cantidad Extra / Proyecto',0),(8207,228,'de','Anzahl Extra / Arbeit',0),(8208,228,'en','Amount Extra / Job',0),(8209,229,'is','',0),(8210,229,'dr','1 Ù…Ø¹Ø§ÙÙŠØª ',0),(8211,229,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ  1 Ù…Ø¹Ø§ÙÙŠØª ',0),(8212,229,'tr','1 muafiyet tutarÄ±',0),(8213,229,'pl','Kwota zwolnienia 1',0),(8214,229,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° 1 Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ',0),(8215,229,'ur','Ø±Ù‚Ù… 1 Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ú©Û’ Ù„Ø¦Û’',0),(8216,229,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° 1 Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(8217,229,'vi','Sá»‘ Tiá»n cho 1 Láº§n Miá»…n Trá»«',0),(8218,229,'af','Bedrag vir 1 vrystelling',0),(8219,229,'ro','Suma de 1 scutire',0),(8220,229,'et','1 vabastamise summa',0),(8221,229,'si','Znesek za 1 oprostitev',0),(8222,229,'ba','Jumlah pembebasan 1',0),(8223,229,'nl','Bedrag voor 1 vrijstelling',0),(8224,229,'fi','MÃ¤Ã¤rÃ¤ 1 vapautus',0),(8225,229,'no','BelÃ¸pet for 1 fritak',0),(8226,229,'da','BelÃ¸b 1 fritagelse',0),(8227,229,'ko','1 ë©´ì œ ê¸ˆì•¡',0),(8228,229,'he','×”×¡×›×•× ×”×¤×˜×•×¨ 1',0),(8229,229,'el','Î Î¿ÏƒÏŒ 1 Î‘Î Î‘Î›Î›Î‘Î“Î—Î£',0),(8230,229,'zh','ä¸€é¡¹è±å…é¢\r\n',0),(8231,229,'sv','Beloppet fÃ¶r 1 undantag',0),(8232,229,'it','QuantitÃ  per 1 esenzione',0),(8233,229,'tl','',0),(8234,229,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610; 1 &#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;',0),(8235,229,'hi','1 à¤›à¥‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¾à¤¶à¤¿',0),(8236,229,'ms','Amaun pengecualian 1',0),(8237,229,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ 1',0),(8238,229,'fr','Montant pour 1 exemption',0),(8239,229,'jp','æŽ§é™¤ï¼‘ã?®ç·?é¡?',0),(8240,229,'pt','Quantidade para 1 isenÃ§Ã£o',0),(8241,229,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð° 1 Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(8242,229,'es','Cantidad por 1 exenciÃ³n',0),(8243,229,'de','Betrag fÃ¼r 1 Freistellung',0),(8244,229,'en','Amount for 1 exemption',0),(8245,230,'is','',0),(8246,230,'dr','2  Ù…Ø¹Ø§ÙÙŠØª ',0),(8247,230,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ 2  Ù…Ø¹Ø§ÙÙŠØª ',0),(8248,230,'tr','2 muafiyet tutarÄ±',0),(8249,230,'pl','Kwota zwolnienia 2',0),(8250,230,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° 2 Ð¸Ð·ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ',0),(8251,230,'ur','Ø±Ù‚Ù… 2 Ø§Ø³ØªØ«Ù†Ø§Ø¦ÛŒÚº Ú©Û’ Ù„Ø¦Û’',0),(8252,230,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° 2 Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(8253,230,'vi','Sá»‘ Tiá»n cho 2 Láº§n Miá»…n Trá»«',0),(8254,230,'af','Bedrag vir 2 vrystellings',0),(8255,230,'ro','Suma de 2 scutiri',0),(8256,230,'et','Summa 2 erandid',0),(8257,230,'si','Znesek za 2 izjeme',0),(8258,230,'ba','Jumlah untuk 2 pengecualian',0),(8259,230,'nl','Bedrag voor 2 vrijstellingen',0),(8260,230,'fi','MÃ¤Ã¤rÃ¤ 2 poikkeuksia',0),(8261,230,'no','BelÃ¸pet for 2 unntak',0),(8262,230,'da','BelÃ¸b for 2 undtagelser',0),(8263,230,'ko','2 ë©´ì œ ê¸ˆì•¡',0),(8264,230,'he','×¡×›×•× ×¢×‘×•×¨ 2 ×¤×˜×•×¨×™×',0),(8265,230,'el','Î Î¿ÏƒÏŒ Î³Î¹Î± 2 ÎµÎ¾Î±Î¹ÏÎ­ÏƒÎµÎ¹Ï‚',0),(8266,230,'zh','2æ¡è±å…é¢\r\n',0),(8267,230,'sv','Beloppet fÃ¶r 2 undantag',0),(8268,230,'it','QuantitÃ  per 2 esenzioni',0),(8269,230,'tl','',0),(8270,230,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610; 2 &#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;',0),(8271,230,'hi','2 à¤®à¥‡à¤‚ à¤›à¥‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¾à¤¶à¤¿',0),(8272,230,'ms','Jumlah pengecualian-pengecualian yang 2',0),(8273,230,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù„Ù„Ø¥Ø¹ÙØ§Ø¡Ø§Øª 2',0),(8274,230,'fr','Montant 2 exemptions',0),(8275,230,'jp','æŽ§é™¤ï¼’ã?®ç·?é¡?',0),(8276,230,'pt','Quantidade para 2 isenÃ§Ãµes',0),(8277,230,'ru','Ð¡ÑƒÐ¼Ð¼Ð° 2 Ð¸ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ð¹',0),(8278,230,'es','Cantidad por 2 exenciÃ³n',0),(8279,230,'de','Betrag fÃ¼r 2 Ausnahmen',0),(8280,230,'en','Amount for 2 exemptions',0),(8281,231,'is','',0),(8282,231,'dr','3 Ù…Ø¹Ø§ÙÙŠØª ',0),(8283,231,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ  3 Ù…Ø¹Ø§ÙÙŠØª ',0),(8284,231,'tr','3 muafiyet tutarÄ±',0),(8285,231,'pl','Kwota zwolnienia 3',0),(8286,231,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° 3 Ð¸Ð·ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ',0),(8287,231,'ur','3 Ø§Ø³ØªØ«Ù†Ø§Ø¦ÛŒÚº Ú©Û’ Ù„Ø¦Û’ Ø±Ù‚Ù…',0),(8288,231,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° 3 Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(8289,231,'vi','Sá»‘ Tiá»n cho 3 Láº§n Miá»…n Trá»«',0),(8290,231,'af','Bedrag vir 3 vrystellings',0),(8291,231,'ro','Suma de 3 scutiri',0),(8292,231,'et','Summa 3 erandid',0),(8293,231,'si','KoliÄina za 3 izjeme',0),(8294,231,'ba','Jumlah untuk pengecualian 3',0),(8295,231,'nl','Bedrag voor 3 vrijstellingen',0),(8296,231,'fi','MÃ¤Ã¤rÃ¤ 3 poikkeuksia',0),(8297,231,'no','BelÃ¸pet for 3 unntak',0),(8298,231,'da','BelÃ¸b for 3 undtagelser',0),(8299,231,'ko','3 ë©´ì œì— ëŒ€ í•œ ê¸ˆì•¡',0),(8300,231,'he','×¡×›×•× ×¢×‘×•×¨ ×¤×˜×•×¨×™× 3',0),(8301,231,'el','Î Î¿ÏƒÏŒ 3 ÎµÎ¾Î±Î¹ÏÎ­ÏƒÎµÎ¹Ï‚',0),(8302,231,'zh','3æ¡è±å…é¢\r\n',0),(8303,231,'sv','Beloppet fÃ¶r 3 undantag',0),(8304,231,'it','QuantitÃ  per 3 esenzioni',0),(8305,231,'tl','',0),(8306,231,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610; 3 &#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;',0),(8307,231,'hi','3 à¤®à¥‡à¤‚ à¤›à¥‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¾à¤¶à¤¿',0),(8308,231,'ms','Jumlah pengecualian 3',0),(8309,231,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù„Ù„Ø¥Ø¹ÙØ§Ø¡Ø§Øª 3',0),(8310,231,'fr','Montant 3 exemptions',0),(8311,231,'jp','æŽ§é™¤ï¼“ã?®ç·?é¡?',0),(8312,231,'pt','Quantidade para 3 isenÃ§Ãµes',0),(8313,231,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð° 3 Ð¸ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ð¹',0),(8314,231,'es','Cantidad por 3 exenciÃ³n',0),(8315,231,'de','Betrag fÃ¼r 3 Ausnahmen',0),(8316,231,'en','Amount for 3 exemptions',0),(8317,232,'is','',0),(8318,232,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(8319,232,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(8320,232,'tr','Ã–denmiÅŸ miktar',0),(8321,232,'pl','Kwota zapÅ‚acona',0),(8322,232,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(8323,232,'ur','Ø±Ù‚Ù… Ø§Ø¯Ø§ Ú©ÛŒ',0),(8324,232,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¸ÑÐ¿Ð»Ð°Ñ›ÐµÐ½',0),(8325,232,'vi','Sá»‘ Tiá»n ÄÃ£ Thanh ToÃ¡n',0),(8326,232,'af','Bedrag Betaal',0),(8327,232,'ro','Suma platita',0),(8328,232,'et','Makse summa',0),(8329,232,'si','PlaÄani znesek',0),(8330,232,'ba','Jumlah yang dibayar',0),(8331,232,'nl','Betaalde bedrag',0),(8332,232,'fi','Maksettu mÃ¤Ã¤rÃ¤',0),(8333,232,'no','BelÃ¸pet betalt',0),(8334,232,'da','BelÃ¸b betalt',0),(8335,232,'ko','ë‚©ë¶€ ê¸ˆì•¡',0),(8336,232,'he','×”×¡×›×•× ×©×©×•×œ×',0),(8337,232,'el','Î Î¿ÏƒÏŒ Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î»Î®Î¸Î·ÎºÎµ',0),(8338,232,'zh','å·²ä»˜é‡‘é¢\r\n',0),(8339,232,'sv','Belopp som betalas ut',0),(8340,232,'it','Importo pagato',0),(8341,232,'tl','',0),(8342,232,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(8343,232,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤°à¤¾à¤¶à¤¿',0),(8344,232,'ms','Jumlah yang dibayar',0),(8345,232,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(8346,232,'fr','Montant payÃ©',0),(8347,232,'jp','æ”¯æ‰•ç·?é¡?',0),(8348,232,'pt','Montante pago',0),(8349,232,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÐ¼Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(8350,232,'es','Monto Pagado',0),(8351,232,'de','Gezahlten Betrag',0),(8352,232,'en','Amount Paid',0),(8353,233,'is','',0),(8354,233,'dr','2',0),(8355,233,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ù…Ø¹Ø§ÙÙŠØª Ø¨Ø±Ø§ÙŠ 2',0),(8356,233,'tr','2 iÃ§in muafiyet baÅŸÄ±na miktar',0),(8357,233,'pl','Kwota zwolnienia dla 2',0),(8358,233,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð·Ð° 2',0),(8359,233,'ur','Ø§Ø³ØªØ«Ù†Ø§Ø¡ ÙÛŒ Ø±Ù‚Ù… 2 Ú©Û’ Ù„Ø¦Û’',0),(8360,233,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾ Ð¸Ð·ÑƒÐ·ÐµÑ›Ð° Ð·Ð° 2',0),(8361,233,'vi','Sá»‘ Tiá»n Má»™t Láº§n Miá»ƒn Trá»« Cho 2',0),(8362,233,'af','Bedrag per Vrystelling vir 2',0),(8363,233,'ro','Suma per scutire pentru 2',0),(8364,233,'et','Summa maksuvabastuse kohta 2',0),(8365,233,'si','Znesek na izvzetje za 2',0),(8366,233,'ba','Jumlah per pembebasan untuk 2',0),(8367,233,'nl','Bedrag per vrijstelling voor 2',0),(8368,233,'fi','Vapautuksen mÃ¤Ã¤rÃ¤ 2',0),(8369,233,'no','BelÃ¸p per fritak for 2',0),(8370,233,'da','BelÃ¸b pr. fritagelse for 2',0),(8371,233,'ko','2ì— ëŒ€ í•œ ë©´ì œ ë‹¹ ê¸ˆì•¡',0),(8372,233,'he','×¡×›×•× ×œ×¤×™ ×¤×˜×•×¨ ×¢×‘×•×¨ 2',0),(8373,233,'el','Î Î¿ÏƒÏŒ Î±Î½Î¬ Î±Ï€Î±Î»Î»Î±Î³Î® Î³Î¹Î± 2',0),(8374,233,'zh','æ¯2é¡¹è±å…é¢',0),(8375,233,'sv','Belopp per undantag fÃ¶r 2',0),(8376,233,'it','Importo per esenzione per 2',0),(8377,233,'tl','',0),(8378,233,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609; 2',0),(8379,233,'hi','2 à¤•à¥‡ à¤²à¤¿à¤ à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿ à¤°à¤¾à¤¶à¤¿',0),(8380,233,'ms','Jumlah satu pengecualian untuk 2',0),(8381,233,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù„ÙƒÙ„ Ø¥Ø¹ÙØ§Ø¡ Ù„ 2',0),(8382,233,'fr','Montant par Exemption pour 2',0),(8383,233,'jp','ï¼’ã?®æŽ§é™¤ã?”ã?¨ã?®ç·?é¡?',0),(8384,233,'pt','Quantidade por isenÃ§Ã£o para 2',0),(8385,233,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ 2',0),(8386,233,'es','Cantidad por ExenciÃ³n para 2',0),(8387,233,'de','Betrag pro Freistellung fÃ¼r 2',0),(8388,233,'en','Amount per Exemption for 2',0),(8389,234,'is','',0),(8390,234,'dr','3',0),(8391,234,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ù…Ø¹Ø§ÙÙŠØª Ø¨Ø±Ø§ÙŠ 3',0),(8392,234,'tr','3 iÃ§in Ã¼cret muafiyet tutarÄ±',0),(8393,234,'pl','Kwota zwolnienia dla 3',0),(8394,234,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð·Ð° 3',0),(8395,234,'ur','Ø§Ø³ØªØ«Ù†Ø§Ø¡ ÙÛŒ Ø±Ù‚Ù… 3',0),(8396,234,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾ Ð¸Ð·ÑƒÐ·ÐµÑ›Ð° Ð·Ð° 3',0),(8397,234,'vi','Sá»‘ Tiá»n Má»™t Láº§n Miá»ƒn Trá»« Cho 3',0),(8398,234,'af','Bedrag per Vrystelling vir 3',0),(8399,234,'ro','Suma per scutire pentru 3',0),(8400,234,'et','Summa maksuvabastuse kohta 3',0),(8401,234,'si','Znesek na izvzetje za 3',0),(8402,234,'ba','Jumlah per pembebasan untuk 3',0),(8403,234,'nl','Bedrag per vrijstelling voor 3',0),(8404,234,'fi','Vapautuksen mÃ¤Ã¤rÃ¤ 3',0),(8405,234,'no','BelÃ¸p per fritak for 3',0),(8406,234,'da','BelÃ¸b pr. fritagelse for 3',0),(8407,234,'ko','3ì— ëŒ€ í•œ ë©´ì œ ë‹¹ ê¸ˆì•¡',0),(8408,234,'he','×¡×›×•× ×œ×¤×™ ×”×¤×˜×•×¨ ×©×œ 3',0),(8409,234,'el','Î Î¿ÏƒÏŒ Î±Î½Î¬ Î±Ï€Î±Î»Î»Î±Î³Î® Î³Î¹Î± 3',0),(8410,234,'zh','æ¯3é¡¹è±å…é¢\r\n',0),(8411,234,'sv','Belopp per undantag fÃ¶r 3',0),(8412,234,'it','Importo per esenzione per 3',0),(8413,234,'tl','',0),(8414,234,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609; 3',0),(8415,234,'hi','3 à¤•à¥‡ à¤²à¤¿à¤ à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿ à¤°à¤¾à¤¶à¤¿',0),(8416,234,'ms','Jumlah satu pengecualian untuk 3',0),(8417,234,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù„ÙƒÙ„ Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ø¹Ù„Ù‰ 3',0),(8418,234,'fr','Montant par Exemption pour 3',0),(8419,234,'jp','ï¼“ã?®æŽ§é™¤ã?”ã?¨ã?®ç·?é¡?',0),(8420,234,'pt','Quantidade por isenÃ§Ã£o para 3',0),(8421,234,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð´Ð»Ñ 3',0),(8422,234,'es','Cantidad por ExenciÃ³n 2para 3',0),(8423,234,'de','Betrag pro Freistellung fÃ¼r 3',0),(8424,234,'en','Amount per Exemption for 3',0),(8425,235,'is','',0),(8426,235,'dr','4 Ùˆ Ø¨Ø§Ù„Ø§ØªØ±',0),(8427,235,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ù…Ø¹Ø§ÙÙŠØª Ø¨Ø±Ø§ÙŠ 4 Ùˆ Ø¨Ø§Ù„Ø§ØªØ±',0),(8428,235,'tr','Muafiyet baÅŸÄ±na miktar 4 & yukarÄ±',0),(8429,235,'pl','Kwota zwolnienia dla 4 & siÄ™',0),(8430,235,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð·Ð° 4 & Ð½Ð°Ð³Ð¾Ñ€Ðµ',0),(8431,235,'ur','4 Ú©Û’ Ù„Ø¦Û’ & Ø§Ù¾ Ø±Ù‚Ù… Ø§Ø³ØªØ«Ù†Ø§Ø¡ ÙÛŒ',0),(8432,235,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾ Ð¸Ð·ÑƒÐ·ÐµÑ›Ð° Ð·Ð° 4 & Ð³Ð¾Ñ€Ðµ',0),(8433,235,'vi','Sá»‘ Tiá»n Má»™t Láº§n Miá»ƒn Trá»« Cho 4 vÃ  nhiá»u hÆ¡n',0),(8434,235,'af','Bedrag per Vrystelling vir 4 en hoÃ«r',0),(8435,235,'ro','Suma la scutire pentru 4 & pÃ¢nÄƒ',0),(8436,235,'et','Summa maksuvabastuse 4 & Ã¼les',0),(8437,235,'si','Znesek na izvzetje za 4 & gor',0),(8438,235,'ba','Jumlah per pembebasan untuk 4 &amp; up',0),(8439,235,'nl','Bedrag per vrijstelling voor 4 & omhoog',0),(8440,235,'fi','Vapautuksen mÃ¤Ã¤rÃ¤ 4 & ylÃ¶s',0),(8441,235,'no','BelÃ¸p per fritak for 4 & opp',0),(8442,235,'da','BelÃ¸b pr. fritagelse for 4 & op',0),(8443,235,'ko','&ë¥¼ 4ì— ëŒ€ í•œ ë©´ì œ ë‹¹ ê¸ˆì•¡',0),(8444,235,'he','×¡×›×•× ×œ×¤×™ ×”×¤×˜×•×¨ ×œ-4 &.',0),(8445,235,'el','Î Î¿ÏƒÏŒ Î±Î½Î¬ Î±Ï€Î±Î»Î»Î±Î³Î® Î³Î¹Î± 4 & ÎµÏ€Î¬Î½Ï‰',0),(8446,235,'zh','æ¯4é¡¹åŠä»¥ä¸Šè±å…é¢\r\n',0),(8447,235,'sv','Belopp per undantag fÃ¶r 4 & upp',0),(8448,235,'it','Importo per esenzione per 4 & fino',0),(8449,235,'tl','',0),(8450,235,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609; 4 &#3649;&#3621;&#3632;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3609;&#3637;&#3657;',0),(8451,235,'hi','4 à¤•à¥‡ à¤²à¤¿à¤ & à¤¤à¤• à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿ à¤°à¤¾à¤¶à¤¿',0),(8452,235,'ms','Jumlah satu pengecualian untuk 4 & sehingga',0),(8453,235,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù„ÙƒÙ„ Ø¥Ø¹ÙØ§Ø¡ Ù„ 4 Ø¢Ù†Ø¯ Ø­ØªÙ‰',0),(8454,235,'fr','Montant par Exemption pour 4 & vers le haut',0),(8455,235,'jp','ï¼”ã?¨ã??ã‚Œä»¥ä¸Šã?®æŽ§é™¤ã?”ã?¨ã?®ç·?é¡?',0),(8456,235,'pt','Quantidade por isenÃ§Ã£o para 4 & acima',0),(8457,235,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ 4 & Ð²Ð²ÐµÑ€Ñ…',0),(8458,235,'es','Cantidad por ExenciÃ³n para 4 & mÃ¡s',0),(8459,235,'de','Betrag pro Freistellung fÃ¼r 4 & oben',0),(8460,235,'en','Amount per Exemption for 4 & up',0),(8461,236,'is','',0),(8462,236,'dr','(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ )',0),(8463,236,'pr','Ù…Ù‚Ø¯Ø§Ø±  Ø¨Ø± Ø¯Ù‚ÙŠÙ‚Ù‡ (Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ )',0),(8464,236,'tr','Tutar / M',0),(8465,236,'pl','Kwota / M',0),(8466,236,'bg','Ð¡ÑƒÐ¼Ð° / M',0),(8467,236,'ur','Ø±Ù‚Ù… / M',0),(8468,236,'sr','Ð˜Ð·Ð½Ð¾Ñ / Ðœ',0),(8469,236,'vi','Sá»‘ Tiá»n / M',0),(8470,236,'af','Bedrag / M',0),(8471,236,'ro','Cantitate / M',0),(8472,236,'et','Summa / M',0),(8473,236,'si','Znesek / M',0),(8474,236,'ba','Jumlah / M',0),(8475,236,'nl','Bedrag / M',0),(8476,236,'fi','MÃ¤Ã¤rÃ¤ / M',0),(8477,236,'no','BelÃ¸pet / M',0),(8478,236,'da','BelÃ¸b / M',0),(8479,236,'ko','ê¸ˆì•¡ / M',0),(8480,236,'he','×›×ž×•×ª / M',0),(8481,236,'el','Î Î¿ÏƒÏŒ / M',0),(8482,236,'zh','é‡‘é¢/ æœˆ\r\n',0),(8483,236,'sv','Belopp / M',0),(8484,236,'it','QuantitÃ  / M',0),(8485,236,'tl','',0),(8486,236,'th','&#3592;&#3635;&#3609;&#3623;&#3609;/M',0),(8487,236,'hi','à¤°à¤¾à¤¶à¤¿ / M',0),(8488,236,'ms','Jumlah / M',0),(8489,236,'ar','Ø§Ù„Ù…Ø¨Ù„Øº/M',0),(8490,236,'fr','Montant / M',0),(8491,236,'jp','ç·?é¡?/M',0),(8492,236,'pt','Quantidade / M',0),(8493,236,'ru','Ð¡ÑƒÐ¼Ð¼Ð° / Ðœ',0),(8494,236,'es','Cantidad / M',0),(8495,236,'de','Betrag / M',0),(8496,236,'en','Amount / M',0),(8497,237,'is','',0),(8498,237,'dr','(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) Ø¨Ø±Ù‚Ø³Ù…Øª ',0),(8499,237,'pr','Ù…Ù‚Ø¯Ø§Ø±  Ø¨Ø± Ø¯Ù‚ÙŠÙ‚Ù‡ (Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) Ø¨Ø±Ù‚Ø³Ù…Øª ',0),(8500,237,'tr','Tutar / M / bÃ¶lÃ¼m',0),(8501,237,'pl','Kwota / M / czÄ™Å›Ä‡',0),(8502,237,'bg','Ð¡ÑƒÐ¼Ð° / M / Ñ‡Ð°ÑÑ‚',0),(8503,237,'ur','Ø±Ù‚Ù… / M / Ø­ØµÛ',0),(8504,237,'sr','Ð˜Ð·Ð½Ð¾Ñ / Ðœ / Ñ€Ð°ÑÑ‚Ð°Ñ‚Ð¸',0),(8505,237,'vi','Sá»‘ Tiá»n / M / Pháº§n',0),(8506,237,'af','Bedrag / M / Onderdeel',0),(8507,237,'ro','Cantitate / M / partea',0),(8508,237,'et','Summa / M / Part',0),(8509,237,'si','Znesek / M / del',0),(8510,237,'ba','Jumlah / M / bagian',0),(8511,237,'nl','Bedrag / M / deel',0),(8512,237,'fi','MÃ¤Ã¤rÃ¤ / M / osa',0),(8513,237,'no','BelÃ¸pet / M / del',0),(8514,237,'da','BelÃ¸b / M / del',0),(8515,237,'ko','ê¸ˆì•¡ / M / ë¶€í’ˆ',0),(8516,237,'he','×›×ž×•×ª / M / ×—×œ×§',0),(8517,237,'el','Î Î¿ÏƒÏŒ / M / Î¼Î­ÏÎ¿Ï‚',0),(8518,237,'zh','é‡‘é¢/æœˆ/éƒ¨ä»½\r\n',0),(8519,237,'sv','Belopp / M / del',0),(8520,237,'it','QuantitÃ  / M / parte',0),(8521,237,'tl','',0),(8522,237,'th','&#3592;&#3635;&#3609;&#3623;&#3609;/M/&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(8523,237,'hi','à¤°à¤¾à¤¶à¤¿ / à¤à¤® / à¤­à¤¾à¤—',0),(8524,237,'ms','Jumlah / M / bahagian',0),(8525,237,'ar','Ø§Ù„Ù…Ø¨Ù„Øº/M/Ø§Ù„Ø¬Ø²Ø¡',0),(8526,237,'fr','Montant / M / partie',0),(8527,237,'jp','ç·?é¡?/M/éƒ¨å“?',0),(8528,237,'pt','Quantidade / M / peÃ§a',0),(8529,237,'ru','Ð¡ÑƒÐ¼Ð¼Ð° / Ðœ / Ñ‡Ð°ÑÑ‚ÑŒ',0),(8530,237,'es','Cantidad / M /Parte',0),(8531,237,'de','Betrag / M / Teil',0),(8532,237,'en','Amount / M / Part',0),(8533,238,'is','',0),(8534,238,'dr','(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) Ø¨Ø± Ø¬Ù‡Øª ',0),(8535,238,'pr','Ù…Ù‚Ø¯Ø§Ø±  Ø¨Ø± Ø¯Ù‚ÙŠÙ‚Ù‡ (Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) Ø¨Ø± Ø¬Ù‡Øª ',0),(8536,238,'tr','Tutar / M /Side',0),(8537,238,'pl','Kwota / M /Side',0),(8538,238,'bg','Ð¡ÑƒÐ¼Ð° / M /Side',0),(8539,238,'ur','Ø±Ù‚Ù… / M /Side',0),(8540,238,'sr','Ð˜Ð·Ð½Ð¾Ñ / Ðœ /Ð¡Ð¸Ð´Ðµ',0),(8541,238,'vi','Sá»‘ Tiá»n / M / Máº·t',0),(8542,238,'af','Bedrag / M /Side',0),(8543,238,'ro','Cantitate / M /Side',0),(8544,238,'et','Summa / M /Side',0),(8545,238,'si','Znesek / M /Side',0),(8546,238,'ba','Jumlah / M /Side',0),(8547,238,'nl','Bedrag / M /Side',0),(8548,238,'fi','MÃ¤Ã¤rÃ¤ / M /Side',0),(8549,238,'no','BelÃ¸pet / M /Side',0),(8550,238,'da','BelÃ¸b / M /Side',0),(8551,238,'ko','ê¸ˆì•¡ / M /Side',0),(8552,238,'he','×›×ž×•×ª / M /Side',0),(8553,238,'el','Î Î¿ÏƒÏŒ / M /Side',0),(8554,238,'zh','é‡‘é¢/æœˆ/è¾¹\r\n',0),(8555,238,'sv','Belopp / M /Side',0),(8556,238,'it','QuantitÃ  / M /Side',0),(8557,238,'tl','',0),(8558,238,'th','&#3592;&#3635;&#3609;&#3623;&#3609;/M/&#3604;&#3657;&#3634;&#3609;',0),(8559,238,'hi','à¤°à¤¾à¤¶à¤¿ / à¤à¤® /Side',0),(8560,238,'ms','Jumlah / M /Side',0),(8561,238,'ar','Ø§Ù„Ù…Ø¨Ù„Øº/Ù…ÙŠÙ…ÙŠØ³ M',0),(8562,238,'fr','Montant / M /Side',0),(8563,238,'jp','ç·?é¡?/M/å?´é?¢',0),(8564,238,'pt','Quantidade / M /Side',0),(8565,238,'ru','Ð¡ÑƒÐ¼Ð¼Ð° / Ðœ Ð±Ð¾ÐºÐ¾Ð²Ñ‹Ð¼',0),(8566,238,'es','Cantidad / M / Lado',0),(8567,238,'de','Betrag / M /Side',0),(8568,238,'en','Amount / M /Side',0),(8569,239,'is','',0),(8570,239,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ù‡Ø²ÙŠÙ†Ù‡ ',0),(8571,239,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ù‡Ø²ÙŠÙ†Ù‡ ',0),(8572,239,'tr','Ãœcret tutarÄ±',0),(8573,239,'pl','Kwota do opÅ‚aty',0),(8574,239,'bg','Ð’ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(8575,239,'ur','Ú†Ø§Ø±Ø¬ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø±Ù‚Ù…',0),(8576,239,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ñƒ',0),(8577,239,'vi','Sá»‘ Tiá»n Pháº£i Thu',0),(8578,239,'af','Koste beloop',0),(8579,239,'ro','Suma de taxa',0),(8580,239,'et','Tasu summa',0),(8581,239,'si','Znesek stroÅ¡ka',0),(8582,239,'ba','Jumlah biaya',0),(8583,239,'nl','Oplopen tot gratis',0),(8584,239,'fi','MÃ¤Ã¤rÃ¤ maksu',0),(8585,239,'no','BelÃ¸p Ã¥ lade',0),(8586,239,'da','BelÃ¸be sig til opladning',0),(8587,239,'ko','ì¶©ì „ ê¸ˆì•¡',0),(8588,239,'he','×¡×›×•× ×ª×©×œ×•×',0),(8589,239,'el','Î™ÏƒÎ¿Î´Ï…Î½Î±Î¼ÎµÎ¯ Î¼Îµ Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(8590,239,'zh','æ”¶è´¹é‡‘é¢\r\n',0),(8591,239,'sv','UppgÃ¥ till avgift',0),(8592,239,'it','Ammontano a carica',0),(8593,239,'tl','',0),(8594,239,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(8595,239,'hi','à¤šà¤¾à¤°à¥à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¾à¤¶à¤¿',0),(8596,239,'ms','Jumlah caj',0),(8597,239,'ar','ØªØµÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø³Ø¤ÙˆÙ„',0),(8598,239,'fr','S\'Ã©lÃ¨vent Ã  Charge',0),(8599,239,'jp','è«‹æ±‚é‡‘é¡?',0),(8600,239,'pt','Quantidade de carga',0),(8601,239,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð°Ñ€ÑÐ´Ð°',0),(8602,239,'es','Monto a Cargar',0),(8603,239,'de','Belaufen sich auf kostenlos',0),(8604,239,'en','Amount to Charge',0),(8605,240,'is','',0),(8606,240,'dr','* Ø¬ÙˆØ§Ø¨',0),(8607,240,'pr','Ù…Ù‚Ø¯Ø§Ø± * Ø¬ÙˆØ§Ø¨',0),(8608,240,'tr','TutarÄ± X cevap',0),(8609,240,'pl','Kwota X odpowiedÅº',0),(8610,240,'bg','Ð¡ÑƒÐ¼Ð° X Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(8611,240,'ur','Ø±Ù‚Ù… X Ú©Ø§ Ø¬ÙˆØ§Ø¨',0),(8612,240,'sr','Ð˜Ð·Ð½Ð¾Ñ X Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€',0),(8613,240,'vi','Sá»‘ Tiá»n X Tráº£ Lá»i',0),(8614,240,'af','Bedrag X Antwoord',0),(8615,240,'ro','Raspuns suma X',0),(8616,240,'et','Koguse X vastus',0),(8617,240,'si','Znesek X odgovor',0),(8618,240,'ba','Jumlah X jawaban',0),(8619,240,'nl','Bedrag X antwoord',0),(8620,240,'fi','MÃ¤Ã¤rÃ¤ X vastaus',0),(8621,240,'no','BelÃ¸pet X svaret',0),(8622,240,'da','MÃ¦ngden X svar',0),(8623,240,'ko','ê¸ˆì•¡ X ëŒ€ë‹µ',0),(8624,240,'he','×›×ž×•×ª X ×ª×©×•×‘×”',0),(8625,240,'el','Î Î¿ÏƒÏŒ X Î±Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(8626,240,'zh','é‡‘é¢ X ç­”æ¡ˆ\r\n',0),(8627,240,'sv','Belopp X svar',0),(8628,240,'it','QuantitÃ  X risposta',0),(8629,240,'tl','',0),(8630,240,'th','&#3592;&#3635;&#3609;&#3623;&#3609; * &#3588;&#3635;&#3605;&#3629;&#3610;',0),(8631,240,'hi','à¤°à¤¾à¤¶à¤¿ X à¤‰à¤¤à¥à¤¤à¤°',0),(8632,240,'ms','Jawapan jumlah X',0),(8633,240,'ar','Ø¬ÙˆØ§Ø¨ Ø§Ù„Ù…Ø¨Ù„Øº X',0),(8634,240,'fr','Montant X rÃ©ponse',0),(8635,240,'jp','ç·?é¡?Ã—å›žç­”',0),(8636,240,'pt','Resposta quantidade X',0),(8637,240,'ru','Ð¡ÑƒÐ¼Ð¼Ð° X ÐžÑ‚Ð²ÐµÑ‚',0),(8638,240,'es','Cantidad X Respuesta',0),(8639,240,'de','Betrag X Antwort',0),(8640,240,'en','Amount X Answer',0),(8641,241,'is','',0),(8642,241,'dr','* Ø±Ù†Ú¯Ù‡Ø§',0),(8643,241,'pr','Ù…Ù‚Ø¯Ø§Ø± * Ø±Ù†Ú¯Ù‡Ø§',0),(8644,241,'tr','TutarÄ± X renkleri',0),(8645,241,'pl','Kwota X kolory',0),(8646,241,'bg','Ð¡ÑƒÐ¼Ð° X Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(8647,241,'ur','Ø±Ù‚Ù… X Ø±Ù†Ú¯',0),(8648,241,'sr','Ð˜Ð·Ð½Ð¾Ñ X Ð±Ð¾Ñ˜Ðµ',0),(8649,241,'vi','Sá»‘ Tiá»n X Máº§u',0),(8650,241,'af','Bedrag X kleure',0),(8651,241,'ro','Suma X culori',0),(8652,241,'et','Summa X vÃ¤rvid',0),(8653,241,'si','Znesek X barve',0),(8654,241,'ba','Jumlah X warna',0),(8655,241,'nl','Bedrag X kleuren',0),(8656,241,'fi','MÃ¤Ã¤rÃ¤ X vÃ¤rit',0),(8657,241,'no','BelÃ¸pet X farger',0),(8658,241,'da','MÃ¦ngden X farver',0),(8659,241,'ko','ê¸ˆì•¡ X ìƒ‰ìƒ',0),(8660,241,'he','×›×ž×•×ª X ×¦×‘×¢×™×',0),(8661,241,'el','Î Î¿ÏƒÏŒ X Ï‡ÏÏŽÎ¼Î±Ï„Î±',0),(8662,241,'zh','é‡‘é¢ x é¢œè‰²\r\n',0),(8663,241,'sv','Belopp X fÃ¤rger',0),(8664,241,'it','QuantitÃ  X colori',0),(8665,241,'tl','',0),(8666,241,'th','&#3592;&#3635;&#3609;&#3623;&#3609; * &#3626;&#3637;',0),(8667,241,'hi','à¤à¤•à¥à¤¸ à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤°à¤‚à¤—',0),(8668,241,'ms','Jumlah X warna',0),(8669,241,'ar','Ø£Ù„ÙˆØ§Ù† Ø§Ù„Ù…Ø¨Ù„Øº X',0),(8670,241,'fr','Montant X couleurs',0),(8671,241,'jp','ç·?é¡?Ã—è‰²',0),(8672,241,'pt','Quantidade X cores',0),(8673,241,'ru','Ð¡ÑƒÐ¼Ð¼Ð° X Ñ†Ð²ÐµÑ‚Ð°',0),(8674,241,'es','Cantidad X Colores',0),(8675,241,'de','Betrag X Farben',0),(8676,241,'en','Amount X Colors',0),(8677,242,'is','',0),(8678,242,'dr','* Ø¯Ù‚ÙŠÙ‚Ù‡(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ )  8.5 * 11 Ù…Ø¹Ø§Ø¯Ù„ ØµÙØ­Ø§Øª ',0),(8679,242,'pr','Ù…Ù‚Ø¯Ø§Ø± * Ø¯Ù‚ÙŠÙ‚Ù‡(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ )  8.5 * 11 Ù…Ø¹Ø§Ø¯Ù„ ØµÙØ­Ø§Øª ',0),(8680,242,'tr','TutarÄ± X M 8.5x11 equiv levhalar',0),(8681,242,'pl','Kwota X M 8.5x11 equiv arkuszy',0),(8682,242,'bg','Ð¡ÑƒÐ¼Ð° Ð¥ Ðœ 8.5x11 ÐµÐºÐ² Ð»Ð¸ÑÑ‚Ð¾Ð²Ðµ',0),(8683,242,'ur','Ø±Ù‚Ù… X M 8.5x11 equiv Ø§ÙˆØ±Ø§Ù‚',0),(8684,242,'sr','Ð˜Ð·Ð½Ð¾Ñ X Ðœ 8.5 x11 ÐµqÑƒÐ¸Ð² Ð»Ð¸ÑÑ‚Ð¾Ð²Ðµ',0),(8685,242,'vi','Sá»‘ Tiá»n X M 8.5x11 equiv sheets',0),(8686,242,'af','Bedrag X M 8.5x11 equiv blaaie',0),(8687,242,'ro','Suma X M 8.5x11 equiv foi',0),(8688,242,'et','Summa X M 8.5x11 ekvivalent lehed',0),(8689,242,'si','Znesek X M 8.5x11 equiv listov',0),(8690,242,'ba','Jumlah X M 8.5x11 equiv lembar',0),(8691,242,'nl','Bedrag X M 8.5x11 equiv bladen',0),(8692,242,'fi','MÃ¤Ã¤rÃ¤ X M 8.5x11 equiv levyt',0),(8693,242,'no','BelÃ¸pet X M 8.5x11 equiv ark',0),(8694,242,'da','MÃ¦ngden X M 8.5x11 equiv ark',0),(8695,242,'ko','ê¸ˆì•¡ X M 8.5 x 11 equiv ì‹œíŠ¸',0),(8696,242,'he','×›×ž×•×ª ×ž\' X 8.5 x11 equiv ×’×œ×™×•× ×•×ª',0),(8697,242,'el','Î Î¿ÏƒÏŒ X M 8.5x11 equiv Ï†ÏÎ»Î»Î±',0),(8698,242,'zh','é‡‘é¢ x æœˆ 8.5x11 å½“é‡è¡¨\r\n',0),(8699,242,'sv','Belopp X M 8.5x11 motsv ark',0),(8700,242,'it','QuantitÃ  X M 5x11 equiv fogli',0),(8701,242,'tl','',0),(8702,242,'th','&#3592;&#3635;&#3609;&#3623;&#3609; * M 8.5x11 &#3648;&#3627;&#3617;&#3639;&#3629;&#3609;&#3594;&#3637;&#3626;',0),(8703,242,'hi','à¤°à¤¾à¤¶à¤¿ à¤à¤•à¥à¤¸ à¤à¤® 8.5 x11 equiv à¤¶à¥€à¤Ÿà¥à¤¸',0),(8704,242,'ms','Jumlah X M 8.5x11 equiv cadar',0),(8705,242,'ar','M X Ù…Ø¨Ù„Øº 8.5 x11 equiv Ø£ÙˆØ±Ø§Ù‚',0),(8706,242,'fr','Montant X M feuilles de 8,5 x 11 equiv',0),(8707,242,'jp','ç·?é¡?Ã—M 8.5x11ç›¸å½“ã?®ã‚·ãƒ¼ãƒˆ',0),(8708,242,'pt','Quantidade X M 8.5 X11 equiv folhas',0),(8709,242,'ru','Ð¡ÑƒÐ¼Ð¼Ð° X M 8.5x11 equiv Ð»Ð¸ÑÑ‚Ñ‹',0),(8710,242,'es','Cantidad X M 8.5x11 equiv. hojas',0),(8711,242,'de','Betrag X M 8.5 Equiv BlÃ¤tter',0),(8712,242,'en','Amount X M 8.5x11 equiv sheets',0),(8713,243,'is','',0),(8714,243,'dr','* Ø¯Ù‚ÙŠÙ‚Ù‡(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) Ø¨Ø± Ø¬ÙˆØ§Ø¨ ',0),(8715,243,'pr','Ù…Ù‚Ø¯Ø§Ø± * Ø¯Ù‚ÙŠÙ‚Ù‡(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) Ø¨Ø± Ø¬ÙˆØ§Ø¨ ',0),(8716,243,'tr','TutarÄ± X M/cevap',0),(8717,243,'pl','Kwota X M/odpowiedÅº',0),(8718,243,'bg','Ð¡ÑƒÐ¼Ð° Ð¥ Ðœ/Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(8719,243,'ur','Ø±Ù‚Ù… X M/Ø¬ÙˆØ§Ø¨',0),(8720,243,'sr','Ð˜Ð·Ð½Ð¾Ñ X Ðœ/Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€',0),(8721,243,'vi','Sá»‘ Tiá»n X M/Tráº£ Lá»i',0),(8722,243,'af','Bedrag X M/Antwoord',0),(8723,243,'ro','Suma X M/rÄƒspuns',0),(8724,243,'et','Summa X M/vastus',0),(8725,243,'si','Znesek X M/odgovor',0),(8726,243,'ba','Jumlah X M/jawaban',0),(8727,243,'nl','Bedrag X M/antwoord',0),(8728,243,'fi','MÃ¤Ã¤rÃ¤ X M/vastaus',0),(8729,243,'no','BelÃ¸pet X M/svar',0),(8730,243,'da','MÃ¦ngden X M/svar',0),(8731,243,'ko','ê¸ˆì•¡ X M/ë‹µë³€',0),(8732,243,'he','×›×ž×•×ª X M/×ª×©×•×‘×”',0),(8733,243,'el','Î Î¿ÏƒÏŒ X M/Î±Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(8734,243,'zh','é‡‘é¢ x æœˆ/ç­”æ¡ˆ\r\n',0),(8735,243,'sv','Belopp X M/svar',0),(8736,243,'it','QuantitÃ  X M/risposta',0),(8737,243,'tl','',0),(8738,243,'th','&#3592;&#3635;&#3609;&#3623;&#3609; * M/&#3588;&#3635;&#3606;&#3634;&#3617;',0),(8739,243,'hi','à¤°à¤¾à¤¶à¤¿ à¤à¤•à¥à¤¸ à¤à¤®/à¤œà¤µà¤¾à¤¬',0),(8740,243,'ms','Jumlah X M/jawapan',0),(8741,243,'ar','Ø§Ù„Ù…Ø¨Ù„Øº X M/Ø¬ÙˆØ§Ø¨',0),(8742,243,'fr','Montant X M/rÃ©ponse',0),(8743,243,'jp','ç·?é¡?Ã—M/å›žç­”',0),(8744,243,'pt','Quantidade X M/resposta',0),(8745,243,'ru','Ð¡ÑƒÐ¼Ð¼Ð° X Ðœ/Ð¾Ñ‚Ð²ÐµÑ‚',0),(8746,243,'es','Cantidad X M/Respuesta',0),(8747,243,'de','Betrag X M/Antwort',0),(8748,243,'en','Amount X M/Answer',0),(8749,244,'is','',0),(8750,244,'dr','* Ø¯Ù‚ÙŠÙ‚Ù‡(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) Ø¨Ø± Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§ ',0),(8751,244,'pr','Ù…Ù‚Ø¯Ø§Ø± * Ø¯Ù‚ÙŠÙ‚Ù‡(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) Ø¨Ø± Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§ ',0),(8752,244,'tr','TutarÄ± X M/NumberUp',0),(8753,244,'pl','Kwota X M/NumberUp',0),(8754,244,'bg','Ð¡ÑƒÐ¼Ð° Ð¥ Ðœ/NumberUp',0),(8755,244,'ur','Ø±Ù‚Ù… X M/Ù†ÙˆÙ…Ø¨Ø±ÙˆÙ¾',0),(8756,244,'sr','Ð˜Ð·Ð½Ð¾Ñ X Ðœ/ÐÑƒÐ¼Ð±ÐµÑ€Ð£Ð¿',0),(8757,244,'vi','Sá»‘ Tiá»n X M/NumberUp',0),(8758,244,'af','Bedrag X M/NumberUp',0),(8759,244,'ro','Suma X M/NumberUp',0),(8760,244,'et','Summa X M/NumberUp',0),(8761,244,'si','Znesek X M/NumberUp',0),(8762,244,'ba','Jumlah X M/NumberUp',0),(8763,244,'nl','Bedrag X M/NumberUp',0),(8764,244,'fi','MÃ¤Ã¤rÃ¤ X M/NumberUp',0),(8765,244,'no','BelÃ¸pet X M/NumberUp',0),(8766,244,'da','MÃ¦ngden X M/NumberUp',0),(8767,244,'ko','ê¸ˆì•¡ X M/NumberUp',0),(8768,244,'he','×›×ž×•×ª X M/NumberUp',0),(8769,244,'el','Î Î¿ÏƒÏŒ X M/NumberUp',0),(8770,244,'zh','é‡‘é¢xæœˆ/ æ¯å¢žåŠ ä¸€ä½æ•°\r\n',0),(8771,244,'sv','Belopp X M/NumberUp',0),(8772,244,'it','QuantitÃ  X M/NumberUp',0),(8773,244,'tl','',0),(8774,244,'th','&#3592;&#3635;&#3609;&#3623;&#3609; * M/&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(8775,244,'hi','à¤°à¤¾à¤¶à¤¿ à¤à¤•à¥à¤¸ à¤à¤®/NumberUp',0),(8776,244,'ms','Jumlah X M/NumberUp',0),(8777,244,'ar','Ø§Ù„Ù…Ø¨Ù„Øº X M/Ù†ÙˆÙ…Ø¨ÙŠØ±ÙˆØ¨',0),(8778,244,'fr','Montant X M/NumberUp',0),(8779,244,'jp','Amount X M/NumberUp',0),(8780,244,'pt','Quantidade X M/jÃªrsei',0),(8781,244,'ru','Ð¡ÑƒÐ¼Ð¼Ð° X Ðœ/NumberUp',0),(8782,244,'es','Cantidad X M/NumeroUp',0),(8783,244,'de','Betrag X M/NumberUp',0),(8784,244,'en','Amount X M/NumberUp',0),(8785,245,'is','',0),(8786,245,'dr','(Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ) 1 Ù‡ÙØªÙ‡ Ø¨Ø± Ù…Ø§Ù‡',0),(8787,245,'pr','Ù…Ù‚Ø¯Ø§Ø± (Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ) 1 Ù‡ÙØªÙ‡ Ø¨Ø± Ù…Ø§Ù‡',0),(8788,245,'tr','Tutar 1 hafta/ay',0),(8789,245,'pl','Kwota 1 tydzieÅ„/miesiÄ…c',0),(8790,245,'bg','Ð¡ÑƒÐ¼Ð° 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°/Ð¼ÐµÑÐµÑ†',0),(8791,245,'ur','Amt. 1 ÛÙØªÛ/Ù…ÛÛŒÙ†Û',0),(8792,245,'sr','Ð˜Ð·Ð½Ð¾Ñ 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°/Ð¼ÐµÑÐµÑ†',0),(8793,245,'vi','Sá»‘ Tiá»n. 1 Tuáº§n/ThÃ¡ng',0),(8794,245,'af','Bedrag 1 Week/Maand',0),(8795,245,'ro','SumÄƒ 1 sÄƒptÄƒmÃ¢nÄƒ/lunÄƒ',0),(8796,245,'et','Summa 1 nÃ¤dal/kuu',0),(8797,245,'si','Znesek 1 teden/mesec',0),(8798,245,'ba','Amt. 1 minggu/bulan',0),(8799,245,'nl','Bedrag 1 Week/maand',0),(8800,245,'fi','Summa 1 viikko/kuukausi',0),(8801,245,'no','RestbelÃ¸p 1 uke/mÃ¥ned',0),(8802,245,'da','BelÃ¸b 1 uge/mÃ¥ned',0),(8803,245,'ko','ë¦¬ì†ŒìŠ¤ 1 ì£¼/ì›”',0),(8804,245,'he','Amt. 1 ×©×‘×•×¢/×—×•×“×©',0),(8805,245,'el','Î Î¿ÏƒÏŒ 1 ÎµÎ²Î´Î¿Î¼Î¬Î´Î±/Î¼Î®Î½Î±',0),(8806,245,'zh','é‡‘é¢ ã€‚1å‘¨/æœˆ\r\n',0),(8807,245,'sv','Belopp 1 vecka/mÃ¥nad',0),(8808,245,'it','AMT. 1 settimana/mese',0),(8809,245,'tl','',0),(8810,245,'th','&#3592;&#3635;&#3609;&#3623;&#3609; 1 &#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;/&#3648;&#3604;&#3636;&#3629;&#3609;',0),(8811,245,'hi','Amt. 1 à¤¸à¤ªà¥à¤¤à¤¾à¤¹/à¤®à¤¾à¤¹',0),(8812,245,'ms','AMT. 1 minggu/bulan',0),(8813,245,'ar','Amt. 1 ÙÙŠ Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹/Ø§Ù„Ø´Ù‡Ø±',0),(8814,245,'fr','AMT. 1 semaine/mois',0),(8815,245,'jp','ç·?é¡?ã€€ï¼‘é€±é–“/æœˆ',0),(8816,245,'pt','AMT. 1 semana/mÃªs',0),(8817,245,'ru','Ð¡ÑƒÐ¼Ð¼Ð° 1 Ð½ÐµÐ´ÐµÐ»Ñ/Ð¼ÐµÑÑÑ†',0),(8818,245,'es','Cant. 1 Semana/Mes',0),(8819,245,'de','Amt 1 Woche/Monat',0),(8820,245,'en','Amt. 1 Week/Month',0),(8821,246,'is','',0),(8822,246,'dr','ÙŠÙƒ Ø®Ø·Ø§ Ù…Ø§Ù†Ø¹  Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù† Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(8823,246,'pr','ÙŠÙƒ Ø®Ø·Ø§ Ù…Ø§Ù†Ø¹  Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù† Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(8824,246,'tr','Bir hata veritabanÄ± gÃ¼ncelleÅŸtirilmesini engelledi',0),(8825,246,'pl','BÅ‚Ä…d przeszkodziÅ‚ baza danych jest aktualizowana',0),(8826,246,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ðµ Ð²ÑŠÐ·Ð¿Ñ€ÐµÐ¿ÑÑ‚ÑÑ‚Ð²Ð°Ð½ Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°',0),(8827,246,'ur','Ø§ÛŒÚ© Ù†Ù‚Øµ Ú©ÙˆØ§Ø¦ÙÛŒÛ ØªØ§Ø²Û ÛÙˆÙ†Û’ Ø³Û’ Ø±ÙˆÚ© Ø¯ÛŒØ§ ÛÛ’',0),(8828,246,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ˜Ðµ ÑÐ¿Ñ€ÐµÑ‡Ð¸Ð»Ð° Ð±Ð°Ð·Ñƒ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð´Ð° ÑÐµ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñƒ',0),(8829,246,'vi','Lá»—i xáº£y ra khiáº¿n dá»¯ liá»‡u khÃ´ng cáº­p nháº­t Ä‘Æ°á»£c',0),(8830,246,'af','\'n Fout het die databasis verhoed om te opdateer',0),(8831,246,'ro','O eroare a Ã®mpiedicat baza de date actualizate',0),(8832,246,'et','TÃµrge takistas andmebaasi uuendamist',0),(8833,246,'si','Napako je prepreÄil zbirki posodablja',0),(8834,246,'ba','Kesalahan melarang database sedang Diperbarui',0),(8835,246,'nl','Een fout heeft de database verhinderd worden bijgewerkt',0),(8836,246,'fi','Virhe esti tietokannan pÃ¤ivittÃ¤minen',0),(8837,246,'no','En feil har hindret databasen oppdateres',0),(8838,246,'da','En fejl har forhindret databasen opdateres',0),(8839,246,'ko','ì˜¤ë¥˜ ë°ì´í„°ë² ì´ìŠ¤ë¥¼ ì—…ë°ì´íŠ¸ ë˜ ê³ ì—ì„œ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(8840,246,'he','×©×’×™××” ×ž× ×¢×” ××ª ×ž×¡×“ ×”× ×ª×•× ×™× ×ž×ª×¢×“×›×Ÿ',0),(8841,246,'el','ÎˆÎ½Î± ÏƒÏ†Î¬Î»Î¼Î± ÎµÎ¼Ï€ÏŒÎ´Î¹ÏƒÎµ Ï„Î· Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹',0),(8842,246,'zh','ä¸€ä¸ªé”™è¯¯é˜»æ­¢æ•°æ®åº“è¢«æ›´æ–°\r\n',0),(8843,246,'sv','Ett fel har fÃ¶rhindrat databasen uppdateras',0),(8844,246,'it','Un errore ha impedito di database in fase di aggiornamento',0),(8845,246,'tl','',0),(8846,246,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3652;&#3604;&#3657;&#3586;&#3633;&#3604;&#3586;&#3623;&#3634;&#3591;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3592;&#3634;&#3585;&#3',0),(8847,246,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤°à¤¹à¤¾ à¤¸à¥‡ à¤°à¥‹à¤•à¤¾ à¤—à¤¯à¤¾',0),(8848,246,'ms','Satu ralat yang tidak menghalang pangkalan data daripada sedang dikemaskini',0),(8849,246,'ar','Ø«Ù…Ø© Ø®Ø·Ø£ Ù…Ù†Ø¹ ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(8850,246,'fr','Une erreur a empÃªchÃ© la base de donnÃ©es mise Ã  jour',0),(8851,246,'jp','ã‚¨ãƒ©ãƒ¼ã?Œã?‚ã?£ã?¦ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?®æ›´æ–°ã?Œã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(8852,246,'pt','Um erro impediu que o banco de dados sendo atualizado',0),(8853,246,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€ÐµÐ¿ÑÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¾Ð±Ð½Ð¾Ð²Ð»ÑÐµÑ‚ÑÑ Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(8854,246,'es','Un error se previno que la base de Datos sea actualizada',0),(8855,246,'de','Aufgrund eines Fehlers wurde die Datenbank nicht aktualisiert',0),(8856,246,'en','An error has prevented the database from being updated',0),(8857,247,'is','',0),(8858,247,'dr','. Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø±ØªØ¨Ù‡ Ø¨Ù†Ø¯ÙŠ Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ø´Ù…Ø§ ØªØºÙŠÙŠØ± Ø¯Ù‡Ø¯',0),(8859,247,'pr','ÙŠÙƒ Ø®Ø·Ø§ÙŠ Ø¬Ø¯ÙŠ Ø¯Ø§Ø®Ù„ÙŠ  Ø±ÙˆÙŠ Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª . Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø±ØªØ¨Ù‡ Ø¨Ù†Ø¯ÙŠ Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ø´Ù…Ø§ ØªØºÙŠÙŠØ± Ø¯Ù‡Ø¯',0),(8860,247,'tr','Dahili bir felaket meydana geldi.  SÄ±ralamasÄ±, bÃ¼tÃ§eler iÃ§in deÄŸiÅŸtirebilirsiniz.',0),(8861,247,'pl','WystÄ…piÅ‚ wewnÄ™trzny katastrofy.  Nie moÅ¼na zmieniÄ‡ rankingu na TwÃ³j budÅ¼et.',0),(8862,247,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð°Ð»Ð° Ðµ Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð° ÐºÐ°Ñ‚Ð°ÑÑ‚Ñ€Ð¾Ñ„Ð°.  ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ñ€Ð°Ð½Ð³Ð»Ð¸ÑÑ‚Ð° Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ Ð±ÑŽÐ´Ð¶ÐµÑ‚.',0),(8863,247,'ur','Ø§ÛŒÚ© Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ ØªØ¨Ø§ÛÛŒ ÙˆØ§Ù‚Ø¹ ÛÙˆØ§ ÛÛ’ Û”  Ø¢Ù¾ Ú©Û’ Ø¨Ø¬Ù¹ Ú©Û’ Ù„Ø¦Û’ Ø±ÛŒÙ†Ú©Ù†Ú¯ Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(8864,247,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ñ˜Ðµ ÑƒÐ½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ° ÐºÐ°Ñ‚Ð°ÑÑ‚Ñ€Ð¾Ñ„Ðµ.  ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð½Ð° Ñ€Ð°Ð½Ð³ Ð»Ð¸ÑÑ‚Ð¸ Ð·Ð° ÑÐ²Ð¾Ñ˜Ðµ Ð±ÑƒÑŸÐµÑ‚Ðµ.',0),(8865,247,'vi','Lá»—i ná»™i bá»™. KhÃ´ng thay Ä‘á»•i Ä‘Æ°á»£c thá»© háº¡ng trong ngÃ¢n sÃ¡ch cá»§a báº¡n',0),(8866,247,'af','\'n Interne katastrofe het voorgekom.  Kon nie die rangorde vir u begrotings verander.',0),(8867,247,'ro','S-a produs o catastrofÄƒ de interne.  Nu putea sÄƒ schimbe clasamentul pentru bugetele dvs.',0),(8868,247,'et','Ilmnenud on sisemine katastroofi.  Eelarvete alusstruktuurid pingeread ei muutu.',0),(8869,247,'si','PriÅ¡lo je do notranje katastrofa.  Na lestvici za vaÅ¡ proraÄun ne more spremeniti.',0),(8870,247,'ba','Bencana internal yang telah terjadi.  Tidak dapat mengubah peringkat untuk anggaran Anda.',0),(8871,247,'nl','Een interne ramp heeft plaatsgevonden.  De ranglijst voor uw begrotingen kan niet wijzigen.',0),(8872,247,'fi','SisÃ¤inen katastrofi on tapahtunut.  Kirjanpitobudjetteja rankingissa ei voi muuttaa.',0),(8873,247,'no','Det oppstod en intern katastrofe.  Kan ikke endre rangeringen i budsjettene.',0),(8874,247,'da','Der opstod en intern katastrofe.  Kunne ikke Ã¦ndre placeringer for dine budgetter.',0),(8875,247,'ko','ë‚´ë¶€ ìž¬ì•™ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.  ê·€í•˜ì˜ ì˜ˆì‚°ì— ëŒ€ í•œ ìˆœìœ„ë¥¼ ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(8876,247,'he','×§×˜×¡×˜×¨×•×¤×” ×¤× ×™×ž×™×ª ××™×¨×¢×”.  ×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×©× ×•×ª ××ª ×”×“×™×¨×•×’ ×©×œ×š ×ª×§×¦×™×‘.',0),(8877,247,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ Î¼Î¹Î± ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® ÎºÎ±Ï„Î±ÏƒÏ„ÏÎ¿Ï†Î®.  Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î±Î»Î»Î¬Î¾ÎµÎ¹ Ï„Î¹Ï‚ Ï„Î±Î¾Î¹Î½Î¿Î¼Î®ÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ ÏƒÎ±Ï‚.',0),(8878,247,'zh','å†…éƒ¨ç¾éš¾å·²ç»å‘ç”Ÿã€‚æ— æ³•æ”¹å˜ä½ çš„é¢„ç®—çš„é¡ºåº',0),(8879,247,'sv','En inre katastrof har intrÃ¤ffat.  Kunde inte Ã¤ndra rankingen fÃ¶r din budget.',0),(8880,247,'it','Si Ã¨ verificata una catastrofe interna.  Non poteva cambiare le classifiche per il vostro budget.',0),(8881,247,'tl','',0),(8882,247,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3616;&#3634;&#3618;&#3651;&#3609; &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3629;&#',0),(8883,247,'hi','à¤à¤• à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¤à¤¬à¤¾à¤¹à¥€ à¤¹à¥à¤ˆ à¤¹à¥ˆà¥¤  à¤…à¤ªà¤¨à¥‡ à¤¬à¤œà¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¥ˆà¤‚à¤•à¤¿à¤‚à¤— à¤¨à¤¹à¥€à¤‚ à¤¬à¤¦à¤² à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(8884,247,'ms','Bencana dalaman yang telah berlaku.  Tidak dapat menukar kedudukan untuk bajet anda.',0),(8885,247,'ar','ÙˆÙ‚Ø¯ Ø­Ø¯Ø«Øª ÙƒØ§Ø±Ø«Ø© Ø¯Ø§Ø®Ù„ÙŠØ©.  Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØºÙŠÙŠØ± Ø§Ù„ØªØµÙ†ÙŠÙ Ø§Ù„Ø¹Ø§Ù„Ù…ÙŠ Ù„Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(8886,247,'fr','Une catastrophe interne s\'est produite.  Il ne pouvait pas changer le classement de vos budgets.',0),(8887,247,'jp','å†…éƒ¨ã‚¨ãƒ©ãƒ¼ã?Œç™ºç”Ÿã?„ã?Ÿã?—ã?¾ã?—ã?Ÿã€‚äºˆç®—ã?®ãƒ©ãƒ³ã‚­ãƒ³ã‚°ã?Œå¤‰æ›´ã?§ã??ã?¾ã?›ã‚“',0),(8888,247,'pt','Ocorreu uma catÃ¡strofe interna.  NÃ£o poderia mudar as classificaÃ§Ãµes para os seus orÃ§amentos.',0),(8889,247,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÑÑ ÐºÐ°Ñ‚Ð°ÑÑ‚Ñ€Ð¾Ñ„Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð°.  ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³Ð¸ Ð´Ð»Ñ Ð²Ð°ÑˆÐµÐ³Ð¾ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°.',0),(8890,247,'es','Un CatÃ¡strofe Internal ha ocurrido. No se podÃ­a cambiar la jerarquÃ­a de sus presupuestos',0),(8891,247,'de','Eine interne Katastrophe stattgefunden hat.  Die Rankings fÃ¼r Ihre Budgets konnte nicht geÃ¤ndert werden.',0),(8892,247,'en','An internal catastrophe has occurred.  Could not change the rankings for your budgets.',0),(8893,248,'is','',0),(8894,248,'dr','. Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ù†Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡ Ø´Ù…Ø§ Ø±Ø§  ØªØºÙŠÙŠØ± Ø¯Ù‡Ø¯',0),(8895,248,'pr','ÙŠÙƒ Ø®Ø·Ø§ÙŠ Ø¬Ø¯ÙŠ Ø¯Ø§Ø®Ù„ÙŠ  Ø±ÙˆÙŠ Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª . Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ù†Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡ Ø´Ù…Ø§ Ø±Ø§  ØªØºÙŠÙŠØ± Ø¯Ù‡Ø¯',0),(8896,248,'tr','Dahili bir felaket meydana geldi.  BÃ¼tÃ§e adÄ±nÄ± deÄŸiÅŸtirebilirsiniz.',0),(8897,248,'pl','WystÄ…piÅ‚ wewnÄ™trzny katastrofy.  Nie moÅ¼na zmieniÄ‡ nazwÄ™ twÃ³j budÅ¼et.',0),(8898,248,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð°Ð»Ð° Ðµ Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð° ÐºÐ°Ñ‚Ð°ÑÑ‚Ñ€Ð¾Ñ„Ð°.  ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° ÑÐ¸.',0),(8899,248,'ur','Ø§ÛŒÚ© Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ ØªØ¨Ø§ÛÛŒ ÙˆØ§Ù‚Ø¹ ÛÙˆØ§ ÛÛ’ Û”  Ø¢Ù¾ Ú©Û’ Ø¨Ø¬Ù¹ Ú©Ø§ Ù†Ø§Ù… ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(8900,248,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ñ˜Ðµ ÑƒÐ½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ° ÐºÐ°Ñ‚Ð°ÑÑ‚Ñ€Ð¾Ñ„Ðµ.  ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³Ð°Ð¾ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¸Ð¼Ðµ Ð±ÑƒÑŸÐµÑ‚Ð°.',0),(8901,248,'vi','Lá»—i ná»™i bá»™. KhÃ´ng Ä‘á»•i tÃªn ngÃ¢n sÃ¡ch Ä‘Æ°á»£c',0),(8902,248,'af','\'n Interne katastrofe het voorgekom.  Kon nie die naam vir u begrotings verander.',0),(8903,248,'ro','S-a produs o catastrofÄƒ de interne.  Nu putea sÄƒ schimbe numele de bugetul dvs.',0),(8904,248,'et','Ilmnenud on sisemine katastroofi.  Oma eelarve nime ei saanud muuta.',0),(8905,248,'si','PriÅ¡lo je do notranje katastrofa.  Ne more spremeniti ime vaÅ¡ega proraÄuna.',0),(8906,248,'ba','Bencana internal yang telah terjadi.  Tidak dapat mengubah nama anggaran Anda.',0),(8907,248,'nl','Een interne ramp heeft plaatsgevonden.  De naam van uw budget kan niet worden gewijzigd.',0),(8908,248,'fi','SisÃ¤inen katastrofi on tapahtunut.  Budjetin nimi ei voinut muuttaa.',0),(8909,248,'no','Det oppstod en intern katastrofe.  Kan ikke endre navnet pÃ¥ budsjettet.',0),(8910,248,'da','Der opstod en intern katastrofe.  Kan ikke Ã¦ndre navnet pÃ¥ dit budget.',0),(8911,248,'ko','ë‚´ë¶€ ìž¬ì•™ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.  ì˜ˆì‚°ì˜ ì´ë¦„ì„ ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(8912,248,'he','×§×˜×¡×˜×¨×•×¤×” ×¤× ×™×ž×™×ª ××™×¨×¢×”.  ×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×©× ×•×ª ××ª ×”×©× ×©×œ ×”×ª×§×¦×™×‘ ×©×œ×š.',0),(8913,248,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ Î¼Î¹Î± ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® ÎºÎ±Ï„Î±ÏƒÏ„ÏÎ¿Ï†Î®.  Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î±Î»Î»Î¬Î¾ÎµÎ¹ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï ÏƒÎ±Ï‚.',0),(8914,248,'zh','å†…éƒ¨ç¾éš¾å·²ç»å‘ç”Ÿã€‚æ— æ³•æ”¹å˜ä½ çš„é¢„ç®—çš„åå­—\r\n',0),(8915,248,'sv','En inre katastrof har intrÃ¤ffat.  Kunde inte Ã¤ndra namnet pÃ¥ din budget.',0),(8916,248,'it','Si Ã¨ verificata una catastrofe interna.  Non poteva cambiare il nome del vostro budget.',0),(8917,248,'tl','',0),(8918,248,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3616;&#3634;&#3618;&#3651;&#3609; &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3594;&#',0),(8919,248,'hi','à¤à¤• à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¤à¤¬à¤¾à¤¹à¥€ à¤¹à¥à¤ˆ à¤¹à¥ˆà¥¤  à¤†à¤ªà¤•à¥‡ à¤¬à¤œà¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤® à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¾à¥¤',0),(8920,248,'ms','Bencana dalaman yang telah berlaku.  Tidak dapat menukar nama bajet anda.',0),(8921,248,'ar','ÙˆÙ‚Ø¯ Ø­Ø¯Ø«Øª ÙƒØ§Ø±Ø«Ø© Ø¯Ø§Ø®Ù„ÙŠØ©.  Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØºÙŠÙŠØ± Ø§Ø³Ù… Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(8922,248,'fr','Une catastrophe interne s\'est produite.  Pouvez pas changer le nom de votre budget.',0),(8923,248,'jp','å†…éƒ¨ã‚¨ãƒ©ãƒ¼ã?Œç™ºç”Ÿã?„ã?Ÿã?—ã?¾ã?—ã?Ÿã€‚äºˆç®—å??ã?Œå¤‰æ›´ã?§ã??ã?¾ã?›ã‚“',0),(8924,248,'pt','Ocorreu uma catÃ¡strofe interna.  NÃ£o poderia mudar o nome do seu orÃ§amento.',0),(8925,248,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÑÑ ÐºÐ°Ñ‚Ð°ÑÑ‚Ñ€Ð¾Ñ„Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð°.  ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¸Ð¼Ñ Ð²Ð°ÑˆÐµÐ³Ð¾ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°.',0),(8926,248,'es','Un CatÃ¡strofe Internal ha ocurrido. No se podÃ­a cambiar el nombre de su presupuesto',0),(8927,248,'de','Eine interne Katastrophe stattgefunden hat.  Der Name Ihres Budgets konnte nicht geÃ¤ndert werden.',0),(8928,248,'en','An internal catastrophe has occurred.  Could not change the name of your budget.',0),(8929,249,'is','',0),(8930,249,'dr','. Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ Ø±Ø§ Ø­Ø°Ù ÙƒÙ†Ø¯',0),(8931,249,'pr','ÙŠÙƒ Ø®Ø·Ø§ÙŠ Ø¬Ø¯ÙŠ Ø¯Ø§Ø®Ù„ÙŠ  Ø±ÙˆÙŠ Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª . Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ Ø±Ø§ Ø­Ø°Ù ÙƒÙ†Ø¯',0),(8932,249,'tr','Dahili bir felaket meydana geldi.  BÃ¼tÃ§eleri silin.',0),(8933,249,'pl','WystÄ…piÅ‚ wewnÄ™trzny katastrofy.  Nie moÅ¼na usunÄ…Ä‡ budÅ¼etÃ³w.',0),(8934,249,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð°Ð»Ð° Ðµ Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð° ÐºÐ°Ñ‚Ð°ÑÑ‚Ñ€Ð¾Ñ„Ð°.  ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° ÑÐµ Ð¸Ð·Ñ‚Ñ€Ð¸Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸.',0),(8935,249,'ur','Ø§ÛŒÚ© Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ ØªØ¨Ø§ÛÛŒ ÙˆØ§Ù‚Ø¹ ÛÙˆØ§ ÛÛ’ Û”  ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) Ú©Ùˆ Ø­Ø°Ù Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(8936,249,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ñ˜Ðµ ÑƒÐ½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ° ÐºÐ°Ñ‚Ð°ÑÑ‚Ñ€Ð¾Ñ„Ðµ.  ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ð±ÑƒÑŸÐµÑ‚Ðµ.',0),(8937,249,'vi','Lá»—i ná»™i bá»™. KhÃ´ng xÃ³a Ä‘Æ°á»£c ngÃ¢n sÃ¡ch',0),(8938,249,'af','\'n Interne katastrofe het ontstaan.  Was nie instaat om begrotings te skrap.',0),(8939,249,'ro','S-a produs o catastrofÄƒ de interne.  Imposibil de È™ters bugetele.',0),(8940,249,'et','Ilmnenud on sisemine katastroofi.  Eelarveid ei saa kustutada.',0),(8941,249,'si','PriÅ¡lo je do notranje katastrofa.  ProraÄuna ni bilo mogoÄe izbrisati.',0),(8942,249,'ba','Bencana internal yang telah terjadi.  Tidak dapat menghapus anggaran.',0),(8943,249,'nl','Een interne ramp heeft plaatsgevonden.  Kan geen gegevens begrotingen verwijderen.',0),(8944,249,'fi','SisÃ¤inen katastrofi on tapahtunut.  Budjetteja ei voitu poistaa.',0),(8945,249,'no','Det oppstod en intern katastrofe.  Kan ikke slette budsjetter.',0),(8946,249,'da','Der opstod en intern katastrofe.  Kunne ikke slette budgetter.',0),(8947,249,'ko','ë‚´ë¶€ ìž¬ì•™ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.  ì˜ˆì‚°ì„ ì‚­ì œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(8948,249,'he','×§×˜×¡×˜×¨×•×¤×” ×¤× ×™×ž×™×ª ××™×¨×¢×”.  ×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×—×•×§ ××ª ×”×ª×§×¦×™×‘×™×.',0),(8949,249,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ Î¼Î¹Î± ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® ÎºÎ±Ï„Î±ÏƒÏ„ÏÎ¿Ï†Î®.  Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚.',0),(8950,249,'zh','å†…éƒ¨ç¾éš¾å·²ç»å‘ç”Ÿã€‚æ— æ³•åˆ é™¤é¢„ç®—\r\n',0),(8951,249,'sv','En inre katastrof har intrÃ¤ffat.  Det gick inte att ta bort budgetar.',0),(8952,249,'it','Si Ã¨ verificata una catastrofe interna.  Impossibile eliminare i bilanci.',0),(8953,249,'tl','',0),(8954,249,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3616;&#3634;&#3618;&#3651;&#3609; &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3621;&#3610;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#',0),(8955,249,'hi','à¤à¤• à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¤à¤¬à¤¾à¤¹à¥€ à¤¹à¥à¤ˆ à¤¹à¥ˆà¥¤  à¤¬à¤œà¤Ÿ à¤•à¥‹ à¤¹à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(8956,249,'ms','Bencana dalaman yang telah berlaku.  Tidak dapat menghapuskan belanjawan.',0),(8957,249,'ar','ÙˆÙ‚Ø¯ Ø­Ø¯Ø«Øª ÙƒØ§Ø±Ø«Ø© Ø¯Ø§Ø®Ù„ÙŠØ©.  Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø­Ø°Ù Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª.',0),(8958,249,'fr','Une catastrophe interne s\'est produite.  Pas pu supprimer les budgets.',0),(8959,249,'jp','å†…éƒ¨ã‚¨ãƒ©ãƒ¼ã?Œç™ºç”Ÿã?„ã?Ÿã?—ã?¾ã?—ã?Ÿã€‚äºˆç®—ã?Œæ¶ˆåŽ»ã?§ã??ã?¾ã?›ã‚“',0),(8960,249,'pt','Ocorreu uma catÃ¡strofe interna.  NÃ£o foi possÃ­vel excluir os orÃ§amentos.',0),(8961,249,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÑÑ ÐºÐ°Ñ‚Ð°ÑÑ‚Ñ€Ð¾Ñ„Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð°.  ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¾Ð².',0),(8962,249,'es','Un CatÃ¡strofe Internal ha ocurrido. No se podÃ­a eliminar los presupuestos',0),(8963,249,'de','Eine interne Katastrophe stattgefunden hat.  Haushalte konnten nicht gelÃ¶scht werden.',0),(8964,249,'en','An internal catastrophe has occurred.  Could not delete budgets.',0),(8965,250,'is','',0),(8966,250,'dr','Ùˆ',0),(8967,250,'pr','Ùˆ',0),(8968,250,'tr','ve',0),(8969,250,'pl','i',0),(8970,250,'bg','Ð¸',0),(8971,250,'ur','Ø§ÙˆØ±',0),(8972,250,'sr','Ð¸',0),(8973,250,'vi','vÃ ',0),(8974,250,'af','en',0),(8975,250,'ro','ÅŸi',0),(8976,250,'et','ja',0),(8977,250,'si','in',0),(8978,250,'ba','dan',0),(8979,250,'nl','en',0),(8980,250,'fi','ja',0),(8981,250,'no','og',0),(8982,250,'da','og',0),(8983,250,'ko','ê·¸ë¦¬ê³ ',0),(8984,250,'he','×•',0),(8985,250,'el','ÎºÎ±Î¹',0),(8986,250,'zh','å’Œ\r\n',0),(8987,250,'sv','och',0),(8988,250,'it','e',0),(8989,250,'tl','',0),(8990,250,'th','&#3649;&#3621;&#3632;',0),(8991,250,'hi','à¤”à¤°',0),(8992,250,'ms','dan',0),(8993,250,'ar','Ùˆ',0),(8994,250,'fr','et',0),(8995,250,'jp','ã??ã?—ã?¦',0),(8996,250,'pt','e',0),(8997,250,'ru','Ð¸',0),(8998,250,'es','y',0),(8999,250,'de','und',0),(9000,250,'en','and',0),(9001,251,'is','',0),(9002,251,'dr','Ùˆ Ø§Ú¯Ø± Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ',0),(9003,251,'pr','Ùˆ Ø§Ú¯Ø± Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ',0),(9004,251,'tr','ve eÄŸer daha bÃ¼yÃ¼k',0),(9005,251,'pl','i jeÅ›li jest wiÄ™kszy niÅ¼',0),(9006,251,'bg','Ð¸ Ð°ÐºÐ¾ Ðµ Ð¿Ð¾-Ð³Ð¾Ð»ÑÐ¼ Ð¾Ñ‚',0),(9007,251,'ur','Ø§ÙˆØ± Ø§Ú¯Ø± Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø¨Ú‘Ø§',0),(9008,251,'sr','Ð° Ð°ÐºÐ¾ Ñ˜Ðµ Ð²ÐµÑ›Ð° Ð¾Ð´',0),(9009,251,'vi','vÃ  náº¿u lá»›n hÆ¡n',0),(9010,251,'af','en indien groter as',0),(9011,251,'ro','ÅŸi dacÄƒ mai mari',0),(9012,251,'et','ja kui suurem',0),(9013,251,'si','in Äe je veÄja od',0),(9014,251,'ba','dan jika lebih besar dari',0),(9015,251,'nl','en als groter dan',0),(9016,251,'fi','ja jos suurempi kuin',0),(9017,251,'no','og hvis det er stÃ¸rre enn',0),(9018,251,'da','og hvis stÃ¸rre end',0),(9019,251,'ko','ë³´ë‹¤ í° ê²½ìš°',0),(9020,251,'he','×•×× ×’×“×•×œ ×™×•×ª×¨',0),(9021,251,'el','ÎºÎ±Î¹ Î±Î½ ÎµÎ¯Î½Î±Î¹ Î¼ÎµÎ³Î±Î»ÏÏ„ÎµÏÎ¿ Î±Ï€ÏŒ',0),(9022,251,'zh','å¦‚æžœå¤§äºŽ\r\n',0),(9023,251,'sv','och om stÃ¶rre Ã¤n',0),(9024,251,'it','e se piÃ¹ grande',0),(9025,251,'tl','',0),(9026,251,'th','&#3649;&#3621;&#3632;&#3606;&#3657;&#3634;&#3651;&#3627;&#3597;&#3656;&#3648;&#3585;&#3636;&#3609;&#3585;&#3623;&#3656;&#3634;',0),(9027,251,'hi','à¤”à¤° à¤…à¤—à¤° à¤¸à¥‡ à¤¬à¤¡à¤¼à¥€',0),(9028,251,'ms','dan jika lebih besar daripada',0),(9029,251,'ar','ÙˆØ¥Ø°Ø§ ÙƒØ§Ù† Ø£ÙƒØ¨Ø± Ù…Ù†',0),(9030,251,'fr','et si il y a plus de',0),(9031,251,'jp','ã‚‚ã?—ï½žã‚ˆã‚Šå¤§ã??ã?‘ã‚Œã?°',0),(9032,251,'pt','e se maior do que',0),(9033,251,'ru','Ð¸ ÐµÑÐ»Ð¸ Ð±Ð¾Ð»ÑŒÑˆÐµ Ñ‡ÐµÐ¼',0),(9034,251,'es','y si es mÃ¡s grande que',0),(9035,251,'de','und wenn grÃ¶ÃŸer als',0),(9036,251,'en','and if larger than',0),(9037,252,'is','',0),(9038,252,'dr','Ùˆ Ø§Ú¯Ø± ÙƒÙˆÚ†ÙƒØªØ± Ø§Ø² ',0),(9039,252,'pr','Ùˆ Ø§Ú¯Ø± ÙƒÙˆÚ†ÙƒØªØ± Ø§Ø² ',0),(9040,252,'tr','EÄŸer daha kÃ¼Ã§Ã¼k ve',0),(9041,252,'pl','i jeÅ›li mniejsze niÅ¼',0),(9042,252,'bg','Ð¸ Ð°ÐºÐ¾ Ðµ Ð¿Ð¾-Ð¼Ð°Ð»ÑŠÐº Ð¾Ñ‚',0),(9043,252,'ur','Ø§ÙˆØ± Ø§Ú¯Ø± Ú†Ú¾ÙˆÙ¹Û’ Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(9044,252,'sr','Ð° Ð°ÐºÐ¾ Ñ˜Ðµ Ð¼Ð°ÑšÐ° Ð¾Ð´',0),(9045,252,'vi','vÃ  náº¿u nhá» hÆ¡n',0),(9046,252,'af','en indien kleiner as',0),(9047,252,'ro','ÅŸi dacÄƒ mai mici',0),(9048,252,'et','ja kui alla',0),(9049,252,'si','in Äe je manjÅ¡e od',0),(9050,252,'ba','dan jika lebih kecil daripada',0),(9051,252,'nl','en indien kleiner dan',0),(9052,252,'fi','ja alle',0),(9053,252,'no','og hvis det er mindre enn',0),(9054,252,'da','og hvis mindre end',0),(9055,252,'ko','ë³´ë‹¤ ìž‘ì€ ê²½ìš°',0),(9056,252,'he','×•×× ×§×˜×Ÿ ×™×•×ª×¨',0),(9057,252,'el','ÎºÎ±Î¹ Î±Î½ ÎµÎ¯Î½Î±Î¹ Î¼Î¹ÎºÏÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ',0),(9058,252,'zh','å¦‚æžœå°äºŽ\r\n',0),(9059,252,'sv','och om mindre Ã¤n',0),(9060,252,'it','e se Ã¨ piÃ¹ piccolo',0),(9061,252,'tl','',0),(9062,252,'th','&#3649;&#3621;&#3632;&#3606;&#3657;&#3634;&#3648;&#3621;&#3655;&#3585;&#3648;&#3585;&#3636;&#3609;&#3585;&#3623;&#3656;&#3634;',0),(9063,252,'hi','à¤”à¤° à¤…à¤—à¤° à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾ à¤®à¥‡à¤‚ à¤›à¥‹à¤Ÿà¥‡',0),(9064,252,'ms','dan jika lebih kecil daripada',0),(9065,252,'ar','ÙˆØ¥Ø°Ø§ ÙƒØ§Ù† Ø£ØµØºØ± Ù…Ù†',0),(9066,252,'fr','et si infÃ©rieurs Ã ',0),(9067,252,'jp','ã‚‚ã?—ï½žã‚ˆã‚Šå°?ã?•ã?‘ã‚Œã?°',0),(9068,252,'pt','e se menor do que',0),(9069,252,'ru','Ð¸ ÐµÑÐ»Ð¸ Ð¼ÐµÐ½ÑŒÑˆÐµ Ñ‡ÐµÐ¼',0),(9070,252,'es','y si es mÃ¡s pequeÃ±o que',0),(9071,252,'de','und wenn kleiner als',0),(9072,252,'en','and if smaller than',0),(9073,253,'is','',0),(9074,253,'dr','Ùˆ Ø§Ú¯Ø± Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ù…Ø´ÙƒÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†ÙŠØ¯',0),(9075,253,'pr','Ùˆ Ø§Ú¯Ø± Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ù…Ø´ÙƒÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†ÙŠØ¯',0),(9076,253,'tr','ve eÄŸer daha fazla siyah mÃ¼rekkep kullanarak',0),(9077,253,'pl','a jeÅ›li za pomocÄ… wiÄ™cej niÅ¼ czarny atrament',0),(9078,253,'bg','Ð¸ Ð°ÐºÐ¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ Ñ‡ÐµÑ€Ð½Ð¾ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾',0),(9079,253,'ur','Ø§ÙˆØ± Ø§Ú¯Ø± Ø³ÛŒØ§Û Ø³ÛŒØ§ÛÛŒ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(9080,253,'sr','Ð¸ Ð°ÐºÐ¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ñ†Ñ€Ð½Ð¸Ð¼ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾Ð¼',0),(9081,253,'vi','vÃ  náº¿u sá»­ dá»¥ng hÆ¡n má»±c Ä‘en',0),(9082,253,'af','en as gebruik meer as swart ink',0),(9083,253,'ro','ÅŸi dacÄƒ folosiÅ£i mai mult de cernealÄƒ neagrÄƒ',0),(9084,253,'et','ja kui kasutades Ã¼le musta tindiga',0),(9085,253,'si','in Äe z veÄ kot Ärno-belo',0),(9086,253,'ba','dan jika menggunakan lebih dari tinta hitam',0),(9087,253,'nl','en als meer dan zwarte inkt gebruikt',0),(9088,253,'fi','ja jos kÃ¤yttÃ¤Ã¤ enemmÃ¤n kuin mustaa mustetta',0),(9089,253,'no','og hvis bruker mer enn svart blekk',0),(9090,253,'da','og hvis bruger mere end sort blÃ¦k',0),(9091,253,'ko','ê²€ì • ìž‰í¬ ë³´ë‹¤ ë” ë§Žì´ ì‚¬ìš© í•˜ëŠ” ê²½ìš°',0),(9092,253,'he','×•×× ×‘××ž×¦×¢×•×ª ×™×•×ª×¨ ×ž×“×™×• ×©×—×•×¨',0),(9093,253,'el','ÎºÎ±Î¹ Î±Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ Î¼Î±ÏÏÎ¿ Î¼ÎµÎ»Î¬Î½Î¹',0),(9094,253,'zh','å¦‚æžœä½¿ç”¨å¤šäºŽé»‘è‰²å¢¨æ°´\r\n',0),(9095,253,'sv','och om du anvÃ¤nder mer Ã¤n svart blÃ¤ck',0),(9096,253,'it','e se si utilizza piÃ¹ di inchiostro nero',0),(9097,253,'tl','',0),(9098,253,'th','&#3649;&#3621;&#3632;&#3606;&#3657;&#3634;&#3651;&#3594;&#3657;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3627;&#3617;&#3638;&#3585;&#3626;&#3637;&#3604;&#3635;',0),(9099,253,'hi','à¤”à¤° à¤¯à¤¦à¤¿ à¤•à¤¾à¤²à¥€ à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¤¾',0),(9100,253,'ms','dan jika menggunakan lebih daripada dakwat hitam',0),(9101,253,'ar','ÙˆÙÙŠ Ø­Ø§Ù„Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø£ÙƒØ«Ø± Ù…Ù† Ø§Ù„Ø­Ø¨Ø± Ø§Ù„Ø£Ø³ÙˆØ¯',0),(9102,253,'fr','et si vous utilisez plus d\'encre noire',0),(9103,253,'jp','ã‚‚ã?—é»’ä»¥å¤–ã?«ã‚‚ã‚¤ãƒ³ã‚¯ã?Œä½¿ã‚?ã‚Œã?¦ã?„ã‚Œã?°',0),(9104,253,'pt','e se usar mais do que tinta preta',0),(9105,253,'ru','Ð¸ ÐµÑÐ»Ð¸ Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ñ‡ÐµÑ€Ð½Ñ‹Ð¼Ð¸ Ñ‡ÐµÑ€Ð½Ð¸Ð»Ð°Ð¼Ð¸',0),(9106,253,'es','y si esta usando mÃ¡s que Tinta Negra',0),(9107,253,'de','und wenn mehr als schwarze Tinte verwenden',0),(9108,253,'en','and if using more than black ink',0),(9109,254,'is','',0),(9110,254,'dr','Ùˆ Ø§Ú¯Ø± Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†ÙŠØ¯',0),(9111,254,'pr','Ùˆ Ø§Ú¯Ø± Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†ÙŠØ¯',0),(9112,254,'tr','ve eÄŸer birden fazla mÃ¼rekkep kullanarak',0),(9113,254,'pl','a jeÅ›li przy uÅ¼yciu wiÄ™cej niÅ¼ jednej farby',0),(9114,254,'bg','Ð¸ Ð°ÐºÐ¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð¸Ð½ Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ',0),(9115,254,'ur','Ø§ÙˆØ± Ø§Ú¯Ø± Ø§ÛŒÚ© Ø³Û’ Ø²Ø§Ø¦Ø¯ Ø³ÛŒØ§ÛÛŒ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(9116,254,'sr','Ð¸ Ð°ÐºÐ¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ñ˜ÐµÐ´Ð½Ð¾Ð³ Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿ÐµÑ€Ð¾Ð¼',0),(9117,254,'vi','vÃ  náº¿u sá»­ dá»¥ng hÆ¡n má»™t loáº¡i má»±c',0),(9118,254,'af','en indien meer as een ink gebruik',0),(9119,254,'ro','ÅŸi dacÄƒ mai mult de o cernealÄƒ',0),(9120,254,'et','ja kui enam kui Ã¼he tindi kasutamine',0),(9121,254,'si','in Äe uporabljate veÄ kot eno Ärnilo',0),(9122,254,'ba','dan jika menggunakan lebih dari satu tinta',0),(9123,254,'nl','en als meer dan Ã©Ã©n inkt gebruiken',0),(9124,254,'fi','ja jos useampi kuin yksi musteella',0),(9125,254,'no','og hvis bruker mer enn Ã©n trykkfarge',0),(9126,254,'da','og hvis bruger mere end Ã©n trykfarve',0),(9127,254,'ko','í•˜ë‚˜ ì´ìƒì˜ ìž‰í¬ë¥¼ ì‚¬ìš© í•˜ëŠ” ê²½ìš°ì™€',0),(9128,254,'he','×•×× ×‘××ž×¦×¢×•×ª ×“×™×• ××—×“ ××• ×™×•×ª×¨',0),(9129,254,'el','ÎºÎ±Î¹ Î±Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ± Î±Ï€ÏŒ Î­Î½Î± Î¼ÎµÎ»Î¬Î½Î¹Î±',0),(9130,254,'zh','å¦‚æžœä½¿ç”¨è¶…è¿‡ä¸€ç§å¢¨æ°´\r\n',0),(9131,254,'sv','och om du anvÃ¤nder mer Ã¤n en tryckfÃ¤rg',0),(9132,254,'it','e se si utilizza piÃ¹ di un inchiostro',0),(9133,254,'tl','',0),(9134,254,'th','&#3649;&#3621;&#3632;&#3606;&#3657;&#3634;&#3651;&#3594;&#3657;&#3627;&#3617;&#3638;&#3585;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3627;&#3609;&#3638;&#3656;&#3591;&#3626;&#3637;',0),(9135,254,'hi','à¤”à¤° à¤¯à¤¦à¤¿ à¤à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°',0),(9136,254,'ms','dan jika menggunakan dakwat lebih daripada satu',0),(9137,254,'ar','ÙˆÙÙŠ Ø­Ø§Ù„Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø£ÙƒØ«Ø± Ù…Ù† ÙˆØ§Ø­Ø¯ Ù…Ù† Ø§Ù„Ø­Ø¨Ø±',0),(9138,254,'fr','et si vous utilisez plus d\'une encre',0),(9139,254,'jp','ã‚‚ã?—ä¸€è‰²ä»¥ä¸Šã?®ã‚¤ãƒ³ã‚¯ã?Œä½¿ã‚?ã‚Œã?¦ã?„ã‚Œã?°',0),(9140,254,'pt','e se utilizar mais de uma tinta',0),(9141,254,'ru','Ð¸ ÐµÑÐ»Ð¸ Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ð¾Ð´Ð½Ð¾Ð¹ ÐºÑ€Ð°ÑÐºÐ¸',0),(9142,254,'es','y si esta usando mÃ¡s que una tinta',0),(9143,254,'de','und wenn mehr als eine Tinte verwenden',0),(9144,254,'en','and if using more than one ink',0),(9145,255,'is','',0),(9146,255,'dr','Ùˆ Ø§Ú¯Ø± Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø·Ø±Ù Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†ÙŠØ¯',0),(9147,255,'pr','Ùˆ Ø§Ú¯Ø± Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø·Ø±Ù Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†ÙŠØ¯',0),(9148,255,'tr','ve eÄŸer birden fazla yan kullanarak',0),(9149,255,'pl','a jeÅ›li przy uÅ¼yciu wiÄ™cej niÅ¼ jednej strony',0),(9150,255,'bg','Ð¸ Ð°ÐºÐ¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð°',0),(9151,255,'ur','Ø§ÙˆØ± Ø§Ú¯Ø± Ø§ÛŒÚ© Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Ù…Øª Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(9152,255,'sr','Ð¸ Ð°ÐºÐ¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ñ˜ÐµÐ´Ð½Ðµ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(9153,255,'vi','vÃ  náº¿u sá»­ dá»¥ng hÆ¡n má»™t máº·t',0),(9154,255,'af','en indien meer as een kant gebruik',0),(9155,255,'ro','ÅŸi dacÄƒ folosiÅ£i mai mult de o parte',0),(9156,255,'et','ja kui kasutada rohkem kui Ã¼hel kÃ¼ljel',0),(9157,255,'si','in Äe se uporabi veÄ kot ene strani',0),(9158,255,'ba','dan jika menggunakan lebih dari satu sisi',0),(9159,255,'nl','en als met behulp van meer dan een kant',0),(9160,255,'fi','ja jos enemmÃ¤n kuin yksi puoli',0),(9161,255,'no','og hvis bruker mer enn Ã©n side',0),(9162,255,'da','og hvis bruger mere end Ã©n side',0),(9163,255,'ko','í•˜ë‚˜ ì´ìƒì˜ ì¸¡ë©´ì„ ì‚¬ìš© í•˜ëŠ” ê²½ìš°ì™€',0),(9164,255,'he','×•×× ×‘××ž×¦×¢×•×ª ×¦×“ ××—×“ ××• ×™×•×ª×¨',0),(9165,255,'el','ÎºÎ±Î¹ ÎµÎ¬Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Î±Ï€ÏŒ Î¼Î¯Î± Ï€Î»ÎµÏ…ÏÎ¬',0),(9166,255,'zh','å¦‚æžœä½¿ç”¨å¤šä¸ªä¾§é¢\r\n',0),(9167,255,'sv','och om du anvÃ¤nder mer Ã¤n en sida',0),(9168,255,'it','e se si utilizza piÃ¹ di un lato',0),(9169,255,'tl','',0),(9170,255,'th','&#3649;&#3621;&#3632;&#3606;&#3657;&#3634;&#3651;&#3594;&#3657;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3627;&#3609;&#3638;&#3656;&#3591;&#3604;&#3657;&#3634;&#3609;',0),(9171,255,'hi','à¤”à¤° à¤¯à¤¦à¤¿ à¤à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤ªà¤•à¥à¤· à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¤¾',0),(9172,255,'ms','dan jika menggunakan lebih daripada satu bahagian',0),(9173,255,'ar','ÙˆÙÙŠ Ø­Ø§Ù„Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø£ÙƒØ«Ø± Ù…Ù† Ø§Ù„Ø¬Ø§Ù†Ø¨',0),(9174,255,'fr','et si vous utilisez plus d\'un cÃ´tÃ©',0),(9175,255,'jp','ã‚‚ã?—ä¸€é?¢ä»¥ä¸Šä½¿ã‚?ã‚Œã?¦ã?„ã‚Œã?°',0),(9176,255,'pt','e se usando mais de um lado',0),(9177,255,'ru','Ð¸ ÐµÑÐ»Ð¸ Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ð¾Ð´Ð½Ð¾Ð¹ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(9178,255,'es','y si esta usando mÃ¡s que un lado',0),(9179,255,'de','und wenn mehr als einer Seite zu verwenden',0),(9180,255,'en','and if using more than one side',0),(9181,256,'is','',0),(9182,256,'dr','Ùˆ Ù…Ø§Ù‡ ',0),(9183,256,'pr','Ùˆ Ù…Ø§Ù‡ ',0),(9184,256,'tr','ve ay',0),(9185,256,'pl','i miesiÄ…c',0),(9186,256,'bg','Ð¸ Ð¼ÐµÑÐµÑ†',0),(9187,256,'ur','Ø§ÙˆØ± Ù…Ø§Û',0),(9188,256,'sr','Ð¸ Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(9189,256,'vi','vÃ  ThÃ¡ng',0),(9190,256,'af','en Maand',0),(9191,256,'ro','ÅŸi luna',0),(9192,256,'et','ja kuu',0),(9193,256,'si','in mesec',0),(9194,256,'ba','dan bulan',0),(9195,256,'nl','en maand',0),(9196,256,'fi','ja kuukausi',0),(9197,256,'no','og mÃ¥ned',0),(9198,256,'da','og mÃ¥ned',0),(9199,256,'ko','ê·¸ë¦¬ê³  ë‹¬',0),(9200,256,'he','×•×—×•×“×©',0),(9201,256,'el','ÎºÎ±Î¹ Ï„Î¿ Î¼Î®Î½Î±',0),(9202,256,'zh','å’Œæœˆ\r\n',0),(9203,256,'sv','och mÃ¥nad',0),(9204,256,'it','e mese',0),(9205,256,'tl','',0),(9206,256,'th','&#3649;&#3621;&#3632;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(9207,256,'hi','à¤”à¤° à¤®à¤¹à¥€à¤¨à¥‡',0),(9208,256,'ms','dan bulan',0),(9209,256,'ar','ÙˆÙÙŠ Ø§Ù„Ø´Ù‡Ø±',0),(9210,256,'fr','et mois',0),(9211,256,'jp','ï½žã?¨æœˆ',0),(9212,256,'pt','e mÃªs',0),(9213,256,'ru','Ð¸ ÐœÐµÑÑÑ†',0),(9214,256,'es','y Mes',0),(9215,256,'de','und Monat',0),(9216,256,'en','and Month',0),(9217,257,'is','',0),(9218,257,'dr','Ø³Ù‡Ù…ÙŠÙ‡ Ù…Ø¹Ø§ÙÙŠØª Ø³Ø§Ù„Ø§Ù†Ù‡',0),(9219,257,'pr','Ø³Ù‡Ù…ÙŠÙ‡ Ù…Ø¹Ø§ÙÙŠØª Ø³Ø§Ù„Ø§Ù†Ù‡',0),(9220,257,'tr','YÄ±llÄ±k muafiyet hakkÄ±',0),(9221,257,'pl','Roczne zwolnienie dodatku',0),(9222,257,'bg','Ð“Ð¾Ð´Ð¸ÑˆÐ½Ð° Ð½Ð°Ð´Ð±Ð°Ð²ÐºÐ° Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ',0),(9223,257,'ur','Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ú©Û’ Ø³Ø§Ù„Ø§Ù†Û Ø§Ù„Ø§Ø¤Ù†Ø³',0),(9224,257,'sr','Ð“Ð¾Ð´Ð¸ÑˆÑšÐ° Ð½Ð°Ð´Ð¾ÐºÐ½Ð°Ð´Ð° Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(9225,257,'vi','Trá»£ Cáº¥p Miá»…n Trá»« HÃ ng NÄƒm',0),(9226,257,'af','Jaarlikse Vrystellingstoelaag',0),(9227,257,'ro','AlocaÅ£ia de scutirea anualÄƒ',0),(9228,257,'et','Aastase maksuvabastuse hÃ¼vitisega',0),(9229,257,'si','Letne oprostitve nadomestila',0),(9230,257,'ba','Tahunan pembebasan tunjangan',0),(9231,257,'nl','Jaarlijkse toelage van de vrijstelling',0),(9232,257,'fi','Vuotuinen vapautus korvaus',0),(9233,257,'no','Ã…rlige fritak godtgjÃ¸relse',0),(9234,257,'da','Ã…rlige fritagelse godtgÃ¸relse',0),(9235,257,'ko','ì—°ë¡€ ë©´ì œ ìˆ˜ë‹¹',0),(9236,257,'he','×”×§×¦×‘×” ×”×¤×˜×•×¨ ×”×©× ×ª×™',0),(9237,257,'el','Î•Ï„Î®ÏƒÎ¹Î¿ ÎµÏ€Î¯Î´Î¿Î¼Î± Î±Ï€Î±Î»Î»Î±Î³Î®',0),(9238,257,'zh','å¹´åº¦è±å…æ´¥è´´\r\n',0),(9239,257,'sv','Ã…rliga undantag ersÃ¤ttning',0),(9240,257,'it','Assegno annuale di esenzione',0),(9241,257,'tl','',0),(9242,257,'th','&#3585;&#3634;&#3619;&#3618;&#3636;&#3609;&#3618;&#3629;&#3617;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3611;&#3619;&#3632;&#3592;&#3635;&#3611;&#3637;',0),(9243,257,'hi','à¤µà¤¾à¤°à¥à¤·à¤¿à¤• à¤›à¥‚à¤Ÿ à¤­à¤¤à¥à¤¤à¤¾',0),(9244,257,'ms','Elaun pengecualian Tahunan',0),(9245,257,'ar','Ø¨Ø¯Ù„ Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø³Ù†ÙˆÙŠ',0),(9246,257,'fr','Allocation d\'Exemption annuelle',0),(9247,257,'jp','å¹´é–“æŽ§é™¤æ‰‹å½“ã?¦',0),(9248,257,'pt','SubsÃ­dio anual de isenÃ§Ã£o',0),(9249,257,'ru','Ð•Ð¶ÐµÐ³Ð¾Ð´Ð½Ð°Ñ Ð½Ð°Ð´Ð±Ð°Ð²ÐºÐ° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(9250,257,'es','Cuota de ExenciÃ³n Anual',0),(9251,257,'de','JÃ¤hrliche Befreiung-EntschÃ¤digung',0),(9252,257,'en','Annual Exemption Allowance',0),(9253,258,'is','',0),(9254,258,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„ Ø¯ÙŠÚ¯Ø± ÙŠØ§ Ú†Ø§Ù¾ ',0),(9255,258,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„ Ø¯ÙŠÚ¯Ø± ÙŠØ§ Ú†Ø§Ù¾ ',0),(9256,258,'tr','BaÅŸka bir gemi miktar veya YazdÄ±r',0),(9257,258,'pl','IloÅ›Ä‡ innego statku lub wydruku',0),(9258,258,'bg','Ð”Ñ€ÑƒÐ³ ÐºÐ¾Ñ€Ð°Ð± ÐºÐ¾Ð» Ð¸Ð»Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚',0),(9259,258,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ù‚ÛŒ ÛŒØ§ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(9260,258,'sr','ÐˆÐ¾Ñˆ Ñ˜ÐµÐ´Ð°Ð½ Ð±Ñ€Ð¾Ð´ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ Ð¸Ð»Ð¸ ÐŸÑ€Ð¸Ð½Ñ‚',0),(9261,258,'vi','Sá»‘ LÆ°á»£ng VÃ¢n Chuyá»ƒn hay In KhÃ¡c',0),(9262,258,'af','\'n Ander Versendings Hoev. of Uitdruk',0),(9263,258,'ro','O altÄƒ navÄƒ cantit sau Print',0),(9264,258,'et','Teise laeva kogus vÃµi Prindi',0),(9265,258,'si','Drugi ladji koliÄina ali tiskanje',0),(9266,258,'ba','Qty kapal lainnya atau cetak',0),(9267,258,'nl','Een ander schip Qty of afdrukken',0),(9268,258,'fi','Toisen aluksen mÃ¤Ã¤rÃ¤ tai tulosta',0),(9269,258,'no','Et annet skip antall eller utskrift',0),(9270,258,'da','Et andet skib Qty eller Print',0),(9271,258,'ko','ë˜ ë‹¤ë¥¸ ë°° ìˆ˜ëŸ‰ ë˜ëŠ” ì¸ì‡„',0),(9272,258,'he','×¡×¤×™× ×” × ×•×¡×¤×ª ×›×ž×•×ª ××• ×”×“×¤×¡×”',0),(9273,258,'el','Qty Î¬Î»Î»Î¿ Ï€Î»Î¿Î¯Î¿ Î® ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(9274,258,'zh','å¦ä¸€èˆ¹æ•°é‡æˆ–æ‰“å°\r\n',0),(9275,258,'sv','Annat fartyg Kvt eller skriv ut',0),(9276,258,'it','Un\'altra nave Qty o stampa',0),(9277,258,'tl','',0),(9278,258,'th','&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3588;&#3640;&#3603;&#3616;&#3634;&#3614;&#3627;&#3619;&#3639;&#3629;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3629;&#3633;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(9279,258,'hi','à¤à¤• à¤”à¤° à¤œà¤¹à¤¾à¤œ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¯à¤¾ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(9280,258,'ms','Qty kapal lain atau cetak',0),(9281,258,'ar','Qty Ø³ÙÙŠÙ†Ø© Ø£Ø®Ø±Ù‰ Ø£Ùˆ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(9282,258,'fr','Un autre navire Qty ou Print',0),(9283,258,'jp','ä»–ã?®é…?é€?æ•°é‡?ã?‹å?°åˆ·',0),(9284,258,'pt','Qtde de outra nave ou impressÃ£o',0),(9285,258,'ru','Ð•Ñ‰Ðµ Ð¾Ð´Ð¸Ð½ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Qty Ð¸Ð»Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(9286,258,'es','Otra Cantidad de Enviar o Imprimir',0),(9287,258,'de','Ein weiteres Schiff Qty \"oder\" Drucken',0),(9288,258,'en','Another Ship Qty or Print',0),(9289,259,'is','',0),(9290,259,'dr','Ù‡Ø± Ù…Ù†Ø¨Ø¹ÙŠ',0),(9291,259,'pr','Ù‡Ø± Ù…Ù†Ø¨Ø¹ÙŠ',0),(9292,259,'tr','Herhangi bir kaynak',0),(9293,259,'pl','Wszelkie ÅºrÃ³dÅ‚a',0),(9294,259,'bg','Ð’ÑÐµÐºÐ¸ Ð¸Ð·Ñ‚Ð¾Ñ‡Ð½Ð¸Ðº',0),(9295,259,'ur','Ú©Ø³ÛŒ Ø¨Ú¾ÛŒ Ù…Ø§Ø®Ø°',0),(9296,259,'sr','Ð‘Ð¸Ð»Ð¾ ÐºÐ¾Ñ˜Ð¸ Ð¸Ð·Ð²Ð¾Ñ€',0),(9297,259,'vi','Báº¥t Ká»³ Nguá»“n NÃ o',0),(9298,259,'af','Enige Bron',0),(9299,259,'ro','Orice sursÄƒ',0),(9300,259,'et','Infoallikate',0),(9301,259,'si','Vsak vir',0),(9302,259,'ba','Sumber',0),(9303,259,'nl','Elke bron',0),(9304,259,'fi','Tahansa lÃ¤hteestÃ¤',0),(9305,259,'no','Noen kilde',0),(9306,259,'da','Enhver kilde',0),(9307,259,'ko','ëª¨ë“  ì†ŒìŠ¤',0),(9308,259,'he','×›×œ ×ž×§×•×¨',0),(9309,259,'el','ÎŸÏ€Î¿Î¹Î±Î´Î®Ï€Î¿Ï„Îµ Ï€Î·Î³Î®',0),(9310,259,'zh','ä»»ä½•æ¥æº\r\n',0),(9311,259,'sv','NÃ¥gon kÃ¤lla',0),(9312,259,'it','Qualsiasi fonte',0),(9313,259,'tl','',0),(9314,259,'th','&#3610;&#3634;&#3591;&#3649;&#3627;&#3621;&#3656;&#3591;&#3607;&#3637;&#3656;&#3617;&#3634;',0),(9315,259,'hi','à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤¸à¥à¤°à¥‹à¤¤',0),(9316,259,'ms','Mana-mana sumber',0),(9317,259,'ar','Ø£ÙŠ Ù…ØµØ¯Ø±',0),(9318,259,'fr','N\'importe quelle Source',0),(9319,259,'jp','ã?‚ã‚‰ã‚†ã‚‹æº?æ³‰',0),(9320,259,'pt','Qualquer fonte',0),(9321,259,'ru','Ð›ÑŽÐ±Ð¾Ð¹ Ð¸ÑÑ‚Ð¾Ñ‡Ð½Ð¸Ðº',0),(9322,259,'es','Alguna Fuente',0),(9323,259,'de','Jede Quelle',0),(9324,259,'en','Any Source',0),(9325,260,'is','',0),(9326,260,'dr','Ù‡Ø±ÙƒØ³ÙŠ ',0),(9327,260,'pr','Ù‡Ø±ÙƒØ³ÙŠ ',0),(9328,260,'tr','Kimse',0),(9329,260,'pl','KtoÅ›',0),(9330,260,'bg','Ð’ÑÐµÐºÐ¸',0),(9331,260,'ur','Ú©Ø³ÛŒ Ú©Ùˆ Ø¨Ú¾ÛŒ',0),(9332,260,'sr','ÐÐ¸ÐºÐ¾Ð¼Ðµ',0),(9333,260,'vi','Báº¥t Cá»© Ai',0),(9334,260,'af','Enige iemand',0),(9335,260,'ro','Oricine',0),(9336,260,'et','KÃµik',0),(9337,260,'si','Kdorkoli',0),(9338,260,'ba','Siapa pun',0),(9339,260,'nl','Iedereen',0),(9340,260,'fi','Kuka tahansa',0),(9341,260,'no','Noen',0),(9342,260,'da','Nogen',0),(9343,260,'ko','ëˆ„êµ¬ ë“  ì§€',0),(9344,260,'he','×›×œ ××—×“',0),(9345,260,'el','ÎšÎ¬Ï€Î¿Î¹Î¿Ï‚',0),(9346,260,'zh','ä»»ä½•äºº\r\n',0),(9347,260,'sv','NÃ¥gon',0),(9348,260,'it','Chiunque',0),(9349,260,'tl','',0),(9350,260,'th','&#3610;&#3634;&#3591;&#3588;&#3609;',0),(9351,260,'hi','à¤•à¤¿à¤¸à¥€ à¤•à¥‹ à¤­à¥€',0),(9352,260,'ms','Sesiapa sahaja',0),(9353,260,'ar','Ø£ÙŠ Ø´Ø®Øµ',0),(9354,260,'fr','N\'importe qui',0),(9355,260,'jp','èª°ã?§ã‚‚',0),(9356,260,'pt','Qualquer um',0),(9357,260,'ru','ÐšÑ‚Ð¾ Ð£Ð³Ð¾Ð´Ð½Ð¾',0),(9358,260,'es','Alguien',0),(9359,260,'de','Jeder',0),(9360,260,'en','Anyone',0),(9361,261,'is','',0),(9362,261,'dr','Ù‡Ø± Ú†ÙŠØ²ÙŠ ',0),(9363,261,'pr','Ù‡Ø± Ú†ÙŠØ²ÙŠ ',0),(9364,261,'tr','bir ÅŸey',0),(9365,261,'pl','nic',0),(9366,261,'bg','Ð½Ð¸Ñ‰Ð¾',0),(9367,261,'ur','Ú©Ú†Ú¾ Ø¨Ú¾ÛŒ',0),(9368,261,'sr','Ð½Ð¸ÑˆÑ‚Ð°',0),(9369,261,'vi','báº¥t cá»© cÃ¡i gÃ¬',0),(9370,261,'af','enige iets',0),(9371,261,'ro','nimic',0),(9372,261,'et','kÃµik',0),(9373,261,'si','niÄesar',0),(9374,261,'ba','apa pun',0),(9375,261,'nl','om het even wat',0),(9376,261,'fi','mitÃ¤Ã¤n',0),(9377,261,'no','noe',0),(9378,261,'da','noget',0),(9379,261,'ko','ì•„ë¬´ê²ƒë„',0),(9380,261,'he','×©×•× ×“×‘×¨',0),(9381,261,'el','Ï„Î¯Ï€Î¿Ï„Î±',0),(9382,261,'zh','ä»»ä½•ä¸œè¥¿\r\n',0),(9383,261,'sv','nÃ¥got',0),(9384,261,'it','niente',0),(9385,261,'tl','',0),(9386,261,'th','&#3610;&#3634;&#3591;&#3626;&#3636;&#3656;&#3591;',0),(9387,261,'hi','à¤•à¥à¤› à¤­à¥€',0),(9388,261,'ms','apa-apa',0),(9389,261,'ar','Ø£ÙŠ Ø´ÙŠØ¡',0),(9390,261,'fr','n\'importe quoi',0),(9391,261,'jp','ã?©ã‚Œã?§ã‚‚',0),(9392,261,'pt','nada',0),(9393,261,'ru','Ñ‡Ñ‚Ð¾-Ð½Ð¸Ð±ÑƒÐ´ÑŒ',0),(9394,261,'es','cualquier cosa',0),(9395,261,'de','alles andere',0),(9396,261,'en','anything',0),(9397,262,'is','',0),(9398,262,'dr','ØªØ§ÙŠÙŠØ¯',0),(9399,262,'pr','ØªØ§ÙŠÙŠØ¯',0),(9400,262,'tr','AP',0),(9401,262,'pl','AP',0),(9402,262,'bg','AP',0),(9403,262,'ur','AP',0),(9404,262,'sr','ÐÐŸ',0),(9405,262,'vi','TÃ i khoáº£n pháº£i tráº£',0),(9406,262,'af','RB',0),(9407,262,'ro','AP',0),(9408,262,'et','AP',0),(9409,262,'si','AP',0),(9410,262,'ba','AP',0),(9411,262,'nl','AP',0),(9412,262,'fi','AP',0),(9413,262,'no','AP',0),(9414,262,'da','AP',0),(9415,262,'ko','AP',0),(9416,262,'he','AP',0),(9417,262,'el','AP',0),(9418,262,'zh','åº”ä»˜è´¦æ¬¾\r\n',0),(9419,262,'sv','AP',0),(9420,262,'it','AP',0),(9421,262,'tl','',0),(9422,262,'th','&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(9423,262,'hi','à¤à¤ªà¥€',0),(9424,262,'ms','AP',0),(9425,262,'ar','Ø£ ÙØ¨',0),(9426,262,'fr','AP',0),(9427,262,'jp','AP',0),(9428,262,'pt','AP',0),(9429,262,'ru','AP',0),(9430,262,'es','CP',0),(9431,262,'de','LD',0),(9432,262,'en','AP',0),(9433,263,'is','',0),(9434,263,'dr','ØªØ§ÙŠÙŠØ¯ Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(9435,263,'pr','ØªØ§ÙŠÙŠØ¯ Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(9436,263,'tr','YaÅŸlandÄ±rma raporunu AP',0),(9437,263,'pl','AP Raport wiekowania',0),(9438,263,'bg','AP ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(9439,263,'ur','AP Ø±Ù¾ÙˆØ±Ù¹ Ø®Ø³ØªÛ',0),(9440,263,'sr','ÐÐŸ ÑÑ‚Ð°Ñ€ÐµÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(9441,263,'vi','BÃ¡o CÃ¡o Pháº£i Tráº£ Theo Tuá»•i Ná»£',0),(9442,263,'af','RB Ouderdomsverslag',0),(9443,263,'ro','AP Raport de imbatranire',0),(9444,263,'et','Aegumisaruande AP',0),(9445,263,'si','AP Aging poroÄilo',0),(9446,263,'ba','AP penuaan laporan',0),(9447,263,'nl','AP veroudering verslag',0),(9448,263,'fi','AP yht.veto-raportin',0),(9449,263,'no','AP aldersfordelt saldoliste',0),(9450,263,'da','AP Aging rapport',0),(9451,263,'ko','AP ë¶„ê¸° ë ˆí¬íŠ¸',0),(9452,263,'he','AP ×“×•×— ×’×™×•×œ',0),(9453,263,'el','AP Î•Î½Î·Î»Î¹ÎºÎ¯Ï‰ÏƒÎ·Ï‚ Î¥Ï€Î¿Î»',0),(9454,263,'zh','åº”ä»˜è´¦æ¬¾è´¦é¾„æŠ¥å‘Š\r\n',0),(9455,263,'sv','AP Ã…ldersrapport',0),(9456,263,'it','AP Report di invecchiamento',0),(9457,263,'tl','',0),(9458,263,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(9459,263,'hi','à¤à¤ªà¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤à¤œà¤¿à¤‚à¤—',0),(9460,263,'ms','AP penuaan Laporan',0),(9461,263,'ar','AP Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(9462,263,'fr','AP rapport d\'ANTERIORITE',0),(9463,263,'jp','ï¼¡ï¼°ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(9464,263,'pt','AP relatÃ³rio do envelhecimento',0),(9465,263,'ru','AP ÑÑ‚Ð°Ñ€ÐµÐ½Ð¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(9466,263,'es','CP Informe de Antiguedad',0),(9467,263,'de','AP Alterung Bericht',0),(9468,263,'en','AP Aging Report',0),(9469,264,'is','',0),(9470,264,'dr','ØªØ§ÙŠÙŠØ¯ Ù„ÙŠØ³Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(9471,264,'pr','ØªØ§ÙŠÙŠØ¯ Ù„ÙŠØ³Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(9472,264,'tr','AP fatura listesi',0),(9473,264,'pl','AP Bill listy',0),(9474,264,'bg','AP Ð±Ð¸Ð» ÑÐ¿Ð¸ÑÑŠÐº',0),(9475,264,'ur','AP Ø¨Ù„ ÙÛØ±Ø³Øª',0),(9476,264,'sr','ÐÐŸ Ð‘Ð¸Ð» Ð»Ð¸ÑÑ‚Ð°',0),(9477,264,'vi','Danh SÃ¡ch AP Xuáº¥t HÃ³a ÄÆ¡n',0),(9478,264,'af','RB Rekeninglys',0),(9479,264,'ro','ListÄƒ de Bill AP',0),(9480,264,'et','AP Bill loend',0),(9481,264,'si','AP Bill seznam',0),(9482,264,'ba','AP Bill daftar',0),(9483,264,'nl','AP Bill lijst',0),(9484,264,'fi','AP Bill luettelo',0),(9485,264,'no','AP Bill liste',0),(9486,264,'da','AP Bill liste',0),(9487,264,'ko','AP ë²•ì•ˆ ëª©ë¡',0),(9488,264,'he','×¨×©×™×ž×ª ×‘×™×œ AP',0),(9489,264,'el','AP Bill Î»Î¯ÏƒÏ„Î±',0),(9490,264,'zh','åº”ä»˜è´¦æ¬¾æ˜Žç»†è¡¨\r\n',0),(9491,264,'sv','AP Bill lista',0),(9492,264,'it','Elenco di Bill AP',0),(9493,264,'tl','',0),(9494,264,'th','&#3619;&#3634;&#3618;&#3594;&#3639;&#3656;&#3629;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(9495,264,'hi','à¤à¤ªà¥€ à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤¸à¥‚à¤šà¥€',0),(9496,264,'ms','Senarai Rang undang-undang AP',0),(9497,264,'ar','AP Ø¨ÙŠÙ„ Ù‚Ø§Ø¦Ù…Ø©',0),(9498,264,'fr','Liste de Bill AP',0),(9499,264,'jp','APè«‹æ±‚æ›¸ãƒªã‚¹ãƒˆ',0),(9500,264,'pt','Lista de Bill AP',0),(9501,264,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð‘Ð¸Ð»Ð» AP',0),(9502,264,'es','CP Lista de Facturas',0),(9503,264,'de','AP Bill Liste',0),(9504,264,'en','AP Bill List',0),(9505,265,'is','',0),(9506,265,'dr','ØªØ§ÙŠÙŠØ¯ Ú†Ùƒ Ù„ÙŠØ³Øª',0),(9507,265,'pr','ØªØ§ÙŠÙŠØ¯ Ú†Ùƒ Ù„ÙŠØ³Øª',0),(9508,265,'tr','AP kontrol listesi',0),(9509,265,'pl','Lista wyboru AP',0),(9510,265,'bg','AP ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº',0),(9511,265,'ur','AP Ù¾Ú‘ØªØ§Ù„ ÙÛØ±Ø³Øª',0),(9512,265,'sr','ÐÐŸ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ð° Ð»Ð¸ÑÑ‚Ð°',0),(9513,265,'vi','Danh SÃ¡ch Kiá»ƒm Tra TK Pháº£i Tráº£',0),(9514,265,'af','RB Nasienlys',0),(9515,265,'ro','Lista de verificare de AP',0),(9516,265,'et','AP kontroll-loend',0),(9517,265,'si','AP preverite seznam',0),(9518,265,'ba','Daftar Periksa AP',0),(9519,265,'nl','AP checklist',0),(9520,265,'fi','AP muistilista',0),(9521,265,'no','AP sjekkliste',0),(9522,265,'da','AP tjekliste',0),(9523,265,'ko','AP ì²´í¬ ë¦¬ìŠ¤íŠ¸',0),(9524,265,'he','×”×¨×©×™×ž×” ×©×œ AP',0),(9525,265,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… AP',0),(9526,265,'zh','åº”ä»˜è´¦æ¬¾æ¸…å•\r\n',0),(9527,265,'sv','AP checklista',0),(9528,265,'it','Elenco di controllo di AP',0),(9529,265,'tl','',0),(9530,265,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3619;&#3634;&#3618;&#3594;&#3639;&#3656;&#3629;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(9531,265,'hi','à¤à¤ªà¥€ à¤œà¤¾à¤‚à¤š à¤¸à¥‚à¤šà¥€',0),(9532,265,'ms','Senarai Semak AP',0),(9533,265,'ar','Ù‚Ø§Ø¦Ù…Ø© ØµÙƒÙˆÙƒ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯Ø§Ø¦Ù†Ø© ',0),(9534,265,'fr','Liste de vÃ©rification de l\'AP',0),(9535,265,'jp','APå°?åˆ‡æ‰‹ãƒªã‚¹ãƒˆ',0),(9536,265,'pt','Lista de verificaÃ§Ã£o de AP',0),(9537,265,'ru','AP ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(9538,265,'es','CP Lista de ComprobaciÃ³n',0),(9539,265,'de','AP-Checkliste',0),(9540,265,'en','AP Check List',0),(9541,266,'is','',0),(9542,266,'dr','ØªØ§ÙŠÙŠØ¯ Ø¨Ø±Ø±Ø³ÙŠ',0),(9543,266,'pr','ØªØ§ÙŠÙŠØ¯ Ø¨Ø±Ø±Ø³ÙŠ',0),(9544,266,'tr','AP denetleme',0),(9545,266,'pl','Sprawdzanie AP',0),(9546,266,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° AP',0),(9547,266,'ur','AP Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(9548,266,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° ÐÐŸ',0),(9549,266,'vi','Kiá»ƒm Tra TK Pháº£i Tráº£',0),(9550,266,'af','GP kontroleer',0),(9551,266,'ro','AP de verificare',0),(9552,266,'et','AP kontrollimine',0),(9553,266,'si','AP preverjanje',0),(9554,266,'ba','AP memeriksa',0),(9555,266,'nl','AP controleren',0),(9556,266,'fi','AP tarkistaminen',0),(9557,266,'no','AP sjekke',0),(9558,266,'da','AP kontrol',0),(9559,266,'ko','AP ê²€ì‚¬',0),(9560,266,'he','×‘×“×™×§×ª AP',0),(9561,266,'el','Î‘Î  Ï„Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿',0),(9562,266,'zh','åº”ä»˜è´¦æ¬¾æ£€æŸ¥\r\n',0),(9563,266,'sv','AP kontroll',0),(9564,266,'it','Controllo AP',0),(9565,266,'tl','',0),(9566,266,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(9567,266,'hi','à¤à¤ªà¥€ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(9568,266,'ms','Menyemak AP',0),(9569,266,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(9570,266,'fr','VÃ©rification de l\'AP',0),(9571,266,'jp','APå°?åˆ‡æ‰‹',0),(9572,266,'pt','VerificaÃ§Ã£o de AP',0),(9573,266,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° AP',0),(9574,266,'es','CP ComprobaciÃ³n',0),(9575,266,'de','AP Ã¼berprÃ¼fen',0),(9576,266,'en','AP Checking',0),(9577,267,'is','',0),(9578,267,'dr','ØªØ§ÙŠÙŠØ¯ Ø¬Ø²Ø¦ÙŠØ§Øª Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(9579,267,'pr','ØªØ§ÙŠÙŠØ¯ Ø¬Ø²Ø¦ÙŠØ§Øª Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(9580,267,'tr','AP ayrÄ±ntÄ± raporu',0),(9581,267,'pl','AP szczegÃ³Å‚owy raport wiekowania',0),(9582,267,'bg','AP Ð´ÐµÑ‚Ð°Ð¹Ð»Ð½Ð¾ÑÑ‚ ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(9583,267,'ur','AP ØªÙØµÛŒÙ„ Ø±Ù¾ÙˆØ±Ù¹ Ø®Ø³ØªÛ',0),(9584,267,'sr','ÐÐŸ Ð´ÐµÑ‚Ð°Ñ™ ÑÑ‚Ð°Ñ€ÐµÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(9585,267,'vi','BÃ¡o CÃ¡o Pháº£i Tráº£ Theo Tuá»•i Ná»£ Chi Tiáº¿t ',0),(9586,267,'af','RB Detail Ouderdomsverslag',0),(9587,267,'ro','AP detaliu raportul de imbatranire',0),(9588,267,'et','Aegumisaruande AP Detail',0),(9589,267,'si','AP podrobno poroÄilo o staranju',0),(9590,267,'ba','AP Detail penuaan laporan',0),(9591,267,'nl','AP Detail veroudering verslag',0),(9592,267,'fi','AP yksityiskohtaisesti yht.veto-raportin',0),(9593,267,'no','AP detalj aldersfordelt saldoliste',0),(9594,267,'da','AP detaljer Aging rapport',0),(9595,267,'ko','AP ìƒì„¸ ë¶„ê¸° ë ˆí¬íŠ¸',0),(9596,267,'he','×¤×™×¨×•×˜ AP ×“×•×— ×’×™×•×œ',0),(9597,267,'el','AP Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î•Î½Î·Î»Î¹ÎºÎ¯Ï‰ÏƒÎ·Ï‚ Î¥Ï€Î¿Î»',0),(9598,267,'zh','ç¾Žè”ç¤¾è¯¦ç»†å¸é¾„æŠ¥è¡¨\r\n',0),(9599,267,'sv','AP detalj Ã…ldersrapport',0),(9600,267,'it','Dettaglio AP relazione di invecchiamento',0),(9601,267,'tl','',0),(9602,267,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3',0),(9603,267,'hi','à¤à¤ªà¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤à¤œà¤¿à¤‚à¤— à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(9604,267,'ms','AP butiran penuaan Laporan',0),(9605,267,'ar','AP Ø§Ù„ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(9606,267,'fr','DÃ©tail AP rapport d\'ANTERIORITE',0),(9607,267,'jp','APè©³ç´°ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(9608,267,'pt','AP detalhe relatÃ³rio do envelhecimento',0),(9609,267,'ru','AP Ð´ÐµÑ‚Ð°Ð»ÑŒ ÑÑ‚Ð°Ñ€ÐµÐ½Ð¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(9610,267,'es','CP Informe de Antiguedad Detallado',0),(9611,267,'de','AP Detail Alterung Bericht',0),(9612,267,'en','AP Detail Aging Report',0),(9613,268,'is','',0),(9614,268,'dr','ØªØ§ÙŠÙŠØ¯  Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„',0),(9615,268,'pr','ØªØ§ÙŠÙŠØ¯  Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„',0),(9616,268,'tr','AP standart GL hesaplarÄ±',0),(9617,268,'pl','Konta AP Standard GL',0),(9618,268,'bg','AP ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ GL ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(9619,268,'ur','AP Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(9620,268,'sr','ÐÐŸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ñƒ Ð“Ð› Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(9621,268,'vi','Pháº£i Thu TK Sá»• CÃ¡i Tá»•ng Há»£p Chuáº©n',0),(9622,268,'af','RB Standaard AG Rekeninge',0),(9623,268,'ro','AP Standard GL conturi',0),(9624,268,'et','AP standardi GL kontod',0),(9625,268,'si','AP Standard GL raÄunov',0),(9626,268,'ba','AP standar GL account',0),(9627,268,'nl','AP standaard GL Accounts',0),(9628,268,'fi','AP standardi GL tilit',0),(9629,268,'no','AP Standard GL kontoer',0),(9630,268,'da','AP Standard GL konti',0),(9631,268,'ko','AP í‘œì¤€ GL ê³„ì •',0),(9632,268,'he','×ª×§×Ÿ AP GL ×—×©×‘×•× ×•×ª',0),(9633,268,'el','AP Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ GL',0),(9634,268,'zh','åº”ä»˜è´¦æ¬¾æ ‡å‡†æ€»å¸å¸æˆ·\r\n',0),(9635,268,'sv','AP Standard GL konton',0),(9636,268,'it','Conti GL AP Standard',0),(9637,268,'tl','',0),(9638,268,'th','&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(9639,268,'hi','à¤à¤ªà¥€ à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‹à¤‚',0),(9640,268,'ms','AP Standard GL akaun',0),(9641,268,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯Ø§Ø¦Ù†Ø© Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ù„Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(9642,268,'fr','GLG AP Standard',0),(9643,268,'jp','APæ¨™æº–ç·?å‹˜å®šå…ƒå¸³',0),(9644,268,'pt','Norma AP GL contas',0),(9645,268,'ru','AP ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ GL ÑÑ‡ÐµÑ‚Ð°',0),(9646,268,'es','CP Cuentas de LM EstÃ¡ndar',0),(9647,268,'de','AP Standard GL Konten',0),(9648,268,'en','AP Standard GL Accounts',0),(9649,269,'is','',0),(9650,269,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(9651,269,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(9652,269,'tr','BorÃ§ hesaplarÄ±',0),(9653,269,'pl','Rozrachunki z dostawcami',0),(9654,269,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(9655,269,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(9656,269,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(9657,269,'vi','TÃ i Khoáº£n Pháº£i Tráº£',0),(9658,269,'af','Uitgawes (Rekeninge Betaalbaar)',0),(9659,269,'ro','Conturile de plÄƒtit',0),(9660,269,'et','Kreditoorne vÃµlgnevus',0),(9661,269,'si','PlaÄujejo raÄune',0),(9662,269,'ba','Hutang Dagang',0),(9663,269,'nl','Crediteuren',0),(9664,269,'fi','Ostovelat',0),(9665,269,'no','LeverandÃ¸rer',0),(9666,269,'da','Kreditor',0),(9667,269,'ko','ê³„ì • ì§€ê¸‰',0),(9668,269,'he','×—×©×‘×•× ×•×ª ×–×›××™×',0),(9669,269,'el','Î Î»Î·ÏÏ‰Ï„Î­Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(9670,269,'zh','åº”ä»˜å¸æ¬¾\r\n',0),(9671,269,'sv','LeverantÃ¶rsreskontra',0),(9672,269,'it','ContabilitÃ  fornitori',0),(9673,269,'tl','',0),(9674,269,'th','&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(9675,269,'hi','à¤²à¥‡à¤–à¤¾ à¤¦à¥‡à¤¯',0),(9676,269,'ms','Akaun belum bayar',0),(9677,269,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯Ø§Ø¦Ù†Ø©',0),(9678,269,'fr','Comptes crÃ©diteurs',0),(9679,269,'jp','è²·æŽ›é‡‘',0),(9680,269,'pt','Contas a pagar',0),(9681,269,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ',0),(9682,269,'es','Cuentas por Pagar',0),(9683,269,'de','Kreditoren-',0),(9684,269,'en','Accounts Payable',0),(9685,270,'is','',0),(9686,270,'dr','(ØªØ§ÙŠÙŠØ¯) Ø´Ø±ÙƒØª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(9687,270,'pr','Ù†ØµØ¨ Ø¢Ù¾Ø§Ú†ÙŠ(ØªØ§ÙŠÙŠØ¯) Ø´Ø±ÙƒØª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(9688,270,'tr','AP firma ekleme baÅŸarÄ±sÄ±z',0),(9689,270,'pl','Firma AP Wstaw nie powiodÅ‚o siÄ™',0),(9690,270,'bg','AP ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(9691,270,'ur','AP Ú©Ù…Ù¾Ù†ÛŒ Ø¯Ø§Ø®Ù„ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§',0),(9692,270,'sr','ÐÐŸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(9693,270,'vi','ChÃ¨n AP CÃ´ng Ty tháº¥t báº¡i',0),(9694,270,'af','Invoeging van RB Onderneming het gefaal',0),(9695,270,'ro','Inserare compania AP nu a reuÈ™it',0),(9696,270,'et','AP firma lisamine nurjus',0),(9697,270,'si','Podjetje AP vstavljanje ni uspela',0),(9698,270,'ba','Sisipkan AP perusahaan gagal',0),(9699,270,'nl','AP bedrijf invoegen mislukt',0),(9700,270,'fi','AP yritys lisÃ¤Ã¤ epÃ¤onnistui',0),(9701,270,'no','AP selskapet sett inn mislyktes',0),(9702,270,'da','AP firma IndsÃ¦t mislykkedes',0),(9703,270,'ko','AP íšŒì‚¬ ì‚½ìž… ì‹¤íŒ¨',0),(9704,270,'he','×—×‘×¨×ª AP ×”×•×¡×¤×” × ×›×©×œ',0),(9705,270,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏ„Î®ÏƒÏ„Îµ AP ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(9706,270,'zh','åº”ä»˜è´¦æ¬¾å…¬å¸æ’å…¥å¤±è´¥\r\n',0),(9707,270,'sv','AP fÃ¶retaget infoga misslyckades',0),(9708,270,'it','Inserimento azienda AP non riuscito',0),(9709,270,'tl','',0),(9710,270,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(9711,270,'hi','à¤à¤ªà¥€ à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(9712,270,'ms','Masukkan AP Syarikat yang gagal',0),(9713,270,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø´Ø±ÙƒØ© AP ÙØ´Ù„',0),(9714,270,'fr','Ã‰chouÃ© de l\'insertion entreprise AP',0),(9715,270,'jp','APä¼šç¤¾ã?®æŒ¿å…¥ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(9716,270,'pt','Inserir empresa AP falhado',0),(9717,270,'ru','Ð’ÑÑ‚Ð°Ð²ÐºÐ° AP ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(9718,270,'es','CP inseciÃ³n de Empresa fallÃ³',0),(9719,270,'de','AP Unternehmen einfÃ¼gen ist fehlgeschlagen',0),(9720,270,'en','AP Company insert failed',0),(9721,271,'is','',0),(9722,271,'dr','(ØªØ§ÙŠÙŠØ¯) Ø´Ø±ÙƒØª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(9723,271,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¢Ù¾Ø§Ú†ÙŠ(ØªØ§ÙŠÙŠØ¯) Ø´Ø±ÙƒØª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(9724,271,'tr','AP ÅŸirket gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu',0),(9725,271,'pl','Firma AP aktualizacji nie powiodÅ‚o siÄ™',0),(9726,271,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° AP ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(9727,271,'ur','AP Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(9728,271,'sr','ÐÐŸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(9729,271,'vi','Cáº­p nháº­t CTy Trong TK Pháº£i Tráº£ tháº¥t báº¡i',0),(9730,271,'af','RB Onderneming Opdatering het gefaal',0),(9731,271,'ro','AP compania actualizarea nu a reuÈ™it',0),(9732,271,'et','AP uuendamine nurjus',0),(9733,271,'si','Podjetje AP ni mogoÄe posodobiti',0),(9734,271,'ba','Gagal update AP perusahaan',0),(9735,271,'nl','AP bedrijf update is mislukt',0),(9736,271,'fi','AP Company pÃ¤ivitys epÃ¤onnistui',0),(9737,271,'no','AP selskapet oppdatering mislyktes',0),(9738,271,'da','AP firma opdatering mislykkedes',0),(9739,271,'ko','AP íšŒì‚¬ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(9740,271,'he','×¢×“×›×•×Ÿ ×—×‘×¨×ª AP × ×›×©×œ',0),(9741,271,'el','AP ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(9742,271,'zh','åº”ä»˜è´¦æ¬¾å…¬å¸æ›´æ–°å¤±è´¥\r\n',0),(9743,271,'sv','AP fÃ¶retaget uppdateringen misslyckades',0),(9744,271,'it','Aggiornamento societÃ  AP non riuscito',0),(9745,271,'tl','',0),(9746,271,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(9747,271,'hi','à¤à¤ªà¥€ à¤•à¤‚à¤ªà¤¨à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²',0),(9748,271,'ms','Kemaskini AP Syarikat yang gagal',0),(9749,271,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø´Ø±ÙƒØ© AP',0),(9750,271,'fr','AP mise Ã  jour a Ã©chouÃ©',0),(9751,271,'jp','APä¼šç¤¾ã?®æ›´æ–°ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(9752,271,'pt','Falhado na atualizaÃ§Ã£o AP empresa',0),(9753,271,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ AP',0),(9754,271,'es','CP actualizaciÃ³n de Empresa fallÃ³',0),(9755,271,'de','AP-Firma-Update fehlgeschlagen',0),(9756,271,'en','AP Company update failed',0),(9757,272,'is','',0),(9758,272,'dr','(Ø¯Ø±Ø®ÙˆØ§Ø³Øª )ØªØ®ÙÙŠÙ',0),(9759,272,'pr','Ø§Ø¹Ù…Ø§Ù„ (Ø¯Ø±Ø®ÙˆØ§Ø³Øª )ØªØ®ÙÙŠÙ',0),(9760,272,'tr','Ä°ndirim uygulanÄ±r',0),(9761,272,'pl','Stosuje zniÅ¼ki',0),(9762,272,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ ÑÐµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°Ñ‚',0),(9763,272,'ur','Ø±Ø¹Ø§ÛŒØª Ú©Ø§ Ø§Ø·Ù„Ø§Ù‚',0),(9764,272,'sr','ÐŸÑ€Ð¸Ð¼ÐµÑšÐ¸Ð²Ð°ÑšÐµ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð° Ð½Ð°',0),(9765,272,'vi','á»¨ng Dá»¥ng Giáº£m GiÃ¡',0),(9766,272,'af','Kortings Toepas',0),(9767,272,'ro','Se aplicÄƒ reduceri',0),(9768,272,'et','Hinda alla',0),(9769,272,'si','Veljajo popusti',0),(9770,272,'ba','Terapkan DISKON',0),(9771,272,'nl','Toepassing van kortingen',0),(9772,272,'fi','KÃ¤ytÃ¤ alennukset',0),(9773,272,'no','Bruke rabatter',0),(9774,272,'da','Anvende rabatter',0),(9775,272,'ko','í• ì¸ ì ìš©',0),(9776,272,'he','×”×—×œ×ª ×”× ×—×•×ª',0),(9777,272,'el','Î™ÏƒÏ‡ÏÎ¿Ï…Î½ ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚',0),(9778,272,'zh','åº”ç”¨æŠ˜æ‰£\r\n',0),(9779,272,'sv','TillÃ¤mpa rabatter',0),(9780,272,'it','Si applicano sconti',0),(9781,272,'tl','',0),(9782,272,'th','&#3651;&#3594;&#3657;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(9783,272,'hi','à¤›à¥‚à¤Ÿ à¤²à¤¾à¤—à¥‚',0),(9784,272,'ms','Memohon diskaun',0),(9785,272,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„ØªØ®ÙÙŠØ¶Ø§Øª ØŸ',0),(9786,272,'fr','Appliquer des rabais',0),(9787,272,'jp','ãƒ‡ã‚£ã‚¹ã‚«ã‚¦ãƒ³ãƒˆã‚’é?©ç”¨',0),(9788,272,'pt','Aplicam-se descontos',0),(9789,272,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½ÑÑ‚ÑŒ ÑÐºÐ¸Ð´ÐºÐ¸',0),(9790,272,'es','Aplicar descuentos',0),(9791,272,'de','ERMÃ„SSIGUNGEN gelten',0),(9792,272,'en','Apply Discounts',0),(9793,273,'is','',0),(9794,273,'dr','(Ø¯Ø±Ø®ÙˆØ§Ø³Øª)Ø¨Ù‡Ø±Ù‡',0),(9795,273,'pr','Ø§Ø¹Ù…Ø§Ù„(Ø¯Ø±Ø®ÙˆØ§Ø³Øª)Ø¨Ù‡Ø±Ù‡',0),(9796,273,'tr','Faiz uygulamak',0),(9797,273,'pl','Stosuje siÄ™ stopy',0),(9798,273,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶Ð¸ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(9799,273,'ur','Ø³ÙˆØ¯ Ú©Ø§ Ø§Ø·Ù„Ø§Ù‚',0),(9800,273,'sr','ÐŸÑ€Ð¸Ð¼ÐµÐ½Ð° ÐºÐ°Ð¼Ð°Ñ‚Ðµ',0),(9801,273,'vi','LÃ£i Suáº¥t Ãp Dá»¥ng',0),(9802,273,'af','Geld rente',0),(9803,273,'ro','Se aplicÄƒ dobÃ¢nzi',0),(9804,273,'et','Liida viivis',0),(9805,273,'si','Uporabljati obrestne',0),(9806,273,'ba','Menerapkan bunga',0),(9807,273,'nl','Toepassing van belang',0),(9808,273,'fi','Sovellettava korko',0),(9809,273,'no','Gjelde interesse',0),(9810,273,'da','Anvende interesse',0),(9811,273,'ko','ì´ìž ì ìš©',0),(9812,273,'he','×œ×™×™×©× ×”××™× ×˜×¨×¡',0),(9813,273,'el','Î•Ï†Î±ÏÎ¼ÏŒÏƒÏ„Îµ Ï„Î¿ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½',0),(9814,273,'zh','ç”³è¯·åˆ©æ¯\r\n',0),(9815,273,'sv','TillÃ¤mpa intresse',0),(9816,273,'it','Applicare interessi',0),(9817,273,'tl','',0),(9818,273,'th','&#3651;&#3594;&#3657;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;',0),(9819,273,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(9820,273,'ms','Dikenakan faedah',0),(9821,273,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(9822,273,'fr','Appliquer l\'intÃ©rÃªt',0),(9823,273,'jp','åˆ©å­?ã‚’é?©ç”¨ã?™ã‚‹',0),(9824,273,'pt','Aplicar juros',0),(9825,273,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(9826,273,'es','Aplicar InterÃ©s',0),(9827,273,'de','Anwenden von Interesse',0),(9828,273,'en','Apply Interest',0),(9829,274,'is','',0),(9830,274,'dr','(Ø§Ø¹Ù…Ø§Ù„ ) Ù¾Ø±Ø¯Ø§Ø®Øª',0),(9831,274,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª (Ø§Ø¹Ù…Ø§Ù„ ) Ù¾Ø±Ø¯Ø§Ø®Øª',0),(9832,274,'tr','Ã–deme uygulamak',0),(9833,274,'pl','Zastosowanie pÅ‚atnoÅ›ci',0),(9834,274,'bg','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(9835,274,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø§ Ø§Ø·Ù„Ø§Ù‚',0),(9836,274,'sr','ÐŸÑ€Ð¸Ð¼ÐµÐ½Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(9837,274,'vi','á»¨ng Dá»¥ng thanh toÃ¡n',0),(9838,274,'af','Betaling van toepassing',0),(9839,274,'ro','Aplica plata',0),(9840,274,'et','Kohaldatakse makse',0),(9841,274,'si','Uporablja plaÄilo',0),(9842,274,'ba','Menerapkan pembayaran',0),(9843,274,'nl','Betaling vereffenen',0),(9844,274,'fi','Hakea maksun',0),(9845,274,'no','Bruke betaling',0),(9846,274,'da','Anvend betaling',0),(9847,274,'ko','ê²°ì œ ì ìš©',0),(9848,274,'he','×œ×”×—×™×œ ××ª ×”×ª×©×œ×•×',0),(9849,274,'el','Î£Ï…ÏƒÏ‡ÎµÏ„Î¯ÏƒÎµÏ„Îµ Ï€Î»Î·ÏÏ‰Î¼Î®',0),(9850,274,'zh','ç”³è¯·æ”¯ä»˜\r\n',0),(9851,274,'sv','Koppla betalning',0),(9852,274,'it','Applicare il pagamento',0),(9853,274,'tl','',0),(9854,274,'th','&#3651;&#3594;&#3657;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(9855,274,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(9856,274,'ms','Memohon bayaran',0),(9857,274,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø¯ÙØ¹',0),(9858,274,'fr','Appliquer le paiement',0),(9859,274,'jp','æ”¯æ‰•ã?„ã‚’é?©ç”¨ã?™ã‚‹',0),(9860,274,'pt','Aplicar o pagamento',0),(9861,274,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(9862,274,'es','Aplicar Pago',0),(9863,274,'de','Zahlung gelten',0),(9864,274,'en','Apply payment',0),(9865,275,'is','',0),(9866,275,'dr','Ø¢ÙˆØ±ÙŠÙ„',0),(9867,275,'pr','Ø¢ÙˆØ±ÙŠÙ„',0),(9868,275,'tr','Nisan',0),(9869,275,'pl','Kwietnia',0),(9870,275,'bg','ÐÐ¿Ñ€Ð¸Ð»',0),(9871,275,'ur','Ø§Ù¾Ø±ÛŒÙ„',0),(9872,275,'sr','ÐÐ¿Ñ€Ð¸Ð»Ð°',0),(9873,275,'vi','ThÃ¡ng TÆ°',0),(9874,275,'af','April',0),(9875,275,'ro','Aprilie',0),(9876,275,'et','Aprill',0),(9877,275,'si','Aprila',0),(9878,275,'ba','April',0),(9879,275,'nl','April',0),(9880,275,'fi','Huhtikuuta',0),(9881,275,'no','April',0),(9882,275,'da','April',0),(9883,275,'ko','4 ì›”',0),(9884,275,'he','××¤×¨×™×œ',0),(9885,275,'el','Î‘Ï€ÏÎ¹Î»Î¯Î¿Ï…',0),(9886,275,'zh','å››æœˆ\r\n',0),(9887,275,'sv','April',0),(9888,275,'it','Aprile',0),(9889,275,'tl','',0),(9890,275,'th','&#3648;&#3617;&#3625;&#3634;&#3618;&#3609;',0),(9891,275,'hi','à¤…à¤ªà¥à¤°à¥ˆà¤²',0),(9892,275,'ms','April',0),(9893,275,'ar','Ø£Ø¨Ø±ÙŠÙ„',0),(9894,275,'fr','Avril',0),(9895,275,'jp','ï¼”æœˆ',0),(9896,275,'pt','Abril',0),(9897,275,'ru','ÐÐ¿Ñ€ÐµÐ»ÑŒ',0),(9898,275,'es','Abril',0),(9899,275,'de','April',0),(9900,275,'en','April',0),(9901,276,'is','',0),(9902,276,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø³ÙˆØ¯ ØµÙ†Ø¹ØªÙŠ',0),(9903,276,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø³ÙˆØ¯ ØµÙ†Ø¹ØªÙŠ',0),(9904,276,'tr','AR faiz hesaplama',0),(9905,276,'pl','AR obliczyÄ‡ odsetki',0),(9906,276,'bg','AR Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ñ‚ Ð»Ð¸Ñ…Ð²Ð¸',0),(9907,276,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø³ÙˆØ¯ Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(9908,276,'sr','ÐÐ  Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(9909,276,'vi','TÃ­nh LÃ£i Suáº¥t Cá»§a AR ',0),(9910,276,'af','RO Rente Bereken',0),(9911,276,'ro','AR calcula dobÃ¢nzi',0),(9912,276,'et','AR viivist arvutada',0),(9913,276,'si','AR obraÄuna obresti',0),(9914,276,'ba','AR menghitung bunga',0),(9915,276,'nl','AR rente berekenen',0),(9916,276,'fi','AR korko lasketaan',0),(9917,276,'no','AR beregne rente',0),(9918,276,'da','AR renteberegning',0),(9919,276,'ko','ì•„ì¹¸ì†ŒëŠ” ì´ìžë¥¼ ê³„ì‚°',0),(9920,276,'he','AR ×œ×—×©×‘ ×¨×™×‘×™×ª',0),(9921,276,'el','AR Ï…Ï€Î¿Î»Î¿Î³Î¯ÏƒÎµÎ¹ Ï„Î¿Î½ Ï„ÏŒÎºÎ¿ ÎºÎ±Î¹',0),(9922,276,'zh','åº”æ”¶è´¦æ¬¾è®¡ç®—åˆ©æ¯\r\n',0),(9923,276,'sv','AR berÃ¤kna rÃ¤nta',0),(9924,276,'it','AR calcolare gli interessi',0),(9925,276,'tl','',0),(9926,276,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(9927,276,'hi','à¤. à¤†à¤°. à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤¬à¥à¤¯à¤¾à¤œ',0),(9928,276,'ms','AR mengira faedah',0),(9929,276,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(9930,276,'fr','AR calculer les intÃ©rÃªts',0),(9931,276,'jp','ARåˆ©å­?è¨ˆç®—',0),(9932,276,'pt','AR calcular juros',0),(9933,276,'ru','Ð Ð°ÑÑ‡ÐµÑ‚ ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(9934,276,'es','CC Calcular InterÃ©ses',0),(9935,276,'de','AR berechnen Zinsen',0),(9936,276,'en','AR Calculate Interest',0),(9937,277,'is','',0),(9938,277,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙ†Ø¹Øª Ø´Ø±ÙƒØª Ù…ÙˆÙÙ‚ Ù†Ø¨ÙˆØ¯',0),(9939,277,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙ†Ø¹Øª Ø´Ø±ÙƒØª Ù…ÙˆÙÙ‚ Ù†Ø¨ÙˆØ¯',0),(9940,277,'tr','AR firma ekleme baÅŸarÄ±sÄ±z',0),(9941,277,'pl','AR firmy Insert nie powiodÅ‚o siÄ™',0),(9942,277,'bg','AR ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(9943,277,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ú©Ù…Ù¾Ù†ÛŒ Ø¯Ø§Ø®Ù„ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§',0),(9944,277,'sr','ÐÐ  ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð˜Ð½ÑÐµÑ€Ñ‚ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(9945,277,'vi','ChÃ¨n CÃ´ng Ty AR Tháº¥t Báº¡i',0),(9946,277,'af','AR maatskappy insetsel het misluk',0),(9947,277,'ro','Inserare AR companie nu a reuÅŸit',0),(9948,277,'et','AR firma lisamine nurjus',0),(9949,277,'si','Podjetje AR vstavljanje ni uspela',0),(9950,277,'ba','Insert AR perusahaan gagal',0),(9951,277,'nl','AR bedrijf invoegen mislukt',0),(9952,277,'fi','AR yritys lisÃ¤Ã¤ epÃ¤onnistui',0),(9953,277,'no','AR selskapet sett inn mislyktes',0),(9954,277,'da','AR virksomheden IndsÃ¦t mislykkedes',0),(9955,277,'ko','AR íšŒì‚¬ ì‚½ìž… ì‹¤íŒ¨',0),(9956,277,'he','×—×‘×¨×ª AR ×”×•×¡×¤×” × ×›×©×œ',0),(9957,277,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏ„Î®ÏƒÏ„Îµ AR ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(9958,277,'zh','åº”æ”¶è´¦æ¬¾å…¬å¸æ’å…¥å¤±è´¥\r\n',0),(9959,277,'sv','AR fÃ¶retaget infoga misslyckades',0),(9960,277,'it','Azienda AR Insert non riuscita',0),(9961,277,'tl','',0),(9962,277,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(9963,277,'hi','à¤. à¤†à¤°. à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(9964,277,'ms','Masukkan AR Syarikat yang gagal',0),(9965,277,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø´Ø±ÙƒØ© AR ÙØ´Ù„',0),(9966,277,'fr','Ã‰chouÃ© de l\'insertion entreprise AR',0),(9967,277,'jp','ARä¼šç¤¾ã?®æŒ¿å…¥ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(9968,277,'pt','InserÃ§Ã£o de AR a empresa falhada',0),(9969,277,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ AR Ð²ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(9970,277,'es','CC InserciÃ³n de Empresa FallÃ³',0),(9971,277,'de','AR-Firma einfÃ¼gen ist fehlgeschlagen',0),(9972,277,'en','AR Company Insert Failed',0),(9973,278,'is','',0),(9974,278,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ØµÙ†Ø¹Øª Ø´Ø±ÙƒØª',0),(9975,278,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ØµÙ†Ø¹Øª Ø´Ø±ÙƒØª',0),(9976,278,'tr','AR ÅŸirket seÃ§enekleri',0),(9977,278,'pl','Firma AR opcje',0),(9978,278,'bg','AR ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(9979,278,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(9980,278,'sr','ÐÐ  ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(9981,278,'vi','Lá»±a Chá»n CÃ´ng Ty AR ',0),(9982,278,'af','RO Onderneming Opsies',0),(9983,278,'ro','Compania AR opÅ£iuni',0),(9984,278,'et','AR firma Valikud',0),(9985,278,'si','Podjetje AR moÅ¾nosti',0),(9986,278,'ba','Pilihan AR perusahaan',0),(9987,278,'nl','AR bedrijf opties',0),(9988,278,'fi','AR yhtiÃ¶lle vaihtoehtoja',0),(9989,278,'no','AR selskapet alternativer',0),(9990,278,'da','AR virksomheden indstillinger',0),(9991,278,'ko','AR íšŒì‚¬ ì˜µì…˜',0),(9992,278,'he','××¤×©×¨×•×™×•×ª AR ×”×—×‘×¨×”',0),(9993,278,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ AR ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(9994,278,'zh','é“å…¬å¸é€‰é¡¹\r\n',0),(9995,278,'sv','AR fÃ¶retag alternativ',0),(9996,278,'it','Azienda AR opzioni',0),(9997,278,'tl','',0),(9998,278,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(9999,278,'hi','à¤. à¤†à¤°. à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(10000,278,'ms','Pilihan Syarikat AR',0),(10001,278,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø¹ Ø§Ù„Ø´Ø±ÙƒØ©',0),(10002,278,'fr','Options de l\'entreprise AR',0),(10003,278,'jp','ARä¼šç¤¾ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(10004,278,'pt','Empresa de AR opÃ§Ãµes',0),(10005,278,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ AR Ð¾Ð¿Ñ†Ð¸Ð¸',0),(10006,278,'es','CC Empresa Opciones',0),(10007,278,'de','AR-Firma-Optionen',0),(10008,278,'en','AR Company Options',0),(10009,279,'is','',0),(10010,279,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ØµÙ†Ø¹Øª Ø´Ø±ÙƒØª Ù…ÙˆÙÙ‚ Ù†Ø¨ÙˆØ¯',0),(10011,279,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ØµÙ†Ø¹Øª Ø´Ø±ÙƒØª Ù…ÙˆÙÙ‚ Ù†Ø¨ÙˆØ¯',0),(10012,279,'tr','AR ÅŸirket gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu',0),(10013,279,'pl','Firma AR aktualizacja nie powiodÅ‚a siÄ™',0),(10014,279,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° AR ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(10015,279,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(10016,279,'sr','ÐÐ  ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(10017,279,'vi','Cáº­p Nháº­t Cty Trong TK Pháº£i Thu Tháº¥t Báº¡i',0),(10018,279,'af','RO Onderneming Opdatering het Gefaal',0),(10019,279,'ro','Compania AR Update nu a reuÈ™it',0),(10020,279,'et','AR uuendamine nurjus',0),(10021,279,'si','Podjetje AR ni mogoÄe posodobiti',0),(10022,279,'ba','Gagal Update AR perusahaan',0),(10023,279,'nl','AR bedrijf Update is mislukt',0),(10024,279,'fi','AR Company pÃ¤ivitys epÃ¤onnistui',0),(10025,279,'no','AR selskapet oppdatering mislyktes',0),(10026,279,'da','AR virksomheden opdatering mislykkedes',0),(10027,279,'ko','AR íšŒì‚¬ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(10028,279,'he','×¢×“×›×•×Ÿ ×—×‘×¨×ª AR × ×›×©×œ',0),(10029,279,'el','AR ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(10030,279,'zh','åº”æ”¶è´¦æ¬¾å…¬å¸æ›´æ–°å¤±è´¥\r\n',0),(10031,279,'sv','AR fÃ¶retaget uppdateringen misslyckades',0),(10032,279,'it','Azienda AR aggiornamento non riuscito',0),(10033,279,'tl','',0),(10034,279,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(10035,279,'hi','à¤. à¤†à¤°. à¤•à¤‚à¤ªà¤¨à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²',0),(10036,279,'ms','Update AR Syarikat yang gagal',0),(10037,279,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø¹ Ø§Ù„Ø´Ø±ÙƒØ©',0),(10038,279,'fr','AR compagnie mise Ã  jour a Ã©chouÃ©',0),(10039,279,'jp','ARä¼šç¤¾ã?®æ›´æ–°ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(10040,279,'pt','Empresa de AR atualizaÃ§Ã£o falhada',0),(10041,279,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ ÐÑ€',0),(10042,279,'es','CC ActualizaciÃ³n de Empresa Fall\'o',0),(10043,279,'de','AR-Firma-Update fehlgeschlagen',0),(10044,279,'en','AR Company Update Failed',0),(10045,280,'is','',0),(10046,280,'dr','ÙØ§ÙƒØªÙˆØ± ØµÙ†Ø¹ØªÙŠ',0),(10047,280,'pr','ÙØ§ÙƒØªÙˆØ± ØµÙ†Ø¹ØªÙŠ',0),(10048,280,'tr','AR fatura',0),(10049,280,'pl','AR faktury',0),(10050,280,'bg','AR Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(10051,280,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(10052,280,'sr','ÐÐ  Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(10053,280,'vi','HÃ³a ÄÆ¡n AR',0),(10054,280,'af','RO Faktuur',0),(10055,280,'ro','FacturÄƒ AR',0),(10056,280,'et','AR arve',0),(10057,280,'si','AR raÄuna',0),(10058,280,'ba','AR faktur',0),(10059,280,'nl','AR factuur',0),(10060,280,'fi','AR laskun',0),(10061,280,'no','AR faktura',0),(10062,280,'da','AR faktura',0),(10063,280,'ko','AR ì†¡ìž¥',0),(10064,280,'he','AR ×—×©×‘×•× ×™×ª',0),(10065,280,'el','AR Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(10066,280,'zh','é“å‘ç¥¨\r\n',0),(10067,280,'sv','AR faktura',0),(10068,280,'it','Fattura AR',0),(10069,280,'tl','',0),(10070,280,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(10071,280,'hi','à¤. à¤†à¤°. à¤šà¤¾à¤²à¤¾à¤¨',0),(10072,280,'ms','Invois AR',0),(10073,280,'ar','Ø¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(10074,280,'fr','AR facture',0),(10075,280,'jp','å£²æŽ›é‡‘è«‹æ±‚æ›¸',0),(10076,280,'pt','Factura de AR',0),(10077,280,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° AR',0),(10078,280,'es','CC Factura',0),(10079,280,'de','AR-Rechnung',0),(10080,280,'en','AR Invoice',0),(10081,281,'is','',0),(10082,281,'dr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙ†Ø¹ØªÙŠ',0),(10083,281,'pr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙ†Ø¹ØªÙŠ',0),(10084,281,'tr','AR fatura Ã¶deme',0),(10085,281,'pl','PÅ‚atnoÅ›ci faktury AR',0),(10086,281,'bg','AR Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(10087,281,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(10088,281,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ ÐÐ ',0),(10089,281,'vi','Thanh ToÃ¡n HÃ³a ÄÆ¡n AR',0),(10090,281,'af','RO Faktuur Betaling',0),(10091,281,'ro','Plata de facturi AR',0),(10092,281,'et','AR arve tasumine',0),(10093,281,'si','PlaÄilo raÄuna AR',0),(10094,281,'ba','Pembayaran tagihan AR',0),(10095,281,'nl','AR factuur betaling',0),(10096,281,'fi','AR laskun maksu',0),(10097,281,'no','AR fakturabetalingen',0),(10098,281,'da','AR fakturabetaling',0),(10099,281,'ko','AR ì†¡ìž¥ ì§€ë¶ˆ',0),(10100,281,'he','AR ×—×©×‘×•× ×™×ª ×ª×©×œ×•×',0),(10101,281,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… AR',0),(10102,281,'zh','é“å‘ç¥¨ä»˜æ¬¾\r\n',0),(10103,281,'sv','AR fakturabetalning',0),(10104,281,'it','Pagamento fattura AR',0),(10105,281,'tl','',0),(10106,281,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(10107,281,'hi','à¤. à¤†à¤°. à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(10108,281,'ms','Pembayaran invois AR',0),(10109,281,'ar','Ø¯ÙØ¹ ÙØ§ØªÙˆØ±Ø© AR',0),(10110,281,'fr','Paiement des factures AR',0),(10111,281,'jp','å£²æŽ›é‡‘è«‹æ±‚æ›¸æ”¯æ‰•',0),(10112,281,'pt','Pagamento de fatura de AR',0),(10113,281,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð° AR',0),(10114,281,'es','CC Pago de Factura',0),(10115,281,'de','AR Rechnung Zahlung',0),(10116,281,'en','AR Invoice Payment',0),(10117,282,'is','',0),(10118,282,'dr','Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÙŠØ®Ø¬Ù‡ ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙ†Ø¹Øª',0),(10119,282,'pr','Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÙŠØ®Ø¬Ù‡ ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙ†Ø¹Øª',0),(10120,282,'tr','AR fatura Ã¶deme GeÃ§miÅŸi raporu',0),(10121,282,'pl','Raport historia pÅ‚atnoÅ›ci faktury AR',0),(10122,282,'bg','AR Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(10123,282,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø±Ù¾ÙˆØ±Ù¹',0),(10124,282,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐÐ ',0),(10125,282,'vi','BÃ¡o CÃ¡o Lá»‹ch Sá»­ Thanh ToÃ¡n HÃ³a ÄÆ¡n AR',0),(10126,282,'af','RO Faktuur Betalingsgeskiedenis',0),(10127,282,'ro','Raportul de istorie AR factura de platÄƒ',0),(10128,282,'et','AR arve makse ajalugu aruanne',0),(10129,282,'si','AR raÄuna plaÄilo zgodovino poroÄilo',0),(10130,282,'ba','Laporan sejarah AR faktur pembayaran',0),(10131,282,'nl','AR factuurrapport betaling geschiedenis',0),(10132,282,'fi','AR laskun maksu historiaraportti',0),(10133,282,'no','AR fakturarapport betaling historie',0),(10134,282,'da','AR faktura betaling historie rapport',0),(10135,282,'ko','AR ì†¡ìž¥ ì§€ë¶ˆ ë‚´ì—­ ë¦¬í¬íŠ¸',0),(10136,282,'he','AR ×—×©×‘×•× ×™×ª ×”×ª×©×œ×•× ×‘×”×™×¡×˜×•×¨×™×”',0),(10137,282,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÎ¿Ï Ï€Î»Î·ÏÏ‰Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… AR',0),(10138,282,'zh','åº”æ”¶è´¦æ¬¾å‘ç¥¨ä»˜æ¬¾åŽ†å²æŠ¥å‘Š\r\n',0),(10139,282,'sv','AR faktura betalning historia rapport',0),(10140,282,'it','Report di storia pagamento fattura AR',0),(10141,282,'tl','',0),(10142,282,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3629;&#3',0),(10143,282,'hi','à¤. à¤†à¤°. à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(10144,282,'ms','Laporan sejarah pembayaran invois AR',0),(10145,282,'ar','ØªÙ‚Ø±ÙŠØ± ØªØ§Ø±ÙŠØ® Ø¯ÙØ¹ ÙØ§ØªÙˆØ±Ø© AR',0),(10146,282,'fr','Ã‰tat historique de paiement de facture AR',0),(10147,282,'jp','å£²æŽ›é‡‘è«‹æ±‚æ›¸æ”¯æ‰•å±¥æ­´ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(10148,282,'pt','RelatÃ³rio de histÃ³rico de pagamento de fatura de AR',0),(10149,282,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÑ‡ÐµÑ‚Ð° AR',0),(10150,282,'es','CC Informe Historico de Pagos de Facturas',0),(10151,282,'de','AR Rechnung Zahlung Verlaufsbericht',0),(10152,282,'en','AR Invoice Payment History Report',0),(10153,283,'is','',0),(10154,283,'dr','Ù…Ø¹ÙƒÙˆØ³ Ø³Ø§Ø²ÙŠ ÙØ§ÙƒØªÙˆØ± ØµÙ†Ø¹Øª',0),(10155,283,'pr','Ù…Ø¹ÙƒÙˆØ³ Ø³Ø§Ø²ÙŠ ÙØ§ÙƒØªÙˆØ± ØµÙ†Ø¹Øª',0),(10156,283,'tr','AR fatura tersine Ã§evirme',0),(10157,283,'pl','Wycofanie faktury AR',0),(10158,283,'bg','AR Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¾Ð±Ñ€ÑŠÑ‰Ð°Ð½Ðµ',0),(10159,283,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ù„Ù¹',0),(10160,283,'sr','ÐÐ  ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(10161,283,'vi','Äáº£o NgÆ°á»£c HÃ³a ÄÆ¡n AR',0),(10162,283,'af','AR faktuur ommekeer',0),(10163,283,'ro','Inversare de facturÄƒ AR',0),(10164,283,'et','AR arve tÃ¼histamine',0),(10165,283,'si','AR raÄuna preobrat',0),(10166,283,'ba','AR faktur pembalikan',0),(10167,283,'nl','AR factuur omkering',0),(10168,283,'fi','AR peruutus',0),(10169,283,'no','AR faktura reversering',0),(10170,283,'da','AR faktura tilbagefÃ¸rsel',0),(10171,283,'ko','AR ì†¡ìž¥ ë°˜ì „',0),(10172,283,'he','×”×™×¤×•×š ×—×©×‘×•× ×™×ª AR',0),(10173,283,'el','AR Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±Î½Ï„Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(10174,283,'zh','é“å‘ç¥¨å†²é”€\r\n',0),(10175,283,'sv','AR faktura Ã¥terfÃ¶ring',0),(10176,283,'it','AR fattura inversione',0),(10177,283,'tl','',0),(10178,283,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3618;&#3657;&#3629;&#3609;&#3627;&#3621;&#3633;&#3591;',0),(10179,283,'hi','à¤. à¤†à¤°. à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤‰à¤¤à¥à¤•à¥à¤°à¤®à¤£',0),(10180,283,'ms','Pembalikan invois AR',0),(10181,283,'ar','Ø¹ Ø¹ÙƒØ³ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(10182,283,'fr','Inversion de facture AR',0),(10183,283,'jp','å£²æŽ›é‡‘ç ´æ£„è«‹æ±‚æ›¸',0),(10184,283,'pt','ReversÃ£o de factura de AR',0),(10185,283,'ru','AR ÑÑ‡ÐµÑ‚ Ñ€Ð°Ð·Ð²Ð¾Ñ€Ð¾Ñ‚Ð°',0),(10186,283,'es','CC ReversiÃ³n de Factura',0),(10187,283,'de','AR Rechnung Umkehr',0),(10188,283,'en','AR Invoice Reversal',0),(10189,284,'is','',0),(10190,284,'dr','ÙØ§ÙƒØªÙˆØ± Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ØµÙ†Ø¹ØªÙŠ',0),(10191,284,'pr','ÙØ§ÙƒØªÙˆØ± Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ØµÙ†Ø¹ØªÙŠ',0),(10192,284,'tr','AR fatura satÄ±ÅŸ vergisi raporu',0),(10193,284,'pl','AR faktury podatku raportu',0),(10194,284,'bg','AR Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð´Ð°Ð½ÑŠÐº Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(10195,284,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø±Ù¾ÙˆØ±Ù¹',0),(10196,284,'sr','ÐÐ  Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(10197,284,'vi','BÃ¡o CÃ¡o HÃ³a ÄÆ¡n Thuáº¿ Kinh Doanh Pháº£i Thu',0),(10198,284,'af','AR faktuur verkoopsbelasting verslag',0),(10199,284,'ro','Raportul de impozitul pe vÃ¢nzÄƒri AR factura',0),(10200,284,'et','AR arve kÃ¤ibemaksu aruanne',0),(10201,284,'si','AR raÄuna prodajni davek poroÄilo',0),(10202,284,'ba','AR laporan faktur pajak penjualan',0),(10203,284,'nl','AR factuur Sales Tax verslag',0),(10204,284,'fi','AR laskun ALV-raportti',0),(10205,284,'no','AR faktura mva-rapport',0),(10206,284,'da','AR fakturarapport omsÃ¦tningsafgift',0),(10207,284,'ko','AR ì†¡ìž¥ íŒë§¤ ì„¸ê¸ˆ ë³´ê³ ì„œ',0),(10208,284,'he','×“×•×— ×ž×¢ ×ž ×—×©×‘×•× ×™×•×ª AR',0),(10209,284,'el','AR Î­ÎºÎ¸ÎµÏƒÎ· Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ \"Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿\"',0),(10210,284,'zh','åº”æ”¶è´¦æ¬¾å‘ç¥¨é”€å”®ç¨Žçš„æŠ¥å‘Š\r\n',0),(10211,284,'sv','AR faktura momsrapporten',0),(10212,284,'it','Report di AR fattura IVA',0),(10213,284,'tl','',0),(10214,284,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(10215,284,'hi','à¤. à¤†à¤°. à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤° à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(10216,284,'ms','AR invois cukai jualan Laporan',0),(10217,284,'ar','ØªÙ‚Ø±ÙŠØ± Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ÙØ§ØªÙˆØ±Ø© AR',0),(10218,284,'fr','Ã‰tat de taxe facture AR',0),(10219,284,'jp','å£²æŽ›é‡‘è«‹æ±‚æ›¸å£²ä¸Šç¨Žãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(10220,284,'pt','RelatÃ³rio de imposto sobre vendas de fatura de AR',0),(10221,284,'ru','AR ÑÑ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(10222,284,'es','CC Factura Informe de IVA',0),(10223,284,'de','AR Rechnung MehrwertsteuererklÃ¤rung',0),(10224,284,'en','AR Invoice Sales Tax Report',0),(10225,285,'is','',0),(10226,285,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ ØµÙ†Ø¹ØªÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„',0),(10227,285,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ ØµÙ†Ø¹ØªÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„',0),(10228,285,'tr','AR GL standart hesaplarÄ±',0),(10229,285,'pl','AR GL standardowych kont',0),(10230,285,'bg','AR ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ GL ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(10231,285,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(10232,285,'sr','ÐÐ  ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð“Ð› Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(10233,285,'vi','Pháº£i Thu TK Sá»• CÃ¡i Tá»•ng Há»£p Chuáº©n',0),(10234,285,'af','RO Standaard AG Rekeninge',0),(10235,285,'ro','Conturile de Standard GL AR',0),(10236,285,'et','AR Standard GL kontod',0),(10237,285,'si','AR Standard GL raÄunov',0),(10238,285,'ba','AR GL standar account',0),(10239,285,'nl','AR standaard GL Accounts',0),(10240,285,'fi','AR Standard GL tilit',0),(10241,285,'no','AR Standard GL kontoer',0),(10242,285,'da','AR Standard GL konti',0),(10243,285,'ko','AR í‘œì¤€ GL ê³„ì •',0),(10244,285,'he','AR GL ×¨×’×™×œ×™×. ×—×©×‘×•× ×•×ª',0),(10245,285,'el','AR Ï€ÏÏŒÏ„Ï…Ï€Î¿ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(10246,285,'zh','åº”æ”¶è´¦æ¬¾æ ‡å‡†æ€»å¸å¸æˆ·\r\n',0),(10247,285,'sv','AR Standard GL konton',0),(10248,285,'it','AR GL Standard conti',0),(10249,285,'tl','',0),(10250,285,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(10251,285,'hi','à¤. à¤†à¤°. à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‹à¤‚',0),(10252,285,'ms','Akaun Standard GL AR',0),(10253,285,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø¯ÙŠÙ†Ø© Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ù„Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(10254,285,'fr','GLG Standard AR',0),(10255,285,'jp','å£²æŽ›é‡‘æ¨™æº–ç·?å‹˜å®šå…ƒå¸³',0),(10256,285,'pt','Contas de AR padrÃ£o GL',0),(10257,285,'ru','AR GL ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(10258,285,'es','CC Cuentas de LM EstÃ¡ndar',0),(10259,285,'de','AR-Standard GL-Konten',0),(10260,285,'en','AR Standard GL Accounts',0),(10261,286,'is','',0),(10262,286,'dr','Ø¹Ø±Ø¨ÙŠ',0),(10263,286,'pr','Ø¹Ø±Ø¨ÙŠ',0),(10264,286,'tr','ArapÃ§a',0),(10265,286,'pl','Arabski',0),(10266,286,'bg','ÐÑ€Ð°Ð±ÑÐºÐ¸',0),(10267,286,'ur','Ø¹Ø±Ø¨ÛŒ',0),(10268,286,'sr','Ð°Ñ€Ð°Ð¿ÑÐºÐ¸',0),(10269,286,'vi','Tiáº¿ng áº¢ Ráº­p',0),(10270,286,'af','Arabies',0),(10271,286,'ro','ArabÄƒ',0),(10272,286,'et','Araabia',0),(10273,286,'si','arabÅ¡Äina',0),(10274,286,'ba','Arab',0),(10275,286,'nl','Arabisch',0),(10276,286,'fi','arabia',0),(10277,286,'no','Arabisk',0),(10278,286,'da','arabisk',0),(10279,286,'ko','ì•„ëžì–´',0),(10280,286,'he','×¢×¨×‘×™×ª',0),(10281,286,'el','Î‘ÏÎ±Î²Î¹ÎºÎ¬',0),(10282,286,'zh','é˜¿æ‹‰ä¼¯è¯­\r\n',0),(10283,286,'sv','Arabiska',0),(10284,286,'it','Arabo',0),(10285,286,'tl','',0),(10286,286,'th','&#3629;&#3634;&#3619;&#3610;&#3636;&#3585;',0),(10287,286,'hi','à¤…à¤°à¤¬à¥€',0),(10288,286,'ms','Arab',0),(10289,286,'ar','Ø§Ù„Ø¹Ø±Ø¨ÙŠØ©',0),(10290,286,'fr','Arabe',0),(10291,286,'jp','ã‚¢ãƒ©ãƒ“ã‚¢èªž',0),(10292,286,'pt','Ãrabe',0),(10293,286,'ru','Ð°Ñ€Ð°Ð±ÑÐºÐ¸Ð¹',0),(10294,286,'es','Ãrabe',0),(10295,286,'de','Arabisch',0),(10296,286,'en','Arabic',0),(10297,287,'is','',0),(10298,287,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(10299,287,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(10300,287,'tr','Bu oluÅŸturma emrinin silmek istediÄŸinizden emin misiniz?',0),(10301,287,'pl','Czy na pewno chcesz usunÄ…Ä‡ ten Build Order?',0),(10302,287,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ?',0),(10303,287,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ø³ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± ØªØ±ØªÛŒØ¨ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(10304,287,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð±Ñ€Ð¸ÑˆÐµÑ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÑƒ?',0),(10305,287,'vi','Muá»‘n XÃ“A ÄÆ¡n HÃ ng NÃ y?',0),(10306,287,'af','Is u seker u wil hierdie Geboude Bestelling SKRAP',0),(10307,287,'ro','Sigur È™tergeÈ›i aceastÄƒ comandÄƒ construi?',0),(10308,287,'et','Kas kindlasti kustutada seda ehitada?',0),(10309,287,'si','Ali ste prepriÄani, da Å¾elite izbrisati ta graditi nalog?',0),(10310,287,'ba','Apakah Anda yakin Anda ingin menghapus pesanan ini membangun?',0),(10311,287,'nl','Weet u zeker dat u wilt verwijderen van deze bestelling bouwen?',0),(10312,287,'fi','Oletko varma, ettÃ¤ haluat poistaa tÃ¤mÃ¤n rakentaa tilauksen?',0),(10313,287,'no','Er du sikker pÃ¥ at du vil slette denne bygge ordren?',0),(10314,287,'da','Er du sikker pÃ¥ du vil slette denne bygge rÃ¦kkefÃ¸lge?',0),(10315,287,'ko','ë‹¹ì‹ ì€ì´ êµ¬ì¶• ìˆœì„œë¥¼ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(10316,287,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ×¦×• ×–×” ×œ×‘× ×•×ª?',0),(10317,287,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î”Î™Î‘Î“Î¡Î†Î¨Î•Î¤Î• Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Î¿Î¹ÎºÎ¿Î´Î¿Î¼Î®ÏƒÎ¿Ï…Î¼Îµ;',0),(10318,287,'zh','æ‚¨ç¡®å®šè¦åˆ é™¤æ­¤æž„å»ºé¡ºåº\r\n',0),(10319,287,'sv','Ã„r du sÃ¤ker du vill ta bort denna bygga ordning?',0),(10320,287,'it','Sei sicuro di che voler eliminare questo ordine di costruire?',0),(10321,287,'tl','',0),(10322,287,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(10323,287,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(10324,287,'ms','Adakah anda pasti anda mahu menghapuskan perintah membina ini?',0),(10325,287,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø­Ø°Ù Ù‡Ø°Ø§ \"Ø§Ù„Ù†Ø¸Ø§Ù… Ø¨Ù†Ø§Ø¡\"ØŸ',0),(10326,287,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer cet ordre de la gÃ©nÃ©ration ?',0),(10327,287,'jp','æœ¬å½“ã?«ã?“ã?®çµ„ç«‹æ³¨æ–‡ã‚’æ¶ˆåŽ»ã?—ã?¦ã?„ã?„ã?§ã?™ã?‹ï¼Ÿ',0),(10328,287,'pt','Tem certeza que deseja excluir esta ordem de construir?',0),(10329,287,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ?',0),(10330,287,'es','Â¿Esta seguro que quiere eliminar este pedido de construcciÃ³n?',0),(10331,287,'de','Bist du sicher, dass Sie diese Buildreihenfolge lÃ¶schen mÃ¶chten?',0),(10332,287,'en','Are you sure you want to DELETE this Build Order?',0),(10333,288,'is','',0),(10334,288,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø±Ø§ Ù†Ù‡Ø§ÙŠÙŠ ÙƒÙ†ÙŠØ¯ØŸ',0),(10335,288,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø±Ø§ Ù†Ù‡Ø§ÙŠÙŠ ÙƒÙ†ÙŠØ¯ØŸ',0),(10336,288,'tr','Bu inÅŸa sipariÅŸ sonuÃ§landÄ±rmak istiyor musun?',0),(10337,288,'pl','Czy na pewno chcesz zakoÅ„czyÄ‡ ten Build Order?',0),(10338,288,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ñ„Ð¸Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ?',0),(10339,288,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ø³ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ø­ØªÙ…ÛŒ Ø´Ú©Ù„ Ø¯ÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(10340,288,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ñ„Ð¸Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚Ð¸ Ð½Ð°Ñ€ÑƒÑŸÐ±Ð° Ð³Ñ€Ð°Ð´Ð¸?',0),(10341,288,'vi','Káº¿t thÃºc Ä‘Æ¡n hÃ ng nÃ y?',0),(10342,288,'af','Is u seker u wil hierdie Geboude Bestelling finaliseer?',0),(10343,288,'ro','SunteÅ£i sigur cÄƒ doriÅ£i pentru a finaliza aceastÄƒ ordine construi?',0),(10344,288,'et','Kas kindlasti vormistab jÃ¤rgekorras ehitada?',0),(10345,288,'si','Ali ste prepriÄani, da Å¾elite dokonÄati ta graditi nalog?',0),(10346,288,'ba','Apakah Anda yakin Anda ingin menyelesaikan pesanan ini membangun?',0),(10347,288,'nl','Weet u zeker dat u wilt finaliseren van deze bestelling bouwen?',0),(10348,288,'fi','Oletko varma, ettÃ¤ haluat viimeistellÃ¤ rakentaa jÃ¤rjestyksessÃ¤?',0),(10349,288,'no','Er du sikker pÃ¥ at du vil fullfÃ¸re denne bygge rekkefÃ¸lgen?',0),(10350,288,'da','Vil du afslutte denne bygge rÃ¦kkefÃ¸lge?',0),(10351,288,'ko','ë‹¹ì‹ ì€ì´ êµ¬ì¶• ìˆœì„œë¥¼ ì™„ë£Œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(10352,288,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×¡×™×™× ××ª ×¦×• ×–×” ×œ×‘× ×•×ª?',0),(10353,288,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÏƒÎµÎ¹ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Î¿Î¹ÎºÎ¿Î´Î¿Î¼Î®ÏƒÎ¿Ï…Î¼Îµ;',0),(10354,288,'zh','ä½ ç¡®å®šè¦å®Œæˆæ­¤æž„å»ºé¡ºåºï¼Ÿ\r\n',0),(10355,288,'sv','Ã„r du sÃ¤ker du vill slutfÃ¶ra denna bygga ordning?',0),(10356,288,'it','Sei sicuro di che voler finalizzare questo ordine di costruire?',0),(10357,288,'tl','',0),(10358,288,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3585;&#3634;&#3619;&#3607;&#3635;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3',0),(10359,288,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥à¤°à¤® à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¥‡à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(10360,288,'ms','Adakah anda pasti anda mahu untuk memuktamadkan perintah membina ini?',0),(10361,288,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ ÙˆØ¶Ø¹ Ø§Ù„ØµÙŠØºØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© Ù„Ù‡Ø°Ø§ \"Ø§Ù„Ù†Ø¸Ø§Ù… Ø¨Ù†Ø§Ø¡\"ØŸ',0),(10362,288,'fr','ÃŠtes-vous certain de que vouloir mettre au point de cet ordre de la gÃ©nÃ©ration ?',0),(10363,288,'jp','æœ¬å½“ã?«ã?“ã?®çµ„ç«‹æ³¨æ–‡ã‚’å®Œäº†ã?•ã?›ã?¦ã?„ã?„ã?§ã?™ã?‹ï¼Ÿ',0),(10364,288,'pt','Tem certeza que deseja finalizar esta ordem de construir?',0),(10365,288,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð·Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ?',0),(10366,288,'es','Â¿Esta seguro que quiere finalizar este Pedido de ConstrucciÃ³n?',0),(10367,288,'de','Bist du sicher, dass Sie diese Reihenfolge abschlieÃŸen mÃ¶chten?',0),(10368,288,'en','Are you sure you want to finalize this Build Order?',0),(10369,289,'is','',0),(10370,289,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ÙŠÙƒ Ø¨ÙˆØ¯Ø¬Ù‡ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ØŸ',0),(10371,289,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ÙŠÙƒ Ø¨ÙˆØ¯Ø¬Ù‡ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ØŸ',0),(10372,289,'tr','Yeni bir bÃ¼tÃ§e mali yÄ±l iÃ§in eklemek istediÄŸinizden emin misiniz',0),(10373,289,'pl','Czy jesteÅ› pewien, Å¼e chcesz dodaÄ‡ nowy budÅ¼et na rok obrachunkowy',0),(10374,289,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð¾Ð² Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(10375,289,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§ÛŒÚ© Ù†ÛŒØ§ Ø¨Ø¬Ù¹ Ø¨Ø±Ø§Ø¦Û’ Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº',0),(10376,289,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð±ÑƒÑŸÐµÑ‚ Ð·Ð° Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ñƒ Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(10377,289,'vi','ThÃªm ngÃ¢n sÃ¡ch má»›i cho nÄƒm tÃ i chÃ­nh?',0),(10378,289,'af','Is u seker u wil \'n nuwe begroting vir die fisiese jaar byvoeg',0),(10379,289,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ adÄƒugaÅ£i un nou buget pentru anul fiscal',0),(10380,289,'et','Kas kindlasti lisada uue eelarve finantsaasta',0),(10381,289,'si','Ali ste prepriÄani, da Å¾elite dodati nov predraÄun za poslovno leto',0),(10382,289,'ba','Apakah Anda yakin Anda ingin menambahkan baru anggaran untuk tahun fiskal',0),(10383,289,'nl','Weet u zeker dat u wilt toevoegen een nieuw budget voor fiscale jaar',0),(10384,289,'fi','Oletko varma, ettÃ¤ haluat lisÃ¤tÃ¤ uuden budjetin tilikauden',0),(10385,289,'no','Er du sikker pÃ¥ at du vil legge til et nytt budsjett for regnskapsÃ¥ret',0),(10386,289,'da','Er du sikker pÃ¥ du vil tilfÃ¸je et nyt budget for regnskabsÃ¥r',0),(10387,289,'ko','ë‹¹ì‹ ì€ ìƒˆë¡œìš´ ì˜ˆì‚° íšŒê³„ ì—°ë„ ëŒ€ í•œ ì¶”ê°€ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ',0),(10388,289,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×”×•×¡×™×£ ×ª×§×¦×™×‘ ×—×“×© ×¢×‘×•×¨ ×©× ×ª ×”×›×¡×¤×™×',0),(10389,289,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î­Î½Î± Î½Î­Î¿ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î³Î¹Î± Ï„Î¿ Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚',0),(10390,289,'zh','ä½ ç¡®å®šä½ è¦æ·»åŠ ä¸€ä¸ªæ–°çš„è´¢æ”¿å¹´åº¦çš„é¢„ç®—ï¼Ÿ\r\n',0),(10391,289,'sv','Ã„r du sÃ¤ker du vill lÃ¤gga till en ny budget fÃ¶r rÃ¤kenskapsÃ¥ret',0),(10392,289,'it','Sei sicuro che si desidera aggiungere un nuovo bilancio per l\'anno fiscale',0),(10393,289,'tl','',0),(10394,289,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3604;&#3657;&#3634;&#3609;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;&#3586;&#3629;&#3',0),(10395,289,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤à¤• à¤¨à¤¯à¤¾ à¤¬à¤œà¤Ÿ à¤•à¥‹ à¤µà¤¿à¤¤à¥à¤¤ à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(10396,289,'ms','Adakah anda pasti anda mahu menambah belanjawan baru bagi tahun fiskal',0),(10397,289,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¥Ø¶Ø§ÙØ© Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø© Ù„Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© ',0),(10398,289,'fr','ÃŠtes-vous sÃ»r de que vouloir ajouter un nouveau budget pour l\'exercice',0),(10399,289,'jp','ä¼šè¨ˆå¹´åº¦ã?®æ–°ã?—ã?„äºˆç®—ã‚’è¿½åŠ ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(10400,289,'pt','Tens a certeza de que vocÃª deseja adicionar um novo orÃ§amento para o ano fiscal',0),(10401,289,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð½Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´',0),(10402,289,'es','Â¿Esta seguro que quiere agregar un nuevo presupuesto para este ejercicio?',0),(10403,289,'de','Sind Sie sicher, dass Sie ein neues Budget fÃ¼r das GeschÃ¤ftsjahr hinzufÃ¼gen mÃ¶chten',0),(10404,289,'en','Are you sure you want to add a new budget for fiscal year',0),(10405,290,'is','',0),(10406,290,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ú†Ùƒ Ù‡Ø§ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ÙŠ Ø±Ø§   Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒÙ†ÙŠØ¯ØŸ',0),(10407,290,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ú†Ùƒ Ù‡Ø§ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ÙŠ Ø±Ø§   Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒÙ†ÙŠØ¯ØŸ',0),(10408,290,'tr','SeÃ§ili denetimleri iÅŸlemek istediÄŸinizden emin misiniz?',0),(10409,290,'pl','Czy na pewno chcesz przetworzyÄ‡ wybranego kontroli?',0),(10410,290,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸?',0),(10411,290,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ù…Ù†ØªØ®Ø¨ Ú†ÛŒÚ© Ù¾Ø± Ø¹Ù…Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(10412,290,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð¾Ð±Ñ€Ð°Ð´Ð¸Ñ‚Ð¸ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ?',0),(10413,290,'vi','Báº¡n cÃ³ cháº¯c muá»‘n xá»­ lÃ½ nhá»¯ng SÃ©c Ä‘Ã£ chá»n?',0),(10414,290,'af','Is u seker u wil die geselekteerde tjeks prosesseer?',0),(10415,290,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ proceseze controalele selectate?',0),(10416,290,'et','Kas kindlasti tÃ¶Ã¶delda valitud kontrolli?',0),(10417,290,'si','Ali ste prepriÄani, da Å¾elite obdelati izbrane Äeke?',0),(10418,290,'ba','Apakah Anda yakin Anda ingin proses pemeriksaan yang dipilih?',0),(10419,290,'nl','Weet u zeker dat u wilt verwerken van de geselecteerde controles?',0),(10420,290,'fi','Oletko varma, ettÃ¤ haluat kÃ¤sitellÃ¤ valitut tarkistukset?',0),(10421,290,'no','Er du sikker du vil behandle merkede kontrollene?',0),(10422,290,'da','Er du sikker pÃ¥, du vil behandle den valgte kontrol?',0),(10423,290,'ko','ë‹¹ì‹ ì€ ì„ íƒ ëœ ê²€ì‚¬ë¥¼ ì²˜ë¦¬ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(10424,290,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×¢×‘×“ ××ª ×”×¦\'×§×™× ×©× ×‘×—×¨×•?',0),(10425,290,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚;',0),(10426,290,'zh','ä½ ç¡®å®šè¦å¤„ç†é€‰å®šæ£€æŸ¥ï¼Ÿ\r\n',0),(10427,290,'sv','Ã„r du sÃ¤ker du vill bearbeta de markerade kontrollerna?',0),(10428,290,'it','Sei sicuro che si desidera elaborare i controlli selezionati?',0),(10429,290,'tl','',0),(10430,290,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3649;&#3621;&#3657;&#3623;&#3627;&#3619;&#3639;&#3629;&#3623;&#3656;&#3634;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3',0),(10431,290,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤šà¤¯à¤¨à¤¿à¤¤ à¤šà¥‡à¤• à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(10432,290,'ms','Adakah anda pasti anda mahu proses semakan yang terpilih?',0),(10433,290,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ø§Ø®ØªØ¨Ø§Ø±Ø§Øª Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©ØŸ',0),(10434,290,'fr','ÃŠtes-vous certain de que vouloir traiter les contrÃ´les sÃ©lectionnÃ©s ?',0),(10435,290,'jp','ã?“ã?®é?¸æŠžã?•ã‚Œã?Ÿå°?åˆ‡æ‰‹ã?§ã?™ã?™ã‚?ã?¦ã‚‚ã?„ã?„ã?§ã?™ã?‹ï¼Ÿ',0),(10436,290,'pt','Tens a certeza de que vocÃª deseja processar os controlos seleccionados?',0),(10437,290,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸?',0),(10438,290,'es','Â¿Esta seguro que quiere procesar los cheques seleccionados?',0),(10439,290,'de','Bist du sicher, dass Sie die ausgewÃ¤hlten PrÃ¼fungen bearbeiten wollen?',0),(10440,290,'en','Are you sure you want to process the selected checks?',0),(10441,291,'is','',0),(10442,291,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø¨ÙˆØ¯Ø¬Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ÙŠ Ø§Ø®ÙŠØ±  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(10443,291,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø¨ÙˆØ¯Ø¬Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ÙŠ Ø§Ø®ÙŠØ±  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(10444,291,'tr','SeÃ§ili bÃ¼tÃ§e silmek istediÄŸinizden emin misiniz',0),(10445,291,'pl','Czy na pewno chcesz usunÄ…Ä‡ aktualnie wybranego budÅ¼etu',0),(10446,291,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(10447,291,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø­Ø§Ù„ÛŒÛ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ø¨Ø¬Ù¹ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº',0),(10448,291,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð±Ñ€Ð¸ÑˆÐµÑ‚Ðµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸ Ð±ÑƒÑŸÐµÑ‚',0),(10449,291,'vi','XÃ³a NgÃ¢n SÃ¡ch Vá»«a Chá»n?',0),(10450,291,'af','Is u seker u wil die huidige geselekteerde begrogte skrap',0),(10451,291,'ro','Sigur È™tergeÈ›i bugetul selectat',0),(10452,291,'et','Oled kindel, et soovid kustutada praegu valitud eelarvet',0),(10453,291,'si','Ali ste prepriÄani, da Å¾elite izbrisati trenutno izbrano proraÄuna',0),(10454,291,'ba','Apakah Anda yakin Anda ingin menghapus anggaran sedang dipilih',0),(10455,291,'nl','Weet u zeker dat u wilt verwijderen van de geselecteerde begroting',0),(10456,291,'fi','Oletko varma, ettÃ¤ haluat poistaa valitun',0),(10457,291,'no','Er du sikker pÃ¥ at du vil slette det valgte budsjettet',0),(10458,291,'da','Er du sikker pÃ¥ du vil slette den aktuelt valgte budget',0),(10459,291,'ko','ë‹¹ì‹ ì€ í˜„ìž¬ ì„ íƒ ëœ ì˜ˆì‚° ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ',0),(10460,291,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ××ª ×”×ª×§×¦×™×‘ ×”× ×•×›×—×™ ×©× ×‘×—×¨',0),(10461,291,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿Î½ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ',0),(10462,291,'zh','ä½ ç¡®å®šè¦åˆ é™¤å½“å‰é€‰å®šçš„é¢„ç®—\r\n',0),(10463,291,'sv','Ã„r du sÃ¤ker du vill ta bort den markerade budgeten',0),(10464,291,'it','Sei sicuro di che voler eliminare il budget attualmente selezionato',0),(10465,291,'tl','',0),(10466,291,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3607;&#3',0),(10467,291,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤šà¤¯à¤¨à¤¿à¤¤ à¤¬à¤œà¤Ÿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(10468,291,'ms','Adakah anda pasti anda mahu menghapuskan bajet dipilih',0),(10469,291,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø­Ø°Ù Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ù…Ø­Ø¯Ø¯Ø© Ø­Ø§Ù„ÙŠØ§ ØŸ',0),(10470,291,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer le budget actuellement sÃ©lectionnÃ©',0),(10471,291,'jp','ç?¾åœ¨é?¸æŠžã?•ã‚Œã?¦ã?„ã‚‹äºˆç®—ã‚’æ¶ˆåŽ»ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(10472,291,'pt','Tem certeza que deseja excluir o orÃ§amento selecionado',0),(10473,291,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ð¹ Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(10474,291,'es','Â¿Esta seguro que quiere eliminar el presupuesto actualmente seleccionado?',0),(10475,291,'de','Bist du sicher, dass Sie den aktuell ausgewÃ¤hlten Haushalt lÃ¶schen mÃ¶chten',0),(10476,291,'en','Are you sure you want to delete the currently selected budget',0),(10477,292,'is','',0),(10478,292,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ',0),(10479,292,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ',0),(10480,292,'tr','Alacak hesaplarÄ±',0),(10481,292,'pl','Rozrachunki z odbiorcami',0),(10482,292,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ',0),(10483,292,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¬Ø§Ø¦Ø²',0),(10484,292,'sr','ÐšÐ¾Ð½Ñ‚Ð° Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(10485,292,'vi','TÃ i Khoáº£n Pháº£i Thu',0),(10486,292,'af','Bedrag Ontvangbaar',0),(10487,292,'ro','Conturi de Ã®ncasat',0),(10488,292,'et','Laekumata Arved',0),(10489,292,'si','Saldakonti kupcev',0),(10490,292,'ba','Piutang',0),(10491,292,'nl','Debiteuren',0),(10492,292,'fi','Myyntisaamiset',0),(10493,292,'no','Fordringer',0),(10494,292,'da','Tilgodehavender',0),(10495,292,'ko','ê³„ì • ë¯¸ìˆ˜ê¸ˆ',0),(10496,292,'he','×—×©×‘×•× ×•×ª ×—×™×™×‘×™×',0),(10497,292,'el','Î•Î¹ÏƒÏ€ÏÎ±ÎºÏ„Î­Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(10498,292,'zh','åº”æ”¶è´¦æ¬¾\r\n',0),(10499,292,'sv','Kundfordringar',0),(10500,292,'it','ContabilitÃ  clienti',0),(10501,292,'tl','',0),(10502,292,'th','&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(10503,292,'hi','à¤²à¥‡à¤–à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¯',0),(10504,292,'ms','Akaun belum terima',0),(10505,292,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù‚Ø¨Ø¶',0),(10506,292,'fr','Comptes Ã  recevoir',0),(10507,292,'jp','å£²æŽ›é‡‘',0),(10508,292,'pt','Contas a receber',0),(10509,292,'ru','Ð”ÐµÐ±Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ',0),(10510,292,'es','Cuentas por Cobrar',0),(10511,292,'de','Accounts Receivable',0),(10512,292,'en','Accounts Receivable',0),(10513,293,'is','',0),(10514,293,'dr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ ÙÙ‚Ø· Ø§Ú¯Ø± Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ',0),(10515,293,'pr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ ÙÙ‚Ø· Ø§Ú¯Ø± Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ',0),(10516,293,'tr','Sadece sormak eÄŸer daha bÃ¼yÃ¼k',0),(10517,293,'pl','Zapytaj tylko jeÅ›li wiÄ™ksze niÅ¼',0),(10518,293,'bg','ÐŸÐ¸Ñ‚Ð°Ð¼ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ðµ Ð¿Ð¾-Ð³Ð¾Ð»ÑÐ¼ Ð¾Ñ‚',0),(10519,293,'ur','ØµØ±Ù Ù¾ÙˆÚ†Ú¾ ØªÙˆ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø¨Ú‘Ø§',0),(10520,293,'sr','ÐŸÐ¸Ñ‚Ð°Ñ˜ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ñ˜Ðµ Ð²ÐµÑ›Ð° Ð¾Ð´',0),(10521,293,'vi','Chá»‰ há»i khi lá»›n hÆ¡n',0),(10522,293,'af','Vra net as groter as',0),(10523,293,'ro','ÃŽntreb doar dacÄƒ mai mari',0),(10524,293,'et','KÃ¼si juhul kui suurem kui',0),(10525,293,'si','Zahteva le, Äe je veÄja od',0),(10526,293,'ba','Meminta hanya jika lebih besar dari',0),(10527,293,'nl','Vragen alleen als groter dan',0),(10528,293,'fi','PyytÃ¤Ã¤ vain, jos suurempi kuin',0),(10529,293,'no','SpÃ¸r bare hvis det er stÃ¸rre enn',0),(10530,293,'da','SpÃ¸rg kun hvis stÃ¸rre end',0),(10531,293,'ko','ë§Œ ë¬¼ì–´ ë³´ë‹¤ í° ê²½ìš°',0),(10532,293,'he','×œ×‘×§×© ×¨×§ ×× ×’×“×•×œ ×™×•×ª×¨',0),(10533,293,'el','Î¡Ï‰Ï„Î®ÏƒÏ„Îµ Î¼ÏŒÎ½Î¿ Î±Î½ ÎµÎ¯Î½Î±Î¹ Î¼ÎµÎ³Î±Î»ÏÏ„ÎµÏÎ¿ Î±Ï€ÏŒ',0),(10534,293,'zh','åªè¦æ±‚å¤§äºŽ\r\n',0),(10535,293,'sv','FrÃ¥ga bara om stÃ¶rre Ã¤n',0),(10536,293,'it','Chiedo solo se piÃ¹ grande',0),(10537,293,'tl','',0),(10538,293,'th','&#3606;&#3634;&#3617;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3651;&#3627;&#3597;&#3656;&#3585;&#3623;&#3656;&#3634;&#3607;&#3637;&#3656;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(10539,293,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥‚à¤›à¤¨à¤¾ à¤…à¤—à¤° à¤¸à¥‡ à¤¬à¤¡à¤¼à¥€',0),(10540,293,'ms','Tanya sahaja jika lebih besar daripada',0),(10541,293,'ar','Ø§Ø³Ø£Ù„ ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† Ø£ÙƒØ¨Ø± Ù…Ù†',0),(10542,293,'fr','Demander seulement si plus de',0),(10543,293,'jp','ï½žã‚ˆã‚Šå¤§ã??ã?„å ´å?ˆã?®ã?¿è?žã??',0),(10544,293,'pt','SÃ³ peÃ§o se maior do que',0),(10545,293,'ru','ÐŸÑ€Ð¾ÑˆÑƒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð±Ð¾Ð»ÑŒÑˆÐµ, Ñ‡ÐµÐ¼',0),(10546,293,'es','Pedir solamente si es mÃ¡s grande que',0),(10547,293,'de','Bitte nur wenn grÃ¶ÃŸer als',0),(10548,293,'en','Ask only if larger than',0),(10549,294,'is','',0),(10550,294,'dr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ ÙÙ‚Ø· Ø§Ú¯Ø± ÙƒÙˆÚ†ÙƒØªØ± Ø§Ø² ',0),(10551,294,'pr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ ÙÙ‚Ø· Ø§Ú¯Ø± ÙƒÙˆÚ†ÙƒØªØ± Ø§Ø² ',0),(10552,294,'tr','Sadece sormak eÄŸer daha kÃ¼Ã§Ã¼k',0),(10553,294,'pl','Tylko zapytaÄ‡ czy mniejszych niÅ¼',0),(10554,294,'bg','ÐŸÐ¸Ñ‚Ð°Ð¼ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ðµ Ð¿Ð¾-Ð¼Ð°Ð»ÑŠÐº Ð¾Ñ‚',0),(10555,294,'ur','ØµØ±Ù Ù¾ÙˆÚ†Ú¾ ØªÙˆ Ú†Ú¾ÙˆÙ¹Û’ Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(10556,294,'sr','ÐŸÐ¸Ñ‚Ð°Ñ˜ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ñ˜Ðµ Ð¼Ð°ÑšÐ° Ð¾Ð´',0),(10557,294,'vi','Chá»‰ há»i khi nhá» hÆ¡n',0),(10558,294,'af','Vra net as kleiner as',0),(10559,294,'ro','ÃŽntreb doar dacÄƒ este mai micÄƒ',0),(10560,294,'et','KÃ¼si juhul kui vÃ¤iksem kui',0),(10561,294,'si','Zahteva le, Äe je manjÅ¡a od',0),(10562,294,'ba','Meminta hanya jika lebih kecil daripada',0),(10563,294,'nl','Vragen alleen indien kleiner dan',0),(10564,294,'fi','PyytÃ¤Ã¤ vain, jos pienempi kuin',0),(10565,294,'no','SpÃ¸r bare hvis mindre enn',0),(10566,294,'da','SpÃ¸rg kun hvis mindre end',0),(10567,294,'ko','ë§Œ ë¬¼ì–´ ë³´ë‹¤ ìž‘ì€ ê²½ìš°',0),(10568,294,'he','×œ×‘×§×© ×¨×§ ×× ×§×˜×Ÿ ×™×•×ª×¨',0),(10569,294,'el','Î¡Ï‰Ï„Î®ÏƒÏ„Îµ Î¼ÏŒÎ½Î¿ Î±Î½ ÎµÎ¯Î½Î±Î¹ Î¼Î¹ÎºÏÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ',0),(10570,294,'zh','åªè¦æ±‚å°äºŽ\r\n',0),(10571,294,'sv','FrÃ¥ga bara om mindre Ã¤n',0),(10572,294,'it','Chiedo solo se Ã¨ piÃ¹ piccolo',0),(10573,294,'tl','',0),(10574,294,'th','&#3606;&#3634;&#3617;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3648;&#3621;&#3655;&#3585;&#3585;&#3623;&#3656;&#3634;&#3607;&#3637;&#3656;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(10575,294,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥‚à¤›à¤¨à¤¾ à¤…à¤—à¤° à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾ à¤®à¥‡à¤‚ à¤›à¥‹à¤Ÿà¥‡',0),(10576,294,'ms','Tanya sahaja jika ianya lebih kecil daripada',0),(10577,294,'ar','Ø§Ø³Ø£Ù„ ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† Ø£ØµØºØ± Ù…Ù†',0),(10578,294,'fr','Demander seulement si infÃ©rieurs Ã ',0),(10579,294,'jp','ï½žã‚ˆã‚Šå°?ã?•ã?„å ´å?ˆã?®ã?¿è?žã??',0),(10580,294,'pt','SÃ³ peÃ§o se menor do que',0),(10581,294,'ru','Ð¡Ð¿Ñ€Ð°ÑˆÐ¸Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð¼ÐµÐ½ÑŒÑˆÐµ Ñ‡ÐµÐ¼',0),(10582,294,'es','Pedir solamente si es mÃ¡s pequeÃ±o que',0),(10583,294,'de','Bitte nur wenn kleiner als',0),(10584,294,'en','Ask only if smaller than',0),(10585,295,'is','',0),(10586,295,'dr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± ÙÙ‚Ø· Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡  Ù…ÙŠ Ø´ÙˆØ¯',0),(10587,295,'pr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± ÙÙ‚Ø· Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡  Ù…ÙŠ Ø´ÙˆØ¯',0),(10588,295,'tr','Sadece sormak eÄŸer birden fazla mÃ¼rekkep kullanarak',0),(10589,295,'pl','Tylko zapytaÄ‡ czy przy uÅ¼yciu wiÄ™cej niÅ¼ jednej farby',0),(10590,295,'bg','ÐŸÐ¸Ñ‚Ð°Ð¼ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð¸Ð½ Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ',0),(10591,295,'ur','ØµØ±Ù Ù¾ÙˆÚ†Ú¾ Ø§Ú¯Ø± Ø§ÛŒÚ© Ø³Û’ Ø²Ø§Ø¦Ø¯ Ø³ÛŒØ§ÛÛŒ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(10592,295,'sr','ÐŸÐ¸Ñ‚Ð°Ñ˜ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ñ˜ÐµÐ´Ð½Ð¾Ð³ Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿ÐµÑ€Ð¾Ð¼',0),(10593,295,'vi','Chá»‰ há»i khi sá»­ dá»¥ng hÆ¡n má»™t loáº¡i má»±c',0),(10594,295,'af','Vra slegs indien meer as een ink gebruik',0),(10595,295,'ro','ÃŽntreb doar dacÄƒ utilizaÅ£i mai mult de o cernealÄƒ',0),(10596,295,'et','KÃ¼sida ainult kui Ã¼le Ã¼he tindi kasutamine',0),(10597,295,'si','Zahteva le, Äe uporabljate veÄ kot eno Ärnilo',0),(10598,295,'ba','Meminta hanya jika menggunakan lebih dari satu tinta',0),(10599,295,'nl','Vragen alleen als meer dan Ã©Ã©n inkt gebruiken',0),(10600,295,'fi','PyytÃ¤Ã¤ vain, jos useampi kuin yksi musteella',0),(10601,295,'no','SpÃ¸r bare hvis bruker mer enn Ã©n trykkfarge',0),(10602,295,'da','SpÃ¸rg kun hvis bruger mere end Ã©n trykfarve',0),(10603,295,'ko','ë§Œ ê²Œ í•˜ë‚˜ ì´ìƒì˜ ìž‰í¬ë¥¼ ì‚¬ìš© í•˜ëŠ” ê²½ìš°',0),(10604,295,'he','×¨×§ ×ž×‘×§×©, ×× ×‘××ž×¦×¢×•×ª ×“×™×• ××—×“ ××• ×™×•×ª×¨',0),(10605,295,'el','Î¡Ï‰Ï„Î®ÏƒÏ„Îµ Î¼ÏŒÎ½Î¿ Î±Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ± Î±Ï€ÏŒ Î­Î½Î± Î¼ÎµÎ»Î¬Î½Î¹Î±',0),(10606,295,'zh','è¦æ±‚åªä½¿ç”¨ä¸€ä¸ªä»¥ä¸Šçš„å¢¨æ°´\r\n',0),(10607,295,'sv','FrÃ¥ga bara om du anvÃ¤nder mer Ã¤n en tryckfÃ¤rg',0),(10608,295,'it','Chiedo solo se si utilizza piÃ¹ di un inchiostro',0),(10609,295,'tl','',0),(10610,295,'th','&#3606;&#3634;&#3617;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3627;&#3617;&#3638;&#3585;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3627;&#3609;&#3638;&#3656;&#3591;&#3626;&#3637;',0),(10611,295,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥‚à¤›à¤¨à¤¾ à¤¯à¤¦à¤¿ à¤à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°',0),(10612,295,'ms','Tanya sahaja jika menggunakan dakwat lebih daripada satu',0),(10613,295,'ar','Ø§Ø³Ø£Ù„ ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ø¨Ø± ÙˆØ§Ø­Ø¯ Ø£Ùˆ Ø£ÙƒØ«Ø±',0),(10614,295,'fr','Demander seulement si vous utilisez plus d\'une encre',0),(10615,295,'jp','ï¼‘è‰²ä»¥ä¸Šä½¿ã‚?ã‚Œã?¦ã?„ã‚‹å ´å?ˆã?®ã?¿è?žã??',0),(10616,295,'pt','SÃ³ peÃ§o se usando mais de uma tinta',0),(10617,295,'ru','ÐŸÑ€Ð¾ÑˆÑƒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ñ€Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ð¾Ð´Ð½Ð¾Ð¹ ÐºÑ€Ð°ÑÐºÐ¸',0),(10618,295,'es','Pedir solamente si esta usando mÃ¡s que una tinta',0),(10619,295,'de','Bitte nur wenn mehr als eine Tinte verwenden',0),(10620,295,'en','Ask only if using more than one ink',0),(10621,296,'is','',0),(10622,296,'dr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± ÙÙ‚Ø· Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡  Ù…ÙŠ Ø´ÙˆØ¯',0),(10623,296,'pr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± ÙÙ‚Ø· Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡  Ù…ÙŠ Ø´ÙˆØ¯',0),(10624,296,'tr','Sadece sormak eÄŸer birden fazla yan kullanarak',0),(10625,296,'pl','Tylko zapytaÄ‡ czy przy uÅ¼yciu wiÄ™cej niÅ¼ jednej strony',0),(10626,296,'bg','ÐŸÐ¸Ñ‚Ð°Ð¼ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð°',0),(10627,296,'ur','ØµØ±Ù Ù¾ÙˆÚ†Ú¾Ù†Ø§ ÛÛ’ Ø§Ú¯Ø± Ø§ÛŒÚ© Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Ù…Øª Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(10628,296,'sr','ÐŸÐ¸Ñ‚Ð°Ñ˜ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ñ˜ÐµÐ´Ð½Ðµ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(10629,296,'vi','Chá»‰ há»i khi sá»­ dá»¥ng hÆ¡n má»™t máº·t',0),(10630,296,'af','Vra slegs indien meer as een kant gebruik',0),(10631,296,'ro','ÃŽntreb doar dacÄƒ utilizaÅ£i mai mult de o parte',0),(10632,296,'et','KÃ¼sida ainult seda, kui kasutada rohkem kui Ã¼hel kÃ¼ljel',0),(10633,296,'si','Zahteva le, Äe uporabljate veÄ kot eno stran',0),(10634,296,'ba','Meminta hanya jika menggunakan lebih dari satu sisi',0),(10635,296,'nl','Alleen vragen als met behulp van meer dan een kant',0),(10636,296,'fi','PyytÃ¤Ã¤ vain, jos kÃ¤ytÃ¤t enemmÃ¤n kuin yksi puoli',0),(10637,296,'no','SpÃ¸r bare hvis bruker mer enn Ã©n side',0),(10638,296,'da','SpÃ¸rg kun hvis bruger mere end Ã©n side',0),(10639,296,'ko','ë§Œ ê²Œ í•˜ë‚˜ ì´ìƒì˜ ì¸¡ë©´ì„ ì‚¬ìš© í•˜ëŠ” ê²½ìš°',0),(10640,296,'he','×œ×‘×§×© ×¨×§ ×× ×ž×©×ª×ž×© ××—×“ ××• ×™×•×ª×¨ ×‘×¦×“',0),(10641,296,'el','Î¡Ï‰Ï„Î®ÏƒÏ„Îµ Î¼ÏŒÎ½Î¿ Î±Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Î±Ï€ÏŒ Î¼Î¯Î± Ï€Î»ÎµÏ…ÏÎ¬',0),(10642,296,'zh','è¦æ±‚åªä½¿ç”¨ä¸€é¢ä»¥ä¸Š\r\n',0),(10643,296,'sv','FrÃ¥ga bara om du anvÃ¤nder mer Ã¤n en sida',0),(10644,296,'it','Chiedo solo se si utilizza piÃ¹ di un lato',0),(10645,296,'tl','',0),(10646,296,'th','&#3606;&#3634;&#3617;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3627;&#3609;&#3638;&#3656;&#3591;&#3604;&#3657;&#3634;&#3609;',0),(10647,296,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥‚à¤›à¤¨à¤¾ à¤¯à¤¦à¤¿ à¤à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤ªà¤•à¥à¤· à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¤¾',0),(10648,296,'ms','Tanya sahaja jika menggunakan lebih daripada satu bahagian',0),(10649,296,'ar','Ø§Ø³Ø£Ù„ ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ø³ØªØ®Ø¯Ø§Ù… ÙˆØ§Ø­Ø¯ Ø£Ùˆ Ø£ÙƒØ«Ø± Ù…Ù† Ø§Ù„Ø¬Ø§Ù†Ø¨',0),(10650,296,'fr','Demander seulement si vous utilisez plus d\'un cÃ´tÃ©',0),(10651,296,'jp','ä¸€é?¢ä»¥ä¸Šã‚’ä½¿ã?£ã?¦ã?„ã‚‹å ´å?ˆã?®ã?¿è?žã??',0),(10652,296,'pt','SÃ³ peÃ§o se usando mais de um lado',0),(10653,296,'ru','ÐŸÑ€Ð¾ÑˆÑƒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ñ€Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ð¾Ð´Ð½Ð¾Ð¹ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(10654,296,'es','Pedir solamente si esta usando mÃ¡s que un lado',0),(10655,296,'de','Bitte nur wenn mehr als einer Seite zu verwenden',0),(10656,296,'en','Ask only if using more than one side',0),(10657,297,'is','',0),(10658,297,'dr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø±   Ø§Ø²Ø¬ÙˆÙ‡Ø±ÙŠ ØºÙŠØ± Ø§Ø² Ù…Ø´ÙƒÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡  Ù…ÙŠ Ø´ÙˆØ¯',0),(10659,297,'pr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø±   Ø§Ø²Ø¬ÙˆÙ‡Ø±ÙŠ ØºÙŠØ± Ø§Ø² Ù…Ø´ÙƒÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡  Ù…ÙŠ Ø´ÙˆØ¯',0),(10660,297,'tr','Sadece sormak eÄŸer siyah olmayan mÃ¼rekkep kullanarak',0),(10661,297,'pl','Tylko zapytaÄ‡ czy przy uÅ¼yciu nie-czarny atrament',0),(10662,297,'bg','ÐŸÐ¸Ñ‚Ð°Ð¼ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð½Ðµ-Ñ‡ÐµÑ€Ð½Ð¸ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾',0),(10663,297,'ur','ØµØ±Ù Ù¾ÙˆÚ†Ú¾ ØªÙˆ Ø§Ù†Ú© non-Ø³ÛŒØ§Û Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(10664,297,'sr','ÐŸÐ¸Ñ‚Ð°Ñ˜ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° ÐºÐ¾Ñ˜Ðµ Ð½Ð¸ÑÑƒ Ñ†Ñ€Ð½Ð¸',0),(10665,297,'vi','Chá»‰ há»i khi sá»­ dá»¥ng má»±c khÃ´ng mÃ u Ä‘en',0),(10666,297,'af','Vra net as gebruik nie swart ink',0),(10667,297,'ro','ÃŽntreb doar dacÄƒ folosind cernealÄƒ non-negru',0),(10668,297,'et','Palun ainult mitte-must tint kasutamisel',0),(10669,297,'si','Zahteva le, Äe uporaba ni Ärna Ärnila',0),(10670,297,'ba','Meminta hanya jika menggunakan tinta hitam non',0),(10671,297,'nl','Vragen alleen als niet-zwarte inkt gebruiken',0),(10672,297,'fi','PyytÃ¤Ã¤ vain, jos kÃ¤ytÃ¤t ei-musta muste',0),(10673,297,'no','SpÃ¸r bare hvis bruker ikke-svart farge',0),(10674,297,'da','SpÃ¸rg kun anvender ikke-sorte blÃ¦k',0),(10675,297,'ko','ë§Œ ê²Œ ë¹„ ê²€ì • ìž‰í¬ë¥¼ ì‚¬ìš© í•˜ëŠ” ê²½ìš°',0),(10676,297,'he','×œ×‘×§×© ×¨×§ ×× ×ž×©×ª×ž×© ×ž×©×—×•×¨ ×”×“×™×•',0),(10677,297,'el','Î¡Ï‰Ï„Î®ÏƒÏ„Îµ Î¼ÏŒÎ½Î¿ Î±Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Î¼Î· Î¼Î±ÏÏÎ¿ Î¼ÎµÎ»Î¬Î½Î¹',0),(10678,297,'zh','è¦æ±‚åªä½¿ç”¨éžé»‘è‰²å¢¨æ°´\r\n',0),(10679,297,'sv','FrÃ¥ga bara om du anvÃ¤nder icke-svarta blÃ¤ck',0),(10680,297,'it','Chiedo solo se si utilizza inchiostro non-nero',0),(10681,297,'tl','',0),(10682,297,'th','&#3606;&#3634;&#3617;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3627;&#3617;&#3638;&#3585;&#3614;&#3636;&#3617;&#3614;&#3660;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3626;&#3637;&#3',0),(10683,297,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥‚à¤›à¤¨à¤¾ à¤…à¤—à¤° à¤—à¥ˆà¤° à¤•à¤¾à¤²à¥‡ à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°',0),(10684,297,'ms','Tanya sahaja jika menggunakan dakwat non-hitam',0),(10685,297,'ar','Ø§Ø³Ø£Ù„ ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø­Ø¨Ø± ØºÙŠØ± Ø§Ù„Ø£Ø³ÙˆØ¯',0),(10686,297,'fr','Demander seulement si l\'utilisation d\'encre non-noir',0),(10687,297,'jp','é»’ä»¥å¤–ã?®ã‚¤ãƒ³ã‚¯ã?Œä½¿ã‚?ã‚Œã?¦ã?„ã‚‹å ´å?ˆã?®ã?¿è?žã??',0),(10688,297,'pt','SÃ³ peÃ§o se usando tinta nÃ£o-negros',0),(10689,297,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÑÐ¿Ñ€Ð¾ÑÐ¸Ñ‚Ðµ ÐµÑÐ»Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑ Ñ‡ÐµÑ€Ð½Ð¸Ð»Ð° Ñ‡ÐµÑ€Ð½Ð¾Ð³Ð¾',0),(10690,297,'es','Pedir solamente si esta usando una tinta que no es negra',0),(10691,297,'de','Frage nur, wenn nicht-schwarze Tinte verwenden',0),(10692,297,'en','Ask only if using non-black ink',0),(10693,298,'is','',0),(10694,298,'dr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± ÙÙ‚Ø· Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡  Ù…ÙŠ Ø´ÙˆØ¯',0),(10695,298,'pr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± ÙÙ‚Ø· Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡  Ù…ÙŠ Ø´ÙˆØ¯',0),(10696,298,'tr','Sadece sormak eÄŸer bir mÃ¼rekkep kullanarak',0),(10697,298,'pl','Tylko zapytaÄ‡ czy przy uÅ¼yciu jednego tuszu',0),(10698,298,'bg','ÐŸÐ¸Ñ‚Ð°Ð¼ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ ÐµÐ´Ð½Ð¾ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾',0),(10699,298,'ur','ØµØ±Ù Ù¾ÙˆÚ†Ú¾ ØªÙˆ Ø§ÛŒÚ© Ø³ÛŒØ§ÛÛŒ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(10700,298,'sr','ÐŸÐ¸Ñ‚Ð°Ñ˜ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ñ˜ÐµÐ´Ð°Ð½ Ð¿ÐµÑ€Ð¾Ð¼',0),(10701,298,'vi','Chá»‰ há»i khi sá»­ dá»¥ng má»™t loáº¡i má»±c',0),(10702,298,'af','Vra net as een ink gebruik',0),(10703,298,'ro','ÃŽntreb doar dacÄƒ folosind o cernealÄƒ',0),(10704,298,'et','KÃ¼sida ainult kui Ã¼he tindi kasutamine',0),(10705,298,'si','Zahteva le, Äe uporabljate eno Ärnilo',0),(10706,298,'ba','Meminta hanya jika menggunakan satu tinta',0),(10707,298,'nl','Vragen alleen als een inkt gebruiken',0),(10708,298,'fi','PyytÃ¤Ã¤ vain, jos yksi musteella',0),(10709,298,'no','SpÃ¸r bare hvis bruker Ã©n blekkfarge',0),(10710,298,'da','SpÃ¸rg kun anvender Ã©n trykfarve',0),(10711,298,'ko','ë§Œ ìš”êµ¬ í•œ ìž‰í¬ë¥¼ ì‚¬ìš© í•˜ëŠ” ê²½ìš°',0),(10712,298,'he','×¨×§ ×ž×‘×§×©, ×× ×‘××ž×¦×¢×•×ª ×“×™×• ××—×“',0),(10713,298,'el','Î¡Ï‰Ï„Î®ÏƒÏ‰ Î¼ÏŒÎ½Î¿ ÎµÎ¬Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Î­Î½Î± Î¼ÎµÎ»Î¬Î½Î¹',0),(10714,298,'zh','è¦æ±‚åªä½¿ç”¨ä¸€ä¸ªå¢¨æ°´\r\n',0),(10715,298,'sv','FrÃ¥ga bara om du anvÃ¤nder en tryckfÃ¤rg',0),(10716,298,'it','Chiedo solo se si utilizza un inchiostro',0),(10717,298,'tl','',0),(10718,298,'th','&#3606;&#3634;&#3617;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3627;&#3617;&#3638;&#3585;&#3626;&#3637;&#3648;&#3604;&#3637;&#3618;&#3623;',0),(10719,298,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥‚à¤›à¤¨à¤¾ à¤…à¤—à¤° à¤à¤• à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°',0),(10720,298,'ms','Tanya sahaja jika menggunakan dakwat satu',0),(10721,298,'ar','Ø§Ø³Ø£Ù„ ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø­Ø¨Ø± ÙˆØ§Ø­Ø¯',0),(10722,298,'fr','Demander seulement si vous utilisez une encre',0),(10723,298,'jp','1è‰²ã?®ã‚¤ãƒ³ã‚¯ã?Œä½¿ã‚?ã‚Œã?¦ã?„ã‚‹å ´å?ˆã?®ã?¿è?žã??',0),(10724,298,'pt','SÃ³ peÃ§o se usando uma tinta',0),(10725,298,'ru','Ð¡Ð¿Ñ€Ð¾ÑÐ¸Ñ‚ÑŒ, Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ Ð¾Ð´Ð½Ð¾Ð¹ ÐºÑ€Ð°ÑÐºÐ¸',0),(10726,298,'es','Pedir solamente si esta usando una tinta',0),(10727,298,'de','Frage nur, wenn eine Tinte verwenden',0),(10728,298,'en','Ask only if using one ink',0),(10729,299,'is','',0),(10730,299,'dr','Ø³ÙˆØ§Ù„ Ø¨Ù¾Ø±Ø³ÙŠØ¯',0),(10731,299,'pr','Ø³ÙˆØ§Ù„ Ø¨Ù¾Ø±Ø³ÙŠØ¯',0),(10732,299,'tr','Soru sor',0),(10733,299,'pl','Zadaj pytanie',0),(10734,299,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð²ÑŠÐ¿Ñ€Ð¾Ñ',0),(10735,299,'ur','Ø³ÙˆØ§Ù„ Ù¾ÙˆÚ†Ú¾ÛŒÚº',0),(10736,299,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ð¼ Ð¿Ð¸Ñ‚Ð°ÑšÐµ',0),(10737,299,'vi','Äáº·t CÃ¢u Há»i',0),(10738,299,'af','Vra \'n Vraag',0),(10739,299,'ro','AdresaÅ£i Ã®ntrebarea',0),(10740,299,'et','KÃ¼si',0),(10741,299,'si','VpraÅ¡ajte vpraÅ¡anje',0),(10742,299,'ba','Mengajukan pertanyaan',0),(10743,299,'nl','Vraag',0),(10744,299,'fi','Kysy kysymys',0),(10745,299,'no','Stille spÃ¸rsmÃ¥l',0),(10746,299,'da','Stille spÃ¸rgsmÃ¥l',0),(10747,299,'ko','ì§ˆë¬¸',0),(10748,299,'he','×œ×©××•×œ ×©××œ×”',0),(10749,299,'el','Î•ÏÏŽÏ„Î·ÏƒÎ·',0),(10750,299,'zh','é—®é—®é¢˜\r\n',0),(10751,299,'sv','FrÃ¥ga',0),(10752,299,'it','Fai domanda',0),(10753,299,'tl','',0),(10754,299,'th','&#3606;&#3634;&#3617;&#3588;&#3635;&#3606;&#3634;&#3617;',0),(10755,299,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨ à¤ªà¥‚à¤›à¥‡à¤‚',0),(10756,299,'ms','Tanya soalan',0),(10757,299,'ar','Ø§Ø³Ø£Ù„ Ø§Ù„Ø³Ø¤Ø§Ù„',0),(10758,299,'fr','Poser Question',0),(10759,299,'jp','è³ªå•?ã?™ã‚‹',0),(10760,299,'pt','Fazer pergunta',0),(10761,299,'ru','Ð—Ð°Ð´Ð°Ñ‚ÑŒ Ð’Ð¾Ð¿Ñ€Ð¾Ñ',0),(10762,299,'es','Hacer una Pregunta',0),(10763,299,'de','Frage',0),(10764,299,'en','Ask Question',0),(10765,300,'is','',0),(10766,300,'dr','(Ø­ÙˆØ§Ù„Ù‡)',0),(10767,300,'pr','ØªØ¹ÙŠÙŠÙ†(Ø­ÙˆØ§Ù„Ù‡)',0),(10768,300,'tr','Atama',0),(10769,300,'pl','Przypisz',0),(10770,300,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð°',0),(10771,300,'ur','ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(10772,300,'sr','Ð”Ð¾Ð´ÐµÑ™Ð¸Ð²Ð°ÑšÐµ',0),(10773,300,'vi','Chá»‰ Äá»‹nh',0),(10774,300,'af','Toestaan',0),(10775,300,'ro','AsociaÅ£i',0),(10776,300,'et','MÃ¤Ã¤rata',0),(10777,300,'si','Dodelite',0),(10778,300,'ba','Menetapkan',0),(10779,300,'nl','Toewijzen',0),(10780,300,'fi','MÃ¤Ã¤rittÃ¤Ã¤',0),(10781,300,'no','Tilordne',0),(10782,300,'da','Tildel',0),(10783,300,'ko','í• ë‹¹',0),(10784,300,'he','×œ×”×§×¦×•×ª',0),(10785,300,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ',0),(10786,300,'zh','åˆ†é…\r\n',0),(10787,300,'sv','Tilldela',0),(10788,300,'it','Assegnare',0),(10789,300,'tl','',0),(10790,300,'th','&#3585;&#3635;&#3627;&#3609;&#3604;',0),(10791,300,'hi','à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(10792,300,'ms','Peruntukkan',0),(10793,300,'ar','ØªØ¹ÙŠÙŠÙ†',0),(10794,300,'fr','Assign',0),(10795,300,'jp','å‰²ã‚Šå½“ã?¦ã‚‹',0),(10796,300,'pt','Atribuir',0),(10797,300,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ',0),(10798,300,'es','Asignar',0),(10799,300,'de','Zuweisen',0),(10800,300,'en','Assign',0),(10801,301,'is','',0),(10802,301,'dr','(Ø§Ø¨ØªØ¯Ø§ Ø°Ø®ÙŠØ±Ù‡ ÙƒÙ†ÙŠØ¯',0),(10803,301,'pr','ØªØ¹ÙŠÙŠÙ† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ (Ø§Ø¨ØªØ¯Ø§ Ø°Ø®ÙŠØ±Ù‡ ÙƒÙ†ÙŠØ¯',0),(10804,301,'tr','Malzemeler (SAVE ilk!!) atayÄ±n',0),(10805,301,'pl','PrzypisaÄ‡ materiaÅ‚y (Zapisz pierwszy!)',0),(10806,301,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ (SAVE Ð¿ÑŠÑ€Ð²Ð¾!)',0),(10807,301,'ur','(Ù…Ø­ÙÙˆØ¸ Ù¾ÛÙ„Û’!!) Ù…ÙˆØ§Ø¯ Ú©Ùˆ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(10808,301,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð° (Ð¡ÐÐ§Ð£Ð’ÐÐˆ Ð¿Ñ€Ð²Ð¾!!)',0),(10809,301,'vi','Chá»‰ Äá»‹nh Váº­t Liá»‡u (LÆ¯U TRÆ¯á»šC!!)',0),(10810,301,'af','Wys materiaal (stoor eerste!!)',0),(10811,301,'ro','Atribui materiale (cu excepÅ£ia prima!!)',0),(10812,301,'et','MÃ¤Ã¤rata materjalidest (SAVE esimene!)',0),(10813,301,'si','Materialov (razen prve!) dodeliti',0),(10814,301,'ba','Menetapkan bahan (Simpan pertama!!)',0),(10815,301,'nl','Toewijzen van materialen (opslaan eerst!)',0),(10816,301,'fi','MÃ¤Ã¤rittÃ¤Ã¤ materiaalit (Tallenna ensin!)',0),(10817,301,'no','Tilordne materiale (lagre fÃ¸rst!)',0),(10818,301,'da','Tildele materialer (Gem fÃ¸rst!)',0),(10819,301,'ko','(ì²« ë²ˆì§¸!) ì €ìž¥ ìž¬ì§ˆ í• ë‹¹',0),(10820,301,'he','×”×§×¦××ª ×—×•×ž×¨×™× (×©×ž×•×¨ ×§×•×“×!!)',0),(10821,301,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ Ï„Î± Ï…Î»Î¹ÎºÎ¬ (Î•ÎšÎ¤ÎŒÎ£ Ï„Î·Î½ Ï€ÏÏŽÏ„Î·!!)',0),(10822,301,'zh','æŒ‡å®šææ–™ï¼ˆå…ˆå­˜ç›˜ï¼ï¼‰\r\n',0),(10823,301,'sv','Tilldela material (spara fÃ¶rst!)',0),(10824,301,'it','Assegnare materiali (Salva prima!!)',0),(10825,301,'tl','',0),(10826,301,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;(SAVE FIRST!!)',0),(10827,301,'hi','($ à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤ªà¥à¤°à¤¥à¤®!!) à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(10828,301,'ms','Memperuntukkan bahan-bahan (Simpan pertama!!)',0),(10829,301,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…ÙˆØ§Ø¯ (Ø§Ø­ÙØ¸ Ø£ÙˆÙ„Ø§Ù‹!!)',0),(10830,301,'fr','Assigner des matÃ©riaux (enregistrer tout d\'abord!)',0),(10831,301,'jp','è³‡æ–™ã?®å‰²ã‚Šå½“ã?¦ï¼ˆå…ˆã?«ä¿?å­˜ã?—ã?¦ã??ã? ã?•ã?„ï¼?ï¼‰',0),(10832,301,'pt','Atribuir materiais (salvar primeiro!!!!)',0),(10833,301,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð² (Ð·Ð° Ð¸ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ÐµÐ¼ Ð¿ÐµÑ€Ð²Ð¾Ð³Ð¾!)',0),(10834,301,'es','Asignar Materiales (GRABAR PRIMERO!!)',0),(10835,301,'de','Ordnen Sie Materialien (auÃŸer zuerst!)',0),(10836,301,'en','Assign Materials (SAVE FIRST!!)',0),(10837,302,'is','',0),(10838,302,'dr','Ø¯Ø±',0),(10839,302,'pr','Ø¯Ø±',0),(10840,302,'tr','At',0),(10841,302,'pl','W',0),(10842,302,'bg','Ð’',0),(10843,302,'ur','Ù…ÛŒÚº',0),(10844,302,'sr','Ð£',0),(10845,302,'vi','Táº¡i',0),(10846,302,'af','By',0),(10847,302,'ro','La',0),(10848,302,'et','Kell',0),(10849,302,'si','Na',0),(10850,302,'ba','Di',0),(10851,302,'nl','At',0),(10852,302,'fi','Klo',0),(10853,302,'no','PÃ¥',0),(10854,302,'da','PÃ¥',0),(10855,302,'ko','ì—ì„œ',0),(10856,302,'he','×‘',0),(10857,302,'el','Î£Ï„Î¿',0),(10858,302,'zh','åœ¨\r\n',0),(10859,302,'sv','PÃ¥',0),(10860,302,'it','Presso',0),(10861,302,'tl','',0),(10862,302,'th','&#3607;&#3637;&#3656;',0),(10863,302,'hi','à¤ªà¤°',0),(10864,302,'ms','Pada',0),(10865,302,'ar','ÙÙŠ',0),(10866,302,'fr','Ã€',0),(10867,302,'jp','At',0),(10868,302,'pt','No',0),(10869,302,'ru','Ð’',0),(10870,302,'es','A',0),(10871,302,'de','Bei',0),(10872,302,'en','At',0),(10873,303,'is','',0),(10874,303,'dr','Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ÙŠØ¯ Ø­Ù‚ Ø§ØµÙ„Ø§Ø­ Ø±Ø§  Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(10875,303,'pr','Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ÙŠØ¯ Ø­Ù‚ Ø§ØµÙ„Ø§Ø­ Ø±Ø§  Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(10876,303,'tr','En az bir kullanÄ±cÄ± haklarÄ±nÄ± deÄŸiÅŸtirmeniz gerekir.',0),(10877,303,'pl','Co najmniej jeden uÅ¼ytkownik musi zmieniÄ‡ prawa.',0),(10878,303,'bg','ÐŸÐ¾Ð½Ðµ ÐµÐ´Ð¸Ð½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð¿Ñ€Ð°Ð²Ð°.',0),(10879,303,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø§ÛŒÚ© ØµØ§Ø±Ù Ø¶Ø±ÙˆØ±ÛŒ ÛÛ’ ØªØ±Ù…ÛŒÙ… Ø­Ù‚ÙˆÙ‚ ÛÛŒÚº Û”',0),(10880,303,'sr','ÐÐ°Ñ˜Ð¼Ð°ÑšÐµ Ñ˜ÐµÐ´Ð°Ð½ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð¼Ð¾Ñ€Ð° Ð¸Ð¼Ð°Ñ‚Ð¸ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð²Ð°.',0),(10881,303,'vi','Ãt nháº¥t pháº£i cÃ³ 1 NgÆ°á»i Sá»­ Dá»¥ng cÃ³ quyá»n chá»‰nh sá»­a',0),(10882,303,'af','Ten minste een gebruiker moet oor wysigingsregte beskik.',0),(10883,303,'ro','Cel puÅ£in un utilizator trebuie sÄƒ aibÄƒ modifica drepturile.',0),(10884,303,'et','Ãœks kasutaja on muuta Ãµigusi.',0),(10885,303,'si','Vsaj en uporabnik mora imeti spremeniti pravice.',0),(10886,303,'ba','Setidaknya satu pengguna harus memodifikasi hak.',0),(10887,303,'nl','Ten minste Ã©Ã©n gebruiker moet rechten hebben wijzigen.',0),(10888,303,'fi','VÃ¤hintÃ¤Ã¤n yksi kÃ¤yttÃ¤jÃ¤ on muokattava oikeuksia.',0),(10889,303,'no','Minst Ã©n bruker mÃ¥ ha endre rettigheter.',0),(10890,303,'da','Mindst Ã©n bruger skal have Ã¦ndre rettigheder.',0),(10891,303,'ko','ì ì–´ë„ í•˜ë‚˜ì˜ ì‚¬ìš©ìž ê¶Œí•œì„ ìˆ˜ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(10892,303,'he','×œ×¤×—×•×ª ×ž×©×ª×ž×© ××—×“ ×¢×œ×™×š ×œ×©× ×•×ª ×–×›×•×™×•×ª.',0),(10893,303,'el','Î¤Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î­Î½Î±Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡Î¿Ï…Î½ Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹ Ï„Î± Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î±.',0),(10894,303,'zh','è‡³å°‘æœ‰ä¸€ä½ç”¨æˆ·å¿…é¡»å…·æœ‰ä¿®æ”¹çš„æƒåˆ©ã€‚\r\n',0),(10895,303,'sv','Minst en anvÃ¤ndare mÃ¥ste ha Ã¤ndra rÃ¤ttigheter.',0),(10896,303,'it','Almeno un utente deve avere modificare diritti.',0),(10897,303,'tl','',0),(10898,303,'th','&#3629;&#3618;&#3656;&#3634;&#3591;&#3609;&#3657;&#3629;&#3618;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3627;&#3609;&#3638;&#3656;&#3591;&#3588;&#3609;&#3605;&#3657;&#3629;&#3591;&#3649;&#3585;&#3657;&#3652;&#3586;&#3606;&#3641;&#3585;&#3605;&#3657;&#3',0),(10899,303,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ à¤¹à¥ˆà¥¤',0),(10900,303,'ms','Sekurang-kurangnya satu pengguna mestilah telah mengubah hak.',0),(10901,303,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù…Ø³ØªØ®Ø¯Ù… ÙˆØ§Ø­Ø¯ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„ ØªØ¹Ø¯ÙŠÙ„ Ø§Ù„Ø­Ù‚ÙˆÙ‚.',0),(10902,303,'fr','Au moins un utilisateur doit avoir modifier les droits.',0),(10903,303,'jp','å°‘ã?ªã??ã?¦ã‚‚ä¸€äººä»¥ä¸Šã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?Œä¿®æ­£æ¨©åˆ©ã‚’æŒ?ã?Ÿã?ªã??ã?¦ã?¯ã?ªã‚Šã?¾ã?›ã‚“',0),(10904,303,'pt','Pelo menos um usuÃ¡rio deve ter modificar direitos.',0),(10905,303,'ru','ÐŸÐ¾ ÐºÑ€Ð°Ð¹Ð½ÐµÐ¹ Ð¼ÐµÑ€Ðµ Ð¾Ð´Ð¸Ð½ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð°Ð²Ð°.',0),(10906,303,'es','Por lo Menos un usuario debe tener derechos de modificar',0),(10907,303,'de','Mindestens ein Benutzer muss haben Ã¤ndern Rechte.',0),(10908,303,'en','At least one user must have modify rights.',0),(10909,304,'is','',0),(10910,304,'dr','Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ÙŠØ¯ Ø­Ù‚ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ø±Ø§  Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯',0),(10911,304,'pr','Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ÙŠØ¯ Ø­Ù‚ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ø±Ø§  Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯',0),(10912,304,'tr','En az bir kullanÄ±cÄ± gÃ¶rÃ¼nÃ¼mÃ¼ haklarÄ±nÄ±z olmalÄ±dÄ±r.',0),(10913,304,'pl','Co najmniej jeden uÅ¼ytkownik musi mieÄ‡ widzenia prawa.',0),(10914,304,'bg','ÐŸÐ¾Ð½Ðµ ÐµÐ´Ð¸Ð½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð¿Ñ€Ð°Ð²Ð° Ð½Ð° Ð¸Ð·Ð³Ð»ÐµÐ´.',0),(10915,304,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø§ÛŒÚ© ØµØ§Ø±Ù Ù…Ù†Ø¸Ø± Ø­Ù‚ÙˆÙ‚ Ù†ÛÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ Û”',0),(10916,304,'sr','ÐÐ°Ñ˜Ð¼Ð°ÑšÐµ Ñ˜ÐµÐ´Ð°Ð½ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð¼Ð¾Ñ€Ð° Ð¸Ð¼Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð¿Ñ€Ð°Ð²Ð°.',0),(10917,304,'vi','Ãt nháº¥t pháº£i cÃ³ 1 NgÆ°á»i Sá»­ Dá»¥ng cÃ³ quyá»n xem',0),(10918,304,'af','Ten minste een gebruiker moet beskik oor besigtingsregte.',0),(10919,304,'ro','Cel puÅ£in un utilizator trebuie sÄƒ aibÄƒ vedere drepturile.',0),(10920,304,'et','Ãœhel kasutajal peab olema vaade Ãµigused.',0),(10921,304,'si','Vsaj en uporabnik mora imeti pogled pravice.',0),(10922,304,'ba','Setidaknya satu pengguna harus memiliki pemandangan hak.',0),(10923,304,'nl','Ten minste Ã©Ã©n gebruiker moet weergave rechten hebben.',0),(10924,304,'fi','VÃ¤hintÃ¤Ã¤n yhdellÃ¤ kÃ¤yttÃ¤jÃ¤llÃ¤ tÃ¤ytyy olla katseluoikeudet.',0),(10925,304,'no','Minst Ã©n bruker mÃ¥ ha visningsrettigheter.',0),(10926,304,'da','Mindst Ã©n bruger skal have Se rettigheder.',0),(10927,304,'ko','í•˜ë‚˜ ì´ìƒì˜ ì‚¬ìš©ìžëŠ” ë³´ê¸° ê¶Œí•œì´ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(10928,304,'he','×œ×¤×—×•×ª ×ž×©×ª×ž×© ××—×“ ×—×™×™×‘ ×œ×”×™×•×ª ×ª×¦×•×’×” ×–×›×•×™×•×ª.',0),(10929,304,'el','Î¤Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î­Î½Î±Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï€ÏÎ¿Î²Î¿Î»Î®Ï‚.',0),(10930,304,'zh','è‡³å°‘æœ‰ä¸€ä¸ªç”¨æˆ·å¿…é¡»æœ‰æŸ¥çœ‹çš„æƒåˆ©ã€‚\r\n',0),(10931,304,'sv','Minst en anvÃ¤ndare mÃ¥ste ha Visa.',0),(10932,304,'it','Almeno un utente deve disporre dei diritti di visualizzazione.',0),(10933,304,'tl','',0),(10934,304,'th','&#3629;&#3618;&#3656;&#3634;&#3591;&#3609;&#3657;&#3629;&#3618;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3627;&#3609;&#3638;&#3656;&#3591;&#3588;&#3609;&#3605;&#3657;&#3629;&#3591;&#3617;&#3629;&#3591;&#3604;&#3641;&#3606;&#3641;&#3585;&#3605;&#3657;&#3',0),(10935,304,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¦à¥‡à¤–à¥‡à¤‚ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(10936,304,'ms','Sekurang-kurangnya satu pengguna mesti mempunyai hak view.',0),(10937,304,'ar','Ù…Ø³ØªØ®Ø¯Ù… ÙˆØ§Ø­Ø¯ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„ ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ø¹Ø±Ø¶.',0),(10938,304,'fr','Au moins un utilisateur doit disposer des droits de vue.',0),(10939,304,'jp','å°‘ã?ªã??ã?¦ã‚‚ä¸€äººä»¥ä¸Šã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?Œé–²è¦§æ¨©åˆ©ã‚’æŒ?ã?Ÿã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(10940,304,'pt','Pelo menos um usuÃ¡rio deve ter direitos de exibiÃ§Ã£o.',0),(10941,304,'ru','ÐŸÐ¾ ÐºÑ€Ð°Ð¹Ð½ÐµÐ¹ Ð¼ÐµÑ€Ðµ Ð¾Ð´Ð¸Ð½ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð²Ð¸Ð´ÐµÑ‚ÑŒ Ð¿Ñ€Ð°Ð²Ð° Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ.',0),(10942,304,'es','Por lo Menos un usuario debe tener derechos de Visionar',0),(10943,304,'de','Mindestens ein Benutzer muss die Ansicht Rechte verfÃ¼gen.',0),(10944,304,'en','At least one user must have view rights.',0),(10945,305,'is','',0),(10946,305,'dr','ÙØ§ÙŠÙ„ Ø¯ÙŠÚ¯Ø± Ø±Ø§ Ø¶Ù…ÙŠÙ…Ù‡ ÙƒÙ†ÙŠØ¯',0),(10947,305,'pr','ÙØ§ÙŠÙ„ Ø¯ÙŠÚ¯Ø± Ø±Ø§ Ø¶Ù…ÙŠÙ…Ù‡ ÙƒÙ†ÙŠØ¯',0),(10948,305,'tr','BaÅŸka bir dosya ekleme',0),(10949,305,'pl','Inny plik',0),(10950,305,'bg','ÐŸÑ€Ð¸ÐºÐ°Ñ‡Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³ Ñ„Ð°Ð¹Ð»',0),(10951,305,'ur','Ú©Ø³ÛŒ Ø¯ÙˆØ³Ø±ÛŒ Ù…Ø³Ù„ Ù…Ù†Ø³Ù„Ú© Ú©Ø±ÛŒÚº',0),(10952,305,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(10953,305,'vi','Gá»§i KÃ¨m Há»“ SÆ¡ KhÃ¡c',0),(10954,305,'af','\'n Ander LÃªer Aangheg (\"Attach\")',0),(10955,305,'ro','AtaÅŸaÅ£i un alt fiÅŸier',0),(10956,305,'et','Lisage muu fail',0),(10957,305,'si','Drugo, priloÅ¾ite datoteko',0),(10958,305,'ba','Melampirkan File lain',0),(10959,305,'nl','Een ander bestand bijvoegen',0),(10960,305,'fi','LiitÃ¤ toinen tiedosto',0),(10961,305,'no','Legge til en annen fil',0),(10962,305,'da','VedhÃ¦fte en anden fil',0),(10963,305,'ko','ë‹¤ë¥¸ íŒŒì¼ ì—°ê²°',0),(10964,305,'he','×¦×¨×£ ×§×•×‘×¥ ××—×¨',0),(10965,305,'el','Î•Ï€Î¹ÏƒÏ…Î½Î¬ÏˆÎµÏ„Îµ Î­Î½Î± Î¬Î»Î»Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(10966,305,'zh','é™„åŠ å…¶ä»–æ–‡ä»¶\r\n',0),(10967,305,'sv','Bifoga en annan fil',0),(10968,305,'it','Allegare un altro File',0),(10969,305,'tl','',0),(10970,305,'th','&#3649;&#3609;&#3610;&#3652;&#3615;&#3621;&#3660;&#3629;&#3639;&#3656;&#3609;',0),(10971,305,'hi','à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤¨à¥à¤²à¤—à¥à¤¨ à¤•à¤°à¥‡à¤‚',0),(10972,305,'ms','Melampirkan fail yang lain',0),(10973,305,'ar','Ø¥Ø±ÙØ§Ù‚ Ù…Ù„Ù Ø¢Ø®Ø±',0),(10974,305,'fr','Joindre un autre fichier',0),(10975,305,'jp','ä»–ã?®ãƒ•ã‚¡ã‚¤ãƒ«ã‚’æ·»ä»˜ã?™ã‚‹',0),(10976,305,'pt','Anexar outro arquivo',0),(10977,305,'ru','ÐŸÑ€Ð¸ÐºÑ€ÐµÐ¿Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð¹ Ð¤Ð°Ð¹Ð»',0),(10978,305,'es','Anexar Otro Archivo',0),(10979,305,'de','FÃ¼gen Sie eine andere Datei',0),(10980,305,'en','Attach Another File',0),(10981,306,'is','',0),(10982,306,'dr','Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(10983,306,'pr','Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(10984,306,'tr','Attn',0),(10985,306,'pl','Attn',0),(10986,306,'bg','ÐÐ° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸ÐµÑ‚Ð¾ Ð½Ð°',0),(10987,306,'ur','Ø§Ù¹Ù¹Ù†',0),(10988,306,'sr','ÐÑ‚Ñ‚Ð½',0),(10989,306,'vi','ChÃº Ã',0),(10990,306,'af','Aandag',0),(10991,306,'ro','Attn',0),(10992,306,'et','Teadmiseks',0),(10993,306,'si','V vednost',0),(10994,306,'ba','Attn',0),(10995,306,'nl','T.a.v.',0),(10996,306,'fi','Yhteystiedot',0),(10997,306,'no','Attn',0),(10998,306,'da','Att.',0),(10999,306,'ko','ë‹´ë‹¹ìž',0),(11000,306,'he','×”×•×‘×œ×”',0),(11001,306,'el','ATTN',0),(11002,306,'zh','ç»åŠžäºº\r\n',0),(11003,306,'sv','Att.',0),(11004,306,'it','Attn',0),(11005,306,'tl','',0),(11006,306,'th','&#3606;&#3638;&#3591;',0),(11007,306,'hi','Attn',0),(11008,306,'ms','U.p.',0),(11009,306,'ar','Ø¹Ù†Ø§ÙŠØ©',0),(11010,306,'fr','Attn',0),(11011,306,'jp','ã?”æ‹…å½“è€…',0),(11012,306,'pt','Ã€ atenÃ§Ã£o',0),(11013,306,'ru','ÐšÐ¾Ð¼Ñƒ',0),(11014,306,'es','Attn',0),(11015,306,'de','Attn',0),(11016,306,'en','Attn',0),(11017,307,'is','',0),(11018,307,'dr','Ø¬Ù‡Øª Ù…Ù„Ø§Ø­Ø¸Ù‡',0),(11019,307,'pr','Ø¬Ù‡Øª Ù…Ù„Ø§Ø­Ø¸Ù‡',0),(11020,307,'tr','Attn iÃ§in',0),(11021,307,'pl','Kontakt do',0),(11022,307,'bg','ÐÐ° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸ÐµÑ‚Ð¾ Ð½Ð°',0),(11023,307,'ur','Ø§Ù¹Ù¹Ù† Ú©Ø±Ù†Ø§',0),(11024,307,'sr','ÐÑ‚Ñ‚Ð½ Ð´Ð°',0),(11025,307,'vi','KÃ­nh gá»­i',0),(11026,307,'af','Attn om te',0),(11027,307,'ro','Attn sÄƒ',0),(11028,307,'et','Teadmiseks et',0),(11029,307,'si','V vednost na',0),(11030,307,'ba','Attn untuk',0),(11031,307,'nl','T.a.v. te',0),(11032,307,'fi','Huom jos haluat',0),(11033,307,'no','Attn til',0),(11034,307,'da','Att. til',0),(11035,307,'ko','ë‹´ë‹¹ìžë¥¼',0),(11036,307,'he','×ž×—×œ×§×ª ×¢×œ',0),(11037,307,'el','ATTN Î Î¡ÎŸÎ£',0),(11038,307,'zh','ç»åŠžäººåˆ°\r\n',0),(11039,307,'sv','Att. till',0),(11040,307,'it','All\'attenzione di',0),(11041,307,'tl','',0),(11042,307,'th','&#3626;&#3656;&#3591;&#3606;&#3638;&#3591;',0),(11043,307,'hi','Attn à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(11044,307,'ms','U.p. untuk',0),(11045,307,'ar','Ø¹Ù†Ø§ÙŠØ© Ø¥Ù„Ù‰',0),(11046,307,'fr','Ã€ l\'attention de',0),(11047,307,'jp','å®›',0),(11048,307,'pt','Ã€ atenÃ§Ã£o de',0),(11049,307,'ru','Attn Ð½Ð°',0),(11050,307,'es','Attn a',0),(11051,307,'de','Attn',0),(11052,307,'en','Attn to',0),(11053,308,'is','',0),(11054,308,'dr','Ø¢Ú¯ÙˆØ³Øª',0),(11055,308,'pr','Ø¢Ú¯ÙˆØ³Øª',0),(11056,308,'tr','AÄŸustos',0),(11057,308,'pl','Sie',0),(11058,308,'bg','ÐÐ²Ð³ÑƒÑÑ‚',0),(11059,308,'ur','Ø§Ú¯Ø³Øª',0),(11060,308,'sr','ÐÐ²Ð³ÑƒÑÑ‚Ð°',0),(11061,308,'vi','ThÃ¡ng TÃ¡m',0),(11062,308,'af','Augustus',0),(11063,308,'ro','August',0),(11064,308,'et','August',0),(11065,308,'si','Avgust',0),(11066,308,'ba','Agustus',0),(11067,308,'nl','Augustus',0),(11068,308,'fi','Elokuu',0),(11069,308,'no','August',0),(11070,308,'da','August',0),(11071,308,'ko','8 ì›”',0),(11072,308,'he','××•×’×•×¡×˜',0),(11073,308,'el','Î‘Ï…Î³Î¿ÏÏƒÏ„Î¿Ï…',0),(11074,308,'zh','å…«æœˆ\r\n',0),(11075,308,'sv','Augusti',0),(11076,308,'it','Agosto',0),(11077,308,'tl','',0),(11078,308,'th','&#3626;&#3636;&#3591;&#3627;&#3634;&#3588;&#3617;',0),(11079,308,'hi','à¤…à¤—à¤¸à¥à¤¤',0),(11080,308,'ms','Ogos',0),(11081,308,'ar','Ø£ØºØ³Ø·Ø³',0),(11082,308,'fr','AoÃ»t',0),(11083,308,'jp','ï¼˜æœˆ',0),(11084,308,'pt','Agosto',0),(11085,308,'ru','ÐÐ²Ð³ÑƒÑÑ‚',0),(11086,308,'es','Agosto',0),(11087,308,'de','August',0),(11088,308,'en','August',0),(11089,309,'is','',0),(11090,309,'dr','Ù†ÙˆÙŠØ³Ù†Ø¯Ù‡',0),(11091,309,'pr','Ù†ÙˆÙŠØ³Ù†Ø¯Ù‡',0),(11092,309,'tr','Yazar',0),(11093,309,'pl','Autor',0),(11094,309,'bg','ÐÐ²Ñ‚Ð¾Ñ€',0),(11095,309,'ur','Ù…ØµÙ†Ù',0),(11096,309,'sr','ÐÑƒÑ‚Ð¾Ñ€',0),(11097,309,'vi','TÃ¡c Giáº£',0),(11098,309,'af','Outeur',0),(11099,309,'ro','Autor',0),(11100,309,'et','Autor',0),(11101,309,'si','Avtor',0),(11102,309,'ba','Penulis',0),(11103,309,'nl','Auteur',0),(11104,309,'fi','Kirjoittaja',0),(11105,309,'no','Forfatter',0),(11106,309,'da','Forfatter',0),(11107,309,'ko','ì €ìž',0),(11108,309,'he','×ž×—×‘×¨',0),(11109,309,'el','Î£Ï…Î³Î³ÏÎ±Ï†Î­Î±Ï‚',0),(11110,309,'zh','ä½œè€…\r\n',0),(11111,309,'sv','FÃ¶rfattare',0),(11112,309,'it','Autore',0),(11113,309,'tl','',0),(11114,309,'th','&#3612;&#3641;&#3657;&#3649;&#3605;&#3656;&#3591;',0),(11115,309,'hi','à¤²à¥‡à¤–à¤•',0),(11116,309,'ms','Penulis',0),(11117,309,'ar','Ø§Ù„ÙƒØ§ØªØ¨',0),(11118,309,'fr','Auteur',0),(11119,309,'jp','è‘—è€…',0),(11120,309,'pt','Autor',0),(11121,309,'ru','ÐÐ²Ñ‚Ð¾Ñ€',0),(11122,309,'es','Autor',0),(11123,309,'de','Autor',0),(11124,309,'en','Author',0),(11125,310,'is','',0),(11126,310,'dr','Ù†Ø¸Ø± Ù…ÙˆÙ„Ù',0),(11127,310,'pr','Ù†Ø¸Ø± Ù…ÙˆÙ„Ù',0),(11128,310,'tr','Yazar yorum',0),(11129,310,'pl','Autor komentarza',0),(11130,310,'bg','ÐÐ²Ñ‚Ð¾Ñ€ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(11131,310,'ur','Ù…ØµÙ†Ù Ú©Ø§ ØªØ¨ØµØ±Û',0),(11132,310,'sr','ÐÑƒÑ‚Ð¾Ñ€ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð°',0),(11133,310,'vi','ChÃº Giáº£i Cá»§a TÃ¡c Giáº£',0),(11134,310,'af','Outeur Kommentaar',0),(11135,310,'ro','Comentariu de autor',0),(11136,310,'et','Autor kommentaar',0),(11137,310,'si','Komentar avtor',0),(11138,310,'ba','Penulis komentar',0),(11139,310,'nl','Opmerkingen van de auteur',0),(11140,310,'fi','LÃ¤hettÃ¤jÃ¤ kommentti',0),(11141,310,'no','Forfatteren kommentar',0),(11142,310,'da','Forfatter kommentar',0),(11143,310,'ko','ìž‘ì„±ìž ì˜ê²¬',0),(11144,310,'he','×ž×—×‘×¨ ×ª×’×•×‘×”',0),(11145,310,'el','Î£Ï…Î³Î³ÏÎ±Ï†Î­Î±Ï‚ ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(11146,310,'zh','æŽˆæƒäººè¯„è®º\r\n',0),(11147,310,'sv','FÃ¶rfattare kommentar',0),(11148,310,'it','Autore commento',0),(11149,310,'tl','',0),(11150,310,'th','&#3623;&#3636;&#3592;&#3634;&#3619;&#3603;&#3660;&#3612;&#3641;&#3657;&#3649;&#3605;&#3656;&#3591;',0),(11151,310,'hi','à¤²à¥‡à¤–à¤• à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€',0),(11152,310,'ms','Komen penulis',0),(11153,310,'ar','ÙƒØ§ØªØ¨ Ø§Ù„ØªØ¹Ù„ÙŠÙ‚',0),(11154,310,'fr','Commentaire de l\'auteur',0),(11155,310,'jp','è‘—è€…ã?®ã‚³ãƒ¡ãƒ³ãƒˆ',0),(11156,310,'pt','ComentÃ¡rio do autor',0),(11157,310,'ru','ÐšÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¸ ÐÐ²Ñ‚Ð¾Ñ€Ð°',0),(11158,310,'es','Comentario de Autor',0),(11159,310,'de','Autor Kommentar',0),(11160,310,'en','Author Comment',0),(11161,311,'is','',0),(11162,311,'dr','Ø¢ÙŠØ§ Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯ÙƒØ§Ø± Ú†Ø§Ù¾ Ø´ÙˆØ¯ØŸ',0),(11163,311,'pr','Ø¢ÙŠØ§ Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯ÙƒØ§Ø± Ú†Ø§Ù¾ Ø´ÙˆØ¯ØŸ',0),(11164,311,'tr','Otomatik YazdÄ±rma depozito check?',0),(11165,311,'pl','Auto wyboru druku wpÅ‚aty?',0),(11166,311,'bg','ÐÐ²Ñ‚Ð¾ Ð¿ÐµÑ‡Ð°Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ‡ÐµÐº?',0),(11167,311,'ur','Ø¢Ù¹Ùˆ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ ÚˆÙ¾Ø§Ø²Ù¹ Ú†ÛŒÚ© Ú©Ø±ÛŒÚºØŸ',0),(11168,311,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ?',0),(11169,311,'vi','Tá»± Äá»™ng In SÃ©c Äáº·t Cá»c?',0),(11170,311,'af','Outomatiese druk deposito kontroleer?',0),(11171,311,'ro','Auto depozit de imprimare a verifica?',0),(11172,311,'et','Auto print tagatisraha sisse?',0),(11173,311,'si','Auto tiskanja vloga Äek?',0),(11174,311,'ba','Auto cetak deposit check?',0),(11175,311,'nl','Auto afdrukken storting controleren?',0),(11176,311,'fi','Tarkista tulostuksen tallettaa automaattisesti?',0),(11177,311,'no','Automatisk ut innskudd sjekk?',0),(11178,311,'da','Auto print depositum check?',0),(11179,311,'ko','ìžë™ ì¸ì‡„ ìž…ê¸ˆ í™•ì¸?',0),(11180,311,'he','××•×˜×•×ž×˜×™ ×”×“×¤×¡×” ×”×¤×™×§×“×•×Ÿ?',0),(11181,311,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Ï‡Ï‰;',0),(11182,311,'zh','è‡ªåŠ¨æ‰“å°å­˜æ¬¾æ”¯ç¥¨ï¼Ÿ\r\n',0),(11183,311,'sv','Auto print insÃ¤ttning check?',0),(11184,311,'it','Auto controllo stampa deposito?',0),(11185,311,'tl','',0),(11186,311,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;&#3627;&#3619;&#3639;&#3629;&#3652;&#3',0),(11187,311,'hi','à¤‘à¤Ÿà¥‹ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤œà¤®à¤¾ à¤šà¥‡à¤•?',0),(11188,311,'ms','Semak cetakan deposit auto?',0),(11189,311,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©ØŸ',0),(11190,311,'fr','ChÃ¨que de dÃ©pÃ´t impression auto ?',0),(11191,311,'jp','é ?é‡‘å°?åˆ‡æ‰‹ã‚’è‡ªå‹•å?°åˆ·ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(11192,311,'pt','Auto seleÃ§Ã£o de impressÃ£o do depÃ³sito?',0),(11193,311,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ°Ñ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ Ñ‡ÐµÐº?',0),(11194,311,'es','AutoimpresiÃ³n cheque de depÃ³sito',0),(11195,311,'de','Selbst drucken Einzahlung Ã¼berprÃ¼fen?',0),(11196,311,'en','Auto print deposit check?',0),(11197,312,'is','',0),(11198,312,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ  Ú¯Ø±Ø¯ Ø¢ÙˆØ±ÙŠ Ø´Ø¯Ù‡',0),(11199,312,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ  Ú¯Ø±Ø¯ Ø¢ÙˆØ±ÙŠ Ø´Ø¯Ù‡',0),(11200,312,'tr','KullanÄ±labilir monte',0),(11201,312,'pl','DostÄ™pne montowane',0),(11202,312,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¸ ÑÐ³Ð»Ð¾Ð±ÐµÐ½Ð¸',0),(11203,312,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ Ø¬Ù…Ø¹ ÛÙˆØ¦Û’',0),(11204,312,'sr','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸ Ð¾ÐºÑƒÐ¿Ð¸Ð¾',0),(11205,312,'vi','Táº­p Há»£p CÃ³ Sáºµn',0),(11206,312,'af','Aanmekaargesit is beskikbaar',0),(11207,312,'ro','Asamblate disponibile',0),(11208,312,'et','Saadaval kokku pandud',0),(11209,312,'si','Na voljo sestavil',0),(11210,312,'ba','Tersedia berkumpul',0),(11211,312,'nl','Beschikbare gemonteerd',0),(11212,312,'fi','Saatavilla koottu',0),(11213,312,'no','Tilgjengelige samlet',0),(11214,312,'da','TilgÃ¦ngelige samlet',0),(11215,312,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” ì¡°ë¦½',0),(11216,312,'he','×”×ª××¡×¤×• ×–×ž×™×Ÿ',0),(11217,312,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± ÏƒÏ…Î½Î±ÏÎ¼Î¿Î»Î¿Î³Î¿ÏÎ½Ï„Î±Î¹',0),(11218,312,'zh','å¯ç»„è£…\r\n',0),(11219,312,'sv','TillgÃ¤ngliga monteras',0),(11220,312,'it','Disponibile montato',0),(11221,312,'tl','',0),(11222,312,'th','&#3619;&#3623;&#3610;&#3619;&#3623;&#3617;&#3648;&#3607;&#3656;&#3634;&#3607;&#3637;&#3656;&#3592;&#3632;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;',0),(11223,312,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤‡à¤•à¤Ÿà¥à¤ à¥‡',0),(11224,312,'ms','Dipasang disediakan',0),(11225,312,'ar','ØªØ¬Ù…ÙŠØ¹ Ù…ØªÙˆÙØ±Ø©',0),(11226,312,'fr','AssemblÃ© disponible',0),(11227,312,'jp','Available assembled',0),(11228,312,'pt','DisponÃ­vel montado',0),(11229,312,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ ÑÐ¾Ð±Ñ€Ð°Ð»',0),(11230,312,'es','Disponible Armado',0),(11231,312,'de','VerfÃ¼gbare montiert',0),(11232,312,'en','Available Assembled',0),(11233,313,'is','',0),(11234,313,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ†',0),(11235,313,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ†',0),(11236,313,'tr','Ortalama',0),(11237,313,'pl','Åšrednia',0),(11238,313,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð¾',0),(11239,313,'ur','Ø§ÙˆØ³Ø·',0),(11240,313,'sr','ÐŸÑ€Ð¾ÑÐµÐº',0),(11241,313,'vi','Trung BÃ¬nh',0),(11242,313,'af','Gemiddelde',0),(11243,313,'ro','Medie',0),(11244,313,'et','Keskmine',0),(11245,313,'si','PovpreÄje',0),(11246,313,'ba','Rata-rata',0),(11247,313,'nl','Gemiddelde',0),(11248,313,'fi','Keskiarvo',0),(11249,313,'no','Gjennomsnitt',0),(11250,313,'da','Gennemsnit',0),(11251,313,'ko','í‰ê· ',0),(11252,313,'he','×ž×ž×•×¦×¢',0),(11253,313,'el','ÎœÎ­ÏƒÎ¿Ï‚ ÏŒÏÎ¿Ï‚',0),(11254,313,'zh','å¹³å‡\r\n',0),(11255,313,'sv','Genomsnitt',0),(11256,313,'it','Media',0),(11257,313,'tl','',0),(11258,313,'th','&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;',0),(11259,313,'hi','à¤”à¤¸à¤¤',0),(11260,313,'ms','Purata',0),(11261,313,'ar','ÙÙŠ Ø§Ù„Ù…ØªÙˆØ³Ø·',0),(11262,313,'fr','Moyenne',0),(11263,313,'jp','å¹³å?‡',0),(11264,313,'pt','MÃ©dia',0),(11265,313,'ru','Ð’ ÑÑ€ÐµÐ´Ð½ÐµÐ¼',0),(11266,313,'es','Promedio',0),(11267,313,'de','Durchschnitt',0),(11268,313,'en','Average',0),(11269,314,'is','',0),(11270,314,'dr','Ø¯Ø±ØµØ¯ Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(11271,314,'pr','Ø¯Ø±ØµØ¯ Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(11272,314,'tr','AVG biÃ§imlendirme %',0),(11273,314,'pl','AVG znacznikÃ³w %',0),(11274,314,'bg','AVG ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð° %',0),(11275,314,'ur','Ø§ÙˆØ³Ø· Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­ %',0),(11276,314,'sr','ÐÐ²Ð³ Ð½Ð°Ð·Ð½Ð°ÐºÐµ %',0),(11277,314,'vi','% Cá»™ng ThÃªm Trung BÃ¬nh',0),(11278,314,'af','Avg Markup %',0),(11279,314,'ro','AVG Markup %',0),(11280,314,'et','AVG lisakulude %',0),(11281,314,'si','AVG Markup %',0),(11282,314,'ba','AVG Markup %',0),(11283,314,'nl','AVG Markup %',0),(11284,314,'fi','AVG lisÃ¤ys %',0),(11285,314,'no','AVG Markup %',0),(11286,314,'da','AVG Markup %',0),(11287,314,'ko','í‰ê·  íƒœê·¸ %',0),(11288,314,'he','Avg ×¡×™×ž×•×Ÿ %',0),(11289,314,'el','AVG Markup %',0),(11290,314,'zh','å¹³å‡æ ‡è®°ï¼…\r\n',0),(11291,314,'sv','AVG Markup %',0),(11292,314,'it','AVG Markup %',0),(11293,314,'tl','',0),(11294,314,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;',0),(11295,314,'hi','à¤”à¤¸à¤¤ à¤®à¤¾à¤°à¥à¤•à¤…à¤ª %',0),(11296,314,'ms','Penanda AVG %',0),(11297,314,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„Ø²ÙŠØ§Ø¯Ø© %',0),(11298,314,'fr','AVG balisage %',0),(11299,314,'jp','å¹³å?‡å€¤ä¸Šã?’çŽ‡',0),(11300,314,'pt','AVG marcaÃ§Ã£o %',0),(11301,314,'ru','AVG Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸ %',0),(11302,314,'es','Encarecimiento Promedia %',0),(11303,314,'de','AVG Markup %',0),(11304,314,'en','Avg Markup %',0),(11305,315,'is','',0),(11306,315,'dr','Ø¨Ø±Ú¯Ø´Øª',0),(11307,315,'pr','Ø¨Ø±Ú¯Ø´Øª',0),(11308,315,'tr','Geri',0),(11309,315,'pl','Wstecz',0),(11310,315,'bg','ÐÐ°Ð·Ð°Ð´',0),(11311,315,'ur','Ù¾ÛŒÚ†Ú¾Û’ Ø¬Ø§Ø¡ÛŒÚº',0),(11312,315,'sr','ÐÐ°Ð·Ð°Ð´',0),(11313,315,'vi','Quay Láº¡i',0),(11314,315,'af','Terug',0),(11315,315,'ro','Inapoi',0),(11316,315,'et','Tagasi',0),(11317,315,'si','Nazaj',0),(11318,315,'ba','Kembali',0),(11319,315,'nl','Terug',0),(11320,315,'fi','Takaisin',0),(11321,315,'no','Tilbake',0),(11322,315,'da','Tilbage',0),(11323,315,'ko','ë’¤ë¡œ',0),(11324,315,'he','×—×–×¨×”',0),(11325,315,'el','Î Î¯ÏƒÏ‰',0),(11326,315,'zh','è¿”å›ž\r\n',0),(11327,315,'sv','Tillbaka',0),(11328,315,'it','Indietro',0),(11329,315,'tl','',0),(11330,315,'th','&#3585;&#3621;&#3633;&#3610;',0),(11331,315,'hi','à¤ªà¥€à¤ ',0),(11332,315,'ms','Belakang',0),(11333,315,'ar','Ø§Ù„Ø±Ø¬ÙˆØ¹',0),(11334,315,'fr','Retour',0),(11335,315,'jp','æˆ»ã‚‹',0),(11336,315,'pt','Voltar',0),(11337,315,'ru','ÐÐ°Ð·Ð°Ð´',0),(11338,315,'es','AtrÃ¡s',0),(11339,315,'de','ZurÃ¼ck',0),(11340,315,'en','Back',0),(11341,316,'is','',0),(11342,316,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ù…Ù†Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª',0),(11343,316,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ù…Ù†Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª',0),(11344,316,'tr','Admin menÃ¼sÃ¼ne geri',0),(11345,316,'pl','PowrÃ³t do menu admina',0),(11346,316,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÐºÑŠÐ¼ Ð¼ÐµÐ½ÑŽÑ‚Ð¾ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€',0),(11347,316,'ur','Ø§ÛŒÚˆÙ…Ù† Ù…ÛŒÙ†ÛŒÙˆ ÙˆØ§Ù¾Ø³',0),(11348,316,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¼ÐµÐ½Ð¸ ÐÐ´Ð¼Ð¸Ð½',0),(11349,316,'vi','Quay Láº¡i TrÃ¬nh ÄÆ¡n Quáº£n Trá»‹',0),(11350,316,'af','Terug na Admin menu',0),(11351,316,'ro','Inapoi la meniu - Administrare',0),(11352,316,'et','Tagasi haldamise menÃ¼Ã¼sse',0),(11353,316,'si','Nazaj v Admin meniju',0),(11354,316,'ba','Kembali ke Admin menu',0),(11355,316,'nl','Terug naar adminmenu',0),(11356,316,'fi','Palaa Admin valikon',0),(11357,316,'no','Tilbake til Admin-menyen',0),(11358,316,'da','Tilbage til admin.menu',0),(11359,316,'ko','ê´€ë¦¬ìž ë©”ë‰´ ëŒì•„ê°€ê¸°',0),(11360,316,'he','×—×–×¨×” ×œ×ª×¤×¨×™×˜ Admin',0),(11361,316,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î¿ Î¼ÎµÎ½Î¿Ï Admin',0),(11362,316,'zh','è¿”å›žç®¡ç†èœå•\r\n',0),(11363,316,'sv','Tillbaka till Admin-menyn',0),(11364,316,'it','Torna al menÃ¹ di amministrazione',0),(11365,316,'tl','',0),(11366,316,'th','&#3585;&#3621;&#3633;&#3610;&#3626;&#3641;&#3656;&#3648;&#3617;&#3609;&#3641;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3619;&#3632;&#3610;&#3610;',0),(11367,316,'hi','à¤µà¤¾à¤ªà¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤®à¥‡à¤¨à¥‚',0),(11368,316,'ms','Kembali ke Admin menu',0),(11369,316,'ar','Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ø´Ø±Ù',0),(11370,316,'fr','Retour au menu Admin',0),(11371,316,'jp','ç®¡ç?†ãƒ¡ãƒ‹ãƒ¥ãƒ¼ã?¸æˆ»ã‚‹',0),(11372,316,'pt','Voltar ao menu de Admin',0),(11373,316,'ru','ÐÐ°Ð·Ð°Ð´ Ðº ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°Ð¼ Ð¼ÐµÐ½ÑŽ',0),(11374,316,'es','Regresar a menus de Admin',0),(11375,316,'de','ZurÃ¼ck zu Admin menu',0),(11376,316,'en','Back to Admin menu',0),(11377,317,'is','',0),(11378,317,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¬Ù‡Øª Ø§Ù†ØªØ®Ø§Ø¨ Ù†ÙˆØ¹ Ø¯ÙŠÚ¯Ø± Ø­Ø³Ø§Ø¨',0),(11379,317,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¬Ù‡Øª Ø§Ù†ØªØ®Ø§Ø¨ Ù†ÙˆØ¹ Ø¯ÙŠÚ¯Ø± Ø­Ø³Ø§Ø¨',0),(11380,317,'tr','Geri farklÄ± hesap tÃ¼rÃ¼ seÃ§mek iÃ§in',0),(11381,317,'pl','PowrÃ³t do wyboru innego typu konta',0),(11382,317,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾, Ð·Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ€Ð°Ð·Ð»Ð¸Ñ‡ÐµÐ½ Ñ‚Ð¸Ð¿ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(11383,317,'ur','Ù…Ø®ØªÙ„Ù Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù‚Ø³Ù… Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù„ÛŒÛ’ ÙˆØ§Ù¾Ø³',0),(11384,317,'sr','ÐÐ°Ð·Ð°Ð´ Ð´Ð° Ð¾Ð´Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð¸Ñ‚Ðµ Ð²Ñ€ÑÑ‚Ðµ ÐºÐ¾Ð½Ñ‚Ð°',0),(11385,317,'vi','Quay láº¡i lá»±a chá»n Loáº¡i TK khÃ¡c nhau',0),(11386,317,'af','Terug na kies ander Rekening tipe',0),(11387,317,'ro','ÃŽnapoi pentru a alege alt tip de cont',0),(11388,317,'et','Tagasi valida erinevate kontotÃ¼Ã¼p',0),(11389,317,'si','Nazaj, da izberejo razliÄne vrste raÄuna',0),(11390,317,'ba','Kembali ke memilih jenis Account yang berbeda',0),(11391,317,'nl','Terug naar verschillende accounttype kiezen',0),(11392,317,'fi','Takaisin Valitse eri tilityyppi',0),(11393,317,'no','Tilbake til Velg annen kontotype',0),(11394,317,'da','Tilbage til at vÃ¦lge forskellige kontotype',0),(11395,317,'ko','ë‹¤ë¥¸ ê³„ì • ìœ í˜• ì„ íƒìœ¼ë¡œ ëŒì•„ê°€ê¸°',0),(11396,317,'he','×—×–×¨×” ×œ×‘×—×™×¨×ª ×¡×•×’ ×—×©×‘×•×Ÿ ×©×•× ×”',0),(11397,317,'el','Î Î¯ÏƒÏ‰ Î³Î¹Î± Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÏŒ Ï„ÏÏ€Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(11398,317,'zh','è¿”å›žé€‰æ‹©ä¸åŒçš„è´¦æˆ·ç±»åž‹\r\n',0),(11399,317,'sv','Tillbaka fÃ¶r att vÃ¤lja olika typ av konto',0),(11400,317,'it','Indietro per scegliere un diverso tipo di profilo',0),(11401,317,'tl','',0),(11402,317,'th','&#3585;&#3621;&#3633;&#3610;&#3652;&#3611;&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3623;&#3634;&#3617;&#3649;&#3605;&#3585;&#3605;&#3656;&#3634;&#3591;&#3586;&#3629;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(11403,317,'hi','à¤…à¤²à¤— à¤…à¤²à¤— à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤ªà¤¸',0),(11404,317,'ms','Belakang untuk memilih jenis akaun yang berbeza',0),(11405,317,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ø®ØªÙŠØ§Ø± Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ù…Ø®ØªÙ„Ù',0),(11406,317,'fr','Retour Ã  choisir diffÃ©rent type de compte',0),(11407,317,'jp','æˆ»ã?£ã?¦åˆ¥ã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—ã‚’é?¸æŠžã?™ã‚‹',0),(11408,317,'pt','Para escolher o tipo de conta diferente',0),(11409,317,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ñ‚Ð¸Ð¿ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(11410,317,'es','AtrÃ¡s para escoger un diferente tipo de Cuenta',0),(11411,317,'de','ZurÃ¼ck zu verschiedenen Kontotyp auswÃ¤hlen',0),(11412,317,'en','Back to choose different Account type',0),(11413,318,'is','',0),(11414,318,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¬Ù‡Øª   Ø§Ù†ØªØ®Ø§Ø¨  Ù†Ø§Ù… Ø¯ÙŠÚ¯Ø± ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(11415,318,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¬Ù‡Øª   Ø§Ù†ØªØ®Ø§Ø¨  Ù†Ø§Ù… Ø¯ÙŠÚ¯Ø± ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(11416,318,'tr','Geri farklÄ± satÄ±cÄ± adÄ± seÃ§mek iÃ§in',0),(11417,318,'pl','PowrÃ³t do wyboru rÃ³Å¼ne nazwy sprzedawca',0),(11418,318,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾, Ð·Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¾ Ð¸Ð¼Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡',0),(11419,318,'ur','Ø¨Ù†Ø§Ú©Ø± Ú©Û’ Ù…Ø®ØªÙ„Ù Ù†Ø§Ù… Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù„ÛŒÛ’ ÙˆØ§Ù¾Ø³',0),(11420,318,'sr','ÐÐ°Ð·Ð°Ð´ Ñƒ ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¾ Ð¸Ð¼Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(11421,318,'vi','Quay láº¡i lá»±a chá»n tÃªn nhÃ¢n viÃªn kinh doanh khÃ¡c nhau',0),(11422,318,'af','Terug na kies ander Verkoopspersoon Naam',0),(11423,318,'ro','ÃŽnapoi pentru a alege alt nume vanzator',0),(11424,318,'et','Naasmiseks valige muu mÃ¼Ã¼ja nimi',0),(11425,318,'si','Nazaj na izberite drugaÄno ime prodajalec',0),(11426,318,'ba','Kembali ke memilih nama Salesman berbeda',0),(11427,318,'nl','Terug naar kiezen voor andere verkoper naam',0),(11428,318,'fi','Takaisin Valitse toinen myyjÃ¤ nimi',0),(11429,318,'no','Tilbake til Velg annet selger navn',0),(11430,318,'da','Tilbage til at vÃ¦lge forskellige sÃ¦lger navn',0),(11431,318,'ko','ë‹¤ë¥¸ ì„¸ì¼ì¦ˆ ë§¨ ì´ë¦„ì„ ì„ íƒìœ¼ë¡œ ëŒì•„ê°€ê¸°',0),(11432,318,'he','×—×–×¨×” ×œ×‘×—×™×¨×ª ×©× ×ž×•×›×¨ ××—×¨',0),(11433,318,'el','Î Î¯ÏƒÏ‰ Î³Î¹Î± Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÏŒ ÏŒÎ½Î¿Î¼Î± Ï€Ï‰Î»Î·Ï„Î®',0),(11434,318,'zh','è¿”å›žé€‰æ‹©ä¸åŒçš„æŽ¨é”€å‘˜çš„åå­—\r\n',0),(11435,318,'sv','Tillbaka till vÃ¤lja olika sÃ¤ljare namn',0),(11436,318,'it','Indietro per scegliere un diverso nome dell\'agente vendite',0),(11437,318,'tl','',0),(11438,318,'th','&#3585;&#3621;&#3633;&#3610;&#3652;&#3611;&#3648;&#3621;&#3639;&#3629;&#3585;&#3594;&#3639;&#3656;&#3629;&#3588;&#3609;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3649;&#3605;&#3585;&#3605;&#3656;&#3634;&#3591;&#3585;&#3633;&#3609;',0),(11439,318,'hi','à¤µà¤¾à¤ªà¤¸ à¤µà¤¿à¤­à¤¿à¤¨à¥à¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤¨à¤¾à¤® à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(11440,318,'ms','Kembali kepada memilih nama jurujual lain',0),(11441,318,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ø®ØªÙŠØ§Ø± Ø§Ø³Ù… Ø¨Ø§Ø¦Ø¹ Ù…Ø®ØªÙ„Ù',0),(11442,318,'fr','Retour Ã  choisir le nom de vendeur diffÃ©rent',0),(11443,318,'jp','æˆ»ã?£ã?¦åˆ¥ã?®ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…å??ã‚’é?¸æŠžã?™ã‚‹',0),(11444,318,'pt','Para escolher o nome do vendedor diferente',0),(11445,318,'ru','ÐÐ°Ð·Ð°Ð´ Ð´Ð»Ñ Ð²Ñ‹Ð±Ð¾Ñ€Ð° Ð´Ñ€ÑƒÐ³Ð¾Ð³Ð¾ Ð¸Ð¼ÐµÐ½Ð¸ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(11446,318,'es','AtrÃ¡s para escoger un diferente nombre de Vendedor',0),(11447,318,'de','ZurÃ¼ck zu anderen VerkÃ¤ufer Namen wÃ¤hlen',0),(11448,318,'en','Back to choose different Salesman name',0),(11449,319,'is','',0),(11450,319,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡  ÙˆÙŠØ±Ø§ÙŠØ´',0),(11451,319,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡  ÙˆÙŠØ±Ø§ÙŠØ´',0),(11452,319,'tr','Yeniden dÃ¼zenleme',0),(11453,319,'pl','WrÃ³Ä‡ do edycji',0),(11454,319,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÐºÑŠÐ¼ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(11455,319,'ur','ÙˆØ§Ù¾Ø³ ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(11456,319,'sr','ÐÐ°Ð·Ð°Ð´ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(11457,319,'vi','Quay Láº¡i Chá»‰nh Sá»­a',0),(11458,319,'af','Terug na Redigeer',0),(11459,319,'ro','ÃŽnapoi la Edit.',0),(11460,319,'et','Tagasi muutma',0),(11461,319,'si','Nazaj na urejanje',0),(11462,319,'ba','Kembali ke Edit',0),(11463,319,'nl','Terug naar bewerken',0),(11464,319,'fi','Palaa Muokkaa',0),(11465,319,'no','Tilbake til Rediger',0),(11466,319,'da','Tilbage til at redigere',0),(11467,319,'ko','ë‹¤ì‹œ íŽ¸ì§‘ í•˜ë ¤ë©´',0),(11468,319,'he','×—×–×¨×” ×›×“×™ ×œ×¢×¨×•×š',0),(11469,319,'el','Î Î¯ÏƒÏ‰ Î³Î¹Î± Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(11470,319,'zh','è¿”å›žç¼–è¾‘\r\n',0),(11471,319,'sv','Tillbaka till Edit.',0),(11472,319,'it','Indietro per modificare',0),(11473,319,'tl','',0),(11474,319,'th','&#3585;&#3621;&#3633;&#3610;&#3652;&#3611;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(11475,319,'hi','à¤µà¤¾à¤ªà¤¸ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(11476,319,'ms','Kembali untuk mengedit',0),(11477,319,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ ØªØ­Ø±ÙŠØ±',0),(11478,319,'fr','Retour Ã  Edit',0),(11479,319,'jp','ç·¨é›†ã?¸æˆ»ã‚‹',0),(11480,319,'pt','Volta para editar',0),(11481,319,'ru','ÐÐ°Ð·Ð°Ð´ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(11482,319,'es','AtrÃ¡s para Editar',0),(11483,319,'de','ZurÃ¼ck zu bearbeiten',0),(11484,319,'en','Back to Edit',0),(11485,320,'is','',0),(11486,320,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÙŠ ',0),(11487,320,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÙŠ ',0),(11488,320,'tr','Posta kutusuna geri',0),(11489,320,'pl','WrÃ³Ä‡ do skrzynki pocztowej',0),(11490,320,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÐºÑŠÐ¼ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ° ÐºÑƒÑ‚Ð¸Ñ',0),(11491,320,'ur','Ù…ÛŒÙ„ Ø¨Ø§Ú©Ø³ Ù¾Ø± ÙˆØ§Ù¾Ø³',0),(11492,320,'sr','ÐÐ°Ð·Ð°Ð´ Ñƒ Ð¿Ð¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¾ ÑÐ°Ð½Ð´ÑƒÑ‡Ðµ',0),(11493,320,'vi','Quay láº¡i há»™p thÆ°',0),(11494,320,'af','Terug na Posbus',0),(11495,320,'ro','ÃŽnapoi la cutia poÅŸtalÄƒ',0),(11496,320,'et','Aastasse postkasti',0),(11497,320,'si','Nazaj v poÅ¡tni nabiralnik',0),(11498,320,'ba','Kembali ke kotak pesan',0),(11499,320,'nl','Terug naar Mailbox',0),(11500,320,'fi','Palaa postilaatikkoon',0),(11501,320,'no','Tilbake til postboksen',0),(11502,320,'da','Tilbage til postkasse',0),(11503,320,'ko','ì‚¬ì„œí•¨ì„ ë‹¤ì‹œ',0),(11504,320,'he','×‘×—×–×¨×” ×œ×ª×™×‘×ª ×”×“×•××¨',0),(11505,320,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î¿ Î³ÏÎ±Î¼Î¼Î±Ï„Î¿ÎºÎ¹Î²ÏŽÏ„Î¹Î¿',0),(11506,320,'zh','è¿”å›žåˆ°é‚®ç®±\r\n',0),(11507,320,'sv','Tillbaka till brevlÃ¥dan',0),(11508,320,'it','Torna alla casella di posta',0),(11509,320,'tl','',0),(11510,320,'th','&#3585;&#3621;&#3633;&#3610;&#3652;&#3611;&#3626;&#3641;&#3656;&#3585;&#3621;&#3656;&#3629;&#3591;&#3592;&#3604;&#3627;&#3617;&#3634;&#3618;',0),(11511,320,'hi','à¤®à¥‡à¤²à¤¬à¥‰à¤•à¥à¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤ªà¤¸',0),(11512,320,'ms','Kembali ke peti mel',0),(11513,320,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø¹Ù„Ø¨Ø© Ø§Ù„Ø¨Ø±ÙŠØ¯',0),(11514,320,'fr','Retour Ã  la boÃ®te aux lettres',0),(11515,320,'jp','ãƒ¡ãƒ¼ãƒ«ãƒœãƒƒã‚¯ã‚¹ã?¸æˆ»ã‚‹',0),(11516,320,'pt','Voltar Ã  caixa de correio',0),(11517,320,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ Ð² ÑÑ‰Ð¸Ðº',0),(11518,320,'es','AtrÃ¡s al BuzÃ³n',0),(11519,320,'de','ZurÃ¼ck zur Mailbox',0),(11520,320,'en','Back to Mailbox',0),(11521,321,'is','',0),(11522,321,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ ',0),(11523,321,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ ',0),(11524,321,'tr','Fiziksel stok',0),(11525,321,'pl','PowrÃ³t do spisu',0),(11526,321,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÐºÑŠÐ¼ Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(11527,321,'ur','Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ùˆ ÙˆØ§Ù¾Ø³',0),(11528,321,'sr','ÐÐ°Ñ‚Ñ€Ð°Ð³ Ð½Ð° Ð¿Ð¾Ð¿Ð¸Ñ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(11529,321,'vi','Quay láº¡i hÃ ng trong kho thá»±c táº¿',0),(11530,321,'af','Terug na Fisiese Voorraad',0),(11531,321,'ro','ÃŽnapoi la inventar fizic',0),(11532,321,'et','Aastasse inventuur',0),(11533,321,'si','Nazaj na popisa zaloge',0),(11534,321,'ba','Kembali ke persediaan fisik',0),(11535,321,'nl','Terug naar fysieke inventaris',0),(11536,321,'fi','Palaa inventointi',0),(11537,321,'no','Tilbake til vareopptelling',0),(11538,321,'da','Tilbage til fysisk lager',0),(11539,321,'ko','ì‹¤ì œ ìž¬ê³ ë¥¼ ë‹¤ì‹œ',0),(11540,321,'he','×—×–×¨×” ×œ×ž×œ××™ ×¤×™×–×™',0),(11541,321,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î· Ï†Ï…ÏƒÎ¹ÎºÎ® Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(11542,321,'zh','è¿”å›žåº“å­˜ç›˜ç‚¹\r\n',0),(11543,321,'sv','Tillbaka till inventering',0),(11544,321,'it','Torna all\'inventario fisico',0),(11545,321,'tl','',0),(11546,321,'th','&#3585;&#3621;&#3633;&#3610;&#3626;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3634;&#3591;&#3585;&#3634;&#3618;&#3616;&#3634;&#3614;',0),(11547,321,'hi','à¤­à¥Œà¤¤à¤¿à¤• à¤¸à¥‚à¤šà¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤ªà¤¸',0),(11548,321,'ms','Semula inventori fizikal',0),(11549,321,'ar','Ø§Ù„Ø±Ø¬ÙˆØ¹ Ø¥Ù„Ù‰ Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(11550,321,'fr','Retour Ã  l\'inventaire physique',0),(11551,321,'jp','æœŸæœ«æ£šå?¸ã?¸æˆ»ã‚‹',0),(11552,321,'pt','Volta para o inventÃ¡rio fÃ­sico',0),(11553,321,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(11554,321,'es','AtrÃ¡s para el Inventario FÃ­sico',0),(11555,321,'de','ZurÃ¼ck zur Inventur',0),(11556,321,'en','Back to Physical Inventory',0),(11557,322,'is','',0),(11558,322,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ ',0),(11559,322,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ ',0),(11560,322,'tr','Fiziksel stok',0),(11561,322,'pl','PowrÃ³t do spisu',0),(11562,322,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÐºÑŠÐ¼ Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(11563,322,'ur','Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ùˆ ÙˆØ§Ù¾Ø³',0),(11564,322,'sr','ÐÐ°Ñ‚Ñ€Ð°Ð³ Ð½Ð° Ð¿Ð¾Ð¿Ð¸Ñ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(11565,322,'vi','Quay láº¡i hÃ ng trong kho thá»±c táº¿',0),(11566,322,'af','Terug na Fisiese Inventaris',0),(11567,322,'ro','ÃŽnapoi la inventar fizic',0),(11568,322,'et','Aastasse inventuur',0),(11569,322,'si','Nazaj na popisa zaloge',0),(11570,322,'ba','Kembali ke persediaan fisik',0),(11571,322,'nl','Terug naar fysieke inventaris',0),(11572,322,'fi','Palaa inventointi',0),(11573,322,'no','Tilbake til vareopptelling',0),(11574,322,'da','Tilbage til fysisk lager',0),(11575,322,'ko','ì‹¤ì œ ìž¬ê³ ë¥¼ ë‹¤ì‹œ',0),(11576,322,'he','×—×–×¨×” ×œ×ž×œ××™ ×¤×™×–×™',0),(11577,322,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î· Ï†Ï…ÏƒÎ¹ÎºÎ® Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(11578,322,'zh','è¿”å›žåº“å­˜ç›˜ç‚¹\r\n',0),(11579,322,'sv','Tillbaka till inventering',0),(11580,322,'it','Torna all\'inventario fisico',0),(11581,322,'tl','',0),(11582,322,'th','&#3585;&#3621;&#3633;&#3610;&#3626;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3634;&#3591;&#3585;&#3634;&#3618;&#3616;&#3634;&#3614;',0),(11583,322,'hi','à¤­à¥Œà¤¤à¤¿à¤• à¤¸à¥‚à¤šà¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤ªà¤¸',0),(11584,322,'ms','Semula inventori fizikal',0),(11585,322,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„ÙØ¹Ù„ÙŠ',0),(11586,322,'fr','Retour Ã  l\'inventaire physique',0),(11587,322,'jp','æœŸæœ«æ£šå?¸ã?¸æˆ»ã‚‹',0),(11588,322,'pt','Volta para o inventÃ¡rio fÃ­sico',0),(11589,322,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(11590,322,'es','AtrÃ¡s al Inventario FÃ­sico',0),(11591,322,'de','ZurÃ¼ck zur Inventur',0),(11592,322,'en','Back to Physical Inventory',0),(11593,323,'is','',0),(11594,323,'dr','Bad locale.  Ù…Ø­Ù„ Ù„Ø§ ÙˆØµÙˆÙ„ ',0),(11595,323,'pr','Bad locale.  Ù…Ø­Ù„ Ù„Ø§ ÙˆØµÙˆÙ„ ',0),(11596,323,'tr','KÃ¶tÃ¼ yerel.',0),(11597,323,'pl','ZÅ‚e ustawienia regionalne.',0),(11598,323,'bg','Ð›Ð¾ÑˆÐ° ÐµÐ·Ð¸ÐºÐ¾Ð²Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð»Ð¸Ð²Ð°.',0),(11599,323,'ur','Ø¨Ø±Ø§ Ù…Ù‚Ø§Ù…ÛŒ.',0),(11600,323,'sr','Ð›Ð¾Ñˆ Ð»Ð¾ÐºÐ°Ð»Ð½Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´.',0),(11601,323,'vi','Äá»‹a phÆ°Æ¡ng xáº¥u',0),(11602,323,'af','Slegte lokaliteit.',0),(11603,323,'ro','Localizare rÄƒu.',0),(11604,323,'et','Vale asukoht.',0),(11605,323,'si','Neveljavna podroÄna nastavitev.',0),(11606,323,'ba','Buruk lokal.',0),(11607,323,'nl','Slechte locale.',0),(11608,323,'fi','Virheellinen maa-asetus.',0),(11609,323,'no','DÃ¥rlig locale.',0),(11610,323,'da','DÃ¥rlig landestandard.',0),(11611,323,'ko','ë‚˜ìœ ë¡œìº˜ìž…ë‹ˆë‹¤.',0),(11612,323,'he','××–×•×¨ ×¨×¢.',0),(11613,323,'el','ÎšÎ±ÎºÎ® Ï„Î¿Ï€Î¹ÎºÎ­Ï‚ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚.',0),(11614,323,'zh','ä¸è‰¯çŽ¯å¢ƒã€‚\r\n',0),(11615,323,'sv','DÃ¥lig locale.',0),(11616,323,'it','Cattive impostazioni locali.',0),(11617,323,'tl','',0),(11618,323,'th','&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3604;&#3648;&#3627;&#3605;&#3640;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(11619,323,'hi','à¤¬à¥à¤°à¤¾ à¤²à¥‹à¤•à¥‡à¤²à¥¤',0),(11620,323,'ms','Buruk tempatan.',0),(11621,323,'ar','Ù„ØºØ© Ø³ÙŠØ¦Ø©.',0),(11622,323,'fr','Mauvais paramÃ¨tres rÃ©gionaux.',0),(11623,323,'jp','ä¸?é?©åˆ‡ã?ªå ´æ‰€',0),(11624,323,'pt','Localidade ruim.',0),(11625,323,'ru','ÐŸÐ»Ð¾Ñ…Ð¾Ð¹ ÑÐ·Ñ‹Ðº.',0),(11626,323,'es','Mala UbicaciÃ³n',0),(11627,323,'de','Schlechte Gebietsschema.',0),(11628,323,'en','Bad locale.',0),(11629,324,'is','',0),(11630,324,'dr','Bad Tax Type Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ù„Ø§ ÙˆØµÙˆÙ„  ',0),(11631,324,'pr','Bad Tax Type Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ù„Ø§ ÙˆØµÙˆÙ„  ',0),(11632,324,'tr','KÃ¶tÃ¼ vergi tÃ¼rÃ¼',0),(11633,324,'pl','Typ podatku zÅ‚y',0),(11634,324,'bg','Ð›Ð¾ÑˆÐ¸Ñ‚Ðµ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ñ‚Ð¸Ð¿',0),(11635,324,'ur','Ø¨Ø±Û’ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù…',0),(11636,324,'sr','Ð’Ñ€ÑÑ‚Ð° Ð»Ð¾ÑˆÐµ ÐŸÐ”Ð’-Ð°',0),(11637,324,'vi','Loáº¡i thuáº¿ xáº¥u',0),(11638,324,'af','Slegte belasting tipe',0),(11639,324,'ro','Tipul rÄƒu fiscale',0),(11640,324,'et','Halb maksu liik',0),(11641,324,'si','Slabo izstavljenih',0),(11642,324,'ba','Jenis pajak yang buruk',0),(11643,324,'nl','Slechte belasting Type',0),(11644,324,'fi','Huono ALV-tyyppi',0),(11645,324,'no','DÃ¥rlig skatt Type',0),(11646,324,'da','DÃ¥rlig afgiftstype.',0),(11647,324,'ko','ë‚˜ìœ ì„¸ê¸ˆ ì¢…ë¥˜',0),(11648,324,'he','×¡×•×’ ×”×ž×¡ ×¨×¢',0),(11649,324,'el','Î¤ÏÏ€Î¿Ï‚ ÎºÎ±ÎºÏŒ Î¦Î Î‘',0),(11650,324,'zh','åç¨Žç§\r\n',0),(11651,324,'sv','Typ av dÃ¥lig skatte',0),(11652,324,'it','Tipo fiscale male',0),(11653,324,'tl','',0),(11654,324,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(11655,324,'hi','à¤¬à¥à¤°à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(11656,324,'ms','Jenis cukai yang buruk',0),(11657,324,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø³ÙŠØ¦Ø©',0),(11658,324,'fr','Type de taxe mauvais',0),(11659,324,'jp','æ‚ªç¨Žã‚¿ã‚¤ãƒ—',0),(11660,324,'pt','Tipo de imposto ruim',0),(11661,324,'ru','Ð¢Ð¸Ð¿ Ð‘Ð°Ð´ Ð½Ð°Ð»Ð¾Ð³',0),(11662,324,'es','Mal Tipo de Impuestos',0),(11663,324,'de','Schlechte Steuerart',0),(11664,324,'en','Bad Tax Type',0),(11665,325,'is','',0),(11666,325,'dr','Ù…Ø§Ù†Ø¯Ù‡',0),(11667,325,'pr','Ù…Ø§Ù†Ø¯Ù‡',0),(11668,325,'tr','Denge',0),(11669,325,'pl','Bilans',0),(11670,325,'bg','Ð‘Ð°Ð»Ð°Ð½Ñ',0),(11671,325,'ur','ØªÙˆØ§Ø²Ù†',0),(11672,325,'sr','Ð¡Ð°Ð»Ð´Ð¾',0),(11673,325,'vi','Sá»‘ dÆ°',0),(11674,325,'af','Balans',0),(11675,325,'ro','Echilibru',0),(11676,325,'et','Saldo',0),(11677,325,'si','Ravnovesje',0),(11678,325,'ba','Keseimbangan',0),(11679,325,'nl','Saldo',0),(11680,325,'fi','Tasapaino',0),(11681,325,'no','Balanse',0),(11682,325,'da','Balance',0),(11683,325,'ko','ê· í˜•',0),(11684,325,'he','×ž××–×Ÿ',0),(11685,325,'el','Î™ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±',0),(11686,325,'zh','ä½™é¢',0),(11687,325,'sv','Balans',0),(11688,325,'it','Equilibrio',0),(11689,325,'tl','',0),(11690,325,'th','&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(11691,325,'hi','à¤¸à¤‚à¤¤à¥à¤²à¤¨',0),(11692,325,'ms','Baki',0),(11693,325,'ar','Ø§Ù„Ø±ØµÙŠØ¯',0),(11694,325,'fr','Solde',0),(11695,325,'jp','å·®å¼•æ®‹é«˜',0),(11696,325,'pt','EquilÃ­brio',0),(11697,325,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ',0),(11698,325,'es','Balance',0),(11699,325,'de','Balance',0),(11700,325,'en','Balance',0),(11701,326,'is','',0),(11702,326,'dr','Ù…Ø§Ù†Ø¯Ù‡ Ø¨Ø¯Ù‡ÙŠ',0),(11703,326,'pr','Ù…Ø§Ù†Ø¯Ù‡ Ø¨Ø¯Ù‡ÙŠ',0),(11704,326,'tr','Ã–denecek Bakiye',0),(11705,326,'pl','Saldo zadÅ‚uÅ¼enia',0),(11706,326,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð¼ Ð¾ÑÑ‚Ð°Ñ‚ÑŠÐº',0),(11707,326,'ur','ØªÙˆØ§Ø²Ù† Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾Ù†Û’ Ù…ÛŒÚº Ù…Ù‚Ø±Ø±Û',0),(11708,326,'sr','Ð”Ð¾ÑÐ¿ÐµÐ»Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(11709,326,'vi','Sá»‘ dÆ° Ä‘áº¿n háº¡n',0),(11710,326,'af','Balans Verskuldig',0),(11711,326,'ro','Echilibru cuvenit',0),(11712,326,'et','Saldo',0),(11713,326,'si','Zapadli saldo',0),(11714,326,'ba','Keseimbangan karena',0),(11715,326,'nl','Due in evenwicht',0),(11716,326,'fi','Tasapainottaa asianmukaisesti',0),(11717,326,'no','Forfalt saldo',0),(11718,326,'da','Balance behÃ¸rig',0),(11719,326,'ko','ì¸í•´ ê· í˜•',0),(11720,326,'he','××™×–×•×Ÿ ×ª×§×™×Ÿ',0),(11721,326,'el','Î›Î·Î¾Î¹Ï€ÏÏŒÎ¸ÎµÏƒÎ¼Î¿ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(11722,326,'zh','åº”ä»˜ä½™é¢\r\n',0),(11723,326,'sv','Balansera vederbÃ¶rlig',0),(11724,326,'it','Scaduto',0),(11725,326,'tl','',0),(11726,326,'th','&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(11727,326,'hi','à¤¬à¤•à¤¾à¤¯à¤¾ à¤°à¤¾à¤¶à¥€',0),(11728,326,'ms','Baki akhir',0),(11729,326,'ar','Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ù…Ø³ØªØ­Ù‚',0),(11730,326,'fr','Balance Due',0),(11731,326,'jp','ä¸?è¶³é¡?',0),(11732,326,'pt','Equilibrar devido',0),(11733,326,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾',0),(11734,326,'es','Balance Vencido',0),(11735,326,'de','Balance Due',0),(11736,326,'en','Balance Due',0),(11737,327,'is','',0),(11738,327,'dr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø¨Ø±Ø§ÙŠ',0),(11739,327,'pr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø¨Ø±Ø§ÙŠ',0),(11740,327,'tr','BilanÃ§o iÃ§in',0),(11741,327,'pl','Bilans',0),(11742,327,'bg','Ð‘Ð°Ð»Ð°Ð½ÑÐ¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð°',0),(11743,327,'ur','Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ Ú©Û’ Ù„Ø¦Û’',0),(11744,327,'sr','Ð‘Ð¸Ð»Ð°Ð½Ñ ÑÑ‚Ð°ÑšÐ° Ð·Ð°',0),(11745,327,'vi','Báº£ng cÃ¢n Ä‘á»‘i cho',0),(11746,327,'af','Balansstaat vir',0),(11747,327,'ro','BilanÈ›ul',0),(11748,327,'et','Saldoteatis:',0),(11749,327,'si','Bilance stanja za',0),(11750,327,'ba','Neraca untuk',0),(11751,327,'nl','Balans voor',0),(11752,327,'fi','Taseen',0),(11753,327,'no','Balansen for',0),(11754,327,'da','Balancen for',0),(11755,327,'ko','ëŒ€ì°¨ ëŒ€ì¡°í‘œ',0),(11756,327,'he','×ž××–×Ÿ ×¢×‘×•×¨',0),(11757,327,'el','Î™ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚',0),(11758,327,'zh','èµ„äº§è´Ÿå€ºè¡¨\r\n',0),(11759,327,'sv','BalansrÃ¤kningen fÃ¶r',0),(11760,327,'it','Stato patrimoniale per',0),(11761,327,'tl','',0),(11762,327,'th','&#3651;&#3610;&#3591;&#3610;&#3604;&#3640;&#3621;&#3586;&#3629;&#3591;',0),(11763,327,'hi','à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤',0),(11764,327,'ms','Kunci kira-kira bagi',0),(11765,327,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¹Ù…ÙˆÙ…ÙŠØ©',0),(11766,327,'fr','Bilan financier pour',0),(11767,327,'jp','ï½žã?®ãƒ?ãƒ©ãƒ³ã‚¹ã‚·ãƒ¼ãƒˆ',0),(11768,327,'pt','BalanÃ§o para',0),(11769,327,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ',0),(11770,327,'es','Balance General para',0),(11771,327,'de','Bilanz',0),(11772,327,'en','Balance Sheet for',0),(11773,328,'is','',0),(11774,328,'dr','Ù¾Ø§ÙŠÙ‡',0),(11775,328,'pr','Ù¾Ø§ÙŠÙ‡',0),(11776,328,'tr','BankasÄ±',0),(11777,328,'pl','Podstawy',0),(11778,328,'bg','Ð‘Ð°Ð·Ð°',0),(11779,328,'ur','Ø¨Ù†ÛŒØ§Ø¯',0),(11780,328,'sr','Ð‘Ð°Ð·Ð°',0),(11781,328,'vi','Gá»‘c',0),(11782,328,'af','Basis',0),(11783,328,'ro','Baza',0),(11784,328,'et','Baasi',0),(11785,328,'si','Osnove',0),(11786,328,'ba','Base',0),(11787,328,'nl','Base',0),(11788,328,'fi','Base',0),(11789,328,'no','Base',0),(11790,328,'da','Base',0),(11791,328,'ko','ìžë£Œ',0),(11792,328,'he','×‘×¡×™×¡',0),(11793,328,'el','Î’Î¬ÏƒÎ·',0),(11794,328,'zh','åŸºç¡€\r\n',0),(11795,328,'sv','Base',0),(11796,328,'it','Base',0),(11797,328,'tl','',0),(11798,328,'th','&#3600;&#3634;&#3609;',0),(11799,328,'hi','à¤¬à¥‡à¤¸',0),(11800,328,'ms','Asas',0),(11801,328,'ar','Ù‚Ø§Ø¹Ø¯Ø©',0),(11802,328,'fr','Base',0),(11803,328,'jp','ãƒ™ãƒ¼ã‚¹',0),(11804,328,'pt','Base',0),(11805,328,'ru','Ð‘Ð°Ð·Ð°',0),(11806,328,'es','Base',0),(11807,328,'de','Base',0),(11808,328,'en','Base',0),(11809,329,'is','',0),(11810,329,'dr','Ù…Ø¨Ù†Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª',0),(11811,329,'pr','Ù…Ø¨Ù†Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª',0),(11812,329,'tr','Hesaplama temeli',0),(11813,329,'pl','PodstawÄ™ obliczenia',0),(11814,329,'bg','Ð‘Ð°Ð·Ð° Ð·Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ',0),(11815,329,'ur','Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯',0),(11816,329,'sr','ÐžÑÐ½Ð¾Ð²Ð° Ð·Ð° Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½',0),(11817,329,'vi','CÆ¡ sá»Ÿ Ä‘á»ƒ tÃ­nh toÃ¡n',0),(11818,329,'af','Basis vir Berekening',0),(11819,329,'ro','Baza de calcul',0),(11820,329,'et','Arvutamise alus',0),(11821,329,'si','Osnova za izraÄun',0),(11822,329,'ba','Dasar perhitungan',0),(11823,329,'nl','Basis voor berekening',0),(11824,329,'fi','Laskentaperuste',0),(11825,329,'no','Grunnlag for beregning',0),(11826,329,'da','Grundlaget for beregning',0),(11827,329,'ko','ê³„ì‚°ì„ ìœ„í•œ ê¸°ì´ˆ',0),(11828,329,'he','×‘×¡×™×¡ ×œ×—×™×©×•×‘',0),(11829,329,'el','Î’Î¬ÏƒÎ· Î³Î¹Î± Ï„Î¿Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ',0),(11830,329,'zh','è®¡ç®—çš„ä¾æ®\r\n',0),(11831,329,'sv','Grund fÃ¶r berÃ¤kning av',0),(11832,329,'it','Base di calcolo',0),(11833,329,'tl','',0),(11834,329,'th','&#3627;&#3621;&#3633;&#3585;&#3648;&#3585;&#3603;&#3601;&#3660;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(11835,329,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤§à¤¾à¤°',0),(11836,329,'ms','Asas pengiraan',0),(11837,329,'ar','Ø£Ø³Ø§Ø³Ø§ Ù„Ø­Ø³Ø§Ø¨',0),(11838,329,'fr','Base de calcul',0),(11839,329,'jp','è¨ˆç®—åŸºæº–',0),(11840,329,'pt','Base de cÃ¡lculo',0),(11841,329,'ru','ÐžÑÐ½Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð´Ð»Ñ Ð’Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(11842,329,'es','Base para el CÃ¡lculo',0),(11843,329,'de','Grundlage fÃ¼r die Berechnung',0),(11844,329,'en','Basis for Calculation',0),(11845,330,'is','',0),(11846,330,'dr','Ø¯Ø± ÙˆØ¬Ù‡ Ø­Ø§Ù…Ù„ Ø¨Ù‡  Ø¹Ø±Ø¶ Ø¯Ø± ÙˆØ¬Ù‡ Ø­Ø§Ù…Ù„',0),(11847,330,'pr','Ø¯Ø± ÙˆØ¬Ù‡ Ø­Ø§Ù…Ù„ Ø¨Ù‡  Ø¹Ø±Ø¶ Ø¯Ø± ÙˆØ¬Ù‡ Ø­Ø§Ù…Ù„',0),(11848,330,'tr','TaÅŸÄ±yÄ±cÄ±-taÅŸÄ±yÄ±cÄ± geniÅŸliÄŸi',0),(11849,330,'pl','SzerokoÅ›Ä‡ noÅ›nika na okaziciela',0),(11850,330,'bg','ÐÐ¾ÑÐ¸Ñ‚ÐµÐ» Ð½Ð° Ð¿Ñ€Ð¸Ð½Ð¾ÑÐ¸Ñ‚ÐµÐ» ÑˆÐ¸Ñ€Ð¸Ð½Ð°',0),(11851,330,'ur','Ø³Ù†Ø§Ù†Û’ ÙˆØ§Ù„Ø§ Ú©Ùˆ Ø³Ù†Ø§Ù†Û’ ÙˆØ§Ù„Ø§ Ú†ÙˆÚ‘Ø§Ø¦ÛŒ',0),(11852,330,'sr','Ð¨Ð¸Ñ€Ð¸Ð½Ð° Ð½Ð¾ÑÐ¸Ð¾Ñ†Ð° Ð´Ð° Ð½Ð¾ÑÐ¸Ð¾Ñ†Ð°',0),(11853,330,'vi','Chiá»u rá»™ng ngÆ°á»i mang tá»›i ngÆ°á»i mang',0),(11854,330,'af','Ampsdraer tot ampsdraer breedte',0),(11855,330,'ro','LÄƒÅ£imea purtÄƒtor la purtÄƒtor',0),(11856,330,'et','Kuller kandjaks laius',0),(11857,330,'si','Å irina nosilca na prinosnika',0),(11858,330,'ba','Pembawa-pembawa lebar',0),(11859,330,'nl','Aan toonder aan toonder breedte',0),(11860,330,'fi','Siirtotie-siirtotie leveys',0),(11861,330,'no','BÃ¦rer til bÃ¦rer bredde',0),(11862,330,'da','BÃ¦rer til ihÃ¦ndehaveren bredde',0),(11863,330,'ko','ë¬´ê¸°ëª… ë¬´ê¸°ëª… í­',0),(11864,330,'he','× ×•×©× ××ª × ×•×©× ×¨×•×—×‘',0),(11865,330,'el','Î Î»Î¬Ï„Î¿Ï‚ Ï„Î¿Ï… ÎºÎ¿Î¼Î¹ÏƒÏ„Î® Î½Î± ÎºÎ¿Î¼Î¹ÏƒÏ„Î®',0),(11866,330,'zh','æŒæœ‰äººåˆ°æŒæœ‰äººå®½åº¦\r\n',0),(11867,330,'sv','BÃ¤rare till bÃ¤rare bredd',0),(11868,330,'it','Larghezza portatore a portatore',0),(11869,330,'tl','',0),(11870,330,'th','Bearer to Bearer Width',0),(11871,330,'hi','à¤µà¤¾à¤¹à¤• à¤µà¤¾à¤¹à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ',0),(11872,330,'ms','Pembawa-pembawa lebar',0),(11873,330,'ar','Ø¹Ø±Ø¶ Ø­Ø§Ù…Ù„Ù‡Ø§ Ù„Ø­Ø§Ù…Ù„Ù‡Ø§',0),(11874,330,'fr','Largeur au porteur au porteur',0),(11875,330,'jp','Bearer to bearer Width',0),(11876,330,'pt','Largura de portador para portador',0),(11877,330,'ru','Ð¨Ð¸Ñ€Ð¸Ð½Ð° Ð½Ð¾ÑÐ¸Ñ‚ÐµÐ»Ñ Ð½Ð° Ð¿Ñ€ÐµÐ´ÑŠÑÐ²Ð¸Ñ‚ÐµÐ»Ñ',0),(11878,330,'es','Portador a Portador Anchura',0),(11879,330,'de','Breite von TrÃ¤ger zu TrÃ¤ger',0),(11880,330,'en','Bearer to Bearer Width',0),(11881,331,'is','',0),(11882,331,'dr','Ø¨Ù‡ Ø¹Ù„Øª Ø¨Ø±Ø®ÙŠ Ø®Ø·Ø§Ù‡Ø§ÙŠ Ù†Ø§Ø®ÙˆØ§Ø³ØªÙ‡  Ø¨ÙˆØ¯Ø¬Ù‡ Ø¬Ø¯ÙŠØ¯ Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø«Ø¨Øª Ø´ÙˆØ¯',0),(11883,331,'pr','Ø¨Ù‡ Ø¹Ù„Øª Ø¨Ø±Ø®ÙŠ Ø®Ø·Ø§Ù‡Ø§ÙŠ Ù†Ø§Ø®ÙˆØ§Ø³ØªÙ‡  Ø¨ÙˆØ¯Ø¬Ù‡ Ø¬Ø¯ÙŠØ¯ Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø«Ø¨Øª Ø´ÙˆØ¯',0),(11884,331,'tr','Talihsiz bazÄ± hatalar nedeniyle, yeni bÃ¼tÃ§e girdi deÄŸil.',0),(11885,331,'pl','Ze wzglÄ™du na niefortunne bÅ‚Ä™dy moÅ¼e nie wszedÅ‚ nowy budÅ¼et.',0),(11886,331,'bg','ÐŸÐ¾Ñ€Ð°Ð´Ð¸ Ð½ÑÐºÐ¾Ð¸ Ð¶Ð°Ð»ÐºÐ¾ Ð³Ñ€ÐµÑˆÐºÐ¸ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð²Ð¿Ð¸ÑÐ²Ð°Ñ‚ Ð¿Ð¾ Ð½Ð¾Ð²Ð¸Ñ Ð²Ð¸ Ð±ÑŽÐ´Ð¶ÐµÑ‚.',0),(11887,331,'ur','Ú©Ú†Ú¾ Ø¨Ø¯Ø¨Ø®Øª Ù†Ù‚Ø§Ø¦Øµ Ú©Û’ Ø¨Ø§Ø¹Ø«ØŒ Ø§Ù¾Ù†Û’ Ù†Ø¦Û’ Ø¨Ø¬Ù¹ Ø¯Ø§Ø®Ù„ Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©ØªØ§ Û”',0),(11888,331,'sr','Ð—Ð±Ð¾Ð³ Ð½ÐµÐºÐ¸Ñ… Ð³Ñ€ÐµÑˆÐ°ÐºÐ° Ñƒ Ð½ÐµÐ·Ð³Ð¾Ð´Ð½Ð¾, Ñ‚Ð²Ð¾Ñ˜ Ð½Ð¾Ð²Ð¸ Ð±ÑƒÑŸÐµÑ‚ Ð½Ð¸Ñ˜Ðµ Ð¼Ð¾Ð³Ð°Ð¾ Ð±Ð¸Ñ‚Ð¸ ÑƒÐ½ÐµÑ‚.',0),(11889,331,'vi','NgÃ¢n sÃ¡ch má»›i cá»§a báº¡n khÃ´ng thá»ƒ nháº­p vÃ o vÃ¬ cÃ³ má»™t sá»‘ lá»—i',0),(11890,331,'af','As gevolg van \'n paar ongelukkige foute, jou nuwe begroting kon nie ingeskryf word.',0),(11891,331,'ro','Din cauza unor erori de nefericit, bugetul noi nu ar putea se Ã®nscrie.',0),(11892,331,'et','MÃµned Ãµnnetu tÃµrgete tÃµttu ei saa sisestada oma uude eelarvesse.',0),(11893,331,'si','Zaradi nekaj obÅ¾alovanja napake, ni treba vpisati nov predraÄun.',0),(11894,331,'ba','Karena beberapa galat Malang, anggaran baru bisa tidak dimasukkan.',0),(11895,331,'nl','Vanwege enkele ongelukkige fouten, kon uw nieuwe budget niet worden ingevoerd.',0),(11896,331,'fi','Joistakin valitettavaa virheistÃ¤ uudella budjetilla ei voi mÃ¤Ã¤rittÃ¤Ã¤.',0),(11897,331,'no','PÃ¥ grunn av noen uheldige feil, kan det nye budsjettet ikke angis.',0),(11898,331,'da','PÃ¥ grund af nogle uheldige fejl, kunne dit nye budget ikke angives.',0),(11899,331,'ko','ì¼ë¶€ ë¶ˆí–‰ í•œ ì˜¤ë¥˜ë¡œ ì¸í•´ ìƒˆë¡œìš´ ì˜ˆì‚° í•˜ì§€ ìž…ë ¥í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(11900,331,'he','×‘×’×œ×œ ×›×ž×” ×˜×¢×•×™×•×ª ×ž×¦×¢×¨×•×ª, ×”×ª×§×¦×™×‘ ×”×—×“×© ×©×œ×š ×œ× ×™×›×•×œ ××¤×©×¨×•×ª ×œ×”×–×™×Ÿ.',0),(11901,331,'el','Î•Î¾Î±Î¹Ï„Î¯Î±Ï‚ Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î± ÏƒÏ†Î¬Î»Î¼Î±Ï„Î± Î±Ï„Ï…Ï‡Î­Ï‚, Ï„Î¿Î½ Î½Î­Î¿ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î´ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎ±Î½ Î½Î± ÎµÎ³Î³ÏÎ±Ï†Î¿ÏÎ½.',0),(11902,331,'zh','ç”±äºŽä¸€äº›ä¸å¹¸çš„é”™è¯¯ï¼Œæ–°çš„é¢„ç®—æ— æ³•è¿›å…¥\r\n',0),(11903,331,'sv','PÃ¥ grund av vissa olyckliga fel, kunde din nya budget inte registreras.',0),(11904,331,'it','A causa di alcuni errori sfortunati, non poteva essere inserito il nuovo budget.',0),(11905,331,'tl','',0),(11906,331,'th','&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3592;&#3634;&#3585;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3610;&#3634;&#3591;&#3611;&#3619;&#3632;&#3585;&#3634;&#3619; &#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#',0),(11907,331,'hi','à¤•à¥à¤› à¤¦à¥à¤°à¥à¤­à¤¾à¤—à¥à¤¯à¤ªà¥‚à¤°à¥à¤£ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤•à¤¾à¤°à¤£, à¤…à¤ªà¤¨à¥‡ à¤¨à¤ à¤¬à¤œà¤Ÿ à¤¦à¤°à¥à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(11908,331,'ms','Kerana beberapa kesilapan yang malang, bajet baru anda boleh tidak dimasukkan.',0),(11909,331,'ar','Ø¨Ø³Ø¨Ø¨ Ø¨Ø¹Ø¶ Ø£Ø®Ø·Ø§Ø¡ Ù…Ø¤Ø³ÙØ©ØŒ ØªØ¹Ø°Ø± Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(11910,331,'fr','Ã€ cause de quelques erreurs de malheureux, votre nouveau budget ne pourrait pas Ãªtre inscrit.',0),(11911,331,'jp','ä½•ã‚‰ã?‹ã?®ã‚¨ãƒ©ãƒ¼ã?®ã‚¬ç”Ÿã?˜ã?Ÿç‚ºã€?æ–°ã?—ã?„äºˆç®—ã?Œè¨˜å¸³ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(11912,331,'pt','Devido a alguns erros infelizes, seu novo orÃ§amento nÃ£o pode ser inserido.',0),(11913,331,'ru','Ð˜Ð·-Ð·Ð° Ð½ÐµÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ñ… Ð½ÐµÑÑ‡Ð°ÑÑ‚Ð½Ñ‹Ñ… Ð¾ÑˆÐ¸Ð±Ð¾Ðº Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð²Ð²ÐµÑÑ‚Ð¸ Ð²Ð°Ñˆ Ð½Ð¾Ð²Ñ‹Ð¹ Ð±ÑŽÐ´Ð¶ÐµÑ‚.',0),(11914,331,'es','Por algunos errores desafortunados, no se podÃ­a ingresar su nuevo presupuesto',0),(11915,331,'de','Durch einige unglÃ¼ckliche Fehler kÃ¶nnte dein neue Budget nicht eingegeben werden.',0),(11916,331,'en','Because of some unfortunate errors, your new budget could not be entered.',0),(11917,332,'is','',0),(11918,332,'dr','Ø´Ø±ÙˆØ¹ ',0),(11919,332,'pr','Ø´Ø±ÙˆØ¹ ',0),(11920,332,'tr','Begin',0),(11921,332,'pl','BEGIN',0),(11922,332,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ',0),(11923,332,'ur','Ø´Ø±ÙˆØ¹ Ú©Ø±ÛŒÚº',0),(11924,332,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð¸',0),(11925,332,'vi','Báº¯t Ä‘áº§u',0),(11926,332,'af','Begin',0),(11927,332,'ro','ÃŽncepe',0),(11928,332,'et','Alustada',0),(11929,332,'si','ZaÄeli',0),(11930,332,'ba','Mulai',0),(11931,332,'nl','Beginnen',0),(11932,332,'fi','Alkaa',0),(11933,332,'no','Begynne',0),(11934,332,'da','Begynder',0),(11935,332,'ko','ì‹œìž‘',0),(11936,332,'he','×‘×’×™×Ÿ',0),(11937,332,'el','Î‘ÏÏ‡Î¯Î¶Î¿Ï…Î½',0),(11938,332,'zh','å¼€å§‹\r\n',0),(11939,332,'sv','BÃ¶rja',0),(11940,332,'it','Begin',0),(11941,332,'tl','',0),(11942,332,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(11943,332,'hi','à¤¶à¥à¤°à¥‚ à¤¹à¥‹',0),(11944,332,'ms','Mula',0),(11945,332,'ar','ØªØ¨Ø¯Ø£',0),(11946,332,'fr','Begin',0),(11947,332,'jp','é–‹å§‹',0),(11948,332,'pt','Begin',0),(11949,332,'ru','ÐÐ°Ñ‡Ð°Ñ‚ÑŒ',0),(11950,332,'es','Comienza',0),(11951,332,'de','BEGIN',0),(11952,332,'en','Begin',0),(11953,333,'is','',0),(11954,333,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹',0),(11955,333,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹',0),(11956,333,'tr','BaÅŸlangÄ±Ã§ tarihi',0),(11957,333,'pl','Data rozp.',0),(11958,333,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(11959,333,'ur','ØªØ§Ø±ÛŒØ® Ø¢ØºØ§Ø²',0),(11960,333,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(11961,333,'vi','NgÃ y báº¯t Ä‘áº§u',0),(11962,333,'af','Begin Datum',0),(11963,333,'ro','Data de incepere',0),(11964,333,'et','AlguskuupÃ¤ev',0),(11965,333,'si','ZaÄetni datum',0),(11966,333,'ba','Mulai tanggal',0),(11967,333,'nl','Begindatum',0),(11968,333,'fi','PÃ¤ivÃ¤ alkaen',0),(11969,333,'no','Start dato',0),(11970,333,'da','Start dato',0),(11971,333,'ko','ì‹œìž‘ ë‚ ì§œ',0),(11972,333,'he','×ª××¨×™×š ×”×ª×—×œ×”',0),(11973,333,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(11974,333,'zh','å¼€å§‹æ—¥æœŸ\r\n',0),(11975,333,'sv','BÃ¶rja dagen',0),(11976,333,'it','Data di inizio',0),(11977,333,'tl','',0),(11978,333,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(11979,333,'hi','à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(11980,333,'ms','Mula tarikh',0),(11981,333,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(11982,333,'fr','Date de dÃ©but',0),(11983,333,'jp','é–‹å§‹æ—¥',0),(11984,333,'pt','Data de inÃ­cio',0),(11985,333,'ru','Ð”Ð°Ñ‚Ð° ÐÐ°Ñ‡Ð°Ð»Ð°',0),(11986,333,'es','Fecha de Inicio',0),(11987,333,'de','Anfangsdatum',0),(11988,333,'en','Begin Date',0),(11989,334,'is','',0),(11990,334,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ú†Ùƒ Ù‡Ø§',0),(11991,334,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ú†Ùƒ Ù‡Ø§',0),(11992,334,'tr','Ã‡eklerin baÅŸlayacak',0),(11993,334,'pl','Data rozpoczÄ™cia kontroli',0),(11994,334,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸Ñ‚Ðµ',0),(11995,334,'ur','Ú†ÛŒÚ© Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¢ØºØ§Ø²',0),(11996,334,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ñ‡ÐµÐºÐ¾Ð²Ð°',0),(11997,334,'vi','NgÃ y báº¯t Ä‘áº§u cá»§a SÃ©c',0),(11998,334,'af','Begin Datum van Tjeks',0),(11999,334,'ro','Data inceput controalele',0),(12000,334,'et','Hakkavad kontrolli kuupÃ¤ev',0),(12001,334,'si','ZaÄetni datum kontrole',0),(12002,334,'ba','Mulai tanggal cek',0),(12003,334,'nl','Begindatum van de controles',0),(12004,334,'fi','AloituspÃ¤ivÃ¤ tarkastusten',0),(12005,334,'no','Start dato kontroller',0),(12006,334,'da','Start dato for kontrollen',0),(12007,334,'ko','ê²€ì‚¬ì˜ ë‚ ì§œë¥¼ ì‹œìž‘',0),(12008,334,'he','×ª××¨×™×š ×‘×’×™×Ÿ ×¦\'×§×™×',0),(12009,334,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Ï„Ï‰Î½ ÎµÎ»Î­Î³Ï‡Ï‰Î½',0),(12010,334,'zh','æ£€æŸ¥å¼€å§‹æ—¥æœŸ\r\n',0),(12011,334,'sv','BÃ¶rja dagen fÃ¶r kontroller',0),(12012,334,'it','Data di inizio dei controlli',0),(12013,334,'tl','',0),(12014,334,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;',0),(12015,334,'hi','à¤œà¤¾à¤‚à¤š à¤•à¥€ à¤¤à¤¿à¤¥à¤¿ à¤¶à¥à¤°à¥‚',0),(12016,334,'ms','Mula tarikh pemeriksaan',0),(12017,334,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡ Ù„Ù„Ø´ÙŠÙƒØ§Øª',0),(12018,334,'fr','Date de dÃ©but des contrÃ´les',0),(12019,334,'jp','å°?åˆ‡æ‰‹ã?®é–‹å§‹æ—¥',0),(12020,334,'pt','Data de inÃ­cio dos controlos',0),(12021,334,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(12022,334,'es','Fecha de Inicio de los Cheques',0),(12023,334,'de','Anfangsdatum der Kontrollen',0),(12024,334,'en','Begin Date of Checks',0),(12025,335,'is','',0),(12026,335,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ÙØ§ÙƒØªÙˆØ±',0),(12027,335,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ÙØ§ÙƒØªÙˆØ±',0),(12028,335,'tr','Fatura tarihi baÅŸlar',0),(12029,335,'pl','BEGIN Data faktury',0),(12030,335,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°',0),(12031,335,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¢ØºØ§Ø²',0),(12032,335,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(12033,335,'vi','NgÃ y báº¯t Ä‘áº§u cá»§a hÃ³a Ä‘Æ¡n',0),(12034,335,'af','Begin Datum van Fakture',0),(12035,335,'ro','ÃŽncepe facturare',0),(12036,335,'et','Arve alguskuupÃ¤ev',0),(12037,335,'si','ZaÄetni datum raÄuna',0),(12038,335,'ba','Mulai tanggal faktur',0),(12039,335,'nl','Begindatum van de factuur',0),(12040,335,'fi','Aloittaa laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(12041,335,'no','Starte fakturadato',0),(12042,335,'da','Begynde fakturadato',0),(12043,335,'ko','ì‹œìž‘ ë‚ ì§œ',0),(12044,335,'he','×ª××¨×™×š ×”×”×ª×—×œ×” ×©×œ ×—×©×‘×•× ×™×ª',0),(12045,335,'el','Î‘ÏÏ‡Î¯Î¶Î¿Ï…Î½ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(12046,335,'zh','å‘ç¥¨æ—¥æœŸå¼€å§‹\r\n',0),(12047,335,'sv','BÃ¶rja fakturadatum',0),(12048,335,'it','Iniziare la data della fattura',0),(12049,335,'tl','',0),(12050,335,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(12051,335,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¶à¥à¤°à¥‚ à¤¹à¥‹',0),(12052,335,'ms','Mula tarikh invois',0),(12053,335,'ar','ÙŠØ¨Ø¯Ø£ ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(12054,335,'fr','Date de dÃ©but de facturation',0),(12055,335,'jp','è«‹æ±‚æ›¸ã?®é–‹å§‹æ—¥',0),(12056,335,'pt','ComeÃ§ar a data da fatura',0),(12057,335,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð”Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(12058,335,'es','Fecha de Inicio de Factura',0),(12059,335,'de','Rechnungsdatum zu beginnen',0),(12060,335,'en','Begin Date of Invoice',0),(12061,336,'is','',0),(12062,336,'dr','Ø´Ø±ÙˆØ¹ Ø³Ø± Ø±Ø³ÙŠØ¯',0),(12063,336,'pr','Ø´Ø±ÙˆØ¹ Ø³Ø± Ø±Ø³ÙŠØ¯',0),(12064,336,'tr','BaÅŸlamadan vade tarihi',0),(12065,336,'pl','RozpoczÄ…Ä‡ odpowiednim terminie',0),(12066,336,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ðµ Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(12067,336,'ur','Ø¢ØºØ§Ø² Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(12068,336,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(12069,336,'vi','NgÃ y báº¯t Ä‘áº§u Ä‘áº¿n háº¡n',0),(12070,336,'af','Begin Verskuldigde Datum',0),(12071,336,'ro','ÃŽncepe util data',0),(12072,336,'et','Algab tÃ¤htaeg kuupÃ¤ev',0),(12073,336,'si','ZaÄeli zaradi datuma',0),(12074,336,'ba','Mulai Due Date',0),(12075,336,'nl','Beginnen Due datum',0),(12076,336,'fi','Alkaa asianmukaisesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(12077,336,'no','Begynne Due dato',0),(12078,336,'da','Begynde Due dato',0),(12079,336,'ko','ê¸°í•œ ì‹œìž‘ ë‚ ì§œ',0),(12080,336,'he','×œ×”×ª×—×™×œ ×™×¢×“ ×ª××¨×™×š',0),(12081,336,'el','Î‘ÏÏ‡Î¯ÏƒÎ¿Ï…Î½ Î»ÏŒÎ³Ï‰ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(12082,336,'zh','å¼€å§‹æˆªæ­¢æ—¥æœŸ\r\n',0),(12083,336,'sv','BÃ¶rja Due Date',0),(12084,336,'it','Iniziano Due Date',0),(12085,336,'tl','',0),(12086,336,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(12087,336,'hi','à¤¨à¤¿à¤¯à¤¤ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(12088,336,'ms','Mula akhir tarikh',0),(12089,336,'ar','ÙŠØ¨Ø¯Ø£ Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(12090,336,'fr','Commencer Due Date',0),(12091,336,'jp','æœŸé™?é–‹å§‹æ—¥',0),(12092,336,'pt','ComeÃ§ar Due Date',0),(12093,336,'ru','ÐÐ°Ñ‡Ð¸Ð½Ð°Ñ ÐŸÐ¾ Ð”Ð°Ñ‚Ðµ',0),(12094,336,'es','Iniciar Fecha de Vencimiento',0),(12095,336,'de','Beginnen Due Date',0),(12096,336,'en','Begin Due Date',0),(12097,337,'is','',0),(12098,337,'dr','Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡',0),(12099,337,'pr','Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡',0),(12100,337,'tr','SÃ¼re baÅŸlar',0),(12101,337,'pl','RozpoczÄ…Ä‡ okres',0),(12102,337,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(12103,337,'ur','Ø¯ÙˆØ± Ø´Ø±ÙˆØ¹',0),(12104,337,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(12105,337,'vi','Ká»³ báº¯t Ä‘áº§u',0),(12106,337,'af','Periode Begin',0),(12107,337,'ro','ÃŽncepe perioada',0),(12108,337,'et','Perioodi algus',0),(12109,337,'si','ZaÄne obdobje',0),(12110,337,'ba','Memulai periode',0),(12111,337,'nl','Begin van de periode',0),(12112,337,'fi','Aloittaa kauden',0),(12113,337,'no','Begynn perioden',0),(12114,337,'da','Begynde perioden',0),(12115,337,'ko','ê¸°ê°„ ì‹œìž‘',0),(12116,337,'he','×ž×ª×—×™×œ×” ×ª×§×•×¤×”',0),(12117,337,'el','Î‘ÏÏ‡Î¯Î¶Î¿Ï…Î½ Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(12118,337,'zh','å¼€å§‹æ—¶æœŸ\r\n',0),(12119,337,'sv','PÃ¥bÃ¶rja Period',0),(12120,337,'it','Inizio periodo',0),(12121,337,'tl','',0),(12122,337,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(12123,337,'hi','à¤…à¤µà¤§à¤¿ à¤¶à¥à¤°à¥‚',0),(12124,337,'ms','Tempoh mula',0),(12125,337,'ar','Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©',0),(12126,337,'fr','Commencer la pÃ©riode',0),(12127,337,'jp','æœŸé–“ã?®å§‹ã?¾ã‚Š',0),(12128,337,'pt','ComeÃ§ar o perÃ­odo',0),(12129,337,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ ÐŸÐµÑ€Ð¸Ð¾Ð´Ð°',0),(12130,337,'es','Inicio del PerÃ­odo',0),(12131,337,'de','Periode',0),(12132,337,'en','Begin Period',0),(12133,338,'is','',0),(12134,338,'dr','/ Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹ ',0),(12135,338,'pr','Ø³Ø§Ù„ / Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹ ',0),(12136,338,'tr','Year/Month baÅŸlar',0),(12137,338,'pl','MiesiÄ…c i rok rozpoczÄ™cia',0),(12138,338,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ð°/Ð¼ÐµÑÐµÑ†',0),(12139,338,'ur','Ø³Ø§Ù„ Ù…ÛŒÚº Ø§ÛŒÚ© Ù…ÛÛŒÙ†Û Ø´Ø±ÙˆØ¹',0),(12140,338,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð³Ð¾Ð´Ð¸Ð½Ðµ/Ð¼ÐµÑÐµÑ†',0),(12141,338,'vi','NÄƒm báº¯t Ä‘áº§u/thÃ¡ng',0),(12142,338,'af','Jaar/maand begin',0),(12143,338,'ro','Incepe anul/luna',0),(12144,338,'et','Algab aasta/kuu',0),(12145,338,'si','ZaÄeli leto/mesec',0),(12146,338,'ba','Mulai tahun/bulan',0),(12147,338,'nl','Begin jaar/maand',0),(12148,338,'fi','Aloita vuosi/kuukausi',0),(12149,338,'no','Starte Ã¥r/mÃ¥ned',0),(12150,338,'da','Begynde Ã¥r/mÃ¥ned',0),(12151,338,'ko','ë…„/ì›”ì„ ì‹œìž‘',0),(12152,338,'he','×ž×ª×—×™×œ×™× ×©× ×”/×—×•×“×©',0),(12153,338,'el','Î‘ÏÏ‡Î¯ÏƒÎ¿Ï…Î½ Î­Ï„Î¿Ï…Ï‚/Î¼Î®Î½Î±',0),(12154,338,'zh','å¼€å§‹å¹´/æœˆ\r\n',0),(12155,338,'sv','BÃ¶rja Ã¥r/mÃ¥nad',0),(12156,338,'it','Inizio anno/mese',0),(12157,338,'tl','',0),(12158,338,'th','&#3611;&#3637;/&#3648;&#3604;&#3639;&#3629;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(12159,338,'hi','à¤µà¤°à¥à¤·/à¤®à¤¾à¤¹ à¤¶à¥à¤°à¥‚',0),(12160,338,'ms','Mula tahun/bulan',0),(12161,338,'ar','ØªØ¨Ø¯Ø£ Ø§Ù„Ø³Ù†Ø©/Ø§Ù„Ø´Ù‡Ø±',0),(12162,338,'fr','Commencer l\'annÃ©e/mois',0),(12163,338,'jp','é–‹å§‹å¹´/æœˆ',0),(12164,338,'pt','ComeÃ§ar o ano/mÃªs',0),(12165,338,'ru','ÐÐ°Ñ‡Ð¸Ð½Ð°ÐµÑ‚ÑÑ Ð³Ð¾Ð´ Ð¸ Ð¼ÐµÑÑÑ†',0),(12166,338,'es','AÃ±o/Mes de Inicio',0),(12167,338,'de','Jahr/Monat beginnen',0),(12168,338,'en','Begin Year/Month',0),(12169,339,'is','',0),(12170,339,'dr','ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ',0),(12171,339,'pr','ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ',0),(12172,339,'tr','BaÅŸlangÄ±Ã§ bakiyesi',0),(12173,339,'pl','Saldo poczÄ…tkowe',0),(12174,339,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð¾ ÑÐ°Ð»Ð´Ð¾',0),(12175,339,'ur','ØªÙˆØ§Ø²Ù† Ú©ÛŒ Ø§Ø¨ØªØ¯Ø§Ø¡',0),(12176,339,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(12177,339,'vi','Sá»‘ dÆ° báº¯t Ä‘áº§u',0),(12178,339,'af','Begin Balans',0),(12179,339,'ro','ÃŽnceputul echilibru',0),(12180,339,'et','Algsaldo',0),(12181,339,'si','ZaÄetni saldo',0),(12182,339,'ba','Saldo awal',0),(12183,339,'nl','Beginsaldo',0),(12184,339,'fi','Alkusaldo',0),(12185,339,'no','Startsaldo',0),(12186,339,'da','Startsaldo',0),(12187,339,'ko','ì²˜ìŒ ìž”ì•¡',0),(12188,339,'he','×”×—×œ ××™×–×•×Ÿ',0),(12189,339,'el','Î¥Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ Î­Î½Î±ÏÎ¾Î·Ï‚',0),(12190,339,'zh','æœŸåˆä½™é¢',0),(12191,339,'sv','IngÃ¥ende balans',0),(12192,339,'it','Saldo iniziale',0),(12193,339,'tl','',0),(12194,339,'th','&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604;',0),(12195,339,'hi','à¤¶à¥à¤°à¥à¤†à¤¤ à¤¸à¤‚à¤¤à¥à¤²à¤¨',0),(12196,339,'ms','Baki awal',0),(12197,339,'ar','Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ø¥ÙØªØªØ§Ø­ÙŠ',0),(12198,339,'fr','Solde d\'ouverture',0),(12199,339,'jp','é–‹å§‹ãƒ?ãƒ©ãƒ³ã‚¹',0),(12200,339,'pt','Saldo inicial',0),(12201,339,'ru','ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð‘Ð°Ð»Ð°Ð½Ñ',0),(12202,339,'es','Saldo de Inicio',0),(12203,339,'de','Anfangssaldo',0),(12204,339,'en','Beginning Balance',0),(12205,340,'is','',0),(12206,340,'dr','(Ø§ÙˆÙ„ÙŠÙ‡',0),(12207,340,'pr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ø§ÙØªØªØ§Ø­ÙŠÙ‡(Ø§ÙˆÙ„ÙŠÙ‡',0),(12208,340,'tr','BaÅŸlangÄ±Ã§ta kontrol #',0),(12209,340,'pl','PoczÄ…tku sprawdziÄ‡ #',0),(12210,340,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾ ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ #',0),(12211,340,'ur','Ø¢ØºØ§Ø² # Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(12212,340,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð²Ð¸Ð´Ð¸ #',0),(12213,340,'vi','Sá»‘ báº¯t Ä‘áº§u cá»§a SÃ©c',0),(12214,340,'af','Aanvanklike Tjek #',0),(12215,340,'ro','ÃŽnceputul verifica #',0),(12216,340,'et','Alguses Check #',0),(12217,340,'si','ZaÄetku preveri #',0),(12218,340,'ba','Awal memeriksa #',0),(12219,340,'nl','Begin controleren #',0),(12220,340,'fi','Alussa tarkistaa #',0),(12221,340,'no','Begynnelsen nÃ¥r #',0),(12222,340,'da','Begyndelsen tjekke #',0),(12223,340,'ko','ì‹œìž‘ í™•ì¸ #',0),(12224,340,'he','×¨××©×™×ª ×‘×“×•×§ #',0),(12225,340,'el','Î‘ÏÏ‡Î® ÎµÎ»Î­Î³Ï‡ÎµÎ¹ #',0),(12226,340,'zh','ï¼ƒå¼€å§‹æ£€æŸ¥\r\n',0),(12227,340,'sv','BÃ¶rjan kontrollera #',0),(12228,340,'it','Inizio verifica #',0),(12229,340,'tl','',0),(12230,340,'th','&#3585;&#3634;&#3619;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;',0),(12231,340,'hi','à¤¶à¥à¤°à¥à¤†à¤¤ à¤•à¥€ à¤œà¤¾à¤à¤š #',0),(12232,340,'ms','Permulaan semak #',0),(12233,340,'ar','Ø¨Ø¯Ø§ÙŠØ© ØªØ­Ù‚Ù‚ #',0),(12234,340,'fr','DÃ©but vÃ©rifier #',0),(12235,340,'jp','é–‹å§‹å°?åˆ‡æ‰‹ç•ªå?·',0),(12236,340,'pt','InÃ­cio verificar #',0),(12237,340,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ #',0),(12238,340,'es','# Cheque de Inicio',0),(12239,340,'de','Anfang Check #',0),(12240,340,'en','Beginning Check #',0),(12241,341,'is','',0),(12242,341,'dr','(Ù…Ù‚Ø¯Ù…Ø§ØªÙŠ',0),(12243,341,'pr','ØªØ§Ø±ÙŠØ® Ø§Ø±Ø²ÙŠØ§Ø¨ÙŠ Ø§ÙØªØªØ§Ø­ÙŠÙ‡(Ù…Ù‚Ø¯Ù…Ø§ØªÙŠ',0),(12244,341,'tr','Ä°lk deÄŸerlendirme tarihi',0),(12245,341,'pl','Ocena data poczÄ…tkowa',0),(12246,341,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(12247,341,'ur','Ø¬Ø§Ø¦Ø²Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¢ØºØ§Ø²',0),(12248,341,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð° Ð¾Ñ†ÐµÐ½Ñƒ',0),(12249,341,'vi','NgÃ y báº¯t Ä‘áº§u dá»‹nh giÃ¡',0),(12250,341,'af','Beginnende Evualiasie Datum',0),(12251,341,'ro','ÃŽncepÃ¢nd cu data de evaluare',0),(12252,341,'et','Alguses hindamise kuupÃ¤ev',0),(12253,341,'si','ZaÄetni datum vrednotenja',0),(12254,341,'ba','Mulai tanggal evaluasi',0),(12255,341,'nl','Begindatum van de evaluatie',0),(12256,341,'fi','Arviointi alkamispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(12257,341,'no','Startdatoen for evaluering',0),(12258,341,'da','Begyndelsen evaluering aldersbestemme',0),(12259,341,'ko','í‰ê°€ ë‚ ì§œë¥¼ ì‹œìž‘',0),(12260,341,'he','×”×¢×¨×›×” ×ª××¨×™×š ×ª×—×™×œ×ª',0),(12261,341,'el','Î‘Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(12262,341,'zh','æ•°æ®è¯„ä»·å¼€å§‹æ—¥æœŸ\r\n',0),(12263,341,'sv','Startdatum fÃ¶r utvÃ¤rdering',0),(12264,341,'it','Data di valutazione iniziale',0),(12265,341,'tl','',0),(12266,341,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3619;&#3634;&#3588;&#3634;',0),(12267,341,'hi','à¤¶à¥à¤°à¥à¤†à¤¤ à¤®à¥‚à¤²à¥à¤¯à¤¾à¤‚à¤•à¤¨ à¤¤à¤¿à¤¥à¤¿',0),(12268,341,'ms','Mulai tarikh penilaian',0),(12269,341,'ar','Ø§Ø¨ØªØ¯Ø§Ø¡ Ù…Ù† ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙ‚ÙŠÙŠÙ…',0),(12270,341,'fr','Date d\'Ã©valuation dÃ©but',0),(12271,341,'jp','è©•ä¾¡é–‹å§‹æ—¥',0),(12272,341,'pt','Data de avaliaÃ§Ã£o inicial',0),(12273,341,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¾Ñ†ÐµÐ½ÐºÐ¸',0),(12274,341,'es','Fecha de Inicial de la EvaluaciÃ³n',0),(12275,341,'de','Anfangsdatum Bewertung',0),(12276,341,'en','Beginning Evaluation Date',0),(12277,342,'is','',0),(12278,342,'dr','Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹',0),(12279,342,'pr','Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹',0),(12280,342,'tr','Ay baÅŸÄ±nda',0),(12281,342,'pl','PoczÄ…tek miesiÄ…ca',0),(12282,342,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð¼ÐµÑÐµÑ†',0),(12283,342,'ur','Ø´Ø±ÙˆØ¹ Ù…ÛÛŒÙ†Û',0),(12284,342,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð¼ÐµÑÐµÑ†Ð°',0),(12285,342,'vi','ThÃ¡ng báº¯t Ä‘áº§u',0),(12286,342,'af','Begin Maand',0),(12287,342,'ro','ÃŽncepÃ¢nd cu luna',0),(12288,342,'et','Algav kuu',0),(12289,342,'si','ZaÄetku meseca',0),(12290,342,'ba','Awal bulan',0),(12291,342,'nl','Begin maand',0),(12292,342,'fi','Kuun alussa',0),(12293,342,'no','Begynnelsen mÃ¥ned',0),(12294,342,'da','Begyndelsen mÃ¥ned',0),(12295,342,'ko','ë‹¬ ì‹œìž‘',0),(12296,342,'he','×—×•×“×© ×”×ª×—×œ×”',0),(12297,342,'el','Î‘ÏÏ‡Î® Ï„Î¿Ï… Î¼Î®Î½Î±',0),(12298,342,'zh','æœ¬æœˆå¼€å§‹\r\n',0),(12299,342,'sv','BÃ¶rjan mÃ¥nad',0),(12300,342,'it','Inizio mese',0),(12301,342,'tl','',0),(12302,342,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(12303,342,'hi','à¤®à¤¾à¤¹ à¤•à¥€ à¤¶à¥à¤°à¥à¤†à¤¤',0),(12304,342,'ms','Mulai bulan',0),(12305,342,'ar','Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø´Ù‡Ø±',0),(12306,342,'fr','Mois de dÃ©but',0),(12307,342,'jp','é–‹å§‹æœˆ',0),(12308,342,'pt','MÃªs de inÃ­cio',0),(12309,342,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð¼ÐµÑÑÑ†Ð°',0),(12310,342,'es','Mes Inicial',0),(12311,342,'de','Anfang Monat',0),(12312,342,'en','Beginning Month',0),(12313,343,'is','',0),(12314,343,'dr','Ù…Ø²Ø§ÙŠØ§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(12315,343,'pr','Ù…Ø²Ø§ÙŠØ§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(12316,343,'tr','YararlarÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(12317,343,'pl','KorzyÅ›ci pomyÅ›lnie zaktualizowana',0),(12318,343,'bg','ÐžÐ±ÐµÐ·Ñ‰ÐµÑ‚ÐµÐ½Ð¸Ñ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(12319,343,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ ÙÙˆØ§Ø¦Ø¯',0),(12320,343,'sr','ÐŸÑ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(12321,343,'vi','Cáº­p Nháº­t Lá»£i Ãch thÃ nh cÃ´ng',0),(12322,343,'af','Voordele Suksesvol Opdateer',0),(12323,343,'ro','Beneficiile actualizat cu succes',0),(12324,343,'et','VÃ¤rskendatud kasu',0),(12325,343,'si','Koristi uspeÅ¡no posodobljena',0),(12326,343,'ba','Manfaat yang berhasil',0),(12327,343,'nl','Voordelen bijgewerkt',0),(12328,343,'fi','Edut pÃ¤ivitetty',0),(12329,343,'no','Fordeler oppdatert',0),(12330,343,'da','Fordele opdateret',0),(12331,343,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” í˜œíƒ',0),(12332,343,'he','×™×ª×¨×•× ×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(12333,343,'el','ÎŸÏ†Î­Î»Î· Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(12334,343,'zh','åˆ©ç›ŠæˆåŠŸæ›´æ–°\r\n',0),(12335,343,'sv','FÃ¶rdelar uppdaterats',0),(12336,343,'it','Benefici aggiornati con successo',0),(12337,343,'tl','',0),(12338,343,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3636;&#3607;&#3608;&#3636;&#3611;&#3619;&#3632;&#3650;&#3618;&#3594;&#3609;&#3660;&#3611;&#3619;&#3632;&#3626;&#3610;&#3588;&#3623;&#3634;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(12339,343,'hi','à¤²à¤¾à¤­à¥‹à¤‚ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(12340,343,'ms','Faedah-faedah yang berjaya dikemas kini',0),(12341,343,'ar','ÙÙˆØ§Ø¦Ø¯ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(12342,343,'fr','Avantages mis Ã  jour avec succÃ¨s',0),(12343,343,'jp','çµ¦ä»˜é‡‘ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(12344,343,'pt','BenefÃ­cios atualizados com sucesso',0),(12345,343,'ru','ÐŸÑ€ÐµÐ¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(12346,343,'es','Beneficios Actualizados Exitosamente',0),(12347,343,'de','Vorteile, die erfolgreich aktualisiert',0),(12348,343,'en','Benefits Updated Successfully',0),(12349,344,'is','',0),(12350,344,'dr','ÙØ±Ø§ØªØ± Ø§Ø²  Ø¯ÙˆØ±Ù‡ ØªØ®ÙÙŠÙ',0),(12351,344,'pr','ÙØ±Ø§ØªØ± Ø§Ø²  Ø¯ÙˆØ±Ù‡ ØªØ®ÙÙŠÙ',0),(12352,344,'tr','Ã–tesinde<br>DÃ¶nem indirim',0),(12353,344,'pl','Poza<br>ZniÅ¼ki okres',0),(12354,344,'bg','ÐžÑ‚Ð²ÑŠÐ´<br>ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(12355,344,'ur','Ø³Û’ Ø¢Ú¯Û’<br>Ø¯ÙˆØ± ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(12356,344,'sr','Ð˜Ð·Ð²Ð°Ð½<br>ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(12357,344,'vi','TrÃªnthá»i ká»³ chiáº¿t kháº¥u',0),(12358,344,'af','Na afloop<br>Korting Periode',0),(12359,344,'ro','Dincolo de<br>Reducere perioada',0),(12360,344,'et','Kaugemale<br>Allahindluse perioodil',0),(12361,344,'si','Beyond<br>Popust obdobje',0),(12362,344,'ba','Beyond<br>DISKON TERBAIK untuk periode',0),(12363,344,'nl','Buiten<br>Goedkope periode',0),(12364,344,'fi','Beyond<br>Alennuskauden',0),(12365,344,'no','Utover<br>Rabatt perioden',0),(12366,344,'da','Ud over<br>Discount periode',0),(12367,344,'ko','ë„˜ì–´<br>ê¸°ê°„ í• ì¸',0),(12368,344,'he','×ž×¢×‘×¨<br>×”× ×—×” ×œ×ª×§×•×¤×”',0),(12369,344,'el','Î Î­ÏÎ± Î±Ï€ÏŒ<br>Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(12370,344,'zh','ä»¥ä¸ŠæŠ˜æ‰£ä¼˜æƒ æœŸ',0),(12371,344,'sv','UtÃ¶ver<br>Rabatt Period',0),(12372,344,'it','Di lÃ <br>Periodo di sconto',0),(12373,344,'tl','',0),(12374,344,'th','&#3609;&#3629;&#3585;&#3592;&#3634;&#3585;&#3609;&#3637;&#3657;<br>&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(12375,344,'hi','à¤¸à¥‡ à¤ªà¤°à¥‡<br>à¤›à¥‚à¤Ÿ à¤•à¥€ à¤…à¤µà¤§à¤¿',0),(12376,344,'ms','Luar<br>Diskaun tempoh',0),(12377,344,'ar','Ø¥Ù„Ù‰ Ù…Ø§ Ø¨Ø¹Ø¯<br>Ø®ØµÙ… Ø§Ù„ÙØªØ±Ø©',0),(12378,344,'fr','Au-delÃ  de<br>PÃ©riode de remise',0),(12379,344,'jp','ãƒ‡ã‚£ã‚¹ã‚«ã‚¦ãƒ³ãƒˆæœŸé–“å¾Œ',0),(12380,344,'pt','AlÃ©m da<br>PerÃ­odo de desconto',0),(12381,344,'ru','Ð—Ð° Ð¿Ñ€ÐµÐ´ÐµÐ»Ð°Ð¼Ð¸<br>Ð›ÑŒÐ³Ð¾Ñ‚Ð½Ñ‹Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(12382,344,'es','Fuera de<br>PerÃ­odo de Descuento',0),(12383,344,'de','DarÃ¼ber hinaus<br>Rabatt-Zeitraum',0),(12384,344,'en','Beyond<br>Discount Period',0),(12385,345,'is','',0),(12386,345,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(12387,345,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(12388,345,'tr','Bill Ekle',0),(12389,345,'pl','Bill dodaÄ‡',0),(12390,345,'bg','Ð‘Ð¸Ð» Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(12391,345,'ur','Ø¨Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(12392,345,'sr','Ð‘Ð¸Ð» Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ',0),(12393,345,'vi','ThÃªm HÃ³a ÄÆ¡n',0),(12394,345,'af','Wetsontwerp voeg',0),(12395,345,'ro','Bill Adauga',0),(12396,345,'et','Arve lisa',0),(12397,345,'si','Zakona dodati',0),(12398,345,'ba','Bill menambahkan',0),(12399,345,'nl','Bill toevoegen',0),(12400,345,'fi','Bill lisÃ¤Ã¤',0),(12401,345,'no','Bill legge',0),(12402,345,'da','Bill tilfÃ¸je',0),(12403,345,'ko','ë¹Œ ì¶”ê°€',0),(12404,345,'he','×”×•×¡×¤×ª ',0),(12405,345,'el','Bill Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(12406,345,'zh','æ–°å¢žå¸å•\r\n',0),(12407,345,'sv','Bill lÃ¤gga till',0),(12408,345,'it','Bill aggiungere',0),(12409,345,'tl','',0),(12410,345,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3636;&#3621;',0),(12411,345,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(12412,345,'ms','Rang undang-undang Tambah',0),(12413,345,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ù…ÙˆØ±Ù‘Ø¯',0),(12414,345,'fr','Projet de loi ajoute',0),(12415,345,'jp','è«‹æ±‚æ›¸ã?®è¿½åŠ ',0),(12416,345,'pt','Bill adicionar',0),(12417,345,'ru','Ð‘Ð¸Ð»Ð» Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(12418,345,'es','Agregar Factura',0),(12419,345,'de','Bill hinzufÃ¼gen',0),(12420,345,'en','Bill Add',0),(12421,346,'is','',0),(12422,346,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(12423,346,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(12424,346,'tr','Bill baÅŸarÄ±yla eklendi',0),(12425,346,'pl','Bill dodano pomyÅ›lnie',0),(12426,346,'bg','Ð‘Ð¸Ð» Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(12427,346,'ur','Ø¨Ù„ Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(12428,346,'sr','Ð‘Ð¸Ð» Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(12429,346,'vi','ThÃªm HÃ³a ÄÆ¡n thÃ nh cÃ´ng',0),(12430,346,'af','Rekening suksesvol bygevoeg',0),(12431,346,'ro','Bill adÄƒugat cu succes',0),(12432,346,'et','Bill lisatud',0),(12433,346,'si','Bill uspeÅ¡no dodani',0),(12434,346,'ba','Bill ditambahkan berhasil',0),(12435,346,'nl','Bill toegevoegd',0),(12436,346,'fi','Bill lisÃ¤Ã¤minen onnistui',0),(12437,346,'no','Bill lagt',0),(12438,346,'da','Bill tilfÃ¸jet',0),(12439,346,'ko','ë¹Œì€ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(12440,346,'he','×—×©×‘×•×Ÿ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(12441,346,'el','Bill Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(12442,346,'zh','å¸å•æ·»åŠ æˆåŠŸ\r\n',0),(12443,346,'sv','Bill lagts',0),(12444,346,'it','Bill aggiunto con successo',0),(12445,346,'tl','',0),(12446,346,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3636;&#3621;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(12447,346,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(12448,346,'ms','Rang undang-undang berjaya menambah',0),(12449,346,'ar','Ø£Ø¶ÙŠÙØª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(12450,346,'fr','Bill a ajoutÃ© avec succÃ¨s',0),(12451,346,'jp','è«‹æ±‚æ›¸ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(12452,346,'pt','Bill adicionado com sucesso',0),(12453,346,'ru','Ð‘Ð¸Ð»Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(12454,346,'es','Factura Agregada Exitosamente',0),(12455,346,'de','Bill wurde erfolgreich hinzugefÃ¼gt.',0),(12456,346,'en','Bill added successfully',0),(12457,347,'is','',0),(12458,347,'dr','Ø­Ø°Ù ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(12459,347,'pr','Ø­Ø°Ù ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(12460,347,'tr','Bill baÅŸarÄ±yla silindi.',0),(12461,347,'pl','Bill usuniÄ™te pomyÅ›lnie.',0),(12462,347,'bg','Ð‘Ð¸Ð» Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(12463,347,'ur','Ø¨Ù„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(12464,347,'sr','Ð‘Ð¸Ð» Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(12465,347,'vi','XÃ³a HÃ³a ÄÆ¡n thÃ nh cÃ´ng',0),(12466,347,'af','Rekening suksesvol geskrap',0),(12467,347,'ro','Bill ÅŸters cu succes.',0),(12468,347,'et','Arve kustutati edukalt',0),(12469,347,'si','Bill uspeÅ¡no izbrisana.',0),(12470,347,'ba','Bill berhasil dihapus.',0),(12471,347,'nl','Bill verwijderd.',0),(12472,347,'fi','Bill poistettu.',0),(12473,347,'no','Bill er slettet.',0),(12474,347,'da','Bill slettet.',0),(12475,347,'ko','ë¹Œì—ì„œ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(12476,347,'he','×”×—×©×‘×•×Ÿ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(12477,347,'el','Bill Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(12478,347,'zh','å¸å•åˆ é™¤æˆåŠŸã€‚\r\n',0),(12479,347,'sv','Bill raderades.',0),(12480,347,'it','Bill eliminato con successo.',0),(12481,347,'tl','',0),(12482,347,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3610;&#3636;&#3621;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(12483,347,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾à¥¤',0),(12484,347,'ms','Rang undang-undang dihapuskan dengan jayanya.',0),(12485,347,'ar','Ø­Ø°ÙØª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(12486,347,'fr','Bill supprimÃ© avec succÃ¨s.',0),(12487,347,'jp','è«‹æ±‚æ›¸ã‚’æ¶ˆåŽ»ã?—ã?¾ã?—ã?Ÿ',0),(12488,347,'pt','Bill excluÃ­do com sucesso.',0),(12489,347,'ru','Ð‘Ð¸Ð»Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(12490,347,'es','Factura Eliminada Exitosamente',0),(12491,347,'de','Bill erfolgreich gelÃ¶scht.',0),(12492,347,'en','Bill deleted successfully.',0),(12493,348,'is','',0),(12494,348,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø´Ù†Ø§Ø³Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(12495,348,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø´Ù†Ø§Ø³Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(12496,348,'tr','Kambiyo senedi kodu #',0),(12497,348,'pl','Bill id #',0),(12498,348,'bg','Ð‘Ð¸Ð» id #',0),(12499,348,'ur','Ø¨Ù„ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª #',0),(12500,348,'sr','Ð‘Ð¸Ð» Ð¸Ð´ #',0),(12501,348,'vi','Sá»‘ ID cá»§a hÃ³a Ä‘Æ¡n',0),(12502,348,'af','Wetsontwerp id #',0),(12503,348,'ro','Bill id #',0),(12504,348,'et','Arve id #',0),(12505,348,'si','Bill id #',0),(12506,348,'ba','Bill id #',0),(12507,348,'nl','Bill id #',0),(12508,348,'fi','Vekselin tunnus #',0),(12509,348,'no','Veksel-id #',0),(12510,348,'da','Veksel-id #',0),(12511,348,'ko','ë¹Œ id #',0),(12512,348,'he','×‘×™×œ id #',0),(12513,348,'el','Bill id #',0),(12514,348,'zh','å¸å•èº«åˆ†è¯ï¼ƒ\r\n',0),(12515,348,'sv','VÃ¤xel-id #',0),(12516,348,'it','Id Bill #',0),(12517,348,'tl','',0),(12518,348,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3586;&#3629;&#3591;&#3610;&#3636;&#3621;',0),(12519,348,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤†à¤ˆà¤¡à¥€ #',0),(12520,348,'ms','Rang undang-undang id #',0),(12521,348,'ar','Ø±Ù‚Ù… Ù…Ø¹Ø±Ù‘Ù Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(12522,348,'fr','Id de Bill #',0),(12523,348,'jp','è«‹æ±‚æ›¸ID#',0),(12524,348,'pt','IdentificaÃ§Ã£o de Bill #',0),(12525,348,'ru','Ð‘Ð¸Ð»Ð» id #',0),(12526,348,'es','Factura ID #',0),(12527,348,'de','Bill Id #',0),(12528,348,'en','Bill id #',0),(12529,349,'is','',0),(12530,349,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(12531,349,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(12532,349,'tr','Bill beklemeye',0),(12533,349,'pl','Bill zawieszone',0),(12534,349,'bg','Ð‘Ð¸Ð» Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½',0),(12535,349,'ur','ÛÙˆÙ„Úˆ Ù¾Ø± Ø¨Ù„',0),(12536,349,'sr','Ð‘Ð¸Ð» Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(12537,349,'vi','HÃ³a ÄÆ¡n Táº¡m Ngá»«ng',0),(12538,349,'af','Wetsontwerp op hou',0),(12539,349,'ro','Bill pe \"hold\"',0),(12540,349,'et','Bill ootel',0),(12541,349,'si','Bill na Äakanju',0),(12542,349,'ba','Bill ditunda',0),(12543,349,'nl','Bill in de wachtstand',0),(12544,349,'fi','Bill pitoon',0),(12545,349,'no','Bill pÃ¥ vent',0),(12546,349,'da','Bill pÃ¥ Hold',0),(12547,349,'ko','ì— ë¹Œ',0),(12548,349,'he','×—×©×‘×•×Ÿ ×‘×”×ž×ª× ×”',0),(12549,349,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Î³Î¹Î± Ï„Î¿Î½ Î±Î½Î±Î¼Î¿Î½Î®',0),(12550,349,'zh','ä¿æŒå¸å•\r\n',0),(12551,349,'sv','Bill pÃ¥ is',0),(12552,349,'it','Bill in attesa',0),(12553,349,'tl','',0),(12554,349,'th','&#3610;&#3636;&#3621;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3586;&#3603;&#3632;&#3609;&#3637;&#3657;',0),(12555,349,'hi','à¤ªà¤•à¤¡à¤¼ à¤ªà¤° à¤µà¤¿à¤§à¥‡à¤¯à¤•',0),(12556,349,'ms','Rang undang-undang penahanan',0),(12557,349,'ar','Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ø¨Ø´Ø£Ù† Ø¹Ù‚Ø¯',0),(12558,349,'fr','Projet de loi en attente',0),(12559,349,'jp','ä¿?ç•™è«‹æ±‚æ›¸',0),(12560,349,'pt','Bill em espera',0),(12561,349,'ru','Ð¡Ñ‡ÐµÑ‚ Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(12562,349,'es','Factura en Espera',0),(12563,349,'de','Bill auf Eis',0),(12564,349,'en','Bill On Hold',0),(12565,350,'is','',0),(12566,350,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ',0),(12567,350,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ',0),(12568,350,'tr','Accts tahsil edilecek<br>Kurulum',0),(12569,350,'pl','Accts naleÅ¼noÅ›ci<br>Instalator',0),(12570,350,'bg','Accts Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ<br>ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(12571,350,'ur','Ø¬Ø§Ø¦Ø² Ø§Ú©Ú©ØªØ³<br>Ø³ÛŒÙ¹ Ø§Ù¾',0),(12572,350,'sr','ÐÑ†Ñ†Ñ‚Ñ Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°<br>ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(12573,350,'vi','TK Pháº£i Tráº£Setup',0),(12574,350,'af','Accts ontvangbaar<br>Opstelling',0),(12575,350,'ro','Accts de primit<br>Programul de instalare',0),(12576,350,'et','Accts nÃµue<br>Seadistamine',0),(12577,350,'si','Accts terjatev<br>Nastavitev',0),(12578,350,'ba','Accts piutang<br>Setup',0),(12579,350,'nl','Accts vordering<br>Setup',0),(12580,350,'fi','Accts saaminen<br>Asetukset',0),(12581,350,'no','Accts fordringer<br>Installasjonsprogrammet',0),(12582,350,'da','Accts tilgodehavende<br>OpsÃ¦tning',0),(12583,350,'ko','Accts ë¯¸ìˆ˜ê¸ˆ<br>ì„¤ì¹˜',0),(12584,350,'he','Accts ×œ×’×‘×™×™×”<br>×ª×•×›× ×™×ª ×”×”×ª×§× ×”',0),(12585,350,'el','Î•Î¹ÏƒÏ€ÏÎ±ÎºÏ„Î­Î¿Î¹ accts<br>Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(12586,350,'zh','å¸åŠ¡è®¾ç½®åº”æ”¶\r\n',0),(12587,350,'sv','Accts fordran<br>Setup',0),(12588,350,'it','Accts Receivable<br>Installazione',0),(12589,350,'tl','',0),(12590,350,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(12591,350,'hi','Accts à¤ªà¥à¤°à¤¾à¤ªà¥à¤¯<br>à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(12592,350,'ms','Akan diterima Accts<br>Persediaan',0),(12593,350,'ar','Accts Ø§Ù„Ù…Ø³ØªØ­Ù‚<br>Ø¨Ø±Ù†Ø§Ù…Ø¬ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(12594,350,'fr','Comptes Ã  recevoir<br>Programme d\'installation',0),(12595,350,'jp','å£²æŽ›é‡‘<br>ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(12596,350,'pt','Accts Receivable<br>InstalaÃ§Ã£o',0),(12597,350,'ru','Ð¡Ñ‡ÐµÑ‚Ð¾Ð² Ðº Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ÑŽ<br>Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ°',0),(12598,350,'es','Cuentas por Cobrar<br>Iniciar',0),(12599,350,'de','Accts Debitorenbuchhaltung<br>Setup',0),(12600,350,'en','Accts Receivable<br>Setup',0),(12601,351,'is','',0),(12602,351,'dr','Ø§Ø±Ø³Ø§Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ù‡Øª Ø§Ø·Ù„Ø§Ø¹ ',0),(12603,351,'pr','Ø§Ø±Ø³Ø§Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ù‡Øª Ø§Ø·Ù„Ø§Ø¹ ',0),(12604,351,'tr','Attn fatura',0),(12605,351,'pl','Bill kontakt',0),(12606,351,'bg','Ð—Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð·Ð° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸ÐµÑ‚Ð¾',0),(12607,351,'ur','Ø¨Ù„ Ø§Ù¹Ù¹Ù† Ù…ÛŒÚº',0),(12608,351,'sr','Ð‘Ð¸Ð» Ð´Ð° ÐÑ‚Ñ‚Ð½',0),(12609,351,'vi','NgÆ°á»i Nháº­n',0),(12610,351,'af','Wetsontwerp Attn',0),(12611,351,'ro','Proiect de lege Attn',0),(12612,351,'et','Arve saaja (nimi vÃµi osakond)',0),(12613,351,'si','RaÄun â€“ v vednost',0),(12614,351,'ba','Tagihan untuk Attn',0),(12615,351,'nl','T.a.v. voor factuur',0),(12616,351,'fi','Yhteystiedot Bill',0),(12617,351,'no','Fakturagate Attn',0),(12618,351,'da','Bill til ATT',0),(12619,351,'ko','ë‹´ë‹¹ìžë¥¼ ë¹Œ',0),(12620,351,'he','×‘×™×œ ×œ×™×“×™',0),(12621,351,'el','Bill Î½Î± Attn',0),(12622,351,'zh','è®¡è´¹åˆ°ç»åŠžäºº\r\n',0),(12623,351,'sv','Bill till att.',0),(12624,351,'it','Bill a Attn',0),(12625,351,'tl','',0),(12626,351,'th','&#3626;&#3656;&#3591;&#3610;&#3636;&#3621;&#3606;&#3638;&#3591;&#3612;&#3641;&#3657;&#3619;&#3633;&#3610;',0),(12627,351,'hi','Attn à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²',0),(12628,351,'ms','Rang undang-undang untuk U.p.',0),(12629,351,'ar','ØªÙˆØ¬ÙŠÙ‡ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(12630,351,'fr','Projet de loi Ã  l\'adresse suivante',0),(12631,351,'jp','è«‹æ±‚å…ˆ',0),(12632,351,'pt','Projeto de lei para a/c',0),(12633,351,'ru','Ð‘Ð¸Ð»Ð» Ðº ÐºÐ¾Ð¼Ñƒ',0),(12634,351,'es','Facturar a la Attn.',0),(12635,351,'de','Gesetzentwurf zur Attn',0),(12636,351,'en','Bill To Attn',0),(12637,352,'is','',0),(12638,352,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(12639,352,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(12640,352,'tr','Fatura gÃ¼ncelleÅŸtirme',0),(12641,352,'pl','Bill aktualizacji',0),(12642,352,'bg','Ð‘Ð¸Ð» Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(12643,352,'ur','Ø¨Ù„ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(12644,352,'sr','Ð‘Ð¸Ð» Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(12645,352,'vi','Cáº­p Nháº­t HÃ³a ÄÆ¡n',0),(12646,352,'af','Wetsontwerp bywerking',0),(12647,352,'ro','Bill Update',0),(12648,352,'et','Bill uuendamine',0),(12649,352,'si','Posodobitev zakona',0),(12650,352,'ba','Bill Update',0),(12651,352,'nl','Bill Update',0),(12652,352,'fi','Bill pÃ¤ivitys',0),(12653,352,'no','Bill oppdatering',0),(12654,352,'da','Bill opdatering',0),(12655,352,'ko','ë¹Œ ì—…ë°ì´íŠ¸',0),(12656,352,'he','×¢×“×›×•×Ÿ ×—×©×‘×•×Ÿ',0),(12657,352,'el','Bill ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(12658,352,'zh','å¸å•æ›´æ–°\r\n',0),(12659,352,'sv','Bill uppdatering',0),(12660,352,'it','Aggiornamento di Bill',0),(12661,352,'tl','',0),(12662,352,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3636;&#3621;',0),(12663,352,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(12664,352,'ms','Rang undang-undang Update',0),(12665,352,'ar','ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(12666,352,'fr','Mise Ã  jour du projet de loi',0),(12667,352,'jp','è«‹æ±‚æ›¸æ›´æ–°',0),(12668,352,'pt','AtualizaÃ§Ã£o de conta',0),(12669,352,'ru','Ð‘Ð¸Ð»Ð» Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(12670,352,'es','Actualizar Factura',0),(12671,352,'de','Bill-Update',0),(12672,352,'en','Bill Update',0),(12673,353,'is','',0),(12674,353,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(12675,353,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(12676,353,'tr','Bill baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(12677,353,'pl','Bill pomyÅ›lnie zaktualizowana',0),(12678,353,'bg','Ð‘Ð¸Ð» Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(12679,353,'ur','Ø¨Ù„ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(12680,353,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(12681,353,'vi','Cáº­p Nháº­t HÃ³a ÄÆ¡n thÃ nh cÃ´ng',0),(12682,353,'af','Rekening Suksesvol Opdateer',0),(12683,353,'ro','Bill actualizat cu succes',0),(12684,353,'et','Bill vÃ¤rskendamine Ãµnnestus',0),(12685,353,'si','Bill uspeÅ¡no posodobljena',0),(12686,353,'ba','Bill berhasil diperbarui',0),(12687,353,'nl','Bill bijgewerkt',0),(12688,353,'fi','Bill pÃ¤ivitetty',0),(12689,353,'no','Bill oppdatert',0),(12690,353,'da','Bill opdateret',0),(12691,353,'ko','ë¹Œ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(12692,353,'he','×‘×™×œ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(12693,353,'el','Bill ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(12694,353,'zh','å¸å•å·²æˆåŠŸæ›´æ–°\r\n',0),(12695,353,'sv','Bill uppdaterats',0),(12696,353,'it','Bill aggiornato con successo',0),(12697,353,'tl','',0),(12698,353,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3636;&#3621;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(12699,353,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(12700,353,'ms','Rang undang-undang berjaya dikemas kini',0),(12701,353,'ar','Ø­Ø¯Ù‘Ø«Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(12702,353,'fr','Projet de loi mis Ã  jour avec succÃ¨s',0),(12703,353,'jp','è«‹æ±‚æ›¸ã‚’æ›´æ–°ã?—ã?¾ã?—ã?Ÿ',0),(12704,353,'pt','Bill atualizado com sucesso',0),(12705,353,'ru','Ð‘Ð¸Ð»Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(12706,353,'es','Factura Actualizada Exitosamente',0),(12707,353,'de','Bill erfolgreich aktualisiert',0),(12708,353,'en','Bill Updated Successfully',0),(12709,354,'is','',0),(12710,354,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø§ Ø§ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(12711,354,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø§ Ø§ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(12712,354,'tr','Bill ile girmiÅŸ bu fatura numarasÄ±.',0),(12713,354,'pl','Bill z tym juÅ¼ wprowadzony numer faktury.',0),(12714,354,'bg','Ð‘Ð¸Ð» Ñ Ñ‚Ð¾Ð·Ð¸ Ð²ÐµÑ‡Ðµ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°.',0),(12715,354,'ur','Ø¨Ù„ Ù¾ÛÙ„Û’ ÛÛŒ Ø¯Ø§Ø®Ù„ ÛÙˆØ¦Û’ Ø§Ø³ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ú©Û’ Ø³Ø§ØªÚ¾ ÛÛ’ Û”',0),(12716,354,'sr','Ð‘Ð¸Ð»Ð» Ñ˜Ðµ ÑÐ° Ð¾Ð²Ð¸Ð¼ Ð±Ñ€Ð¾Ñ˜ÐµÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð²ÐµÑ› ÑƒÐ½ÐµÐ»Ð¸.',0),(12717,354,'vi','HÃ³a ÄÆ¡n Vá»›i Sá»‘ NÃ y ÄÃ£ tá»“n táº¡i.',0),(12718,354,'af','Wetsontwerp met hierdie faktuur nommer reeds ingeskryf.',0),(12719,354,'ro','Proiectul de lege cu acest numÄƒr de facturÄƒ deja introduse.',0),(12720,354,'et','Sellise arvenumbriga arve on juba olemas',0),(12721,354,'si','ObraÄun s to Å¡tevilko raÄuna, ki so Å¾e vpisana.',0),(12722,354,'ba','Bill dengan nomor faktur ini sudah masuk.',0),(12723,354,'nl','Bill met dit factuurnummer al ingevoerd.',0),(12724,354,'fi','TÃ¤mÃ¤n laskunumero syÃ¶tetty lasku.',0),(12725,354,'no','Regning med denne fakturanummeret allerede angitt.',0),(12726,354,'da','Bill med denne fakturanummer allerede er angivet.',0),(12727,354,'ko','ì´ë¯¸ ìž…ë ¥ì´ ì†¡ìž¥ ë²ˆí˜¸ ë¹Œìž…ë‹ˆë‹¤.',0),(12728,354,'he','×‘×™×œ ×¢× ×–×” ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª ×©×›×‘×¨ ×”×•×–× ×•.',0),(12729,354,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Î¼Îµ Î±Ï…Ï„ÏŒ Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£ Î®Î´Î· ÎµÎ¹ÏƒÎ­Î»Î¸ÎµÎ¹.',0),(12730,354,'zh','æœ‰è¯¥å‘ç¥¨å·ç çš„å¸å•å·²è¾“å…¥ã€‚\r\n',0),(12731,354,'sv','Bill med denna fakturanummer som redan har registrerats.',0),(12732,354,'it','Bill con questo numero di fattura giÃ  inserito.',0),(12733,354,'tl','',0),(12734,354,'th','&#3610;&#3636;&#3621;&#3651;&#3610;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3609;&#3637;&#3657;&#3652;&#3604;&#3657;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3649;&#3621;&#3',0),(12735,354,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤‡à¤¸ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤•à¥‡ à¤¸à¤¾à¤¥à¥¤',0),(12736,354,'ms','Rang undang-undang dengan nombor invois ini sudah dimasukkan.',0),(12737,354,'ar','Ù‡Ø°Ø§ Ø§Ù„Ø±Ù‚Ù… Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(12738,354,'fr','Projet de loi portant ce numÃ©ro de facture dÃ©jÃ  entrÃ©.',0),(12739,354,'jp','ã?“ã?®è«‹æ±‚æ›¸ç•ªå?·ã?§ã?®è«‹æ±‚æ›¸ã?¯æ—¢ã?«å…¥åŠ›ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(12740,354,'pt','Bill com este nÃºmero de factura jÃ¡ entrado.',0),(12741,354,'ru','Ð‘Ð¸Ð»Ð» Ñ ÑÑ‚Ð¾Ð¹ ÑƒÐ¶Ðµ Ð²Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°.',0),(12742,354,'es','Facturar con este numero de Factura ya entrada.',0),(12743,354,'de','Rechnung mit dieser Rechnungsnummer eingetragen.',0),(12744,354,'en','Bill with this invoice number already entered.',0),(12745,355,'is','',0),(12746,355,'dr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ',0),(12747,355,'pr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ',0),(12748,355,'tr','Fatura',0),(12749,355,'pl','Zapowiadane',0),(12750,355,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸',0),(12751,355,'ur','Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(12752,355,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(12753,355,'vi','Láº­p HÃ³a ÄÆ¡n',0),(12754,355,'af','WeerspieÃ«l',0),(12755,355,'ro','Facturat',0),(12756,355,'et','Arve esitatud',0),(12757,355,'si','ZaraÄunavajo',0),(12758,355,'ba','Ditagih',0),(12759,355,'nl','Gefactureerd',0),(12760,355,'fi','Laskutetaan',0),(12761,355,'no','Fakturert',0),(12762,355,'da','Faktureret',0),(12763,355,'ko','ì²­êµ¬',0),(12764,355,'he','×—×•×™×‘',0),(12765,355,'el','Î§ÏÎµÏŽÎ½ÎµÏ„Î±Î¹',0),(12766,355,'zh','å¼€è´¦å•\r\n',0),(12767,355,'sv','Faktureras',0),(12768,355,'it','Fatturati',0),(12769,355,'tl','',0),(12770,355,'th','&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;',0),(12771,355,'hi','à¤¬à¤¿à¤² à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(12772,355,'ms','Dibilkan',0),(12773,355,'ar','ÙÙˆØ§ØªÙŠØ±',0),(12774,355,'fr','Bec',0),(12775,355,'jp','è«‹æ±‚æ¸ˆ',0),(12776,355,'pt','De bico',0),(12777,355,'ru','Ð’Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚',0),(12778,355,'es','Facturado',0),(12779,355,'de','In Rechnung gestellt',0),(12780,355,'en','Billed',0),(12781,356,'is','',0),(12782,356,'dr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ Ø³Ø§Ù„ ØªØ§Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(12783,356,'pr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ Ø³Ø§Ù„ ØªØ§Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(12784,356,'tr','Fatura YTD',0),(12785,356,'pl','Rozliczane OPR',0),(12786,356,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸ Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(12787,356,'ur','Ø¨Ø§Ù„Ù„Ø§Ø¯ ÛŒÙ¹Ø¯',0),(12788,356,'sr','ÐšÑƒÐ¿Ð¾Ð²Ð¸Ð½Ð° Ñ‚ÐµÑ€ÐµÑ‚Ð¸Ñ›Ðµ Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(12789,356,'vi','Láº­p HÃ³a ÄÆ¡n Tá»« Äáº§u NÄƒm Äáº¿n HÃ´m Nay',0),(12790,356,'af','Fakture Uitgereik YTD',0),(12791,356,'ro','YTD facturate',0),(12792,356,'et','Ostu kohta arveldus YTD',0),(12793,356,'si','Bremenjene YTD',0),(12794,356,'ba','Ditagih YTD',0),(12795,356,'nl','Gefactureerde YTD',0),(12796,356,'fi','Laskutetaan vuoden alusta',0),(12797,356,'no','Fakturerte YTD',0),(12798,356,'da','Faktureret Ã…TD',0),(12799,356,'ko','ì²­êµ¬ YTD',0),(12800,356,'he','×©×—×•×™×‘ ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(12801,356,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î¿ YTD',0),(12802,356,'zh','å¸å•å¹´æœˆæ—¥\r\n',0),(12803,356,'sv','Fakturerade YTD',0),(12804,356,'it','Fatturati YTD',0),(12805,356,'tl','',0),(12806,356,'th','&#3610;&#3636;&#3621; YTD',0),(12807,356,'hi','à¤–à¤¼à¤°à¥€à¤¦ YTD',0),(12808,356,'ms','THK dibilkan sebanyak',0),(12809,356,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(12810,356,'fr','YTD facturÃ©',0),(12811,356,'jp','å¹´é–“ç´¯è¨ˆè«‹æ±‚æ¸ˆ',0),(12812,356,'pt','YTD faturado',0),(12813,356,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ñ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð°',0),(12814,356,'es','Facturado AÃ±o a la Fecha (AAF)',0),(12815,356,'de','-Abrechnung YTD',0),(12816,356,'en','Billed YTD',0),(12817,357,'is','',0),(12818,357,'dr','Ù…ÙŠÙ„ÙŠØ§Ø±Ø¯',0),(12819,357,'pr','Ù…ÙŠÙ„ÙŠØ§Ø±Ø¯',0),(12820,357,'tr','milyar',0),(12821,357,'pl','mld euro',0),(12822,357,'bg','Ð¼Ð¸Ð»Ð¸Ð°Ñ€Ð´Ð°',0),(12823,357,'ur','Ø§Ø±Ø¨',0),(12824,357,'sr','Ð¼Ð¸Ð»Ð¸Ñ˜Ð°Ñ€Ð´Ð¸',0),(12825,357,'vi','Tá»·',0),(12826,357,'af','miljoen',0),(12827,357,'ro','miliarde de euro',0),(12828,357,'et','miljardit eurot',0),(12829,357,'si','milijard',0),(12830,357,'ba','miliar',0),(12831,357,'nl','miljard',0),(12832,357,'fi','miljardia euroa',0),(12833,357,'no','milliarder',0),(12834,357,'da','milliarder',0),(12835,357,'ko','10 ì–µ',0),(12836,357,'he','×ž×™×œ×™××¨×“',0),(12837,357,'el','Î´Î¹ÏƒÎµÎºÎ±Ï„Î¿Î¼Î¼ÏÏÎ¹Î¿',0),(12838,357,'zh','äº¿\r\n',0),(12839,357,'sv','miljarder',0),(12840,357,'it','miliardi',0),(12841,357,'tl','',0),(12842,357,'th','&#3614;&#3633;&#3609;&#3621;&#3657;&#3634;&#3609;',0),(12843,357,'hi','à¤…à¤°à¤¬',0),(12844,357,'ms','bilion',0),(12845,357,'ar','Ø¨Ù„ÙŠÙˆÙ† / Ù…Ù„ÙŠØ§Ø±',0),(12846,357,'fr','milliard',0),(12847,357,'jp','10å„„',0),(12848,357,'pt','bilhÃ£o',0),(12849,357,'ru','Ð¼Ð¸Ð»Ð»Ð¸Ð°Ñ€Ð´',0),(12850,357,'es','mil millÃ³n',0),(12851,357,'de','Milliarden',0),(12852,357,'en','billion',0),(12853,358,'is','',0),(12854,358,'dr','- ',0),(12855,358,'pr','ØªØ§Ø¨Ø¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡- ',0),(12856,358,'tr','BaÄŸlayÄ±cÄ± iÅŸlevi',0),(12857,358,'pl','Funkcja introligatornia',0),(12858,358,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(12859,358,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„',0),(12860,358,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°',0),(12861,358,'vi','Chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch',0),(12862,358,'af','Bindery funksie',0),(12863,358,'ro','FuncÅ£ia de legatorie',0),(12864,358,'et','Kirjansitomo funktsioon',0),(12865,358,'si','Knjigoveznica funkcijo',0),(12866,358,'ba','Bindery fungsi',0),(12867,358,'nl','Bindery functie',0),(12868,358,'fi','Bindery-funktio',0),(12869,358,'no','Binding-funksjonen',0),(12870,358,'da','Bindery funktion',0),(12871,358,'ko','ë°”ì¸ë”ë¦¬ í•¨ìˆ˜',0),(12872,358,'he','×¤×•× ×§×¦×™×” ×ž×¡×•×’ bindery',0),(12873,358,'el','Bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(12874,358,'zh','è£…è®¢åŠŸèƒ½\r\n',0),(12875,358,'sv','Bindery funktion',0),(12876,358,'it','Funzione della legatoria',0),(12877,358,'tl','',0),(12878,358,'th','&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;',0),(12879,358,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹',0),(12880,358,'ms','Fungsi bindery',0),(12881,358,'ar','Ø¯Ø§Ù„Ø© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(12882,358,'fr','Fonction de faÃ§onnage',0),(12883,358,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½',0),(12884,358,'pt','FunÃ§Ã£o de ligaÃ§Ã£o',0),(12885,358,'ru','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ',0),(12886,358,'es','FunciÃ³n de Encuadernadora',0),(12887,358,'de','Buchbinderei-Funktion',0),(12888,358,'en','Bindery Function',0),(12889,359,'is','',0),(12890,359,'dr','(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(12891,359,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ ØªØ§Ø¨Ø¹(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(12892,359,'tr','BaÄŸlayÄ±cÄ± iÅŸlevini baÅŸarÄ±yla eklendi.',0),(12893,359,'pl','Introligatornia Funkcja dodana pomyÅ›lnie.',0),(12894,359,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(12895,359,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(12896,359,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(12897,359,'vi','ThÃªm chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch thÃ nh cÃ´ng',0),(12898,359,'af','Bindery funksie suksesvol bygevoeg.',0),(12899,359,'ro','FuncÅ£ia de legatorie adÄƒugat cu succes.',0),(12900,359,'et','Kirjansitomo funktsiooni edukalt lisatud.',0),(12901,359,'si','Knjigoveznica funkcijo uspeÅ¡no dodana.',0),(12902,359,'ba','Fungsi bindery ditambahkan berhasil.',0),(12903,359,'nl','Bindery functie toegevoegd.',0),(12904,359,'fi','Kantata funktion lisÃ¤Ã¤minen onnistui.',0),(12905,359,'no','Bindingen funksjon lagt.',0),(12906,359,'da','Bindery funktion tilfÃ¸jet.',0),(12907,359,'ko','ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ëŠ” ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(12908,359,'he','×¤×•× ×§×¦×™×” ×ž×¡×•×’ bindery × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(12909,359,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± bindery Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(12910,359,'zh','è£…è®¢åŠŸèƒ½æ·»åŠ æˆåŠŸã€‚\r\n',0),(12911,359,'sv','Bindery funktion lagts.',0),(12912,359,'it','Funzione della legatoria aggiunta con successo.',0),(12913,359,'tl','',0),(12914,359,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(12915,359,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(12916,359,'ms','Fungsi bindery yang berjaya menambah.',0),(12917,359,'ar','ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(12918,359,'fr','Fonction de faÃ§onnage ajoutÃ©e avec succÃ¨s.',0),(12919,359,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(12920,359,'pt','FunÃ§Ã£o de bindery adicionado com Ãªxito.',0),(12921,359,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(12922,359,'es','Funciones de Encuadernadora Agregadas Exitosamente',0),(12923,359,'de','Buchbinderei-Funktion wurde erfolgreich hinzugefÃ¼gt.',0),(12924,359,'en','Bindery Function Added Successfully.',0),(12925,360,'is','',0),(12926,360,'dr','(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(12927,360,'pr','Ø­Ø°Ù ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ ØªØ§Ø¨Ø¹(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(12928,360,'tr','BaÄŸlayÄ±cÄ± iÅŸlevini baÅŸarÄ±yla silindi.',0),(12929,360,'pl','Introligatornia funkcja pomyÅ›lnie usuniÄ™ty.',0),(12930,360,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(12931,360,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(12932,360,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(12933,360,'vi','XÃ³a chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch thÃ nh cÃ´ng',0),(12934,360,'af','Bindery funksie suksesvol geskrap.',0),(12935,360,'ro','FuncÅ£ia de legatorie ÅŸters cu succes.',0),(12936,360,'et','Kirjansitomo funktsiooni edukalt kustutatud.',0),(12937,360,'si','Knjigoveznica funkcijo uspeÅ¡no izbrisana.',0),(12938,360,'ba','Bindery fungsi menghapus berhasil.',0),(12939,360,'nl','Bindery functie verwijderd.',0),(12940,360,'fi','Bindery-toiminto poistettu.',0),(12941,360,'no','Bindingen funksjon slettet.',0),(12942,360,'da','Bindery funktion slettet.',0),(12943,360,'ko','ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(12944,360,'he','×¤×•× ×§×¦×™×” ×ž×¡×•×’ bindery × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(12945,360,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± bindery Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(12946,360,'zh','è£…è®¢åŠŸèƒ½å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(12947,360,'sv','Bindery funktion raderades.',0),(12948,360,'it','Funzione della legatoria eliminata con successo.',0),(12949,360,'tl','',0),(12950,360,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(12951,360,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(12952,360,'ms','Bindery fungsi dihapuskan dengan jayanya.',0),(12953,360,'ar','ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(12954,360,'fr','Fonction de faÃ§onnage supprimÃ©e avec succÃ¨s.',0),(12955,360,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(12956,360,'pt','FunÃ§Ã£o de bindery excluÃ­da com sucesso.',0),(12957,360,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(12958,360,'es','Funciones de Encuadernadora Eliminadas Exitosamente',0),(12959,360,'de','Buchbinderei-Funktion wurde erfolgreich gelÃ¶scht.',0),(12960,360,'en','Bindery Function Deleted Successfully.',0),(12961,361,'is','',0),(12962,361,'dr','(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(12963,361,'pr','ØªØ§Ø¨Ø¹(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(12964,361,'tr','BaÄŸlayÄ±cÄ± iÅŸlevi bulunamadÄ±.',0),(12965,361,'pl','Funkcja wiÄ…zaÅ„ nie znaleziono.',0),(12966,361,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(12967,361,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(12968,361,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°.',0),(12969,361,'vi','KhÃ´ng tÃ¬m tháº¥y chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch',0),(12970,361,'af','Bindery funksie gevind nie.',0),(12971,361,'ro','Legatorie funcÅ£ia nu a fost gÄƒsit.',0),(12972,361,'et','Kirjansitomo funktsiooni ei leitud.',0),(12973,361,'si','Knjigoveznica funkcije ni mogoÄe najti.',0),(12974,361,'ba','Fungsi bindery tidak ditemukan.',0),(12975,361,'nl','Bindery functie niet gevonden.',0),(12976,361,'fi','Bindery-funktiota ei lÃ¶ydy.',0),(12977,361,'no','Bindingen funksjon ikke funnet.',0),(12978,361,'da','Bindery funktion blev ikke fundet.',0),(12979,361,'ko','ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(12980,361,'he','×¤×•× ×§×¦×™×” ×ž×¡×•×’ bindery ×œ× × ×ž×¦×.',0),(12981,361,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± bindery Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(12982,361,'zh','è£…è®¢åŠŸèƒ½æ²¡æœ‰æ‰¾åˆ°ã€‚\r\n',0),(12983,361,'sv','Bindery funktion inte finns.',0),(12984,361,'it','Funzione della legatoria non trovata.',0),(12985,361,'tl','',0),(12986,361,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;',0),(12987,361,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾à¥¤',0),(12988,361,'ms','Fungsi bindery yang tidak dijumpai.',0),(12989,361,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(12990,361,'fr','FaÃ§onnage fonction introuvable.',0),(12991,361,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã?Œã?¿ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(12992,361,'pt','FunÃ§Ã£o de ligaÃ§Ã£o nÃ£o foi encontrada.',0),(12993,361,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°.',0),(12994,361,'es','Funciones de Encuadernadora no se encuentra',0),(12995,361,'de','Buchbinderei-Funktion wurde nicht gefunden.',0),(12996,361,'en','Bindery Function not found.',0),(12997,362,'is','',0),(12998,362,'dr','(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(12999,362,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ ØªØ§Ø¨Ø¹(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13000,362,'tr','BaÄŸlayÄ±cÄ± iÅŸlevi boyutu baÅŸarÄ±yla eklendi.',0),(13001,362,'pl','Introligatornia funkcja rozmiar dodane pomyÅ›lnie.',0),(13002,362,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(13003,362,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ø³Ø§Ø¦Ø² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(13004,362,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(13005,362,'vi','KÃ­ch cá»¡ Ä‘Ã³ng sÃ¡ch thÃªm vÃ o thÃ nh cÃ´ng',0),(13006,362,'af','Bindery funksie grootte suksesvol bygevoeg.',0),(13007,362,'ro','Legatorie funcÅ£ia dimensiunea adÄƒugat cu succes.',0),(13008,362,'et','Kirjansitomo funktsiooni suuruse edukalt lisatud.',0),(13009,362,'si','Knjigoveznica funkcijo velikost uspeÅ¡no dodana.',0),(13010,362,'ba','Bindery fungsi ukuran ditambahkan berhasil.',0),(13011,362,'nl','Bindery functie grootte toegevoegd.',0),(13012,362,'fi','Kantata tehtÃ¤vÃ¤ koko lisÃ¤Ã¤minen onnistui.',0),(13013,362,'no','Bindingen funksjonen stÃ¸rrelse lagt.',0),(13014,362,'da','Bindery funktion stÃ¸rrelse tilfÃ¸jet.',0),(13015,362,'ko','ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ í¬ê¸° ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(13016,362,'he','×’×•×“×œ ×¤×•× ×§×¦×™×” ×ž×¡×•×’ bindery × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(13017,362,'el','Bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(13018,362,'zh','è£…è®¢åŠŸèƒ½å¤§å°æ·»åŠ æˆåŠŸã€‚\r\n',0),(13019,362,'sv','Bindery funktion storlek lagts.',0),(13020,362,'it','Legatoria funzione dimensione aggiunto con successo.',0),(13021,362,'tl','',0),(13022,362,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3609;&#3634;&#3604;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(13023,362,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤†à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(13024,362,'ms','Bindery fungsi saiz berjaya menambah.',0),(13025,362,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø­Ø¬Ù… Ø§Ù„Ø¯Ø§Ù„Ø© Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(13026,362,'fr','FaÃ§onnage fonction taille ajoutÃ©e avec succÃ¨s.',0),(13027,362,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚µã‚¤ã‚ºã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(13028,362,'pt','Bindery tamanho funÃ§Ã£o adicionado com Ãªxito.',0),(13029,362,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(13030,362,'es','Funciones de Encuadernadora, TamaÃ±o Agregado Exitosamente',0),(13031,362,'de','Buchbinderei Funktion GrÃ¶ÃŸe erfolgreich hinzugefÃ¼gt.',0),(13032,362,'en','Bindery Function Size Added Successfully.',0),(13033,363,'is','',0),(13034,363,'dr','(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13035,363,'pr','Ø­Ø°Ù Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ ØªØ§Ø¨Ø¹(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13036,363,'tr','BaÄŸlayÄ±cÄ± iÅŸlevi boyutu baÅŸarÄ±yla silindi.',0),(13037,363,'pl','Introligatornia funkcja rozmiar usuniÄ™te pomyÅ›lnie.',0),(13038,363,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(13039,363,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ø³Ø§Ø¦Ø² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(13040,363,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(13041,363,'vi','XÃ³a kÃ­ch cá»¡ Ä‘Ã³ng sÃ¡ch thÃ nh cÃ´ng',0),(13042,363,'af','Bindery funksie grootte suksesvol geskrap.',0),(13043,363,'ro','Legatorie funcÅ£ia dimensiunea ÅŸters cu succes.',0),(13044,363,'et','Kirjansitomo funktsiooni suurus edukalt kustutatud.',0),(13045,363,'si','Knjigoveznica funkcijo velikost uspeÅ¡no izbrisana.',0),(13046,363,'ba','Bindery fungsi ukuran berhasil dihapus.',0),(13047,363,'nl','Bindery functie grootte met succes verwijderd.',0),(13048,363,'fi','Kantata tehtÃ¤vÃ¤ koko poistettu.',0),(13049,363,'no','Bindingen funksjon stÃ¸rrelsen slettet.',0),(13050,363,'da','Bindery funktion stÃ¸rrelse slettet.',0),(13051,363,'ko','ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ í¬ê¸° ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(13052,363,'he','×’×•×“×œ ×¤×•× ×§×¦×™×” ×ž×¡×•×’ bindery × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(13053,363,'el','Bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(13054,363,'zh','è£…è®¢åŠŸèƒ½çš„å¤§å°å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(13055,363,'sv','Bindery funktion storlek raderades.',0),(13056,363,'it','Legatoria funzione dimensione eliminato con successo.',0),(13057,363,'tl','',0),(13058,363,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3586;&#3609;&#3634;&#3604;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(13059,363,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤†à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(13060,363,'ms','Bindery fungsi saiz dihapuskan dengan jayanya.',0),(13061,363,'ar','Ø­Ø¬Ù… ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(13062,363,'fr','FaÃ§onnage fonction taille supprimÃ©e avec succÃ¨s.',0),(13063,363,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚µã‚¤ã‚ºã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(13064,363,'pt','Bindery funÃ§Ã£o tamanho excluÃ­do com sucesso.',0),(13065,363,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(13066,363,'es','Funciones de Encuadernadora, TamaÃ±o Eliminado Exitosamente',0),(13067,363,'de','Buchbinderei Funktion GrÃ¶ÃŸe erfolgreich gelÃ¶scht.',0),(13068,363,'en','Bindery Function Size Deleted Successfully.',0),(13069,364,'is','',0),(13070,364,'dr','(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13071,364,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ ØªØ§Ø¨Ø¹(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13072,364,'tr','BaÄŸlayÄ±cÄ± iÅŸlevi boyutu baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(13073,364,'pl','Introligatornia rozmiar funkcja pomyÅ›lnie zaktualizowana.',0),(13074,364,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(13075,364,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ø³Ø§Ø¦Ø² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(13076,364,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(13077,364,'vi','Cáº­p Nháº­t KÃ­ch Cá»Ÿ ÄÃ³ng SÃ¡ch ThÃ nh CÃ´ng',0),(13078,364,'af','Bindery funksie grootte suksesvol opgedateer.',0),(13079,364,'ro','Legatorie funcÅ£ia dimensiunea actualizat cu succes.',0),(13080,364,'et','Kirjansitomo funktsiooni suurus vÃ¤rskendamine Ãµnnestus.',0),(13081,364,'si','Knjigoveznica funkcijo velikost uspeÅ¡no posodobljena.',0),(13082,364,'ba','Bindery fungsi ukuran diperbarui berhasil.',0),(13083,364,'nl','Bindery functie grootte bijgewerkt.',0),(13084,364,'fi','Kantata tehtÃ¤vÃ¤ koko pÃ¤ivitettiin onnistuneesti.',0),(13085,364,'no','Bindingen funksjon stÃ¸rrelsen oppdatert.',0),(13086,364,'da','Bindery funktion stÃ¸rrelse opdateret.',0),(13087,364,'ko','ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ í¬ê¸° ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(13088,364,'he','×’×•×“×œ ×¤×•× ×§×¦×™×” ×ž×¡×•×’ bindery ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(13089,364,'el','Bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(13090,364,'zh','è£…è®¢åŠŸèƒ½çš„å¤§å°æ›´æ–°æˆåŠŸã€‚\r\n',0),(13091,364,'sv','Bindery funktion storlek uppdaterats.',0),(13092,364,'it','Legatoria funzione dimensione aggiornato con successo.',0),(13093,364,'tl','',0),(13094,364,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3609;&#3634;&#3604;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(13095,364,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤†à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(13096,364,'ms','Bindery fungsi saiz berjaya dikemas kini.',0),(13097,364,'ar','Ø­Ø¬Ù… ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(13098,364,'fr','FaÃ§onnage fonction taille correctement mis Ã  jour.',0),(13099,364,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚µã‚¤ã‚ºã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(13100,364,'pt','Bindery funÃ§Ã£o tamanho atualizado com Ãªxito.',0),(13101,364,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(13102,364,'es','Funciones de Encuadernadora, TamaÃ±o Actualizado Exitosamente',0),(13103,364,'de','Buchbinderei Funktion GrÃ¶ÃŸe erfolgreich aktualisiert.',0),(13104,364,'en','Bindery Function Size Updated Successfully.',0),(13105,365,'is','',0),(13106,365,'dr','(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13107,365,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ ØªØ§Ø¨Ø¹(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13108,365,'tr','BaÄŸlayÄ±cÄ± iÅŸlevini baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(13109,365,'pl','Introligatornia funkcja pomyÅ›lnie zaktualizowana.',0),(13110,365,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(13111,365,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(13112,365,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(13113,365,'vi','Cáº­p Nháº­t Chá»©c nÄƒng ÄÃ³ng SÃ¡ch ThÃ nh CÃ´ng',0),(13114,365,'af','Bindery funksie suksesvol opgedateer.',0),(13115,365,'ro','FuncÅ£ia de legatorie actualizat cu succes.',0),(13116,365,'et','Kirjansitomo funktsiooni vÃ¤rskendatud.',0),(13117,365,'si','Knjigoveznica funkcijo uspeÅ¡no posodobljena.',0),(13118,365,'ba','Bindery fungsi diperbarui berhasil.',0),(13119,365,'nl','Bindery functie bijgewerkt.',0),(13120,365,'fi','Bindery-funktio pÃ¤ivitettiin onnistuneesti.',0),(13121,365,'no','Bindingen funksjonen oppdatert.',0),(13122,365,'da','Bindery funktion opdateret.',0),(13123,365,'ko','ë°”ì¸ë”ë¦¬ ê¸°ëŠ¥ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(13124,365,'he','×¤×•× ×§×¦×™×” ×ž×¡×•×’ bindery ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(13125,365,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± bindery ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(13126,365,'zh','è£…è®¢åŠŸèƒ½æ›´æ–°æˆåŠŸã€‚\r\n',0),(13127,365,'sv','Bindery funktion uppdaterades.',0),(13128,365,'it','Funzione della legatoria aggiornata con successo.',0),(13129,365,'tl','',0),(13130,365,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(13131,365,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(13132,365,'ms','Bindery fungsi berjaya dikemas kini.',0),(13133,365,'ar','Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ« ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(13134,365,'fr','FaÃ§onnage fonction de mise Ã  jour avec succÃ¨s.',0),(13135,365,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(13136,365,'pt','FunÃ§Ã£o de bindery atualizada com Ãªxito.',0),(13137,365,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(13138,365,'es','Funciones de Encuadernadora Actualizadas Exitosamente',0),(13139,365,'de','Buchbinderei-Funktion erfolgreich aktualisiert.',0),(13140,365,'en','Bindery Function Updated Successfully.',0),(13141,366,'is','',0),(13142,366,'dr','(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(13143,366,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ ØªÙˆØ§Ø¨Ø¹(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(13144,366,'tr','BaÄŸlayÄ±cÄ± iÅŸlevler ekleme',0),(13145,366,'pl','Dodaj funkcje introligatornia',0),(13146,366,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(13147,366,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ø§ÙØ¹Ø§Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(13148,366,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð±Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ',0),(13149,366,'vi','ThÃªm chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch',0),(13150,366,'af','Voeg bindery funksies',0),(13151,366,'ro','Adauga funcÅ£ii de legatorie',0),(13152,366,'et','Kirjansitomo funktsioonide lisamine',0),(13153,366,'si','Knjigoveznica funkcije dodati',0),(13154,366,'ba','Tambahkan fungsi bindery',0),(13155,366,'nl','Bindery functies toevoegen',0),(13156,366,'fi','Kantata toimintojen lisÃ¤Ã¤minen',0),(13157,366,'no','Bindingen funksjoner legge',0),(13158,366,'da','Bindery funktioner tilfÃ¸je',0),(13159,366,'ko','ë°”ì¸ë”ë¦¬ ê¸°ëŠ¥ ì¶”ê°€',0),(13160,366,'he','×œ×”×•×¡×™×£ ×¤×•× ×§×¦×™×•×ª ×ž×¡×•×’ bindery',0),(13161,366,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚',0),(13162,366,'zh','è£…è®¢åŠŸèƒ½æ·»åŠ \r\n',0),(13163,366,'sv','Bindery funktionerna Add',0),(13164,366,'it','Aggiungere funzioni di legatoria',0),(13165,366,'tl','',0),(13166,366,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;',0),(13167,366,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤•à¤¾à¤°à¥à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(13168,366,'ms','Fungsi-fungsi bindery Tambah',0),(13169,366,'ar','Ø¥Ø¶Ø§ÙØ© Ø¯Ø§Ù„Ø§Øª Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(13170,366,'fr','Ajoutez des fonctions de faÃ§onnage',0),(13171,366,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã?®è¿½åŠ ',0),(13172,366,'pt','Adicionar funÃ§Ãµes de bindery',0),(13173,366,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(13174,366,'es','Agregar Funciones de Encuadernadora',0),(13175,366,'de','Buchbinderei Funktionen hinzufÃ¼gen',0),(13176,366,'en','Bindery Functions Add',0),(13177,367,'is','',0),(13178,367,'dr','(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(13179,367,'pr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ØªÙˆØ§Ø¨Ø¹(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(13180,367,'tr','BaÄŸlayÄ±cÄ± fiyat gÃ¼ncelleÅŸtirme iÅŸlevleri',0),(13181,367,'pl','Introligatornia funkcje aktualizacji cen',0),(13182,367,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(13183,367,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† ØªØ¬Ø¯ÛŒØ¯ Ú©Ø§Ù… Ú©Ø±ØªØ§ ÛÛ’ Û”',0),(13184,367,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¾Ð½Ð¸ÑˆÐµ Ñ†ÐµÐ½Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(13185,367,'vi','Cáº­p nháº­t giÃ¡ Ä‘Ã³ng sÃ¡ch',0),(13186,367,'af','Bindery funksies pryse bywerking',0),(13187,367,'ro','Legatorie funcÅ£iile tarifare Update',0),(13188,367,'et','Kirjansitomo funktsioneerib hinnakujunduse Update',0),(13189,367,'si','Knjigoveznica funkcije oblikovanja cen posodobitev',0),(13190,367,'ba','Bindery fungsi Update harga',0),(13191,367,'nl','Bindery functies prijzen Update',0),(13192,367,'fi','Kantata toimii hinnoittelu pÃ¤ivitys',0),(13193,367,'no','Bindingen fungerer priser oppdatering',0),(13194,367,'da','Bindery fungerer prissÃ¦tningen opdatering',0),(13195,367,'ko','ë°”ì¸ë”ë¦¬ ê¸°ëŠ¥ ê°€ê²© ì—…ë°ì´íŠ¸',0),(13196,367,'he','Bindery ×¤×•× ×§×¦×™×•×ª ×¢×“×›×•×Ÿ ×ª×ž×—×•×¨',0),(13197,367,'el','Bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³ÎµÎ¯ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(13198,367,'zh','è£…è®¢åŠŸèƒ½ä»·æ ¼æ›´æ–°\r\n',0),(13199,367,'sv','Bindery fungerar prissÃ¤ttning uppdatering',0),(13200,367,'it','Legatoria funzioni aggiornamento dei prezzi',0),(13201,367,'tl','',0),(13202,367,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3588;&#3634;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;',0),(13203,367,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾à¤°à¥à¤¯ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(13204,367,'ms','Bindery fungsi Kemaskini harga',0),(13205,367,'ar','ÙˆØ¸Ø§Ø¦Ù Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ØªØ­Ø¯ÙŠØ« Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(13206,367,'fr','FaÃ§onnage fonctions mise Ã  jour de prix',0),(13207,367,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½æ ¹ä»˜ã?‘ã?®æ›´æ–°',0),(13208,367,'pt','Bindery funÃ§Ãµes de atualizaÃ§Ã£o de preÃ§os',0),(13209,367,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(13210,367,'es','Funciones de Encuadernadora, ActualizaciÃ³n de Precios',0),(13211,367,'de','Buchbinderei Funktionen Preis Update',0),(13212,367,'en','Bindery Functions Pricing Update',0),(13213,368,'is','',0),(13214,368,'dr','(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡   ',0),(13215,368,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ ØªÙˆØ§Ø¨Ø¹(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡   ',0),(13216,368,'tr','BaÄŸlayÄ±cÄ± iÅŸlevleri seÃ§im listesi gÃ¼ncelleme',0),(13217,368,'pl','Aktualizacja listy wyboru funkcji introligatornia',0),(13218,368,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ ÑÐ¿Ð¸ÑÑŠÐº Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(13219,368,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ø§ÙØ¹Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(13220,368,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ Ð˜Ð·Ð±Ð¾Ñ€ Ð»Ð¸ÑÑ‚Ð° Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(13221,368,'vi','Cáº­p Nháº­t Lá»±a Chá»n Ä‘Ã³ng sÃ¡ch',0),(13222,368,'af','Bindery funksies seleksie lys bywerking',0),(13223,368,'ro','Legatorie funcÅ£ii selecÅ£ie lista actualizare',0),(13224,368,'et','Kirjansitomo funktsioonide valiku loendi vÃ¤rskendus',0),(13225,368,'si','Knjigoveznica funkcije izbor seznam posodobitev',0),(13226,368,'ba','Bindery fungsi pilihan daftar Update',0),(13227,368,'nl','Bindery functies selectie lijst Update',0),(13228,368,'fi','Kantata toimintoja valinta pÃ¤ivitys',0),(13229,368,'no','Bindingen funksjoner utvalg List oppdatering',0),(13230,368,'da','Bindery funktioner udvalg liste Update',0),(13231,368,'ko','ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ ì„ íƒ ëª©ë¡ ì—…ë°ì´íŠ¸',0),(13232,368,'he','×¢×“×›×•×Ÿ ×¨×©×™×ž×ª ×”×‘×—×™×¨×” ×©×œ ×¤×•× ×§×¦×™×•×ª ×ž×¡×•×’ bindery',0),(13233,368,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î® Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚ Ï„Î¿Ï… bindery',0),(13234,368,'zh','è£…è®¢åŠŸèƒ½é€‰æ‹©æ¸…å•æ›´æ–°\r\n',0),(13235,368,'sv','Bindery funktioner urval uppdatering',0),(13236,368,'it','Legatoria funzioni selezione elenco aggiornamento',0),(13237,368,'tl','',0),(13238,368,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(13239,368,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤•à¤¾à¤°à¥à¤¯ à¤šà¤¯à¤¨ à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(13240,368,'ms','Bindery fungsi pilihan senarai Kemaskini',0),(13241,368,'ar','ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ø®ØªÙŠØ§Ø± ÙˆØ¸Ø§Ø¦Ù Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(13242,368,'fr','Mise Ã  jour liste de la sÃ©lection de fonctions faÃ§onnage',0),(13243,368,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚»ãƒ¬ã‚¯ã‚·ãƒ§ãƒ³ã?®æ›´æ–°',0),(13244,368,'pt','AtualizaÃ§Ã£o de lista de seleÃ§Ã£o de funÃ§Ãµes bindery',0),(13245,368,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ð²Ñ‹Ð±Ð¾Ñ€Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¹ Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ',0),(13246,368,'es','Funciones de Encuadernadora, ActualizaciÃ³n de Lista de SelecciÃ³n',0),(13247,368,'de','Buchbinderei Funktionen Auswahl Liste Update',0),(13248,368,'en','Bindery Functions Selection List Update',0),(13249,369,'is','',0),(13250,369,'dr','(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(13251,369,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ ØªÙˆØ§Ø¨Ø¹(ÙØ¹Ø§Ù„ÙŠØª) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(13252,369,'tr','BaÄŸlayÄ±cÄ± iÅŸlev gÃ¼ncelleÅŸtirme',0),(13253,369,'pl','Introligatornia funkcje aktualizacji',0),(13254,369,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(13255,369,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ø§ÙØ¹Ø§Ù„ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(13256,369,'sr','Ð£Ð¿Ð´Ð°Ñ‚Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ Ð±Ð¸Ð½Ð´ÐµÑ€y',0),(13257,369,'vi','Cáº­p Nháº­t Chá»©c NÄƒng ÄÃ³ng SÃ¡ch',0),(13258,369,'af','Bindery funksies bywerking',0),(13259,369,'ro','Legatorie funcÅ£ii de actualizare',0),(13260,369,'et','Kirjansitomo funktsioonide vÃ¤rskendus',0),(13261,369,'si','Knjigoveznica funkcije Update',0),(13262,369,'ba','Bindery fungsi Update',0),(13263,369,'nl','Bindery functies Update',0),(13264,369,'fi','Kantata toiminnot pÃ¤ivitys',0),(13265,369,'no','Bindingen funksjoner oppdatering',0),(13266,369,'da','Bindery funktioner opdatering',0),(13267,369,'ko','ë°”ì¸ë”ë¦¬ ê¸°ëŠ¥ ì—…ë°ì´íŠ¸',0),(13268,369,'he','×¢×“×›×•×Ÿ ×¤×•× ×§×¦×™×•×ª ×ž×¡×•×’ bindery',0),(13269,369,'el','Î— ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚ Ï„Î¿Ï… bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚',0),(13270,369,'zh','è£…è®¢åŠŸèƒ½æ›´æ–°\r\n',0),(13271,369,'sv','Bindery funktioner uppdatering',0),(13272,369,'it','Aggiornamento funzioni della legatoria',0),(13273,369,'tl','',0),(13274,369,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;',0),(13275,369,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤•à¤¾à¤°à¥à¤¯ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(13276,369,'ms','Bindery fungsi Kemaskini',0),(13277,369,'ar','ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ù‡Ø§Ù…',0),(13278,369,'fr','Mise Ã  jour des fonctions de faÃ§onnage',0),(13279,369,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã?®æ›´æ–°',0),(13280,369,'pt','AtualizaÃ§Ã£o de funÃ§Ãµes de bindery',0),(13281,369,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¹ Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ',0),(13282,369,'es','Actualizar Funciones de Encuadernadora',0),(13283,369,'de','Buchbinderei Funktionen Update',0),(13284,369,'en','Bindery Functions Update',0),(13285,370,'is','',0),(13286,370,'dr','Ù†Ø§Ù… ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(13287,370,'pr','Ù†Ø§Ù… ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(13288,370,'tr','BaÄŸlama adÄ±',0),(13289,370,'pl','Nazwa introligatornia',0),(13290,370,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ð¸Ð¼Ðµ',0),(13291,370,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù†Ø§Ù…',0),(13292,370,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ð¸Ð¼Ðµ',0),(13293,370,'vi','TÃªn Ä‘Ã³ng sÃ¡ch',0),(13294,370,'af','Bindery naam',0),(13295,370,'ro','Numele de legatorie',0),(13296,370,'et','Kirjansitomo nimi',0),(13297,370,'si','Knjigoveznica ime',0),(13298,370,'ba','Nama bindery',0),(13299,370,'nl','Bindery naam',0),(13300,370,'fi','Bindery-tietokannan nimi',0),(13301,370,'no','Bindingen navn',0),(13302,370,'da','Bindery navn',0),(13303,370,'ko','ë°”ì¸ë”ë¦¬ ì´ë¦„',0),(13304,370,'he','×©× bindery',0),(13305,370,'el','ÎŒÎ½Î¿Î¼Î± bindery',0),(13306,370,'zh','è£…è®¢åç§°\r\n',0),(13307,370,'sv','Bindery namn',0),(13308,370,'it','Nome della legatoria',0),(13309,370,'tl','',0),(13310,370,'th','&#3594;&#3639;&#3656;&#3629;&#3649;&#3615;&#3657;&#3617;',0),(13311,370,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¨à¤¾à¤®',0),(13312,370,'ms','Nama bindery',0),(13313,370,'ar','Ø§Ø³Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(13314,370,'fr','Nom de faÃ§onnage',0),(13315,370,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼å??',0),(13316,370,'pt','Nome de bindery',0),(13317,370,'ru','Ð˜Ð¼Ñ ÑÐ¸ÑÑ‚ÐµÐ¼Ð½Ð¾Ð¹ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(13318,370,'es','Nombre de Encuadernadora',0),(13319,370,'de','Buchbinderei-Name',0),(13320,370,'en','Bindery Name',0),(13321,371,'is','',0),(13322,371,'dr','(ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(13323,371,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª(ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(13324,371,'tr','BaÄŸlayÄ±cÄ± fiyat listesi gÃ¼ncelleme',0),(13325,371,'pl','Aktualizacja listy ceny introligatornia',0),(13326,371,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(13327,371,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(13328,371,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ñ†ÐµÐ½Ðµ Ð±Ð¸Ð½Ð´ÐµÑ€y',0),(13329,371,'vi','Cáº­p Nháº­t biá»ƒu giÃ¡ ÄÃ³ng SÃ¡ch ',0),(13330,371,'af','Bindery prys lys bywerking',0),(13331,371,'ro','Legatorie Pret lista actualizare',0),(13332,371,'et','Kirjansitomo hind uuendamisel',0),(13333,371,'si','Knjigoveznica cena seznam posodobitev',0),(13334,371,'ba','Daftar harga bindery pembaruan',0),(13335,371,'nl','Bindery prijs lijst Update',0),(13336,371,'fi','Kantata hinnasto PÃ¤ivitÃ¤',0),(13337,371,'no','Bindingen Prisoppdatering liste',0),(13338,371,'da','Bindery pris liste Update',0),(13339,371,'ko','ë°”ì¸ë”ë¦¬ ê°€ê²© ëª©ë¡ ì—…ë°ì´íŠ¸',0),(13340,371,'he','×¢×“×›×•×Ÿ ×¨×©×™×ž×ª ×ž×—×™×¨ bindery',0),(13341,371,'el','Bindery ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½',0),(13342,371,'zh','è£…è®¢ä»·æ ¼è¡¨æ›´æ–°\r\n',0),(13343,371,'sv','Bindery prisuppdatering',0),(13344,371,'it','Aggiornamento di elenco prezzi della legatoria',0),(13345,371,'tl','',0),(13346,371,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3615;&#3657;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(13347,371,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(13348,371,'ms','Kemas kini senarai harga bindery',0),(13349,371,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(13350,371,'fr','FaÃ§onnage Prix liste mise Ã  jour',0),(13351,371,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ä¾¡æ ¼è¡¨æ›´æ–°',0),(13352,371,'pt','AtualizaÃ§Ã£o de lista de preÃ§o de encadernaÃ§Ã£o',0),(13353,371,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ð¦ÐµÐ½Ð°',0),(13354,371,'es','Encuadernadora, ActualizaciÃ³n de Lista de Precios',0),(13355,371,'de','Buchbinderei Preis Liste Update',0),(13356,371,'en','Bindery Price List Update',0),(13357,372,'is','',0),(13358,372,'dr','Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(13359,372,'pr','Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(13360,372,'tr','BaÄŸlayÄ±cÄ± tÃ¼rÃ¼',0),(13361,372,'pl','Typ wiÄ…zaÅ„',0),(13362,372,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ‚Ð¸Ð¿',0),(13363,372,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚Ø³Ù…',0),(13364,372,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ‚Ð¸Ð¿',0),(13365,372,'vi','Loáº¡i Ä‘Ã³ng sÃ¡ch',0),(13366,372,'af','Bindery tipe',0),(13367,372,'ro','Tip de legatorie',0),(13368,372,'et','Kirjansitomo tÃ¼Ã¼p',0),(13369,372,'si','Knjigoveznica tipa',0),(13370,372,'ba','Jenis bindery',0),(13371,372,'nl','Bindery Type',0),(13372,372,'fi','Bindery-tietokannan tyyppi',0),(13373,372,'no','Bindingen Type',0),(13374,372,'da','Bindery Type',0),(13375,372,'ko','ë°”ì¸ë”ë¦¬ í˜•ì‹',0),(13376,372,'he','×ž×¡×•×’ bindery',0),(13377,372,'el','Bindery Ï„ÏÏ€Î¿Ï…',0),(13378,372,'zh','è£…è®¢ç±»åž‹\r\n',0),(13379,372,'sv','Bindery typ',0),(13380,372,'it','Tipo di legatoria',0),(13381,372,'tl','',0),(13382,372,'th','&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3649;&#3615;&#3657;&#3617;',0),(13383,372,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(13384,372,'ms','Jenis bindery',0),(13385,372,'ar','Ù†ÙˆØ¹ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(13386,372,'fr','Type de faÃ§onnage',0),(13387,372,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚¿ã‚¤ãƒ—',0),(13388,372,'pt','Tipo de encadernaÃ§Ã£o',0),(13389,372,'ru','Ð¢Ð¸Ð¿ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð”',0),(13390,372,'es','Tipo de Encuadernador',0),(13391,372,'de','Buchbinderei-Typ',0),(13392,372,'en','Bindery Type',0),(13393,373,'is','',0),(13394,373,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13395,373,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13396,373,'tr','BaÄŸlayÄ±cÄ± tÃ¼rÃ¼ Ekle',0),(13397,373,'pl','DodaÄ‡ typ wiÄ…zaÅ„',0),(13398,373,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ‚Ð¸Ð¿',0),(13399,373,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(13400,373,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð±Ð¸Ð½Ð´ÐµÑ€y Ñ‚Ð¸Ð¿',0),(13401,373,'vi','ThÃªm loáº¡i Ä‘Ã³ng sÃ¡ch',0),(13402,373,'af','Bindery tipe voeg',0),(13403,373,'ro','Adauga tip de legatorie',0),(13404,373,'et','Kirjansitomo liigi lisamine',0),(13405,373,'si','Knjigoveznica vrsto dodati',0),(13406,373,'ba','Menambahkan jenis bindery',0),(13407,373,'nl','Bindery Type toevoegen',0),(13408,373,'fi','Kantata lisÃ¤Ã¤',0),(13409,373,'no','Bindingen Type legge',0),(13410,373,'da','Bindery Type tilfÃ¸je',0),(13411,373,'ko','ë°”ì¸ë”ë¦¬ í˜•ì‹ ì¶”ê°€',0),(13412,373,'he','×œ×”×•×¡×™×£ ×ž×¡×•×’ bindery',0),(13413,373,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ bindery Ï„ÏÏ€Î¿Ï…',0),(13414,373,'zh','è£…è®¢ç±»åž‹æ·»åŠ \r\n',0),(13415,373,'sv','Bindery typ lÃ¤gga till',0),(13416,373,'it','Aggiungi tipo di legatoria',0),(13417,373,'tl','',0),(13418,373,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3649;&#3615;&#3657;&#3617;',0),(13419,373,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(13420,373,'ms','Tambah jenis bindery',0),(13421,373,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(13422,373,'fr','Ajouter le Type de faÃ§onnage',0),(13423,373,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚¿ã‚¤ãƒ—ã?®è¿½åŠ ',0),(13424,373,'pt','Adicionar o tipo de encadernaÃ§Ã£o',0),(13425,373,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð”',0),(13426,373,'es','Agregar Tipo de Encuadernador',0),(13427,373,'de','Buchbinderei Typ hinzufÃ¼gen',0),(13428,373,'en','Bindery Type Add',0),(13429,374,'is','',0),(13430,374,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13431,374,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13432,374,'tr','BaÄŸlayÄ±cÄ± tÃ¼rÃ¼ baÅŸarÄ±yla eklendi.',0),(13433,374,'pl','Typ wiÄ…zaÅ„ dodane pomyÅ›lnie.',0),(13434,374,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ‚Ð¸Ð¿ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(13435,374,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚Ø³Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(13436,374,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ‚Ð¸Ð¿ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(13437,374,'vi','ThÃªm loáº¡i Ä‘Ã³ng sÃ¡ch thÃ nh cÃ´ng',0),(13438,374,'af','Bindery tipe suksesvol bygevoeg.',0),(13439,374,'ro','Tip de legatorie adÄƒugat cu succes.',0),(13440,374,'et','Kirjansitomo tÃ¼Ã¼p edukalt lisatud.',0),(13441,374,'si','Knjigoveznica vrsto uspeÅ¡no dodana.',0),(13442,374,'ba','Bindery jenis ditambahkan berhasil.',0),(13443,374,'nl','Bindery Type toegevoegd.',0),(13444,374,'fi','Bindery-tietokannan tyyppi lisÃ¤Ã¤minen onnistui.',0),(13445,374,'no','Bindingen Type lagt.',0),(13446,374,'da','Bindery Type tilfÃ¸jet.',0),(13447,374,'ko','ë°”ì¸ë”ë¦¬ í˜•ì‹ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(13448,374,'he','×¡×•×’ bindery × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(13449,374,'el','Î¤ÏÏ€Î¿Ï‚ bindery Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(13450,374,'zh','è£…è®¢ç±»åž‹æ·»åŠ æˆåŠŸã€‚\r\n',0),(13451,374,'sv','Bindery typ lagts.',0),(13452,374,'it','Legatoria tipo aggiunto con successo.',0),(13453,374,'tl','',0),(13454,374,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3649;&#3615;&#3657;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(13455,374,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(13456,374,'ms','Jenis bindery berjaya menambah.',0),(13457,374,'ar','Ù†ÙˆØ¹ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(13458,374,'fr','Type de reliure ajoutÃ© avec succÃ¨s.',0),(13459,374,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚¿ã‚¤ãƒ—ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(13460,374,'pt','Tipo de encadernaÃ§Ã£o adicionado com Ãªxito.',0),(13461,374,'ru','Ð¡ÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(13462,374,'es','Tipo de Encuadernador Agregado Exitosamente',0),(13463,374,'de','Buchbinderei-Typ wurde erfolgreich hinzugefÃ¼gt.',0),(13464,374,'en','Bindery Type Added Successfully.',0),(13465,375,'is','',0),(13466,375,'dr','Ø­Ø°Ù Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13467,375,'pr','Ø­Ø°Ù Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13468,375,'tr','BaÄŸlayÄ±cÄ± tÃ¼rÃ¼ baÅŸarÄ±yla silindi.',0),(13469,375,'pl','UsuniÄ™ty typ wiÄ…zaÅ„.',0),(13470,375,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ‚Ð¸Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(13471,375,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚Ø³Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(13472,375,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ‚Ð¸Ð¿ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(13473,375,'vi','XÃ³a loáº¡i Ä‘Ã³ng sÃ¡ch thÃ nh cÃ´ng',0),(13474,375,'af','Bindery tipe suksesvol geskrap.',0),(13475,375,'ro','Tip de legatorie ÅŸters cu succes.',0),(13476,375,'et','Kirjansitomo tÃ¼Ã¼p edukalt kustutatud.',0),(13477,375,'si','Knjigoveznica vrsto uspeÅ¡no izbrisana.',0),(13478,375,'ba','Bindery jenis berhasil dihapus.',0),(13479,375,'nl','Bindery Type verwijderd.',0),(13480,375,'fi','Bindery-tietokannan tyyppi poistettu.',0),(13481,375,'no','Bindingen Type slettet.',0),(13482,375,'da','Bindery Type slettet.',0),(13483,375,'ko','ë°”ì¸ë”ë¦¬ í˜•ì‹ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(13484,375,'he','×¡×•×’ bindery × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(13485,375,'el','Î¤ÏÏ€Î¿Ï‚ bindery Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(13486,375,'zh','è£…è®¢å½¢å¼å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(13487,375,'sv','Bindery typ raderades.',0),(13488,375,'it','Legatoria tipo eliminato con successo.',0),(13489,375,'tl','',0),(13490,375,'th','&#3621;&#3610;&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3649;&#3615;&#3657;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(13491,375,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(13492,375,'ms','Bindery jenis dihapuskan dengan jayanya.',0),(13493,375,'ar','Ù†ÙˆØ¹ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(13494,375,'fr','Type de reliure supprimÃ© avec succÃ¨s.',0),(13495,375,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚¿ã‚¤ãƒ—ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(13496,375,'pt','Tipo de encadernaÃ§Ã£o excluÃ­do com sucesso.',0),(13497,375,'ru','Ð¡ÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(13498,375,'es','Tipo de Encuadernador Eliminado Exitosamente',0),(13499,375,'de','Buchbinderei Typ erfolgreich gelÃ¶scht.',0),(13500,375,'en','Bindery Type Deleted Successfully.',0),(13501,376,'is','',0),(13502,376,'dr','Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(13503,376,'pr','Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(13504,376,'tr','BaÄŸlayÄ±cÄ± tÃ¼rÃ¼ bulunamadÄ±.',0),(13505,376,'pl','Typ wiÄ…zaÅ„ nie znaleziono.',0),(13506,376,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ‚Ð¸Ð¿ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(13507,376,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚Ø³Ù… Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(13508,376,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ‚Ð¸Ð¿ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(13509,376,'vi','KhÃ´ng tÃ¬m tháº¥y loáº¡i Ä‘Ã³ng sÃ¡ch',0),(13510,376,'af','Bindery tipe gevind nie.',0),(13511,376,'ro','Legatorie tip nu a fost gÄƒsit.',0),(13512,376,'et','Kirjansitomo tÃ¼Ã¼p ei leitud.',0),(13513,376,'si','Knjigoveznica tipa ni mogoÄe najti.',0),(13514,376,'ba','Jenis bindery tidak ditemukan.',0),(13515,376,'nl','Bindery Type niet gevonden.',0),(13516,376,'fi','Kantata tyyppiÃ¤ ei lÃ¶ydy.',0),(13517,376,'no','Finner ikke Bindery-typen.',0),(13518,376,'da','Bindery Type blev ikke fundet.',0),(13519,376,'ko','ë°”ì¸ë”ë¦¬ í˜•ì‹ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(13520,376,'he','×¡×•×’ bindery ×œ× × ×ž×¦×.',0),(13521,376,'el','Bindery Ï„ÏÏ€Î¿Ï‚ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(13522,376,'zh','è£…è®¢ç±»åž‹æœªæ‰¾åˆ°ã€‚\r\n',0),(13523,376,'sv','Bindery typ hittades inte.',0),(13524,376,'it','Legatoria tipo non trovato.',0),(13525,376,'tl','',0),(13526,376,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3594;&#3609;&#3636;&#3604;&#3649;&#3615;&#3657;&#3617;',0),(13527,376,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(13528,376,'ms','Jenis bindery yang tidak dijumpai.',0),(13529,376,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù†ÙˆØ¹ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(13530,376,'fr','Type de reliure introuvable.',0),(13531,376,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚¿ã‚¤ãƒ—ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(13532,376,'pt','Tipo de ligaÃ§Ã£o nÃ£o foi encontrado.',0),(13533,376,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ Ñ‚Ð¸Ð¿ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(13534,376,'es','Tipo de Encuadernador no se encontrÃ³',0),(13535,376,'de','Buchbinderei-Typ nicht gefunden.',0),(13536,376,'en','Bindery Type not found.',0),(13537,377,'is','',0),(13538,377,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13539,377,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(13540,377,'tr','BaÄŸlayÄ±cÄ± tÃ¼rÃ¼ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(13541,377,'pl','Typ wiÄ…zaÅ„ pomyÅ›lnie zaktualizowana.',0),(13542,377,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ‚Ð¸Ð¿ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(13543,377,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚Ø³Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(13544,377,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ‚Ð¸Ð¿ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(13545,377,'vi','Cáº­p Nháº­t Thá»ƒ Loáº¡i ÄÃ³ng SÃ¡ch ThÃ nh CÃ´ng',0),(13546,377,'af','Bindery tipe suksesvol opgedateer.',0),(13547,377,'ro','Tip de legatorie actualizat cu succes.',0),(13548,377,'et','Kirjansitomo tÃ¼Ã¼p vÃ¤rskendamine Ãµnnestus.',0),(13549,377,'si','Knjigoveznica vrsto uspeÅ¡no posodobljena.',0),(13550,377,'ba','Bindery jenis diperbarui berhasil.',0),(13551,377,'nl','Bindery Type bijgewerkt.',0),(13552,377,'fi','Bindery-tietokannan tyyppi pÃ¤ivitettiin onnistuneesti.',0),(13553,377,'no','Bindingen Type oppdatert.',0),(13554,377,'da','Bindery Type opdateret.',0),(13555,377,'ko','ë°”ì¸ë”ë¦¬ í˜•ì‹ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(13556,377,'he','×¡×•×’ bindery ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(13557,377,'el','Î¤ÏÏ€Î¿Ï‚ bindery ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(13558,377,'zh','è£…è®¢ç±»åž‹æ›´æ–°æˆåŠŸã€‚\r\n',0),(13559,377,'sv','Bindery typ uppdaterats.',0),(13560,377,'it','Legatoria tipo aggiornato con successo.',0),(13561,377,'tl','',0),(13562,377,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3649;&#3615;&#3657;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(13563,377,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(13564,377,'ms','Jenis bindery berjaya dikemas kini.',0),(13565,377,'ar','Ù†ÙˆØ¹ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(13566,377,'fr','Type de faÃ§onnage mis Ã  jour avec succÃ¨s.',0),(13567,377,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚¿ã‚¤ãƒ—ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(13568,377,'pt','Tipo de encadernaÃ§Ã£o atualizado com Ãªxito.',0),(13569,377,'ru','Ð¡ÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(13570,377,'es','Tipo de Encuadernador Actualizado Exitosamente',0),(13571,377,'de','Buchbinderei Typ erfolgreich aktualisiert.',0),(13572,377,'en','Bindery Type Updated Successfully.',0),(13573,378,'is','',0),(13574,378,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø± Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(13575,378,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø± Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(13576,378,'tr','BaÄŸlayÄ±cÄ± iÅŸ tÃ¼rÃ¼ baÅŸarÄ±yla silindi.',0),(13577,378,'pl','Typ wiÄ…zaÅ„ pracy usuniÄ™te pomyÅ›lnie.',0),(13578,378,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(13579,378,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø¨Ø§Ù†ÚˆØ±ÛŒ Ú©Ø§Ù… Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª Û”',0),(13580,378,'sr','Ð’Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð° Ð±Ð¸Ð½Ð´ÐµÑ€y ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(13581,378,'vi','XÃ³a loáº¡i Ä‘Ã³ng sÃ¡ch thÃ nh cÃ´ng',0),(13582,378,'af','Bindery werk tipe suksesvol geskrap.',0),(13583,378,'ro','Legatorie de lucru tip ÅŸters cu succes.',0),(13584,378,'et','Kirjansitomo TÃ¶Ã¶liigi edukalt kustutatud.',0),(13585,378,'si','Knjigoveznica vrsta dela uspeÅ¡no izbrisana.',0),(13586,378,'ba','Jenis pekerjaan bindery berhasil dihapus.',0),(13587,378,'nl','Bindery werksoort verwijderd.',0),(13588,378,'fi','Kantata TyÃ¶tyyppi poistettu.',0),(13589,378,'no','Bindingen arbeidstype slettet.',0),(13590,378,'da','Bindery arbejdstype slettet.',0),(13591,378,'ko','ë°”ì¸ë”ë¦¬ ìž‘ì—… í˜•ì‹ì„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(13592,378,'he','×¡×•×’ ×¢×‘×•×“×” ×ž×¡×•×’ bindery × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(13593,378,'el','Î¤ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ bindery Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(13594,378,'zh','è£…è®¢å·¥ä½œç±»åž‹åˆ é™¤æˆåŠŸã€‚\r\n',0),(13595,378,'sv','Bindery arbetstyp raderades.',0),(13596,378,'it','Tipo di lavoro di legatoria eliminato con successo.',0),(13597,378,'tl','',0),(13598,378,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3594;&#3609;&#3636;&#3604;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3649;&#3615;&#3657;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(13599,378,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(13600,378,'ms','Jenis kerja bindery dihapuskan dengan jayanya.',0),(13601,378,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(13602,378,'fr','Type de travail de faÃ§onnage supprimÃ© avec succÃ¨s.',0),(13603,378,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ãƒ¯ãƒ¼ã‚¯ã‚¿ã‚¤ãƒ—ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(13604,378,'pt','Tipo de trabalho de bindery excluÃ­do com sucesso.',0),(13605,378,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚ÑŒ Ñ‚Ð¸Ð¿ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(13606,378,'es','Tipo de Trabajo de Encuadernador Eliminado Exitosamente',0),(13607,378,'de','Buchbinderei Arbeitstyp erfolgreich gelÃ¶scht.',0),(13608,378,'en','Bindery work type deleted successfully.',0),(13609,379,'is','',0),(13610,379,'dr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯',0),(13611,379,'pr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯',0),(13612,379,'tr','DoÄŸum gÃ¼nÃ¼',0),(13613,379,'pl','Urodziny',0),(13614,379,'bg','Ð Ð¾Ð¶Ð´ÐµÐ½ Ð´ÐµÐ½',0),(13615,379,'ur','Ø³Ø§Ù„Ú¯Ø±Û',0),(13616,379,'sr','Ð Ð¾Ñ’ÐµÐ½Ð´Ð°Ð½',0),(13617,379,'vi','NgÃ y sinh',0),(13618,379,'af','Verjaarsdag',0),(13619,379,'ro','Ziua de nastere',0),(13620,379,'et','SÃ¼nnipÃ¤ev',0),(13621,379,'si','Rojstni dan',0),(13622,379,'ba','Ulang tahun',0),(13623,379,'nl','Verjaardag',0),(13624,379,'fi','SyntymÃ¤pÃ¤ivÃ¤',0),(13625,379,'no','Bursdag',0),(13626,379,'da','FÃ¸dselsdag',0),(13627,379,'ko','ìƒì¼',0),(13628,379,'he','×™×•× ×”×•×œ×“×ª',0),(13629,379,'el','Î“ÎµÎ½Î­Î¸Î»Î¹Î±',0),(13630,379,'zh','ç”Ÿæ—¥\r\n',0),(13631,379,'sv','FÃ¶delsedag',0),(13632,379,'it','Compleanno',0),(13633,379,'tl','',0),(13634,379,'th','&#3623;&#3633;&#3609;&#3648;&#3585;&#3636;&#3604;',0),(13635,379,'hi','à¤œà¤¨à¥à¤®à¤¦à¤¿à¤¨',0),(13636,379,'ms','Hari Keputeraan',0),(13637,379,'ar','Ø¹ÙŠØ¯ Ù…ÙŠÙ„Ø§Ø¯',0),(13638,379,'fr','Anniversaire',0),(13639,379,'jp','èª•ç”Ÿæ—¥',0),(13640,379,'pt','AniversÃ¡rio',0),(13641,379,'ru','Ð”ÐµÐ½ÑŒ Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(13642,379,'es','CumpleaÃ±os',0),(13643,379,'de','Geburtstag',0),(13644,379,'en','Birthday',0),(13645,380,'is','',0),(13646,380,'dr','Ù…Ø´ÙƒÙŠ',0),(13647,380,'pr','Ù…Ø´ÙƒÙŠ',0),(13648,380,'tr','Siyah',0),(13649,380,'pl','Czarny',0),(13650,380,'bg','Ð§ÐµÑ€Ð½Ð¾',0),(13651,380,'ur','Ø³ÛŒØ§Û',0),(13652,380,'sr','Ð¦Ñ€Ð½Ð¸',0),(13653,380,'vi','Äen',0),(13654,380,'af','Swart',0),(13655,380,'ro','Negru',0),(13656,380,'et','Must',0),(13657,380,'si','Black',0),(13658,380,'ba','Hitam',0),(13659,380,'nl','Black',0),(13660,380,'fi','Musta',0),(13661,380,'no','Svart',0),(13662,380,'da','Sort',0),(13663,380,'ko','ë¸”ëž™',0),(13664,380,'he','×©×—×•×¨',0),(13665,380,'el','ÎœÎ±ÏÏÎ¿',0),(13666,380,'zh','é»‘è‰²\r\n',0),(13667,380,'sv','Svart',0),(13668,380,'it','Nero',0),(13669,380,'tl','',0),(13670,380,'th','&#3626;&#3637;&#3604;&#3635;',0),(13671,380,'hi','à¤¬à¥à¤²à¥ˆà¤•',0),(13672,380,'ms','Hitam',0),(13673,380,'ar','Ø£Ø³ÙˆØ¯',0),(13674,380,'fr','Black',0),(13675,380,'jp','é»’',0),(13676,380,'pt','Preto',0),(13677,380,'ru','Ð§ÐµÑ€Ð½Ñ‹Ð¹',0),(13678,380,'es','Negro',0),(13679,380,'de','Schwarz',0),(13680,380,'en','Black',0),(13681,381,'is','',0),(13682,381,'dr','Ù‚Ø³Ù…Øª Ù…Ø¹Ø±ÙÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø±Ø§ Ù¾Ø±Ø±Ù†Ú¯ ÙƒÙ†ÙŠØ¯',0),(13683,381,'pr','Ù‚Ø³Ù…Øª Ù…Ø¹Ø±ÙÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø±Ø§ Ù¾Ø±Ø±Ù†Ú¯ ÙƒÙ†ÙŠØ¯',0),(13684,381,'tr','Not kalÄ±n Intro bÃ¶lÃ¼mÃ¼',0),(13685,381,'pl','Pogrubiony fragment Intro Uwaga',0),(13686,381,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÑ€ Ð¸Ð½Ñ‚Ñ€Ð¾ Ñ‡Ð°ÑÑ‚ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(13687,381,'ur','Ù†ÙˆÙ¹ Ú©Û’ Ø­ØµÛ’ Ú©ÛŒ Ø¬Ù„ÛŒ Ø§Ù†Ù¹Ø±Ùˆ',0),(13688,381,'sr','ÐŸÐ¾Ð´ÐµÐ±Ñ™Ð°Ð½Ð¸ Ð˜Ð½Ñ‚Ñ€Ð¾ Ð´ÐµÐ¾ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(13689,381,'vi','In Ä‘áº­m pháº§n giá»›i thiá»‡u cá»§a ghi chÃº',0),(13690,381,'af','Vetdruk Intro gedeelte van kennis',0),(13691,381,'ro','Bold Intro parte a nota',0),(13692,381,'et','TÃ¤hele Bold Intro osa',0),(13693,381,'si','Krepko Intro del Opomba',0),(13694,381,'ba','Bagian Intro berani catatan',0),(13695,381,'nl','Vet Intro gedeelte van notitie',0),(13696,381,'fi','Rohkea Intro osa Huomautus',0),(13697,381,'no','Fet Intro delen av notatet',0),(13698,381,'da','Fed Intro del af Note',0),(13699,381,'ko','ë©”ëª¨ì˜ ì†Œê°œ ë¶€ë¶„ì„ êµµê²Œ',0),(13700,381,'he','×ž×‘×•× ×ž×•×“×’×© ×—×œ×§ ×”×¢×¨×”',0),(13701,381,'el','Intro Ï„Î¿Î»Î¼Î·ÏÏŒ Î¼ÎµÏÎ¯Î´Î± Ï„Î·Ï‚ ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·Ï‚',0),(13702,381,'zh','å¤‡æ³¨éƒ¨åˆ†ç®€è¦ä»‹ç»\r\n',0),(13703,381,'sv','Fet Intro del av Obs',0),(13704,381,'it','Intro grassetto porzione di nota',0),(13705,381,'tl','',0),(13706,381,'th','&#3588;&#3635;&#3609;&#3635;&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(13707,381,'hi','à¤¨à¥‹à¤Ÿ à¤•à¤¾ à¤ªà¤°à¤¿à¤šà¤¯ à¤­à¤¾à¤— à¤¬à¥‹à¤²à¥à¤¡',0),(13708,381,'ms','Intro berani sebahagian daripada Nota',0),(13709,381,'ar','Ù…Ù‚Ø¯Ù…Ø© Ø¬Ø±ÙŠØ¦Ø© Ø¬Ø²Ø¡ Ù…Ù† Ù…Ù„Ø§Ø­Ø¸Ø©',0),(13710,381,'fr','Intro \"BOLD\" partie de la Note',0),(13711,381,'jp','ãƒ¡ãƒ¢ã?®å¤ªå­—ã‚¤ãƒ³ãƒˆãƒ­éƒ¨åˆ†',0),(13712,381,'pt','Intro bold (realce) parte da nota',0),(13713,381,'ru','Ð¡Ð¼ÐµÐ»Ñ‹Ðµ Ð¸Ð½Ñ‚Ñ€Ð¾ Ñ‡Ð°ÑÑ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÐºÐ¸',0),(13714,381,'es','PorciÃ³n de Nota Intro Negrita',0),(13715,381,'de','Fett Intro Teil der Hinweis',0),(13716,381,'en','Bold Intro Portion of Note',0),(13717,382,'is','',0),(13718,382,'dr','ØµÙˆØ±Øª Ù…ÙˆØ§Ø¯',0),(13719,382,'pr','ØµÙˆØ±Øª Ù…ÙˆØ§Ø¯',0),(13720,382,'tr','ÃœRÃœN REÃ‡ETESÄ°',0),(13721,382,'pl','BOM',0),(13722,382,'bg','ÐšÐ˜',0),(13723,382,'ur','Ø¨Ø§Ù…',0),(13724,382,'sr','Ð¡ÐÐ¡Ð¢ÐÐ’ÐÐ˜Ð¦Ð',0),(13725,382,'vi','BOM',0),(13726,382,'af','BOM',0),(13727,382,'ro','LM',0),(13728,382,'et','KOOSLUSE',0),(13729,382,'si','KOSOVNICE',0),(13730,382,'ba','BOM',0),(13731,382,'nl','STUKLIJST',0),(13732,382,'fi','TUOTERAKENTEEN',0),(13733,382,'no','STYKKLISTE',0),(13734,382,'da','BOM',0),(13735,382,'ko','BOM',0),(13736,382,'he','BOM',0),(13737,382,'el','Î¤Î•Î§ÎÎ™ÎšÎ‰ Î Î¡ÎŸÎ”Î™Î‘Î“Î¡Î‘Î¦Î‰',0),(13738,382,'zh','ç‰©æ–™æ¸…å•\r\n',0),(13739,382,'sv','BOM',0),(13740,382,'it','BOM',0),(13741,382,'tl','',0),(13742,382,'th','&#3588;&#3656;&#3634;&#3623;&#3633;&#3626;&#3604;&#3640;',0),(13743,382,'hi','BOM',0),(13744,382,'ms','BOM',0),(13745,382,'ar','Ø´Ø¬Ø±Ø© Ø§Ù„Ù…ÙˆØ§Ø¯',0),(13746,382,'fr','BOM',0),(13747,382,'jp','BOM',0),(13748,382,'pt','BOM',0),(13749,382,'ru','Ð¡ÐŸÐ•Ð¦Ð˜Ð¤Ð˜ÐšÐÐ¦Ð˜Ð˜',0),(13750,382,'es','BOM',0),(13751,382,'de','STÃœCKLISTE',0),(13752,382,'en','BOM',0),(13753,383,'is','',0),(13754,383,'dr','11 Ø·Ø±Ø­ ÙØ§Ù‚Ø¯ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù…',0),(13755,383,'pr','Ú©Ø§Ø¯Ø± 11 Ø·Ø±Ø­ ÙØ§Ù‚Ø¯ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù…',0),(13756,383,'tr','Kutu 11 kalifiye olmayan planÄ±',0),(13757,383,'pl','Pole 11-kwalifikacje Plan',0),(13758,383,'bg','ÐšÐ»ÐµÑ‚ÐºÐ° 11 Ð½ÐµÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½ Ð¿Ð»Ð°Ð½',0),(13759,383,'ur','Ø®Ø§Ù†Û 11 ØºÛŒØ± Ú©ÙˆØ§Ù„ÛŒÙØ§Ø¦ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(13760,383,'sr','ÐŸÐ»Ð°Ð½ Ð½ÐµÑÑ‚Ñ€ÑƒÑ‡Ð½Ð¾ ÐºÑƒÑ‚Ð¸Ñ˜Ð° 11',0),(13761,383,'vi','Káº¿ hoáº¡ch khÃ´ng Ä‘áº¡t chuáº©n há»™p 11',0),(13762,383,'af','Posbus 11 nie-gekwalifiseerde Plan',0),(13763,383,'ro','Rubrica 11 necalificat Plan',0),(13764,383,'et','Lahter 11-kellel plaan',0),(13765,383,'si','Polje 11 nekvalificiranega naÄrt',0),(13766,383,'ba','Box 11 berkualitas bebas rencana',0),(13767,383,'nl','Vak 11 niet-gekwalificeerde Plan',0),(13768,383,'fi','11 kohtaan pÃ¤tevÃ¤n suunnitelma',0),(13769,383,'no','Boks 11 ikke-kvalifisert Plan',0),(13770,383,'da','Rubrik 11 ikke-uddannede Plan',0),(13771,383,'ko','ìƒìž 11 ìžê²©ì´ ì—†ëŠ” ê³„íš',0),(13772,383,'he','×ª×•×›× ×™×ª ×©××™× ×• ×ž×•×¡×ž×š box 11',0),(13773,383,'el','Î Î»Î±Î¯ÏƒÎ¹Î¿ 11 Î¼Î· Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÎ¼Î­Î½Î¿ ÏƒÏ‡Î­Î´Î¹Î¿',0),(13774,383,'zh','æ¡†11éžåˆæ ¼è®¡åˆ’\r\n',0),(13775,383,'sv','Ruta 11 icke-kvalificerade Plan',0),(13776,383,'it','Casella 11 Non qualificato piano',0),(13777,383,'tl','',0),(13778,383,'th','&#3585;&#3621;&#3656;&#3629;&#3591; 11 &#3649;&#3612;&#3609;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;',0),(13779,383,'hi','à¤¬à¥‰à¤•à¥à¤¸ 11 à¤—à¥ˆà¤°-à¤¯à¥‹à¤—à¥à¤¯ à¤¯à¥‹à¤œà¤¨à¤¾',0),(13780,383,'ms','Kotak 11-kelayakan pelan',0),(13781,383,'ar','Ø®Ø·Ø© ØºÙŠØ± Ø§Ù„Ù…Ø¤Ù‡Ù„ÙŠÙ† Ù…Ø±Ø¨Ø¹ 11',0),(13782,383,'fr','EncadrÃ© 11 non-qualifiÃ©s Plan',0),(13783,383,'jp','ãƒœãƒƒã‚¯ã‚¹11ã€€é?žé?©æ ¼ãƒ—ãƒ©ãƒ³',0),(13784,383,'pt','Caixa 11 plano de nÃ£o-qualificado',0),(13785,383,'ru','Ð’ÑÑ‚Ð°Ð²ÐºÐ° 11 Ð½ÐµÐ¿Ð¾Ð»Ð½Ð¾Ðµ Ð¿Ð»Ð°Ð½',0),(13786,383,'es','Caja 11 Plan No Calificado',0),(13787,383,'de','Feld 11 nicht qualifizierten Plan',0),(13788,383,'en','Box 11 Non-Qualified Plan',0),(13789,384,'is','',0),(13790,384,'dr','12 Ø·Ø±Ø­ ÙØ§Ù‚Ø¯ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù…',0),(13791,384,'pr','Ø¬Ø¹Ø¨Ù‡ 12 Ø·Ø±Ø­ ÙØ§Ù‚Ø¯ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù…',0),(13792,384,'tr','Kutu 12 kalifiye olmayan planÄ±',0),(13793,384,'pl','Pole 12-kwalifikacje Plan',0),(13794,384,'bg','ÐšÐ»ÐµÑ‚ÐºÐ° 12 Ð½ÐµÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½ Ð¿Ð»Ð°Ð½',0),(13795,384,'ur','Ø®Ø§Ù†Û 12 ØºÛŒØ± Ú©ÙˆØ§Ù„ÛŒÙØ§Ø¦ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(13796,384,'sr','12 ÐºÑƒÑ‚Ð¸Ñ˜Ð° Ð½ÐµÑÑ‚Ñ€ÑƒÑ‡Ð½Ð¾ ÐŸÐ»Ð°Ð½',0),(13797,384,'vi','Káº¿ hoáº¡ch khÃ´ng Ä‘áº¡t chuáº©n há»™p 12',0),(13798,384,'af','Posbus 12 nie-gekwalifiseerde Plan',0),(13799,384,'ro','Rubrica 12 necalificat Plan',0),(13800,384,'et','Lahter 12-kellel plaan',0),(13801,384,'si','Polje 12 nekvalificiranega naÄrt',0),(13802,384,'ba','12 kotak berkualitas bebas rencana',0),(13803,384,'nl','Vak 12 niet-gekwalificeerde Plan',0),(13804,384,'fi','Laatikko 12 pÃ¤tevÃ¤n suunnitelma',0),(13805,384,'no','Boks 12 ikke-kvalifisert Plan',0),(13806,384,'da','Boks 12 ikke-uddannede Plan',0),(13807,384,'ko','ìƒìž 12 ìžê²©ì´ ì—†ëŠ” ê³„íš',0),(13808,384,'he','×ª×™×‘×ª 12 ×©××™× ×• ×ž×•×¡×ž×š ×ª×•×›× ×™×ª',0),(13809,384,'el','Î Î»Î±Î¯ÏƒÎ¹Î¿ 12 Î¼Î· Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÎ¼Î­Î½Î¿ ÏƒÏ‡Î­Î´Î¹Î¿',0),(13810,384,'zh','ç®±12ä¸ªéžåˆæ ¼è®¡åˆ’\r\n',0),(13811,384,'sv','Ruta 12 icke-kvalificerade Plan',0),(13812,384,'it','Scatola 12 Non qualificato piano',0),(13813,384,'tl','',0),(13814,384,'th','&#3585;&#3621;&#3656;&#3629;&#3591; 12 &#3649;&#3612;&#3609;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;',0),(13815,384,'hi','à¤¬à¥‰à¤•à¥à¤¸ 12 à¤—à¥ˆà¤°-à¤¯à¥‹à¤—à¥à¤¯ à¤¯à¥‹à¤œà¤¨à¤¾',0),(13816,384,'ms','Kotak 12-kelayakan pelan',0),(13817,384,'ar','Ø®Ø·Ø© 12 Ù…Ø±Ø¨Ø¹ ØºÙŠØ± Ø§Ù„Ù…Ø¤Ù‡Ù„ÙŠÙ†',0),(13818,384,'fr','EncadrÃ© 12 non-qualifiÃ©s Plan',0),(13819,384,'jp','ãƒœãƒƒã‚¯ã‚¹12ã€€é?žé?©æ ¼ãƒ—ãƒ©ãƒ³',0),(13820,384,'pt','Plano de caixa 12 nÃ£o qualificado',0),(13821,384,'ru','Ð’ÑÑ‚Ð°Ð²ÐºÐ° 12 Ð½ÐµÐ¿Ð¾Ð»Ð½Ð¾Ðµ Ð¿Ð»Ð°Ð½',0),(13822,384,'es','Caja 12 Plan No Calificado',0),(13823,384,'de','Feld 12 nicht qualifizierten Plan',0),(13824,384,'en','Box 12 Non-Qualified Plan',0),(13825,385,'is','',0),(13826,385,'dr','13 Ø·Ø±Ø­ ÙˆØ§Ø¬Ø¯ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù…',0),(13827,385,'pr','Ø¬Ø¹Ø¨Ù‡ 13 Ø·Ø±Ø­ ÙˆØ§Ø¬Ø¯ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù…',0),(13828,385,'tr','Kutu 13 nitelikli Plan',0),(13829,385,'pl','Pole 13 wykwalifikowanych Plan',0),(13830,385,'bg','Ð“Ñ€Ð°Ñ„Ð° 13 ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð»Ð°Ð½',0),(13831,385,'ur','Ø§ÛÙ„ Ø®Ø§Ù†Û 13 Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(13832,385,'sr','ÐšÑƒÑ‚Ð¸Ñ˜Ð° 13 ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¸Ñ… ÐŸÐ»Ð°Ð½',0),(13833,385,'vi','Káº¿ hoáº¡ch Ä‘áº¡t chuáº©n há»™p 13',0),(13834,385,'af','Posbus 13 gekwalifiseerde Plan',0),(13835,385,'ro','Caseta 13 calificat Plan',0),(13836,385,'et','Lahtris 13 kvalifitseeritud plaan',0),(13837,385,'si','Polje 13 kvalificirano naÄrt',0),(13838,385,'ba','Box 13 berkualitas rencana',0),(13839,385,'nl','Vak 13 gekwalificeerde Plan',0),(13840,385,'fi','Laatikko 13 pÃ¤tevÃ¤ suunnitelma',0),(13841,385,'no','Boksen 13 kvalifisert Plan',0),(13842,385,'da','Rubrik 13 kvalificeret Plan',0),(13843,385,'ko','ìƒìž 13 ìžê²©ì„ ê³„íš',0),(13844,385,'he','×ª×•×›× ×™×ª ×ž×•×¡×ž×š ×ª×™×‘×ª 13',0),(13845,385,'el','Î˜Î­ÏƒÎ· 13 ÎµÎ¹Î´Î¹ÎºÎ® ÏƒÏ‡Î­Î´Î¹Î¿',0),(13846,385,'zh','æ¡†13åˆæ ¼è®¡åˆ’\r\n',0),(13847,385,'sv','FÃ¤lt 13 kvalificerad Plan',0),(13848,385,'it','Casella 13 piano qualificato',0),(13849,385,'tl','',0),(13850,385,'th','&#3585;&#3621;&#3656;&#3629;&#3591; 13 &#3649;&#3612;&#3609;&#3612;&#3656;&#3634;&#3609;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;',0),(13851,385,'hi','à¤¬à¥‰à¤•à¥à¤¸ 13 à¤¯à¥‹à¤—à¥à¤¯ à¤¯à¥‹à¤œà¤¨à¤¾',0),(13852,385,'ms','13 Peti layak pelan',0),(13853,385,'ar','Ø®Ø·Ø© Ø§Ù„Ù…Ø¤Ù‡Ù„ÙŠÙ† Ù…Ø±Ø¨Ø¹ 13',0),(13854,385,'fr','EncadrÃ© 13 Plan qualifiÃ©',0),(13855,385,'jp','ãƒœãƒƒã‚¯ã‚¹13ã€€é?©æ ¼ãƒ—ãƒ©ãƒ³',0),(13856,385,'pt','Caixa 13 plano qualificado',0),(13857,385,'ru','Ð’ÑÑ‚Ð°Ð²ÐºÐ° 13 ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð¿Ð»Ð°Ð½',0),(13858,385,'es','Caja 13 Plan Calificado',0),(13859,385,'de','Kasten 13 qualifizierte Plan',0),(13860,385,'en','Box 13 Qualified Plan',0),(13861,386,'is','',0),(13862,386,'dr','14 Ø·Ø±Ø­ ÙˆØ§Ø¬Ø¯ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù…',0),(13863,386,'pr','Ø¬Ø¹Ø¨Ù‡ 14 Ø·Ø±Ø­ ÙˆØ§Ø¬Ø¯ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù…',0),(13864,386,'tr','Kutu 14 nitelikli Plan',0),(13865,386,'pl','Pole 14 kwalifikacje Plan',0),(13866,386,'bg','ÐšÐ»ÐµÑ‚ÐºÐ° 14 ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð»Ð°Ð½',0),(13867,386,'ur','Ø§ÛÙ„ Ø®Ø§Ù†Û 14 Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(13868,386,'sr','ÐšÑƒÑ‚Ð¸Ñ˜Ð° 14 ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¸Ñ… ÐŸÐ»Ð°Ð½',0),(13869,386,'vi','Káº¿ hoáº¡ch Ä‘áº¡t chuáº©n há»™p 14',0),(13870,386,'af','Posbus 14 gekwalifiseerde Plan',0),(13871,386,'ro','Rubrica 14 calificatÄƒ Plan',0),(13872,386,'et','Lahter 14 kvalifitseeritud plaan',0),(13873,386,'si','Polje 14 kvalificirano naÄrt',0),(13874,386,'ba','Kotak 14 berkualitas rencana',0),(13875,386,'nl','Vak 14 gekwalificeerde Plan',0),(13876,386,'fi','14 kohta pÃ¤tevÃ¤ suunnitelma',0),(13877,386,'no','Boks 14 kvalifisert Plan',0),(13878,386,'da','Rubrik 14 kvalificerede Plan',0),(13879,386,'ko','ìƒìž 14 ìžê²©ëœ ê³„íš',0),(13880,386,'he','×ª×•×›× ×™×ª ×ž×•×¡×ž×š ×ª×™×‘×ª 14',0),(13881,386,'el','Î•Î¹Î´Î¹ÎºÎ® ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ 14',0),(13882,386,'zh','æ–¹æ¡†14åˆæ ¼è®¡åˆ’\r\n',0),(13883,386,'sv','FÃ¤lt 14 kvalificerad Plan',0),(13884,386,'it','Casella 14 piano qualificato',0),(13885,386,'tl','',0),(13886,386,'th','&#3585;&#3621;&#3656;&#3629;&#3591; 14 &#3649;&#3612;&#3609;&#3612;&#3656;&#3634;&#3609;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;',0),(13887,386,'hi','à¤¬à¥‰à¤•à¥à¤¸ 14 à¤¯à¥‹à¤—à¥à¤¯ à¤¯à¥‹à¤œà¤¨à¤¾',0),(13888,386,'ms','14 Peti layak pelan',0),(13889,386,'ar','Ø®Ø·Ø© Ø§Ù„Ù…Ø¤Ù‡Ù„ÙŠÙ† Ù…Ø±Ø¨Ø¹ 14',0),(13890,386,'fr','Case 14 Plan qualifiÃ©',0),(13891,386,'jp','ãƒœãƒƒã‚¯ã‚¹14ã€€é?©æ ¼ãƒ—ãƒ©ãƒ³',0),(13892,386,'pt','Caixa 14 plano qualificado',0),(13893,386,'ru','Ð’ÑÑ‚Ð°Ð²ÐºÐ° 14 ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð¿Ð»Ð°Ð½',0),(13894,386,'es','Caja 14 Plan Calificado',0),(13895,386,'de','Feld 14 qualifizierte Plan',0),(13896,386,'en','Box 14 Qualified Plan',0),(13897,387,'is','',0),(13898,387,'dr','Ú©Ø§Ø¯Ø±Ù‡Ø§',0),(13899,387,'pr','Ú©Ø§Ø¯Ø±Ù‡Ø§',0),(13900,387,'tr','KutularÄ±',0),(13901,387,'pl','Pola',0),(13902,387,'bg','ÐšÑƒÑ‚Ð¸Ð¸',0),(13903,387,'ur','Ø®Ø§Ù†Û’',0),(13904,387,'sr','ÐšÑƒÑ‚Ð¸Ñ˜Ðµ',0),(13905,387,'vi','Há»™p',0),(13906,387,'af','Bokse',0),(13907,387,'ro','Cutii',0),(13908,387,'et','Kastid',0),(13909,387,'si','Å katle',0),(13910,387,'ba','Kotak',0),(13911,387,'nl','Vakken',0),(13912,387,'fi','Laatikot',0),(13913,387,'no','Bokser',0),(13914,387,'da','Kasser',0),(13915,387,'ko','ìƒìž',0),(13916,387,'he','×ª×™×‘×•×ª',0),(13917,387,'el','ÎšÎ¿Ï…Ï„Î¹Î¬',0),(13918,387,'zh','ç›’\r\n',0),(13919,387,'sv','LÃ¥dor',0),(13920,387,'it','Scatole',0),(13921,387,'tl','',0),(13922,387,'th','&#3585;&#3621;&#3656;&#3629;&#3591;',0),(13923,387,'hi','à¤¬à¤•à¥à¤¸à¥‡',0),(13924,387,'ms','Kotak',0),(13925,387,'ar','Ù…Ø±Ø¨Ø¹Ø§Øª',0),(13926,387,'fr','BoÃ®tes',0),(13927,387,'jp','ãƒœãƒƒã‚¯ã‚¹',0),(13928,387,'pt','Caixas',0),(13929,387,'ru','ÐšÐ¾Ñ€Ð¾Ð±ÐºÐ¸',0),(13930,387,'es','Cajas',0),(13931,387,'de','Boxen',0),(13932,387,'en','Boxes',0),(13933,388,'is','',0),(13934,388,'dr','Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÙŠ ÙŠØ§ÙØªÙ†',0),(13935,388,'pr','Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÙŠ ÙŠØ§ÙØªÙ†',0),(13936,388,'tr','Bulmak iÃ§in gÃ¶z atÄ±n',0),(13937,388,'pl','PrzeglÄ…daj, aby znaleÅºÄ‡',0),(13938,388,'bg','ÐŸÑ€ÐµÐ¼Ð¸Ð½ÐµÑ‚Ðµ ÐºÑŠÐ¼ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(13939,388,'ur','ØªÙ„Ø§Ø´ Ú©Û’ Ù„ÛŒÛ’ Ø¨Ø±Ø§Ø¤Ø² Ú©Ø±ÛŒÚº',0),(13940,388,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð¶Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð¸ Ð¤Ð¸Ð½Ð´',0),(13941,388,'vi','Tiáº¿p tá»¥c tÃ¬m kiáº¿m',0),(13942,388,'af','Blaai om te vind',0),(13943,388,'ro','RÄƒsfoiÅ£i pentru a gÄƒsi',0),(13944,388,'et','Liikuge sirvides otsimine',0),(13945,388,'si','Prebrskajte do iskanja',0),(13946,388,'ba','Browse untuk menemukan',0),(13947,388,'nl','Ga naar zoeken',0),(13948,388,'fi','Selaa lÃ¶ytÃ¤Ã¤',0),(13949,388,'no','Bla gjennom for Ã¥ finne',0),(13950,388,'da','Gennemse til at finde',0),(13951,388,'ko','ì°¾ê¸°ë¥¼ í´ë¦­ í•˜ ì—¬ ê²€ìƒ‰',0),(13952,388,'he','××ª×¨ ×—×™×¤×•×©',0),(13953,388,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± Î½Î± Î²ÏÎµÎ¯Ï„Îµ',0),(13954,388,'zh','æµè§ˆæŸ¥æ‰¾\r\n',0),(13955,388,'sv','BlÃ¤ddra till SÃ¶k',0),(13956,388,'it','Sfoglia per trovare',0),(13957,388,'tl','',0),(13958,388,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3607;&#3637;&#3656;&#3592;&#3632;&#3588;&#3657;&#3609;&#3627;&#3634;',0),(13959,388,'hi','à¤–à¥‹à¤œà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥à¤°à¤¾à¤‰à¤œà¤¼ à¤•à¤°à¥‡à¤‚',0),(13960,388,'ms','Semak seimbas untuk mencari',0),(13961,388,'ar','Ø§Ø³ØªØ¹Ø±Ø¶ Ù„Ù„Ø¨Ø­Ø« Ø¹Ù†',0),(13962,388,'fr','AccÃ©dez Ã  trouver',0),(13963,388,'jp','è¦‹ã?¤ã?‘ã‚‹ãƒ–ãƒ©ã‚¦ã‚¶',0),(13964,388,'pt','Navegue atÃ© encontrar',0),(13965,388,'ru','ÐžÐ±Ð·Ð¾Ñ€, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð½Ð°Ð¹Ñ‚Ð¸',0),(13966,388,'es','Buscar para Encontrar',0),(13967,388,'de','Wechseln Sie zu suchen',0),(13968,388,'en','Browse to Find',0),(13969,389,'is','',0),(13970,389,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(13971,389,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(13972,389,'tr','BÃ¼tÃ§e',0),(13973,389,'pl','BudÅ¼et',0),(13974,389,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(13975,389,'ur','Ø¨Ø¬Ù¹',0),(13976,389,'sr','Ð‘ÑƒÑŸÐµÑ‚',0),(13977,389,'vi','NgÃ¢n sÃ¡ch',0),(13978,389,'af','Begroting',0),(13979,389,'ro','Buget',0),(13980,389,'et','Eelarve',0),(13981,389,'si','ProraÄun',0),(13982,389,'ba','Anggaran',0),(13983,389,'nl','Begroting',0),(13984,389,'fi','Talousarvion',0),(13985,389,'no','Budsjett',0),(13986,389,'da','Budget',0),(13987,389,'ko','ì˜ˆì‚°',0),(13988,389,'he','×ª×§×¦×™×‘',0),(13989,389,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(13990,389,'zh','è´¢æ”¿é¢„ç®—æ¡ˆ\r\n',0),(13991,389,'sv','Budget',0),(13992,389,'it','Bilancio',0),(13993,389,'tl','',0),(13994,389,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(13995,389,'hi','à¤¬à¤œà¤Ÿ',0),(13996,389,'ms','Bajet',0),(13997,389,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(13998,389,'fr','Budget',0),(13999,389,'jp','äºˆç®—',0),(14000,389,'pt','OrÃ§amento',0),(14001,389,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(14002,389,'es','Presupuesto',0),(14003,389,'de','Budget',0),(14004,389,'en','Budget',0),(14005,390,'is','',0),(14006,390,'dr','/ Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡',0),(14007,390,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ/ Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡',0),(14008,390,'tr','BÃ¼tÃ§e Ekle/GÃ¼ncelle',0),(14009,390,'pl','BudÅ¼et Dodaj/Aktualizuj',0),(14010,390,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(14011,390,'ur','Ø¨Ø¬Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(14012,390,'sr','Ð‘ÑƒÑŸÐµÑ‚/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(14013,390,'vi','ThÃªm/Cáº­p Nháº­t NgÃ¢n SÃ¡ch',0),(14014,390,'af','Begroting Byvoeg/Opdateer',0),(14015,390,'ro','Buget AdÄƒugaÅ£i/actualizaÅ£i',0),(14016,390,'et','Eelarve lisamine/uuendamine',0),(14017,390,'si','ProraÄun Dodaj/posodobi',0),(14018,390,'ba','Anggaran Tambahkan/Perbarui',0),(14019,390,'nl','Begroting toevoegen/bijwerken',0),(14020,390,'fi','Talousarvion lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(14021,390,'no','Budsjett/Oppdater',0),(14022,390,'da','Budget TilfÃ¸j/opdater',0),(14023,390,'ko','ì˜ˆì‚° ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(14024,390,'he','×ª×§×¦×™×‘ ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(14025,390,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(14026,390,'zh','é¢„ç®—æ–°å¢ž/æ›´æ–°\r\n',0),(14027,390,'sv','Budget LÃ¤gg till/uppdatera',0),(14028,390,'it','Aggiungere/aggiornare un bilancio',0),(14029,390,'tl','',0),(14030,390,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(14031,390,'hi','à¤¬à¤œà¤Ÿ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(14032,390,'ms','Bajet Tambah/Kemaskini',0),(14033,390,'ar','ØªØ­Ø¯ÙŠØ«/ÙÙŠ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(14034,390,'fr','Ajouter/mise Ã  jour budgÃ©taire',0),(14035,390,'jp','äºˆç®—ã?®è¿½åŠ /æ›´æ–°',0),(14036,390,'pt','OrÃ§amento adicionar/atualizar',0),(14037,390,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(14038,390,'es','Presupuesto Agregar/Actualizar',0),(14039,390,'de','Haushalt hinzufÃ¼gen/aktualisieren',0),(14040,390,'en','Budget Add/Update',0),(14041,391,'is','',0),(14042,391,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(14043,391,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(14044,391,'tr','BÃ¼tÃ§e baÅŸarÄ±yla eklendi.',0),(14045,391,'pl','BudÅ¼et dodane pomyÅ›lnie.',0),(14046,391,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(14047,391,'ur','Ø¨Ø¬Ù¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(14048,391,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(14049,391,'vi','ThÃªm NgÃ¢n sÃ¡ch thÃ nh cÃ´ng',0),(14050,391,'af','Begroting suksesvol bygevoeg',0),(14051,391,'ro','Buget adÄƒugat cu succes.',0),(14052,391,'et','Eelarvesse lisatud.',0),(14053,391,'si','ProraÄun uspeÅ¡no dodana.',0),(14054,391,'ba','Anggaran ditambahkan berhasil.',0),(14055,391,'nl','Begroting met succes toegevoegd.',0),(14056,391,'fi','Talousarvion lisÃ¤Ã¤minen onnistui.',0),(14057,391,'no','Budsjett lagt.',0),(14058,391,'da','Budget tilfÃ¸jet.',0),(14059,391,'ko','ì˜ˆì‚° ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(14060,391,'he','×ª×§×¦×™×‘ × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(14061,391,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(14062,391,'zh','é¢„ç®—æ·»åŠ æˆåŠŸã€‚\r\n',0),(14063,391,'sv','Budgeten lagts.',0),(14064,391,'it','Bilancio aggiunto con successo.',0),(14065,391,'tl','',0),(14066,391,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(14067,391,'hi','à¤¬à¤œà¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(14068,391,'ms','Bajet yang berjaya menambah.',0),(14069,391,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„ØªÙ‚Ø¯ÙŠØ±ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(14070,391,'fr','Budget ajoutÃ© avec succÃ¨s.',0),(14071,391,'jp','äºˆç®—ã‚’è¿½åŠ ã?—ã?¾ã?—ã?Ÿ',0),(14072,391,'pt','OrÃ§amento adicionado com Ãªxito.',0),(14073,391,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(14074,391,'es','Presupuesto Agregado Exitosamente',0),(14075,391,'de','Budget erfolgreich hinzugefÃ¼gt.',0),(14076,391,'en','Budget added successfully.',0),(14077,392,'is','',0),(14078,392,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ ÙŠØ§ÙØª Ù†Ù…ÙŠ Ø´ÙˆØ¯',0),(14079,392,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ ÙŠØ§ÙØª Ù†Ù…ÙŠ Ø´ÙˆØ¯',0),(14080,392,'tr','BÃ¼tÃ§e-ebil deÄŸil bulunmak.',0),(14081,392,'pl','Nie moÅ¼na odnaleÅºÄ‡ budÅ¼etu.',0),(14082,392,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(14083,392,'ur','Ø¨Ø¬Ù¹ Ù†ÛÛŒÚº Ù…Ù„ Ø³Ú©Ø§ Û”',0),(14084,392,'sr','Ð‘ÑƒÑŸÐµÑ‚ ÑÐµ Ð½Ð¸Ñ˜Ðµ Ð¼Ð¾Ð³Ð»Ð° Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸.',0),(14085,392,'vi','KhÃ´ng tÃ¬m tháº¥y NgÃ¢n sÃ¡ch',0),(14086,392,'af','Begroting kon nie gevind word nie.',0),(14087,392,'ro','Bugetul nu ar putea fi gÄƒsite.',0),(14088,392,'et','Eelarvest ei leia.',0),(14089,392,'si','ProraÄuna ni bilo mogoÄe najti.',0),(14090,392,'ba','Anggaran tidak dapat ditemukan.',0),(14091,392,'nl','Begroting kon niet worden gevonden.',0),(14092,392,'fi','Talousarvio ei lÃ¶ytynyt.',0),(14093,392,'no','Finner ikke budsjettet.',0),(14094,392,'da','Budget kunne ikke findes.',0),(14095,392,'ko','ì˜ˆì‚°ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(14096,392,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ×ª×§×¦×™×‘.',0),(14097,392,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ, Î´ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î²ÏÎµÎ¸ÎµÎ¯.',0),(14098,392,'zh','é¢„ç®—æ¡ˆæœªèƒ½æ‰¾åˆ°ã€‚\r\n',0),(14099,392,'sv','Budgeten kunde inte hittas.',0),(14100,392,'it','Bilancio non Ã¨ stato trovato.',0),(14101,392,'tl','',0),(14102,392,'th','&#3627;&#3634;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3652;&#3617;&#3656;&#3648;&#3592;&#3629;',0),(14103,392,'hi','à¤¬à¤œà¤Ÿ à¤¢à¥‚à¤à¤¢à¤¼à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤¸à¤•à¤¾à¥¤',0),(14104,392,'ms','Bajet tidak dapat ditemui.',0),(14105,392,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥ÙŠØ¬Ø§Ø¯ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(14106,392,'fr','Budget est introuvable.',0),(14107,392,'jp','äºˆç®—ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(14108,392,'pt','OrÃ§amento nÃ£o pÃ´de ser encontrado.',0),(14109,392,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(14110,392,'es','No se podia encontrar el presupuesto',0),(14111,392,'de','Haushalt konnte nicht gefunden werden.',0),(14112,392,'en','Budget could not be found.',0),(14113,393,'is','',0),(14114,393,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(14115,393,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(14116,393,'tr','BÃ¼tÃ§e baÅŸarÄ±yla silindi.',0),(14117,393,'pl','BudÅ¼et usuniÄ™te pomyÅ›lnie.',0),(14118,393,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(14119,393,'ur','Ø¨Ø¬Ù¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(14120,393,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(14121,393,'vi','XÃ³a NgÃ¢n sÃ¡ch thÃ nh cÃ´ng',0),(14122,393,'af','Begroting suksesvol geskrap',0),(14123,393,'ro','Buget ÅŸters cu succes.',0),(14124,393,'et','Eelarve kustutati edukalt',0),(14125,393,'si','ProraÄun uspeÅ¡no izbrisana.',0),(14126,393,'ba','Anggaran berhasil dihapus.',0),(14127,393,'nl','Begroting met succes verwijderd.',0),(14128,393,'fi','Talousarvion poistettu.',0),(14129,393,'no','Budsjett slettet.',0),(14130,393,'da','Budget slettet.',0),(14131,393,'ko','ì˜ˆì‚° ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(14132,393,'he','×ª×§×¦×™×‘ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(14133,393,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(14134,393,'zh','è´¢æ”¿é¢„ç®—æ¡ˆå·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(14135,393,'sv','Budget raderades.',0),(14136,393,'it','Bilancio cancellato con successo.',0),(14137,393,'tl','',0),(14138,393,'th','&#3621;&#3610;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(14139,393,'hi','à¤¬à¤œà¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(14140,393,'ms','Bajet dihapuskan dengan jayanya.',0),(14141,393,'ar','Ø­Ø°ÙØª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„ØªÙ‚Ø¯ÙŠØ±ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(14142,393,'fr','Budget supprimÃ© avec succÃ¨s.',0),(14143,393,'jp','äºˆç®—ã‚’æ¶ˆåŽ»ã?—ã?¾ã?—ã?Ÿ',0),(14144,393,'pt','OrÃ§amento excluÃ­do com sucesso.',0),(14145,393,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½.',0),(14146,393,'es','Presupuesto Eliminado Exitosamente',0),(14147,393,'de','Budget erfolgreich gelÃ¶scht.',0),(14148,393,'en','Budget deleted successfully.',0),(14149,394,'is','',0),(14150,394,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆÙŠØ±Ø§ÙŠØ´ Ø´Ø¯',0),(14151,394,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆÙŠØ±Ø§ÙŠØ´ Ø´Ø¯',0),(14152,394,'tr','BÃ¼tÃ§e baÅŸarÄ±yla dÃ¼zenlenmiÅŸ.',0),(14153,394,'pl','BudÅ¼et edytowane pomyÅ›lnie.',0),(14154,394,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚, Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(14155,394,'ur','Ø¨Ø¬Ù¹ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ ÛÛ’ Û”',0),(14156,394,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÑ€ÐµÑ’ÐµÐ½Ð¸.',0),(14157,394,'vi','NgÃ¢n SÃ¡ch Sá»­a thÃ nh cÃ´ng',0),(14158,394,'af','Begroting suksesvol geredigeer.',0),(14159,394,'ro','Buget editat cu succes.',0),(14160,394,'et','Eelarve muudeti edukalt',0),(14161,394,'si','ProraÄun uspeÅ¡no urejati.',0),(14162,394,'ba','Anggaran Edit sukses.',0),(14163,394,'nl','Begroting met succes bewerkt.',0),(14164,394,'fi','Talousarvion muokattu onnistuneesti.',0),(14165,394,'no','Budsjett endret vellykket.',0),(14166,394,'da','Budget redigeret med succes.',0),(14167,394,'ko','ì˜ˆì‚° ì„±ê³µì ìœ¼ë¡œ íŽ¸ì§‘ í•©ë‹ˆë‹¤.',0),(14168,394,'he','×ª×§×¦×™×‘ × ×¢×¨×š ×‘×”×¦×œ×—×”.',0),(14169,394,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(14170,394,'zh','é¢„ç®—ç¼–è¾‘æˆåŠŸã€‚\r\n',0),(14171,394,'sv','Budget redigerad framgÃ¥ngsrikt.',0),(14172,394,'it','Bilancio modificato con successo.',0),(14173,394,'tl','',0),(14174,394,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(14175,394,'hi','à¤¬à¤œà¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾à¥¤',0),(14176,394,'ms','Bajet diedit berjaya.',0),(14177,394,'ar','Ø­Ø±Ù‘Ø±Øª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„ØªÙ‚Ø¯ÙŠØ±ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(14178,394,'fr','Budget rÃ©visÃ© avec succÃ¨s.',0),(14179,394,'jp','äºˆç®—ã‚’ç·¨é›†ã?—ã?¾ã?—ã?Ÿ',0),(14180,394,'pt','OrÃ§amento editado com sucesso.',0),(14181,394,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½.',0),(14182,394,'es','Presupuesto Editado Exitosamente',0),(14183,394,'de','Budget erfolgreich bearbeitet.',0),(14184,394,'en','Budget edited successfully.',0),(14185,395,'is','',0),(14186,395,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(14187,395,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(14188,395,'tr','YÄ±l iÃ§in bÃ¼tÃ§e',0),(14189,395,'pl','BudÅ¼etu na rok',0),(14190,395,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(14191,395,'ur','Ø³Ø§Ù„ Ú©Ø§ Ø¨Ø¬Ù¹',0),(14192,395,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(14193,395,'vi','NgÃ¢n sÃ¡ch cho nÄƒm',0),(14194,395,'af','Begroting vir Jaar',0),(14195,395,'ro','Bugetul pentru anul',0),(14196,395,'et','Aasta eelarve',0),(14197,395,'si','ProraÄuna za leto',0),(14198,395,'ba','Anggaran untuk tahun',0),(14199,395,'nl','Begroting voor jaar',0),(14200,395,'fi','Vuoden talousarviossa',0),(14201,395,'no','Budsjettet for Ã¥ret',0),(14202,395,'da','Budgettet for Ã¥ret',0),(14203,395,'ko','1 ë…„ ì˜ˆì‚°',0),(14204,395,'he','×”×ª×§×¦×™×‘ ×œ×©× ×”',0),(14205,395,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚',0),(14206,395,'zh','å¹´åº¦é¢„ç®—\r\n',0),(14207,395,'sv','Budget fÃ¶r Ã¥r',0),(14208,395,'it','Bilancio per l\'anno',0),(14209,395,'tl','',0),(14210,395,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3586;&#3629;&#3591;&#3611;&#3637;',0),(14211,395,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤œà¤Ÿ',0),(14212,395,'ms','Bajet untuk tahun',0),(14213,395,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù„Ø³Ù†Ø© ',0),(14214,395,'fr','Budget pour l\'annÃ©e',0),(14215,395,'jp','ï½žã?®å¹´ã?®äºˆç®—',0),(14216,395,'pt','OrÃ§amento para o ano',0),(14217,395,'ru','Ð“Ð¾Ð´Ð¾Ð²Ð¾Ð¹ Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(14218,395,'es','Presupuesto para el AÃ±o',0),(14219,395,'de','Budget fÃ¼r das Jahr',0),(14220,395,'en','Budget for Year',0),(14221,396,'is','',0),(14222,396,'dr','Ù„ÙŠØ³Øª Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÙŠ',0),(14223,396,'pr','Ù„ÙŠØ³Øª Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÙŠ',0),(14224,396,'tr','Hesap iÃ§in bÃ¼tÃ§e bazÄ±nda',0),(14225,396,'pl','Lista budÅ¼etu przez konto',0),(14226,396,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ ÑÐ¿Ð¸ÑÑŠÐº Ð¾Ñ‚ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð°',0),(14227,396,'ur','Ø¨Ø¬Ù¹ Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„Ø¦Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(14228,396,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ð»Ð¸ÑÑ‚Ðµ Ð¿Ð¾ Ð½Ð°Ð»Ð¾Ð³Ñƒ Ð·Ð°',0),(14229,396,'vi','Danh SÃ¡ch NgÃ¢n SÃ¡ch theo TK cho',0),(14230,396,'af','Begrotinglys per Rekening vir',0),(14231,396,'ro','ListÄƒ de buget de cont pentru',0),(14232,396,'et','Eelarve loendist konto jÃ¤rgi',0),(14233,396,'si','ProraÄun seznam raÄun za',0),(14234,396,'ba','Anggaran daftar rekening untuk',0),(14235,396,'nl','Begroting lijst per Account voor',0),(14236,396,'fi','Budjetti luetteloon tilin mukaan',0),(14237,396,'no','Budsjett listen etter konto for',0),(14238,396,'da','Budget liste af konto for',0),(14239,396,'ko','ì˜ˆì‚° ëª©ë¡ì— ëŒ€ í•œ ê³„ì •ìœ¼ë¡œ',0),(14240,396,'he','×¨×©×™×ž×ª ×ª×§×¦×™×‘ ×œ×¤×™ ×—×©×‘×•×Ÿ ×¢×‘×•×¨',0),(14241,396,'el','Î›Î¯ÏƒÏ„Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î±Ï€ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î³Î¹Î±',0),(14242,396,'zh','é¢„ç®—å¸æˆ·ä¸€è§ˆè¡¨\r\n',0),(14243,396,'sv','Budget lista av konto fÃ¶r',0),(14244,396,'it','Bilancio elenco di Account per',0),(14245,396,'tl','',0),(14246,396,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3650;&#3604;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;&#3586;&#3629;&#3591;',0),(14247,396,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¬à¤œà¤Ÿ à¤¸à¥‚à¤šà¥€',0),(14248,396,'ms','Senarai bajet oleh akaun untuk',0),(14249,396,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø¨Ø­Ø³Ø§Ø¨',0),(14250,396,'fr','Liste de budget par compte pour',0),(14251,396,'jp','ï½žã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆåˆ¥äºˆç®—ãƒªã‚¹ãƒˆ',0),(14252,396,'pt','Lista de orÃ§amento por conta de',0),(14253,396,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° Ð½Ð° ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ',0),(14254,396,'es','Presupuesto, Lista por Cuenta para',0),(14255,396,'de','Budget Liste von entfallen',0),(14256,396,'en','Budget List by Account for',0),(14257,397,'is','',0),(14258,397,'dr','Ù†Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡',0),(14259,397,'pr','Ù†Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡',0),(14260,397,'tr','BÃ¼tÃ§e adÄ±',0),(14261,397,'pl','Nazwa budÅ¼etu',0),(14262,397,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(14263,397,'ur','Ø¨Ø¬Ù¹ Ú©Ø§ Ù†Ø§Ù…',0),(14264,397,'sr','Ð˜Ð¼Ðµ Ð±ÑƒÑŸÐµÑ‚Ð°',0),(14265,397,'vi','TÃªn NgÃ¢n sÃ¡ch',0),(14266,397,'af','Begrotingnaam',0),(14267,397,'ro','Nume buget',0),(14268,397,'et','Eelarve nimi',0),(14269,397,'si','Ime predraÄuna',0),(14270,397,'ba','Nama anggaran',0),(14271,397,'nl','Naam artikelbudget',0),(14272,397,'fi','Budjetin nimi',0),(14273,397,'no','Navn pÃ¥ varebudsjett',0),(14274,397,'da','Budgetnavn',0),(14275,397,'ko','ì˜ˆì‚° ì´ë¦„',0),(14276,397,'he','×©× ×ª×§×¦×™×‘',0),(14277,397,'el','ÎŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(14278,397,'zh','è´¢æ”¿é¢„ç®—æ¡ˆå\r\n',0),(14279,397,'sv','Budgetnamnet',0),(14280,397,'it','Nome del bilancio',0),(14281,397,'tl','',0),(14282,397,'th','&#3594;&#3639;&#3656;&#3629;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(14283,397,'hi','à¤¬à¤œà¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(14284,397,'ms','Nama bajet',0),(14285,397,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(14286,397,'fr','Nom de budget',0),(14287,397,'jp','äºˆç®—å??',0),(14288,397,'pt','Nome do orÃ§amento',0),(14289,397,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(14290,397,'es','Nombre de Presupuesto',0),(14291,397,'de','Haushalt Namen',0),(14292,397,'en','Budget Name',0),(14293,398,'is','',0),(14294,398,'dr','/ Ø­Ø°Ù',0),(14295,398,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ / Ø­Ø°Ù',0),(14296,398,'tr','BÃ¼tÃ§e iÃ§in DÃ¼zenle/Sil',0),(14297,398,'pl','BudÅ¼et do edycji/usuwania',0),(14298,398,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(14299,398,'ur','Ø¨Ø¬Ù¹ Ø§ÙŠÚˆÙ¹/Ø®ØªÙ…',0),(14300,398,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ð´Ð° Ð£Ñ€ÐµÐ´Ð¸/Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸',0),(14301,398,'vi','Sá»­a/XÃ³a NgÃ¢n SÃ¡ch',0),(14302,398,'af','Begroting om te Redigeer/Skrap',0),(14303,398,'ro','Buget pentru a edita/sterge',0),(14304,398,'et','Muuda/Kustuta eelarvet',0),(14305,398,'si','ProraÄun za urejanje/brisanje',0),(14306,398,'ba','Anggaran untuk mengedit/menghapus',0),(14307,398,'nl','Begroting te bewerken/verwijderen',0),(14308,398,'fi','Talousarvion muokata tai poistaa',0),(14309,398,'no','Budsjett til Ã¥ redigere/slette',0),(14310,398,'da','Budget til Rediger/slet',0),(14311,398,'ko','ì˜ˆì‚° ìˆ˜ì •/ì‚­ì œ',0),(14312,398,'he','×ª×§×¦×™×‘ ×¢×¨×™×›×ª/×ž×—×™×§×ª',0),(14313,398,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ/Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ',0),(14314,398,'zh','è´¢æ”¿é¢„ç®—æ¡ˆç¼–è¾‘/åˆ é™¤\r\n',0),(14315,398,'sv','Budget fÃ¶r att redigera/ta bort',0),(14316,398,'it','Bilancio per modificare/eliminare',0),(14317,398,'tl','',0),(14318,398,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;/&#3621;&#3610;',0),(14319,398,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤/à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤œà¤Ÿ',0),(14320,398,'ms','Bajet untuk Edit/Delete',0),(14321,398,'ar','ØªØ­Ø±ÙŠØ±/Ø­Ø°Ù Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(14322,398,'fr','Budget de modifier/supprimer',0),(14323,398,'jp','ç·¨é›†/æ¶ˆåŽ»ã?™ã‚‹äºˆç®—',0),(14324,398,'pt','OrÃ§amento para editar/apagar',0),(14325,398,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð´Ð»Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ/Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ñ',0),(14326,398,'es','Presupuesto para Editar/Eliminar',0),(14327,398,'de','Haushalt zu bearbeiten/lÃ¶schen',0),(14328,398,'en','Budget to Edit/Delete',0),(14329,399,'is','',0),(14330,399,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù…ØºØ§ÙŠØ±Øª Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø±Ø§ÙŠ',0),(14331,399,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù…ØºØ§ÙŠØ±Øª Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø±Ø§ÙŠ',0),(14332,399,'tr','BÃ¼tÃ§e varyans deyim iÃ§in',0),(14333,399,'pl','BudÅ¼et odchylenie instrukcja dla',0),(14334,399,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð´Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð°',0),(14335,399,'ur','Ø¨Ø¬Ù¹ ØªØºÛŒØ± Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(14336,399,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð¾Ð´ÑÑ‚ÑƒÐ¿Ð°ÑšÐ° Ð±ÑƒÑŸÐµÑ‚Ð° Ð·Ð°',0),(14337,399,'vi','Sao kÃª ChÃªnh lá»‡ch NgÃ¢n sÃ¡ch cho',0),(14338,399,'af','Begroting Afwyking Staat vir',0),(14339,399,'ro','Buget varianÅ£a declaraÅ£ie pentru',0),(14340,399,'et','Eelarve erinevus lause',0),(14341,399,'si','Varianca izpisek predraÄuna za',0),(14342,399,'ba','Pernyataan varians anggaran untuk',0),(14343,399,'nl','Verklaring van de variantie van de begroting voor',0),(14344,399,'fi','Budjetin varianssin lauseen',0),(14345,399,'no','Budsjett varians setningen for',0),(14346,399,'da','Budget afvigelse redegÃ¸relse for',0),(14347,399,'ko','ì˜ˆì‚° ë¶„ì‚° ë¬¸',0),(14348,399,'he','×¡×˜×™×™×ª ×ª×§×¦×™×‘ ×¡×™×¡×‘',0),(14349,399,'el','Î”Î®Î»Ï‰ÏƒÎ· Ï„Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î´Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ·Ï‚ Î³Î¹Î±',0),(14350,399,'zh','å£°æ˜Žå¯¹é¢„ç®—å·®å¼‚\r\n',0),(14351,399,'sv','Budget varians uttrycket fÃ¶r',0),(14352,399,'it','Dichiarazione di variazione bilancio per',0),(14353,399,'tl','',0),(14354,399,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3649;&#3611;&#3619;&#3611;&#3619;&#3623;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(14355,399,'hi','à¤¬à¤œà¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤šà¤°à¤£ à¤•à¤¥à¤¨',0),(14356,399,'ms','Bajet penyata varians bagi',0),(14357,399,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„ÙØ±Ù‚ ÙÙŠ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(14358,399,'fr','DÃ©claration d\'Ã©cart budgÃ©taire pour',0),(14359,399,'jp','äºˆç®—å·®é¡?æ˜Žç´°',0),(14360,399,'pt','DeclaraÃ§Ã£o de variÃ¢ncia orÃ§amento para',0),(14361,399,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ÐºÐ»Ð¾Ð½ÐµÐ½Ð¸Ð¹ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° Ð´Ð»Ñ',0),(14362,399,'es','Presupuesto DeclaraciÃ³n de VariaciÃ³n',0),(14363,399,'de','Varianz EinnahmenÃ¼bersicht fÃ¼r',0),(14364,399,'en','Budget Variance Statement for',0),(14365,400,'is','',0),(14366,400,'dr','Ø³Ø§Ø®ØªÙ†',0),(14367,400,'pr','Ø³Ø§Ø®ØªÙ†',0),(14368,400,'tr','YapÄ±',0),(14369,400,'pl','BudowaÄ‡',0),(14370,400,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ',0),(14371,400,'ur','ØªØ¹Ù…ÛŒØ±',0),(14372,400,'sr','Ð˜Ð·Ð³Ñ€Ð°Ð´Ð¸',0),(14373,400,'vi','Thiáº¿t káº¿',0),(14374,400,'af','Bou',0),(14375,400,'ro','Construi',0),(14376,400,'et','Ehitada',0),(14377,400,'si','Graditi',0),(14378,400,'ba','Membangun',0),(14379,400,'nl','Bouwen',0),(14380,400,'fi','Rakentaa',0),(14381,400,'no','Bygge',0),(14382,400,'da','Bygge',0),(14383,400,'ko','ë¹Œë“œ',0),(14384,400,'he','×œ×‘× ×•×ª',0),(14385,400,'el','ÎšÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(14386,400,'zh','å»ºè®¾\r\n',0),(14387,400,'sv','Bygga',0),(14388,400,'it','Costruire',0),(14389,400,'tl','',0),(14390,400,'th','&#3626;&#3619;&#3657;&#3634;&#3591;',0),(14391,400,'hi','à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(14392,400,'ms','Membina',0),(14393,400,'ar','Ø¨Ù†Ø§Ø¡',0),(14394,400,'fr','Construire',0),(14395,400,'jp','çµ„ç«‹',0),(14396,400,'pt','Construir',0),(14397,400,'ru','ÐŸÐ¾ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ',0),(14398,400,'es','Materiales',0),(14399,400,'de','Build',0),(14400,400,'en','Build',0),(14401,401,'is','',0),(14402,401,'dr','(Ù„ÙˆØ§Ø²Ù… ÙŠØ§ ÙÙ‡Ø±Ø³Øª ÙŠØ§ Ù…ÙˆÙ†ØªØ§Ú˜',0),(14403,401,'pr','Ø³Ø§Ø®Øª ÙƒØ§Ù„Ø§(Ù„ÙˆØ§Ø²Ù… ÙŠØ§ ÙÙ‡Ø±Ø³Øª ÙŠØ§ Ù…ÙˆÙ†ØªØ§Ú˜',0),(14404,401,'tr','Madde (Kit veya katalog veya derleme) inÅŸa',0),(14405,401,'pl','Tworzenie elementu (Kit lub katalog lub wirtualny plik dziennika)',0),(14406,401,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ (ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚ Ð¸Ð»Ð¸ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð¸Ð»Ð¸ ÑÑŠÐ±Ñ€Ð°Ð½Ð¸Ðµ)',0),(14407,401,'ur','Ø´Û’ (Ú©Ù¹ ÛŒØ§ Ø³Øª ÛŒØ§ Ø§Ø³Ù…Ø¨Ù„ÛŒ) Ú©ÛŒ ØªØ¹Ù…ÛŒØ±',0),(14408,401,'sr','Ð˜Ð·Ð³Ñ€Ð°Ð´Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° (\"ÐšÐ¸Ñ‚\" Ð¸Ð»Ð¸ \"ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³\" Ð¸Ð»Ð¸ \"Ð¡ÐºÑƒÐ¿ÑˆÑ‚Ð¸Ð½Ð°\")',0),(14409,401,'vi','Thiáº¿t káº¿ hÃ ng (catalo hay láº¯p rÃ¡p)',0),(14410,401,'af','Geboude Item (Stel of Katalogus of Versameling)',0),(14411,401,'ro','Construi element (Kit sau Catalog sau asamblare)',0),(14412,401,'et','Ehitada kauba (Kit vÃµi kataloogi vÃµi komplekteerimine)',0),(14413,401,'si','Graditi element (Kit ali katalog ali skupÅ¡Äine)',0),(14414,401,'ba','Membangun Item (Kit atau Katalog atau perakitan)',0),(14415,401,'nl','Bouwen Item (Kit of catalogus of vergadering)',0),(14416,401,'fi','Rakenna kohde (Kit tai luettelon tai kokoonpano)',0),(14417,401,'no','Bygge varen (Kit eller katalogen eller montering)',0),(14418,401,'da','Bygge element (Kit eller katalog eller forsamling)',0),(14419,401,'ko','í•­ëª© (í‚¤íŠ¸ ë˜ëŠ” ì¹´íƒˆë¡œê·¸ ë˜ëŠ” ì–´ì…ˆë¸”ë¦¬)ë¥¼ êµ¬ì¶•',0),(14420,401,'he','×œ×‘× ×•×ª ×¤×¨×™×˜ (×¢×¨×›×ª ××• ×§×˜×œ×•×’ ××• ×”×¨×›×‘×”)',0),(14421,401,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… (ÎºÎ¹Ï„ Î® ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î® Î£Ï…Î½Î­Î»ÎµÏ…ÏƒÎ·)',0),(14422,401,'zh','å»ºè®¾é¡¹ç›®ï¼ˆæˆå¥—å·¥å…·æˆ–ç›®å½•æˆ–é›†æˆï¼‰\r\n',0),(14423,401,'sv','Bygga objekt (Kit eller katalog eller fÃ¶rsamling)',0),(14424,401,'it','Costruire Item (Kit o catalogo o Assembly)',0),(14425,401,'tl','',0),(14426,401,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; (&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;&#3627;&#3619;&#3639;&#3629;&#3649;&#3588;&#3655;&#3605;&#3605;&#3634;&#3621;&#3655;&',0),(14427,401,'hi','à¤†à¤‡à¤Ÿà¤® (à¤•à¤¿à¤Ÿ à¤¯à¤¾ à¤•à¥ˆà¤Ÿà¤²à¥‰à¤— à¤¯à¤¾ à¤µà¤¿à¤§à¤¾à¤¨à¤¸à¤­à¤¾) à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(14428,401,'ms','Membina Item (Kit atau Katalog atau Dewan)',0),(14429,401,'ar','Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø§Ù„Ø¨Ù†Ø¯ (Ø·Ù‚Ù… Ø£Ùˆ ÙƒØªØ§Ù„ÙˆØ¬ Ø£Ùˆ Ø§Ù„Ø¬Ù…Ø¹ÙŠØ©)',0),(14430,401,'fr','Construire le point (Kit ou catalogue ou assemblage)',0),(14431,401,'jp','çµ„ç«‹å“?ï¼ˆã‚­ãƒƒãƒˆã€?ã‚«ã‚¿ãƒ­ã‚°ã‚‚ã?—ã??ã?¯çµ„ç«‹éƒ¨å“?ï¼‰',0),(14432,401,'pt','Item (Kit ou catÃ¡logo ou montagem) de construir',0),(14433,401,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° (ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚ Ð¸Ð»Ð¸ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð¸Ð»Ð¸ ÐÑÑÐ°Ð¼Ð±Ð»ÐµÐ¸)',0),(14434,401,'es','Item de Materiales (Kit o CatÃ¡logo o Asamblea',0),(14435,401,'de','Bauen Sie (Kit oder Katalog oder Assembly)',0),(14436,401,'en','Build Item (Kit or Catalog or&nbsp;Assembly)',0),(14437,402,'is','',0),(14438,402,'dr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(14439,402,'pr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(14440,402,'tr','SipariÅŸ oluÅŸturma',0),(14441,402,'pl','Tworzenie zamÃ³wienia',0),(14442,402,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(14443,402,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØ¹Ù…ÛŒØ±',0),(14444,402,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(14445,402,'vi','ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(14446,402,'af','Volgorde bou',0),(14447,402,'ro','Construi ordine',0),(14448,402,'et','Ehitada jÃ¤rjekorras',0),(14449,402,'si','Graditi nalog',0),(14450,402,'ba','Membangun Order',0),(14451,402,'nl','Bouwen van volgorde',0),(14452,402,'fi','Rakentaa jÃ¤rjestyksessÃ¤',0),(14453,402,'no','Bygge rekkefÃ¸lge',0),(14454,402,'da','Bygge rÃ¦kkefÃ¸lge',0),(14455,402,'ko','ë¹Œë“œ ìˆœì„œ',0),(14456,402,'he','×œ×‘× ×•×ª ×¡×“×¨',0),(14457,402,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(14458,402,'zh','æž„å»ºé¡ºåº\r\n',0),(14459,402,'sv','Bygga ordning',0),(14460,402,'it','Compilare l\'ordine',0),(14461,402,'tl','',0),(14462,402,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(14463,402,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(14464,402,'ms','Membina perintah',0),(14465,402,'ar','Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø£Ù…Ø±',0),(14466,402,'fr','Construire l\'ordre',0),(14467,402,'jp','çµ„ç«‹æ³¨æ–‡',0),(14468,402,'pt','Construir a ordem',0),(14469,402,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(14470,402,'es','Pedido de ConstrucciÃ³n',0),(14471,402,'de','Buildreihenfolge',0),(14472,402,'en','Build Order',0),(14473,403,'is','',0),(14474,403,'dr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(14475,403,'pr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(14476,403,'tr','YapÄ± sipariÅŸi baÅŸarÄ±yla silindi',0),(14477,403,'pl','ZbudowaÄ‡ zamÃ³wienie zostaÅ‚o pomyÅ›lnie usuniÄ™te',0),(14478,403,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(14479,403,'ur','ØªØ¹Ù…ÛŒØ± Ø¢Ø±ÚˆØ± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø®Ø§Ø±Ø¬ Ú©Ø±Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(14480,403,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÑƒ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(14481,403,'vi','XÃ³a ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng thÃ nh cÃ´ng',0),(14482,403,'af','Die bou van die bestelling is suksesvol geskrap',0),(14483,403,'ro','ComandÄƒ construi a fost sters cu succes',0),(14484,403,'et','Ehitada tellimus on edukalt kustutatud',0),(14485,403,'si','Naloga zgraditi uspeÅ¡no izbrisan',0),(14486,403,'ba','Urutan membangun telah berhasil dihapus',0),(14487,403,'nl','De volgorde van bouwen is verwijderd',0),(14488,403,'fi','Build Order on poistettu onnistuneesti',0),(14489,403,'no','Bygge rekkefÃ¸lgen er blitt slettet',0),(14490,403,'da','De bygge rÃ¦kkefÃ¸lge er blevet slettet',0),(14491,403,'ko','ë¹Œë“œ ìˆœì„œë¥¼ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(14492,403,'he','×¡×“×¨ ×œ×‘× ×•×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(14493,403,'el','Î•Î½Ï„Î¿Î»Î®Ï‚ Î¿Î¹ÎºÎ¿Î´Î¿Î¼Î®ÏƒÎ¿Ï…Î¼Îµ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(14494,403,'zh','ç”Ÿæˆè®¢å•å·²æˆåŠŸåˆ é™¤\r\n',0),(14495,403,'sv','Att bygga har raderats',0),(14496,403,'it','L\'ordine di costruire Ã¨ stato eliminato correttamente',0),(14497,403,'tl','',0),(14498,403,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3604;&#3657;&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;&#3649;&#3621;&#3657;&#3623;',0),(14499,403,'hi','à¤—à¤ à¤¨ à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(14500,403,'ms','Perintah membina telah berjaya dihapuskan',0),(14501,403,'ar','ØªÙ… Ø¨Ù†Ø¬Ø§Ø­ Ø­Ø°Ù \"ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¨Ù†Ø§Ø¡\"',0),(14502,403,'fr','L\'ordre de la gÃ©nÃ©ration a Ã©tÃ© supprimÃ©e avec succÃ¨s',0),(14503,403,'jp','çµ„ç«‹æ³¨æ–‡ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(14504,403,'pt','A ordem de construir foi apagada com sucesso',0),(14505,403,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ Ð±Ñ‹Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(14506,403,'es','El Pedido de ConstrucciÃ³n ha \r\nsido eliminado exitosamente',0),(14507,403,'de','Die Buildreihenfolge wurde gelÃ¶scht',0),(14508,403,'en','The Build Order has been successfully deleted',0),(14509,404,'is','',0),(14510,404,'dr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù†Ù‡Ø§ÙŠÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(14511,404,'pr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù†Ù‡Ø§ÙŠÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(14512,404,'tr','YapÄ± sipariÅŸi baÅŸarÄ±yla sonuÃ§landÄ±rÄ±lmÄ±ÅŸtÄ±r',0),(14513,404,'pl','Zlecenia budowy zostaÅ‚ pomyÅ›lnie zakoÅ„czony',0),(14514,404,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ðµ Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(14515,404,'ur','ØªØ¹Ù…ÛŒØ± Ø¢Ø±ÚˆØ± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø§ØªØ­Øª Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(14516,404,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð¸Ð·Ð³Ñ€Ð°Ð´Ð¸ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½',0),(14517,404,'vi','ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng Ä‘Ã£ káº¿t thÃºc thÃ nh cÃ´ng',0),(14518,404,'af','Die bou-orde suksesvol afgehandel is',0),(14519,404,'ro','ComandÄƒ construi a fost finalizat cu succes',0),(14520,404,'et','Ehitada tellimus on edukalt lÃµpetatud',0),(14521,404,'si','Naloga zgraditi uspeÅ¡no zakljuÄeni',0),(14522,404,'ba','Urutan membangun telah berhasil diselesaikan',0),(14523,404,'nl','De volgorde van bouwen heeft met succes afgerond',0),(14524,404,'fi','Build Order pÃ¤Ã¤tÃ¶kseen onnistuneesti',0),(14525,404,'no','Bygge bestillingen er fullfÃ¸rt',0),(14526,404,'da','De bygge rÃ¦kkefÃ¸lge har afsluttet med succes',0),(14527,404,'ko','ë¹Œë“œ ìˆœì„œë¥¼ ì„±ê³µì ìœ¼ë¡œ ì™„ë£Œ ë˜ì–´',0),(14528,404,'he','×¡×“×¨ ×œ×‘× ×•×ª ×›×‘×¨ ×”×•×©×œ×ž×• ×‘×”×¦×œ×—×”',0),(14529,404,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÎ½Ï„Î¿Î»Î®Ï‚ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„Î¹ÎºÎ¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(14530,404,'zh','ç”Ÿæˆè®¢å•å·²æˆåŠŸå®Œæˆ\r\n',0),(14531,404,'sv','Att bygga har slutfÃ¶rts pÃ¥ ett framgÃ¥ngsrikt',0),(14532,404,'it','L\'ordine di compilazione Ã¨ stata completata con successo',0),(14533,404,'tl','',0),(14534,404,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3607;&#3635;&#3651;&#3627;&#3657;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3',0),(14535,404,'hi','à¤—à¤ à¤¨ à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(14536,404,'ms','Perintah membina telah telah berjaya disiapkan',0),(14537,404,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¨Ù†Ø§Ø¡ Ù‚Ø¯ Ø§ÙƒØªÙ…Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(14538,404,'fr','L\'ordre de la gÃ©nÃ©ration a Ã©tÃ© finalisÃ© avec succÃ¨s',0),(14539,404,'jp','çµ„ç«‹æ³¨æ–‡ã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(14540,404,'pt','A ordem de construÃ§Ã£o foi finalizada com sucesso',0),(14541,404,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°',0),(14542,404,'es','El Pedido de ConstrucciÃ³n ha sido finalizado Exitosamente',0),(14543,404,'de','Die Buildreihenfolge erfolgreich abgeschlossen',0),(14544,404,'en','The Build Order has been successfully finalized',0),(14545,405,'is','',0),(14546,405,'dr','(ÙƒØ§Ù‡Ø´ Ø¯Ù‡Ù†Ø¯Ù‡',0),(14547,405,'pr','Ø§Ù…Ø§ Ø¨Ø±Ø´ Ø¯Ù‡Ù†Ø¯Ù‡ (ÙƒØ§Ù‡Ø´ Ø¯Ù‡Ù†Ø¯Ù‡',0),(14548,405,'tr','Ama kesici',0),(14549,405,'pl','Ale frez',0),(14550,405,'bg','ÐÐ¾ ÐšÑŠÑ‚ÑŠÑ€',0),(14551,405,'ur','Ú©Ù¹Ø± Ù„ÛŒÚ©Ù†',0),(14552,405,'sr','ÐÐ»Ð¸ Ð¦ÑƒÑ‚Ñ‚ÐµÑ€',0),(14553,405,'vi','Cáº¯t but',0),(14554,405,'af','Maar koekiedrukker',0),(14555,405,'ro','Dar Cutter',0),(14556,405,'et','Kuid lÃµikur',0),(14557,405,'si','Ampak rezalnik',0),(14558,405,'ba','Tapi Cutter',0),(14559,405,'nl','Maar Cutter',0),(14560,405,'fi','Mutta leikkuri',0),(14561,405,'no','Men Cutter',0),(14562,405,'da','Men frÃ¦ser',0),(14563,405,'ko','í•˜ì§€ë§Œ ì»¤í„°',0),(14564,405,'he','××‘×œ ×§××˜×¨',0),(14565,405,'el','Î‘Î»Î»Î¬ ÎºÏŒÏ€Ï„Î·Ï‚',0),(14566,405,'zh','é™¤äº†è£å‰ª\r\n',0),(14567,405,'sv','Men Cutter',0),(14568,405,'it','Ma Cutter',0),(14569,405,'tl','',0),(14570,405,'th','&#3612;&#3641;&#3657;&#3605;&#3633;&#3604;&#3619;&#3634;&#3588;&#3634;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(14571,405,'hi','à¤²à¥‡à¤•à¤¿à¤¨ à¤•à¤Ÿà¤°',0),(14572,405,'ms','Tetapi pemotong',0),(14573,405,'ar','Ù„ÙƒÙ† ÙƒØªØ±',0),(14574,405,'fr','Mais la fraise',0),(14575,405,'jp','But Cutter',0),(14576,405,'pt','Mas o cortador',0),(14577,405,'ru','ÐÐ¾ Ñ€ÐµÐ·ÐµÑ†',0),(14578,405,'es','Pero Cortador',0),(14579,405,'de','Aber Cutter',0),(14580,405,'en','But Cutter',0),(14581,406,'is','',0),(14582,406,'dr','Ø·Ø¨Ù‚',0),(14583,406,'pr','Ø·Ø¨Ù‚',0),(14584,406,'tr','tarafÄ±ndan',0),(14585,406,'pl','przez',0),(14586,406,'bg','Ð¾Ñ‚',0),(14587,406,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(14588,406,'sr','Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(14589,406,'vi','bá»Ÿi',0),(14590,406,'af','deur',0),(14591,406,'ro','de',0),(14592,406,'et','poolt',0),(14593,406,'si','z',0),(14594,406,'ba','oleh',0),(14595,406,'nl','door',0),(14596,406,'fi','mennessÃ¤',0),(14597,406,'no','ved',0),(14598,406,'da','af',0),(14599,406,'ko','ì— ì˜í•´',0),(14600,406,'he','×¢×œ ×™×“×™',0),(14601,406,'el','Î±Ï€ÏŒ',0),(14602,406,'zh','ç”±\r\n',0),(14603,406,'sv','av',0),(14604,406,'it','di',0),(14605,406,'tl','',0),(14606,406,'th','&#3650;&#3604;&#3618;',0),(14607,406,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(14608,406,'ms','oleh',0),(14609,406,'ar','Ù‚Ø¨Ù„',0),(14610,406,'fr','par',0),(14611,406,'jp','ï½žåˆ¥',0),(14612,406,'pt','por',0),(14613,406,'ru','Ð¿Ð¾',0),(14614,406,'es','por',0),(14615,406,'de','von',0),(14616,406,'en','by',0),(14617,407,'is','',0),(14618,407,'dr','Ø¨Ø§ÙŠØª',0),(14619,407,'pr','Ø¨Ø§ÙŠØª',0),(14620,407,'tr','bayt sayÄ±sÄ±',0),(14621,407,'pl','bajtÃ³w',0),(14622,407,'bg','Ð±Ð°Ð¹Ñ‚Ð¾Ð²Ðµ',0),(14623,407,'ur','Ø¨Ø§Ø¦Ù¹',0),(14624,407,'sr','Ð±Ð°Ñ˜Ñ‚Ð¾Ð²Ð°',0),(14625,407,'vi','byte',0),(14626,407,'af','grepe',0),(14627,407,'ro','octeÅ£i',0),(14628,407,'et','Baite',0),(14629,407,'si','bajtov',0),(14630,407,'ba','byte',0),(14631,407,'nl','bytes',0),(14632,407,'fi','tavua',0),(14633,407,'no','byte',0),(14634,407,'da','byte',0),(14635,407,'ko','ë°”ì´íŠ¸',0),(14636,407,'he','×‘×ª×™×',0),(14637,407,'el','bytes',0),(14638,407,'zh','å­—èŠ‚\r\n',0),(14639,407,'sv','byte',0),(14640,407,'it','byte',0),(14641,407,'tl','',0),(14642,407,'th','&#3652;&#3610;&#3607;&#3660;',0),(14643,407,'hi','à¤¬à¤¾à¤‡à¤Ÿà¥à¤¸',0),(14644,407,'ms','Bait',0),(14645,407,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ø¨Ø§ÙŠØª',0),(14646,407,'fr','octets',0),(14647,407,'jp','ãƒ?ã‚¤ãƒˆ',0),(14648,407,'pt','bytes',0),(14649,407,'ru','Ð±Ð°Ð¹Ñ‚',0),(14650,407,'es','bytes',0),(14651,407,'de','Bytes',0),(14652,407,'en','bytes',0),(14653,408,'is','',0),(14654,408,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡',0),(14655,408,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡',0),(14656,408,'tr','Hesaplamak',0),(14657,408,'pl','ObliczyÄ‡',0),(14658,408,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ',0),(14659,408,'ur','Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(14660,408,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ˜',0),(14661,408,'vi','TÃ­nh toÃ¡n',0),(14662,408,'af','Bereken',0),(14663,408,'ro','Se calculeazÄƒ',0),(14664,408,'et','Arvuta',0),(14665,408,'si','IzraÄun',0),(14666,408,'ba','Menghitung',0),(14667,408,'nl','Berekenen',0),(14668,408,'fi','Laske',0),(14669,408,'no','Beregne',0),(14670,408,'da','Beregne',0),(14671,408,'ko','ê³„ì‚°',0),(14672,408,'he','×—×©×‘',0),(14673,408,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚',0),(14674,408,'zh','è®¡ç®—\r\n',0),(14675,408,'sv','BerÃ¤kna',0),(14676,408,'it','Calcolare',0),(14677,408,'tl','',0),(14678,408,'th','&#3588;&#3635;&#3609;&#3623;&#3603;',0),(14679,408,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(14680,408,'ms','Mengira',0),(14681,408,'ar','Ø­Ø³Ø§Ø¨',0),(14682,408,'fr','Calculer',0),(14683,408,'jp','è¨ˆç®—',0),(14684,408,'pt','Calcular',0),(14685,408,'ru','Ð Ð°ÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ',0),(14686,408,'es','Calcular',0),(14687,408,'de','Berechnen',0),(14688,408,'en','Calculate',0),(14689,409,'is','',0),(14690,409,'dr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ Ù…Ø­Ø§Ø³Ø¨Ù‡',0),(14691,409,'pr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ Ù…Ø­Ø§Ø³Ø¨Ù‡',0),(14692,409,'tr','Hesaplamak nasÄ±l',0),(14693,409,'pl','Oblicz jak',0),(14694,409,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»Ð¸ ÐºÐ°Ðº',0),(14695,409,'ur','Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº Ú©Ø³ Ø·Ø±Ø­',0),(14696,409,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ˜ ÐºÐ°ÐºÐ¾',0),(14697,409,'vi','TÃ­nh nhÆ° tháº¿ nÃ o',0),(14698,409,'af','Hoe Bereken',0),(14699,409,'ro','Calcula cÃ¢t',0),(14700,409,'et','Arvuta kuidas',0),(14701,409,'si','IzraÄunaj kako',0),(14702,409,'ba','Menghitung bagaimana',0),(14703,409,'nl','Berekenen hoe',0),(14704,409,'fi','Laske kuinka',0),(14705,409,'no','Beregne hvor',0),(14706,409,'da','Beregne hvordan',0),(14707,409,'ko','ê³„ì‚° ë°©ë²•',0),(14708,409,'he','×œ×—×©×‘ ×›×ž×”',0),(14709,409,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯ÏƒÎµÎ¹ Ï€ÏŽÏ‚',0),(14710,409,'zh','å¦‚ä½•è®¡ç®—\r\n',0),(14711,409,'sv','BerÃ¤kna hur',0),(14712,409,'it','Calcolare come',0),(14713,409,'tl','',0),(14714,409,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3619;',0),(14715,409,'hi','à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤•à¥ˆà¤¸à¥‡',0),(14716,409,'ms','Mengira berapa',0),(14717,409,'ar','Ø­Ø³Ø§Ø¨ ÙƒÙŠÙ',0),(14718,409,'fr','Calculer comment',0),(14719,409,'jp','è¨ˆç®—æ³•',0),(14720,409,'pt','Calcular quanto',0),(14721,409,'ru','Ð Ð°ÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ ÐšÐ°Ðº',0),(14722,409,'es','Calcular CÃ³mo',0),(14723,409,'de','Berechnen wie',0),(14724,409,'en','Calculate How',0),(14725,410,'is','',0),(14726,410,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù‚ÙŠÙ…ØªÙ‡Ø§',0),(14727,410,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù‚ÙŠÙ…ØªÙ‡Ø§',0),(14728,410,'tr','FiyatlarÄ± hesaplamak',0),(14729,410,'pl','Obliczenia cen',0),(14730,410,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¸Ñ‚Ðµ',0),(14731,410,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(14732,410,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ñ†ÐµÐ½Ðµ',0),(14733,410,'vi','TÃ­nh giÃ¡',0),(14734,410,'af','Bereken Pryse',0),(14735,410,'ro','Calcula preÅ£urile',0),(14736,410,'et','Hindade arvutamiseks',0),(14737,410,'si','IzraÄun cene',0),(14738,410,'ba','Menghitung harga',0),(14739,410,'nl','Prijzen berekenen',0),(14740,410,'fi','Laske hinnat',0),(14741,410,'no','Beregne priser',0),(14742,410,'da','Beregne priser',0),(14743,410,'ko','ê°€ê²©ì„ ê³„ì‚°',0),(14744,410,'he','×œ×—×©×‘ ×ž×—×™×¨×™×',0),(14745,410,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯ÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Ï„Î¹Î¼Î­Ï‚',0),(14746,410,'zh','è®¡ç®—ä»·æ ¼\r\n',0),(14747,410,'sv','BerÃ¤kna priser',0),(14748,410,'it','Calcolo dei prezzi',0),(14749,410,'tl','',0),(14750,410,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3619;&#3634;&#3588;&#3634;',0),(14751,410,'hi','à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(14752,410,'ms','Mengira harga',0),(14753,410,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(14754,410,'fr','Calculer les prix',0),(14755,410,'jp','å€¤æ®µã?®è¨ˆç®—',0),(14756,410,'pt','Calcular os preÃ§os',0),(14757,410,'ru','Ð Ð°ÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð¦ÐµÐ½Ñ‹',0),(14758,410,'es','Calcular Precios',0),(14759,410,'de','Preise berechnen',0),(14760,410,'en','Calculate Prices',0),(14761,411,'is','',0),(14762,411,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(14763,411,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(14764,411,'tr','Teklifi hesapla',0),(14765,411,'pl','ObliczyÄ‡ cytat',0),(14766,411,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(14767,411,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(14768,411,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ˜ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(14769,411,'vi','TÃ­nh bÃ¡o giÃ¡',0),(14770,411,'af','Bereken Kwotasie',0),(14771,411,'ro','Calcula citat',0),(14772,411,'et','Arvutab hinnapakkumise',0),(14773,411,'si','IzraÄun ponudbe',0),(14774,411,'ba','Menghitung kutipan',0),(14775,411,'nl','Prijsopgave berekenen',0),(14776,411,'fi','Laske tarjous',0),(14777,411,'no','Beregne tilbud',0),(14778,411,'da','Beregne tilbud',0),(14779,411,'ko','ê²¬ì  ê³„ì‚°',0),(14780,411,'he','×—×©×‘ ×œ×¦×˜×˜',0),(14781,411,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯ÏƒÎµÎ¹ Ï„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(14782,411,'zh','è®¡ç®—æŠ¥ä»·\r\n',0),(14783,411,'sv','BerÃ¤kna citat',0),(14784,411,'it','Calcolare il preventivo',0),(14785,411,'tl','',0),(14786,411,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0);
INSERT INTO `langdef` VALUES (14787,411,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(14788,411,'ms','Mengira Quote',0),(14789,411,'ar','Ø­Ø³Ø§Ø¨ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(14790,411,'fr','Calculer le devis',0),(14791,411,'jp','è¦‹ç©?ã‚‚ã‚Šã?®è¨ˆç®—',0),(14792,411,'pt','Calcular a citaÃ§Ã£o',0),(14793,411,'ru','Ð’Ñ‹Ñ‡Ð¸ÑÐ»Ð¸Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(14794,411,'es','Calcular Cotizaciones',0),(14795,411,'de','Angebot berechnen',0),(14796,411,'en','Calculate Quote',0),(14797,412,'is','',0),(14798,412,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡',0),(14799,412,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡',0),(14800,412,'tr','Hesaplanan',0),(14801,412,'pl','Oblicza',0),(14802,412,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°',0),(14803,412,'ur','Ø­Ø³Ø§Ø¨',0),(14804,412,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°',0),(14805,412,'vi','ÄÃ£ tÃ­nh toÃ¡n',0),(14806,412,'af','Bereken',0),(14807,412,'ro','Calculat',0),(14808,412,'et','Arvutatud',0),(14809,412,'si','IzraÄuna',0),(14810,412,'ba','Dihitung',0),(14811,412,'nl','Berekend',0),(14812,412,'fi','Laskettu',0),(14813,412,'no','Beregnet',0),(14814,412,'da','Beregnet',0),(14815,412,'ko','ê³„ì‚°',0),(14816,412,'he','×”×—×™×©×•×‘',0),(14817,412,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÏ„Î±Î¹',0),(14818,412,'zh','è®¡ç®—\r\n',0),(14819,412,'sv','BerÃ¤knas',0),(14820,412,'it','Calcolato',0),(14821,412,'tl','',0),(14822,412,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3649;&#3621;&#3657;&#3623;',0),(14823,412,'hi','à¤—à¤£à¤¨à¤¾ à¤•à¥€',0),(14824,412,'ms','Dikira',0),(14825,412,'ar','Ø­Ø³Ø§Ø¨',0),(14826,412,'fr','CalculÃ©',0),(14827,412,'jp','è¨ˆç®—ã?—ã?¾ã?—ã?Ÿ',0),(14828,412,'pt','Calculado',0),(14829,412,'ru','Ð Ð°ÑÑ‡Ð¸Ñ‚Ð°Ð½Ð¾',0),(14830,412,'es','Calculado',0),(14831,412,'de','Berechnet',0),(14832,412,'en','Calculated',0),(14833,413,'is','',0),(14834,413,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ù‡',0),(14835,413,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ù‡',0),(14836,413,'tr','Hesaplama verileri',0),(14837,413,'pl','Obliczanie danych',0),(14838,413,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸',0),(14839,413,'ur','Ø­Ø³Ø§Ø¨ Ú©ÙˆØ§Ø¦Ù',0),(14840,413,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(14841,413,'vi','Dá»¯ liá»‡u TÃ­nh toÃ¡n',0),(14842,413,'af','Berekende Data',0),(14843,413,'ro','Calcularea datelor',0),(14844,413,'et','Andmete arvutamine',0),(14845,413,'si','IzraÄun podatkov',0),(14846,413,'ba','Perhitungan Data',0),(14847,413,'nl','Berekening gegevens',0),(14848,413,'fi','Laskentatietoja',0),(14849,413,'no','Beregningsdata',0),(14850,413,'da','Beregningsdata',0),(14851,413,'ko','ê³„ì‚° ë°ì´í„°',0),(14852,413,'he','×—×™×©×•×‘ × ×ª×•× ×™×',0),(14853,413,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(14854,413,'zh','è®¡ç®—æ•°æ®\r\n',0),(14855,413,'sv','BerÃ¤kningsdata',0),(14856,413,'it','Dati di calcolo',0),(14857,413,'tl','',0),(14858,413,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(14859,413,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤¡à¥‡à¤Ÿà¤¾',0),(14860,413,'ms','Pengiraan Data',0),(14861,413,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø­Ø³Ø§Ø¨',0),(14862,413,'fr','DonnÃ©es de calcul',0),(14863,413,'jp','è¨ˆç®—ãƒ‡ãƒ¼ã‚¿',0),(14864,413,'pt','Dados de cÃ¡lculo',0),(14865,413,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(14866,413,'es','Datos de CÃ¡lculo',0),(14867,413,'de','Berechnungsdaten',0),(14868,413,'en','Calculation Data',0),(14869,414,'is','',0),(14870,414,'dr','Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯',0),(14871,414,'pr','Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯',0),(14872,414,'tr','boÅŸ bÄ±rakÄ±labilir',0),(14873,414,'pl','moÅ¼e byÄ‡ puste',0),(14874,414,'bg','Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð° Ð¿Ñ€Ð°Ð·Ð½Ð°',0),(14875,414,'ur','Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘Ø§ Ø¨Ú¾ÛŒ Ø¬Ø§Ø³Ú©ØªØ§ ÛÛ’',0),(14876,414,'sr','Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾ÑÑ‚Ð°Ð½Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð°',0),(14877,414,'vi','cÃ³ thá»ƒ Ä‘á»ƒ trá»‘ng',0),(14878,414,'af','kan skoon gelaat word',0),(14879,414,'ro','poate fi lÄƒsatÄƒ necompletatÄƒ',0),(14880,414,'et','vÃµib jÃ¤tta tÃ¼hjaks',0),(14881,414,'si','lahko ostane prazno:',0),(14882,414,'ba','dapat dibiarkan kosong',0),(14883,414,'nl','leeg mag blijven',0),(14884,414,'fi','voi olla tyhjÃ¤',0),(14885,414,'no','kan vÃ¦re tom',0),(14886,414,'da','kan vÃ¦re tomt',0),(14887,414,'ko','ë¹ˆ ë‚¨ì•„ ìžˆì„ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(14888,414,'he','× ×™×ª×Ÿ ×™×”×™×” ×œ×”×©××™×¨ ×¨×™×§',0),(14889,414,'el','Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î¼ÎµÎ¯Î½ÎµÎ¹ ÎºÎµÎ½ÏŒ',0),(14890,414,'zh','å¯ä»¥å·¦ç•™ç©º\r\n',0),(14891,414,'sv','kan lÃ¤mnas tomt',0),(14892,414,'it','puÃ² essere lasciato vuoto',0),(14893,414,'tl','',0),(14894,414,'th','&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3652;&#3604;&#3657;',0),(14895,414,'hi','à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(14896,414,'ms','boleh ditinggalkan kosong',0),(14897,414,'ar','ÙˆÙŠÙ…ÙƒÙ† Ø£Ù† ØªØªØ±Ùƒ ÙØ§Ø±ØºØ©',0),(14898,414,'fr','peut Ãªtre laissÃ© vide',0),(14899,414,'jp','ç©ºæ¬„ã?§ã‚‚Okã?§ã?™',0),(14900,414,'pt','pode ser deixado em branco',0),(14901,414,'ru','Ð¼Ð¾Ð¶Ð½Ð¾ Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿ÑƒÑÑ‚Ñ‹Ð¼',0),(14902,414,'es','Se puede dejar en blanco',0),(14903,414,'de','kann leer gelassen werden',0),(14904,414,'en','can be left blank',0),(14905,415,'is','',0),(14906,415,'dr','Ø§Ø¨Ø²Ø§Ø± Ù…Ø§Ø´ÙŠÙ† Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯',0),(14907,415,'pr','Ø§Ø¨Ø²Ø§Ø± Ù…Ø§Ø´ÙŠÙ† Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯',0),(14908,415,'tr','Makine aletleri kullanabilirsiniz',0),(14909,415,'pl','MoÅ¼na uÅ¼yÄ‡ maszyny',0),(14910,415,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð¸',0),(14911,415,'ur','Ù…Ø´ÛŒÙ† Ù¹ÙˆÙ„Ø² Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(14912,415,'sr','ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð°Ð»Ð°Ñ‚Ð½Ð¸Ñ… Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(14913,415,'vi','cÃ³ thá»ƒ dÃ¹ng dá»¥ng cá»¥ mÃ¡y',0),(14914,415,'af','Masjien gereedskap kan gebruik',0),(14915,415,'ro','PuteÅ£i folosi unelte',0),(14916,415,'et','VÃµite kasutada tÃ¶Ã¶pingid',0),(14917,415,'si','Lahko uporabite stroj orodja',0),(14918,415,'ba','Dapat menggunakan alat-alat mesin',0),(14919,415,'nl','Gereedschapswerktuigen kunt gebruiken',0),(14920,415,'fi','KÃ¤yttÃ¤Ã¤ TyÃ¶stÃ¶koneet',0),(14921,415,'no','Kan bruke verktÃ¸ymaskiner',0),(14922,415,'da','Kan bruge vÃ¦rktÃ¸jsmaskiner',0),(14923,415,'ko','ê¸°ê³„ ë„êµ¬ë¥¼ ì‚¬ìš©í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(14924,415,'he','×‘××¤×©×¨×•×ª×š ×œ×”×©×ª×ž×© ×ž×›×•× ×ª ×›×œ×™×',0),(14925,415,'el','ÎÎ± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ ÎµÏÎ³Î±Î»ÎµÎ¹Î¿Î¼Î·Ï‡Î±Î½ÏŽÎ½',0),(14926,415,'zh','å¯ä»¥ç”¨æœºåºŠ\r\n',0),(14927,415,'sv','Kan anvÃ¤nda verktygsmaskiner',0),(14928,415,'it','Possibile utilizzare macchine utensili',0),(14929,415,'tl','',0),(14930,415,'th','&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(14931,415,'hi','à¤®à¤¶à¥€à¤¨ à¤‰à¤ªà¤•à¤°à¤£ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(14932,415,'ms','Boleh menggunakan alat-alat Mesin',0),(14933,415,'ar','ÙˆÙŠÙ…ÙƒÙ† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¢Ù„Ø§Øª ÙˆØ£Ø¯ÙˆØ§Øª',0),(14934,415,'fr','Peut utiliser des machines-outils',0),(14935,415,'jp','æ©Ÿæ¢°ãƒ„ãƒ¼ãƒ«ã?Œä½¿ã?ˆã?¾ã?™',0),(14936,415,'pt','Pode usar ferramentas de mÃ¡quina',0),(14937,415,'ru','ÐœÐ¾Ð¶Ð½Ð¾ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð°Ð½ÐºÐ¸',0),(14938,415,'es','Se puede uasr herramientas mecÃ¡nicas',0),(14939,415,'de','Werkzeugmaschinen kÃ¶nnen',0),(14940,415,'en','Can use machine tools',0),(14941,416,'is','',0),(14942,416,'dr','Ù„ØºÙˆ ÙƒØ±Ø¯Ù†',0),(14943,416,'pr','Ù„ØºÙˆ ÙƒØ±Ø¯Ù†',0),(14944,416,'tr','Ä°ptal',0),(14945,416,'pl','Anuluj',0),(14946,416,'bg','ÐžÑ‚ÐºÐ°Ð·',0),(14947,416,'ur','Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº',0),(14948,416,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ',0),(14949,416,'vi','XÃ³a',0),(14950,416,'af','Kanseleer',0),(14951,416,'ro','Revocare',0),(14952,416,'et','Loobu',0),(14953,416,'si','PrekliÄi',0),(14954,416,'ba','Batal',0),(14955,416,'nl','Annuleren',0),(14956,416,'fi','Peruuta',0),(14957,416,'no','Avbryt',0),(14958,416,'da','Annuller',0),(14959,416,'ko','ì·¨ì†Œ',0),(14960,416,'he','×‘×™×˜×•×œ',0),(14961,416,'el','\"Î†ÎºÏ…ÏÎ¿\"',0),(14962,416,'zh','å–æ¶ˆ\r\n',0),(14963,416,'sv','Avbryt',0),(14964,416,'it','Annulla',0),(14965,416,'tl','',0),(14966,416,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(14967,416,'hi','à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚',0),(14968,416,'ms','Batal',0),(14969,416,'ar','Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø£Ù…Ø±',0),(14970,416,'fr','Annuler',0),(14971,416,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(14972,416,'pt','Cancelar',0),(14973,416,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(14974,416,'es','Cancelar',0),(14975,416,'de','Abbrechen',0),(14976,416,'en','Cancel',0),(14977,417,'is','',0),(14978,417,'dr','Ù„ØºÙˆ Ø§ÙØ²ÙˆØ¯Ù† Ùˆ Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨',0),(14979,417,'pr','Ù„ØºÙˆ Ø§ÙØ²ÙˆØ¯Ù† Ùˆ Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨',0),(14980,417,'tr','Ä°ptal eklemek ve seÃ§ime dÃ¶nmek',0),(14981,417,'pl','Anuluj dodaÄ‡ i powrÃ³t do wyboru',0),(14982,417,'bg','ÐžÑ‚Ð¼ÐµÐ½Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¸ ÑÐµ Ð²ÑŠÑ€Ð½ÐµÑ‚Ðµ ÐºÑŠÐ¼ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ',0),(14983,417,'ur','Ù…Ù†Ø³ÙˆØ® Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù„ÛŒÛ’ ÙˆØ§Ù¾Ø³',0),(14984,417,'sr','\"ÐžÑ‚ÐºÐ°Ð¶Ð¸ \" Ð”Ð¾Ð´Ð°Ñ˜ Ð¸ Ð²Ñ€Ð°Ñ‚Ð¸ ÑÐµ Ñƒ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ð¸',0),(14985,417,'vi','ThÃªm xÃ³a & trá»Ÿ láº¡i lá»±a chá»n',0),(14986,417,'af','Kanselleer voeg en keer terug na seleksie',0),(14987,417,'ro','Revocare a adÄƒuga ÅŸi a reveni la selecÅ£ie',0),(14988,417,'et','Loobu lisada ja naasta valik',0),(14989,417,'si','PrekliÄi dodajanje in vrniti izbiro',0),(14990,417,'ba','Membatalkan menambahkan dan kembali ke pilihan',0),(14991,417,'nl','Annuleren toevoegen en ga terug naar selectie',0),(14992,417,'fi','Peruuta lisÃ¤Ã¤ ja palaa valinta',0),(14993,417,'no','Avbryt legge og gÃ¥ tilbake til valg',0),(14994,417,'da','Annuller tilfÃ¸je og vende tilbage til udvalg',0),(14995,417,'ko','ì·¨ì†ŒëŠ” ì¶”ê°€ í•˜ ê³  ì„ íƒ ì˜ì—­ì„ ë°˜í™˜',0),(14996,417,'he','×‘×™×˜×•×œ ×œ×”×•×¡×™×£ ×•×œ×—×–×•×¨ ×œ×‘×—×™×¨×”',0),(14997,417,'el','Î†ÎºÏ…ÏÎ¿ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÎºÎ±Î¹ Î½Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ­ÏˆÎµÏ„Îµ ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î®',0),(14998,417,'zh','å–æ¶ˆæ–°å¢žå¹¶è¿”å›žåˆ°é€‰æ‹©\r\n',0),(14999,417,'sv','Avbryt LÃ¤gg till och gÃ¥ tillbaka till val',0),(15000,417,'it','Annulla aggiungere e ritornare alla selezione',0),(15001,417,'tl','',0),(15002,417,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3649;&#3621;&#3632;&#3585;&#3621;&#3633;&#3610;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(15003,417,'hi','à¤°à¤¦à¥à¤¦ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤”à¤° à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥Œà¤Ÿà¥‡à¤‚',0),(15004,417,'ms','Batal menambah dan kembali ke pilihan',0),(15005,417,'ar','Ø¥Ø¶Ø§ÙØ© \"Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø£Ù…Ø±\" ÙˆØ§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ù„ØªØ­Ø¯ÙŠØ¯',0),(15006,417,'fr','Annuler ajouter et revenir Ã  la sÃ©lection',0),(15007,417,'jp','è¿½åŠ ã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?—ã?¦ã€?ã‚‚ã?†ä¸€åº¦é?¸æŠžã?—ã?ªã?Šã?™',0),(15008,417,'pt','Cancelar adicionar e regressar Ã  selecÃ§Ã£o',0),(15009,417,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð’Ð²Ð¾Ð´ Ð¸ Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ð’Ñ‹Ð±Ð¾Ñ€Ñƒ',0),(15010,417,'es','Cancelar Agregar y Regrear a la SeleccciÃ³n',0),(15011,417,'de','\"Abbrechen\" hinzufÃ¼gen und zurÃ¼ck zur Auswahl',0),(15012,417,'en','Cancel Add and Return to Selection',0),(15013,418,'is','',0),(15014,418,'dr','Ù„ØºÙˆ Ø§ÙØ²ÙˆØ¯Ù† Ùˆ Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨',0),(15015,418,'pr','Ù„ØºÙˆ Ø§ÙØ²ÙˆØ¯Ù† Ùˆ Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨',0),(15016,418,'tr','Ä°ptal eklemek ve seÃ§ime dÃ¶nmek',0),(15017,418,'pl','Anuluj dodaÄ‡ i powrÃ³t do wyboru',0),(15018,418,'bg','ÐžÑ‚Ð¼ÐµÐ½Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¸ ÑÐµ Ð²ÑŠÑ€Ð½ÐµÑ‚Ðµ ÐºÑŠÐ¼ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ',0),(15019,418,'ur','Ù…Ù†Ø³ÙˆØ® Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù„ÛŒÛ’ ÙˆØ§Ù¾Ø³',0),(15020,418,'sr','\"ÐžÑ‚ÐºÐ°Ð¶Ð¸ \" Ð”Ð¾Ð´Ð°Ñ˜ Ð¸ Ð²Ñ€Ð°Ñ‚Ð¸ ÑÐµ Ñƒ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ð¸',0),(15021,418,'vi','ThÃªm xÃ³a & trá»Ÿ láº¡i lá»±a chá»n',0),(15022,418,'af','Kanselleer voeg en keer terug na seleksie',0),(15023,418,'ro','Revocare a adÄƒuga ÅŸi a reveni la selecÅ£ie',0),(15024,418,'et','Loobu lisada ja naasta valik',0),(15025,418,'si','PrekliÄi dodajanje in vrniti izbiro',0),(15026,418,'ba','Membatalkan menambahkan dan kembali ke pilihan',0),(15027,418,'nl','Annuleren toevoegen en ga terug naar selectie',0),(15028,418,'fi','Peruuta lisÃ¤Ã¤ ja palaa valinta',0),(15029,418,'no','Avbryt legge og gÃ¥ tilbake til valg',0),(15030,418,'da','Annuller tilfÃ¸je og vende tilbage til udvalg',0),(15031,418,'ko','ì·¨ì†ŒëŠ” ì¶”ê°€ í•˜ ê³  ì„ íƒ ì˜ì—­ì„ ë°˜í™˜',0),(15032,418,'he','×‘×™×˜×•×œ ×œ×”×•×¡×™×£ ×•×œ×—×–×•×¨ ×œ×‘×—×™×¨×”',0),(15033,418,'el','Î†ÎºÏ…ÏÎ¿ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÎºÎ±Î¹ Î½Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ­ÏˆÎµÏ„Îµ ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î®',0),(15034,418,'zh','å–æ¶ˆæ–°å¢žå¹¶è¿”å›žåˆ°é€‰æ‹©\r\n',0),(15035,418,'sv','Avbryt LÃ¤gg till och gÃ¥ tillbaka till val',0),(15036,418,'it','Annulla aggiungere e ritornare alla selezione',0),(15037,418,'tl','',0),(15038,418,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3649;&#3621;&#3632;&#3585;&#3621;&#3633;&#3610;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(15039,418,'hi','à¤°à¤¦à¥à¤¦ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤”à¤° à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥Œà¤Ÿà¥‡à¤‚',0),(15040,418,'ms','Batal menambah dan kembali ke pilihan',0),(15041,418,'ar','Ø¥Ø¶Ø§ÙØ© \"Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø£Ù…Ø±\" ÙˆØ§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ù„ØªØ­Ø¯ÙŠØ¯',0),(15042,418,'fr','Annuler ajouter et revenir Ã  la sÃ©lection',0),(15043,418,'jp','è¿½åŠ ã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?—ã?¦ã€?ã‚‚ã?†ä¸€åº¦é?¸æŠžã?—ã?ªã?Šã?™',0),(15044,418,'pt','Cancelar adicionar e regressar Ã  selecÃ§Ã£o',0),(15045,418,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð’Ð²Ð¾Ð´ Ð˜ Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðš Ð’Ñ‹Ð±Ð¾Ñ€Ñƒ',0),(15046,418,'es','Cancelar Agregar y Regrear a la SeleccciÃ³n',0),(15047,418,'de','\"Abbrechen\" hinzufÃ¼gen und zurÃ¼ck zur Auswahl',0),(15048,418,'en','Cancel Add and Return to Selection',0),(15049,419,'is','',0),(15050,419,'dr','(Ø­Ø³Ø§Ø¨Ù‡Ø§)',0),(15051,419,'pr','Ù„ØºÙˆ ØªÙ…Ø§Ù… Ø´Ù…Ø§Ø±Ø´ Ù‡Ø§(Ø­Ø³Ø§Ø¨Ù‡Ø§)',0),(15052,419,'tr','Her durumda iptal et',0),(15053,419,'pl','Anuluj wszystkie liczniki',0),(15054,419,'bg','ÐžÑ‚Ð¼ÐµÐ½Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(15055,419,'ur','ØªÙ…Ø§Ù… Ø´Ù…Ø§Ø± Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº',0),(15056,419,'sr','ÐžÑ‚ÐºÐ°Ð¶Ð¸ ÑÐ²Ð¸Ð¼ Ñ‚Ð°Ñ‡ÐºÐ°Ð¼Ð° Ð¾Ð¿Ñ‚ÑƒÐ¶Ð½Ð¸Ñ†Ðµ',0),(15057,419,'vi','XÃ³a táº¥t cáº£ cÃ¡c phÃ©p tÃ­nh',0),(15058,419,'af','Kanselleer alle tellings',0),(15059,419,'ro','Anula toate capetele de acuzare',0),(15060,419,'et','TÃ¼hista kÃµik loeb',0),(15061,419,'si','PrekliÄi vse grofje',0),(15062,419,'ba','Membatalkan semua penting',0),(15063,419,'nl','Annuleren alle tellingen',0),(15064,419,'fi','Peruuta kaikki lasketaan',0),(15065,419,'no','Avbryte alle punkter',0),(15066,419,'da','Annuller alle tÃ¦ller',0),(15067,419,'ko','ëª¨ë“  ì¹´ìš´íŠ¸ë¥¼ ì·¨ì†Œ',0),(15068,419,'he','×œ×‘×˜×œ ×‘×›×œ ×”×¡×¢×™×¤×™×',0),(15069,419,'el','Î‘ÎºÏ…ÏÏŽÏƒÏ„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î±ÏÎ¹Î¸Î¼Î®ÏƒÎµÎ¹Ï‚',0),(15070,419,'zh','å–æ¶ˆæ‰€æœ‰ç½ªå\r\n',0),(15071,419,'sv','Avbryt alla rÃ¤knar',0),(15072,419,'it','Annullare tutti i conteggi',0),(15073,419,'tl','',0),(15074,419,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3609;&#3633;&#3610;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(15075,419,'hi','à¤¸à¤¬ à¤®à¤¾à¤¯à¤¨à¥‡ à¤°à¤–à¤¤à¤¾ à¤¹à¥ˆ à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚',0),(15076,419,'ms','Membatalkan semua tuduhan',0),(15077,419,'ar','Ø¥Ù„ØºØ§Ø¡ Ø¬Ù…ÙŠØ¹ Ø§Ù„ØªÙ‡Ù… Ø§Ù„Ù…ÙˆØ¬Ù‡Ø© Ø¥Ù„ÙŠÙ‡',0),(15078,419,'fr','Annuler tous les chefs d\'accusation',0),(15079,419,'jp','å…¨ã?¦ã?®è¨ˆç®—ã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?™ã‚‹',0),(15080,419,'pt','Cancelar todas as acusaÃ§Ãµes',0),(15081,419,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²ÑÐµ ÑÑ‡ÐµÑ‚Ñ‡Ð¸ÐºÐ¸',0),(15082,419,'es','Cancelar todos los Conteos',0),(15083,419,'de','Abbrechen von allen Anklagepunkten',0),(15084,419,'en','Cancel all Counts',0),(15085,420,'is','',0),(15086,420,'dr','Ú†Ø§Ù¾ Ø¨Ù„ÙŠØ· â€“Ù„ØºÙˆ Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯Ù‡',0),(15087,420,'pr','Ú†Ø§Ù¾ Ø¨Ù„ÙŠØ· â€“Ù„ØºÙˆ Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯Ù‡',0),(15088,420,'tr','BaskÄ± bilet<br>(Ä°ptal kaydedilmemiÅŸ)',0),(15089,420,'pl','WydrukowaÄ‡ bilet<br>(Anuluj niezapisane)',0),(15090,420,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð±Ð¸Ð»ÐµÑ‚Ð¸<br>(ÐžÑ‚ÐºÐ°Ð· Ð½ÐµÐ·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸)',0),(15091,420,'ur','Ù¹Ú©Ù¹ Ú†Ú¾Ø§Ù¾ÛŒÚº<br>(ØºÛŒØ± Ù…Ø­ÙÙˆØ¸ Ù…Ù†Ø³ÙˆØ®)',0),(15092,420,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ñƒ<br>(\"ÐžÑ‚ÐºÐ°Ð¶Ð¸ \" Ð½Ð¸ÑÑƒ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½Ð¸)',0),(15093,420,'vi','In vÃ©(XÃ³a chÆ°a lÆ°u)',0),(15094,420,'af','Kaartjie druk<br>(Kanselleer ongestoorde)',0),(15095,420,'ro','Bilet de imprimare<br>(Anulare nesalvate)',0),(15096,420,'et','Piletite printimine<br>(TÃ¼hista salvestamata)',0),(15097,420,'si','Tiskanje vozovnice<br>(PrekliÄi neshranjeni)',0),(15098,420,'ba','Mencetak tiket<br>(Membatalkan un disimpan)',0),(15099,420,'nl','Ticket afgedrukt<br>(Annuleren un-opgeslagen)',0),(15100,420,'fi','Tulostaa lippu<br>(Peruuta tallentamaton)',0),(15101,420,'no','Skrive ut billetten<br>(Avbryt ulagra)',0),(15102,420,'da','Udskrive billet<br>(Annuller ikke er gemt)',0),(15103,420,'ko','ì¸ì‡„ í‹°ì¼“<br>(ì·¨ì†Œ ì·¨ì†Œ ì €ìž¥ëœ)',0),(15104,420,'he','×œ×”×“×¤×™×¡ ×›×¨×˜×™×¡<br>×‘×™×˜×•×œ (×©×œ× × ×©×ž×¨×•)',0),(15105,420,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„Î¿Ï… ÎµÎ¹ÏƒÎ¹Ï„Î·ÏÎ¯Î¿Ï…<br>(Un-Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Î¼Î­Î½ÎµÏ‚ Î¬ÎºÏ…ÏÎ¿)',0),(15106,420,'zh','æ‰“å°é—¨ç¥¨ï¼ˆå–æ¶ˆå–æ¶ˆä¿å­˜ï¼‰\r\n',0),(15107,420,'sv','Skriva ut biljetten<br>(Avbryt inte sparats)',0),(15108,420,'it','Stampare il biglietto<br>(Annulla non salvato)',0),(15109,420,'tl','',0),(15110,420,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3633;&#3659;&#3623;<br>(&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3605;&#3657;&#3629;&#3591;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;)',0),(15111,420,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤Ÿà¤¿à¤•à¤Ÿ<br>(à¤°à¤¦à¥à¤¦ à¤¨ à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾)',0),(15112,420,'ms','Cetakan Tiket<br>(Batal tidak disimpan)',0),(15113,420,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªØ°ÙƒØ±Ø©<br>(Ø¥Ù„ØºØ§Ø¡ ØºÙŠØ± Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø©)',0),(15114,420,'fr','Ticket d\'impression<br>(Annulation non enregistrÃ©e)',0),(15115,420,'jp','ãƒ?ã‚±ãƒƒãƒˆå?°åˆ·<br>ï¼ˆæœªä¿?å­˜ã?®ã‚­ãƒ£ãƒ³ã‚»ãƒ«ï¼‰',0),(15116,420,'pt','Imprimir o bilhete<br>(Cancelar nÃ£o salvo)',0),(15117,420,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚<br>(ÐžÑ‚Ð¼ÐµÐ½Ð° Ð½ÐµÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ñ…)',0),(15118,420,'es','Imprimir Boleto<br> (Cancelar No Grabado)',0),(15119,420,'de','Ticket ausdrucken<br>(\"Abbrechen\" nicht gespeicherten)',0),(15120,420,'en','Print Ticket<br>(Cancel Un-saved)',0),(15121,421,'is','',0),(15122,421,'dr','-ÙŠÙƒ Ø¨ÙˆØ¯Ø¬Ù‡ Ùˆ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø¨Ø§ÙŠØ¯ ØªÙ†Ø¸ÙŠÙ… Ø´ÙˆØ¯',0),(15123,421,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ù†ÙŠØ³Øª-ÙŠÙƒ Ø¨ÙˆØ¯Ø¬Ù‡ Ùˆ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø¨Ø§ÙŠØ¯ ØªÙ†Ø¸ÙŠÙ… Ø´ÙˆØ¯',0),(15124,421,'tr','BÃ¼tÃ§eleri ekleyemezsiniz.  BÃ¼tÃ§e adÄ± ve mali yÄ±l ayarlamanÄ±z gerekir.',0),(15125,421,'pl','Nie moÅ¼na dodaÄ‡ budÅ¼etu. Nazwa budÅ¼etu i rok fiskalny musi byÄ‡ ustawiony.',0),(15126,421,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð´Ð¾Ð±Ð°Ð²ÑÑ‚Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸.  Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð·Ð°Ð´Ð°Ð´Ðµ Ð¸Ð¼Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð¸ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°.',0),(15127,421,'ur','Ø¨Ø¬Ù¹ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§ Û”  Ø§ÛŒÚ© Ø¨Ø¬Ù¹ Ú©Ø§ Ù†Ø§Ù… Ø§ÙˆØ± Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’ Û”',0),(15128,421,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð±ÑƒÑŸÐµÑ‚Ðµ.  Ð˜Ð¼Ðµ Ð±ÑƒÑŸÐµÑ‚Ð° Ð¸ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°.',0),(15129,421,'vi','KhÃ´ng thá»ƒ thÃªm ngÃ¢n sÃ¡ch. Pháº£i cÃ³ tÃªn & nÄƒm tÃ i chÃ­nh ',0),(15130,421,'af','Nie instaat om \'n begrotings by te voeg.  \'n Begrotingsnaam en fisiese jaar moet gestel word.',0),(15131,421,'ro','Imposibil de adÄƒugat bugetele.  Trebuie stabilit un nume buget ÅŸi an fiscal.',0),(15132,421,'et','Ei saa lisada eelarved.  Saab mÃ¤Ã¤rata eelarve nimi ja majandusaasta.',0),(15133,421,'si','Ni mogoÄe dodati proraÄunov.  Nastavite ime predraÄuna in poslovno leto.',0),(15134,421,'ba','Tidak dapat menambahkan anggaran.  Nama anggaran dan tahun fiskal harus ditetapkan.',0),(15135,421,'nl','Kan niet toevoegen begrotingen.  Een naam artikelbudget en fiscaal jaar moeten worden ingesteld.',0),(15136,421,'fi','Ei voi lisÃ¤tÃ¤ budjetit.  Budjetin nimi ja tilivuoden on asetettava.',0),(15137,421,'no','Kan ikke legge budsjetter.  Et Budsjettnavn og regnskapsÃ¥ret mÃ¥ angis.',0),(15138,421,'da','Kan ikke tilfÃ¸je budgetter.  Et budgetnavn og regnskabsÃ¥r skal angives.',0),(15139,421,'ko','ì˜ˆì‚°ì— ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.  ì˜ˆì‚° ì´ë¦„ ë° íšŒê³„ ì—°ë„ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(15140,421,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×•×¡×™×£ ×ª×§×¦×™×‘×™×.  ×™×© ×œ×”×’×“×™×¨ ×ª×§×¦×™×‘ ×©× ×¢× ×”×›×¡×¤×™×.',0),(15141,421,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÏ‰ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚.  Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï ÎºÎ±Î¹ Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÎ¿Ï Î­Ï„Î¿Ï…Ï‚.',0),(15142,421,'zh','æ— æ³•æ–°å¢žé¢„ç®—ã€‚å¿…é¡»è®¾ç½®ä¸€ä¸ªåç§°å’Œæ•´ä¸ªè´¢å¹´çš„é¢„ç®—\r\n',0),(15143,421,'sv','Kan inte lÃ¤gga till budgetar.  MÃ¥ste ange ett budgetnamn och rÃ¤kenskapsÃ¥r.',0),(15144,421,'it','Non Ã¨ possibile aggiungere i bilanci.  Deve essere impostati un nome di bilancio e l\'anno fiscale.',0),(15145,421,'tl','',0),(15146,421,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603; &#3594;&#3639;&#3656;&#3629;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3649;&#3621;&#',0),(15147,421,'hi','à¤¬à¤œà¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼ à¤¸à¤•à¤¤à¥‡à¥¤  à¤à¤• à¤¬à¤œà¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤® à¤”à¤° à¤µà¤¿à¤¤à¥à¤¤ à¤µà¤°à¥à¤· à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(15148,421,'ms','Tidak boleh menambah belanjawan.  Nama bajet dan tahun fiskal yang perlu disetkan.',0),(15149,421,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª.  Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø¸Ø¨Ø· Ø¥Ø³Ù… Ù…ÙŠØ²Ø§Ù†ÙŠØ© ÙˆØ³Ù†Ø© Ù…Ø§Ù„ÙŠØ©',0),(15150,421,'fr','Impossible d\'ajouter des budgets.  Un nom de budget et l\'exercice doivent Ãªtre dÃ©finis.',0),(15151,421,'jp','äºˆç®—ã?Œè¿½åŠ ã?§ã??ã?¾ã?›ã‚“ã€‚äºˆç®—å??ã?¨ä¼šè¨ˆå¹´åº¦ã‚’ã‚»ãƒƒãƒˆã?—ã?¦ä¸‹ã?•ã?„',0),(15152,421,'pt','NÃ£o Ã© possÃ­vel adicionar os orÃ§amentos.  Devem ser definidos um orÃ§amento nome e ano fiscal.',0),(15153,421,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¾Ð².  ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð·Ð°Ð´Ð°Ñ‚ÑŒ Ð¸Ð¼Ñ Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð¸ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´.',0),(15154,421,'es','No se puede agregar presupuestos. El nombre de presupuesto y ejercicio deben ser configurados',0),(15155,421,'de','Budgets kann nicht hinzugefÃ¼gt werden.  Ein Haushalt Name und GeschÃ¤ftsjahr mÃ¼ssen festgelegt werden.',0),(15156,421,'en','Cannot add budgets.  A budget name and fiscal year must be set.',0),(15157,422,'is','',0),(15158,422,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ø¯Ø§Ù…Ù‡ Ù†ÙŠØ³Øª ØªØ§ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±Ù‰ ØªØ±Ø§Ø² Ø´ÙˆØ¯',0),(15159,422,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ø¯Ø§Ù…Ù‡ Ù†ÙŠØ³Øª ØªØ§ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±Ù‰ ØªØ±Ø§Ø² Ø´ÙˆØ¯',0),(15160,422,'tr','FiÅŸ dengeli kadar devam edemez.',0),(15161,422,'pl','Nie moÅ¼e kontynuowaÄ‡, dopÃ³ki Voucher jest zrÃ³wnowaÅ¼ona.',0),(15162,422,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸, Ð´Ð¾ÐºÐ°Ñ‚Ð¾ ÑÐµ Ð±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€.',0),(15163,422,'ur','ÙˆØ§Ø¤Ú†Ø± Ù…ØªÙˆØ§Ø²Ù† ÛÛ’ ÛŒÛØ§Úº ØªÚ© Ú©Û Ø¬Ø§Ø±ÛŒ Ù†ÛÛŒÚº Ø±Ú©Ú¾ Ø³Ú©ØªØ§ Û”',0),(15164,422,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ð¸ Ð´Ð¾Ðº Ð²Ð°ÑƒÑ‡ÐµÑ€ Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÑ’ÐµÐ½.',0),(15165,422,'vi','KhÃ´ng thá»ƒ tiáº¿p tá»¥c cho Ä‘áº¿n khi Phiáº¿u cÃ¢n Ä‘á»‘i',0),(15166,422,'af','Kan voortgaan totdat bewys is gebalanseerd.',0),(15167,422,'ro','Nu continuÄƒ pÃ¢nÄƒ cÃ¢nd Voucher este echilibrat.',0),(15168,422,'et','Ei saa jÃ¤tkata enne, kui kanne on tasakaalus.',0),(15169,422,'si','Ne more nadaljevati, dokler kupon je uravnoteÅ¾en.',0),(15170,422,'ba','Tidak dapat melanjutkan sampai Voucher yang seimbang.',0),(15171,422,'nl','Kan niet doorgaan totdat Voucher is evenwichtig.',0),(15172,422,'fi','Ei voi jatkua ennen tosite on tasapainoinen.',0),(15173,422,'no','Kan ikke fortsette fÃ¸r bilaget er balansert.',0),(15174,422,'da','Kan ikke fortsÃ¦tte indtil Voucher er afbalanceret.',0),(15175,422,'ko','ë°”ìš°ì²˜ ê· í˜• ë•Œê¹Œì§€ ê³„ì†í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(15176,422,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×ž×©×™×š ×¢×“ ×©×•×‘×¨ ×ž××•×–× ×ª.',0),(15177,422,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÏƒÏ…Î½ÎµÏ‡Î¯ÏƒÎµÎ¹ Î¼Î­Ï‡ÏÎ¹ Ï„Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ ÎµÎ¯Î½Î±Î¹ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î·Î¼Î­Î½Î·.',0),(15178,422,'zh','æ— æ³•ç»§ç»­ä¸‹åŽ»ï¼Œç›´åˆ°åˆ¸æ˜¯å¹³è¡¡çš„',0),(15179,422,'sv','Kan inte fortsÃ¤tta fÃ¶rrÃ¤n verifikationen Ã¤r balanserad.',0),(15180,422,'it','Non puÃ² continuare fino a quando non Ã¨ equilibrato buono.',0),(15181,422,'tl','',0),(15182,422,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3607;&#3635;&#3605;&#3656;&#3629;&#3652;&#3604;&#3657;&#3592;&#3609;&#3585;&#3623;&#3656;&#3634;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3592;&#3656;&#3634;&#3618;&#3592;&#3632;&#3',0),(15183,422,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¸à¤‚à¤¤à¥à¤²à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¹à¥ˆ à¤œà¤¬ à¤¤à¤• à¤œà¤¾à¤°à¥€ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡à¥¤',0),(15184,422,'ms','Tidak boleh diteruskan sehingga baucer adalah seimbang.',0),(15185,422,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªØ³ØªÙ…Ø± Ø­ØªÙ‰ Ù…ØªÙˆØ§Ø²Ù† Ø§Ù„Ø¥ÙŠØµØ§Ù„.',0),(15186,422,'fr','Ne peut pas continuer jusqu\'Ã  ce que le bon est Ã©quilibrÃ©.',0),(15187,422,'jp','ä¼?ç¥¨ã?Œæ¸…ç®—ã?•ã‚Œã‚‹ã?¾ã?§ç¶šã?‘ã‚‹äº‹ã?Œã?§ã??ã?¾ã?›ã‚“',0),(15188,422,'pt','NÃ£o pode continuar atÃ© Voucher Ã© equilibrado.',0),(15189,422,'ru','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð°Ñ‚ÑŒÑÑ Ð´Ð¾ Ñ‚ÐµÑ… Ð¿Ð¾Ñ€, Ð¿Ð¾ÐºÐ° Ð²Ð°ÑƒÑ‡ÐµÑ€ ÑÐ²Ð»ÑÐµÑ‚ÑÑ ÑÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð¾Ð¹.',0),(15190,422,'es','No se puede Continuar hasta que el Voucher esta balanceado',0),(15191,422,'de','Kann nicht fortgesetzt werden bis Gutschein ausgeglichen ist.',0),(15192,422,'en','Cannot continue until Voucher is balanced.',0),(15193,423,'is','',0),(15194,423,'dr','.Ø§Ø² Ø´Ø±Ø· ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(15195,423,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ù†ÙŠØ³Øª.Ø§Ø² Ø´Ø±Ø· ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(15196,423,'tr','Tablo oluÅŸturamazsÄ±nÄ±z. From yan tÃ¼mcesi ayarlÄ± deÄŸil.',0),(15197,423,'pl','Nie moÅ¼na utworzyÄ‡ tabeli. Klauzula nie zostaÅ‚a ustawiona.',0),(15198,423,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°. ÐžÑ‚ ÐºÐ»Ð°ÑƒÐ·Ð° Ð½Ðµ Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½.',0),(15199,423,'ur','Ø¬Ø¯ÙˆÙ„ Ù†ÛÛŒÚº Ø¨Ù†Ø§ Ø³Ú©ØªØ§ Û” Ø´Ù‚ Ø³Û’ Ø·Û’ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(15200,423,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ Ñ‚Ð°Ð±ÐµÐ»Ñƒ. Ð˜Ð· ÐºÐ»Ð°ÑƒÐ·ÑƒÐ»Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½.',0),(15201,423,'vi','KhÃ´ng thá»ƒ táº¡o báº£ng. ChÆ°a táº¡o Ä‘iá»u khoáº£n',0),(15202,423,'af','Kan skep tabel. Van klousule is nie vasgestel nie.',0),(15203,423,'ro','Imposibil de creat tabelul. La clauza nu a fost stabilit.',0),(15204,423,'et','Tabelit ei saa luua. FROM-klausli pole mÃ¤Ã¤ratud.',0),(15205,423,'si','Tabele ni mogoÄe ustvariti. Stavku FROM ni bil doloÄen.',0),(15206,423,'ba','Tidak dapat membuat tabel. Dari ayat tidak telah ditetapkan.',0),(15207,423,'nl','Tabel kan niet maken. From-component heeft niet is ingesteld.',0),(15208,423,'fi','Taulukkoa ei voi luoda. From-lauseessa ei ole mÃ¤Ã¤ritetty.',0),(15209,423,'no','Kan ikke opprette tabellen. FROM-setningsdel er ikke angitt.',0),(15210,423,'da','Kan ikke oprette tabellen. FROM-delsÃ¦tning er ikke angivet.',0),(15211,423,'ko','í…Œì´ë¸”ì„ ë§Œë“¤ ìˆ˜ ì—†ìŠµë‹ˆë‹¤. ì ˆì—ì„œ ì„¤ì • ë˜ì§€ ì•Šì•˜ìŠµë‹ˆë‹¤.',0),(15212,423,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×™×¦×•×¨ ×˜×‘×œ×”. ×¤×¡×•×§×™×ª from ×œ× ×”×•×’×“×¨.',0),(15213,423,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î¯Î½Î±ÎºÎ±. Î— ÏÎ®Ï„ÏÎ± Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯.',0),(15214,423,'zh','ä¸èƒ½åˆ›å»ºè¡¨ã€‚ä»Žæ¡æ¬¾å°šæœªç¡®å®šã€‚\r\n',0),(15215,423,'sv','Kan inte skapa tabell. From-sats har inte stÃ¤llts in.',0),(15216,423,'it','Impossibile creare la tabella. Da tale clausola non Ã¨ stata impostata.',0),(15217,423,'tl','',0),(15218,423,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3626;&#3619;&#3657;&#3634;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591; &#3592;&#3634;&#3585;&#3611;&#3619;&#3632;&#3650;&#3618;&#3588;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3605;&#3633;&#',0),(15219,423,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¬à¤¨à¤¾à¤à¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾à¥¤ à¤–à¤£à¥à¤¡ à¤¸à¥‡ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(15220,423,'ms','Tidak dapat mencipta jadual. Dari Fasal tidak ditetapkan.',0),(15221,423,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø¬Ø¯ÙˆÙ„. Ù…Ù† Ø´Ø±Ø· Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ†.',0),(15222,423,'fr','Ne peut pas crÃ©er le tableau. Clause from n\'a pas Ã©tÃ© dÃ©finie.',0),(15223,423,'jp','è¡¨ã‚’ä½œæˆ?ã?§ã??ã?¾ã?›ã‚“ã€‚ï½žã?‹ã‚‰ã?®é …ç›®ã?Œè¨­å®šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“ã€‚',0),(15224,423,'pt','NÃ£o Ã© possÃ­vel criar a tabela. ClÃ¡usula from nÃ£o foi definida.',0),(15225,423,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñƒ. ÐÐµ Ð±Ñ‹Ð»Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¾ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ FROM.',0),(15226,423,'es','No se puede crear una tabla. La Clausula \"De\" no ha sido configurado',0),(15227,423,'de','Tabelle kann nicht erstellt werden. From-Klausel wurde nicht festgelegt.',0),(15228,423,'en','Cannot create table. From clause has not been set.',0),(15229,424,'is','',0),(15230,424,'dr','. ÙÙŠÙ„Ø¯Ù‡Ø§ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(15231,424,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ù†ÙŠØ³Øª. ÙÙŠÙ„Ø¯Ù‡Ø§ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(15232,424,'tr','Tablo oluÅŸturamazsÄ±nÄ±z. AlanlarÄ± ayarlanmamÄ±ÅŸ.',0),(15233,424,'pl','Nie moÅ¼na utworzyÄ‡ tabeli. Nie ustawiono pÃ³l.',0),(15234,424,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°. ÐÐµ ÑÐ° Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¸ Ð¿Ð¾Ð»ÐµÑ‚Ð°.',0),(15235,424,'ur','Ø¬Ø¯ÙˆÙ„ Ù†ÛÛŒÚº Ø¨Ù†Ø§ Ø³Ú©ØªØ§ Û” Ù‚Ø·Ø¹Ø§Øª Ø³ÛŒÙ¹ Ù†ÛÛŒÚº Ú©ÛŒ Ú¯Ø¦ÛŒ ÛÛ’ Û”',0),(15236,424,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ Ñ‚Ð°Ð±ÐµÐ»Ñƒ. ÐŸÐ¾Ñ™Ð° Ñ˜Ð¾Ñˆ Ð½Ð¸ÑÑƒ Ð¿Ð¾Ð´ÐµÑˆÐµÐ½Ð°.',0),(15237,424,'vi','KhÃ´ng thá»ƒ táº¡o báº£ng. ChÆ°a táº¡o trÆ°á»ng',0),(15238,424,'af','Kan nie tabel skep.  Velde is nie gestel.',0),(15239,424,'ro','Imposibil de creat tabelul. Domenii nu au fost stabilite.',0),(15240,424,'et','Tabelit ei saa luua. VÃ¤ljad on mÃ¤Ã¤ramata.',0),(15241,424,'si','Tabele ni mogoÄe ustvariti. Polja niso bila nastavljena.',0),(15242,424,'ba','Tidak dapat membuat tabel. Bidang tidak ditetapkan.',0),(15243,424,'nl','Tabel kan niet maken. Velden zijn niet ingesteld.',0),(15244,424,'fi','Taulukkoa ei voi luoda. KenttiÃ¤ ei ole mÃ¤Ã¤ritetty.',0),(15245,424,'no','Kan ikke opprette tabellen. Felt har ikke blitt angitt.',0),(15246,424,'da','Kan ikke oprette tabellen. Felter der ikke er fastsat.',0),(15247,424,'ko','í…Œì´ë¸”ì„ ë§Œë“¤ ìˆ˜ ì—†ìŠµë‹ˆë‹¤. í•„ë“œ ì„¤ì • í•˜ì§€ ì•Šì€.',0),(15248,424,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×™×¦×•×¨ ×˜×‘×œ×”. ×©×“×•×ª ×œ× ×”×•×’×“×¨×•.',0),(15249,424,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î¯Î½Î±ÎºÎ±. Î ÎµÎ´Î¯Î± Î´ÎµÎ½ Î­Ï‡Î¿Ï…Î½ Ï„ÎµÎ¸ÎµÎ¯.',0),(15250,424,'zh','ä¸èƒ½åˆ›å»ºè¡¨ã€‚é¢†åŸŸéƒ½å°šæœªç¡®å®š',0),(15251,424,'sv','Kan inte skapa tabell. FÃ¤lt har inte angetts.',0),(15252,424,'it','Impossibile creare la tabella. Campi non sono state impostate.',0),(15253,424,'tl','',0),(15254,424,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3626;&#3619;&#3657;&#3634;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591; &#3585;&#3634;&#3619;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3591;&#3634;&#3609;&#3652;&#3617;&#3656;&#3652;&#',0),(15255,424,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¬à¤¨à¤¾à¤à¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾à¥¤ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(15256,424,'ms','Tidak dapat mencipta jadual. Bidang yang telah ditetapkan.',0),(15257,424,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø¬Ø¯ÙˆÙ„. Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø­Ù‚ÙˆÙ„.',0),(15258,424,'fr','Ne peut pas crÃ©er le tableau. Champs n\'ont pas Ã©tÃ© dÃ©finies.',0),(15259,424,'jp','è¡¨ã‚’ä½œæˆ?ã?§ã??ã?¾ã?›ã‚“ã€‚ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã?Œè¨­å®šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“ã€‚',0),(15260,424,'pt','NÃ£o Ã© possÃ­vel criar a tabela. Campos nÃ£o foram definidos.',0),(15261,424,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñƒ. ÐŸÐ¾Ð»Ñ Ð½Ðµ Ð±Ñ‹Ð»Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(15262,424,'es','No se puede crear una tabla. Los campos no han sido completados',0),(15263,424,'de','Tabelle kann nicht erstellt werden. Felder wurden nicht festgelegt.',0),(15264,424,'en','Cannot create table. Fields have not been set.',0),(15265,425,'is','',0),(15266,425,'dr','(Ø«Ø¨Øª) Ø¯Ùˆ Ø¬ÙˆÙ‡Ø± Ù†ÙŠØ³Øª Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† = Ø¬ÙˆÙ‡Ø± ',0),(15267,425,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙˆØ±ÙˆØ¯(Ø«Ø¨Øª) Ø¯Ùˆ Ø¬ÙˆÙ‡Ø± Ù†ÙŠØ³Øª Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† = Ø¬ÙˆÙ‡Ø± \r\n PMS INK',0),(15268,425,'tr','Ä°KÄ° mÃ¼rekkep tÃ¼rÃ¼ giremezsiniz PMS INK =',0),(15269,425,'pl','Nie moÅ¼na wprowadziÄ‡ dwa atramenty jako typ = PMS INK',0),(15270,425,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð²Ð»ÐµÐ·Ðµ Ð´Ð²Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° ÐºÐ°Ñ‚Ð¾ Ñ‚Ð¸Ð¿ = PMS ÐœÐÐ¡Ð¢Ð˜Ð›Ðž',0),(15271,425,'ur','Ø¯Ùˆ Ø§Ù†Ú©Ø³ Ù‚Ø³Ù… Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø¯Ø§Ø®Ù„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§ ÙˆØ²Ø±Ø§Ø¦Û’ Ø§Ø¹Ø¸Ù… Ú©Ø§ Ø§Ù†Ú© =',0),(15272,425,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð´Ð²Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° ÐºÐ°Ð¾ Ñ‚Ð¸Ð¿ = ÐŸÐœÐ¡ Ð˜ÐÐš',0),(15273,425,'vi','KhÃ´ng thá»ƒ nháº­p 2 loáº¡i má»±c nhÆ° lÃ  loáº¡i = Má»±c PMS',0),(15274,425,'af','TWEE ink kan voer as tipe = PMS INK',0),(15275,425,'ro','Nu puteÅ£i introduce douÄƒ cerneluri ca tip = PMS INK',0),(15276,425,'et','Ei saa sisestada tintide tÃ¼Ã¼p = PMS INK',0),(15277,425,'si','Ne morete vnesti Ärnili kot vrsta = PMS Ärnila',0),(15278,425,'ba','Tidak dapat masuk dua tinta sebagai jenis = PMS INK',0),(15279,425,'nl','TWEE inkten niet kunt invoeren als type = PMS inkt',0),(15280,425,'fi','PÃ¤Ã¤se musteet tyyppi = PMS MUSTE',0),(15281,425,'no','Kan ikke angi to blekkfarger som type = PMS INK',0),(15282,425,'da','Kan ikke angive to trykfarver som type = PMS INK',0),(15283,425,'ko','í˜•ì‹ìœ¼ë¡œ ë‘ ê°€ì§€ ìž‰í¬ë¥¼ ìž…ë ¥í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤ = PMS ìž‰í¬',0),(15284,425,'he','×œ× × ×™×ª×Ÿ ×œ×”×–×™×Ÿ ×©× ×™ ×¦×‘×¢×™ ×›×¡×•×’ = ×ª×¡×ž×•× ×ª ×§×“× ×•×¡×ª×™×ª ×“×™×•',0),(15285,425,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„ÏŒ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î´ÏÎ¿ Î¼ÎµÎ»Î¬Î½Î¹Î± Ï‰Ï‚ Ï„ÏÏ€Î¿Ï‚ = PMS ÎœÎ•Î›Î†ÎÎ™',0),(15286,425,'zh','ä¸èƒ½è¾“å…¥ä¸¤ä¸ªç§æ²¹å¢¨ä½œä¸ºç±»åž‹= é‡‡è´­ç®¡ç†ç³»ç»Ÿçš„æ²¹å¢¨\r\n',0),(15287,425,'sv','Kan inte ange tvÃ¥ tryckfÃ¤rger som typ = PMS INK',0),(15288,425,'it','Non Ã¨ possibile immettere due inchiostri come tipo = PMS INK',0),(15289,425,'tl','',0),(15290,425,'th','&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3627;&#3617;&#3638;&#3585;&#3626;&#3629;&#3591;&#3626;&#3637;&#3648;&#3617;&#3639;&#3656;&#3629;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607; = &#3627;',0),(15291,425,'hi','à¤¦à¥‹ à¤‡à¤‚à¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¦à¤°à¥à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ = à¤ªà¥€à¤à¤®à¤à¤¸ à¤‡à¤‚à¤•',0),(15292,425,'ms','Tidak dapat memasuki dua dakwat sebagai jenis = PMS INK',0),(15293,425,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¯Ø®Ø§Ù„ Ø­Ø¨Ø±ÙŠÙ† ÙƒÙ†ÙˆØ¹ = Ø§Ù„Ø­Ø¨Ø± Ø§Ù„Ø¯ÙˆØ±Ø© Ø§Ù„Ø´Ù‡Ø±ÙŠØ©',0),(15294,425,'fr','Ne pouvez pas entrer deux encres comme type = INK PMS',0),(15295,425,'jp','2è‰²ã?®ã‚¤ãƒ³ã‚¯ã‚’ã??ã?®ã‚¿ã‚¤ãƒ—ã?¨ã?—ã?¦å…¥åŠ›ã?§ã??ã?¾ã?›ã‚“= PMS INK',0),(15296,425,'pt','NÃ£o podemos entrar duas tintas como tipo = PMS INK',0),(15297,425,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ð²Ð²Ð¾Ð´Ð¸Ñ‚ÑŒ Ð´Ð²Ðµ ÐºÑ€Ð°ÑÐºÐ¸ ÐºÐ°Ðº Ñ‚Ð¸Ð¿ = PMS Ñ‡ÐµÑ€Ð½Ð¸Ð»Ð°',0),(15298,425,'es','No se puede introducir DOS tintas cÃ³mo tipo = TINTA PMS',0),(15299,425,'de','Kann nicht geben Sie zwei Druckfarben als Typ = PMS INK',0),(15300,425,'en','Cannot enter TWO inks as type = PMS INK',0),(15301,426,'is','',0),(15302,426,'dr','(Ø¹Ù…ÙˆÙ…ÙŠ) Ù†ÙŠØ³Øª',0),(15303,426,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù†ÙˆØ¹ ÙƒØ§Ø± Ù…ØªØ¯Ø§ÙˆÙ„(Ø¹Ù…ÙˆÙ…ÙŠ) Ù†ÙŠØ³Øª',0),(15304,426,'tr','Genel iÅŸ tÃ¼rÃ¼ bulunamÄ±yor',0),(15305,426,'pl','Nie moÅ¼na odnaleÅºÄ‡ typu ogÃ³lna praca',0),(15306,426,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð¾Ð±Ñ‰Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿',0),(15307,426,'ur','Ø¹Ø§Ù… Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©ØªØ§',0),(15308,426,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð²Ñ€ÑÑ‚Ñƒ ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ñ€Ð°Ð´Ð°',0),(15309,426,'vi','KhÃ´ng thá»ƒ tÃ¬m tháº¥y loáº¡i cÃ´ng viá»‡c chung',0),(15310,426,'af','Vind nie die algemene werktipe',0),(15311,426,'ro','Nu pot gÄƒsi lucrÄƒri generale tip',0),(15312,426,'et','Ei leia Ã¼ldise tÃ¶Ã¶ tÃ¼Ã¼p',0),(15313,426,'si','Ni mogoÄe najti vrsto sploÅ¡nega dela',0),(15314,426,'ba','Tidak dapat menemukan jenis pekerjaan umum',0),(15315,426,'nl','Algemene werk type niet kunt vinden',0),(15316,426,'fi','Vakuutussopimusoikeuden tyyppiÃ¤ ei lÃ¶ydy',0),(15317,426,'no','Finner ikke generelt arbeidstype',0),(15318,426,'da','Kan ikke finde generelle arbejdstype',0),(15319,426,'ko','ì¼ë°˜ ìž‘ì—… í˜•ì‹ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(15320,426,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×¦×•× ×¡×•×’ ×¢×‘×•×“×” ×›×œ×œ×™',0),(15321,426,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Î²ÏÎµÎ¯Ï„Îµ Î³ÎµÎ½Î¹ÎºÎ­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Ï„ÏÏ€Î¿Ï…',0),(15322,426,'zh','ä¸€èˆ¬æ‰¾ä¸åˆ°å·¥ä½œç±»åž‹\r\n',0),(15323,426,'sv','Kan inte hitta allmÃ¤nna arbetstyp',0),(15324,426,'it','Impossibile trovare il tipo di lavoro generale',0),(15325,426,'tl','',0),(15326,426,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(15327,426,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¤à¤¾',0),(15328,426,'ms','Tidak dapat mencari jenis kerja-kerja am',0),(15329,426,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù…',0),(15330,426,'fr','Ne peut pas trouver le type de travail gÃ©nÃ©rales',0),(15331,426,'jp','ä¸€èˆ¬ä½œæ¥­ã‚¿ã‚¤ãƒ—ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(15332,426,'pt','NÃ£o consigo encontrar o tipo de trabalho geral',0),(15333,426,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð½Ð°Ð¹Ñ‚Ð¸ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(15334,426,'es','No se puede encontrar tipo general de trabajo',0),(15335,426,'de','Allgemeine Arbeitstyp nicht gefunden werden.',0),(15336,426,'en','Cannot find general work type',0),(15337,427,'is','',0),(15338,427,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ù†ÙŠØ³Øª',0),(15339,427,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ù†ÙŠØ³Øª',0),(15340,427,'tr','Fiyat listesi hisse senedi bilgileri bulunamÄ±yor',0),(15341,427,'pl','Nie mogÄ™ znaleÅºÄ‡ ceny listy zasobÃ³w informacji',0),(15342,427,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð°ÐºÑ†Ð¸Ð¸ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(15343,427,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©ØªØ§',0),(15344,427,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° Ð»Ð¸ÑÑ‚Ð¸ Ñ†ÐµÐ½Ð°',0),(15345,427,'vi','KhÃ´ng thá»ƒ tháº¥y thÃ´ng tin báº£ng giÃ¡ hÃ ng tá»“n',0),(15346,427,'af','Prys lys voorraad inligting kan vind',0),(15347,427,'ro','Nu pot gÄƒsi informaÅ£ii de stoc pret lista',0),(15348,427,'et','Ei leia loendi Stock hinnateave',0),(15349,427,'si','Ni mogoÄe najti informacij o ceni seznam zalog',0),(15350,427,'ba','Tidak dapat menemukan informasi saham daftar harga',0),(15351,427,'nl','Niet vinden prijs lijst voorraad informatie',0),(15352,427,'fi','LÃ¶ydÃ¤ hinta varastossa tiedot',0),(15353,427,'no','Finner ikke listen aksjen prisinformasjon',0),(15354,427,'da','Kan ikke finde prisen listen Stock oplysninger',0),(15355,427,'ko','ê°€ê²© ëª©ë¡ ì†Œìž¬ ì •ë³´ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(15356,427,'he','×œ× ×™×›×•×œ ×œ×ž×¦×•× ×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™ ×ž×™×“×¢',0),(15357,427,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î²ÏÏ‰ Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Stock Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(15358,427,'zh','æ‰¾ä¸åˆ°ä»·æ ¼è¡¨åº“å­˜ä¿¡æ¯\r\n',0),(15359,427,'sv','Kan inte hitta pris lista lager Information',0),(15360,427,'it','Non Ã¨ possibile trovare informazioni di Stock prezzo elenco',0),(15361,427,'tl','',0),(15362,427,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3',0),(15363,427,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¶à¥‡à¤¯à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¤à¤¾',0),(15364,427,'ms','Tidak dapat mencari maklumat stok senarai harga',0),(15365,427,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ \"Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø£Ø³Ù‡Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\"',0),(15366,427,'fr','Ne peut pas trouver les informations de Stock de liste de prix',0),(15367,427,'jp','ä¾¡æ ¼è¡¨åœ¨åº«æƒ…å ±ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(15368,427,'pt','NÃ£o consigo encontrar informaÃ§Ãµes de estoque lista de preÃ§o',0),(15369,427,'ru','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð½Ð°Ð¹Ñ‚Ð¸ Ñ†ÐµÐ½Ñƒ ÑÐ¿Ð¸ÑÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸',0),(15370,427,'es','No se puede encontrar InformaciÃ³n de Lista de Precios de Stock',0),(15371,427,'de','Preis Liste BÃ¶rseninformationen nicht gefunden werden.',0),(15372,427,'en','Cannot find Price List Stock Information',0),(15373,428,'is','',0),(15374,428,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡  Ù†ÙŠØ³Øª',0),(15375,428,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡  Ù†ÙŠØ³Øª',0),(15376,428,'tr','SeÃ§ili alt grubu bulunamÄ±yor',0),(15377,428,'pl','Nie moÅ¼na odnaleÅºÄ‡ podgrupy wybranych',0),(15378,428,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(15379,428,'ur','Ø³Ø¨Ú¯Ø±ÙˆÙ¾ Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©ØªØ§',0),(15380,428,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ñƒ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(15381,428,'vi','KhÃ´ng thá»ƒ tháº¥y nhÃ³m phá»¥ Ä‘Ã£ chá»n',0),(15382,428,'af','Supgroep gekies kan vind',0),(15383,428,'ro','Nu pot gÄƒsi subgrup selectate',0),(15384,428,'et','Ei leia valitud alarÃ¼hm',0),(15385,428,'si','Ni mogoÄe najti izbrani podskupini',0),(15386,428,'ba','Tidak dapat menemukan subgrup dipilih',0),(15387,428,'nl','Kan niet vinden deelgroep geselecteerd',0),(15388,428,'fi','LÃ¶ydÃ¤ alaryhmÃ¤ valittu',0),(15389,428,'no','Finner ikke undergruppe valgt',0),(15390,428,'da','Kan ikke finde undergruppe valgt',0),(15391,428,'ko','ì„ íƒ í•˜ëŠ” í•˜ìœ„ ê·¸ë£¹ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(15392,428,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×¦×•× ×ª×ª ×§×‘×•×¦×” × ×‘×—×¨×ª',0),(15393,428,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î²ÏÏ‰ Ï…Ï€Î¿Î¿Î¼Î¬Î´Î± Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(15394,428,'zh','æ‰¾ä¸åˆ°å­ç»„é€‰å®š\r\n',0),(15395,428,'sv','Kan inte hitta undergrupp valt',0),(15396,428,'it','Non Ã¨ possibile trovare il sottogruppo selezionato',0),(15397,428,'tl','',0),(15398,428,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3621;&#3640;&#3656;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(15399,428,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤‰à¤ªà¤¸à¤®à¥‚à¤¹ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¤à¤¾',0),(15400,428,'ms','Tidak dapat mencari subkumpulan yang dipilih',0),(15401,428,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ø¬Ù…ÙˆØ¹Ø© ÙØ±Ø¹ÙŠØ© Ù…Ø®ØªØ§Ø±Ø©',0),(15402,428,'fr','Sous-groupe sÃ©lectionnÃ© est introuvable',0),(15403,428,'jp','é?¸æŠžã?•ã‚Œã?Ÿã‚µãƒ–ã‚°ãƒ«ãƒ¼ãƒ—ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(15404,428,'pt','NÃ£o consigo encontrar o subgrupo selecionado',0),(15405,428,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð½Ð°Ð¹Ñ‚Ð¸ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½ÑƒÑŽ ÐŸÐ¾Ð´Ð³Ñ€ÑƒÐ¿Ð¿Ñƒ',0),(15406,428,'es','No se puede encontrar Subgrupo Seleccionado',0),(15407,428,'de','Untergruppe ausgewÃ¤hlt kann nicht gefunden werden.',0),(15408,428,'en','Cannot find Subgroup selected',0),(15409,429,'is','',0),(15410,429,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù†ÙˆØ¹ ÙƒØ§Ø± Ù†ÙŠØ³Øª',0),(15411,429,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù†ÙˆØ¹ ÙƒØ§Ø± Ù†ÙŠØ³Øª',0),(15412,429,'tr','Ä°ÅŸ tÃ¼rÃ¼ bulunamÄ±yor',0),(15413,429,'pl','Nie mogÄ™ znaleÅºÄ‡ pracy typu',0),(15414,429,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(15415,429,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©ØªØ§',0),(15416,429,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð°',0),(15417,429,'vi','KhÃ´ng thá»ƒ tháº¥y loáº¡i cÃ´ng viá»‡c',0),(15418,429,'af','Werk tipe kan vind',0),(15419,429,'ro','Nu pot gÄƒsi de lucru tip',0),(15420,429,'et','Ei leia tÃ¶Ã¶ tÃ¼Ã¼p',0),(15421,429,'si','Ni mogoÄe najti vrsto dela',0),(15422,429,'ba','Tidak dapat menemukan jenis pekerjaan',0),(15423,429,'nl','Werk Type niet kunt vinden',0),(15424,429,'fi','LÃ¶ydÃ¤ tyÃ¶n tyyppi',0),(15425,429,'no','Finner ikke arbeidstype',0),(15426,429,'da','Kan ikke finde arbejdstype',0),(15427,429,'ko','ìž‘ì—… í˜•ì‹ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(15428,429,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×¦×•× ×¡×•×’ ×¢×‘×•×“×”',0),(15429,429,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î²ÏÏ‰ ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï…',0),(15430,429,'zh','æ‰¾ä¸åˆ°å·¥ä½œç±»åˆ«\r\n',0),(15431,429,'sv','Kan inte hitta arbetstyp',0),(15432,429,'it','Impossibile trovare il tipo di lavoro',0),(15433,429,'tl','',0),(15434,429,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(15435,429,'hi','à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¤à¤¾',0),(15436,429,'ms','Tidak dapat mencari jenis kerja',0),(15437,429,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ \"Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„\"',0),(15438,429,'fr','Impossible de trouver le Type de travail',0),(15439,429,'jp','ä½œæ¥­ã‚¿ã‚¤ãƒ—ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(15440,429,'pt','NÃ£o consigo encontrar o tipo de trabalho',0),(15441,429,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð½Ð°Ð¹Ñ‚Ð¸ Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(15442,429,'es','No se puede encontrar tipo de trabajo',0),(15443,429,'de','Arbeit-Typ nicht gefunden werden.',0),(15444,429,'en','Cannot find Work Type',0),(15445,430,'is','',0),(15446,430,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø² ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ´ØªÙ† Ù†ÙŠØ³Øª',0),(15447,430,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø² ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ´ØªÙ† Ù†ÙŠØ³Øª',0),(15448,430,'tr','DosyasÄ± yazmak iÃ§in aÃ§Ä±lamÄ±yor',0),(15449,430,'pl','Nie moÅ¼na otworzyÄ‡ pliku w celu zapisu',0),(15450,430,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸ Ñ„Ð°Ð¹Ð»Ð° Ð·Ð° Ð¿Ð¸ÑÐ°Ð½Ðµ',0),(15451,430,'ur','Ù„Ú©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø³Ù„ Ù†ÛÛŒÚº Ú©Ú¾ÙˆÙ„ Ø³Ú©ØªØ§',0),(15452,430,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ð¿Ð¸ÑÐ°ÑšÐµ',0),(15453,430,'vi','KhÃ´ng thá»ƒ má»Ÿ há»“ sÆ¡ Ä‘á»ƒ viáº¿t',0),(15454,430,'af','Kan nie lÃªer open om in te skryf',0),(15455,430,'ro','Nu pot deschide fiÅŸierul pentru scris',0),(15456,430,'et','Ei saa avada faili kirjutamine',0),(15457,430,'si','Ne more odpreti datoteke za pisanje',0),(15458,430,'ba','Tidak dapat membuka file untuk menulis',0),(15459,430,'nl','Kan niet openen bestand voor schrijven',0),(15460,430,'fi','Ei voi avata tiedostoa kirjoittamista varten',0),(15461,430,'no','Kan ikke Ã¥pne filen for skriving',0),(15462,430,'da','Kan ikke Ã¥bne fil til skrivning',0),(15463,430,'ko','ì“°ê¸° ìœ„í•´ íŒŒì¼ì„ ì—´ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(15464,430,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×¤×ª×•×— ×§×•×‘×¥ ×œ×›×ª×™×‘×”',0),(15465,430,'el','Î•Î¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„ÏŒ Ï„Î¿ Î¬Î½Î¿Î¹Î³Î¼Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï… Î³Î¹Î± ÎµÎ³Î³ÏÎ±Ï†Î®',0),(15466,430,'zh','æ— æ³•æ‰“å¼€ç”¨äºŽå†™å…¥æ–‡ä»¶\r\n',0),(15467,430,'sv','Kan inte Ã¶ppna filen fÃ¶r skrivning',0),(15468,430,'it','Impossibile aprire il file per la scrittura',0),(15469,430,'tl','',0),(15470,430,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3611;&#3636;&#3604;&#3649;&#3615;&#3657;&#3617;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3648;&#3614;&#3639;&#3656;&#3629;&#3607;&#3635;&#3585;&#3634;&#3619;&#3648;&#3586;&#3637;&#3',0),(15471,430,'hi','à¤²à¥‡à¤–à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤¨à¤¹à¥€à¤‚ à¤–à¥‹à¤² à¤¸à¤•à¤¤à¤¾',0),(15472,430,'ms','Tidak dapat membuka fail bagi penulisan',0),(15473,430,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ÙØªØ­ Ù…Ù„Ù Ù„Ù„ÙƒØªØ§Ø¨Ø©',0),(15474,430,'fr','Impossible d\'ouvrir le fichier pour l\'Ã©criture',0),(15475,430,'jp','æ›¸ã??è¾¼ã‚€ç‚ºã?®ãƒ•ã‚¡ã‚¤ãƒ«ã?Œé–‹ã?‘ã?¾ã?›ã‚“',0),(15476,430,'pt','NÃ£o Ã© possÃ­vel abrir o arquivo para gravaÃ§Ã£o',0),(15477,430,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» Ð´Ð»Ñ Ð¿Ð¸ÑÑŒÐ¼Ð°',0),(15478,430,'es','No se puede abrir archivo para escribir',0),(15479,430,'de','Kann nicht Datei zum Schreiben Ã¶ffnen',0),(15480,430,'en','Cannot open file for writing',0),(15481,431,'is','',0),(15482,431,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø±Ù†Ú¯  Ø²Ù…Ø§Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªÙ…Ø§Ù…  Ø§Ù†Ø¨Ø§Ø±Ù‡Ø§ÙŠ ÙØ±Ø¹ÙŠ  Ù†ÙŠØ³Øª',0),(15483,431,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø±Ù†Ú¯  Ø²Ù…Ø§Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªÙ…Ø§Ù…  Ø§Ù†Ø¨Ø§Ø±Ù‡Ø§ÙŠ ÙØ±Ø¹ÙŠ  Ù†ÙŠØ³Øª',0),(15484,431,'tr','TÃ¼m substocks kullanÄ±rken renk seÃ§emezsiniz',0),(15485,431,'pl','Nie moÅ¼na wybraÄ‡ kolory, uÅ¼ywajÄ…c wszystkich substocks',0),(15486,431,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ, Ð¿Ñ€Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ substocks',0),(15487,431,'ur','ØªÙ…Ø§Ù… Ø³Ø¨Ø³Ù¹Ø§Ú©Ø³ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ø¬Ø¨ Ø±Ù†Ú¯ Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(15488,431,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ñ‚Ð¸ Ð±Ð¾Ñ˜Ðµ ÐºÐ°Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÐ²Ðµ ÑÑƒÐ±ÑÑ‚Ð¾Ñ†ÐºÑ',0),(15489,431,'vi','KhÃ´ng thá»ƒ sá»­ dá»¥ng máº§u khi dÃ¹ng táº¥t cáº£ máº·t hÃ ng phá»¥',0),(15490,431,'af','Kleure kan kies wanneer die gebruik van alle substocks',0),(15491,431,'ro','Nu pot selecta culori, atunci cÃ¢nd se utilizeazÄƒ toate substocks',0),(15492,431,'et','Ei saa valida vÃ¤rve kasutades kÃµiki substocks',0),(15493,431,'si','Ne morete izbrati barve pri uporabi vseh substocks',0),(15494,431,'ba','Tidak bisa Pilih warna dengan menggunakan semua substocks',0),(15495,431,'nl','Kleuren selecteren niet wanneer met behulp van alle substocks',0),(15496,431,'fi','Voi valita vÃ¤rejÃ¤ kÃ¤ytettÃ¤essÃ¤ kaikki substocks',0),(15497,431,'no','Kan ikke velge farger ved alle substocks',0),(15498,431,'da','Kan ikke vÃ¦lge farver, nÃ¥r du bruger alle substocks',0),(15499,431,'ko','ëª¨ë“  substocksë¥¼ ì‚¬ìš© í•˜ ì—¬ ìƒ‰ìƒì„ ì„ íƒí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(15500,431,'he','×œ× × ×™×ª×Ÿ ×œ×‘×—×•×¨ ×¦×‘×¢×™× ×‘××ž×¦×¢×•×ª ×›×œ substocks',0),(15501,431,'el','Î”ÎµÎ½ ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Ï„Î± Ï‡ÏÏŽÎ¼Î±Ï„Î± ÎºÎ±Ï„Î¬ Ï„Î· Ï‡ÏÎ®ÏƒÎ· ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ substocks',0),(15502,431,'zh','å½“æ‰€æœ‰å­è‚¡ç¥¨åœ¨ä½¿ç”¨æ—¶ä¸èƒ½é€‰æ‹©é¢œè‰²',0),(15503,431,'sv','Kan inte vÃ¤lja fÃ¤rger nÃ¤r du anvÃ¤nder alla substocks',0),(15504,431,'it','Non Ã¨ possibile selezionare i colori quando si utilizzano tutti i substocks',0),(15505,431,'tl','',0),(15506,431,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3637;&#3652;&#3604;&#3657;&#3648;&#3617;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3626;&#3605;&#3655;&#3629;&#3585;&#3618;&#3656;&#3629;&#3618;&#3',0),(15507,431,'hi','à¤°à¤‚à¤— à¤œà¤¬ à¤¸à¤­à¥€ substocks à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(15508,431,'ms','Tidak boleh memilih warna bila menggunakan semua substocks',0),(15509,431,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø£Ù„ÙˆØ§Ù† Ø¹Ù†Ø¯ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¬Ù…ÙŠØ¹ Ø³ÙˆØ¨Ø³ØªÙˆÙƒØ³',0),(15510,431,'fr','Ne pouvez pas sÃ©lectionner de couleurs lors de l\'utilisation de tous les sous-stocks',0),(15511,431,'jp','å…¨ã‚µãƒ–ã‚¹ãƒˆãƒƒã‚¯ã‚’ä½¿ç”¨ä¸­ã?¯è‰²ã?®é?¸æŠžã?Œã?§ã??ã?¾ã?›ã‚“',0),(15512,431,'pt','NÃ£o Ã© possÃ­vel selecionar cores ao usar todos os substocks',0),(15513,431,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ñ†Ð²ÐµÑ‚Ð° Ð¿Ñ€Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ð²ÑÐµÑ… substocks',0),(15514,431,'es','No se puede seleccionar colores cuando usa TODOS los Sub-Stocks',0),(15515,431,'de','Kann nicht Farben auswÃ¤hlen, wenn Sie alle Substocks verwenden',0),(15516,431,'en','Cannot select colors when using ALL substocks',0),(15517,432,'is','',0),(15518,432,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù†ÙˆØ´ØªÙ† Ø¯Ø± ÙØ§ÙŠÙ„ Ù†ÙŠØ³Øª',0),(15519,432,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù†ÙˆØ´ØªÙ† Ø¯Ø± ÙØ§ÙŠÙ„ Ù†ÙŠØ³Øª',0),(15520,432,'tr','Dosyaya yazÄ±lamÄ±yor',0),(15521,432,'pl','Nie moÅ¼na zapisaÄ‡ do pliku',0),(15522,432,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ð¸ÑˆÐµ Ð²ÑŠÐ² Ñ„Ð°Ð¹Ð»Ð°',0),(15523,432,'ur','Ù…Ø³Ù„ Ú©Ùˆ Ù†ÛÛŒÚº Ù„Ú©Ú¾ Ø³Ú©ØªØ§',0),(15524,432,'sr','ÐÐµÐ¼Ð¾Ð³ÑƒÑ› ÑƒÐ¿Ð¸Ñ Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(15525,432,'vi','KhÃ´ng thá»ƒ viáº¿t há»“ sÆ¡',0),(15526,432,'af','Kan nie na lÃªer skryf',0),(15527,432,'ro','Nu se poate scrie la fiÅŸier',0),(15528,432,'et','Faili ei saa kirjutada',0),(15529,432,'si','Ne more zapisati v datoteko',0),(15530,432,'ba','Tidak dapat menulis ke file',0),(15531,432,'nl','Kan niet schrijven naar bestand',0),(15532,432,'fi','Ei voi kirjoittaa tiedostoon',0),(15533,432,'no','Kan ikke skrive til filen',0),(15534,432,'da','Kan ikke skrive til fil',0),(15535,432,'ko','íŒŒì¼ì— ì“¸ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(15536,432,'he','×œ× × ×™×ª×Ÿ ×œ×›×ª×•×‘ ×§×•×‘×¥',0),(15537,432,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· ÎµÎ³Î³ÏÎ±Ï†Î® ÏƒÏ„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(15538,432,'zh','æ— æ³•å†™å…¥æ–‡ä»¶\r\n',0),(15539,432,'sv','Kan inte skriva till fil',0),(15540,432,'it','Non Ã¨ possibile scrivere il file',0),(15541,432,'tl','',0),(15542,432,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3586;&#3637;&#3618;&#3609;&#3652;&#3611;&#3626;&#3641;&#3656;&#3649;&#3615;&#3657;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(15543,432,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¤° à¤¨à¤¹à¥€à¤‚ à¤²à¤¿à¤– à¤¸à¤•à¤¤à¤¾',0),(15544,432,'ms','Tidak dapat menulis ke fail',0),(15545,432,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„ÙƒØªØ§Ø¨Ø© Ø¥Ù„Ù‰ Ù…Ù„Ù',0),(15546,432,'fr','Impossible d\'Ã©crire dans le fichier',0),(15547,432,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?«æ›¸ã??è¾¼ã?¿ã?§ã??ã?¾ã?›ã‚“',0),(15548,432,'pt','NÃ£o Ã© possÃ­vel gravar arquivo.',0),(15549,432,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð½Ð°Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ð² Ñ„Ð°Ð¹Ð»',0),(15550,432,'es','No se puede escribir a un archivo',0),(15551,432,'de','Kann nicht in Datei schreiben',0),(15552,432,'en','Cannot write to file',0),(15553,433,'is','',0),(15554,433,'dr','ÙƒØ§Ø±ØªÙ‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ\r\nVI Visa,MC MasterCard,DI \r\nDiscover,AE American Express',0),(15555,433,'pr','ÙƒØ§Ø±ØªÙ‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ\r\nVI Visa,MC MasterCard,DI \r\nDiscover,AE American Express',0),(15556,433,'tr','VI Visa, MasterCard MC, DI Discover, American Express AE',0),(15557,433,'pl','VI Visa, MC MasterCard, DI Discover, AE American Express',0),(15558,433,'bg','VI Visa, MC MasterCard, Ð´Ð¸ ÐžÑ‚ÐºÑ€Ð¸Ð¹Ñ‚Ðµ, AE American Express',0),(15559,433,'ur','VI ÙˆÛŒØ²Ø§ØŒ MC Ù…Ø§Ø³Ù¹Ø±Ú©Ø§Ø±ÚˆØŒ ÚˆØ§ Ø¯Ø±ÛŒØ§ÙØªØŒ AE Ø§Ù…Ø±ÛŒÚ©Ù† Ø§ÛŒÚ©Ø³Ù¾Ø±ÛŒØ³',0),(15560,433,'sr','Ð’ÐÐˆ Ð’Ð¸ÑÐ°, ÐœÐ¦ ÐœÐ°ÑÑ‚ÐµÑ€Ð¦Ð°Ñ€Ð´, Ð”Ð˜ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸, ÐÐ• ÐÐ¼ÐµÑ€Ð¸Ñ†Ð°Ð½ Ð•xÐ¿Ñ€ÐµÑÑ',0),(15561,433,'vi','VI lÃ  tháº» Visa, MC lÃ  tháº» Master card, DI lÃ  tháº» Discover, AE lÃ  tháº» American Express',0),(15562,433,'af','VI Visa,MC MasterCard,DI Discover,AE American Express',0),(15563,433,'ro','VI Visa, MC MasterCard, DI descoperi, AE American Express',0),(15564,433,'et','VI Visa, MC MasterCard, DI Discover, AE American Express',0),(15565,433,'si','VI Visa, MC MasterCard, DI Discover, AE American Express',0),(15566,433,'ba','VI Visa, MC MasterCard, DI menemukan, AE American Express',0),(15567,433,'nl','VI Visa, MC MasterCard, DI Discover, American Express AE',0),(15568,433,'fi','VI Visa, MC MasterCard, DI lÃ¶ytÃ¤Ã¤, AE American Express',0),(15569,433,'no','VI Visa, MC MasterCard, DI oppdager, AE American Express',0),(15570,433,'da','VI Visa, MC MasterCard, DI Oplev, AE American Express',0),(15571,433,'ko','VI ë¹„ìž, ì— ì”¨ ë§ˆìŠ¤í„°, ë”” ë””ìŠ¤ ì»¤ë²„, ì•„ë©”ë¦¬ì¹¸ ìµìŠ¤í”„ë ˆìŠ¤ AE',0),(15572,433,'he','×”×©×™×©×™ ×•×™×–×”, ×ž××¡×˜×¨×›××¨×“ MC, DI ×œ×’×œ×•×ª, AE ××ž×¨×™×§×Ÿ ××§×¡×¤×¨×¡',0),(15573,433,'el','VI Visa, MC MasterCard, DI Î±Î½Î±ÎºÎ±Î»ÏÏˆÎ¿Ï…Î½, American Express Î‘Î•',0),(15574,433,'zh','å…­ï¼Œç­¾è¯ï¼Œä¸‰è±å•†äº‹ä¸‡äº‹ï¼Œç›´æŽ¥æŠ•èµ„æŽ¢ç´¢ï¼Œç¾Žå›½è¿é€šæ›å…‰\r\n',0),(15575,433,'sv','VI Visa, MC MasterCard, DI upptÃ¤cka, AE American Express',0),(15576,433,'it','VI Visa, MasterCard MC, DI scoprire, AE American Express',0),(15577,433,'tl','',0),(15578,433,'th','VI Visa,MC MasterCard,DI Discover,AE American Express',0),(15579,433,'hi','VI à¤µà¥€à¤œà¤¼à¤¾, à¤®à¤¾à¤¸à¥à¤Ÿà¤°à¤•à¤¾à¤°à¥à¤¡ MC, DI à¤¡à¤¿à¤¸à¥à¤•à¤µà¤°, AE à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¨ à¤à¤•à¥à¤¸à¤ªà¥à¤°à¥‡à¤¸',0),(15580,433,'ms','VI Visa, MC MasterCard, DI menemui, AE American Express',0),(15581,433,'ar','Ø³Ø§Ø¯Ø³Ø§ ÙÙŠØ²Ø§ØŒ Ù…Ø§Ø³ØªØ±ÙƒØ§Ø±Ø¯ MCØŒ Ø¯ÙŠ Ø§ÙƒØªØ´ÙØŒ Ø¹Ø¨Ø¯ Ø§Ù„Ù„Ø·ÙŠÙ Ø£Ù…Ø±ÙŠÙƒØ§Ù† Ø¥ÙƒØ³Ø¨Ø±ÙŠØ³',0),(15582,433,'fr','VI Visa, MC MasterCard, DI Discover, American Express AE',0),(15583,433,'jp','VIã€€ãƒ“ã‚¶ã€?MCã€€ãƒžã‚¹ã‚¿ãƒ¼ã‚«ãƒ¼ãƒ‰ã€?DIã€€ãƒ‡ã‚£ã‚¹ã‚«ãƒ?ãƒ¼ã€?AEã€€ã‚¢ãƒ¡ãƒªã‚«ãƒ³ã‚¨ã‚­ã‚¹ãƒ—ãƒ¬ã‚¹',0),(15584,433,'pt','VI Visa, MasterCard MC, DI Discover, American Express AE',0),(15585,433,'ru','VI Visa, MC MasterCard, Ð´Ð¸ Ð¾Ð±Ð½Ð°Ñ€ÑƒÐ¶Ð¸Ð²Ð°ÑŽÑ‚, American Express Ð.Ð•',0),(15586,433,'es','VI Visa,MC MasterCard,DI Discover,AE American Express',0),(15587,433,'de','DI, VI Visa, MC MasterCard Discover, AE American Express',0),(15588,433,'en','VI Visa,MC MasterCard,DI Discover,AE American Express',0),(15589,434,'is','',0),(15590,434,'dr','Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(15591,434,'pr','Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(15592,434,'tr','TaÅŸÄ±yÄ±cÄ±',0),(15593,434,'pl','PrzewoÅºnik',0),(15594,434,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(15595,434,'ur','Ú©ÛŒØ±ÛŒØ¦Ø±',0),(15596,434,'sr','ÐÐ¾ÑÐ°Ñ‡',0),(15597,434,'vi','HÃ£ng váº­n chuyá»ƒn',0),(15598,434,'af','Karweier',0),(15599,434,'ro','Operator de transport',0),(15600,434,'et','Kuller',0),(15601,434,'si','Prevoznik',0),(15602,434,'ba','Pembawa',0),(15603,434,'nl','Vervoerder',0),(15604,434,'fi','Harjoittaja',0),(15605,434,'no','TransportÃ¸r',0),(15606,434,'da','Luftfartsselskab',0),(15607,434,'ko','ìºë¦¬ì–´',0),(15608,434,'he','×ž× ×©×',0),(15609,434,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(15610,434,'zh','æ‰¿è¿äºº\r\n',0),(15611,434,'sv','Carrier',0),(15612,434,'it','Vettore',0),(15613,434,'tl','',0),(15614,434,'th','&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(15615,434,'hi','à¤µà¤¾à¤¹à¤•',0),(15616,434,'ms','Pembawa',0),(15617,434,'ar','Ø§Ù„Ù†Ø§Ù‚Ù„',0),(15618,434,'fr','Transporteur',0),(15619,434,'jp','ã‚­ãƒ£ãƒªã‚¢',0),(15620,434,'pt','Transportadora',0),(15621,434,'ru','ÐšÑƒÑ€ÑŒÐµÑ€',0),(15622,434,'es','Transportador',0),(15623,434,'de','TrÃ¤ger',0),(15624,434,'en','Carrier',0),(15625,435,'is','',0),(15626,435,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(15627,435,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(15628,435,'tr','TaÅŸÄ±yÄ±cÄ± baÅŸarÄ±yla eklendi',0),(15629,435,'pl','PrzewoÅºnik pomyÅ›lnie dodane',0),(15630,435,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(15631,435,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(15632,435,'sr','ÐÐ¾ÑÐ°Ñ‡ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(15633,435,'vi','ThÃªm hÃ£ng váº­n chuyá»ƒn thÃ nh cÃ´ng',0),(15634,435,'af','Karweier suksesvol bygevoeg',0),(15635,435,'ro','Transportatorul adÄƒugat cu succes',0),(15636,435,'et','Lisatud vedaja',0),(15637,435,'si','Prevoznik uspeÅ¡no dodani',0),(15638,435,'ba','Pembawa ditambahkan berhasil',0),(15639,435,'nl','Vervoerder met succes toegevoegd',0),(15640,435,'fi','Operaattorin lisÃ¤Ã¤minen onnistui',0),(15641,435,'no','TransportÃ¸r lagt',0),(15642,435,'da','Carrier tilfÃ¸jet',0),(15643,435,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ìºë¦¬ì–´',0),(15644,435,'he','× ×•×©× × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(15645,435,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(15646,435,'zh','æ‰¿è¿äººæ·»åŠ æˆåŠŸ\r\n',0),(15647,435,'sv','Carrier lagts',0),(15648,435,'it','Vettore aggiunto con successo',0),(15649,435,'tl','',0),(15650,435,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(15651,435,'hi','à¤µà¤¾à¤¹à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(15652,435,'ms','Pengangkut yang berjaya menambah',0),(15653,435,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ù†Ø§Ù‚Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(15654,435,'fr','Transporteur ajoutÃ© avec succÃ¨s',0),(15655,435,'jp','é?‹é€?æ¥­è€…ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(15656,435,'pt','Transportadora adicionada com sucesso',0),(15657,435,'ru','ÐšÑƒÑ€ÑŒÐµÑ€ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(15658,435,'es','Transportador Agregado Exitosamente',0),(15659,435,'de','TrÃ¤ger erfolgreich hinzugefÃ¼gt',0),(15660,435,'en','Carrier added successfully',0),(15661,436,'is','',0),(15662,436,'dr','Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(15663,436,'pr','Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(15664,436,'tr','TaÅŸÄ±yÄ±cÄ± zaten var',0),(15665,436,'pl','PrzewoÅºnik juÅ¼ istnieje',0),(15666,436,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(15667,436,'ur','Ø¨Ø±Ø¯Ø§Ø± Ø¬ÛØ§Ø² Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(15668,436,'sr','ÐÐ¾ÑÐ°Ñ‡ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(15669,436,'vi','HÃ£ng váº­n chuyá»ƒn Ä‘Ã£ tá»“n táº¡i',0),(15670,436,'af','Karweier bestaan alreeds',0),(15671,436,'ro','Transportatorul existÄƒ deja',0),(15672,436,'et','Vedaja on juba olemas',0),(15673,436,'si','Prevoznik Å¾e obstaja',0),(15674,436,'ba','Operator sudah ada',0),(15675,436,'nl','Vervoerder bestaat al',0),(15676,436,'fi','Carrier on jo olemassa',0),(15677,436,'no','TransportÃ¸ren finnes allerede',0),(15678,436,'da','Carrier findes allerede',0),(15679,436,'ko','ì´ë¯¸ ìºë¦¬ì–´',0),(15680,436,'he','×ž× ×©× ×›×‘×¨ ×§×™×™×',0),(15681,436,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Î± Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(15682,436,'zh','æ‰¿è¿äººå·²ç»å­˜åœ¨\r\n',0),(15683,436,'sv','BÃ¤rare finns redan',0),(15684,436,'it','Vettore esiste giÃ ',0),(15685,436,'tl','',0),(15686,436,'th','&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3614;&#3619;&#3657;&#3629;&#3617;&#3649;&#3621;&#3657;&#3623;',0),(15687,436,'hi','à¤µà¤¾à¤¹à¤• à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(15688,436,'ms','Pembekal perkhidmatan telah sedia wujud',0),(15689,436,'ar','Ø§Ù„Ù†Ø§Ù‚Ù„ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(15690,436,'fr','Transporteur existe dÃ©jÃ ',0),(15691,436,'jp','é?‹é€?æ¥­è€…ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(15692,436,'pt','Transportadora jÃ¡ existe',0),(15693,436,'ru','ÐšÑƒÑ€ÑŒÐµÑ€ Ð£Ð¶Ðµ Ð¡Ð¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ÑÑ',0),(15694,436,'es','Transportador ya existe',0),(15695,436,'de','TrÃ¤ger ist bereits vorhanden.',0),(15696,436,'en','Carrier already exists',0),(15697,437,'is','',0),(15698,437,'dr','Ø­Ø°Ù Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(15699,437,'pr','Ø­Ø°Ù Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(15700,437,'tr','TaÅŸÄ±yÄ±cÄ± baÅŸarÄ±yla silindi',0),(15701,437,'pl','PrzewoÅºnik pomyÅ›lnie usuniÄ™ty',0),(15702,437,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(15703,437,'ur','Ø¨Ø±Ø¯Ø§Ø± Ø¬ÛØ§Ø² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(15704,437,'sr','ÐÐ¾ÑÐ°Ñ‡ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(15705,437,'vi','XÃ³a HÃ£ng váº­n chuyá»ƒn thÃ nh cÃ´ng',0),(15706,437,'af','Karweier suksesvol geskrap',0),(15707,437,'ro','Transportatorul eliminÄƒ cu succes',0),(15708,437,'et','Vedaja edukalt kustutatud',0),(15709,437,'si','Nosilec uspeÅ¡no izbrisal',0),(15710,437,'ba','Pembawa dihapus berhasil',0),(15711,437,'nl','Vervoerder met succes verwijderd',0),(15712,437,'fi','Operaattorin poistettu',0),(15713,437,'no','OperatÃ¸ren slettet',0),(15714,437,'da','Carrier slettet',0),(15715,437,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ìºë¦¬ì–´',0),(15716,437,'he','×ž× ×©× × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(15717,437,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Î±Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(15718,437,'zh','æ‰¿è¿äººåˆ é™¤æˆåŠŸ\r\n',0),(15719,437,'sv','Carrier raderades',0),(15720,437,'it','Vettore eliminato con successo',0),(15721,437,'tl','',0),(15722,437,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(15723,437,'hi','à¤µà¤¾à¤¹à¤• à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(15724,437,'ms','Pembawa dihapuskan dengan jayanya',0),(15725,437,'ar','Ø­Ø°Ù Ø§Ù„Ù†Ø§Ù‚Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(15726,437,'fr','Porteuse supprimÃ©e avec succÃ¨s',0),(15727,437,'jp','é?‹é€?æ¥­è€…ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(15728,437,'pt','Transportadora apagada com sucesso',0),(15729,437,'ru','ÐšÑƒÑ€ÑŒÐµÑ€ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½',0),(15730,437,'es','Transportador eliminado exitosamente',0),(15731,437,'de','TrÃ¤ger erfolgreich gelÃ¶scht',0),(15732,437,'en','Carrier deleted successfully',0),(15733,438,'is','',0),(15734,438,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(15735,438,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(15736,438,'tr','TaÅŸÄ±yÄ±cÄ± bilgileri',0),(15737,438,'pl','NoÅ›nik informacji',0),(15738,438,'bg','ÐÐ¾ÑÐ¸Ñ‚ÐµÐ» Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(15739,438,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(15740,438,'sr','ÐÐ¾ÑÐ°Ñ‡ Ð˜Ð½Ñ„Ð¾',0),(15741,438,'vi','ThÃ´ng tin hÃ£ng váº­n chuyá»ƒn',0),(15742,438,'af','Karweier Inligting',0),(15743,438,'ro','Transportatorul Info',0),(15744,438,'et','Vedaja teave',0),(15745,438,'si','Prevoznik Info',0),(15746,438,'ba','Info maskapai',0),(15747,438,'nl','Vervoerder Info',0),(15748,438,'fi','Rahdinkuljettajan tiedot',0),(15749,438,'no','TransportÃ¸r Info',0),(15750,438,'da','Carrier Info',0),(15751,438,'ko','ìºë¦¬ì–´ ì •ë³´',0),(15752,438,'he','×¤×¨×˜×™ ×”×¡×¤×§',0),(15753,438,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï„Î¿Ï… Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(15754,438,'zh','æ‰¿è¿äººä¿¡æ¯\r\n',0),(15755,438,'sv','Carrier information',0),(15756,438,'it','Vettore Info',0),(15757,438,'tl','',0),(15758,438,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(15759,438,'hi','à¤•à¥ˆà¤°à¤¿à¤¯à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(15760,438,'ms','Maklumat penerbangan',0),(15761,438,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù†Ø§Ù‚Ù„',0),(15762,438,'fr','Transporteur Info',0),(15763,438,'jp','é?‹é€?æ¥­è€…æƒ…å ±',0),(15764,438,'pt','InformaÃ§Ã£o da transportadora',0),(15765,438,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ðž ÐšÑƒÑ€ÑŒÐµÑ€Ðµ',0),(15766,438,'es','Transportador Info',0),(15767,438,'de','Carrier-Info',0),(15768,438,'en','Carrier Info',0),(15769,439,'is','',0),(15770,439,'dr','Ø±ÙˆØ´ Ø­Ù…Ù„ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(15771,439,'pr','Ø±ÙˆØ´ Ø­Ù…Ù„ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(15772,439,'tr','TaÅŸÄ±yÄ±cÄ± nakliye yÃ¶ntemi',0),(15773,439,'pl','Metody wysyÅ‚ki przewoÅºnika',0),(15774,439,'bg','ÐÐ°Ñ‡Ð¸Ð½ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð° Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡Ð°',0),(15775,439,'ur','Ø¨Ø±Ø¯Ø§Ø± Ø¬ÛØ§Ø² Ø±Ø§Ù†ÛŒ Ø·Ø±ÛŒÙ‚Û',0),(15776,439,'sr','ÐÐ°Ñ‡Ð¸Ð½ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð½Ð¾ÑÐ°Ñ‡',0),(15777,439,'vi','PhÆ°Æ¡ng thá»©c chuyá»ƒn hÃ ng',0),(15778,439,'af','Draer gestuur metode',0),(15779,439,'ro','Metoda de transport maritim de transport',0),(15780,439,'et','Vedaja meresÃµidu meetod',0),(15781,439,'si','NaÄin poÅ¡iljanja prevoznik',0),(15782,439,'ba','Metode pengiriman pembawa',0),(15783,439,'nl','Vervoerder verzendmethode',0),(15784,439,'fi','Operaattorin toimitustapa',0),(15785,439,'no','TransportÃ¸r Fraktmetode',0),(15786,439,'da','Carrier Shipping metode',0),(15787,439,'ko','ìºë¦¬ì–´ ë°°ì†¡ ë°©ë²•',0),(15788,439,'he','×©×™×˜×ª ×”×ž×©×œ×•×— × ×•×©××ª',0),(15789,439,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Î±Ï‚ ÎœÎ•Î˜ÎŸÎ”ÎŸÎ¥ Î‘Î ÎŸÎ£Î¤ÎŸÎ›Î—Î£',0),(15790,439,'zh','æ‰¿è¿äººè¿é€æ–¹æ³•\r\n',0),(15791,439,'sv','Carrier leveranssÃ¤tt',0),(15792,439,'it','Metodo di spedizione del vettore',0),(15793,439,'tl','',0),(15794,439,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(15795,439,'hi','à¤µà¤¾à¤¹à¤• à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¿à¤§à¤¿',0),(15796,439,'ms','Kaedah penghantaran pembawa',0),(15797,439,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ù†Ù‚Ù„',0),(15798,439,'fr','Mode de livraison transporteur',0),(15799,439,'jp','é?‹é€?æ¥­è€…ç™ºé€?æ³•',0),(15800,439,'pt','MÃ©todo de envio da transportadora',0),(15801,439,'ru','Ð¡Ð¿Ð¾ÑÐ¾Ð± ÐšÑƒÑ€ÑŒÐµÑ€ÑÐºÐ¾Ð¹ Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(15802,439,'es','Transportador Metodo de EnvÃ­o',0),(15803,439,'de','Carrier Versandart',0),(15804,439,'en','Carrier Shipping Method',0),(15805,440,'is','',0),(15806,440,'dr','Ù†Ø§Ù… Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(15807,440,'pr','Ù†Ø§Ù… Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(15808,440,'tr','TaÅŸÄ±yÄ±cÄ± adÄ±',0),(15809,440,'pl','Nazwa przewoÅºnika',0),(15810,440,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ Ð¸Ð¼Ðµ',0),(15811,440,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ú©Û’ Ù†Ø§Ù…',0),(15812,440,'sr','ÐÐ¾ÑÐ°Ñ‡ Ð¸Ð¼Ðµ',0),(15813,440,'vi','TÃªn hÃ£ng váº­n chuyá»ƒn',0),(15814,440,'af','Karweier Naam',0),(15815,440,'ro','Nume de operator de transport',0),(15816,440,'et','Vedaja nimi',0),(15817,440,'si','Ime prevoznika',0),(15818,440,'ba','Nama operator',0),(15819,440,'nl','Naam transporteur',0),(15820,440,'fi','Operaattorin nimi',0),(15821,440,'no','Navn pÃ¥ transportÃ¸r:',0),(15822,440,'da','Navn pÃ¥ fragtmand',0),(15823,440,'ko','ìºë¦¬ì–´ ì´ë¦„',0),(15824,440,'he','×©× ×”×ž×•×‘×™×œ',0),(15825,440,'el','Î¤Î¿ ÏŒÎ½Î¿Î¼Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Ï‰Î½',0),(15826,440,'zh','èˆªç©ºå…¬å¸åç§°\r\n',0),(15827,440,'sv','Namn pÃ¥ fraktfirma',0),(15828,440,'it','Nome del vettore',0),(15829,440,'tl','',0),(15830,440,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(15831,440,'hi','à¤µà¤¾à¤¹à¤• à¤•à¤¾ à¤¨à¤¾à¤®',0),(15832,440,'ms','Nama pengangkut',0),(15833,440,'ar','Ø§Ø³Ù… Ø§Ù„Ù†Ø§Ù‚Ù„',0),(15834,440,'fr','Nom du transporteur',0),(15835,440,'jp','é?‹é€?æ¥­è€…å??',0),(15836,440,'pt','Nome do portador',0),(15837,440,'ru','ÐÐ°Ð¸Ð¼ÐµÐ½Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸ÐºÐ°',0),(15838,440,'es','Transportador Nombre',0),(15839,440,'de','Spediteurname',0),(15840,440,'en','Carrier Name',0),(15841,441,'is','',0),(15842,441,'dr','Ø®Ø¯Ù…Ø§Øª Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(15843,441,'pr','Ø®Ø¯Ù…Ø§Øª Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(15844,441,'tr','Carrier Servisi',0),(15845,441,'pl','UsÅ‚ugi przewoÅºnika',0),(15846,441,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(15847,441,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ú©ÛŒ Ø®Ø¯Ù…Øª',0),(15848,441,'sr','ÐÐ¾ÑÐ°Ñ‡ ÑÐµÑ€Ð²Ð¸Ñ',0),(15849,441,'vi','Dá»‹ch vá»¥ hÃ£ng váº­n chuyá»ƒn',0),(15850,441,'af','Karweier Diens',0),(15851,441,'ro','Serviciul de transport',0),(15852,441,'et','Vedaja Service',0),(15853,441,'si','Nosilec storitve',0),(15854,441,'ba','Layanan Carrier',0),(15855,441,'nl','Vervoerder Service',0),(15856,441,'fi','Rahdinkuljettajan',0),(15857,441,'no','TransportÃ¸rtjenesten',0),(15858,441,'da','Fragttjenesten',0),(15859,441,'ko','ì´ë™ í†µì‹ ì‚¬ ì„œë¹„ìŠ¤',0),(15860,441,'he','×”×©×™×¨×•×ª ×”×ž×•×‘×™×œ',0),(15861,441,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï„Î¿Ï… Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(15862,441,'zh','è¿è¥å•†æœåŠ¡\r\n',0),(15863,441,'sv','Carrier Service',0),(15864,441,'it','Servizio di vettore',0),(15865,441,'tl','',0),(15866,441,'th','&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(15867,441,'hi','à¤µà¤¾à¤¹à¤• à¤¸à¥‡à¤µà¤¾',0),(15868,441,'ms','Perkhidmatan pengangkutan',0),(15869,441,'ar','Ø®Ø¯Ù…Ø© Ø§Ù„Ù†Ø§Ù‚Ù„',0),(15870,441,'fr','Service de l\'entreprise',0),(15871,441,'jp','é?‹é€?ã‚µãƒ¼ãƒ“ã‚¹',0),(15872,441,'pt','ServiÃ§o de transportadora',0),(15873,441,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(15874,441,'es','Transportador Servicio',0),(15875,441,'de','Carrier Service',0),(15876,441,'en','Carrier Service',0),(15877,442,'is','',0),(15878,442,'dr','/ Ø®Ø¯Ù…Ø§Øª',0),(15879,442,'pr','Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡/ Ø®Ø¯Ù…Ø§Øª',0),(15880,442,'tr','TaÅŸÄ±yÄ±cÄ±/hizmet',0),(15881,442,'pl','PrzewoÅºnik/usÅ‚ugi',0),(15882,442,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡/ÑƒÑÐ»ÑƒÐ³Ð°',0),(15883,442,'ur','Ú©ÛŒØ±ÛŒØ¦Ø±/Ø³Ø±ÙˆØ³',0),(15884,442,'sr','ÐÐ¾ÑÐ°Ñ‡/ÑÐµÑ€Ð²Ð¸Ñ',0),(15885,442,'vi','HÃ£ng váº­n chuyá»ƒn/Dá»‹ch vá»¥ ',0),(15886,442,'af','Karweier/Diens',0),(15887,442,'ro','Operatorul de transport/servicii',0),(15888,442,'et','Vedaja/teenus',0),(15889,442,'si','Prevoznik/storitev',0),(15890,442,'ba','Layanan/Carrier',0),(15891,442,'nl','Vervoerder/Service',0),(15892,442,'fi','Harjoittajan tai palvelun',0),(15893,442,'no','TransportÃ¸rtjenesten /',0),(15894,442,'da','Carrier/Service',0),(15895,442,'ko','ìºë¦¬ì–´/ì„œë¹„ìŠ¤',0),(15896,442,'he','×ž× ×©×/×©×™×¨×•×ª',0),(15897,442,'el','Î¦Î¿ÏÎ­Î±/Ï…Ï€Î·ÏÎµÏƒÎ¯Î±',0),(15898,442,'zh','è¿è¥å•†æœåŠ¡2\r\n',0),(15899,442,'sv','Carrier/Service',0),(15900,442,'it','Vettore/servizio',0),(15901,442,'tl','',0),(15902,442,'th','&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;/&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(15903,442,'hi','à¤µà¤¾à¤¹à¤•/à¤¸à¥‡à¤µà¤¾',0),(15904,442,'ms','Pembawa/Perkhidmatan',0),(15905,442,'ar','Ø§Ù„Ù†Ø§Ù‚Ù„/Ø§Ù„Ø®Ø¯Ù…Ø©',0),(15906,442,'fr','Transporteur/Service',0),(15907,442,'jp','é?‹é€?æ¥­è€…/ã‚µãƒ¼ãƒ“ã‚¹',0),(15908,442,'pt','Transportadora/serviÃ§o',0),(15909,442,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº/ÑÐµÑ€Ð²Ð¸Ñ',0),(15910,442,'es','Transportador/Servicio',0),(15911,442,'de','Carrier/Service',0),(15912,442,'en','Carrier/Service',0),(15913,443,'is','',0),(15914,443,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(15915,443,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(15916,443,'tr','Nakliye gemisi DÃ¼zenle',0),(15917,443,'pl','Edytuj, przewoÅºnik',0),(15918,443,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(15919,443,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ø´Ù¾Ù†Ú¯ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(15920,443,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð½Ð¾ÑÐ°Ñ‡ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(15921,443,'vi','Cáº­p Nháº­t HÃ£ng Váº­n Chuyá»ƒn',0),(15922,443,'af','Karweier Opdateer',0),(15923,443,'ro','Editare de transport maritim de transport',0),(15924,443,'et','Redigeeri Shipping vedaja',0),(15925,443,'si','Urejanje ladijskega prevoznika',0),(15926,443,'ba','Mengedit pengiriman Carrier',0),(15927,443,'nl','Bewerken verzending van vervoerder',0),(15928,443,'fi','Muokkaa lÃ¤hetyksen rahdinkuljettaja',0),(15929,443,'no','Redigere frakt Carrier',0),(15930,443,'da','Redigere Shipping transportvirksomhed',0),(15931,443,'ko','ìºë¦¬ì–´ ë°°ì†¡ íŽ¸ì§‘',0),(15932,443,'he','×¢×¨×™×›×ª ×”×ž×©×œ×•×— × ×•×©××ª',0),(15933,443,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î½Î±Ï…Ï„Î¹Î»Î¯Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(15934,443,'zh','æ‰¿è¿äººæ›´æ–°\r\n',0),(15935,443,'sv','Redigera frakt bÃ¤rare',0),(15936,443,'it','Modificare il vettore di spedizione',0),(15937,443,'tl','',0),(15938,443,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(15939,443,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¥ˆà¤°à¤¿à¤¯à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(15940,443,'ms','Edit penghantaran pembawa',0),(15941,443,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù†Ø§Ù‚Ù„',0),(15942,443,'fr','Modifier la livraison transporteur',0),(15943,443,'jp','é?‹é€?æ¥­è€…ã?®æ›´æ–°',0),(15944,443,'pt','Editar transporte transportadora',0),(15945,443,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸ÐºÐ¾Ð¼',0),(15946,443,'es','Transportador Actualizar',0),(15947,443,'de','Bearbeiten, Versand',0),(15948,443,'en','Edit Shipping Carrier',0),(15949,444,'is','',0),(15950,444,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(15951,444,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(15952,444,'tr','Nakliye taÅŸÄ±yÄ±cÄ±ya baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(15953,444,'pl','PrzewoÅºnik pomyÅ›lnie zaktualizowana',0),(15954,444,'bg','ÐœÐ¾Ñ€ÑÐºÐ¸ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(15955,444,'ur','Ø´Ù¾Ù†Ú¯ Ø¨Ø±Ø¯Ø§Ø± Ø¬ÛØ§Ø² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(15956,444,'sr','ÐÐ¾ÑÐ°Ñ‡ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(15957,444,'vi','Cáº­p Nháº­t HÃ£ng Váº­n Chuyá»ƒn thÃ nh cÃ´ng',0),(15958,444,'af','Karweier suksesvol Opdateer',0),(15959,444,'ro','Transport maritim actualizat cu succes',0),(15960,444,'et','Laevade vedaja vÃ¤rskendatud',0),(15961,444,'si','Ladijskega prevoznika, ki je uspeÅ¡no posodobljena',0),(15962,444,'ba','Pembawa pengiriman yang berhasil',0),(15963,444,'nl','Verzending vervoerder bijgewerkt',0),(15964,444,'fi','Rahdinkuljettajan pÃ¤ivitetty',0),(15965,444,'no','TransportÃ¸ren oppdatert',0),(15966,444,'da','Fragtmanden opdateret',0),(15967,444,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ë°°ì†¡ ìºë¦¬ì–´',0),(15968,444,'he','×”×ž×©×œ×•×— × ×•×©××ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(15969,444,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(15970,444,'zh','æ‰¿è¿äººæˆåŠŸæ›´æ–°\r\n',0),(15971,444,'sv','TransportfÃ¶retaget uppdaterats',0),(15972,444,'it','Trasportatore aggiornato con successo',0),(15973,444,'tl','',0),(15974,444,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(15975,444,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¾à¤¹à¤• à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(15976,444,'ms','Penghantaran pesawat yang berjaya dikemas kini',0),(15977,444,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ù†Ø§Ù‚Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(15978,444,'fr','Transporteur correctement mis Ã  jour',0),(15979,444,'jp','é?‹é€?æ¥­è€…ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(15980,444,'pt','Frete transportadora atualizada com sucesso',0),(15981,444,'ru','ÐšÑƒÑ€ÑŒÐµÑ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(15982,444,'es','Transportador Actualizado Exitosamente',0),(15983,444,'de','Versand erfolgreich aktualisiert',0),(15984,444,'en','Shipping Carrier updated successfully',0),(15985,445,'is','',0),(15986,445,'dr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(15987,445,'pr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(15988,445,'tr','Nakit',0),(15989,445,'pl','ÅšrodkÃ³w pieniÄ™Å¼nych',0),(15990,445,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°',0),(15991,445,'ur','Ù†Ù‚Ø¯',0),(15992,445,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ñƒ',0),(15993,445,'vi','Tiá»n máº·t',0),(15994,445,'af','Kontant',0),(15995,445,'ro','Numerar',0),(15996,445,'et','Sularaha',0),(15997,445,'si','Denarnih',0),(15998,445,'ba','Tunai',0),(15999,445,'nl','Contant geld',0),(16000,445,'fi','KÃ¤teisellÃ¤',0),(16001,445,'no','Kontanter',0),(16002,445,'da','Kontant',0),(16003,445,'ko','í˜„ê¸ˆ',0),(16004,445,'he','×ž×–×•×ž×Ÿ',0),(16005,445,'el','ÎœÎµÏ„ÏÎ·Ï„Î¬',0),(16006,445,'zh','çŽ°é‡‘\r\n',0),(16007,445,'sv','Cash',0),(16008,445,'it','Contanti',0),(16009,445,'tl','',0),(16010,445,'th','&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;',0),(16011,445,'hi','à¤¨à¤•à¤¦',0),(16012,445,'ms','Wang Tunai',0),(16013,445,'ar','Ù†Ù‚Ø¯Ø§',0),(16014,445,'fr','TrÃ©sorerie',0),(16015,445,'jp','ç?¾é‡‘',0),(16016,445,'pt','Em dinheiro',0),(16017,445,'ru','ÐÐ°Ð»Ð¸Ñ‡Ð½Ñ‹Ðµ',0),(16018,445,'es','Efectivo',0),(16019,445,'de','Bargeld',0),(16020,445,'en','Cash',0),(16021,446,'is','',0),(16022,446,'dr','Ø¢ÙŠØ§ Ù†Ù‚Ø¯ Ø´Ø¯Ù‡ Ø§Ø³ØªØŸ',0),(16023,446,'pr','Ø¢ÙŠØ§ Ù†Ù‚Ø¯ Ø´Ø¯Ù‡ Ø§Ø³ØªØŸ',0),(16024,446,'tr','Paraya mÄ±?',0),(16025,446,'pl','Zrealizowane?',0),(16026,446,'bg','ÐžÑÑ€ÐµÐ±Ñ€ÑÑ‚?',0),(16027,446,'ur','Ø¨Ø¸Ø§ÛØ±Ø§Ù†ØŸ',0),(16028,446,'sr','Ð£Ð½Ð¾Ð²Ñ‡Ð¸Ð¾?',0),(16029,446,'vi','ÄÃ£ dá»•i thÃ nh Tiá»n máº·t?',0),(16030,446,'af','Gewisseldes?',0),(16031,446,'ro','Incasate?',0),(16032,446,'et','Kasseeritud?',0),(16033,446,'si','VnovÄil?',0),(16034,446,'ba','Menguangkan?',0),(16035,446,'nl','GeÃ¯nd?',0),(16036,446,'fi','Lunastettu?',0),(16037,446,'no','InnlÃ¸ses?',0),(16038,446,'da','IndlÃ¸st?',0),(16039,446,'ko','í˜„ê¸ˆìœ¼ë¡œ?',0),(16040,446,'he','×¤×“×”?',0),(16041,446,'el','Î¤ÎµÏÎ¼Î¬Ï„Î¹ÏƒÎµ ÏƒÏ„Î± Ï‡ÏÎ®Î¼Î±Ï„Î±;',0),(16042,446,'zh','å…‘çŽ°ï¼Ÿ\r\n',0),(16043,446,'sv','Inkasserades?',0),(16044,446,'it','Incassato?',0),(16045,446,'tl','',0),(16046,446,'th','&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(16047,446,'hi','à¤­à¥à¤¨à¤¾à¤¯à¤¾?',0),(16048,446,'ms','Ditunaikan?',0),(16049,446,'ar','ØµØ±ÙØ©ØŸ',0),(16050,446,'fr','EncaissÃ© ?',0),(16051,446,'jp','æ?›é‡‘ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(16052,446,'pt','Descontaram?',0),(16053,446,'ru','ÐžÐ±Ð½Ð°Ð»Ð¸Ñ‡Ð¸Ñ‚ÑŒ?',0),(16054,446,'es','Â¿Cambiado?',0),(16055,446,'de','EingelÃ¶st?',0),(16056,446,'en','Cashed?',0),(16057,447,'is','',0),(16058,447,'dr','ØªØ§Ø±ÙŠØ® Ù†Ù‚Ø¯ Ø´Ø¯Ù†',0),(16059,447,'pr','ØªØ§Ø±ÙŠØ® Ù†Ù‚Ø¯ Ø´Ø¯Ù†',0),(16060,447,'tr','Paraya tarihi',0),(16061,447,'pl','Data wypÅ‚aty',0),(16062,447,'bg','Ð”Ð°Ñ‚Ð° Ð¾ÑÑ€ÐµÐ±Ñ€ÑÑ‚',0),(16063,447,'ur','Ø¨Ø¸Ø§ÛØ±Ø§Ù† ØªØ§Ø±ÛŒØ®',0),(16064,447,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ ÑƒÐ½Ð¾Ð²Ñ‡Ð¸Ð¾',0),(16065,447,'vi','NgÃ y dá»•i thÃ nh Tiá»n máº·t',0),(16066,447,'af','Datum Gewissel',0),(16067,447,'ro','Data incasate',0),(16068,447,'et','Kasseerimise kuupÃ¤ev',0),(16069,447,'si','Datum unovÄiti',0),(16070,447,'ba','Tanggal menguangkan',0),(16071,447,'nl','Datum geÃ¯nd',0),(16072,447,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ lunastettu',0),(16073,447,'no','Dato innlÃ¸ses',0),(16074,447,'da','Dato indlÃ¸st',0),(16075,447,'ko','í˜„ê¸ˆìœ¼ë¡œ í•˜ëŠ” ë‚ ì§œ',0),(16076,447,'he','×ª××¨×™×š ×¤×“×”',0),(16077,447,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ¾Î±ÏÎ³Ï…ÏÏŽÏƒÎµÎ¹',0),(16078,447,'zh','å…‘çŽ°æ—¥æœŸ\r\n',0),(16079,447,'sv','Datum inkasserades',0),(16080,447,'it','Data incassato',0),(16081,447,'tl','',0),(16082,447,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(16083,447,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤­à¥à¤¨à¤¾à¤¯à¤¾',0),(16084,447,'ms','Tarikh yang ditunaikan',0),(16085,447,'ar','ØªØ§Ø±ÙŠØ® ØµØ±ÙÙ‡Ø§',0),(16086,447,'fr','Date encaissÃ©',0),(16087,447,'jp','æ?›é‡‘æ—¥',0),(16088,447,'pt','Data descontada',0),(16089,447,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ñ€Ð¸Ð·Ð¾Ð²Ñ‹Ðµ Ð¼ÐµÑÑ‚Ð°',0),(16090,447,'es','Fecha Cambiado',0),(16091,447,'de','Datum eingelÃ¶st',0),(16092,447,'en','Date Cashed',0),(16093,448,'is','',0),(16094,448,'dr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ù†Ù‚Ø¯Ø´Ø¯Ù† Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ \" ÙÙ‚Ø· Ù†Ù‚Ø¯ Ø´Ø¯Ù‡ Ù‡Ø§ Ø±Ø§ Ù†Ù…Ø§ÙŠØ´ Ø¯ÛŒÙˆÙ† Ø¯\"  Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(16095,448,'pr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ù†Ù‚Ø¯Ø´Ø¯Ù† Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ \" ÙÙ‚Ø· Ù†Ù‚Ø¯ Ø´Ø¯Ù‡ Ù‡Ø§ Ø±Ø§ Ù†Ù…Ø§ÙŠØ´ Ø¨Ø¯Ù‡ÙŠØ¯\"  Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(16096,448,'tr','Paraya tarihleri \"Show sadece para Ã¶dÃ¼lÃ¼\" grubu iÃ§in kullanÄ±lan',0),(16097,448,'pl','Terminy wypÅ‚aty stosowane dla grupy \"PokaÅ¼ tylko zrealizowane\"',0),(16098,448,'bg','Ð”Ð°Ñ‚Ð¸ Ð¾ÑÑ€ÐµÐ±Ñ€ÑÑ‚ Ð·Ð° \"ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¾ÑÑ€ÐµÐ±Ñ€ÑÑ‚\" Ð³Ñ€ÑƒÐ¿Ð°',0),(16099,448,'ur','Ø¨Ø¸Ø§ÛØ±Ø§Ù† ØªØ§Ø±ÛŒØ®ÛŒÚº Ú¯Ø±ÙˆÙ¾ \"Ø´Ùˆ ØµØ±Ù Ø¨Ø¸Ø§ÛØ±Ø§Ù†\" Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(16100,448,'sr','Ð”Ð°Ñ‚ÑƒÐ¼Ð¸ ÑƒÐ½Ð¾Ð²Ñ‡Ð¸Ð¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ñƒ \"ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÑƒÐ½Ð¾Ð²Ñ‡Ð¸Ð¾\"',0),(16101,448,'vi','dá»•i thÃ nh Tiá»n máº·t chá»‰ dÃ¹ng cho nhÃ³m \"Hiá»ƒn thá»‹ tiá»n máº·t\" ',0),(16102,448,'af','Datums Gewissel Gebruik vir \"Wys Alleenlik Gewisseldes\" Groep',0),(16103,448,'ro','Datele incasate pentru \"AratÄƒ numai Ã®ncasate\" grup',0),(16104,448,'et','Laekunud kuupÃ¤evad \"NÃ¤ita ainult sularahaks\" grupi jaoks kasutatav',0),(16105,448,'si','Sega vnovÄil uporablja za \"PrikaÅ¾i samo vnovÄil\" skupine',0),(16106,448,'ba','Tanggal menguangkan digunakan untuk kelompok \"Tampilkan hanya menguangkan\"',0),(16107,448,'nl','Datums geÃ¯ncasseerd gebruikt voor \"Toon alleen geÃ¯ncasseerd\" groep',0),(16108,448,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t lunastettu kÃ¤ytetÃ¤Ã¤n \"NÃ¤ytÃ¤ vain lunastaa\" ryhmÃ¤',0),(16109,448,'no','Datoer innlÃ¸ses brukes for \"Vis bare innlÃ¸ses\" gruppe',0),(16110,448,'da','Datoer indkasserede bruges til \"Vis kun indlÃ¸ses\" gruppe',0),(16111,448,'ko','ë‚ ì§œ í˜„ê¸ˆ \"í‘œì‹œë§Œ í˜„ê¸ˆ\" ê·¸ë£¹ì— ëŒ€ í•œ ì‚¬ìš©',0),(16112,448,'he','×ª××¨×™×›×™ ×¤×“×” ×”×ž×©×ž×© ×¢×‘×•×¨ ×§×‘×•×¦×ª \"×”×¦×’ ×¨×§ ×¤×“×”\"',0),(16113,448,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚ ÎµÎ¾Î±ÏÎ³Ï…ÏÏŽÏƒÎµÎ¹ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ \"Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ ÎµÎ¾Î±ÏÎ³Ï…ÏÏŽÏƒÎµÎ¹\" Î¿Î¼Î¬Î´Î±',0),(16114,448,'zh','ç”¨äºŽå…‘çŽ°æ—¥æœŸâ€œåªæ˜¾ç¤ºå…‘çŽ°â€œé›†å›¢\r\n',0),(16115,448,'sv','Datum inkasserades anvÃ¤nds fÃ¶r \"Visa endast inkasserades\" grupp',0),(16116,448,'it','Incassato i dati utilizzati per il gruppo \"Visualizza solo incassato\"',0),(16117,448,'tl','',0),(16118,448,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;&#3651;&#3594;&#3657;&#3586;&#3629;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617; \"&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&',0),(16119,448,'hi','à¤­à¥à¤¨à¤¾à¤¯à¤¾ à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤ \"à¤¶à¥‹ à¤¹à¥€ à¤­à¥à¤¨à¤¾à¤¯à¤¾\" à¤¸à¤®à¥‚à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(16120,448,'ms','Tarikh yang ditunaikan digunakan untuk Kumpulan \"Papar hanya ditunaikan\"',0),(16121,448,'ar','ØªÙˆØ§Ø±ÙŠØ® ØµØ±ÙÙ‡Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© \"Ø¥Ø¸Ù‡Ø§Ø± ÙÙ‚Ø· ØµØ±ÙØ©\"',0),(16122,448,'fr','Dates encaissÃ©s utilisÃ© pour Â« Voir la seulement encaissÃ©s Â» groupe',0),(16123,448,'jp','æ?›é‡‘æ—¥ã?¯â€œæ?›é‡‘æ¸ˆã?®ã?¿è¡¨ç¤ºâ€?ã‚°ãƒ«ãƒ¼ãƒ—ã?«ä½¿ç”¨ã?•ã‚Œã?¦ã?„ã?¾ã?™ã€‚',0),(16124,448,'pt','Datas descontadas usado para \"Mostrar apenas descontou\" grupo',0),(16125,448,'ru','Ð¡Ñ€Ð¾ÐºÐ¸ Ð¾Ð±Ð½Ð°Ð»Ð¸Ñ‡Ð¸Ñ‚ÑŒ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Â«ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ñ€Ð¸Ð·Ð¾Ð²Ñ‹Ðµ Ð¼ÐµÑÑ‚Ð°Â»',0),(16126,448,'es','Fechas Cambiados Usados para el Grupo \"Muestra Solo Cambiado\"',0),(16127,448,'de','Termine eingelÃ¶st verwendet fÃ¼r \"Show eingelÃ¶st nur\" Gruppe',0),(16128,448,'en','Dates Cashed Used for \"Show Only Cashed\" Group',0),(16129,449,'is','',0),(16130,449,'dr','ÙÙ‡Ø±Ø³Øª',0),(16131,449,'pr','ÙÙ‡Ø±Ø³Øª',0),(16132,449,'tr','Katalog',0),(16133,449,'pl','Katalog',0),(16134,449,'bg','ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³',0),(16135,449,'ur','Ø³Øª',0),(16136,449,'sr','ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³',0),(16137,449,'vi','catalo',0),(16138,449,'af','katalogus',0),(16139,449,'ro','Catalog',0),(16140,449,'et','kataloog',0),(16141,449,'si','Katalog',0),(16142,449,'ba','Katalog',0),(16143,449,'nl','catalogus',0),(16144,449,'fi','Verkkokauppa',0),(16145,449,'no','katalogen',0),(16146,449,'da','butik',0),(16147,449,'ko','ì¹´íƒˆë¡œê·¸',0),(16148,449,'he','×§×˜×œ×•×’',0),(16149,449,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚',0),(16150,449,'zh','ç›®å½•\r\n',0),(16151,449,'sv','Katalog',0),(16152,449,'it','Catalogo',0),(16153,449,'tl','',0),(16154,449,'th','&#3649;&#3588;&#3655;&#3605;&#3605;&#3634;&#3621;&#3655;&#3629;&#3585;',0),(16155,449,'hi','à¤•à¥ˆà¤Ÿà¤²à¥‰à¤—',0),(16156,449,'ms','Katalog',0),(16157,449,'ar','Ø§Ù„Ù†Ø´Ø±Ø© Ø§Ù„Ù…ØµÙˆØ±Ø©',0),(16158,449,'fr','Catalogue',0),(16159,449,'jp','ã‚«ã‚¿ãƒ­ã‚°',0),(16160,449,'pt','CatÃ¡logo',0),(16161,449,'ru','ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³',0),(16162,449,'es','CatÃ¡logo',0),(16163,449,'de','Katalog',0),(16164,449,'en','catalog',0),(16165,450,'is','',0),(16166,450,'dr','(Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(16167,450,'pr','Ø§Ù‚Ù„Ø§Ù…(Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(16168,450,'tr','Kategoriler',0),(16169,450,'pl','Kategorie',0),(16170,450,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(16171,450,'ur','Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(16172,450,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(16173,450,'vi','Thá»ƒ loáº¡i',0),(16174,450,'af','KategoriÃ« ',0),(16175,450,'ro','Categorii',0),(16176,450,'et','Kategooriad',0),(16177,450,'si','Kategorije',0),(16178,450,'ba','Kategori',0),(16179,450,'nl','CategorieÃ«n',0),(16180,450,'fi','Luokat',0),(16181,450,'no','Kategorier',0),(16182,450,'da','Kategorier',0),(16183,450,'ko','ì¹´í…Œê³ ë¦¬',0),(16184,450,'he','×§×˜×’×•×¨×™×•×ª',0),(16185,450,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(16186,450,'zh','åˆ†ç±»\r\n',0),(16187,450,'sv','Kategorier',0),(16188,450,'it','Categorie',0),(16189,450,'tl','',0),(16190,450,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(16191,450,'hi','à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(16192,450,'ms','Kategori',0),(16193,450,'ar','Ø§Ù„ØªØµÙ†ÙŠÙØ§Øª',0),(16194,450,'fr','CatÃ©gories',0),(16195,450,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(16196,450,'pt','Categorias',0),(16197,450,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(16198,450,'es','CategorÃ­as',0),(16199,450,'de','Kategorien',0),(16200,450,'en','Categories',0),(16201,451,'is','',0),(16202,451,'dr','Ú¯Ø±ÙˆÙ‡',0),(16203,451,'pr','Ú¯Ø±ÙˆÙ‡',0),(16204,451,'tr','Kategori',0),(16205,451,'pl','Kategoria',0),(16206,451,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(16207,451,'ur','Ø²Ù…Ø±Û',0),(16208,451,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(16209,451,'vi','Thá»ƒ Loáº¡i ',0),(16210,451,'af','Kategorie',0),(16211,451,'ro','Categorie',0),(16212,451,'et','Kategooria',0),(16213,451,'si','Kategorija',0),(16214,451,'ba','Kategori',0),(16215,451,'nl','Categorie',0),(16216,451,'fi','Luokka',0),(16217,451,'no','Kategori',0),(16218,451,'da','Kategori',0),(16219,451,'ko','ì¹´í…Œê³ ë¦¬',0),(16220,451,'he','×§×˜×’×•×¨×™×”',0),(16221,451,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(16222,451,'zh','åˆ†ç±»\r\n',0),(16223,451,'sv','Kategori',0),(16224,451,'it','Categoria',0),(16225,451,'tl','',0),(16226,451,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(16227,451,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€',0),(16228,451,'ms','Kategori',0),(16229,451,'ar','Ø§Ù„ØªØµÙ†ÙŠÙ',0),(16230,451,'fr','CatÃ©gorie',0),(16231,451,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(16232,451,'pt','Categoria',0),(16233,451,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(16234,451,'es','CategorÃ­a',0),(16235,451,'de','Kategorie',0),(16236,451,'en','Category',0),(16237,452,'is','',0),(16238,452,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(16239,452,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(16240,452,'tr','Kategori baÅŸarÄ±yla eklendi',0),(16241,452,'pl','Kategoria dodane pomyÅ›lnie',0),(16242,452,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(16243,452,'ur','Ø²Ù…Ø±Û Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(16244,452,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(16245,452,'vi','Thá»ƒ Loáº¡i thÃªm vÃ o thÃ nh cÃ´ng',0),(16246,452,'af','Kategorie suksesvol bygevoeg',0),(16247,452,'ro','Categoria adÄƒugat cu succes',0),(16248,452,'et','Kategooria edukalt lisatud',0),(16249,452,'si','UspeÅ¡no dodana Kategorija',0),(16250,452,'ba','Kategori ditambahkan berhasil',0),(16251,452,'nl','Categorie toegevoegd',0),(16252,452,'fi','Luokan lisÃ¤Ã¤minen onnistui',0),(16253,452,'no','Kategori lagt',0),(16254,452,'da','Kategori tilfÃ¸jet',0),(16255,452,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì¹´í…Œê³ ë¦¬',0),(16256,452,'he','×§×˜×’×•×¨×™×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(16257,452,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(16258,452,'zh','åˆ†ç±»æ·»åŠ æˆåŠŸ\r\n',0),(16259,452,'sv','Kategori lagts',0),(16260,452,'it','Categoria aggiunto con successo',0),(16261,452,'tl','',0),(16262,452,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(16263,452,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(16264,452,'ms','Kategori yang berjaya menambah',0),(16265,452,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„ØªØµÙ†ÙŠÙ Ø¨Ù†Ø¬Ø§Ø­',0),(16266,452,'fr','CatÃ©gorie ajoutÃ©e avec succÃ¨s',0),(16267,452,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(16268,452,'pt','Categoria adicionada com sucesso',0),(16269,452,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(16270,452,'es','CategorÃ­a agregada exitosamente',0),(16271,452,'de','Kategorie erfolgreich hinzugefÃ¼gt',0),(16272,452,'en','Category added successfully',0),(16273,453,'is','',0),(16274,453,'dr','- Ù„Ø·ÙØ§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯',0),(16275,453,'pr','Ú¯Ø±ÙˆÙ‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯- Ù„Ø·ÙØ§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯',0),(16276,453,'tr','Kategori zaten var, lÃ¼tfen yeniden deneyin.',0),(16277,453,'pl','Kategoria istnieje, proszÄ™ sprÃ³bowaÄ‡ ponownie.',0),(16278,453,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°, Ð¼Ð¾Ð»Ñ Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾.',0),(16279,453,'ur','Ø²Ù…Ø±Û Ù…ÛŒÚº Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’, Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº Û”',0),(16280,453,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸, Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾.',0),(16281,453,'vi','Thá»ƒ Loáº¡i Ä‘Ã£ tá»“n táº¡i, thá»­ láº¡i láº§n ná»¯a',0),(16282,453,'af','Kategorie bestaan alreeds, probeer asseblief weer.',0),(16283,453,'ro','Categorie existÄƒ deja, vÄƒ rugÄƒm sÄƒ Ã®ncercaÅ£i din nou.',0),(16284,453,'et','Kategooria on olemas, palun proovige uuesti',0),(16285,453,'si','Kategorija Å¾e obstaja, poskusite znova.',0),(16286,453,'ba','Kategori sudah ada, silakan coba lagi.',0),(16287,453,'nl','Categorie reeds bestaat, gelieve opnieuw te proberen.',0),(16288,453,'fi','Luokka on jo olemassa, yritÃ¤ uudelleen.',0),(16289,453,'no','Det finnes allerede en kategori, prÃ¸v igjen.',0),(16290,453,'da','Kategori findes allerede, kan du prÃ¸ve igen.',0),(16291,453,'ko','ì¹´í…Œê³ ë¦¬ëŠ” ì´ë¯¸ ì¡´ìž¬, ë‹¤ì‹œ ì‹œë„ í•˜ì‹­ì‹œì˜¤.',0),(16292,453,'he','×§×˜×’×•×¨×™×” ×›×‘×¨ ×§×™×™×, ×× × × ×¡×” ×©× ×™×ª.',0),(16293,453,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î®Î´Î· Ï…Ï€Î¬ÏÏ‡ÎµÎ¹, Ï€Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬.',0),(16294,453,'zh','ç±»åˆ«å·²å­˜åœ¨ï¼Œè¯·å†è¯•ä¸€æ¬¡',0),(16295,453,'sv','Kategori existerar redan, fÃ¶rsÃ¶k vÃ¤nligen igen.',0),(16296,453,'it','Categoria esiste giÃ , riprovare.',0),(16297,453,'tl','',0),(16298,453,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3609;&#3637;&#3657;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623; &#3585;&#3619;&#3640;&#3603;&#3634;&#3621;&#3629;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(16299,453,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ, à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚à¥¤',0),(16300,453,'ms','Kategori sudah ada, sila cuba lagi.',0),(16301,453,'ar','Ø§Ù„ØªØµÙ†ÙŠÙ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(16302,453,'fr','CatÃ©gorie existe dÃ©jÃ , veuillez rÃ©essayer.',0),(16303,453,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œæ—¢ã?«å­˜åœ¨ã?—ã?¾ã?™ã€?ã‚‚ã?†ä¸€åº¦å…¥åŠ›ã?—ã?¦ä¸‹ã?•ã?„',0),(16304,453,'pt','Categoria jÃ¡ existe, por favor tente novamente.',0),(16305,453,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÑƒÐ¶Ðµ ÑÐ¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ÑÑ, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÑÐ½Ð¾Ð²Ð°.',0),(16306,453,'es','CategorÃ­a ya existe, por favor intenta otra vez',0),(16307,453,'de','Bereits vorhanden ist, versuchen Sie es erneut.',0),(16308,453,'en','Category already exists, please try again.',0),(16309,454,'is','',0),(16310,454,'dr','Ú¯Ø±ÙˆÙ‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù…  ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(16311,454,'pr','Ú¯Ø±ÙˆÙ‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù…  ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(16312,454,'tr','Kategori bu isimde zaten',0),(16313,454,'pl','Kategoria istnieje pod tÄ… nazwÄ…',0),(16314,454,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ñ Ñ‚Ð¾Ð²Ð° Ð¸Ð¼Ðµ',0),(16315,454,'ur','Ø²Ù…Ø±Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø³ Ú©Ø§ Ù†Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(16316,454,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð¿Ð¾Ð´ Ñ‚Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼',0),(16317,454,'vi','TÃªn Thá»ƒ Loáº¡i nÃ y Ä‘Ã£ tá»“n táº¡i ',0),(16318,454,'af','Kategorie bestaan alreeds met daardie naam',0),(16319,454,'ro','Categorie existÄƒ deja cÄƒ numele de',0),(16320,454,'et','Sellise nimga kategooria on olemas',0),(16321,454,'si','Kategorija Å¾e obstaja s tem imenom',0),(16322,454,'ba','Kategori sudah ada menurut nama',0),(16323,454,'nl','Categorie bestaat al met die naam',0),(16324,454,'fi','Luokka on jo olemassa samanniminen',0),(16325,454,'no','Kategori finnes allerede med det navnet',0),(16326,454,'da','Kategori findes allerede med navnet',0),(16327,454,'ko','ì¹´í…Œê³ ë¦¬ëŠ” ì´ë¯¸ ê·¸ ì´ë¦„ìœ¼ë¡œ ì¡´ìž¬',0),(16328,454,'he','×›×‘×¨ ×§×™×™×ž×ª ×§×˜×’×•×¨×™×” ×¢× ××•×ª×• ×©×',0),(16329,454,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(16330,454,'zh','ç±»åˆ«å·²å­˜åœ¨è¯¥åç§°çš„\r\n',0),(16331,454,'sv','Kategori finns redan med det namnet',0),(16332,454,'it','Categoria esiste giÃ  con quel nome',0),(16333,454,'tl','',0),(16334,454,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3609;&#3637;&#3657;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;&#3650;&#3604;&#3618;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3594;&#3639;&#3656;&#3629;&#3609;&#3637;&#3',0),(16335,454,'hi','à¤µà¤°à¥à¤— à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‰à¤¸ à¤¨à¤¾à¤® à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(16336,454,'ms','Kategori telah wujud dengan nama itu',0),(16337,454,'ar','Ø§Ù„ØªØµÙ†ÙŠÙ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§ Ø¨Ù‡Ø°Ø§ Ø§Ù„Ø¥Ø³Ù…',0),(16338,454,'fr','CatÃ©gorie existe dÃ©jÃ  sous ce nom',0),(16339,454,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œã??ã?®å??å‰?ã?§ã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(16340,454,'pt','Categoria jÃ¡ existe com esse nome',0),(16341,454,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ñ Ñ‚Ð°ÐºÐ¸Ð¼ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸ÐµÐ¼ ÑƒÐ¶Ðµ ÑÐ¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ÑÑ',0),(16342,454,'es','CategorÃ­a ya existe por este nombre',0),(16343,454,'de','Kategorie ist mit diesem Namen bereits vorhanden.',0),(16344,454,'en','Category already exists by that name',0),(16345,455,'is','',0),(16346,455,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(16347,455,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(16348,455,'tr','Kategori baÅŸarÄ±yla silindi',0),(16349,455,'pl','Kategoria przesâ”‚anie',0),(16350,455,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(16351,455,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø²Ù…Ø±Û',0),(16352,455,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(16353,455,'vi','XÃ³a Thá»ƒ Loáº¡i thÃ nh cÃ´ng',0),(16354,455,'af','Kategorie suksesvol geskrap',0),(16355,455,'ro','Categorie ÅŸtearsÄƒ cu succes',0),(16356,455,'et','Kategooria kustutati edukalt',0),(16357,455,'si','Kategorije, uspeÅ¡no izbrisana',0),(16358,455,'ba','Kategori dihapus berhasil',0),(16359,455,'nl','Categorie verwijderd',0),(16360,455,'fi','Luokka poistettu',0),(16361,455,'no','Kategori slettet',0),(16362,455,'da','Kategori slettet',0),(16363,455,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë²”ì£¼',0),(16364,455,'he','×§×˜×’×•×¨×™×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(16365,455,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(16366,455,'zh','åˆ†ç±»åˆ é™¤æˆåŠŸ\r\n',0),(16367,455,'sv','Kategori raderades',0),(16368,455,'it','Categoria eliminato con successo',0),(16369,455,'tl','',0),(16370,455,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(16371,455,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(16372,455,'ms','Kategori dihapuskan dengan jayanya',0),(16373,455,'ar','Ø­Ø°Ù Ø§Ù„ØªØµÙ†ÙŠÙ Ø¨Ù†Ø¬Ø§Ø­',0),(16374,455,'fr','CatÃ©gorie supprimÃ©e avec succÃ¨s',0),(16375,455,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(16376,455,'pt','Categoria apagada com sucesso',0),(16377,455,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð°',0),(16378,455,'es','CategorÃ­a eliminada exitosamente',0),(16379,455,'de','Kategorie erfolgreich gelÃ¶scht',0),(16380,455,'en','Category deleted successfully',0),(16381,456,'is','',0),(16382,456,'dr','Ú¯Ø±ÙˆÙ‡ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(16383,456,'pr','Ú¯Ø±ÙˆÙ‡ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(16384,456,'tr','DÃ¼zenlemek iÃ§in kategori seÃ§in',0),(16385,456,'pl','Wybierz kategoriÄ™, aby edytowaÄ‡',0),(16386,456,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(16387,456,'ur','Ø²Ù…Ø±Û ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(16388,456,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÑ€ÐµÐ´Ð¸Ð»Ð¸',0),(16389,456,'vi','Chá»n thá»ƒ loáº¡i cáº§n sá»­a',0),(16390,456,'af','Selekteer Kategorie om te Redigeer',0),(16391,456,'ro','SelectaÅ£i categoria pentru a edita',0),(16392,456,'et','Vali kategooria muutmiseks',0),(16393,456,'si','Izberite kategorijo za urejanje',0),(16394,456,'ba','Pilih kategori untuk mengedit',0),(16395,456,'nl','Selecteer categorie bewerken',0),(16396,456,'fi','Valitse muokattava luokka',0),(16397,456,'no','Velg kategorien redigere',0),(16398,456,'da','VÃ¦lg kategori for at redigere',0),(16399,456,'ko','ë²”ì£¼ íŽ¸ì§‘ë¥¼ ì„ íƒí•©ë‹ˆë‹¤',0),(16400,456,'he','×‘×—×¨ ×§×˜×’×•×¨×™×” ×›×“×™ ×œ×¢×¨×•×š',0),(16401,456,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î³Î¹Î± Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(16402,456,'zh','é€‰æ‹©åˆ†ç±»ç¼–è¾‘\r\n',0),(16403,456,'sv','VÃ¤lj kategori fÃ¶r att redigera',0),(16404,456,'it','Selezionare la categoria modifica',0),(16405,456,'tl','',0),(16406,456,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(16407,456,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(16408,456,'ms','Pilih kategori untuk mengedit',0),(16409,456,'ar','Ø¥Ø®ØªØ± ØªØµÙ†ÙŠÙØ§ Ù„Ù„ØªØ­Ø±ÙŠØ±',0),(16410,456,'fr','SÃ©lectionnez la catÃ©gorie Ã  modifier',0),(16411,456,'jp','ç·¨é›†ã?™ã‚‹ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’é?¸æŠž',0),(16412,456,'pt','Selecione a categoria para editar',0),(16413,456,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ Ð´Ð»Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(16414,456,'es','Seleccionar CategorÃ­a para Editar',0),(16415,456,'de','WÃ¤hlen Sie Kategorie bearbeiten',0),(16416,456,'en','Select Category to Edit',0),(16417,457,'is','',0),(16418,457,'dr','Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡',0),(16419,457,'pr','Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡',0),(16420,457,'tr','Kategori adÄ±',0),(16421,457,'pl','Nazwa kategorii',0),(16422,457,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(16423,457,'ur','Ù‚Ø³Ù… Ú©Ø§ Ù†Ø§Ù…',0),(16424,457,'sr','Ð˜Ð¼Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(16425,457,'vi','TÃªn thá»ƒ loáº¡i',0),(16426,457,'af','Kategorie Naam',0),(16427,457,'ro','Numele categoriei',0),(16428,457,'et','Kategooria nimi',0),(16429,457,'si','Ime kategorije',0),(16430,457,'ba','Nama kategori',0),(16431,457,'nl','Categorienaam',0),(16432,457,'fi','Luokkanimi',0),(16433,457,'no','Kategorinavn',0),(16434,457,'da','Kategorinavn',0),(16435,457,'ko','ì¹´í…Œê³ ë¦¬ ì´ë¦„',0),(16436,457,'he','×©× ×”×§×˜×’×•×¨×™×”',0),(16437,457,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚',0),(16438,457,'zh','åˆ†ç±»åç§°\r\n',0),(16439,457,'sv','Kategorinamn',0),(16440,457,'it','Nome categoria',0),(16441,457,'tl','',0),(16442,457,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(16443,457,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¨à¤¾à¤®',0),(16444,457,'ms','Nama kategori',0),(16445,457,'ar','Ø¥Ø³Ù… Ø§Ù„ØªØµÙ†ÙŠÙ',0),(16446,457,'fr','Nom de la catÃ©gorie',0),(16447,457,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼å??',0),(16448,457,'pt','Nome da categoria',0),(16449,457,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(16450,457,'es','CategorÃ­a Nombre',0),(16451,457,'de','Kategorienamen',0),(16452,457,'en','Category Name',0),(16453,458,'is','',0),(16454,458,'dr','Ú¯Ø±ÙˆÙ‡ ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(16455,458,'pr','Ú¯Ø±ÙˆÙ‡ ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(16456,458,'tr','Kategori bulunamadÄ±',0),(16457,458,'pl','Kategoria nie znaleziono',0),(16458,458,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÑ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð°',0),(16459,458,'ur','Ø²Ù…Ø±Û Ù†ÛÛŒÚº Ù…Ù„',0),(16460,458,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°',0),(16461,458,'vi','KhÃ´ng tÃ¬m tháº¥y thá»ƒ loáº¡i',0),(16462,458,'af','Kategorie Nie Gevind',0),(16463,458,'ro','Categorie nu a fost gÄƒsit',0),(16464,458,'et','Kategooriat ei leitud',0),(16465,458,'si','Kategorije ni bilo mogoÄe najti',0),(16466,458,'ba','Kategori tidak ditemukan',0),(16467,458,'nl','Categorie niet gevonden',0),(16468,458,'fi','Luokkaa ei lÃ¶ydy',0),(16469,458,'no','Kategori ikke funnet',0),(16470,458,'da','Kategori ikke fundet',0),(16471,458,'ko','ë²”ì£¼ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(16472,458,'he','×§×˜×’×•×¨×™×” ×œ× × ×ž×¦×',0),(16473,458,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(16474,458,'zh','åˆ†ç±»æœªæ‰¾åˆ°\r\n',0),(16475,458,'sv','Kategori hittades inte',0),(16476,458,'it','Categoria non trovata',0),(16477,458,'tl','',0),(16478,458,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(16479,458,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€',0),(16480,458,'ms','Kategori yang tidak dijumpai',0),(16481,458,'ar','Ø§Ù„ØªØµÙ†ÙŠÙ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(16482,458,'fr','CatÃ©gorie introuvable',0),(16483,458,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œã?¿ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(16484,458,'pt','Categoria nÃ£o encontrada',0),(16485,458,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ð°',0),(16486,458,'es','CategorÃ­a No se EncontrÃ³',0),(16487,458,'de','Kategorie nicht gefunden',0),(16488,458,'en','Category Not Found',0),(16489,459,'is','',0),(16490,459,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(16491,459,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(16492,459,'tr','Kategori baÅŸarÄ±yla kaydedildi',0),(16493,459,'pl','Kategoria zapisane',0),(16494,459,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(16495,459,'ur','Ø²Ù…Ø±Û Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(16496,459,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(16497,459,'vi','Thá»ƒ loáº¡i sao lÆ°u thÃ nh cÃ´ng',0),(16498,459,'af','Kategorie suksesvol gestoor',0),(16499,459,'ro','Categoria salvat cu succes',0),(16500,459,'et','Kategooria edukalt salvestatud',0),(16501,459,'si','Kategorije, uspeÅ¡no shranjen',0),(16502,459,'ba','Kategori disimpan berhasil',0),(16503,459,'nl','Categorie opgeslagen',0),(16504,459,'fi','Tallennettu luokkaan',0),(16505,459,'no','Kategori lagret',0),(16506,459,'da','Kategori gemt med succes',0),(16507,459,'ko','ì¹´í…Œê³ ë¦¬ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(16508,459,'he','×§×˜×’×•×¨×™×” ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(16509,459,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(16510,459,'zh','åˆ†ç±»ä¿å­˜æˆåŠŸ\r\n',0),(16511,459,'sv','Kategori sparats',0),(16512,459,'it','Categoria salvato correttamente',0),(16513,459,'tl','',0),(16514,459,'th','&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(16515,459,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(16516,459,'ms','Kategori yang berjaya disimpan',0),(16517,459,'ar','Ø­ÙØ¸ Ø§Ù„ØªØµÙ†ÙŠÙ Ø¨Ù†Ø¬Ø§Ø­',0),(16518,459,'fr','CatÃ©gorie enregistrÃ© avec succÃ¨s',0),(16519,459,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(16520,459,'pt','Categoria com sucesso',0),(16521,459,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð°',0),(16522,459,'es','CategorÃ­a guardada exitosamente',0),(16523,459,'de','Kategorie erfolgreich gespeichert',0),(16524,459,'en','Category saved successfully',0),(16525,460,'is','',0),(16526,460,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(16527,460,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(16528,460,'tr','Kategori baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(16529,460,'pl','Kategoria zostaâ”‚a zaktualizowana',0),(16530,460,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(16531,460,'ur','Ø²Ù…Ø±Û Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(16532,460,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(16533,460,'vi','Cáº­p Nháº­t Thá»ƒ Loáº¡i ThÃ nh CÃ´ng',0),(16534,460,'af','Kategorie suksesvol opdateer',0),(16535,460,'ro','Categoria actualizat cu succes',0),(16536,460,'et','Kategooria vÃ¤rskendatud',0),(16537,460,'si','Kategorije, uspeÅ¡no posodobljena',0),(16538,460,'ba','Kategori berhasil',0),(16539,460,'nl','Categorie bijgewerkt',0),(16540,460,'fi','Luokka pÃ¤ivitetty',0),(16541,460,'no','Kategori oppdatert',0),(16542,460,'da','Kategori opdateret',0),(16543,460,'ko','ì¹´í…Œê³ ë¦¬ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(16544,460,'he','×§×˜×’×•×¨×™×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(16545,460,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(16546,460,'zh','åˆ†ç±»æ›´æ–°æˆåŠŸ\r\n',0),(16547,460,'sv','Kategori uppdaterats',0),(16548,460,'it','Categoria aggiornato con successo',0),(16549,460,'tl','',0),(16550,460,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(16551,460,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(16552,460,'ms','Kategori yang berjaya dikemas kini',0),(16553,460,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„ØªØµÙ†ÙŠÙ Ø¨Ù†Ø¬Ø§Ø­',0),(16554,460,'fr','CatÃ©gorie mise Ã  jour avec succÃ¨s',0),(16555,460,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(16556,460,'pt','Categoria atualizada com sucesso',0),(16557,460,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(16558,460,'es','CategorÃ­a grabada exitosamente',0),(16559,460,'de','Kategorie erfolgreich aktualisiert',0),(16560,460,'en','Category updated successfully',0),(16561,461,'is','',0),(16562,461,'dr','(Ø­ÙØ±Ù‡',0),(16563,461,'pr','Ø¹Ù…Ù‚ Ú¯ÙˆØ¯Ø§Ù„(Ø­ÙØ±Ù‡',0),(16564,461,'tr','BoÅŸluk derinliÄŸi',0),(16565,461,'pl','GÅ‚Ä™bokoÅ›Ä‡ jamy',0),(16566,461,'bg','ÐšÑƒÑ…Ð¸Ð½Ð° Ð´ÑŠÐ»Ð±Ð¾Ñ‡Ð¸Ð½Ð°',0),(16567,461,'ur','Ø±Ø®Ù†Û Ú¯ÛØ±Ø§Ø¦ÛŒ',0),(16568,461,'sr','Ð£Ð´ÑƒÐ±Ñ™ÐµÑšÐµ',0),(16569,461,'vi','Chiá»u sÃ¢u lá»— há»•ng',0),(16570,461,'af','Holte diepte',0),(16571,461,'ro','Profunzimea cavitatii',0),(16572,461,'et','SÃ¼vend sÃ¼gavus',0),(16573,461,'si','Votlini globina',0),(16574,461,'ba','Kedalaman rongga',0),(16575,461,'nl','Holte diepte',0),(16576,461,'fi','Onkalo syvyys',0),(16577,461,'no','Hulrom dybde',0),(16578,461,'da','Hulrum dybde',0),(16579,461,'ko','êµ¬ë© ê¹Šì´',0),(16580,461,'he','×¢×•×ž×§ ×—×œ×œ',0),(16581,461,'el','Î¤Î¿ Î²Î¬Î¸Î¿Ï‚ ÎºÎ¿Î¹Î»ÏŒÏ„Î·Ï„Î±Ï‚',0),(16582,461,'zh','æ¨¡æ§½æ·±åº¦\r\n',0),(16583,461,'sv','HÃ¥lighet djup',0),(16584,461,'it','ProfonditÃ  cavitÃ ',0),(16585,461,'tl','',0),(16586,461,'th','&#3588;&#3623;&#3634;&#3617;&#3621;&#3638;&#3585;&#3586;&#3629;&#3591;&#3594;&#3656;&#3629;&#3591;\n',0),(16587,461,'hi','à¤—à¥à¤¹à¤¾ à¤—à¤¹à¤°à¤¾à¤ˆ',0),(16588,461,'ms','Kedalaman rongga',0),(16589,461,'ar','Ø¹Ù…Ù‚ Ø§Ù„ØªØ¬ÙˆÙŠÙ',0),(16590,461,'fr','Profondeur de la cavitÃ©',0),(16591,461,'jp','Cavity Depth',0),(16592,461,'pt','Profundidade da cavidade',0),(16593,461,'ru','Ð“Ð»ÑƒÐ±Ð¸Ð½Ð° Ð¿Ð¾Ð»Ð¾ÑÑ‚Ð¸',0),(16594,461,'es','Cavidad Profundidad',0),(16595,461,'de','Hohlraum-Tiefe',0),(16596,461,'en','Cavity Depth',0),(16597,462,'is','',0),(16598,462,'dr','(Ø­ÙØ±Ù‡',0),(16599,462,'pr','Ø´ÙƒÙ„ Ú¯ÙˆØ¯Ø§Ù„(Ø­ÙØ±Ù‡',0),(16600,462,'tr','Kavite ÅŸekli',0),(16601,462,'pl','KsztaÅ‚t jamy',0),(16602,462,'bg','ÐšÑƒÑ…Ð¸Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°',0),(16603,462,'ur','Ø¬ÙˆÙ Ø´Ú©Ù„',0),(16604,462,'sr','ÐžÐ±Ð»Ð¸Ðº ÑˆÑƒÐ¿Ñ™Ð¸Ð½Ðµ',0),(16605,462,'vi','HÃ¬nh dÃ¡ng lá»— há»•ng',0),(16606,462,'af','Holte vorm',0),(16607,462,'ro','Cavitatea formei',0),(16608,462,'et','SÃ¼vend kuju',0),(16609,462,'si','Votlino obliko',0),(16610,462,'ba','Bentuk rongga',0),(16611,462,'nl','Holte vorm',0),(16612,462,'fi','Ontelon muoto',0),(16613,462,'no','Hulrom figur',0),(16614,462,'da','Hulrum form',0),(16615,462,'ko','êµ¬ë© ëª¨ì–‘',0),(16616,462,'he','×¦×•×¨×ª ×—×œ×œ',0),(16617,462,'el','Î£Ï‡Î®Î¼Î± ÎºÎ¿Î¹Î»ÏŒÏ„Î·Ï„Î±Ï‚',0),(16618,462,'zh','æ¨¡æ§½å½¢çŠ¶\r\n',0),(16619,462,'sv','HÃ¥lighet form',0),(16620,462,'it','Forma di cavitÃ ',0),(16621,462,'tl','',0),(16622,462,'th','&#3619;&#3641;&#3611;&#3619;&#3656;&#3634;&#3591;&#3586;&#3629;&#3591;&#3594;&#3656;&#3629;&#3591;',0),(16623,462,'hi','à¤—à¥à¤¹à¤¾ à¤†à¤•à¥ƒà¤¤à¤¿',0),(16624,462,'ms','Bentuk rongga',0),(16625,462,'ar','Ø´ÙƒÙ„ Ø§Ù„ØªØ¬ÙˆÙŠÙ',0),(16626,462,'fr','Forme de la cavitÃ©',0),(16627,462,'jp','Cavity Shape',0),(16628,462,'pt','Forma de cavidade',0),(16629,462,'ru','Ð¤Ð¾Ñ€Ð¼Ð° Ð¿Ð¾Ð»Ð¾ÑÑ‚Ð¸',0),(16630,462,'es','Cavidad Forma',0),(16631,462,'de','Hohlraum-Form',0),(16632,462,'en','Cavity Shape',0),(16633,463,'is','',0),(16634,463,'dr','(Ø­ÙØ±Ù‡',0),(16635,463,'pr','Ù¾Ù‡Ù†Ø§ÙŠ Ú¯ÙˆØ¯Ø§Ù„(Ø­ÙØ±Ù‡',0),(16636,463,'tr','BoÅŸluk geniÅŸliÄŸi',0),(16637,463,'pl','SzerokoÅ›Ä‡ wnÄ™ki',0),(16638,463,'bg','ÐšÑƒÑ…Ð¸Ð½Ð° ÑˆÐ¸Ñ€Ð¸Ð½Ð°',0),(16639,463,'ur','Ø±Ø®Ù†Û Ú†ÙˆÚ‘Ø§Ø¦ÛŒ',0),(16640,463,'sr','Ð¨Ð¸Ñ€Ð¸Ð½Ð° ÑˆÑƒÐ¿Ñ™Ð¸Ð½Ðµ',0),(16641,463,'vi','Chiá»u rá»™ng lá»— há»•ng',0),(16642,463,'af','Holte Breedte',0),(16643,463,'ro','Cavitatea lÄƒÅ£ime',0),(16644,463,'et','SÃ¼vend laius',0),(16645,463,'si','Å irina votlino',0),(16646,463,'ba','Rongga lebar',0),(16647,463,'nl','Holte breedte',0),(16648,463,'fi','Onkalo leveys',0),(16649,463,'no','Hulrom bredde',0),(16650,463,'da','Hulrum bredde',0),(16651,463,'ko','êµ¬ë© í­',0),(16652,463,'he','×¨×•×—×‘ ×—×œ×œ',0),(16653,463,'el','Î Î»Î¬Ï„Î¿Ï‚ ÎºÎ¿Î¹Î»ÏŒÏ„Î·Ï„Î±',0),(16654,463,'zh','æ¨¡æ§½å®½åº¦\r\n',0),(16655,463,'sv','HÃ¥lighet bredd',0),(16656,463,'it','Larghezza cavitÃ ',0),(16657,463,'tl','',0),(16658,463,'th','&#3588;&#3623;&#3634;&#3617;&#3585;&#3623;&#3657;&#3634;&#3591;&#3586;&#3629;&#3591;&#3594;&#3656;&#3629;&#3591;',0),(16659,463,'hi','à¤—à¥à¤¹à¤¾ à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ',0),(16660,463,'ms','Lebar rongga',0),(16661,463,'ar','Ø¹Ø±Ø¶ ØªØ¬ÙˆÙŠÙ',0),(16662,463,'fr','Largeur de la cavitÃ©',0),(16663,463,'jp','Cavity Width',0),(16664,463,'pt','Largura da cavidade',0),(16665,463,'ru','Ð¨Ð¸Ñ€Ð¸Ð½Ð° Ð¿Ð¾Ð»Ð¾ÑÑ‚Ð¸',0),(16666,463,'es','Cavidad Anchura',0),(16667,463,'de','Hohlraum-Breite',0),(16668,463,'en','Cavity Width',0),(16669,464,'is','',0),(16670,464,'dr','Ù†Ø§Ù… Ø±ÙˆÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(16671,464,'pr','Ù†Ø§Ù… Ø±ÙˆÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(16672,464,'tr','Kredi kartÄ±nÄ±n',0),(16673,464,'pl','Nazwisko na karcie kredytowej',0),(16674,464,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(16675,464,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù¾Ø± Ù†Ø§Ù…',0),(16676,464,'sr','Ð˜Ð¼Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ñ˜ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¸',0),(16677,464,'vi','TÃªn trÃªn tháº» tÃ­n dá»¥ng',0),(16678,464,'af','Naam op Kredietkaart',0),(16679,464,'ro','Numele de pe cardul de Credit',0),(16680,464,'et','Nimi krediitkaardi',0),(16681,464,'si','Ime na kreditni kartici',0),(16682,464,'ba','Nama pada kartu kredit',0),(16683,464,'nl','Naam op creditcard',0),(16684,464,'fi','Nimi luottokortilla',0),(16685,464,'no','Navn pÃ¥ kredittkort',0),(16686,464,'da','Navn pÃ¥ kreditkort',0),(16687,464,'ko','ì‹ ìš© ì¹´ë“œ ìƒì˜ ì´ë¦„',0),(16688,464,'he','×”×©× ×¢×œ ×›×¨×˜×™×¡ ×”××©×¨××™',0),(16689,464,'el','ÎŒÎ½Î¿Î¼Î± ÏƒÏ„Î·Î½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(16690,464,'zh','ä¿¡ç”¨å¡ä¸Šçš„å§“å\r\n',0),(16691,464,'sv','Namn pÃ¥ kreditkort',0),(16692,464,'it','Nome sulla carta di credito',0),(16693,464,'tl','',0),(16694,464,'th','&#3594;&#3639;&#3656;&#3629;&#3610;&#3609;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(16695,464,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤ªà¤° à¤¨à¤¾à¤®',0),(16696,464,'ms','Nama pada kad kredit',0),(16697,464,'ar','Ø§Ù„Ø§Ø³Ù… Ø¹Ù„Ù‰ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(16698,464,'fr','Nom sur carte de crÃ©dit',0),(16699,464,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰å??ç¾©',0),(16700,464,'pt','Nome no cartÃ£o de crÃ©dito',0),(16701,464,'ru','Ð˜Ð¼Ñ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ðµ',0),(16702,464,'es','Nombre en la Tarjeta de CrÃ©dito',0),(16703,464,'de','Name auf der Kreditkarte',0),(16704,464,'en','Name on Credit Card',0),(16705,465,'is','',0),(16706,465,'dr','Ø³Ù†Øª Ú©Ù‡ Ù…Ø¹Ø§Ø¯Ù„ ÙŠÚ© ØµØ¯Ù… Ø¯Ù„Ø§Ø± Ø§Ù…Ø±ÙŠÚ©Ø§ÙŠÙ‰ Ø§Ø³Øª ',0),(16707,465,'pr','Ø³Ù†Øª Ú©Ù‡ Ù…Ø¹Ø§Ø¯Ù„ ÙŠÚ© ØµØ¯Ù… Ø¯Ù„Ø§Ø± Ø§Ù…Ø±ÙŠÚ©Ø§ÙŠÙ‰ Ø§Ø³Øª ',0),(16708,465,'tr','sent',0),(16709,465,'pl','centÃ³w',0),(16710,465,'bg','Ñ†ÐµÐ½Ñ‚Ð°',0),(16711,465,'ur','Ø³ÛŒÙ†Ù¹',0),(16712,465,'sr','Ñ†ÐµÐ½Ñ‚Ð¸',0),(16713,465,'vi','xu',0),(16714,465,'af','sente',0),(16715,465,'ro','cenÅ£i',0),(16716,465,'et','senti',0),(16717,465,'si','centa',0),(16718,465,'ba','sen',0),(16719,465,'nl','cent',0),(16720,465,'fi','senttiÃ¤',0),(16721,465,'no','cent',0),(16722,465,'da','cent',0),(16723,465,'ko','ì„¼íŠ¸',0),(16724,465,'he','×¡× ×˜',0),(16725,465,'el','ÏƒÎµÎ½Ï„',0),(16726,465,'zh','åˆ†\r\n',0),(16727,465,'sv','cent',0),(16728,465,'it','centesimi',0),(16729,465,'tl','',0),(16730,465,'th','&#3627;&#3609;&#3638;&#3656;&#3591;&#3651;&#3609;&#3619;&#3657;&#3629;&#3618;',0),(16731,465,'hi','à¤¸à¥‡à¤‚à¤Ÿ',0),(16732,465,'ms','sen',0),(16733,465,'ar','Ø³Ù†ØªØ§',0),(16734,465,'fr','cents',0),(16735,465,'jp','ã‚»ãƒ³ãƒˆ',0),(16736,465,'pt','centavos',0),(16737,465,'ru','Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(16738,465,'es','centavos',0),(16739,465,'de','Cent',0),(16740,465,'en','cents',0),(16741,466,'is','',0),(16742,466,'dr','ØªØºÙŠÙŠØ± Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµÙØ­Ù‡',0),(16743,466,'pr','ØªØºÙŠÙŠØ± Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµÙØ­Ù‡',0),(16744,466,'tr','Sayfa boyutunu deÄŸiÅŸtir',0),(16745,466,'pl','ZmieniÄ‡ rozmiar strony',0),(16746,466,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€Ð° Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(16747,466,'ur','ØµÙØ­Û Ø³Ø§Ø¦Ø² ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(16748,466,'sr','ÐœÐµÑšÐ°ÑšÐµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(16749,466,'vi','Thay Ä‘á»•i cá»¡ trang',0),(16750,466,'af','Verander Bladsy Grootte',0),(16751,466,'ro','Schimba dimensiunea paginii',0),(16752,466,'et','LehekÃ¼lje suuruse muutmine',0),(16753,466,'si','Spremeni velikost strani',0),(16754,466,'ba','Mengubah ukuran halaman',0),(16755,466,'nl','Paginaformaat wijzigen',0),(16756,466,'fi','Muuta sivun kokoa',0),(16757,466,'no','Endre sidestÃ¸rrelse',0),(16758,466,'da','Ã†ndre sidestÃ¸rrelse',0),(16759,466,'ko','íŽ˜ì´ì§€ í¬ê¸° ë³€ê²½',0),(16760,466,'he','×©×™× ×•×™ ×’×•×“×œ ×¢×ž×•×“',0),(16761,466,'el','Î‘Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚ ÏƒÎµÎ»Î¯Î´Î±Ï‚',0),(16762,466,'zh','æ›´æ”¹é¡µé¢å°ºå¯¸\r\n',0),(16763,466,'sv','Ã„ndra sidstorlek',0),(16764,466,'it','Modificare le dimensioni della pagina',0),(16765,466,'tl','',0),(16766,466,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3586;&#3609;&#3634;&#3604;&#3627;&#3609;&#3657;&#3634;',0),(16767,466,'hi','à¤ªà¥ƒà¤·à¥à¤  à¤•à¤¾ à¤†à¤•à¤¾à¤° à¤¬à¤¦à¤²à¥‡à¤‚',0),(16768,466,'ms','Tukar saiz muka',0),(16769,466,'ar','ØªØºÙŠÙŠØ± Ø­Ø¬Ù… Ø§Ù„ØµÙØ­Ø©',0),(16770,466,'fr','Modifier la taille de Page',0),(16771,466,'jp','ãƒšãƒ¼ã‚¸ã‚µã‚¤ã‚ºã?®å¤‰æ›´',0),(16772,466,'pt','Alterar tamanho da pÃ¡gina',0),(16773,466,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð Ð°Ð·Ð¼ÐµÑ€ Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹',0),(16774,466,'es','Cambiar TamaÃ±o de PÃ¡gina',0),(16775,466,'de','Seitenformat Ã¤ndern',0),(16776,466,'en','Change Page Size',0),(16777,467,'is','',0),(16778,467,'dr','ØªØºÙŠÙŠØ± Ú¯Ø²ÙŠÙ†Ø´ Ù‡Ø§',0),(16779,467,'pr','ØªØºÙŠÙŠØ± Ú¯Ø²ÙŠÙ†Ø´ Ù‡Ø§',0),(16780,467,'tr','SeÃ§imlerini DeÄŸiÅŸtir',0),(16781,467,'pl','ZmieÅ„ opcje',0),(16782,467,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¸Ð·Ð±Ð¾Ñ€Ð°',0),(16783,467,'ur','Ø§Ù†ØªØ®Ø§Ø¨ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(16784,467,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¸Ð·Ð±Ð¾Ñ€Ðµ',0),(16785,467,'vi','Thay Ä‘á»•i lá»±a chá»n',0),(16786,467,'af','Verander Seleksies',0),(16787,467,'ro','Schimbare selecÅ£ii',0),(16788,467,'et','Muuda valikut',0),(16789,467,'si','Spremenite izbor',0),(16790,467,'ba','Mengubah pilihan',0),(16791,467,'nl','Selecties wijzigen',0),(16792,467,'fi','Muuta valintoja',0),(16793,467,'no','Endre valg',0),(16794,467,'da','Ã†ndre valg',0),(16795,467,'ko','ì„ íƒ ë³€ê²½',0),(16796,467,'he','×©× ×” ×‘×—×™×¨×•×ª',0),(16797,467,'el','Î‘Î»Î»Î¬Î¾Ï„Îµ Ï„Î¹Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(16798,467,'zh','æ”¹å˜é€‰æ‹©\r\n',0),(16799,467,'sv','Ã„ndra val',0),(16800,467,'it','Modificare le selezioni',0),(16801,467,'tl','',0),(16802,467,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3623;&#3634;&#3617;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(16803,467,'hi','à¤šà¤¯à¤¨ à¤¬à¤¦à¤²',0),(16804,467,'ms','Tukar pilihan',0),(16805,467,'ar','ØªØºÙŠÙŠØ± Ø§Ù„ØªØ­Ø¯ÙŠØ¯Ø§Øª',0),(16806,467,'fr','Modifier les sÃ©lections',0),(16807,467,'jp','é?¸æŠžã‚’å¤‰æ›´',0),(16808,467,'pt','Alterar as seleÃ§Ãµes',0),(16809,467,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð’Ñ‹Ð±Ð¾Ñ€',0),(16810,467,'es','Cambiar Selecciones',0),(16811,467,'de','Auswahl Ã¤ndern',0),(16812,467,'en','Change Selections',0),(16813,468,'is','',0),(16814,468,'dr','ØªØºÙŠÙŠØ± Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡',0),(16815,468,'pr','ØªØºÙŠÙŠØ± Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡',0),(16816,468,'tr','Gemiye deÄŸiÅŸtirme',0),(16817,468,'pl','Zmiana statku',0),(16818,468,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(16819,468,'ur','Ø¬ÛØ§Ø² Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(16820,468,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð±Ñ€Ð¾Ð´ Ð´Ð°',0),(16821,468,'vi','Thay Ä‘á»‹a chá»‰ chuyá»ƒn Ä‘áº¿n',0),(16822,468,'af','Verandering in Versend Aan',0),(16823,468,'ro','Schimba nava sÄƒ',0),(16824,468,'et','Muuda tarneaadressi',0),(16825,468,'si','Spremenite ladji',0),(16826,468,'ba','Mengubah kapal untuk',0),(16827,468,'nl','Verzendadres wijzigen',0),(16828,468,'fi','Muuta aluksen',0),(16829,468,'no','Endre skip',0),(16830,468,'da','Ã†ndre skib til',0),(16831,468,'ko','ë°°ë¥¼ ë³€ê²½',0),(16832,468,'he','×œ×©× ×•×ª ××ª ×”×¡×¤×™× ×”',0),(16833,468,'el','Î‘Î»Î»Î±Î³Î® Ï€Î»Î¿Î¯Î¿ Î½Î±',0),(16834,468,'zh','æ›´æ”¹æ”¶è´§\r\n',0),(16835,468,'sv','Ã„ndra fartyget fÃ¶r att',0),(16836,468,'it','Cambiare nave a',0),(16837,468,'tl','',0),(16838,468,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;',0),(16839,468,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(16840,468,'ms','Tukar kapal',0),(16841,468,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(16842,468,'fr','Changement de navire Ã ',0),(16843,468,'jp','é…?é€?å…ˆå¤‰æ›´',0),(16844,468,'pt','Navio de mudanÃ§a para',0),(16845,468,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(16846,468,'es','Cambiar Enviar A',0),(16847,468,'de','Schiff zu Ã¤ndern',0),(16848,468,'en','Change Ship To',0),(16849,469,'is','',0),(16850,469,'dr','.Ø§ÙŠÙ† ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¯Ø± Ù…Ø­ØªÙˆÙŠØ§Øª/ my_defines.php',0),(16851,469,'pr','ØªØºÙŠÙŠØ± ÙƒÙ„ÙŠØ¯ Ø±Ù…Ø² Ø¯Ø§Ø± ÙƒØ±Ø¯Ù† .Ø§ÙŠÙ† ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¯Ø± Ù…Ø­ØªÙˆÙŠØ§Øª/ my_defines.php',0),(16852,469,'tr','Åžifreleme anahtarÄ±nÄ± deÄŸiÅŸtirin. Ä°ncludes/my_defines.php tanÄ±mlanÄ±r',0),(16853,469,'pl','Zmiana klucza szyfrowania. Jest ona definiowana w includes/my_defines.php',0),(16854,469,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° ÐºÐ»ÑŽÑ‡Ð° Ð·Ð° ÑˆÐ¸Ñ„Ñ€Ð¾Ð²Ð°Ð½Ðµ. Ð¢Ð¾Ð¹ Ðµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ð² includes/my_defines.php',0),(16855,469,'ur','Ø®ÙÛŒÛ Ú©Ø§Ø±ÛŒ Ú©Ù„ÛŒØ¯ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº Û” Ø§Ø³ Ù…ÛŒÚº includes/my_defines.php Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(16856,469,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÐºÑ™ÑƒÑ‡ Ð·Ð° ÑˆÐ¸Ñ„Ñ€Ð¾Ð²Ð°ÑšÐµ. Ð¢Ð¾ Ñ˜Ðµ Ð´ÐµÑ„Ð¸Ð½Ð¸ÑÐ°Ð½ Ñƒ Ð¸Ð½Ñ†Ð»ÑƒÐ´ÐµÑ/Ð¼y_Ð´ÐµÑ„Ð¸Ð½ÐµÑ.Ð¿Ñ…Ð¿',0),(16857,469,'vi','Thay Ä‘á»•i chÃ¬a khÃ³a máº­t mÃ£. NÃ³ Ä‘Æ°á»£c Ä‘á»‹nh nghÄ©a trong includes/my_defines.php',0),(16858,469,'af','Verander die enkripsie sleutel. Dit word gedefinieer in includes/my_defines.php',0),(16859,469,'ro','ModificaÅ£i cheia de criptare. Ea este definitÄƒ Ã®n includes/my_defines.php',0),(16860,469,'et','KrÃ¼ptimise vÃµtme muutmist. See on defineeritud includes/my_defines.php',0),(16861,469,'si','Spremenite Å¡ifrirni kljuÄ. Opredeljena je v includes/my_defines.php',0),(16862,469,'ba','Mengubah kunci enkripsi. Didefinisikan dalam includes/my_defines.php',0),(16863,469,'nl','De encryptie sleutel wijzigen Dit is gedefinieerd in includes/my_defines.php',0),(16864,469,'fi','Muuttaa salausavain. Se mÃ¤Ã¤ritellÃ¤Ã¤n includes/my_defines.php',0),(16865,469,'no','Endre krypteringsnÃ¸kkelen. Det er definert i includes/my_defines.php',0),(16866,469,'da','Ã†ndre krypteringsnÃ¸glen. Det er defineret i includes/my_defines.php',0),(16867,469,'ko','ì•”í˜¸í™” í‚¤ë¥¼ ë³€ê²½ í•©ë‹ˆë‹¤. ê·¸ê²ƒì€ includes/my_defines.phpì— ì •ì˜ ë˜ì–´',0),(16868,469,'he','×œ×©× ×•×ª ××ª ×ž×¤×ª×— ×”×”×¦×¤× ×”. ×”×•× ×ž×•×’×“×¨ ×‘- includes/my_defines.php',0),(16869,469,'el','ÎœÏ€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Î±Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î¿ ÎºÎ»ÎµÎ¹Î´Î¯ ÎºÏÏ…Ï€Ï„Î¿Î³ÏÎ¬Ï†Î·ÏƒÎ·Ï‚. Î•Î¯Î½Î±Î¹ Î¿ÏÎ¯Î¶ÎµÏ„Î±Î¹ ÏƒÏ„Î¿ includes/my_defines.php',0),(16870,469,'zh','æ›´æ”¹åŠ å¯†å¯†é’¥ã€‚å®ƒè¢«å®šä¹‰åœ¨',0),(16871,469,'sv','Ã„ndra krypteringsnyckeln. Det definieras i includes/my_defines.php',0),(16872,469,'it','Modificare la chiave di crittografia. Ãˆ definito in includes/my_defines.php',0),(16873,469,'tl','',0),(16874,469,'th','Change the encryption key. It is defined in includes/my_defines.php',0),(16875,469,'hi','à¤à¤¨à¥à¤•à¥à¤°à¤¿à¤ªà¥à¤¶à¤¨ à¤•à¥à¤‚à¤œà¥€ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚à¥¤ à¤¯à¤¹ includes/my_defines.php à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(16876,469,'ms','Tukar kekunci enkripsi. Ia ditakrifkan dalam includes/my_defines.php',0),(16877,469,'ar','ØªØºÙŠÙŠØ± Ù…ÙØªØ§Ø­ Ø§Ù„ØªØ´ÙÙŠØ±. ÙØ¥Ù†Ù‡ ÙŠØªÙ… ØªØ¹Ø±ÙŠÙ ÙÙŠ includes/my_defines.php',0),(16878,469,'fr','Modifier la clÃ© de cryptage. Il est dÃ©fini dans includes/my_defines.php',0),(16879,469,'jp','æš—å?·åŒ–ã‚­ãƒ¼ã‚’å¤‰æ›´ã?—ã?¦ã??ã? ã?•ã?„ã€‚my_defines.phpã‚’å?«ã‚€ã?¨å®šã‚?ã‚‰ã‚Œã?¦ã?„ã?¾ã?™ã€‚',0),(16880,469,'pt','Altere a chave de criptografia. Ele Ã© definido em includes/my_defines.php',0),(16881,469,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÐºÐ»ÑŽÑ‡ ÑˆÐ¸Ñ„Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ. ÐžÐ½ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ð² includes/my_defines.php',0),(16882,469,'es','Cambiar la Clave de EncriptaciÃ³n',0),(16883,469,'de','Ã„ndern Sie den VerschlÃ¼sselungsschlÃ¼ssel. Es ist in includes/my_defines.php definiert.',0),(16884,469,'en','Change the encryption key. It is defined in includes/my_defines.php',0),(16885,470,'is','',0),(16886,470,'dr','. .Ø§ÙŠÙ† ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¯Ø± Ù…Ø­ØªÙˆÙŠØ§Øª/ my_defines.php.',0),(16887,470,'pr','ØªØºÙŠÙŠØ± Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§. .Ø§ÙŠÙ† ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¯Ø± Ù…Ø­ØªÙˆÙŠØ§Øª/ my_defines.php.',0),(16888,470,'tr','VeritabanÄ± parolasÄ±nÄ± deÄŸiÅŸtirin. Ä°ncludes/my_defines.php tanÄ±mlanÄ±r.',0),(16889,470,'pl','ZmieniÄ‡ hasÅ‚o do bazy danych. To jest zdefiniowany w includes/my_defines.php.',0),(16890,470,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°Ñ‚Ð° Ð·Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸. Ð¢Ð¾Ð¹ Ðµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ð² includes/my_defines.php.',0),(16891,470,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù¾Ø§Ø³ ÙˆØ±Úˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº Û” ÛŒÛ includes/my_defines.php Ù…ÛŒÚº ÙˆØ§Ø¶Ø­ Ú©ÛŒØ§ Ú¯ÙŠØ§ ÛÛ’ Û”',0),(16892,470,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ Ð·Ð° Ð±Ð°Ð·Ñƒ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°. Ð¢Ð¾ Ñ˜Ðµ Ð´ÐµÑ„Ð¸Ð½Ð¸ÑÐ°Ð½ Ñƒ Ð¸Ð½Ñ†Ð»ÑƒÐ´ÐµÑ/Ð¼y_Ð´ÐµÑ„Ð¸Ð½ÐµÑ.Ð¿Ñ…Ð¿.',0),(16893,470,'vi','Thay Ä‘á»•i máº­t kháº©u cho dá»¯ liá»‡u. NÃ³ Ä‘Æ°á»£c Ä‘á»‹nh nghÄ©a trong includes/my_defines.php',0),(16894,470,'af','Verander die wagwoord vir databasis.  Dit word omskryf in includes/my_defines.php',0),(16895,470,'ro','Schimba parola pentru baza de date. Ea este definitÄƒ Ã®n includes/my_defines.php.',0),(16896,470,'et','Andmebaasi parooli muuta. See mÃ¤Ã¤ratletakse includes/my_defines.php.',0),(16897,470,'si','Spremenite geslo za zbirko podatkov. Opredeljena je v includes/my_defines.php.',0),(16898,470,'ba','Mengubah password untuk database. Didefinisikan dalam includes/my_defines.php.',0),(16899,470,'nl','Het wachtwoord voor database wijzigen. Dit is gedefinieerd in includes/my_defines.php.',0),(16900,470,'fi','Vaihda salasana tietokannalle. Se on mÃ¤Ã¤ritelty includes/my_defines.php.',0),(16901,470,'no','Endre passordet for databasen. Det er definert i includes/my_defines.php.',0),(16902,470,'da','Ã†ndre adgangskoden til databasen. Det er defineret i includes/my_defines.php.',0),(16903,470,'ko','ë°ì´í„°ë² ì´ìŠ¤ì˜ ì•”í˜¸ë¥¼ ë³€ê²½ í•©ë‹ˆë‹¤. ê·¸ê²ƒì€ includes/my_defines.phpì— ì •ì˜ ë©ë‹ˆë‹¤.',0),(16904,470,'he','×©× ×” ××ª ×”×¡×™×¡×ž×” ×©×œ ×ž×¡×“ ×”× ×ª×•× ×™×. ×–×” ×ž×•×’×“×¨ includes/my_defines.php.',0),(16905,470,'el','Î‘Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î· Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½. Î•Î¯Î½Î±Î¹ Î¿ÏÎ¯Î¶ÎµÏ„Î±Î¹ ÏƒÏ„Î¿ includes/my_defines.php.',0),(16906,470,'zh','æ›´æ”¹æ•°æ®åº“çš„å¯†ç ã€‚å®ƒå®šä¹‰åœ¨\r\n',0),(16907,470,'sv','Ã„ndra lÃ¶senordet fÃ¶r databasen. Det definieras i includes/my_defines.php.',0),(16908,470,'it','Cambiare la password per il database. Ãˆ definito in includes/my_defines.php.',0),(16909,470,'tl','',0),(16910,470,'th','Change the password for database. It is defined in includes/my_defines.php.',0),(16911,470,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚à¥¤ à¤¯à¤¹ includes/my_defines.php à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(16912,470,'ms','Tukar kata laluan untuk pangkalan data. Ia ditakrifkan di includes/my_defines.php.',0),(16913,470,'ar','ØºÙŠØ± ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ù„Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª. Ø³ØªØ¬Ø¯Ù‡Ø§ Ù…Ø¹Ø±ÙØ© ÙÙŠ includes/my_defines.php.',0),(16914,470,'fr','Changer le mot de passe pour la base de donnÃ©es. Il est dÃ©fini dans includes/my_defines.php.',0),(16915,470,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ç”¨ã?®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å¤‰æ›´ã?—ã?¦ã??ã? ã?•ã?„ã€‚my_defines.phpã‚’å?«ã‚€ã?¨å®šã‚?ã‚‰ã‚Œã?¦ã?„ã?¾ã?™ã€‚',0),(16916,470,'pt','Altere a senha de banco de dados. Ã‰ definida em includes/my_defines.php.',0),(16917,470,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ñ Ð´Ð»Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…. ÐžÐ½ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ð² includes/my_defines.php.',0),(16918,470,'es','Cambiar el Password para la Base de Datos. Se Define en includes/my_defines.php',0),(16919,470,'de','Ã„ndern Sie das Kennwort fÃ¼r die Datenbank. Es ist in includes/my_defines.php definiert.',0),(16920,470,'en','Change the password for database. It is defined in includes/my_defines.php.',0),(16921,471,'is','',0),(16922,471,'dr','ØªØºÙŠÙŠØ± ÙŠØ§ÙØªÙ‡ Ø¨Ù‡',0),(16923,471,'pr','ØªØºÙŠÙŠØ± ÙŠØ§ÙØªÙ‡ Ø¨Ù‡',0),(16924,471,'tr','deÄŸiÅŸtirildi',0),(16925,471,'pl','zmieniÅ‚ siÄ™',0),(16926,471,'bg','Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð¾ Ð½Ð°',0),(16927,471,'ur','Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(16928,471,'sr','Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½ Ñƒ',0),(16929,471,'vi','Thay Ä‘á»•i tá»›i',0),(16930,471,'af','verander na',0),(16931,471,'ro','schimbat Ã®n',0),(16932,471,'et','muutunud',0),(16933,471,'si','sprememba v',0),(16934,471,'ba','berubah menjadi',0),(16935,471,'nl','gewijzigd om te',0),(16936,471,'fi','muuttunut',0),(16937,471,'no','endret til',0),(16938,471,'da','Ã¦ndret til',0),(16939,471,'ko','ë¡œ ë³€ê²½',0),(16940,471,'he','×©×™× ×”',0),(16941,471,'el','Î¬Î»Î»Î±Î¾Îµ ÏƒÎµ',0),(16942,471,'zh','æ”¹ä¸º\r\n',0),(16943,471,'sv','Ã¤ndras till',0),(16944,471,'it','cambiato in',0),(16945,471,'tl','',0),(16946,471,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3626;&#3641;&#3656;',0),(16947,471,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¦à¤² à¤—à¤¯à¤¾',0),(16948,471,'ms','ditukar kepada',0),(16949,471,'ar','ØªØºÙŠÙŠØ± Ø¥Ù„Ù‰',0),(16950,471,'fr','changÃ© Ã ',0),(16951,471,'jp','ï½žã?«å¤‰æ›´ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(16952,471,'pt','mudou-se para',0),(16953,471,'ru','Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¾ Ð½Ð°',0),(16954,471,'es','Cambiado a',0),(16955,471,'de','in geÃ¤ndert',0),(16956,471,'en','changed to',0),(16957,472,'is','',0),(16958,472,'dr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡',0),(16959,472,'pr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡',0),(16960,472,'tr','Ãœcret kodu',0),(16961,472,'pl','Kod opÅ‚aty',0),(16962,472,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ',0),(16963,472,'ur','Ø¨Ø§Ø± Ú©ÙˆÚˆ',0),(16964,472,'sr','Ð¨Ð¸Ñ„Ñ€Ñƒ Ð·Ð°Ñ‚ÐµÐ·Ð½Ð¸Ñ…',0),(16965,472,'vi','MÃ£ phÃ­',0),(16966,472,'af','Heffingskode',0),(16967,472,'ro','Codul de Ã®ncÄƒrcare',0),(16968,472,'et','Lisakulude kood',0),(16969,472,'si','Naboja Å¡ifra',0),(16970,472,'ba','Kode biaya',0),(16971,472,'nl','Gratis Code',0),(16972,472,'fi','Kulujen koodi',0),(16973,472,'no','Tilleggskoden',0),(16974,472,'da','TillÃ¦gskode',0),(16975,472,'ko','ì¶©ì „ ì½”ë“œ',0),(16976,472,'he','×§×•×“ ×—×™×•×‘',0),(16977,472,'el','ÎšÏ‰Î´Î¹ÎºÏŒ Ï„ÏŒÎºÏ‰Î½',0),(16978,472,'zh','æ”¶è´¹ä»£ç \r\n',0),(16979,472,'sv','Avgiftskoden',0),(16980,472,'it','Codice di carica',0),(16981,472,'tl','',0),(16982,472,'th','&#3619;&#3627;&#3633;&#3626;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(16983,472,'hi','à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤•à¥‹à¤¡',0),(16984,472,'ms','Kod bayaran',0),(16985,472,'ar','ÙƒÙˆØ¯ Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ',0),(16986,472,'fr','Code frais',0),(16987,472,'jp','è«‹æ±‚ã‚³ãƒ¼ãƒ‰',0),(16988,472,'pt','CÃ³digo da carga',0),(16989,472,'ru','ÐšÐ¾Ð´ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(16990,472,'es','CÃ³digo de Carga',0),(16991,472,'de','Code fÃ¼r ZuschlÃ¤ge',0),(16992,472,'en','Charge Code',0),(16993,473,'is','',0),(16994,473,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª Ù†Ø§Ù… ',0),(16995,473,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª Ù†Ø§Ù… ',0),(16996,473,'tr','SÄ±kÄ± kayÄ±t iÃ§in Ã¼cret',0),(16997,473,'pl','Za mocno rejestracji',0),(16998,473,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° ÑÑ‚ÐµÐ³Ð½Ð°Ñ‚ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(16999,473,'ur','ØªÙ†Ú¯ Ø±Ø¬Ø³Ù¹Ø±ÛŒØ´Ù† Ú©Û’ Ù„Ø¦Û’ Ú†Ø§Ø±Ø¬',0),(17000,473,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð·Ð° Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ñƒ Ñ‡Ð²Ñ€ÑÑ‚Ð¾',0),(17001,473,'vi','PhÃ­ cho Ä‘Äƒng kÃ½ cháº·t',0),(17002,473,'af','Fooi vir stywe registrasie',0),(17003,473,'ro','Taxa de Ã®nregistrare strans',0),(17004,473,'et','Tasu tihe registreerimine',0),(17005,473,'si','Pristojbine za registracijo tesen',0),(17006,473,'ba','Biaya untuk pendaftaran ketat',0),(17007,473,'nl','Kosten voor strakke registratie',0),(17008,473,'fi','Tiukka rekisterÃ¶inti ilmaiseksi',0),(17009,473,'no','Betalt for stramme registrering',0),(17010,473,'da','Gebyr for stramme registrering',0),(17011,473,'ko','ê½‰ ë“±ë¡ì— ëŒ€ í•œ ìš”ê¸ˆ',0),(17012,473,'he','×ª×©×œ×•× ×¢×‘×•×¨ ×”×¨×©×ž×” ×—×–×§',0),(17013,473,'el','Î¤Î­Î»Î¿Ï‚ Î³Î¹Î± Ï„Î·Î½ ÎµÎ³Î³ÏÎ±Ï†Î® ÏƒÏ†Î¹Ï‡Ï„ÏŒ',0),(17014,473,'zh','è‡´å¯†ç™»è®°è´¹\r\n',0),(17015,473,'sv','Avgift fÃ¶r snÃ¤va registrering',0),(17016,473,'it','Tassa di registrazione stretto',0),(17017,473,'tl','',0),(17018,473,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3638;&#3657;&#3609;&#3607;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;',0),(17019,473,'hi','à¤¤à¤‚à¤— à¤ªà¤‚à¤œà¥€à¤•à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(17020,473,'ms','Untuk pendaftaran ketat',0),(17021,473,'ar','Ø±Ø³ÙˆÙ… Ù„ØªØ³Ø¬ÙŠÙ„ Ø¶ÙŠÙ‚',0),(17022,473,'fr','Frais d\'inscription serrÃ©e',0),(17023,473,'jp','Charge for Tight Registration',0),(17024,473,'pt','Carga de registo apertado',0),(17025,473,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸ÑŽ Ñ‚ÑƒÐ³Ð¾',0),(17026,473,'es','Cargar para RegistraciÃ³n Apretada',0),(17027,473,'de','FÃ¼r enge Registrierung kostenlos',0),(17028,473,'en','Charge for Tight Registration',0),(17029,474,'is','',0),(17030,474,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ù‡Ø±Ù‡',0),(17031,474,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ù‡Ø±Ù‡',0),(17032,474,'tr','Åžarj faiz',0),(17033,474,'pl','Za zainteresowanie',0),(17034,474,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð»Ð¸Ñ…Ð²Ð¸',0),(17035,474,'ur','Ø³ÙˆØ¯ ÙˆØµÙˆÙ„ Ú©Ø±ØªÛ’ ÛÛŒÚº',0),(17036,474,'sr','Ð“Ð»Ð°Ð²Ð½Ð¸ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(17037,474,'vi','PhÃ­ lÃ£i suáº¥t',0),(17038,474,'af','Hef Rente',0),(17039,474,'ro','Taxa de interes',0),(17040,474,'et','KÃ¼si viivist',0),(17041,474,'si','StroÅ¡ek obresti',0),(17042,474,'ba','Bunga',0),(17043,474,'nl','Gratis belang',0),(17044,474,'fi','Ilmaiseksi etua',0),(17045,474,'no','Gratis interesse',0),(17046,474,'da','Afgift interesse',0),(17047,474,'ko','ìš”ê¸ˆ ê´€ì‹¬',0),(17048,474,'he','×ª×©×œ×•× ×¨×™×‘×™×ª',0),(17049,474,'el','Î§ÏÎ­Ï‰ÏƒÎ· Ï„ÏŒÎºÏ‰Î½',0),(17050,474,'zh','æ”¶å–åˆ©æ¯\r\n',0),(17051,474,'sv','Avgift intresse',0),(17052,474,'it','Addebito interessi',0),(17053,474,'tl','',0),(17054,474,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;',0),(17055,474,'hi','à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤¬à¥à¤¯à¤¾à¤œ',0),(17056,474,'ms','Caj faedah',0),(17057,474,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(17058,474,'fr','Imposons des intÃ©rÃªts',0),(17059,474,'jp','åˆ©æ?¯è«‹æ±‚',0),(17060,474,'pt','Taxa de juros',0),(17061,474,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹ Ð·Ð°Ñ€ÑÐ´Ð°',0),(17062,474,'es','Cobrar InterÃ©ses',0),(17063,474,'de','Kostenlos Zinsen',0),(17064,474,'en','Charge Interest',0),(17065,475,'is','',0),(17066,475,'dr','(Ø·Ù„Ø¨ Ù‡Ø§)',0),(17067,475,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ùˆ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ(Ø·Ù„Ø¨ Ù‡Ø§)',0),(17068,475,'tr','Ãœcretleri ve kredi',0),(17069,475,'pl','OpÅ‚aty i kredyty',0),(17070,475,'bg','Ð¢Ð°ÐºÑÐ¸ Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸',0),(17071,475,'ur','Ø§Ù„Ø²Ø§Ù…Ø§Øª Ø§ÙˆØ± Ú©Ø±ÛŒÚˆÙ¹',0),(17072,475,'sr','ÐžÐ¿Ñ‚ÑƒÐ¶Ð±Ðµ Ð¸ ÑˆÐ¿Ð¸Ñ†Ð°',0),(17073,475,'vi','Pháº£i Tráº£ & TÃ­n Dá»¥ng',0),(17074,475,'af','Kostes en Krediete',0),(17075,475,'ro','Taxe ÅŸi credite',0),(17076,475,'et','Tasud ja krediidid',0),(17077,475,'si','StroÅ¡ki in krediti',0),(17078,475,'ba','Biaya dan kredit',0),(17079,475,'nl','Kosten en crediteringen',0),(17080,475,'fi','Veloitukset ettÃ¤ hyvitykset',0),(17081,475,'no','Belastninger av og krediteringer',0),(17082,475,'da','Afgifter og Credits',0),(17083,475,'ko','ìš”ê¸ˆ ë° í•™ì ',0),(17084,475,'he','×•×–×™×›×•×™×™',0),(17085,475,'el','Î§ÏÎµÏŽÏƒÎµÎ¹Ï‚ ÎºÎ±Î¹ Ï€Î¹ÏƒÏ„ÏŽÏƒÎµÎ¹Ï‚',0),(17086,475,'zh','æ”¶è´¹åŠä¿¡ç”¨\r\n',0),(17087,475,'sv','Avgifter och krediter',0),(17088,475,'it','Oneri e crediti',0),(17089,475,'tl','',0),(17090,475,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3632;&#3623;&#3591;&#3648;&#3591;&#3636;&#3609;',0),(17091,475,'hi','à¤†à¤°à¥‹à¤ª à¤”à¤° à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿà¥à¤¸',0),(17092,475,'ms','Caj dan kredit',0),(17093,475,'ar','Ø±Ø³ÙˆÙ… ÙˆØ§Ù„Ø§Ø¦ØªÙ…Ø§Ù†Ø§Øª',0),(17094,475,'fr','DÃ©bits et les crÃ©dits',0),(17095,475,'jp','è«‹æ±‚ã?¨è²¸æ–¹',0),(17096,475,'pt','Encargos e crÃ©ditos',0),(17097,475,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ñ‹',0),(17098,475,'es','Cargas y CrÃ©ditos',0),(17099,475,'de','GebÃ¼hren und Gutschriften',0),(17100,475,'en','Charges and Credits',0),(17101,476,'is','',0),(17102,476,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ø¢ÙˆØ±Ø¯ ÙƒØ±Ø¯Ù† Ø¨Ù‡ ',0),(17103,476,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ø¢ÙˆØ±Ø¯ ÙƒØ±Ø¯Ù† Ø¨Ù‡ ',0),(17104,476,'tr','Masraflar iÃ§in boyut deÄŸerine kadar',0),(17105,476,'pl','OpÅ‚aty za rozmiar do',0),(17106,476,'bg','Ð¢Ð°ÐºÑÐ¸ Ð·Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð´Ð¾',0),(17107,476,'ur','Ø³Ø§Ø¦Ø² Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú©Û’ Ù„Ø¦Û’ Ú†Ø§Ø±Ø¬Ø²',0),(17108,476,'sr','ÐžÐ¿Ñ‚ÑƒÐ¶Ð±Ðµ Ð·Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ Ð´Ð¾',0),(17109,476,'vi','PhÃ­ cho kÃ­ch cá»¡ tá»›i',0),(17110,476,'af','Kostes vir Vergroting na',0),(17111,476,'ro','Taxe pentru dimensiunea pÃ¢nÄƒ la',0),(17112,476,'et','Kulude suurus kuni',0),(17113,476,'si','StroÅ¡ki za velikosti do',0),(17114,476,'ba','Biaya untuk ukuran hingga',0),(17115,476,'nl','Kosten voor grootte tot',0),(17116,476,'fi','Maksut kokoon asti',0),(17117,476,'no','Kostnader for stÃ¸rrelsen til',0),(17118,476,'da','Afgifter for stÃ¸rrelse op til',0),(17119,476,'ko','ìµœëŒ€ í¬ê¸°ì— ëŒ€ í•œ ìš”ê¸ˆ',0),(17120,476,'he','×—×™×•×‘×™× ×¢×‘×•×¨ ×’×•×“×œ ×¢×“',0),(17121,476,'el','Î§ÏÎµÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î­Ï‰Ï‚',0),(17122,476,'zh','æ”¶è´¹è§„æ¨¡é«˜è¾¾\r\n',0),(17123,476,'sv','Avgifter fÃ¶r storlek upp till',0),(17124,476,'it','Spese per dimensioni fino a',0),(17125,476,'tl','',0),(17126,476,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3586;&#3609;&#3634;&#3604;&#3652;&#3611;&#3606;&#3638;&#3591;',0),(17127,476,'hi','à¤†à¤•à¤¾à¤° à¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(17128,476,'ms','Caj-caj untuk saiz sehingga',0),(17129,476,'ar','Ø±Ø³ÙˆÙ… Ù„Ø­Ø¬Ù… Ù…Ø§ ÙŠØµÙ„ Ø¥Ù„Ù‰',0),(17130,476,'fr','Frais pour les dimensions jusqu\'Ã ',0),(17131,476,'jp','ï½žã?¾ã?§ã?®ã‚µã‚¤ã‚ºã?®æ–™é‡‘',0),(17132,476,'pt','Encargos de tamanho atÃ©',0),(17133,476,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð´Ð¾',0),(17134,476,'es','Cargas por TamaÃ±o hasta',0),(17135,476,'de','GebÃ¼hren fÃ¼r GrÃ¶ÃŸe bis zu',0),(17136,476,'en','Charges for Size up to',0),(17137,477,'is','',0),(17138,477,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ù‡ Ú†Ù‡ Ù…Ù‚Ø¯Ø§Ø±',0),(17139,477,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ù‡ Ú†Ù‡ Ù…Ù‚Ø¯Ø§Ø±',0),(17140,477,'tr','Ne boyutu maksimum Ã¼cretleri',0),(17141,477,'pl','OpÅ‚aty do jakiej wielkoÅ›ci',0),(17142,477,'bg','Ð¢Ð°ÐºÑÐ¸ Ð´Ð¾ ÐºÐ°ÐºÑŠÐ² Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(17143,477,'ur','Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©ÛŒØ§ Ú©Ø§ Ø³Ø§Ø¦Ø² ØªÚ©',0),(17144,477,'sr','ÐžÐ¿Ñ‚ÑƒÐ¶Ð±Ðµ Ð½Ð° ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ñ‚Ð¾ Ð±Ñ€Ð¾Ñ˜',0),(17145,477,'vi','PhÃ­ Ä‘áº¿n cá»¡',0),(17146,477,'af','Verander Na Watter Grootte',0),(17147,477,'ro','Taxe pÃ¢nÄƒ la ce dimensiune',0),(17148,477,'et','Maksud mis suurus kuni',0),(17149,477,'si','StroÅ¡kov, do kakÅ¡ne velikosti',0),(17150,477,'ba','Biaya ukuran apa',0),(17151,477,'nl','Kosten tot en met welke maat',0),(17152,477,'fi','Maksut jopa mitÃ¤ koko',0),(17153,477,'no','Kostnader til hvilken stÃ¸rrelse',0),(17154,477,'da','Afgifter op til hvilken stÃ¸rrelse',0),(17155,477,'ko','ì–´ë–¤ í¬ê¸°ê¹Œì§€ ìš”ê¸ˆ',0),(17156,477,'he','×—×™×•×‘×™× ×¢×“ ××™×–×” ×’×•×“×œ',0),(17157,477,'el','Î¤Î­Î»Î· Î¼Î­Ï‡ÏÎ¹ Ï€Î¿Î¹Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚',0),(17158,477,'zh','æ”¶è´¹åˆ°ä»€ä¹ˆè§„æ¨¡\r\n',0),(17159,477,'sv','Avgifter upp till vilken storlek',0),(17160,477,'it','Spese fino a che taglia',0),(17161,477,'tl','',0),(17162,477,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3652;&#3611;&#3606;&#3638;&#3591;&#3586;&#3609;&#3634;&#3604;&#3652;&#3627;&#3609;',0),(17163,477,'hi','à¤•à¥à¤¯à¤¾ à¤†à¤•à¤¾à¤° à¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(17164,477,'ms','Caj sehingga saiz apa',0),(17165,477,'ar','Ø±Ø³ÙˆÙ… ØªØµÙ„ Ø¥Ù„Ù‰ Ø­Ø¬Ù… Ù…Ø§',0),(17166,477,'fr','Charges jusqu\'Ã  ce que la taille',0),(17167,477,'jp','ã?©ã?®ã‚µã‚¤ã‚ºã?¾ã?§ã?®æ–™é‡‘',0),(17168,477,'pt','CobranÃ§as atÃ© que tamanho',0),(17169,477,'ru','ÐžÐ±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ Ð´Ð¾ ÐºÐ°ÐºÐ¾Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(17170,477,'es','Cargas Hasta que TamaÃ±o',0),(17171,477,'de','GebÃ¼hren bis zu welcher GrÃ¶ÃŸe',0),(17172,477,'en','Charges Up To What Size',0),(17173,478,'is','',0),(17174,478,'dr','Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ',0),(17175,478,'pr','Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ',0),(17176,478,'tr','Hesap iÃ§in',0),(17177,478,'pl','Plan kont dla',0),(17178,478,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¾Ð¿Ð»Ð°Ð½ÑŠÑ‚ Ð½Ð°',0),(17179,478,'ur','Ú†Ø§Ø±Ù¹ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú©Û’ Ù„Ø¦Û’',0),(17180,478,'sr','ÐšÐ¾Ð½Ñ‚Ð½Ð¸ Ð¿Ð»Ð°Ð½ Ð·Ð°',0),(17181,478,'vi','Biá»ƒu Äá»“ TK cho',0),(17182,478,'af','Tabel van Rekeninge vir',0),(17183,478,'ro','Planul de conturi pentru',0),(17184,478,'et','Konoplaan',0),(17185,478,'si','Kontni naÄrt za',0),(17186,478,'ba','Bagan akun untuk',0),(17187,478,'nl','Rekeningschema voor',0),(17188,478,'fi','Tilikartan',0),(17189,478,'no','Kontogruppe',0),(17190,478,'da','Kontoplanen for',0),(17191,478,'ko','ê³„ì •ì— ëŒ€ í•œ ì°¨íŠ¸',0),(17192,478,'he','×ª×¨×©×™× ×©×œ ×—×©×‘×•× ×•×ª ×¢×‘×•×¨',0),(17193,478,'el','Î›Î¿Î³Î¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ‡Î­Î´Î¹Î¿ Î³Î¹Î±',0),(17194,478,'zh','ä¼šè®¡å›¾è¡¨\r\n',0),(17195,478,'sv','Kontoplanen fÃ¶r',0),(17196,478,'it','Piano dei conti per',0),(17197,478,'tl','',0),(17198,478,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(17199,478,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¤¾ à¤šà¤¾à¤°à¥à¤Ÿ',0),(17200,478,'ms','Carta akaun untuk',0),(17201,478,'ar','Ø¯Ù„ÙŠÙ„ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ù„Ù€',0),(17202,478,'fr','Plan comptable pour',0),(17203,478,'jp','ï½žã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®ãƒ?ãƒ£ãƒ¼ãƒˆ',0),(17204,478,'pt','Plano de contas para',0),(17205,478,'ru','ÐŸÐ»Ð°Ð½ ÑÑ‡ÐµÑ‚Ð¾Ð² Ð´Ð»Ñ',0),(17206,478,'es','CatÃ¡logo de Cuentas para',0),(17207,478,'de','Kontenplan fÃ¼r',0),(17208,478,'en','Chart of Accounts for',0),(17209,479,'is','',0),(17210,479,'dr','Ú†Ùƒ ',0),(17211,479,'pr','Ú†Ùƒ ',0),(17212,479,'tr','Onay',0),(17213,479,'pl','Wyboru',0),(17214,479,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ',0),(17215,479,'ur','Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(17216,479,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(17217,479,'vi','SÃ©c',0),(17218,479,'af','Tjek',0),(17219,479,'ro','Verifica',0),(17220,479,'et','TÅ¡ekk',0),(17221,479,'si','Preverite',0),(17222,479,'ba','Periksa',0),(17223,479,'nl','Selectievakje',0),(17224,479,'fi','Tarkista',0),(17225,479,'no','Sjekk',0),(17226,479,'da','Check',0),(17227,479,'ko','í™•ì¸',0),(17228,479,'he','×¦\'×§',0),(17229,479,'el','Î•Î»Î­Î³Ï‡Î¿Ï…',0),(17230,479,'zh','æ£€æŸ¥\r\n',0),(17231,479,'sv','Kontrollera',0),(17232,479,'it','Verifica',0),(17233,479,'tl','',0),(17234,479,'th','&#3648;&#3594;&#3655;&#3588;',0),(17235,479,'hi','à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17236,479,'ms','Semak',0),(17237,479,'ar','ØµÙ€Ùƒ',0),(17238,479,'fr','VÃ©rifier',0),(17239,479,'jp','è«‹æ±‚æ›¸',0),(17240,479,'pt','SeleÃ§Ã£o',0),(17241,479,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ',0),(17242,479,'es','Cheque',0),(17243,479,'de','ÃœberprÃ¼fen',0),(17244,479,'en','Check',0),(17245,480,'is','',0),(17246,480,'dr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ',0),(17247,480,'pr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ',0),(17248,480,'tr','Onay PetrÃ³va',0),(17249,480,'pl','SprawdÅº krÃ³tko',0),(17250,480,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð°ÐºÐ°Ð´ÐµÐ¼Ð¸Ñ‡Ð½Ð°',0),(17251,480,'ur','Abbr. Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17252,480,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ ÐÐ±Ð±Ñ€.',0),(17253,480,'vi','Viáº¿t táº¯t trÃªn SÃ©c',0),(17254,480,'af','Tjek Afkort.',0),(17255,480,'ro','Verifica Abbr.',0),(17256,480,'et','Vaata Abbr.',0),(17257,480,'si','Preverite pinjinu',0),(17258,480,'ba','Periksa singkatan',0),(17259,480,'nl','Selectievakje afgekort',0),(17260,480,'fi','Tarkista lyhyemmin',0),(17261,480,'no','NÃ¥r en',0),(17262,480,'da','Check Fork',0),(17263,480,'ko','ì•½ì‹ ê²€ì‚¬',0),(17264,480,'he','×‘×“×™×§×ª ×¨×©×•×ª',0),(17265,480,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÏƒÎµ ÏƒÏÎ½Ï„Î¼Î·ÏƒÎ·',0),(17266,480,'zh','æ£€æŸ¥ç¼©å†™ã€‚\r\n',0),(17267,480,'sv','Kontrollera teleoperatÃ¶r',0),(17268,480,'it','Verifica abbr',0),(17269,480,'tl','',0),(17270,480,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610; Abbr.',0),(17271,480,'hi','Abbr. à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17272,480,'ms','Semak Abbr.',0),(17273,480,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Abbr.',0),(17274,480,'fr','VÃ©rifier en abrÃ©gÃ©',0),(17275,480,'jp','ç•¥èªžã?®ç¢ºèª?',0),(17276,480,'pt','Abreviatura de seleÃ§Ã£o',0),(17277,480,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ ÑÐ¾ÐºÑ€.',0),(17278,480,'es','Cheque Abrev.',0),(17279,480,'de','KontrollkÃ¤stchen abk.',0),(17280,480,'en','Check Abbr.',0),(17281,481,'is','',0),(17282,481,'dr',' Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ',0),(17283,481,'pr',' Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ',0),(17284,481,'tr','Ã‡ek hesabÄ±',0),(17285,481,'pl','Rachunek czekowy',0),(17286,481,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(17287,481,'ur','Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹',0),(17288,481,'sr','Ð¢ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(17289,481,'vi','TK SÃ©c',0),(17290,481,'af','Nasien Rekening',0),(17291,481,'ro','Verificare cont',0),(17292,481,'et','Pangakonto',0),(17293,481,'si','Preverjanje raÄuna',0),(17294,481,'ba','Rekening Giro',0),(17295,481,'nl','Betaalrekening',0),(17296,481,'fi','Tarkkailun huomioon',0),(17297,481,'no','Brukskonto',0),(17298,481,'da','Checkkonto',0),(17299,481,'ko','ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(17300,481,'he','×—×©×‘×•×Ÿ ×‘× ×§',0),(17301,481,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÏŒÏˆÎµÏ‰Ï‚',0),(17302,481,'zh','æ”¯ç¥¨è´¦æˆ·\r\n',0),(17303,481,'sv','Checkkonto',0),(17304,481,'it','Conto corrente',0),(17305,481,'tl','',0),(17306,481,'th','&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(17307,481,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(17308,481,'ms','Memeriksa akaun',0),(17309,481,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø­Ø³Ø§Ø¨',0),(17310,481,'fr','Compte-chÃ¨ques',0),(17311,481,'jp','å½“åº§å‹˜å®š',0),(17312,481,'pt','Conta corrente',0),(17313,481,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÑ‡ÐµÑ‚Ð°',0),(17314,481,'es','Cuenta de Cheques',0),(17315,481,'de','Girokonto',0),(17316,481,'en','Checking Account',0),(17317,482,'is','',0),(17318,482,'dr','Ø­Ø³Ø§Ø¨ Ú†Ùƒ',0),(17319,482,'pr','Ø­Ø³Ø§Ø¨ Ú†Ùƒ',0),(17320,482,'tr','HesabÄ±nÄ±zÄ± kontrol edin',0),(17321,482,'pl','SprawdÅº konta',0),(17322,482,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(17323,482,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17324,482,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ñ€Ð°Ñ‡ÑƒÐ½',0),(17325,482,'vi','TK SÃ©c',0),(17326,482,'af','Tjekrekening',0),(17327,482,'ro','Verifica contul',0),(17328,482,'et','Kontrollige konto',0),(17329,482,'si','Preverite raÄun',0),(17330,482,'ba','Memeriksa rekening',0),(17331,482,'nl','-Account controleren',0),(17332,482,'fi','Tarkista',0),(17333,482,'no','Sjekk kontoen',0),(17334,482,'da','Check konto',0),(17335,482,'ko','ê³„ì • í™•ì¸',0),(17336,482,'he','×‘×“×™×§×ª ×—×©×‘×•×Ÿ',0),(17337,482,'el','Î•Ï€Î¹Ï„Î±Î³Î®',0),(17338,482,'zh','æ”¯ç¥¨æˆ·å£\r\n',0),(17339,482,'sv','Kontrollera konto',0),(17340,482,'it','Verifica Account',0),(17341,482,'tl','',0),(17342,482,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(17343,482,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17344,482,'ms','Semak akaun',0),(17345,482,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø­Ø³Ø§Ø¨',0),(17346,482,'fr','VÃ©rifier le compte',0),(17347,482,'jp','æ”¯æ‰•ã?„ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(17348,482,'pt','Verifique a conta',0),(17349,482,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚',0),(17350,482,'es','Chequear Cuenta',0),(17351,482,'de','Konto Ã¼berprÃ¼fen',0),(17352,482,'en','Check Account',0),(17353,483,'is','',0),(17354,483,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø­Ø³Ø§Ø¨ Ú†Ùƒ ',0),(17355,483,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø­Ø³Ø§Ø¨ Ú†Ùƒ ',0),(17356,483,'tr','Onay acct gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu.',0),(17357,483,'pl','Wyboru acct aktualizacja nie powiodÅ‚a siÄ™.',0),(17358,483,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° acct.',0),(17359,483,'ur','Ú†ÛŒÚ© Ø§Ú©Ú©Ù¹ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù… Û”',0),(17360,483,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°Ñ†Ñ†Ñ‚ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(17361,483,'vi','Cáº­p Nháº­t TK SÃ©c tháº¥t báº¡i',0),(17362,483,'af','Tjekrek. opdatering het gefaal.',0),(17363,483,'ro','Selectare acct actualizarea nu a reuÈ™it.',0),(17364,483,'et','VÃ¤ljaregistreerimine acct vÃ¤rskendamine nurjus.',0),(17365,483,'si','Potrdite acct posodobitev ni uspela.',0),(17366,483,'ba','Check acct update gagal.',0),(17367,483,'nl','Selectievakje acct bijwerken is mislukt.',0),(17368,483,'fi','Acct pÃ¤ivitys epÃ¤onnistui.',0),(17369,483,'no','Sjekk acct oppdatering mislyktes.',0),(17370,483,'da','Check acct opdateringen mislykkedes.',0),(17371,483,'ko','ì²´í¬ acct ì—…ë°ì´íŠ¸ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(17372,483,'he','×‘×“×™×§×ª ×—×©×‘×•×Ÿ ×¢×“×›×•×Ÿ × ×›×©×œ.',0),(17373,483,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï ÎµÎ»Î­Î³Ï‡Î¿Ï….',0),(17374,483,'zh','æ£€æŸ¥ä¼šè®¡æ›´æ–°å¤±è´¥ã€‚\r\n',0),(17375,483,'sv','Det gick inte att kontrollera acct uppdatera.',0),(17376,483,'it','Controllo acct aggiornamento fallito.',0),(17377,483,'tl','',0),(17378,483,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(17379,483,'hi','à¤šà¥‡à¤• acct à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¥‡à¥¤',0),(17380,483,'ms','Cek acct Kemaskini gagal.',0),(17381,483,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« acct Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±.',0),(17382,483,'fr','Cocher acct mise Ã  jour a Ã©chouÃ©.',0),(17383,483,'jp','å½“åº§å‹˜å®šã?®æ›´æ–°ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(17384,483,'pt','SeleÃ§Ã£o acct atualizaÃ§Ã£o falhou.',0),(17385,483,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ acct Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ.',0),(17386,483,'es','Chequear Cuenta actualizaciÃ³n fallÃ³',0),(17387,483,'de','KontrollkÃ¤stchen Acct Update fehlgeschlagen.',0),(17388,483,'en','Check acct update failed.',0),(17389,484,'is','',0),(17390,484,'dr','ØªØ§Ø±ÙŠØ® Ú†Ùƒ',0),(17391,484,'pr','ØªØ§Ø±ÙŠØ® Ú†Ùƒ',0),(17392,484,'tr','Onay tarihi',0),(17393,484,'pl','SprawdÅº datÄ™',0),(17394,484,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð´Ð°Ñ‚Ð°Ñ‚Ð°',0),(17395,484,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17396,484,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(17397,484,'vi','NgÃ y SÃ©c',0),(17398,484,'af','Tjek Datum',0),(17399,484,'ro','VerificaÅ£i data',0),(17400,484,'et','TÅ¡eki kuupÃ¤ev',0),(17401,484,'si','Preverite datum',0),(17402,484,'ba','Periksa tanggal',0),(17403,484,'nl','Datum controleren',0),(17404,484,'fi','Tarkista pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(17405,484,'no','Sjekke dato',0),(17406,484,'da','Kontrollere dato',0),(17407,484,'ko','ë‚ ì§œ í™•ì¸',0),(17408,484,'he','×‘×“×•×§ ×ª××¨×™×š',0),(17409,484,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(17410,484,'zh','æ£€æŸ¥æ—¥æœŸ\r\n',0),(17411,484,'sv','Kontrollera datum',0),(17412,484,'it','Controllare la data di',0),(17413,484,'tl','',0),(17414,484,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3594;&#3655;&#3588;',0),(17415,484,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17416,484,'ms','Semak tarikh',0),(17417,484,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØµÙƒ',0),(17418,484,'fr','VÃ©rifier la Date',0),(17419,484,'jp','è«‹æ±‚æ›¸æ”¯æ‰•ã?„æ—¥ä»˜',0),(17420,484,'pt','Verificar a data',0),(17421,484,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð´Ð°Ñ‚Ñƒ',0),(17422,484,'es','Cheque Fecha',0),(17423,484,'de','ÃœberprÃ¼fen Sie Datum',0),(17424,484,'en','Check Date',0),(17425,485,'is','',0),(17426,485,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¨Ø±Ú¯Ø´Øª Ø§Ø³Ù†Ø§Ø¯',0),(17427,485,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¨Ø±Ú¯Ø´Øª Ø§Ø³Ù†Ø§Ø¯',0),(17428,485,'tr','Kontrol belgesi geri koy',0),(17429,485,'pl','SprawdÅº ponownie dokument w',0),(17430,485,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾ Ð²',0),(17431,485,'ur','Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Ø¯Ø³ØªØ§ÙˆÛŒØ² ÙˆØ§Ù¾Ø³ Ù…ÛŒÚº',0),(17432,485,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð½Ð°Ñ‚Ñ€Ð°Ð³ Ñƒ',0),(17433,485,'vi','TÃ i liá»‡u SÃ©c vÃ o láº¡i',0),(17434,485,'af','Kontroleer Dokument Terug-In',0),(17435,485,'ro','VerificaÅ£i documentul Ã®napoi Ã®n',0),(17436,485,'et','Kontrollige dokumenti uuesti sisse',0),(17437,485,'si','Preverite dokument nazaj v',0),(17438,485,'ba','Periksa dokumen kembali di',0),(17439,485,'nl','Controleer Document terug In',0),(17440,485,'fi','Tarkista asiakirjan takaisin sisÃ¤Ã¤n',0),(17441,485,'no','Sjekk dokumentet tilbake i',0),(17442,485,'da','Tjek dokument tilbage i',0),(17443,485,'ko','í™•ì¸ ë¬¸ì„œì— ë‹¤ì‹œ',0),(17444,485,'he','×‘×“×•×§ ×ž×¡×ž×š ×—×–×¨×” ×¤× ×™×ž×”',0),(17445,485,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï€Î¯ÏƒÏ‰ Î­Î³Î³ÏÎ±Ï†Î¿ ÏƒÏ„Î¿',0),(17446,485,'zh','æ—©åœ¨æ£€æŸ¥æ–‡æ¡£\r\n',0),(17447,485,'sv','Kontrollera dokumentet tillbaka i',0),(17448,485,'it','Controllare il documento indietro nel',0),(17449,485,'tl','',0),(17450,485,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3585;&#3621;&#3633;&#3610;&#3648;&#3586;&#3657;&#3634;&#3652;&#3611;',0),(17451,485,'hi','à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤•à¥‹ à¤µà¤¾à¤ªà¤¸',0),(17452,485,'ms','Semak dokumen kembali dalam',0),(17453,485,'ar','ÙØ­Øµ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ ÙÙŠ',0),(17454,485,'fr','RÃ©archivez Document',0),(17455,485,'jp','æ–‡æ›¸ã‚’å†?ã?³ãƒ?ã‚§ãƒƒã‚¯ã‚¤ãƒ³',0),(17456,485,'pt','Confira documento de volta',0),(17457,485,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾ Ð²',0),(17458,485,'es','Chequear Documento RegresÃ³',0),(17459,485,'de','Checken Sie Dokument wieder In',0),(17460,485,'en','Check Document Back In',0),(17461,486,'is','',0),(17462,486,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯ ',0),(17463,486,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯ ',0),(17464,486,'tr','Belgeyi iade etme',0),(17465,486,'pl','Zaewidencjonuj dokument',0),(17466,486,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð²',0),(17467,486,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ù…ÛŒÚº Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(17468,486,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(17469,486,'vi','TÃ i liá»‡u SÃ©c vÃ o',0),(17470,486,'af','Kontroleer dokument',0),(17471,486,'ro','ArhivaÈ›i documentul',0),(17472,486,'et','Dokumendi sissemÃ¶llimine',0),(17473,486,'si','Sprosti dokument',0),(17474,486,'ba','Periksa dokumen dalam',0),(17475,486,'nl','Document inchecken',0),(17476,486,'fi','Tarkista asiakirja',0),(17477,486,'no','Innsjekking av dokument',0),(17478,486,'da','Tjekke dokumentet ind',0),(17479,486,'ko','ë¬¸ì„œ ì²´í¬ì¸',0),(17480,486,'he','×¦\'×§ ××™×Ÿ ×ž×¡×ž×š',0),(17481,486,'el','ÎœÎµÏ„Î±Î²Î¯Î²Î±ÏƒÎ· ÎµÎ»Î­Î³Ï‡Î¿Ï… ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(17482,486,'zh','æ£€æŸ¥æ–‡æ¡£\r\n',0),(17483,486,'sv','Kontrollera dokument',0),(17484,486,'it','Controllo del documento In',0),(17485,486,'tl','',0),(17486,486,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;',0),(17487,486,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤šà¥‡à¤• à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(17488,486,'ms','Menyemak dokumen',0),(17489,486,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(17490,486,'fr','Document de vÃ©rification dans',0),(17491,486,'jp','æ–‡æ›¸ã?®ãƒ?ã‚§ãƒƒã‚¯ã‚¤ãƒ³',0),(17492,486,'pt','Verificar o documento',0),(17493,486,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð²',0),(17494,486,'es','Ingresar Documento ',0),(17495,486,'de','Dokument einchecken',0),(17496,486,'en','Check Document In',0),(17497,487,'is','',0),(17498,487,'dr','(ØªØ³ÙˆÙŠÙ‡) Ø§Ø³Ù†Ø§Ø¯',0),(17499,487,'pr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù†(ØªØ³ÙˆÙŠÙ‡) Ø§Ø³Ù†Ø§Ø¯',0),(17500,487,'tr','Belgeyi kullanÄ±ma',0),(17501,487,'pl','SprawdÅº dokument',0),(17502,487,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(17503,487,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ø¨Ø§ÛØ± Ú©ÛŒ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„',0),(17504,487,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(17505,487,'vi','TÃ i liá»‡u SÃ©c ra',0),(17506,487,'af','Dokument check',0),(17507,487,'ro','VerificaÅ£i documentul',0),(17508,487,'et','Vaata dokumenti',0),(17509,487,'si','Preverite dokument',0),(17510,487,'ba','Memeriksa dokumen',0),(17511,487,'nl','Document uitchecken',0),(17512,487,'fi','Tarkistaa asiakirjan',0),(17513,487,'no','UndersÃ¸k dokument',0),(17514,487,'da','Tjek dokument',0),(17515,487,'ko','ë¬¸ì„œë¥¼ ì²´í¬ ì•„ì›ƒ',0),(17516,487,'he','×‘×“×•×§ ××ª ×”×ž×¡×ž×š',0),(17517,487,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î¿ Î­Î³Î³ÏÎ±Ï†Î¿',0),(17518,487,'zh','æ£€æŸ¥æ–‡ä»¶ä¸­çš„\r\n',0),(17519,487,'sv','Kolla dokument',0),(17520,487,'it','Scopri il documento',0),(17521,487,'tl','',0),(17522,487,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3629;&#3629;&#3585;',0),(17523,487,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17524,487,'ms','Menyemak dokumen',0),(17525,487,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(17526,487,'fr','Consultez le Document',0),(17527,487,'jp','æ–‡æ›¸ã?®ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆ',0),(17528,487,'pt','Confira o documento',0),(17529,487,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(17530,487,'es','Sacar Documento ',0),(17531,487,'de','Dokument auschecken',0),(17532,487,'en','Check Document Out',0),(17533,488,'is','',0),(17534,488,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø­ÙˆØ§Ù„Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡     ',0),(17535,488,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø­ÙˆØ§Ù„Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡     ',0),(17536,488,'tr','Ciranta kontrol',0),(17537,488,'pl','SprawdÅº promujÄ…cego',0),(17538,488,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡Ð¸Ñ‚ÐµÐ»',0),(17539,488,'ur','Endorser Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17540,488,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¶Ð¸Ñ€Ð°Ð½Ñ‚Ð°',0),(17541,488,'vi','ÄÃ³ng dáº¥u vÃ o SÃ©c',0),(17542,488,'af','Tjek Endossement',0),(17543,488,'ro','Verifica girant',0),(17544,488,'et','Kontrollige toetaja',0),(17545,488,'si','Preverite podpornik',0),(17546,488,'ba','Periksa Endorser',0),(17547,488,'nl','Selectievakje Endorser',0),(17548,488,'fi','Tarkista Endorser',0),(17549,488,'no','Sjekk Endorser',0),(17550,488,'da','Check Endorser',0),(17551,488,'ko','Endorser í™•ì¸',0),(17552,488,'he','×‘×“×•×§ Endorser',0),(17553,488,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÎµÏ€Î¹ÏƒÏ†ÏÎ¬Î³Î¹ÏƒÎ·Ï‚',0),(17554,488,'zh','æ£€æŸ¥ä»£è¨€äºº\r\n',0),(17555,488,'sv','Kontrollera Endorser',0),(17556,488,'it','Verifica Endorser',0),(17557,488,'tl','',0),(17558,488,'th','&#3612;&#3641;&#3657;&#3621;&#3591;&#3609;&#3634;&#3617;&#3648;&#3594;&#3655;&#3588;',0),(17559,488,'hi','Endorser à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17560,488,'ms','Periksa penyokong',0),(17561,488,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø£Ø¯Ø§Ø© Ø§Ù„Ø¥Ø¸Ù‡Ø§Ø±',0),(17562,488,'fr','VÃ©rifier l\'endosseur',0),(17563,488,'jp','å°?åˆ‡æ‰‹è£?æ›¸äºº',0),(17564,488,'pt','Verifique o endossante',0),(17565,488,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð¸Ð½Ð´Ð¾ÑÑÐ°Ð½Ñ‚Ð°',0),(17566,488,'es','Cheque Endosante',0),(17567,488,'de','KontrollkÃ¤stchen Endorser',0),(17568,488,'en','Check Endorser',0),(17569,489,'is','',0),(17570,489,'dr','(Ø¨Ø§Ù‚ÙŠØ¨ÛŒÙ„Ø§Ù†Ø³',0),(17571,489,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ø¯Ø± ØªØ±Ø§Ø²(Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡',0),(17572,489,'tr','Ä°NÃ‡ DENGE OLMADIÄžINI KONTROL EDÄ°N',0),(17573,489,'pl','SPRAWDÅ¹, CZY W RÃ“WNOWAGI',0),(17574,489,'bg','ÐŸÐ ÐžÐ’Ð•Ð Ð•Ð¢Ð• Ð”ÐÐ›Ð˜ Ð’ Ð‘ÐÐ›ÐÐÐ¡',0),(17575,489,'ur','Ø§Ú¯Ø± Ù…ÛŒÚº ØªÙˆØ§Ø²Ù† Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾Ù†Û’ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17576,489,'sr','ÐŸÐžÐ¢Ð’Ð Ð”Ð£ ÐÐšÐž Ð˜Ð Ð˜Ð—Ð‘ÐÐ›ÐÐÐ¡Ð˜Ð ÐÐÐ˜.',0),(17577,489,'vi','ÄÃ¡nh dáº¥u náº¿u cÃ¢n Ä‘á»‘i',0),(17578,489,'af','MERK INDIEN BALANSEER',0),(17579,489,'ro','VERIFICAÅ¢I DACÄ‚ ÃŽN ECHILIBRU',0),(17580,489,'et','SISSE, KUI TOLLI TASAKAALUS',0),(17581,489,'si','PREVERITE, ÄŒE V RAVNOVESJE',0),(17582,489,'ba','PERIKSA APAKAH DALAM KESEIMBANGAN',0),(17583,489,'nl','CONTROLEER OF IN EVENWICHT',0),(17584,489,'fi','TARKISTA IN TASAPAINO',0),(17585,489,'no','SJEKK HVIS I BALANSE',0),(17586,489,'da','CHECK HVIS I BALANCE',0),(17587,489,'ko','ë§Œì•½ì— ê· í˜• í™•ì¸',0),(17588,489,'he','×‘×“×•×§ ×× IN ×œ××–×Ÿ',0),(17589,489,'el','Î•Î›ÎˆÎ“ÎžÎ¤Î• Î‘Î Î£Î¤Î—Î Î™Î£ÎŸÎ¡Î¡ÎŸÎ ÎŠÎ‘',0),(17590,489,'zh','æ£€æŸ¥æ˜¯å¦å¹³è¡¡\r\n',0),(17591,489,'sv','KONTROLLERA OM I BALANS',0),(17592,489,'it','VERIFICA SE IN EQUILIBRIO',0),(17593,489,'tl','',0),(17594,489,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3651;&#3609;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(17595,489,'hi','à¤®à¥‡à¤‚ à¤¸à¤‚à¤¤à¥à¤²à¤¿à¤¤ à¤¹à¥ˆ, à¤¤à¥‹ à¤šà¥‡à¤•',0),(17596,489,'ms','SEMAK JIKA BAKI DALAM',0),(17597,489,'ar','Ù…Ø¹Ø±ÙØ© Ù…Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„ØªÙˆØ§Ø²Ù†',0),(17598,489,'fr','VÃ‰RIFIEZ SI EN Ã‰QUILIBRE',0),(17599,489,'jp','ç²¾ç®—ã?•ã‚Œã?¦ã?„ã?Ÿã‚‰ãƒ?ã‚§ãƒƒã‚¯ã?™ã‚‹',0),(17600,489,'pt','VERIFIQUE SE EM EQUILÃBRIO.',0),(17601,489,'ru','ÐŸÐ ÐžÐ’Ð•Ð Ð¬Ð¢Ð•, Ð•Ð¡Ð›Ð˜ Ð’ Ð‘ÐÐ›ÐÐÐ¡',0),(17602,489,'es','CHECAR SI EN BALANCE',0),(17603,489,'de','ÃœBERPRÃœFEN SIE, OB IN BALANCE',0),(17604,489,'en','CHECK IF IN BALANCE',0),(17605,490,'is','',0),(17606,490,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú†Ùƒ',0),(17607,490,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú†Ùƒ',0),(17608,490,'tr','Bilgi kontrol edin',0),(17609,490,'pl','SprawdÅº informacje',0),(17610,490,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(17611,490,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17612,490,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð˜Ð½Ñ„Ð¾',0),(17613,490,'vi','Kiá»ƒm tra thÃ´ng tin',0),(17614,490,'af','Tjek Inligting',0),(17615,490,'ro','Verifica informaÅ£ii',0),(17616,490,'et','Vaadake teave',0),(17617,490,'si','Preverite Info',0),(17618,490,'ba','Periksa Info',0),(17619,490,'nl','Selectievakje Info',0),(17620,490,'fi','Tarkista tiedot',0),(17621,490,'no','NÃ¥r Info',0),(17622,490,'da','Check Info',0),(17623,490,'ko','í™•ì¸ ì •ë³´',0),(17624,490,'he','×”×¡×™×ž×•×Ÿ ×¤×¨×˜×™',0),(17625,490,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î¿ Info',0),(17626,490,'zh','æŸ¥çœ‹è¯¦ç»†ä¿¡æ¯\r\n',0),(17627,490,'sv','Kolla Info',0),(17628,490,'it','Controllare le informazioni',0),(17629,490,'tl','',0),(17630,490,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3594;&#3655;&#3588;',0),(17631,490,'hi','à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17632,490,'ms','Semak maklumat',0),(17633,490,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(17634,490,'fr','VÃ©rifier les infos',0),(17635,490,'jp','å°?åˆ‡æ‰‹æƒ…å ±',0),(17636,490,'pt','Verificar a informaÃ§Ã£o',0),(17637,490,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ',0),(17638,490,'es','Comprobar Info',0),(17639,490,'de','Info zu Ã¼berprÃ¼fen',0),(17640,490,'en','Check Info',0),(17641,491,'is','',0),(17642,491,'dr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ',0),(17643,491,'pr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ',0),(17644,491,'tr','Kontrol #',0),(17645,491,'pl','SprawdÅº #',0),(17646,491,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ #',0),(17647,491,'ur','# Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17648,491,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ #',0),(17649,491,'vi','Sá»‘ SÃ©c',0),(17650,491,'af','Tjek#',0),(17651,491,'ro','Verifica #',0),(17652,491,'et','Kontrollige #',0),(17653,491,'si','Preverite #',0),(17654,491,'ba','Periksa #',0),(17655,491,'nl','# Controleer',0),(17656,491,'fi','Tarkista #',0),(17657,491,'no','Sjekk #',0),(17658,491,'da','Kontrollere #',0),(17659,491,'ko','# ì²´í¬',0),(17660,491,'he','#×¦\'×§',0),(17661,491,'el','Î•Î»Î­Î³Î¾Ï„Îµ #',0),(17662,491,'zh','æ£€æŸ¥ï¼ƒ\r\n',0),(17663,491,'sv','Kontrollera #',0),(17664,491,'it','Verifica #',0),(17665,491,'tl','',0),(17666,491,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&#3588;',0),(17667,491,'hi','à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ #',0),(17668,491,'ms','Semak #',0),(17669,491,'ar','Ø±Ù‚Ù… Ø§Ù„ØµÙƒ',0),(17670,491,'fr','VÃ©rifier #',0),(17671,491,'jp','è«‹æ±‚æ›¸æ”¯æ‰•ã?„ï¼ƒ',0),(17672,491,'pt','Verifique #',0),(17673,491,'ru','Ð§ÐµÐº#',0),(17674,491,'es','Cheque #',0),(17675,491,'de','# ÃœberprÃ¼fen',0),(17676,491,'en','Check #',0),(17677,492,'is','',0),(17678,492,'dr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ',0),(17679,492,'pr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ',0),(17680,492,'tr','Kontrol #',0),(17681,492,'pl','SprawdÅº #',0),(17682,492,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ #',0),(17683,492,'ur','# Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17684,492,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ #',0),(17685,492,'vi','Sá»‘ SÃ©c',0),(17686,492,'af','Tjek #',0),(17687,492,'ro','Verifica #',0),(17688,492,'et','Kontrollige #',0),(17689,492,'si','Preverite #',0),(17690,492,'ba','Periksa #',0),(17691,492,'nl','# Controleer',0),(17692,492,'fi','Tarkista #',0),(17693,492,'no','Sjekk #',0),(17694,492,'da','Kontrollere #',0),(17695,492,'ko','# ì²´í¬',0),(17696,492,'he','×‘×“×•×§ #',0),(17697,492,'el','Î•Î»Î­Î³Î¾Ï„Îµ #',0),(17698,492,'zh','æ£€æŸ¥ï¼ƒ\r\n',0),(17699,492,'sv','Kontrollera #',0),(17700,492,'it','Verifica #',0),(17701,492,'tl','',0),(17702,492,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&#3588;',0),(17703,492,'hi','à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ #',0),(17704,492,'ms','Semak #',0),(17705,492,'ar','Ø±Ù‚Ù… Ø§Ù„ØµÙƒ',0),(17706,492,'fr','VÃ©rifier #',0),(17707,492,'jp','å°?åˆ‡æ‰‹ç•ªå?·',0),(17708,492,'pt','Verifique #',0),(17709,492,'ru','Ð§ÐµÐº #',0),(17710,492,'es','Cheque #',0),(17711,492,'de','# ÃœberprÃ¼fen',0),(17712,492,'en','Check #',0),(17713,493,'is','',0),(17714,493,'dr','/ ØªØ³ÙˆÙŠÙ‡ ÙƒØ±Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù…Ø§ÛŒØ´',0),(17715,493,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙˆØ±ÙˆØ¯ / ØªØ³ÙˆÙŠÙ‡ ÙƒØ±Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(17716,493,'tr','Kontrol dÄ±ÅŸarÄ±/sipariÅŸ numarasÄ±',0),(17717,493,'pl','SprawdÅº siÄ™/w numeru zamÃ³wienia',0),(17718,493,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ/Ð² Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(17719,493,'ur','Ú†ÛŒÚ© Ø¢Ø¤Ù¹/Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ù…ÛŒÚº',0),(17720,493,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð¿Ð¾Ñ™Ðµ/Ñƒ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(17721,493,'vi','Kiá»ƒm Tra sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng vÃ o/ra',0),(17722,493,'af','Kontroleer uit/In orde nommer',0),(17723,493,'ro','A verifica afarÄƒ/Ã®n numÄƒrul de ordine',0),(17724,493,'et','Check Out/jÃ¤rjenumbri',0),(17725,493,'si','Check Out/zaporedno Å¡tevilko',0),(17726,493,'ba','Periksa luar/dalam nomor pesanan',0),(17727,493,'nl','Controleren/In ordernummer',0),(17728,493,'fi','Tarkista/jÃ¤rjestysnumeron',0),(17729,493,'no','Sjekk ut/inn bestillingsnummer',0),(17730,493,'da','Check Out/i lÃ¸benummer',0),(17731,493,'ko','ì²´í¬ ì•„ì›ƒ/ì£¼ë¬¸ ë²ˆí˜¸ì—',0),(17732,493,'he','×‘×“×•×§ ×”×—×•×¦×”/×‘×ž×¡×¤×¨ ×”×–×ž× ×”',0),(17733,493,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î­Î¾Ï‰/Ï„Î¬Î¾Î· Î±ÏÎ¹Î¸Î¼Î¿Ï',0),(17734,493,'zh','ç¦»åº—/ä¸ºäº†å·ç \r\n',0),(17735,493,'sv','Kolla in/i ordernummer',0),(17736,493,'it','Check Out/In numero di ordine',0),(17737,493,'tl','',0),(17738,493,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3586;&#3657;&#3634;/&#3629;&#3629;&#3585;',0),(17739,493,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤®à¥‡à¤‚/à¤•à¥‡ à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17740,493,'ms','Daftar keluar/masuk nombor pesanan',0),(17741,493,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù†/ÙÙŠ Ø±Ù‚Ù… Ø§Ù„ØªØ±ØªÙŠØ¨',0),(17742,493,'fr','Check Out/numÃ©ro d\'ordre',0),(17743,493,'jp','ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆ/ã‚¤ãƒ³ç•ªå?·é †',0),(17744,493,'pt','Check Out/nÃºmero de ordem',0),(17745,493,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Out/Ð² Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(17746,493,'es','Registrarse In/Out el NÃºmero de Pedido',0),(17747,493,'de','PrÃ¼fen Sie/Bestellnummer',0),(17748,493,'en','Check Out/In Order Number',0),(17749,494,'is','',0),(17750,494,'dr','ØªØ³ÙˆÙŠÙ‡ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´',0),(17751,494,'pr','ØªØ³ÙˆÙŠÙ‡ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´',0),(17752,494,'tr','Kontrol',0),(17753,494,'pl','SprawdÅº kolejnoÅ›Ä‡',0),(17754,494,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ñ€ÐµÐ´',0),(17755,494,'ur','Ù†Ú©Ø§Ù„ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17756,494,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜ Ñ€ÐµÐ´',0),(17757,494,'vi','Kiá»ƒm Tra Ä‘Æ¡n Ä‘áº·t hÃ ng ra',0),(17758,494,'af','Check uit orde',0),(17759,494,'ro','VerificaÅ£i comanda',0),(17760,494,'et','Check Out tellimus',0),(17761,494,'si','Oglejte si naroÄilo',0),(17762,494,'ba','Memeriksa pesanan',0),(17763,494,'nl','Bekijk bestelling',0),(17764,494,'fi','Tarkista tilaus',0),(17765,494,'no','Sjekk ut ordre',0),(17766,494,'da','Tjek rÃ¦kkefÃ¸lge',0),(17767,494,'ko','ìˆœì„œ í™•ì¸',0),(17768,494,'he','×‘×“×•×§ ×¡×“×¨',0),(17769,494,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î­Î¾Ï‰ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(17770,494,'zh','æ£€æŸ¥è®¢å•\r\n',0),(17771,494,'sv','Kolla in Order',0),(17772,494,'it','Controlla ordine',0),(17773,494,'tl','',0),(17774,494,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3629;&#3585;',0),(17775,494,'hi','à¤†à¤¦à¥‡à¤¶ à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17776,494,'ms','Menyemak perintah',0),(17777,494,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† ØªØ±ØªÙŠØ¨',0),(17778,494,'fr','DÃ©couvrez ordre',0),(17779,494,'jp','ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆé †',0),(17780,494,'pt','Confira em ordem',0),(17781,494,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(17782,494,'es','Despedirse el Pedido',0),(17783,494,'de','Schauen Sie sich die Reihenfolge',0),(17784,494,'en','Check Out Order',0),(17785,495,'is','',0),(17786,495,'dr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ ',0),(17787,495,'pr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ ',0),(17788,495,'tr','Onay Ã–zeti',0),(17789,495,'pl','Sprawdzenie podsumowania',0),(17790,495,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(17791,495,'ur','Ø®Ù„Ø§ØµÛ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17792,495,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(17793,495,'vi','Tá»•ng há»£p SÃ©c',0),(17794,495,'af','Tjek Opsomming',0),(17795,495,'ro','Verifica Rezumat',0),(17796,495,'et','Kontrollige KokkuvÃµte',0),(17797,495,'si','Preverite Povzetek',0),(17798,495,'ba','Periksa ringkasan',0),(17799,495,'nl','Selectievakje samenvatting',0),(17800,495,'fi','Tarkista Yhteenveto',0),(17801,495,'no','Sammendrag',0),(17802,495,'da','Check ResumÃ©',0),(17803,495,'ko','ê²€ì‚¬ ìš”ì•½',0),(17804,495,'he','×¡×™×›×•× ×¦\'×§×™×',0),(17805,495,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î·Î½ Ï€ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(17806,495,'zh','æ£€æŸ¥æ€»ç»“\r\n',0),(17807,495,'sv','Kontrollera Sammanfattning',0),(17808,495,'it','Controllare il riepilogo',0),(17809,495,'tl','',0),(17810,495,'th','&#3626;&#3619;&#3640;&#3611;&#3648;&#3594;&#3655;&#3588;',0),(17811,495,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17812,495,'ms','Menyemak ringkasan',0),(17813,495,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ù…Ù„Ø®Øµ',0),(17814,495,'fr','VÃ©rifiez le rÃ©sumÃ©',0),(17815,495,'jp','å°?åˆ‡æ‰‹ã‚µãƒžãƒªãƒ¼',0),(17816,495,'pt','Verifique o resumo',0),(17817,495,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(17818,495,'es','Resumen de Cheques',0),(17819,495,'de','ÃœberprÃ¼fen Sie die Zusammenfassung',0),(17820,495,'en','Check Summary',0),(17821,496,'is','',0),(17822,496,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ù†Ù‚Ø¯ Ù†Ø´Ø¯Ù†',0),(17823,496,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ù†Ù‚Ø¯ Ù†Ø´Ø¯Ù†',0),(17824,496,'tr','Uncash onay',0),(17825,496,'pl','SprawdÅº, Uncash',0),(17826,496,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Uncash',0),(17827,496,'ur','ÛŒÙˆÙ†Ú©Ø§Ø´ Ú©Û’ Ù„Ø¦Û’ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(17828,496,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´Ð° ÑÐµ Ð£Ð½Ñ†Ð°ÑÑ…',0),(17829,496,'vi','ÄÃ¡nh dáº¥u Ä‘á»ƒ khÃ´ng Ä‘á»•i tiá»n máº·t',0),(17830,496,'af','Kontroleer om te Uncash',0),(17831,496,'ro','VerificaÅ£i pentru a Uncash',0),(17832,496,'et','Sisse Uncash',0),(17833,496,'si','Preverite Uncash',0),(17834,496,'ba','Periksa untuk Uncash',0),(17835,496,'nl','Controleer Uncash',0),(17836,496,'fi','Tarkista Uncash',0),(17837,496,'no','Kontroller Uncash',0),(17838,496,'da','Kontrol af Uncash',0),(17839,496,'ko','Uncashë¥¼ í™•ì¸',0),(17840,496,'he','×‘×“×•×§ Uncash',0),(17841,496,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î³Î¹Î± Î½Î± Uncash',0),(17842,496,'zh','æ£€æŸ¥ä¸å…‘çŽ°\r\n',0),(17843,496,'sv','Kontrollera att Uncash',0),(17844,496,'it','Controllo di Uncash',0),(17845,496,'tl','',0),(17846,496,'th','&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3594;&#3655;&#3588;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;',0),(17847,496,'hi','Uncash à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17848,496,'ms','Masuk ke Uncash',0),(17849,496,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø£ÙˆÙ†ÙƒØ§Ø´',0),(17850,496,'fr','VÃ©rifier Uncash',0),(17851,496,'jp','æœªæ?›é‡‘ã?®å°?åˆ‡æ‰‹',0),(17852,496,'pt','SeleÃ§Ã£o de Uncash',0),(17853,496,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ, Uncash',0),(17854,496,'es','Chequear para no cambiar cheque',0),(17855,496,'de','ÃœberprÃ¼fen Sie, Uncash',0),(17856,496,'en','Check to Uncash',0),(17857,497,'is','',0),(17858,497,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ø¨Ø§Ø·Ù„ Ù†ÙƒØ±Ø¯Ù†',0),(17859,497,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ø¨Ø§Ø·Ù„ Ù†ÙƒØ±Ø¯Ù†',0),(17860,497,'tr','Unvoid iÃ§in kontrol edin',0),(17861,497,'pl','SprawdÅº, Unvoid',0),(17862,497,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Unvoid',0),(17863,497,'ur','ÛŒÙˆÙ†ÙˆÙˆØ§Úˆ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17864,497,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð½Ð° Ð£Ð½Ð²Ð¾Ð¸Ð´',0),(17865,497,'vi','ÄÃ¡nh dáº¥u Ä‘á»ƒ xÃ³a',0),(17866,497,'af','Kontroleer Unvoid',0),(17867,497,'ro','Verifica la Unvoid',0),(17868,497,'et','Kontrollige, Unvoid',0),(17869,497,'si','Preverite Unvoid',0),(17870,497,'ba','Periksa Unvoid',0),(17871,497,'nl','Unvoid controleren',0),(17872,497,'fi','Tarkista Unvoid',0),(17873,497,'no','Se Unvoid',0),(17874,497,'da','Kontroller at Unvoid',0),(17875,497,'ko','Unvoid í™•ì¸',0),(17876,497,'he','×‘×“×•×§ Unvoid',0),(17877,497,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î³Î¹Î± Î½Î± Unvoid',0),(17878,497,'zh','æ£€æŸ¥ä¸ä½œåºŸ\r\n',0),(17879,497,'sv','Kontrollera att Unvoid',0),(17880,497,'it','Verifica di Unvoid',0),(17881,497,'tl','',0),(17882,497,'th','&#3648;&#3594;&#3655;&#3588;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(17883,497,'hi','Unvoid à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17884,497,'ms','Semak untuk Unvoid',0),(17885,497,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø£ÙˆÙ†ÙÙˆÙŠØ¯',0),(17886,497,'fr','VÃ©rifier Ã  Unvoid',0),(17887,497,'jp','æœªç ´æ£„ã?®å°?åˆ‡æ‰‹',0),(17888,497,'pt','Verificar a Unvoid',0),(17889,497,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Unvoid',0),(17890,497,'es','Chequear para Desanular',0),(17891,497,'de','ÃœberprÃ¼fen auf Unvoid',0),(17892,497,'en','Check to Unvoid',0),(17893,498,'is','',0),(17894,498,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(17895,498,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(17896,498,'tr','Onay gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu.',0),(17897,498,'pl','Sprawdzanie aktualizacji nie powiodÅ‚o siÄ™.',0),(17898,498,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°.',0),(17899,498,'ur','Ú†ÛŒÚ© Ø§Ù¾ ÚˆÛŒÙ¹ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§ Û”',0),(17900,498,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(17901,498,'vi','Cáº­p Nháº­t SÃ©c tháº¥t báº¡i',0),(17902,498,'af','Tjek opdatering het gefaal.',0),(17903,498,'ro','Verifica update nu a reuÈ™it.',0),(17904,498,'et','VÃ¤ljaregistreerimine vÃ¤rskendamine nurjus.',0),(17905,498,'si','Preverjanje posodobitev ni uspela.',0),(17906,498,'ba','Check update gagal.',0),(17907,498,'nl','Het selectievakje bijwerken mislukt.',0),(17908,498,'fi','PÃ¤ivitys epÃ¤onnistui.',0),(17909,498,'no','Sjekk oppdatering mislyktes.',0),(17910,498,'da','Tjek opdatering mislykkedes.',0),(17911,498,'ko','í‘œ ì—…ë°ì´íŠ¸ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(17912,498,'he','×”×¡×™×ž×•×Ÿ ×¢×“×›×•×Ÿ × ×›×©×œ.',0),(17913,498,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… ÎµÎ»Î­Î³Ï‡Î¿Ï….',0),(17914,498,'zh','æ£€æŸ¥æ›´æ–°å¤±è´¥ã€‚\r\n',0),(17915,498,'sv','Det gick inte att kontrollera uppdatera.',0),(17916,498,'it','Controllo aggiornamento fallito.',0),(17917,498,'tl','',0),(17918,498,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3594;&#3655;&#3588;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(17919,498,'hi','à¤šà¥‡à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¥‡à¥¤',0),(17920,498,'ms','Kemaskini Daftar gagal.',0),(17921,498,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±.',0),(17922,498,'fr','VÃ©rification de mise Ã  jour a Ã©chouÃ©.',0),(17923,498,'jp','å°?åˆ‡æ‰‹ã?®æ›´æ–°ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(17924,498,'pt','Falha de verificaÃ§Ã£o de atualizaÃ§Ã£o.',0),(17925,498,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ.',0),(17926,498,'es','ActualizaciÃ³n de Cheque FallÃ³',0),(17927,498,'de','KontrollkÃ¤stchen Aktualisierung ist fehlgeschlagen.',0),(17928,498,'en','Check update failed.',0),(17929,499,'is','',0),(17930,499,'dr','Ú†Ùƒ Ø¨Ø§Ø·Ù„  Ø§Ø³Øª',0),(17931,499,'pr','Ú†Ùƒ Ø¨Ø§Ø·Ù„  Ø§Ø³Øª',0),(17932,499,'tr','BoÅŸluÄŸu kontrol',0),(17933,499,'pl','SprawdÅº Void',0),(17934,499,'bg','Void Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(17935,499,'ur','Ø®Ù„Ø§ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(17936,499,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ñƒ',0),(17937,499,'vi','XÃ³a SÃ©c',0),(17938,499,'af','Tjek leemte',0),(17939,499,'ro','VerificaÅ£i vid',0),(17940,499,'et','Kontrollige Void',0),(17941,499,'si','Preveri neveljavne',0),(17942,499,'ba','Periksa kekosongan',0),(17943,499,'nl','Void controleren',0),(17944,499,'fi','Tarkista tyhjiÃ¶',0),(17945,499,'no','Sjekk Void',0),(17946,499,'da','Check tomrum',0),(17947,499,'ko','ë¬´íš¨ í™•ì¸',0),(17948,499,'he','×‘×“×•×§ ××ª ×”×—×œ×œ ×”×¨×™×§',0),(17949,499,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î¿ ÎºÎµÎ½ÏŒ',0),(17950,499,'zh','æ£€æŸ¥æ— æ•ˆ\r\n',0),(17951,499,'sv','Kontrollera Void',0),(17952,499,'it','Controllare il vuoto',0),(17953,499,'tl','',0),(17954,499,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3594;&#3655;&#3588;',0),(17955,499,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(17956,499,'ms','Semak kekosongan',0),(17957,499,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„ÙØ±Ø§Øº',0),(17958,499,'fr','VÃ©rifier le vide',0),(17959,499,'jp','å°?åˆ‡æ‰‹ã?®ç ´æ£„',0),(17960,499,'pt','Cheque Void',0),(17961,499,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Void',0),(17962,499,'es','Cheque Nulo',0),(17963,499,'de','Void zu Ã¼berprÃ¼fen',0),(17964,499,'en','Check Void',0),(17965,500,'is','',0),(17966,500,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ',0),(17967,500,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ',0),(17968,500,'tr','Onay yazma',0),(17969,500,'pl','Wyboru pisania',0),(17970,500,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¿Ð¸ÑÐ°Ð½Ðµ',0),(17971,500,'ur','Ú†ÛŒÚ© Ø§Ù† Ú©ÛŒ ØªØ­Ø±ÛŒØ±',0),(17972,500,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¿Ð¸ÑÐ°ÑšÐµ',0),(17973,500,'vi','Viáº¿t SÃ©c',0),(17974,500,'af','Tjeks Uitskrywe',0),(17975,500,'ro','Scris de verificare',0),(17976,500,'et','Sisse kirjutamine',0),(17977,500,'si','Pisno preverjanje',0),(17978,500,'ba','Check menulis',0),(17979,500,'nl','Selectievakje schrijven',0),(17980,500,'fi','Uloskirjautuminen kirjoittaminen',0),(17981,500,'no','Sjekk skriving',0),(17982,500,'da','Check skriftligt',0),(17983,500,'ko','í™•ì¸ ì„œ ë©´',0),(17984,500,'he','×›×ª×™×‘×ª ×¡×™×ž×•×Ÿ',0),(17985,500,'el','Î•Î»Î­Î³Ï‡Î¿Ï… Î³ÏÎ±Ï†Î®Ï‚',0),(17986,500,'zh','æ”¯ç¥¨\r\n',0),(17987,500,'sv','Du skriva',0),(17988,500,'it','Controllo scrittura',0),(17989,500,'tl','',0),(17990,500,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;',0),(17991,500,'hi','à¤šà¥‡à¤• à¤²à¥‡à¤–à¤¨',0),(17992,500,'ms','Semak bertulis',0),(17993,500,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(17994,500,'fr','Cocher Ã©criture',0),(17995,500,'jp','å°?åˆ‡æ‰‹ã?®æ›¸ã??è¾¼ã?¿',0),(17996,500,'pt','VerificaÃ§Ã£o escrita',0),(17997,500,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(17998,500,'es','Escribir Cheque',0),(17999,500,'de','KontrollkÃ¤stchen Writing',0),(18000,500,'en','Check Writing',0),(18001,501,'is','',0),(18002,501,'dr','Ø´Ù…Ø§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ú†Ùƒ Ù‚Ø¨Ù„ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø¬Ø§Ø±Ù‰ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯',0),(18003,501,'pr','Ø´Ù…Ø§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ú†Ùƒ Ù‚Ø¨Ù„ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø¬Ø§Ø±Ù‰ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯',0),(18004,501,'tr','Kontrol bir tarihten Ã¶nce geÃ§erli tarihi girdiniz!',0),(18005,501,'pl','Wprowadzono sprawdziÄ‡ daty bieÅ¼Ä…cej daty!',0),(18006,501,'bg','Ð¡Ñ‚Ðµ Ð²ÑŠÐ²ÐµÐ»Ð¸ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¿Ñ€ÐµÐ´Ð¸ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°!',0),(18007,501,'ur','Ø¢Ù¾ Ø­Ø§Ù„ÛŒÛ ØªØ§Ø±ÛŒØ® Ø³Û’ Ù¾ÛÙ„Û’ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø¯Ø§Ø®Ù„ Ú©ÛŒØ§ ÛÛ’!',0),(18008,501,'sr','Ð£Ð½ÐµÑÐµÑ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ðµ Ð´Ð°Ð½Ð°ÑˆÑšÐµÐ³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°, Ñ‡ÐµÐºÐ°!',0),(18009,501,'vi','Báº¡n Ä‘Ã£ nháº­p má»™t ngÃ y SÃ©c trÆ°á»›c ngÃ y hiá»‡n táº¡i',0),(18010,501,'af','U het \'n Tjekdatum ingevoer vroeÃ«r as die huidige datum!',0),(18011,501,'ro','AÅ£i introdus o datÄƒ verificaÅ£i Ã®nainte de data curentÄƒ!',0),(18012,501,'et','Sisestatud kontrollida algas enne praeguse kuupÃ¤eva!',0),(18013,501,'si','Vnesli ste preverite datum pred trenutni datum!',0),(18014,501,'ba','Anda telah memasukkan tanggal memeriksa sebelum tanggal sekarang!',0),(18015,501,'nl','U hebt een datum controleren voorafgaand aan de huidige datum ingevoerd!',0),(18016,501,'fi','Olet syÃ¶ttÃ¤nyt Tarkista pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ nykyisen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n!',0),(18017,501,'no','Du har angitt sjekke datoer fÃ¸r dagens dato!',0),(18018,501,'da','Du har indtastet en checkdato fÃ¸r dags dato!',0),(18019,501,'ko','í™•ì¸ ë‚ ì§œ ì „ì— í˜„ìž¬ ë‚ ì§œë¥¼ ìž…ë ¥ í–ˆìŠµë‹ˆë‹¤!',0),(18020,501,'he','×”×–× ×ª ×ª××¨×™×š ×œ×‘×“×•×§ ×œ×¤× ×™ ×”×ª××¨×™×š ×”× ×•×›×—×™!',0),(18021,501,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ»Î­Î³Î¾ÎµÏ„Îµ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±!',0),(18022,501,'zh','æ‚¨æ‰€è¾“å…¥çš„æ—¥æœŸæ—©äºŽçŽ°åœ¨æ—¥æœŸï¼\r\n',0),(18023,501,'sv','Du har angett en kontrollera datum fÃ¶re dagens datum!',0),(18024,501,'it','Immessa una data verifica prima della data corrente!',0),(18025,501,'tl','',0),(18026,501,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3611;&#3657;&#3629;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3594;&#3655;&#3588;&#3585;&#3656;&#3629;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3611;&#3633;&#3592;&#3592;&#3640;&#3',0),(18027,501,'hi','à¤†à¤ª à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ!',0),(18028,501,'ms','Anda telah memasukkan tarikh semak sebelum tarikh semasa!',0),(18029,501,'ar','Ù„Ù‚Ø¯ Ù‚Ù…Øª Ø¨Ø¥Ø¯Ø®Ø§Ù„ \"ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ­Ù‚Ù‚\" Ù‚Ø¨Ù„ Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø§Ù„ÙŠ!',0),(18030,501,'fr','Vous avez entrÃ© une Date chÃ¨que avant la date du jour !',0),(18031,501,'jp','æ”¯æ‰•æ—¥å‰?ã?®æ—¥ä»˜ã?Œå…¥åŠ›ã?•ã‚Œã?¾ã?—ã?Ÿï¼?',0),(18032,501,'pt','VocÃª digitou uma data verificar antes da data atual!',0),(18033,501,'ru','Ð’Ñ‹ Ð·Ð°ÑˆÐ»Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð´Ð°Ñ‚Ñƒ, Ð¿Ñ€ÐµÐ´ÑˆÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÑƒÑŽ Ñ‚ÐµÐºÑƒÑ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹!',0),(18034,501,'es','Ha entrado una Fecha de Cheque antes que la Fecha actual',0),(18035,501,'de','Sie haben ein Datum Ã¼berprÃ¼fen vor dem aktuellen Datum eingegeben!',0),(18036,501,'en','You have entered a Check Date prior to current date!',0),(18037,502,'is','',0),(18038,502,'dr','(ØªØ·Ø¨ÙŠÙ‚ Ø¯Ø§Ø¯Ù†',0),(18039,502,'pr','ØªØ³ÙˆÙŠÙ‡ Ø­Ø³Ø§Ø¨ ÙƒØ±Ø¯Ù† (ØªØ·Ø¨ÙŠÙ‚ Ø¯Ø§Ø¯Ù†',0),(18040,502,'tr','KullanÄ±ma alÄ±nmÄ±ÅŸ',0),(18041,502,'pl','Wyewidencjonowany',0),(18042,502,'bg','Ð˜Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(18043,502,'ur','Ø®Ø§Ø±Ø¬ Ú©Ø± Ø¯ÛŒØ§',0),(18044,502,'sr','ÐžÐ´Ñ˜Ð°Ð²Ñ™ÐµÐ½',0),(18045,502,'vi','RÃºt ra',0),(18046,502,'af','Nagegaan het',0),(18047,502,'ro','Verificat',0),(18048,502,'et','VÃ¤lja mÃ¶llitud',0),(18049,502,'si','Rezerviran',0),(18050,502,'ba','Memeriksa',0),(18051,502,'nl','Uitgecheckt',0),(18052,502,'fi','Kuitattu ulos',0),(18053,502,'no','Sjekket ut',0),(18054,502,'da','Tjekket ud',0),(18055,502,'ko','ì²´í¬ ì•„ì›ƒ',0),(18056,502,'he','×‘×“×§×ª×™',0),(18057,502,'el','ÎˆÎ»ÎµÎ³Î¾Î± Î­Î¾Ï‰',0),(18058,502,'zh','ç­¾å‡º\r\n',0),(18059,502,'sv','Checkat ut',0),(18060,502,'it','Check-Out',0),(18061,502,'tl','',0),(18062,502,'th','&#3648;&#3594;&#3655;&#3588;&#3629;&#3629;&#3585;',0),(18063,502,'hi','à¤šà¥‡à¤• à¤†à¤‰à¤Ÿ',0),(18064,502,'ms','Menyemak',0),(18065,502,'ar','Ø³Ø­Ø¨',0),(18066,502,'fr','Extrait',0),(18067,502,'jp','ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆ',0),(18068,502,'pt','Check-Out',0),(18069,502,'ru','Ð˜Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(18070,502,'es','Chequeado',0),(18071,502,'de','Ausgecheckt',0),(18072,502,'en','Checked Out',0),(18073,503,'is','',0),(18074,503,'dr','Ú†Ùƒ',0),(18075,503,'pr','Ú†Ùƒ',0),(18076,503,'tr','Denetleme',0),(18077,503,'pl','Sprawdzanie',0),(18078,503,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(18079,503,'ur','Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(18080,503,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð°',0),(18081,503,'vi','Kiá»ƒm tra',0),(18082,503,'af','Kontroleer',0),(18083,503,'ro','Verificarea',0),(18084,503,'et','Kontrollimine',0),(18085,503,'si','Preverjanje',0),(18086,503,'ba','Memeriksa',0),(18087,503,'nl','Controleren',0),(18088,503,'fi','Tarkistaminen',0),(18089,503,'no','Kontrollere',0),(18090,503,'da','Kontrol',0),(18091,503,'ko','ê²€ì‚¬',0),(18092,503,'he','×‘×“×™×§×ª',0),(18093,503,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚',0),(18094,503,'zh','æ”¯ç¥¨\r\n',0),(18095,503,'sv','Kontrollera',0),(18096,503,'it','Controllo',0),(18097,503,'tl','',0),(18098,503,'th','&#3648;&#3594;&#3655;&#3588;',0),(18099,503,'hi','à¤œà¤¾à¤à¤š à¤¹à¥‹ à¤°à¤¹à¥€',0),(18100,503,'ms','Menyemak',0),(18101,503,'ar','Ø§Ù„ØªØ­Ù‚Ù‚',0),(18102,503,'fr','VÃ©rification',0),(18103,503,'jp','ç¢ºèª?ä¸­',0),(18104,503,'pt','VerificaÃ§Ã£o de',0),(18105,503,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(18106,503,'es','Cuenta Bancaria',0),(18107,503,'de','ÃœberprÃ¼fung',0),(18108,503,'en','Checking',0),(18109,504,'is','',0),(18110,504,'dr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰',0),(18111,504,'pr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰',0),(18112,504,'tr','Ã‡ek hesabÄ±',0),(18113,504,'pl','Rachunek czekowy',0),(18114,504,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(18115,504,'ur','Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹',0),(18116,504,'sr','Ð¢ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(18117,504,'vi','Kiá»ƒm Tra TK',0),(18118,504,'af','Tjekrekening',0),(18119,504,'ro','Verificare cont',0),(18120,504,'et','Pangakonto',0),(18121,504,'si','Preverjanje raÄuna',0),(18122,504,'ba','Rekening Giro',0),(18123,504,'nl','Betaalrekening',0),(18124,504,'fi','Tarkkailun huomioon',0),(18125,504,'no','Brukskonto',0),(18126,504,'da','Checkkonto',0),(18127,504,'ko','ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(18128,504,'he','×—×©×‘×•×Ÿ ×‘× ×§',0),(18129,504,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÏŒÏˆÎµÏ‰Ï‚',0),(18130,504,'zh','æ”¯ç¥¨è´¦æˆ·\r\n',0),(18131,504,'sv','Checkkonto',0),(18132,504,'it','Conto corrente',0),(18133,504,'tl','',0),(18134,504,'th','&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(18135,504,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(18136,504,'ms','Memeriksa akaun',0),(18137,504,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ',0),(18138,504,'fr','Compte-chÃ¨ques',0),(18139,504,'jp','ãƒ?ã‚§ãƒƒã‚¯ç”¨ã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(18140,504,'pt','Conta corrente',0),(18141,504,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÑ‡ÐµÑ‚Ð°',0),(18142,504,'es','Cuenta de Cheques',0),(18143,504,'de','Girokonto',0),(18144,504,'en','Checking Account',0),(18145,505,'is','',0),(18146,505,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰',0),(18147,505,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰',0),(18148,505,'tr','Yeni Ã§ek hesabÄ±',0),(18149,505,'pl','Nowe konto bankowe',0),(18150,505,'bg','ÐÐ¾Ð²Ð° Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(18151,505,'ur','Ù†Ø¦Û’ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹',0),(18152,505,'sr','ÐÐ¾Ð²Ð¸ Ð±Ð°Ð½ÐºÐ¾Ð²Ð½Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(18153,505,'vi','ThÃªm TK SÃ©c',0),(18154,505,'af','Tjekrekening Bygevoeg',0),(18155,505,'ro','Noul cont de verificare',0),(18156,505,'et','Uue pangakonto',0),(18157,505,'si','Nov banÄni raÄun',0),(18158,505,'ba','Rekening baru',0),(18159,505,'nl','Nieuwe betaalrekening',0),(18160,505,'fi','Uusi pankkitililtÃ¤si',0),(18161,505,'no','Nye brukskonto',0),(18162,505,'da','Nye checkkonto',0),(18163,505,'ko','ìƒˆë¡œìš´ ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(18164,505,'he','×—×©×‘×•×Ÿ ×‘× ×§ ×—×“×©',0),(18165,505,'el','ÎÎ­Î¿ Î±Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(18166,505,'zh','æ”¯ç¥¨å¸æˆ·æ·»åŠ \r\n',0),(18167,505,'sv','Nya checkkonto',0),(18168,505,'it','Nuovo conto corrente',0),(18169,505,'tl','',0),(18170,505,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(18171,505,'hi','à¤¨à¤ à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(18172,505,'ms','Baru menyemak akaun',0),(18173,505,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ',0),(18174,505,'fr','Nouveau compte-chÃ¨ques',0),(18175,505,'jp','å½“åº§é ?é‡‘å?£åº§ã?®è¿½åŠ ',0),(18176,505,'pt','Nova conta corrente',0),(18177,505,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚',0),(18178,505,'es','Cuenta de Cheques Agregar',0),(18179,505,'de','Neues Girokonto',0),(18180,505,'en','New Checking Account',0),(18181,506,'is','',0),(18182,506,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(18183,506,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(18184,506,'tr','Ã‡ek hesabÄ± baÅŸarÄ±yla eklendi',0),(18185,506,'pl','PomyÅ›lnie dodano konto czekowe',0),(18186,506,'bg','Ð Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(18187,506,'ur','Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(18188,506,'sr','Ð¢ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(18189,506,'vi','ThÃªm TK SÃ©c ThÃ nh CÃ´ng',0),(18190,506,'af','Tjekrekening suksesvol bygevoeg',0),(18191,506,'ro','Cont de verificare adÄƒugat cu succes',0),(18192,506,'et','Lisatud pangakonto',0),(18193,506,'si','TekoÄi raÄun uspeÅ¡no dodan',0),(18194,506,'ba','Rekening ditambahkan berhasil',0),(18195,506,'nl','Betaalrekening toegevoegd',0),(18196,506,'fi','Tarkistaa tilin lisÃ¤Ã¤minen onnistui',0),(18197,506,'no','Brukskonto lagt',0),(18198,506,'da','Checkkonto tilfÃ¸jet',0),(18199,506,'ko','ë‹¹ì¢Œ ê³„ì •ì„ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(18200,506,'he','×—×©×‘×•×Ÿ ×‘× ×§ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(18201,506,'el','Î¤ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(18202,506,'zh','æ”¯ç¥¨å¸æˆ·æ·»åŠ æˆåŠŸ\r\n',0),(18203,506,'sv','Checkkonto lagts',0),(18204,506,'it','Conto corrente aggiunto con successo',0),(18205,506,'tl','',0),(18206,506,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(18207,506,'hi','à¤šà¥‡à¤•à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(18208,506,'ms','Memeriksa akaun berjaya menambah',0),(18209,506,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(18210,506,'fr','Compte-chÃ¨ques ajoutÃ© avec succÃ¨s',0),(18211,506,'jp','å½“åº§é ?é‡‘å?£åº§ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(18212,506,'pt','Conta corrente adicionada com sucesso',0),(18213,506,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(18214,506,'es','Cuenta de Cheques agregada exitosamente',0),(18215,506,'de','Girokonto erfolgreich hinzugefÃ¼gt',0),(18216,506,'en','Checking Account added successfully',0),(18217,507,'is','',0),(18218,507,'dr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(18219,507,'pr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(18220,507,'tr','Ã‡ek hesabÄ± zaten var',0),(18221,507,'pl','Konto czekowe juÅ¼ istnieje',0),(18222,507,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(18223,507,'ur','Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(18224,507,'sr','Ð¢ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(18225,507,'vi','TK SÃ©c Ä‘Ã£ tá»“n táº¡i',0),(18226,507,'af','Tjekrekening bestaan alreeds',0),(18227,507,'ro','Verificare cont existÄƒ deja',0),(18228,507,'et','Pangakonto on juba olemas',0),(18229,507,'si','TekoÄi raÄun Å¾e obstaja',0),(18230,507,'ba','Rekening sudah ada',0),(18231,507,'nl','Betaalrekening bestaat al',0),(18232,507,'fi','Tarkkailun huomioon jo',0),(18233,507,'no','Det finnes allerede en brukskonto',0),(18234,507,'da','Checkkonto findes allerede',0),(18235,507,'ko','ë‹¹ì¢Œ ê³„ì •ì´ ì´ë¯¸ ì¡´ìž¬',0),(18236,507,'he','×§×™×™× ×›×‘×¨ ×—×©×‘×•×Ÿ ×‘× ×§',0),(18237,507,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÏŒÏˆÎµÏ‰Ï‚',0),(18238,507,'zh','æ”¯ç¥¨å¸æˆ·å·²å­˜åœ¨\r\n',0),(18239,507,'sv','LÃ¶nekonto finns redan',0),(18240,507,'it','Conto corrente giÃ  esistente',0),(18241,507,'tl','',0),(18242,507,'th','&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(18243,507,'hi','à¤šà¥‡à¤•à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(18244,507,'ms','Memeriksa akaun telah wujud',0),(18245,507,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(18246,507,'fr','Compte-chÃ¨ques existe dÃ©jÃ ',0),(18247,507,'jp','å½“åº§é ?é‡‘å?£åº§ã?¯æ—¢ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(18248,507,'pt','Conta jÃ¡ existe.',0),(18249,507,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(18250,507,'es','Cuenta de Cheques ya existe',0),(18251,507,'de','Girokonto ist bereits vorhanden.',0),(18252,507,'en','Checking Account already exists',0),(18253,508,'is','',0),(18254,508,'dr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰  ØªØ§Ø±ÙŠØ®  Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ ',0),(18255,508,'pr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰  ØªØ§Ø±ÙŠØ®  Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ ',0),(18256,508,'tr','Ã‡ek hesabÄ±, tarihi, kontrol #',0),(18257,508,'pl','Konto czekowe, data, sprawdÅº #',0),(18258,508,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°, Ð´Ð°Ñ‚Ð°Ñ‚Ð°, Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ #',0),(18259,508,'ur','Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ØŒ ØªØ§Ø±ÛŒØ®ØŒ # Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(18260,508,'sr','Ð¢ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½, Ð´Ð°Ñ‚ÑƒÐ¼, Ð²Ð¸Ð´Ð¸ #',0),(18261,508,'vi','TK SÃ©c: NgÃ y, Sá»‘ SÃ©c',0),(18262,508,'af','Tjekrekening, Datum, Tjek #',0),(18263,508,'ro','Verificare cont, data, verifica #',0),(18264,508,'et','Pangakonto, kuupÃ¤ev, kontrollige #',0),(18265,508,'si','Preverjanje raÄuna, datum, preverite #',0),(18266,508,'ba','Rekening, tanggal, memeriksa #',0),(18267,508,'nl','Betaalrekening, datum, controleren #',0),(18268,508,'fi','Tarkkailun huomioon, pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤, tarkista #',0),(18269,508,'no','Brukskonto, dato, sjekk #',0),(18270,508,'da','Checkkonto, dato, tjekke #',0),(18271,508,'ko','ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ, ë‚ ì§œ, í™•ì¸ #',0),(18272,508,'he','×—×©×‘×•×Ÿ ×‘× ×§, ×ª××¨×™×š, ×‘×“×•×§ #',0),(18273,508,'el','Î¤ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ, Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±, ÎµÎ»Î­Î³Î¾Ï„Îµ #',0),(18274,508,'zh','æ”¯ç¥¨å¸æˆ·ï¼Œæ—¥æœŸï¼Œæ”¯ç¥¨ï¼ƒ\r\n',0),(18275,508,'sv','LÃ¶nekonto, datum, kolla #',0),(18276,508,'it','Conto corrente, data, verifica #',0),(18277,508,'tl','',0),(18278,508,'th','&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637; &#3623;&#3633;&#3609;&#3607;&#3637;&#3656; &#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;',0),(18279,508,'hi','à¤œà¤¾à¤à¤š à¤–à¤¾à¤¤à¥‡, à¤¦à¤¿à¤¨à¤¾à¤‚à¤•, à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ #',0),(18280,508,'ms','Memeriksa akaun, tarikh, semak #',0),(18281,508,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ , Ø§Ù„ØªØ§Ø±ÙŠØ® , Ø±Ù‚Ù… Ø§Ù„ØµÙƒÙ‘',0),(18282,508,'fr','Compte-chÃ¨ques, Date, vÃ©rifiez #',0),(18283,508,'jp','å½“åº§é ?é‡‘å?£åº§ã€?æ—¥ä»˜ã€?å?£åº§ç•ªå?·',0),(18284,508,'pt','Conta corrente, data, verifique #',0),(18285,508,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚, Ð´Ð°Ñ‚Ñƒ, Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ #',0),(18286,508,'es','Cuenta de Cheques, Fecha, Cheque #',0),(18287,508,'de','Girokonto, Datum, Check #',0),(18288,508,'en','Checking Account, Date, Check #',0),(18289,509,'is','',0),(18290,509,'dr','Ø­Ø°Ù Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(18291,509,'pr','Ø­Ø°Ù Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(18292,509,'tr','Ã‡ek hesabÄ± baÅŸarÄ±yla silindi',0),(18293,509,'pl','Sprawdzanie konta usuniÄ™te pomyÅ›lnie',0),(18294,509,'bg','Ð Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(18295,509,'ur','Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(18296,509,'sr','Ð¢ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(18297,509,'vi','XÃ³a TK SÃ©c thÃ nh cÃ´ng',0),(18298,509,'af','Tjekrekening suksesvol geskrap',0),(18299,509,'ro','Verificare cont ÅŸters cu succes',0),(18300,509,'et','Edukalt kustutatud pangakonto',0),(18301,509,'si','Preverjanje raÄuna uspeÅ¡no izbrisana',0),(18302,509,'ba','Rekening dihapus berhasil',0),(18303,509,'nl','Betaalrekening succesvol verwijderd',0),(18304,509,'fi','Sekkitilin poistettu',0),(18305,509,'no','Brukskonto slettet',0),(18306,509,'da','Checkkonto slettet',0),(18307,509,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(18308,509,'he','×—×©×‘×•×Ÿ ×‘× ×§ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(18309,509,'el','Î¤ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(18310,509,'zh','æ”¯ç¥¨å¸æˆ·åˆ é™¤æˆåŠŸ\r\n',0),(18311,509,'sv','Kontroll-konto raderades',0),(18312,509,'it','Checking Account eliminato con successo',0),(18313,509,'tl','',0),(18314,509,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(18315,509,'hi','à¤šà¥‡à¤•à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(18316,509,'ms','Menyemak akaun dihapuskan dengan jayanya',0),(18317,509,'ar','Ø­Ø°Ù Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(18318,509,'fr','Compte-chÃ¨ques supprimÃ© avec succÃ¨s',0),(18319,509,'jp','å½“åº§é ?é‡‘å?£åº§ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(18320,509,'pt','Conta corrente apagada com sucesso',0),(18321,509,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(18322,509,'es','Cuenta de Cheques eliminado exitosamente',0),(18323,509,'de','Girokonto erfolgreich gelÃ¶scht',0),(18324,509,'en','Checking Account deleted successfully',0),(18325,510,'is','',0),(18326,510,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ',0),(18327,510,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ',0),(18328,510,'tr','Ã‡ek hesabÄ± DÃ¼zenle',0),(18329,510,'pl','Edytuj konto czekowe',0),(18330,510,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(18331,510,'ur','Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(18332,510,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(18333,510,'vi','Cáº­p Nháº­t TK SÃ©c',0),(18334,510,'af','Tjekrekening Opdateer',0),(18335,510,'ro','Editare cont de verificare',0),(18336,510,'et','Muuda kontot',0),(18337,510,'si','Urejanje preverjanje raÄuna',0),(18338,510,'ba','Mengedit rekening',0),(18339,510,'nl','Checking Account bewerken',0),(18340,510,'fi','Muokkaa tarkkailun huomioon',0),(18341,510,'no','Redigere brukskonto',0),(18342,510,'da','Redigere checkkonto',0),(18343,510,'ko','ë‹¹ì¢Œ ê³„ì • íŽ¸ì§‘',0),(18344,510,'he','×¢×¨×™×›×ª ×—×©×‘×•×Ÿ ×‘× ×§',0),(18345,510,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(18346,510,'zh','æ”¯ç¥¨å¸æˆ·æ›´æ–°\r\n',0),(18347,510,'sv','Redigera lÃ¶nekonto',0),(18348,510,'it','Modifica conto corrente',0),(18349,510,'tl','',0),(18350,510,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(18351,510,'hi','à¤šà¥‡à¤•à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(18352,510,'ms','Edit akaun memeriksa',0),(18353,510,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ',0),(18354,510,'fr','Modifier le compte courant',0),(18355,510,'jp','å½“åº§é ?é‡‘å?£åº§ã?®æ›´æ–°',0),(18356,510,'pt','Editar conta corrente',0),(18357,510,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(18358,510,'es','Cuenta de Cheques Actualizaar',0),(18359,510,'de','Girokonto zu bearbeiten',0),(18360,510,'en','Edit Checking Account',0),(18361,511,'is','',0),(18362,511,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(18363,511,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(18364,511,'tr','Ã‡ek hesabÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(18365,511,'pl','Konto czekowe pomyÅ›lnie zaktualizowana',0),(18366,511,'bg','Ð Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(18367,511,'ur','Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(18368,511,'sr','Ð¢ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(18369,511,'vi','Cáº­p Nháº­t TK SÃ©c thÃ nh cÃ´ng',0),(18370,511,'af','Tjekrekening suksesvol Opdateer',0),(18371,511,'ro','Verificare cont actualizate cu succes',0),(18372,511,'et','VÃ¤rskendatud pangakonto',0),(18373,511,'si','Preverjanje raÄuna uspeÅ¡no posodobljena',0),(18374,511,'ba','Rekening yang berhasil',0),(18375,511,'nl','Betaalrekening bijgewerkt',0),(18376,511,'fi','Sekkitilin pÃ¤ivitetty',0),(18377,511,'no','Brukskonto oppdatert',0),(18378,511,'da','Checkkonto opdateret',0),(18379,511,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(18380,511,'he','×—×©×‘×•×Ÿ ×‘× ×§ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(18381,511,'el','Î¤ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(18382,511,'zh','æ”¯ç¥¨å¸æˆ·å·²æˆåŠŸæ›´æ–°\r\n',0),(18383,511,'sv','Checkkonto uppdaterats',0),(18384,511,'it','Conto corrente aggiornato con successo',0),(18385,511,'tl','',0),(18386,511,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(18387,511,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(18388,511,'ms','Memeriksa akaun berjaya dikemas kini',0),(18389,511,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(18390,511,'fr','Mis Ã  jour avec succÃ¨s sur le compte courant',0),(18391,511,'jp','å½“åº§é ?é‡‘å?£åº§ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(18392,511,'pt','Conta atualizada com sucesso',0),(18393,511,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(18394,511,'es','Cuenta de Cheques actualizada exitosamente',0),(18395,511,'de','Girokonto erfolgreich aktualisiert',0),(18396,511,'en','Checking Account updated successfully',0),(18397,512,'is','',0),(18398,512,'dr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ',0),(18399,512,'pr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ',0),(18400,512,'tr','Ã‡ek hesabÄ±',0),(18401,512,'pl','Czekowy',0),(18402,512,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Acct',0),(18403,512,'ur','Ø§Ú©Ú©Ù¹ Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(18404,512,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° ÐÑ†Ñ†Ñ‚',0),(18405,512,'vi','TK SÃ©c',0),(18406,512,'af','Tjekrek.',0),(18407,512,'ro','Verificarea Acct',0),(18408,512,'et','Kontrollimise Acct',0),(18409,512,'si','Preverjanje Acct',0),(18410,512,'ba','Memeriksa Acct',0),(18411,512,'nl','Betaalrekening',0),(18412,512,'fi','Tarkkailun Acct',0),(18413,512,'no','Sjekkonto',0),(18414,512,'da','Kontrollere Acct',0),(18415,512,'ko','Acct ê²€ì‚¬',0),(18416,512,'he','×‘×“×™×§×ª ×—×©×‘×•×Ÿ',0),(18417,512,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(18418,512,'zh','æ£€æŸ¥ä¼šè®¡\r\n',0),(18419,512,'sv','Kontrollera Acct',0),(18420,512,'it','Controllo Acct',0),(18421,512,'tl','',0),(18422,512,'th','&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(18423,512,'hi','Acct à¤œà¤¾à¤à¤š',0),(18424,512,'ms','Menyemak Acct',0),(18425,512,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ',0),(18426,512,'fr','VÃ©rification Acct',0),(18427,512,'jp','å½“åº§é ?é‡‘å?£åº§',0),(18428,512,'pt','Verificando Acct',0),(18429,512,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Acct',0),(18430,512,'es','Cuenta de Cheques',0),(18431,512,'de','ÃœberprÃ¼fung Acct',0),(18432,512,'en','Checking Acct',0),(18433,513,'is','',0),(18434,513,'dr','Ú†Ùƒ Ù‡Ø§ ',0),(18435,513,'pr','Ú†Ùƒ Ù‡Ø§ ',0),(18436,513,'tr','Ã‡ekler',0),(18437,513,'pl','Kontrole',0),(18438,513,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(18439,513,'ur','Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’',0),(18440,513,'sr','Ð§ÐµÐºÐ¾Ð²Ðµ',0),(18441,513,'vi','SÃ©c',0),(18442,513,'af','Tjeks',0),(18443,513,'ro','Controale',0),(18444,513,'et','Kontrolli',0),(18445,513,'si','Pregledi',0),(18446,513,'ba','Cek',0),(18447,513,'nl','Controles',0),(18448,513,'fi','Tarkastukset',0),(18449,513,'no','Sjekker',0),(18450,513,'da','Kontrol',0),(18451,513,'ko','ê²€ì‚¬',0),(18452,513,'he','×‘×“×™×§×•×ª',0),(18453,513,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Î¹',0),(18454,513,'zh','æ£€æŸ¥\r\n',0),(18455,513,'sv','Kontroller',0),(18456,513,'it','Controlli',0),(18457,513,'tl','',0),(18458,513,'th','&#3648;&#3594;&#3655;&#3588;',0),(18459,513,'hi','à¤œà¤¾à¤à¤š à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(18460,513,'ms','Menyemak',0),(18461,513,'ar','Ø§Ù„ØµÙƒÙˆÙƒ',0),(18462,513,'fr','VÃ©rifie',0),(18463,513,'jp','Checks',0),(18464,513,'pt','Verifica',0),(18465,513,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚',0),(18466,513,'es','Cheques',0),(18467,513,'de','Kontrollen',0),(18468,513,'en','Checks',0),(18469,514,'is','',0),(18470,514,'dr','Ú†Ùƒ Ù‡Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(18471,514,'pr','Ú†Ùƒ Ù‡Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(18472,514,'tr','Zaten yazÄ±lÄ± denetler.',0),(18473,514,'pl','Sprawdza, czy juÅ¼ napisane.',0),(18474,514,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐ²Ð° Ð²ÐµÑ‡Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸.',0),(18475,514,'ur','Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’ Ù¾ÛÙ„Û’ ÛÛŒ Ù„Ú©Ú¾Ø§ ÛÛ’ Û”',0),(18476,514,'sr','Ð§ÐµÐºÐ¾Ð²Ðµ Ñ˜Ðµ Ð²ÐµÑ› Ð½Ð°Ð¿Ð¸ÑÐ°Ð¾.',0),(18477,514,'vi','SÃ©c Ä‘Ã£ viáº¿t',0),(18478,514,'af','Tjeks alreeds uitgeskryf.',0),(18479,514,'ro','Controalele deja scris.',0),(18480,514,'et','Juba kirjutatud kontrollid.',0),(18481,514,'si','Pregledi Å¾e napisal.',0),(18482,514,'ba','Memeriksa sudah ditulis.',0),(18483,514,'nl','Controles al geschreven.',0),(18484,514,'fi','Tarkistaa jo kirjoittanut.',0),(18485,514,'no','Kontrollerer allerede skrevet.',0),(18486,514,'da','Kontrol allerede skrevet.',0),(18487,514,'ko','ì´ë¯¸ ìž‘ì„± ëœ í™•ì¸ í•©ë‹ˆë‹¤.',0),(18488,514,'he','×‘×•×“×§ ×›×‘×¨ ×›×ª×‘×ª×™.',0),(18489,514,'el','Î•Î»Î­Î³Ï‡Î¿Ï…Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î®Î´Î· Î³ÏÎ¬ÏˆÎµÎ¹.',0),(18490,514,'zh','æ”¯ç¥¨å·²ç»å†™å¥½ã€‚\r\n',0),(18491,514,'sv','Kontrollerar redan skrivit.',0),(18492,514,'it','Controlli giÃ  scritti.',0),(18493,514,'tl','',0),(18494,514,'th','&#3648;&#3594;&#3655;&#3588;&#3652;&#3604;&#3657;&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(18495,514,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤²à¤¿à¤–à¤¾ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(18496,514,'ms','Cek yang telah ditulis.',0),(18497,514,'ar','Ø§Ù„Ø´ÙŠÙƒØ§Øª Ù…ÙƒØªÙˆØ¨Ø© Ù…Ø³Ø¨Ù‚Ø§Ù‹.',0),(18498,514,'fr','VÃ©rifie dÃ©jÃ  rÃ©digÃ©s.',0),(18499,514,'jp','ã?™ã?§ã?«åˆ‡ã‚‰ã‚Œã?Ÿå°?åˆ‡æ‰‹',0),(18500,514,'pt','Verifica jÃ¡ escritos.',0),(18501,514,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚ ÑƒÐ¶Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾.',0),(18502,514,'es','Cheques ya Escritos',0),(18503,514,'de','ÃœberprÃ¼ft, ob bereits geschrieben.',0),(18504,514,'en','Checks already written.',0),(18505,515,'is','',0),(18506,515,'dr','Ú†Ùƒ Ù‡Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù†Ù‚Ø¯ Ø´Ø¯Ù‡  Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(18507,515,'pr','Ú†Ùƒ Ù‡Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù†Ù‚Ø¯ Ø´Ø¯Ù‡  Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(18508,515,'tr','Ã‡ekleri bozdurdum olarak iÅŸaretlenmiÅŸ.',0),(18509,515,'pl','Czek oznaczone jako zrealizowane.',0),(18510,515,'bg','Ð§ÐµÐº(Ð¾Ð²Ðµ) Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ð¸ ÐºÐ°Ñ‚Ð¾ Ð¾ÑÑ€ÐµÐ±Ñ€ÑÑ‚.',0),(18511,515,'ur','Check(s) Ø¨Ø¸Ø§ÛØ±Ø§Ù† Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†Ø´Ø§Ù† Ù„Ú¯Ø§ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(18512,515,'sr','Ð§ÐµÐºÐ¾Ð²Ðµ Ñ˜Ðµ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½ ÐºÐ°Ð¾ ÑƒÐ½Ð¾Ð²Ñ‡Ð¸Ð¾.',0),(18513,515,'vi','SÃ©c Ä‘Ã¡nh dáº¥u Ä‘Ã£ Ä‘á»•i thÃ nh tiá»n máº·t',0),(18514,515,'af','Tjek(s) gemerk as gewissel.',0),(18515,515,'ro','Cecul/cecurile marcate ca incasate.',0),(18516,515,'et','TÅ¡ekke mÎ£rgitud sularahaks.',0),(18517,515,'si','ÄŒeke oznaÄena kot vnovÄil.',0),(18518,515,'ba','Check(s) ditandai sebagai menguangkan.',0),(18519,515,'nl','Cheques gemarkeerd als geÃ¯ncasseerd.',0),(18520,515,'fi','Sekki on merkitty lunastettu.',0),(18521,515,'no','Sjekken(e) merket som innlÃ¸ses.',0),(18522,515,'da','Checken(e) markeret som indlÃ¸st.',0),(18523,515,'ko','í˜„ê¸ˆ ë“  í‘œì‹œ.',0),(18524,515,'he','Check(s) ×©×¡×•×ž× ×• ×¤×“×”.',0),(18525,515,'el','Î•Ï€Î¹Ï„Î±Î³Î® Î® ÎµÏ€Î¹Ï„Î±Î³Î­Ï‚ ÎµÏ€Î¹ÏƒÎ·Î¼Î±Î½Î¸ÎµÎ¯ Ï‰Ï‚ ÎµÎ¾Î±ÏÎ³Ï…ÏÏŽÏƒÎµÎ¹.',0),(18526,515,'zh','æ”¯ç¥¨ï¼Œå¹¶æ ‡è®°ä¸ºå…‘çŽ°ã€‚\r\n',0),(18527,515,'sv','Checken/checkarna markeras som inkasserades.',0),(18528,515,'it','Assegni contrassegnato come incassato.',0),(18529,515,'tl','',0),(18530,515,'th','&#3648;&#3594;&#3655;&#3588;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;',0),(18531,515,'hi','Check(s) à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤­à¥à¤¨à¤¾à¤¯à¤¾à¥¤',0),(18532,515,'ms','Check(s) ditandakan sebagai ditunaikan.',0),(18533,515,'ar','Check(s) ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© ØµØ±ÙØ©.',0),(18534,515,'fr','ChÃ¨ques marquÃ©s comme encaissÃ©.',0),(18535,515,'jp','æ?›é‡‘æ¸ˆã?«ã?ªã?£ã?¦ã?„ã‚‹å°?åˆ‡æ‰‹',0),(18536,515,'pt','VerificaÃ§Ãµes marcado como descontou.',0),(18537,515,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ñ, Ð¿Ð¾Ð¼ÐµÑ‡ÐµÐ½Ð½Ñ‹Ðµ ÐºÐ°Ðº Ð¾Ð±Ð½Ð°Ð»Ð¸Ñ‡Ð¸Ñ‚ÑŒ.',0),(18538,515,'es','Cheque(s) marcados como coleccionados',0),(18539,515,'de','Schecks als eingelÃ¶st gekennzeichnet.',0),(18540,515,'en','Check(s) marked as cashed.',0),(18541,516,'is','',0),(18542,516,'dr','Ú†Ùƒ Ù‡Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù†Ù‚Ø¯ Ù†Ø´Ø¯Ù‡  Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(18543,516,'pr','Ú†Ùƒ Ù‡Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù†Ù‚Ø¯ Ù†Ø´Ø¯Ù‡  Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(18544,516,'tr','Ã‡ekleri uncashed olarak iÅŸaretlenmiÅŸ.',0),(18545,516,'pl','Czek oznaczone jako uncashed Los.',0),(18546,516,'bg','Ð§ÐµÐº(Ð¾Ð²Ðµ) Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ð¸ ÐºÐ°Ñ‚Ð¾ Ð½ÐµÐºÐ°ÑÐ¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ.',0),(18547,516,'ur','Check(s) Ø§Ù†Ú©Ø§Ø´Ø§Ø¯ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†Ø´Ø§Ù† Ø²Ø¯ ÛÛ’ Û”',0),(18548,516,'sr','Ð§ÐµÐºÐ¾Ð²Ðµ Ñ˜Ðµ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½ ÐºÐ°Ð¾ ÑƒÐ½Ñ†Ð°ÑÑ…ÐµÐ´.',0),(18549,516,'vi','SÃ©c Ä‘Ã¡nh dáº¥u chÆ°a Ä‘á»•i thÃ nh tiá»n máº·t',0),(18550,516,'af','Tjek(s) gemerk as ongewissel.',0),(18551,516,'ro','Cecul/cecurile marcat uncashed.',0),(18552,516,'et','TÅ¡ekke mÃ¤rgitud uncashed.',0),(18553,516,'si','ÄŒeke oznaÄen kot uncashed.',0),(18554,516,'ba','Check(s) ditandai sebagai uncashed.',0),(18555,516,'nl','Cheques gemarkeerd als uncashed.',0),(18556,516,'fi','Sekki merkitty uncashed.',0),(18557,516,'no','Sjekken(e) merket som uinnlÃ¸ste.',0),(18558,516,'da','Checken(e) markeret som uindlÃ¸ste.',0),(18559,516,'ko','ë“  í˜„ê¸ˆí™”ë¡œ í‘œì‹œ ë©ë‹ˆë‹¤.',0),(18560,516,'he','Check(s) ×ž×¡×•×ž×Ÿ ×›- uncashed.',0),(18561,516,'el','Î•Ï€Î¹Ï„Î±Î³Î® Î® ÎµÏ€Î¹Ï„Î±Î³Î­Ï‚ Ï‡Î±ÏÎ±ÎºÏ„Î·ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹ uncashed.',0),(18562,516,'zh','æ”¯ç¥¨ï¼ˆï¼‰æ ‡è®°ä¸ºæœªå…‘çŽ°ã€‚\r\n',0),(18563,516,'sv','Checken/checkarna markeras som gÃ¤llde outlÃ¶sta.',0),(18564,516,'it','Assegni contrassegnato come assegno.',0),(18565,516,'tl','',0),(18566,516,'th','&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3594;&#3655;&#3588;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;',0),(18567,516,'hi','Check(s) à¤¬à¤¿à¤¨à¤¾ à¤­à¥à¤¨à¤¾à¤¯à¤¾ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤à¥¤',0),(18568,516,'ms','Check(s) ditandakan sebagai uncashed.',0),(18569,516,'ar','Check(s) Ø¹Ù„Ø§Ù…Ø© Ù„Ù‡Ø§.',0),(18570,516,'fr','ChÃ¨ques marquÃ©s comme non encaissÃ©s.',0),(18571,516,'jp','æœªæ?›é‡‘ã?«ã?ªã?£ã?¦ã?„ã‚‹å°?åˆ‡æ‰‹',0),(18572,516,'pt','VerificaÃ§Ãµes marcadas como contracheques.',0),(18573,516,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ñ Ð¿Ð¾Ð¼ÐµÑ‡ÐµÐ½Ñ‹ ÐºÐ°Ðº Ð½ÐµÐ¾Ð±Ð½Ð°Ð»Ð¸Ñ‡ÐµÐ½Ð½Ñ‹Ñ….',0),(18574,516,'es','Cheque(s) marcados como no coleccianados',0),(18575,516,'de','Schecks, die als eingeloste markiert werden.',0),(18576,516,'en','Check(s) marked as uncashed.',0),(18577,517,'is','',0),(18578,517,'dr','Ú†Ùƒ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ú†Ø§Ù¾ Ø´Ø¯Ù†Ø¯',0),(18579,517,'pr','Ú†Ùƒ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ú†Ø§Ù¾ Ø´Ø¯Ù†Ø¯',0),(18580,517,'tr','BaÅŸarÄ±yla Ã§eklerin.',0),(18581,517,'pl','Kontrole drukowany pomyÅ›lnie.',0),(18582,517,'bg','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð½Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ.',0),(18583,517,'ur','Ú†ÛŒÚ© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ú†Ú¾Ù¾ÛŒ ÛÙˆØ¦ÛŒ ÛÛ’ Û”',0),(18584,517,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð»Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ.',0),(18585,517,'vi','In SÃ©c thÃ nh cÃ´ng',0),(18586,517,'af','Tjeks suksesvol uitgedruk.',0),(18587,517,'ro','Controale imprimat cu succes.',0),(18588,517,'et','TÅ¡ekid printima edukalt.',0),(18589,517,'si','UspeÅ¡no natisniti Äeke.',0),(18590,517,'ba','Cek dicetak berhasil.',0),(18591,517,'nl','Cheques worden afgedrukt met succes.',0),(18592,517,'fi','Sekit tulostaa onnistuneesti.',0),(18593,517,'no','Sjekker skrives ut med hell.',0),(18594,517,'da','Checks udskrives korrekt.',0),(18595,517,'ko','ê²€ì‚¬ëŠ” ì„±ê³µì ìœ¼ë¡œ ì¸ì‡„ í•©ë‹ˆë‹¤.',0),(18596,517,'he','×‘×“×™×§×•×ª ×ž×•×“×¤×¡ ×‘×”×¦×œ×—×”.',0),(18597,517,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Î¹ ÎµÎºÏ„Ï…Ï€ÏŽÎ½Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(18598,517,'zh','æ£€æŸ¥æ‰“å°æˆåŠŸã€‚\r\n',0),(18599,517,'sv','Checkar ut framgÃ¥ngsrikt.',0),(18600,517,'it','Controlli stampato correttamente.',0),(18601,517,'tl','',0),(18602,517,'th','&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3594;&#3655;&#3588;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(18603,517,'hi','à¤šà¥‡à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤®à¥à¤¦à¥à¤°à¤¿à¤¤à¥¤',0),(18604,517,'ms','Pemeriksaan dicetak berjaya.',0),(18605,517,'ar','Ø·Ø¨Ø¹Øª Ø§Ù„ØµÙƒÙˆÙƒ Ø¨Ù†Ø¬Ø§Ø­',0),(18606,517,'fr','ChÃ¨ques imprimÃ©s avec succÃ¨s.',0),(18607,517,'jp','è«‹æ±‚é¡?ã?Œæ”¯æ‰•ã‚?ã‚Œã?¾ã?—ã?Ÿ',0),(18608,517,'pt','Cheques impressos com Ãªxito.',0),(18609,517,'ru','Ð§ÐµÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ñ€Ð°Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð½Ñ‹.',0),(18610,517,'es','Cheques Imprimidos exitosamente',0),(18611,517,'de','Schecks gedruckt erfolgreich.',0),(18612,517,'en','Checks printed successfully.',0),(18613,518,'is','',0),(18614,518,'dr','Ú†Ùƒ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¯Ø§Ø±Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±  Ø´Ø¯Ù†Ø¯',0),(18615,518,'pr','Ú†Ùƒ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¯Ø§Ø±Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±  Ø´Ø¯Ù†Ø¯',0),(18616,518,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde unvoided denetler.',0),(18617,518,'pl','Sprawdza unvoided pomyÅ›lnie.',0),(18618,518,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐ²Ð° unvoided ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(18619,518,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù†ÙˆÙˆØ§ÚˆÛŒØ¯ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’ Û”',0),(18620,518,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð° ÑƒÐ½Ð²Ð¾Ð¸Ð´ÐµÐ´ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾.',0),(18621,518,'vi','ChÆ°a XÃ³a SÃ©c thÃ nh cÃ´ng',0),(18622,518,'af','Uitgevee van Tjeks suksesvol ongedaan gemaak.',0),(18623,518,'ro','Controale unvoided cu succes.',0),(18624,518,'et','Kontrollib unvoided edukalt.',0),(18625,518,'si','Preveri unvoided uspeÅ¡no.',0),(18626,518,'ba','Memeriksa unvoided berhasil.',0),(18627,518,'nl','Controleert unvoided met succes.',0),(18628,518,'fi','Tarkistaa unvoided onnistuneesti.',0),(18629,518,'no','Kontrollerer unvoided vellykket.',0),(18630,518,'da','Kontrollerer unvoided med succes.',0),(18631,518,'ko','ì„±ê³µì ìœ¼ë¡œ unvoided í™•ì¸í•©ë‹ˆë‹¤.',0),(18632,518,'he','. ××ª×” ×‘×•×“×§ unvoided ×‘×”×¦×œ×—×”.',0),(18633,518,'el','Î•Î»Î­Î³Ï‡ÎµÎ¹ unvoided Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(18634,518,'zh','æ£€æŸ¥ä¸ä½œåºŸæˆåŠŸ',0),(18635,518,'sv','Kontrollerar unvoided framgÃ¥ngsrikt.',0),(18636,518,'it','Controlla unvoided con successo.',0),(18637,518,'tl','',0),(18638,518,'th','&#3585;&#3634;&#3619;&#3652;&#3617;&#3656;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3594;&#3655;&#3588;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(18639,518,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• unvoided à¤œà¤¾à¤à¤š à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(18640,518,'ms','Menyemak unvoided berjaya.',0),(18641,518,'ar','ÙŠØªØ­Ù‚Ù‚ Ø£ÙˆÙ†ÙÙˆÙŠØ¯ÙŠØ¯ Ø¨Ù†Ø¬Ø§Ø­.',0),(18642,518,'fr','VÃ©rifie unvoided avec succÃ¨s.',0),(18643,518,'jp','å°?åˆ‡æ‰‹ã‚’æœªç ´æ£„ã?«ã?—ã?¾ã?—ã?Ÿ',0),(18644,518,'pt','Verifica unvoided com Ãªxito.',0),(18645,518,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚ unvoided ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(18646,518,'es','Cheques desanulados exitosamente',0),(18647,518,'de','ÃœberprÃ¼ft unvoided erfolgreich.',0),(18648,518,'en','Checks unvoided successfully.',0),(18649,519,'is','',0),(18650,519,'dr','Ú†Ùƒ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ø§Ø·Ù„  Ø´Ø¯Ù†Ø¯',0),(18651,519,'pr','Ú†Ùƒ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ø§Ø·Ù„  Ø´Ø¯Ù†Ø¯',0),(18652,519,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde HÃ¼kÃ¼msÃ¼z Ã§ek.',0),(18653,519,'pl','Kontrole pomyÅ›lnie anulowane.',0),(18654,519,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(18655,519,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ ÙˆÙˆØ§ÚˆÛŒØ¯ Ú†ÛŒÚ© Ú©Ø±ØªØ§ ÛÛ’ Û”',0),(18656,519,'sr','Ð§ÐµÐºÐ¾Ð²Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½.',0),(18657,519,'vi','XÃ³a SÃ©c thÃ nh cÃ´ng',0),(18658,519,'af','Tjeks suksesvol Uitgevee.',0),(18659,519,'ro','VerificÄƒri anulate cu succes.',0),(18660,519,'et','Kontrolli tÃ¼histatud edukalt.',0),(18661,519,'si','Preverjanje uspeÅ¡no razveljavljena.',0),(18662,519,'ba','Cek voided berhasil.',0),(18663,519,'nl','Controles met succes ongeldig.',0),(18664,519,'fi','Tarkastukset pÃ¤tevÃ¤ onnistuneesti.',0),(18665,519,'no','Kontrollerer annullert vellykket.',0),(18666,519,'da','Kontrol annulleret med succes.',0),(18667,519,'ko','ì„±ê³µì ìœ¼ë¡œ ë¬´íš¨ í™•ì¸ í•©ë‹ˆë‹¤.',0),(18668,519,'he','×‘×“×™×§×ª ×‘×•×˜×œ ×‘×”×¦×œ×—×”.',0),(18669,519,'el','Î•Î»Î­Î³Ï‡Î¿Ï…Ï‚ Ï€Î¿Ï… Î±ÎºÏ…ÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(18670,519,'zh','æ”¯ç¥¨ä½œåºŸæˆåŠŸã€‚\r\n',0),(18671,519,'sv','Kontroller annullerad framgÃ¥ngsrikt.',0),(18672,519,'it','Assegni annullati con successo.',0),(18673,519,'tl','',0),(18674,519,'th','&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3594;&#3655;&#3588;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(18675,519,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• voided à¤•à¥€ à¤œà¤¾à¤‚à¤šà¥¤',0),(18676,519,'ms','Pemeriksaan voided berjaya.',0),(18677,519,'ar','Ø´ÙŠÙƒØ§Øª Ù…Ù„ØºÙŠØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(18678,519,'fr','ChÃ¨ques annulÃ©s avec succÃ¨s.',0),(18679,519,'jp','å°?åˆ‡æ‰‹ã‚’ç ´æ£„ã?—ã?¾ã?—ã?Ÿ',0),(18680,519,'pt','Cheques anulados com Ãªxito.',0),(18681,519,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(18682,519,'es','Cheques Anulados exitosamente',0),(18683,519,'de','PrÃ¼fungen erfolgreich storniert.',0),(18684,519,'en','Checks voided successfully.',0),(18685,520,'is','',0),(18686,520,'dr','Ú†Ùƒ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù†Ø¯',0),(18687,520,'pr','Ú†Ùƒ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù†Ø¯',0),(18688,520,'tr','Ã‡ekler baÅŸarÄ±yla yazÄ±ldÄ±.',0),(18689,520,'pl','Kontrole pomyÅ›lnie zapisane.',0),(18690,520,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸, Ð´Ð°Ð´ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(18691,520,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ù„Ú©Ú¾Û’ Ú†ÛŒÚ© Ú©Ø±ØªØ§ ÛÛ’ Û”',0),(18692,520,'sr','Ð§ÐµÐºÐ¾Ð²Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½.',0),(18693,520,'vi','ÄÃ£ viáº¿t SÃ©c thÃ nh cÃ´ng',0),(18694,520,'af','Tjeks suksesvol Uitgeskryf.',0),(18695,520,'ro','Controalele scris cu succes.',0),(18696,520,'et','Kontrollid edukalt kirjutada.',0),(18697,520,'si','Pregledi koncu uspeÅ¡no.',0),(18698,520,'ba','Cek ditulis berhasil.',0),(18699,520,'nl','Controles met succes geschreven.',0),(18700,520,'fi','Tarkastuksia kirjoitettu onnistuneesti.',0),(18701,520,'no','Sjekker skrevet uten problemer.',0),(18702,520,'da','Kontrol skrevet med succes.',0),(18703,520,'ko','ì„±ê³µì ìœ¼ë¡œ ìž‘ì„± ëœ í™•ì¸ í•©ë‹ˆë‹¤.',0),(18704,520,'he','×‘×“×™×§×ª × ×›×ª×‘ ×‘×”×¦×œ×—×”.',0),(18705,520,'el','Î¤Î¿Ï…Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Î³ÏÎ±Ï€Ï„Î® Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(18706,520,'zh','æ£€æŸ¥æˆåŠŸå†™å…¥ã€‚\r\n',0),(18707,520,'sv','Kontroller skrivna framgÃ¥ngsrikt.',0),(18708,520,'it','Controlli scritti correttamente.',0),(18709,520,'tl','',0),(18710,520,'th','&#3585;&#3634;&#3619;&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(18711,520,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤²à¤¿à¤–à¤¾ à¤šà¥‡à¤•à¥¤',0),(18712,520,'ms','Cek ditulis berjaya.',0),(18713,520,'ar','Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø®Ø·ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(18714,520,'fr','ChÃ¨ques Ã©mis avec succÃ¨s.',0),(18715,520,'jp','Checks written successfully.',0),(18716,520,'pt','Cheques escritos com sucesso.',0),(18717,520,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½.',0),(18718,520,'es','Cheques Escritos exitosamente',0),(18719,520,'de','PrÃ¼fungen erfolgreich geschrieben.',0),(18720,520,'en','Checks written successfully.',0),(18721,521,'is','',0),(18722,521,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø·Ø¨Ù‚ ØªØ§Ø±ÙŠØ®',0),(18723,521,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø·Ø¨Ù‚ ØªØ§Ø±ÙŠØ®',0),(18724,521,'tr','Tarihe gÃ¶re seÃ§in',0),(18725,521,'pl','Wybierz wedÅ‚ug daty',0),(18726,521,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð°',0),(18727,521,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(18728,521,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ñƒ',0),(18729,521,'vi','Chá»n theo ngÃ y',0),(18730,521,'af','Kies per Datum',0),(18731,521,'ro','Alege data',0),(18732,521,'et','Vali kuupÃ¤eva jÃ¤rgi',0),(18733,521,'si','Izberite datum',0),(18734,521,'ba','Pilih tanggal',0),(18735,521,'nl','Kies door datum',0),(18736,521,'fi','Valitse pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(18737,521,'no','Velge etter dato',0),(18738,521,'da','VÃ¦lg efter dato',0),(18739,521,'ko','ë‚ ì§œ ì„ íƒ',0),(18740,521,'he','×œ×‘×—×•×¨ ×œ×¤×™ ×ª××¨×™×š',0),(18741,521,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±Ï€ÏŒ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(18742,521,'zh','é€‰æ‹©çš„æ—¥æœŸ\r\n',0),(18743,521,'sv','VÃ¤lj datum',0),(18744,521,'it','Scegli per data',0),(18745,521,'tl','',0),(18746,521,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3650;&#3604;&#3618;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(18747,521,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤° à¤šà¥à¤¨à¥‡à¤‚',0),(18748,521,'ms','Pilih tarikh',0),(18749,521,'ar','Ø§Ø®ØªØ± Ø­Ø³Ø¨ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(18750,521,'fr','Choisir par Date',0),(18751,521,'jp','æ—¥ä»˜é †ã?§é?¸ã?¶',0),(18752,521,'pt','Escolha por data',0),(18753,521,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¿Ð¾ Ð”Ð°Ñ‚Ðµ',0),(18754,521,'es','Seleccionar por Fecha',0),(18755,521,'de','WÃ¤hlen Sie nach Datum',0),(18756,521,'en','Choose by Date',0),(18757,522,'is','',0),(18758,522,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø·Ø¨Ù‚ Ù…Ø§Ù‡ ',0),(18759,522,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø·Ø¨Ù‚ Ù…Ø§Ù‡ ',0),(18760,522,'tr','Ay seÃ§in',0),(18761,522,'pl','Wybierz przez miesiÄ…c',0),(18762,522,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¼ÐµÑÐµÑ†',0),(18763,522,'ur','Ù…Ø§Û Ø³Û’ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(18764,522,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾ Ð¼ÐµÑÐµÑ†Ð¸Ð¼Ð°',0),(18765,522,'vi','Chá»n theo thÃ¡ng',0),(18766,522,'af','Kies per maand',0),(18767,522,'ro','Alege luna',0),(18768,522,'et','Vali kuu',0),(18769,522,'si','Izberite po mesecih',0),(18770,522,'ba','Pilih bulan',0),(18771,522,'nl','Kies per maand',0),(18772,522,'fi','Valitse kuukausi',0),(18773,522,'no','Velge etter mÃ¥ned',0),(18774,522,'da','VÃ¦lg pr. mÃ¥ned',0),(18775,522,'ko','ì›”ë³„ë¡œ ì„ íƒ',0),(18776,522,'he','×œ×‘×—×•×¨ ×œ×¤×™ ×—×•×“×©',0),(18777,522,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±Ï€ÏŒ Ï„Î¿ Î¼Î®Î½Î±',0),(18778,522,'zh','é€‰æ‹©æŒ‰æœˆ\r\n',0),(18779,522,'sv','VÃ¤lj mÃ¥nad',0),(18780,522,'it','Scegli per mese',0),(18781,522,'tl','',0),(18782,522,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3650;&#3604;&#3618;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(18783,522,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤šà¥à¤¨à¥‡à¤‚',0),(18784,522,'ms','Pilih mengikut bulan',0),(18785,522,'ar','Ø§Ø®ØªØ± Ø­Ø³Ø¨ Ø§Ù„Ø´Ù‡Ø±',0),(18786,522,'fr','Choisissez par mois',0),(18787,522,'jp','æœˆã?”ã?¨ã?«é?¸ã?¶',0),(18788,522,'pt','Escolha por mÃªs',0),(18789,522,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¿Ð¾ Ð¼ÐµÑÑÑ†Ñƒ',0),(18790,522,'es','Seleccionar por mes',0),(18791,522,'de','WÃ¤hlen Sie nach Monat',0),(18792,522,'en','Choose by month',0),(18793,523,'is','',0),(18794,523,'dr','Ø´Ø±ÙƒØª Ø®ÙˆØ¯ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(18795,523,'pr','Ø´Ø±ÙƒØª Ø®ÙˆØ¯ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(18796,523,'tr','Åžirket seÃ§in',0),(18797,523,'pl','Wyboru firmy',0),(18798,523,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(18799,523,'ur','Ø¢Ù¾ Ú©ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(18800,523,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÐµ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ðµ',0),(18801,523,'vi','Chá»n Cty cá»§a báº¡n',0),(18802,523,'af','Kies U Onderneming',0),(18803,523,'ro','Alege compania ta',0),(18804,523,'et','Vali ettevÃµte',0),(18805,523,'si','Izberite vaÅ¡e podjetje',0),(18806,523,'ba','Memilih perusahaan Anda',0),(18807,523,'nl','Kies uw bedrijf',0),(18808,523,'fi','Valitse yritys',0),(18809,523,'no','Velg firmaet',0),(18810,523,'da','VÃ¦lg din virksomhed',0),(18811,523,'ko','ë‹¹ì‹ ì˜ íšŒì‚¬ë¥¼ ì„ íƒ',0),(18812,523,'he','×œ×‘×—×•×¨ ××ª ×”×—×‘×¨×” ×©×œ×š',0),(18813,523,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÏƒÎ±Ï‚',0),(18814,523,'zh','é€‰æ‹©ä½ çš„å…¬å¸\r\n',0),(18815,523,'sv','VÃ¤lj ditt fÃ¶retag',0),(18816,523,'it','Scegli la tua azienda',0),(18817,523,'tl','',0),(18818,523,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(18819,523,'hi','à¤†à¤ªà¤•à¥€ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤šà¤¯à¤¨',0),(18820,523,'ms','Pilih Syarikat anda',0),(18821,523,'ar','Ø§Ø®ØªØ± Ø´Ø±ÙƒØªÙƒ',0),(18822,523,'fr','Choisissez votre entreprise',0),(18823,523,'jp','ã?‚ã?ªã?Ÿã?®ä¼šç¤¾ã‚’é?¸ã?¶',0),(18824,523,'pt','Escolha sua empresa',0),(18825,523,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð’Ð°ÑˆÑƒ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ',0),(18826,523,'es','Seleccionar Su Empresa',0),(18827,523,'de','WÃ¤hlen Sie Ihr Unternehmen',0),(18828,523,'en','Choose Your Company',0),(18829,524,'is','',0),(18830,524,'dr','Ø´Ù‡Ø± ',0),(18831,524,'pr','Ø´Ù‡Ø± ',0),(18832,524,'tr','Åžehir',0),(18833,524,'pl','Miasto',0),(18834,524,'bg','Ð“Ñ€Ð°Ð´',0),(18835,524,'ur','Ø´ÛØ±',0),(18836,524,'sr','Ð“Ñ€Ð°Ð´',0),(18837,524,'vi','ThÃ nh phá»‘',0),(18838,524,'af','Dorp/Stad',0),(18839,524,'ro','City',0),(18840,524,'et','Linn',0),(18841,524,'si','Mesto',0),(18842,524,'ba','Kota',0),(18843,524,'nl','Stad',0),(18844,524,'fi','City',0),(18845,524,'no','Byen',0),(18846,524,'da','City',0),(18847,524,'ko','ë„ì‹œ',0),(18848,524,'he','×¢×™×¨',0),(18849,524,'el','Î ÏŒÎ»Î·',0),(18850,524,'zh','å¸‚\r\n',0),(18851,524,'sv','Staden',0),(18852,524,'it','CittÃ ',0),(18853,524,'tl','',0),(18854,524,'th','&#3629;&#3635;&#3648;&#3616;&#3629;/&#3648;&#3586;&#3605;',0),(18855,524,'hi','à¤¶à¤¹à¤°',0),(18856,524,'ms','Bandar',0),(18857,524,'ar','Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(18858,524,'fr','Ville',0),(18859,524,'jp','éƒ½å¸‚',0),(18860,524,'pt','Cidade',0),(18861,524,'ru','Ð“Ð¾Ñ€Ð¾Ð´',0),(18862,524,'es','Ciudad',0),(18863,524,'de','Stadt',0),(18864,524,'en','City',0),(18865,525,'is','',0),(18866,525,'dr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ÙŠ Ø´Ù‡Ø±ÙŠ',0),(18867,525,'pr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ÙŠ Ø´Ù‡Ø±ÙŠ',0),(18868,525,'tr','Åžehir muafiyetler',0),(18869,525,'pl','Miasto zwolnienia',0),(18870,525,'bg','Ð“Ñ€Ð°Ð´ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ð¸Ñ',0),(18871,525,'ur','Ø´ÛØ± Ø§Ø³ØªØ«Ù†Ø§Ø¦ÛŒÚº',0),(18872,525,'sr','Ð“Ñ€Ð°Ð´ Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(18873,525,'vi','Ngoáº¡i trá»« thÃ nh phá»‘',0),(18874,525,'af','Dorp/Stad Vrystellings',0),(18875,525,'ro','OraÅŸul scutiri',0),(18876,525,'et','Linn maksuvabastused',0),(18877,525,'si','Mesto izjeme',0),(18878,525,'ba','Kota pengecualian',0),(18879,525,'nl','Stad vrijstellingen',0),(18880,525,'fi','Kaupungin vapautukset',0),(18881,525,'no','Byen unntak',0),(18882,525,'da','Byen undtagelser',0),(18883,525,'ko','ì‹œ ë©´ì œ',0),(18884,525,'he','×”×¢×™×¨ ×¤×˜×•×¨×™×',0),(18885,525,'el','Î ÏŒÎ»Î· ÎµÎ¾Î±Î¹ÏÎ­ÏƒÎµÎ¹Ï‚',0),(18886,525,'zh','å¸‚è±å…\r\n',0),(18887,525,'sv','Staden undantag',0),(18888,525,'it','CittÃ  esenzioni',0),(18889,525,'tl','',0),(18890,525,'th','&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(18891,525,'hi','à¤¶à¤¹à¤° à¤®à¥‡à¤‚ à¤›à¥‚à¤Ÿ',0),(18892,525,'ms','Pengecualian bandar',0),(18893,525,'ar','Ù…Ø¯ÙŠÙ†Ø© Ø§Ù„Ø¥Ø¹ÙØ§Ø¡Ø§Øª',0),(18894,525,'fr','Exemptions de la ville',0),(18895,525,'jp','å¸‚æŽ§é™¤',0),(18896,525,'pt','IsenÃ§Ãµes de cidade',0),(18897,525,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð³Ð¾Ñ€Ð¾Ð´Ð°',0),(18898,525,'es','Ciudad Exenciones',0),(18899,525,'de','Stadt-Ausnahmen',0),(18900,525,'en','City Exemptions',0),(18901,526,'is','',0),(18902,526,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ù‡Ø±ÙŠ',0),(18903,526,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ù‡Ø±ÙŠ',0),(18904,526,'tr','Åžehir gelir vergisi',0),(18905,526,'pl','Miasto podatku dochodowego',0),(18906,526,'bg','Ð“Ñ€Ð°Ð´Ð° Ð´Ð°Ð½ÑŠÐºÐ° Ð²ÑŠÑ€Ñ…Ñƒ Ð´Ð¾Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(18907,526,'ur','Ø´ÛØ± Ø§Ù†Ú©Ù… Ù¹ÛŒÚ©Ø³',0),(18908,526,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð´Ð¾Ñ…Ð¾Ð´Ð°Ðº Ð³Ñ€Ð°Ð´Ð°',0),(18909,526,'vi','Thuáº¿ thu nháº­p thÃ nh phá»‘',0),(18910,526,'af','Dorp/Stad Inkomstebelasting',0),(18911,526,'ro','Impozitul pe venit City',0),(18912,526,'et','Linn tulumaksu',0),(18913,526,'si','Mesto dohodnine',0),(18914,526,'ba','Pajak pendapatan kota',0),(18915,526,'nl','Stad inkomstenbelasting',0),(18916,526,'fi','Kaupungin tulovero',0),(18917,526,'no','Byen inntektsskatt',0),(18918,526,'da','Byen indkomstskat',0),(18919,526,'ko','ì‹œ ì†Œë“ì„¸',0),(18920,526,'he','×ž×¡ ×”×›× ×¡×” ×”×¢×™×¨',0),(18921,526,'el','Î”Î·Î¼Î¿Ï„Î¹ÎºÏŒÏ‚ Ï†ÏŒÏÎ¿Ï‚ ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(18922,526,'zh','åŸŽå¸‚æ”¶å…¥ç¨Ž\r\n',0),(18923,526,'sv','Staden inkomstskatt',0),(18924,526,'it','Tassa di reddito',0),(18925,526,'tl','',0),(18926,526,'th','&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;',0),(18927,526,'hi','à¤¶à¤¹à¤° à¤†à¤¯à¤•à¤°',0),(18928,526,'ms','Cukai pendapatan bandar',0),(18929,526,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯Ø®Ù„ ÙÙŠ Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(18930,526,'fr','ImpÃ´t sur le revenu ville',0),(18931,526,'jp','æ‰€å¾—ç¨Ž',0),(18932,526,'pt','Imposto de renda da cidade',0),(18933,526,'ru','Ð“Ð¾Ñ€Ð¾Ð´ Ð¿Ð¾Ð´Ð¾Ñ…Ð¾Ð´Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(18934,526,'es','Ciudad Impuesto Sobre la Renta',0),(18935,526,'de','Stadt-Einkommensteuer',0),(18936,526,'en','City Income Tax',0),(18937,527,'is','',0),(18938,527,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø´Ù‡Ø±ÙŠ',0),(18939,527,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø´Ù‡Ø±ÙŠ',0),(18940,527,'tr','Åžehir vergisi',0),(18941,527,'pl','Podatek miejski',0),(18942,527,'bg','ÐšÑƒÑ€Ð¾Ñ€Ñ‚Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(18943,527,'ur','Ø´ÛØ± Ù¹ÛŒÚ©Ø³',0),(18944,527,'sr','Ð“Ñ€Ð°Ð´ÑÐºÐ¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(18945,527,'vi','Thuáº¿ thÃ nh phá»‘',0),(18946,527,'af','Dorp/Stad Belasting',0),(18947,527,'ro','Taxa de oraÅŸ',0),(18948,527,'et','Linnamaksu',0),(18949,527,'si','Mesto davÄne',0),(18950,527,'ba','Pajak kota',0),(18951,527,'nl','Toeristenbelasting',0),(18952,527,'fi','Kaupungin vero',0),(18953,527,'no','Byskatt',0),(18954,527,'da','Byskat',0),(18955,527,'ko','ì‹œ ì„¸ê¸ˆ',0),(18956,527,'he','×ž×¡ ×¢×™×¨×•× ×™',0),(18957,527,'el','Î”Î·Î¼Î¿Ï„Î¹ÎºÏŒÏ‚ Ï†ÏŒÏÎ¿Ï‚',0),(18958,527,'zh','å¸‚ç¨Ž\r\n',0),(18959,527,'sv','Stadsskatt',0),(18960,527,'it','Tassa di soggiorno',0),(18961,527,'tl','',0),(18962,527,'th','&#3616;&#3634;&#3625;&#3637;&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;',0),(18963,527,'hi','à¤¶à¤¹à¤° à¤•à¤°',0),(18964,527,'ms','Cukai bandar',0),(18965,527,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(18966,527,'fr','Taxe de sÃ©jour',0),(18967,527,'jp','å¸‚ç¨Ž',0),(18968,527,'pt','Imposto Municipal',0),(18969,527,'ru','Ð“Ð¾Ñ€Ð¾Ð´ÑÐºÐ¾Ð¹ ÐÐ°Ð»Ð¾Ð³',0),(18970,527,'es','Ciudad Impuesto',0),(18971,527,'de','Kurtaxe',0),(18972,527,'en','City Tax',0),(18973,528,'is','',0),(18974,528,'dr','2',0),(18975,528,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø´Ù‡Ø±ÙŠ 2',0),(18976,528,'tr','Åžehir vergisi',0),(18977,528,'pl','Podatek miejski',0),(18978,528,'bg','ÐšÑƒÑ€Ð¾Ñ€Ñ‚Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(18979,528,'ur','Ø´ÛØ± Ù¹ÛŒÚ©Ø³',0),(18980,528,'sr','Ð“Ñ€Ð°Ð´ÑÐºÐ¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(18981,528,'vi','Thuáº¿ thÃ nh phá»‘',0),(18982,528,'af','Dorp/Stad Belasting',0),(18983,528,'ro','Taxa de oraÅŸ',0),(18984,528,'et','Linnamaksu',0),(18985,528,'si','Mesto davÄne',0),(18986,528,'ba','Pajak kota',0),(18987,528,'nl','Toeristenbelasting',0),(18988,528,'fi','Kaupungin vero',0),(18989,528,'no','Byskatt',0),(18990,528,'da','Byskat',0),(18991,528,'ko','ì‹œ ì„¸ê¸ˆ',0),(18992,528,'he','×ž×¡ ×¢×™×¨×•× ×™',0),(18993,528,'el','Î”Î·Î¼Î¿Ï„Î¹ÎºÏŒÏ‚ Ï†ÏŒÏÎ¿Ï‚',0),(18994,528,'zh','å¸‚ç¨Ž\r\n',0),(18995,528,'sv','Stadsskatt',0),(18996,528,'it','Tassa di soggiorno',0),(18997,528,'tl','',0),(18998,528,'th','&#3616;&#3634;&#3625;&#3637;&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;',0),(18999,528,'hi','à¤¶à¤¹à¤° à¤•à¤°',0),(19000,528,'ms','Cukai bandar',0),(19001,528,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(19002,528,'fr','Taxe de sÃ©jour',0),(19003,528,'jp','å¸‚ç¨Ž',0),(19004,528,'pt','Imposto Municipal',0),(19005,528,'ru','Ð“Ð¾Ñ€Ð¾Ð´ÑÐºÐ¾Ð¹ ÐÐ°Ð»Ð¾Ð³',0),(19006,528,'es','Ciudad Impuesto',0),(19007,528,'de','Kurtaxe',0),(19008,528,'en','City Tax',0),(19009,529,'is','',0),(19010,529,'dr','Ù‚Ø³Ù…Øª Ø²ÙŠØ± Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø«Ø¨Øª  Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù‡ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡  Ù…Ø¹ÙƒÙˆØ³ ÙƒÙ†ÙŠØ¯',0),(19011,529,'pr','Ù‚Ø³Ù…Øª Ø²ÙŠØ± Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø«Ø¨Øª  Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù‡ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡  Ù…Ø¹ÙƒÙˆØ³ ÙƒÙ†ÙŠØ¯',0),(19012,529,'tr','AÅŸaÄŸÄ±da tersine Ã§evirmek iÃ§in tÄ±klatÄ±n<br>belirtilen ay iÃ§in baÅŸlÄ±klar',0),(19013,529,'pl','Kliknij poniÅ¼ej, aby odwrÃ³ciÄ‡<br>wpisy w okreÅ›lonym miesiÄ…cu',0),(19014,529,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ, Ð·Ð° Ð´Ð° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‚Ðµ<br>Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¿Ð¾ÑÐ¾Ñ‡ÐµÐ½Ð¸Ñ Ð¼ÐµÑÐµÑ†',0),(19015,529,'ur','Ù†ÛŒÚ†Û’ Ø§Ù„Ù¹Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº<br>Ø§Ø®ØªØµØ§ØµÛŒ Ù…ÛÛŒÙ†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(19016,529,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ð·Ð° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ<br>ÑÑ‚Ð°Ð²ÐºÐµ Ð·Ð° Ð½Ð°Ð²ÐµÐ´ÐµÐ½Ð¸ Ð¼ÐµÑÐµÑ†',0),(19017,529,'vi','Nháº¥n dÆ°á»›i Ä‘Ã¢y Ä‘á»ƒ viáº¿t ngÆ°á»£c<br> cho má»™t thÃ¡ng cá»¥ thá»ƒ',0),(19018,529,'af','Klik hieronder om te ruil<br>inskrywings vir gespesifiseerde maand',0),(19019,529,'ro','Click mai jos pentru a inversa<br>ÃŽnscrierile pentru luna specificat',0),(19020,529,'et','KlÃµpsake allpool reverse<br>VÃµistlustÃ¶Ã¶d ette mÃ¤Ã¤ratud kuu',0),(19021,529,'si','Kliknite spodaj, da se obrne<br>vnosov za navedeni mesec',0),(19022,529,'ba','Klik di bawah untuk membalikkan<br>entri untuk bulan tertentu',0),(19023,529,'nl','Klik hieronder om te keren<br>vermeldingen voor opgegeven maand',0),(19024,529,'fi','Napsauta alla kÃ¤Ã¤ntÃ¤Ã¤<br>mÃ¤Ã¤ritetyn kuukauden tapahtumat',0),(19025,529,'no','Klikk nedenfor for Ã¥ reversere<br>oppfÃ¸ringer for angitte mÃ¥neden',0),(19026,529,'da','Klik nedenfor for at vende<br>indgange til angivne mÃ¥ned',0),(19027,529,'ko','ë°˜ëŒ€ë¡œ ì•„ëž˜ë¥¼ í´ë¦­<br>ì§€ì • ëœ ì›”ì— ëŒ€ í•œ í•­ëª©',0),(19028,529,'he','×œ×—×¥ ×œ×”×œ×Ÿ ×›×“×™ ×œ×”×¤×•×š<br>×¢×¨×›×™ ×‘×—×•×“×© ×©×¦×•×™×Ÿ',0),(19029,529,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î³Î¹Î± Ï„Î·Î½ Î±Î½Î±ÏƒÏ„ÏÎ¿Ï†Î®<br>ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î³Î¹Î± Ï„Î¿ ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Î¼Î®Î½Î±',0),(19030,529,'zh','ç‚¹å‡»ä¸‹é¢çš„åå‘æŒ‡å®šæœˆä»½<br>ç‰©ç†åŒ–å­¦æ¡ç›®\r\n',0),(19031,529,'sv','Klicka nedan fÃ¶r att vÃ¤nda<br>poster fÃ¶r angiven mÃ¥nad',0),(19032,529,'it','Clicca qui sotto per invertire<br>voci per mese specificato',0),(19033,529,'tl','',0),(19034,529,'th','&#3588;&#3621;&#3636;&#3585;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3618;&#3657;&#3629;&#3609;&#3585;&#3621;&#3633;&#3610;<br>&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3635;&#3627;&#3619;&#3633',0),(19035,529,'hi','à¤°à¤¿à¤µà¤°à¥à¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚<br>à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤‚',0),(19036,529,'ms','Klik di bawah untuk menarik balik<br>entri untuk bulan tertentu',0),(19037,529,'ar','Ø§Ù†Ù‚Ø± Ø£Ø¯Ù†Ø§Ù‡ Ù„Ø¹ÙƒØ³<br>Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ù„Ù„Ø´Ù‡Ø± Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(19038,529,'fr','Cliquez ci-dessous pour inverser<br>inscriptions pour le mois spÃ©cifiÃ©',0),(19039,529,'jp','ç„¡åŠ¹ã?«ã?™ã‚‹ã?«ã?¯ä¸‹ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„<br>ç‰¹å®šã?•ã‚Œã?Ÿæœˆã?®å…¥åŠ›',0),(19040,529,'pt','Clique abaixo para inverter<br>inscriÃ§Ãµes para o mÃªs especificado',0),(19041,529,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð¸Ð¶Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾Ð±Ñ€Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð²ÑÐ¿ÑÑ‚ÑŒ<br>Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð»Ñ ÑƒÐºÐ°Ð·Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð¼ÐµÑÑÑ†Ð°',0),(19042,529,'es','Click Abajo Para reversar<br>entradas para el MES especificado',0),(19043,529,'de','Klicken Sie unten, um umzukehren<br>EintrÃ¤ge fÃ¼r den angegebenen Monat',0),(19044,529,'en','Click below to reverse<br>entries for specified MONTH',0),(19045,530,'is','',0),(19046,530,'dr','Ù‚Ø³Ù…Øª Ø²ÙŠØ± Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø«Ø¨Øª  Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡  Ù…Ø¹ÙƒÙˆØ³ ÙƒÙ†ÙŠØ¯',0),(19047,530,'pr','Ù‚Ø³Ù…Øª Ø²ÙŠØ± Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø«Ø¨Øª  Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡  Ù…Ø¹ÙƒÙˆØ³ ÙƒÙ†ÙŠØ¯',0),(19048,530,'tr','AÅŸaÄŸÄ±da tersine Ã§evirmek iÃ§in tÄ±klatÄ±n<br>Belirtilen tarih iÃ§in baÅŸlÄ±klar',0),(19049,530,'pl','Kliknij poniÅ¼ej, aby odwrÃ³ciÄ‡<br>wpisy dla okreÅ›lonej daty',0),(19050,530,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ, Ð·Ð° Ð´Ð° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‚Ðµ<br>Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð° Ð´Ð°Ñ‚Ð°',0),(19051,530,'ur','Ù†ÛŒÚ†Û’ Ø§Ù„Ù¹Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº<br>Ø§Ø®ØªØµØ§ØµÛŒ ØªØ§Ø±ÛŒØ® Ú©Û’ Ù„ÛŒÛ’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(19052,530,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ð·Ð° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ<br>ÑÑ‚Ð°Ð²ÐºÐµ Ð·Ð° Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(19053,530,'vi','Nháº¥n dÆ°á»›i Ä‘Ã¢y Ä‘á»ƒ viáº¿t ngÆ°á»£c<br> cho má»™t ngÃ y cá»¥ thá»ƒ',0),(19054,530,'af','Klik hieronder om te ruil<br>inskrywings vir die gespesifiseerde datum',0),(19055,530,'ro','Click mai jos pentru a inversa<br>ÃŽnscrierile pentru data specificatÄƒ',0),(19056,530,'et','KlÃµpsake allpool reverse<br>mÃ¤Ã¤ratud KUUPÃ„EVA kanded',0),(19057,530,'si','Kliknite spodaj, da se obrne<br>vnosov za navedeni DATUMSKI',0),(19058,530,'ba','Klik di bawah untuk membalikkan<br>entri untuk tanggal tertentu',0),(19059,530,'nl','Klik hieronder om te keren<br>vermeldingen voor de opgegeven datum',0),(19060,530,'fi','Napsauta alla kÃ¤Ã¤ntÃ¤Ã¤<br>tapahtumat mÃ¤Ã¤ritettyyn PÃ„IVÃ„MÃ„Ã„RÃ„Ã„N',0),(19061,530,'no','Klikk nedenfor for Ã¥ reversere<br>oppfÃ¸ringer for angitt dato',0),(19062,530,'da','Klik nedenfor for at vende<br>indgange til angivne dato',0),(19063,530,'ko','ë°˜ëŒ€ë¡œ ì•„ëž˜ë¥¼ í´ë¦­<br>ì§€ì • ëœ ë‚ ì§œì— ëŒ€ í•œ í•­ëª©',0),(19064,530,'he','×œ×—×¥ ×œ×”×œ×Ÿ ×›×“×™ ×œ×”×¤×•×š<br>×”×¢×¨×›×™× ×¢×‘×•×¨ ×ª××¨×™×š ×ž×¡×•×™×',0),(19065,530,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î³Î¹Î± Ï„Î·Î½ Î±Î½Î±ÏƒÏ„ÏÎ¿Ï†Î®<br>ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î·Î½ ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(19066,530,'zh','\r\nç‚¹å‡»ä¸‹é¢çš„åå‘<br>ç‰©ç†åŒ–å­¦æ¡ç›®æŒ‡å®šæ—¥æœŸ\r\n',0),(19067,530,'sv','Klicka nedan fÃ¶r att vÃ¤nda<br>poster fÃ¶r angivet datum',0),(19068,530,'it','Clicca qui sotto per invertire<br>voci per la data specificata',0),(19069,530,'tl','',0),(19070,530,'th','&#3588;&#3621;&#3636;&#3585;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3618;&#3657;&#3629;&#3609;&#3585;&#3621;&#3633;&#3610;<br>&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3635;&#3627;&#3619;&#3633',0),(19071,530,'hi','à¤°à¤¿à¤µà¤°à¥à¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚<br>à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤¤à¤¿à¤¥à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤‚',0),(19072,530,'ms','Klik di bawah untuk menarik balik<br>penyertaan untuk tarikh tertentu',0),(19073,530,'ar','Ø§Ù†Ù‚Ø± Ø£Ø¯Ù†Ø§Ù‡ Ù„Ø¹ÙƒØ³<br>Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ù„ØªØ§Ø±ÙŠØ® Ù…Ø­Ø¯Ø¯',0),(19074,530,'fr','Cliquez ci-dessous pour inverser<br>inscriptions pour la DATE spÃ©cifiÃ©e',0),(19075,530,'jp','ç„¡åŠ¹ã?«ã?™ã‚‹ã?«ã?¯ä¸‹ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„<br>ç‰¹å®šã?•ã‚Œã?Ÿæ—¥ã?«ã?¡ã?®å…¥åŠ›',0),(19076,530,'pt','Clique abaixo para inverter<br>inscriÃ§Ãµes para a data especificada',0),(19077,530,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð¸Ð¶Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾Ð±Ñ€Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð²ÑÐ¿ÑÑ‚ÑŒ<br>Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð»Ñ ÑƒÐºÐ°Ð·Ð°Ð½Ð½Ð¾Ð¹ Ð´Ð°Ñ‚Ñ‹',0),(19078,530,'es','Click Abajo Para reversar<br>entradas para la Fecha especificada',0),(19079,530,'de','Klicken Sie unten, um umzukehren<br>EintrÃ¤ge fÃ¼r die angegebene Datum',0),(19080,530,'en','Click below to reverse<br>entries for specified DATE',0),(19081,531,'is','',0),(19082,531,'dr','Ø¯ÙƒÙ…Ù‡ Ø²ÙŠØ± Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ú¯Ø²Ø§Ø±Ø´ Ø®ÙˆØ¯ Ø±Ø§  Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒÙ†ÙŠØ¯',0),(19083,531,'pr','Ø¯ÙƒÙ…Ù‡ Ø²ÙŠØ± Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ú¯Ø²Ø§Ø±Ø´ Ø®ÙˆØ¯ Ø±Ø§  Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒÙ†ÙŠØ¯',0),(19084,531,'tr','Raporunuzu indirmek iÃ§in dÃ¼ÄŸmesini tÄ±klatÄ±n',0),(19085,531,'pl','Kliknij przycisk, aby pobraÄ‡ raport',0),(19086,531,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð±ÑƒÑ‚Ð¾Ð½Ð° Ð·Ð° Ð¸Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(19087,531,'ur','Ø¢Ù¾ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ú©Ùˆ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ù¹Ù† Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(19088,531,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÐ»Ð¸ Ñ‚Ð²Ð¾Ñ˜ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(19089,531,'vi','Nháº¥n nÃºt nÃ y Ä‘á»ƒ táº£i bÃ¡o cÃ¡o cá»§a báº¡n',0),(19090,531,'af','Kliek knoppie om u verslag af te laai',0),(19091,531,'ro','FaceÅ£i clic pe butonul pentru a descÄƒrca raportul dumneavoastrÄƒ',0),(19092,531,'et','KlÃµpsake nuppu, et laadida oma aruande',0),(19093,531,'si','Kliknite gumb za prenos vaÅ¡e poroÄilo',0),(19094,531,'ba','Klik untuk mengunduh laporan Anda',0),(19095,531,'nl','Klik om te downloaden van uw rapport',0),(19096,531,'fi','Valitse ladattavan raportin',0),(19097,531,'no','Klikk hvis du vil laste ned rapporten',0),(19098,531,'da','Klik pÃ¥ knappen for at downloade din rapport',0),(19099,531,'ko','ë³´ê³ ì„œë¥¼ ë‹¤ìš´ë¡œë“œ ë²„íŠ¼ì„ í´ë¦­',0),(19100,531,'he','×œ×—×¥ ×¢×œ ×œ×—×¦×Ÿ ×›×“×™ ×œ×”×•×¨×™×“ ××ª ×”×“×• ×— ×©×œ×š',0),(19101,531,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÎºÎ¿Ï…Î¼Ï€Î¯ Î³Î¹Î± Î½Î± ÎºÎ±Ï„ÎµÎ²Î¬ÏƒÎµÏ„Îµ Ï„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ® ÏƒÎ±Ï‚',0),(19102,531,'zh','æŒ‰ä¸€ä¸‹æŒ‰é’®ä»¥ä¸‹è½½æ‚¨çš„æŠ¥å‘Š\r\n',0),(19103,531,'sv','Klicka pÃ¥ knappen fÃ¶r att ladda ner rapporten',0),(19104,531,'it','Fare clic sul pulsante per scaricare il report',0),(19105,531,'tl','',0),(19106,531,'th','&#3588;&#3621;&#3636;&#3585;&#3586;&#3657;&#3634;&#3591;&#3621;&#3656;&#3634;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3588;&#3',0),(19107,531,'hi','à¤†à¤ªà¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤Ÿà¤¨ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(19108,531,'ms','Klik butang untuk memuat turun laporan anda',0),(19109,531,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„Ø²Ø± Ù„ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(19110,531,'fr','Cliquez sur le bouton pour tÃ©lÃ©charger votre rapport',0),(19111,531,'jp','ãƒ¬ãƒ?ãƒ¼ãƒˆã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã?™ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(19112,531,'pt','Clique no botÃ£o para baixar o relatÃ³rio',0),(19113,531,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð·Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ð²Ð°Ñˆ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(19114,531,'es','Click el BotÃ³n para descargar su informe',0),(19115,531,'de','Klicken Sie, um Ihren Bericht herunterladen',0),(19116,531,'en','Click button to download your report',0),(19117,532,'is','',0),(19118,532,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(19119,532,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(19120,532,'tr','buraya tÄ±klayÄ±n',0),(19121,532,'pl','Kliknij tutaj',0),(19122,532,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð°',0),(19123,532,'ur','ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(19124,532,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ',0),(19125,532,'vi','nháº¥n vÃ o Ä‘Ã¢y',0),(19126,532,'af','kliek hier',0),(19127,532,'ro','faceÅ£i clic aici',0),(19128,532,'et','Kliki siia',0),(19129,532,'si','Kliknite tukaj',0),(19130,532,'ba','Klik di sini',0),(19131,532,'nl','Klik hier',0),(19132,532,'fi','Klikkaa tÃ¤stÃ¤',0),(19133,532,'no','Klikk her',0),(19134,532,'da','Klik her',0),(19135,532,'ko','ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì„¸ìš”',0),(19136,532,'he','×œ×—×¥ ×›××Ÿ',0),(19137,532,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ',0),(19138,532,'zh','ç‚¹å‡»è¿™é‡Œ\r\n',0),(19139,532,'sv','Klicka hÃ¤r',0),(19140,532,'it','Clicca qui',0),(19141,532,'tl','',0),(19142,532,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;',0),(19143,532,'hi','à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(19144,532,'ms','Klik di sini',0),(19145,532,'ar','Ø£Ù†Ù‚Ø± Ù‡Ù†Ø§',0),(19146,532,'fr','Cliquez ici',0),(19147,532,'jp','ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(19148,532,'pt','Clique aqui',0),(19149,532,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ',0),(19150,532,'es','Click aquÃ­',0),(19151,532,'de','Klicken Sie hier',0),(19152,532,'en','click here',0),(19153,533,'is','',0),(19154,533,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ ÙŠÙƒ Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø§ÙŠ  Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø§ÙƒØ³Ù„ Ø§Ø±Ø³Ø§Ù„ Ø´ÙˆØ¯',0),(19155,533,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ ÙŠÙƒ Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø§ÙŠ  Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø§ÙƒØ³Ù„ Ø§Ø±Ø³Ø§Ù„ Ø´ÙˆØ¯',0),(19156,533,'tr','MS Excel\'e rapor vermek iÃ§in buraya tÄ±klayÄ±n',0),(19157,533,'pl','Kliknij tutaj, aby wyeksportowaÄ‡ raport do MS Excel',0),(19158,533,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð² MS Excel',0),(19159,533,'ur','MS Ø§ÛŒÚ©Ø³Ù„ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ø±Ù¾ÙˆØ±Ù¹ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(19160,533,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð²ÐµÐ·Ð»Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ñƒ ÐœÐ¡ Ð•xÑ†ÐµÐ»',0),(19161,533,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ xuáº¥t bÃ¡o cÃ¡o sang MS Excel',0),(19162,533,'af','Kliek hier om \'n verslag uit te voer na MS Excel ',0),(19163,533,'ro','Click aici pentru a exporta un raport MS Excel',0),(19164,533,'et','Vajuta siia, et aruande eksportimiseks MS Excel',0),(19165,533,'si','Kliknite tukaj za izvoz poroÄila v MS Excel',0),(19166,533,'ba','Klik di sini untuk mengekspor laporan ke MS Excel',0),(19167,533,'nl','Klik hier als u wilt een rapport exporteren naar MS Excel',0),(19168,533,'fi','Klikkaa raportin vieminen MS Excel',0),(19169,533,'no','Klikk her for Ã¥ eksportere en rapport til Excel',0),(19170,533,'da','Klik her for at eksportere en rapport til MS Excel',0),(19171,533,'ko','MS Excelë¡œ ë³´ê³ ì„œë¥¼ ë‚´ë³´ë‚´ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(19172,533,'he','.×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×™×¦× ×“×•×— ×œ×ž×™×§×¨×•×¡×•×¤×˜ ××§×¡×œ',0),(19173,533,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ, Î³Î¹Î± Î½Î± ÎµÎ¾Î±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î±Î½Î±Ï†Î¿ÏÎ¬ ÏƒÎµ MS Excel',0),(19174,533,'zh','ç‚¹å‡»æ­¤å¤„å°†æŠ¥è¡¨å¯¼å‡ºåˆ°MS Excelä¸­\r\n',0),(19175,533,'sv','Klicka hÃ¤r fÃ¶r att exportera en rapport till MS Excel',0),(19176,533,'it','Clicca qui per esportare un report in MS Excel',0),(19177,533,'tl','',0),(19178,533,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3652;&#3611;&#3618;&#3633;&#3591; MS Excel.',0),(19179,533,'hi','MS Excel à¤•à¥‹ à¤à¤• à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(19180,533,'ms','Klik di sini untuk mengeksport laporan ke MS Excel',0),(19181,533,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„ØªØµØ¯ÙŠØ± ØªÙ‚Ø±ÙŠØ± Ø¥Ù„Ù‰ MS Excel',0),(19182,533,'fr','Cliquez ici pour exporter un rapport vers MS Excel',0),(19183,533,'jp','ã‚¨ã‚¯ã‚»ãƒ«ã?«ãƒ¬ãƒ?ãƒ¼ãƒˆã‚’ã‚¨ã‚­ã‚¹ãƒ?ãƒ¼ãƒˆã?™ã‚‹ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(19184,533,'pt','Clique aqui para exportar um relatÃ³rio para o MS Excel',0),(19185,533,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ ÑÑŽÐ´Ð° Ð´Ð»Ñ Ð¿ÐµÑ€ÐµÐ½Ð¾ÑÐ° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° Ð² MS Excel.',0),(19186,533,'es','Click AquÃ­ para exportar un informe a MS Excel',0),(19187,533,'de','Klicken Sie hier, um einen Bericht in MS Excel zu exportieren',0),(19188,533,'en','Click here to export a report to MS Excel',0),(19189,534,'is','',0),(19190,534,'dr','/ Ø¨Ù‡ Ø±ÙˆØ² ÙƒØ±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§Ø² Ú¯Ø±Ø¯ÙŠØ¯',0),(19191,534,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¨Ù‡ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ  Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ² ÙƒØ±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§Ø² Ú¯Ø±Ø¯ÙŠØ¯',0),(19192,534,'tr','TÄ±klayÄ±n dÃ¶nmek iÃ§in bÃ¼tÃ§e Ekle/GÃ¼ncelle ana sayfa.',0),(19193,534,'pl','Kliknij tutaj, aby powrÃ³ciÄ‡ do gÅ‚Ã³wnego dodaÄ‡ aktualizacja budÅ¼etu strony.',0),(19194,534,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº Ð·Ð° Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð³Ð»Ð°Ð²Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°.',0),(19195,534,'ur','Ø¨Ø¬Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÙ† Ù…ÛŒÚº ÙˆØ§Ù¾Ø³ÛŒ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº ØµÙØ­Û.',0),(19196,534,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚Ð°Ðº Ð½Ð° Ð±ÑƒÑŸÐµÑ‚/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð³Ð»Ð°Ð²Ð½Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ.',0),(19197,534,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ quay láº¡i trang chá»§ ThÃªm/Cáº­p Nháº­t NgÃ¢n SÃ¡ch',0),(19198,534,'af','Kliek Hier om terug te keer na die Begroting Byvoeg/Opdateer Hoofblad.',0),(19199,534,'ro','Click aici pentru a reveni la buget AdÄƒugaÅ£i/actualizaÅ£i principalele filme.',0),(19200,534,'et','Vajuta siia, et naasta eelarve Lisa/vÃ¤rskenda Main Page.',0),(19201,534,'si','Kliknite tukaj za vrnitev glavni proraÄun Dodaj/posodobi strani.',0),(19202,534,'ba','Klik di sini untuk kembali ke anggaran menambahkan Update utama halaman.',0),(19203,534,'nl','Klik hier om terug te keren naar de begroting toevoegen/bijwerken Main Page.',0),(19204,534,'fi','Klikkaa tÃ¤stÃ¤ palata talousarvioon lisÃ¤Ã¤/PÃ¤ivitÃ¤ tÃ¤rkein sivu.',0),(19205,534,'no','Klikk her for Ã¥ gÃ¥ tilbake til budsjett Legg til/Oppdater Main siden.',0),(19206,534,'da','Klik her for at tilbagevenden til Budget TilfÃ¸j/opdater Main side.',0),(19207,534,'ko','ì˜ˆì‚° ì¶”ê°€/ì—…ë°ì´íŠ¸ ë©”ì¸ì— ë°˜í™˜ í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ íŽ˜ì´ì§€.',0),(19208,534,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×—×–×•×¨ ×”×¨××©×™ ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ ×ª×§×¦×™×‘ ×“×£.',0),(19209,534,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ, Î³Î¹Î± Î½Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ­ÏˆÎµÎ¹ Î· ÎºÏÏÎ¹Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï ÏƒÎµÎ»Î¯Î´Î±.',0),(19210,534,'zh','ç‚¹å‡»è¿™é‡Œè¿”å›žé¢„ç®—æ¡ˆæ–°å¢ž/æ›´æ–°çš„é¡µé¢ã€‚\r\n',0),(19211,534,'sv','Klicka hÃ¤r fÃ¶r att Ã¥tergÃ¥ till den Budget LÃ¤gg till/uppdatera huvudsakligt sida.',0),(19212,534,'it','Clicca qui per il ritorno al bilancio aggiungere/aggiornare principale pagina.',0),(19213,534,'tl','',0),(19214,534,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3621;&#3633;&#3610;&#3652;&#3611;&#3607;&#3637;&#3656;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603; &#3585;&#3634;&#3619;&#3648;&#',0),(19215,534,'hi','à¤¬à¤œà¤Ÿ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤®à¥à¤–à¥à¤¯ à¤•à¥€ à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚ à¤ªà¥ƒà¤·à¥à¤ à¥¤',0),(19216,534,'ms','Klik di sini untuk kembali ke Main Tambah/Kemaskini bajet laman.',0),(19217,534,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ù„Ø¹ÙˆØ¯Ø© Ù„Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© ØµÙØ­Ø©.',0),(19218,534,'fr','Cliquez ici pour revenir Ã  la Main ajouter/mettre Ã  jour de Budget Page.',0),(19219,534,'jp','äºˆç®—ã?®è¿½åŠ /æ›´æ–°ã?®ãƒ¡ã‚¤ãƒ³ãƒšãƒ¼ã‚¸ã?«æˆ»ã‚‹ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(19220,534,'pt','Cliquem aqui para voltar ao orÃ§amento principal adicionar/atualizar pÃ¡gina.',0),(19221,534,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð²ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ð½Ð° Ð³Ð»Ð°Ð²Ð½ÑƒÑŽ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð±ÑŽÐ´Ð¶ÐµÑ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹.',0),(19222,534,'es','Click AquÃ­ para Regresar al Presupuesto Agregar/Actualizar PÃ¡gina Principal',0),(19223,534,'de','Hier geht\'s zur RÃ¼ckkehr in den Haushalt hinzufÃ¼gen/aktualisieren Main Page.',0),(19224,534,'en','Click Here to Return to the Budget Add/Update Main Page.',0),(19225,535,'is','',0),(19226,535,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨ÙŠØ´ØªØ±ÙŠ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡  ÙŠØ§ Ø¨Ù‡ Ø±ÙˆØ² ÙƒÙ†ÙŠØ¯',0),(19227,535,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨ÙŠØ´ØªØ±ÙŠ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡  ÙŠØ§ Ø¨Ù‡ Ø±ÙˆØ² ÙƒÙ†ÙŠØ¯',0),(19228,535,'tr','GÃ¼ncelleÅŸtirmek iÃ§in burayÄ± tÄ±klatÄ±n veya daha fazla bÃ¼tÃ§e ekleyin.',0),(19229,535,'pl','Kliknij tutaj aby poprawiÄ‡ lub dodaÄ‡ wiÄ™cej budÅ¼etÃ³w.',0),(19230,535,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²ÐµÑ‚Ðµ Ð¾Ñ‰Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸.',0),(19231,535,'ur','Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº ÛŒØ§ Ù…Ø²ÛŒØ¯ ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº Û”',0),(19232,535,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð·Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¸Ð»Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ð¸ÑˆÐµ Ð±ÑƒÑŸÐµÑ‚Ðµ.',0),(19233,535,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ Cáº­p Nháº­t hay ThÃªm NgÃ¢n SÃ¡ch',0),(19234,535,'af','Kliek Hier vir Opdatering of Voeg Meer Begrotings By.',0),(19235,535,'ro','FaceÅ£i clic aici pentru actualizare sau pentru a adÄƒuga mai multe bugete.',0),(19236,535,'et','Click Here to Update vÃµi lisada rohkem eelarved.',0),(19237,535,'si','Kliknite tukaj za posodobitev ali dodate veÄ proraÄunov.',0),(19238,535,'ba','Klik di sini untuk Update atau menambahkan lebih banyak anggaran.',0),(19239,535,'nl','Klik hier om Update of voeg meer begrotingen.',0),(19240,535,'fi','Napsauttamalla tÃ¤tÃ¤ PÃ¤ivitÃ¤ tai lisÃ¤Ã¤ lisÃ¤Ã¤ budjetit.',0),(19241,535,'no','Klikk her Ã¥ oppdatere eller legge til flere budsjetter.',0),(19242,535,'da','Klik her for at opdatere eller tilfÃ¸je flere budgetter.',0),(19243,535,'ko','ì—…ë°ì´íŠ¸ í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ê±°ë‚˜ ë” ë§Žì€ ì˜ˆì‚°ì„ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(19244,535,'he','×œ×—×¥ ×›××Ÿ ×œ×¢×“×›×•×Ÿ ××• ×œ×”×•×¡×™×£ ×ª×§×¦×™×‘×™× × ×•×¡×¤×™×.',0),(19245,535,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Î® Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚.',0),(19246,535,'zh','ç‚¹å‡»è¿™é‡Œæ›´æ–°æˆ–å¢žåŠ é¢„ç®—ã€‚\r\n',0),(19247,535,'sv','Klicka hÃ¤r fÃ¶r att uppdatera eller lÃ¤gga till mer budgetar.',0),(19248,535,'it','Clicca qui per l\'aggiornamento o aggiungere ulteriori bilanci.',0),(19249,535,'tl','',0),(19250,535,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3619;&#3639;&#3629;&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3610;&#3611;&#3619;&#3',0),(19251,535,'hi','à¤¯à¤¹à¤¾à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤…à¤§à¤¿à¤• à¤¬à¤œà¤Ÿ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚à¥¤',0),(19252,535,'ms','Klik di sini untuk Kemaskini atau menambah belanjawan yang lebih banyak.',0),(19253,535,'ar','Ø£Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„ØªØ­Ø¯ÙŠØ« Ø£Ùˆ Ø¥Ø¶Ø§ÙØ© Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ø¥Ø¶Ø§ÙÙŠØ©.',0),(19254,535,'fr','Cliquez ici pour la mise Ã  jour ou ajouter plus de Budgets.',0),(19255,535,'jp','äºˆç®—ã‚’æ›´æ–°å?ˆã?¯è¿½åŠ ã?™ã‚‹ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(19256,535,'pt','Clique aqui para atualizar ou adicionar mais orÃ§amentos.',0),(19257,535,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð¡ÑŽÐ´Ð° Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¸Ð»Ð¸ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ñ‹.',0),(19258,535,'es','Click AquÃ­ para Actualizar o Agregar MÃ¡s Presupuestos',0),(19259,535,'de','Hier geht\'s zum Update, oder fÃ¼gen Sie weitere Budgets.',0),(19260,535,'en','Click Here to Update or Add More Budgets.',0),(19261,536,'is','',0),(19262,536,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¬Ø²Ø¦ÙŠØ§Øª Ø±Ø§ Ø¨Ø¨ÙŠÙ†ÙŠØ¯',0),(19263,536,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¬Ø²Ø¦ÙŠØ§Øª Ø±Ø§ Ø¨Ø¨ÙŠÙ†ÙŠØ¯',0),(19264,536,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ bilgileri iÃ§in tÄ±klayÄ±nÄ±z',0),(19265,536,'pl','Kliknij tutaj aby zobacz szczegÃ³Å‚y',0),(19266,536,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(19267,536,'ur','Ù…Ù†Ø¸Ø± ØªÙØ§ØµÛŒÙ„ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(19268,536,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð´ÐµÑ‚Ð°Ñ™Ð°',0),(19269,536,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ xem chi tiáº¿t',0),(19270,536,'af','Kliek Hier om Details te Besigtig',0),(19271,536,'ro','Click aici sa Vezi detalii',0),(19272,536,'et','KlÃµpsa siia, et nÃ¤ha tÃ¤psemalt',0),(19273,536,'si','Kliknite tukaj za ogled podrobnosti',0),(19274,536,'ba','Klik disini untuk Lihat rincian',0),(19275,536,'nl','Klik hier om te bekijken',0),(19276,536,'fi','Napsauttamalla NÃ¤ytÃ¤ tiedot',0),(19277,536,'no','Klikk her for Ã¥ visningsdetaljer',0),(19278,536,'da','Klik her for at se detaljer',0),(19279,536,'ko','ì„¸ë¶€ ì •ë³´ ë³´ê¸°ì— ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(19280,536,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×”×¦×’×ª ×¤×¨×˜×™×',0),(19281,536,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(19282,536,'zh','ç‚¹å‡»è¿™é‡ŒæŸ¥çœ‹è¯¦ç»†ä¿¡æ¯\r\n',0),(19283,536,'sv','Klicka hÃ¤r fÃ¶r att Visa Detaljer',0),(19284,536,'it','Clicca qui per maggiori dettagli',0),(19285,536,'tl','',0),(19286,536,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(19287,536,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(19288,536,'ms','Klik di sini untuk lihat butiran',0),(19289,536,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¹Ø±Ø¶ Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(19290,536,'fr','Cliquez ici pour voir les dÃ©tails',0),(19291,536,'jp','è©³ç´°ã‚’è¡¨ç¤ºã?™ã‚‹ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(19292,536,'pt','Clique aqui para ver os detalhes',0),(19293,536,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð¡ÑŽÐ´Ð° Ð´Ð»Ñ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð”ÐµÑ‚Ð°Ð»ÐµÐ¹',0),(19294,536,'es','Click AquÃ­ para Ver Detalles',0),(19295,536,'de','Klicken Sie hier, um Details anzeigen',0),(19296,536,'en','Click Here to View Details',0),(19297,537,'is','',0),(19298,537,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†  Ø±Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ†ÙŠØ¯',0),(19299,537,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†  Ø±Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ†ÙŠØ¯',0),(19300,537,'tr','SatÄ±cÄ±lar CSV listesini gÃ¶rÃ¼ntÃ¼lemek iÃ§in burayÄ± tÄ±klatÄ±n',0),(19301,537,'pl','Kliknij tutaj, aby wyÅ›wietliÄ‡ listÄ™ CSV dostawcÃ³w',0),(19302,537,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ CSV ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸Ñ‚Ðµ',0),(19303,537,'ur','CSV Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©ÛŒ ÙÛØ±Ø³Øª Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(19304,537,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð·Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð¦Ð¡Ð’ Ð»Ð¸ÑÑ‚Ñƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(19305,537,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ xem danh sÃ¡ch CSV cá»§a ngÆ°á»i bÃ¡n',0),(19306,537,'af','Kliek Hier om die CSV Lys van Verskaffers te Besigtig',0),(19307,537,'ro','Click aici pentru a vizualiza lista CSV de furnizori',0),(19308,537,'et','KlÃµpsa siia, et nÃ¤ha CSV faili hankijatest',0),(19309,537,'si','Kliknite tukaj za ogled CSV seznam prodajalcev',0),(19310,537,'ba','Klik di sini untuk melihat daftar vendor CSV',0),(19311,537,'nl','Klik hier om te bekijken de CSV lijst van verkopers',0),(19312,537,'fi','Klikkaa tÃ¤stÃ¤ nÃ¤hdÃ¤ksesi toimittajien CSV-luettelo',0),(19313,537,'no','Klikk her for Ã¥ vise listen CSV leverandÃ¸rer',0),(19314,537,'da','Klik her for at se CSV-listen over sÃ¦lgere',0),(19315,537,'ko','ê³µê¸‰ ì—…ì²´ì˜ CSV ëª©ë¡ì„ ë³´ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(19316,537,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×¦×™×’ ××ª ×¨×©×™×ž×ª ×”-CSV ×¡×¤×§×™×',0),(19317,537,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î· Î»Î¯ÏƒÏ„Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ CSV',0),(19318,537,'zh','ç‚¹å‡»è¿™é‡ŒæŸ¥çœ‹ä¾›åº”å•†çš„CSVåå•\r\n',0),(19319,537,'sv','Klicka hÃ¤r fÃ¶r att visa listan CSV-leverantÃ¶rer',0),(19320,537,'it','Clicca qui per visualizzare la lista CSV dei fornitori',0),(19321,537,'tl','',0),(19322,537,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3652;&#3615;&#3621;&#3660; CSV &#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(19323,537,'hi','CSV à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(19324,537,'ms','Klik di sini untuk melihat senarai vendor CSV',0),(19325,537,'ar','Ø£Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¹Ø±Ø¶ Ù‚Ø§Ø¦Ù…Ø© (CSV) Ù„Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(19326,537,'fr','Cliquez ici pour afficher la liste CSV des vendeurs',0),(19327,537,'jp','æ¥­è€…ã?®CSVãƒªã‚¹ãƒˆã‚’è¦‹ã‚‹ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(19328,537,'pt','Clique aqui para ver a lista de fornecedores CSV',0),(19329,537,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° CSV ÑÐ¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(19330,537,'es','Click AquÃ­ para Ver la Lista de Proveedores de CSV',0),(19331,537,'de','Klicken Sie hier fÃ¼r die CSV-Liste der Anbieter',0),(19332,537,'en','Click Here to View the CSV List of Vendors',0),(19333,538,'is','',0),(19334,538,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù…Ø¹Ø§Ù…Ù„Ø§Øª  Ø±Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ†ÙŠØ¯',0),(19335,538,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù…Ø¹Ø§Ù…Ù„Ø§Øª  Ø±Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ†ÙŠØ¯',0),(19336,538,'tr','Hesap $oldglaccountname gÃ¶rÃ¼ntÃ¼lemek iÃ§in burayÄ± tÄ±klatÄ±n.',0),(19337,538,'pl','Kliknij tutaj, aby wyÅ›wietliÄ‡ transakcje dla konta $oldglaccountname.',0),(19338,538,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ ÑÐ´ÐµÐ»ÐºÐ¸ Ð·Ð° ÑÐ¼ÐµÑ‚ÐºÐ° $oldglaccountname.',0),(19339,538,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ $oldglaccountname Ú©Û’ Ù„Ø¦Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº.',0),(19340,538,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð·Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ð·Ð° Ñ€Ð°Ñ‡ÑƒÐ½ $ Ð¾Ð»Ð´Ð³Ð»Ð°Ñ†Ñ†Ð¾ÑƒÐ½Ñ‚Ð½Ð°Ð¼Ðµ.',0),(19341,538,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ xem giao dá»‹ch cho TK $oldglaccountname.',0),(19342,538,'af','Kliek Hier om transaksies te besigtig vir rekening $oldglaccountname',0),(19343,538,'ro','Click aici pentru a vizualiza tranzacÅ£iile pentru contul $oldglaccountname.',0),(19344,538,'et','KlÃµpsa siia, et nÃ¤ha tehinguid',0),(19345,538,'si','Kliknite tukaj za ogled poslov za raÄun $oldglaccountname.',0),(19346,538,'ba','Klik di sini untuk melihat transaksi untuk akun $oldglaccountname.',0),(19347,538,'nl','Klik hier om te bekijken van transacties voor rekening $oldglaccountname.',0),(19348,538,'fi','Klikkaa tÃ¤stÃ¤ voit tarkastella tilin $oldglaccountname.',0),(19349,538,'no','Klikk her for Ã¥ vise transaksjoner for konto $oldglaccountname.',0),(19350,538,'da','Klik her for at fÃ¥ vist posteringer for konto $oldglaccountname.',0),(19351,538,'ko','ê³„ì • $oldglaccountnameì— ëŒ€ í•œ ê±°ëž˜ë¥¼ ë³´ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(19352,538,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×¦×™×’ ×ª× ×•×¢×•×ª ×¢×‘×•×¨ ×—×©×‘×•×Ÿ $oldglaccountname.',0),(19353,538,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ Î³Î¹Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ $oldglaccountname.',0),(19354,538,'zh','ç‚¹å‡»æ­¤å¤„æŸ¥çœ‹å¸æˆ·$å’ŒGLå¸æˆ·åä¹‰è¿›è¡Œäº¤æ˜“ã€‚\r\n',0),(19355,538,'sv','Klicka hÃ¤r fÃ¶r att Visa transaktioner fÃ¶r konto $oldglaccountname.',0),(19356,538,'it','Clicca qui per visualizzare le transazioni per conto $oldglaccountname.',0),(19357,538,'tl','',0),(19358,538,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637; $oldglaccountname.',0),(19359,538,'hi','à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤•à¥‡ à¤–à¤¾à¤¤à¥‡ $oldglaccountname à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚à¥¤',0),(19360,538,'ms','Klik di sini untuk melihat transaksi bagi akaun $oldglaccountname.',0),(19361,538,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù„Ø­Ø³Ø§Ø¨ $oldglaccountname.',0),(19362,538,'fr','Cliquez ici pour afficher les transactions pour compte $oldglaccountname.',0),(19363,538,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ $oldglaccountnameã€€ã?®å?–å¼•ã‚’è¦‹ã‚‹ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(19364,538,'pt','Clique aqui para ver as transacÃ§Ãµes por conta $oldglaccountname.',0),(19365,538,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð´Ð»Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ $oldglaccountname.',0),(19366,538,'es','Click AquÃ­ para ver transacciones para la cuenta $oldglaccountname.',0),(19367,538,'de','Klicken Sie hier um Transaktionen fÃ¼r Konto $oldglaccountname.',0),(19368,538,'en','Click here to view transactions for account $oldglaccountname.',0),(19369,539,'is','',0),(19370,539,'dr','Ø¨Ø±Ø§ÙŠ Ø¯ÙŠØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(19371,539,'pr','Ø¨Ø±Ø§ÙŠ Ø¯ÙŠØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(19372,539,'tr','Detaylar iÃ§in tÄ±klayÄ±n',0),(19373,539,'pl','Kliknij, aby zobaczyÄ‡ szczegÃ³Å‚y',0),(19374,539,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(19375,539,'ur','ØªÙØµÛŒÙ„Ø§Øª Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(19376,539,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð²Ð¸Ð´ÐµÐ»Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(19377,539,'vi','Nháº¥n Ä‘á»ƒ xem chi tiáº¿t',0),(19378,539,'af','Kliek om details te sien',0),(19379,539,'ro','Click pentru a vedea detalii',0),(19380,539,'et','KlÃµpsake Ã¼ksikasjade kuvamiseks',0),(19381,539,'si','Kliknite za prikaz podrobnosti',0),(19382,539,'ba','Klik untuk melihat rincian',0),(19383,539,'nl','Klik om te zien details',0),(19384,539,'fi','Klikkaa nÃ¤hdÃ¤ksesi tiedot',0),(19385,539,'no','Klikk for Ã¥ se detaljer',0),(19386,539,'da','Klik her for at se detaljer',0),(19387,539,'ko','ì„¸ë¶€ ì •ë³´ë¥¼ í´ë¦­ í•©ë‹ˆë‹¤',0),(19388,539,'he','×œ×—×¥ ×›×“×™ ×œ×¨××•×ª ×¤×¨×˜×™×',0),(19389,539,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(19390,539,'zh','ç‚¹å‡»çœ‹è¯¦ç»†\r\n',0),(19391,539,'sv','Klicka fÃ¶r att se Detaljer',0),(19392,539,'it','Clicca per maggiori dettagli',0),(19393,539,'tl','',0),(19394,539,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(19395,539,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(19396,539,'ms','Klik untuk lihat butiran',0),(19397,539,'ar','Ø£Ù†Ù‚Ø± Ù„Ø±Ø¤ÙŠØ© Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(19398,539,'fr','Cliquez ici pour voir les dÃ©tails',0),(19399,539,'jp','è©³ç´°ã‚’è¦‹ã‚‹',0),(19400,539,'pt','Clique para ver detalhes',0),(19401,539,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑƒÐ²Ð¸Ð´ÐµÑ‚ÑŒ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(19402,539,'es','Click para ver detalles',0),(19403,539,'de','Hier klicken, um Details zu sehen',0),(19404,539,'en','Click to see details',0),(19405,540,'is','',0),(19406,540,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(19407,540,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(19408,540,'tr','GÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klatÄ±n',0),(19409,540,'pl','Kliknij aby zobaczyÄ‡',0),(19410,540,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð˜Ð·Ð³Ð»ÐµÐ´',0),(19411,540,'ur','Ù…Ù†Ø¸Ø± Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(19412,540,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·',0),(19413,540,'vi','Nháº¥n Ä‘á»ƒ Xem',0),(19414,540,'af','Kliek om te Besigtig',0),(19415,540,'ro','Click pentru a vizualiza',0),(19416,540,'et','Vaatamiseks klÃµpsa',0),(19417,540,'si','Kliknite za ogled',0),(19418,540,'ba','Klik untuk melihat',0),(19419,540,'nl','Klik om te bekijken',0),(19420,540,'fi','Klikkaa nÃ¤hdÃ¤ksesi',0),(19421,540,'no','Klikk for Ã¥ vise',0),(19422,540,'da','Klik for at se',0),(19423,540,'ko','í´ë¦­ ë³´ê¸°',0),(19424,540,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’',0),(19425,540,'el','ÎšÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¹Ï„Îµ',0),(19426,540,'zh','ç‚¹å‡»æŸ¥çœ‹\r\n',0),(19427,540,'sv','Klicka fÃ¶r att Visa',0),(19428,540,'it','Mostra',0),(19429,540,'tl','',0),(19430,540,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;',0),(19431,540,'hi','à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(19432,540,'ms','Klik untuk paparan',0),(19433,540,'ar','Ø£Ù†Ù‚Ø± Ù„Ù„Ø¹Ø±Ø¶',0),(19434,540,'fr','Cliquez pour voir',0),(19435,540,'jp','è¦‹ã‚‹',0),(19436,540,'pt','Clique para ver',0),(19437,540,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð´Ð»Ñ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð°',0),(19438,540,'es','Click para Ver',0),(19439,540,'de','Klicken Sie auf Ansicht',0),(19440,540,'en','Click to View',0),(19441,541,'is','',0),(19442,541,'dr','Ø¨Ø³ØªÙ† ',0),(19443,541,'pr','Ø¨Ø³ØªÙ† ',0),(19444,541,'tr','Kapat',0),(19445,541,'pl','Zamknij',0),(19446,541,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸',0),(19447,541,'ur','Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº',0),(19448,541,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸',0),(19449,541,'vi','KhÃ³a sá»•',0),(19450,541,'af','Sluit',0),(19451,541,'ro','ÃŽnchide',0),(19452,541,'et','Sulgege',0),(19453,541,'si','Zaprite',0),(19454,541,'ba','Tutup',0),(19455,541,'nl','Sluiten',0),(19456,541,'fi','Sulje',0),(19457,541,'no','Lukk',0),(19458,541,'da','Luk',0),(19459,541,'ko','ë‹«ê¸°',0),(19460,541,'he','×¡×’×•×¨',0),(19461,541,'el','ÎšÎ»ÎµÎ¯ÏƒÎ¹Î¼Î¿',0),(19462,541,'zh','å…³é—­\r\n',0),(19463,541,'sv','StÃ¤ng',0),(19464,541,'it','Chiudere',0),(19465,541,'tl','',0),(19466,541,'th','&#3611;&#3636;&#3604;',0),(19467,541,'hi','à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(19468,541,'ms','Tutup',0),(19469,541,'ar','Ø§Ù„Ø¥ØºÙ„Ø§Ù‚',0),(19470,541,'fr','Fermer',0),(19471,541,'jp','é–‰ã?˜ã‚‹',0),(19472,541,'pt','Fechar',0),(19473,541,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ',0),(19474,541,'es','Cerrar',0),(19475,541,'de','SchlieÃŸen',0),(19476,541,'en','Close',0),(19477,542,'is','',0),(19478,542,'dr','Ù¾Ù†Ø¬Ø±Ù‡ Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÙŠØ¯',0),(19479,542,'pr','Ù¾Ù†Ø¬Ø±Ù‡ Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÙŠØ¯',0),(19480,542,'tr','Pencereyi Kapat',0),(19481,542,'pl','Zamknij okno',0),(19482,542,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ Ð¿Ñ€Ð¾Ð·Ð¾Ñ€ÐµÑ†Ð°',0),(19483,542,'ur','Ø¯Ø±ÛŒÚ†Û Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº',0),(19484,542,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ Ð¿Ñ€Ð¾Ð·Ð¾Ñ€',0),(19485,542,'vi','ÄÃ³ng cá»­a sá»•',0),(19486,542,'af','Sluit Venster',0),(19487,542,'ro','Inchide fereastra',0),(19488,542,'et','Sulge aken',0),(19489,542,'si','Zaprite okno',0),(19490,542,'ba','Tutup jendela',0),(19491,542,'nl','Sluit venster',0),(19492,542,'fi','Sulje ikkuna',0),(19493,542,'no','Lukk vinduet',0),(19494,542,'da','Luk vinduet',0),(19495,542,'ko','ì°½ì„ ë‹«ìŠµë‹ˆë‹¤',0),(19496,542,'he','×¡×’×•×¨ ×—×œ×•×Ÿ',0),(19497,542,'el','ÎšÎ»ÎµÎ¯ÏƒÎ¹Î¼Î¿ Ï€Î±ÏÎ±Î¸ÏÏÎ¿Ï…',0),(19498,542,'zh','å…³é—­çª—å£\r\n',0),(19499,542,'sv','StÃ¤ng fÃ¶nstret',0),(19500,542,'it','Chiudere la finestra',0),(19501,542,'tl','',0),(19502,542,'th','&#3611;&#3636;&#3604;&#3627;&#3609;&#3657;&#3634;&#3605;&#3656;&#3634;&#3591;',0),(19503,542,'hi','à¤µà¤¿à¤‚à¤¡à¥‹ à¤•à¥‹ à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(19504,542,'ms','Tutup tetingkap',0),(19505,542,'ar','Ø¥ØºÙ„Ø§Ù‚ Ø§Ù„Ù†Ø§ÙØ°Ø©',0),(19506,542,'fr','Fermer la fenÃªtre',0),(19507,542,'jp','ã‚¦ã‚¤ãƒ³ãƒ‰ã‚¦ã‚’é–‰ã?˜ã‚‹',0),(19508,542,'pt','Fechar janela',0),(19509,542,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ ÐžÐºÐ½Ð¾',0),(19510,542,'es','Cerrar Ventana',0),(19511,542,'de','SchlieÃŸen Sie das Fenster',0),(19512,542,'en','Close Window',0),(19513,543,'is','',0),(19514,543,'dr','Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(19515,543,'pr','Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(19516,543,'tr','KapalÄ±',0),(19517,543,'pl','ZamkniÄ™te',0),(19518,543,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(19519,543,'ur','Ø¨Ù†Ø¯',0),(19520,543,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð°',0),(19521,543,'vi','KhÃ³a sá»•',0),(19522,543,'af','Gesluit',0),(19523,543,'ro','ÃŽnchis',0),(19524,543,'et','Suletud',0),(19525,543,'si','Zaprta',0),(19526,543,'ba','Ditutup',0),(19527,543,'nl','Gesloten',0),(19528,543,'fi','Suljettu',0),(19529,543,'no','Stengt',0),(19530,543,'da','Lukket',0),(19531,543,'ko','íì‡„',0),(19532,543,'he','×¡×’×•×¨',0),(19533,543,'el','ÎšÎ»ÎµÎ¹ÏƒÏ„Î¬',0),(19534,543,'zh','å…³é—­\r\n',0),(19535,543,'sv','StÃ¤ngt',0),(19536,543,'it','Chiuso',0),(19537,543,'tl','',0),(19538,543,'th','&#3611;&#3636;&#3604;&#3649;&#3621;&#3657;&#3623;',0),(19539,543,'hi','à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(19540,543,'ms','Ditutup',0),(19541,543,'ar','Ù…ØºÙ„Ù‚Ø©',0),(19542,543,'fr','FermÃ©',0),(19543,543,'jp','é–‰éŽ–',0),(19544,543,'pt','Fechado',0),(19545,543,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚',0),(19546,543,'es','Cerrado',0),(19547,543,'de','Geschlossen',0),(19548,543,'en','Closed',0),(19549,544,'is','',0),(19550,544,'dr','Ù¾ÙˆØ´Ø´ Ù…Ø§Ù„ÙŠØ§Øª  ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¨ÙŠÙ…Ù‡ Ù¾Ø²Ø´ÙƒÙŠ ',0),(19551,544,'pr','Ù¾ÙˆØ´Ø´ Ù…Ø§Ù„ÙŠØ§Øª  ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¨ÙŠÙ…Ù‡ Ù¾Ø²Ø´ÙƒÙŠ ',0),(19552,544,'tr','Co FICA vergi',0),(19553,544,'pl','Podatek co. FICA',0),(19554,544,'bg','ÐšÐ¾ FICA Ð´Ð°Ð½ÑŠÐº',0),(19555,544,'ur','Ú©Ù…Ù¾Ù†ÛŒ ÙØ§Ú©ÛŒ Ù¹ÛŒÚ©Ø³',0),(19556,544,'sr','Ð¦Ð¾ . ÐžÐ”Ð Ð•Ð¡ÐšÐ£ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(19557,544,'vi','Thuáº¿ Báº£o hiá»ƒm xÃ£ há»™i cá»§a cty',0),(19558,544,'af','Co FICA belasting',0),(19559,544,'ro','Co FICA fiscale',0),(19560,544,'et','Co. FICA maksu',0),(19561,544,'si','Co. FICA davÄne',0),(19562,544,'ba','Co FICA pajak',0),(19563,544,'nl','Co. FICA belasting',0),(19564,544,'fi','Co FICA vero',0),(19565,544,'no','Co FICA skatt',0),(19566,544,'da','Co FICA skat',0),(19567,544,'ko','ìœ í•œ FICA ì„¸ê¸ˆ',0),(19568,544,'he','×ž×¡ ×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™ ×•×©×•×ª\'',0),(19569,544,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Î£Î¥ÎœÎ’ÎŸÎ¥Î›Î‰ Co.',0),(19570,544,'zh','ç¤¾ä¼šä¿é™©ç¨Žæœ‰é™å…¬å¸\r\n',0),(19571,544,'sv','Co FICA skatt',0),(19572,544,'it','Tassa di FICA Co.',0),(19573,544,'tl','',0),(19574,544,'th','Co. FICA Tax',0),(19575,544,'hi','à¤•à¤‚ FICA à¤Ÿà¥ˆà¤•à¥à¤¸',0),(19576,544,'ms','Co. FICA cukai',0),(19577,544,'ar','Ø´Ø±ÙƒØ© Ù…Ø­ÙƒÙ…ÙŠ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(19578,544,'fr','L\'impÃ´t de FICA Co.',0),(19579,544,'jp','æ³•äººé€£é‚¦ä¿?é™ºå¯„ä¸Žæ³•ç¨Ž',0),(19580,544,'pt','Imposto FICA co.',0),(19581,544,'ru','Co. Ð¡Ð¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(19582,544,'es','Cubrir Impuesto FICA',0),(19583,544,'de','Co. FICA Steuern',0),(19584,544,'en','Co. FICA Tax',0),(19585,545,'is','',0),(19586,545,'dr','FUI Ù…Ø§Ù„ÙŠØ§Øª',0),(19587,545,'pr','Ø´Ø±ÙƒØª FUI Ù…Ø§Ù„ÙŠØ§Øª',0),(19588,545,'tr','Co FUI vergi',0),(19589,545,'pl','Co. FUI podatku',0),(19590,545,'bg','ÐšÐ¾ FUI Ð´Ð°Ð½ÑŠÐº',0),(19591,545,'ur','Ú©Ù…Ù¾Ù†ÛŒ ÙØ§ Ù¹ÛŒÚ©Ø³',0),(19592,545,'sr','Ð¦Ð¾ . ÑÐ¸Ñ‚Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(19593,545,'vi','Thuáº¿ FUI Cty',0),(19594,545,'af','Co FUI belasting',0),(19595,545,'ro','Co FUI fiscale',0),(19596,545,'et','Co FUI maksu',0),(19597,545,'si','Co. FUI davka',0),(19598,545,'ba','FUI Co pajak',0),(19599,545,'nl','Co. FUI belasting',0),(19600,545,'fi','Co FUI vero',0),(19601,545,'no','Co FUI skatt',0),(19602,545,'da','Co FUI skat',0),(19603,545,'ko','ìœ í•œ FUI ì„¸ê¸ˆ',0),(19604,545,'he','×ž×¡ FUI ×•×©×•×ª\'',0),(19605,545,'el','Co. FUI Ï†ÏŒÏÎ¿Ï…',0),(19606,545,'zh','å…¬å¸å¥Žç¨Ž\r\n',0),(19607,545,'sv','Co FUI skatt',0),(19608,545,'it','Fiscale FUI Co.',0),(19609,545,'tl','',0),(19610,545,'th','Co. FUI Tax',0),(19611,545,'hi','à¤•à¤‚ FUI à¤Ÿà¥ˆà¤•à¥à¤¸',0),(19612,545,'ms','Cukai Co. FUI',0),(19613,545,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ ÙÙŠ Ø´Ø±ÙƒØ©',0),(19614,545,'fr','ImpÃ´t FUI Co.',0),(19615,545,'jp','æ³•äººï¼¦ï¼µï¼©ç¨Ž',0),(19616,545,'pt','FUI co. imposto',0),(19617,545,'ru','Co. FUI Ð½Ð°Ð»Ð¾Ð³',0),(19618,545,'es','Cubrir Impuesto FUI',0),(19619,545,'de','Co. FUI Steuer',0),(19620,545,'en','Co. FUI Tax',0),(19621,546,'is','',0),(19622,546,'dr','(Ø´Ø±ÙƒØª) Ù…Ø±Ø§Ù‚Ø¨Øª Ø¯Ø§Ú©ØªØ±ÛŒ',0),(19623,546,'pr','Ù¾ÙˆØ´Ø´ (Ø´Ø±ÙƒØª) Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰',0),(19624,546,'tr','Co Medicare',0),(19625,546,'pl','Co. Medicare',0),(19626,546,'bg','ÐšÐ¾ Medicare',0),(19627,546,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ù…ÛŒÚˆÛŒ',0),(19628,546,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ñ†Ð¾.',0),(19629,546,'vi','Dá»‹ch vá»¥ y táº¿ Cty',0),(19630,546,'af','Co Medicare',0),(19631,546,'ro','Medicare co',0),(19632,546,'et','Co Medicare',0),(19633,546,'si','Co. Medicare',0),(19634,546,'ba','Medicare Co',0),(19635,546,'nl','Co. Medicare',0),(19636,546,'fi','Co Medicare',0),(19637,546,'no','Co Medicare',0),(19638,546,'da','Co Medicare',0),(19639,546,'ko','ìœ í•œ ë©”ë””ì¼€ì–´',0),(19640,546,'he','Medicare ×•×©×•×ª\'',0),(19641,546,'el','Co. Medicare',0),(19642,546,'zh','å…¬å¸åŒ»ç–—ä¿é™©\r\n',0),(19643,546,'sv','Co Medicare',0),(19644,546,'it','Medicare Co.',0),(19645,546,'tl','',0),(19646,546,'th','Co. Medicare',0),(19647,546,'hi','à¤•à¤‚ à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤°',0),(19648,546,'ms','Co. Medicare',0),(19649,546,'ar','Ø´Ø±ÙƒØ© Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(19650,546,'fr','Assurance-maladie de co.',0),(19651,546,'jp','æ³•äººåŒ»ç™‚ä¿?é™º',0),(19652,546,'pt','Medicare co.',0),(19653,546,'ru','Co. Medicare',0),(19654,546,'es','Cubrir Medicare',0),(19655,546,'de','Co. Medicare',0),(19656,546,'en','Co. Medicare',0),(19657,547,'is','',0),(19658,547,'dr','SUI Ù…Ø§Ù„ÙŠØ§Øª',0),(19659,547,'pr','Ø´Ø±ÙƒØª SUI Ù…Ø§Ù„ÙŠØ§Øª',0),(19660,547,'tr','Co SUI vergi',0),(19661,547,'pl','Co. SUI podatku',0),(19662,547,'bg','ÐšÐ¾ SUI Ð´Ð°Ð½ÑŠÐº',0),(19663,547,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ø³ÙˆØ¦ÛŒ Ù¹ÛŒÚ©Ø³',0),(19664,547,'sr','Ð¦Ð¾ . Ð¡Ð£Ð˜ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(19665,547,'vi','Thuáº¿ SUI cty',0),(19666,547,'af','Co SUI belasting',0),(19667,547,'ro','Co SUI fiscale',0),(19668,547,'et','Co SUI maksu',0),(19669,547,'si','Co. SUI davka',0),(19670,547,'ba','Pajak SUI Co',0),(19671,547,'nl','Co. SUI belasting',0),(19672,547,'fi','Co SUI vero',0),(19673,547,'no','Co SUI skatt',0),(19674,547,'da','Co SUI skat',0),(19675,547,'ko','ìœ í•œ ìˆ˜ì´ ì„¸',0),(19676,547,'he','×•×©×•×ª\' ×œ×¡×•×™ ×ž×¡',0),(19677,547,'el','Co. SUI Ï†ÏŒÏÎ¿Ï…',0),(19678,547,'zh','å…¬å¸SUIç¨Ž\r\n',0),(19679,547,'sv','Co SUI skatt',0),(19680,547,'it','Tassa SUI Co.',0),(19681,547,'tl','',0),(19682,547,'th','Co. SUI Tax',0),(19683,547,'hi','à¤•à¤‚ à¤¸à¥à¤‡ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(19684,547,'ms','Cukai Co. SUI',0),(19685,547,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø³ÙˆÙ‰ Ø´Ø±ÙƒØ©',0),(19686,547,'fr','ImpÃ´t SUI Co.',0),(19687,547,'jp','æ³•äººï¼³ï¼µï¼©ç¨Ž',0),(19688,547,'pt','Imposto SUI co.',0),(19689,547,'ru','Ð¡ÑƒÐ¹ Co. Ð½Ð°Ð»Ð¾Ð³',0),(19690,547,'es','Cubrir Impuesto SUI',0),(19691,547,'de','Co. SUI Steuer',0),(19692,547,'en','Co. SUI Tax',0),(19693,548,'is','',0),(19694,548,'dr','ÙƒØ¯',0),(19695,548,'pr','ÙƒØ¯',0),(19696,548,'tr','Kodu',0),(19697,548,'pl','Kod',0),(19698,548,'bg','ÐšÐ¾Ð´',0),(19699,548,'ur','Ø¶Ø§Ø¨Ø·Û',0),(19700,548,'sr','Ð¨Ð¸Ñ„Ñ€Ð°',0),(19701,548,'vi','MÃ£',0),(19702,548,'af','Kode',0),(19703,548,'ro','Cod',0),(19704,548,'et','Kood',0),(19705,548,'si','Zbornik',0),(19706,548,'ba','Kode',0),(19707,548,'nl','Code',0),(19708,548,'fi','Koodi',0),(19709,548,'no','Kode',0),(19710,548,'da','Kode',0),(19711,548,'ko','ì½”ë“œ',0),(19712,548,'he','×§×•×“',0),(19713,548,'el','ÎšÏŽÎ´Î¹ÎºÎ±',0),(19714,548,'zh','ç \r\n',0),(19715,548,'sv','Koden',0),(19716,548,'it','Codice',0),(19717,548,'tl','',0),(19718,548,'th','&#3619;&#3627;&#3633;&#3626;',0),(19719,548,'hi','à¤•à¥‹à¤¡',0),(19720,548,'ms','Kod',0),(19721,548,'ar','Ø§Ù„Ø±Ù…Ø²',0),(19722,548,'fr','Code',0),(19723,548,'jp','ã‚³ãƒ¼ãƒ‰',0),(19724,548,'pt','CÃ³digo',0),(19725,548,'ru','ÐšÐ¾Ð´',0),(19726,548,'es','CÃ³digo',0),(19727,548,'de','Code',0),(19728,548,'en','Code',0),(19729,549,'is','',0),(19730,549,'dr','.',0),(19731,549,'pr','Ø«Ø¨Øª Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´.',0),(19732,549,'tr','SMM girin',0),(19733,549,'pl','WprowadÅº KWS',0),(19734,549,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐŸÐ Ð•Ð”Ð¡ÐšÐÐ—ÐÐ¢Ð•Ð›Ð˜Ð¢Ð•',0),(19735,549,'ur','Ú©Ø§ÙˆÚ¯Ø³ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(19736,549,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¢ÐŸÐ ',0),(19737,549,'vi','Nháº­p giÃ¡ thÃ nh hÃ ng bÃ¡n',0),(19738,549,'af','Tik RATTE',0),(19739,549,'ro','IntroduceÅ£i COGS',0),(19740,549,'et','Sisesta OMAHIND',0),(19741,549,'si','Vnesite porabe',0),(19742,549,'ba','Masukkan roda',0),(19743,549,'nl','Voer KPV',0),(19744,549,'fi','Kirjoita hampaat',0),(19745,549,'no','Angi COGS',0),(19746,549,'da','Angiv tandhjul',0),(19747,549,'ko','í†±ë‹ˆë¥¼ ìž…ë ¥',0),(19748,549,'he','×”×–×Ÿ ×ª×•×¨×™×›×ž ×ª×•×œ×¢',0),(19749,549,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ Ï€Ï‰Î»Î·Î¸Î­Î½Ï„Ï‰Î½',0),(19750,549,'zh','è¾“å…¥é”€å”®æˆæœ¬\r\n',0),(19751,549,'sv','Ange kuggar',0),(19752,549,'it','Immettere COGS',0),(19753,549,'tl','',0),(19754,549,'th','&#3611;&#3657;&#3629;&#3609;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3634;&#3618;',0),(19755,549,'hi','COGS à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(19756,549,'ms','Masukkan salah satu alat',0),(19757,549,'ar','Ø¥Ø¯Ø®Ø§Ù„ ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(19758,549,'fr','Entrez les COGS',0),(19759,549,'jp','COGSã?®å…¥åŠ›',0),(19760,549,'pt','Digite COGS',0),(19761,549,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð—Ð£Ð‘Ð¬Ð¯',0),(19762,549,'es','Ingresar Costo de Ventas',0),(19763,549,'de','Geben Sie COGS',0),(19764,549,'en','Enter COGS',0),(19765,550,'is','',0),(19766,550,'dr','Ø±Ù†Ú¯ ',0),(19767,550,'pr','Ø±Ù†Ú¯ ',0),(19768,550,'tr','Renk',0),(19769,550,'pl','Kolor',0),(19770,550,'bg','Ð¦Ð²ÑÑ‚',0),(19771,550,'ur','Ø±Ù†Ú¯',0),(19772,550,'sr','Ð‘Ð¾Ñ˜Ð°',0),(19773,550,'vi','Máº§u',0),(19774,550,'af','Kleur',0),(19775,550,'ro','Culoare',0),(19776,550,'et','VÃ¤rv',0),(19777,550,'si','Barva',0),(19778,550,'ba','Warna',0),(19779,550,'nl','Kleur',0),(19780,550,'fi','VÃ¤ri',0),(19781,550,'no','Farge',0),(19782,550,'da','Farve',0),(19783,550,'ko','ìƒ‰',0),(19784,550,'he','×¦×‘×¢',0),(19785,550,'el','Î§ÏÏŽÎ¼Î±',0),(19786,550,'zh','é¢œè‰²\r\n',0),(19787,550,'sv','FÃ¤rg',0),(19788,550,'it','Colore',0),(19789,550,'tl','',0),(19790,550,'th','&#3626;&#3637;',0),(19791,550,'hi','à¤°à¤‚à¤—',0),(19792,550,'ms','Warna',0),(19793,550,'ar','Ø§Ù„Ù„ÙˆÙ†',0),(19794,550,'fr','Couleur',0),(19795,550,'jp','è‰²',0),(19796,550,'pt','Cor',0),(19797,550,'ru','Ð¦Ð²ÐµÑ‚',0),(19798,550,'es','Color',0),(19799,550,'de','Farbe',0),(19800,550,'en','Color',0),(19801,551,'is','',0),(19802,551,'dr','Ø¢Ø¨ÙŠ',0),(19803,551,'pr','Ø¢Ø¨ÙŠ',0),(19804,551,'tr','Mavi',0),(19805,551,'pl','Niebieski',0),(19806,551,'bg','Ð¡Ð¸Ð½',0),(19807,551,'ur','Ø¨Ù„ÛŒÙˆ',0),(19808,551,'sr','ÐŸÐ»Ð°Ð²Ð¸',0),(19809,551,'vi','Xanh',0),(19810,551,'af','Blou',0),(19811,551,'ro','Albastru',0),(19812,551,'et','Sinine',0),(19813,551,'si','Modra',0),(19814,551,'ba','Biru',0),(19815,551,'nl','Blauw',0),(19816,551,'fi','Sininen',0),(19817,551,'no','BlÃ¥',0),(19818,551,'da','BlÃ¥',0),(19819,551,'ko','ë¸”ë£¨',0),(19820,551,'he','×›×—×•×œ',0),(19821,551,'el','ÎœÏ€Î»Îµ',0),(19822,551,'zh','è“\r\n',0),(19823,551,'sv','BlÃ¥',0),(19824,551,'it','Blu',0),(19825,551,'tl','',0),(19826,551,'th','&#3626;&#3637;&#3615;&#3657;&#3634;',0),(19827,551,'hi','à¤¬à¥à¤²à¥‚',0),(19828,551,'ms','Biru',0),(19829,551,'ar','Ø£Ø²Ø±Ù‚',0),(19830,551,'fr','Bleu',0),(19831,551,'jp','é?’',0),(19832,551,'pt','Azul',0),(19833,551,'ru','Ð¡Ð¸Ð½Ð¸Ð¹',0),(19834,551,'es','Azul',0),(19835,551,'de','Blau',0),(19836,551,'en','Blue',0),(19837,552,'is','',0),(19838,552,'dr','Ù‚Ù‡ÙˆÙ‡ Ø§ÙŠ',0),(19839,552,'pr','Ù‚Ù‡ÙˆÙ‡ Ø§ÙŠ',0),(19840,552,'tr','Brown',0),(19841,552,'pl','Brown',0),(19842,552,'bg','Ð‘Ñ€Ð°ÑƒÐ½',0),(19843,552,'ur','Ø¨Ø±Ø§Ø¤Ù†',0),(19844,552,'sr','Ð‘Ñ€Ð¾wÐ½',0),(19845,552,'vi','NÃ¢u',0),(19846,552,'af','Bruin',0),(19847,552,'ro','Brown',0),(19848,552,'et','Brown',0),(19849,552,'si','Brown',0),(19850,552,'ba','Brown',0),(19851,552,'nl','Brown',0),(19852,552,'fi','Brown',0),(19853,552,'no','Brown',0),(19854,552,'da','Brown',0),(19855,552,'ko','ë¸Œë¼ìš´',0),(19856,552,'he','×‘×¨××•×Ÿ',0),(19857,552,'el','ÎšÎ±Ï†Î­',0),(19858,552,'zh','æ£•\r\n',0),(19859,552,'sv','Brown',0),(19860,552,'it','Brown',0),(19861,552,'tl','',0),(19862,552,'th','&#3626;&#3637;&#3609;&#3657;&#3635;&#3605;&#3634;&#3621;',0),(19863,552,'hi','à¤¬à¥à¤°à¤¾à¤‰à¤¨',0),(19864,552,'ms','Brown',0),(19865,552,'ar','Ø¨Ù†Ù‘ÙŠ',0),(19866,552,'fr','Brown',0),(19867,552,'jp','èŒ¶',0),(19868,552,'pt','Brown',0),(19869,552,'ru','ÐšÐ¾Ñ€Ð¸Ñ‡Ð½ÐµÐ²Ñ‹Ð¹',0),(19870,552,'es','CafÃ©',0),(19871,552,'de','Brown',0),(19872,552,'en','Brown',0),(19873,553,'is','',0),(19874,553,'dr','ÙƒØ±Ù… ',0),(19875,553,'pr','ÙƒØ±Ù… ',0),(19876,553,'tr','Krem',0),(19877,553,'pl','Creme',0),(19878,553,'bg','ÐšÑ€ÐµÐ¼',0),(19879,553,'ur','Ú©Ø±ÛŒÙ…',0),(19880,553,'sr','ÐšÑ€ÐµÐ¼Ð°',0),(19881,553,'vi','Máº§u kem',0),(19882,553,'af','Room',0),(19883,553,'ro','Crema',0),(19884,553,'et','Creme',0),(19885,553,'si','Krem',0),(19886,553,'ba','Creme',0),(19887,553,'nl','Creme',0),(19888,553,'fi','Creme',0),(19889,553,'no','Creme',0),(19890,553,'da','Creme',0),(19891,553,'ko','í¬ë¦¼',0),(19892,553,'he','×§×¨×',0),(19893,553,'el','Creme',0),(19894,553,'zh','å¥¶æ²¹ç™½\r\n',0),(19895,553,'sv','Creme',0),(19896,553,'it','Creme',0),(19897,553,'tl','',0),(19898,553,'th','&#3626;&#3637;&#3588;&#3619;&#3637;&#3617;',0),(19899,553,'hi','Creme',0),(19900,553,'ms','Creme',0),(19901,553,'ar','ÙƒØ±ÙŠÙ…',0),(19902,553,'fr','CREME',0),(19903,553,'jp','ã‚¯ãƒªãƒ¼ãƒ ',0),(19904,553,'pt','Creme',0),(19905,553,'ru','ÐšÑ€ÐµÐ¼Ð¾Ð²Ñ‹Ð¹',0),(19906,553,'es','Crema',0),(19907,553,'de','Creme',0),(19908,553,'en','Creme',0),(19909,554,'is','',0),(19910,554,'dr','Ø®Ø§ÙƒØ³ØªØ±ÙŠ',0),(19911,554,'pr','Ø®Ø§ÙƒØ³ØªØ±ÙŠ',0),(19912,554,'tr','Gri',0),(19913,554,'pl','Szary',0),(19914,554,'bg','Ð“Ñ€ÐµÐ¹',0),(19915,554,'ur','Ø®Ø§Ú©Ø³ØªØ±ÛŒ',0),(19916,554,'sr','Ð“Ñ€Ð°y',0),(19917,554,'vi','XÃ¡m',0),(19918,554,'af','Grys',0),(19919,554,'ro','Gri',0),(19920,554,'et','Gray',0),(19921,554,'si','Siva',0),(19922,554,'ba','Abu-abu',0),(19923,554,'nl','Gray',0),(19924,554,'fi','Harmaa',0),(19925,554,'no','GrÃ¥',0),(19926,554,'da','GrÃ¥',0),(19927,554,'ko','íšŒìƒ‰',0),(19928,554,'he','××¤×•×¨',0),(19929,554,'el','Î“ÎºÏÎ¹',0),(19930,554,'zh','ç°è‰²\r\n',0),(19931,554,'sv','GrÃ¥',0),(19932,554,'it','Gray',0),(19933,554,'tl','',0),(19934,554,'th','&#3626;&#3637;&#3648;&#3607;&#3634;',0),(19935,554,'hi','à¤—à¥à¤°à¥‡',0),(19936,554,'ms','Kelabu',0),(19937,554,'ar','Ø±Ù…Ø§Ø¯ÙŠ',0),(19938,554,'fr','Gray',0),(19939,554,'jp','ã‚°ãƒ¬ãƒ¼',0),(19940,554,'pt','Gray',0),(19941,554,'ru','Ð¡ÐµÑ€Ñ‹Ð¹',0),(19942,554,'es','Gris',0),(19943,554,'de','Gray',0),(19944,554,'en','Gray',0),(19945,555,'is','',0),(19946,555,'dr','Ø³Ø¨Ø²',0),(19947,555,'pr','Ø³Ø¨Ø²',0),(19948,555,'tr','YeÅŸil',0),(19949,555,'pl','Zielony',0),(19950,555,'bg','Ð“Ñ€Ð¸Ð¹Ð½',0),(19951,555,'ur','Ø³Ø¨Ø²',0),(19952,555,'sr','Ð—ÐµÐ»ÐµÐ½Ð¸',0),(19953,555,'vi','Xanh lÃ¡',0),(19954,555,'af','Groen',0),(19955,555,'ro','Verde',0),(19956,555,'et','Roheline',0),(19957,555,'si','Zelena',0),(19958,555,'ba','Hijau',0),(19959,555,'nl','Green',0),(19960,555,'fi','VihreÃ¤',0),(19961,555,'no','GrÃ¸nn',0),(19962,555,'da','GrÃ¸n',0),(19963,555,'ko','ê·¸ë¦°',0),(19964,555,'he','×’×¨×™×Ÿ',0),(19965,555,'el','Î ÏÎ¬ÏƒÎ¹Î½Î¿',0),(19966,555,'zh','ç»¿\r\n',0),(19967,555,'sv','GrÃ¶n',0),(19968,555,'it','Verde',0),(19969,555,'tl','',0),(19970,555,'th','&#3626;&#3637;&#3648;&#3586;&#3637;&#3618;&#3623;',0),(19971,555,'hi','à¤—à¥à¤°à¥€à¤¨',0),(19972,555,'ms','Hijau',0),(19973,555,'ar','Ø£Ø®Ø¶Ø±',0),(19974,555,'fr','Vert',0),(19975,555,'jp','ç·‘',0),(19976,555,'pt','Verde',0),(19977,555,'ru','Ð—ÐµÐ»ÐµÐ½Ñ‹Ð¹',0),(19978,555,'es','Verde',0),(19979,555,'de','Green',0),(19980,555,'en','Green',0),(19981,556,'is','',0),(19982,556,'dr',' Ù†Ø§Ø±Ù†Ø¬ÙŠ \r\n \r\n',0),(19983,556,'pr',' Ù†Ø§Ø±Ù†Ø¬ÙŠ \r\n \r\n',0),(19984,556,'tr','Turuncu',0),(19985,556,'pl','Orange',0),(19986,556,'bg','ÐžÑ€Ð¸Ð½Ð´Ð¶',0),(19987,556,'ur','Ù†Ø§Ø±Ù†Ú¯ÛŒ',0),(19988,556,'sr','ÐžÑ€Ð°Ð½Ð³Ðµ',0),(19989,556,'vi','Cam',0),(19990,556,'af','Oranje',0),(19991,556,'ro','Orange',0),(19992,556,'et','Orange',0),(19993,556,'si','Orange',0),(19994,556,'ba','Orange',0),(19995,556,'nl','Orange',0),(19996,556,'fi','Oranssi',0),(19997,556,'no','Oransje',0),(19998,556,'da','Orange',0),(19999,556,'ko','ì˜¤ë Œì§€',0),(20000,556,'he','×›×ª×•×',0),(20001,556,'el','Î Î¿ÏÏ„Î¿ÎºÎ±Î»Î¯',0),(20002,556,'zh','æ©™\r\n',0),(20003,556,'sv','Orange',0),(20004,556,'it','Orange',0),(20005,556,'tl','',0),(20006,556,'th','&#3626;&#3637;&#3626;&#3657;&#3617;',0),(20007,556,'hi','à¤‘à¤°à¥‡à¤‚à¤œ',0),(20008,556,'ms','Orange',0),(20009,556,'ar','Ø¨Ø±ØªÙ‚Ø§Ù„ÙŠ',0),(20010,556,'fr','Orange',0),(20011,556,'jp','ã‚ªãƒ¬ãƒ³ã‚¸',0),(20012,556,'pt','Laranja',0),(20013,556,'ru','ÐžÑ€Ð°Ð½Ð¶ÐµÐ²Ñ‹Ð¹',0),(20014,556,'es','Naranja',0),(20015,556,'de','Orange',0),(20016,556,'en','Orange',0),(20017,557,'is','',0),(20018,557,'dr','ØµÙˆØ±ØªÙŠ',0),(20019,557,'pr','ØµÙˆØ±ØªÙŠ',0),(20020,557,'tr','Pembe',0),(20021,557,'pl','RÃ³Å¼owy',0),(20022,557,'bg','Ð Ð¾Ð·Ð¾Ð²Ð¾',0),(20023,557,'ur','Ú¯Ù„Ø§Ø¨ÛŒ',0),(20024,557,'sr','Ð Ð¾Ð·Ðµ',0),(20025,557,'vi','Há»“ng',0),(20026,557,'af','Pienk',0),(20027,557,'ro','Roz',0),(20028,557,'et','Roosa',0),(20029,557,'si','Roza',0),(20030,557,'ba','Pink',0),(20031,557,'nl','Roze',0),(20032,557,'fi','Vaaleanpunainen',0),(20033,557,'no','Rosa',0),(20034,557,'da','Pink',0),(20035,557,'ko','í•‘í¬',0),(20036,557,'he','×•×¨×•×“',0),(20037,557,'el','Î¡Î¿Î¶',0),(20038,557,'zh','ç²‰çº¢è‰²\r\n',0),(20039,557,'sv','Rosa',0),(20040,557,'it','Rosa',0),(20041,557,'tl','',0),(20042,557,'th','&#3626;&#3637;&#3594;&#3617;&#3614;&#3641;',0),(20043,557,'hi','à¤—à¥à¤²à¤¾à¤¬à¥€',0),(20044,557,'ms','Pink',0),(20045,557,'ar','ÙˆØ±Ø¯ÙŠ',0),(20046,557,'fr','Rose',0),(20047,557,'jp','ãƒ”ãƒ³ã‚¯',0),(20048,557,'pt','Rosa',0),(20049,557,'ru','Ð Ð¾Ð·Ð¾Ð²Ñ‹Ð¹',0),(20050,557,'es','Rosa',0),(20051,557,'de','Rosa',0),(20052,557,'en','Pink',0),(20053,558,'is','',0),(20054,558,'dr','Ø¨Ù†ÙØ´',0),(20055,558,'pr','Ø¨Ù†ÙØ´',0),(20056,558,'tr','Mor',0),(20057,558,'pl','Fioletowy',0),(20058,558,'bg','Ð›Ð¸Ð»Ð°Ð²Ð¾',0),(20059,558,'ur','Ø¬Ø§Ù…Ù†ÛŒ',0),(20060,558,'sr','ÐŸÑƒÑ€Ð¿ÑƒÑ€Ð½Ð¸',0),(20061,558,'vi','TÃ­m',0),(20062,558,'af','Pers',0),(20063,558,'ro','Violet',0),(20064,558,'et','Lilla',0),(20065,558,'si','VijoliÄna',0),(20066,558,'ba','Ungu',0),(20067,558,'nl','Paars',0),(20068,558,'fi','Violetti',0),(20069,558,'no','Lilla',0),(20070,558,'da','Lilla',0),(20071,558,'ko','ë³´ë¼ìƒ‰',0),(20072,558,'he','×¡×’×•×œ',0),(20073,558,'el','ÎœÏ‰Î²',0),(20074,558,'zh','ç´«\r\n',0),(20075,558,'sv','Lila',0),(20076,558,'it','Viola',0),(20077,558,'tl','',0),(20078,558,'th','&#3626;&#3637;&#3617;&#3656;&#3623;&#3591;',0),(20079,558,'hi','à¤¬à¥ˆà¤‚à¤—à¤¨à¥€',0),(20080,558,'ms','Ungu',0),(20081,558,'ar','Ø¨Ù†ÙØ³Ø¬ÙŠ',0),(20082,558,'fr','Purple',0),(20083,558,'jp','ç´«',0),(20084,558,'pt','Roxo',0),(20085,558,'ru','Ð¤Ð¸Ð¾Ð»ÐµÑ‚Ð¾Ð²Ñ‹Ð¹',0),(20086,558,'es','PÃºrpura',0),(20087,558,'de','Lila',0),(20088,558,'en','Purple',0),(20089,559,'is','',0),(20090,559,'dr','Ù‚Ø±Ù…Ø²',0),(20091,559,'pr','Ù‚Ø±Ù…Ø²',0),(20092,559,'tr','KÄ±rmÄ±zÄ±',0),(20093,559,'pl','Czerwony',0),(20094,559,'bg','Ð§ÐµÑ€Ð²ÐµÐ½',0),(20095,559,'ur','Ø³Ø±Ø®',0),(20096,559,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸',0),(20097,559,'vi','Äá»',0),(20098,559,'af','Rooi',0),(20099,559,'ro','Red',0),(20100,559,'et','Punane',0),(20101,559,'si','RdeÄa',0),(20102,559,'ba','Merah',0),(20103,559,'nl','Red',0),(20104,559,'fi','Punainen',0),(20105,559,'no','RÃ¸d',0),(20106,559,'da','RÃ¸d',0),(20107,559,'ko','ë ˆë“œ',0),(20108,559,'he','××“×•×',0),(20109,559,'el','ÎšÏŒÎºÎºÎ¹Î½Î¿',0),(20110,559,'zh','çº¢\r\n',0),(20111,559,'sv','RÃ¶d',0),(20112,559,'it','Rosso',0),(20113,559,'tl','',0),(20114,559,'th','&#3626;&#3637;&#3649;&#3604;&#3591;',0),(20115,559,'hi','à¤²à¤¾à¤²',0),(20116,559,'ms','Merah',0),(20117,559,'ar','Ø£Ø­Ù…Ø±',0),(20118,559,'fr','Rouge',0),(20119,559,'jp','èµ¤',0),(20120,559,'pt','Vermelho',0),(20121,559,'ru','ÐšÑ€Ð°ÑÐ½Ñ‹Ð¹',0),(20122,559,'es','Rojo',0),(20123,559,'de','Rot',0),(20124,559,'en','Red',0),(20125,560,'is','',0),(20126,560,'dr','Ø²Ø±Ø¯ ',0),(20127,560,'pr','Ø²Ø±Ø¯ ',0),(20128,560,'tr','SarÄ±',0),(20129,560,'pl','Å»Ã³Å‚ty',0),(20130,560,'bg','Ð–ÑŠÐ»Ñ‚',0),(20131,560,'ur','Ø²Ø±Ø¯',0),(20132,560,'sr','Ð–ÑƒÑ‚Ð°',0),(20133,560,'vi','VÃ ng',0),(20134,560,'af','Geel',0),(20135,560,'ro','Galben',0),(20136,560,'et','Kollane',0),(20137,560,'si','Rumena',0),(20138,560,'ba','Kuning',0),(20139,560,'nl','Geel',0),(20140,560,'fi','Keltainen',0),(20141,560,'no','Gul',0),(20142,560,'da','Gul',0),(20143,560,'ko','ë…¸ëž€ìƒ‰',0),(20144,560,'he','×¦×”×•×‘',0),(20145,560,'el','ÎšÎ¯Ï„ÏÎ¹Î½Î¿',0),(20146,560,'zh','é»„\r\n',0),(20147,560,'sv','Gul',0),(20148,560,'it','Giallo',0),(20149,560,'tl','',0),(20150,560,'th','&#3626;&#3637;&#3648;&#3627;&#3621;&#3639;&#3629;&#3591;',0),(20151,560,'hi','à¤ªà¥€à¤²à¤¾',0),(20152,560,'ms','Kuning',0),(20153,560,'ar','Ø£ØµÙØ±',0),(20154,560,'fr','Jaune',0),(20155,560,'jp','é»„è‰²',0),(20156,560,'pt','Amarelo',0),(20157,560,'ru','Ð–ÐµÐ»Ñ‚Ñ‹Ð¹',0),(20158,560,'es','Amarillo',0),(20159,560,'de','Gelb',0),(20160,560,'en','Yellow',0),(20161,561,'is','',0),(20162,561,'dr','Ø±Ù†Ú¯Ù‡Ø§',0),(20163,561,'pr','Ø±Ù†Ú¯Ù‡Ø§',0),(20164,561,'tr','Renkler',0),(20165,561,'pl','Kolory',0),(20166,561,'bg','Ð¦Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(20167,561,'ur','Ø±Ù†Ú¯',0),(20168,561,'sr','Ð‘Ð¾Ñ˜Ðµ',0),(20169,561,'vi','Máº§u',0),(20170,561,'af','Kleure',0),(20171,561,'ro','Culori',0),(20172,561,'et','VÃ¤rvid',0),(20173,561,'si','Barve',0),(20174,561,'ba','Warna',0),(20175,561,'nl','Kleuren',0),(20176,561,'fi','VÃ¤rit',0),(20177,561,'no','Farger',0),(20178,561,'da','Farver',0),(20179,561,'ko','ìƒ‰ìƒ',0),(20180,561,'he','×¦×‘×¢×™×',0),(20181,561,'el','Î§ÏÏŽÎ¼Î±Ï„Î±',0),(20182,561,'zh','é¢œè‰²\r\n',0),(20183,561,'sv','FÃ¤rger',0),(20184,561,'it','Colori',0),(20185,561,'tl','',0),(20186,561,'th','&#3626;&#3637;',0),(20187,561,'hi','à¤°à¤‚à¤—',0),(20188,561,'ms','Warna-warna',0),(20189,561,'ar','Ø§Ù„Ø£Ù„ÙˆØ§Ù†',0),(20190,561,'fr','Couleurs',0),(20191,561,'jp','è‰²',0),(20192,561,'pt','Cores',0),(20193,561,'ru','Ð¦Ð²ÐµÑ‚Ð°',0),(20194,561,'es','Colores',0),(20195,561,'de','Farben',0),(20196,561,'en','Colors',0),(20197,562,'is','',0),(20198,562,'dr','16/1  Ø§ÙŠÙ†Ú† Ù‡Ø³ØªÙ†Ø¯ ÙŠØ§  Ù„ÙˆÚ¯ÙˆÙŠ Ø±Ù†Ú¯   2',0),(20199,562,'pr','Ø±Ù†Ú¯Ù‡Ø§ Ø¯Ø± 16/1  Ø§ÙŠÙ†Ú† Ù‡Ø³ØªÙ†Ø¯ ÙŠØ§  Ù„ÙˆÚ¯ÙˆÙŠ Ø±Ù†Ú¯   2',0),(20200,562,'tr','1/16 inÃ§ veya 2-renkli logo renklerdir.',0),(20201,562,'pl','Kolory sÄ… w 1/16 cala lub 2-kolorowe logo.',0),(20202,562,'bg','Ð¦Ð²ÐµÑ‚Ð¾Ð²ÐµÑ‚Ðµ ÑÐ° Ð² Ñ€Ð°Ð¼ÐºÐ¸Ñ‚Ðµ Ð½Ð° 1/16 Ð¸Ð½Ñ‡Ð° Ð¸Ð»Ð¸ 2 Ñ†Ð²ÑÑ‚Ð° Ð»Ð¾Ð³Ð¾.',0),(20203,562,'ur','Ø±Ù†Ú¯ 1/16 Ø§Ù†Ú† ÛŒØ§ 2-Ø±Ù†Ú¯ Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ) Ú©Û’ Ø§Ù†Ø¯Ø± Ø§Ù†Ø¯Ø± ÛÛŒÚº.',0),(20204,562,'sr','Ð‘Ð¾Ñ˜Ðµ ÑÑƒ Ñƒ Ñ€Ð¾ÐºÑƒ Ð¾Ð´ 1/16 Ð¸Ð½Ñ‡Ð° Ð¸Ð»Ð¸ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿ 2-Ð±Ð¾Ñ˜Ð°.',0),(20205,562,'vi','Máº§u trong 1/16 inch hay logo 2 máº§u',0),(20206,562,'af','Kleure is binne 1/16de duim of 2-kleur logo.',0),(20207,562,'ro','Culorile sunt de la 1/16 inch sau 2 culori logo-ul.',0),(20208,562,'et','VÃ¤rvid on maksimaalselt 1/16 tollise vÃµi kahevÃ¤rviline logo.',0),(20209,562,'si','Barve so v 1/16 inch ali 2-barvni logotip.',0),(20210,562,'ba','Warna berada dalam jarak 1/16 inci atau 2-warna logo.',0),(20211,562,'nl','Kleuren zijn binnen 1/16 inch of 2-kleurenlogo.',0),(20212,562,'fi','VÃ¤rit ovat 1/16th tuuma tai 2-vÃ¤ri logo.',0),(20213,562,'no','Fargene er 1/16 tomme eller to farger logo.',0),(20214,562,'da','Farver er i 1/16 tommer eller 2-farvede logo.',0),(20215,562,'ko','ìƒ‰ìƒì€ 1/16 ì¸ì¹˜ ë˜ëŠ” 2 ìƒ‰ ë¡œê³ .',0),(20216,562,'he','×”×¦×‘×¢×™× ×”× ×‘×ª×•×š 1/16 ×¡ ×ž ××• 2-×¦×‘×¢ ×œ×•×’×•.',0),(20217,562,'el','Î¤Î± Ï‡ÏÏŽÎ¼Î±Ï„Î± ÎµÎ¯Î½Î±Î¹ ÏƒÏ„Î¿ 1/16 Î¹Î½Ï„ÏƒÏŽÎ½ Î® 2-Ï‡ÏÏŽÎ¼Î± Î»Î¿Î³ÏŒÏ„Ï…Ï€Î¿.',0),(20218,562,'zh','é¢œè‰²æ˜¯åœ¨1/16å¯¸ä»¥å†…æˆ–2è‰²æ ‡è¯†',0),(20219,562,'sv','FÃ¤rgerna Ã¤r inom 1/16 tum eller 2-fÃ¤rg logotyp.',0),(20220,562,'it','I colori sono all\'interno di 2 colori logo o 1/16 di pollice.',0),(20221,562,'tl','',0),(20222,562,'th','&#3626;&#3637;&#3586;&#3629;&#3591;&#3626;&#3633;&#3597;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609; 1/16 &#3609;&#3636;&#3657;&#3623;&#3627;&#3619;&#3639;&#3629; 2 &#3626;&#3637;',0),(20223,562,'hi','à¤°à¤‚à¤— 1/16th à¤‡à¤‚à¤š à¤¯à¤¾ 2-à¤°à¤‚à¤— à¤²à¥‹à¤—à¥‹ à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(20224,562,'ms','Warna-warna yang berada dalam jarak 1/16 inci atau 2-warna logo.',0),(20225,562,'ar','Ø§Ù„Ø£Ù„ÙˆØ§Ù† Ø­Ø¯ÙˆØ¯ 1/16 Ø¨ÙˆØµØ© Ø£Ùˆ 2-Ù„ÙˆÙ† Ø§Ù„Ø´Ø¹Ø§Ø±.',0),(20226,562,'fr','Les couleurs sont au 1/16e de pouce ou d\'un logo 2 couleurs.',0),(20227,562,'jp','è‰²ã?¯16åˆ†ã?®1ã‚¤ãƒ³ãƒ?ä»¥å†…ã?‹2è‰²ã?®ãƒ­ã‚´ã?§ã?™',0),(20228,562,'pt','As cores estÃ£o dentro de 1/16 de polegada ou logotipo de 2 cores.',0),(20229,562,'ru','Ð¦Ð²ÐµÑ‚Ð° Ð½Ð°Ñ…Ð¾Ð´ÑÑ‚ÑÑ Ð² Ð¿Ñ€ÐµÐ´ÐµÐ»Ð°Ñ… 1/16 Ð´ÑŽÐ¹Ð¼Ð° Ð¸Ð»Ð¸ 2-Ñ†Ð²ÐµÑ‚Ð½Ð¾Ð¹ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿.',0),(20230,562,'es','Colores estan dentro de 1/16 de pulgada o 2-color logo',0),(20231,562,'de','Farben sind in 1/16 Zoll oder 2-farbiges Logo.',0),(20232,562,'en','Colors are within 1/16th inch or 2-color logo.',0),(20233,563,'is','',0),(20234,563,'dr','-Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ù†Ù‡Ø§ÙŠÙŠ',0),(20235,563,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙƒØ§Ù…Ù¾ÙŠÙˆØªØ±ÙŠ-Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ù†Ù‡Ø§ÙŠÙŠ',0),(20236,563,'tr','Final<br>SatÄ±lÄ±k Amt',0),(20237,563,'pl','KoÅ„cowe<br>Amt sprzedaÅ¼',0),(20238,563,'bg','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÐµÐ½<br>ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð° Amt',0),(20239,563,'ur','Ø¢Ø®Ø±ÛŒ<br>ÙØ±ÙˆØ®Øª Ø§Ù…Ù¹',0),(20240,563,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð°<br>ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° Ð Ð•Ð¤. Ð’Ð°Ð».',0),(20241,563,'vi','Doanh sá»‘cuá»‘i',0),(20242,563,'af','Finale<br>Verkoop Amt',0),(20243,563,'ro','FinalÄƒ<br>VÃ¢nzare Amt',0),(20244,563,'et','LÃµplik<br>MÃ¼Ã¼k Amt',0),(20245,563,'si','KonÄni<br>Prodajo Amt',0),(20246,563,'ba','Akhir<br>Dijual Amt',0),(20247,563,'nl','Laatste<br>Verkoop Amt',0),(20248,563,'fi','Lopullinen<br>MyytÃ¤vÃ¤nÃ¤ Amt',0),(20249,563,'no','Siste<br>Salg Amt',0),(20250,563,'da','Endelige<br>Salg Amt',0),(20251,563,'ko','ìµœì¢…<br>íŒë§¤ Amt',0),(20252,563,'he','×¡×•×¤×™<br>×œ×ž×›×™×¨×” Amt',0),(20253,563,'el','Î¤ÎµÎ»Î¹ÎºÎ®<br>Î ÏŽÎ»Î·ÏƒÎ· Amt',0),(20254,563,'zh','æœ€åŽçš„é”€å”®é‡‘é¢\r\n',0),(20255,563,'sv','Sista<br>FÃ¶rsÃ¤ljning Amt',0),(20256,563,'it','Finale<br>Vendita Amt',0),(20257,563,'tl','',0),(20258,563,'th','&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;<br>&#3592;&#3635;&#3609;&#3623;&#3609;&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;',0),(20259,563,'hi','à¤…à¤‚à¤¤à¤¿à¤®<br>à¤¬à¤¿à¤•à¥à¤°à¥€ Amt',0),(20260,563,'ms','Akhir<br>Amt jualan',0),(20261,563,'ar','Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ<br>Ø¨ÙŠØ¹ Ø§Ù„ØªÙˆÙ†Ø³ÙŠÙŠÙ†',0),(20262,563,'fr','Finale<br>Vente Amt',0),(20263,563,'jp','æœ€çµ‚<br>å£²ä¸Šé«˜',0),(20264,563,'pt','Final<br>Venda Amt',0),(20265,563,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹<br>ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° Amt',0),(20266,563,'es','Final<br>Monto de Venta',0),(20267,563,'de','Final<br>Verkauf-Amt',0),(20268,563,'en','Final<br>Sale Amt',0),(20269,564,'is','',0),(20270,564,'dr','2 -Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ù†Ù‡Ø§ÙŠÙŠ',0),(20271,564,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙƒØ§Ù…Ù¾ÙŠÙˆØªØ±ÙŠ 2 -Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ù†Ù‡Ø§ÙŠÙŠ',0),(20272,564,'tr','Nihai satÄ±ÅŸ Amt',0),(20273,564,'pl','Amt totalna WyprzedaÅ¼',0),(20274,564,'bg','Ð¤Ð¸Ð½Ð°Ð»Ð½Ð° Ñ€Ð°Ð·Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Amt',0),(20275,564,'ur','ÙØ§Ø¦Ù†Ù„ Ú©Û’ Ù„ÙŠØ¦Û’ Ø§Ù…Ù¹',0),(20276,564,'sr','Ð Ð•Ð¤ . Ð’Ð°Ð» ÐºÐ¾Ð½Ð°Ñ‡Ð½Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ.',0),(20277,564,'vi','Doanh sá»‘ cuá»‘i',0),(20278,564,'af','Finale verkoop Amt',0),(20279,564,'ro','Final de vÃ¢nzare Amt',0),(20280,564,'et','LÃµplik mÃ¼Ã¼k Amt',0),(20281,564,'si','KonÄno prodajo Amt',0),(20282,564,'ba','Final Sale Amt',0),(20283,564,'nl','Final Sale Amt',0),(20284,564,'fi','Lopullista myyntiÃ¤ Amt',0),(20285,564,'no','Siste salg Amt',0),(20286,564,'da','Endelige salg Amt',0),(20287,564,'ko','ìµœì¢… íŒë§¤ Amt',0),(20288,564,'he','×”×ž×›×™×¨×” ×”×¡×•×¤×™ Amt',0),(20289,564,'el','Î¤ÎµÎ»Î¹ÎºÎ® Ï€ÏŽÎ»Î·ÏƒÎ· Amt',0),(20290,564,'zh','æœ€åŽçš„é”€å”®é‡‘é¢\r\n',0),(20291,564,'sv','SlutfÃ¶rsÃ¤ljning Amt',0),(20292,564,'it','Vendita finale Amt',0),(20293,564,'tl','',0),(20294,564,'th','&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3592;&#3635;&#3609;&#3623;&#3609;&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;',0),(20295,564,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¬à¤¿à¤•à¥à¤°à¥€ Amt',0),(20296,564,'ms','Amt jualan akhir',0),(20297,564,'ar','Ø§Ù„Ù‚Ø¶Ø§Ø© Ø§Ù„ØªÙˆÙ†Ø³ÙŠÙŠÙ† Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ',0),(20298,564,'fr','Amt vente finale',0),(20299,564,'jp','æœ€çµ‚å£²ä¸Šé«˜',0),(20300,564,'pt','Venda final Amt',0),(20301,564,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð¹ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Amt',0),(20302,564,'es','Monto de Venta Final',0),(20303,564,'de','Endverkauf Amt',0),(20304,564,'en','Final Sale Amt',0),(20305,565,'is','',0),(20306,565,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø´Ø±ÙƒØª ',0),(20307,565,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø´Ø±ÙƒØª ',0),(20308,565,'tr','Åžirket seÃ§enekleri',0),(20309,565,'pl','Firma opcje',0),(20310,565,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð¾Ð¿Ñ†Ð¸Ð¸',0),(20311,565,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(20312,565,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(20313,565,'vi','Lá»±a chá»n cty',0),(20314,565,'af','Maatskappy opsies',0),(20315,565,'ro','OpÅ£iuni de companie',0),(20316,565,'et','EttevÃµtte vÃµimalusi',0),(20317,565,'si','Podjetje moÅ¾nosti',0),(20318,565,'ba','Pilihan perusahaan',0),(20319,565,'nl','Bedrijf opties',0),(20320,565,'fi','Yrityksen asetukset',0),(20321,565,'no','Selskapet alternativer',0),(20322,565,'da','Virksomheden indstillinger',0),(20323,565,'ko','íšŒì‚¬ ì˜µì…˜',0),(20324,565,'he','××¤×©×¨×•×™×•×ª ×”×—×‘×¨×”',0),(20325,565,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(20326,565,'zh','å…¬å¸æœŸæƒ\r\n',0),(20327,565,'sv','FÃ¶retaget alternativ',0),(20328,565,'it','Azienda opzioni',0),(20329,565,'tl','',0),(20330,565,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(20331,565,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(20332,565,'ms','Syarikat pilihan',0),(20333,565,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ©',0),(20334,565,'fr','Options de l\'entreprise',0),(20335,565,'jp','ä¼šç¤¾ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(20336,565,'pt','OpÃ§Ãµes de empresa',0),(20337,565,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(20338,565,'es','Opciones de Empresa',0),(20339,565,'de','Unternehmen-Optionen',0),(20340,565,'en','Company Options',0),(20341,566,'is','',0),(20342,566,'dr','Ù†Ø¸Ø± ',0),(20343,566,'pr','Ù†Ø¸Ø± ',0),(20344,566,'tr','Yorum',0),(20345,566,'pl','Komentarz',0),(20346,566,'bg','ÐšÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(20347,566,'ur','ØªØ¨ØµØ±Û',0),(20348,566,'sr','ÐšÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(20349,566,'vi','Nháº­n xÃ©t',0),(20350,566,'af','Kommentaar',0),(20351,566,'ro','Comentariu',0),(20352,566,'et','Kommentaar',0),(20353,566,'si','Komentar',0),(20354,566,'ba','Komentar',0),(20355,566,'nl','Commentaar',0),(20356,566,'fi','Kommentti',0),(20357,566,'no','Kommentar',0),(20358,566,'da','Kommentar',0),(20359,566,'ko','ì½”ë©˜íŠ¸',0),(20360,566,'he','×”×¢×¨×”',0),(20361,566,'el','Î£Ï‡ÏŒÎ»Î¹Î¿',0),(20362,566,'zh','è¯„è®º\r\n',0),(20363,566,'sv','Kommentar',0),(20364,566,'it','Commento',0),(20365,566,'tl','',0),(20366,566,'th','&#3588;&#3623;&#3634;&#3617;&#3648;&#3627;&#3655;&#3609;',0),(20367,566,'hi','à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€',0),(20368,566,'ms','Komen',0),(20369,566,'ar','ØªØ¹Ù„ÙŠÙ‚',0),(20370,566,'fr','Commentaire',0),(20371,566,'jp','ã‚³ãƒ¡ãƒ³ãƒˆ',0),(20372,566,'pt','ComentÃ¡rio',0),(20373,566,'ru','ÐšÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹',0),(20374,566,'es','Comentario',0),(20375,566,'de','Kommentar',0),(20376,566,'en','Comment',0),(20377,567,'is','',0),(20378,567,'dr','Ù†Ø¸Ø±Ø§Øª ',0),(20379,567,'pr','Ù†Ø¸Ø±Ø§Øª ',0),(20380,567,'tr','Yorumlar',0),(20381,567,'pl','Komentarze',0),(20382,567,'bg','ÐšÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸',0),(20383,567,'ur','ØªØ¨ØµØ±Û’',0),(20384,567,'sr','ÐšÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸',0),(20385,567,'vi','Nháº­n xÃ©t',0),(20386,567,'af','Kommentare',0),(20387,567,'ro','Comentarii',0),(20388,567,'et','Kommentaarid',0),(20389,567,'si','Komentarji',0),(20390,567,'ba','Komentar',0),(20391,567,'nl','Opmerkingen',0),(20392,567,'fi','Kommentit',0),(20393,567,'no','Kommentarer',0),(20394,567,'da','Kommentarer',0),(20395,567,'ko','ì½”ë©˜íŠ¸',0),(20396,567,'he','×”×¢×¨×•×ª',0),(20397,567,'el','Î£Ï‡ÏŒÎ»Î¹Î±',0),(20398,567,'zh','è¯„è®º\r\n',0),(20399,567,'sv','Kommentarer',0),(20400,567,'it','Commenti',0),(20401,567,'tl','',0),(20402,567,'th','&#3588;&#3623;&#3634;&#3617;&#3648;&#3627;&#3655;&#3609;',0),(20403,567,'hi','à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¤¿à¤¯à¤¾à¤',0),(20404,567,'ms','Komen',0),(20405,567,'ar','ØªØ¹Ù„ÙŠÙ‚Ø§Øª',0),(20406,567,'fr','Commentaires',0),(20407,567,'jp','ã‚³ãƒ¡ãƒ³ãƒˆ',0),(20408,567,'pt','ComentÃ¡rios',0),(20409,567,'ru','ÐšÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¸',0),(20410,567,'es','Comentarios',0),(20411,567,'de','Kommentare',0),(20412,567,'en','Comments',0),(20413,568,'is','',0),(20414,568,'dr','ÙÙ‚Ø· Ù†Ø¸Ø±Ø§Øª ',0),(20415,568,'pr','ÙÙ‚Ø· Ù†Ø¸Ø±Ø§Øª ',0),(20416,568,'tr','Sadece yorumlar',0),(20417,568,'pl','Komentarze tylko',0),(20418,568,'bg','ÐšÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸ ÑÐ°Ð¼Ð¾',0),(20419,568,'ur','ØµØ±Ù ØªØ¨ØµØ±Û’',0),(20420,568,'sr','Ð¡Ð°Ð¼Ð¾ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ðµ',0),(20421,568,'vi','Chá»‰ Nháº­n xÃ©t',0),(20422,568,'af','Slegs Kommentaar',0),(20423,568,'ro','Comentarii',0),(20424,568,'et','Ainult kommentaarid',0),(20425,568,'si','Komentarji samo',0),(20426,568,'ba','Komentar hanya',0),(20427,568,'nl','Alleen opmerkingen',0),(20428,568,'fi','Kommentit vain',0),(20429,568,'no','Kommentarer',0),(20430,568,'da','Kommentarer kun',0),(20431,568,'ko','ëŒ“ê¸€ë§Œ',0),(20432,568,'he','×”×¢×¨×•×ª ×‘×œ×‘×“',0),(20433,568,'el','ÎœÏŒÎ½Î¿ ÏƒÏ‡ÏŒÎ»Î¹Î±',0),(20434,568,'zh','ä»…è¯„è®º\r\n',0),(20435,568,'sv','Kommentarer endast',0),(20436,568,'it','Solo commenti',0),(20437,568,'tl','',0),(20438,568,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3588;&#3623;&#3634;&#3617;&#3648;&#3627;&#3655;&#3609;',0),(20439,568,'hi','à¤•à¥‡à¤µà¤² à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¤¿à¤¯à¤¾à¤',0),(20440,568,'ms','Komen sahaja',0),(20441,568,'ar','ØªØ¹Ù„ÙŠÙ‚Ø§Øª ÙÙ‚Ø·',0),(20442,568,'fr','Uniquement des commentaires',0),(20443,568,'jp','ã‚³ãƒ¡ãƒ³ãƒˆã?®ã?¿',0),(20444,568,'pt','ComentÃ¡rios somente',0),(20445,568,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¸',0),(20446,568,'es','Comentarios Solamente',0),(20447,568,'de','Nur Kommentare',0),(20448,568,'en','Comments only',0),(20449,569,'is','',0),(20450,569,'dr','Ù…Ø¨Ù†Ø§ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(20451,569,'pr','Ù…Ø¨Ù†Ø§ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(20452,569,'tr','Komisyon BankasÄ±',0),(20453,569,'pl','Komisja Base',0),(20454,569,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð±Ð°Ð·Ð°',0),(20455,569,'ur','Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯',0),(20456,569,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð±Ð°Ð·Ð¸',0),(20457,569,'vi','Gá»‘c hoa há»“ng',0),(20458,569,'af','Kommissie Basis',0),(20459,569,'ro','Comisia de bazÄƒ',0),(20460,569,'et','Komisjon tugineb',0),(20461,569,'si','Komisija',0),(20462,569,'ba','Komisi Base',0),(20463,569,'nl','Commissie Base',0),(20464,569,'fi','Komissio perustaa',0),(20465,569,'no','Kommisjonen Base',0),(20466,569,'da','Kommissionen Base',0),(20467,569,'ko','ìœ„ì›íšŒ ìžë£Œ',0),(20468,569,'he','×¢×ž×œ×ª ×‘×¡×™×¡',0),(20469,569,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Î²Î¬ÏƒÎ·',0),(20470,569,'zh','ä½£é‡‘åˆ¶\r\n',0),(20471,569,'sv','Kommissionen Base',0),(20472,569,'it','Commissione Base',0),(20473,569,'tl','',0),(20474,569,'th','&#3600;&#3634;&#3609;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(20475,569,'hi','à¤†à¤¯à¥‹à¤— à¤¬à¥‡à¤¸',0),(20476,569,'ms','Komisen asas',0),(20477,569,'ar','Ø£Ø³Ø§Ø³ Ø§Ù„Ø¹Ù…ÙˆÙ„Ø©',0),(20478,569,'fr','Base de la Commission',0),(20479,569,'jp','ã‚³ãƒŸãƒƒã‚·ãƒ§ãƒ³ãƒ™ãƒ¼ã‚¹',0),(20480,569,'pt','Base de ComissÃ£o',0),(20481,569,'ru','Ð‘Ð°Ð·Ð° ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(20482,569,'es','Base de ComisiÃ³n',0),(20483,569,'de','Kommission Base',0),(20484,569,'en','Commission Base',0),(20485,570,'is','',0),(20486,570,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(20487,570,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(20488,570,'tr','Komisyon verilerini',0),(20489,570,'pl','Dane Komisji',0),(20490,570,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð´Ð°Ð½Ð½Ð¸',0),(20491,570,'ur','Ú©Ù…ÛŒØ´Ù† Ú©ÙˆØ§Ø¦Ù',0),(20492,570,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(20493,570,'vi','Dá»¯ liá»‡u hoa há»“ng',0),(20494,570,'af','Kommissie Data',0),(20495,570,'ro','Comisiei date',0),(20496,570,'et','Komisjoni andmed',0),(20497,570,'si','Komisija podatkov',0),(20498,570,'ba','Komisi Data',0),(20499,570,'nl','Commissie gegevens',0),(20500,570,'fi','Komissiolle tiedot',0),(20501,570,'no','Provisjonsdata',0),(20502,570,'da','Kommissionen Data',0),(20503,570,'ko','ìœ„ì›íšŒ ë°ì´í„°',0),(20504,570,'he','×”×•×•×¢×“×” × ×ª×•× ×™×',0),(20505,570,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(20506,570,'zh','ä½£é‡‘æ•°æ®\r\n',0),(20507,570,'sv','Kommissionens uppgifter',0),(20508,570,'it','Dati Commissione',0),(20509,570,'tl','',0),(20510,570,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(20511,570,'hi','à¤†à¤¯à¥‹à¤— à¤¡à¤¾à¤Ÿà¤¾',0),(20512,570,'ms','Data Suruhanjaya',0),(20513,570,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¹Ù…ÙˆÙ„Ø©',0),(20514,570,'fr','DonnÃ©es de la Commission',0),(20515,570,'jp','ã‚³ãƒŸãƒƒã‚·ãƒ§ãƒ³ãƒ‡ãƒ¼ã‚¿',0),(20516,570,'pt','Dados da ComissÃ£o',0),(20517,570,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(20518,570,'es','Datos de Comisiones',0),(20519,570,'de','Provisionsdaten',0),(20520,570,'en','Commission Data',0),(20521,571,'is','',0),(20522,571,'dr','Ù†Ø±Ø® ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(20523,571,'pr','Ù†Ø±Ø® ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(20524,571,'tr','Komisyon oranÄ±',0),(20525,571,'pl','Stawki prowizji',0),(20526,571,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° ÐºÑƒÑ€Ñ',0),(20527,571,'ur','Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ø´Ø±Ø­',0),(20528,571,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° ÑÑ‚Ð¾Ð¿Ð°',0),(20529,571,'vi','GiÃ¡ Hoa há»“ng ',0),(20530,571,'af','Kommissie Koers',0),(20531,571,'ro','Rata comision',0),(20532,571,'et','Vahendustasu mÃ¤Ã¤r',0),(20533,571,'si','Stopnja provizije',0),(20534,571,'ba','Tingkat komisi',0),(20535,571,'nl','Commissie tarief',0),(20536,571,'fi','Provision',0),(20537,571,'no','Kommisjon',0),(20538,571,'da','Kommissionstaksten',0),(20539,571,'ko','ìˆ˜ìˆ˜ë£Œìœ¨',0),(20540,571,'he','×ª×¢×¨×™×£ ×¢×ž×œ×”',0),(20541,571,'el','Î ÎŸÎ£ÎŸÎ£Î¤ÎŸ Ï€ÏÎ¿Î¼Î·Î¸ÎµÎ¹Î±Ï‚',0),(20542,571,'zh','ä½£é‡‘çŽ‡\r\n',0),(20543,571,'sv','Provisionssats',0),(20544,571,'it','Tasso di Commissione',0),(20545,571,'tl','',0),(20546,571,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(20547,571,'hi','à¤†à¤¯à¥‹à¤— à¤¦à¤°',0),(20548,571,'ms','Kadar komisen',0),(20549,571,'ar','Ù†Ø³Ø¨Ø© Ø§Ù„Ø¹Ù…ÙˆÙ„Ø©',0),(20550,571,'fr','Taux de Commission',0),(20551,571,'jp','ã‚³ãƒŸãƒƒã‚·ãƒ§ãƒ³çŽ‡',0),(20552,571,'pt','Taxa de ComissÃ£o',0),(20553,571,'ru','Ð¡Ñ‚Ð°Ð²ÐºÐ° ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(20554,571,'es','Tasa de ComisiÃ³n',0),(20555,571,'de','Provision',0),(20556,571,'en','Commission Rate',0),(20557,572,'is','',0),(20558,572,'dr','ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(20559,572,'pr','ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(20560,572,'tr','Kabul edilen',0),(20561,572,'pl','PopeÅ‚nione',0),(20562,572,'bg','Ð˜Ð·Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸',0),(20563,572,'ur','Ú©Ø§ Ø§Ø±ØªÚ©Ø§Ø¨ Ú©ÛŒØ§',0),(20564,572,'sr','ÐŸÐ¾Ñ‡Ð¸Ð½Ð¸Ð¾',0),(20565,572,'vi','Cam káº¿t',0),(20566,572,'af','Gepleeg',0),(20567,572,'ro','Comis',0),(20568,572,'et','Toime',0),(20569,572,'si','Zavezana',0),(20570,572,'ba','Berkomitmen',0),(20571,572,'nl','Gepleegd',0),(20572,572,'fi','Sitoutunut',0),(20573,572,'no','BegÃ¥tt',0),(20574,572,'da','BegÃ¥et',0),(20575,572,'ko','ìµœì„ ì„ ë‹¤í•˜ê³ ',0),(20576,572,'he','×‘×™×¦×¢',0),(20577,572,'el','Î”Î¹Î±Ï€ÏÎ¬Î¾ÎµÎ¹',0),(20578,572,'zh','æ‰¿è¯º\r\n',0),(20579,572,'sv','BegÃ¥tt',0),(20580,572,'it','Commesso',0),(20581,572,'tl','',0),(20582,572,'th','&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;&#3651;&#3627;&#3657;',0),(20583,572,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§',0),(20584,572,'ms','Komited',0),(20585,572,'ar','Ø§Ø±ØªÙƒØ¨Øª',0),(20586,572,'fr','Commis',0),(20587,572,'jp','ç´„æ?Ÿã?—ã?Ÿ',0),(20588,572,'pt','Cometido',0),(20589,572,'ru','Ð¡Ð¾Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ',0),(20590,572,'es','Comprometido',0),(20591,572,'de','Begangen',0),(20592,572,'en','Committed',0),(20593,573,'is','',0),(20594,573,'dr','Ø´Ø±ÙƒØª ',0),(20595,573,'pr','Ø´Ø±ÙƒØª ',0),(20596,573,'tr','Åžirket',0),(20597,573,'pl','Firma',0),(20598,573,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð°',0),(20599,573,'ur','Ú©Ù…Ù¾Ù†ÛŒ',0),(20600,573,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(20601,573,'vi','CÃ´ng TY',0),(20602,573,'af','Onderneming',0),(20603,573,'ro','Companie',0),(20604,573,'et','EttevÃµte',0),(20605,573,'si','Podjetje',0),(20606,573,'ba','Perusahaan',0),(20607,573,'nl','Bedrijf',0),(20608,573,'fi','Yritys',0),(20609,573,'no','Selskapet',0),(20610,573,'da','Virksomheden',0),(20611,573,'ko','íšŒì‚¬',0),(20612,573,'he','×”×—×‘×¨×”',0),(20613,573,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î±',0),(20614,573,'zh','å…¬å¸\r\n',0),(20615,573,'sv','FÃ¶retaget',0),(20616,573,'it','Azienda',0),(20617,573,'tl','',0),(20618,573,'th','(&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;)',0),(20619,573,'hi','à¤•à¤‚à¤ªà¤¨à¥€',0),(20620,573,'ms','Syarikat',0),(20621,573,'ar','Ø´Ø±ÙƒØ©',0),(20622,573,'fr','SociÃ©tÃ©',0),(20623,573,'jp','ä¼šç¤¾',0),(20624,573,'pt','Empresa',0),(20625,573,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(20626,573,'es','Empresa',0),(20627,573,'de','Firma',0),(20628,573,'en','Company',0),(20629,574,'is','',0),(20630,574,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª ',0),(20631,574,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª ',0),(20632,574,'tr','Firma Ekle',0),(20633,574,'pl','Dodaj firmÄ™',0),(20634,574,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð°',0),(20635,574,'ur','Ù†Ø¡ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Ø±ÛŒÚº',0),(20636,574,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(20637,574,'vi','ThÃªm Cty',0),(20638,574,'af','Onderneming Byvoeg',0),(20639,574,'ro','Adauga companie',0),(20640,574,'et','EttevÃµtte lisamine',0),(20641,574,'si','Podjetju Dodaj',0),(20642,574,'ba','Tambahkan perusahaan',0),(20643,574,'nl','Bedrijf toevoegen',0),(20644,574,'fi','Yritys lisÃ¤tÃ¤',0),(20645,574,'no','Selskapet legge',0),(20646,574,'da','Virksomheden tilfÃ¸je',0),(20647,574,'ko','íšŒì‚¬ ì¶”ê°€',0),(20648,574,'he','×”×•×¡×£ ×—×‘×¨×”',0),(20649,574,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(20650,574,'zh','å…¬å¸åœ°å€\r\n',0),(20651,574,'sv','FÃ¶retaget lÃ¤gga till',0),(20652,574,'it','Aggiungi azienda',0),(20653,574,'tl','',0),(20654,574,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(20655,574,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(20656,574,'ms','Syarikat menambah',0),(20657,574,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙƒØ©',0),(20658,574,'fr','Ajouter de la sociÃ©tÃ©',0),(20659,574,'jp','ä¼šç¤¾ã?®è¿½åŠ ',0),(20660,574,'pt','Adicionar empresa',0),(20661,574,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ',0),(20662,574,'es','Agregar Empresa',0),(20663,574,'de','Firma hinzufÃ¼gen',0),(20664,574,'en','Company Add',0),(20665,575,'is','',0),(20666,575,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(20667,575,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(20668,575,'tr','Åžirket baÅŸarÄ±yla eklendi',0),(20669,575,'pl','Firma pomyÅ›lnie dodane',0),(20670,575,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(20671,575,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(20672,575,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(20673,575,'vi','ThÃªm Cty thÃ nh cÃ´ng',0),(20674,575,'af','Onderneming suksesvol bygevoeg',0),(20675,575,'ro','Companie adaugata cu succes',0),(20676,575,'et','EttevÃµte lisati edukalt',0),(20677,575,'si','Podjetje uspeÅ¡no dodani',0),(20678,575,'ba','Perusahaan berhasil ditambahkan',0),(20679,575,'nl','Bedrijf succesvol toegevoegd',0),(20680,575,'fi','Yrityksen lisÃ¤Ã¤minen onnistui',0),(20681,575,'no','Selskapet ble lagt til',0),(20682,575,'da','Virksomheden tilfÃ¸jet',0),(20683,575,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” íšŒì‚¬',0),(20684,575,'he','×”×—×‘×¨×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(20685,575,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(20686,575,'zh','å…¬å¸æˆåŠŸæ·»åŠ \r\n',0),(20687,575,'sv','FÃ¶retaget lagts',0),(20688,575,'it','Azienda aggiunto con successo',0),(20689,575,'tl','',0),(20690,575,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(20691,575,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(20692,575,'ms','Syarikat yang berjaya menambah',0),(20693,575,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„Ø´Ø±ÙƒØ© Ø¨Ù†Ø¬Ø§Ø­',0),(20694,575,'fr','SociÃ©tÃ© ajoutÃ©e avec succÃ¨s',0),(20695,575,'jp','ä¼šç¤¾ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(20696,575,'pt','Empresa adicionada com sucesso',0),(20697,575,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(20698,575,'es','Empresa Agregada exitosamente',0),(20699,575,'de','Unternehmen, die erfolgreich hinzugefÃ¼gt',0),(20700,575,'en','Company added successfully',0),(20701,576,'is','',0),(20702,576,'dr','(Ø³Ø±Ù…Ø§ÙŠÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ) Ø´Ø±ÙƒØª ',0),(20703,576,'pr','Ú©Ù…Ú©Ù‡Ø§ (Ø³Ø±Ù…Ø§ÙŠÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ) Ø´Ø±ÙƒØª ',0),(20704,576,'tr','Åžirket katkÄ±larÄ±',0),(20705,576,'pl','Firma skÅ‚adki',0),(20706,576,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð²Ð½Ð¾ÑÐºÐ¸',0),(20707,576,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø§Ø¹Ø§Ù†Øª',0),(20708,576,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾ÑÐ°',0),(20709,576,'vi','ÄÃ³ng gÃ³p tá»« Cty',0),(20710,576,'af','Onderneming Bydraes',0),(20711,576,'ro','Compania contribuÅ£iile',0),(20712,576,'et','Ã„riÃ¼hingu osamaksud',0),(20713,576,'si','Prispevki podjetja',0),(20714,576,'ba','Kontribusi perusahaan',0),(20715,576,'nl','Bedrijf bijdragen',0),(20716,576,'fi','Yritysten sosiaaliturvamaksujen',0),(20717,576,'no','Pensjonspremie fra selskapet',0),(20718,576,'da','Virksomhedens bidrag',0),(20719,576,'ko','íšŒì‚¬ ê¸°ì—¬',0),(20720,576,'he','×ª×¨×•×”×•×ª ×—×‘×¨×”',0),(20721,576,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± ÎµÎ¹ÏƒÏ†Î¿ÏÎ­Ï‚',0),(20722,576,'zh','å…¬å¸åˆ†æ‹…è´¹ç”¨\r\n',0),(20723,576,'sv','FÃ¶retaget bidrag',0),(20724,576,'it','Contributi azienda',0),(20725,576,'tl','',0),(20726,576,'th','&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3592;&#3634;&#3588;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(20727,576,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤¯à¥‹à¤—à¤¦à¤¾à¤¨',0),(20728,576,'ms','Sumbangan Syarikat',0),(20729,576,'ar','Ù…Ø³Ø§Ù‡Ù…Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ©',0),(20730,576,'fr','Contributions de la sociÃ©tÃ©',0),(20731,576,'jp','ä¼šç¤¾è²¢çŒ®',0),(20732,576,'pt','ContribuiÃ§Ãµes da empresa',0),(20733,576,'ru','Ð’ÐºÐ»Ð°Ð´ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(20734,576,'es','Contribuciones de la Empresa',0),(20735,576,'de','Firma BeitrÃ¤ge',0),(20736,576,'en','Company Contributions',0),(20737,577,'is','',0),(20738,577,'dr','(Ø³Ø±Ù…Ø§ÙŠÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ) Ø´Ø±ÙƒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(20739,577,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ú©Ù…Ú©Ù‡Ø§ (Ø³Ø±Ù…Ø§ÙŠÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ) Ø´Ø±ÙƒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(20740,577,'tr','Åžirket katkÄ±larÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(20741,577,'pl','WkÅ‚ad firmy pomyÅ›lnie zaktualizowana',0),(20742,577,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð²Ð½Ð¾ÑÐºÐ¸, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(20743,577,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø´Ø±Ø§Ú©Øª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(20744,577,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾ÑÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(20745,577,'vi','Cáº­p Nháº­t ÄÃ³ng GÃ³p Cá»§a Cty ThÃ nh CÃ´ng',0),(20746,577,'af','Onderneming Bydraes suksesvol opdateer',0),(20747,577,'ro','Compania contribuÅ£ii actualizat cu succes',0),(20748,577,'et','Ã„riÃ¼hingu osamaksud vÃ¤rskendatud',0),(20749,577,'si','Prispevki podjetja uspeÅ¡no posodobljena',0),(20750,577,'ba','Kontribusi perusahaan berhasil',0),(20751,577,'nl','Bedrijf bijdragen bijgewerkt',0),(20752,577,'fi','Yritysten sosiaaliturvamaksujen pÃ¤ivitetty',0),(20753,577,'no','Pensjonspremie fra selskapet oppdatert',0),(20754,577,'da','Virksomhedens bidrag opdateret',0),(20755,577,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ëŠ” íšŒì‚¬ ê¸°ì—¬',0),(20756,577,'he','×ª×¨×•×ž×•×ª ×”×—×‘×¨×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(20757,577,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± ÎµÎ¹ÏƒÏ†Î¿ÏÎ­Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(20758,577,'zh','å…¬å¸å·²æˆåŠŸæ›´æ–°åˆ†æ‹…è´¹ç”¨\r\n',0),(20759,577,'sv','FÃ¶retaget bidrag uppdaterats',0),(20760,577,'it','Contributi azienda aggiornati con successo',0),(20761,577,'tl','',0),(20762,577,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3592;&#3634;&#3588;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(20763,577,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤¯à¥‹à¤—à¤¦à¤¾à¤¨ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(20764,577,'ms','Sumbangan Syarikat yang berjaya dikemas kini',0),(20765,577,'ar','Ø­Ø¯Ù‘Ø«Øª Ù…Ø³Ø§Ù‡Ù…Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ© Ø¨Ù†Ø¬Ø§Ø­',0),(20766,577,'fr','Contributions de l\'entreprise mis Ã  jour avec succÃ¨s',0),(20767,577,'jp','ä¼šç¤¾è² æ‹…é‡‘ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(20768,577,'pt','ContribuiÃ§Ãµes da empresa atualizadas com sucesso',0),(20769,577,'ru','Ð’ÐºÐ»Ð°Ð´ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(20770,577,'es','Contribuciones de la Empresa actualizadas exitosamente',0),(20771,577,'de','Unternehmen-BeitrÃ¤ge, die erfolgreich aktualisiert',0),(20772,577,'en','Company Contributions updated successfully',0),(20773,578,'is','',0),(20774,578,'dr','Ø­Ø°Ù Ø´Ø±ÙƒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(20775,578,'pr','Ø­Ø°Ù Ø´Ø±ÙƒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(20776,578,'tr','Åžirket baÅŸarÄ±yla silindi',0),(20777,578,'pl','Firma przesâ”‚anie',0),(20778,578,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(20779,578,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(20780,578,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(20781,578,'vi','XÃ³a Cty thÃ nh cÃ´ng',0),(20782,578,'af','Onderneming suksesvol geskrap',0),(20783,578,'ro','Compania eliminÄƒ cu succes',0),(20784,578,'et','EttevÃµte kustutati edukalt',0),(20785,578,'si','Podjetje uspeÅ¡no izbrisana',0),(20786,578,'ba','Perusahaan berhasil dihapus',0),(20787,578,'nl','Bedrijf succesvol verwijderd',0),(20788,578,'fi','Yritys poistettu',0),(20789,578,'no','Selskapet ble slettet',0),(20790,578,'da','Virksomheden slettet',0),(20791,578,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” íšŒì‚¬',0),(20792,578,'he','×”×—×‘×¨×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(20793,578,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(20794,578,'zh','å…¬å¸å·²æˆåŠŸåˆ é™¤\r\n',0),(20795,578,'sv','FÃ¶retaget raderades',0),(20796,578,'it','Azienda eliminato con successo',0),(20797,578,'tl','',0),(20798,578,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(20799,578,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(20800,578,'ms','Syarikat dihapuskan dengan jayanya',0),(20801,578,'ar','Ø­Ø°ÙØª Ø§Ù„Ø´Ø±ÙƒØ© Ø¨Ù†Ø¬Ø§Ø­',0),(20802,578,'fr','SociÃ©tÃ© supprimÃ©e avec succÃ¨s',0),(20803,578,'jp','ä¼šç¤¾ã‚’æ¶ˆåŽ»ã?¾ã?—ã?Ÿ',0),(20804,578,'pt','Empresa apagada com sucesso',0),(20805,578,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð° ',0),(20806,578,'es','Empresa Eliminada exitosamente',0),(20807,578,'de','Unternehmen, die erfolgreich gelÃ¶scht',0),(20808,578,'en','Company deleted successfully',0),(20809,579,'is','',0),(20810,579,'dr','ØªÙ‚Ø³ÙŠÙ…Ø§Øª Ø´Ø±ÙƒØª',0),(20811,579,'pr','ØªÙ‚Ø³ÙŠÙ…Ø§Øª Ø´Ø±ÙƒØª',0),(20812,579,'tr','Åžirket bÃ¶lÃ¼mlerini',0),(20813,579,'pl','DziaÅ‚Ã³w',0),(20814,579,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð´Ð¸Ð²Ð¸Ð·Ð¸Ð¸',0),(20815,579,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ ØªÙ‚Ø³ÛŒÙ…',0),(20816,579,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¾Ð´ÐµÑ™ÐµÑšÐ°',0),(20817,579,'vi','PhÃ²ng ban cá»§a Cty',0),(20818,579,'af','Onderneming Afdelings',0),(20819,579,'ro','Diviziunile companiei',0),(20820,579,'et','Ã„riÃ¼hingu jagunemise',0),(20821,579,'si','Oddelke',0),(20822,579,'ba','Divisi perusahaan',0),(20823,579,'nl','Bedrijf divisies',0),(20824,579,'fi','Yrityksen osastoja',0),(20825,579,'no','Selskapets divisjoner',0),(20826,579,'da','Virksomheden divisioner',0),(20827,579,'ko','íšŒì‚¬ ë¶€ì„œ',0),(20828,579,'he','×—×˜×™×‘×•×ª ×”×—×‘×¨×”',0),(20829,579,'el','Î¤Î¼Î®Î¼Î±Ï„Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(20830,579,'zh','å…¬å¸åˆ†éƒ¨\r\n',0),(20831,579,'sv','FÃ¶retagsdivisioner',0),(20832,579,'it','Divisioni aziendali',0),(20833,579,'tl','',0),(20834,579,'th','&#3585;&#3634;&#3619;&#3649;&#3610;&#3656;&#3591;&#3649;&#3618;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(20835,579,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤ªà¥à¤°à¤­à¤¾à¤—à¥‹à¤‚',0),(20836,579,'ms','Bahagian Syarikat',0),(20837,579,'ar','Ø£Ù‚Ø³Ø§Ù… Ø§Ù„Ø´Ø±ÙƒØ©',0),(20838,579,'fr','Divisions de l\'entreprise',0),(20839,579,'jp','ä¼šç¤¾éƒ¨é–€',0),(20840,579,'pt','DivisÃµes da empresa',0),(20841,579,'ru','ÐŸÐ¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(20842,579,'es','Empresas Divisiones',0),(20843,579,'de','Unternehmensbereiche',0),(20844,579,'en','Company Divisions',0),(20845,580,'is','',0),(20846,580,'dr','Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¨ÙŠÙ…Ù‡ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø´Ø±ÙƒØª ',0),(20847,580,'pr','Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¨ÙŠÙ…Ù‡ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø´Ø±ÙƒØª ',0),(20848,580,'tr','Åžirket FICA/Medicare',0),(20849,580,'pl','Firma FICA/Medicare',0),(20850,580,'bg','Ð¤Ð¸Ñ€Ð¼Ð° FICA/Medicare',0),(20851,580,'ur','Ú©Ù…Ù¾Ù†ÛŒ ÙØ§Ú©ÛŒ/Ù…ÛŒÚˆÛŒ',0),(20852,580,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° ÐžÐ”Ð Ð•Ð¡ÐšÐ£/Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚',0),(20853,580,'vi','Báº£o hiá»ƒm xÃ£ há»™i cá»§a cty/Y táº¿',0),(20854,580,'af','Maatskappy FICA/Medicare',0),(20855,580,'ro','Compania FICA/Medicare',0),(20856,580,'et','Firma FICA/Medicare',0),(20857,580,'si','Podjetje FICA/Medicare',0),(20858,580,'ba','Perusahaan FICA/Medicare',0),(20859,580,'nl','Bedrijf FICA/Medicare',0),(20860,580,'fi','Yrityksen FICA/Medicare',0),(20861,580,'no','Selskapet FICA/Medicare',0),(20862,580,'da','Virksomheden FICA/Medicare',0),(20863,580,'ko','íšŒì‚¬ê°€ ë´/ë©”ë””ì¼€ì–´',0),(20864,580,'he','×”×—×‘×¨×” ×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™/×ž×“×™×§×¨',0),(20865,580,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± Î£Î¥ÎœÎ’ÎŸÎ¥Î›Î‰/Medicare',0),(20866,580,'zh','å…¬å¸è”é‚¦ä¿é™©å±€å•ŠçŒªæ¡ä¾‹/åŒ»ç–—ä¿é™©\r\n',0),(20867,580,'sv','FÃ¶retaget FICA/Medicare',0),(20868,580,'it','Azienda FICA/Medicare',0),(20869,580,'tl','',0),(20870,580,'th','&#3585;&#3629;&#3591;&#3607;&#3640;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;/&#3649;&#3612;&#3609;&#3626;&#3623;&#3633;&#3626;&#3604;&#3636;&#3585;&#3634;&#3619; &#3610;&#3619;&#3636;&#3625;&#3633;&#3607; ',0),(20871,580,'hi','à¤•à¤‚à¤ªà¤¨à¥€ FICA/à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤°',0),(20872,580,'ms','Syarikat FICA/Medicare',0),(20873,580,'ar','Ø´Ø±ÙƒØ© Ù…Ø­ÙƒÙ…ÙŠ/Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(20874,580,'fr','SociÃ©tÃ© FICA/assurance maladie',0),(20875,580,'jp','ä¼šç¤¾é€£é‚¦ä¿?é™ºå¯„ä¸Žæ³•/åŒ»ç™‚ä¿?é™º',0),(20876,580,'pt','Empresa FICA/Medicare',0),(20877,580,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ FICA/Medicare',0),(20878,580,'es','Empresa FICA/Medicare',0),(20879,580,'de','Firma FICA/Medicare',0),(20880,580,'en','Company FICA/Medicare',0),(20881,581,'is','',0),(20882,581,'dr','Ù†Ø§Ù… Ø´Ø±ÙƒØª ',0),(20883,581,'pr','Ù†Ø§Ù… Ø´Ø±ÙƒØª ',0),(20884,581,'tr','Åžirket adÄ±',0),(20885,581,'pl','Nazwa firmy',0),(20886,581,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð°',0),(20887,581,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù…',0),(20888,581,'sr','Ð˜Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(20889,581,'vi','TÃªn Cty',0),(20890,581,'af','Ondernemingnaam',0),(20891,581,'ro','Nume companie',0),(20892,581,'et','EttevÃµtte nimi',0),(20893,581,'si','Ime podjetja',0),(20894,581,'ba','Nama perusahaan',0),(20895,581,'nl','Bedrijfsnaam',0),(20896,581,'fi','Yrityksen nimi',0),(20897,581,'no','Firmanavn',0),(20898,581,'da','Virksomhedens navn',0),(20899,581,'ko','íšŒì‚¬ ì´ë¦„',0),(20900,581,'he','×©× ×—×‘×¨×”',0),(20901,581,'el','Î¤Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(20902,581,'zh','å…¬å¸åç§°\r\n',0),(20903,581,'sv','FÃ¶retagets namn',0),(20904,581,'it','Nome della societÃ ',0),(20905,581,'tl','',0),(20906,581,'th','&#3594;&#3639;&#3656;&#3629;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(20907,581,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¨à¤¾à¤®',0),(20908,581,'ms','Nama Syarikat',0),(20909,581,'ar','Ø¥Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ©',0),(20910,581,'fr','Nom de l\'entreprise',0),(20911,581,'jp','ä¼šç¤¾å??',0),(20912,581,'pt','Nome da empresa',0),(20913,581,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(20914,581,'es','Nombre de la Empresa',0),(20915,581,'de','Name des Unternehmens',0),(20916,581,'en','Company Name',0),(20917,582,'is','',0),(20918,582,'dr','Ø´Ø±ÙƒØª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(20919,582,'pr','Ø´Ø±ÙƒØª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(20920,582,'tr','Åžirketi bulunamadÄ±',0),(20921,582,'pl','Firma nie znaleziono',0),(20922,582,'bg','Ð”Ñ€ÑƒÐ¶ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(20923,582,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(20924,582,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(20925,582,'vi','KhÃ´ng tÃ¬m tháº¥y Cty',0),(20926,582,'af','Onderneming nie gevind',0),(20927,582,'ro','Compania nu exista',0),(20928,582,'et','EttevÃµtet ei leitud',0),(20929,582,'si','Podjetje ni bilo mogoÄe najti',0),(20930,582,'ba','Perusahaan tidak ditemukan',0),(20931,582,'nl','Bedrijf niet gevonden',0),(20932,582,'fi','YritystÃ¤ ei lÃ¶ydy',0),(20933,582,'no','Selskapet ikke funnet',0),(20934,582,'da','Virksomheden blev ikke fundet',0),(20935,582,'ko','íšŒì‚¬ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(20936,582,'he','×”×—×‘×¨×” ×œ× × ×ž×¦××”',0),(20937,582,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(20938,582,'zh','å…¬å¸æœªæ‰¾åˆ°\r\n',0),(20939,582,'sv','FÃ¶retaget hittades inte',0),(20940,582,'it','Azienda non trovata',0),(20941,582,'tl','',0),(20942,582,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(20943,582,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(20944,582,'ms','Syarikat yang tidak dijumpai',0),(20945,582,'ar','Ø§Ù„Ø´Ø±ÙƒØ© ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(20946,582,'fr','SociÃ©tÃ© n\'avait ne pas',0),(20947,582,'jp','ä¼šç¤¾ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(20948,582,'pt','Empresa nÃ£o encontrada',0),(20949,582,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°',0),(20950,582,'es','Empresa no se encontrÃ³',0),(20951,582,'de','Firma nicht gefunden',0),(20952,582,'en','Company not found',0),(20953,583,'is','',0),(20954,583,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø´Ø±ÙƒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙƒØ±Ø¯',0),(20955,583,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø´Ø±ÙƒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙƒØ±Ø¯',0),(20956,583,'tr','Åžirket seÃ§enekleri baÅŸarÄ±yla deÄŸiÅŸtirildi',0),(20957,583,'pl','Firma opcji zmienione',0),(20958,583,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð¾Ð¿Ñ†Ð¸Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(20959,583,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(20960,583,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½',0),(20961,583,'vi','Thay lá»±a chá»n cty thÃ nh cÃ´ng',0),(20962,583,'af','Onderneming opsies suksesvol verander',0),(20963,583,'ro','Compania opÅ£iuni schimbat cu succes',0),(20964,583,'et','EttevÃµtte valikud muudeti edukalt',0),(20965,583,'si','Podjetje moÅ¾nosti uspeÅ¡no',0),(20966,583,'ba','Pilihan perusahaan berhasil diubah',0),(20967,583,'nl','Bedrijf opties met succes gewijzigd',0),(20968,583,'fi','YhtiÃ¶lle vaihtoehtoja muutettu',0),(20969,583,'no','Selskapet alternativer endret',0),(20970,583,'da','Virksomheden indstillinger Ã¦ndret',0),(20971,583,'ko','íšŒì‚¬ ì˜µì…˜ ì„±ê³µì ìœ¼ë¡œ ë³€ê²½',0),(20972,583,'he','××¤×©×¨×•×™×•×ª ×”×—×‘×¨×” ×”×©×ª× ×” ×‘×”×¦×œ×—×”',0),(20973,583,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î¬Î»Î»Î±Î¾Îµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(20974,583,'zh','å…¬å¸è‚¡æƒå˜æ›´æˆåŠŸ\r\n',0),(20975,583,'sv','FÃ¶retaget alternativ Ã¤ndras framgÃ¥ngsrikt',0),(20976,583,'it','Opzioni di azienda cambiati con successo',0),(20977,583,'tl','',0),(20978,583,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(20979,583,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¦à¤² à¤—à¤¯à¤¾',0),(20980,583,'ms','Pilihan Syarikat yang berjaya diubah',0),(20981,583,'ar','ØºÙŠÙ‘Ø±Øª Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ© Ø¨Ù†Ø¬Ø§Ø­',0),(20982,583,'fr','Options de la compagnie a changÃ© avec succÃ¨s',0),(20983,583,'jp','ä¼šç¤¾ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?Œå¤‰æ›´ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(20984,583,'pt','OpÃ§Ãµes de empresa mudadas-se com sucesso',0),(20985,583,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ñ‹',0),(20986,583,'es','Opciones de la empresa cambiadas exitosamente',0),(20987,583,'de','Firma Optionen erfolgreich geÃ¤ndert',0),(20988,583,'en','Company options changed successfully',0),(20989,584,'is','',0),(20990,584,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±ÙƒØª ',0),(20991,584,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±ÙƒØª ',0),(20992,584,'tr','Åžirket gÃ¼ncelleÅŸtirme',0),(20993,584,'pl','Firma Update',0),(20994,584,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(20995,584,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(20996,584,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð°',0),(20997,584,'vi','Cáº­p Nháº­t Cty',0),(20998,584,'af','Onderneming Opdateer',0),(20999,584,'ro','Compania Update',0),(21000,584,'et','EttevÃµtte uuendamine',0),(21001,584,'si','Podjetje posodobitev',0),(21002,584,'ba','Perusahaan Update',0),(21003,584,'nl','Bedrijf Update',0),(21004,584,'fi','Company pÃ¤ivitys',0),(21005,584,'no','Selskapet oppdateringen',0),(21006,584,'da','Virksomheden opdatering',0),(21007,584,'ko','íšŒì‚¬ ì—…ë°ì´íŠ¸',0),(21008,584,'he','×¢×“×›×•×Ÿ ×—×‘×¨×ª',0),(21009,584,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(21010,584,'zh','å…¬å¸å¿«è®¯\r\n',0),(21011,584,'sv','FÃ¶retaget uppdatering',0),(21012,584,'it','Azienda aggiornamento',0),(21013,584,'tl','',0),(21014,584,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(21015,584,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(21016,584,'ms','Kemaskini Syarikat',0),(21017,584,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø´Ø±ÙƒØ©',0),(21018,584,'fr','Mise Ã  jour',0),(21019,584,'jp','ä¼šç¤¾æ›´æ–°',0),(21020,584,'pt','AtualizaÃ§Ã£o de empresa',0),(21021,584,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ',0),(21022,584,'es','ActualizaciÃ³n de la Empresa',0),(21023,584,'de','Unternehmen-Update',0),(21024,584,'en','Company Update',0),(21025,585,'is','',0),(21026,585,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ù‡ Ø±ÙˆØ² ÙƒØ±Ø¯Ù† Ø´Ø±ÙƒØª  Ø¯Ø± Ù†Ù…ÙˆÙ†Ù‡ Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ  Ù†ÙŠØ³Øª ',0),(21027,585,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ù‡ Ø±ÙˆØ² ÙƒØ±Ø¯Ù† Ø´Ø±ÙƒØª  Ø¯Ø± Ù†Ù…ÙˆÙ†Ù‡ Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ  Ù†ÙŠØ³Øª ',0),(21028,585,'tr','Demo modunda iken ÅŸirket gÃ¼ncelleÅŸtirilemiyor',0),(21029,585,'pl','Nie moÅ¼na zaktualizowaÄ‡ spÃ³Å‚ki w trybie demo',0),(21030,585,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð² Ð´ÐµÐ¼Ð¾ Ñ€ÐµÐ¶Ð¸Ð¼',0),(21031,585,'ur','Ø¬Ø¨Ú©Û ÚˆÛŒÙ…Ùˆ Ù…ÙˆÚˆ Ù…ÛŒÚº Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(21032,585,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð´Ð¾Ðº Ñ˜Ðµ Ð±Ð¸Ð¾ Ñƒ Ð´ÐµÐ¼Ð¾ ÐœÐ¾Ð´',0),(21033,585,'vi','KhÃ´ng Thá»ƒ Cáº­p Nháº­t Cty khi Ä‘ang demo ',0),(21034,585,'af','Nie Instaat om die Onderneming te opdateer terwyl in demo modus is',0),(21035,585,'ro','Imposibil de actualizat companiei Ã®n timp ce Ã®n modul demo',0),(21036,585,'et','Ei saa vÃ¤rskendada ettevÃµtte demo reÅ¾iim',0),(21037,585,'si','Ne more posodobiti podjetje v demo naÄinu',0),(21038,585,'ba','Tidak dapat memperbarui perusahaan sementara dalam versi demo',0),(21039,585,'nl','Bedrijf in de demo mode bijwerken niet',0),(21040,585,'fi','Ei voi pÃ¤ivittÃ¤Ã¤ yritys mielenosoitus moodi',0),(21041,585,'no','Kan ikke oppdatere selskapet i demomodus',0),(21042,585,'da','Kan ikke opdatere selskab i demotilstand',0),(21043,585,'ko','ë°ëª¨ ëª¨ë“œì—ì„œ íšŒì‚¬ë¥¼ ì—…ë°ì´íŠ¸í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(21044,585,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×¢×“×›×Ÿ ××ª ×”×—×‘×¨×” ×‘×ž×¦×‘ ×”×“×’×ž×”',0),(21045,585,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹ Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎµÎ½ÏŽ ÏƒÎµ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± ÎµÏ€Î¯Î´ÎµÎ¹Î¾Î·Ï‚',0),(21046,585,'zh','æ— æ³•æ›´æ–°ï¼Œè€Œåœ¨å…¬å¸æ¨¡å¼æ¼”ç¤º\r\n',0),(21047,585,'sv','Kan inte uppdatera fÃ¶retag medan i demo-lÃ¤ge',0),(21048,585,'it','Non Ã¨ possibile aggiornare l\'azienda mentre in modalitÃ  demo',0),(21049,585,'tl','',0),(21050,585,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3586;&#3603;&#3632;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3650;&#3627;&#3617;&#3604;&#3',0),(21051,585,'hi','à¤œà¤¬à¤•à¤¿ à¤¡à¥‡à¤®à¥‹ à¤®à¥‹à¤¡ à¤®à¥‡à¤‚ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(21052,585,'ms','Tidak dapat mengemaskini Syarikat semasa dalam mod demo',0),(21053,585,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø´Ø±ÙƒØ© Ø¨ÙŠÙ†Ù…Ø§ ÙÙŠ Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¹Ø±Ø¶',0),(21054,585,'fr','Impossible de mettre Ã  jour entreprise en mode dÃ©mo',0),(21055,585,'jp','ãƒ‡ãƒ¢ãƒ¢ãƒ¼ãƒ‰ä¸­ã?¯ä¼šç¤¾ã?®æ›´æ–°ã?§ã??ã?¾ã?›ã‚“ã‚“',0),(21056,585,'pt','NÃ£o Ã© possÃ­vel atualizar a empresa enquanto estiver no modo de demonstraÃ§Ã£o',0),(21057,585,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑ Ñ€ÐµÐ¶Ð¸Ð¼ demo',0),(21058,585,'es','No se puede actualizar la empresa mientras que esta en modo de demo',0),(21059,585,'de','Unternehmen im Demomodus kann nicht aktualisiert werden.',0),(21060,585,'en','Cannot update company while in demo mode',0),(21061,586,'is','',0),(21062,586,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±ÙƒØª Ø¨Ø§ Ù…Ùˆ ÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(21063,586,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±ÙƒØª Ø¨Ø§ Ù…Ùˆ ÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(21064,586,'tr','Åžirket baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(21065,586,'pl','Firma pomyÅ›lnie zaktualizowana',0),(21066,586,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(21067,586,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(21068,586,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(21069,586,'vi','Cáº­p Nháº­t Cty ThÃ nh CÃ´ng',0),(21070,586,'af','Onderneming suksesvol opdateer',0),(21071,586,'ro','Compania actualizat cu succes',0),(21072,586,'et','EttevÃµte uuendati edukalt',0),(21073,586,'si','Podjetje uspeÅ¡no posodobljena',0),(21074,586,'ba','Perusahaan yang berhasil',0),(21075,586,'nl','Bedrijf succesvol bijgewerkt',0),(21076,586,'fi','Yrityksen pÃ¤ivittÃ¤minen onnistui',0),(21077,586,'no','Selskapet oppdatert',0),(21078,586,'da','Selskab opdateret',0),(21079,586,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” íšŒì‚¬',0),(21080,586,'he','×”×—×‘×¨×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(21081,586,'el','Î— ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(21082,586,'zh','å…¬å¸å·²æˆåŠŸæ›´æ–°\r\n',0),(21083,586,'sv','FÃ¶retaget uppdaterats',0),(21084,586,'it','Azienda aggiornato con successo',0),(21085,586,'tl','',0),(21086,586,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(21087,586,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(21088,586,'ms','Syarikat yang berjaya dikemas kini',0),(21089,586,'ar','Ø­Ø¯Ù‘Ø«Øª Ø§Ù„Ø´Ø±ÙƒØ© Ø¨Ù†Ø¬Ø§Ø­',0),(21090,586,'fr','SociÃ©tÃ© mis Ã  jour avec succÃ¨s',0),(21091,586,'jp','ä¼šç¤¾ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(21092,586,'pt','Empresa atualizada com sucesso',0),(21093,586,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(21094,586,'es','Empresa actualizada exitosamente',0),(21095,586,'de','Unternehmen, die erfolgreich aktualisiert',0),(21096,586,'en','Company updated successfully',0),(21097,587,'is','',0),(21098,587,'dr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù†  Ø´Ø±ÙƒØª ',0),(21099,587,'pr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù†  Ø´Ø±ÙƒØª ',0),(21100,587,'tr','Åžirket kullanÄ±cÄ±larÄ±',0),(21101,587,'pl','Firma uÅ¼ytkownikÃ³w',0),(21102,587,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(21103,587,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ ØµØ§Ø±ÙÛŒÙ†',0),(21104,587,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸',0),(21105,587,'vi','NgÆ°á»i Sá»­ Dá»¥ng Cá»§a Cty',0),(21106,587,'af','Onderneming Gebruikers',0),(21107,587,'ro','Utilizatori companie',0),(21108,587,'et','EttevÃµtte kasutajad',0),(21109,587,'si','Podjetje uporabnikov',0),(21110,587,'ba','Pengguna perusahaan',0),(21111,587,'nl','Bedrijf gebruikers',0),(21112,587,'fi','YrityskÃ¤yttÃ¤jÃ¤t',0),(21113,587,'no','Selskapet brukere',0),(21114,587,'da','Virksomhedsbrugere',0),(21115,587,'ko','íšŒì‚¬ ì‚¬ìš©ìž',0),(21116,587,'he','×”×—×‘×¨×” ×ž×©×ª×ž×©×™×',0),(21117,587,'el','Î•Ï„Î±Î¹ÏÎ¹ÎºÎ¿Î¯ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(21118,587,'zh','ä¼ä¸šç”¨æˆ·\r\n',0),(21119,587,'sv','FÃ¶retagsanvÃ¤ndare',0),(21120,587,'it','Utenti aziendali',0),(21121,587,'tl','',0),(21122,587,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(21123,587,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤•à¤‚à¤ªà¤¨à¥€',0),(21124,587,'ms','Syarikat pengguna',0),(21125,587,'ar','Ù…Ø³ØªØ®Ø¯Ù…ÙŠ Ø§Ù„Ø´Ø±ÙƒØ©',0),(21126,587,'fr','Utilisateurs de l\'entreprise',0),(21127,587,'jp','ä¼šç¤¾ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(21128,587,'pt','UsuÃ¡rios da empresa',0),(21129,587,'ru','Ð¤Ð¸Ñ€Ð¼Ñ‹ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸',0),(21130,587,'es','Usuarios de la Empresa',0),(21131,587,'de','Benutzer der Firma',0),(21132,587,'en','Company Users',0),(21133,588,'is','',0),(21134,588,'dr','Ù…Ù‚Ø§ÙŠØ³Ù‡ ÙƒØ±Ø¯Ù†  Ø¨Ø§ ',0),(21135,588,'pr','Ù…Ù‚Ø§ÙŠØ³Ù‡ ÙƒØ±Ø¯Ù†  Ø¨Ø§ ',0),(21136,588,'tr','KarÅŸÄ±laÅŸtÄ±rÄ±n',0),(21137,588,'pl','W porÃ³wnaniu do',0),(21138,588,'bg','Ð¡Ñ€Ð°Ð²Ð½Ð¸ Ñ',0),(21139,588,'ur','Ú©Ø§ Ù…ÙˆØ§Ø²Ù†Û',0),(21140,588,'sr','Ð£Ð¿Ð¾Ñ€ÐµÐ´Ð¸ ÑÐ°',0),(21141,588,'vi','So sÃ¡nh vá»›i',0),(21142,588,'af','Vergelyk om te',0),(21143,588,'ro','Compara',0),(21144,588,'et','VÃµrrelda',0),(21145,588,'si','Primerjati z',0),(21146,588,'ba','Dibandingkan',0),(21147,588,'nl','Vergelijken met',0),(21148,588,'fi','Vertaa',0),(21149,588,'no','Sammenligne',0),(21150,588,'da','Sammenligne med',0),(21151,588,'ko','ë¹„êµ',0),(21152,588,'he','×œ×”×©×•×•×ª',0),(21153,588,'el','Î£Îµ ÏƒÏÎ³ÎºÏÎ¹ÏƒÎ· Î¼Îµ',0),(21154,588,'zh','å¯¹æ¯”\r\n',0),(21155,588,'sv','JÃ¤mfÃ¶r med',0),(21156,588,'it','Confrontare con',0),(21157,588,'tl','',0),(21158,588,'th','&#3648;&#3611;&#3619;&#3637;&#3618;&#3610;&#3648;&#3607;&#3637;&#3618;&#3610;&#3585;&#3633;&#3610;',0),(21159,588,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾ à¤•à¤°à¥‡à¤‚',0),(21160,588,'ms','Berbanding dengan',0),(21161,588,'ar','Ù„Ù…Ù‚Ø§Ø±Ù†Ø©',0),(21162,588,'fr','Comparer Ã ',0),(21163,588,'jp','æ¯”è¼ƒ',0),(21164,588,'pt','Comparar com',0),(21165,588,'ru','ÐŸÐ¾ ÑÑ€Ð°Ð²Ð½ÐµÐ½Ð¸ÑŽ Ñ',0),(21166,588,'es','Comparar a',0),(21167,588,'de','Vergleichen Sie mit',0),(21168,588,'en','Compare to',0),(21169,589,'is','',0),(21170,589,'dr','Ø¯Ø± Ù…Ù‚Ø§ÙŠØ³Ù‡ Ø¨Ø§ Ø¯ÙŠÚ¯Ø± Ø¯ÙˆØ±Ù‡ Ù‡Ø§',0),(21171,589,'pr','Ø¯Ø± Ù…Ù‚Ø§ÙŠØ³Ù‡ Ø¨Ø§ Ø¯ÙŠÚ¯Ø± Ø¯ÙˆØ±Ù‡ Ù‡Ø§',0),(21172,589,'tr','BaÅŸka bir dÃ¶nem iÃ§in karÅŸÄ±laÅŸtÄ±rÄ±n',0),(21173,589,'pl','PorÃ³wnanie do innych okres',0),(21174,589,'bg','Ð¡Ñ€Ð°Ð²Ð½Ð¸ Ñ Ð´Ñ€ÑƒÐ³ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(21175,589,'ur','Ø¯ÙˆØ³Ø±ÛŒ Ù…Ø¯Øª Ú©Û’ Ù„ÛŒÛ’ Ú©Ø§ Ù…ÙˆØ§Ø²Ù†Û Ú©Ø±ÛŒÚº',0),(21176,589,'sr','Ð£Ð¿Ð¾Ñ€ÐµÐ´Ð¸ ÑÐ° Ð´Ñ€ÑƒÐ³Ð¾Ð¼ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñƒ',0),(21177,589,'vi','So sÃ¡nh vá»›i thá»i ká»³ khÃ¡c',0),(21178,589,'af','Vergelyk met Ander Periode',0),(21179,589,'ro','Compara cu alte perioade',0),(21180,589,'et','VÃµrreldes teiste perioodi',0),(21181,589,'si','Primerjati z drugimi obdobje',0),(21182,589,'ba','Dibandingkan dengan periode lain',0),(21183,589,'nl','Te vergelijken met andere periode',0),(21184,589,'fi','Vertaa muun ajan',0),(21185,589,'no','Sammenlignet med andre periode',0),(21186,589,'da','Sammenlign med andre periode',0),(21187,589,'ko','ë‹¤ë¥¸ ê¸°ê°„ì„ ë¹„êµ',0),(21188,589,'he','×œ×”×©×•×•×ª ×œ×ª×§×•×¤×” ××—×¨×ª',0),(21189,589,'el','Î£Îµ ÏƒÏÎ³ÎºÏÎ¹ÏƒÎ· Î¼Îµ Î¬Î»Î»Î± Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(21190,589,'zh','ç›¸è¾ƒäºŽå…¶ä»–æœŸé™\r\n',0),(21191,589,'sv','JÃ¤mfÃ¶r med andra perioden',0),(21192,589,'it','Confrontare con altri periodo',0),(21193,589,'tl','',0),(21194,589,'th','&#3648;&#3611;&#3619;&#3637;&#3618;&#3610;&#3648;&#3607;&#3637;&#3618;&#3610;&#3585;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3629;&#3639;&#3656;&#3609;',0),(21195,589,'hi','à¤…à¤¨à¥à¤¯ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾ à¤•à¤°à¥‡à¤‚',0),(21196,589,'ms','Berbanding dengan tempoh',0),(21197,589,'ar','Ù‚Ø§Ø±Ù† Ø¥Ù„Ù‰ ÙØªØ±Ø© Ø£Ø®Ø±Ù‰',0),(21198,589,'fr','Comparer Ã  une autre pÃ©riode',0),(21199,589,'jp','ä»–ã?®æœŸé–“ã?¨æ¯”è¼ƒ',0),(21200,589,'pt','Comparar com outro perÃ­odo',0),(21201,589,'ru','Ð¡Ñ€Ð°Ð²Ð½Ð¸Ñ‚ÑŒ Ñ Ð´Ñ€ÑƒÐ³Ð¸Ð¼ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¾Ð¼',0),(21202,589,'es','Comparar a Otro PerÃ­odo',0),(21203,589,'de','Vergleichen Sie mit anderen Zeitraum',0),(21204,589,'en','Compare to Other Period',0),(21205,590,'is','',0),(21206,590,'dr','Ù…Ù‚Ø§ÙŠØ³Ù‡ ÙƒØ±Ø¯Ù†  Ø¨Ø§ ',0),(21207,590,'pr','Ù…Ù‚Ø§ÙŠØ³Ù‡ ÙƒØ±Ø¯Ù†  Ø¨Ø§ ',0),(21208,590,'tr','KarÅŸÄ±laÅŸtÄ±rÄ±ldÄ±ÄŸÄ±nda',0),(21209,590,'pl','W porÃ³wnaniu do',0),(21210,590,'bg','Ð’ ÑÑ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ Ñ',0),(21211,590,'ur','Ú©Û’ Ù…Ù‚Ø§Ø¨Ù„Û’ Ù…ÛŒÚº',0),(21212,590,'sr','Ð£ Ð¾Ð´Ð½Ð¾ÑÑƒ Ð½Ð°',0),(21213,590,'vi','So sÃ¡nh vá»›i',0),(21214,590,'af','Vergelyk met',0),(21215,590,'ro','ÃŽn comparaÅ£ie cu',0),(21216,590,'et','VÃµrreldes',0),(21217,590,'si','V primerjavi z',0),(21218,590,'ba','Dibandingkan dengan',0),(21219,590,'nl','In vergelijking met',0),(21220,590,'fi','Verrattuna',0),(21221,590,'no','Sammenlignet med',0),(21222,590,'da','I forhold til',0),(21223,590,'ko','ì— ë¹„í•´',0),(21224,590,'he','×‘×”×©×•×•××”',0),(21225,590,'el','Î£Îµ ÏƒÏÎ³ÎºÏÎ¹ÏƒÎ· Î¼Îµ',0),(21226,590,'zh','ç›¸æ¯”\r\n',0),(21227,590,'sv','JÃ¤mfÃ¶rt med',0),(21228,590,'it','Rispetto al',0),(21229,590,'tl','',0),(21230,590,'th','&#3648;&#3611;&#3619;&#3637;&#3618;&#3610;&#3648;&#3607;&#3637;&#3618;&#3610;&#3585;&#3633;&#3610;',0),(21231,590,'hi','à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾ à¤®à¥‡à¤‚',0),(21232,590,'ms','Berbanding dengan',0),(21233,590,'ar','Ø¨Ø§Ù„Ù…Ù‚Ø§Ø±Ù†Ø© Ù…Ø¹',0),(21234,590,'fr','Par rapport Ã ',0),(21235,590,'jp','æ¯”è¼ƒ',0),(21236,590,'pt','Em comparaÃ§Ã£o com',0),(21237,590,'ru','ÐŸÐ¾ ÑÑ€Ð°Ð²Ð½ÐµÐ½Ð¸ÑŽ Ñ',0),(21238,590,'es','En ComparaciÃ³n con',0),(21239,590,'de','Im Vergleich zu',0),(21240,590,'en','Compared to',0),(21241,591,'is','',0),(21242,591,'dr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† ',0),(21243,591,'pr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† ',0),(21244,591,'tr','Tamamlamak',0),(21245,591,'pl','Kompletny',0),(21246,591,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐ¸',0),(21247,591,'ur','Ù…Ú©Ù…Ù„',0),(21248,591,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐµ',0),(21249,591,'vi','HoÃ n táº¥t',0),(21250,591,'af','Voltooi',0),(21251,591,'ro','Completa',0),(21252,591,'et','Viia lÃµpule',0),(21253,591,'si','DokonÄanje',0),(21254,591,'ba','Menyelesaikan',0),(21255,591,'nl','Voltooien',0),(21256,591,'fi','TÃ¤ydellinen',0),(21257,591,'no','FullfÃ¸re',0),(21258,591,'da','Komplet',0),(21259,591,'ko','ì™„ë£Œ',0),(21260,591,'he','vuako',0),(21261,591,'el','ÎŸÎ»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ·',0),(21262,591,'zh','å®Œæˆ\r\n',0),(21263,591,'sv','Komplett',0),(21264,591,'it','Completare',0),(21265,591,'tl','',0),(21266,591,'th','&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(21267,591,'hi','à¤•à¥‹ à¤ªà¥‚à¤°à¤¾',0),(21268,591,'ms','Melengkapkan',0),(21269,591,'ar','Ø¥ÙƒÙ…Ø§Ù„',0),(21270,591,'fr','Toutes les',0),(21271,591,'jp','å®Œäº†',0),(21272,591,'pt','Completar',0),(21273,591,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ',0),(21274,591,'es','Completar',0),(21275,591,'de','AbschlieÃŸen',0),(21276,591,'en','Complete',0),(21277,592,'is','',0),(21278,592,'dr','(ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(21279,592,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ù…Ù„ (ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(21280,592,'tr','Tam Bill',0),(21281,592,'pl','Kompletny projekt ustawy',0),(21282,592,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð°',0),(21283,592,'ur','Ù…Ú©Ù…Ù„ Ø¨Ù„',0),(21284,592,'sr','ÐšÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð° Ð‘Ð¸Ð»',0),(21285,592,'vi','HoÃ n Táº¥t hÃ³a Ä‘Æ¡n',0),(21286,592,'af','Wetsontwerp voltooi',0),(21287,592,'ro','Completat de lege',0),(21288,592,'et','TÃ¤itke arve',0),(21289,592,'si','Popolna Bill',0),(21290,592,'ba','Menyelesaikan tagihan',0),(21291,592,'nl','Volledige Bill',0),(21292,592,'fi','TÃ¤ydellinen Bill',0),(21293,592,'no','Komplett Bill',0),(21294,592,'da','Komplet Bill',0),(21295,592,'ko','ì™„ì „ í•œ ë¹Œ',0),(21296,592,'he','×œ×”×©×œ×™× ××ª ×‘×™×œ',0),(21297,592,'el','Î Î»Î®ÏÎµÏ‚ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(21298,592,'zh','å®Œæˆå¸å•\r\n',0),(21299,592,'sv','Komplett Bill',0),(21300,592,'it','Bill completo',0),(21301,592,'tl','',0),(21302,592,'th','&#3651;&#3610;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(21303,592,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤•à¥‹ à¤ªà¥‚à¤°à¤¾',0),(21304,592,'ms','Rang undang-undang yang lengkap',0),(21305,592,'ar','Ø¥ÙƒÙ…Ø§Ù„ Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ†',0),(21306,592,'fr','Projet de loi complet',0),(21307,592,'jp','è«‹æ±‚æ›¸ã‚’å®Œæˆ?',0),(21308,592,'pt','Bill completo',0),(21309,592,'ru','ÐŸÐ¾Ð»Ð½Ð°Ñ Ð‘Ð¸Ð»Ð»',0),(21310,592,'es','Completar Factura',0),(21311,592,'de','Komplette Bill',0),(21312,592,'en','Complete Bill',0),(21313,593,'is','',0),(21314,593,'dr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† ÙØ§ÙƒØªÙˆØ±',0),(21315,593,'pr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† ÙØ§ÙƒØªÙˆØ±',0),(21316,593,'tr','FaturanÄ±n tamamÄ±',0),(21317,593,'pl','Faktur',0),(21318,593,'bg','ÐŸÑŠÐ»Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(21319,593,'ur','Ù…Ú©Ù…Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(21320,593,'sr','ÐšÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(21321,593,'vi','HÃ³a Ä‘Æ¡n hoÃ n thÃ nh',0),(21322,593,'af','Voltooide Faktuur',0),(21323,593,'ro','Complet facturÄƒ',0),(21324,593,'et','TÃ¤itke arve',0),(21325,593,'si','DokonÄanje raÄuna',0),(21326,593,'ba','Lengkap faktur',0),(21327,593,'nl','Volledige factuur',0),(21328,593,'fi','Laskun tÃ¤ydellisen',0),(21329,593,'no','Fullstendig faktura',0),(21330,593,'da','Komplet faktura',0),(21331,593,'ko','ì™„ì „ í•œ ì†¡ìž¥',0),(21332,593,'he','×œ×”×©×œ×™× ××ª ×”×—×©×‘×•× ×™×ª',0),(21333,593,'el','Î Î»Î®ÏÎµÏ‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(21334,593,'zh','å®Œæˆå‘ç¥¨\r\n',0),(21335,593,'sv','FullstÃ¤ndig faktura',0),(21336,593,'it','Fattura completa',0),(21337,593,'tl','',0),(21338,593,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(21339,593,'hi','à¤ªà¥‚à¤°à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(21340,593,'ms','Invois yang lengkap',0),(21341,593,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙƒØ§Ù…Ù„Ø©',0),(21342,593,'fr','Facture complÃ¨te',0),(21343,593,'jp','è«‹æ±‚å®Œäº†',0),(21344,593,'pt','Fatura completa',0),(21345,593,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚',0),(21346,593,'es','Completar Factura',0),(21347,593,'de','Komplette Rechnung',0),(21348,593,'en','Complete Invoice',0),(21349,594,'is','',0),(21350,594,'dr','( Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ù…Ù„ ',0),(21351,594,'pr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª ( Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ù…Ù„ ',0),(21352,594,'tr','Tam Ã¶deme',0),(21353,594,'pl','Dokonaj pÅ‚atnoÅ›ci',0),(21354,594,'bg','ÐŸÑŠÐ»Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(21355,594,'ur','Ù…Ú©Ù…Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(21356,594,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(21357,594,'vi','Thanh toÃ¡n hoÃ n thÃ nh',0),(21358,594,'af','Volledige Betaling',0),(21359,594,'ro','PlatÄƒ completÄƒ',0),(21360,594,'et','TÃ¤ies ulatuses makse',0),(21361,594,'si','DokonÄno plaÄilo',0),(21362,594,'ba','Menyelesaikan pembayaran',0),(21363,594,'nl','Volledige betaling',0),(21364,594,'fi','Maksettu',0),(21365,594,'no','Helt',0),(21366,594,'da','Komplet betaling',0),(21367,594,'ko','ê²°ì œ ì™„ë£Œ',0),(21368,594,'he','×ª×©×œ×•× ×ž×œ×',0),(21369,594,'el','ÎŸÎ»Î¿ÎºÎ»Î·ÏÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î®',0),(21370,594,'zh','å®Œæˆä»˜æ¬¾\r\n',0),(21371,594,'sv','Full betalning',0),(21372,594,'it','Completare il pagamento',0),(21373,594,'tl','',0),(21374,594,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(21375,594,'hi','à¤ªà¥‚à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(21376,594,'ms','Melengkapkan pembayaran',0),(21377,594,'ar','Ø¥ÙƒÙ…Ø§Ù„ Ø§Ù„Ø¯ÙØ¹',0),(21378,594,'fr','Paiement complet',0),(21379,594,'jp','æ”¯æ‰•ã?„å®Œäº†',0),(21380,594,'pt','Pagamento completo',0),(21381,594,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶',0),(21382,594,'es','Completar Pago',0),(21383,594,'de','VollstÃ¤ndigen Bezahlung',0),(21384,594,'en','Complete Payment',0),(21385,595,'is','',0),(21386,595,'dr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(21387,595,'pr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(21388,595,'tr','Tam PO',0),(21389,595,'pl','Kompletne PO',0),(21390,595,'bg','ÐŸÑŠÐ»Ð½Ð° PO',0),(21391,595,'ur','Ù…Ú©Ù…Ù„ Ù¾Ùˆ',0),(21392,595,'sr','ÐšÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½ ÐŸÐž',0),(21393,595,'vi','ÄÆ¡n mua hÃ ng hoÃ n thÃ nh',0),(21394,595,'af','Voltooi AB',0),(21395,595,'ro','Complet PO',0),(21396,595,'et','TÃ¤ielik PO',0),(21397,595,'si','Celoten PO',0),(21398,595,'ba','Lengkap PO',0),(21399,595,'nl','Volledige PO',0),(21400,595,'fi','TÃ¤ydellinen PO',0),(21401,595,'no','Komplett PO',0),(21402,595,'da','Komplet PO',0),(21403,595,'ko','ì™„ì „ í•œ í¬',0),(21404,595,'he','×¤×• ×”×©×œ×',0),(21405,595,'el','Î Î»Î®ÏÎ·Ï‚ PO',0),(21406,595,'zh','å®Œæˆè®¢å•\r\n',0),(21407,595,'sv','Komplett PO',0),(21408,595,'it','PO completa',0),(21409,595,'tl','',0),(21410,595,'th','&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(21411,595,'hi','à¤ªà¥‚à¤°à¤¾ à¤ªà¥‹',0),(21412,595,'ms','Melengkapkan PO',0),(21413,595,'ar','Øµ. Ø¨ ÙƒØ§Ù…Ù„Ø©',0),(21414,595,'fr','PO complet',0),(21415,595,'jp','POã‚’å®Œäº†',0),(21416,595,'pt','PO completa',0),(21417,595,'ru','ÐŸÐ¾Ð»Ð½Ð°Ñ PO',0),(21418,595,'es','Completar OC',0),(21419,595,'de','Komplette PO',0),(21420,595,'en','Complete PO',0),(21421,596,'is','',0),(21422,596,'dr','ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(21423,596,'pr','ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(21424,596,'tr','TamamlandÄ±',0),(21425,596,'pl','ZakoÅ„czone',0),(21426,596,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð°',0),(21427,596,'ur','Ù…Ú©Ù…Ù„',0),(21428,596,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾',0),(21429,596,'vi','ÄÃ£ hoÃ n thÃ nh',0),(21430,596,'af','Voltooid',0),(21431,596,'ro','Finalizat',0),(21432,596,'et','LÃµpetatud',0),(21433,596,'si','DokonÄana',0),(21434,596,'ba','Selesai',0),(21435,596,'nl','Voltooid',0),(21436,596,'fi','Valmis',0),(21437,596,'no','FullfÃ¸rt',0),(21438,596,'da','Afsluttet',0),(21439,596,'ko','ì™„ë£Œ',0),(21440,596,'he','×”×•×©×œ×',0),(21441,596,'el','ÎŸÎ»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(21442,596,'zh','å·²å®Œæˆ\r\n',0),(21443,596,'sv','Avslutade',0),(21444,596,'it','Completato',0),(21445,596,'tl','',0),(21446,596,'th','&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;',0),(21447,596,'hi','à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹',0),(21448,596,'ms','Siap dibina',0),(21449,596,'ar','Ù…Ù†Ø¬Ø²',0),(21450,596,'fr','TerminÃ©',0),(21451,596,'jp','å®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(21452,596,'pt','ConcluÃ­do',0),(21453,596,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ',0),(21454,596,'es','Completado',0),(21455,596,'de','Abgeschlossen',0),(21456,596,'en','Completed',0),(21457,597,'is','',0),(21458,597,'dr','Ø§Ø¬Ø²Ø§Ø¡ ÙƒØ§Ù„Ø§',0),(21459,597,'pr','Ø§Ø¬Ø²Ø§Ø¡ ÙƒØ§Ù„Ø§',0),(21460,597,'tr','BileÅŸen maddesi',0),(21461,597,'pl','SkÅ‚adnik elementu',0),(21462,597,'bg','ÐšÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚ Ð¾Ñ‚ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(21463,597,'ur','Ø¬Ø²Ùˆ Ø´Û’',0),(21464,597,'sr','ÐšÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(21465,597,'vi','ThÃ nh pháº§n hÃ ng',0),(21466,597,'af','Saamgestelde Item',0),(21467,597,'ro','Element component',0),(21468,597,'et','Koostiskauba',0),(21469,597,'si','Artikel komponente',0),(21470,597,'ba','Komponen Item',0),(21471,597,'nl','Onderdeel',0),(21472,597,'fi','Komponenttinimikkeen',0),(21473,597,'no','Komponentvare',0),(21474,597,'da','Komponentvare',0),(21475,597,'ko','êµ¬ì„± ìš”ì†Œ í•­ëª©',0),(21476,597,'he','×¨×›×™×‘ ×¤×¨×™×˜',0),(21477,597,'el','Î£Ï…ÏƒÏ„Î±Ï„Î¹ÎºÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(21478,597,'zh','ç»„ä»¶é¡¹ç›®\r\n',0),(21479,597,'sv','Komponent',0),(21480,597,'it','Articolo componente',0),(21481,597,'tl','',0),(21482,597,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(21483,597,'hi','à¤˜à¤Ÿà¤• à¤†à¤‡à¤Ÿà¤®',0),(21484,597,'ms','Komponen Item',0),(21485,597,'ar','Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„Ù…ÙƒÙˆÙ†',0),(21486,597,'fr','Article composant',0),(21487,597,'jp','æ§‹æˆ?å“?ç›®',0),(21488,597,'pt','Item componente',0),(21489,597,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚',0),(21490,597,'es','Item Componente',0),(21491,597,'de','Betreffende Element',0),(21492,597,'en','Component Item',0),(21493,598,'is','',0),(21494,598,'dr','Ø§Ø¬Ø²Ø§Ø¡ ÙƒØ§Ù„Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(21495,598,'pr','Ø§Ø¬Ø²Ø§Ø¡ ÙƒØ§Ù„Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(21496,598,'tr','SeÃ§ili bileÅŸen maddeleri',0),(21497,598,'pl','Elementy skÅ‚adnika juÅ¼ wybrane',0),(21498,598,'bg','ÐšÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚ Ð²ÐµÑ‡Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(21499,598,'ur','Ø¬Ø²Ùˆ ØªØ±Ú©ÛŒØ¨ Ú©Û’ Ø§Ø´ÛŒØ§Ø¡ Ú©Ùˆ Ù¾ÛÙ„Û’ ÛÛŒ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§',0),(21500,598,'sr','ÐšÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ñ˜Ðµ Ð²ÐµÑ› Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½',0),(21501,598,'vi','ÄÃ£ chá»n ThÃ nh pháº§n hÃ ng',0),(21502,598,'af','Saamgestelde Items Alreeds Gekies',0),(21503,598,'ro','Componenta elemente deja selectate',0),(21504,598,'et','Juba valitud koostiskaupade',0),(21505,598,'si','Komponenta Å¾e izbranih elementov',0),(21506,598,'ba','Item komponen yang sudah dipilih',0),(21507,598,'nl','Onderdelen al geselecteerd',0),(21508,598,'fi','Komponenttinimikkeiden valittuna',0),(21509,598,'no','Komponentvarer allerede valgt',0),(21510,598,'da','Komponentvarer allerede valgt',0),(21511,598,'ko','ì´ë¯¸ ì„ íƒ ëœ êµ¬ì„± ìš”ì†Œ í•­ëª©',0),(21512,598,'he','×¨×›×™×‘ ×¤×¨×™×˜×™× ×›×‘×¨ × ×‘×—×¨',0),(21513,598,'el','Î£Ï…ÏƒÏ„Î±Ï„Î¹ÎºÎ¬ ÎµÎ¯Î´Î· Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î®Î´Î· ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯',0),(21514,598,'zh','ç»„ä»¶é¡¹ç›®å·²é€‰å®š\r\n',0),(21515,598,'sv','Komponentartiklar som redan valts',0),(21516,598,'it','Componente articoli giÃ  selezionati',0),(21517,598,'tl','',0),(21518,598,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3614;&#3619;&#3657;&#3629;&#3617;&#3606;&#3641;&#3585;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(21519,598,'hi','à¤˜à¤Ÿà¤• à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤šà¤¯à¤¨à¤¿à¤¤ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(21520,598,'ms','Komponen item-item yang telah dipilih',0),(21521,598,'ar','Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…ÙƒÙˆÙ†Ø§Øª Ø§Ù„Ù…Ø­Ø¯Ø¯Ø© Ø¨Ø§Ù„ÙØ¹Ù„',0),(21522,598,'fr','Articles de composants dÃ©jÃ  sÃ©lectionnÃ©s',0),(21523,598,'jp','æ§‹æˆ?å“?ç›®ã?¯ã?™ã?§ã?«é?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(21524,598,'pt','Componente itens jÃ¡ selecionados',0),(21525,598,'ru','Ð£Ð¶Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð°',0),(21526,598,'es','Items de Componente Ya Seleccionados',0),(21527,598,'de','Bereits ausgewÃ¤hlten Komponentenelemente',0),(21528,598,'en','Component Items Already Selected',0),(21529,599,'is','',0),(21530,599,'dr','(Ù…Ø®Ù„ÙˆØ·',0),(21531,599,'pr','Ù…Ø±ÙƒØ¨(Ù…Ø®Ù„ÙˆØ·',0),(21532,599,'tr','Kompozit',0),(21533,599,'pl','Kompozytowe',0),(21534,599,'bg','ÐšÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚',0),(21535,599,'ur','Ù…Ø±Ú©Ø¨',0),(21536,599,'sr','ÐšÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(21537,599,'vi','Nhá»±a Composite',0),(21538,599,'af','Saamgestelde',0),(21539,599,'ro','Compozit',0),(21540,599,'et','Komposiit',0),(21541,599,'si','Kompozitni',0),(21542,599,'ba','Komposit',0),(21543,599,'nl','Composiet',0),(21544,599,'fi','Komposiitti',0),(21545,599,'no','Kompositt',0),(21546,599,'da','Composite',0),(21547,599,'ko','í•©ì„±',0),(21548,599,'he','×œ×œ× ×”×¤×¨×“×•×ª ×¦×‘×¢',0),(21549,599,'el','Î£ÏÎ½Î¸ÎµÏ„Î¿',0),(21550,599,'zh','ç»¼åˆ\r\n',0),(21551,599,'sv','Komposit',0),(21552,599,'it','Composito',0),(21553,599,'tl','',0),(21554,599,'th','&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3604;&#3657;&#3623;&#3618;',0),(21555,599,'hi','à¤•à¤®à¥à¤ªà¥‹à¤œà¤¿à¤Ÿ',0),(21556,599,'ms','Komposit',0),(21557,599,'ar','Ù…Ø±ÙƒÙ‘Ø¨',0),(21558,599,'fr','Composite',0),(21559,599,'jp','è¤‡å?ˆ',0),(21560,599,'pt','Composto',0),(21561,599,'ru','ÐšÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹',0),(21562,599,'es','Compuesto',0),(21563,599,'de','Composite',0),(21564,599,'en','Composite',0),(21565,600,'is','',0),(21566,600,'dr','ÙƒØ§Ù„Ø§ÙŠ Ù…Ø±ÙƒØ¨',0),(21567,600,'pr','ÙƒØ§Ù„Ø§ÙŠ Ù…Ø±ÙƒØ¨',0),(21568,600,'tr','BileÅŸik madde',0),(21569,600,'pl','Element zÅ‚oÅ¼ony',0),(21570,600,'bg','Ð¡ÑŠÑÑ‚Ð°Ð²ÐµÐ½ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(21571,600,'ur','Ø¬Ø§Ù…Ø¹ Ø´Û’',0),(21572,600,'sr','ÐšÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(21573,600,'vi','HÃ ng Composite',0),(21574,600,'af','Saamgestelde Item',0),(21575,600,'ro','Element de compozit',0),(21576,600,'et','Kombineeritud kaup',0),(21577,600,'si','Kompozitni element',0),(21578,600,'ba','Komposit Item',0),(21579,600,'nl','Samengestelde Item',0),(21580,600,'fi','Yhdistetty kohde',0),(21581,600,'no','Sammensatt element',0),(21582,600,'da','Sammensat element',0),(21583,600,'ko','ë³µí•© í•­ëª©',0),(21584,600,'he','×¤×¨×™×˜ ×œ×œ× ×”×¤×¨×“×•×ª ×¦×‘×¢',0),(21585,600,'el','Î£ÏÎ½Î¸ÎµÏ„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(21586,600,'zh','ç»¼åˆé¡¹ç›®\r\n',0),(21587,600,'sv','Sammansatt objekt',0),(21588,600,'it','Elemento composito',0),(21589,600,'tl','',0),(21590,600,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3604;&#3657;&#3623;&#3618;',0),(21591,600,'hi','à¤•à¤®à¥à¤ªà¥‹à¤œà¤¿à¤Ÿ à¤†à¤‡à¤Ÿà¤®',0),(21592,600,'ms','Butiran Komposit',0),(21593,600,'ar','ØµÙ†Ù Ù…Ø±ÙƒÙ‘Ø¨',0),(21594,600,'fr','Ã‰lÃ©ment composite',0),(21595,600,'jp','è¤‡å?ˆå“?ç›®',0),(21596,600,'pt','Item composto',0),(21597,600,'ru','ÐšÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(21598,600,'es','Item Compuesto',0),(21599,600,'de','Zusammengesetzte Element',0),(21600,600,'en','Composite Item',0),(21601,601,'is','',0),(21602,601,'dr','Ù„ÙŠØ³Øª Ø§Ø¬Ø²Ø§Ø¡  ÙƒØ§Ù„Ø§ÙŠ Ù…Ø±ÙƒØ¨ Ø¨Ø±Ø§ÙŠ',0),(21603,601,'pr','Ù„ÙŠØ³Øª Ø§Ø¬Ø²Ø§Ø¡  ÙƒØ§Ù„Ø§ÙŠ Ù…Ø±ÙƒØ¨ Ø¨Ø±Ø§ÙŠ',0),(21604,601,'tr','BileÅŸik maddesi bileÅŸen listesi iÃ§in',0),(21605,601,'pl','SkÅ‚adnik zÅ‚oÅ¼ony element listy',0),(21606,601,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¸ Ð½Ð° ÑÑŠÑÑ‚Ð°Ð²Ð½Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð°',0),(21607,601,'ur','Ø¬Ø§Ù…Ø¹ Ø´Û’ Ø¬Ø²Ùˆ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’',0),(21608,601,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¸ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¸Ñ… Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð·Ð°',0),(21609,601,'vi','Danh sÃ¡ch thÃ nh pháº§n hÃ ng Composite cho',0),(21610,601,'af','Saamgestelde Item Komponentlys vir',0),(21611,601,'ro','Compozit element lista de componente pentru',0),(21612,601,'et','Komposiit HooldusÃ¼ks. komponentide loend jaoks',0),(21613,601,'si','Seznam komponent kompozitni element za',0),(21614,601,'ba','Daftar komponen komposit Item untuk',0),(21615,601,'nl','Lijst van de Component van de samengestelde Item voor',0),(21616,601,'fi','Komposiitti nimikkeen osan luettelo',0),(21617,601,'no','Sammensatt oversikt over servicevarekomponenter for',0),(21618,601,'da','Sammensat komponent elementlisten for',0),(21619,601,'ko','ë³µí•© í•­ëª© êµ¬ì„± ìš”ì†Œ ëª©ë¡',0),(21620,601,'he','×¨×©×™×ž×ª ×¤×¨×™×˜×™× ×œ×œ× ×”×¤×¨×“×•×ª ×¦×‘×¢ ×¨×›×™×‘ ×¢×‘×•×¨',0),(21621,601,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î£Ï…Î½Î±ÏÎ¼Î¿Î»Î¿Î³Î·Î¼Î¬Ï„Ï‰Î½ ÏƒÏÎ½Î¸ÎµÏ„Î± ÎµÎ¹Î´ÏŽÎ½ Î³Î¹Î±',0),(21622,601,'zh','ç»¼åˆé¡¹ç›®ç»„ä»¶ç›®å½•\r\n',0),(21623,601,'sv','Sammansatta Serviceartikelkomponent lista fÃ¶r',0),(21624,601,'it','Elenco di elementi compositi di componente per',0),(21625,601,'tl','',0),(21626,601,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3604;&#3657;&#3623;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3586;&#3',0),(21627,601,'hi','à¤•à¤®à¥à¤ªà¥‹à¤œà¤¿à¤Ÿ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‚à¤šà¥€ à¤˜à¤Ÿà¤•',0),(21628,601,'ms','Senarai komponen komposit Item untuk',0),(21629,601,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¹Ù†ØµØ± Ø¹Ù†ØµØ± Ù…Ø±ÙƒØ¨',0),(21630,601,'fr','Liste de composant d\'Ã©lÃ©ments composites pour',0),(21631,601,'jp','è¤‡å?ˆå“?ç›®æ§‹æˆ?ãƒªã‚¹ãƒˆ',0),(21632,601,'pt','Lista de componente Item composto por',0),(21633,601,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¾Ð² ÑÐ¾ÑÑ‚Ð°Ð²Ð½Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð´Ð»Ñ',0),(21634,601,'es','Lista de Componentes de Item Compuesto para',0),(21635,601,'de','Zusammengesetzte Komponente Artikelliste fÃ¼r',0),(21636,601,'en','Composite Item Component List for',0),(21637,602,'is','',0),(21638,602,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…Ø±ÙƒØ¨',0),(21639,602,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…Ø±ÙƒØ¨',0),(21640,602,'tr','BileÅŸik madde arama',0),(21641,602,'pl','ZÅ‚oÅ¼ony element wyszukiwania',0),(21642,602,'bg','Ð¡ÑŠÑÑ‚Ð°Ð²Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¢ÑŠÑ€ÑÐµÐ½Ðµ',0),(21643,602,'ur','Ø¬Ø§Ù…Ø¹ Ø´Û’ Ú©ÛŒ ØªÙ„Ø§Ø´',0),(21644,602,'sr','Ð¢Ñ€Ð°Ð¶ÐµÑšÐµ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¸Ñ… Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(21645,602,'vi','TÃ¬m hÃ ng Composite',0),(21646,602,'af','Soek Saamgestelde Item',0),(21647,602,'ro','Compozit element cÄƒutare',0),(21648,602,'et','Komposiit Ã¼ksuse otsing',0),(21649,602,'si','IÅ¡Äi sestavljenega artikla',0),(21650,602,'ba','Cari Item komposit',0),(21651,602,'nl','Samengestelde Item zoeken',0),(21652,602,'fi','Komposiitti tuote haku',0),(21653,602,'no','Sammensatt elementet sÃ¸k',0),(21654,602,'da','Sammensat vare sÃ¸gning',0),(21655,602,'ko','ë³µí•© í•­ëª© ê²€ìƒ‰',0),(21656,602,'he','×—×¤×© ×¤×¨×™×˜ ×œ×œ× ×”×¤×¨×“×•×ª ×¦×‘×¢',0),(21657,602,'el','Î£ÏÎ½Î¸ÎµÏ„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(21658,602,'zh','ç»¼åˆå•†å“æ£€ç´¢\r\n',0),(21659,602,'sv','Sammansatt objekt sÃ¶kning',0),(21660,602,'it','Ricerca elemento composito',0),(21661,602,'tl','',0),(21662,602,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3604;&#3657;&#3623;&#3618;',0),(21663,602,'hi','à¤•à¤®à¥à¤ªà¥‹à¤œà¤¿à¤Ÿ à¤†à¤‡à¤Ÿà¤® à¤–à¥‹à¤œà¥‡à¤‚',0),(21664,602,'ms','Cari Item Komposit',0),(21665,602,'ar','Ø¨Ø­Ø« Ø§Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø±ÙƒÙ‘Ø¨Ø©',0),(21666,602,'fr','Recherche de l\'Ã©lÃ©ment composite',0),(21667,602,'jp','è¤‡å?ˆå“?ç›®ã?®æ¤œç´¢',0),(21668,602,'pt','Pesquisa de Item composto',0),(21669,602,'ru','ÐŸÐ¾Ð¸ÑÐº ÑÐ¾ÑÑ‚Ð°Ð²Ð½Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(21670,602,'es','Busqueda de Item Compuesto',0),(21671,602,'de','Zusammengesetzte Artikelsuche',0),(21672,602,'en','Composite Item Search',0),(21673,603,'is','',0),(21674,603,'dr','( Ù…Ø«Ù„ ÙŠÙƒ Ø§Ø«Ø§Ø«Ù‡ ÙŠØ§ ÙÙ‡Ø±Ø³Øª',0),(21675,603,'pr','ÙƒØ§Ù„Ø§ÙŠ Ù…Ø±ÙƒØ¨ ( Ù…Ø«Ù„ ÙŠÙƒ Ø§Ø«Ø§Ø«Ù‡ ÙŠØ§ ÙÙ‡Ø±Ø³Øª',0),(21676,603,'tr','BileÅŸik Ã¶ÄŸe:<br><small>(kit, katalog, vs.)</small>',0),(21677,603,'pl','Element zÅ‚oÅ¼ony:<br><small>(zestaw, katalog, itp.)</small>',0),(21678,603,'bg','Ð¡ÑŠÑÑ‚Ð°Ð²Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°:<br><small>(ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚, ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð¸ Ð´Ñ€.)</small>',0),(21679,603,'ur','Ø¬Ø§Ù…Ø¹ Ø´Û’:<br><small>(Ú©Ù¹ØŒ Ø³ØªØŒ ÙˆØºÛŒØ±Û)</small>',0),(21680,603,'sr','ÐšÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°:<br><small>(Ð¿Ñ€Ð¸Ð±Ð¾Ñ€ , ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³Ð° Ð¸Ñ‚Ð´.)</small>',0),(21681,603,'vi','HÃ ng Composite (nhÆ° catalog hay tÃºi Ä‘á»±ng',0),(21682,603,'af','Saamgestelde Item (soos \'n stel of katalogus)',0),(21683,603,'ro','Element compozit:<br><small>(kit, catalog, etc.)</small>',0),(21684,603,'et','Kombineeritud kaup:<br><small>(kit, kataloog)</small>',0),(21685,603,'si','Kompozitni element:<br><small>(kit, katalog, itd.)</small>',0),(21686,603,'ba','Komposit Item:<br><small>(kit, Katalog, dll.)</small>',0),(21687,603,'nl','Samengestelde Item:<br><small>(kit, winkel, enz.)</small>',0),(21688,603,'fi','Komposiitti kohta:<br><small>(kit, Verkkokauppa, jne.)</small>',0),(21689,603,'no','Sammensatt element:<br><small>(kit, katalog, etc.)</small>',0),(21690,603,'da','Sammensat element:<br><small>(kit, butik, etc.)</small>',0),(21691,603,'ko','ë³µí•© í•­ëª©:<br><small>(í‚¤íŠ¸, ì¹´íƒˆë¡œê·¸ ë“±)</small>',0),(21692,603,'he','×¤×¨×™×˜ ×ž×•×¨×›×‘:<br><small>(×¢×¨×›×ª, ×§×˜×œ×•×’, ×•×›×• \'.)</small>',0),(21693,603,'el','Î£ÏÎ½Î¸ÎµÏ„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿:<br><small>(ÎµÎ¾Î¬ÏÏ„Î·ÏƒÎ·, ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚, ÎºÎ»Ï€.)</small>',0),(21694,603,'zh','ç»¼åˆé¡¹ç›®ï¼ˆå¦‚ä¸€ä¸ªå·¥å…·åŒ…æˆ–ç›®å½•ï¼‰\r\n',0),(21695,603,'sv','Sammansatt objekt:<br><small>(kit, katalog, etc.)</small>',0),(21696,603,'it','Elemento composito:<br><small>(kit, catalogo, ecc.)</small>',0),(21697,603,'tl','',0),(21698,603,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3604;&#3657;&#3623;&#3618;(&#3648;&#3594;&#3656;&#3609; &#3594;&#3640;&#3604; &#3627;&#3619;&#3639;&#3629; &#3649;&#3588;&#3655;&#3605;&#3605;&#3634;&#3621;&#3655;&#3629',0),(21699,603,'hi','à¤•à¤®à¥à¤ªà¥‹à¤œà¤¿à¤Ÿ à¤†à¤‡à¤Ÿà¤®:<br><small>(à¤•à¤¿à¤Ÿ, à¤•à¥ˆà¤Ÿà¤²à¥‰à¤—, à¤†à¤¦à¤¿.)</small>',0),(21700,603,'ms','Komposit Item:<br><small>(kit, Katalog, dll.)</small>',0),(21701,603,'ar','ØµÙ†Ù Ù…Ø±ÙƒÙ‘Ø¨',0),(21702,603,'fr','Ã‰lÃ©ment composite :<br><small>(kit, catalogue, etc.).</small>',0),(21703,603,'jp','è¤‡å?ˆå“?ç›®ï¼ˆã‚­ãƒƒãƒˆã‚„ã‚«ã‚¿ãƒ­ã‚°ã?ªã?©ï¼‰',0),(21704,603,'pt','Item composto:<br><small>(kit, catÃ¡logo, etc.)</small>',0),(21705,603,'ru','Ð¡Ð¾ÑÑ‚Ð°Ð²Ð½Ð¾Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚:<br><small>(ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚, ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð¸ Ñ‚.Ð´.)</small>',0),(21706,603,'es','Item Compuesto (como un kit o catÃ¡logo)',0),(21707,603,'de','Zusammengesetzte Element:<br><small>(Kit, Katalog usw.).</small>',0),(21708,603,'en','Composite Item:<br><small>(kit, catalog, etc.)</small>',0),(21709,604,'is','',0),(21710,604,'dr','ØªØ§ÙŠÙŠØ¯ ',0),(21711,604,'pr','ØªØ§ÙŠÙŠØ¯ ',0),(21712,604,'tr','Onayla',0),(21713,604,'pl','PotwierdziÄ‡',0),(21714,604,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ',0),(21715,604,'ur','ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(21716,604,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸',0),(21717,604,'vi','XÃ¡c nháº­n',0),(21718,604,'af','Bevestig',0),(21719,604,'ro','Confirma',0),(21720,604,'et','Kinnita',0),(21721,604,'si','Potrditev',0),(21722,604,'ba','Konfirmasi',0),(21723,604,'nl','Bevestigen',0),(21724,604,'fi','Vahvista',0),(21725,604,'no','Bekrefte',0),(21726,604,'da','BekrÃ¦fte',0),(21727,604,'ko','í™•ì¸',0),(21728,604,'he','×œ××©×¨',0),(21729,604,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·',0),(21730,604,'zh','ç¡®è®¤\r\n',0),(21731,604,'sv','BekrÃ¤fta',0),(21732,604,'it','Confermare',0),(21733,604,'tl','',0),(21734,604,'th','&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(21735,604,'hi','à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(21736,604,'ms','Mengesahkan',0),(21737,604,'ar','Ø§Ù„ØªØ£ÙƒÙŠØ¯',0),(21738,604,'fr','Confirmer',0),(21739,604,'jp','ç¢ºèª?',0),(21740,604,'pt','Confirmar',0),(21741,604,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ',0),(21742,604,'es','Confirmar',0),(21743,604,'de','BestÃ¤tigen',0),(21744,604,'en','Confirm',0),(21745,605,'is','',0),(21746,605,'dr','ØªÙ…Ø§Ø³ ',0),(21747,605,'pr','ØªÙ…Ø§Ø³ ',0),(21748,605,'tr','Ä°lgili kiÅŸi',0),(21749,605,'pl','Kontakt',0),(21750,605,'bg','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(21751,605,'ur','Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯',0),(21752,605,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(21753,605,'vi','LiÃªn há»‡',0),(21754,605,'af','Kontak',0),(21755,605,'ro','PersoanÄƒ de contact',0),(21756,605,'et','Kontakt',0),(21757,605,'si','Stik',0),(21758,605,'ba','Kontak',0),(21759,605,'nl','Contact',0),(21760,605,'fi','Yhteystiedot',0),(21761,605,'no','Kontakt',0),(21762,605,'da','Kontakt',0),(21763,605,'ko','ì—°ë½ì²˜',0),(21764,605,'he','×¦×•×¨ ×§×©×¨',0),(21765,605,'el','Î•Ï€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±',0),(21766,605,'zh','è”ç³»æ–¹å¼\r\n',0),(21767,605,'sv','Kontakt',0),(21768,605,'it','Contatto',0),(21769,605,'tl','',0),(21770,605,'th','&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(21771,605,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤•',0),(21772,605,'ms','Orang hubungan',0),(21773,605,'ar','Ø§Ù„Ø¥ØªØµØ§Ù„',0),(21774,605,'fr','Contact',0),(21775,605,'jp','é€£çµ¡å…ˆ',0),(21776,605,'pt','Contato',0),(21777,605,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(21778,605,'es','Contacto',0),(21779,605,'de','Kontakt',0),(21780,605,'en','Contact',0),(21781,606,'is','',0),(21782,606,'dr','Ù†Ø§Ù… ØªÙ…Ø§Ø³ ',0),(21783,606,'pr','Ù†Ø§Ù… ØªÙ…Ø§Ø³ ',0),(21784,606,'tr','KiÅŸi adÄ±',0),(21785,606,'pl','Nazwa kontaktu',0),(21786,606,'bg','Ð˜Ð¼Ðµ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(21787,606,'ur','Ù†Ø§Ù… Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯',0),(21788,606,'sr','Ð˜Ð¼Ðµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð°',0),(21789,606,'vi','TÃªn liÃªn há»‡',0),(21790,606,'af','Kontak Naam',0),(21791,606,'ro','Numele persoanei de contact',0),(21792,606,'et','Kontaktisiku nimi',0),(21793,606,'si','Ime stika',0),(21794,606,'ba','Nama kontak',0),(21795,606,'nl','De naam van contactpersoon',0),(21796,606,'fi','YhteyshenkilÃ¶n nimi',0),(21797,606,'no','Navn pÃ¥ kontakt',0),(21798,606,'da','Navn pÃ¥ kontaktperson',0),(21799,606,'ko','ì—°ë½ì²˜ ì´ë¦„',0),(21800,606,'he','×©× ××™×© ×§×©×¨',0),(21801,606,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏ€Î±Ï†Î®Ï‚',0),(21802,606,'zh','è”ç³»äººå§“å\r\n',0),(21803,606,'sv','Kontaktens namn',0),(21804,606,'it','Nome del contatto',0),(21805,606,'tl','',0),(21806,606,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(21807,606,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤¨à¤¾à¤®',0),(21808,606,'ms','Nama kenalan',0),(21809,606,'ar','Ø¥Ø³Ù… Ø§Ù„Ø¥ØªØµØ§Ù„',0),(21810,606,'fr','Personne-ressource',0),(21811,606,'jp','é€£çµ¡å…ˆå??',0),(21812,606,'pt','Nome de contato',0),(21813,606,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð¾Ðµ Ð›Ð¸Ñ†Ð¾',0),(21814,606,'es','Nombre de Contacto',0),(21815,606,'de','Kontaktnamen',0),(21816,606,'en','Contact Name',0),(21817,607,'is','',0),(21818,607,'dr','Ø§Ø¯Ø§Ù…Ù‡ Ø¨Ø¯Ù‡ÙŠØ¯ ',0),(21819,607,'pr','Ø§Ø¯Ø§Ù…Ù‡ Ø¨Ø¯Ù‡ÙŠØ¯ ',0),(21820,607,'tr','Devam etmek',0),(21821,607,'pl','W dalszym ciÄ…gu',0),(21822,607,'bg','ÐŸÑ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸',0),(21823,607,'ur','Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾ÛŒÚº',0),(21824,607,'sr','ÐÐ°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ',0),(21825,607,'vi','Tiáº¿p tá»¥c',0),(21826,607,'af','Gaan Voort',0),(21827,607,'ro','Continua',0),(21828,607,'et','JÃ¤tkata',0),(21829,607,'si','Å e',0),(21830,607,'ba','Lanjutkan',0),(21831,607,'nl','Blijven',0),(21832,607,'fi','Jatka',0),(21833,607,'no','Fortsett',0),(21834,607,'da','Fortsat',0),(21835,607,'ko','ê³„ì† í•´ ì„œ',0),(21836,607,'he','×”×ž×©×š',0),(21837,607,'el','Î£Ï…Î½ÎµÏ‡Î¯ÏƒÎµÎ¹',0),(21838,607,'zh','ç»§ç»­\r\n',0),(21839,607,'sv','FortsÃ¤tta',0),(21840,607,'it','Continuare',0),(21841,607,'tl','',0),(21842,607,'th','&#3605;&#3656;&#3629;&#3652;&#3611;',0),(21843,607,'hi','à¤œà¤¾à¤°à¥€ à¤°à¤–à¥‡à¤‚',0),(21844,607,'ms','Terus',0),(21845,607,'ar','Ø¥Ø³ØªÙ…Ø±',0),(21846,607,'fr','Continuer',0),(21847,607,'jp','ç¶šã?‘ã‚‹',0),(21848,607,'pt','Continuar',0),(21849,607,'ru','Ð—Ð°ÐºÐ¾Ð½Ñ‡Ð¸Ñ‚ÑŒ',0),(21850,607,'es','Continuar',0),(21851,607,'de','Weiter',0),(21852,607,'en','Continue',0),(21853,608,'is','',0),(21854,608,'dr','Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÙŠØ¯ Ùˆ Ø°Ø®ÙŠØ±Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(21855,608,'pr','Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÙŠØ¯ Ùˆ Ø°Ø®ÙŠØ±Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(21856,608,'tr','Devam etmek ve kaydetmek',0),(21857,608,'pl','W dalszym ciÄ…gu i zapisaÄ‡',0),(21858,608,'bg','ÐŸÑ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸ Ð¸ Ð—Ð°Ð¿Ð¸ÑˆÐ¸',0),(21859,608,'ur','Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾ÛŒÚº Ø§ÙˆØ± Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(21860,608,'sr','ÐÐ°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¸ ÑÐ°Ñ‡ÑƒÐ²Ð°Ñ‚Ðµ',0),(21861,608,'vi','Tiáº¿p tá»¥c & sao lÆ°u',0),(21862,608,'af','GAAN VOORT en Stoor',0),(21863,608,'ro','ÃŽn continuare ÅŸi de a salva',0),(21864,608,'et','JÃ¤tka ja salvesta',0),(21865,608,'si','Nadaljevati in shraniti',0),(21866,608,'ba','Lanjutkan dan menyimpan',0),(21867,608,'nl','Blijven en opslaan',0),(21868,608,'fi','Jatka ja Tallenna',0),(21869,608,'no','Fortsette og lagre',0),(21870,608,'da','FortsÃ¦tte og gemme',0),(21871,608,'ko','ê³„ì† í•˜ ê³  ì €ìž¥',0),(21872,608,'he','×œ×”×ž×©×™×š ×•×œ×©×ž×•×¨',0),(21873,608,'el','Î£Ï…Î½Î­Ï‡ÎµÎ¹Î± ÎºÎ±Î¹ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·',0),(21874,608,'zh','ç»§ç»­å¹¶ä¿å­˜\r\n',0),(21875,608,'sv','FortsÃ¤tta och spara',0),(21876,608,'it','Continuare e salvare',0),(21877,608,'tl','',0),(21878,608,'th','&#3605;&#3656;&#3629;&#3652;&#3611;&#3649;&#3621;&#3632;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;',0),(21879,608,'hi','à¤œà¤¾à¤°à¥€ à¤°à¤–à¤¨à¥‡ à¤”à¤° à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(21880,608,'ms','Terus dan menjimatkan',0),(21881,608,'ar','Ø§Ù„Ù…ØªØ§Ø¨Ø¹Ø© ÙˆØ­ÙØ¸',0),(21882,608,'fr','Continuer et Ã©conomisez',0),(21883,608,'jp','ç¶šã?‘ã?¦ä¿?å­˜ã?™ã‚‹',0),(21884,608,'pt','Continuar e salvar',0),(21885,608,'ru','Ð—Ð°ÐºÐ¾Ð½Ñ‡Ð¸Ñ‚ÑŒ Ð˜ Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ',0),(21886,608,'es','Continuar y Guardar',0),(21887,608,'de','Fahren und sparen',0),(21888,608,'en','Continue And Save',0),(21889,609,'is','',0),(21890,609,'dr','Ø§Ø¯Ø§Ù…Ù‡ Ø¬Ø³ØªØ¬Ùˆ ',0),(21891,609,'pr','Ø§Ø¯Ø§Ù…Ù‡ Ø¬Ø³ØªØ¬Ùˆ ',0),(21892,609,'tr','Tarama devam',0),(21893,609,'pl','kontynuowaÄ‡ przeglÄ…danie',0),(21894,609,'bg','Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸Ñ‚Ðµ Ð´Ð° ÑÑŠÑ€Ñ„Ð¸Ñ€Ð°Ñ‚Ðµ',0),(21895,609,'ur','Ø¨Ø±Ø§Ø¤Ø² Ú©Ø§Ø±ÛŒ Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾ÛŒÚº',0),(21896,609,'sr','Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(21897,609,'vi','tiáº¿p tá»¥c xem web',0),(21898,609,'af','aanhou Blaai',0),(21899,609,'ro','continua navigarea',0),(21900,609,'et','sirvimise jÃ¤tkamiseks',0),(21901,609,'si','nadaljujejo brskanje',0),(21902,609,'ba','melanjutkan browsing',0),(21903,609,'nl','doorgaan met bladeren',0),(21904,609,'fi','jatkaa selaamista',0),(21905,609,'no','Fortsett lesing',0),(21906,609,'da','fortsÃ¦tte med at gennemse',0),(21907,609,'ko','íƒìƒ‰ì„ ê³„ì†í•©ë‹ˆë‹¤',0),(21908,609,'he','×”×ž×©×š ×’×œ×™×©×”',0),(21909,609,'el','ÏƒÏ…Î½ÎµÏ‡Î¯ÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€ÎµÏÎ¹Î®Î³Î·ÏƒÎ·',0),(21910,609,'zh','ç»§ç»­æµè§ˆ\r\n',0),(21911,609,'sv','fortsÃ¤tta surfa',0),(21912,609,'it','continuare la navigazione',0),(21913,609,'tl','',0),(21914,609,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;&#3605;&#3656;&#3629;&#3652;&#3611;',0),(21915,609,'hi','à¤¬à¥à¤°à¤¾à¤‰à¤œà¤¼à¤¿à¤‚à¤— à¤œà¤¾à¤°à¥€ à¤°à¤–à¤¨à¥‡',0),(21916,609,'ms','Teruskan melayari',0),(21917,609,'ar','Ù…ÙˆØ§ØµÙ„Ø© Ø§Ù„ØªØµÙØ­',0),(21918,609,'fr','continuer Ã  naviguer',0),(21919,609,'jp','é–²è¦§ã‚’ç¶šã?‘ã‚‹',0),(21920,609,'pt','continuar navegando',0),(21921,609,'ru','Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€',0),(21922,609,'es','Continuar la Busqueda',0),(21923,609,'de','Weiter blÃ¤ttern',0),(21924,609,'en','continue browsing',0),(21925,610,'is','',0),(21926,610,'dr','ÙƒÙ¾ÙŠ ',0),(21927,610,'pr','ÙƒÙ¾ÙŠ ',0),(21928,610,'tr','Kopyala',0),(21929,610,'pl','Kopia',0),(21930,610,'bg','ÐšÐ¾Ð¿Ð¸Ðµ',0),(21931,610,'ur','Ù†Ù‚Ù„',0),(21932,610,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ˜',0),(21933,610,'vi','Sao chÃ©p',0),(21934,610,'af','KopiÃ«',0),(21935,610,'ro','Copie',0),(21936,610,'et','Kopeeri',0),(21937,610,'si','Izvod',0),(21938,610,'ba','Salinan',0),(21939,610,'nl','Kopie',0),(21940,610,'fi','Kopioi',0),(21941,610,'no','Kopier',0),(21942,610,'da','Kopi',0),(21943,610,'ko','ë³µì‚¬',0),(21944,610,'he','×”×¢×ª×§',0),(21945,610,'el','Î‘Î½Ï„Î¯Î³ÏÎ±Ï†Î¿',0),(21946,610,'zh','å¤åˆ¶\r\n',0),(21947,610,'sv','Kopia',0),(21948,610,'it','Copia',0),(21949,610,'tl','',0),(21950,610,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;',0),(21951,610,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(21952,610,'ms','Salinan',0),(21953,610,'ar','Ø§Ù„Ù†Ø³Ø®',0),(21954,610,'fr','Copie',0),(21955,610,'jp','ã‚³ãƒ”ãƒ¼',0),(21956,610,'pt','CÃ³pia',0),(21957,610,'ru','ÐšÐ¾Ð¿Ð¸Ñ',0),(21958,610,'es','Copiar',0),(21959,610,'de','Kopie',0),(21960,610,'en','Copy',0),(21961,611,'is','',0),(21962,611,'dr','ØªØ§Ø±ÙŠØ® Ø¨ÙˆØ¯Ø¬Ù‡ Ø±Ø§ ÙƒÙ¾ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ø² ',0),(21963,611,'pr','ØªØ§Ø±ÙŠØ® Ø¨ÙˆØ¯Ø¬Ù‡ Ø±Ø§ ÙƒÙ¾ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ø² ',0),(21964,611,'tr','BÃ¼tÃ§e verilerini kopyalama',0),(21965,611,'pl','Skopiuj dane budÅ¼etowe z',0),(21966,611,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ‚Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð¾Ñ‚',0),(21967,611,'ur','Ø¨Ø¬Ù¹ Ø³Û’ Ú©ÙˆØ§Ø¦Ù Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(21968,611,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð±ÑƒÑŸÐµÑ‚Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¸Ð·',0),(21969,611,'vi','Dá»¯ liá»‡u ngÃ¢n sÃ¡ch sao chÃ©p tá»«',0),(21970,611,'af','KopiÃ«er Begroting Data Vanaf',0),(21971,611,'ro','CopiaÅ£i date din',0),(21972,611,'et','Kopeeri koondamisel',0),(21973,611,'si','Kopirati podatke iz',0),(21974,611,'ba','Menyalin Data anggaran dari',0),(21975,611,'nl','Begrotingsgegevens kopiÃ«ren van',0),(21976,611,'fi','Kopioi budjettitiedot',0),(21977,611,'no','Kopiere budsjettdata',0),(21978,611,'da','Kopier budgetdata fra',0),(21979,611,'ko','ì˜ˆì‚° ë°ì´í„°ë¥¼ ë³µì‚¬',0),(21980,611,'he','×”×¢×ª×§ ×©×œ × ×ª×•× ×™ ×ª×§×¦×™×‘',0),(21981,611,'el','Î‘Î½Ï„Î¹Î³ÏÎ¬ÏˆÏ„Îµ Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î±Ï€ÏŒ',0),(21982,611,'zh','ä»Žé¢„ç®—æ•°æ®å¤åˆ¶\r\n',0),(21983,611,'sv','Kopiera budgetdata frÃ¥n',0),(21984,611,'it','Copiare i dati di bilancio da',0),(21985,611,'tl','',0),(21986,611,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3592;&#3634;&#3585;',0),(21987,611,'hi','à¤¬à¤œà¤Ÿ à¤¸à¥‡ à¤¡à¥‡à¤Ÿà¤¾ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(21988,611,'ms','Menyalin Data belanjawan dari',0),(21989,611,'ar','Ù†Ø³Ø® Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù…Ù† ',0),(21990,611,'fr','Copier les donnÃ©es du Budget',0),(21991,611,'jp','ï½žã?‹ã‚‰äºˆç®—ãƒ‡ãƒ¼ã‚¿ã‚’ã‚³ãƒ”ãƒ¼',0),(21992,611,'pt','Copiar dados do orÃ§amento de',0),(21993,611,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ðµ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð° Ð˜Ð·',0),(21994,611,'es','Copiar Datos de Presupuesto De',0),(21995,611,'de','Budgetdaten aus',0),(21996,611,'en','Copy Budget Data From',0),(21997,612,'is','',0),(21998,612,'dr','Ø§ÙƒÙ†ÙˆÙ† ÙƒÙ¾ÙŠ ÙƒÙ†ÙŠØ¯',0),(21999,612,'pr','Ø§ÙƒÙ†ÙˆÙ† ÙƒÙ¾ÙŠ ÙƒÙ†ÙŠØ¯',0),(22000,612,'tr','Åžimdi Kopyala',0),(22001,612,'pl','Teraz Skopiuj',0),(22002,612,'bg','ÐšÐ¾Ð¿Ð¸Ðµ ÑÐµÐ³Ð°',0),(22003,612,'ur','Ø§Ø¨ Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(22004,612,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ˜ ÑÐ°Ð´Ð°',0),(22005,612,'vi','Sao chÃ©p bÃ¢y giá»',0),(22006,612,'af','KopiÃ«er Nou',0),(22007,612,'ro','Copiaza acum',0),(22008,612,'et','Koopia nÃ¼Ã¼d',0),(22009,612,'si','Izvod zdaj',0),(22010,612,'ba','Salin sekarang',0),(22011,612,'nl','Nu kopiÃ«ren',0),(22012,612,'fi','Kopioida nyt',0),(22013,612,'no','Eksemplar nÃ¥',0),(22014,612,'da','Kopier nu',0),(22015,612,'ko','ì§€ê¸ˆ ë³µì‚¬',0),(22016,612,'he','×§×™×‘×œ×ª×™ ×¢×›×©×™×•',0),(22017,612,'el','Î¤ÏŽÏÎ± Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿',0),(22018,612,'zh','çŽ°åœ¨å¤åˆ¶\r\n',0),(22019,612,'sv','Kopiera nu',0),(22020,612,'it','Copia ora',0),(22021,612,'tl','',0),(22022,612,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(22023,612,'hi','à¤…à¤¬ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(22024,612,'ms','Salin sekarang',0),(22025,612,'ar','Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø¢Ù†',0),(22026,612,'fr','Copiez maintenant',0),(22027,612,'jp','ä»Šã‚³ãƒ”ãƒ¼ã?™ã‚‹',0),(22028,612,'pt','Copie agora',0),(22029,612,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¡ÐµÐ¹Ñ‡Ð°Ñ',0),(22030,612,'es','Copiar Ahora',0),(22031,612,'de','Kopieren Sie jetzt',0),(22032,612,'en','Copy Now',0),(22033,613,'is','',0),(22034,613,'dr','ÙƒÙ¾ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ  Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ùˆ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¨Ø§Ù„Ø§ Ø§Ø² Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(22035,613,'pr','ÙƒÙ¾ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ  Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ùˆ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¨Ø§Ù„Ø§ Ø§Ø² Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(22036,613,'tr','Hisse senedi seÃ§imleri ve upcharges fiyat listesinden kopyalama',0),(22037,613,'pl','Kopia czas wyborÃ³w i upcharges z cennikiem',0),(22038,613,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð°Ñ‚Ð° ÑÐµÐ»ÐµÐºÑ†Ð¸Ð¸ Ð¸ upcharges Ð¾Ñ‚ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(22039,613,'ur','Ø§Ø³Ù¹Ø§Ú© Ø§Ù†ØªØ®Ø§Ø¨ Ø§ÙˆØ± Ø§Ù¾Ú†Ø¢Ø±Ú¯Ø§Ø³ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø³Û’ Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(22040,613,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð¾Ð´Ð°Ð±Ð¸Ñ€Ðµ Ð¸ ÑƒÐ¿Ñ†Ñ…Ð°Ñ€Ð³ÐµÑ ÑÐ° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ¾Ð¼',0),(22041,613,'vi','Sao chÃ©p lá»±a chá»n hÃ ng tá»“n & phÃ­ tá»« báº£ng giÃ¡ ',0),(22042,613,'af','Kopieer voorraad seleksies en upcharges uit prys lys',0),(22043,613,'ro','Copie stoc selecÅ£ii ÅŸi upcharges la lista de preturi',0),(22044,613,'et','Varude valikut ja upcharges kopeerida hinnakiri',0),(22045,613,'si','Kopirajte izbor parka in upcharges iz cenika',0),(22046,613,'ba','Menyalin pilihan saham dan upcharges dari daftar harga',0),(22047,613,'nl','Kopie materieel selecties en upcharges vanaf prijslijst',0),(22048,613,'fi','Kopioi varastossa valinnat ja upcharges hinnasto',0),(22049,613,'no','Kopiere lager valg og upcharges fra prisliste',0),(22050,613,'da','Kopiere Stock valg og upcharges fra prisliste',0),(22051,613,'ko','ìž¬ê³  ì„ íƒ ë° upcharges ê°€ê²© ëª©ë¡ì—ì„œ ë³µì‚¬',0),(22052,613,'he','×œ×”×¢×ª×™×§ ×‘×—×™×¨×•×ª ×”×ž× ×™×•×ª ×•××ª upcharges ×ž×—×™×¨×•×Ÿ',0),(22053,613,'el','Î‘Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ ÎºÎ±Î¹ upcharges Î±Ï€ÏŒ Ï„Î¿Î½ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(22054,613,'zh','ä»Žå¦ä¸€ä»·æ ¼è¡¨å¤åˆ¶è‚¡ç¥¨é€‰æ‹©ä¸ŽåŠ ä»·\r\n',0),(22055,613,'sv','Kopiera Stock val och upcharges frÃ¥n prislista',0),(22056,613,'it','Copiare selezioni Stock e upcharges dal prezzo di listino',0),(22057,613,'tl','',0),(22058,613,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3605;&#3655;&#3629;&#3585;&#3649;&#3621;&#3632;&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3',0),(22059,613,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤šà¤¯à¤¨ à¤”à¤° upcharges à¤¸à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(22060,613,'ms','Salin pilihan saham dan upcharges dari senarai harga',0),(22061,613,'ar','Ù†Ø³Ø® \"ØªØ­Ø¯ÙŠØ¯Ø§Øª Ø§Ù„Ø£Ø³Ù‡Ù…\" ÙˆØ£ÙˆØ¨ØªØ´Ø§Ø±Ø¬ÙŠØ³ Ù…Ù† \"Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\"',0),(22062,613,'fr','Copier les sÃ©lections de Stock et Payment de liste de prix',0),(22063,613,'jp','ä¾¡æ ¼è¡¨ã?‹ã‚‰åœ¨åº«ä¸€è¦§ã?¨è¿½åŠ æ–™é‡‘ã‚’ã‚³ãƒ”ãƒ¼ã?™ã‚‹',0),(22064,613,'pt','Copiar seleÃ§Ãµes de estoque e upcharges lista de preÃ§o',0),(22065,613,'ru','Ð¡ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²Ñ‹Ð±Ð¾Ñ€ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ð¸ upcharges Ð¸Ð· Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚Ð°',0),(22066,613,'es','Copiar Selecciones de Stock y Upcharges desde Otra Lista de Precios',0),(22067,613,'de','Kopieren Sie Stock-Auswahl und Upcharges aus Preisliste',0),(22068,613,'en','Copy Stock Selections and upcharges from Price List',0),(22069,614,'is','',0),(22070,614,'dr','ÙƒÙ¾ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ùˆ  Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¨Ø§Ù„Ø§  Ø§Ø² Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¯ÙŠÚ¯Ø± ',0),(22071,614,'pr','ÙƒÙ¾ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ùˆ  Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¨Ø§Ù„Ø§  Ø§Ø² Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¯ÙŠÚ¯Ø± ',0),(22072,614,'tr','Hisse senetleri ve Upcharges baÅŸka bir fiyat listesinden kopyalama',0),(22073,614,'pl','Skopiuj zapasÃ³w i Upcharges z innym Cennik',0),(22074,614,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ Ð¸ Upcharges Ð¾Ñ‚ Ð´Ñ€ÑƒÐ³Ð° Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(22075,614,'ur','Ø³Ù¹Ø§Ú©Ø³ Ø§ÙˆØ± Ø§Ù¾Ú†Ø¢Ø±Ú¯Ø§Ø³ Ø§ÛŒÚ© Ø§ÙˆØ± Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø³Û’ Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(22076,614,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð¸ Ð£Ð¿Ñ†Ñ…Ð°Ñ€Ð³ÐµÑ Ð¸Ð· Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(22077,614,'vi','Sao chÃ©p hÃ ng tá»“n & phÃ­ tá»« báº£ng giÃ¡ khÃ¡c',0),(22078,614,'af','Kopieer Voorrade en laai vanaf \'n Ander Pryslys',0),(22079,614,'ro','Copie stocurilor ÅŸi Upcharges la un alt preÅ£ listÄƒ',0),(22080,614,'et','Varude ja Upcharges kopeerimiseks teise hinnakiri',0),(22081,614,'si','Kopiranje zalog in Upcharges iz drugega cenik',0),(22082,614,'ba','Menyalin saham dan Upcharges dari daftar harga yang lain',0),(22083,614,'nl','Voorraden en Upcharges van een andere prijslijst kopiÃ«ren',0),(22084,614,'fi','Varastot ja Upcharges kopioidaan toiseen hinnasto',0),(22085,614,'no','Kopiere aksjer og Upcharges fra en annen prisliste',0),(22086,614,'da','Eksemplar lagre og Upcharges fra en anden prisliste',0),(22087,614,'ko','ì£¼ì‹ ë° Upcharges ë‹¤ë¥¸ ê°€ê²© ëª©ë¡ì—ì„œ ë³µì‚¬',0),(22088,614,'he','×œ×”×¢×ª×™×§ ×”×ž×œ××™ ×•××ª Upcharges ×ž×—×™×¨×•×Ÿ ××—×¨',0),(22089,614,'el','Î‘Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î± ÎºÎ±Î¹ Upcharges Î±Ï€ÏŒ Î¼Î¹Î± Î¬Î»Î»Î· Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½',0),(22090,614,'zh','ä»Žå¦ä¸€ä»·æ ¼è¡¨å¤åˆ¶è‚¡ç¥¨ä¸ŽåŠ ä»·\r\n',0),(22091,614,'sv','Kopiera bestÃ¥nd och Upcharges frÃ¥n en annan prislista',0),(22092,614,'it','Stock di copia e Upcharges da un altro Listino',0),(22093,614,'tl','',0),(22094,614,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3626;&#3605;&#3655;&#3629;&#3585;&#3649;&#3621;&#3632;&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3592;&#3634;&#3585;&#3619;&#3634;&#3618;&#3585;&#3',0),(22095,614,'hi','à¤¸à¥à¤Ÿà¥‰à¤•à¥à¤¸ à¤”à¤° Upcharges à¤¸à¥‡ à¤à¤• à¤”à¤° à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(22096,614,'ms','Salin stok dan Upcharges dari senarai harga lain',0),(22097,614,'ar','Ù†Ø³Ø® Ø§Ù„Ø£Ø±ØµØ¯Ø© ÙˆØ£ÙˆØ¨ØªØ´Ø§Ø±Ø¬ÙŠØ³ Ù…Ù† Ø¢Ø®Ø± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(22098,614,'fr','Copiez les Stocks et Payment d\'une autre liste de prix',0),(22099,614,'jp','ä»–ã?®ä¾¡æ ¼è¡¨ã?‹ã‚‰åœ¨åº«ã?¨è¿½åŠ æ–™é‡‘ã‚’ã‚³ãƒ”ãƒ¼ã?™ã‚‹',0),(22100,614,'pt','Estoques de cÃ³pia e Upcharges de outra lista de preÃ§o',0),(22101,614,'ru','Ð¡ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¸Ð· Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ Ð°ÐºÑ†Ð¸Ð¸ Ð¸ Upcharges',0),(22102,614,'es','Copiar Stock y Upcharges desde Otra Lista de Precios',0),(22103,614,'de','Kopieren von Aktien und Upcharges aus einer anderen Preisliste',0),(22104,614,'en','Copy Stocks and Upcharges from Another Price List',0),(22105,615,'is','',0),(22106,615,'dr','ÙƒÙ¾ÙŠ Ø±Ø§ÙŠØª ',0),(22107,615,'pr','ÙƒÙ¾ÙŠ Ø±Ø§ÙŠØª ',0),(22108,615,'tr','Telif hakkÄ±',0),(22109,615,'pl','Prawa autorskie',0),(22110,615,'bg','ÐÐ²Ñ‚Ð¾Ñ€ÑÐºÐ¾ Ð¿Ñ€Ð°Ð²Ð¾',0),(22111,615,'ur','Ú©Ø§Ù¾ÛŒ Ø±Ø§Ø¦Ù¹',0),(22112,615,'sr','ÐÑƒÑ‚Ð¾Ñ€ÑÐºÐ¾ Ð¿Ñ€Ð°Ð²Ð¾',0),(22113,615,'vi','Báº£n Quyá»n ',0),(22114,615,'af','Kopiereg',0),(22115,615,'ro','Drepturile de autor',0),(22116,615,'et','AutoriÃµigus',0),(22117,615,'si','Avtorske pravice',0),(22118,615,'ba','Hak cipta',0),(22119,615,'nl','Copyright',0),(22120,615,'fi','Copyright',0),(22121,615,'no','Opphavsrett',0),(22122,615,'da','Copyright',0),(22123,615,'ko','ì €ìž‘ê¶Œ',0),(22124,615,'he','×–×›×•×™×•×ª ×™×•×¦×¨×™×',0),(22125,615,'el','Î Î½ÎµÏ…Î¼Î±Ï„Î¹ÎºÎ¬ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î±',0),(22126,615,'zh','ç‰ˆæƒæ‰€æœ‰\r\n',0),(22127,615,'sv','Copyright',0),(22128,615,'it','Copyright',0),(22129,615,'tl','',0),(22130,615,'th','Copyright',0),(22131,615,'hi','à¤•à¥‰à¤ªà¥€à¤°à¤¾à¤‡à¤Ÿ',0),(22132,615,'ms','Hakcipta Terpelihara',0),(22133,615,'ar','Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù†Ø´Ø±',0),(22134,615,'fr','Droit d\'auteur',0),(22135,615,'jp','è‘—ä½œæ¨©',0),(22136,615,'pt','Copyright',0),(22137,615,'ru','ÐÐ²Ñ‚Ð¾Ñ€ÑÐºÐ¾Ðµ Ð¿Ñ€Ð°Ð²Ð¾',0),(22138,615,'es','Derechos de Autor',0),(22139,615,'de','Copyright',0),(22140,615,'en','Copyright',0),(22141,616,'is','',0),(22142,616,'dr','Ù‡Ø²ÙŠÙ†Ù‡  ',0),(22143,616,'pr','Ù‡Ø²ÙŠÙ†Ù‡  ',0),(22144,616,'tr','Maliyet',0),(22145,616,'pl','Koszt',0),(22146,616,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(22147,616,'ur','Ù„Ø§Ú¯Øª',0),(22148,616,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº',0),(22149,616,'vi','Chi PhÃ­',0),(22150,616,'af','Koste',0),(22151,616,'ro','Cost',0),(22152,616,'et','Kulu',0),(22153,616,'si','StroÅ¡ki',0),(22154,616,'ba','Biaya',0),(22155,616,'nl','Kosten',0),(22156,616,'fi','Kustannukset',0),(22157,616,'no','Kostnader',0),(22158,616,'da','Omkostninger',0),(22159,616,'ko','ë¹„ìš©',0),(22160,616,'he','×¢×œ×•×ª',0),(22161,616,'el','ÎšÏŒÏƒÏ„Î¿Ï‚',0),(22162,616,'zh','æˆæœ¬\r\n',0),(22163,616,'sv','Kostnad',0),(22164,616,'it','Costo',0),(22165,616,'tl','',0),(22166,616,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(22167,616,'hi','à¤²à¤¾à¤—à¤¤',0),(22168,616,'ms','Kos',0),(22169,616,'ar','Ø§Ù„ØªÙƒÙ„ÙØ©',0),(22170,616,'fr','CoÃ»t',0),(22171,616,'jp','åŽŸä¾¡',0),(22172,616,'pt','Custo',0),(22173,616,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(22174,616,'es','Costo',0),(22175,616,'de','Kosten',0),(22176,616,'en','Cost',0),(22177,617,'is','',0),(22178,617,'dr','ÙƒÙ…Ùƒ Ù‡Ø²ÙŠÙ†Ù‡  Ø¨Ø± Ø³Ø§Ø¹Øª ',0),(22179,617,'pr','ÙƒÙ…Ùƒ Ù‡Ø²ÙŠÙ†Ù‡  Ø¨Ø± Ø³Ø§Ø¹Øª ',0),(22180,617,'tr','Asistan mal / insan kaynaklarÄ±',0),(22181,617,'pl','Koszt asystent / Hr',0),(22182,617,'bg','Ð¡Ñ‚Ñ€ÑƒÐ²Ð° Ð°ÑÐ¸ÑÑ‚ÐµÐ½Ñ‚ / Hr',0),(22183,617,'ur','Ø§Ø³Ø³Ù¹Ù†Ù¹ Ù„Ø§Ú¯Øª / Hr',0),(22184,617,'sr','ÐšÐ¾ÑˆÑ‚Ð° Ð°ÑÐ¸ÑÑ‚ÐµÐ½Ñ‚ / Ð¥Ñ€',0),(22185,617,'vi','Trá»£ giÃºp giÃ¡ thÃ nh / Giá»',0),(22186,617,'af','Koste Assistent / Uur',0),(22187,617,'ro','Asistent de cost / Hr',0),(22188,617,'et','Kulu assistent / Hr',0),(22189,617,'si','StroÅ¡ek asistent / Hr',0),(22190,617,'ba','Biaya asisten / Hr',0),(22191,617,'nl','Kosten van assistent / Hr',0),(22192,617,'fi','Maksaa avustaja / Hr',0),(22193,617,'no','Koste assistent / Hr',0),(22194,617,'da','Koste assistent / Hr',0),(22195,617,'ko','ë„ìš°ë¯¸ ë¹„ìš© / ì‹œê°„',0),(22196,617,'he','×ª×¢×œ×” ××ª ×¢×•×–×¨ / Hr',0),(22197,617,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î²Î¿Î·Î¸ÏŒÏ‚ / Hr',0),(22198,617,'zh','æˆæœ¬åŠ©ç†/å°æ—¶\r\n',0),(22199,617,'sv','Kosta assistent / Hr',0),(22200,617,'it','Costo assistente / Hr',0),(22201,617,'tl','',0),(22202,617,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3612;&#3641;&#3657;&#3594;&#3656;&#3623;&#3618;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(22203,617,'hi','à¤¸à¤¹à¤¾à¤¯à¤• à¤²à¤¾à¤—à¤¤ / Hr',0),(22204,617,'ms','Kos Pembantu / Hr',0),(22205,617,'ar','ØªÙƒÙ„ÙØ© Ù…Ø³Ø§Ø¹Ø¯/Ø§Ù„Ù…ÙˆØ§Ø±Ø¯ Ø§Ù„Ø¨Ø´Ø±ÙŠØ©',0),(22206,617,'fr','CoÃ»t assistante / Hr',0),(22207,617,'jp','åŽŸä¾¡ã‚¢ã‚·ã‚¹ã‚¿ãƒ³ãƒˆ',0),(22208,617,'pt','Assistente de custos / Hr',0),(22209,617,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ð¾Ð¼Ð¾Ñ‰Ð½Ð¸Ðº / Hr',0),(22210,617,'es','Asistente de Costo / Hora',0),(22211,617,'de','Kosten Assistant / Hr',0),(22212,617,'en','Cost Assistant / Hr',0),(22213,618,'is','',0),(22214,618,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø·Ø¨Ù‚ ',0),(22215,618,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø·Ø¨Ù‚ ',0),(22216,618,'tr','Temel maliyet',0),(22217,618,'pl','Koszt na podstawie',0),(22218,618,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸, Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð°',0),(22219,618,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø±',0),(22220,618,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ Ð¾ÑÐ½Ð¾Ð²Ñƒ',0),(22221,618,'vi','GiÃ¡ thÃ nh dá»±a trÃªn',0),(22222,618,'af','Koste gebasseer op',0),(22223,618,'ro','Cost bazat pe',0),(22224,618,'et','PÃµhineb kulu',0),(22225,618,'si','StroÅ¡ki na podlagi',0),(22226,618,'ba','Biaya berdasarkan',0),(22227,618,'nl','Kosten op basis van',0),(22228,618,'fi','Perustuvan',0),(22229,618,'no','Kostnader basert pÃ¥',0),(22230,618,'da','Omkostninger baseret pÃ¥',0),(22231,618,'ko','ë¹„ìš©ì— ë”°ë¼',0),(22232,618,'he','×¢×œ×•×ª ×‘×”×ª×‘×¡×¡ ×¢×œ',0),(22233,618,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î¼Îµ Î²Î¬ÏƒÎ·',0),(22234,618,'zh','åŸºäºŽæˆæœ¬\r\n',0),(22235,618,'sv','Kostnaden baserat pÃ¥',0),(22236,618,'it','Costo basato su',0),(22237,618,'tl','',0),(22238,618,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3610;&#3609;&#3614;&#3639;&#3657;&#3609;&#3600;&#3634;&#3609;&#3586;&#3629;&#3591;',0),(22239,618,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤°',0),(22240,618,'ms','Kos berdasarkan',0),(22241,618,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³',0),(22242,618,'fr','CoÃ»t basÃ© sur',0),(22243,618,'jp','ï½žã?«åŸºã?¥ã??åŽŸä¾¡',0),(22244,618,'pt','Custo com base no',0),(22245,618,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ',0),(22246,618,'es','Costo basado en',0),(22247,618,'de','Kosten auf Basis',0),(22248,618,'en','Cost based on',0),(22249,619,'is','',0),(22250,619,'dr','Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(22251,619,'pr','Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(22252,619,'tr','Maliyet Merkezi',0),(22253,619,'pl','MPK',0),(22254,619,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(22255,619,'ur','Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ú©Ø²',0),(22256,619,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(22257,619,'vi','Cost Center',0),(22258,619,'af','Koste Sentrum',0),(22259,619,'ro','Centrul de cost',0),(22260,619,'et','Kulukeskust',0),(22261,619,'si','StroÅ¡kovno srediÅ¡Äe',0),(22262,619,'ba','Biaya Pusat',0),(22263,619,'nl','Kostenplaats',0),(22264,619,'fi','Kustannuspaikka',0),(22265,619,'no','Kostsenter',0),(22266,619,'da','Omkostningssted',0),(22267,619,'ko','ë¹„ìš© ì„¼í„°',0),(22268,619,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª',0),(22269,619,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(22270,619,'zh','æˆæœ¬ä¸­å¿ƒ\r\n',0),(22271,619,'sv','KostnadsstÃ¤lle',0),(22272,619,'it','Centro di costo',0),(22273,619,'tl','',0),(22274,619,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;',0),(22275,619,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(22276,619,'ms','Pusat kos',0),(22277,619,'ar','Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(22278,619,'fr','Centre de coÃ»t',0),(22279,619,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼',0),(22280,619,'pt','Centro de custo',0),(22281,619,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(22282,619,'es','Centro de Costos',0),(22283,619,'de','Kostenstelle',0),(22284,619,'en','Cost Center',0),(22285,620,'is','',0),(22286,620,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡',0),(22287,620,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡',0),(22288,620,'tr','Yeni maliyet merkezi',0),(22289,620,'pl','Nowe centrum kosztÃ³w',0),(22290,620,'bg','ÐÐ¾Ð² Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(22291,620,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ù…Ø±Ú©Ø²',0),(22292,620,'sr','ÐÐ¾Ð²Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(22293,620,'vi','ThÃªm Cost Center',0),(22294,620,'af','Koste Sentrum Byvoeg',0),(22295,620,'ro','Noul centru de Cost',0),(22296,620,'et','Uus Kulukeskus',0),(22297,620,'si','Nove stroÅ¡kovno srediÅ¡Äe',0),(22298,620,'ba','Pusat biaya baru',0),(22299,620,'nl','Nieuwe kostenplaats',0),(22300,620,'fi','Uusi kustannuspaikka',0),(22301,620,'no','Nye kostsenter',0),(22302,620,'da','Nye omkostningssted',0),(22303,620,'ko','ìƒˆë¡œìš´ ë¹„ìš© ì„¼í„°',0),(22304,620,'he','×ž×¨×›×– ×¢×œ×•×ª ×—×“×©',0),(22305,620,'el','ÎÎ­Î¿ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(22306,620,'zh','æˆæœ¬ä¸­å¿ƒåœ°å€\r\n',0),(22307,620,'sv','Nya kostnadsstÃ¤lle',0),(22308,620,'it','Nuovo centro di costo',0),(22309,620,'tl','',0),(22310,620,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;',0),(22311,620,'hi','à¤¨à¤ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(22312,620,'ms','Pusat kos baru',0),(22313,620,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ©',0),(22314,620,'fr','Nouveau centre de coÃ»t',0),(22315,620,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?®è¿½åŠ ',0),(22316,620,'pt','Novo centro de custo',0),(22317,620,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ†ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(22318,620,'es','Agregar Centro de Costos',0),(22319,620,'de','Neue Kostenstelle',0),(22320,620,'en','New Cost Center',0),(22321,621,'is','',0),(22322,621,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(22323,621,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(22324,621,'tr','Maliyet merkezi baÅŸarÄ±yla eklendi',0),(22325,621,'pl','MPK dodano pomyÅ›lnie',0),(22326,621,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(22327,621,'ur','Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ú©Ø² Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(22328,621,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(22329,621,'vi','ThÃªm Cost Center thÃ nh cÃ´ng',0),(22330,621,'af','Koste Sentrum suksesvol Skep.',0),(22331,621,'ro','Centrul de cost adÄƒugat cu succes',0),(22332,621,'et','Lisatud Kulukeskus',0),(22333,621,'si','StroÅ¡kovno srediÅ¡Äe uspeÅ¡no dodani',0),(22334,621,'ba','Biaya pusat ditambahkan berhasil',0),(22335,621,'nl','Kostenplaats toegevoegd',0),(22336,621,'fi','Kustannuspaikka lisÃ¤Ã¤minen onnistui',0),(22337,621,'no','Kostsenteret som ble lagt til',0),(22338,621,'da','Omkostningssted tilfÃ¸jet',0),(22339,621,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ë¹„ìš© ì„¼í„°',0),(22340,621,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(22341,621,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(22342,621,'zh','æˆæœ¬ä¸­å¿ƒæ·»åŠ æˆåŠŸã€‚\r\n',0),(22343,621,'sv','KostnadsstÃ¤lle som lagts',0),(22344,621,'it','Centro di costo aggiunto con successo',0),(22345,621,'tl','',0),(22346,621,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(22347,621,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(22348,621,'ms','Pusat kos yang berjaya menambah',0),(22349,621,'ar','Ø£Ø¶ÙŠÙ Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(22350,621,'fr','Centre de coÃ»t ajoutÃ© avec succÃ¨s',0),(22351,621,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(22352,621,'pt','Centro de custo adicionado com sucesso',0),(22353,621,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(22354,621,'es','Centro de Costos agregado exitosamente',0),(22355,621,'de','Kostenstelle erfolgreich hinzugefÃ¼gt',0),(22356,621,'en','Cost Center added successfully',0),(22357,622,'is','',0),(22358,622,'dr','Ø­Ø°Ù Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(22359,622,'pr','Ø­Ø°Ù Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(22360,622,'tr','Maliyet merkezi baÅŸarÄ±yla silindi',0),(22361,622,'pl','MPK przesâ”‚anie',0),(22362,622,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(22363,622,'ur','Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(22364,622,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(22365,622,'vi','XÃ³a Cost Center thÃ nh cÃ´ng',0),(22366,622,'af','Koste Sentrum Suksesvol Geskrap.',0),(22367,622,'ro','Centrul de cost eliminÄƒ cu succes',0),(22368,622,'et','Kulukeskuse edukalt kustutatud',0),(22369,622,'si','StroÅ¡kovno srediÅ¡Äe uspeÅ¡no izbrisana',0),(22370,622,'ba','Biaya pusat dihapus berhasil',0),(22371,622,'nl','Kostenplaats met succes verwijderd',0),(22372,622,'fi','Kustannuspaikka poistettu',0),(22373,622,'no','Kostsenter slettet',0),(22374,622,'da','Omkostningssted slettet',0),(22375,622,'ko','ë¹„ìš© ì„¼í„°ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(22376,622,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(22377,622,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(22378,622,'zh','æˆæœ¬ä¸­å¿ƒå·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(22379,622,'sv','KostnadsstÃ¤lle raderades',0),(22380,622,'it','Centro di costo eliminato con successo',0),(22381,622,'tl','',0),(22382,622,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(22383,622,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(22384,622,'ms','Pusat kos yang dihapuskan dengan jayanya',0),(22385,622,'ar','Ø­Ø°Ù Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(22386,622,'fr','Centre de coÃ»t supprimÃ© avec succÃ¨s',0),(22387,622,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(22388,622,'pt','Centro de custo apagado com sucesso',0),(22389,622,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(22390,622,'es','Centro de Costos Eliminado Exitosamente',0),(22391,622,'de','Kostenstelle erfolgreich gelÃ¶scht',0),(22392,622,'en','Cost Center deleted successfully',0),(22393,623,'is','',0),(22394,623,'dr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡  Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(22395,623,'pr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡  Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(22396,623,'tr','Maliyet merkezini ailenin baÅŸarÄ±yla eklendi',0),(22397,623,'pl','MPK rodziny dodano pomyÅ›lnie',0),(22398,623,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(22399,623,'ur','Ù‚ÛŒÙ…Øª Ù…Ø±Ú©Ø² Ú©Û’ Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(22400,623,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(22401,623,'vi','Gia ÄÃ¬nh Cost Center thÃªm vÃ o thÃ nh cÃ´ng',0),(22402,623,'af','Koste Sentrum Familie suksesvol geskep.',0),(22403,623,'ro','Centrul de cost familia adÄƒugat cu succes',0),(22404,623,'et','Kulukeskuse pere lisatud',0),(22405,623,'si','StroÅ¡kovno srediÅ¡Äe druÅ¾ine uspeÅ¡no dodani',0),(22406,623,'ba','Biaya pusat keluarga ditambahkan berhasil',0),(22407,623,'nl','Kostenplaats familie toegevoegd',0),(22408,623,'fi','Kustannuspaikka perheen lisÃ¤Ã¤minen onnistui',0),(22409,623,'no','Kostsenter familien lagt',0),(22410,623,'da','Omkostningssted familie tilfÃ¸jet',0),(22411,623,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ë¹„ìš© ì„¼í„° ê°€ì¡±',0),(22412,623,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª ×”×ž×©×¤×—×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(22413,623,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(22414,623,'zh','æˆæœ¬ä¸­å¿ƒç³»åˆ—æ·»åŠ æˆåŠŸã€‚\r\n',0),(22415,623,'sv','KostnadsstÃ¤lle familj lagts',0),(22416,623,'it','Famiglia centro di costo aggiunto con successo',0),(22417,623,'tl','',0),(22418,623,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3626;&#3617;&#3634;&#3594;&#3636;&#3585;&#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(22419,623,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤ªà¤°à¤¿à¤µà¤¾à¤°',0),(22420,623,'ms','Keluarga Pusat kos yang berjaya menambah',0),(22421,623,'ar','Ø§Ù„Ø£Ø³Ø±Ø© Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(22422,623,'fr','Famille de centre de coÃ»t ajoutÃ© avec succÃ¨s',0),(22423,623,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ç³»çµ±ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(22424,623,'pt','FamÃ­lia de centro de custo adicionada com sucesso',0),(22425,623,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ ÑÐµÐ¼ÑŒÐ¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(22426,623,'es','Centro de Costos Familia agregada exitosamente',0),(22427,623,'de','Kostenstelle Familie erfolgreich hinzugefÃ¼gt',0),(22428,623,'en','Cost Center Family added successfully',0),(22429,624,'is','',0),(22430,624,'dr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø´Ø¯ ',0),(22431,624,'pr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø´Ø¯ ',0),(22432,624,'tr','Maliyet merkezini ailenin baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(22433,624,'pl','MPK rodziny pomyÅ›lnie zaktualizowana',0),(22434,624,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾Ñ‚Ð¾ ÑÐ¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(22435,624,'ur','Ù…Ø±Ú©Ø² Ø®Ø§Ù†Ø¯Ø§Ù† Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(22436,624,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(22437,624,'vi','Gia ÄÃ¬nh Cost Center cáº­p nháº­t thÃ nh cÃ´ng',0),(22438,624,'af','Koste Sentrum Familie suksesvol opdateer.',0),(22439,624,'ro','Centrul de cost familia actualizat cu succes',0),(22440,624,'et','Kulukeskuse pere vÃ¤rskendatud',0),(22441,624,'si','StroÅ¡kovno srediÅ¡Äe druÅ¾ine uspeÅ¡no posodobljena',0),(22442,624,'ba','Biaya pusat keluarga berhasil',0),(22443,624,'nl','Kostenplaats familie bijgewerkt',0),(22444,624,'fi','Kustannuspaikka perhe pÃ¤ivitetty',0),(22445,624,'no','Kostsenter familien oppdatert',0),(22446,624,'da','Omkostningssted familie opdateret',0),(22447,624,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ë¹„ìš© ì„¼í„° ê°€ì¡±',0),(22448,624,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª ×”×ž×©×¤×—×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(22449,624,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(22450,624,'zh','æˆæœ¬ä¸­å¿ƒç³»åˆ—æ›´æ–°æˆåŠŸã€‚\r\n',0),(22451,624,'sv','KostnadsstÃ¤lle familj uppdaterats',0),(22452,624,'it','Centro di costo famiglia aggiornato con successo',0),(22453,624,'tl','',0),(22454,624,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3626;&#3617;&#3634;&#3594;&#3636;&#3585;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(22455,624,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤°',0),(22456,624,'ms','Keluarga Pusat kos yang berjaya dikemas kini',0),(22457,624,'ar','Ø§Ù„Ø£Ø³Ø±Ø© Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(22458,624,'fr','Famille de centre de coÃ»ts Ã  jour avec succÃ¨s',0),(22459,624,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ç³»çµ±ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(22460,624,'pt','FamÃ­lia de centro de custo atualizada com sucesso',0),(22461,624,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ ÑÐµÐ¼ÑŒÐ¸, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(22462,624,'es','Centro de Costos Familia actualizada exitosamente',0),(22463,624,'de','Kostenstelle Familie erfolgreich aktualisiert',0),(22464,624,'en','Cost Center Family updated successfully',0),(22465,625,'is','',0),(22466,625,'dr','Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(22467,625,'pr','Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(22468,625,'tr','Maliyet merkezi makine aile',0),(22469,625,'pl','MPK maszyny rodziny',0),(22470,625,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(22471,625,'ur','Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø² Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù†',0),(22472,625,'sr','ÐŸÐ¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ÑÐºÑƒ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(22473,625,'vi','DÃ²ng mÃ¡y gia Ä‘Ã¬nh Cost center',0),(22474,625,'af','Koste sentrum masjien familie',0),(22475,625,'ro','Centrul de cost masina de familie',0),(22476,625,'et','Kulukeskuse masin perele',0),(22477,625,'si','StroÅ¡kovno srediÅ¡Äe stroj druÅ¾ine',0),(22478,625,'ba','Biaya pusat mesin keluarga',0),(22479,625,'nl','Kostenplaats Machine familie',0),(22480,625,'fi','Kustannuspaikka kone perhe',0),(22481,625,'no','Kostsenter maskin familien',0),(22482,625,'da','Omkostningssted maskine familie',0),(22483,625,'ko','ë¹„ìš© ì„¼í„° ê¸°ê³„ ê°€ì¡±',0),(22484,625,'he','×ž×¨×›×– ×¢×œ×•×ª ×”×ž×›×•× ×” ×”×ž×©×¤×—×”',0),(22485,625,'el','ÎŸÎ¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Î¼Î·Ï‡Î±Î½Î® ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(22486,625,'zh','æˆæœ¬ä¸­å¿ƒæœºç³»åˆ—\r\n',0),(22487,625,'sv','KostnadsstÃ¤lle maskin familj',0),(22488,625,'it','Centro di costo macchina famiglia',0),(22489,625,'tl','',0),(22490,625,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3626;&#3617;&#3634;&#3594;&#3636;&#3585;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(22491,625,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤°',0),(22492,625,'ms','Pusat kos Mesin keluarga',0),(22493,625,'ar','Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© Ø¢Ù„Ø© Ø§Ù„Ø£Ø³Ø±Ø©',0),(22494,625,'fr','Centre de coÃ»t Machine familiale',0),(22495,625,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼æ©Ÿæ¢°ç³»çµ±',0),(22496,625,'pt','FamÃ­lia de mÃ¡quina de centro de custo',0),(22497,625,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ ÑÐµÐ¼ÑŒÐ¸',0),(22498,625,'es','Familia de Maquina de Centro de Costos ',0),(22499,625,'de','Kostenstelle Maschine Familie',0),(22500,625,'en','Cost Center Machine Family',0),(22501,626,'is','',0),(22502,626,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(22503,626,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(22504,626,'tr','Yeni maliyet merkezi makine aile',0),(22505,626,'pl','Nowa rodzina maszyna MPK',0),(22506,626,'bg','ÐÐ¾Ð² Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(22507,626,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ù…Ø±Ú©Ø² Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù†',0),(22508,626,'sr','ÐÐ¾Ð²Ð° Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð° Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(22509,626,'vi','ThÃªm DÃ²ng mÃ¡y gia Ä‘Ã¬nh Cost center',0),(22510,626,'af','Nuwe koste sentrum masjien familie',0),(22511,626,'ro','Noul centru de Cost masina de familie',0),(22512,626,'et','Uus kulukeskuse masin perele',0),(22513,626,'si','Novo stroj druÅ¾ino stroÅ¡kovno srediÅ¡Äe',0),(22514,626,'ba','Keluarga mesin biaya pusat baru',0),(22515,626,'nl','Nieuwe kostenplaats Machine familie',0),(22516,626,'fi','Uusi kustannuspaikka kone perhe',0),(22517,626,'no','Nye kostsenter maskin familien',0),(22518,626,'da','Nye omkostningssted maskine familie',0),(22519,626,'ko','ìƒˆë¡œìš´ ë¹„ìš© ì„¼í„° ê¸°ê³„ ê°€ì¡±',0),(22520,626,'he','×ž×©×¤×—×” ×—×“×©×” ×©×œ ×”×ž×›×•× ×” ×ž×¨×›×– ×¢×œ×•×™×•×ª',0),(22521,626,'el','ÎÎ­Î± Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Î¼Î·Ï‡Î±Î½Î® ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(22522,626,'zh','æˆæœ¬ä¸­å¿ƒæœºç³»åˆ—æ–°å¢ž\r\n',0),(22523,626,'sv','Ny kostnadsstÃ¤lle maskin familj',0),(22524,626,'it','Nuova famiglia di macchina centro di costo',0),(22525,626,'tl','',0),(22526,626,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3626;&#3617;&#3634;&#3594;&#3636;&#3585;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(22527,626,'hi','à¤¨à¤ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤°',0),(22528,626,'ms','Keluarga Mesin Pusat kos baru',0),(22529,626,'ar','Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø¢Ù„Ø© Ø§Ù„Ø£Ø³Ø±Ø©',0),(22530,626,'fr','Nouvelle gamme de Machine de centre de coÃ»t',0),(22531,626,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼æ©Ÿæ¢°ç³»çµ±ã?®è¿½åŠ ',0),(22532,626,'pt','Nova famÃ­lia de mÃ¡quina de centro de custo',0),(22533,626,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ†ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ ÑÐµÐ¼ÑŒÐ¸',0),(22534,626,'es','Familia de Maquina del Centro de Costos Agregada',0),(22535,626,'de','Neue Kostenstelle Maschine Familie',0),(22536,626,'en','New Cost Center Machine Family',0),(22537,627,'is','',0),(22538,627,'dr','Ø­Ø°Ù Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(22539,627,'pr','Ø­Ø°Ù Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(22540,627,'tr','Maliyet merkezi makine aile baÅŸarÄ±yla silindi',0),(22541,627,'pl','MPK maszyny rodziny przesâ”‚anie',0),(22542,627,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(22543,627,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø² Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù†',0),(22544,627,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(22545,627,'vi','XÃ³a DÃ²ng mÃ¡y gia Ä‘Ã¬nh Cost center thÃ nh cÃ´ng',0),(22546,627,'af','Koste Sentrum Masjien familie suksesvol geskrap.',0),(22547,627,'ro','Centrul de cost masina de familie eliminÄƒ cu succes',0),(22548,627,'et','Kulukeskuse kohapeal pere edukalt kustutatud',0),(22549,627,'si','StroÅ¡kovno srediÅ¡Äe stroj druÅ¾ina uspeÅ¡no izbrisana',0),(22550,627,'ba','Biaya pusat mesin keluarga dihapus berhasil',0),(22551,627,'nl','Kostenplaats Machine familie met succes verwijderd',0),(22552,627,'fi','Kustannuspaikka kone perhe poistettu',0),(22553,627,'no','Kostsenter maskin familien slettet',0),(22554,627,'da','Omkostningssted maskine familie slettet',0),(22555,627,'ko','ë¹„ìš© ì„¼í„° ê¸°ê³„ ê°€ì¡± ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(22556,627,'he','×ž×¨×›×– ×¢×œ×•×ª ×”×ž×›×•× ×” ×”×ž×©×¤×—×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(22557,627,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Î¼Î·Ï‡Î±Î½Î® Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(22558,627,'zh','æˆæœ¬ä¸­å¿ƒæœºç³»åˆ—å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(22559,627,'sv','KostnadsstÃ¤lle maskin familj raderades',0),(22560,627,'it','Centro di costo macchina famiglia eliminato con successo',0),(22561,627,'tl','',0),(22562,627,'th','&#3621;&#3610;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3626;&#3617;&#3634;&#3594;&#3636;&#3585;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(22563,627,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(22564,627,'ms','Pusat kos Mesin keluarga dihapuskan dengan jayanya',0),(22565,627,'ar','Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© Ø¢Ù„Ø© Ø§Ù„Ø£Ø³Ø±Ø© Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(22566,627,'fr','Centre de coÃ»t Machine famille supprimÃ© avec succÃ¨s',0),(22567,627,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼æ©Ÿæ¢°ç³»çµ±ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(22568,627,'pt','Centro de custo mÃ¡quina famÃ­lia apagada com sucesso',0),(22569,627,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ ÑÐµÐ¼ÑŒÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(22570,627,'es','Familia de Maquina del Centro de Costos eliminado exitosamente',0),(22571,627,'de','Kostenstelle Maschine Familie erfolgreich gelÃ¶scht',0),(22572,627,'en','Cost Center Machine Family deleted successfully',0),(22573,628,'is','',0),(22574,628,'dr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ø´ÙŠÙ† ÙŠØ§ÙØª Ù†Ø´Ø¯ ',0),(22575,628,'pr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ø´ÙŠÙ† ÙŠØ§ÙØª Ù†Ø´Ø¯ ',0),(22576,628,'tr','Maliyet merkezi makine aile bulunamadÄ±',0),(22577,628,'pl','MPK maszyny rodziny nie znaleziono',0),(22578,628,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(22579,628,'ur','Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø² Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù† Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(22580,628,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(22581,628,'vi','KhÃ´ng tÃ¬m tháº¥y Cost center cá»§a dÃ²ng mÃ¡y gia Ä‘Ã¬nh',0),(22582,628,'af','Koste sentrum masjien familie nie gevind nie',0),(22583,628,'ro','Centrul de cost masina de familie nu a fost gÄƒsit',0),(22584,628,'et','Kulukeskuse masin perele ei leitud',0),(22585,628,'si','StroÅ¡kovno srediÅ¡Äe stroj druÅ¾ino ni mogoÄe najti',0),(22586,628,'ba','Biaya pusat mesin keluarga tidak ditemukan',0),(22587,628,'nl','Kostenplaats Machine familie niet gevonden',0),(22588,628,'fi','Kustannuspaikka kone perhe ei lÃ¶ydy',0),(22589,628,'no','Kostsenter maskin familien ikke funnet',0),(22590,628,'da','Omkostningssted maskine familie ikke fundet',0),(22591,628,'ko','ë¹„ìš© ì„¼í„° ê¸°ê³„ ê°€ì¡± ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(22592,628,'he','×ž×¨×›×– ×¢×œ×•×ª ×”×ž×›×•× ×” ×”×ž×©×¤×—×” ×œ× × ×ž×¦×',0),(22593,628,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Î¼Î·Ï‡Î±Î½Î® Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(22594,628,'zh','æˆæœ¬ä¸­å¿ƒæœºç³»åˆ—æ²¡æœ‰æ‰¾åˆ°',0),(22595,628,'sv','KostnadsstÃ¤lle maskin familj hittades inte',0),(22596,628,'it','Centro di costo famiglia di macchina non trovato',0),(22597,628,'tl','',0),(22598,628,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3626;&#3617;&#3634;&#3594;&#3636;&#3585;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(22599,628,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(22600,628,'ms','Pusat kos Mesin keluarga tidak dijumpai',0),(22601,628,'ar','Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© Ø¢Ù„Ø© Ø§Ù„Ø£Ø³Ø±Ø© Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(22602,628,'fr','Centre de coÃ»t Machine famille introuvable',0),(22603,628,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼æ©Ÿæ¢°ç³»çµ±ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(22604,628,'pt','FamÃ­lia de mÃ¡quina de centro de custo nÃ£o encontrada',0),(22605,628,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ ÑÐµÐ¼ÑŒÐ¸ Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°',0),(22606,628,'es','Familia de Maquina del Centro de Costos no se EncontrÃ³',0),(22607,628,'de','Kostenstelle Maschine Familie nicht gefunden',0),(22608,628,'en','Cost Center Machine Family not found',0),(22609,629,'is','',0),(22610,629,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(22611,629,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(22612,629,'tr','DÃ¼zen maliyet merkezi makine aile',0),(22613,629,'pl','Edycja MPK maszyny rodziny',0),(22614,629,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð½Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(22615,629,'ur','ØªØ¯ÙˆÛŒÙ† Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø² Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù†',0),(22616,629,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ÑÐºÑƒ Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð°',0),(22617,629,'vi','Cost Center cá»§a dÃ²ng mÃ¡y gia Ä‘Ã¬nh cáº­p nháº­t thÃ nh cÃ´ng',0),(22618,629,'af','Redigeer koste sentrum masjien familie',0),(22619,629,'ro','Centrul de Cost editare masina de familie',0),(22620,629,'et','Redigeeri kulukeskuse masin perele',0),(22621,629,'si','Urejanje stroÅ¡kovno srediÅ¡Äe stroj druÅ¾ine',0),(22622,629,'ba','Edit biaya pusat mesin keluarga',0),(22623,629,'nl','Bewerken kostenplaats Machine familie',0),(22624,629,'fi','Muokkaa kustannuspaikka kone perhe',0),(22625,629,'no','Rediger kostsenteret maskin familien',0),(22626,629,'da','Rediger omkostningssted maskine familie',0),(22627,629,'ko','íŽ¸ì§‘ ë¹„ìš© ì„¼í„° ê¸°ê³„ ê°€ì¡±',0),(22628,629,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª ×¢×¨×™×›×ª ×ž×›×•× ×ª ×”×ž×©×¤×—×”',0),(22629,629,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼Î·Ï‡Î±Î½Î® Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±',0),(22630,629,'zh','æˆæœ¬ä¸­å¿ƒæœºç³»åˆ—æ›´æ–°\r\n',0),(22631,629,'sv','Redigera kostnadsstÃ¤llet maskin familj',0),(22632,629,'it','Centro di costo modifica macchina famiglia',0),(22633,629,'tl','',0),(22634,629,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3619;&#3623;&#3617;&#3617;&#3634;&#3594;&#3636;&#3585;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(22635,629,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤°',0),(22636,629,'ms','Edit Pusat kos Mesin keluarga',0),(22637,629,'ar','Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© ØªØ­Ø±ÙŠØ± Ø¢Ù„Ø© Ø§Ù„Ø£Ø³Ø±Ø©',0),(22638,629,'fr','Edit Centre de coÃ»t Machine familiale',0),(22639,629,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼æ©Ÿæ¢°ç³»çµ±ã?®æ›´æ–°',0),(22640,629,'pt','FamÃ­lia de mÃ¡quina de centro de custo de ediÃ§Ã£o',0),(22641,629,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ ÑÐµÐ¼ÑŒÐ¸',0),(22642,629,'es','Familia de Maquina del Centro de Costos Actualizar',0),(22643,629,'de','Bearbeiten-Kostenstelle Maschine Familie',0),(22644,629,'en','Edit Cost Center Machine Family',0),(22645,630,'is','',0),(22646,630,'dr','Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(22647,630,'pr','Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(22648,630,'tr','Maliyet merkezi bulunamadÄ±',0),(22649,630,'pl','MPK nie znaleziono',0),(22650,630,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(22651,630,'ur','Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø² Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(22652,630,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(22653,630,'vi','KhÃ´ng tÃ¬m tháº¥y Cost center',0),(22654,630,'af','Koste Sentrum nie gevind',0),(22655,630,'ro','Centrul de cost nu a fost gÄƒsit',0),(22656,630,'et','Kulukeskuse ei leitud',0),(22657,630,'si','StroÅ¡kovno srediÅ¡Äe ni mogoÄe najti',0),(22658,630,'ba','Biaya pusat tidak ditemukan',0),(22659,630,'nl','Kostenplaats niet gevonden',0),(22660,630,'fi','Kustannuspaikka ei lÃ¶ydy',0),(22661,630,'no','Kostsenter ikke funnet',0),(22662,630,'da','BÃ¦rer ikke fundet',0),(22663,630,'ko','ë¹„ìš© ì„¼í„°ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(22664,630,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª ×œ× × ×ž×¦×',0),(22665,630,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(22666,630,'zh','æˆæœ¬ä¸­å¿ƒæ²¡æœ‰æ‰¾åˆ°\r\n',0),(22667,630,'sv','KostnadsstÃ¤lle hittades inte',0),(22668,630,'it','Centro di costo non trovato',0),(22669,630,'tl','',0),(22670,630,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3619;&#3623;&#3617;',0),(22671,630,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(22672,630,'ms','Pusat kos yang tidak dijumpai',0),(22673,630,'ar','Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ© ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(22674,630,'fr','Centre de coÃ»t non trouvÃ©',0),(22675,630,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(22676,630,'pt','Centro de custo nÃ£o encontrado',0),(22677,630,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(22678,630,'es','Centro de Costos no se encontrÃ³',0),(22679,630,'de','Kostenstelle nicht gefunden',0),(22680,630,'en','Cost Center not found',0),(22681,631,'is','',0),(22682,631,'dr','Ù†ÙˆØ¹ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(22683,631,'pr','Ù†ÙˆØ¹ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(22684,631,'tr','Maliyet merkezi tÃ¼rÃ¼',0),(22685,631,'pl','Typ MPK',0),(22686,631,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ñ‚Ð¸Ð¿',0),(22687,631,'ur','Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ú©Ø² Ú©ÛŒ Ù‚Ø³Ù…',0),(22688,631,'sr','Ð¢Ð¸Ð¿ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(22689,631,'vi','Loáº¡i Cost center',0),(22690,631,'af','Koste Sentrum Tipe',0),(22691,631,'ro','Centrul de cost tip',0),(22692,631,'et','Kulukeskuse tÃ¼Ã¼p',0),(22693,631,'si','StroÅ¡kovno srediÅ¡Äe tipa',0),(22694,631,'ba','Jenis biaya Pusat',0),(22695,631,'nl','Kostenplaats Type',0),(22696,631,'fi','Kustannuspaikan tyyppi',0),(22697,631,'no','Kostsenter Type',0),(22698,631,'da','Omkostningssted Type',0),(22699,631,'ko','ë¹„ìš© ì„¼í„° ìœ í˜•',0),(22700,631,'he','×¡×•×’ ×ž×¨×›×– ×¢×œ×•×™×•×ª',0),(22701,631,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï„ÏÏ€Î¿Ï…',0),(22702,631,'zh','æˆæœ¬ä¸­å¿ƒåž‹\r\n',0),(22703,631,'sv','KostnadsstÃ¤lle typ',0),(22704,631,'it','Tipo di centro di costo',0),(22705,631,'tl','',0),(22706,631,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3619;&#3623;&#3617;',0),(22707,631,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤ªà¥à¤°à¤•à¤¾à¤°',0),(22708,631,'ms','Jenis Pusat kos',0),(22709,631,'ar','Ù†ÙˆØ¹ Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(22710,631,'fr','Type de centre de coÃ»t',0),(22711,631,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã‚¿ã‚¤ãƒ—',0),(22712,631,'pt','Tipo de centro de custo',0),(22713,631,'ru','Ð¢Ð¸Ð¿ Ñ†ÐµÐ½Ñ‚Ñ€Ð° Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(22714,631,'es','Tipo de Centro de Costos',0),(22715,631,'de','Kostenstelle-Typ',0),(22716,631,'en','Cost Center Type',0),(22717,632,'is','',0),(22718,632,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡',0),(22719,632,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡',0),(22720,632,'tr','DÃ¼zen maliyet merkezi',0),(22721,632,'pl','Edycja MPK',0),(22722,632,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð½Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(22723,632,'ur','ØªØ¯ÙˆÛŒÙ† Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø²',0),(22724,632,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(22725,632,'vi','Cáº­p Nháº­t Cost Center',0),(22726,632,'af','Koste Sentrum Opdateer',0),(22727,632,'ro','Centrul de Cost Edit',0),(22728,632,'et','Redigeeri Kulukeskus',0),(22729,632,'si','Urejanje stroÅ¡kovno srediÅ¡Äe',0),(22730,632,'ba','Edit biaya Pusat',0),(22731,632,'nl','Bewerken kostenplaats',0),(22732,632,'fi','Muokkaa kustannuspaikka',0),(22733,632,'no','Rediger kostsenteret',0),(22734,632,'da','Rediger omkostningssted',0),(22735,632,'ko','íŽ¸ì§‘ ë¹„ìš© ì„¼í„°',0),(22736,632,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª ×¢×¨×™×›×”',0),(22737,632,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(22738,632,'zh','æˆæœ¬ä¸­å¿ƒæ›´æ–°\r\n',0),(22739,632,'sv','Redigera kostnadsstÃ¤llet',0),(22740,632,'it','Centro di costo di modifica',0),(22741,632,'tl','',0),(22742,632,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3619;&#3623;&#3617;',0),(22743,632,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(22744,632,'ms','Edit Pusat kos',0),(22745,632,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(22746,632,'fr','Centre de coÃ»t Edit',0),(22747,632,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?®æ›´æ–°',0),(22748,632,'pt','Centro de custo de ediÃ§Ã£o',0),(22749,632,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(22750,632,'es','Centro de Costos Actualizar',0),(22751,632,'de','Kostenstelle bearbeiten',0),(22752,632,'en','Edit Cost Center',0),(22753,633,'is','',0),(22754,633,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(22755,633,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(22756,633,'tr','Maliyet merkezi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(22757,633,'pl','MPK pomyÅ›lnie zaktualizowana',0),(22758,633,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(22759,633,'ur','Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø² Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(22760,633,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(22761,633,'vi','Cáº­p Nháº­t Cost Center thÃ nh cÃ´ng',0),(22762,633,'af','Koste Sentrum suksesvol Opdateer',0),(22763,633,'ro','Centrul de cost actualizat cu succes',0),(22764,633,'et','VÃ¤rskendatud Kulukeskus',0),(22765,633,'si','StroÅ¡kovno srediÅ¡Äe uspeÅ¡no posodobljena',0),(22766,633,'ba','Biaya pusat berhasil',0),(22767,633,'nl','Kostenplaats bijgewerkt',0),(22768,633,'fi','PÃ¤ivitetty kustannuspaikka',0),(22769,633,'no','Kostsenter oppdatert',0),(22770,633,'da','Omkostningssted opdateret',0),(22771,633,'ko','ë¹„ìš© ì„¼í„°ì— ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(22772,633,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(22773,633,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(22774,633,'zh','æˆæœ¬ä¸­å¿ƒå·²æˆåŠŸæ›´æ–°ã€‚\r\n',0),(22775,633,'sv','KostnadsstÃ¤lle uppdaterats',0),(22776,633,'it','Centro di costo aggiornato con successo',0),(22777,633,'tl','',0),(22778,633,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3619;&#3623;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(22779,633,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(22780,633,'ms','Pusat kos yang berjaya dikemas kini',0),(22781,633,'ar','Ø­Ø¯Ù‘Ø« Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(22782,633,'fr','Centre de coÃ»ts Ã  jour avec succÃ¨s',0),(22783,633,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(22784,633,'pt','Centro de custo atualizado com sucesso',0),(22785,633,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(22786,633,'es','Centro de Costos actualizado exitosamente',0),(22787,633,'de','Kostenstelle, die erfolgreich aktualisiert',0),(22788,633,'en','Cost Center updated successfully',0),(22789,634,'is','',0),(22790,634,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø±',0),(22791,634,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø±',0),(22792,634,'tr','Her maliyet',0),(22793,634,'pl','Koszt kaÅ¼dego',0),(22794,634,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð²ÑÐµÐºÐ¸',0),(22795,634,'ur','ÛØ± Ø§ÛŒÚ© Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(22796,634,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº ÑÐ²Ð°ÐºÐ¾Ð³',0),(22797,634,'vi','Cost tá»«ng Ä‘Æ¡n vá»‹',0),(22798,634,'af','Koste van Elk',0),(22799,634,'ro','Costul fiecÄƒrui',0),(22800,634,'et','Maksumus iga',0),(22801,634,'si','StroÅ¡kov vsakega',0),(22802,634,'ba','Biaya setiap',0),(22803,634,'nl','Kosten elke',0),(22804,634,'fi','Kustannukset kunkin',0),(22805,634,'no','Koste hver',0),(22806,634,'da','Koste hver',0),(22807,634,'ko','ê° ë¹„ìš©',0),(22808,634,'he','×¢×œ×•×ª ×›×œ',0),(22809,634,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÎ¬Î¸Îµ',0),(22810,634,'zh','æ¯ä¸ªæˆæœ¬\r\n',0),(22811,634,'sv','Kostnad varje',0),(22812,634,'it','Costo di ogni',0),(22813,634,'tl','',0),(22814,634,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3649;&#3605;&#3656;&#3621;&#3632;',0),(22815,634,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤²à¤¾à¤—à¤¤',0),(22816,634,'ms','Kos setiap',0),(22817,634,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ù„Ù„Ù‚Ø·Ø¹Ø©',0),(22818,634,'fr','CoÃ»t de chaque',0),(22819,634,'jp','å?˜ä¾¡',0),(22820,634,'pt','Custo de cada',0),(22821,634,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ°Ð¶Ð´Ð¾Ð³Ð¾',0),(22822,634,'es','Costo Cada Uno',0),(22823,634,'de','Kosten Sie jeweils',0),(22824,634,'en','Cost Each',0),(22825,635,'is','',0),(22826,635,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(22827,635,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(22828,635,'tr','Maliyet GL hesabÄ±',0),(22829,635,'pl','Konto koszt GL',0),(22830,635,'bg','Ð¦ÐµÐ½Ð° GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(22831,635,'ur','Ù„Ø§Ú¯Øª Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(22832,635,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð“Ð›',0),(22833,635,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p GiÃ¡ ThÃ nh',0),(22834,635,'af','Koste AG Rekening',0),(22835,635,'ro','Cont de costul GL',0),(22836,635,'et','Kulu pearaamatukontole',0),(22837,635,'si','StroÅ¡kovno GL raÄun',0),(22838,635,'ba','Biaya GL Account',0),(22839,635,'nl','Kosten GL Account',0),(22840,635,'fi','Kustannusten Kirjanpitotilin pÃ¤Ã¤tilin',0),(22841,635,'no','Kostnader gi-konto',0),(22842,635,'da','Omkostninger GL konto',0),(22843,635,'ko','ë¹„ìš©ëœ GL ê³„ì •',0),(22844,635,'he','GL ×¢×œ×•×ª ×—×©×‘×•×Ÿ',0),(22845,635,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î³/Î»',0),(22846,635,'zh','æˆæœ¬æ€»å¸å¸æˆ·\r\n',0),(22847,635,'sv','Kostnad GL konto',0),(22848,635,'it','Conto costo GL',0),(22849,635,'tl','',0),(22850,635,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(22851,635,'hi','à¤²à¤¾à¤—à¤¤ GL à¤–à¤¾à¤¤à¥‡',0),(22852,635,'ms','GL kos akaun',0),(22853,635,'ar','Ø­Ø³Ø§Ø¨ ØªÙƒÙ„ÙØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(22854,635,'fr','Compte coÃ»t GL',0),(22855,635,'jp','ç·?å£²ä¸Šå‹˜å®šå…ƒå¸³ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®åŽŸä¾¡',0),(22856,635,'pt','Conta de custo GL',0),(22857,635,'ru','Ð¡Ñ‡ÐµÑ‚ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ GL',0),(22858,635,'es','Costo Cuenta de LM',0),(22859,635,'de','Kosten Sako',0),(22860,635,'en','Cost GL Account',0),(22861,636,'is','',0),(22862,636,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ø´ÙŠÙ† Ø¨Ø± Ø³Ø§Ø¹Øª ',0),(22863,636,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ø´ÙŠÙ† Ø¨Ø± Ø³Ø§Ø¹Øª ',0),(22864,636,'tr','Makine maliyet / insan kaynaklarÄ±',0),(22865,636,'pl','Koszt maszyny / Hr',0),(22866,636,'bg','Ð¡Ñ‚Ñ€ÑƒÐ²Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð° / Hr',0),(22867,636,'ur','Ù…Ø´ÛŒÙ† Ú©Ø§ Ø®Ø±Ú†Û / Hr',0),(22868,636,'sr','ÐšÐ¾ÑˆÑ‚Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð° / Ð¥Ñ€',0),(22869,636,'vi','GiÃ¡ thÃ nh mÃ¡y /Giá»',0),(22870,636,'af','Masjien kos / Hr',0),(22871,636,'ro','MaÅŸinÄƒ de cost / Hr',0),(22872,636,'et','Maksa masin / Hr',0),(22873,636,'si','StroÅ¡ek stroj / Hr',0),(22874,636,'ba','Biaya mesin / Hr',0),(22875,636,'nl','Kosten van Machine / Hr',0),(22876,636,'fi','Maksaa kone / Hr',0),(22877,636,'no','Koste maskin / Hr',0),(22878,636,'da','Koste maskine / Hr',0),(22879,636,'ko','ê¸°ê³„ ë¹„ìš© / ì‹œê°„',0),(22880,636,'he','×¢×œ×•×ª ×ž×›×•× ×” / Hr',0),(22881,636,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î¼Î·Ï‡Î±Î½Î® / Hr',0),(22882,636,'zh','æˆæœ¬æœº/å°æ—¶\r\n',0),(22883,636,'sv','Kostnad maskin / Hr',0),(22884,636,'it','Costo macchina / Hr',0),(22885,636,'tl','',0),(22886,636,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(22887,636,'hi','à¤®à¤¶à¥€à¤¨ à¤•à¥€ à¤²à¤¾à¤—à¤¤ / Hr',0),(22888,636,'ms','Kos Mesin / Hr',0),(22889,636,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ø¬Ù‡Ø§Ø²/Ø§Ù„Ù…ÙˆØ§Ø±Ø¯ Ø§Ù„Ø¨Ø´Ø±ÙŠØ©',0),(22890,636,'fr','CoÃ»t Machine / Hr',0),(22891,636,'jp','æ©Ÿæ¢°çµŒè²»/æ™‚é–“',0),(22892,636,'pt','MÃ¡quina de custo / Hr',0),(22893,636,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ / Hr',0),(22894,636,'es','Costo de Maquina / Hora',0),(22895,636,'de','Kosten Maschine / Hr',0),(22896,636,'en','Cost Machine / Hr',0),(22897,637,'is','',0),(22898,637,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ ',0),(22899,637,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ ',0),(22900,637,'tr','Mamul maliyeti',0),(22901,637,'pl','Koszt towarÃ³w',0),(22902,637,'bg','Ð¡ÐµÐ±ÐµÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð½Ð° ÑÑ‚Ð¾ÐºÐ¸',0),(22903,637,'ur','Ø³Ø§Ù…Ø§Ù† Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(22904,637,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ñ€Ð¾Ð±Ðµ',0),(22905,637,'vi','GiÃ¡ thÃ nh sáº£n pháº©m',0),(22906,637,'af','Koste van Verkope',0),(22907,637,'ro','Costul produselor',0),(22908,637,'et','Kaupade hinnad',0),(22909,637,'si','StroÅ¡ki blaga',0),(22910,637,'ba','Biaya barang',0),(22911,637,'nl','Kosten van goederen',0),(22912,637,'fi','Tuotteiden kustannukset',0),(22913,637,'no','Kostnader for varer',0),(22914,637,'da','Vareforbrug',0),(22915,637,'ko','ìƒí’ˆì˜ ë¹„ìš©',0),(22916,637,'he','×¢×œ×•×ª ×”×ž×›×¨',0),(22917,637,'el','ÎšÎŸÎ£Î¤ÎŸÎ£ Î Î©Î›Î—Î˜Î•ÎÎ¤Î©Î',0),(22918,637,'zh','å•†å“æˆæœ¬\r\n',0),(22919,637,'sv','Kostnad fÃ¶r varor',0),(22920,637,'it','Costo dei beni',0),(22921,637,'tl','',0),(22922,637,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(22923,637,'hi','à¤µà¤¸à¥ à¤¤à¥à¤“à¤‚ à¤•à¥€ à¤²à¤¾à¤—à¤¤',0),(22924,637,'ms','Kos barangan',0),(22925,637,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(22926,637,'fr','CoÃ»t des marchandises',0),(22927,637,'jp','å•†å“?åŽŸä¾¡',0),(22928,637,'pt','Custo das mercadorias',0),(22929,637,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(22930,637,'es','Costo de Bienes',0),(22931,637,'de','Warenaufwand',0),(22932,637,'en','Cost of Goods',0),(22933,638,'is','',0),(22934,638,'dr','Ø¨Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ÙŠ ÙØ±ÙˆØ´ Ø±ÙØªÙ‡',0),(22935,638,'pr','Ø¨Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ÙŠ ÙØ±ÙˆØ´ Ø±ÙØªÙ‡',0),(22936,638,'tr','SatÄ±lan malÄ±n maliyeti',0),(22937,638,'pl','Koszt towarÃ³w sprzedanych',0),(22938,638,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¸Ñ‚Ðµ ÑÑ‚Ð¾ÐºÐ¸',0),(22939,638,'ur','Ø³Ø§Ù…Ø§Ù† Ú©ÛŒ Ù‚ÛŒÙ…Øª ÙØ±ÙˆØ®Øª',0),(22940,638,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ‚Ðµ Ñ€Ð¾Ð±Ðµ',0),(22941,638,'vi','GiÃ¡ thÃ nh sáº£n pháº©m Ä‘Ã£ bÃ¡n',0),(22942,638,'af','Koste van Verkope Herverkoop',0),(22943,638,'ro','Costul produselor vÃ¢ndute',0),(22944,638,'et','MÃ¼Ã¼dud kaupade kulu',0),(22945,638,'si','StroÅ¡ki prodanega blaga',0),(22946,638,'ba','Harga pokok penjualan',0),(22947,638,'nl','Kostprijs van verkochte goederen',0),(22948,638,'fi','Myytyjen tuotteiden kustannukset',0),(22949,638,'no','Kostnader for solgte varer',0),(22950,638,'da','Omkostninger for solgte varer',0),(22951,638,'ko','ìƒí’ˆì˜ ë¹„ìš©ì€ íŒë§¤',0),(22952,638,'he','×¢×œ×•×ª ×¡×—×•×¨×” ×©× ×ž×›×¨×”',0),(22953,638,'el','ÎšÏŒÏƒÏ„Î¿Ï…Ï‚ Ï„Ï‰Î½ Ï€Ï‰Î»Î·Î¸Î­Î½Ï„Ï‰Î½',0),(22954,638,'zh','é”€è´§æˆæœ¬\r\n',0),(22955,638,'sv','Kostnad fÃ¶r sÃ¥lda varor',0),(22956,638,'it','Costo dei beni venduti',0),(22957,638,'tl','',0),(22958,638,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3634;&#3618;',0),(22959,638,'hi','à¤¬à¥‡à¤šà¤¾ à¤µà¤¸à¥à¤¤à¥à¤“à¤‚ à¤•à¥€ à¤²à¤¾à¤—à¤¤',0),(22960,638,'ms','Kos barangan yang dijual',0),(22961,638,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(22962,638,'fr','CoÃ»t des marchandises vendues',0),(22963,638,'jp','è²©å£²æ¸ˆå•†å“?åŽŸä¾¡',0),(22964,638,'pt','Custo das mercadorias vendidas',0),(22965,638,'ru','Ð¡ÐµÐ±ÐµÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ñ€Ð¾Ð´Ð°Ð½Ð½Ñ‹Ñ… Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(22966,638,'es','Costo de Bienes Vendidos',0),(22967,638,'de','Herstellkosten der verkauften Produkte',0),(22968,638,'en','Cost of Goods Sold',0),(22969,639,'is','',0),(22970,639,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ù¾Ø±Ø§ØªÙˆØ± Ø¨Ø±Ø³Ø§Ø¹Øª ',0),(22971,639,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ù¾Ø±Ø§ØªÙˆØ± Ø¨Ø±Ø³Ø§Ø¹Øª ',0),(22972,639,'tr','Ä°ÅŸleÃ§ maliyet / insan kaynaklarÄ±',0),(22973,639,'pl','Koszt operatora / Hr',0),(22974,639,'bg','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ / Hr',0),(22975,639,'ur','Ø¢Ù¾Ø±ÛŒÙ¹Ø± Ú©ÛŒ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ / Hr',0),(22976,639,'sr','ÐšÐ¾ÑˆÑ‚Ð° ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€ / Ð¥Ñ€',0),(22977,639,'vi','Chi phÃ­ váº­n hÃ nh / Giá»',0),(22978,639,'af','Operateur koste / Hr',0),(22979,639,'ro','Operatorul de cost / Hr',0),(22980,639,'et','Maksma korraldaja / Hr',0),(22981,639,'si','StroÅ¡kov operaterja / Hr',0),(22982,639,'ba','Biaya Operator / Hr',0),(22983,639,'nl','Kosten van de exploitant / Hr',0),(22984,639,'fi','Maksaa operaattori / Hr',0),(22985,639,'no','Koste operatÃ¸r / Hr',0),(22986,639,'da','Koste operatÃ¸r / Hr',0),(22987,639,'ko','ì—°ì‚°ìž ë¹„ìš© / ì‹œê°„',0),(22988,639,'he','×¢×œ×•×ª ××•×¤×¨×˜×•×¨ / Hr',0),(22989,639,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï„Î¿ Ï†Î¿ÏÎ­Î± / Hr',0),(22990,639,'zh','è¥è¿æˆæœ¬/å°æ—¶\r\n',0),(22991,639,'sv','Kosta operatÃ¶r / Hr',0),(22992,639,'it','Costo operatore / Hr',0),(22993,639,'tl','',0),(22994,639,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(22995,639,'hi','à¤‘à¤ªà¤°à¥‡à¤Ÿà¤° à¤•à¥€ à¤²à¤¾à¤—à¤¤ / Hr',0),(22996,639,'ms','Kos pengendali / Hr',0),(22997,639,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø´ØºÙ„/Ø§Ù„Ù…ÙˆØ§Ø±Ø¯ Ø§Ù„Ø¨Ø´Ø±ÙŠØ©',0),(22998,639,'fr','CoÃ»t opÃ©rateur / Hr',0),(22999,639,'jp','ã‚ªãƒšãƒ¬ãƒ¼ã‚¿ãƒ¼çµŒè²»/æ™‚é–“',0),(23000,639,'pt','Custo de operador / Hr',0),(23001,639,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ð° / Hr',0),(23002,639,'es','Operador de Costo / Hora',0),(23003,639,'de','Kosten Operator / Hr',0),(23004,639,'en','Cost Operator / Hr',0),(23005,640,'is','',0),(23006,640,'dr','Ù‡Ø²ÙŠÙ†Ù‡  Ù‡Ø±   Ø¯ÙƒÙ…Ù‡ Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ ÙØ´Ø§Ø±  Ø¯Ù‡ÙŠØ¯ ',0),(23007,640,'pr','Ù‡Ø²ÙŠÙ†Ù‡  Ù‡Ø±   Ø¯ÙƒÙ…Ù‡ Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ ÙØ´Ø§Ø±  Ø¯Ù‡ÙŠØ¯ ',0),(23008,640,'tr','BasÄ±n miktar maliyet',0),(23009,640,'pl','Koszt iloÅ›Ä‡ prasy',0),(23010,640,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° Ð¿Ñ€ÐµÑÐ°Ñ‚Ð° ÐºÐ¾Ð»',0),(23011,640,'ur','Ù¾Ø±ÛŒØ³ Ù‚ÛŒ ÙÛŒ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(23012,640,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ ÐšÐ¾Ð».',0),(23013,640,'vi','GiÃ¡ má»—i má»™t sá»‘ lÆ°á»£ng in áº¥n',0),(23014,640,'af','Koste Per Drukpers Hoev.',0),(23015,640,'ro','Costul pe presa cantit',0),(23016,640,'et','Vajutage tk-pealt',0),(23017,640,'si','StroÅ¡ki na kol Press',0),(23018,640,'ba','Biaya tekan Qty',0),(23019,640,'nl','Kosten Per pers Qty',0),(23020,640,'fi','Hinta Per paina mÃ¤Ã¤rÃ¤',0),(23021,640,'no','Kostnad Per trykk Ant',0),(23022,640,'da','Omkostning pr. Tryk Qty',0),(23023,640,'ko','ë³´ë„ ìˆ˜ëŸ‰ ë‹¹ ë¹„ìš©',0),(23024,640,'he','×¢×œ×•×ª ×›×œ ×›×ž×•×ª ×©×œ ×”×¢×™×ª×•× ×•×ª',0),(23025,640,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ Ï„ÏÏ€Î¿ Qty',0),(23026,640,'zh','è´¹ç”¨æ¯æŒ‰æ•°é‡\r\n',0),(23027,640,'sv','Kostnad Per Tryck Kvt',0),(23028,640,'it','Costo Per stampa Qty',0),(23029,640,'tl','',0),(23030,640,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3605;&#3656;&#3629;&#3592;&#3635;&#3609;&#3623;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(23031,640,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤²à¤¾à¤—à¤¤',0),(23032,640,'ms','Kos setiap Qty Seluar',0),(23033,640,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ù„ÙƒÙ„ ØµØ­ÙÙŠ Qty',0),(23034,640,'fr','CoÃ»t par QtÃ© de presse',0),(23035,640,'jp','ãƒ—ãƒ¬ã‚¹æ•°é‡?ã?”ã?¨ã?®åŽŸä¾¡',0),(23036,640,'pt','Custo por imprensa Qty',0),(23037,640,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ ÑˆÑ‚',0),(23038,640,'es','Costo Por Cantidad de ImpresiÃ³n',0),(23039,640,'de','Kosten pro Press Qty',0),(23040,640,'en','Cost Per Press Qty',0),(23041,641,'is','',0),(23042,641,'dr','Ù‡Ø²ÙŠÙ†Ù‡  Ù‡Ø± ÙˆØ§Ø­Ø¯ ',0),(23043,641,'pr','Ù‡Ø²ÙŠÙ†Ù‡  Ù‡Ø± ÙˆØ§Ø­Ø¯ ',0),(23044,641,'tr','Birim baÅŸÄ±na maliyet',0),(23045,641,'pl','Koszt na jednostkÄ™',0),(23046,641,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(23047,641,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(23048,641,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(23049,641,'vi','GiÃ¡ má»—i 1 Ä‘Æ¡n vá»‹',0),(23050,641,'af','Koste Per Eenheid',0),(23051,641,'ro','Costul pe unitate',0),(23052,641,'et','Maksumus Ã¼hiku kohta',0),(23053,641,'si','StroÅ¡ek na enoto',0),(23054,641,'ba','Biaya Per Unit',0),(23055,641,'nl','Kosten Per eenheid',0),(23056,641,'fi','Kustannus Per yksikkÃ¶',0),(23057,641,'no','Kostnad Per enhet',0),(23058,641,'da','Omkostninger pr. enhed',0),(23059,641,'ko','ë‹¨ìœ„ ë‹¹ ë¹„ìš©',0),(23060,641,'he','×¢×œ×•×ª ×œ×™×—×™×“×”',0),(23061,641,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î±',0),(23062,641,'zh','å•ä½æˆæœ¬\r\n',0),(23063,641,'sv','Kostnad Per enhet',0),(23064,641,'it','Costo unitario',0),(23065,641,'tl','',0),(23066,641,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(23067,641,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤•à¤¾à¤ˆ à¤²à¤¾à¤—à¤¤',0),(23068,641,'ms','Kos seunit',0),(23069,641,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø©',0),(23070,641,'fr','CoÃ»t par unitÃ©',0),(23071,641,'jp','å?˜ä¾¡',0),(23072,641,'pt','Custo por unidade',0),(23073,641,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(23074,641,'es','Costo Por Unidad',0),(23075,641,'de','Kosten pro Einheit',0),(23076,641,'en','Cost Per Unit',0),(23077,642,'is','',0),(23078,642,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(23079,642,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(23080,642,'tr','KullanÄ±m baÅŸÄ±na maliyet',0),(23081,642,'pl','Koszt uÅ¼ycia',0),(23082,642,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾',0),(23083,642,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ ÙÛŒ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(23084,642,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸',0),(23085,642,'vi','GiÃ¡ má»™t láº§n sá»­ dá»¥ng',0),(23086,642,'af','Koste Per gebruik',0),(23087,642,'ro','Costul pe utilizarea',0),(23088,642,'et','Kasuta kulu',0),(23089,642,'si','StroÅ¡ki na uporabo',0),(23090,642,'ba','Biaya penggunaan',0),(23091,642,'nl','Kosten Per gebruik',0),(23092,642,'fi','KÃ¤yttÃ¶kohtainen kustannus',0),(23093,642,'no','Kostnader Per bruk',0),(23094,642,'da','Omkostninger pr. gang',0),(23095,642,'ko','ì‚¬ìš© ë‹¹ ë¹„ìš©',0),(23096,642,'he','×¢×œ×•×ª ×œ×›×œ ×©×™×ž×•×©',0),(23097,642,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ Ï‡ÏÎ®ÏƒÎ·',0),(23098,642,'zh','æ¯æ¬¡ä½¿ç”¨æˆæœ¬\r\n',0),(23099,642,'sv','Kostnad Per anvÃ¤ndning',0),(23100,642,'it','Costo Per uso',0),(23101,642,'tl','',0),(23102,642,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;',0),(23103,642,'hi','à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(23104,642,'ms','Bayaran guna',0),(23105,642,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ù„ÙƒÙ„ Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(23106,642,'fr','CoÃ»t par utilisation',0),(23107,642,'jp','ä½¿ç”¨ã?”ã?¨ã?®åŽŸä¾¡',0),(23108,642,'pt','Custo por uso',0),(23109,642,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(23110,642,'es','Costo Por Uso',0),(23111,642,'de','Kosten pro Einsatz',0),(23112,642,'en','Cost Per Use',0),(23113,643,'is','',0),(23114,643,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ØªØµØ§Ù„ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§   Ù†ÙŠØ³Øª',0),(23115,643,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ØªØµØ§Ù„ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§   Ù†ÙŠØ³Øª',0),(23116,643,'tr','VeritabanÄ±na baÄŸlanamadÄ±.',0),(23117,643,'pl','Nie moÅ¼na poÅ‚Ä…czyÄ‡ z bazÄ… danych.',0),(23118,643,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ ÑÐ²ÑŠÑ€Ð¶Ðµ Ñ Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸.',0),(23119,643,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ø³Û’ Ù†ÛÛŒÚº Ø¬Ú‘ Ø³Ú©Ø§ Û”',0),(23120,643,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³Ð°Ð¾ Ð¿Ð¾Ð²ÐµÐ·Ð°Ñ‚Ð¸ ÑÐ° Ð±Ð°Ð·Ð¾Ð¼ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°.',0),(23121,643,'vi','KhÃ´ng káº¿t ná»“i Ä‘Æ°á»£c vá»›i dá»¯ liá»‡u',0),(23122,643,'af','Kon nie koppel aan die databasis.',0),(23123,643,'ro','Nu sa putut conecta la baza de date.',0),(23124,643,'et','Ei saanud Ã¼hendust andmebaasiga.',0),(23125,643,'si','Zbirke podatkov ni bilo mogoÄe vzpostaviti.',0),(23126,643,'ba','Tidak dapat menyambung ke database.',0),(23127,643,'nl','Kan geen verbinding maken met de database.',0),(23128,643,'fi','Ei pysty muodostamaan tietokantaan.',0),(23129,643,'no','Kan ikke koble til databasen.',0),(23130,643,'da','Kunne ikke forbinde til databasen.',0),(23131,643,'ko','ë°ì´í„°ë² ì´ìŠ¤ì— ì—°ê²°í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23132,643,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×”×ª×—×‘×¨ ×œ×ž×¡×“ ×”× ×ª×•× ×™×.',0),(23133,643,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· ÏƒÏÎ½Î´ÎµÏƒÎ· Î¼Îµ Ï„Î· Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½.',0),(23134,643,'zh','æ— æ³•è¿žæŽ¥åˆ°æ•°æ®åº“ã€‚\r\n',0),(23135,643,'sv','Kunde inte ansluta till databasen.',0),(23136,643,'it','Impossibile connettersi al database.',0),(23137,643,'tl','',0),(23138,643,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3652;&#3604;&#3657;',0),(23139,643,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥‡ à¤•à¤¨à¥‡à¤•à¥à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¾à¥¤',0),(23140,643,'ms','Tidak dapat menyambung ke dalam pangkalan data.',0),(23141,643,'ar','Ù„Ù… ÙŠÙ…ÙƒÙ† Ø§Ù„Ø§ØªØµØ§Ù„ Ø¨Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(23142,643,'fr','Pas pu se connecter Ã  la base de donnÃ©es.',0),(23143,643,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?«æŽ¥ç¶šã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(23144,643,'pt','NÃ£o foi possÃ­vel conectar ao banco de dados.',0),(23145,643,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÑÐ¾ÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒ Ñ Ð±Ð°Ð·Ð¾Ð¹ Ð´Ð°Ð½Ð½Ñ‹Ñ….',0),(23146,643,'es','No se podÃ­a conectar a la base de datos',0),(23147,643,'de','Konnte nicht mit der Datenbank herstellen.',0),(23148,643,'en','Could not connect to the database.',0),(23149,644,'is','',0),(23150,644,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø­Ø°Ù  Ù†ÙŠØ³Øª',0),(23151,644,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø­Ø°Ù  Ù†ÙŠØ³Øª',0),(23152,644,'tr','  Silin.',0),(23153,644,'pl','  Nie moÅ¼na usunÄ…Ä‡.',0),(23154,644,'bg','  ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ðµ.',0),(23155,644,'ur','  Ø­Ø°Ù Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(23156,644,'sr','  ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸.',0),(23157,644,'vi','KhÃ´ng xÃ³a Ä‘Æ°á»£c',0),(23158,644,'af','   Kon nie skrap.',0),(23159,644,'ro','  Imposibil de È™ters.',0),(23160,644,'et','  Ei saanud kustutada.',0),(23161,644,'si','  Ni bilo mogoÄe izbrisati.',0),(23162,644,'ba','  Tidak dapat menghapus.',0),(23163,644,'nl','  Kan geen gegevens verwijderen.',0),(23164,644,'fi','  Ei voi poistaa.',0),(23165,644,'no','  Kan ikke slette.',0),(23166,644,'da','  Kunne ikke slettes.',0),(23167,644,'ko','  ì‚­ì œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23168,644,'he','  ×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×—×•×§.',0),(23169,644,'el','  Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î´Î¹Î±Î³ÏÎ±Ï†Î®.',0),(23170,644,'zh','æ— æ³•åˆ é™¤ã€‚\r\n',0),(23171,644,'sv','  Kunde inte tas bort.',0),(23172,644,'it','  Impossibile eliminare.',0),(23173,644,'tl','',0),(23174,644,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3621;&#3610;&#3652;&#3604;&#3657;',0),(23175,644,'hi','  à¤¨à¤¹à¥€à¤‚ à¤¹à¤Ÿà¤¾ à¤¸à¤•à¤¾à¥¤',0),(23176,644,'ms','  Tidak dapat menghapuskan.',0),(23177,644,'ar','  Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø­Ø°Ù.',0),(23178,644,'fr','  Pas pu supprimer.',0),(23179,644,'jp','æ¶ˆåŽ»ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(23180,644,'pt','  NÃ£o foi possÃ­vel excluir.',0),(23181,644,'ru',' ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ.',0),(23182,644,'es','No se podÃ­a eliminar',0),(23183,644,'de','  Konnte nicht gelÃ¶scht werden.',0),(23184,644,'en','  Could not delete.',0),(23185,645,'is','',0),(23186,645,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†ÙŠØ³Øª',0),(23187,645,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†ÙŠØ³Øª',0),(23188,645,'tr','Bill bulamadÄ±.',0),(23189,645,'pl','Nie mogÅ‚em znaleÅºÄ‡ ustawy.',0),(23190,645,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð±Ð¸Ð».',0),(23191,645,'ur','Ø¨Ù„ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§ Û”',0),(23192,645,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð‘Ð¸Ð».',0),(23193,645,'vi','KhÃ´ng tháº¥y hÃ³a Ä‘Æ¡n',0),(23194,645,'af','Kon nie die Wetsontwerp vind nie.',0),(23195,645,'ro','Proiectul de lege nu a putut gÄƒsi.',0),(23196,645,'et','EelnÃµu ei leidnud.',0),(23197,645,'si','Zakona ni mogoÄe najti.',0),(23198,645,'ba','Tidak dapat menemukan tagihan.',0),(23199,645,'nl','Kan niet vinden bill.',0),(23200,645,'fi','Bill ei lÃ¶ytynyt.',0),(23201,645,'no','Finner ikke bill.',0),(23202,645,'da','Kunne ikke finde bill.',0),(23203,645,'ko','ì²­êµ¬ì„œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23204,645,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×‘×™×œ.',0),(23205,645,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿.',0),(23206,645,'zh','æ‰¾ä¸åˆ°å¸å•',0),(23207,645,'sv','Kunde inte hitta bill.',0),(23208,645,'it','Non riusciva a trovare bill.',0),(23209,645,'tl','',0),(23210,645,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3610;&#3636;&#3621;&#3652;&#3604;&#3657;',0),(23211,645,'hi','à¤¬à¤¿à¤² à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾à¥¤',0),(23212,645,'ms','Tidak dapat mencari Rang undang-undang.',0),(23213,645,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ†.',0),(23214,645,'fr','Projet de loi introuvable.',0),(23215,645,'jp','è«‹æ±‚æ›¸ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(23216,645,'pt','NÃ£o foi possÃ­vel encontrar o bill.',0),(23217,645,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ Ð‘Ð¸Ð»Ð»Ð°.',0),(23218,645,'es','No se podÃ­a encontrar el recibo',0),(23219,645,'de','Bill konnte nicht gefunden werden.',0),(23220,645,'en','Could not find bill.',0),(23221,646,'is','',0),(23222,646,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù†Ø§Ù… Ù…Ø­Ù„ Ù†ÙŠØ³Øª',0),(23223,646,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù†Ø§Ù… Ù…Ø­Ù„ Ù†ÙŠØ³Øª',0),(23224,646,'tr','Konum adÄ± bulunamadÄ±',0),(23225,646,'pl','Nie moÅ¼na odnaleÅºÄ‡ nazwy lokalizacji',0),(23226,646,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(23227,646,'ur','Ù†Ø§Ù… Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù†ÛÛŒÚº Ù…Ù„ Ø³Ú©Ø§',0),(23228,646,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð½Ð°Ð·Ð¸Ð² Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(23229,646,'vi','KhÃ´ng tÃ¬m tháº¥y tÃªn vá»‹ trÃ­',0),(23230,646,'af','Was nie instaat om ligging te vind',0),(23231,646,'ro','Nu am putut gÄƒsi nume de locaÅ£ie',0),(23232,646,'et','Asukoha nime ei leitud',0),(23233,646,'si','Ime mesta ni bilo mogoÄe najti.',0),(23234,646,'ba','Tidak dapat menemukan nama lokasi',0),(23235,646,'nl','Konden niet vondst locatienaam',0),(23236,646,'fi','Sijainnin nimeÃ¤ ei lÃ¶ytynyt',0),(23237,646,'no','Finner ikke stedsnavn',0),(23238,646,'da','Kunne ikke finde lokationens navn',0),(23239,646,'ko','ìœ„ì¹˜ ì´ë¦„ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23240,646,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×©× ×”×ž×™×§×•×',0),(23241,646,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±Ï‚',0),(23242,646,'zh','æ‰¾ä¸åˆ°ä½ç½®çš„åç§°\r\n',0),(23243,646,'sv','Kunde inte hitta namn',0),(23244,646,'it','Non riusciva a trovare il nome di percorso',0),(23245,646,'tl','',0),(23246,646,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3594;&#3639;&#3656;&#3629;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3652;&#3604;&#3657;',0),(23247,646,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¤¾ à¤¨à¤¾à¤® à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(23248,646,'ms','Tidak dapat mencari nama lokasi',0),(23249,646,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥ÙŠØ¬Ø§Ø¯ Ø¥Ø³Ù… Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(23250,646,'fr','Nom de l\'emplacement est introuvable',0),(23251,646,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³å??ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(23252,646,'pt','NÃ£o foi possÃ­vel encontrar o nome da localidade',0),(23253,646,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð½Ð°Ð¹Ñ‚Ð¸ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¸Ð¼ÐµÐ½Ð¸',0),(23254,646,'es','No se podÃ­a encontrar el nombre de la ubicaciÃ³n',0),(23255,646,'de','Lage-Name konnte nicht gefunden werden.',0),(23256,646,'en','Could not find location name',0),(23257,647,'is','',0),(23258,647,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  Ø³ÙŠØ³ØªÙ… Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´  Ù†ÙŠØ³Øª',0),(23259,647,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  Ø³ÙŠØ³ØªÙ… Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´  Ù†ÙŠØ³Øª',0),(23260,647,'tr','BiÃ§imlendirme bul ayarlÄ± olabilir',0),(23261,647,'pl','Kulisy nie znaleÅºÄ‡ zestaw znacznikÃ³w',0),(23262,647,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð½Ðµ Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¾ ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸',0),(23263,647,'ur','Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ù†Û Ù…Ù„ Ø³Ú©ÛŒ',0),(23264,647,'sr','ÐœÐ¾Ð³Ð»Ð¸ Ð½Ð°Ñ›Ð¸ Ð½Ð°Ð·Ð½Ð°ÐºÐµ Ð·Ð°Ð´Ð°Ð²Ð°Ñ‚Ð¸',0),(23265,647,'vi','KhÃ´ng tÃ¬m tháº¥y báº£ng cá»™ng thÃªm',0),(23266,647,'af','Kan nie vind Markup stel',0),(23267,647,'ro','Ar putea nu gÄƒsi Set Markup',0),(23268,647,'et','Kas ei leia mÃ¤rgistus seada',0),(23269,647,'si','Bi lahko naÅ¡li Markup vzide',0),(23270,647,'ba','Bisa tidak menemukan Markup diatur',0),(23271,647,'nl','Kan niet vinden Markup instellen',0),(23272,647,'fi','Voisi lÃ¶ytÃ¤Ã¤ Markup aseteta',0),(23273,647,'no','Kunne ikke finne Markup angitt',0),(23274,647,'da','Kunne ikke finde Markup sÃ¦t',0),(23275,647,'ko','ì°¾ì„ íƒœê·¸ ì„¤ì • í•˜ì§€ ìˆ˜',0),(23276,647,'he','×¢×œ×•×œ ×œ× ×œ×ž×¦×•× ××ª ×”×’×“×¨ ×¡×™×ž×•×Ÿ',0),(23277,647,'el','Î˜Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î´ÎµÎ½ Î²ÏÎµÎ¯Ï„Îµ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ Ï€Î¿Ï…',0),(23278,647,'zh','æ— æ³•æ‰¾åˆ°æ ‡è®°é›†\r\n',0),(23279,647,'sv','Kunde inte hitta Markup instÃ¤lld',0),(23280,647,'it','Potrebbe non trovare impostata Markup',0),(23281,647,'tl','',0),(23282,647,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3586;&#3634;&#3618;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;',0),(23283,647,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(23284,647,'ms','Boleh tidak mencari penanda disetkan',0),(23285,647,'ar','ÙˆÙŠÙ…ÙƒÙ† Ø£Ù† Ù„Ø§ \"ØªØ¬Ø¯ ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª\"',0),(23286,647,'fr','Pourrait pas trouver balisage dÃ©fini',0),(23287,647,'jp','å€¤ä¸Šã?’è¨­å®šã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(23288,647,'pt','Poderia nÃ£o encontrar marcaÃ§Ã£o definida',0),(23289,647,'ru','ÐœÐ¾Ð¶ÐµÑ‚ Ð½Ðµ Ð½Ð°Ð¹Ñ‚Ð¸ Ð½Ð°Ð±Ð¾Ñ€Ð¾Ð² Ð¿Ð¾Ð¼ÐµÑ‚Ð¾Ðº',0),(23290,647,'es','No se podÃ­a encontrar el juego de encarecimiento',0),(23291,647,'de','Konnte nicht finden Markup festgelegt',0),(23292,647,'en','Could not Find Markup Set',0),(23293,648,'is','',0),(23294,648,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù†Ù…ÙˆØ¯Ø§Ø±  Ù†ÙŠØ³Øª',0),(23295,648,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù†Ù…ÙˆØ¯Ø§Ø±  Ù†ÙŠØ³Øª',0),(23296,648,'tr','Pasta bulamadÄ±m',0),(23297,648,'pl','Nie moÅ¼na odnaleÅºÄ‡ koÅ‚owy',0),(23298,648,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð¿Ð°Ð¹',0),(23299,648,'ur','Ù¾Ø§Ø¦ÛŒ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§',0),(23300,648,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð¿Ð¸Ñ‚Ñƒ',0),(23301,648,'vi','KhÃ´ng tÃ¬m tháº¥y á»‘ng',0),(23302,648,'af','Kan nie Sirkeldiagram vind nie',0),(23303,648,'ro','Nu am putut gÄƒsi pie',0),(23304,648,'et','Ei leidnud pirukas',0),(23305,648,'si','Pie ni bilo mogoÄe najti.',0),(23306,648,'ba','Tidak dapat menemukan kue',0),(23307,648,'nl','Konden niet vondst taart',0),(23308,648,'fi','Ei lÃ¶ytÃ¤nyt pie',0),(23309,648,'no','Finner ikke sektor',0),(23310,648,'da','Kunne ikke finde pie',0),(23311,648,'ko','íŒŒì´ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23312,648,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×¤××™',0),(23313,648,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï€Î¯Ï„Î±',0),(23314,648,'zh','æ‰¾ä¸åˆ°é¥¼çŠ¶å›¾\r\n',0),(23315,648,'sv','Kunde inte hitta paj',0),(23316,648,'it','Non poteva trovare la torta',0),(23317,648,'tl','',0),(23318,648,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3588;&#3657;&#3609;&#3627;&#3634;&#3626;&#3656;&#3623;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(23319,648,'hi','à¤ªà¤¾à¤ˆ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(23320,648,'ms','Tidak dapat mencari pai',0),(23321,648,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠ',0),(23322,648,'fr','Tarte est introuvable',0),(23323,648,'jp','ãƒ‘ã‚¤ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(23324,648,'pt','NÃ£o foi possÃ­vel encontrar torta',0),(23325,648,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ Ð¿Ð¸Ñ€Ð¾Ð³',0),(23326,648,'es','No se podÃ­a encontrar pastel',0),(23327,648,'de','Pie konnte nicht gefunden werden.',0),(23328,648,'en','Could not find pie',0),(23329,649,'is','',0),(23330,649,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´  Ù†ÙŠØ³Øª',0),(23331,649,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´  Ù†ÙŠØ³Øª',0),(23332,649,'tr','Hisse senedi dÃ¼zenlemek iÃ§in bulunamadÄ±',0),(23333,649,'pl','Nie mogÅ‚em znaleÅºÄ‡ czas, aby edytowaÄ‡',0),(23334,649,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ ÑÑŠÑÑ‚Ð°Ð² Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(23335,649,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³Ù¹Ø§Ú© Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§',0),(23336,649,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(23337,649,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ ng Ä‘á»ƒ sá»­a',0),(23338,649,'af','Nie instaat om Voorraad te Vind om te Redigeer',0),(23339,649,'ro','Nu am putut gÄƒsi stoc pentru a edita',0),(23340,649,'et','Stock redigeerimiseks ei leitud',0),(23341,649,'si','Strjena lava ne odkriti staleÅ¾ za urejanje',0),(23342,649,'ba','Tidak dapat menemukan saham untuk mengedit',0),(23343,649,'nl','Konden niet vondst voorraad om te bewerken',0),(23344,649,'fi','Ei lÃ¶ydy varastossa muokkaaminen',0),(23345,649,'no','Finner ikke lager redigere',0),(23346,649,'da','Kunne ikke finde materiel til at redigere',0),(23347,649,'ko','íŽ¸ì§‘ í•˜ë ¤ë©´ ì£¼ì‹ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23348,649,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×”×ž× ×™×•×ª ×›×“×™ ×œ×¢×¨×•×š',0),(23349,649,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(23350,649,'zh','æ‰¾ä¸åˆ°è‚¡ç¥¨ç¼–è¾‘\r\n',0),(23351,649,'sv','Kunde inte hitta lager att redigera',0),(23352,649,'it','Non poteva trovare stock di modificare',0),(23353,649,'tl','',0),(23354,649,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3588;&#3657;&#3609;&#3627;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3607;&#3637;&#3656;&#3592;&#3632;&#3649;&#3585;&#3657;&#3652;&#3586;&#3652;&#3604;&#3',0),(23355,649,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤² à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(23356,649,'ms','Tidak dapat mencari saham untuk mengedit',0),(23357,649,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ© ØªØ­Ø±ÙŠØ±',0),(23358,649,'fr','Stock d\'Ã©diter est introuvable',0),(23359,649,'jp','ç·¨é›†ã?™ã‚‹åœ¨åº«ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(23360,649,'pt','NÃ£o foi possÃ­vel encontrar o estoque para editar',0),(23361,649,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ ÑÐºÐ»Ð°Ð´Ðµ Ð´Ð»Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(23362,649,'es','No se puede encontrar existencia para editar',0),(23363,649,'de','Lager bearbeiten konnte nicht gefunden werden.',0),(23364,649,'en','Could not find stock to edit',0),(23365,650,'is','',0),(23366,650,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù…ÙˆØ§Ø±Ø¯ Ù…ØµØ±ÙÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±   Ù†ÙŠØ³Øª',0),(23367,650,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù…ÙˆØ§Ø±Ø¯ Ù…ØµØ±ÙÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±   Ù†ÙŠØ³Øª',0),(23368,650,'tr','Stok kullanÄ±mÄ± bulunamadÄ±',0),(23369,650,'pl','Nie mogÅ‚em znaleÅºÄ‡ czas uÅ¼ytkowania',0),(23370,650,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ',0),(23371,650,'ur','Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§',0),(23372,650,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ðµ',0),(23373,650,'vi','KhÃ´ng tÃ¬m tháº¥y báº£ng sá»­ dá»¥ng hÃ ng tá»“n',0),(23374,650,'af','Nie instaat om Voorraadgebruik te Vind',0),(23375,650,'ro','Nu am putut gÄƒsi stoc de utilizare',0),(23376,650,'et','Ei leidnud varude kasutamine',0),(23377,650,'si','Zalog uporabe ni bilo mogoÄe najti.',0),(23378,650,'ba','Tidak dapat menemukan penggunaan saham',0),(23379,650,'nl','Konden niet vondst voorraad gebruik',0),(23380,650,'fi','Ei lÃ¶ydy varastossa kÃ¤yttÃ¶',0),(23381,650,'no','Finner ikke lagerforbruket',0),(23382,650,'da','Kunne ikke finde stock skik',0),(23383,650,'ko','ì‚¬ì§„ ì‚¬ìš©ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23384,650,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×”×©×™×ž×•×© ×ž× ×™×•×ª',0),(23385,650,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï‡ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(23386,650,'zh','æ‰¾ä¸åˆ°è‚¡ç¥¨ç”¨æ³•\r\n',0),(23387,650,'sv','Kunde inte hitta lageranvÃ¤ndningen',0),(23388,650,'it','Non poteva trovare uso magazzino',0),(23389,650,'tl','',0),(23390,650,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3588;&#3657;&#3609;&#3627;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;',0),(23391,650,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(23392,650,'ms','Tidak dapat mencari stok penggunaan',0),(23393,650,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù…',0),(23394,650,'fr','N\'a pas trouvÃ© son utilisation stock',0),(23395,650,'jp','åœ¨åº«ä½¿ç”¨ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(23396,650,'pt','NÃ£o foi possÃ­vel encontrar o uso das aÃ§Ãµes',0),(23397,650,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ Ñ€Ð°ÑÑ…Ð¾Ð´Ð°',0),(23398,650,'es','No se puede encontrar uso de existencia',0),(23399,650,'de','Lager Verwendung konnte nicht gefunden werden.',0),(23400,650,'en','Could not find stock usage',0),(23401,651,'is','',0),(23402,651,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ù†ÙŠØ³Øª',0),(23403,651,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ù†ÙŠØ³Øª',0),(23404,651,'tr','GÃ¶nderemedik.',0),(23405,651,'pl','Nie moÅ¼na zaksiÄ™gowaÄ‡.',0),(23406,651,'bg','Ð”Ð° Ð½Ðµ Ð¿ÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ñ‚Ðµ.',0),(23407,651,'ur','Ù¾ÙˆØ³Ù¹ Ø³Ú©ØªØ§ ÛÛ’ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(23408,651,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³Ð°Ð¾ Ð´Ð° Ð¾Ð±Ñ˜Ð°Ð²Ð¸.',0),(23409,651,'vi','KhÃ´ng tÃ¬m tháº¥y káº¿t chuyá»ƒn',0),(23410,651,'af','Kon nie pos.',0),(23411,651,'ro','Ar putea posta.',0),(23412,651,'et','Postitamine.',0),(23413,651,'si','Mogli objaviti.',0),(23414,651,'ba','Tidak bisa posting.',0),(23415,651,'nl','Kan niet plaatsen.',0),(23416,651,'fi','Ei voitu kirjata.',0),(23417,651,'no','Kunne ikke innlegg.',0),(23418,651,'da','Kunne ikke bogfÃ¸res.',0),(23419,651,'ko','ê²Œì‹œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23420,651,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×¨×©×•×.',0),(23421,651,'el','Î˜Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµs ÏŒÏ‡Î¹ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÏŽ.',0),(23422,651,'zh','æ— æ³•å‘å¸ƒ\r\n',0),(23423,651,'sv','Gick inte att bokfÃ¶ra.',0),(23424,651,'it','Non si potrebbe postare.',0),(23425,651,'tl','',0),(23426,651,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3604;&#3657;',0),(23427,651,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡à¥¤',0),(23428,651,'ms','Tidak dapat menghantar.',0),(23429,651,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ±Ø­ÙŠÙ„.',0),(23430,651,'fr','Ne pouvait.',0),(23431,651,'jp','è¨ˆä¸Šã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(23432,651,'pt','NÃ£o poderia postar.',0),(23433,651,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ.',0),(23434,651,'es','No se puede asentar.',0),(23435,651,'de','Konnte nicht gesendet werden.',0),(23436,651,'en','Could not post.',0),(23437,652,'is','',0),(23438,652,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù† Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ø±Ø³Ø§Ù„  Ù†ÙŠØ³Øª',0),(23439,652,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù† Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ø±Ø³Ø§Ù„  Ù†ÙŠØ³Øª',0),(23440,652,'tr','  Unpost deÄŸil.',0),(23441,652,'pl','  MoÅ¼e nie unpost.',0),(23442,652,'bg','  ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° unpost.',0),(23443,652,'ur','  Ø§Ù†Ù¾ÙˆØ³Ù¹ Ø³Ú©ØªØ§ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(23444,652,'sr','  ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³Ð°Ð¾ Ð´Ð° Ð¿Ð¾Ð²ÑƒÐ¸Ðµ.',0),(23445,652,'vi','KhÃ´ng thá»ƒ Ä‘á»•i thÃ nh chÆ°a káº¿t chuyá»ƒn',0),(23446,652,'af','  Kon nie onposteer.',0),(23447,652,'ro','  Nu ar putea unpost.',0),(23448,652,'et','  VÃµiks unpost.',0),(23449,652,'si','  Bi ne unpost.',0),(23450,652,'ba','  Tidak bisa unpost.',0),(23451,652,'nl','  Kan niet unpost.',0),(23452,652,'fi','  Voi ei unpost.',0),(23453,652,'no','  Kan ikke unpost.',0),(23454,652,'da','  Kunne ikke unpost.',0),(23455,652,'ko','  Unpost ì•ˆ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23456,652,'he','  ×œ× ×™×›×•×œ unpost.',0),(23457,652,'el','  Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± unpost.',0),(23458,652,'zh','æ— æ³•å–æ¶ˆèŒä½',0),(23459,652,'sv','  Kunde inte unpost.',0),(23460,652,'it','  Non poteva unpost.',0),(23461,652,'tl','',0),(23462,652,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3604;&#3657;',0),(23463,652,'hi','  Unpost à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾à¥¤',0),(23464,652,'ms','  Boleh unpost.',0),(23465,652,'ar','  Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† Ø£ÙˆÙ†Ø¨ÙˆØ³Øª.',0),(23466,652,'fr','  Pouvait pas unpost.',0),(23467,652,'jp','æœªè¨ˆä¸Šã?«ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(23468,652,'pt','  NÃ£o poderia unpost.',0),(23469,652,'ru','  ÐœÐ¾Ð¶ÐµÑ‚ Ð½Ðµ unpost.',0),(23470,652,'es','No se puede quitar.',0),(23471,652,'de','  Konnte nicht unpost.',0),(23472,652,'en','  Could not unpost.',0),(23473,653,'is','',0),(23474,653,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù†ÙŠØ³Øª',0),(23475,653,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù†ÙŠØ³Øª',0),(23476,653,'tr','  GÃ¼ncelleÅŸtirin.',0),(23477,653,'pl','  Nie moÅ¼na zaktualizowaÄ‡.',0),(23478,653,'bg','  ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°.',0),(23479,653,'ur','  Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø³Ú©Ø§ Ù†ÛÛŒÚº Û”',0),(23480,653,'sr','  ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ð¸.',0),(23481,653,'vi','KhÃ´ng Cáº­p Nháº­t ÄÆ°á»£c',0),(23482,653,'af','   Nie instaat om te opdateer.',0),(23483,653,'ro','  Imposibil de actualizat.',0),(23484,653,'et','  Ei saanud vÃ¤rskendada.',0),(23485,653,'si','  Ni bilo mogoÄe posodobiti.',0),(23486,653,'ba','  Tidak dapat memperbarui.',0),(23487,653,'nl','  Kon niet worden bijgewerkt.',0),(23488,653,'fi','  Ei voitu pÃ¤ivittÃ¤Ã¤.',0),(23489,653,'no','  Kan ikke oppdatere.',0),(23490,653,'da','  Kunne ikke opdateres.',0),(23491,653,'ko','  ì—…ë°ì´íŠ¸í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23492,653,'he','  ×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×¢×“×›×Ÿ.',0),(23493,653,'el','  Î”ÎµÎ½ Î®Ï„Î±Î½ Î´Ï…Î½Î±Ï„Î® Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·.',0),(23494,653,'zh','æ— æ³•æ›´æ–°',0),(23495,653,'sv','  Kunde inte uppdatera.',0),(23496,653,'it','  Impossibile aggiornare.',0),(23497,653,'tl','',0),(23498,653,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3652;&#3604;&#3657;',0),(23499,653,'hi','  à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¾à¥¤',0),(23500,653,'ms','  Tidak dapat mengemaskini.',0),(23501,653,'ar','  Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­Ø¯ÙŠØ«.',0),(23502,653,'fr','  Ne pourrait pas mettre Ã  jour.',0),(23503,653,'jp','æ›´æ–°ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(23504,653,'pt','  NÃ£o foi possÃ­vel atualizar.',0),(23505,653,'ru','  ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ.',0),(23506,653,'es','No se puede actualizar.',0),(23507,653,'de','  Konnte nicht aktualisiert werden.',0),(23508,653,'en','  Could not update.',0),(23509,654,'is','',0),(23510,654,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù†ÙŠØ³Øª Ø²ÙŠØ±Ø§',0),(23511,654,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù†ÙŠØ³Øª Ø²ÙŠØ±Ø§',0),(23512,654,'tr','Ã‡Ã¼nkÃ¼ GÃœNCELLEÅžTÄ°RÄ°LEMEDÄ°',0),(23513,654,'pl','NIE moÅ¼na zaktualizowaÄ‡ bo',0),(23514,654,'bg','ÐÐ• Ð¼Ð¾Ð¶Ð° Ð´Ð° ÐÐšÐ¢Ð£ÐÐ›Ð˜Ð—Ð˜Ð Ð Ð·Ð°Ñ‰Ð¾Ñ‚Ð¾',0),(23515,654,'ur','Ú©ÛŒÙˆÙ†Ú©Û ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(23516,654,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÐÐ–Ð£Ð Ð˜Ð ÐÐ¢Ð˜ Ñ˜ÐµÑ€',0),(23517,654,'vi','KhÃ´ng Cáº­p Nháº­t ÄÆ°á»£c bá»Ÿi vÃ¬',0),(23518,654,'af','OPDATERING KON NIE UITGEVOER WORD NIE omdat',0),(23519,654,'ro','NU se poate actualiza, deoarece',0),(23520,654,'et','EI saanud VÃ„RSKENDADA, sest',0),(23521,654,'si','NI bilo mogoÄe posodobiti, ker',0),(23522,654,'ba','TIDAK dapat memperbarui karena',0),(23523,654,'nl','KON niet worden bijgewerkt omdat',0),(23524,654,'fi','EI voitu pÃ¤ivittÃ¤Ã¤, koska',0),(23525,654,'no','KAN ikke oppdatere fordi',0),(23526,654,'da','KUNNE ikke opdatere fordi',0),(23527,654,'ko','ë•Œë¬¸ì— ì—…ë°ì´íŠ¸í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23528,654,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×¢×“×›×Ÿ ×›×™',0),(23529,654,'el','Î”Î•Î Î®Ï„Î±Î½ Î´Ï…Î½Î±Ï„Î® Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î´Î¹ÏŒÏ„Î¹',0),(23530,654,'zh','å› ä¸ºæ— æ³•æ›´æ–°\r\n',0),(23531,654,'sv','KUNDE inte uppdatera eftersom',0),(23532,654,'it','Impossibile aggiornare perchÃ©',0),(23533,654,'tl','',0),(23534,654,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3652;&#3604;&#3657;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3592;&#3634;&#3585;',0),(23535,654,'hi','à¤•à¥à¤¯à¥‹à¤‚à¤•à¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¾',0),(23536,654,'ms','TIDAK dapat mengemaskini kerana',0),(23537,654,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„ØªØ­Ø¯ÙŠØ« Ù„Ø£Ù† ',0),(23538,654,'fr','Ne pourrait pas mettre Ã  jour parce que',0),(23539,654,'jp','æ¬¡ã?®ç?†ç”±ã?§æ›´æ–°ã?§ã??ã?¾ã?›ã‚“',0),(23540,654,'pt','NÃ£o foi possÃ­vel atualizar porque',0),(23541,654,'ru','ÐÐ•Ð’ÐžÐ—ÐœÐžÐ–ÐÐž ÐžÐ‘ÐÐžÐ’Ð˜Ð¢Ð¬ Ð¸Ð·-Ð·Ð°',0),(23542,654,'es','NO SE PUEDE ACTUALIZAR porque',0),(23543,654,'de','KONNTE nicht weil aktualisieren',0),(23544,654,'en','COULD NOT UPDATE because',0),(23545,655,'is','',0),(23546,655,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù†ÙˆØ´ØªÙ† Ø¯Ø± ÙØ§ÙŠÙ„  Ù†ÙŠØ³Øª',0),(23547,655,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù†ÙˆØ´ØªÙ† Ø¯Ø± ÙØ§ÙŠÙ„  Ù†ÙŠØ³Øª',0),(23548,655,'tr','Dosyaya yazÄ±lamadÄ±',0),(23549,655,'pl','Nie moÅ¼na zapisaÄ‡ do pliku',0),(23550,655,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ð¸ÑˆÐµ Ð²ÑŠÐ² Ñ„Ð°Ð¹Ð»Ð°',0),(23551,655,'ur','Ù…Ø³Ù„ Ú©Ùˆ Ù†ÛÛŒÚº Ù„Ú©Ú¾ Ø³Ú©Ø§',0),(23552,655,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÑƒÐ¿Ð¸ÑÐ°Ñ‚Ð¸ Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(23553,655,'vi','KhÃ´ng viáº¿t Ä‘Æ°á»£c vÃ o há»“ sÆ¡',0),(23554,655,'af','Kon nie na lÃªer skryf nie',0),(23555,655,'ro','Nu poate scrie la fiÅŸier',0),(23556,655,'et','VÃµiks kirjutada faili',0),(23557,655,'si','Mogel pisati v datoteko',0),(23558,655,'ba','Tidak dapat menulis ke file',0),(23559,655,'nl','Kan niet schrijven naar bestand',0),(23560,655,'fi','Ei voinut kirjoittaa tiedoston',0),(23561,655,'no','Kan ikke skrive til filen',0),(23562,655,'da','Kunne ikke skrive til fil',0),(23563,655,'ko','íŒŒì¼ì— ì“¸ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23564,655,'he','×œ× ×™×›×•×œ ×œ×›×ª×•×‘ ×§×•×‘×¥',0),(23565,655,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î³ÏÎ¬ÏˆÎµÎ¹ ÏƒÏ„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(23566,655,'zh','æ— æ³•å†™å…¥æ–‡ä»¶\r\n',0),(23567,655,'sv','Kunde inte skriva till fil',0),(23568,655,'it','Impossibile scrivere il file.',0),(23569,655,'tl','',0),(23570,655,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3586;&#3637;&#3618;&#3609;&#3652;&#3611;&#3607;&#3637;&#3656;&#3649;&#3615;&#3657;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3652;&#3604;&#3657;',0),(23571,655,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¤° à¤¨à¤¹à¥€à¤‚ à¤²à¤¿à¤– à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(23572,655,'ms','Tidak dapat menulis ke fail',0),(23573,655,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„ÙƒØªØ§Ø¨Ø© Ø¥Ù„Ù‰ Ø§Ù„Ù…Ù„Ù',0),(23574,655,'fr','Ne peut pas Ã©crire dans le fichier',0),(23575,655,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?«æ›¸ã??è¾¼ã‚?ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(23576,655,'pt','NÃ£o foi possÃ­vel gravar para arquivo.',0),(23577,655,'ru','Ð’ Ñ„Ð°Ð¹Ð»Ðµ Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ð½ÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ',0),(23578,655,'es','No se podÃ­a escribir al archivo',0),(23579,655,'de','Konnte nicht in die Datei schreiben',0),(23580,655,'en','Could not write to file',0),(23581,656,'is','',0),(23582,656,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø®ÙˆØ§Ù†Ø¯Ù† Ù…Ù†Ùˆ Ù†ÙŠØ³Øª â€“ Ø§ÙƒÙ†ÙˆÙ† Ø®Ø§Ø±Ø¬ Ø´ÙˆÙŠØ¯ ',0),(23583,656,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø®ÙˆØ§Ù†Ø¯Ù† Ù…Ù†Ùˆ Ù†ÙŠØ³Øª â€“ Ø§ÙƒÙ†ÙˆÙ† Ø®Ø§Ø±Ø¬ Ø´ÙˆÙŠØ¯ ',0),(23584,656,'tr','MenÃ¼ - ÅŸimdi Ã§Ä±karken okunamadÄ±',0),(23585,656,'pl','Nie moÅ¼na odczytaÄ‡ w menu - teraz zamykania',0),(23586,656,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð¿Ñ€Ð¾Ñ‡ÐµÑ‚Ðµ Ð¼ÐµÐ½ÑŽ - ÑÐµÐ³Ð° Ð¸Ð·Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(23587,656,'ur','Ù…ÛŒÙ†ÛŒÙˆ - Ø§Ø¨ Ø®Ø±ÙˆØ¬ Ú©Ø§ Ù…Ø·Ø§Ù„Ø¹Û Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(23588,656,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚Ð¸ Ð¼ÐµÐ½Ð¸ - Ð¸Ð·Ð»Ð°Ð·Ð¸',0),(23589,656,'vi','KhÃ´ng Ä‘á»c Ä‘Æ°á»£c Menu - Ä‘ang tá»“n táº¡i',0),(23590,656,'af','Kon nie lees spyskaart - nou verlaat',0),(23591,656,'ro','Imposibil de citit meniul - acum ies',0),(23592,656,'et','VÃµiks lugeda menÃ¼Ã¼ - nÃ¼Ã¼d vÃ¤ljumine',0),(23593,656,'si','Ni bilo mogoÄe prebrati meni - zdaj izhod',0),(23594,656,'ba','Tidak bisa membaca menu - sekarang keluar',0),(23595,656,'nl','Menu - nu afsluiten kan niet worden gelezen',0),(23596,656,'fi','Ei voitu lukea menu - nyt poistuminen',0),(23597,656,'no','Kan ikke lese meny - nÃ¥ avslutter',0),(23598,656,'da','Kunne ikke lÃ¦se menu - nu spÃ¦ndende',0),(23599,656,'ko','ë©”ë‰´-ì§€ê¸ˆ ì¢…ë£Œë¥¼ ì½ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23600,656,'he','×œ× × ×™×ª×Ÿ ×œ×§×¨×•× ×ª×¤×¨×™×˜ - ×™×•×¦× ×›×¢×ª',0),(23601,656,'el','Î”ÎµÎ½ Î®Ï„Î±Î½ Î´Ï…Î½Î±Ï„Î® Î· Î±Î½Î¬Î³Î½Ï‰ÏƒÎ· Î¼ÎµÎ½Î¿Ï - Ï„ÏŽÏÎ± Ï„Î·Î½ Î­Î¾Î¿Î´Î¿',0),(23602,656,'zh','æ— æ³•è¯»å–èœå•- çŽ°åœ¨é€€å‡º\r\n',0),(23603,656,'sv','Kunde inte lÃ¤sa menyn - nu spÃ¤nnande',0),(23604,656,'it','Non sapeva leggere il menÃ¹ - ora uscendo dalla',0),(23605,656,'tl','',0),(23606,656,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3629;&#3656;&#3634;&#3609;&#3648;&#3617;&#3609;&#3641; &#3585;&#3635;&#3621;&#3633;&#3591;&#3629;&#3629;&#3585;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(23607,656,'hi','à¤…à¤¬ à¤¨à¤¿à¤•à¤² à¤®à¥‡à¤¨à¥‚ - à¤ªà¤¢à¤¼à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤¸à¤•à¤¾',0),(23608,656,'ms','Tidak dapat membaca menu - sekarang Keluar',0),(23609,656,'ar','Ù‚Ø±Ø§Ø¡Ø© Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© ØºÙŠØ± Ù…Ù…ÙƒÙ†Ø© - Ø³ÙŠØªÙ… Ø§Ù„Ø®Ø±ÙˆØ¬ Ø§Ù„Ø¢Ù†',0),(23610,656,'fr','Impossible d\'accÃ©der au menu - sortie ...',0),(23611,656,'jp','ãƒ¡ãƒ‹ãƒ¥ãƒ¼ã?Œèª­ã?¿è¾¼ã‚?ã?¾ã?›ã‚“ã?§ã?—ã?Ÿãƒ¼çµ‚äº†ã?—ã?¦ã?„ã?¾ã?™',0),(23612,656,'pt','NÃ£o foi possÃ­vel ler o menu - saindo agora',0),(23613,656,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð¼ÐµÐ½ÑŽ - Ñ‚ÐµÐ¿ÐµÑ€ÑŒ ÑƒÐ´Ð°Ð»Ð¸Ð»Ð¸ÑÑŒ',0),(23614,656,'es','No se podÃ­a leer el MenuÃº - Saliendo Ahora',0),(23615,656,'de','MenÃ¼ - jetzt beenden konnte nicht gelesen werden.',0),(23616,656,'en','Could not read menu - now exiting',0),(23617,657,'is','',0),(23618,657,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø®ÙˆØ§Ù†Ø¯Ù† Ù…Ø¬ÙˆØ²  ÙƒØ§Ø±Ø¨Ø±  Ù†ÙŠØ³Øª â€“ Ø§ÙƒÙ†ÙˆÙ† Ø®Ø§Ø±Ø¬ Ø´ÙˆÙŠØ¯ ',0),(23619,657,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø®ÙˆØ§Ù†Ø¯Ù† Ù…Ø¬ÙˆØ²  ÙƒØ§Ø±Ø¨Ø±  Ù†ÙŠØ³Øª â€“ Ø§ÙƒÙ†ÙˆÙ† Ø®Ø§Ø±Ø¬ Ø´ÙˆÙŠØ¯ ',0),(23620,657,'tr','KullanÄ±cÄ± izinleri - ÅŸimdi Ã§Ä±karken okunamadÄ±',0),(23621,657,'pl','Nie moÅ¼na odczytaÄ‡ uprawnieÅ„ uÅ¼ytkownika - teraz zamykania',0),(23622,657,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð¿Ñ€Ð¾Ñ‡ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð²Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ - ÑÐµÐ³Ð° Ð¸Ð·Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(23623,657,'ur','ØµØ§Ø±Ù Ø§Ø¬Ø§Ø²ØªÛŒÚº - Ø§Ø¨ Ø®Ø±ÙˆØ¬ Ú©Ø§ Ù…Ø·Ø§Ù„Ø¹Û Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(23624,657,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ðµ - Ð¸Ð·Ð»Ð°Ð·Ð¸',0),(23625,657,'vi','KhÃ´ng Ä‘á»c Ä‘Æ°á»£c quyá»n cá»§a NgÆ°á»i Sá»­ Dá»¥ng - Ä‘ang thoÃ¡t ra',0),(23626,657,'af','Nie instaat om gebruikervergunnings te lees nie - verlaat stelsel nou',0),(23627,657,'ro','Imposibil de citit permisiunile utilizatorului - acum ies',0),(23628,657,'et','Saanud lugeda, kasutaja Ãµiguste - nÃ¼Ã¼d vÃ¤ljumine',0),(23629,657,'si','Ni bilo mogoÄe prebrati uporabniÅ¡ka dovoljenja - zdaj izhod',0),(23630,657,'ba','Tidak bisa membaca izin pengguna - sekarang keluar',0),(23631,657,'nl','Gebruikersmachtigingen - nu afsluiten kan niet worden gelezen',0),(23632,657,'fi','Ei voitu lukea kÃ¤yttÃ¶oikeuksia - nyt poistuminen',0),(23633,657,'no','Kan ikke lese brukertillatelser - nÃ¥ avslutter',0),(23634,657,'da','Kunne ikke lÃ¦se brugertilladelser - nu spÃ¦ndende',0),(23635,657,'ko','ì‚¬ìš©ìž ê¶Œí•œ-ì§€ê¸ˆ ì¢…ë£Œë¥¼ ì½ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(23636,657,'he','×œ× × ×™×ª×Ÿ ×œ×§×¨×•× ×”×¨×©××•×ª ×ž×©×ª×ž×© - ×™×•×¦× ×›×¢×ª',0),(23637,657,'el','Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î´Î¹Î±Î²Î¬ÏƒÎµÎ¹ Ï„Î± Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï‡ÏÎ®ÏƒÏ„Î· - Ï„ÏŽÏÎ± Ï„Î·Î½ Î­Î¾Î¿Î´Î¿',0),(23638,657,'zh','æ— æ³•è¯»å–ç”¨æˆ·æƒé™- çŽ°åœ¨é€€å‡º\r\n',0),(23639,657,'sv','Kunde inte lÃ¤sa anvÃ¤ndarbehÃ¶righeter - nu spÃ¤nnande',0),(23640,657,'it','Non leggere le autorizzazioni utente - ora uscendo dalla',0),(23641,657,'tl','',0),(23642,657,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3629;&#3656;&#3634;&#3609;&#3626;&#3636;&#3607;&#3608;&#3636;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657; &#3585;&#3635;&#3621;&#3633;&#3591;&#3629;&#3629;&#3585;&#3605;&#',0),(23643,657,'hi','à¤…à¤¬ à¤¨à¤¿à¤•à¤² à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤¨à¥à¤®à¤¤à¤¿à¤¯à¤¾à¤ - à¤ªà¤¢à¤¼à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤¸à¤•à¤¾',0),(23644,657,'ms','Tidak dapat membaca kebenaran pengguna - sekarang Keluar',0),(23645,657,'ar','Ù‚Ø±Ø§Ø¡Ø© ØµÙ„Ø§Ø­ÙŠØ§Øª Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† ØºÙŠØ± Ù…Ù…ÙƒÙ†Ø© - Ø³ÙŠØªÙ… Ø§Ù„Ø®Ø±ÙˆØ¬ Ø§Ù„Ø¢Ù†',0),(23646,657,'fr','Impossible d\'accÃ©der aux permissions d\'utilisateur - sortie ...',0),(23647,657,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ‰¿èª?ã?Œèª­ã?¿è¾¼ã‚?ã?¾ã?›ã‚“ã?§ã?—ã?Ÿãƒ¼çµ‚äº†ã?—ã?¦ã?„ã?¾ã?™',0),(23648,657,'pt','NÃ£o conseguia ler as permissÃµes de usuÃ¡rio - saindo agora',0),(23649,657,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ - Ñ‚ÐµÐ¿ÐµÑ€ÑŒ ÑƒÐ´Ð°Ð»Ð¸Ð»Ð¸ÑÑŒ',0),(23650,657,'es','No se podÃ­a leer permisiones de usuarios - Saliendo Ahora',0),(23651,657,'de','Benutzerberechtigungen - jetzt beenden konnte nicht gelesen werden.',0),(23652,657,'en','Could not read user permissions - now exiting',0),(23653,658,'is','',0),(23654,658,'dr','Ø´Ù…Ø§Ø±Ø´',0),(23655,658,'pr','Ø´Ù…Ø§Ø±Ø´',0),(23656,658,'tr','Count',0),(23657,658,'pl','Hrabia',0),(23658,658,'bg','Ð‘Ñ€Ð¾Ð¹',0),(23659,658,'ur','Ú¯Ù†ØªÛŒ',0),(23660,658,'sr','Ð“Ñ€Ð¾Ñ„',0),(23661,658,'vi','Äáº¿m',0),(23662,658,'af','Telling',0),(23663,658,'ro','Contele',0),(23664,658,'et','Krahv',0),(23665,658,'si','Count',0),(23666,658,'ba','Count',0),(23667,658,'nl','Graaf',0),(23668,658,'fi','MÃ¤Ã¤rÃ¤',0),(23669,658,'no','Antall',0),(23670,658,'da','Grev',0),(23671,658,'ko','ì¹´ìš´íŠ¸',0),(23672,658,'he','×¡×¤×™×¨×”',0),(23673,658,'el','Î‘ÏÎ¯Î¸Î¼Î·ÏƒÎ·',0),(23674,658,'zh','è®¡æ•°\r\n',0),(23675,658,'sv','Greve',0),(23676,658,'it','Conte',0),(23677,658,'tl','',0),(23678,658,'th','&#3609;&#3633;&#3610;',0),(23679,658,'hi','à¤—à¤¿à¤¨à¤¤à¥€',0),(23680,658,'ms','Kiraan',0),(23681,658,'ar','Ø§Ù„Ø¹Ø¯',0),(23682,658,'fr','Comte',0),(23683,658,'jp','STR_CURRENT_COUNT',0),(23684,658,'pt','Contagem',0),(23685,658,'ru','Ð¤Ð¾Ñ‚Ð¾',0),(23686,658,'es','Conteo',0),(23687,658,'de','Count',0),(23688,658,'en','Count',0),(23689,659,'is','',0),(23690,659,'dr','ÙƒØ´ÙˆØ±',0),(23691,659,'pr','ÙƒØ´ÙˆØ±',0),(23692,659,'tr','Ãœlke',0),(23693,659,'pl','Kraju',0),(23694,659,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð°',0),(23695,659,'ur','Ù…Ù„Ú©',0),(23696,659,'sr','Ð—ÐµÐ¼Ñ™Ð°',0),(23697,659,'vi','Äáº¥t nÆ°á»›c',0),(23698,659,'af','Land',0),(23699,659,'ro','Tara',0),(23700,659,'et','Riik',0),(23701,659,'si','DrÅ¾avi',0),(23702,659,'ba','Negara',0),(23703,659,'nl','Land',0),(23704,659,'fi','Maan',0),(23705,659,'no','Land',0),(23706,659,'da','Land',0),(23707,659,'ko','êµ­ê°€',0),(23708,659,'he','×ž×“×™× ×”',0),(23709,659,'el','Î§ÏŽÏÎ±',0),(23710,659,'zh','å›½å®¶\r\n',0),(23711,659,'sv','Land',0),(23712,659,'it','Paese',0),(23713,659,'tl','',0),(23714,659,'th','&#3611;&#3619;&#3632;&#3648;&#3607;&#3624;',0),(23715,659,'hi','à¤¦à¥‡à¤¶',0),(23716,659,'ms','Negara',0),(23717,659,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(23718,659,'fr','Pays',0),(23719,659,'jp','å›½',0),(23720,659,'pt','PaÃ­s',0),(23721,659,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð°',0),(23722,659,'es','PaÃ­s',0),(23723,659,'de','Land',0),(23724,659,'en','Country',0),(23725,660,'is','',0),(23726,660,'dr','( ØµÙˆØ±ØªÙ‡Ø§ÙŠ Ù…Ø§Ù„ÙŠ',0),(23727,660,'pr','Ø¨Ø±Ø±Ø³ÙŠ( ØµÙˆØ±ØªÙ‡Ø§ÙŠ Ù…Ø§Ù„ÙŠ',0),(23728,660,'tr','Kapsama alanÄ±',0),(23729,660,'pl','ZasiÄ™g',0),(23730,660,'bg','ÐŸÐ¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ',0),(23731,660,'ur','Ú©ÙˆØ±ÛŒØ¬',0),(23732,660,'sr','ÐŸÐ¾ÐºÑ€Ð¸Ð²ÐµÐ½Ð¾ÑÑ‚',0),(23733,660,'vi','Bao phá»§',0),(23734,660,'af','Dekking',0),(23735,660,'ro','Acoperire',0),(23736,660,'et','Katvus',0),(23737,660,'si','Pokritost',0),(23738,660,'ba','Cakupan',0),(23739,660,'nl','Dekking',0),(23740,660,'fi','Kattavuus',0),(23741,660,'no','Dekning',0),(23742,660,'da','DÃ¦kning',0),(23743,660,'ko','ì ìš© ë²”ìœ„',0),(23744,660,'he','×›×™×¡×•×™',0),(23745,660,'el','ÎšÎ¬Î»Ï…ÏˆÎ·',0),(23746,660,'zh','è¦†ç›–\r\n',0),(23747,660,'sv','TÃ¤ckning',0),(23748,660,'it','Copertura',0),(23749,660,'tl','',0),(23750,660,'th','&#3588;&#3640;&#3657;&#3617;&#3588;&#3619;&#3629;&#3591;',0),(23751,660,'hi','à¤•à¤µà¤°à¥‡à¤œ',0),(23752,660,'ms','Perlindungan',0),(23753,660,'ar','Ø§Ù„ØªØºØ·ÙŠØ©',0),(23754,660,'fr','Couverture',0),(23755,660,'jp','å¯¾è±¡ç¯„å›²',0),(23756,660,'pt','Cobertura',0),(23757,660,'ru','ÐžÑÐ²ÐµÑ‰ÐµÐ½Ð¸Ðµ',0),(23758,660,'es','Cobertura',0),(23759,660,'de','Abdeckung',0),(23760,660,'en','Coverage',0),(23761,661,'is','',0),(23762,661,'dr','ÙƒØ¯Ø§Ù… ÙƒØ§Ø±Ù…Ù†Ø¯ Ø±Ø§ Ù¾ÙˆØ´Ø´ Ù…ÙŠØ¯Ù‡Ø¯ØŸ',0),(23763,661,'pr','ÙƒØ¯Ø§Ù… ÙƒØ§Ø±Ù…Ù†Ø¯ Ø±Ø§ Ù¾ÙˆØ´Ø´ Ù…ÙŠØ¯Ù‡Ø¯ØŸ',0),(23764,661,'tr','Hangi iÅŸÃ§i kapsar?',0),(23765,661,'pl','Obejmuje pracownikÃ³w, ktÃ³rych?',0),(23766,661,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÐºÐ¾Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ†Ð¸?',0),(23767,661,'ur','Ø¬Ù† Ú©Ø§Ø±Ú©Ù†ÙˆÚº Ú©Ø§ Ø§Ø­Ø§Ø·Û Ú©Ø±ØªØ§ ÛÛ’ØŸ',0),(23768,661,'sr','ÐŸÐ¾ÐºÑ€Ð¸Ð²Ð° ÐºÐ¾Ñ˜Ð¸ Ñ€Ð°Ð´Ð½Ð¸Ñ†Ð¸?',0),(23769,661,'vi','Bao phá»§ cÃ´ng nhÃ¢n nÃ o?',0),(23770,661,'af','Dek watter werkers?',0),(23771,661,'ro','AcoperÄƒ care lucrÄƒtorii?',0),(23772,661,'et','HÃµlmab, millega tÃ¶Ã¶tajad?',0),(23773,661,'si','Zajema delavci?',0),(23774,661,'ba','Mencakup pekerja yang?',0),(23775,661,'nl','Omvat waaraan de werknemers?',0),(23776,661,'fi','Kattaa tyÃ¶ntekijÃ¶itÃ¤?',0),(23777,661,'no','Dekker som arbeidere?',0),(23778,661,'da','DÃ¦kker som arbejdstagere?',0),(23779,661,'ko','ì»¤ë²„ëŠ” ë…¸ë™ìž?',0),(23780,661,'he','×ž×›×¡×” ××©×¨ ×¢×•×‘×“×™×?',0),(23781,661,'el','ÎšÎ±Î»ÏÏ€Ï„ÎµÎ¹ Ï„Î·Î½ Î¿Ï€Î¿Î¯Î± ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½;',0),(23782,661,'zh','æ¶µç›–å“ªä¸ªå·¥äººï¼Ÿ\r\n',0),(23783,661,'sv','TÃ¤cker som arbetare?',0),(23784,661,'it','Copre quali lavoratori?',0),(23785,661,'tl','',0),(23786,661,'th','&#3588;&#3640;&#3657;&#3617;&#3588;&#3619;&#3629;&#3591;&#3612;&#3641;&#3657;&#3607;&#3635;&#3591;&#3634;&#3609;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3627;&#3609;?',0),(23787,661,'hi','à¤•à¥Œà¤¨ à¤¸à¤¾ à¤•à¤¾à¤°à¥à¤¯à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾?',0),(23788,661,'ms','Meliputi pekerja yang mana?',0),(23789,661,'ar','ÙˆÙŠØºØ·ÙŠ ÙÙŠÙ‡Ø§ Ø§Ù„Ø¹Ù…Ø§Ù„ØŸ',0),(23790,661,'fr','Couvre que les travailleurs ?',0),(23791,661,'jp','ã?©ã?®ä½œæ¥­å“¡ã‚’å¯¾è±¡ã?«ã?—ã?¾ã?™ã?‹?',0),(23792,661,'pt','Cobre que os trabalhadores?',0),(23793,661,'ru','ÐžÑ…Ð²Ð°Ñ‚Ñ‹Ð²Ð°ÐµÑ‚ ÐºÐ°ÐºÐ¸Ðµ Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ðµ?',0),(23794,661,'es','Cubrir cuales trabajadores',0),(23795,661,'de','Deckt die Arbeitnehmer?',0),(23796,661,'en','Covers which workers?',0),(23797,662,'is','',0),(23798,662,'dr','Ø§ÙŠØ¬Ø§Ø¯ÙƒØ±Ø¯Ù†',0),(23799,662,'pr','Ø§ÙŠØ¬Ø§Ø¯ÙƒØ±Ø¯Ù†',0),(23800,662,'tr','CR',0),(23801,662,'pl','CR',0),(23802,662,'bg','CR',0),(23803,662,'ur','Ø¨Ù†Ø§Ø¦ÛŒÚº Ø§ÛŒÚ© Ø¨ Ø­',0),(23804,662,'sr','Ð¦Ð ',0),(23805,662,'vi','CR',0),(23806,662,'af','CR',0),(23807,662,'ro','CR',0),(23808,662,'et','CR',0),(23809,662,'si','CR',0),(23810,662,'ba','CR',0),(23811,662,'nl','CR',0),(23812,662,'fi','OP',0),(23813,662,'no','CR',0),(23814,662,'da','CR',0),(23815,662,'ko','CR',0),(23816,662,'he','CR',0),(23817,662,'el','CR',0),(23818,662,'zh','å›žè½¦\r\n',0),(23819,662,'sv','CR',0),(23820,662,'it','CR',0),(23821,662,'tl','',0),(23822,662,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(23823,662,'hi','à¤¸à¥€. à¤†à¤°.',0),(23824,662,'ms','CR',0),(23825,662,'ar','Ø§Ù„Ø¬Ù…Ù‡ÙˆØ±ÙŠØ© Ø§Ù„ØªØ´ÙŠÙƒÙŠØ©',0),(23826,662,'fr','CR',0),(23827,662,'jp','CR',0),(23828,662,'pt','CR',0),(23829,662,'ru','CR',0),(23830,662,'es','CR',0),(23831,662,'de','CR',0),(23832,662,'en','CR',0),(23833,663,'is','',0),(23834,663,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(23835,663,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(23836,663,'tr','Yeni OluÅŸtur',0),(23837,663,'pl','Tworzenie nowych',0),(23838,663,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²',0),(23839,663,'ur','Ù†ÛŒØ§ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(23840,663,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜ Ð½Ð¾Ð²Ð¸',0),(23841,663,'vi','Táº¡o má»›i',0),(23842,663,'af','Skep Nuwe',0),(23843,663,'ro','Crearea de noi',0),(23844,663,'et','Loo uus',0),(23845,663,'si','Ustvari novo',0),(23846,663,'ba','Membuat baru',0),(23847,663,'nl','Nieuwe maken',0),(23848,663,'fi','Luo uusi',0),(23849,663,'no','Opprette nye',0),(23850,663,'da','Opret en ny',0),(23851,663,'ko','ìƒˆë¡œ ë§Œë“¤ê¸°',0),(23852,663,'he','×œ×™×¦×•×¨ ×—×“×©×•×ª',0),(23853,663,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î½Î­Ï‰Î½',0),(23854,663,'zh','æ–°å»º\r\n',0),(23855,663,'sv','Skapa nya',0),(23856,663,'it','Creare un nuovo',0),(23857,663,'tl','',0),(23858,663,'th','&#3626;&#3619;&#3657;&#3634;&#3591;',0),(23859,663,'hi','à¤¨à¤¯à¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(23860,663,'ms','Mencipta yang baru',0),(23861,663,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¬Ø¯ÙŠØ¯',0),(23862,663,'fr','CrÃ©er de nouvelles',0),(23863,663,'jp','æ–°è¦?ä½œæˆ?',0),(23864,663,'pt','Criar uma nova',0),(23865,663,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ðµ',0),(23866,663,'es','Crear Nuevo',0),(23867,663,'de','Neu erstellen',0),(23868,663,'en','Create New',0),(23869,664,'is','',0),(23870,664,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¶Ø§ÙÙ‰',0),(23871,664,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¶Ø§ÙÙ‰',0),(23872,664,'tr','Fazla Ã¶deme oluÅŸtur',0),(23873,664,'pl','Tworzenie nadpÅ‚aty',0),(23874,664,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð°Ð´Ð²Ð·ÐµÑ‚Ð¸Ñ‚Ðµ',0),(23875,664,'ur','Ø§ÙˆÙˆØ±Ù¾ÛŒÙ…Ø§Ù†Ù¹ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(23876,664,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¿Ñ€ÐµÐºÐ¾Ð¼ÐµÑ€Ð½Ñƒ',0),(23877,664,'vi','Táº¡o thanh toÃ¡n quÃ¡',0),(23878,664,'af','Skep Oorbetaling',0),(23879,664,'ro','SumÄƒ suplimentarÄƒ a crea',0),(23880,664,'et','Loo enammaksed',0),(23881,664,'si','Ustvarite preplaÄila',0),(23882,664,'ba','Membuat kelebihan pembayaran',0),(23883,664,'nl','Maken overbetaling',0),(23884,664,'fi','Luo liikaa',0),(23885,664,'no','Opprette overbetaling',0),(23886,664,'da','Oprette overbetaling',0),(23887,664,'ko','Overpayment ë§Œë“¤ê¸°',0),(23888,664,'he','×œ×™×¦×•×¨ ×ª×©×œ×•× ×™×ª×¨',0),(23889,664,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î±Ï‡ÏÎµÏ‰ÏƒÏ„Î®Ï„Ï‰Ï‚ ÎºÎ±Ï„Î±Î²Î»Î·Î¸Î­Î½Ï„Î¿Ï‚',0),(23890,664,'zh','åˆ›å»ºå¤šç¼´\r\n',0),(23891,664,'sv','Skapa Ã¶verbetalning',0),(23892,664,'it','Creare eccedenza',0),(23893,664,'tl','',0),(23894,664,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3618;&#3629;&#3604;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;',0),(23895,664,'hi','Overpayment à¤¬à¤¨à¤¾à¤à¤',0),(23896,664,'ms','Mencipta berlebihan',0),(23897,664,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø²Ø§Ø¦Ø¯Ø©',0),(23898,664,'fr','CrÃ©er le trop-payÃ©',0),(23899,664,'jp','é?Žæ‰•ã?„é‡‘ã?®ä½œæˆ?',0),(23900,664,'pt','Criar excedente',0),(23901,664,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¿ÐµÑ€ÐµÐ¿Ð»Ð°Ñ‚Ñ‹',0),(23902,664,'es','Crear Pago Excesivo',0),(23903,664,'de','Erstellen einer Ãœberzahlung',0),(23904,664,'en','Create Overpayment',0),(23905,665,'is','',0),(23906,665,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ú¯Ø²Ø§Ø±Ø´ ',0),(23907,665,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ú¯Ø²Ø§Ø±Ø´ ',0),(23908,665,'tr','Rapor oluÅŸturma',0),(23909,665,'pl','Tworzenie raportu',0),(23910,665,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(23911,665,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ø¨Ù†Ø§Ù†Û’',0),(23912,665,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(23913,665,'vi','Táº¡o bÃ¡o cÃ¡o',0),(23914,665,'af','Skep Verslag',0),(23915,665,'ro','CreaÅ£i raportul',0),(23916,665,'et','Aruande loomine',0),(23917,665,'si','Ustvarjanje poroÄila',0),(23918,665,'ba','Membuat laporan',0),(23919,665,'nl','Rapport maken',0),(23920,665,'fi','Raportin luominen',0),(23921,665,'no','Opprette rapport',0),(23922,665,'da','Opret rapport',0),(23923,665,'ko','ë³´ê³ ì„œ ë§Œë“¤ê¸°',0),(23924,665,'he','×¦×•×¨ ×“×•×—',0),(23925,665,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(23926,665,'zh','åˆ›å»ºæŠ¥å‘Š\r\n',0),(23927,665,'sv','Skapa rapport',0),(23928,665,'it','Creare Report',0),(23929,665,'tl','',0),(23930,665,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(23931,665,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¬à¤¨à¤¾à¤à¤',0),(23932,665,'ms','Membuat laporan',0),(23933,665,'ar','Ø¥Ù†Ø´Ø§Ø¡ ØªÙ‚Ø±ÙŠØ±',0),(23934,665,'fr','CrÃ©er le rapport',0),(23935,665,'jp','ãƒ¬ãƒ?ãƒ¼ãƒˆã‚’ä½œæˆ?',0),(23936,665,'pt','Criar relatÃ³rio',0),(23937,665,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ ÐžÑ‚Ñ‡ÐµÑ‚',0),(23938,665,'es','Crear Informe',0),(23939,665,'de','Bericht erstellen',0),(23940,665,'en','Create Report',0),(23941,666,'is','',0),(23942,666,'dr','/  ÙˆØ±ÙˆØ¯  Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ ',0),(23943,666,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ú¯Ø²Ø§Ø±Ø´ /  ÙˆØ±ÙˆØ¯  Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ ',0),(23944,666,'tr','Rapor OluÅŸtur / sayÄ±larÄ± girin',0),(23945,666,'pl','UtworzyÄ‡ raport / WprowadÅº liczby',0),(23946,666,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ / Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð±Ñ€Ð¾Ñ',0),(23947,666,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ø¨Ù†Ø§Ù†Û’ / Ø´Ù…Ø§Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(23948,666,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ / ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ Ñ‚Ð°Ñ‡ÐºÐµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð½Ð¸Ñ†Ðµ',0),(23949,666,'vi','Táº¡o bÃ¡o cÃ¡o / Nháº­p bá»™ Ä‘áº¿m',0),(23950,666,'af','Skep Verslag / Voer Telling In ',0),(23951,666,'ro','CreaÅ£i raportul / intre conteazÄƒ',0),(23952,666,'et','Aruande loomine / Enter arvu',0),(23953,666,'si','Ustvarjanje poroÄila / vnesite Å¡teje',0),(23954,666,'ba','Membuat laporan / masukkan jumlah',0),(23955,666,'nl','Rapport maken / Enter graven',0),(23956,666,'fi','Luo raportti / Anna laskee',0),(23957,666,'no','Opprette rapport / inn teller',0),(23958,666,'da','Oprette rapport / Enter tÃ¦ller',0),(23959,666,'ko','ë³´ê³ ì„œ ë§Œë“¤ê¸°/ìˆ˜ ìž…ë ¥',0),(23960,666,'he','×™×¦×™×¨×ª ×“×•×— / ×”×›× ×¡ ×¡×¤×™×¨×•×ª',0),(23961,666,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î­ÎºÎ¸ÎµÏƒÎ·Ï‚ / Enter Î¼ÎµÏ„ÏÎ¬ÎµÎ¹',0),(23962,666,'zh','åˆ›å»ºæŠ¥å‘Š/è®¡æ•°è¾“å…¥\r\n',0),(23963,666,'sv','Skapa rapport / retur rÃ¤knas',0),(23964,666,'it','Creare Report / Enter conteggi',0),(23965,666,'tl','',0),(23966,666,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;/&#3585;&#3634;&#3619;&#3609;&#3633;&#3610;&#3607;&#3637;&#3656;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(23967,666,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¬à¤¨à¤¾à¤à¤ / à¤—à¤£à¤¨à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(23968,666,'ms','Membuat laporan / masukkan kiraan',0),(23969,666,'ar','Ø¥Ù†Ø´Ø§Ø¡ ØªÙ‚Ø±ÙŠØ±/Ø£Ø¯Ø®Ù„ Ø§Ù„ØªÙ‡Ù…',0),(23970,666,'fr','CrÃ©er rapport / saisie des comtes',0),(23971,666,'jp','ãƒ¬ãƒ?ãƒ¼ãƒˆä½œæˆ?/è¨ˆç®—å…¥åŠ›',0),(23972,666,'pt','Criar relatÃ³rio / Enter contagens',0),(23973,666,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ ÐžÑ‚Ñ‡ÐµÑ‚ / Ð’Ð²ÐµÑÑ‚Ð¸ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(23974,666,'es','Crear Informe / Ingresar Conteos',0),(23975,666,'de','Bericht erstellen / Enter zÃ¤hlt',0),(23976,666,'en','Create Report / Enter Counts',0),(23977,667,'is','',0),(23978,667,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ù„ÙŠØ³Øª Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ù‚ÙŠÙ…Øª ',0),(23979,667,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ù„ÙŠØ³Øª Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ù‚ÙŠÙ…Øª ',0),(23980,667,'tr','Standart miktar listesi fiyat listeleri oluÅŸturma',0),(23981,667,'pl','Tworzenie listy standardowe iloÅ›ci cennikÃ³w',0),(23982,667,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ð»Ð¸ÑÑ‚Ð¸',0),(23983,667,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©ÛŒ ÙÛØ±Ø³Øª Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(23984,667,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐµ',0),(23985,667,'vi','Táº¡o danh sÃ¡ch sá»‘ lÆ°á»£ng chuáº©n chi Danh sÃ¡ch báº£ng giÃ¡',0),(23986,667,'af','Skep Standaard Kwaliteitslys vir Pryslys',0),(23987,667,'ro','CreaÅ£i lista cantitatea Standard pentru listele de preÅ£uri',0),(23988,667,'et','Loo standardkoguste nimekiri hinnakirja jaoks',0),(23989,667,'si','Ustvarite seznam standardne koliÄine za cenike',0),(23990,667,'ba','Membuat daftar kuantitas standar untuk daftar harga',0),(23991,667,'nl','Standaard hoeveelheid lijst voor prijslijsten maken',0),(23992,667,'fi','Luoda vakiomÃ¤Ã¤rÃ¤ hinnastot',0),(23993,667,'no','Opprette Standardantallet for prislister',0),(23994,667,'da','Oprette standardmÃ¦ngde liste til prislister',0),(23995,667,'ko','ê°€ê²© ëª©ë¡ì— ëŒ€ í•œ í‘œì¤€ ìˆ˜ëŸ‰ ëª©ë¡ ë§Œë“¤ê¸°',0),(23996,667,'he','×¦×•×¨ ×¨×©×™×ž×ª ×ž×›×ž×•×ª ×”×ª×§×Ÿ ×¢×‘×•×¨ ×ž×—×™×¨×•× ×™×',0),(23997,667,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î»Î¯ÏƒÏ„Î±Ï‚ Ï„Ï…Ï€Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï…Ï‚',0),(23998,667,'zh','åˆ›å»ºæ ‡å‡†çš„ä»·ç›®è¡¨é‡æ¸…å•\r\n',0),(23999,667,'sv','Skapa standardkvantiteten lista fÃ¶r prislistor',0),(24000,667,'it','Creare lista quantitÃ  Standard per listini prezzi',0),(24001,667,'tl','',0),(24002,667,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3',0),(24003,667,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤¬à¤¨à¤¾à¤à¤',0),(24004,667,'ms','Mencipta senarai kuantiti yang Standard untuk senarai harga',0),(24005,667,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ù„Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(24006,667,'fr','CrÃ©er liste de quantitÃ© Standard pour les listes de prix',0),(24007,667,'jp','ä¾¡æ ¼è¡¨ã?®æ¨™æº–æ•°é‡?ãƒªã‚¹ãƒˆä½œæˆ?',0),(24008,667,'pt','Criar lista de quantidade padrÃ£o para listas de preÃ§o',0),(24009,667,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð»Ñ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚Ñ‹',0),(24010,667,'es','Crear Lista de Cantidades EstÃ¡ndares para Listas de Precios',0),(24011,667,'de','Standardmenge Liste fÃ¼r Preislisten erstellen',0),(24012,667,'en','Create Standard Quantity List for Price Lists',0),(24013,668,'is','',0),(24014,668,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø±ÙˆÙŠ',0),(24015,668,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø±ÙˆÙŠ',0),(24016,668,'tr','Tarihinde yaratÄ±lmÄ±ÅŸtÄ±r',0),(24017,668,'pl','Utworzone na',0),(24018,668,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° Ð½Ð°',0),(24019,668,'ur','Ù¾Ø± Ù¾ÛŒØ¯Ø§ ÛÙˆ Ú¯ÛŒØ§',0),(24020,668,'sr','Ð¤Ð¾Ñ€Ð¼Ð¸Ñ€Ð°Ð½Ð° Ð½Ð°',0),(24021,668,'vi','Táº¡o vÃ o',0),(24022,668,'af','Geskep Op',0),(24023,668,'ro','Creat pe',0),(24024,668,'et','Loodud',0),(24025,668,'si','Ustvarjena na',0),(24026,668,'ba','Dibuat pada',0),(24027,668,'nl','Gemaakt op',0),(24028,668,'fi','Luotu',0),(24029,668,'no','Opprettet pÃ¥',0),(24030,668,'da','Lavet pÃ¥',0),(24031,668,'ko','ë§Œë“ ',0),(24032,668,'he','×¤×•×¨×¡× ×‘-',0),(24033,668,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ ÏƒÏ„Î¹Ï‚',0),(24034,668,'zh','åˆ›å»ºæ—¥æœŸ\r\n',0),(24035,668,'sv','Skapat pÃ¥',0),(24036,668,'it','Creato su',0),(24037,668,'tl','',0),(24038,668,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3610;&#3609;',0),(24039,668,'hi','à¤ªà¤° à¤¬à¤¨à¤¾à¤¯à¤¾',0),(24040,668,'ms','Dicipta pada',0),(24041,668,'ar','ØªÙ… Ø§Ù„Ù†Ø´Ø±',0),(24042,668,'fr','CrÃ©Ã©e le',0),(24043,668,'jp','ä½œæˆ?æ—¥',0),(24044,668,'pt','Criado na',0),(24045,668,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¾',0),(24046,668,'es','Creado En',0),(24047,668,'de','Erstellt am',0),(24048,668,'en','Created On',0),(24049,669,'is','',0),(24050,669,'dr','Ø§ÙŠØ¬Ø§Ø¯ÙƒÙ†Ù†Ø¯Ù‡ ',0),(24051,669,'pr','Ø§ÙŠØ¬Ø§Ø¯ÙƒÙ†Ù†Ø¯Ù‡ ',0),(24052,669,'tr','YaratÄ±cÄ±sÄ±',0),(24053,669,'pl','TwÃ³rca',0),(24054,669,'bg','Ð¡ÑŠÐ·Ð´Ð°Ñ‚ÐµÐ»',0),(24055,669,'ur','Ø®Ø§Ù„Ù‚',0),(24056,669,'sr','Ð¢Ð²Ð¾Ñ€Ð°Ñ†',0),(24057,669,'vi','NgÆ°á»i táº¡o',0),(24058,669,'af','Skepper',0),(24059,669,'ro','Creatorul',0),(24060,669,'et','Looja',0),(24061,669,'si','Ustvarjalca',0),(24062,669,'ba','Pencipta',0),(24063,669,'nl','Creator',0),(24064,669,'fi','Luoja',0),(24065,669,'no','Skaperen',0),(24066,669,'da','Skaberen',0),(24067,669,'ko','ì°½ì¡° ìž',0),(24068,669,'he','×™×•×¦×¨',0),(24069,669,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÏŒÏ‚',0),(24070,669,'zh','åˆ›å»ºè€…\r\n',0),(24071,669,'sv','Skapare',0),(24072,669,'it','Creatore',0),(24073,669,'tl','',0),(24074,669,'th','&#3612;&#3641;&#3657;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(24075,669,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤¤à¤¾',0),(24076,669,'ms','Pencipta',0),(24077,669,'ar','Ø§Ù„Ø®Ø§Ù„Ù‚',0),(24078,669,'fr','CrÃ©ateur',0),(24079,669,'jp','ä½œæˆ?è€…',0),(24080,669,'pt','Criador',0),(24081,669,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÐµÐ»ÑŒ',0),(24082,669,'es','Creador',0),(24083,669,'de','Creator',0),(24084,669,'en','Creator',0),(24085,670,'is','',0),(24086,670,'dr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(24087,670,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(24088,670,'tr','Kredi',0),(24089,670,'pl','Kredyt',0),(24090,670,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚',0),(24091,670,'ur','Ú©Ø±ÛŒÚˆÙ¹',0),(24092,670,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ',0),(24093,670,'vi','TÃ­n Dá»¥ng',0),(24094,670,'af','Krediet',0),(24095,670,'ro','Credit',0),(24096,670,'et','Krediit',0),(24097,670,'si','Kreditne',0),(24098,670,'ba','Kredit',0),(24099,670,'nl','Krediet',0),(24100,670,'fi','Luotto',0),(24101,670,'no','Kreditt',0),(24102,670,'da','Kredit',0),(24103,670,'ko','ì‹ ìš©',0),(24104,670,'he','××©×¨××™',0),(24105,670,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½',0),(24106,670,'zh','ä¿¡ç”¨\r\n',0),(24107,670,'sv','Kredit',0),(24108,670,'it','Credito',0),(24109,670,'tl','',0),(24110,670,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(24111,670,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(24112,670,'ms','Kredit',0),(24113,670,'ar','Ø¯Ø§Ø¦Ù†',0),(24114,670,'fr','CrÃ©dit',0),(24115,670,'jp','è²¸æ–¹',0),(24116,670,'pt','CrÃ©dito',0),(24117,670,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚',0),(24118,670,'es','CrÃ©dito',0),(24119,670,'de','Kredit',0),(24120,670,'en','Credit',0),(24121,671,'is','',0),(24122,671,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø³ØªØ§Ù†Ú©Ø§Ø±',0),(24123,671,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø³ØªØ§Ù†Ú©Ø§Ø±',0),(24124,671,'tr','Alacak hesabÄ±',0),(24125,671,'pl','Konto kredytowe',0),(24126,671,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(24127,671,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(24128,671,'sr','ÐšÐ¾Ð½Ñ‚Ð° Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(24129,671,'vi','TK TÃ­n Dá»¥ng',0),(24130,671,'af','Krediet Bedrag',0),(24131,671,'ro','Contul de credit',0),(24132,671,'et','Krediit konto',0),(24133,671,'si','Kreditni raÄun',0),(24134,671,'ba','Rekening kredit',0),(24135,671,'nl','Creditrekening',0),(24136,671,'fi','Kredit-tili',0),(24137,671,'no','Kreditt-kontoen',0),(24138,671,'da','Kredit-konto',0),(24139,671,'ko','ì‹ ìš© ê³„ì¢Œ',0),(24140,671,'he','×—×©×‘×•×Ÿ ×”××©×¨××™',0),(24141,671,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚',0),(24142,671,'zh','ä¿¡ç”¨å¡å¸æˆ·\r\n',0),(24143,671,'sv','Kreditkonto',0),(24144,671,'it','Conto di credito',0),(24145,671,'tl','',0),(24146,671,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(24147,671,'hi','à¤‹à¤£ à¤–à¤¾à¤¤à¥‡',0),(24148,671,'ms','Akaun kredit',0),(24149,671,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(24150,671,'fr','Compte de crÃ©dit',0),(24151,671,'jp','æŽ›å£²å‹˜å®š',0),(24152,671,'pt','Conta de crÃ©dito',0),(24153,671,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ ÑÑ‡ÐµÑ‚Ð°',0),(24154,671,'es','Cuenta de CrÃ©dito',0),(24155,671,'de','Habenkonto',0),(24156,671,'en','Credit Account',0),(24157,672,'is','',0),(24158,672,'dr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(24159,672,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(24160,672,'tr','Kredi',0),(24161,672,'pl','Kredyt',0),(24162,672,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚',0),(24163,672,'ur','Ú©Ø±ÛŒÚˆÙ¹',0),(24164,672,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ',0),(24165,672,'vi','TÃ­n Dá»¥ng',0),(24166,672,'af','Krediet',0),(24167,672,'ro','Credit',0),(24168,672,'et','Krediidi',0),(24169,672,'si','Kreditne',0),(24170,672,'ba','Kredit',0),(24171,672,'nl','Krediet',0),(24172,672,'fi','Luotto',0),(24173,672,'no','Kreditt',0),(24174,672,'da','Kredit',0),(24175,672,'ko','ì‹ ìš©',0),(24176,672,'he','××©×¨××™',0),(24177,672,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½',0),(24178,672,'zh','ä¿¡ç”¨\r\n',0),(24179,672,'sv','Kredit',0),(24180,672,'it','Credito',0),(24181,672,'tl','',0),(24182,672,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(24183,672,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(24184,672,'ms','Kredit',0),(24185,672,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(24186,672,'fr','CrÃ©dit',0),(24187,672,'jp','è²¸ä»˜',0),(24188,672,'pt','CrÃ©dito',0),(24189,672,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚',0),(24190,672,'es','CrÃ©dito',0),(24191,672,'de','Kredit',0),(24192,672,'en','Credit',0),(24193,673,'is','',0),(24194,673,'dr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(24195,673,'pr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(24196,673,'tr','Kredi kartÄ±',0),(24197,673,'pl','Karta kredytowa',0),(24198,673,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(24199,673,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ',0),(24200,673,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(24201,673,'vi','Tháº» TÃ­n Dá»¥ng',0),(24202,673,'af','Kredietkaart',0),(24203,673,'ro','Card de credit',0),(24204,673,'et','Maksekaart',0),(24205,673,'si','Kreditne kartice',0),(24206,673,'ba','Kartu kredit',0),(24207,673,'nl','Credit Card',0),(24208,673,'fi','Luottokortti',0),(24209,673,'no','Kredittkort',0),(24210,673,'da','Kreditkort',0),(24211,673,'ko','ì‹ ìš© ì¹´ë“œ',0),(24212,673,'he','×›×¨×˜×™×¡ ××©×¨××™',0),(24213,673,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(24214,673,'zh','ä¿¡ç”¨å¡\r\n',0),(24215,673,'sv','Kreditkort',0),(24216,673,'it','Carta di credito',0),(24217,673,'tl','',0),(24218,673,'th','&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(24219,673,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡',0),(24220,673,'ms','Kad kredit',0),(24221,673,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø¥Ø¦ØªÙ…Ø§Ù†',0),(24222,673,'fr','Carte de crÃ©dit',0),(24223,673,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰',0),(24224,673,'pt','CartÃ£o de crÃ©dito',0),(24225,673,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ ÐšÐ°Ñ€Ñ‚Ð°',0),(24226,673,'es','Tarjeta de CrÃ©dito',0),(24227,673,'de','Kreditkarte',0),(24228,673,'en','Credit Card',0),(24229,674,'is','',0),(24230,674,'dr','1  Ù…Ø¹Ø§ÙÙŠØª ',0),(24231,674,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ  Ø¨Ø±Ø§ÙŠ  1  Ù…Ø¹Ø§ÙÙŠØª ',0),(24232,674,'tr','Kredi 1 muafiyet',0),(24233,674,'pl','Kredytowa 1 zwolnienia',0),(24234,674,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° 1 Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ',0),(24235,674,'ur','1 Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ú©Û’ Ù„Ø¦Û’ Ú©Ø±ÛŒÚˆÙ¹',0),(24236,674,'sr','Ð—Ð°ÑÐ»ÑƒÐ³Ðµ Ð·Ð° 1 Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(24237,674,'vi','TÃ­n Dá»¥ng Cho 1 Láº§n Miá»…n Trá»«',0),(24238,674,'af','Krediet vir 1 vrystelling',0),(24239,674,'ro','Credit pentru scutirea 1',0),(24240,674,'et','1 vabastamise eest',0),(24241,674,'si','Kredit za 1 oprostitev',0),(24242,674,'ba','Kredit untuk pembebasan 1',0),(24243,674,'nl','Krediet voor 1 vrijstelling',0),(24244,674,'fi','Luotto 1 poikkeusta',0),(24245,674,'no','Kreditt 1 unntak',0),(24246,674,'da','Ã†ren for 1 fritagelse',0),(24247,674,'ko','1 ë©´ì œì— ëŒ€ í•œ ì‹ ìš©',0),(24248,674,'he','×§×¨×“×™×˜ ×¢×œ ×¤×˜×•×¨ 1',0),(24249,674,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® 1 Î‘Î Î‘Î›Î›Î‘Î“Î—Î£',0),(24250,674,'zh','ä¿¡ç”¨è±å…1\r\n',0),(24251,674,'sv','Kredit fÃ¶r 1 undantag',0),(24252,674,'it','Credito per 1 esenzione',0),(24253,674,'tl','',0),(24254,674,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609; 1',0),(24255,674,'hi','1 à¤›à¥‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤‹à¤£',0),(24256,674,'ms','Kredit untuk pengecualian 1',0),(24257,674,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù„Ø¥Ø¹ÙØ§Ø¡ 1',0),(24258,674,'fr','CrÃ©dit 1 exemption',0),(24259,674,'jp','æŽ§é™¤ï¼‘ã?«å¯¾ã?™ã‚‹è²¸ä»˜',0),(24260,674,'pt','CrÃ©dito de 1 isenÃ§Ã£o',0),(24261,674,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° 1 Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(24262,674,'es','CrÃ©dito para 1 exenciÃ³n',0),(24263,674,'de','Kredit fÃ¼r 1 Freistellung',0),(24264,674,'en','Credit for 1 exemption',0),(24265,675,'is','',0),(24266,675,'dr','Ø³Ù‚Ù Ø§Ø¹ØªØ¨Ø§Ø±',0),(24267,675,'pr','Ø³Ù‚Ù Ø§Ø¹ØªØ¨Ø§Ø±',0),(24268,675,'tr','Kredi limiti',0),(24269,675,'pl','Limit kredytowy',0),(24270,675,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ÐµÐ½ Ð»Ð¸Ð¼Ð¸Ñ‚',0),(24271,675,'ur','Ú©ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ø­Ø¯',0),(24272,675,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð›Ð¸Ð¼Ð¸Ñ‚',0),(24273,675,'vi','Má»©c TÃ­n Dá»¥ng',0),(24274,675,'af','Kredietlimiet',0),(24275,675,'ro','Limita de credit',0),(24276,675,'et','Krediidilimiiti',0),(24277,675,'si','Kreditni Limit',0),(24278,675,'ba','Batas kredit',0),(24279,675,'nl','Kredietlimiet',0),(24280,675,'fi','Luottoraja',0),(24281,675,'no','Kredittgrensen',0),(24282,675,'da','Kreditmaksimum',0),(24283,675,'ko','ì‹ ìš© í•œë„',0),(24284,675,'he','×ž×’×‘×œ×ª ××©×¨××™',0),(24285,675,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ ÏŒÏÎ¹Î¿',0),(24286,675,'zh','ä¿¡ç”¨é™é¢\r\n',0),(24287,675,'sv','KreditgrÃ¤ns',0),(24288,675,'it','Limite di credito',0),(24289,675,'tl','',0),(24290,675,'th','&#3623;&#3591;&#3648;&#3591;&#3636;&#3609;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(24291,675,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¸à¥€à¤®à¤¾',0),(24292,675,'ms','Had kredit',0),(24293,675,'ar','Ø­Ø¯ Ø§Ù„Ø¥Ø¦ØªÙ…Ø§Ù†',0),(24294,675,'fr','Limite de crÃ©dit',0),(24295,675,'jp','è²¸ä»˜é™?åº¦',0),(24296,675,'pt','Limite de crÃ©dito',0),(24297,675,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¹ Ð›Ð¸Ð¼Ð¸Ñ‚',0),(24298,675,'es','Limite de CrÃ©dito',0),(24299,675,'de','Kreditlimit',0),(24300,675,'en','Credit Limit',0),(24301,676,'is','',0),(24302,676,'dr','2',0),(24303,676,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ù‡Ø±  Ù…Ø¹Ø§ÙÙŠØª Ø¨Ø±Ø§ÙŠ 2',0),(24304,676,'tr','2 iÃ§in muafiyet iÃ§in kredi',0),(24305,676,'pl','Kredyt na zwolnienie 2',0),(24306,676,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð·Ð° 2',0),(24307,676,'ur','2 Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ«Ù†Ø§Ø¡ ÙÛŒ Ú©Ø±ÛŒÚˆÙ¹',0),(24308,676,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° Ð¿Ð¾ Ð¸Ð·ÑƒÐ·ÐµÑ›Ð° Ð·Ð° 2',0),(24309,676,'vi','TÃ­n Dá»¥ng Má»—i Láº§n Miá»…n Trá»« Cho 2',0),(24310,676,'af','Krediet per Vrystelling vir 2',0),(24311,676,'ro','Credit per scutire pentru 2',0),(24312,676,'et','Krediidi eest erand 2',0),(24313,676,'si','Kredit na izvzetje za 2',0),(24314,676,'ba','Kredit per pembebasan untuk 2',0),(24315,676,'nl','Krediet per vrijstelling voor 2',0),(24316,676,'fi','Luotto per poikkeusta 2',0),(24317,676,'no','Kreditt per fritak for 2',0),(24318,676,'da','Kreditenhed pr. fritagelse for 2',0),(24319,676,'ko','2ì— ëŒ€ í•œ ë©´ì œ ë‹¹ ì‹ ìš©',0),(24320,676,'he','×§×¨×“×™×˜ ×œ×›×œ ×¤×˜×•×¨ ×¢×‘×•×¨ 2',0),(24321,676,'el','Î Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚ Î±Î½Î¬ Î±Ï€Î±Î»Î»Î±Î³Î® Î³Î¹Î± 2',0),(24322,676,'zh','æ¯2å­¦åˆ†è±å…\r\n',0),(24323,676,'sv','Kredit per undantag fÃ¶r 2',0),(24324,676,'it','Credito per esenzione per 2',0),(24325,676,'tl','',0),(24326,676,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610; 2 ',0),(24327,676,'hi','2 à¤•à¥‡ à¤²à¤¿à¤ à¤›à¥‚à¤Ÿ à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤‹à¤£',0),(24328,676,'ms','Kredit satu pengecualian untuk 2',0),(24329,676,'ar','Ø§Ù„ÙØ¶Ù„ ÙÙŠ Ø§Ù„ÙˆØ§Ø­Ø¯Ø© ÙˆØ¥Ø¹ÙØ§Ø¡ 2',0),(24330,676,'fr','CrÃ©dit par Exemption pour 2',0),(24331,676,'jp','ï¼’ã?®æŽ§é™¤ã?”ã?¨ã?®è²¸ä»˜',0),(24332,676,'pt','CrÃ©dito por isenÃ§Ã£o para 2',0),(24333,676,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ 2',0),(24334,676,'es','CrÃ©dito por ExenciÃ³n para 2',0),(24335,676,'de','Gutschrift pro Freistellung fÃ¼r 2',0),(24336,676,'en','Credit per Exemption for 2',0),(24337,677,'is','',0),(24338,677,'dr','3',0),(24339,677,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ù‡Ø±  Ù…Ø¹Ø§ÙÙŠØª Ø¨Ø±Ø§ÙŠ 3',0),(24340,677,'tr','3 iÃ§in Ã¼cret muafiyet kredi',0),(24341,677,'pl','Kredyt na zwolnienie na 3',0),(24342,677,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð·Ð° 3',0),(24343,677,'ur','3 Ø§Ø³ØªØ«Ù†Ø§Ø¡ ÙÛŒ Ú©Ø±ÛŒÚˆÙ¹',0),(24344,677,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° Ð¿Ð¾ Ð¸Ð·ÑƒÐ·ÐµÑ›Ð° Ð·Ð° 3',0),(24345,677,'vi','TÃ­n Dá»¥ng Má»—i Láº§n Miá»…n Trá»« Cho 3',0),(24346,677,'af','Krediet per Vrystelling vir 3',0),(24347,677,'ro','Credit per scutire pentru 3',0),(24348,677,'et','Krediidi eest maksuvabastuse 3',0),(24349,677,'si','Kredit na izvzetje za 3',0),(24350,677,'ba','Kredit per pembebasan untuk 3',0),(24351,677,'nl','Krediet per vrijstelling voor 3',0),(24352,677,'fi','Luotto per vapautusta 3',0),(24353,677,'no','Kreditt per fritak for 3',0),(24354,677,'da','Kreditenhed pr. fritagelse for 3',0),(24355,677,'ko','3ì— ëŒ€ í•œ ë©´ì œ ë‹¹ ì‹ ìš©',0),(24356,677,'he','×§×¨×“×™×˜ ×œ×›×œ ×¤×˜×•×¨ ×¢×‘×•×¨ 3',0),(24357,677,'el','Î Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚ Î±Î½Î¬ Î±Ï€Î±Î»Î»Î±Î³Î® Î³Î¹Î± 3',0),(24358,677,'zh','æ¯3å­¦åˆ†è±å…\r\n',0),(24359,677,'sv','Kredit per undantag fÃ¶r 3',0),(24360,677,'it','Credito per esenzione per 3',0),(24361,677,'tl','',0),(24362,677,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610; 3 ',0),(24363,677,'hi','3 à¤•à¥‡ à¤²à¤¿à¤ à¤›à¥‚à¤Ÿ à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤‹à¤£',0),(24364,677,'ms','Kredit satu pengecualian untuk 3',0),(24365,677,'ar','Ø§Ù„ÙØ¶Ù„ ÙÙŠ Ø§Ù„ÙˆØ§Ø­Ø¯Ø© ÙˆØ¥Ø¹ÙØ§Ø¡ 3',0),(24366,677,'fr','CrÃ©dit par Exemption pour 3',0),(24367,677,'jp','ï¼“ã?®æŽ§é™¤ã?”ã?¨ã?®è²¸ä»˜',0),(24368,677,'pt','CrÃ©dito por isenÃ§Ã£o para 3',0),(24369,677,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð´Ð»Ñ 3',0),(24370,677,'es','CrÃ©dito por ExenciÃ³n para 3',0),(24371,677,'de','Gutschrift pro Freistellung fÃ¼r 3',0),(24372,677,'en','Credit per Exemption for 3',0),(24373,678,'is','',0),(24374,678,'dr','4 Ùˆ Ø¨Ø§Ù„Ø§ ',0),(24375,678,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ù‡Ø±  Ù…Ø¹Ø§ÙÙŠØª Ø¨Ø±Ø§ÙŠ 4 Ùˆ Ø¨Ø§Ù„Ø§ ',0),(24376,678,'tr','Muafiyet 4 iÃ§in kredi & yukarÄ±',0),(24377,678,'pl','Kredyt za zwolnienie dla 4 & siÄ™',0),(24378,678,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð·Ð° 4 & Ð½Ð°Ð³Ð¾Ñ€Ðµ',0),(24379,678,'ur','4 Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ«Ù†Ø§Ø¡ ÙÛŒ Ú©Ø±ÛŒÚˆÙ¹ & Ø¨Ø§Ù„Ø§',0),(24380,678,'sr','ÐŸÐ¾ Ð¸Ð·ÑƒÐ·ÐµÑ›Ñƒ Ð¿Ñ€Ð¸Ð·Ð½Ð°Ð²Ð°Ð»Ð° 4 & Ð³Ð¾Ñ€Ðµ',0),(24381,678,'vi','TÃ­n Dá»¥ng Má»—i Láº§n Miá»…n Trá»« Cho 4 & cao hÆ¡n',0),(24382,678,'af','Krediet per Vrystelling vir 4 & meer',0),(24383,678,'ro','Credit per scutire pentru 4 & sus',0),(24384,678,'et','4 vabastamise eest krediiti & Ã¼les',0),(24385,678,'si','Kredit na izvzetje za 4 & gor',0),(24386,678,'ba','Kredit per pembebasan untuk 4 &amp; naik',0),(24387,678,'nl','Krediet per vrijstelling voor 4 & omhoog',0),(24388,678,'fi','Luotto / vapautus 4 & ylÃ¶s',0),(24389,678,'no','Kreditt per fritak for 4 & opp',0),(24390,678,'da','Credit pr. fritagelse for 4 & op',0),(24391,678,'ko','4ì— ëŒ€ í•œ ë©´ì œ ë‹¹ credit & ìµœëŒ€',0),(24392,678,'he','×§×¨×“×™×˜ ×œ×›×œ ×¤×˜×•×¨ ×¢×œ 4 & ×œ×ž×¢×œ×”',0),(24393,678,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Î±Î½Î¬ Î±Ï€Î±Î»Î»Î±Î³Î® Î³Î¹Î± 4 & ÎµÏ€Î¬Î½Ï‰',0),(24394,678,'zh','æ¯4ä¸ªå­¦åˆ†è±å…åŠä»¥ä¸Š\r\n',0),(24395,678,'sv','Kredit per undantag fÃ¶r 4 & upp',0),(24396,678,'it','Di credito per ogni esenzione per 4 & fino',0),(24397,678,'tl','',0),(24398,678,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610; 4 &#3649;&#3621;&#3632;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3609;&#3637;',0),(24399,678,'hi','4 à¤•à¥‡ à¤²à¤¿à¤ à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ & à¤Šà¤ªà¤°',0),(24400,678,'ms','Kredit satu pengecualian untuk 4 & sehingga',0),(24401,678,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„ÙˆØ§Ø­Ø¯Ø© ÙˆØ¥Ø¹ÙØ§Ø¡ 4 Ø¢Ù†Ø¯ Ø­ØªÙ‰',0),(24402,678,'fr','CrÃ©dit par Exemption pour 4 & vers le haut',0),(24403,678,'jp','ï¼”ã?¨ã??ã‚Œä»¥ä¸Šã?®æŽ§é™¤ã?”ã?¨ã?®è²¸ä»˜',0),(24404,678,'pt','CrÃ©dito por isenÃ§Ã£o para 4 & de cima',0),(24405,678,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð´Ð»Ñ 4 & Ð²Ð²ÐµÑ€Ñ…',0),(24406,678,'es','CrÃ©dito por ExenciÃ³n para 4 & mÃ¡s',0),(24407,678,'de','Kredit pro Freistellung fÃ¼r 4 & oben',0),(24408,678,'en','Credit per Exemption for 4 & up',0),(24409,679,'is','',0),(24410,679,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(24411,679,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(24412,679,'tr','Kredi kartÄ± tipi',0),(24413,679,'pl','Rodzaj karty kredytowej',0),(24414,679,'bg','Ð¢Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(24415,679,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ù‚Ø³Ù…',0),(24416,679,'sr','Ð¢Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(24417,679,'vi','Loáº¡i Tháº» TÃ­n Dá»¥ng',0),(24418,679,'af','Kredietkaart Tipe',0),(24419,679,'ro','Tipul de Card de credit',0),(24420,679,'et','Krediitkaardi tÃ¼Ã¼p',0),(24421,679,'si','Vrsta kreditne kartice',0),(24422,679,'ba','Jenis kartu kredit',0),(24423,679,'nl','Creditcard Type',0),(24424,679,'fi','Luottokorttityyppi',0),(24425,679,'no','Kredittkorttype',0),(24426,679,'da','Kreditkorttype',0),(24427,679,'ko','ì‹ ìš© ì¹´ë“œ ì¢…ë¥˜',0),(24428,679,'he','×¡×•×’ ×›×¨×˜×™×¡ ××©×¨××™',0),(24429,679,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Ï„ÏÏ€Î¿Ï…',0),(24430,679,'zh','ä¿¡ç”¨å¡ç§ç±»\r\n',0),(24431,679,'sv','Kreditkortstyp',0),(24432,679,'it','Tipo di carta di credito',0),(24433,679,'tl','',0),(24434,679,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(24435,679,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(24436,679,'ms','Jenis kad kredit',0),(24437,679,'ar','Ù†ÙˆØ¹ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(24438,679,'fr','Type de carte de crÃ©dit',0),(24439,679,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ã‚¿ã‚¤ãƒ—',0),(24440,679,'pt','Tipo de cartÃ£o de crÃ©dito',0),(24441,679,'ru','Ð¢Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(24442,679,'es','Tarjeta de CrÃ©dito Tipo',0),(24443,679,'de','Kreditkartentyp',0),(24444,679,'en','Credit Card Type',0),(24445,680,'is','',0),(24446,680,'dr','Ø§Ø¹ØªØ¨Ø§Ø±Ø§Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(24447,680,'pr','Ø§Ø¹ØªØ¨Ø§Ø±Ø§Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(24448,680,'tr','KullanÄ±lan krediler',0),(24449,680,'pl','Kredyty uÅ¼ywane',0),(24450,680,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¸, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸',0),(24451,680,'ur','Ú©Ø±ÛŒÚˆÛŒÙ¹Ø³ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(24452,680,'sr','Ð¨Ð¿Ð¸Ñ†Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(24453,680,'vi','TÃ­n Dá»¥ng ÄÃ£ Sá»­ Dá»¥ng',0),(24454,680,'af','Krediete Gebruik',0),(24455,680,'ro','Creditele utilizate',0),(24456,680,'et','Krediiti kasutatud',0),(24457,680,'si','Kredite, ki se uporablja',0),(24458,680,'ba','Kredit digunakan',0),(24459,680,'nl','Kredieten gebruikt',0),(24460,680,'fi','Luotoista, mÃ¤Ã¤rien',0),(24461,680,'no','Studiepoeng brukes',0),(24462,680,'da','Credits bruges',0),(24463,680,'ko','í¬ë ˆë”§ ì‚¬ìš©',0),(24464,680,'he','×§×¨×“×™×˜×™× ×‘×©×™×ž×•×©',0),(24465,680,'el','Î Î¹ÏƒÏ„ÏŽÏƒÎµÎ¹Ï‚ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹',0),(24466,680,'zh','ç§¯åˆ†ä½¿ç”¨\r\n',0),(24467,680,'sv','PoÃ¤ng som anvÃ¤nds',0),(24468,680,'it','Crediti utilizzati',0),(24469,680,'tl','',0),(24470,680,'th','&#3651;&#3594;&#3657;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(24471,680,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(24472,680,'ms','Kredit yang digunakan',0),(24473,680,'ar','Ø§Ù„Ø§Ø¹ØªÙ…Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(24474,680,'fr','CrÃ©dits utilisÃ©s',0),(24475,680,'jp','ä½¿ç”¨ã?—ã?Ÿè²¸ä»˜',0),(24476,680,'pt','CrÃ©ditos utilizados',0),(24477,680,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑŽÑ‚ÑÑ',0),(24478,680,'es','CrÃ©ditos Usados',0),(24479,680,'de','Gutschriften verwendet',0),(24480,680,'en','Credits Used',0),(24481,681,'is','',0),(24482,681,'dr','CSV    Ù„ÙŠØ³Øª ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ ',0),(24483,681,'pr','CSV    Ù„ÙŠØ³Øª ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ ',0),(24484,681,'tr','CSV listesi',0),(24485,681,'pl','Lista CSV',0),(24486,681,'bg','CSV ÑÐ¿Ð¸ÑÑŠÐº',0),(24487,681,'ur','CSV ÙÛØ±Ø³Øª',0),(24488,681,'sr','Ð¦Ð¡Ð’ Ð»Ð¸ÑÑ‚Ð°',0),(24489,681,'vi','Danh sÃ¡ch CSV',0),(24490,681,'af','CSV-lys',0),(24491,681,'ro','CSV lista',0),(24492,681,'et','CSV loend',0),(24493,681,'si','CSV seznam',0),(24494,681,'ba','Daftar CSV',0),(24495,681,'nl','CSV-lijst',0),(24496,681,'fi','CSV-luettelon',0),(24497,681,'no','CSV-listen',0),(24498,681,'da','CSV-liste',0),(24499,681,'ko','CSV ëª©ë¡',0),(24500,681,'he','×¨×©×™×ž×ª ×”-CSV',0),(24501,681,'el','Î›Î¯ÏƒÏ„Î± CSV',0),(24502,681,'zh','é€—å·åˆ†éš”å€¼æ ¼å¼åå•\r\n',0),(24503,681,'sv','CSV-lista',0),(24504,681,'it','Lista CSV',0),(24505,681,'tl','',0),(24506,681,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; CSV',0),(24507,681,'hi','CSV à¤¸à¥‚à¤šà¥€',0),(24508,681,'ms','Senarai CSV',0),(24509,681,'ar','Ù‚Ø§Ø¦Ù…Ø© CSV',0),(24510,681,'fr','Liste CSV',0),(24511,681,'jp','CSVãƒªã‚¹ãƒˆ',0),(24512,681,'pt','Lista CSV',0),(24513,681,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº CSV',0),(24514,681,'es','Lista de CSV',0),(24515,681,'de','CSV-Liste',0),(24516,681,'en','CSV List',0),(24517,682,'is','',0),(24518,682,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ¹Ù„ÙŠ ',0),(24519,682,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ¹Ù„ÙŠ ',0),(24520,682,'tr','GeÃ§erli tutar',0),(24521,682,'pl','Aktualne kwoty',0),(24522,682,'bg','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(24523,682,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø±Ù‚Ù…',0),(24524,682,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(24525,682,'vi','Sá»‘ tiá»n hiá»‡n thá»i ',0),(24526,682,'af','Huidige Getal',0),(24527,682,'ro','Valori: valoarea curentÄƒ',0),(24528,682,'et','Praegune summa',0),(24529,682,'si','Trenutni znesek',0),(24530,682,'ba','Jumlah',0),(24531,682,'nl','Huidige bedrag',0),(24532,682,'fi','Nykyinen summa',0),(24533,682,'no','Gjeldende belÃ¸p',0),(24534,682,'da','Aktuelt belÃ¸b',0),(24535,682,'ko','í˜„ìž¬ ê¸ˆì•¡',0),(24536,682,'he','×¡×›×•× × ×•×›×—×™',0),(24537,682,'el','Î¤ÏÎ­Ï‡Î¿Î½ Ï€Î¿ÏƒÏŒ',0),(24538,682,'zh','å½“å‰æ•°é¢\r\n',0),(24539,682,'sv','Aktuellt belopp',0),(24540,682,'it','QuantitÃ  di corrente',0),(24541,682,'tl','',0),(24542,682,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(24543,682,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿',0),(24544,682,'ms','Jumlah semasa',0),(24545,682,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(24546,682,'fr','Montant actuel',0),(24547,682,'jp','ç?¾åœ¨ã?®é‡‘é¡?',0),(24548,682,'pt','Quantidade atual',0),(24549,682,'ru','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(24550,682,'es','Monto Actual',0),(24551,682,'de','Aktuelle HÃ¶he',0),(24552,682,'en','Current Amount',0),(24553,683,'is','',0),(24554,683,'dr','( ÙØ¹Ù„ÙŠ',0),(24555,683,'pr','Ø¬Ø§Ø±ÙŠ ( ÙØ¹Ù„ÙŠ',0),(24556,683,'tr','AkÄ±m',0),(24557,683,'pl','PrÄ…d',0),(24558,683,'bg','Ð¢Ð¾Ðº',0),(24559,683,'ur','Ù…ÙˆØ¬ÙˆØ¯Û',0),(24560,683,'sr','Ð¡Ñ‚Ñ€ÑƒÑ˜Ð°',0),(24561,683,'vi','Hiá»‡n thá»i',0),(24562,683,'af','Huidig',0),(24563,683,'ro','Curent',0),(24564,683,'et','Praegune',0),(24565,683,'si','Tok',0),(24566,683,'ba','Saat ini',0),(24567,683,'nl','Huidige',0),(24568,683,'fi','Nykyinen',0),(24569,683,'no','Gjeldende',0),(24570,683,'da','NuvÃ¦rende',0),(24571,683,'ko','ì „ë¥˜',0),(24572,683,'he','× ×•×›×—×™',0),(24573,683,'el','Î¡ÎµÏÎ¼Î±',0),(24574,683,'zh','å½“å‰\r\n',0),(24575,683,'sv','Nuvarande',0),(24576,683,'it','Corrente',0),(24577,683,'tl','',0),(24578,683,'th','&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(24579,683,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨',0),(24580,683,'ms','Semasa',0),(24581,683,'ar','Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(24582,683,'fr','Courant',0),(24583,683,'jp','ç?¾åœ¨',0),(24584,683,'pt','Corrente',0),(24585,683,'ru','Ð¢Ð¾Ðº',0),(24586,683,'es','Actual',0),(24587,683,'de','Strom',0),(24588,683,'en','Current',0),(24589,684,'is','',0),(24590,684,'dr','(Ø¨Ø§Ù‚ÙŠØ¨ÛŒÙ„Ø§Ù†Ø³)Ø¬Ø§Ø±ÙŠ ',0),(24591,684,'pr','ØªØ±Ø§Ø² (Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡)Ø¬Ø§Ø±ÙŠ ',0),(24592,684,'tr','GeÃ§erli Balance',0),(24593,684,'pl','Aktualne saldo',0),(24594,684,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¾ ÑÐ°Ð»Ð´Ð¾',0),(24595,684,'ur','Ø­Ø§Ù„ÛŒÛ Ø¨ÛŒÙ„Ù†Ø³',0),(24596,684,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(24597,684,'vi','Sá»‘ dÆ° hiá»‡n thá»i',0),(24598,684,'af','Huidige Balans',0),(24599,684,'ro','Soldul curent',0),(24600,684,'et','Hetkesaldo',0),(24601,684,'si','Trenutni saldo',0),(24602,684,'ba','Saldo',0),(24603,684,'nl','Huidig saldo',0),(24604,684,'fi','Nykyinen saldo',0),(24605,684,'no','Gjeldende saldo',0),(24606,684,'da','NuvÃ¦rende saldo',0),(24607,684,'ko','í˜„ìž¬ ìž”ì•¡',0),(24608,684,'he','×ž××–×Ÿ × ×•×›×—×™',0),(24609,684,'el','Î¤ÏÎ­Ï‡Î¿Î½ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(24610,684,'zh','ç›®å‰ä½™é¢\r\n',0),(24611,684,'sv','Aktuella saldo',0),(24612,684,'it','Saldo corrente',0),(24613,684,'tl','',0),(24614,684,'th','&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(24615,684,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿',0),(24616,684,'ms','Baki semasa',0),(24617,684,'ar','Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(24618,684,'fr','Solde actuel',0),(24619,684,'jp','çµŒå¸¸å?Žæ”¯',0),(24620,684,'pt','Saldo atual',0),(24621,684,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð±Ð°Ð»Ð°Ð½Ñ',0),(24622,684,'es','Balance Actual',0),(24623,684,'de','Aktueller Kontostand',0),(24624,684,'en','Current Balance',0),(24625,685,'is','',0),(24626,685,'dr','( ØªØ¹Ø¯Ø§Ø¯ ) ÙØ¹Ù„ÙŠ ',0),(24627,685,'pr','Ø´Ù…Ø§Ø±Ø´ ( ØªØ¹Ø¯Ø§Ø¯ ) ÙØ¹Ù„ÙŠ ',0),(24628,685,'tr','GeÃ§erli sayÄ±sÄ±',0),(24629,685,'pl','Licznik prÄ…du',0),(24630,685,'bg','Ð¢ÐµÐºÑƒÑ‰ Ð±Ñ€Ð¾Ð¹',0),(24631,685,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ú©Ø§ Ø´Ù…Ø§Ø±',0),(24632,685,'sr','Ð¢ÐµÐºÑƒÑ›Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(24633,685,'vi','Äáº¿m hiá»‡n thá»i',0),(24634,685,'af','Huidige Telling',0),(24635,685,'ro','Curent conta',0),(24636,685,'et','Praegune krahv',0),(24637,685,'si','Trenutno Å¡tevilo',0),(24638,685,'ba','Saat ini jumlah',0),(24639,685,'nl','Huidige Count',0),(24640,685,'fi','Nykyinen mÃ¤Ã¤rÃ¤',0),(24641,685,'no','Gjeldende antall',0),(24642,685,'da','StrÃ¸m Greven',0),(24643,685,'ko','í˜„ìž¬ ì¹´ìš´íŠ¸',0),(24644,685,'he','×¡×¤×™×¨×ª ×”× ×•×›×—×™',0),(24645,685,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Count',0),(24646,685,'zh','å½“å‰è®¡æ•°\r\n',0),(24647,685,'sv','LÃ¶pande rÃ¤kning',0),(24648,685,'it','Conteggio corrente',0),(24649,685,'tl','',0),(24650,685,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3609;&#3633;&#3610;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(24651,685,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤—à¤£à¤¨à¤¾',0),(24652,685,'ms','Kiraan semasa',0),(24653,685,'ar','Ø§Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(24654,685,'fr','Nombre actuel de',0),(24655,685,'jp','ç?¾åœ¨ã?®å‹˜å®š',0),(24656,685,'pt','Contagem de corrente',0),(24657,685,'ru','Ð¢ÐµÐºÑƒÑ‰ÐµÐµ Ñ‡Ð¸ÑÐ»Ð¾',0),(24658,685,'es','Conteo Actual',0),(24659,685,'de','Aktuelle Anzahl',0),(24660,685,'en','Current Count',0),(24661,686,'is','',0),(24662,686,'dr','( ØªØ¹Ø¯Ø§Ø¯ ) ÙØ¹Ù„ÙŠ Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ â€“ Ø¯ÙƒÙ…Ù‡  Ø²ÙŠØ± Ø±Ø§ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(24663,686,'pr','Ø´Ù…Ø§Ø±Ø´ ( ØªØ¹Ø¯Ø§Ø¯ ) ÙØ¹Ù„ÙŠ Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ â€“ Ø¯ÙƒÙ…Ù‡  Ø²ÙŠØ± Ø±Ø§ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(24664,686,'tr','GeÃ§erli sayÄ±larÄ± kaydedildi, yazÄ±ya tÄ±klayÄ±n alÄ±nmÄ±ÅŸtÄ±r',0),(24665,686,'pl','BieÅ¼Ä…cej liczby zapisane, kliknij poniÅ¼ej, aby Post',0),(24666,686,'bg','Ð¢ÐµÐºÑƒÑ‰ Ð±Ñ€Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸, ÐºÐ»Ð¸ÐºÐ½ÐµÑ‚Ðµ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ Ð½Ð° Ð¿Ð¾ÑÑ‚',0),(24667,686,'ur','Ø­Ø§Ù„ÛŒÛ Ø´Ù…Ø§Ø± Ù…Ø­ÙÙˆØ¸ØŒ Ù¾ÙˆØ³Ù¹ Ú©Û’ Ù„Ø¦Û’ Ù†ÛŒÚ†Û’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(24668,686,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ñ‚Ð°Ñ‡Ð°ÐºÐ° ÑÐ°Ñ‡ÑƒÐ²Ð°Ð»Ð¸, ÐºÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ð¸ ÐŸÐ¾ÑÑ‚',0),(24669,686,'vi','ÄÃ£ sao lÆ°u bá»™ Ä‘áº¿m hiá»‡n thá»i, nháº¥n dÆ°á»›i Ä‘Ã¢y Ä‘á»ƒ káº¿t chuyá»ƒn',0),(24670,686,'af','Huidge Telling Gestoor, Kliek onderaan om te Pos',0),(24671,686,'ro','Curent conteazÄƒ salvat, faceÅ£i clic mai jos pentru Post',0),(24672,686,'et','Praegune loeb salvestanud, klÃµpsake allpool Post',0),(24673,686,'si','Trenutno Å¡teje shranili, kliknite spodaj, da Post',0),(24674,686,'ba','Saat ini jumlah yang disimpan, klik di bawah untuk posting',0),(24675,686,'nl','Huidige graven opgeslagen, klik hieronder om Post te',0),(24676,686,'fi','Nykyinen laskee tallennettu, klikkaa alla tekstiin',0),(24677,686,'no','Gjeldende antall lagret, klikk nedenfor til innlegget',0),(24678,686,'da','NuvÃ¦rende tÃ¦ller gemt, Klik nedenfor til indlÃ¦g',0),(24679,686,'ko','í˜„ìž¬ ì¹´ìš´íŠ¸ ì €ìž¥, ê²Œì‹œë¬¼ ì•„ëž˜ í´ë¦­',0),(24680,686,'he','×¡×¤×™×¨×•×ª ×”× ×•×›×—×™ ×”×¦×™×œ, ×œ×—×¥ ×ž×ª×—×ª ×œ×¢×ž×“×”',0),(24681,686,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î¼ÎµÏ„ÏÎ¬ÎµÎ¹ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯, ÎºÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ ÏƒÎµ Î±Î½Î¬ÏÏ„Î·ÏƒÎ·',0),(24682,686,'zh','å½“å‰è®¡æ•°ä¿å­˜åŽï¼Œç‚¹å‡»ä¸‹é¢é‚®å¯„\r\n',0),(24683,686,'sv','Nuvarande rÃ¤knas sparas, klicka pÃ¥ nedan till inlÃ¤gget',0),(24684,686,'it','Conti correnti salvato, clicca qui sotto per Post',0),(24685,686,'tl','',0),(24686,686,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3592;&#3635;&#3609;&#3623;&#3609;&#3609;&#3633;&#3610;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609; &#3588;&#3621;&#3636;&#3585;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;&#3648;&#3614;&#',0),(24687,686,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤¾à¤‰à¤‚à¤Ÿà¥à¤¸ à¤¬à¤šà¤¾à¤¯à¤¾, à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(24688,686,'ms','Semasa kiraan yang disimpan, klik di bawah untuk pos',0),(24689,686,'ar','Ø§Ù„Ø­Ø§Ù„ÙŠ Ø§Ù„ØªÙ‡Ù… Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø©ØŒ Ø§Ù†Ù‚Ø± Ø£Ø¯Ù†Ø§Ù‡ Ù„ÙˆØ¸ÙŠÙØ©',0),(24690,686,'fr','Compte courant enregistrÃ©, veuillez cliquer en bas de Post',0),(24691,686,'jp','ç?¾åœ¨ã?®å‹˜å®šã?Œä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿãƒ¼è¨ˆä¸Šã?™ã‚‹ã?«ã?¯ä¸‹ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(24692,686,'pt','Atuais contagens salvadas, clique abaixo para Post',0),(24693,686,'ru','Ð¢ÐµÐºÑƒÑ‰ÐµÐµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹, Ð½Ð°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð¸Ð¶Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾ÑÑ‚',0),(24694,686,'es','Conteos Actuales Guardados. Click Abajo para Asentar',0),(24695,686,'de','Aktuelle Grafen gespeichert haben, klicken Sie unten auf das Post',0),(24696,686,'en','Current Counts Saved, Click Below to Post',0),(24697,687,'is','',0),(24698,687,'dr','Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø¬Ø§Ø±ÙŠ  ØªØ§ Ø§ÙŠÙ†  ØªØ§Ø±ÙŠØ®  ',0),(24699,687,'pr','Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø¬Ø§Ø±ÙŠ  ØªØ§ Ø§ÙŠÙ†  ØªØ§Ø±ÙŠØ®  ',0),(24700,687,'tr','GEÃ‡ERLÄ° MALÄ° YIL BAÅžINDAN BUGÃœNE',0),(24701,687,'pl','BIEÅ»Ä„CEGO ROKU OBRACHUNKOWEGO, DO TEJ PORY',0),(24702,687,'bg','Ð¢Ð•ÐšÐ£Ð©ÐÐ¢Ð Ð¤Ð˜ÐÐÐÐ¡ÐžÐ’Ð Ð“ÐžÐ”Ð˜ÐÐ Ð”Ðž ÐœÐžÐœÐ•ÐÐ¢Ð',0),(24703,687,'ur','Ø±ÙˆØ§Úº Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Û’ Ù„Ø¦Û’',0),(24704,687,'sr','Ð¢Ð•ÐšÐ£Ð‹Ð• Ð¤Ð˜Ð¡ÐšÐÐ›ÐÐ• Ð“ÐžÐ”Ð˜ÐÐ• Ð”Ðž Ð”ÐÐ¢Ð£ÐœÐ',0),(24705,687,'vi','NÄ‚M TÃ€I CHÃNH HIá»†N THá»œI Äáº¾N NAY',0),(24706,687,'af','HUIDIGE FISIESE JAAR TOT OP DATUM',0),(24707,687,'ro','ANULUI FISCAL CURENT PÃ‚NÄ‚ ÃŽN PREZENT',0),(24708,687,'et','JOOKSVA AASTA KUUPÃ„EV',0),(24709,687,'si','TRENUTNO PRORAÄŒUNSKO LETO DO DATUMA',0),(24710,687,'ba','TAHUN FISKAL UNTUK TANGGAL',0),(24711,687,'nl','LOPENDE BOEKJAAR TOT NU TOE',0),(24712,687,'fi','NYKYISEN TILIKAUDEN PÃ„Ã„TTYMISPÃ„IVÃ„MÃ„Ã„RÃ„',0),(24713,687,'no','NÃ…VÃ†RENDE REGNSKAPSÃ…RET HITTIL',0),(24714,687,'da','AKTUELLE REGNSKABSÃ…R TIL DATO',0),(24715,687,'ko','í˜„ìž¬ íšŒê³„ ì—°ë„ì˜ ë‚ ì§œ',0),(24716,687,'he','×œ×©× ×ª ×”×›×¡×¤×™× ×”× ×•×›×—×™×ª ×¢×“ ×›×”',0),(24717,687,'el','Î¤Î¡ÎˆÎ§ÎŸÎ ÎŸÎ™ÎšÎŸÎÎŸÎœÎ™ÎšÎŒ ÎˆÎ¤ÎŸÎ£ ÎœÎˆÎ§Î¡Î™ Î£Î‰ÎœÎ•Î¡Î‘',0),(24718,687,'zh','æˆªè‡³ç›®å‰ä¸ºæ­¢çš„æœ¬è´¢æ”¿å¹´åº¦\r\n',0),(24719,687,'sv','AKTUELLA RÃ„KENSKAPSÃ…RET HITTILLS',0),(24720,687,'it','ANNO FISCALE CORRENTE ALLA DATA',0),(24721,687,'tl','',0),(24722,687,'th','&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;&#3611;&#3637;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3652;&#3611;&#3606;&#3638;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(24723,687,'hi','à¤¤à¤¿à¤¥à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤µà¤¿à¤¤à¥à¤¤ à¤µà¤°à¥à¤·',0),(24724,687,'ms','TAHUN KEWANGAN SEMASA HINGGA TARIKH',0),(24725,687,'ar','Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø§Ù„Ø­Ø§Ù„ÙŠØ© Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(24726,687,'fr','EXERCICE Ã€ CE JOUR',0),(24727,687,'jp','ç?¾åœ¨ã?®ä¼šè¨ˆå¹´åº¦ç´¯è¨ˆ',0),(24728,687,'pt','ATUAL ANO FISCAL, ATÃ‰ Ã€ DATA',0),(24729,687,'ru','Ð¢Ð•ÐšÐ£Ð©Ð˜Ð™ Ð¤Ð˜ÐÐÐÐ¡ÐžÐ’Ð«Ð™ Ð“ÐžÐ” Ð”Ðž ÐÐÐ¡Ð¢ÐžÐ¯Ð©Ð•Ð“Ðž Ð’Ð Ð•ÐœÐ•ÐÐ˜',0),(24730,687,'es','EJERCICIO ACTUAL A LA FECHA',0),(24731,687,'de','AKTUELLEN GESCHÃ„FTSJAHRES',0),(24732,687,'en','CURRENT FISCAL YEAR TO DATE',0),(24733,688,'is','',0),(24734,688,'dr','(Ø³Ù‡Ù… ) Ø¬Ø§Ø±ÙŠ',0),(24735,688,'pr','Ø¨Ù‡Ø±Ù‡ (Ø³Ù‡Ù… ) Ø¬Ø§Ø±ÙŠ',0),(24736,688,'tr','Cari faiz',0),(24737,688,'pl','Aktualnej stopy procentowej',0),(24738,688,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(24739,688,'ur','Ø­Ø§Ù„ÛŒÛ Ø¯Ù„Ú†Ø³Ù¾ÛŒ',0),(24740,688,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(24741,688,'vi','LÃ£i suáº¥t hiá»‡n thá»i ',0),(24742,688,'af','Huidige Rente',0),(24743,688,'ro','Interes curent',0),(24744,688,'et','Praegune viivis',0),(24745,688,'si','Sedanje obresti',0),(24746,688,'ba','Bunga saat ini',0),(24747,688,'nl','Lopende rente',0),(24748,688,'fi','Nykyinen kiinnostus',0),(24749,688,'no','Aktuelle',0),(24750,688,'da','NuvÃ¦rende interesse',0),(24751,688,'ko','í˜„ìž¬ ê´€ì‹¬',0),(24752,688,'he','×¨×™×‘×™×ª',0),(24753,688,'el','Î¤ÏÎ­Ï‡Î¿Î½ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½',0),(24754,688,'zh','ç›®å‰çš„åˆ©çŽ‡\r\n',0),(24755,688,'sv','Nuvarande intresse',0),(24756,688,'it','Interesse attuale',0),(24757,688,'tl','',0),(24758,688,'th','&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(24759,688,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¬à¥à¤¯à¤¾à¤œ',0),(24760,688,'ms','Kepentingan semasa',0),(24761,688,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(24762,688,'fr','ActualitÃ©',0),(24763,688,'jp','ç?¾è¡Œåˆ©å­?',0),(24764,688,'pt','Interesse atual',0),(24765,688,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(24766,688,'es','InterÃ©ses Actuales',0),(24767,688,'de','Aktuelle Zinsen',0),(24768,688,'en','Current Interest',0),(24769,689,'is','',0),(24770,689,'dr','ÙƒØ§Ù„Ø§ Ù‡Ø§ÙŠ ÙØ¹Ù„ÙŠ ',0),(24771,689,'pr','ÙƒØ§Ù„Ø§ Ù‡Ø§ÙŠ ÙØ¹Ù„ÙŠ ',0),(24772,689,'tr','GEÃ‡ERLÄ° Ã–ÄžELER',0),(24773,689,'pl','BIEÅ»Ä„CYCH ZAPASÃ“W',0),(24774,689,'bg','Ð¢Ð•ÐšÐ£Ð©Ð˜ Ð•Ð›Ð•ÐœÐ•ÐÐ¢Ð˜',0),(24775,689,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ø´ÛŒØ§',0),(24776,689,'sr','Ð¢Ð Ð•ÐÐ£Ð¢ÐÐ• Ð¡Ð¢ÐÐ’ÐšÐ•',0),(24777,689,'vi','HÃ ng hiá»‡n táº¡i',0),(24778,689,'af','HUIDIGE ITEMS',0),(24779,689,'ro','ELEMENTE DE CURENT',0),(24780,689,'et','PRAEGUSED ÃœKSUSED',0),(24781,689,'si','TRENUTNIH NALOG',0),(24782,689,'ba','ITEM YANG SAAT INI',0),(24783,689,'nl','HUIDIGE ARTIKELEN',0),(24784,689,'fi','NYKYISET KOHTEET',0),(24785,689,'no','GJELDENDE ELEMENTER',0),(24786,689,'da','AKTUELLE EMNER',0),(24787,689,'ko','í˜„ìž¬ í•­ëª©',0),(24788,689,'he','×¤×¨×™×˜×™× × ×•×›×—×™×™×',0),(24789,689,'el','Î¤Î¡ÎˆÎ§ÎŸÎÎ¤Î‘ Î£Î¤ÎŸÎ™Î§Î•ÎŠÎ‘',0),(24790,689,'zh','ç»å¸¸é¡¹ç›®\r\n',0),(24791,689,'sv','AKTUELLA OBJEKT',0),(24792,689,'it','ELEMENTI CORRENTI',0),(24793,689,'tl','',0),(24794,689,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(24795,689,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(24796,689,'ms','ITEM SEMASA',0),(24797,689,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(24798,689,'fr','Ã‰LÃ‰MENTS ACTIFS',0),(24799,689,'jp','ç?¾åœ¨ã?®å“?ç›®',0),(24800,689,'pt','ARTIGOS ATUAIS',0),(24801,689,'ru','Ð¢Ð•ÐšÐ£Ð©Ð˜Ð• Ð¢ÐžÐ’ÐÐ Ð«',0),(24802,689,'es','ITEMS ACTUALES',0),(24803,689,'de','AKTUELLE ARTIKEL',0),(24804,689,'en','CURRENT ITEMS',0),(24805,690,'is','',0),(24806,690,'dr','ØµÙØ­Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(24807,690,'pr','ØµÙØ­Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(24808,690,'tr','GeÃ§erli sayfa',0),(24809,690,'pl','BieÅ¼Ä…ca strona',0),(24810,690,'bg','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(24811,690,'ur','Ø­Ø§Ù„ÛŒÛ ØµÙØ­Û',0),(24812,690,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(24813,690,'vi','Trang hiá»‡n táº¡i',0),(24814,690,'af','Huidige Blad',0),(24815,690,'ro','Pagina curentÄƒ',0),(24816,690,'et','Praegune leht',0),(24817,690,'si','Trenutna stran',0),(24818,690,'ba','Saat ini Halaman',0),(24819,690,'nl','Huidige pagina',0),(24820,690,'fi','Nykyinen sivu',0),(24821,690,'no','Gjeldende side',0),(24822,690,'da','Aktuel side',0),(24823,690,'ko','í˜„ìž¬ íŽ˜ì´ì§€',0),(24824,690,'he','×”×¢×ž×•×“ ×”× ×•×›×—×™',0),(24825,690,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÏƒÎµÎ»Î¯Î´Î±',0),(24826,690,'zh','å½“å‰é¡µ\r\n',0),(24827,690,'sv','Aktuell sida',0),(24828,690,'it','Pagina corrente',0),(24829,690,'tl','',0),(24830,690,'th','&#3627;&#3609;&#3657;&#3634;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(24831,690,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ªà¥ƒà¤·à¥à¤ ',0),(24832,690,'ms','Laman semasa',0),(24833,690,'ar','Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(24834,690,'fr','Page en cours',0),(24835,690,'jp','ç?¾åœ¨ã?®ãƒšãƒ¼ã‚¸',0),(24836,690,'pt','PÃ¡gina atual',0),(24837,690,'ru','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(24838,690,'es','PÃ¡gina Actual',0),(24839,690,'de','Aktuelle Seite',0),(24840,690,'en','Current Page',0),(24841,691,'is','',0),(24842,691,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ¹Ù„ÙŠ ',0),(24843,691,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ¹Ù„ÙŠ ',0),(24844,691,'tr','GeÃ§erli toplam',0),(24845,691,'pl','BieÅ¼Ä…cÄ… sumÄ™',0),(24846,691,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(24847,691,'ur','Ø­Ø§Ù„ÛŒÛ Ú©Ù„',0),(24848,691,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð·Ð±Ð¸Ñ€',0),(24849,691,'vi','Tá»•ng cá»™ng hiá»‡n thá»i ',0),(24850,691,'af','Huidige Totaal',0),(24851,691,'ro','Totalul curent',0),(24852,691,'et','Praegune kogusumma',0),(24853,691,'si','Trenutno skupna',0),(24854,691,'ba','Saat ini Total',0),(24855,691,'nl','Huidige totaal',0),(24856,691,'fi','YhteensÃ¤',0),(24857,691,'no','TotalbelÃ¸pet',0),(24858,691,'da','NuvÃ¦rende i alt',0),(24859,691,'ko','í˜„ìž¬ ì´',0),(24860,691,'he','×¡×š × ×•×›×—×™',0),(24861,691,'el','Î¤ÏÎ­Ï‡Î¿Î½ ÏƒÏÎ½Î¿Î»Î¿',0),(24862,691,'zh','å½“å‰æ€»é¢\r\n',0),(24863,691,'sv','Nuvarande totalt',0),(24864,691,'it','Corrente totale',0),(24865,691,'tl','',0),(24866,691,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(24867,691,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¥à¤²',0),(24868,691,'ms','Jumlah semasa',0),(24869,691,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(24870,691,'fr','Total actuel',0),(24871,691,'jp','ç?¾åœ¨ã?®å?ˆè¨ˆ',0),(24872,691,'pt','Total atual',0),(24873,691,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð²ÑÐµÐ³Ð¾',0),(24874,691,'es','Total Actual',0),(24875,691,'de','Aktuelle Summe',0),(24876,691,'en','Current Total',0),(24877,692,'is','',0),(24878,692,'dr','( ØªØ³ÙˆÙŠÙ‡ Ø­Ø³Ø§Ø¨ ÙƒØ±Ø¯Ù† )  Ø¨Ø§ ',0),(24879,692,'pr','Ø§Ø®ÙŠØ±Ø§ Ø¨Ø±Ø±Ø³ÙŠ Ø´Ø¯ ( ØªØ³ÙˆÙŠÙ‡ Ø­Ø³Ø§Ø¨ ÙƒØ±Ø¯Ù† )  Ø¨Ø§ ',0),(24880,692,'tr','Åžu anda kullanÄ±ma',0),(24881,692,'pl','Obecnie wyewidencjonowane dla',0),(24882,692,'bg','Ð’ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° ÑÐµ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð° ÑÐµ Ð¿Ñ€Ð¸',0),(24883,692,'ur','Ø§Ø³ ÙˆÙ‚Øª Ø³Û’ Ø®Ø§Ø±Ø¬ Ú©Ø± Ø¯ÛŒØ§',0),(24884,692,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð¾Ð´Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð° Ð½Ð°',0),(24885,692,'vi','Hiá»‡n nay ra Ä‘áº¿n',0),(24886,692,'af','Huidiglik uitgeteken aan',0),(24887,692,'ro','Verificat Ã®n prezent la',0),(24888,692,'et','Praegu vÃ¤ljamÃ¶llitud',0),(24889,692,'si','Trenutno rezerviran za',0),(24890,692,'ba','Saat ini memeriksa untuk',0),(24891,692,'nl','Momenteel uitgecheckt om te',0),(24892,692,'fi','Kuitattu ulos',0),(24893,692,'no','Sjekket ut til',0),(24894,692,'da','I Ã¸jeblikket er tjekket ud til',0),(24895,692,'ko','í˜„ìž¬ ì²´í¬ ì•„ì›ƒ',0),(24896,692,'he','×›×¢×ª ×ž××—×¡×•×Ÿ',0),(24897,692,'el','Î•Ï€Î¯ Ï„Î¿Ï… Ï€Î±ÏÏŒÎ½Ï„Î¿Ï‚ Î±Ï€Î¿ÏƒÏ…ÏÎ¼Î­Î½Î± ÏƒÎµ',0),(24898,692,'zh','ç›®å‰ç­¾å‡º\r\n',0),(24899,692,'sv','Utcheckat till',0),(24900,692,'it','Attualmente estratti a',0),(24901,692,'tl','',0),(24902,692,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3629;&#3629;&#3585;&#3651;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3626;&#3641;&#3656;',0),(24903,692,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¥‡à¤• à¤†à¤‰à¤Ÿ',0),(24904,692,'ms','Kini keluar masuk ke',0),(24905,692,'ar','Ø§Ù„Ø³Ø­Ø¨ ÙÙŠ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ø­Ø§Ù„ÙŠ Ø¥Ù„Ù‰',0),(24906,692,'fr','Actuellement retirÃ©s Ã ',0),(24907,692,'jp','ï½žã?¸ä»Šãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?—ã?¦ã?„ã?¾ã?™',0),(24908,692,'pt','Atualmente, check-out para',0),(24909,692,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(24910,692,'es','Actualmente sacado en prÃ©stamo a',0),(24911,692,'de','Derzeit ausgecheckt wurden',0),(24912,692,'en','Currently checked out to',0),(24913,693,'is','',0),(24914,693,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(24915,693,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(24916,693,'tr','MÃ¼ÅŸteri',0),(24917,693,'pl','Nabywca',0),(24918,693,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚',0),(24919,693,'ur','Ú©',0),(24920,693,'sr','Ð—Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(24921,693,'vi','KhÃ¡ch hÃ ng',0),(24922,693,'af','Klant',0),(24923,693,'ro','Mihai',0),(24924,693,'et','Kliendiandmiku kande nr',0),(24925,693,'si','Postavka kupca',0),(24926,693,'ba','Cust',0),(24927,693,'nl','Cust',0),(24928,693,'fi','Asiakastapahtuma',0),(24929,693,'no','Kundepost',0),(24930,693,'da','Debitorpost',0),(24931,693,'ko','Cust',0),(24932,693,'he','×¢×œ×•×ª',0),(24933,693,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚',0),(24934,693,'zh','å®¢æˆ·\r\n',0),(24935,693,'sv','Cust',0),(24936,693,'it','Cust',0),(24937,693,'tl','',0),(24938,693,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(24939,693,'hi','Cust',0),(24940,693,'ms','Cust',0),(24941,693,'ar','Cust',0),(24942,693,'fr','Cust',0),(24943,693,'jp','Cust',0),(24944,693,'pt','Cust',0),(24945,693,'ru','Cust',0),(24946,693,'es','Clnte',0),(24947,693,'de','Cust',0),(24948,693,'en','Cust',0),(24949,694,'is','',0),(24950,694,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± Ø´Ø±ÙƒØª Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(24951,694,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± Ø´Ø±ÙƒØª Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(24952,694,'tr','Custcompanyid geÃ§ersiz.',0),(24953,694,'pl','Custcompanyid nieprawidÅ‚owe.',0),(24954,694,'bg','Custcompanyid Ð½ÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½.',0),(24955,694,'ur','Ú©Ø³Ù¹Ú©ÙˆÙ…Ù¾Ù†ÛŒØ§Ø¯ Ù†Ø§Ø¬Ø§Ø¦Ø² ÛÛ’ Û”',0),(24956,694,'sr','Ð¦ÑƒÑÑ‚Ñ†Ð¾Ð¼Ð¿Ð°Ð½yÐ¸Ð´ Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð°.',0),(24957,694,'vi','VÃ´ hiá»‡u',0),(24958,694,'af','Ongeldige Custcompanyid.',0),(24959,694,'ro','Custcompanyid nevalid.',0),(24960,694,'et','Custcompanyid ei sobi.',0),(24961,694,'si','Neveljaven Custcompanyid.',0),(24962,694,'ba','Custcompanyid tidak valid.',0),(24963,694,'nl','Ongeldige Custcompanyid.',0),(24964,694,'fi','Custcompanyid ei kelpaa.',0),(24965,694,'no','Custcompanyid er ugyldig.',0),(24966,694,'da','Custcompanyid ugyldig.',0),(24967,694,'ko','ìž˜ëª» ëœ Custcompanyidìž…ë‹ˆë‹¤.',0),(24968,694,'he','Custcompanyid ×œ× ×—×•×§×™×ª.',0),(24969,694,'el','Custcompanyid Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ·.',0),(24970,694,'zh','å®¢æˆ·å…¬å¸IDæ— æ•ˆ',0),(24971,694,'sv','Custcompanyid ogiltigt.',0),(24972,694,'it','Custcompanyid non valido.',0),(24973,694,'tl','',0),(24974,694,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(24975,694,'hi','Custcompanyid à¤…à¤®à¤¾à¤¨à¥à¤¯à¥¤',0),(24976,694,'ms','Custcompanyid tidak sah.',0),(24977,694,'ar','ÙƒÙˆØ³ØªÙƒÙˆÙ…Ø¨Ø§Ù†ÙŠÙŠØ¯ ØºÙŠØ± ØµØ§Ù„Ø­.',0),(24978,694,'fr','Custcompanyid non valide.',0),(24979,694,'jp','Custcompanyid invalid.',0),(24980,694,'pt','Custcompanyid invÃ¡lido.',0),(24981,694,'ru','Custcompanyid Ð½ÐµÐ²ÐµÑ€Ð½Ñ‹Ð¹.',0),(24982,694,'es','Clnteidempresa invalido',0),(24983,694,'de','Custcompanyid ungÃ¼ltig.',0),(24984,694,'en','Custcompanyid invalid.',0),(24985,695,'is','',0),(24986,695,'dr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(24987,695,'pr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(24988,695,'tr','Ã–zel',0),(24989,695,'pl','Niestandardowe',0),(24990,695,'bg','ÐŸÐ¾ Ð¸Ð·Ð±Ð¾Ñ€',0),(24991,695,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚',0),(24992,695,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¾',0),(24993,695,'vi','Tá»± lÃ m',0),(24994,695,'af','Aangepasde',0),(24995,695,'ro','Custom',0),(24996,695,'et','Vali...',0),(24997,695,'si','Po meri',0),(24998,695,'ba','Custom',0),(24999,695,'nl','Aangepaste',0),(25000,695,'fi','Custom',0),(25001,695,'no','Egendefinert',0),(25002,695,'da','Custom',0),(25003,695,'ko','ì‚¬ìš©ìž ì§€ì •',0),(25004,695,'he','×ž×•×ª×× ××™×©×™×ª',0),(25005,695,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î·',0),(25006,695,'zh','è‡ªå®šä¹‰\r\n',0),(25007,695,'sv','Anpassad',0),(25008,695,'it','Custom',0),(25009,695,'tl','',0),(25010,695,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3612;&#3641;&#3657;&#3595;&#3639;&#3657;&#3629;',0),(25011,695,'hi','à¤•à¤¸à¥à¤Ÿà¤®',0),(25012,695,'ms','Adat',0),(25013,695,'ar','Ù…Ø®ØµØµ',0),(25014,695,'fr','Custom',0),(25015,695,'jp','å¾—æ„?å…ˆ',0),(25016,695,'pt','Personalizado',0),(25017,695,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ',0),(25018,695,'es','Personalizado',0),(25019,695,'de','Custom',0),(25020,695,'en','Custom',0),(25021,696,'is','',0),(25022,696,'dr','Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª ØªÙˆÙ„ÙŠØ¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ ',0),(25023,696,'pr','Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª ØªÙˆÙ„ÙŠØ¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ ',0),(25024,696,'tr','Ã–zel PMS',0),(25025,696,'pl','Niestandardowe PMS',0),(25026,696,'bg','Custom PMS',0),(25027,696,'ur','Ù…Ø®ØµÙˆØµ ÙˆØ²Ø±Ø§Ø¦Û’ Ø§Ø¹Ø¸Ù… Ú©Ø§',0),(25028,696,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¾ ÐŸÐœÐ¡',0),(25029,696,'vi','PMS tá»± táº¡o',0),(25030,696,'af','Aangepasde PMS',0),(25031,696,'ro','Custom PMS',0),(25032,696,'et','Kohandatud PMS',0),(25033,696,'si','Custom PMS',0),(25034,696,'ba','Custom PMS',0),(25035,696,'nl','Aangepaste PMS',0),(25036,696,'fi','Custom PMS',0),(25037,696,'no','Egendefinert PMS',0),(25038,696,'da','Custom PMS',0),(25039,696,'ko','ì‚¬ìš©ìž ì •ì˜ PMS',0),(25040,696,'he','×ž×•×ª×× ××™×©×™×ª PMS',0),(25041,696,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· PMS',0),(25042,696,'zh','è‡ªå®šä¹‰ç§äººæ¶ˆæ¯\r\n',0),(25043,696,'sv','Anpassad PMS',0),(25044,696,'it','Custom PMS',0),(25045,696,'tl','',0),(25046,696,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; PMS',0),(25047,696,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤ªà¥€à¤à¤®à¤à¤¸',0),(25048,696,'ms','Adat PMS',0),(25049,696,'ar','Ø¹Ø±Ù Ø§Ù„Ø¯ÙˆØ±Ø© Ø§Ù„Ø´Ù‡Ø±ÙŠØ©',0),(25050,696,'fr','Custom PMS',0),(25051,696,'jp','å¾—æ„?å…ˆï¼°ï¼­ï¼³',0),(25052,696,'pt','Custom PMS',0),(25053,696,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ PMS',0),(25054,696,'es','PMS Personalizado',0),(25055,696,'de','Benutzerdefinierte PMS',0),(25056,696,'en','Custom PMS',0),(25057,697,'is','',0),(25058,697,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25059,697,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25060,697,'tr','MÃ¼ÅŸteri',0),(25061,697,'pl','Klienta',0),(25062,697,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚',0),(25063,697,'ur','Ú¯Ø§ÛÚ©',0),(25064,697,'sr','ÐšÑƒÐ¿Ð°Ñ†',0),(25065,697,'vi','KhÃ¡ch hÃ ng',0),(25066,697,'af','Klant/KliÃ«nt',0),(25067,697,'ro','Client',0),(25068,697,'et','Klient',0),(25069,697,'si','Kupca',0),(25070,697,'ba','Pelanggan',0),(25071,697,'nl','Klant',0),(25072,697,'fi','Asiakkaan',0),(25073,697,'no','Kunden',0),(25074,697,'da','Kunde',0),(25075,697,'ko','ê³ ê°',0),(25076,697,'he','×œ×§×•×—',0),(25077,697,'el','Î ÎµÎ»Î¬Ï„Î·',0),(25078,697,'zh','å®¢æˆ·\r\n',0),(25079,697,'sv','Kunden',0),(25080,697,'it','Cliente',0),(25081,697,'tl','',0),(25082,697,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25083,697,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•',0),(25084,697,'ms','Pelanggan',0),(25085,697,'ar','Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(25086,697,'fr','Client',0),(25087,697,'jp','é¡§å®¢',0),(25088,697,'pt','Cliente',0),(25089,697,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚',0),(25090,697,'es','Cliente',0),(25091,697,'de','Kunde',0),(25092,697,'en','Customer',0),(25093,698,'is','',0),(25094,698,'dr','Ø­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(25095,698,'pr','Ø­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(25096,698,'tr','MÃ¼ÅŸteri hesabÄ±',0),(25097,698,'pl','Konto klienta',0),(25098,698,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(25099,698,'ur','Ú©Ø³Ù¹Ù…Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(25100,698,'sr','Ð Ð°Ñ‡ÑƒÐ½ ÐºÑƒÐ¿Ñ†Ð°',0),(25101,698,'vi','TK KhÃ¡ch HÃ ng',0),(25102,698,'af','Klant/KliÃ«nt Rekening',0),(25103,698,'ro','Contul de client',0),(25104,698,'et','Kliendi konto',0),(25105,698,'si','RaÄun kupca',0),(25106,698,'ba','Akun pelanggan',0),(25107,698,'nl','Klantenaccount',0),(25108,698,'fi','Asiakastili',0),(25109,698,'no','Kundekonto',0),(25110,698,'da','Debitorkontoen',0),(25111,698,'ko','ê³ ê° ê³„ì •',0),(25112,698,'he','×—×©×‘×•×Ÿ ×œ×§×•×—',0),(25113,698,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(25114,698,'zh','å®¢æˆ·å¸æˆ·\r\n',0),(25115,698,'sv','Kundkonto',0),(25116,698,'it','Conto cliente',0),(25117,698,'tl','',0),(25118,698,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25119,698,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤–à¤¾à¤¤à¤¾',0),(25120,698,'ms','Akaun pelanggan',0),(25121,698,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(25122,698,'fr','Compte client',0),(25123,698,'jp','é¡§å®¢ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(25124,698,'pt','Conta de cliente',0),(25125,698,'ru','Ð¡Ñ‡ÐµÑ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25126,698,'es','Cuenta de Cliente',0),(25127,698,'de','Kundenkonto',0),(25128,698,'en','Customer Account',0),(25129,699,'is','',0),(25130,699,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25131,699,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25132,699,'tr','MÃ¼ÅŸteri Ekle',0),(25133,699,'pl','Dodaj klienta',0),(25134,699,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(25135,699,'ur','Ú¯Ø§ÛÚ© Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(25136,699,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÑƒÐ¿Ñ†Ð°',0),(25137,699,'vi','ThÃªm KhÃ¡ch hÃ ng',0),(25138,699,'af','Klant/KliÃ«nt Byvoeg',0),(25139,699,'ro','Adauga client',0),(25140,699,'et','Lisa klient',0),(25141,699,'si','Dodajanje kupcev',0),(25142,699,'ba','Tambahkan pelanggan',0),(25143,699,'nl','Klant toevoegen',0),(25144,699,'fi','Asiakkaan lisÃ¤Ã¤minen',0),(25145,699,'no','Kunde legge til',0),(25146,699,'da','Kunde fÃ¸je',0),(25147,699,'ko','ê³ ê° ì¶”ê°€',0),(25148,699,'he','×”×•×¡×¤×ª ×œ×§×•×— ',0),(25149,699,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€ÎµÎ»Î¬Ï„Î·',0),(25150,699,'zh','æ–°å¢žå®¢æˆ·\r\n',0),(25151,699,'sv','Kund lÃ¤gga till',0),(25152,699,'it','Aggiungi cliente',0),(25153,699,'tl','',0),(25154,699,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25155,699,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(25156,699,'ms','Baca Tambah',0),(25157,699,'ar','Ø¥Ø¶Ø§ÙØ© Ø²Ø¨ÙˆÙ†',0),(25158,699,'fr','Ajouter client',0),(25159,699,'jp','é¡§å®¢ã?®è¿½åŠ ',0),(25160,699,'pt','Adicionar cliente',0),(25161,699,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25162,699,'es','Cliente Agregar',0),(25163,699,'de','Kunden hinzufÃ¼gen',0),(25164,699,'en','Customer Add',0),(25165,700,'is','',0),(25166,700,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(25167,700,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(25168,700,'tr','MÃ¼ÅŸteri baÅŸarÄ±yla eklendi',0),(25169,700,'pl','Klient pomyÅ›lnie dodane',0),(25170,700,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(25171,700,'ur','Ú¯Ø§ÛÚ© Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(25172,700,'sr','ÐšÑƒÐ¿Ð°Ñ† Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(25173,700,'vi','ThÃªm KhÃ¡ch hÃ ng thÃ nh cÃ´ng',0),(25174,700,'af','Klant/KliÃ«nt suksesvol bygevoeg',0),(25175,700,'ro','Client adÄƒugat cu succes',0),(25176,700,'et','Klient edukalt lisatud',0),(25177,700,'si','Stranke, ki so dodani',0),(25178,700,'ba','Pelanggan ditambahkan berhasil',0),(25179,700,'nl','Klant met succes toegevoegd',0),(25180,700,'fi','Asiakkaan lisÃ¤Ã¤minen onnistui',0),(25181,700,'no','Kunden ble lagt til',0),(25182,700,'da','Kunde tilfÃ¸jet',0),(25183,700,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ê³ ê°',0),(25184,700,'he','×œ×§×•×— × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(25185,700,'el','Î ÎµÎ»Î¬Ï„Î· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(25186,700,'zh','ç”¨æˆ·æ·»åŠ æˆåŠŸ\r\n',0),(25187,700,'sv','Kund som lagts',0),(25188,700,'it','Cliente aggiunto con successo',0),(25189,700,'tl','',0),(25190,700,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(25191,700,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(25192,700,'ms','Pelanggan yang berjaya menambah',0),(25193,700,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ø²Ø¨ÙˆÙ† Ø¨Ù†Ø¬Ø§Ø­',0),(25194,700,'fr','Client ajoutÃ© avec succÃ¨s',0),(25195,700,'jp','é¡§å®¢ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(25196,700,'pt','Cliente adicionado com sucesso',0),(25197,700,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(25198,700,'es','Cliente Agregado Exitosamente',0),(25199,700,'de','Kunden, die erfolgreich hinzugefÃ¼gt',0),(25200,700,'en','Customer added successfully',0),(25201,701,'is','',0),(25202,701,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ù…Ø¹ Ù…ÙŠ Ø´ÙˆØ¯  Ø¨Ù‡ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(25203,701,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ù…Ø¹ Ù…ÙŠ Ø´ÙˆØ¯  Ø¨Ù‡ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(25204,701,'tr','Åžarj iÃ§in mÃ¼ÅŸteri tutarÄ±',0),(25205,701,'pl','Klienta kwoty opÅ‚aty',0),(25206,701,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑƒÐ¼Ð° Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(25207,701,'ur','Ú©Ø³Ù¹Ù…Ø± Ø±Ù‚Ù… Ú†Ø§Ø±Ø¬ Ú©Ø±Ù†Û’',0),(25208,701,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° ÐºÑƒÐ¿Ñ†Ð° Ð·Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ñƒ',0),(25209,701,'vi','PhÃ­ tÃ­nh KhÃ¡ch hÃ ng',0),(25210,701,'af','Klant/KliÃ«nt Bedrag om te Hef',0),(25211,701,'ro','Clientului valoarea taxelor',0),(25212,701,'et','Kliendi summa eest',0),(25213,701,'si','Kupec znesek dajatev',0),(25214,701,'ba','Jumlah pelanggan biaya',0),(25215,701,'nl','Klant bedrag aan heffing',0),(25216,701,'fi','Asiakkaan summa ilmaiseksi',0),(25217,701,'no','Kunden belÃ¸p Ã¥ lade',0),(25218,701,'da','Kunden belÃ¸bet til betaling',0),(25219,701,'ko','ì¶©ì „ ê¸ˆì•¡ì€ ê³ ê°',0),(25220,701,'he','×”×œ×§×•×— ×¡×›×•× ×ª×©×œ×•×',0),(25221,701,'el','Î Î¿ÏƒÏŒ Ï€ÎµÎ»Î¬Ï„Î· Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(25222,701,'zh','å®¢æˆ·æ”¶è´¹æ¬¾é¢\r\n',0),(25223,701,'sv','Kunden belopp avgift',0),(25224,701,'it','Cliente importo addebitare',0),(25225,701,'tl','',0),(25226,701,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3592;&#3632;&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(25227,701,'hi','à¤šà¤¾à¤°à¥à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¾à¤¶à¤¿',0),(25228,701,'ms','Jumlah pelanggan untuk bayaran',0),(25229,701,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ù…Ø¨Ù„Øº Ù„Ù„Ù…Ø³Ø¤ÙˆÙ„',0),(25230,701,'fr','Client s\'Ã©lÃ¨vent Ã  Charge',0),(25231,701,'jp','é¡§å®¢è«‹æ±‚é¡?',0),(25232,701,'pt','Cliente quantidade de carga',0),(25233,701,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(25234,701,'es','Cliente Monto a Cobrar',0),(25235,701,'de','Kunde Betrag zu berechnen',0),(25236,701,'en','Customer Amount to Charge',0),(25237,702,'is','',0),(25238,702,'dr','ÙƒØ¯ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25239,702,'pr','ÙƒØ¯ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25240,702,'tr','MÃ¼ÅŸteri Fatura kodu',0),(25241,702,'pl','Kod rachunku klienta',0),(25242,702,'bg','ÐšÐ¾Ð´ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(25243,702,'ur','Ú©Ø³Ù¹Ù…Ø± Ø¨Ù„ Ú©ÙˆÚˆ',0),(25244,702,'sr','Ð‘Ð¸Ð» ÑˆÐ¸Ñ„Ñ€Ñƒ ÐºÑƒÐ¿Ñ†Ð°',0),(25245,702,'vi','MÃ£ sá»‘ thanh toÃ¡n cá»§a khÃ¡ch hÃ ng ',0),(25246,702,'af','KliÃ«nt Wetsontwerp kode',0),(25247,702,'ro','Codul de factura clientului',0),(25248,702,'et','Kliendi arve number',0),(25249,702,'si','Bill kupca',0),(25250,702,'ba','Kode tagihan pelanggan',0),(25251,702,'nl','Klant Bill Code',0),(25252,702,'fi','Asiakkaan laskun koodi',0),(25253,702,'no','Bill kundekode',0),(25254,702,'da','Kunde Bill kode',0),(25255,702,'ko','ê³ ê° ë¹Œ ì½”ë“œ',0),(25256,702,'he','×§×•×“ ×—×©×‘×•×Ÿ ×”×œ×§×•×—',0),(25257,702,'el','Bill ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(25258,702,'zh','å®¢æˆ·å¸å•ä»£ç \r\n',0),(25259,702,'sv','Kunden Bill kod',0),(25260,702,'it','Codice fattura cliente',0),(25261,702,'tl','',0),(25262,702,'th','&#3619;&#3627;&#3633;&#3626;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25263,702,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¬à¤¿à¤² à¤•à¥‹à¤¡',0),(25264,702,'ms','Pelanggan bil kod',0),(25265,702,'ar','Ø±Ù…Ø² ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(25266,702,'fr','Code de facture client',0),(25267,702,'jp','é¡§å®¢è«‹æ±‚æ›¸ã‚³ãƒ¼ãƒ‰',0),(25268,702,'pt','CÃ³digo de conta de cliente',0),(25269,702,'ru','Ð‘Ð¸Ð»Ð» ÐºÐ¾Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25270,702,'es','Cliente CÃ³digo de FacturaciÃ³n',0),(25271,702,'de','Bill Kundencode',0),(25272,702,'en','Customer Bill Code',0),(25273,703,'is','',0),(25274,703,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25275,703,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25276,703,'tr','MÃ¼ÅŸteri Ã¼cretleri',0),(25277,703,'pl','Odbiorcy opÅ‚at',0),(25278,703,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ñ‚Ð°ÐºÑÐ¸',0),(25279,703,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(25280,703,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(25281,703,'vi','PhÃ­ KhÃ¡ch hÃ ng',0),(25282,703,'af','KliÃ«nt / Klant Kostes',0),(25283,703,'ro','Taxele de client',0),(25284,703,'et','Kliendi makse',0),(25285,703,'si','Bo zaraÄunavalo strankam',0),(25286,703,'ba','Biaya pelanggan',0),(25287,703,'nl','Klant kosten',0),(25288,703,'fi','Asiakkaan maksut',0),(25289,703,'no','Kunden kostnader',0),(25290,703,'da','Kunden gebyrer',0),(25291,703,'ko','ê³ ê° ìš”ê¸ˆ',0),(25292,703,'he','×”×—×™×•×‘×™× ×œ×œ×§×•×—',0),(25293,703,'el','Î§ÏÎµÏŽÏƒÎµÎ¹Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(25294,703,'zh','å®¢æˆ·æ”¶è´¹\r\n',0),(25295,703,'sv','Kunden avgifter',0),(25296,703,'it','Oneri del cliente',0),(25297,703,'tl','',0),(25298,703,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25299,703,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤†à¤°à¥‹à¤ª',0),(25300,703,'ms','Caj pelanggan',0),(25301,703,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(25302,703,'fr','Frais du client',0),(25303,703,'jp','é¡§å®¢è² æ‹…',0),(25304,703,'pt','Encargos do cliente',0),(25305,703,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð·Ð°ÐºÐ°Ð·Ñ‡Ð¸ÐºÐ°',0),(25306,703,'es','Cliente Cargos de',0),(25307,703,'de','Kunden GebÃ¼hren',0),(25308,703,'en','Customer Charges',0),(25309,704,'is','',0),(25310,704,'dr','Ù†Ø§Ù… Ø´Ø±ÙƒØª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25311,704,'pr','Ù†Ø§Ù… Ø´Ø±ÙƒØª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25312,704,'tr','MÃ¼ÅŸteri ÅŸirket adÄ±',0),(25313,704,'pl','Nazwa firmy klienta',0),(25314,704,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25315,704,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù…',0),(25316,704,'sr','Ð˜Ð¼Ðµ ÐºÑƒÐ¿Ñ†Ð° Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð°',0),(25317,704,'vi','TÃªn cty khÃ¡ch hÃ ng',0),(25318,704,'af','Klant / KliÃ«nt Ondernemingnaam',0),(25319,704,'ro','Numele companiei client',0),(25320,704,'et','Kliendi ettevÃµtte nimi',0),(25321,704,'si','Ime podjetja za kupca',0),(25322,704,'ba','Nama pelanggan perusahaan',0),(25323,704,'nl','Klant bedrijfsnaam',0),(25324,704,'fi','Asiakasyrityksen nimi',0),(25325,704,'no','Kundens firmanavn',0),(25326,704,'da','Kunde firmanavn',0),(25327,704,'ko','ê³ ê° íšŒì‚¬ ì´ë¦„',0),(25328,704,'he','×©× ×”×—×‘×¨×” ×œ×§×•×—×•×ª',0),(25329,704,'el','Î•Ï€Ï‰Î½Ï…Î¼Î¯Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(25330,704,'zh','å®¢æˆ·å…¬å¸åç§°\r\n',0),(25331,704,'sv','Kunden fÃ¶retagets namn',0),(25332,704,'it','Nome dell\'azienda cliente',0),(25333,704,'tl','',0),(25334,704,'th','&#3594;&#3639;&#3656;&#3629;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25335,704,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤‚à¤ªà¤¨à¥€ à¤¨à¤¾à¤®',0),(25336,704,'ms','Nama syarikat pelanggan',0),(25337,704,'ar','Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(25338,704,'fr','Nom de l\'entreprise du client',0),(25339,704,'jp','é¡§å®¢ä¼šç¤¾å??',0),(25340,704,'pt','Nome da empresa do cliente',0),(25341,704,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25342,704,'es','Cliente Nombre de Empresa',0),(25343,704,'de','Kunden Firmennamen',0),(25344,704,'en','Customer Company Name',0),(25345,705,'is','',0),(25346,705,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(25347,705,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(25348,705,'tr','MÃ¼ÅŸteri baÅŸarÄ±yla silindi',0),(25349,705,'pl','Klient pomyÅ›lnie usuniÄ™ty',0),(25350,705,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(25351,705,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(25352,705,'sr','ÐšÑƒÐ¿Ð°Ñ† Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(25353,705,'vi','XÃ³a KhÃ¡ch hÃ ng thÃ nh cÃ´ng',0),(25354,705,'af','Klant / KliÃ«nt suksesvol geskrap',0),(25355,705,'ro','Client eliminÄƒ cu succes',0),(25356,705,'et','Klient kustutati edukalt',0),(25357,705,'si','Stranke, ki so uspeÅ¡no izbrisana',0),(25358,705,'ba','Pelanggan yang berhasil dihapus',0),(25359,705,'nl','Klant met succes verwijderd',0),(25360,705,'fi','Asiakkaan poistettu',0),(25361,705,'no','Kunden slettet',0),(25362,705,'da','Kunde slettet',0),(25363,705,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ê³ ê°',0),(25364,705,'he','×”×œ×§×•×— × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(25365,705,'el','Î ÎµÎ»Î¬Ï„Î· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(25366,705,'zh','å®¢æˆ·åˆ é™¤æˆåŠŸ',0),(25367,705,'sv','Kunden raderades',0),(25368,705,'it','Cliente eliminato con successo',0),(25369,705,'tl','',0),(25370,705,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(25371,705,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(25372,705,'ms','Pelanggan yang berjaya dipadam',0),(25373,705,'ar','Ø­Ø°Ù Ø§Ù„Ø²Ø¨ÙˆÙ† Ø¨Ù†Ø¬Ø§Ø­',0),(25374,705,'fr','Client supprimÃ© avec succÃ¨s',0),(25375,705,'jp','é¡§å®¢ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(25376,705,'pt','Cliente excluÃ­do com sucesso',0),(25377,705,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½',0),(25378,705,'es','Cliente eliminado exitosamente',0),(25379,705,'de','Kunden, die erfolgreich gelÃ¶scht',0),(25380,705,'en','Customer deleted successfully',0),(25381,706,'is','',0),(25382,706,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25383,706,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25384,706,'tr','MÃ¼ÅŸteri DÃ¼zenle',0),(25385,706,'pl','Edycja klientÃ³w',0),(25386,706,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(25387,706,'ur','Ú©Ø³Ù¹Ù…Ø± ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(25388,706,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÐºÑƒÐ¿Ñ†Ð°',0),(25389,706,'vi','KhÃ¡ch hÃ ng sá»­a',0),(25390,706,'af','Redigeer Klant / KliÃ«nt ',0),(25391,706,'ro','Editare de client',0),(25392,706,'et','Muuda klienti',0),(25393,706,'si','Urejanje kupca',0),(25394,706,'ba','Edit pelanggan',0),(25395,706,'nl','Klant bewerken',0),(25396,706,'fi','Asiakkaan muokkaaminen',0),(25397,706,'no','Kunden Rediger',0),(25398,706,'da','Kunde Rediger',0),(25399,706,'ko','ê³ ê° íŽ¸ì§‘',0),(25400,706,'he','×œ×§×•×—×•×ª ×¢×¨×™×›×”',0),(25401,706,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(25402,706,'zh','å®¢æˆ·ç¼–è¾‘\r\n',0),(25403,706,'sv','Kunden redigera',0),(25404,706,'it','Modifica del cliente',0),(25405,706,'tl','',0),(25406,706,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25407,706,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(25408,706,'ms','Edit pelanggan',0),(25409,706,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(25410,706,'fr','Edit du client',0),(25411,706,'jp','é¡§å®¢ã?®ç·¨é›†',0),(25412,706,'pt','EdiÃ§Ã£o de cliente',0),(25413,706,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25414,706,'es','Cliente Editar',0),(25415,706,'de','Kunde bearbeiten',0),(25416,706,'en','Customer Edit',0),(25417,707,'is','',0),(25418,707,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  ÙƒØ§Ø±Ø¨Ø± Ø®Ø±ÙŠØ¯Ø§Ø± Ø®Ø§Ø±Ø¬ÙŠ  ',0),(25419,707,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  ÙƒØ§Ø±Ø¨Ø± Ø®Ø±ÙŠØ¯Ø§Ø± Ø®Ø§Ø±Ø¬ÙŠ  ',0),(25420,707,'tr','MÃ¼ÅŸteri harici kullanÄ±cÄ± gÃ¼ncelleÅŸtirme',0),(25421,707,'pl','Aktualizacja klienta uÅ¼ytkownika zewnÄ™trznego',0),(25422,707,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð²ÑŠÐ½ÑˆÐµÐ½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(25423,707,'ur','Ú¯Ø§ÛÚ© Ø¨ÛŒØ±ÙˆÙ†ÛŒ ØµØ§Ø±Ù ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(25424,707,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÑƒÐ¿Ñ†Ð° ÐµÐºÑÑ‚ÐµÑ€Ð½Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(25425,707,'vi','Cáº­p Nháº­t NgÆ°á»i Sá»­ Dá»¥ng Cá»§a KhÃ¡ch HÃ ng BÃªn NgoÃ i',0),(25426,707,'af','Klant / KliÃ«nt Eksterne Gebruiksersopdatering ',0),(25427,707,'ro','Clientul extern utilizator Update',0),(25428,707,'et','Kliendi vÃ¤liskasutajatele Update',0),(25429,707,'si','Kupec zunanji uporabnik modernizirati',0),(25430,707,'ba','Pelanggan pengguna eksternal Update',0),(25431,707,'nl','Klant externe gebruiker Update',0),(25432,707,'fi','Asiakkaan ulkoinen kÃ¤yttÃ¤jÃ¤ pÃ¤ivitys',0),(25433,707,'no','Kunden ekstern bruker oppdateringen',0),(25434,707,'da','Kundernes eksterne bruger Update',0),(25435,707,'ko','ê³ ê°ì´ ì™¸ë¶€ ì‚¬ìš©ìž ì—…ë°ì´íŠ¸',0),(25436,707,'he','×”×œ×§×•×— ×ž×©×ª×ž×© ×—×™×¦×•× ×™ ×¢×“×›×•×Ÿ',0),(25437,707,'el','Î•Î¾Ï‰Ï„ÎµÏÎ¹ÎºÏŒÏ‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(25438,707,'zh','å®¢æˆ·å¤–éƒ¨ç”¨æˆ·æ›´æ–°\r\n',0),(25439,707,'sv','Kund-uppdatering fÃ¶r externa anvÃ¤ndare',0),(25440,707,'it','Aggiornamento utente esterno cliente',0),(25441,707,'tl','',0),(25442,707,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3592;&#3634;&#3585;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585;',0),(25443,707,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¬à¤¾à¤¹à¤°à¥€ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(25444,707,'ms','Pelanggan luar pengguna Kemaskini',0),(25445,707,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ø®Ø§Ø±Ø¬ÙŠ',0),(25446,707,'fr','Mise Ã  jour de client utilisateur externe',0),(25447,707,'jp','é¡§å®¢å¤–éƒ¨ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®æ›´æ–°',0),(25448,707,'pt','AtualizaÃ§Ã£o de cliente usuÃ¡rio externo',0),(25449,707,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð²Ð½ÐµÑˆÐ½ÐµÐ³Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25450,707,'es','Cliente Actualizar Usuario External',0),(25451,707,'de','Kunden externe Benutzer Update',0),(25452,707,'en','Customer External User Update',0),(25453,708,'is','',0),(25454,708,'dr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25455,708,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25456,708,'tr','MÃ¼ÅŸteri dosya sÃ¼tun biÃ§imi',0),(25457,708,'pl','Klienta kolumna Format pliku',0),(25458,708,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° Ñ„Ð°Ð¹Ð» ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(25459,708,'ur','Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„ Ú¯Ø§ÛÚ©',0),(25460,708,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÐºÑƒÐ¿Ñ†Ð°',0),(25461,708,'vi','Há»“ sÆ¡ KhÃ¡ch hÃ ng dáº¡ng cá»™t',0),(25462,708,'af','Klant / KliÃ«nt LÃªerkolomformaat',0),(25463,708,'ro','Client dosar Format coloane',0),(25464,708,'et','Kliendifaili veeru formaat',0),(25465,708,'si','Stolpec zapisa kupca',0),(25466,708,'ba','Format kolom pelanggan File',0),(25467,708,'nl','Klant kolom bestandsindeling',0),(25468,708,'fi','Asiakkaan sarakkeen tiedostomuoto',0),(25469,708,'no','Kunde-kolonnen filformat',0),(25470,708,'da','Kunde-kolonne filformat',0),(25471,708,'ko','ê³ ê° íŒŒì¼ ì—´ í˜•ì‹',0),(25472,708,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×§×•×‘×¥ ×œ×§×•×—×•×ª',0),(25473,708,'el','Î£Ï„Î®Î»Î· Î¼Î¿ÏÏ†Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï… Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(25474,708,'zh','å®¢æˆ·æ¡£æ¡ˆæ æ ¼å¼\r\n',0),(25475,708,'sv','Kund-kolumn filformatet',0),(25476,708,'it','Formato colonna cliente',0),(25477,708,'tl','',0),(25478,708,'th','&#3592;&#3633;&#3604;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3649;&#3615;&#3657;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3605;&#3634;&#3617;&#3649;&#3606;&#3623;',0),(25479,708,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(25480,708,'ms','Format kolum fail pelanggan',0),(25481,708,'ar','Ø¨Ù†ÙŠØ© Ø£Ø¹Ù…Ø¯Ø© Ù…Ù„Ù Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(25482,708,'fr','Format de colonne de fichier client',0),(25483,708,'jp','é¡§å®¢ãƒ•ã‚¡ã‚¤ãƒ«ã‚³ãƒ©ãƒ ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(25484,708,'pt','Formato de coluna do arquivo de cliente',0),(25485,708,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐšÐ¾Ð»Ð¾Ð½Ð¾Ðº Ð¤Ð°Ð¹Ð»Ð° ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25486,708,'es','Cliente Formato de Fila Columna',0),(25487,708,'de','Kunden-Datei-Spalten-Format',0),(25488,708,'en','Customer File Column Format',0),(25489,709,'is','',0),(25490,709,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25491,709,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25492,709,'tr','MÃ¼ÅŸteri geÃ§miÅŸi',0),(25493,709,'pl','Historia klienta',0),(25494,709,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(25495,709,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(25496,709,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(25497,709,'vi','Lá»‹ch sá»­ KhÃ¡ch hÃ ng',0),(25498,709,'af','Klant / KliÃ«nt Geskiedenis',0),(25499,709,'ro','Istoria clientului',0),(25500,709,'et','Kliendi ajalugu',0),(25501,709,'si','Zgodovina kupca',0),(25502,709,'ba','Sejarah pelanggan',0),(25503,709,'nl','Klantgeschiedenis',0),(25504,709,'fi','Asiakashistoria',0),(25505,709,'no','Kundehistorikk',0),(25506,709,'da','Kunde historie',0),(25507,709,'ko','ê³ ê° ê¸°ë¡',0),(25508,709,'he','×œ×§×•×—×•×ª ×”×™×¡×˜×•×¨×™×”',0),(25509,709,'el','Î™ÏƒÏ„Î¿ÏÎ¯Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(25510,709,'zh','å®¢æˆ·åŽ†å²è®°å½•\r\n',0),(25511,709,'sv','Kundhistorik',0),(25512,709,'it','Storia del cliente',0),(25513,709,'tl','',0),(25514,709,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25515,709,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(25516,709,'ms','Baca sejarah',0),(25517,709,'ar','Ø­Ø±ÙƒØ© Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(25518,709,'fr','Historique du client',0),(25519,709,'jp','é¡§å®¢å±¥æ­´',0),(25520,709,'pt','HistÃ³ria de cliente',0),(25521,709,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25522,709,'es','Cliente Historia',0),(25523,709,'de','Kundenhistorie',0),(25524,709,'en','Customer History',0),(25525,710,'is','',0),(25526,710,'dr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25527,710,'pr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25528,710,'tr','MÃ¼ÅŸteri listesi',0),(25529,710,'pl','Lista klientÃ³w',0),(25530,710,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(25531,710,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ÙÛØ±Ø³Øª',0),(25532,710,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(25533,710,'vi','Danh sÃ¡ch KhÃ¡ch hÃ ng',0),(25534,710,'af','Klant / KliÃ«nt Lys',0),(25535,710,'ro','Lista de client',0),(25536,710,'et','Klientide nimekiri',0),(25537,710,'si','Seznam kupcev',0),(25538,710,'ba','Daftar pelanggan',0),(25539,710,'nl','Klantenlijst',0),(25540,710,'fi','Asiakasluettelo',0),(25541,710,'no','Kundeoversikt',0),(25542,710,'da','Kundeliste',0),(25543,710,'ko','ê³ ê° ëª©ë¡',0),(25544,710,'he','×¨×©×™×ž×ª ×œ×§×•×—×•×ª',0),(25545,710,'el','Î ÎµÎ»Î±Ï„Î¿Î»ÏŒÎ³Î¹Î¿',0),(25546,710,'zh','å®¢æˆ·åå•\r\n',0),(25547,710,'sv','Kundlista',0),(25548,710,'it','Elenco dei clienti',0),(25549,710,'tl','',0),(25550,710,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25551,710,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‚à¤šà¥€',0),(25552,710,'ms','Senarai pelanggan',0),(25553,710,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(25554,710,'fr','Liste des clients',0),(25555,710,'jp','é¡§å®¢ãƒªã‚¹ãƒˆ',0),(25556,710,'pt','Lista de clientes',0),(25557,710,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(25558,710,'es','Cliente Lista',0),(25559,710,'de','Kundenliste',0),(25560,710,'en','Customer List',0),(25561,711,'is','',0),(25562,711,'dr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø± Ù…Ø­Ù„ Ø§ØµÙ„ÙŠ ',0),(25563,711,'pr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø± Ù…Ø­Ù„ Ø§ØµÙ„ÙŠ ',0),(25564,711,'tr','MÃ¼ÅŸteri listesi (ana konum)',0),(25565,711,'pl','Lista klientÃ³w (gÅ‚Ã³wnej lokalizacji)',0),(25566,711,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ (Ð¾ÑÐ½Ð¾Ð²Ð½Ð° Ð¼ÑÑÑ‚Ð¾)',0),(25567,711,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ÙÛØ±Ø³Øª (Ø§ØµÙ„ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹)',0),(25568,711,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÑƒÐ¿Ð°Ñ†Ð° (Ð³Ð»Ð°Ð²Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°)',0),(25569,711,'vi','Danh sÃ¡ch KhÃ¡ch hÃ ng (vá»‹ trÃ­ chÃ­nh)',0),(25570,711,'af','Klant / KliÃ«nt Lys (Hoofligging)',0),(25571,711,'ro','Lista de client (locaÅ£ia principalÄƒ)',0),(25572,711,'et','Klientide nimekiri (juriidiline aadress)',0),(25573,711,'si','Seznam kupcev (glavno mesto)',0),(25574,711,'ba','Daftar pelanggan (utama lokasi)',0),(25575,711,'nl','Klantenoverzicht (hoofdvestiging)',0),(25576,711,'fi','Asiakasluettelo (pÃ¤Ã¤asiallinen sijainti)',0),(25577,711,'no','Kundeliste (viktigste plassering)',0),(25578,711,'da','Kundeliste (vigtigste placering)',0),(25579,711,'ko','ê³ ê° ëª©ë¡ (ì£¼ìš” ìœ„ì¹˜)',0),(25580,711,'he','×¨×©×™×ž×ª ×œ×§×•×—×•×ª (×”×ž×™×§×•× ×”×ž×¨×›×–×™)',0),(25581,711,'el','Î ÎµÎ»Î±Ï„Î¿Î»ÏŒÎ³Î¹Î¿ (ÎºÏÏÎ¹Î± Î¸Î­ÏƒÎ·)',0),(25582,711,'zh','å®¢æˆ·åå•ï¼ˆä¸»è¦ä½ç½®ï¼‰\r\n',0),(25583,711,'sv','Kundlistan (huvudsakligt lÃ¤ge)',0),(25584,711,'it','Elenco clienti (sede principale)',0),(25585,711,'tl','',0),(25586,711,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634; (&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3627;&#3621;&#3633;&#3585;)',0),(25587,711,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‚à¤šà¥€ (à¤®à¥à¤–à¥à¤¯ à¤¸à¥à¤¥à¤¾à¤¨)',0),(25588,711,'ms','Senarai pelanggan (lokasi utama)',0),(25589,711,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ (Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ)',0),(25590,711,'fr','Liste de clients (site principal)',0),(25591,711,'jp','é¡§å®¢ãƒªã‚¹ãƒˆï¼ˆãƒ¡ã‚¤ãƒ³ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ï¼‰',0),(25592,711,'pt','Lista de clientes (principal localizaÃ§Ã£o)',0),(25593,711,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² (Ð“Ð»Ð°Ð²Ð½Ð¾Ðµ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ)',0),(25594,711,'es','Cliente Lista (UbicaciÃ³n Principal)',0),(25595,711,'de','Kundenliste (Hauptstandort)',0),(25596,711,'en','Customer List (Main Location)',0),(25597,712,'is','',0),(25598,712,'dr',')',0),(25599,712,'pr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø±  Ø­Ù…Ù„ Ø¨Ù‡ Ù…Ø­Ù„ )',0),(25600,712,'tr','MÃ¼ÅŸteri listesi (konuma gemi)',0),(25601,712,'pl','Lista klientÃ³w (statek do lokalizacji)',0),(25602,712,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ (ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ)',0),(25603,712,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ÙÛØ±Ø³Øª (Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Û’ Ù„ÛŒÛ’ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²)',0),(25604,712,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÑƒÐ¿Ð°Ñ†Ð° (Ð±Ñ€Ð¾Ð´ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ)',0),(25605,712,'vi','Danh sÃ¡ch khÃ¡ch hÃ ng (Ä‘á»‹a chá»‰ váº­n chuyá»ƒn hÃ ng)',0),(25606,712,'af','Klant / KliÃ«nt Lyste (Versendingsplek)',0),(25607,712,'ro','Lista de client (navÄƒ locaÅ£ie)',0),(25608,712,'et','Klientide nimekiri (tarneaadress)',0),(25609,712,'si','Seznam kupcev (ladja mesto)',0),(25610,712,'ba','Daftar pelanggan (kapal ke lokasi)',0),(25611,712,'nl','Klantenoverzicht (schip naar locatie)',0),(25612,712,'fi','Asiakasluettelo (laiva paikkaan)',0),(25613,712,'no','Kundeliste (skip til plassering)',0),(25614,712,'da','Kundeliste (skib til placering)',0),(25615,712,'ko','ê³ ê° ëª©ë¡ (ìœ„ì¹˜ í•¨)',0),(25616,712,'he','×¨×©×™×ž×ª ×œ×§×•×—×•×ª (××•× ×™×™×” ×œ×ž×™×§×•×)',0),(25617,712,'el','Î ÎµÎ»Î±Ï„Î¿Î»ÏŒÎ³Î¹Î¿ (Ï€Î»Î¿Î¯Î¿ ÏƒÎµ Î¸Î­ÏƒÎ·)',0),(25618,712,'zh','å®¢æˆ·åå•ï¼ˆæ”¶è´§åœ°ç‚¹ï¼‰\r\n',0),(25619,712,'sv','Kundlistan (fartyg till plats)',0),(25620,712,'it','Elenco clienti (nave a posizione)',0),(25621,712,'tl','',0),(25622,712,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634; (&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;)',0),(25623,712,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‚à¤šà¥€ (à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ)',0),(25624,712,'ms','Senarai pelanggan (kapal ke lokasi)',0),(25625,712,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ (Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ù„Ù…ÙˆÙ‚Ø¹)',0),(25626,712,'fr','Liste de clients (navire d\'emplacement)',0),(25627,712,'jp','é¡§å®¢ãƒªã‚¹ãƒˆï¼ˆé…?é€?å…ˆãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ï¼‰',0),(25628,712,'pt','Lista de clientes (navio de localizaÃ§Ã£o)',0),(25629,712,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² (ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¼ÐµÑÑ‚Ð¾)',0),(25630,712,'es','Cliente Lista (UbicaciÃ³n de Enviar)',0),(25631,712,'de','Kundenliste (Schiff, Lage)',0),(25632,712,'en','Customer List (Ship To Location)',0),(25633,713,'is','',0),(25634,713,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(25635,713,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(25636,713,'tr','MÃ¼ÅŸteri arama',0),(25637,713,'pl','Wyszukiwanie klientÃ³w',0),(25638,713,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(25639,713,'ur','Ú©Ø³Ù¹Ù…Ø± Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(25640,713,'sr','Ð—Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ ÐºÑƒÐ¿Ñ†Ð°',0),(25641,713,'vi','TÃ¬m KhÃ¡ch hÃ ng',0),(25642,713,'af','Klant / KliÃ«nt Opsoek',0),(25643,713,'ro','CÄƒutare de client',0),(25644,713,'et','Kliendi otsing',0),(25645,713,'si','Iskanje kupca',0),(25646,713,'ba','Pelanggan Lookup',0),(25647,713,'nl','Klant opzoeken',0),(25648,713,'fi','Asiakkaan haku',0),(25649,713,'no','Kundeoppslag',0),(25650,713,'da','Kunde opslag',0),(25651,713,'ko','ê³ ê° ì¡°íšŒ',0),(25652,713,'he','×—×™×¤×•×© ×œ×§×•×—',0),(25653,713,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Ï€ÎµÎ»Î¬Ï„Î·',0),(25654,713,'zh','æŸ¥æ‰¾å®¢æˆ·',0),(25655,713,'sv','Kunden sÃ¶kning',0),(25656,713,'it','Ricerca cliente',0),(25657,713,'tl','',0),(25658,713,'th','&#3588;&#3657;&#3609;&#3604;&#3641;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25659,713,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤²à¥à¤•à¤…à¤ª',0),(25660,713,'ms','Cari pelanggan',0),(25661,713,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø²Ø¨ÙˆÙ†',0),(25662,713,'fr','Recherche client',0),(25663,713,'jp','é¡§å®¢å?‚ç…§',0),(25664,713,'pt','Pesquisa do cliente',0),(25665,713,'ru','ÐŸÐ¾Ð¸ÑÐº ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(25666,713,'es','Cliente BÃºsqueda',0),(25667,713,'de','Kundensuche',0),(25668,713,'en','Customer Lookup',0),(25669,714,'is','',0),(25670,714,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25671,714,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25672,714,'tr','MÃ¼ÅŸteri asgari Ã¼cret',0),(25673,714,'pl','Minimalna opÅ‚ata klienta',0),(25674,714,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(25675,714,'ur','Ú¯Ø§ÛÚ© Ú©Ù… Ø³Û’ Ú©Ù… Ú†Ø§Ø±Ø¬',0),(25676,714,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ñ‚Ð°Ñ€Ð¸Ñ„Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(25677,714,'vi','PhÃ­ KhÃ¡ch hÃ ng tá»‘i thiá»ƒu',0),(25678,714,'af','Klant / KliÃ«nt Minimum Heffing',0),(25679,714,'ro','Taxa minimÄƒ de client',0),(25680,714,'et','Kliendi miinimumarve',0),(25681,714,'si','NajmanjÅ¡a obraÄunska kupca',0),(25682,714,'ba','Biaya Minimum nasabah',0),(25683,714,'nl','Klant Minimum tarief',0),(25684,714,'fi','Asiakkaan minimiveloitus',0),(25685,714,'no','Kunden lading',0),(25686,714,'da','Kunde minimumsgebyr',0),(25687,714,'ko','ê³ ê° ìµœì†Œ ìš”ê¸ˆ',0),(25688,714,'he','×ª×©×œ×•× ×ž×™× ×™×ž×•× ×œ×œ×§×•×—',0),(25689,714,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î· Ï‡ÏÎ­Ï‰ÏƒÎ· Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(25690,714,'zh','å®¢æˆ·æœ€ä½Žæ”¶è´¹\r\n',0),(25691,714,'sv','Minimidebitering fÃ¶r kunden',0),(25692,714,'it','Ricarico minimo cliente',0),(25693,714,'tl','',0),(25694,714,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3609;&#3657;&#3629;&#3618;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25695,714,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤ªà¥à¤°à¤­à¤¾à¤°',0),(25696,714,'ms','Caj Minimum pelanggan',0),(25697,714,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† ØªÙ‡Ù…Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(25698,714,'fr','Frais minimums de client',0),(25699,714,'jp','é¡§å®¢æœ€å°?è«‹æ±‚',0),(25700,714,'pt','Carga mÃ­nima do cliente',0),(25701,714,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25702,714,'es','Cliente cargo MÃ­nimo',0),(25703,714,'de','Kunde MindestgebÃ¼hr',0),(25704,714,'en','Customer Minimum Charge',0),(25705,715,'is','',0),(25706,715,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25707,715,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25708,715,'tr','MÃ¼ÅŸteri #',0),(25709,715,'pl','Klient #',0),(25710,715,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ #',0),(25711,715,'ur','Ú©Ø³Ù¹Ù…Ø± #',0),(25712,715,'sr','ÐšÑƒÐ¿Ð°Ñ† #',0),(25713,715,'vi','KhÃ¡ch hÃ ng sá»‘',0),(25714,715,'af','Klant / KliÃ«nt #',0),(25715,715,'ro','Client #',0),(25716,715,'et','Klient #',0),(25717,715,'si','Kupec #',0),(25718,715,'ba','Pelanggan #',0),(25719,715,'nl','Klant #',0),(25720,715,'fi','Asiakas #',0),(25721,715,'no','Kunden #',0),(25722,715,'da','Kunde #',0),(25723,715,'ko','ê³ ê° #',0),(25724,715,'he','×œ×§×•×— #',0),(25725,715,'el','Î ÎµÎ»Î¬Ï„Î· #',0),(25726,715,'zh','å®¢æˆ· #',0),(25727,715,'sv','Kunden #',0),(25728,715,'it','# cliente',0),(25729,715,'tl','',0),(25730,715,'th','&#3621;&#3635;&#3604;&#3633;&#3610;&#3607;&#3637;&#3656;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25731,715,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• #',0),(25732,715,'ms','Baca #',0),(25733,715,'ar','Ø±Ù‚Ù… Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(25734,715,'fr','Client #',0),(25735,715,'jp','é¡§å®¢ç•ªå?·',0),(25736,715,'pt','Cliente #',0),(25737,715,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° #',0),(25738,715,'es','Cliente #',0),(25739,715,'de','Kunden #',0),(25740,715,'en','Customer #',0),(25741,716,'is','',0),(25742,716,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± ÙŠØ§ÙØª Ù†Ø´Ø¯ ',0),(25743,716,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± ÙŠØ§ÙØª Ù†Ø´Ø¯ ',0),(25744,716,'tr','MÃ¼ÅŸteri bulunamadÄ±',0),(25745,716,'pl','Klient nie znaleziono',0),(25746,716,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(25747,716,'ur','Ú¯Ø§ÛÚ© Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(25748,716,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(25749,716,'vi','KhÃ´ng tÃ¬m tháº¥y KhÃ¡ch hÃ ng',0),(25750,716,'af','Klant / KliÃ«nt nie gevind',0),(25751,716,'ro','Clientul nu a fost gÄƒsit',0),(25752,716,'et','Klienti ei leitud',0),(25753,716,'si','Kupca ni mogoÄe najti',0),(25754,716,'ba','Pelanggan tidak ditemukan',0),(25755,716,'nl','Klant niet gevonden',0),(25756,716,'fi','Asiakasta ei lÃ¶ydy',0),(25757,716,'no','Kunde ikke funnet',0),(25758,716,'da','Kunde ikke fundet',0),(25759,716,'ko','ê³ ê°ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(25760,716,'he','×”×œ×§×•×— ×œ× × ×ž×¦×',0),(25761,716,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(25762,716,'zh','å®¢æˆ·æœªæ‰¾åˆ°\r\n',0),(25763,716,'sv','Kunden inte hittas',0),(25764,716,'it','Cliente non trovato',0),(25765,716,'tl','',0),(25766,716,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25767,716,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(25768,716,'ms','Pelanggan yang tidak dijumpai',0),(25769,716,'ar','Ø§Ù„Ø²Ø¨ÙˆÙ† ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(25770,716,'fr','Client introuvable',0),(25771,716,'jp','é¡§å®¢ã?Œã?¿ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(25772,716,'pt','Cliente nÃ£o encontrado',0),(25773,716,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(25774,716,'es','Cliente no se encontrÃ³',0),(25775,716,'de','Kunden, die nicht gefunden',0),(25776,716,'en','Customer not found',0),(25777,717,'is','',0),(25778,717,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ¯ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25779,717,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ¯ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25780,717,'tr','MÃ¼ÅŸteri kodu numarasÄ±',0),(25781,717,'pl','Numer kodu klienta',0),(25782,717,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ð´Ð¾Ð² Ð½Ð¾Ð¼ÐµÑ€',0),(25783,717,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆÚˆ Ù†Ù…Ø¨Ø±',0),(25784,717,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑˆÐ¸Ñ„Ñ€Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(25785,717,'vi','MÃ£ KhÃ¡ch hÃ ng',0),(25786,717,'af','Klant / KliÃ«nt kode nommer',0),(25787,717,'ro','NumÄƒrul de cod client',0),(25788,717,'et','Kliendi kood',0),(25789,717,'si','Å ifra kupca',0),(25790,717,'ba','Nomor kode nasabah',0),(25791,717,'nl','Code klantnummer',0),(25792,717,'fi','Asiakkaan tunnusnumero',0),(25793,717,'no','Kunden kodenummer',0),(25794,717,'da','Kunde kodenummer',0),(25795,717,'ko','ê³ ê° ì½”ë“œ ë²ˆí˜¸',0),(25796,717,'he','×ž×¡×¤×¨ ×§×•×“ ×œ×§×•×—',0),(25797,717,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(25798,717,'zh','å®¢æˆ·ä»£ç å·ç ',0),(25799,717,'sv','Kundnummer',0),(25800,717,'it','Numero codice cliente',0),(25801,717,'tl','',0),(25802,717,'th','&#3619;&#3627;&#3633;&#3626;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25803,717,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹à¤¡ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(25804,717,'ms','Baca kod nombor',0),(25805,717,'ar','Ø§Ù„Ø±Ù‚Ù… Ø§Ù„Ø±Ù…Ø²ÙŠ Ù„Ù„Ø²Ø¨ÙˆÙ†',0),(25806,717,'fr','NumÃ©ro de Code de client',0),(25807,717,'jp','é¡§å®¢ã‚³ãƒ¼ãƒ‰ç•ªå?·',0),(25808,717,'pt','NÃºmero de cÃ³digo do cliente',0),(25809,717,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐšÐ¾Ð´Ð° ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25810,717,'es','NÃºmero de CÃ³digo de Cliente',0),(25811,717,'de','Kunden-Code-Nummer',0),(25812,717,'en','Customer Code Number',0),(25813,718,'is','',0),(25814,718,'dr','Ù‚ÙŠÙ…Øª Ø®Ø±ÙŠØ¯Ø§Ø± Ú†Ú¯ÙˆÙ†Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(25815,718,'pr','Ù‚ÙŠÙ…Øª Ø®Ø±ÙŠØ¯Ø§Ø± Ú†Ú¯ÙˆÙ†Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(25816,718,'tr','MÃ¼ÅŸteri fiyatÄ± nasÄ±l hesaplanÄ±r',0),(25817,718,'pl','Cena obliczana jak',0),(25818,718,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ° Ñ†ÐµÐ½Ð°, Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð° ÐºÐ°Ðº',0),(25819,718,'ur','Ú¯Ø§ÛÚ© Ù‚ÛŒÙ…Øª Ú©Ø³ Ø·Ø±Ø­ Ø­Ø³Ø§Ø¨',0),(25820,718,'sr','Ð¦ÐµÐ½Ð° Ð·Ð° ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð° ÐºÐ¾Ð»Ð¸ÐºÐ¾',0),(25821,718,'vi','TÃ­nh giÃ¡ khÃ¡ch hÃ ng nhÆ° tháº¿ nÃ o',0),(25822,718,'af','Hoe is die Klant / KliÃ«nt Prys Bereken',0),(25823,718,'ro','Clientului preÅ£ul calculat cum',0),(25824,718,'et','Kuidas arvutada kliendi hind',0),(25825,718,'si','KupÄeva cena izraÄuna kako',0),(25826,718,'ba','Pelanggan harga dihitung berapa',0),(25827,718,'nl','Klant prijs berekend hoe',0),(25828,718,'fi','Matkaviestinasiakkaan hinta lasketaan kuinka',0),(25829,718,'no','Kundepris beregnet hvor',0),(25830,718,'da','Kundepris beregnet hvor',0),(25831,718,'ko','ê³ ê° ê°€ê²© ê³„ì‚° ë°©ë²•',0),(25832,718,'he','×ž×—×™×¨ ×œ×œ×§×•×— ×œ×—×©×‘ ×›×ž×”',0),(25833,718,'el','Î¤Î¹Î¼Î®Ï‚ Ï€ÎµÎ»Î¬Ï„Î· Ï€ÏŽÏ‚ Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÏ„Î±Î¹',0),(25834,718,'zh','é¡¾å®¢ä»·è®¡ç®—ï¼Œå¦‚ä½•\r\n',0),(25835,718,'sv','Kundpris berÃ¤knat hur',0),(25836,718,'it','Prezzo per il cliente calcolato come',0),(25837,718,'tl','',0),(25838,718,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3619;&#3634;&#3588;&#3634;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3619;',0),(25839,718,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¥‚à¤²à¥à¤¯ à¤•à¥ˆà¤¸à¥‡ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(25840,718,'ms','Harga pelanggan dikira bagaimana',0),(25841,718,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ØªØ­Ø³Ø¨ ÙƒÙŠÙ',0),(25842,718,'fr','Prix client calculÃ© comment',0),(25843,718,'jp','é¡§å®¢ä¾¡æ ¼ã?®è¨ˆç®—æ³•',0),(25844,718,'pt','Cliente preÃ§o calculado como',0),(25845,718,'ru','Ð ÐµÐºÐ¾Ð¼ÐµÐ½Ð´ÑƒÐµÐ¼Ð°Ñ Ñ†ÐµÐ½Ð° Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ñ‹Ð²Ð°ÐµÑ‚ÑÑ ÐºÐ°Ðº',0),(25846,718,'es','Cliente Como esta Calculado el Precio',0),(25847,718,'de','Kundenpreis berechnet, wie',0),(25848,718,'en','Customer Price Calculated How',0),(25849,719,'is','',0),(25850,719,'dr','Ø®Ø¯Ù…Ø§Øª Ù¾Ø³ Ø§Ø² ÙØ±ÙˆØ´',0),(25851,719,'pr','Ø®Ø¯Ù…Ø§Øª Ù¾Ø³ Ø§Ø² ÙØ±ÙˆØ´',0),(25852,719,'tr','MÃ¼ÅŸteri Hizmetleri',0),(25853,719,'pl','Biuro obsÅ‚ugi klienta',0),(25854,719,'bg','ÐžÐ±ÑÐ»ÑƒÐ¶Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(25855,719,'ur','Ú©Ø³Ù¹Ù…Ø± Ø³Ø±ÙˆØ³',0),(25856,719,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸ ÑÐµÑ€Ð²Ð¸Ñ',0),(25857,719,'vi','Dá»‹ch vá»¥ KhÃ¡ch hÃ ng',0),(25858,719,'af','KliÃªnt-/Klantediens',0),(25859,719,'ro','Serviciul clienÅ£i',0),(25860,719,'et','Klienditeenindus',0),(25861,719,'si','Storitve za stranke',0),(25862,719,'ba','Layanan pelanggan',0),(25863,719,'nl','Klantenservice',0),(25864,719,'fi','Asiakaspalvelu',0),(25865,719,'no','Kundeservice',0),(25866,719,'da','Kundeservice',0),(25867,719,'ko','ê³ ê° ì„œë¹„ìŠ¤',0),(25868,719,'he','×©×¨×•×ª ×œ×§×•×—×•×ª',0),(25869,719,'el','Î•Î¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ· Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(25870,719,'zh','å®¢æˆ·æœåŠ¡\r\n',0),(25871,719,'sv','Kundservice',0),(25872,719,'it','Servizio clienti',0),(25873,719,'tl','',0),(25874,719,'th','&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25875,719,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡à¤µà¤¾',0),(25876,719,'ms','Perkhidmatan pelanggan',0),(25877,719,'ar','Ø®Ø¯Ù…Ø§Øª Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(25878,719,'fr','Service Ã  la clientÃ¨le',0),(25879,719,'jp','é¡§å®¢ã‚µãƒ¼ãƒ“ã‚¹',0),(25880,719,'pt','Atendimento ao cliente',0),(25881,719,'ru','ÐžÐ±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(25882,719,'es','AtenciÃ³n a Cliente',0),(25883,719,'de','Kundendienst',0),(25884,719,'en','Customer Service',0),(25885,720,'is','',0),(25886,720,'dr','ØªÙ„ÙÙ† Ø®Ø¯Ù…Ø§Øª Ù¾Ø³ Ø§Ø² ÙØ±ÙˆØ´',0),(25887,720,'pr','ØªÙ„ÙÙ† Ø®Ø¯Ù…Ø§Øª Ù¾Ø³ Ø§Ø² ÙØ±ÙˆØ´',0),(25888,720,'tr','MÃ¼ÅŸteri servis telefonu',0),(25889,720,'pl','Telefon obsÅ‚ugi klienta',0),(25890,720,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÑÐ»ÑƒÐ¶Ð±Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(25891,720,'ur','Ú©Ø³Ù¹Ù…Ø± Ø³Ø±ÙˆØ³ ÙÙˆÙ†',0),(25892,720,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ÑÐºÐ¸ ÑÐµÑ€Ð²Ð¸Ñ ÐºÑƒÐ¿Ñ†Ð°',0),(25893,720,'vi','Phone Dá»‹ch vá»¥ KhÃ¡ch hÃ ng',0),(25894,720,'af','KliÃªnte-/Klantediens Foonnr.',0),(25895,720,'ro','Telefon de serviciu clientului',0),(25896,720,'et','Klienditeeninduse telefon',0),(25897,720,'si','Kupca storitev telefon',0),(25898,720,'ba','Pelanggan layanan telepon',0),(25899,720,'nl','Klant Service telefoon',0),(25900,720,'fi','Asiakaspalvelun Puhelin',0),(25901,720,'no','Kunden Service telefon',0),(25902,720,'da','Kunde Service telefon',0),(25903,720,'ko','ê³ ê° ì„œë¹„ìŠ¤ ì „í™” ë²ˆí˜¸',0),(25904,720,'he','×˜×œ×¤×•×Ÿ ×©×™×¨×•×ª ×œ×§×•×—×•×ª',0),(25905,720,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ ÎµÎ¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ·Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(25906,720,'zh','å®¢æˆ·æœåŠ¡ç”µè¯\r\n',0),(25907,720,'sv','Kund Service telefon',0),(25908,720,'it','Telefono di servizio di cliente',0),(25909,720,'tl','',0),(25910,720,'th','&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25911,720,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡à¤µà¤¾ à¤«à¥‹à¤¨',0),(25912,720,'ms','Pelanggan perkhidmatan telefon',0),(25913,720,'ar','Ù‡Ø§ØªÙ Ø®Ø¯Ù…Ø§Øª Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(25914,720,'fr','TÃ©lÃ©phone du Service clientÃ¨le',0),(25915,720,'jp','é¡§å®¢ã‚µãƒ¼ãƒ“ã‚¹é›»è©±',0),(25916,720,'pt','Telefone de serviÃ§o ao cliente',0),(25917,720,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð° ÐžÐ±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(25918,720,'es','TelÃ©fono de AtenciÃ³n a Cliente',0),(25919,720,'de','Kunden-Service-Telefon',0),(25920,720,'en','Customer Service Phone',0),(25921,721,'is','',0),(25922,721,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25923,721,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(25924,721,'tr','MÃ¼ÅŸteri Kur farkÄ±',0),(25925,721,'pl','Ustawienia klienta bezpÅ‚atnie',0),(25926,721,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ñ‚Ð°ÐºÑÐ°',0),(25927,721,'ur','Ú©Ø³Ù¹Ù…Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ú†Ø§Ø±Ø¬',0),(25928,721,'sr','ÐŸÑƒÑšÐµÑšÐµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(25929,721,'vi','PhÃ­ setup KhÃ¡ch hÃ ng',0),(25930,721,'af','KliÃªnt/Klant Opstellingsheffing',0),(25931,721,'ro','Taxa de configurare client',0),(25932,721,'et','Kliendi Setup tasu',0),(25933,721,'si','Kupec Setup pristojbine',0),(25934,721,'ba','Biaya Setup pelanggan',0),(25935,721,'nl','Klant Setup kosten',0),(25936,721,'fi','Asiakkaan asetukset maksu',0),(25937,721,'no','Kunden Setup kostnad',0),(25938,721,'da','Kunde Setup gebyr',0),(25939,721,'ko','ê³ ê° ì„¤ì¹˜ ìš”ê¸ˆ',0),(25940,721,'he','×ª×©×œ×•× ×”×’×“×¨×ª ×”×œ×§×•×—',0),(25941,721,'el','Î ÎµÎ»Î¬Ï„Î· Ï‡ÏÎ­Ï‰ÏƒÎ· ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(25942,721,'zh','å®¢æˆ·å®‰è£…è´¹\r\n',0),(25943,721,'sv','Kunden Setup avgift',0),(25944,721,'it','Cliente installazione carica',0),(25945,721,'tl','',0),(25946,721,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3592;&#3634;&#3585;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(25947,721,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¶à¥à¤²à¥à¤•',0),(25948,721,'ms','Baca persediaan caj',0),(25949,721,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(25950,721,'fr','Charge d\'installation client',0),(25951,721,'jp','é¡§å®¢è¨­å®šæ–™',0),(25952,721,'pt','Comando de instalaÃ§Ã£o de cliente',0),(25953,721,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° ÑÐ¾ÐµÐ´Ð¸Ð½ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25954,721,'es','Cliente Costo de ConfiguraciÃ³n',0),(25955,721,'de','Kunden-Setup-GebÃ¼hr',0),(25956,721,'en','Customer Setup Charge',0),(25957,722,'is','',0),(25958,722,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(25959,722,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(25960,722,'tr','MÃ¼ÅŸteri gemiye',0),(25961,722,'pl','Statek klienta',0),(25962,722,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(25963,722,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ú©Ø´ØªÛŒ Ù¾Ø±',0),(25964,722,'sr','Ð‘Ñ€Ð¾Ð´ ÐºÑƒÐ¿Ñ†Ð° Ð´Ð°',0),(25965,722,'vi','Äá»‹a chá»‰ váº­n chuyá»ƒn hÃ ng cá»§a khÃ¡ch hÃ ng',0),(25966,722,'af','KliÃªnt/Klant Versend Na',0),(25967,722,'ro','NavÄƒ de client pentru',0),(25968,722,'et','Kliendi tarneaadress',0),(25969,722,'si','Kupec ladje',0),(25970,722,'ba','Kapal pelanggan untuk',0),(25971,722,'nl','Klant schip',0),(25972,722,'fi','Asiakkaan aluksen',0),(25973,722,'no','Kunden skip',0),(25974,722,'da','Kunde skib til',0),(25975,722,'ko','ê³ ê° ë°°ì†¡',0),(25976,722,'he','×œ×§×•×—×•×ª ×œ×¡×¤×™× ×”',0),(25977,722,'el','Î•Î¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ· Ï€Î»Î¿Î¯Ï‰Î½ Î½Î±',0),(25978,722,'zh','å®¢æˆ·æ”¶è´§\r\n',0),(25979,722,'sv','Kunden fartyget till',0),(25980,722,'it','Indirizzo spedizione cliente',0),(25981,722,'tl','',0),(25982,722,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656;',0),(25983,722,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(25984,722,'ms','Baca kapal',0),(25985,722,'ar','Ø³ÙÙŠÙ†Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¥Ù„Ù‰',0),(25986,722,'fr','Navire de client Ã ',0),(25987,722,'jp','é¡§å®¢é…?é€?å…ˆ',0),(25988,722,'pt','Navio de cliente para',0),(25989,722,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(25990,722,'es','Cliente Enviar A',0),(25991,722,'de','Kunde Schiff',0),(25992,722,'en','Customer Ship To',0),(25993,723,'is','',0),(25994,723,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(25995,723,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(25996,723,'tr','A iÃ§in baÅŸarÄ±yla mÃ¼ÅŸteri gemi',0),(25997,723,'pl','Statek klient pomyÅ›lnie dodane',0),(25998,723,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(25999,723,'ur','Ø§Ø¶Ø§ÙÛ Ú©Û’ Ù„ÛŒÛ’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ú¯Ø§ÛÚ© Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²',0),(26000,723,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð±Ñ€Ð¾Ð´Ð° Ð´Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(26001,723,'vi','ThÃªm Ä‘á»‹a chá»‰ váº­n chuyá»ƒn hÃ ng thÃ nh cÃ´ng',0),(26002,723,'af','Klant / KliÃ«nt versend aan suksesvol bygevoeg',0),(26003,723,'ro','NavÄƒ de client pentru a adÄƒugat cu succes',0),(26004,723,'et','Kliendi tarneaadress lisati edukalt',0),(26005,723,'si','Kupec ladje za uspeÅ¡no dodani',0),(26006,723,'ba','Kapal pelanggan ditambahkan berhasil',0),(26007,723,'nl','Klant schip met succes toegevoegd',0),(26008,723,'fi','Asiakkaan aluksen lisÃ¤Ã¤minen onnistui',0),(26009,723,'no','Kunden skipet ble lagt til',0),(26010,723,'da','Kunde skib til tilfÃ¸jet',0),(26011,723,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ê³ ê° ë°°',0),(26012,723,'he','×œ×ž×©×œ×•×— ×œ×œ×§×•×— × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(26013,723,'el','Î•Î¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ· Ï€Î»Î¿Î¯Ï‰Î½ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(26014,723,'zh','é¡¾å®¢æ”¶è´§åœ°æˆåŠŸæ·»åŠ \r\n',0),(26015,723,'sv','Kunden fartyget att lagts',0),(26016,723,'it','Indirizzo spedizione cliente aggiunto correttamente',0),(26017,723,'tl','',0),(26018,723,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3651;&#3627;&#3657;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634; &#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(26019,723,'hi','à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¹à¤¾à¤œ',0),(26020,723,'ms','Kapal pelanggan berjaya menambah',0),(26021,723,'ar','Ø£Ø¶Ø¨ÙØª Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø­Ù† Ø¥Ù„Ù‰ Ø§Ù„Ø²Ø¨ÙˆÙ† Ø¨Ù†Ø¬Ø§Ø­',0),(26022,723,'fr','Navire client ajoutÃ© avec succÃ¨s',0),(26023,723,'jp','é¡§å®¢é…?é€?å…ˆã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(26024,723,'pt','Navio de cliente adicionado com sucesso',0),(26025,723,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(26026,723,'es','Cliente Enviar a agregado exitosamente',0),(26027,723,'de','Kunde Schiff erfolgreich hinzugefÃ¼gt',0),(26028,723,'en','Customer ship to added successfully',0),(26029,724,'is','',0),(26030,724,'dr','Ø­Ø°Ù  Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(26031,724,'pr','Ø­Ø°Ù  Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(26032,724,'tr','MÃ¼ÅŸteri gemiye baÅŸarÄ±yla silindi',0),(26033,724,'pl','Statek klienta przesâ”‚anie',0),(26034,724,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ñ€Ð°Ð± Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(26035,724,'ur','Ú©Ø³Ù¹Ù…Ø± Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø®Ø§Ø±Ø¬',0),(26036,724,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð±Ñ€Ð¾Ð´Ð° Ð´Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(26037,724,'vi','XÃ³a Ä‘á»‹a chá»‰ váº­n chuyá»ƒn hÃ ng thÃ nh cÃ´ng',0),(26038,724,'af','Klant / KliÃ«nt versend aan suksesvol geskrap',0),(26039,724,'ro','Client nava a ÅŸters cu succes',0),(26040,724,'et','Kliendi tarneaadress kustutati edukalt',0),(26041,724,'si','Kupec ladje za uspeÅ¡no izbrisana',0),(26042,724,'ba','Kapal pelanggan untuk berhasil dihapus',0),(26043,724,'nl','Klant schip met succes verwijderd',0),(26044,724,'fi','Asiakkaan aluksen poistettu',0),(26045,724,'no','Kunden skipet til slettet',0),(26046,724,'da','Kunde skib til slettet',0),(26047,724,'ko','ê³ ê° ë°°ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(26048,724,'he','×”×¡×¤×™× ×” ×”×œ×§×•×— × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(26049,724,'el','Î•Î¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ· Ï€Î»Î¿Î¯Ï‰Î½ Î½Î± Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(26050,724,'zh','é¡¾å®¢æ”¶è´§åœ°æˆåŠŸåˆ é™¤\r\n',0),(26051,724,'sv','Kunden fartyget att raderades',0),(26052,724,'it','Indirizzo spedizione cliente eliminato correttamente',0),(26053,724,'tl','',0),(26054,724,'th','&#3621;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656; &#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(26055,724,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(26056,724,'ms','Kapal Baca dihapuskan dengan jayanya',0),(26057,724,'ar','Ø­Ø°ÙØª Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø­Ù† Ø¥Ù„Ù‰ Ø§Ù„Ø²Ø¨ÙˆÙ† Ø¨Ù†Ø¬Ø§Ø­',0),(26058,724,'fr','Navire de client Ã  supprimÃ© avec succÃ¨s',0),(26059,724,'jp','é¡§å®¢é…?é€?å…ˆã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(26060,724,'pt','Navio de cliente para apagado com sucesso',0),(26061,724,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(26062,724,'es','Cliente Enviar a eliminado exitosamente',0),(26063,724,'de','Kunde Schiff wurde erfolgreich gelÃ¶scht.',0),(26064,724,'en','Customer Ship To Deleted Successfully',0),(26065,725,'is','',0),(26066,725,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ÙŠØ§ÙØª Ù†Ø´Ø¯ ',0),(26067,725,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ÙŠØ§ÙØª Ù†Ø´Ø¯ ',0),(26068,725,'tr','MÃ¼ÅŸteri gemi bulunamadÄ±',0),(26069,725,'pl','Statek klienta nie znaleÅºÄ‡',0),(26070,725,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(26071,725,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ø¬ÛØ§Ø² Ú©Ùˆ Ù†ÛÛŒÚº Ù…Ù„ÛŒ',0),(26072,725,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð±Ñ€Ð¾Ð´Ð° Ð´Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°',0),(26073,725,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘á»‹a chá»‰ váº­n chuyá»ƒn hÃ ng',0),(26074,725,'af','KliÃªnt/Klant Versend Na nie gevind',0),(26075,725,'ro','Client nava sÄƒ nu a fost gÄƒsit',0),(26076,725,'et','Klendi tarneaadressi ei leitud',0),(26077,725,'si','Kupec ladje ni bilo mogoÄe najti',0),(26078,725,'ba','Kapal pelanggan untuk tidak ditemukan',0),(26079,725,'nl','Klant schip niet gevonden',0),(26080,725,'fi','Asiakas alus ei lÃ¶ydy',0),(26081,725,'no','Kunden skipet ikke funnet',0),(26082,725,'da','Kunde skib at ikke fundet',0),(26083,725,'ko','ê³ ê° ìš°ì£¼ì„ ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(26084,725,'he','×”×¡×¤×™× ×” ×”×œ×§×•×— ×›×“×™ ×œ× × ×ž×¦×',0),(26085,725,'el','Î•Î¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ· Ï€Î»Î¿Î¯Ï‰Î½ Î½Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(26086,725,'zh','é¡¾å®¢æ”¶è´§åœ°æœªæ‰¾åˆ°\r\n',0),(26087,725,'sv','Kunden fartyget kan inte hittas',0),(26088,725,'it','Indirizzo spedizione cliente non trovato',0),(26089,725,'tl','',0),(26090,725,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656;',0),(26091,725,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¹à¤¾à¤œ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(26092,725,'ms','Kapal pelanggan tidak dijumpai',0),(26093,725,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø­Ù† Ø¥Ù„Ù‰ Ø§Ù„Ø²Ø¨ÙˆÙ† ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(26094,725,'fr','Navire de client Ã  introuvable',0),(26095,725,'jp','é¡§å®¢é…?é€?å…ˆã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(26096,725,'pt','Navio de cliente nÃ£o encontrado',0),(26097,725,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(26098,725,'es','Cliente Enviar a no se encontrÃ³',0),(26099,725,'de','Kunden-Schiff, das nicht gefunden',0),(26100,725,'en','Customer ship to not found',0),(26101,726,'is','',0),(26102,726,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±  Ø¨Ø±Ø§ÙŠ ',0),(26103,726,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±  Ø¨Ø±Ø§ÙŠ ',0),(26104,726,'tr','GÃ¶nderilecek mÃ¼ÅŸteri GÃ¼ncelleÅŸtirmesi',0),(26105,726,'pl','Aktualizacja odbiorcy dostawy dla',0),(26106,726,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð·Ð°',0),(26107,726,'ur','Ú©Ø³Ù¹Ù…Ø± Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’',0),(26108,726,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð° Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐ° Ð·Ð°',0),(26109,726,'vi','Cáº­p Nháº­t Äá»‹a Chá»‰ Váº­n Chuyá»ƒn cá»§a KhÃ¡ch HÃ ng cho',0),(26110,726,'af','KliÃªnt/Klant Versend Na Opdatering vir',0),(26111,726,'ro','Client livrare-la Update pentru',0),(26112,726,'et','Kliendi tarneaadressi uuendamine:',0),(26113,726,'si','Kupec za dobavo posodobitev za',0),(26114,726,'ba','Pelanggan kapal ke Update untuk',0),(26115,726,'nl','Klant schip-to Update voor',0),(26116,726,'fi','Asiakkaan Toimitusasiakkaan pÃ¤ivitys',0),(26117,726,'no','Kunden lever til-oppdateringen for',0),(26118,726,'da','Kunde leveringsadresse opdatering til',0),(26119,726,'ko','ê³ ê° ë°°ì†¡ì— ëŒ€ í•œ ì—…ë°ì´íŠ¸',0),(26120,726,'he','×œ×§×•×—×•×ª ×œ×ž×©×œ×•×— ×¢×“×›×•×Ÿ ×¢×‘×•×¨',0),(26121,726,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³Î¹Î±',0),(26122,726,'zh','å®¢æˆ·æ”¶è´§åœ°æ›´æ–°\r\n',0),(26123,726,'sv','Kunden leveransadress uppdatering fÃ¶r',0),(26124,726,'it','Cliente spedire a aggiornamento per',0),(26125,726,'tl','',0),(26126,726,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(26127,726,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(26128,726,'ms','Baca kapal untuk Kemaskini bagi',0),(26129,726,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ ØªØ­Ø¯ÙŠØ«',0),(26130,726,'fr','Client destinataire mise Ã  jour pour',0),(26131,726,'jp','é¡§å®¢é…?é€?å…ˆæ›´æ–°',0),(26132,726,'pt','Cliente envio-a atualizaÃ§Ã£o para',0),(26133,726,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´Ð»Ñ',0),(26134,726,'es','Cliente Enviar a Actualizar para',0),(26135,726,'de','Kunde Lieferadresse Update fÃ¼r',0),(26136,726,'en','Customer Ship-to Update for',0),(26137,727,'is','',0),(26138,727,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(26139,727,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(26140,727,'tr','GÃ¼ncelleme iÃ§in baÅŸarÄ±yla mÃ¼ÅŸteri gemi',0),(26141,727,'pl','Statek klient pomyÅ›lnie zaktualizowana',0),(26142,727,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(26143,727,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²',0),(26144,727,'sr','Ð‘Ñ€Ð¾Ð´ ÐºÑƒÐ¿Ñ†Ð° Ð´Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(26145,727,'vi','Cáº­p Nháº­t Äá»‹a Chá»‰ Váº­n Chuyá»ƒn cá»§a KhÃ¡ch HÃ ng ThÃ nh CÃ´ng',0),(26146,727,'af','KliÃªnt/Klant Versend Na Opdatering Suksesvol',0),(26147,727,'ro','Client nava a actualizat cu succes',0),(26148,727,'et','Kliendi tarneaadress uuendati edukalt',0),(26149,727,'si','Kupec ladje za uspeÅ¡no posodobljena',0),(26150,727,'ba','Kapal pelanggan untuk berhasil',0),(26151,727,'nl','Klant schip met succes bijgewerkt',0),(26152,727,'fi','Asiakkaan aluksen pÃ¤ivitetty',0),(26153,727,'no','Kunden skipet til oppdatert',0),(26154,727,'da','Kunde skib til opdateret',0),(26155,727,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ë¥¼ ê³ ê° ë°°',0),(26156,727,'he','×”×¡×¤×™× ×” ×”×œ×§×•×— ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(26157,727,'el','Î•Î¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ· Ï€Î»Î¿Î¯Ï‰Î½ Î½Î± ÎµÎ½Î·Î¼ÎµÏÏ‰Î¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(26158,727,'zh','é¡¾å®¢æ”¶è´§åœ°æ›´æ–°æˆåŠŸ\r\n',0),(26159,727,'sv','Kunden fartyget att uppdaterats',0),(26160,727,'it','Indirizzo spedizione cliente aggiornato correttamente',0),(26161,727,'tl','',0),(26162,727,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(26163,727,'hi','à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¹à¤¾à¤œ',0),(26164,727,'ms','Kapal pelanggan berjaya dikemas kini',0),(26165,727,'ar','Ø­Ø¯Ù‘Ø«Øª Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø­Ù† Ø¥Ù„Ù‰ Ø§Ù„Ø²Ø¨ÙˆÙ† Ø¨Ù†Ø¬Ø§Ø­',0),(26166,727,'fr','Navire client mis Ã  jour avec succÃ¨s',0),(26167,727,'jp','é¡§å®¢é…?é€?å…ˆã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(26168,727,'pt','Navio de cliente atualizado com sucesso',0),(26169,727,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(26170,727,'es','Cliente Enviar a actualizado exitosamente',0),(26171,727,'de','Kunde Schiff erfolgreich aktualisiert',0),(26172,727,'en','Customer ship to updated successfully',0),(26173,728,'is','',0),(26174,728,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(26175,728,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(26176,728,'tr','MÃ¼ÅŸteri toplam',0),(26177,728,'pl','Sumie klienta',0),(26178,728,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¾Ð±Ñ‰Ð¾',0),(26179,728,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ú©Ù„',0),(26180,728,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(26181,728,'vi','Tá»•ng cá»™ng KhÃ¡ch hÃ ng',0),(26182,728,'af','KliÃªnt/Klant Totaal',0),(26183,728,'ro','Client Total',0),(26184,728,'et','Klient kokku',0),(26185,728,'si','Skupaj strank',0),(26186,728,'ba','Total pelanggan',0),(26187,728,'nl','Klant totaal',0),(26188,728,'fi','Asiakas yhteensÃ¤',0),(26189,728,'no','Kunden totalt',0),(26190,728,'da','Kunde alt',0),(26191,728,'ko','ê³ ê° ì´',0),(26192,728,'he','×¡×” ×› ×œ×§×•×—',0),(26193,728,'el','Î£ÏÎ½Î¿Î»Î¿ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(26194,728,'zh','å®¢æˆ·å…±\r\n',0),(26195,728,'sv','Kunden totalt',0),(26196,728,'it','Totale del cliente',0),(26197,728,'tl','',0),(26198,728,'th','&#3619;&#3623;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(26199,728,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥à¤²',0),(26200,728,'ms','Jumlah pelanggan',0),(26201,728,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(26202,728,'fr','Total de la clientÃ¨le',0),(26203,728,'jp','é¡§å®¢ç·?æ•°',0),(26204,728,'pt','Cliente Total',0),(26205,728,'ru','Ð’ÑÐµÐ³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(26206,728,'es','Cliente Total',0),(26207,728,'de','Kunden gesamt',0),(26208,728,'en','Customer Total',0),(26209,729,'is','',0),(26210,729,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø±Ù‡Ú¯ÙŠØ±ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(26211,729,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø±Ù‡Ú¯ÙŠØ±ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(26212,729,'tr','MÃ¼ÅŸteri Takibi #',0),(26213,729,'pl','Klient Å›ledzenia #',0),(26214,729,'bg','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ # Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(26215,729,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ù†Ù…Ø¨Ø± Ú©Ø³Ù¹Ù…Ø±',0),(26216,729,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð¿Ñ€Ð°Ñ›ÐµÑšÐ° #',0),(26217,729,'vi','Sá»‘ dÃ² tÃ¬m KhÃ¡ch hÃ ng',0),(26218,729,'af','KliÃªnt/Klant Sporing #',0),(26219,729,'ro','Client # de urmÄƒrire',0),(26220,729,'et','Kliendi jÃ¤lgimine #',0),(26221,729,'si','Sledenje # stranko',0),(26222,729,'ba','Pelacakan # pelanggan',0),(26223,729,'nl','Klant trackingnummer',0),(26224,729,'fi','Asiakkaiden seuranta #',0),(26225,729,'no','Kunden sporing #',0),(26226,729,'da','Kunderegistrering #',0),(26227,729,'ko','ê³ ê° ì¶”ì  #',0),(26228,729,'he','×œ×§×•×—×•×ª ×ž×¢×§×‘ #',0),(26229,729,'el','Î Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ· # Ï„Ï‰Î½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(26230,729,'zh','å®¢æˆ·è·Ÿè¸ªï¼ƒ\r\n',0),(26231,729,'sv','Kunden spÃ¥ra #',0),(26232,729,'it','Cliente Tracking #',0),(26233,729,'tl','',0),(26234,729,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(26235,729,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— # à¤—à¥à¤°à¤¾à¤¹à¤•',0),(26236,729,'ms','Pelanggan yang menjejaki #',0),(26237,729,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ØªØªØ¨Ø¹ #',0),(26238,729,'fr','Client suivi de #',0),(26239,729,'jp','é¡§å®¢ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°ç•ªå?·',0),(26240,729,'pt','Cliente rastreamento #',0),(26241,729,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ #',0),(26242,729,'es','Cliente Rastreo #',0),(26243,729,'de','Kunden Tracking #',0),(26244,729,'en','Customer Tracking #',0),(26245,730,'is','',0),(26246,730,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(26247,730,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(26248,730,'tr','MÃ¼ÅŸteri Update',0),(26249,730,'pl','Aktualizacja klienta',0),(26250,730,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¾Ð±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(26251,730,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(26252,730,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÑƒÐ¿Ñ†Ð°',0),(26253,730,'vi','Cáº­p Nháº­t KhÃ¡ch HÃ ng',0),(26254,730,'af','Klant / KliÃ«nt Opdateer',0),(26255,730,'ro','Clientul actualizare',0),(26256,730,'et','Kliendi uuendamine',0),(26257,730,'si','Posodobitev kupca',0),(26258,730,'ba','Pelanggan Update',0),(26259,730,'nl','Klant Update',0),(26260,730,'fi','Asiakkaan pÃ¤ivitys',0),(26261,730,'no','Kunden oppdatering',0),(26262,730,'da','Kunde opdatering',0),(26263,730,'ko','ê³ ê° ì—…ë°ì´íŠ¸',0),(26264,730,'he','×¢×“×›×•×Ÿ ×”×œ×§×•×—',0),(26265,730,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÎµÎ»Î¬Ï„Î·',0),(26266,730,'zh','å®¢æˆ·æ›´æ–°\r\n',0),(26267,730,'sv','Kunden uppdatering',0),(26268,730,'it','Aggiornamento del cliente',0),(26269,730,'tl','',0),(26270,730,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(26271,730,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(26272,730,'ms','Baca Update',0),(26273,730,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(26274,730,'fr','Mise Ã  jour du client',0),(26275,730,'jp','é¡§å®¢æ›´æ–°',0),(26276,730,'pt','AtualizaÃ§Ã£o de cliente',0),(26277,730,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(26278,730,'es','Cliente Actualizar',0),(26279,730,'de','Kunden-Update',0),(26280,730,'en','Customer Update',0),(26281,731,'is','',0),(26282,731,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(26283,731,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(26284,731,'tr','MÃ¼ÅŸteri baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(26285,731,'pl','Klient pomyÅ›lnie zaktualizowana',0),(26286,731,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(26287,731,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(26288,731,'sr','ÐšÑƒÐ¿Ð°Ñ† Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(26289,731,'vi','Cáº­p Nháº­t KhÃ¡ch HÃ ng ThÃ nh CÃ´ng',0),(26290,731,'af','Klant / KliÃ«nt suksesvol opdateer',0),(26291,731,'ro','Client actualizat cu succes',0),(26292,731,'et','Klient uuendati edukalt',0),(26293,731,'si','Stranke, ki so uspeÅ¡no posodobljena',0),(26294,731,'ba','Pelanggan yang berhasil',0),(26295,731,'nl','Klant met succes bijgewerkt',0),(26296,731,'fi','Asiakkaan pÃ¤ivitetty',0),(26297,731,'no','Kunden oppdatert',0),(26298,731,'da','Kunde opdateret',0),(26299,731,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ê³ ê°',0),(26300,731,'he','×”×œ×§×•×— ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(26301,731,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(26302,731,'zh','å®¢æˆ·æˆåŠŸæ›´æ–°\r\n',0),(26303,731,'sv','Kunden uppdaterats',0),(26304,731,'it','Cliente aggiornato con successo',0),(26305,731,'tl','',0),(26306,731,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(26307,731,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(26308,731,'ms','Pelanggan yang berjaya dikemas kini',0),(26309,731,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ø²Ø¨ÙˆÙ† Ø¨Ù†Ø¬Ø§Ø­',0),(26310,731,'fr','Client mis Ã  jour avec succÃ¨s',0),(26311,731,'jp','é¡§å®¢ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(26312,731,'pt','Cliente atualizado com sucesso',0),(26313,731,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(26314,731,'es','Cliente actualizado exitosamente',0),(26315,731,'de','Kunden, die erfolgreich aktualisiert',0),(26316,731,'en','Customer updated successfully',0),(26317,732,'is','',0),(26318,732,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(26319,732,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(26320,732,'tr','MÃ¼ÅŸteri',0),(26321,732,'pl','Klienta',0),(26322,732,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚',0),(26323,732,'ur','Ú¯Ø§ÛÚ©',0),(26324,732,'sr','ÐšÑƒÐ¿Ð°Ñ†',0),(26325,732,'vi','KhÃ¡ch hÃ ng',0),(26326,732,'af','Klant/KliÃ«nt',0),(26327,732,'ro','Client',0),(26328,732,'et','Klient',0),(26329,732,'si','Kupca',0),(26330,732,'ba','Pelanggan',0),(26331,732,'nl','Klant',0),(26332,732,'fi','Asiakkaan',0),(26333,732,'no','Kunden',0),(26334,732,'da','Kunde',0),(26335,732,'ko','ê³ ê°',0),(26336,732,'he','×œ×§×•×—',0),(26337,732,'el','Î ÎµÎ»Î¬Ï„Î·',0),(26338,732,'zh','å®¢æˆ·\r\n',0),(26339,732,'sv','Kunden',0),(26340,732,'it','Cliente',0),(26341,732,'tl','',0),(26342,732,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(26343,732,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•',0),(26344,732,'ms','Pelanggan',0),(26345,732,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(26346,732,'fr','Client',0),(26347,732,'jp','é¡§å®¢',0),(26348,732,'pt','Cliente',0),(26349,732,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚',0),(26350,732,'es','Cliente',0),(26351,732,'de','Kunde',0),(26352,732,'en','Customer',0),(26353,733,'is','',0),(26354,733,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ÙŠØ§ Ø´Ù†Ø§Ø³Ù‡ ÙØ§ÙƒØªÙˆØ± Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(26355,733,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ÙŠØ§ Ø´Ù†Ø§Ø³Ù‡ ÙØ§ÙƒØªÙˆØ± Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(26356,733,'tr','MÃ¼ÅŸteri kimliÄŸi veya invoiceid geÃ§medi.',0),(26357,733,'pl','Identyfikator klienta lub nie odnaleziono.',0),(26358,733,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ invoiceid Ð½Ðµ Ðµ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ».',0),(26359,733,'ur','Ú©Ø³Ù¹ÙˆÙ…Ø§Ø±Ø§Ø¯ ÛŒØ§ Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ù†ÛÛŒÚº Ú¯Ø²Ø± Ú†Ú©Ø§ ÛÛ’ Û”',0),(26360,733,'sr','Ð˜Ð”ÐšÑƒÐ¿Ñ†Ð° Ð¸Ð»Ð¸ Ð¸Ð½Ð²Ð¾Ð¸Ñ†ÐµÐ¸Ð´ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾ÑˆÐ°Ð¾.',0),(26361,733,'vi','ID KhÃ¡ch hÃ ng hay hÃ³a Ä‘Æ¡n chÆ°a qua',0),(26362,733,'af','Klant/KliÃ«nt ID of Faktuur ID is nie goedgekeur.',0),(26363,733,'ro','IDClient sau invoiceid nu a trecut.',0),(26364,733,'et','Kliendi-ID vÃµi invoiceid pole sooritanud.',0),(26365,733,'si','Â»CustomerID Â«ali invoiceid, ni bil podeljen.',0),(26366,733,'ba','Customerid atau invoiceid tidak berlalu.',0),(26367,733,'nl','Klantnummer of invoiceid wordt niet doorgegeven.',0),(26368,733,'fi','Asiakastunnus tai invoiceid ole hyvÃ¤ksytty.',0),(26369,733,'no','Kunde eller invoiceid ikke bestÃ¥tt.',0),(26370,733,'da','Kunde-id eller invoiceid ikke bestÃ¥et.',0),(26371,733,'ko','Customerid ë˜ëŠ” invoiceid ì „ë‹¬ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(26372,733,'he','Customerid ××• invoiceid ×œ× ×—×œ×¤×•.',0),(26373,733,'el','\"ÎšÏ‰Î´Î ÎµÎ»Î¬Ï„Î·\" Î® invoiceid Ï€Î¿Ï… Î´ÎµÎ½ Ï€Î­ÏÎ±ÏƒÎµ.',0),(26374,733,'zh','å®¢æˆ·ç¼–å·æˆ–å‘ç¥¨ç¼–å·ä¸é€šè¿‡\r\n',0),(26375,733,'sv','Kundnr eller invoiceid inte gÃ¥tt.',0),(26376,733,'it','CustomerID o invoiceid non passato.',0),(26377,733,'tl','',0),(26378,733,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3627;&#3619;&#3639;&#3629;&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3',0),(26379,733,'hi','Customerid à¤¯à¤¾ invoiceid à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤°à¤¿à¤¤ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(26380,733,'ms','Customerid atau invoiceid yang tidak diluluskan.',0),(26381,733,'ar','Ù„Ø§ ØªÙ…Ø±ÙŠØ± Ù…Ø¹Ø±Ù Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ Ø¥ÙŠÙ†ÙÙˆÙŠØ³ÙŠØ¯.',0),(26382,733,'fr','CustomerID ou RÃ©fFacture pas passÃ©.',0),(26383,733,'jp','é¡§å®¢ï¼©ï¼¤ã?‹è«‹æ±‚æ›¸ï¼©ï¼¤ã?Œæ‰¿èª?ã?•ã‚Œã?¾ã?›ã‚“',0),(26384,733,'pt','CustomerID ou invoiceid nÃ£o passou.',0),(26385,733,'ru','CustomerID Ð¸Ð»Ð¸ invoiceid Ð½Ðµ Ð¿Ñ€Ð¾ÑˆÐ»Ð¾.',0),(26386,733,'es','Clienteid o Facturaid no pasÃ³',0),(26387,733,'de','CustomerID oder Invoiceid nicht bestanden.',0),(26388,733,'en','Customerid or invoiceid not passed.',0),(26389,734,'is','',0),(26390,734,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯ ',0),(26391,734,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯ ',0),(26392,734,'tr','MÃ¼ÅŸteriler alÄ±ndÄ±ktan',0),(26393,734,'pl','Klienci zostaÅ‚y przywiezione',0),(26394,734,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð²Ð½ÐµÑÐµÐ½Ð¸',0),(26395,734,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©Ùˆ Ø¯Ø±Ø¢Ù…Ø¯ Ù†ÛÛŒÚº Ú©ÛŒÛ’ Ú¯Ø¦Û’',0),(26396,734,'sr','ÐšÑƒÐ¿Ñ†Ð¸ ÑÑƒ ÑƒÐ²ÐµÐ·ÐµÐ½Ð°.',0),(26397,734,'vi','ÄÃ£ nháº­p khÃ¡ch hÃ ng',0),(26398,734,'af','Klante/KliÃ«nte is ingevoer',0),(26399,734,'ro','ClienÅ£ii au fost importate',0),(26400,734,'et','Kliendid on imporditud',0),(26401,734,'si','Uporabniki, ki so bili uvoÅ¾eni',0),(26402,734,'ba','Pelanggan telah diimpor',0),(26403,734,'nl','Klanten zijn ingevoerd',0),(26404,734,'fi','Asiakkaat on tuotu',0),(26405,734,'no','Kundene er importert',0),(26406,734,'da','Kunder er blevet importeret',0),(26407,734,'ko','ê³ ê°ì„ ê°€ì ¸ì™”ìŠµë‹ˆë‹¤.',0),(26408,734,'he','×”×œ×§×•×—×•×ª ×™×•×‘××•',0),(26409,734,'el','ÎŸÎ¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯',0),(26410,734,'zh','å®¢æˆ·å·²å¯¼å…¥\r\n',0),(26411,734,'sv','Kunder har importerats',0),(26412,734,'it','I clienti sono stati importati',0),(26413,734,'tl','',0),(26414,734,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3652;&#3604;&#3657;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3649;&#3621;&#3657;&#3623;',0),(26415,734,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¤¾ à¤†à¤¯à¤¾à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(26416,734,'ms','Pelanggan telah diimport',0),(26417,734,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(26418,734,'fr','Les visiteurs ont Ã©tÃ© importÃ©s',0),(26419,734,'jp','é¡§å®¢ã?Œã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆã?•ã‚Œã?¾ã?—ã?Ÿ',0),(26420,734,'pt','Os clientes foram importados',0),(26421,734,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹ Ð±Ñ‹Ð»Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹',0),(26422,734,'es','Clientes han sido importados',0),(26423,734,'de','Kunden wurden importiert',0),(26424,734,'en','Customers have been imported',0),(26425,735,'is','',0),(26426,735,'dr','ØªØ®ÙÙŠÙ',0),(26427,735,'pr','ØªØ®ÙÙŠÙ',0),(26428,735,'tr','Keser',0),(26429,735,'pl','KawaÅ‚ki',0),(26430,735,'bg','Ð¡ÑŠÐºÑ€Ð°Ñ‰ÐµÐ½Ð¸Ñ',0),(26431,735,'ur','Ú©Ù…ÛŒ',0),(26432,735,'sr','Ð¡Ð¼Ð°ÑšÐµÑšÐ°',0),(26433,735,'vi','Cáº¯t',0),(26434,735,'af','Snye',0),(26435,735,'ro','TÄƒieturi',0),(26436,735,'et','LÃµikab',0),(26437,735,'si','Kosi',0),(26438,735,'ba','Pemotongan',0),(26439,735,'nl','Bezuinigingen',0),(26440,735,'fi','Leikkaukset',0),(26441,735,'no','Kutt',0),(26442,735,'da','NedskÃ¦ringer',0),(26443,735,'ko','ì¸í•˜',0),(26444,735,'he','×—×ª×›×™×',0),(26445,735,'el','Î ÎµÏÎ¹ÎºÎ¿Ï€Î­Ï‚',0),(26446,735,'zh','å‰Šå‡\r\n',0),(26447,735,'sv','SkÃ¤r',0),(26448,735,'it','Tagli',0),(26449,735,'tl','',0),(26450,735,'th','&#3605;&#3633;&#3604;',0),(26451,735,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€',0),(26452,735,'ms','Potongan',0),(26453,735,'ar','ØªØ®ÙÙŠØ¶Ø§Øª',0),(26454,735,'fr','Coupes',0),(26455,735,'jp','å‰Šæ¸›',0),(26456,735,'pt','Cortes',0),(26457,735,'ru','ÐžÑ‚Ñ€ÑƒÐ±Ñ‹',0),(26458,735,'es','Cortes',0),(26459,735,'de','Schnitte',0),(26460,735,'en','Cuts',0),(26461,736,'is','',0),(26462,736,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ù‡ Ù†Ø¸Ø± ÙØ§Ù‚Ø¯ Ø§Ø¹ØªØ¨Ø§Ø± Ù…ÙŠ Ø¢ÙŠØ¯ â€“ Ù„Ø·ÙØ§ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÙŠØ¯ Ùˆ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯',0),(26463,736,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ù‡ Ù†Ø¸Ø± ÙØ§Ù‚Ø¯ Ø§Ø¹ØªØ¨Ø§Ø± Ù…ÙŠ Ø¢ÙŠØ¯ â€“ Ù„Ø·ÙØ§ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÙŠØ¯ Ùˆ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯',0),(26464,736,'tr','VeritabanÄ± bilgileri geÃ§ersiz gÃ¶rÃ¼nÃ¼yor; LÃ¼tfen programÄ± kapatÄ±n ve yeniden deneyin',0),(26465,736,'pl','Baza danych informacji wydaje siÄ™ byÄ‡ nieprawidÅ‚owy; Zamknij program i sprÃ³bowaÄ‡ ponownie',0),(26466,736,'bg','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¸Ð·Ð³Ð»ÐµÐ¶Ð´Ð° Ðµ Ð½ÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½; Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð°Ñ‚Ð° Ð¸ Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(26467,736,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù†Ø§Ø¬Ø§Ø¦Ø² ÛÙˆÙ†Ø§ Ø¸Ø§ÛØ± ÛÙˆØªØ§ ÛÛ’ Û” Ù¾Ø±ÙˆÚ¯Ø±Ø§Ù… Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù¾Ú¾Ø± Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº',0),(26468,736,'sr','Ð£ Ð±Ð°Ð·Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ ÑÐµ Ð¿Ð¾Ñ˜Ð°Ð²Ñ™ÑƒÑ˜Ñƒ Ð±Ð¸Ñ‚Ð¸ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð¸; Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼ Ð¸ Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(26469,736,'vi','ThÃ´ng Tin Dá»¯ Liá»‡u vÃ´ hiá»‡u. Vui lÃ²ng Ä‘Ã³ng chÆ°Æ¡ng trÃ¬nh & thá»­ láº¡i',0),(26470,736,'af','Die Databasis Inligting Blyk om Ongeldig te wees;  Verlaat asb. program af en probeer weer',0),(26471,736,'ro','BazÄƒ de date informaÅ£ii pare a fi incorecte; VÄƒ rugÄƒm sÄƒ Ã®nchideÅ£i programul ÅŸi Ã®ncercaÅ£i din nou',0),(26472,736,'et','Andmebaasi informasioon paistab olevat kehtetu; palun sulge programm ja proovi uuesti',0),(26473,736,'si','V zbirko podatkov informacij zdi, da je neveljavna; Zaprite program in poskusite znova',0),(26474,736,'ba','Database informasi tampaknya menjadi valid; Silakan tutup program dan coba lagi',0),(26475,736,'nl','De Database informatie lijkt te zijn ongeldig; Sluit programma en probeer het opnieuw',0),(26476,736,'fi','Tietokannan tiedot nÃ¤kyvÃ¤t on pÃ¤temÃ¤tÃ¶n; Sulje ohjelma ja yritÃ¤ uudelleen',0),(26477,736,'no','Databasen informasjon synes Ã¥ vÃ¦re ugyldig; Lukk programmet, og prÃ¸v igjen',0),(26478,736,'da','Database oplysninger synes at vÃ¦re ugyldige; Luk programmet, og prÃ¸v igen',0),(26479,736,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì •ë³´ê°€ í‘œì‹œ ë  ìž˜ëª» ëœ; í”„ë¡œê·¸ëž¨ì„ ì¢…ë£Œ í•˜ ê³  ë‹¤ì‹œ ì‹œë„ í•˜ì‹­ì‹œì˜¤',0),(26480,736,'he','×ž×¡×“ ×”× ×ª×•× ×™× ×ž×™×“×¢ ×©× ×¨××” ×—×•×§×™; × × ×¡×’×•×¨ ××ª ×”×ª×•×›× ×™×ª ×•× ×¡×” ×©×•×‘',0),(26481,736,'el','Î— Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï†Î±Î¯Î½ÎµÏ„Î±Î¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¬ÎºÏ…ÏÎ¿? ÎšÎ»ÎµÎ¯ÏƒÏ„Îµ Ï„Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± ÎºÎ±Î¹ Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(26482,736,'zh','è¯¥æ•°æ®åº“ä¿¡æ¯ä¼¼ä¹Žæ— æ•ˆï¼Œè¯·å…³é—­ç¨‹åºï¼Œç„¶åŽå†è¯•ä¸€æ¬¡\r\n',0),(26483,736,'sv','Den databas Information verkar vara ogiltig; StÃ¤ng programmet och fÃ¶rsÃ¶k igen',0),(26484,736,'it','Il Database di informazioni sembra essere invalido; Si prega di chiudere il programma e riprovare',0),(26485,736,'tl','',0),(26486,736,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3611;&#3619;&#3634;&#3585;&#3598;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591; &#',0),(26487,736,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤•à¤Ÿ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ; à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥à¤°à¥‹à¤—à¥à¤°à¤¾à¤® à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à',0),(26488,736,'ms','Dalam pangkalan data maklumat nampaknya tidak sah; Sila tutup atur cara dan cuba lagi',0),(26489,736,'ar','ØªØ¸Ù‡Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ØªÙƒÙˆÙ† ØµØ§Ù„Ø­Ø©Ø› Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥ØºÙ„Ø§Ù‚ Ø§Ù„Ø¨Ø±Ù†Ø§Ù…Ø¬ ÙˆØ­Ø§ÙˆÙ„ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(26490,736,'fr','Les informations de base de donnÃ©es apparaÃ®t invalide ; Fermez le programme et essayez Ã  nouveau',0),(26491,736,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹æƒ…å ±ã?Œç„¡åŠ¹ã?«ã?ªã?£ã?¦ã?„ã‚‹ã‚ˆã?†ã?§ã?™ã€‚ä¸€åº¦ãƒ—ãƒ­ã‚°ãƒ©ãƒ ã‚’é–‰ã?˜ã?¦ã€?ã‚‚ã?†ä¸€åº¦ãƒˆãƒ©ã‚¤ã?—ã?¦ä¸‹ã?•ã?„ã€‚',0),(26492,736,'pt','O banco de dados de informaÃ§Ã£o parece ser invÃ¡lido; Feche o programa e tente novamente',0),(26493,736,'ru','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¿Ð¾ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð±Ñ‹Ñ‚ÑŒ Ð½ÐµÐ´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼Ð¸; Ð—Ð°ÐºÑ€Ð¾Ð¹Ñ‚Ðµ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ñƒ Ð¸ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð¿Ñ‹Ñ‚ÐºÑƒ',0),(26494,736,'es','La InformaciÃ³n de Base de Datos Aparece ser Invalida. Por favor cierre el programa y intenta otra vez',0),(26495,736,'de','Die Datenbank Informationen scheint ungÃ¼ltig zu sein; Bitte schlieÃŸen Sie Programm und versuchen Sie es erneut',0),(26496,736,'en','The Database Information Appears to be Invalid; Please close program and try again',0),(26497,737,'is','',0),(26498,737,'dr','ØªØ§Ø±ÙŠØ®',0),(26499,737,'pr','ØªØ§Ø±ÙŠØ®',0),(26500,737,'tr','Tarihi',0),(26501,737,'pl','Data',0),(26502,737,'bg','Ð”Ð°Ñ‚Ð°',0),(26503,737,'ur','ØªØ§Ø±ÛŒØ®',0),(26504,737,'sr','Ð”Ð°Ñ‚ÑƒÐ¼',0),(26505,737,'vi','NgÃ y',0),(26506,737,'af','Datum',0),(26507,737,'ro','Data',0),(26508,737,'et','KuupÃ¤ev',0),(26509,737,'si','Datum',0),(26510,737,'ba','Tanggal',0),(26511,737,'nl','Datum',0),(26512,737,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(26513,737,'no','Dato',0),(26514,737,'da','Dato',0),(26515,737,'ko','ë‚ ì§œ',0),(26516,737,'he','×ª××¨×™×š',0),(26517,737,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(26518,737,'zh','æ—¥æœŸ\r\n',0),(26519,737,'sv','Datum',0),(26520,737,'it','Data',0),(26521,737,'tl','',0),(26522,737,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(26523,737,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(26524,737,'ms','Tarikh',0),(26525,737,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(26526,737,'fr','Date',0),(26527,737,'jp','æ—¥ä»˜',0),(26528,737,'pt','Data',0),(26529,737,'ru','Ð”Ð°Ñ‚Ð°',0),(26530,737,'es','Fecha',0),(26531,737,'de','Datum',0),(26532,737,'en','Date',0),(26533,738,'is','',0),(26534,738,'dr','ØªØ§Ø±ÙŠØ®  Ùˆ Ø²Ù…Ø§Ù† ',0),(26535,738,'pr','ØªØ§Ø±ÙŠØ®  Ùˆ Ø²Ù…Ø§Ù† ',0),(26536,738,'tr','Tarih & Saat',0),(26537,738,'pl','Czas &',0),(26538,738,'bg','Ð”Ð°Ñ‚Ð° & Ñ‡Ð°Ñ',0),(26539,738,'ur','ØªØ§Ø±ÛŒØ® & ÙˆÙ‚Øª',0),(26540,738,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸ Ð²Ñ€ÐµÐ¼Ðµ',0),(26541,738,'vi','NgÃ y & thá»i gian',0),(26542,738,'af','Datum & Tyd',0),(26543,738,'ro','Data & timp',0),(26544,738,'et','KuupÃ¤eva & aeg',0),(26545,738,'si','Datum & Äas',0),(26546,738,'ba','Tanggal &amp; waktu',0),(26547,738,'nl','Datum & tijd',0),(26548,738,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ & aika',0),(26549,738,'no','Dato & klokkeslett',0),(26550,738,'da','Dato & tid',0),(26551,738,'ko','ë‚ ì§œ & ì‹œê°„',0),(26552,738,'he','×ª××¨×™×š ×©×¢×” &',0),(26553,738,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± & ÏŽÏÎ±',0),(26554,738,'zh','æ—¥æœŸåŠæ—¶é—´\r\n',0),(26555,738,'sv','Datum & tid',0),(26556,738,'it','Data ora &',0),(26557,738,'tl','',0),(26558,738,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3649;&#3621;&#3632;&#3648;&#3623;&#3621;&#3634;',0),(26559,738,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¤®à¤¯ &',0),(26560,738,'ms','Tarikh & masa',0),(26561,738,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ùˆ Ø§Ù„ÙˆÙ‚Øª',0),(26562,738,'fr','Date heure &',0),(26563,738,'jp','æ—¥æ™‚',0),(26564,738,'pt','Data hora &',0),(26565,738,'ru','Ð”Ð°Ñ‚Ð° & Ð’Ñ€ÐµÐ¼Ñ',0),(26566,738,'es','Fecha & Hora',0),(26567,738,'de','Datum & Zeit',0),(26568,738,'en','Date & Time',0),(26569,739,'is','',0),(26570,739,'dr','(Ø§ÙŠØ¬Ø§Ø¯) Ø´Ø¯Ù‡ ',0),(26571,739,'pr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„ÙŠØ¯(Ø§ÙŠØ¬Ø§Ø¯) Ø´Ø¯Ù‡ ',0),(26572,739,'tr','OluÅŸturma tarihi',0),(26573,739,'pl','Data utworzenia',0),(26574,739,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ',0),(26575,739,'ur','Ø¨Ù†Ø§Ù†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(26576,739,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐ°',0),(26577,739,'vi','NgÃ y táº¡o ra',0),(26578,739,'af','Datum Geskep',0),(26579,739,'ro','Data creat',0),(26580,739,'et','Loomise kuupÃ¤ev',0),(26581,739,'si','Datum nastanka',0),(26582,739,'ba','Tanggal dibuat',0),(26583,739,'nl','Datum gemaakt',0),(26584,739,'fi','LuontipÃ¤ivÃ¤',0),(26585,739,'no','Opprettelsesdato',0),(26586,739,'da','Dato for oprettelse',0),(26587,739,'ko','ë§Œë“  ë‚ ì§œ',0),(26588,739,'he','×ª××¨×™×š ×™×¦×™×¨×”',0),(26589,739,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±Ï‚',0),(26590,739,'zh','åˆ›å»ºæ—¥æœŸ\r\n',0),(26591,739,'sv','Datum skapad',0),(26592,739,'it','Data di creazione',0),(26593,739,'tl','',0),(26594,739,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(26595,739,'hi','à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(26596,739,'ms','Tarikh dicipta',0),(26597,739,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(26598,739,'fr','Date de crÃ©ation',0),(26599,739,'jp','ä½œæˆ?æ—¥',0),(26600,739,'pt','Data de criaÃ§Ã£o',0),(26601,739,'ru','Ð”Ð°Ñ‚Ð° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ',0),(26602,739,'es','Fecha Creada',0),(26603,739,'de','Erstellungsdatum',0),(26604,739,'en','Date Created',0),(26605,740,'is','',0),(26606,740,'dr','ØªØ§Ø±ÙŠØ® Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(26607,740,'pr','ØªØ§Ø±ÙŠØ® Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(26608,740,'tr','Girilen Tarih',0),(26609,740,'pl','Data',0),(26610,740,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(26611,740,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±Ø¯Û ØªØ§Ø±ÛŒØ®',0),(26612,740,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÐºÐ¾Ñ˜Ð¸ ÑÑ‚Ðµ ÑƒÐ½ÐµÐ»Ð¸',0),(26613,740,'vi','Nháº­p NgÃ y ',0),(26614,740,'af','Datum Ingevoer',0),(26615,740,'ro','Data introdusÄƒ',0),(26616,740,'et','Sisestatud kuupÃ¤ev',0),(26617,740,'si','Datum',0),(26618,740,'ba','Tanggal masuk',0),(26619,740,'nl','Datum die is ingevoerd',0),(26620,740,'fi','LisÃ¤yspÃ¤ivÃ¤',0),(26621,740,'no','Dato',0),(26622,740,'da','Traadt',0),(26623,740,'ko','ë‚ ì§œ ìž…ë ¥',0),(26624,740,'he','×”×ª××¨×™×š ×”×ž×•×–×Ÿ',0),(26625,740,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Î±Î¹',0),(26626,740,'zh','è¾“å…¥æ—¥æœŸ\r\n',0),(26627,740,'sv','Datum som anges',0),(26628,740,'it','Data di entrata',0),(26629,740,'tl','',0),(26630,740,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(26631,740,'hi','à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(26632,740,'ms','Tarikh dimasukkan',0),(26633,740,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(26634,740,'fr','Date d\'entrÃ©e',0),(26635,740,'jp','è¨˜å¸³æ—¥',0),(26636,740,'pt','Data de entrada',0),(26637,740,'ru','Ð”Ð°Ñ‚Ð° Ð’Ð²ÐµÐ´ÐµÐ½Ð°',0),(26638,740,'es','Fecha Entrada',0),(26639,740,'de','Eingegebene Datum',0),(26640,740,'en','Date Entered',0),(26641,741,'is','',0),(26642,741,'dr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯ ',0),(26643,741,'pr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯ ',0),(26644,741,'tr','DoÄŸum tarihi',0),(26645,741,'pl','Data urodzenia',0),(26646,741,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ',0),(26647,741,'ur','ØªØ§Ø±ÙŠØ® Ù¾ÙŠØ¯Ø§Ø¦Ø´',0),(26648,741,'sr','Ð´Ð°Ñ‚ÑƒÐ¼ Ñ€Ð¾Ñ’ÐµÑšÐ°',0),(26649,741,'vi','NgÃ y sinh',0),(26650,741,'af','Geboortedatum',0),(26651,741,'ro','data naÅŸterii',0),(26652,741,'et','SÃ¼nnikuupÃ¤ev',0),(26653,741,'si','datum rojstva',0),(26654,741,'ba','Tanggal lahir',0),(26655,741,'nl','Geboortedatum',0),(26656,741,'fi','SyntymÃ¤pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(26657,741,'no','fÃ¸dselsdato',0),(26658,741,'da','FÃ¸dselsdag',0),(26659,741,'ko','ìƒë…„ì›”ì¼',0),(26660,741,'he','×ª××¨×™×š ×œ×™×“×”',0),(26661,741,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î³Î­Î½Î½Î·ÏƒÎ·Ï‚',0),(26662,741,'zh','å‡ºç”Ÿæ—¥æœŸ\r\n',0),(26663,741,'sv','FÃ¶delsedatum',0),(26664,741,'it','Data di nascita',0),(26665,741,'tl','',0),(26666,741,'th','&#3623;&#3633;&#3609;&#3648;&#3585;&#3636;&#3604;',0),(26667,741,'hi','à¤œà¤¨à¥à¤® à¤¤à¤¿à¤¥à¤¿',0),(26668,741,'ms','tarikh lahir',0),(26669,741,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ÙŠÙ„Ø§Ø¯',0),(26670,741,'fr','Date de naissance',0),(26671,741,'jp','èª•ç”Ÿæ—¥',0),(26672,741,'pt','Data de nascimento',0),(26673,741,'ru','Ð”Ð°Ñ‚Ð° Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(26674,741,'es','Fecha de Nacimiento',0),(26675,741,'de','Geburtsdatum',0),(26676,741,'en','Date of Birth',0),(26677,742,'is','',0),(26678,742,'dr','ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± ',0),(26679,742,'pr','ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± ',0),(26680,742,'tr','Fatura tarihi',0),(26681,742,'pl','Data faktury',0),(26682,742,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°',0),(26683,742,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(26684,742,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(26685,742,'vi','NgÃ y hÃ³a Ä‘Æ¡n',0),(26686,742,'af','Datum van Faktuur',0),(26687,742,'ro','Data facturii',0),(26688,742,'et','Arve kuupÃ¤ev',0),(26689,742,'si','Datum raÄuna',0),(26690,742,'ba','Tanggal faktur',0),(26691,742,'nl','Datum van de factuur',0),(26692,742,'fi','Laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(26693,742,'no','Fakturadato',0),(26694,742,'da','Datoen for faktura',0),(26695,742,'ko','ì†¡ìž¥ ë‚ ì§œ',0),(26696,742,'he','×ª××¨×™×š ×—×©×‘×•× ×™×ª',0),(26697,742,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(26698,742,'zh','å‘ç¥¨æ—¥æœŸ\r\n',0),(26699,742,'sv','Fakturadatum',0),(26700,742,'it','Data della fattura',0),(26701,742,'tl','',0),(26702,742,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(26703,742,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(26704,742,'ms','Tarikh invois',0),(26705,742,'ar','ØªØ§Ø±ÙŠØ® Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(26706,742,'fr','Date de la facture',0),(26707,742,'jp','è«‹æ±‚æ›¸ã?®æ—¥ä»˜',0),(26708,742,'pt','Data da fatura',0),(26709,742,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(26710,742,'es','Fecha de Factura',0),(26711,742,'de','Rechnungsdatum',0),(26712,742,'en','Date of Invoice',0),(26713,743,'is','',0),(26714,743,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(26715,743,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(26716,743,'tr','Deftere nakledildiÄŸi tarihi',0),(26717,743,'pl','Daty wysÅ‚ana na',0),(26718,743,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð°',0),(26719,743,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ø¨Ø·Ø±Ù ØªØ§Ø±ÛŒØ®',0),(26720,743,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ð·Ð°',0),(26721,743,'vi','NgÃ y káº¿t chuyá»ƒn vÃ o',0),(26722,743,'af','Datum Gepos Na',0),(26723,743,'ro','Data postat la',0),(26724,743,'et','KuupÃ¤ev',0),(26725,743,'si','Datum, objavljen v',0),(26726,743,'ba','Tanggal posting untuk',0),(26727,743,'nl','Datum naar geboekt',0),(26728,743,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤, kirjattu',0),(26729,743,'no','Datoen postert til',0),(26730,743,'da','Dato, bogfÃ¸rt',0),(26731,743,'ko','ë‚ ì§œì— ê²Œì‹œ ë¨',0),(26732,743,'he','×ª××¨×™×š ×¢×“×›×•×Ÿ ×›×“×™',0),(26733,743,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏ„Î·ÎºÎµ ÏƒÏ„Î¿',0),(26734,743,'zh','å‘å¸ƒæ—¥æœŸä¸º\r\n',0),(26735,743,'sv','Datum Inlagd till',0),(26736,743,'it','Data registrato per',0),(26737,743,'tl','',0),(26738,743,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(26739,743,'hi','à¤¤à¤¿à¤¥à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(26740,743,'ms','Tarikh dimasukkan ke',0),(26741,743,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ±Ø­ÙŠÙ„ Ù„Ù€',0),(26742,743,'fr','Date de publication de',0),(26743,743,'jp','è¨ˆä¸Šæ—¥',0),(26744,743,'pt','Data postada para',0),(26745,743,'ru','Ð”Ð°Ñ‚Ð°',0),(26746,743,'es','Fecha Asentada a',0),(26747,743,'de','Verfasst um',0),(26748,743,'en','Date Posted To',0),(26749,744,'is','',0),(26750,744,'dr','ØªØ§Ø±ÙŠØ® Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(26751,744,'pr','ØªØ§Ø±ÙŠØ® Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(26752,744,'tr','AlÄ±nan Tarih',0),(26753,744,'pl','Daty otrzymania',0),(26754,744,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð°, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð°',0),(26755,744,'ur','ØªØ§Ø±ÛŒØ® ÙˆØµÙˆÙ„ÛŒ',0),(26756,744,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð°',0),(26757,744,'vi','NgÃ y Ä‘Ã£ nháº­n',0),(26758,744,'af','Datum Ontvang',0),(26759,744,'ro','Data primirii',0),(26760,744,'et','Laekumise kuupÃ¤ev',0),(26761,744,'si','Datum prejema',0),(26762,744,'ba','Tanggal diterima',0),(26763,744,'nl','Datum van ontvangst',0),(26764,744,'fi','Vastaanotettuja',0),(26765,744,'no','Mottatt',0),(26766,744,'da','Dato modtaget',0),(26767,744,'ko','ë°›ì€ ë‚ ì§œ',0),(26768,744,'he','×ª××¨×™×š ×”×ª×§×‘×œ',0),(26769,744,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î±ÏÎ±Î»Î±Î²Î®Ï‚',0),(26770,744,'zh','æ”¶ä»¶æ—¥æœŸ\r\n',0),(26771,744,'sv','Dag mottog',0),(26772,744,'it','Data di ricezione',0),(26773,744,'tl','',0),(26774,744,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(26775,744,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(26776,744,'ms','Tarikh diterima',0),(26777,744,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø³ØªÙ„Ø§Ù…',0),(26778,744,'fr','Date de rÃ©ception',0),(26779,744,'jp','å?—é ˜æ—¥',0),(26780,744,'pt','Data recebida',0),(26781,744,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ',0),(26782,744,'es','Fecha Recibida',0),(26783,744,'de','Eingangsdatum',0),(26784,744,'en','Date Received',0),(26785,745,'is','',0),(26786,745,'dr','ØªØ§Ø±ÙŠØ® Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡ ',0),(26787,745,'pr','ØªØ§Ø±ÙŠØ® Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡ ',0),(26788,745,'tr','GÃ¶nderilen Tarih',0),(26789,745,'pl','Data',0),(26790,745,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð°',0),(26791,745,'ur','ØªØ§Ø±ÛŒØ® Ù†Û’ Ø¹Ø±Ø¶ Ú©ÛŒØ§',0),(26792,745,'sr','ÐŸÑ€Ð¾ÑÐ»ÐµÑ’ÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(26793,745,'vi','NgÃ y ná»™p',0),(26794,745,'af','Datum Ingehandig',0),(26795,745,'ro','Data prezentÄƒrii',0),(26796,745,'et','Esitamist',0),(26797,745,'si','Vpisali datum',0),(26798,745,'ba','Tanggal disampaikan',0),(26799,745,'nl','Datum ingediend',0),(26800,745,'fi','JÃ¤tetty',0),(26801,745,'no','Dato sendt inn',0),(26802,745,'da','Dato indsendt',0),(26803,745,'ko','ì œì¶œ ë‚ ì§œ',0),(26804,745,'he','×ª××¨×™×š × ××¡×¤×•',0),(26805,745,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(26806,745,'zh','æäº¤æ—¥æœŸ\r\n',0),(26807,745,'sv','Dag in',0),(26808,745,'it','Data di presentazione',0),(26809,745,'tl','',0),(26810,745,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;&#3617;&#3629;&#3610;',0),(26811,745,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤',0),(26812,745,'ms','Tarikh dikemukakan',0),(26813,745,'ar','ØªØ§Ø±ÙŠØ® ØªÙ‚Ø¯ÙŠÙ…',0),(26814,745,'fr','Date d\'introduction',0),(26815,745,'jp','æ??å‡ºæ—¥',0),(26816,745,'pt','Data enviada',0),(26817,745,'ru','Ð”Ð°Ñ‚Ð° Ð·Ð°Ð½ÐµÑÐµÐ½Ð¸Ñ',0),(26818,745,'es','Fecha Sometida',0),(26819,745,'de','Datum eingereicht',0),(26820,745,'en','Date Submitted',0),(26821,746,'is','',0),(26822,746,'dr','ØªØ§Ø±ÙŠØ® â€“ Ø²Ù…Ø§Ù† ',0),(26823,746,'pr','ØªØ§Ø±ÙŠØ® â€“ Ø²Ù…Ø§Ù† ',0),(26824,746,'tr','Tarih-Saat',0),(26825,746,'pl','Data godzina',0),(26826,746,'bg','Ð”Ð°Ñ‚Ð° Ð¸ Ñ‡Ð°Ñ',0),(26827,746,'ur','ØªØ§Ø±ÛŒØ®-ÙˆÙ‚Øª',0),(26828,746,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸ Ð²Ñ€ÐµÐ¼Ðµ',0),(26829,746,'vi','NgÃ y-thá»i gian',0),(26830,746,'af','Datum-Tyd',0),(26831,746,'ro','Data-ora',0),(26832,746,'et','KuupÃ¤eva ja kellaaja',0),(26833,746,'si','Datum-Äas',0),(26834,746,'ba','Tanggal-waktu',0),(26835,746,'nl','Datum / tijd',0),(26836,746,'fi','-Aika',0),(26837,746,'no','Dato og klokkeslett',0),(26838,746,'da','Dato og klokkeslÃ¦t',0),(26839,746,'ko','ë‚ ì§œ ë° ì‹œê°„',0),(26840,746,'he','×ª××¨×™×š-×©×¢×”',0),(26841,746,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±-ÏŽÏÎ±',0),(26842,746,'zh','æ—¥æœŸæ—¶é—´\r\n',0),(26843,746,'sv','Datum och tid',0),(26844,746,'it','Data-ora',0),(26845,746,'tl','',0),(26846,746,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;-&#3648;&#3623;&#3621;&#3634;',0),(26847,746,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤•-à¤¸à¤®à¤¯',0),(26848,746,'ms','Tarikh-masa',0),(26849,746,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ®-Ø§Ù„ÙˆÙ‚Øª',0),(26850,746,'fr','Date-heure',0),(26851,746,'jp','æ—¥ä»˜ï¼?æ™‚é–“',0),(26852,746,'pt','Data e hora',0),(26853,746,'ru','Ð”Ð°Ñ‚Ð°-Ð’Ñ€ÐµÐ¼Ñ',0),(26854,746,'es','Fecha-Hora',0),(26855,746,'de','Datum / Uhrzeit',0),(26856,746,'en','Date-Time',0),(26857,747,'is','',0),(26858,747,'dr','ØªØ§Ø±ÙŠØ® Ø¯Ø§Ø±',0),(26859,747,'pr','ØªØ§Ø±ÙŠØ® Ø¯Ø§Ø±',0),(26860,747,'tr','Tarihli',0),(26861,747,'pl','Z dnia',0),(26862,747,'bg','Ð¡ Ð´Ð°Ñ‚Ð°',0),(26863,747,'ur','Ù…Ø¤Ø±Ø®Û',0),(26864,747,'sr','Ð˜Ð·Ð»Ð°Ð·Ð¸Ð»Ð¸',0),(26865,747,'vi','NgÃ y',0),(26866,747,'af','Gedateer',0),(26867,747,'ro','Din data de',0),(26868,747,'et','Dateeritud',0),(26869,747,'si','Z dne',0),(26870,747,'ba','Tanggal',0),(26871,747,'nl','Gedateerd',0),(26872,747,'fi','PÃ¤ivÃ¤tty',0),(26873,747,'no','Datert',0),(26874,747,'da','Dateret',0),(26875,747,'ko','ì¼ìž',0),(26876,747,'he','×™×¦××ª×™',0),(26877,747,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(26878,747,'zh','æ—¥æœŸ\r\n',0),(26879,747,'sv','Daterad',0),(26880,747,'it','Datato',0),(26881,747,'tl','',0),(26882,747,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(26883,747,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤•à¤¿à¤¤',0),(26884,747,'ms','Bertarikh',0),(26885,747,'ar','Ù…Ø¤Ø±Ø®',0),(26886,747,'fr','En date du',0),(26887,747,'jp','æ—¥ä»˜ã?®',0),(26888,747,'pt','Datado de',0),(26889,747,'ru','ÐžÑ‚',0),(26890,747,'es','Fechado',0),(26891,747,'de','Datiert',0),(26892,747,'en','Dated',0),(26893,748,'is','',0),(26894,748,'dr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ù…ÙŠ Ø´ÙˆÙ†Ø¯ ÙˆÙ‚ØªÙŠ ÙƒÙ‡ \" ÙÙ‚Ø· Ø¨Ø§Ø² \" Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(26895,748,'pr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ù…ÙŠ Ø´ÙˆÙ†Ø¯ ÙˆÙ‚ØªÙŠ ÙƒÙ‡ \" ÙÙ‚Ø· Ø¨Ø§Ø² \" Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(26896,748,'tr','Ne zaman aÃ§Ä±k yalnÄ±zca seÃ§ili tarihler kullanÄ±lmaz',0),(26897,748,'pl','Terminy nie sÄ… uÅ¼ywane, gdy otwarte tylko wybrane',0),(26898,748,'bg','Ð”Ð°Ñ‚Ð¸Ñ‚Ðµ Ð½Ðµ ÑÐ° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð¿Ñ€Ð¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ ÑÐ°Ð¼Ð¾ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(26899,748,'ur','Ø¬Ø¨ Ú©Ú¾Ù„Û’ ØµØ±Ù Ù…Ù†ØªØ®Ø¨ ØªØ§Ø±ÛŒØ®ÛŒÚº Ø¨Ú¾ÛŒ Ø¯ÛŒ Ø¬Ø§ØªÛŒ ÛÛŒÚº',0),(26900,748,'sr','Ð”Ð°Ñ‚ÑƒÐ¼Ð¸ Ð½Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ðµ ÑÐµ ÐºÐ°Ð´Ð° Ñ˜Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½ ÑÐ°Ð¼Ð¾ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(26901,748,'vi','NgÃ y khÃ´ng sá»­ dá»¥ng khi chá»n CHá»ˆ Má»ž',0),(26902,748,'af','Datums word nie gebruik wanneer OOP ALLEENLIK geselekteer word',0),(26903,748,'ro','Datele nu sunt utilizate atunci cÃ¢nd deschise doar selectat',0),(26904,748,'et','KuupÃ¤evad on kasutatud avatud ainult valitud',0),(26905,748,'si','Datumi se ne uporabljajo, ko je odprta le izbrane',0),(26906,748,'ba','Tanggal tidak digunakan ketika terbuka hanya dipilih',0),(26907,748,'nl','Datums worden niet gebruikt als OPEN alleen ingeschakeld',0),(26908,748,'fi','PÃ¤ivÃ¤mÃ¤Ã¤riÃ¤ ei kÃ¤ytetÃ¤ avoinna vain valittuna',0),(26909,748,'no','Datoer brukes ikke nÃ¥r Ã¥pen bare valgt',0),(26910,748,'da','Datoer bruges ikke, nÃ¥r Ã¥ben kun udvalgte',0),(26911,748,'ko','ì˜¤í”ˆë§Œ ì„ íƒ í•˜ë©´ ë‚ ì§œ ì‚¬ìš© ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(26912,748,'he','×ª××¨×™×›×™× ×œ× ×ž×©×ž×©×™× ×›×©×‘×•×—×¨×™× ×¤×ª×•×— ×‘×œ×‘×“',0),(26913,748,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚ Î´ÎµÎ½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ ÏŒÏ„Î±Î½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ Î±Î½Î¿Î¹Ï‡Ï„ÏŒ Î¼ÏŒÎ½Î¿',0),(26914,748,'zh','ä»…æ‰“å¼€é€‰æ‹©æ—¶æ—¥æœŸä¸ä½¿ç”¨',0),(26915,748,'sv','Datum anvÃ¤nds inte nÃ¤r Ã¶ppen endast markerat',0),(26916,748,'it','Le date non vengono utilizzate quando aperto solo selezionati',0),(26917,748,'tl','',0),(26918,748,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;&#3648;&#3617;&#3639;&#3656;&#3629;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3',0),(26919,748,'hi','à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤ à¤œà¤¬ à¤–à¥à¤²à¥‡ à¤•à¥‡à¤µà¤² à¤šà¤¯à¤¨à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾',0),(26920,748,'ms','Tarikh yang digunakan apabila terbuka sahaja dipilih',0),(26921,748,'ar','Ù„Ø§ ØªØ³ØªØ®Ø¯Ù… Ø§Ù„ØªÙˆØ§Ø±ÙŠØ® Ø¹Ù†Ø¯ ØªØ­Ø¯ÙŠØ¯ \"Ù…ÙØªÙˆØ­Ø© ÙÙ‚Ø·\"',0),(26922,748,'fr','Dates ne sont pas utilisÃ©s lorsque ouvert seulement sÃ©lectionnÃ©',0),(26923,748,'jp','ã‚ªãƒ¼ãƒ—ãƒ³ã?®ã?¿ã‚’é?¸æŠžã?—ã?¦ã?„ã‚‹æ™‚ã?¯ã?“ã?®æ—¥ã?«ã?¡ã?¯ä½¿ã?ˆã?¾ã?›ã‚“ã€‚',0),(26924,748,'pt','As datas nÃ£o sÃ£o usadas quando aberto somente selecionados',0),(26925,748,'ru','Ð”Ð°Ñ‚Ñ‹ Ð½Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑŽÑ‚ÑÑ ÐºÐ¾Ð³Ð´Ð° Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð¾ Ð¢ÐžÐ›Ð¬ÐšÐž ÐžÐ¢ÐšÐ Ð«Ð¢Ð«Ð•',0),(26926,748,'es','Fechas no estan usadas cuando seleccionar ABRIR SOLAMENTE',0),(26927,748,'de','Termine werden nicht verwendet, wenn nur offene gewÃ¤hlt',0),(26928,748,'en','Dates are not used when OPEN ONLY selected',0),(26929,749,'is','',0),(26930,749,'dr','Ø±ÙˆØ²',0),(26931,749,'pr','Ø±ÙˆØ²',0),(26932,749,'tr','GÃ¼n',0),(26933,749,'pl','DzieÅ„',0),(26934,749,'bg','Ð”ÐµÐ½',0),(26935,749,'ur','Ø¯Ù†',0),(26936,749,'sr','Ð”Ð°Ð½',0),(26937,749,'vi','NgÃ y',0),(26938,749,'af','Dag',0),(26939,749,'ro','Ziua',0),(26940,749,'et','PÃ¤ev',0),(26941,749,'si','Dan',0),(26942,749,'ba','Hari',0),(26943,749,'nl','Dag',0),(26944,749,'fi','PÃ¤ivÃ¤',0),(26945,749,'no','Dag',0),(26946,749,'da','Dag',0),(26947,749,'ko','í•˜ë£¨',0),(26948,749,'he','×™×•×',0),(26949,749,'el','Î—Î¼Î­ÏÎ±',0),(26950,749,'zh','æ—¥',0),(26951,749,'sv','Dag',0),(26952,749,'it','Giorno',0),(26953,749,'tl','',0),(26954,749,'th','&#3623;&#3633;&#3609;',0),(26955,749,'hi','à¤¦à¤¿à¤µà¤¸',0),(26956,749,'ms','Hari',0),(26957,749,'ar','Ø§Ù„ÙŠÙˆÙ…',0),(26958,749,'fr','JournÃ©e',0),(26959,749,'jp','æ—¥',0),(26960,749,'pt','Dia',0),(26961,749,'ru','Ð”ÐµÐ½ÑŒ',0),(26962,749,'es','DÃ­a',0),(26963,749,'de','Tag',0),(26964,749,'en','Day',0),(26965,750,'is','',0),(26966,750,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø§Ø²  Ø¢Ø²Ù…Ø§ÙŠØ´',0),(26967,750,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø§Ø²  Ø¢Ø²Ù…Ø§ÙŠØ´',0),(26968,750,'tr','GÃ¼n iÃ§inde duruÅŸma yaptÄ±',0),(26969,750,'pl','Czasy zostawiaÄ‡ w procesie',0),(26970,750,'bg','Days Ð»ÑÐ² in ÑÑŠÐ´ÐµÐ±Ð½Ð¸Ñ Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(26971,750,'ur','Ø¯Ù†ÙˆÚº Ù…ÛŒÚº Ù…Ù‚Ø¯Ù…Û’ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒØ§',0),(26972,750,'sr','ÐžÑÑ‚Ð°Ð»Ð¾ Ð´Ð°Ð½Ð° ÑÑƒÑ’ÐµÑšÐ°',0),(26973,750,'vi','NgÃ y cÃ²n láº¡i Ä‘á»ƒ thá»­',0),(26974,750,'af','Proefdae Oor ',0),(26975,750,'ro','Zile stÃ¢nga Ã®n proces',0),(26976,750,'et','PÃ¤eva jÃ¤Ã¤nud kohtuprotsess',0),(26977,750,'si','Days levi v preskuÅ¡anju',0),(26978,750,'ba','Hari yang tersisa di pengadilan',0),(26979,750,'nl','Dagen verlaten in proces',0),(26980,750,'fi','Days jÃ¤ljelle kotona karsintakilpailu',0),(26981,750,'no','Dager igjen i rettssak',0),(26982,750,'da','Dage tilbage i retssag',0),(26983,750,'ko','ì¼ ìž¬íŒì—ì„œ ì™¼ìª½',0),(26984,750,'he','×™×ž×™× × ×©××¨×• ×‘×ž×©×¤×˜',0),(26985,750,'el','Î—Î¼Î­ÏÎµÏ‚ Ï€Î¿Ï… Î±Ï†Î®Î½Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î· Î´Î¿ÎºÎ¹Î¼Î®',0),(26986,750,'zh','å¤©æ—¶é—´åœ¨å®¡åˆ¤\r\n',0),(26987,750,'sv','Dagar kvar i rÃ¤ttegÃ¥ng',0),(26988,750,'it','Giorni lasciato in prova',0),(26989,750,'tl','',0),(26990,750,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3627;&#3621;&#3639;&#3629;&#3651;&#3609;&#3585;&#3634;&#3619;&#3607;&#3604;&#3621;&#3629;&#3591;&#3651;&#3594;&#3657;',0),(26991,750,'hi','à¤¦à¤¿à¤¨ à¤›à¥‹à¤¡à¤¼ à¤¦à¤¿à¤¯à¤¾ à¤®à¥‡à¤‚ à¤ªà¤°à¥€à¤•à¥à¤·à¤£',0),(26992,750,'ms','Hari ditinggalkan dalam percubaan',0),(26993,750,'ar','ÙˆØ¨Ù‚ÙŠ ÙŠÙˆÙ…Ø§ ÙÙŠ Ù…Ø­Ø§ÙƒÙ…Ø©',0),(26994,750,'fr','Jours restant en procÃ¨s',0),(26995,750,'jp','ãƒˆãƒ©ã‚¤ã‚¢ãƒ«æ®‹ã‚Šæ—¥æ•°',0),(26996,750,'pt','Faltam dias em julgamento',0),(26997,750,'ru','Ð”Ð½ÐµÐ¹ Ð¾ÑÑ‚Ð°Ð»Ð¾ÑÑŒ Ð² ÑÑƒÐ´Ðµ',0),(26998,750,'es','DÃ­as Restantes en la Prueba',0),(26999,750,'de','Tage im Prozess',0),(27000,750,'en','Days Left in Trial',0),(27001,751,'is','',0),(27002,751,'dr','/ Ø³Ø§Ù„ ',0),(27003,751,'pr','Ø±ÙˆØ²Ù‡Ø§  / Ø³Ø§Ù„ ',0),(27004,751,'tr','GÃ¼n/yÄ±l',0),(27005,751,'pl','Dni w roku',0),(27006,751,'bg','Ð”Ð½Ð¸ Ð² Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(27007,751,'ur','Ø¯Ù†/Ø³Ø§Ù„',0),(27008,751,'sr','Ð”Ð°Ð½Ð°/Ð³Ð¾Ð´.',0),(27009,751,'vi','NgÃ y/NÄƒm',0),(27010,751,'af','Dae/Jaar',0),(27011,751,'ro','De zile pe an',0),(27012,751,'et','PÃ¤eva aastas',0),(27013,751,'si','Dni/leto',0),(27014,751,'ba','Hari/tahun',0),(27015,751,'nl','Dagen/jaar',0),(27016,751,'fi','PÃ¤ivÃ¤Ã¤/vuosi',0),(27017,751,'no','Dager i Ã¥ret',0),(27018,751,'da','Dage/Ã¥r',0),(27019,751,'ko','ì¼/ë…„',0),(27020,751,'he','×™×ž×™×/×©× ×”',0),(27021,751,'el','Î—Î¼Î­ÏÎµÏ‚/Î­Ï„Î¿Ï‚',0),(27022,751,'zh','å¤©/å¹´\r\n',0),(27023,751,'sv','Dagar/Ã¥r',0),(27024,751,'it','Giorni/anno',0),(27025,751,'tl','',0),(27026,751,'th','&#3623;&#3633;&#3609;/&#3611;&#3637;',0),(27027,751,'hi','à¤¦à¤¿à¤¨/à¤µà¤°à¥à¤·',0),(27028,751,'ms','Hari/tahun',0),(27029,751,'ar','ÙŠÙˆÙ…Ø§ ÙÙŠ Ø§Ù„Ø³Ù†Ø©',0),(27030,751,'fr','Jours/an',0),(27031,751,'jp','æ—¥æ•°/å¹´',0),(27032,751,'pt','Dias/ano',0),(27033,751,'ru','Ð”Ð½Ð¸/Ð“Ð¾Ð´',0),(27034,751,'es','DÃ­as/Anos',0),(27035,751,'de','Tage/Jahr',0),(27036,751,'en','Days/Year',0),(27037,752,'is','',0),(27038,752,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¬Ø¯Ø§ÙˆÙ„ Ø³ÙŠØ³ØªÙ… ',0),(27039,752,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¬Ø¯Ø§ÙˆÙ„ Ø³ÙŠØ³ØªÙ… ',0),(27040,752,'tr','Sistem tablolarÄ± denetleniyor...',0),(27041,752,'pl','Sprawdzanie systemu tabel...',0),(27042,752,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¸ÑÑ‚ÐµÐ¼Ð½Ð¸Ñ‚Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð¸...',0),(27043,752,'ur','Ù†Ø¸Ø§Ù… Ø¬Ø¯ÙˆÙ„ÛŒÚº Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’...',0),(27044,752,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° ÑÐ¸ÑÑ‚ÐµÐ¼ÑÐºÐ¸Ñ… Ñ‚Ð°Ð±ÐµÐ»Ð°...',0),(27045,752,'vi','Kiá»ƒm tra báº£ng há»‡ thá»‘ng',0),(27046,752,'af','Kontroleer sisteem tabelle...',0),(27047,752,'ro','Verificarea tabelele de sistem...',0),(27048,752,'et','SÃ¼steemi tabelite kontrollimine...',0),(27049,752,'si','Preverjanje sistemskih tabel...',0),(27050,752,'ba','Memeriksa sistem tabel...',0),(27051,752,'nl','Systeemtabellen controleren...',0),(27052,752,'fi','Tarkistetaan jÃ¤rjestelmÃ¤taulukoiden...',0),(27053,752,'no','Kontrollerer systemtabeller...',0),(27054,752,'da','Kontrol systemtabeller...',0),(27055,752,'ko','ì‹œìŠ¤í…œ í…Œì´ë¸”ì„ ê²€ì‚¬...',0),(27056,752,'he','...×‘×•×“×§ ×˜×‘×œ××•×ª ×ž×¢×¨×›×ª',0),(27057,752,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ Ï€Î¯Î½Î±ÎºÎµÏ‚ ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚...',0),(27058,752,'zh','æ£€æŸ¥ç³»ç»Ÿè¡¨...\r\n',0),(27059,752,'sv','Kontrollera systemtabeller...',0),(27060,752,'it','Controllando le tabelle di sistema...',0),(27061,752,'tl','',0),(27062,752,'th','Checking system tables...',0),(27063,752,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤¤à¤¾à¤²à¤¿à¤•à¤¾à¤“à¤‚ à¤•à¥€ à¤œà¤¾à¤à¤š...',0),(27064,752,'ms','Menyemak jadual sistem...',0),(27065,752,'ar','ÙŠØ¬Ø±ÙŠ ÙØ­Øµ Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ù„Ù†Ø¸Ø§Ù…...',0),(27066,752,'fr','VÃ©rification des tables systÃ¨me...',0),(27067,752,'jp','ã‚·ã‚¹ãƒ†ãƒ è¡¨ã‚’ãƒ?ã‚§ãƒƒã‚¯ã?—ã?¦ã?„ã?¾ã?™â€¦',0),(27068,752,'pt','VerificaÃ§Ã£o de tabelas do sistema...',0),(27069,752,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÐ¸ÑÑ‚ÐµÐ¼Ð½Ñ‹Ñ… Ñ‚Ð°Ð±Ð»Ð¸Ñ†...',0),(27070,752,'es','Chequeando Tablas del Sistema',0),(27071,752,'de','ÃœberprÃ¼fen die Systemtabellen...',0),(27072,752,'en','Checking system tables...',0),(27073,753,'is','',0),(27074,753,'dr','Ù…Ø­Ù„ Ø§Ø¹Ø´Ø§Ø± Ø§Ø±Ø²',0),(27075,753,'pr','Ù…Ø­Ù„ Ø§Ø¹Ø´Ø§Ø± Ø§Ø±Ø²',0),(27076,753,'tr','Para birimi ondalÄ±k basamaklar:',0),(27077,753,'pl','Waluty po przecinku:',0),(27078,753,'bg','Ð’Ð°Ð»ÑƒÑ‚Ð° Ð·Ð½Ð°Ðº ÑÐ»ÐµÐ´ Ð´ÐµÑÐµÑ‚Ð¸Ñ‡Ð½Ð°Ñ‚Ð° Ð·Ð°Ð¿ÐµÑ‚Ð°Ñ:',0),(27079,753,'ur','Ú©Ø±Ù†Ø³ÛŒ Ø§Ø¹Ø´Ø§Ø±ÛŒ Ø¬Ú¯ÛÙŠÚº:',0),(27080,753,'sr','Ð’Ð°Ð»ÑƒÑ‚Ð° Ð´ÐµÑ†Ð¸Ð¼Ð°Ð»Ðµ:',0),(27081,753,'vi','Dáº¥u tháº­p phÃ¢n tiá»n tá»‡',0),(27082,753,'af','Huidige Desimale Plekke:',0),(27083,753,'ro','Moneda zecimale:',0),(27084,753,'et','Valuuta pÃ¤rast koma:',0),(27085,753,'si','Valuta decimalnih mest:',0),(27086,753,'ba','Tempat desimal mata uang:',0),(27087,753,'nl','Valuta decimalen:',0),(27088,753,'fi','Valuutan desimaalipaikkojen mÃ¤Ã¤rÃ¤:',0),(27089,753,'no','Valuta desimaler:',0),(27090,753,'da','Valuta decimaler:',0),(27091,753,'ko','í†µí™” ì†Œìˆ˜ ìžë¦¿ìˆ˜:',0),(27092,753,'he','×ž×˜×‘×¢ ×”× ×§×•×“×” ×”×¢×©×¨×•× ×™×ª:',0),(27093,753,'el','ÎÏŒÎ¼Î¹ÏƒÎ¼Î± Î´ÎµÎºÎ±Î´Î¹ÎºÎ¬ ÏˆÎ·Ï†Î¯Î±:',0),(27094,753,'zh','è´§å¸å°æ•°ä½æ•°ï¼š\r\n',0),(27095,753,'sv','Valuta decimaler:',0),(27096,753,'it','Valuta decimale:',0),(27097,753,'tl','',0),(27098,753,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;&#3607;&#3624;&#3609;&#3636;&#3618;&#3617;',0),(27099,753,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤¦à¤¶à¤®à¤²à¤µ à¤¸à¥à¤¥à¤¾à¤¨:',0),(27100,753,'ms','Tempat perpuluhan Mata Wang:',0),(27101,753,'ar','Ø§Ù„Ø¹Ù…Ù„Ø© Ø§Ù„Ø¹Ø´Ø±ÙŠØ©:',0),(27102,753,'fr','Monnaie dÃ©cimales :',0),(27103,753,'jp','é€šè²¨å°?æ•°ç‚¹ä»¥ä¸‹ã?®æ¡?æ•°',0),(27104,753,'pt','Moeda casas decimais:',0),(27105,753,'ru','Ð’Ð°Ð»ÑŽÑ‚Ñ‹ Ð´ÐµÑÑÑ‚Ð¸Ñ‡Ð½Ñ‹Ñ… Ð·Ð½Ð°ÐºÐ¾Ð²:',0),(27106,753,'es','Moneda Puntos Decimales',0),(27107,753,'de','WÃ¤hrung Dezimalstellen:',0),(27108,753,'en','Currency Decimal Places:',0),(27109,754,'is','',0),(27110,754,'dr','Ø³Ù…Ø¨Ù„ Ø§Ø±Ø²',0),(27111,754,'pr','Ø³Ù…Ø¨Ù„ Ø§Ø±Ø²',0),(27112,754,'tr','Para birimi simgesi:',0),(27113,754,'pl','Symbol waluty:',0),(27114,754,'bg','Ð¡Ð¸Ð¼Ð²Ð¾Ð» Ð·Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°:',0),(27115,754,'ur','Ú©Ø±Ù†Ø³ÛŒ Ø¹Ù„Ø§Ù…Øª:',0),(27116,754,'sr','Ð¡Ð¸Ð¼Ð±Ð¾Ð» Ð²Ð°Ð»ÑƒÑ‚Ðµ:',0),(27117,754,'vi','Biá»ƒu tÆ°á»£ng tiá»n tá»‡',0),(27118,754,'af','Geldeenheid Simbool:',0),(27119,754,'ro','Simbol monetar:',0),(27120,754,'et','Valuuta tÃ¤his:',0),(27121,754,'si','Simbol valute:',0),(27122,754,'ba','Simbol mata uang:',0),(27123,754,'nl','Valutasymbool:',0),(27124,754,'fi','RahayksikÃ¶n tunnus:',0),(27125,754,'no','Valutasymbol:',0),(27126,754,'da','Valutasymbol:',0),(27127,754,'ko','í†µí™” ê¸°í˜¸:',0),(27128,754,'he','×¡×ž×œ ×ž×˜×‘×¢:',0),(27129,754,'el','Î£ÏÎ¼Î²Î¿Î»Î¿ Î½Î¿Î¼Î¯ÏƒÎ¼Î±Ï„Î¿Ï‚:',0),(27130,754,'zh','è´§å¸ç¬¦å·',0),(27131,754,'sv','Valutasymbolen:',0),(27132,754,'it','Simbolo di valuta:',0),(27133,754,'tl','',0),(27134,754,'th','&#3626;&#3633;&#3597;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;  :\n',0),(27135,754,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¥€à¤•:',0),(27136,754,'ms','Simbol Mata Wang:',0),(27137,754,'ar','Ø±Ù…Ø² Ø§Ù„Ø¹Ù…Ù„Ø©:',0),(27138,754,'fr','Symbole monÃ©taire :',0),(27139,754,'jp','é€šè²¨æ–‡å­—',0),(27140,754,'pt','SÃ­mbolo de moeda:',0),(27141,754,'ru','Ð¡Ð¸Ð¼Ð²Ð¾Ð» Ð²Ð°Ð»ÑŽÑ‚Ñ‹:',0),(27142,754,'es','SÃ­mbolo de Moneda',0),(27143,754,'de','WÃ¤hrungssymbol:',0),(27144,754,'en','Currency Symbol:',0),(27145,755,'is','',0),(27146,755,'dr','Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(27147,755,'pr','Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(27148,755,'tr','VeritabanÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(27149,755,'pl','Baza danych zostaÅ‚a pomyÅ›lnie zaktualizowana!',0),(27150,755,'bg','Ð‘Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾!',0),(27151,755,'ur','ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’!',0),(27152,755,'sr','Ð‘Ð°Ð·Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½!',0),(27153,755,'vi','Dá»¯ Liá»‡u Cáº­p Nháº­t ThÃ nh CÃ´ng',0),(27154,755,'af','Die databasis is suksesvol opdateer!',0),(27155,755,'ro','Baza de date a fost actualizat cu succes!',0),(27156,755,'et','Andmebaas uuendati edukalt',0),(27157,755,'si','Zbirka podatkov je bila uspeÅ¡no posodobljena!',0),(27158,755,'ba','Database telah berhasil diperbarui!',0),(27159,755,'nl','De database is succesvol bijgewerkt!',0),(27160,755,'fi','Tietokannan pÃ¤ivitys onnistui!',0),(27161,755,'no','Databasen oppdatert er!',0),(27162,755,'da','Databasen er blevet opdateret!',0),(27163,755,'ko','ë°ì´í„°ë² ì´ìŠ¤ê°€ëŠ” ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤!',0),(27164,755,'he','×ž×¡×“ ×”× ×ª×•× ×™× ×¢×•×“×›× ×” ×‘×”×¦×œ×—×”!',0),(27165,755,'el','Î— Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î­Ï‡ÎµÎ¹ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±!',0),(27166,755,'zh','è¯¥æ•°æ®åº“å·²æˆåŠŸæ›´æ–°ï¼\r\n',0),(27167,755,'sv','Databasen har uppdaterats!',0),(27168,755,'it','Il database Ã¨ stato aggiornato con successo!',0),(27169,755,'tl','',0),(27170,755,'th','&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3652;&#3604;&#3657;&#3607;&#3635;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;&#3649;&#3621;&#3657;&#3623;',0),(27171,755,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ!',0),(27172,755,'ms','Pangkalan data ini telah berjaya dikemaskini!',0),(27173,755,'ar','ØªÙ… ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø¨Ù†Ø¬Ø§Ø­!',0),(27174,755,'fr','La base de donnÃ©es a Ã©tÃ© mis Ã  jour avec succÃ¨s !',0),(27175,755,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(27176,755,'pt','O banco de dados foi atualizado com sucesso!',0),(27177,755,'ru','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð±Ñ‹Ð»Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°!',0),(27178,755,'es','La base de datos se actualizÃ³ exitosamente',0),(27179,755,'de','Die Datenbank wurde erfolgreich aktualisiert!',0),(27180,755,'en','The database has been successfully updated!',0),(27181,756,'is','',0),(27182,756,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³ØªÙˆÙ† ',0),(27183,756,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³ØªÙˆÙ† ',0),(27184,756,'tr','Hata ekleme sÃ¼tun',0),(27185,756,'pl','Dodawanie kolumna bÅ‚Ä…d',0),(27186,756,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð”Ð¾Ð±Ð°Ð²Ð¸ ÐºÐ¾Ð»Ð¾Ð½Ð°',0),(27187,756,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Ø§Ù„Ù…',0),(27188,756,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÐºÐ¾Ð»Ð¾Ð½Ðµ',0),(27189,756,'vi','Lá»—i thÃªm cá»™t',0),(27190,756,'af','Fout het ontstaan met die byvoeging van \'n kolom',0),(27191,756,'ro','Eroare adÄƒugarea coloana',0),(27192,756,'et','Viga lisades veerg',0),(27193,756,'si','Napaka pri dodajanju stolpec',0),(27194,756,'ba','Kesalahan menambahkan kolom',0),(27195,756,'nl','Fout toe te voegen kolom',0),(27196,756,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ sarake',0),(27197,756,'no','Feil Ã¥ legge til kolonnen',0),(27198,756,'da','Fejl tilfÃ¸jer kolonne',0),(27199,756,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì—´',0),(27200,756,'he','×©×’×™××” ×”×•×¡×¤×ª ×¢×ž×•×“×”',0),(27201,756,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î®Î»Î·Ï‚ ÏƒÏ†Î¬Î»Î¼Î±',0),(27202,756,'zh','æ•°æ®åº“çš„é”™è¯¯åˆ—é…åŠ \r\n',0),(27203,756,'sv','Fel att lÃ¤gga till kolumnen',0),(27204,756,'it','Errore aggiunta colonna',0),(27205,756,'tl','',0),(27206,756,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(27207,756,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤¸à¥à¤¤à¤‚à¤­',0),(27208,756,'ms','Ralat menambah lajur',0),(27209,756,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¹Ù…ÙˆØ¯',0),(27210,756,'fr','Erreur ajout colonne',0),(27211,756,'jp','æ¬„ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(27212,756,'pt','Erro adicionando coluna',0),(27213,756,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ¾Ð»Ð¾Ð½ÐºÐ¸',0),(27214,756,'es','Error agregando columna',0),(27215,756,'de','HinzufÃ¼gen von Fehlerspalte',0),(27216,756,'en','Error adding column',0),(27217,757,'is','',0),(27218,757,'dr','Ø®Ø·Ø§ Ø¯Ø± ØªØºÙŠÙŠØ± Ø³ØªÙˆÙ† Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(27219,757,'pr','Ø®Ø·Ø§ Ø¯Ø± ØªØºÙŠÙŠØ± Ø³ØªÙˆÙ† Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(27220,757,'tr','Hata deÄŸiÅŸen sÃ¼tun',0),(27221,757,'pl','Zmiana kolumna bÅ‚Ä…d',0),(27222,757,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° ÐºÐ¾Ð»Ð¾Ð½Ð°',0),(27223,757,'ur','Ù†Ù‚Øµ Ø¨Ø¯Ù„ØªÛ’ ÛÙˆØ¦Û’ Ú©Ø§Ù„Ù…',0),(27224,757,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° ÐºÐ¾Ð»Ð¾Ð½Ð° Ð³Ñ€ÐµÑˆÐºÐµ',0),(27225,757,'vi','Lá»—i Ä‘á»•i cá»™t',0),(27226,757,'af','\'n Fout het ontstaan met die verandering van kolom',0),(27227,757,'ro','Coloana schimbÄƒtoare de eroare',0),(27228,757,'et','Viga muutuvate veerg',0),(27229,757,'si','Napaka spreminjanje stolpcev',0),(27230,757,'ba','Kesalahan mengubah kolom',0),(27231,757,'nl','Fout veranderende kolom',0),(27232,757,'fi','Virhe muuttaa sarakkeen',0),(27233,757,'no','Feil endring sÃ¸ylen',0),(27234,757,'da','Fejl skiftende kolonne',0),(27235,757,'ko','ì˜¤ë¥˜ ë³€í™” ì—´',0),(27236,757,'he','×©×’×™××ª ×©×™× ×•×™ ×¢×ž×•×“×”',0),(27237,757,'el','Î›Î¬Î¸Î¿Ï‚ Î¼ÎµÏ„Î±Î²Î±Î»Î»ÏŒÎ¼ÎµÎ½Î¿ ÏƒÏ„Î®Î»Î·',0),(27238,757,'zh','é”™è¯¯æ›´æ”¹åˆ—\r\n',0),(27239,757,'sv','Fel Ã¤ndra kolumn',0),(27240,757,'it','Errore cambiando colonna',0),(27241,757,'tl','',0),(27242,757,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(27243,757,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¤¶à¥€à¤² à¤¸à¥à¤¤à¤‚à¤­',0),(27244,757,'ms','Kolum berubah ralat',0),(27245,757,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØºÙŠÙŠØ± Ø§Ù„Ø¹Ù…ÙˆØ¯',0),(27246,757,'fr','Colonne changeant d\'erreur',0),(27247,757,'jp','æ¬„ã?®å¤‰æ›´ã‚¨ãƒ©ãƒ¼',0),(27248,757,'pt','Coluna mudanÃ§a de erro',0),(27249,757,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¸ ÐºÐ¾Ð»Ð¾Ð½ÐºÐ¸',0),(27250,757,'es','Error cambiando columna',0),(27251,757,'de','Ã„ndernden Fehlerspalte',0),(27252,757,'en','Error changing column',0),(27253,758,'is','',0),(27254,758,'dr','Ø®Ø·Ø§ Ø¯Ø± ØªØºÙŠÙŠØ± Ù†ÙˆØ¹  Ø¬Ø¯ÙˆÙ„ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ',0),(27255,758,'pr','Ø®Ø·Ø§ Ø¯Ø± ØªØºÙŠÙŠØ± Ù†ÙˆØ¹  Ø¬Ø¯ÙˆÙ„ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ',0),(27256,758,'tr','Hata deÄŸiÅŸen tablo tÃ¼rÃ¼ iÃ§in',0),(27257,758,'pl','BÅ‚Ä…d zmienia typ tabela dla',0),(27258,758,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ñ‚Ð¸Ð¿ Ð³Ñ€ÐµÑˆÐºÐ° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° Ð·Ð°',0),(27259,758,'ur','Ù†Ù‚Øµ Ø¨Ø¯Ù„ØªÛ’ ÛÙˆØ¦Û’ Ù…ÛŒØ² Ù‚Ø³Ù… Ú©Û’ Ù„ÛŒÛ’',0),(27260,758,'sr','Ð—Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñƒ ÑÑ‚Ð¾ Ñ‚Ð¸Ð¿ Ð³Ñ€ÐµÑˆÐºÐµ',0),(27261,758,'vi','Lá»—i Ä‘á»•i loáº¡i báº£ng',0),(27262,758,'af','Fout mer verandering van tabeltipe vir',0),(27263,758,'ro','Eroare schimba tipul de masÄƒ pentru',0),(27264,758,'et','Viga muutuvate tabeli tÃ¼Ã¼p',0),(27265,758,'si','Napaka spreminjanje tabele za',0),(27266,758,'ba','Kesalahan mengubah tabel jenis untuk',0),(27267,758,'nl','Fout veranderende tabelweergavetype voor',0),(27268,758,'fi','Virhe muuttaa taulukon tyyppi',0),(27269,758,'no','Feil endring tabelltype for',0),(27270,758,'da','Fejl skiftende tabeltype for',0),(27271,758,'ko','ì˜¤ë¥˜ì— ëŒ€ í•œ ë³€ê²½ í…Œì´ë¸” í˜•ì‹',0),(27272,758,'he','×©×’×™××” ×”×˜×‘×œ×” ×ž×©×ª× ×” ×œ×¡×•×’',0),(27273,758,'el','Î›Î¬Î¸Î¿Ï‚ Î¼ÎµÏ„Î±Î²Î±Î»Î»ÏŒÎ¼ÎµÎ½Î¿ Ï€Î¯Î½Î±ÎºÎ± Ï„ÏÏ€Î¿Ï… Î³Î¹Î±',0),(27274,758,'zh','è¡¨åž‹æ”¹å˜é”™è¯¯\r\n',0),(27275,758,'sv','Ã„ndra tabellen feltyp fÃ¶r',0),(27276,758,'it','Cambia tipo di tabella errore',0),(27277,758,'tl','',0),(27278,758,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(27279,758,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¤¶à¥€à¤² à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤',0),(27280,758,'ms','Ralat jenis Jadual perubahan untuk',0),(27281,758,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØºÙŠÙŠØ± Ù†ÙˆØ¹ Ø¬Ø¯ÙˆÙ„',0),(27282,758,'fr','Type de table changeant d\'erreur pour',0),(27283,758,'jp','è¡¨ã‚¿ã‚¤ãƒ—ã?®å¤‰æ›´ã‚¨ãƒ©ãƒ¼',0),(27284,758,'pt','Tipo de erro tabela mudando para',0),(27285,758,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ñ‚Ð¸Ð¿Ð° Ð´Ð»Ñ',0),(27286,758,'es','Error cambiando tipo de tabla para',0),(27287,758,'de','Fehlertyp Ã¤ndernden Tabelle fÃ¼r',0),(27288,758,'en','Error changing table type for',0),(27289,759,'is','',0),(27290,759,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ø¬Ø¯ÙŠØ¯ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(27291,759,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ø¬Ø¯ÙŠØ¯ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(27292,759,'tr','Hata oluÅŸturma yeni bir tablo',0),(27293,759,'pl','Tworzenie nowej tabela bÅ‚Ä…d',0),(27294,759,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(27295,759,'ur','Ù†Ù‚Øµ Ø¨Ù†Ø§Ù†Û’ Ù†ÛŒØ§ Ø¬Ø¯ÙˆÙ„',0),(27296,759,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ñ‚Ð°Ð±ÐµÐ»Ðµ Ð³Ñ€ÐµÑˆÐºÐµ',0),(27297,759,'vi','Lá»—i táº¡o báº£ng má»›i',0),(27298,759,'af','Fout met skep van nuwe tabel',0),(27299,759,'ro','Eroare creare tabel nou',0),(27300,759,'et','Uue tabeli loomisel tekkis viga',0),(27301,759,'si','Napaka ustvarjanja nove tabele',0),(27302,759,'ba','Kesalahan membuat tabel baru',0),(27303,759,'nl','Fout maken nieuwe tabel',0),(27304,759,'fi','Virhe luotaessa uusi taulukko',0),(27305,759,'no','Feil skaper ny tabell',0),(27306,759,'da','Fejl skaber ny tabel',0),(27307,759,'ko','ì˜¤ë¥˜ ë§Œë“¤ê¸° ìƒˆ í…Œì´ë¸”',0),(27308,759,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×”×˜×‘×œ×” ×”×—×“×©×”',0),(27309,759,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î½Î­Î¿Ï… Ï€Î¯Î½Î±ÎºÎ± ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½',0),(27310,759,'zh','é”™è¯¯åˆ›å»ºæ–°è¡¨\r\n',0),(27311,759,'sv','Fel att skapa ny tabell',0),(27312,759,'it','Creazione tabella nuovo Errori',0),(27313,759,'tl','',0),(27314,759,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(27315,759,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤¨à¤ˆ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(27316,759,'ms','Ralat mencipta jadual baru',0),(27317,759,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(27318,759,'fr','Table nouvelle crÃ©ation d\'erreurs',0),(27319,759,'jp','æ–°è¦?è¡¨ã?®ä½œæˆ?ã‚¨ãƒ©ãƒ¼',0),(27320,759,'pt','Criar nova tabela de erro',0),(27321,759,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ Ð½Ð¾Ð²Ð¾Ð¹ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(27322,759,'es','Error creando nueva tabla',0),(27323,759,'de','Fehler beim Erstellen von neuen Tabelle',0),(27324,759,'en','Error creating new table',0),(27325,760,'is','',0),(27326,760,'dr','( Ø§Ù†Ø¯Ø§Ø®ØªÙ† ) Ø¬Ø¯ÙˆÙ„ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(27327,760,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù ( Ø§Ù†Ø¯Ø§Ø®ØªÙ† ) Ø¬Ø¯ÙˆÙ„ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(27328,760,'tr','Hata bÄ±rakarak tablo',0),(27329,760,'pl','BÅ‚Ä…d upuszczanie tabela',0),(27330,760,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ñ‚Ð¿Ð°Ð´Ð°Ð½Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(27331,760,'ur','Ù†Ù‚Øµ Ø¢Ù†Û’ Ø¬Ø¯ÙˆÙ„',0),(27332,760,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ð°Ð´Ð° Ñ‚Ð°Ð±ÐµÐ»Ðµ',0),(27333,760,'vi','Lá»—i tháº£ báº£ng',0),(27334,760,'af','Fout val tabel',0),(27335,760,'ro','Tabel de cÄƒdere eroare',0),(27336,760,'et','TÃµrge kukkumine tabel',0),(27337,760,'si','Napaka kapljanje tabele',0),(27338,760,'ba','Kesalahan menjatuhkan tabel',0),(27339,760,'nl','Fout dropping tabel',0),(27340,760,'fi','Pudottamalla Virhetaulukon',0),(27341,760,'no','Feil slippe tabell',0),(27342,760,'da','Fejl faldende bordet',0),(27343,760,'ko','ì˜¤ë¥˜ ë“œë¡­ í…Œì´ë¸”',0),(27344,760,'he','×©×’×™××” ×œ×¦× ×™×—×ª ×˜×‘×œ×”',0),(27345,760,'el','Î¡Î¯ÏˆÎ· Ï€Î¯Î½Î±ÎºÎ± ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½',0),(27346,760,'zh','è¡¨é”™è¯¯ä¸‹é™\r\n',0),(27347,760,'sv','Fel slÃ¤ppa tabell',0),(27348,760,'it','Tabella di eliminazione Errori',0),(27349,760,'tl','',0),(27350,760,'th','&#3585;&#3634;&#3619;&#3623;&#3634;&#3591;&#3648;&#3609;&#3639;&#3657;&#3629;&#3627;&#3634;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(27351,760,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤›à¥‹à¤¡à¤¼à¤¨à¥‡ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(27352,760,'ms','Ralat menjatuhkan Jadual',0),(27353,760,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(27354,760,'fr','Table de largage des erreurs',0),(27355,760,'jp','Error dropping table',0),(27356,760,'pt','Tabela de queda de erros',0),(27357,760,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(27358,760,'es','Error eliminando tabla',0),(27359,760,'de','Dropping Fehlertabelle',0),(27360,760,'en','Error dropping table',0),(27361,761,'is','',0),(27362,761,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¯Ø±ÙŠØ§ÙØª ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ',0),(27363,761,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¯Ø±ÙŠØ§ÙØª ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ',0),(27364,761,'tr','Hata alma varsayÄ±lan deÄŸerleri',0),(27365,761,'pl','BÅ‚Ä…d pobierania wartoÅ›ci domyÅ›lnych dla',0),(27366,761,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð°',0),(27367,761,'ur','Ù†Ù‚Øµ Ø­ØµÙˆÙ„ Ø·Û’ Ø´Ø¯Û Ù‚Ø¯Ø±ÙˆÚº Ú©Û’ Ù„ÛŒÛ’',0),(27368,761,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð¸Ñ˜Ð°ÑšÑƒ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸Ñ… Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(27369,761,'vi','Lá»—i khi láº¥y giÃ¡ trá»‹ máº·c Ä‘á»‹nh cho',0),(27370,761,'af','Fout met verkryging van verstekte waardes vir',0),(27371,761,'ro','Eroare obtinerea valorile implicite pentru',0),(27372,761,'et','Viga saada vaikevÃ¤Ã¤rtuste jaoks',0),(27373,761,'si','Napaka pri pridobivanju privzete vrednosti za',0),(27374,761,'ba','Kesalahan nilai default persiapan untuk',0),(27375,761,'nl','Fout krijgen standaardwaarden voor',0),(27376,761,'fi','Virhe haettaessa oletusarvot',0),(27377,761,'no','Feil komme standardverdier for',0),(27378,761,'da','Fejl at fÃ¥ standardvÃ¦rdier for',0),(27379,761,'ko','ì˜¤ë¥˜ì— ëŒ€ í•œ ì ì  ê¸°ë³¸ê°’',0),(27380,761,'he','×©×’×™××” ×ž×§×‘×œ ×¢×¨×›×™ ×‘×¨×™×¨×ª ×ž×—×“×œ ×¢×‘×•×¨',0),(27381,761,'el','Î£Ï†Î¬Î»Î¼Î± Î½Î± Ï€Î¬ÏÎµÎ¹ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Ï„Î¹Î¼Î­Ï‚ Î³Î¹Î±',0),(27382,761,'zh','å‘ç”Ÿé”™è¯¯çš„é»˜è®¤å€¼\r\n',0),(27383,761,'sv','Fel att fÃ¥ standardvÃ¤rden fÃ¶r',0),(27384,761,'it','Errore ricevendo i valori predefiniti per',0),(27385,761,'tl','',0),(27386,761,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3588;&#3656;&#3634;&#3614;&#3639;&#3657;&#3609;&#3',0),(27387,761,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¹à¥‹ à¤°à¤¹à¥€ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¤¾à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤',0),(27388,761,'ms','Nilai lalai daripada mendapat ralat untuk',0),(27389,761,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¬Ø§Ø¹ Ø§Ù„Ù‚ÙŠÙ… Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ù„Ø¬Ø¯ÙˆÙ„',0),(27390,761,'fr','Valeurs par dÃ©faut d\'obtention d\'erreur pour',0),(27391,761,'jp','ï½žã?®ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆå€¤ã?®å?–å¾—ã‚¨ãƒ©ãƒ¼',0),(27392,761,'pt','Valores de erro padrÃ£o ficando para',0),(27393,761,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ',0),(27394,761,'es','Error agarrando valores por defecto para',0),(27395,761,'de','Fehler immer Standardwerte fÃ¼r',0),(27396,761,'en','Error getting default values for',0),(27397,762,'is','',0),(27398,762,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¯Ø±ÙŠØ§ÙØª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡Ø§  Ø¨Ø±Ø§ÙŠ ',0),(27399,762,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¯Ø±ÙŠØ§ÙØª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡Ø§  Ø¨Ø±Ø§ÙŠ ',0),(27400,762,'tr','Hata alma tablosu oluÅŸturmak iÃ§in haberdar etmek',0),(27401,762,'pl','Coraz tabela bÅ‚Ä…d tworzenia informacji dla',0),(27402,762,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð°',0),(27403,762,'ur','Ù†Ù‚Øµ Ø­ØµÙˆÙ„ Ø¬Ø¯ÙˆÙ„ Ø¨Ù†Ø§Ø¦ÛŒÚº Ú©Û’ Ù„ÛŒÛ’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(27404,762,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ñ‚Ð°Ð±ÐµÐ»Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ Ð¸Ð½Ñ„Ð¾ Ð·Ð°',0),(27405,762,'vi','Lá»—i khi táº¡o báº£ng thÃ´ng tin cho',0),(27406,762,'af','Fout mer verkryging van tabel skeppingsinligting vir',0),(27407,762,'ro','Eroare obtinerea tabel creeazÄƒ informaÅ£ii pentru',0),(27408,762,'et','Viga saada tabeli luua info eest',0),(27409,762,'si','Napaka pridobivanje tabele ustvarite info za',0),(27410,762,'ba','Tabel mendapatkan kesalahan membuat info untuk',0),(27411,762,'nl','Fout krijgen tabel maken info voor',0),(27412,762,'fi','Virhetaulukon hakeminen luoda info',0),(27413,762,'no','Feil Ã¥ opprette informasjon for',0),(27414,762,'da','Fejl at fÃ¥ tabel oprette info for',0),(27415,762,'ko','ì˜¤ë¥˜ ê°€ì ¸ì˜¤ëŠ” í…Œì´ë¸” ë§Œë“¤ê¸°ì— ëŒ€ í•œ ì •ë³´',0),(27416,762,'he','×©×•×œ×—×Ÿ ×ž×§×‘×œ ×©×’×™××” ×œ×™×¦×•×¨ ×¤×¨×˜×™ ×¢×‘×•×¨',0),(27417,762,'el','ÎÎ± Ï€Î¬ÏÎµÎ¹ Ï€Î¯Î½Î±ÎºÎ± ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î±',0),(27418,762,'zh','é”™è¯¯ä½¿ç”¨è¡¨åˆ›å»ºä¿¡æ¯\r\n',0),(27419,762,'sv','Fel att fÃ¥ bord skapa information fÃ¶r',0),(27420,762,'it','Tavolo ricevendo errore creare informazioni per',0),(27421,762,'tl','',0),(27422,762,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;&#3586;&#3657;&#3629;&#3',0),(27423,762,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¹à¥‹ à¤°à¤¹à¥€ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(27424,762,'ms','Jadual mendapat ralat mencipta maklumat untuk',0),(27425,762,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¬Ø§Ø¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(27426,762,'fr','Table d\'erreurs se crÃ©er d\'informations pour',0),(27427,762,'jp','ï½žã?®è¡¨ä½œæˆ?æƒ…å ±ã?®å?–å¾—ã‚¨ãƒ©ãƒ¼',0),(27428,762,'pt','A tabela de erro criar informaÃ§Ã£o para',0),(27429,762,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ ÑÐ¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð»Ñ',0),(27430,762,'es','Error agarrando Info de crear tabla para',0),(27431,762,'de','Immer Error-Tabelle erstellen-Info Ã¼ber',0),(27432,762,'en','Error getting table create info for',0),(27433,763,'is','',0),(27434,763,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ù†  ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø®ÙˆØ¯ÙƒØ§Ø± Ø¯Ø± ',0),(27435,763,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ù†  ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø®ÙˆØ¯ÙƒØ§Ø± Ø¯Ø± ',0),(27436,763,'tr','VarsayÄ±lan deÄŸerleri iÃ§ine ekleme hatasÄ±',0),(27437,763,'pl','BÅ‚Ä…d wstawiania wartoÅ›ci domyÅ›lne w',0),(27438,763,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð²',0),(27439,763,'ur','Ø·Û’ Ø´Ø¯Û Ù‚Ø¯Ø±ÙˆÚº Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(27440,763,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ¼ÐµÑ‚Ð°ÑšÑƒ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ñƒ',0),(27441,763,'vi','Lá»—i cho thÃ´ng tin giÃ¡ trá»‹ máº·c Ä‘á»‹nh',0),(27442,763,'af','Fout met invoeging van verstekte waardes binne',0),(27443,763,'ro','Eroare introducÃ¢nd valori implicite Ã®n',0),(27444,763,'et','VaikevÃ¤Ã¤rtused vÃµetakse lisamisel tÃµrge',0),(27445,763,'si','Pri vstavljanju privzete vrednosti v',0),(27446,763,'ba','Kesalahan memasukkan nilai-nilai default ke',0),(27447,763,'nl','Error invoegen standaardwaarden in',0),(27448,763,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ oletusarvot otetaan',0),(27449,763,'no','Feil under innsetting standardverdier i',0),(27450,763,'da','Fejl indsÃ¦tte standardvÃ¦rdierne i',0),(27451,763,'ko','ê¸°ë³¸ ê°’ìœ¼ë¡œ ì‚½ìž… ì˜¤ë¥˜',0),(27452,763,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×¢×¨×›×™ ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×œ×ª×•×š',0),(27453,763,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Ï‰Î½ Ï„Î¹Î¼ÏŽÎ½ ÏƒÎµ',0),(27454,763,'zh','é»˜è®¤å€¼é”™è¯¯æ’å…¥\r\n',0),(27455,763,'sv','Fel att sÃ¤tta in standardvÃ¤rden i',0),(27456,763,'it','Errore di inserimento di valori predefiniti in',0),(27457,763,'tl','',0),(27458,763,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3656;&#3634;&#3614;&#3639;&#3657;&#3609;&#3600;&#3',0),(27459,763,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¤¾à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(27460,763,'ms','Kesilapan memasukkan nilai-nilai lalai ke dalam',0),(27461,763,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù‚ÙŠÙ… Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ø¥Ù„Ù‰',0),(27462,763,'fr','Erreur insertion de valeurs par dÃ©faut dans',0),(27463,763,'jp','ï½žã?¸ã?®ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆå€¤æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(27464,763,'pt','Erro de inserÃ§Ã£o de valores padrÃ£o em',0),(27465,763,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ð¹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð²',0),(27466,763,'es','Error insertando valores por defecto a',0),(27467,763,'de','EinfÃ¼gen von Standardwerten in Fehler',0),(27468,763,'en','Error inserting default values into',0),(27469,764,'is','',0),(27470,764,'dr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠÙŠ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´  ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(27471,764,'pr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠÙŠ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´  ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(27472,764,'tr','GÃ¶rÃ¼ntÃ¼lenecek fiziksel envanterinde hiÃ§bir Ã¶ÄŸe vardÄ±r.',0),(27473,764,'pl','Nie ma Å¼adnych towarÃ³w w magazynie fizycznym do wyÅ›wietlania.',0),(27474,764,'bg','ÐÑÐ¼Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð²ÑŠÐ² Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸Ñ‚Ðµ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð·Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ.',0),(27475,764,'ur','Ø¯Ú©Ú¾Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…ÛŒÚº Ú©ÙˆØ¦ÛŒ Ø´Û’ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(27476,764,'sr','ÐÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ð¾Ð¿Ð¸ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ñƒ.',0),(27477,764,'vi','KhÃ´ng cÃ³ hÃ ng thá»±c táº¿ trong kho hiá»ƒn thá»‹',0),(27478,764,'af','Daar is geen items in fisiese Voorraad om te wys.',0),(27479,764,'ro','Nu sunt articole Ã®n inventar fizic pentru a afiÅŸa.',0),(27480,764,'et','FÃ¼Ã¼silise kaubavaru kuvamiseks pole Ã¼ksusi.',0),(27481,764,'si','Ni nobenih elementov v fiziÄni inventar razpoloÅ¾iti.',0),(27482,764,'ba','Ada tidak ada item dalam persediaan fisik untuk menampilkan.',0),(27483,764,'nl','Er zijn geen objecten in de fysieke voorraad om weer te geven.',0),(27484,764,'fi','NÃ¤ytettÃ¤viÃ¤ kohteita ei ole fyysinen varasto nÃ¤yttÃ¤Ã¤.',0),(27485,764,'no','Det finnes ingen elementer i vareopptellingen skal vises.',0),(27486,764,'da','Der er ingen elementer i lageropgÃ¸relse til at vise.',0),(27487,764,'ko','ì‹¤ì œ ìž¬ê³ ë¥¼ í‘œì‹œ í•˜ëŠ” í•­ëª©ì´ ì—†ìŠµë‹ˆë‹¤.',0),(27488,764,'he','×œ× ×§×™×™×ž×™× ×¤×¨×™×˜×™× ×‘×ž×œ××™ ×”×¤×™×–×™ ×›×“×™ ×œ×”×¦×™×’.',0),(27489,764,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏ„Î· Ï†Ï…ÏƒÎ¹ÎºÎ® Î±Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÎ¼Ï†Î±Î½Î¯Î¶Ï‰.',0),(27490,764,'zh','å®žé™…åº“å­˜ä¸­æ²¡æœ‰æ˜¾ç¤ºä»»ä½•é¡¹ç›®ã€‚\r\n',0),(27491,764,'sv','Det finns inga objekt i fysiska lagret ska visas.',0),(27492,764,'it','Esistono elementi nell\'inventario fisico da visualizzare.',0),(27493,764,'tl','',0),(27494,764,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3651;&#3609;&#3588;&#3621;&#3633;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3626;&#3',0),(27495,764,'hi','à¤­à¥Œà¤¤à¤¿à¤• à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¤‚à¥¤',0),(27496,764,'ms','Terdapat tiada item dalam inventori fizikal untuk dipaparkan.',0),(27497,764,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙŠ Ø¹Ù†Ø§ØµØ± ÙÙŠ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø§Ø¯ÙŠ Ù„Ø¹Ø±Ø¶.',0),(27498,764,'fr','Il n\'y a aucun Ã©lÃ©ment dans l\'inventaire pour afficher.',0),(27499,764,'jp','æœŸæœ«æ£šå?¸ã?®ä¸­ã?«ã?¯è¡¨ç¤ºã?™ã‚‹å“?ç›®ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(27500,764,'pt','NÃ£o existem itens no inventÃ¡rio fÃ­sico para exibir.',0),(27501,764,'ru','ÐÐµÑ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð´Ð»Ñ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ.',0),(27502,764,'es','No hay items en el inventario fÃ­sico para desplegar',0),(27503,764,'de','Es gibt keine Elemente in der Inventur angezeigt.',0),(27504,764,'en','There are no items in physical inventory to display.',0),(27505,765,'is','',0),(27506,765,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø² ÙŠØ§Ø¨ÙŠ Ø³ØªÙˆÙ† Ù‡Ø§ÙŠ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø§Ø² ',0),(27507,765,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø² ÙŠØ§Ø¨ÙŠ Ø³ØªÙˆÙ† Ù‡Ø§ÙŠ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø§Ø² ',0),(27508,765,'tr','SÃ¼tunlarÄ±ndan alÄ±nÄ±rken hata oluÅŸtu',0),(27509,765,'pl','BÅ‚Ä…d podczas pobierania kolumn z',0),(27510,765,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¾Ð½Ð¸ Ð¾Ñ‚',0),(27511,765,'ur','Ú©Ø§Ù„Ù… Ø³Û’ Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(27512,765,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð¸Ð·',0),(27513,765,'vi','Lá»—i truy váº¥n cá»™t tá»«',0),(27514,765,'af','Fout kolomme van herwinning',0),(27515,765,'ro','Eroare recuperare coloane din',0),(27516,765,'et','TÃµrge allalaadimisel standardveerud',0),(27517,765,'si','Napaka pri pridobivanju stolpce iz',0),(27518,765,'ba','Mengambil kolom dari kesalahan',0),(27519,765,'nl','Fout bij het ophalen van kolommen uit',0),(27520,765,'fi','Virhe haettaessa perussarakkeet',0),(27521,765,'no','Feil under henting av kolonner fra',0),(27522,765,'da','Fejl under hentning af kolonner fra',0),(27523,765,'ko','ì—´ì—ì„œ ê²€ìƒ‰ ì˜¤ë¥˜',0),(27524,765,'he','×©×’×™××” ×‘××—×–×•×¨ ×¢×ž×•×“×•×ª ×ž×ª×•×š',0),(27525,765,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· ÏƒÏ„Î®Î»ÎµÏ‚ Î±Ï€ÏŒ',0),(27526,765,'zh','é”™è¯¯æ£€ç´¢åˆ—\r\n',0),(27527,765,'sv','Fel vid hÃ¤mtning av kolumner frÃ¥n',0),(27528,765,'it','Errore nel recupero di colonne da',0),(27529,765,'tl','',0),(27530,765,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3588;&#3639;&#3609;&#3588;&#3629;&#3621;&#3633;&#3617;&#3616;&#3660;&#3592;&#3634;&#3585;',0),(27531,765,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¥à¤¤à¤‚à¤­à¥‹à¤‚ à¤¸à¥‡ à¤ªà¥à¤¨à¤ƒà¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(27532,765,'ms','Ralat mendapatkan semula tiang dari',0),(27533,765,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¬Ø§Ø¹ Ø£Ø¹Ù…Ø¯Ø©',0),(27534,765,'fr','Erreur rÃ©cupÃ©rer colonnes de',0),(27535,765,'jp','ï½žã?®ã‚³ãƒ©ãƒ ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(27536,765,'pt','Erro ao recuperar colunas da',0),(27537,765,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð¾Ð² Ð¸Ð·',0),(27538,765,'es','Error recobrando columnas de',0),(27539,765,'de','Fehler beim Abrufen von Spalten aus',0),(27540,765,'en','Error retrieving columns from',0),(27541,766,'is','',0),(27542,766,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø² ÙŠØ§Ø¨ÙŠ Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ø²  Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(27543,766,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø² ÙŠØ§Ø¨ÙŠ Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ø²  Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(27544,766,'tr','Ã–zgÃ¼n veritabanÄ±ndan tablolar alÄ±nÄ±rken bir hata oluÅŸtu.',0),(27545,766,'pl','BÅ‚Ä…d podczas pobierania tabele z oryginalnej bazy danych.',0),(27546,766,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð¸ Ð¾Ñ‚ Ð¿ÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸.',0),(27547,766,'ur','Ø¬Ø¯Ø§ÙˆÙ„ Ø§ØµÙ„ Ú©ÙˆØ§Ø¦ÙÛŒÛ Ø³Û’ Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ Û”',0),(27548,766,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ñ‚Ð°Ð±ÐµÐ»Ðµ Ð¸Ð· Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ðµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°.',0),(27549,766,'vi','Lá»—i truy váº¥n báº£ng tá»« dá»¯ liá»‡u gá»‘c',0),(27550,766,'af','Fout met herwinning van tabelle vanuit oorspronklike databasis.',0),(27551,766,'ro','Eroare la regÄƒsirea tabelelor din baza de date iniÅ£ialÄƒ.',0),(27552,766,'et','TÃµrge allalaadimisel tabelite lÃ¤hteandmebaasist.',0),(27553,766,'si','Napaka pri pridobivanju tabel iz originalne podatkovne zbirke.',0),(27554,766,'ba','Kesalahan mengambil tabel dari database asli.',0),(27555,766,'nl','Fout bij het ophalen van tabellen uit de oorspronkelijke database.',0),(27556,766,'fi','Virhe haettaessa taulukot alkuperÃ¤isestÃ¤ tietokannasta.',0),(27557,766,'no','Feil under henting av tabeller fra opprinnelige databasen.',0),(27558,766,'da','Fejl under hentning af tabeller fra oprindelige database.',0),(27559,766,'ko','ì›ë³¸ ë°ì´í„°ë² ì´ìŠ¤ì—ì„œ í…Œì´ë¸”ì„ ê²€ìƒ‰ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(27560,766,'he','×©×’×™××” ×‘××—×–×•×¨ ×˜×‘×œ××•×ª ×ž×ž×¡×“ ×”× ×ª×•× ×™× ×”×ž×§×•×¨×™.',0),(27561,766,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï€Î¯Î½Î±ÎºÎµÏ‚ Î±Ï€ÏŒ Ï„Î·Î½ Î±ÏÏ‡Î¹ÎºÎ® Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½.',0),(27562,766,'zh','ä»ŽåŽŸæ¥çš„é”™è¯¯æ£€ç´¢æ•°æ®åº“è¡¨',0),(27563,766,'sv','Fel vid hÃ¤mtning av tabeller frÃ¥n originaldatabasen.',0),(27564,766,'it','Errore nel recupero tabelle dal database originale.',0),(27565,766,'tl','',0),(27566,766,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3588;&#3639;&#3609;&#3648;&#3609;&#3639;&#3657;&#3629;&#3627;&#3634;&#3592;&#3634;&#3585;&#3600;&#3634;&#3609;&#3586;&#3',0),(27567,766,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾à¤à¤ à¤®à¥‚à¤² à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥‡ à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(27568,766,'ms','Ralat mendapatkan jadual dari pangkalan data asal.',0),(27569,766,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¬Ø§Ø¹ Ø§Ù„Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ù† Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø£ØµÙ„ÙŠØ©.',0),(27570,766,'fr','Erreur lors de la rÃ©cupÃ©ration des tables de base de donnÃ©es originale.',0),(27571,766,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?‹ã‚‰ã?®è¡¨ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(27572,766,'pt','Erro ao recuperar tabelas de banco de dados original.',0),(27573,766,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð¸Ð· Ð¸ÑÑ…Ð¾Ð´Ð½Ð¾Ð¹ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ….',0),(27574,766,'es','Error recobrando tablas de la base de datos original',0),(27575,766,'de','Fehler beim Abrufen von Tabellen aus der ursprÃ¼nglichen Datenbank.',0),(27576,766,'en','Error retrieving tables from original database.',0),(27577,767,'is','',0),(27578,767,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø² ÙŠØ§Ø¨ÙŠ Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ø² Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…ÙˆÙ‚Øª ',0),(27579,767,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø² ÙŠØ§Ø¨ÙŠ Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ø² Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…ÙˆÙ‚Øª ',0),(27580,767,'tr','GeÃ§ici veritabanÄ±ndan tablolar alÄ±nÄ±rken bir hata oluÅŸtu.',0),(27581,767,'pl','BÅ‚Ä…d podczas pobierania tabele z tymczasowej bazy danych.',0),(27582,767,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð¸ Ð¾Ñ‚ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸.',0),(27583,767,'ur','Ø¬Ø¯Ø§ÙˆÙ„ Ø¹Ø§Ø±Ø¶ÛŒ Ú©ÙˆØ§Ø¦ÙÛŒÛ Ø³Û’ Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ Û”',0),(27584,767,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ñ‚Ð°Ð±ÐµÐ»Ðµ Ð¸Ð· Ð¿Ñ€Ð¸Ð²Ñ€ÐµÐ¼ÐµÐ½Ðµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°.',0),(27585,767,'vi','Lá»—i truy váº¥n báº£ng tá»« dá»¯ liá»‡u táº¡m thá»i',0),(27586,767,'af','Fout met herwinning van tabelle vanuit tydelike databasis.',0),(27587,767,'ro','Eroare la regÄƒsirea tabelelor din baza de date temporarÄƒ.',0),(27588,767,'et','Ajutiselt andmebaasi tabelid toomisel tÃµrge.',0),(27589,767,'si','Napaka pri pridobivanju tabel iz zaÄasne zbirke podatkov.',0),(27590,767,'ba','Kesalahan mengambil tabel dari database sementara.',0),(27591,767,'nl','Fout bij het ophalen van tabellen uit tijdelijke database.',0),(27592,767,'fi','Virhe haettaessa taulukot vÃ¤liaikaisen tietokannan.',0),(27593,767,'no','Feil under henting av tabeller fra midlertidig database.',0),(27594,767,'da','Fejl under hentning af tabeller fra midlertidige database.',0),(27595,767,'ko','ìž„ì‹œ ë°ì´í„°ë² ì´ìŠ¤ì—ì„œ í…Œì´ë¸”ì„ ê²€ìƒ‰ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(27596,767,'he','×©×’×™××” ×‘××—×–×•×¨ ×˜×‘×œ××•×ª ×ž×ž×¡×“ × ×ª×•× ×™× ×–×ž× ×™.',0),(27597,767,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï€Î¯Î½Î±ÎºÎµÏ‚ Î±Ï€ÏŒ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÏ‰ÏÎ¹Î½Î® Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½.',0),(27598,767,'zh','ä»Žä¸´æ—¶æ•°æ®åº“ä¸­é”™è¯¯æ£€ç´¢çš„è¡¨\r\n',0),(27599,767,'sv','Fel vid hÃ¤mtning av tabeller frÃ¥n temporÃ¤r databas.',0),(27600,767,'it','Errore nel recupero tabelle dal database temporaneo.',0),(27601,767,'tl','',0),(27602,767,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3588;&#3639;&#3609;&#3648;&#3609;&#3639;&#3657;&#3629;&#3627;&#3634;&#3592;&#3634;&#3585;&#3600;&#3634;&#3609;&#3586;&#3',0),(27603,767,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾à¤à¤ à¤…à¤¸à¥à¤¥à¤¾à¤¯à¥€ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥‡ à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(27604,767,'ms','Ralat mendapatkan jadual dari pangkalan data sementara.',0),(27605,767,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¬Ø§Ø¹ Ø§Ù„Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ù† Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø¤Ù‚ØªØ©.',0),(27606,767,'fr','Erreur lors de la rÃ©cupÃ©ration des tables de base de donnÃ©es temporaire.',0),(27607,767,'jp','è‡¨æ™‚ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?‹ã‚‰ã?®è¡¨ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(27608,767,'pt','Erro ao recuperar tabelas de banco de dados temporÃ¡rio.',0),(27609,767,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð¸Ð· Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾Ð¹ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ….',0),(27610,767,'es','Error recobrando tablas de la base de datos temporal',0),(27611,767,'de','Fehler beim Abrufen der Tabellen von temporÃ¤ren Datenbank.',0),(27612,767,'en','Error retrieving tables from temporary database.',0),(27613,768,'is','',0),(27614,768,'dr','ÙØ§ÙŠÙ„ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ÙŠØ§ÙØª Ù†Ø´Ø¯ ',0),(27615,768,'pr','ÙØ§ÙŠÙ„ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ÙŠØ§ÙØª Ù†Ø´Ø¯ ',0),(27616,768,'tr','VeritabanÄ± gÃ¼ncelleÅŸtirme dosyasÄ± bulunamadÄ±.',0),(27617,768,'pl','Nie znaleziono pliku aktualizacji bazy danych.',0),(27618,768,'bg','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ„Ð°Ð¹Ð» Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(27619,768,'ur','ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ø§Ù¾ ÚˆÛŒÙ¹ Ù…Ø³Ù„ Ù†ÛÛŒÚº Ù…Ù„ÛŒ Û”',0),(27620,768,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(27621,768,'vi','Há»“ sÆ¡ cáº­p nháº­t dá»¯ liá»‡u khÃ´ng tháº¥y',0),(27622,768,'af','Databasis opdatering lÃªer nie gevind nie.',0),(27623,768,'ro','FiÅŸierul de actualizare a bazei de date nu a fost gÄƒsit.',0),(27624,768,'et','Andmebaasi vÃ¤rskendamine faili ei leitud.',0),(27625,768,'si','Posodobitev datoteke zbirke podatkov ni mogoÄe najti.',0),(27626,768,'ba','Database update file tidak ditemukan.',0),(27627,768,'nl','Database update-bestand is niet gevonden.',0),(27628,768,'fi','Tietokannan pÃ¤ivitys tiedostoa ei lÃ¶ydy.',0),(27629,768,'no','Oppdatere databasefilen ikke funnet.',0),(27630,768,'da','Database opdateringsfil ikke fundet.',0),(27631,768,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì—…ë°ì´íŠ¸ íŒŒì¼ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(27632,768,'he','×œ× × ×ž×¦× ×§×•×‘×¥ ×¢×“×›×•×Ÿ ×ž×¡×“ ×”× ×ª×•× ×™×.',0),(27633,768,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ Î±ÏÏ‡ÎµÎ¯Î¿ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½.',0),(27634,768,'zh','æ•°æ®åº“æ›´æ–°æ–‡ä»¶æœªæ‰¾åˆ°',0),(27635,768,'sv','Databas uppdateringsfilen hittades inte.',0),(27636,768,'it','File di aggiornamento di database non trovato.',0),(27637,768,'tl','',0),(27638,768,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3652;&#3615;&#3621;&#3660;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(27639,768,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€à¥¤',0),(27640,768,'ms','Pangkalan data Kemaskini fail tidak dijumpai.',0),(27641,768,'ar','Ù…Ù„Ù ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯.',0),(27642,768,'fr','Fichier de mise Ã  jour de base de donnÃ©es introuvable.',0),(27643,768,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹æ›´æ–°ãƒ•ã‚¡ã‚¤ãƒ«ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(27644,768,'pt','Arquivo de atualizaÃ§Ã£o de banco de dados nÃ£o encontrado.',0),(27645,768,'ru','Ð¤Ð°Ð¹Ð» Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(27646,768,'es','Base de Datos archivo de actualizaciÃ³n no se encontrÃ³',0),(27647,768,'de','Datenbank-Update-Datei nicht gefunden.',0),(27648,768,'en','Database update file not found.',0),(27649,769,'is','',0),(27650,769,'dr','Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù† Ø§Ø³Øª â€“ Ù„Ø·ÙØ§ ØµØ¨Ø± ÙƒÙ†ÙŠØ¯ ',0),(27651,769,'pr','Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù† Ø§Ø³Øª â€“ Ù„Ø·ÙØ§ ØµØ¨Ø± ÙƒÙ†ÙŠØ¯ ',0),(27652,769,'tr','VeritabanÄ± gÃ¼ncelleÅŸtiriliyor.  LÃ¼tfen bekleyin.',0),(27653,769,'pl','Baza danych jest aktualizowana.  Czekaj.',0),(27654,769,'bg','Ð‘Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°.  ÐœÐ¾Ð»Ñ, Ð¸Ð·Ñ‡Ð°ÐºÐ°Ð¹Ñ‚Ðµ.',0),(27655,769,'ur','ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©ÛŒØ§ Ø¬Ø§ Ø±ÛØ§ ÛÛ’ Û”  Ø¨Ø±Ø§Û“ Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§Ù†ØªØ¸Ø§Ø± Ú©Ø±ÙŠÚº.',0),(27656,769,'sr','Ð‘Ð°Ð·Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÑÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°.  Ð¼Ð¾Ð»Ð¸Ð¼ Ñ‚Ðµ ÑÐ°Ñ‡ÐµÐºÐ°Ñ˜.',0),(27657,769,'vi','Dá»¯ Liá»‡u Äang Cáº­p Nháº­t. Vui LÃ²ng Chá»',0),(27658,769,'af','Databasis word opdateer.  Wag asseblief.',0),(27659,769,'ro','Baza de date este actualizat.  te rog sÄƒ aÅŸtepÅ£i.',0),(27660,769,'et','Andmebaasi uuendatakse.  Oota.',0),(27661,769,'si','Zbirka podatkov se posodablja.  poÄakaj, prosim.',0),(27662,769,'ba','Database ini sedang diperbarui.  Harap tunggu.',0),(27663,769,'nl','Database wordt bijgewerkt.  Een ogenblik geduld.',0),(27664,769,'fi','Tietokantaa pÃ¤ivitetÃ¤Ã¤n.  Ole hyvÃ¤ ja odota.',0),(27665,769,'no','Databasen oppdateres.  vent.',0),(27666,769,'da','Databasen opdateres.  Vent venligst.',0),(27667,769,'ko','ë°ì´í„°ë² ì´ìŠ¤ê°€ ì—…ë°ì´íŠ¸ ë˜ ê³  ìžˆìŠµë‹ˆë‹¤.  ìž ì‹œë§Œ ê¸°ë‹¤ë ¤ ì£¼ì‹­ì‹œì˜¤.',0),(27668,769,'he','×¢×“×›×•×Ÿ ×ž×¡×“ × ×ª×•× ×™×.  ×—×›×” ×‘×‘×§×©×”.',0),(27669,769,'el','Î’Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î±Î½Î±Î½ÎµÏŽÎ½ÎµÏ„Î±Î¹.  Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï€ÎµÏÎ¯Î¼ÎµÎ½Îµ.',0),(27670,769,'zh','æ•°æ®åº“æ­£åœ¨æ›´æ–°ã€‚è¯·ç¨å€™',0),(27671,769,'sv','Databasen uppdateras.  SnÃ¤lla vÃ¤nta.',0),(27672,769,'it','Database viene aggiornato.  Attendere prego.',0),(27673,769,'tl','',0),(27674,769,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621; &#3585;&#3619;&#3640;&#3603;&#3634;&#3619;&#3629;',0),(27675,769,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤°à¤¹à¤¾ à¤¹à¥ˆà¥¤  à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥à¤°à¤¤à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¥‹.',0),(27676,769,'ms','Pangkalan data sedang dikemaskini.  sila tunggu.',0),(27677,769,'ar','ÙŠØ¬Ø±ÙŠ ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª. ÙØ¶Ù„Ø§Ù‹ Ø§Ù†ØªØ¸Ø±.',0),(27678,769,'fr','Base de donnÃ©es est en cours d\'actualisation.  Veuillez patienter.',0),(27679,769,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚’æ›´æ–°ã?—ã?¦ã?„ã?¾ã?™ã€‚ã?—ã?°ã‚‰ã??ã?Šå¾…ã?¡ä¸‹ã?•ã?„ã€‚',0),(27680,769,'pt','Banco de dados estÃ¡ sendo atualizado.  Aguarde.',0),(27681,769,'ru','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¾Ð±Ð½Ð¾Ð²Ð»ÑÐµÑ‚ÑÑ.  ÐŸÐ¾Ð´Ð¾Ð¶Ð´Ð¸Ñ‚Ðµ.',0),(27682,769,'es','La Base de Datos se Actualiza. Por favor espere',0),(27683,769,'de','Datenbank wird aktualisiert.  Bitte warten.',0),(27684,769,'en','Database is being updated.  Please wait.',0),(27685,770,'is','',0),(27686,770,'dr','Ù…Ø­Ù„ Ø³Ø±ÙˆØ± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(27687,770,'pr','Ù…Ø­Ù„ Ø³Ø±ÙˆØ± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(27688,770,'tr','VeritabanÄ± sunucu yeri:',0),(27689,770,'pl','Lokalizacja serwera bazy danych:',0),(27690,770,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° ÑÑŠÑ€Ð²ÑŠÑ€Ð° Ð·Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸:',0),(27691,770,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù¾ÛŒØ´ Ú©Ø§Ø± Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹:',0),(27692,770,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° ÑÐµÑ€Ð²ÐµÑ€Ð° Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°:',0),(27693,770,'vi','Vá»‹ trÃ­ mÃ¡y chá»§ dá»¯ liá»‡u',0),(27694,770,'af','Databasis bediener ligging:',0),(27695,770,'ro','LocaÅ£ia Server de baze de date:',0),(27696,770,'et','Andmebaasi Server asukoht:',0),(27697,770,'si','Mesto streÅ¾nika zbirke podatkov:',0),(27698,770,'ba','Lokasi Server database:',0),(27699,770,'nl','De locatie van de Server van de database:',0),(27700,770,'fi','Tietokannan palvelimen sijainti:',0),(27701,770,'no','Databasen serverplasseringen:',0),(27702,770,'da','Database serverplacering:',0),(27703,770,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì„œë²„ ìœ„ì¹˜:',0),(27704,770,'he','×ž×™×§×•× ×”×©×¨×ª ×©×œ ×ž×¡×“ ×”× ×ª×•× ×™×:',0),(27705,770,'el','Î˜Î­ÏƒÎ· Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î® Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½:',0),(27706,770,'zh','æ•°æ®åº“æœåŠ¡å™¨ä½ç½®ï¼š\r\n',0),(27707,770,'sv','Databas serverplats:',0),(27708,770,'it','Percorso del Server di database:',0),(27709,770,'tl','',0),(27710,770,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3604;&#3634;&#3605;&#3657;&#3634;&#3648;&#3610;&#3626;&#3648;&#3595;&#3636;&#3619;&#3660;&#3626;&#3648;&#3623;&#3629;&#3619;&#3660;',0),(27711,770,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤°à¥à¤µà¤° à¤¸à¥à¤¥à¤¾à¤¨:',0),(27712,770,'ms','Lokasi pelayan pangkalan data:',0),(27713,770,'ar','Ù…ÙˆÙ‚Ø¹ Ø®Ø§Ø¯Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª:',0),(27714,770,'fr','Emplacement du serveur de base de donnÃ©es :',0),(27715,770,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚µãƒ¼ãƒ?ãƒ¼ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(27716,770,'pt','LocalizaÃ§Ã£o de servidor de banco de dados:',0),(27717,770,'ru','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ ÑÐµÑ€Ð²ÐµÑ€Ð° Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…:',0),(27718,770,'es','ColocaciÃ³n de Servidor de Base de Datos',0),(27719,770,'de','Datenbank-Server-Standort:',0),(27720,770,'en','Database Server Location:',0),(27721,771,'is','',0),(27722,771,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù‡ÙŠÚ† Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ  Ø¬Ø¯ÙŠØ¯ÙŠ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(27723,771,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù‡ÙŠÚ† Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ  Ø¬Ø¯ÙŠØ¯ÙŠ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(27724,771,'tr','Yeni VeritabanÄ± gÃ¼ncelleÅŸtirme vardÄ±r.',0),(27725,771,'pl','Nie ma Å¼adnych nowych aktualizacji bazy danych.',0),(27726,771,'bg','ÐÑÐ¼Ð° Ð½Ð¾Ð²Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸.',0),(27727,771,'ur','Ú©ÙˆØ¦ÛŒ Ù†ÛŒØ§ ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ø§Ù¾ ÚˆÛŒÙ¹Ø³ ÛÛŒÚº Û”',0),(27728,771,'sr','ÐÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ðµ Ð½Ð¾Ð²Ðµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐµ.',0),(27729,771,'vi','KhÃ´ng CÃ³ Dá»¯ Liá»‡u Cáº­p Nháº­t Má»›i',0),(27730,771,'af','Daar is geen nuwe databasis opdaterings.',0),(27731,771,'ro','Nu sunt nici noi actualizÄƒri de baze de date.',0),(27732,771,'et','Ei leitud Ã¼htki andmebaasi uuendust',0),(27733,771,'si','Obstaja nobene nove posodobitve baze podatkov.',0),(27734,771,'ba','Ada tidak ada Update database baru.',0),(27735,771,'nl','Er zijn geen nieuwe database updates.',0),(27736,771,'fi','EivÃ¤t ole uuden tietokannan pÃ¤ivityksistÃ¤.',0),(27737,771,'no','Det er ingen ny databaseoppdateringer.',0),(27738,771,'da','Der er ingen nye database opdateringer.',0),(27739,771,'ko','ìƒˆ ë°ì´í„°ë² ì´ìŠ¤ ì—…ë°ì´íŠ¸ê°€ ìžˆìŠµë‹ˆë‹¤.',0),(27740,771,'he','×™×©× × ××™×Ÿ ×¢×“×›×•× ×™ ×ž×¡×“ × ×ª×•× ×™× ×—×“×©.',0),(27741,771,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÎºÎ±Î¼Î¯Î± Î½Î­Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹Ï‚ Ï„Î·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½.',0),(27742,771,'zh','æœ‰æ²¡æœ‰æ–°çš„æ•°æ®åº“æ›´æ–°ã€‚\r\n',0),(27743,771,'sv','Det finns inga nya uppdateringar.',0),(27744,771,'it','Ci sono nuovi aggiornamenti database.',0),(27745,771,'tl','',0),(27746,771,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(27747,771,'hi','à¤µà¤¹à¤¾à¤ à¤•à¥‹à¤ˆ à¤¨à¤¯à¤¾ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(27748,771,'ms','Terdapat tiada pengemaskinian pangkalan data yang baru.',0),(27749,771,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø£ÙŠ ØªØ­Ø¯ÙŠØ«Ø§Øª Ø¬Ø¯ÙŠØ¯Ø© Ù„Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(27750,771,'fr','Il n\'y a aucune nouvelle mise Ã  jour de base de donnÃ©es.',0),(27751,771,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?®æ–°ã?Ÿã?ªæ›´æ–°ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(27752,771,'pt','HÃ¡ nÃ£o novas atualizaÃ§Ãµes de banco de dados.',0),(27753,771,'ru','ÐÐµÑ‚ Ð½Ð¾Ð²Ñ‹Ñ… Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¹ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ….',0),(27754,771,'es','No hay nuevas actualizaciones de la base de datos',0),(27755,771,'de','Es gibt keine neuen Datenbankupdates.',0),(27756,771,'en','There are no new database updates.',0),(27757,772,'is','',0),(27758,772,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø³Ø±ÙˆØ± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(27759,772,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø³Ø±ÙˆØ± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(27760,772,'tr','Server ÅŸifresi:',0),(27761,772,'pl','HasÅ‚o serwera bazy danych:',0),(27762,772,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð° Ð·Ð° ÑÑŠÑ€Ð²ÑŠÑ€ Ð½Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸:',0),(27763,772,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù¾ÛŒØ´ Ú©Ø§Ø± Ù¾Ø§Ø³ ÙˆØ±Úˆ:',0),(27764,772,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ° ÑÐµÑ€Ð²ÐµÑ€Ð° Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°:',0),(27765,772,'vi','Máº­t kháº©u mÃ¡y chá»§ dá»¯ liá»‡u',0),(27766,772,'af','Databasis bediener wagwoord:',0),(27767,772,'ro','Parola serverului bazei de date:',0),(27768,772,'et','Andmebaasi serveri parool:',0),(27769,772,'si','Geslo za streÅ¾nik zbirke podatkov:',0),(27770,772,'ba','Database Server Password:',0),(27771,772,'nl','Database serverwachtwoord:',0),(27772,772,'fi','Palvelimen salasana:',0),(27773,772,'no','Database Server passord:',0),(27774,772,'da','Database Serveradgangskode:',0),(27775,772,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì„œë²„ ì•”í˜¸:',0),(27776,772,'he','×¡×™×¡×ž×ª ×©×¨×ª ×ž×¡×“ × ×ª×•× ×™×:',0),(27777,772,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î® Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½:',0),(27778,772,'zh','æ•°æ®åº“æœåŠ¡å™¨å¯†ç ï¼š\r\n',0),(27779,772,'sv','Databas serverlÃ¶senord:',0),(27780,772,'it','Password del Server di database:',0),(27781,772,'tl','',0),(27782,772,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3604;&#3634;&#3605;&#3657;&#3634;&#3648;&#3610;&#3626;&#3648;&#3595;&#3636;&#3619;&#3660;&#3626;&#3648;&#3623;&#3629;&#3619;&#3660;',0),(27783,772,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤°à¥à¤µà¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡:',0),(27784,772,'ms','Kata laluan pelayan pangkalan data:',0),(27785,772,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ù„Ø®Ø§Ø¯Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª:',0),(27786,772,'fr','Serveur de base de donnÃ©es mot de passe :',0),(27787,772,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚µãƒ¼ãƒ?ãƒ¼ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰',0),(27788,772,'pt','Senha do servidor de banco de dados:',0),(27789,772,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… ÑÐµÑ€Ð²ÐµÑ€Ð°:',0),(27790,772,'es','ContraseÃ±a de Servidor de base de datos',0),(27791,772,'de','Datenbank-Server-Passwort:',0),(27792,772,'en','Database Server Password:',0),(27793,773,'is','',0),(27794,773,'dr','Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…ÙˆÙ‚Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(27795,773,'pr','Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…ÙˆÙ‚Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(27796,773,'tr','GeÃ§ici veritabanÄ± baÅŸarÄ±yla silindi.',0),(27797,773,'pl','Tymczasowej bazy danych zostaÅ‚ pomyÅ›lnie usuniÄ™ty.',0),(27798,773,'bg','Ð’Ñ€ÐµÐ¼ÐµÐ½Ð½Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(27799,773,'ur','Ø¹Ø§Ø±Ø¶ÛŒ Ú©ÙˆØ§Ø¦ÙÛŒÛ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø®Ø§Ø±Ø¬ Ú©Ø±Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(27800,773,'sr','ÐŸÑ€Ð¸Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð±Ð°Ð·Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(27801,773,'vi','Dá»¯ Liá»‡u Táº¡m ÄÃ£ XÃ³a ThÃ nh CÃ´ng',0),(27802,773,'af','Die tydelike databasis is suksesvol geskrap.',0),(27803,773,'ro','Baza de date temporarÄƒ a fost ÅŸters cu succes.',0),(27804,773,'et','Ajutine andmebaas kustutati edukalt',0),(27805,773,'si','ZaÄasne zbirke podatkov je bila uspeÅ¡no izbrisana.',0),(27806,773,'ba','Sementara database telah berhasil dihapus.',0),(27807,773,'nl','De tijdelijke database is verwijderd.',0),(27808,773,'fi','VÃ¤liaikainen tietokanta on poistettu onnistuneesti.',0),(27809,773,'no','Den midlertidige databasen er blitt slettet.',0),(27810,773,'da','Den midlertidige database er blevet slettet.',0),(27811,773,'ko','ìž„ì‹œ ë°ì´í„°ë² ì´ìŠ¤ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í–ˆìŠµë‹ˆë‹¤.',0),(27812,773,'he','×”×ž××’×¨ ×”×–×ž× ×™ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(27813,773,'el','Î¤Î·Î½ Ï€ÏÎ¿ÏƒÏ‰ÏÎ¹Î½Î® Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(27814,773,'zh','ä¸´æ—¶æ•°æ®åº“å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(27815,773,'sv','Den tillfÃ¤lliga databasen har raderats.',0),(27816,773,'it','Il database temporaneo Ã¨ stato eliminato correttamente.',0),(27817,773,'tl','',0),(27818,773,'th','&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3594;&#3633;&#3656;&#3623;&#3588;&#3619;&#3634;&#3623;&#3606;&#3641;&#3585;&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(27819,773,'hi','à¤…à¤¸à¥à¤¥à¤¾à¤¯à¥€ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(27820,773,'ms','Pangkalan data sementara telah berjaya dihapuskan.',0),(27821,773,'ar','ØªÙ… Ø­Ø°Ù Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø¤Ù‚ØªØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(27822,773,'fr','La base de donnÃ©es temporaire a Ã©tÃ© supprimÃ© avec succÃ¨s.',0),(27823,773,'jp','ä»®ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?¯æ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(27824,773,'pt','Banco de dados temporÃ¡rio foi apagado com sucesso.',0),(27825,773,'ru','Ð’Ñ€ÐµÐ¼ÐµÐ½Ð½Ð°Ñ Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð±Ñ‹Ð»Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð°.',0),(27826,773,'es','La base de datos temporal se eliminÃ³ exitosamente',0),(27827,773,'de','Die temporÃ¤re Datenbank wurde erfolgreich gelÃ¶scht.',0),(27828,773,'en','The temporary database has been successfully deleted.',0),(27829,774,'is','',0),(27830,774,'dr','Startup Ù†ÙˆØ§Ø± Ø§Ø¨Ø²Ø§Ø± ØµÙØ­Ù‡  ',0),(27831,774,'pr','Startup Ù†ÙˆØ§Ø± Ø§Ø¨Ø²Ø§Ø± ØµÙØ­Ù‡  ',0),(27832,774,'tr','BaÅŸlangÄ±Ã§ sayfasÄ± araÃ§:',0),(27833,774,'pl','Uruchamianie narzÄ™dzi Strona:',0),(27834,774,'bg','Ð›ÐµÐ½Ñ‚Ð°Ñ‚Ð° Ñ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¸ ÑÑ‚Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°:',0),(27835,774,'ur','Ø¢ØºØ§Ø² ØµÙØ­Û Ù¹ÙˆÙ„ Ø¨Ø§Ø±:',0),(27836,774,'sr','Ð¡Ð° Ð°Ð»Ð°Ñ‚ÐºÐ°Ð¼Ð° Ð·Ð° Ð¿Ð¾ÐºÑ€ÐµÑ‚Ð°ÑšÐµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ:',0),(27837,774,'vi','Báº¯t Ä‘áº§u trang thanh trÃ¬nh Ä‘Æ¡n',0),(27838,774,'af','Selflaai bladsy nutsbalk:',0),(27839,774,'ro','Startup filme Toolbar:',0),(27840,774,'et','Startup lehele tÃ¶Ã¶riistariba:',0),(27841,774,'si','ZaÄetek strani orodne vrstice:',0),(27842,774,'ba','Startup halaman Toolbar:',0),(27843,774,'nl','De werkbalk van de pagina van opstarten:',0),(27844,774,'fi','KÃ¤ynnistys sivun tyÃ¶kalurivillÃ¤:',0),(27845,774,'no','Oppstart verktÃ¸ylinjen:',0),(27846,774,'da','Start side vÃ¦rktÃ¸jslinjen:',0),(27847,774,'ko','ì‹œìž‘ íŽ˜ì´ì§€ ë„êµ¬ ëª¨ìŒ:',0),(27848,774,'he','×¡×¨×’×œ ×”×›×œ×™× ×©×œ ×“×£ ×”×¤×¢×œ×”:',0),(27849,774,'el','Î•ÏÎ³Î±Î»ÎµÎ¯Ï‰Î½ ÏƒÎµÎ»Î¯Î´Î± ÎµÎºÎºÎ¯Î½Î·ÏƒÎ·Ï‚:',0),(27850,774,'zh','å¯åŠ¨é¡µå·¥å…·æ ï¼š\r\n',0),(27851,774,'sv','Start sida verktygsfÃ¤ltet:',0),(27852,774,'it','Pagina di avvio barra degli strumenti:',0),(27853,774,'tl','',0),(27854,774,'th','&#3627;&#3609;&#3657;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3649;&#3606;&#3610;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;',0),(27855,774,'hi','à¤¸à¥à¤Ÿà¤¾à¤°à¥à¤Ÿà¤…à¤ª à¤ªà¥ƒà¤·à¥à¤  à¤Ÿà¥‚à¤²à¤¬à¤¾à¤°:',0),(27856,774,'ms','Toolbar Laman permulaan:',0),(27857,774,'ar','Ø´Ø±ÙŠØ· Ø£Ø¯ÙˆØ§Øª Ø§Ù„ØµÙØ­Ø© Ø¨Ø¯Ø¡ Ø§Ù„ØªØ´ØºÙŠÙ„:',0),(27858,774,'fr','Barre d\'outils Page dÃ©marrage :',0),(27859,774,'jp','ã‚¹ã‚¿ãƒ¼ãƒˆã‚¢ãƒƒãƒ—ãƒšãƒ¼ã‚¸ãƒ„ãƒ¼ãƒ«ãƒ?ãƒ¼',0),(27860,774,'pt','Barra de ferramentas pÃ¡gina de inicializaÃ§Ã£o:',0),(27861,774,'ru','ÐŸÑ€Ð¸ Ð·Ð°Ð¿ÑƒÑÐºÐµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ð¿Ð°Ð½ÐµÐ»Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²:',0),(27862,774,'es','Toolbar de PÃ¡gina de Inicio:',0),(27863,774,'de','Symbolleiste der Start-Seite:',0),(27864,774,'en','Startup Page Toolbar:',0),(27865,775,'is','',0),(27866,775,'dr','Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ  Ø³Ø±ÙˆØ± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ ',0),(27867,775,'pr','Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ  Ø³Ø±ÙˆØ± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ ',0),(27868,775,'tr','VeritabanÄ± sunucusu adÄ±:',0),(27869,775,'pl','Nazwa serwera bazy danych:',0),(27870,775,'bg','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¸Ð¼Ðµ Ð½Ð° ÑÑŠÑ€Ð²ÑŠÑ€Ð°:',0),(27871,775,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù¾ÛŒØ´ Ú©Ø§Ø± ØµØ§Ø±Ù Ú©Ø§ Ù†Ø§Ù…:',0),(27872,775,'sr','[[ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ ÑÐµÑ€Ð²ÐµÑ€Ð° Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°:',0),(27873,775,'vi','TÃªn NgÆ°á»i Sá»­ Dá»¥ng MÃ¡y Chá»§ Dá»¯ Liá»‡u',0),(27874,775,'af','Databasis Bediener Gebruikernaam:',0),(27875,775,'ro','Nume de utilizator(serverul bazei de date):',0),(27876,775,'et','Andmebaasi serveri kasutajanimi:',0),(27877,775,'si','UporabniÅ¡ko ime za streÅ¾nik zbirke podatkov:',0),(27878,775,'ba','Database Server nama pengguna:',0),(27879,775,'nl','Database Server gebruikersnaam:',0),(27880,775,'fi','Tietokannan palvelimen kÃ¤yttÃ¤jÃ¤nimi:',0),(27881,775,'no','Database Server brukernavn:',0),(27882,775,'da','Database Server Username:',0),(27883,775,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì„œë²„ ì´ë¦„:',0),(27884,775,'he','×©× ×ž×©×ª×ž×© ×©×œ ×©×¨×ª ×ž×¡×“ ×”× ×ª×•× ×™×:',0),(27885,775,'el','Î’Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î® ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î·:',0),(27886,775,'zh','æ•°æ®åº“æœåŠ¡å™¨ç”¨æˆ·å',0),(27887,775,'sv','Databas Server anvÃ¤ndarnamn:',0),(27888,775,'it','Nome utente di database Server:',0),(27889,775,'tl','',0),(27890,775,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3604;&#3634;&#3605;&#3657;&#3634;&#3648;&#3610;&#3626;&#3648;&#3595;&#3636;&#3619;&#3660;&#3626;&#3648;&#3623;&#3629;&#3619;&#3660;:',0),(27891,775,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤°à¥à¤µà¤° à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤®:',0),(27892,775,'ms','Nama pelayan pangkalan data:',0),(27893,775,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù„Ø®Ø§Ø¯Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª::',0),(27894,775,'fr','Nom d\'utilisateur de base de donnÃ©es serveur :',0),(27895,775,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚µãƒ¼ãƒ?ãƒ¼ãƒ¦ãƒ¼ã‚¶ãƒ¼å??',0),(27896,775,'pt','Nome do servidor de banco de dados:',0),(27897,775,'ru','Ð˜Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… ÑÐµÑ€Ð²ÐµÑ€Ð°:',0),(27898,775,'es','Servidor de Base de Datos Nombre de Usuario',0),(27899,775,'de','Datenbank-Server-Benutzername:',0),(27900,775,'en','Database Server Username:',0),(27901,776,'is','',0),(27902,776,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡Ù‰ ',0),(27903,776,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡Ù‰ ',0),(27904,776,'tr','Bankamatik',0),(27905,776,'pl','Bankowa',0),(27906,776,'bg','Ð”ÐµÐ±Ð¸Ñ‚',0),(27907,776,'ur','ÚˆÛŒØ¨Ù¹',0),(27908,776,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(27909,776,'vi','Sá»± ghi ná»£',0),(27910,776,'af','Debiet',0),(27911,776,'ro','Debit',0),(27912,776,'et','Deebet',0),(27913,776,'si','Breme',0),(27914,776,'ba','Debit',0),(27915,776,'nl','Debet',0),(27916,776,'fi','Debet',0),(27917,776,'no','Debet',0),(27918,776,'da','Debet',0),(27919,776,'ko','ì§ë¶ˆ',0),(27920,776,'he','×—×™×•×‘',0),(27921,776,'el','Î§ÏÎµÏ‰ÏƒÏ„Î¹ÎºÎ®',0),(27922,776,'zh','å€Ÿæ–¹\r\n',0),(27923,776,'sv','Betalkort',0),(27924,776,'it','Addebito',0),(27925,776,'tl','',0),(27926,776,'th','&#3648;&#3604;&#3610;&#3636;&#3605;',0),(27927,776,'hi','à¤¡à¥‡à¤¬à¤¿à¤Ÿ',0),(27928,776,'ms','Debit',0),(27929,776,'ar','Ù…Ø¯ÙŠÙ†',0),(27930,776,'fr','DÃ©bit',0),(27931,776,'jp','å€Ÿæ–¹',0),(27932,776,'pt','DÃ©bito',0),(27933,776,'ru','Ð”ÐµÐ±ÐµÑ‚',0),(27934,776,'es','DÃ©bito',0),(27935,776,'de','Debit',0),(27936,776,'en','Debit',0),(27937,777,'is','',0),(27938,777,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡ÙŠ',0),(27939,777,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡ÙŠ',0),(27940,777,'tr','BorÃ§ hesabÄ±',0),(27941,777,'pl','Konto debetowe',0),(27942,777,'bg','Ð”ÐµÐ±Ð¸Ñ‚Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(27943,777,'ur','ÚˆÛŒØ¨Ù¹ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(27944,777,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(27945,777,'vi','TÃ i Khoáº£n Ná»£',0),(27946,777,'af','Debiet Rekening',0),(27947,777,'ro','Debit contul',0),(27948,777,'et','Deebet konto',0),(27949,777,'si','Breme raÄuna',0),(27950,777,'ba','Debet rekening',0),(27951,777,'nl','Debet rekening',0),(27952,777,'fi','Debet-tili',0),(27953,777,'no','Belastning',0),(27954,777,'da','Debetkonto',0),(27955,777,'ko','ì§ë¶ˆ ê³„ì •',0),(27956,777,'he','×—×™×•×‘ ×—×©×‘×•×Ÿ',0),(27957,777,'el','Î›Î¿Î³/ÏƒÎ¼ÏŒÏ‚',0),(27958,777,'zh','å€Ÿæ–¹å¸æˆ·\r\n',0),(27959,777,'sv','Kontokredit',0),(27960,777,'it','Conto di addebito',0),(27961,777,'tl','',0),(27962,777,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3648;&#3604;&#3610;&#3636;&#3605;',0),(27963,777,'hi','à¤¡à¥‡à¤¬à¤¿à¤Ÿ à¤–à¤¾à¤¤à¥‡',0),(27964,777,'ms','Debit akaun',0),(27965,777,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¯ÙŠÙ†',0),(27966,777,'fr','Compte de dÃ©bit',0),(27967,777,'jp','å€Ÿæ–¹å‹˜å®š',0),(27968,777,'pt','Conta dÃ©bito',0),(27969,777,'ru','Ð”ÐµÐ±ÐµÑ‚ ÑÑ‡ÐµÑ‚Ð°',0),(27970,777,'es','Cuenta de DÃ©bito',0),(27971,777,'de','Sollkonto',0),(27972,777,'en','Debit Account',0),(27973,778,'is','',0),(27974,778,'dr','Ø¯Ø³Ø§Ù…Ø¨Ø± ',0),(27975,778,'pr','Ø¯Ø³Ø§Ù…Ø¨Ø± ',0),(27976,778,'tr','AralÄ±k',0),(27977,778,'pl','Grudnia',0),(27978,778,'bg','Ð”ÐµÐºÐµÐ¼Ð²Ñ€Ð¸',0),(27979,778,'ur','Ø¯Ø³Ù…Ø¨Ø±',0),(27980,778,'sr','Ð”ÐµÑ†ÐµÐ¼Ð±Ñ€Ð°',0),(27981,778,'vi','ThÃ¡ng mÆ°á»i hai',0),(27982,778,'af','Desember',0),(27983,778,'ro','Decembrie',0),(27984,778,'et','Detsember',0),(27985,778,'si','Decembra',0),(27986,778,'ba','Desember',0),(27987,778,'nl','December',0),(27988,778,'fi','Joulukuuta',0),(27989,778,'no','Desember',0),(27990,778,'da','December',0),(27991,778,'ko','12 ì›”',0),(27992,778,'he','×“×¦×ž×‘×¨',0),(27993,778,'el','Î”ÎµÎºÎµÎ¼Î²ÏÎ¯Î¿Ï…',0),(27994,778,'zh','åäºŒæœˆ\r\n',0),(27995,778,'sv','December',0),(27996,778,'it','Dicembre',0),(27997,778,'tl','',0),(27998,778,'th','&#3608;&#3633;&#3609;&#3623;&#3634;&#3588;&#3617;',0),(27999,778,'hi','à¤¦à¤¿à¤¸à¤®à¥à¤¬à¤°',0),(28000,778,'ms','Disember',0),(28001,778,'ar','Ø¯ÙŠØ³Ù…Ø¨Ø±',0),(28002,778,'fr','DÃ©cembre',0),(28003,778,'jp','ï¼‘ï¼’æœˆ',0),(28004,778,'pt','Dezembro de',0),(28005,778,'ru','Ð”ÐµÐºÐ°Ð±Ñ€ÑŒ',0),(28006,778,'es','Diciembre',0),(28007,778,'de','Dezember',0),(28008,778,'en','December',0),(28009,779,'is','',0),(28010,779,'dr','Ú¯Ø±ÙˆÙ‡  ÙƒØ³Ø±ÙŠ',0),(28011,779,'pr','Ú¯Ø±ÙˆÙ‡  ÙƒØ³Ø±ÙŠ',0),(28012,779,'tr','Grup Ä°ndirimi',0),(28013,779,'pl','Grupa odliczenia',0),(28014,779,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ð°',0),(28015,779,'ur','Ù…Ù†ÛØ§Ø¦ÛŒ Ú¯Ø±ÙˆÙ¾',0),(28016,779,'sr','Ð”ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð³Ñ€ÑƒÐ¿Ðµ',0),(28017,779,'vi','NhÃ³m Giáº£m trá»« ',0),(28018,779,'af','Aftrekking groep',0),(28019,779,'ro','Deducerea grup',0),(28020,779,'et','Mahaarvamise grupp',0),(28021,779,'si','Odbitek skupine',0),(28022,779,'ba','Pengurangan Group',0),(28023,779,'nl','Aftrek groep',0),(28024,779,'fi','VÃ¤hennetty konsernin',0),(28025,779,'no','Fradrag gruppe',0),(28026,779,'da','Fradrag gruppe',0),(28027,779,'ko','ê³µì œ ê·¸ë£¹',0),(28028,779,'he','×§×‘×•×¦×ª × ×™×›×•×™',0),(28029,779,'el','ÎŸÎ¼Î¬Î´Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(28030,779,'zh','æ‰£é™¤ç»„\r\n',0),(28031,779,'sv','Avdrag grupp',0),(28032,779,'it','Detrazione di gruppo',0),(28033,779,'tl','',0),(28034,779,'th','&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3591;&#3636;&#3609;&#3648;&#3611;&#3655;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(28035,779,'hi','à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(28036,779,'ms','Potongan Kumpulan',0),(28037,779,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø®ØµÙ…',0),(28038,779,'fr','Groupe de dÃ©duction',0),(28039,779,'jp','æŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—',0),(28040,779,'pt','Grupo de deduÃ§Ã£o',0),(28041,779,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(28042,779,'es','DeducciÃ³n Grupo',0),(28043,779,'de','Abzug-Gruppe',0),(28044,779,'en','Deduction Group',0),(28045,780,'is','',0),(28046,780,'dr','Ø¢ÙŠØ§ Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ÙØ¯Ø±Ø§Ù„ Ø±Ø§ ÙƒØ³Ø± Ù…ÙŠ ÙƒÙ†ÙŠØ¯ ØŸ',0),(28047,780,'pr','Ø¢ÙŠØ§ Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ÙØ¯Ø±Ø§Ù„ Ø±Ø§ ÙƒØ³Ø± Ù…ÙŠ ÙƒÙ†ÙŠØ¯ ØŸ',0),(28048,780,'tr','Ä°lk Federal vergi dÃ¼ÅŸeriz?',0),(28049,780,'pl','Odliczenia podatku federalnego po raz pierwszy?',0),(28050,780,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð° Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº Ð¿ÑŠÑ€Ð²Ð¾?',0),(28051,780,'ur','ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³ Ù¾ÛÙ„Û’ Ù…Ù†ÛØ§ Ú©Ø± Ù„Û’ØŸ',0),(28052,780,'sr','ÐŸÑ€Ð²Ð¾ , Ð¾Ð´ÑƒÐ·Ð¼Ð¸ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·?',0),(28053,780,'vi','Trá»« thuáº¿ liÃªn bang trÆ°á»›c',0),(28054,780,'af','Eerste federale belasting aftrek?',0),(28055,780,'ro','Deduce impozitul Federal Ã®n primul rÃ¢nd?',0),(28056,780,'et','Mahaarvamise fÃ¶deraalse tulumaksu?',0),(28057,780,'si','Zvezni davek odbije najprej?',0),(28058,780,'ba','Memotong pajak Federal pertama?',0),(28059,780,'nl','Aftrek van de eerste federale belasting?',0),(28060,780,'fi','VÃ¤hentÃ¤Ã¤ liittovaltion veroja ensin?',0),(28061,780,'no','Trekke fra fÃ¸deral skatt fÃ¸rst?',0),(28062,780,'da','FratrÃ¦kke fÃ¸deral skat fÃ¸rst?',0),(28063,780,'ko','ì²˜ìŒ ì—°ë°© ì„¸ê¸ˆ ê³µì œ?',0),(28064,780,'he','×œ× ×›×•×ª ×ž×¡ ×¤×“×¨×œ×™ ×§×•×“×?',0),(28065,780,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Ï„Î¿Ï… Î¿Î¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï… Ï€ÏÏŽÏ„Î±;',0),(28066,780,'zh','è”é‚¦ç¨Žä¸­é¦–å…ˆæ‰£é™¤ï¼Ÿ\r\n',0),(28067,780,'sv','Dra av Federal skatt fÃ¶rst?',0),(28068,780,'it','Detrazione fiscale federale prima?',0),(28069,780,'tl','',0),(28070,780,'th','&#3627;&#3633;&#3585;&#3616;&#3634;&#3625;&#3637;&#3619;&#3633;&#3600;&#3648;&#3611;&#3655;&#3609;&#3629;&#3618;&#3656;&#3634;&#3591;&#3649;&#3619;&#3585;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(28071,780,'hi','à¤¸à¤¬à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¤‚à¤˜à¥€à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤˜à¤Ÿà¤¾?',0),(28072,780,'ms','Memotong cukai Persekutuan pertama?',0),(28073,780,'ar','Ø®ØµÙ… Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ø£ÙˆÙ„Ø§Ù‹ØŸ',0),(28074,780,'fr','DÃ©duction de la taxe fÃ©dÃ©rale d\'abord ?',0),(28075,780,'jp','ã?¾ã?šé€£é‚¦ç¨Žã‚’æŽ§é™¤ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(28076,780,'pt','DeduÃ§Ã£o do imposto Federal primeiro?',0),(28077,780,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð²Ñ‹Ñ‡ÐµÑÑ‚ÑŒ Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³?',0),(28078,780,'es','Deducir Impuestos Federales Primero',0),(28079,780,'de','Absetzen Bundessteuer zuerst?',0),(28080,780,'en','Deduct Federal Tax First?',0),(28081,781,'is','',0),(28082,781,'dr',' ÙƒØ³Ø±ÙŠ',0),(28083,781,'pr',' ÙƒØ³Ø±ÙŠ',0),(28084,781,'tr','Kesinti',0),(28085,781,'pl','Odliczenie',0),(28086,781,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(28087,781,'ur','Ù…Ù†ÛØ§Ø¦ÛŒ',0),(28088,781,'sr','Ð”ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð°',0),(28089,781,'vi','Giáº£m trá»«',0),(28090,781,'af','Aftrekking',0),(28091,781,'ro','Deducerea',0),(28092,781,'et','Mahaarvamine',0),(28093,781,'si','Odbitek',0),(28094,781,'ba','Pengurangan',0),(28095,781,'nl','Aftrek',0),(28096,781,'fi','VÃ¤hennys',0),(28097,781,'no','Fradrag',0),(28098,781,'da','Fradrag',0),(28099,781,'ko','ê³µì œ',0),(28100,781,'he','× ×™×›×•×™',0),(28101,781,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ·',0),(28102,781,'zh','æ‰£é™¤\r\n',0),(28103,781,'sv','Avdrag',0),(28104,781,'it','Deduzione',0),(28105,781,'tl','',0),(28106,781,'th','&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;',0),(28107,781,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€',0),(28108,781,'ms','Potongan',0),(28109,781,'ar','Ø®ØµÙ…',0),(28110,781,'fr','DÃ©duction',0),(28111,781,'jp','æŽ§é™¤',0),(28112,781,'pt','DeduÃ§Ã£o',0),(28113,781,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚',0),(28114,781,'es','DeducciÃ³n',0),(28115,781,'de','Abzug',0),(28116,781,'en','Deduction',0),(28117,782,'is','',0),(28118,782,'dr','( ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡',0),(28119,782,'pr',' Ø¬Ø¯ÙˆÙ„ ÙƒØ§Ù‡Ø´ Ù…Ø³ØªÙ…Ø±ÙŠ ( ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡',0),(28120,782,'tr','Kesinti Ã¶denek tablosu',0),(28121,782,'pl','PotrÄ…cenie zasiÅ‚ek tabeli',0),(28122,782,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð½Ð°Ð´Ð±Ð°Ð²ÐºÐ° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(28123,782,'ur','Ù…Ù†ÛØ§Ø¦ÛŒ Ø§Ù„Ø§Ø¤Ù†Ø³ Ø¬Ø¯ÙˆÙ„',0),(28124,782,'sr','Ð”ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð´Ð·ÐµÐ¿Ð°Ñ€Ð°Ñ† Ñ‚Ð°Ð±ÐµÐ»Ðµ',0),(28125,782,'vi','Báº£ng Giáº£m trá»« phá»¥ cáº¥p',0),(28126,782,'af','Aftrekking aftrekking tabel',0),(28127,782,'ro','Tabel de indemnizaÅ£ie deducerea',0),(28128,782,'et','Mahaarvamise saastekvootide tabeli',0),(28129,782,'si','Odbitek dodatek tabela',0),(28130,782,'ba','Pengurangan yang diperbolehkan tabel',0),(28131,782,'nl','Aftrek uitkering tabel',0),(28132,782,'fi','VÃ¤hennys pÃ¤Ã¤stÃ¶oikeuksien taulun',0),(28133,782,'no','Fradrag godtgjÃ¸relse tabell',0),(28134,782,'da','Fradrag godtgÃ¸relse tabel',0),(28135,782,'ko','ê³µì œ ìˆ˜ë‹¹ í‘œ',0),(28136,782,'he','× ×™×›×•×™ ×“×ž×™ ×©×•×œ×—×Ÿ',0),(28137,782,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ· ÎµÏ€Î¯Î´Î¿Î¼Î± Ï€Î¯Î½Î±ÎºÎ±',0),(28138,782,'zh','æ‰£é™¤æ´¥è´´è¡¨\r\n',0),(28139,782,'sv','Avdrag avdrag tabell',0),(28140,782,'it','Tabella indennitÃ  di deduzione',0),(28141,782,'tl','',0),(28142,782,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3627;&#3633;&#3585;&#3648;&#3591;&#3636;&#3609;',0),(28143,782,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤­à¤¤à¥à¤¤à¤¾ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(28144,782,'ms','Potongan elaun Jadual',0),(28145,782,'ar','Ø®ØµÙ… Ø¨Ø¯Ù„ Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(28146,782,'fr','Table d\'allocation de dÃ©duction',0),(28147,782,'jp','æŽ§é™¤å¼•å½“é‡‘è¡¨',0),(28148,782,'pt','Tabela de subsÃ­dio de deduÃ§Ã£o',0),(28149,782,'ru','Ð£Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ðµ Ð¿Ð¾ÑÐ¾Ð±Ð¸Ñ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(28150,782,'es','Tabla de Deducciones Permitidas',0),(28151,782,'de','Abzug Taschengeld Tabelle',0),(28152,782,'en','Deduction Allowance table',0),(28153,783,'is','',0),(28154,783,'dr','Ù…Ø¨Ù„Øº  ÙƒØ³Ø±ÙŠ',0),(28155,783,'pr','Ù…Ø¨Ù„Øº  ÙƒØ³Ø±ÙŠ',0),(28156,783,'tr','Kesinti tutarÄ±',0),(28157,783,'pl','Kwota potrÄ…cenia',0),(28158,783,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½ÐµÑ‚Ð¾ ÑÑƒÐ¼Ð°',0),(28159,783,'ur','Ù…Ù†ÛØ§Ø¦ÛŒ Ø±Ù‚Ù…',0),(28160,783,'sr','ÐžÐ´Ð±Ð¸Ñ‚Ð°Ðº Ð¸Ð·Ð½Ð¾Ñ',0),(28161,783,'vi','Sá»‘ tiá»n Giáº£m trá»«',0),(28162,783,'af','Aftrekking bedrag',0),(28163,783,'ro','Deducerea sumei',0),(28164,783,'et','Mahaarvamise summa',0),(28165,783,'si','Znesek odbitka',0),(28166,783,'ba','Jumlah deduksi',0),(28167,783,'nl','Bedrag van de aftrek',0),(28168,783,'fi','KotitalousvÃ¤hennyksen mÃ¤Ã¤rÃ¤n',0),(28169,783,'no','Trekket belÃ¸p',0),(28170,783,'da','Fradrag belÃ¸b',0),(28171,783,'ko','ê³µì œ ê¸ˆì•¡',0),(28172,783,'he','×¡×›×•× × ×™×›×•×™',0),(28173,783,'el','Î Î¿ÏƒÏŒ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(28174,783,'zh','æ‰£é™¤é¢\r\n',0),(28175,783,'sv','Avdraget belopp',0),(28176,783,'it','Importo detrazione',0),(28177,783,'tl','',0),(28178,783,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3591;&#3636;&#3609;',0),(28179,783,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤°à¤¾à¤¶à¤¿',0),(28180,783,'ms','Amaun potongan',0),(28181,783,'ar','Ø®ØµÙ… Ø§Ù„Ù…Ø¨Ù„Øº',0),(28182,783,'fr','Montant de la dÃ©duction',0),(28183,783,'jp','æŽ§é™¤é¡?',0),(28184,783,'pt','Montante da deduÃ§Ã£o',0),(28185,783,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð²Ñ‹Ñ‡ÐµÑ‚Ð°',0),(28186,783,'es','Monto de DeducciÃ³n',0),(28187,783,'de','Abzug Betrag',0),(28188,783,'en','Deduction Amount',0),(28189,784,'is','',0),(28190,784,'dr','Ú¯Ø±ÙˆÙ‡  ÙƒØ³Ø±ÙŠ',0),(28191,784,'pr','Ú¯Ø±ÙˆÙ‡  ÙƒØ³Ø±ÙŠ',0),(28192,784,'tr','Grup Ä°ndirimi',0),(28193,784,'pl','Grupa odliczenia',0),(28194,784,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ð°',0),(28195,784,'ur','Ù…Ù†ÛØ§Ø¦ÛŒ Ú¯Ø±ÙˆÙ¾',0),(28196,784,'sr','Ð”ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð³Ñ€ÑƒÐ¿Ðµ',0),(28197,784,'vi','NhÃ³m Giáº£m trá»«',0),(28198,784,'af','Aftrekking groep',0),(28199,784,'ro','Deducerea grup',0),(28200,784,'et','Mahaarvamise grupp',0),(28201,784,'si','Odbitek skupine',0),(28202,784,'ba','Pengurangan Group',0),(28203,784,'nl','Aftrek groep',0),(28204,784,'fi','VÃ¤hennetty konsernin',0),(28205,784,'no','Fradrag gruppe',0),(28206,784,'da','Fradrag gruppe',0),(28207,784,'ko','ê³µì œ ê·¸ë£¹',0),(28208,784,'he','×§×‘×•×¦×ª × ×™×›×•×™',0),(28209,784,'el','ÎŸÎ¼Î¬Î´Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(28210,784,'zh','æ‰£é™¤ç»„',0),(28211,784,'sv','Avdrag grupp',0),(28212,784,'it','Detrazione di gruppo',0),(28213,784,'tl','',0),(28214,784,'th','&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3611;&#3655;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(28215,784,'hi','à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(28216,784,'ms','Potongan Kumpulan',0),(28217,784,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø®ØµÙ…',0),(28218,784,'fr','Groupe de dÃ©duction',0),(28219,784,'jp','æŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—',0),(28220,784,'pt','Grupo de deduÃ§Ã£o',0),(28221,784,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(28222,784,'es','Grupo de Deducciones',0),(28223,784,'de','Abzug-Gruppe',0),(28224,784,'en','Deduction Group',0),(28225,785,'is','',0),(28226,785,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙƒØ³Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(28227,785,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙƒØ³Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(28228,785,'tr','Kesinti grubu baÅŸarÄ±yla eklendi',0),(28229,785,'pl','Grupa odliczenia dodano pomyÅ›lnie',0),(28230,785,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(28231,785,'ur','Ù…Ù†ÛØ§Ø¦ÛŒ Ú¯Ø±ÙˆÙ¾ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(28232,785,'sr','Ð”ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð³Ñ€ÑƒÐ¿Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(28233,785,'vi','ThÃªm NhÃ³m Giáº£m trá»« thÃ nh cÃ´ng',0),(28234,785,'af','Aftrekkingsgroep suksesvol geskep.',0),(28235,785,'ro','Deducerea grup adÄƒugat cu succes',0),(28236,785,'et','Mahaarvamise grupp edukalt lisatud',0),(28237,785,'si','Odbitek skupina uspeÅ¡no dodani',0),(28238,785,'ba','Pengurangan Group berhasil ditambahkan',0),(28239,785,'nl','Aftrek groep toegevoegd',0),(28240,785,'fi','VÃ¤hennys ryhmÃ¤n lisÃ¤Ã¤minen onnistui',0),(28241,785,'no','Fradrag gruppe lagt',0),(28242,785,'da','Fradrag gruppe tilfÃ¸jet',0),(28243,785,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ê³µì œ ê·¸ë£¹',0),(28244,785,'he','×§×‘×•×¦×ª × ×™×›×•×™ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(28245,785,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ· Î¿Î¼Î¬Î´Î± Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(28246,785,'zh','æ‰£é™¤ç»„æˆåŠŸæ·»åŠ \r\n',0),(28247,785,'sv','Avdrag grupp lagts',0),(28248,785,'it','Deduzione gruppo aggiunto con successo',0),(28249,785,'tl','',0),(28250,785,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3611;&#3655;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(28251,785,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤¸à¤®à¥‚à¤¹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(28252,785,'ms','Potongan Kumpulan berjaya menambah',0),(28253,785,'ar','Ø§Ù„ÙØ±ÙŠÙ‚ Ø§Ù„Ø®ØµÙ… Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(28254,785,'fr','DÃ©duction groupe ajoutÃ© avec succÃ¨s',0),(28255,785,'jp','æŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(28256,785,'pt','Grupo de deduÃ§Ã£o adicionado com sucesso',0),(28257,785,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚ Ð³Ñ€ÑƒÐ¿Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(28258,785,'es','Grupo de Deducciones agregado exitosamente',0),(28259,785,'de','Abzug-Gruppe erfolgreich hinzugefÃ¼gt',0),(28260,785,'en','Deduction Group added successfully',0),(28261,786,'is','',0),(28262,786,'dr','Ø­Ø°Ù  Ú¯Ø±ÙˆÙ‡  ÙƒØ³Ø±ÙŠ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(28263,786,'pr','Ø­Ø°Ù  Ú¯Ø±ÙˆÙ‡  ÙƒØ³Ø±ÙŠ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(28264,786,'tr','Kesinti grubu baÅŸarÄ±yla silindi',0),(28265,786,'pl','Grupa odliczenia przesâ”‚anie',0),(28266,786,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ð° Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(28267,786,'ur','Ù…Ù†ÛØ§Ø¦ÛŒ Ú¯Ø±ÙˆÙ¾ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(28268,786,'sr','Ð”ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð³Ñ€ÑƒÐ¿Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(28269,786,'vi','XÃ³a NhÃ³m Giáº£m trá»« thÃ nh cÃ´ng',0),(28270,786,'af','Aftrekkingsgroep suksesvol geskrap ',0),(28271,786,'ro','Deducerea grupului ÅŸters cu succes',0),(28272,786,'et','Mahaarvamise rÃ¼hm edukalt kustutatud',0),(28273,786,'si','Odbitek skupina uspeÅ¡no izbrisana',0),(28274,786,'ba','Pengurangan Group berhasil dihapus',0),(28275,786,'nl','Aftrek groep succesvol verwijderd',0),(28276,786,'fi','VÃ¤hennys ryhmÃ¤n poistettu',0),(28277,786,'no','Fradrag gruppe slettet',0),(28278,786,'da','Fradrag gruppen slettet',0),(28279,786,'ko','ê³µì œ ê·¸ë£¹ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(28280,786,'he','×§×‘×•×¦×ª × ×™×›×•×™ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(28281,786,'el','ÎŸÎ¼Î¬Î´Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(28282,786,'zh','æ‰£é™¤ç»„å·²æˆåŠŸåˆ é™¤\r\n',0),(28283,786,'sv','Avdrag grupp raderades',0),(28284,786,'it','Deduzione gruppo eliminato con successo',0),(28285,786,'tl','',0),(28286,786,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3611;&#3655;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(28287,786,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤¸à¤®à¥‚à¤¹',0),(28288,786,'ms','Potongan Kumpulan dihapuskan dengan jayanya',0),(28289,786,'ar','Ø®ØµÙ… Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(28290,786,'fr','DÃ©duction groupe supprimÃ© avec succÃ¨s',0),(28291,786,'jp','æŽ§é™¤ã‚¯ãƒ«ãƒ¼ãƒ—ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(28292,786,'pt','DeduÃ§Ã£o grupo excluÃ­do com sucesso',0),(28293,786,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚ Ð³Ñ€ÑƒÐ¿Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(28294,786,'es','Grupo de Deducciones eliminado exitosamente',0),(28295,786,'de','Abzug-Gruppe erfolgreich gelÃ¶scht',0),(28296,786,'en','Deduction Group deleted successfully',0),(28297,787,'is','',0),(28298,787,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù‡Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(28299,787,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù‡Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(28300,787,'tr','Kesinti grubu baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(28301,787,'pl','Grupa odliczenia pomyÅ›lnie zaktualizowana',0),(28302,787,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(28303,787,'ur','Ù…Ù†ÛØ§Ø¦ÛŒ Ú¯Ø±ÙˆÙ¾ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(28304,787,'sr','Ð”ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð³Ñ€ÑƒÐ¿Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(28305,787,'vi','Cáº­p Nháº­t NhÃ³m Giáº£m Trá»« thÃ nh cÃ´ng',0),(28306,787,'af','Aftrekkingsgroep suksesvol opdateer',0),(28307,787,'ro','Deducerea grup actualizat cu succes',0),(28308,787,'et','Mahaarvamise rÃ¼hma vÃ¤rskendamine Ãµnnestus',0),(28309,787,'si','Odbitek skupina uspeÅ¡no posodobljena',0),(28310,787,'ba','Pengurangan Group berhasil',0),(28311,787,'nl','Aftrek groep bijgewerkt',0),(28312,787,'fi','VÃ¤hennys ryhmÃ¤ pÃ¤ivitetty',0),(28313,787,'no','Fradrag gruppen oppdatert',0),(28314,787,'da','Fradrag gruppe opdateret',0),(28315,787,'ko','ê³µì œ ê·¸ë£¹ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(28316,787,'he','×§×‘×•×¦×ª × ×™×›×•×™ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(28317,787,'el','ÎŸÎ¼Î¬Î´Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(28318,787,'zh','æ‰£é™¤é›†å›¢æˆåŠŸæ›´æ–°\r\n',0),(28319,787,'sv','Avdrag grupp uppdaterats',0),(28320,787,'it','Deduzione gruppo aggiornato con successo',0),(28321,787,'tl','',0),(28322,787,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3611;&#3655;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(28323,787,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤®à¥‚à¤¹',0),(28324,787,'ms','Potongan Kumpulan berjaya dikemas kini',0),(28325,787,'ar','Ø§Ù„ÙØ±ÙŠÙ‚ Ø§Ù„Ø®ØµÙ… Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(28326,787,'fr','DÃ©duction de groupe mis Ã  jour avec succÃ¨s',0),(28327,787,'jp','æŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(28328,787,'pt','DeduÃ§Ã£o grupo atualizado com sucesso',0),(28329,787,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚ Ð³Ñ€ÑƒÐ¿Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(28330,787,'es','Grupo de Deducciones actualizado exitosamente',0),(28331,787,'de','Abzug-Gruppe erfolgreich aktualisiert',0),(28332,787,'en','Deduction Group updated successfully',0),(28333,788,'is','',0),(28334,788,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ù‡Ø´',0),(28335,788,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ù‡Ø´',0),(28336,788,'tr','Kesinti bilgileri',0),(28337,788,'pl','Odliczenie Info',0),(28338,788,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(28339,788,'ur','ÙˆØ¶Ø¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(28340,788,'sr','Ð”ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð˜Ð½Ñ„Ð¾',0),(28341,788,'vi','ThÃ´ng tin giáº£m trá»«',0),(28342,788,'af','Aftrekking Inligting',0),(28343,788,'ro','Deducerea Info',0),(28344,788,'et','Mahaarvamise Info',0),(28345,788,'si','Odbitek Info',0),(28346,788,'ba','Pengurangan Info',0),(28347,788,'nl','Aftrek Info',0),(28348,788,'fi','VÃ¤hennys Info',0),(28349,788,'no','Fradrag Info',0),(28350,788,'da','Fradrag Info',0),(28351,788,'ko','ê³µì œ ì •ë³´',0),(28352,788,'he','× ×™×›×•×™ ×¤×¨×˜×™',0),(28353,788,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(28354,788,'zh','æ‰£é™¤ä¿¡æ¯\r\n',0),(28355,788,'sv','Avdrag information',0),(28356,788,'it','Info detrazione',0),(28357,788,'tl','',0),(28358,788,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3591;&#3636;&#3609;',0),(28359,788,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(28360,788,'ms','Maklumat potongan',0),(28361,788,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø®ØµÙ…',0),(28362,788,'fr','DÃ©duction Info',0),(28363,788,'jp','æŽ§é™¤æƒ…å ±',0),(28364,788,'pt','InformaÃ§Ã£o de deduÃ§Ã£o',0),(28365,788,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ð¸',0),(28366,788,'es','DeducciÃ³n Info',0),(28367,788,'de','Abzug-Info',0),(28368,788,'en','Deduction Info',0),(28369,789,'is','',0),(28370,789,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ   ÙƒØ³Ø±ÙŠ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(28371,789,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ   ÙƒØ³Ø±ÙŠ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(28372,789,'tr','Kesinti baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(28373,789,'pl','Odliczenie pomyÅ›lnie zaktualizowana',0),(28374,789,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(28375,789,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ù…Ù†ÛØ§Ø¦ÛŒ',0),(28376,789,'sr','Ð”ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(28377,789,'vi','Giáº£m Trá»« Cáº­p Nháº­t thÃ nh cÃ´ng',0),(28378,789,'af','Aftrekking suksesvol opdateer',0),(28379,789,'ro','Deducerea actualizat cu succes',0),(28380,789,'et','VÃ¤rskendatud mahaarvamine',0),(28381,789,'si','Odbitek uspeÅ¡no posodobljena',0),(28382,789,'ba','Pengurangan yang berhasil',0),(28383,789,'nl','Aftrek bijgewerkt',0),(28384,789,'fi','VÃ¤hennys pÃ¤ivitetty',0),(28385,789,'no','Fradrag oppdatert',0),(28386,789,'da','Fradrag opdateret',0),(28387,789,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ê³µì œ',0),(28388,789,'he','× ×™×›×•×™ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(28389,789,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(28390,789,'zh','æ‰£é™¤å·²æˆåŠŸæ›´æ–°\r\n',0),(28391,789,'sv','Avdrag uppdaterats',0),(28392,789,'it','Deduzione aggiornato con successo',0),(28393,789,'tl','',0),(28394,789,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3591;&#3636;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(28395,789,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(28396,789,'ms','Potongan yang berjaya dikemas kini',0),(28397,789,'ar','Ø®ØµÙ… ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(28398,789,'fr','DÃ©duction mis Ã  jour avec succÃ¨s',0),(28399,789,'jp','æŽ§é™¤ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(28400,789,'pt','DeduÃ§Ã£o atualizada com sucesso',0),(28401,789,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(28402,789,'es','DeducciÃ³n actualizado exitosamente',0),(28403,789,'de','Abzug erfolgreich aktualisiert',0),(28404,789,'en','Deduction updated successfully',0),(28405,790,'is','',0),(28406,790,'dr',' ÙƒØ³ÙˆØ±Ø§Øª',0),(28407,790,'pr',' ÙƒØ³ÙˆØ±Ø§Øª',0),(28408,790,'tr','Kesintiler',0),(28409,790,'pl','PotrÄ…cenia',0),(28410,790,'bg','Ð£Ð´Ñ€ÑŠÐ¶ÐºÐ¸',0),(28411,790,'ur','Ú©Ù¹ÙˆØªÛŒ',0),(28412,790,'sr','ÐžÐ´Ð±Ð¸Ñ‚ÐºÐµ',0),(28413,790,'vi','CÃ¡c khoáº£n giáº£m trá»«',0),(28414,790,'af','Aftrekkings',0),(28415,790,'ro','Deduceri',0),(28416,790,'et','Mahaarvamised',0),(28417,790,'si','Odbitki',0),(28418,790,'ba','Pengurangan',0),(28419,790,'nl','Inhoudingen',0),(28420,790,'fi','VÃ¤hennykset',0),(28421,790,'no','Fradrag',0),(28422,790,'da','Fradrag',0),(28423,790,'ko','ê³µì œ',0),(28424,790,'he','× ×™×›×•×™×™×',0),(28425,790,'el','ÎšÏÎ±Ï„Î®ÏƒÎµÎ¹Ï‚',0),(28426,790,'zh','æ‰£é™¤\r\n',0),(28427,790,'sv','Avdrag',0),(28428,790,'it','Deduzioni',0),(28429,790,'tl','',0),(28430,790,'th','&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;',0),(28431,790,'hi','à¤•à¤Ÿà¥Œà¤¤à¤¿à¤¯à¤¾à¤‚',0),(28432,790,'ms','Potongan',0),(28433,790,'ar','Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª',0),(28434,790,'fr','DÃ©ductions',0),(28435,790,'jp','æŽ§é™¤',0),(28436,790,'pt','DeduÃ§Ãµes',0),(28437,790,'ru','Ð£Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ',0),(28438,790,'es','Deducciones',0),(28439,790,'de','AbzÃ¼ge',0),(28440,790,'en','Deductions',0),(28441,791,'is','',0),(28442,791,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø´Ø±Ø­ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(28443,791,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø´Ø±Ø­ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(28444,791,'tr','VarsayÄ±lan Fatura AÃ§Ä±klamasÄ±',0),(28445,791,'pl','DomyÅ›lnie Bill opis',0),(28446,791,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð±Ð¸Ð» Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(28447,791,'ur','Ø·Û’ Ø´Ø¯Û Ø¨Ù„ ØªØµØ±ÛŒØ­',0),(28448,791,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð‘Ð¸Ð» Ð¾Ð¿Ð¸Ñ',0),(28449,791,'vi','Diá»…n Giáº£i HÃ³a ÄÆ¡n Máº·c Äá»‹nh',0),(28450,791,'af','Verstek Wetsontwerp Beskrywing',0),(28451,791,'ro','Implicit Bill Descriere',0),(28452,791,'et','Bill vaikekirjeldus',0),(28453,791,'si','Privzeti raÄun opis',0),(28454,791,'ba','Deskripsi Bill default',0),(28455,791,'nl','Standaard Bill beschrijving',0),(28456,791,'fi','Laskun kuvauksen oletusarvo',0),(28457,791,'no','Standard Bill beskrivelse',0),(28458,791,'da','Standard Bill beskrivelse',0),(28459,791,'ko','ê¸°ë³¸ ë²•ì•ˆ ì„¤ëª…',0),(28460,791,'he','×ª×™××•×¨ ×—×©×‘×•×Ÿ ×‘×¨×™×¨×ª ×”×ž×—×“×œ',0),(28461,791,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(28462,791,'zh','é»˜è®¤å¸å•çš„è¯´æ˜Ž\r\n',0),(28463,791,'sv','Bill standardbeskrivning',0),(28464,791,'it','Descrizione di Bill predefinita',0),(28465,791,'tl','',0),(28466,791,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3586;&#3629;&#3591;&#3610;&#3636;&#3621;',0),(28467,791,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¬à¤¿à¤² à¤µà¤¿à¤µà¤°à¤£',0),(28468,791,'ms','Lalai Rang undang-undang keterangan',0),(28469,791,'ar','ÙˆØµÙ Ø¨ÙŠÙ„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(28470,791,'fr','Description du projet de loi par dÃ©faut',0),(28471,791,'jp','æ—¢å®šè«‹æ±‚æ›¸è§£èª¬',0),(28472,791,'pt','DescriÃ§Ã£o de conta padrÃ£o',0),(28473,791,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð‘Ð¸Ð»Ð»',0),(28474,791,'es','DescripciÃ³n de Recibo por Defecto',0),(28475,791,'de','Standardbeschreibung Bill',0),(28476,791,'en','Default Bill Description',0),(28477,792,'is','',0),(28478,792,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(28479,792,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(28480,792,'tr','VarsayÄ±lan hesap',0),(28481,792,'pl','DomyÅ›lne konto czekowe',0),(28482,792,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(28483,792,'ur','Ø·Û’ Ø´Ø¯Û Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹',0),(28484,792,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(28485,792,'vi','TK SÃ©c Máº·c Äá»‹nh',0),(28486,792,'af','Verstekte Kontrolerings Rekening',0),(28487,792,'ro','Cont de verificare implicit',0),(28488,792,'et','Vaikimisi pangakonto',0),(28489,792,'si','Privzeto preverjanje raÄuna',0),(28490,792,'ba','Default rekening',0),(28491,792,'nl','Standaard betaalrekening',0),(28492,792,'fi','Oletuksena tarkkailun huomioon',0),(28493,792,'no','Standard brukskonto',0),(28494,792,'da','Standard checkkonto',0),(28495,792,'ko','ê¸°ë³¸ ë‹¹ì¢Œ ê³„ì •',0),(28496,792,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×—×©×‘×•×Ÿ ×‘× ×§',0),(28497,792,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÏŒÏˆÎµÏ‰Ï‚',0),(28498,792,'zh','é»˜è®¤æ”¯ç¥¨å¸æˆ·\r\n',0),(28499,792,'sv','Standard lÃ¶nekonto',0),(28500,792,'it','Conto corrente predefinito',0),(28501,792,'tl','',0),(28502,792,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(28503,792,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(28504,792,'ms','Lalai memeriksa akaun',0),(28505,792,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠ',0),(28506,792,'fr','Par dÃ©faut le compte courant',0),(28507,792,'jp','æ—¢å®šå°?åˆ‡æ‰‹å‹˜å®š',0),(28508,792,'pt','Conta padrÃ£o',0),(28509,792,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ñ‚ÐµÐºÑƒÑ‰Ð¸Ð¹ ÑÑ‡ÐµÑ‚',0),(28510,792,'es','Cuenta de Cheques por Defecto',0),(28511,792,'de','Standard-Girokonto',0),(28512,792,'en','Default Checking Account',0),(28513,793,'is','',0),(28514,793,'dr','( Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ) Ø¨Ø±Ø§ÙŠ Ø¬ÙˆÙ‡Ø± ',0),(28515,793,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ù¾ÙˆØ´Ø´( Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ) Ø¨Ø±Ø§ÙŠ Ø¬ÙˆÙ‡Ø± ',0),(28516,793,'tr','MÃ¼rekkep iÃ§in varsayÄ±lan kapsamÄ±',0),(28517,793,'pl','DomyÅ›lnie pokrycie tuszem',0),(28518,793,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ Ð·Ð° Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ',0),(28519,793,'ur','Ø³ÛŒØ§ÛÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û Ú©ÙˆØ±ÛŒØ¬',0),(28520,793,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾ Ð¿Ð¾ÐºÑ€Ð¸Ñ›Ðµ Ð·Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾',0),(28521,793,'vi','Máº·c Ä‘á»‹nh pháº¡m vi cho má»±c',0),(28522,793,'af','Verstek dekking vir ink',0),(28523,793,'ro','Implicit acoperire pentru cernealÄƒ',0),(28524,793,'et','Vaike kate tint',0),(28525,793,'si','Privzeto pokritost s Ärnilom',0),(28526,793,'ba','Cakupan standar untuk tinta',0),(28527,793,'nl','Standaard dekking voor inkt',0),(28528,793,'fi','Oletuksena kattavuus muste',0),(28529,793,'no','Standard dekning for blekk',0),(28530,793,'da','Standard dÃ¦kning for blÃ¦k',0),(28531,793,'ko','ìž‰í¬ì— ëŒ€ í•œ ê¸°ë³¸ ë²”ìœ„',0),(28532,793,'he','×›×™×¡×•×™ ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×‘×•×¨ ×“×™×•',0),(28533,793,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® ÎºÎ¬Î»Ï…ÏˆÎ· Î³Î¹Î± Î¼ÎµÎ»Î¬Î½Î¹',0),(28534,793,'zh','é»˜è®¤è¦†ç›–çŽ‡å¢¨æ°´\r\n',0),(28535,793,'sv','Standard tÃ¤ckning fÃ¶r blÃ¤ck',0),(28536,793,'it','Riempimento predefinito per inchiostro',0),(28537,793,'tl','',0),(28538,793,'th','&#3588;&#3623;&#3634;&#3617;&#3588;&#3640;&#3657;&#3617;&#3588;&#3619;&#3629;&#3591;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3627;&#3617;&#3638;&#3585;',0),(28539,793,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤•à¤µà¤°à¥‡à¤œ',0),(28540,793,'ms','Perlindungan lalai untuk dakwat',0),(28541,793,'ar','ØªØºØ·ÙŠØ© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù„Ø­Ø¨Ø±',0),(28542,793,'fr','Couverture de dÃ©faut d\'encre',0),(28543,793,'jp','ã‚¤ãƒ³ã‚¯ã?®æ—¢å®šå¯¾è±¡ç¯„å›²',0),(28544,793,'pt','Cobertura de padrÃ£o de tinta',0),(28545,793,'ru','ÐžÑÐ²ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ ÐºÑ€Ð°ÑÐºÐ¸',0),(28546,793,'es','Cobertura por defecto para tinta',0),(28547,793,'de','Standard-Abdeckung fÃ¼r Tinte',0),(28548,793,'en','Default coverage for ink',0),(28549,794,'is','',0),(28550,794,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­ÙˆØ§Ù„Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡',0),(28551,794,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­ÙˆØ§Ù„Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡',0),(28552,794,'tr','VarsayÄ±lan doÄŸrulayÄ±cÄ±',0),(28553,794,'pl','DomyÅ›lnie promujÄ…cego',0),(28554,794,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡Ð¸Ñ‚ÐµÐ»',0),(28555,794,'ur','Ø·Û’ Ø´Ø¯Û Endorser',0),(28556,794,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¶Ð¸Ñ€Ð°Ð½Ñ‚Ð°',0),(28557,794,'vi','XÃ¡c nháº­n Máº·c Ä‘á»‹nh',0),(28558,794,'af','Verstek Endorser',0),(28559,794,'ro','Implicit girant',0),(28560,794,'et','Vaikimisi toetaja',0),(28561,794,'si','Privzeto podpornik',0),(28562,794,'ba','Default Endorser',0),(28563,794,'nl','Standaard Endorser',0),(28564,794,'fi','Oletuksena Endorser',0),(28565,794,'no','Standard Endorser',0),(28566,794,'da','Standard Endorser',0),(28567,794,'ko','ê¸°ë³¸ Endorser',0),(28568,794,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ Endorser',0),(28569,794,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® ÎµÏ€Î¹ÏƒÏ†ÏÎ¬Î³Î¹ÏƒÎ·Ï‚',0),(28570,794,'zh','é»˜è®¤ä»£è¨€äºº\r\n',0),(28571,794,'sv','Standard Endorser',0),(28572,794,'it','Endorser predefinito',0),(28573,794,'tl','',0),(28574,794,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3612;&#3641;&#3657;&#3621;&#3591;&#3609;&#3634;&#3617;',0),(28575,794,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ Endorser',0),(28576,794,'ms','Penyokong lalai',0),(28577,794,'ar','Ø£Ø¯Ø§Ø© Ø§Ù„Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(28578,794,'fr','Endosseur par dÃ©faut',0),(28579,794,'jp','æ—¢å®šè£?æ›¸äºº',0),(28580,794,'pt','PadrÃ£o endossante',0),(28581,794,'ru','Ð˜Ð½Ð´Ð¾ÑÑÐ°Ð½Ñ‚ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(28582,794,'es','Endosante por Defecto',0),(28583,794,'de','Standard-Endorser',0),(28584,794,'en','Default Endorser',0),(28585,795,'is','',0),(28586,795,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(28587,795,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(28588,795,'tr','VarsayÄ±lan GL hesabÄ±',0),(28589,795,'pl','DomyÅ›lne konto GL',0),(28590,795,'bg','GL Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(28591,795,'ur','Ø·Û’ Ø´Ø¯Û Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(28592,795,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð“Ð›',0),(28593,795,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Máº·c Äá»‹nh',0),(28594,795,'af','Verstekte AG Rekening',0),(28595,795,'ro','Cont de GL implicit',0),(28596,795,'et','Vaikekonto GL',0),(28597,795,'si','Privzeti raÄun za GL',0),(28598,795,'ba','Akun bawaan GL',0),(28599,795,'nl','Standaardaccount voor GL',0),(28600,795,'fi','GL oletustili',0),(28601,795,'no','Standardkontoen GL',0),(28602,795,'da','Standardkontoen GL',0),(28603,795,'ko','ê¸°ë³¸ GL ê³„ì •',0),(28604,795,'he','×—×©×‘×•×Ÿ ×‘×¨×™×¨×ª ×”×ž×—×“×œ GL',0),(28605,795,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(28606,795,'zh','é»˜è®¤æ€»å¸å¸æˆ·\r\n',0),(28607,795,'sv','Standardkontot GL',0),(28608,795,'it','Account predefinito di GL',0),(28609,795,'tl','',0),(28610,795,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(28611,795,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ GL à¤–à¤¾à¤¤à¥‡',0),(28612,795,'ms','Akaun GL lalai',0),(28613,795,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠ',0),(28614,795,'fr','Compte GL par dÃ©faut',0),(28615,795,'jp','æ—¢å®šå…ƒå¸³',0),(28616,795,'pt','Conta padrÃ£o de GL',0),(28617,795,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ GL',0),(28618,795,'es','Cuenta LM por Defecto',0),(28619,795,'de','GL Standardkonto',0),(28620,795,'en','Default GL Account',0),(28621,796,'is','',0),(28622,796,'dr','Ù…Ø­Ù„ Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(28623,796,'pr','Ù…Ø­Ù„ Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(28624,796,'tr','VarsayÄ±lan konum',0),(28625,796,'pl','DomyÅ›lna lokalizacja',0),(28626,796,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(28627,796,'ur','Ø·Û’ Ø´Ø¯Û Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(28628,796,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(28629,796,'vi','Vá»‹ trÃ­ Máº·c Ä‘á»‹nh',0),(28630,796,'af','Verstekte Ligging',0),(28631,796,'ro','LocaÅ£ia implicitÄƒ',0),(28632,796,'et','Vaikeasukohta',0),(28633,796,'si','Privzeto mesto',0),(28634,796,'ba','Lokasi default',0),(28635,796,'nl','Standaardlocatie',0),(28636,796,'fi','Oletussijainti',0),(28637,796,'no','Standardplassering',0),(28638,796,'da','Standardplaceringen',0),(28639,796,'ko','ê¸°ë³¸ ìœ„ì¹˜',0),(28640,796,'he','×ž×™×§×•× ×‘×¨×™×¨×ª ×”×ž×—×“×œ',0),(28641,796,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¸Î­ÏƒÎ·',0),(28642,796,'zh','é»˜è®¤ä½ç½®\r\n',0),(28643,796,'sv','Standardplatsen',0),(28644,796,'it','Percorso predefinito',0),(28645,796,'tl','',0),(28646,796,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;',0),(28647,796,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥à¤¥à¤¾à¤¨',0),(28648,796,'ms','Lokasi lalai',0),(28649,796,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(28650,796,'fr','Emplacement par dÃ©faut',0),(28651,796,'jp','æ—¢å®šãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(28652,796,'pt','LocalizaÃ§Ã£o padrÃ£o',0),(28653,796,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ ÐŸÐ¾ Ð£Ð¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(28654,796,'es','UbicaciÃ³n por Defecto',0),(28655,796,'de','Standardspeicherort',0),(28656,796,'en','Default Location',0),(28657,797,'is','',0),(28658,797,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª ',0),(28659,797,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª ',0),(28660,797,'tr','VarsayÄ±lan fiyat dÃ¼zeyi',0),(28661,797,'pl','DomyÅ›lnie poziom cen',0),(28662,797,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð¾ Ñ€Ð°Ð²Ð½Ð¸Ñ‰Ðµ',0),(28663,797,'ur','Ø·Û’ Ø´Ø¯Û Ù‚ÛŒÙ…Øª Ø³Ø·Ø­',0),(28664,797,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð°',0),(28665,797,'vi','GiÃ¡ Máº·c Ä‘á»‹nh',0),(28666,797,'af','Verstekte Prysvlak',0),(28667,797,'ro','Nivelul de pret implicit',0),(28668,797,'et','Vaikimisi hinnatase',0),(28669,797,'si','Privzeta raven cen',0),(28670,797,'ba','Tingkat harga standar',0),(28671,797,'nl','Standaard prijsniveau',0),(28672,797,'fi','Oletuksena hintataso',0),(28673,797,'no','Standard prisnivÃ¥',0),(28674,797,'da','Standard prisniveau',0),(28675,797,'ko','ê¸°ë³¸ ê°€ê²© ìˆ˜ì¤€',0),(28676,797,'he','×¨×ž×ª ×ž×—×™×¨ ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(28677,797,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½',0),(28678,797,'zh','é¢„è®¾ä»·æ ¼æ°´å¹³\r\n',0),(28679,797,'sv','Standard prisnivÃ¥n',0),(28680,797,'it','Livello di prezzo predefinito',0),(28681,797,'tl','',0),(28682,797,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(28683,797,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°',0),(28684,797,'ms','Aras harga lalai',0),(28685,797,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(28686,797,'fr','Niveau de prix par dÃ©faut',0),(28687,797,'jp','æ—¢å®šä¾¡æ ¼æ°´æº–',0),(28688,797,'pt','NÃ­vel de preÃ§o padrÃ£o',0),(28689,797,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ñ†ÐµÐ½',0),(28690,797,'es','Nivel de Precios por Defecto',0),(28691,797,'de','Standard-Preisniveau',0),(28692,797,'en','Default Price Level',0),(28693,798,'is','',0),(28694,798,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø±ÙˆØ´ Ø­Ù…Ù„',0),(28695,798,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø±ÙˆØ´ Ø­Ù…Ù„',0),(28696,798,'tr','VarsayÄ±lan sevkiyat yÃ¶ntemi',0),(28697,798,'pl','DomyÅ›lna metoda wysyÅ‚ki',0),(28698,798,'bg','ÐœÐµÑ‚Ð¾Ð´ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(28699,798,'ur','Ø·Û’ Ø´Ø¯Û Ø´Ù¾Ù†Ú¯ Ø·Ø±ÛŒÙ‚Û',0),(28700,798,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ñ‡Ð¸Ð½ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(28701,798,'vi','PhÆ°Æ¡ng thá»©c váº­n chuyá»ƒn máº·c Ä‘á»‹nh',0),(28702,798,'af','Verstekte Versending Metode',0),(28703,798,'ro','MetodÄƒ de expediere prestabilitÄƒ',0),(28704,798,'et','Vaikimisi tarneviis',0),(28705,798,'si','Privzeti naÄin poÅ¡iljanja',0),(28706,798,'ba','Metode pengiriman default',0),(28707,798,'nl','Standaard Verzendingsmethode',0),(28708,798,'fi','Oletuksena toimitustapa',0),(28709,798,'no','Standard forsendelsesmÃ¥te',0),(28710,798,'da','Standard Shipping metode',0),(28711,798,'ko','ê¸°ë³¸ ë°°ì†¡ ë°©ë²•',0),(28712,798,'he','×©×™×˜×ª ×”×ž×©×œ×•×— ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(28713,798,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¼Î­Î¸Î¿Î´Î¿Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(28714,798,'zh','é»˜è®¤è¿è¾“æ–¹å¼',0),(28715,798,'sv','Standard leveranssÃ¤tt',0),(28716,798,'it','Metodo di spedizione predefinita',0),(28717,798,'tl','',0),(28718,798,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;',0),(28719,798,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¿à¤§à¤¿',0),(28720,798,'ms','Kaedah penghantaran lalai',0),(28721,798,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠØ©',0),(28722,798,'fr','Mode de livraison par dÃ©faut',0),(28723,798,'jp','æ—¢å®šé…?é€?æ–¹æ³•',0),(28724,798,'pt','MÃ©todo de envio padrÃ£o',0),(28725,798,'ru','Ð¡Ð¿Ð¾ÑÐ¾Ð± Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(28726,798,'es','MÃ©todo de Transporte por Defecto',0),(28727,798,'de','Standard-Versandart',0),(28728,798,'en','Default Shipping Method',0),(28729,799,'is','',0),(28730,799,'dr','Ø­Ø°Ù ÙƒØ±Ø¯Ù†',0),(28731,799,'pr','Ø­Ø°Ù ÙƒØ±Ø¯Ù†',0),(28732,799,'tr','Sil',0),(28733,799,'pl','UsuÅ„',0),(28734,799,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(28735,799,'ur','Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(28736,799,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸',0),(28737,799,'vi','XÃ³a',0),(28738,799,'af','Skrap',0),(28739,799,'ro','Sterge',0),(28740,799,'et','Kustuta',0),(28741,799,'si','Izbrisati',0),(28742,799,'ba','Hapus',0),(28743,799,'nl','Verwijderen',0),(28744,799,'fi','Poista',0),(28745,799,'no','Slette',0),(28746,799,'da','Slet',0),(28747,799,'ko','ì‚­ì œ',0),(28748,799,'he','×ž×—×§',0),(28749,799,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î®',0),(28750,799,'zh','åˆ é™¤',0),(28751,799,'sv','Ta bort',0),(28752,799,'it','Eliminare',0),(28753,799,'tl','',0),(28754,799,'th','&#3621;&#3610;',0),(28755,799,'hi','à¤¹à¤Ÿà¤¾à¤à¤',0),(28756,799,'ms','Menghapuskan',0),(28757,799,'ar','Ø§Ù„Ø­Ø°Ù',0),(28758,799,'fr','Supprimer',0),(28759,799,'jp','æ¶ˆåŽ»',0),(28760,799,'pt','Excluir',0),(28761,799,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ',0),(28762,799,'es','Eliminar',0),(28763,799,'de','LÃ¶schen',0),(28764,799,'en','Delete',0),(28765,800,'is','',0),(28766,800,'dr','Ø­Ø°Ù Ø¹Ù…Ù„ÙŠØ§Øª',0),(28767,800,'pr','Ø­Ø°Ù Ø¹Ù…Ù„ÙŠØ§Øª',0),(28768,800,'tr','Eylem silme',0),(28769,800,'pl','UsunÄ…Ä‡ akcjÄ™',0),(28770,800,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(28771,800,'ur','Ø¹Ù…Ù„ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(28772,800,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ð°',0),(28773,800,'vi','XÃ³a hÃ nh Ä‘á»™ng',0),(28774,800,'af','Skrap Aksie',0),(28775,800,'ro','Sterge actiune',0),(28776,800,'et','Kustuta tegevus',0),(28777,800,'si','Izbrisati dejanje',0),(28778,800,'ba','Menghapus tindakan',0),(28779,800,'nl','Actie verwijderen',0),(28780,800,'fi','Poista tehtÃ¤vÃ¤',0),(28781,800,'no','Slette handling',0),(28782,800,'da','Slet aktion',0),(28783,800,'ko','ìž‘ì—… ì‚­ì œ',0),(28784,800,'he','×ž×—×§ ×¤×¢×•×œ×”',0),(28785,800,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÎµÎ½Î­ÏÎ³ÎµÎ¹Î±Ï‚',0),(28786,800,'zh','åˆ é™¤æ“ä½œ\r\n',0),(28787,800,'sv','Ta bort Ã¥tgÃ¤rd',0),(28788,800,'it','Eliminare l\'azione',0),(28789,800,'tl','',0),(28790,800,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;',0),(28791,800,'hi','à¤¹à¤Ÿà¤¾à¤à¤ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(28792,800,'ms','Menghapuskan tindakan',0),(28793,800,'ar','Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ø­Ø°Ù',0),(28794,800,'fr','Supprimer Action',0),(28795,800,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³æ¶ˆåŽ»',0),(28796,800,'pt','Excluir a aÃ§Ã£o',0),(28797,800,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(28798,800,'es','Eliminar AcciÃ³n',0),(28799,800,'de','Aktion lÃ¶schen',0),(28800,800,'en','Delete Action',0),(28801,801,'is','',0),(28802,801,'dr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(28803,801,'pr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(28804,801,'tr','YapÄ± sipariÅŸi sil',0),(28805,801,'pl','UsuÅ„ zamÃ³wienie budowaÄ‡',0),(28806,801,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ñ€Ð¾Ñ Ñ€ÐµÐ´',0),(28807,801,'ur','ØªØ¹Ù…ÛŒØ± Ø­Ú©Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(28808,801,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð‘ÑƒÐ¸Ð»Ð´',0),(28809,801,'vi','XÃ³a ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(28810,801,'af','Skrap Geboude Bestelling',0),(28811,801,'ro','ÅžtergeÅ£i construi ordine',0),(28812,801,'et','Kustutada ehitada',0),(28813,801,'si','Izbrisati izgradnje',0),(28814,801,'ba','Menghapus membangun Order',0),(28815,801,'nl','Build Order verwijderen',0),(28816,801,'fi','Poistaa tilauksen mukaan',0),(28817,801,'no','Bygge en ordre slettes',0),(28818,801,'da','Slette Byg efter ordre',0),(28819,801,'ko','ë¹Œë“œ ìˆœì„œë¥¼ ì‚­ì œ',0),(28820,801,'he','×ž×—×™×§×ª ×‘× ×™×” ×”×–×ž× ×”',0),(28821,801,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® ÎµÎ½Ï„Î¿Î»Î®',0),(28822,801,'zh','æž„å»ºé¡ºåºåˆ é™¤\r\n',0),(28823,801,'sv','Ta bort bygga Order',0),(28824,801,'it','Eliminare l\'ordine di compilazione',0),(28825,801,'tl','',0),(28826,801,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(28827,801,'hi','à¤¬à¤¿à¤²à¥à¤¡ à¤•à¥à¤°à¤® à¤¹à¤Ÿà¤¾à¤à¤',0),(28828,801,'ms','Padam perintah membina',0),(28829,801,'ar','Ø­Ø°Ù ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(28830,801,'fr','Supprimer l\'ordre de compilation',0),(28831,801,'jp','çµ„ç«‹æ³¨æ–‡ã‚’æ¶ˆåŽ»',0),(28832,801,'pt','Excluir a ordem de compilaÃ§Ã£o',0),(28833,801,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(28834,801,'es','Eliminar Orden de ConstrucciÃ³n',0),(28835,801,'de','Build Order lÃ¶schen',0),(28836,801,'en','Delete Build Order',0),(28837,802,'is','',0),(28838,802,'dr','Ø­Ø°Ù Ú¯Ø±ÙˆÙ‡ ',0),(28839,802,'pr','Ø­Ø°Ù Ú¯Ø±ÙˆÙ‡ ',0),(28840,802,'tr','Kategori silme',0),(28841,802,'pl','Usuwanie kategorii',0),(28842,802,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(28843,802,'ur','Ù‚Ø³Ù… Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(28844,802,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(28845,802,'vi','XÃ³a thá»ƒ loáº¡i',0),(28846,802,'af','Skrap Kategorie',0),(28847,802,'ro','ÅžtergeÅ£i categorie',0),(28848,802,'et','Kustuta kategooria',0),(28849,802,'si','Izbrisati kategorijo',0),(28850,802,'ba','Hapus Kategori',0),(28851,802,'nl','Categorie verwijderen',0),(28852,802,'fi','Poista luokka',0),(28853,802,'no','Slett kategori',0),(28854,802,'da','Slet kategori',0),(28855,802,'ko','ë²”ì£¼ ì‚­ì œ',0),(28856,802,'he','×ž×—×§ ×§×˜×’×•×¨×™×™×”',0),(28857,802,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(28858,802,'zh','åˆ é™¤ç±»åˆ«\r\n',0),(28859,802,'sv','Ta bort kategori',0),(28860,802,'it','Eliminare categoria',0),(28861,802,'tl','',0),(28862,802,'th','&#3621;&#3610;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(28863,802,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¹à¤Ÿà¤¾à¤à¤',0),(28864,802,'ms','Hapus kategori',0),(28865,802,'ar','Ø­Ø°Ù Ø§Ù„ØªØµÙ†ÙŠÙ',0),(28866,802,'fr','Supprimer la catÃ©gorie',0),(28867,802,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼æ¶ˆåŽ»',0),(28868,802,'pt','Excluir categoria',0),(28869,802,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(28870,802,'es','Eliminar CategorÃ­a',0),(28871,802,'de','Kategorie lÃ¶schen',0),(28872,802,'en','Delete Category',0),(28873,803,'is','',0),(28874,803,'dr','Ø­Ø°Ù\r\n Ded.',0),(28875,803,'pr','Ø­Ø°Ù\r\n Ded.',0),(28876,803,'tr','Ded silin.',0),(28877,803,'pl','UsuÅ„ Ded.',0),(28878,803,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ded.',0),(28879,803,'ur','Ø¯Ø¯ Ø­Ø°Ù Ú©Ø±ÛŒÚº Û”',0),(28880,803,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð”ÐµÐ´.',0),(28881,803,'vi','XÃ³a Ded.',0),(28882,803,'af','Skrap Aftrekk.',0),(28883,803,'ro','ÅžtergeÅ£i Ded.',0),(28884,803,'et','Kustuta Ded.',0),(28885,803,'si','Izbrisati zmletimi.',0),(28886,803,'ba','Menghapus Ded.',0),(28887,803,'nl','Ded verwijderen.',0),(28888,803,'fi','Poista Ded.',0),(28889,803,'no','Slette Ded.',0),(28890,803,'da','Slette Ded.',0),(28891,803,'ko','ê³µê²© í•œ ì‚­ì œ í•©ë‹ˆë‹¤.',0),(28892,803,'he','×ž×—×§ Ded.',0),(28893,803,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ded.',0),(28894,803,'zh','åˆ é™¤å‰¯æ‰§è¡Œå¹²äº‹ã€‚\r\n',0),(28895,803,'sv','Ta bort Ded.',0),(28896,803,'it','Eliminare Ded.',0),(28897,803,'tl','',0),(28898,803,'th','&#3621;&#3610; Ded.',0),(28899,803,'hi','Ded à¤¹à¤Ÿà¤¾à¤à¤à¥¤',0),(28900,803,'ms','Hapuskan Anugerah.',0),(28901,803,'ar','Ø­Ø°Ù Ø§Ù„Ø¯Ø§Ø¦Ø±Ø© Ø§Ù„Ø§Ù‚ØªØµØ§Ø¯ÙŠØ©.',0),(28902,803,'fr','Supprimer Ded.',0),(28903,803,'jp','Delete Ded.',0),(28904,803,'pt','Exclua Ded.',0),(28905,803,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð£Ð´ÐµÑ€Ð¶.',0),(28906,803,'es','Eliminar Ded.',0),(28907,803,'de','LÃ¶schen Sie Ded.',0),(28908,803,'en','Delete Ded.',0),(28909,804,'is','',0),(28910,804,'dr','Ø­Ø°Ù Ø¬Ø±Ø¦ÙŠØ§Øª Ø³Ø·Ø± ',0),(28911,804,'pr','Ø­Ø°Ù Ø¬Ø±Ø¦ÙŠØ§Øª Ø³Ø·Ø± ',0),(28912,804,'tr','AyrÄ±ntÄ± satÄ±rÄ± Sil',0),(28913,804,'pl','UsuÅ„ wiersz szczegÃ³Å‚Ã³w',0),(28914,804,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð´ÐµÑ‚Ð°Ð¹Ð» Ð»Ð¸Ð½Ð¸Ñ',0),(28915,804,'ur','ØªÙØµÛŒÙ„ Ø³Ø·Ø± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(28916,804,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ñ€ÐµÐ´ Ð´ÐµÑ‚Ð°Ñ™',0),(28917,804,'vi','XÃ³a dÃ²ng chi tiáº¿t',0),(28918,804,'af','Skrap Detaillyn',0),(28919,804,'ro','Åžterge linia de detaliu',0),(28920,804,'et','Kustuta Ã¼ksikasja Real',0),(28921,804,'si','IzbriÅ¡ite vrstico podrobnosti',0),(28922,804,'ba','Menghapus baris Detail',0),(28923,804,'nl','Detail lijn verwijderen',0),(28924,804,'fi','Poista rivillÃ¤',0),(28925,804,'no','Slette detaljlinje',0),(28926,804,'da','Slette detaljelinje',0),(28927,804,'ko','ì„¸ë¶€ ë¼ì¸ ì‚­ì œ',0),(28928,804,'he','×œ×ž×—×•×§ ×©×•×¨×ª ×¤×¨×˜',0),(28929,804,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î³ÏÎ±Î¼Î¼Î®Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(28930,804,'zh','åˆ é™¤æ˜Žç»†è¡Œ\r\n',0),(28931,804,'sv','Ta bort detalj raden',0),(28932,804,'it','Eliminare la riga di dettaglio',0),(28933,804,'tl','',0),(28934,804,'th','&#3621;&#3610;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(28935,804,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤°à¥‡à¤–à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(28936,804,'ms','Menghapuskan garisan terperinci',0),(28937,804,'ar','Ø­Ø°Ù Ø§Ù„Ø³Ø·Ø± Ø¨Ø§Ù„ØªÙØµÙŠÙ„',0),(28938,804,'fr','Supprimer la ligne de dÃ©tails',0),(28939,804,'jp','æ˜Žç´°æ¥­ã‚’æ¶ˆåŽ»',0),(28940,804,'pt','Excluir linha de detalhe',0),(28941,804,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾ÐºÑƒ Ð´ÐµÑ‚Ð°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(28942,804,'es','Eliminar Linea de Detalle',0),(28943,804,'de','Detailzeile lÃ¶schen',0),(28944,804,'en','Delete Detail Line',0),(28945,805,'is','',0),(28946,805,'dr','Ø­Ø°Ù Ø³Ù†Ø¯  ',0),(28947,805,'pr','Ø­Ø°Ù Ø³Ù†Ø¯  ',0),(28948,805,'tr','Belgeyi sil',0),(28949,805,'pl','Usuwanie dokumentu',0),(28950,805,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(28951,805,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(28952,805,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(28953,805,'vi','XÃ³a tÃ i liá»‡u',0),(28954,805,'af','Skrap Dokument',0),(28955,805,'ro','È˜tergeÈ›i documentul',0),(28956,805,'et','Kustuta dokument',0),(28957,805,'si','Brisanje dokumentov',0),(28958,805,'ba','Menghapus dokumen',0),(28959,805,'nl','Document verwijderen',0),(28960,805,'fi','Poista asiakirja',0),(28961,805,'no','Slette dokumentet',0),(28962,805,'da','Slet dokument',0),(28963,805,'ko','ë¬¸ì„œ ì‚­ì œ',0),(28964,805,'he','×ž×—×§ ×ž×¡×ž×š',0),(28965,805,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ Î­Î³Î³ÏÎ±Ï†Î¿',0),(28966,805,'zh','åˆ é™¤æ–‡æ¡£\r\n',0),(28967,805,'sv','Ta bort dokument',0),(28968,805,'it','Eliminare il documento',0),(28969,805,'tl','',0),(28970,805,'th','&#3621;&#3610;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(28971,805,'hi','à¤¦à¤¸à¥ à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¹à¤Ÿà¤¾à¤à¤',0),(28972,805,'ms','Hapus dokumen',0),(28973,805,'ar','Ø­Ø°Ù Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(28974,805,'fr','Supprimer le Document',0),(28975,805,'jp','æ–‡æ›¸ã‚’æ¶ˆåŽ»',0),(28976,805,'pt','Excluir documento',0),(28977,805,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(28978,805,'es','Eliminar Documento',0),(28979,805,'de','Dokument lÃ¶schen',0),(28980,805,'en','Delete Document',0),(28981,806,'is','',0),(28982,806,'dr','Ø­Ø°Ù Ø«Ø¨Øª ',0),(28983,806,'pr','Ø­Ø°Ù Ø«Ø¨Øª ',0),(28984,806,'tr','Girdisini silme',0),(28985,806,'pl','UsuÅ„ wpis',0),(28986,806,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ°',0),(28987,806,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(28988,806,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(28989,806,'vi','XÃ³a Entry',0),(28990,806,'af','Skrap Inskrywing',0),(28991,806,'ro','Åžterge intrarea',0),(28992,806,'et','Kustuta sissekanne',0),(28993,806,'si','IzbriÅ¡ite vnos',0),(28994,806,'ba','Menghapus entri',0),(28995,806,'nl','Vermelding verwijderen',0),(28996,806,'fi','Poista merkintÃ¤',0),(28997,806,'no','Slette oppfÃ¸ringen',0),(28998,806,'da','Slette posten',0),(28999,806,'ko','í•­ëª© ì‚­ì œ',0),(29000,806,'he','×œ×ž×—×•×§ ×¢×¨×š',0),(29001,806,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚',0),(29002,806,'zh','åˆ é™¤æ¡ç›®\r\n',0),(29003,806,'sv','Ta bort post',0),(29004,806,'it','Eliminare voce',0),(29005,806,'tl','',0),(29006,806,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(29007,806,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¹à¤Ÿà¤¾à¤à¤',0),(29008,806,'ms','Memadam kemasukan',0),(29009,806,'ar','Ø­Ø°Ù Ø¥Ø¯Ø®Ø§Ù„',0),(29010,806,'fr','Supprimer l\'entrÃ©e',0),(29011,806,'jp','ã‚¨ãƒ³ãƒˆãƒªãƒ¼æ¶ˆåŽ»',0),(29012,806,'pt','Excluir entrada',0),(29013,806,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(29014,806,'es','Eliminar Entrada',0),(29015,806,'de','Eintrag lÃ¶schen',0),(29016,806,'en','Delete Entry',0),(29017,807,'is','',0),(29018,807,'dr','Ø­Ø°Ù Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(29019,807,'pr','Ø­Ø°Ù Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(29020,807,'tr','BaÅŸarÄ±sÄ±z silme',0),(29021,807,'pl','UsuniÄ™cie nie powiodÅ‚o siÄ™',0),(29022,807,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ðµ Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(29023,807,'ur','Ù†Ø§Ú©Ø§Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29024,807,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(29025,807,'vi','XÃ³a tháº¥t báº¡i',0),(29026,807,'af','Skrapping het gefaal',0),(29027,807,'ro','È˜tergere nu a reuÈ™it',0),(29028,807,'et','Kustutamine ebaÃµnnestus',0),(29029,807,'si','Brisanje ni uspela',0),(29030,807,'ba','Hapus gagal',0),(29031,807,'nl','Verwijderen is mislukt',0),(29032,807,'fi','Poisto epÃ¤onnistui',0),(29033,807,'no','Slett mislyktes',0),(29034,807,'da','Sletning mislykkedes',0),(29035,807,'ko','ì‚­ì œ ì‹¤íŒ¨',0),(29036,807,'he','×ž×—×™×§×” × ×›×©×œ×”',0),(29037,807,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(29038,807,'zh','åˆ é™¤å¤±è´¥\r\n',0),(29039,807,'sv','Ta bort misslyckades',0),(29040,807,'it','Eliminazione non riuscita',0),(29041,807,'tl','',0),(29042,807,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(29043,807,'hi','à¤¹à¤Ÿà¤¾à¤à¤ à¤µà¤¿à¤«à¤²',0),(29044,807,'ms','Delete yang gagal',0),(29045,807,'ar','ÙØ´Ù„ Ø§Ù„Ø­Ø°Ù',0),(29046,807,'fr','Ã‰chouÃ© de la suppression',0),(29047,807,'jp','æ¶ˆåŽ»å¤±æ•—',0),(29048,807,'pt','Falha ao excluir',0),(29049,807,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ',0),(29050,807,'es','Eliminar fallÃ³',0),(29051,807,'de','LÃ¶schen fehlgeschlagen',0),(29052,807,'en','Delete failed',0),(29053,808,'is','',0),(29054,808,'dr','Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(29055,808,'pr','Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(29056,808,'tr','Fatura ÅŸartlarÄ± Sil',0),(29057,808,'pl','UsuÅ„ fakturÄ™ warunki',0),(29058,808,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð¸',0),(29059,808,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29060,808,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸Ñ‚Ðµ ÑƒÑÐ»Ð¾Ð²Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(29061,808,'vi','XÃ³a Ä‘iá»u khoáº£n hÃ³a Ä‘Æ¡n',0),(29062,808,'af','Skrap Faktuurterme',0),(29063,808,'ro','Sterge conditiile facturii',0),(29064,808,'et','Kustuta maksetingimused',0),(29065,808,'si','IzbriÅ¡ite pogoje raÄuna',0),(29066,808,'ba','Menghapus istilah faktur',0),(29067,808,'nl','Voorwaarden van de factuur verwijderen',0),(29068,808,'fi','Poistaa laskun ehtojen',0),(29069,808,'no','Slette faktureringsvilkÃ¥r',0),(29070,808,'da','Slette fakturaen vilkÃ¥r',0),(29071,808,'ko','ì†¡ìž¥ ìš©ì–´ ì‚­ì œ',0),(29072,808,'he','×œ×ž×—×•×§ ×—×©×‘×•× ×™×ª ×ª× ××™',0),(29073,808,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(29074,808,'zh','åˆ é™¤å‘ç¥¨æ¡æ¬¾\r\n',0),(29075,808,'sv','Ta bort faktura villkor',0),(29076,808,'it','Eliminare i termini di fattura',0),(29077,808,'tl','',0),(29078,808,'th','&#3621;&#3610;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(29079,808,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤¿à¤¯à¤® à¤¹à¤Ÿà¤¾à¤à¤',0),(29080,808,'ms','Menghapuskan syarat invois',0),(29081,808,'ar','Ø­Ø°Ù Ø´Ø±ÙˆØ· Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(29082,808,'fr','Supprimer les termes de la facture',0),(29083,808,'jp','è«‹æ±‚æ?¡ä»¶æ¶ˆåŽ»',0),(29084,808,'pt','Excluir termos de factura',0),(29085,808,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð°',0),(29086,808,'es','Eliminar TÃ©rminos de la Factura',0),(29087,808,'de','LÃ¶schen von Rechnung AusdrÃ¼cken',0),(29088,808,'en','Delete Invoice Terms',0),(29089,809,'is','',0),(29090,809,'dr','Ø­Ø°Ù Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­Ù„ ',0),(29091,809,'pr','Ø­Ø°Ù Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­Ù„ ',0),(29092,809,'tr','Konum bilgisini Sil',0),(29093,809,'pl','UsuÅ„ informacje o lokalizacji',0),(29094,809,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑÑ‚Ð° Ð·Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(29095,809,'ur','Ù…Ù‚Ø§Ù… Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29096,809,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸',0),(29097,809,'vi','XÃ³a Vá»‹ trÃ­ thÃ´ng tin',0),(29098,809,'af','Skrap Plek Inligting',0),(29099,809,'ro','È˜tergeÈ›i informaÈ›iile despre locaÈ›ie',0),(29100,809,'et','Kustuta asukoha informatsioon',0),(29101,809,'si','Izbrisati informacije o lokaciji',0),(29102,809,'ba','Menghapus informasi lokasi',0),(29103,809,'nl','Locatie-informatie verwijderen',0),(29104,809,'fi','Poistaa sijaintitiedot',0),(29105,809,'no','Slette plasseringen beskjed',0),(29106,809,'da','Slette oplysninger om placering',0),(29107,809,'ko','ìœ„ì¹˜ ì •ë³´ ì‚­ì œ',0),(29108,809,'he','×ž×—×™×§×ª ×ž×™×“×¢ ×ž×™×§×•×',0),(29109,809,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Ï„Î¿ Ï€Î»Î·',0),(29110,809,'zh','åˆ é™¤ä½ç½®ä¿¡æ¯\r\n',0),(29111,809,'sv','Ta bort platsinformation',0),(29112,809,'it','Eliminare le informazioni di posizione',0),(29113,809,'tl','',0),(29114,809,'th','&#3621;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(29115,809,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¹à¤Ÿà¤¾à¤à¤',0),(29116,809,'ms','Menghapuskan maklumat lokasi',0),(29117,809,'ar','Ø­Ø°Ù Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(29118,809,'fr','Supprimer les informations de localisation',0),(29119,809,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³æƒ…å ±æ¶ˆåŽ»',0),(29120,809,'pt','Excluir informaÃ§Ãµes de localizaÃ§Ã£o',0),(29121,809,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ðž ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¸',0),(29122,809,'es','Eliminar InformaciÃ³n de UbicaciÃ³n',0),(29123,809,'de','Standortinformationen zu lÃ¶schen',0),(29124,809,'en','Delete Location Information',0),(29125,810,'is','',0),(29126,810,'dr','Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(29127,810,'pr','Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(29128,810,'tr','Ã–deme ÅŸartlarÄ± Sil',0),(29129,810,'pl','UsuÅ„ terminy pÅ‚atnoÅ›ci',0),(29130,810,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(29131,810,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø· Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29132,810,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ ÑƒÑÐ»Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(29133,810,'vi','XÃ³a Ä‘iá»u khoáº£n thanh toÃ¡n',0),(29134,810,'af','Skrap Betalingsterme',0),(29135,810,'ro','ÅžtergeÅ£i condiÅ£ii de platÄƒ',0),(29136,810,'et','Kustuta maksetingimused',0),(29137,810,'si','Brisanje plaÄilnih pogojev',0),(29138,810,'ba','Menghapus ketentuan pembayaran',0),(29139,810,'nl','Betalingscondities verwijderen',0),(29140,810,'fi','Poista maksuehdot',0),(29141,810,'no','Slette betalingsbetingelser',0),(29142,810,'da','Slette betalingsbetingelser',0),(29143,810,'ko','ì§€ë¶ˆ ì¡°ê±´ ì‚­ì œ',0),(29144,810,'he','×œ×ž×—×•×§ ××ª ×ª× ××™ ×”×ª×©×œ×•×',0),(29145,810,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÏŒÏÎ¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(29146,810,'zh','ä»˜æ¬¾æ¡æ¬¾åˆ é™¤\r\n',0),(29147,810,'sv','Ta bort betalningsvillkor',0),(29148,810,'it','Eliminare i termini di pagamento',0),(29149,810,'tl','',0),(29150,810,'th','&#3621;&#3610;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(29151,810,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤¹à¤Ÿà¤¾ à¤¦à¥‡à¤‚',0),(29152,810,'ms','Menghapuskan terma pembayaran',0),(29153,810,'ar','Ø­Ø°Ù Ø´Ø±ÙˆØ· Ø§Ù„Ø¯ÙØ¹',0),(29154,810,'fr','Supprimer les conditions de paiement',0),(29155,810,'jp','æ”¯æ‰•ã?„æ?¡ä»¶ã?®å‰Šé™¤',0),(29156,810,'pt','Excluir termos de pagamento',0),(29157,810,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(29158,810,'es','Eliminar TÃ©rminos de Pago',0),(29159,810,'de','Zahlungsbedingungen zu lÃ¶schen',0),(29160,810,'en','Delete Payment Terms',0),(29161,811,'is','',0),(29162,811,'dr','Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø±  ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ',0),(29163,811,'pr','Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø±  ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ',0),(29164,811,'tr','Pasta Sil',0),(29165,811,'pl','UsuÅ„ Pie',0),(29166,811,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð°Ð¹',0),(29167,811,'ur','Ù¾Ø§Ø¦ÛŒ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29168,811,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¿Ð¸Ñ‚Ñƒ',0),(29169,811,'vi','XÃ³a á»‘ng',0),(29170,811,'af','Skrap Sirkeldiagram',0),(29171,811,'ro','ÅžtergeÅ£i Pie',0),(29172,811,'et','Kustuta sektordiagramm',0),(29173,811,'si','Izbrisati Pie',0),(29174,811,'ba','Menghapus Pie',0),(29175,811,'nl','Verwijderen van Pie',0),(29176,811,'fi','Poista Pie',0),(29177,811,'no','Slette Pie',0),(29178,811,'da','Slette Pie',0),(29179,811,'ko','íŒŒì´ ì‚­ì œ',0),(29180,811,'he','×ž×—×™×§×ª ×¤××™',0),(29181,811,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï€Î¯Ï„Î±',0),(29182,811,'zh','åˆ é™¤é¥¼çŠ¶å›¾\r\n',0),(29183,811,'sv','Ta bort paj',0),(29184,811,'it','Eliminare la torta',0),(29185,811,'tl','',0),(29186,811,'th','&#3621;&#3610; Pie',0),(29187,811,'hi','à¤ªà¤¾à¤ˆ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29188,811,'ms','Menghapuskan pai',0),(29189,811,'ar','Ø­Ø°Ù Ø¯Ø§Ø¦Ø±ÙŠ',0),(29190,811,'fr','Supprimer Pie',0),(29191,811,'jp','ãƒ‘ã‚¤æ¶ˆåŽ»',0),(29192,811,'pt','Excluir torta',0),(29193,811,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¿Ð¸Ñ€Ð¾Ð³',0),(29194,811,'es','Eliminar Pie',0),(29195,811,'de','Pie zu lÃ¶schen',0),(29196,811,'en','Delete Pie',0),(29197,812,'is','',0),(29198,812,'dr','Ø­Ø°Ù Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø§ÙŠÙ† Ù‚Ø³Ù…Øª ',0),(29199,812,'pr','Ø­Ø°Ù Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø§ÙŠÙ† Ù‚Ø³Ù…Øª ',0),(29200,812,'tr','Bu bÃ¶lÃ¼mÃ¼ fiyatlandÄ±rma Sil',0),(29201,812,'pl','UsuÅ„ ceny tej czÄ™Å›ci',0),(29202,812,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ñ‡Ð°ÑÑ‚ Ð·Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(29203,812,'ur','Ø§Ø³ Ø­ØµÛ’ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29204,812,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ ÑƒÐ»Ð¾Ð³Ñƒ Ñƒ Ð¾Ð´Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÑƒ Ñ†ÐµÐ½Ð°',0),(29205,812,'vi','XÃ³a giÃ¡ cá»§a pháº§n nÃ y',0),(29206,812,'af','Skrap hierdie deel pryse',0),(29207,812,'ro','ÅžtergeÅ£i aceastÄƒ parte de stabilire a preÅ£urilor',0),(29208,812,'et','Hinnad selle osa kustutamine',0),(29209,812,'si','IzbriÅ¡ite ta del cene',0),(29210,812,'ba','Menghapus harga bagian ini',0),(29211,812,'nl','Verwijderen van de prijzen van dit deel',0),(29212,812,'fi','Poista hinnoittelu tÃ¤mÃ¤n osan',0),(29213,812,'no','Slette priser denne delen',0),(29214,812,'da','Slette prissÃ¦tning denne del',0),(29215,812,'ko','ì´ ë¶€ë¶„ì„ ê°€ê²© ì‚­ì œ',0),(29216,812,'he','×ž×—×§ ×ª×ž×—×•×¨ ××ª ×”×—×œ×§ ×”×–×”',0),(29217,812,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î­Ï‚ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î­ÏÎ¿Ï‚',0),(29218,812,'zh','åˆ é™¤å®šä»·æœ¬éƒ¨\r\n',0),(29219,812,'sv','Ta bort prissÃ¤ttning denna del',0),(29220,812,'it','Eliminare questa parte di Pricing',0),(29221,812,'tl','',0),(29222,812,'th','&#3621;&#3610;&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3594;&#3636;&#3657;&#3609;&#3626;&#3656;&#3623;&#3609;&#3609;&#3637;&#3657;',0),(29223,812,'hi','à¤‡à¤¸ à¤­à¤¾à¤— à¤•à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29224,812,'ms','Hapuskan harga bahagian ini',0),(29225,812,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø¬Ø²Ø¡ Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(29226,812,'fr','Supprimer cette partie de prix',0),(29227,812,'jp','ã?“ã?®éƒ¨å“?ã?®ãƒ—ãƒ©ã‚¤ã‚·ãƒ³ã‚°ã‚’æ¶ˆåŽ»',0),(29228,812,'pt','Apagar esta parte de preÃ§os',0),(29229,812,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÑ‚Ð¾Ð¹ Ñ‡Ð°ÑÑ‚Ð¸ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(29230,812,'es','Eliminar Precio de este Parte',0),(29231,812,'de','Preise dieser Teil zu lÃ¶schen',0),(29232,812,'en','Delete Pricing this Part',0),(29233,813,'is','',0),(29234,813,'dr','Ø­Ø°Ù ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(29235,813,'pr','Ø­Ø°Ù ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(29236,813,'tr','AlÄ±ntÄ± revizyon silmek',0),(29237,813,'pl','UsuÅ„ ofertÄ™ rewizji',0),(29238,813,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð¿Ñ€ÐµÑ€Ð°Ð·Ð³Ð»ÐµÐ¶Ð´Ð°Ð½Ðµ',0),(29239,813,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29240,813,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ñƒ',0),(29241,813,'vi','XÃ³a bÃ¡o giÃ¡ chá»‰nh sá»­a',0),(29242,813,'af','Skrap Kwotasie Hersiening',0),(29243,813,'ro','ÅžtergeÅ£i revizuire citat',0),(29244,813,'et','Kustuta tsiteerida redaktsioon',0),(29245,813,'si','IzbriÅ¡i revizija citat',0),(29246,813,'ba','Menghapus revisi kutipan',0),(29247,813,'nl','Offerte herziening verwijderen',0),(29248,813,'fi','Lainaus tarkistus poistaa',0),(29249,813,'no','Slette tilbud revisjon',0),(29250,813,'da','Slette tilbud Revision',0),(29251,813,'ko','ê²¬ì  ìˆ˜ì • ì‚­ì œ',0),(29252,813,'he','×ž×—×™×§×ª ×”×¦×¢×ª ×ª×™×§×•×Ÿ',0),(29253,813,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(29254,813,'zh','åˆ é™¤æŠ¥ä»·ä¿®æ”¹\r\n',0),(29255,813,'sv','Ta bort citat Ã¶versyn',0),(29256,813,'it','Eliminare la revisione del preventivo',0),(29257,813,'tl','',0),(29258,813,'th','&#3621;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(29259,813,'hi','à¤¬à¥‹à¤²à¥€ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤¹à¤Ÿà¤¾à¤à¤',0),(29260,813,'ms','Menghapuskan Quote semakan',0),(29261,813,'ar','Ø­Ø°Ù ØªØ¹Ø¯ÙŠÙ„ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(29262,813,'fr','Supprimer le devis de rÃ©vision',0),(29263,813,'jp','è¦‹ç©?ã‚‚ã‚Šä¿®æ­£ã?®æ¶ˆåŽ»',0),(29264,813,'pt','Excluir revisÃ£o de citaÃ§Ã£o',0),(29265,813,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ñ€ÐµÐ´Ð°ÐºÑ†Ð¸Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(29266,813,'es','Eliminar RevisiÃ³n de CotizaciÃ³n',0),(29267,813,'de','Zitat Revision zu lÃ¶schen',0),(29268,813,'en','Delete Quote Revision',0),(29269,814,'is','',0),(29270,814,'dr','Ø­Ø°Ù ØªÚ©Ù‡',0),(29271,814,'pr','Ø­Ø°Ù ØªÚ©Ù‡',0),(29272,814,'tr','Dilimi silmek',0),(29273,814,'pl','UsuÅ„ plasterek',0),(29274,814,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð´ÑÐ»',0),(29275,814,'ur','Ù‚Ø§Ø´ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29276,814,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¸ÑÐµÑ‡Ð°Ðº',0),(29277,814,'vi','XÃ³a lÃ¡t cáº¯t',0),(29278,814,'af','Skyf Skrap',0),(29279,814,'ro','ÅžtergeÅ£i felie',0),(29280,814,'et','Kustuta sektor',0),(29281,814,'si','Izbrisati rezina',0),(29282,814,'ba','Menghapus Slice',0),(29283,814,'nl','Verwijderen segment',0),(29284,814,'fi','Poista siivu',0),(29285,814,'no','Slette skive',0),(29286,814,'da','Slette skive',0),(29287,814,'ko','ì¡°ê° ì‚­ì œ',0),(29288,814,'he','×ž×—×™×§×ª ×¤×¨×•×¡×”',0),(29289,814,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï†Î­Ï„Î±',0),(29290,814,'zh','åˆ é™¤åˆ‡ç‰‡\r\n',0),(29291,814,'sv','Radera skiva',0),(29292,814,'it','Eliminare la fetta',0),(29293,814,'tl','',0),(29294,814,'th','&#3621;&#3610;&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3656;&#3591;',0),(29295,814,'hi','à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29296,814,'ms','Menghapuskan Slice',0),(29297,814,'ar','Ø­Ø°Ù Ø´Ø±ÙŠØ­Ø©',0),(29298,814,'fr','Supprimer la tranche',0),(29299,814,'jp','ã‚¹ãƒ©ã‚¤ã‚¹ã‚’æ¶ˆåŽ»',0),(29300,814,'pt','Excluir a fatia',0),(29301,814,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ñ„Ñ€Ð°Ð³Ð¼ÐµÐ½Ñ‚',0),(29302,814,'es','Eliminar Rebanada',0),(29303,814,'de','Segment lÃ¶schen',0),(29304,814,'en','Delete Slice',0),(29305,815,'is','',0),(29306,815,'dr','Ø­Ø°Ù Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(29307,815,'pr','Ø­Ø°Ù Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(29308,815,'tr','Alt grup silme',0),(29309,815,'pl','UsuÅ„ podgrupy',0),(29310,815,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð°Ñ‚Ð°',0),(29311,815,'ur','Ø³Ø¨Ú¯Ø±ÙˆÙ¾ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29312,815,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ñƒ',0),(29313,815,'vi','XÃ³a nhÃ³m phá»¥',0),(29314,815,'af','Skrap Sub-groep',0),(29315,815,'ro','ÅžtergeÅ£i subgrup',0),(29316,815,'et','Kustuta alagrupp',0),(29317,815,'si','Izbrisati podskupini',0),(29318,815,'ba','Menghapus subgrup',0),(29319,815,'nl','Subgroep verwijderen',0),(29320,815,'fi','Poistaa kÃ¤sittelevÃ¤ alaryhmÃ¤',0),(29321,815,'no','Slette undergruppe',0),(29322,815,'da','Slette undergruppe',0),(29323,815,'ko','í•˜ìœ„ ê·¸ë£¹ ì‚­ì œ',0),(29324,815,'he','×ž×—×™×§×ª ×§×‘×•×¦×ª ×ž×©× ×”',0),(29325,815,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï…Ï€Î¿Î¿Î¼Î¬Î´Î±',0),(29326,815,'zh','åˆ é™¤åˆ†ç»„\r\n',0),(29327,815,'sv','Ta bort undergrupp',0),(29328,815,'it','Eliminare il sottogruppo',0),(29329,815,'tl','',0),(29330,815,'th','&#3621;&#3610;&#3585;&#3621;&#3640;&#3656;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(29331,815,'hi','à¤‰à¤ªà¤¸à¤®à¥‚à¤¹ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29332,815,'ms','Menghapuskan subkumpulan',0),(29333,815,'ar','Ø­Ø°Ù Ù…Ø¬Ù…ÙˆØ¹Ø© ÙØ±Ø¹ÙŠØ©',0),(29334,815,'fr','Supprimer le sous-groupe',0),(29335,815,'jp','ã‚µãƒ–ã‚°ãƒ«ãƒ¼ãƒ—ã‚’æ¶ˆåŽ»',0),(29336,815,'pt','Excluir o subgrupo',0),(29337,815,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(29338,815,'es','Eliminar Subgrupo',0),(29339,815,'de','LÃ¶schen Teilkonzern',0),(29340,815,'en','Delete Subgroup',0),(29341,816,'is','',0),(29342,816,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø­Ø³Ø§Ø¨ ',0),(29343,816,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø­Ø³Ø§Ø¨ ',0),(29344,816,'tr','Bu hesabÄ± silmek',0),(29345,816,'pl','UsuÅ„ to konto',0),(29346,816,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(29347,816,'ur','ÛŒÛ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29348,816,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½',0),(29349,816,'vi','XÃ³a TK NÃ y',0),(29350,816,'af','Skrap hierdie Rekening',0),(29351,816,'ro','Sterge acest cont',0),(29352,816,'et','Kustuta see konto',0),(29353,816,'si','IzbriÅ¡ite ta raÄun',0),(29354,816,'ba','Menghapus akun ini',0),(29355,816,'nl','Dit Account verwijderen',0),(29356,816,'fi','Poistaa tÃ¤mÃ¤n tilin',0),(29357,816,'no','Slette kontoen',0),(29358,816,'da','Slet denne konto',0),(29359,816,'ko','ì´ ê³„ì • ì‚­ì œ',0),(29360,816,'he','×ž×—×§ ×—×©×‘×•×Ÿ ×–×”',0),(29361,816,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(29362,816,'zh','åˆ é™¤æ­¤å¸æˆ·\r\n',0),(29363,816,'sv','Ta bort detta konto',0),(29364,816,'it','Eliminare questo Account',0),(29365,816,'tl','',0),(29366,816,'th','&#3621;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3609;&#3637;&#3657;',0),(29367,816,'hi','à¤‡à¤¸ à¤–à¤¾à¤¤à¥‡ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29368,816,'ms','Hapus akaun ini',0),(29369,816,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(29370,816,'fr','Supprimer ce compte',0),(29371,816,'jp','ã?“ã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’æ¶ˆåŽ»',0),(29372,816,'pt','Exclua esta conta',0),(29373,816,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(29374,816,'es','Eliminar esta Cuenta',0),(29375,816,'de','Dieses Konto lÃ¶schen',0),(29376,816,'en','Delete this Account',0),(29377,817,'is','',0),(29378,817,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ ',0),(29379,817,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ ',0),(29380,817,'tr','Bu hesap tÃ¼rÃ¼ Sil',0),(29381,817,'pl','UsunÄ…Ä‡ ten typ konta',0),(29382,817,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ñ‚Ð¸Ð¿ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(29383,817,'ur','Ø§Ø³ Ù‚Ø³Ù… Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29384,817,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(29385,817,'vi','XÃ³a Loáº¡i TK NÃ y',0),(29386,817,'af','Skrap hierdie Rekeningtipe',0),(29387,817,'ro','ÅžtergeÅ£i acest tip de cont',0),(29388,817,'et','Kustuta see konto tÃ¼Ã¼p',0),(29389,817,'si','IzbriÅ¡ite ta vrsta raÄuna',0),(29390,817,'ba','Menghapus akun jenis ini',0),(29391,817,'nl','Dit Type Account verwijderen',0),(29392,817,'fi','Poista tÃ¤mÃ¤ tilityyppi',0),(29393,817,'no','Slette denne kontotypen',0),(29394,817,'da','Slet denne kontotype',0),(29395,817,'ko','ì´ ê³„ì • ìœ í˜•ì€ ì‚­ì œ',0),(29396,817,'he','×œ×ž×—×•×§ ××ª ×¡×•×’ ×”×—×©×‘×•×Ÿ ×”×–×”',0),(29397,817,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï„ÏÏ€Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(29398,817,'zh','åˆ é™¤æ­¤å¸æˆ·ç±»åž‹\r\n',0),(29399,817,'sv','Ta bort denna kontotyp',0),(29400,817,'it','Eliminare questo tipo di conto',0),(29401,817,'tl','',0),(29402,817,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3609;&#3637;&#3657;',0),(29403,817,'hi','à¤‡à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29404,817,'ms','Menghapuskan jenis akaun',0),(29405,817,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø¬Ø³Ø§Ø¨ Ù‡Ø°Ø§',0),(29406,817,'fr','Supprimer ce Type de compte',0),(29407,817,'jp','ã?“ã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—ã‚’æ¶ˆåŽ»',0),(29408,817,'pt','Excluir este tipo de conta',0),(29409,817,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ñ‚Ð¸Ð¿ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(29410,817,'es','Eliminar esta Tipo de AcciÃ³n',0),(29411,817,'de','Dieser Kontotyp lÃ¶schen',0),(29412,817,'en','Delete this Account Type',0),(29413,818,'is','',0),(29414,818,'dr','Ø­Ø°Ù Ø§ÙŠÙ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(29415,818,'pr','Ø­Ø°Ù Ø§ÙŠÙ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(29416,818,'tr','Bu fatura silme',0),(29417,818,'pl','UsuÅ„ ten Bill',0),(29418,818,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(29419,818,'ur','Ø§Ø³ Ø¨Ù„ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29420,818,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð·Ð°ÐºÐ¾Ð½',0),(29421,818,'vi','XÃ³a HÃ³a ÄÆ¡n nÃ y',0),(29422,818,'af','Skrap hierdie Wetsontwerp',0),(29423,818,'ro','ÅžtergeÅ£i acest proiect de lege',0),(29424,818,'et','Kustuta see arve',0),(29425,818,'si','Brisanje tega zakona',0),(29426,818,'ba','Menghapus RUU ini',0),(29427,818,'nl','Dit wetsvoorstel verwijderen',0),(29428,818,'fi','Poista tÃ¤mÃ¤ lakiesitys',0),(29429,818,'no','Slette denne regningen',0),(29430,818,'da','Slet dette lovforslag',0),(29431,818,'ko','ì´ ë²•ì•ˆì„ ì‚­ì œ',0),(29432,818,'he','×œ×ž×—×•×§ ××ª ×”×—×©×‘×•×Ÿ',0),(29433,818,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(29434,818,'zh','åˆ é™¤æ­¤å¸å•\r\n',0),(29435,818,'sv','Ta bort detta lagfÃ¶rslag',0),(29436,818,'it','Eliminare questo disegno di legge',0),(29437,818,'tl','',0),(29438,818,'th','&#3621;&#3610;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3609;&#3637;&#3657;',0),(29439,818,'hi','à¤‡à¤¸ à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29440,818,'ms','Menghapuskan Rang undang-undang ini',0),(29441,818,'ar','Ø­Ø°Ù Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ù‡Ø°Ø§',0),(29442,818,'fr','Supprimer ce projet de loi',0),(29443,818,'jp','ã?“ã?®è«‹æ±‚æ›¸ã‚’æ¶ˆåŽ»',0),(29444,818,'pt','Exclua esta conta',0),(29445,818,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(29446,818,'es','Eliminar este Recibo',0),(29447,818,'de','LÃ¶schen Sie dieses Gesetz',0),(29448,818,'en','Delete this Bill',0),(29449,819,'is','',0),(29450,819,'dr','( ØªØ§Ø¨Ø¹ ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(29451,819,'pr','Ø­Ø°Ù Ø¹Ù…Ù„ÙŠØ§Øª ( ØªØ§Ø¨Ø¹ ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(29452,819,'tr','Bu baÄŸlayÄ±cÄ± iÅŸlev silmek',0),(29453,819,'pl','UsuÅ„ ten funkcja introligatornia',0),(29454,819,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(29455,819,'ur','ÛŒÛ Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29456,819,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ Ð‘Ð¸Ð½Ð´ÐµÑ€y',0),(29457,819,'vi','XÃ³a chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch',0),(29458,819,'af','Skrap hierdie Bindery funksie',0),(29459,819,'ro','ÅžtergeÅ£i aceastÄƒ funcÅ£ie de legatorie',0),(29460,819,'et','Kustuta see Kirjansitomo funktsioon',0),(29461,819,'si','IzbriÅ¡ite ta funkcija Knjigoveznica',0),(29462,819,'ba','Menghapus fungsi Bindery ini',0),(29463,819,'nl','Verwijderen van deze Bindery-functie',0),(29464,819,'fi','Poista Bindery-toiminto',0),(29465,819,'no','Slette denne Bindery-funksjonen',0),(29466,819,'da','Slet denne Bindery funktion',0),(29467,819,'ko','ì´ ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ ì‚­ì œ',0),(29468,819,'he','×ž×—×™×§×ª ×©×¤×•× ×§×¦×™×™×ª Bindery',0),(29469,819,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(29470,819,'zh','åˆ é™¤æ­¤è£…è®¢åŠŸèƒ½\r\n',0),(29471,819,'sv','Ta bort denna Bindery-funktion',0),(29472,819,'it','Eliminare questa funzione della legatoria',0),(29473,819,'tl','',0),(29474,819,'th','Delete this Bindery Function',0),(29475,819,'hi','à¤‡à¤¸ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29476,819,'ms','Menghapuskan fungsi Bindery ini',0),(29477,819,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ \"Ø§Ù„Ø¯Ø§Ù„Ø© ÙÙŠ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª\"',0),(29478,819,'fr','Supprimer cette fonction Bindery',0),(29479,819,'jp','ã?“ã?®ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚’æ¶ˆåŽ»',0),(29480,819,'pt','Excluir esta funÃ§Ã£o Bindery',0),(29481,819,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸ÑŽ Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ',0),(29482,819,'es','Eliminar esta FunciÃ³n de EncuadernaciÃ³n',0),(29483,819,'de','LÃ¶schen Sie diese Bindery-Funktion',0),(29484,819,'en','Delete this Bindery Function',0),(29485,820,'is','',0),(29486,820,'dr','( ØªØ§Ø¨Ø¹ ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ ',0),(29487,820,'pr','Ø­Ø°Ù Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ  Ø¹Ù…Ù„ÙŠØ§Øª ( ØªØ§Ø¨Ø¹ ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ ',0),(29488,820,'tr','Bu baÄŸlayÄ±cÄ± iÅŸlevi boyutu fiyatlandÄ±rma Sil',0),(29489,820,'pl','UsuÅ„ ten introligatornia funkcji wielkoÅ›ci ceny',0),(29490,820,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð½Ð° ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(29491,820,'ur','ÛŒÛ Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ø³Ø§Ø¦Ø² Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29492,820,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(29493,820,'vi','XÃ³a giÃ¡ kÃ­ch cá»¡ nÄƒng chá»©c Ä‘Ã³ng sÃ¡ch',0),(29494,820,'af','Skrap hierdie Bindery funksie grootte pryse',0),(29495,820,'ro','ÅžtergeÅ£i aceastÄƒ funcÅ£ie legatorie dimensiune preturi',0),(29496,820,'et','Kustuta see Kirjansitomo funktsiooni suurus hinnakujundus',0),(29497,820,'si','IzbriÅ¡ite ta Knjigoveznica funkcijo velikost cen',0),(29498,820,'ba','Menghapus ini Bindery fungsi ukuran harga',0),(29499,820,'nl','Verwijder deze Bindery functie grootte prijzen',0),(29500,820,'fi','Poista tÃ¤mÃ¤ Bindery toiminto koko hinnoittelu',0),(29501,820,'no','Slette denne bindingen funksjonen stÃ¸rrelse priser',0),(29502,820,'da','Slet denne Bindery funktion stÃ¸rrelse prissÃ¦tning',0),(29503,820,'ko','ì´ ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ í¬ê¸° ê°€ê²© ì‚­ì œ',0),(29504,820,'he','×œ×ž×—×•×§ ×–×” ×ª×ž×—×•×¨ ×’×•×“×œ ×¤×•× ×§×¦×™×” ×ž×¡×•×’ Bindery',0),(29505,820,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ Bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(29506,820,'zh','åˆ é™¤æ­¤è£…è®¢åŠŸèƒ½çš„å¤§å°å®šä»·\r\n',0),(29507,820,'sv','Ta bort denna Bindery funktion storlek prissÃ¤ttning',0),(29508,820,'it','Eliminare questa funzione di legatoria dimensioni prezzi',0),(29509,820,'tl','',0),(29510,820,'th','Delete this Bindery Function Size Pricing',0),(29511,820,'hi','à¤‡à¤¸ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤•à¤¾ à¤†à¤•à¤¾à¤° à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤¹à¤Ÿà¤¾à¤à¤',0),(29512,820,'ms','Menghapuskan ini Bindery fungsi saiz harga',0),(29513,820,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ \"Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø­Ø¬Ù… ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª\"',0),(29514,820,'fr','Supprimer cette fonction de faÃ§onnage taille prix',0),(29515,820,'jp','ã?“ã?®ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚µã‚¤ã‚ºä¾¡æ ¼è¨­å®šã‚’æ¶ˆåŽ»ã?™ã‚‹',0),(29516,820,'pt','Excluir este tamanho de funÃ§Ã£o de Bindery preÃ§os',0),(29517,820,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Bindery Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ñ†ÐµÐ½Ñ‹',0),(29518,820,'es','Eliminar esta FunciÃ³n de EncuadernaciÃ³n Precio de TamaÃ±o',0),(29519,820,'de','LÃ¶schen Sie diese Buchbinderei Funktion GrÃ¶ÃŸe Preise',0),(29520,820,'en','Delete this Bindery Function Size Pricing',0),(29521,821,'is','',0),(29522,821,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹  Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(29523,821,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹  Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(29524,821,'tr','Bu baÄŸlayÄ±cÄ± tÃ¼rÃ¼ Sil',0),(29525,821,'pl','UsunÄ…Ä‡ ten typ wiÄ…zaÅ„',0),(29526,821,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ñ‚Ð¸Ð¿ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð°',0),(29527,821,'ur','Ø§Ø³ Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29528,821,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð²Ñ€ÑÑ‚Ñƒ Ð±Ð¸Ð½Ð´ÐµÑ€y',0),(29529,821,'vi','XÃ³a loáº¡i Ä‘Ã³ng sÃ¡ch nÃ y',0),(29530,821,'af','Skrap hierdie bindery tipe',0),(29531,821,'ro','ÅžtergeÅ£i acest tip de legatorie',0),(29532,821,'et','Kustuta see Kirjansitomo tÃ¼Ã¼p',0),(29533,821,'si','Izbrisati to vrsto vezi',0),(29534,821,'ba','Menghapus jenis bindery',0),(29535,821,'nl','Dit type bindery verwijderen',0),(29536,821,'fi','Poista tÃ¤mÃ¤ kantata',0),(29537,821,'no','Slette denne bindingen',0),(29538,821,'da','Slet denne bindery type',0),(29539,821,'ko','ì´ ë°”ì¸ë”ë¦¬ í˜•ì‹ ì‚­ì œ',0),(29540,821,'he','×œ×ž×—×•×§ ×¡×•×’ ×–×” ×ž×¡×•×’ bindery',0),(29541,821,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï„ÏÏ€Î¿ bindery',0),(29542,821,'zh','åˆ é™¤æ­¤è£…è®¢ç±»åž‹\r\n',0),(29543,821,'sv','Ta bort denna bindery-typ',0),(29544,821,'it','Eliminare questo tipo di legatoria',0),(29545,821,'tl','',0),(29546,821,'th','Delete this bindery type',0),(29547,821,'hi','à¤‡à¤¸ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(29548,821,'ms','Menghapuskan jenis bindery ini',0),(29549,821,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ù†ÙˆØ¹ Ù…Ù† Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(29550,821,'fr','Supprimer ce type de faÃ§onnage',0),(29551,821,'jp','ã?“ã?®ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚¿ã‚¤ãƒ—ã‚’æ¶ˆåŽ»',0),(29552,821,'pt','Excluir este tipo de encadernaÃ§Ã£o',0),(29553,821,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ñ‚Ð¸Ð¿ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð”',0),(29554,821,'es','Eliminar esta funciÃ³n de encuadernaciÃ³n',0),(29555,821,'de','LÃ¶schen Sie derartige Buchbinderei',0),(29556,821,'en','Delete this bindery type',0),(29557,822,'is','',0),(29558,822,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(29559,822,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(29560,822,'tr','Bu taÅŸÄ±yÄ±cÄ± silin',0),(29561,822,'pl','UsuÅ„ ten przewoÅºnik',0),(29562,822,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(29563,822,'ur','ÛŒÛ Ú©ÛŒØ±ÛŒØ¦Ø± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29564,822,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð½Ð¾ÑÐ°Ñ‡',0),(29565,822,'vi','XÃ³a hÃ£ng váº­n chuyá»ƒn nÃ y',0),(29566,822,'af','Skrap hierdie Karweier',0),(29567,822,'ro','ÅžtergeÅ£i acest transportator',0),(29568,822,'et','Kustuta see vedaja',0),(29569,822,'si','IzbriÅ¡ite ta prevoznik',0),(29570,822,'ba','Menghapus maskapai ini',0),(29571,822,'nl','Verwijderen van deze luchtvaartmaatschappij',0),(29572,822,'fi','Poista kyseinen lentoliikenteen harjoittaja',0),(29573,822,'no','Slette denne bÃ¦rebÃ¸lgen',0),(29574,822,'da','Slet dette luftfartsselskab',0),(29575,822,'ko','ì´ ìš´ë°˜ëŒ€ë¥¼ ì‚­ì œ',0),(29576,822,'he','×œ×ž×—×•×§ ××ª ×”× ×•×©× ×”×–×”',0),(29577,822,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎµÎ½ Î»ÏŒÎ³Ï‰ Î±ÎµÏÎ¿Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(29578,822,'zh','åˆ é™¤æ­¤æ‰¿è¿å•†\r\n',0),(29579,822,'sv','Ta bort detta lufttrafikfÃ¶retag',0),(29580,822,'it','Eliminare questo vettore',0),(29581,822,'tl','',0),(29582,822,'th','&#3621;&#3610;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3619;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(29583,822,'hi','à¤‡à¤¸ à¤µà¤¾à¤¹à¤• à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29584,822,'ms','Menghapuskan pembawa ini',0),(29585,822,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ù†Ø§Ù‚Ù„',0),(29586,822,'fr','Supprimer ce porte-vÃ©los',0),(29587,822,'jp','ã?“ã?®é…?é€?æ¥­è€…ã‚’æ¶ˆåŽ»',0),(29588,822,'pt','Excluir desta transportadora',0),(29589,822,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ ÐšÑƒÑ€ÑŒÐµÑ€Ð°',0),(29590,822,'es','Eliminar este Transportador',0),(29591,822,'de','LÃ¶schen Sie diese Carrier',0),(29592,822,'en','Delete this Carrier',0),(29593,823,'is','',0),(29594,823,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ ',0),(29595,823,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ ',0),(29596,823,'tr','Bu kategoriyi silmek',0),(29597,823,'pl','UsunÄ…Ä‡ tÄ™ kategoriÄ™',0),(29598,823,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(29599,823,'ur','ÛŒÛ Ø²Ù…Ø±Û Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29600,823,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(29601,823,'vi','XÃ³a thá»ƒ loáº¡i nÃ y',0),(29602,823,'af','Skrap hierdie KategoriÃ«',0),(29603,823,'ro','ÅžtergeÅ£i aceastÄƒ categorie',0),(29604,823,'et','Kustuta see kategooria',0),(29605,823,'si','Izbrisati tole kategorijo',0),(29606,823,'ba','Hapus kategori ini',0),(29607,823,'nl','Deze categorie verwijderen',0),(29608,823,'fi','Poistaa tÃ¤mÃ¤n kategorian',0),(29609,823,'no','Slette denne kategorien',0),(29610,823,'da','Slette denne kategori',0),(29611,823,'ko','ì´ ë²”ì£¼ ì‚­ì œ',0),(29612,823,'he','×œ×ž×—×•×§ ×§×˜×’×•×¨×™×” ×–×•',0),(29613,823,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(29614,823,'zh','åˆ é™¤è¯¥ç±»åˆ«\r\n',0),(29615,823,'sv','Ta bort denna kategori',0),(29616,823,'it','Eliminare questa categoria',0),(29617,823,'tl','',0),(29618,823,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3609;&#3637;&#3657;',0),(29619,823,'hi','à¤‡à¤¸ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29620,823,'ms','Menghapuskan kategori ini',0),(29621,823,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„ØªØµÙ†ÙŠÙ',0),(29622,823,'fr','Supprimer cette catÃ©gorie',0),(29623,823,'jp','ã?“ã?®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’æ¶ˆåŽ»',0),(29624,823,'pt','Apagar esta categoria',0),(29625,823,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½ÑƒÑŽ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(29626,823,'es','Eliminar esta CategorÃ­a',0),(29627,823,'de','Diese Kategorie lÃ¶schen',0),(29628,823,'en','Delete this Category',0),(29629,824,'is','',0),(29630,824,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(29631,824,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(29632,824,'tr','Bu ÅŸirketi silmek',0),(29633,824,'pl','UsuniÄ™cie tej firmy',0),(29634,824,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°',0),(29635,824,'ur','Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29636,824,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(29637,824,'vi','XÃ³a Cty nÃ y',0),(29638,824,'af','Skrap hierdie Onderneming',0),(29639,824,'ro','Sterge aceasta companie',0),(29640,824,'et','Kustuta see ettevÃµte',0),(29641,824,'si','Izbrisati to podjetje',0),(29642,824,'ba','Menghapus perusahaan ini',0),(29643,824,'nl','Dit bedrijf verwijderen',0),(29644,824,'fi','Poista yritys',0),(29645,824,'no','Slett dette selskapet',0),(29646,824,'da','Slet dette selskab',0),(29647,824,'ko','ì´ íšŒì‚¬ ì‚­ì œ',0),(29648,824,'he','×œ×ž×—×•×§ ××ª ×”×—×‘×¨×” ×”×–××ª',0),(29649,824,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(29650,824,'zh','åˆ é™¤æ­¤å…¬å¸\r\n',0),(29651,824,'sv','Ta bort detta fÃ¶retag',0),(29652,824,'it','Eliminare questa azienda',0),(29653,824,'tl','',0),(29654,824,'th','&#3621;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3609;&#3637;&#3657;',0),(29655,824,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29656,824,'ms','Hapuskan Syarikat ini',0),(29657,824,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(29658,824,'fr','Supprimer cette entreprise',0),(29659,824,'jp','ã?“ã?®ä¼šç¤¾ã‚’æ¶ˆåŽ»',0),(29660,824,'pt','Excluir esta empresa',0),(29661,824,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½ÑƒÑŽ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ',0),(29662,824,'es','Eliminar esta Empresa',0),(29663,824,'de','LÃ¶schen Sie dieses Unternehmen',0),(29664,824,'en','Delete this Company',0),(29665,825,'is','',0),(29666,825,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(29667,825,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(29668,825,'tr','Bu maliyet merkezi silme',0),(29669,825,'pl','UsuÅ„ ten MPK',0),(29670,825,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(29671,825,'ur','Ø§Ø³ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ù…Ø±Ú©Ø² Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29672,825,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(29673,825,'vi','XÃ³a Cost Center nÃ y',0),(29674,825,'af','Skrap hierdie Koste Sentrum',0),(29675,825,'ro','ÅžtergeÅ£i acest centru de Cost',0),(29676,825,'et','Kustuta selle kulukeskust',0),(29677,825,'si','Izbrisati to stroÅ¡kovno srediÅ¡Äe',0),(29678,825,'ba','Menghapus ini biaya Pusat',0),(29679,825,'nl','Verwijderen van deze kosten Center',0),(29680,825,'fi','Poista tÃ¤mÃ¤ kustannuspaikka',0),(29681,825,'no','Slette denne kostsenter',0),(29682,825,'da','Slet denne omkostningssted',0),(29683,825,'ko','ì´ ë¹„ìš© ì„¼í„° ì‚­ì œ',0),(29684,825,'he','×œ×ž×—×•×§ ××ª ×ž×¨×›×– ×¢×œ×•×ª ×”×–×”',0),(29685,825,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(29686,825,'zh','åˆ é™¤æ­¤æˆæœ¬ä¸­å¿ƒ\r\n',0),(29687,825,'sv','Ta bort detta kostnadsstÃ¤lle',0),(29688,825,'it','Eliminare questo centro di costo',0),(29689,825,'tl','',0),(29690,825,'th','&#3621;&#3610;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3609;&#3637;&#3657;',0),(29691,825,'hi','à¤‡à¤¸ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29692,825,'ms','Menghapuskan Pusat kos ini',0),(29693,825,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(29694,825,'fr','Supprimer ce centre de coÃ»t',0),(29695,825,'jp','ã?“ã?®ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã‚’æ¶ˆåŽ»',0),(29696,825,'pt','Excluir este centro de custo',0),(29697,825,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ñ†ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(29698,825,'es','Eliminar este Centro de Costos',0),(29699,825,'de','LÃ¶schen dieser Kostenstelle',0),(29700,825,'en','Delete this Cost Center',0),(29701,826,'is','',0),(29702,826,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(29703,826,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(29704,826,'tr','Bu maliyet merkezi makine aile Sil',0),(29705,826,'pl','UsuÅ„ ten koszt centrum maszyny rodziny',0),(29706,826,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð²Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(29707,826,'ur','Ø§Ø³ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ù…Ø±Ú©Ø² Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù† Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29708,826,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ñƒ Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ñ†ÐµÐ½Ñ‚Ñ€Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(29709,826,'vi','XÃ³a Cost Center cho mÃ¡y gia Ä‘Ã¬nh nÃ y',0),(29710,826,'af','Skrap hierdie Koste Sentrum Masjien familie',0),(29711,826,'ro','ÅžtergeÅ£i acest Cost centru maÅŸinÄƒ de familie',0),(29712,826,'et','Kustuta see kulu keskuses kohapeal pere',0),(29713,826,'si','IzbriÅ¡ite ta stroÅ¡ek Center stroj druÅ¾ine',0),(29714,826,'ba','Menghapus ini biaya pusat mesin keluarga',0),(29715,826,'nl','Deze kosten Center Machine familie verwijderen',0),(29716,826,'fi','Poista tÃ¤mÃ¤ kustannus Center kone perhe',0),(29717,826,'no','Slette denne kostnaden Center maskin familien',0),(29718,826,'da','Slet denne Cost Center maskine familie',0),(29719,826,'ko','ì´ ë¹„ìš© ì„¼í„° ê¸°ê³„ ê°€ì¡± ì‚­ì œ',0),(29720,826,'he','×ž×—×™×§×ª ×ž×”×ž×©×¤×—×” ×”×ž×›×•× ×” ×ž×¨×›×– ×¢×œ×•×ª',0),(29721,826,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Î¼Î·Ï‡Î±Î½Î® ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(29722,826,'zh','åˆ é™¤æ­¤æˆæœ¬ä¸­å¿ƒæœºç³»åˆ—\r\n',0),(29723,826,'sv','Ta bort denna kostnad Center maskin familj',0),(29724,826,'it','Eliminare questa famiglia di macchina centro di costo',0),(29725,826,'tl','',0),(29726,826,'th','&#3621;&#3610;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3609;&#3637;&#3657;',0),(29727,826,'hi','à¤‡à¤¸ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29728,826,'ms','Menghapuskan keluarga Mesin Pusat kos ini',0),(29729,826,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ \"Ø§Ù„Ø£Ø³Ø±Ø© Ø¢Ù„Ø© Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©\"',0),(29730,826,'fr','Supprimer cette famille de Machine de centre de coÃ»t',0),(29731,826,'jp','ã?“ã?®ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼æ©Ÿæ¢°ç³»çµ±ã‚’æ¶ˆåŽ»',0),(29732,826,'pt','Excluir esta famÃ­lia de mÃ¡quina de centro de custo',0),(29733,826,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ñ†ÐµÐ½Ñ‚Ñ€ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ ÑÐµÐ¼ÑŒÐ¸',0),(29734,826,'es','Eliminar este Centro de Costos Familia de MÃ¡quinas',0),(29735,826,'de','LÃ¶schen Sie diese Cost-Center-Maschine-Familie',0),(29736,826,'en','Delete this Cost Center Machine Family',0),(29737,827,'is','',0),(29738,827,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±',0),(29739,827,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±',0),(29740,827,'tr','Bu mÃ¼ÅŸteri Sil',0),(29741,827,'pl','UsuÅ„ ten klient',0),(29742,827,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(29743,827,'ur','Ø§Ø³ Ú¯Ø§ÛÚ© Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29744,827,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¾Ð²Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð°',0),(29745,827,'vi','XÃ³a khÃ¡ch hÃ ng nÃ y',0),(29746,827,'af','Skrap hierdie KliÃ«nt/Klant',0),(29747,827,'ro','Sterge acest client',0),(29748,827,'et','Kustuta see klient',0),(29749,827,'si','IzbriÅ¡em tega kupca',0),(29750,827,'ba','Menghapus pelanggan ini',0),(29751,827,'nl','Deze klant verwijderen',0),(29752,827,'fi','Poistetaanko asiakas',0),(29753,827,'no','Slette denne kunden',0),(29754,827,'da','Slet denne kunde',0),(29755,827,'ko','ì´ ê³ ê° ì‚­ì œ',0),(29756,827,'he','×œ×ž×—×•×§ ××ª ×”×œ×§×•×— ×”×–×”',0),(29757,827,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(29758,827,'zh','åˆ é™¤æ­¤å®¢æˆ·\r\n',0),(29759,827,'sv','Ta bort denna kund',0),(29760,827,'it','Eliminare questo cliente',0),(29761,827,'tl','',0),(29762,827,'th','&#3621;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3619;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(29763,827,'hi','à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29764,827,'ms','Menghapuskan Baca ini',0),(29765,827,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(29766,827,'fr','Supprimer ce client',0),(29767,827,'jp','ã?“ã?®é¡§å®¢ã‚’æ¶ˆåŽ»',0),(29768,827,'pt','Excluir este cliente',0),(29769,827,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(29770,827,'es','Eliminar este Cliente',0),(29771,827,'de','LÃ¶schen Sie diesen Kunden',0),(29772,827,'en','Delete this Customer',0),(29773,828,'is','',0),(29774,828,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ ØªØ­ÙˆÙŠÙ„ ',0),(29775,828,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ ØªØ­ÙˆÙŠÙ„ ',0),(29776,828,'tr','Bu kesinti grubu silme',0),(29777,828,'pl','UsunÄ…Ä‡ tÄ™ grupÄ™ odliczenia',0),(29778,828,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ð³Ñ€ÑƒÐ¿Ð° Ð·Ð° Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(29779,828,'ur','Ø§Ø³ Ú©Ø§ Ù†ØªÛŒØ¬Û Ú¯Ø±ÙˆÙ¾ Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(29780,828,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð³Ñ€ÑƒÐ¿Ñƒ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð°',0),(29781,828,'vi','XÃ³a nhÃ³m giáº£m trá»« nÃ y',0),(29782,828,'af','Skrap hierdie Aftrekkingsgroep',0),(29783,828,'ro','È˜tergeÈ›i acest grup de deducere',0),(29784,828,'et','Seda mahaarvamist rÃ¼hma kustutamine',0),(29785,828,'si','Izbrisati skupino odbitek',0),(29786,828,'ba','Menghapus Grup pengurangan ini',0),(29787,828,'nl','Deze aftrek groep verwijderen',0),(29788,828,'fi','Poistaa tÃ¤mÃ¤n vÃ¤hennyksen ryhmÃ¤n',0),(29789,828,'no','Slette denne fradrag gruppen',0),(29790,828,'da','Slet dette fradrag gruppe',0),(29791,828,'ko','ì´ ê³µì œ ê·¸ë£¹ ì‚­ì œ',0),(29792,828,'he','×ž×—×™×§×ª ×§×‘×•×¦×” ×–×• ×ž×¡×§× ×”',0),(29793,828,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î¿Î¼Î¬Î´Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(29794,828,'zh','åˆ é™¤è¿™ä¸€æ‰£é™¤ç»„\r\n',0),(29795,828,'sv','Ta bort detta avdrag grupp',0),(29796,828,'it','Eliminare questo gruppo di deduzione',0),(29797,828,'tl','',0),(29798,828,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3591;&#3636;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;&#3609;&#3637;&#3657;',0),(29799,828,'hi','à¤‡à¤¸ à¤•à¤Ÿà¥Œà¤¤à¥€ à¤¸à¤®à¥‚à¤¹ à¤¹à¤Ÿà¤¾à¤à¤',0),(29800,828,'ms','Hapuskan Kumpulan potongan ini',0),(29801,828,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„ÙØ±ÙŠÙ‚ Ø§Ù„Ø®ØµÙ…',0),(29802,828,'fr','Supprimer ce groupe de dÃ©duction',0),(29803,828,'jp','ã?“ã?®æŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—ã‚’æ¶ˆåŽ»',0),(29804,828,'pt','Excluir este grupo de deduÃ§Ã£o',0),(29805,828,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÑ‚Ð¾Ð¹ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð²Ñ‹Ñ‡ÐµÑ‚',0),(29806,828,'es','Eliminar este Grupo de Deducciones',0),(29807,828,'de','Dieser Abzug-Gruppe lÃ¶schen',0),(29808,828,'en','Delete this Deduction Group',0),(29809,829,'is','',0),(29810,829,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø¬ÙˆÙ‡Ø±',0),(29811,829,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø¬ÙˆÙ‡Ø±',0),(29812,829,'tr','Bu mÃ¼rekkep silme',0),(29813,829,'pl','UsuÅ„ ten atrament',0),(29814,829,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ',0),(29815,829,'ur','Ø§Ø³ Ú©ÛŒ Ø§Ù†Ú© Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29816,829,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ð·Ð°Ð¿Ð¸Ñ Ð¾Ð»Ð¾Ð²ÐºÐ¾Ð¼',0),(29817,829,'vi','XÃ³a má»±c nÃ y',0),(29818,829,'af','Skrap hierdie ink',0),(29819,829,'ro','ÅžtergeÅ£i aceastÄƒ cernealÄƒ',0),(29820,829,'et','Selle Tindi kustutamine',0),(29821,829,'si','Izbrisati to Ärnilo',0),(29822,829,'ba','Menghapus tinta ini',0),(29823,829,'nl','Deze inkt verwijderen',0),(29824,829,'fi','Poista tÃ¤mÃ¤ muste',0),(29825,829,'no','Slette denne blekk',0),(29826,829,'da','Slet denne blÃ¦k',0),(29827,829,'ko','ì´ ìž‰í¬ ì‚­ì œ',0),(29828,829,'he','×œ×ž×—×•×§ ×“×™×•',0),(29829,829,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼ÎµÎ»Î¬Î½Î¹',0),(29830,829,'zh','åˆ é™¤æ­¤æ²¹å¢¨\r\n',0),(29831,829,'sv','Ta bort detta blÃ¤ck',0),(29832,829,'it','Eliminare questo inchiostro',0),(29833,829,'tl','',0),(29834,829,'th','&#3621;&#3610;&#3627;&#3617;&#3638;&#3585;&#3609;&#3637;&#3657;',0),(29835,829,'hi','à¤‡à¤¸ à¤‡à¤‚à¤• à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29836,829,'ms','Memadam dakwat ini',0),(29837,829,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø­Ø¨Ø±',0),(29838,829,'fr','Supprimer cette encre',0),(29839,829,'jp','ã?“ã?®ã‚¤ãƒ³ã‚¯ã‚’æ¶ˆåŽ»',0),(29840,829,'pt','Excluir esta tinta',0),(29841,829,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÑ‚Ð¾Ð¹ ÐºÑ€Ð°ÑÐºÐ¸',0),(29842,829,'es','Eliminar Esta Tinta',0),(29843,829,'de','LÃ¶schen Sie diese Tinte',0),(29844,829,'en','Delete this ink',0),(29845,830,'is','',0),(29846,830,'dr','Ø­Ø°Ù Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(29847,830,'pr','Ø­Ø°Ù Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(29848,830,'tr','Bu fatura silme',0),(29849,830,'pl','Usuwanie tej faktury',0),(29850,830,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(29851,830,'ur','Ø§Ø³ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29852,830,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(29853,830,'vi','XÃ³a hÃ³a Ä‘Æ¡n nÃ y',0),(29854,830,'af','Skrap hierdie Faktuur',0),(29855,830,'ro','ÅžtergeÅ£i aceastÄƒ facturÄƒ',0),(29856,830,'et','Kustuta see arve',0),(29857,830,'si','IzbriÅ¡ite ta raÄun',0),(29858,830,'ba','Menghapus faktur ini',0),(29859,830,'nl','Deze factuur verwijderen',0),(29860,830,'fi','Poistaa tÃ¤tÃ¤ laskua',0),(29861,830,'no','Slette denne fakturaen',0),(29862,830,'da','Slet denne faktura',0),(29863,830,'ko','ì´ ì²­êµ¬ì„œë¥¼ ì‚­ì œ',0),(29864,830,'he','.×ž×—×§ ×—×©×‘×•× ×™×ª ×–×•',0),(29865,830,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(29866,830,'zh','åˆ é™¤æ­¤å‘ç¥¨\r\n',0),(29867,830,'sv','Ta bort denna faktura',0),(29868,830,'it','Eliminare questa fattura',0),(29869,830,'tl','',0),(29870,830,'th','&#3621;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3609;&#3637;&#3657;',0),(29871,830,'hi','à¤‡à¤¸ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29872,830,'ms','Menghapuskan invois ini',0),(29873,830,'ar','Ø­Ø°Ù Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ù‡Ø°Ù‡',0),(29874,830,'fr','Supprimer cette facture',0),(29875,830,'jp','ã?“ã?®è«‹æ±‚æ›¸ã‚’æ¶ˆåŽ»',0),(29876,830,'pt','Excluir esta fatura',0),(29877,830,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð¡Ñ‡ÐµÑ‚',0),(29878,830,'es','Eliminar esta Factura',0),(29879,830,'de','LÃ¶schen Sie diese Rechnung',0),(29880,830,'en','Delete this Invoice',0),(29881,831,'is','',0),(29882,831,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡  ÙƒØ§Ù„Ø§',0),(29883,831,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡  ÙƒØ§Ù„Ø§',0),(29884,831,'tr','Bu madde kategorisi silme',0),(29885,831,'pl','UsunÄ…Ä‡ tÄ™ kategoriÄ™ do elementu',0),(29886,831,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(29887,831,'ur','ÛŒÛ Ø´Û’ Ø²Ù…Ø±Û Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29888,831,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(29889,831,'vi','XÃ³a thá»ƒ loáº¡i nÃ y',0),(29890,831,'af','Skrap hierdie Item Kategorie',0),(29891,831,'ro','ÅžtergeÅ£i aceastÄƒ categorie de articole',0),(29892,831,'et','Kustuta see tootekategooria',0),(29893,831,'si','Izbrisati tole kategorijo artikla',0),(29894,831,'ba','Hapus kategori Item ini',0),(29895,831,'nl','Verwijderen van deze artikelcategorie',0),(29896,831,'fi','Poista kohteen luokka',0),(29897,831,'no','Slette denne varekategorien',0),(29898,831,'da','Slet denne varekategori',0),(29899,831,'ko','ì´ í•­ëª© ë²”ì£¼ ì‚­ì œ',0),(29900,831,'he','×œ×ž×—×•×§ ×§×˜×’×•×¨×™×” ×–×• ×œ×¤×¨×™×˜',0),(29901,831,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(29902,831,'zh','åˆ é™¤æ­¤é¡¹ç›®ç±»åˆ«\r\n',0),(29903,831,'sv','Ta bort denna artikelkategori',0),(29904,831,'it','Eliminare questa categoria dell\'elemento',0),(29905,831,'tl','',0),(29906,831,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;',0),(29907,831,'hi','à¤‡à¤¸ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤†à¤‡à¤Ÿà¤® à¤¹à¤Ÿà¤¾à¤à¤',0),(29908,831,'ms','Menghapuskan kategori Item ini',0),(29909,831,'ar','Ø­Ø°Ù ØªØµÙ†ÙŠÙ Ø§Ù„ØµÙ†Ù Ù‡Ø°Ø§',0),(29910,831,'fr','Supprimer cette catÃ©gorie de l\'Ã©lÃ©ment',0),(29911,831,'jp','ã?“ã?®å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’æ¶ˆåŽ»',0),(29912,831,'pt','Apagar esta categoria de Item',0),(29913,831,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½ÑƒÑŽ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(29914,831,'es','Eliminar esta CategorÃ­a de Item',0),(29915,831,'de','LÃ¶schen Sie diesen Positionstyp',0),(29916,831,'en','Delete this Item Category',0),(29917,832,'is','',0),(29918,832,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø­Ù„',0),(29919,832,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø­Ù„',0),(29920,832,'tr','Bu konumu silmek',0),(29921,832,'pl','UsuÅ„ tÄ™ lokalizacjÄ™',0),(29922,832,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð²Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(29923,832,'ur','ÛŒÛ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29924,832,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(29925,832,'vi','XÃ³a vá»‹ trÃ­ nÃ y',0),(29926,832,'af','Skrap hierdie Ligging',0),(29927,832,'ro','ÅžtergeÅ£i aceastÄƒ locaÅ£ie',0),(29928,832,'et','Kustuta selles asukohas',0),(29929,832,'si','IzbriÅ¡ite to mesto',0),(29930,832,'ba','Menghapus lokasi ini',0),(29931,832,'nl','Deze locatie verwijderen',0),(29932,832,'fi','Poista tÃ¤mÃ¤ sijainti',0),(29933,832,'no','Slette denne plasseringen',0),(29934,832,'da','Slet denne placering',0),(29935,832,'ko','ì´ ìœ„ì¹˜ë¥¼ ì‚­ì œ',0),(29936,832,'he','×œ×ž×—×•×§ ××ª ×”×ž×™×§×•× ×”×–×”',0),(29937,832,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ Î¸Î­ÏƒÎ·Ï‚',0),(29938,832,'zh','åˆ é™¤æ­¤ä½ç½®\r\n',0),(29939,832,'sv','Ta bort denna plats',0),(29940,832,'it','Eliminare questa posizione',0),(29941,832,'tl','',0),(29942,832,'th','&#3621;&#3610;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3609;&#3637;&#3657;',0),(29943,832,'hi','à¤‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0);
INSERT INTO `langdef` VALUES (29944,832,'ms','Hapuskan lokasi ini',0),(29945,832,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(29946,832,'fr','Supprimer cet emplacement',0),(29947,832,'jp','ã?“ã?®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã‚’æ¶ˆåŽ»',0),(29948,832,'pt','Excluir este local',0),(29949,832,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(29950,832,'es','Eliminar esta UbicaciÃ³n',0),(29951,832,'de','Dieser Speicherort lÃ¶schen',0),(29952,832,'en','Delete this Location',0),(29953,833,'is','',0),(29954,833,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø§Ø´ÙŠÙ† ',0),(29955,833,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø§Ø´ÙŠÙ† ',0),(29956,833,'tr','Bu makineyi silin',0),(29957,833,'pl','UsuÅ„ ten maszyna',0),(29958,833,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(29959,833,'ur','Ø§Ø³ Ù…Ø´ÛŒÙ† Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29960,833,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð¼Ð°ÑˆÐ¸Ð½Ñƒ',0),(29961,833,'vi','XÃ³a mÃ¡y nÃ y',0),(29962,833,'af','Skrap hierdie Masjien',0),(29963,833,'ro','ÅžtergeÅ£i aceastÄƒ maÅŸinÄƒ',0),(29964,833,'et','Kustutada selle masin',0),(29965,833,'si','IzbriÅ¡ite ta stroj',0),(29966,833,'ba','Menghapus mesin ini',0),(29967,833,'nl','Deze Machine verwijderen',0),(29968,833,'fi','Poista tÃ¤mÃ¤ kone',0),(29969,833,'no','Slette denne maskinen',0),(29970,833,'da','Slet denne maskine',0),(29971,833,'ko','ì´ ì»´í“¨í„°ë¥¼ ì‚­ì œ',0),(29972,833,'he','×œ×ž×—×•×§ ××ª ×”×ž×›×•× ×” ×”×–××ª',0),(29973,833,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î·Ï‡Î¬Î½Î·Î¼Î±',0),(29974,833,'zh','åˆ é™¤æœ¬æœº\r\n',0),(29975,833,'sv','Ta bort denna maskin',0),(29976,833,'it','Eliminare questa macchina',0),(29977,833,'tl','',0),(29978,833,'th','&#3621;&#3610;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3609;&#3637;&#3657;',0),(29979,833,'hi','à¤‡à¤¸ à¤®à¤¶à¥€à¤¨ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(29980,833,'ms','Hapuskan mesin ini',0),(29981,833,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø¬Ù‡Ø§Ø²',0),(29982,833,'fr','Supprimer cette Machine',0),(29983,833,'jp','ã?“ã?®æ©Ÿæ¢°ã‚’æ¶ˆåŽ»',0),(29984,833,'pt','Excluir esta mÃ¡quina',0),(29985,833,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ Ð¼Ð°ÑˆÐ¸Ð½Ñƒ',0),(29986,833,'es','Eliminar esta MÃ¡quina',0),(29987,833,'de','Diese Maschine lÃ¶schen',0),(29988,833,'en','Delete this Machine',0),(29989,834,'is','',0),(29990,834,'dr','Ø­Ø°Ù Ø§ÙŠÙ†  ØªÙ†Ø¸ÙŠÙ… Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(29991,834,'pr','Ø­Ø°Ù Ø§ÙŠÙ†  ØªÙ†Ø¸ÙŠÙ… Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(29992,834,'tr','Bu biÃ§imlendirme kÃ¼mesi silme',0),(29993,834,'pl','UsunÄ…Ä‡ ten zestaw znacznikÃ³w',0),(29994,834,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð°Ð¿ÐºÐ° Ð·Ð° Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(29995,834,'ur','ÛŒÛ Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(29996,834,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð½Ð°Ð·Ð½Ð°ÐºÐµ Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ',0),(29997,834,'vi','XÃ³a cá»™ng thÃªm nÃ y',0),(29998,834,'af','Skrap hierdie Prysverhogingstel',0),(29999,834,'ro','È˜tergeÈ›i acest Set de marcare',0),(30000,834,'et','Kustuta mÃ¤rgistus seada',0),(30001,834,'si','IzbriÅ¡ite ta komplet oznaÄevalnih',0),(30002,834,'ba','Menghapus ini Markup Set',0),(30003,834,'nl','Verwijder deze Markup instellen',0),(30004,834,'fi','Poista tÃ¤mÃ¤ Markup Set',0),(30005,834,'no','Slette denne Markup Set',0),(30006,834,'da','Slet denne Markup Set',0),(30007,834,'ko','ì´ íƒœê·¸ ì„¤ì • ì‚­ì œ',0),(30008,834,'he','×œ×ž×—×•×§ ××ª ×¡×™×ž×•×Ÿ ×”×’×“×¨',0),(30009,834,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏÎ½Î¿Î»Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(30010,834,'zh','åˆ é™¤æ­¤æ ‡è®°é›†\r\n',0),(30011,834,'sv','Ta bort denna markering Set',0),(30012,834,'it','Eliminare questo Set di Markup',0),(30013,834,'tl','',0),(30014,834,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3594;&#3640;&#3604;&#3609;&#3637;&#3657;',0),(30015,834,'hi','à¤‡à¤¸ à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30016,834,'ms','Menghapuskan Set penanda ini',0),(30017,834,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ \"Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©\"',0),(30018,834,'fr','Supprimez la valeur de ce balisage',0),(30019,834,'jp','ã?“ã?®å€¤ä¸Šã?’è¨­å®šã‚’æ¶ˆåŽ»',0),(30020,834,'pt','Excluir esta marcaÃ§Ã£o definida',0),(30021,834,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð½Ð°Ð±Ð¾Ñ€ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(30022,834,'es','Eliminar esta Juego de Encarecimiento',0),(30023,834,'de','LÃ¶schen Sie dieses Markup festgelegt',0),(30024,834,'en','Delete this Markup Set',0),(30025,835,'is','',0),(30026,835,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø±ÙˆØ´',0),(30027,835,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø±ÙˆØ´',0),(30028,835,'tr','Bu yÃ¶ntem Sil',0),(30029,835,'pl','UsuÅ„ ten metoda',0),(30030,835,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð¼ÐµÑ‚Ð¾Ð´',0),(30031,835,'ur','ÛŒÛ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30032,835,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð¼ÐµÑ‚Ð¾Ð´',0),(30033,835,'vi','XÃ³a phÆ°Æ¡ng thá»©c nÃ y',0),(30034,835,'af','Skrap hierdie Metode',0),(30035,835,'ro','ÅžtergeÅ£i aceastÄƒ metodÄƒ',0),(30036,835,'et','Kustuta see meetod',0),(30037,835,'si','To metodo Ärtati',0),(30038,835,'ba','Menghapus metode ini',0),(30039,835,'nl','Deze methode verwijderen',0),(30040,835,'fi','Poista tÃ¤mÃ¤ menetelmÃ¤',0),(30041,835,'no','Slette denne metoden',0),(30042,835,'da','Slet denne metode',0),(30043,835,'ko','ì´ ë©”ì„œë“œë¥¼ ì‚­ì œ',0),(30044,835,'he','×ž×—×™×§×ª ×‘×©×™×˜×” ×–×•',0),(30045,835,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ Î¼ÎµÎ¸ÏŒÎ´Î¿Ï…',0),(30046,835,'zh','åˆ é™¤æ­¤æ–¹æ³•\r\n',0),(30047,835,'sv','Ta bort denna metod',0),(30048,835,'it','Questo metodo Delete',0),(30049,835,'tl','',0),(30050,835,'th','&#3621;&#3610;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;',0),(30051,835,'hi','à¤‡à¤¸ à¤µà¤¿à¤§à¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30052,835,'ms','Menghapuskan kaedah ini',0),(30053,835,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ Ø§Ù„Ø·Ø±ÙŠÙ‚Ø©',0),(30054,835,'fr','Cette mÃ©thode Delete',0),(30055,835,'jp','ã?“ã?®æ–¹æ³•ã‚’æ¶ˆåŽ»',0),(30056,835,'pt','Este mÃ©todo Delete',0),(30057,835,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¼ÐµÑ‚Ð¾Ð´',0),(30058,835,'es','Eliminar este MÃ©todo',0),(30059,835,'de','Diese Methode zu lÃ¶schen',0),(30060,835,'en','Delete this Method',0),(30061,836,'is','',0),(30062,836,'dr','Ø­Ø°Ù Ø§ÙŠÙ† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(30063,836,'pr','Ø­Ø°Ù Ø§ÙŠÙ† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(30064,836,'tr','Bu notu Sil',0),(30065,836,'pl','UsunÄ…Ä‡ tÄ™ notatkÄ™',0),(30066,836,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ Ñ‚Ð°Ð·Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(30067,836,'ur','ÛŒÛ Ù†ÙˆÙ¹ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30068,836,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€ÑƒÐºÑƒ',0),(30069,836,'vi','XÃ³a ghi chÃº nÃ y',0),(30070,836,'af','Skrap hierdie Nota',0),(30071,836,'ro','È˜tergeÈ›i aceastÄƒ notÄƒ',0),(30072,836,'et','Kustuta see mÃ¤rge',0),(30073,836,'si','Izbrisati to opombo',0),(30074,836,'ba','Menghapus catatan',0),(30075,836,'nl','Deze notitie verwijderen',0),(30076,836,'fi','Poista tÃ¤mÃ¤ muistilappu',0),(30077,836,'no','Slett denne lappen',0),(30078,836,'da','Slette denne Note',0),(30079,836,'ko','ì´ ë©”ëª¨ ì‚­ì œ',0),(30080,836,'he','×œ×ž×—×•×§ ××ª ×”×¤×ª×§ ×”×–×”',0),(30081,836,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î· ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(30082,836,'zh','åˆ é™¤æœ¬è¯´æ˜Ž\r\n',0),(30083,836,'sv','Ta bort denna anmÃ¤rkning',0),(30084,836,'it','Eliminare questa nota',0),(30085,836,'tl','',0),(30086,836,'th','&#3621;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3609;&#3637;&#3657;',0),(30087,836,'hi','à¤‡à¤¸ à¤¨à¥‹à¤Ÿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30088,836,'ms','Hapuskan Nota ini',0),(30089,836,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø©',0),(30090,836,'fr','Supprimer cette Note',0),(30091,836,'jp','ã?“ã?®ãƒ¡ãƒ¢ã‚’æ¶ˆåŽ»',0),(30092,836,'pt','Excluir esta nota',0),(30093,836,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½ÑƒÑŽ Ð—Ð°Ð¼ÐµÑ‚ÐºÑƒ',0),(30094,836,'es','Eliminar esta Nota',0),(30095,836,'de','Diese Notiz lÃ¶schen',0),(30096,836,'en','Delete this Note',0),(30097,837,'is','',0),(30098,837,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø¹Ù…Ù„ÙŠØ§Øª ',0),(30099,837,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø¹Ù…Ù„ÙŠØ§Øª ',0),(30100,837,'tr','Bu iÅŸlemi silme',0),(30101,837,'pl','Ta operacja usuwania',0),(30102,837,'bg','Ð¢Ð°Ð·Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(30103,837,'ur','Ø§Ø³ Ø¹Ù…Ù„ÛŒÛ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30104,837,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(30105,837,'vi','XÃ³a hoáº¡t Ä‘á»™ng nÃ y',0),(30106,837,'af','Skrap hierdie Operasie',0),(30107,837,'ro','ÅžtergeÅ£i aceastÄƒ operaÅ£ie',0),(30108,837,'et','Kustuta see toiming',0),(30109,837,'si','Ta operacija brisanja',0),(30110,837,'ba','Menghapus pengoperasian ini',0),(30111,837,'nl','Deze bewerking verwijderen',0),(30112,837,'fi','Poista toiminto',0),(30113,837,'no','Slette denne operasjonen',0),(30114,837,'da','Slet denne handling',0),(30115,837,'ko','ì´ ìž‘ì—… ì‚­ì œ',0),(30116,837,'he','×œ×ž×—×•×§ ××ª ×”×ž×‘×¦×¢ ×”×–×”',0),(30117,837,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±Ï‚',0),(30118,837,'zh','åˆ é™¤æ­¤æ“ä½œ\r\n',0),(30119,837,'sv','Ta bort denna Operation',0),(30120,837,'it','Eliminare questa operazione',0),(30121,837,'tl','',0),(30122,837,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(30123,837,'hi','à¤‡à¤¸ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30124,837,'ms','Menghapuskan operasi ini',0),(30125,837,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(30126,837,'fr','Cette opÃ©ration de suppression',0),(30127,837,'jp','ã?“ã?®ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã‚’æ¶ˆåŽ»',0),(30128,837,'pt','Esta operaÃ§Ã£o de exclusÃ£o',0),(30129,837,'ru','Ð­Ñ‚Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ',0),(30130,837,'es','Eliminar esta OperaciÃ³n',0),(30131,837,'de','Dieser LÃ¶schvorgang',0),(30132,837,'en','Delete this Operation',0),(30133,838,'is','',0),(30134,838,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù‚Ø³Ù…Øª ',0),(30135,838,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù‚Ø³Ù…Øª ',0),(30136,838,'tr','Bu bÃ¶lÃ¼mÃ¼ silmek',0),(30137,838,'pl','UsunÄ…Ä‡ tÄ™ czÄ™Å›Ä‡',0),(30138,838,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ñ‡Ð°ÑÑ‚',0),(30139,838,'ur','ÛŒÛ Ø­ØµÛ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30140,838,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð´ÐµÐ¾',0),(30141,838,'vi','XÃ³a pháº§n nÃ y',0),(30142,838,'af','Skrap hierdie Part',0),(30143,838,'ro','ÅžtergeÅ£i aceastÄƒ parte',0),(30144,838,'et','Kustuta selles osas',0),(30145,838,'si','IzbriÅ¡ite ta del',0),(30146,838,'ba','Hapus bagian ini',0),(30147,838,'nl','Dit gedeelte verwijderen',0),(30148,838,'fi','Poistaa',0),(30149,838,'no','Slette denne delen',0),(30150,838,'da','Slet denne del',0),(30151,838,'ko','ì´ ë¶€ë¶„ì„ ì‚­ì œ',0),(30152,838,'he','×œ×ž×—×•×§ ××ª ×”×—×œ×§ ×”×–×”',0),(30153,838,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï…Ï„Î¿Ï Ï„Î¿Ï… ÏƒÎ·Î¼ÎµÎ¯Î¿Ï…',0),(30154,838,'zh','åˆ é™¤æ­¤éƒ¨åˆ†\r\n',0),(30155,838,'sv','Ta bort denna del',0),(30156,838,'it','Eliminare questa parte',0),(30157,838,'tl','',0),(30158,838,'th','&#3621;&#3610;&#3626;&#3656;&#3623;&#3609;&#3609;&#3637;&#3657;',0),(30159,838,'hi','à¤‡à¤¸ à¤­à¤¾à¤— à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30160,838,'ms','Menghapuskan bahagian ini',0),(30161,838,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø¬Ø²Ø¡',0),(30162,838,'fr','Supprimer cette partie',0),(30163,838,'jp','ã?“ã?®éƒ¨å“?ã‚’æ¶ˆåŽ»',0),(30164,838,'pt','Apagar esta parte',0),(30165,838,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ Ñ‡Ð°ÑÑ‚ÑŒ',0),(30166,838,'es','Eliminar este Parte',0),(30167,838,'de','Dieser Teil lÃ¶schen',0),(30168,838,'en','Delete this Part',0),(30169,839,'is','',0),(30170,839,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(30171,839,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(30172,839,'tr','Bu Ã¶deme tipi silme',0),(30173,839,'pl','UsunÄ…Ä‡ ten typ pÅ‚atnoÅ›ci',0),(30174,839,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ñ‚Ð¸Ð¿ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(30175,839,'ur','Ø§Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30176,839,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð²Ñ€ÑÑ‚Ñƒ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(30177,839,'vi','XÃ³a loáº¡i thanh toÃ¡n nÃ y',0),(30178,839,'af','Skrap hierdie Betalingstipe',0),(30179,839,'ro','ÅžtergeÅ£i acest tip de platÄƒ',0),(30180,839,'et','Kustuta see makse tÃ¼Ã¼p',0),(30181,839,'si','IzbriÅ¡ite ta vrsta plaÄila',0),(30182,839,'ba','Menghapus jenis pembayaran',0),(30183,839,'nl','Deze betalingstype verwijderen',0),(30184,839,'fi','Poista tÃ¤mÃ¤ maksu',0),(30185,839,'no','Slette denne betalingsmÃ¥ten',0),(30186,839,'da','Slet denne betalingstype',0),(30187,839,'ko','ì´ ì§€ë¶ˆ ìœ í˜• ì‚­ì œ',0),(30188,839,'he','×œ×ž×—×•×§ ×¡×•×’ ×ª×©×œ×•× ×–×”',0),(30189,839,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï„ÏÏ€Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(30190,839,'zh','åˆ é™¤æ­¤ä»˜æ¬¾æ–¹å¼\r\n',0),(30191,839,'sv','Ta bort denna betalningstyp',0),(30192,839,'it','Eliminare questo tipo di pagamento',0),(30193,839,'tl','',0),(30194,839,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3609;&#3637;&#3657;',0),(30195,839,'hi','à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(30196,839,'ms','Menghapuskan jenis bayaran ini',0),(30197,839,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ \"Ø§Ù„Ù†ÙˆØ¹ Ù…Ù† Ø§Ù„Ø¯ÙØ¹\"',0),(30198,839,'fr','Supprimer ce Type de paiement',0),(30199,839,'jp','ã?“ã?®æ”¯æ‰•ã‚¿ã‚¤ãƒ—ã‚’æ¶ˆåŽ»',0),(30200,839,'pt','Excluir este tipo de pagamento',0),(30201,839,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð¢Ð¸Ð¿ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(30202,839,'es','Eliminar este Tipo de Pago',0),(30203,839,'de','LÃ¶schen Sie diese Zahlungsart',0),(30204,839,'en','Delete this Payment Type',0),(30205,840,'is','',0),(30206,840,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø·Ø±Ø­',0),(30207,840,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø·Ø±Ø­',0),(30208,840,'tr','Bu planÄ± Sil',0),(30209,840,'pl','UsuÅ„ ten Plan',0),(30210,840,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ Ñ‚Ð¾Ð·Ð¸ Ð¿Ð»Ð°Ð½',0),(30211,840,'ur','ÛŒÛ Ù¾Ù„Ø§Ù† Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30212,840,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ ÐŸÐ»Ð°Ð½',0),(30213,840,'vi','XÃ³a káº¿ hoáº¡ch nÃ y',0),(30214,840,'af','Skrap hierdie Plan',0),(30215,840,'ro','ÅžtergeÅ£i acest Plan',0),(30216,840,'et','Kustuta see graafik',0),(30217,840,'si','IzbriÅ¡ite ta naÄrt',0),(30218,840,'ba','Menghapus rencana ini',0),(30219,840,'nl','Dit schema verwijderen',0),(30220,840,'fi','Poista suunnitelma',0),(30221,840,'no','Slette denne planen',0),(30222,840,'da','Slet denne Plan',0),(30223,840,'ko','ì´ ê³„íš ì‚­ì œ',0),(30224,840,'he','×œ×ž×—×•×§ ××ª ×”×ª×•×›× ×™×ª ×”×–××ª',0),(30225,840,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ‡Î­Î´Î¹Î¿',0),(30226,840,'zh','åˆ é™¤æ­¤è®¡åˆ’\r\n',0),(30227,840,'sv','Ta bort denna Plan',0),(30228,840,'it','Eliminare questo piano',0),(30229,840,'tl','',0),(30230,840,'th','&#3621;&#3610;&#3649;&#3612;&#3609;&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(30231,840,'hi','à¤‡à¤¸ à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‹ à¤®à¤¿à¤Ÿà¤¾à¤à¤',0),(30232,840,'ms','Hapuskan pelan ini',0),(30233,840,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ Ø§Ù„Ø®Ø·Ø©',0),(30234,840,'fr','Supprimer ce Plan',0),(30235,840,'jp','ã?“ã?®ãƒ—ãƒ©ãƒ³ã‚’æ¶ˆåŽ»',0),(30236,840,'pt','Excluir este plano',0),(30237,840,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½',0),(30238,840,'es','Eliminar este Plan',0),(30239,840,'de','Dieser Plan lÃ¶schen',0),(30240,840,'en','Delete this Plan',0),(30241,841,'is','',0),(30242,841,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(30243,841,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(30244,841,'tr','Bu PO Sil',0),(30245,841,'pl','UsuÅ„ PO tym',0),(30246,841,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ Ñ‚Ð¾Ð·Ð¸ PO',0),(30247,841,'ur','ÛŒÛ Ù¾ÙˆØ³Ù¹ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30248,841,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ ÐŸÐž',0),(30249,841,'vi','XÃ³a Ä‘Æ¡n mua hÃ ng nÃ y',0),(30250,841,'af','Skrap hierdie AB',0),(30251,841,'ro','ÅžtergeÅ£i acest PO',0),(30252,841,'et','Kustuta see PO',0),(30253,841,'si','IzbriÅ¡ite ta PO',0),(30254,841,'ba','Menghapus PO ini',0),(30255,841,'nl','Deze PO verwijderen',0),(30256,841,'fi','Poista tÃ¤mÃ¤ PO',0),(30257,841,'no','Slette denne PO',0),(30258,841,'da','Slet denne PO',0),(30259,841,'ko','ì´ ì‚¬ì„œí•¨ì„ ì‚­ì œ',0),(30260,841,'he','×œ×ž×—×•×§ ××ª ×¤×•',0),(30261,841,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ PO',0),(30262,841,'zh','åˆ é™¤æ­¤è®¢å•\r\n',0),(30263,841,'sv','Ta bort denna PO',0),(30264,841,'it','Eliminare questo PO',0),(30265,841,'tl','',0),(30266,841,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;',0),(30267,841,'hi','à¤‡à¤¸ à¤ªà¥‹ à¤¹à¤Ÿà¤¾à¤à¤',0),(30268,841,'ms','Menghapuskan PO ini',0),(30269,841,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø¨Ùˆ',0),(30270,841,'fr','Supprimer ce PO',0),(30271,841,'jp','ã?“ã?®POã‚’æ¶ˆåŽ»',0),(30272,841,'pt','Excluir esta PO',0),(30273,841,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ PO',0),(30274,841,'es','Eliminar este OC',0),(30275,841,'de','LÃ¶schen dieser PO',0),(30276,841,'en','Delete this PO',0),(30277,842,'is','',0),(30278,842,'dr','Ø¢ÙŠØ§ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯  Ø¯ÙƒÙ…Ù‡  Ø§Ø¨Ø²Ø§Ø± Ø±Ø§ ÙØ´Ø§Ø± Ø¯Ù‡ÙŠØ¯',0),(30279,842,'pr','Ø¢ÙŠØ§ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯  Ø¯ÙƒÙ…Ù‡  Ø§Ø¨Ø²Ø§Ø± Ø±Ø§ ÙØ´Ø§Ø± Ø¯Ù‡ÙŠØ¯',0),(30280,842,'tr','Bu basÄ±n aracÄ± silinsin mi?',0),(30281,842,'pl','UsuÅ„ ten narzÄ™dzie?',0),(30282,842,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ñ€ÐµÑÐ°Ñ‚Ð°?',0),(30283,842,'ur','Ø§Ø³ Ù¾Ø±ÛŒØ³ Ú©Û’ Ø¢Ù„Û’ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚºØŸ',0),(30284,842,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð°Ð»Ð°Ñ‚ Ð·Ð° Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ?',0),(30285,842,'vi','XÃ³a cÃ´ng cá»¥ bÃ¡o chÃ­ nÃ y?',0),(30286,842,'af','Skrap hierdie Press instrument?',0),(30287,842,'ro','Åžterge acest instrument de presÄƒ?',0),(30288,842,'et','Kustuta see stants?',0),(30289,842,'si','IzbriÅ¡i to orodje tiska?',0),(30290,842,'ba','Menghapus alat tekan ini?',0),(30291,842,'nl','Deze Press Tool verwijderen?',0),(30292,842,'fi','Poista tÃ¤mÃ¤ paina tyÃ¶kalu?',0),(30293,842,'no','Slette trykk verktÃ¸yet?',0),(30294,842,'da','Slet denne presse vÃ¦rktÃ¸j?',0),(30295,842,'ko','ì´ í”„ë ˆìŠ¤ ë„êµ¬ ì‚­ì œ?',0),(30296,842,'he','×”×× ×œ×ž×—×•×§ ××ª ×›×œ×™ ×”×ª×§×©×•×¨×ª ×–×”?',0),(30297,842,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ Ï„ÏÏ€Î¿Ï…;',0),(30298,842,'zh','åˆ é™¤æ­¤æŒ‰é”®å·¥å…·ï¼Ÿ\r\n',0),(30299,842,'sv','Ta bort tryck verktyget?',0),(30300,842,'it','Eliminare questo strumento di stampa?',0),(30301,842,'tl','',0),(30302,842,'th','&#3621;&#3610;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;&#3611;&#3640;&#3656;&#3617;&#3585;&#3604;&#3609;&#3637;&#3657;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(30303,842,'hi','à¤‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤•à¥‡ à¤ªà¥à¤°à¥‡à¤¸ à¤¹à¤Ÿà¤¾ à¤¦à¥‡à¤‚?',0),(30304,842,'ms','Menghapuskan alat Seluar ini?',0),(30305,842,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ \"Ø§Ù„Ø£Ø¯Ø§Ø© Ø§Ù„ØµØ­Ø§ÙØ©\"ØŸ',0),(30306,842,'fr','Supprimer cet outil de presse ?',0),(30307,842,'jp','ã?“ã?®ãƒ—ãƒ¬ã‚¹ãƒ„ãƒ¼ãƒ«ã‚’æ¶ˆåŽ»ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(30308,842,'pt','Excluir esta ferramenta de imprensa?',0),(30309,842,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿Ñ€ÐµÑÑ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚?',0),(30310,842,'es','Eliminar esta Herramienta de Prensa',0),(30311,842,'de','LÃ¶schen dieses Presse-Tool?',0),(30312,842,'en','Delete this Press Tool?',0),(30313,843,'is','',0),(30314,843,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(30315,843,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(30316,843,'tr','Bu fiyat dÃ¼zeyi silme',0),(30317,843,'pl','UsuÅ„ ten poziom cen',0),(30318,843,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð²Ð° Ð½Ð¸Ð²Ð¾',0),(30319,843,'ur','Ø§Ø³ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30320,843,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð°',0),(30321,843,'vi','XÃ³a má»©c giÃ¡ nÃ y',0),(30322,843,'af','Skrap hierdie Prysvlak',0),(30323,843,'ro','Åžterge acest nivel de pret',0),(30324,843,'et','Kustuta see hinnatase',0),(30325,843,'si','IzbriÅ¡ite ta raven',0),(30326,843,'ba','Menghapus tingkat harga ini',0),(30327,843,'nl','Verwijderen van dit prijsniveau',0),(30328,843,'fi','Poista tÃ¤mÃ¤ hintataso',0),(30329,843,'no','Slett dette prisnivÃ¥et',0),(30330,843,'da','Slet dette prisniveau',0),(30331,843,'ko','ì´ ê°€ê²© ìˆ˜ì¤€ ì‚­ì œ',0),(30332,843,'he','×œ×ž×—×•×§ ××ª ×¨×ž×ª ×ž×—×™×¨',0),(30333,843,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½',0),(30334,843,'zh','åˆ é™¤è¿™ä¸ªä»·æ ¼æ°´å¹³\r\n',0),(30335,843,'sv','Ta bort denna prisnivÃ¥',0),(30336,843,'it','Eliminare questo livello di prezzo',0),(30337,843,'tl','',0),(30338,843,'th','&#3621;&#3610;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3609;&#3637;&#3657;',0),(30339,843,'hi','à¤‡à¤¸ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(30340,843,'ms','Menghapuskan paras harga ini',0),(30341,843,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ \"Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\"',0),(30342,843,'fr','Supprimer ce niveau de prix',0),(30343,843,'jp','ã?“ã?®ä¾¡æ ¼æ°´æº–ã‚’æ¶ˆåŽ»',0),(30344,843,'pt','Excluir este nÃ­vel de preÃ§o',0),(30345,843,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð¦ÐµÐ½',0),(30346,843,'es','Eliminar este Nivel de Precios',0),(30347,843,'de','Dieses Preisniveau zu lÃ¶schen',0),(30348,843,'en','Delete this Price Level',0),(30349,844,'is','',0),(30350,844,'dr','Ø­Ø°Ù Ø§ÙŠÙ†  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(30351,844,'pr','Ø­Ø°Ù Ø§ÙŠÙ†  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(30352,844,'tr','Bu fiyat listesini silme',0),(30353,844,'pl','UsuÅ„ ten Cennik',0),(30354,844,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(30355,844,'ur','Ø§Ø³ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30356,844,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(30357,844,'vi','XÃ³a danh sÃ¡ch giÃ¡ nÃ y',0),(30358,844,'af','Skrap hierdie Prysvlak',0),(30359,844,'ro','ÅžtergeÅ£i lista de preÅ£uri',0),(30360,844,'et','Kustuta see hinnakiri',0),(30361,844,'si','IzbriÅ¡ite ta cenik',0),(30362,844,'ba','Menghapus daftar harga',0),(30363,844,'nl','Deze prijslijst verwijderen',0),(30364,844,'fi','Poista tÃ¤mÃ¤ hinnasto',0),(30365,844,'no','Slette denne prislisten',0),(30366,844,'da','Slet denne prisliste',0),(30367,844,'ko','ì´ ê°€ê²© ëª©ë¡ ì‚­ì œ',0),(30368,844,'he','×ž×—×™×§×ª ×ž×—×™×¨×•×Ÿ ×–×”',0),(30369,844,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(30370,844,'zh','åˆ é™¤æ­¤ä»·æ ¼è¡¨\r\n',0),(30371,844,'sv','Ta bort denna prislista',0),(30372,844,'it','Eliminare questo listino',0),(30373,844,'tl','',0),(30374,844,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3609;&#3637;&#3657;',0),(30375,844,'hi','à¤‡à¤¸ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¹à¤Ÿà¤¾à¤à¤',0),(30376,844,'ms','Hapuskan senarai harga ini',0),(30377,844,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ \"Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\"',0),(30378,844,'fr','Supprimer de cette liste de prix',0),(30379,844,'jp','ã?“ã?®ä¾¡æ ¼è¡¨ã‚’æ¶ˆåŽ»',0),(30380,844,'pt','Excluir esta lista de preÃ§o',0),(30381,844,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(30382,844,'es','Eliminar esta Lista de Precios',0),(30383,844,'de','LÃ¶schen Sie diese Preisliste',0),(30384,844,'en','Delete this Price List',0),(30385,845,'is','',0),(30386,845,'dr','Ø­Ø°Ù Ø§ÙŠÙ†  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(30387,845,'pr','Ø­Ø°Ù Ø§ÙŠÙ†  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(30388,845,'tr','Bu fiyat listesi stok Sil',0),(30389,845,'pl','UsuÅ„ listÄ™ cena akcji',0),(30390,845,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð²',0),(30391,845,'ur','ÛŒÛ Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30392,845,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ñ†ÐµÐ½Ñƒ Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(30393,845,'vi','XÃ³a danh sÃ¡ch giÃ¡ hÃ ng tá»“n nÃ y',0),(30394,845,'af','Skrap hierdie Voorraad Pryslys',0),(30395,845,'ro','ÅžtergeÅ£i acest Pret lista stoc',0),(30396,845,'et','Kustuta hind nimekirja kÃµnealuste kalavarude',0),(30397,845,'si','IzbriÅ¡ite ta cena seznam zalog',0),(30398,845,'ba','Menghapus saham ini daftar harga',0),(30399,845,'nl','Deze prijs lijst voorraad verwijderen',0),(30400,845,'fi','Poista hinta luettelon kannan',0),(30401,845,'no','Slette denne prisen liste lager',0),(30402,845,'da','Slet denne liste aktiekurs',0),(30403,845,'ko','ì´ ê°€ê²© ëª©ë¡ ì‚¬ì§„ ì‚­ì œ',0),(30404,845,'he','×œ×ž×—×•×§ ××ª ×”×ž× ×™×” ×¨×©×™×ž×” ×ž×—×™×¨',0),(30405,845,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½',0),(30406,845,'zh','åˆ é™¤è¯¥è‚¡ç¥¨ä»·æ ¼è¡¨\r\n',0),(30407,845,'sv','Ta bort detta pris lista bestÃ¥nd',0),(30408,845,'it','Eliminare questo prezzo lista Stock',0),(30409,845,'tl','',0),(30410,845,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3657;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(30411,845,'hi','à¤‡à¤¸ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30412,845,'ms','Hapuskan senarai harga saham',0),(30413,845,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ \"Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ÙÙŠ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\"',0),(30414,845,'fr','Supprimer ce Stock de liste de prix',0),(30415,845,'jp','Delete this Price List Stock',0),(30416,845,'pt','Excluir este estoque de lista de preÃ§o',0),(30417,845,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð·Ð°Ð¿Ð°Ñ ÑÐ¿Ð¸ÑÐ¾Ðº Ñ†ÐµÐ½',0),(30418,845,'es','Eliminar esta Lista de Precios se Stock',0),(30419,845,'de','LÃ¶schen Sie diesen Preis Liste bestand',0),(30420,845,'en','Delete this Price List Stock',0),(30421,846,'is','',0),(30422,846,'dr','Ø­Ø°Ù Ø§ÙŠÙ†  Ø³ÙˆØ§Ù„',0),(30423,846,'pr','Ø­Ø°Ù Ø§ÙŠÙ†  Ø³ÙˆØ§Ù„',0),(30424,846,'tr','Bu soruyu silmek',0),(30425,846,'pl','UsuÅ„ to pytanie',0),(30426,846,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð²ÑŠÐ¿Ñ€Ð¾Ñ',0),(30427,846,'ur','ÛŒÛ Ø³ÙˆØ§Ù„ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30428,846,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð¾ Ð¿Ð¸Ñ‚Ð°ÑšÐµ',0),(30429,846,'vi','XÃ³a cÃ¢u há»i nÃ y',0),(30430,846,'af','Skrap hierdie Vraag',0),(30431,846,'ro','ÅžtergeÅ£i aceastÄƒ Ã®ntrebare',0),(30432,846,'et','Kustuta kÃ¼simus',0),(30433,846,'si','Izbrisati to vpraÅ¡anje',0),(30434,846,'ba','Menghapus pertanyaan ini',0),(30435,846,'nl','Verwijderen van deze vraag',0),(30436,846,'fi','Poistaa tÃ¤mÃ¤n kysymyksen',0),(30437,846,'no','Slette dette spÃ¸rsmÃ¥let',0),(30438,846,'da','Slet dette spÃ¸rgsmÃ¥l',0),(30439,846,'ko','ì´ ì§ˆë¬¸ì„ ì‚­ì œ',0),(30440,846,'he','×œ×ž×—×•×§ ×©××œ×” ×–×•',0),(30441,846,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(30442,846,'zh','åˆ é™¤æ­¤é—®é¢˜\r\n',0),(30443,846,'sv','Ta bort denna frÃ¥ga',0),(30444,846,'it','Cancella questa domanda',0),(30445,846,'tl','',0),(30446,846,'th','&#3621;&#3610;&#3588;&#3635;&#3606;&#3634;&#3617;&#3609;&#3637;&#3657;',0),(30447,846,'hi','à¤‡à¤¸ à¤¸à¤µà¤¾à¤² à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30448,846,'ms','Menghapuskan soalan ini',0),(30449,846,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø³Ø¤Ø§Ù„',0),(30450,846,'fr','Supprimer cette Question',0),(30451,846,'jp','ã?“ã?®è³ªå•?ã‚’æ¶ˆåŽ»',0),(30452,846,'pt','Exclua esta pergunta',0),(30453,846,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð’Ð¾Ð¿Ñ€Ð¾Ñ',0),(30454,846,'es','Eliminar esta Pregunta',0),(30455,846,'de','Diese Frage zu lÃ¶schen',0),(30456,846,'en','Delete this Question',0),(30457,847,'is','',0),(30458,847,'dr','Ø­Ø°Ù Ø§ÙŠÙ†  Ù†Ø¸Ø± Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(30459,847,'pr','Ø­Ø°Ù Ø§ÙŠÙ†  Ù†Ø¸Ø± Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(30460,847,'tr','Bu alÄ±ntÄ± yorumu silmek',0),(30461,847,'pl','UsunÄ…Ä‡ ten cytat komentarz',0),(30462,847,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð·Ð° ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(30463,847,'ur','ÛŒÛ Ø§Ù‚ØªØ¨Ø§Ø³ ØªØ¨ØµØ±Û Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30464,847,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€ Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ñ‚Ð¸',0),(30465,847,'vi','XÃ³a nháº­n xÃ©t cá»§a bÃ¡o giÃ¡ nÃ y',0),(30466,847,'af','Skrap hierdie Kwotasie Opmerking',0),(30467,847,'ro','ÅžtergeÅ£i acest comentariu cita',0),(30468,847,'et','Kustuta seda tsiteerida kommentaari',0),(30469,847,'si','Izbrisati citiram komentar',0),(30470,847,'ba','Menghapus komentar ini mengutip',0),(30471,847,'nl','Dit citaat commentaar verwijderen',0),(30472,847,'fi','Poista tÃ¤mÃ¤ lainaus kommentti',0),(30473,847,'no','Slette denne sitat kommentaren',0),(30474,847,'da','Slet denne citerer kommentar',0),(30475,847,'ko','ì´ ì¸ìš© ì½”ë©˜íŠ¸ ì‚­ì œ',0),(30476,847,'he','×œ×ž×—×•×§ ××ª ×”×”×¢×¨×” ×œ×¦×˜×˜',0),(30477,847,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï€Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï„Î¿ ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(30478,847,'zh','åˆ é™¤æ­¤æŠ¥ä»·è¯„è®º\r\n',0),(30479,847,'sv','Ta bort detta citerar kommentar',0),(30480,847,'it','Cancella questo commento di risposta',0),(30481,847,'tl','',0),(30482,847,'th','&#3621;&#3610;&#3588;&#3623;&#3634;&#3617;&#3648;&#3627;&#3655;&#3609;&#3607;&#3637;&#3656;&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3617;&#3634;&#3609;&#3637;&#3657;',0),(30483,847,'hi','à¤‡à¤¸ à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤¹à¤Ÿà¤¾à¤à¤',0),(30484,847,'ms','Menghapuskan komen sebut harga ini',0),(30485,847,'ar','Ø­Ø°Ù ØªØ¹Ù‚ÙŠØ¨ Ù‡Ø°Ø§ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(30486,847,'fr','Supprimer ce commentaire cite',0),(30487,847,'jp','ã?“ã?®è¦‹ç©?ã‚‚ã‚Šæ³¨é‡ˆã‚’æ¶ˆåŽ»',0),(30488,847,'pt','Excluir este comentÃ¡rio citar',0),(30489,847,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹, Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(30490,847,'es','Eliminar este Comentario de la CotizaciÃ³n',0),(30491,847,'de','Dieses Zitat Kommentar lÃ¶schen',0),(30492,847,'en','Delete this Quote Comment',0),(30493,848,'is','',0),(30494,848,'dr','Ø­Ø°Ù Ø§ÙŠÙ†  ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± ',0),(30495,848,'pr','Ø­Ø°Ù Ø§ÙŠÙ†  ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± ',0),(30496,848,'tr','Bu inceleme Sil',0),(30497,848,'pl','UsuÅ„ ten przeglÄ…d',0),(30498,848,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(30499,848,'ur','ÛŒÛ ØªØ¨ØµØ±Û Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30500,848,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ ÐºÑ€Ð¸Ñ‚Ð¸ÐºÑƒ',0),(30501,848,'vi','XÃ³a Ä‘Ã¡nh giÃ¡ nÃ y',0),(30502,848,'af','Skrap hierdie Oorsig',0),(30503,848,'ro','ÅžtergeÅ£i aceastÄƒ recenzie',0),(30504,848,'et','Kustuta see arvustus',0),(30505,848,'si','IzbriÅ¡ite ta pregled',0),(30506,848,'ba','Menghapus ulasan ini',0),(30507,848,'nl','Dit overzicht verwijderen',0),(30508,848,'fi','Poista tÃ¤mÃ¤ tarkastelu',0),(30509,848,'no','Slette denne anmeldelsen',0),(30510,848,'da','Slet denne anmeldelse',0),(30511,848,'ko','ì´ ë¦¬ë·° ì‚­ì œ',0),(30512,848,'he','×œ×ž×—×•×§ ××ª ×”×‘×™×§×•×¨×ª ×”×–×•',0),(30513,848,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(30514,848,'zh','åˆ é™¤æ­¤å®¡æ ¸\r\n',0),(30515,848,'sv','Ta bort denna Ã¶versyn',0),(30516,848,'it','Cancella questa recensione',0),(30517,848,'tl','',0),(30518,848,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3607;&#3610;&#3607;&#3623;&#3609;&#3609;&#3637;&#3657;',0),(30519,848,'hi','à¤‡à¤¸ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30520,848,'ms','Menghapuskan ini',0),(30521,848,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„ØªÙ‚ÙŠÙŠÙ…',0),(30522,848,'fr','Supprimer cet examen',0),(30523,848,'jp','ã?“ã?®ãƒ¬ãƒ“ãƒ¥ãƒ¼ã‚’æ¶ˆåŽ»',0),(30524,848,'pt','Excluir esta revisÃ£o',0),(30525,848,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¾Ñ‚Ð·Ñ‹Ð²',0),(30526,848,'es','Eliminar esta RevisiÃ³n',0),(30527,848,'de','LÃ¶schen Sie diesen Bericht',0),(30528,848,'en','Delete this Review',0),(30529,849,'is','',0),(30530,849,'dr','Ø­Ø°Ù Ø§ÙŠÙ†  Ù†Ø±Ø® ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø±',0),(30531,849,'pr','Ø­Ø°Ù Ø§ÙŠÙ†  Ù†Ø±Ø® ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø±',0),(30532,849,'tr','Bu inceleme Puan silme',0),(30533,849,'pl','UsuÅ„ ten przeglÄ…d ocena',0),(30534,849,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(30535,849,'ur','Ø§Ø³ Ú©ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30536,849,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³',0),(30537,849,'vi','XÃ³a thang Ä‘Ã¡nh giÃ¡ nÃ y',0),(30538,849,'af','Skrap hierdie Oorsig \"Rating\"',0),(30539,849,'ro','ÅžtergeÅ£i aceastÄƒ recenzie Rating',0),(30540,849,'et','Kustuta see lÃ¤bi Reiting',0),(30541,849,'si','IzbriÅ¡ite ta pregled Rating',0),(30542,849,'ba','Menghapus Rating Review ini',0),(30543,849,'nl','Verwijder deze Review Rating',0),(30544,849,'fi','Poista tÃ¤mÃ¤ Review luokitus',0),(30545,849,'no','Slette denne gjennomgang Rating',0),(30546,849,'da','Slet denne Spilanmeldelse bedÃ¸mmelse',0),(30547,849,'ko','ì´ ê²€í†  í‰ê°€ ì‚­ì œ',0),(30548,849,'he','×œ×ž×—×•×§ ××ª ×“×™×¨×•×’ ×¡×§×™×¨×”',0),(30549,849,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Î²Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(30550,849,'zh','åˆ é™¤æ­¤å®¡æ ¸çŽ‡\r\n',0),(30551,849,'sv','Ta bort denna Ã¶versyn betyg',0),(30552,849,'it','Cancella questo voto di recensione',0),(30553,849,'tl','',0),(30554,849,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3607;&#3610;&#3607;&#3623;&#3609;&#3629;&#3633;&#3605;&#3619;&#3634;&#3609;&#3637;&#3657;',0),(30555,849,'hi','à¤‡à¤¸ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30556,849,'ms','Menghapuskan Rating kajian ini',0),(30557,849,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ \"Ø§Ù„Ø§Ø³ØªØ¹Ø±Ø§Ø¶ ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ù…ÙˆÙ‚Ø¹\"',0),(30558,849,'fr','Supprimer cette rÃ©vision de note',0),(30559,849,'jp','ã?“ã?®ãƒ¬ãƒ“ãƒ¥ãƒ¼è©•ä¾¡ã‚’æ¶ˆåŽ»',0),(30560,849,'pt','Excluir esta revisÃ£o de avaliaÃ§Ã£o',0),(30561,849,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¾Ð±Ð·Ð¾Ñ€ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(30562,849,'es','Eliminar esta ValuaciÃ³n de RevisiÃ³n',0),(30563,849,'de','LÃ¶schen Sie dieses Review Rating',0),(30564,849,'en','Delete this Review Rating',0),(30565,850,'is','',0),(30566,850,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± ÙØ±ÙˆØ´',0),(30567,850,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± ÙØ±ÙˆØ´',0),(30568,850,'tr','Bu satÄ±ÅŸ vergisi Sil',0),(30569,850,'pl','UsuÅ„ ten podatek',0),(30570,850,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð´Ð°Ð½ÑŠÐº',0),(30571,850,'ur','Ø§Ø³ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30572,850,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(30573,850,'vi','XÃ³a thuáº¿ bÃ¡n hÃ ng nÃ y',0),(30574,850,'af','Skrap hierdie Verkoopsbelasting',0),(30575,850,'ro','ÅžtergeÅ£i acest TVA',0),(30576,850,'et','Kustuta see kÃ¤ibemaks',0),(30577,850,'si','IzbriÅ¡ite ta prometni davek',0),(30578,850,'ba','Menghapus pajak penjualan ini',0),(30579,850,'nl','Deze Sales Tax verwijderen',0),(30580,850,'fi','Poista tÃ¤mÃ¤ arvonlisÃ¤vero',0),(30581,850,'no','Slette denne mva',0),(30582,850,'da','Slet denne moms',0),(30583,850,'ko','ì´ íŒë§¤ì„¸ë¥¼ ì‚­ì œ',0),(30584,850,'he','×œ×ž×—×•×§ ××ª ×”×ž×¢ ×ž',0),(30585,850,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(30586,850,'zh','åˆ é™¤æ­¤é”€å”®ç¨Ž\r\n',0),(30587,850,'sv','Ta bort denna moms',0),(30588,850,'it','Cancella questa tassa di vendite',0),(30589,850,'tl','',0),(30590,850,'th','&#3621;&#3610;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(30591,850,'hi','à¤‡à¤¸ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡',0),(30592,850,'ms','Menghapuskan cukai jualan ini',0),(30593,850,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(30594,850,'fr','Supprimer cette taxe de vente',0),(30595,850,'jp','ã?“ã?®å£²ä¸Šç¨Žã‚’æ¶ˆåŽ»',0),(30596,850,'pt','Excluir este imposto sobre vendas',0),(30597,850,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ð¹ ÐÐ°Ð»Ð¾Ð³ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(30598,850,'es','Eliminar este IVA',0),(30599,850,'de','LÃ¶schen Sie diese Umsatzsteuer',0),(30600,850,'en','Delete this Sales Tax',0),(30601,851,'is','',0),(30602,851,'dr','Ø­Ø°Ù Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(30603,851,'pr','Ø­Ø°Ù Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(30604,851,'tr','Bu satÄ±ÅŸ elemanÄ± Sil',0),(30605,851,'pl','UsuÅ„ ten sprzedawca',0),(30606,851,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(30607,851,'ur','ÛŒÛ Ù¾Ø±Ø³Ù† Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30608,851,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¾Ð²Ð¾Ð³ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(30609,851,'vi','XÃ³a nhÃ¢n viÃªn kinh doanh nÃ y',0),(30610,851,'af','Skrap hierdie Verkoopspersoon',0),(30611,851,'ro','ÅžtergeÅ£i acest agent de vÃ¢nzÄƒri',0),(30612,851,'et','Kustuta see mÃ¼Ã¼giisik',0),(30613,851,'si','Brisanje tega prodajalca',0),(30614,851,'ba','Menghapus penjual ini',0),(30615,851,'nl','Deze verkoper verwijderen',0),(30616,851,'fi','Poista myyjÃ¤n',0),(30617,851,'no','Slette denne selgeren',0),(30618,851,'da','Slet denne sÃ¦lger',0),(30619,851,'ko','ì´ ì˜ì—… ì‚¬ì› ì‚­ì œ',0),(30620,851,'he','×œ×ž×—×•×§ ××ª ××™×© ×”×ž×›×™×¨×•×ª',0),(30621,851,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï€Ï‰Î»Î·Ï„Î®',0),(30622,851,'zh','åˆ é™¤è¿™åé”€å”®äººå‘˜\r\n',0),(30623,851,'sv','Ta bort denna sÃ¤ljare',0),(30624,851,'it','Cancella questo venditore',0),(30625,851,'tl','',0),(30626,851,'th','&#3621;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(30627,851,'hi','à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30628,851,'ms','Menghapuskan jurujual ini',0),(30629,851,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(30630,851,'fr','Supprimer ce vendeur',0),(30631,851,'jp','ã?“ã?®ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“ã‚’æ¶ˆåŽ»',0),(30632,851,'pt','Excluir este vendedor',0),(30633,851,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(30634,851,'es','Eliminar este Vendedor',0),(30635,851,'de','LÃ¶schen Sie diesen VerkÃ¤ufer',0),(30636,851,'en','Delete this Salesperson',0),(30637,852,'is','',0),(30638,852,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø­Ù…Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³',0),(30639,852,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø­Ù…Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³',0),(30640,852,'tr','Bu gemi iÃ§in adres silme',0),(30641,852,'pl','UsuÅ„ ten statek na adres',0),(30642,852,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð° Ð°Ð´Ñ€ÐµÑ',0),(30643,852,'ur','Ø§Ø³ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Ùˆ Ù¾ØªÛ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30644,852,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð±Ñ€Ð¾Ð´ Ð½Ð° Ð°Ð´Ñ€ÐµÑÑƒ',0),(30645,852,'vi','XÃ³a Ä‘á»‹a chá»‰ chuyá»ƒn hÃ ng',0),(30646,852,'af','Skrap hierdie Versend Na Adres',0),(30647,852,'ro','ÅžtergeÅ£i aceastÄƒ navÄƒ la adresa',0),(30648,852,'et','Kustuta see tarneaadress',0),(30649,852,'si','IzbriÅ¡ite ta ladja na naslov',0),(30650,852,'ba','Hapus kapal ini ke alamat',0),(30651,852,'nl','Dit verzendadres verwijderen',0),(30652,852,'fi','Poista tÃ¤mÃ¤ toim.asiakk.',0),(30653,852,'no','Slette denne forsendelsesadresse',0),(30654,852,'da','Slet denne leveringsadresse',0),(30655,852,'ko','ì´ ë°°ì†¡ ì£¼ì†Œ ì‚­ì œ',0),(30656,852,'he','×œ×ž×—×•×§ ××ª ×”×¡×¤×™× ×” ×œ×›×ª×•×‘×ª',0),(30657,852,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï€Î»Î¿Î¯Î¿ ÏƒÏ„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(30658,852,'zh','åˆ é™¤æ­¤æ”¶è´§åœ°å€\r\n',0),(30659,852,'sv','Ta bort denna fraktadress',0),(30660,852,'it','Cancella questo indirizzo a cui spedire',0),(30661,852,'tl','',0),(30662,852,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3609;&#3637;&#3657;',0),(30663,852,'hi','à¤ªà¤¤à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30664,852,'ms','Menghapuskan kapal ini ke alamat',0),(30665,852,'ar','Ø­Ø°Ù Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø´Ø­Ù† Ù‡Ø°Ø§',0),(30666,852,'fr','Supprimer ce navire Ã  l\'adresse',0),(30667,852,'jp','ã?“ã?®é…?é€?å…ˆä½?æ‰€ã‚’æ¶ˆåŽ»',0),(30668,852,'pt','Excluir este navio para o endereÃ§o',0),(30669,852,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð½Ð° Ð°Ð´Ñ€ÐµÑ',0),(30670,852,'es','Eliminar esta DirecciÃ³n a Enviar',0),(30671,852,'de','Dieses Schiff an Adresse lÃ¶schen',0),(30672,852,'en','Delete this Ship to Address',0),(30673,853,'is','',0),(30674,853,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø­Ù…Ù„ Ø¨Ù‡ Ù…Ø­Ù„ ',0),(30675,853,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø­Ù…Ù„ Ø¨Ù‡ Ù…Ø­Ù„ ',0),(30676,853,'tr','Bu gemi iÃ§in konumu silmek',0),(30677,853,'pl','UsuÅ„ ten statek do lokalizacji',0),(30678,853,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ ÐºÐ¾Ñ€Ð°Ð± Ð·Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(30679,853,'ur','Ø§Ø³ Ú©Ø´ØªÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30680,853,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð±Ñ€Ð¾Ð´ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(30681,853,'vi','XÃ³a vá»‹ trÃ­ chuyá»ƒn hÃ ng',0),(30682,853,'af','Skrap hierdie Versend Aan Ligging',0),(30683,853,'ro','ÅžtergeÅ£i aceastÄƒ navÄƒ la locaÅ£ie',0),(30684,853,'et','Kustuta see tarne sihtpunkt',0),(30685,853,'si','IzbriÅ¡ite ta ladja na lokaciji',0),(30686,853,'ba','Hapus kapal ke lokasi ini',0),(30687,853,'nl','Dit schip tot locatie verwijderen',0),(30688,853,'fi','Poistaa tÃ¤mÃ¤n aluksen sen sijainnin',0),(30689,853,'no','Slette denne skipet til plasseringen',0),(30690,853,'da','Slet dette skib til placering',0),(30691,853,'ko','ì´ ì„ ì  ìœ„ì¹˜ ì‚­ì œ',0),(30692,853,'he','×ž×—×™×§×ª ×ž×™×§×•× ×›×“×™ ×–×” ×”×¡×¤×™× ×”',0),(30693,853,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Ï‰Î½ Î±Ï…Ï„ÏŒ Ï€Î»Î¿Î¯Î¿ ÏƒÏ„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎ· Ï€ÏÎ¿Î¿ÏÎ¹ÏƒÎ¼Î¿Ï',0),(30694,853,'zh','åˆ é™¤æ­¤æ”¶è´§åœ°ç‚¹\r\n',0),(30695,853,'sv','Ta bort detta fartyg till lÃ¤ge',0),(30696,853,'it','Cancella questa localitÃ  a cui spedire',0),(30697,853,'tl','',0),(30698,853,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3609;&#3637;&#3657;',0),(30699,853,'hi','à¤‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30700,853,'ms','Hapuskan lokasi untuk kapal ini',0),(30701,853,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ \"Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ù„Ù…ÙˆÙ‚Ø¹\"',0),(30702,853,'fr','Supprimer ce navire Ã  l\'autre',0),(30703,853,'jp','ã?“ã?®é…?é€?å…ˆãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã‚’æ¶ˆåŽ»',0),(30704,853,'pt','Excluir este navio para localizaÃ§Ã£o',0),(30705,853,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð½Ð° Ð¼ÐµÑÑ‚Ðµ',0),(30706,853,'es','Eliminar este UbicaciÃ³n para Enviar',0),(30707,853,'de','Dieses Schiff zu Ort lÃ¶schen',0),(30708,853,'en','Delete this Ship To Location',0),(30709,854,'is','',0),(30710,854,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(30711,854,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(30712,854,'tr','Bu standart Ã¶lÃ§Ã¼ Sil',0),(30713,854,'pl','UsuÅ„ ten rozmiar standardowy',0),(30714,854,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(30715,854,'ur','ÛŒÛ Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ø³Ø§Ø¦Ø² Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30716,854,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ñƒ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(30717,854,'vi','XÃ³a kÃ­ch cá»¡ chuáº©n nÃ y',0),(30718,854,'af','Skrap hierdie standaard lÃªer',0),(30719,854,'ro','ÅžtergeÅ£i aceastÄƒ dimensiune standard',0),(30720,854,'et','KÃ¤esolev standard suurus kustutamine',0),(30721,854,'si','Izbrisati te standardne velikosti',0),(30722,854,'ba','Menghapus ini ukuran standar',0),(30723,854,'nl','Verwijderen van deze standaard grootte',0),(30724,854,'fi','Poista tÃ¤mÃ¤ vakiokoko',0),(30725,854,'no','Slette denne standard stÃ¸rrelse',0),(30726,854,'da','Slet denne standard stÃ¸rrelse',0),(30727,854,'ko','ì´ í‘œì¤€ í¬ê¸° ì‚­ì œ',0),(30728,854,'he','×œ×ž×—×•×§ ××ª ×–×” ×‘×’×•×“×œ ×¡×˜× ×“×¨×˜×™',0),(30729,854,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ ÎºÎ±Î½Î¿Î½Î¹ÎºÎ¿Ï Î¼ÎµÎ³Î­Î¸Î¿Ï…Ï‚',0),(30730,854,'zh','åˆ é™¤æ­¤æ ‡å‡†å°ºå¯¸\r\n',0),(30731,854,'sv','Ta bort denna standard storlek',0),(30732,854,'it','Cancella questa dimensione standard',0),(30733,854,'tl','',0),(30734,854,'th','&#3621;&#3610;&#3586;&#3609;&#3634;&#3604;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(30735,854,'hi','à¤‡à¤¸ à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤° à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30736,854,'ms','Menghapuskan saiz standard ini',0),(30737,854,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ',0),(30738,854,'fr','Supprimer cette taille standard',0),(30739,854,'jp','ã?“ã?®ã‚¹ã‚¿ãƒ³ãƒ€ãƒ¼ãƒ‰ã‚µã‚¤ã‚ºã‚’æ¶ˆåŽ»',0),(30740,854,'pt','Excluir este tamanho padrÃ£o',0),(30741,854,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(30742,854,'es','Eliminar este tamaÃ±o estÃ¡ndar',0),(30743,854,'de','LÃ¶schen Sie diese StandardgrÃ¶ÃŸe',0),(30744,854,'en','Delete this standard size',0),(30745,855,'is','',0),(30746,855,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(30747,855,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(30748,855,'tr','Bu vergi muafiyeti Sil',0),(30749,855,'pl','UsuÅ„ to zwolnienie z podatku',0),(30750,855,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð²Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº',0),(30751,855,'ur','ÛŒÛ Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30752,855,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½Ð¾Ð³ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(30753,855,'vi','XÃ³a miá»…n trá»« thuáº¿ nÃ y',0),(30754,855,'af','Skrap hierdie Belastingvrystelling',0),(30755,855,'ro','ÅžtergeÅ£i aceastÄƒ scutire de impozit',0),(30756,855,'et','Kustuta see maksuvabastus',0),(30757,855,'si','IzbriÅ¡ite ta oprostitev davka',0),(30758,855,'ba','Menghapus Pembebasan pajak ini',0),(30759,855,'nl','Verwijderen van deze fiscale vrijstelling',0),(30760,855,'fi','Poista verovapautus',0),(30761,855,'no','Slette denne skattefritak',0),(30762,855,'da','Slet denne skattefrihed',0),(30763,855,'ko','ì´ ì„¸ê¸ˆ ê³µì œë¥¼ ì‚­ì œ',0),(30764,855,'he','×œ×ž×—×•×§ ×–×” ×¤×˜×•×¨ ×ž×ž×¡',0),(30765,855,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï€Î±Î»Î»Î±Î³Î® Î±Ï€ÏŒ Ï„Î¿ Ï†ÏŒÏÎ¿ Î±Ï…Ï„ÏŒ',0),(30766,855,'zh','åˆ é™¤æ­¤å…ç¨Ž\r\n',0),(30767,855,'sv','Ta bort denna skattebefrielse',0),(30768,855,'it','Eliminare questa esenzione fiscale',0),(30769,855,'tl','',0),(30770,855,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;&#3609;&#3637;&#3657;',0),(30771,855,'hi','à¤‡à¤¸ à¤•à¤° à¤›à¥‚à¤Ÿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30772,855,'ms','Menghapuskan pengecualian cukai',0),(30773,855,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ',0),(30774,855,'fr','Supprimer cette exonÃ©ration fiscale',0),(30775,855,'jp','ã?“ã?®ç¨ŽæŽ§é™¤ã‚’æ¶ˆåŽ»',0),(30776,855,'pt','Excluir esta isenÃ§Ã£o fiscal',0),(30777,855,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(30778,855,'es','Eliminar este ExenciÃ³n de Impuestos',0),(30779,855,'de','LÃ¶schen Sie diese Steuerbefreiung',0),(30780,855,'en','Delete this Tax Exemption',0),(30781,856,'is','',0),(30782,856,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(30783,856,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(30784,856,'tr','Bu vergi tÃ¼rÃ¼ Sil',0),(30785,856,'pl','UsunÄ…Ä‡ ten typ podatku',0),(30786,856,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ñ‚Ð¸Ð¿ Ð´Ð°Ð½ÑŠÐº',0),(30787,856,'ur','ÛŒÛ Ù¹ÛŒÚ©Ø³ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30788,856,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð²Ñ€ÑÑ‚Ñƒ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(30789,856,'vi','XÃ³a loáº¡i thuáº¿ nÃ y',0),(30790,856,'af','Skrap hierdie Belastingtipe',0),(30791,856,'ro','ÅžtergeÅ£i acest tip de impozit',0),(30792,856,'et','Kustuta selle maksu liik',0),(30793,856,'si','Izbrisati to vrsto davka',0),(30794,856,'ba','Menghapus jenis pajak',0),(30795,856,'nl','Deze belasting Type verwijderen',0),(30796,856,'fi','Poista tÃ¤mÃ¤ vero',0),(30797,856,'no','Slette denne skatt',0),(30798,856,'da','Slet denne afgiftstype.',0),(30799,856,'ko','ì´ ì„¸ê¸ˆ ìœ í˜• ì‚­ì œ',0),(30800,856,'he','×œ×ž×—×•×§ ×¡×•×’ ×”×ž×¡ ×–×”',0),(30801,856,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎµÎ¯Î´Î¿Ï‚ Ï†ÏŒÏÎ¿Ï…',0),(30802,856,'zh','åˆ é™¤æ­¤ç¨Žç§\r\n',0),(30803,856,'sv','Ta bort denna typ av skatte',0),(30804,856,'it','Cancella questo tipo di tassa',0),(30805,856,'tl','',0),(30806,856,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;&#3609;&#3637;&#3657;',0),(30807,856,'hi','à¤‡à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¹à¤Ÿà¤¾',0),(30808,856,'ms','Menghapuskan jenis cukai ini',0),(30809,856,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ \"Ø§Ù„Ù†ÙˆØ¹ Ù…Ù† Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨\"',0),(30810,856,'fr','Supprimer ce Type d\'impÃ´t',0),(30811,856,'jp','ã?“ã?®ç¨Žã‚¿ã‚¤ãƒ—ã‚’æ¶ˆåŽ»',0),(30812,856,'pt','Excluir este tipo de imposto',0),(30813,856,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð¢Ð¸Ð¿ ÐÐ°Ð»Ð¾Ð³Ð°',0),(30814,856,'es','Eliminar este Tipo de Impuesto',0),(30815,856,'de','LÃ¶schen Sie diese Steuerart',0),(30816,856,'en','Delete this Tax Type',0),(30817,857,'is','',0),(30818,857,'dr','Ø­Ø°Ù Ø§ÙŠÙ† ÙˆØ§Ø­Ø¯ Ù†Ø§Ù… ',0),(30819,857,'pr','Ø­Ø°Ù Ø§ÙŠÙ† ÙˆØ§Ø­Ø¯ Ù†Ø§Ù… ',0),(30820,857,'tr','Bu birim adÄ± silme',0),(30821,857,'pl','DelegowaÄ‡ ten nazwa jednostki',0),(30822,857,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð²Ð° Ð·Ð²ÐµÐ½Ð¾ Ð¸Ð¼Ðµ',0),(30823,857,'ur','Ø§Ø³ ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30824,857,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ Ð¸Ð¼Ðµ',0),(30825,857,'vi','XÃ³a tÃªn Ä‘Æ¡n vá»‹ nÃ y',0),(30826,857,'af','Skrap hierdie Eenheidsnaam',0),(30827,857,'ro','ÅžtergeÅ£i acest nume de unitatea de',0),(30828,857,'et','Kustuta selle Ã¼hiku nimi',0),(30829,857,'si','Izbrisati to ime enote',0),(30830,857,'ba','Menghapus nama Unit ini',0),(30831,857,'nl','Deze eenheid naam verwijderen',0),(30832,857,'fi','Poista tÃ¤mÃ¤n yksikÃ¶n nimi',0),(30833,857,'no','Slette denne navn',0),(30834,857,'da','Slet denne enhed navn',0),(30835,857,'ko','ì´ ë‹¨ìœ„ ì´ë¦„ì„ ì‚­ì œí•©ë‹ˆë‹¤',0),(30836,857,'he','×œ×ž×—×•×§ ××ª ×©× ×”×™×—×™×“×”',0),(30837,857,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î±',0),(30838,857,'zh','åˆ é™¤è¯¥å•ä½åç§°\r\n',0),(30839,857,'sv','Ta bort denna enhet namn',0),(30840,857,'it','Cancella questo tipo di unitÃ ',0),(30841,857,'tl','',0),(30842,857,'th','&#3621;&#3610;&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3609;&#3637;&#3657;',0),(30843,857,'hi','à¤‡à¤¸ à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤¨à¤¾à¤® à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30844,857,'ms','Menghapuskan nama Unit ini',0),(30845,857,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ \"Ø§Ù„Ø§Ø³Ù… ÙˆØ­Ø¯Ø©\"',0),(30846,857,'fr','Supprimer le nom de cette unitÃ©',0),(30847,857,'jp','ã?“ã?®å?˜ä½?å??ã‚’æ¶ˆåŽ»',0),(30848,857,'pt','Excluir este nome de unidade',0),(30849,857,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾ Ð¸Ð¼Ñ ÑƒÑÑ‚Ñ€Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(30850,857,'es','Eliminar este Nombre de Unidad',0),(30851,857,'de','LÃ¶schen Sie diese Unit-Namen',0),(30852,857,'en','Delete this Unit Name',0),(30853,858,'is','',0),(30854,858,'dr','Ø­Ø°Ù Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø±',0),(30855,858,'pr','Ø­Ø°Ù Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø±',0),(30856,858,'tr','Bu kullanÄ±cÄ±yÄ± silmek',0),(30857,858,'pl','UsunÄ…Ä‡ tego uÅ¼ytkownika',0),(30858,858,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(30859,858,'ur','Ø§Ø³ ØµØ§Ø±Ù Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30860,858,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¾Ð²Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(30861,858,'vi','XÃ³a NgÆ°á»i Sá»­ Dá»¥ng nÃ y',0),(30862,858,'af','Skrap hierdie Gebruiker',0),(30863,858,'ro','Sterge acest utilizator',0),(30864,858,'et','Kustuta see kasutaja',0),(30865,858,'si','Tega uporabnika',0),(30866,858,'ba','Menghapus pengguna ini',0),(30867,858,'nl','Deze gebruiker verwijderen',0),(30868,858,'fi','Poistaa tÃ¤mÃ¤n kÃ¤yttÃ¤jÃ¤n',0),(30869,858,'no','Slette denne brukeren',0),(30870,858,'da','Slet denne bruger',0),(30871,858,'ko','ì´ ì‚¬ìš©ìž ì‚­ì œ',0),(30872,858,'he','×ž×—×§ ×ž×©×ª×ž×© ×–×”',0),(30873,858,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï…Ï„Î¿Ï Ï„Î¿Ï… Ï‡ÏÎ®ÏƒÏ„Î·',0),(30874,858,'zh','åˆ é™¤æ­¤ç”¨æˆ·\r\n',0),(30875,858,'sv','Ta bort den hÃ¤r anvÃ¤ndaren',0),(30876,858,'it','Cancella questo utente',0),(30877,858,'tl','',0),(30878,858,'th','&#3621;&#3610;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3609;&#3637;&#3657;',0),(30879,858,'hi','à¤‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30880,858,'ms','Hapuskan pengguna ini',0),(30881,858,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(30882,858,'fr','Supprimer cet utilisateur',0),(30883,858,'jp','ã?“ã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’æ¶ˆåŽ»',0),(30884,858,'pt','Apagar este usuÃ¡rio',0),(30885,858,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(30886,858,'es','Eliminar este Usuario',0),(30887,858,'de','Diesen Benutzer lÃ¶schen',0),(30888,858,'en','Delete this User',0),(30889,859,'is','',0),(30890,859,'dr','Ø­Ø°Ù Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø± Ø§Ø² Ø¯Ø³ØªØ±Ø³ÙŠ Ø®Ø§Ø±Ø¬ÙŠ',0),(30891,859,'pr','Ø­Ø°Ù Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø± Ø§Ø² Ø¯Ø³ØªØ±Ø³ÙŠ Ø®Ø§Ø±Ø¬ÙŠ',0),(30892,859,'tr','Bu kullanÄ±cÄ±yÄ± silmek dÄ±ÅŸ eriÅŸim',0),(30893,859,'pl','UsunÄ…Ä‡ tego uÅ¼ytkownika z dostÄ™pu do zewnÄ™trznej',0),(30894,859,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð¾Ñ‚ Ð²ÑŠÐ½ÑˆÐµÐ½ Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(30895,859,'ur','Ø§Ø³ ØµØ§Ø±Ù Ú©Ùˆ Ø¨ÛŒØ±ÙˆÙ†ÛŒ Ø±Ø³Ø§Ø¦ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30896,859,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¾Ð²Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¸Ð· ÐµÐºÑÑ‚ÐµÑ€Ð½Ð¾Ð³ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð° Ð°Ñ†Ñ†ÐµÑÑ',0),(30897,859,'vi','XÃ³a NgÆ°á»i Sá»­ Dá»¥ng tá»« nguá»“n truy cáº­p bÃªn ngoÃ i nÃ y',0),(30898,859,'af','Skrap hierdie gebruiker van eksterne toegang',0),(30899,859,'ro','ÅžtergeÅ£i acest utilizator la acces extern',0),(30900,859,'et','Selle kasutaja kustutamine vÃ¤list juurdepÃ¤Ã¤su',0),(30901,859,'si','Pobrisati tega uporabnika pred zunanjim dostopom',0),(30902,859,'ba','Menghapus pengguna dari akses eksternal',0),(30903,859,'nl','Deze gebruiker uit externe toegang verwijderen',0),(30904,859,'fi','Poistaa tÃ¤mÃ¤n kÃ¤yttÃ¤jÃ¤n ulkoiselta kÃ¤ytÃ¶ltÃ¤',0),(30905,859,'no','Slette denne brukeren fra ekstern tilgang',0),(30906,859,'da','Slet denne bruger fra ekstern adgang',0),(30907,859,'ko','ì™¸ë¶€ ì•¡ì„¸ìŠ¤ì—ì„œì´ ì‚¬ìš©ìžë¥¼ ì‚­ì œ',0),(30908,859,'he','×ž×—×™×§×ª ×ž×©×ª×ž×© ×–×” ×’×™×©×” ×—×™×¦×•× ×™×ª',0),(30909,859,'el','Î”Î™Î‘Î“Î¡Î‘Î¨Î•Î¤Î• Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï‡ÏÎ®ÏƒÏ„Î· Î±Ï€ÏŒ Ï„Î·Î½ ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÎ® Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·',0),(30910,859,'zh','åˆ é™¤æ­¤ç”¨æˆ·ä»Žå¤–éƒ¨è®¿é—®\r\n',0),(30911,859,'sv','Ta bort anvÃ¤ndaren frÃ¥n extern Ã¥tkomst',0),(30912,859,'it','Cancella questo utente dall\'accesso esterno',0),(30913,859,'tl','',0),(30914,859,'th','&#3621;&#3610;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3609;&#3637;&#3657;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3592;&#3634;&#3585;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585;',0),(30915,859,'hi','à¤‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‹ à¤¬à¤¾à¤¹à¤°à¥€ à¤ªà¤¹à¥à¤à¤š à¤¸à¥‡ à¤¹à¤Ÿà¤¾à¤à¤',0),(30916,859,'ms','Hapuskan pengguna ini daripada akses Luaran',0),(30917,859,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù…Ù† Ø§Ù„ÙˆØµÙˆÙ„ Ø§Ù„Ø®Ø§Ø±Ø¬ÙŠ',0),(30918,859,'fr','Supprimer cet utilisateur d\'accÃ¨s externe',0),(30919,859,'jp','å¤–éƒ¨ã‚¢ã‚¯ã‚»ã‚¹ã?‹ã‚‰ã?“ã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’æ¶ˆåŽ»',0),(30920,859,'pt','Apagar este usuÃ¡rio de acesso externo',0),(30921,859,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð¸Ð· Ð²Ð½ÐµÑˆÐ½ÐµÐ³Ð¾ Ð´Ð¾Ð¿ÑƒÑÐºÐ°',0),(30922,859,'es','Eliminar este Usuario de Acceso External',0),(30923,859,'de','LÃ¶schen Sie diesen Benutzer vor externen Zugriffen',0),(30924,859,'en','Delete This user from external access',0),(30925,860,'is','',0),(30926,860,'dr','Ø­Ø°Ù Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(30927,860,'pr','Ø­Ø°Ù Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(30928,860,'tr','Bu satÄ±cÄ± silmek',0),(30929,860,'pl','UsuÅ„ ten sprzedawca',0),(30930,860,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(30931,860,'ur','ÛŒÛ ÙˆÛŒÙ†ÚˆØ± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30932,860,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¾Ð²Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(30933,860,'vi','XÃ³a ngÆ°á»i bÃ¡n nÃ y',0),(30934,860,'af','Skrap hierdie Verskaffer',0),(30935,860,'ro','ÅžtergeÅ£i acest furnizorul',0),(30936,860,'et','Kustuta see hankija',0),(30937,860,'si','IzbriÅ¡ite ta dobavitelj',0),(30938,860,'ba','Menghapus Vendor ini',0),(30939,860,'nl','Deze leverancier verwijderen',0),(30940,860,'fi','Poista toimittajan',0),(30941,860,'no','Slette denne leverandÃ¸ren',0),(30942,860,'da','Slet denne kreditor',0),(30943,860,'ko','ì´ ê³µê¸‰ ì—…ì²´ë¥¼ ì‚­ì œ',0),(30944,860,'he','×œ×ž×—×•×§ ××ª ×¡×¤×§ ×–×”',0),(30945,860,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(30946,860,'zh','åˆ é™¤æ­¤ä¾›åº”å•†\r\n',0),(30947,860,'sv','Ta bort leverantÃ¶ren',0),(30948,860,'it','Cancella questo fornitore',0),(30949,860,'tl','',0),(30950,860,'th','&#3621;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3619;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(30951,860,'hi','à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30952,860,'ms','Menghapuskan penjual ini',0),(30953,860,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(30954,860,'fr','Supprimer ce fournisseur',0),(30955,860,'jp','ã?“ã?®æ¥­è€…ã‚’æ¶ˆåŽ»',0),(30956,860,'pt','Excluir este fornecedor',0),(30957,860,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ð¾Ð³Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(30958,860,'es','Eliminar este Proveedor',0),(30959,860,'de','LÃ¶schen Sie diesen Kreditor',0),(30960,860,'en','Delete This Vendor',0),(30961,861,'is','',0),(30962,861,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(30963,861,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(30964,861,'tr','Bu Ã§eki Sil',0),(30965,861,'pl','UsuÅ„ ten kupon',0),(30966,861,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(30967,861,'ur','ÛŒÛ ÙˆØ§Ø¤Ú†Ø± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(30968,861,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(30969,861,'vi','XÃ³a phiáº¿u nÃ y',0),(30970,861,'af','Skrap hierdie Bewysstuk',0),(30971,861,'ro','ÅžtergeÅ£i acest Voucher',0),(30972,861,'et','Selle kande kustutamine',0),(30973,861,'si','IzbriÅ¡ite ta kupon',0),(30974,861,'ba','Menghapus Voucher ini',0),(30975,861,'nl','Deze Voucher verwijderen',0),(30976,861,'fi','Poista tÃ¤mÃ¤ tosite',0),(30977,861,'no','Slette denne Voucheren',0),(30978,861,'da','Slet denne kupon',0),(30979,861,'ko','ì´ ë°”ìš°ì²˜ë¥¼ ì‚­ì œ',0),(30980,861,'he','×œ×ž×—×•×§ ×©×•×‘×¨ ×–×”',0),(30981,861,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(30982,861,'zh','åˆ é™¤æ­¤åˆ¸\r\n',0),(30983,861,'sv','Ta bort denna verifikation',0),(30984,861,'it','Cancella questo voucher',0),(30985,861,'tl','',0),(30986,861,'th','&#3621;&#3610;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3592;&#3656;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(30987,861,'hi','à¤‡à¤¸ à¤µà¤¾à¤‰à¤šà¤° à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(30988,861,'ms','Menghapuskan baucar ini',0),(30989,861,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(30990,861,'fr','Supprimer ce bon',0),(30991,861,'jp','ã?“ã?®ä¼?ç¥¨ã‚’æ¶ˆåŽ»',0),(30992,861,'pt','Excluir este Voucher',0),(30993,861,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(30994,861,'es','Eliminar este Vale',0),(30995,861,'de','LÃ¶schen Sie diesen Gutschein',0),(30996,861,'en','Delete this Voucher',0),(30997,862,'is','',0),(30998,862,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(30999,862,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(31000,862,'tr','Bu iÅŸ tÃ¼rÃ¼ Sil',0),(31001,862,'pl','UsunÄ…Ä‡ ten typ pracy',0),(31002,862,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(31003,862,'ur','Ø§Ø³ Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(31004,862,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð°',0),(31005,862,'vi','XÃ³a loáº¡i cÃ´ng viá»‡c nÃ y',0),(31006,862,'af','Skrap hierdie Werktipe',0),(31007,862,'ro','ÅžtergeÅ£i acest tip de munca',0),(31008,862,'et','Kustuta see tÃ¶Ã¶ tÃ¼Ã¼p',0),(31009,862,'si','Izbrisati to vrsto dela',0),(31010,862,'ba','Menghapus jenis pekerjaan ini',0),(31011,862,'nl','Dit Type werk verwijderen',0),(31012,862,'fi','Poista tÃ¤mÃ¤ tyÃ¶',0),(31013,862,'no','Slette denne arbeidstypen',0),(31014,862,'da','Slet denne arbejdstype',0),(31015,862,'ko','ì´ ìž‘ì—… í˜•ì‹ ì‚­ì œ',0),(31016,862,'he','×œ×ž×—×•×§ ××ª ×¡×•×’ ×”×¢×‘×•×“×” ×”×–×”',0),(31017,862,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï„ÏÏ€Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(31018,862,'zh','åˆ é™¤æ­¤å·¥ä½œç±»åž‹\r\n',0),(31019,862,'sv','Ta bort detta arbetstyp',0),(31020,862,'it','Cancella questo tipo di lavoro',0),(31021,862,'tl','',0),(31022,862,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(31023,862,'hi','à¤‡à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(31024,862,'ms','Menghapuskan jenis kerja ini',0),(31025,862,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ \"Ø§Ù„Ù†ÙˆØ¹ Ù…Ù† Ø§Ù„Ø¹Ù…Ù„\"',0),(31026,862,'fr','Supprimer ce Type de travail',0),(31027,862,'jp','ã?“ã?®ä»•äº‹å†…å®¹ã‚’æ¶ˆåŽ»',0),(31028,862,'pt','Excluir este tipo de trabalho',0),(31029,862,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(31030,862,'es','Eliminar este Tipo de Trabajo',0),(31031,862,'de','Diese Art von Arbeit zu lÃ¶schen',0),(31032,862,'en','Delete this Work Type',0),(31033,863,'is','',0),(31034,863,'dr','Ø­Ø°Ù Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§',0),(31035,863,'pr','Ø­Ø°Ù Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§',0),(31036,863,'tr','SatÄ±cÄ± iÃ§in bu Ã¶ÄŸeyi Sil',0),(31037,863,'pl','UsunÄ…Ä‡ dostawcy dla tego przedmiotu',0),(31038,863,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(31039,863,'ur','Ø§Ø³ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ ÙˆÛŒÙ†ÚˆØ± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(31040,863,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(31041,863,'vi','XÃ³a ngÆ°á»i bÃ¡n cho hÃ ng nÃ y',0),(31042,863,'af','Skrap Verskaffer vir hierdie Item',0),(31043,863,'ro','ÅžtergeÅ£i furnizor pentru acest element',0),(31044,863,'et','Kustuta selle toote hankija',0),(31045,863,'si','Izbrisati dobavitelja za ta element',0),(31046,863,'ba','Menghapus Vendor untuk Item ini',0),(31047,863,'nl','Leverancier voor dit object verwijderen',0),(31048,863,'fi','Poista toimittajan tÃ¤lle kohteelle',0),(31049,863,'no','Slette leverandÃ¸r for denne varen',0),(31050,863,'da','Slette kreditor for dette element',0),(31051,863,'ko','ì´ í•­ëª©ì— ëŒ€ í•œ ê³µê¸‰ ì—…ì²´ë¥¼ ì‚­ì œ',0),(31052,863,'he','×œ×ž×—×•×§ ××ª ×¡×¤×§ ×¢×‘×•×¨ ×¤×¨×™×˜ ×–×”',0),(31053,863,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î³Î¹Î± Ï„Î¿ ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ ÎµÎ¯Î´Î¿Ï‚',0),(31054,863,'zh','åˆ é™¤è¯¥é¡¹ç›®ä¾›åº”å•†\r\n',0),(31055,863,'sv','Ta bort leverantÃ¶ren fÃ¶r den hÃ¤r artikeln',0),(31056,863,'it','Cancella fornitore per questo oggetto',0),(31057,863,'tl','',0),(31058,863,'th','&#3621;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;',0),(31059,863,'hi','à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(31060,863,'ms','Menghapuskan penjual untuk Item ini',0),(31061,863,'ar','Ø­Ø°Ù Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ† Ù„Ù‡Ø°Ø§ Ø§Ù„ØµÙ†Ù',0),(31062,863,'fr','Supprimer du vendeur pour cet article',0),(31063,863,'jp','ã?“ã?®å“?ç›®ã?‹ã‚‰æ¥­è€…ã‚’æ¶ˆåŽ»',0),(31064,863,'pt','Excluir fornecedores para este Item',0),(31065,863,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð´Ð»Ñ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(31066,863,'es','Eliminar el Proveedor para este Item',0),(31067,863,'de','Anbieter fÃ¼r diesen Artikel lÃ¶schen',0),(31068,863,'en','Delete Vendor for this Item',0),(31069,864,'is','',0),(31070,864,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(31071,864,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(31072,864,'tr','BaÅŸarÄ±yla silindi',0),(31073,864,'pl','UsuniÄ™te pomyÅ›lnie',0),(31074,864,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(31075,864,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(31076,864,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(31077,864,'vi','XÃ³a thÃ nh cÃ´ng',0),(31078,864,'af','Suksesvol Geskrap',0),(31079,864,'ro','EliminÄƒ cu succes',0),(31080,864,'et','Kustutati edukalt',0),(31081,864,'si','UspeÅ¡no izbrisana',0),(31082,864,'ba','Dihapus berhasil',0),(31083,864,'nl','Met succes verwijderd',0),(31084,864,'fi','Poistettu',0),(31085,864,'no','Slettet',0),(31086,864,'da','Slettet',0),(31087,864,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ',0),(31088,864,'he','× ×ž×—×§ ×‘×”×¦×œ×—×”',0),(31089,864,'el','Î”Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(31090,864,'zh','åˆ é™¤æˆåŠŸ',0),(31091,864,'sv','Raderades',0),(31092,864,'it','Eliminato con successo',0),(31093,864,'tl','',0),(31094,864,'th','&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(31095,864,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(31096,864,'ms','Dihapuskan dengan jayanya',0),(31097,864,'ar','Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(31098,864,'fr','SupprimÃ© avec succÃ¨s',0),(31099,864,'jp','æ¶ˆåŽ»ã?—ã?¾ã?—ã?Ÿ',0),(31100,864,'pt','Apagado com sucesso',0),(31101,864,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½Ð¾',0),(31102,864,'es','Eliminado Exitosamente',0),(31103,864,'de','Erfolgreich gelÃ¶scht',0),(31104,864,'en','Deleted Successfully',0),(31105,865,'is','',0),(31106,865,'dr','Ø­Ù…Ù„ Ø¨Ù‡ ',0),(31107,865,'pr','Ø­Ù…Ù„ Ø¨Ù‡ ',0),(31108,865,'tr','GÃ¶nderilecek',0),(31109,865,'pl','Dostawy',0),(31110,865,'bg','Ð—Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(31111,865,'ur','Ø¬ÛØ§Ø² Ú©Ùˆ',0),(31112,865,'sr','ÐŸÑ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(31113,865,'vi','Chuyá»ƒn tá»›i',0),(31114,865,'af','Skip-om te',0),(31115,865,'ro','Livrare-la',0),(31116,865,'et','Saaja',0),(31117,865,'si','Za dobavo',0),(31118,865,'ba','Kapal ke',0),(31119,865,'nl','Verzendadres',0),(31120,865,'fi','Toimitusasiakkaan',0),(31121,865,'no','Lever til-',0),(31122,865,'da','Skibet til-',0),(31123,865,'ko','ë°°ì†¡',0),(31124,865,'he','×œ×ž×©×œ×•×—',0),(31125,865,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ',0),(31126,865,'zh','æ”¶è´§åœ°\r\n',0),(31127,865,'sv','Leveransadress',0),(31128,865,'it','Spedisci a',0),(31129,865,'tl','',0),(31130,865,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;',0),(31131,865,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‹',0),(31132,865,'ms','Kapal untuk',0),(31133,865,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(31134,865,'fr','Destinataire',0),(31135,865,'jp','é…?é€?å…ˆ',0),(31136,865,'pt','Envio-a',0),(31137,865,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ',0),(31138,865,'es','Enviar-a',0),(31139,865,'de','Lieferadresse',0),(31140,865,'en','Ship-to',0),(31141,866,'is','',0),(31142,866,'dr','Ø±ÙˆØ´ Ù†Ù…ÙˆÙ†Ù‡ Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ ',0),(31143,866,'pr','Ø±ÙˆØ´ Ù†Ù…ÙˆÙ†Ù‡ Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ ',0),(31144,866,'tr','DEMO MODU',0),(31145,866,'pl','TRYB DEMONSTRACYJNY',0),(31146,866,'bg','Ð”Ð•ÐœÐž Ð Ð•Ð–Ð˜Ðœ',0),(31147,866,'ur','ÚˆÛŒÙ…Ùˆ Ù…ÙˆÚˆ',0),(31148,866,'sr','Ð”Ð•ÐœÐž ÐœÐžÐ”',0),(31149,866,'vi','Äang Demo',0),(31150,866,'af','DEMO MODUS',0),(31151,866,'ro','MODUL DEMO',0),(31152,866,'et','DEMO REÅ½IIM',0),(31153,866,'si','DEMO NAÄŒINU',0),(31154,866,'ba','DEMO MODE',0),(31155,866,'nl','DEMO-MODUS',0),(31156,866,'fi','MIELENOSOITUS MOODI',0),(31157,866,'no','DEMO-MODUS',0),(31158,866,'da','DEMO-TILSTAND',0),(31159,866,'ko','ë°ëª¨ ëª¨ë“œ',0),(31160,866,'he','×‘×ž×¦×‘ ×”×“×’×ž×”',0),(31161,866,'el','Î›Î•Î™Î¤ÎŸÎ¥Î¡Î“ÎŠÎ‘ Î•Î ÎŠÎ”Î•Î™ÎžÎ—Î£',0),(31162,866,'zh','æ¼”ç¤ºæ¨¡å¼\r\n',0),(31163,866,'sv','DEMO-LÃ„GE',0),(31164,866,'it','MODALITA\' DIMOSTRATIVA',0),(31165,866,'tl','',0),(31166,866,'th','&#3650;&#3627;&#3617;&#3604;&#3626;&#3634;&#3608;&#3636;&#3605;',0),(31167,866,'hi','à¤¡à¥‡à¤®à¥‹ à¤®à¥‹à¤¡',0),(31168,866,'ms','MOD DEMO',0),(31169,866,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¹Ø±Ø¶',0),(31170,866,'fr','MODE DÃ‰MO',0),(31171,866,'jp','ãƒ‡ãƒ¢ãƒ¢ãƒ¼ãƒ‰',0),(31172,866,'pt','MODO DE DEMONSTRAÃ‡ÃƒO',0),(31173,866,'ru','Ð”Ð•ÐœÐž-Ð Ð•Ð–Ð˜Ðœ',0),(31174,866,'es','MODO DEMO',0),(31175,866,'de','DEMO-MODUS',0),(31176,866,'en','DEMO MODE',0),(31177,867,'is','',0),(31178,867,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(31179,867,'pr','Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(31180,867,'tr','Depozito Check',0),(31181,867,'pl','SprawdÅº depozyt',0),(31182,867,'bg','Ð’Ð»Ð¾Ð³ ÑˆÐ°Ñ…',0),(31183,867,'ur','Ø¬Ù…Ø¹ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(31184,867,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(31185,867,'vi','SÃ©c Ä‘áº·t trÆ°á»›c',0),(31186,867,'af','Deposito Tjek',0),(31187,867,'ro','Depozit a verifica',0),(31188,867,'et','Tagatisraha sisse',0),(31189,867,'si','Vloga Äek',0),(31190,867,'ba','Deposit Check',0),(31191,867,'nl','Storting Check',0),(31192,867,'fi','Internet LAN',0),(31193,867,'no','Innskudd sjekk',0),(31194,867,'da','Depositum Check',0),(31195,867,'ko','ìž…ê¸ˆ í™•ì¸',0),(31196,867,'he','×”×¤×™×§×“×•×Ÿ',0),(31197,867,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Ï‡Ï‰',0),(31198,867,'zh','æŒ‰é‡‘æ”¯ç¥¨\r\n',0),(31199,867,'sv','InsÃ¤ttning kontroll',0),(31200,867,'it','Deposito assegno',0),(31201,867,'tl','',0),(31202,867,'th','&#3648;&#3594;&#3655;&#3588;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;',0),(31203,867,'hi','à¤œà¤®à¤¾ à¤šà¥‡à¤•',0),(31204,867,'ms','Deposit cek',0),(31205,867,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(31206,867,'fr','ChÃ¨que de dÃ©pÃ´t',0),(31207,867,'jp','é ?é‡‘å°?åˆ‡æ‰‹',0),(31208,867,'pt','DepÃ³sito de cheque',0),(31209,867,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ Ñ‡ÐµÐº',0),(31210,867,'es','Depositar Cheque',0),(31211,867,'de','Kaution-Check',0),(31212,867,'en','Deposit Check',0),(31213,868,'is','',0),(31214,868,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  â€“ ØªÙˆØ¬Ù‡ : Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† ÙŠÙƒ Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù‡Ù…Ú†Ù†ÙŠÙ† Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù†ÙƒØ±Ø¯Ù†  ØªÙ…Ø§Ù…  Ú†Ùƒ Ù‡Ø§ÙŠ Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡  Ú¯Ù†Ø¬Ø§Ù†Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(31215,868,'pr','Ù¾ÙŠØºØ§Ù… Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù†  Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  â€“ ØªÙˆØ¬Ù‡ : Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† ÙŠÙƒ Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù‡Ù…Ú†Ù†ÙŠÙ† Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù†ÙƒØ±Ø¯Ù†  ØªÙ…Ø§Ù…  Ú†Ùƒ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯  Ú¯Ù†Ø¬Ø§Ù†Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(31216,868,'tr','<b>Not:</b><i>Bir depozito kontrol de UN hesaplar - depozito check-in dahil tÃ¼m bordro denetler geÃ§ersiz</i>',0),(31217,868,'pl','<b>Uwaga:</b><i>Anulowanie depozytu sprawdziÄ‡ rÃ³wnieÅ¼ UN-oblicza wszystkie liÅ›cie pÅ‚ac kontroli zawarte w zastaw sprawdzanie</i>',0),(31218,868,'bg','<b>Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ°:</b><i>ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÑŠÑ‰Ð¾ ÐžÐžÐ Ð˜Ð—Ð§Ð˜Ð¡Ð›Ð¯Ð’Ð Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸, Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð² Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°Ñ‚Ð° Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚</i>',0),(31219,868,'ur','<b>Ù†ÙˆÙ¹:</b><i>Ø§ÛŒÚ© Ú†ÛŒÚ© Ø¬Ù…Ø¹ Ø¨Ú¾ÛŒ Ø§Ù‚ÙˆØ§Ù… Ù…ØªØ­Ø¯Û - Ø¬Ù…Ø¹ Ú†ÛŒÚ© Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ØªÙ…Ø§Ù… Ù¾Û’ Ø±ÙˆÙ„ Ù¾Ú‘ØªØ§Ù„ Ø´Ù…Ø§Ø± Ú©Ø±ØªØ§ ÛÛ’ ÙˆÙˆØ§Ø¯Ø§Ù†Ú¯</i>',0),(31220,868,'sr','<b>ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°:</b> <i>Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¿Ð¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ñ‚Ð°ÐºÐ¾Ñ’Ðµ Ð£Ð-Ð˜Ð—Ð ÐÐ§Ð£ÐÐÐ’Ð ÑÐ²Ðµ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð° ÑƒÐºÑ™ÑƒÑ‡ÐµÐ½ Ñƒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ‡ÐµÐº</i>',0),(31221,868,'vi','<b>NOTE: </b><i>Há»§y SÃ©c thanh toÃ¡n & KhÃ´ng TÃ­nh táº¥t cáº£ cÃ¡c sÃ©c lÆ°Æ¡ng khÃ´ng bao gá»“m trong SÃ©c thanh toÃ¡n nÃ y</i>',0),(31222,868,'af','<b>NOTA: </b><i>Skrapping van \'n Deposito Tjek sal ook al die loonroltjeks ingesluit in die deposito tjek </i> ONBEREKEN laat  ',0),(31223,868,'ro','<b>NotÄƒ:</b><i>Anularea un depozit a verifica, de asemenea, UN-calculeazÄƒ toate salarizare verificÄƒ incluse Ã®n depozit a verifica</i>',0),(31224,868,'et','<b>MÃ¤rkus:</b><i>Voiding tagatisraha kontrollida ka UN-ARVUTAB kogu palgaarvestuse kontrollib tagatisraha kontrollitakse</i>',0),(31225,868,'si','<b>Opomba:</b><i>Razveljavili depozit, preverite tudi ZN-izraÄuna vse izplaÄane plaÄe pregledi vkljuÄeni v vloga Äek</i>',0),(31226,868,'ba','<b>Catatan:</b><i>Membatalkan Deposit memeriksa juga UN-menghitung semua penggajian cek termasuk deposit cek</i>',0),(31227,868,'nl','<b>Opmerking:</b><i>Ongeldig te verklaren een storting controleren ook UN-berekent de loonlijst controleert opgenomen in de controle van de storting</i>',0),(31228,868,'fi','<b>Huomautus:</b><i>Virtsaamisen talletus Tarkista myÃ¶s YK: N laskee kaikki palkanlaskennan tarkistaa talletus tarkastuksesta</i>',0),(31229,868,'no','<b>Merk:</b><i>Kansellere en innskudd Sjekk ogsÃ¥ UN-BEREGNER alle lÃ¸nn sjekker i innskudd sjekken</i>',0),(31230,868,'da','<b>BemÃ¦rk:</b><i>Annullering af et depositum Check ogsÃ¥ UN-beregner alle lÃ¸nningslisten kontrollerer inkluderet i depositum check</i>',0),(31231,868,'ko','<b>ì°¸ê³ :</b><i>Voiding ìž…ê¸ˆ í™•ì¸ ë˜í•œ ìœ ì—” ê³„ì‚° ëª¨ë“  ê¸‰ì—¬ í™•ì¸ ìž…ê¸ˆ í™•ì¸ì— í¬í•¨</i>',0),(31232,868,'he','<b>×”×¢×¨×”:</b><i>×”×¨×§×” ×”×¤×™×§×“×•×Ÿ ×œ×‘×“×•×§ ×’× ×”××• ×-×ž×—×©×‘×ª ××ª ×›×œ ×”×©×›×¨ ×©×œ ×‘×•×“×§ ×›×œ×•×œ ×”×¤×™×§×“×•×Ÿ</i>',0),(31233,868,'el','<b>Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·:</b><i>Î‘ÎºÏ…ÏÏŽÏƒÎµÎ¹ Î¼Î¹Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Î¾Ï„Îµ ÎµÏ€Î¯ÏƒÎ·Ï‚ UN-Î¥Î ÎŸÎ›ÎŸÎ“ÎŠÎ–Î•Î™ ÏŒÎ»ÎµÏ‚ Ï„Î·Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ ÎµÎ»Î­Î³Ï‡ÎµÎ¹ Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·</i>',0),(31234,868,'zh','æ³¨æ„ï¼šæ­£åœ¨ä½œåºŸä¸€å¼ å­˜æ¬¾æ”¯ç¥¨ï¼Œä¹Ÿæ— æ³•è®¡ç®—åŒ…æ‹¬å­˜æ¬¾æ”¯ç¥¨åœ¨å†…çš„æ‰€æœ‰è–ªé‡‘æ”¯ç¥¨\r\n',0),(31235,868,'sv','<b>Obs:</b><i>Annullera en insÃ¤ttning Kontrollera ocksÃ¥ UN-BERÃ„KNAR alla lÃ¶nelistan kontroller ingÃ¥r i kontrollen insÃ¤ttning</i>',0),(31236,868,'it','<b>Nota:</b><i>Minzionale un deposito verifica anche delle Nazioni Unite-calcola tutte le paghe verifica incluso nel controllo di deposito</i>',0),(31237,868,'tl','',0),(31238,868,'th','<b>NOTE: </b><i>Voiding a Deposit Check also UN-CALCULATES all the payroll checks included in the deposit check</i>',0),(31239,868,'hi','<b>à¤¨à¥‹à¤Ÿ:</b><i>à¤à¤• à¤œà¤®à¤¾ à¤•à¥€ à¤œà¤¾à¤‚à¤š à¤­à¥€ voiding à¤¸à¤‚à¤¯à¥à¤•à¥à¤¤ à¤°à¤¾à¤·à¥à¤Ÿà¥à¤° - à¤¸à¤­à¥€ à¤ªà¥‡à¤°à¥‹à¤² à¤šà¥‡à¤• à¤œà¤®à¤¾ à¤•à¥€ à¤œà¤¾à¤‚à¤š à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤¾ à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(31240,868,'ms','<b>Nota:</b><i>Mengganggu semak Deposit juga UN-mengira semua gaji menyemak dalam semak deposit</i>',0),(31241,868,'ar','<b>Ù…Ù„Ø§Ø­Ø¸Ø©:</b><i>Ø¥Ø¨Ø·Ø§Ù„ \"Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø¥ÙŠØ¯Ø§Ø¹\" Ø£ÙŠØ¶Ø§ ÙØ­Øµ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø§Ù„Ù…Ø¯Ø±Ø¬Ø© ÙÙŠ Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø´ÙŠÙƒ Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ù…Ù… Ø§Ù„Ù…ØªØ­Ø¯Ø©</i>',0),(31242,868,'fr','<b>Remarque :</b><i>Annuler un dÃ©pÃ´t vÃ©rifier Ã©galement UN-calcule tous les Ã‰tats de paie vÃ©rifie incluse dans le chÃ¨que de dÃ©pÃ´t</i>',0),(31243,868,'jp','<b>ãƒ¡ãƒ¢: </b><i>é ?é‡‘å°?åˆ‡æ‰‹ã?¨é ?é‡‘å°?åˆ‡æ‰‹ã?«å?«ã?¾ã‚Œã‚‹å…¨ã?¦ã?®æœªè¨ˆç®—çµ¦ä¸Žå°?åˆ‡æ‰‹ã‚’ç ´æ£„ã?™ã‚‹</i>',0),(31244,868,'pt','<b>Nota:</b><i>Anular um depÃ³sito Verifique tambÃ©m UN-calcula toda a folha de pagamento cheques incluÃ­dos a verificaÃ§Ã£o do depÃ³sito</i>',0),(31245,868,'ru','<b>ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ:</b><i>ÐžÑ‚Ð¼ÐµÐ½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ‚Ð°ÐºÐ¶Ðµ ÐžÐžÐ-Ð’Ð«Ð§Ð˜Ð¡Ð›Ð¯Ð•Ð¢ Ð²ÑÐµ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚, Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ Ñ‡ÐµÐº</i>',0),(31246,868,'es','<b>NOTE: </b><i>Anulando un Cheque de DepÃ³sito tambiÃ©n DESCALCULA todos los cheques de depÃ³sito incluido en el cheque de depÃ³sito</i>',0),(31247,868,'de','<b>Hinweis:</b><i>Storno einer Einzahlung Ã¼berprÃ¼fen auch UN-berechnet die Abrechnung Ã¼berprÃ¼ft die Kaution-PrÃ¼fung finden Sie im</i>',0),(31248,868,'en','<b>NOTE: </b><i>Voiding a Deposit Check also UN-CALCULATES all the payroll checks included in the deposit check</i>',0),(31249,869,'is','',0),(31250,869,'dr','Ø´Ø±Ø­ ',0),(31251,869,'pr','Ø´Ø±Ø­ ',0),(31252,869,'tr','AÃ§Ä±klama',0),(31253,869,'pl','Opis',0),(31254,869,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(31255,869,'ur','ØªØµØ±ÛŒØ­',0),(31256,869,'sr','ÐžÐ¿Ð¸Ñ',0),(31257,869,'vi','Diá»…n giáº£i',0),(31258,869,'af','Beskrywing',0),(31259,869,'ro','Descriere',0),(31260,869,'et','Kirjeldus',0),(31261,869,'si','Opis',0),(31262,869,'ba','Deskripsi',0),(31263,869,'nl','Beschrijving',0),(31264,869,'fi','Kuvaus',0),(31265,869,'no','Beskrivelse',0),(31266,869,'da','Beskrivelse',0),(31267,869,'ko','ì„¤ëª…',0),(31268,869,'he','×ª×™××•×¨',0),(31269,869,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(31270,869,'zh','è¯´æ˜Ž\r\n',0),(31271,869,'sv','Beskrivning',0),(31272,869,'it','Descrizione',0),(31273,869,'tl','',0),(31274,869,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(31275,869,'hi','à¤µà¤¿à¤µà¤°à¤£',0),(31276,869,'ms','Description/kawalan',0),(31277,869,'ar','Ø§Ù„Ø¨ÙŠÙ€Ù€Ø§Ù†',0),(31278,869,'fr','Description',0),(31279,869,'jp','èª¬æ˜Ž',0),(31280,869,'pt','DescriÃ§Ã£o',0),(31281,869,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(31282,869,'es','DescripciÃ³n',0),(31283,869,'de','Beschreibung',0),(31284,869,'en','Description',0),(31285,870,'is','',0),(31286,870,'dr','Ø´Ø±Ø­ Ø¨Ø±Ø§ÙŠ ÙÙ‡Ø±Ø³Øª Ù…Ø­ØµÙˆÙ„',0),(31287,870,'pr','Ø´Ø±Ø­ Ø¨Ø±Ø§ÙŠ ÙÙ‡Ø±Ø³Øª Ù…Ø­ØµÙˆÙ„',0),(31288,870,'tr','ÃœrÃ¼n katalog aÃ§Ä±klamasÄ±',0),(31289,870,'pl','Opis katalog produktÃ³w',0),(31290,870,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð² ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³',0),(31291,870,'ur','Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©Û’ Ú©ÛŒÙ¹Ù„Ø§Ú¯ Ú©Û’ Ù„ÛŒÛ’ ØªØµØ±ÛŒØ­',0),(31292,870,'sr','ÐžÐ¿Ð¸Ñ Ð·Ð° ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(31293,870,'vi','MÃ´ táº£ Catalog sáº£n pháº©m',0),(31294,870,'af','Beskrywing vir Produk Katalogus',0),(31295,870,'ro','Descriere pentru Catalog de produse',0),(31296,870,'et','Kirjeldus tootekataloog',0),(31297,870,'si','Opis za katalog izdelkov',0),(31298,870,'ba','Deskripsi untuk Katalog Produk',0),(31299,870,'nl','Beschrijving voor productcatalogus',0),(31300,870,'fi','Kuvaus tuoteluettelo',0),(31301,870,'no','Beskrivelse for Produktkatalog',0),(31302,870,'da','Beskrivelse af produktkataloget',0),(31303,870,'ko','ì œí’ˆ ì¹´íƒˆë¡œê·¸ì— ëŒ€ í•œ ì„¤ëª…',0),(31304,870,'he','×ª×™××•×¨ ×¢×‘×•×¨ ×§×˜×œ×•×’ ×ž×•×¦×¨×™×',0),(31305,870,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î³Î¹Î± Ï„Î¿Î½ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Ï‰Î½',0),(31306,870,'zh','äº§å“ç›®å½•è¯´æ˜Ž\r\n',0),(31307,870,'sv','Beskrivning fÃ¶r produktkatalogen',0),(31308,870,'it','Descrizione per catalogo prodotti',0),(31309,870,'tl','',0),(31310,870,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3586;&#3629;&#3591;&#3649;&#3588;&#3655;&#3605;&#3634;&#3621;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(31311,870,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤•à¥ˆà¤Ÿà¤²à¥‰à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤µà¤°à¤£',0),(31312,870,'ms','Perihalan untuk Katalog produk',0),(31313,870,'ar','ÙˆØµÙ Ù„ÙƒØªØ§Ù„ÙˆØ¬ Ø§Ù„Ù…Ù†ØªØ¬Ø§Øª',0),(31314,870,'fr','Description produit catalogue',0),(31315,870,'jp','è£½å“?ã‚«ã‚¿ãƒ­ã‚°ã?®èª¬æ˜Ž',0),(31316,870,'pt','DescriÃ§Ã£o de catÃ¡logo de produto',0),(31317,870,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð´Ð»Ñ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ†Ð¸Ð¸',0),(31318,870,'es','DescripciÃ³n para CatÃ¡logo de Producto',0),(31319,870,'de','Beschreibung fÃ¼r Produktkatalog',0),(31320,870,'en','Description for Product&nbsp;Catalog',0),(31321,871,'is','',0),(31322,871,'dr','Ø´Ø±Ø­ Ù…Ø­ØªÙˆØ§',0),(31323,871,'pr','Ø´Ø±Ø­ Ù…Ø­ØªÙˆØ§',0),(31324,871,'tr','Ä°Ã§erik aÃ§Ä±klamasÄ±',0),(31325,871,'pl','Opis zawartoÅ›ci',0),(31326,871,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° ÑÑŠÐ´ÑŠÑ€Ð¶Ð°Ð½Ð¸ÐµÑ‚Ð¾',0),(31327,871,'ur','ÙÛØ±Ø³Øª Ù…Ø´Ù…ÙˆÙ„Ø§Øª Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(31328,871,'sr','ÐžÐ¿Ð¸Ñ ÑÐ°Ð´Ñ€Ð¶Ð°Ñ˜Ð°',0),(31329,871,'vi','MÃ´ táº£ ná»™i dung',0),(31330,871,'af','Beskrywing van Inhoud',0),(31331,871,'ro','Descriere a conÅ£inutului',0),(31332,871,'et','Sisu kirjeldus',0),(31333,871,'si','Opis vsebine',0),(31334,871,'ba','Deskripsi isi',0),(31335,871,'nl','Beschrijving van inhoud',0),(31336,871,'fi','Kuvaus sisÃ¤llÃ¶stÃ¤',0),(31337,871,'no','Beskrivelse av innholdet',0),(31338,871,'da','Beskrivelse af indholdet',0),(31339,871,'ko','ë‚´ìš© ì„¤ëª…',0),(31340,871,'he','×ª×™××•×¨ ×©×œ ×ª×•×›×Ÿ',0),(31341,871,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Ï€ÎµÏÎ¹ÎµÏ‡Î¿Î¼Î­Î½Î¿Ï…',0),(31342,871,'zh','å†…å®¹è¯´æ˜Ž\r\n',0),(31343,871,'sv','Beskrivning av innehÃ¥ll',0),(31344,871,'it','Descrizione del contenuto',0),(31345,871,'tl','',0),(31346,871,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3586;&#3629;&#3591;&#3626;&#3634;&#3619;&#3610;&#3633;&#3597;',0),(31347,871,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(31348,871,'ms','Huraian kandungan',0),(31349,871,'ar','ÙˆØµÙ Ù„Ù…Ø­ØªÙˆÙŠØ§Øª',0),(31350,871,'fr','Description du contenu',0),(31351,871,'jp','å†…å®¹ã?®èª¬æ˜Ž',0),(31352,871,'pt','DescriÃ§Ã£o do conteÃºdo',0),(31353,871,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑÐ¾Ð´ÐµÑ€Ð¶Ð¸Ð¼Ð¾Ð³Ð¾',0),(31354,871,'es','DescripciÃ³n de Contenido',0),(31355,871,'de','Beschreibung des Inhalts',0),(31356,871,'en','Description of Contents',0),(31357,872,'is','',0),(31358,872,'dr','Ø´Ø±Ø­ ',0),(31359,872,'pr','Ø´Ø±Ø­ ',0),(31360,872,'tr','AÃ‡IKLAMA',0),(31361,872,'pl','OPIS',0),(31362,872,'bg','ÐžÐŸÐ˜Ð¡ÐÐÐ˜Ð•',0),(31363,872,'ur','ØªØµØ±ÛŒØ­',0),(31364,872,'sr','ÐžÐŸÐ˜Ð¡',0),(31365,872,'vi','DIá»„N GIáº¢I',0),(31366,872,'af','BESKRYWING',0),(31367,872,'ro','DESCRIERE',0),(31368,872,'et','KIRJELDUS',0),(31369,872,'si','OPIS',0),(31370,872,'ba','DESKRIPSI',0),(31371,872,'nl','BESCHRIJVING',0),(31372,872,'fi','KUVAUS',0),(31373,872,'no','BESKRIVELSE',0),(31374,872,'da','BESKRIVELSE',0),(31375,872,'ko','ì„¤ëª…',0),(31376,872,'he','×ª×™××•×¨',0),(31377,872,'el','Î Î•Î¡Î™Î“Î¡Î‘Î¦Î‰',0),(31378,872,'zh','æè¿°\r\n',0),(31379,872,'sv','BESKRIVNING',0),(31380,872,'it','DESCRIZIONE',0),(31381,872,'tl','',0),(31382,872,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(31383,872,'hi','à¤µà¤¿à¤µà¤°à¤£',0),(31384,872,'ms','DESCRIPTION/KAWALAN',0),(31385,872,'ar','Ø§Ù„Ø¨ÙŠÙ€Ù€Ø§Ù†',0),(31386,872,'fr','DESCRIPTION',0),(31387,872,'jp','èª¬æ˜Ž',0),(31388,872,'pt','DESCRIÃ‡ÃƒO',0),(31389,872,'ru','ÐžÐŸÐ˜Ð¡ÐÐÐ˜Ð•',0),(31390,872,'es','DESCRIPCIÃ“N',0),(31391,872,'de','BESCHREIBUNG',0),(31392,872,'en','DESCRIPTION',0),(31393,873,'is','',0),(31394,873,'dr','ÙÙ‚Ø· Ø´Ø±Ø­',0),(31395,873,'pr','ÙÙ‚Ø· Ø´Ø±Ø­',0),(31396,873,'tr','YalnÄ±zca aÃ§Ä±klamalar',0),(31397,873,'pl','Opisy tylko',0),(31398,873,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ ÑÐ°Ð¼Ð¾',0),(31399,873,'ur','ØµØ±Ù ØªØµØ±ÛŒØ­',0),(31400,873,'sr','Ð¡Ð°Ð¼Ð¾ Ð¾Ð¿Ð¸ÑÐµ',0),(31401,873,'vi','Chá»‰ diá»…n giáº£i',0),(31402,873,'af','Slegs Beskrywings',0),(31403,873,'ro','Descrieri numai',0),(31404,873,'et','Ainult kirjeldus',0),(31405,873,'si','Opisi le',0),(31406,873,'ba','Deskripsi hanya',0),(31407,873,'nl','Beschrijvingen alleen',0),(31408,873,'fi','Vain kuvaukset',0),(31409,873,'no','Beskrivelser bare',0),(31410,873,'da','Beskrivelser kun',0),(31411,873,'ko','ì„¤ëª…ë§Œ',0),(31412,873,'he','×ª×™××•×¨×™× ×‘×œ×‘×“',0),(31413,873,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚ Î¼ÏŒÎ½Î¿',0),(31414,873,'zh','åªè¯´æ˜Ž\r\n',0),(31415,873,'sv','Beskrivningar endast',0),(31416,873,'it','Descrizioni solo',0),(31417,873,'tl','',0),(31418,873,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(31419,873,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‡à¤µà¤²',0),(31420,873,'ms','Penerangan sahaja',0),(31421,873,'ar','Ø§Ù„ÙˆØµÙ ÙÙ‚Ø·',0),(31422,873,'fr','Descriptions uniquement',0),(31423,873,'jp','èª¬æ˜Žã?®ã?¿',0),(31424,873,'pt','Somente descriÃ§Ãµes',0),(31425,873,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(31426,873,'es','Descripciones Soloamente',0),(31427,873,'de','Beschreibungen nur',0),(31428,873,'en','Descriptions only',0),(31429,874,'is','',0),(31430,874,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(31431,874,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(31432,874,'tr','Detay',0),(31433,874,'pl','SzczegÃ³Å‚y',0),(31434,874,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(31435,874,'ur','ØªÙØµÛŒÙ„',0),(31436,874,'sr','Ð”ÐµÑ‚Ð°Ñ™',0),(31437,874,'vi','Chi tiáº¿t',0),(31438,874,'af','Detail',0),(31439,874,'ro','Detaliu',0),(31440,874,'et','Detail',0),(31441,874,'si','Podrobnosti',0),(31442,874,'ba','Detail',0),(31443,874,'nl','Detail',0),(31444,874,'fi','Yksityiskohta',0),(31445,874,'no','Detaljer',0),(31446,874,'da','Detaljer',0),(31447,874,'ko','ì„¸ë¶€ ì‚¬í•­',0),(31448,874,'he','×¤×¨×˜',0),(31449,874,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(31450,874,'zh','è¯¦ç»†\r\n',0),(31451,874,'sv','Detalj',0),(31452,874,'it','Dettaglio',0),(31453,874,'tl','',0),(31454,874,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(31455,874,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(31456,874,'ms','Terperinci',0),(31457,874,'ar','Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(31458,874,'fr','DÃ©tail',0),(31459,874,'jp','è©³ç´°',0),(31460,874,'pt','Detalhe',0),(31461,874,'ru','Ð”ÐµÑ‚Ð°Ð»ÑŒ',0),(31462,874,'es','Detalle',0),(31463,874,'de','Detail',0),(31464,874,'en','Detail',0),(31465,875,'is','',0),(31466,875,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(31467,875,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(31468,875,'tr','AyrÄ±ntÄ±lÄ± Ã§alÄ±ÅŸma tÃ¼rÃ¼',0),(31469,875,'pl','SzczegÃ³Å‚Ã³w pracy typu',0),(31470,875,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(31471,875,'ur','ØªÙØµÛŒÙ„ Ú©Û’ Ú©Ø§Ù… Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª',0),(31472,875,'sr','Ð’Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð° Ð´ÐµÑ‚Ð°Ñ™',0),(31473,875,'vi','Chi tiáº¿t loáº¡i cÃ´ng viá»‡c',0),(31474,875,'af','Detail Werk Tipe',0),(31475,875,'ro','Tipul de lucru detaliat',0),(31476,875,'et','Detail tÃ¶Ã¶ tÃ¼Ã¼p',0),(31477,875,'si','Vrsta dela podrobnosti',0),(31478,875,'ba','Jenis pekerjaan detail',0),(31479,875,'nl','Detail werksoort',0),(31480,875,'fi','TyÃ¶n tyyppi',0),(31481,875,'no','Detalj arbeidstype',0),(31482,875,'da','Detaljeret arbejdstype',0),(31483,875,'ko','ì„¸ë¶€ ìž‘ì—… í˜•ì‹',0),(31484,875,'he','×¤×™×¨×•×˜ ×¡×•×’ ×¢×‘×•×“×”',0),(31485,875,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(31486,875,'zh','ç»†èŠ‚å·¥ä½œç±»åž‹\r\n',0),(31487,875,'sv','Detalj arbetstyp',0),(31488,875,'it','Tipo di lavoro di dettaglio',0),(31489,875,'tl','',0),(31490,875,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(31491,875,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤°',0),(31492,875,'ms','Jenis kerja terperinci',0),(31493,875,'ar','ØªÙØ§ØµÙŠÙ„ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(31494,875,'fr','Type de travaux de dÃ©tail',0),(31495,875,'jp','ä»•äº‹å†…å®¹è©³ç´°',0),(31496,875,'pt','Tipo de trabalho de detalhe',0),(31497,875,'ru','Ð¢Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(31498,875,'es','Tipo de Trabajo Detallado',0),(31499,875,'de','Detail-Arbeit-Typ',0),(31500,875,'en','Detail Work Type',0),(31501,876,'is','',0),(31502,876,'dr','( Ù…Ø¬Ù…ÙˆØ¹ÙŠ ) Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(31503,876,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø± Ù…ØªØ¯Ø§ÙˆÙ„ ( ÙƒÙ„ÙŠ ) Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(31504,876,'tr','AyrÄ±ntÄ± Ã§alÄ±ÅŸma tÃ¼rÃ¼ eklemek iÃ§in genel iÅŸ tÃ¼rÃ¼',0),(31505,876,'pl','SzczegÃ³Å‚Ã³w pracy typu dodaÄ‡ typ pracy ogÃ³lne',0),(31506,876,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²ÑÑ‚ Ð·Ð° Ð¾Ð±Ñ‰ Ð²Ð¸Ð´ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(31507,876,'ur','ØªÙØµÛŒÙ„ Ú©Ø§Ù… Ù‚Ø³Ù… Ø¬Ù†Ø±Ù„ Ú©Ø§Ù… Ù‚Ø³Ù… Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(31508,876,'sr','Ð’Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð° Ð´ÐµÑ‚Ð°Ñ™ Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð° Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð° Ð“ÐµÐ½ÐµÑ€Ð°Ð»',0),(31509,876,'vi','ThÃªm Chi tiáº¿t loáº¡i cÃ´ng viá»‡c cho loáº¡i cÃ´ng viá»‡c chung',0),(31510,876,'af','Detail Werk Tipe byvoeg vir Algemene Werk Tipe',0),(31511,876,'ro','Adauga detaliu locul de muncÄƒ tip pentru tipul de muncÄƒ General',0),(31512,876,'et','Detail TÃ¶Ã¶liigi lisada Ã¼ldine tÃ¶Ã¶ tÃ¼Ã¼p',0),(31513,876,'si','Vrsta dela podrobno dodati za vrsto dela sploÅ¡ne',0),(31514,876,'ba','Jenis pekerjaan detail menambahkan untuk jenis pekerjaan umum',0),(31515,876,'nl','Detail werksoort toevoegen voor algemene werksoort',0),(31516,876,'fi','TyÃ¶n tyyppi lisÃ¤Ã¤ yleensÃ¤ tyÃ¶n tyyppi',0),(31517,876,'no','Detalj arbeidstype legge for General arbeidstypen',0),(31518,876,'da','Detaljeret arbejdstype tilfÃ¸je for General arbejdstype',0),(31519,876,'ko','ì¼ë°˜ ìž‘ì—… í˜•ì‹ì— ëŒ€ í•œ ì„¸ë¶€ ìž‘ì—… ìœ í˜• ì¶”ê°€',0),(31520,876,'he','×¤×™×¨×•×˜ ×¡×•×’ ×¢×‘×•×“×” ×œ×”×•×¡×™×£ ×¢×‘×•×¨ ×¡×•×’ ×¢×‘×•×“×” ×›×œ×œ×™',0),(31521,876,'el','Î¤ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î³Î¹Î± Î“ÎµÎ½Î¹ÎºÏŒÏ‚ Î¤ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(31522,876,'zh','å…·ä½“å·¥ä½œä¸­é”®å…¥æ·»åŠ ä¸€èˆ¬å·¥ä½œç±»åˆ«\r\n',0),(31523,876,'sv','Detalj arbetstyp lÃ¤gga fÃ¶r allmÃ¤nt arbete typ',0),(31524,876,'it','Tipo di lavoro di dettaglio aggiungere per tipo di lavoro generale',0),(31525,876,'tl','',0),(31526,876,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3648;&#3614;&#3639;&#3656;&#3629;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3',0),(31527,876,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤',0),(31528,876,'ms','Jenis kerja terperinci Tambah bagi jenis kerja am',0),(31529,876,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ ØªÙØ§ØµÙŠÙ„ Ø¹Ù† Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù…Ø©',0),(31530,876,'fr','Type de travaux de dÃ©tail ajouter pour le Type de travail gÃ©nÃ©ral',0),(31531,876,'jp','ä¸€èˆ¬ä»•äº‹å†…å®¹ã?«ä»•äº‹å†…å®¹è©³ç´°ã‚’è¿½åŠ ',0),(31532,876,'pt','Adicionar o tipo de trabalho de detalhe para o tipo de trabalho geral',0),(31533,876,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´ÐµÑ‚Ð°Ð»ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ñ‚Ð¸Ð¿Ð° Ð´Ð»Ñ Ð¾Ð±Ñ‰ÐµÐ³Ð¾ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‡ÐµÐ³Ð¾',0),(31534,876,'es','Tipo de Trabajo Detallado Agregar para Tipo de Trabajo General',0),(31535,876,'de','Detail-Arbeit-Typ fÃ¼r General Arbeitstyp hinzufÃ¼gen',0),(31536,876,'en','Detail Work Type Add for General Work Type',0),(31537,877,'is','',0),(31538,877,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(31539,877,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(31540,877,'tr','AyrÄ±ntÄ±lÄ± Ã§alÄ±ÅŸma tÃ¼rÃ¼ baÅŸarÄ±yla eklendi.',0),(31541,877,'pl','SzczegÃ³Å‚Ã³w pracy typu dodane pomyÅ›lnie.',0),(31542,877,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(31543,877,'ur','ØªÙØµÛŒÙ„ Ú©Ø§Ù… Ù‚Ø³Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(31544,877,'sr','Ð”ÐµÑ‚Ð°Ñ™ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð°.',0),(31545,877,'vi','ThÃªm Chi tiáº¿t loáº¡i cÃ´ng viá»‡c thÃ nh cÃ´ng',0),(31546,877,'af','Gedetailleerde Werktipe suksesvol bygevoeg.',0),(31547,877,'ro','Detaliu de lucru tip adÄƒugat cu succes.',0),(31548,877,'et','Detail TÃ¶Ã¶liigi edukalt lisatud.',0),(31549,877,'si','Podrobnosti delo vrsta uspeÅ¡no dodana.',0),(31550,877,'ba','Jenis pekerjaan detail ditambahkan berhasil.',0),(31551,877,'nl','Detail werksoort met succes toegevoegd.',0),(31552,877,'fi','TyÃ¶n tyypin lisÃ¤Ã¤minen onnistui.',0),(31553,877,'no','Detalj arbeidstype lagt.',0),(31554,877,'da','Detaljeret arbejdstype tilfÃ¸jet.',0),(31555,877,'ko','ì„¸ë¶€ ìž‘ì—… í˜•ì‹ì„ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(31556,877,'he','×¤×™×¨×•×˜ ×¡×•×’ ×¢×‘×•×“×” × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(31557,877,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(31558,877,'zh','ç»†èŠ‚å·¥ä½œç±»åž‹æ·»åŠ æˆåŠŸã€‚\r\n',0),(31559,877,'sv','Detalj arbetstyp lagts.',0),(31560,877,'it','Tipo di lavoro di dettaglio aggiunto con successo.',0),(31561,877,'tl','',0),(31562,877,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(31563,877,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(31564,877,'ms','Jenis kerja terperinci berjaya menambah.',0),(31565,877,'ar','ØªÙØ§ØµÙŠÙ„ \"Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„\" Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(31566,877,'fr','Type de travaux de dÃ©tail ajoutÃ© avec succÃ¨s.',0),(31567,877,'jp','ä»•äº‹å†…å®¹è©³ç´°ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(31568,877,'pt','Tipo de trabalho de detalhe adicionado com Ãªxito.',0),(31569,877,'ru','Ð¢Ð¸Ð¿ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°.',0),(31570,877,'es','Tipo de Trabajo Detallado agregado exitosamente',0),(31571,877,'de','Detail-Arbeit-Typ wurde erfolgreich hinzugefÃ¼gt.',0),(31572,877,'en','Detail Work Type added successfully.',0),(31573,878,'is','',0),(31574,878,'dr','Ø­Ø°Ù  Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(31575,878,'pr','Ø­Ø°Ù  Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(31576,878,'tr','AyrÄ±ntÄ±lÄ± Ã§alÄ±ÅŸma tÃ¼rÃ¼ baÅŸarÄ±yla silindi',0),(31577,878,'pl','SzczegÃ³Å‚Ã³w pracy typu przesâ”‚anie',0),(31578,878,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(31579,878,'ur','ØªÙØµÛŒÙ„ Ú©Ø§Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©ÛŒ Ù‚Ø³Ù…',0),(31580,878,'sr','Ð’Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð° Ð´ÐµÑ‚Ð°Ñ™ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(31581,878,'vi','XÃ³a Chi tiáº¿t loáº¡i cÃ´ng viá»‡c thÃ nh cÃ´ng',0),(31582,878,'af','Gedetailleerde Werkstipe suksesvol geskrap',0),(31583,878,'ro','Detaliu de lucru tip eliminÄƒ cu succes',0),(31584,878,'et','Detail TÃ¶Ã¶liigi edukalt kustutatud',0),(31585,878,'si','Podrobnosti delo vrsta uspeÅ¡no izbrisana',0),(31586,878,'ba','Jenis pekerjaan detail dihapus berhasil',0),(31587,878,'nl','Detail werksoort met succes verwijderd',0),(31588,878,'fi','TyÃ¶n tyyppi poistettu',0),(31589,878,'no','Detalj arbeidstype slettet',0),(31590,878,'da','Detaljeret arbejdstype slettet',0),(31591,878,'ko','ì„¸ë¶€ ìž‘ì—… í˜•ì‹ì„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(31592,878,'he','×¤×™×¨×•×˜ ×¡×•×’ ×¢×‘×•×“×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(31593,878,'el','Î¤ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(31594,878,'zh','ç»†èŠ‚å·¥ä½œç±»åž‹åˆ é™¤æˆåŠŸ\r\n',0),(31595,878,'sv','Detalj arbetstyp raderades',0),(31596,878,'it','Tipo di lavoro di dettaglio eliminato con successo',0),(31597,878,'tl','',0),(31598,878,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(31599,878,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤¾à¤°à¥à¤¯ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤ˆ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(31600,878,'ms','Jenis kerja terperinci dihapuskan dengan jayanya',0),(31601,878,'ar','ØªÙØ§ØµÙŠÙ„ \"Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„\" Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(31602,878,'fr','Type de travaux de dÃ©tail supprimÃ© avec succÃ¨s',0),(31603,878,'jp','ä»•äº‹å†…å®¹è©³ç´°ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(31604,878,'pt','Tipo de trabalho de detalhe apagado com sucesso',0),(31605,878,'ru','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(31606,878,'es','Tipo de Trabajo Detallado eliminado exitosamente',0),(31607,878,'de','Detail-Arbeitstyp erfolgreich gelÃ¶scht',0),(31608,878,'en','Detail Work Type deleted successfully',0),(31609,879,'is','',0),(31610,879,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(31611,879,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(31612,879,'tr','AyrÄ±ntÄ±lÄ± Ã§alÄ±ÅŸma tÃ¼rÃ¼ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(31613,879,'pl','SzczegÃ³Å‚Ã³w pracy typu pomyÅ›lnie zaktualizowana',0),(31614,879,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(31615,879,'ur','ØªÙØµÛŒÙ„ Ú©Ø§Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(31616,879,'sr','Ð’Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð° Ð´ÐµÑ‚Ð°Ñ™ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(31617,879,'vi','Chi Tiáº¿t Loáº¡i CÃ´ng Viá»‡c Cáº­p Nháº­t thÃ nh cÃ´ng',0),(31618,879,'af','Gedetailleerde Werktipe suksesvol opdateer',0),(31619,879,'ro','Detaliu de lucru tip actualizat cu succes',0),(31620,879,'et','Detail tÃ¶Ã¶ tÃ¼Ã¼p vÃ¤rskendamine Ãµnnestus',0),(31621,879,'si','Podrobnosti delo vrsta uspeÅ¡no posodobljena',0),(31622,879,'ba','Jenis pekerjaan detail yang berhasil',0),(31623,879,'nl','Detail werksoort bijgewerkt',0),(31624,879,'fi','TyÃ¶n tyyppi pÃ¤ivitetty',0),(31625,879,'no','Detalj arbeidstype oppdatert',0),(31626,879,'da','Detaljeret arbejdstype opdateret',0),(31627,879,'ko','ì„¸ë¶€ ìž‘ì—… í˜•ì‹ì„ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(31628,879,'he','×¤×™×¨×•×˜ ×¡×•×’ ×¢×‘×•×“×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(31629,879,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(31630,879,'zh','ç»†èŠ‚å·¥ä½œç±»åž‹æ›´æ–°æˆåŠŸ\r\n',0),(31631,879,'sv','Detalj arbetstyp uppdaterats',0),(31632,879,'it','Tipo di lavoro di dettaglio aggiornato con successo',0),(31633,879,'tl','',0),(31634,879,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(31635,879,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤¾à¤°à¥à¤¯ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(31636,879,'ms','Terperinci jenis kerja yang berjaya dikemas kini',0),(31637,879,'ar','ØªÙØ§ØµÙŠÙ„ \"Ù†ÙˆØ¹ Ø¹Ù…Ù„\" ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(31638,879,'fr','Type de travaux de dÃ©tail mis Ã  jour avec succÃ¨s',0),(31639,879,'jp','ä»•äº‹å†…å®¹è©³ç´°ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(31640,879,'pt','Tipo de trabalho de detalhe atualizado com sucesso',0),(31641,879,'ru','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(31642,879,'es','Tipo de Trabajo Detallado actualizado exitosamente',0),(31643,879,'de','Detail-Arbeitstyp erfolgreich aktualisiert',0),(31644,879,'en','Detail Work Type updated successfully',0),(31645,880,'is','',0),(31646,880,'dr','Ù†ØªÙˆØ§Ù†Ø³Øª ÙŠÙƒ Ø´Ù†Ø§Ø³Ù‡ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¬Ø¯ÙŠØ¯ Ø¨Ù‡ Ø¯Ø³Øª Ø¢ÙˆØ±Ø¯ ',0),(31647,880,'pr','Ù†ØªÙˆØ§Ù†Ø³Øª ÙŠÙƒ Ø´Ù†Ø§Ø³Ù‡ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¬Ø¯ÙŠØ¯ Ø¨Ù‡ Ø¯Ø³Øª Ø¢ÙˆØ±Ø¯ ',0),(31648,880,'tr','Yeni bir voucherid almak.',0),(31649,880,'pl','Nie zrobiÅ‚ dostaÄ‡ nowy voucherid.',0),(31650,880,'bg','ÐÐµ ÑÐµ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸ Ð½Ð¾Ð² voucherid.',0),(31651,880,'ur','Ø§ÛŒÚ© Ù†Ø¦Û’ ÙˆÙˆÙˆÚ†Ø±Ø§Ø¯ Ù†Û Ú©Ø±Ø³Ú©Ø§ Û”',0),(31652,880,'sr','ÐÐ¸Ñ˜Ðµ Ð´Ð¾Ð±Ð¸Ð¾ Ð½Ð¾Ð²Ñƒ Ð²Ð¾ÑƒÑ†Ñ…ÐµÑ€Ð¸Ð´.',0),(31653,880,'vi','KhÃ´ng cÃ³ ID phiáº¿u má»›i',0),(31654,880,'af','Het nie \'n nuwe Bewysstuk ID gevind nie.',0),(31655,880,'ro','Nu a lua un voucherid nou.',0),(31656,880,'et','Sain uue voucherid.',0),(31657,880,'si','Nisem dobil novo voucherid.',0),(31658,880,'ba','Tidak mendapatkan voucherid baru.',0),(31659,880,'nl','Did niet worden naar een nieuwe voucherid.',0),(31660,880,'fi','Saaneet uusia voucherid.',0),(31661,880,'no','Ikke fikk en ny voucherid.',0),(31662,880,'da','Fik ikke en ny voucherid.',0),(31663,880,'ko','ìƒˆë¡œìš´ voucheridë¥¼ ì–»ì§€ ì•Šì•˜ë‹¤.',0),(31664,880,'he','×œ× ×§×™×‘×œ×ª×™ voucherid ×”×—×“×©.',0),(31665,880,'el','Î”ÎµÎ½ Ï€Î®ÏÎµ Î­Î½Î± Î½Î­Î¿ voucherid.',0),(31666,880,'zh','æ²¡æœ‰å¾—åˆ°ä¸€ä¸ªæ–°çš„ç¤¼åˆ¸ç¼–å·\r\n',0),(31667,880,'sv','Fick inte en ny voucherid.',0),(31668,880,'it','Non ha ottenuto un nuovo voucherid.',0),(31669,880,'tl','',0),(31670,880,'th','&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3651;&#3627;&#3617;&#3656;',0),(31671,880,'hi','à¤à¤• à¤¨à¤ˆ voucherid à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤¥à¤¾à¥¤',0),(31672,880,'ms','Tidak mendapat voucherid yang baru.',0),(31673,880,'ar','Ù„Ù… ÙŠØ­ØµÙ„ ÙÙˆØªØ´ÙŠØ±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯Ø©.',0),(31674,880,'fr','N\'a pas obtenu un nouveau voucherid.',0),(31675,880,'jp','æ–°ã?—ã?„ä¼?ç¥¨IDã?Œå?–å¾—ã?§ã??ã?¾ã?›ã‚“',0),(31676,880,'pt','NÃ£o conseguiu um novo voucherid.',0),(31677,880,'ru','ÐÐµ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ voucherid.',0),(31678,880,'es','No se Obtuvo un Nuevo Vale ID',0),(31679,880,'de','Nicht bekommen eine neue Voucherid.',0),(31680,880,'en','Did not get a new voucherid.',0),(31681,881,'is','',0),(31682,881,'dr','( Ù‚Ø§Ù„Ø¨ ',0),(31683,881,'pr','Ù…Ø±Ø¯Ù† ( Ù‚Ø§Ù„Ø¨ ',0),(31684,881,'tr','Die',0),(31685,881,'pl','UmrzeÄ‡',0),(31686,881,'bg','Die',0),(31687,881,'ur','Ù…Ø±Ù†Ø§',0),(31688,881,'sr','Ð£Ð¼Ñ€Ð¸',0),(31689,881,'vi','Cháº¿t',0),(31690,881,'af','Sterf',0),(31691,881,'ro','Mor',0),(31692,881,'et','Surra',0),(31693,881,'si','Die',0),(31694,881,'ba','Mati',0),(31695,881,'nl','Sterven',0),(31696,881,'fi','Die',0),(31697,881,'no','DÃ¸',0),(31698,881,'da','Die',0),(31699,881,'ko','ë‹¤ì´',0),(31700,881,'he','×œ×ž×•×ª',0),(31701,881,'el','Î ÎµÎ¸Î±Î¯Î½Î¿Ï…Î½',0),(31702,881,'zh','æ­»\r\n',0),(31703,881,'sv','DÃ¶',0),(31704,881,'it','Morire',0),(31705,881,'tl','',0),(31706,881,'th','&#3605;&#3634;&#3618;',0),(31707,881,'hi','à¤®à¤°à¥‹',0),(31708,881,'ms','Mati',0),(31709,881,'ar','ÙŠÙ…ÙˆØª',0),(31710,881,'fr','Die',0),(31711,881,'jp','å°?ç«‹æ–¹ä½“',0),(31712,881,'pt','Morrer',0),(31713,881,'ru','Ð£Ð¼ÐµÑ€ÐµÑ‚ÑŒ',0),(31714,881,'es','Estampa',0),(31715,881,'de','Sterben',0),(31716,881,'en','Die',0),(31717,882,'is','',0),(31718,882,'dr','ØªÙØ§ÙˆØª ',0),(31719,882,'pr','ØªÙØ§ÙˆØª ',0),(31720,882,'tr','Fark',0),(31721,882,'pl','RÃ³Å¼nica',0),(31722,882,'bg','Ð Ð°Ð·Ð»Ð¸ÐºÐ°',0),(31723,882,'ur','ÙØ±Ù‚',0),(31724,882,'sr','Ð Ð°Ð·Ð»Ð¸ÐºÐ°',0),(31725,882,'vi','KhÃ¡c nhau',0),(31726,882,'af','Verskil',0),(31727,882,'ro','DiferenÅ£a',0),(31728,882,'et','Erinevus',0),(31729,882,'si','Razlika',0),(31730,882,'ba','Perbedaan',0),(31731,882,'nl','Verschil',0),(31732,882,'fi','Ero',0),(31733,882,'no','Forskjellen',0),(31734,882,'da','Forskellen',0),(31735,882,'ko','ì°¨ì´',0),(31736,882,'he','×”×‘×“×œ',0),(31737,882,'el','Î”Î¹Î±Ï†Î¿ÏÎ¬',0),(31738,882,'zh','å·®å¼‚\r\n',0),(31739,882,'sv','Skillnaden',0),(31740,882,'it','Differenza',0),(31741,882,'tl','',0),(31742,882,'th','&#3649;&#3605;&#3585;&#3605;&#3656;&#3634;&#3591;',0),(31743,882,'hi','à¤…à¤‚à¤¤à¤°',0),(31744,882,'ms','Perbezaan',0),(31745,882,'ar','Ø§Ù„ÙØ±Ù‚',0),(31746,882,'fr','DiffÃ©rence',0),(31747,882,'jp','å·®',0),(31748,882,'pt','DiferenÃ§a',0),(31749,882,'ru','Ð Ð°Ð·Ð½Ð¸Ñ†Ð°',0),(31750,882,'es','Diferencia',0),(31751,882,'de','Unterschied',0),(31752,882,'en','Difference',0),(31753,883,'is','',0),(31754,883,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ù…ØªÙØ§ÙˆØª ',0),(31755,883,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ù…ØªÙØ§ÙˆØª ',0),(31756,883,'tr','FarklÄ± mÃ¼ÅŸteri',0),(31757,883,'pl','Inny klient',0),(31758,883,'bg','Ð”Ñ€ÑƒÐ³ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(31759,883,'ur','Ù…Ø®ØªÙ„Ù Ú¯Ø§ÛÚ©',0),(31760,883,'sr','Ð”Ñ€ÑƒÐ³Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð°',0),(31761,883,'vi','KhÃ¡ch hÃ ng khÃ¡c',0),(31762,883,'af','Verskillende KliÃ«nt/Klant',0),(31763,883,'ro','Diferite client',0),(31764,883,'et','Teine klient',0),(31765,883,'si','Drugemu kupcu',0),(31766,883,'ba','Pelanggan yang berbeda',0),(31767,883,'nl','Andere klant',0),(31768,883,'fi','Asiakkaalle',0),(31769,883,'no','Annen kunde',0),(31770,883,'da','Anden kunde',0),(31771,883,'ko','ë‹¤ë¥¸ ê³ ê°',0),(31772,883,'he','×œ×§×•×— ×©×•× ×”',0),(31773,883,'el','Î†Î»Î»Î¿Ï‚ Ï€ÎµÎ»Î¬Ï„Î·Ï‚',0),(31774,883,'zh','ä¸åŒçš„å®¢æˆ·\r\n',0),(31775,883,'sv','Annan kund',0),(31776,883,'it','Cliente diverso',0),(31777,883,'tl','',0),(31778,883,'th','&#3649;&#3605;&#3585;&#3605;&#3656;&#3634;&#3591;&#3585;&#3633;&#3609;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(31779,883,'hi','à¤µà¤¿à¤­à¤¿à¤¨à¥à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(31780,883,'ms','Pelanggan yang berbeza',0),(31781,883,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ù…Ø®ØªÙ„ÙØ©',0),(31782,883,'fr','Client diffÃ©rent',0),(31783,883,'jp','åˆ¥ã?®é¡§å®¢',0),(31784,883,'pt','Diferente do cliente',0),(31785,883,'ru','Ð”Ñ€ÑƒÐ³Ð¾Ð¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(31786,883,'es','Cliente Diferente',0),(31787,883,'de','Verschiedene Kunden',0),(31788,883,'en','Different Customer',0),(31789,884,'is','',0),(31790,884,'dr','(Ø§Ø±Ø³Ø§Ù„)  Ù…ØªÙØ§ÙˆØª ',0),(31791,884,'pr','Ø­Ù…Ù„ (Ø§Ø±Ø³Ø§Ù„)  Ù…ØªÙØ§ÙˆØª ',0),(31792,884,'tr','FarklÄ± gemi',0),(31793,884,'pl','Inny statek',0),(31794,884,'bg','Ð Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð¸ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(31795,884,'ur','Ù…Ø®ØªÙ„Ù Ú©Ø´ØªÛŒ Ù¾Ø±',0),(31796,884,'sr','Ð”Ð° Ð´Ñ€ÑƒÐ³Ð¸ Ð±Ñ€Ð¾Ð´.',0),(31797,884,'vi','Äá»‹a chá»‰ váº­n chuyá»ƒn khÃ¡c',0),(31798,884,'af','Ander Versend Aan',0),(31799,884,'ro','Nave diferite la',0),(31800,884,'et','Erinev tarneaadress',0),(31801,884,'si','RazliÄne ladje',0),(31802,884,'ba','Kapal yang berbeda untuk',0),(31803,884,'nl','Verschillende schip',0),(31804,884,'fi','Eri aluksen',0),(31805,884,'no','Forskjellige skip',0),(31806,884,'da','Andet skib til',0),(31807,884,'ko','ë‹¤ë¥¸ ë°°ë¥¼',0),(31808,884,'he','×©×•× ×” ×œ×ž×©×œ×•×—',0),(31809,884,'el','Î”Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÎ­Ï‚ Ï€Î»Î¿Î¯Î¿Ï… Î³Î¹Î± Î½Î±',0),(31810,884,'zh','ä¸åŒçš„èˆ¹è¦\r\n',0),(31811,884,'sv','Olika fartyg',0),(31812,884,'it','Nave differente a',0),(31813,884,'tl','',0),(31814,884,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3607;&#3637;&#3656;&#3605;&#3656;&#3634;&#3591;&#3585;&#3633;&#3609;',0),(31815,884,'hi','à¤µà¤¿à¤­à¤¿à¤¨à¥à¤¨ à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(31816,884,'ms','Kapal yang berbeza untuk',0),(31817,884,'ar','Ø³ÙÙŠÙ†Ø© Ù…Ø®ØªÙ„ÙØ© Ø¥Ù„Ù‰',0),(31818,884,'fr','Autre navire Ã ',0),(31819,884,'jp','åˆ¥ã?®é…?é€?å…ˆ',0),(31820,884,'pt','Nave diferente para',0),(31821,884,'ru','Ð”Ñ€ÑƒÐ³Ð¾Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(31822,884,'es','Diferente Enviar a',0),(31823,884,'de','Anderes Schiff zu',0),(31824,884,'en','Different Ship To',0),(31825,885,'is','',0),(31826,885,'dr','Ø¯ÙŠØ¬ÙŠØªØ§Ù„',0),(31827,885,'pr','Ø¯ÙŠØ¬ÙŠØªØ§Ù„',0),(31828,885,'tr','Dijital',0),(31829,885,'pl','Cyfrowy',0),(31830,885,'bg','Ð¦Ð¸Ñ„Ñ€Ð¾Ð²',0),(31831,885,'ur','Ø¹Ø¯Ø¯ÛŒ',0),(31832,885,'sr','Ð”Ð¸Ð³Ð¸Ñ‚Ð°Ð»Ð½Ð¸',0),(31833,885,'vi','Ká»¹ thuáº­t sá»‘',0),(31834,885,'af','Digitaal',0),(31835,885,'ro','Digital',0),(31836,885,'et','Digitaalne',0),(31837,885,'si','Digitalni',0),(31838,885,'ba','Digital',0),(31839,885,'nl','Digitale',0),(31840,885,'fi','Digitaalinen',0),(31841,885,'no','Digital',0),(31842,885,'da','Digital',0),(31843,885,'ko','ë””ì§€í„¸',0),(31844,885,'he','×“×™×’×™×˜×œ×™',0),(31845,885,'el','Î¨Î·Ï†Î¹Î±ÎºÎ®',0),(31846,885,'zh','æ•°å­—\r\n',0),(31847,885,'sv','Digital',0),(31848,885,'it','Digitale',0),(31849,885,'tl','',0),(31850,885,'th','&#3604;&#3636;&#3592;&#3636;&#3605;&#3633;&#3621;',0),(31851,885,'hi','à¤¡à¤¿à¤œà¤¿à¤Ÿà¤²',0),(31852,885,'ms','Digital',0),(31853,885,'ar','Ø§Ù„Ø±Ù‚Ù…ÙŠØ©',0),(31854,885,'fr','Digital',0),(31855,885,'jp','ãƒ‡ã‚¸ã‚¿ãƒ«',0),(31856,885,'pt','Digital',0),(31857,885,'ru','Ð¦Ð¸Ñ„Ñ€Ð¾Ð²Ð¾Ð¹',0),(31858,885,'es','Digital',0),(31859,885,'de','Digital',0),(31860,885,'en','Digital',0),(31861,886,'is','',0),(31862,886,'dr','ØªØ®ÙÙŠÙ ',0),(31863,886,'pr','ØªØ®ÙÙŠÙ ',0),(31864,886,'tr','Ä°ndirim',0),(31865,886,'pl','ZniÅ¼ki',0),(31866,886,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(31867,886,'ur','Ø±Ø¹Ø§ÛŒØª',0),(31868,886,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚',0),(31869,886,'vi','Chiáº¿t kháº¥u',0),(31870,886,'af','Korting',0),(31871,886,'ro','Reducere',0),(31872,886,'et','Allahindlus',0),(31873,886,'si','Popust',0),(31874,886,'ba','Diskon',0),(31875,886,'nl','Korting',0),(31876,886,'fi','Alennus',0),(31877,886,'no','Rabatt',0),(31878,886,'da','Rabat',0),(31879,886,'ko','í• ì¸',0),(31880,886,'he','×”× ×—×”',0),(31881,886,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ·',0),(31882,886,'zh','æŠ˜æ‰£\r\n',0),(31883,886,'sv','Rabatt',0),(31884,886,'it','Sconto',0),(31885,886,'tl','',0),(31886,886,'th','&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(31887,886,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ',0),(31888,886,'ms','Diskaun',0),(31889,886,'ar','Ø§Ù„ØªØ®ÙÙŠØµ',0),(31890,886,'fr','Discount',0),(31891,886,'jp','ãƒ‡ã‚£ã‚¹ã‚«ã‚¦ãƒ³ãƒˆ',0),(31892,886,'pt','Desconto',0),(31893,886,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ°',0),(31894,886,'es','Descuento',0),(31895,886,'de','Rabatt',0),(31896,886,'en','Discount',0),(31897,887,'is','',0),(31898,887,'dr','Ø­Ø³Ø§Ø¨ ØªØ®ÙÙŠÙ ',0),(31899,887,'pr','Ø­Ø³Ø§Ø¨ ØªØ®ÙÙŠÙ ',0),(31900,887,'tr','Ä°skonto hesabÄ±',0),(31901,887,'pl','Rabat konta',0),(31902,887,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(31903,887,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(31904,887,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(31905,887,'vi','TK Chiáº¿t Kháº¥u',0),(31906,887,'af','Korting Rekening',0),(31907,887,'ro','Reducere cont',0),(31908,887,'et','Allahindluse konto',0),(31909,887,'si','Popust raÄuna',0),(31910,887,'ba','DISKON TERBAIK untuk Account',0),(31911,887,'nl','Goedkope Account',0),(31912,887,'fi','Alennus huomioon',0),(31913,887,'no','Rabatt konto',0),(31914,887,'da','Discount konto',0),(31915,887,'ko','ê³„ì • í• ì¸',0),(31916,887,'he','×”× ×—×” ×‘×—×©×‘×•×Ÿ',0),(31917,887,'el','Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(31918,887,'zh','æŠ˜æ‰£å¸æˆ·\r\n',0),(31919,887,'sv','Rabatt konto',0),(31920,887,'it','Sconto Account',0),(31921,887,'tl','',0),(31922,887,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(31923,887,'hi','à¤–à¤¾à¤¤à¤¾ à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ',0),(31924,887,'ms','Diskaun akaun',0),(31925,887,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„ØªØ®ÙÙŠØ¶Ø§Øª',0),(31926,887,'fr','Compte d\'escompte',0),(31927,887,'jp','å‰²å¼•å‹˜å®š',0),(31928,887,'pt','Desconto conta',0),(31929,887,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° ÑÑ‡ÐµÑ‚Ð°',0),(31930,887,'es','Cuenta de Descuento',0),(31931,887,'de','Discount-Konto',0),(31932,887,'en','Discount Account',0),(31933,888,'is','',0),(31934,888,'dr','(ØªÙ†Ø²ÙŠÙ„ ) Ø±Ø§ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù…ÙˆØ¹Ø¯ Ø«Ø¨Øª ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(31935,888,'pr','Ø´Ù…Ø§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® ØªØ®ÙÙŠÙ (ØªÙ†Ø²ÙŠÙ„ ) Ø±Ø§ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø«Ø¨Øª ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(31936,888,'tr','Bir indirim tarihten sonra girdiÄŸiniz iÃ§in son tarih.',0),(31937,888,'pl','PodaÅ‚eÅ› Data rabatu po do wymagalnoÅ›ci!',0),(31938,888,'bg','Ð’Ð¸Ðµ ÑÑ‚Ðµ Ð²ÑŠÐ²ÐµÐ»Ð¸ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð´Ð°Ñ‚Ð° ÑÐ»ÐµÐ´ Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶!',0),(31939,888,'ur','ØªÙ… Ú©Ø³ÛŒ Ø±Ø¹Ø§ÛŒØª Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Û’ Ø¨Ø¹Ø¯ Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ ØªØ§Ø±ÛŒØ®!',0),(31940,888,'sr','Ð£Ð½ÐµÑÐµÑ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ ÐºÐ°ÑÐ°ÑÐºÐ¾Ð½Ñ‚Ð° Ð¿Ð¾ÑÐ»Ðµ Ð´Ð° Ñ˜Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº!',0),(31941,888,'vi','Báº¡n Ä‘Ã£ nháº­p 1 ngÃ y chiáº¿t kháº¥u sau ngÃ y Ä‘áº¿n háº¡n!',0),(31942,888,'af','U het \'n kortingsdatum ingevoer na tot verskuldigde datum!',0),(31943,888,'ro','AÅ£i introdus o datÄƒ de reducere dupÄƒ data scadentÄƒ la!',0),(31944,888,'et','Sisestatud skonto kuupÃ¤ev pÃ¤rast-tÃ¤htaeg!',0),(31945,888,'si','Vnesli ste datum kasaskonta po do rok!',0),(31946,888,'ba','Anda telah memasukkan tanggal diskon setelah sampai jatuh tempo!',0),(31947,888,'nl','U hebt een kortingsvervaldatum na tot vervaldatum!',0),(31948,888,'fi','Olet syÃ¶ttÃ¤nyt alennuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n jÃ¤lkeen jotta erÃ¤pÃ¤ivÃ¤!',0),(31949,888,'no','Du har angitt en rabattdatoen etter til forfallsdato!',0),(31950,888,'da','Du har indtastet en rabatdatoen efter til forfaldsdatoen!',0),(31951,888,'ko','í›„ í• ì¸ ë‚ ì§œ ìž…ë ¥ì„ ê¸°í•œ!',0),(31952,888,'he','×”×–× ×ª ×ª××¨×™×š ×”× ×—×” ×œ××—×¨ ×ª××¨×™×š ×”×™×¢×“ ×œ!',0),(31953,888,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚ Î¼ÎµÏ„Î¬ ÏƒÎµ Î—Î¼/Î½Î¯Î±!',0),(31954,888,'zh','æ‚¨å·²è¾“å…¥åˆ°æˆªæ­¢æ—¥æœŸåŽçš„æŠ˜æ‰£çŽ‡ï¼\r\n',0),(31955,888,'sv','Du har angett en rabattdatum efter till fÃ¶rfallodatum!',0),(31956,888,'it','Hai inserito una data di sconto dopo la data di scadenza!',0),(31957,888,'tl','',0),(31958,888,'th','&#3588;&#3640;&#3603;&#3652;&#3604;&#3657;&#3651;&#3626;&#3656;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3651;&#3627;&#3657;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3627;&#3621;&#3633;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3',0),(31959,888,'hi','à¤¤à¥à¤® à¤à¤• à¤›à¥‚à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•!',0),(31960,888,'ms','Anda telah memasukkan diskaun tarikh selepas tarikh ke matang!',0),(31961,888,'ar','Ù„Ù‚Ø¯ Ù‚Ù…Øª Ø¨Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ® Ø®ØµÙ… Ø¨Ø¹Ø¯ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø¥Ù„Ù‰!',0),(31962,888,'fr','Vous avez entrÃ© une date de remise aprÃ¨s Ã  Ã©chÃ©ance !',0),(31963,888,'jp','å‰²å¼•æ—¥ã‚’ç· åˆ‡æ—¥ã?®å¾Œã?«å…¥åŠ›ã?—ã?¦ã?„ã?¾ã?™',0),(31964,888,'pt','VocÃª digitou uma data de desconto apÃ³s a data de vencimento!',0),(31965,888,'ru','Ð’Ñ‹ Ð²Ð²ÐµÐ»Ð¸ Ð´Ð°Ñ‚Ñƒ ÑÐºÐ¸Ð´ÐºÐ¸ Ð¿Ð¾ÑÐ»Ðµ Ð´Ð¾ ÑÑ€Ð¾ÐºÐ°!',0),(31966,888,'es','HabÃ­a entrado una fecha de descuento despuÃ©s de la fecha de vencimiento',0),(31967,888,'de','Eingegebene ein Rabatt-Datum nach zu FÃ¤lligkeit!',0),(31968,888,'en','You have entered a discount date after to due date!',0),(31969,889,'is','',0),(31970,889,'dr','Ú¯Ø²Ø§Ø±Ø´  Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ ØªØ®ÙÙŠÙ ',0),(31971,889,'pr','Ú¯Ø²Ø§Ø±Ø´  Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ ØªØ®ÙÙŠÙ ',0),(31972,889,'tr','YaÅŸlandÄ±rma raporunu indirim',0),(31973,889,'pl','ZniÅ¼ki Raport wiekowania',0),(31974,889,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(31975,889,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ø®Ø³ØªÛ Ø±Ø¹Ø§ÛŒØª',0),(31976,889,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° ÑÑ‚Ð°Ñ€Ð¸Ð¼ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(31977,889,'vi','BÃ¡o CÃ¡o Chiáº¿t Kháº¥u Tuá»•i Ná»£',0),(31978,889,'af','Korting Ouderdomsverslag',0),(31979,889,'ro','Reducere Aging raport',0),(31980,889,'et','Aegumisaruande allahindlus',0),(31981,889,'si','Popust Aging poroÄilo',0),(31982,889,'ba','Diskon penuaan laporan',0),(31983,889,'nl','Korting veroudering verslag',0),(31984,889,'fi','Alennus yht.veto-raportin',0),(31985,889,'no','Rabatt aldersfordelt saldoliste',0),(31986,889,'da','Rabat Aging rapport',0),(31987,889,'ko','ë¶„ê¸° ë ˆí¬íŠ¸ í• ì¸',0),(31988,889,'he','×”× ×—×” ×“×•×— ×’×™×•×œ',0),(31989,889,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Î•Î½Î·Î»Î¹ÎºÎ¯Ï‰ÏƒÎ·Ï‚ Î¥Ï€Î¿Î»',0),(31990,889,'zh','æŠ˜æ‰£è€åŒ–æŠ¥å‘Š\r\n',0),(31991,889,'sv','Rabatt Ã…ldersrapport',0),(31992,889,'it','Sconto invecchiamento relazione',0),(31993,889,'tl','',0),(31994,889,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(31995,889,'hi','à¤à¤œà¤¿à¤‚à¤— à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤›à¥‚à¤Ÿ',0),(31996,889,'ms','Diskaun penuaan Laporan',0),(31997,889,'ar','Ø§Ù„Ø®ØµÙ… Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(31998,889,'fr','Remise rapport d\'ANTERIORITE',0),(31999,889,'jp','ãƒ‡ã‚£ã‚¹ã‚«ã‚¦ãƒ³ãƒˆã‚¨ãƒ¼ã‚¸ãƒ³ã‚°ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(32000,889,'pt','Desconto relatÃ³rio do envelhecimento',0),(32001,889,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° ÑÑ‚Ð°Ñ€ÐµÐ½Ð¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(32002,889,'es','Descuento Informe de AntigÃ¼edad',0),(32003,889,'de','Rabatt Alterung Bericht',0),(32004,889,'en','Discount Aging Report',0),(32005,890,'is','',0),(32006,890,'dr','Ù…Ù‚Ø¯Ø§Ø± ØªØ®ÙÙŠÙ ',0),(32007,890,'pr','Ù…Ù‚Ø¯Ø§Ø± ØªØ®ÙÙŠÙ ',0),(32008,890,'tr','Ä°skonto tutarÄ±',0),(32009,890,'pl','Kwota rabatu',0),(32010,890,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°Ñ‚Ð°',0),(32011,890,'ur','Ø±Ù‚Ù… ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(32012,890,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(32013,890,'vi','Sá»‘ tiá»n Chiáº¿t kháº¥u',0),(32014,890,'af','Korting Bedrag',0),(32015,890,'ro','Discount suma',0),(32016,890,'et','Allahindluse summa',0),(32017,890,'si','Znesek popusta',0),(32018,890,'ba','DISKON TERBAIK untuk jumlah',0),(32019,890,'nl','Korting bedrag',0),(32020,890,'fi','Alennuksen suuruus',0),(32021,890,'no','RabattbelÃ¸p',0),(32022,890,'da','RabatbelÃ¸b',0),(32023,890,'ko','í• ì¸ ê¸ˆì•¡',0),(32024,890,'he','×¡×›×•× ×”× ×—×ª',0),(32025,890,'el','Î Î¿ÏƒÏŒ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(32026,890,'zh','æŠ˜æ‰£é¢\r\n',0),(32027,890,'sv','Rabattbelopp',0),(32028,890,'it','Sconto quantitÃ ',0),(32029,890,'tl','',0),(32030,890,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(32031,890,'hi','à¤›à¥‚à¤Ÿ à¤°à¤¾à¤¶à¤¿',0),(32032,890,'ms','Diskaun amaun',0),(32033,890,'ar','Ù…Ø¨Ù„Øº Ø§Ù„ØªØ®ÙÙŠØ¶',0),(32034,890,'fr','Montant remise',0),(32035,890,'jp','ãƒ‡ã‚£ã‚¹ã‚«ã‚¦ãƒ³ãƒˆé¡?',0),(32036,890,'pt','Desconto de quantidade',0),(32037,890,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÐºÐ¸Ð´ÐºÐ¸',0),(32038,890,'es','Monto de Descuento',0),(32039,890,'de','Rabattbetrag',0),(32040,890,'en','Discount Amount',0),(32041,891,'is','',0),(32042,891,'dr','ØªØ§Ø±ÙŠØ® Ø§Ù†Ù‚Ø·Ø§Ø¹ ØªØ®ÙÙŠÙ ',0),(32043,891,'pr','ØªØ§Ø±ÙŠØ® Ø§Ù†Ù‚Ø·Ø§Ø¹ ØªØ®ÙÙŠÙ ',0),(32044,891,'tr','Kesme tarihi indirim',0),(32045,891,'pl','OdciÄ™cia Data rabatu',0),(32046,891,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÑÐ²Ð°Ð½Ðµ',0),(32047,891,'ur','ÙØ±ÛŒÙ… Cutoff ØªØ§Ø±ÛŒØ® ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(32048,891,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÐºÐ¸Ð´Ð°',0),(32049,891,'vi','NgÃ y ngÆ°ng Chiáº¿t kháº¥u',0),(32050,891,'af','Kortings Afsnydatum',0),(32051,891,'ro','Reducere datÄƒ Ã®ntrerupere',0),(32052,891,'et','Soodus Ã¤ralÃµikekuupÃ¤eva',0),(32053,891,'si','Popust Cutoff rok',0),(32054,891,'ba','DISKON TERBAIK untuk tanggal Cutoff',0),(32055,891,'nl','Goedkope Cutoff datum',0),(32056,891,'fi','Alennus mÃ¤Ã¤rÃ¤pÃ¤ivÃ¤',0),(32057,891,'no','Rabatt fristen',0),(32058,891,'da','Discount skÃ¦ringsdato',0),(32059,891,'ko','ì»·ì˜¤í”„ ë°ì´íŠ¸ í• ì¸',0),(32060,891,'he','×”× ×—×” ×ª××¨×™×š ×—×™×ª×•×š',0),(32061,891,'el','Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÎºÎ¿Ï€Î®Ï‚',0),(32062,891,'zh','æŠ˜æ‰£æˆªæ­¢æ—¥æœŸ\r\n',0),(32063,891,'sv','Rabatt Cutoff datum',0),(32064,891,'it','Data limite di sconto',0),(32065,891,'tl','',0),(32066,891,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3611;&#3636;&#3604;&#3618;&#3629;&#3604;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(32067,891,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤•à¤Ÿà¤‘à¤«à¤¼ à¤¤à¤¿à¤¥à¤¿',0),(32068,891,'ms','Diskaun tarikh tamat tempoh',0),(32069,891,'ar','Ø®ØµÙ… ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†Ù‚Ø·Ø§Ø¹',0),(32070,891,'fr','Date limite de remise',0),(32071,891,'jp','ãƒ‡ã‚£ã‚¹ã‚«ã‚¦ãƒ³ãƒˆçµ‚äº†æ—¥',0),(32072,891,'pt','Data limite de desconto',0),(32073,891,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð”Ð°Ñ‚Ð° Ð¾Ñ‚ÑÐµÑ‡ÐºÐ¸',0),(32074,891,'es','Fecha de Corte del Descuento',0),(32075,891,'de','Discount Stichtagsdatum',0),(32076,891,'en','Discount Cutoff Date',0),(32077,892,'is','',0),(32078,892,'dr','ØªØ§Ø±ÙŠØ® ØªØ®ÙÙŠÙ ',0),(32079,892,'pr','ØªØ§Ø±ÙŠØ® ØªØ®ÙÙŠÙ ',0),(32080,892,'tr','Ä°skonto tarihi',0),(32081,892,'pl','Data rabatu',0),(32082,892,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(32083,892,'ur','ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(32084,892,'sr','Ð”Ð°Ñ‚ÑƒÐ¼Ð° ÐºÐ°ÑÐ°ÑÐºÐ¾Ð½Ñ‚Ð°',0),(32085,892,'vi','NgÃ y Chiáº¿t kháº¥u',0),(32086,892,'af','Kortingsdatum',0),(32087,892,'ro','Data reducerii',0),(32088,892,'et','Allahindluse kuupÃ¤ev',0),(32089,892,'si','Datuma kasaskonta',0),(32090,892,'ba','DISKON TERBAIK untuk tanggal',0),(32091,892,'nl','Contantkorting',0),(32092,892,'fi','Alennuksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(32093,892,'no','Kontantrabattdato',0),(32094,892,'da','Discount dato',0),(32095,892,'ko','ë‚ ì§œ í• ì¸',0),(32096,892,'he','×”× ×—×” ×ª××¨×™×š',0),(32097,892,'el','Î¤Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(32098,892,'zh','æŠ˜æ‰£æ—¥æœŸ\r\n',0),(32099,892,'sv','Kassarabattsdatumet',0),(32100,892,'it','Sconto data',0),(32101,892,'tl','',0),(32102,892,'th','&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(32103,892,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤¤à¤¿à¤¥à¤¿',0),(32104,892,'ms','Diskaun tarikh',0),(32105,892,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ®ÙÙŠØ¶',0),(32106,892,'fr','Date de remise',0),(32107,892,'jp','ãƒ‡ã‚£ã‚¹ã‚«ã‚¦ãƒ³ãƒˆæ—¥',0),(32108,892,'pt','Data de desconto',0),(32109,892,'ru','Ð”Ð°Ñ‚Ð° ÑÐºÐ¸Ð´ÐºÐ¸',0),(32110,892,'es','Fecha de Descuento',0),(32111,892,'de','Discount-Datum',0),(32112,892,'en','Discount Date',0),(32113,893,'is','',0),(32114,893,'dr','( ØªÙ†Ø²ÙŠÙ„ ) Ø¯Ø± Ù…Ø§Ù‡ Ø¢ÙŠÙ†Ø¯Ù‡ (Prox)',0),(32115,893,'pr','Ø±ÙˆØ² ØªØ®ÙÙŠÙ ( ØªÙ†Ø²ÙŠÙ„ ) Ø¯Ø± Ù…Ø§Ù‡ Ø¢ÙŠÙ†Ø¯Ù‡ (Prox)',0),(32116,893,'tr','AyÄ±n (Prox) indirim',0),(32117,893,'pl','Rabat dzieÅ„ miesiÄ…ca (ok)',0),(32118,893,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð´ÐµÐ½ Ð½Ð° Ð¼ÐµÑÐµÑ† (Prox)',0),(32119,893,'ur','ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹ Ù…ÛÛŒÙ†Û’ (Ù¾Ø±Ø§ÙˆÙ†) Ú©ÛŒ',0),(32120,893,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° Ð´Ð°Ð½ Ñƒ Ð¼ÐµÑÐµÑ†Ñƒ (ÐŸÑ€Ð¾x)',0),(32121,893,'vi','NgÃ y Chiáº¿t kháº¥u trong thÃ¡ng (Prox)',0),(32122,893,'af','Kortingsdag van Maand (Gemidd.)',0),(32123,893,'ro','Reducere a luni (Prox)',0),(32124,893,'et','Soodus kuu (Prox)',0),(32125,893,'si','Popust dan meseca (bli)',0),(32126,893,'ba','DISKON TERBAIK untuk bulan (Prox)',0),(32127,893,'nl','Korting dag van maand (Prox)',0),(32128,893,'fi','Alennus kuukauden (Prox)',0),(32129,893,'no','Rabatt dagen i mÃ¥neden (Prox)',0),(32130,893,'da','Rabat dag i mÃ¥neden (Prox)',0),(32131,893,'ko','ë‹¬ (Prox)ì˜ í• ì¸',0),(32132,893,'he','×”× ×—×” ×”×™×•× ×‘×—×•×“×© (Prox)',0),(32133,893,'el','Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Ï„Î·Î½ Î·Î¼Î­ÏÎ± Ï„Î¿Ï… Î¼Î®Î½Î± (Prox)',0),(32134,893,'zh','æœˆä¸­çš„æŠ˜æ‰£å¤©ï¼ˆå¤§çº¦ï¼‰\r\n',0),(32135,893,'sv','Rabatt dagen i mÃ¥naden (Prox)',0),(32136,893,'it','Sconto del giorno del mese (Prox)',0),(32137,893,'tl','',0),(32138,893,'th','&#3623;&#3633;&#3609;&#3586;&#3629;&#3591;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3586;&#3629;&#3591;&#3648;&#3604;&#3639;&#3629;&#3609; (&#3648;&#3604;&#3639;&#3629;&#3609;&#3627;&#3609;&#3657;&#3634;)',0),(32139,893,'hi','à¤¦à¤¿à¤¨ à¤®à¤¹à¥€à¤¨à¥‡ (Prox) à¤•à¥‡ à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ',0),(32140,893,'ms','Diskaun hari bulan (Prox)',0),(32141,893,'ar','Ø®ØµÙ… ÙŠÙˆÙ… Ø´Ù‡Ø± (Prox)',0),(32142,893,'fr','Remise Ã  jour du mois (Prox)',0),(32143,893,'jp','å‰²å¼•æ—¥ (Prox)',0),(32144,893,'pt','Desconto dia do mÃªs (Prox)',0),(32145,893,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð´Ð½Ñ Ð¼ÐµÑÑÑ†Ð° (Ð±ÐµÑÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ñ‹Ðµ)',0),(32146,893,'es','DÃ­a del Mes de Descuento (Prox.)',0),(32147,893,'de','Discount Tag des Monats (Prox)',0),(32148,893,'en','Discount Day of Month (Prox)',0),(32149,894,'is','',0),(32150,894,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ  ØªØ®ÙÙŠÙ ',0),(32151,894,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ  ØªØ®ÙÙŠÙ ',0),(32152,894,'tr','GÃ¼n indirim',0),(32153,894,'pl','Rabat dni',0),(32154,894,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð´Ð½Ð¸',0),(32155,894,'ur','Ø¯Ù† ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(32156,894,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° Ð´Ð°Ð½Ð°',0),(32157,894,'vi','NgÃ y Chiáº¿t kháº¥u',0),(32158,894,'af','Korting Dae',0),(32159,894,'ro','Reducere de zile',0),(32160,894,'et','Soodus pÃ¤eva',0),(32161,894,'si','Popust dni',0),(32162,894,'ba','Diskon hari terbaik untuk',0),(32163,894,'nl','Goedkope dagen',0),(32164,894,'fi','Alennus pÃ¤ivÃ¤Ã¤',0),(32165,894,'no','Rabatt dager',0),(32166,894,'da','Discount dage',0),(32167,894,'ko','ì¼ í• ì¸',0),(32168,894,'he','×”× ×—×” ×™×ž×™×',0),(32169,894,'el','Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Î·Î¼Î­ÏÎµÏ‚',0),(32170,894,'zh','æŠ˜æ‰£å¤©æ•°\r\n',0),(32171,894,'sv','Rabatt dagar',0),(32172,894,'it','Sconto giorni',0),(32173,894,'tl','',0),(32174,894,'th','&#3623;&#3633;&#3609;&#3586;&#3629;&#3591;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(32175,894,'hi','à¤¦à¤¿à¤¨à¥‹à¤‚ à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ',0),(32176,894,'ms','Diskaun hari',0),(32177,894,'ar','Ø®ØµÙ… Ø§Ù„Ø£ÙŠØ§Ù…',0),(32178,894,'fr','Jours d\'escompte',0),(32179,894,'jp','å‰²å¼•æ—¥æ•°',0),(32180,894,'pt','Desconto dias',0),(32181,894,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð´Ð½Ñ',0),(32182,894,'es','DÃ­as de Descuento',0),(32183,894,'de','Rabatt-Tage',0),(32184,894,'en','Discount Days',0),(32185,895,'is','',0),(32186,895,'dr','ØªØ®ÙÙŠÙ  ÙƒØ³Ø¨ Ø´Ø¯Ù‡',0),(32187,895,'pr','ØªØ®ÙÙŠÙ  ÙƒØ³Ø¨ Ø´Ø¯Ù‡',0),(32188,895,'tr','KazanÄ±lan indirim',0),(32189,895,'pl','ZniÅ¼ki zdobyÅ‚',0),(32190,895,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° ÑÐ¿ÐµÑ‡ÐµÐ»ÐµÐ½Ð¸',0),(32191,895,'ur','Ú©Ù…Ø§ØªØ§ ØªÚ¾Ø§ Ú©ÛŒ Ø±Ø¹Ø§ÛŒØª',0),(32192,895,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ñ˜Ðµ Ð·Ð°Ñ€Ð°Ð´Ð¸Ð¾',0),(32193,895,'vi','Chiáº¿t kháº¥u kiáº¿m Ä‘Æ°á»£c',0),(32194,895,'af','Korting Verdien',0),(32195,895,'ro','Reducere a cÃ¢ÅŸtigat',0),(32196,895,'et','Allahindluse teenitud',0),(32197,895,'si','Popust prisluÅ¾il',0),(32198,895,'ba','Diskon yang diterima',0),(32199,895,'nl','Korting verdiend',0),(32200,895,'fi','Alennus ansainnut',0),(32201,895,'no','Rabatt opptjent',0),(32202,895,'da','Rabat tjent',0),(32203,895,'ko','í• ì¸ ì ë¦½',0),(32204,895,'he','×”×”× ×—×” ×”×¨×•×•×—×ª',0),(32205,895,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· ÎºÎµÏÎ´Î¯ÏƒÎµÎ¹',0),(32206,895,'zh','èŽ·å¾—çš„æŠ˜æ‰£\r\n',0),(32207,895,'sv','Rabatt tjÃ¤nat',0),(32208,895,'it','Sconto guadagnato',0),(32209,895,'tl','',0),(32210,895,'th','&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3592;&#3634;&#3585;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(32211,895,'hi','à¤…à¤°à¥à¤œà¤¿à¤¤ à¤•à¥€ à¤›à¥‚à¤Ÿ',0),(32212,895,'ms','Diskaun yang diperolehi',0),(32213,895,'ar','Ø§Ù„Ø®ØµÙ… Ø§Ù„Ù…ÙƒØªØ³Ø¨',0),(32214,895,'fr','Escomptes gagnÃ©s',0),(32215,895,'jp','å?—å?–å‰²å¼•æ–™',0),(32216,895,'pt','Desconto ganhado',0),(32217,895,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð»',0),(32218,895,'es','Descuento Devengado',0),(32219,895,'de','Rabatt erworben',0),(32220,895,'en','Discount Earned',0),(32221,896,'is','',0),(32222,896,'dr','ØªØ®ÙÙŠÙ  Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(32223,896,'pr','ØªØ®ÙÙŠÙ  Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(32224,896,'tr','Verilen iskonto',0),(32225,896,'pl','Rabat termin.',0),(32226,896,'bg','ÐšÐ¾Ð½Ñ„Ð¸Ð´ÐµÐ½Ñ†Ð¸Ð°Ð»Ð½Ð¾ÑÑ‚',0),(32227,896,'ur','Ø±Ø¹Ø§ÛŒØª Ø¯ÛŒ Ú¯Ø¦ÛŒ',0),(32228,896,'sr','Ð”Ð°Ñ‚Ð¾Ð³ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(32229,896,'vi','ÄÃ£ cho Chiáº¿t kháº¥u',0),(32230,896,'af','Korting Gegee',0),(32231,896,'ro','Reducere de dat',0),(32232,896,'et','Antud hinnaaland',0),(32233,896,'si','Popust ob',0),(32234,896,'ba','Diskon yang diberikan',0),(32235,896,'nl','Korting gegeven',0),(32236,896,'fi','Alennuksen',0),(32237,896,'no','Rabatt gitt',0),(32238,896,'da','Rabat gives',0),(32239,896,'ko','ì£¼ì–´ì§„ í• ì¸',0),(32240,896,'he','×”×”× ×—×”',0),(32241,896,'el','Î¤Î·Ï‚ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚ Ï€Î¿Ï… Î³Î¯Î½ÎµÏ„Î±Î¹',0),(32242,896,'zh','èµ‹äºˆçš„æŠ˜æ‰£\r\n',0),(32243,896,'sv','Rabatt ges',0),(32244,896,'it','Sconto dato',0),(32245,896,'tl','',0),(32246,896,'th','&#3651;&#3627;&#3657;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(32247,896,'hi','à¤›à¥‚à¤Ÿ à¤¦à¥€',0),(32248,896,'ms','Diskaun yang diberikan',0),(32249,896,'ar','ÙˆÙ†Ø¸Ø±Ø§ Ù„Ù„Ø®ØµÙ…',0),(32250,896,'fr','Remise accordÃ©e',0),(32251,896,'jp','æ—¢å®šå‰²å¼•',0),(32252,896,'pt','Desconto dado',0),(32253,896,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð°',0),(32254,896,'es','Descuento Concedido',0),(32255,896,'de','Rabatt gegeben',0),(32256,896,'en','Discount Given',0),(32257,897,'is','',0),(32258,897,'dr','ØªØ®ÙÙŠÙ  Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡ ',0),(32259,897,'pr','ØªØ®ÙÙŠÙ  Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡ ',0),(32260,897,'tr','KayÄ±p indirim',0),(32261,897,'pl','ZniÅ¼ki straciÅ‚',0),(32262,897,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð·Ð° Ð¸Ð·Ð³ÑƒÐ±ÐµÐ½Ð¸',0),(32263,897,'ur','Ø±Ø¹Ø§ÛŒØª Ú©Ú¾Ùˆ Ø¯ÛŒØ§',0),(32264,897,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ñ˜Ðµ Ð¸Ð·Ð³ÑƒÐ±Ð¸Ð¾',0),(32265,897,'vi','Máº¥t Chiáº¿t kháº¥u',0),(32266,897,'af','Korting Verloor',0),(32267,897,'ro','Reducere a pierdut',0),(32268,897,'et','Allahindluse kaotanud',0),(32269,897,'si','Popust izgubil',0),(32270,897,'ba','Diskon yang hilang',0),(32271,897,'nl','Korting verloren',0),(32272,897,'fi','Alennus menettÃ¤nyt',0),(32273,897,'no','Rabatt mistet',0),(32274,897,'da','Rabat mistet',0),(32275,897,'ko','í• ì¸ ì†ì‹¤',0),(32276,897,'he','×“×™×¡×§×•× ×˜ ××™×‘×“×”',0),(32277,897,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Î­Ï‡Î±ÏƒÎµ',0),(32278,897,'zh','æŠ˜æ‰£ä¸¢å¤±\r\n',0),(32279,897,'sv','Rabatt fÃ¶rlorade',0),(32280,897,'it','Sconto perduto',0),(32281,897,'tl','',0),(32282,897,'th','&#3586;&#3634;&#3604;&#3607;&#3640;&#3609;&#3592;&#3634;&#3585;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(32283,897,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤–à¥‹ à¤¦à¤¿à¤¯à¤¾',0),(32284,897,'ms','Diskaun yang hilang',0),(32285,897,'ar','Ø§Ù„Ø®ØµÙ… Ø§Ù„ØªÙŠ ÙÙ‚Ø¯Øª',0),(32286,897,'fr','Escompte perdu',0),(32287,897,'jp','å‰²å¼•æ??å¤±',0),(32288,897,'pt','Desconto perdido',0),(32289,897,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð¿Ð¾Ñ‚ÐµÑ€ÑÐ»',0),(32290,897,'es','Descuento PerdÃ­do',0),(32291,897,'de','Rabatt verloren',0),(32292,897,'en','Discount Lost',0),(32293,898,'is','',0),(32294,898,'dr','Ø¯Ø±ØµØ¯ ØªØ®ÙÙŠÙ ',0),(32295,898,'pr','Ø¯Ø±ØµØ¯ ØªØ®ÙÙŠÙ ',0),(32296,898,'tr','YÃ¼zde indirim',0),(32297,898,'pl','Procent zniÅ¼ki',0),(32298,898,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° %',0),(32299,898,'ur','ÙÛŒØµØ¯ ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(32300,898,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ %',0),(32301,898,'vi','% Chiáº¿t kháº¥u',0),(32302,898,'af','Korting Persentasie',0),(32303,898,'ro','Reducere la sutÄƒ',0),(32304,898,'et','Allahindluse protsent',0),(32305,898,'si','Popust odstotkov',0),(32306,898,'ba','DISKON TERBAIK persen untuk',0),(32307,898,'nl','Procent korting',0),(32308,898,'fi','Alennus %',0),(32309,898,'no','Rabatt prosent',0),(32310,898,'da','Discount procent',0),(32311,898,'ko','% í• ì¸',0),(32312,898,'he','××—×•×– ×”× ×—×”',0),(32313,898,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(32314,898,'zh','æŠ˜æ‰£ç™¾åˆ†æ¯”\r\n',0),(32315,898,'sv','Rabatt procent',0),(32316,898,'it','Per cento di sconto',0),(32317,898,'tl','',0),(32318,898,'th','&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3586;&#3629;&#3591;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(32319,898,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤›à¥‚à¤Ÿ',0),(32320,898,'ms','Peratus diskaun',0),(32321,898,'ar','Ù†Ø³Ø¨Ø© Ø§Ù„ØªØ®ÙÙŠØ¶',0),(32322,898,'fr','Pour cent de remise',0),(32323,898,'jp','å‰²å¼•çŽ‡',0),(32324,898,'pt','Por cento de desconto',0),(32325,898,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÑÐºÐ¸Ð´ÐºÐ¸',0),(32326,898,'es','Porciento de Descuento',0),(32327,898,'de','Prozent Rabatt',0),(32328,898,'en','Discount Percent',0),(32329,899,'is','',0),(32330,899,'dr','ØªØ®ÙÙŠÙ  Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡ ',0),(32331,899,'pr','ØªØ®ÙÙŠÙ  Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡ ',0),(32332,899,'tr','AlÄ±nan iskonto',0),(32333,899,'pl','Odebrany rabat',0),(32334,899,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð²Ð·ÐµÑ‚Ð¸',0),(32335,899,'ur','Ø±Ø¹Ø§ÛŒØª Ù„ÛŒ Ú¯Ø¦ÛŒ',0),(32336,899,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ñ˜Ðµ ÑƒÐ·ÐµÐ¾',0),(32337,899,'vi','ÄÃ£ Chiáº¿t kháº¥u',0),(32338,899,'af','Korting Geneem',0),(32339,899,'ro','Reducere luate',0),(32340,899,'et','Allahindluse vÃµetud',0),(32341,899,'si','Popust, sprejeti',0),(32342,899,'ba','Diskon diambil',0),(32343,899,'nl','Korting genomen',0),(32344,899,'fi','KÃ¤ytetty alennus',0),(32345,899,'no','Rabatten som er gitt',0),(32346,899,'da','Rabat taget',0),(32347,899,'ko','ì´¬ì˜ í• ì¸',0),(32348,899,'he','×”× ×—×” × ×œ×§×—',0),(32349,899,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Ï€Î¿Ï… Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹',0),(32350,899,'zh','é‡‡å–æŠ˜æ‰£\r\n',0),(32351,899,'sv','Rabatt',0),(32352,899,'it','Sconto preso',0),(32353,899,'tl','',0),(32354,899,'th','&#3651;&#3627;&#3657;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(32355,899,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤²à¥‡ à¤²à¤¿à¤¯à¤¾',0),(32356,899,'ms','Diskaun yang diambil',0),(32357,899,'ar','Ø§Ù„Ø®ØµÙ…',0),(32358,899,'fr','Remise de pris',0),(32359,899,'jp','å?–å¾—å‰²å¼•',0),(32360,899,'pt','Desconto tomado',0),(32361,899,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð¿Ñ€Ð¸Ð½ÑÑ‚Ð¾',0),(32362,899,'es','Descuento Tomado',0),(32363,899,'de','Gezogener Skonto',0),(32364,899,'en','Discount Taken',0),(32365,900,'is','',0),(32366,900,'dr','ØªØ®ÙÙŠÙØ§Øª Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(32367,900,'pr','ØªØ®ÙÙŠÙØ§Øª Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(32368,900,'tr','AlÄ±nan iskonto',0),(32369,900,'pl','ZniÅ¼ki brane',0),(32370,900,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ð·Ð° Ð²Ð·ÐµÑ‚Ð¸',0),(32371,900,'ur','Ø¢Ø®Ø± Ù…ÛŒÚº Ú†Ú¾ÙˆÙ¹ Ú©Û’ Ù„ÛŒ',0),(32372,900,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚Ð¸ Ð½Ð° ÑƒÐ·ÐµÐ¾',0),(32373,900,'vi','ÄÃ£ Chiáº¿t kháº¥u',0),(32374,900,'af','Kortings Ontvang',0),(32375,900,'ro','Reduceri luate',0),(32376,900,'et','Tehtud allahindlused',0),(32377,900,'si','Popusti, ki',0),(32378,900,'ba','Diskon diambil',0),(32379,900,'nl','Kortingen genomen',0),(32380,900,'fi','Alennukset otetaan',0),(32381,900,'no','Rabatter tatt',0),(32382,900,'da','Rabatter taget',0),(32383,900,'ko','ì´¬ì˜ í• ì¸',0),(32384,900,'he','×”× ×—×•×ª × ×œ×§×—',0),(32385,900,'el','Î•ÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹',0),(32386,900,'zh','é‡‡å–æŠ˜æ‰£\r\n',0),(32387,900,'sv','Rabatter tas',0),(32388,900,'it','SCONTI presi',0),(32389,900,'tl','',0),(32390,900,'th','&#3585;&#3634;&#3619;&#3651;&#3627;&#3657;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(32391,900,'hi','à¤›à¥‚à¤Ÿ à¤²à¥‡ à¤²à¤¿à¤¯à¤¾',0),(32392,900,'ms','Diskaun yang diambil',0),(32393,900,'ar','Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª Ø§Ù„ØªÙŠ Ø§ØªØ®Ø°Øª',0),(32394,900,'fr','Escompte sur',0),(32395,900,'jp','å?–å¾—å‰²å¼•',0),(32396,900,'pt','Descontos tomados',0),(32397,900,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ ÑÐºÐ¸Ð´ÐºÐ¸',0),(32398,900,'es','Descuentos Tomados',0),(32399,900,'de','ERMÃ„SSIGUNGEN genommen',0),(32400,900,'en','Discounts Taken',0),(32401,901,'is','',0),(32402,901,'dr','Ù†Ù…Ø§ÙŠØ´ ØªÙ‚ÙˆÙŠÙ… ',0),(32403,901,'pr','Ù†Ù…Ø§ÙŠØ´ ØªÙ‚ÙˆÙŠÙ… ',0),(32404,901,'tr','Ekran Takvim',0),(32405,901,'pl','WyÅ›wietlanie kalendarza',0),(32406,901,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€',0),(32407,901,'ur','ÚˆØ³Ù¾Ù„Û’ Ú©ÛŒÙ„Ù†ÚˆØ±',0),(32408,901,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð°',0),(32409,901,'vi','Hiá»ƒn thá»‹ lá»‹ch',0),(32410,901,'af','Wys Kaleder',0),(32411,901,'ro','AfiÈ™are Calendar',0),(32412,901,'et','Kalendri kuvamine',0),(32413,901,'si','Prikaz koledarja',0),(32414,901,'ba','Menampilkan kalender',0),(32415,901,'nl','Weergave Kalender',0),(32416,901,'fi','Kalenterin',0),(32417,901,'no','Vis kalenderen',0),(32418,901,'da','Visningen Kalender',0),(32419,901,'ko','ì „ì‹œ ì¼ì •',0),(32420,901,'he','×”×¦×’ ×œ×•×— ×©× ×”',0),(32421,901,'el','ÎŸÎ¸ÏŒÎ½Î· Î·Î¼ÎµÏÎ¿Î»ÏŒÎ³Î¹Î¿',0),(32422,901,'zh','æ˜¾ç¤ºæ—¥åŽ†\r\n',0),(32423,901,'sv','Visa kalender',0),(32424,901,'it','Visualizzazione calendario',0),(32425,901,'tl','',0),(32426,901,'th','&#3649;&#3626;&#3604;&#3591;&#3611;&#3599;&#3636;&#3607;&#3636;&#3609;',0),(32427,901,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤°',0),(32428,901,'ms','Paparan kalendar',0),(32429,901,'ar','Ø¹Ø±Ø¶ Ø§Ù„ØªÙ‚ÙˆÙŠÙ…',0),(32430,901,'fr','Affichage Calendrier',0),(32431,901,'jp','ã‚«ãƒ¬ãƒ³ãƒ€ãƒ¼ã‚’è¡¨ç¤º',0),(32432,901,'pt','Exibir calendÃ¡rio',0),(32433,901,'ru','Ð”Ð¸ÑÐ¿Ð»ÐµÐ¹ ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ÑŒ',0),(32434,901,'es','Desplegar Calendario',0),(32435,901,'de','Anzeige Kalender',0),(32436,901,'en','Display Calendar',0),(32437,902,'is','',0),(32438,902,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ ',0),(32439,902,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ ',0),(32440,902,'tr','GÃ¶rÃ¼ntÃ¼leme sÄ±rasÄ±',0),(32441,902,'pl','KolejnoÅ›Ä‡ wyÅ›wietlania',0),(32442,902,'bg','Ð ÐµÐ´ Ð½Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ',0),(32443,902,'ur','ØªØ±ØªÛŒØ¨ Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(32444,902,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(32445,902,'vi','Hiá»ƒn thá»‹ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(32446,902,'af','Wys Bestelling',0),(32447,902,'ro','Ordinea de afiÅŸare',0),(32448,902,'et','Kuvamise jÃ¤rjestus',0),(32449,902,'si','Vrstni red prikaza',0),(32450,902,'ba','Order tampilan',0),(32451,902,'nl','De volgorde van weergave',0),(32452,902,'fi','NÃ¤yttÃ¶jÃ¤rjestys',0),(32453,902,'no','VisningsrekkefÃ¸lgen',0),(32454,902,'da','VisningsrÃ¦kkefÃ¸lgen',0),(32455,902,'ko','í‘œì‹œ ìˆœì„œ',0),(32456,902,'he','×¡×“×¨ ×”×ª×¦×•×’×”',0),(32457,902,'el','Î£ÎµÎ¹ÏÎ¬ ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ·Ï‚',0),(32458,902,'zh','æ˜¾ç¤ºé¡ºåº\r\n',0),(32459,902,'sv','Visningsordning',0),(32460,902,'it','Ordine di visualizzazione',0),(32461,902,'tl','',0),(32462,902,'th','&#3649;&#3626;&#3604;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(32463,902,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¥à¤°à¤®',0),(32464,902,'ms','Susunan paparan',0),(32465,902,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ø±Ø¶',0),(32466,902,'fr','Ordre d\'affichage',0),(32467,902,'jp','æ³¨æ–‡ã?®è¡¨ç¤º',0),(32468,902,'pt','Ordem de exibiÃ§Ã£o',0),(32469,902,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(32470,902,'es','Desplegar Pedido',0),(32471,902,'de','Anzeigereihenfolge',0),(32472,902,'en','Display Order',0),(32473,903,'is','',0),(32474,903,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙˆØ§Ù„ ',0),(32475,903,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙˆØ§Ù„ ',0),(32476,903,'tr','GÃ¶rÃ¼ntÃ¼lÃ¼ soru',0),(32477,903,'pl','WyÅ›wietlacz pytanie',0),(32478,903,'bg','Ð”Ð¸ÑÐ¿Ð»ÐµÑ Ð²ÑŠÐ¿Ñ€Ð¾Ñ',0),(32479,903,'ur','ÚˆØ³Ù¾Ù„Û’ Ø³ÙˆØ§Ù„',0),(32480,903,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ð¸Ñ‚Ð°ÑšÐµ',0),(32481,903,'vi','Hiá»ƒn thá»‹ cÃ¢u há»i',0),(32482,903,'af','Wys \'n Vraag',0),(32483,903,'ro','AfiÈ™are Ã®ntrebare',0),(32484,903,'et','NÃ¤ita kÃ¼simust',0),(32485,903,'si','Prikaz vpraÅ¡anje',0),(32486,903,'ba','Tampilan pertanyaan',0),(32487,903,'nl','Weergave vraag',0),(32488,903,'fi','NÃ¤yttÃ¶ kysymys',0),(32489,903,'no','Vis spÃ¸rsmÃ¥l',0),(32490,903,'da','Display spÃ¸rgsmÃ¥l',0),(32491,903,'ko','ë””ìŠ¤í”Œë ˆì´ ì§ˆë¬¸',0),(32492,903,'he','×”×¦×’ ×©××œ×”',0),(32493,903,'el','Î•ÏÏŽÏ„Î·ÏƒÎ· Î¿Î¸ÏŒÎ½Î·',0),(32494,903,'zh','æ˜¾ç¤ºé—®é¢˜\r\n',0),(32495,903,'sv','SkÃ¤rm frÃ¥ga',0),(32496,903,'it','Visualizzazione domanda',0),(32497,903,'tl','',0),(32498,903,'th','&#3649;&#3626;&#3604;&#3591;&#3588;&#3635;&#3606;&#3634;&#3617;',0),(32499,903,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤ªà¥à¤°à¤¶à¥à¤¨',0),(32500,903,'ms','Paparan soalan',0),(32501,903,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø³Ø¤Ø§Ù„',0),(32502,903,'fr','Question de l\'affichage',0),(32503,903,'jp','è³ªå•?ã?®è¡¨ç¤º',0),(32504,903,'pt','Pergunta de exibiÃ§Ã£o',0),(32505,903,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð’Ð¾Ð¿Ñ€Ð¾Ñ',0),(32506,903,'es','Desplegar Preguntas',0),(32507,903,'de','Anzeige Frage',0),(32508,903,'en','Display Question',0),(32509,904,'is','',0),(32510,904,'dr','ØªÙˆØ²ÙŠØ¹ ',0),(32511,904,'pr','ØªÙˆØ²ÙŠØ¹ ',0),(32512,904,'tr','DaÄŸÄ±tÄ±m',0),(32513,904,'pl','Dystrybucja',0),(32514,904,'bg','Ð Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(32515,904,'ur','Ø¨Ø§Ù†Ù¹',0),(32516,904,'sr','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ†Ð¸Ñ˜Ð°',0),(32517,904,'vi','PhÃ¢n phá»‘i',0),(32518,904,'af','Verspreiding',0),(32519,904,'ro','DistribuÈ›ie',0),(32520,904,'et','Jaotus',0),(32521,904,'si','Porazdelitev',0),(32522,904,'ba','Distribusi',0),(32523,904,'nl','Distributie',0),(32524,904,'fi','Jakelu',0),(32525,904,'no','Distribusjon',0),(32526,904,'da','Distribution',0),(32527,904,'ko','ë°°í¬',0),(32528,904,'he','×”×¤×¦×”',0),(32529,904,'el','Î”Î¹Î±Î½Î¿Î¼Î®',0),(32530,904,'zh','åˆ†å¸ƒ\r\n',0),(32531,904,'sv','Distribution',0),(32532,904,'it','Distribuzione',0),(32533,904,'tl','',0),(32534,904,'th','&#3585;&#3634;&#3619;&#3592;&#3635;&#3627;&#3609;&#3656;&#3634;&#3618;',0),(32535,904,'hi','à¤µà¤¿à¤¤à¤°à¤£',0),(32536,904,'ms','Pengagihan',0),(32537,904,'ar','Ø§Ù„ØªÙˆØ²ÙŠØ¹',0),(32538,904,'fr','Distribution',0),(32539,904,'jp','é…?åˆ†',0),(32540,904,'pt','DistribuiÃ§Ã£o',0),(32541,904,'ru','Ð Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(32542,904,'es','DistribuciÃ³n',0),(32543,904,'de','Vertrieb',0),(32544,904,'en','Distribution',0),(32545,905,'is','',0),(32546,905,'dr','Ø§ÙƒÙ†ÙˆÙ† ÙƒÙ¾ÙŠ Ù†ÙƒÙ†ÙŠØ¯ ',0),(32547,905,'pr','Ø§ÙƒÙ†ÙˆÙ† ÙƒÙ¾ÙŠ Ù†ÙƒÙ†ÙŠØ¯ ',0),(32548,905,'tr','Åžimdi duyuyor musun',0),(32549,905,'pl','Nie naleÅ¼y kopiowaÄ‡ teraz',0),(32550,905,'bg','ÐÐµ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ ÑÐµÐ³Ð°',0),(32551,905,'ur','Ø§Ø¨ Ù†Ù‚Ù„ Ù†ÛÛŒÚº Ú©ÛŒ',0),(32552,905,'sr','ÐÐµ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ ÑÐ°Ð´Ð°',0),(32553,905,'vi','Äá»«ng sao chÃ©p bÃ¢y giá»',0),(32554,905,'af','Moenie Nou \'n Kopie Maak',0),(32555,905,'ro','Nu copiaÅ£i acum',0),(32556,905,'et','Kopeeri nÃ¼Ã¼d',0),(32557,905,'si','Ne kopirajte zdaj',0),(32558,905,'ba','Jangan tidak menyalin sekarang',0),(32559,905,'nl','Kopieer niet nu',0),(32560,905,'fi','Ã„lÃ¤ kopioi nyt',0),(32561,905,'no','Ikke kopier nÃ¥',0),(32562,905,'da','Du mÃ¥ ikke kopiere nu',0),(32563,905,'ko','ì§€ê¸ˆ ë³µì‚¬ í•˜ì§€ ë§ˆì‹­ì‹œì˜¤',0),(32564,905,'he','××™×Ÿ ×œ×”×¢×ª×™×§ ×¢×›×©×™×•',0),(32565,905,'el','ÎœÎ·Î½ Î±Î½Ï„Î¹Î³ÏÎ¬Ï†ÎµÏ„Îµ Ï„ÏŽÏÎ±',0),(32566,905,'zh','çŽ°åœ¨ä¸è¦å¤åˆ¶\r\n',0),(32567,905,'sv','Kopiera inte nu',0),(32568,905,'it','Non copiare ora',0),(32569,905,'tl','',0),(32570,905,'th','&#3629;&#3618;&#3656;&#3634;&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3651;&#3609;&#3586;&#3603;&#3632;&#3609;&#3637;&#3657;',0),(32571,905,'hi','à¤…à¤¬ à¤¨à¤¾ à¤•à¥‰à¤ªà¥€ à¤•à¤°à¥‡à¤‚',0),(32572,905,'ms','Salin sekarang',0),(32573,905,'ar','Ù„Ø§ ØªÙ‚Ù… Ø¨Ù†Ø³Ø® Ø§Ù„Ø¢Ù†',0),(32574,905,'fr','Ne copiez pas maintenant',0),(32575,905,'jp','ä»Šã‚³ãƒ”ãƒ¼ã?—ã?ªã?„ã?§ä¸‹ã?•ã?„',0),(32576,905,'pt','NÃ£o copie agora',0),(32577,905,'ru','ÐÐµ ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¡ÐµÐ¹Ñ‡Ð°Ñ',0),(32578,905,'es','No CÃ³pia Ahora',0),(32579,905,'de','Kopieren Sie nicht jetzt',0),(32580,905,'en','Do Not Copy Now',0),(32581,906,'is','',0),(32582,906,'dr',' ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± Ø¢Ø®Ø± Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯',0),(32583,906,'pr',' ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± Ø¢Ø®Ø± Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯',0),(32584,906,'tr','Son girilen fatura gÃ¶sterme',0),(32585,906,'pl','Nie pokazuj wprowadzone w ostatniej faktury',0),(32586,906,'bg','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸, Ð²Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð² Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ',0),(32587,906,'ur','Ø¢Ø®Ø± Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ù†Û Ú©Ø±ÛŒÚº',0),(32588,906,'sr','ÐÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÑƒÐ½ÐµÑ‚ Ñƒ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ',0),(32589,906,'vi','Äá»«ng thá»ƒ hiá»‡n hÃ³a Ä‘Æ¡n Ä‘Ã£ nháº­p cuá»‘i cÃ¹ng',0),(32590,906,'af','Moenie Fakture Laaste Ingevoer Wys Nie',0),(32591,906,'ro','Nu aratÄƒ facturi au intrat Ã®n ultima',0),(32592,906,'et','Ã„ra nÃ¤ita arveid, mis on sisestatud viimase',0),(32593,906,'si','Ne Show raÄuni vneseni v zadnji',0),(32594,906,'ba','Tidak menunjukkan faktur masuk terakhir',0),(32595,906,'nl','Vertonen geen facturen ingevoerd In laatste',0),(32596,906,'fi','Ã„lÃ¤ NÃ¤ytÃ¤ laskut tuli viime',0),(32597,906,'no','Ikke Vis fakturaer i siste',0),(32598,906,'da','Vis ikke fakturaer indtastes i sidste',0),(32599,906,'ko','ë§ˆì§€ë§‰ì— ìž…ë ¥ ëœ ì†¡ìž¥ í‘œì‹œ í•˜ì§€ ì•ŠìŒ',0),(32600,906,'he','××œ ×ª×¦×™×’ ×—×©×‘×•× ×™×•×ª × ×›× ×¡ ××—×¨×•×Ÿ',0),(32601,906,'el','Î”ÎµÎ½ Î´ÎµÎ¯Ï‡Î½Î¿Ï…Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… ÎµÎ³Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î¿ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿',0),(32602,906,'zh','ä¸è¦æ˜¾ç¤ºä¸Šæ¬¡è¾“å…¥çš„å‘ç¥¨\r\n',0),(32603,906,'sv','Visa inte fakturor angett i sista',0),(32604,906,'it','Non mostrare fatture entrate nell\'ultimo',0),(32605,906,'tl','',0),(32606,906,'th','&#3629;&#3618;&#3656;&#3634;&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3588;&#3619;&#3633;&#3657;&#3591;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(32607,906,'hi','à¤†à¤–à¤¿à¤°à¥€ à¤®à¥‡à¤‚ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤ à¤—à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(32608,906,'ms','Tidak menunjukkan invois-invois yang dimasukkan dalam terakhir',0),(32609,906,'ar','Ø¹Ø¯Ù… Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ ÙÙŠ Ø§Ù„Ø£Ø®ÙŠØ±',0),(32610,906,'fr','Ne montrez pas de factures est entrÃ©s en dernier',0),(32611,906,'jp','æœ€å¾Œã?«å…¥åŠ›ã?—ã?Ÿè«‹æ±‚æ›¸ã‚’è¡¨ç¤ºã?—ã?ªã?„',0),(32612,906,'pt','NÃ£o mostrar as facturas que entraram na Ãºltima',0),(32613,906,'ru','ÐÐµ ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚Ð° Ð’Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ðµ ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¼Ð¸',0),(32614,906,'es','No Muestra las Ultimas Facturas Entradas',0),(32615,906,'de','Eingetragen In letzten Rechnungen nicht anzeigen',0),(32616,906,'en','Do Not Show Invoices Entered In Last',0),(32617,907,'is','',0),(32618,907,'dr','Ø³Ù†Ø¯',0),(32619,907,'pr','Ø³Ù†Ø¯',0),(32620,907,'tr','Belge',0),(32621,907,'pl','Dokument',0),(32622,907,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(32623,907,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ²',0),(32624,907,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(32625,907,'vi','TÃ i liá»‡u',0),(32626,907,'af','Dokument',0),(32627,907,'ro','Documentul',0),(32628,907,'et','Dokument',0),(32629,907,'si','Dokument',0),(32630,907,'ba','Dokumen',0),(32631,907,'nl','Document',0),(32632,907,'fi','Asiakirja',0),(32633,907,'no','Dokumentet',0),(32634,907,'da','Dokument',0),(32635,907,'ko','ë¬¸ì„œ',0),(32636,907,'he','×”×ž×¡×ž×š',0),(32637,907,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿',0),(32638,907,'zh','æ–‡ä»¶\r\n',0),(32639,907,'sv','Dokument',0),(32640,907,'it','Documento',0),(32641,907,'tl','',0),(32642,907,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(32643,907,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼',0),(32644,907,'ms','Dokumen',0),(32645,907,'ar','Ø§Ù„ÙˆØ«ÙŠÙ‚Ø©',0),(32646,907,'fr','Document',0),(32647,907,'jp','æ–‡æ›¸',0),(32648,907,'pt','Documento',0),(32649,907,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(32650,907,'es','Documento',0),(32651,907,'de','Dokument',0),(32652,907,'en','Document',0),(32653,908,'is','',0),(32654,908,'dr','Ø³Ù†Ø¯ ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(32655,908,'pr','Ø³Ù†Ø¯ ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(32656,908,'tr','Belgeyi iade etme',0),(32657,908,'pl','Zaewidencjonowanie dokumentu',0),(32658,908,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(32659,908,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ù…ÛŒÚº',0),(32660,908,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(32661,908,'vi','TÃ i liá»‡u vÃ o',0),(32662,908,'af','Dokument Ingeteken',0),(32663,908,'ro','Verificarea documentelor Ã®n',0),(32664,908,'et','Dokumendi sissemÃ¶llimine',0),(32665,908,'si','SproÅ¡Äanje dokumenta',0),(32666,908,'ba','Dokumen Check In',0),(32667,908,'nl','Document inchecken',0),(32668,908,'fi','Asiakirjan kuittaaminen sisÃ¤Ã¤n',0),(32669,908,'no','Innsjekking av dokument',0),(32670,908,'da','Dokument Check-In',0),(32671,908,'ko','ë¬¸ì„œ ì²´í¬ ì¸',0),(32672,908,'he','×”×ž×¡×ž×š ×¦\'×§',0),(32673,908,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ Ï„Ï‰Î½ ÎµÎ³Î³ÏÎ¬Ï†Ï‰Î½ ÏƒÎµ',0),(32674,908,'zh','æ–‡æ¡£ç­¾å…¥\r\n',0),(32675,908,'sv','Dokumentkontrollen i',0),(32676,908,'it','Documento Check In',0),(32677,908,'tl','',0),(32678,908,'th','&#3609;&#3635;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;',0),(32679,908,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤šà¥‡à¤• à¤‡à¤¨',0),(32680,908,'ms','Pemeriksaan dokumen di',0),(32681,908,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ø³ØªÙ†Ø¯',0),(32682,908,'fr','Document Check-In',0),(32683,908,'jp','æ–‡æ›¸ã?®ãƒ?ã‚§ãƒƒã‚¯ã‚¤ãƒ³',0),(32684,908,'pt','Documento Check-In',0),(32685,908,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð²',0),(32686,908,'es','Documento Ingresar',0),(32687,908,'de','Dokument einchecken',0),(32688,908,'en','Document Check In',0),(32689,909,'is','',0),(32690,909,'dr','Ø³Ù†Ø¯ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ Ø¯Ø± ',0),(32691,909,'pr','Ø³Ù†Ø¯ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ Ø¯Ø± ',0),(32692,909,'tr','Belge Ã¼zerinde oluÅŸturulan',0),(32693,909,'pl','Dokument utworzony na',0),(32694,909,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½ Ð²',0),(32695,909,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ù¾Ø± Ù¾ÛŒØ¯Ø§ ÛÙˆ Ú¯ÛŒØ§',0),(32696,909,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½ Ð½Ð°',0),(32697,909,'vi','TÃ i liá»‡u táº¡o ra vÃ o',0),(32698,909,'af','Dokument geskep op',0),(32699,909,'ro','Document creat pe',0),(32700,909,'et','Dokumendi loonud',0),(32701,909,'si','Dokumenta, ustvarjenega na',0),(32702,909,'ba','Dokumen yang dibuat pada',0),(32703,909,'nl','Document dat is gemaakt op',0),(32704,909,'fi','Asiakirja luotu',0),(32705,909,'no','Dokument som er opprettet pÃ¥',0),(32706,909,'da','Dokument oprettet pÃ¥',0),(32707,909,'ko','ì— ë§Œë“  ë¬¸ì„œ',0),(32708,909,'he','×‘×ž×¡×ž×š ×©× ×•×¦×¨',0),(32709,909,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ ÏƒÎµ',0),(32710,909,'zh','æ–‡æ¡£åˆ›å»º\r\n',0),(32711,909,'sv','Dokument skapat pÃ¥',0),(32712,909,'it','Documento creato il',0),(32713,909,'tl','',0),(32714,909,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3610;&#3609;',0),(32715,909,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¤° à¤¬à¤¨à¤¾à¤¯à¤¾',0),(32716,909,'ms','Dokumen yang diwujudkan dalam',0),(32717,909,'ar','Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø§Ù„Ø°ÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡ ÙÙŠ',0),(32718,909,'fr','Document crÃ©Ã© le',0),(32719,909,'jp','ï½žã?«ä½œæˆ?ã?—ã?Ÿæ–‡æ›¸',0),(32720,909,'pt','Documento criado em',0),(32721,909,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚, ÑÐ¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð½Ð°',0),(32722,909,'es','Documento creado en',0),(32723,909,'de','Dokument erstellt am',0),(32724,909,'en','Document created on',0),(32725,910,'is','',0),(32726,910,'dr','. Ù‡ÙŠÚ† Ø§ØµÙ„Ø§Ø­ÙŠ Ø¯Ø± Ø¢ÙŠÙ†Ø¯Ù‡ Ù…Ù…ÙƒÙ† Ù†ÙŠØ³Øª',0),(32727,910,'pr','Ø³Ù†Ø¯  Ù†Ù‡Ø§ÙŠÙŠ  Ø´Ø¯Ù‡ Ø§Ø³Øª  . Ù‡ÙŠÚ† Ø§ØµÙ„Ø§Ø­ÙŠ Ø¯Ø± Ø¢ÙŠÙ†Ø¯Ù‡ Ù…Ù…ÙƒÙ† Ù†ÙŠØ³Øª',0),(32728,910,'tr','Belge son olarak iÅŸaretlenmiÅŸ.  BaÅŸka hiÃ§bir dÃ¼zeltme yapÄ±lÄ±r.',0),(32729,910,'pl','Dokument zostaÅ‚ oznaczony jako wersjÄ™ ostatecznÄ….  Dalsze zmiany nie sÄ… moÅ¼liwe.',0),(32730,910,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ðµ Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½ ÐºÐ°Ñ‚Ð¾ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÐµÐ½.  ÐÑÐ¼Ð° Ð¿Ð¾-Ð½Ð°Ñ‚Ð°Ñ‚ÑŠÑˆÐ½Ð¸ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸ ÑÐ° Ð²ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð¸.',0),(32731,910,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ùˆ Ø­ØªÙ…ÛŒ Ø·ÙˆØ± Ù¾Ø± Ù†Ø´Ø§Ù† Ø²Ø¯ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”  Ú©ÙˆØ¦ÛŒ Ù…Ø²ÛŒØ¯ Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ Ù…Ù…Ú©Ù† ÛÛŒÚº Û”',0),(32732,910,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¸Ð¼Ð° Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸ ÐºÐ°Ð¾ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸.  ÐœÐ¾Ð³ÑƒÑ›Ð¸ ÑÑƒ Ð¸ Ð±ÐµÐ· Ð´Ð°Ñ™Ð¸Ñ… Ð¿Ñ€ÐµÐ¸ÑÐ¿Ð¸Ñ‚Ð¸Ð²Ð°ÑšÐ°.',0),(32733,910,'vi','TÃ i liá»‡u Ä‘Ã£ Ä‘Ã¡nh dáº¥u káº¿t thÃºc. KhÃ´ng chá»‰nh sá»­a Ä‘Æ°á»£c ná»¯a',0),(32734,910,'af','Dokument het as finale gemerk is.  Geen verdere hersienings is moontlik.',0),(32735,910,'ro','Documentul a fost marcat ca final.  Nu revizuiri ulterioare sunt posibile.',0),(32736,910,'et','Dokument on mÃ¤rgitud lÃµplikuks.  TÃ¤iendavaid parandusi on vÃµimalik.',0),(32737,910,'si','Dokument je bil oznaÄen kot dokonÄen.  Brez nadaljnje revizije so moÅ¾ne.',0),(32738,910,'ba','Dokumen telah ditandai sebagai akhir.  Revisi tidak lebih lanjut mungkin.',0),(32739,910,'nl','Document is gemarkeerd als definitief.  Geen verdere wijzigingen zijn mogelijk.',0),(32740,910,'fi','Tiedosto on merkitty lopulliseksi.  Ei muita tarkistuksia ei mahdollista.',0),(32741,910,'no','Dokumentet er merket som endelig.  Ingen ytterligere endringer er mulig.',0),(32742,910,'da','Dokumentet er blevet markeret som final.  Ingen yderligere revisioner er muligt.',0),(32743,910,'ko','ë¬¸ì„œ ìµœì¢…ë³¸ìœ¼ë¡œ í‘œì‹œ ë˜ì—ˆìŠµë‹ˆë‹¤.  ì•„ë‹ˆ ì¶”ê°€ ìˆ˜ì •ì´ ê°€ëŠ¥ í•©ë‹ˆë‹¤.',0),(32744,910,'he','×”×ž×¡×ž×š ×¡×•×ž×Ÿ ×›×¡×•×¤×™.  ××™×Ÿ ×ª×™×§×•× ×™× × ×•×¡×¤×™× ××¤×©×¨×™×™×.',0),(32745,910,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Î­Ï‡ÎµÎ¹ ÏƒÎ·Î¼Î±Î½Î¸ÎµÎ¯ Ï‰Ï‚ Ï„ÎµÎ»Î¹ÎºÏŒ.  Î ÏÎ¿Î±Î³Î¬Î³Î¿Ï…Î½ Ï„Î¹Ï‚ Î±Î½Î±Î¸ÎµÏ‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„ÏŒ.',0),(32746,910,'zh','æ–‡ä»¶å·²è¢«æ ‡ç¤ºä¸ºæœ€åŽã€‚æ²¡æœ‰æ›´å¤šå¯èƒ½çš„å›žé¡¾\r\n',0),(32747,910,'sv','Dokument har markerats som slutgiltigt.  Inga ytterligare Ã¤ndringar Ã¤r mÃ¶jliga.',0),(32748,910,'it','Documento Ã¨ stato contrassegnato come finale.  Nessun ulteriore revisioni sono possibili.',0),(32749,910,'tl','',0),(32750,910,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3607;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3652;&#3623;&#3657;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3607;&#3657;&#3',0),(32751,910,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤  à¤¨à¤¹à¥€à¤‚ à¤†à¤—à¥‡ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤¸à¤‚à¤­à¤µ à¤¹à¥‹ à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(32752,910,'ms','Dokumen telah ditandakan sebagai akhir.  Tiada semakan selanjutnya yang mungkin.',0),(32753,910,'ar','ØªÙ… ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ ÙƒÙ†Ù‡Ø§Ø¦ÙŠ.  Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…Ø²ÙŠØ¯ Ù…Ù† Ø§Ù„ØªÙ†Ù‚ÙŠØ­Ø§Øª Ø§Ù„Ù…Ù…ÙƒÙ†Ø©.',0),(32754,910,'fr','Document marquÃ© comme final.  Aucuns nouvelles rÃ©visions ne sont possibles.',0),(32755,910,'jp','æ–‡æ›¸ã?¯æ­£å¼?ã?«å®Œäº†ã?•ã‚Œã?¦ã?„ã?¾ã?™ã€‚ã?“ã‚Œä»¥é™?ã?®ä¿®æ­£ã?¯ã?§ã??ã?¾ã?›ã‚“ã€‚',0),(32756,910,'pt','Documento foi marcado como final.  Sem revisÃµes adicionais sÃ£o possÃ­veis.',0),(32757,910,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ð¼ÐµÑ‡ÐµÐ½ ÐºÐ°Ðº Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹.  Ð‘ÐµÐ· Ð´Ð°Ð»ÑŒÐ½ÐµÐ¹ÑˆÐµÐ³Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ñ‹.',0),(32758,910,'es','Documento se marcÃ³ como final. MÃ¡s revisiones no son posibles',0),(32759,910,'de','Dokument wurde als abgeschlossen markiert.  Keine weiteren Ã„nderungen sind mÃ¶glich.',0),(32760,910,'en','Document has been marked as final.  No further revisions are possible.',0),(32761,911,'is','',0),(32762,911,'dr','Ù„ÙŠØ³Øª Ø¨Ø±Ø¯Ø§Ø±ÙŠ Ø³Ù†Ø¯ ',0),(32763,911,'pr','Ù„ÙŠØ³Øª Ø¨Ø±Ø¯Ø§Ø±ÙŠ Ø³Ù†Ø¯ ',0),(32764,911,'tr','Belge listesi',0),(32765,911,'pl','Lista dokumentÃ³w',0),(32766,911,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº',0),(32767,911,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ Ù„Ø³Ù¹Ù†Ú¯',0),(32768,911,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð›Ð¸ÑÑ‚Ð¸Ð½Ð³',0),(32769,911,'vi','Liá»‡t kÃª TÃ i liá»‡u',0),(32770,911,'af','Dokument lys',0),(32771,911,'ro','Listarea documentului',0),(32772,911,'et','Dokumentide loetelu',0),(32773,911,'si','Uvrstitev dokumenta',0),(32774,911,'ba','Daftar dokumen',0),(32775,911,'nl','Document aanbieding',0),(32776,911,'fi','Asiakirjaan luettelon',0),(32777,911,'no','Dokumentet liste',0),(32778,911,'da','Dokument oversigt',0),(32779,911,'ko','ë¬¸ì„œ ëª©ë¡',0),(32780,911,'he','×ž×¡×ž×š ×¨×™×©×•×',0),(32781,911,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ³Î³ÏÎ¬Ï†Ï‰Î½',0),(32782,911,'zh','æ–‡ä»¶æ¸…å•\r\n',0),(32783,911,'sv','Dokument lista',0),(32784,911,'it','Documento elenco',0),(32785,911,'tl','',0),(32786,911,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(32787,911,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤²à¤¿à¤¸à¥à¤Ÿà¤¿à¤‚à¤—',0),(32788,911,'ms','Senarai dokumen',0),(32789,911,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª',0),(32790,911,'fr','Document inscription',0),(32791,911,'jp','æ–‡æ›¸ãƒªã‚¹ãƒˆ',0),(32792,911,'pt','Listagem de documentos',0),(32793,911,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(32794,911,'es','Documento Listar',0),(32795,911,'de','Dokument-Liste',0),(32796,911,'en','Document Listing',0),(32797,912,'is','',0),(32798,912,'dr','Ù…Ø¯ÙŠØ± Ø³Ù†Ø¯ ',0),(32799,912,'pr','Ù…Ø¯ÙŠØ± Ø³Ù†Ø¯ ',0),(32800,912,'tr','Belge yÃ¶neticisi',0),(32801,912,'pl','ZarzÄ…dzanie dokumentami',0),(32802,912,'bg','ÐœÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(32803,912,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ù…ÛŒÙ†ÛŒØ¬Ø±',0),(32804,912,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°Ñ‡ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸Ð¼Ð°',0),(32805,912,'vi','Quáº£n LÃ½ TÃ i Liá»‡u',0),(32806,912,'af','Dokument Bestuurder',0),(32807,912,'ro','Manager de documente',0),(32808,912,'et','Dokumendi haldur',0),(32809,912,'si','Dokument Manager',0),(32810,912,'ba','Dokumen manajer',0),(32811,912,'nl','Document Manager',0),(32812,912,'fi','Asiakirjan hallinta',0),(32813,912,'no','Dokumentbehandling',0),(32814,912,'da','Dokument Manager',0),(32815,912,'ko','ë¬¸ì„œ ê´€ë¦¬ìž',0),(32816,912,'he','×ž×¡×ž×š ×ž× ×”×œ',0),(32817,912,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Ï„Î¿Ï… Î´Î¹ÎµÏ…Î¸Ï…Î½Ï„Î®',0),(32818,912,'zh','æ–‡ä»¶ç®¡ç†å™¨\r\n',0),(32819,912,'sv','Document Manager',0),(32820,912,'it','Gestione documenti',0),(32821,912,'tl','',0),(32822,912,'th','&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(32823,912,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤•',0),(32824,912,'ms','Pengurus dokumen',0),(32825,912,'ar','Ù…Ø¯ÙŠØ± Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª',0),(32826,912,'fr','Gestion de Document',0),(32827,912,'jp','æ–‡æ›¸ç®¡ç?†è€…',0),(32828,912,'pt','Gerenciador de documentos',0),(32829,912,'ru','ÐœÐµÐ½ÐµÐ´Ð¶ÐµÑ€ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(32830,912,'es','Supervisor de Documento',0),(32831,912,'de','Document Manager',0),(32832,912,'en','Document Manager',0),(32833,913,'is','',0),(32834,913,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù…Ø¯ÙŠØ± Ø³Ù†Ø¯ ',0),(32835,913,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù…Ø¯ÙŠØ± Ø³Ù†Ø¯ ',0),(32836,913,'tr','Belge yÃ¶neticisi kategori ekleme',0),(32837,913,'pl','Dokument MenedÅ¼era kategorii Dodaj',0),(32838,913,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð·Ð° Ð¼ÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(32839,913,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ù…Ù†ÛŒØ¬Ø± Ø²Ù…Ø±Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(32840,913,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° ÐœÐµÐ½Ð°ÑŸÐµÑ€Ð° Ð·Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(32841,913,'vi','ThÃªm Thá»ƒ Loáº¡i Quáº£n LÃ½ TÃ i Liá»‡u',0),(32842,913,'af','Dokument Bestuurder kategorie voeg',0),(32843,913,'ro','Adauga categorie de conducÄƒtor documentului',0),(32844,913,'et','Manager dokumendikategooria lisamiseks',0),(32845,913,'si','Category Manager dokument dodate',0),(32846,913,'ba','Tambahkan dokumen manajer Kategori',0),(32847,913,'nl','Document Manager categorie toevoegen',0),(32848,913,'fi','Manager tiedostoluokka lisÃ¤Ã¤',0),(32849,913,'no','Manager dokumentkategori legge',0),(32850,913,'da','Manager dokumentkategori tilfÃ¸je',0),(32851,913,'ko','ë¬¸ì„œ ê´€ë¦¬ìž ì¹´í…Œê³ ë¦¬ ì¶”ê°€',0),(32852,913,'he','×”×•×¡×£ ×ž×¡×ž×š ×ž× ×”×œ ×§×˜×’×•×¨×™×”',0),(32853,913,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î­Î³Î³ÏÎ±Ï†Î¿ Manager ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(32854,913,'zh','æ–‡ä»¶ç®¡ç†å™¨ç±»åˆ«æ·»åŠ \r\n',0),(32855,913,'sv','Manager dokumentkategori lÃ¤gga till',0),(32856,913,'it','Aggiungi documento Manager categoria',0),(32857,913,'tl','',0),(32858,913,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(32859,913,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(32860,913,'ms','Tambah Kategori Pengurus dokumen',0),(32861,913,'ar','Ø¥Ø¶Ø§ÙØ© ÙØ¦Ø© Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(32862,913,'fr','Ajouter catÃ©gorie gestionnaire de document',0),(32863,913,'jp','æ–‡æ›¸ç®¡ç?†è€…ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®è¿½åŠ ',0),(32864,913,'pt','Adicionar categoria de Document Manager',0),(32865,913,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¼ÐµÐ½ÐµÐ´Ð¶ÐµÑ€ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(32866,913,'es','Suprvisor de Documento Agregar CategorÃ­a',0),(32867,913,'de','Dokument-Manager Kategorie hinzufÃ¼gen',0),(32868,913,'en','Document Manager Category Add',0),(32869,914,'is','',0),(32870,914,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ù…Ø¯ÙŠØ±ÙŠØª Ø³Ù†Ø¯ ',0),(32871,914,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ù…Ø¯ÙŠØ±ÙŠØª Ø³Ù†Ø¯ ',0),(32872,914,'tr','Belge yÃ¶neticisi Kategori gÃ¼ncelleÅŸtirme',0),(32873,914,'pl','Dokument MenedÅ¼era kategorii aktualizacji',0),(32874,914,'bg','ÐœÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(32875,914,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ù…Ù†ÛŒØ¬Ø± Ø²Ù…Ø±Û ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(32876,914,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°Ñ‡ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸Ð¼Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(32877,914,'vi','Cáº­p nháº­t thá»ƒ loáº¡i quáº£n lÃ½ tÃ i liá»‡u',0),(32878,914,'af','Dokument Bestuurder kategorie bywerking',0),(32879,914,'ro','Actualizare de Categorie Manager de documente',0),(32880,914,'et','Dokumendi haldur kategooria Update',0),(32881,914,'si','Posodobitev Category Manager dokument',0),(32882,914,'ba','Dokumen manajer kategori Update',0),(32883,914,'nl','Document Manager categorie Update',0),(32884,914,'fi','Asiakirjan haltijan luokka pÃ¤ivitys',0),(32885,914,'no','Dokumentbehandling kategori oppdatering',0),(32886,914,'da','Dokument Manager kategori opdatering',0),(32887,914,'ko','ë¬¸ì„œ ê´€ë¦¬ìž ì¹´í…Œê³ ë¦¬ ì—…ë°ì´íŠ¸',0),(32888,914,'he','×ž×¡×ž×š ×ž× ×”×œ ×§×˜×’×•×¨×™×” ×¢×“×›×•×Ÿ',0),(32889,914,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Î´Î¹ÎµÏ…Î¸Ï…Î½Ï„Î® ÎµÎ³Î³ÏÎ¬Ï†Ï‰Î½',0),(32890,914,'zh','æ–‡ä»¶ç®¡ç†å™¨ç±»åˆ«æ›´æ–°\r\n',0),(32891,914,'sv','Document Manager kategori uppdatering',0),(32892,914,'it','Aggiornamento categoria Document Manager',0),(32893,914,'tl','',0),(32894,914,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(32895,914,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(32896,914,'ms','Kemaskini kategori Pengurus dokumen',0),(32897,914,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙØ¦Ø© Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª',0),(32898,914,'fr','Mise Ã  jour de la catÃ©gorie Document Manager',0),(32899,914,'jp','æ–‡æ›¸ç®¡ç?†è€…ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®æ›´æ–°',0),(32900,914,'pt','ActualizaÃ§Ã£o de categoria do Gerenciador de documentos',0),(32901,914,'ru','ÐœÐµÐ½ÐµÐ´Ð¶ÐµÑ€ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(32902,914,'es','Suprvisor de Documento Actualizar CategorÃ­a',0),(32903,914,'de','Dokumentverwaltung-Kategorie-Update',0),(32904,914,'en','Document Manager Category Update',0),(32905,915,'is','',0),(32906,915,'dr','Ø³Ù†Ø¯ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ÙŠØ§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±  ØªØ³ÙˆÙŠÙ‡ Ø­Ø³Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(32907,915,'pr','Ø³Ù†Ø¯ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ÙŠØ§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±  ØªØ³ÙˆÙŠÙ‡ Ø­Ø³Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(32908,915,'tr','Belge bulunamadÄ± veya kullanÄ±ma alÄ±nmÄ±ÅŸ.',0),(32909,915,'pl','Dokument nie znaleziono lub juÅ¼ wyewidencjonowany.',0),(32910,915,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½ Ð¸Ð»Ð¸ Ð²ÐµÑ‡Ðµ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½.',0),(32911,915,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ù†ÛÛŒÚº Ù…Ù„ÛŒ ÛŒØ§ Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ø®Ø§Ø±Ø¬ Ú©Ø± Ø¯ÛŒØ§ Û”',0),(32912,915,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½ Ð¸Ð»Ð¸ Ð²ÐµÑ› Ð¾Ð´Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð°.',0),(32913,915,'vi','KhÃ´ng tÃ¬m tháº¥y tÃ i liá»‡u hoáº·c Ä‘Ã£ Ä‘Æ°a ra',0),(32914,915,'af','Dokument nie gevind of reeds nagegaan het.',0),(32915,915,'ro','Documentul nu a fost gÄƒsit sau deja verificat.',0),(32916,915,'et','Dokumenti ei leitud vÃµi juba vÃ¤lja mÃ¶llitud.',0),(32917,915,'si','Dokumenta ni mogoÄe najti ali Å¾e rezerviran.',0),(32918,915,'ba','Dokumen tidak ditemukan atau sudah memeriksa.',0),(32919,915,'nl','Document niet wordt gevonden of al uitgecheckt.',0),(32920,915,'fi','Tiedostoa ei lÃ¶ydy, tai jo uloskuitattu.',0),(32921,915,'no','Dokumentet funnet ikke eller allerede sjekket ut.',0),(32922,915,'da','Dokumentet findes ikke eller allerede er tjekket ud.',0),(32923,915,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ë˜ëŠ” ì´ë¯¸ ì²´í¬ ì•„ì›ƒ ëœ ë¬¸ì„œ.',0),(32924,915,'he','×”×ž×¡×ž×š ×œ× × ×ž×¦× ××• ×›×‘×¨ ×”×•×¦×.',0),(32925,915,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ Î® Î³Î¯Î½ÎµÎ¹ Î®Î´Î· Î±Î½Î¬Î»Î·ÏˆÎ·.',0),(32926,915,'zh','æ‰¾ä¸åˆ°æ–‡ä»¶æˆ–å·²ç­¾å‡º',0),(32927,915,'sv','Dokument hittades inte eller redan Ã¤r utcheckat.',0),(32928,915,'it','Documento non trovato o giÃ  verificato.',0),(32929,915,'tl','',0),(32930,915,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3627;&#3619;&#3639;&#3629;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3652;&#3604;&#3657;&#3609;&#3635;&#3629;&#3629;&#3585;&#3652;&#3611;&#3649;&#3621;&#3657;&#3623;',0),(32931,915,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤¯à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¥€à¥¤',0),(32932,915,'ms','Dokumen tidak dijumpai atau menandakan.',0),(32933,915,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø£Ùˆ Ø§Ù„Ø³Ø­Ø¨ Ø¨Ø§Ù„ÙØ¹Ù„.',0),(32934,915,'fr','Document introuvable ou dÃ©jÃ  vÃ©rifiÃ©.',0),(32935,915,'jp','æ–‡æ›¸ã?Œè¦‹ã?¤ã?‹ã‚‰ã?ªã?„ã?‹ã?™ã?§ã?«ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(32936,915,'pt','Documento nÃ£o encontrado ou jÃ¡ teve alta.',0),(32937,915,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½ Ð¸Ð»Ð¸ ÑƒÐ¶Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½.',0),(32938,915,'es','Documento no se encontrÃ³ o ya salÃ­o',0),(32939,915,'de','Dokument nicht gefunden oder bereits ausgecheckt.',0),(32940,915,'en','Document not found or already checked out.',0),(32941,916,'is','',0),(32942,916,'dr','( Ø®ØµÙˆØµÙŠØ§Øª Ø³Ù†Ø¯',0),(32943,916,'pr','Ø³Ù†Ø¯ Ø¯Ø§Ø±Ø§ÙŠÙŠ Ù‡Ø§( Ø®ØµÙˆØµÙŠØ§Øª Ø³Ù†Ø¯',0),(32944,916,'tr','Belge Ã¶zellikleri',0),(32945,916,'pl','WÅ‚aÅ›ciwoÅ›ci dokumentu',0),(32946,916,'bg','Ð¡Ð²Ð¾Ð¹ÑÑ‚Ð²Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(32947,916,'ur','Ø®ÙˆØ§Øµ Ø¯Ø³ØªØ§ÙˆÛŒØ²',0),(32948,916,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(32949,916,'vi','TÃ­nh cháº¥t TÃ i liá»‡u',0),(32950,916,'af','Dokument Eienskappe',0),(32951,916,'ro','ProprietÄƒÅ£i document',0),(32952,916,'et','Dokumendi atribuudid',0),(32953,916,'si','Lastnosti dokumenta',0),(32954,916,'ba','Properti dokumen',0),(32955,916,'nl','Documenteigenschappen',0),(32956,916,'fi','Asiakirjan ominaisuudet',0),(32957,916,'no','Dokumentegenskaper',0),(32958,916,'da','Dokumentegenskaber',0),(32959,916,'ko','ë¬¸ì„œ ì†ì„±',0),(32960,916,'he','×ž××¤×™×™× ×™ ×ž×¡×ž×š',0),(32961,916,'el','Î™Î´Î¹ÏŒÏ„Î·Ï„ÎµÏ‚ ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(32962,916,'zh','æ–‡æ¡£å±žæ€§\r\n',0),(32963,916,'sv','Dokumentegenskaper',0),(32964,916,'it','ProprietÃ  documento',0),(32965,916,'tl','',0),(32966,916,'th','&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;&#3586;&#3629;&#3591;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(32967,916,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤—à¥à¤£',0),(32968,916,'ms','Sifat-sifat dokumen',0),(32969,916,'ar','Ø®ØµØ§Ø¦Øµ Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(32970,916,'fr','PropriÃ©tÃ©s du document',0),(32971,916,'jp','æ–‡æ›¸ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£',0),(32972,916,'pt','Propriedades do documento',0),(32973,916,'ru','Ð¡Ð²Ð¾Ð¹ÑÑ‚Ð²Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(32974,916,'es','CaracterÃ­stcas de Documento',0),(32975,916,'de','Dokumenteigenschaften',0),(32976,916,'en','Document Properties',0),(32977,917,'is','',0),(32978,917,'dr','( Ø§ØµÙ„Ø§Ø­ )   Ø³Ù†Ø¯',0),(32979,917,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± ( Ø§ØµÙ„Ø§Ø­ )   Ø³Ù†Ø¯',0),(32980,917,'tr','Belge geÃ§miÅŸi',0),(32981,917,'pl','Historia zmian dokumentu',0),(32982,917,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð²ÐµÑ€ÑÐ¸Ð¸Ñ‚Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(32983,917,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(32984,917,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(32985,917,'vi','Lá»‹ch sá»­ chá»‰nh sá»­a TÃ i liá»‡u',0),(32986,917,'af','Dokument hersieningsgeskiedenis',0),(32987,917,'ro','Istoria de revizuirea documentului',0),(32988,917,'et','Dokumendi lÃ¤bivaatuse ajalugu',0),(32989,917,'si','Zgodovina revizij dokumenta',0),(32990,917,'ba','Riwayat revisi dokumen',0),(32991,917,'nl','Document revisiegeschiedenis',0),(32992,917,'fi','Asiakirjan versiohistorian',0),(32993,917,'no','Dokumentet revisjonslogger',0),(32994,917,'da','Dokument revisionsoversigten',0),(32995,917,'ko','ë¬¸ì„œ ë²„ì „ ê¸°ë¡',0),(32996,917,'he','×”×™×¡×˜×•×¨×™×™×ª ×”×ž×¡×ž×š',0),(32997,917,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(32998,917,'zh','æ–‡æ¡£å›žé¡¾åŽ†å²\r\n',0),(32999,917,'sv','Versionshistorik fÃ¶r dokument',0),(33000,917,'it','Cronologia delle revisioni documento',0),(33001,917,'tl','',0),(33002,917,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(33003,917,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(33004,917,'ms','Sejarah semakan dokumen',0),(33005,917,'ar','ØªØ§Ø±ÙŠØ® Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(33006,917,'fr','Document historique des rÃ©visions',0),(33007,917,'jp','æ–‡æ›¸è¨‚æ­£å±¥æ­´',0),(33008,917,'pt','HistÃ³rico de revisÃ£o de documento',0),(33009,917,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð²ÐµÑ€ÑÐ¸Ð¹ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(33010,917,'es','Documento Historia de RevisiÃ³n',0),(33011,917,'de','Dokument Revision History',0),(33012,917,'en','Document Revision History',0),(33013,918,'is','',0),(33014,918,'dr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(33015,918,'pr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(33016,918,'tr','Belge baÅŸarÄ±yla eklendi',0),(33017,918,'pl','Dokument dodano pomyÅ›lnie',0),(33018,918,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸',0),(33019,918,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(33020,918,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(33021,918,'vi','ThÃªm TÃ i liá»‡u thÃ nh cÃ´ng',0),(33022,918,'af','Dokument suksesvol bygevoeg',0),(33023,918,'ro','Documentul adÄƒugat cu succes',0),(33024,918,'et','Dokumendi lisamine Ãµnnestus',0),(33025,918,'si','Dokument, ki uspeÅ¡no dodane',0),(33026,918,'ba','Dokumen yang berhasil ditambahkan',0),(33027,918,'nl','Document met succes toegevoegd',0),(33028,918,'fi','Asiakirjan lisÃ¤Ã¤minen onnistui',0),(33029,918,'no','Dokument lagt',0),(33030,918,'da','Dokument tilfÃ¸jet',0),(33031,918,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ë¬¸ì„œ',0),(33032,918,'he','×ž×¡×ž×š × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(33033,918,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯',0),(33034,918,'zh','æ–‡æ¡£æ·»åŠ æˆåŠŸ\r\n',0),(33035,918,'sv','Dokument som har lagts till',0),(33036,918,'it','Documento aggiunto correttamente',0),(33037,918,'tl','',0),(33038,918,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(33039,918,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(33040,918,'ms','Dokumen berjaya ditambah',0),(33041,918,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(33042,918,'fr','Document ajoutÃ© avec succÃ¨s',0),(33043,918,'jp','æ–‡æ›¸ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(33044,918,'pt','Documento adicionado com sucesso',0),(33045,918,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(33046,918,'es','Documento Agregado Exitosamente',0),(33047,918,'de','Dokument erfolgreich hinzugefÃ¼gt',0),(33048,918,'en','Document successfully added',0),(33049,919,'is','',0),(33050,919,'dr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(33051,919,'pr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(33052,919,'tr','Belge baÅŸarÄ±yla kontrol',0),(33053,919,'pl','Dokument pomyÅ›lnie sprawdzone',0),(33054,919,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð²ÐºÐ°Ñ€Ð°Ð½',0),(33055,919,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾Ú‘ØªØ§Ù„',0),(33056,919,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ð¾',0),(33057,919,'vi','TÃ i liá»‡u vÃ o thÃ nh cÃ´ng',0),(33058,919,'af','Dokument suksesvol ingeteken',0),(33059,919,'ro','Documentului arhivat cu succes',0),(33060,919,'et','Edukalt sisse mÃ¶llida dokumendi',0),(33061,919,'si','UspeÅ¡no preveriti dokument',0),(33062,919,'ba','Dokumen yang berhasil diperiksa di',0),(33063,919,'nl','Document met succes gecontroleerd',0),(33064,919,'fi','Asiakirjan onnistuneesti tarkastetaan',0),(33065,919,'no','Dokumentet ble sjekket inn',0),(33066,919,'da','Dokumentet blev tjekket',0),(33067,919,'ko','ë¬¸ì„œë¥¼ ì„±ê³µì ìœ¼ë¡œ ì²´í¬ ì¸',0),(33068,919,'he','×”×ž×¡×ž×š ×”×•×›× ×¡ ×‘×”×¦×œ×—×”',0),(33069,919,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ»ÎµÎ³Ï‡Î¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(33070,919,'zh','æˆåŠŸç­¾å…¥æ–‡ä»¶\r\n',0),(33071,919,'sv','Dokument som framgÃ¥ngsrikt checkas in',0),(33072,919,'it','Documento controllato con successo',0),(33073,919,'tl','',0),(33074,919,'th','&#3609;&#3635;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(33075,919,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤šà¥‡à¤• à¤®à¥‡à¤‚',0),(33076,919,'ms','Dokumen berjaya didaftar masuk',0),(33077,919,'ar','Ø§Ù„ÙˆØ«ÙŠÙ‚Ø© Ø§Ù„ØªØ­Ù‚Ù‚ Ø¨Ù†Ø¬Ø§Ø­',0),(33078,919,'fr','Document archivÃ© avec succÃ¨s',0),(33079,919,'jp','æ–‡æ›¸ã?Œãƒ?ã‚§ãƒƒã‚¯ã‚¤ãƒ³ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(33080,919,'pt','Documento com Ãªxito check-in',0),(33081,919,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½',0),(33082,919,'es','Documento regresado exitosamente',0),(33083,919,'de','Dokument erfolgreich eingecheckt',0),(33084,919,'en','Document successfully checked in',0),(33085,920,'is','',0),(33086,920,'dr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(33087,920,'pr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(33088,920,'tr','Belge baÅŸarÄ±yla silindi',0),(33089,920,'pl','PomyÅ›lnie usuniÄ™to dokument',0),(33090,920,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(33091,920,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ù†ÛÛŒÚº Ú©ÛŒ',0),(33092,920,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(33093,920,'vi','XÃ³a TÃ i liá»‡u thÃ nh cÃ´ng',0),(33094,920,'af','Dokument Suksesvol Geskrap',0),(33095,920,'ro','Document ÅŸters cu succes',0),(33096,920,'et','Dokument on edukalt kustutatud',0),(33097,920,'si','UspeÅ¡no izbrisan dokument',0),(33098,920,'ba','Dokumen yang berhasil dihapus.',0),(33099,920,'nl','Document met succes verwijderd',0),(33100,920,'fi','Asiakirja poistettu',0),(33101,920,'no','Dokumentet ble slettet',0),(33102,920,'da','Dokumentet blev slettet',0),(33103,920,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ëœ ë¬¸ì„œ',0),(33104,920,'he','×”×ž×¡×ž×š ×ž×—×§ ×‘×”×¦×œ×—×”',0),(33105,920,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Ï€Î¿Ï… Î´Î¹Î­Î³ÏÎ±ÏˆÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(33106,920,'zh','æ–‡ä»¶å·²æˆåŠŸåˆ é™¤\r\n',0),(33107,920,'sv','Dokumentet har tagits bort',0),(33108,920,'it','Documento eliminato correttamente',0),(33109,920,'tl','',0),(33110,920,'th','&#3621;&#3610;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(33111,920,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(33112,920,'ms','Dokumen yang berjaya dihapuskan',0),(33113,920,'ar','Ø­Ø°Ù Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(33114,920,'fr','Document supprimÃ© avec succÃ¨s',0),(33115,920,'jp','æ–‡æ›¸ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(33116,920,'pt','Documento excluÃ­do com Ãªxito',0),(33117,920,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(33118,920,'es','Documento eliminado exitosamente',0),(33119,920,'de','Dokument erfolgreich gelÃ¶scht',0),(33120,920,'en','Document successfully deleted',0),(33121,921,'is','',0),(33122,921,'dr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(33123,921,'pr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(33124,921,'tr','Belge baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(33125,921,'pl','Dokument pomyÅ›lnie zaktualizowane',0),(33126,921,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½',0),(33127,921,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(33128,921,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(33129,921,'vi','TÃ i Liá»‡u Cáº­p Nháº­t thÃ nh cÃ´ng',0),(33130,921,'af','Dokument suksesvol opdateer',0),(33131,921,'ro','Document actualizat cu succes',0),(33132,921,'et','Dokument on vÃ¤rskendatud',0),(33133,921,'si','Dokument, ki uspeÅ¡no posodobljen',0),(33134,921,'ba','Dokumen yang berhasil diperbarui',0),(33135,921,'nl','Document met succes bijgewerkt',0),(33136,921,'fi','Asiakirja pÃ¤ivitetty',0),(33137,921,'no','Dokumentet er oppdatert',0),(33138,921,'da','Dokumentet blev opdateret',0),(33139,921,'ko','ë¬¸ì„œ ì—…ë°ì´íŠ¸',0),(33140,921,'he','×ž×¡×ž×š ×ž×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(33141,921,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(33142,921,'zh','æ–‡ä»¶å·²æˆåŠŸæ›´æ–°\r\n',0),(33143,921,'sv','Dokumentet uppdaterades',0),(33144,921,'it','Documento aggiornato correttamente',0),(33145,921,'tl','',0),(33146,921,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(33147,921,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(33148,921,'ms','Dokumen berjaya dikemaskini',0),(33149,921,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(33150,921,'fr','Document mis Ã  jour',0),(33151,921,'jp','æ–‡æ›¸ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(33152,921,'pt','Documento atualizado com sucesso',0),(33153,921,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(33154,921,'es','Documento actualizado exitosamente',0),(33155,921,'de','Dokument erfolgreich aktualisiert',0),(33156,921,'en','Document successfully updated',0),(33157,922,'is','',0),(33158,922,'dr','( Ø¨Ø±Ø±Ø³ÙŠ )  Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(33159,922,'pr','Ù…Ø¯Ø§Ø±Ùƒ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§ ØªØ³ÙˆÙŠÙ‡( Ø¨Ø±Ø±Ø³ÙŠ )  Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(33160,922,'tr','Belge kullanÄ±ma',0),(33161,922,'pl','dokument(-y) wyewidencjonowane dla Ciebie',0),(33162,922,'bg','Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚(Ð¸), Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½ Ð¿Ñ€Ð¸ Ð²Ð°Ñ',0),(33163,922,'ur','Ù…Ø¸Ø§ÛØ± Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª Ø¢Ù¾ Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø± Ø¯ÛŒØ§',0),(33164,922,'sr','Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð° Ñ˜Ðµ Ð¾Ð´Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð° Ð½Ð° Ð²Ð°Ñ',0),(33165,922,'vi','tÃ i liá»‡u Ä‘Æ°a ra cho báº¡n',0),(33166,922,'af','dokument(e) aan u uitgeteken',0),(33167,922,'ro','document(e) verificat pentru tine',0),(33168,922,'et','dokumente mÃ¶llitakse teile',0),(33169,922,'si','dokumente, ki so rezervirani za vas',0),(33170,922,'ba','memeriksa dokumen Anda',0),(33171,922,'nl','voor u uitgecheckt (de) document(en)',0),(33172,922,'fi','kuitattu ulos sinulle asiakirjat',0),(33173,922,'no','dokumentet sjekket ut til deg',0),(33174,922,'da','dokumenter, der er tjekket ud til dig',0),(33175,922,'ko','ë¬¸ì„œ ì²´í¬ ì•„ì›ƒ',0),(33176,922,'he','×ž×¡×ž×›×™× ×ž××—×¡×•×Ÿ ×‘×©×‘×™×œ×š',0),(33177,922,'el','Î­Î³Î³ÏÎ±Ï†Î± Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ»ÎµÎ³Ï‡Î¸ÎµÎ¯ ÏƒÎµ ÏƒÎ±Ï‚',0),(33178,922,'zh','æ–‡ä»¶ç­¾å‡ºç»™æ‚¨\r\n',0),(33179,922,'sv','dokumentet utcheckat till dig',0),(33180,922,'it','documenti estratti',0),(33181,922,'tl','',0),(33182,922,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3629;&#3629;&#3585;&#3652;&#3611;&#3626;&#3641;&#3656;&#3588;&#3640;&#3603;&#3649;&#3621;&#3657;&#3623;',0),(33183,922,'hi','à¤†à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤šà¥‡à¤• à¤†à¤‰à¤Ÿ',0),(33184,922,'ms','Identification menyemak untuk anda',0),(33185,922,'ar','Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø£Ùˆ Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª Ù‚ÙŠØ¯ Ø§Ù„Ø³Ø­Ø¨ Ù„Ùƒ',0),(33186,922,'fr','document (s) extrait pour vous',0),(33187,922,'jp','æ–‡æ›¸ã?Œãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?•ã‚Œã?¾ã?—ã?Ÿ',0),(33188,922,'pt','documento (s) check-out para vocÃª',0),(33189,922,'ru','Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(33190,922,'es','Documento (s) Emitido (s) a usted',0),(33191,922,'de','Dokumente, die Sie ausgecheckt',0),(33192,922,'en','document(s) checked out to you',0),(33193,923,'is','',0),(33194,923,'dr','( Ø¨Ø±Ø±Ø³ÙŠ )Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(33195,923,'pr','Ù…Ø¯Ø§Ø±ÙƒÙŠ ÙƒÙ‡ Ø§Ø®ÙŠØ±Ø§ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§ ØªØ³ÙˆÙŠÙ‡ ( Ø¨Ø±Ø±Ø³ÙŠ )Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(33196,923,'tr','Åžu anda kullanÄ±ma belgeler',0),(33197,923,'pl','Dokumenty obecnie wyewidencjonowane dla Ciebie',0),(33198,923,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸, ÐºÐ¾Ð¸Ñ‚Ð¾ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° ÑÐ° Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸ Ð¿Ñ€Ð¸ Ð²Ð°Ñ',0),(33199,923,'ur','Ø§Ø³ ÙˆÙ‚Øª Ø¢Ù¾ Ú©Û’ Ù„Ø¦Û’ Ø®Ø§Ø±Ø¬ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(33200,923,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð° Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð¾Ð´Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð° Ð½Ð° Ð²Ð°Ñ',0),(33201,923,'vi','TÃ i liá»‡u hiá»‡n nay Ä‘Æ°a ra cho báº¡n',0),(33202,923,'af','Dokumente Huidiglik aan u Uitgeteken',0),(33203,923,'ro','Documentele Ã®n prezent verificat pentru tine',0),(33204,923,'et','Praegu teile vÃ¤ljamÃ¶llitud dokumendid',0),(33205,923,'si','Dokumenti, ki so trenutno rezervirani za vas',0),(33206,923,'ba','Dokumen-dokumen yang sedang memeriksa untuk Anda',0),(33207,923,'nl','Documenten momenteel uitgecheckt aan u',0),(33208,923,'fi','Kuitattu ulos sinulle asiakirjat',0),(33209,923,'no','Dokumenter som er sjekket ut til deg',0),(33210,923,'da','Dokumenter i Ã¸jeblikket tjekket ud til dig',0),(33211,923,'ko','í˜„ìž¬ ë‹¹ì‹ ì— ê²Œ ì²´í¬ ì•„ì›ƒ ëœ ë¬¸ì„œ',0),(33212,923,'he','×ž×¡×ž×›×™× ×›×¢×ª ×ž××—×¡×•×Ÿ ×‘×©×‘×™×œ×š',0),(33213,923,'el','ÎˆÎ³Î³ÏÎ±Ï†Î± Ï€Î¿Ï… ÎµÏ€Î¯ Ï„Î¿Ï… Ï€Î±ÏÏŒÎ½Ï„Î¿Ï‚ Ï„Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿',0),(33214,923,'zh','ç›®å‰æ–‡ä»¶ç­¾å‡ºç»™æ‚¨\r\n',0),(33215,923,'sv','Dokument utcheckat till dig',0),(33216,923,'it','Documenti attualmente estratti',0),(33217,923,'tl','',0),(33218,923,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3629;&#3629;&#3585;&#3652;&#3611;&#3626;&#3641;&#3656;&#3588;&#3640;&#3603;&#3649;&#3621;&#3657;&#3623;',0),(33219,923,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤ª à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤šà¥‡à¤•à¥à¤¡ à¤†à¤‰à¤Ÿ',0),(33220,923,'ms','Dokumen-dokumen yang sedang menyemak untuk anda',0),(33221,923,'ar','Ø§Ù„ÙˆØ«Ø§Ø¦Ù‚ Ø­Ø§Ù„ÙŠØ§ Ø§Ù„Ø³Ø­Ø¨ Ø¨Ø§Ù„Ù†Ø³Ø¨Ø© Ù„Ùƒ',0),(33222,923,'fr','Documents actuellement extraits pour vous',0),(33223,923,'jp','æ–‡æ›¸ã?Œãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(33224,923,'pt','Documentos atualmente, Check-Out para vocÃª',0),(33225,923,'ru','ÐÐ°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð²Ñ‹Ð¿Ð¸ÑÐ°Ð½ Ð²Ð°Ð¼ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(33226,923,'es','Documento (s) Actualmente Emitido (s) a usted',0),(33227,923,'de','Dokumente, die derzeit fÃ¼r Sie ausgecheckt',0),(33228,923,'en','Documents Currently Checked Out To You',0),(33229,924,'is','',0),(33230,924,'dr','Ø§Ø² ÙŠÙƒ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¯ÙŠÚ¯Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†ÙƒÙ†ÙŠØ¯ ',0),(33231,924,'pr','Ø§Ø² ÙŠÙƒ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¯ÙŠÚ¯Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†ÙƒÙ†ÙŠØ¯ ',0),(33232,924,'tr','DiÄŸer fiyat listesini kullanmaz',0),(33233,924,'pl','Nie uÅ¼ywaÄ‡ innych Cennik',0),(33234,924,'bg','ÐÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(33235,924,'ur','Ø¯ÛŒÚ¯Ø± Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù†ÛÛŒÚº Ú©Ø±ØªØ§ Û”',0),(33236,924,'sr','ÐÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð´Ñ€ÑƒÐ³Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(33237,924,'vi','KhÃ´ng dÃ¹ng báº£ng giÃ¡ khÃ¡c',0),(33238,924,'af','Gebruik Nie Ander Pryslys',0),(33239,924,'ro','Nu folosi alte lista de preturi',0),(33240,924,'et','Kasutada muid hinnakiri',0),(33241,924,'si','Uporabljajte drugih cenik',0),(33242,924,'ba','Tidak menggunakan daftar harga lainnya',0),(33243,924,'nl','Maakt geen gebruik van andere prijslijst',0),(33244,924,'fi','Ei kÃ¤ytÃ¤ muita hinnasto',0),(33245,924,'no','Bruker ikke andre prisliste',0),(33246,924,'da','Bruger ikke andre prisliste',0),(33247,924,'ko','ë‹¤ë¥¸ ê°€ê²© ë¦¬ìŠ¤íŠ¸ë¥¼ ì‚¬ìš© í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(33248,924,'he','××™× ×• ×ž×©×ª×ž×© ××—×¨×™× ×ž×—×™×¨×•×Ÿ',0),(33249,924,'el','Î”ÎµÎ½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯ Î¬Î»Î»Î· Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½',0),(33250,924,'zh','ä¸ä½¿ç”¨å…¶ä»–ä»·æ ¼è¡¨\r\n',0),(33251,924,'sv','AnvÃ¤nder inte andra prislista',0),(33252,924,'it','Non utilizzare altri Listino',0),(33253,924,'tl','',0),(33254,924,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3629;&#3639;&#3656;&#3609;&#3652;&#3604;&#3657;',0),(33255,924,'hi','à¤…à¤¨à¥à¤¯ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(33256,924,'ms','Tidak menggunakan senarai harga lain',0),(33257,924,'ar','Ù„Ø§ ØªØ³ØªØ®Ø¯Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø£Ø®Ø±Ù‰',0),(33258,924,'fr','N\'utilise pas d\'autre liste de prix',0),(33259,924,'jp','ä»–ã?®ä¾¡æ ¼è¡¨ã‚’ä½¿ç”¨ã?—ã?ªã?„',0),(33260,924,'pt','NÃ£o usa outra lista de preÃ§o',0),(33261,924,'ru','ÐÐµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¸Ðµ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(33262,924,'es','No Usa Otra Lista de Precios',0),(33263,924,'de','Andere Preisliste wird nicht verwendet werden.',0),(33264,924,'en','Does Not Use Other Price List',0),(33265,925,'is','',0),(33266,925,'dr','Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(33267,925,'pr','Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(33268,925,'tr','mevcut deÄŸil.',0),(33269,925,'pl','nie istnieje.',0),(33270,925,'bg','Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°.',0),(33271,925,'ur','Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº Û”',0),(33272,925,'sr','ÐÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(33273,925,'vi','khÃ´ng tá»“n táº¡i',0),(33274,925,'af','bestaan nie.',0),(33275,925,'ro','nu exista.',0),(33276,925,'et','pole olemas.',0),(33277,925,'si','ne obstaja.',0),(33278,925,'ba','tidak ada.',0),(33279,925,'nl','bestaat niet.',0),(33280,925,'fi','ei ole olemassa.',0),(33281,925,'no','finnes ikke.',0),(33282,925,'da','findes ikke.',0),(33283,925,'ko','ì¡´ìž¬ í•˜ì§€ ì•ŠëŠ”ë‹¤.',0),(33284,925,'he','×œ× ×§×™×™×.',0),(33285,925,'el','Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹.',0),(33286,925,'zh','ä¸å­˜åœ¨ã€‚\r\n',0),(33287,925,'sv','finns inte.',0),(33288,925,'it','non esiste.',0),(33289,925,'tl','',0),(33290,925,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(33291,925,'hi','à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(33292,925,'ms','tidak wujud.',0),(33293,925,'ar','ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯.',0),(33294,925,'fr','n\'existe pas.',0),(33295,925,'jp','å­˜åœ¨ã?—ã?¾ã?›ã‚“',0),(33296,925,'pt','NÃ£o existe.',0),(33297,925,'ru','Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚.',0),(33298,925,'es','no existe',0),(33299,925,'de','ist nicht vorhanden.',0),(33300,925,'en','does not exist.',0),(33301,926,'is','',0),(33302,926,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ù„Ø§Ø± ',0),(33303,926,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ù„Ø§Ø± ',0),(33304,926,'tr','TutarÄ±',0),(33305,926,'pl','Kwoty w dolarach',0),(33306,926,'bg','Ð¡ÑƒÐ¼Ð° Ð´Ð¾Ð»Ð°Ñ€',0),(33307,926,'ur','ÚˆØ§Ù„Ø± Ú©ÛŒ Ù‚Ø¯Ø±',0),(33308,926,'sr','Ð”Ð¾Ð»Ð°Ñ€ÑÐºÐ¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(33309,926,'vi','Sá»‘ tiá»n dola',0),(33310,926,'af','Dollar bedrag',0),(33311,926,'ro','Dolar suma',0),(33312,926,'et','Dollari suuruse',0),(33313,926,'si','Dolar znesek',0),(33314,926,'ba','Jumlah dolar',0),(33315,926,'nl','Bedrag in dollars',0),(33316,926,'fi','Dollarin summa',0),(33317,926,'no','PengebelÃ¸p',0),(33318,926,'da','Dollar belÃ¸b',0),(33319,926,'ko','ë‹¬ëŸ¬ ê¸ˆì•¡',0),(33320,926,'he','×¡×›×•× ×›×¡×£',0),(33321,926,'el','Î Î¿ÏƒÏŒ ÏƒÎµ Î´Î¿Î»Î¬ÏÎ¹Î±',0),(33322,926,'zh','é‡‘é¢\r\n',0),(33323,926,'sv','Dollarn belopp',0),(33324,926,'it','Importo in dollari',0),(33325,926,'tl','',0),(33326,926,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3604;&#3629;&#3621;&#3621;&#3656;&#3634;&#3619;&#3660;',0),(33327,926,'hi','à¤¡à¥‰à¤²à¤° à¤•à¥€ à¤°à¤¾à¤¶à¤¿',0),(33328,926,'ms','Amaun dolar yang',0),(33329,926,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¯ÙÙˆØ¹ Ø¨Ø§Ù„Ø¯ÙˆÙ„Ø§Ø±',0),(33330,926,'fr','Montant en dollars',0),(33331,926,'jp','ãƒ‰ãƒ«ç·?é¡?',0),(33332,926,'pt','Quantidade de dÃ³lar',0),(33333,926,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð² Ð´Ð¾Ð»Ð»Ð°Ñ€Ð°Ñ…',0),(33334,926,'es','Monto en DÃ³lares',0),(33335,926,'de','Dollar-Betrag',0),(33336,926,'en','Dollar Amount',0),(33337,927,'is','',0),(33338,927,'dr','Ø¯Ù„Ø§Ø±',0),(33339,927,'pr','Ø¯Ù„Ø§Ø±',0),(33340,927,'tr','Dolar',0),(33341,927,'pl','DolarÃ³w',0),(33342,927,'bg','Ð”Ð¾Ð»Ð°Ñ€Ð°',0),(33343,927,'ur','ÚˆØ§Ù„Ø±',0),(33344,927,'sr','Ð”Ð¾Ð»Ð°Ñ€Ð°',0),(33345,927,'vi','Dola',0),(33346,927,'af','Dollars',0),(33347,927,'ro','De dolari',0),(33348,927,'et','Eurot',0),(33349,927,'si','Dolarjev',0),(33350,927,'ba','Dolar',0),(33351,927,'nl','Dollar',0),(33352,927,'fi','Dollaria',0),(33353,927,'no','Dollar',0),(33354,927,'da','Dollars',0),(33355,927,'ko','ë‹¬ëŸ¬',0),(33356,927,'he','×“×•×œ×¨×™×',0),(33357,927,'el','Î”Î¿Î»Î¬ÏÎ¹Î±',0),(33358,927,'zh','ç¾Žå…ƒ',0),(33359,927,'sv','Dollar',0),(33360,927,'it','Dollari',0),(33361,927,'tl','',0),(33362,927,'th','&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;',0),(33363,927,'hi','à¤¡à¥‰à¤²à¤°',0),(33364,927,'ms','Dolar',0),(33365,927,'ar','Ø¯ÙˆÙ„Ø§Ø± Ø£Ù…Ø±ÙŠÙƒÙŠ',0),(33366,927,'fr','Dollars',0),(33367,927,'jp','Dollars',0),(33368,927,'pt','DÃ³lares',0),(33369,927,'ru','Ð”Ð¾Ð»Ð»Ð°Ñ€Ð¾Ð²',0),(33370,927,'es','DÃ³lares',0),(33371,927,'de','Dollar',0),(33372,927,'en','Dollars',0),(33373,928,'is','',0),(33374,928,'dr','Ø¯Ù„Ø§Ø±   Ùˆ ',0),(33375,928,'pr','Ø¯Ù„Ø§Ø±   Ùˆ ',0),(33376,928,'tr','dolar ve',0),(33377,928,'pl','dolarÃ³w i',0),(33378,928,'bg','Ð´Ð¾Ð»Ð°Ñ€Ð° Ð¸',0),(33379,928,'ur','ÚˆØ§Ù„Ø± Ø§ÙˆØ±',0),(33380,928,'sr','Ð´Ð¾Ð»Ð°Ñ€Ð° Ð¸',0),(33381,928,'vi','dola & ',0),(33382,928,'af','dollars en',0),(33383,928,'ro','de dolari ÅŸi',0),(33384,928,'et','Eurot ja',0),(33385,928,'si','dolarjev in',0),(33386,928,'ba','dolar dan',0),(33387,928,'nl','dollar en',0),(33388,928,'fi','dollaria ja',0),(33389,928,'no','dollar og',0),(33390,928,'da','dollars og',0),(33391,928,'ko','ë‹¬ëŸ¬ì™€',0),(33392,928,'he','×“×•×œ×¨ ×•',0),(33393,928,'el','Î´Î¿Î»Î¬ÏÎ¹Î± ÎºÎ±Î¹',0),(33394,928,'zh','ç¾Žå…ƒå’Œ\r\n',0),(33395,928,'sv','dollar och',0),(33396,928,'it','dollari e',0),(33397,928,'tl','',0),(33398,928,'th','&#3648;&#3591;&#3636;&#3609;&#3604;&#3629;&#3621;&#3621;&#3656;&#3634;&#3619;&#3660; &#3649;&#3621;&#3632;',0),(33399,928,'hi','à¤¡à¥‰à¤²à¤° à¤”à¤°',0),(33400,928,'ms','ringgit dan',0),(33401,928,'ar','Ø¯ÙˆÙ„Ø§Ø± Ø£Ù…Ø±ÙŠÙƒÙŠ Ùˆ',0),(33402,928,'fr','dollars et',0),(33403,928,'jp','ãƒ‰ãƒ«ã?¨',0),(33404,928,'pt','dÃ³lares e',0),(33405,928,'ru','Ð´Ð¾Ð»Ð»Ð°Ñ€Ð¾Ð² Ð¸',0),(33406,928,'es','DÃ³lares y',0),(33407,928,'de','Dollar und',0),(33408,928,'en','dollars and',0),(33409,929,'is','',0),(33410,929,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨',0),(33411,929,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨',0),(33412,929,'tr','Download hesap listesi',0),(33413,929,'pl','Pobierz listy kont',0),(33414,929,'bg','Ð¸Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð¿Ñ€Ð¾Ñ„Ð¸Ð» ÑÐ¿Ð¸ÑÑŠÐº',0),(33415,929,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ ÙÛØ±Ø³Øª ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(33416,929,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(33417,929,'vi','táº£i danh sÃ¡ch TK',0),(33418,929,'af','aflaai van rekeninglys',0),(33419,929,'ro','Descarca lista de cont',0),(33420,929,'et','Lae loend',0),(33421,929,'si','Download raÄun seznam',0),(33422,929,'ba','men-download daftar account',0),(33423,929,'nl','Accountlijst downloaden',0),(33424,929,'fi','Imuroi tilin luettelo',0),(33425,929,'no','Last ned kontolisten',0),(33426,929,'da','Download kontolisten',0),(33427,929,'ko','ê³„ì • ëª©ë¡ ë‹¤ìš´ë¡œë“œ',0),(33428,929,'he','×¨×©×™×ž×ª ×ª×™×§×™ ×œ×§×•×—×•×ª ×œ×”×•×¨×“×”',0),(33429,929,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(33430,929,'zh','ä¸‹è½½å¸æˆ·åå•\r\n',0),(33431,929,'sv','HÃ¤mta kontolista',0),(33432,929,'it','Scarica elenco account',0),(33433,929,'tl','',0),(33434,929,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(33435,929,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¥‚à¤šà¥€ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(33436,929,'ms','Muat turun senarai akaun',0),(33437,929,'ar','ØªØ­Ù…ÙŠÙ„ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(33438,929,'fr','TÃ©lÃ©charger la liste des comptes',0),(33439,929,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒªã‚¹ãƒˆã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰',0),(33440,929,'pt','baixar a lista de contas',0),(33441,929,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(33442,929,'es','Descargar lista de cuentas',0),(33443,929,'de','Download-Konto-Liste',0),(33444,929,'en','download account list',0),(33445,930,'is','',0),(33446,930,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒÙ†ÙŠØ¯ ',0),(33447,930,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒÙ†ÙŠØ¯ ',0),(33448,930,'tr','Buradan indirin',0),(33449,930,'pl','Pobierz tutaj',0),(33450,930,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ñ‚ÑƒÐº',0),(33451,930,'ur','ÛŒÛØ§Úº ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(33452,930,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¼Ð¸Ñ‚Ðµ Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´',0),(33453,930,'vi','Táº£i á»Ÿ Ä‘Ã¢y',0),(33454,930,'af','Laai Hier Af',0),(33455,930,'ro','Descarca aici',0),(33456,930,'et','Lae alla siit',0),(33457,930,'si','Prenesete tukaj',0),(33458,930,'ba','Download di sini',0),(33459,930,'nl','Download hier',0),(33460,930,'fi','Lataa tÃ¤stÃ¤',0),(33461,930,'no','Last ned her',0),(33462,930,'da','Download her',0),(33463,930,'ko','ë‹¤ìš´ë¡œë“œëŠ” ì—¬ê¸°ì—',0),(33464,930,'he','×œ×”×•×¨×™×“ ×›××Ÿ',0),(33465,930,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ ÎµÎ´ÏŽ',0),(33466,930,'zh','è¿™é‡Œä¸‹è½½\r\n',0),(33467,930,'sv','Ladda ner hÃ¤r',0),(33468,930,'it','Scarica qui',0),(33469,930,'tl','',0),(33470,930,'th','&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;',0),(33471,930,'hi','à¤¯à¤¹à¤¾à¤ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(33472,930,'ms','Muat turun di sini',0),(33473,930,'ar','ØªØ­Ù…ÙŠÙ„ Ù‡Ù†Ø§',0),(33474,930,'fr','TÃ©lÃ©charger ici',0),(33475,930,'jp','ã?“ã?“ã?«ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã?™ã‚‹',0),(33476,930,'pt','FaÃ§a o download aqui',0),(33477,930,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ Ð·Ð´ÐµÑÑŒ',0),(33478,930,'es','Descargar aquÃ­',0),(33479,930,'de','Download hier',0),(33480,930,'en','Download here',0),(33481,931,'is','',0),(33482,931,'dr','Ø¨Ø¯Ù‡ÙŠ',0),(33483,931,'pr','Ø¨Ø¯Ù‡ÙŠ',0),(33484,931,'tr','Vade',0),(33485,931,'pl','Ze wzglÄ™du',0),(33486,931,'bg','ÐŸÐ°Ð´ÐµÐ¶',0),(33487,931,'ur','ÙˆØ§Ø¬Ø¨',0),(33488,931,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(33489,931,'vi','Äáº¿n háº¡n',0),(33490,931,'af','Verskuldig',0),(33491,931,'ro','Datorate',0),(33492,931,'et','Otse',0),(33493,931,'si','Zapadlosti',0),(33494,931,'ba','Jatuh tempo',0),(33495,931,'nl','Verschuldigd',0),(33496,931,'fi','Asianmukaisesti',0),(33497,931,'no','Forfaller',0),(33498,931,'da','Due',0),(33499,931,'ko','ì¸í•´',0),(33500,931,'he','×œ×¤×¨×¢×•×Ÿ',0),(33501,931,'el','Î”ÎµÏŒÎ½Ï„Ï‰Ï‚',0),(33502,931,'zh','ç”±äºŽ\r\n',0),(33503,931,'sv','PÃ¥ grund av',0),(33504,931,'it','Dovuta',0),(33505,931,'tl','',0),(33506,931,'th','&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(33507,931,'hi','à¤¨à¤¿à¤¯à¤¤',0),(33508,931,'ms','Kena dibayar',0),(33509,931,'ar','Ù…Ø³ØªØ­Ù‚Ø© ÙÙŠ',0),(33510,931,'fr','Due',0),(33511,931,'jp','æœŸé™?',0),(33512,931,'pt','Devida',0),(33513,931,'ru','Ð˜Ð·-Ð·Ð°',0),(33514,931,'es','Vencido',0),(33515,931,'de','FÃ¤llig',0),(33516,931,'en','Due',0),(33517,932,'is','',0),(33518,932,'dr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(33519,932,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(33520,932,'tr','Son Tarih',0),(33521,932,'pl','Termin',0),(33522,932,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶',0),(33523,932,'ur','ÙˆØ§Ø¬Ø¨ ØªØ§Ø±ÛŒØ®',0),(33524,932,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(33525,932,'vi','NgÃ y Äáº¿n háº¡n',0),(33526,932,'af','Datum Verskuldig',0),(33527,932,'ro','Data scadenÅ£ei',0),(33528,932,'et','MaksetÃ¤htaeg',0),(33529,932,'si','Datum zapadlosti',0),(33530,932,'ba','Tanggal jatuh tempo',0),(33531,932,'nl','Vervaldatum',0),(33532,932,'fi','ErÃ¤pÃ¤ivÃ¤',0),(33533,932,'no','Forfallsdatoen',0),(33534,932,'da','Forfaldsdato',0),(33535,932,'ko','ê¸°í•œ',0),(33536,932,'he','×ž×•×¢×“ ×œ×¤×¨×¢×•×Ÿ',0),(33537,932,'el','Î—Î¼/Î½Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(33538,932,'zh','åˆ°æœŸæ—¥\r\n',0),(33539,932,'sv','FÃ¶rfallodatum',0),(33540,932,'it','Data di scadenza',0),(33541,932,'tl','',0),(33542,932,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(33543,932,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(33544,932,'ms','Tarikh akhir',0),(33545,932,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø³ØªØ­Ù‚Ø§Ù‚',0),(33546,932,'fr','Date d\'Ã©chÃ©ance',0),(33547,932,'jp','æœŸæ—¥',0),(33548,932,'pt','Data Devida',0),(33549,932,'ru','ÐŸÐ¾ Ð”Ð°Ñ‚Ðµ',0),(33550,932,'es','Fecha de Vencimiento',0),(33551,932,'de','FÃ¤lligkeitsdatum',0),(33552,932,'en','Due Date',0),(33553,933,'is','',0),(33554,933,'dr','/ Ø²Ù…Ø§Ù† Ø·Ù„Ø¨ ( ØªØ§Ø±ÙŠØ® Ù…ÙˆØ¹Ø¯ / Ø²Ù…Ø§Ù† )',0),(33555,933,'pr','ØªØ§Ø±ÙŠØ® / Ø²Ù…Ø§Ù† Ø·Ù„Ø¨ ( ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ / Ø²Ù…Ø§Ù† )',0),(33556,933,'tr','Son Tarih/Saat',0),(33557,933,'pl','Na czas',0),(33558,933,'bg','Ð”Ð°Ñ‚Ð°/Ñ‡Ð°Ñ',0),(33559,933,'ur','ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ ØªØ§Ø±ÛŒØ®/ÙˆÙ‚Øª',0),(33560,933,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼/Ð²Ñ€ÐµÐ¼Ðµ',0),(33561,933,'vi','NgÃ y Äáº¿n háº¡n/thá»i gian',0),(33562,933,'af','Datum/Tyd Verskuldig',0),(33563,933,'ro','Data/ora scadenÅ£ei',0),(33564,933,'et','TÃ¤htaeg kuupÃ¤ev/kellaaeg',0),(33565,933,'si','Datum/ura zapadlosti',0),(33566,933,'ba','Tanggal/waktu jatuh tempo',0),(33567,933,'nl','Datum/tijd',0),(33568,933,'fi','ErÃ¤Ã¤ntymisen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤/aika',0),(33569,933,'no','Grunn av dato/klokkeslett',0),(33570,933,'da','Due Dato_tidspunkt',0),(33571,933,'ko','ê¸°í•œ ë‚ ì§œ/ì‹œê°„',0),(33572,933,'he','×™×¢×“ ×ª××¨×™×š/×©×¢×”',0),(33573,933,'el','Î—Î¼/Î½Î¹Î±/ÏŽÏÎ±',0),(33574,933,'zh','æˆªæ­¢æ—¥æœŸ/æ—¶é—´\r\n',0),(33575,933,'sv','Datum/tid',0),(33576,933,'it','Scadenza/tempo',0),(33577,933,'tl','',0),(33578,933,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;/&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(33579,933,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•/à¤¸à¤®à¤¯',0),(33580,933,'ms','Masa/tarikh kena dibayar',0),(33581,933,'ar','ØªØ§Ø±ÙŠØ®/ÙˆÙ‚Øª Ø§Ù„Ø¥Ø³ØªØ­Ù‚Ø§Ù‚',0),(33582,933,'fr','Due Date/heure',0),(33583,933,'jp','æœŸé™?æ—¥æ™‚',0),(33584,933,'pt','Data/hora',0),(33585,933,'ru','ÐŸÐ¾ Ð”Ð°Ñ‚Ðµ/Ð’Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(33586,933,'es','Fecha/Tiempo de Vencimiento',0),(33587,933,'de','Due Datum/Uhrzeit',0),(33588,933,'en','Due Date/Time',0),(33589,934,'is','',0),(33590,934,'dr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(33591,934,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(33592,934,'tr','SON TARÄ°H',0),(33593,934,'pl','TERMIN',0),(33594,934,'bg','Ð”ÐÐ¢Ð ÐÐ ÐŸÐÐ”Ð•Ð–',0),(33595,934,'ur','ÙˆØ§Ø¬Ø¨ ØªØ§Ø±ÛŒØ®',0),(33596,934,'sr','ÐšÐ ÐÐˆÐŠÐ˜ Ð ÐžÐš',0),(33597,934,'vi','NgÃ y Äáº¿n háº¡n',0),(33598,934,'af','DATUM VERSKULDIG',0),(33599,934,'ro','DATA SCADENÅ¢EI',0),(33600,934,'et','TÃ„HTAEG',0),(33601,934,'si','DATUM ZAPADLOSTI',0),(33602,934,'ba','TANGGAL JATUH TEMPO',0),(33603,934,'nl','VERVALDATUM',0),(33604,934,'fi','ERÃ„PÃ„IVÃ„',0),(33605,934,'no','FORFALLSDATOEN',0),(33606,934,'da','FORFALDSDATO',0),(33607,934,'ko','ê¸°í•œ',0),(33608,934,'he','×ª××¨×™×š ×™×¢×“',0),(33609,934,'el','Î—Îœ/ÎÎŠÎ‘ Î Î‘Î¡Î†Î”ÎŸÎ£Î—Î£',0),(33610,934,'zh','åˆ°æœŸæ—¥\r\n',0),(33611,934,'sv','FÃ–RFALLODATUM',0),(33612,934,'it','DATA DI SCADENZA',0),(33613,934,'tl','',0),(33614,934,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(33615,934,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(33616,934,'ms','TARIKH AKHIR',0),(33617,934,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(33618,934,'fr','DATE D\'Ã‰CHÃ‰ANCE',0),(33619,934,'jp','æœŸé™?æ—¥',0),(33620,934,'pt','DATA DE VENCIMENTO',0),(33621,934,'ru','Ð”ÐÐ¢Ð',0),(33622,934,'es','FECHA DE VENCIMIENTO',0),(33623,934,'de','FÃ„LLIGKEITSDATUM',0),(33624,934,'en','DUE DATE',0),(33625,935,'is','',0),(33626,935,'dr','( Ù…Ù‚Ø±Ø±)',0),(33627,935,'pr','Ø²Ù…Ø§Ù† Ø¨Ø¯Ù‡ÙŠ( Ù…Ù‚Ø±Ø±)',0),(33628,935,'tr','Son saat',0),(33629,935,'pl','WÅ‚aÅ›ciwym czasie',0),(33630,935,'bg','Ð¡Ð²Ð¾ÐµÐ²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾',0),(33631,935,'ur','Ù…Ù‚Ø±Ø±Û ÙˆÙ‚Øª',0),(33632,935,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð´Ð¾ÑÐ¿ÐµÑ›Ð°',0),(33633,935,'vi','Äáº¿n háº¡n',0),(33634,935,'af','Verskuldigde Tyd',0),(33635,935,'ro','Timpul cuvenit',0),(33636,935,'et','TÃ¤htaja kellaaeg',0),(33637,935,'si','PravoÄasno',0),(33638,935,'ba','Jatuh tempo',0),(33639,935,'nl','Zijner tijd',0),(33640,935,'fi','Aikanaan',0),(33641,935,'no','Forfallstidspunktet',0),(33642,935,'da','Tiden',0),(33643,935,'ko','ì˜ˆì • ì‹œê°„',0),(33644,935,'he','×”×–×ž×Ÿ',0),(33645,935,'el','ÎÏÎ± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(33646,935,'zh','åˆ°æœŸæ—¶é—´\r\n',0),(33647,935,'sv','Tid',0),(33648,935,'it','Tempo debito',0),(33649,935,'tl','',0),(33650,935,'th','&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(33651,935,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¸à¤®à¤¯',0),(33652,935,'ms','Masa matang',0),(33653,935,'ar','Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ù…Ù†Ø§Ø³Ø¨',0),(33654,935,'fr','DÃ©lai d\'attente',0),(33655,935,'jp','æ™‚æœŸ',0),(33656,935,'pt','Devido tempo',0),(33657,935,'ru','ÐŸÐ¾ Ð’Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(33658,935,'es','Tiempo de Vencimiento',0),(33659,935,'de','Zu gegebener Zeit',0),(33660,935,'en','Due Time',0),(33661,936,'is','',0),(33662,936,'dr','.Ù†Ø§Ù… Ø¯ÙŠÚ¯Ø±ÙŠ Ø±Ø§ Ø§Ù…ØªØ­Ø§Ù† ÙƒÙ†ÙŠØ¯ ',0),(33663,936,'pr',' Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ ØªÚ©Ø±Ø§Ø±Ù‰ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ .Ù†Ø§Ù… Ø¯ÙŠÚ¯Ø±ÙŠ Ø±Ø§ Ø§Ù…ØªØ­Ø§Ù† ÙƒÙ†ÙŠØ¯ ',0),(33664,936,'tr','Yinelenen hesap tÃ¼rÃ¼ yok.  BaÅŸka bir ad deneyin.',0),(33665,936,'pl','Istnieje zduplikowane typ konta.  SprÃ³buj innÄ… nazwÄ™.',0),(33666,936,'bg','Ð¡ÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ð½ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ñ‚Ð¸Ð¿.  ÐžÐ¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ñ Ð´Ñ€ÑƒÐ³Ð¾ Ð¸Ð¼Ðµ.',0),(33667,936,'ur','Ù…Ø«Ù†ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù‚Ø³Ù… Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Û”  Ú©ÙˆØ¦ÛŒ Ø¯ÙˆØ³Ø±Ø§ Ù†Ø§Ù… Ú©ÛŒ Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº Û”',0),(33668,936,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚ Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°.  ÐŸÑ€Ð¾Ð±Ð°Ñ˜ Ð´Ñ€ÑƒÐ³Ð¾ Ð¸Ð¼Ðµ.',0),(33669,936,'vi','TrÃ¹ng loáº¡i TK. Thá»­ TÃªn KhÃ¡c',0),(33670,936,'af','Dieselfde Rekeningtipe bestaan.  Probeer \'n ander naam.',0),(33671,936,'ro','Tip de cont duplicat existÄƒ.  ÃŽncercaÈ›i alt nume.',0),(33672,936,'et','Duplikaat konto tÃ¼Ã¼p on olemas.  Proovige mÃµnda muud nime.',0),(33673,936,'si','Obstaja podvojen raÄun tip.  Poskusite drugo ime.',0),(33674,936,'ba','Ada jenis Account duplikat.  Coba nama lain.',0),(33675,936,'nl','Dubbele accounttype bestaat.  Probeer een andere naam.',0),(33676,936,'fi','Kaksoiskappaleiden tilityyppi on olemassa.  Anna nimi.',0),(33677,936,'no','Det finnes dupliserte kontotype.  PrÃ¸v et annet navn.',0),(33678,936,'da','Dublerede kontotype findes.  PrÃ¸v et andet navn.',0),(33679,936,'ko','ì¤‘ë³µ ê³„ì • ìœ í˜•ì´ ì¡´ìž¬í•©ë‹ˆë‹¤.  ë‹¤ë¥¸ ì´ë¦„ì„ ë³´ì‹­ì‹œì˜¤.',0),(33680,936,'he','×¡×•×’ ×”×—×©×‘×•×Ÿ ×”×›×¤×•×œ×™× ×§×™×™×ž×ª.  × ×¡×” ×©× ××—×¨.',0),(33681,936,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€Î¿Ï‚ Ï„ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï.  Î”Î¿ÎºÎ¹Î¼Î¬ÏƒÏ„Îµ Î­Î½Î± Î¬Î»Î»Î¿ ÏŒÎ½Î¿Î¼Î±.',0),(33682,936,'zh','é‡å¤çš„å¸æˆ·ç±»åž‹å­˜åœ¨ã€‚å°è¯•å…¶ä»–åç§°ã€‚\r\n',0),(33683,936,'sv','Det finns dubblerade kontotyp.  Prova ett annat namn.',0),(33684,936,'it','Tipo di Account duplicati esiste.  Provare un altro nome.',0),(33685,936,'tl','',0),(33686,936,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3594;&#3657;&#3635;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623; &#3585;&#3619;&#3640;&#3603;&#3634;&#3621;&#3629;&#3591;&#3594;&#',0),(33687,936,'hi','à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆà¥¤  à¤•à¥‹à¤ˆ à¤…à¤¨à¥à¤¯ à¤¨à¤¾à¤® à¤•à¤¾ à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚à¥¤',0),(33688,936,'ms','Wujud jenis akaun berganda.  Cuba nama lain.',0),(33689,936,'ar','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ù…ÙƒØ±Ø± Ù…ÙˆØ¬ÙˆØ¯.  Ø­Ø§ÙˆÙ„ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ø³Ù… Ø¢Ø®Ø±.',0),(33690,936,'fr','Type de compte en double existe.  Essayez un autre nom.',0),(33691,936,'jp','å?Œã?˜ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—ã?Œå­˜åœ¨ã?—ã?¾ã?™ã€‚åˆ¥ã?®å??å‰?ã?«ã?—ã?¦ä¸‹ã?•ã?„ã€‚',0),(33692,936,'pt','Tipo de conta duplicada existe.  Tente outro nome.',0),(33693,936,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð´ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ‚ ÑÑ‡ÐµÑ‚Ð° Ñ‚Ð¸Ð¿.  ÐŸÐ¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¾Ðµ Ð¸Ð¼Ñ.',0),(33694,936,'es','Duplicado de Tipo de Cuentas existe. Intenta otra vez',0),(33695,936,'de','Doppelte Konto-Typ vorhanden ist.  Versuchen Sie einen anderen Namen.',0),(33696,936,'en','Duplicate Account Type exists.  Try another name.',0),(33697,937,'is','',0),(33698,937,'dr',' Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ ØªÙƒØ±Ø§Ø±ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(33699,937,'pr',' Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ ØªÙƒØ±Ø§Ø±ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(33700,937,'tr','Yinelenen sÄ±ralama sipariÅŸ numarasÄ±',0),(33701,937,'pl','PowtÃ³rzony numer kolejnoÅ›ci sortowania',0),(33702,937,'bg','Ð”ÑƒÐ±Ð»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð·Ð° ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(33703,937,'ur','Ú†Ú¾Ø§Ù†Ù¹ÛŒÚº ØªØ±ØªÛŒØ¨ Ù†Ù…Ø¨Ø± Ù…Ø«Ù†ÛŒ',0),(33704,937,'sr','Ð”ÑƒÐ¿Ð»Ð¸Ñ€Ð°ÑšÐµ Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ˜ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(33705,937,'vi','TrÃ¹ng sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(33706,937,'af','Dupliseer Sorterings Bestelnommer',0),(33707,937,'ro','Duplicat numÄƒrul de ordine sortare',0),(33708,937,'et','Dubleeri sordi jÃ¤rjekorranumber',0),(33709,937,'si','Podvojena Å¡tevilka naloga razvrÅ¡Äanja',0),(33710,937,'ba','Duplikat semacam nomor pesanan',0),(33711,937,'nl','Soort ordernummer dupliceren',0),(33712,937,'fi','Sama Ã¤kÃ¶isesti aste numero',0),(33713,937,'no','Kopiere Sorter ordrenummer',0),(33714,937,'da','Duplikere form ordrenummer',0),(33715,937,'ko','ì •ë ¬ ìˆœì„œ ë²ˆí˜¸ ì¤‘ë³µ',0),(33716,937,'he','×©×›×¤×œ ×ž×¡×¤×¨ ×”×–×ž× ×” ×ž×™×•×Ÿ',0),(33717,937,'el','Î”Î¹Ï€Î»ÏŒÏ„Ï…Ï€Î¿ Î±ÏÎ¾Ï‰Î½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÎ¯Î´Î¿Ï…Ï‚',0),(33718,937,'zh','é‡å¤çš„æŽ’åºé¡ºåºç¼–å·\r\n',0),(33719,937,'sv','Duplicera sortera ordernummer',0),(33720,937,'it','Duplicare il numero di ordine di sorta',0),(33721,937,'tl','',0),(33722,937,'th','&#3648;&#3619;&#3637;&#3618;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3595;&#3657;&#3635;',0),(33723,937,'hi','à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(33724,937,'ms','Salinan nombor pesanan semacam',0),(33725,937,'ar','ØªÙƒØ±Ø§Ø± Ø±Ù‚Ù… ØªØ±ØªÙŠØ¨ Ø§Ù„ÙØ±Ø²',0),(33726,937,'fr','NumÃ©ro d\'ordre de tri en double',0),(33727,937,'jp','å?Œã?˜åˆ†é¡žé †ç•ªå?·',0),(33728,937,'pt','Duplicar o nÃºmero de ordem de classificaÃ§Ã£o',0),(33729,937,'ru','Ð”ÑƒÐ±Ð»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(33730,937,'es','Duplicado NÃºmero de Orden de Sorteo',0),(33731,937,'de','Doppelte Art Bestellnummer',0),(33732,937,'en','Duplicate Sort Order Number',0),(33733,938,'is','',0),(33734,938,'dr','Ù‡Ø±',0),(33735,938,'pr','Ù‡Ø±',0),(33736,938,'tr','Her',0),(33737,938,'pl','KaÅ¼dy',0),(33738,938,'bg','Ð’ÑÐµÐºÐ¸',0),(33739,938,'ur','ÛØ± Ø§ÛŒÚ©',0),(33740,938,'sr','Ð¡Ð²Ð°ÐºÐ¸',0),(33741,938,'vi','Má»—i',0),(33742,938,'af','Elk',0),(33743,938,'ro','Fiecare',0),(33744,938,'et','Iga',0),(33745,938,'si','Vsak',0),(33746,938,'ba','Masing-masing',0),(33747,938,'nl','Elke',0),(33748,938,'fi','Kunkin',0),(33749,938,'no','Hver',0),(33750,938,'da','Hver',0),(33751,938,'ko','ê°',0),(33752,938,'he','×›×œ',0),(33753,938,'el','ÎšÎ¬Î¸Îµ',0),(33754,938,'zh','æ¯ä¸ª\r\n',0),(33755,938,'sv','Varje',0),(33756,938,'it','Ogni',0),(33757,938,'tl','',0),(33758,938,'th','&#3649;&#3605;&#3656;&#3621;&#3632;',0),(33759,938,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤•',0),(33760,938,'ms','Setiap',0),(33761,938,'ar','Ù‚Ø·Ø¹Ø©',0),(33762,938,'fr','Chaque',0),(33763,938,'jp','å?„',0),(33764,938,'pt','Cada',0),(33765,938,'ru','ÐšÐ°Ð¶Ð´Ñ‹Ð¹',0),(33766,938,'es','Cada Uno',0),(33767,938,'de','Jedes',0),(33768,938,'en','Each',0),(33769,939,'is','',0),(33770,939,'dr','Ø§ÙˆÙ„ÙŠÙ‡ ',0),(33771,939,'pr','Ø§ÙˆÙ„ÙŠÙ‡ ',0),(33772,939,'tr','Erken',0),(33773,939,'pl','Na poczÄ…tku',0),(33774,939,'bg','Ð Ð°Ð½Ð¾',0),(33775,939,'ur','Ø³ÙˆÛŒØ±Û’',0),(33776,939,'sr','Ð Ð°Ð½Ð¾',0),(33777,939,'vi','Sá»›m',0),(33778,939,'af','Vroeg',0),(33779,939,'ro','La Ã®nceputul anului',0),(33780,939,'et','Varakult',0),(33781,939,'si','Zgodaj',0),(33782,939,'ba','Awal',0),(33783,939,'nl','Vroeg',0),(33784,939,'fi','Aikaisin',0),(33785,939,'no','Tidlig',0),(33786,939,'da','Tidligt',0),(33787,939,'ko','ì¼ì°',0),(33788,939,'he','×ž×•×§×“×',0),(33789,939,'el','ÎÏ‰ÏÎ¯Ï‚',0),(33790,939,'zh','æ—©æœŸ\r\n',0),(33791,939,'sv','Tidigt',0),(33792,939,'it','All\'inizio',0),(33793,939,'tl','',0),(33794,939,'th','&#3648;&#3619;&#3655;&#3623;&#3585;&#3623;&#3656;&#3634;&#3607;&#3637;&#3656;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(33795,939,'hi','à¤œà¤²à¥à¤¦à¥€',0),(33796,939,'ms','Awal',0),(33797,939,'ar','ÙˆÙ‚Øª Ù…Ø¨ÙƒØ±',0),(33798,939,'fr','DÃ¨s le dÃ©but',0),(33799,939,'jp','åˆ?æœŸ',0),(33800,939,'pt','Cedo',0),(33801,939,'ru','Ð Ð°Ð½Ð¾',0),(33802,939,'es','Temprano',0),(33803,939,'de','FrÃ¼h',0),(33804,939,'en','Early',0),(33805,940,'is','',0),(33806,940,'dr','Ø¯Ø±Ø¢Ù…Ø¯ ÙƒØ³Ø¨ Ø´Ø¯Ù‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(33807,940,'pr','Ø¯Ø±Ø¢Ù…Ø¯ ÙƒØ³Ø¨ Ø´Ø¯Ù‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(33808,940,'tr','KazanÄ±lan gelir kredi',0),(33809,940,'pl','Zarobione kredytowej dochodu',0),(33810,940,'bg','Ð¡Ð¿ÐµÑ‡ÐµÐ»Ð¸Ð» Ð´Ð¾Ñ…Ð¾Ð´ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(33811,940,'ur','Ø¢Ù…Ø¯Ù†ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ù…Ø§Ø¦Û’',0),(33812,940,'sr','Ð—Ð°Ñ€Ð°Ð´Ð¸Ð»Ð¸ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ',0),(33813,940,'vi','Thu Nháº­p Tá»« TÃ­n Dá»¥ng',0),(33814,940,'af','Verdiende Inkomste Krediet',0),(33815,940,'ro','ObÅ£inut venituri Credit',0),(33816,940,'et','Teenitud tulu krediidi',0),(33817,940,'si','ZasluÅ¾eni prihodki kreditne',0),(33818,940,'ba','Memperoleh pendapatan kredit',0),(33819,940,'nl','Verdiende inkomen krediet',0),(33820,940,'fi','Ansaitut tulot luotto',0),(33821,940,'no','Opptjent inntekt kreditt',0),(33822,940,'da','Optjent indkomst kredit',0),(33823,940,'ko','ì†Œë“ ì‹ ìš©ì„ ì–»ì€',0),(33824,940,'he','×ž×–×•×›×” ×”×›× ×¡×” ××©×¨××™',0),(33825,940,'el','ÎšÎµÏÎ´Î¯ÏƒÎµÎ¹ ÎµÎ¹ÏƒÏŒÎ´Î·Î¼Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½',0),(33826,940,'zh','åŠ³åŠ¨æ”¶å…¥ä¿¡ç”¨\r\n',0),(33827,940,'sv','IntjÃ¤nade inkomst kredit',0),(33828,940,'it','Guadagnato credito reddito',0),(33829,940,'tl','',0),(33830,940,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3648;&#3591;&#3636;&#3609;&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3592;&#3634;&#3585;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;',0),(33831,940,'hi','à¤†à¤¯ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤…à¤°à¥à¤œà¤¿à¤¤ à¤•à¤¿à¤¯à¤¾',0),(33832,940,'ms','Kredit pendapatan yang diperolehi',0),(33833,940,'ar','Ø­ØµÙ„ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ø¯Ø®Ù„',0),(33834,940,'fr','A obtenu le crÃ©dit pour revenu de',0),(33835,940,'jp','å‹¤åŠ´æ‰€å¾—æŽ§é™¤',0),(33836,940,'pt','Ganhou crÃ©dito de renda',0),(33837,940,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ð» Ð´Ð¾Ñ…Ð¾Ð´ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(33838,940,'es','CrÃ©dito Basado en Ingresos Devengados',0),(33839,940,'de','Income Credit erworben',0),(33840,940,'en','Earned Income Credit',0),(33841,941,'is','',0),(33842,941,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(33843,941,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(33844,941,'tr','DÃ¼zenle',0),(33845,941,'pl','Edycja',0),(33846,941,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(33847,941,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(33848,941,'sr','Ð£Ñ€ÐµÐ´Ð¸',0),(33849,941,'vi','Chá»‰nh Sá»­a ',0),(33850,941,'af','Redigeer',0),(33851,941,'ro','Editeaza',0),(33852,941,'et','Muuda',0),(33853,941,'si','Urejanje',0),(33854,941,'ba','Mengedit',0),(33855,941,'nl','Bewerken',0),(33856,941,'fi','Muokkaa',0),(33857,941,'no','Rediger',0),(33858,941,'da','Rediger',0),(33859,941,'ko','íŽ¸ì§‘',0),(33860,941,'he','×¢×¨×™×›×”',0),(33861,941,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(33862,941,'zh','ç¼–è¾‘-æœªæ³¨å†Œå’ŒåŒ»ç–—å«ç”ŸæœåŠ¡åˆ°è½»åº¦è¦†ç›–',0),(33863,941,'sv','Redigera',0),(33864,941,'it','Modifica',0),(33865,941,'tl','',0),(33866,941,'th','&#3649;&#3585;&#3657;&#3652;&#3586;',0),(33867,941,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(33868,941,'ms','Edit',0),(33869,941,'ar','ØªØ­Ø±ÙŠØ±',0),(33870,941,'fr','Edit',0),(33871,941,'jp','ç·¨é›†',0),(33872,941,'pt','Editar',0),(33873,941,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(33874,941,'es','Editar',0),(33875,941,'de','Bearbeiten',0),(33876,941,'en','Edit',0),(33877,942,'is','',0),(33878,942,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ¹Ø§Ù„ÙŠØª ',0),(33879,942,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ¹Ø§Ù„ÙŠØª ',0),(33880,942,'tr','Eylem DÃ¼zenle',0),(33881,942,'pl','Edycja akcji',0),(33882,942,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(33883,942,'ur','Ø¹Ù…Ù„ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(33884,942,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(33885,942,'vi','HÃ nh Äá»™ng Chá»‰nh Sá»­a',0),(33886,942,'af','Redigeer Aksie',0),(33887,942,'ro','Editeaza actiune',0),(33888,942,'et','Toimingu redigeerimine',0),(33889,942,'si','Uredite dejanja',0),(33890,942,'ba','Mengedit aksi',0),(33891,942,'nl','Actie bewerken',0),(33892,942,'fi','Muokkaa tehtÃ¤vÃ¤Ã¤',0),(33893,942,'no','Rediger handling',0),(33894,942,'da','Rediger handling',0),(33895,942,'ko','ìž‘ì—… íŽ¸ì§‘',0),(33896,942,'he','×¢×¨×•×š ×¤×¢×•×œ×”',0),(33897,942,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î· Î´ÏÎ¬ÏƒÎ·',0),(33898,942,'zh','ç¼–è¾‘åŠ¨ä½œ\r\n',0),(33899,942,'sv','Redigera Ã¥tgÃ¤rd',0),(33900,942,'it','Modificare l\'azione',0),(33901,942,'tl','',0),(33902,942,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(33903,942,'hi','à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(33904,942,'ms','Edit tindakan',0),(33905,942,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(33906,942,'fr','Modifier l\'Action',0),(33907,942,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã?®ç·¨é›†',0),(33908,942,'pt','Editar aÃ§Ã£o',0),(33909,942,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(33910,942,'es','Editar AcciÃ³n',0),(33911,942,'de','Aktion Bearbeiten',0),(33912,942,'en','Edit Action',0),(33913,943,'is','',0),(33914,943,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(33915,943,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(33916,943,'tr','Varolan bir GL hesabÄ± DÃ¼zenle',0),(33917,943,'pl','Edycja istniejÄ…cego konta GL',0),(33918,943,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰ Ð°ÐºÐ°ÑƒÐ½Ñ‚ GL',0),(33919,943,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(33920,943,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð“Ð›',0),(33921,943,'vi','Sá»­a TK Sá»• CÃ¡i Tá»•ng Há»£p Hiá»‡n Táº¡i',0),(33922,943,'af','Redigeer \'n Bestaande AG Rekening',0),(33923,943,'ro','Edita un cont existent de GL',0),(33924,943,'et','Olemasoleva GL konto',0),(33925,943,'si','Uredi obstojeÄi raÄun GL',0),(33926,943,'ba','Mengedit akun GL',0),(33927,943,'nl','Een bestaande GL-Account bewerken',0),(33928,943,'fi','Muokkaa GL-tiliÃ¤',0),(33929,943,'no','Redigere en eksisterende GL-konto',0),(33930,943,'da','Redigere en eksisterende konto, GL',0),(33931,943,'ko','ê¸°ì¡´ GL ê³„ì • íŽ¸ì§‘',0),(33932,943,'he','×¢×¨×™×›×ª ×—×©×‘×•×Ÿ GL ×§×™×™×',0),(33933,943,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î­Î½Î±Î½ Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ GL',0),(33934,943,'zh','ç¼–è¾‘çŽ°æœ‰GLå¸æˆ·\r\n',0),(33935,943,'sv','Redigera ett befintligt GL-konto',0),(33936,943,'it','Modificare un Account esistente GL',0),(33937,943,'tl','',0),(33938,943,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(33939,943,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ GL à¤–à¤¾à¤¤à¥‡ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(33940,943,'ms','Edit akaun GL yang sedia ada',0),(33941,943,'ar','ØªØ­Ø±ÙŠØ± Ø­Ø³Ø§Ø¨ Ø£Ø³ØªØ§Ø° Ø¹Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(33942,943,'fr','Modifier un compte existant de GL',0),(33943,943,'jp','å­˜åœ¨ã?™ã‚‹GLã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®ç·¨é›†',0),(33944,943,'pt','Editar uma conta existente do GL',0),(33945,943,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÐµÐ¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ GL',0),(33946,943,'es','Editar una Cuenta LM Existente',0),(33947,943,'de','Bearbeiten Sie ein vorhandenes Konto GL',0),(33948,943,'en','Edit an Existing GL Account',0),(33949,944,'is','',0),(33950,944,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ø¯ÙŠÚ¯Ø±',0),(33951,944,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ø¯ÙŠÚ¯Ø±',0),(33952,944,'tr','BaÅŸka bir hesabÄ± DÃ¼zenle',0),(33953,944,'pl','Edycja innego konta',0),(33954,944,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(33955,944,'ur','Ø¯ÙˆØ³Ø±Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(33956,944,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(33957,944,'vi','Sá»­a TK KhÃ¡c',0),(33958,944,'af','Redigeer \'n Ander Rekening',0),(33959,944,'ro','EditaÅ£i un alt cont',0),(33960,944,'et','Teise konto redigeerimine',0),(33961,944,'si','Urejanje drug raÄun',0),(33962,944,'ba','Mengedit Account lain',0),(33963,944,'nl','Een andere Account bewerken',0),(33964,944,'fi','Muokkaa toista tiliÃ¤',0),(33965,944,'no','Redigere en annen konto',0),(33966,944,'da','Redigere en anden konto',0),(33967,944,'ko','ë‹¤ë¥¸ ê³„ì • íŽ¸ì§‘',0),(33968,944,'he','×¢×¨×•×š ×—×©×‘×•×Ÿ × ×•×¡×£',0),(33969,944,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î¬Î»Î»Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(33970,944,'zh','ç¼–è¾‘å¦ä¸€ä¸ªå¸æˆ·\r\n',0),(33971,944,'sv','Redigera ett annat konto',0),(33972,944,'it','Modificare un altro Account',0),(33973,944,'tl','',0),(33974,944,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3610;&#3633;&#3597;&#3594;&#3637;&#3629;&#3639;&#3656;&#3609;',0),(33975,944,'hi','à¤•à¥‹à¤ˆ à¤…à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(33976,944,'ms','Edit akaun lain',0),(33977,944,'ar','ØªØ­Ø±ÙŠØ± Ø­Ø³Ø§Ø¨ Ø¢Ø®Ø±',0),(33978,944,'fr','Modifier un autre compte',0),(33979,944,'jp','ä»–ã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®ç·¨é›†',0),(33980,944,'pt','Editar outra conta',0),(33981,944,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(33982,944,'es','Editar Otra Cuenta',0),(33983,944,'de','Ein anderes Konto bearbeiten',0),(33984,944,'en','Edit Another Account',0),(33985,945,'is','',0),(33986,945,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø±Ù…Ù†Ø¯  Ø¯ÙŠÚ¯Ø±',0),(33987,945,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø±Ù…Ù†Ø¯  Ø¯ÙŠÚ¯Ø±',0),(33988,945,'tr','BaÅŸka bir Ã§alÄ±ÅŸan DÃ¼zenle',0),(33989,945,'pl','Edycja innego pracownika',0),(33990,945,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(33991,945,'ur','Ø§ÛŒÚ© Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(33992,945,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ˜Ð¾Ñˆ Ñ˜ÐµÐ´Ð½Ð¾Ð³ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(33993,945,'vi','Sá»­a NhÃ¢n ViÃªn KhÃ¡c',0),(33994,945,'af','Redigeer \'n Ander Werknemer',0),(33995,945,'ro','EditaÅ£i un alt angajat',0),(33996,945,'et','Muuda teist kasutajat',0),(33997,945,'si','Urejanje drugega zaposlenega',0),(33998,945,'ba','Mengedit karyawan lain',0),(33999,945,'nl','Een andere werknemer bewerken',0),(34000,945,'fi','Muokkaa toiselle tyÃ¶ntekijÃ¤lle',0),(34001,945,'no','Redigere en annen ansatt',0),(34002,945,'da','Redigere en anden medarbejder',0),(34003,945,'ko','ë‹¤ë¥¸ ì§ì›ì„ íŽ¸ì§‘',0),(34004,945,'he','×¢×¨×•×š ×¢×•×‘×“ × ×•×¡×£',0),(34005,945,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î¬Î»Î»Î¿Î½ Ï…Ï€Î¬Î»Î»Î·Î»Î¿',0),(34006,945,'zh','ç¼–è¾‘å¦ä¸€åé›‡å‘˜\r\n',0),(34007,945,'sv','Redigera en annan anstÃ¤lld',0),(34008,945,'it','Modifica di un altro dipendente',0),(34009,945,'tl','',0),(34010,945,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(34011,945,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34012,945,'ms','Edit pekerja lain',0),(34013,945,'ar','ØªØ­Ø±ÙŠØ± Ù…ÙˆØ¸Ù Ø¢Ø®Ø±',0),(34014,945,'fr','Modifier un autre employÃ©',0),(34015,945,'jp','ä»–ã?®å¾“æ¥­å“¡ã?®ç·¨é›†',0),(34016,945,'pt','Editar outro empregado',0),(34017,945,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð³Ð¾ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(34018,945,'es','Editar Otro Empleado',0),(34019,945,'de','Ein weiterer Mitarbeiter bearbeiten',0),(34020,945,'en','Edit Another Employee',0),(34021,946,'is','',0),(34022,946,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„  Ø¯ÙŠÚ¯Ø±',0),(34023,946,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„  Ø¯ÙŠÚ¯Ø±',0),(34024,946,'tr','BaÅŸka GL rapor DÃ¼zenle',0),(34025,946,'pl','Edycja innego konta GL',0),(34026,946,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(34027,946,'ur','Ø¯ÙˆØ³Ø±Û’ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34028,946,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ð½Ð°Ð»Ð¾Ð³Ð° Ð“Ð›',0),(34029,946,'vi','Sá»­a TK Sá»• CÃ¡i Tá»•ng Há»£p KhÃ¡c',0),(34030,946,'af','Redigeer \'n Ander AG Rekening',0),(34031,946,'ro','EditaÅ£i un alt cont de GL',0),(34032,946,'et','Redigeeri teisele pearaamatukontole',0),(34033,946,'si','Urejanje drug raÄun GL',0),(34034,946,'ba','Mengedit Account GL lain',0),(34035,946,'nl','Een andere GL Account bewerken',0),(34036,946,'fi','Muokkaa toisen Kirjanpitotilin pÃ¤Ã¤tilin',0),(34037,946,'no','Redigere en gi-konto',0),(34038,946,'da','Redigere en anden konto, GL',0),(34039,946,'ko','ë‹¤ë¥¸ GL ê³„ì • íŽ¸ì§‘',0),(34040,946,'he','×¢×¨×™×›×ª ×—×©×‘×•×Ÿ GL ××—×¨',0),(34041,946,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î¼Î¹Î± Î¬Î»Î»Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(34042,946,'zh','ç¼–è¾‘å¦ä¸€ä¸ªæ€»å¸å¸æˆ·\r\n',0),(34043,946,'sv','Redigera en annan GL konto',0),(34044,946,'it','Modificare un altro Account GL',0),(34045,946,'tl','',0),(34046,946,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3629;&#3639;&#3656;&#3609;',0),(34047,946,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ GL à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34048,946,'ms','Edit akaun GL lain',0),(34049,946,'ar','ØªØ­Ø±ÙŠØ± Ø­Ø³Ø§Ø¨ Ø£Ø³ØªØ§Ø° Ø¹Ø§Ù… Ø¢Ø®Ø±',0),(34050,946,'fr','Modifier un autre compte GL',0),(34051,946,'jp','æ–°ã?Ÿã?«GLã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’æ›´æ–°',0),(34052,946,'pt','Editar outra conta GL',0),(34053,946,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ ÑÑ‡ÐµÑ‚ GL',0),(34054,946,'es','Editar Otra Cuenta de LM',0),(34055,946,'de','Ein anderes GL-Konto bearbeiten',0),(34056,946,'en','Edit Another GL Account',0),(34057,947,'is','',0),(34058,947,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ Ø¯ÙŠÚ¯Ø±',0),(34059,947,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ Ø¯ÙŠÚ¯Ø±',0),(34060,947,'tr','BaÅŸka bir satÄ±ÅŸ iÅŸlemi DÃ¼zenle',0),(34061,947,'pl','Edycja innego procesu sprzedaÅ¼y',0),(34062,947,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(34063,947,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± ÙØ±ÙˆØ®Øª Ú©Û’ Ø¹Ù…Ù„ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34064,947,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(34065,947,'vi','Sá»­a Má»™t QuÃ¡ TrÃ¬nh BÃ¡n HÃ ng KhÃ¡c',0),(34066,947,'af','Rediger \'n Ander Verkoopsproses',0),(34067,947,'ro','EditaÅ£i un alt proces de vÃ¢nzÄƒri',0),(34068,947,'et','Muuda teise mÃ¼Ã¼giprotsessi',0),(34069,947,'si','Urejanje drug prodajni proces',0),(34070,947,'ba','Mengedit proses penjualan lain',0),(34071,947,'nl','Een verkoopproces bewerken',0),(34072,947,'fi','Muokkaa toisessa myyntiprosessissa',0),(34073,947,'no','Redigere en annen salgsprosess',0),(34074,947,'da','Rediger en salgsproces',0),(34075,947,'ko','ë‹¤ë¥¸ ì˜ì—… í”„ë¡œì„¸ìŠ¤ íŽ¸ì§‘',0),(34076,947,'he','×¢×¨×™×›×” ××—×¨ ×ª×”×œ×™×š ×”×ž×›×™×¨×”',0),(34077,947,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î¼Î¹Î± Î¬Î»Î»Î· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(34078,947,'zh','ç¼–è¾‘å¦ä¸€ä¸ªé”€å”®è¿‡ç¨‹\r\n',0),(34079,947,'sv','Redigera en annan fÃ¶rsÃ¤ljningsprocess',0),(34080,947,'it','Modificare un altro processo di vendita',0),(34081,947,'tl','',0),(34082,947,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3629;&#3639;&#3656;&#3609;',0),(34083,947,'hi','à¤à¤• à¤”à¤° à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥€ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34084,947,'ms','Edit proses jualan yang lain',0),(34085,947,'ar','ØªØ­Ø±ÙŠØ± Ø¹Ù…Ù„ÙŠØ© Ù…Ø¨ÙŠØ¹Ø§Øª Ø£Ø®Ø±Ù‰',0),(34086,947,'fr','Modifier un autre processus de vente',0),(34087,947,'jp','ä»–ã?®ã‚»ãƒ¼ãƒ«ã‚¹ãƒ—ãƒ­ã‚»ã‚¹ã?®ç·¨é›†',0),(34088,947,'pt','Editar um outro processo de vendas',0),(34089,947,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ð¿Ñ€Ð¾Ñ†ÐµÑÑ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(34090,947,'es','Editar Otro Proceso de Ventas',0),(34091,947,'de','Bearbeiten einer anderen Sales-Prozess',0),(34092,947,'en','Edit Another Sales Process',0),(34093,948,'is','',0),(34094,948,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯ÙŠÚ¯Ø±',0),(34095,948,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯ÙŠÚ¯Ø±',0),(34096,948,'tr','BaÅŸka bir satÄ±cÄ± DÃ¼zenle',0),(34097,948,'pl','EdytowaÄ‡ inny sprzedawca',0),(34098,948,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡',0),(34099,948,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± ÙØ±ÙˆØ´Ù†Ø¯Û ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34100,948,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð´Ñ€ÑƒÐ³Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(34101,948,'vi','Sá»­a NhÃ¢n ViÃªn Kinh Doanh KhÃ¡c',0),(34102,948,'af','Rediger \'n Ander Verkoopspersoon',0),(34103,948,'ro','EditaÅ£i un alt vanzator',0),(34104,948,'et','Muuda teise mÃ¼Ã¼gimees',0),(34105,948,'si','Urejanje drug prodajalec',0),(34106,948,'ba','Mengedit Salesman lain',0),(34107,948,'nl','Een andere verkoper bewerken',0),(34108,948,'fi','Muokkaa toinen myyjÃ¤',0),(34109,948,'no','Redigere en annen selger',0),(34110,948,'da','Redigere en anden sÃ¦lger',0),(34111,948,'ko','ë‹¤ë¥¸ ì„¸ì¼ì¦ˆ ë§¨ íŽ¸ì§‘',0),(34112,948,'he','×¢×¨×•×š ××™×© ×ž×›×™×¨×•×ª × ×•×¡×£',0),(34113,948,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î­Î½Î± Î¬Î»Î»Î¿ Ï€Ï‰Î»Î·Ï„Î®',0),(34114,948,'zh','ç¼–è¾‘å¦ä¸€ä¸ªæŽ¨é”€å‘˜\r\n',0),(34115,948,'sv','Redigera en annan sÃ¤ljare',0),(34116,948,'it','Modificare un altro venditore',0),(34117,948,'tl','',0),(34118,948,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3588;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(34119,948,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34120,948,'ms','Edit lagi jurujual',0),(34121,948,'ar','ØªØ­Ø±ÙŠØ± Ø¨Ø§Ø¦Ø¹ Ø¢Ø®Ø±',0),(34122,948,'fr','Modifier un autre vendeur',0),(34123,948,'jp','ä»–ã?®ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…ã?®ç·¨é›†',0),(34124,948,'pt','Editar outro vendedor',0),(34125,948,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð³Ð¾ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(34126,948,'es','Editar Otro Vendedor',0),(34127,948,'de','Bearbeiten von einem anderen VerkÃ¤ufer',0),(34128,948,'en','Edit Another Salesman',0),(34129,949,'is','',0),(34130,949,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¯ÙŠÚ¯Ø±',0),(34131,949,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¯ÙŠÚ¯Ø±',0),(34132,949,'tr','BaÅŸka bir fiÅŸ dÃ¼zenleme',0),(34133,949,'pl','Edit kolejny kupon',0),(34134,949,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(34135,949,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34136,949,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð´Ñ€ÑƒÐ³Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(34137,949,'vi','Sá»­a Má»™t Phiáº¿u KhÃ¡c',0),(34138,949,'af','Redigeer \'n Ander Bewysstuk',0),(34139,949,'ro','EditaÅ£i un alt Voucher',0),(34140,949,'et','Teise kande redigeerimine',0),(34141,949,'si','Drugo kupona urejanje',0),(34142,949,'ba','Mengedit lain Voucher',0),(34143,949,'nl','Bewerken van een andere Voucher',0),(34144,949,'fi','Muokkaa toisen tositteen',0),(34145,949,'no','Redigere et annet bilag',0),(34146,949,'da','Redigere en anden Voucher',0),(34147,949,'ko','ë‹¤ë¥¸ ë°”ìš°ì²˜ë¥¼ íŽ¸ì§‘',0),(34148,949,'he','×¢×¨×™×›×ª ×©×•×‘×¨ × ×•×¡×£',0),(34149,949,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î¼Î¹Î± Î¬Î»Î»Î· ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(34150,949,'zh','ç¼–è¾‘å…¶ä»–åˆ¸\r\n',0),(34151,949,'sv','Redigera en annan verifikation',0),(34152,949,'it','Modificare un altro buono',0),(34153,949,'tl','',0),(34154,949,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3629;&#3639;&#3656;&#3609;',0),(34155,949,'hi','à¤à¤• à¤”à¤° à¤µà¤¾à¤‰à¤šà¤° à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34156,949,'ms','Edit satu lagi baucar yang',0),(34157,949,'ar','ØªØ­Ø±ÙŠØ± Ù‚Ø³ÙŠÙ…Ø© Ø£Ø®Ø±Ù‰',0),(34158,949,'fr','Modifier un autre Voucher',0),(34159,949,'jp','æ–°ã?Ÿã?ªä¼?ç¥¨ã‚’ç·¨é›†',0),(34160,949,'pt','Editar outro Voucher',0),(34161,949,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐµÑ‰Ðµ Ð¾Ð´Ð¸Ð½ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(34162,949,'es','Editar otro Voucher',0),(34163,949,'de','Ein weiterer Beleg bearbeiten',0),(34164,949,'en','Edit Another Voucher',0),(34165,950,'is','',0),(34166,950,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(34167,950,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(34168,950,'tr','BÃ¼tÃ§e dÃ¼zenleme',0),(34169,950,'pl','Edytuj budÅ¼etu',0),(34170,950,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(34171,950,'ur','Ø¨Ø¬Ù¹ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34172,950,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð±ÑƒÑŸÐµÑ‚',0),(34173,950,'vi','Sá»­a NgÃ¢n SÃ¡ch',0),(34174,950,'af','Redigeer Begroting',0),(34175,950,'ro','Editare buget',0),(34176,950,'et','Muuda eelarvet',0),(34177,950,'si','Urejanje proraÄuna',0),(34178,950,'ba','Mengedit anggaran',0),(34179,950,'nl','Begroting bewerken',0),(34180,950,'fi','Muokkaa budjettia',0),(34181,950,'no','Redigere budsjett',0),(34182,950,'da','Redigere Budget',0),(34183,950,'ko','ì˜ˆì‚° íŽ¸ì§‘',0),(34184,950,'he','×¢×¨×™×›×ª ×ª×§×¦×™×‘',0),(34185,950,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(34186,950,'zh','ä¿®æ”¹é¢„ç®—\r\n',0),(34187,950,'sv','Redigera Budget',0),(34188,950,'it','Modificare il bilancio',0),(34189,950,'tl','',0),(34190,950,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(34191,950,'hi','à¤¬à¤œà¤Ÿ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34192,950,'ms','Edit bajet',0),(34193,950,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(34194,950,'fr','Modifier le Budget',0),(34195,950,'jp','äºˆç®—ã‚’ç·¨é›†',0),(34196,950,'pt','Editar orÃ§amento',0),(34197,950,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(34198,950,'es','Editar Presupuesto',0),(34199,950,'de','Bearbeiten von Budgets',0),(34200,950,'en','Edit Budget',0),(34201,951,'is','',0),(34202,951,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(34203,951,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(34204,951,'tr','YapÄ± sipariÅŸi gir',0),(34205,951,'pl','Edycja zamÃ³wienia budowaÄ‡',0),(34206,951,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ñ€Ð¾Ñ Ñ€ÐµÐ´',0),(34207,951,'ur','ØªØ¹Ù…ÛŒØ± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34208,951,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(34209,951,'vi','Sá»­a ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng Sá»‘',0),(34210,951,'af','Redigeer bou orde',0),(34211,951,'ro','Editare construi ordine',0),(34212,951,'et','Muuda ehitada tellimust',0),(34213,951,'si','Urejanje izgradnje',0),(34214,951,'ba','Mengedit membangun Order',0),(34215,951,'nl','Opbouwvolgorde bewerken',0),(34216,951,'fi','Muokkaa tilauksen mukaan',0),(34217,951,'no','Redigere Bygg rekkefÃ¸lge',0),(34218,951,'da','Redigere Byg efter ordre',0),(34219,951,'ko','ë¹Œë“œ ìˆœì„œ íŽ¸ì§‘',0),(34220,951,'he','×¢×¨×•×š ×”×–×ž× ×ª ×‘× ×™×™×”',0),(34221,951,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(34222,951,'zh','ç¼–è¾‘æž„å»ºé¡ºåº\r\n',0),(34223,951,'sv','Redigera bygga Order',0),(34224,951,'it','Modificare l\'ordine di compilazione',0),(34225,951,'tl','',0),(34226,951,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3626;&#3619;&#3657;&#3634;&#3591;&#3586;&#3638;&#3657;&#3609;',0),(34227,951,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤•à¥à¤°à¤® à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34228,951,'ms','Edit perintah membina',0),(34229,951,'ar','ØªØ­Ø±ÙŠØ± Ø£Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(34230,951,'fr','Modifier l\'ordre de compilation',0),(34231,951,'jp','çµ„ç«‹æ³¨æ–‡ç•ªå?·ã?®ç·¨é›†',0),(34232,951,'pt','Editar a ordem de compilaÃ§Ã£o',0),(34233,951,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(34234,951,'es','Editar Orden de ConstrucciÃ³n',0),(34235,951,'de','Buildreihenfolge bearbeiten',0),(34236,951,'en','Edit Build Order',0),(34237,952,'is','',0),(34238,952,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(34239,952,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(34240,952,'tr','YapÄ± sipariÅŸ DÃ¼zenle',0),(34241,952,'pl','Edycja zamÃ³wienia budowaÄ‡',0),(34242,952,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(34243,952,'ur','ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34244,952,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(34245,952,'vi','Sá»­a ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(34246,952,'af','Redigeer Geboude Bestellings',0),(34247,952,'ro','Editare construi comenzi',0),(34248,952,'et','Redigeeri ehitada tellimused',0),(34249,952,'si','Urejanje naroÄila graditi',0),(34250,952,'ba','Ganti Pembuatan Pesanan',0),(34251,952,'nl','Build Orders bewerken',0),(34252,952,'fi','Muokkaa rakentaa tilauksia',0),(34253,952,'no','Redigere Bygg ordrer',0),(34254,952,'da','Redigere bygge ordrer',0),(34255,952,'ko','ë¹Œë“œ ìˆœì„œ íŽ¸ì§‘',0),(34256,952,'he','×¢×¨×•×š ×”×–×ž× ×•×ª ×‘× ×™×™×”',0),(34257,952,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÎšÎ‘Î¤Î‘Î£ÎšÎ•Î¥Î—Î£',0),(34258,952,'zh','ç¼–è¾‘æž„å»ºé¡ºåº\r\n',0),(34259,952,'sv','Redigera bygga order',0),(34260,952,'it','Modifica compilazione ordini',0),(34261,952,'tl','',0),(34262,952,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3626;&#3619;&#3657;&#3634;&#3591;&#3586;&#3638;&#3657;&#3609;',0),(34263,952,'hi','à¤¬à¤¿à¤²à¥à¤¡ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34264,952,'ms','Edit membina pesanan',0),(34265,952,'ar','ØªØ­Ø±ÙŠØ± Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(34266,952,'fr','Modifier des commandes de gÃ©nÃ©ration',0),(34267,952,'jp','çµ„ç«‹æ³¨æ–‡ã?®ç·¨é›†',0),(34268,952,'pt','Editar ordens de construÃ§Ã£o',0),(34269,952,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(34270,952,'es','Editar Ordenes de ConstrucciÃ³n',0),(34271,952,'de','Build AuftrÃ¤ge bearbeiten',0),(34272,952,'en','Edit Build Orders',0),(34273,953,'is','',0),(34274,953,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ú¯Ø±ÙˆÙ‡ ',0),(34275,953,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ú¯Ø±ÙˆÙ‡ ',0),(34276,953,'tr','Kategori DeÄŸiÅŸtir',0),(34277,953,'pl','Edycja kategorii',0),(34278,953,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(34279,953,'ur','Ø²Ù…Ø±Û ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34280,953,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(34281,953,'vi','Sá»­a Thá»ƒ Loáº¡i',0),(34282,953,'af','Redigeer Kategorie',0),(34283,953,'ro','Editare categorie',0),(34284,953,'et','Redigeeri kategooriat',0),(34285,953,'si','Urejanje kategorije',0),(34286,953,'ba','Mengedit Kategori',0),(34287,953,'nl','Rubriek bewerken',0),(34288,953,'fi','Muokkaa luokkaa',0),(34289,953,'no','Redigere kategori',0),(34290,953,'da','Redigere kategori',0),(34291,953,'ko','ë²”ì£¼ íŽ¸ì§‘',0),(34292,953,'he','×¢×¨×•×š ×§×˜×’×•×¨×™×™×”',0),(34293,953,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚',0),(34294,953,'zh','ç¼–è¾‘ç±»åˆ«\r\n',0),(34295,953,'sv','Redigera kategori',0),(34296,953,'it','Modifica categoria',0),(34297,953,'tl','',0),(34298,953,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(34299,953,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34300,953,'ms','Mengedit kategori',0),(34301,953,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„ØªØµÙ†ÙŠÙ',0),(34302,953,'fr','Modifier la catÃ©gorie',0),(34303,953,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®ç·¨é›†',0),(34304,953,'pt','Editar Categoria',0),(34305,953,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(34306,953,'es','Editar CategorÃ­a',0),(34307,953,'de','Kategorie bearbeiten',0),(34308,953,'en','Edit Category',0),(34309,954,'is','',0),(34310,954,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ÙØ¹Ù„ÙŠ',0),(34311,954,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ÙØ¹Ù„ÙŠ',0),(34312,954,'tr','GeÃ§erli Ã§alÄ±ÅŸanÄ± DÃ¼zenle',0),(34313,954,'pl','Edytuj aktualnie zatrudnionych pracownikÃ³w',0),(34314,954,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐºÑƒÑ‰Ð¸Ñ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(34315,954,'ur','Ø­Ø§Ù„ÛŒÛ Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34316,954,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(34317,954,'vi','Sá»­a NhÃ¢n ViÃªn Hiá»‡n Táº¡i',0),(34318,954,'af','Redigeer Huidige Werknemers',0),(34319,954,'ro','Editare curent angajaÅ£i',0),(34320,954,'et','Muuda praeguseid tÃ¶Ã¶tajaid',0),(34321,954,'si','Uredi trenutno zaposlenih',0),(34322,954,'ba','Mengedit karyawan saat ini',0),(34323,954,'nl','Bewerken van huidige werknemers',0),(34324,954,'fi','Muokkaa nykyiset tyÃ¶ntekijÃ¤t',0),(34325,954,'no','Rediger gjeldende ansatte',0),(34326,954,'da','Redigere nuvÃ¦rende medarbejdere',0),(34327,954,'ko','í˜„ìž¬ ì§ì› íŽ¸ì§‘',0),(34328,954,'he','×¢×¨×•×š ×¢×•×‘×“×™× × ×•×›×—×™×™×',0),(34329,954,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ„Î¿Ï…Ï‚ Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„ÎµÏ‚ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Î¿Ï…Ï‚',0),(34330,954,'zh','ç¼–è¾‘å½“å‰é›‡å‘˜\r\n',0),(34331,954,'sv','Redigera nuvarande anstÃ¤llda',0),(34332,954,'it','Modificare le attuali impiegati',0),(34333,954,'tl','',0),(34334,954,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(34335,954,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34336,954,'ms','Edit pekerja semasa',0),(34337,954,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ† Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(34338,954,'fr','Modifier les employÃ©s actuels',0),(34339,954,'jp','ç?¾å¾“æ¥­å“¡ã?®ç·¨é›†',0),(34340,954,'pt','Editar atuais empregados',0),(34341,954,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¢ÐµÐºÑƒÑ‰Ð¸Ñ… Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(34342,954,'es','Editar Empleados Actuales',0),(34343,954,'de','Aktuelle Mitarbeiter bearbeiten',0),(34344,954,'en','Edit Current Employees',0),(34345,955,'is','',0),(34346,955,'dr','/ Ø­Ø°Ù ÙŠÙƒ Ø¨ÙˆØ¯Ø¬Ù‡',0),(34347,955,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ / Ø­Ø°Ù ÙŠÙƒ Ø¨ÙˆØ¯Ø¬Ù‡',0),(34348,955,'tr','DÃ¼zenle/Sil bir bÃ¼tÃ§e',0),(34349,955,'pl','Edycja/usuwanie budÅ¼etu',0),(34350,955,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(34351,955,'ur','ØªØ¯ÙˆÛŒÙ† Ø­Ø°Ù Ø¨Ø¬Ù¹',0),(34352,955,'sr','Ð£Ñ€ÐµÐ´Ð¸ /Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð±ÑƒÑŸÐµÑ‚',0),(34353,955,'vi','Sá»­a/XÃ³a 1 NgÃ¢n SÃ¡ch',0),(34354,955,'af','Redigeer/Skrap \'n Begroting',0),(34355,955,'ro','Edita/ÅŸterge un buget',0),(34356,955,'et','Redigeeri/Kustuta eelarve',0),(34357,955,'si','Urejanje/brisanje proraÄun',0),(34358,955,'ba','Mengedit/menghapus anggaran',0),(34359,955,'nl','Bewerken/verwijderen een begroting',0),(34360,955,'fi','Muokata tai poistaa budjetin',0),(34361,955,'no','Rediger/Slett et budsjett',0),(34362,955,'da','Rediger/slet et Budget',0),(34363,955,'ko','ì˜ˆì‚° ìˆ˜ì •/ì‚­ì œ',0),(34364,955,'he','×¢×¨×•×š/×ž×—×§ ×ª×§×¦×™×‘',0),(34365,955,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±/Î”Î¹Î±Î³ÏÎ±Ï†Î® Î­Î½Î±Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ',0),(34366,955,'zh','ç¼–è¾‘/åˆ é™¤çš„è´¢æ”¿é¢„ç®—æ¡ˆ\r\n',0),(34367,955,'sv','Redigera/radera en Budget',0),(34368,955,'it','Modificare/eliminare un bilancio',0),(34369,955,'tl','',0),(34370,955,'th','&#3649;&#3585;&#3657;&#3652;&#3586;/&#3621;&#3610;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(34371,955,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤/à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤à¤• à¤¬à¤œà¤Ÿ',0),(34372,955,'ms','Edit/Delete bajet',0),(34373,955,'ar','ØªØ­Ø±ÙŠØ±/Ø­Ø°Ù Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(34374,955,'fr','Modifier/supprimer un Budget',0),(34375,955,'jp','äºˆç®—ã?®ç·¨é›†/æ¶ˆåŽ»',0),(34376,955,'pt','Editar/apagar um orÃ§amento',0),(34377,955,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ/Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(34378,955,'es','Editar/Eliminar un Presupuesto',0),(34379,955,'de','LÃ¶schen Sie bearbeiten/ein Budget',0),(34380,955,'en','Edit/Delete a Budget',0),(34381,956,'is','',0),(34382,956,'dr','( Ø³Ù†Ø¯ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§)',0),(34383,956,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø®ØµÙˆØµÙŠØ§Øª Ø³Ù†Ø¯ ( Ø³Ù†Ø¯ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§)',0),(34384,956,'tr','Belge Ã¶zelliklerini dÃ¼zenleme',0),(34385,956,'pl','Edytuj wÅ‚aÅ›ciwoÅ›ci dokumentu',0),(34386,956,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(34387,956,'ur','Ø®ÙˆØ§Øµ Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34388,956,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð°Ð²Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(34389,956,'vi','Sá»­a TÃ­nh Cháº¥t TÃ i Liá»‡u',0),(34390,956,'af','Redigeer Dokument Eienskappe',0),(34391,956,'ro','Editare proprietÄƒÅ£i Document',0),(34392,956,'et','Redigeeri dokumendi atribuute',0),(34393,956,'si','Urejanje lastnosti dokumenta',0),(34394,956,'ba','Mengedit properti dokumen',0),(34395,956,'nl','Documenteigenschappen bewerken',0),(34396,956,'fi','Muokkaa asiakirjaominaisuuksia',0),(34397,956,'no','Redigere dokumentegenskaper',0),(34398,956,'da','Rediger dokumentegenskaber',0),(34399,956,'ko','ë¬¸ì„œ ì†ì„± íŽ¸ì§‘',0),(34400,956,'he','×¢×¨×•×š ×ž××¤×™×™× ×™ ×ž×¡×ž×š',0),(34401,956,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¹Î´Î¹Î¿Ï„Î®Ï„Ï‰Î½ ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(34402,956,'zh','ç¼–è¾‘æ–‡æ¡£å±žæ€§\r\n',0),(34403,956,'sv','Redigera dokumentegenskaper',0),(34404,956,'it','Modificare le proprietÃ  del documento',0),(34405,956,'tl','',0),(34406,956,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(34407,956,'hi','à¤¦à¤¸à¥ à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤—à¥à¤£ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34408,956,'ms','Mengedit dokumen',0),(34409,956,'ar','ØªØ­Ø±ÙŠØ± Ø®ØµØ§Ø¦Øµ Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(34410,956,'fr','Modifier les propriÃ©tÃ©s de Document',0),(34411,956,'jp','æ–‡æ›¸ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã?®ç·¨é›†',0),(34412,956,'pt','Editar propriedades de documento',0),(34413,956,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÐ²Ð¾Ð¹ÑÑ‚Ð² Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(34414,956,'es','Editar CaracterÃ­sticas del Documento',0),(34415,956,'de','Bearbeiten von Dokumenteigenschaften',0),(34416,956,'en','Edit Document Properties',0),(34417,957,'is','',0),(34418,957,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙŠÙƒ ÙØ¹Ø§Ù„ÙŠØª Ù…ÙˆØ¬ÙˆØ¯',0),(34419,957,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙŠÙƒ ÙØ¹Ø§Ù„ÙŠØª Ù…ÙˆØ¬ÙˆØ¯',0),(34420,957,'tr','Varolan eylem DÃ¼zenle',0),(34421,957,'pl','Edytowanie istniejÄ…cych akcji',0),(34422,957,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(34423,957,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø¹Ù…Ù„ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34424,957,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ñ€Ð°Ð´ÑšÐµ',0),(34425,957,'vi','Sá»­a 1 HÃ nh Äá»™ng Hiá»‡n Táº¡i',0),(34426,957,'af','Redigeer \'n Bestaande Aksie',0),(34427,957,'ro','Editarea unei acÅ£iuni existent',0),(34428,957,'et','Olemasolevate toimingu redigeerimine',0),(34429,957,'si','Uredite obstojeÄega ukrepa.',0),(34430,957,'ba','Mengedit yang sudah ada tindakan',0),(34431,957,'nl','Bewerken van een bestaande actie',0),(34432,957,'fi','Muokkaa nykyisten toimien',0),(34433,957,'no','Redigere en eksisterende handling',0),(34434,957,'da','Rediger en eksisterende sag',0),(34435,957,'ko','ê¸°ì¡´ ìž‘ì—… íŽ¸ì§‘',0),(34436,957,'he','×¢×¨×•×š ×¤×¢×•×œ×” ×§×™×™×ž×ª',0),(34437,957,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï…Ï†Î¹ÏƒÏ„Î¬ÂµÎµÎ½Î·Ï‚ Î´ÏÎ¬ÏƒÎ·Ï‚',0),(34438,957,'zh','ç¼–è¾‘çŽ°æœ‰çš„è¡ŒåŠ¨\r\n',0),(34439,957,'sv','Redigera en befintlig Ã¥tgÃ¤rd',0),(34440,957,'it','Modificare un\'azione esistente',0),(34441,957,'tl','',0),(34442,957,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(34443,957,'hi','à¤•à¤¿à¤¸à¥€ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34444,957,'ms','Edit tindakan sedia ada',0),(34445,957,'ar','ØªØ­Ø±ÙŠØ± Ø¥Ø¬Ø±Ø§Ø¡ Ù…ÙˆØ¬ÙˆØ¯',0),(34446,957,'fr','Modifier une Action existante',0),(34447,957,'jp','å­˜åœ¨ã?™ã‚‹ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã?®ç·¨é›†',0),(34448,957,'pt','Editar uma aÃ§Ã£o existente',0),(34449,957,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÐµÐµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(34450,957,'es','Editar una AcciÃ³n Existente',0),(34451,957,'de','Bearbeiten einer vorhandenen Aktion',0),(34452,957,'en','Edit An Existing Action',0),(34453,958,'is','',0),(34454,958,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙŠÙƒ Ú¯Ø±ÙˆÙ‡ Ù…ÙˆØ¬ÙˆØ¯ ',0),(34455,958,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙŠÙƒ Ú¯Ø±ÙˆÙ‡ Ù…ÙˆØ¬ÙˆØ¯ ',0),(34456,958,'tr','Varolan bir kategoriyi DÃ¼zenle',0),(34457,958,'pl','Edytowanie istniejÄ…cej kategorii',0),(34458,958,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(34459,958,'ur','Ø§ÛŒÚ© Ù…ÙˆØ¬ÙˆØ¯Û Ø²Ù…Ø±Û ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34460,958,'sr','Ð£Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(34461,958,'vi','Sá»­a 1 Thá»ƒ Loáº¡i Hiá»‡n Táº¡i',0),(34462,958,'af','Redigeer \'n Bestaande Kategorie',0),(34463,958,'ro','Editare categorie o existente',0),(34464,958,'et','Redigeeri olemasolevat kategooriat',0),(34465,958,'si','Urejanje obstojeÄe kategorije',0),(34466,958,'ba','Mengedit kategori yang ada',0),(34467,958,'nl','Bewerken van een bestaande categorie',0),(34468,958,'fi','Muokkaa aiemmin luotua luokkaa',0),(34469,958,'no','Redigere en eksisterende kategori',0),(34470,958,'da','Rediger en eksisterende kategori',0),(34471,958,'ko','ê¸°ì¡´ ë²”ì£¼ íŽ¸ì§‘',0),(34472,958,'he','×¢×¨×•×š ×§×˜×’×•×¨×™×” ×§×™×™×ž×ª',0),(34473,958,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î¼Î¹Î± Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎ± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(34474,958,'zh','ç¼–è¾‘çŽ°æœ‰çš„åˆ†ç±»\r\n',0),(34475,958,'sv','Redigera en befintlig kategori',0),(34476,958,'it','Modificare una categoria esistente',0),(34477,958,'tl','',0),(34478,958,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(34479,958,'hi','à¤à¤• à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34480,958,'ms','Mengedit kategori sedia ada untuk',0),(34481,958,'ar','ØªØ­Ø±ÙŠØ± ØªØµÙ†ÙŠÙ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(34482,958,'fr','Modifier une catÃ©gorie existante',0),(34483,958,'jp','å­˜åœ¨ã?™ã‚‹ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®ç·¨é›†',0),(34484,958,'pt','Editar uma categoria existente',0),(34485,958,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÑƒÑŽ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(34486,958,'es','Editar una Empresa Existente',0),(34487,958,'de','Bearbeiten einer vorhandenen Kategorie',0),(34488,958,'en','Edit An Existing Category',0),(34489,959,'is','',0),(34490,959,'dr','/ Ù†Ù‡Ø§Ø¦ÙŠ ÙƒØ±Ø¯Ù† ÙØ±Ù…Ø§ÛŒØ´ Ø³Ø§Ø®Øª ',0),(34491,959,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ / Ù†Ù‡Ø§Ø¦ÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(34492,959,'tr','YapÄ± sipariÅŸi DÃ¼zenle/sonlandÄ±rma',0),(34493,959,'pl','Edycja/sfinalizowaÄ‡ zamÃ³wienie budowaÄ‡',0),(34494,959,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ñ„Ð¸Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð·Ð³Ñ€Ð°Ð´Ð¸Ð¼ Ñ€ÐµÐ´',0),(34495,959,'ur','ØªØ¯ÙˆÛŒÙ†/Ø­ØªÙ…ÛŒ Ø´Ú©Ù„ Ø¯ÛŒÙ†Û’ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ¹Ù…ÛŒØ±',0),(34496,959,'sr','Ð£Ñ€ÐµÐ´Ð¸ /Ñ„Ð¸Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚Ð¸ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(34497,959,'vi','Sá»­a/Káº¿t ThÃºc ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(34498,959,'af','Redigeer/POMA volgorde bou',0),(34499,959,'ro','Editare/finaliza construi ordine',0),(34500,959,'et','Edit/lÃµpetamine ehitada jÃ¤rjekorras',0),(34501,959,'si','Uredi/dokonÄanje izgradnje',0),(34502,959,'ba','Edit/menyelesaikan membangun Order',0),(34503,959,'nl','Bewerken/Finaliseer opbouwvolgorde',0),(34504,959,'fi','Muokkaa ja viimeistellÃ¤ tilauksen mukaan',0),(34505,959,'no','Rediger/fullfÃ¸re bygge rekkefÃ¸lge',0),(34506,959,'da','Rediger/afslutte bygge rÃ¦kkefÃ¸lge',0),(34507,959,'ko','ë¹Œë“œ ìˆœì„œë¥¼ íŽ¸ì§‘/ì™„ë£Œ',0),(34508,959,'he','×¢×¨×™×›×”/×¡×™×•× ×‘× ×™×” ×”×–×ž× ×”',0),(34509,959,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±/Î¿ÏÎ¹ÏƒÏ„Î¹ÎºÎ¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(34510,959,'zh','ç¼–è¾‘/ç¡®å®šæž„å»ºé¡ºåº\r\n',0),(34511,959,'sv','Redigera/fÃ¤rdigstÃ¤lla bygga Order',0),(34512,959,'it','Modifica/finalizzare l\'ordine di compilazione',0),(34513,959,'tl','',0),(34514,959,'th','&#3649;&#3585;&#3657;&#3652;&#3586;/&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(34515,959,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚/à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¥‡à¤¨à¥‡ à¤•à¤¾ à¤•à¥à¤°à¤® à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(34516,959,'ms','Edit/memuktamadkan perintah membina',0),(34517,959,'ar','ØªØ­Ø±ÙŠØ±/Ø§Ø³ØªÙƒÙ…Ø§Ù„ Ø¨Ù†Ø§Ø¡ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(34518,959,'fr','Edit/finaliser l\'ordre de compilation',0),(34519,959,'jp','çµ„ç«‹æ³¨æ–‡ã?®ç·¨é›†/å®Œäº†',0),(34520,959,'pt','Editar/finalizar a ordem de compilaÃ§Ã£o',0),(34521,959,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ/Ð´Ð¾Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(34522,959,'es','Editar/Finalizar Orden de ConstrucciÃ³n',0),(34523,959,'de','SchlieÃŸen Sie bearbeiten ab/Buildreihenfolge',0),(34524,959,'en','Edit/Finalize Build Order',0),(34525,960,'is','',0),(34526,960,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¹Ù…Ù„ÙƒØ±Ø¯ ',0),(34527,960,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¹Ù…Ù„ÙƒØ±Ø¯ ',0),(34528,960,'tr','Operasyon dÃ¼zenlemek',0),(34529,960,'pl','Edytuj operacjÄ™',0),(34530,960,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸ÑÑ‚Ð°',0),(34531,960,'ur','Ø¹Ù…Ù„ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34532,960,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð°',0),(34533,960,'vi','Sá»­a HÃ nh Äá»™ng',0),(34534,960,'af','Redigeer bewerking',0),(34535,960,'ro','Editare operaÈ›iune',0),(34536,960,'et','Toimingu redigeerimine',0),(34537,960,'si','Uredi delovanje',0),(34538,960,'ba','Mengedit operasi',0),(34539,960,'nl','Operatie bewerken',0),(34540,960,'fi','Muokkaa toimintoa',0),(34541,960,'no','Rediger operasjon',0),(34542,960,'da','Redigere drift',0),(34543,960,'ko','ìž‘ì—… íŽ¸ì§‘',0),(34544,960,'he','×œ×¢×¨×•×š ×ž×‘×¦×¢',0),(34545,960,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(34546,960,'zh','ç¼–è¾‘æ“ä½œ\r\n',0),(34547,960,'sv','Redigera Operation',0),(34548,960,'it','Modifica operazione',0),(34549,960,'tl','',0),(34550,960,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;',0),(34551,960,'hi','à¤‘à¤ªà¤°à¥‡à¤¶à¤¨ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34552,960,'ms','Edit operasi',0),(34553,960,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(34554,960,'fr','Modifier le fonctionnement',0),(34555,960,'jp','ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã?®ç·¨é›†',0),(34556,960,'pt','Editar operaÃ§Ã£o',0),(34557,960,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸ÑŽ',0),(34558,960,'es','Editar OperaciÃ³n',0),(34559,960,'de','Vorgang bearbeiten',0),(34560,960,'en','Edit Operation',0),(34561,961,'is','',0),(34562,961,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(34563,961,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(34564,961,'tr','PO # dÃ¼zenlemek',0),(34565,961,'pl','Edytuj PO #',0),(34566,961,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐŸÐŸ #',0),(34567,961,'ur','Ù¾Ùˆ # ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34568,961,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐŸÐž #',0),(34569,961,'vi','Sá»­a ÄÆ¡n Mua HÃ ng Sá»‘',0),(34570,961,'af','Redigeer AB#',0),(34571,961,'ro','Editare PO #',0),(34572,961,'et','Redigeeri PO #',0),(34573,961,'si','Urejanje naroÄilnice',0),(34574,961,'ba','Mengedit PO #',0),(34575,961,'nl','Bewerken PO #',0),(34576,961,'fi','Muokkaa Ostotilauksen numero',0),(34577,961,'no','Redigere bestillingsnummeret',0),(34578,961,'da','Redigere PO #',0),(34579,961,'ko','íŽ¸ì§‘ í¬ #',0),(34580,961,'he','×¢×¨×™×›×ª ×ž×¡×¤×¨ ×ª× ×“×•××¨',0),(34581,961,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ PO #',0),(34582,961,'zh','ç¼–è¾‘è®¢å•ï¼ƒ\r\n',0),(34583,961,'sv','Redigera PO #',0),(34584,961,'it','Modifica PO #',0),(34585,961,'tl','',0),(34586,961,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(34587,961,'hi','à¤ªà¥€à¤“ # à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34588,961,'ms','Edit PO #',0),(34589,961,'ar','ØªØ­Ø±ÙŠØ± Øµ. Ø¨ #',0),(34590,961,'fr','Edition nÂ° BC',0),(34591,961,'jp','PO#ã‚’ç·¨é›†',0),(34592,961,'pt','Editar PO #',0),(34593,961,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ PO #',0),(34594,961,'es','Editar OC#',0),(34595,961,'de','Bearbeiten PO #',0),(34596,961,'en','Edit PO#',0),(34597,962,'is','',0),(34598,962,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(34599,962,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(34600,962,'tr','Komisyon verilerini DÃ¼zenle',0),(34601,962,'pl','Edycja danych Komisji',0),(34602,962,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸ Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(34603,962,'ur','Ú©Ù…ÛŒØ´Ù† Ú©ÙˆØ§Ø¦Ù ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34604,962,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð°',0),(34605,962,'vi','Sá»­a Dá»¯ Liá»‡u Hoa Há»“ng ',0),(34606,962,'af','Redigeer Kommissie Data',0),(34607,962,'ro','EditaÅ£i datele Comisiei',0),(34608,962,'et','Komisjonile andmete redigeerimine',0),(34609,962,'si','Urejanje podatkov Komisiji',0),(34610,962,'ba','Mengedit Data komisi',0),(34611,962,'nl','Commissie gegevens bewerken',0),(34612,962,'fi','Komission tietojen muokkaaminen',0),(34613,962,'no','Redigere provisjonsdata',0),(34614,962,'da','Redigere Kommissionen Data',0),(34615,962,'ko','ìœ„ì›íšŒì˜ ë°ì´í„° íŽ¸ì§‘',0),(34616,962,'he','×¢×¨×•×š × ×ª×•× ×™× ×”× ×¦×™×‘×•×ª',0),(34617,962,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(34618,962,'zh','ç¼–è¾‘ä½£é‡‘æ•°æ®\r\n',0),(34619,962,'sv','Redigera kommissionen Data',0),(34620,962,'it','Modificare i dati della Commissione',0),(34621,962,'tl','',0),(34622,962,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(34623,962,'hi','à¤†à¤¯à¥‹à¤— à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(34624,962,'ms','Edit Data Suruhanjaya',0),(34625,962,'ar','ØªØ­Ø±ÙŠØ± Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¹Ù…ÙˆÙ„Ø§Øª',0),(34626,962,'fr','Modifier les donnÃ©es de la Commission',0),(34627,962,'jp','ã‚³ãƒŸãƒƒã‚·ãƒ§ãƒ³ãƒ‡ãƒ¼ã‚¿ã?®ç·¨é›†',0),(34628,962,'pt','Editar dados da ComissÃ£o',0),(34629,962,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ðµ ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(34630,962,'es','Editar Datos de la ComisiÃ³n',0),(34631,962,'de','Kommission Daten bearbeiten',0),(34632,962,'en','Edit Commission Data',0),(34633,963,'is','',0),(34634,963,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ ',0),(34635,963,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ ',0),(34636,963,'tr','SatÄ±ÅŸ iÅŸlemi DÃ¼zenle',0),(34637,963,'pl','Edytuj proces sprzedaÅ¼y',0),(34638,963,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(34639,963,'ur','ÙØ±ÙˆØ®Øª Ú©Û’ Ø¹Ù…Ù„ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34640,963,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(34641,963,'vi','Sá»­a QuÃ¡ TrÃ¬nh BÃ¡n HÃ ng',0),(34642,963,'af','Redigeer Verkoopsproses',0),(34643,963,'ro','Editare proces de vÃ¢nzÄƒri',0),(34644,963,'et','Muuta mÃ¼Ã¼giprotsessi',0),(34645,963,'si','Urejanje prodajnega procesa',0),(34646,963,'ba','Mengedit proses penjualan',0),(34647,963,'nl','Verkoopproces bewerken',0),(34648,963,'fi','Muokkaa myyntiprosessin',0),(34649,963,'no','Redigere salgsprosess',0),(34650,963,'da','Rediger en salgsproces',0),(34651,963,'ko','ì˜ì—… í”„ë¡œì„¸ìŠ¤ë¥¼ íŽ¸ì§‘',0),(34652,963,'he','×¢×¨×™×›×ª ×ª×”×œ×™×š ×”×ž×›×™×¨×”',0),(34653,963,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(34654,963,'zh','ç¼–è¾‘é”€å”®è¿‡ç¨‹\r\n',0),(34655,963,'sv','Redigera fÃ¶rsÃ¤ljningsprocess',0),(34656,963,'it','Modificare il processo di vendita',0),(34657,963,'tl','',0),(34658,963,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(34659,963,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34660,963,'ms','Edit proses jualan',0),(34661,963,'ar','ØªØ­Ø±ÙŠØ± Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(34662,963,'fr','Modifier le processus de vente',0),(34663,963,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒ—ãƒ­ã‚»ã‚¹ã?®ç·¨é›†',0),(34664,963,'pt','Editar o processo de vendas',0),(34665,963,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐŸÑ€Ð¾Ñ†ÐµÑÑ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(34666,963,'es','Editar Proceso de Ventas',0),(34667,963,'de','Bearbeiten Vertriebsprozess',0),(34668,963,'en','Edit Sales Process',0),(34669,964,'is','',0),(34670,964,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø´Ø±ÙƒØª Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(34671,964,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø´Ø±ÙƒØª Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(34672,964,'tr','SeÃ§ili ÅŸirket DÃ¼zenle',0),(34673,964,'pl','Edytowanie wybranej firmie',0),(34674,964,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð°Ñ‚Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(34675,964,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34676,964,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¾Ð´Ð°Ð±Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(34677,964,'vi','Sá»­a Cty ÄÃ£ Chá»n',0),(34678,964,'af','Redigeer geselekteerde Onderneming',0),(34679,964,'ro','Modifica compania selectata',0),(34680,964,'et','Muuda valitud ettevÃµtet',0),(34681,964,'si','Uredite izbrano podjetje',0),(34682,964,'ba','Mengedit dipilih perusahaan',0),(34683,964,'nl','Geselecteerde bedrijf bewerken',0),(34684,964,'fi','Muokkaa valitun yrityksen',0),(34685,964,'no','Rediger valgte selskapet',0),(34686,964,'da','Redigere valgte firma',0),(34687,964,'ko','íŽ¸ì§‘ ì„ íƒí•œ íšŒì‚¬',0),(34688,964,'he','×¢×¨×™×›×ª ×—×‘×¨×” ×©× ×‘×—×¨×•',0),(34689,964,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(34690,964,'zh','ç¼–è¾‘é€‰å®šçš„å…¬å¸\r\n',0),(34691,964,'sv','Redigera valda fÃ¶retaget',0),(34692,964,'it','Modifica societÃ  selezionati',0),(34693,964,'tl','',0),(34694,964,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(34695,964,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34696,964,'ms','Edit syarikat terpilih',0),(34697,964,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(34698,964,'fr','Modifier la sociÃ©tÃ© sÃ©lectionnÃ©e',0),(34699,964,'jp','é?¸æŠžã?•ã‚Œã?Ÿä¼šç¤¾ã‚’ç·¨é›†',0),(34700,964,'pt','Editar empresa selecionada',0),(34701,964,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½ÑƒÑŽ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ',0),(34702,964,'es','Editar Empresa Seleccionada',0),(34703,964,'de','Bearbeiten von ausgewÃ¤hlten Unternehmen',0),(34704,964,'en','Edit selected Company',0),(34705,965,'is','',0),(34706,965,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(34707,965,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(34708,965,'tr','SeÃ§ilen kullanÄ±cÄ± dÃ¼zenlemek',0),(34709,965,'pl','EdytowaÄ‡ wybranego uÅ¼ytkownika',0),(34710,965,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(34711,965,'ur','Ù…Ù†ØªØ®Ø¨ ØµØ§Ø±Ù ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34712,965,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(34713,965,'vi','Sá»­a NgÆ°á»i Sá»­ Dá»¥ng Ä‘Ã£ chá»n',0),(34714,965,'af','Redigeer gekiesde gebruiker',0),(34715,965,'ro','Editeaza utilizatorul selectat',0),(34716,965,'et','Muuda valitud kasutajat',0),(34717,965,'si','Uredi izbrani uporabnik',0),(34718,965,'ba','Mengedit dipilih pengguna',0),(34719,965,'nl','Geselecteerde gebruiker bewerken',0),(34720,965,'fi','Muokkaa valitun kÃ¤yttÃ¤jÃ¤n',0),(34721,965,'no','Rediger valgte brukeren',0),(34722,965,'da','Redigere valgte bruger',0),(34723,965,'ko','ì„ íƒí•œ ì‚¬ìš©ìž íŽ¸ì§‘',0),(34724,965,'he','×¢×¨×•×š ×ž×©×ª×ž×© × ×‘×—×¨',0),(34725,965,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(34726,965,'zh','ç¼–è¾‘æ‰€é€‰ç”¨æˆ·\r\n',0),(34727,965,'sv','Redigera vald anvÃ¤ndare',0),(34728,965,'it','Modifica utente selezionato',0),(34729,965,'tl','',0),(34730,965,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(34731,965,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34732,965,'ms','Edit pengguna terpilih',0),(34733,965,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(34734,965,'fr','Modifier utilisateur sÃ©lectionnÃ©',0),(34735,965,'jp','é?¸æŠžã?•ã‚Œã?Ÿãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’ç·¨é›†',0),(34736,965,'pt','Editar usuÃ¡rio selecionado',0),(34737,965,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(34738,965,'es','Editar Usuario Seleccionado',0),(34739,965,'de','AusgewÃ¤hlten Benutzer bearbeiten',0),(34740,965,'en','Edit selected user',0),(34741,966,'is','',0),(34742,966,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ù†ØªØ®Ø§Ø¨',0),(34743,966,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ù†ØªØ®Ø§Ø¨',0),(34744,966,'tr','SeÃ§imi DÃ¼zenle',0),(34745,966,'pl','Edytuj selekcje',0),(34746,966,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐµÐ»ÐµÐºÑ†Ð¸ÑÑ‚Ð°',0),(34747,966,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34748,966,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ñƒ',0),(34749,966,'vi','Sá»­a lá»±a chá»n',0),(34750,966,'af','Redigeer Seleksie',0),(34751,966,'ro','Editare de selecÅ£ie',0),(34752,966,'et','Muuda valikut',0),(34753,966,'si','Urejanje izbor',0),(34754,966,'ba','Edit pilihan',0),(34755,966,'nl','Selectie bewerken',0),(34756,966,'fi','Muokata valinta',0),(34757,966,'no','Rediger valg',0),(34758,966,'da','Rediger valg',0),(34759,966,'ko','ì„ íƒ íŽ¸ì§‘',0),(34760,966,'he','×¢×¨×•×š ×‘×—×™×¨×”',0),(34761,966,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î®',0),(34762,966,'zh','ç¼–è¾‘é€‰æ‹©\r\n',0),(34763,966,'sv','Redigera urval',0),(34764,966,'it','Modifica la selezione',0),(34765,966,'tl','',0),(34766,966,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3623;&#3657;',0),(34767,966,'hi','à¤šà¤¯à¤¨ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34768,966,'ms','Mengedit pilihan',0),(34769,966,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¥Ø®ØªÙŠØ§Ø±',0),(34770,966,'fr','Modifier la sÃ©lection',0),(34771,966,'jp','é?¸æŠžã‚’ç·¨é›†',0),(34772,966,'pt','Editar a seleÃ§Ã£o',0),(34773,966,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð±Ð¾Ñ€',0),(34774,966,'es','Editar SelecciÃ³n',0),(34775,966,'de','Auswahl bearbeiten',0),(34776,966,'en','Edit selection',0),(34777,967,'is','',0),(34778,967,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ù…Ù„ Ø¨Ù‡ ',0),(34779,967,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ù…Ù„ Ø¨Ù‡ ',0),(34780,967,'tr','Gemiye DÃ¼zenle',0),(34781,967,'pl','Edytuj statku',0),(34782,967,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(34783,967,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34784,967,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð±Ñ€Ð¾Ð´',0),(34785,967,'vi','Sá»­a Chuyá»ƒn Äáº¿n',0),(34786,967,'af','Redigeer Versend aan',0),(34787,967,'ro','Editare nava sÄƒ',0),(34788,967,'et','Muuda tarneaadressi',0),(34789,967,'si','Urejanje ladji',0),(34790,967,'ba','Mengedit kapal untuk',0),(34791,967,'nl','Verzendadres bewerken',0),(34792,967,'fi','Muokkaa aluksen',0),(34793,967,'no','Redigere skip',0),(34794,967,'da','Redigere skib til',0),(34795,967,'ko','ë°°ë¥¼ íŽ¸ì§‘',0),(34796,967,'he','×¢×¨×•×š ××ª ×”×¡×¤×™× ×”',0),(34797,967,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ Ï€Î»Î¿Î¯Î¿ Î½Î±',0),(34798,967,'zh','ç¼–è¾‘æ”¶è´§æ–¹\r\n',0),(34799,967,'sv','Redigera fartyget fÃ¶r att',0),(34800,967,'it','Modificare la nave a',0),(34801,967,'tl','',0),(34802,967,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3626;&#3641;&#3656;',0),(34803,967,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34804,967,'ms','Edit kapal',0),(34805,967,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(34806,967,'fr','Modifier le navire Ã ',0),(34807,967,'jp','é…?é€?å…ˆã?®ç·¨é›†',0),(34808,967,'pt','Editar o navio para',0),(34809,967,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(34810,967,'es','Editar Enviar a',0),(34811,967,'de','Schiff zu bearbeiten',0),(34812,967,'en','Edit Ship To',0),(34813,968,'is','',0),(34814,968,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø³Ù…Øª',0),(34815,968,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø³Ù…Øª',0),(34816,968,'tr','Dilim ayrÄ±ntÄ±larÄ± DÃ¼zenle',0),(34817,968,'pl','Edytuj plasterek szczegÃ³Å‚y',0),(34818,968,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð°Ñ€Ñ‡Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(34819,968,'ur','Ù‚Ø§Ø´ ØªÙØµÛŒÙ„Ø§Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34820,968,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð¸ÑÐµÑ‡Ð°Ðº',0),(34821,968,'vi','Sá»­a Chi Tiáº¿t LÃ¡t Cáº¯t',0),(34822,968,'af','Redigeer skyf details',0),(34823,968,'ro','EditaÅ£i detalii felie',0),(34824,968,'et','Viil Ã¼ksikasjade redigeerimine',0),(34825,968,'si','Urejanje podrobnosti rezina',0),(34826,968,'ba','Mengedit rincian slice',0),(34827,968,'nl','Segment details bewerken',0),(34828,968,'fi','Muokkaa-slice',0),(34829,968,'no','Rediger skive detaljer',0),(34830,968,'da','Redigere skive detaljer',0),(34831,968,'ko','ì¡°ê° ì •ë³´ íŽ¸ì§‘',0),(34832,968,'he','×¢×¨×™×›×ª ×¤×¨×˜×™ ×¤×¨×•×¡×”',0),(34833,968,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï†Î­Ï„Î±',0),(34834,968,'zh','ç¼–è¾‘åˆ‡ç‰‡ç»†èŠ‚\r\n',0),(34835,968,'sv','Redigera segment Detaljer',0),(34836,968,'it','Modificare i dettagli della fetta',0),(34837,968,'tl','',0),(34838,968,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3607;&#3637;&#3656;&#3605;&#3633;&#3604;',0),(34839,968,'hi','à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤µà¤¿à¤µà¤°à¤£ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34840,968,'ms','Mengedit butiran slice',0),(34841,968,'ar','ØªØ­Ø±ÙŠØ± ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø´Ø±ÙŠØ­Ø©',0),(34842,968,'fr','Modifier les dÃ©tails de la tranche',0),(34843,968,'jp','ã‚¹ãƒ©ã‚¤ã‚¹è©³ç´°ã?®ç·¨é›†',0),(34844,968,'pt','Editar detalhes de fatia',0),(34845,968,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ„Ñ€Ð°Ð³Ð¼ÐµÐ½Ñ‚Ð¾Ð² Ð´ÐµÑ‚Ð°Ð»ÐµÐ¹',0),(34846,968,'es','Editar detalles de la Rebanada',0),(34847,968,'de','StÃ¼ck Details bearbeiten',0),(34848,968,'en','Edit slice details',0),(34849,969,'is','',0),(34850,969,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ù‚ÙˆÙ‚ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ',0),(34851,969,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ù‚ÙˆÙ‚ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ',0),(34852,969,'tr','Oturum aÃ§ma haklarÄ± DÃ¼zenle',0),(34853,969,'pl','ZgÅ‚oÅ› siÄ™ do systemu prawa do edycji',0),(34854,969,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ñ…Ð¾Ð´ Ð¿Ñ€Ð°Ð²Ð°',0),(34855,969,'ur','Ù„Ø§Ú¯ Ø§Ù† Ø­Ù‚ÙˆÙ‚ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34856,969,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ',0),(34857,969,'vi','Sá»­a Quyá»n ÄÄƒng Nháº­p',0),(34858,969,'af','Redigeer Aantekenregte',0),(34859,969,'ro','Editeaza drepturi de autentificare',0),(34860,969,'et','Login redigeerimisÃµigused',0),(34861,969,'si','Uredi prijavo pravice',0),(34862,969,'ba','Mengedit hak Login',0),(34863,969,'nl','Login rechten bewerken',0),(34864,969,'fi','Muokkaa Kirjaudu oikeudet',0),(34865,969,'no','Redigere logikk rettigheter',0),(34866,969,'da','Redigere Login rettigheder',0),(34867,969,'ko','ë¡œê·¸ì¸ ê¶Œí•œ íŽ¸ì§‘',0),(34868,969,'he','×¢×¨×™×›×ª ×–×›×•×™×•×ª ×›× ×™×¡×”',0),(34869,969,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î´Î¹ÎºÎ±Î¹Ï‰Î¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÏ„Î·',0),(34870,969,'zh','ç¼–è¾‘ç™»å½•æƒé™\r\n',0),(34871,969,'sv','Redigera inloggning rÃ¤ttigheter',0),(34872,969,'it','Modificare i diritti di accesso',0),(34873,969,'tl','',0),(34874,969,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3651;&#3657;&#3594;&#3657;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(34875,969,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34876,969,'ms','Edit hak log masuk',0),(34877,969,'ar','ØªØ­Ø±ÙŠØ± Ø­Ù‚ÙˆÙ‚ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(34878,969,'fr','Modifier les droits de connexion',0),(34879,969,'jp','ãƒ­ã‚°ã‚¤ãƒ³æ¨©åˆ©ã?®ç·¨é›†',0),(34880,969,'pt','Editar direitos de Login',0),(34881,969,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ñ€Ð°Ð²Ð° Ð²Ñ…Ð¾Ð´Ð°',0),(34882,969,'es','Editar Derechos de Login',0),(34883,969,'de','Login Rechte bearbeiten',0),(34884,969,'en','Edit Login Rights',0),(34885,970,'is','',0),(34886,970,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(34887,970,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(34888,970,'tr','SatÄ±cÄ±lar iÃ§in Ã¶ÄŸe DÃ¼zenle',0),(34889,970,'pl','Edytowanie dostawcy dla elementu',0),(34890,970,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(34891,970,'ur','ÙˆÛŒÙ†ÚˆØ±Ø² Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34892,970,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»',0),(34893,970,'vi','Sá»­a NgÆ°á»i BÃ¡n Cá»§a 1 Máº·t HÃ ng',0),(34894,970,'af','Redigeer Verskaffers vir Item',0),(34895,970,'ro','Editare furnizori pentru articol',0),(34896,970,'et','Muuda toote hankijaid',0),(34897,970,'si','Urejanje prodajalci za artikel',0),(34898,970,'ba','Mengedit vendor untuk Item',0),(34899,970,'nl','Leveranciers voor Item bewerken',0),(34900,970,'fi','Muokkaa nimikkeelle',0),(34901,970,'no','Redigere leverandÃ¸rer for vare',0),(34902,970,'da','Redigere leverandÃ¸rer for varen',0),(34903,970,'ko','íŽ¸ì§‘ í•˜ëŠ” í•­ëª©ì— ëŒ€ í•œ ê³µê¸‰ ì—…ì²´',0),(34904,970,'he','×¢×¨×™×›×ª ×¡×¤×§×™× ×¢×‘×•×¨ ×¤×¨×™×˜',0),(34905,970,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï€Ï‰Î»Î·Ï„Î­Ï‚ Î³Î¹Î± Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(34906,970,'zh','ç¼–è¾‘ç‰©å“ä¾›åº”å•†\r\n',0),(34907,970,'sv','Redigera leverantÃ¶rer fÃ¶r objekt',0),(34908,970,'it','Modificare i venditori per elemento',0),(34909,970,'tl','',0),(34910,970,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(34911,970,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34912,970,'ms','Edit pembekal bagi Item',0),(34913,970,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ† Ù„Ù„ØµÙ†Ù',0),(34914,970,'fr','Modifier les fournisseurs pour Ã©lÃ©ment',0),(34915,970,'jp','å“?ç›®æ¥­è€…ã?®ç·¨é›†',0),(34916,970,'pt','Editar os vendedores por Item',0),(34917,970,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð´Ð»Ñ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(34918,970,'es','Editar Proveedores para el Item',0),(34919,970,'de','Anbieter fÃ¼r Artikel bearbeiten',0),(34920,970,'en','Edit Vendors for Item',0),(34921,971,'is','',0),(34922,971,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(34923,971,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(34924,971,'tr','FiÅŸi dÃ¼zenleme',0),(34925,971,'pl','EdytowaÄ‡ zaÅ‚Ä…cznik',0),(34926,971,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(34927,971,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(34928,971,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(34929,971,'vi','Sá»­a Phiáº¿u',0),(34930,971,'af','Redigeer Bewysstuk',0),(34931,971,'ro','Editare Voucher',0),(34932,971,'et','Muuda kande',0),(34933,971,'si','Kupona urejanje',0),(34934,971,'ba','Mengedit Voucher',0),(34935,971,'nl','Voucher bewerken',0),(34936,971,'fi','Muokkaa tosite',0),(34937,971,'no','Redigere bilag',0),(34938,971,'da','Redigere Voucher',0),(34939,971,'ko','ë°”ìš°ì²˜ë¥¼ íŽ¸ì§‘',0),(34940,971,'he','×¢×¨×™×›×ª ×©×•×‘×¨',0),(34941,971,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(34942,971,'zh','ç¼–è¾‘åˆ¸\r\n',0),(34943,971,'sv','Redigera verifikation',0),(34944,971,'it','Modifica Voucher',0),(34945,971,'tl','',0),(34946,971,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(34947,971,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(34948,971,'ms','Edit baucar',0),(34949,971,'ar','ØªØ­Ø±ÙŠØ± Ù‚Ø³ÙŠÙ…Ø©',0),(34950,971,'fr','Edit bon',0),(34951,971,'jp','ä¼?ç¥¨ã‚’ç·¨é›†',0),(34952,971,'pt','Editar Voucher',0),(34953,971,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(34954,971,'es','Editar Voucher',0),(34955,971,'de','Bearbeiten Gutschein',0),(34956,971,'en','Edit Voucher',0),(34957,972,'is','',0),(34958,972,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ¯Ø§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØŸ ',0),(34959,972,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ¯Ø§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØŸ ',0),(34960,972,'tr','Hangi bilgileri dÃ¼zenleyin.',0),(34961,972,'pl','EdytowaÄ‡ informacje?',0),(34962,972,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ?',0),(34963,972,'ur','Ø¬Ø³ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚºØŸ',0),(34964,972,'sr','Ð£Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ ÐºÐ¾Ñ˜Ðµ?',0),(34965,972,'vi','Sá»­a ThÃ´ng Tin NÃ o?',0),(34966,972,'af','Redigeer Watter Inligting?',0),(34967,972,'ro','EditaÅ£i informaÅ£iile?',0),(34968,972,'et','Millist informatsiooni muuta?',0),(34969,972,'si','Urejanje katere informacije?',0),(34970,972,'ba','Mengedit informasi yang?',0),(34971,972,'nl','Welke informatie bewerken?',0),(34972,972,'fi','Muokata tiedot?',0),(34973,972,'no','Redigere informasjon?',0),(34974,972,'da','Rediger hvilke oplysninger?',0),(34975,972,'ko','ì •ë³´ë¥¼ ìˆ˜ì •?',0),(34976,972,'he','×œ×¢×¨×•×š ××™×–×” ×ž×™×“×¢?',0),(34977,972,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚;',0),(34978,972,'zh','ç¼–è¾‘å“ªäº›ä¿¡æ¯ï¼Ÿ\r\n',0),(34979,972,'sv','Redigera vilken Information?',0),(34980,972,'it','Modificare le informazioni che?',0),(34981,972,'tl','',0),(34982,972,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3633;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3629;&#3633;&#3609;&#3652;&#3627;&#3609;?',0),(34983,972,'hi','à¤œà¥‹ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚?',0),(34984,972,'ms','Edit maklumat yang?',0),(34985,972,'ar','ØªØ­Ø±ÙŠØ± Ø£ÙŠÙ‘ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØŸ',0),(34986,972,'fr','Modifier les informations ?',0),(34987,972,'jp','ã?©ã?®æƒ…å ±ã‚’ç·¨é›†ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(34988,972,'pt','Editar a informaÃ§Ã£o?',0),(34989,972,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐšÐ°ÐºÑƒÑŽ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ?',0),(34990,972,'es','Editar Cual InformaciÃ³n',0),(34991,972,'de','Bearbeiten Sie die Informationen?',0),(34992,972,'en','Edit Which Information?',0),(34993,973,'is','',0),(34994,973,'dr','EIC  ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯',0),(34995,973,'pr','EIC  ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯',0),(34996,973,'tr','EIC',0),(34997,973,'pl','EIC',0),(34998,973,'bg','Ð•Ð˜Ð¦',0),(34999,973,'ur','EIC',0),(35000,973,'sr','Ð•Ð˜Ð¦',0),(35001,973,'vi','EIC',0),(35002,973,'af','EIC',0),(35003,973,'ro','EIC',0),(35004,973,'et','EIC',0),(35005,973,'si','EIC',0),(35006,973,'ba','EIC',0),(35007,973,'nl','EIC',0),(35008,973,'fi','EIC',0),(35009,973,'no','EIC',0),(35010,973,'da','EIC',0),(35011,973,'ko','EIC',0),(35012,973,'he','EIC',0),(35013,973,'el','Î•ÎšÎ ',0),(35014,973,'zh','é›‡ä¸»è¯†åˆ«ç \r\n',0),(35015,973,'sv','EIC',0),(35016,973,'it','EIC',0),(35017,973,'tl','',0),(35018,973,'th','EIC',0),(35019,973,'hi','EIC',0),(35020,973,'ms','EIC',0),(35021,973,'ar','Ø¥ÙŠÙƒ',0),(35022,973,'fr','CPN',0),(35023,973,'jp','EIC',0),(35024,973,'pt','EIC',0),(35025,973,'ru','Ð•Ð˜Ð¦',0),(35026,973,'es','EIC',0),(35027,973,'de','EIC',0),(35028,973,'en','EIC',0),(35029,974,'is','',0),(35030,974,'dr','EIC Ø§Ø¹ØªØ¨Ø§Ø± ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯',0),(35031,974,'pr','EIC Ø§Ø¹ØªØ¨Ø§Ø± ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯\r\n',0),(35032,974,'tr','EIC kredi',0),(35033,974,'pl','EIC kredytu',0),(35034,974,'bg','Ð•Ð˜Ð¦ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(35035,974,'ur','Ú©Ø±ÛŒÚˆÙ¹',0),(35036,974,'sr','Ð•Ð˜Ð¦ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ',0),(35037,974,'vi','TÃ­n Dá»¥ng EIC',0),(35038,974,'af','EIC krediet',0),(35039,974,'ro','EIC Credit',0),(35040,974,'et','EIC krediidi',0),(35041,974,'si','EIC kreditne',0),(35042,974,'ba','Kredit EIC',0),(35043,974,'nl','EIC krediet',0),(35044,974,'fi','EIC luotto',0),(35045,974,'no','EIC kreditt',0),(35046,974,'da','EIC kredit',0),(35047,974,'ko','EIC ì‹ ìš©',0),(35048,974,'he','×§×¨×“×™×˜ EIC',0),(35049,974,'el','Î•ÎšÎ  Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½',0),(35050,974,'zh','é›‡ä¸»è¯†åˆ«ä¿¡ç”¨\r\n',0),(35051,974,'sv','EIC kredit',0),(35052,974,'it','Credito EIC',0),(35053,974,'tl','',0),(35054,974,'th','EIC &#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(35055,974,'hi','EIC à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(35056,974,'ms','EIC kredit',0),(35057,974,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¥ÙŠÙƒ',0),(35058,974,'fr','CrÃ©dit CPN',0),(35059,974,'jp','EICè²¸æ–¹',0),(35060,974,'pt','CrÃ©dito EIC',0),(35061,974,'ru','Ð•Ð˜Ð¦ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(35062,974,'es','EIC CrÃ©dito',0),(35063,974,'de','EIC Credit',0),(35064,974,'en','EIC Credit',0),(35065,975,'is','',0),(35066,975,'dr','EIC    ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ Ù…ØªØ§Ù‡Ù„ ',0),(35067,975,'pr','EIC    ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ Ù…ØªØ§Ù‡Ù„ ',0),(35068,975,'tr','EIC evlendi',0),(35069,975,'pl','EIC Å¼onaty',0),(35070,975,'bg','Ð•Ð˜Ð¦ Ð¶ÐµÐ½ÐµÐ½',0),(35071,975,'ur','Ø³Û’ Ø´Ø§Ø¯ÛŒ Ú©ÛŒ',0),(35072,975,'sr','Ð•Ð˜Ð¦ Ñƒ Ð±Ñ€Ð°ÐºÑƒ',0),(35073,975,'vi','ÄÃ£ káº¿t hÃ´n EIC',0),(35074,975,'af','EIC getroud',0),(35075,975,'ro','EIC cÄƒsÄƒtorit',0),(35076,975,'et','EIC abielus',0),(35077,975,'si','EIC poroÄen',0),(35078,975,'ba','Menikah EIC',0),(35079,975,'nl','EIC getrouwd',0),(35080,975,'fi','EIC naimisissa',0),(35081,975,'no','EIC gift',0),(35082,975,'da','EIC gift',0),(35083,975,'ko','EIC ê²°í˜¼',0),(35084,975,'he','× ×©×•×™ EIC',0),(35085,975,'el','Î Î±Î½Ï„ÏÎµÎ¼Î­Î½Î¿Ï‚ Î•ÎšÎ ',0),(35086,975,'zh','ä¸‰ç”µå·²å©š\r\n',0),(35087,975,'sv','EIC gift',0),(35088,975,'it','SposÃ² EIC',0),(35089,975,'tl','',0),(35090,975,'th','EIC &#3626;&#3617;&#3619;&#3626;&#3649;&#3621;&#3657;&#3623;',0),(35091,975,'hi','EIC à¤¶à¤¾à¤¦à¥€',0),(35092,975,'ms','Berkahwin dengan EIC',0),(35093,975,'ar','ØªØ²ÙˆØ¬ Ø¥ÙŠÙƒ',0),(35094,975,'fr','CPN mariÃ©',0),(35095,975,'jp','EICæ—¢å©š',0),(35096,975,'pt','EIC casado',0),(35097,975,'ru','Ð•Ð˜Ð¦ Ð¶ÐµÐ½Ð¸Ð»ÑÑ',0),(35098,975,'es','EIC Casado',0),(35099,975,'de','EIC verheiratet',0),(35100,975,'en','EIC Married',0),(35101,976,'is','',0),(35102,976,'dr','EIC    ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ Ù…Ø¬Ø±Ø¯',0),(35103,976,'pr','EIC    ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ Ù…Ø¬Ø±Ø¯',0),(35104,976,'tr','EIC tek',0),(35105,976,'pl','Jeden EIC',0),(35106,976,'bg','Ð•Ð˜Ð¦ ÑÐ¸Ð½Ð³ÑŠÐ»',0),(35107,976,'ur','ÙˆØ§Ø­Ø¯',0),(35108,976,'sr','Ð•Ð˜Ð¦ ÑÐ¸Ð½Ð³Ð»',0),(35109,976,'vi','Äá»™c thÃ¢n EIC',0),(35110,976,'af','EIC enkel',0),(35111,976,'ro','EIC Single',0),(35112,976,'et','EIC Ã¼he',0),(35113,976,'si','EIC eno',0),(35114,976,'ba','EIC Single',0),(35115,976,'nl','EIC Single',0),(35116,976,'fi','EIC yhden',0),(35117,976,'no','EIC enkelt',0),(35118,976,'da','EIC Single',0),(35119,976,'ko','EIC ë‹¨ì¼',0),(35120,976,'he','×™×—×™×“×” EIC',0),(35121,976,'el','Î•Î½Î¹Î±Î¯Î± Î•ÎšÎ ',0),(35122,976,'zh','é›‡ä¸»è¯†åˆ«å•èº«\r\n',0),(35123,976,'sv','EIC singel',0),(35124,976,'it','EIC singolo',0),(35125,976,'tl','',0),(35126,976,'th','EIC &#3650;&#3626;&#3604;',0),(35127,976,'hi','EIC à¤à¤•à¤²',0),(35128,976,'ms','EIC tunggal',0),(35129,976,'ar','Ø¥ÙŠÙƒ ÙˆØ§Ø­Ø¯',0),(35130,976,'fr','Single CPN',0),(35131,976,'jp','EICæœªå©š',0),(35132,976,'pt','EIC Single',0),(35133,976,'ru','Ð•Ð˜Ð¦ ÑÐ¸Ð½Ð³Ð»',0),(35134,976,'es','EIC Soltero',0),(35135,976,'de','EIC Single',0),(35136,976,'en','EIC Single',0),(35137,977,'is','',0),(35138,977,'dr','Ù‡Ø´Øª ',0),(35139,977,'pr','Ù‡Ø´Øª ',0),(35140,977,'tr','sekiz',0),(35141,977,'pl','osiem',0),(35142,977,'bg','Ð¾ÑÐµÐ¼',0),(35143,977,'ur','Ø¢Ù¹Ú¾',0),(35144,977,'sr','Ð¾ÑÐ°Ð¼',0),(35145,977,'vi','tÃ¡m',0),(35146,977,'af','agt',0),(35147,977,'ro','opt',0),(35148,977,'et','kaheksa',0),(35149,977,'si','osem',0),(35150,977,'ba','delapan',0),(35151,977,'nl','acht',0),(35152,977,'fi','kahdeksan',0),(35153,977,'no','Ã¥tte',0),(35154,977,'da','otte',0),(35155,977,'ko','8',0),(35156,977,'he','×©×ž×•× ×”',0),(35157,977,'el','Î¿ÎºÏ„ÏŽ',0),(35158,977,'zh','å…«\r\n',0),(35159,977,'sv','Ã¥tta',0),(35160,977,'it','otto',0),(35161,977,'tl','',0),(35162,977,'th','&#3649;&#3611;&#3604;',0),(35163,977,'hi','à¤†à¤ ',0),(35164,977,'ms','lapan',0),(35165,977,'ar','Ø«Ù…Ø§Ù†ÙŠØ©',0),(35166,977,'fr','huit',0),(35167,977,'jp','8',0),(35168,977,'pt','oito',0),(35169,977,'ru','Ð²Ð¾ÑÐµÐ¼ÑŒ',0),(35170,977,'es','ocho',0),(35171,977,'de','acht',0),(35172,977,'en','eight',0),(35173,978,'is','',0),(35174,978,'dr','Ù‡Ø¬Ø¯Ù‡ ',0),(35175,978,'pr','Ù‡Ø¬Ø¯Ù‡ ',0),(35176,978,'tr','on sekiz',0),(35177,978,'pl','osiemnaÅ›cie',0),(35178,978,'bg','Ð¾ÑÐµÐ¼Ð½Ð°Ð´ÐµÑÐµÑ‚',0),(35179,978,'ur','Ø§Ù¹Ú¾Ø§Ø±Û',0),(35180,978,'sr','Ð¾ÑÐ°Ð¼Ð½Ð°ÐµÑÑ‚ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(35181,978,'vi','mÆ°á»i tÃ¡m',0),(35182,978,'af','agtien',0),(35183,978,'ro','optsprezece ani',0),(35184,978,'et','kaheksateist',0),(35185,978,'si','osemnajst let',0),(35186,978,'ba','delapan belas',0),(35187,978,'nl','achttien',0),(35188,978,'fi','kahdeksantoista',0),(35189,978,'no','atten',0),(35190,978,'da','atten',0),(35191,978,'ko','18',0),(35192,978,'he','×©×ž×•× ×” ×¢×©×¨×”',0),(35193,978,'el','Î´ÎµÎºÎ±Î¿ÎºÏ„ÏŽ',0),(35194,978,'zh','åå…«\r\n',0),(35195,978,'sv','arton',0),(35196,978,'it','diciotto anni',0),(35197,978,'tl','',0),(35198,978,'th','&#3626;&#3636;&#3610;&#3649;&#3611;&#3604;',0),(35199,978,'hi','à¤…à¤ à¤¾à¤°à¤¹',0),(35200,978,'ms','lapan belas',0),(35201,978,'ar','Ø«Ù…Ø§Ù†ÙŠØ© Ø¹Ø´Ø±Ø©',0),(35202,978,'fr','dix-huit ans',0),(35203,978,'jp','18',0),(35204,978,'pt','dezoito anos',0),(35205,978,'ru','Ð’Ð¾ÑÐµÐ¼Ð½Ð°Ð´Ñ†Ð°Ñ‚ÑŒ',0),(35206,978,'es','dieciocho',0),(35207,978,'de','achtzehn',0),(35208,978,'en','eighteen',0),(35209,979,'is','',0),(35210,979,'dr','Ù‡Ø´ØªØ§Ø¯ ',0),(35211,979,'pr','Ù‡Ø´ØªØ§Ø¯ ',0),(35212,979,'tr','seksen',0),(35213,979,'pl','osiemdziesiÄ…t',0),(35214,979,'bg','Ð¾ÑÐµÐ¼Ð´ÐµÑÐµÑ‚',0),(35215,979,'ur','Û¸Û°',0),(35216,979,'sr','ÐžÑÐ°Ð¼Ð´ÐµÑÐµÑ‚',0),(35217,979,'vi','tÃ¡m mÆ°Æ¡i',0),(35218,979,'af','tagtig',0),(35219,979,'ro','optzeci',0),(35220,979,'et','kaheksakÃ¼mmend',0),(35221,979,'si','osemdeset',0),(35222,979,'ba','delapan puluh',0),(35223,979,'nl','tachtig',0),(35224,979,'fi','kahdeksankymmentÃ¤',0),(35225,979,'no','Ã¥tti',0),(35226,979,'da','Firs',0),(35227,979,'ko','80',0),(35228,979,'he','×©×ž×•× ×™×',0),(35229,979,'el','Î¿Î³Î´ÏŒÎ½Ï„Î±',0),(35230,979,'zh','å…«å\r\n',0),(35231,979,'sv','Ã¥ttio',0),(35232,979,'it','ottanta',0),(35233,979,'tl','',0),(35234,979,'th','&#3649;&#3611;&#3604;&#3626;&#3636;&#3610;',0),(35235,979,'hi','à¤…à¤¸à¥à¤¸à¥€',0),(35236,979,'ms','lapan puluh',0),(35237,979,'ar','Ø«Ù…Ø§Ù†ÙˆÙ†',0),(35238,979,'fr','quatre-vingts',0),(35239,979,'jp','80',0),(35240,979,'pt','oitenta',0),(35241,979,'ru','Ð²Ð¾ÑÐµÐ¼ÑŒÐ´ÐµÑÑÑ‚',0),(35242,979,'es','ochenta',0),(35243,979,'de','achtzig',0),(35244,979,'en','eighty',0),(35245,980,'is','',0),(35246,980,'dr','ÙŠØ§Ø²Ø¯Ù‡ ',0),(35247,980,'pr','ÙŠØ§Ø²Ø¯Ù‡ ',0),(35248,980,'tr','Onbir',0),(35249,980,'pl','jedenaÅ›cie',0),(35250,980,'bg','ÐµÐ´Ð¸Ð½Ð°Ð´ÐµÑÐµÑ‚',0),(35251,980,'ur','Ú¯ÛŒØ§Ø±Û',0),(35252,980,'sr','Ñ˜ÐµÐ´Ð°Ð½Ð°ÐµÑÑ‚',0),(35253,980,'vi','mÆ°á»i má»™t',0),(35254,980,'af','elf',0),(35255,980,'ro','unsprezece',0),(35256,980,'et','Ã¼ksteist',0),(35257,980,'si','enajst',0),(35258,980,'ba','sebelas',0),(35259,980,'nl','elf',0),(35260,980,'fi','yksitoista',0),(35261,980,'no','elleve',0),(35262,980,'da','elleve',0),(35263,980,'ko','11',0),(35264,980,'he','××—×“ ×¢×©×¨×”',0),(35265,980,'el','Î­Î½Ï„ÎµÎºÎ±',0),(35266,980,'zh','åä¸€\r\n',0),(35267,980,'sv','elva',0),(35268,980,'it','undici',0),(35269,980,'tl','',0),(35270,980,'th','&#3626;&#3636;&#3610;&#3648;&#3629;&#3655;&#3604;',0),(35271,980,'hi','à¤—à¥à¤¯à¤¾à¤°à¤¹',0),(35272,980,'ms','sebelas',0),(35273,980,'ar','Ø¥Ø­Ø¯Ù‰ Ø¹Ø´Ø±Ø©',0),(35274,980,'fr','onze',0),(35275,980,'jp','11',0),(35276,980,'pt','onze',0),(35277,980,'ru','ÐžÐ´Ð¸Ð½Ð½Ð°Ð´Ñ†Ð°Ñ‚ÑŒ',0),(35278,980,'es','once',0),(35279,980,'de','elf',0),(35280,980,'en','eleven',0),(35281,981,'is','',0),(35282,981,'dr','Ø§ÙŠÙ…ÙŠÙ„ ',0),(35283,981,'pr','Ø§ÙŠÙ…ÙŠÙ„ ',0),(35284,981,'tr','E-posta',0),(35285,981,'pl','Adres e-mail',0),(35286,981,'bg','Ð˜Ð¼ÐµÐ¹Ð»',0),(35287,981,'ur','Ø§ÛŒ Ù…ÛŒÙ„',0),(35288,981,'sr','Ð•-Ð¿Ð¾ÑˆÑ‚Ð°',0),(35289,981,'vi','Email',0),(35290,981,'af','E-pos',0),(35291,981,'ro','E-mail',0),(35292,981,'et','E-mail',0),(35293,981,'si','Email',0),(35294,981,'ba','Email',0),(35295,981,'nl','E-mail',0),(35296,981,'fi','SÃ¤hkÃ¶posti',0),(35297,981,'no','E-post',0),(35298,981,'da','E-mail',0),(35299,981,'ko','ë©”ì¼ ì£¼ì†Œ',0),(35300,981,'he','×“×•×\"×œ',0),(35301,981,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(35302,981,'zh','ç”µå­é‚®ä»¶\r\n',0),(35303,981,'sv','E-post',0),(35304,981,'it','Posta elettronica',0),(35305,981,'tl','',0),(35306,981,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(35307,981,'hi','à¤ˆà¤®à¥‡à¤²',0),(35308,981,'ms','E-mel',0),(35309,981,'ar','Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(35310,981,'fr','Courriel',0),(35311,981,'jp','E-ãƒ¡ãƒ¼ãƒ«',0),(35312,981,'pt','Email',0),(35313,981,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(35314,981,'es','E-mail',0),(35315,981,'de','E-Mail',0),(35316,981,'en','Email',0),(35317,982,'is','',0),(35318,982,'dr','Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(35319,982,'pr','Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(35320,982,'tr','E-posta adresi',0),(35321,982,'pl','Adres e-mail',0),(35322,982,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ',0),(35323,982,'ur','Ø§ÛŒ-Ù…ÛŒÙ„ Ù¾ØªØ§',0),(35324,982,'sr','ÐÐ´Ñ€ÐµÑÐ° Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(35325,982,'vi','Äá»‹a chá»‰ Email',0),(35326,982,'af','E-pos Adres',0),(35327,982,'ro','Adresa de e-mail',0),(35328,982,'et','E-maili aadress',0),(35329,982,'si','E-poÅ¡tni naslov',0),(35330,982,'ba','Alamat e-mail',0),(35331,982,'nl','E-mailadres',0),(35332,982,'fi','SÃ¤hkÃ¶postiosoite',0),(35333,982,'no','E-postadresse',0),(35334,982,'da','E-mail-adresse',0),(35335,982,'ko','ì „ìž ë©”ì¼ ì£¼ì†Œ',0),(35336,982,'he','×›×ª×•×‘×ª ×“×•×\"×œ',0),(35337,982,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(35338,982,'zh','ç”µé‚®åœ°å€\r\n',0),(35339,982,'sv','E-postadress',0),(35340,982,'it','Indirizzo di posta elettronica',0),(35341,982,'tl','',0),(35342,982,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(35343,982,'hi','à¤ˆ-à¤®à¥‡à¤² à¤ªà¤¤à¤¾',0),(35344,982,'ms','Alamat e-mel',0),(35345,982,'ar','Ø¹Ù†ÙˆØ§Ù† Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(35346,982,'fr','Address du courriel',0),(35347,982,'jp','Eãƒ¡ãƒ¼ãƒ«ã‚¢ãƒ‰ãƒ¬ã‚¹',0),(35348,982,'pt','EndereÃ§o de email',0),(35349,982,'ru','E-mail ÐÐ´Ñ€ÐµÑ',0),(35350,982,'es','Email DirecciÃ³n',0),(35351,982,'de','E-Mail-Adresse',0),(35352,982,'en','E-mail Address',0),(35353,983,'is','',0),(35354,983,'dr','Ø´Ø±Ø­ Ø§ÙŠÙ…ÙŠÙ„ ',0),(35355,983,'pr','Ø´Ø±Ø­ Ø§ÙŠÙ…ÙŠÙ„ ',0),(35356,983,'tr','E-posta aÃ§Ä±klamasÄ±',0),(35357,983,'pl','Opis e-mail',0),(35358,983,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð»',0),(35359,983,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(35360,983,'sr','ÐžÐ¿Ð¸Ñ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(35361,983,'vi','Diá»…n giáº£i Email',0),(35362,983,'af','E-pos Beskrywing',0),(35363,983,'ro','E-mail Descriere',0),(35364,983,'et','E-posti kirjeldus',0),(35365,983,'si','Opis e-poÅ¡tnega',0),(35366,983,'ba','Deskripsi e-mail',0),(35367,983,'nl','E-beschrijving',0),(35368,983,'fi','SÃ¤hkÃ¶postin kuvaus',0),(35369,983,'no','E-beskrivelse',0),(35370,983,'da','E-mail-beskrivelse',0),(35371,983,'ko','ë©”ì¼ ì„¤ëª…',0),(35372,983,'he','×ª×™××•×¨ ×“×•×\"×œ',0),(35373,983,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(35374,983,'zh','ç”µå­é‚®ä»¶è¯´æ˜Ž\r\n',0),(35375,983,'sv','E-Beskrivning',0),(35376,983,'it','E-mail Descrizione',0),(35377,983,'tl','',0),(35378,983,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(35379,983,'hi','à¤ˆ-à¤®à¥‡à¤² à¤µà¤°à¥à¤£à¤¨',0),(35380,983,'ms','E-mel keterangan',0),(35381,983,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(35382,983,'fr','Description de l\'e-mail',0),(35383,983,'jp','Eãƒ¡ãƒ¼ãƒ«è§£èª¬',0),(35384,983,'pt','E-mail descriÃ§Ã£o',0),(35385,983,'ru','E-mail ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(35386,983,'es','Email DescripciÃ³n',0),(35387,983,'de','E-Mail Beschreibung',0),(35388,983,'en','E-mail Description',0),(35389,984,'is','',0),(35390,984,'dr','Ø§ÙŠÙ…ÙŠÙ„ ÙŠÙƒ ',0),(35391,984,'pr','Ø§ÙŠÙ…ÙŠÙ„ ÙŠÙƒ ',0),(35392,984,'tr','Bir e-posta',0),(35393,984,'pl','Jeden e-mail',0),(35394,984,'bg','Ð•Ð´Ð¸Ð½ Ðµ-Ð¼ÐµÐ¹Ð»',0),(35395,984,'ur','Ø§ÛŒÚ© Ø§ÛŒ Ù…ÛŒÙ„',0),(35396,984,'sr','ÐˆÐµÐ´Ð°Ð½ Ðµ-Ð¼Ð°Ð¸Ð»',0),(35397,984,'vi','Email Má»™t',0),(35398,984,'af','E-pos Een',0),(35399,984,'ro','E-mail unul',0),(35400,984,'et','E-post 1',0),(35401,984,'si','E-mail eden',0),(35402,984,'ba','E-mail satu',0),(35403,984,'nl','E-mail een',0),(35404,984,'fi','SÃ¤hkÃ¶posti yksi',0),(35405,984,'no','E-post en',0),(35406,984,'da','E-mail en',0),(35407,984,'ko','í•˜ë‚˜ì˜ ì „ìž ë©”ì¼',0),(35408,984,'he','×“×•××¨ ××œ×§×˜×¨×•× ×™ ××—×“',0),(35409,984,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Î­Î½Î± e-mail',0),(35410,984,'zh','ç”µå­é‚®ä»¶ä¸€\r\n',0),(35411,984,'sv','E-post en',0),(35412,984,'it','E-mail uno',0),(35413,984,'tl','',0),(35414,984,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3607;&#3637;&#3656; 1 ',0),(35415,984,'hi','à¤à¤• à¤ˆ-à¤®à¥‡à¤² à¤•à¤°à¥‡à¤‚',0),(35416,984,'ms','E-mel seseorang',0),(35417,984,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø£ÙˆÙ„',0),(35418,984,'fr','Un e-mail',0),(35419,984,'jp','Eãƒ¡ãƒ¼ãƒ«ã€€ï¼‘',0),(35420,984,'pt','Um e-mail',0),(35421,984,'ru','E-mail ÐžÐ´Ð¸Ð½',0),(35422,984,'es','Email Uno',0),(35423,984,'de','Eine e-Mail',0),(35424,984,'en','E-mail One',0),(35425,985,'is','',0),(35426,985,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(35427,985,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(35428,985,'tr','E-posta alÄ±ntÄ±',0),(35429,985,'pl','E-Mail cytatem',0),(35430,985,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ð¿Ð¾Ñ‰Ð°',0),(35431,985,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø§Ù‚ØªØ¨Ø§Ø³',0),(35432,985,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ðµ-Ð¿Ð¾ÑˆÑ‚Ñƒ',0),(35433,985,'vi','Email bÃ¡o giÃ¡',0),(35434,985,'af','E-pos Kwotasie',0),(35435,985,'ro','Citat de e-Mail',0),(35436,985,'et','E-post tsiteerida',0),(35437,985,'si','E-Mail ponudba',0),(35438,985,'ba','E-Mail kutipan',0),(35439,985,'nl','E-offerte',0),(35440,985,'fi','SÃ¤hkÃ¶postitse tarjouksen',0),(35441,985,'no','E-tilbud',0),(35442,985,'da','E-mail-tilbud',0),(35443,985,'ko','ì „ìž ê²¬ì ',0),(35444,985,'he','×“×•××¨ ××œ×§×˜×¨×•× ×™ ×”×¦×¢×ª ×ž×—×™×¨',0),(35445,985,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ e-Mail',0),(35446,985,'zh','ç”µå­é‚®ä»¶æŠ¥ä»·\r\n',0),(35447,985,'sv','E-offert',0),(35448,985,'it','Citazione di e-Mail',0),(35449,985,'tl','',0),(35450,985,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(35451,985,'hi','à¤ˆ à¤®à¥‡à¤² à¤¬à¥‹à¤²à¥€',0),(35452,985,'ms','Petikan e-mel',0),(35453,985,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ø¨Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(35454,985,'fr','E-Mail Devis',0),(35455,985,'jp','è¦‹ç©?ã‚‚ã‚Šã‚’Eãƒ¡ãƒ¼ãƒ«ã?™ã‚‹',0),(35456,985,'pt','E-Mail cotaÃ§Ã£o',0),(35457,985,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð¦Ð¸Ñ‚Ð°Ñ‚Ð°',0),(35458,985,'es','Email CotizaciÃ³n',0),(35459,985,'de','E-Mail-Angebot',0),(35460,985,'en','E-Mail Quote',0),(35461,986,'is','',0),(35462,986,'dr','Ø§ÙŠÙ…ÙŠÙ„ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ Ø¨Ù‡',0),(35463,986,'pr','Ø§ÙŠÙ…ÙŠÙ„ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ Ø¨Ù‡',0),(35464,986,'tr','GÃ¶nderilen e-postalar',0),(35465,986,'pl','E-mail wysÅ‚any do',0),(35466,986,'bg','Ð˜Ð¼ÐµÐ¹Ð»Ð¸, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð´Ð¾',0),(35467,986,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(35468,986,'sr','ÐŸÐ¾ÑÐ»Ð°Ñ‚Ð¸ Ðµ-Ð¿Ð¾ÑˆÑ‚Ñƒ',0),(35469,986,'vi','Email gá»­i tá»›i',0),(35470,986,'af','E-pos Gestuur vir',0),(35471,986,'ro','PoÅŸta electronicÄƒ trimisÄƒ cÄƒtre',0),(35472,986,'et','E-kiri saadeti jÃ¤rgnevale:',0),(35473,986,'si','E-poÅ¡ta, poslana',0),(35474,986,'ba','E-mail yang dikirim ke',0),(35475,986,'nl','E-mail gestuurd naar',0),(35476,986,'fi','LÃ¤hetetyt sÃ¤hkÃ¶postiviestit',0),(35477,986,'no','E-post',0),(35478,986,'da','E-mail sendt til',0),(35479,986,'ko','ì „ìž ë©”ì¼ ì „ì†¡',0),(35480,986,'he','×“×•××¨ ××œ×§×˜×¨×•× ×™ ×”× ×©×œ×— ××œ',0),(35481,986,'el','E-mail Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(35482,986,'zh','ç”µå­é‚®ä»¶å‘é€åˆ°\r\n',0),(35483,986,'sv','E-post skickas till',0),(35484,986,'it','E-mail inviata a',0),(35485,986,'tl','',0),(35486,986,'th','&#3626;&#3656;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3606;&#3638;&#3591;',0),(35487,986,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤ˆ-à¤®à¥‡à¤²',0),(35488,986,'ms','E-mel yang dihantar kepada',0),(35489,986,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¥Ù„Ù‰',0),(35490,986,'fr','Courriel envoyÃ© Ã ',0),(35491,986,'jp','Eãƒ¡ãƒ¼ãƒ«ã€€é€?ä»˜å…ˆ',0),(35492,986,'pt','Email enviado para',0),(35493,986,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð°Ñ Ð¿Ð¾Ñ‡Ñ‚Ð°, Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ð°Ñ',0),(35494,986,'es','Email enviada a',0),(35495,986,'de','E-Mail an',0),(35496,986,'en','E-mail sent to',0),(35497,987,'is','',0),(35498,987,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(35499,987,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(35500,987,'tr','MÃ¼ÅŸteriye e-posta',0),(35501,987,'pl','E-mail do klienta',0),(35502,987,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(35503,987,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒ Ù…ÛŒÙ„',0),(35504,987,'sr','Ð• -Ð¿Ð¾Ñ€ÑƒÐºÐµ Ð½Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(35505,987,'vi','Email cho khÃ¡ch hÃ ng ',0),(35506,987,'af','E-pos aan kliÃ«nt/klant',0),(35507,987,'ro','E-mail client',0),(35508,987,'et','Saada kliendile e-kiri',0),(35509,987,'si','E-mail za kupca',0),(35510,987,'ba','E-mail ke pelanggan',0),(35511,987,'nl','E-mail aan klant',0),(35512,987,'fi','SÃ¤hkÃ¶posti asiakkaalle',0),(35513,987,'no','E-post til kunde',0),(35514,987,'da','E-mail til kunde',0),(35515,987,'ko','ê³ ê°ì— ê²Œ ì „ìž ë©”ì¼',0),(35516,987,'he','×“×•××¨ ××œ×§×˜×¨×•× ×™ ×œ×œ×§×•×—',0),(35517,987,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Ï€ÎµÎ»Î¬Ï„Î·',0),(35518,987,'zh','ç”µé‚®ç»™å®¢æˆ·\r\n',0),(35519,987,'sv','E-post till kunden',0),(35520,987,'it','E-mail al cliente',0),(35521,987,'tl','',0),(35522,987,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3606;&#3638;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(35523,987,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹ à¤ˆ-à¤®à¥‡à¤² à¤•à¤°à¥‡à¤‚',0),(35524,987,'ms','E-mel kepada pelanggan',0),(35525,987,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¹Ù…ÙŠÙ„',0),(35526,987,'fr','E-mail au client',0),(35527,987,'jp','é¡§å®¢ã?¸ã?®Eãƒ¡ãƒ¼ãƒ«',0),(35528,987,'pt','Um e-mail ao cliente',0),(35529,987,'ru','E-mail Ð´Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(35530,987,'es','Email a Cliente',0),(35531,987,'de','E-Mail an Kunden',0),(35532,987,'en','E-mail to customer',0),(35533,988,'is','',0),(35534,988,'dr','2 ',0),(35535,988,'pr','Ø§ÙŠÙ…ÙŠÙ„ 2 ',0),(35536,988,'tr','Ä°ki e-posta',0),(35537,988,'pl','Dwa e-mail',0),(35538,988,'bg','Ð•Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ð¿Ð¾Ñ‰Ð° Ð´Ð²Ðµ',0),(35539,988,'ur','Ø¯Ùˆ Ø§ÛŒ Ù…ÛŒÙ„',0),(35540,988,'sr','Ð• -Ð¿Ð¾ÑˆÑ‚Ðµ 2',0),(35541,988,'vi','Email Hai',0),(35542,988,'af','E-pos Twee',0),(35543,988,'ro','DouÄƒ e-mail',0),(35544,988,'et','E-mail 2',0),(35545,988,'si','E-mail dve',0),(35546,988,'ba','E-mail dua',0),(35547,988,'nl','E-twee',0),(35548,988,'fi','SÃ¤hkÃ¶posti kaksi',0),(35549,988,'no','E-to',0),(35550,988,'da','E-mail to',0),(35551,988,'ko','ì „ìž ë©”ì¼ 2',0),(35552,988,'he','×“×•××¨ ××œ×§×˜×¨×•× ×™ ×©× ×™×™×',0),(35553,988,'el','Î”ÏÎ¿ e-mail',0),(35554,988,'zh','ç”µå­é‚®ä»¶äºŒ\r\n',0),(35555,988,'sv','E-post tvÃ¥',0),(35556,988,'it','Due e-mail',0),(35557,988,'tl','',0),(35558,988,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3607;&#3637;&#3656; 2',0),(35559,988,'hi','à¤¦à¥‹ à¤ˆ-à¤®à¥‡à¤² à¤•à¤°à¥‡à¤‚',0),(35560,988,'ms','E-mel dua',0),(35561,988,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(35562,988,'fr','Deux e-mail',0),(35563,988,'jp','Eãƒ¡ãƒ¼ãƒ«ã€€ï¼’',0),(35564,988,'pt','E-mail-dois',0),(35565,988,'ru','E-mail Ð”Ð²Ð°',0),(35566,988,'es','Email Dos',0),(35567,988,'de','E-Mail zwei',0),(35568,988,'en','E-mail Two',0),(35569,989,'is','',0),(35570,989,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(35571,989,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(35572,989,'tr','Ã‡alÄ±ÅŸan',0),(35573,989,'pl','Pracownik',0),(35574,989,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(35575,989,'ur','Ù…Ù„Ø§Ø²Ù…',0),(35576,989,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸',0),(35577,989,'vi','NhÃ¢n viÃªn',0),(35578,989,'af','Werknemer',0),(35579,989,'ro','Angajat',0),(35580,989,'et','TÃ¶Ã¶taja',0),(35581,989,'si','Zaposlenega',0),(35582,989,'ba','Karyawan',0),(35583,989,'nl','Werknemer',0),(35584,989,'fi','TyÃ¶ntekijÃ¤n',0),(35585,989,'no','Ansatte',0),(35586,989,'da','Medarbejder',0),(35587,989,'ko','ì§ì›',0),(35588,989,'he','×¢×•×‘×“',0),(35589,989,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚',0),(35590,989,'zh','å‘˜å·¥',0),(35591,989,'sv','AnstÃ¤lld',0),(35592,989,'it','Dipendente',0),(35593,989,'tl','',0),(35594,989,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(35595,989,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(35596,989,'ms','Pekerja',0),(35597,989,'ar','Ø§Ù„Ù…ÙˆØ¸Ù',0),(35598,989,'fr','EmployÃ©',0),(35599,989,'jp','å¾“æ¥­å“¡',0),(35600,989,'pt','Empregado',0),(35601,989,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº',0),(35602,989,'es','Empleado',0),(35603,989,'de','Mitarbeiter',0),(35604,989,'en','Employee',0),(35605,990,'is','',0),(35606,990,'dr','Ø´Ø±Ø§ÙŠØ· ÙØ¹Ø§Ù„ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(35607,990,'pr','Ø´Ø±Ø§ÙŠØ· ÙØ¹Ø§Ù„ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(35608,990,'tr','Ã‡alÄ±ÅŸanÄ±n etkin durumu baÅŸarÄ±yla deÄŸiÅŸtirildi.',0),(35609,990,'pl','Urlopowania pracownika zostaâ”‚y zmienione.',0),(35610,990,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(35611,990,'ur','Ù…Ù„Ø§Ø²Ù… ÙØ¹Ø§Ù„ Ø­Ø§Ù„Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(35612,990,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ ÑÑ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½.',0),(35613,990,'vi','TÃ¬nh tráº¡ng hoáº¡t Ä‘á»™ng cá»§a nhÃ¢n viÃªn Ä‘á»•i thÃ nh cÃ´ng',0),(35614,990,'af','Werknemer aktiewe status suksesvol verander.',0),(35615,990,'ro','Angajatul statutul activ s-a schimbat cu succes.',0),(35616,990,'et','TÃ¶Ã¶taja aktiivse oleku muutmine nurjus.',0),(35617,990,'si','Zaposleni aktivno stanje uspeÅ¡no spremenjeno.',0),(35618,990,'ba','Status aktif karyawan berhasil diubah.',0),(35619,990,'nl','De actieve status van werknemer gewijzigd met succes.',0),(35620,990,'fi','TyÃ¶ntekijÃ¤n aktiivinen tila vaihdettu.',0),(35621,990,'no','Ansatt aktiv status er endret.',0),(35622,990,'da','Medarbejder aktive status Ã¦ndres med succes.',0),(35623,990,'ko','ì§ì› í™œì„± ìƒíƒœê°€ ì„±ê³µì ìœ¼ë¡œ ë³€ê²½ìž…ë‹ˆë‹¤.',0),(35624,990,'he','×¡×˜×˜×•×¡ ×¤×¢×™×œ ×”×¢×•×‘×“ ×©×™× ×” ×‘×”×¦×œ×—×”.',0),(35625,990,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ ÎµÎ½ÎµÏÎ³ÏŒ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î¬Î»Î»Î±Î¾Îµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(35626,990,'zh','å‘˜å·¥å·¥ä½œçŠ¶æ€ä¿®æ”¹æˆåŠŸ',0),(35627,990,'sv','AnstÃ¤lld aktiv status Ã¤ndrats framgÃ¥ngsrikt.',0),(35628,990,'it','Stato attivo dipendente cambiato con successo.',0),(35629,990,'tl','',0),(35630,990,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3626;&#3606;&#3634;&#3609;&#3632;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3591;&#3634;&#3609;&#3',0),(35631,990,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(35632,990,'ms','Pekerja status aktif berjaya ditukar.',0),(35633,990,'ar','ØªØºÙŠÙŠØ± Ø­Ø§Ù„Ø© Ø§Ù„Ù…ÙˆØ¸Ù Ø§Ù„Ù†Ø´Ø· Ø¨Ù†Ø¬Ø§Ø­.',0),(35634,990,'fr','Statut d\'employÃ© actif changÃ© avec succÃ¨s.',0),(35635,990,'jp','å¾“æ¥­å“¡ã?®æ´»å‹•çŠ¶æ³?ã?Œå¤‰æ›´ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(35636,990,'pt','Empregado ativo status alterado com sucesso.',0),(35637,990,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½.',0),(35638,990,'es','Status activo de Empleado cambiado exitosamente',0),(35639,990,'de','Aktive Mitarbeiterstatus wurden erfolgreich geÃ¤ndert.',0),(35640,990,'en','Employee active status changed successfully.',0),(35641,991,'is','',0),(35642,991,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(35643,991,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(35644,991,'tr','Ã‡alÄ±ÅŸan baÅŸarÄ±yla eklendi.',0),(35645,991,'pl','Pracownik dodane pomyÅ›lnie.',0),(35646,991,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(35647,991,'ur','Ù…Ù„Ø§Ø²Ù… Ù†Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(35648,991,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÑÑƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(35649,991,'vi','ThÃªm nhÃ¢n viÃªn thÃ nh cÃ´ng',0),(35650,991,'af','Werknemer suksesvol bygevoeg.',0),(35651,991,'ro','Angajat adÄƒugat cu succes.',0),(35652,991,'et','TÃ¶Ã¶taja lisati edukalt',0),(35653,991,'si','Zaposlenega dodane uspeÅ¡no.',0),(35654,991,'ba','Karyawan ditambahkan berhasil.',0),(35655,991,'nl','Werknemer met succes toegevoegd.',0),(35656,991,'fi','TyÃ¶ntekijÃ¤ lisÃ¤Ã¤minen onnistui.',0),(35657,991,'no','Ansatte ble lagt til.',0),(35658,991,'da','Medarbejder tilfÃ¸jet.',0),(35659,991,'ko','ì§ì› ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(35660,991,'he','.×¢×•×‘×“ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(35661,991,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(35662,991,'zh','å‘˜å·¥å¢žåŠ æˆåŠŸ',0),(35663,991,'sv','Medarbetare lagts.',0),(35664,991,'it','Dipendente aggiunto con successo.',0),(35665,991,'tl','',0),(35666,991,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(35667,991,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(35668,991,'ms','Pekerja yang berjaya menambah.',0),(35669,991,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ù…ÙˆØ¸Ù‘Ù Ø¨Ù†Ø¬Ø§Ø­',0),(35670,991,'fr','EmployÃ© ajoutÃ© avec succÃ¨s.',0),(35671,991,'jp','å¾“æ¥­å“¡ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(35672,991,'pt','Empregado adicionado com Ãªxito.',0),(35673,991,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(35674,991,'es','Empleado agregado exitosamente',0),(35675,991,'de','Mitarbeiter erfolgreich hinzugefÃ¼gt.',0),(35676,991,'en','Employee added successfully.',0),(35677,992,'is','',0),(35678,992,'dr','.',0),(35679,992,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ø§Ø®ÙŠØ±Ø§ ØºÙŠØ± ÙØ¹Ø§Ù„ Ø§Ø³Øª .',0),(35680,992,'tr','Ã‡alÄ±ÅŸanÄ±n ÅŸu anda etkin deÄŸil.',0),(35681,992,'pl','Pracownik jest obecnie nieaktywne.',0),(35682,992,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²ÐµÐ½.',0),(35683,992,'ur','Ù…Ù„Ø§Ø²Ù… ÙÛŒ Ø§Ù„Ø­Ø§Ù„ ØºÛŒØ± ÙØ¹Ø§Ù„ ÛÛ’ Û”',0),(35684,992,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð½Ð¸Ñ˜Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð°Ð½.',0),(35685,992,'vi','NhÃ¢n viÃªn hiá»‡n nay khÃ´ng hoáº¡t Ä‘á»™ng',0),(35686,992,'af','Werknemer huidiglike onaktief.',0),(35687,992,'ro','Angajat inactiv.',0),(35688,992,'et','TÃ¶Ã¶taja pole praegu aktiivne.',0),(35689,992,'si','Zaposleni trenutno neaktivno.',0),(35690,992,'ba','Karyawan sedang tak aktif.',0),(35691,992,'nl','Werknemer momenteel inactief.',0),(35692,992,'fi','TyÃ¶ntekijÃ¤ ole tÃ¤llÃ¤ hetkellÃ¤ kÃ¤ytÃ¶ssÃ¤.',0),(35693,992,'no','Ansatte som er inaktive.',0),(35694,992,'da','Medarbejder i Ã¸jeblikket inaktive.',0),(35695,992,'ko','ì§ì› í˜„ìž¬ ë¹„í™œì„±í™” ë˜ì–´ ìžˆìŠµë‹ˆë‹¤.',0),(35696,992,'he','×”×¢×•×‘×“ ××™× ×• ×¤×¢×™×œ ×›×¢×ª.',0),(35697,992,'el','Î•ÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚ Ï€ÏÎ¿ÏƒÏ‰ÏÎ¹Î½Î¬ Î±Î½ÎµÎ½ÎµÏÎ³Î¬.',0),(35698,992,'zh','å‘˜å·¥ç›®å‰æ— æ•ˆã€‚\r\n',0),(35699,992,'sv','Medarbetare fÃ¶r nÃ¤rvarande inaktiv.',0),(35700,992,'it','Dipendente attualmente inattivo.',0),(35701,992,'tl','',0),(35702,992,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3591;&#3634;&#3609;&#3651;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3',0),(35703,992,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€à¥¤',0),(35704,992,'ms','Pekerja yang sedang aktif.',0),(35705,992,'ar','Ø§Ù„Ù…ÙˆØ¸Ù Ø®Ø§Ù…Ù„ Ø­Ø§Ù„ÙŠØ§',0),(35706,992,'fr','EmployÃ© actuellement inactif.',0),(35707,992,'jp','å¾“æ¥­å“¡ã?¯ç?¾åœ¨ä¸?æ´»å‹•ä¸­ã?§ã?™',0),(35708,992,'pt','Empregado atualmente inativo.',0),(35709,992,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ð¹ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº.',0),(35710,992,'es','Empleado actualmente inactivo',0),(35711,992,'de','Mitarbeiter derzeit inaktiv.',0),(35712,992,'en','Employee currently inactive.',0),(35713,993,'is','',0),(35714,993,'dr','( ÙƒØ³ÙˆØ±Ø§Øª ) ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(35715,993,'pr','ØªØ®ÙÙŠÙØ§Øª ( ÙƒØ³ÙˆØ±Ø§Øª ) ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(35716,993,'tr','Ã‡alÄ±ÅŸan kesintiler',0),(35717,993,'pl','PotrÄ…cenia pracownika',0),(35718,993,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸',0),(35719,993,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ù¹ÙˆØªÛŒ',0),(35720,993,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ',0),(35721,993,'vi','Giáº£m trá»« NhÃ¢n viÃªn ',0),(35722,993,'af','Werknemer Aftrekkings',0),(35723,993,'ro','Deduceri angajat',0),(35724,993,'et','TÃ¶Ã¶taja mahaarvamine',0),(35725,993,'si','Zaposlenega odbitki',0),(35726,993,'ba','Pengurangan karyawan',0),(35727,993,'nl','Werknemer inhoudingen',0),(35728,993,'fi','TyÃ¶ntekijÃ¤n vÃ¤hennykset',0),(35729,993,'no','Ansatt fradrag',0),(35730,993,'da','Medarbejder fradrag',0),(35731,993,'ko','ì§ì› ê³µì œ',0),(35732,993,'he','×”×¢×•×‘×“ × ×™×›×•×™×™×',0),(35733,993,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½',0),(35734,993,'zh','å‘˜å·¥æ‰£é™¤\r\n',0),(35735,993,'sv','AnstÃ¤lld avdrag',0),(35736,993,'it','Detrazioni dipendente',0),(35737,993,'tl','',0),(35738,993,'th','&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3592;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(35739,993,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(35740,993,'ms','Pengurangan pekerja',0),(35741,993,'ar','Ø¥Ø³ØªÙ‚Ø·Ø§Ø¹Ø§Øª Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(35742,993,'fr','DÃ©ductions de l\'employÃ©',0),(35743,993,'jp','å¾“æ¥­å“¡æŽ§é™¤',0),(35744,993,'pt','DeduÃ§Ãµes de empregado',0),(35745,993,'ru','Ð£Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ Ð¡ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(35746,993,'es','Deducciones de Empleados',0),(35747,993,'de','Mitarbeiter-AbzÃ¼ge',0),(35748,993,'en','Employee Deductions',0),(35749,994,'is','',0),(35750,994,'dr','/ Ø¯Ø±Ù…Ø§Ù†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(35751,994,'pr','Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ / Ø¯Ø±Ù…Ø§Ù†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(35752,994,'tr','Ã‡alÄ±ÅŸan FICA/Medicare',0),(35753,994,'pl','Pracownik FICA/Medicare',0),(35754,994,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» FICA/Medicare',0),(35755,994,'ur','Ù…Ù„Ø§Ø²Ù… ÙØ§Ú©ÛŒ/Ù…ÛŒÚˆÛŒ',0),(35756,994,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÐžÐ”Ð Ð•Ð¡ÐšÐ£/Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚',0),(35757,994,'vi','Báº£o hiá»ƒm xÃ£ há»™i cá»§a nhÃ¢n viÃªn/Y táº¿',0),(35758,994,'af','Werknemer FICA/Medicare',0),(35759,994,'ro','Angajat FICA/Medicare',0),(35760,994,'et','TÃ¶Ã¶taja tÃ¶Ã¶tuskindlustus',0),(35761,994,'si','Zaposlenega FICA/Medicare',0),(35762,994,'ba','Karyawan FICA/Medicare',0),(35763,994,'nl','Werknemer FICA/Medicare',0),(35764,994,'fi','TyÃ¶ntekijÃ¤n FICA/Medicare',0),(35765,994,'no','Ansatt FICA/Medicare',0),(35766,994,'da','Medarbejder FICA/Medicare',0),(35767,994,'ko','ì§ì›ì´ ë´/ë©”ë””ì¼€ì–´',0),(35768,994,'he','×”×¢×•×‘×“ ×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™/×ž×“×™×§×¨',0),(35769,994,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î£Î¥ÎœÎ’ÎŸÎ¥Î›Î‰/Medicare',0),(35770,994,'zh','å‘˜å·¥çš„ç¤¾ä¼šä¿é™©/åŒ»ç–—ä¿é™©\r\n',0),(35771,994,'sv','AnstÃ¤lld FICA/Medicare',0),(35772,994,'it','Dipendente FICA/Medicare',0),(35773,994,'tl','',0),(35774,994,'th','&#3585;&#3629;&#3591;&#3607;&#3640;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;/&#3626;&#3623;&#3633;&#3626;&#3604;&#3636;&#3585;&#3634;&#3619; &#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(35775,994,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ FICA/à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤°',0),(35776,994,'ms','Pekerja FICA/Medicare',0),(35777,994,'ar','Ù…ÙˆØ¸Ù Ù…Ø­ÙƒÙ…ÙŠ/Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(35778,994,'fr','EmployÃ© FICA/assurance maladie',0),(35779,994,'jp','å¾“æ¥­å“¡é€£é‚¦ä¿?é™ºå¯„ä¸Žæ³•/åŒ»ç™‚å?¥åº·ä¿?é™ºåˆ¶åº¦',0),(35780,994,'pt','Empregado FICA/Medicare',0),(35781,994,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº FICA/Medicare',0),(35782,994,'es','Empleado FICA/Medicare',0),(35783,994,'de','Mitarbeiter FICA/Medicare',0),(35784,994,'en','Employee FICA/Medicare',0),(35785,995,'is','',0),(35786,995,'dr','Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(35787,995,'pr','Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(35788,995,'tr','Ã‡alÄ±ÅŸan saat baÅŸarÄ±yla eklendi.',0),(35789,995,'pl','Godzin pracownika dodano pomyÅ›lnie.',0),(35790,995,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ñ‡Ð°ÑÐ° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(35791,995,'ur','Ù…Ù„Ø§Ø²Ù… Ú¯Ú¾Ù†Ù¹ÙˆÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(35792,995,'sr','Ð¡Ð°Ñ‚Ð¸ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(35793,995,'vi','ThÃªm giá» NhÃ¢n viÃªn thÃ nh cÃ´ng',0),(35794,995,'af','Werknemer ure suksesvol bygevoeg.',0),(35795,995,'ro','Angajat ore adÄƒugat cu succes.',0),(35796,995,'et','TÃ¶Ã¶taja tÃ¶Ã¶tunnid lisati edukalt',0),(35797,995,'si','Zaposleni ur uspeÅ¡no dodana.',0),(35798,995,'ba','Karyawan jam ditambahkan berhasil.',0),(35799,995,'nl','Werknemer uren met succes toegevoegd.',0),(35800,995,'fi','TyÃ¶ntekijÃ¤n tuntien lisÃ¤Ã¤minen onnistui.',0),(35801,995,'no','Ansatt timer lagt.',0),(35802,995,'da','Medarbejdertimer tilfÃ¸jet.',0),(35803,995,'ko','ì§ì› ì‹œê°„ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(35804,995,'he','×©×¢×•×ª ×¢×•×‘×“×™× × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(35805,995,'el','Î•ÏÎ³Î±Ï„Î¿ÏŽÏÎµÏ‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(35806,995,'zh','å‘˜å·¥å·¥ä½œæ—¶æ•°æ·»åŠ æˆåŠŸã€‚\r\n',0),(35807,995,'sv','Medarbetartimmar lagts.',0),(35808,995,'it','Ore dipendente aggiunti con successo.',0),(35809,995,'tl','',0),(35810,995,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(35811,995,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤˜à¤‚à¤Ÿà¥‹à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(35812,995,'ms','Jam pekerja berjaya menambah.',0),(35813,995,'ar','Ø£Ø¶ÙŠÙØª Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ù…ÙˆØ¸Ù‘Ù Ø¨Ù†Ø¬Ø§Ø­',0),(35814,995,'fr','Ses heures ajoutÃ©s avec succÃ¨s.',0),(35815,995,'jp','å¾“æ¥­å“¡å‹¤å‹™æ™‚é–“ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(35816,995,'pt','Horas de empregado adicionadas com Ãªxito.',0),(35817,995,'ru','Ð§Ð°ÑÑ‹ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹.',0),(35818,995,'es','Horas de Empleados agregadas exitosamente',0),(35819,995,'de','Mitarbeiter Stunden erfolgreich hinzugefÃ¼gt.',0),(35820,995,'en','Employee hours added successfully.',0),(35821,996,'is','',0),(35822,996,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ø±Ù…Ù†Ø¯',0),(35823,996,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ø±Ù…Ù†Ø¯',0),(35824,996,'tr','Ã‡alÄ±ÅŸan listesi',0),(35825,996,'pl','Lista pracownikÃ³w',0),(35826,996,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(35827,996,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ÙÛØ±Ø³Øª',0),(35828,996,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(35829,996,'vi','Danh sÃ¡ch NhÃ¢n viÃªn ',0),(35830,996,'af','Werknemer Lys',0),(35831,996,'ro','Angajat lista',0),(35832,996,'et','TÃ¶Ã¶tajate nimekiri',0),(35833,996,'si','Seznam zaposlenih',0),(35834,996,'ba','Karyawan daftar',0),(35835,996,'nl','Werknemerslijst',0),(35836,996,'fi','TyÃ¶ntekijÃ¤luettelo',0),(35837,996,'no','Ansatt-listen',0),(35838,996,'da','Medarbejderoversigt',0),(35839,996,'ko','ì§ì› ëª©ë¡',0),(35840,996,'he','×¨×©×™×ž×ª ×¢×•×‘×“×™×',0),(35841,996,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Ï‰Î½',0),(35842,996,'zh','å‘˜å·¥åˆ—è¡¨',0),(35843,996,'sv','Personallista',0),(35844,996,'it','Elenco dei dipendenti',0),(35845,996,'tl','',0),(35846,996,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(35847,996,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¥‚à¤šà¥€',0),(35848,996,'ms','Senarai kakitangan',0),(35849,996,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(35850,996,'fr','Liste des employÃ©s',0),(35851,996,'jp','å¾“æ¥­å“¡ãƒªã‚¹ãƒˆ',0),(35852,996,'pt','Lista de funcionÃ¡rios',0),(35853,996,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(35854,996,'es','Empleados Lista de ',0),(35855,996,'de','Mitarbeiterliste',0),(35856,996,'en','Employee List',0),(35857,997,'is','',0),(35858,997,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ÙŠØ¯ Ø´Ø±ÙƒØª ÙƒÙ†Ø¯ ',0),(35859,997,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ÙŠØ¯ Ø´Ø±ÙƒØª ÙƒÙ†Ø¯ ',0),(35860,997,'tr','Ã‡alÄ±ÅŸan katÄ±lmalÄ±dÄ±r',0),(35861,997,'pl','Pracownik musi uczestniczyÄ‡',0),(35862,997,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑƒÑ‡Ð°ÑÑ‚Ð²Ð°Ñ‚',0),(35863,997,'ur','Ù…Ù„Ø§Ø²Ù… Ø´Ø±Ú©Øª Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(35864,997,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¼Ð¾Ñ€Ð°Ñ˜Ñƒ Ð´Ð° ÑƒÑ‡ÐµÑÑ‚Ð²ÑƒÑ˜Ñƒ',0),(35865,997,'vi','NhÃ¢n viÃªn pháº£i tham gia',0),(35866,997,'af','Werknemer moet deelneem.',0),(35867,997,'ro','Angajatul trebuie sÄƒ participe',0),(35868,997,'et','TÃ¶Ã¶taja peab osalema',0),(35869,997,'si','Zaposleni morajo sodelovati',0),(35870,997,'ba','Karyawan harus berpartisipasi',0),(35871,997,'nl','Werknemer moet nemen',0),(35872,997,'fi','TyÃ¶ntekijÃ¤n on osallistuttava',0),(35873,997,'no','Ansatte mÃ¥ delta',0),(35874,997,'da','Medarbejderen skal deltage',0),(35875,997,'ko','ì§ì› ì°¸ì—¬ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(35876,997,'he','×”×¢×•×‘×“ ×—×™×™×‘ ×œ×”×©×ª×ª×£',0),(35877,997,'el','Î•ÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÏƒÏ…Î¼Î¼ÎµÏ„Î­Ï‡Î¿Ï…Î½',0),(35878,997,'zh','å‘˜å·¥å¿…é¡»å‚ä¸Ž\r\n',0),(35879,997,'sv','Medarbetaren mÃ¥ste delta',0),(35880,997,'it','Dipendente deve partecipare',0),(35881,997,'tl','',0),(35882,997,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3626;&#3656;&#3623;&#3609;&#3619;&#3656;&#3623;&#3617;',0),(35883,997,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤­à¤¾à¤— à¤²à¥‡à¤¨à¥‡ à¤šà¤¾à¤¹à¤¿à¤',0),(35884,997,'ms','Pekerja mesti mengambil bahagian',0),(35885,997,'ar','ÙˆÙŠØ¬Ø¨ Ø£Ù† ÙŠØ´Ø§Ø±Ùƒ Ø§Ù„Ù…ÙˆØ¸Ù',0),(35886,997,'fr','EmployÃ© doit participer',0),(35887,997,'jp','å¾“æ¥­å“¡ã?¯å?‚åŠ ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(35888,997,'pt','Empregado deve participar',0),(35889,997,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð¿Ñ€Ð¸Ð½ÑÑ‚ÑŒ ÑƒÑ‡Ð°ÑÑ‚Ð¸Ðµ',0),(35890,997,'es','Empleado debe participar',0),(35891,997,'de','Mitarbeiter muss teilnehmen.',0),(35892,997,'en','Employee must participate',0),(35893,998,'is','',0),(35894,998,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(35895,998,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(35896,998,'tr','Ã‡alÄ±ÅŸan bulunamadÄ±.',0),(35897,998,'pl','Pracownik nie znaleziono.',0),(35898,998,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ð½Ðµ Ðµ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚.',0),(35899,998,'ur','Ù…Ù„Ø§Ø²Ù… Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(35900,998,'sr','Ð¡Ð»ÑƒÐ¶Ð±ÐµÐ½Ð¸Ðº Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(35901,998,'vi','KhÃ´ng tháº¥y NhÃ¢n viÃªn ',0),(35902,998,'af','Werknemer nie gevind.',0),(35903,998,'ro','Angajatul nu a fost gÄƒsit.',0),(35904,998,'et','TÃ¶Ã¶tajat ei leitud',0),(35905,998,'si','Zaposlenega ni bilo mogoÄe najti.',0),(35906,998,'ba','Karyawan tidak ditemukan.',0),(35907,998,'nl','Werknemer niet gevonden.',0),(35908,998,'fi','TyÃ¶ntekijÃ¤Ã¤ ei lÃ¶ydy.',0),(35909,998,'no','Finner ikke ansatt.',0),(35910,998,'da','Medarbejder ikke fundet.',0),(35911,998,'ko','ì§ì› ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(35912,998,'he','.×¢×•×‘×“ ×œ× × ×ž×¦×',0),(35913,998,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ Î¿ Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚.',0),(35914,998,'zh','å‘˜å·¥æœªæ‰¾åˆ°',0),(35915,998,'sv','AnstÃ¤lld hittades inte.',0),(35916,998,'it','Dipendente non trovato.',0),(35917,998,'tl','',0),(35918,998,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(35919,998,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤à¥¤',0),(35920,998,'ms','Pekerja tidak ditemui.',0),(35921,998,'ar','Ø§Ù„Ù…ÙˆØ¸Ù ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(35922,998,'fr','EmployÃ© introuvable.',0),(35923,998,'jp','å¾“æ¥­å“¡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(35924,998,'pt','Empregado nÃ£o encontrado.',0),(35925,998,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(35926,998,'es','Empleado no se encontrÃ³',0),(35927,998,'de','Mitarbeiter, die nicht gefunden werden.',0),(35928,998,'en','Employee not found.',0),(35929,999,'is','',0),(35930,999,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø±ØªØ¨Ù‡ Ø¨Ù†Ø¯ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(35931,999,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø±ØªØ¨Ù‡ Ø¨Ù†Ø¯ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(35932,999,'tr','Oy verin Ã§alÄ±ÅŸan eklemek',0),(35933,999,'pl','DodaÄ‡ ocena pracownika',0),(35934,999,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¾Ñ†ÐµÐ½ÐºÐ° Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ',0),(35935,999,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(35936,999,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³',0),(35937,999,'vi','ThÃªm GiÃ¡ NhÃ¢n viÃªn',0),(35938,999,'af','Werknemerskaal Byvoeg',0),(35939,999,'ro','Adauga angajat de evaluare',0),(35940,999,'et','TÃ¶Ã¶taja hinnang lisamine',0),(35941,999,'si','Ocena zaposlenih poveÄati',0),(35942,999,'ba','Tambahkan karyawan Rating',0),(35943,999,'nl','Werknemer beoordeling toevoegen',0),(35944,999,'fi','TyÃ¶ntekijÃ¤n Rating lisÃ¤Ã¤',0),(35945,999,'no','Ansatt vurdering legge',0),(35946,999,'da','Medarbejder Rating tilfÃ¸je',0),(35947,999,'ko','ì§ì› í‰ê°€ ì¶”ê°€',0),(35948,999,'he','×“×™×¨×•×’ ×”×¢×•×‘×“ ×œ×”×•×¡×™×£',0),(35949,999,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î²Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ',0),(35950,999,'zh','è¯„åˆ†æ–°å¢žé›‡å‘˜\r\n',0),(35951,999,'sv','AnstÃ¤lld betyg lÃ¤gga till',0),(35952,999,'it','Aggiungi dipendente analoghe',0),(35953,999,'tl','',0),(35954,999,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3629;&#3633;&#3605;&#3619;&#3634;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(35955,999,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¦à¤°à¥à¤œà¤¼à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(35956,999,'ms','Tambah pekerja Rating',0),(35957,999,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ¸Ù ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(35958,999,'fr','Ajoute employÃ© de note',0),(35959,999,'jp','å¾“æ¥­å“¡è©•ä¾¡ã?®è¿½åŠ ',0),(35960,999,'pt','Adiciona o empregado classificaÃ§Ã£o',0),(35961,999,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(35962,999,'es','ClasificaciÃ³n de Empleado Agregar',0),(35963,999,'de','Mitarbeiter, die Bewertung hinzufÃ¼gen',0),(35964,999,'en','Employee Rating Add',0),(35965,1000,'is','',0),(35966,1000,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø±ØªØ¨Ù‡ Ø¨Ù†Ø¯ÙŠ  ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(35967,1000,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø±ØªØ¨Ù‡ Ø¨Ù†Ø¯ÙŠ  ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(35968,1000,'tr','Bir yaÅŸ derecelendirme gÃ¼ncelleÅŸtirme',0),(35969,1000,'pl','Aktualizacja ocena pracownika',0),(35970,1000,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(35971,1000,'ur','Ù…Ù„Ø§Ø²Ù… Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(35972,1000,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(35973,1000,'vi','Cáº­p Nháº­t ÄÃ¡nh GiÃ¡ NhÃ¢n ViÃªn',0),(35974,1000,'af','Werknemerskaal Opdateer',0),(35975,1000,'ro','Actualizare de Rating angajat',0),(35976,1000,'et','TÃ¶Ã¶taja hinnang Update',0),(35977,1000,'si','Zaposleni ocena posodobitev',0),(35978,1000,'ba','Karyawan peringkat Update',0),(35979,1000,'nl','Werknemer Rating Update',0),(35980,1000,'fi','TyÃ¶ntekijÃ¤n luokituksen pÃ¤ivitys',0),(35981,1000,'no','Ansatt vurdering oppdatering',0),(35982,1000,'da','Medarbejder Rating opdatering',0),(35983,1000,'ko','ì§ì› í‰ê°€ ì—…ë°ì´íŠ¸',0),(35984,1000,'he','×¢×“×›×•×Ÿ ×“×™×¨×•×’ ×”×¢×•×‘×“',0),(35985,1000,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î²Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(35986,1000,'zh','å‘˜å·¥è¯„çº§æ›´æ–°\r\n',0),(35987,1000,'sv','AnstÃ¤lld Rating uppdatering',0),(35988,1000,'it','Aggiornamento del Rating dipendente',0),(35989,1000,'tl','',0),(35990,1000,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3629;&#3633;&#3605;&#3619;&#3634;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(35991,1000,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¦à¤°à¥à¤œà¤¼à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(35992,1000,'ms','Pengemaskinian penilaian pekerja',0),(35993,1000,'ar','ØªØ­Ø¯ÙŠØ« ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ù…ÙˆØ¸Ù',0),(35994,1000,'fr','Mise Ã  jour de la cotation employÃ©',0),(35995,1000,'jp','å¾“æ¥­å“¡è©•ä¾¡ã?®æ›´æ–°',0),(35996,1000,'pt','AtualizaÃ§Ã£o do Rating de empregado',0),(35997,1000,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(35998,1000,'es','ClasificaciÃ³n de Empleado ActualizaciÃ³n',0),(35999,1000,'de','Mitarbeiter Rating Update',0),(36000,1000,'en','Employee Rating Update',0),(36001,1001,'is','',0),(36002,1001,'dr','Ø§ÙØ²ÙˆØ¯Ù†  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(36003,1001,'pr','Ø§ÙØ²ÙˆØ¯Ù†  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(36004,1001,'tr','Yeni bir yaÅŸ inceleme',0),(36005,1001,'pl','PrzeglÄ…d pod kÄ…tem nowego pracownika',0),(36006,1001,'bg','ÐÐ¾Ð² ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(36007,1001,'ur','Ù†ÛŒÙˆ Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û',0),(36008,1001,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(36009,1001,'vi','ThÃªm Ä‘Ã¡nh giÃ¡ NhÃ¢n viÃªn',0),(36010,1001,'af','Werknemer Oorsig Byvoeg',0),(36011,1001,'ro','Noul angajat Review',0),(36012,1001,'et','Lisa tÃ¶Ã¶taja iseloomustus',0),(36013,1001,'si','Novo zaposlenega pregled',0),(36014,1001,'ba','Review karyawan baru',0),(36015,1001,'nl','Nieuwe werknemer Review',0),(36016,1001,'fi','Uuden tyÃ¶ntekijÃ¤n tarkastelu',0),(36017,1001,'no','Ny ansatt gjennomgang',0),(36018,1001,'da','Ny medarbejder anmeldelse',0),(36019,1001,'ko','ìƒˆë¡œìš´ ì§ì› ê²€í† ',0),(36020,1001,'he','×¡×§×™×¨×” ×¢×•×‘×“ ×—×“×©',0),(36021,1001,'el','ÎÎ­Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(36022,1001,'zh','å‘˜å·¥å®¡æŸ¥æ·»åŠ \r\n',0),(36023,1001,'sv','Nya medarbetare recension',0),(36024,1001,'it','Nuova recensione di dipendente',0),(36025,1001,'tl','',0),(36026,1001,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(36027,1001,'hi','à¤¨à¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(36028,1001,'ms','Baru pekerja kajian',0),(36029,1001,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙ‚ÙŠÙŠÙ… Ù…ÙˆØ¸Ù',0),(36030,1001,'fr','Nouvelle revue de l\'employÃ©',0),(36031,1001,'jp','å¾“æ¥­å“¡ãƒ¬ãƒ“ãƒ¥ãƒ¼ã?®è¿½åŠ ',0),(36032,1001,'pt','Nova revisÃ£o de empregado',0),(36033,1001,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð½Ð¾Ð²Ñ‹Ñ… ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(36034,1001,'es','Empleado RevisiÃ³n Agregar',0),(36035,1001,'de','Neue Mitarbeiter-Rezension',0),(36036,1001,'en','New Employee Review',0),(36037,1002,'is','',0),(36038,1002,'dr','Ø§ÙØ²ÙˆØ¯Ù†  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(36039,1002,'pr','Ø§ÙØ²ÙˆØ¯Ù†  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(36040,1002,'tr','Ã‡alÄ±ÅŸan bir daha gÃ¶zden geÃ§irme baÅŸarÄ±yla eklendi.',0),(36041,1002,'pl','PrzeglÄ…d pracownika dodano pomyÅ›lnie.',0),(36042,1002,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(36043,1002,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(36044,1002,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(36045,1002,'vi','ThÃªm Ä‘Ã¡nh giÃ¡ NhÃ¢n viÃªn thÃ nh cÃ´ng',0),(36046,1002,'af','Werknemer Oorsig suksesvol bygevoeg.',0),(36047,1002,'ro','Opinie angajat adÄƒugat cu succes.',0),(36048,1002,'et','TÃ¶Ã¶taja iseloomustus lisati edukalt',0),(36049,1002,'si','Zaposlenega pregled uspeÅ¡no dodana.',0),(36050,1002,'ba','Karyawan meninjau ditambahkan berhasil.',0),(36051,1002,'nl','Werknemer Review met succes toegevoegd.',0),(36052,1002,'fi','TyÃ¶ntekijÃ¤n uudelleen lisÃ¤Ã¤minen onnistui.',0),(36053,1002,'no','Medarbeider vurdering lagt.',0),(36054,1002,'da','Medarbejder anmeldelse tilfÃ¸jet.',0),(36055,1002,'ko','ì§ì› ê²€í†  ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(36056,1002,'he','×¡×§×™×¨×” ×¢×•×‘×“ × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(36057,1002,'el','Î‘Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(36058,1002,'zh','å‘˜å·¥å®¡æŸ¥æ·»åŠ æˆåŠŸã€‚\r\n',0),(36059,1002,'sv','AnstÃ¤lld recension lagts.',0),(36060,1002,'it','Recensione dipendente aggiunto con successo.',0),(36061,1002,'tl','',0),(36062,1002,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(36063,1002,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(36064,1002,'ms','Kajian pekerja berjaya menambah.',0),(36065,1002,'ar','Ø£Ø¶ÙŠÙ ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ù…ÙˆØ¸Ù‘Ù Ø¨Ù†Ø¬Ø§Ø­',0),(36066,1002,'fr','EmployÃ© examen ajoutÃ© avec succÃ¨s.',0),(36067,1002,'jp','å¾“æ¥­å“¡ãƒ¬ãƒ“ãƒ¥ãƒ¼ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(36068,1002,'pt','RevisÃ£o de empregado adicionado com Ãªxito.',0),(36069,1002,'ru','ÐžÐ±Ð·Ð¾Ñ€ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(36070,1002,'es','Empleado RevisiÃ³n Agregada Exitosamente',0),(36071,1002,'de','Mitarbeiter-Review erfolgreich hinzugefÃ¼gt.',0),(36072,1002,'en','Employee Review added successfully.',0),(36073,1003,'is','',0),(36074,1003,'dr','Ø§ÙØ²ÙˆØ¯Ù†  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù  Ø´Ø¯ ',0),(36075,1003,'pr','Ø§ÙØ²ÙˆØ¯Ù†  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù  Ø´Ø¯ ',0),(36076,1003,'tr','Ã‡alÄ±ÅŸan bir daha gÃ¶zden geÃ§irme baÅŸarÄ±yla silindi.',0),(36077,1003,'pl','PrzeglÄ…d pracownik pomyÅ›lnie usuniÄ™ty.',0),(36078,1003,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(36079,1003,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(36080,1003,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÐºÑ€Ð¸Ñ‚Ð¸ÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(36081,1003,'vi','XÃ³a Ä‘Ã¡nh giÃ¡ NhÃ¢n viÃªn thÃ nh cÃ´ng',0),(36082,1003,'af','Werknemer Oorsig suksesvol geskrap.',0),(36083,1003,'ro','Opinie angajat ÅŸters cu succes.',0),(36084,1003,'et','TÃ¶Ã¶taja iseloomustus kustutati edukalt',0),(36085,1003,'si','Zaposlenega pregled uspeÅ¡no izbrisana.',0),(36086,1003,'ba','Karyawan Review berhasil dihapus.',0),(36087,1003,'nl','Werknemer Review verwijderd.',0),(36088,1003,'fi','TyÃ¶ntekijÃ¤n tarkastelu poistettu.',0),(36089,1003,'no','Medarbeider vurdering slettet.',0),(36090,1003,'da','Medarbejder anmeldelse slettet.',0),(36091,1003,'ko','ì§ì› ê²€í†  ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(36092,1003,'he','×¡×§×™×¨×” ×”×¢×•×‘×“ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(36093,1003,'el','Î‘Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(36094,1003,'zh','å‘˜å·¥å®¡æŸ¥åˆ é™¤æˆåŠŸ\r\n',0),(36095,1003,'sv','AnstÃ¤lld recension raderades.',0),(36096,1003,'it','Recensione dipendente eliminato con successo.',0),(36097,1003,'tl','',0),(36098,1003,'th','&#3621;&#3610;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(36099,1003,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(36100,1003,'ms','Kajian pekerja dihapuskan dengan jayanya.',0),(36101,1003,'ar','Ø­Ø°Ù ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ù…ÙˆØ¸Ù‘Ù Ø¨Ù†Ø¬Ø§Ø­',0),(36102,1003,'fr','EmployÃ© examen supprimÃ© avec succÃ¨s.',0),(36103,1003,'jp','å¾“æ¥­å“¡ãƒ¬ãƒ“ãƒ¥ãƒ¼ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(36104,1003,'pt','RevisÃ£o de empregado excluÃ­do com sucesso.',0),(36105,1003,'ru','ÐžÐ±Ð·Ð¾Ñ€ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(36106,1003,'es','Empleado RevisiÃ³n Eliminada Exitosamente',0),(36107,1003,'de','Mitarbeiter-Review erfolgreich gelÃ¶scht.',0),(36108,1003,'en','Employee Review deleted successfully.',0),(36109,1004,'is','',0),(36110,1004,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù¾ÙŠØ¯Ø§  Ù†Ø´Ø¯ ',0),(36111,1004,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù¾ÙŠØ¯Ø§  Ù†Ø´Ø¯ ',0),(36112,1004,'tr','Ã‡alÄ±ÅŸan inceleme bulunamadÄ±.',0),(36113,1004,'pl','PrzeglÄ…d pracownika nie znaleziono.',0),(36114,1004,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(36115,1004,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù†ÛÛŒÚº Ù…Ù„ Û”',0),(36116,1004,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÐºÑ€Ð¸Ñ‚Ð¸ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(36117,1004,'vi','khÃ´ng tháº¥y Ä‘Ã¡nh giÃ¡ NhÃ¢n viÃªn',0),(36118,1004,'af','Werknemer Oorsig nie gevind.',0),(36119,1004,'ro','Opinie angajat nu a fost gÄƒsit.',0),(36120,1004,'et','TÃ¶Ã¶taja iseloomustust ei leitud',0),(36121,1004,'si','Pregled delavca ni mogoÄe najti.',0),(36122,1004,'ba','Review karyawan tidak ditemukan.',0),(36123,1004,'nl','Werknemer Review niet gevonden.',0),(36124,1004,'fi','TyÃ¶ntekijÃ¤n tarkastelu ei lÃ¶ydy.',0),(36125,1004,'no','Medarbeider vurdering ikke funnet.',0),(36126,1004,'da','Medarbejder gennemgang ikke fundet.',0),(36127,1004,'ko','ì§ì› ê²€í†  ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(36128,1004,'he','×¡×§×™×¨×” ×©×œ ×”×¢×•×‘×“ ×œ× × ×ž×¦×.',0),(36129,1004,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(36130,1004,'zh','æœªæ‰¾åˆ°å‘˜å·¥å®¡æŸ¥ã€‚\r\n',0),(36131,1004,'sv','AnstÃ¤lld recension hittades inte.',0),(36132,1004,'it','Recensione di dipendente non trovato.',0),(36133,1004,'tl','',0),(36134,1004,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(36135,1004,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(36136,1004,'ms','Kajian pekerja tidak ditemui.',0),(36137,1004,'ar','ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ù…ÙˆØ¸Ù ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(36138,1004,'fr','Examen employÃ© introuvable.',0),(36139,1004,'jp','å¾“æ¥­å“¡ãƒ¬ãƒ“ãƒ¥ãƒ¼ã?Œã?¿ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(36140,1004,'pt','RevisÃ£o de empregado nÃ£o encontrado.',0),(36141,1004,'ru','ÐžÐ±Ð·Ð¾Ñ€ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(36142,1004,'es','Empleado RevisiÃ³n no se encontrÃ³',0),(36143,1004,'de','Mitarbeiter-ÃœberprÃ¼fung nicht gefunden.',0),(36144,1004,'en','Employee Review not found.',0),(36145,1005,'is','',0),(36146,1005,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(36147,1005,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(36148,1005,'tr','Ã‡alÄ±ÅŸan bir daha gÃ¶zden geÃ§irme dÃ¼zenleme',0),(36149,1005,'pl','Edycja przeglÄ…du pracownika',0),(36150,1005,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(36151,1005,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(36152,1005,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(36153,1005,'vi','Cáº­p Nháº­t BÃ¬nh Duyá»‡t NhÃ¢n ViÃªn',0),(36154,1005,'af','Werknemer Oorsig opdateer.',0),(36155,1005,'ro','Editare opinie angajat',0),(36156,1005,'et','TÃ¶Ã¶taja iseloomustuse uuendamine',0),(36157,1005,'si','UredniÅ¡ki pregled zaposlenih',0),(36158,1005,'ba','Mengedit karyawan Review',0),(36159,1005,'nl','Werknemer beoordeling bewerken',0),(36160,1005,'fi','Muokkaa tyÃ¶ntekijÃ¤n tarkastelu',0),(36161,1005,'no','Redigere medarbeider vurdering',0),(36162,1005,'da','Redigere medarbejder anmeldelse',0),(36163,1005,'ko','ì§ì› ê²€í†  íŽ¸ì§‘',0),(36164,1005,'he','×¢×¨×™×›×ª ×‘×™×§×•×¨×ª ×”×¢×•×‘×“',0),(36165,1005,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(36166,1005,'zh','å‘˜å·¥å®¡æŸ¥æ›´æ–°\r\n',0),(36167,1005,'sv','Redigera medarbetare recension',0),(36168,1005,'it','Modifica dipendente recensione',0),(36169,1005,'tl','',0),(36170,1005,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;',0),(36171,1005,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(36172,1005,'ms','Edit kajian pekerja',0),(36173,1005,'ar','ØªØ­Ø¯ÙŠØ« ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ù…ÙˆØ¸Ù',0),(36174,1005,'fr','Modifier l\'apprÃ©ciation du',0),(36175,1005,'jp','å¾“æ¥­å“¡ãƒ¬ãƒ“ãƒ¥ãƒ¼ã?®æ›´æ–°',0),(36176,1005,'pt','RevisÃ£o de empregado',0),(36177,1005,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¾Ð±Ð·Ð¾Ñ€ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(36178,1005,'es','Empleado RevisiÃ³n ActualizaciÃ³n',0),(36179,1005,'de','Bearbeiten Mitarbeiter Review',0),(36180,1005,'en','Edit Employee Review',0),(36181,1006,'is','',0),(36182,1006,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(36183,1006,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(36184,1006,'tr','Ã‡alÄ±ÅŸan bir daha gÃ¶zden geÃ§irme baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(36185,1006,'pl','PrzeglÄ…d pracownik pomyÅ›lnie zaktualizowana.',0),(36186,1006,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(36187,1006,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(36188,1006,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÐºÑ€Ð¸Ñ‚Ð¸ÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(36189,1006,'vi','Cáº­p Nháº­t BÃ¬nh Duyá»‡t NhÃ¢n ViÃªn thÃ nh cÃ´ng',0),(36190,1006,'af','Werknemer Oorsig suksesvolg opdateer.',0),(36191,1006,'ro','Opinie angajat actualizat cu succes.',0),(36192,1006,'et','TÃ¶Ã¶taja iseloomustus lisati edukalt',0),(36193,1006,'si','Zaposlenega pregled uspeÅ¡no posodobljena.',0),(36194,1006,'ba','Karyawan Review diperbarui berhasil.',0),(36195,1006,'nl','Werknemer Review bijgewerkt.',0),(36196,1006,'fi','TyÃ¶ntekijÃ¤n tarkastelun pÃ¤ivitetty.',0),(36197,1006,'no','Ansatte gjennomgang oppdatert.',0),(36198,1006,'da','Medarbejder anmeldelse opdateret.',0),(36199,1006,'ko','ì§ì› ë¦¬ë·° ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(36200,1006,'he','×¡×§×™×¨×” ×”×¢×•×‘×“ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(36201,1006,'el','Î‘Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(36202,1006,'zh','å‘˜å·¥å®¡æŸ¥æ›´æ–°æˆåŠŸã€‚\r\n',0),(36203,1006,'sv','AnstÃ¤lld recension uppdaterats.',0),(36204,1006,'it','Recensione dipendente aggiornato con successo.',0),(36205,1006,'tl','',0),(36206,1006,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(36207,1006,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(36208,1006,'ms','Kajian pekerja berjaya dikemas kini.',0),(36209,1006,'ar','Ø­Ø¯Ù‘Ø« ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ù…ÙˆØ¸Ù‘Ù Ø¨Ù†Ø¬Ø§Ø­',0),(36210,1006,'fr','EmployÃ© examen de mise Ã  jour avec succÃ¨s.',0),(36211,1006,'jp','å¾“æ¥­å“¡ãƒ¬ãƒ“ãƒ¥ãƒ¼ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(36212,1006,'pt','RevisÃ£o de funcionÃ¡rio atualizado com sucesso.',0),(36213,1006,'ru','ÐžÐ±Ð·Ð¾Ñ€ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(36214,1006,'es','Empleado RevisiÃ³n actualizada exitosamente',0),(36215,1006,'de','Mitarbeiter-Review erfolgreich aktualisiert.',0),(36216,1006,'en','Employee Review updated successfully.',0),(36217,1007,'is','',0),(36218,1007,'dr','Ú¯Ø²ÙŠÙ†Ø´ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(36219,1007,'pr','Ú¯Ø²ÙŠÙ†Ø´ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(36220,1007,'tr','Personel seÃ§imi',0),(36221,1007,'pl','Selekcja pracownikÃ³w',0),(36222,1007,'bg','ÐŸÐ¾Ð´Ð±Ð¾Ñ€ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(36223,1007,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨',0),(36224,1007,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ñƒ',0),(36225,1007,'vi','Chá»n NhÃ¢n viÃªn',0),(36226,1007,'af','Werknemer Seleksie',0),(36227,1007,'ro','Angajat de selecÅ£ie',0),(36228,1007,'et','TÃ¶Ã¶tajate valimine',0),(36229,1007,'si','Izbira zaposlenih',0),(36230,1007,'ba','Pilihan karyawan',0),(36231,1007,'nl','Werknemer selectie',0),(36232,1007,'fi','TyÃ¶ntekijÃ¤n valinta',0),(36233,1007,'no','Employee utvalg',0),(36234,1007,'da','Medarbejder udvÃ¦lgelse',0),(36235,1007,'ko','ì§ì› ì„ íƒ',0),(36236,1007,'he','×‘×—×™×¨×ª ×”×¢×•×‘×“',0),(36237,1007,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(36238,1007,'zh','å‘˜å·¥çš„é€‰æ‹©\r\n',0),(36239,1007,'sv','AnstÃ¤lld urval',0),(36240,1007,'it','Selezione dei dipendenti',0),(36241,1007,'tl','',0),(36242,1007,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(36243,1007,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤šà¤¯à¤¨',0),(36244,1007,'ms','Pemilihan pekerja',0),(36245,1007,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù…ÙˆØ¸Ù',0),(36246,1007,'fr','SÃ©lection de l\'employÃ©',0),(36247,1007,'jp','å¾“æ¥­å“¡ã‚»ãƒ¬ã‚¯ã‚·ãƒ§ãƒ³',0),(36248,1007,'pt','SeleÃ§Ã£o de funcionÃ¡rios',0),(36249,1007,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(36250,1007,'es','Empleado SelecciÃ³n',0),(36251,1007,'de','Mitarbeiterauswahl',0),(36252,1007,'en','Employee Selection',0),(36253,1008,'is','',0),(36254,1008,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ³Ø®  Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(36255,1008,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ³Ø®  Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(36256,1008,'tr','Ã‡alÄ±ÅŸan baÅŸarÄ±yla sonlandÄ±rÄ±ldÄ±.',0),(36257,1008,'pl','Pracownik pomyÅ›lnie zakoÅ„czone.',0),(36258,1008,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÑÐ²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(36259,1008,'ur','Ù…Ù„Ø§Ø²Ù… Ù†Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø®ØªÙ… Ú©Ø± Ø¯ÛŒØ§ Û”',0),(36260,1008,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¿Ñ€ÐµÐºÐ¸Ð½ÑƒÑ‚Ð°.',0),(36261,1008,'vi','Cháº¥m dá»©t NhÃ¢n viÃªn thÃ nh cÃ´ng',0),(36262,1008,'af','Werknemer suksesvol getermineer.',0),(36263,1008,'ro','Angajat Ã®ncheiatÄƒ cu succes.',0),(36264,1008,'et','TÃ¶Ã¶taja lÃµpetatud edukalt.',0),(36265,1008,'si','Zaposleni uspeÅ¡no prekinjeno.',0),(36266,1008,'ba','Karyawan dihentikan berhasil.',0),(36267,1008,'nl','Werknemer beÃ«indigd met succes.',0),(36268,1008,'fi','TyÃ¶suhde pÃ¤Ã¤ttyy onnistuneesti.',0),(36269,1008,'no','Ansatt avsluttet vellykket.',0),(36270,1008,'da','Medarbejder opsiges med succes.',0),(36271,1008,'ko','ì§ì› ì¢…ë£Œ ì„±ê³µì ìœ¼ë¡œ.',0),(36272,1008,'he','×”×¢×•×‘×“ ×”×¡×ª×™×™× ×‘×”×¦×œ×—×”.',0),(36273,1008,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(36274,1008,'zh','å‘˜å·¥æˆåŠŸç»ˆæ­¢ã€‚\r\n',0),(36275,1008,'sv','AnstÃ¤lld avslutas framgÃ¥ngsrikt.',0),(36276,1008,'it','Dipendente terminato con successo.',0),(36277,1008,'tl','',0),(36278,1008,'th','&#3585;&#3634;&#3619;&#3607;&#3635;&#3651;&#3627;&#3657;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(36279,1008,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤ˆà¥¤',0),(36280,1008,'ms','Pekerja ditamatkan berjaya.',0),(36281,1008,'ar','Ù…ÙˆØ¸Ù Ø£Ù†Ù‡ÙŠØª Ø¨Ù†Ø¬Ø§Ø­.',0),(36282,1008,'fr','EmployÃ© licenciÃ© avec succÃ¨s.',0),(36283,1008,'jp','å¾“æ¥­å“¡ã‚’è§£é›‡ã?—ã?¾ã?—ã?Ÿ',0),(36284,1008,'pt','Empregado terminada com Ãªxito.',0),(36285,1008,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°.',0),(36286,1008,'es','Empleado terminado exitosamente',0),(36287,1008,'de','Mitarbeiter erfolgreich beendet.',0),(36288,1008,'en','Employee terminated successfully.',0),(36289,1009,'is','',0),(36290,1009,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(36291,1009,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(36292,1009,'tr','Ã‡alÄ±ÅŸan baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(36293,1009,'pl','Pracownik pomyÅ›lnie zaktualizowana.',0),(36294,1009,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(36295,1009,'ur','Ù…Ù„Ø§Ø²Ù… Ù†Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(36296,1009,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(36297,1009,'vi','Cáº­p Nháº­t NhÃ¢n ViÃªn thÃ nh cÃ´ng',0),(36298,1009,'af','Werknemer suksesvol opdateer.',0),(36299,1009,'ro','Angajat actualizat cu succes.',0),(36300,1009,'et','TÃ¶Ã¶taja uuendati edukalt',0),(36301,1009,'si','Zaposleni uspeÅ¡no posodobljena.',0),(36302,1009,'ba','Karyawan diperbarui berhasil.',0),(36303,1009,'nl','Werknemer bijgewerkt.',0),(36304,1009,'fi','TyÃ¶ntekijÃ¤ pÃ¤ivitettiin onnistuneesti.',0),(36305,1009,'no','Ansatte oppdatert.',0),(36306,1009,'da','Medarbejder opdateret.',0),(36307,1009,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì§ì›.',0),(36308,1009,'he','.×¢×•×‘×“ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(36309,1009,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(36310,1009,'zh','å‘˜å·¥æ›´æ–°æˆåŠŸã€‚\r\n',0),(36311,1009,'sv','Medarbetare uppdaterats.',0),(36312,1009,'it','Dipendente aggiornato con successo.',0),(36313,1009,'tl','',0),(36314,1009,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(36315,1009,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(36316,1009,'ms','Pekerja yang berjaya dikemas kini.',0),(36317,1009,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ù…ÙˆØ¸Ù‘Ù Ø¨Ù†Ø¬Ø§Ø­',0),(36318,1009,'fr','EmployÃ© mise Ã  jour avec succÃ¨s.',0),(36319,1009,'jp','å¾“æ¥­å“¡ã‚’æ›´æ–°ã?—ã?¾ã?—ã?Ÿ',0),(36320,1009,'pt','FuncionÃ¡rio atualizado com sucesso.',0),(36321,1009,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½.',0),(36322,1009,'es','Empleado actualizado exitosamente',0),(36323,1009,'de','Mitarbeiter erfolgreich aktualisiert.',0),(36324,1009,'en','Employee updated successfully.',0),(36325,1010,'is','',0),(36326,1010,'dr','(Ø§Ø¹Ø§Ù†Ù‡â€Œ Ø¯Ø§Ø¯Ù†â€Œ) Ù…ÙŠ ÙƒÙ†Ø¯ ØŸ',0),(36327,1010,'pr','ÙƒØ§Ø±ÙØ±Ù…Ø§ Ú†Ú¯ÙˆÙ†Ù‡ Ù‡Ù…ÙƒØ§Ø±ÙŠ (Ø§Ø¹Ø§Ù†Ù‡â€Œ Ø¯Ø§Ø¯Ù†â€Œ) Ù…ÙŠ ÙƒÙ†Ø¯ ØŸ',0),(36328,1010,'tr','Ä°ÅŸveren katkÄ±sÄ± nasÄ±l?',0),(36329,1010,'pl','Pracodawca przyczynia siÄ™ jak?',0),(36330,1010,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»ÑÑ‚ Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð°ÑÑ ÐºÐ°Ðº?',0),(36331,1010,'ur','Ø¢Ø¬Ø± Ø³Û’ Ø§Ø®Ø±Ø§Ø¬ Ú©Ø³ Ø·Ø±Ø­ØŸ',0),(36332,1010,'sr','Ð”Ð¾Ð¿Ñ€Ð¸Ð½Ð¾ÑÐ¸ Ð¿Ð¾ÑÐ»Ð¾Ð´Ð°Ð²Ñ†Ð° ÐºÐ°ÐºÐ¾?',0),(36333,1010,'vi','Chá»§ doanh nghiá»‡p Ä‘Ã³ng gÃ³p nhÆ° tháº¿ nÃ o?',0),(36334,1010,'af','Hoe dra Werkgewer by?',0),(36335,1010,'ro','Angajatorul contribuie cum?',0),(36336,1010,'et','TÃ¶Ã¶andja kuidas?',0),(36337,1010,'si','Delodajalec prispeva kako?',0),(36338,1010,'ba','Memberikan kontribusi majikan bagaimana?',0),(36339,1010,'nl','Werkgever draagt bij hoe?',0),(36340,1010,'fi','TyÃ¶nantaja maksaa miten?',0),(36341,1010,'no','Arbeidsgivers bidrag hvordan?',0),(36342,1010,'da','Arbejdsgiveren bidrager hvordan?',0),(36343,1010,'ko','ê³ ìš©ì£¼ ê¸°ì—¬ ì–´ë–»ê²Œ?',0),(36344,1010,'he','?×›×™×¦×“ ×”×ž×¢×¡×™×§ ×ª×•×¨×',0),(36345,1010,'el','Î•ÏÎ³Î¿Î´ÏŒÏ„Î· ÏƒÏ…Î¼Î²Î¬Î»Î»ÎµÎ¹ Ï€ÏŽÏ‚;',0),(36346,1010,'zh','é›‡ä¸»å¦‚ä½•æåŠ©ï¼Ÿ\r\n',0),(36347,1010,'sv','Arbetsgivaren bidrar hur?',0),(36348,1010,'it','Datore di lavoro contribuisce come?',0),(36349,1010,'tl','',0),(36350,1010,'th','&#3609;&#3634;&#3618;&#3592;&#3657;&#3634;&#3591;&#3651;&#3627;&#3657;&#3648;&#3591;&#3636;&#3609;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3619;',0),(36351,1010,'hi','à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤•à¥‡ à¤¯à¥‹à¤—à¤¦à¤¾à¤¨ à¤¦à¥‡à¤¤à¤¾ à¤¹à¥ˆ à¤•à¥ˆà¤¸à¥‡?',0),(36352,1010,'ms','Majikan menyumbang bagaimana?',0),(36353,1010,'ar','ÙŠØ³Ø§Ù‡Ù… Ø±Ø¨ Ø§Ù„Ø¹Ù…Ù„ ÙƒÙŠÙØŸ',0),(36354,1010,'fr','Employeur verse comment ?',0),(36355,1010,'jp','å¾“æ¥­å“¡ã?¯ã?©ã?®ã‚ˆã?†ã?«è²¢çŒ®ã?—ã?¦ã?„ã?¾ã?™ã?‹ï¼Ÿ',0),(36356,1010,'pt','Empregador contribui como?',0),(36357,1010,'ru','ÐšÐ°Ðº ÑÐ¿Ð¾ÑÐ¾Ð±ÑÑ‚Ð²ÑƒÐµÑ‚ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº?',0),(36358,1010,'es','Â¿Empleado se contribuye como?',0),(36359,1010,'de','Arbeitgeber trÃ¤gt wie?',0),(36360,1010,'en','Employer Contributes How?',0),(36361,1011,'is','',0),(36362,1011,'dr','Ù‡Ù…ÙƒØ§Ø±ÙŠ ÙƒØ§Ø±ÙØ±Ù…Ø§',0),(36363,1011,'pr','Ù‡Ù…ÙƒØ§Ø±ÙŠ ÙƒØ§Ø±ÙØ±Ù…Ø§',0),(36364,1011,'tr','Ä°ÅŸveren katkÄ±sÄ±',0),(36365,1011,'pl','Pracodawcy',0),(36366,1011,'bg','ÐŸÑ€Ð¸Ð½Ð¾Ñ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»Ñ',0),(36367,1011,'ur','Ø¢Ø¬Ø± Ú©Ø§ Ú©Ø±Ø¯Ø§Ø±',0),(36368,1011,'sr','Ð”Ð¾Ð¿Ñ€Ð¸Ð½Ð¾Ñ Ð¿Ð¾ÑÐ»Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(36369,1011,'vi','Chá»§ doanh nghiá»‡p Ä‘Ã³ng gÃ³p ',0),(36370,1011,'af','Werkgewer Bydrae',0),(36371,1011,'ro','ContribuÅ£ia angajatorului',0),(36372,1011,'et','TÃ¶Ã¶andja panus',0),(36373,1011,'si','Prispevek delodajalca',0),(36374,1011,'ba','Kontribusi majikan',0),(36375,1011,'nl','Werkgeversbijdrage',0),(36376,1011,'fi','TyÃ¶nantajan osuus',0),(36377,1011,'no','Arbeidsgiver',0),(36378,1011,'da','Arbejdsgiver bidrag',0),(36379,1011,'ko','ê³ ìš©ì£¼ ê¸°ì—¬',0),(36380,1011,'he','×ª×¨×•×ž×ª ×ž×¢×¡×™×§',0),(36381,1011,'el','Î£Ï…Î½ÎµÎ¹ÏƒÏ†Î¿ÏÎ¬ ÎµÏÎ³Î¿Î´ÏŒÏ„Î·',0),(36382,1011,'zh','é›‡ä¸»æåŠ©\r\n',0),(36383,1011,'sv','Arbetsgivaren bidrag',0),(36384,1011,'it','Contributo del datore di lavoro',0),(36385,1011,'tl','',0),(36386,1011,'th','&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3621;&#3641;&#3585;&#3592;&#3657;&#3634;&#3591;',0),(36387,1011,'hi','à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤…à¤‚à¤¶à¤¦à¤¾à¤¨',0),(36388,1011,'ms','Caruman majikan',0),(36389,1011,'ar','Ù…Ø³Ø§Ù‡Ù…Ø© Ø¬Ù‡Ø© Ø§Ù„Ø¹Ù…Ù„',0),(36390,1011,'fr','Contribution de l\'employeur',0),(36391,1011,'jp','é›‡ç”¨è€…åˆ†æ‹…é‡‘',0),(36392,1011,'pt','ContribuiÃ§Ã£o do empregador',0),(36393,1011,'ru','Ð’Ð·Ð½Ð¾Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»Ñ',0),(36394,1011,'es','Empleado ContribuciÃ³n',0),(36395,1011,'de','Arbeitgeberbeitrag',0),(36396,1011,'en','Employer contribution',0),(36397,1012,'is','',0),(36398,1012,'dr','Ù…ÙˆØ§Ø¬Ù‡ Ø´Ø¯Ù† Ø¨Ø§ ÙŠÙƒ Ø®Ø·Ø§ Ø¯Ø± Ù…Ø±Ø­Ù„Ù‡ ',0),(36399,1012,'pr','Ù…ÙˆØ§Ø¬Ù‡ Ø´Ø¯Ù† Ø¨Ø§ ÙŠÙƒ Ø®Ø·Ø§ Ø¯Ø± Ù…Ø±Ø­Ù„Ù‡ ',0),(36400,1012,'tr','Bir adÄ±mda karÅŸÄ±laÅŸtÄ±',0),(36401,1012,'pl','WystÄ…piÅ‚ bÅ‚Ä…d w kroku',0),(36402,1012,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð° Ð³Ñ€ÐµÑˆÐºÐ° Ð² ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(36403,1012,'ur','Ù‚Ø¯Ù… Ù…ÛŒÚº Ø§ÛŒÚ© Ù†Ù‚Øµ Ù…Ù„Ø§',0),(36404,1012,'sr','ÐˆÐµ Ð½Ð°Ð¸ÑˆÐ°Ð¾ Ð½Ð° Ð³Ñ€ÐµÑˆÐºÑƒ Ñƒ ÐºÐ¾Ñ€Ð°ÐºÑƒ',0),(36405,1012,'vi','Bá»‹ lá»—i trong quÃ¡ trÃ¬nh',0),(36406,1012,'af','\'N teÃ«gekom in stap',0),(36407,1012,'ro','A Ã®ntÃ¢lnit o eroare Ã®n pas',0),(36408,1012,'et','Ilmnes tÃµrge juhises',0),(36409,1012,'si','Napaka v korak',0),(36410,1012,'ba','Mengalami kesalahan dalam langkah',0),(36411,1012,'nl','Een fout opgetreden in stap',0),(36412,1012,'fi','Virhe vaiheessa',0),(36413,1012,'no','Det oppstod en feil i trinn',0),(36414,1012,'da','Der opstod en fejl i trin',0),(36415,1012,'ko','ë‹¨ê³„ì—ì„œ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(36416,1012,'he','× ×ª×§×œ ×‘×©×’×™××” ×‘×ž×”×œ×š ×©×œ×‘',0),(36417,1012,'el','Î‘Î½Ï„Î¹Î¼ÎµÏ„ÏŽÏ€Î¹ÏƒÎµ Î­Î½Î± ÏƒÏ†Î¬Î»Î¼Î± ÏƒÏ„Î¿ Î²Î®Î¼Î±',0),(36418,1012,'zh','é‡åˆ°ä¸€ä¸ªé”™è¯¯çš„æ­¥éª¤\r\n',0),(36419,1012,'sv','Det uppstod ett fel i steg',0),(36420,1012,'it','Rilevato un errore nel passaggio',0),(36421,1012,'tl','',0),(36422,1012,'th','&#3614;&#3610;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3586;&#3633;&#3657;&#3609;&#3609;&#3637;&#3657;',0),(36423,1012,'hi','à¤šà¤°à¤£ à¤®à¥‡à¤‚ à¤•à¥‹à¤ˆ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¤¾ à¤¸à¤¾à¤®à¤¨à¤¾ à¤•à¤°à¤¨à¤¾ à¤ªà¤¡à¤¼à¤¾',0),(36424,1012,'ms','Menghadapi masalah dalam langkah',0),(36425,1012,'ar','ØµØ§Ø¯Ù Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø®Ø·ÙˆØ©',0),(36426,1012,'fr','A rencontrÃ© une erreur Ã  l\'Ã©tape',0),(36427,1012,'jp','é€”ä¸­ã?§ã‚¨ãƒ©ãƒ¼ã?Œç™ºç”Ÿã?—ã?¾ã?—ã?Ÿ',0),(36428,1012,'pt','Encontrou um erro na etapa',0),(36429,1012,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð° Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð² ÑˆÐ°Ð³Ðµ',0),(36430,1012,'es','Se encontrÃ³ un error en el paso',0),(36431,1012,'de','Fehler in Schritt',0),(36432,1012,'en','Encountered an error in step',0),(36433,1013,'is','',0),(36434,1013,'dr','Ù¾Ø§ÙŠØ§Ù† ',0),(36435,1013,'pr','Ù¾Ø§ÙŠØ§Ù† ',0),(36436,1013,'tr','BitiÅŸ',0),(36437,1013,'pl','Koniec',0),(36438,1013,'bg','ÐšÑ€Ð°Ð¹',0),(36439,1013,'ur','Ø§Ø®ØªØªØ§Ù…',0),(36440,1013,'sr','ÐšÑ€Ð°Ñ˜',0),(36441,1013,'vi','Káº¿t thÃºc',0),(36442,1013,'af','Einde',0),(36443,1013,'ro','SfÃ¢rÅŸitul',0),(36444,1013,'et','LÃµpp',0),(36445,1013,'si','Konec',0),(36446,1013,'ba','Akhir',0),(36447,1013,'nl','Einde',0),(36448,1013,'fi','Loppu',0),(36449,1013,'no','Slutten',0),(36450,1013,'da','Udgangen',0),(36451,1013,'ko','ë',0),(36452,1013,'he','×¡×•×£',0),(36453,1013,'el','Î¤Î­Î»Î¿Ï‚',0),(36454,1013,'zh','å®Œ\r\n',0),(36455,1013,'sv','Slutet',0),(36456,1013,'it','Fine',0),(36457,1013,'tl','',0),(36458,1013,'th','&#3592;&#3610;',0),(36459,1013,'hi','à¤…à¤‚à¤¤',0),(36460,1013,'ms','Akhir',0),(36461,1013,'ar','Ù†Ù‡Ø§ÙŠØ©',0),(36462,1013,'fr','Fin',0),(36463,1013,'jp','çµ‚äº†',0),(36464,1013,'pt','Fim',0),(36465,1013,'ru','ÐšÐ¾Ð½ÐµÑ†',0),(36466,1013,'es','Final',0),(36467,1013,'de','Ende',0),(36468,1013,'en','End',0),(36469,1014,'is','',0),(36470,1014,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(36471,1014,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(36472,1014,'tr','BitiÅŸ tarihi',0),(36473,1014,'pl','Data zakoÅ„czenia',0),(36474,1014,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(36475,1014,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(36476,1014,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(36477,1014,'vi','NgÃ y cuá»‘i',0),(36478,1014,'af','End Datum',0),(36479,1014,'ro','Data de sfarsit',0),(36480,1014,'et','LÃµppkuupÃ¤ev',0),(36481,1014,'si','KonÄni datum',0),(36482,1014,'ba','Tanggal berakhir',0),(36483,1014,'nl','Einddatum',0),(36484,1014,'fi','PÃ¤ivÃ¤ pÃ¤Ã¤ttyen',0),(36485,1014,'no','Sluttdatoen',0),(36486,1014,'da','Slutdato',0),(36487,1014,'ko','ë ë‚ ì§œ',0),(36488,1014,'he','×ª××¨×™×š ×¡×™×•×',0),(36489,1014,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(36490,1014,'zh','ç»“æŸæ—¥æœŸ',0),(36491,1014,'sv','Slutdatum',0),(36492,1014,'it','Data di fine',0),(36493,1014,'tl','',0),(36494,1014,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(36495,1014,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(36496,1014,'ms','Tarikh akhir',0),(36497,1014,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(36498,1014,'fr','Date de fin',0),(36499,1014,'jp','å®Œäº†æ—¥',0),(36500,1014,'pt','Data de tÃ©rmino',0),(36501,1014,'ru','ÐšÐ¾Ð½ÐµÑ‡Ð½Ð°Ñ Ð”Ð°Ñ‚Ð°',0),(36502,1014,'es','Fecha Final',0),(36503,1014,'de','End-Datum',0),(36504,1014,'en','End Date',0),(36505,1015,'is','',0),(36506,1015,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ú†Ùƒ Ù‡Ø§ ',0),(36507,1015,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ú†Ùƒ Ù‡Ø§ ',0),(36508,1015,'tr','BitiÅŸ tarihi denetimleri',0),(36509,1015,'pl','Data zakoÅ„czenia kontroli',0),(36510,1015,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸Ñ‚Ðµ',0),(36511,1015,'ur','Ú†ÛŒÚ© Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(36512,1015,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ñ‡ÐµÐºÐ¾Ð²Ð°',0),(36513,1015,'vi','Káº¿t thÃºc ngÃ y SÃ©c',0),(36514,1015,'af','End Datum van Tjeks',0),(36515,1015,'ro','Data de sfÃ¢rÅŸit a controalelor',0),(36516,1015,'et','Kontrollide lÃµpetamine',0),(36517,1015,'si','KonÄni datum kontrole',0),(36518,1015,'ba','Akhir tanggal cek',0),(36519,1015,'nl','Einddatum van de controles',0),(36520,1015,'fi','Loppuun mennessÃ¤ tarkastusten',0),(36521,1015,'no','Sluttdatoen for sjekker',0),(36522,1015,'da','Slutdatoen for kontrol',0),(36523,1015,'ko','ê²€ì‚¬ì˜ ì¢…ë£Œ ë‚ ì§œ',0),(36524,1015,'he','×ª××¨×™×š ×¡×™×•× ×©×œ ×‘×“×™×§×•×ª',0),(36525,1015,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï„Ï‰Î½ ÎµÎ»Î­Î³Ï‡Ï‰Î½',0),(36526,1015,'zh','æ”¯ç¥¨ç»“æŸæ—¥æœŸ',0),(36527,1015,'sv','Slutdatum fÃ¶r kontroller',0),(36528,1015,'it','Data di scadenza dei controlli',0),(36529,1015,'tl','',0),(36530,1015,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;&#3586;&#3629;&#3591;&#3648;&#3594;&#3655;&#3588;',0),(36531,1015,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¤à¤¿à¤¥à¤¿ à¤•à¥€ à¤œà¤¾à¤‚à¤š à¤•à¥€',0),(36532,1015,'ms','Tarikh akhir semakan',0),(36533,1015,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ù…Ù† ØªØ¯Ù‚ÙŠÙ‚',0),(36534,1015,'fr','Date de la fin des contrÃ´les',0),(36535,1015,'jp','å°?åˆ‡æ‰‹ã?®å®Œäº†æ—¥',0),(36536,1015,'pt','Data de tÃ©rmino dos controlos',0),(36537,1015,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(36538,1015,'es','Fecha Final de Cheques',0),(36539,1015,'de','End-Datum der PrÃ¼fungen',0),(36540,1015,'en','End Date of Checks',0),(36541,1016,'is','',0),(36542,1016,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ÙØ§ÙƒØªÙˆØ± ',0),(36543,1016,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ÙØ§ÙƒØªÙˆØ± ',0),(36544,1016,'tr','Son fatura tarihi',0),(36545,1016,'pl','Data koÅ„cowa faktura',0),(36546,1016,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°',0),(36547,1016,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(36548,1016,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(36549,1016,'vi','NgÃ y cuá»‘i cá»§a hÃ³a Ä‘Æ¡n',0),(36550,1016,'af','End Datum van Faktuur',0),(36551,1016,'ro','Data de sfÃ¢rÅŸit a facturii',0),(36552,1016,'et','Arve lÃµppkuupÃ¤ev',0),(36553,1016,'si','KonÄni datum raÄuna',0),(36554,1016,'ba','Akhir tanggal faktur',0),(36555,1016,'nl','Einddatum van factuur',0),(36556,1016,'fi','Laskun pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(36557,1016,'no','Sluttdatoen for faktura',0),(36558,1016,'da','Slutdato for faktura',0),(36559,1016,'ko','ë ë‚ ì§œ',0),(36560,1016,'he','×ª××¨×™×š ×¡×™×•× ×©×œ ×—×©×‘×•× ×™×ª',0),(36561,1016,'el','Î¤Î­Î»Î¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(36562,1016,'zh','å‘ç¥¨ç»“æŸæ—¥æœŸ\r\n',0),(36563,1016,'sv','Slutdatum fÃ¶r faktura',0),(36564,1016,'it','Data di scadenza della fattura',0),(36565,1016,'tl','',0),(36566,1016,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(36567,1016,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥€ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(36568,1016,'ms','Tarikh akhir bagi invois',0),(36569,1016,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(36570,1016,'fr','Date de fin de facture',0),(36571,1016,'jp','è«‹æ±‚æ›¸å®Œäº†æ—¥',0),(36572,1016,'pt','Data de fim da fatura',0),(36573,1016,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°',0),(36574,1016,'es','Fecha Final de Factura',0),(36575,1016,'de','End-Datum der Rechnung',0),(36576,1016,'en','End Date of Invoice',0),(36577,1017,'is','',0),(36578,1017,'dr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø³Ø± Ø±Ø³ÙŠØ¯ ',0),(36579,1017,'pr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø³Ø± Ø±Ø³ÙŠØ¯ ',0),(36580,1017,'tr','Sonunda vade tarihi',0),(36581,1017,'pl','Koniec odpowiednim terminie',0),(36582,1017,'bg','ÐŸÐ°Ð´ÐµÐ¶ Ð² ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(36583,1017,'ur','Ø¢Ø®Ø± Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(36584,1017,'sr','ÐšÑ€Ð°Ñ˜ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(36585,1017,'vi','NgÃ y Ä‘áº¿n háº¡n cuá»‘i',0),(36586,1017,'af','End Verskuldigde Datum',0),(36587,1017,'ro','SfÃ¢rÅŸitul cuvenit data',0),(36588,1017,'et','LÃµpe tÃ¤htaeg kuupÃ¤ev',0),(36589,1017,'si','Na koncu zaradi datuma',0),(36590,1017,'ba','Mengakhiri Due Date',0),(36591,1017,'nl','Einde Due datum',0),(36592,1017,'fi','Lopettaa asianmukaisesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(36593,1017,'no','Avslutte grunn dato',0),(36594,1017,'da','Ende Due dato',0),(36595,1017,'ko','ê¸°í•œ ì¢…ë£Œ ë‚ ì§œ',0),(36596,1017,'he','×œ×¡×™×™× ××ª ×™×¢×“ ×ª××¨×™×š',0),(36597,1017,'el','Î¤Î­Î»Î¿Ï‚ Î»ÏŒÎ³Ï‰ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(36598,1017,'zh','ç»“æŸåˆ°æœŸæ—¥æœŸ',0),(36599,1017,'sv','Avsluta Due Date',0),(36600,1017,'it','Fine scadenza Data',0),(36601,1017,'tl','',0),(36602,1017,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(36603,1017,'hi','à¤…à¤‚à¤¤ à¤®à¥‡à¤‚ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(36604,1017,'ms','Akhir akhir tarikh',0),(36605,1017,'ar','Ø§Ù„ÙˆØ§Ø¬Ø¨ ÙÙŠ Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(36606,1017,'fr','Fin Due Date',0),(36607,1017,'jp','æœŸé™?çµ‚äº†æ—¥',0),(36608,1017,'pt','Acabar Due Date',0),(36609,1017,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ðµ ÐŸÐ¾ Ð”Ð°Ñ‚Ðµ',0),(36610,1017,'es','Fecha Final de Vencimiento',0),(36611,1017,'de','Ende Due Date',0),(36612,1017,'en','End Due Date',0),(36613,1018,'is','',0),(36614,1018,'dr','Ù¾Ø§ÙŠØ§Ù† ÙŠÙƒ ÙƒÙ„Ù…Ù‡ ',0),(36615,1018,'pr','Ù¾Ø§ÙŠØ§Ù† ÙŠÙƒ ÙƒÙ„Ù…Ù‡ ',0),(36616,1018,'tr','submitend',0),(36617,1018,'pl','submitend',0),(36618,1018,'bg','submitend',0),(36619,1018,'ur','Ø³Ø¨Ù…Ø§Ù¹Ø§Ù†Ø¯',0),(36620,1018,'sr','ÑÑƒÐ±Ð¼Ð¸Ñ‚ÐµÐ½Ð´',0),(36621,1018,'vi','Káº¿t thÃºc ná»™p',0),(36622,1018,'af','ingedien',0),(36623,1018,'ro','submitend',0),(36624,1018,'et','submitend',0),(36625,1018,'si','submitend',0),(36626,1018,'ba','submitend',0),(36627,1018,'nl','submitend',0),(36628,1018,'fi','submitend',0),(36629,1018,'no','submitend',0),(36630,1018,'da','submitend',0),(36631,1018,'ko','submitend',0),(36632,1018,'he','submitend',0),(36633,1018,'el','submitend',0),(36634,1018,'zh','æäº¤',0),(36635,1018,'sv','submitend',0),(36636,1018,'it','submitend',0),(36637,1018,'tl','',0),(36638,1018,'th','&#3592;&#3610;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3617;&#3629;&#3610;',0),(36639,1018,'hi','submitend',0),(36640,1018,'ms','submitend',0),(36641,1018,'ar','Ø³ÙˆØ¨Ù…ÙŠØªÙŠÙ†Ø¯',0),(36642,1018,'fr','submitend',0),(36643,1018,'jp','submitend',0),(36644,1018,'pt','submitend',0),(36645,1018,'ru','submitend',0),(36646,1018,'es','Final de Presentar',0),(36647,1018,'de','submitend',0),(36648,1018,'en','submitend',0),(36649,1019,'is','',0),(36650,1019,'dr','Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ ',0),(36651,1019,'pr','Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ ',0),(36652,1019,'tr','Son dÃ¶nem',0),(36653,1019,'pl','Koniec okresu',0),(36654,1019,'bg','ÐšÑ€Ð°Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(36655,1019,'ur','Ø§Ø®ØªØªØ§Ù… Ù…Ø¯Øª',0),(36656,1019,'sr','ÐšÑ€Ð°Ñ˜ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(36657,1019,'vi','Cuá»‘i ká»³',0),(36658,1019,'af','Periode Eindig',0),(36659,1019,'ro','SfÃ¢rÅŸitul perioadei',0),(36660,1019,'et','Perioodi lÃµpp',0),(36661,1019,'si','KonÄno obdobje',0),(36662,1019,'ba','Akhir periode',0),(36663,1019,'nl','Einde periode',0),(36664,1019,'fi','Tilikauden lopussa',0),(36665,1019,'no','End perioden',0),(36666,1019,'da','Ende periode',0),(36667,1019,'ko','ë ê¸°ê°„',0),(36668,1019,'he','×¡×•×£ ×ª×§×•×¤×”',0),(36669,1019,'el','Î¤Î­Î»Î¿Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(36670,1019,'zh','æœŸæœ«\r\n',0),(36671,1019,'sv','Slutperiod',0),(36672,1019,'it','Fine periodo',0),(36673,1019,'tl','',0),(36674,1019,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(36675,1019,'hi','à¤…à¤‚à¤¤ à¤…à¤µà¤§à¤¿',0),(36676,1019,'ms','Akhir zaman',0),(36677,1019,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©',0),(36678,1019,'fr','Fin de pÃ©riode',0),(36679,1019,'jp','æœŸé–“ã?®çµ‚ã‚?ã‚Š',0),(36680,1019,'pt','Fim de perÃ­odo',0),(36681,1019,'ru','ÐšÐ¾Ð½ÐµÑ† ÐŸÐµÑ€Ð¸Ð¾Ð´Ð°',0),(36682,1019,'es','Fin del PerÃ­odo',0),(36683,1019,'de','End-Periode',0),(36684,1019,'en','End Period',0),(36685,1020,'is','',0),(36686,1020,'dr','Ù¾Ø§ÙŠØ§Ù† Ú¯Ø²ÙŠÙ†Ø´ Ù‡Ø§ ',0),(36687,1020,'pr','Ù¾Ø§ÙŠØ§Ù† Ú¯Ø²ÙŠÙ†Ø´ Ù‡Ø§ ',0),(36688,1020,'tr','Son seÃ§imler',0),(36689,1020,'pl','Koniec selekcji',0),(36690,1020,'bg','ÐšÑ€Ð°Ð¹ ÑÐµÐ»ÐµÐºÑ†Ð¸Ð¸',0),(36691,1020,'ur','Ø¢Ø®Ø± Ø§Ù†ØªØ®Ø§Ø¨',0),(36692,1020,'sr','ÐšÑ€Ð°Ñ˜ Ð¾Ð´Ð°Ð±Ð¸Ñ€Ðµ',0),(36693,1020,'vi','Káº¿t thÃºc lá»±a chá»n',0),(36694,1020,'af','Einde seleksies',0),(36695,1020,'ro','SfÃ¢rÅŸitul selecÅ£ii',0),(36696,1020,'et','LÃµpuks Valikud',0),(36697,1020,'si','KonÄni izbor',0),(36698,1020,'ba','Pilihan akhir',0),(36699,1020,'nl','Einde selecties',0),(36700,1020,'fi','Lopulta valinnat',0),(36701,1020,'no','Slutten valg',0),(36702,1020,'da','Ende valg',0),(36703,1020,'ko','ë ì„ íƒ',0),(36704,1020,'he','×¡×•×£ ×‘×—×™×¨×•×ª',0),(36705,1020,'el','Î¤Î­Î»Î¿Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(36706,1020,'zh','é€‰å®Œ',0),(36707,1020,'sv','Slutet val',0),(36708,1020,'it','Fine selezioni',0),(36709,1020,'tl','',0),(36710,1020,'th','&#3592;&#3610;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(36711,1020,'hi','à¤…à¤‚à¤¤ à¤šà¤¯à¤¨à¥‹à¤‚',0),(36712,1020,'ms','Pilihan akhir',0),(36713,1020,'ar','ØªØ­Ø¯ÙŠØ¯Ø§Øª Ù†Ù‡Ø§ÙŠØ©',0),(36714,1020,'fr','SÃ©lections de fin',0),(36715,1020,'jp','é?¸æŠžçµ‚äº†',0),(36716,1020,'pt','Final de seleÃ§Ãµes',0),(36717,1020,'ru','Ð—Ð°ÐºÐ¾Ð½Ñ‡Ð¸Ñ‚ÑŒ Ð’Ñ‹Ð±Ð¾Ñ€',0),(36718,1020,'es','Terminar Selecciones',0),(36719,1020,'de','Ende-Auswahl',0),(36720,1020,'en','End Selections',0),(36721,1021,'is','',0),(36722,1021,'dr','/ Ù…Ø§Ù‡ ',0),(36723,1021,'pr','Ù¾Ø§ÙŠØ§Ù† Ø³Ø§Ù„  / Ù…Ø§Ù‡ ',0),(36724,1021,'tr','Son yÄ±l/ay',0),(36725,1021,'pl','Koniec rok/miesiÄ…c',0),(36726,1021,'bg','ÐšÑ€Ð°Ð¹ Ð³Ð¾Ð´Ð¸Ð½Ð°/Ð¼ÐµÑÐµÑ†',0),(36727,1021,'ur','Ø§Ø®ØªØªØ§Ù… Ø³Ø§Ù„/Ù…ÛÛŒÙ†Û',0),(36728,1021,'sr','ÐšÑ€Ð°Ñ˜ Ð³Ð¾Ð´Ð¸Ð½Ðµ/Ð¼ÐµÑÐµÑ†',0),(36729,1021,'vi','Cuá»‘i nÄƒm/thÃ¡ng',0),(36730,1021,'af','Einde jaar/maand',0),(36731,1021,'ro','SfÃ¢rÈ™itul anul/luna',0),(36732,1021,'et','LÃµpp aasta/kuu',0),(36733,1021,'si','Konec leto/mesec',0),(36734,1021,'ba','Akhir tahun/bulan',0),(36735,1021,'nl','Einde jaar/maand',0),(36736,1021,'fi','Loppu vuosi/kuukausi',0),(36737,1021,'no','Slutten Ã¥r/mÃ¥ned',0),(36738,1021,'da','Ende Ã¥r/mÃ¥ned',0),(36739,1021,'ko','ë ë…„/ì›”',0),(36740,1021,'he','×¡×•×£ ×©× ×”/×—×•×“×©',0),(36741,1021,'el','Î¤Î­Î»Î¿Ï‚ Î­Ï„Î¿Ï…Ï‚/Î¼Î®Î½Î±',0),(36742,1021,'zh','ç»“æŸå¹´ä»½/æœˆ',0),(36743,1021,'sv','Slutet Ã¥r/mÃ¥nad',0),(36744,1021,'it','Fine anno/mese',0),(36745,1021,'tl','',0),(36746,1021,'th','&#3611;&#3637;/&#3648;&#3604;&#3639;&#3629;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(36747,1021,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤µà¤°à¥à¤·/à¤®à¤¾à¤¹',0),(36748,1021,'ms','Akhir tahun/bulan',0),(36749,1021,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©/Ø§Ù„Ø´Ù‡Ø±',0),(36750,1021,'fr','Fin annÃ©e/mois',0),(36751,1021,'jp','çµ‚äº†ã€€å¹´/æœˆ',0),(36752,1021,'pt','Final de ano/mÃªs',0),(36753,1021,'ru','Ð“Ð¾Ð´/Ð¼ÐµÑÑÑ† Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(36754,1021,'es','AÃ±o/Mes Final',0),(36755,1021,'de','Ende Jahr/Monat',0),(36756,1021,'en','End Year/Month',0),(36757,1022,'is','',0),(36758,1022,'dr','ØªØ±Ø§Ø² Ø§Ø®ØªØªØ§Ù…ÙŠÙ‡ ',0),(36759,1022,'pr','ØªØ±Ø§Ø² Ø§Ø®ØªØªØ§Ù…ÙŠÙ‡ ',0),(36760,1022,'tr','KapanÄ±ÅŸ bakiyesi',0),(36761,1022,'pl','Saldo koÅ„cowe',0),(36762,1022,'bg','ÐšÑ€Ð°Ð¹Ð½Ð¾ ÑÐ°Ð»Ð´Ð¾',0),(36763,1022,'ur','ØªÙˆØ§Ø²Ù† Ú©Ùˆ Ø®ØªÙ… Ú©Ø±Ù†Û’',0),(36764,1022,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(36765,1022,'vi','DÆ° ná»£ cuá»‘i',0),(36766,1022,'af','Eindigende Balans',0),(36767,1022,'ro','Sold final',0),(36768,1022,'et','LÃµppsaldo',0),(36769,1022,'si','KonÄni saldo',0),(36770,1022,'ba','Saldo akhir',0),(36771,1022,'nl','Eindsaldo',0),(36772,1022,'fi','Loppusaldo',0),(36773,1022,'no','Sluttsaldo',0),(36774,1022,'da','Slutsaldo',0),(36775,1022,'ko','ê²°ë§ ê· í˜•',0),(36776,1022,'he','×”×¡×•×£ ××™×–×•×Ÿ',0),(36777,1022,'el','Î¥Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ Ï„Î­Î»Î¿Ï…Ï‚',0),(36778,1022,'zh','æœŸæœ«ä½™é¢\r\n',0),(36779,1022,'sv','UtgÃ¥ende balans',0),(36780,1022,'it','Saldi fine',0),(36781,1022,'tl','',0),(36782,1022,'th','&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3626;&#3636;&#3657;&#3609;&#3591;&#3623;&#3604;',0),(36783,1022,'hi','à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤•à¥‹ à¤¸à¤®à¤¾à¤ªà¥à¤¤',0),(36784,1022,'ms','Kira-kira berakhir',0),(36785,1022,'ar','Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ø®ØªØ§Ù…ÙŠ',0),(36786,1022,'fr','Solde de clÃ´ture',0),(36787,1022,'jp','çµ‚äº†ãƒ?ãƒ©ãƒ³ã‚¹',0),(36788,1022,'pt','Saldo final',0),(36789,1022,'ru','ÐšÐ¾Ð½ÐµÑ‡Ð½Ð¾Ðµ ÑÐ°Ð»ÑŒÐ´Ð¾',0),(36790,1022,'es','Saldo Final',0),(36791,1022,'de','Endsaldo',0),(36792,1022,'en','Ending Balance',0),(36793,1023,'is','',0),(36794,1023,'dr','ØªØ§Ø±ÙŠØ® Ø§Ø±Ø²ÙŠØ§Ø¨ÙŠ Ù¾Ø§ÙŠØ§Ù†ÙŠ ',0),(36795,1023,'pr','ØªØ§Ø±ÙŠØ® Ø§Ø±Ø²ÙŠØ§Ø¨ÙŠ Ù¾Ø§ÙŠØ§Ù†ÙŠ ',0),(36796,1023,'tr','Son deÄŸerlendirme tarihi',0),(36797,1023,'pl','Data zakoÅ„czenia oceny',0),(36798,1023,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(36799,1023,'ur','Ø¬Ø§Ø¦Ø²Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø®ØªÙ… ÛÙˆÙ†Û’',0),(36800,1023,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð° ÐµÐ²Ð°Ð»ÑƒÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(36801,1023,'vi','NgÃ y Ä‘Ã¡nh giÃ¡ cuá»‘i',0),(36802,1023,'af','Endig Evaluasiedatum',0),(36803,1023,'ro','Evaluare data de sfÃ¢rÅŸit',0),(36804,1023,'et','Hindamise lÃµppkuupÃ¤ev',0),(36805,1023,'si','KonÄni datum vrednotenja',0),(36806,1023,'ba','Evaluasi tanggal berakhirnya',0),(36807,1023,'nl','Einddatum van de evaluatie',0),(36808,1023,'fi','Arviointi Lopetuspvm',0),(36809,1023,'no','Sluttdato for evaluering',0),(36810,1023,'da','Slutdato for evaluering',0),(36811,1023,'ko','í‰ê°€ ë‚ ì§œ ê²°ë§',0),(36812,1023,'he','×”×¢×¨×›×” ×ª××¨×™×š ×¡×’×™×¨×”',0),(36813,1023,'el','Î—Î¼/Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Î±Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(36814,1023,'zh','ç»“æŸè¯„ä¼°æ—¥æœŸ\r\n',0),(36815,1023,'sv','Slutdatum fÃ¶r utvÃ¤rdering',0),(36816,1023,'it','Valutazione data fine',0),(36817,1023,'tl','',0),(36818,1023,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3586;&#3637;&#3618;&#3609;&#3611;&#3621;&#3634;&#3618;&#3591;&#3623;&#3604;',0),(36819,1023,'hi','à¤®à¥‚à¤²à¥à¤¯à¤¾à¤‚à¤•à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‹ à¤¸à¤®à¤¾à¤ªà¥à¤¤',0),(36820,1023,'ms','Berakhir pada tarikh penilaian',0),(36821,1023,'ar','Ø§Ù„Ù…Ù†ØªÙ‡ÙŠ ÙÙŠ ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙ‚ÙŠÙŠÙ…',0),(36822,1023,'fr','Ã‰valuation Date fin',0),(36823,1023,'jp','è©•ä¾¡çµ‚äº†æ—¥',0),(36824,1023,'pt','Data de avaliaÃ§Ã£o final',0),(36825,1023,'ru','ÐšÐ¾Ð½ÐµÑ‡Ð½Ð°Ñ Ð´Ð°Ñ‚Ð° Ð¾Ñ†ÐµÐ½ÐºÐ¸',0),(36826,1023,'es','Fecha de EvaluaciÃ³n Final',0),(36827,1023,'de','Bewertung Enddatum',0),(36828,1023,'en','Ending Evaluation Date',0),(36829,1024,'is','',0),(36830,1024,'dr','Ù…Ø§Ù‡ Ù¾Ø§ÙŠØ§Ù†ÙŠ ',0),(36831,1024,'pr','Ù…Ø§Ù‡ Ù¾Ø§ÙŠØ§Ù†ÙŠ ',0),(36832,1024,'tr','Son ay',0),(36833,1024,'pl','ZakoÅ„czenie miesiÄ…ca',0),(36834,1024,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐ²Ð°Ñ‰ Ð¼ÐµÑÐµÑ†',0),(36835,1024,'ur','Ù…ÛÛŒÙ†Û Ø®ØªÙ… ÛÙˆÙ†Û’',0),(36836,1024,'sr','ÐšÑ€Ð°Ñ˜ Ð¼ÐµÑÐµÑ†Ð°',0),(36837,1024,'vi','ThÃ¡ng cuá»‘i',0),(36838,1024,'af','Laaste Maand',0),(36839,1024,'ro','Se Ã®ncheie luni',0),(36840,1024,'et','LÃµppev kuu',0),(36841,1024,'si','Konec meseca',0),(36842,1024,'ba','Akhir bulan',0),(36843,1024,'nl','Einde maand',0),(36844,1024,'fi','Loppu kuussa',0),(36845,1024,'no','Til mÃ¥ned',0),(36846,1024,'da','Slutter mÃ¥ned',0),(36847,1024,'ko','ê²°ë§ ë‹¬',0),(36848,1024,'he','×—×•×“×© ×¡×™×•×',0),(36849,1024,'el','Î¤Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î¼Î®Î½Î±',0),(36850,1024,'zh','æœ€åŽæœˆä»½',0),(36851,1024,'sv','LÃ¶per mÃ¥nad',0),(36852,1024,'it','Fine mese',0),(36853,1024,'tl','',0),(36854,1024,'th','&#3648;&#3604;&#3639;&#3629;&#3609;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(36855,1024,'hi','à¤®à¤¹à¥€à¤¨à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤',0),(36856,1024,'ms','Berakhir pada bulan',0),(36857,1024,'ar','ØªÙ†ØªÙ‡ÙŠ ÙÙŠ Ø´Ù‡Ø±',0),(36858,1024,'fr','Fin de mois',0),(36859,1024,'jp','æœŸæœ«æœˆ',0),(36860,1024,'pt','MÃªs final',0),(36861,1024,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ðµ Ð¼ÐµÑÑÑ†Ð°',0),(36862,1024,'es','Mes Final',0),(36863,1024,'de','Monat',0),(36864,1024,'en','Ending Month',0),(36865,1025,'is','',0),(36866,1025,'dr','Ø­ÙˆØ§Ù„Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡',0),(36867,1025,'pr','Ø­ÙˆØ§Ù„Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡',0),(36868,1025,'tr','DoÄŸrulayÄ±cÄ±',0),(36869,1025,'pl','Indos',0),(36870,1025,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð¸Ñ‚ÐµÐ»',0),(36871,1025,'ur','Endorser',0),(36872,1025,'sr','Ð–Ð¸Ñ€Ð°Ð½Ñ‚Ð°',0),(36873,1025,'vi','Thá»«a nháº­n',0),(36874,1025,'af','Endorser',0),(36875,1025,'ro','Girant',0),(36876,1025,'et','Toetaja',0),(36877,1025,'si','Podpornik',0),(36878,1025,'ba','Endorser',0),(36879,1025,'nl','Endorser',0),(36880,1025,'fi','Endorser',0),(36881,1025,'no','PÃ¥skriveren',0),(36882,1025,'da','Endorser',0),(36883,1025,'ko','Endorser',0),(36884,1025,'he','Endorser',0),(36885,1025,'el','Î•Ï€Î¹ÏƒÏ†ÏÎ¬Î³Î¹ÏƒÎ·Ï‚',0),(36886,1025,'zh','è½¬è®©äºº',0),(36887,1025,'sv','Endorser',0),(36888,1025,'it','Testimonial',0),(36889,1025,'tl','',0),(36890,1025,'th','&#3612;&#3641;&#3657;&#3621;&#3591;&#3609;&#3634;&#3617;',0),(36891,1025,'hi','Endorser à¤•à¥‡',0),(36892,1025,'ms','Penyokong',0),(36893,1025,'ar','Ø£Ø¯Ø§Ø© Ø§Ù„Ø¥Ø¸Ù‡Ø§Ø±',0),(36894,1025,'fr','Endosseur',0),(36895,1025,'jp','è£?æ›¸äºº.',0),(36896,1025,'pt','Endossante',0),(36897,1025,'ru','Ð˜Ð½Ð´Ð¾ÑÑÐ°Ð½Ñ‚',0),(36898,1025,'es','Endosante',0),(36899,1025,'de','Endorser',0),(36900,1025,'en','Endorser',0),(36901,1026,'is','',0),(36902,1026,'dr','Ø§Ù†Ú¯Ù„ÙŠØ³ÙŠ ',0),(36903,1026,'pr','Ø§Ù†Ú¯Ù„ÙŠØ³ÙŠ ',0),(36904,1026,'tr','Ä°ngilizce',0),(36905,1026,'pl','Angielski',0),(36906,1026,'bg','ÐÐ½Ð³Ð»Ð¸Ð¹ÑÐºÐ¸',0),(36907,1026,'ur','Ø§Ù†Ú¯Ø±ÙŠØ²ÛŒ',0),(36908,1026,'sr','ÐµÐ½Ð³Ð»ÐµÑÐºÐ¸',0),(36909,1026,'vi','Tiáº¿ng Anh',0),(36910,1026,'af','Engels',0),(36911,1026,'ro','EnglezÄƒ',0),(36912,1026,'et','Inglise',0),(36913,1026,'si','angleÅ¡Äina',0),(36914,1026,'ba','Inggris',0),(36915,1026,'nl','Engels',0),(36916,1026,'fi','englanti',0),(36917,1026,'no','Engelsk',0),(36918,1026,'da','engelsk',0),(36919,1026,'ko','ì˜ì–´',0),(36920,1026,'he','×× ×’×œ×™×ª',0),(36921,1026,'el','Î‘Î³Î³Î»Î¹ÎºÎ¬',0),(36922,1026,'zh','è‹±è¯­',0),(36923,1026,'sv','Engelska',0),(36924,1026,'it','Inglese',0),(36925,1026,'tl','',0),(36926,1026,'th','&#3629;&#3633;&#3591;&#3585;&#3620;&#3625;',0),(36927,1026,'hi','à¤…à¤‚à¤—à¥à¤°à¥‡à¥›à¥€',0),(36928,1026,'ms','Inggeris',0),(36929,1026,'ar','Ø§Ù„Ø¥Ù†Ø¬Ù„ÙŠØ²ÙŠØ©',0),(36930,1026,'fr','Anglais',0),(36931,1026,'jp','è‹±èªž',0),(36932,1026,'pt','InglÃªs',0),(36933,1026,'ru','Ð°Ð½Ð³Ð»Ð¸Ð¹ÑÐºÐ¸Ð¹',0),(36934,1026,'es','InglÃ©s',0),(36935,1026,'de','Englisch',0),(36936,1026,'en','English',0),(36937,1027,'is','',0),(36938,1027,'dr','( Ù…Ø±ÙƒØ¨',0),(36939,1027,'pr','Ø«Ø¨Øª ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…Ø®ØªÙ„Ø· ( Ù…Ø±ÙƒØ¨',0),(36940,1027,'tr','BileÅŸik Ã¶ÄŸeleri ÅŸimdi girin',0),(36941,1027,'pl','Teraz naleÅ¼y wprowadziÄ‡ elementy kompozytowe',0),(36942,1027,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÑŠÑÑ‚Ð°Ð²Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ ÑÐµÐ³Ð°',0),(36943,1027,'ur','Ø§Ø¨ Ø¬Ø§Ù…Ø¹ Ø§Ø´ÛŒØ§Ø¡ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(36944,1027,'sr','Ð¡Ð°Ð´Ð° ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ ÑÐ»Ð¾Ð¶ÐµÐ½Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ',0),(36945,1027,'vi','Nháº­p hÃ ng composite bÃ¢y giá»',0),(36946,1027,'af','Voer saamgestelde items nou in',0),(36947,1027,'ro','Intre elementele de compozite acum',0),(36948,1027,'et','Sisestage nÃ¼Ã¼d komposiit Ã¼ksused',0),(36949,1027,'si','Sedaj vnesite sestavljenih elementov',0),(36950,1027,'ba','Masukkan komposit item sekarang',0),(36951,1027,'nl','Samengestelde artikelen nu invoeren',0),(36952,1027,'fi','Anna komposiitti kohteita nyt',0),(36953,1027,'no','Angi sammensatte elementer nÃ¥',0),(36954,1027,'da','Indtaste sammensatte varer nu',0),(36955,1027,'ko','ì´ì œ ë³µí•© í•­ëª© ìž…ë ¥',0),(36956,1027,'he','×”×–×Ÿ ×¤×¨×™×˜×™× ×ž×•×¨×›×‘×™× ×¢×›×©×™×•',0),(36957,1027,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„ÏŽÏÎ± ÏƒÏÎ½Î¸ÎµÏ„Î± Î±Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î±',0),(36958,1027,'zh','çŽ°åœ¨è¾“å…¥å¤åˆææ–™é¡¹ç›®\r\n',0),(36959,1027,'sv','Ange sammansatta artiklar nu',0),(36960,1027,'it','Immettere elementi compositi ora',0),(36961,1027,'tl','',0),(36962,1027,'th','&#3611;&#3657;&#3629;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3586;&#3638;&#3657;&#3609;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(36963,1027,'hi','à¤•à¤®à¥à¤ªà¥‹à¤œà¤¿à¤Ÿ à¤®à¤¦à¥‹à¤‚ à¤…à¤¬ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(36964,1027,'ms','Masukkan butiran komposit sekarang',0),(36965,1027,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…Ø±ÙƒØ¨Ø© Ø§Ù„Ø¢Ù†',0),(36966,1027,'fr','Participez maintenant et Ã©lÃ©ments composites',0),(36967,1027,'jp','è¤‡å?ˆå“?ç›®ã?®å…¥åŠ›',0),(36968,1027,'pt','Inserir itens compostos agora',0),(36969,1027,'ru','Ð¢ÐµÐ¿ÐµÑ€ÑŒ Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÐ¾ÑÑ‚Ð°Ð²Ð½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹',0),(36970,1027,'es','Introducir items compÃ³sitos ahora',0),(36971,1027,'de','Geben Sie jetzt ein zusammengesetzten Elemente',0),(36972,1027,'en','Enter composite items now',0),(36973,1028,'is','',0),(36974,1028,'dr','Ø«Ø¨Øª Ø¨Ù‡Ø§ ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ ÙƒØ§Ù„Ø§ ',0),(36975,1028,'pr','Ø«Ø¨Øª Ø¨Ù‡Ø§ ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ ÙƒØ§Ù„Ø§ ',0),(36976,1028,'tr','MalÄ±n maliyeti girin',0),(36977,1028,'pl','WprowadÅº koszt towarÃ³w',0),(36978,1028,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð½Ð° ÑÑ‚Ð¾ÐºÐ¸Ñ‚Ðµ',0),(36979,1028,'ur','Ø³Ø§Ù…Ø§Ù† Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(36980,1028,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ñ€Ð¾Ð±Ðµ',0),(36981,1028,'vi','Nháº­p GiÃ¡ thÃ nh hÃ ng hÃ³a',0),(36982,1028,'af','Voer Koste van Goedere in',0),(36983,1028,'ro','IntroduceÅ£i costul produselor',0),(36984,1028,'et','Sisestage kauba maksumusest',0),(36985,1028,'si','Vnesete ceno blaga',0),(36986,1028,'ba','Masukkan biaya barang',0),(36987,1028,'nl','Kosten van goederen invoeren',0),(36988,1028,'fi','SyÃ¶tÃ¤ tuotteiden kustannukset',0),(36989,1028,'no','Angi kostnader for varer',0),(36990,1028,'da','Angiv prisen pÃ¥ varer',0),(36991,1028,'ko','ìƒí’ˆì˜ ë¹„ìš© ìž…ë ¥',0),(36992,1028,'he','×”×–×Ÿ ×¢×œ×•×ª ×”×ž×›×¨',0),(36993,1028,'el','Î Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÏ„Îµ Ï„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ Ï„Ï‰Î½ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Ï‰Î½',0),(36994,1028,'zh','è¾“å…¥å•†å“æˆæœ¬\r\n',0),(36995,1028,'sv','Ange kostnaden fÃ¶r varor',0),(36996,1028,'it','Immettere il costo dei beni',0),(36997,1028,'tl','',0),(36998,1028,'th','&#3611;&#3657;&#3629;&#3609;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(36999,1028,'hi','à¤®à¤¾à¤² à¤•à¥€ à¤²à¤¾à¤—à¤¤ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(37000,1028,'ms','Masukkan kos barangan',0),(37001,1028,'ar','Ø¥Ø¯Ø®Ø§Ù„ ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(37002,1028,'fr','Entrez le coÃ»t des marchandises',0),(37003,1028,'jp','å•†å“?åŽŸä¾¡ã?®å…¥åŠ›',0),(37004,1028,'pt','Digite o custo das mercadorias',0),(37005,1028,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(37006,1028,'es','Introducir Costo de Bienes',0),(37007,1028,'de','Geben Sie Kosten von waren',0),(37008,1028,'en','Enter Cost of Goods',0),(37009,1029,'is','',0),(37010,1029,'dr','Ø«Ø¨Øª Ø³Ø§Ø¹Ø§Øª Ø¨ÙŠØ´ØªØ± ',0),(37011,1029,'pr','Ø«Ø¨Øª Ø³Ø§Ø¹Ø§Øª Ø¨ÙŠØ´ØªØ± ',0),(37012,1029,'tr','Daha fazla saat girin',0),(37013,1029,'pl','WprowadÅº wiÄ™cej godzin',0),(37014,1029,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ñ‡Ð°ÑÐ¾Ð²Ðµ',0),(37015,1029,'ur','Ù…Ø²ÛŒØ¯ Ú¯Ú¾Ù†Ù¹Û’ Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(37016,1029,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð²Ð¸ÑˆÐµ ÑÐ°Ñ‚Ð¸',0),(37017,1029,'vi','Nháº­p thÃªm giá»',0),(37018,1029,'af','Meer Ure Invoer',0),(37019,1029,'ro','IntroduceÅ£i mai multe ore',0),(37020,1029,'et','Sisestage rohkem tundi',0),(37021,1029,'si','Vnesite veÄ ur',0),(37022,1029,'ba','Masukkan jam',0),(37023,1029,'nl','Meer uren invoeren',0),(37024,1029,'fi','LisÃ¤Ã¤ tuntien',0),(37025,1029,'no','Angi flere timer',0),(37026,1029,'da','Angiv flere timer',0),(37027,1029,'ko','ë” ë§Žì€ ì‹œê°„ì„ ìž…ë ¥',0),(37028,1029,'he','×”×–×Ÿ ×©×¢×•×ª × ×•×¡×¤×•×ª',0),(37029,1029,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ ÏŽÏÎµÏ‚',0),(37030,1029,'zh','è¾“å…¥æ›´å¤šçš„æ—¶é—´',0),(37031,1029,'sv','Ange fler timmar',0),(37032,1029,'it','Immettere le ore piÃ¹',0),(37033,1029,'tl','',0),(37034,1029,'th','&#3611;&#3657;&#3629;&#3609;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(37035,1029,'hi','à¤…à¤§à¤¿à¤• à¤˜à¤‚à¤Ÿà¥‡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(37036,1029,'ms','Masukkan lebih jam',0),(37037,1029,'ar','Ø£Ø¯Ø®Ù„ Ø³Ø§Ø¹Ø§Øª Ø£ÙƒØ«Ø±',0),(37038,1029,'fr','Entrez le plus dâ€™heures',0),(37039,1029,'jp','è¿½åŠ å‹¤å‹™æ™‚é–“ã?®å…¥åŠ›',0),(37040,1029,'pt','Introduzir mais horas',0),(37041,1029,'ru','Ð’Ð²ÐµÑÑ‚Ð¸ Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð§Ð°ÑÑ‹',0),(37042,1029,'es','Introducir MÃ¡s Horas',0),(37043,1029,'de','Geben Sie mehr Stunden',0),(37044,1029,'en','Enter More Hours',0),(37045,1030,'is','',0),(37046,1030,'dr','Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª Ø²Ù…Ø§Ù†  Ùˆ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(37047,1030,'pr','Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª Ø²Ù…Ø§Ù†  Ùˆ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(37048,1030,'tr','Zaman ve malzeme girmek iÃ§in tÄ±klatÄ±n',0),(37049,1030,'pl','Kliknij, aby wprowadziÄ‡ czas & materiaÅ‚Ã³w',0),(37050,1030,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ñ€ÐµÐ¼Ðµ & Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸',0),(37051,1030,'ur','ÙˆÙ‚Øª & Ù…ÙˆØ§Ø¯ Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(37052,1030,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÐ½ÐµÐ»Ð¸ Ð²Ñ€ÐµÐ¼Ðµ & Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð°',0),(37053,1030,'vi','Nháº¥n vÃ o Ä‘á»ƒ nháº­p thá»i gian & váº­t liá»‡u ',0),(37054,1030,'af','Kliek vir invoering van Tyd & Materiale',0),(37055,1030,'ro','FaceÅ£i clic pentru a introduce timpul & materiale',0),(37056,1030,'et','KlÃµpsake, et sisestada aeg & materjalid',0),(37057,1030,'si','Kliknite, Äe Å¾elite vnesti Äas & materialov',0),(37058,1030,'ba','Klik untuk memasukkan waktu & bahan',0),(37059,1030,'nl','Schakel tijd & materialen',0),(37060,1030,'fi','LisÃ¤Ã¤ aikaa & materiaalit',0),(37061,1030,'no','Klikk for Ã¥ angi tiden & materialer',0),(37062,1030,'da','Klik her for at indtaste tid & materialer',0),(37063,1030,'ko','ì‹œê°„ ë° ìž¬ë£Œë¥¼ ìž…ë ¥ í•˜ë ¤ë©´ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(37064,1030,'he','×œ×—×¥ ×›×“×™ ×œ×”×–×™×Ÿ ×–×ž×Ÿ & ×—×•×ž×¨×™×',0),(37065,1030,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï‡ÏÏŒÎ½Î¿ & Ï…Î»Î¹ÎºÎ¬',0),(37066,1030,'zh','ç‚¹å‡»è¾“å…¥æ—¶é—´ä¸Žææ–™',0),(37067,1030,'sv','Klicka fÃ¶r att ange tid & material',0),(37068,1030,'it','Clicca per entrare nel tempo & materiali',0),(37069,1030,'tl','',0),(37070,1030,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3611;&#3657;&#3629;&#3609;&#3648;&#3623;&#3621;&#3634;&#3649;&#3621;&#3632;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(37071,1030,'hi','à¤¸à¤®à¤¯ & à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(37072,1030,'ms','Klik untuk memasukkan masa & bahan-bahan',0),(37073,1030,'ar','Ø§Ù†Ù‚Ø± Ù„Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„ÙˆÙ‚Øª & Ø§Ù„Ù…ÙˆØ§Ø¯',0),(37074,1030,'fr','Cliquez pour entrer dans les temps & matÃ©riaux',0),(37075,1030,'jp','æ™‚é–“ã?¨è³‡æ–™ã?®å…¥åŠ›ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ã??ã? ã?•ã?„',0),(37076,1030,'pt','Clique para entrar &amp; materiais do tempo',0),(37077,1030,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ Ð’Ñ€ÐµÐ¼Ñ & ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹',0),(37078,1030,'es','Click para Introducir Tiempo y Materiales',0),(37079,1030,'de','Click to Enter Zeit & Materialien',0),(37080,1030,'en','Click to Enter Time & Materials',0),(37081,1031,'is','',0),(37082,1031,'dr','Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(37083,1031,'pr','Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(37084,1031,'tr','Girilen',0),(37085,1031,'pl','Wprowadzone',0),(37086,1031,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½Ð°',0),(37087,1031,'ur','Ø¯Ø§Ø®Ù„',0),(37088,1031,'sr','Ð£Ð½ÐµÑ‚Ð°',0),(37089,1031,'vi','ÄÃ£ nháº­p',0),(37090,1031,'af','Ingevoer',0),(37091,1031,'ro','A intrat',0),(37092,1031,'et','Sisestatud',0),(37093,1031,'si','ZaÄel',0),(37094,1031,'ba','Masuk',0),(37095,1031,'nl','Ingevoerd',0),(37096,1031,'fi','Tuli',0),(37097,1031,'no','Angitt',0),(37098,1031,'da','Indtastet',0),(37099,1031,'ko','ìž…ë ¥',0),(37100,1031,'he','×”×•×›× ×¡',0),(37101,1031,'el','Î¤Î­Î¸Î·ÎºÎµ',0),(37102,1031,'zh','è¿›å…¥',0),(37103,1031,'sv','In',0),(37104,1031,'it','Entrato',0),(37105,1031,'tl','',0),(37106,1031,'th','&#3611;&#3657;&#3629;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(37107,1031,'hi','à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(37108,1031,'ms','Memasuki',0),(37109,1031,'ar','Ù…Ø¯Ø®Ù„',0),(37110,1031,'fr','EntrÃ©',0),(37111,1031,'jp','è¨˜å¸³',0),(37112,1031,'pt','Entrou',0),(37113,1031,'ru','Ð’Ð²ÐµÐ´ÐµÐ½Ð¾',0),(37114,1031,'es','Entrado',0),(37115,1031,'de','Eingegeben',0),(37116,1031,'en','Entered',0),(37117,1032,'is','',0),(37118,1032,'dr','Ø«Ø¨Øª Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ',0),(37119,1032,'pr','Ø«Ø¨Øª Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ',0),(37120,1032,'tr','TarafÄ±ndan girilen',0),(37121,1032,'pl','Wpisany przez',0),(37122,1032,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸ Ð¾Ñ‚',0),(37123,1032,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¯Ø§Ø®Ù„ ÛÙˆØ¦Û’ Û”',0),(37124,1032,'sr','Ð£Ð½Ð¾ÑÐ¸',0),(37125,1032,'vi','ÄÃ£ nháº­p bá»Ÿi',0),(37126,1032,'af','Ingetik deur',0),(37127,1032,'ro','Introduse de',0),(37128,1032,'et','Neid kohustusi',0),(37129,1032,'si','Vnesla',0),(37130,1032,'ba','Dimasukkan oleh',0),(37131,1032,'nl','Ingebracht door',0),(37132,1032,'fi','Tuli',0),(37133,1032,'no','Angitt av',0),(37134,1032,'da','Skrevet af',0),(37135,1032,'ko','ìž…ë ¥ í•œ',0),(37136,1032,'he','×©×”×•×–×Ÿ ×¢×œ-×™×“×™',0),(37137,1032,'el','Î•Î¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ',0),(37138,1032,'zh','è¾“å…¥è€…',0),(37139,1032,'sv','Anges av',0),(37140,1032,'it','Inserito da',0),(37141,1032,'tl','',0),(37142,1032,'th','&#3606;&#3641;&#3585;&#3611;&#3657;&#3629;&#3609;&#3650;&#3604;&#3618;',0),(37143,1032,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(37144,1032,'ms','Dimeterai oleh',0),(37145,1032,'ar','Ø¯Ø®Ù„Øª Ù‚Ø¨Ù„',0),(37146,1032,'fr','EntrÃ© par',0),(37147,1032,'jp','è¨˜å¸³',0),(37148,1032,'pt','Introduzido por',0),(37149,1032,'ru','Ð’Ð²ÐµÐ´ÐµÐ½Ð¾',0),(37150,1032,'es','Entrada por',0),(37151,1032,'de','Eingetragen von',0),(37152,1032,'en','Entered by',0),(37153,1033,'is','',0),(37154,1033,'dr','Ù…ÙˆØ³Ø³Ù‡ ØªØ¬Ø§Ø±ÙŠ',0),(37155,1033,'pr','Ù…ÙˆØ³Ø³Ù‡ ØªØ¬Ø§Ø±ÙŠ',0),(37156,1033,'tr','Kurumsal',0),(37157,1033,'pl','PrzedsiÄ™biorstwo',0),(37158,1033,'bg','ÐŸÑ€ÐµÐ´Ð¿Ñ€Ð¸ÑÑ‚Ð¸ÐµÑ‚Ð¾',0),(37159,1033,'ur','Ø§Ù†Ù¹Ø±Ù¾Ø±Ø§Ø¦Ø²',0),(37160,1033,'sr','Ð•Ð½Ñ‚ÐµÑ€Ð¿Ñ€Ð¸ÑÐµ',0),(37161,1033,'vi','Doanh nghiá»‡p',0),(37162,1033,'af','Enterprise',0),(37163,1033,'ro','Intreprindere',0),(37164,1033,'et','EttevÃµtte',0),(37165,1033,'si','Podjetje',0),(37166,1033,'ba','Perusahaan',0),(37167,1033,'nl','Enterprise',0),(37168,1033,'fi','Yrityksen',0),(37169,1033,'no','Enterprise',0),(37170,1033,'da','Enterprise',0),(37171,1033,'ko','ì—”í„° í”„ ë¼ì´ì¦ˆ',0),(37172,1033,'he','×ž×¤×¢×œ',0),(37173,1033,'el','Î•Ï€Î¹Ï‡ÎµÎ¯ÏÎ·ÏƒÎ·',0),(37174,1033,'zh','ä¼ä¸š',0),(37175,1033,'sv','Enterprise',0),(37176,1033,'it','Enterprise',0),(37177,1033,'tl','',0),(37178,1033,'th','Enterprise',0),(37179,1033,'hi','à¤‰à¤¦à¥à¤¯à¤®',0),(37180,1033,'ms','Enterprise',0),(37181,1033,'ar','Ø§Ù„Ù…Ø¤Ø³Ø³Ø©',0),(37182,1033,'fr','Entreprise',0),(37183,1033,'jp','ä¼?æ¥­',0),(37184,1033,'pt','Enterprise',0),(37185,1033,'ru','ÐŸÑ€ÐµÐ´Ð¿Ñ€Ð¸ÑÑ‚Ð¸Ðµ',0),(37186,1033,'es','Empresa',0),(37187,1033,'de','Enterprise',0),(37188,1033,'en','Enterprise',0),(37189,1034,'is','',0),(37190,1034,'dr','ÙƒÙ„ Ù…Ù‚Ø§Ø¯ÙŠØ± Ù‡Ù†ÙˆØ² Ø­Ù…Ù„ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(37191,1034,'pr','ÙƒÙ„ Ù…Ù‚Ø§Ø¯ÙŠØ± Ù‡Ù†ÙˆØ² Ø­Ù…Ù„ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(37192,1034,'tr','TÃ¼m miktar henÃ¼z sevk',0),(37193,1034,'pl','CaÅ‚a iloÅ›Ä‡ nie zostaÅ‚y jeszcze wysÅ‚ane',0),(37194,1034,'bg','Ð¦ÑÐ»Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²ÑÐµ Ð¾Ñ‰Ðµ Ð½Ðµ ÑÐ° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸',0),(37195,1034,'ur','Ù¾ÙˆØ±ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ø§Ø¨Ú¾ÛŒ ØªÚ© Ù†ÛÛŒÚº',0),(37196,1034,'sr','Ð¦ÐµÐ»Ñƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ ÐºÐ¾Ñ˜Ð° Ñ˜Ð¾Ñˆ Ð½Ð¸Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð°',0),(37197,1034,'vi','ToÃ n bá»™ sá»‘ lÆ°á»£ng hÃ ng chÆ°a chuyá»ƒn',0),(37198,1034,'af','Totale hoeveelheid nog nie versend',0),(37199,1034,'ro','ÃŽntreaga cantitate nu au fost Ã®ncÄƒ expediate',0),(37200,1034,'et','Terve kogus pole veel tarnitud',0),(37201,1034,'si','Celotno koliÄino, ki Å¡e niso dobavljeni',0),(37202,1034,'ba','Seluruh kuantitas yang belum dikirim',0),(37203,1034,'nl','Gehele hoeveelheid nog niet verzonden',0),(37204,1034,'fi','Koko ei vielÃ¤ toimitettu mÃ¤Ã¤rÃ¤',0),(37205,1034,'no','Hele antallet som ennÃ¥ ikke er sendt',0),(37206,1034,'da','Hele antal, der endnu ikke er leveret',0),(37207,1034,'ko','ì•„ì§ ë°°ì†¡ ì „ì²´ ìˆ˜ëŸ‰',0),(37208,1034,'he','×›×ž×•×ª ×›×•×œ×• ×¢×“×™×™×Ÿ ×œ× × ×©×œ×—',0),(37209,1034,'el','Î”ÎµÎ½ Î­Ï‡Î¿Ï…Î½ Î±ÎºÏŒÎ¼Î· Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯ Î¿Î»ÏŒÎºÎ»Î·ÏÎ· Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(37210,1034,'zh','å°šæœªè¿å…¨éƒ¨æ•°é‡',0),(37211,1034,'sv','Hela den kvantitet som Ã¤nnu inte levererats',0),(37212,1034,'it','Intera quantitÃ  non ancora spedito',0),(37213,1034,'tl','',0),(37214,1034,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3649;&#3588;&#3656;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(37215,1034,'hi','à¤¸à¤‚à¤ªà¥‚à¤°à¥à¤£ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¨à¤¹à¥€à¤‚ à¤…à¤­à¥€ à¤¤à¤• à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(37216,1034,'ms','Keseluruhan kuantiti yang belum dihantar',0),(37217,1034,'ar','ÙƒØ§Ù…Ù„ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ Ù„Ù… ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ø¨Ø¹Ø¯',0),(37218,1034,'fr','Toute quantitÃ© non encore livrÃ©e',0),(37219,1034,'jp','ç™ºé€?å‰?ã?®å…¨æ•°é‡?',0),(37220,1034,'pt','Totalidade da quantidade ainda nÃ£o enviado',0),(37221,1034,'ru','Ð’ÑÐµÐ³Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐµÑ‰Ðµ Ð½Ðµ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(37222,1034,'es','Cantidad Entera Ya No HabÃ­a Enviado',0),(37223,1034,'de','Gesamte noch nicht gelieferte Menge',0),(37224,1034,'en','Entire quantity not yet shipped',0),(37225,1035,'is','',0),(37226,1035,'dr','Ø«Ø¨Øª ØªÙ†Ø§Ù‚Ø¶Ø§Øª Ø¨Ø§ Ø­Ø³Ø§Ø¨ ',0),(37227,1035,'pr','Ø«Ø¨Øª ØªÙ†Ø§Ù‚Ø¶Ø§Øª Ø¨Ø§ Ø­Ø³Ø§Ø¨ ',0),(37228,1035,'tr','Hesap girdisi Ã§akÄ±ÅŸÄ±yor',0),(37229,1035,'pl','Wpis konflikty z konta',0),(37230,1035,'bg','Ð’Ð»Ð¸Ð·Ð°Ð½Ðµ Ð² ÐºÐ¾Ð½Ñ„Ð»Ð¸ÐºÑ‚ ÑÑŠÑ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(37231,1035,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù†Ø¯Ø±Ø§Ø¬ ØªÙ†Ø§Ø²Ø¹Ø§Øª',0),(37232,1035,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ°Ð³Ð»Ð°ÑˆÐµÐ½Ð¾ ÑÐ° Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(37233,1035,'vi','BÃºt ToÃ¡n khÃ´ng Ä‘á»“ng thuáº­n vá»›i TK',0),(37234,1035,'af','Inskrywing konflikte met rekening',0),(37235,1035,'ro','Intrarea Ã®n conflict cu contul',0),(37236,1035,'et','Kirje konto on vastuolus',0),(37237,1035,'si','Vstop v sporu z raÄuna',0),(37238,1035,'ba','Entri konflik dengan account',0),(37239,1035,'nl','Vermelding conflicten met account',0),(37240,1035,'fi','Kohta on ristiriidassa tili',0),(37241,1035,'no','OppfÃ¸ringen er i konflikt med konto',0),(37242,1035,'da','Posten konflikter med hensyn',0),(37243,1035,'ko','ê³„ì • í•­ëª© ì¶©ëŒ',0),(37244,1035,'he','×¢×¨×š ×ž×ª× ×’×© ×¢× ×”×—×©×‘×•×Ÿ',0),(37245,1035,'el','ÎˆÎ½Î±ÏÎ¾Î· ÏƒÏ…Î³ÎºÏÎ¿ÏÏƒÎµÏ‰Î½ Î¼Îµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(37246,1035,'zh','æ¡ç›®ä¸Žå¸æˆ·å†²çª',0),(37247,1035,'sv','Posten konflikter med hÃ¤nsyn',0),(37248,1035,'it','Conflitti di entrata con account',0),(37249,1035,'tl','',0),(37250,1035,'th','&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3605;&#3619;&#3591;&#3585;&#3633;&#3609;&#3586;&#3657;&#3634;&#3617;&#3585;&#3633;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(37251,1035,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤µà¤¿à¤°à¥‹à¤§',0),(37252,1035,'ms','Kemasukan konflik dengan akaun',0),(37253,1035,'ar','Ø§Ù„Ø¯Ø®ÙˆÙ„ ÙÙŠ ØµØ±Ø§Ø¹Ø§Øª Ù…Ø¹ Ø­Ø³Ø§Ø¨',0),(37254,1035,'fr','Conflits d\'entrÃ©e avec compte',0),(37255,1035,'jp','å…¥åŠ›ã?Œã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?«ä¸€è‡´ã?—ã?¾ã?›ã‚“',0),(37256,1035,'pt','Conflitos de entrada com conta',0),(37257,1035,'ru','ÐšÐ¾Ð½Ñ„Ð»Ð¸ÐºÑ‚Ñ‹ Ð²Ñ…Ð¾Ð´ Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÑŒÑŽ',0),(37258,1035,'es','Conflictos de entradas con la cuenta',0),(37259,1035,'de','Eintrag-Konflikt mit Konto',0),(37260,1035,'en','Entry conflicts with account',0),(37261,1036,'is','',0),(37262,1036,'dr','ØªØ§Ø±ÙŠØ® Ø«Ø¨Øª ',0),(37263,1036,'pr','ØªØ§Ø±ÙŠØ® Ø«Ø¨Øª ',0),(37264,1036,'tr','GiriÅŸ tarihi',0),(37265,1036,'pl','Data wpisu',0),(37266,1036,'bg','Ð’Ð»Ð¸Ð·Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð°',0),(37267,1036,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(37268,1036,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð°',0),(37269,1036,'vi','NgÃ y Entry',0),(37270,1036,'af','Inskrywingsdatum',0),(37271,1036,'ro','Data de intrare',0),(37272,1036,'et','Kande kuupÃ¤ev',0),(37273,1036,'si','Datum vnosa',0),(37274,1036,'ba','Tanggal entri',0),(37275,1036,'nl','Post datum',0),(37276,1036,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(37277,1036,'no','OppfÃ¸ringsdatoen',0),(37278,1036,'da','Tilmeldningsfrist',0),(37279,1036,'ko','ìž…êµ­ ë‚ ì§œ',0),(37280,1036,'he','×ª××¨×™×š ×›× ×™×¡×”',0),(37281,1036,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(37282,1036,'zh','æ¡ç›®æ—¥æœŸ',0),(37283,1036,'sv','Datumet',0),(37284,1036,'it','Data di entrata',0),(37285,1036,'tl','',0),(37286,1036,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(37287,1036,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(37288,1036,'ms','Tarikh kemasukan',0),(37289,1036,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(37290,1036,'fr','Date d\'entrÃ©e',0),(37291,1036,'jp','è¨˜å¸³æ—¥',0),(37292,1036,'pt','Data de entrada',0),(37293,1036,'ru','Ð”Ð°Ñ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(37294,1036,'es','Fecha de Entrada',0),(37295,1036,'de','Eintrag vom',0),(37296,1036,'en','Entry Date',0),(37297,1037,'is','',0),(37298,1037,'dr','Ø«Ø¨Øª Ø§Ø² ',0),(37299,1037,'pr','Ø«Ø¨Øª Ø§Ø² ',0),(37300,1037,'tr','GiriÅŸi',0),(37301,1037,'pl','Wpis z',0),(37302,1037,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð¾Ñ‚',0),(37303,1037,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø³Û’',0),(37304,1037,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð¸Ð·',0),(37305,1037,'vi','Entry tá»«',0),(37306,1037,'af','Inskrywings Vanaf',0),(37307,1037,'ro','Intrare de la',0),(37308,1037,'et','Vaadelge',0),(37309,1037,'si','Vnos iz',0),(37310,1037,'ba','Entri dari',0),(37311,1037,'nl','Ingang van',0),(37312,1037,'fi','SisÃ¤Ã¤nkÃ¤ynti',0),(37313,1037,'no','OppfÃ¸ring fra',0),(37314,1037,'da','Posten fra',0),(37315,1037,'ko','í•­ëª©ì—ì„œ',0),(37316,1037,'he','×›× ×™×¡×” ×ž×¨×—×•×‘',0),(37317,1037,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î±Ï€ÏŒ',0),(37318,1037,'zh','æ¡ç›®æ¥è‡ª',0),(37319,1037,'sv','Post frÃ¥n',0),(37320,1037,'it','Entrata da',0),(37321,1037,'tl','',0),(37322,1037,'th','&#3649;&#3610;&#3610;&#3615;&#3629;&#3619;&#3660;&#3617;&#3585;&#3634;&#3619;&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(37323,1037,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¥‡',0),(37324,1037,'ms','Kemasukan dari',0),(37325,1037,'ar','Ø¯Ø®ÙˆÙ„ Ù…Ù†',0),(37326,1037,'fr','EntrÃ©e de',0),(37327,1037,'jp','ï½žã?‹ã‚‰è¨˜å¸³',0),(37328,1037,'pt','Entrada de',0),(37329,1037,'ru','Ð’Ð²Ð¾Ð´ Ð˜Ð·',0),(37330,1037,'es','Formulario de Entrada',0),(37331,1037,'de','Eintrag aus',0),(37332,1037,'en','Entry From',0),(37333,1038,'is','',0),(37334,1038,'dr','Ø«Ø¨Øª ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(37335,1038,'pr','Ø«Ø¨Øª ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(37336,1038,'tr','GÄ°RÄ°Åž EKLEME',0),(37337,1038,'pl','WSTAWIANIE WPISU',0),(37338,1038,'bg','Ð—ÐÐŸÐ˜Ð¡ Ð—Ð Ð’ÐœÐªÐšÐ’ÐÐÐ•',0),(37339,1038,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(37340,1038,'sr','Ð£ÐœÐ•Ð¢ÐÐŠÐ• Ð¡Ð¢ÐÐ’ÐšÐ•',0),(37341,1038,'vi','ChÃ¨n Entry',0),(37342,1038,'af','INSKRYWING INVOER',0),(37343,1038,'ro','INSERARE INTRARE',0),(37344,1038,'et','KIRJE LISAMINE',0),(37345,1038,'si','VSTAVI VNOS',0),(37346,1038,'ba','MASUKKAN CATATAN',0),(37347,1038,'nl','ITEM INVOEGEN',0),(37348,1038,'fi','TAPAHTUMA LISÃ„Ã„',0),(37349,1038,'no','SETT INN OPPFÃ˜RINGEN',0),(37350,1038,'da','POSTEN INDSÃ†T',0),(37351,1038,'ko','í•­ëª© ì‚½ìž…',0),(37352,1038,'he','×”×•×¡×£ ×¢×¨×š',0),(37353,1038,'el','Î•Î™Î£Î‘Î“Î©Î“Î‰ Î•Î™Î£ÎŒÎ”ÎŸÎ¥',0),(37354,1038,'zh','å‚èµ›çš„æ’å…¥\r\n',0),(37355,1038,'sv','POSTEN INFOGA',0),(37356,1038,'it','INSERISCI VOCE',0),(37357,1038,'tl','',0),(37358,1038,'th','&#3649;&#3607;&#3619;&#3585;&#3585;&#3634;&#3619;&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(37359,1038,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(37360,1038,'ms','MASUKKAN ENTRI',0),(37361,1038,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø¥Ø¯Ø®Ø§Ù„',0),(37362,1038,'fr','ENTRÃ‰E INSERT',0),(37363,1038,'jp','å…¥åŠ›ã?®æŒ¿å…¥',0),(37364,1038,'pt','INSERIR ENTRADA',0),(37365,1038,'ru','Ð’Ð¡Ð¢ÐÐ’ÐšÐ Ð—ÐÐŸÐ˜Ð¡Ð˜',0),(37366,1038,'es','INSERCIÃ“N DE ENTRADA',0),(37367,1038,'de','EINTRAG EINFÃœGEN',0),(37368,1038,'en','ENTRY INSERT',0),(37369,1039,'is','',0),(37370,1039,'dr','Ù…Ø¬Ù‡Ø² ÙƒØ±Ø¯Ù†â€Œ',0),(37371,1039,'pr','Ù…Ø¬Ù‡Ø² ÙƒØ±Ø¯Ù†â€Œ',0),(37372,1039,'tr','Donatmak',0),(37373,1039,'pl','WyposaÅ¼yÄ‡',0),(37374,1039,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ',0),(37375,1039,'ur','Ø¢Ø±Ø§Ø³ØªÛ',0),(37376,1039,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð°ÑšÐµ',0),(37377,1039,'vi','Thiáº¿t bá»‹',0),(37378,1039,'af','Toerus',0),(37379,1039,'ro','Dota',0),(37380,1039,'et','Varustada',0),(37381,1039,'si','Opremiti',0),(37382,1039,'ba','Melengkapi',0),(37383,1039,'nl','Rusten',0),(37384,1039,'fi','Varustaa',0),(37385,1039,'no','Utstyre',0),(37386,1039,'da','Udstyre',0),(37387,1039,'ko','ìž¥ë¹„',0),(37388,1039,'he','×œ×¦×™×™×“',0),(37389,1039,'el','Î•Î¾Î¿Ï€Î»Î¯ÏƒÎµÎ¹',0),(37390,1039,'zh','è£…å¤‡',0),(37391,1039,'sv','Utrusta',0),(37392,1039,'it','Dotare',0),(37393,1039,'tl','',0),(37394,1039,'th','&#3629;&#3640;&#3611;&#3585;&#3619;&#3603;&#3660;',0),(37395,1039,'hi','à¤¸à¥‡ à¤²à¥ˆà¤¸',0),(37396,1039,'ms','Melengkapkan',0),(37397,1039,'ar','ØªØ¬Ù‡ÙŠØ²',0),(37398,1039,'fr','Ã‰quiper',0),(37399,1039,'jp','å‚™ä»˜ã?‘ã‚‹',0),(37400,1039,'pt','Equipar',0),(37401,1039,'ru','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ñ‚ÑŒ',0),(37402,1039,'es','Equipar',0),(37403,1039,'de','AusrÃ¼sten',0),(37404,1039,'en','Equip',0),(37405,1040,'is','',0),(37406,1040,'dr','Ø­Ù‚ Ù…Ø§Ù„ÙŠ',0),(37407,1040,'pr','Ø­Ù‚ Ù…Ø§Ù„ÙŠ',0),(37408,1040,'tr','Hisse senedi',0),(37409,1040,'pl','KapitaÅ‚ wÅ‚asny',0),(37410,1040,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½ ÐºÐ°Ð¿Ð¸Ñ‚Ð°Ð»',0),(37411,1040,'ur','Ù…Ø³Ø§ÙˆØ§Øª',0),(37412,1040,'sr','ÐšÐ°Ð¿Ð¸Ñ‚Ð°Ð»',0),(37413,1040,'vi','GiÃ¡ trá»‹ chá»§ sá»Ÿ há»¯u',0),(37414,1040,'af','Ekwiteit',0),(37415,1040,'ro','Capitaluri proprii',0),(37416,1040,'et','Omakapital',0),(37417,1040,'si','LastniÅ¡kega kapitala',0),(37418,1040,'ba','Ekuitas',0),(37419,1040,'nl','Eigen vermogen',0),(37420,1040,'fi','Oma pÃ¤Ã¤oma',0),(37421,1040,'no','Egenkapital',0),(37422,1040,'da','Egenkapital',0),(37423,1040,'ko','ì£¼ì‹',0),(37424,1040,'he','×”×•×Ÿ ×¢×¦×ž×™',0),(37425,1040,'el','ÎŠÎ´Î¹Î± ÎºÎµÏ†Î¬Î»Î±Î¹Î±',0),(37426,1040,'zh','äº§æƒ',0),(37427,1040,'sv','Eget kapital',0),(37428,1040,'it','Patrimonio netto',0),(37429,1040,'tl','',0),(37430,1040,'th','&#3607;&#3640;&#3609;(&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;)',0),(37431,1040,'hi','à¤‡à¤•à¥à¤µà¤¿à¤Ÿà¥€',0),(37432,1040,'ms','Ekuiti',0),(37433,1040,'ar','Ø§Ù„Ø¥Ù†ØµØ§Ù',0),(37434,1040,'fr','Capitaux propres',0),(37435,1040,'jp','æ ª',0),(37436,1040,'pt','PatrimÃ´nio lÃ­quido',0),(37437,1040,'ru','Ð¡Ð¿Ñ€Ð°Ð²ÐµÐ´Ð»Ð¸Ð²Ð¾ÑÑ‚ÑŒ',0),(37438,1040,'es','Equidad',0),(37439,1040,'de','Eigenkapital',0),(37440,1040,'en','Equity',0),(37441,1041,'is','',0),(37442,1041,'dr','Ø®Ø·Ø§ ÙŠ  ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(37443,1041,'pr','Ø®Ø·Ø§ ÙŠ  ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(37444,1041,'tr','Hata ekleme fiÅŸ haberdar etmek.',0),(37445,1041,'pl','Wstawianie zaÅ‚Ä…cznikÃ³w Informacje o bÅ‚Ä™dzie.',0),(37446,1041,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(37447,1041,'ur','Ù†Ù‚Øµ ÙˆØ§Ø¤Ú†Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(37448,1041,'sr','Ð“Ñ€ÐµÑˆÐºÐ° ÑƒÐ¼ÐµÑ‚Ð°ÑšÐµÐ¼ Ð²Ð°ÑƒÑ‡ÐµÑ€ ÑÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°Ð¼Ð°.',0),(37449,1041,'vi','Lá»—i chÃ¨n thÃ´ng tin phiáº¿u',0),(37450,1041,'af','Fout invoeging bewys info.',0),(37451,1041,'ro','Eroare inserarea voucher info.',0),(37452,1041,'et','Viga lisamine kande info.',0),(37453,1041,'si','Napaka Vstavljanje voucher info.',0),(37454,1041,'ba','Kesalahan memasukkan voucher info.',0),(37455,1041,'nl','Fout invoegen voucher info.',0),(37456,1041,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tositteen tiedot.',0),(37457,1041,'no','Feil Ã¥ sette inn kupong info.',0),(37458,1041,'da','Fejl indsÃ¦tte gavekort info.',0),(37459,1041,'ko','ì˜¤ë¥˜ ì‚½ìž… ë°”ìš°ì²˜ ì •ë³´ìž…ë‹ˆë‹¤.',0),(37460,1041,'he','×©×’×™××” ×”×•×¡×¤×ª ×¤×¨×˜×™ ×”×©×•×‘×¨.',0),(37461,1041,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚.',0),(37462,1041,'zh','æ’å…¥å‡­è¯é”™è¯¯ä¿¡æ¯ã€‚\r\n',0),(37463,1041,'sv','Fel infoga verifikationen info.',0),(37464,1041,'it','Informazioni buono inserimento di errore.',0),(37465,1041,'tl','',0),(37466,1041,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(37467,1041,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¡à¤¾à¤²à¤¨à¥‡ à¤µà¤¾à¤‰à¤šà¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€à¥¤',0),(37468,1041,'ms','Kesalahan memasukkan maklumat baucer.',0),(37469,1041,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¯Ø±Ø§Ø¬ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¥ÙŠØµØ§Ù„.',0),(37470,1041,'fr','Informations relatives au bon encartage erreur.',0),(37471,1041,'jp','ãƒ?ã‚¦ãƒ?ãƒ£ãƒ¼æƒ…å ±ã?®æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(37472,1041,'pt','Inserindo informaÃ§Ãµes de voucher erro.',0),(37473,1041,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(37474,1041,'es','Error insertando info de voucher',0),(37475,1041,'de','Fehler EinfÃ¼gen von Gutschein-Info.',0),(37476,1041,'en','Error inserting voucher info.',0),(37477,1042,'is','',0),(37478,1042,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(37479,1042,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(37480,1042,'tr','Hata alma fiÅŸi haberdar etmek.',0),(37481,1042,'pl','BÅ‚Ä…d pobierania informacji kupon.',0),(37482,1042,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(37483,1042,'ur','Ù†Ù‚Øµ ÙˆØ§Ø¤Ú†Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’ Û”',0),(37484,1042,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð²Ð°ÑƒÑ‡ÐµÑ€ ÑÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°Ð¼Ð°.',0),(37485,1042,'vi','Lá»—i truy váº¥n thÃ´ng tin phiáº¿u',0),(37486,1042,'af','Fout herwinning bewys info.',0),(37487,1042,'ro','Eroare preluare informaÅ£ii voucher.',0),(37488,1042,'et','TÃµrge allalaadimisel kande info.',0),(37489,1042,'si','Napaka pri pridobivanju voucher info.',0),(37490,1042,'ba','Kesalahan pengambilan voucher info.',0),(37491,1042,'nl','Fout ophalen voucher info.',0),(37492,1042,'fi','Virhe noudettaessa tositteen tiedot.',0),(37493,1042,'no','Hente bilag feilinformasjon.',0),(37494,1042,'da','Fejl under hentning af gavekort info.',0),(37495,1042,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ë°”ìš°ì²˜ ì •ë³´ìž…ë‹ˆë‹¤.',0),(37496,1042,'he','×©×’×™××” ×‘××—×–×•×¨ ×ž×™×“×¢ ×©×•×‘×¨.',0),(37497,1042,'el','Î‘Î½Î¬ÎºÏ„Î·ÏƒÎ· ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(37498,1042,'zh','é”™è¯¯ä¿¡æ¯æ£€ç´¢å‡­è¯ã€‚\r\n',0),(37499,1042,'sv','Fel hÃ¤mtar verifikationen info.',0),(37500,1042,'it','Informazioni buono recupero di errore.',0),(37501,1042,'tl','',0),(37502,1042,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(37503,1042,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤²à¤¾à¤¤à¥‡ à¤¸à¤®à¤¯ à¤µà¤¾à¤‰à¤šà¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€à¥¤',0),(37504,1042,'ms','Ralat mendapatkan semula maklumat baucer.',0),(37505,1042,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¥ÙŠØµØ§Ù„.',0),(37506,1042,'fr','Informations relatives au bon rÃ©cupÃ©ration erreur.',0),(37507,1042,'jp','ãƒ?ã‚¦ãƒ?ãƒ£ãƒ¼æƒ…å ±ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(37508,1042,'pt','InformaÃ§Ã£o de voucher recuperaÃ§Ã£o de erro.',0),(37509,1042,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ñ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(37510,1042,'es','Error recuperando info de voucher',0),(37511,1042,'de','Fehler beim Abrufen des Gutschein-Info.',0),(37512,1042,'en','Error retrieving voucher info.',0),(37513,1043,'is','',0),(37514,1043,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(37515,1043,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(37516,1043,'tr','FiÅŸ iÃ§in ana veritabanÄ± eklenirken bir hata oluÅŸtu.',0),(37517,1043,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania zaÅ‚Ä…cznikÃ³w do gÅ‚Ã³wnej bazy danych.',0),(37518,1043,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€ ÐºÑŠÐ¼ Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸.',0),(37519,1043,'ur','Ù†Ù‚Øµ ÙˆØ§Ø¤Ú†Ø± Ù†Û’ Ù…Ø±Ú©Ø²ÛŒ Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(37520,1043,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð²Ð°ÑƒÑ‡ÐµÑ€ ÑÐ° Ð³Ð»Ð°Ð²Ð½Ð¾Ð¼ Ð±Ð°Ð·Ð¾Ð¼ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°.',0),(37521,1043,'vi','Lá»—i thÃªm Phiáº¿u vÃ o dá»¯ liá»‡u chÃ­nh',0),(37522,1043,'af','Fout bewys belangrikste databasis by te voeg.',0),(37523,1043,'ro','Eroare la adÄƒugarea Voucher la principalele date.',0),(37524,1043,'et','Viga lisades kanne peamine andmebaasi.',0),(37525,1043,'si','Napaka pri dodajanju kupon v glavno zbirko podatkov.',0),(37526,1043,'ba','Kesalahan menambahkan Voucher ke database utama.',0),(37527,1043,'nl','Fout Voucher aan hoofddatabase toe te voegen.',0),(37528,1043,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tositteen pÃ¤Ã¤tietokantaan.',0),(37529,1043,'no','Feil under tillegging bilaget til hoveddatabasen.',0),(37530,1043,'da','Fejl ved tilfÃ¸jelse af Voucher til hoveddatabasen.',0),(37531,1043,'ko','ì£¼ ë°ì´í„°ë² ì´ìŠ¤ì— ì¿ í°ì„ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(37532,1043,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×©×•×‘×¨ ×ž×¡×“ ×”× ×ª×•× ×™× ×”×ž×¨×›×–×™.',0),(37533,1043,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹, Î¼Îµ ÎºÏÏÎ¹Î± Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½.',0),(37534,1043,'zh','é”™è¯¯æ·»åŠ åˆ°ä¸»æ•°æ®åº“åˆ¸\r\n',0),(37535,1043,'sv','Fel att lÃ¤gga till verifikationen till huvuddatabasen.',0),(37536,1043,'it','Errore durante l\'aggiunta Voucher al database principale.',0),(37537,1043,'tl','',0),(37538,1043,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3652;&#3611;&#3626;&#3641;&#3656;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3',0),(37539,1043,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥à¤–à¥à¤¯ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(37540,1043,'ms','Ralat menambah baucer ke pangkalan data utama.',0),(37541,1043,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù‚Ø³ÙŠÙ…Ø© Ø¥Ù„Ù‰ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©.',0),(37542,1043,'fr','Erreur en ajoutant le bon Ã  la base de donnÃ©es principale.',0),(37543,1043,'jp','ãƒ¡ã‚¤ãƒ³ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?¸ã?®ãƒ?ã‚¦ãƒ?ãƒ£ãƒ¼è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(37544,1043,'pt','Erro ao adicionar o Voucher para o banco de dados principal.',0),(37545,1043,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð´Ð»Ñ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ….',0),(37546,1043,'es','Error agregando voucher a la base de datos principal',0),(37547,1043,'de','Fehler beim HinzufÃ¼gen von Gutschein zur Hauptdatenbank.',0),(37548,1043,'en','Error adding Voucher to main database.',0),(37549,1044,'is','',0),(37550,1044,'dr','Ø®Ø·Ø§ â€“ Ù†Ù‚Ù„ Ø¬Ø¯ÙˆÙ„ Ù…ÙˆÙ‚Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(37551,1044,'pr','Ø®Ø·Ø§ â€“ Ù†Ù‚Ù„ Ø¬Ø¯ÙˆÙ„ Ù…ÙˆÙ‚Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(37552,1044,'tr','Ä°ÅŸlem geÃ§ici tablo bÄ±rakma baÅŸarÄ±sÄ±z oldu',0),(37553,1044,'pl','Spadek tabeli tymczasowej transakcji nie powiodÅ‚o siÄ™',0),(37554,1044,'bg','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° drop Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(37555,1044,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ø¹Ø§Ø±Ø¶ÛŒ Ø¬Ø¯ÙˆÙ„ Ù‚Ø·Ø±Û Ú©ÛŒ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§',0),(37556,1044,'sr','ÐšÐ°Ð¿ Ð¿Ñ€Ð¸Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ñ‚Ð°Ð±ÐµÐ»Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(37557,1044,'vi','Báº£ng giao dá»‹ch táº¡m thá»i tháº¥t báº¡i',0),(37558,1044,'af','Transaksie tydelike tafel daling het misluk',0),(37559,1044,'ro','TranzacÅ£ie tabel temporar scÄƒdere eÅŸuat',0),(37560,1044,'et','Tehingu ajutine tabel drop nurjus',0),(37561,1044,'si','Transakcije zaÄasno tabelo padec ni uspela',0),(37562,1044,'ba','Drop tabel sementara transaksi gagal',0),(37563,1044,'nl','Transactie daling van de tijdelijke tabel is mislukt',0),(37564,1044,'fi','Tapahtuman vÃ¤liaikaisen taulukon pudota epÃ¤onnistui',0),(37565,1044,'no','Transaksjonen midlertidig tabell slipp mislyktes',0),(37566,1044,'da','Transaktionen midlertidig tabel drop mislykkedes',0),(37567,1044,'ko','ì‹¤íŒ¨ í•œ íŠ¸ëžœìž­ì…˜ ìž„ì‹œ í…Œì´ë¸” ë“œë¡­',0),(37568,1044,'he','×¢×¡×§×ª ×©×—×¨×•×¨ ×˜×‘×œ×” ×–×ž× ×™×ª × ×›×©×œ',0),(37569,1044,'el','Î£Ï…Î½Î±Î»Î»Î±Î³ÏŽÎ½ Ï€Ï„ÏŽÏƒÎ· Ï€ÏÎ¿ÏƒÏ‰ÏÎ¹Î½Î¿Ï Ï€Î¯Î½Î±ÎºÎ± Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(37570,1044,'zh','äº‹åŠ¡ä¸´æ—¶è¡¨é™å¤±è´¥\r\n',0),(37571,1044,'sv','Transaktionen temporÃ¤r tabell drop misslyckades',0),(37572,1044,'it','Goccia di tabella temporanea di transazione non riuscita',0),(37573,1044,'tl','',0),(37574,1044,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3607;&#3636;&#3657;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;&#3594;&#3633;&#3656;&#3623;&#3588;&#3619;&#3634;&#3623;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(37575,1044,'hi','à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤…à¤¸à¥à¤¥à¤¾à¤¯à¥€ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¡à¥à¤°à¥‰à¤ª à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(37576,1044,'ms','Kejatuhan sementara Jadual transaksi yang gagal',0),(37577,1044,'ar','Ø¥Ø³Ù‚Ø§Ø· Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ù…Ø¤Ù‚Øª Ø§Ù„Ø­Ø±ÙƒØ© ÙØ´Ù„Øª',0),(37578,1044,'fr','Drop table temporaire de transaction a Ã©chouÃ©',0),(37579,1044,'jp','Transaction temporary table drop failed',0),(37580,1044,'pt','Gota de tabela temporÃ¡ria de transaÃ§Ã£o falhada',0),(37581,1044,'ru','ÐŸÐ°Ð´ÐµÐ½Ð¸Ðµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾Ð¹ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(37582,1044,'es','FallÃ³ bajar tabla temporal de la TransacciÃ³n',0),(37583,1044,'de','Transaktion temporÃ¤re Tabelle Drop fehlgeschlagen',0),(37584,1044,'en','Transaction temporary table drop failed',0),(37585,1045,'is','',0),(37586,1045,'dr','-  Ù†Ù‚Ù„ Ø¬Ø¯ÙˆÙ„ Ù…ÙˆÙ‚Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(37587,1045,'pr','Ø®Ø·Ø§-  Ù†Ù‚Ù„ Ø¬Ø¯ÙˆÙ„ Ù…ÙˆÙ‚Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(37588,1045,'tr','FiÅŸ geÃ§ici tablo bÄ±rakma baÅŸarÄ±sÄ±z oldu',0),(37589,1045,'pl','ZaÅ‚Ä…cznik tabela tymczasowa upuszczania nie powiodÅ‚o siÄ™',0),(37590,1045,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° drop Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(37591,1045,'ur','ÙˆØ§Ø¤Ú†Ø± Ø¹Ø§Ø±Ø¶ÛŒ Ø¬Ø¯ÙˆÙ„ Ù‚Ø·Ø±Û Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§',0),(37592,1045,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¿Ñ€Ð¸Ð²Ñ€ÐµÐ¼ÐµÐ½Ñƒ Ñ‚Ð°Ð±ÐµÐ»Ñƒ ÐºÐ°Ð¿ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(37593,1045,'vi','Phiáº¿u giao dá»‹ch táº¡m thá»i tháº¥t báº¡i',0),(37594,1045,'af','Bewys tydelike tafel daling het misluk',0),(37595,1045,'ro','Voucher tabel temporar scÄƒdere eÅŸuat',0),(37596,1045,'et','Kande ajutine tabel drop nurjus',0),(37597,1045,'si','Voucher zaÄasno tabelo padec ni uspela',0),(37598,1045,'ba','Voucher tabel sementara drop gagal',0),(37599,1045,'nl','Voucher voor een daling van de tijdelijke tabel is mislukt',0),(37600,1045,'fi','Tositteen vÃ¤liaikaisen taulukon pudota epÃ¤onnistui',0),(37601,1045,'no','Bilag midlertidig tabell slipp mislyktes',0),(37602,1045,'da','Voucher midlertidig tabel drop mislykkedes',0),(37603,1045,'ko','ë°”ìš°ì²˜ ìž„ì‹œ í…Œì´ë¸” ë“œë¡­ ì‹¤íŒ¨',0),(37604,1045,'he','×©×•×‘×¨ ×˜×‘×œ×” ×–×ž× ×™×ª ×˜×™×¤×” × ×›×©×œ',0),(37605,1045,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Ï€ÏÎ¿ÏƒÏ‰ÏÎ¹Î½Î¿Ï Ï€Î¯Î½Î±ÎºÎ± Ï€Ï„ÏŽÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(37606,1045,'zh','åˆ¸ä¸´æ—¶è¡¨é™å¤±è´¥\r\n',0),(37607,1045,'sv','Verifikationen temporÃ¤r tabell drop misslyckades',0),(37608,1045,'it','Goccia di tabella temporanea di voucher non riuscita',0),(37609,1045,'tl','',0),(37610,1045,'th','&#3585;&#3634;&#3619;&#3607;&#3636;&#3657;&#3591;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3594;&#3633;&#3656;&#3623;&#3588;&#3619;&#3634;&#3623;&#3651;&#3609;&#3605;&#3634;&#3619;&#3634;&#3591;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(37611,1045,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤…à¤¸à¥à¤¥à¤¾à¤¯à¥€ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¡à¥à¤°à¥‰à¤ª à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(37612,1045,'ms','Penurunan Jadual sementara baucer yang gagal',0),(37613,1045,'ar','Ø¥Ø³Ù‚Ø§Ø· Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ù…Ø¤Ù‚Øª Ø§Ù„Ø¥ÙŠØµØ§Ù„ ÙØ´Ù„',0),(37614,1045,'fr','Drop table temporaire de bon a Ã©chouÃ©',0),(37615,1045,'jp','Voucher temporary table drop failed',0),(37616,1045,'pt','Gota de tabela temporÃ¡ria de voucher falhada',0),(37617,1045,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾Ð¹ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(37618,1045,'es','FallÃ³ bajar tabla temporal del voucher',0),(37619,1045,'de','Gutschein temporÃ¤re Tabelle Drop fehlgeschlagen',0),(37620,1045,'en','Voucher temporary table drop failed',0),(37621,1046,'is','',0),(37622,1046,'dr','Ù†Ø§Ù… Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª â€“ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(37623,1046,'pr','Ù†Ø§Ù… Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª â€“ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(37624,1046,'tr','FiÅŸi adÄ± geÃ§ersiz.  Yeniden Deneyin.',0),(37625,1046,'pl','NieprawidÅ‚owa nazwa zaÅ‚Ä…cznika.  PrÃ³buj ponownie.',0),(37626,1046,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¾ Ð¸Ð¼Ðµ Ð½Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€.  ÐžÐ¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾.',0),(37627,1046,'ur','ÙˆØ§Ø¤Ú†Ø± Ù†Ø§Ù… Ù†Ø§Ø¬Ø§Ø¦Ø² ÛÛ’ Û”  Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ Ú©Ø±Ùˆ.',0),(37628,1046,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¸Ð¼Ðµ Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð¸.  Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜ Ð¿Ð¾Ð½Ð¾Ð²Ð¾.',0),(37629,1046,'vi','TÃªn phiáº¿u vÃ´ hiá»‡u. Thá»­ láº¡i 1 láº§n ná»¯a',0),(37630,1046,'af','Bewys naam ongeldig.  Probeer weer.',0),(37631,1046,'ro','Voucher nume nevalid.  Ã®ncearcÄƒ din nou.',0),(37632,1046,'et','Kande nimi ei sobi.  Proovi uuesti.',0),(37633,1046,'si','Voucher ime neveljavno.  poskusi znova.',0),(37634,1046,'ba','Nama voucher tidak valid.  Coba lagi.',0),(37635,1046,'nl','De naam van de waardebon ongeldig.  &Opnieuw.',0),(37636,1046,'fi','Tositteen nimi ei kelpaa.  YritÃ¤ uudestaan.',0),(37637,1046,'no','Bilag-navnet er ugyldig.  prÃ¸v igjen.',0),(37638,1046,'da','Voucher navn ugyldige.  PrÃ¸v igen.',0),(37639,1046,'ko','ë°”ìš°ì²˜ ì´ë¦„ ìž˜ëª» ë˜ì—ˆìŠµë‹ˆë‹¤.  ë‹¤ì‹œ ì‹œë„.',0),(37640,1046,'he','×©×•×‘×¨ ×©× ×œ× ×—×•×§×™.  × ×¡×” ×©×•×‘.',0),(37641,1046,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ ÏŒÎ½Î¿Î¼Î± Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ¿.  Î”Î¿ÎºÎ¯Î¼Î±ÏƒÎµ Î¾Î±Î½Î¬.',0),(37642,1046,'zh','å‡­è¯åç§°æ— æ•ˆã€‚å†è¯•ä¸€æ¬¡ã€‚\r\n',0),(37643,1046,'sv','Verifikationen namn Ã¤r ogiltigt.  FÃ¶rsÃ¶k igen.',0),(37644,1046,'it','Nome buono non valido.  Riprova.',0),(37645,1046,'tl','',0),(37646,1046,'th','&#3594;&#3639;&#3656;&#3629;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3592;&#3656;&#3634;&#3618;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591; &#3621;&#3629;&#3591;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(37647,1046,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¨à¤¾à¤® à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤¹à¥ˆà¥¤  à¤«à¤¿à¤° à¤•à¥‹à¤¶à¤¿à¤¶ à¤•à¤°à¥‹.',0),(37648,1046,'ms','Nama baucer tidak sah.  cuba lagi.',0),(37649,1046,'ar','Ø§Ù„Ø¥ÙŠØµØ§Ù„ Ø§Ø³Ù… ØºÙŠØ± ØµØ§Ù„Ø­.  Ø­Ø§ÙˆÙ„ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰.',0),(37650,1046,'fr','Nom de coupon non valide.  RÃ©essayez.',0),(37651,1046,'jp','ä¼?ç¥¨å??ã?Œç„¡åŠ¹ã?§ã?™ã€‚å†?åº¦å®Ÿè¡Œã?—ã?¦ã??ã? ã?•ã?„',0),(37652,1046,'pt','Nome de cupom invÃ¡lido.  Tentar novamente.',0),(37653,1046,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð¾Ðµ Ð¸Ð¼Ñ Ð²Ð°ÑƒÑ‡ÐµÑ€.  ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð¸Ñ‚ÑŒ.',0),(37654,1046,'es','Nombre de voucher invalido - Intenta otra vez',0),(37655,1046,'de','Gutschein-Name ist ungÃ¼ltig.  Wiederholen.',0),(37656,1046,'en','Voucher name invalid.  Try again.',0),(37657,1047,'is','',0),(37658,1047,'dr','Ø®Ø·Ø§ ',0),(37659,1047,'pr','Ø®Ø·Ø§ ',0),(37660,1047,'tr','Hata',0),(37661,1047,'pl','BÅ‚Ä…d',0),(37662,1047,'bg','Ð“Ñ€ÐµÑˆÐºÐ°',0),(37663,1047,'ur','Ù†Ù‚Øµ',0),(37664,1047,'sr','Ð“Ñ€ÐµÑˆÐºÐ°',0),(37665,1047,'vi','Lá»—i',0),(37666,1047,'af','Fout',0),(37667,1047,'ro','Eroare',0),(37668,1047,'et','TÃµrge',0),(37669,1047,'si','Napaka',0),(37670,1047,'ba','Kesalahan',0),(37671,1047,'nl','Fout',0),(37672,1047,'fi','Virhe',0),(37673,1047,'no','Feil',0),(37674,1047,'da','Fejl',0),(37675,1047,'ko','ì˜¤ë¥˜',0),(37676,1047,'he','×©×’×™××”',0),(37677,1047,'el','Î£Ï†Î¬Î»Î¼Î±',0),(37678,1047,'zh','é”™è¯¯',0),(37679,1047,'sv','Fel',0),(37680,1047,'it','Errore',0),(37681,1047,'tl','',0),(37682,1047,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(37683,1047,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(37684,1047,'ms','Ralat',0),(37685,1047,'ar','Ø®Ø·Ø£',0),(37686,1047,'fr','Erreur',0),(37687,1047,'jp','ã‚¨ãƒ©ãƒ¼',0),(37688,1047,'pt','Erro',0),(37689,1047,'ru','ÐžÑˆÐ¸Ð±ÐºÐ°',0),(37690,1047,'es','Error',0),(37691,1047,'de','Fehler',0),(37692,1047,'en','Error',0),(37693,1048,'is','',0),(37694,1048,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ ',0),(37695,1048,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ ',0),(37696,1048,'tr','Hesap ekleme hatasÄ±',0),(37697,1048,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania konta',0),(37698,1048,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(37699,1048,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø¶Ø§ÙÛ Ú©Ø±ØªØ§ ÛÙˆØ§ Ù†Ù‚Øµ',0),(37700,1048,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(37701,1048,'vi','ThÃªm TK Bá»‹ Lá»—i',0),(37702,1048,'af','Fout met die Byvoeging van Rekening',0),(37703,1048,'ro','Eroare la adÄƒugarea cont',0),(37704,1048,'et','Viga lisades konto',0),(37705,1048,'si','Napaka pri dodajanju raÄuna',0),(37706,1048,'ba','Kesalahan menambahkan akun',0),(37707,1048,'nl','Fout account toe te voegen',0),(37708,1048,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tiliÃ¤',0),(37709,1048,'no','Feil under tillegging av konto',0),(37710,1048,'da','Fejl ved tilfÃ¸jelse af konto',0),(37711,1048,'ko','ê³„ì •ì„ ì¶”ê°€ í•˜ëŠ” ì˜¤ë¥˜',0),(37712,1048,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×—×©×‘×•× ×•×ª',0),(37713,1048,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(37714,1048,'zh','é”™è¯¯ï¼šæ–°å¢žå¸æˆ·',0),(37715,1048,'sv','Fel att lÃ¤gga till konto',0),(37716,1048,'it','Errore di aggiunta di account',0),(37717,1048,'tl','',0),(37718,1048,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(37719,1048,'hi','à¤–à¤¾à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(37720,1048,'ms','Ralat menambah akaun',0),(37721,1048,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨',0),(37722,1048,'fr','Erreur en ajoutant le compte',0),(37723,1048,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(37724,1048,'pt','Erro ao adicionar conta',0),(37725,1048,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ñ€Ð¾Ñ„Ð¸Ð»Ñ',0),(37726,1048,'es','Error agregando un Cuenta',0),(37727,1048,'de','Fehler beim HinzufÃ¼gen des Kontos',0),(37728,1048,'en','Error adding account',0),(37729,1049,'is','',0),(37730,1049,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ â€“ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ ØªÙƒØ±Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(37731,1049,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ â€“ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ ØªÙƒØ±Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(37732,1049,'tr','Hata ekleyerek hesap - yinelenen hesap numarasÄ± yok',0),(37733,1049,'pl','BÅ‚Ä…d dodawania konto - numer konta zduplikowane istnieje',0),(37734,1049,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ - Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ð½Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(37735,1049,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ - Ù…Ø«Ù†ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Û”',0),(37736,1049,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ€Ð°Ñ‡ÑƒÐ½ - Ð±Ñ€Ð¾Ñ˜ Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(37737,1049,'vi','ThÃªm TK Bá»‹ Lá»—i - Sá»‘ TK TrÃ¹ng',0),(37738,1049,'af','Fout met die byvoeging van rekening - dieselfde rekening nommer bestaan',0),(37739,1049,'ro','ExistÄƒ numÄƒrul de duplicat cont eroare adÄƒugarea cont-',0),(37740,1049,'et','Viga lisades konto - duplikaat konto number olemas',0),(37741,1049,'si','Napaka pri dodajanju raÄuna - podvojen raÄun Å¡tevilka obstaja',0),(37742,1049,'ba','Kesalahan menambahkan account - nomor rekening duplikat ada',0),(37743,1049,'nl','Fout toevoegen account - dubbele rekeningnummer bestaat',0),(37744,1049,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tiliÃ¤ - sama tili on olemassa',0),(37745,1049,'no','Feil Ã¥ legge til konto - like kontonummeret finnes',0),(37746,1049,'da','TilfÃ¸je fejlkontoen - dublerede kontonummer findes',0),(37747,1049,'ko','ì¶”ê°€ ê³„ì • ì˜¤ë¥˜-ì¤‘ë³µ ê³„ì • ë²ˆí˜¸ ì¡´ìž¬',0),(37748,1049,'he','×§×™×™× ×—×©×‘×•×Ÿ ×›×¤×•×œ ×ž×¡×¤×¨ ×©×’×™××” ×”×•×¡×¤×ª ×—×©×‘×•×Ÿ-',0),(37749,1049,'el','Î£Ï†Î¬Î»Î¼Î± Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï - Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´Î¹Ï€Î»ÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹',0),(37750,1049,'zh','é”™è¯¯æ·»åŠ è´¦æˆ· -è´¦æˆ·å·ç å­˜åœ¨é‡å¤',0),(37751,1049,'sv','Fel att lÃ¤gga till konto - dubbla kontonummer finns',0),(37752,1049,'it','Errore aggiungendo account - account duplicato numero esiste',0),(37753,1049,'tl','',0),(37754,1049,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637; &#3648;&#3621;&#3586;&#3607;&#3637;&#3610;&#3633;&#3597;&#3594;&#3637;&#3595;&#3657;&#3635;',0),(37755,1049,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤–à¤¾à¤¤à¥‡ - à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(37756,1049,'ms','Ralat menambah akaun - akaun pendua nombor wujud',0),(37757,1049,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨-Ø±Ù‚Ù… Ø­Ø³Ø§Ø¨ Ù…ÙƒØ±Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(37758,1049,'fr','Erreur ajout compte - numÃ©ro de compte en double existe',0),(37759,1049,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼/å?Œã?˜ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå?·ã?Œå­˜åœ¨ã?—ã?¾ã?™',0),(37760,1049,'pt','Erro adicionando conta - nÃºmero da conta duplicada existe',0),(37761,1049,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð° - Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð´ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ‚ ÑÑ‡ÐµÑ‚Ð° Ð½Ð¾Ð¼ÐµÑ€',0),(37762,1049,'es','Error agregando una cuenta - nÃºmero de cuenta duplicado existe',0),(37763,1049,'de','Es gibt Fehler hinzufÃ¼gen Konto - doppelte Kontonummer',0),(37764,1049,'en','Error adding account - duplicate account number exists',0),(37765,1050,'is','',0),(37766,1050,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ â€“ Ø´Ø±Ø­ Ø­Ø³Ø§Ø¨ ØªÙƒØ±Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(37767,1050,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ â€“ Ø´Ø±Ø­ Ø­Ø³Ø§Ø¨ ØªÙƒØ±Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(37768,1050,'tr','Hata ekleyerek hesap - yinelenen hesap aÃ§Ä±klama var',0),(37769,1050,'pl','BÅ‚Ä…d dodawania konta - opis konto istnieje',0),(37770,1050,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ - ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ð½ ÑÐ¼ÐµÑ‚ÐºÐ° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(37771,1050,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ - Ù…Ø«Ù†ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªØµØ±ÛŒØ­ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(37772,1050,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ€Ð°Ñ‡ÑƒÐ½ - Ð¾Ð¿Ð¸Ñ Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(37773,1050,'vi','ThÃªm TK Bá»‹ Lá»—i - Diá»…n Giáº£i TK TrÃ¹ng',0),(37774,1050,'af','Fout voeg rekening - duplikaat rekening Beskrywing bestaan',0),(37775,1050,'ro','ExistÄƒ eroare adÄƒugarea cont - cont de duplicat Descriere',0),(37776,1050,'et','Viga lisades konto - duplikaat konto kirjeldus olemas',0),(37777,1050,'si','Napaka pri dodajanju raÄuna - obstaja opis podvojen raÄun',0),(37778,1050,'ba','Kesalahan menambahkan rekening - rekening duplikat ada',0),(37779,1050,'nl','Fout toevoegen account - dubbele accountbeschrijving bestaat',0),(37780,1050,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tiliÃ¤ - sama tili kuvaus olemassa',0),(37781,1050,'no','Feil Ã¥ legge til konto - lik konto beskrivelse finnes',0),(37782,1050,'da','TilfÃ¸je fejlkontoen - dublerede kontobeskrivelse findes',0),(37783,1050,'ko','ì¡´ìž¬ í•˜ëŠ” ì˜¤ë¥˜ ì¶”ê°€ ê³„ì •-ì¤‘ë³µ ê³„ì • ì„¤ëª…',0),(37784,1050,'he','×§×™×™× ×—×©×‘×•×Ÿ ×›×¤×•×œ ×ª×™××•×¨ ×©×’×™××” ×”×•×¡×¤×ª ×—×©×‘×•×Ÿ-',0),(37785,1050,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î´Î¹Ï€Î»ÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚ Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï-',0),(37786,1050,'zh','é”™è¯¯ï¼šæ–°å¢žå¸æˆ· -å¸æˆ·è¯´æ˜Žå­˜åœ¨é‡å¤',0),(37787,1050,'sv','Fel att lÃ¤gga till konto - dubblettkonto beskrivning finns',0),(37788,1050,'it','Errore aggiungendo account - account duplicato Descrizione esiste',0),(37789,1050,'tl','',0),(37790,1050,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637; &#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;&#3595;&#',0),(37791,1050,'hi','à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤–à¤¾à¤¤à¤¾ à¤µà¤¿à¤µà¤°à¤£ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤–à¤¾à¤¤à¥‡ - à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(37792,1050,'ms','Ralat menambah akaun - akaun berganda keterangan wujud',0),(37793,1050,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨-ÙˆØµÙ Ø­Ø³Ø§Ø¨ Ù…ÙƒØ±Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(37794,1050,'fr','Erreur ajout compte - compte dupliquÃ© description existe',0),(37795,1050,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼/å?Œã?˜ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?Œå­˜åœ¨ã?—ã?¾ã?™',0),(37796,1050,'pt','Adicionando conta de erro - descriÃ§Ã£o de conta duplicada existe',0),(37797,1050,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ - Ð´ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ‚Ñ‹ ÑÑ‡ÐµÑ‚Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(37798,1050,'es','Error agregando una cuenta - descripciÃ³n duplicada de cuenta existe',0),(37799,1050,'de','Gibt Fehler hinzufÃ¼gen Konto - doppeltes Kontobeschreibung',0),(37800,1050,'en','Error adding account - duplicate account description exists',0),(37801,1051,'is','',0),(37802,1051,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ ',0),(37803,1051,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ ',0),(37804,1051,'tr','Hata ekleme hesap tÃ¼rÃ¼',0),(37805,1051,'pl','BÅ‚Ä…d dodawania konta typu',0),(37806,1051,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ñ‚Ð¸Ð¿ Ð³Ñ€ÐµÑˆÐºÐ°',0),(37807,1051,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(37808,1051,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(37809,1051,'vi','ThÃªm Loáº¡i TK Bá»‹ Lá»—i',0),(37810,1051,'af','Fout voeg rekeningtipe',0),(37811,1051,'ro','Eroare adÄƒugarea tip cont',0),(37812,1051,'et','Viga lisades kontotÃ¼Ã¼p',0),(37813,1051,'si','Dodajanje raÄuna vrsta napake',0),(37814,1051,'ba','Jenis account menambahkan kesalahan',0),(37815,1051,'nl','Fout Rekeningsoort toe te voegen',0),(37816,1051,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tilityyppi',0),(37817,1051,'no','Feil Ã¥ legge kontotype',0),(37818,1051,'da','Fejl tilfÃ¸je kontotype',0),(37819,1051,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê³„ì • ìœ í˜•',0),(37820,1051,'he','×¡×•×’ ×—×©×‘×•×Ÿ ×”×•×¡×¤×ª ×”×©×’×™××”',0),(37821,1051,'el','Î£Ï†Î¬Î»Î¼Î± Ï„ÏÏ€Î¿Ï… Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(37822,1051,'zh','é”™è¯¯ï¼šæ–°å¢žå¸æˆ·ç±»åž‹',0),(37823,1051,'sv','Fel att lÃ¤gga kontotyp',0),(37824,1051,'it','Tipo di account aggiungendo errore',0),(37825,1051,'tl','',0),(37826,1051,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(37827,1051,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(37828,1051,'ms','Ralat menambah akaun jenis',0),(37829,1051,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(37830,1051,'fr','Erreur ajout type de compte',0),(37831,1051,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(37832,1051,'pt','Tipo de conta erro adicionando',0),(37833,1051,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ñ‚Ð¸Ð¿ Ð¾ÑˆÐ¸Ð±ÐºÐ¸',0),(37834,1051,'es','Error agregando tipo de cuenta',0),(37835,1051,'de','Fehlertyp hinzufÃ¼gen Konto',0),(37836,1051,'en','Error adding account type',0),(37837,1052,'is','',0),(37838,1052,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(37839,1052,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(37840,1052,'tr','Hata ekleme bill',0),(37841,1052,'pl','Dodawanie rachunku bÅ‚Ä™dÃ³w',0),(37842,1052,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð±Ð¸Ð»',0),(37843,1052,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø¨Ù„',0),(37844,1052,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð‘Ð¸Ð»',0),(37845,1052,'vi','ThÃªm hÃ³a Ä‘Æ¡n bá»‹ lá»—i',0),(37846,1052,'af','Fout voeg Wetsontwerp',0),(37847,1052,'ro','Eroare adÄƒugarea de lege',0),(37848,1052,'et','Viga lisades seaduseelnÃµu',0),(37849,1052,'si','Napaka pri dodajanju bill',0),(37850,1052,'ba','Bill menambahkan kesalahan',0),(37851,1052,'nl','Fout toe te voegen bill',0),(37852,1052,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ bill',0),(37853,1052,'no','Feil Ã¥ legge bill',0),(37854,1052,'da','Fejl tilfÃ¸je bill',0),(37855,1052,'ko','ì˜¤ë¥˜ ì¶”ê°€ ë¹Œ',0),(37856,1052,'he','×‘×™×œ ×”×•×¡×¤×ª ×”×©×’×™××”',0),(37857,1052,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ ÏƒÏ†Î¬Î»Î¼Î±',0),(37858,1052,'zh','é”™è¯¯æ·»åŠ å¸å•',0),(37859,1052,'sv','Fel att lÃ¤gga till bill',0),(37860,1052,'it','Bill aggiungendo errore',0),(37861,1052,'tl','',0),(37862,1052,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3636;&#3621;',0),(37863,1052,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤µà¤¿à¤§à¥‡à¤¯à¤•',0),(37864,1052,'ms','Rang undang-undang menambah ralat',0),(37865,1052,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(37866,1052,'fr','Projet de loi ajoutant erreur',0),(37867,1052,'jp','è«‹æ±‚æ›¸ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(37868,1052,'pt','Adicionando conta de erro',0),(37869,1052,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð‘Ð¸Ð»Ð»',0),(37870,1052,'es','Error agregando recibo',0),(37871,1052,'de','Fehler HinzufÃ¼gen von bill',0),(37872,1052,'en','Error adding bill',0),(37873,1053,'is','',0),(37874,1053,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø±Ø¦ÙŠØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(37875,1053,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø±Ø¦ÙŠØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(37876,1053,'tr','Hata ekleme fatura ayrÄ±ntÄ±sÄ±',0),(37877,1053,'pl','BÅ‚Ä…d dodawania szczegÃ³Å‚Ã³w ustawy',0),(37878,1053,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° Ð´ÐµÑ‚Ð°Ð¹Ð»',0),(37879,1053,'ur','Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ù„ ØªÙØµÛŒÙ„ Ù†Ù‚Øµ',0),(37880,1053,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð‘Ð¸Ð» Ð´ÐµÑ‚Ð°Ñ™',0),(37881,1053,'vi','ThÃªm hÃ³a Ä‘Æ¡n chi tiáº¿t bá»‹ lá»—i',0),(37882,1053,'af','Fout voeg Wetsontwerp detail',0),(37883,1053,'ro','Eroare adÄƒugarea bill detaliu',0),(37884,1053,'et','Viga lisades seaduseelnÃµu Ã¼ksikasjalikult',0),(37885,1053,'si','Napaka dodajanje zakona podrobno',0),(37886,1053,'ba','Detail tagihan menambahkan kesalahan',0),(37887,1053,'nl','Fout toe te voegen bill detail',0),(37888,1053,'fi','LisÃ¤Ã¤mÃ¤llÃ¤ bill virheestÃ¤',0),(37889,1053,'no','Legge til bill feildetaljer',0),(37890,1053,'da','Fejl tilfÃ¸je bill detaljer',0),(37891,1053,'ko','ì˜¤ë¥˜ ì¶”ê°€ ë²•ì•ˆ ì„¸ë¶€ ì‚¬í•­',0),(37892,1053,'he','×©×’×™××” ×‘×™×œ ×”×•×¡×¤×ª ×¤×™×¨×•×˜',0),(37893,1053,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(37894,1053,'zh','é”™è¯¯æ·»åŠ å¸å•ç»†èŠ‚',0),(37895,1053,'sv','Fel att lÃ¤gga till bill detalj',0),(37896,1053,'it','Dettaglio fattura aggiunta di errore',0),(37897,1053,'tl','',0),(37898,1053,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3610;&#3636;&#3621;',0),(37899,1053,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤¬à¤¿à¤² à¤µà¤¿à¤µà¤°à¤£',0),(37900,1053,'ms','Ralat menambah bil terperinci',0),(37901,1053,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(37902,1053,'fr','DÃ©tail de facture ajout erreur',0),(37903,1053,'jp','è«‹æ±‚æ›¸è©³ç´°ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(37904,1053,'pt','Detalhe de bill erro adicionando',0),(37905,1053,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð‘Ð¸Ð»Ð» Ð´ÐµÑ‚Ð°Ð»ÑŒ',0),(37906,1053,'es','Error agregando detalle de recibo',0),(37907,1053,'de','HinzufÃ¼gen von Bill Fehlerdetails.',0),(37908,1053,'en','Error adding bill detail',0),(37909,1054,'is','',0),(37910,1054,'dr','- Ù„ØºÙˆ Ø«Ø¨Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(37911,1054,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø±Ø¦ÙŠØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨- Ù„ØºÙˆ Ø«Ø¨Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(37912,1054,'tr','Fatura ayrÄ±ntÄ±larÄ± - fatura giriÅŸi iptal ekleme hatasÄ±',0),(37913,1054,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania szczegÃ³Å‚y rachunku - anulowania wejÅ›cia ustawy',0),(37914,1054,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ - Ð±Ð¸Ð» ÐžÐ¢ÐœÐ•ÐÐ•Ð Ð·Ð°Ð¿Ð¸Ñ',0),(37915,1054,'ur','Ø¨Ù„ - Ø¨Ù„ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(37916,1054,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð‘Ð¸Ð» Ð´ÐµÑ‚Ð°Ñ™Ð¸ - Ð‘Ð¸Ð» ÑÑ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð°',0),(37917,1054,'vi','ThÃªm hÃ³a Ä‘Æ¡n chi tiáº¿t bá»‹ lá»—i - HÃ³a ÄÆ¡n Nháº­p vÃ o sáº½ bá»‹ há»§y',0),(37918,1054,'af','Fout voeg Wetsontwerp besonderhede - Wetsontwerp inskrywing GEKANSELLEER',0),(37919,1054,'ro','Eroare la adÄƒugarea detalii bill - BILL intrare anulate',0),(37920,1054,'et','Viga lisades seaduseelnÃµu Ã¼ksikasjad - arve KANDE tÃ¼histatud',0),(37921,1054,'si','Napaka pri dodajanju bill podrobnosti - BILL vnos ODPOVEDAN',0),(37922,1054,'ba','Kesalahan menambahkan rincian tagihan - tagihan masuk dibatalkan',0),(37923,1054,'nl','Fout toe te voegen bill details - BILL post geannuleerd',0),(37924,1054,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ bill details - BILL tapahtuma peruutetaan',0),(37925,1054,'no','Feil under tillegging av bill detaljer - BILL oppfÃ¸ring avbrutt',0),(37926,1054,'da','Fejl ved tilfÃ¸jelse af bill detaljer - BILL post aflyst',0),(37927,1054,'ko','ë²•ì•ˆ ë‚´ìš©ì„-ë¹Œ í•­ëª© ì·¨ì†Œ ì¶”ê°€ ì˜¤ë¥˜',0),(37928,1054,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×¤×¨×˜×™× ×‘×™×œ - ×‘×™×œ ×‘×™×˜×œ ×›× ×™×¡×”',0),(37929,1054,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ - BILL ÎµÎ³Î³ÏÎ±Ï†Î® Î‘ÎšÎ¥Î¡ÎÎ˜Î—ÎšÎ•',0),(37930,1054,'zh','é”™è¯¯æ·»åŠ å¸å•ç»†èŠ‚-å¸å•æ¡ç›®è¢«å–æ¶ˆ',0),(37931,1054,'sv','Fel att lÃ¤gga till bill Detaljer - BILL transaktionen AVBRÃ–TS',0),(37932,1054,'it','Errore aggiungendo dettagli bill - BILL voce cancellata',0),(37933,1054,'tl','',0),(37934,1054,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3610;&#3636;&#3621; - &#3585;&#3634;&#3619;&#3609;&#3635;&#3610;',0),(37935,1054,'hi','à¤¬à¤¿à¤² à¤µà¤¿à¤µà¤°à¤£ - à¤¬à¤¿à¤² à¤°à¤¦à¥à¤¦ à¤•à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(37936,1054,'ms','Ralat menambah butiran bil - bil penyertaan dibatalkan',0),(37937,1054,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ø§Ù„ÙØ§ØªÙˆØ±Ø©-\"Ø£Ù„ØºÙ‰ Ù‚Ø§Ù†ÙˆÙ† Ø¯Ø®ÙˆÙ„\"',0),(37938,1054,'fr','Erreur en ajoutant des dÃ©tails du projet de loi - BILL entrÃ©e annulÃ©',0),(37939,1054,'jp','è«‹æ±‚æ›¸è©³ç´°è¿½åŠ ã‚¨ãƒ©ãƒ¼ãƒ»è«‹æ±‚æ›¸è¨˜å¸³ã?Œã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(37940,1054,'pt','Erro ao adicionar detalhes de bill - BILL entrada cancelado',0),(37941,1054,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð‘Ð¸Ð»Ð» Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ - Ð‘Ð¸Ð»Ð» Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(37942,1054,'es','Error agregando detalles de recibo - ENTRADA DE RECIBO CANCELADA',0),(37943,1054,'de','Fehler beim HinzufÃ¼gen von Bill Details - BILL Eintrag abgesagt',0),(37944,1054,'en','Error adding bill details - BILL ENTRY CANCELLED',0),(37945,1055,'is','',0),(37946,1055,'dr','( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª ',0),(37947,1055,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ØªØ§Ø¨Ø¹ ( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª ',0),(37948,1055,'tr','Hata ekleme birleÅŸtirme iÅŸlevi.',0),(37949,1055,'pl','Dodanie funkcji bÅ‚Ä™du bazy danych bindery.',0),(37950,1055,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ.',0),(37951,1055,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ ÛÛ’ Û”',0),(37952,1055,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð±Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°.',0),(37953,1055,'vi','ThÃªm chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch bá»‹ lá»—i',0),(37954,1055,'af','Fout voeg bindery funksie.',0),(37955,1055,'ro','AdÄƒugarea de legatorie eroare funcÅ£ia.',0),(37956,1055,'et','Viga lisades Kirjansitomo funktsiooni.',0),(37957,1055,'si','Dodajanje Knjigoveznica funkcijo napake.',0),(37958,1055,'ba','Kesalahan menambahkan bindery fungsi.',0),(37959,1055,'nl','Fout toe te voegen bindery functie.',0),(37960,1055,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ bindery-toimintoa.',0),(37961,1055,'no','Feil Ã¥ legge bindery-funksjonen.',0),(37962,1055,'da','Fejl tilfÃ¸je bindery funktion.',0),(37963,1055,'ko','ì˜¤ë¥˜ ì¶”ê°€ ë°”ì¸ë”ë¦¬ ê¸°ëŠ¥.',0),(37964,1055,'he','×¤×•× ×§×¦×™×™×ª bindery ×”×•×¡×¤×ª ×”×©×’×™××”.',0),(37965,1055,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· bindery ÏƒÏ…Î½Î¬ÏÏ„Î·ÏƒÎ· ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(37966,1055,'zh','é”™è¯¯æ·»åŠ è£…è®¢åŠŸèƒ½',0),(37967,1055,'sv','Fel att lÃ¤gga till bindery funktion.',0),(37968,1055,'it','Errore aggiunta funzione della legatoria.',0),(37969,1055,'tl','',0),(37970,1055,'th','Error adding bindery function.',0),(37971,1055,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹à¥¤',0),(37972,1055,'ms','Ralat menambah fungsi bindery.',0),(37973,1055,'ar','Ø¥Ø¶Ø§ÙØ© Ø¯Ø§Ù„Ø© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø®Ø·Ø£.',0),(37974,1055,'fr','Ajout fonction erreur de faÃ§onnage.',0),(37975,1055,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(37976,1055,'pt','Adicionando funÃ§Ã£o de bindery erro.',0),(37977,1055,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ.',0),(37978,1055,'es','Error agregando funciÃ³n de encuadernaciÃ³n',0),(37979,1055,'de','HinzufÃ¼gen von Buchbinderei Fehlerfunktion.',0),(37980,1055,'en','Error adding bindery function.',0),(37981,1056,'is','',0),(37982,1056,'dr','( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(37983,1056,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ ØªØ§Ø¨Ø¹ ( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(37984,1056,'tr','Hata ekleme birleÅŸtirme iÅŸlevi boyutu.',0),(37985,1056,'pl','BÅ‚Ä…d dodawania introligatornia funkcja rozmiar.',0),(37986,1056,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(37987,1056,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ø³Ø§Ø¦Ø² Û”',0),(37988,1056,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð±Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ.',0),(37989,1056,'vi','ThÃªm cá»¡ chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch bá»‹ lá»—i',0),(37990,1056,'af','Fout voeg bindery funksie grootte.',0),(37991,1056,'ro','Eroare adÄƒugarea legatorie funcÅ£ia dimensiunea.',0),(37992,1056,'et','Viga lisades Kirjansitomo funktsiooni suurus.',0),(37993,1056,'si','Napaka dodajanje Knjigoveznica funkcijo velikosti.',0),(37994,1056,'ba','Kesalahan menambahkan bindery fungsi ukuran.',0),(37995,1056,'nl','Fout toe te voegen bindery functie grootte.',0),(37996,1056,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ bindery tehtÃ¤vÃ¤ koko.',0),(37997,1056,'no','Feil Ã¥ legge bindery funksjon stÃ¸rrelsen.',0),(37998,1056,'da','Fejl tilfÃ¸je bindery funktion stÃ¸rrelse.',0),(37999,1056,'ko','ì˜¤ë¥˜ ì¶”ê°€ ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ í¬ê¸°.',0),(38000,1056,'he','×”×•×¡×¤×ª ×©×’×™××” ×ž×¡×•×’ bindery ×¤×•× ×§×¦×™×” ×’×•×“×œ.',0),(38001,1056,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· bindery ÏƒÏ†Î¬Î»Î¼Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚.',0),(38002,1056,'zh','é”™è¯¯æ·»åŠ è£…è®¢åŠŸèƒ½çš„å¤§å°ã€‚\r\n',0),(38003,1056,'sv','Fel att lÃ¤gga till bindery funktion storlek.',0),(38004,1056,'it','Dimensione di funzione della legatoria aggiungendo errore.',0),(38005,1056,'tl','',0),(38006,1056,'th','Error adding bindery function size.',0),(38007,1056,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤†à¤•à¤¾à¤°à¥¤',0),(38008,1056,'ms','Ralat menambah bindery fungsi saiz.',0),(38009,1056,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø­Ø¬Ù… ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(38010,1056,'fr','Erreur ajout faÃ§onnage fonction taille.',0),(38011,1056,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚µã‚¤ã‚ºã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38012,1056,'pt','Tamanho adiÃ§Ã£o da funÃ§Ã£o bindery de erro.',0),(38013,1056,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(38014,1056,'es','Error agregando el tamaÃ±o de la funciÃ³n de encuadernaciÃ³n',0),(38015,1056,'de','Fehler hinzufÃ¼gen Buchbinderei Funktion GrÃ¶ÃŸe.',0),(38016,1056,'en','Error adding bindery function size.',0),(38017,1057,'is','',0),(38018,1057,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ú¯Ø²ÙŠÙ†Ù‡ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(38019,1057,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ú¯Ø²ÙŠÙ†Ù‡ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(38020,1057,'tr','BaÄŸlayÄ±cÄ± seÃ§eneÄŸi liste Ã¶ÄŸesi eklenirken bir hata oluÅŸtu.',0),(38021,1057,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania elementu listy opcji bazy danych bindery.',0),(38022,1057,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ð¾Ð¿Ñ†Ð¸Ñ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº.',0),(38023,1057,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ø§Ø®ØªÛŒØ§Ø± ÙÛØ±Ø³Øª Ø´Û’ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(38024,1057,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÑÑ‚Ð°Ð²ÐºÐµ Ð»Ð¸ÑÑ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð±Ð¸Ð½Ð´ÐµÑ€y.',0),(38025,1057,'vi','ThÃªm danh sÃ¡ch Ä‘Ã³ng sÃ¡ch bá»‹ lá»—i',0),(38026,1057,'af','Fout met byvoeging van boekbindery opsie itemlys.',0),(38027,1057,'ro','Eroare la adÄƒugarea legatorie opÅ£iune element din listÄƒ.',0),(38028,1057,'et','Viga lisades Kirjansitomo variant loendiÃ¼ksust.',0),(38029,1057,'si','Napaka pri dodajanju elementa seznama moÅ¾nost vezi.',0),(38030,1057,'ba','Kesalahan menambahkan bindery pilihan daftar item.',0),(38031,1057,'nl','Fout bij het toevoegen van bindery optie lijstitem.',0),(38032,1057,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ bindery luettelon vaihtoehdon.',0),(38033,1057,'no','Feil under tillegging bindery alternativet listeelementet.',0),(38034,1057,'da','Fejl ved tilfÃ¸jelse af bindery indstilling listeelementet.',0),(38035,1057,'ko','ë°”ì¸ë”ë¦¬ ì˜µì…˜ ëª©ë¡ í•­ëª©ì„ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(38036,1057,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¤×¨×™×˜ ×¨×©×™×ž×” ×©×œ ××¤×©×¨×•×™×•×ª ×’×™×ž×•×¨.',0),(38037,1057,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î»Î¯ÏƒÏ„Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î® bindery.',0),(38038,1057,'zh','é”™è¯¯æ·»åŠ è£…è®¢é€‰é¡¹åˆ—è¡¨ä¸­é¡¹ç›®ã€‚\r\n',0),(38039,1057,'sv','Fel att lÃ¤gga till bindery alternativet listobjektet.',0),(38040,1057,'it','Errore di aggiunta della legatoria opzione elenco elemento.',0),(38041,1057,'tl','',0),(38042,1057,'th','Error adding bindery option list item.',0),(38043,1057,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(38044,1057,'ms','Ralat menambah item senarai pilihan bindery.',0),(38045,1057,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø¹Ù†ØµØ± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø®ÙŠØ§Ø± Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(38046,1057,'fr','Erreur lors de l\'ajout d\'Ã©lÃ©ment de liste option faÃ§onnage.',0),(38047,1057,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚ªãƒ—ã‚·ãƒ§ãƒ³ãƒªã‚¹ãƒˆå“?ç›®ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38048,1057,'pt','Erro ao adicionar o item de lista de opÃ§Ã£o de encadernaÃ§Ã£o.',0),(38049,1057,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÑÐ¿Ð¸ÑÐºÐ° Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ bindery.',0),(38050,1057,'es','Error agregando lista de opciones de la encuadernaciÃ³n',0),(38051,1057,'de','Fehler beim HinzufÃ¼gen der Buchbinderei Option Listenelement.',0),(38052,1057,'en','Error adding bindery option list item.',0),(38053,1058,'is','',0),(38054,1058,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(38055,1058,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(38056,1058,'tr','Hata ekleme baÄŸlayÄ±cÄ± tÃ¼rÃ¼.',0),(38057,1058,'pl','BÅ‚Ä…d dodawania typ wiÄ…zaÅ„.',0),(38058,1058,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ‚Ð¸Ð¿.',0),(38059,1058,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚Ø³Ù… ÛÛ’ Û”',0),(38060,1058,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð±Ð¸Ð½Ð´ÐµÑ€y Ñ‚Ð¸Ð¿ Ð³Ñ€ÐµÑˆÐºÐµ.',0),(38061,1058,'vi','ThÃªm loáº¡i chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch bá»‹ lá»—i',0),(38062,1058,'af','Voeg bindery fouttipe.',0),(38063,1058,'ro','Eroare adÄƒugarea tip de legatorie.',0),(38064,1058,'et','Viga lisades Kirjansitomo tÃ¼Ã¼p.',0),(38065,1058,'si','Dodajanje Knjigoveznica vrsta napake.',0),(38066,1058,'ba','Jenis bindery menambahkan galat.',0),(38067,1058,'nl','Toe te voegen bindery fouttype.',0),(38068,1058,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ bindery tyyppi.',0),(38069,1058,'no','Feil Ã¥ legge bindery type.',0),(38070,1058,'da','Fejltypen tilfÃ¸je bindery.',0),(38071,1058,'ko','ì˜¤ë¥˜ ì¶”ê°€ ë°”ì¸ë”ë¦¬ í˜•ì‹ìž…ë‹ˆë‹¤.',0),(38072,1058,'he','×©×’×™××” ×ž×¡×•×’ bindery ×”×•×¡×¤×ª.',0),(38073,1058,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„ÏÏ€Î¿Ï… bindery ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(38074,1058,'zh','é”™è¯¯æ·»åŠ è£…è®¢ç±»åž‹ã€‚',0),(38075,1058,'sv','LÃ¤gga till bindery feltyp.',0),(38076,1058,'it','Errore aggiungendo tipo della legatoria.',0),(38077,1058,'tl','',0),(38078,1058,'th','Error adding bindery type.',0),(38079,1058,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤•à¤¾à¤°à¥¤',0),(38080,1058,'ms','Jenis bindery menambah ralat.',0),(38081,1058,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(38082,1058,'fr','Erreur ajout type de faÃ§onnage.',0),(38083,1058,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚¿ã‚¤ãƒ—ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38084,1058,'pt','Tipo de encadernaÃ§Ã£o de erro adicionando.',0),(38085,1058,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ‚Ð¸Ð¿Ð°.',0),(38086,1058,'es','Error agregando tipo de encuadernaciÃ³n',0),(38087,1058,'de','HinzufÃ¼gen von Buchbinderei Fehlertyp.',0),(38088,1058,'en','Error adding bindery type.',0),(38089,1059,'is','',0),(38090,1059,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(38091,1059,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(38092,1059,'tr','Bindery Ã§alÄ±ÅŸma tÃ¼rÃ¼nÃ¼ eklenirken bir hata oluÅŸtu.',0),(38093,1059,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania typu prace introligatorskie.',0),(38094,1059,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°.',0),(38095,1059,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ú©Ø§Ù… Ù‚Ø³Ù… Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(38096,1059,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð±Ð¸Ð½Ð´ÐµÑ€y Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð°.',0),(38097,1059,'vi','ThÃªm loáº¡i cÃ´ng viá»‡c Ä‘Ã³ng sÃ¡ch bá»‹ lá»—i',0),(38098,1059,'af','Fout bindery werk tipe by te voeg.',0),(38099,1059,'ro','Eroare la adÄƒugarea tip de muncÄƒ legatorie.',0),(38100,1059,'et','Viga lisades Kirjansitomo tÃ¶Ã¶ liik.',0),(38101,1059,'si','Napaka pri dodajanju Knjigoveznica vrsto dela.',0),(38102,1059,'ba','Kesalahan menambahkan jenis pekerjaan bindery.',0),(38103,1059,'nl','Fout bij het toevoegen van bindery werksoort.',0),(38104,1059,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ bindery tyÃ¶tyyppi.',0),(38105,1059,'no','Feil under tillegging bindery arbeidstype.',0),(38106,1059,'da','Fejl ved tilfÃ¸jelse af bindery arbejdstype.',0),(38107,1059,'ko','ë°”ì¸ë”ë¦¬ ìž‘ì—… ìœ í˜•ì„ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(38108,1059,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¡×•×’ ×¢×‘×•×“×” ×ž×¡×•×’ bindery.',0),(38109,1059,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· bindery Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚.',0),(38110,1059,'zh','é”™è¯¯æ·»åŠ è£…è®¢å·¥ä½œç±»åž‹ã€‚',0),(38111,1059,'sv','Fel att lÃ¤gga till bindery arbetstyp.',0),(38112,1059,'it','Errore durante l\'aggiunta della legatoria tipo di lavoro.',0),(38113,1059,'tl','',0),(38114,1059,'th','Error adding bindery work type.',0),(38115,1059,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(38116,1059,'ms','Ralat menambah jenis kerja bindery.',0),(38117,1059,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¹Ù…Ù„.',0),(38118,1059,'fr','Erreur en ajoutant le type de travail de faÃ§onnage.',0),(38119,1059,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ãƒ¯ãƒ¼ã‚¯ã‚¿ã‚¤ãƒ—ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38120,1059,'pt','Erro ao adicionar o tipo de vinculaÃ§Ã£o de trabalho.',0),(38121,1059,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¸Ð¿Ð° Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ñ‹Ñ… Ñ€Ð°Ð±Ð¾Ñ‚.',0),(38122,1059,'es','Error agregando tipo de trabajo de encuadernaciÃ³n',0),(38123,1059,'de','Fehler beim HinzufÃ¼gen der Buchbinderei Arbeitstyp.',0),(38124,1059,'en','Error adding bindery work type.',0),(38125,1060,'is','',0),(38126,1060,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(38127,1060,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(38128,1060,'tr','Hata ekleme taÅŸÄ±yÄ±cÄ±',0),(38129,1060,'pl','BÅ‚Ä…d dodajÄ…c przewoÅºnika',0),(38130,1060,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(38131,1060,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©ÛŒØ±ÛŒØ¦Ø±',0),(38132,1060,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð½Ð¾ÑÐ°Ñ‡',0),(38133,1060,'vi','ThÃªm hÃ£ng váº­n chuyá»ƒn bá»‹ lá»—i',0),(38134,1060,'af','\'n Fout het ontstaan met die byvoeging van \'n karweier',0),(38135,1060,'ro','Eroare adÄƒugarea de transport',0),(38136,1060,'et','Viga lisades vedaja',0),(38137,1060,'si','Napaka pri dodajanju prevoznik',0),(38138,1060,'ba','Pembawa menambahkan kesalahan',0),(38139,1060,'nl','Fout toe te voegen vervoerder',0),(38140,1060,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ harjoittaja',0),(38141,1060,'no','Feil Ã¥ legge transportÃ¸r',0),(38142,1060,'da','Fejl tilfÃ¸je carrier',0),(38143,1060,'ko','ì˜¤ë¥˜ ì¶”ê°€ ìºë¦¬ì–´',0),(38144,1060,'he','× ×•×©× ×”×•×¡×¤×ª ×”×©×’×™××”',0),(38145,1060,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î± ÏƒÏ†Î¬Î»Î¼Î±',0),(38146,1060,'zh','é”™è¯¯æ·»åŠ æ‰¿è¿å•†',0),(38147,1060,'sv','Fel att lÃ¤gga till transportÃ¶ren',0),(38148,1060,'it','Vettore aggiungendo errore',0),(38149,1060,'tl','',0),(38150,1060,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(38151,1060,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤µà¤¾à¤¹à¤•',0),(38152,1060,'ms','Ralat menambah pembawa',0),(38153,1060,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù†Ø§Ù‚Ù„',0),(38154,1060,'fr','Transporteur ajout d\'erreur',0),(38155,1060,'jp','é…?é€?æ¥­è€…ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38156,1060,'pt','Adicionando transportadora erro',0),(38157,1060,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÑƒÑ€ÑŒÐµÑ€Ð°',0),(38158,1060,'es','Error agregando transportador',0),(38159,1060,'de','Fehler hinzufÃ¼gen TrÃ¤ger',0),(38160,1060,'en','Error adding carrier',0),(38161,1061,'is','',0),(38162,1061,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ â€“ Ù†Ø§Ù… ØªÙƒØ±Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(38163,1061,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ â€“ Ù†Ø§Ù… ØªÙƒØ±Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(38164,1061,'tr','Yinelenen ad hata ekleme kategori - var',0),(38165,1061,'pl','BÅ‚Ä…d dodawania kategorii - istnieje duplikat nazwy',0),(38166,1061,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ - ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ñ‰Ð¾ ÑÐµ Ð¸Ð¼Ðµ',0),(38167,1061,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø²Ù…Ø±Û: Ù…Ø«Ù†ÛŒ Ù†Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Û”',0),(38168,1061,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° - Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚ Ð¸Ð¼Ðµ',0),(38169,1061,'vi','ThÃªm thá»ƒ loáº¡i bá»‹ lá»—i - trÃ¹ng tÃªn',0),(38170,1061,'af','Fout voeg kategorie - duplikaat naam bestaan',0),(38171,1061,'ro','Eroare de categorie adÄƒugarea - nume duplicat existÄƒ',0),(38172,1061,'et','Viga lisades kategooria - esineb mitu nime',0),(38173,1061,'si','Dodajanje category napaka - obstaja podvojeno ime',0),(38174,1061,'ba','Ada kesalahan menambahkan kategori - nama duplikat',0),(38175,1061,'nl','Fout toevoegen categorie - dubbele naam bestaat',0),(38176,1061,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ luokka - on kahdentunut nimi',0),(38177,1061,'no','Feil Ã¥ legge til kategori - navnet finnes allerede',0),(38178,1061,'da','Fejl tilfÃ¸je kategori - identisk navn findes',0),(38179,1061,'ko','ì¡´ìž¬ í•˜ëŠ” ì¤‘ë³µ ì´ë¦„ ì˜¤ë¥˜ ì¶”ê°€ ë²”ì£¼-',0),(38180,1061,'he','×§×™×™×ž×ª ×©×’×™××” ×”×•×¡×¤×ª ×§×˜×’×•×¨×™×” - ×”×©× ×”×›×¤×•×œ',0),(38181,1061,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€Î¿ ÏŒÎ½Î¿Î¼Î± ÏƒÏ†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±-',0),(38182,1061,'zh','é”™è¯¯æ·»åŠ ç±»åˆ«-å­˜åœ¨é‡å¤çš„åç§°',0),(38183,1061,'sv','Fel att lÃ¤gga till kategori - dubblettnamn finns',0),(38184,1061,'it','Categoria aggiungendo errore - nome duplicato esiste',0),(38185,1061,'tl','',0),(38186,1061,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;-&#3617;&#3637;&#3594;&#3639;&#',0),(38187,1061,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ - à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤¨à¤¾à¤® à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(38188,1061,'ms','Ralat menambah kategori - nama pendua wujud',0),(38189,1061,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„ØªØµÙ†ÙŠÙ - Ø§Ù„Ø¥Ø³Ù… Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(38190,1061,'fr','Erreur ajout catÃ©gorie - nom dupliquÃ© existe',0),(38191,1061,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼/å?Œã?˜å??å‰?ã?Œå­˜åœ¨ã?—ã?¾ã?™',0),(38192,1061,'pt','Erro adicionando categoria - nome duplicado existe',0),(38193,1061,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ - Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰ÐµÐµÑÑ Ð¸Ð¼Ñ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(38194,1061,'es','Error agregando categorÃ­a - nombre duplicado existe',0),(38195,1061,'de','HinzufÃ¼gen von Fehlerkategorie - existiert doppelter name',0),(38196,1061,'en','Error adding category - duplicate name exists',0),(38197,1062,'is','',0),(38198,1062,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú†Ùƒ',0),(38199,1062,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú†Ùƒ',0),(38200,1062,'tr','Onay ekleme hatasÄ±',0),(38201,1062,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania wyboru',0),(38202,1062,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¾Ñ‚Ð¼ÐµÑ‚ÐºÐ°',0),(38203,1062,'ur','Ú†ÛŒÚ© Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(38204,1062,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(38205,1062,'vi','ThÃªm SÃ©c bá»‹ lá»—i',0),(38206,1062,'af','Fout voeg kontroleer',0),(38207,1062,'ro','Eroare la adÄƒugarea verifica',0),(38208,1062,'et','Viga lisades sisse',0),(38209,1062,'si','Napaka pri dodajanju potrdite',0),(38210,1062,'ba','Kesalahan menambahkan check',0),(38211,1062,'nl','Fout selectievakje toevoegen',0),(38212,1062,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ uloskirjautuminen',0),(38213,1062,'no','Feil under tillegging av',0),(38214,1062,'da','Fejl ved tilfÃ¸jelse af check',0),(38215,1062,'ko','ì˜¤ë¥˜ ê²€ì‚¬ë¥¼ ì¶”ê°€',0),(38216,1062,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¡×™×ž×•×Ÿ',0),(38217,1062,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(38218,1062,'zh','åŠ å…¥é”™è¯¯æ£€æŸ¥',0),(38219,1062,'sv','Fel att lÃ¤gga till check',0),(38220,1062,'it','Errore aggiungendo il controllo',0),(38221,1062,'tl','',0),(38222,1062,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;',0),(38223,1062,'hi','à¤šà¥‡à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(38224,1062,'ms','Ralat menambah Daftar',0),(38225,1062,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(38226,1062,'fr','Erreur en ajoutant le cocher',0),(38227,1062,'jp','å°?åˆ‡æ‰‹ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38228,1062,'pt','Erro ao adicionar seleÃ§Ã£o',0),(38229,1062,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(38230,1062,'es','Error agregando cheque',0),(38231,1062,'de','Fehler beim HinzufÃ¼gen von KontrollkÃ¤stchen',0),(38232,1062,'en','Error adding check',0),(38233,1063,'is','',0),(38234,1063,'dr','/ ÙˆØ§Ø±Ø¯ Ø­Ø³Ø§Ø¨ ÙƒØ±Ø¯Ù†',0),(38235,1063,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªØ³ÙˆÙŠÙ‡ Ø­Ø³Ø§Ø¨ ÙƒØ±Ø¯Ù† / ÙˆØ§Ø±Ø¯ Ø­Ø³Ø§Ø¨ ÙƒØ±Ø¯Ù†',0),(38236,1063,'tr','Check out/in bilgisi eklenirken bir hata oluÅŸtu.',0),(38237,1063,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania check out/w informacje.',0),(38238,1063,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° out/Ð² Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(38239,1063,'ur','Ú†ÛŒÚ© Ø¢Ø¤Ù¹/Ù…ÛŒÚº Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(38240,1063,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¸Ð·Ð»Ð°Ð·/Ñƒ Ð¸Ð½Ñ„Ð¾.',0),(38241,1063,'vi','Lá»—i khi thÃªm thÃ´ng tin Ä‘Æ°a ra Ä‘Æ°a vÃ o',0),(38242,1063,'af','Fout met byvoeging van vertrek/aankoms inligting.',0),(38243,1063,'ro','Eroare la adÄƒugarea check-out/in info.',0),(38244,1063,'et','Viga lisades kontrollige vÃ¤lja/info.',0),(38245,1063,'si','Napaka pri dodajanju Äek/v info.',0),(38246,1063,'ba','Menambahkan kesalahan cek luar/dalam info.',0),(38247,1063,'nl','Fout bij het inchecken out/info toe te voegen.',0),(38248,1063,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ sisÃ¤Ã¤n ulos-ja info.',0),(38249,1063,'no','Feil legge sjekk ut/inn info.',0),(38250,1063,'da','Fejl ved tilfÃ¸jelse af check out/i info.',0),(38251,1063,'ko','ì²´í¬ ì•„ì›ƒ/ì¸ ì •ë³´ë¥¼ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(38252,1063,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×”×¦\'×§ ×××•×˜/×¤×¨×˜×™.',0),(38253,1063,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· check out/ÏƒÏ„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚.',0),(38254,1063,'zh','é”™è¯¯æ·»åŠ ç™»å‡º/ç™»å…¥ä¿¡æ¯ã€‚',0),(38255,1063,'sv','Ett fel uppstod nÃ¤r checka ut/in information.',0),(38256,1063,'it','Errore durante l\'aggiunta di check-out/in informazioni.',0),(38257,1063,'tl','',0),(38258,1063,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3',0),(38259,1063,'hi','à¤šà¥‡à¤• à¤†à¤‰à¤Ÿ/à¤®à¥‡à¤‚ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(38260,1063,'ms','Ralat menambah Daftar keluar/masuk maklumat.',0),(38261,1063,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±/ÙÙŠ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª.',0),(38262,1063,'fr','Erreur lors de lâ€™ajout de check-out/in info.',0),(38263,1063,'jp','ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆ/ã‚¤ãƒ³æƒ…å ±ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38264,1063,'pt','Erro ao adicionar check-out/in informaÃ§Ã£o.',0),(38265,1063,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ check out/in info.',0),(38266,1063,'es','Error agregando info de salir/ingresar',0),(38267,1063,'de','Fehler beim HinzufÃ¼gen des Check-Out/in Info.',0),(38268,1063,'en','Error adding check out/in info.',0),(38269,1064,'is','',0),(38270,1064,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(38271,1064,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(38272,1064,'tr','Hata ekleme Ã§ek hesabÄ±',0),(38273,1064,'pl','BÅ‚Ä…d dodawania konta bankowego',0),(38274,1064,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(38275,1064,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹',0),(38276,1064,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(38277,1064,'vi','ThÃªm TK SÃ©c Bá»‹ Lá»—i',0),(38278,1064,'af','Fout met byvoeging van tjekrekening',0),(38279,1064,'ro','AdÄƒugarea cont de verificare eroare',0),(38280,1064,'et','Viga lisades pangakonto',0),(38281,1064,'si','Napaka pri dodajanju preverjanje raÄuna',0),(38282,1064,'ba','Rekening menambahkan kesalahan',0),(38283,1064,'nl','Fout toe te voegen betaalrekening',0),(38284,1064,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tarkkailun huomioon',0),(38285,1064,'no','Feil Ã¥ legge brukskonto',0),(38286,1064,'da','Fejl tilfÃ¸je checkkonto',0),(38287,1064,'ko','ì˜¤ë¥˜ ì¶”ê°€ ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(38288,1064,'he','×©×’×™××” ×”×•×¡×¤×ª ×—×©×‘×•×Ÿ ×‘× ×§',0),(38289,1064,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ ÎµÎ»Î­Î³Ï‡Î¿Ï… ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚',0),(38290,1064,'zh','é”™è¯¯æ·»åŠ æ”¯ç¥¨å¸æˆ·\r\n',0),(38291,1064,'sv','Fel att lÃ¤gga lÃ¶nekonto',0),(38292,1064,'it','Errore aggiungendo conto corrente',0),(38293,1064,'tl','',0),(38294,1064,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3',0),(38295,1064,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(38296,1064,'ms','Ralat menambah memeriksa akaun',0),(38297,1064,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ',0),(38298,1064,'fr','Erreur ajout compte-chÃ¨ques',0),(38299,1064,'jp','å½“åº§é ?é‡‘ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38300,1064,'pt','Erro adicionando conta',0),(38301,1064,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(38302,1064,'es','Error agregando cuenta de cheques',0),(38303,1064,'de','Fehler hinzufÃ¼gen Girokonto',0),(38304,1064,'en','Error adding checking account',0),(38305,1065,'is','',0),(38306,1065,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø±Ù†Ú¯ ',0),(38307,1065,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø±Ù†Ú¯ ',0),(38308,1065,'tr','Renk eklenirken bir hata oluÅŸtu.',0),(38309,1065,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania kolor.',0),(38310,1065,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ†Ð²ÑÑ‚.',0),(38311,1065,'ur','Ø±Ù†Ú¯ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(38312,1065,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð±Ð¾Ñ˜Ð°.',0),(38313,1065,'vi','ThÃªm máº§u bá»‹ lá»—i',0),(38314,1065,'af','Fout kleur by te voeg.',0),(38315,1065,'ro','Eroare la adÄƒugarea de culoare.',0),(38316,1065,'et','Viga lisades vÃ¤rvi.',0),(38317,1065,'si','Napaka pri dodajanju barvo.',0),(38318,1065,'ba','Kesalahan menambahkan warna.',0),(38319,1065,'nl','Fout bij het toevoegen van kleur.',0),(38320,1065,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ vÃ¤ri.',0),(38321,1065,'no','Feil Ã¥ legge farge.',0),(38322,1065,'da','Fejl ved tilfÃ¸jelse af farve.',0),(38323,1065,'ko','ìƒ‰ìƒì„ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(38324,1065,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¦×‘×¢.',0),(38325,1065,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï‡ÏÏŽÎ¼Î±Ï„Î¿Ï‚.',0),(38326,1065,'zh','é”™è¯¯æ·»åŠ è‰²å½©ã€‚',0),(38327,1065,'sv','Fel att lÃ¤gga till fÃ¤rg.',0),(38328,1065,'it','Errore durante l\'aggiunta di colore.',0),(38329,1065,'tl','',0),(38330,1065,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3637;',0),(38331,1065,'hi','à¤°à¤‚à¤— à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(38332,1065,'ms','Ralat menambah warna.',0),(38333,1065,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù„ÙˆÙ†.',0),(38334,1065,'fr','Erreur lors de l\'ajout de couleur.',0),(38335,1065,'jp','è‰²ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38336,1065,'pt','Erro ao adicionar a cor.',0),(38337,1065,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ†Ð²ÐµÑ‚Ð°.',0),(38338,1065,'es','Error agregando color',0),(38339,1065,'de','Fehler beim HinzufÃ¼gen von Farbe.',0),(38340,1065,'en','Error adding color.',0),(38341,1066,'is','',0),(38342,1066,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª',0),(38343,1066,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª',0),(38344,1066,'tr','Hata ekleyerek ÅŸirket',0),(38345,1066,'pl','BÅ‚Ä…d dodawania firmy',0),(38346,1066,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(38347,1066,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Ù…Ù¾Ù†ÛŒ',0),(38348,1066,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(38349,1066,'vi','ThÃªm cty bá»‹ lá»—i',0),(38350,1066,'af','Fout voeg maatskappy',0),(38351,1066,'ro','Eroare de companie adÄƒugÃ¢nd',0),(38352,1066,'et','EttevÃµtte lisamisel tekkis viga',0),(38353,1066,'si','Dodajanje podjetje napaka',0),(38354,1066,'ba','Perusahaan menambahkan kesalahan',0),(38355,1066,'nl','Fout toevoegen bedrijf',0),(38356,1066,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ yritys',0),(38357,1066,'no','Feil Ã¥ legge til selskapet',0),(38358,1066,'da','Fejl tilfÃ¸je selskab',0),(38359,1066,'ko','ì˜¤ë¥˜ ì¶”ê°€ íšŒì‚¬',0),(38360,1066,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×—×‘×¨×”',0),(38361,1066,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÏƒÏ†Î¬Î»Î¼Î±',0),(38362,1066,'zh','é”™è¯¯æ·»åŠ å…¬å¸',0),(38363,1066,'sv','Fel att lÃ¤gga till fÃ¶retag',0),(38364,1066,'it','Azienda aggiungendo errore',0),(38365,1066,'tl','',0),(38366,1066,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(38367,1066,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¤‚à¤ªà¤¨à¥€',0),(38368,1066,'ms','Syarikat menambah ralat',0),(38369,1066,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø´Ø±ÙƒØ©',0),(38370,1066,'fr','SociÃ©tÃ© ajout d\'erreur',0),(38371,1066,'jp','ä¼šç¤¾ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38372,1066,'pt','Empresa adicionando erro',0),(38373,1066,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(38374,1066,'es','Error agregando empresa',0),(38375,1066,'de','Fehler HinzufÃ¼gen von Unternehmen',0),(38376,1066,'en','Error adding company',0),(38377,1067,'is','',0),(38378,1067,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª â€“ Ù†Ø§Ù… ØªÙƒØ±Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(38379,1067,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª â€“ Ù†Ø§Ù… ØªÙƒØ±Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(38380,1067,'tr','Yinelenen ad hata ekleyerek ÅŸirket - var',0),(38381,1067,'pl','BÅ‚Ä…d dodawania firmy - istnieje duplikat nazwy',0),(38382,1067,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ - ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ñ‰Ð¾ ÑÐµ Ð¸Ð¼Ðµ',0),(38383,1067,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Ù…Ù¾Ù†ÛŒ - Ù…Ø«Ù†ÛŒ Ù†Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Û”',0),(38384,1067,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° - Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚Ð° Ð¸Ð¼Ðµ',0),(38385,1067,'vi','ThÃªm cty bá»‹ lá»—i - TrÃ¹ng tÃªn',0),(38386,1067,'af','Fout voeg maatskappy - duplikaat naam bestaan',0),(38387,1067,'ro','Eroare adÄƒugarea companie - nume duplicat existÄƒ',0),(38388,1067,'et','EttevÃµtte lisamisel tekkis viga - sarnase nimega ettevÃµte on juba olemas',0),(38389,1067,'si','Napaka pri dodajanju podjetje - podvojeno ime obstaja',0),(38390,1067,'ba','Perusahaan menambahkan kesalahan - ada nama duplikat',0),(38391,1067,'nl','Fout toe te voegen bedrijf - dubbele naam bestaat',0),(38392,1067,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ yritys - on kahdentunut nimi',0),(38393,1067,'no','Feil Ã¥ legge selskap - navnet finnes allerede',0),(38394,1067,'da','Fejl tilfÃ¸je selskab - identisk navn findes',0),(38395,1067,'ko','ì¡´ìž¬ í•˜ëŠ” ì¤‘ë³µ ì´ë¦„ ì˜¤ë¥˜ ì¶”ê°€ íšŒì‚¬-',0),(38396,1067,'he','×—×‘×¨×ª ×”×•×¡×¤×ª ×”×©×’×™××” - ×”×©× ×”×›×¤×•×œ ×§×™×™×',0),(38397,1067,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€Î¿ ÏŒÎ½Î¿Î¼Î± ÏƒÏ†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±-',0),(38398,1067,'zh','é”™è¯¯åŠ å…¥å…¬å¸-å­˜åœ¨é‡å¤çš„åç§°',0),(38399,1067,'sv','Fel att lÃ¤gga fÃ¶retaget - dubblettnamn finns',0),(38400,1067,'it','Azienda aggiungendo errore - nome duplicato esiste',0),(38401,1067,'tl','',0),(38402,1067,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607; &#3617;&#3637;&#3594;&#3639;&#3656;&#3629;&#',0),(38403,1067,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¤‚à¤ªà¤¨à¥€ - à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤¨à¤¾à¤® à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(38404,1067,'ms','Syarikat menambah ralat - nama pendua wujud',0),(38405,1067,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø´Ø±ÙƒØ© - Ø§Ù„Ø¥Ø³Ù… Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(38406,1067,'fr','Erreur ajout sociÃ©tÃ© - nom dupliquÃ© existe',0),(38407,1067,'jp','ä¼šç¤¾ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼/å?Œã?˜å??å‰?ã?Œå­˜åœ¨ã?—ã?¾ã?™',0),(38408,1067,'pt','Erro adicionando empresa - nome duplicado existe',0),(38409,1067,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ - Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰ÐµÐµÑÑ Ð¸Ð¼Ñ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(38410,1067,'es','Error agregando empresa - nombre duplicado existe',0),(38411,1067,'de','Fehler hinzufÃ¼gen Firma - besteht doppelter name',0),(38412,1067,'en','Error adding company - duplicate name exists',0),(38413,1068,'is','',0),(38414,1068,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(38415,1068,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(38416,1068,'tr','Maliyet merkezi ekleme hatasÄ±',0),(38417,1068,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania MPK',0),(38418,1068,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(38419,1068,'ur','Ù‚ÛŒÙ…Øª Ù…Ø±Ú©Ø² Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(38420,1068,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(38421,1068,'vi','ThÃªm Cost center bá»‹ lá»—i',0),(38422,1068,'af','Fout voeg koste Sentrum',0),(38423,1068,'ro','Eroare la adÄƒugarea centru de Cost',0),(38424,1068,'et','Viga lisades Kulukeskus',0),(38425,1068,'si','Napaka pri dodajanju stroÅ¡kovno srediÅ¡Äe',0),(38426,1068,'ba','Kesalahan menambahkan biaya Pusat',0),(38427,1068,'nl','Fout toe te voegen kosten Center',0),(38428,1068,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ kustannuspaikka',0),(38429,1068,'no','Feil under tillegging av kostsenter',0),(38430,1068,'da','Fejl ved tilfÃ¸jelse af bÃ¦reren',0),(38431,1068,'ko','ë¹„ìš© ì„¼í„°ë¥¼ ì¶”ê°€ ì˜¤ë¥˜',0),(38432,1068,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×ž×¨×›×– ×¢×œ×•×™×•×ª',0),(38433,1068,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(38434,1068,'zh','é”™è¯¯ï¼šæ–°å¢žæˆæœ¬ä¸­å¿ƒ\r\n',0),(38435,1068,'sv','Fel att lÃ¤gga till kostnadsstÃ¤lle',0),(38436,1068,'it','Errore di aggiunta di centro di costo',0),(38437,1068,'tl','',0),(38438,1068,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;',0),(38439,1068,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(38440,1068,'ms','Ralat menambah pusat kos',0),(38441,1068,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ©',0),(38442,1068,'fr','Erreur en ajoutant des centre de coÃ»t',0),(38443,1068,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38444,1068,'pt','Erro na adiÃ§Ã£o de centro de custo',0),(38445,1068,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½Ñ‚Ñ€Ð° Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(38446,1068,'es','Error agregando centro de costos',0),(38447,1068,'de','Fehler beim HinzufÃ¼gen der Kostenstelle',0),(38448,1068,'en','Error adding Cost Center',0),(38449,1069,'is','',0),(38450,1069,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(38451,1069,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(38452,1069,'tr','Maliyet Merkezi Aile ekleme hatasÄ±',0),(38453,1069,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania kosztÃ³w centrum rodziny',0),(38454,1069,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(38455,1069,'ur','Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ú©Ø² Ú©Û’ Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(38456,1069,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(38457,1069,'vi','ThÃªm gia Ä‘Ã¬nh Cost center bá»‹ lá»—i',0),(38458,1069,'af','Fout voeg koste sentrum familie',0),(38459,1069,'ro','Eroare la adÄƒugarea familie de centru de Cost',0),(38460,1069,'et','Viga lisades kulu Center pere',0),(38461,1069,'si','Napaka pri dodajanju stroÅ¡kov Center druÅ¾ine',0),(38462,1069,'ba','Kesalahan menambahkan biaya pusat keluarga',0),(38463,1069,'nl','Fout toe te voegen kosten Center familie',0),(38464,1069,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ kustannus Center-tuoteperheen',0),(38465,1069,'no','Feil under tillegging Cost Center-produktfamilien',0),(38466,1069,'da','Fejl ved tilfÃ¸jelse af Cost Center familie',0),(38467,1069,'ko','ë¹„ìš© ì„¼í„° ê°€ì¡± ì¶”ê°€ ì˜¤ë¥˜',0),(38468,1069,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¢×œ×•×ª ×ž×¨×›×– ×”×ž×©×¤×—×”',0),(38469,1069,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(38470,1069,'zh','é”™è¯¯æ·»åŠ æˆæœ¬ä¸­å¿ƒç³»åˆ—',0),(38471,1069,'sv','Fel att lÃ¤gga kostnaden Center familj',0),(38472,1069,'it','Errore di aggiunta di famiglia di centro di costo',0),(38473,1069,'tl','',0),(38474,1069,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3585;&#3640;&#3621;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3',0),(38475,1069,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(38476,1069,'ms','Ralat menambah kos Pusat keluarga',0),(38477,1069,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© \"ØªÙƒÙ„ÙØ© Ù…Ø±ÙƒØ² Ø§Ù„Ø£Ø³Ø±Ø©\"',0),(38478,1069,'fr','Erreur en ajoutant des famille de centre de coÃ»t',0),(38479,1069,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ç³»çµ±ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38480,1069,'pt','Erro ao adicionar a famÃ­lia de centro de custo',0),(38481,1069,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ñ†ÐµÐ½Ñ‚Ñ€Ð° ÑÐµÐ¼ÑŒÐ¸',0),(38482,1069,'es','Error agregando familia de centro de costos',0),(38483,1069,'de','Fehler beim HinzufÃ¼gen des Cost-Center-Produktfamilie',0),(38484,1069,'en','Error adding Cost Center Family',0),(38485,1070,'is','',0),(38486,1070,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(38487,1070,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(38488,1070,'tr','Hata ekleme mÃ¼ÅŸteri',0),(38489,1070,'pl','BÅ‚Ä…d dodawania klienta',0),(38490,1070,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(38491,1070,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú¯Ø§ÛÚ©',0),(38492,1070,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÐºÑƒÐ¿Ñ†Ð°',0),(38493,1070,'vi','ThÃªm khÃ¡ch hÃ ng bá»‹ lá»—i',0),(38494,1070,'af','Fout met byvoeging van KliÃ«nt/Klant',0),(38495,1070,'ro','Eroare client adÄƒugarea',0),(38496,1070,'et','Kliendi lisamisel tekkis viga',0),(38497,1070,'si','Napaka dodajanje kupcev',0),(38498,1070,'ba','Pelanggan menambahkan kesalahan',0),(38499,1070,'nl','Fout toe te voegen klant',0),(38500,1070,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ asiakkaan',0),(38501,1070,'no','Feil Ã¥ legge til kunde',0),(38502,1070,'da','Fejl tilfÃ¸je kunde',0),(38503,1070,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê³ ê°',0),(38504,1070,'he','×©×’×™××” ×”×•×¡×¤×ª ×œ×§×•×—',0),(38505,1070,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÎµÎ»Î¬Ï„Î·',0),(38506,1070,'zh','é”™è¯¯ï¼šæ–°å¢žå®¢æˆ·',0),(38507,1070,'sv','Fel att lÃ¤gga till kund',0),(38508,1070,'it','Cliente aggiungendo errore',0),(38509,1070,'tl','',0),(38510,1070,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(38511,1070,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(38512,1070,'ms','Ralat menambah pelanggan',0),(38513,1070,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(38514,1070,'fr','Client ajout d\'erreur',0),(38515,1070,'jp','é¡§å®¢ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38516,1070,'pt','Cliente adicionando erro',0),(38517,1070,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(38518,1070,'es','Error agregando cliente',0),(38519,1070,'de','Fehler HinzufÃ¼gen von Kunden',0),(38520,1070,'en','Error adding customer',0),(38521,1071,'is','',0),(38522,1071,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(38523,1071,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(38524,1071,'tr','MÃ¼ÅŸteri gemiye ekleme hatasÄ±',0),(38525,1071,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania statku klienta',0),(38526,1071,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(38527,1071,'ur','Ú©Ø³Ù¹Ù…Ø± Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(38528,1071,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÐºÑƒÐ¿Ñ†Ð° Ð´Ð° Ð±Ñ€Ð¾Ð´',0),(38529,1071,'vi','Lá»—i khi thÃªm Ä‘á»‹a chá»‰ váº­n chuyá»ƒn',0),(38530,1071,'af','Fout met byvoeging van KliÃ«nt/Klant',0),(38531,1071,'ro','Eroare la adÄƒugarea nava clientului la',0),(38532,1071,'et','Kliendi tarneaadressi lisamisel tekkis viga',0),(38533,1071,'si','Napaka pri dodajanju kupec ladje',0),(38534,1071,'ba','Kesalahan menambahkan kapal pelanggan untuk',0),(38535,1071,'nl','Fout toe te voegen klant schip',0),(38536,1071,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ asiakkaan aluksen',0),(38537,1071,'no','Feil under tillegging av kunden skip',0),(38538,1071,'da','Fejl ved tilfÃ¸jelse af kunden skib til',0),(38539,1071,'ko','ê³ ê° ë°°ì†¡ ì¶”ê°€ ì˜¤ë¥˜',0),(38540,1071,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×œ×§×•×—×•×ª ×œ×¡×¤×™× ×”',0),(38541,1071,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÎ¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ· Ï€Î»Î¿Î¯Ï‰Î½ Î½Î±',0),(38542,1071,'zh','é”™è¯¯ï¼šæ–°å¢žå®¢æˆ·æ”¶è´§åœ°',0),(38543,1071,'sv','Fel att lÃ¤gga till kund fartyget till',0),(38544,1071,'it','Errore durante l\'aggiunta cliente nave a',0),(38545,1071,'tl','',0),(38546,1071,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3651;&#3627;&#3657;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(38547,1071,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(38548,1071,'ms','Ralat menambah pelanggan kapal',0),(38549,1071,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(38550,1071,'fr','Erreur ajout client navire Ã ',0),(38551,1071,'jp','é¡§å®¢é…?é€?å…ˆã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38552,1071,'pt','Erro ao adicionar cliente navio para',0),(38553,1071,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(38554,1071,'es','Error agregando cliente enviar a',0),(38555,1071,'de','Fehler beim HinzufÃ¼gen des Kunden Schiff',0),(38556,1071,'en','Error adding customer ship to',0),(38557,1072,'is','',0),(38558,1072,'dr','( ÙƒØ³Ø±ÙŠ',0),(38559,1072,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ØªØ®ÙÙŠÙ ( ÙƒØ³Ø±ÙŠ',0),(38560,1072,'tr','Hata ekleme kesinti grubu',0),(38561,1072,'pl','BÅ‚Ä…d dodawania grupy odliczenia',0),(38562,1072,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ð°',0),(38563,1072,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ ÛÙˆÙ†Û’Ùˆ Ú¯Ø±ÙˆÙ¾',0),(38564,1072,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ðµ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð³Ñ€ÐµÑˆÐºÐµ',0),(38565,1072,'vi','ThÃªm nhÃ³m giáº£m trá»« bá»‹ lá»—i',0),(38566,1072,'af','Fout voeg aftrekking groep',0),(38567,1072,'ro','Eroare adÄƒugarea deducerea grup',0),(38568,1072,'et','Viga lisades mahaarvamise grupp',0),(38569,1072,'si','Napaka dodajanje odbitek skupine',0),(38570,1072,'ba','Kesalahan menambahkan pengurangan kelompok',0),(38571,1072,'nl','Fout toe te voegen aftrek groep',0),(38572,1072,'fi','Virhe vÃ¤hennys ryhmÃ¤n lisÃ¤Ã¤minen',0),(38573,1072,'no','Feil Ã¥ legge fradrag gruppe',0),(38574,1072,'da','Fejl tilfÃ¸je fradrag gruppe',0),(38575,1072,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê³µì œ ê·¸ë£¹',0),(38576,1072,'he','×§×‘×•×¦×ª × ×™×›×•×™ ×”×•×¡×¤×ª ×”×©×’×™××”',0),(38577,1072,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Ï†Î±Î¯ÏÎµÏƒÎ· Î¿Î¼Î¬Î´Î± ÏƒÏ†Î¬Î»Î¼Î±',0),(38578,1072,'zh','é”™è¯¯æ·»åŠ æ‰£é™¤ç»„',0),(38579,1072,'sv','Fel att lÃ¤gga till avdrag grupp',0),(38580,1072,'it','Gruppo di deduzione aggiungendo errore',0),(38581,1072,'tl','',0),(38582,1072,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;',0),(38583,1072,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤¸à¤®à¥‚à¤¹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(38584,1072,'ms','Ralat menambah potongan Kumpulan',0),(38585,1072,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø®ØµÙ… Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(38586,1072,'fr','Groupe de dÃ©duction ajout erreur',0),(38587,1072,'jp','æŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38588,1072,'pt','Grupo de deduÃ§Ã£o erro adicionando',0),(38589,1072,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(38590,1072,'es','Error agregando grupo de deducciones',0),(38591,1072,'de','Fehler hinzufÃ¼gen Abzug Gruppe',0),(38592,1072,'en','Error adding deduction group',0),(38593,1073,'is','',0),(38594,1073,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(38595,1073,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(38596,1073,'tr','Hata ekleyerek ayrÄ±ntÄ±lÄ± iÅŸ tÃ¼rÃ¼.',0),(38597,1073,'pl','BÅ‚Ä…d dodawania szczegÃ³Å‚Ã³w pracy typu.',0),(38598,1073,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´ÐµÑ‚Ð°Ð¹Ð» Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿.',0),(38599,1073,'ur','Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©ÛŒ ØªÙØµÛŒÙ„ Ù†Ù‚Øµ Ù‚Ø³Ù… Ú©Ø§Ù… Ú©Ø±ØªÛ’ ÛÛŒÚº Û”',0),(38600,1073,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð´ÐµÑ‚Ð°Ñ™ Ð²Ñ€ÑÑ‚Ðµ Ñ€Ð°Ð´Ð°.',0),(38601,1073,'vi','ThÃªm chi tiáº¿t loáº¡i cÃ´ng viá»‡c bá»‹ lá»—i',0),(38602,1073,'af','Fout voeg detail werk tipe.',0),(38603,1073,'ro','Eroare detaliu adÄƒugarea de lucru tip.',0),(38604,1073,'et','Viga lisades detail tÃ¶Ã¶ liik.',0),(38605,1073,'si','Napaka pri dodajanju podrobno delo tipa.',0),(38606,1073,'ba','Kesalahan menambahkan detail bekerja jenis.',0),(38607,1073,'nl','Fout toe te voegen detail werksoort.',0),(38608,1073,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ yksityiskohtaisesti tyÃ¶n tyyppi.',0),(38609,1073,'no','Legge feildetaljer arbeidstype.',0),(38610,1073,'da','Fejl tilfÃ¸je detaljer arbejde type.',0),(38611,1073,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì„¸ë¶€ ìž‘ì—… í˜•ì‹.',0),(38612,1073,'he','×¤×™×¨×•×˜ ×”×•×¡×¤×ª ×”×©×’×™××” ×¢×•×‘×“×™× ×¡×•×’.',0),(38613,1073,'el','Î¤ÏÏ€Î¿Ï‚ Î­ÏÎ³Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(38614,1073,'zh','é”™è¯¯æ·»åŠ è¯¦ç»†çš„å·¥ä½œç±»åž‹ã€‚\r\n',0),(38615,1073,'sv','Fel att lÃ¤gga till detalj arbetstyp.',0),(38616,1073,'it','Dettaglio aggiungendo errore tipo di lavoro.',0),(38617,1073,'tl','',0),(38618,1073,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3',0),(38619,1073,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾à¤® à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(38620,1073,'ms','Ralat menambah butiran kerja jenis.',0),(38621,1073,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„.',0),(38622,1073,'fr','DÃ©tail ajout d\'erreur type de travail.',0),(38623,1073,'jp','ä»•äº‹å†…å®¹è©³ç´°ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38624,1073,'pt','Adicionando detalhes de erro de tipo de trabalho.',0),(38625,1073,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð´ÐµÑ‚Ð°Ð»ÐµÐ¹ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹.',0),(38626,1073,'es','Error agregando tipo de trabajo detallado',0),(38627,1073,'de','HinzufÃ¼gen von Fehlerdetails arbeiten Typ.',0),(38628,1073,'en','Error adding detail work type.',0),(38629,1074,'is','',0),(38630,1074,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(38631,1074,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(38632,1074,'tr','Hata ekleme Ã§alÄ±ÅŸan',0),(38633,1074,'pl','BÅ‚Ä…d dodawania pracownika',0),(38634,1074,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(38635,1074,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ù…Ù„Ø§Ø²Ù…',0),(38636,1074,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(38637,1074,'vi','ThÃªm nhÃ¢n viÃªn bá»‹ lá»—i',0),(38638,1074,'af','Fout met byvoeging van Werknemer',0),(38639,1074,'ro','Eroare adÄƒugarea angajat',0),(38640,1074,'et','TÃ¶Ã¶taja lisamisel tekkis viga',0),(38641,1074,'si','Napaka dodajanje zaposlenega',0),(38642,1074,'ba','Karyawan menambahkan kesalahan',0),(38643,1074,'nl','Fout toe te voegen werknemer',0),(38644,1074,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tyÃ¶ntekijÃ¤n',0),(38645,1074,'no','Feil Ã¥ legge til ansatte',0),(38646,1074,'da','Fejl tilfÃ¸je medarbejder',0),(38647,1074,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì§ì›',0),(38648,1074,'he','×”×¢×•×‘×“ ×”×•×¡×¤×ª ×”×©×’×™××”',0),(38649,1074,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ ÏƒÏ†Î¬Î»Î¼Î±',0),(38650,1074,'zh','é”™è¯¯ï¼šæ–°å¢žé›‡å‘˜',0),(38651,1074,'sv','Fel att lÃ¤gga till medarbetare',0),(38652,1074,'it','Dipendente aggiungendo errore',0),(38653,1074,'tl','',0),(38654,1074,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(38655,1074,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(38656,1074,'ms','Ralat menambah pekerja',0),(38657,1074,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…ÙˆØ¸Ù',0),(38658,1074,'fr','EmployÃ© ajout d\'erreur',0),(38659,1074,'jp','å¾“æ¥­å“¡ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38660,1074,'pt','Adicionando empregado erro',0),(38661,1074,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(38662,1074,'es','Error agregando empleado',0),(38663,1074,'de','Fehler hinzufÃ¼gen Mitarbeiter',0),(38664,1074,'en','Error adding employee',0),(38665,1075,'is','',0),(38666,1075,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(38667,1075,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(38668,1075,'tr','Hata ekleyerek personel inceleme.',0),(38669,1075,'pl','BÅ‚Ä…d dodawania pracownika przeglÄ…du.',0),(38670,1075,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´.',0),(38671,1075,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº Û”',0),(38672,1075,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ ÐºÑ€Ð¸Ñ‚Ð¸ÐºÐ°.',0),(38673,1075,'vi','ThÃªm Ä‘Ã¡nh giÃ¡ nhÃ¢n viÃªn bá»‹ lá»—i',0),(38674,1075,'af','Fout met byvoeging van Werknemer Oorsig.',0),(38675,1075,'ro','Eroare adÄƒugarea opinie angajat.',0),(38676,1075,'et','TÃ¶Ã¶taja iseloomustuse lisamisel tekkis viga',0),(38677,1075,'si','Napaka dodajanje zaposlenega pregled.',0),(38678,1075,'ba','Kesalahan menambahkan karyawan review.',0),(38679,1075,'nl','Fout toe te voegen werknemer beoordeling.',0),(38680,1075,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tyÃ¶ntekijÃ¤n uudelleen.',0),(38681,1075,'no','Feil Ã¥ legge medarbeider vurdering.',0),(38682,1075,'da','Fejl tilfÃ¸je medarbejder anmeldelse.',0),(38683,1075,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì§ì› ê²€í† .',0),(38684,1075,'he','×©×’×™××” ×”×•×¡×¤×ª ×¡×§×™×¨×” ×”×¢×•×‘×“.',0),(38685,1075,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ ÏƒÏ†Î¬Î»Î¼Î±.',0),(38686,1075,'zh','é”™è¯¯ï¼šæ–°å¢žé›‡å‘˜å®¡æŸ¥ã€‚',0),(38687,1075,'sv','Fel att lÃ¤gga till medarbetare Ã¶versyn.',0),(38688,1075,'it','Recensione di dipendente aggiungendo errore.',0),(38689,1075,'tl','',0),(38690,1075,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3607;&#3610;&#3607;&#3623;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3609;&#3633;&#3585;&#3',0),(38691,1075,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾à¥¤',0),(38692,1075,'ms','Ralat menambah pekerja kajian.',0),(38693,1075,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ù…ÙˆØ¸Ù.',0),(38694,1075,'fr','ApprÃ©ciation du erreur ajout.',0),(38695,1075,'jp','å¾“æ¥­å“¡ãƒ¬ãƒ“ãƒ¥ãƒ¼ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38696,1075,'pt','RevisÃ£o de empregado erro adicionando.',0),(38697,1075,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð·Ð¾Ñ€ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð².',0),(38698,1075,'es','Error agregando revisiÃ³n de empleado',0),(38699,1075,'de','Fehler HinzufÃ¼gen von Mitarbeiter-ÃœberprÃ¼fung.',0),(38700,1075,'en','Error adding employee review.',0),(38701,1076,'is','',0),(38702,1076,'dr','(Ø¨Ø±Ø´) Ù…Ø¬Ù…ÙˆØ¹ÙŠ',0),(38703,1076,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªØ®ÙÙŠÙ (Ø¨Ø±Ø´) ÙƒÙ„ÙŠ',0),(38704,1076,'tr','Genel kesme bilgisi eklenirken bir hata oluÅŸtu.',0),(38705,1076,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania informacji ogÃ³lnych ciÄ™cia.',0),(38706,1076,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¾Ð±Ñ‰Ð¸ Ñ€ÑÐ·Ð°Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(38707,1076,'ur','Ø¬Ù†Ø±Ù„ Ú©Ø§Ù¹Ù†Û’ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(38708,1076,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¾Ð¿ÑˆÑ‚Ðµ ÑÐµÑ‡ÐµÑšÐµ Ð¸Ð½Ñ„Ð¾.',0),(38709,1076,'vi','Lá»—i khi thÃªm thÃ´ng tin cáº¯t chung',0),(38710,1076,'af','Fout met skep van Algemene \"Cutting\" inligting.',0),(38711,1076,'ro','Eroare la adÄƒugarea informaÅ£ii generale de tÄƒiere.',0),(38712,1076,'et','Viga lisades Ã¼ldise lÃµikamine info.',0),(38713,1076,'si','Napaka pri dodajanju sploÅ¡na rezanje info.',0),(38714,1076,'ba','Kesalahan menambahkan info umum pemotongan.',0),(38715,1076,'nl','Fout bij het toevoegen van algemene snij info.',0),(38716,1076,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ yleinen leikkaus info.',0),(38717,1076,'no','Det oppstod en generell kutte info.',0),(38718,1076,'da','Fejl ved tilfÃ¸jelse af generelle skÃ¦ring info.',0),(38719,1076,'ko','ì¼ë°˜ ê°€ê³µ ì •ë³´ë¥¼ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(38720,1076,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×ž×™×“×¢ ×›×œ×œ×™ ×’×–×™×¨×”.',0),(38721,1076,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î³ÎµÎ½Î¹ÎºÎ­Ï‚ Ï„Î­Î¼Î½Î¿Ï…ÏƒÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚.',0),(38722,1076,'zh','é”™è¯¯æ·»åŠ ä¸€èˆ¬åˆ‡å‰²ä¿¡æ¯',0),(38723,1076,'sv','Fel att lÃ¤gga till allmÃ¤nna skÃ¤rning information.',0),(38724,1076,'it','Errore aggiungendo informazioni di taglio generale.',0),(38725,1076,'tl','',0),(38726,1076,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(38727,1076,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤Ÿà¤¨à¥‡ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(38728,1076,'ms','Ralat menambah maklumat am memotong.',0),(38729,1076,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª \"Ø¹Ø§Ù…Ø© Ø´Ø§Ù…Ù„Ø©\".',0),(38730,1076,'fr','Erreur lors de l\'ajout d\'informations gÃ©nÃ©rales coupe.',0),(38731,1076,'jp','ä¸€èˆ¬å€¤å¼•ã??æƒ…å ±ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38732,1076,'pt','Erro ao adicionar informaÃ§Ã£o de corte geral.',0),(38733,1076,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ð±Ñ‰Ð¸Ðµ Ñ€ÐµÐ·ÐºÐ¸.',0),(38734,1076,'es','Error agregando info general de corte ',0),(38735,1076,'de','Fehler beim HinzufÃ¼gen von allgemeinen schneiden-Info.',0),(38736,1076,'en','Error adding General Cutting info.',0),(38737,1077,'is','',0),(38738,1077,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¹Ù…ÙˆÙ…ÙŠ',0),(38739,1077,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¹Ù…ÙˆÙ…ÙŠ',0),(38740,1077,'tr','Genel iÅŸ tÃ¼rÃ¼nÃ¼ ekleme hatasÄ±',0),(38741,1077,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania ogÃ³lne pracy typu',0),(38742,1077,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²Ð¸Ð´ Ð¾Ð±Ñ‰Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(38743,1077,'ur','Ø¹Ù…ÙˆÙ…ÛŒ Ú©Ø§Ù… Ù‚Ø³Ù… Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(38744,1077,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð²Ñ€ÑÑ‚Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ñ€Ð°Ð´Ð°',0),(38745,1077,'vi','ThÃªm loáº¡i cÃ´ng viá»‡c chung bá»‹ lá»—i',0),(38746,1077,'af','Fout in byvoeging van algemene werktipe',0),(38747,1077,'ro','Eroare la adÄƒugarea lucrÄƒri generale tip',0),(38748,1077,'et','Viga lisades Ã¼ldise tÃ¶Ã¶ tÃ¼Ã¼p',0),(38749,1077,'si','Napaka pri dodajanju Vrsta sploÅ¡nega dela',0),(38750,1077,'ba','Menambahkan jenis pekerjaan umum kesalahan',0),(38751,1077,'nl','Foutbericht algemene werk type toe te voegen',0),(38752,1077,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ ehdot tyÃ¶n tyyppi',0),(38753,1077,'no','Feil under tillegging av generelle arbeidstype',0),(38754,1077,'da','Fejl ved tilfÃ¸jelse af generelle arbejdstype',0),(38755,1077,'ko','ì¼ë°˜ ìž‘ì—… ìœ í˜•ì„ ì¶”ê°€ ì˜¤ë¥˜',0),(38756,1077,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¡×•×’ ×¢×‘×•×“×” ×›×œ×œ×™',0),(38757,1077,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î³ÎµÎ½Î¹ÎºÎ­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Ï„ÏÏ€Î¿Ï…',0),(38758,1077,'zh','é”™è¯¯æ·»åŠ ä¸€èˆ¬å·¥ä½œç±»åž‹',0),(38759,1077,'sv','Fel att lÃ¤gga till allmÃ¤nt arbetstyp',0),(38760,1077,'it','Errore aggiungendo il tipo di lavoro generale',0),(38761,1077,'tl','',0),(38762,1077,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(38763,1077,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(38764,1077,'ms','Ralat menambah jenis kerja-kerja am',0),(38765,1077,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù…',0),(38766,1077,'fr','Erreur en ajoutant le type de travail gÃ©nÃ©rales',0),(38767,1077,'jp','ä¸€èˆ¬ä»•äº‹å†…å®¹ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38768,1077,'pt','Erro ao adicionar o tipo de trabalho geral',0),(38769,1077,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð³Ð¾ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(38770,1077,'es','Error agregando tipo general de trabajo',0),(38771,1077,'de','Fehler beim HinzufÃ¼gen des allgemeinen Arbeitstyp',0),(38772,1077,'en','Error adding general work type',0),(38773,1078,'is','',0),(38774,1078,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„',0),(38775,1078,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„',0),(38776,1078,'tr','GL pasta dilimi ayrÄ±ntÄ± ekleme hatasÄ±',0),(38777,1078,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania szczegÃ³Å‚owo kawaÅ‚ek pie GL',0),(38778,1078,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° GL ÐºÑ€ÑŠÐ³Ð¾Ð²Ð° Ð¿Ð°Ñ€Ñ‡Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(38779,1078,'ur','Ø¬ÛŒØ¬Û’ Ù¾Ø§Ø¦ÛŒ Ù‚Ø§Ø´ ØªÙØµÛŒÙ„ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(38780,1078,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð“Ð› Ð¿Ð¸Ñ‚Ñƒ Ð¸ÑÐµÑ‡Ð°Ðº Ð´ÐµÑ‚Ð°Ñ™',0),(38781,1078,'vi','ThÃªm chi tiáº¿t lÃ¡t cáº¯t á»‘ng bá»‹ lá»—i',0),(38782,1078,'af','Fout onstaan met skepping van AG Sirkeldiagram skyf detail',0),(38783,1078,'ro','Eroare la adÄƒugarea GL plÄƒcintÄƒ felie detaliu',0),(38784,1078,'et','Viga lisades GL pirukas viil detail',0),(38785,1078,'si','Napaka pri dodajanju GL pito rezine podrobnosti',0),(38786,1078,'ba','Kesalahan menambahkan GL pie slice detail',0),(38787,1078,'nl','Fout toe te voegen GL taart segment detail',0),(38788,1078,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ GL kakku siivu yksityiskohtaisesti',0),(38789,1078,'no','Feil under tillegging av GL pai skive detaljer',0),(38790,1078,'da','Fejl ved tilfÃ¸jelse af GL pie skive detaljer',0),(38791,1078,'ko','ì˜¤ë¥˜ GL íŒŒì´ ì¡°ê° ì„¸ë¶€ ì‚¬í•­ì„ ì¶”ê°€',0),(38792,1078,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¤×™×¨×•×˜ ×¤×¨×•×¡×ª ×¢×•×’×” GL',0),(38793,1078,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· GL Ï€Î¯Ï„Î± Ï†Î­Ï„Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(38794,1078,'zh','é”™è¯¯æ·»åŠ æ€»å¸é¥¼çŠ¶å›¾ä¸€å—çš„ç»†èŠ‚',0),(38795,1078,'sv','Fel att lÃ¤gga till GL paj slice detalj',0),(38796,1078,'it','Errore durante l\'aggiunta dettaglio fetta torta GL',0),(38797,1078,'tl','',0),(38798,1078,'th','Error adding GL pie slice detail',0),(38799,1078,'hi','à¤œà¥€à¤à¤² à¤ªà¤¾à¤‡ à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(38800,1078,'ms','Ralat menambah GL pai slice terperinci',0),(38801,1078,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„ØªÙØ§ØµÙŠÙ„ Ø´Ø±ÙŠØ­Ø© Ø§Ù„ØªØ®Ø·ÙŠØ· Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠ GL',0),(38802,1078,'fr','Erreur ajout GL tarte tranche en dÃ©tail',0),(38803,1078,'jp','GLãƒ‘ã‚¤ã‚¹ãƒ©ã‚¤ã‚¹è©³ç´°ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38804,1078,'pt','Erro ao adicionar detalhes de fatia de torta GL',0),(38805,1078,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ GL ÐºÑ€ÑƒÐ³Ð¾Ð²Ð¾Ð¹ ÑÑ€ÐµÐ· Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(38806,1078,'es','Error agregando LM detalle de rebanada de pastel',0),(38807,1078,'de','Fehler beim HinzufÃ¼gen des GL Kreis-Scheibe detail',0),(38808,1078,'en','Error adding GL pie slice detail',0),(38809,1079,'is','',0),(38810,1079,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ ',0),(38811,1079,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ ',0),(38812,1079,'tr','GL iÅŸlem ekleme hatasÄ±',0),(38813,1079,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania transakcji GL',0),(38814,1079,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(38815,1079,'ur','Ø¬ÛŒØ¬Û’ Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(38816,1079,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(38817,1079,'vi','ThÃªm giao dá»‹ch sá»• cÃ¡i bá»‹ lá»—i',0),(38818,1079,'af','Fout met byvoeging van AG transaksie',0),(38819,1079,'ro','Eroare la adÄƒugarea GL tranzacÅ£ie',0),(38820,1079,'et','Viga lisades GL tehingu',0),(38821,1079,'si','Napaka pri dodajanju GL transakcije',0),(38822,1079,'ba','Kesalahan menambahkan GL transaksi',0),(38823,1079,'nl','Fout toe te voegen GL transactie',0),(38824,1079,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ GL tapahtuman',0),(38825,1079,'no','Feil under tillegging av GL transaksjonen',0),(38826,1079,'da','Fejl ved tilfÃ¸jelse af GL transaktion',0),(38827,1079,'ko','ì˜¤ë¥˜ GL íŠ¸ëžœìž­ì…˜ ì¶”ê°€',0),(38828,1079,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×ª× ×•×¢×ª GL',0),(38829,1079,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· GL ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®',0),(38830,1079,'zh','é”™è¯¯æ·»åŠ æ€»å¸äº¤æ˜“',0),(38831,1079,'sv','Fel att lÃ¤gga till GL transaktion',0),(38832,1079,'it','Errore durante l\'aggiunta delle transazioni GL',0),(38833,1079,'tl','',0),(38834,1079,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(38835,1079,'hi','GL à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(38836,1079,'ms','Ralat menambah transaksi GL',0),(38837,1079,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª GL',0),(38838,1079,'fr','Erreur ajout d\'opÃ©ration GL',0),(38839,1079,'jp','GLå?–å¼•ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(38840,1079,'pt','Erro ao adicionar transaÃ§Ã£o GL',0),(38841,1079,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(38842,1079,'es','Error agregando transacciÃ³n de LM',0),(38843,1079,'de','Fehler beim HinzufÃ¼gen des GL-Transaktion',0),(38844,1079,'en','Error adding GL transaction',0),(38845,1080,'is','',0),(38846,1080,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ â€“ Ù„ØºÙˆ Ø«Ø¨Øª Ø¯ÙØªØ± ÙƒÙ„',0),(38847,1080,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ â€“ Ù„ØºÙˆ Ø«Ø¨Øª Ø¯ÙØªØ± ÙƒÙ„',0),(38848,1080,'tr','GL iÅŸlem ayrÄ±ntÄ±larÄ±nÄ± - ekleme hatasÄ± GL iptal girdisi',0),(38849,1080,'pl','BÅ‚Ä…d dodawania szczegÃ³Å‚Ã³w transakcji GL - GL zapis odwoÅ‚any',0),(38850,1080,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸ - GL Ð·Ð°Ð¿Ð¸Ñ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ',0),(38851,1080,'ur','Ø¬ÛŒØ¬Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª - Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(38852,1080,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð“Ð› - Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð°',0),(38853,1080,'vi','ThÃªm chi tiáº¿t giao dá»‹ch sá»• cÃ¡i bá»‹ lá»—i - Há»§y bÃºt toÃ¡n ',0),(38854,1080,'af','Fout met byvoeging van AG transaksie details - AG Inskrywing gekanselleer',0),(38855,1080,'ro','Eroare la adÄƒugarea detaliile tranzactiei GL - GL intrare anulate',0),(38856,1080,'et','Viga lisades GL tehingu Ã¼ksikasjad - GL kande tÃ¼histatud',0),(38857,1080,'si','Napaka pri dodajanju GL transakcija podrobnosti - GL vnos odpovedan',0),(38858,1080,'ba','Kesalahan menambahkan rincian transaksi GL - GL entri dibatalkan',0),(38859,1080,'nl','Fout toe te voegen GL transactiegegevens - GL post geannuleerd',0),(38860,1080,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ GL tapahtumatiedot - GL tapahtuma peruutetaan',0),(38861,1080,'no','Feil under tillegging av GL transaksjonsdetaljer - GL oppfÃ¸ring avbrutt',0),(38862,1080,'da','Fejl ved tilfÃ¸jelse af GL transaktionsdetaljer - GL post aflyst',0),(38863,1080,'ko','ì˜¤ë¥˜ GL íŠ¸ëžœìž­ì…˜ ì„¸ë¶€ ì‚¬í•­-ì¶”ê°€ GL í•­ëª© ì·¨ì†Œ',0),(38864,1080,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¤×¨×˜×™ ×”×¢×¡×§×” GL - ×›× ×™×¡×” GL ×‘×•×˜×œ×”',0),(38865,1080,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Ï‰Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Ï„Ï‰Î½ ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½ Ï„Î¿Ï… GL - GL ÎµÎ³Î³ÏÎ±Ï†Î® Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ',0),(38866,1080,'zh','é”™è¯¯æ·»åŠ å‰å°”çš„äº¤æ˜“ç»†èŠ‚-å‰å°”å–æ¶ˆå…¥å­¦',0),(38867,1080,'sv','Fel att lÃ¤gga till GL transaktionsdetaljer - GL transaktionen avbrÃ¶ts',0),(38868,1080,'it','Errore aggiungendo dettagli della transazione GL - GL voce cancellata',0),(38869,1080,'tl','',0),(38870,1080,'th','Error adding GL transaction details - GL Entry cancelled',0),(38871,1080,'hi','GL à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤µà¤¿à¤µà¤°à¤£ - à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿ GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤°à¤¦à¥à¤¦',0),(38872,1080,'ms','Ralat menambah butir-butir transaksi GL - kemasukan GL yang dibatalkan',0),(38873,1080,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª GL-Ø¯Ø®ÙˆÙ„ GL Ø§Ù„Ù…Ù„ØºØ§Ø©',0),(38874,1080,'fr','Erreur en ajoutant des dÃ©tails de transaction GL - GL entrÃ©e annulÃ©',0),(38875,1080,'jp','GLå?–å¼•è©³ç´°è¿½åŠ ã‚¨ãƒ©ãƒ¼ã€€ãƒ»GLè¨˜å¸³ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(38876,1080,'pt','Erro ao adicionar detalhes de transaÃ§Ã£o GL - GL entrada cancelado',0),(38877,1080,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð´ÐµÑ‚Ð°Ð»Ð¸ ÑÐ´ÐµÐ»ÐºÐ¸ GL - GL Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(38878,1080,'es','Error agregando detalles de transacciÃ³n de LM - Entrada de LM cancelada',0),(38879,1080,'de','Fehler beim HinzufÃ¼gen von Transaktionsdetails GL - GL-Eintrag abgesagt',0),(38880,1080,'en','Error adding GL transaction details - GL Entry cancelled',0),(38881,1081,'is','',0),(38882,1081,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ â€“ Ù„ØºÙˆ Ø«Ø¨Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(38883,1081,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ â€“ Ù„ØºÙˆ Ø«Ø¨Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(38884,1081,'tr','GL iÅŸlem ayrÄ±ntÄ±larÄ±nÄ± - fatura giriÅŸi iptal ekleme hatasÄ±',0),(38885,1081,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania szczegÃ³Å‚Ã³w transakcji GL - BILL zapis odwoÅ‚any',0),(38886,1081,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸ - Ð±Ð¸Ð» Ð—ÐÐŸÐ˜Ð¡ÐªÐ¢ ÐžÐ¢ÐœÐ•ÐÐ•Ð',0),(38887,1081,'ur','Ø¬ÛŒØ¬Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª - Ø¨Ù„ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ù†Ø³ÙˆØ® Ù†ÛÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø±ØªØ§ ÛÙˆØ§ Ù†Ù‚Øµ',0),(38888,1081,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ñƒ Ð“Ð› - Ð‘Ð¸Ð» ÑÑ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð°',0),(38889,1081,'vi','ThÃªm CÃ¡c Giao Dá»‹ch Chi Tiáº¿t Cá»§a Sá»• CÃ¡i bá»‹ lá»—i - HÃ³a ÄÆ¡n Nháº­p vÃ o sáº½ bá»‹ há»§y',0),(38890,1081,'af','Fout met byvoeging van AG transaksie details - GEFAKTUREERDE INSKRYWING GEKANSELEER',0),(38891,1081,'ro','Eroare la adÄƒugarea detaliile tranzactiei GL - BILL intrare anulat',0),(38892,1081,'et','Viga lisades GL tehingu Ã¼ksikasjad - arve KANDE tÃ¼histatud',0),(38893,1081,'si','Napaka pri dodajanju GL transakcija podrobnosti - BILL vnos ODPOVEDAN',0),(38894,1081,'ba','Kesalahan menambahkan rincian transaksi GL - BILL entri dibatalkan',0),(38895,1081,'nl','Fout toe te voegen GL transactiegegevens - BILL post geannuleerd',0),(38896,1081,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ GL tapahtumatiedot - BILL tapahtuma peruutettu',0),(38897,1081,'no','Feil under tillegging av GL transaksjonsdetaljer - BILL oppfÃ¸ring avbrutt',0),(38898,1081,'da','Fejl ved tilfÃ¸jelse af GL transaktionsdetaljer - BILL post annulleret',0),(38899,1081,'ko','GL íŠ¸ëžœìž­ì…˜ ì„¸ë¶€ ì‚¬í•­ì„-ë¹Œ í•­ëª© ì·¨ì†Œ ì¶”ê°€ ì˜¤ë¥˜',0),(38900,1081,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¤×¨×˜×™ ×”×¢×¡×§×” GL - ×‘×™×œ ×›× ×™×¡×” ×‘×•×˜×œ×”',0),(38901,1081,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Ï‰Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Ï„Ï‰Î½ ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½ Ï„Î¿Ï… GL - BILL ÎµÎ³Î³ÏÎ±Ï†Î® Î‘ÎšÎ¥Î¡ÎÎ˜Î—ÎšÎ•',0),(38902,1081,'zh','é”™è¯¯æ·»åŠ æ€»å¸çš„äº¤æ˜“ç»†èŠ‚- å¸å•æ¡ç›®è¢«æ’¤é”€',0),(38903,1081,'sv','Fel att lÃ¤gga till GL transaktionsdetaljer - BILL transaktionen AVBRÃ–TS',0),(38904,1081,'it','Errore aggiungendo dettagli della transazione GL - BILL entrata annullato',0),(38905,1081,'tl','',0),(38906,1081,'th','Error adding GL transaction details - BILL ENTRY CANCELLED',0),(38907,1081,'hi','GL à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤µà¤¿à¤µà¤°à¤£ - à¤¬à¤¿à¤² à¤°à¤¦à¥à¤¦ à¤•à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(38908,1081,'ms','Ralat menambah butir-butir transaksi GL - Rang undang-undang penyertaan dibatalkan',0),(38909,1081,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª GL-\"Ø¥Ù„ØºØ§Ø¡ Ø¯Ø®ÙˆÙ„ Ø¨ÙŠÙ„\"',0),(38910,1081,'fr','Erreur en ajoutant des dÃ©tails de transaction des GL - BILL entrÃ©e annulÃ©',0),(38911,1081,'jp','GLå?–å¼•è©³ç´°è¿½åŠ ã‚¨ãƒ©ãƒ¼ãƒ»è«‹æ±‚æ›¸è¨˜å¸³ã?Œã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(38912,1081,'pt','Erro ao adicionar detalhes de transaÃ§Ã£o GL - BILL entrada cancelado',0),(38913,1081,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð´ÐµÑ‚Ð°Ð»Ð¸ ÑÐ´ÐµÐ»ÐºÐ¸ GL - Ð‘Ð¸Ð»Ð» Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(38914,1081,'es','Error agregando detalles de transacciÃ³n de LM - ENTRADA DE RECIBOS CANCELADA',0),(38915,1081,'de','Fehler beim HinzufÃ¼gen des GL Transaktionsdetails - BILL Eintrag abgebrochen',0),(38916,1081,'en','Error adding GL transaction details - BILL ENTRY CANCELED',0),(38917,1082,'is','',0),(38918,1082,'dr','- Ú†Ùƒ Ù…Ø§Ù„ÙŠØ§Øª Ø³Ù¾Ø±Ø¯Ù‡ ',0),(38919,1082,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ  Ø¯ÙØªØ± ÙƒÙ„- Ú†Ùƒ Ù…Ø§Ù„ÙŠØ§Øª Ø³Ù¾Ø±Ø¯Ù‡ ',0),(38920,1082,'tr','GL transvoucher kaydÄ± - vergi Ã¶deme onay ekleme hatasÄ±',0),(38921,1082,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania rekordu transvoucher GL - wyboru wpÅ‚aty podatku',0),(38922,1082,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° GL transvoucher Ñ€ÐµÐºÐ¾Ñ€Ð´ - Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ‡ÐµÐº',0),(38923,1082,'ur','Ø¬ÛŒØ¬Û’ Ù¹Ø±Ø§Ù†Ø³ÙˆØ§Ú†Ø± Ø±ÛŒÚ©Ø§Ø±Úˆ - Ù¹ÛŒÚ©Ø³ Ø¬Ù…Ø¹ Ú†ÛŒÚ© Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(38924,1082,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ²Ð¾ÑƒÑ†Ñ…ÐµÑ€ Ð·Ð°Ð¿Ð¸Ñ - Ð¿Ð¾Ñ€ÐµÐ· Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(38925,1082,'vi','ThÃªm há»“ sÆ¡ phiáº¿u chuyá»ƒn sá»• cÃ¡i bá»‹ lá»—i - SÃ©c ná»™p thuáº¿',0),(38926,1082,'af','Fout met skepping van AG transbewysstuk rekord - Belasting deposito tjek',0),(38927,1082,'ro','Eroare la adÄƒugarea GL transvoucher record - taxa depozit a verifica',0),(38928,1082,'et','Viga lisades GL transvoucher rekord - maksu tagatisraha sisse',0),(38929,1082,'si','Napaka pri dodajanju GL transvoucher zapis - davek vloga Äek',0),(38930,1082,'ba','Kesalahan menambahkan GL transvoucher catatan - check setoran pajak',0),(38931,1082,'nl','Fout GL transvoucher record - belasting storting selectievakje toe te voegen',0),(38932,1082,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ GL transvoucher record - vero Internet LAN',0),(38933,1082,'no','Feil under tillegging av GL transvoucher post - skatt innskudd sjekk',0),(38934,1082,'da','Fejl ved tilfÃ¸jelse af GL transvoucher post - skat depositum check',0),(38935,1082,'ko','ì˜¤ë¥˜ GL transvoucher ë ˆì½”ë“œ-ì„¸ê¸ˆ ìž…ê¸ˆ í‘œ ì¶”ê°€',0),(38936,1082,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¨×©×•×ž×” transvoucher GL - ×ž×¡ ×”×¤×™×§×“×•×Ÿ',0),(38937,1082,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· GL transvoucher ÏÎµÎºÏŒÏ - Ï†ÏŒÏÎ¿Ï… ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Ï‡Ï‰',0),(38938,1082,'zh','é”™è¯¯æ·»åŠ å‰å°”ååˆ¸çºªå½•- ç¨ŽåŠ¡æ”¯ç¥¨å­˜æ¬¾',0),(38939,1082,'sv','Fel att lÃ¤gga till GL transvoucher post - skatt insÃ¤ttning kontroll',0),(38940,1082,'it','Errore aggiungendo GL transvoucher record - controllo deposito fiscale',0),(38941,1082,'tl','',0),(38942,1082,'th','Error adding GL transvoucher record - Tax deposit check',0),(38943,1082,'hi','à¤œà¥€à¤à¤² transvoucher à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ - à¤Ÿà¥ˆà¤•à¥à¤¸ à¤œà¤®à¤¾ à¤šà¥‡à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(38944,1082,'ms','Ralat menambah rekod transvoucher GL - semak deposit cukai',0),(38945,1082,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø³Ø¬Ù„ ØªØ±Ø§Ù†Ø³ÙÙˆØªØ´ÙŠØ± GL-Ø¶Ø±ÙŠØ¨Ø© Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(38946,1082,'fr','Erreur ajout GL transvoucher fiche - chÃ¨que de dÃ©pÃ´t de taxe',0),(38947,1082,'jp','GLå?–å¼•ä¼?ç¥¨è¨˜éŒ²ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼/é ?é‡‘å°?åˆ‡æ‰‹ã?¸ã?®èª²ç¨Ž',0),(38948,1082,'pt','Erro ao adicionar o registro de transvoucher GL - seleÃ§Ã£o de depÃ³sito fiscal',0),(38949,1082,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ GL transvoucher Ð·Ð°Ð¿Ð¸ÑÐ¸ - Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð³Ð¾ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(38950,1082,'es','Error agregando LM record de transvoucher - Cheque de depÃ³sito de Impuesto',0),(38951,1082,'de','Fehler beim HinzufÃ¼gen des GL Transvoucher Rekord - Kaution Steuercheck',0),(38952,1082,'en','Error adding GL transvoucher record - Tax deposit check',0),(38953,1083,'is','',0),(38954,1083,'dr','- ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(38955,1083,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ  Ø¯ÙØªØ± ÙƒÙ„- ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(38956,1083,'tr','GL transvoucher kaydÄ± - fatura giriÅŸi iptal ekleme hatasÄ±',0),(38957,1083,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania rekordu transvoucher GL - BILL zapis odwoÅ‚any',0),(38958,1083,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° GL transvoucher Ñ€ÐµÐºÐ¾Ñ€Ð´ - Ð±Ð¸Ð» ÐžÐ¢ÐœÐ•ÐÐ•Ð Ð·Ð°Ð¿Ð¸Ñ',0),(38959,1083,'ur','Ø¬ÛŒØ¬Û’ Ù¹Ø±Ø§Ù†Ø³ÙˆØ§Ú†Ø± Ø±ÛŒÚ©Ø§Ø±Úˆ - Ø¨Ù„ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(38960,1083,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ²Ð¾ÑƒÑ†Ñ…ÐµÑ€ Ð·Ð°Ð¿Ð¸Ñ - Ð‘Ð¸Ð» ÑÑ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð°',0),(38961,1083,'vi','ThÃªm CÃ¡c Giao Dá»‹ch Theo Phiáº¿u Cá»§a Sá»• CÃ¡i bá»‹ lá»—i - HÃ³a ÄÆ¡n Nháº­p vÃ o sáº½ bá»‹ há»§y',0),(38962,1083,'af','Fout met skepping van AG transbewysstuk vaslÃªgging - GEFAKTUREERDE INSKRYWING GEKANSELLEER',0),(38963,1083,'ro','Eroare la adÄƒugarea GL transvoucher record - BILL intrare anulate',0),(38964,1083,'et','Viga lisades GL transvoucher rekord - arve KANDE tÃ¼histatud',0),(38965,1083,'si','Napaka pri dodajanju GL transvoucher zapis - BILL vnos ODPOVEDAN',0),(38966,1083,'ba','Kesalahan menambahkan catatan transvoucher GL - BILL entri dibatalkan',0),(38967,1083,'nl','Fout GL transvoucher record - BILL post geannuleerd toe te voegen',0),(38968,1083,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ GL transvoucher record - BILL tapahtuma peruutetaan',0),(38969,1083,'no','Feil under tillegging av GL transvoucher posten - BILL oppfÃ¸ring avbrutt',0),(38970,1083,'da','Fejl ved tilfÃ¸jelse af GL transvoucher post - BILL post aflyst',0),(38971,1083,'ko','ì˜¤ë¥˜ GL transvoucher ë ˆì½”ë“œ-ë¹Œ í•­ëª© ì·¨ì†Œ ì¶”ê°€',0),(38972,1083,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¨×©×•×ž×” transvoucher GL - ×‘×™×œ ×‘×™×˜×œ ×›× ×™×¡×”',0),(38973,1083,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· GL transvoucher ÏÎµÎºÏŒÏ - BILL ÎµÎ³Î³ÏÎ±Ï†Î® Î‘ÎšÎ¥Î¡ÎÎ˜Î—ÎšÎ•',0),(38974,1083,'zh','é”™è¯¯æ·»åŠ æ€»å¸ç›¸äº’ä»˜æ¬¾å‡­è¯ -å¸å•æ¡ç›®è¢«æ’¤é”€',0),(38975,1083,'sv','Fel att lÃ¤gga till GL transvoucher post - BILL transaktionen AVBRÃ–TS',0),(38976,1083,'it','Errore aggiungendo GL transvoucher record - BILL voce cancellata',0),(38977,1083,'tl','',0),(38978,1083,'th','Error adding GL transvoucher record - BILL ENTRY CANCELLED',0),(38979,1083,'hi','à¤œà¥€à¤à¤² transvoucher à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ - à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤°à¤¦à¥à¤¦ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(38980,1083,'ms','Ralat menambah rekod transvoucher GL - Rang undang-undang penyertaan dibatalkan',0),(38981,1083,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø³Ø¬Ù„ ØªØ±Ø§Ù†Ø³ÙÙˆØªØ´ÙŠØ± GL-\"Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„\"',0),(38982,1083,'fr','Erreur en ajoutant le dossier transvoucher GL - BILL entrÃ©e annulÃ©',0),(38983,1083,'jp','Error adding GL transvoucher record - BILL ENTRY CANCELLED',0),(38984,1083,'pt','Erro ao adicionar o registro de transvoucher GL - BILL entrada cancelado',0),(38985,1083,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ GL transvoucher Ð·Ð°Ð¿Ð¸ÑÑŒ - Ð‘Ð¸Ð»Ð» Ð·Ð°Ð¿Ð¸ÑÑŒ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€ÑƒÐµÑ‚ÑÑ',0),(38986,1083,'es','Error agregando LM record de transvoucher - ENTRADA DE RECIBO CANCELADA',0),(38987,1083,'de','Fehler beim HinzufÃ¼gen des GL Transvoucher Record - BILL Eintrag abgesagt',0),(38988,1083,'en','Error adding GL transvoucher record - BILL ENTRY CANCELLED',0),(38989,1084,'is','',0),(38990,1084,'dr','- ÙƒØ§Ø±Ù…Ù†Ø¯',0),(38991,1084,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ  Ø¯ÙØªØ± ÙƒÙ„- ÙƒØ§Ø±Ù…Ù†Ø¯',0),(38992,1084,'tr','GL transvoucher kaydÄ± - Ã§alÄ±ÅŸan eklenirken bir hata oluÅŸtu:',0),(38993,1084,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania rekordu transvoucher GL - pracownik:',0),(38994,1084,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° GL transvoucher Ñ€ÐµÐºÐ¾Ñ€Ð´ - Ð¡Ð›Ð£Ð–Ð˜Ð¢Ð•Ð›:',0),(38995,1084,'ur','Ø¬ÛŒØ¬Û’ Ù¹Ø±Ø§Ù†Ø³ÙˆØ§Ú†Ø± Ø±ÛŒÚ©Ø§Ø±Úˆ - Ù…Ù„Ø§Ø²Ù… Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ:',0),(38996,1084,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ²Ð¾ÑƒÑ†Ñ…ÐµÑ€ Ð·Ð°Ð¿Ð¸Ñ - Ð—ÐÐŸÐžÐ¡Ð›Ð•ÐÐžÐ“:',0),(38997,1084,'vi','ThÃªm phiáº¿u chuyá»ƒn sá»• cÃ¡i bá»‹ lá»—i - NhÃ¢n viÃªn',0),(38998,1084,'af','Fout met skepping van AG transbewysstuk vaslÃªgging - WERKNEMER:',0),(38999,1084,'ro','Eroare la adÄƒugarea GL transvoucher record - angajat:',0),(39000,1084,'et','Viga lisades GL transvoucher rekord - tÃ¶Ã¶taja:',0),(39001,1084,'si','Napaka pri dodajanju GL transvoucher zapis - delavec:',0),(39002,1084,'ba','Kesalahan menambahkan GL transvoucher catatan - karyawan:',0),(39003,1084,'nl','Fout GL transvoucher record - werknemer toe te voegen:',0),(39004,1084,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ GL transvoucher record - tyÃ¶ntekijÃ¤:',0),(39005,1084,'no','Feil under tillegging av GL transvoucher posten - ansatt:',0),(39006,1084,'da','Fejl ved tilfÃ¸jelse af GL transvoucher post - medarbejder:',0),(39007,1084,'ko','ì˜¤ë¥˜ GL transvoucher ë ˆì½”ë“œ-ì§ì› ì¶”ê°€:',0),(39008,1084,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¨×©×•×ž×” transvoucher GL - ×”×¢×•×‘×“:',0),(39009,1084,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· GL transvoucher ÏÎµÎºÏŒÏ - Î¥Î Î†Î›Î›Î—Î›ÎŸÎ£:',0),(39010,1084,'zh','é”™è¯¯æ·»åŠ å‰å°”ååˆ¸è®°å½• -å‘˜å·¥ï¼š',0),(39011,1084,'sv','Fel att lÃ¤gga till GL transvoucher post - MEDARBETAREN:',0),(39012,1084,'it','Errore aggiungendo GL transvoucher record - dipendente:',0),(39013,1084,'tl','',0),(39014,1084,'th','Error adding GL transvoucher record - EMPLOYEE:',0),(39015,1084,'hi','à¤œà¥€à¤à¤² transvoucher à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ - à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿:',0),(39016,1084,'ms','Ralat menambah rekod transvoucher GL - pekerja:',0),(39017,1084,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø³Ø¬Ù„ ØªØ±Ø§Ù†Ø³ÙÙˆØªØ´ÙŠØ± GL-Ø§Ù„Ù…ÙˆØ¸Ù:',0),(39018,1084,'fr','Erreur ajout GL transvoucher fiche - employÃ© :',0),(39019,1084,'jp','GLå?–å¼•ä¼?ç¥¨è¨˜éŒ²ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼/å¾“æ¥­å“¡',0),(39020,1084,'pt','Erro ao adicionar o registro de transvoucher GL - empregado:',0),(39021,1084,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ GL transvoucher Ñ€ÐµÐºÐ¾Ñ€Ð´ - Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°:',0),(39022,1084,'es','Error agregando LM record de transvoucher - EMPLEADO',0),(39023,1084,'de','Fehler beim HinzufÃ¼gen des GL Transvoucher Record - Mitarbeiter:',0),(39024,1084,'en','Error adding GL transvoucher record - EMPLOYEE:',0),(39025,1085,'is','',0),(39026,1085,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(39027,1085,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(39028,1085,'tr','Hata ekleme GL fiÅŸ',0),(39029,1085,'pl','BÅ‚Ä…d dodawania zaÅ‚Ä…cznikÃ³w GL',0),(39030,1085,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ GL Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(39031,1085,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø¬ÛŒØ¬Û’ ÙˆØ§Ø¤Ú†Ø±',0),(39032,1085,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð“Ð› Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(39033,1085,'vi','ThÃªm phiáº¿u sá»• cÃ¡i bá»‹ lá»—i',0),(39034,1085,'af','Fout met skepping van AG bewysstuk',0),(39035,1085,'ro','Eroare adÄƒugarea GL voucher',0),(39036,1085,'et','Viga lisades GL kanne',0),(39037,1085,'si','Napaka dodajanje GL kupon',0),(39038,1085,'ba','Kesalahan menambahkan GL voucher',0),(39039,1085,'nl','Fout toe te voegen GL voucher',0),(39040,1085,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ GL tosite',0),(39041,1085,'no','Feil Ã¥ legge GL bilag',0),(39042,1085,'da','Fejl tilfÃ¸je GL voucher',0),(39043,1085,'ko','ì˜¤ë¥˜ ì¶”ê°€ GL ë°”ìš°ì²˜',0),(39044,1085,'he','×©×•×‘×¨ GL ×”×•×¡×¤×ª ×”×©×’×™××”',0),(39045,1085,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· GL ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(39046,1085,'zh','é”™è¯¯æ·»åŠ æ€»å¸ä»˜æ¬¾å‡­è¯',0),(39047,1085,'sv','Fel att lÃ¤gga till GL verifikation',0),(39048,1085,'it','Voucher di errore aggiungendo GL',0),(39049,1085,'tl','',0),(39050,1085,'th','Error adding GL voucher',0),(39051,1085,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ GL à¤µà¤¾à¤‰à¤šà¤°',0),(39052,1085,'ms','Ralat menambah GL baucer',0),(39053,1085,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù‚ÙŠØ¯ Ø£Ø³ØªØ§Ø° Ø¹Ø§Ù…',0),(39054,1085,'fr','Bon GL ajout d\'erreur',0),(39055,1085,'jp','GLä¼?ç¥¨ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39056,1085,'pt','Comprovante GL erro adicionando',0),(39057,1085,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ GL Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(39058,1085,'es','Error agregando LM voucher',0),(39059,1085,'de','Fehler hinzufÃ¼gen GL Gutschein',0),(39060,1085,'en','Error adding GL voucher',0),(39061,1086,'is','',0),(39062,1086,'dr','- Ø«Ø¨Øª Ù„ÛŒØ¬Ø± Ù„ØºÙˆ Ø´Ø¯ ',0),(39063,1086,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ  Ø¯ÙØªØ± ÙƒÙ„- Ø«Ø¨Øª Ø¯ÙØªØ± ÙƒÙ„ Ù„ØºÙˆ Ø´Ø¯ ',0),(39064,1086,'tr','Ä°ptal gltransvoucher kaydÄ± - GL girdisini ekleme hatasÄ±',0),(39065,1086,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania rekordu gltransvoucher - GL zapis odwoÅ‚any',0),(39066,1086,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° gltransvoucher Ð·Ð°Ð¿Ð¸Ñ - GL Ð·Ð°Ð¿Ð¸Ñ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ',0),(39067,1086,'ur','Ú¯Ù„Ù¹Ø±Ø§Ù†Ø³ÙˆØ§Ú†Ø± Ø±ÛŒÚ©Ø§Ø±Úˆ - Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(39068,1086,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð³Ð»Ñ‚Ñ€Ð°Ð½ÑÐ²Ð¾ÑƒÑ†Ñ…ÐµÑ€ Ð·Ð°Ð¿Ð¸Ñ - Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð°',0),(39069,1086,'vi','ThÃªm phiáº¿u chuyá»ƒn sá»• cÃ¡i bá»‹ lá»—i - Há»§y bÃºt toÃ¡n ',0),(39070,1086,'af','Fout met skepping van AG transbewysstuk vaslÃªgging - AG inskrywing gekanselleer',0),(39071,1086,'ro','Eroare la adÄƒugarea gltransvoucher record - GL intrare anulate',0),(39072,1086,'et','Viga lisades gltransvoucher kirjele - GL kande tÃ¼histatud',0),(39073,1086,'si','Napaka pri dodajanju gltransvoucher zapis - GL vnos odpovedan',0),(39074,1086,'ba','Kesalahan menambahkan gltransvoucher catatan - catatan GL dibatalkan',0),(39075,1086,'nl','Fout gltransvoucher record - GL vermelding toe te voegen geannuleerd',0),(39076,1086,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ gltransvoucher record - GL tapahtuma peruutetaan',0),(39077,1086,'no','Feil under tillegging av gltransvoucher posten - GL oppfÃ¸ring avbrutt',0),(39078,1086,'da','Fejl ved tilfÃ¸jelse af gltransvoucher post - GL post aflyst',0),(39079,1086,'ko','Gltransvoucher ë ˆì½”ë“œ-GL í•­ëª© ì¶”ê°€ ì˜¤ë¥˜ ì·¨ì†Œ',0),(39080,1086,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¨×©×•×ž×” gltransvoucher - ×›× ×™×¡×” GL ×‘×•×˜×œ',0),(39081,1086,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· gltransvoucher ÏÎµÎºÏŒÏ - GL ÎµÎ³Î³ÏÎ±Ï†Î® Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ',0),(39082,1086,'zh','é”™è¯¯ï¼šæ–°å¢žåŒ–éªŒç¤¼åˆ¸çºªå½•å­¦',0),(39083,1086,'sv','Fel att lÃ¤gga till gltransvoucher post - GL transaktionen avbrÃ¶ts',0),(39084,1086,'it','Errore durante l\'aggiunta gltransvoucher record - GL voce cancellata',0),(39085,1086,'tl','',0),(39086,1086,'th','Error adding gltransvoucher record - GL Entry cancelled',0),(39087,1086,'hi','à¤°à¤¦à¥à¤¦à¤•à¤°à¤£ gltransvoucher à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ - GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(39088,1086,'ms','Ralat menambah rekod gltransvoucher - kemasukan GL yang dibatalkan',0),(39089,1086,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø³Ø¬Ù„ Ø¬Ù„ØªØ±Ø§Ù†Ø³ÙÙˆØªØ´ÙŠØ±-Ø¯Ø®ÙˆÙ„ GL Ø§Ù„Ù…Ù„ØºØ§Ø©',0),(39090,1086,'fr','Erreur ajout d\'enregistrement gltransvoucher - GL entrÃ©e annulÃ©',0),(39091,1086,'jp','GLå?–å¼•ä¼?ç¥¨è¨˜éŒ²ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼/GLã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?Œã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(39092,1086,'pt','Erro ao adicionar o registro de gltransvoucher - GL entrada cancelado',0),(39093,1086,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ gltransvoucher Ð·Ð°Ð¿Ð¸ÑÑŒ - Ð·Ð°Ð¿Ð¸ÑÑŒ GL Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½',0),(39094,1086,'es','Error agregando LM record de transvoucher - Entrada de LM cancelado',0),(39095,1086,'de','Fehler beim HinzufÃ¼gen des Gltransvoucher Record - GL-Eintrag abgesagt',0),(39096,1086,'en','Error adding gltransvoucher record - GL Entry cancelled',0),(39097,1087,'is','',0),(39098,1087,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠÙ†Ùƒ',0),(39099,1087,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠÙ†Ùƒ',0),(39100,1087,'tr','MÃ¼rekkep eklenirken bir hata oluÅŸtu.',0),(39101,1087,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania atramentu.',0),(39102,1087,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾.',0),(39103,1087,'ur','Ø§Ù†Ú© Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(39104,1087,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾.',0),(39105,1087,'vi','ThÃªm má»±c bá»‹ lá»—i',0),(39106,1087,'af','Fout voeg ink.',0),(39107,1087,'ro','Eroare la adÄƒugarea de cernealÄƒ.',0),(39108,1087,'et','Viga lisades tinti.',0),(39109,1087,'si','Napaka pri dodajanju Ärnila.',0),(39110,1087,'ba','Kesalahan menambahkan tinta.',0),(39111,1087,'nl','Fout bij het toevoegen van inkt.',0),(39112,1087,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ muste.',0),(39113,1087,'no','Feil under tillegging av blekk.',0),(39114,1087,'da','Fejl ved tilfÃ¸jelse af blÃ¦k.',0),(39115,1087,'ko','ìž‰í¬ë¥¼ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(39116,1087,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×“×™×•.',0),(39117,1087,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼ÎµÎ»Î¬Î½Î¹.',0),(39118,1087,'zh','é”™è¯¯æ·»åŠ å¢¨æ°´',0),(39119,1087,'sv','Fel att lÃ¤gga till pennanteckningar.',0),(39120,1087,'it','Errore durante l\'aggiunta dell\'inchiostro.',0),(39121,1087,'tl','',0),(39122,1087,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3638;&#3585;',0),(39123,1087,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(39124,1087,'ms','Ralat menambah dakwat.',0),(39125,1087,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø­Ø¨Ø±.',0),(39126,1087,'fr','Erreur lors de l\'ajout d\'encre.',0),(39127,1087,'jp','ã‚¤ãƒ³ã‚¯ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39128,1087,'pt','Erro ao adicionar a tinta.',0),(39129,1087,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ‡ÐµÑ€Ð½Ð¸Ð».',0),(39130,1087,'es','Error agregando tinta',0),(39131,1087,'de','Fehler beim HinzufÃ¼gen von Tinte.',0),(39132,1087,'en','Error adding ink.',0),(39133,1088,'is','',0),(39134,1088,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù„ÙŠÙ†Ùƒ ',0),(39135,1088,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù„ÙŠÙ†Ùƒ ',0),(39136,1088,'tr','Hata ekleyerek mÃ¼rekkep haberdar etmek.',0),(39137,1088,'pl','BÅ‚Ä…d dodawania informacji atramentu.',0),(39138,1088,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(39139,1088,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø§Ù†Ú© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ÛÛŒÚº Û”',0),(39140,1088,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿ÐµÑ€Ð¾Ð¼ ÑÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°Ð¼Ð°.',0),(39141,1088,'vi','Lá»—i khi thÃªm thÃ´ng tin má»±c',0),(39142,1088,'af','Fout met skepping van ink inligting.',0),(39143,1088,'ro','Eroare adÄƒugarea cernealÄƒ info.',0),(39144,1088,'et','Viga lisades tindi info.',0),(39145,1088,'si','Napaka dodajanje Ärnilo info.',0),(39146,1088,'ba','Kesalahan menambahkan tinta info.',0),(39147,1088,'nl','Fout toe te voegen inkt info.',0),(39148,1088,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ muste info.',0),(39149,1088,'no','Feil Ã¥ legge til blekk info.',0),(39150,1088,'da','Fejl tilfÃ¸je blÃ¦k info.',0),(39151,1088,'ko','ì˜¤ë¥˜ ì¶”ê°€ ìž‰í¬ ì •ë³´.',0),(39152,1088,'he','×©×’×™××” ×”×•×¡×¤×ª ×¤×¨×˜×™ ×“×™×•.',0),(39153,1088,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼ÎµÎ»Î¬Î½Î¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(39154,1088,'zh','é”™è¯¯æ·»åŠ å¢¨æ°´ä¿¡æ¯ã€‚\r\n',0),(39155,1088,'sv','Fel att lÃ¤gga till pennanteckningar info.',0),(39156,1088,'it','Informazioni di inchiostro aggiungendo errore.',0),(39157,1088,'tl','',0),(39158,1088,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3627;&#3617;&#3638;&#3585;',0),(39159,1088,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€à¥¤',0),(39160,1088,'ms','Ralat menambah info dakwat.',0),(39161,1088,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø­Ø¨Ø±.',0),(39162,1088,'fr','Info encre ajoutant par erreur.',0),(39163,1088,'jp','ã‚¤ãƒ³ã‚¯æƒ…å ±ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39164,1088,'pt','Adicionando informaÃ§Ã£o de tinta erro.',0),(39165,1088,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÐºÑ€Ð°ÑÐºÐ¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(39166,1088,'es','Error agregando info de tinta',0),(39167,1088,'de','HinzufÃ¼gen von Tinte StÃ¶rungsinfo.',0),(39168,1088,'en','Error adding ink info.',0),(39169,1089,'is','',0),(39170,1089,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(39171,1089,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(39172,1089,'tr','Hata ekleme stok konumu',0),(39173,1089,'pl','BÅ‚Ä…d dodawania lokalizacji zapasÃ³w',0),(39174,1089,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¼ÑÑÑ‚Ð¾ Ð·Ð° ÑÐºÐ»Ð°Ð´',0),(39175,1089,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(39176,1089,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(39177,1089,'vi','ThÃªm Äá»‹a Äiá»ƒm HÃ ng hÃ³a Bá»‹ Lá»—i',0),(39178,1089,'af','Fout met byvoeging van item ligging',0),(39179,1089,'ro','Eroare adÄƒugarea inventar locaÅ£ie',0),(39180,1089,'et','Viga lisades varude asukoha',0),(39181,1089,'si','Napaka pri dodajanju lokacijo zaloge',0),(39182,1089,'ba','Kesalahan menambahkan persediaan lokasi',0),(39183,1089,'nl','Fout voorraadvestiging toevoegen',0),(39184,1089,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ varaston sijainti',0),(39185,1089,'no','Feil Ã¥ legge lagerlokasjon',0),(39186,1089,'da','Fejl tilfÃ¸je lagerlokation',0),(39187,1089,'ko','ì˜¤ë¥˜ ì¶”ê°€ ìž¬ê³  ìœ„ì¹˜',0),(39188,1089,'he','×ž×™×§×•× ×”×ž×œ××™ ×”×•×¡×¤×ª ×©×’×™××ª',0),(39189,1089,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(39190,1089,'zh','é”™è¯¯ï¼šæ–°å¢žåº“å­˜ä½ç½®',0),(39191,1089,'sv','Fel att lÃ¤gga lagerstÃ¤lle',0),(39192,1089,'it','Ubicazione di inventario aggiungendo errore',0),(39193,1089,'tl','',0),(39194,1089,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3',0),(39195,1089,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨',0),(39196,1089,'ms','Ralat menambah inventori lokasi',0),(39197,1089,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(39198,1089,'fr','Emplacement de l\'inventaire erreur ajout',0),(39199,1089,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39200,1089,'pt','LocalizaÃ§Ã£o de inventÃ¡rio erro adicionando',0),(39201,1089,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐºÐ»Ð°Ð´Ðµ',0),(39202,1089,'es','Error agregando ubicaciÃ³n de inventario',0),(39203,1089,'de','HinzufÃ¼gen von Lagerstandortes Fehler',0),(39204,1089,'en','Error adding inventory location',0),(39205,1090,'is','',0),(39206,1090,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ±',0),(39207,1090,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ±',0),(39208,1090,'tr','Hata ekleme fatura ÅŸartlarÄ±',0),(39209,1090,'pl','BÅ‚Ä…d dodawania faktury warunki',0),(39210,1090,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(39211,1090,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø´Ø±Ø§Ø¦Ø·',0),(39212,1090,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° ÑƒÑÐ»Ð¾Ð²Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(39213,1090,'vi','ThÃªm Ä‘iá»u khoáº£n hÃ³a Ä‘Æ¡n bá»‹ lá»—i',0),(39214,1090,'af','Fout voeg faktuur terme',0),(39215,1090,'ro','Eroare adÄƒugarea termeni de facturÄƒ',0),(39216,1090,'et','Viga lisades arve tingimused',0),(39217,1090,'si','Napaka dodajanje pogoje raÄuna',0),(39218,1090,'ba','Syarat-syarat faktur menambahkan kesalahan',0),(39219,1090,'nl','Fout toe te voegen factuur voorwaarden',0),(39220,1090,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ laskun ehtojen',0),(39221,1090,'no','Feil Ã¥ legge faktureringsvilkÃ¥r',0),(39222,1090,'da','Fejl tilfÃ¸je faktura vilkÃ¥r',0),(39223,1090,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì†¡ìž¥ ìš©ì–´',0),(39224,1090,'he','×©×’×™××” ×”×•×¡×¤×ª ×ª× ××™ ×—×©×‘×•× ×™×ª',0),(39225,1090,'el','Î£Ï†Î¬Î»Î¼Î± Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(39226,1090,'zh','é”™è¯¯æ·»åŠ å‘ç¥¨é¡¹ç›®',0),(39227,1090,'sv','Fel att lÃ¤gga till faktura villkor',0),(39228,1090,'it','Termini di fattura aggiungendo errore',0),(39229,1090,'tl','',0),(39230,1090,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3',0),(39231,1090,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(39232,1090,'ms','Ralat menambah invois terma-terma',0),(39233,1090,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙˆØ· Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(39234,1090,'fr','Termes facture ajout d\'erreur',0),(39235,1090,'jp','è«‹æ±‚æ?¡ä»¶ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39236,1090,'pt','Termos de factura erro adicionando',0),(39237,1090,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð°',0),(39238,1090,'es','Error agregando tÃ©rminos de Factura',0),(39239,1090,'de','Fehler hinzufÃ¼gen Rechnung hinsichtlich',0),(39240,1090,'en','Error adding invoice terms',0),(39241,1091,'is','',0),(39242,1091,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ ',0),(39243,1091,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ ',0),(39244,1091,'tr','Ã–ÄŸesi ekleme hatasÄ±',0),(39245,1091,'pl','BÅ‚Ä…d dodawania elementu',0),(39246,1091,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(39247,1091,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø´Û’',0),(39248,1091,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(39249,1091,'vi','ThÃªm hÃ ng bá»‹ lá»—i',0),(39250,1091,'af','Fout met skep van item',0),(39251,1091,'ro','Eroare adÄƒugarea elementului',0),(39252,1091,'et','Toote muutmisel ilmnes viga',0),(39253,1091,'si','Napaka dodajanje artiklov',0),(39254,1091,'ba','Kesalahan menambahkan item',0),(39255,1091,'nl','Fout toe te voegen item',0),(39256,1091,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ kohdetta',0),(39257,1091,'no','Feil Ã¥ legge til elementet',0),(39258,1091,'da','Fejl tilfÃ¸jer elementet',0),(39259,1091,'ko','ì˜¤ë¥˜ ì¶”ê°€ í•­ëª©',0),(39260,1091,'he','×©×’×™××” ×”×•×¡×¤×ª ×¤×¨×™×˜',0),(39261,1091,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… ÏƒÏ†Î¬Î»Î¼Î±',0),(39262,1091,'zh','é”™è¯¯ï¼šæ–°å¢žé¡¹ç›®',0),(39263,1091,'sv','Fel att lÃ¤gga till objekt',0),(39264,1091,'it','Errore aggiunta elemento',0),(39265,1091,'tl','',0),(39266,1091,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(39267,1091,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾ à¤†à¤‡à¤Ÿà¤®',0),(39268,1091,'ms','Ralat menambah item',0),(39269,1091,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© ØµÙ†Ù',0),(39270,1091,'fr','Erreur ajout de l\'Ã©lÃ©ment',0),(39271,1091,'jp','å“?ç›®ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39272,1091,'pt','Adicionar item de erro',0),(39273,1091,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(39274,1091,'es','Error agregando item',0),(39275,1091,'de','Fehler hinzufÃ¼gen Element',0),(39276,1091,'en','Error adding item',0),(39277,1092,'is','',0),(39278,1092,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ ',0),(39279,1092,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ ',0),(39280,1092,'tr','Hata ekleme Ã¶ÄŸe kategorisi.',0),(39281,1092,'pl','BÅ‚Ä…d dodawania kategorii zapasu.',0),(39282,1092,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ».',0),(39283,1092,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø´Û’ Ø²Ù…Ø±Û ÛÛ’ Û”',0),(39284,1092,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°.',0),(39285,1092,'vi','ThÃªm thá»ƒ loáº¡i hÃ ng bá»‹ lá»—i',0),(39286,1092,'af','Fout met skep van item kategorie',0),(39287,1092,'ro','Eroare adÄƒugarea categorie de articole.',0),(39288,1092,'et','Tootekategooria lisamisel ilmnes viga',0),(39289,1092,'si','Napaka dodajanje kategoriji artikla.',0),(39290,1092,'ba','Kesalahan menambahkan item kategori.',0),(39291,1092,'nl','Fout toe te voegen artikelcategorie.',0),(39292,1092,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ Nimikekategorian.',0),(39293,1092,'no','Feil Ã¥ legge varekategori.',0),(39294,1092,'da','Fejl tilfÃ¸je varekategori.',0),(39295,1092,'ko','ì˜¤ë¥˜ ì¶”ê°€ í•­ëª© ë²”ì£¼ìž…ë‹ˆë‹¤.',0),(39296,1092,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×§×˜×’×•×¨×™×™×ª ×¤×¨×™×˜',0),(39297,1092,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ¹Î´ÏŽÎ½.',0),(39298,1092,'zh','é”™è¯¯ï¼šæ–°å¢žé¡¹ç›®ç±»åˆ«ã€‚',0),(39299,1092,'sv','Fel att lÃ¤gga artikelkategori.',0),(39300,1092,'it','Voce aggiunta categoria di errore.',0),(39301,1092,'tl','',0),(39302,1092,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3',0),(39303,1092,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾ à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€à¥¤',0),(39304,1092,'ms','Ralat menambah item kategori.',0),(39305,1092,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© ØªØµÙ†ÙŠÙ ØµÙ†Ù',0),(39306,1092,'fr','Ajout catÃ©gorie de point d\'erreur.',0),(39307,1092,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39308,1092,'pt','Categoria de item de erro adicionando.',0),(39309,1092,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð°.',0),(39310,1092,'es','Error agregando categorÃ­a de item',0),(39311,1092,'de','Fehler hinzufÃ¼gen Positionstyp.',0),(39312,1092,'en','Error adding item category.',0),(39313,1093,'is','',0),(39314,1093,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ØªØ±ÙƒÙŠØ¨ ÙƒØ§Ù„Ø§ ',0),(39315,1093,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ØªØ±ÙƒÙŠØ¨ ÙƒØ§Ù„Ø§ ',0),(39316,1093,'tr','Hata ekleme Ã¶ÄŸe kompozit',0),(39317,1093,'pl','BÅ‚Ä…d dodawania elementu materiaÅ‚Ã³w kompozytowych',0),(39318,1093,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚',0),(39319,1093,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø´Û’ Ù…Ø±Ú©Ø¨',0),(39320,1093,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(39321,1093,'vi','ThÃªm hÃ ng composite bá»‹ lá»—i',0),(39322,1093,'af','Fout met skep van item kategorie',0),(39323,1093,'ro','Eroare adÄƒugarea elementului compozit',0),(39324,1093,'et','Viga lisades kauba komposiit',0),(39325,1093,'si','Napaka Dodajanje elementa kompozitni',0),(39326,1093,'ba','Kesalahan menambahkan item komposit',0),(39327,1093,'nl','Fout toe te voegen item composiet',0),(39328,1093,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ kohdetta komposiitti',0),(39329,1093,'no','Feil Ã¥ legge til element kompositt',0),(39330,1093,'da','Fejl tilfÃ¸je vare sammensatte',0),(39331,1093,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì•„ì´í…œ í•©ì„±',0),(39332,1093,'he','×©×’×™××” ×”×•×¡×¤×ª ×¤×¨×™×˜ ×ž×•×¨×›×‘',0),(39333,1093,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… ÏƒÏÎ½Î¸ÎµÏ„Î¿ ÏƒÏ†Î¬Î»Î¼Î±',0),(39334,1093,'zh','é”™è¯¯ï¼šæ–°å¢žé¡¹ç›®ç»„åˆ',0),(39335,1093,'sv','Fel att lÃ¤gga till objektet komposit',0),(39336,1093,'it','Composito di errore aggiunta elemento',0),(39337,1093,'tl','',0),(39338,1093,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3626;&#3636;&#3',0),(39339,1093,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾ à¤†à¤‡à¤Ÿà¤® à¤•à¤®à¥à¤ªà¥‹à¤œà¤¿à¤Ÿ',0),(39340,1093,'ms','Ralat menambah butiran Komposit',0),(39341,1093,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© ØµÙ†Ù Ù…Ø±ÙƒÙ‘Ø¨',0),(39342,1093,'fr','Composite d\'Ã©lÃ©ment Ajout erreur',0),(39343,1093,'jp','è¤‡å?ˆå“?ç›®ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39344,1093,'pt','Composto de item erro adicionando',0),(39345,1093,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚',0),(39346,1093,'es','Error agregando compuesto de item',0),(39347,1093,'de','Fehler hinzufÃ¼gen Element composite',0),(39348,1093,'en','Error adding item composite',0),(39349,1094,'is','',0),(39350,1094,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ ',0),(39351,1094,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ ',0),(39352,1094,'tr','Hata ekleme Ã¶ÄŸe konumu',0),(39353,1094,'pl','BÅ‚Ä…d dodawania lokalizacji elementu',0),(39354,1094,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¼ÐµÑÑ‚Ð¾Ð½Ð°Ñ…Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(39355,1094,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø´Û’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(39356,1094,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð³Ñ€ÐµÑˆÐºÐµ',0),(39357,1094,'vi','ThÃªm vá»‹ trÃ­ hÃ ng bá»‹ lá»—i',0),(39358,1094,'af','Fout met byvoeging van item ligging',0),(39359,1094,'ro','Eroare adÄƒugarea locaÅ£ia elementului',0),(39360,1094,'et','Toote asukoha lisamisel ilmnes viga',0),(39361,1094,'si','Napaka pri dodajanju mesto elementa',0),(39362,1094,'ba','Lokasi menambahkan kesalahan',0),(39363,1094,'nl','Locatie van het item fout toe te voegen',0),(39364,1094,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ kohteen sijainti',0),(39365,1094,'no','Feil Ã¥ legge elementplasseringen',0),(39366,1094,'da','Fejl tilfÃ¸je emnets placering',0),(39367,1094,'ko','ì˜¤ë¥˜ ì¶”ê°€ í•­ëª© ìœ„ì¹˜',0),(39368,1094,'he','×ž×™×§×•× ×”×¤×¨×™×˜ ×”×•×¡×¤×ª ×©×’×™××ª',0),(39369,1094,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î¸Î­ÏƒÎ· ÏƒÏ†Î¬Î»Î¼Î±',0),(39370,1094,'zh','é”™è¯¯ï¼šæ–°å¢žé¡¹ç›®ä½ç½®',0),(39371,1094,'sv','LÃ¤gga till objekt plats',0),(39372,1094,'it','Posizione elemento aggiungendo errore',0),(39373,1094,'tl','',0),(39374,1094,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3586;&#3629;&#3591;&#3626;&#3636;&#3',0),(39375,1094,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾ à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨',0),(39376,1094,'ms','Ralat menambah item lokasi',0),(39377,1094,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹ ØµÙ†Ù',0),(39378,1094,'fr','Emplacement d\'Ã©lÃ©ment Ajout erreur',0),(39379,1094,'jp','å“?ç›®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39380,1094,'pt','LocalizaÃ§Ã£o de item erro adicionando',0),(39381,1094,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(39382,1094,'es','Error agregando ubicaciÃ³n de item',0),(39383,1094,'de','HinzufÃ¼gen von Artikelstandort Fehler',0),(39384,1094,'en','Error adding item location',0),(39385,1095,'is','',0),(39386,1095,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù„Ø§ ',0),(39387,1095,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù„Ø§ ',0),(39388,1095,'tr','Ã–ÄŸe konumu fiyatlandÄ±rma ekleme hatasÄ±',0),(39389,1095,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania elementu lokalizacji ceny',0),(39390,1095,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(39391,1095,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø´Û’ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(39392,1095,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(39393,1095,'vi','ThÃªm giÃ¡ hÃ ng bá»‹ lá»—i',0),(39394,1095,'af','Fout met byvoeging van item ligging prysberekening',0),(39395,1095,'ro','Eroare la adÄƒugarea elementului locaÅ£ie de stabilire a preÅ£urilor',0),(39396,1095,'et','Viga lisades kauba asukoht hinnad',0),(39397,1095,'si','Napaka pri dodajanju elementa mesto cen',0),(39398,1095,'ba','Kesalahan menambahkan item lokasi harga',0),(39399,1095,'nl','Fout toe te voegen item locatie prijzen',0),(39400,1095,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ kohteen sijainti hinnoittelu',0),(39401,1095,'no','Feil under tillegging av elementet plassering priser',0),(39402,1095,'da','Fejl ved tilfÃ¸jelse af vare placering prissÃ¦tning',0),(39403,1095,'ko','í•­ëª© ìœ„ì¹˜ ê°€ê²© ì¶”ê°€ ì˜¤ë¥˜',0),(39404,1095,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¤×¨×™×˜ ×œ×ž×™×§×•× ×ª×ž×—×•×¨',0),(39405,1095,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(39406,1095,'zh','é”™è¯¯ï¼šæ–°å¢žé¡¹ç›®ä½ç½®ä»·æ ¼',0),(39407,1095,'sv','Fel att lÃ¤gga till objekt plats prissÃ¤ttning',0),(39408,1095,'it','Errore durante l\'aggiunta elemento posizione prezzi',0),(39409,1095,'tl','',0),(39410,1095,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3',0),(39411,1095,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‡ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(39412,1095,'ms','Ralat menambah item lokasi harga',0),(39413,1095,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© ØªØ³Ø¹ÙŠØ±Ø© Ù…ÙˆÙ‚Ø¹ ØµÙ†Ù',0),(39414,1095,'fr','Erreur en ajoutant le prix emplacement par item',0),(39415,1095,'jp','å“?ç›®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ä¾¡æ ¼è¨­å®šã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39416,1095,'pt','Erro ao adicionar item LocalizaÃ§Ã£o preÃ§os',0),(39417,1095,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½Ñ‹',0),(39418,1095,'es','Error agregando precios de ubicaciÃ³n de item',0),(39419,1095,'de','Fehler beim HinzufÃ¼gen des Elements Lage Preise',0),(39420,1095,'en','Error adding item location pricing',0),(39421,1096,'is','',0),(39422,1096,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ØªØ®ÙÙŠÙØ§Øª Ù…Ø­Ù„ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù„Ø§ ',0),(39423,1096,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ØªØ®ÙÙŠÙØ§Øª Ù…Ø­Ù„ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù„Ø§ ',0),(39424,1096,'tr','Ã–ÄŸe konumu indirim fiyat ekleme hatasÄ±',0),(39425,1096,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania lokalizacji elementu ceny zniÅ¼ki',0),(39426,1096,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸',0),(39427,1096,'ur','Ø´Û’ Ú©Ø§ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©ÛŒ Ø±Ø¹Ø§ÛŒØª Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(39428,1096,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ð¿Ð¾Ð¿ÑƒÑÑ‚Ðµ',0),(39429,1096,'vi','ThÃªm chiáº¿t kháº¥u hÃ ng bá»‹ lá»—i',0),(39430,1096,'af','Fout met byvoeging van item ligging prysberekeningkortings',0),(39431,1096,'ro','Eroare la adÄƒugarea locaÅ£ia elementului reduceri de preÅ£uri',0),(39432,1096,'et','Viga lisades kauba asukoha hinnakujunduse allahindlused',0),(39433,1096,'si','Napaka pri dodajanju mesto elementa cene popusti',0),(39434,1096,'ba','Kesalahan menambahkan lokasi harga diskon',0),(39435,1096,'nl','Fout objectlocatie prijzen kortingen toe te voegen',0),(39436,1096,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ nimikkeen sijainnin hinnoittelu alennukset',0),(39437,1096,'no','Feil under tillegging elementplasseringen priser rabatter',0),(39438,1096,'da','Fejl ved tilfÃ¸jelse af emnets placering prissÃ¦tning rabatter',0),(39439,1096,'ko','ì˜¤ë¥˜ í•­ëª© ìœ„ì¹˜ ê°€ê²© ì¶”ê°€ í• ì¸',0),(39440,1096,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×ž×™×§×•× ×”×¤×¨×™×˜ ×ª×ž×—×•×¨ ×”× ×—×•×ª',0),(39441,1096,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚',0),(39442,1096,'zh','é”™è¯¯ï¼šæ–°å¢žé¡¹ç›®ä½ç½®ä»·æ ¼æŠ˜æ‰£',0),(39443,1096,'sv','Fel att lÃ¤gga till objekt plats prissÃ¤ttning rabatter',0),(39444,1096,'it','Errore durante l\'aggiunta elemento posizione prezzi sconti',0),(39445,1096,'tl','',0),(39446,1096,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3',0),(39447,1096,'hi','à¤†à¤‡à¤Ÿà¤® à¤›à¥‚à¤Ÿ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(39448,1096,'ms','Ralat menambah lokasi item harga diskaun',0),(39449,1096,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹ ØµÙ†Ù ØªØ³Ø¹ÙŠØ± Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª',0),(39450,1096,'fr','Erreur en ajoutant l\'Ã©lÃ©ment emplacement prix PREFERENTIELS',0),(39451,1096,'jp','Error adding item location pricing discounts',0),(39452,1096,'pt','Erro ao adicionar item LocalizaÃ§Ã£o descontos de preÃ§os',0),(39453,1096,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¦ÐµÐ½Ñ‹ ÑÐºÐ¸Ð´ÐºÐ¸',0),(39454,1096,'es','Error agregando descuentos de precios de ubicaciÃ³n de item',0),(39455,1096,'de','Fehler beim HinzufÃ¼gen der Artikelstandort Preise Rabatte',0),(39456,1096,'en','Error adding item location pricing discounts',0),(39457,1097,'is','',0),(39458,1097,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ø´ÙŠÙ† ',0),(39459,1097,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ø´ÙŠÙ† ',0),(39460,1097,'tr','Hata hesap makinesi.',0),(39461,1097,'pl','BÅ‚Ä…d dodawania maszyny.',0),(39462,1097,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð°.',0),(39463,1097,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©ÛŒ Ù…Ø´ÛŒÙ† ÛÛ’ Û”',0),(39464,1097,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ ÐºÐ°Ð»ÐºÑƒÐ»Ð°Ñ‚Ð¾Ñ€Ñƒ.',0),(39465,1097,'vi','ThÃªm nÃ¡y bá»‹ lá»—i',0),(39466,1097,'af','Fout rekenmasjien.',0),(39467,1097,'ro','AdÄƒugarea de eroare maÅŸinÄƒ.',0),(39468,1097,'et','TÃµrge aritmomeetril.',0),(39469,1097,'si','Napaka pri raÄunskem stroju.',0),(39470,1097,'ba','Kesalahan menambahkan mesin.',0),(39471,1097,'nl','Fout toe te voegen machine.',0),(39472,1097,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ kone.',0),(39473,1097,'no','Feil regnemaskin.',0),(39474,1097,'da','Fejl tilfÃ¸je maskine.',0),(39475,1097,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê¸°ê³„.',0),(39476,1097,'he','×ž×›×•× ×ª ×”×ž×©×—×§×™× ×©×’×™××”.',0),(39477,1097,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î¸ÏÎ¿Î¹ÏƒÏ„Î¹ÎºÎ® Î¼Î·Ï‡Î±Î½Î®.',0),(39478,1097,'zh','é”™è¯¯æ·»åŠ æœºå™¨ã€‚',0),(39479,1097,'sv','Fel bordsrÃ¤knare.',0),(39480,1097,'it','Macchina di aggiunta di errore.',0),(39481,1097,'tl','',0),(39482,1097,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(39483,1097,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¤¶à¥€à¤¨à¥¤',0),(39484,1097,'ms','Ralat menambah Mesin.',0),(39485,1097,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¬Ù‡Ø§Ø².',0),(39486,1097,'fr','Machine Ã  additionner erreur.',0),(39487,1097,'jp','æ©Ÿæ¢°ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39488,1097,'pt','MÃ¡quina de somar de erro.',0),(39489,1097,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐÑ€Ð¸Ñ„Ð¼Ð¾Ð¼ÐµÑ‚Ñ€.',0),(39490,1097,'es','Error agregando mÃ¡quina',0),(39491,1097,'de','Fehler HinzufÃ¼gende Maschine.',0),(39492,1097,'en','Error adding machine.',0),(39493,1098,'is','',0),(39494,1098,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙŠØ³ØªÙ… ØªÙØ§ÙˆØª Ø¨ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ù‚ÙŠÙ…Øª Ú©Ø§Ù„Ø§ Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­ ',0),(39495,1098,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙŠØ³ØªÙ… ØªÙØ§ÙˆØª Ø¨ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ù‚ÙŠÙ…Øª Ú©Ø§Ù„Ø§ Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­ ',0),(39496,1098,'tr','BiÃ§imlendirme kÃ¼me dÃ¼zeyinde eklenirken bir hata oluÅŸtu.',0),(39497,1098,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania znacznikÃ³w ustawiÄ‡ poziom.',0),(39498,1098,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Markup ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚ Ð·Ð° Ð½Ð¸Ð²Ð¾.',0),(39499,1098,'ur','Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ø³Ø·Ø­ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(39500,1098,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð½Ð°Ð·Ð½Ð°ÐºÐµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½ Ð·Ð° Ð½Ð¸Ð²Ð¾.',0),(39501,1098,'vi','ThÃªm má»©c cá»™ng thÃªm bá»‹ lá»—i',0),(39502,1098,'af','Fout voeg Markup stel vir vlak.',0),(39503,1098,'ro','Eroare la adÄƒugarea Markup stabilit pentru nivel.',0),(39504,1098,'et','Viga lisades mÃ¤rgistus seada tasemele.',0),(39505,1098,'si','Napaka pri dodajanju oznake nastavite raven.',0),(39506,1098,'ba','Kesalahan menambahkan Markup Set untuk tingkat.',0),(39507,1098,'nl','Fout bij het toevoegen van aantekeningen voor niveau ingesteld.',0),(39508,1098,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ Markup asettaa tasolle.',0),(39509,1098,'no','Feil under tillegging Markup satt for nivÃ¥et.',0),(39510,1098,'da','Fejl ved tilfÃ¸jelse af Markup fastsatte niveau.',0),(39511,1098,'ko','ìˆ˜ì¤€ì— ëŒ€ í•œ ì„¤ì • íƒœê·¸ë¥¼ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(39512,1098,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¡×™×ž×•×Ÿ ×œ×”×’×“×™×¨ ×¨×ž×”.',0),(39513,1098,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ Ï€Î¿Ï… Î³Î¹Î± Ï„Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿.',0),(39514,1098,'zh','é”™è¯¯æ·»åŠ çº§åˆ«æ ‡è®°é›†ã€‚\r\n',0),(39515,1098,'sv','Fel att Markup fÃ¶r nivÃ¥.',0),(39516,1098,'it','Errore aggiungendo Markup impostato per il livello.',0),(39517,1098,'tl','',0),(39518,1098,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3632;&#3',0),(39519,1098,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤•à¥‡ à¤¸à¥à¤¤à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(39520,1098,'ms','Ralat menambah Set penanda aras.',0),(39521,1098,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© \"Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©\" Ù„Ù„Ù…Ø³ØªÙˆÙ‰.',0),(39522,1098,'fr','Erreur en ajoutant le balisage mis Ã  niveau.',0),(39523,1098,'jp','ã??ã?®ãƒ¬ãƒ™ãƒ«ã?®å€¤ä¸Šã?’è¨­å®šã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39524,1098,'pt','Erro ao adicionar marcaÃ§Ã£o definida para o nÃ­vel.',0),(39525,1098,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ð´Ð»Ñ ÑƒÑ€Ð¾Ð²Ð½Ñ.',0),(39526,1098,'es','Error agregando Juego de Encarecimiento para Nivel',0),(39527,1098,'de','Fehler beim HinzufÃ¼gen von Markup fÃ¼r Ebene festgelegt.',0),(39528,1098,'en','Error adding Markup Set for Level.',0),(39529,1099,'is','',0),(39530,1099,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙØ¹Ø§Ù„ÙŠØª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(39531,1099,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙØ¹Ø§Ù„ÙŠØª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(39532,1099,'tr','-BaskÄ± iÅŸlemi boyutu eklenirken bir hata oluÅŸtu.',0),(39533,1099,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania rozmiar wydruku bez operacji.',0),(39534,1099,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚Ð½Ð¸Ñ‚Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(39535,1099,'ur','ØºÛŒØ±-Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº Ø¹Ù…Ù„ÛŒÛ Ø³Ø§Ø¦Ø² Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(39536,1099,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð°-Ð¿Ñ€Ð¸Ð½Ñ‚ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð°.',0),(39537,1099,'vi','ThÃªm cá»¡ hoáº¡t Ä‘á»™ng khÃ´ng in bá»‹ lá»—i',0),(39538,1099,'af','Fout by nie-druk bewerking grootte te voeg.',0),(39539,1099,'ro','Eroare la adÄƒugarea non-imprimare funcÅ£ionarea dimensiune.',0),(39540,1099,'et','Viga lisades Prindi operatsiooni suurus.',0),(39541,1099,'si','Napaka pri dodajanju-print delovanje velikost.',0),(39542,1099,'ba','Kesalahan menambahkan ukuran operasi non-cetak.',0),(39543,1099,'nl','Fout bij het toevoegen van niet-print operatie grootte.',0),(39544,1099,'fi','Virhe lisÃ¤ttÃ¤essÃ¤-print toiminta kokoa.',0),(39545,1099,'no','Feil under tillegging uten utskrift operasjonen stÃ¸rrelse.',0),(39546,1099,'da','Fejl ved tilfÃ¸jelse af ikke-print operation stÃ¸rrelse.',0),(39547,1099,'ko','ë¹„ ì¸ì‡„ ìž‘ì—… í¬ê¸°ë¥¼ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(39548,1099,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×’×•×“×œ ×©××™× × ×ž×•×“×¤×¡×™× ×‘×ž×‘×¦×¢.',0),(39549,1099,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼Î·-print Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚.',0),(39550,1099,'zh','é”™è¯¯æ·»åŠ éžå°åˆ·ä¸šåŠ¡è§„æ¨¡ã€‚',0),(39551,1099,'sv','Fel att lÃ¤gga till icke-print drift storlek.',0),(39552,1099,'it','Errore aggiunta operazione non stampa dimensioni.',0),(39553,1099,'tl','',0),(39554,1099,'th','Error adding non-print operation size.',0),(39555,1099,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤ªà¤°à¥‡à¤¶à¤¨ à¤†à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(39556,1099,'ms','Ralat menambah saiz operasi cetak.',0),(39557,1099,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø­Ø¬Ù… Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© ØºÙŠØ± Ø¹Ù…Ù„ÙŠØ©.',0),(39558,1099,'fr','Erreur en ajoutant la taille de l\'opÃ©ration non imprimÃ©s.',0),(39559,1099,'jp','é?žå?°åˆ·ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã‚µã‚¤ã‚ºã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39560,1099,'pt','Erro ao adicionar o tamanho da operaÃ§Ã£o sem impressÃ£o.',0),(39561,1099,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸-Ð¿Ñ€Ð¸Ð½Ñ‚ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(39562,1099,'es','Error agregando tamaÃ±o de operaciÃ³n de no imprimir',0),(39563,1099,'de','Fehler beim HinzufÃ¼gen von nicht-Print-Betrieb-GrÃ¶ÃŸe.',0),(39564,1099,'en','Error adding non-print operation size.',0),(39565,1100,'is','',0),(39566,1100,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡  Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ ÙƒØ§Ù„Ø§',0),(39567,1100,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡  Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ ÙƒØ§Ù„Ø§',0),(39568,1100,'tr','BaskÄ±da malzeme ile Ã¶ÄŸe eklenirken bir hata oluÅŸtu',0),(39569,1100,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania niedrukowalne materiaÅ‚u z przedmiotu',0),(39570,1100,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð½Ð¸Ñ‚Ðµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð» Ñ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(39571,1100,'ur','ØºÛŒØ± Ø·Ø¨Ø§Ø¹Øª Ù…ÙˆØ§Ø¯ Ø´Û’ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ø¶Ø§ÙÛ Ú©Ø±ØªØ§ ÛÙˆØ§ Ù†Ù‚Øµ',0),(39572,1100,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÐºÐ¾Ñ˜Ð¸ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð» ÑÐ° ÑÑ‚Ð°Ð²ÐºÐ¾Ð¼',0),(39573,1100,'vi','ThÃªm nguyÃªn váº­t liá»‡u khÃ´ng in bá»‹ lá»—i',0),(39574,1100,'af','Fout nie-druk materiaal met item voeg',0),(39575,1100,'ro','Eroare la adÄƒugarea material nu se imprimÄƒ cu element',0),(39576,1100,'et','Viga lisades printimatu materjali kaubaga',0),(39577,1100,'si','Napaka pri dodajanju tiskano gradivo z elementom',0),(39578,1100,'ba','Kesalahan menambahkan bebas-Percetakan bahan dengan item',0),(39579,1100,'nl','Fout niet-afdrukbare materiaal met item toevoegen',0),(39580,1100,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tulostumattomat materiaali kohde',0),(39581,1100,'no','Feil under tillegging av ikke-utskrivbare materiale med element',0),(39582,1100,'da','Fejl ved tilfÃ¸jelse af trykfri materiale med varen',0),(39583,1100,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ìžë£Œ í•­ëª© ì¶”ê°€ ì˜¤ë¥˜',0),(39584,1100,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×—×•×ž×¨ ×ž×•×“×¤×¡ ×¢× ×¤×¨×™×˜',0),(39585,1100,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼Î· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î¿ Ï…Î»Î¹ÎºÏŒ Î¼Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(39586,1100,'zh','é”™è¯¯ï¼šæ–°å¢žé¡¹ç›®éžå°åˆ·ææ–™',0),(39587,1100,'sv','Fel att lÃ¤gga till icke-utskrift material med objekt',0),(39588,1100,'it','Errore aggiungendo materiale non stampabili con elemento',0),(39589,1100,'tl','',0),(39590,1100,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604; &#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3614;&#3636;&#3617;&#3614;&#3660;&#3652;&#3617;&#3656;&#',0),(39591,1100,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤¯à¥‹à¤—à¥à¤¯ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤¸à¤¾à¤¥ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(39592,1100,'ms','Ralat menambah-percetakan bahan dengan perkara',0),(39593,1100,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…ÙˆØ§Ø¯ ØºÙŠØ± Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© Ù…Ø¹ Ø§Ù„Ø¨Ù†Ø¯',0),(39594,1100,'fr','Erreur d\'ajout de matiÃ¨re non imprimables avec point',0),(39595,1100,'jp','ã??ã?®å“?ç›®ã?¨ã?®é?žå?°åˆ·æ??æ–™ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39596,1100,'pt','Erro na adiÃ§Ã£o de material nÃ£o-imprimÃ­vel com item',0),(39597,1100,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð°-Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ñ Ð¿ÑƒÐ½ÐºÑ‚Ð°',0),(39598,1100,'es','Error agregando material de no imprimir con el item',0),(39599,1100,'de','Fehler beim HinzufÃ¼gen von nicht druckbaren Material mit Element',0),(39600,1100,'en','Error adding non-printing material with item',0),(39601,1101,'is','',0),(39602,1101,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(39603,1101,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(39604,1101,'tr','Hata ekleme yazdÄ±rÄ±lmayan fiyat listesi.',0),(39605,1101,'pl','Dodawanie bÅ‚Ä…d techniczny Cennik.',0),(39606,1101,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°.',0),(39607,1101,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(39608,1101,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¾Ð¸Ð²Ð¸Ñ‡ÐµÐ½ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°.',0),(39609,1101,'vi','ThÃªm danh sÃ¡ch giÃ¡ khÃ´ng in bá»‹ lá»—i',0),(39610,1101,'af','Fout voeg nonprinting prys lys.',0),(39611,1101,'ro','Eroare adÄƒugarea neimprimabile lista de preturi.',0),(39612,1101,'et','Viga lisades mitteprinditavad hinnakiri.',0),(39613,1101,'si','Napaka pri dodajanju Nenatisljivi cenik.',0),(39614,1101,'ba','Kesalahan menambahkan daftar harga nonprinting.',0),(39615,1101,'nl','Fout toe te voegen niet-afdrukbare prijslijst.',0),(39616,1101,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tulostumattomat hinnasto.',0),(39617,1101,'no','Feil Ã¥ legge til ikke-utskrivbare prisliste.',0),(39618,1101,'da','Fejl tilfÃ¸je afsnitstegn prisliste.',0),(39619,1101,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡.',0),(39620,1101,'he','×”×•×¡×¤×ª ×©××™× × ×ž×•×“×¤×¡×™× ×”×ž×—×™×¨ ×‘×¨×©×™×ž×ª ×”×©×’×™××•×ª.',0),(39621,1101,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼Î· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»Î¯ÏƒÏ„Î± ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½ Ï„Î¹Î¼Î®.',0),(39622,1101,'zh','é”™è¯¯æ·»åŠ éžæ‰“å°ä»·æ ¼è¡¨ã€‚',0),(39623,1101,'sv','Fel att lÃ¤gga icke utskrivbar prislista.',0),(39624,1101,'it','Errore aggiungendo non stampabile listino.',0),(39625,1101,'tl','',0),(39626,1101,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604; &#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3614;&#3636;&#3617;&#3614;&#3660;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;',0),(39627,1101,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤—à¥ˆà¤° à¤®à¥à¤¦à¥à¤°à¤£à¥€à¤¯ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€à¥¤',0),(39628,1101,'ms','Ralat menambah nonprinting senarai harga.',0),(39629,1101,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© ØºÙŠØ± Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(39630,1101,'fr','Erreur ajout non imprimable liste de prix.',0),(39631,1101,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39632,1101,'pt','Lista de preÃ§os de nÃ£o-imprimÃ­vel adicionando erro.',0),(39633,1101,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ñ€Ð°Ð¹Ñ Ð»Ð¸ÑÑ‚.',0),(39634,1101,'es','Error agregando lista de precios de no imprimir',0),(39635,1101,'de','Fehler hinzufÃ¼gen nicht druckbare Preisliste.',0),(39636,1101,'en','Error adding non-printing price list.',0),(39637,1102,'is','',0),(39638,1102,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ÙØ¹Ø§Ù„ÙŠØª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ ',0),(39639,1102,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ÙØ¹Ø§Ù„ÙŠØª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ ',0),(39640,1102,'tr','YazdÄ±rÄ±lmayan fiyat listesi iÅŸlemi SeÃ§imi liste Ã¶ÄŸesi eklenirken bir hata oluÅŸtu.',0),(39641,1102,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania niedrukowane cena lista operacji wyboru listy pozycji.',0),(39642,1102,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ ÑÐ¿Ð¸ÑÑŠÐº ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°.',0),(39643,1102,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø¢Ù¾Ø±ÛŒØ´Ù† Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª Ø´Û’ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(39644,1102,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¾Ð¸Ð²Ð¸Ñ‡ÐµÐ½ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ñƒ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð»Ð¸ÑÑ‚Ðµ ÑÑ‚Ð°Ð²ÐºÑƒ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°.',0),(39645,1102,'vi','ThÃªm danh sÃ¡ch giÃ¡ khÃ´ng in bá»‹ lá»—i',0),(39646,1102,'af','Fout nonprinting prys lys bewerking seleksie lys item voeg.',0),(39647,1102,'ro','Eroare la adÄƒugarea neimprimabile preÅ£ listÄƒ funcÅ£ionarea selecÅ£ie element din listÄƒ.',0),(39648,1102,'et','Viga lisades mitteprinditavad operatsiooni valiku nimekirja hinnakirjaÃ¼ksuse.',0),(39649,1102,'si','Napaka pri dodajanju Nenatisljivi delovanje izbor seznam element cenika.',0),(39650,1102,'ba','Kesalahan menambahkan nonprinting harga daftar daftar item pilihan operasi.',0),(39651,1102,'nl','Fout bij het niet-afdrukbare lijst bewerking selectie prijslijstitem toevoegen.',0),(39652,1102,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tulostumattomat toiminnon valinta luettelon Hinnastonimike.',0),(39653,1102,'no','Feil under tillegging av ikke-utskrivbare operasjonen utvalg liste prislisteelement.',0),(39654,1102,'da','Fejl ved tilfÃ¸jelse af afsnitstegn operation udvalg liste prislisteelement.',0),(39655,1102,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡ ìž‘ì—… ì„ íƒ ëª©ë¡ í•­ëª©ì„ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(39656,1102,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×” ×ž×‘×¦×¢ ×‘×—×™×¨×” ×‘×¨×©×™×ž×” ×¤×¨×™×˜ ×ž×—×™×¨×•×Ÿ.',0),(39657,1102,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼Î· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚ Î»Î¯ÏƒÏ„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï….',0),(39658,1102,'zh','é”™è¯¯æ·»åŠ éžæ‰“å°ä»·æ ¼è¡¨ä¸­æ“ä½œé€‰é¡¹åˆ—è¡¨é¡¹ç›®',0),(39659,1102,'sv','Fel att lÃ¤gga icke utskrivbara lista drift urval prislisteobjekt.',0),(39660,1102,'it','Errore durante l\'aggiunta non stampabile prezzo operazione selezione elenco elemento dell\'elenco.',0),(39661,1102,'tl','',0),(39662,1102,'th','Error adding nonprinting price list operation selection list item.',0),(39663,1102,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤‘à¤ªà¤°à¥‡à¤¶à¤¨ à¤šà¤¯à¤¨ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(39664,1102,'ms','Ralat menambah nonprinting harga senarai operasi pilihan senarai item.',0),(39665,1102,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø¹Ù…Ù„ÙŠØ© Ø§Ø®ØªÙŠØ§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø¹Ù†ØµØ± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©.',0),(39666,1102,'fr','Erreur ajout non imprimables opÃ©ration sÃ©lection liste Ã©lÃ©ment tarifaire.',0),(39667,1102,'jp','Error adding nonprinting price list operation selection list item.',0),(39668,1102,'pt','Erro ao adicionar o item de lista de seleÃ§Ã£o de operaÃ§Ã£o do preÃ§o lista nÃ£o imprimÃ­veis.',0),(39669,1102,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÑÐ¿Ð¸ÑÐºÐ° Ð²Ñ‹Ð±Ð¾Ñ€Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ñ†ÐµÐ½Ð° Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ ÑÐ¿Ð¸ÑÐºÐ°.',0),(39670,1102,'es','Error agregando item de lista de selecciÃ³n de operaciÃ³n de lista de precios de no imprimir',0),(39671,1102,'de','Fehler beim HinzufÃ¼gen nicht druckbare Liste Vorgang Auswahl Preislistenelement.',0),(39672,1102,'en','Error adding non-printing price list operation selection list item.',0),(39673,1103,'is','',0),(39674,1103,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù†  ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(39675,1103,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù†  ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(39676,1103,'tr','Teklif iÃ§in notlar eklenirken bir hata oluÅŸtu.',0),(39677,1103,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania notatek do oferty.',0),(39678,1103,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°.',0),(39679,1103,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Û’ Ù„Ø¦Û’ Ù†ÙˆÙ¹Ø³ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(39680,1103,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð·Ð° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ.',0),(39681,1103,'vi','ThÃªm ghi chÃº bÃ¡o giÃ¡ bá»‹ lá»—i',0),(39682,1103,'af','Fout met skep van notas vir kwotasie.',0),(39683,1103,'ro','Eroare la adÄƒugarea de note pentru citat.',0),(39684,1103,'et','Viga lisades mÃ¤rkused hinnapakkumise.',0),(39685,1103,'si','Napaka pri dodajanju opombe za ponudbo.',0),(39686,1103,'ba','Kesalahan menambahkan catatan untuk kutipan.',0),(39687,1103,'nl','Fout bij het toevoegen van notities voor offerte.',0),(39688,1103,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ toteaa tarjouspyynnÃ¶n.',0),(39689,1103,'no','Feil legge til notater om tilbud.',0),(39690,1103,'da','Fejl ved tilfÃ¸jelse af noter om tilbud.',0),(39691,1103,'ko','ê²¬ì ì— ëŒ€ í•œ ë©”ëª¨ë¥¼ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(39692,1103,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×”×¢×¨×•×ª ×œ×”×¦×¢×ª ×ž×—×™×¨.',0),(39693,1103,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÏ‰Î½ Î³Î¹Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬.',0),(39694,1103,'zh','é”™è¯¯æ·»åŠ æŠ¥ä»·å¤‡æ³¨\r\n',0),(39695,1103,'sv','Fel att lÃ¤gga till anteckningar fÃ¶r offert.',0),(39696,1103,'it','Errore aggiungendo note per preventivo.',0),(39697,1103,'tl','',0),(39698,1103,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3',0),(39699,1103,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥‹à¤Ÿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(39700,1103,'ms','Ralat menambah Nota-nota bagi sebut harga.',0),(39701,1103,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø¥Ù„Ù‰ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(39702,1103,'fr','Erreur lors de l\'ajout de notes de devis.',0),(39703,1103,'jp','è¦‹ç©?ã‚‚ã‚Šã?¸ã?®ãƒ¡ãƒ¢è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39704,1103,'pt','Erro ao adicionar notas para citaÃ§Ã£o.',0),(39705,1103,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ Ð´Ð»Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹.',0),(39706,1103,'es','Error agregando notas para cotizaciones',0),(39707,1103,'de','Fehler beim HinzufÃ¼gen von Notizen fÃ¼r Angebot.',0),(39708,1103,'en','Error adding notes for quote.',0),(39709,1104,'is','',0),(39710,1104,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ â€“ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(39711,1104,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ â€“ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(39712,1104,'tr','SeÃ§enek boyutu fiyatlandÄ±rma bilgisi ekleme hatasÄ±',0),(39713,1104,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania opcji rozmiar informacje cenowe',0),(39714,1104,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð¾Ð¿Ñ†Ð¸ÑÑ‚Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(39715,1104,'ur','Ø§Ø®ØªÛŒØ§Ø± Ø³Ø§Ø¦Ø² Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø±ØªØ§ ÛÙˆØ§ Ù†Ù‚Øµ',0),(39716,1104,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°-Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ° Ð¸Ð½Ñ„Ð¾',0),(39717,1104,'vi','Lá»—i khi thÃªm thÃ´ng tin giÃ¡ theo kÃ­ch cá»¡',0),(39718,1104,'af','Fout met skepping van opsie-grootte prys inligting.',0),(39719,1104,'ro','Eroare la adÄƒugarea marimea opÅ£iunea informaÅ£ii tarifare',0),(39720,1104,'et','Viga lisades variant-suurus hindade info',0),(39721,1104,'si','Napaka pri dodajanju velikost moÅ¾nosti oblikovanja cen info',0),(39722,1104,'ba','Kesalahan menambahkan info harga opsi ukuran',0),(39723,1104,'nl','Fout toe te voegen het tarief info optie-grootte',0),(39724,1104,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ vaihtoehto kokoinen hinnoittelun info',0),(39725,1104,'no','Feil under tillegging av alternativ stÃ¸rrelse prisdetaljer info',0),(39726,1104,'da','Fejl ved tilfÃ¸jelse af option-stÃ¸rrelse prisfastsÃ¦ttelse info',0),(39727,1104,'ko','ì˜¤ë¥˜ ì˜µì…˜ í¬ê¸° ê°€ê²© ì •ë³´ ì¶”ê°€',0),(39728,1104,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¤×¨×˜×™ ×ª×ž×—×•×¨-×’×•×“×œ',0),(39729,1104,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏ€Î¹Î»Î¿Î³Î® Î¼ÎµÎ³Î­Î¸Î¿Ï…Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(39730,1104,'zh','é”™è¯¯æ·»åŠ é€‰é¡¹å¤§å°çš„ä»·æ ¼ä¿¡æ¯\r\n',0),(39731,1104,'sv','Fel att lÃ¤gga till alternativ-storlek prissÃ¤ttning info',0),(39732,1104,'it','Errore aggiungendo l\'opzione-dimensione informazioni sui prezzi',0),(39733,1104,'tl','',0),(39734,1104,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604; &#3586;&#3609;&#3634;&#3604;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3619;&#3634;&#3588;&#3634;',0),(39735,1104,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª-à¤†à¤•à¤¾à¤° à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(39736,1104,'ms','Ralat menambah maklumat harga opsyen-saiz',0),(39737,1104,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø®ÙŠØ§Ø± Ø­Ø¬Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(39738,1104,'fr','Erreur en ajoutant l\'option taille prix info',0),(39739,1104,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚µã‚¤ã‚ºä¾¡æ ¼è¨­å®šæƒ…å ±ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39740,1104,'pt','Erro ao adicionar a opÃ§Ã£o-tamanho preÃ§os info',0),(39741,1104,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ Ð Ð°Ð·Ð¼ÐµÑ€ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ñ†ÐµÐ½Ð°Ñ…',0),(39742,1104,'es','Error agregando informacion de precios de tamaÃ±o de opciÃ³n',0),(39743,1104,'de','Fehler beim HinzufÃ¼gen der Option GrÃ¶ÃŸe Preise info',0),(39744,1104,'en','Error adding option-size pricing info',0),(39745,1105,'is','',0),(39746,1105,'dr','(Ù…Ø¹Ø§Ø´',0),(39747,1105,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª (Ø­Ù‚ÙˆÙ‚',0),(39748,1105,'tr','Ã–deme tÃ¼rÃ¼ ekleme hatasÄ±',0),(39749,1105,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania zapÅ‚aciÄ‡ typu',0),(39750,1105,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ñ‚Ð¸Ð¿',0),(39751,1105,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(39752,1105,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ñ‚Ð¸Ð¿',0),(39753,1105,'vi','ThÃªm loáº¡i thanh toÃ¡n bá»‹ lá»—i',0),(39754,1105,'af','Fout het ontstaan met die byvoeging van Besoldigingstipe',0),(39755,1105,'ro','Eroare la adÄƒugarea plÄƒteascÄƒ tip',0),(39756,1105,'et','Viga lisades maksa tÃ¼Ã¼p',0),(39757,1105,'si','Napaka pri dodajanju plaÄati tipa',0),(39758,1105,'ba','Menambahkan jenis membayar kesalahan',0),(39759,1105,'nl','Fout betalen Type toe te voegen',0),(39760,1105,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ maksu-tyyppi',0),(39761,1105,'no','Feil under tillegging av betale Type',0),(39762,1105,'da','Fejl ved tilfÃ¸jelse af betale Type',0),(39763,1105,'ko','ì§€ë¶ˆ ìœ í˜•ì„ ì¶”ê°€ ì˜¤ë¥˜',0),(39764,1105,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¡×•×’ ×œ×©×œ×',0),(39765,1105,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„ÏÏ€Î¿ Î¼Îµ Ï€Î»Î·ÏÏŽÏƒÎ¿Ï…Î½',0),(39766,1105,'zh','é”™è¯¯æ·»åŠ æ”¯ä»˜ç±»åž‹ã€‚',0),(39767,1105,'sv','Fel att lÃ¤gga till betala typ',0),(39768,1105,'it','Errore durante l\'aggiunta tipo pagare',0),(39769,1105,'tl','',0),(39770,1105,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3',0),(39771,1105,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(39772,1105,'ms','Ralat menambah jenis membayar',0),(39773,1105,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© \"Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹\"',0),(39774,1105,'fr','Erreur ajout Type de payer',0),(39775,1105,'jp','æ”¯æ‰•æ–¹æ³•ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39776,1105,'pt','Erro ao adicionar tipo de pagar',0),(39777,1105,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¸Ð¿Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹.',0),(39778,1105,'es','Error agregando tipo de pago',0),(39779,1105,'de','Fehler beim HinzufÃ¼gen von Zahlen-Typ',0),(39780,1105,'en','Error adding Pay Type',0),(39781,1106,'is','',0),(39782,1106,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª',0),(39783,1106,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª',0),(39784,1106,'tr','Ã–deme ekleme hatasÄ±',0),(39785,1106,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania pÅ‚atnoÅ›ci',0),(39786,1106,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(39787,1106,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(39788,1106,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(39789,1106,'vi','ThÃªm thanh toÃ¡n bá»‹ lá»—i',0),(39790,1106,'af','Fout het ontstaan met die byvoeging van betaling',0),(39791,1106,'ro','Eroare la adÄƒugarea de platÄƒ',0),(39792,1106,'et','Viga lisades makse',0),(39793,1106,'si','Napaka pri dodajanju plaÄilo',0),(39794,1106,'ba','Kesalahan menambahkan pembayaran',0),(39795,1106,'nl','Fout toe te voegen betaling',0),(39796,1106,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ maksu',0),(39797,1106,'no','Feil under tillegging av betaling',0),(39798,1106,'da','Fejl ved tilfÃ¸jelse af betaling',0),(39799,1106,'ko','ì¶”ê°€ ê²°ì œ ì˜¤ë¥˜',0),(39800,1106,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×ª×©×œ×•×',0),(39801,1106,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(39802,1106,'zh','é”™è¯¯æ·»åŠ ä»˜æ¬¾',0),(39803,1106,'sv','Fel att lÃ¤gga till betalning',0),(39804,1106,'it','Errore durante l\'aggiunta pagamento',0),(39805,1106,'tl','',0),(39806,1106,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(39807,1106,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(39808,1106,'ms','Ralat menambah pembayaran',0),(39809,1106,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¯ÙØ¹',0),(39810,1106,'fr','Erreur en ajoutant le paiement',0),(39811,1106,'jp','æ”¯æ‰•ã?„ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39812,1106,'pt','Erro ao adicionar pagamento',0),(39813,1106,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(39814,1106,'es','Error agregando pago',0),(39815,1106,'de','Fehler beim HinzufÃ¼gen der Zahlung',0),(39816,1106,'en','Error adding payment',0),(39817,1107,'is','',0),(39818,1107,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(39819,1107,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(39820,1107,'tr','Hata ekleme fiyat dÃ¼zeyi.',0),(39821,1107,'pl','BÅ‚Ä…d dodawania cene.',0),(39822,1107,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð¾ Ð½Ð¸Ð²Ð¾.',0),(39823,1107,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ ÛÛ’ Û”',0),(39824,1107,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð°.',0),(39825,1107,'vi','ThÃªm giÃ¡ bá»‹ lá»—i',0),(39826,1107,'af','Fout voeg prys vlak.',0),(39827,1107,'ro','Eroare adÄƒugarea nivel de preÅ£.',0),(39828,1107,'et','Viga lisades hinnatase.',0),(39829,1107,'si','Napaka pri dodajanju raven cen.',0),(39830,1107,'ba','Kesalahan menambahkan tingkat harga.',0),(39831,1107,'nl','Fout toe te voegen prijsniveau.',0),(39832,1107,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ hintataso.',0),(39833,1107,'no','Feil Ã¥ legge prisnivÃ¥et.',0),(39834,1107,'da','Fejl tilfÃ¸je prisniveau.',0),(39835,1107,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê°€ê²© ìˆ˜ì¤€.',0),(39836,1107,'he','×©×’×™××” ×”×•×¡×¤×ª ×¨×ž×ª ×ž×—×™×¨×™×.',0),(39837,1107,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼Î® ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(39838,1107,'zh','é”™è¯¯æ·»åŠ ä»·æ ¼æ°´å¹³ã€‚',0),(39839,1107,'sv','Fel att lÃ¤gga prisnivÃ¥n.',0),(39840,1107,'it','Livello di prezzo aggiungendo errore.',0),(39841,1107,'tl','',0),(39842,1107,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(39843,1107,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°à¥¤',0),(39844,1107,'ms','Ralat menambah tingkat harga.',0),(39845,1107,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(39846,1107,'fr','Ajout niveau erreur de prix.',0),(39847,1107,'jp','ä¾¡æ ¼æ°´æº–ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39848,1107,'pt','NÃ­vel de preÃ§o adicionando erros.',0),(39849,1107,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑƒÑ€Ð¾Ð²Ð½Ñ Ñ†ÐµÐ½.',0),(39850,1107,'es','Error agregando nivel de precios',0),(39851,1107,'de','Fehler hinzufÃ¼gen Preisniveau.',0),(39852,1107,'en','Error adding price level.',0),(39853,1108,'is','',0),(39854,1108,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(39855,1108,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(39856,1108,'tr','Hata ekleme fiyat listesi.',0),(39857,1108,'pl','BÅ‚Ä…d dodawania Cennik.',0),(39858,1108,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°.',0),(39859,1108,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(39860,1108,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°.',0),(39861,1108,'vi','ThÃªm danh sÃ¡ch giÃ¡ bá»‹ lá»—i',0),(39862,1108,'af','Fout voeg prys lys.',0),(39863,1108,'ro','Eroare adÄƒugarea lista de preturi.',0),(39864,1108,'et','Viga lisades hinnakiri.',0),(39865,1108,'si','Napaka pri dodajanju cenik.',0),(39866,1108,'ba','Daftar harga menambahkan kesalahan.',0),(39867,1108,'nl','Fout toe te voegen prijslijst.',0),(39868,1108,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ hinnasto.',0),(39869,1108,'no','Feil Ã¥ legge prisliste.',0),(39870,1108,'da','Fejl tilfÃ¸je prisliste.',0),(39871,1108,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê°€ê²© ëª©ë¡ìž…ë‹ˆë‹¤.',0),(39872,1108,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×ž×—×™×¨×•×Ÿ',0),(39873,1108,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½.',0),(39874,1108,'zh','é”™è¯¯ï¼šæ–°å¢žä»·æ ¼è¡¨\r\n',0),(39875,1108,'sv','Fel att lÃ¤gga till prislistan.',0),(39876,1108,'it','Listino aggiungendo errore.',0),(39877,1108,'tl','',0),(39878,1108,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(39879,1108,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€à¥¤',0),(39880,1108,'ms','Ralat menambah senarai harga.',0),(39881,1108,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(39882,1108,'fr','Ajout liste erreur de prix.',0),(39883,1108,'jp','ä¾¡æ ¼è¡¨ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(39884,1108,'pt','Lista de preÃ§o de erro adicionando.',0),(39885,1108,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚.',0),(39886,1108,'es','Error agregando lista de precios',0),(39887,1108,'de','Fehler hinzufÃ¼gen Preisliste.',0),(39888,1108,'en','Error adding price list.',0),(39889,1109,'is','',0),(39890,1109,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(39891,1109,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(39892,1109,'tr','Fiyat listesi stok eklenirken bir hata oluÅŸtu.',0),(39893,1109,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania cena lista zapasÃ³w.',0),(39894,1109,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð².',0),(39895,1109,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(39896,1109,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ.',0),(39897,1109,'vi','ThÃªm danh sÃ¡ch giÃ¡ hÃ ng tá»“n bá»‹ lá»—i',0),(39898,1109,'af','Fout het ontstaan met die byvoeging van voorraad pryslys.',0),(39899,1109,'ro','Eroare la adÄƒugarea Pret lista stoc.',0),(39900,1109,'et','Viga lisades hind nimekirja stock.',0),(39901,1109,'si','Napaka pri dodajanju cena seznam zalog.',0),(39902,1109,'ba','Kesalahan menambahkan daftar harga saham.',0),(39903,1109,'nl','Fout bij het toevoegen van prijs lijst voorraad.',0),(39904,1109,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ hinta luettelo varastossa.',0),(39905,1109,'no','Feil under tillegging pris liste lager.',0),(39906,1109,'da','Fejl under tilfÃ¸jelse af listen aktiekurs.',0),(39907,1109,'ko','ê°€ê²© ëª©ë¡ ì£¼ì‹ì„ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(39908,1109,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™.',0),(39909,1109,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î§ÏÎ·Î¼Î±Ï„Î¹ÏƒÏ„Î®ÏÎ¹Î¿.',0),(39910,1109,'zh','é”™è¯¯æ·»åŠ ä»·ç›®è¡¨è‚¡ç¥¨ã€‚\r\n',0),(39911,1109,'sv','Fel att lÃ¤gga till pris lista lager.',0),(39912,1109,'it','Errore aggiungendo brodo di elenco prezzi.',0),(39913,1109,'tl','',0),(39914,1109,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3',0),(39915,1109,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(39916,1109,'ms','Ralat menambah stok senarai harga.',0),(39917,1109,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø£Ø³Ù‡Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(39918,1109,'fr','Erreur lors de l\'ajout de stock de liste de prix.',0),(39919,1109,'jp','Error adding price list stock.',0),(39920,1109,'pt','Erro ao adicionar estoque lista de preÃ§o.',0),(39921,1109,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÐ¿Ð¸ÑÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ñ†ÐµÐ½Ð°.',0),(39922,1109,'es','Error agregando el stock de la lista de precios',0),(39923,1109,'de','Fehler beim HinzufÃ¼gen der Preis Liste Lager.',0),(39924,1109,'en','Error adding price list stock.',0),(39925,1110,'is','',0),(39926,1110,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(39927,1110,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(39928,1110,'tr','Fiyat listesi stok kullanÄ±mÄ± eklenirken bir hata oluÅŸtu.',0),(39929,1110,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania cena listy czas uÅ¼ytkowania.',0),(39930,1110,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¾ÑÐ½Ð¾Ð²ÐµÐ½ Ð¾Ñ‚Ð½Ð°ÑÑÐ½Ðµ.',0),(39931,1110,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(39932,1110,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¾Ð³ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ðµ.',0),(39933,1110,'vi','ThÃªm danh sÃ¡ch giÃ¡ sá»­ dá»¥ng hÃ ng tá»“n bá»‹ lá»—i',0),(39934,1110,'af','Fout het ontstaan met die byvoeging van pryslys vir voorraadgebruik.',0),(39935,1110,'ro','Eroare la adÄƒugarea Pret lista stoc de utilizare.',0),(39936,1110,'et','Viga lisades hind nimekirja varude kasutamine.',0),(39937,1110,'si','Napaka pri dodajanju cena seznam zalog navada.',0),(39938,1110,'ba','Kesalahan menambahkan daftar harga saham penggunaan.',0),(39939,1110,'nl','Fout bij het toevoegen van prijs lijst voorraad gebruik.',0),(39940,1110,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ hinta luetteloon kaluston kÃ¤yttÃ¶.',0),(39941,1110,'no','Feil under tillegging pris listen lagerforbruket.',0),(39942,1110,'da','Fejl ved tilfÃ¸jelse af pris liste stock skik.',0),(39943,1110,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš©ì„ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(39944,1110,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¨×©×™×ž×ª ×ž×—×™×¨ ×”×©×™×ž×•×© ×ž× ×™×•×ª.',0),(39945,1110,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Ï‡ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½.',0),(39946,1110,'zh','é”™è¯¯æ·»åŠ ä»·ç›®è¡¨è‚¡ç¥¨ç”¨æ³•',0),(39947,1110,'sv','Fel att lÃ¤gga till pris lista lageranvÃ¤ndningen.',0),(39948,1110,'it','Errore durante l\'aggiunta uso magazzino di elenco prezzi.',0),(39949,1110,'tl','',0),(39950,1110,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3',0),(39951,1110,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(39952,1110,'ms','Ralat menambah penggunaan stok senarai harga.',0),(39953,1110,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(39954,1110,'fr','Erreur lors de l\'ajout d\'utilisation stock liste de prix.',0),(39955,1110,'jp','Error adding price list stock usage.',0),(39956,1110,'pt','Erro ao adicionar o uso das aÃ§Ãµes da lista de preÃ§o.',0),(39957,1110,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½Ð° Ð°ÐºÑ†Ð¸Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑÐ¿Ð¸ÑÐºÐ°.',0),(39958,1110,'es','Error agregando uso de stock de lista de precios',0),(39959,1110,'de','Fehler beim HinzufÃ¼gen der Preis Liste hat Verwendung.',0),(39960,1110,'en','Error adding price list stock usage.',0),(39961,1111,'is','',0),(39962,1111,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(39963,1111,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(39964,1111,'tr','Fiyat listesi stok kullanÄ±mÄ± stok listesi eklenirken bir hata oluÅŸtu.',0),(39965,1111,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania cena lista zapasÃ³w czas uÅ¼ytkowania.',0),(39966,1111,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ ÑÑŠÑÑ‚Ð°Ð².',0),(39967,1111,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ø³Ù¹Ø§Ú© ÙÛØ±Ø³Øª Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(39968,1111,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¾Ð³ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð»Ð°Ð³ÐµÑ€ Ð»Ð¸ÑÑ‚Ð°.',0),(39969,1111,'vi','ThÃªm danh sÃ¡ch giÃ¡ sá»­ dá»¥ng hÃ ng tá»“n bá»‹ lá»—i',0),(39970,1111,'af','Fout het ontstaan met die byvoeging van gebruikte voorraad voorraadlys.',0),(39971,1111,'ro','Eroare la adÄƒugarea Pret lista stoc utilizare stoc listÄƒ.',0),(39972,1111,'et','Viga lisades hind nimekirja varude kasutamise nimestik.',0),(39973,1111,'si','Napaka pri dodajanju cena seznam zalog seznam zalog uporabe.',0),(39974,1111,'ba','Kesalahan menambahkan daftar saham saham penggunaan daftar harga.',0),(39975,1111,'nl','Fout bij het toevoegen van de lijst voorraad gebruik voorraad prijslijst.',0),(39976,1111,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ hinnasto luettelon kaluston kÃ¤yttÃ¶ varastossa.',0),(39977,1111,'no','Feil under tillegging lager av prisliste pÃ¥ listen av lagerforbruket.',0),(39978,1111,'da','Fejl ved tilfÃ¸jelse af prisliste liste stock skik stock.',0),(39979,1111,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš© ìž¬ê³  ëª©ë¡ì„ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(39980,1111,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¨×©×™×ž×ª ×©×™×ž×•×© ×ž× ×™×•×ª ×ž× ×™×•×ª ×ž×—×™×¨×•×Ÿ.',0),(39981,1111,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½.',0),(39982,1111,'zh','è‚¡ç¥¨çš„ä»·æ ¼è¡¨ï¼ŒåŠ å…¥é”™è¯¯ç”¨æ³•åº“å­˜æ¸…å•ã€‚',0),(39983,1111,'sv','Fel att lÃ¤gga till listan lageranvÃ¤ndningen lager prislista.',0),(39984,1111,'it','Errore durante l\'aggiunta lista stock utilizzo stock listino.',0),(39985,1111,'tl','',0),(39986,1111,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3',0),(39987,1111,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥‚à¤šà¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(39988,1111,'ms','Ralat menambah senarai saham saham penggunaan senarai harga.',0),(39989,1111,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø£Ø³Ù‡Ù….',0),(39990,1111,'fr','Erreur ajout liste stock stock utilisation liste de prix.',0),(39991,1111,'jp','Error adding price list stock usage stock list.',0),(39992,1111,'pt','Erro ao adicionar a lista de estoque preÃ§o lista aÃ§Ãµes de uso.',0),(39993,1111,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐ¾Ðº Ð°ÐºÑ†Ð¸Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð·Ð°Ð¿Ð°ÑÐ¾Ð².',0),(39994,1111,'es','Error agregando lista de stock del uso de lista de precios del stock',0),(39995,1111,'de','Fehler beim HinzufÃ¼gen der Preis Liste hat Verwendung Lagerliste.',0),(39996,1111,'en','Error adding price list stock usage stock list.',0),(39997,1112,'is','',0),(39998,1112,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ú†Ø§Ù¾',0),(39999,1112,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ú†Ø§Ù¾',0),(40000,1112,'tr','YazdÄ±rma konumu ekleme hatasÄ±',0),(40001,1112,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania lokalizacji wydruku',0),(40002,1112,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(40003,1112,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(40004,1112,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(40005,1112,'vi','ThÃªm vá»‹ trÃ­ in bá»‹ lá»—i',0),(40006,1112,'af','Fout met byvoeging van Uitdrukbare Punt',0),(40007,1112,'ro','Eroare la adÄƒugarea imprimare locaÅ£ie',0),(40008,1112,'et','Viga lisades Prindi asukoht',0),(40009,1112,'si','Napaka pri dodajanju tiskanja mesto',0),(40010,1112,'ba','Kesalahan menambahkan lokasi cetak',0),(40011,1112,'nl','Fout toe te voegen afdrukpositie',0),(40012,1112,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tulosta sijainti',0),(40013,1112,'no','Feil under tillegging utskriftsplassering',0),(40014,1112,'da','Fejl ved tilfÃ¸jelse af Print placering',0),(40015,1112,'ko','ì¸ì‡„ ìœ„ì¹˜ë¥¼ ì¶”ê°€ í•˜ëŠ” ì˜¤ë¥˜',0),(40016,1112,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×ž×™×§×•× ×”×”×“×¤×¡×”',0),(40017,1112,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¸Î­ÏƒÎ·Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(40018,1112,'zh','é”™è¯¯ï¼šæ–°å¢žæ‰“å°ä½ç½®',0),(40019,1112,'sv','Fel att lÃ¤gga ut lÃ¤ge',0),(40020,1112,'it','Errore durante l\'aggiunta area di stampa',0),(40021,1112,'tl','',0),(40022,1112,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(40023,1112,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(40024,1112,'ms','Ralat menambah lokasi cetakan',0),(40025,1112,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(40026,1112,'fr','Erreur en ajoutant l\'emplacement de l\'impression',0),(40027,1112,'jp','å?°åˆ·ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40028,1112,'pt','Erro ao adicionar o local de impressÃ£o',0),(40029,1112,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(40030,1112,'es','Error Agregando ColocaciÃ³n de ImpresiÃ³n',0),(40031,1112,'de','Fehler beim Drucken Speicherort hinzufÃ¼gen',0),(40032,1112,'en','Error Adding Print Location',0),(40033,1113,'is','',0),(40034,1113,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡',0),(40035,1113,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡',0),(40036,1113,'tr','TÄ±rnak iÅŸareti ekleme hatasÄ±',0),(40037,1113,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania oferty',0),(40038,1113,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(40039,1113,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: Ø§Ø¶Ø§ÙÛ Ú©Ø±ØªØ§ ÛÙˆØ§ Ù†Ù‚Øµ',0),(40040,1113,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(40041,1113,'vi','ThÃªm bÃ¡o giÃ¡ bá»‹ lá»—i',0),(40042,1113,'af','Fout voeg aanhaling',0),(40043,1113,'ro','Eroare la adÄƒugarea citat',0),(40044,1113,'et','Viga lisades quote',0),(40045,1113,'si','Napaka pri dodajanju ponudbo',0),(40046,1113,'ba','Kesalahan menambahkan kutipan',0),(40047,1113,'nl','Fout citaat toevoegen',0),(40048,1113,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ lainaus',0),(40049,1113,'no','Feil under tillegging av tilbud',0),(40050,1113,'da','Fejl ved tilfÃ¸jelse af tilbud',0),(40051,1113,'ko','ê²¬ì  ì¶”ê°€ ì˜¤ë¥˜',0),(40052,1113,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¦×™×˜×•×˜',0),(40053,1113,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(40054,1113,'zh','é”™è¯¯æ·»åŠ æŠ¥ä»·',0),(40055,1113,'sv','Fel att lÃ¤gga till citat',0),(40056,1113,'it','Errore durante l\'aggiunta citazione',0),(40057,1113,'tl','',0),(40058,1113,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3',0),(40059,1113,'hi','à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(40060,1113,'ms','Ralat menambah petikan',0),(40061,1113,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(40062,1113,'fr','Erreur ajout citation',0),(40063,1113,'jp','è¦‹ç©?ã‚‚ã‚Šã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40064,1113,'pt','Erro ao adicionar citaÃ§Ã£o',0),(40065,1113,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(40066,1113,'es','Error agregando cotizaciÃ³n',0),(40067,1113,'de','Fehler beim HinzufÃ¼gen von Zitat',0),(40068,1113,'en','Error adding quote',0),(40069,1114,'is','',0),(40070,1114,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø¸Ø±Ø§Øª Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡',0),(40071,1114,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø¸Ø±Ø§Øª Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡',0),(40072,1114,'tr','AlÄ±ntÄ± yorum ekleme hatasÄ±',0),(40073,1114,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania cytat komentarz',0),(40074,1114,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(40075,1114,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: ØªØ¨ØµØ±Û Ø§Ø¶Ø§ÙÛ Ú©Ø±ØªØ§ ÛÙˆØ§ Ù†Ù‚Øµ',0),(40076,1114,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(40077,1114,'vi','ThÃªm nháº­n xÃ©t bÃ¡o giÃ¡ bá»‹ lá»—i',0),(40078,1114,'af','Fout aanhaling Voeg kommentaar',0),(40079,1114,'ro','Eroare la adÄƒugarea citat comentariu',0),(40080,1114,'et','Viga lisades tsiteerida kommentaari',0),(40081,1114,'si','Napaka pri dodajanju citiram komentar',0),(40082,1114,'ba','Kesalahan menambahkan kutipan komentar',0),(40083,1114,'nl','Fout citaat commentaar toe te voegen',0),(40084,1114,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ lainaus kommentti',0),(40085,1114,'no','Feil under tillegging sitat kommentar',0),(40086,1114,'da','Fejl under tilfÃ¸jelse citat kommentar',0),(40087,1114,'ko','ì¸ìš© ì½”ë©˜íŠ¸ ì¶”ê°€ ì˜¤ë¥˜',0),(40088,1114,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¦×™×˜×•×˜ ×ª×’×•×‘×”',0),(40089,1114,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€Î±ÏÎ±Î¸Î­Ï„Ï‰ ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(40090,1114,'zh','é”™è¯¯æ·»åŠ æŠ¥ä»·è¯„è®º',0),(40091,1114,'sv','Fel att lÃ¤gga till citat kommentar',0),(40092,1114,'it','Errore durante l\'aggiunta citazione commento',0),(40093,1114,'tl','',0),(40094,1114,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3623;&#3634;&#3617;&#3648;&#3627;&#3655;&#3609;&#3607;&#3637;&#3656;&#3651;&#3',0),(40095,1114,'hi','à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(40096,1114,'ms','Ralat menambah petikan komen',0),(40097,1114,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© ØªØ¹Ù‚ÙŠØ¨ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(40098,1114,'fr','Erreur ajout citation commentaire',0),(40099,1114,'jp','è¦‹ç©?ã‚‚ã‚Šæ³¨é‡ˆã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40100,1114,'pt','Erro ao adicionar citar comentÃ¡rio',0),(40101,1114,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹',0),(40102,1114,'es','Error agregando comentario de CotizaciÃ³n',0),(40103,1114,'de','Fehler beim zitieren Kommentar hinzufÃ¼gen',0),(40104,1114,'en','Error adding quote comment',0),(40105,1115,'is','',0),(40106,1115,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø±Ø³ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ',0),(40107,1115,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø±Ø³ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ',0),(40108,1115,'tr','Bu Ã¶ÄŸe iÃ§in okundu bilgisi ekleme hatasÄ±',0),(40109,1115,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania odbioru dla tego przedmiotu',0),(40110,1115,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(40111,1115,'ur','Ø§Ø³ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ø±Ø³ÛŒØ¯ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(40112,1115,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° Ð·Ð° Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(40113,1115,'vi','Lá»—i khi thÃªm biÃªn nháº­n cho hÃ ng nÃ y',0),(40114,1115,'af','Fout met skep van ontvang vir hierdie item',0),(40115,1115,'ro','Eroare la adÄƒugarea primirea pentru acest element',0),(40116,1115,'et','Viga lisades selle kauba kÃ¤tte',0),(40117,1115,'si','Napaka pri dodajanju potrdilo za ta element',0),(40118,1115,'ba','Kesalahan yang menambahkan tanda terima untuk item ini',0),(40119,1115,'nl','Fout ontvangst voor dit item toe te voegen',0),(40120,1115,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ saamisesta tÃ¤lle kohteelle',0),(40121,1115,'no','Feil under tillegging av kvittering pÃ¥ elementversjonen',0),(40122,1115,'da','Fejl ved tilfÃ¸jelse af kvittering for dette element',0),(40123,1115,'ko','ì´ í•­ëª©ì— ëŒ€ í•œ ì˜ìˆ˜ì¦ ì¶”ê°€ ì˜¤ë¥˜',0),(40124,1115,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ××™×©×•×¨ ×¢×‘×•×¨ ×¤×¨×™×˜ ×–×”',0),(40125,1115,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(40126,1115,'zh','é”™è¯¯æ·»åŠ è¿™ä¸ªé¡¹ç›®çš„æ”¶æ®',0),(40127,1115,'sv','Fel att lÃ¤gga till kvitto fÃ¶r objektet',0),(40128,1115,'it','Errore durante l\'aggiunta ricevuta per questo elemento',0),(40129,1115,'tl','',0),(40130,1115,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3619;&#3633;&#3610;&#3648;&#3591;&#3',0),(40131,1115,'hi','à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¸à¥€à¤¦ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(40132,1115,'ms','Ralat menambah resit untuk item ini',0),(40133,1115,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© ØªÙ„Ù‚ÙŠ Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¨Ù†Ø¯',0),(40134,1115,'fr','Erreur en ajoutant des rÃ©ception pour cet article',0),(40135,1115,'jp','ã?“ã?®å“?ç›®ã?®é ˜å?Žæ›¸ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40136,1115,'pt','Erro ao adicionar o recibo para este item',0),(40137,1115,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(40138,1115,'es','Error agregandorecibo para este item',0),(40139,1115,'de','Fehler beim HinzufÃ¼gen der Quittung fÃ¼r diesen Artikel',0),(40140,1115,'en','Error adding receipt for this item',0),(40141,1116,'is','',0),(40142,1116,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(40143,1116,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(40144,1116,'tr','GÃ¶zden geÃ§irme derecelendirme ekleme hatasÄ±',0),(40145,1116,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania PrzeglÄ…d Ocena',0),(40146,1116,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(40147,1116,'ur','Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©ÛŒ Ø±ÛŒÙ¹Ù†Ú¯ Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø±ØªØ§ ÛÙˆØ§ Ù†Ù‚Øµ',0),(40148,1116,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³Ð°',0),(40149,1116,'vi','ThÃªm thang Ä‘Ã¡nh giÃ¡ bá»‹ lá»—i',0),(40150,1116,'af','Fout voeg hersiening gradering',0),(40151,1116,'ro','Eroare la adÄƒugarea de revizuire evaluare',0),(40152,1116,'et','Viga lisades lÃ¤bivaatamise reiting',0),(40153,1116,'si','Napaka pri dodajanju pregled ocena',0),(40154,1116,'ba','Kesalahan menambahkan nilai Tinjauan',0),(40155,1116,'nl','Fout herziening beoordeling toevoegen',0),(40156,1116,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ review Luokitus',0),(40157,1116,'no','Feil Ã¥ legge VurderingsnivÃ¥',0),(40158,1116,'da','Fejl ved tilfÃ¸jelse af anmeldelse rating',0),(40159,1116,'ko','ê²€í†  ë“±ê¸‰ ì¶”ê°€ ì˜¤ë¥˜',0),(40160,1116,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¡×§×™×¨×” ×“×™×¨×•×’',0),(40161,1116,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î²Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(40162,1116,'zh','é”™è¯¯æ·»åŠ å®¡æ ¸çº§åˆ«',0),(40163,1116,'sv','Fel att lÃ¤gga recension betyg',0),(40164,1116,'it','Errore durante l\'aggiunta recensione punteggio',0),(40165,1116,'tl','',0),(40166,1116,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3607;&#3610;&#3607;&#3623;&#3609;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;',0),(40167,1116,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(40168,1116,'ms','Ralat menambah kajian penilaian',0),(40169,1116,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© ØªØµÙ†ÙŠÙ Ø§Ø³ØªØ¹Ø±Ø§Ø¶',0),(40170,1116,'fr','Erreur en ajoutant le prix |',0),(40171,1116,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼è©•ä¾¡ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40172,1116,'pt','Erro ao adicionar a classificaÃ§Ã£o de revisÃ£o',0),(40173,1116,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐžÐ±Ð·Ð¾Ñ€ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(40174,1116,'es','Error agregando valuaciÃ³n de la revisiÃ³n',0),(40175,1116,'de','Fehler beim HinzufÃ¼gen der Digitalkamera Test',0),(40176,1116,'en','Error adding review rating',0),(40177,1117,'is','',0),(40178,1117,'dr','(ÙØ±ÙˆØ´',0),(40179,1117,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø³Ù†Ù„ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ (ÙØ±ÙˆØ´',0),(40180,1117,'tr','Hata ekleme satÄ±ÅŸ personeli',0),(40181,1117,'pl','BÅ‚Ä…d dodawania personelu sprzedaÅ¼y',0),(40182,1117,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(40183,1117,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ø³ÛŒÙ„Ø² Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø±',0),(40184,1117,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(40185,1117,'vi','ThÃªm nhÃ¢n viÃªn kinh doanh bá»‹ lá»—i',0),(40186,1117,'af','Fout het ontstaan met die skep van Verkoopspersoneel',0),(40187,1117,'ro','Eroare adÄƒugarea personal de vÃ¢nzÄƒri',0),(40188,1117,'et','Viga lisades mÃ¼Ã¼gipersonalile',0),(40189,1117,'si','Napaka pri dodajanju prodajno osebje',0),(40190,1117,'ba','Personil penjualan menambahkan kesalahan',0),(40191,1117,'nl','Fout toe te voegen verkooppersoneel',0),(40192,1117,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ myyntihenkilÃ¶stÃ¶Ã¤',0),(40193,1117,'no','Feil Ã¥ legge til selgere',0),(40194,1117,'da','Fejl tilfÃ¸je salgspersonale',0),(40195,1117,'ko','ì˜¤ë¥˜ ì¶”ê°€ íŒë§¤ ì§ì›',0),(40196,1117,'he','×× ×©×™ ×ž×›×™×¨×•×ª ×”×•×¡×¤×ª ×”×©×’×™××”',0),(40197,1117,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ¿Ï Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(40198,1117,'zh','é”™è¯¯æ·»åŠ é”€å”®äººå‘˜',0),(40199,1117,'sv','Fel att lÃ¤gga sÃ¤ljpersonal',0),(40200,1117,'it','Personale di vendita aggiungendo errore',0),(40201,1117,'tl','',0),(40202,1117,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(40203,1117,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚',0),(40204,1117,'ms','Ralat menambah kakitangan jualan',0),(40205,1117,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø£ÙØ±Ø§Ø¯ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(40206,1117,'fr','Ajout personnel de vente par erreur',0),(40207,1117,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¹ã‚¿ãƒƒãƒ•ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40208,1117,'pt','Pessoal de vendas erro adicionando',0),(40209,1117,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(40210,1117,'es','Error agregando personal de ventas',0),(40211,1117,'de','Fehler HinzufÃ¼gen von Verkaufspersonal',0),(40212,1117,'en','Error adding sales personnel',0),(40213,1118,'is','',0),(40214,1118,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(40215,1118,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(40216,1118,'tr','SatÄ±ÅŸ vergisi ekleme hatasÄ±',0),(40217,1118,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania podatku',0),(40218,1118,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(40219,1118,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø±ØªØ§ ÛÙˆØ§ Ù†Ù‚Øµ',0),(40220,1118,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(40221,1118,'vi','ThÃªm thuáº¿ bÃ¡n hÃ ng bá»‹ lá»—i',0),(40222,1118,'af','Fout voeg verkoopsbelasting',0),(40223,1118,'ro','Eroare la adÄƒugarea impozit pe vÃ¢nzÄƒri',0),(40224,1118,'et','Viga lisades kÃ¤ibemaksu',0),(40225,1118,'si','Napaka pri dodajanju prometnega davka',0),(40226,1118,'ba','Kesalahan menambahkan pajak penjualan',0),(40227,1118,'nl','Fout toe te voegen omzetbelasting',0),(40228,1118,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ arvonlisÃ¤vero',0),(40229,1118,'no','Feil under tillegging av mva',0),(40230,1118,'da','Fejl ved tilfÃ¸jelse af moms',0),(40231,1118,'ko','íŒë§¤ ì„¸ê¸ˆ ì¶”ê°€ í•˜ëŠ” ì˜¤ë¥˜',0),(40232,1118,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×ž×¡ ×ž×›×™×¨×•×ª',0),(40233,1118,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(40234,1118,'zh','é”™è¯¯ï¼šæ–°å¢žé”€å”®ç¨Ž',0),(40235,1118,'sv','Fel att lÃ¤gga till moms',0),(40236,1118,'it','Errore durante l\'aggiunta IVA',0),(40237,1118,'tl','',0),(40238,1118,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(40239,1118,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(40240,1118,'ms','Ralat menambah cukai jualan',0),(40241,1118,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(40242,1118,'fr','Erreur en ajoutant la taxe de vente',0),(40243,1118,'jp','å£²ä¸Šç¨Žã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40244,1118,'pt','Erro ao adicionar o imposto sobre vendas',0),(40245,1118,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð°Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¾Ð±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(40246,1118,'es','Error agregando IVA',0),(40247,1118,'de','Fehler beim HinzufÃ¼gen der Umsatzsteuer',0),(40248,1118,'en','Error adding sales tax',0),(40249,1119,'is','',0),(40250,1119,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø±ÙˆØ´ Ø­Ù…Ù„ ',0),(40251,1119,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø±ÙˆØ´ Ø­Ù…Ù„ ',0),(40252,1119,'tr','Nakliye yÃ¶ntemi ekleme hatasÄ±',0),(40253,1119,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania metody wysyÅ‚ki',0),(40254,1119,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð°Ñ‡Ð¸Ð½ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(40255,1119,'ur','Ú©Ø´ØªÛŒ Ø±Ø§Ù†ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø±ØªØ§ ÛÙˆØ§ Ù†Ù‚Øµ',0),(40256,1119,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð½Ð°Ñ‡Ð¸Ð½ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(40257,1119,'vi','Lá»—i khi thÃªm phÆ°Æ¡ng thá»©c váº­n chuyá»ƒn',0),(40258,1119,'af','Fout met byvoeging van Versendingsmetode',0),(40259,1119,'ro','Eroare la adÄƒugarea metoda de transport maritim',0),(40260,1119,'et','Tarneviisi lisamisel tekkis viga',0),(40261,1119,'si','Napaka pri dodajanju naÄin poÅ¡iljanja',0),(40262,1119,'ba','Kesalahan menambahkan metode pengiriman',0),(40263,1119,'nl','Fout scheepvaart methode toe te voegen',0),(40264,1119,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ toimitustapa',0),(40265,1119,'no','Feil under tillegging av leveringsmÃ¥tene',0),(40266,1119,'da','Fejl ved tilfÃ¸jelse af shipping metode',0),(40267,1119,'ko','ë°°ì†¡ ë°©ë²• ì¶”ê°€ ì˜¤ë¥˜',0),(40268,1119,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×©×™×˜×ª ×”×ž×©×œ×•×—',0),(40269,1119,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎœÎ•Î˜ÎŸÎ”ÎŸÎ¥ Î‘Î ÎŸÎ£Î¤ÎŸÎ›Î—Î£',0),(40270,1119,'zh','é”™è¯¯æ·»åŠ é€è´§æ–¹å¼',0),(40271,1119,'sv','Fel att lÃ¤gga till leveranssÃ¤tt',0),(40272,1119,'it','Errore aggiungendo il metodo di spedizione',0),(40273,1119,'tl','',0),(40274,1119,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(40275,1119,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤ªà¤¦à¥à¤§à¤¤à¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(40276,1119,'ms','Ralat menambah kaedah penghantaran',0),(40277,1119,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø´Ø­Ù†',0),(40278,1119,'fr','Erreur en ajoutant le mode de livraison',0),(40279,1119,'jp','é…?é€?æ–¹æ³•ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40280,1119,'pt','Erro ao adicionar o mÃ©todo de envio',0),(40281,1119,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ¿Ð¾ÑÐ¾Ð±Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(40282,1119,'es','Error agregando mÃ©todo de envÃ­o',0),(40283,1119,'de','Fehler beim HinzufÃ¼gen der Versandart',0),(40284,1119,'en','Error adding shipping method',0),(40285,1120,'is','',0),(40286,1120,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙŠØ³ØªÙ… ØªÙØ§ÙˆØª Ø¨ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ù‚ÙŠÙ…Øª Ú©Ø§Ù„Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(40287,1120,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙŠØ³ØªÙ… ØªÙØ§ÙˆØª Ø¨ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ù‚ÙŠÙ…Øª Ú©Ø§Ù„Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(40288,1120,'tr','Standart biÃ§imlendirme kÃ¼me eklenirken bir hata oluÅŸtu.',0),(40289,1120,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania, standardowy zestaw znacznikÃ³w.',0),(40290,1120,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Markup Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼.',0),(40291,1120,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(40292,1120,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ð¸ Ð½Ð°Ð·Ð½Ð°ÐºÐµ.',0),(40293,1120,'vi','ThÃªm giÃ¡ cá»™ng thÃªm chuáº©n bá»‹ lá»—i',0),(40294,1120,'af','Fout standaard Markup stel te voeg.',0),(40295,1120,'ro','Eroare la adÄƒugarea Set Standard de marcare.',0),(40296,1120,'et','Viga lisades Standard mÃ¤rgistuskeel mÃ¤Ã¤ra.',0),(40297,1120,'si','Napaka pri dodajanju Standard oznaÄevalni Set.',0),(40298,1120,'ba','Kesalahan menambahkan Standard Markup Set.',0),(40299,1120,'nl','Fout bij het toevoegen van standaard Markup ingesteld.',0),(40300,1120,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ standardijoukkoon Markup.',0),(40301,1120,'no','Feil under tillegging av Standard Markup satt.',0),(40302,1120,'da','Fejl ved tilfÃ¸jelse af Standard Markup sÃ¦t.',0),(40303,1120,'ko','í‘œì¤€ íƒœê·¸ ì§‘í•©ì„ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(40304,1120,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×”×’×“×¨ ×¡×™×ž×•×Ÿ ×¨×’×™×œ.',0),(40305,1120,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î´Î­ÏƒÎ¼Î·Ï‚ Ï€ÏÎ¿Ï„ÏÏ€Ï‰Î½ Markup.',0),(40306,1120,'zh','é”™è¯¯æ·»åŠ æ ‡å‡†æ ‡è®°é›†ã€‚\r\n',0),(40307,1120,'sv','Fel att Standard Markup.',0),(40308,1120,'it','Errore aggiungendo Markup Standard impostato.',0),(40309,1120,'tl','',0),(40310,1120,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;',0),(40311,1120,'hi','à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(40312,1120,'ms','Ralat menambah penanda Standard ditetapkan.',0),(40313,1120,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© \"ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©\".',0),(40314,1120,'fr','Erreur en ajoutant la valeur Standard de balisage.',0),(40315,1120,'jp','æ¨™æº–å€¤ä¸Šã?’è¨­å®šã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40316,1120,'pt','Erro ao adicionar marcaÃ§Ã£o padrÃ£o definida.',0),(40317,1120,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… Ð½Ð°Ð±Ð¾Ñ€Ð¾Ð² Ð¿Ð¾Ð¼ÐµÑ‚Ð¾Ðº.',0),(40318,1120,'es','Error agregando Juego de Encarecimiento EstÃ¡ndar',0),(40319,1120,'de','Fehler beim HinzufÃ¼gen der Standard Markup festgelegt.',0),(40320,1120,'en','Error adding Standard Markup Set.',0),(40321,1121,'is','',0),(40322,1121,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(40323,1121,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(40324,1121,'tr','Standart Ã¶lÃ§Ã¼ eklenirken bir hata oluÅŸtu.',0),(40325,1121,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania standardowego rozmiaru.',0),(40326,1121,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(40327,1121,'ur','Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ø³Ø§Ø¦Ø² Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(40328,1121,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ðµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ.',0),(40329,1121,'vi','ThÃªm cá»¡ chuáº©n bá»‹ lá»—i',0),(40330,1121,'af','Fout standaard grootte te voeg.',0),(40331,1121,'ro','Eroare la adÄƒugarea dimensiunea standard.',0),(40332,1121,'et','Viga lisades standard suurus.',0),(40333,1121,'si','Napaka pri dodajanju standardne velikosti.',0),(40334,1121,'ba','Kesalahan menambahkan ukuran standar.',0),(40335,1121,'nl','Fout bij het toevoegen van standaard formaat.',0),(40336,1121,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ vakiokoko.',0),(40337,1121,'no','Feil under tillegging av standard stÃ¸rrelse.',0),(40338,1121,'da','Fejl ved tilfÃ¸jelse af standard stÃ¸rrelse.',0),(40339,1121,'ko','í‘œì¤€ í¬ê¸°ë¥¼ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(40340,1121,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×‘×’×•×“×œ ×¡×˜× ×“×¨×˜×™.',0),(40341,1121,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÎ±Î½Î¿Î½Î¹ÎºÎ¿Ï Î¼ÎµÎ³Î­Î¸Î¿Ï…Ï‚.',0),(40342,1121,'zh','é”™è¯¯æ·»åŠ æ ‡å‡†å°ºå¯¸ã€‚\r\n',0),(40343,1121,'sv','Fel att lÃ¤gga till standardstorlek.',0),(40344,1121,'it','Errore durante l\'aggiunta di dimensioni standard.',0),(40345,1121,'tl','',0),(40346,1121,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3609;&#3634;&#3604;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;',0),(40347,1121,'hi','à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(40348,1121,'ms','Ralat menambah saiz standard.',0),(40349,1121,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ.',0),(40350,1121,'fr','Erreur lors de l\'ajout de taille standard.',0),(40351,1121,'jp','æ¨™æº–ã‚µã‚¤ã‚ºã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40352,1121,'pt','Erro ao adicionar o tamanho padrÃ£o.',0),(40353,1121,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð³Ð¾ Ñ€Ð°Ð·Ð¼ÐµÑ€Ð°.',0),(40354,1121,'es','Error agregando tamaÃ±o estÃ¡ndar',0),(40355,1121,'de','Fehler beim HinzufÃ¼gen der StandardgrÃ¶ÃŸe.',0),(40356,1121,'en','Error adding standard size.',0),(40357,1122,'is','',0),(40358,1122,'dr','(Ù…ÙˆØ¬ÙˆØ¯Ù‰ Ú¯Ø¯Ø§Ù…',0),(40359,1122,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù‡Ø§Ù… (Ù…ÙˆØ¬ÙˆØ¯Ù‰ Ø§Ù†Ø¨Ø§Ø±',0),(40360,1122,'tr','Hisse senedi eklenirken bir hata oluÅŸtu.',0),(40361,1122,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania fotografii.',0),(40362,1122,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´.',0),(40363,1122,'ur','Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(40364,1122,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð°ÐºÑ†Ð¸Ñ˜Ðµ.',0),(40365,1122,'vi','ThÃªm hÃ ng tá»“n kho bá»‹ lá»—i',0),(40366,1122,'af','Fout het ontstaan met die byvoeging van voorraad.',0),(40367,1122,'ro','Eroare la adÄƒugarea stoc.',0),(40368,1122,'et','Viga lisades stock.',0),(40369,1122,'si','Napaka pri dodajanju parka.',0),(40370,1122,'ba','Kesalahan menambahkan saham.',0),(40371,1122,'nl','Fout bij het toevoegen van de voorraad.',0),(40372,1122,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ varastossa.',0),(40373,1122,'no','Feil under tillegging av lager.',0),(40374,1122,'da','Fejl ved tilfÃ¸jelse af materiel.',0),(40375,1122,'ko','ì£¼ì‹ì„ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(40376,1122,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×ž× ×™×•×ª.',0),(40377,1122,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Ï€ÏŒÎ¸ÎµÎ¼Î±.',0),(40378,1122,'zh','é”™è¯¯ï¼šæ–°å¢žè‚¡ç¥¨ã€‚',0),(40379,1122,'sv','Fel att lÃ¤gga till lager.',0),(40380,1122,'it','Errore durante l\'aggiunta di brodo.',0),(40381,1122,'tl','',0),(40382,1122,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3605;&#3655;&#3629;&#3585;',0),(40383,1122,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(40384,1122,'ms','Ralat menambah stok.',0),(40385,1122,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ©.',0),(40386,1122,'fr','Erreur lors de l\'ajout de stock.',0),(40387,1122,'jp','åœ¨åº«ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40388,1122,'pt','Erro ao adicionar o estoque.',0),(40389,1122,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð·Ð°Ð¿Ð°ÑÐ¾Ð².',0),(40390,1122,'es','Error agregando stock',0),(40391,1122,'de','Fehler beim HinzufÃ¼gen der Lager.',0),(40392,1122,'en','Error adding stock.',0),(40393,1123,'is','',0),(40394,1123,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(40395,1123,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(40396,1123,'tr','alt grup ekleme hatasÄ±',0),(40397,1123,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania podgrupy',0),(40398,1123,'bg','Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð°',0),(40399,1123,'ur','Ø³Ø¨Ú¯Ø±ÙˆÙ¾ Ø§Ø¶Ø§ÙÛ Ú©Ø±ØªØ§ ÛÙˆØ§ Ù†Ù‚Øµ',0),(40400,1123,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ñƒ',0),(40401,1123,'vi','ThÃªm nhÃ³m phá»¥ bá»‹ lá»—i',0),(40402,1123,'af','fout supgroep te voeg',0),(40403,1123,'ro','Eroare la adÄƒugarea subgrup',0),(40404,1123,'et','viga lisades alarÃ¼hm',0),(40405,1123,'si','Napaka pri dodajanju podskupini',0),(40406,1123,'ba','kesalahan menambahkan subgrup',0),(40407,1123,'nl','fout in ondergroep toevoegen',0),(40408,1123,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ alaryhmÃ¤',0),(40409,1123,'no','feil under tillegging av undergruppe',0),(40410,1123,'da','fejl ved tilfÃ¸jelse af undergruppe',0),(40411,1123,'ko','í•˜ìœ„ ê·¸ë£¹ ì¶”ê°€ ì˜¤ë¥˜',0),(40412,1123,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×§×‘×•×¦×ª ×ž×©× ×”',0),(40413,1123,'el','ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï…Ï€Î¿Î¿Î¼Î¬Î´Î±',0),(40414,1123,'zh','é”™è¯¯ï¼šæ–°å¢žç¾¤',0),(40415,1123,'sv','fel att lÃ¤gga till undergruppen',0),(40416,1123,'it','errore durante l\'aggiunta sottogruppo',0),(40417,1123,'tl','',0),(40418,1123,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(40419,1123,'hi','à¤‰à¤ªà¤¸à¤®à¥‚à¤¹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(40420,1123,'ms','Ralat menambah subkumpulan',0),(40421,1123,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø© ÙØ±Ø¹ÙŠØ©',0),(40422,1123,'fr','erreur en ajoutant le sous-groupe',0),(40423,1123,'jp','ã‚µãƒ–ã‚°ãƒ«ãƒ¼ãƒ—ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40424,1123,'pt','erro ao adicionar o subgrupo',0),(40425,1123,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(40426,1123,'es','Error agregando subgrupo',0),(40427,1123,'de','Fehler beim HinzufÃ¼gen der Untergruppe',0),(40428,1123,'en','error adding subgroup',0),(40429,1124,'is','',0),(40430,1124,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(40431,1124,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(40432,1124,'tr','Hata ekleme vergi muafiyeti',0),(40433,1124,'pl','BÅ‚Ä…d dodawania zwolnienia z podatku',0),(40434,1124,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº',0),(40435,1124,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(40436,1124,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð±ÐµÐ· Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ†Ð°Ñ€Ð¸Ð½Ðµ',0),(40437,1124,'vi','ThÃªm miá»…n trá»« thuáº¿ bá»‹ lá»—i',0),(40438,1124,'af','Fout met byvoeging van belastingvrystelling',0),(40439,1124,'ro','Eroare adÄƒugarea scutire de impozit',0),(40440,1124,'et','Viga lisades maksuvabastus',0),(40441,1124,'si','Napaka dodajanje davÄne oprostitve',0),(40442,1124,'ba','Pembebasan pajak menambahkan kesalahan',0),(40443,1124,'nl','Fout belastingvrijstelling toe te voegen',0),(40444,1124,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ verovapautus',0),(40445,1124,'no','Feil Ã¥ legge skattefritak',0),(40446,1124,'da','Fejl tilfÃ¸je skattefrihed',0),(40447,1124,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì„¸ê¸ˆ ë©´ì œ',0),(40448,1124,'he','×¤×˜×•×¨ ×ž×ž×¡ ×”×•×¡×¤×ª ×”×©×’×™××”',0),(40449,1124,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï†Î¿ÏÎ¿Î±Ï€Î±Î»Î»Î±Î³Î® ÏƒÏ†Î¬Î»Î¼Î±',0),(40450,1124,'zh','é”™è¯¯æ·»åŠ å…ç¨Ž',0),(40451,1124,'sv','Fel att lÃ¤gga till skattebefrielse',0),(40452,1124,'it','Esenzione fiscale aggiungendo di errore',0),(40453,1124,'tl','',0),(40454,1124,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3',0),(40455,1124,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¤° à¤›à¥‚à¤Ÿ',0),(40456,1124,'ms','Ralat menambah pengecualian cukai ke',0),(40457,1124,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ',0),(40458,1124,'fr','ExonÃ©ration de l\'impÃ´t ajoutant erreur',0),(40459,1124,'jp','ç¨ŽæŽ§é™¤ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40460,1124,'pt','IsenÃ§Ã£o de imposto erro adicionando',0),(40461,1124,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ Ð¾Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(40462,1124,'es','Error agregando exenciÃ³n de impuesto',0),(40463,1124,'de','Fehler hinzufÃ¼gen Steuerbefreiung',0),(40464,1124,'en','Error adding tax exemption',0),(40465,1125,'is','',0),(40466,1125,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(40467,1125,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(40468,1125,'tr','Ä°zleme bilgisi eklenirken bir hata oluÅŸtu.',0),(40469,1125,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania info Å›ledzenia.',0),(40470,1125,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ.',0),(40471,1125,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(40472,1125,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ ÐºÑ€ÐµÑ‚Ð°ÑšÑƒ.',0),(40473,1125,'vi','Lá»—i khi thÃªm thÃ´ng tin dÃ² tÃ¬m',0),(40474,1125,'af','Fout met skepping van sporingsinligting.',0),(40475,1125,'ro','Eroare la adÄƒugarea de urmÄƒrire informaÅ£ii.',0),(40476,1125,'et','Viga lisades jÃ¤lgimise info.',0),(40477,1125,'si','Napaka pri dodajanju sledenje info.',0),(40478,1125,'ba','Kesalahan menambahkan pelacakan info.',0),(40479,1125,'nl','Fout bij het toevoegen van tracking info.',0),(40480,1125,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ seurantatiedot.',0),(40481,1125,'no','Feil under tillegging sporing info.',0),(40482,1125,'da','Fejl ved tilfÃ¸jelse af sporing info.',0),(40483,1125,'ko','ì¶”ì  ì •ë³´ë¥¼ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(40484,1125,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×ž×™×“×¢ ×ž×¢×§×‘.',0),(40485,1125,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚.',0),(40486,1125,'zh','é”™è¯¯æ–°å¢žè¿½è¸ªä¿¡æ¯ã€‚\r\n',0),(40487,1125,'sv','Fel att lÃ¤gga till tracking information.',0),(40488,1125,'it','Errore aggiungendo le informazioni di rilevamento.',0),(40489,1125,'tl','',0),(40490,1125,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3',0),(40491,1125,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(40492,1125,'ms','Ralat menambah info Penjejakan.',0),(40493,1125,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ¹Ù‚Ø¨.',0),(40494,1125,'fr','Erreur lors de l\'ajout d\'informations de suivi.',0),(40495,1125,'jp','ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°æƒ…å ±ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40496,1125,'pt','Erro ao adicionar informaÃ§Ã£o de rastreamento.',0),(40497,1125,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸.',0),(40498,1125,'es','Error agregando info de rastreo',0),(40499,1125,'de','Fehler beim HinzufÃ¼gen von Tracking-Informationen.',0),(40500,1125,'en','Error adding tracking info.',0),(40501,1126,'is','',0),(40502,1126,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ ',0),(40503,1126,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ ',0),(40504,1126,'tr','Hata ekleme birimi adÄ±',0),(40505,1126,'pl','BÅ‚Ä…d dodawania nazwy jednostki',0),(40506,1126,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¸Ð¼Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(40507,1126,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù…',0),(40508,1126,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð¼Ðµ',0),(40509,1126,'vi','ThÃªm tÃªn Ä‘Æ¡n vá»‹ bá»‹ lá»—i',0),(40510,1126,'af','Fout met skep van eenheidsnaam',0),(40511,1126,'ro','Eroare adÄƒugarea nume de unitatea de',0),(40512,1126,'et','Viga lisades Ã¼hiku nimi',0),(40513,1126,'si','Napaka dodal ime enote',0),(40514,1126,'ba','Nama unit menambahkan kesalahan',0),(40515,1126,'nl','Fout toe te voegen eenheid naam',0),(40516,1126,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ yksikÃ¶n nimi',0),(40517,1126,'no','Feil Ã¥ legge til navn',0),(40518,1126,'da','Fejl tilfÃ¸je enhed navn',0),(40519,1126,'ko','ì˜¤ë¥˜ ì¶”ê°€ ë‹¨ìœ„ ì´ë¦„',0),(40520,1126,'he','×©×’×™××” ×‘×©× ×™×—×™×“×ª ×”×•×¡×¤×ª',0),(40521,1126,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î± ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚',0),(40522,1126,'zh','é”™è¯¯æ·»åŠ å•ä½åç§°',0),(40523,1126,'sv','Fel att lÃ¤gga till enhetens namn',0),(40524,1126,'it','Errore aggiungendo nome unitÃ ',0),(40525,1126,'tl','',0),(40526,1126,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(40527,1126,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¾à¤®',0),(40528,1126,'ms','Ralat menambah unit nama',0),(40529,1126,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø¥Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø©',0),(40530,1126,'fr','Nom de l\'unitÃ© erreur ajout',0),(40531,1126,'jp','å?˜ä½?å??ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40532,1126,'pt','Nome da unidade de erro adicionando',0),(40533,1126,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ',0),(40534,1126,'es','Error agregando nombre de unidad',0),(40535,1126,'de','Fehler hinzufÃ¼gen GerÃ¤tename',0),(40536,1126,'en','Error adding unit name',0),(40537,1127,'is','',0),(40538,1127,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø± ',0),(40539,1127,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø± ',0),(40540,1127,'tr','Hata kullanÄ±cÄ± ekleniyor',0),(40541,1127,'pl','BÅ‚Ä…d dodawania uÅ¼ytkownika',0),(40542,1127,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(40543,1127,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ ØµØ§Ø±Ù',0),(40544,1127,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(40545,1127,'vi','ThÃªm NgÆ°á»i Sá»­ Dá»¥ng Bá»‹ Lá»—i',0),(40546,1127,'af','Fout met skep van gebruiker',0),(40547,1127,'ro','Eroare adaugare utilizator',0),(40548,1127,'et','Kasutaja lisamisel tekkis viga',0),(40549,1127,'si','Dodajanje uporabnika napaka',0),(40550,1127,'ba','Pengguna menambahkan kesalahan',0),(40551,1127,'nl','Fout toe te voegen gebruiker',0),(40552,1127,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ kÃ¤yttÃ¤jÃ¤Ã¤',0),(40553,1127,'no','Feil Ã¥ legge til bruker',0),(40554,1127,'da','Fejl tilfÃ¸je brugeren',0),(40555,1127,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì‚¬ìš©ìž',0),(40556,1127,'he','×©×’×™××” ×”×•×¡×¤×ª ×ž×©×ª×ž×©',0),(40557,1127,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï‡ÏÎ®ÏƒÏ„Î· ÏƒÏ†Î¬Î»Î¼Î±',0),(40558,1127,'zh','é”™è¯¯ï¼šæ–°å¢žç”¨æˆ·',0),(40559,1127,'sv','Fel att lÃ¤gga till anvÃ¤ndare',0),(40560,1127,'it','Utente aggiungendo errore',0),(40561,1127,'tl','',0),(40562,1127,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(40563,1127,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(40564,1127,'ms','Ralat menambah pengguna',0),(40565,1127,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(40566,1127,'fr','Erreur ajout utilisateur',0),(40567,1127,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40568,1127,'pt','Adicionando usuÃ¡rio erro',0),(40569,1127,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(40570,1127,'es','Error agregando usuario',0),(40571,1127,'de','Fehler HinzufÃ¼gen von Benutzer',0),(40572,1127,'en','Error adding user',0),(40573,1128,'is','',0),(40574,1128,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø± â€“ Ù†Ø§Ù… ØªÙƒØ±Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(40575,1128,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø± â€“ Ù†Ø§Ù… ØªÙƒØ±Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(40576,1128,'tr','Hata kullanÄ±cÄ± ekleniyor - yinelenen bir ad var.',0),(40577,1128,'pl','BÅ‚Ä…d dodawania uÅ¼ytkownika - istnieje duplikat nazwy',0),(40578,1128,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» - ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ñ‰Ð¾ ÑÐµ Ð¸Ð¼Ðµ',0),(40579,1128,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ ØµØ§Ø±Ù - Ù…Ø«Ù†ÛŒ Ù†Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Û”',0),(40580,1128,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° - Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚ Ð¸Ð¼Ðµ',0),(40581,1128,'vi','ThÃªm NgÆ°á»i Sá»­ Dá»¥ng Bá»‹ Lá»—i - TrÃ¹ng TÃªn',0),(40582,1128,'af','Fout met skep van gebruiker - gedupliseerde naam bestaan reeds',0),(40583,1128,'ro','Eroare utilizatorul adÄƒugarea - nume duplicat existÄƒ',0),(40584,1128,'et','Kasutaja lisamisel tekkis viga - sarnane nimi on juba olemas',0),(40585,1128,'si','Dodajanje uporabnika napaka - obstaja podvojeno ime',0),(40586,1128,'ba','Ada duplikasi nama pengguna menambahkan kesalahan-',0),(40587,1128,'nl','Fout toe te voegen gebruiker - dubbele naam bestaat',0),(40588,1128,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ kÃ¤yttÃ¤jÃ¤Ã¤ - on kahdentunut nimi',0),(40589,1128,'no','Feil Ã¥ legge til bruker - navnet finnes allerede',0),(40590,1128,'da','Fejl tilfÃ¸je bruger - identisk navn findes',0),(40591,1128,'ko','ì¡´ìž¬ í•˜ëŠ” ì¤‘ë³µ ì´ë¦„ ì˜¤ë¥˜ ì¶”ê°€ ì‚¬ìš©ìž-',0),(40592,1128,'he','×©×’×™××” ×”×•×¡×¤×ª ×”×ž×©×ª×ž×© - ×”×©× ×”×›×¤×•×œ ×§×™×™×',0),(40593,1128,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€Î¿ ÏŒÎ½Î¿Î¼Î± ÏƒÏ†Î¬Î»Î¼Î± Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï‡ÏÎ®ÏƒÏ„Î·-',0),(40594,1128,'zh','é”™è¯¯æ·»åŠ ç”¨æˆ·-å­˜åœ¨é‡å¤çš„åç§°\r\n',0),(40595,1128,'sv','Fel att lÃ¤gga till anvÃ¤ndare - dubblettnamn finns',0),(40596,1128,'it','Errore aggiunta utente - nome duplicato esiste',0),(40597,1128,'tl','',0),(40598,1128,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657; &#3617;&#3637;&#3594;&#3639;&#3656;&#3629;&#',0),(40599,1128,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ - à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤¨à¤¾à¤® à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(40600,1128,'ms','Ralat menambah pengguna - nama pendua wujud',0),(40601,1128,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… - Ø§Ù„Ø¥Ø³Ù… Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(40602,1128,'fr','Erreur ajout utilisateur - nom dupliquÃ© existe',0),(40603,1128,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼ãƒ¼å?Œã?˜å??å‰?ã?Œå­˜åœ¨ã?—ã?¾ã?™',0),(40604,1128,'pt','Erro adicionando usuÃ¡rio - nome duplicado existe',0),(40605,1128,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ - Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰ÐµÐµÑÑ Ð¸Ð¼Ñ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(40606,1128,'es','Error agregando usuario',0),(40607,1128,'de','Fehler HinzufÃ¼gen von Benutzer - vorhanden ist doppelter name',0),(40608,1128,'en','Error adding user - duplicate name exists',0),(40609,1129,'is','',0),(40610,1129,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(40611,1129,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(40612,1129,'tr','Hata ekleme satÄ±cÄ±',0),(40613,1129,'pl','BÅ‚Ä…d dodawania dostawcy',0),(40614,1129,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(40615,1129,'ur','Ù†Ù‚Øµ Ù…Ú©ÛŒÙ†ÙˆÚº ÙØ±ÙˆØ´Ù†Ø¯Û',0),(40616,1129,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(40617,1129,'vi','ThÃªm ngÆ°á»i bÃ¡n bá»‹ lá»—i',0),(40618,1129,'af','Fout voeg handelaar',0),(40619,1129,'ro','Eroare adÄƒugÃ¢nd furnizor',0),(40620,1129,'et','Tarnija lisamisel tekkis viga',0),(40621,1129,'si','Napaka dodajanje dobavitelja',0),(40622,1129,'ba','Penjual menambahkan kesalahan',0),(40623,1129,'nl','Fout toevoegen leverancier',0),(40624,1129,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ toimittajan',0),(40625,1129,'no','Feil Ã¥ legge til leverandÃ¸r',0),(40626,1129,'da','Fejl tilfÃ¸je leverandÃ¸r',0),(40627,1129,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê³µê¸‰ ì—…ì²´',0),(40628,1129,'he','×©×’×™××” ×”×•×¡×¤×ª ×¡×¤×§',0),(40629,1129,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(40630,1129,'zh','é”™è¯¯ï¼šæ–°å¢žä¾›åº”å•†',0),(40631,1129,'sv','Fel att lÃ¤gga till leverantÃ¶r',0),(40632,1129,'it','Fornitore aggiungendo errore',0),(40633,1129,'tl','',0),(40634,1129,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(40635,1129,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(40636,1129,'ms','Ralat menambah Penjual',0),(40637,1129,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(40638,1129,'fr','Vendeur ajoutant erreur',0),(40639,1129,'jp','æ¥­è€…ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40640,1129,'pt','Fornecedor de erro adicionando',0),(40641,1129,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(40642,1129,'es','Error agregando Proveedor',0),(40643,1129,'de','Fehler hinzufÃ¼gen von Lieferanten',0),(40644,1129,'en','Error adding vendor',0),(40645,1130,'is','',0),(40646,1130,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ù„Ø§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(40647,1130,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ù„Ø§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(40648,1130,'tr','Hata ekleme satÄ±cÄ± maddesi bilgilerinde',0),(40649,1130,'pl','BÅ‚Ä…d dodawania dostawcy element informacji',0),(40650,1130,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(40651,1130,'ur','Ù†Ù‚Øµ Ù…Ú©ÛŒÙ†ÙˆÚº ÙˆÛŒÙ†ÚˆØ± Ø´Û’ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(40652,1130,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ñƒ ÑÐ½Ð°Ð±Ð´ÐµÐ²Ð°Ñ‡Ð°',0),(40653,1130,'vi','Lá»—i khi thÃªm thÃ´ng tin ngÆ°á»i bÃ¡n',0),(40654,1130,'af','Fout met skep van verskaffer item informasie',0),(40655,1130,'ro','Eroare adÄƒugÃ¢nd furnizor articol informaÅ£ii',0),(40656,1130,'et','Viga lisades hankija kauba teabes',0),(40657,1130,'si','Napaka pri dodajanju podatke o artiklu dobavitelja',0),(40658,1130,'ba','Penjual menambahkan kesalahan informasi item',0),(40659,1130,'nl','Fout toevoegen leverancier objectgegevens',0),(40660,1130,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ toimittajan nimiketietoihin',0),(40661,1130,'no','Feil Ã¥ legge til element leverandÃ¸rinformasjon',0),(40662,1130,'da','Fejl tilfÃ¸je kreditor vareoplysninger',0),(40663,1130,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê³µê¸‰ ì—…ì²´ í•­ëª© ì •ë³´',0),(40664,1130,'he','×©×’×™××” ×”×•×¡×¤×ª ×¡×¤×§ ×¤×¨×™×˜ ×ž×™×“×¢',0),(40665,1130,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(40666,1130,'zh','é”™è¯¯ï¼šæ–°å¢žä¾›åº”å•†é¡¹ç›®ä¿¡æ¯\r\n',0),(40667,1130,'sv','Fel att lÃ¤gga till leverantÃ¶rens artikelinformation',0),(40668,1130,'it','Informazioni di errore aggiungendo fornitore elemento',0),(40669,1130,'tl','',0),(40670,1130,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3',0),(40671,1130,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤†à¤‡à¤Ÿà¤® à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(40672,1130,'ms','Penjual menambah kesilapan maklumat item',0),(40673,1130,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØµÙ†Ù Ù„Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(40674,1130,'fr','Erreur ajout vendeur point informations',0),(40675,1130,'jp','æ¥­è€…å“?ç›®æƒ…å ±ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40676,1130,'pt','Erro adicionando fornecedores informaÃ§Ãµes sobre o item',0),(40677,1130,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐµ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(40678,1130,'es','Error agregando informaciÃ³n de item de Proveedor',0),(40679,1130,'de','Fehler hinzufÃ¼gen Element Herstellerinformationen',0),(40680,1130,'en','Error adding vendor item information',0),(40681,1131,'is','',0),(40682,1131,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(40683,1131,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(40684,1131,'tr','SatÄ±cÄ± koÅŸullarÄ± ekleme hatasÄ±',0),(40685,1131,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania warunkÃ³w dostawcy',0),(40686,1131,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑƒÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(40687,1131,'ur','ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø· Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(40688,1131,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑƒÑÐ»Ð¾Ð²Ð¸',0),(40689,1131,'vi','ThÃªm Ä‘iá»u khoáº£n ngÆ°á»i bÃ¡n bá»‹ lá»—i',0),(40690,1131,'af','Fout verkoper terme by te voeg',0),(40691,1131,'ro','Eroare la adÄƒugarea termeni de furnizor',0),(40692,1131,'et','Viga lisades hankija tingimused',0),(40693,1131,'si','Napaka pri dodajanju pogoji dobavitelja',0),(40694,1131,'ba','Kesalahan menambahkan Vendor persyaratan',0),(40695,1131,'nl','Fout leverancier voorwaarden toevoegen',0),(40696,1131,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ toimittajan',0),(40697,1131,'no','Feil Ã¥ legge leverandÃ¸r termer',0),(40698,1131,'da','Fejl ved tilfÃ¸jelse af kreditor vilkÃ¥r',0),(40699,1131,'ko','ê³µê¸‰ ì—…ì²´ ì¡°ê±´ ì¶”ê°€ ì˜¤ë¥˜',0),(40700,1131,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×ª× ××™ ×¡×¤×§',0),(40701,1131,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(40702,1131,'zh','é”™è¯¯ï¼šæ–°å¢žä¾›åº”å•†æ¡æ¬¾',0),(40703,1131,'sv','Ett fel uppstod nÃ¤r leverantÃ¶ren termer',0),(40704,1131,'it','Errore durante l\'aggiunta di termini di fornitore',0),(40705,1131,'tl','',0),(40706,1131,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3586;&#3629;&#3591;&#3612;&#3641;&#3',0),(40707,1131,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤¬à¥à¤¦à¥‹à¤‚ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(40708,1131,'ms','Ralat menambah syarat-syarat Penjual',0),(40709,1131,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(40710,1131,'fr','Erreur en ajoutant des termes du vendeur',0),(40711,1131,'jp','æ¥­è€…æ?¡ä»¶ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40712,1131,'pt','Erro ao adicionar termos de fornecedor',0),(40713,1131,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð¾Ð²',0),(40714,1131,'es','Error agregando TÃ©rminos de Proveedor',0),(40715,1131,'de','Fehler beim HinzufÃ¼gen von VerkÃ¤ufer-AGB',0),(40716,1131,'en','Error adding Vendor Terms',0),(40717,1132,'is','',0),(40718,1132,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø§ØµÙ„ÙŠ ',0),(40719,1132,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø§ØµÙ„ÙŠ ',0),(40720,1132,'tr','FiÅŸ detay iÃ§in ana veritabanÄ± eklenirken bir hata oluÅŸtu.',0),(40721,1132,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania szczegÃ³Å‚Ã³w kupon do gÅ‚Ã³wnej bazy danych.',0),(40722,1132,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ð´Ð° Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸.',0),(40723,1132,'ur','Ù†Ù‚Øµ ÙˆØ§Ø¤Ú†Ø± ØªÙØµÛŒÙ„ Ù…ÛŒÙ† Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(40724,1132,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð´ÐµÑ‚Ð°Ñ™ ÑÐ° Ð³Ð»Ð°Ð²Ð½Ð¾Ð¼ Ð±Ð°Ð·Ð¾Ð¼ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°.',0),(40725,1132,'vi','ThÃªm chi tiáº¿t phiáº¿u vÃ o dá»¯ liá»‡u chÃ­nh bá»‹ lá»—i',0),(40726,1132,'af','Fout met skep van bewysstuk detail aan hoof databasis',0),(40727,1132,'ro','Eroare la adÄƒugarea voucher detaliu la principalele date.',0),(40728,1132,'et','Viga lisades kande detail peamine andmebaasi.',0),(40729,1132,'si','Napaka pri dodajanju voucher podrobnosti v glavno zbirko podatkov.',0),(40730,1132,'ba','Kesalahan menambahkan voucher detail ke database utama.',0),(40731,1132,'nl','Fout voucher detail aan hoofddatabase toe te voegen.',0),(40732,1132,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tositteen tiedot pÃ¤Ã¤tietokantaan.',0),(40733,1132,'no','Feil under tillegging bilaget detalj til hoveddatabasen.',0),(40734,1132,'da','Fejl ved tilfÃ¸jelse af voucher detaljer til hoveddatabasen.',0),(40735,1132,'ko','ì£¼ ë°ì´í„°ë² ì´ìŠ¤ì— ë°”ìš°ì²˜ ì„¸ë¶€ ì •ë³´ë¥¼ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(40736,1132,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¤×™×¨×•×˜ ×©×•×‘×¨ ×ž×¡×“ ×”× ×ª×•× ×™× ×”×ž×¨×›×–×™.',0),(40737,1132,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î¼Îµ ÎºÏÏÎ¹Î± Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½.',0),(40738,1132,'zh','é”™è¯¯æ·»åŠ ä»˜æ¬¾å‡­è¯ç»†èŠ‚åˆ°ä¸»æ•°æ®åº“ã€‚',0),(40739,1132,'sv','Fel att lÃ¤gga till verifikationen detalj till huvuddatabasen.',0),(40740,1132,'it','Errore durante l\'aggiunta dettaglio buono al database principale.',0),(40741,1132,'tl','',0),(40742,1132,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3651;&#3610;&#3',0),(40743,1132,'hi','à¤®à¥à¤–à¥à¤¯ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤‰à¤šà¤° à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(40744,1132,'ms','Ralat menambah butiran baucar kepada pangkalan data utama.',0),(40745,1132,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù‚Ø³ÙŠÙ…Ø© Ø¥Ù„Ù‰ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©.',0),(40746,1132,'fr','Erreur en ajoutant des dÃ©tails de bon Ã  la base de donnÃ©es principale.',0),(40747,1132,'jp','ãƒ¡ã‚¤ãƒ³ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?¸ã?®ãƒ?ã‚¦ãƒ?ãƒ£ãƒ¼è©³ç´°è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40748,1132,'pt','Erro ao adicionar detalhe vale para banco de dados principal.',0),(40749,1132,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð´ÐµÑ‚Ð°Ð»ÑŒ Ðº Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð±Ð°Ð·Ðµ Ð´Ð°Ð½Ð½Ñ‹Ñ….',0),(40750,1132,'es','Error agregando detalle de voucher a la base de datos principal',0),(40751,1132,'de','Fehler beim HinzufÃ¼gen von Gutschein Details zur Hauptdatenbank.',0),(40752,1132,'en','Error adding voucher detail to main database.',0),(40753,1133,'is','',0),(40754,1133,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø§ØµÙ„ÙŠ ',0),(40755,1133,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø§ØµÙ„ÙŠ ',0),(40756,1133,'tr','FiÅŸ haberdar etmek iÃ§in ana veritabanÄ± eklenirken bir hata oluÅŸtu',0),(40757,1133,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania zaÅ‚Ä…cznikÃ³w informacji do gÅ‚Ã³wnej bazy danych',0),(40758,1133,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€Ð° Ð·Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(40759,1133,'ur','Ù†Ù‚Øµ ÙˆØ§Ø¤Ú†Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÛŒÙ† Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(40760,1133,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¸Ð½Ñ„Ð¾ ÑÐ° Ð³Ð»Ð°Ð²Ð½Ð¾Ð¼ Ð±Ð°Ð·Ð¾Ð¼ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(40761,1133,'vi','ThÃªm thÃ´ng tin phiáº¿u vÃ o dá»¯ liá»‡u chÃ­nh bá»‹ lá»—i',0),(40762,1133,'af','Fout met skep van bewysstuk inligting aan hoof databasis',0),(40763,1133,'ro','Eroare la adÄƒugarea voucher info la principale de date',0),(40764,1133,'et','Viga lisades kanne info peamine andmebaas',0),(40765,1133,'si','Napaka pri dodajanju voucher info v glavno zbirko podatkov',0),(40766,1133,'ba','Kesalahan menambahkan voucher info ke database utama',0),(40767,1133,'nl','Fout voucher info toe te voegen aan hoofddatabase',0),(40768,1133,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tositteen tiedot pÃ¤Ã¤tietokantaan',0),(40769,1133,'no','Legge bilaget info til hoveddatabasen',0),(40770,1133,'da','Fejl ved tilfÃ¸jelse af gavekort info til hoveddatabasen',0),(40771,1133,'ko','ì£¼ ë°ì´í„°ë² ì´ìŠ¤ì— ìƒí’ˆê¶Œ ì •ë³´ë¥¼ ì¶”ê°€ í•˜ëŠ” ì˜¤ë¥˜',0),(40772,1133,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×¤×¨×˜×™ ×”×©×•×‘×¨ ×œ×ž×¡×“ ×”× ×ª×•× ×™× ×”×¨××©×™',0),(40773,1133,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ„Î·Î½ ÎºÏÏÎ¹Î± Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(40774,1133,'zh','é”™è¯¯æ·»åŠ ä»˜æ¬¾å‡­è¯ä¿¡æ¯åˆ°ä¸»æ•°æ®åº“\r\n',0),(40775,1133,'sv','Fel att lÃ¤gga till verifikationen information till huvuddatabasen',0),(40776,1133,'it','Errore aggiungendo informazioni voucher al database principale',0),(40777,1133,'tl','',0),(40778,1133,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3',0),(40779,1133,'hi','à¤®à¥à¤–à¥à¤¯ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤‰à¤šà¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(40780,1133,'ms','Ralat menambah maklumat baucer ke pangkalan data utama',0),(40781,1133,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù‚Ø³ÙŠÙ…Ø© Ø¥Ù„Ù‰ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(40782,1133,'fr','Erreur en ajoutant le volet d\'informations Ã  la base de donnÃ©es principale',0),(40783,1133,'jp','ãƒ¡ã‚¤ãƒ³ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?¸ã?®ãƒ?ã‚¦ãƒ?ãƒ£ãƒ¼æƒ…å ±è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40784,1133,'pt','Erro ao adicionar informaÃ§Ã£o vale para o banco de dados principal',0),(40785,1133,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð´Ð»Ñ Ð³Ð»Ð°Ð²Ð½Ð¾Ð¹ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(40786,1133,'es','Error agregando info de Voucher a la base de datos principal',0),(40787,1133,'de','Fehler beim HinzufÃ¼gen von Gutschein-Info zur Hauptdatenbank',0),(40788,1133,'en','Error adding voucher info to main database',0),(40789,1134,'is','',0),(40790,1134,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø§ØµÙ„ÙŠ ',0),(40791,1134,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø§ØµÙ„ÙŠ ',0),(40792,1134,'tr','FiÅŸ iÃ§in ana veritabanÄ± eklenirken bir hata oluÅŸtu.',0),(40793,1134,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania zaÅ‚Ä…cznikÃ³w do gÅ‚Ã³wnej bazy danych.',0),(40794,1134,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€ ÐºÑŠÐ¼ Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸.',0),(40795,1134,'ur','Ù†Ù‚Øµ ÙˆØ§Ø¤Ú†Ø± Ù†Û’ Ù…Ø±Ú©Ø²ÛŒ Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(40796,1134,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð²Ð°ÑƒÑ‡ÐµÑ€ ÑÐ° Ð³Ð»Ð°Ð²Ð½Ð¾Ð¼ Ð±Ð°Ð·Ð¾Ð¼ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°.',0),(40797,1134,'vi','ThÃªm phiáº¿u vÃ o dá»¯ liá»‡u chÃ­nh bá»‹ lá»—i',0),(40798,1134,'af','Fout met skep van bewysstuk aan hoof databasis.',0),(40799,1134,'ro','Eroare la adÄƒugarea voucher la principalele date.',0),(40800,1134,'et','Viga lisades kanne peamine andmebaasi.',0),(40801,1134,'si','Napaka pri dodajanju kupon v glavno zbirko podatkov.',0),(40802,1134,'ba','Kesalahan menambahkan voucher ke database utama.',0),(40803,1134,'nl','Fout waardebon toe te voegen aan hoofddatabase.',0),(40804,1134,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tositteen pÃ¤Ã¤tietokantaan.',0),(40805,1134,'no','Feil under tillegging bilaget til hoveddatabasen.',0),(40806,1134,'da','Fejl ved tilfÃ¸jelse af voucher til hoveddatabasen.',0),(40807,1134,'ko','ì£¼ ë°ì´í„°ë² ì´ìŠ¤ì— ì¿ í°ì„ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(40808,1134,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×©×•×‘×¨ ×ž×¡×“ ×”× ×ª×•× ×™× ×”×ž×¨×›×–×™.',0),(40809,1134,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹, Î¼Îµ ÎºÏÏÎ¹Î± Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½.',0),(40810,1134,'zh','é”™è¯¯æ·»åŠ ä»˜æ¬¾å‡­è¯åˆ°ä¸»æ•°æ®åº“ã€‚\r\n',0),(40811,1134,'sv','Fel att lÃ¤gga till verifikationen till huvuddatabasen.',0),(40812,1134,'it','Errore durante l\'aggiunta voucher al database principale.',0),(40813,1134,'tl','',0),(40814,1134,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3',0),(40815,1134,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥à¤–à¥à¤¯ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(40816,1134,'ms','Ralat menambah baucer ke pangkalan data utama.',0),(40817,1134,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù‚Ø³ÙŠÙ…Ø© Ø¥Ù„Ù‰ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©.',0),(40818,1134,'fr','Erreur lors de l\'ajout de bon Ã  la base de donnÃ©es principale.',0),(40819,1134,'jp','ãƒ¡ã‚¤ãƒ³ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?¸ã?®ãƒ?ã‚¦ãƒ?ãƒ£ãƒ¼è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40820,1134,'pt','Erro ao adicionar o voucher para o banco de dados principal.',0),(40821,1134,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð´Ð»Ñ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ….',0),(40822,1134,'es','Error agregando info de voucher a la base de datos principal',0),(40823,1134,'de','Fehler beim HinzufÃ¼gen von Gutschein zur Hauptdatenbank.',0),(40824,1134,'en','Error adding voucher to main database.',0),(40825,1135,'is','',0),(40826,1135,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(40827,1135,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(40828,1135,'tr','Hata ekleme iÅŸ tÃ¼rÃ¼.',0),(40829,1135,'pl','BÅ‚Ä…d dodawania typu pracy.',0),(40830,1135,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ð°.',0),(40831,1135,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Ø§Ù… Ù‚Ø³Ù… ÛÛ’ Û”',0),(40832,1135,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð°.',0),(40833,1135,'vi','ThÃªm loáº¡i cÃ´ng viá»‡c bá»‹ lá»—i',0),(40834,1135,'af','Voeg werk fouttipe.',0),(40835,1135,'ro','Eroare de adÄƒugarea de lucru tip.',0),(40836,1135,'et','Viga lisades tÃ¶Ã¶ liik.',0),(40837,1135,'si','Dodajanje delo vrste napak.',0),(40838,1135,'ba','Jenis pekerjaan menambahkan kesalahan.',0),(40839,1135,'nl','Fout toe te voegen werksoort.',0),(40840,1135,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tyÃ¶n tyyppi.',0),(40841,1135,'no','Feil Ã¥ legge arbeidstype.',0),(40842,1135,'da','Fejl tilfÃ¸je arbejdstype.',0),(40843,1135,'ko','ì˜¤ë¥˜ ì¶”ê°€ ìž‘ì—… í˜•ì‹ìž…ë‹ˆë‹¤.',0),(40844,1135,'he','×©×’×™××” ×”×•×¡×¤×ª ×¡×•×’ ×¢×‘×•×“×”.',0),(40845,1135,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï… ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(40846,1135,'zh','é”™è¯¯ï¼šæ–°å¢žå·¥ç±»åž‹ã€‚\r\n',0),(40847,1135,'sv','Fel att lÃ¤gga arbetstyp.',0),(40848,1135,'it','Tipo di lavoro aggiungendo errore.',0),(40849,1135,'tl','',0),(40850,1135,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;',0),(40851,1135,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°à¥¤',0),(40852,1135,'ms','Jenis kerja menambah ralat.',0),(40853,1135,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„.',0),(40854,1135,'fr','Erreur ajout type de travail.',0),(40855,1135,'jp','ä»•äº‹å†…å®¹ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40856,1135,'pt','Tipo de trabalho adicionando erro.',0),(40857,1135,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹.',0),(40858,1135,'es','Error agregando tipo de trabajo',0),(40859,1135,'de','Fehler hinzufÃ¼gen Arbeitstyp.',0),(40860,1135,'en','Error adding work type.',0),(40861,1136,'is','',0),(40862,1136,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(40863,1136,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(40864,1136,'tr','Ä°ÅŸ tÃ¼rÃ¼ ek bilgi eklenirken bir hata oluÅŸtu.',0),(40865,1136,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania pracy typu dodatkowe info.',0),(40866,1136,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð²Ð¸Ð´ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(40867,1136,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ Ø§Ø¶Ø§ÙÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(40868,1136,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ€Ð°Ð´ Ñ‚Ð¸Ð¿ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ.',0),(40869,1136,'vi','Lá»—i khi thÃªm thÃ´ng tin loáº¡i cÃ´ng viá»‡c thÃªm',0),(40870,1136,'af','Fout met skepping van werktipe addisionele inligting.',0),(40871,1136,'ro','Eroare la adÄƒugarea de lucru tip informatii suplimentare.',0),(40872,1136,'et','Viga lisades tÃ¶Ã¶ tÃ¼Ã¼p Lisainfo.',0),(40873,1136,'si','Napaka pri dodajanju delo vrsta dodatne info.',0),(40874,1136,'ba','Pekerjaan menambahkan kesalahan ketik info tambahan.',0),(40875,1136,'nl','Fout bij het toevoegen van werk Typ aanvullende info.',0),(40876,1136,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tyÃ¶n tyyppi lisÃ¤tiedot.',0),(40877,1136,'no','Feil under tillegging arbeid type tilleggsinformasjon.',0),(40878,1136,'da','Fejl ved tilfÃ¸jelse af arbejde type yderligere info.',0),(40879,1136,'ko','ìž‘ì—… ìœ í˜• ì¶”ê°€ ì •ë³´ë¥¼ ì¶”ê°€ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(40880,1136,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×ž×™×“×¢ × ×•×¡×£ ×©×œ ×¡×•×’ ×¢×‘×•×“×”.',0),(40881,1136,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï… Ï€ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚.',0),(40882,1136,'zh','é”™è¯¯æ·»åŠ å·¥ä½œç±»åž‹é¢å¤–ä¿¡æ¯',0),(40883,1136,'sv','Fel att lÃ¤gga arbete typ ytterligare info.',0),(40884,1136,'it','Errore aggiungendo lavoro tipo ulteriori info.',0),(40885,1136,'tl','',0),(40886,1136,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3',0),(40887,1136,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(40888,1136,'ms','Ralat menambah maklumat tambahan jenis kerja.',0),(40889,1136,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ© Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„.',0),(40890,1136,'fr','Erreur en ajoutant des informations supplÃ©mentaires sur le type travail.',0),(40891,1136,'jp','ä»•äº‹å†…å®¹ä»˜åŠ æƒ…å ±ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(40892,1136,'pt','Erro ao adicionar informaÃ§Ãµes adicionais de tipo de trabalho.',0),(40893,1136,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð¹ Ð¸Ð½Ñ„Ð¾ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹.',0),(40894,1136,'es','Error agregando info adicional de tipo de trabajo',0),(40895,1136,'de','Fehler beim HinzufÃ¼gen von zusÃ¤tzliche Arbeit-Typinformationen.',0),(40896,1136,'en','Error adding work type additional info.',0),(40897,1137,'is','',0),(40898,1137,'dr',': Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ø¨Ø¹Ø¯ Ø§Ø² Ù¾Ø§ÙŠØ§Ù†  Ø³Ø§Ù„ Ø§Ø³Øª ',0),(40899,1137,'pr','Ø®Ø·Ø§ : Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ø¨Ø¹Ø¯ Ø§Ø² Ù¾Ø§ÙŠØ§Ù†  Ø³Ø§Ù„ Ø§Ø³Øª ',0),(40900,1137,'tr','Hata: BaÅŸlangÄ±Ã§ yÄ±l sonra bitiÅŸ yÄ±lÄ±dÄ±r.',0),(40901,1137,'pl','BÅ‚Ä…d: PoczÄ…tek roku to po roku koÅ„czÄ…c.',0),(40902,1137,'bg','Ð“Ñ€ÐµÑˆÐºÐ°: ÐÐ°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ðµ ÑÐ»ÐµÐ´ ÐºÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°.',0),(40903,1137,'ur','Ù†Ù‚Øµ: Ø¢ØºØ§Ø² Ø³Ø§Ù„ Ú©Û’ Ø¨Ø¹Ø¯ Ø®ØªÙ… Ø³Ø§Ù„ ÛÛ’ Û”',0),(40904,1137,'sr','Ð“Ñ€ÐµÑˆÐºÐ° : ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð³Ð¾Ð´Ð¸Ð½Ðµ Ñ˜Ðµ Ð½Ð°ÐºÐ¾Ð½ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð³Ð¾Ð´Ð¸Ð½Ðµ.',0),(40905,1137,'vi','Lá»—i: NÄƒm báº¯t Ä‘áº§u sau nÄƒm káº¿t thÃºc',0),(40906,1137,'af','Fout: Begin jaar is na eindig jaar.',0),(40907,1137,'ro','Eroare: ÃŽnceputul anului este dupÄƒ care se Ã®ncheie anul.',0),(40908,1137,'et','TÃµrge: Alguses aasta on pÃ¤rast lÃµppenud aasta.',0),(40909,1137,'si','Napaka: ZaÄetek leta je po konÄni leto.',0),(40910,1137,'ba','Kesalahan: Awal tahun adalah setelah mengakhiri tahun.',0),(40911,1137,'nl','Fout: Begin is na beÃ«indiging van jaar.',0),(40912,1137,'fi','Virhe: Aloitusvuosi on jÃ¤lkeen pÃ¤Ã¤ttyvÃ¤n vuoden.',0),(40913,1137,'no','Feil: Begynnelsen Ã¥r er etter endte Ã¥ret.',0),(40914,1137,'da','Fejl: Begyndelsen Ã¥r er efter slutter Ã¥ret.',0),(40915,1137,'ko','ì˜¤ë¥˜: ì‹œìž‘ ì—°ë„ ì¢…ë£Œ ë…„ í›„ìž…ë‹ˆë‹¤.',0),(40916,1137,'he','×©×’×™××”: ×ª×—×™×œ×ª ×©× ×” ×”×™× ×• ×œ××—×¨ ×¡×™×•× ×”×©× ×”.',0),(40917,1137,'el','Î£Ï†Î¬Î»Î¼Î±: Î— Î±ÏÏ‡Î® Î­Ï„Î¿Ï…Ï‚ ÎµÎ¯Î½Î±Î¹ Î¼ÎµÏ„Î¬ Î­Ï„Î¿Ï‚ Ï„ÎµÎ»ÎµÎ¹ÏŽÎ½ÎµÎ¹.',0),(40918,1137,'zh','é”™è¯¯ï¼šå¼€å§‹å¹´ä»½æ˜¯åœ¨ç»“æŸå¹´ä»½åŽçš„ã€‚',0),(40919,1137,'sv','Fel: BÃ¶rjan Ã¥r Ã¤r efter slutar Ã¥ret.',0),(40920,1137,'it','Errore: Inizio anno Ã¨ dopo fine anno.',0),(40921,1137,'tl','',0),(40922,1137,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;:&#3611;&#3637;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3629;&#3618;&#3641;&#3656;&#3627;&#3621;&#3633;&#3591;&#3611;&#3637;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#',0),(40923,1137,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿: à¤¶à¥à¤°à¥à¤†à¤¤ à¤µà¤°à¥à¤· à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤µà¤°à¥à¤· à¤¹à¥ˆà¥¤',0),(40924,1137,'ms','Ralat: Awal tahun ini selepas berakhir tahun.',0),(40925,1137,'ar','Ø§Ù„Ø®Ø·Ø£: Ù‡Ùˆ Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø© \"Ø¨Ø¹Ø¯ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ù†ØªÙ‡ÙŠØ©\".',0),(40926,1137,'fr','Erreur : DÃ©but annÃ©e est aprÃ¨s se terminant l\'annÃ©e.',0),(40927,1137,'jp','ã‚¨ãƒ©ãƒ¼/å¹´ã?®é–‹å§‹ã?Œå¹´ã?®çµ‚äº†ã‚ˆã‚Šã‚‚å¾Œã?§ã?™',0),(40928,1137,'pt','Erro: Ano de inÃ­cio Ã© depois de final de ano.',0),(40929,1137,'ru','ÐžÑˆÐ¸Ð±ÐºÐ°: ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð³Ð¾Ð´Ð° â€” Ð¿Ð¾ÑÐ»Ðµ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð³Ð¾Ð´Ð°.',0),(40930,1137,'es','Error: Inicio de Ejercicio',0),(40931,1137,'de','Fehler: Anfang Jahr ist nach Beendigung.',0),(40932,1137,'en','Error: Beginning Year is After Ending Year.',0),(40933,1138,'is','',0),(40934,1138,'dr',': Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾Ø³Øª ÙƒØ±Ø¯Ù†  Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù†ÙŠØ³Øª ',0),(40935,1138,'pr','Ø®Ø·Ø§ : Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾Ø³Øª ÙƒØ±Ø¯Ù†  Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù†ÙŠØ³Øª ',0),(40936,1138,'tr','Hata:-ebil deÄŸil posta Ã§eki.',0),(40937,1138,'pl','BÅ‚Ä…d: Nie moÅ¼e wysÅ‚aÄ‡ kupon.',0),(40938,1138,'bg','Ð“Ñ€ÐµÑˆÐºÐ°: ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿ÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ñ‚Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€.',0),(40939,1138,'ur','Ù†Ù‚Øµ: ÙˆØ§Ø¤Ú†Ø± Ù¾ÙˆØ³Ù¹ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(40940,1138,'sr','Ð“Ñ€ÐµÑˆÐºÐ° : ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³Ð°Ð¾ Ð¿Ð¾ÑÐ»Ð°Ñ‚Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€.',0),(40941,1138,'vi','Lá»—i: khÃ´ng káº¿t chuyá»ƒn Ä‘Æ°á»£c phiáº¿u',0),(40942,1138,'af','Fout:  Kon nie bewysstuk pos.',0),(40943,1138,'ro','Eroare: Nu ar putea posta voucher.',0),(40944,1138,'et','Viga: Ei saa postitada kande.',0),(40945,1138,'si','Napaka: Ne bi po kupona.',0),(40946,1138,'ba','Kesalahan: Tidak dapat mengirimkan voucher.',0),(40947,1138,'nl','Fout: Kon niet post voucher.',0),(40948,1138,'fi','Virhe: Ei voitu kirjata tositteen.',0),(40949,1138,'no','Feil: Kan ikke legge inn kupong.',0),(40950,1138,'da','Fejl: Kunne ikke sende gavekort.',0),(40951,1138,'ko','ì˜¤ë¥˜: ë°”ìš°ì²˜ë¥¼ ê²Œì‹œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(40952,1138,'he','×©×’×™××”: ×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×¨×©×•× ×©×•×‘×¨.',0),(40953,1138,'el','Î£Ï†Î¬Î»Î¼Î±: Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Ï„Î¿Ï€Î¿Î¸ÎµÏ„Î®ÏƒÎµÎ¹ Ï„Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹.',0),(40954,1138,'zh','é”™è¯¯ï¼šæ— æ³•é‚®å¯„å‡­è¯ã€‚',0),(40955,1138,'sv','Fel: Kunde inte posta kupongen.',0),(40956,1138,'it','Errore: Non poteva postare buono.',0),(40957,1138,'tl','',0),(40958,1138,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;:&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(40959,1138,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿: à¤µà¤¾à¤‰à¤šà¤° à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡à¥¤',0),(40960,1138,'ms','Ralat: Tidak dapat menghantar baucer.',0),(40961,1138,'ar','Ø®Ø·Ø£: ÙŠÙ…ÙƒÙ† Ø£Ù† Ù„Ø§ ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥ÙŠØµØ§Ù„.',0),(40962,1138,'fr','Erreur : Ne pouvait que bon.',0),(40963,1138,'jp','ã‚¨ãƒ©ãƒ¼/ä¼?ç¥¨ã?Œè¨ˆä¸Šã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(40964,1138,'pt','Erro: NÃ£o poderia postar o comprovante.',0),(40965,1138,'ru','ÐžÑˆÐ¸Ð±ÐºÐ°: ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð²Ð°ÑƒÑ‡ÐµÑ€.',0),(40966,1138,'es','Error: No se podÃ­a asentar el voucher',0),(40967,1138,'de','Fehler: Konnte nicht Gutschein gesendet werden.',0),(40968,1138,'en','Error: Could not post voucher.',0),(40969,1139,'is','',0),(40970,1139,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙƒØªÙˆØ± Ø¨Ø±Ø§ÙŠ ',0),(40971,1139,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙƒØªÙˆØ± Ø¨Ø±Ø§ÙŠ ',0),(40972,1139,'tr','Hata oluÅŸturma fatura iÃ§in',0),(40973,1139,'pl','BÅ‚Ä…d tworzenia faktury',0),(40974,1139,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð°',0),(40975,1139,'ur','Ù†Ù‚Øµ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(40976,1139,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð·Ð°',0),(40977,1139,'vi','Lá»—i táº¡o hÃ³a Ä‘Æ¡n cho',0),(40978,1139,'af','Fout skep faktuur vir',0),(40979,1139,'ro','Eroare creare facturÄƒ pentru',0),(40980,1139,'et','TÃµrge loomisel arve',0),(40981,1139,'si','Napaka ustvarjanja raÄuna za',0),(40982,1139,'ba','Kesalahan membuat faktur untuk',0),(40983,1139,'nl','Fout maken factuur voor',0),(40984,1139,'fi','Virhe luotaessa lasku',0),(40985,1139,'no','Feil opprette faktura for',0),(40986,1139,'da','Fejl oprette faktura for',0),(40987,1139,'ko','ì˜¤ë¥˜ ë§Œë“¤ê¸° ì†¡ìž¥ì— ëŒ€ í•œ',0),(40988,1139,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×—×©×‘×•× ×™×ª ×¢×‘×•×¨',0),(40989,1139,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Î³Î¹Î±',0),(40990,1139,'zh','é”™è¯¯å»ºç«‹å‘ç¥¨',0),(40991,1139,'sv','Fel att skapa faktura fÃ¶r',0),(40992,1139,'it','Fattura creazione di errore per',0),(40993,1139,'tl','',0),(40994,1139,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3629;&#3',0),(40995,1139,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤',0),(40996,1139,'ms','Ralat mencipta invois bagi',0),(40997,1139,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ù†Ø´Ø§Ø¡ ÙØ§ØªÙˆØ±Ø©',0),(40998,1139,'fr','CrÃ©ation facture erreur',0),(40999,1139,'jp','ã‚¨ãƒ©ãƒ¼/è«‹æ±‚æ›¸ã?Œä½œæˆ?ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(41000,1139,'pt','Erro criando nota fiscal',0),(41001,1139,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ',0),(41002,1139,'es','Error creando factura para',0),(41003,1139,'de','Fehler Erstellen von Rechnung fÃ¼r',0),(41004,1139,'en','Error creating invoice for',0),(41005,1140,'is','',0),(41006,1140,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø«Ø¨Øª ÙØ§ÙƒØªÙˆØ± Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  Ø«Ø¨ØªÙ‡Ø§ Ù„ØºÙˆ Ø´Ø¯ ',0),(41007,1140,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø«Ø¨Øª ÙØ§ÙƒØªÙˆØ± Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  Ø«Ø¨ØªÙ‡Ø§ Ù„ØºÙˆ Ø´Ø¯ ',0),(41008,1140,'tr','BorÃ§lar fatura giriÅŸi, giriÅŸleri iptal oluÅŸturulurken hata oluÅŸtu',0),(41009,1140,'pl','BÅ‚Ä…d tworzenia wpisu faktury zobowiÄ…zania, wpisy odwoÅ‚any',0),(41010,1140,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ ÐºÑŠÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð°Ð¿Ð¸Ñ, Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ',0),(41011,1140,'ur','Ù†Ù‚Øµ Ù¾ÛŒØ¯Ø§ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ù†Ø¯Ø±Ø§Ø¬ØŒ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Ùˆ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(41012,1140,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° ÑÑ‚Ð°Ð²ÐºÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ, Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(41013,1140,'vi','Lá»—i Khi Nháº­p HÃ³a ÄÆ¡n Pháº£i Tráº£',0),(41014,1140,'af','Fout ontstaan met skepping van Betaalbare Faktuurinskrywing, Inskrywings Gekanseleer',0),(41015,1140,'ro','Eroare la crearea datorii factura de intrare, intrÄƒri anulate',0),(41016,1140,'et','VÃµlad arve kanne kanded tÃ¼histada loomisel ilmnes tÃµrge',0),(41017,1140,'si','Napaka pri ustvarjanju obveznosti vnosu faktur, postavke odpovedan',0),(41018,1140,'ba','Error membuat hutang faktur entri, entri dibatalkan',0),(41019,1140,'nl','Fout bij het maken van schulden factuurpost, posten geannuleerd',0),(41020,1140,'fi','Virhe luotaessa velat Laskutapahtumaan tapahtumat peruutetaan',0),(41021,1140,'no','Feil under oppretting av leverandÃ¸rgjeld fakturaposten, oppfÃ¸ringer avbrutt',0),(41022,1140,'da','Fejl under oprettelse af Kreditorstyring fakturapost, poster aflyst',0),(41023,1140,'ko','ì™¸ìƒ ë§¤ìž…ê¸ˆ ì†¡ìž¥ í•­ëª©, í•­ëª© ì·¨ì†Œë¥¼ ë§Œë“œëŠ” ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤',0),(41024,1140,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×¢×¨×š ×—×©×‘×•× ×™×ª ×–×›××™×, ×¢×¨×›×™ ×‘×•×˜×œ×”',0),(41025,1140,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ ÎµÎ³Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…, Î±ÎºÏ…ÏÏŽÏƒÎµÎ¹Ï‚ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(41026,1140,'zh','åˆ›å»ºåº”ä»˜æ¬¾å‘ç¥¨æ¡ç›®é”™è¯¯ï¼Œå–æ¶ˆæ¡ç›®',0),(41027,1140,'sv','Fel vid skapande av leverantÃ¶rsskulder fakturatransaktionen, transaktioner annulleras',0),(41028,1140,'it','Errore di creazione voce fattura di debiti, voci cancellate',0),(41029,1140,'tl','',0),(41030,1140,'th','Error creating Payables Invoice Entry, Entries Cancelled',0),(41031,1140,'hi','Payables à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿, à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤°à¤¦à¥à¤¦ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(41032,1140,'ms','Ralat ketika mencipta kemasukan invois pemiutang, penyertaan dibatalkan',0),(41033,1140,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ \"Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø©\"ØŒ Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª',0),(41034,1140,'fr','Erreur de crÃ©ation de saisie des factures fournisseurs, informations effacÃ©es',0),(41035,1140,'jp','Error creating Payables Invoice Entry, Entries Cancelled',0),(41036,1140,'pt','Erro ao criar entrada de fatura de contas a pagar, entradas canceladas',0),(41037,1140,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÑ‡ÐµÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸, Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(41038,1140,'es','Error creando IntoducciÃ³n de Factura de Proveedores, Introducciones Canceladas',0),(41039,1140,'de','Fehler beim Erstellen der Verbindlichkeiten Rechnungserfassung, EintrÃ¤ge gelÃ¶scht',0),(41040,1140,'en','Error creating Payables Invoice Entry, Entries Cancelled',0),(41041,1141,'is','',0),(41042,1141,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø¹Ø¯ Ø§Ø² Ø­Ø°Ù',0),(41043,1141,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø¹Ø¯ Ø§Ø² Ø­Ø°Ù',0),(41044,1141,'tr','Tablo gltransaction bÄ±raktÄ±ktan sonra oluÅŸturulurken bir hata oluÅŸtu.',0),(41045,1141,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas tworzenia tabela gltransaction po spadku.',0),(41046,1141,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° gltransaction ÑÐ»ÐµÐ´ ÑÐ¿Ð°Ð´.',0),(41047,1141,'ur','Ù†Ù‚Øµ Ù¹ÛŒØ¨Ù„ Ú¯Ù„Ù¹Ø±Ø§Ù†Ø³Ú©Ø´Ù† Ú©Û’ Ø¨Ø¹Ø¯ ØªÙˆÙ„ÛŒØ¯ÛŒ Ù‚Ø·Ø±Û Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’ Û”',0),(41048,1141,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ñ‚Ð°Ð±ÐµÐ»Ðµ Ð³Ð»Ñ‚Ñ€Ð°Ð½ÑÐ°Ñ†Ñ‚Ð¸Ð¾Ð½ Ð¿Ð¾ÑÐ»Ðµ Ð¿Ð°Ð´Ð°.',0),(41049,1141,'vi','Lá»—i táº¡o báº£ng giao dá»‹ch sau khi bá»',0),(41050,1141,'af','Fout met skepping van tabel agtransaksie na \"drop\".',0),(41051,1141,'ro','Eroare la crearea tabelului gltransaction dupÄƒ picÄƒturÄƒ.',0),(41052,1141,'et','Ei Ãµnnestu luua tabeli gltransaction pÃ¤rast langust.',0),(41053,1141,'si','Napaka pri ustvarjanju tabele gltransaction po kapljico.',0),(41054,1141,'ba','Error membuat tabel gltransaction setelah drop.',0),(41055,1141,'nl','Fout bij het maken van de tabel gltransaction na druppel.',0),(41056,1141,'fi','Virhe luotaessa taulukon gltransaction jÃ¤lkeen pudota.',0),(41057,1141,'no','Feil under oppretting av tabell gltransaction etter fall.',0),(41058,1141,'da','Fejl under oprettelse af tabel gltransaction efter drop.',0),(41059,1141,'ko','ë“œë¡­ í›„ í…Œì´ë¸” gltransactionë¥¼ ë§Œë“œëŠ” ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(41060,1141,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×˜×‘×œ×” gltransaction ×œ××—×¨ ×”×©×—×¨×•×¨.',0),(41061,1141,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î¯Î½Î±ÎºÎ± gltransaction Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ Ï€Ï„ÏŽÏƒÎ·.',0),(41062,1141,'zh','é”™è¯¯åˆ›å»ºåŽåˆ é™¤è¡¨å†°å·äº¤æ˜“ã€‚',0),(41063,1141,'sv','Fel att skapa tabell gltransaction efter slÃ¤pp.',0),(41064,1141,'it','Errore creazione tabella gltransaction dopo goccia.',0),(41065,1141,'tl','',0),(41066,1141,'th','Error creating table gltransaction after drop.',0),(41067,1141,'hi','à¤¬à¤¾à¤¦ à¤¡à¥à¤°à¥‰à¤ª à¤¤à¤¾à¤²à¤¿à¤•à¤¾ gltransaction à¤¬à¤¨à¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(41068,1141,'ms','Ralat mencipta jadual gltransaction selepas kejatuhan.',0),(41069,1141,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø¬Ù„ØªØ±Ø§Ù†Ø³Ø§ÙƒØ´Ù† Ø¨Ø¹Ø¯ Ø¥Ø³Ù‚Ø§Ø·.',0),(41070,1141,'fr','Erreur de crÃ©ation du tableau gltransaction aprÃ¨s la chute.',0),(41071,1141,'jp','Error creating table gltransaction after drop.',0),(41072,1141,'pt','Erro ao criar a tabela gltransaction depois da queda.',0),(41073,1141,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ gltransaction Ð¿Ð¾ÑÐ»Ðµ Ð¿Ð°Ð´ÐµÐ½Ð¸Ñ.',0),(41074,1141,'es','Error Creando tabla de transacciÃ³n de LM despuÃ©s de bajar',0),(41075,1141,'de','Fehler beim Erstellen der Tabelle Gltransaction nach Einbruch.',0),(41076,1141,'en','Error creating table gltransaction after drop.',0),(41077,1142,'is','',0),(41078,1142,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø¹Ø¯ Ø§Ø² Ø­Ø°Ù',0),(41079,1142,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø¹Ø¯ Ø§Ø² Ø­Ø°Ù',0),(41080,1142,'tr','BÄ±raktÄ±ktan sonra tablo fiÅŸi oluÅŸturulurken bir hata oluÅŸtu.',0),(41081,1142,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas tworzenia tabeli zaÅ‚Ä…cznika po spadku.',0),(41082,1142,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€ ÑÐ»ÐµÐ´ ÑÐ¿Ð°Ð´.',0),(41083,1142,'ur','Ù†Ù‚Øµ Ø¬Ø¯ÙˆÙ„ ÙˆØ§Ø¤Ú†Ø± Ú©Û’ Ø¨Ø¹Ø¯ ØªÙˆÙ„ÛŒØ¯ÛŒ Ù‚Ø·Ø±Û Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’ Û”',0),(41084,1142,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ñ‚Ð°Ð±ÐµÐ»Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¿Ð¾ÑÐ»Ðµ Ð¿Ð°Ð´Ð°.',0),(41085,1142,'vi','Lá»—i táº¡o báº£ng phiáº¿u sau khi bá»',0),(41086,1142,'af','Fout met skep tabel bewys na drop.',0),(41087,1142,'ro','Eroare la crearea tabelului voucher dupÄƒ picÄƒturÄƒ.',0),(41088,1142,'et','PÃ¤rast langust tabeli kande loomisel ilmnes tÃµrge.',0),(41089,1142,'si','Napaka pri ustvarjanju tabele kupona po kapljico.',0),(41090,1142,'ba','Error membuat tabel voucher setelah drop.',0),(41091,1142,'nl','Fout bij het maken van tabel voucher na druppel.',0),(41092,1142,'fi','Virhe luotaessa taulukon tositteen jÃ¤lkeen pudota.',0),(41093,1142,'no','Feil under oppretting av tabellen bilag etter fall.',0),(41094,1142,'da','Fejl under oprettelse af tabel voucher efter drop.',0),(41095,1142,'ko','ë“œë¡­ í›„ í…Œì´ë¸” ë°”ìš°ì²˜ë¥¼ ë§Œë“œëŠ” ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(41096,1142,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×˜×‘×œ×” ×”×©×•×‘×¨ ×œ××—×¨ ×”×©×—×¨×•×¨.',0),(41097,1142,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î¯Î½Î±ÎºÎ± ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Î¼ÎµÏ„Î¬ Ï„Î·Î½ Ï€Ï„ÏŽÏƒÎ·.',0),(41098,1142,'zh','é”™è¯¯åˆ›å»ºè¡¨åŽä¸‹é™åˆ¸ã€‚',0),(41099,1142,'sv','Fel att skapa tabell verifikationen efter slÃ¤pp.',0),(41100,1142,'it','Errore creazione voucher tabella dopo goccia.',0),(41101,1142,'tl','',0),(41102,1142,'th','Error creating table voucher after drop.',0),(41103,1142,'hi','à¤¬à¤¾à¤¦ à¤¡à¥à¤°à¥‰à¤ª à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤µà¤¾à¤‰à¤šà¤° à¤¬à¤¨à¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(41104,1142,'ms','Ralat mencipta jadual baucer selepas jatuh.',0),(41105,1142,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø¥ÙŠØµØ§Ù„ Ø¨Ø¹Ø¯ Ø¥Ø³Ù‚Ø§Ø·.',0),(41106,1142,'fr','Erreur de crÃ©ation du chÃ¨que de table aprÃ¨s la chute.',0),(41107,1142,'jp','Error creating table voucher after drop.',0),(41108,1142,'pt','Erro ao criar o voucher de tabela apÃ³s a queda.',0),(41109,1142,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¿Ð¾ÑÐ»Ðµ Ð¿Ð°Ð´ÐµÐ½Ð¸Ñ.',0),(41110,1142,'es','Error Creando voucher de tabla despuÃ©s de bajar',0),(41111,1142,'de','Fehler beim Erstellen der Tabelle Gutschein nach Einbruch.',0),(41112,1142,'en','Error creating table voucher after drop.',0),(41113,1143,'is','',0),(41114,1143,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø­Ø°Ù ',0),(41115,1143,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø­Ø°Ù ',0),(41116,1143,'tr','Silme sÄ±rasÄ±nda hata oluÅŸtu',0),(41117,1143,'pl','BÅ‚Ä…d podczas usuwania',0),(41118,1143,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(41119,1143,'ur','Ø­Ø°Ù Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ',0),(41120,1143,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ Ð±Ñ€Ð¸ÑÐ°ÑšÐ°',0),(41121,1143,'vi','Lá»—i khi xÃ³a',0),(41122,1143,'af','Fout tydens skrapping',0),(41123,1143,'ro','Eroare de È™tergere',0),(41124,1143,'et','TÃµrge kustutamisel',0),(41125,1143,'si','Napaka med',0),(41126,1143,'ba','Error selama Hapus',0),(41127,1143,'nl','Fout tijdens verwijderen',0),(41128,1143,'fi','Virhe poistamisen aikana',0),(41129,1143,'no','Feil under sletting',0),(41130,1143,'da','Fejl under sletning',0),(41131,1143,'ko','ì‚­ì œ ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤',0),(41132,1143,'he','×©×’×™××” ×‘×ª×”×œ×™×š ×ž×—×™×§×”',0),(41133,1143,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(41134,1143,'zh','åˆ é™¤è¿‡ç¨‹ä¸­å‡ºçŽ°é”™è¯¯',0),(41135,1143,'sv','Fel under ta bort',0),(41136,1143,'it','Errore durante l\'eliminazione',0),(41137,1143,'tl','',0),(41138,1143,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;',0),(41139,1143,'hi','à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(41140,1143,'ms','Ralat semasa Hapus',0),(41141,1143,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ù„Ø­Ø°Ù',0),(41142,1143,'fr','Erreur lors de la suppression',0),(41143,1143,'jp','æ¶ˆåŽ»ä¸­ã‚¨ãƒ©ãƒ¼',0),(41144,1143,'pt','Erro durante a exclusÃ£o',0),(41145,1143,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ð¸',0),(41146,1143,'es','Error durante Eliminar',0),(41147,1143,'de','Fehler beim LÃ¶schen',0),(41148,1143,'en','Error During Delete',0),(41149,1144,'is','',0),(41150,1144,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø­Ø³Ø§Ø¨ ',0),(41151,1144,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø­Ø³Ø§Ø¨ ',0),(41152,1144,'tr','Hesap silme hatasÄ±',0),(41153,1144,'pl','BÅ‚Ä…d podczas usuwania konta',0),(41154,1144,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(41155,1144,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(41156,1144,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(41157,1144,'vi','XÃ³a TK Bá»‹ Lá»—i',0),(41158,1144,'af','Fout om rekening te skrap',0),(41159,1144,'ro','Eroare la È™tergerea contului',0),(41160,1144,'et','TÃµrge kustutamisel arvesse',0),(41161,1144,'si','Napaka brisanja raÄuna',0),(41162,1144,'ba','Error menghapus akun',0),(41163,1144,'nl','Fout bij het verwijderen van de account',0),(41164,1144,'fi','Virhe tilin poistaminen',0),(41165,1144,'no','Feil ved sletting av konto',0),(41166,1144,'da','Fejl ved sletning af konto',0),(41167,1144,'ko','ê³„ì • ì‚­ì œ ì˜¤ë¥˜',0),(41168,1144,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×—×©×‘×•×Ÿ',0),(41169,1144,'el','Î£Ï†Î¬Î»Î¼Î± Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(41170,1144,'zh','é”™è¯¯åˆ é™¤å¸æˆ·',0),(41171,1144,'sv','Fel ta bort konto',0),(41172,1144,'it','Errore cancellazione account',0),(41173,1144,'tl','',0),(41174,1144,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(41175,1144,'hi','à¤–à¤¾à¤¤à¤¾ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(41176,1144,'ms','Ralat menghapuskan akaun',0),(41177,1144,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„Ø­Ø³Ø§Ø¨',0),(41178,1144,'fr','Erreur de suppression de compte',0),(41179,1144,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41180,1144,'pt','Erro ao excluir conta',0),(41181,1144,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(41182,1144,'es','Error eliminando cuenta',0),(41183,1144,'de','Fehler beim LÃ¶schen des Kontos',0),(41184,1144,'en','Error deleting account',0),(41185,1145,'is','',0),(41186,1145,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ ',0),(41187,1145,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ ',0),(41188,1145,'tr','Hata silme hesap tÃ¼rÃ¼',0),(41189,1145,'pl','BÅ‚Ä…d usuwania konta typu',0),(41190,1145,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ñ‚Ð¸Ð¿ Ð³Ñ€ÐµÑˆÐºÐ°',0),(41191,1145,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(41192,1145,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(41193,1145,'vi','XÃ³a Loáº¡i TK Bá»‹ Lá»—i',0),(41194,1145,'af','Fout skrap rekeningtipe',0),(41195,1145,'ro','Eroare ÅŸtergerea contului tip',0),(41196,1145,'et','TÃµrge kustutamisel kontotÃ¼Ã¼p',0),(41197,1145,'si','Brisanje raÄun vrsta napake',0),(41198,1145,'ba','Jenis account menghapus kesalahan',0),(41199,1145,'nl','Fout verwijderen accounttype',0),(41200,1145,'fi','Virhe poistettaessa tilityyppi',0),(41201,1145,'no','Feil slette kontotype',0),(41202,1145,'da','Fejl slette kontotype',0),(41203,1145,'ko','ì˜¤ë¥˜ ì‚­ì œ ê³„ì • ìœ í˜•',0),(41204,1145,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×¡×•×’ ×—×©×‘×•×Ÿ',0),(41205,1145,'el','Î£Ï†Î¬Î»Î¼Î± Ï„ÏÏ€Î¿Ï… Î´Î¹Î±Î³ÏÎ±Ï†Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(41206,1145,'zh','é”™è¯¯åˆ é™¤å¸æˆ·ç±»åž‹',0),(41207,1145,'sv','Misstag utplÃ¥nande kontotyp',0),(41208,1145,'it','Tipo di errore Eliminazione account',0),(41209,1145,'tl','',0),(41210,1145,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(41211,1145,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(41212,1145,'ms','Ralat menghapuskan akaun jenis',0),(41213,1145,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(41214,1145,'fr','Type de compte supprimer erreur',0),(41215,1145,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41216,1145,'pt','Tipo de conta erro excluindo',0),(41217,1145,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ñ‚Ð¸Ð¿ Ð¾ÑˆÐ¸Ð±ÐºÐ¸',0),(41218,1145,'es','Error eliminando tipo de cuenta',0),(41219,1145,'de','Fehler lÃ¶schen von Account-Typ',0),(41220,1145,'en','Error deleting account type',0),(41221,1146,'is','',0),(41222,1146,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(41223,1146,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(41224,1146,'tr','Hata silme bill',0),(41225,1146,'pl','BÅ‚Ä…d usuwania ustawy',0),(41226,1146,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð±Ð¸Ð»',0),(41227,1146,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ø¨Ù„',0),(41228,1146,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð‘Ð¸Ð»',0),(41229,1146,'vi','XÃ³a HÃ³a ÄÆ¡n Bá»‹ Lá»—i',0),(41230,1146,'af','Fout met skrapping van Wetsontwerp',0),(41231,1146,'ro','Eroare ÅŸtergerea bill',0),(41232,1146,'et','TÃµrge kustutamisel bill',0),(41233,1146,'si','Napaka brisanja bill',0),(41234,1146,'ba','Error menghapus tagihan',0),(41235,1146,'nl','Fout verwijderen factuur',0),(41236,1146,'fi','Virhe poistettaessa bill',0),(41237,1146,'no','Feil slette bill',0),(41238,1146,'da','Fejl slette bill',0),(41239,1146,'ko','ì˜¤ë¥˜ ì‚­ì œ ì²­êµ¬ì„œ',0),(41240,1146,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×‘×™×œ',0),(41241,1146,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(41242,1146,'zh','é”™è¯¯åˆ é™¤å¸å•',0),(41243,1146,'sv','Misstag utplÃ¥nande bill',0),(41244,1146,'it','Bill eliminazione errore',0),(41245,1146,'tl','',0),(41246,1146,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(41247,1146,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤µà¤¿à¤§à¥‡à¤¯à¤•',0),(41248,1146,'ms','Rang undang-undang menghapuskan kesilapan',0),(41249,1146,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(41250,1146,'fr','Projet de loi supprimant erreur',0),(41251,1146,'jp','è«‹æ±‚æ›¸ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41252,1146,'pt','Excluindo conta de erro',0),(41253,1146,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð‘Ð¸Ð»Ð»',0),(41254,1146,'es','Error eliminando recibo',0),(41255,1146,'de','Fehler lÃ¶schen von bill',0),(41256,1146,'en','Error deleting bill',0),(41257,1147,'is','',0),(41258,1147,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø¬Ø²Ø¦ÙŠØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(41259,1147,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø¬Ø²Ø¦ÙŠØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(41260,1147,'tr','Hata silme fatura ayrÄ±ntÄ±sÄ±',0),(41261,1147,'pl','BÅ‚Ä…d usuwania rachunek szczegÃ³Å‚owy',0),(41262,1147,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð±Ð¸Ð» Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(41263,1147,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ù„ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(41264,1147,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð‘Ð¸Ð» Ð´ÐµÑ‚Ð°Ñ™',0),(41265,1147,'vi','XÃ³a chi tiáº¿t hÃ³a Ä‘Æ¡n bá»‹ lá»—i',0),(41266,1147,'af','Fout met skrapping van Wetsontwerp detail',0),(41267,1147,'ro','Eroare ÅŸtergerea bill detaliu',0),(41268,1147,'et','TÃµrge kustutamisel arve Ã¼ksikasjad',0),(41269,1147,'si','Napaka brisanja zakona podrobno',0),(41270,1147,'ba','Detail tagihan menghapus kesalahan',0),(41271,1147,'nl','Fout verwijderen bill detail',0),(41272,1147,'fi','Virhe poistettaessa laskun tiedot',0),(41273,1147,'no','Slette bill feildetaljer',0),(41274,1147,'da','Fejl slette bill detaljer',0),(41275,1147,'ko','ì˜¤ë¥˜ ì‚­ì œ ì²­êµ¬ì„œ ì„¸ë¶€ ì‚¬í•­',0),(41276,1147,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”×—×©×‘×•×Ÿ ×¤×¨×˜',0),(41277,1147,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(41278,1147,'zh','é”™è¯¯åˆ é™¤å¸å•ç»†èŠ‚\r\n',0),(41279,1147,'sv','Misstag utplÃ¥nande bill detalj',0),(41280,1147,'it','Dettaglio fattura eliminazione di errore',0),(41281,1147,'tl','',0),(41282,1147,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3651;&#3610;&#3648;&#3619;&#3637;&#3',0),(41283,1147,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤¬à¤¿à¤² à¤µà¤¿à¤µà¤°à¤£',0),(41284,1147,'ms','Ralat Menghapuskan bil terperinci',0),(41285,1147,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù ÙØ§ØªÙˆØ±Ø© Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(41286,1147,'fr','DÃ©tail de facture suppression erreur',0),(41287,1147,'jp','è«‹æ±‚æ›¸è©³ç´°ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41288,1147,'pt','Detalhe de bill excluindo erro',0),(41289,1147,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð‘Ð¸Ð»Ð» Ð´ÐµÑ‚Ð°Ð»ÑŒ',0),(41290,1147,'es','Error eliminando detalle de recibo',0),(41291,1147,'de','LÃ¶schen von Bill Fehlerdetails.',0),(41292,1147,'en','Error deleting bill detail',0),(41293,1148,'is','',0),(41294,1148,'dr','( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(41295,1148,'pr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù ØªØ§Ø¨Ø¹ ( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(41296,1148,'tr','Hata silme baÄŸlayÄ±cÄ± iÅŸlev.',0),(41297,1148,'pl','Usuwanie funkcji bÅ‚Ä™du bazy danych bindery.',0),(41298,1148,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ.',0),(41299,1148,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ ÛÛ’ Û”',0),(41300,1148,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð±Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°.',0),(41301,1148,'vi','Lá»—i khi xÃ³a chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch',0),(41302,1148,'af','Fout skrap bindery funksie.',0),(41303,1148,'ro','Eroare de ÅŸtergerea legatorie funcÅ£ia.',0),(41304,1148,'et','TÃµrge kustutamisel Kirjansitomo funktsiooni.',0),(41305,1148,'si','Brisanje Knjigoveznica funkcijo napake.',0),(41306,1148,'ba','Error menghapus bindery fungsi.',0),(41307,1148,'nl','Fout verwijderen bindery functie.',0),(41308,1148,'fi','Virhe poistettaessa bindery-toimintoa.',0),(41309,1148,'no','Feil slette bindery-funksjonen.',0),(41310,1148,'da','Fejl slette bindery funktion.',0),(41311,1148,'ko','ì˜¤ë¥˜ ì‚­ì œ ë°”ì¸ë”ë¦¬ ê¸°ëŠ¥ìž…ë‹ˆë‹¤.',0),(41312,1148,'he','×©×’×™××” ×‘×ž×—×™×§×ª bindery ×¤×•× ×§×¦×™×”.',0),(41313,1148,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® bindery ÏƒÏ…Î½Î¬ÏÏ„Î·ÏƒÎ· ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(41314,1148,'zh','é”™è¯¯åˆ é™¤è£…è®¢åŠŸèƒ½ã€‚',0),(41315,1148,'sv','Misstag utplÃ¥nande bindery funktion.',0),(41316,1148,'it','Funzione della legatoria eliminazione di errori.',0),(41317,1148,'tl','',0),(41318,1148,'th','Error deleting bindery function.',0),(41319,1148,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹à¥¤',0),(41320,1148,'ms','Ralat Menghapuskan fungsi bindery.',0),(41321,1148,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø¯Ø§Ù„Ø©.',0),(41322,1148,'fr','Fonction bindery suppression par erreur.',0),(41323,1148,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41324,1148,'pt','FunÃ§Ã£o de apagar erros de bindery.',0),(41325,1148,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ.',0),(41326,1148,'es','Error eliminando funciÃ³n de encuadernaciÃ³n',0),(41327,1148,'de','Fehler lÃ¶schen von Buchbinderei-Funktion.',0),(41328,1148,'en','Error deleting bindery function.',0),(41329,1149,'is','',0),(41330,1149,'dr','( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(41331,1149,'pr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ø§Ù†Ø¯Ø§Ø²Ù‡  ØªØ§Ø¨Ø¹ ( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(41332,1149,'tr','Hata silme baÄŸlayÄ±cÄ± iÅŸlevi boyutu.',0),(41333,1149,'pl','BÅ‚Ä…d usuwania introligatornia funkcja rozmiar.',0),(41334,1149,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(41335,1149,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ø³Ø§Ø¦Ø² Û”',0),(41336,1149,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð±Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ.',0),(41337,1149,'vi','Lá»—i khi xÃ³a cá»¡ chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch',0),(41338,1149,'af','Fout skrap bindery funksie grootte.',0),(41339,1149,'ro','Eroare ÅŸtergerea legatorie funcÅ£ia dimensiunea.',0),(41340,1149,'et','TÃµrge kustutamisel Kirjansitomo funktsiooni suurus.',0),(41341,1149,'si','Napaka brisanja Knjigoveznica funkcijo velikosti.',0),(41342,1149,'ba','Error menghapus bindery fungsi ukuran.',0),(41343,1149,'nl','Fout verwijderen bindery functie grootte.',0),(41344,1149,'fi','Virhe poistettaessa bindery tehtÃ¤vÃ¤ koko.',0),(41345,1149,'no','Feil slette bindery funksjon stÃ¸rrelsen.',0),(41346,1149,'da','Fejl slette bindery funktion stÃ¸rrelse.',0),(41347,1149,'ko','ì˜¤ë¥˜ ì‚­ì œ ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ í¬ê¸°ìž…ë‹ˆë‹¤.',0),(41348,1149,'he','×©×’×™××” ×‘×ž×—×™×§×ª bindery ×¤×•× ×§×¦×™×” ×’×•×“×œ.',0),(41349,1149,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚.',0),(41350,1149,'zh','é”™è¯¯åˆ é™¤è£…è®¢åŠŸèƒ½çš„å¤§å°',0),(41351,1149,'sv','Misstag utplÃ¥nande bindery funktion storlek.',0),(41352,1149,'it','Dimensione di funzione della legatoria eliminazione errore.',0),(41353,1149,'tl','',0),(41354,1149,'th','Error deleting bindery function size.',0),(41355,1149,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤†à¤•à¤¾à¤°à¥¤',0),(41356,1149,'ms','Ralat Menghapuskan bindery fungsi saiz.',0),(41357,1149,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø­Ø¬Ù… ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(41358,1149,'fr','Erreur suppression faÃ§onnage fonction taille.',0),(41359,1149,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚µã‚¤ã‚ºã?®ã‚¨ãƒ©ãƒ¼',0),(41360,1149,'pt','Tamanho exclusÃ£o da funÃ§Ã£o bindery de erro.',0),(41361,1149,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(41362,1149,'es','Error eliminando tamaÃ±o de funciÃ³n de encuadernaciÃ³n',0),(41363,1149,'de','Fehler lÃ¶schen von Buchbinderei-Funktion-GrÃ¶ÃŸe.',0),(41364,1149,'en','Error deleting bindery function size.',0),(41365,1150,'is','',0),(41366,1150,'dr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ú¯Ø²ÙŠÙ†Ù‡ Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ÙŠ  Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(41367,1150,'pr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ú¯Ø²ÙŠÙ†Ù‡ Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ÙŠ  Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(41368,1150,'tr','BaÄŸlayÄ±cÄ± seÃ§eneÄŸi liste Ã¶ÄŸesi silme hatasÄ±.',0),(41369,1150,'pl','BÅ‚Ä…d podczas usuwania elementu listy opcji bazy danych bindery.',0),(41370,1150,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ð¾Ð¿Ñ†Ð¸Ñ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº.',0),(41371,1150,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ø§Ø®ØªÛŒØ§Ø± ÙÛØ±Ø³Øª Ø´Û’ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(41372,1150,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð±Ð¸Ð½Ð´ÐµÑ€y ÑÑ‚Ð°Ð²ÐºÑƒ ÑÐ° Ð»Ð¸ÑÑ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°.',0),(41373,1150,'vi','XÃ³a lá»±a chá»n Ä‘Ã³ng sÃ¡ch bá»‹ lá»—i',0),(41374,1150,'af','Fout met skrap van boekbindery opsielysitem',0),(41375,1150,'ro','Eroare la È™tergerea legatorie opÅ£iune element din listÄƒ.',0),(41376,1150,'et','TÃµrge kustutamisel Kirjansitomo variant loendiÃ¼ksust.',0),(41377,1150,'si','Napaka pri brisanju elementa seznama moÅ¾nost Knjigoveznica.',0),(41378,1150,'ba','Error menghapus item daftar pilihan bindery.',0),(41379,1150,'nl','Fout bij het verwijderen van bindery optie lijstitem.',0),(41380,1150,'fi','Virhe poistettaessa bindery luettelon vaihtoehdon.',0),(41381,1150,'no','Feil ved sletting av bindery alternativet listeelementet.',0),(41382,1150,'da','Fejl ved sletning af bindery indstilling listeelementet.',0),(41383,1150,'ko','ë°”ì¸ë”ë¦¬ ì˜µì…˜ ëª©ë¡ í•­ëª©ì„ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(41384,1150,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×¤×¨×™×˜ ×¨×©×™×ž×” ×©×œ ××¤×©×¨×•×™×•×ª ×’×™×ž×•×¨.',0),(41385,1150,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î»Î¯ÏƒÏ„Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î® bindery.',0),(41386,1150,'zh','é”™è¯¯åˆ é™¤è£…è®¢é€‰é¡¹åˆ—è¡¨é¡¹ç›®',0),(41387,1150,'sv','Misstag utplÃ¥nande bindery alternativet listobjektet.',0),(41388,1150,'it','Errore eliminando legatoria opzione elenco elemento.',0),(41389,1150,'tl','',0),(41390,1150,'th','Error deleting bindery option list item.',0),(41391,1150,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(41392,1150,'ms','Ralat menghapuskan item senarai pilihan bindery.',0),(41393,1150,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø¹Ù†ØµØ± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø®ÙŠØ§Ø± Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(41394,1150,'fr','Erreur suppression d\'Ã©lÃ©ment de liste option faÃ§onnage.',0),(41395,1150,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚ªãƒ—ã‚·ãƒ§ãƒ³ãƒªã‚¹ãƒˆå“?ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41396,1150,'pt','Erro ao excluir o item de lista de opÃ§Ã£o de encadernaÃ§Ã£o.',0),(41397,1150,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÑÐ¿Ð¸ÑÐºÐ° Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ bindery.',0),(41398,1150,'es','Error eliminando opciÃ³n de encuadernaciÃ³n item de lista',0),(41399,1150,'de','Fehler beim LÃ¶schen der Buchbinderei Option Listenelement.',0),(41400,1150,'en','Error deleting bindery option list item.',0),(41401,1151,'is','',0),(41402,1151,'dr','.',0),(41403,1151,'pr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª.',0),(41404,1151,'tr','Hata silme baÄŸlayÄ±cÄ± tÃ¼rÃ¼.',0),(41405,1151,'pl','BÅ‚Ä…d usuwania typ wiÄ…zaÅ„.',0),(41406,1151,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ‚Ð¸Ð¿.',0),(41407,1151,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚Ø³Ù… ÛÛ’ Û”',0),(41408,1151,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð±Ð¸Ð½Ð´ÐµÑ€y Ñ‚Ð¸Ð¿.',0),(41409,1151,'vi','Lá»—i khi xÃ³a loáº¡i Ä‘Ã³ng sÃ¡ch',0),(41410,1151,'af','Skrap bindery fouttipe.',0),(41411,1151,'ro','Eroare ÅŸtergerea tip de legatorie.',0),(41412,1151,'et','TÃµrge kustutamisel Kirjansitomo tÃ¼Ã¼p.',0),(41413,1151,'si','Brisanje Knjigoveznica vrsta napake.',0),(41414,1151,'ba','Error menghapus bindery tipe.',0),(41415,1151,'nl','Fout verwijderen bindery type.',0),(41416,1151,'fi','Virhe poistettaessa bindery tyyppi.',0),(41417,1151,'no','Feil slette bindery type.',0),(41418,1151,'da','Fejl slette bindery type.',0),(41419,1151,'ko','ì˜¤ë¥˜ ì‚­ì œ ë°”ì¸ë”ë¦¬ í˜•ì‹ìž…ë‹ˆë‹¤.',0),(41420,1151,'he','×©×’×™××” ×‘×ž×—×™×§×ª bindery ×¡×•×’.',0),(41421,1151,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„ÏÏ€Î¿Ï… bindery ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(41422,1151,'zh','é”™è¯¯åˆ é™¤è£…è®¢ç±»åž‹ã€‚',0),(41423,1151,'sv','Ta bort bindery feltyp.',0),(41424,1151,'it','Errore tipo di eliminazione della legatoria.',0),(41425,1151,'tl','',0),(41426,1151,'th','Error deleting bindery type.',0),(41427,1151,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤•à¤¾à¤°à¥¤',0),(41428,1151,'ms','Ralat Menghapuskan jenis bindery.',0),(41429,1151,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù†ÙˆØ¹ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(41430,1151,'fr','Erreur suppression type de faÃ§onnage.',0),(41431,1151,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚¿ã‚¤ãƒ—ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41432,1151,'pt','Excluindo tipo de encadernaÃ§Ã£o de erro.',0),(41433,1151,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ‚Ð¸Ð¿Ð°.',0),(41434,1151,'es','Error eliminando tipo de encuadernaciÃ³n',0),(41435,1151,'de','LÃ¶schen von Buchbinderei Fehlertyp.',0),(41436,1151,'en','Error deleting bindery type.',0),(41437,1152,'is','',0),(41438,1152,'dr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ù†ÙˆØ¹ ÙƒØ§Ø± Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(41439,1152,'pr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ù†ÙˆØ¹ ÙƒØ§Ø± Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(41440,1152,'tr','Bindery Ã§alÄ±ÅŸma tÃ¼rÃ¼nÃ¼ silme hatasÄ±.',0),(41441,1152,'pl','BÅ‚Ä…d podczas usuwania wiÄ…zaÅ„ typu prac.',0),(41442,1152,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°.',0),(41443,1152,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ú©Ø§Ù… Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(41444,1152,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð±Ð¸Ð½Ð´ÐµÑ€y Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð°.',0),(41445,1152,'vi','Lá»—i khi xÃ³a loáº¡i cÃ´ng viá»‡c Ä‘Ã³ng sÃ¡ch',0),(41446,1152,'af','Fout met skrapping bindery werk tipe.',0),(41447,1152,'ro','Eroare la È™tergerea tipului de muncÄƒ legatorie.',0),(41448,1152,'et','TÃµrge kustutamisel Kirjansitomo tÃ¶Ã¶ liik.',0),(41449,1152,'si','Brisanje Knjigoveznica vrsta dela napake.',0),(41450,1152,'ba','Error menghapus jenis pekerjaan bindery.',0),(41451,1152,'nl','Fout bij het verwijderen van bindery werksoort.',0),(41452,1152,'fi','Virhe poistettaessa bindery tyÃ¶tyyppi.',0),(41453,1152,'no','Feil ved sletting av bindery arbeidstype.',0),(41454,1152,'da','Fejl ved sletning af bindery arbejdstype.',0),(41455,1152,'ko','ë°”ì¸ë”ë¦¬ ìž‘ì—… í˜•ì‹ì„ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(41456,1152,'he','×©×’×™××” ×‘×ž×—×™×§×ª bindery ×¡×•×’ ×¢×‘×•×“×”.',0),(41457,1152,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® bindery Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚.',0),(41458,1152,'zh','é”™è¯¯åˆ é™¤è£…è®¢å·¥ä½œç±»åž‹ã€‚',0),(41459,1152,'sv','Misstag utplÃ¥nande bindery arbetstyp.',0),(41460,1152,'it','Errore eliminazione della legatoria tipo di lavoro.',0),(41461,1152,'tl','',0),(41462,1152,'th','Error deleting bindery work type.',0),(41463,1152,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(41464,1152,'ms','Ralat Menghapuskan jenis kerja bindery.',0),(41465,1152,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ù†ÙˆØ¹ Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¹Ù…Ù„.',0),(41466,1152,'fr','Erreur de suppression de type de travail de faÃ§onnage.',0),(41467,1152,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ä½œæ¥­ã‚¿ã‚¤ãƒ—ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41468,1152,'pt','Erro ao excluir o tipo de vinculaÃ§Ã£o de trabalho.',0),(41469,1152,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¸Ð¿Ð° Ð¿ÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ñ‹Ñ… Ñ€Ð°Ð±Ð¾Ñ‚.',0),(41470,1152,'es','Error eliminando tipo de trabajo de encuadernaciÃ³n',0),(41471,1152,'de','Fehler beim LÃ¶schen der Buchbinderei Arbeitstyp.',0),(41472,1152,'en','Error deleting bindery work type.',0),(41473,1153,'is','',0),(41474,1153,'dr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(41475,1153,'pr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(41476,1153,'tr','Hata silme taÅŸÄ±yÄ±cÄ±',0),(41477,1153,'pl','BÅ‚Ä…d usuwania przewoÅºnika',0),(41478,1153,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(41479,1153,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©ÛŒØ±ÛŒØ¦Ø±',0),(41480,1153,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð½Ð¾ÑÐ°Ñ‡',0),(41481,1153,'vi','Lá»—i khi xÃ³a hÃ£ng váº­n chuyá»ƒn',0),(41482,1153,'af','\'n Fout het onstaan met die skrap van karweier',0),(41483,1153,'ro','Eroare ÅŸtergerea transportator',0),(41484,1153,'et','TÃµrge kustutamisel vedaja',0),(41485,1153,'si','Brisanje napake prevoznika',0),(41486,1153,'ba','Operator menghapus kesalahan',0),(41487,1153,'nl','Fout verwijderen vervoerder',0),(41488,1153,'fi','Virhe poistettaessa harjoittaja',0),(41489,1153,'no','Feil slette operatÃ¸r',0),(41490,1153,'da','Fejl slette luftfartsselskabet',0),(41491,1153,'ko','ì˜¤ë¥˜ ì‚­ì œ ìºë¦¬ì–´',0),(41492,1153,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”×ž×•×‘×™×œ',0),(41493,1153,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(41494,1153,'zh','é”™è¯¯åˆ é™¤æ‰¿è¿å•†',0),(41495,1153,'sv','Misstag utplÃ¥nande bÃ¤rare',0),(41496,1153,'it','Vettore eliminazione errore',0),(41497,1153,'tl','',0),(41498,1153,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(41499,1153,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤µà¤¾à¤¹à¤•',0),(41500,1153,'ms','Ralat Menghapuskan pembawa',0),(41501,1153,'ar','Ø®Ø·Ø£ Ø§Ù„Ù†Ø§Ù‚Ù„ Ø­Ø°Ù',0),(41502,1153,'fr','Transporteur suppression erreur',0),(41503,1153,'jp','é…?é€?æ¥­è€…ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41504,1153,'pt','Transportadora excluindo erro',0),(41505,1153,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÐšÑƒÑ€ÑŒÐµÑ€Ð°',0),(41506,1153,'es','Error eliminando transportador',0),(41507,1153,'de','Fehler lÃ¶schen von carrier',0),(41508,1153,'en','Error deleting carrier',0),(41509,1154,'is','',0),(41510,1154,'dr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ú†Ùƒ ',0),(41511,1154,'pr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ú†Ùƒ ',0),(41512,1154,'tr','Onay silme hatasÄ±',0),(41513,1154,'pl','BÅ‚Ä…d podczas usuwania wyboru',0),(41514,1154,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‡ÐµÐº',0),(41515,1154,'ur','Ù†Ù‚Øµ Ù¾Ú‘ØªØ§Ù„ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(41516,1154,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(41517,1154,'vi','XÃ³a SÃ©c bá»‹ lá»—i',0),(41518,1154,'af','Fout skrap kontroleer',0),(41519,1154,'ro','Eroare la È™tergerea verifica',0),(41520,1154,'et','TÃµrge kustutamisel sisse',0),(41521,1154,'si','Potrdite brisanje napake',0),(41522,1154,'ba','Error menghapus check',0),(41523,1154,'nl','Fout bij het verwijderen van selectievakje',0),(41524,1154,'fi','Virhe poistettaessa uloskirjautuminen',0),(41525,1154,'no','Feil ved sletting av',0),(41526,1154,'da','Fejl ved sletning af check',0),(41527,1154,'ko','ì˜¤ë¥˜ ì‚­ì œ í™•ì¸',0),(41528,1154,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×¡×™×ž×•×Ÿ',0),(41529,1154,'el','Î›Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(41530,1154,'zh','é”™è¯¯åˆ é™¤æ£€æŸ¥',0),(41531,1154,'sv','Misstag utplÃ¥nande check',0),(41532,1154,'it','Errore eliminando il controllo',0),(41533,1154,'tl','',0),(41534,1154,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3648;&#3594;&#3655;&#3588;',0),(41535,1154,'hi','à¤šà¥‡à¤• à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(41536,1154,'ms','Ralat Menghapuskan semak',0),(41537,1154,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(41538,1154,'fr','Erreur de suppression de cocher',0),(41539,1154,'jp','å°?åˆ‡æ‰‹ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41540,1154,'pt','Erro ao excluir seleÃ§Ã£o',0),(41541,1154,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(41542,1154,'es','Error eliminando cheque',0),(41543,1154,'de','Fehler beim LÃ¶schen der KontrollkÃ¤stchen',0),(41544,1154,'en','Error deleting check',0),(41545,1155,'is','',0),(41546,1155,'dr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(41547,1155,'pr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(41548,1155,'tr','Hata silme Ã§ek hesabÄ±',0),(41549,1155,'pl','BÅ‚Ä…d usuwania konta bankowego',0),(41550,1155,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(41551,1155,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹',0),(41552,1155,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(41553,1155,'vi','XÃ³a TK SÃ©c Bá»‹ Lá»—i',0),(41554,1155,'af','Fout met skrap van tjekrekening',0),(41555,1155,'ro','Åžtergerea cont de verificare eroare',0),(41556,1155,'et','TÃµrge kustutamisel pangakonto',0),(41557,1155,'si','Napaka brisanja preverjanje raÄuna',0),(41558,1155,'ba','Error menghapus memeriksa rekening',0),(41559,1155,'nl','Fout verwijderen betaalrekening',0),(41560,1155,'fi','Virhe poistettaessa tarkkailun huomioon',0),(41561,1155,'no','Feil slette brukskonto',0),(41562,1155,'da','Fejl slette checkkonto',0),(41563,1155,'ko','ì˜¤ë¥˜ ì‚­ì œ ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(41564,1155,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×—×©×‘×•×Ÿ ×‘× ×§',0),(41565,1155,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï„ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(41566,1155,'zh','é”™è¯¯åˆ é™¤æ”¯ç¥¨å¸æˆ·',0),(41567,1155,'sv','Misstag utplÃ¥nande lÃ¶nekonto',0),(41568,1155,'it','Errore eliminazione conto corrente',0),(41569,1155,'tl','',0),(41570,1155,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3594;&#3655;&#3588;',0),(41571,1155,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(41572,1155,'ms','Ralat Menghapuskan memeriksa akaun',0),(41573,1155,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ',0),(41574,1155,'fr','Erreur suppression compte-chÃ¨ques',0),(41575,1155,'jp','å½“åº§é ?é‡‘ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41576,1155,'pt','ExclusÃ£o de conta de erro',0),(41577,1155,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚',0),(41578,1155,'es','Error eliminando cuenta de cheques',0),(41579,1155,'de','Fehler lÃ¶schen von Girokonto',0),(41580,1155,'en','Error deleting checking account',0),(41581,1156,'is','',0),(41582,1156,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø±Ù†Ú¯ ',0),(41583,1156,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø±Ù†Ú¯ ',0),(41584,1156,'tr','Renk silme hatasÄ±.',0),(41585,1156,'pl','BÅ‚Ä…d podczas usuwania koloru.',0),(41586,1156,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ†Ð²ÑÑ‚.',0),(41587,1156,'ur','Ø±Ù†Ú¯ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(41588,1156,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð±Ð¾Ñ˜Ð°.',0),(41589,1156,'vi','Lá»—i khi xÃ³a máº§u',0),(41590,1156,'af','Fout met skrapping van kleur.',0),(41591,1156,'ro','Eroare la È™tergerea de culoare.',0),(41592,1156,'et','TÃµrge kustutamisel vÃ¤rvi.',0),(41593,1156,'si','Napaka pri brisanju barvne.',0),(41594,1156,'ba','Error menghapus warna.',0),(41595,1156,'nl','Fout bij het verwijderen van kleur.',0),(41596,1156,'fi','Virhe poistettaessa vÃ¤ri.',0),(41597,1156,'no','Feil ved sletting av farge.',0),(41598,1156,'da','Fejl ved sletning af farve.',0),(41599,1156,'ko','ìƒ‰ìƒì„ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(41600,1156,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×¦×‘×¢.',0),(41601,1156,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï‡ÏÏŽÎ¼Î±.',0),(41602,1156,'zh','é”™è¯¯åˆ é™¤çš„é¢œè‰²ã€‚',0),(41603,1156,'sv','Fel ta bort fÃ¤rg.',0),(41604,1156,'it','Errore cancellando il colore.',0),(41605,1156,'tl','',0),(41606,1156,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3626;&#3637;',0),(41607,1156,'hi','à¤°à¤‚à¤— à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(41608,1156,'ms','Ralat Menghapuskan warna.',0),(41609,1156,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„Ø£Ù„ÙˆØ§Ù†.',0),(41610,1156,'fr','Erreur de suppression de couleur.',0),(41611,1156,'jp','å½“åº§é ?é‡‘ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41612,1156,'pt','Erro ao excluir a cor.',0),(41613,1156,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ñ†Ð²ÐµÑ‚Ð°.',0),(41614,1156,'es','Error eliminando color',0),(41615,1156,'de','Fehler beim LÃ¶schen von Farbe.',0),(41616,1156,'en','Error deleting color.',0),(41617,1157,'is','',0),(41618,1157,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø´Ø±ÙƒØª ',0),(41619,1157,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø´Ø±ÙƒØª ',0),(41620,1157,'tr','Hata silme ÅŸirket',0),(41621,1157,'pl','BÅ‚Ä…d usuwania firmy',0),(41622,1157,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(41623,1157,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©Ù…Ù¾Ù†ÛŒ',0),(41624,1157,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(41625,1157,'vi','XÃ³a cty bá»‹ lá»—i',0),(41626,1157,'af','Fout met skrapping van maatskappy',0),(41627,1157,'ro','Eroare ÅŸtergerea companiei',0),(41628,1157,'et','EttevÃµtte kustutamisel tekkis viga',0),(41629,1157,'si','Napaka izbris podjetja',0),(41630,1157,'ba','Error menghapus perusahaan',0),(41631,1157,'nl','Fout verwijderen bedrijf',0),(41632,1157,'fi','Virhe poistettaessa yritys',0),(41633,1157,'no','Feil slette selskap',0),(41634,1157,'da','Fejl slette selskab',0),(41635,1157,'ko','ì˜¤ë¥˜ ì‚­ì œ íšŒì‚¬',0),(41636,1157,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×—×‘×¨×”',0),(41637,1157,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(41638,1157,'zh','é”™è¯¯åˆ é™¤å…¬å¸',0),(41639,1157,'sv','Misstag utplÃ¥nande fÃ¶retag',0),(41640,1157,'it','Azienda eliminazione errore',0),(41641,1157,'tl','',0),(41642,1157,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(41643,1157,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¤‚à¤ªà¤¨à¥€',0),(41644,1157,'ms','Ralat Menghapuskan Syarikat',0),(41645,1157,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø´Ø±ÙƒØ©',0),(41646,1157,'fr','SociÃ©tÃ© suppression erreur',0),(41647,1157,'jp','ä¼šç¤¾ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41648,1157,'pt','Empresa excluindo erro',0),(41649,1157,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(41650,1157,'es','Error eliminando empresa',0),(41651,1157,'de','Fehler lÃ¶schen von Unternehmen',0),(41652,1157,'en','Error deleting company',0),(41653,1158,'is','',0),(41654,1158,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡',0),(41655,1158,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡',0),(41656,1158,'tr','Maliyet merkezi silme hatasÄ±',0),(41657,1158,'pl','BÅ‚Ä…d podczas usuwania MPK',0),(41658,1158,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(41659,1158,'ur','Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø² Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(41660,1158,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(41661,1158,'vi','XÃ³a Cost center bá»‹ lá»—i',0),(41662,1158,'af','Fout skrap koste Sentrum',0),(41663,1158,'ro','Eroare la È™tergerea centru de Cost',0),(41664,1158,'et','TÃµrge kustutamisel Kulukeskus',0),(41665,1158,'si','Napaka pri brisanju stroÅ¡kovno srediÅ¡Äe',0),(41666,1158,'ba','Error menghapus biaya Pusat',0),(41667,1158,'nl','Fout bij het verwijderen van kostenplaats',0),(41668,1158,'fi','Virhe poistettaessa kustannuspaikka',0),(41669,1158,'no','Feil ved sletting av kostsenter',0),(41670,1158,'da','Fejl ved sletning af bÃ¦reren',0),(41671,1158,'ko','ë¹„ìš© ì„¼í„° ì‚­ì œ ì˜¤ë¥˜',0),(41672,1158,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ž×¨×›×– ×¢×œ×•×™×•×ª',0),(41673,1158,'el','Î›Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(41674,1158,'zh','é”™è¯¯åˆ é™¤æˆæœ¬ä¸­å¿ƒã€‚',0),(41675,1158,'sv','Misstag utplÃ¥nande kostnadsstÃ¤lle',0),(41676,1158,'it','Errore cancellando il centro di costo',0),(41677,1158,'tl','',0),(41678,1158,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;',0),(41679,1158,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(41680,1158,'ms','Ralat Menghapuskan Pusat kos',0),(41681,1158,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(41682,1158,'fr','Erreur de suppression de centre de coÃ»t',0),(41683,1158,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41684,1158,'pt','Erro ao excluir o centro de custo',0),(41685,1158,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½Ñ‚Ñ€Ð° Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(41686,1158,'es','Error eliminando centro de costos',0),(41687,1158,'de','Fehler beim LÃ¶schen der Kostenstelle',0),(41688,1158,'en','Error deleting Cost Center',0),(41689,1159,'is','',0),(41690,1159,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(41691,1159,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(41692,1159,'tr','Maliyet merkezi makine aile silme hatasÄ±',0),(41693,1159,'pl','BÅ‚Ä…d podczas usuwania rodziny maszyn centrum kosztÃ³w',0),(41694,1159,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(41695,1159,'ur','Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø² Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù† Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(41696,1159,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð° Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(41697,1159,'vi','XÃ³a Cost center dÃ²ng mÃ¡y gia Ä‘Ã¬nh bá»‹ lá»—i',0),(41698,1159,'af','Fout skrap koste sentrum masjien familie',0),(41699,1159,'ro','Eroare la È™tergerea costul centru maÅŸinÄƒ de familie',0),(41700,1159,'et','TÃµrge kustutamisel kulu keskuses kohapeal pere',0),(41701,1159,'si','Napaka, brisanje stroÅ¡kov Center stroj druÅ¾ine',0),(41702,1159,'ba','Error menghapus biaya pusat mesin keluarga',0),(41703,1159,'nl','Fout bij het verwijderen van kosten Center Machine familie',0),(41704,1159,'fi','Virhe poistettaessa kustannus Center kone perhe',0),(41705,1159,'no','Feil ved sletting av Cost Center maskin familien',0),(41706,1159,'da','Fejl ved sletning af Cost Center maskine familie',0),(41707,1159,'ko','ë¹„ìš© ì„¼í„° ê¸°ê³„ ê°€ì¡± ì‚­ì œ ì˜¤ë¥˜',0),(41708,1159,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×¢×œ×•×ª ×ž×¨×›×– ×ž×›×•× ×ª ×”×ž×©×¤×—×”',0),(41709,1159,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Î¼Î·Ï‡Î±Î½Î® ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(41710,1159,'zh','é”™è¯¯åˆ é™¤æˆæœ¬ä¸­å¿ƒæœºç³»åˆ—ã€‚\r\n',0),(41711,1159,'sv','Fel ta bort kostnaden Center maskin familj',0),(41712,1159,'it','Errore eliminando la famiglia macchina centro di costo',0),(41713,1159,'tl','',0),(41714,1159,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3626;&#3585;&#3640;&#3621;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3',0),(41715,1159,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(41716,1159,'ms','Ralat Menghapuskan kos Pusat Mesin keluarga',0),(41717,1159,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù \"Ø§Ù„Ø£Ø³Ø±Ø© Ø¢Ù„Ø© Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©\"',0),(41718,1159,'fr','Erreur de suppression de famille de Machine pour le centre de coÃ»t',0),(41719,1159,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼æ©Ÿæ¢°ç³»çµ±ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41720,1159,'pt','Erro ao excluir a famÃ­lia de mÃ¡quina de centro de custo',0),(41721,1159,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ†ÐµÐ½Ñ‚Ñ€ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ ÑÐµÐ¼ÑŒÐ¸',0),(41722,1159,'es','Error eliminando familia de maquinas de centro de costos',0),(41723,1159,'de','Fehler beim LÃ¶schen der Cost-Center-Maschine-Familie',0),(41724,1159,'en','Error deleting Cost Center Machine Family',0),(41725,1160,'is','',0),(41726,1160,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø®Ø±ÙŠØ¯Ø§Ø±',0),(41727,1160,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø®Ø±ÙŠØ¯Ø§Ø±',0),(41728,1160,'tr','Hata silme mÃ¼ÅŸteri',0),(41729,1160,'pl','BÅ‚Ä…d usuwania klienta',0),(41730,1160,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(41731,1160,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú¯Ø§ÛÚ©',0),(41732,1160,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ ÐºÑƒÐ¿Ñ†Ð°',0),(41733,1160,'vi','Lá»—i khi xÃ³a khÃ¡ch hÃ ng',0),(41734,1160,'af','Fout met Skrap van KliÃ«nt/Klant',0),(41735,1160,'ro','Eroare client ÅŸtergerea',0),(41736,1160,'et','Kliendi kustutamisel tekkis viga',0),(41737,1160,'si','Napaka brisanje kupca',0),(41738,1160,'ba','Error menghapus pelanggan',0),(41739,1160,'nl','Fout verwijderen klant',0),(41740,1160,'fi','Virhe poistettaessa asiakasta',0),(41741,1160,'no','Feil slette kunde',0),(41742,1160,'da','Fejl slette kunde',0),(41743,1160,'ko','ì˜¤ë¥˜ ì‚­ì œ ê³ ê°',0),(41744,1160,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”×œ×§×•×—',0),(41745,1160,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(41746,1160,'zh','é”™è¯¯åˆ é™¤å®¢æˆ·',0),(41747,1160,'sv','Misstag utplÃ¥nande kund',0),(41748,1160,'it','Cliente eliminazione errore',0),(41749,1160,'tl','',0),(41750,1160,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(41751,1160,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(41752,1160,'ms','Ralat Menghapuskan pelanggan',0),(41753,1160,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(41754,1160,'fr','Client suppression erreur',0),(41755,1160,'jp','é¡§å®¢ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41756,1160,'pt','Cliente apagar erro',0),(41757,1160,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(41758,1160,'es','Error eliminando cliente',0),(41759,1160,'de','Fehler lÃ¶schen von Kunden',0),(41760,1160,'en','Error deleting customer',0),(41761,1161,'is','',0),(41762,1161,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø­Ù…Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(41763,1161,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø­Ù…Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(41764,1161,'tr','MÃ¼ÅŸteri gemiye silme hatasÄ±',0),(41765,1161,'pl','BÅ‚Ä…d podczas usuwania statku klienta',0),(41766,1161,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(41767,1161,'ur','Ú©Ø³Ù¹Ù…Ø± Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(41768,1161,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð±Ñ€Ð¾Ð´Ð° ÐºÑƒÐ¿Ñ†Ð° Ð´Ð°',0),(41769,1161,'vi','Lá»—i khi xÃ³a Ä‘á»‹a chá»‰ váº­n chuyá»ƒn',0),(41770,1161,'af','Fout met Skrap van KliÃ«nt/Klant Versend Aan',0),(41771,1161,'ro','Eroare la È™tergerea nava clientului la',0),(41772,1161,'et','Kliendi tarneaadressi kustutamisel tekkis viga',0),(41773,1161,'si','Napaka, brisanje kupca ladji',0),(41774,1161,'ba','Error menghapus kapal pelanggan untuk',0),(41775,1161,'nl','Fout bij het verwijderen van klant schip',0),(41776,1161,'fi','Virhe poistettaessa asiakasta aluksen',0),(41777,1161,'no','Feil ved sletting av kunden skip',0),(41778,1161,'da','Fejl ved sletning af kunden skib til',0),(41779,1161,'ko','ê³ ê° ë°°ì†¡ ì‚­ì œ ì˜¤ë¥˜',0),(41780,1161,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×œ×§×•×—×•×ª ×œ×¡×¤×™× ×”',0),(41781,1161,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ ÎµÎ¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ· Ï€Î»Î¿Î¯Ï‰Î½ Î½Î±',0),(41782,1161,'zh','é”™è¯¯åˆ é™¤å®¢æˆ·æ”¶è´§åœ°',0),(41783,1161,'sv','Fel ta bort kunden fartyget till',0),(41784,1161,'it','Errore eliminando la nave del cliente a',0),(41785,1161,'tl','',0),(41786,1161,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3586;&#3609;&#3',0),(41787,1161,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(41788,1161,'ms','Ralat Menghapuskan kapal pelanggan',0),(41789,1161,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(41790,1161,'fr','Erreur de suppression de navire de client Ã ',0),(41791,1161,'jp','é¡§å®¢é…?é€?å…ˆã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41792,1161,'pt','Erro ao excluir o cliente navio para',0),(41793,1161,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(41794,1161,'es','Error eliminando cliente enviar a',0),(41795,1161,'de','Fehler beim LÃ¶schen der Kunde Schiff',0),(41796,1161,'en','Error deleting customer ship to',0),(41797,1162,'is','',0),(41798,1162,'dr','( ÙƒØ³Ø±ÙŠ )',0),(41799,1162,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ú¯Ø±ÙˆÙ‡ ØªØ®ÙÙŠÙ ( ÙƒØ³Ø±ÙŠ )',0),(41800,1162,'tr','Hata silme kesinti grubu',0),(41801,1162,'pl','BÅ‚Ä…d usuwania odliczenia Grupa',0),(41802,1162,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ð°',0),(41803,1162,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ø­Ø§ØµÙ„ Ú¯Ø±ÙˆÙ¾',0),(41804,1162,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð³Ñ€ÑƒÐ¿Ðµ',0),(41805,1162,'vi','Lá»—i khi xÃ³a nhÃ³m giáº£m trá»«',0),(41806,1162,'af','Fout met skrapping van aftrekking groep',0),(41807,1162,'ro','Eroare ÅŸtergerea deducerea grup',0),(41808,1162,'et','TÃµrge kustutamisel mahaarvamise grupp',0),(41809,1162,'si','Napaka brisanja odbitek skupine',0),(41810,1162,'ba','Error menghapus pengurangan kelompok',0),(41811,1162,'nl','Fout verwijderen aftrek groep',0),(41812,1162,'fi','Virhe poistettaessa vÃ¤hennys ryhmÃ¤',0),(41813,1162,'no','Feil slette fradrag gruppe',0),(41814,1162,'da','Fejl slette fradrag gruppe',0),(41815,1162,'ko','ì˜¤ë¥˜ ì‚­ì œ ê³µì œ ê·¸ë£¹',0),(41816,1162,'he','×©×’×™××” ×‘×ž×—×™×§×ª × ×™×›×•×™ ×§×‘×•×¦×”',0),(41817,1162,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î±Ï†Î±Î¯ÏÎµÏƒÎ· Î¿Î¼Î¬Î´Î±',0),(41818,1162,'zh','é”™è¯¯åˆ é™¤æ‰£é™¤ç»„',0),(41819,1162,'sv','Misstag utplÃ¥nande avdrag grupp',0),(41820,1162,'it','Gruppo di deduzione eliminazione errore',0),(41821,1162,'tl','',0),(41822,1162,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3585;&#3621;&#3640;&#3656;&#3617;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3591;&#3636;&#3609;&#3',0),(41823,1162,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤¸à¤®à¥‚à¤¹ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(41824,1162,'ms','Ralat Menghapuskan potongan Kumpulan',0),(41825,1162,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø®ØµÙ… Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(41826,1162,'fr','Groupe de dÃ©duction suppression erreur',0),(41827,1162,'jp','æŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41828,1162,'pt','Grupo de deduÃ§Ã£o excluindo erro',0),(41829,1162,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð²Ñ‹Ñ‡ÐµÑ‚ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(41830,1162,'es','Error eliminando grupo de deducciones',0),(41831,1162,'de','Fehler lÃ¶schen von Abzug Gruppe',0),(41832,1162,'en','Error deleting deduction group',0),(41833,1163,'is','',0),(41834,1163,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(41835,1163,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(41836,1163,'tr','Hata silme detay iÅŸ tÃ¼rÃ¼',0),(41837,1163,'pl','BÅ‚Ä…d usuwania szczegÃ³Å‚Ã³w pracy typu',0),(41838,1163,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(41839,1163,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ ØªÙØµÛŒÙ„ Ú©Û’ Ú©Ø§Ù… Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª',0),(41840,1163,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð´ÐµÑ‚Ð°Ñ™ Ð²Ñ€ÑÑ‚Ðµ Ñ€Ð°Ð´Ð°',0),(41841,1163,'vi','Lá»—i khi xÃ³a loáº¡i cÃ´ng viá»‡c chi tiáº¿t',0),(41842,1163,'af','Fout met skrapping van detail werk tipe',0),(41843,1163,'ro','Eroare ÅŸtergerea detaliu locul de muncÄƒ de tip',0),(41844,1163,'et','TÃµrge kustutamisel detail tÃ¶Ã¶ tÃ¼Ã¼p',0),(41845,1163,'si','Napaka brisanja podrobno delo vrste',0),(41846,1163,'ba','Error menghapus detail bekerja jenis',0),(41847,1163,'nl','Fout verwijderen detail werksoort',0),(41848,1163,'fi','Virhe poistettaessa yksityiskohtaisesti tyÃ¶n tyyppi',0),(41849,1163,'no','Slette feildetaljer arbeidstype',0),(41850,1163,'da','Fejl slette detaljer arbejde type',0),(41851,1163,'ko','ì˜¤ë¥˜ ì‚­ì œ ì„¸ë¶€ ìž‘ì—… í˜•ì‹',0),(41852,1163,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×¤×¨×˜ ×¢×•×‘×“×™× ×¡×•×’',0),(41853,1163,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Ï„ÏÏ€Î¿Ï‚ Î­ÏÎ³Î¿Ï…',0),(41854,1163,'zh','é”™è¯¯åˆ é™¤çš„ç»†èŠ‚å·¥ä½œç±»åž‹',0),(41855,1163,'sv','Misstag utplÃ¥nande detalj arbetstyp',0),(41856,1163,'it','Dettaglio eliminazione errore tipo di lavoro',0),(41857,1163,'tl','',0),(41858,1163,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3632;&#3648;&#3616;&#3',0),(41859,1163,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤°',0),(41860,1163,'ms','Ralat Menghapuskan butiran kerja jenis',0),(41861,1163,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø®Ø·Ø£ Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(41862,1163,'fr','Type de travail de dÃ©tail suppression erreur',0),(41863,1163,'jp','ä»•äº‹å†…å®¹è©³ç´°ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41864,1163,'pt','Tipo de trabalho excluindo detalhes de erro',0),(41865,1163,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð´ÐµÑ‚Ð°Ð»ÐµÐ¹ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(41866,1163,'es','Error eliminando detalle de tipo de trabajo',0),(41867,1163,'de','LÃ¶schen von Fehlerdetails arbeiten Typ',0),(41868,1163,'en','Error deleting detail work type',0),(41869,1164,'is','',0),(41870,1164,'dr','Ø®Ø·Ø§ Ø¯ Ø± Ø­Ø°Ù Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ  ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(41871,1164,'pr','Ø®Ø·Ø§ Ø¯ Ø± Ø­Ø°Ù Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ  ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(41872,1164,'tr','Ã‡alÄ±ÅŸan gÃ¶zden geÃ§irme silme hatasÄ±.',0),(41873,1164,'pl','Usuwanie bÅ‚Ä™du pracownika przeglÄ…du.',0),(41874,1164,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´.',0),(41875,1164,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©Û’ Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº Û”',0),(41876,1164,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ ÐºÑ€Ð¸Ñ‚Ð¸ÐºÐ°.',0),(41877,1164,'vi','Lá»—i khi xÃ³a Ä‘Ã¡nh giÃ¡ nhÃ¢n viÃªn',0),(41878,1164,'af','Fout met skrap van Werknemer Oorsig.',0),(41879,1164,'ro','Eroare ÅŸtergerea opinie angajat.',0),(41880,1164,'et','TÃ¶Ã¶taja iseloomustuse kustutamisel tekkis viga',0),(41881,1164,'si','Napaka brisanja zaposlenega pregled.',0),(41882,1164,'ba','Error menghapus karyawan review.',0),(41883,1164,'nl','Fout verwijderen werknemer beoordeling.',0),(41884,1164,'fi','Virhe poistettaessa tyÃ¶ntekijÃ¤n uudelleen.',0),(41885,1164,'no','Feil slette medarbeider vurdering.',0),(41886,1164,'da','Fejl slette medarbejder anmeldelse.',0),(41887,1164,'ko','ì˜¤ë¥˜ ì‚­ì œ ì§ì› ê²€í† ìž…ë‹ˆë‹¤.',0),(41888,1164,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”×¢×•×‘×“ ×¡×§×™×¨×”.',0),(41889,1164,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î±Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½.',0),(41890,1164,'zh','é”™è¯¯åˆ é™¤å‘˜å·¥å®¡æŸ¥ã€‚',0),(41891,1164,'sv','Misstag utplÃ¥nande anstÃ¤lld Ã¶versyn.',0),(41892,1164,'it','Recensione di dipendente eliminazione errore.',0),(41893,1164,'tl','',0),(41894,1164,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;\n',0),(41895,1164,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾à¥¤',0),(41896,1164,'ms','Ralat Menghapuskan pekerja kajian.',0),(41897,1164,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ù…ÙˆØ¸Ù Ø§Ø³ØªØ¹Ø±Ø§Ø¶.',0),(41898,1164,'fr','Examen employÃ© suppression par erreur.',0),(41899,1164,'jp','å¾“æ¥­å“¡è©•ä¾¡ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41900,1164,'pt','RevisÃ£o de empregado excluindo erro.',0),(41901,1164,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð·Ð¾Ñ€ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð².',0),(41902,1164,'es','Error eliminando revisiÃ³n de empleado',0),(41903,1164,'de','Fehler lÃ¶schen von Mitarbeiter-ÃœberprÃ¼fung.',0),(41904,1164,'en','Error deleting employee review.',0),(41905,1165,'is','',0),(41906,1165,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¹Ù…ÙˆÙ…ÙŠ',0),(41907,1165,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¹Ù…ÙˆÙ…ÙŠ',0),(41908,1165,'tr','Genel iÅŸ tÃ¼rÃ¼nÃ¼ silme hatasÄ±.',0),(41909,1165,'pl','BÅ‚Ä…d podczas usuwania ogÃ³lna praca typu.',0),(41910,1165,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð¾Ð±Ñ‰Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°.',0),(41911,1165,'ur','Ø¹Ø§Ù… Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(41912,1165,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð²Ñ€ÑÑ‚Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ñ€Ð°Ð´Ð°.',0),(41913,1165,'vi','Lá»—i khi xÃ³a loáº¡i cÃ´ng viá»‡c chung',0),(41914,1165,'af','Fout in skrap van algemene werktipe',0),(41915,1165,'ro','Eroare la È™tergerea lucrÄƒri generale tip.',0),(41916,1165,'et','TÃµrge kustutamisel Ã¼ldise tÃ¶Ã¶ liik.',0),(41917,1165,'si','Napaka brisanja Vrsta sploÅ¡nega dela.',0),(41918,1165,'ba','Error menghapus jenis pekerjaan umum.',0),(41919,1165,'nl','Fout bij het verwijderen van algemene werksoort.',0),(41920,1165,'fi','Virhe poistettaessa ehdot tyÃ¶tyyppi.',0),(41921,1165,'no','Feil ved sletting av generelle arbeidstype.',0),(41922,1165,'da','Fejl ved sletning af generelle arbejdstype.',0),(41923,1165,'ko','ì¼ë°˜ ìž‘ì—… í˜•ì‹ì„ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(41924,1165,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×›×ª×‘ ×¢×‘×•×“×” ×›×œ×œ×™×ª.',0),(41925,1165,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Î³ÎµÎ½Î¹ÎºÎ­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Ï„ÏÏ€Î¿Ï….',0),(41926,1165,'zh','ä¸€èˆ¬å·¥ä½œé”™è¯¯åˆ é™¤çš„ç±»åž‹ã€‚\r\n',0),(41927,1165,'sv','Misstag utplÃ¥nande allmÃ¤nna arbetstyp.',0),(41928,1165,'it','Errore cancellando il tipo di lavoro generale.',0),(41929,1165,'tl','',0),(41930,1165,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(41931,1165,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(41932,1165,'ms','Ralat Menghapuskan jenis kerja-kerja am.',0),(41933,1165,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù….',0),(41934,1165,'fr','Erreur de suppression de type travail gÃ©nÃ©ral.',0),(41935,1165,'jp','ä¸€èˆ¬ä»•äº‹å†…å®¹ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41936,1165,'pt','Erro ao excluir o tipo de trabalho geral.',0),(41937,1165,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð³Ð¾ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹.',0),(41938,1165,'es','Error eliminando tipo general de trabajo',0),(41939,1165,'de','Fehler beim LÃ¶schen der allgemeine Arbeitstyp.',0),(41940,1165,'en','Error deleting general work type.',0),(41941,1166,'is','',0),(41942,1166,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„ ',0),(41943,1166,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„ ',0),(41944,1166,'tr','GL pasta silme hatasÄ±',0),(41945,1166,'pl','BÅ‚Ä…d podczas usuwania GL koÅ‚owy',0),(41946,1166,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° GL Ð¿Ð°Ð¹',0),(41947,1166,'ur','Ø¬ÛŒØ¬Û’ Ù¾Ø§Ø¦ÛŒ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(41948,1166,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð“Ð› Ð¿Ð¸Ñ‚Ñƒ',0),(41949,1166,'vi','Lá»—i khi xÃ³a á»‘ng sá»• cÃ¡i',0),(41950,1166,'af','Fout onstaan met skrapping van AG Sirkeldiagram',0),(41951,1166,'ro','Eroare la È™tergerea GL plÄƒcintÄƒ',0),(41952,1166,'et','TÃµrge kustutamisel GL pirukas',0),(41953,1166,'si','Napaka brisanja GL pie',0),(41954,1166,'ba','Error menghapus GL pie',0),(41955,1166,'nl','Fout bij het verwijderen van GL taart',0),(41956,1166,'fi','Virhe poistettaessa GL pie',0),(41957,1166,'no','Feil ved sletting av GL pie',0),(41958,1166,'da','Fejl ved sletning af GL pie',0),(41959,1166,'ko','ì˜¤ë¥˜ GL íŒŒì´ ì‚­ì œ',0),(41960,1166,'he','×©×’×™××” ×‘×ž×—×™×§×ª GL ×¤××™',0),(41961,1166,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ GL Ï€Î¯Ï„Î±',0),(41962,1166,'zh','å‰å°”é¦…é¥¼é”™è¯¯åˆ é™¤',0),(41963,1166,'sv','Misstag utplÃ¥nande GL paj',0),(41964,1166,'it','Errore eliminazione torta GL',0),(41965,1166,'tl','',0),(41966,1166,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610; GL pie',0),(41967,1166,'hi','à¤œà¥€à¤à¤² à¤ªà¤¾à¤‡ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(41968,1166,'ms','Ralat Menghapuskan pai GL',0),(41969,1166,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù GL Ø¯Ø§Ø¦Ø±ÙŠ',0),(41970,1166,'fr','Erreur de suppression de tarte GL',0),(41971,1166,'jp','ï¼§ï¼¬ãƒ‘ã‚¤ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(41972,1166,'pt','Erro ao excluir torta GL',0),(41973,1166,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ GL Ð¿Ð¸Ñ€Ð¾Ð³',0),(41974,1166,'es','Error eliminando LM grÃ¡fica pie',0),(41975,1166,'de','Fehler beim LÃ¶schen der GL-Torte',0),(41976,1166,'en','Error deleting GL pie',0),(41977,1167,'is','',0),(41978,1167,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„ ',0),(41979,1167,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„ ',0),(41980,1167,'tr','Hata silme GL pasta dilimi',0),(41981,1167,'pl','BÅ‚Ä…d usuwania GL wycinek',0),(41982,1167,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ GL ÐºÑ€ÑŠÐ³Ð¾Ð²',0),(41983,1167,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø¬ÛŒØ¬Û’ Ù¾Ø§Ø¦ÛŒ Ù‚Ø§Ø´',0),(41984,1167,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð“Ð› Ð¿Ð¸Ñ‚Ñƒ Ð¸ÑÐµÑ‡Ð°Ðº',0),(41985,1167,'vi','Lá»—i khi xÃ³a lÃ¡t cáº¯t á»‘ng sá»• cÃ¡i',0),(41986,1167,'af','Fout onstaan met skrapping van AG Sirkeldiagram skyf',0),(41987,1167,'ro','Eroare ÅŸtergerea felie de plÄƒcintÄƒ GL',0),(41988,1167,'et','TÃµrge kustutamisel GL pirukas viil',0),(41989,1167,'si','Napaka brisanja GL rezina tortnega grafikona',0),(41990,1167,'ba','Error menghapus GL pie slice',0),(41991,1167,'nl','Fout verwijderen GL cirkelsegment',0),(41992,1167,'fi','Virhe poistettaessa GL ympyrÃ¤kaavion sektori',0),(41993,1167,'no','Feil slette GL sektor',0),(41994,1167,'da','Fejl slette GL cirkeludsnit',0),(41995,1167,'ko','ì˜¤ë¥˜ ì‚­ì œ GL ì›í˜• ì¡°ê°',0),(41996,1167,'he','×©×’×™××” ×‘×ž×—×™×§×ª GL ×¤×¨×•×¡×ª ×¢×•×’×”',0),(41997,1167,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ GL Ï†Î­Ï„Î±Ï‚ Ï€Î¯Ï„Î±Ï‚',0),(41998,1167,'zh','é”™è¯¯åˆ é™¤æ€»å¸é¥¼çŠ¶å›¾å—',0),(41999,1167,'sv','Misstag utplÃ¥nande GL cirkelsektor',0),(42000,1167,'it','Eliminazione fetta di torta GL errore',0),(42001,1167,'tl','',0),(42002,1167,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610; GL pie slice',0),(42003,1167,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ GL à¤ªà¤¾à¤‡ à¤¸à¥à¤²à¤¾à¤‡à¤¸',0),(42004,1167,'ms','Ralat Menghapuskan GL pai slice',0),(42005,1167,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø´Ø±ÙŠØ­Ø© Ù…Ø®Ø·Ø· Ø¯Ø§Ø¦Ø±ÙŠ GL',0),(42006,1167,'fr','Tranche de tarte aux GL suppression erreur',0),(42007,1167,'jp','ï¼§ï¼¬ãƒ‘ã‚¤ã‚¹ãƒ©ã‚¤ã‚¹ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42008,1167,'pt','Fatia de torta erro excluindo GL',0),(42009,1167,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ GL ÑÐµÐºÑ‚Ð¾Ñ€Ð° ÐºÑ€ÑƒÐ³Ð¾Ð²Ð¾Ð¹ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¼Ñ‹',0),(42010,1167,'es','Error eliminando LM rebanada de grÃ¡fica de pie',0),(42011,1167,'de','Fehler lÃ¶schen von GL Kreissegment',0),(42012,1167,'en','Error deleting GL pie slice',0),(42013,1168,'is','',0),(42014,1168,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„ ',0),(42015,1168,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„ ',0),(42016,1168,'tr','GL pasta dilimi ayrÄ±ntÄ± silme hatasÄ±',0),(42017,1168,'pl','BÅ‚Ä…d podczas usuwania szczegÃ³Å‚owo kawaÅ‚ek pie GL',0),(42018,1168,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° GL ÐºÑ€ÑŠÐ³Ð¾Ð²Ð° Ð¿Ð°Ñ€Ñ‡Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(42019,1168,'ur','Ø¬ÛŒØ¬Û’ Ù¾Ø§Ø¦ÛŒ Ù‚Ø§Ø´ ØªÙØµÛŒÙ„ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(42020,1168,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð“Ð› Ð¿Ð¸Ñ‚Ñƒ Ð¸ÑÐµÑ‡Ð°Ðº Ð´ÐµÑ‚Ð°Ñ™',0),(42021,1168,'vi','Lá»—i khi xÃ³a chi tiáº¿t lÃ¡t cáº¯t á»‘ng sá»• cÃ¡i',0),(42022,1168,'af','Fout met skrapping van AG Sirkeldiagram skyf detail',0),(42023,1168,'ro','Eroare la È™tergerea GL plÄƒcintÄƒ felie detaliu',0),(42024,1168,'et','TÃµrge kustutamisel GL pirukas viil detail',0),(42025,1168,'si','Brisanje GL pito rezine podrobnosti napake',0),(42026,1168,'ba','Error menghapus GL pie slice detail',0),(42027,1168,'nl','Fout bij het verwijderen van GL taart segment detail',0),(42028,1168,'fi','Virhe poistettaessa GL kakku siivu yksityiskohtaisesti',0),(42029,1168,'no','Feil ved sletting av GL pai skive detaljer',0),(42030,1168,'da','Fejl ved sletning af GL pie skive detaljer',0),(42031,1168,'ko','ì˜¤ë¥˜ GL íŒŒì´ ì¡°ê° ì„¸ë¶€ ì‚¬í•­ ì‚­ì œ',0),(42032,1168,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×¤×¨×˜ ×¤×¨×•×¡×ª ×¢×•×’×” GL',0),(42033,1168,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ GL Ï€Î¯Ï„Î± Ï†Î­Ï„Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(42034,1168,'zh','é”™è¯¯åˆ é™¤é¥¼çŠ¶å›¾å—ç»†èŠ‚',0),(42035,1168,'sv','Misstag utplÃ¥nande GL paj slice detalj',0),(42036,1168,'it','Errore eliminazione dettaglio fetta torta GL',0),(42037,1168,'tl','',0),(42038,1168,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604; GL pie slice',0),(42039,1168,'hi','à¤œà¥€à¤à¤² à¤ªà¤¾à¤‡ à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(42040,1168,'ms','Ralat Menghapuskan GL pai slice terperinci',0),(42041,1168,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù GL Ø§Ù„ØªÙØµÙŠÙ„ Ø´Ø±ÙŠØ­Ø© Ø§Ù„ØªØ®Ø·ÙŠØ· Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠ',0),(42042,1168,'fr','Erreur de suppression de GL tarte tranche en dÃ©tail',0),(42043,1168,'jp','ï¼§ï¼¬ãƒ‘ã‚¤ã‚¹ãƒ©ã‚¤ã‚¹è©³ç´°ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42044,1168,'pt','Erro ao excluir o detalhe de fatia de torta GL',0),(42045,1168,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ GL ÐºÑ€ÑƒÐ³Ð¾Ð²Ð¾Ð¹ ÑÑ€ÐµÐ· Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(42046,1168,'es','Error eliminando LM detalle de rebanada de grÃ¡fica de pie',0),(42047,1168,'de','Fehler beim LÃ¶schen der GL Kreis-Scheibe detail',0),(42048,1168,'en','Error deleting GL pie slice detail',0),(42049,1169,'is','',0),(42050,1169,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ ',0),(42051,1169,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ ',0),(42052,1169,'tr','GL hareketlerini silme hatasÄ±',0),(42053,1169,'pl','BÅ‚Ä…d podczas usuwania GL transakcji',0),(42054,1169,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸Ñ‚Ðµ',0),(42055,1169,'ur','Ø¬ÛŒØ¬Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(42056,1169,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(42057,1169,'vi','Lá»—i khi xÃ³a giao dá»‹ch sá»• cÃ¡i',0),(42058,1169,'af','Fout met skrapping van AG transaksies',0),(42059,1169,'ro','Eroare la È™tergerea GL tranzacÅ£ii',0),(42060,1169,'et','GL kannete kustutamisel tÃµrge',0),(42061,1169,'si','Napaka brisanja transakcij GL',0),(42062,1169,'ba','Error menghapus GL transaksi',0),(42063,1169,'nl','Fout bij het verwijderen van GL transacties',0),(42064,1169,'fi','Virhe poistettaessa GL tapahtumat',0),(42065,1169,'no','Feil ved sletting av GL transaksjoner',0),(42066,1169,'da','Fejl ved sletning af GL transaktioner',0),(42067,1169,'ko','ì˜¤ë¥˜ GL íŠ¸ëžœìž­ì…˜ì„ ì‚­ì œ',0),(42068,1169,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×ª× ×•×¢×•×ª GL',0),(42069,1169,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ GL ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚',0),(42070,1169,'zh','å‰å°”äº¤æ˜“é”™è¯¯åˆ é™¤',0),(42071,1169,'sv','Misstag utplÃ¥nande GL transaktioner',0),(42072,1169,'it','Errore eliminando le transazioni GL',0),(42073,1169,'tl','',0),(42074,1169,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610; GL transactions',0),(42075,1169,'hi','à¤œà¥€à¤à¤² à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(42076,1169,'ms','Ralat Menghapuskan urus niaga GL',0),(42077,1169,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª GL',0),(42078,1169,'fr','Erreur de suppression des transactions de GL',0),(42079,1169,'jp','GLå‡¦ç?†ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42080,1169,'pt','Erro ao excluir as transaÃ§Ãµes de GL',0),(42081,1169,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ GL ÑÐ´ÐµÐ»Ð¾Ðº',0),(42082,1169,'es','Error eliminando LM transacciones',0),(42083,1169,'de','Fehler beim LÃ¶schen der GL-Transaktionen',0),(42084,1169,'en','Error deleting GL transactions',0),(42085,1170,'is','',0),(42086,1170,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ  Ø¯ÙØªØ± ÙƒÙ„ ',0),(42087,1170,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ  Ø¯ÙØªØ± ÙƒÙ„ ',0),(42088,1170,'tr','Hata silme GL transvoucher',0),(42089,1170,'pl','BÅ‚Ä…d usuwania GL transvoucher',0),(42090,1170,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ GL transvoucher',0),(42091,1170,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø¬ÛŒØ¬Û’ Ù¹Ø±Ø§Ù†Ø³ÙˆØ§Ú†Ø±',0),(42092,1170,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ²Ð¾ÑƒÑ†Ñ…ÐµÑ€',0),(42093,1170,'vi','Lá»—i xÃ³a phiáº¿u chuyá»ƒn sá»• cÃ¡i',0),(42094,1170,'af','Fout met skrapping van AG transbewysstuk ',0),(42095,1170,'ro','Eroare ÅŸtergerea GL transvoucher',0),(42096,1170,'et','TÃµrge kustutamisel GL transvoucher',0),(42097,1170,'si','Napaka brisanja GL transvoucher',0),(42098,1170,'ba','Error menghapus GL transvoucher',0),(42099,1170,'nl','Fout verwijderen GL transvoucher',0),(42100,1170,'fi','Virhe poistettaessa GL transvoucher',0),(42101,1170,'no','Feil slette GL transvoucher',0),(42102,1170,'da','Fejl slette GL transvoucher',0),(42103,1170,'ko','ì˜¤ë¥˜ ì‚­ì œ GL transvoucher',0),(42104,1170,'he','×©×’×™××” ×‘×ž×—×™×§×ª GL transvoucher',0),(42105,1170,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ GL transvoucher',0),(42106,1170,'zh','é”™è¯¯åˆ é™¤æ€»å¸ç›¸äº’ä»˜æ¬¾å‡­è¯',0),(42107,1170,'sv','Misstag utplÃ¥nande GL transvoucher',0),(42108,1170,'it','Errore eliminazione GL transvoucher',0),(42109,1170,'tl','',0),(42110,1170,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610; GL transvoucher',0),(42111,1170,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ GL transvoucher',0),(42112,1170,'ms','Ralat Menghapuskan GL transvoucher',0),(42113,1170,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù GL ØªØ±Ø§Ù†Ø³ÙÙˆØªØ´ÙŠØ±',0),(42114,1170,'fr','Erreur suppression GL transvoucher',0),(42115,1170,'jp','GLå‡¦ç?†ä¼?ç¥¨ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42116,1170,'pt','Erro excluindo GL transvoucher',0),(42117,1170,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ GL transvoucher',0),(42118,1170,'es','Error eliminando LM transvoucher',0),(42119,1170,'de','Fehler lÃ¶schen von GL transvoucher',0),(42120,1170,'en','Error deleting GL transvoucher',0),(42121,1171,'is','',0),(42122,1171,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø¬ÙˆÙ‡Ø± ',0),(42123,1171,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø¬ÙˆÙ‡Ø± ',0),(42124,1171,'tr','MÃ¼rekkep silme hatasÄ±.',0),(42125,1171,'pl','BÅ‚Ä…d podczas usuwania farby.',0),(42126,1171,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ.',0),(42127,1171,'ur','Ø§Ù†Ú© Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(42128,1171,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿ÐµÑ€Ð¾Ð¼.',0),(42129,1171,'vi','Lá»—i xÃ³a má»±c',0),(42130,1171,'af','Fout met skrapping van ink.',0),(42131,1171,'ro','Eroare la È™tergerea de cernealÄƒ.',0),(42132,1171,'et','TÃµrge kustutamisel tinti.',0),(42133,1171,'si','Napaka brisanje Ärnila.',0),(42134,1171,'ba','Error menghapus tinta.',0),(42135,1171,'nl','Fout bij het verwijderen van inkt.',0),(42136,1171,'fi','Virhe poistettaessa muste.',0),(42137,1171,'no','Feil ved sletting av blekk.',0),(42138,1171,'da','Fejl ved sletning af blÃ¦k.',0),(42139,1171,'ko','ìž‰í¬ë¥¼ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(42140,1171,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×“×™×•.',0),(42141,1171,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Î¼ÎµÎ»Î¬Î½Î¹.',0),(42142,1171,'zh','é”™è¯¯åˆ é™¤æ²¹å¢¨',0),(42143,1171,'sv','Fel ta bort blÃ¤ck.',0),(42144,1171,'it','Errore durante l\'eliminazione dell\'inchiostro.',0),(42145,1171,'tl','',0),(42146,1171,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3627;&#3617;&#3638;&#3585;',0),(42147,1171,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(42148,1171,'ms','Ralat Menghapuskan dakwat.',0),(42149,1171,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„Ø­Ø¨Ø±.',0),(42150,1171,'fr','Erreur de suppression d\'encre.',0),(42151,1171,'jp','ã‚¤ãƒ³ã‚¯ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42152,1171,'pt','Erro ao excluir a tinta.',0),(42153,1171,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÐºÑ€Ð°ÑÐºÐ¸.',0),(42154,1171,'es','Error eliminando tinta',0),(42155,1171,'de','Fehler beim LÃ¶schen von Tinte.',0),(42156,1171,'en','Error deleting ink.',0),(42157,1172,'is','',0),(42158,1172,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(42159,1172,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(42160,1172,'tr','Hata silme stok konumu',0),(42161,1172,'pl','Usuwanie lokalizacji zapasÃ³w w bÅ‚Ä…d',0),(42162,1172,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°',0),(42163,1172,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø±Ù†Û’ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(42164,1172,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(42165,1172,'vi','XÃ³a Äá»‹a Äiá»ƒm HÃ ng hÃ³a Bá»‹ Lá»—i',0),(42166,1172,'af','Fout met skrap van voorraad ligging',0),(42167,1172,'ro','Eroare ÅŸtergerea inventar locaÅ£ie',0),(42168,1172,'et','TÃµrge kustutamisel varude asukoha',0),(42169,1172,'si','Napaka brisanja lokacijo zaloge',0),(42170,1172,'ba','Error menghapus persediaan lokasi',0),(42171,1172,'nl','Fout voorraadvestiging verwijderen',0),(42172,1172,'fi','Virhe poistettaessa varaston sijainti',0),(42173,1172,'no','Feil slette lagerlokasjon',0),(42174,1172,'da','Fejl slette lagerlokation',0),(42175,1172,'ko','ì˜¤ë¥˜ ì‚­ì œ ìž¬ê³  ìœ„ì¹˜',0),(42176,1172,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ž×œ××™ ×ž×™×§×•×',0),(42177,1172,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î±Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(42178,1172,'zh','é”™è¯¯åˆ é™¤åº“å­˜ä½ç½®',0),(42179,1172,'sv','Misstag utplÃ¥nande lagerstÃ¤lle',0),(42180,1172,'it','Ubicazione di inventario eliminazione errore',0),(42181,1172,'tl','',0),(42182,1172,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3',0),(42183,1172,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨',0),(42184,1172,'ms','Ralat Menghapuskan inventori lokasi',0),(42185,1172,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(42186,1172,'fr','Emplacement de l\'inventaire suppression erreur',0),(42187,1172,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42188,1172,'pt','LocalizaÃ§Ã£o de inventÃ¡rio excluindo erro',0),(42189,1172,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ ÑÐºÐ»Ð°Ð´Ðµ',0),(42190,1172,'es','Error eliminando ubicaciÃ³n de inventario',0),(42191,1172,'de','Fehler lÃ¶schen von Lagerort',0),(42192,1172,'en','Error deleting inventory location',0),(42193,1173,'is','',0),(42194,1173,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(42195,1173,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(42196,1173,'tr','PO silme hatasÄ±',0),(42197,1173,'pl','BÅ‚Ä…d podczas usuwania PO',0),(42198,1173,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° PO',0),(42199,1173,'ur','Ù¾Ùˆ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(42200,1173,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ ÐŸÐž',0),(42201,1173,'vi','XÃ³a ÄÆ¡n Mua HÃ ng Bá»‹ Lá»—i',0),(42202,1173,'af','Fout skrap PO',0),(42203,1173,'ro','Eroare la È™tergerea PO',0),(42204,1173,'et','TÃµrge kustutamisel PO',0),(42205,1173,'si','Napaka pri brisanju PO',0),(42206,1173,'ba','Error menghapus PO',0),(42207,1173,'nl','Fout bij het verwijderen van PO',0),(42208,1173,'fi','Virhe poistettaessa PO',0),(42209,1173,'no','Feil ved sletting av PO',0),(42210,1173,'da','Fejl ved sletning af PO',0),(42211,1173,'ko','ì‚¬ì„œí•¨ ì‚­ì œ ì˜¤ë¥˜',0),(42212,1173,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×¤×•',0),(42213,1173,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ PO',0),(42214,1173,'zh','é”™è¯¯åˆ é™¤è®¢å•',0),(42215,1173,'sv','Misstag utplÃ¥nande PO',0),(42216,1173,'it','Errore eliminazione PO',0),(42217,1173,'tl','',0),(42218,1173,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(42219,1173,'hi','PO à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(42220,1173,'ms','Ralat Menghapuskan PO',0),(42221,1173,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø¨Ùˆ',0),(42222,1173,'fr','Erreur de suppression de PO',0),(42223,1173,'jp','POã‚’æ¶ˆåŽ»ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(42224,1173,'pt','Erro ao excluir PO',0),(42225,1173,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ PO',0),(42226,1173,'es','Error eliminando OC',0),(42227,1173,'de','Fehler beim LÃ¶schen des PO',0),(42228,1173,'en','Error deleting PO',0),(42229,1174,'is','',0),(42230,1174,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù ÙØ§ÙƒØªÙˆØ± ',0),(42231,1174,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù ÙØ§ÙƒØªÙˆØ± ',0),(42232,1174,'tr','Hata silme fatura',0),(42233,1174,'pl','BÅ‚Ä…d usuwania faktury',0),(42234,1174,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(42235,1174,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø§Ù†ÙˆØ§Ø¦Ø³',0),(42236,1174,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(42237,1174,'vi','Lá»—i xÃ³a hÃ³a Ä‘Æ¡n',0),(42238,1174,'af','Fout met skrapping van faktuur',0),(42239,1174,'ro','Eroare ÅŸtergerea facturÄƒ',0),(42240,1174,'et','TÃµrge kustutamisel arve',0),(42241,1174,'si','Napaka brisanja raÄuna',0),(42242,1174,'ba','Error menghapus faktur',0),(42243,1174,'nl','Fout verwijderen factuur',0),(42244,1174,'fi','Virhe poistettaessa laskun',0),(42245,1174,'no','Feil slette faktura',0),(42246,1174,'da','Fejl slette fakturaen',0),(42247,1174,'ko','ì˜¤ë¥˜ ì‚­ì œ ì²­êµ¬ì„œ',0),(42248,1174,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×—×©×‘×•× ×™×ª',0),(42249,1174,'el','Î›Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(42250,1174,'zh','é”™è¯¯åˆ é™¤å‘ç¥¨',0),(42251,1174,'sv','Misstag utplÃ¥nande faktura',0),(42252,1174,'it','Fattura eliminazione errore',0),(42253,1174,'tl','',0),(42254,1174,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(42255,1174,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤šà¤¾à¤²à¤¾à¤¨',0),(42256,1174,'ms','Ralat Menghapuskan invois',0),(42257,1174,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(42258,1174,'fr','Facture suppression erreur',0),(42259,1174,'jp','è«‹æ±‚æ›¸ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42260,1174,'pt','Factura excluindo erro',0),(42261,1174,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÑÑ‡ÐµÑ‚Ð°',0),(42262,1174,'es','Error eliminando factura',0),(42263,1174,'de','Fehler lÃ¶schen von Rechnung',0),(42264,1174,'en','Error deleting invoice',0),(42265,1175,'is','',0),(42266,1175,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(42267,1175,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(42268,1175,'tr','Hata silme fatura ÅŸartlarÄ±',0),(42269,1175,'pl','BÅ‚Ä…d usuwania faktury warunki',0),(42270,1175,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(42271,1175,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø´Ø±Ø§Ø¦Ø·',0),(42272,1175,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ ÑƒÑÐ»Ð¾Ð²Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(42273,1175,'vi','Lá»—i xÃ³a Ä‘iá»u khoáº£n hÃ³a Ä‘Æ¡n',0),(42274,1175,'af','Fout met skrapping van faktuur terme',0),(42275,1175,'ro','Eroare ÅŸtergerea facturÄƒ termeni',0),(42276,1175,'et','TÃµrge kustutamisel arve tingimused',0),(42277,1175,'si','Napaka brisanja raÄuna pogoji',0),(42278,1175,'ba','Error menghapus faktur persyaratan',0),(42279,1175,'nl','Fout verwijderen factuur voorwaarden',0),(42280,1175,'fi','Virhe poistettaessa laskun ehtojen',0),(42281,1175,'no','Feil slette faktureringsvilkÃ¥r',0),(42282,1175,'da','Fejl slette fakturaen vilkÃ¥r',0),(42283,1175,'ko','ì˜¤ë¥˜ ì‚­ì œ ì²­êµ¬ì„œ ì´ìš© ì•½ê´€',0),(42284,1175,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ª× ××™ ×—×©×‘×•× ×™×ª',0),(42285,1175,'el','Î¤Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Î»Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(42286,1175,'zh','é”™è¯¯åˆ é™¤å‘ç¥¨æ¡æ¬¾',0),(42287,1175,'sv','Misstag utplÃ¥nande faktura villkor',0),(42288,1175,'it','Termini di fattura eliminazione errore',0),(42289,1175,'tl','',0),(42290,1175,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3',0),(42291,1175,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(42292,1175,'ms','Ralat Menghapuskan invois terma-terma',0),(42293,1175,'ar','Ø®Ø·Ø£ Ø­Ø°Ù Ø¨Ù†ÙˆØ¯ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(42294,1175,'fr','Termes facture suppression d\'erreurs',0),(42295,1175,'jp','è«‹æ±‚æœŸé™?ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42296,1175,'pt','Excluindo termos de factura erro',0),(42297,1175,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð°',0),(42298,1175,'es','Error eliminando tÃ©rminos de factura',0),(42299,1175,'de','Fehler lÃ¶schen Rechnung hinsichtlich',0),(42300,1175,'en','Error deleting invoice terms',0),(42301,1176,'is','',0),(42302,1176,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ ',0),(42303,1176,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ ',0),(42304,1176,'tr','Madde kategorisi silme hatasÄ±.',0),(42305,1176,'pl','BÅ‚Ä…d usuwania kategorii zapasu.',0),(42306,1176,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ».',0),(42307,1176,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø´Û’ Ø²Ù…Ø±Û ÛÛ’ Û”',0),(42308,1176,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°.',0),(42309,1176,'vi','XÃ³a thá»ƒ loáº¡i hÃ ng bá»‹ lá»—i',0),(42310,1176,'af','Fout met skrap van item kategorie',0),(42311,1176,'ro','Eroare ÅŸtergerea categorie de articole.',0),(42312,1176,'et','Tootekategooria kustutamisel ilmnes viga',0),(42313,1176,'si','Napaka brisanja kategoriji artikla.',0),(42314,1176,'ba','Error menghapus item kategori.',0),(42315,1176,'nl','Fout verwijderen artikelcategorie.',0),(42316,1176,'fi','Virhe poistettaessa kohteen luokka.',0),(42317,1176,'no','Feil ved sletting av varekategorien.',0),(42318,1176,'da','Fejl slette varekategori.',0),(42319,1176,'ko','ì˜¤ë¥˜ ì‚­ì œ í•­ëª© ë²”ì£¼ìž…ë‹ˆë‹¤.',0),(42320,1176,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×¤×¨×™×˜ ×‘×§×˜×’×•×¨×™×”.',0),(42321,1176,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ¹Î´ÏŽÎ½.',0),(42322,1176,'zh','é”™è¯¯åˆ é™¤é¡¹ç›®ç±»åˆ«ã€‚',0),(42323,1176,'sv','Misstag utplÃ¥nande artikelkategori.',0),(42324,1176,'it','Categoria elemento eliminazione di errore.',0),(42325,1176,'tl','',0),(42326,1176,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3',0),(42327,1176,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€à¥¤',0),(42328,1176,'ms','Ralat menghapuskan item kategori.',0),(42329,1176,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù ØªØµÙ†ÙŠÙ Ø§Ù„ØµÙ†Ù',0),(42330,1176,'fr','Suppression article catÃ©gorie d\'erreur.',0),(42331,1176,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42332,1176,'pt','Categoria de item apagar erro.',0),(42333,1176,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(42334,1176,'es','Error eliminando categorÃ­a de item',0),(42335,1176,'de','Fehler lÃ¶schen Positionstyp.',0),(42336,1176,'en','Error deleting item category.',0),(42337,1177,'is','',0),(42338,1177,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø­Ù„  ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(42339,1177,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø­Ù„  ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(42340,1177,'tr','Hata silme madde satÄ±cÄ± konum',0),(42341,1177,'pl','BÅ‚Ä…d usuwania elementu dostawcy lokalizacji',0),(42342,1177,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(42343,1177,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø´Û’ ÙˆÛŒÙ†ÚˆØ± Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(42344,1177,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(42345,1177,'vi','Lá»—i khi xÃ³a vá»‹ trÃ­ ngÆ°á»i bÃ¡n',0),(42346,1177,'af','Fout met skrap van item verskaffer ligging',0),(42347,1177,'ro','Eroare ÅŸtergerea articol furnizor locaÅ£ie',0),(42348,1177,'et','TÃµrge kustutamisel kauba hankija asukoha',0),(42349,1177,'si','Brisanje napake dobavitelja mesto elementa',0),(42350,1177,'ba','Error menghapus lokasi Penjual',0),(42351,1177,'nl','Locatie van de leverancier van het item van fout het verwijderen',0),(42352,1177,'fi','Virhe poistettaessa kohteen paikassa',0),(42353,1177,'no','Feil slette leverandÃ¸r elementplasseringen',0),(42354,1177,'da','Fejl slette elementet kreditor placering',0),(42355,1177,'ko','ì˜¤ë¥˜ ì‚­ì œ í•­ëª© ê³µê¸‰ ì—…ì²´ ìœ„ì¹˜',0),(42356,1177,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×¤×¨×™×˜ ×¡×¤×§ ×ž×™×§×•×',0),(42357,1177,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(42358,1177,'zh','é”™è¯¯åˆ é™¤é¡¹ç›®çš„ä¾›åº”å•†ä½ç½®\r\n',0),(42359,1177,'sv','Misstag utplÃ¥nande artikelplats leverantÃ¶r',0),(42360,1177,'it','Ubicazione di errore eliminazione elemento fornitore',0),(42361,1177,'tl','',0),(42362,1177,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3',0),(42363,1177,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥à¤¥à¤¾à¤¨',0),(42364,1177,'ms','Ralat menghapuskan item penjual lokasi',0),(42365,1177,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„Ø¨Ù†Ø¯',0),(42366,1177,'fr','Erreur suppression article fournisseur emplacement',0),(42367,1177,'jp','å“?ç›®æ¥­è€…ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42368,1177,'pt','LocalizaÃ§Ã£o de fornecedor item excluir erro',0),(42369,1177,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(42370,1177,'es','Error eliminando colocaciÃ³n de item de Proveedor',0),(42371,1177,'de','Fehler lÃ¶schen Artikelstandort Anbieter',0),(42372,1177,'en','Error deleting item vendor location',0),(42373,1178,'is','',0),(42374,1178,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø§Ø´ÙŠÙ† ',0),(42375,1178,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø§Ø´ÙŠÙ† ',0),(42376,1178,'tr','Hata silme makinesi.',0),(42377,1178,'pl','BÅ‚Ä…d usuwania maszyny.',0),(42378,1178,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð°.',0),(42379,1178,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø±Ù†Û’ Ú©ÛŒ Ù…Ø´ÛŒÙ† ÛÛ’ Û”',0),(42380,1178,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¼Ð°ÑˆÐ¸Ð½Ð°.',0),(42381,1178,'vi','Lá»—i xÃ³a mÃ¡y',0),(42382,1178,'af','Skrap fout-masjien.',0),(42383,1178,'ro','Eroare maÅŸinÄƒ de ÅŸtergere.',0),(42384,1178,'et','TÃµrge kustutamisel masin.',0),(42385,1178,'si','Napaka brisanja stroj.',0),(42386,1178,'ba','Error menghapus mesin.',0),(42387,1178,'nl','Fout verwijderen machine.',0),(42388,1178,'fi','Virhe poistettaessa laitetta.',0),(42389,1178,'no','Feil slette maskin.',0),(42390,1178,'da','Fejl slette maskine.',0),(42391,1178,'ko','ì˜¤ë¥˜ ì‚­ì œ ê¸°ê³„ìž…ë‹ˆë‹¤.',0),(42392,1178,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”×ž×›×•× ×”.',0),(42393,1178,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î¼Î·Ï‡Î±Î½Î®.',0),(42394,1178,'zh','é”™è¯¯åˆ é™¤æœºã€‚\r\n',0),(42395,1178,'sv','Misstag utplÃ¥nande maskin.',0),(42396,1178,'it','Macchina eliminazione errore.',0),(42397,1178,'tl','',0),(42398,1178,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(42399,1178,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¤¶à¥€à¤¨à¥¤',0),(42400,1178,'ms','Ralat Menghapuskan Mesin.',0),(42401,1178,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø¬Ù‡Ø§Ø².',0),(42402,1178,'fr','Erreur suppression l\'appareil.',0),(42403,1178,'jp','æ©Ÿæ¢°ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42404,1178,'pt','MÃ¡quina de exclusÃ£o de erro.',0),(42405,1178,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹.',0),(42406,1178,'es','Error eliminando mÃ¡quina',0),(42407,1178,'de','Fehler lÃ¶schen von Maschine.',0),(42408,1178,'en','Error deleting machine.',0),(42409,1179,'is','',0),(42410,1179,'dr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ø³ÙŠØ³ØªÙ… Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(42411,1179,'pr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ø³ÙŠØ³ØªÙ… Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(42412,1179,'tr','BiÃ§imlendirme kÃ¼me silme hatasÄ±.',0),(42413,1179,'pl','BÅ‚Ä…d podczas usuwania, zestaw znacznikÃ³w.',0),(42414,1179,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼.',0),(42415,1179,'ur','Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(42416,1179,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð½Ð°Ð·Ð½Ð°ÐºÐµ Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ.',0),(42417,1179,'vi','Lá»—i xÃ³a giÃ¡ cá»™ng thÃªm',0),(42418,1179,'af','Fout met skrapping Markup stel.',0),(42419,1179,'ro','Eroare la È™tergerea Markup Set.',0),(42420,1179,'et','TÃµrge kustutamisel mÃ¤rgistus seada.',0),(42421,1179,'si','Napaka brisanja oznake nastavite.',0),(42422,1179,'ba','Error menghapus Markup Set.',0),(42423,1179,'nl','Fout bij verwijderen van Markup instellen.',0),(42424,1179,'fi','Virhe poistettaessa Markup asettaa.',0),(42425,1179,'no','Feil ved sletting av Markup satt.',0),(42426,1179,'da','Fejl ved sletning af Markup sÃ¦t.',0),(42427,1179,'ko','íƒœê·¸ ì„¤ì • ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(42428,1179,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×¡×™×ž×•×Ÿ ×”×’×“×¨.',0),(42429,1179,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ Ï€Î¿Ï….',0),(42430,1179,'zh','é”™è¯¯åˆ é™¤æ ‡è®°é›†ã€‚',0),(42431,1179,'sv','Fel ta bort markering anger.',0),(42432,1179,'it','Errore eliminazione Markup impostato.',0),(42433,1179,'tl','',0),(42434,1179,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(42435,1179,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(42436,1179,'ms','Ralat Menghapuskan Set penanda.',0),(42437,1179,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù \"ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª\".',0),(42438,1179,'fr','Erreur de suppression de la valeur de balisage.',0),(42439,1179,'jp','å€¤ä¸Šã?’è¨­å®šã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42440,1179,'pt','Erro ao excluir marcaÃ§Ã£o definida.',0),(42441,1179,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð½Ð°Ð±Ð¾Ñ€Ð¾Ð² Ð¿Ð¾Ð¼ÐµÑ‚Ð¾Ðº.',0),(42442,1179,'es','Error eliminando juego de encarecimiento',0),(42443,1179,'de','Fehler beim LÃ¶schen der Markup festgelegt.',0),(42444,1179,'en','Error deleting Markup Set.',0),(42445,1180,'is','',0),(42446,1180,'dr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ø³ÙŠØ³ØªÙ… Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­',0),(42447,1180,'pr','Ø®Ø·Ø§ Ø¯ Ø±Ø­Ø°Ù Ø³ÙŠØ³ØªÙ… Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­',0),(42448,1180,'tr','BiÃ§imlendirmeyi ayarlamak iÃ§in dÃ¼zeyi silme hatasÄ±.',0),(42449,1180,'pl','BÅ‚Ä…d usuwania znacznikÃ³w ustawiÄ‡ poziom.',0),(42450,1180,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸ Ð·Ð° Ð½Ð¸Ð²Ð¾.',0),(42451,1180,'ur','Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Û’ Ù„ÛŒÛ’ Ø³Ø·Ø­ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(42452,1180,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð½Ð°Ð·Ð½Ð°ÐºÐµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½ Ð·Ð° Ð½Ð¸Ð²Ð¾.',0),(42453,1180,'vi','Lá»—i xÃ³a giÃ¡ cá»™ng thÃªm theo tá»«ng má»©c',0),(42454,1180,'af','Fout met skrapping van Markup stel vir vlak.',0),(42455,1180,'ro','Eroare la È™tergerea Markup stabilit pentru nivel.',0),(42456,1180,'et','TÃµrge kustutamisel mÃ¤rgistus seada tasemele.',0),(42457,1180,'si','Napaka brisanja oznake nastavite za ravni.',0),(42458,1180,'ba','Error menghapus Markup Set untuk tingkat.',0),(42459,1180,'nl','Fout bij het verwijderen van Markup instellen voor niveau.',0),(42460,1180,'fi','Virhe poistettaessa Markup asettaa tasolle.',0),(42461,1180,'no','Feil ved sletting av Markup setter for nivÃ¥.',0),(42462,1180,'da','Fejl ved sletning af Markup indstillet til niveau.',0),(42463,1180,'ko','ìˆ˜ì¤€ì— ëŒ€ í•œ íƒœê·¸ ì„¸íŠ¸ë¥¼ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(42464,1180,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×¡×™×ž×•×Ÿ ×œ×”×’×“×™×¨ ×¨×ž×”.',0),(42465,1180,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ Ï€Î¿Ï… Î³Î¹Î± Ï„Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿.',0),(42466,1180,'zh','é”™è¯¯åˆ é™¤çº§åˆ«æ ‡è®°é›†ã€‚\r\n',0),(42467,1180,'sv','Fel ta bort markering anger fÃ¶r nivÃ¥.',0),(42468,1180,'it','Errore eliminazione Markup impostato per il livello.',0),(42469,1180,'tl','',0),(42470,1180,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3',0),(42471,1180,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¤à¤° à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(42472,1180,'ms','Ralat Menghapuskan menetapkan penanda aras.',0),(42473,1180,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù \"Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©\" Ù„Ù„Ù…Ø³ØªÙˆÙ‰.',0),(42474,1180,'fr','Erreur de suppression de balisage mis Ã  niveau.',0),(42475,1180,'jp','ã??ã?®ãƒ¬ãƒ™ãƒ«ã?®å€¤ä¸Šã?’è¨­å®šã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42476,1180,'pt','Erro ao excluir marcaÃ§Ã£o definida para o nÃ­vel.',0),(42477,1180,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð½Ð°Ð±Ð¾Ñ€Ð¾Ð² Ð¿Ð¾Ð¼ÐµÑ‚Ð¾Ðº Ð´Ð»Ñ ÑƒÑ€Ð¾Ð²Ð½Ñ.',0),(42478,1180,'es','Error eliminando juego de encarecimiento para el nivel',0),(42479,1180,'de','Fehler beim LÃ¶schen von Markup festgelegt, fÃ¼r Ebene.',0),(42480,1180,'en','Error deleting Markup Set for level.',0),(42481,1181,'is','',0),(42482,1181,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¹Ù…Ù„ÙŠØ§Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(42483,1181,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¹Ù…Ù„ÙŠØ§Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(42484,1181,'tr','-BaskÄ± iÅŸlemi boyutu silme hatasÄ±.',0),(42485,1181,'pl','BÅ‚Ä…d podczas usuwania rozmiar wydruku bez operacji.',0),(42486,1181,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚Ð½Ð¸Ñ‚Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(42487,1181,'ur','ØºÛŒØ±-Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº Ø¹Ù…Ù„ÛŒÛ Ø³Ø§Ø¦Ø² Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(42488,1181,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð°-Ð¿Ñ€Ð¸Ð½Ñ‚ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð°.',0),(42489,1181,'vi','Lá»—i xÃ³a cá»¡ hoáº¡t Ä‘á»™ng khÃ´ng in',0),(42490,1181,'af','Fout met skrapping van nie-druk bewerking grootte.',0),(42491,1181,'ro','Eroare la È™tergerea operaÅ£ie non-imprimare dimensiunea.',0),(42492,1181,'et','TÃµrge kustutamisel-print operatsiooni suurus.',0),(42493,1181,'si','Brisanje-print delovanje velikost napake.',0),(42494,1181,'ba','Error menghapus ukuran operasi non-cetak.',0),(42495,1181,'nl','Fout bij het verwijderen van niet-print operatie grootte.',0),(42496,1181,'fi','Virhe poistettaessa tulosta toimintoa koon.',0),(42497,1181,'no','Feil ved sletting uten utskrift operasjonen stÃ¸rrelse.',0),(42498,1181,'da','Fejl ved sletning af ikke-print operation stÃ¸rrelse.',0),(42499,1181,'ko','ë¹„ ì¸ì‡„ ìž‘ì—… í¬ê¸°ë¥¼ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(42500,1181,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×’×•×“×œ ×©××™× × ×ž×•×“×¤×¡×™× ×‘×ž×‘×¦×¢.',0),(42501,1181,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Î¼Î·-print Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚.',0),(42502,1181,'zh','é”™è¯¯åˆ é™¤éžæ‰“å°æ“ä½œè§„æ¨¡ã€‚',0),(42503,1181,'sv','Fel ta bort icke-print drift storlek.',0),(42504,1181,'it','Errore di dimensione non-stampa operazione di eliminazione.',0),(42505,1181,'tl','',0),(42506,1181,'th','Error deleting non-print operation size.',0),(42507,1181,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤ªà¤°à¥‡à¤¶à¤¨ à¤†à¤•à¤¾à¤° à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(42508,1181,'ms','Ralat Menghapuskan saiz operasi cetak.',0),(42509,1181,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø­Ø¬Ù… Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© ØºÙŠØ± Ø¹Ù…Ù„ÙŠØ©.',0),(42510,1181,'fr','Erreur de suppression de taille de l\'opÃ©ration non imprimÃ©s.',0),(42511,1181,'jp','é?žå?°åˆ·ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã‚µã‚¤ã‚ºã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42512,1181,'pt','Erro ao excluir o tamanho da operaÃ§Ã£o sem impressÃ£o.',0),(42513,1181,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸-Ð¿Ñ€Ð¸Ð½Ñ‚ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(42514,1181,'es','Error eliminando tamaÃ±o de operaciÃ³n no-impresiÃ³n',0),(42515,1181,'de','Fehler beim LÃ¶schen nicht-Print-Betrieb-GrÃ¶ÃŸe.',0),(42516,1181,'en','Error deleting non-print operation size.',0),(42517,1182,'is','',0),(42518,1182,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…ÙˆØ§Ø¯Ø§ÙˆÙ„ÙŠÙ‡ Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ ÙƒØ§Ù„Ø§ ',0),(42519,1182,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…ÙˆØ§Ø¯Ø§ÙˆÙ„ÙŠÙ‡ Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ ÙƒØ§Ù„Ø§ ',0),(42520,1182,'tr','BaskÄ±da malzeme ile Ã¶ÄŸe silme hatasÄ±',0),(42521,1182,'pl','BÅ‚Ä…d podczas usuwania-drukowanie materiaÅ‚Ã³w z pozycji',0),(42522,1182,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð½Ð¸Ñ‚Ðµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð» Ñ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(42523,1182,'ur','ØºÛŒØ± Ø·Ø¨Ø§Ø¹Øª Ù…ÙˆØ§Ø¯ Ø´Û’ Ú©Û’ Ø³Ø§ØªÚ¾ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(42524,1182,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð½Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð» ÑÐ° ÑÑ‚Ð°Ð²ÐºÐ¾Ð¼',0),(42525,1182,'vi','Lá»—i xÃ³a nguyÃªn váº­t liá»‡u khÃ´ng in',0),(42526,1182,'af','Fout nie-druk materiaal met item te skrap',0),(42527,1182,'ro','Eroare la È™tergerea nu se imprimÄƒ materialul cu element',0),(42528,1182,'et','TÃµrge kustutamisel printimatu materjali kaubaga',0),(42529,1182,'si','Napaka pri brisanju nenatisljivo materiala z elementom',0),(42530,1182,'ba','Error menghapus bebas-Percetakan bahan dengan item',0),(42531,1182,'nl','Fout bij het verwijderen van niet-afdrukbare materiaal met item',0),(42532,1182,'fi','Virhe poistettaessa tulostumattomat materiaali kohde',0),(42533,1182,'no','Feil ved sletting av ikke-utskrivbare materiale med element',0),(42534,1182,'da','Fejl ved sletning af trykfri materiale med varen',0),(42535,1182,'ko','ì˜¤ë¥˜ í•­ëª© ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ë¬¼ìžë¥¼ ì‚­ì œ',0),(42536,1182,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×—×•×ž×¨ ×ž×•×“×¤×¡ ×¢× ×¤×¨×™×˜',0),(42537,1182,'el','Î›Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® Î¼Î· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î¿ Ï…Î»Î¹ÎºÏŒ Î¼Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(42538,1182,'zh','é”™è¯¯åˆ é™¤é¡¹ç›®éžå°åˆ·ææ–™',0),(42539,1182,'sv','Fel ta bort icke-utskrift material med objekt',0),(42540,1182,'it','Errore eliminazione materiale non stampabili con elemento',0),(42541,1182,'tl','',0),(42542,1182,'th','Error deleting non-printing material with item',0),(42543,1182,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤¯à¥‹à¤—à¥à¤¯ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(42544,1182,'ms','Ralat menghapuskan bahan percetakan dengan perkara',0),(42545,1182,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„Ù…ÙˆØ§Ø¯ ØºÙŠØ± Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© Ù…Ø¹ Ø§Ù„Ø¨Ù†Ø¯',0),(42546,1182,'fr','Erreur de suppression de matÃ©riel non imprimables avec point',0),(42547,1182,'jp','ã??ã?®å“?ç›®ã?¨é?žå?°åˆ·æ??æ–™ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42548,1182,'pt','Erro ao excluir o material nÃ£o-imprimÃ­vel com item',0),(42549,1182,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð°-Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ñ Ð¿ÑƒÐ½ÐºÑ‚Ð°',0),(42550,1182,'es','Error eliminando material de no-impresiÃ³n con el item',0),(42551,1182,'de','Fehler beim LÃ¶schen der nicht druckbaren Material mit Element',0),(42552,1182,'en','Error deleting non-printing material with item',0),(42553,1183,'is','',0),(42554,1183,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(42555,1183,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(42556,1183,'tr','Hata silme yazdÄ±rÄ±lmayan fiyat listesi.',0),(42557,1183,'pl','Usuwanie bÅ‚Ä™du niedrukowane Cennik.',0),(42558,1183,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°.',0),(42559,1183,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(42560,1183,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¾Ð¸Ð²Ð¸Ñ‡ÐµÐ½ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°.',0),(42561,1183,'vi','Lá»—i xÃ³a danh sÃ¡ch giÃ¡ khÃ´ng in',0),(42562,1183,'af','Fout skrap nonprinting prys lys.',0),(42563,1183,'ro','Eroare ÅŸtergerea neimprimabile lista de preturi.',0),(42564,1183,'et','TÃµrge kustutamisel mitteprinditavad hinnakiri.',0),(42565,1183,'si','Napaka brisanja Nenatisljivi cenik.',0),(42566,1183,'ba','Error menghapus daftar harga nonprinting.',0),(42567,1183,'nl','Fout verwijderen niet-afdrukbare prijslijst.',0),(42568,1183,'fi','Virhe poistettaessa tulostumattomat hinnasto.',0),(42569,1183,'no','Feil slette ikke-utskrivbare prisliste.',0),(42570,1183,'da','Fejl slette afsnitstegn prisliste.',0),(42571,1183,'ko','ì˜¤ë¥˜ ì‚­ì œ ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡.',0),(42572,1183,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×” ×ž×—×™×¨×•×Ÿ.',0),(42573,1183,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î¼Î· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»Î¯ÏƒÏ„Î± ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½ Ï„Î¹Î¼Î®.',0),(42574,1183,'zh','é”™è¯¯åˆ é™¤éžå°åˆ·ä»·æ ¼è¡¨ã€‚\r\n',0),(42575,1183,'sv','Misstag utplÃ¥nande icke utskrivbar prislista.',0),(42576,1183,'it','Errore eliminazione non stampabile listino.',0),(42577,1183,'tl','',0),(42578,1183,'th','Error deleting nonprinting price list.',0),(42579,1183,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤—à¥ˆà¤° à¤®à¥à¤¦à¥à¤°à¤£à¥€à¤¯ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€à¥¤',0),(42580,1183,'ms','Ralat Menghapuskan nonprinting senarai harga.',0),(42581,1183,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù‚Ø§Ø¦Ù…Ø© ØºÙŠØ± Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(42582,1183,'fr','Erreur suppression non imprimable liste de prix.',0),(42583,1183,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42584,1183,'pt','Lista de preÃ§o de nÃ£o imprimÃ­vel apagar erros.',0),(42585,1183,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ñ… Ð¿Ñ€Ð°Ð¹Ñ Ð»Ð¸ÑÑ‚.',0),(42586,1183,'es','Error eliminando no-impresiÃ³n lista de precios',0),(42587,1183,'de','Fehler lÃ¶schen nicht druckbare Preisliste.',0),(42588,1183,'en','Error deleting non-printing price list.',0),(42589,1184,'is','',0),(42590,1184,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡   Ù„ÙŠØ³Øª Ú¯Ø²ÙŠÙ†Ø´ Ø¹Ù…Ù„ÙŠØ§Øª ',0),(42591,1184,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡   Ù„ÙŠØ³Øª Ú¯Ø²ÙŠÙ†Ø´ Ø¹Ù…Ù„ÙŠØ§Øª ',0),(42592,1184,'tr','YazdÄ±rÄ±lmayan fiyat listesi iÅŸlemi SeÃ§imi liste Ã¶ÄŸesi silme hatasÄ±.',0),(42593,1184,'pl','BÅ‚Ä…d podczas usuwania niedrukowane cena lista operacji wyboru listy pozycji.',0),(42594,1184,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ ÑÐ¿Ð¸ÑÑŠÐº ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°.',0),(42595,1184,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø¢Ù¾Ø±ÛŒØ´Ù† Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª Ø´Û’ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(42596,1184,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¾Ð¸Ð²Ð¸Ñ‡ÐµÐ½ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ñƒ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð»Ð¸ÑÑ‚Ðµ ÑÑ‚Ð°Ð²ÐºÑƒ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°.',0),(42597,1184,'vi','Lá»—i xÃ³a danh sÃ¡ch giÃ¡ khÃ´ng in',0),(42598,1184,'af','Fout nonprinting prys lys bewerking seleksie lys item te skrap.',0),(42599,1184,'ro','Eroare la È™tergerea neimprimabile preÅ£ listÄƒ funcÅ£ionarea selecÅ£ie element din listÄƒ.',0),(42600,1184,'et','TÃµrge kustutamisel mitteprinditavad operatsiooni valiku nimekirja hinnakirjaÃ¼ksuse.',0),(42601,1184,'si','Napaka brisanje Nenatisljivi delovanje izbor seznam element cenika.',0),(42602,1184,'ba','Error menghapus nonprinting harga daftar daftar item pilihan operasi.',0),(42603,1184,'nl','Fout bij het verwijderen van niet-afdrukbare lijst bewerking selectie prijslijstitem.',0),(42604,1184,'fi','Virhe poistettaessa tulostumattomat toiminnon valinta luettelon Hinnastonimike.',0),(42605,1184,'no','Feil ved sletting av ikke-utskrivbare operasjonen utvalg liste prislisteelement.',0),(42606,1184,'da','Fejl ved sletning af afsnitstegn operation udvalg liste prislisteelement.',0),(42607,1184,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡ ìž‘ì—… ì„ íƒ ëª©ë¡ í•­ëª©ì„ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(42608,1184,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×” ×ž×‘×¦×¢ ×‘×—×™×¨×” ×‘×¨×©×™×ž×” ×¤×¨×™×˜ ×ž×—×™×¨×•×Ÿ.',0),(42609,1184,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Î¼Î· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚ Î»Î¯ÏƒÏ„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï….',0),(42610,1184,'zh','é”™è¯¯åˆ é™¤éžæ‰“å°ä»·æ ¼è¡¨æ“ä½œé€‰æ‹©åˆ—è¡¨é¡¹',0),(42611,1184,'sv','Fel ta bort icke utskrivbara lista drift urval prislisteobjekt.',0),(42612,1184,'it','Errore eliminazione non stampabile prezzo operazione selezione elenco elemento dell\'elenco.',0),(42613,1184,'tl','',0),(42614,1184,'th','Error deleting nonprinting price list operation selection list item.',0),(42615,1184,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤‘à¤ªà¤°à¥‡à¤¶à¤¨ à¤šà¤¯à¤¨ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(42616,1184,'ms','Ralat Menghapuskan nonprinting harga senarai operasi pilihan senarai item.',0),(42617,1184,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø¹Ù…Ù„ÙŠØ© Ø§Ø®ØªÙŠØ§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø¹Ù†ØµØ± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©.',0),(42618,1184,'fr','Erreur de suppression non imprimables opÃ©ration sÃ©lection liste Ã©lÃ©ment tarifaire.',0),(42619,1184,'jp','Error deleting nonprinting price list operation selection list item.',0),(42620,1184,'pt','Erro ao excluir o item de lista de seleÃ§Ã£o de operaÃ§Ã£o do preÃ§o lista nÃ£o imprimÃ­veis.',0),(42621,1184,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ñ… Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐºÐ° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ Ð²Ñ‹Ð±Ð¾Ñ€Ð° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÑÐ¿Ð¸ÑÐºÐ°.',0),(42622,1184,'es','Error eliminando item de lista de selecciÃ³n de operaciÃ³n no-impresiÃ³n lista de precios',0),(42623,1184,'de','Fehler beim LÃ¶schen nicht druckbare Liste Vorgang Auswahl Preislistenelement.',0),(42624,1184,'en','Error deleting non-printing price list operation selection list item.',0),(42625,1185,'is','',0),(42626,1185,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(42627,1185,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(42628,1185,'tr','SipariÅŸ silme hatasÄ± #',0),(42629,1185,'pl','BÅ‚Ä…d podczas usuwania zamÃ³wienia #',0),(42630,1185,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° #',0),(42631,1185,'ur','ØªØ±ØªÛŒØ¨ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ #',0),(42632,1185,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð½Ð°Ð»Ð¾Ð³Ð° #',0),(42633,1185,'vi','Lá»—i khi xÃ³a Ä‘Æ¡n Ä‘áº·t hÃ ng sá»‘',0),(42634,1185,'af','Fout skrap orde #',0),(42635,1185,'ro','Eroare la È™tergerea ordinea #',0),(42636,1185,'et','TÃµrge kustutamisel jÃ¤rjekorras #',0),(42637,1185,'si','Napaka brisanja nalog #',0),(42638,1185,'ba','Error menghapus Order #',0),(42639,1185,'nl','Fout bij het verwijderen van bestelling #',0),(42640,1185,'fi','Virhe poistettaessa jÃ¤rjestyksessÃ¤ #',0),(42641,1185,'no','Feil ved sletting av ordre #',0),(42642,1185,'da','Fejl ved sletning af ordre #',0),(42643,1185,'ko','ì£¼ë¬¸ ì‚­ì œ ì˜¤ë¥˜ #',0),(42644,1185,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×”×–×ž× ×” #',0),(42645,1185,'el','Î›Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ #',0),(42646,1185,'zh','é”™è¯¯åˆ é™¤è®¢å•ï¼ƒ\r\n',0),(42647,1185,'sv','Fel ta bort Order #',0),(42648,1185,'it','Errore eliminazione ordine #',0),(42649,1185,'tl','',0),(42650,1185,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3',0),(42651,1185,'hi','à¤•à¥à¤°à¤® à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿ #',0),(42652,1185,'ms','Ralat Menghapuskan perintah #',0),(42653,1185,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù ØªØ±ØªÙŠØ¨ #',0),(42654,1185,'fr','Erreur de suppression de commande #',0),(42655,1185,'jp','æ³¨æ–‡ç•ªå?·ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42656,1185,'pt','Erro ao excluir ordem #',0),(42657,1185,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð—Ð°ÐºÐ°Ð·Ð° #',0),(42658,1185,'es','Error eliminando Pedido #',0),(42659,1185,'de','Fehler beim LÃ¶schen von Bestellung #',0),(42660,1185,'en','Error deleting Order #',0),(42661,1186,'is','',0),(42662,1186,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(42663,1186,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(42664,1186,'tr','Ã–deme tÃ¼rÃ¼ silme hatasÄ±',0),(42665,1186,'pl','BÅ‚Ä…d podczas usuwania zapÅ‚aciÄ‡ typu',0),(42666,1186,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ñ‚Ð¸Ð¿',0),(42667,1186,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(42668,1186,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ñ‚Ð¸Ð¿',0),(42669,1186,'vi','Lá»—i xÃ³a loáº¡i thanh toÃ¡n',0),(42670,1186,'af','Fout het ontstaan met die skraping van Besoldigingstipe',0),(42671,1186,'ro','Eroare la È™tergerea plÄƒteascÄƒ tip',0),(42672,1186,'et','TÃµrge kustutamisel maksa tÃ¼Ã¼p',0),(42673,1186,'si','Brisanje plaÄati vrsta napake',0),(42674,1186,'ba','Error menghapus jenis membayar',0),(42675,1186,'nl','Fout bij het verwijderen van betalen Type',0),(42676,1186,'fi','Virhe poistettaessa maksu-tyyppi',0),(42677,1186,'no','Feil ved sletting av betale Type',0),(42678,1186,'da','Fejl ved sletning af betale Type',0),(42679,1186,'ko','ì§€ë¶ˆ í˜•ì‹ ì‚­ì œ ì˜¤ë¥˜',0),(42680,1186,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×¡×•×’ ×œ×©×œ×',0),(42681,1186,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï„ÏÏ€Î¿ Î¼Îµ Ï€Î»Î·ÏÏŽÏƒÎ¿Ï…Î½',0),(42682,1186,'zh','é”™è¯¯åˆ é™¤æ”¯ä»˜ç±»åž‹ã€‚',0),(42683,1186,'sv','Misstag utplÃ¥nande betala typ',0),(42684,1186,'it','Errore eliminazione pagare tipo',0),(42685,1186,'tl','',0),(42686,1186,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(42687,1186,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(42688,1186,'ms','Ralat Menghapuskan jenis membayar',0),(42689,1186,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù \"Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹\"',0),(42690,1186,'fr','Erreur de suppression de Type payer',0),(42691,1186,'jp','æ”¯æ‰•ã‚¿ã‚¤ãƒ—ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42692,1186,'pt','Erro ao excluir tipo pagar',0),(42693,1186,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¸Ð¿Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹.',0),(42694,1186,'es','Error eliminando tipo de pago',0),(42695,1186,'de','Fehler beim LÃ¶schen des Zahlen-Typ',0),(42696,1186,'en','Error deleting Pay Type',0),(42697,1187,'is','',0),(42698,1187,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ ',0),(42699,1187,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ ',0),(42700,1187,'tr','BasÄ±n aracÄ± silme hatasÄ±.',0),(42701,1187,'pl','BÅ‚Ä…d podczas usuwania narzÄ™dzie.',0),(42702,1187,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚.',0),(42703,1187,'ur','Ù¾Ø±ÛŒØ³ Ú©Û’ Ø¢Ù„Û’ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(42704,1187,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð°Ð»Ð°Ñ‚ÐºÐ° Ð·Ð° Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ.',0),(42705,1187,'vi','Lá»—i xÃ³a cÃ´ng cá»¥ bÃ¡o chÃ­',0),(42706,1187,'af','Fout met skrapping Press instrument.',0),(42707,1187,'ro','Eroare la È™tergerea instrument de presa.',0),(42708,1187,'et','TÃµrge kustutamisel stants.',0),(42709,1187,'si','Napaka brisanje pritisnite orodje.',0),(42710,1187,'ba','Error menghapus alat tekan.',0),(42711,1187,'nl','Fout bij het verwijderen van Press Tool.',0),(42712,1187,'fi','Virhe poistettaessa puristustyÃ¶kalu.',0),(42713,1187,'no','Feil ved sletting av trykk pÃ¥ verktÃ¸y.',0),(42714,1187,'da','Fejl ved sletning af presse vÃ¦rktÃ¸j.',0),(42715,1187,'ko','í”„ë ˆìŠ¤ ë„êµ¬ë¥¼ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(42716,1187,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×‘×›×œ×™ ×”×ª×§×©×•×¨×ª.',0),(42717,1187,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ Ï„ÏÏ€Î¿Ï….',0),(42718,1187,'zh','é”™è¯¯åˆ é™¤æŒ‰åŽ‹å·¥å…·ã€‚',0),(42719,1187,'sv','Misstag utplÃ¥nande Press verktyg.',0),(42720,1187,'it','Errore eliminazione strumento di stampa.',0),(42721,1187,'tl','',0),(42722,1187,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3611;&#3640;&#3656;&#3617;&#3585;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;',0),(42723,1187,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(42724,1187,'ms','Ralat Menghapuskan alat tekan.',0),(42725,1187,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù \"Ø£Ø¯Ø§Ø© Ø§Ù„ØµØ­Ø§ÙØ©\".',0),(42726,1187,'fr','Erreur de suppression de sertisseuse.',0),(42727,1187,'jp','ãƒ—ãƒ¬ã‚¹æ©Ÿå™¨ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42728,1187,'pt','Erro ao excluir ferramenta de imprensa.',0),(42729,1187,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ñ€ÐµÑÑ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚.',0),(42730,1187,'es','Error eliminando Herramienta de Prensa',0),(42731,1187,'de','Fehler beim LÃ¶schen von Press-Werkzeug.',0),(42732,1187,'en','Error deleting Press Tool.',0),(42733,1188,'is','',0),(42734,1188,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª ',0),(42735,1188,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª ',0),(42736,1188,'tr','Hata silme fiyat dÃ¼zeyi.',0),(42737,1188,'pl','BÅ‚Ä…d usuwania cene.',0),(42738,1188,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð¾ Ð½Ð¸Ð²Ð¾.',0),(42739,1188,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ ÛÛ’ Û”',0),(42740,1188,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð°.',0),(42741,1188,'vi','Lá»—i xÃ³a má»©c giÃ¡',0),(42742,1188,'af','Fout skrap prys vlak.',0),(42743,1188,'ro','Eroare ÅŸtergerea nivel de preÅ£.',0),(42744,1188,'et','TÃµrge kustutamisel hinnatase.',0),(42745,1188,'si','Napaka brisanjem ravni cene.',0),(42746,1188,'ba','Tingkat harga menghapus kesalahan.',0),(42747,1188,'nl','Fout verwijderen prijsniveau.',0),(42748,1188,'fi','Virhe poistettaessa hintataso.',0),(42749,1188,'no','Feil slette prisnivÃ¥et.',0),(42750,1188,'da','Fejl slette prisniveau.',0),(42751,1188,'ko','ì˜¤ë¥˜ ì‚­ì œ ê°€ê²© ìˆ˜ì¤€ìž…ë‹ˆë‹¤.',0),(42752,1188,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×¨×ž×ª ×ž×—×™×¨×™×.',0),(42753,1188,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½.',0),(42754,1188,'zh','é”™è¯¯åˆ é™¤çš„ä»·æ ¼æ°´å¹³ã€‚',0),(42755,1188,'sv','Misstag utplÃ¥nande prisnivÃ¥.',0),(42756,1188,'it','Livello di prezzo eliminazione errore.',0),(42757,1188,'tl','',0),(42758,1188,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(42759,1188,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°à¥¤',0),(42760,1188,'ms','Ralat Menghapuskan paras harga.',0),(42761,1188,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(42762,1188,'fr','Niveau prix suppression par erreur.',0),(42763,1188,'jp','ä¾¡æ ¼æ°´æº–ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42764,1188,'pt','NÃ­vel de preÃ§o apagar erros.',0),(42765,1188,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÑƒÑ€Ð¾Ð²Ð½Ñ Ñ†ÐµÐ½.',0),(42766,1188,'es','Error eliminando nivel de precios',0),(42767,1188,'de','Fehler lÃ¶schen von Preisniveau.',0),(42768,1188,'en','Error deleting price level.',0),(42769,1189,'is','',0),(42770,1189,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(42771,1189,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(42772,1189,'tr','Hata silme fiyat listesi.',0),(42773,1189,'pl','BÅ‚Ä…d usuwania Cennik.',0),(42774,1189,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°.',0),(42775,1189,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(42776,1189,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°.',0),(42777,1189,'vi','Lá»—i xÃ³a danh sÃ¡ch giÃ¡',0),(42778,1189,'af','Fout skrap prys lys.',0),(42779,1189,'ro','Eroare de ÅŸtergere lista de preturi.',0),(42780,1189,'et','TÃµrge kustutamisel hinnakiri.',0),(42781,1189,'si','Napaka brisanja cenika.',0),(42782,1189,'ba','Error menghapus daftar harga.',0),(42783,1189,'nl','Fout verwijderen prijslijst.',0),(42784,1189,'fi','Virhe poistettaessa hinnasto.',0),(42785,1189,'no','Feil slette prisliste.',0),(42786,1189,'da','Fejl slette prisliste.',0),(42787,1189,'ko','ì˜¤ë¥˜ ì‚­ì œ ê°€ê²©í‘œìž…ë‹ˆë‹¤.',0),(42788,1189,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ž×—×™×¨ ×ž×—×™×¨×•×Ÿ.',0),(42789,1189,'el','Î›Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï….',0),(42790,1189,'zh','é”™è¯¯åˆ é™¤çš„ä»·ç›®è¡¨ã€‚',0),(42791,1189,'sv','Misstag utplÃ¥nande prislista.',0),(42792,1189,'it','Listino eliminazione errore.',0),(42793,1189,'tl','',0),(42794,1189,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(42795,1189,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€à¥¤',0),(42796,1189,'ms','Ralat menghapuskan senarai harga.',0),(42797,1189,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(42798,1189,'fr','Liste prix suppression par erreur.',0),(42799,1189,'jp','ä¾¡æ ¼è¡¨ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(42800,1189,'pt','Lista de preÃ§o apagar erros.',0),(42801,1189,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚.',0),(42802,1189,'es','Error eliminando lista de precios',0),(42803,1189,'de','Fehler lÃ¶schen Preisliste.',0),(42804,1189,'en','Error deleting price list.',0),(42805,1190,'is','',0),(42806,1190,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø®Ø´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(42807,1190,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø®Ø´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(42808,1190,'tr','Fiyat listesi bÃ¶lÃ¼mÃ¼ silme hatasÄ±.',0),(42809,1190,'pl','BÅ‚Ä…d podczas usuwania, cena lista czÄ™Å›ci ceny.',0),(42810,1190,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ñ‡Ð°ÑÑ‚ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ.',0),(42811,1190,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø­ØµÛ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(42812,1190,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð° ÑƒÐ»Ð¾Ð³Ñƒ Ñƒ Ð¾Ð´Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÑƒ Ñ†ÐµÐ½Ð°.',0),(42813,1190,'vi','Lá»—i xÃ³a danh sÃ¡ch giÃ¡ tá»«ng pháº§n',0),(42814,1190,'af','Fout met skrapping van prys lys deel pryse.',0),(42815,1190,'ro','Eroare la È™tergerea preÅ£ listÄƒ partea de stabilire a preÅ£urilor.',0),(42816,1190,'et','TÃµrge kustutamisel hind nimekirja osa hinnakujundus.',0),(42817,1190,'si','Napaka brisanje cena seznam del cene.',0),(42818,1190,'ba','Error menghapus harga daftar bagian harga.',0),(42819,1190,'nl','Fout bij verwijderen van prijs lijst deel prijzen.',0),(42820,1190,'fi','Virhe poistettaessa hinta luettelon osa hinnoista.',0),(42821,1190,'no','Feil ved sletting av pris liste del priser.',0),(42822,1190,'da','Fejl ved sletning af pris liste del priser.',0),(42823,1190,'ko','ê°€ê²© ëª©ë¡ ë¶€ë¶„ ê°€ê²© ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(42824,1190,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ž×—×™×¨ ×”×¨×©×™×ž×” ×—×œ×§ ×ª×ž×—×•×¨.',0),(42825,1190,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½ Î¼Î­ÏÎ¿Ï‚.',0),(42826,1190,'zh','é”™è¯¯åˆ é™¤ä»·æ ¼åˆ—è¡¨çš„ä¸€éƒ¨åˆ†å®šä»·',0),(42827,1190,'sv','Misstag utplÃ¥nande pris lista del prissÃ¤ttning.',0),(42828,1190,'it','Errore eliminazione prezzo elenco prezzi parte.',0),(42829,1190,'tl','',0),(42830,1190,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3656;&#3623;&#3609;&#3619;&#3634;&#3588;&#3634;',0),(42831,1190,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‡ à¤¹à¤¿à¤¸à¥à¤¸à¥‡ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(42832,1190,'ms','Ralat Menghapuskan harga senarai sebahagian harga.',0),(42833,1190,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¬Ø²Ø¡ Ø§Ù„ØªØ³Ø¹ÙŠØ±.',0),(42834,1190,'fr','Erreur de suppression de prix liste partie prix.',0),(42835,1190,'jp','Error deleting price list part pricing.',0),(42836,1190,'pt','Erro ao excluir os preÃ§os parte de lista de preÃ§o.',0),(42837,1190,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐ¾Ðº Ñ‡Ð°ÑÑ‚ÑŒ Ñ†ÐµÐ½Ñ‹.',0),(42838,1190,'es','Error eliminando lista de precios de sistema de precios de refacciones',0),(42839,1190,'de','Fehler beim LÃ¶schen der Preis Liste Teil Preise.',0),(42840,1190,'en','Error deleting price list part pricing.',0),(42841,1191,'is','',0),(42842,1191,'dr','( Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù…',0),(42843,1191,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø³Ù‡Ø§Ù… ( Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(42844,1191,'tr','Fiyat listesi stok silme hatasÄ±.',0),(42845,1191,'pl','BÅ‚Ä…d podczas usuwania cena lista zapasÃ³w.',0),(42846,1191,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð².',0),(42847,1191,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(42848,1191,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ.',0),(42849,1191,'vi','Lá»—i xÃ³a danh sÃ¡ch giÃ¡ hÃ ng tá»“n',0),(42850,1191,'af','Fout het ontstaan met die skraaping van pryslys voorraad.',0),(42851,1191,'ro','Eroare la È™tergerea Pret lista stoc.',0),(42852,1191,'et','TÃµrge kustutamisel hind nimekirja stock.',0),(42853,1191,'si','Napaka brisanja cena seznam zalog.',0),(42854,1191,'ba','Error menghapus daftar harga saham.',0),(42855,1191,'nl','Fout bij het verwijderen van prijs lijst voorraad.',0),(42856,1191,'fi','Virhe poistettaessa hinta luettelo varastossa.',0),(42857,1191,'no','Feil ved sletting av pris liste lager.',0),(42858,1191,'da','Fejl ved sletning af listen aktiekurs.',0),(42859,1191,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³ ë¥¼ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(42860,1191,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™.',0),(42861,1191,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï„Î·Î½ Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î§ÏÎ·Î¼Î±Ï„Î¹ÏƒÏ„Î®ÏÎ¹Î¿.',0),(42862,1191,'zh','é”™è¯¯åˆ é™¤ä»·æ ¼åˆ—è¡¨è‚¡ç¥¨',0),(42863,1191,'sv','Misstag utplÃ¥nande pris lista lager.',0),(42864,1191,'it','Errore eliminazione magazzino elenco prezzi.',0),(42865,1191,'tl','',0),(42866,1191,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(42867,1191,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(42868,1191,'ms','Ralat Menghapuskan harga Senarai saham.',0),(42869,1191,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„Ø£Ø³Ù‡Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(42870,1191,'fr','Erreur de suppression de stock de liste de prix.',0),(42871,1191,'jp','Error deleting price list stock.',0),(42872,1191,'pt','Erro ao excluir o estoque de lista de preÃ§o.',0),(42873,1191,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÑÐ¿Ð¸ÑÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ñ†ÐµÐ½Ð°.',0),(42874,1191,'es','Error eliminando lista de precios de stock',0),(42875,1191,'de','Fehler beim LÃ¶schen der Preis Liste Lager.',0),(42876,1191,'en','Error deleting price list stock.',0),(42877,1192,'is','',0),(42878,1192,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù…ØµØ±ÙÙŠ',0),(42879,1192,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù…ØµØ±ÙÙŠ',0),(42880,1192,'tr','Fiyat listesi stok kullanÄ±mÄ± silme hatasÄ±.',0),(42881,1192,'pl','BÅ‚Ä…d podczas usuwania cena listy czas uÅ¼ytkowania.',0),(42882,1192,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¾ÑÐ½Ð¾Ð²ÐµÐ½ Ð¾Ñ‚Ð½Ð°ÑÑÐ½Ðµ.',0),(42883,1192,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(42884,1192,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¾Ð³ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ðµ.',0),(42885,1192,'vi','Lá»—i xÃ³a danh sÃ¡ch giÃ¡ sá»­ dá»¥ng hÃ ng tá»“n ',0),(42886,1192,'af','Fout met skrapping van prys lys voorraad gebruik.',0),(42887,1192,'ro','Eroare la È™tergerea Pret lista stoc de utilizare.',0),(42888,1192,'et','TÃµrge kustutamisel hind nimekirja varude kasutamine.',0),(42889,1192,'si','Napaka brisanja cena seznam zalog navada.',0),(42890,1192,'ba','Error menghapus daftar harga saham penggunaan.',0),(42891,1192,'nl','Fout bij het verwijderen van prijs lijst voorraad gebruik.',0),(42892,1192,'fi','Virhe poistettaessa hinta luetteloon kaluston kÃ¤yttÃ¶.',0),(42893,1192,'no','Feil ved sletting av pris listen lagerforbruket.',0),(42894,1192,'da','Fejl ved sletning af pris liste stock skik.',0),(42895,1192,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš©ì„ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(42896,1192,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×¨×©×™×ž×” ×ž×—×™×¨ ×”×©×™×ž×•×© ×ž× ×™×•×ª.',0),(42897,1192,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï„Î·Î½ Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Ï‡ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½.',0),(42898,1192,'zh','é”™è¯¯åˆ é™¤è‚¡ç¥¨ä»·æ ¼è¡¨çš„ä½¿ç”¨ã€‚\r\n',0),(42899,1192,'sv','Misstag utplÃ¥nande pris lista lageranvÃ¤ndningen.',0),(42900,1192,'it','Errore eliminazione uso magazzino di elenco prezzi.',0),(42901,1192,'tl','',0),(42902,1192,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3',0),(42903,1192,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(42904,1192,'ms','Ralat menghapuskan penggunaan stok senarai harga.',0),(42905,1192,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(42906,1192,'fr','Erreur de suppression utilisation stock liste de prix.',0),(42907,1192,'jp','Error deleting price list stock usage.',0),(42908,1192,'pt','Erro ao excluir o uso das aÃ§Ãµes da lista de preÃ§o.',0),(42909,1192,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½Ð° Ð°ÐºÑ†Ð¸Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑÐ¿Ð¸ÑÐºÐ°.',0),(42910,1192,'es','Error eliminando uso de lista de precios de stock',0),(42911,1192,'de','Fehler beim LÃ¶schen der Preis Liste hat Verwendung.',0),(42912,1192,'en','Error deleting price list stock usage.',0),(42913,1193,'is','',0),(42914,1193,'dr','Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª  Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù…ØµØ±ÙÙŠ',0),(42915,1193,'pr','Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª  Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù…ØµØ±ÙÙŠ',0),(42916,1193,'tr','Fiyat listesi stok kullanÄ±mÄ± silme hatasÄ±.',0),(42917,1193,'pl','BÅ‚Ä…d podczas usuwania, cena lista cen czas uÅ¼ytkowania.',0),(42918,1193,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ.',0),(42919,1193,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(42920,1193,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¾Ð³ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°.',0),(42921,1193,'vi','Lá»—i xÃ³a danh sÃ¡ch giÃ¡ sá»­ dá»¥ng hÃ ng tá»“n ',0),(42922,1193,'af','Fout met skrapping van prys lys voorraad gebruik pryse.',0),(42923,1193,'ro','Eroare la È™tergerea Pret lista stoc de utilizare de stabilire a preÅ£urilor.',0),(42924,1193,'et','TÃµrge kustutamisel hind nimekirja varude kasutamise hinnad.',0),(42925,1193,'si','Napaka brisanje cena seznam zalog navada cenitev.',0),(42926,1193,'ba','Error menghapus harga daftar saham penggunaan harga.',0),(42927,1193,'nl','Fout bij verwijderen van prijs lijst voorraad gebruik prijzen.',0),(42928,1193,'fi','Virhe poistettaessa hinta luetteloon kaluston kÃ¤ytÃ¶n hinnoittelu.',0),(42929,1193,'no','Feil ved sletting av pris listen lagerforbruket priser.',0),(42930,1193,'da','Fejl ved sletning af pris liste stock skik prissÃ¦tning.',0),(42931,1193,'ko','ê°€ê²© ëª©ë¡ ì‚¬ì§„ ì‚¬ìš© ê°€ê²© ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(42932,1193,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™ ×”×©×™×ž×•×© ×ª×ž×—×•×¨.',0),(42933,1193,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎ·.',0),(42934,1193,'zh','é”™è¯¯åˆ é™¤è‚¡ç¥¨ä»·æ ¼è¡¨çš„ä½¿ç”¨ä»·æ ¼ã€‚\r\n',0),(42935,1193,'sv','Misstag utplÃ¥nande pris lista lageranvÃ¤ndningen prissÃ¤ttning.',0),(42936,1193,'it','Errore eliminazione prezzo elenco prezzi uso magazzino.',0),(42937,1193,'tl','',0),(42938,1193,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3619;&#3',0),(42939,1193,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(42940,1193,'ms','Ralat Menghapuskan harga senarai penggunaan stok harga.',0),(42941,1193,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„ØªØ³Ø¹ÙŠØ±.',0),(42942,1193,'fr','Erreur de suppression de liste de prix utilisation stock prix.',0),(42943,1193,'jp','Error deleting price list stock usage pricing.',0),(42944,1193,'pt','Erro ao excluir a lista de preÃ§o uso estoque preÃ§os.',0),(42945,1193,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐ¾Ðº Ð°ÐºÑ†Ð¸Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ.',0),(42946,1193,'es','Error eliminando sistema de precios de la lista de precios de stock',0),(42947,1193,'de','Fehler beim LÃ¶schen der Preis Liste hat Verwendung fÃ¼r Preise.',0),(42948,1193,'en','Error deleting price list stock usage pricing.',0),(42949,1194,'is','',0),(42950,1194,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±   Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù…ØµØ±ÙÙŠ ',0),(42951,1194,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±   Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù…ØµØ±ÙÙŠ ',0),(42952,1194,'tr','Fiyat listesi stok kullanÄ±mÄ± stok listesi silme hatasÄ±.',0),(42953,1194,'pl','BÅ‚Ä…d podczas usuwania cena lista zapasÃ³w czas uÅ¼ytkowania.',0),(42954,1194,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ ÑÑŠÑÑ‚Ð°Ð².',0),(42955,1194,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ø³Ù¹Ø§Ú© ÙÛØ±Ø³Øª Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(42956,1194,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¾Ð³ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð»Ð°Ð³ÐµÑ€ Ð»Ð¸ÑÑ‚Ð°.',0),(42957,1194,'vi','Lá»—i xÃ³a danh sÃ¡ch giÃ¡ sá»­ dá»¥ng hÃ ng tá»“n ',0),(42958,1194,'af','Fout met skraping van gebruikte  voorraad pryslys.',0),(42959,1194,'ro','Eroare la È™tergerea Pret lista stoc utilizare stoc listÄƒ.',0),(42960,1194,'et','TÃµrge kustutamisel hind nimekirja varude kasutamise nimestik.',0),(42961,1194,'si','Napaka izbriÅ¡ete seznam zalog uporabe zalog cenik.',0),(42962,1194,'ba','Error menghapus daftar saham saham penggunaan daftar harga.',0),(42963,1194,'nl','Fout bij het verwijderen van de lijst voorraad gebruik voorraad prijslijst.',0),(42964,1194,'fi','Virhe poistettaessa hinnasto luettelon kaluston kÃ¤yttÃ¶ varastossa.',0),(42965,1194,'no','Feil ved sletting av lager av prisliste pÃ¥ listen av lagerforbruket.',0),(42966,1194,'da','Fejl ved sletning af prisliste liste stock skik stock.',0),(42967,1194,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš© ìž¬ê³  ëª©ë¡ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(42968,1194,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×¨×©×™×ž×ª ×©×™×ž×•×© ×ž× ×™×•×ª ×ž× ×™×•×ª ×ž×—×™×¨×•×Ÿ.',0),(42969,1194,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½.',0),(42970,1194,'zh','é”™è¯¯åˆ é™¤è‚¡ç¥¨ä»·æ ¼åˆ—è¡¨ä½¿ç”¨åº“å­˜æ¸…å•ã€‚',0),(42971,1194,'sv','Fel ta bort listan lageranvÃ¤ndningen lager prislista.',0),(42972,1194,'it','Errore eliminazione lista stock utilizzo stock listino.',0),(42973,1194,'tl','',0),(42974,1194,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3',0),(42975,1194,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥‚à¤šà¥€ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(42976,1194,'ms','Ralat menghapuskan senarai saham saham penggunaan senarai harga.',0),(42977,1194,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø£Ø³Ù‡Ù….',0),(42978,1194,'fr','Erreur de suppression de liste de stock stock utilisation prix de liste.',0),(42979,1194,'jp','Error deleting price list stock usage stock list.',0),(42980,1194,'pt','Erro ao excluir a lista de estoque preÃ§o lista aÃ§Ãµes de uso.',0),(42981,1194,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐ¾Ðº Ð°ÐºÑ†Ð¸Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð·Ð°Ð¿Ð°ÑÐ¾Ð².',0),(42982,1194,'es','Error eliminando lista de uso de stock de la lista de precios de stock',0),(42983,1194,'de','Fehler beim LÃ¶schen der Preis Liste hat Verwendung Lagerliste.',0),(42984,1194,'en','Error deleting price list stock usage stock list.',0),(42985,1195,'is','',0),(42986,1195,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…Ø­Ù„ Ú†Ø§Ù¾ ',0),(42987,1195,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…Ø­Ù„ Ú†Ø§Ù¾ ',0),(42988,1195,'tr','YazdÄ±rma konumu silme hatasÄ±',0),(42989,1195,'pl','BÅ‚Ä…d podczas usuwania wydruku lokalizacji',0),(42990,1195,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(42991,1195,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(42992,1195,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(42993,1195,'vi','Lá»—i xÃ³a vá»‹ trÃ­ in',0),(42994,1195,'af','Fout met skrap van Uitdrukbare Punt',0),(42995,1195,'ro','Eroare la È™tergerea imprimare locaÅ£ie',0),(42996,1195,'et','TÃµrge kustutamisel Prindi asukoht',0),(42997,1195,'si','Brisanje tiskanja lokacija napake',0),(42998,1195,'ba','Error menghapus lokasi cetak',0),(42999,1195,'nl','Fout bij het verwijderen van afdrukpositie',0),(43000,1195,'fi','Virhe poistettaessa tulosta sijainti',0),(43001,1195,'no','Feil ved sletting av utskriftsplassering',0),(43002,1195,'da','Fejl ved sletning af Print placering',0),(43003,1195,'ko','ì˜¤ë¥˜ ì¸ì‡„ ìœ„ì¹˜ ì‚­ì œ',0),(43004,1195,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×ž×™×§×•× ×”×”×“×¤×¡×”',0),(43005,1195,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î¸Î­ÏƒÎ·Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(43006,1195,'zh','é”™è¯¯åˆ é™¤æ‰“å°ä½ç½®',0),(43007,1195,'sv','Misstag utplÃ¥nande tryckta lÃ¤ge',0),(43008,1195,'it','Errore eliminando l\'area di stampa',0),(43009,1195,'tl','',0),(43010,1195,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(43011,1195,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¸à¥à¤¥à¤¾à¤¨ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(43012,1195,'ms','Ralat menghapuskan lokasi cetakan',0),(43013,1195,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(43014,1195,'fr','Erreur de suppression emplacement d\'impression',0),(43015,1195,'jp','å?°åˆ·ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43016,1195,'pt','Erro ao excluir o local de impressÃ£o',0),(43017,1195,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(43018,1195,'es','Error Eliminando UbicaciÃ³n de Imprenta',0),(43019,1195,'de','Fehler beim LÃ¶schen der Drucken-Lage',0),(43020,1195,'en','Error Deleting Print Location',0),(43021,1196,'is','',0),(43022,1196,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(43023,1196,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(43024,1196,'tr','Hata silme alÄ±ntÄ±',0),(43025,1196,'pl','BÅ‚Ä…d usuwania cytat',0),(43026,1196,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(43027,1196,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø§Ù‚ØªØ¨Ø§Ø³',0),(43028,1196,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(43029,1196,'vi','Lá»—i xÃ³a bÃ¡o giÃ¡',0),(43030,1196,'af','Fout met skrapping van aanhaling',0),(43031,1196,'ro','Eroare ÅŸtergerea citat',0),(43032,1196,'et','TÃµrge kustutamisel tsitaat',0),(43033,1196,'si','Napaka brisanja citat',0),(43034,1196,'ba','Error menghapus kutipan',0),(43035,1196,'nl','Fout verwijderen offerte',0),(43036,1196,'fi','Virhe poistettaessa lainaus',0),(43037,1196,'no','Feil slette tilbud',0),(43038,1196,'da','Fejl slette tilbud',0),(43039,1196,'ko','ì˜¤ë¥˜ ì‚­ì œ ê²¬ì ',0);
INSERT INTO `langdef` VALUES (43040,1196,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”×¦×¢×ª ×ž×—×™×¨',0),(43041,1196,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(43042,1196,'zh','é”™è¯¯åˆ é™¤æŠ¥ä»·',0),(43043,1196,'sv','Misstag utplÃ¥nande citat',0),(43044,1196,'it','Citazione eliminazione errore',0),(43045,1196,'tl','',0),(43046,1196,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(43047,1196,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤¬à¥‹à¤²à¥€',0),(43048,1196,'ms','Ralat Menghapuskan quote',0),(43049,1196,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(43050,1196,'fr','Citation de suppression erreur',0),(43051,1196,'jp','è¦‹ç©?ã‚‚ã‚Šã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43052,1196,'pt','CitaÃ§Ã£o de exclusÃ£o de erro',0),(43053,1196,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(43054,1196,'es','Error eliminando cotizaciÃ³n',0),(43055,1196,'de','Fehler lÃ¶schen Zitat',0),(43056,1196,'en','Error deleting quote',0),(43057,1197,'is','',0),(43058,1197,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù†Ø¸Ø±Ø§Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(43059,1197,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù†Ø¸Ø±Ø§Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(43060,1197,'tr','Hata silme alÄ±ntÄ± yorum',0),(43061,1197,'pl','BÅ‚Ä…d usuwania cytat komentarz',0),(43062,1197,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(43063,1197,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø§Ù‚ØªØ¨Ø§Ø³ ØªØ¨ØµØ±Û',0),(43064,1197,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(43065,1197,'vi','Lá»—i xÃ³a nháº­n xÃ©t bÃ¡o giÃ¡',0),(43066,1197,'af','Fout met skrapping van aanhaling kommentaar',0),(43067,1197,'ro','Eroare ÅŸtergerea citat comentariu',0),(43068,1197,'et','TÃµrge kustutamisel tsiteerida kommentaari',0),(43069,1197,'si','Napaka brisanja citiram komentar',0),(43070,1197,'ba','Error menghapus kutipan komentar',0),(43071,1197,'nl','Fout verwijderen citaat commentaar',0),(43072,1197,'fi','Virhe poistettaessa lainaus kommentti',0),(43073,1197,'no','Feil slette tilbud kommentar',0),(43074,1197,'da','Fejl slette tilbud kommentar',0),(43075,1197,'ko','ì˜¤ë¥˜ ì‚­ì œ ì¸ìš© ì½”ë©˜íŠ¸',0),(43076,1197,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”×¦×¢×ª ×ž×—×™×¨ ×ª×’×•×‘×”',0),(43077,1197,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚ ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(43078,1197,'zh','é”™è¯¯åˆ é™¤æŠ¥ä»·è¯„è®º',0),(43079,1197,'sv','Misstag utplÃ¥nande citat kommentar',0),(43080,1197,'it','Commento di citazione eliminazione errore',0),(43081,1197,'tl','',0),(43082,1197,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3588;&#3623;&#3634;&#3617;&#3588;&#3636;&#3604;&#3648;&#3627;&#3655;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(43083,1197,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€',0),(43084,1197,'ms','Ralat Menghapuskan quote komen',0),(43085,1197,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù ØªØ¹Ù‚ÙŠØ¨ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(43086,1197,'fr','Commentaire de citation suppression erreur',0),(43087,1197,'jp','è¦‹ç©?ã‚‚ã‚Šæ³¨é‡ˆã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43088,1197,'pt','ComentÃ¡rio de citaÃ§Ã£o excluindo erro',0),(43089,1197,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹',0),(43090,1197,'es','Error eliminando comentario de cotizaciÃ³n',0),(43091,1197,'de','Fehler lÃ¶schen Zitat Kommentar',0),(43092,1197,'en','Error deleting quote comment',0),(43093,1198,'is','',0),(43094,1198,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(43095,1198,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(43096,1198,'tr','Hata silme alÄ±ntÄ± notlar.',0),(43097,1198,'pl','BÅ‚Ä…d usuwania notatek cytat.',0),(43098,1198,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸.',0),(43099,1198,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ø§Ù‚ØªØ¨Ø§Ø³ Ù†ÙˆÙ¹ Û”',0),(43100,1198,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð½Ð¾Ñ‚Ðµ.',0),(43101,1198,'vi','Lá»—i xÃ³a ghi chÃº bÃ¡o giÃ¡',0),(43102,1198,'af','Fout met skep van kwotasienotas',0),(43103,1198,'ro','Eroare ÅŸtergerea citat note.',0),(43104,1198,'et','TÃµrge kustutamisel hinnapakkumise mÃ¤rkmed.',0),(43105,1198,'si','Napaka brisanja citat opombe.',0),(43106,1198,'ba','Error menghapus kutipan catatan.',0),(43107,1198,'nl','Fout verwijderen citaat notities.',0),(43108,1198,'fi','Virhe poistettaessa lainaus toteaa.',0),(43109,1198,'no','Feil slette tilbud notater.',0),(43110,1198,'da','Fejl slette tilbud noter.',0),(43111,1198,'ko','ì˜¤ë¥˜ ì‚­ì œ ê²¬ì  ë…¸íŠ¸ìž…ë‹ˆë‹¤.',0),(43112,1198,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”×¢×¨×•×ª ×œ×”×¦×¢×ª ×ž×—×™×¨.',0),(43113,1198,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬.',0),(43114,1198,'zh','é”™è¯¯åˆ é™¤æŠ¥ä»·è¯´æ˜Žã€‚\r\n',0),(43115,1198,'sv','Misstag utplÃ¥nande citat anteckningar.',0),(43116,1198,'it','Note di citazione eliminazione errore.',0),(43117,1198,'tl','',0),(43118,1198,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(43119,1198,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤¬à¥‹à¤²à¥€ à¤¨à¥‹à¤Ÿà¥à¤¸à¥¤',0),(43120,1198,'ms','Ralat Menghapuskan quote Nota-nota.',0),(43121,1198,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(43122,1198,'fr','Notes citation suppression par erreur.',0),(43123,1198,'jp','è¦‹ç©?ã‚‚ã‚Šãƒ¡ãƒ¢ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43124,1198,'pt','Excluir notas de citaÃ§Ã£o de erro.',0),(43125,1198,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð¾Ð¹.',0),(43126,1198,'es','Error eliminando notas de cotizaciÃ³n',0),(43127,1198,'de','Fehler lÃ¶schen Zitat Notizen.',0),(43128,1198,'en','Error deleting quote notes.',0),(43129,1199,'is','',0),(43130,1199,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø±ØªØ¨Ù‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(43131,1199,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø±ØªØ¨Ù‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(43132,1199,'tr','Ä°nceleme puanÄ± silme hatasÄ±',0),(43133,1199,'pl','Usuwanie bÅ‚Ä™dÃ³w review ocena',0),(43134,1199,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(43135,1199,'ur','Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(43136,1199,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³Ð°',0),(43137,1199,'vi','Lá»—i xÃ³a thang Ä‘Ã¡nh giÃ¡ bÃ¡o giÃ¡',0),(43138,1199,'af','Fout met skrap hersien gradering',0),(43139,1199,'ro','Eroare la È™tergerea rating de revizuire',0),(43140,1199,'et','TÃµrge kustutamisel review hinnang',0),(43141,1199,'si','Napake pri brisanju rating pregled',0),(43142,1199,'ba','Error menghapus peringkat Tinjauan',0),(43143,1199,'nl','Fout bij het verwijderen van de review beoordeling',0),(43144,1199,'fi','Virhe poistettaessa review Luokitus',0),(43145,1199,'no','Feil ved sletting av VurderingsnivÃ¥',0),(43146,1199,'da','Fejl ved sletning af anmeldelse rating',0),(43147,1199,'ko','ì˜¤ë¥˜ ê²€í†  ë“±ê¸‰ì„ ì‚­ì œ',0),(43148,1199,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×“×™×¨×•×’ ×¡×§×™×¨×”',0),(43149,1199,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î²Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(43150,1199,'zh','é”™è¯¯åˆ é™¤å®¡æ ¸è¯„çº§',0),(43151,1199,'sv','Misstag utplÃ¥nande recension betyg',0),(43152,1199,'it','Errore eliminazione recensione punteggio',0),(43153,1199,'tl','',0),(43154,1199,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;',0),(43155,1199,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(43156,1199,'ms','Ralat Menghapuskan kajian penilaian',0),(43157,1199,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù ØªØµÙ†ÙŠÙ Ø§Ø³ØªØ¹Ø±Ø§Ø¶',0),(43158,1199,'fr','Erreur de suppression de prix |',0),(43159,1199,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼è©•ä¾¡ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43160,1199,'pt','Erro ao excluir a classificaÃ§Ã£o de revisÃ£o',0),(43161,1199,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÐžÐ±Ð·Ð¾Ñ€ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(43162,1199,'es','Error eliminando valuaciÃ³n de la revisiÃ³n',0),(43163,1199,'de','Fehler beim LÃ¶schen der Digitalkamera Test',0),(43164,1199,'en','Error deleting review rating',0),(43165,1200,'is','',0),(43166,1200,'dr','( ÙØ±ÙˆØ´',0),(43167,1200,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù¾Ø±Ø³Ù†Ù„ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ( ÙØ±ÙˆØ´',0),(43168,1200,'tr','Hata silme satÄ±ÅŸ personeli',0),(43169,1200,'pl','Usuwanie bÅ‚Ä™dÃ³w personelu sprzedaÅ¼y',0),(43170,1200,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(43171,1200,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ ÙØ±ÙˆØ®Øª Ø§ÛÙ„Ú©Ø§Ø±ÙˆÚº',0),(43172,1200,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(43173,1200,'vi','Lá»—i xÃ³a nhÃ¢n viÃªn kinh doanh',0),(43174,1200,'af','Fout het ontstaan met die skrap van Verkoopspersoneel',0),(43175,1200,'ro','Eroare ÅŸtergerea personal de vÃ¢nzÄƒri',0),(43176,1200,'et','TÃµrge kustutamisel mÃ¼Ã¼gipersonalile',0),(43177,1200,'si','Napaka brisanja prodajno osebje',0),(43178,1200,'ba','Error menghapus penjualan personil',0),(43179,1200,'nl','Fout verwijderen verkooppersoneel',0),(43180,1200,'fi','Virhe poistettaessa myyntihenkilÃ¶stÃ¶Ã¤',0),(43181,1200,'no','Feil slette salgspersonale',0),(43182,1200,'da','Fejl slette salgspersonale',0),(43183,1200,'ko','ì˜¤ë¥˜ ì‚­ì œ íŒë§¤ ì§ì›',0),(43184,1200,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×× ×©×™ ×ž×›×™×¨×•×ª',0),(43185,1200,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ¿Ï Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(43186,1200,'zh','é”™è¯¯åˆ é™¤é”€å”®äººå‘˜',0),(43187,1200,'sv','Misstag utplÃ¥nande sÃ¤ljpersonal',0),(43188,1200,'it','Personale di vendita eliminazione errore',0),(43189,1200,'tl','',0),(43190,1200,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(43191,1200,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚',0),(43192,1200,'ms','Ralat Menghapuskan kakitangan jualan',0),(43193,1200,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø£ÙØ±Ø§Ø¯ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(43194,1200,'fr','Personnel de vente suppression par erreur',0),(43195,1200,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¹ã‚¿ãƒƒãƒ•ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43196,1200,'pt','Pessoal de vendas excluindo erro',0),(43197,1200,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(43198,1200,'es','Error eliminando personal de ventas',0),(43199,1200,'de','Fehler lÃ¶schen von Verkaufspersonal',0),(43200,1200,'en','Error deleting sales personnel',0),(43201,1201,'is','',0),(43202,1201,'dr',' Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(43203,1201,'pr',' Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(43204,1201,'tr','SatÄ±ÅŸ vergisi silme hatasÄ±',0),(43205,1201,'pl','BÅ‚Ä…d podczas usuwania podatku',0),(43206,1201,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(43207,1201,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(43208,1201,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(43209,1201,'vi','Lá»—i xÃ³a thuáº¿ bÃ¡n hÃ ng',0),(43210,1201,'af','Fout skrap verkoopsbelasting',0),(43211,1201,'ro','Eroare la È™tergerea impozit pe vÃ¢nzÄƒri',0),(43212,1201,'et','TÃµrge kustutamisel kÃ¤ibemaksu',0),(43213,1201,'si','Napaka brisanja prometnega davka',0),(43214,1201,'ba','Error menghapus pajak penjualan',0),(43215,1201,'nl','Fout bij het verwijderen van BTW',0),(43216,1201,'fi','Virhe poistettaessa arvonlisÃ¤vero',0),(43217,1201,'no','Feil ved sletting av mva',0),(43218,1201,'da','Fejl ved sletning af moms',0),(43219,1201,'ko','íŒë§¤ì„¸ë¥¼ ì‚­ì œ ì˜¤ë¥˜',0),(43220,1201,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ž×¢ ×ž',0),(43221,1201,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï„Î¿ Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(43222,1201,'zh','é”™è¯¯åˆ é™¤é”€å”®ç¨Ž\r\n',0),(43223,1201,'sv','Fel ta bort moms',0),(43224,1201,'it','Errore eliminando IVA',0),(43225,1201,'tl','',0),(43226,1201,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3616;&#3634;&#3625;&#3637;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(43227,1201,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(43228,1201,'ms','Ralat Menghapuskan cukai jualan',0),(43229,1201,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(43230,1201,'fr','Erreur de suppression de la taxe de vente',0),(43231,1201,'jp','å£²ä¸Šç¨Žã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43232,1201,'pt','Erro ao excluir o imposto sobre vendas',0),(43233,1201,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¾Ð±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(43234,1201,'es','Error eliminando IVA',0),(43235,1201,'de','Fehler beim LÃ¶schen der Umsatzsteuer',0),(43236,1201,'en','Error deleting sales tax',0),(43237,1202,'is','',0),(43238,1202,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø±ÙˆØ´ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ',0),(43239,1202,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø±ÙˆØ´ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ',0),(43240,1202,'tr','Nakliye yÃ¶ntemi silme hatasÄ±',0),(43241,1202,'pl','BÅ‚Ä…d podczas usuwania metody wysyÅ‚ki',0),(43242,1202,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð°Ñ‡Ð¸Ð½ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(43243,1202,'ur','Ø´Ù¾Ù†Ú¯ Ø·Ø±ÛŒÙ‚Û Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(43244,1202,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð½Ð°Ñ‡Ð¸Ð½ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(43245,1202,'vi','Lá»—i khi xÃ³a phÆ°Æ¡ng thá»©c váº­n chuyá»ƒn',0),(43246,1202,'af','Fout met byvoeging van Versendingsmetode',0),(43247,1202,'ro','Eroare la È™tergerea metoda de transport maritim',0),(43248,1202,'et','Tarneviisi kustutamisel tekkis viga',0),(43249,1202,'si','Napaka pri brisanju naÄin poÅ¡iljanja',0),(43250,1202,'ba','Error menghapus metode pengiriman',0),(43251,1202,'nl','Fout bij het verwijderen van de verzendmethode',0),(43252,1202,'fi','Virhe poistettaessa toimitustapa',0),(43253,1202,'no','Feil ved sletting av leveringsmÃ¥tene',0),(43254,1202,'da','Fejl ved sletning af shipping metode',0),(43255,1202,'ko','ì˜¤ë¥˜ ë°°ì†¡ ë°©ë²• ì‚­ì œ',0),(43256,1202,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×©×™×˜×ª ×”×ž×©×œ×•×—',0),(43257,1202,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ ÎœÎ•Î˜ÎŸÎ”ÎŸÎ¥ Î‘Î ÎŸÎ£Î¤ÎŸÎ›Î—Î£',0),(43258,1202,'zh','é”™è¯¯åˆ é™¤é€è´§æ–¹å¼',0),(43259,1202,'sv','Misstag utplÃ¥nande leveranssÃ¤tt',0),(43260,1202,'it','Errore eliminando il metodo di spedizione',0),(43261,1202,'tl','',0),(43262,1202,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(43263,1202,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤ªà¤¦à¥à¤§à¤¤à¤¿ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(43264,1202,'ms','Ralat Menghapuskan kaedah penghantaran',0),(43265,1202,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø´Ø­Ù†',0),(43266,1202,'fr','Erreur de suppression de mode de livraison',0),(43267,1202,'jp','é…?é€?æ–¹æ³•ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43268,1202,'pt','Erro ao excluir o mÃ©todo de envio',0),(43269,1202,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÑÐ¿Ð¾ÑÐ¾Ð±Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(43270,1202,'es','Error eliminando modo de transporte',0),(43271,1202,'de','Fehler beim LÃ¶schen der Versandart',0),(43272,1202,'en','Error deleting shipping method',0),(43273,1203,'is','',0),(43274,1203,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(43275,1203,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(43276,1203,'tr','Standart miktar silme hatasÄ±.',0),(43277,1203,'pl','BÅ‚Ä…d podczas usuwania standardowa iloÅ›Ä‡.',0),(43278,1203,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾.',0),(43279,1203,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(43280,1203,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°.',0),(43281,1203,'vi','Lá»—i xÃ³a sá»‘ lÆ°á»£ng chuáº©n',0),(43282,1203,'af','Fout standaard hoeveelheid te skrap.',0),(43283,1203,'ro','Eroare la È™tergerea cantitatea standard.',0),(43284,1203,'et','Standardkoguse kustutamisel tekkis viga',0),(43285,1203,'si','Napaka brisanja standardno koliÄino.',0),(43286,1203,'ba','Error menghapus kuantitas standar.',0),(43287,1203,'nl','Fout bij het verwijderen van standaard hoeveelheid.',0),(43288,1203,'fi','Virhe poistettaessa vakiomÃ¤Ã¤rÃ¤.',0),(43289,1203,'no','Feil ved sletting av standardantallet.',0),(43290,1203,'da','Fejl ved sletning af standard mÃ¦ngde.',0),(43291,1203,'ko','í‘œì¤€ ìˆ˜ëŸ‰ì„ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(43292,1203,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×›×ž×•×ª ×¡×˜× ×“×¨×˜×™×ª.',0),(43293,1203,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï€ÏÏŒÏ„Ï…Ï€Î¿ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±.',0),(43294,1203,'zh','é”™è¯¯åˆ é™¤æ ‡å‡†æ•°é‡ã€‚',0),(43295,1203,'sv','Misstag utplÃ¥nande standardkvantiteten.',0),(43296,1203,'it','Errore eliminando la quantitÃ  standard.',0),(43297,1203,'tl','',0),(43298,1203,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(43299,1203,'hi','à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(43300,1203,'ms','Ralat Menghapuskan kuantiti yang standard.',0),(43301,1203,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù ÙƒÙ…ÙŠØ© Ù‚ÙŠØ§Ø³ÙŠØ©.',0),(43302,1203,'fr','Erreur de suppression de quantitÃ© standard.',0),(43303,1203,'jp','æ¨™æº–æ•°é‡?ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43304,1203,'pt','Erro ao excluir a quantidade normal.',0),(43305,1203,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð³Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°.',0),(43306,1203,'es','Error eliminando cantidad estÃ¡ndar',0),(43307,1203,'de','Fehler beim LÃ¶schen der Standardmenge.',0),(43308,1203,'en','Error deleting standard quantity.',0),(43309,1204,'is','',0),(43310,1204,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(43311,1204,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(43312,1204,'tr','alt grup silme hatasÄ±',0),(43313,1204,'pl','bÅ‚Ä…d podczas usuwania podgrupy',0),(43314,1204,'bg','Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð°Ñ‚Ð°',0),(43315,1204,'ur','Ø³Ø¨Ú¯Ø±ÙˆÙ¾ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(43316,1204,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ñƒ',0),(43317,1204,'vi','Lá»—i xÃ³a nhÃ³m phá»¥',0),(43318,1204,'af','fout supgroep te skrap',0),(43319,1204,'ro','Eroare la È™tergerea subgrup',0),(43320,1204,'et','tÃµrge kustutamisel alarÃ¼hm',0),(43321,1204,'si','Napaka pri brisanju podskupini',0),(43322,1204,'ba','Error menghapus subgrup',0),(43323,1204,'nl','fout bij het verwijderen van subgroep',0),(43324,1204,'fi','Virhe poistettaessa alaryhmÃ¤',0),(43325,1204,'no','feil ved sletting av undergruppe',0),(43326,1204,'da','fejl ved sletning af undergruppe',0),(43327,1204,'ko','í•˜ìœ„ ê·¸ë£¹ì„ ì‚­ì œ í•˜ë©´ ì˜¤ë¥˜',0),(43328,1204,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×§×‘×•×¦×ª ×ž×©× ×”',0),(43329,1204,'el','ÏƒÏ†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï…Ï€Î¿Î¿Î¼Î¬Î´Î±',0),(43330,1204,'zh','é”™è¯¯åˆ é™¤ç¾¤',0),(43331,1204,'sv','misstag utplÃ¥nande undergrupp',0),(43332,1204,'it','errore cancellando il sottogruppo',0),(43333,1204,'tl','',0),(43334,1204,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3585;&#3621;&#3640;&#3656;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(43335,1204,'hi','à¤‰à¤ªà¤¸à¤®à¥‚à¤¹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(43336,1204,'ms','Ralat Menghapuskan subkumpulan',0),(43337,1204,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„ÙØ±Ø¹ÙŠ',0),(43338,1204,'fr','erreur de suppression de sous-groupe',0),(43339,1204,'jp','ã‚µãƒ–ã‚°ãƒ«ãƒ¼ãƒ—ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43340,1204,'pt','erro ao excluir o subgrupo',0),(43341,1204,'ru','Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(43342,1204,'es','Error eliminando subgrupo',0),(43343,1204,'de','Fehler beim LÃ¶schen der Untergruppe',0),(43344,1204,'en','error deleting subgroup',0),(43345,1205,'is','',0),(43346,1205,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(43347,1205,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(43348,1205,'tr','Hata silme vergi muafiyeti',0),(43349,1205,'pl','BÅ‚Ä…d usuwania zwolnienia z podatku',0),(43350,1205,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº',0),(43351,1205,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(43352,1205,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð±ÐµÐ· Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ†Ð°Ñ€Ð¸Ð½Ðµ',0),(43353,1205,'vi','Lá»—i xÃ³a miá»…n trá»« thuáº¿',0),(43354,1205,'af','Fout met skraping van belastingvrystelling',0),(43355,1205,'ro','Eroare ÅŸtergerea scutire de impozit',0),(43356,1205,'et','Maksuvabastuse kustutamisel ilmnes viga',0),(43357,1205,'si','Napaka brisanja davÄne oprostitve',0),(43358,1205,'ba','Pembebasan pajak menghapus kesalahan',0),(43359,1205,'nl','Fout belastingvrijstelling verwijderen',0),(43360,1205,'fi','Virhe poistettaessa verovapautus',0),(43361,1205,'no','Feil slette skattefritak',0),(43362,1205,'da','Fejl slette skattefrihed',0),(43363,1205,'ko','ì˜¤ë¥˜ ì‚­ì œ ì„¸ê¸ˆ ë©´ì œ',0),(43364,1205,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×‘×ž×™×¡×™×',0),(43365,1205,'el','Î›Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï€Î±Î»Î»Î±Î³Î® Î±Ï€ÏŒ Ï„Î¿ Ï†ÏŒÏÎ¿',0),(43366,1205,'zh','é”™è¯¯åˆ é™¤å…ç¨Ž',0),(43367,1205,'sv','Misstag utplÃ¥nande skattebefrielse',0),(43368,1205,'it','Esenzione fiscale eliminazione di errore',0),(43369,1205,'tl','',0),(43370,1205,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(43371,1205,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¤° à¤›à¥‚à¤Ÿ',0),(43372,1205,'ms','Ralat Menghapuskan cukai pengecualian',0),(43373,1205,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ',0),(43374,1205,'fr','DÃ©fiscalisation suppression de l\'erreur',0),(43375,1205,'jp','ç¨ŽæŽ§é™¤ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43376,1205,'pt','IsenÃ§Ã£o de imposto apagar erro',0),(43377,1205,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ Ð¾Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(43378,1205,'es','Error eliminando exenciÃ³n de impuestos',0),(43379,1205,'de','Fehler lÃ¶schen von Steuerbefreiung',0),(43380,1205,'en','Error deleting tax exemption',0),(43381,1206,'is','',0),(43382,1206,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù†Ø§Ù…  ÙˆØ§Ø­Ø¯ ',0),(43383,1206,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù†Ø§Ù…  ÙˆØ§Ø­Ø¯ ',0),(43384,1206,'tr','Hata silme birim adÄ±',0),(43385,1206,'pl','BÅ‚Ä…d usuwania Nazwa jednostki',0),(43386,1206,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¸Ð¼Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(43387,1206,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù…',0),(43388,1206,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð¼Ðµ',0),(43389,1206,'vi','Lá»—i xÃ³a tÃªn Ä‘Æ¡n vá»‹',0),(43390,1206,'af','Fout met skrap van eenheidsnaam',0),(43391,1206,'ro','Eroare ÅŸtergerea nume de unitatea de',0),(43392,1206,'et','TÃµrge kustutamisel Ã¼hiku nimi',0),(43393,1206,'si','Napaka brisanja ime enote',0),(43394,1206,'ba','Nama unit menghapus kesalahan',0),(43395,1206,'nl','Fout verwijderen eenheid naam',0),(43396,1206,'fi','Virhe poistettaessa yksikÃ¶n nimi',0),(43397,1206,'no','Feil slette navn',0),(43398,1206,'da','Fejl slette enhed navn',0),(43399,1206,'ko','ì˜¤ë¥˜ ì‚­ì œ ë‹¨ìœ„ ì´ë¦„',0),(43400,1206,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”×™×—×™×“×” ×©×',0),(43401,1206,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î¼Î¿Î½Î¬Î´Î± ÏŒÎ½Î¿Î¼Î±',0),(43402,1206,'zh','é”™è¯¯åˆ é™¤å•ä½åç§°',0),(43403,1206,'sv','Misstag utplÃ¥nande enhet namn',0),(43404,1206,'it','Nome dell\'unitÃ  eliminazione errore',0),(43405,1206,'tl','',0),(43406,1206,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(43407,1206,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¾à¤®',0),(43408,1206,'ms','Ralat Menghapuskan unit nama',0),(43409,1206,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø¥Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø©',0),(43410,1206,'fr','Nom de l\'unitÃ© suppression erreur',0),(43411,1206,'jp','å?˜ä½?å??ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43412,1206,'pt','Nome da unidade de erro excluindo',0),(43413,1206,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ',0),(43414,1206,'es','Error eliminando nombre de unidad',0),(43415,1206,'de','Fehler lÃ¶schen GerÃ¤tename',0),(43416,1206,'en','Error deleting unit name',0),(43417,1207,'is','',0),(43418,1207,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù ÙƒØ§Ø±Ø¨Ø± ',0),(43419,1207,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù ÙƒØ§Ø±Ø¨Ø± ',0),(43420,1207,'tr','Hata silme kullanÄ±cÄ±',0),(43421,1207,'pl','BÅ‚Ä…d usuwania uÅ¼ytkownika',0),(43422,1207,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(43423,1207,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ ØµØ§Ø±Ù',0),(43424,1207,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾Ð³',0),(43425,1207,'vi','XÃ³a NgÆ°á»i Sá»­ Dá»¥ng Bá»‹ Lá»—i',0),(43426,1207,'af','Fout met skrap van gebruiker',0),(43427,1207,'ro','Eroare stergere utilizator',0),(43428,1207,'et','Kasutaja kustutamisel tekkis viga',0),(43429,1207,'si','Napaka brisanja uporabnika',0),(43430,1207,'ba','Error menghapus pengguna',0),(43431,1207,'nl','Fout verwijderen gebruiker',0),(43432,1207,'fi','Virhe poistettaessa kÃ¤yttÃ¤jÃ¤',0),(43433,1207,'no','Feil slette brukeren',0),(43434,1207,'da','Fejl slette bruger',0),(43435,1207,'ko','ì˜¤ë¥˜ ì‚­ì œ ì‚¬ìš©ìž',0),(43436,1207,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ž×©×ª×ž×©',0),(43437,1207,'el','Î›Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï‡ÏÎ®ÏƒÏ„Î·',0),(43438,1207,'zh','é”™è¯¯åˆ é™¤ç”¨æˆ·\r\n',0),(43439,1207,'sv','Fel ta bort anvÃ¤ndare',0),(43440,1207,'it','Eliminazione utente errore',0),(43441,1207,'tl','',0),(43442,1207,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(43443,1207,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(43444,1207,'ms','Ralat Menghapuskan pengguna',0),(43445,1207,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(43446,1207,'fr','Erreur suppression utilisateur',0),(43447,1207,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43448,1207,'pt','Excluindo usuÃ¡rio erro',0),(43449,1207,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(43450,1207,'es','Error eliminando usuario',0),(43451,1207,'de','Fehler lÃ¶schen von Benutzer',0),(43452,1207,'en','Error deleting user',0),(43453,1208,'is','',0),(43454,1208,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(43455,1208,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(43456,1208,'tr','Hata silme satÄ±cÄ±',0),(43457,1208,'pl','BÅ‚Ä…d usuwania dostawcy',0),(43458,1208,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(43459,1208,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(43460,1208,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(43461,1208,'vi','Lá»—i xÃ³a ngÆ°á»i bÃ¡n',0),(43462,1208,'af','Fout skrap handelaar',0),(43463,1208,'ro','Eroare ÅŸtergerea furnizor',0),(43464,1208,'et','Tarnija kustutamisel tekkis viga',0),(43465,1208,'si','Brisanje napake dobavitelja',0),(43466,1208,'ba','Error menghapus Penjual',0),(43467,1208,'nl','Fout verwijderen leverancier',0),(43468,1208,'fi','Virhe poistettaessa toimittajan',0),(43469,1208,'no','Feil slette leverandÃ¸r',0),(43470,1208,'da','Fejl slette leverandÃ¸r',0),(43471,1208,'ko','ì˜¤ë¥˜ ì‚­ì œ ê³µê¸‰ ì—…ì²´',0),(43472,1208,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×¡×¤×§',0),(43473,1208,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(43474,1208,'zh','é”™è¯¯åˆ é™¤ä¾›åº”å•†',0),(43475,1208,'sv','Misstag utplÃ¥nande leverantÃ¶r',0),(43476,1208,'it','Fornitore di eliminazione di errore',0),(43477,1208,'tl','',0),(43478,1208,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(43479,1208,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(43480,1208,'ms','Ralat Menghapuskan Penjual',0),(43481,1208,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(43482,1208,'fr','Fournisseur de suppression erreur',0),(43483,1208,'jp','æ¥­è€…ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43484,1208,'pt','Fornecedor de erro excluindo',0),(43485,1208,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(43486,1208,'es','Error eliminando Proveedor',0),(43487,1208,'de','Fehler lÃ¶schen Anbieter',0),(43488,1208,'en','Error deleting vendor',0),(43489,1209,'is','',0),(43490,1209,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(43491,1209,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(43492,1209,'tr','Hata silme iÅŸ tÃ¼rÃ¼.',0),(43493,1209,'pl','Usuwanie bÅ‚Ä™dÃ³w typu pracy.',0),(43494,1209,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿.',0),(43495,1209,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©Ø§Ù… Ù‚Ø³Ù… ÛÛ’ Û”',0),(43496,1209,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°.',0),(43497,1209,'vi','Lá»—i xÃ³a loáº¡i cÃ´ng viá»‡c',0),(43498,1209,'af','Skrap werk fouttipe.',0),(43499,1209,'ro','Eroare ÅŸtergerea tip de munca.',0),(43500,1209,'et','TÃµrge kustutamisel tÃ¶Ã¶ liik.',0),(43501,1209,'si','Brisanje dela vrsta napake.',0),(43502,1209,'ba','Error menghapus jenis pekerjaan.',0),(43503,1209,'nl','Fout verwijderen werksoort.',0),(43504,1209,'fi','Virhe poistettaessa tyÃ¶tyyppi.',0),(43505,1209,'no','Feil slette arbeidstype.',0),(43506,1209,'da','Fejl slette arbejdstype.',0),(43507,1209,'ko','ì˜¤ë¥˜ ì‚­ì œ ìž‘ì—… í˜•ì‹ìž…ë‹ˆë‹¤.',0),(43508,1209,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×¡×•×’ ×¢×‘×•×“×”.',0),(43509,1209,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚.',0),(43510,1209,'zh','é”™è¯¯åˆ é™¤å·¥ä½œç±»åž‹ã€‚',0),(43511,1209,'sv','Misstag utplÃ¥nande arbetstyp.',0),(43512,1209,'it','Tipo di lavoro eliminazione errore.',0),(43513,1209,'tl','',0),(43514,1209,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(43515,1209,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°à¥¤',0),(43516,1209,'ms','Ralat Menghapuskan jenis kerja.',0),(43517,1209,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„.',0),(43518,1209,'fr','Type d\'erreur suppression de travail.',0),(43519,1209,'jp','ä»•äº‹å†…å®¹ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43520,1209,'pt','Tipo de trabalho excluindo erro.',0),(43521,1209,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹.',0),(43522,1209,'es','Error eliminando tipo de trabajo',0),(43523,1209,'de','Fehler lÃ¶schen Arbeitstyp.',0),(43524,1209,'en','Error deleting work type.',0),(43525,1210,'is','',0),(43526,1210,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø³ÙˆØ§Ù„ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(43527,1210,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø³ÙˆØ§Ù„ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(43528,1210,'tr','Ä°ÅŸ tÃ¼rÃ¼ soru silme hatasÄ±.',0),(43529,1210,'pl','BÅ‚Ä…d usuwania pracy typu pytanie.',0),(43530,1210,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð²ÑŠÐ¿Ñ€Ð¾Ñ.',0),(43531,1210,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©Ø§Ù… Ù‚Ø³Ù… Ø³ÙˆØ§Ù„ ÛÛ’ Û”',0),(43532,1210,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ€Ð°Ð´ Ð¾Ñ‚ÐºÑƒÑ†Ð°Ñ˜Ñ‚Ðµ Ð¿Ð¸Ñ‚Ð°ÑšÐµ.',0),(43533,1210,'vi','XÃ³a loáº¡i cÃ¢u há»i bá»‹ lá»—i',0),(43534,1210,'af','Fout met skrap van werktipe vraag.',0),(43535,1210,'ro','Eroare ÅŸtergerea de lucru tip Ã®ntrebare.',0),(43536,1210,'et','TÃµrge kustutamisel tÃ¶Ã¶ tÃ¼Ã¼bi kÃ¼simus.',0),(43537,1210,'si','Napaka brisanja dela vrsto vpraÅ¡anje.',0),(43538,1210,'ba','Error menghapus kerja jenis pertanyaan.',0),(43539,1210,'nl','Fout verwijderen werk type vraag.',0),(43540,1210,'fi','Virhe poistettaessa tyÃ¶tÃ¤ Kirjoita kysymys.',0),(43541,1210,'no','Feil slette arbeid type spÃ¸rsmÃ¥l.',0),(43542,1210,'da','Fejl slette arbejde type spÃ¸rgsmÃ¥l.',0),(43543,1210,'ko','ì˜¤ë¥˜ ì‚­ì œ ìž‘ì—… ìœ í˜• ì§ˆë¬¸ìž…ë‹ˆë‹¤.',0),(43544,1210,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×©××œ×ª ×¡×•×’ ×¢×‘×•×“×”.',0),(43545,1210,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÏƒÏ†Î¬Î»Î¼Î± Ï„ÏÏ€Î¿Ï… ÎµÏÏŽÏ„Î·ÏƒÎ·.',0),(43546,1210,'zh','é”™è¯¯åˆ é™¤å·¥ä½œç±»åž‹çš„é—®é¢˜ã€‚',0),(43547,1210,'sv','Misstag utplÃ¥nande arbete typ frÃ¥ga.',0),(43548,1210,'it','Domanda di tipo lavoro eliminazione errore.',0),(43549,1210,'tl','',0),(43550,1210,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3588;&#3635;&#3606;&#3634;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(43551,1210,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¥à¤°à¤¶à¥à¤¨à¥¤',0),(43552,1210,'ms','Ralat Menghapuskan kerja jenis soalan.',0),(43553,1210,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø³Ø¤Ø§Ù„ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„.',0),(43554,1210,'fr','Erreur suppression travail type question.',0),(43555,1210,'jp','ä»•äº‹å†…å®¹è³ªå•?ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(43556,1210,'pt','Erro excluindo tipo pergunta de trabalho.',0),(43557,1210,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð²Ð¾Ð¿Ñ€Ð¾ÑÐ° Ð¿Ð¾ Ñ‚Ð¸Ð¿Ñƒ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹.',0),(43558,1210,'es','Error eliminando cuestiÃ³n de tipo de trabajo',0),(43559,1210,'de','Fehler lÃ¶schen von Arbeit-Typ-Frage.',0),(43560,1210,'en','Error deleting work type question.',0),(43561,1211,'is','',0),(43562,1211,'dr','Ø®Ø·Ø§ â€“ ØªØ®ÙÙŠÙ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨ÙŠØ´ØªØ± Ø§Ø² ØµØ¯ Ø¯Ø± ØµØ¯ Ø¨Ø§Ø´Ø¯ ',0),(43563,1211,'pr','Ø®Ø·Ø§ â€“ ØªØ®ÙÙŠÙ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨ÙŠØ´ØªØ± Ø§Ø² ØµØ¯ Ø¯Ø± ØµØ¯ Ø¨Ø§Ø´Ø¯ ',0),(43564,1211,'tr','Hata - % 100 indirim geÃ§emez',0),(43565,1211,'pl','BÅ‚Ä…d - zniÅ¼ki nie moÅ¼e przekraczaÄ‡ 100%',0),(43566,1211,'bg','Ð“Ñ€ÐµÑˆÐºÐ° - Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°Ñ‚Ð° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð´Ñ…Ð²ÑŠÑ€Ð»Ñ 100 %',0),(43567,1211,'ur','Ù†Ù‚Øµ - 100% Ø±Ø¹Ø§ÛŒØª Ø³Û’ ØªØ¬Ø§ÙˆØ² Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(43568,1211,'sr','Ð“Ñ€ÐµÑˆÐºÐ° - Ð¿Ð¾Ð¿ÑƒÑÑ‚ Ð½Ðµ Ð¼Ð¾Ð³Ñƒ Ð¿Ñ€ÐµÐ¼Ð°ÑˆÐ¸Ñ‚Ð¸ 100%',0),(43569,1211,'vi','Lá»—i - chiáº¿t kháº¥u khÃ´ng thá»ƒ hÆ¡n 100%',0),(43570,1211,'af','Fout - Korting kan nie 100% oorskry nie',0),(43571,1211,'ro','Eroare - reducere nu poate depÄƒÅŸi 100%',0),(43572,1211,'et','Viga - allahindlus ei saa Ã¼letada 100%',0),(43573,1211,'si','Napaka - popust ne sme preseÄi 100 %',0),(43574,1211,'ba','Kesalahan - diskon tidak dapat melebihi 100%',0),(43575,1211,'nl','Fout - korting kan niet meer bedragen dan 100%',0),(43576,1211,'fi','Virhe - alennus ei voi ylittÃ¤Ã¤ 100 %',0),(43577,1211,'no','Feil - rabatt kan ikke overstige 100%',0),(43578,1211,'da','Fejl - rabat kan ikke overstige 100%',0),(43579,1211,'ko','ì˜¤ë¥˜-í• ì¸ 100%ë¥¼ ì´ˆê³¼í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(43580,1211,'he','×©×’×™××” - ×”×–×•×œ×™× ×‘×™×•×ª×¨ ×œ× ×™×¢×œ×” ×¢×œ 100%',0),(43581,1211,'el','Î£Ï†Î¬Î»Î¼Î± - Î­ÎºÏ€Ï„Ï‰ÏƒÎ· Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï…Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ Ï„Î¿ 100%',0),(43582,1211,'zh','é”™è¯¯ -æŠ˜æ‰£ä¸èƒ½è¶…è¿‡100ï¼…',0),(43583,1211,'sv','Fel - rabatt kan inte Ã¶verstiga 100%',0),(43584,1211,'it','Errore - sconto non puÃ² superare il 100%',0),(43585,1211,'tl','',0),(43586,1211,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604; - &#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3585;&#3636;&#3609; 100 %',0),(43587,1211,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ - 100% à¤›à¥‚à¤Ÿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(43588,1211,'ms','Ralat - diskaun tidak boleh melebihi 100%',0),(43589,1211,'ar','Ø®Ø·Ø£ - Ø§Ù„ØªØ®ÙÙŠØ¶ Ù„Ø§ ÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ÙŠØªØ¬Ø§ÙˆØ² Ø§Ù„ 100%',0),(43590,1211,'fr','Erreur - rabais ne doit pas dÃ©passer 100 %',0),(43591,1211,'jp','ã‚¨ãƒ©ãƒ¼ã€€ãƒ‡ã‚£ã‚¹ã‚«ã‚¦ãƒ³ãƒˆã?¯ï¼‘ï¼?ï¼?ï¼…ã‚’ä¸Šå›žã‚Œã?¾ã?›ã‚“',0),(43592,1211,'pt','Erro - o desconto nÃ£o pode exceder 100%',0),(43593,1211,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° - Ð¡ÐºÐ¸Ð´ÐºÐ° Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ ÑÐ¾ÑÑ‚Ð°Ð²Ð»ÑÑ‚ÑŒ 100%',0),(43594,1211,'es','Error - Descuento no puede exceder 100%',0),(43595,1211,'de','Fehler - Rabatt kann nicht 100 % Ã¼berschreiten',0),(43596,1211,'en','Error - Discount cannot exceed 100%',0),(43597,1212,'is','',0),(43598,1212,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø¬Ø¯ÙˆÙ„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ ',0),(43599,1212,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø¬Ø¯ÙˆÙ„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ ',0),(43600,1212,'tr','Hata bÄ±rakarak tablo gltransaction.',0),(43601,1212,'pl','BÅ‚Ä…d upuszczanie tabela gltransaction.',0),(43602,1212,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ñ‚Ð¿Ð°Ð´Ð°Ð½Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° gltransaction.',0),(43603,1212,'ur','Ù†Ù‚Øµ Ø¢Ù†Û’ Ú©ÛŒ Ù…ÛŒØ² Ú©Ø§ Ú¯Ù„Ù¹Ø±Ø§Ù†Ø³Ú©Ø´Ù† ÛÛ’ Û”',0),(43604,1212,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ð°Ð´Ð° ÑÑ‚Ð¾ Ð³Ð»Ñ‚Ñ€Ð°Ð½ÑÐ°Ñ†Ñ‚Ð¸Ð¾Ð½.',0),(43605,1212,'vi','Lá»—i báº£ng bá» xuá»‘ng cho giao dá»‹ch sá»• cÃ¡i',0),(43606,1212,'af','Fout met \"dropping\" tabel agtransaksie.',0),(43607,1212,'ro','Eroare dropping tabelul gltransaction.',0),(43608,1212,'et','TÃµrge kukkumine tabel gltransaction.',0),(43609,1212,'si','Napaka kapljanje tabelo gltransaction.',0),(43610,1212,'ba','Kesalahan menjatuhkan meja gltransaction.',0),(43611,1212,'nl','Fout dropping tabel gltransaction.',0),(43612,1212,'fi','Virhe pudottamalla taulukon gltransaction.',0),(43613,1212,'no','Feil slippe tabellen gltransaction.',0),(43614,1212,'da','Fejl faldende bordet gltransaction.',0),(43615,1212,'ko','ì˜¤ë¥˜ ì‚­ì œ í…Œì´ë¸” gltransactionìž…ë‹ˆë‹¤.',0),(43616,1212,'he','×©×’×™××” ×œ×¦× ×™×—×ª ×©×•×œ×—×Ÿ gltransaction.',0),(43617,1212,'el','Î£Ï†Î¬Î»Î¼Î± ÏÎ¯ÏˆÎ· Ï€Î¯Î½Î±ÎºÎ± gltransaction.',0),(43618,1212,'zh','é”™è¯¯æ»´è¡¨å†°å·äº¤æ˜“ã€‚',0),(43619,1212,'sv','Fel slÃ¤ppa tabellen gltransaction.',0),(43620,1212,'it','Errore drop table gltransaction.',0),(43621,1212,'tl','',0),(43622,1212,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3607;&#3636;&#3657;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; GL',0),(43623,1212,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤›à¥‹à¤¡à¤¼à¤¨à¥‡ à¤Ÿà¥‡à¤¬à¤² gltransaction.',0),(43624,1212,'ms','Ralat menjatuhkan Jadual gltransaction.',0),(43625,1212,'ar','Ø®Ø·Ø£ Ø¥Ø³Ù‚Ø§Ø· Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø¬Ù„ØªØ±Ø§Ù†Ø³Ø§ÙƒØ´Ù†.',0),(43626,1212,'fr','Erreur suppression table gltransaction.',0),(43627,1212,'jp','Error dropping table gltransaction.',0),(43628,1212,'pt','Erro caindo tabela gltransaction.',0),(43629,1212,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ gltransaction.',0),(43630,1212,'es','Error bajando tabla de transaccion de LM',0),(43631,1212,'de','Fehler lÃ¶schen Tabelle Gltransaction.',0),(43632,1212,'en','Error dropping table gltransaction.',0),(43633,1213,'is','',0),(43634,1213,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø¬Ø¯ÙˆÙ„ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(43635,1213,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø¬Ø¯ÙˆÙ„ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(43636,1213,'tr','Hata bÄ±rakarak tablo fiÅŸ.',0),(43637,1213,'pl','BÅ‚Ä…d upuszczanie tabela zaÅ‚Ä…cznika.',0),(43638,1213,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ñ‚Ð¿Ð°Ð´Ð°Ð½Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€.',0),(43639,1213,'ur','Ù†Ù‚Øµ Ø¢Ù†Û’ Ú©ÛŒ Ù…ÛŒØ² ÙˆØ§Ø¤Ú†Ø± ÛÛ’ Û”',0),(43640,1213,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ð°Ð´Ð° ÑÑ‚Ð¾ Ð²Ð°ÑƒÑ‡ÐµÑ€.',0),(43641,1213,'vi','Lá»—i báº£ng phiáº¿u bá» xuá»‘ng ',0),(43642,1213,'af','Fout val tabel bewys.',0),(43643,1213,'ro','Eroare dropping tabel voucher.',0),(43644,1213,'et','TÃµrge kukkumine tabeli kanne.',0),(43645,1213,'si','Napaka kapljanje tabela voucher.',0),(43646,1213,'ba','Kesalahan menjatuhkan tabel voucher.',0),(43647,1213,'nl','Fout dropping tabel voucher.',0),(43648,1213,'fi','Virhe pudottamalla taulukon tosite.',0),(43649,1213,'no','Feil slippe tabellen bilaget.',0),(43650,1213,'da','Fejl faldende bordet voucher.',0),(43651,1213,'ko','ì˜¤ë¥˜ ì‚­ì œ í…Œì´ë¸” ë°”ìš°ì²˜ìž…ë‹ˆë‹¤.',0),(43652,1213,'he','×©×’×™××” ×œ×¦× ×™×—×ª ×‘×˜×‘×œ×” ×©×•×‘×¨.',0),(43653,1213,'el','Î£Ï†Î¬Î»Î¼Î± ÏÎ¯ÏˆÎ· Ï€Î¯Î½Î±ÎºÎ± ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹.',0),(43654,1213,'zh','è¡¨é”™è¯¯æ»´åˆ¸ã€‚',0),(43655,1213,'sv','Fel slÃ¤ppa tabellen verifikationen.',0),(43656,1213,'it','Voucher di errore drop table.',0),(43657,1213,'tl','',0),(43658,1213,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3607;&#3636;&#3657;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(43659,1213,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤›à¥‹à¤¡à¤¼à¤¨à¥‡ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤µà¤¾à¤‰à¤šà¤°à¥¤',0),(43660,1213,'ms','Ralat menjatuhkan Jadual baucer.',0),(43661,1213,'ar','Ø®Ø·Ø£ Ø¥Ø³Ù‚Ø§Ø· Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø¥ÙŠØµØ§Ù„.',0),(43662,1213,'fr','Erreur suppression table piÃ¨ce justificative.',0),(43663,1213,'jp','Error dropping table voucher.',0),(43664,1213,'pt','Comprovante de tabela de cair o erro.',0),(43665,1213,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð²Ð°ÑƒÑ‡ÐµÑ€.',0),(43666,1213,'es','Error bajando voucher de tabla',0),(43667,1213,'de','Fehler lÃ¶schen Tabelle Gutschein.',0),(43668,1213,'en','Error dropping table voucher.',0),(43669,1214,'is','',0),(43670,1214,'dr','Ø®Ø·Ø§ÙŠ Ù†Ù‡Ø§ÙŠÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ â€“ ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø¯Ø± Ù…Ø­Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(43671,1214,'pr','Ø®Ø·Ø§ÙŠ Ù†Ù‡Ø§ÙŠÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ â€“ ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø¯Ø± Ù…Ø­Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(43672,1214,'tr','Hata sipariÅŸ tamamlanÄ±yor. SeÃ§ilen konumda ana Ã¶ÄŸe yok',0),(43673,1214,'pl','BÅ‚Ä…d miarÄ™ zamÃ³wienia. GÅ‚Ã³wny element nie istnieje w wybranej lokalizacji',0),(43674,1214,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð²ÑŠÑ€ÑˆÐ¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ñ€ÐµÐ´. Ð“Ð»Ð°Ð²ÐµÐ½ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð² Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¾Ñ‚Ð¾ Ð¼ÑÑÑ‚Ð¾',0),(43675,1214,'ur','Ù†Ù‚Øµ ÙÙ†Ø§Ù„ÛŒØ²Ø§Ù†Ú¯ Ú©ÛŒ ØªØ±ØªÛŒØ¨ ÛÛ’ Û” Ù…Ø§Ø³Ù¹Ø± Ø´Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø± Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(43676,1214,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð”Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°. Ð“Ð»Ð°Ð²Ð½Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð½Ð° Ð¾Ð´Ð°Ð±Ñ€Ð°Ð½Ð¾Ñ˜ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸',0),(43677,1214,'vi','Lá»—i khi káº¿t thÃºc Ä‘Æ¡n Ä‘áº·t hÃ ng. Máº·t hÃ ng chá»§ khÃ´ng cÃ³ á»Ÿ vá»‹ trÃ­ Ä‘Ã£ chá»n',0),(43678,1214,'af','Fout Finaliseer tans orde. Meester item bestaan nie by die gekose ligging',0),(43679,1214,'ro','Eroare de finalizarea comenzii. Element de maestru nu existÄƒ la locaÅ£ia aleasÄƒ',0),(43680,1214,'et','TÃµrge valmimas jÃ¤rjekorras. Kapten Ã¼ksust pole valitud asukohas',0),(43681,1214,'si','Napaka zakljuÄevanja nalog. Glavni element ne obstaja na izbrani lokaciji',0),(43682,1214,'ba','Kesalahan Praptono Order. Master item tidak ada di lokasi pilihan',0),(43683,1214,'nl','Fout beÃ«indigen volgorde. Stramienitem bestaat niet op de gekozen locatie',0),(43684,1214,'fi','Virhe viimeistelemÃ¤Ã¤n tilaus. PÃ¤Ã¤nimikkeen ei ole valitulle alueelle',0),(43685,1214,'no','Feil fullfÃ¸re bestillingen. Malobjekt finnes ikke pÃ¥ valgt sted',0),(43686,1214,'da','Fejl afsluttende rÃ¦kkefÃ¸lge. Masterelement findes ikke pÃ¥ valgte placering',0),(43687,1214,'ko','ì˜¤ë¥˜ ë§ˆë¬´ë¦¬ ìˆœì„œìž…ë‹ˆë‹¤. ë§ˆìŠ¤í„° í•­ëª© ì„ íƒí•œ ìœ„ì¹˜ì— ì¡´ìž¬ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(43688,1214,'he','×©×’×™××” ×”×©×œ×ž×ª ×”×”×–×ž× ×”. ×¤×¨×™×˜ ×”×ž××¡×˜×¨ ×œ× ×§×™×™× ×‘×ž×™×§×•× ×©×‘×—×¨×ª.',0),(43689,1214,'el','ÎŸÏÎ¹ÏƒÏ„Î¹ÎºÎ¿Ï€Î¿Î¯Î·ÏƒÎ· ÏƒÎµÎ¹ÏÎ¬ ÏƒÏ†Î¬Î»Î¼Î±. Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï… ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¸Î­ÏƒÎ·',0),(43690,1214,'zh','é”™è¯¯å®šåž‹ç§©åºã€‚ä¸»ç®¡é¡¹ç›®ä¸å­˜åœ¨é€‰æ‹©çš„ä½ç½®',0),(43691,1214,'sv','Fel slutfÃƒÂ¶rande ordning. Mallobjekt finns inte pÃ¥ den valda platsen',0),(43692,1214,'it','Errore portando ordine. Elemento principale non esiste presso la localitÃ  scelta',0),(43693,1214,'tl','',0),(43694,1214,'th','Error Finalizing Order. Master item does not exist at chosen location',0),(43695,1214,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥à¤°à¤® à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¥‡à¤¨à¥‡à¥¤ à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤†à¤‡à¤Ÿà¤® à¤šà¥à¤¨à¥‡ à¤¹à¥à¤ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤° à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(43696,1214,'ms','Ralat memuktamadkan perintah. Item induk tidak wujud pilihan lokasi',0),(43697,1214,'ar','Ø®Ø·Ø£ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ©. Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ ÙÙŠ Ø§Ù„Ù…ÙƒØ§Ù† Ø§Ù„Ø°ÙŠ Ø§Ø®ØªØ±ØªÙ‡',0),(43698,1214,'fr','Erreur commande finalisation. Ã‰lÃ©ment maÃ®tre n\'existe pas Ã  l\'endroit choisi',0),(43699,1214,'jp','æ³¨æ–‡ã?®å®Œäº†ã‚¨ãƒ©ãƒ¼ã€‚ãƒžã‚¹ã‚¿ãƒ¼å“?ç›®ã?Œé?¸æŠžã?•ã‚Œã?Ÿãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?«å­˜åœ¨ã?—ã?¾ã?›ã‚“ã€‚',0),(43700,1214,'pt','Ordem de finalizaÃ§Ã£o de erro. Item-mestre nÃ£o existir no local escolhido',0),(43701,1214,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð°. Ð“Ð»Ð°Ð²Ð½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð² Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð¼ Ð¼ÐµÑÑ‚Ðµ',0),(43702,1214,'es','Error Finalizando Orden. Item maestro no existe en la colocaciÃ³n seleccionada',0),(43703,1214,'de','Fehler beendenden bestellen. Musterelement ist am gewÃ¤hlten Standort nicht vorhanden.',0),(43704,1214,'en','Error Finalizing Order. Master item does not exist at chosen location',0),(43705,1215,'is','',0),(43706,1215,'dr','Ø®Ø·Ø§ÙŠ Ù†Ù‡Ø§ÙŠÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ â€“ ÙƒØ§Ù„Ø§ÙŠ ÙØ±Ø¹ÙŠ Ø¯Ø± Ù…Ø­Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(43707,1215,'pr','Ø®Ø·Ø§ÙŠ Ù†Ù‡Ø§ÙŠÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ â€“ ÙƒØ§Ù„Ø§ÙŠ ÙØ±Ø¹ÙŠ Ø¯Ø± Ù…Ø­Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(43708,1215,'tr','Hata sipariÅŸ tamamlanÄ±yor. SeÃ§ilen konumda alt Ã¶ÄŸesi yok',0),(43709,1215,'pl','BÅ‚Ä…d miarÄ™ zamÃ³wienia. Sub element nie istnieje w wybranej lokalizacji',0),(43710,1215,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð²ÑŠÑ€ÑˆÐ¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ñ€ÐµÐ´. ÐŸÐ¾Ð´ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð² Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¾Ñ‚Ð¾ Ð¼ÑÑÑ‚Ð¾',0),(43711,1215,'ur','Ù†Ù‚Øµ ÙÙ†Ø§Ù„ÛŒØ²Ø§Ù†Ú¯ Ú©ÛŒ ØªØ±ØªÛŒØ¨ ÛÛ’ Û” Ø°ÛŒÙ„ÛŒ Ø´Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø± Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(43712,1215,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð”Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°. ÐŸÐ¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð½Ð° Ð¾Ð´Ð°Ð±Ñ€Ð°Ð½Ð¾Ñ˜ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸',0),(43713,1215,'vi','Lá»—i khi káº¿t thÃºc Ä‘Æ¡n Ä‘áº·t hÃ ng. Máº·t hÃ ng phá»¥ khÃ´ng cÃ³ á»Ÿ vá»‹ trÃ­ Ä‘Ã£ chá»n',0),(43714,1215,'af','Fout Finaliseer tans orde. Sub-item bestaan nie by die gekose ligging',0),(43715,1215,'ro','Eroare de finalizarea comenzii. Sub elementul nu existÄƒ la locaÅ£ia aleasÄƒ',0),(43716,1215,'et','TÃµrge valmimas jÃ¤rjekorras. Sub Ã¼ksust pole valitud asukohas',0),(43717,1215,'si','Napaka zakljuÄevanja nalog. Sub element ne obstaja na izbrani lokaciji',0),(43718,1215,'ba','Kesalahan Praptono Order. Sub item tidak ada di lokasi pilihan',0),(43719,1215,'nl','Fout beÃ«indigen volgorde. Sub object bestaat niet op de gekozen locatie',0),(43720,1215,'fi','Virhe viimeistelemÃ¤Ã¤n tilaus. Sub kohdetta ei ole haluamillesi sijainnissa',0),(43721,1215,'no','Feil fullfÃ¸re bestillingen. Sub-elementet finnes ikke pÃ¥ valgt sted',0),(43722,1215,'da','Fejl afsluttende rÃ¦kkefÃ¸lge. Sub element findes ikke pÃ¥ valgte placering',0),(43723,1215,'ko','ì˜¤ë¥˜ ë§ˆë¬´ë¦¬ ìˆœì„œìž…ë‹ˆë‹¤. í•˜ìœ„ í•­ëª© ì„ íƒí•œ ìœ„ì¹˜ì— ì¡´ìž¬ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(43724,1215,'he','×©×’×™××” ×”×©×œ×ž×ª ×”×”×–×ž× ×”. ×¡××‘ ×”×¤×¨×™×˜ ××™× ×• ×§×™×™× ×‘×ž×™×§×•× ×©×‘×—×¨×ª.',0),(43725,1215,'el','ÎŸÏÎ¹ÏƒÏ„Î¹ÎºÎ¿Ï€Î¿Î¯Î·ÏƒÎ· ÏƒÎµÎ¹ÏÎ¬ ÏƒÏ†Î¬Î»Î¼Î±. Î¥Ï€Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¸Î­ÏƒÎ·',0),(43726,1215,'zh','é”™è¯¯å®šåž‹ç§©åºã€‚å­é¡¹ä¸å­˜åœ¨é€‰æ‹©çš„ä½ç½®',0),(43727,1215,'sv','Fel slutfÃƒÂ¶rande ordning. Sub objektet finns inte pÃ¥ den valda platsen',0),(43728,1215,'it','Errore portando ordine. Sub elemento non esiste presso la localitÃ  scelta',0),(43729,1215,'tl','',0),(43730,1215,'th','Error Finalizing Order. Sub item does not exist at chosen location',0),(43731,1215,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥à¤°à¤® à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¥‡à¤¨à¥‡à¥¤ à¤‰à¤ª à¤†à¤‡à¤Ÿà¤® à¤šà¥à¤¨à¥‡ à¤¹à¥à¤ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤° à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(43732,1215,'ms','Ralat memuktamadkan perintah. Perkara kecil tidak wujud pilihan lokasi',0),(43733,1215,'ar','Ø®Ø·Ø£ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ©. Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„ÙØ±Ø¹ÙŠ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ ÙÙŠ Ø§Ù„Ù…ÙƒØ§Ù† Ø§Ù„Ø°ÙŠ Ø§Ø®ØªØ±ØªÙ‡',0),(43734,1215,'fr','Erreur commande finalisation. Void Ã©lÃ©ment n\'existe pas Ã  l\'endroit choisi',0),(43735,1215,'jp','æ³¨æ–‡ã?®å®Œäº†ã‚¨ãƒ©ãƒ¼ã€‚ã‚µãƒ–å“?ç›®ã?Œé?¸æŠžã?•ã‚Œã?Ÿãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?«å­˜åœ¨ã?—ã?¾ã?›ã‚“ã€‚',0),(43736,1215,'pt','Ordem de finalizaÃ§Ã£o de erro. Sub item nÃ£o existir no local escolhido',0),(43737,1215,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð°. ÐŸÐ¾Ð´Ð¿ÑƒÐ½ÐºÑ‚ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð½Ð° Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð¼ Ð¼ÐµÑÑ‚Ðµ',0),(43738,1215,'es','Error Finalizando Orden. Sub-Item no existe en la colocaciÃ³n seleccionada',0),(43739,1215,'de','Fehler beendenden bestellen. Sub-Element ist am gewÃ¤hlten Standort nicht vorhanden.',0),(43740,1215,'en','Error Finalizing Order. Sub item does not exist at chosen location',0),(43741,1216,'is','',0),(43742,1216,'dr',': ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø§Ø³Øª ',0),(43743,1216,'pr','Ø®Ø·Ø§ : ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø§Ø³Øª ',0),(43744,1216,'tr','Hata: Mali tarihinden baÅŸlayan mali bitiÅŸ tarihinden sonraki',0),(43745,1216,'pl','BÅ‚Ä…d: Podatkowych rozpoczÄ™cia data jest po dacie zakoÅ„czenia fiskalnych',0),(43746,1216,'bg','Ð“Ñ€ÐµÑˆÐºÐ°: Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð½Ðµ Ð´Ð°Ñ‚Ð° Ðµ ÑÐ»ÐµÐ´ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð¸ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(43747,1216,'ur','Ù†Ù‚Øµ: Ù…Ø§Ù„ÛŒ Ú©Ø§ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Û’ Ø¨Ø¹Ø¯ Ù…Ø§Ù„ÛŒ Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ® ÛÛ’',0),(43748,1216,'sr','Ð“Ñ€ÐµÑˆÐºÐ° : Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð¿Ð¾Ñ‡ÐµÑ‚Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð°ÐºÐ¾Ð½ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ðµ',0),(43749,1216,'vi','Lá»—i: NgÃ y báº¯t Ä‘áº§u nÄƒm tÃ i chÃ­nh sau ngÃ y káº¿t thÃºc',0),(43750,1216,'af','Fout:  Fisiese Begindatum is na Fisiese End Datum',0),(43751,1216,'ro','Eroare: Fiscal incepe data este dupÄƒ data de Ã®ncheiere fiscale',0),(43752,1216,'et','TÃµrge: Fiscal alustada kuupÃ¤ev on pÃ¤rast eelarve lÃµppkuupÃ¤ev',0),(43753,1216,'si','Napaka: Poslovno zaÄetni datum je po fiskalne konÄni datum',0),(43754,1216,'ba','Kesalahan: Fiskal mulai tanggal setelah tanggal akhir fiskal',0),(43755,1216,'nl','Fout: Fiscale beginnen datum is na fiscale einddatum',0),(43756,1216,'fi','Virhe: Tilikauden alkamispÃ¤ivÃ¤ on verotuksen pÃ¤Ã¤ttymispÃ¤ivÃ¤Ã¤',0),(43757,1216,'no','Feil: RegnskapsÃ¥ret begynner dato etter sluttdatoen for regnskapsÃ¥ret',0),(43758,1216,'da','Fejl: Finanspolitisk begynde dato er efter finanspolitiske slutdato',0),(43759,1216,'ko','ì˜¤ë¥˜: íšŒê³„ ì—°ë„ ì‹œìž‘ ë‚ ì§œëŠ” íšŒê³„ ì—°ë„ ì¢…ë£Œì¼ í›„',0),(43760,1216,'he','×©×’×™××”: ×”×›×¡×¤×™× ×ž×ª×—×™×œ×™× ×ª××¨×™×š ×œ××—×¨ ×ª××¨×™×š ×¡×™×•× ×©× ×ª ×›×¡×¤×™×',0),(43761,1216,'el','Î£Ï†Î¬Î»Î¼Î±: Î¤Î¿ Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î±ÏÏ‡Î¯ÏƒÎµÎ¹ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ¯Î½Î±Î¹ Î¼ÎµÏ„Î¬ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï„Î¿Ï… Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ¿Ï',0),(43762,1216,'zh','é”™è¯¯ï¼šè´¢æ”¿å¼€å§‹æ—¥æœŸåœ¨è´¢æ”¿ç»“æŸæ—¥æœŸåŽ',0),(43763,1216,'sv','Fel: Skatte bÃ¶rjar dagen efter rÃ¤kenskapsÃ¥rets slutdatum',0),(43764,1216,'it','Errore: Fiscale cominciano data dopo Data fine fiscale',0),(43765,1216,'tl','',0),(43766,1216,'th','Error: Fiscal begin date is after fiscal end date',0),(43767,1216,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿: à¤µà¤¿à¤¤à¥à¤¤ à¤†à¤°à¤‚à¤­ à¤¤à¤¿à¤¥à¤¿ à¤µà¤¿à¤¤à¥à¤¤à¥€à¤¯ à¤µà¤°à¥à¤· à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¹à¥ˆ',0),(43768,1216,'ms','Ralat: Fiskal mula tarikh selepas tarikh akhir fiskal',0),(43769,1216,'ar','Ø®Ø·Ø£: Ø§Ù„Ù…Ø§Ù„ÙŠØ© ØªØ¨Ø¯Ø£ ØªØ§Ø±ÙŠØ® Ø¨Ø¹Ø¯ ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(43770,1216,'fr','Erreur : Exercice commencer date aprÃ¨s la date de fin exercice',0),(43771,1216,'jp','ã‚¨ãƒ©ãƒ¼ï¼šä¼šè¨ˆå¹´åº¦é–‹å§‹æ—¥ã?Œä¼šè¨ˆå¹´åº¦çµ‚äº†æ—¥ã‚ˆã‚Šã‚‚å¾Œã?§ã?™',0),(43772,1216,'pt','Erro: Fiscal iniciar data Ã© apÃ³s a data de tÃ©rmino fiscal',0),(43773,1216,'ru','ÐžÑˆÐ¸Ð±ÐºÐ°: Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð¾Ð³Ð¾ Ð¿Ð¾ÑÐ»Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹ ÐºÐ¾Ð½ÐµÑ‡Ð½Ð¾Ð¹ Ð´Ð°Ñ‚Ñ‹',0),(43774,1216,'es','Error: Fecha fiscal de comienza es despuÃ©s de la fecha fiscal final',0),(43775,1216,'de','Fehler: GeschÃ¤ftsjahr beginnen Datum ist nach steuerlichen Enddatum',0),(43776,1216,'en','Error: Fiscal begin date is after fiscal end date',0),(43777,1217,'is','',0),(43778,1217,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ÙØ§ÙƒØªÙˆØ± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(43779,1217,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ÙØ§ÙƒØªÙˆØ± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(43780,1217,'tr','Inv PO ayrÄ±ntÄ± ekleme hatasÄ±',0),(43781,1217,'pl','BÅ‚Ä…d wstawiania INV PO szczegÃ³Å‚y',0),(43782,1217,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð¸Ð½Ð² PO Ð´ÐµÑ‚Ð°Ð¹Ð»',0),(43783,1217,'ur','Ø§Ù†Ùˆ Ù¾Ùˆ ØªÙØµÛŒÙ„ Ø¯Ø§Ø®Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(43784,1217,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ¼ÐµÑ‚Ð°ÑšÑƒ Ð˜ÐÐ’ ÐŸÐž Ð´ÐµÑ‚Ð°Ñ™Ð¸Ð¼Ð°',0),(43785,1217,'vi','Lá»—i khi chÃ¨n chi tiáº¿t hÃ³a Ä‘Æ¡n Ä‘Æ¡n mua hÃ ng',0),(43786,1217,'af','Fout INV PO Detail inbring',0),(43787,1217,'ro','Eroare inserarea detaliu de PO INV',0),(43788,1217,'et','Viga paigaldamisel INV PO Detail',0),(43789,1217,'si','Pri vstavljanju INV PO podrobno',0),(43790,1217,'ba','Kesalahan memasukkan INV PO Detail',0),(43791,1217,'nl','Error invoegen INV PO Detail',0),(43792,1217,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ INV PO yksityiskohtaisesti',0),(43793,1217,'no','Feil under innsetting INV PO detaljer',0),(43794,1217,'da','Fejl indsÃ¦tte INV PO detaljer',0),(43795,1217,'ko','INV í¬ ì„¸ë¶€ ì‚½ìž… ì˜¤ë¥˜',0),(43796,1217,'he','×©×’×™××” ×‘×”×•×¡×¤×ª INV ×¤×• ×¤×™×¨×•×˜',0),(43797,1217,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® INV PO Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(43798,1217,'zh','æ’å…¥è®¢å•çš„è¯¦ç»†é”™è¯¯å‘ç¥¨',0),(43799,1217,'sv','Fel att infoga INV PO detalj',0),(43800,1217,'it','Errore inserimento dettaglio PO INV',0),(43801,1217,'tl','',0),(43802,1217,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3',0),(43803,1217,'hi','INV à¤ªà¥‹ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(43804,1217,'ms','Kesilapan memasukkan butiran PO Songsang',0),(43805,1217,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¯Ø±Ø§Ø¬ \"Ø§Ù„ØªÙØ§ØµÙŠÙ„ Ø¨Ùˆ Ù„Ù„Ø§Ø³ØªØ«Ù…Ø§Ø±Ø§Øª\"',0),(43806,1217,'fr','Erreur insertion INV PO dÃ©tail',0),(43807,1217,'jp','è«‹æ±‚æ›¸ç™ºæ³¨æ›¸è©³ç´°ã?®æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(43808,1217,'pt','Erro inserindo INV PO detalhe',0),(43809,1217,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ PO Ð´ÐµÑ‚Ð°Ð»Ð¸ INV',0),(43810,1217,'es','Error insertando Detalle de INV OC',0),(43811,1217,'de','Fehler einfÃ¼gen INV-PO-Detail',0),(43812,1217,'en','Error inserting INV PO Detail',0),(43813,1218,'is','',0),(43814,1218,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(43815,1218,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(43816,1218,'tr','PO ekleme hatasÄ±',0),(43817,1218,'pl','BÅ‚Ä…d wstawiania PO',0),(43818,1218,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð½Ð° PO',0),(43819,1218,'ur','Ù¾Ùˆ Ø¯Ø§Ø®Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(43820,1218,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ¼ÐµÑ‚Ð°ÑšÑƒ ÐŸÐž',0),(43821,1218,'vi','ChÃ¨n ÄÆ¡n Mua HÃ ng Bá»‹ Lá»—i',0),(43822,1218,'af','Fout invoeging PO',0),(43823,1218,'ro','Eroare inserarea PO',0),(43824,1218,'et','Viga paigaldamisel PO',0),(43825,1218,'si','Pri vstavljanju PO',0),(43826,1218,'ba','Kesalahan memasukkan PO',0),(43827,1218,'nl','Error invoegen PO',0),(43828,1218,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ PO',0),(43829,1218,'no','Feil under innsetting PO',0),(43830,1218,'da','Fejl indsÃ¦tte PO',0),(43831,1218,'ko','í¬ ì‚½ìž… ì˜¤ë¥˜',0),(43832,1218,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×¤×•',0),(43833,1218,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® PO',0),(43834,1218,'zh','é”™è¯¯æ’å…¥è®¢å•\r\n',0),(43835,1218,'sv','Fel att infoga PO',0),(43836,1218,'it','Errore inserimento PO',0),(43837,1218,'tl','',0),(43838,1218,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(43839,1218,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥‹ à¤¡à¤¾à¤²à¤¨à¥‡',0),(43840,1218,'ms','Kesilapan memasukkan PO',0),(43841,1218,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¯Ø±Ø§Ø¬ Ø¨Ùˆ',0),(43842,1218,'fr','Erreur insertion PO',0),(43843,1218,'jp','POæŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(43844,1218,'pt','Erro de inserÃ§Ã£o de PO',0),(43845,1218,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ PO',0),(43846,1218,'es','Error insertando OC',0),(43847,1218,'de','Fehler PO einfÃ¼gen',0),(43848,1218,'en','Error inserting PO',0),(43849,1219,'is','',0),(43850,1219,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙØ§ÙƒØªÙˆØ± ',0),(43851,1219,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙØ§ÙƒØªÙˆØ± ',0),(43852,1219,'tr','Hata ekleme fatura',0),(43853,1219,'pl','BÅ‚Ä…d wstawiania faktury',0),(43854,1219,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(43855,1219,'ur','Ù†Ù‚Øµ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¯Ø§Ø®Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(43856,1219,'sr','Ð“Ñ€ÐµÑˆÐºÐ° ÑƒÐ¼ÐµÑ‚Ð°ÑšÐµÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(43857,1219,'vi','Lá»—i khi chÃ¨n hÃ³a Ä‘Æ¡n',0),(43858,1219,'af','Fout invoeging faktuur',0),(43859,1219,'ro','Eroare inserarea facturÄƒ',0),(43860,1219,'et','Viga lisamine arve',0),(43861,1219,'si','Napaka Vstavljanje raÄuna',0),(43862,1219,'ba','Kesalahan memasukkan faktur',0),(43863,1219,'nl','Fout invoegen factuur',0),(43864,1219,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ laskun',0),(43865,1219,'no','Feil Ã¥ sette inn faktura',0),(43866,1219,'da','Fejl indsÃ¦tte faktura',0),(43867,1219,'ko','ì˜¤ë¥˜ ì‚½ìž… ì†¡ìž¥',0),(43868,1219,'he','×—×©×‘×•× ×™×ª ×”×•×¡×¤×ª ×”×©×’×™××”',0),(43869,1219,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(43870,1219,'zh','é”™è¯¯æ’å…¥å‘ç¥¨',0),(43871,1219,'sv','Fel infoga faktura',0),(43872,1219,'it','Inserimento fattura di errore',0),(43873,1219,'tl','',0),(43874,1219,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(43875,1219,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¡à¤¾à¤²à¤¨à¥‡ à¤šà¤¾à¤²à¤¾à¤¨',0),(43876,1219,'ms','Kesilapan memasukkan invois',0),(43877,1219,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(43878,1219,'fr','Facture insertion d\'erreur',0),(43879,1219,'jp','è«‹æ±‚æ›¸ã?®æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(43880,1219,'pt','Inserindo faturas erro',0),(43881,1219,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð²Ð¾Ð´Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(43882,1219,'es','Error insertando factura',0),(43883,1219,'de','Fehler EinfÃ¼gen von Rechnung',0),(43884,1219,'en','Error inserting invoice',0),(43885,1220,'is','',0),(43886,1220,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ÙØ§ÙƒØªÙˆØ± ',0),(43887,1220,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ÙØ§ÙƒØªÙˆØ± ',0),(43888,1220,'tr','Hata ekleme fatura ayrÄ±ntÄ±larÄ±',0),(43889,1220,'pl','BÅ‚Ä…d wstawiania SzczegÃ³Å‚y faktury',0),(43890,1220,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(43891,1220,'ur','Ù†Ù‚Øµ Ø§Ù†ÙˆØ§Ø¦Ø³ ØªÙØµÛŒÙ„Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(43892,1220,'sr','Ð“Ñ€ÐµÑˆÐºÐ° ÑƒÐ¼ÐµÑ‚Ð°ÑšÐµÐ¼ Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(43893,1220,'vi','Lá»—i khi chÃ¨n chi tiáº¿t hÃ³a Ä‘Æ¡n',0),(43894,1220,'af','Invoeging van faktuur foutdetails',0),(43895,1220,'ro','Eroare inserarea detalii facturÄƒ',0),(43896,1220,'et','Viga lisamine arve Ã¼ksikasjad',0),(43897,1220,'si','Vstavljanje podrobnosti raÄuna napaka',0),(43898,1220,'ba','Kesalahan memasukkan rincian faktur',0),(43899,1220,'nl','Fout Factuurdetails invoegen',0),(43900,1220,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ laskutustiedot',0),(43901,1220,'no','Feil sette Fakturaopplysninger',0),(43902,1220,'da','Fejl indsÃ¦tte Fakturadetaljer',0),(43903,1220,'ko','ì˜¤ë¥˜ ì‚½ìž… ì¸ë³´ì´ìŠ¤ ì„¸ë¶€ ì‚¬í•­',0),(43904,1220,'he','×©×’×™××” ×”×•×¡×¤×ª ×¤×¨×˜×™ ×—×©×‘×•× ×™×ª',0),(43905,1220,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î¤Î¹Î¼Î¿Î»',0),(43906,1220,'zh','é”™è¯¯æ’å…¥å‘ç¥¨æ˜Žç»†',0),(43907,1220,'sv','Fel infoga Fakturadetaljer',0),(43908,1220,'it','Dettagli di errore inserimento fattura',0),(43909,1220,'tl','',0),(43910,1220,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3',0),(43911,1220,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¡à¤¾à¤²à¤¨à¥‡ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤µà¤¿à¤µà¤°à¤£',0),(43912,1220,'ms','Butiran invois memasukkan ralat',0),(43913,1220,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¯Ø±Ø§Ø¬ ØªÙØ§ØµÙŠÙ„ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(43914,1220,'fr','DÃ©tail de facture insertion erreur',0),(43915,1220,'jp','è«‹æ±‚æ›¸è©³ç´°ã?®æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(43916,1220,'pt','Detalhes do erro inserindo factura',0),(43917,1220,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð²Ð¾Ð´Ðµ Ð´ÐµÑ‚Ð°Ð»ÐµÐ¹ ÑÑ‡ÐµÑ‚Ð°',0),(43918,1220,'es','Error insertando detalles de factura',0),(43919,1220,'de','EinfÃ¼gen von Rechnung Fehlerdetails.',0),(43920,1220,'en','Error inserting invoice details',0),(43921,1221,'is','',0),(43922,1221,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙØ§ÙƒØªÙˆØ± ',0),(43923,1221,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙØ§ÙƒØªÙˆØ± ',0),(43924,1221,'tr','Fatura not ekleme hatasÄ±.',0),(43925,1221,'pl','BÅ‚Ä…d wstawiania Uwaga faktury.',0),(43926,1221,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°.',0),(43927,1221,'ur','Ù†Ù‚Øµ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÙˆÙ¹ Ø¯Ø§Ø®Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(43928,1221,'sr','Ð“Ñ€ÐµÑˆÐºÐ° ÑƒÐ¼ÐµÑ‚Ð°ÑšÐµÐ¼ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ.',0),(43929,1221,'vi','Lá»—i khi chÃ¨n ghi chÃº hÃ³a Ä‘Æ¡n',0),(43930,1221,'af','Fout invoeging faktuur nota.',0),(43931,1221,'ro','Eroare Inserare notÄƒ de facturÄƒ.',0),(43932,1221,'et','Viga lisamine arve MÃ¤rkus.',0),(43933,1221,'si','Vstavljanje napaka raÄunov Opomba.',0),(43934,1221,'ba','Kesalahan memasukkan faktur catatan.',0),(43935,1221,'nl','Fout invoegen factuur opmerking.',0),(43936,1221,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ laskun huomautus.',0),(43937,1221,'no','Feil sette fakturaen Merk.',0),(43938,1221,'da','Fejl indsÃ¦tte faktura note.',0),(43939,1221,'ko','ì˜¤ë¥˜ ì‚½ìž… ì†¡ìž¥ ì°¸ê³ ìž…ë‹ˆë‹¤.',0),(43940,1221,'he','×©×’×™××” ×”×•×¡×¤×ª ×”×¢×¨×” ×—×©×‘×•× ×™×ª.',0),(43941,1221,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·.',0),(43942,1221,'zh','é”™è¯¯æ’å…¥å‘ç¥¨æ³¨è®°ã€‚',0),(43943,1221,'sv','Fel infoga Faktura notering.',0),(43944,1221,'it','Nota di fattura inserendo errore.',0),(43945,1221,'tl','',0),(43946,1221,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(43947,1221,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¡à¤¾à¤²à¤¨à¥‡ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¥‹à¤Ÿà¥¤',0),(43948,1221,'ms','Kesilapan memasukkan invois Nota.',0),(43949,1221,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¯Ø±Ø§Ø¬ Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø©.',0),(43950,1221,'fr','Insertion Remarque erreur de facture.',0),(43951,1221,'jp','è«‹æ±‚æ›¸ãƒ¡ãƒ¢ã?®æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(43952,1221,'pt','Inserir nota de fatura erro.',0),(43953,1221,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ ÑÑ‡ÐµÑ‚Ð° ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ.',0),(43954,1221,'es','Error insertando nota de factura',0),(43955,1221,'de','Fehler EinfÃ¼gen von Rechnung-Hinweis.',0),(43956,1221,'en','Error inserting invoice note.',0),(43957,1222,'is','',0),(43958,1222,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø§Ù„ÙŠØ§Øª ÙØ§ÙƒØªÙˆØ± ',0),(43959,1222,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø§Ù„ÙŠØ§Øª ÙØ§ÙƒØªÙˆØ± ',0),(43960,1222,'tr','Fatura vergi ayrÄ±ntÄ±larÄ± ekleme hatasÄ±.',0),(43961,1222,'pl','BÅ‚Ä…d wstawiania faktury szczegÃ³Å‚y podatku.',0),(43962,1222,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸.',0),(43963,1222,'ur','Ù†Ù‚Øµ Ø¯Ø§Ø®Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Û”',0),(43964,1222,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¾ Ð³Ñ€ÐµÑˆÑ†Ð¸ ÑƒÐ¼ÐµÑ‚Ð°ÑšÐµÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¿Ð¾Ñ€ÐµÐ·Ð°.',0),(43965,1222,'vi','Lá»—i khi chÃ¨n chi tiáº¿t thuáº¿ hÃ³a Ä‘Æ¡n',0),(43966,1222,'af','Invoeging van faktuur belasting Foutbesonderhede.',0),(43967,1222,'ro','Introducerea facturii fiscale detaliile de eroare.',0),(43968,1222,'et','Viga lisamine arve kÃ¤ibemaksu Ã¼ksikasju.',0),(43969,1222,'si','Podrobnosti o napaki Vstavljanje raÄuna davek.',0),(43970,1222,'ba','Kesalahan memasukkan faktur pajak rincian.',0),(43971,1222,'nl','Fout invoegen factuur belasting details.',0),(43972,1222,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ vero laskutustiedot.',0),(43973,1222,'no','Feil Ã¥ sette inn faktura-detaljer.',0),(43974,1222,'da','Fejl indsÃ¦tte skat Fakturadetaljer.',0),(43975,1222,'ko','ì˜¤ë¥˜ ì‚½ìž… ì†¡ìž¥ ì„¸ê¸ˆ ì •ë³´ìž…ë‹ˆë‹¤.',0),(43976,1222,'he','×”×•×¡×¤×ª ×—×©×‘×•× ×™×ª ×ž×¡ ×¤×¨×˜×™ ×©×’×™××”.',0),(43977,1222,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Ï†ÏŒÏÎ¿Ï… Î¤Î¹Î¼Î¿Î».',0),(43978,1222,'zh','é”™è¯¯æ’å…¥å‘ç¥¨ç¨Žçš„ç»†èŠ‚',0),(43979,1222,'sv','Fel infoga skatt Fakturadetaljer.',0),(43980,1222,'it','Errore inserimento fattura fiscale i dettagli.',0),(43981,1222,'tl','',0),(43982,1222,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3616;&#3634;&#3625;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3',0),(43983,1222,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¡à¤¾à¤²à¤¨à¥‡ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤° à¤µà¤¿à¤µà¤°à¤£à¥¤',0),(43984,1222,'ms','Memasukkan invois cukai butiran ralat.',0),(43985,1222,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¯Ø±Ø§Ø¬ ØªÙØ§ØµÙŠÙ„ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©.',0),(43986,1222,'fr','Erreur insertion facture de taxe.',0),(43987,1222,'jp','è«‹æ±‚æ›¸ç¨Žè©³ç´°ã?®æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(43988,1222,'pt','Inserindo factura fiscal detalhes do erro.',0),(43989,1222,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾ ÑÑ‡ÐµÑ‚Ðµ.',0),(43990,1222,'es','Error insertando detalles de impuesto de factura',0),(43991,1222,'de','EinfÃ¼gen von Rechnung Steuer Fehlerdetails.',0),(43992,1222,'en','Error inserting invoice tax details.',0),(43993,1223,'is','',0),(43994,1223,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(43995,1223,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(43996,1223,'tr','SipariÅŸ notlar ekleme hatasÄ±',0),(43997,1223,'pl','BÅ‚Ä…d wstawiania notatek zamÃ³wienia',0),(43998,1223,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(43999,1223,'ur','Ø¢Ø±ÚˆØ± Ù†ÙˆÙ¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(44000,1223,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ¼ÐµÑ‚Ð°ÑšÑƒ Ñ€ÐµÐ´ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(44001,1223,'vi','Lá»—i khi chÃ¨n ghi chÃº cá»§a Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(44002,1223,'af','Fout met invoeging van bestellingsnotas',0),(44003,1223,'ro','Eroare inserarea de note de comanda',0),(44004,1223,'et','Tellimuse mÃ¤rkuste lisamisel tÃµrge',0),(44005,1223,'si','Pri vstavljanju naloga ugotavlja',0),(44006,1223,'ba','Kesalahan memasukkan urutan catatan',0),(44007,1223,'nl','Error volgorde notities invoegen',0),(44008,1223,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tilaa notes',0),(44009,1223,'no','Feil under innsetting bestille notater',0),(44010,1223,'da','Fejl indsÃ¦ttelse ordre noter',0),(44011,1223,'ko','ì£¼ë¬¸ ë©”ëª¨ ì‚½ìž… ì˜¤ë¥˜',0),(44012,1223,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×”×¢×¨×•×ª',0),(44013,1223,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÎµÎ¹ÏÎ¬ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(44014,1223,'zh','ä¸ºäº†æ’å…¥æ³¨é‡Šé”™è¯¯',0),(44015,1223,'sv','Fel att infoga ordning anteckningar',0),(44016,1223,'it','Errore inserimento note ordine',0),(44017,1223,'tl','',0),(44018,1223,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(44019,1223,'hi','à¤†à¤¦à¥‡à¤¶ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(44020,1223,'ms','Kesilapan memasukkan Nota-Nota pesanan',0),(44021,1223,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø£Ù…Ø±',0),(44022,1223,'fr','Erreur insertion d\'informations sur la commande',0),(44023,1223,'jp','æ³¨æ–‡ãƒ¡ãƒ¢ã?®æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(44024,1223,'pt','Erro de inserÃ§Ã£o de notas de fim',0),(44025,1223,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(44026,1223,'es','Error insertando notas de ordenes',0),(44027,1223,'de','Fehler Reihenfolge Noten einfÃ¼gen',0),(44028,1223,'en','Error inserting order notes',0),(44029,1224,'is','',0),(44030,1224,'dr','Ø®Ø·Ø§ â€“ Ù…Ø­Ù„ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(44031,1224,'pr','Ø®Ø·Ø§ â€“ Ù…Ø­Ù„ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(44032,1224,'tr','Hata - konum zaten',0),(44033,1224,'pl','JuÅ¼ wystÄ™puje bÅ‚Ä…d - lokalizacja',0),(44034,1224,'bg','Ð“Ñ€ÐµÑˆÐºÐ° - Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(44035,1224,'ur','Ù†Ù‚Øµ - Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Ùˆ Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(44036,1224,'sr','Ð“Ñ€ÐµÑˆÐºÐ° - Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(44037,1224,'vi','Lá»—i - vá»‹ trÃ­ Ä‘Ã£ cÃ³',0),(44038,1224,'af','Fout - Ligging Bestaan Alreeds',0),(44039,1224,'ro','Eroare - locaÅ£ie existÄƒ deja',0),(44040,1224,'et','Viga - asukoht on juba olemas',0),(44041,1224,'si','Napaka - mesto Å¾e obstaja',0),(44042,1224,'ba','Kesalahan - lokasi yang sudah ada',0),(44043,1224,'nl','Fout - locatie bestaat al',0),(44044,1224,'fi','Virhe - sijainti on jo olemassa',0),(44045,1224,'no','Feil - plasseringen finnes allerede',0),(44046,1224,'da','Fejl - placering findes allerede',0),(44047,1224,'ko','ì˜¤ë¥˜-ìœ„ì¹˜ëŠ” ì´ë¯¸ ì¡´ìž¬',0),(44048,1224,'he','×©×’×™××” - ×ž×™×§×•× ×§×™×™× ×›×‘×¨',0),(44049,1224,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· ÏƒÏ†Î¬Î»Î¼Î± - Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(44050,1224,'zh','é”™è¯¯- ä½ç½®å·²å­˜åœ¨',0),(44051,1224,'sv','Fel - platsen finns redan',0),(44052,1224,'it','Errore - posizione esiste giÃ ',0),(44053,1224,'tl','',0),(44054,1224,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604; &#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;',0),(44055,1224,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ - à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(44056,1224,'ms','Ralat - lokasi telah wujud',0),(44057,1224,'ar','Ø®Ø·Ø£- Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(44058,1224,'fr','Erreur - emplacement existe dÃ©jÃ ',0),(44059,1224,'jp','ã‚¨ãƒ©ãƒ¼/ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(44060,1224,'pt','Erro - localizaÃ§Ã£o jÃ¡ existe',0),(44061,1224,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° - ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð£Ð¶Ðµ Ð¡Ð¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ÑÑ',0),(44062,1224,'es','Error - UbicaciÃ³n ya existe',0),(44063,1224,'de','Fehler - Ort vorhanden',0),(44064,1224,'en','Error - Location Already Exists',0),(44065,1225,'is','',0),(44066,1225,'dr','Ø®Ø·Ø§ ÙŠ Ù¾ÙŠØºØ§Ù…',0),(44067,1225,'pr','Ø®Ø·Ø§ ÙŠ Ù¾ÙŠØºØ§Ù…',0),(44068,1225,'tr','Hata iletisi',0),(44069,1225,'pl','Komunikat o bÅ‚Ä™dzie',0),(44070,1225,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð·Ð° Ð³Ñ€ÐµÑˆÐºÐ°',0),(44071,1225,'ur','Ø®Ø§Ù…ÛŒ Ú©Ø§ ÛŒÛ Ù¾ÛŒØºØ§Ù…',0),(44072,1225,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐ° Ð¾ Ð³Ñ€ÐµÑˆÑ†Ð¸',0),(44073,1225,'vi','Tin nháº¯n bá»‹ lá»—i',0),(44074,1225,'af','Fout boodskap',0),(44075,1225,'ro','Mesaj de eroare',0),(44076,1225,'et','TÃµrketeade',0),(44077,1225,'si','SporoÄilo o napaki',0),(44078,1225,'ba','Pesan kesalahan',0),(44079,1225,'nl','Foutbericht',0),(44080,1225,'fi','Virhesanoma',0),(44081,1225,'no','Feilmelding',0),(44082,1225,'da','Fejlmeddelelse',0),(44083,1225,'ko','ì˜¤ë¥˜ ë©”ì‹œì§€',0),(44084,1225,'he','×”×•×“×¢×ª ×©×’×™××”',0),(44085,1225,'el','ÎœÎ®Î½Ï…Î¼Î± Î»Î¬Î¸Î¿Ï…Ï‚',0),(44086,1225,'zh','é”™è¯¯ä¿¡æ¯',0),(44087,1225,'sv','Felmeddelande',0),(44088,1225,'it','Messaggio di errore',0),(44089,1225,'tl','',0),(44090,1225,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(44091,1225,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(44092,1225,'ms','Mesej ralat',0),(44093,1225,'ar','Ø±Ø³Ø§Ù„Ø© Ø§Ù„Ø¥Ø¹Ù„Ø§Ù… Ø¨Ø§Ù„Ø®Ø·Ø£',0),(44094,1225,'fr','Message d\'erreur',0),(44095,1225,'jp','ã‚¨ãƒ©ãƒ¼ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(44096,1225,'pt','Mensagem de erro',0),(44097,1225,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(44098,1225,'es','Mensaje de error',0),(44099,1225,'de','Fehlermeldung',0),(44100,1225,'en','Error message',0),(44101,1226,'is','',0),(44102,1226,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(44103,1226,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(44104,1226,'tr','Hata deftere nakil fiÅŸ',0),(44105,1226,'pl','BÅ‚Ä…d wysyÅ‚ania zaÅ‚Ä…cznikÃ³w',0),(44106,1226,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(44107,1226,'ur','Ù†Ù‚Øµ Ù¾ÙˆØ³Ù¹Ù†Ú¯ ÙˆØ§Ø¤Ú†Ø±',0),(44108,1226,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(44109,1226,'vi','Lá»—i khi káº¿t chuyá»ƒn phiáº¿u',0),(44110,1226,'af','Fout het ingesluip met Pos van bewysstuk',0),(44111,1226,'ro','Bonul de Ã®nregistrare eroare',0),(44112,1226,'et','TÃµrge sisestuse kanne',0),(44113,1226,'si','Napake knjiÅ¾enja kupon',0),(44114,1226,'ba','Kesalahan posting voucher',0),(44115,1226,'nl','Fout terbeschikkingstelling voucher',0),(44116,1226,'fi','Virhe Kirjaustosite',0),(44117,1226,'no','Feil Posteringsbilag',0),(44118,1226,'da','Fejl bogfÃ¸ring af kassebilag',0),(44119,1226,'ko','ì˜¤ë¥˜ ê²Œì‹œ ë°”ìš°ì²˜',0),(44120,1226,'he','×©×•×‘×¨ ×©×œ ×¨×™×©×•× ×©×’×™××•×ª',0),(44121,1226,'el','Î£Ï†Î¬Î»Î¼Î± Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ· ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(44122,1226,'zh','é”™è¯¯é‚®å¯„ä»˜æ¬¾å‡­è¯',0),(44123,1226,'sv','Fel bokfÃ¶ring verifikation',0),(44124,1226,'it','Giustificativo registrazione errore',0),(44125,1226,'tl','',0),(44126,1226,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(44127,1226,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤— à¤µà¤¾à¤‰à¤šà¤°',0),(44128,1226,'ms','Ralat hantar baucer',0),(44129,1226,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ±Ø­ÙŠÙ„ Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(44130,1226,'fr','Bon affichage erreur',0),(44131,1226,'jp','ä¼?ç¥¨è¨ˆä¸Šã‚¨ãƒ©ãƒ¼',0),(44132,1226,'pt','Comprovante de postagem de erro',0),(44133,1226,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ñ€Ð°Ð·Ð½Ð¾ÑÐºÐ¸ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(44134,1226,'es','Error asentando el voucher',0),(44135,1226,'de','Fehler Buchung Gutschein',0),(44136,1226,'en','Error posting voucher',0),(44137,1227,'is','',0),(44138,1227,'dr','( Ø³Ø§Ø¨Ù‚Ù‡',0),(44139,1227,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¯Ø±ÙŠØ§ÙØª Ø«Ø¨Øª ( Ø³Ø§Ø¨Ù‚Ù‡',0),(44140,1227,'tr','KayÄ±t hatasÄ± alÄ±rsÄ±nÄ±z.',0),(44141,1227,'pl','BÅ‚Ä…d otrzymujÄ… rekord.',0),(44142,1227,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ.',0),(44143,1227,'ur','Ù†Ù‚Øµ ÙˆØµÙˆÙ„ Ø±ÛŒÚ©Ø§Ø±Úˆ ÛÛ’ Û”',0),(44144,1227,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼ Ð´Ð¾ÑÐ¸Ñ˜Ðµ.',0),(44145,1227,'vi','Lá»—i nháº­n há»“ sÆ¡',0),(44146,1227,'af','Fout ontvang rekord.',0),(44147,1227,'ro','Eroare primi record.',0),(44148,1227,'et','Viga saada kirje.',0),(44149,1227,'si','Napaka prejeli zapis.',0),(44150,1227,'ba','Kesalahan menerima catatan.',0),(44151,1227,'nl','Fout ontvangen record.',0),(44152,1227,'fi','Virhe saada ennÃ¤tys.',0),(44153,1227,'no','Feil motta post.',0),(44154,1227,'da','Fejl modtage post.',0),(44155,1227,'ko','ì˜¤ë¥˜ ë ˆì½”ë“œë¥¼ ë°›ì„.',0),(44156,1227,'he','×©×’×™××” ×§×‘×œ×” ×¨×©×•×ž×”.',0),(44157,1227,'el','Î£Ï†Î¬Î»Î¼Î± Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ ÏÎµÎºÏŒÏ.',0),(44158,1227,'zh','é”™è¯¯æŽ¥æ”¶è®°å½•ã€‚',0),(44159,1227,'sv','Fel fÃ¥ post.',0),(44160,1227,'it','Errore di ricezione record.',0),(44161,1227,'tl','',0),(44162,1227,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;',0),(44163,1227,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(44164,1227,'ms','Ralat menerima rekod.',0),(44165,1227,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„Ø³Ø¬Ù„.',0),(44166,1227,'fr','Erreur recevez l\'appelant.',0),(44167,1227,'jp','è¨˜éŒ²ã?®å?—ä¿¡ã‚¨ãƒ©ãƒ¼',0),(44168,1227,'pt','Erro receber registro.',0),(44169,1227,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸.',0),(44170,1227,'es','Error en la recepciÃ³n de record',0),(44171,1227,'de','Fehlermeldung Datensatz.',0),(44172,1227,'en','Error receive record.',0),(44173,1228,'is','',0),(44174,1228,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(44175,1228,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(44176,1228,'tr','Hata alma bÃ¼tÃ§e haberdar etmek.',0),(44177,1228,'pl','BÅ‚Ä…d pobierania informacji budÅ¼etu.',0),(44178,1228,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°.',0),(44179,1228,'ur','Ù†Ù‚Øµ Ø¨Ø¬Ù¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’ Û”',0),(44180,1228,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð±ÑƒÑŸÐµÑ‚Ð° ÑÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°Ð¼Ð°.',0),(44181,1228,'vi','Lá»—i nháº­n thÃ´ng tin ngÃ¢n sÃ¡ch',0),(44182,1228,'af','Fout met herwinning van begrotingsinligting.',0),(44183,1228,'ro','Eroare preluare bugetul info.',0),(44184,1228,'et','TÃµrge allalaadimisel eelarve info.',0),(44185,1228,'si','Napaka pri pridobivanju proraÄuna info.',0),(44186,1228,'ba','Kesalahan mengambil anggaran info.',0),(44187,1228,'nl','Fout ophalen begroting info.',0),(44188,1228,'fi','Virhe noudettaessa talousarvion info.',0),(44189,1228,'no','Feil ved henting av budsjett-info.',0),(44190,1228,'da','Fejl under hentning af budgettet info.',0),(44191,1228,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ì˜ˆì‚° ì •ë³´ìž…ë‹ˆë‹¤.',0),(44192,1228,'he','×©×’×™××” ×‘××—×–×•×¨ ×ž×™×“×¢ ×ª×§×¦×™×‘.',0),(44193,1228,'el','Î‘Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(44194,1228,'zh','é”™è¯¯æ£€ç´¢é¢„ç®—ä¿¡æ¯ã€‚',0),(44195,1228,'sv','Fel hÃ¤mtar budget info.',0),(44196,1228,'it','Info preventivo recupero di errore.',0),(44197,1228,'tl','',0),(44198,1228,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3591;&#3610;&#3611;&#3619;&#3632;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(44199,1228,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤²à¤¾à¤¤à¥‡ à¤¸à¤®à¤¯ à¤¬à¤œà¤Ÿ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€à¥¤',0),(44200,1228,'ms','Ralat mendapatkan semula maklumat bajet.',0),(44201,1228,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø³ØªØ±Ø¯Ø§Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(44202,1228,'fr','Info budgÃ©taire rÃ©cupÃ©ration par erreur.',0),(44203,1228,'jp','äºˆç®—æƒ…å ±ã‚’å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(44204,1228,'pt','InformaÃ§Ã£o de orÃ§amento recuperaÃ§Ã£o de erro.',0),(44205,1228,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¸Ð½Ñ„Ð¾ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°.',0),(44206,1228,'es','Error recogiendo info de presupuesto',0),(44207,1228,'de','Fehler beim Abrufen des Budget-Info.',0),(44208,1228,'en','Error retrieving budget info.',0),(44209,1229,'is','',0),(44210,1229,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(44211,1229,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(44212,1229,'tr','YapÄ± sipariÅŸi bilgileri alÄ±nÄ±rken hata oluÅŸtu.',0),(44213,1229,'pl','BÅ‚Ä…d podczas pobierania informacji o zamÃ³wieniu budowy.',0),(44214,1229,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°.',0),(44215,1229,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ Û”',0),(44216,1229,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³.',0),(44217,1229,'vi','Lá»—i khi truy váº¥n thÃ´ng tin ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(44218,1229,'af','Fout herwinning bou orde inligting.',0),(44219,1229,'ro','Eroare la regÄƒsirea construi ordine informaÅ£ii.',0),(44220,1229,'et','Ehitada tellimuse teabe toomisel ilmnes tÃµrge.',0),(44221,1229,'si','Napaka pri pridobivanju graditi bi podatke.',0),(44222,1229,'ba','Kesalahan membangun urutan informasi.',0),(44223,1229,'nl','Fout bij het ophalen van bouwen bestelinformatie.',0),(44224,1229,'fi','Virhe haettaessa rakentaa tilaustiedot.',0),(44225,1229,'no','Feil under henting av bygge ordreinformasjon.',0),(44226,1229,'da','Fejl under hentning af bygge ordreoplysninger.',0),(44227,1229,'ko','ë¹Œë“œ ìˆœì„œ ì •ë³´ë¥¼ ê²€ìƒ‰ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(44228,1229,'he','×©×’×™××” ×‘××—×–×•×¨ ×ž×™×“×¢ ××•×“×•×ª ×”×–×ž× ×•×ª ×œ×‘× ×•×ª.',0),(44229,1229,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î¿Î¹ÎºÎ¿Î´Î¿Î¼Î®ÏƒÎ¿Ï…Î¼Îµ.',0),(44230,1229,'zh','é”™è¯¯æ£€ç´¢æž„å»ºé¡ºåºä¿¡æ¯ã€‚\r\n',0),(44231,1229,'sv','Fel vid hÃ¤mtning av bygga orderinformation.',0),(44232,1229,'it','Errore nel recupero di informazioni di compilazione ordine.',0),(44233,1229,'tl','',0),(44234,1229,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3',0),(44235,1229,'hi','à¤—à¤ à¤¨ à¤†à¤¦à¥‡à¤¶ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(44236,1229,'ms','Ralat mendapatkan perintah membina maklumat.',0),(44237,1229,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª \"ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¨Ù†Ø§Ø¡\".',0),(44238,1229,'fr','Erreur lors de la rÃ©cupÃ©ration des informations de l\'ordre de la gÃ©nÃ©ration.',0),(44239,1229,'jp','çµ„ç«‹æ³¨æ–‡æƒ…å ±ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(44240,1229,'pt','Erro ao recuperar informaÃ§Ãµes de ordem de construir.',0),(44241,1229,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ.',0),(44242,1229,'es','Error recogiendo informaciÃ³n de Orden de ConstrucciÃ³n',0),(44243,1229,'de','Fehler beim Abrufen der Buildreihenfolge Informationen.',0),(44244,1229,'en','Error retrieving Build Order information.',0),(44245,1230,'is','',0),(44246,1230,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(44247,1230,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(44248,1230,'tr','Hata alma mÃ¼ÅŸteriler.',0),(44249,1230,'pl','BÅ‚Ä…d pobierania klientÃ³w.',0),(44250,1230,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸.',0),(44251,1230,'ur','Ù†Ù‚Øµ Ú¯Ø§ÛÚ©ÙˆÚº Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’ Û”',0),(44252,1230,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ ÐºÑƒÐ¿Ñ†Ðµ.',0),(44253,1230,'vi','Lá»—i truy váº¥n khÃ¡ch hÃ ng',0),(44254,1230,'af','Fout met herwinning van KliÃ«nt/Klant',0),(44255,1230,'ro','Eroare preluare clienÅ£ii.',0),(44256,1230,'et','TÃµrge allalaadimisel kÃ¼lastajad.',0),(44257,1230,'si','Napaka pri pridobivanju strank.',0),(44258,1230,'ba','Pelanggan mengambil kesalahan.',0),(44259,1230,'nl','Fout ophalen klanten.',0),(44260,1230,'fi','Virhe noudettaessa asiakkaat.',0),(44261,1230,'no','Feil henting kunder.',0),(44262,1230,'da','Fejl under hentning af kunder.',0),(44263,1230,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ê³ ê°ìž…ë‹ˆë‹¤.',0),(44264,1230,'he','×©×’×™××” ×‘××—×–×•×¨ ×œ×§×•×—×•×ª.',0),(44265,1230,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î½Î¬ÎºÏ„Î·ÏƒÎ·Ï‚ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚.',0),(44266,1230,'zh','é”™è¯¯æ£€ç´¢å®¢æˆ·ã€‚',0),(44267,1230,'sv','Fel hÃ¤mtar kunder.',0),(44268,1230,'it','Clienti di recupero di errore.',0),(44269,1230,'tl','',0),(44270,1230,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(44271,1230,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤²à¤¾à¤¤à¥‡ à¤¸à¤®à¤¯ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚à¥¤',0),(44272,1230,'ms','Ralat mendapatkan semula pelanggan.',0),(44273,1230,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡.',0),(44274,1230,'fr','Clients rÃ©cupÃ©ration d\'erreur.',0),(44275,1230,'jp','é¡§å®¢ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(44276,1230,'pt','Clientes de recuperaÃ§Ã£o de erro.',0),(44277,1230,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð².',0),(44278,1230,'es','Error recogiendo Clientes',0),(44279,1230,'de','Fehler beim Abrufen des Kunden.',0),(44280,1230,'en','Error retrieving customers.',0),(44281,1231,'is','',0),(44282,1231,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ù†Ù‡Ø§ÙŠÙŠ',0),(44283,1231,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ù†Ù‡Ø§ÙŠÙŠ',0),(44284,1231,'tr','Alma hatasÄ± buildorder bilgi sonuÃ§landÄ±rÄ±lmÄ±ÅŸtÄ±r.',0),(44285,1231,'pl','BÅ‚Ä…d pobieranie zakoÅ„czone buildorder informacji.',0),(44286,1231,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½ buildorder Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(44287,1231,'ur','Ø¨Ø§Ù„ÚˆÙˆØ±ÚˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ù…Ù†Ù¹Ø³ Ù†Ù‚Øµ Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’ Û”',0),(44288,1231,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½ Ð±ÑƒÐ¸Ð»Ð´Ð¾Ñ€Ð´ÐµÑ€ Ð¸Ð½Ñ„Ð¾.',0),(44289,1231,'vi','Lá»—i khi truy váº¥n káº¿t thÃºc nháº­p thÃ´ng tin ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(44290,1231,'af','Fout met Herwinning van Gefinaliseerde Geboude Bestellings Inligting',0),(44291,1231,'ro','Eroare recuperare finalizat buildorder info.',0),(44292,1231,'et','Viga Allalaadimine lÃµpetatud buildorder info.',0),(44293,1231,'si','Napaka pri pridobivanju dokonÄno izoblikovati buildorder info.',0),(44294,1231,'ba','Mengambil kesalahan diselesaikan buildorder info.',0),(44295,1231,'nl','Fout ophalen afgerond buildorder info.',0),(44296,1231,'fi','Virhe noudettaessa valmiiksi buildorder info.',0),(44297,1231,'no','Feil hente avsluttet buildorder info.',0),(44298,1231,'da','Fejl under hentning af afsluttet buildorder info.',0),(44299,1231,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ buildorder ì •ë³´ ì™„ë£Œ.',0),(44300,1231,'he','×©×’×™××” ×‘××—×–×•×¨ ×¡×•×¤×™×ª buildorder ×¤×¨×˜×™.',0),(44301,1231,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Î¿ÏÎ¹ÏƒÏ„Î¹ÎºÎ¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ buildorder.',0),(44302,1231,'zh','æœ€ç»ˆæž„å»ºé¡ºåºæ£€ç´¢é”™è¯¯ä¿¡æ¯ã€‚',0),(44303,1231,'sv','Fel hÃ¤mtar avslutat buildorder information.',0),(44304,1231,'it','Recupero di errore finalizzato buildorder informazioni.',0),(44305,1231,'tl','',0),(44306,1231,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3619;&#3640;&#3611;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3',0),(44307,1231,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤° à¤°à¤¹à¤¾ buildorder à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¤¿à¤¯à¤¾à¥¤',0),(44308,1231,'ms','Ralat mengambil masa buildorder info.',0),(44309,1231,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ ÙˆØ¶Ø¹ Ø§Ù„ØµÙŠØºØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© Ù„Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨ÙˆÙŠÙ„Ø¯ÙˆØ±Ø¯ÙŠØ±.',0),(44310,1231,'fr','RÃ©cupÃ©ration d\'erreur finalisÃ© buildorder info.',0),(44311,1231,'jp','å®Œäº†æ¸ˆçµ„ç«‹æ³¨æ–‡æƒ…å ±ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(44312,1231,'pt','Erro Recuperando finalizado buildorder informaÃ§Ã£o.',0),(44313,1231,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾ buildorder Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(44314,1231,'es','Error recogiendo info de Orden de Materiales finalizado',0),(44315,1231,'de','Fehler beim Abrufen finalisierte Buildorder Info.',0),(44316,1231,'en','Error retrieving finalized buildorder info.',0),(44317,1232,'is','',0),(44318,1232,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø§Ø² Ù†Ø±Ø® Ø¯Ø³ØªÙŠØ§Ø¨ÙŠ  Ø´Ø±ÙƒØª\r\nAR',0),(44319,1232,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø§Ø² Ù†Ø±Ø® Ø¯Ø³ØªÙŠØ§Ø¨ÙŠ  Ø´Ø±ÙƒØª\r\nAR',0),(44320,1232,'tr','GL hesaplarÄ± AR ÅŸirketten alÄ±nÄ±rken hata oluÅŸtu.',0),(44321,1232,'pl','BÅ‚Ä…d podczas pobierania GL konta firmy AR.',0),(44322,1232,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° GL ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¾Ñ‚ AR ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ.',0),(44323,1232,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ø§Ù„Ø±Ø­ÛŒÙ‚ Ú©Ù…Ù¾Ù†ÛŒ Ø³Û’ Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ Û”',0),(44324,1232,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ð“Ð› Ð½Ð°Ð»Ð¾Ð³Ðµ ÑÐ° ÐÐ  ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ.',0),(44325,1232,'vi','Truy Cáº­p TK Sá»• CÃ¡i Tá»•ng Há»£p tá»« Cty cÃ³ ná»£ pháº£i thu bá»‹ lá»—i',0),(44326,1232,'af','Fout met herwinning van AG rekeninge van RO Onderneming.',0),(44327,1232,'ro','Eroare la regÄƒsirea GL conturi de companie AR.',0),(44328,1232,'et','TÃµrge allalaadimisel GL raamatupidamise AR firma.',0),(44329,1232,'si','Napaka pri pridobivanju GL raÄunov iz AR podjetje.',0),(44330,1232,'ba','Kesalahan mengambil GL account dari AR perusahaan.',0),(44331,1232,'nl','Fout bij het ophalen van GL rekeningen van AR bedrijf.',0),(44332,1232,'fi','Virhe haettaessa GL tilit AR yritys.',0),(44333,1232,'no','Feil under henting av GL kontoer fra AR selskap.',0),(44334,1232,'da','Fejl under hentning af GL konti fra AR virksomheden.',0),(44335,1232,'ko','AR íšŒì‚¬ì—ì„œ GL ê³„ì •ì„ ê²€ìƒ‰ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(44336,1232,'he','×©×’×™××” ×‘××—×–×•×¨ GL ×—×©×‘×•× ×•×ª ×©×œ ×—×‘×¨×ª AR.',0),(44337,1232,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î±Ï€ÏŒ AR ÎµÏ„Î±Î¹ÏÎµÎ¯Î±.',0),(44338,1232,'zh','é”™è¯¯ä»Žåº”ä»˜è´¦æ¬¾å…¬å¸ä¸­æ£€ç´¢æ€»å¸ä¼šè®¡\r\n',0),(44339,1232,'sv','Fel vid hÃ¤mtning av GL konton frÃ¥n AR fÃ¶retag.',0),(44340,1232,'it','Errore nel recupero conti GL da azienda AR.',0),(44341,1232,'tl','',0),(44342,1232,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3592;&#3634;&#3585;&#3610;&#3',0),(44343,1232,'hi','GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤à¤†à¤° à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥‡ à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(44344,1232,'ms','Ralat mendapatkan akaun GL dari Syarikat AR.',0),(44345,1232,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¬Ù„Ø¨ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ù…Ù† Ù…Ù† Ø´Ø±ÙƒØ©',0),(44346,1232,'fr','Erreur lors de la rÃ©cupÃ©ration des comptes GL d\'AR compagnie.',0),(44347,1232,'jp','ARä¼šç¤¾ã?‹ã‚‰ã?®GLã‚¢ã‚«ã‚¦ãƒ³ãƒˆå?Žé›†ã‚¨ãƒ©ãƒ¼',0),(44348,1232,'pt','Erro ao recuperar contas GL de companhia de AR.',0),(44349,1232,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ð¾Ñ‚ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ AR GL ÑÑ‡ÐµÑ‚Ð¾Ð².',0),(44350,1232,'es','Error recogiendo LM cuentas de CC empresa',0),(44351,1232,'de','Fehler beim Abrufen der GL-Konten von AR-Firma.',0),(44352,1232,'en','Error retrieving GL accounts from AR Company.',0),(44353,1233,'is','',0),(44354,1233,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø­Ù„ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(44355,1233,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø­Ù„ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(44356,1233,'tr','Stok yerleÅŸimlerini alÄ±nÄ±rken hata oluÅŸtu.',0),(44357,1233,'pl','BÅ‚Ä…d podczas pobierania zapasÃ³w w lokalizacji.',0),(44358,1233,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÑÑ‚Ð° Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°.',0),(44359,1233,'ur','Ù†Ù‚Øµ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ù‚Ø§Ù…Ø§Øª Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’ Û”',0),(44360,1233,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°.',0),(44361,1233,'vi','Truy Váº¥n Äá»‹a Äiá»ƒm HÃ ng hÃ³a Bá»‹ Lá»—i',0),(44362,1233,'af','Fout met herwinning van Voorraadligggings',0),(44363,1233,'ro','Eroare la regÄƒsirea inventar locaÅ£ii.',0),(44364,1233,'et','TÃµrge allalaadimisel laoasukohti.',0),(44365,1233,'si','Napaka pri pridobivanju lokacije zalog.',0),(44366,1233,'ba','Kesalahan mengambil persediaan lokasi.',0),(44367,1233,'nl','Fout bij het ophalen van voorraadlocaties.',0),(44368,1233,'fi','Virhe haettaessa varaston varastopaikkoja.',0),(44369,1233,'no','Feil under henting av lagerlokasjoner.',0),(44370,1233,'da','Fejl under hentning af lagerlokationer.',0),(44371,1233,'ko','ìž¬ê³  ìœ„ì¹˜ë¥¼ ê²€ìƒ‰ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(44372,1233,'he','×©×’×™××” ×‘××—×–×•×¨ ×ž×œ××™ ×ž×™×§×•×ž×™×.',0),(44373,1233,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Î¸Î­ÏƒÎ· Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½.',0),(44374,1233,'zh','é”™è¯¯æ£€ç´¢åº“å­˜åœ°ç‚¹',0),(44375,1233,'sv','Fel vid hÃ¤mtning av lagerplatser.',0),(44376,1233,'it','Errore nel recupero di posizioni di inventario.',0),(44377,1233,'tl','',0),(44378,1233,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3',0),(44379,1233,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤•à¥‹ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(44380,1233,'ms','Ralat mendapatkan lokasi inventori.',0),(44381,1233,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†.',0),(44382,1233,'fr','Erreur lors de la rÃ©cupÃ©ration des lieux de l\'inventaire.',0),(44383,1233,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(44384,1233,'pt','Erro ao recuperar posiÃ§Ãµes de inventÃ¡rio.',0),(44385,1233,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¼ÐµÑÑ‚.',0),(44386,1233,'es','Error recogiendo ubicaciones de inventario',0),(44387,1233,'de','Fehler beim Abrufen der Inventar-Standorte.',0),(44388,1233,'en','Error retrieving inventory locations.',0),(44389,1234,'is','',0),(44390,1234,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù„Ø§ ',0),(44391,1234,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù„Ø§ ',0),(44392,1234,'tr','SipariÅŸleri madde alma hatasÄ±.',0),(44393,1234,'pl','BÅ‚Ä…d pobierania elementu zamÃ³wienia.',0),(44394,1234,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸.',0),(44395,1234,'ur','Ù†Ù‚Øµ Ø´Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’ Û”',0),(44396,1234,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ.',0),(44397,1234,'vi','Lá»—i khi truy váº¥n Ä‘Æ¡n Ä‘áº·t hÃ ng theo danh má»¥c',0),(44398,1234,'af','Fout met terugvind van Itembestellings.',0),(44399,1234,'ro','Eroare Preluare comenzi de element.',0),(44400,1234,'et','Tellib kauba toomisel ilmnes tÃµrge.',0),(44401,1234,'si','Napaka pri pridobivanju naroÄil artikel.',0),(44402,1234,'ba','Kesalahan penerimaan barang pesanan',0),(44403,1234,'nl','Fout ophalen item orders.',0),(44404,1234,'fi','Virhe noudettaessa kohteen tilauksia.',0),(44405,1234,'no','Feil under henting av element bestillinger.',0),(44406,1234,'da','Fejl under hentning af elementet ordrer.',0),(44407,1234,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ í•­ëª© ìˆœì„œìž…ë‹ˆë‹¤.',0),(44408,1234,'he','×©×’×™××” ×‘××—×–×•×¨ ×”×–×ž× ×•×ª ×¤×¨×™×˜.',0),(44409,1234,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î½Î¬ÎºÏ„Î·ÏƒÎ·Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚.',0),(44410,1234,'zh','é”™è¯¯æ£€ç´¢é¡¹ç›®çš„è®¢å•',0),(44411,1234,'sv','Fel hÃ¤mtar post order.',0),(44412,1234,'it','Ordini elemento recupero di errore.',0),(44413,1234,'tl','',0),(44414,1234,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(44415,1234,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤†à¤¦à¥‡à¤¶à¥¤',0),(44416,1234,'ms','Ralat mendapatkan semula item pesanan.',0),(44417,1234,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø¹Ù†ØµØ± Ø£ÙˆØ§Ù…Ø±.',0),(44418,1234,'fr','Erreur rÃ©cupÃ©ration point les commandes.',0),(44419,1234,'jp','å“?ç›®æ³¨æ–‡ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(44420,1234,'pt','Ordens de item recuperaÃ§Ã£o de erro.',0),(44421,1234,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð·Ð°ÐºÐ°Ð·Ñ‹.',0),(44422,1234,'es','Error recogiendo ordenes de items',0),(44423,1234,'de','Fehler beim Abrufen des Element-Bestellungen.',0),(44424,1234,'en','Error retrieving item orders.',0),(44425,1235,'is','',0),(44426,1235,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø³Ø·Ø± ÙƒØ§Ù„Ø§Ù‡Ø§',0),(44427,1235,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø³Ø·Ø± ÙƒØ§Ù„Ø§Ù‡Ø§',0),(44428,1235,'tr','SatÄ±r Ã¶ÄŸeleri alÄ±nÄ±rken hata oluÅŸtu',0),(44429,1235,'pl','BÅ‚Ä…d podczas pobierania pozycji',0),(44430,1235,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ Ñ€ÐµÐ´Ð¾Ð²Ðµ',0),(44431,1235,'ur','Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§ Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(44432,1235,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(44433,1235,'vi','Truy váº¥n dÃ²ng hÃ ng bá»‹ lá»—i',0),(44434,1235,'af','Fout met terugvind van lyntems',0),(44435,1235,'ro','Eroare recuperare elemente',0),(44436,1235,'et','Kirjete toomisel tÃµrge',0),(44437,1235,'si','Napaka pri pridobivanju vrstiÄne postavke',0),(44438,1235,'ba','Kesalahan mengambil item baris',0),(44439,1235,'nl','Fout bij het ophalen van regelitems',0),(44440,1235,'fi','Virhe haettaessa rivinimikkeet',0),(44441,1235,'no','Feil under henting av elementer',0),(44442,1235,'da','Fejl under hentning af linjeelementer',0),(44443,1235,'ko','ì˜¤ë¥˜ ë¼ì¸ í•­ëª© ê²€ìƒ‰',0),(44444,1235,'he','×©×’×™××” ×‘××—×–×•×¨ ×¤×¨×™×˜×™ ×©×•×¨×”',0),(44445,1235,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(44446,1235,'zh','é”™è¯¯æ£€ç´¢è¡Œé¡¹ç›®\r\n',0),(44447,1235,'sv','Fel vid hÃ¤mtning av poster',0),(44448,1235,'it','Errore nel recupero di elementi pubblicitari',0),(44449,1235,'tl','',0),(44450,1235,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(44451,1235,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡',0),(44452,1235,'ms','Ralat mendapatkan talian barangan',0),(44453,1235,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø³Ø·Ø±',0),(44454,1235,'fr','Erreur de rÃ©cupÃ©ration des lignes de facturation',0),(44455,1235,'jp','ãƒ©ã‚¤ãƒ³å“?ç›®ã‚’å?Žé›†ã?§ã??ã?¾ã?›ã‚“',0),(44456,1235,'pt','Erro ao recuperar itens de linha',0),(44457,1235,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² ÑÑ‚Ñ€Ð¾ÐºÐ¸',0),(44458,1235,'es','Error recogiendo items de linea',0),(44459,1235,'de','Fehler beim Abrufen der Einzelposten',0),(44460,1235,'en','Error retrieving line items',0),(44461,1236,'is','',0),(44462,1236,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø­Ø¯Ø§ÙƒØ«Ø± Ø·ÙˆÙ„ ÙƒØ¯ ',0),(44463,1236,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø­Ø¯Ø§ÙƒØ«Ø± Ø·ÙˆÙ„ ÙƒØ¯ ',0),(44464,1236,'tr','Max kodu uzunluÄŸu alÄ±nÄ±rken hata oluÅŸtu.',0),(44465,1236,'pl','BÅ‚Ä…d podczas pobierania kodu maksymalna dÅ‚ugoÅ›Ä‡.',0),(44466,1236,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¼Ð°ÐºÑ ÐºÐ¾Ð´ Ð´ÑŠÐ»Ð¶Ð¸Ð½Ð°.',0),(44467,1236,'ur','Ù†Ù‚Øµ Ú©ÙˆÚˆ Ú©Û’ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù„Ù…Ø¨Ø§Ø¦ÛŒ Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’ Û”',0),(44468,1236,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ð¼Ð°x Ð¨Ð¸Ñ„Ñ€Ð° Ð´ÑƒÐ¶Ð¸Ð½Ðµ.',0),(44469,1236,'vi','Lá»—i truy váº¥n mÃ£ chiá»u dÃ i tá»‘i Ä‘a',0),(44470,1236,'af','Fout herwinning max kode lengte.',0),(44471,1236,'ro','Eroare la regÄƒsirea lungime max cod.',0),(44472,1236,'et','Max pikkus toomisel tÃµrge.',0),(44473,1236,'si','Napaka pri pridobivanju kode max dolÅ¾ina.',0),(44474,1236,'ba','Kesalahan yang mengambil maks kode panjang.',0),(44475,1236,'nl','Fout bij het ophalen van de lengte van de max code.',0),(44476,1236,'fi','Virhe haettaessa max pituus.',0),(44477,1236,'no','Feil under henting av lengden pÃ¥ maks.',0),(44478,1236,'da','Fejl under hentning af max kode lÃ¦ngde.',0),(44479,1236,'ko','ìµœëŒ€ ì½”ë“œ ê¸¸ì´ ê²€ìƒ‰ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(44480,1236,'he','×©×’×™××” ×‘××—×–×•×¨ ××•×¨×š ×§×•×“ ×ž×§×¡×™×ž×•×.',0),(44481,1236,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· max ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Î¼Î®ÎºÎ¿Ï‚.',0),(44482,1236,'zh','é”™è¯¯æ£€ç´¢æœ€å¤§ç é•¿ã€‚\r\n',0),(44483,1236,'sv','Fel vid hÃ¤mtning av max kod lÃ¤ngd.',0),(44484,1236,'it','Errore nel recupero codice max lunghezza.',0),(44485,1236,'tl','',0),(44486,1236,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3586;&#3629;&#3591;&#3619;&#3627;&#3',0),(44487,1236,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤•à¥‹à¤¡ à¤²à¤‚à¤¬à¤¾à¤ˆ à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(44488,1236,'ms','Ralat mendapatkan kod max panjang.',0),(44489,1236,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø·ÙˆÙ„ Ø§Ù„Ø±Ù…Ø² ÙƒØ­Ø¯ Ø£Ù‚ØµÙ‰.',0),(44490,1236,'fr','Erreur rÃ©cupÃ©rer la longueur max de code.',0),(44491,1236,'jp','Error retrieving max code length.',0),(44492,1236,'pt','Erro ao recuperar o comprimento mÃ¡ximo de cÃ³digo.',0),(44493,1236,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ð´Ð»Ð¸Ð½Ñ‹ ÐœÐ°ÐºÑ ÐºÐ¾Ð´Ð°.',0),(44494,1236,'es','Error recogiendo el largo mÃ¡ximo del cÃ³digo ',0),(44495,1236,'de','Fehler beim Abrufen der max CodelÃ¤nge.',0),(44496,1236,'en','Error retrieving max code length.',0),(44497,1237,'is','',0),(44498,1237,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø²ÙŠØ± Ù…Ø¬Ù…ÙˆØ¹Ù‡ ',0),(44499,1237,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø²ÙŠØ± Ù…Ø¬Ù…ÙˆØ¹Ù‡ ',0),(44500,1237,'tr','Alt Ã¶ÄŸeler alÄ±nÄ±rken hata oluÅŸtu.',0),(44501,1237,'pl','BÅ‚Ä…d podczas pobierania elementÃ³w podskÅ‚adnik.',0),(44502,1237,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð²ÑŠÐ²ÐµÐ´Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸.',0),(44503,1237,'ur','Ø³Ø¨Ú©ÙˆÙ…Ù¾ÙˆÙ†ÛŒÙ†Ù¹ Ø§Ø´ÛŒØ§ Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ Û”',0),(44504,1237,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ð¿Ð¾Ð´ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð° ÑÑ‚Ð°Ð²ÐºÐµ.',0),(44505,1237,'vi','Truy váº¥n thÃ nh pháº§n hÃ ng bá»‹ lá»—i',0),(44506,1237,'af','Fout met terugvind van sub-komponent items.',0),(44507,1237,'ro','Eroare la regÄƒsirea subcomponenta elemente.',0),(44508,1237,'et','TÃµrge alamkomponent Ã¼ksuste toomine.',0),(44509,1237,'si','Napaka pri pridobivanju podkomponenta elementov.',0),(44510,1237,'ba','Kesalahan mengambil barang-barang subcomponent.',0),(44511,1237,'nl','Fout bij het ophalen van subonderdeel items.',0),(44512,1237,'fi','Virhe haettaessa alakomponentin kohteita.',0),(44513,1237,'no','Feil under henting av Delkomponenten elementer.',0),(44514,1237,'da','Fejl under hentning af underkomponent elementer.',0),(44515,1237,'ko','í•˜ìœ„ í•­ëª©ì„ ê²€ìƒ‰ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(44516,1237,'he','×©×’×™××” ×‘××—×–×•×¨ ×¨×›×™×‘ ×¤×¨×™×˜×™×.',0),(44517,1237,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Î´ÎµÏ…Ï„ÎµÏÎµÏÎ¿Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î±.',0),(44518,1237,'zh','é”™è¯¯æ£€ç´¢å­é¡¹ã€‚',0),(44519,1237,'sv','Fel vid hÃ¤mtning av delkomponenten objekt.',0),(44520,1237,'it','Errore nel recupero di elementi sottocomponente.',0),(44521,1237,'tl','',0),(44522,1237,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3618;&#3656;&#3',0),(44523,1237,'hi','à¤‰à¤ª à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(44524,1237,'ms','Ralat mendapatkan semula barang-barang subcomponent.',0),(44525,1237,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø¹Ù†Ø§ØµØ± Ù…ÙƒÙˆÙ†.',0),(44526,1237,'fr','Erreur lors de la rÃ©cupÃ©ration des Ã©lÃ©ments du sous-composant.',0),(44527,1237,'jp','ã‚µãƒ–ã‚³ãƒ³ãƒ?ãƒ¼ãƒ?ãƒ³ãƒˆå“?ç›®ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(44528,1237,'pt','Erro ao recuperar itens subcomponente.',0),(44529,1237,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð°.',0),(44530,1237,'es','Error recogiendo items de subcomponente',0),(44531,1237,'de','Fehler beim Abrufen der Unterkomponente Elemente.',0),(44532,1237,'en','Error retrieving subcomponent items.',0),(44533,1238,'is','',0),(44534,1238,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(44535,1238,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(44536,1238,'tr','SatÄ±cÄ± bilgisi alÄ±nÄ±rken hata oluÅŸtu.',0),(44537,1238,'pl','BÅ‚Ä…d pobierania informacji dostawcy.',0),(44538,1238,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°.',0),(44539,1238,'ur','Ù†Ù‚Øµ ÙˆÛŒÙ†ÚˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’ Û”',0),(44540,1238,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ Ð³Ñ€ÐµÑˆÐºÐ°Ð¼Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°.',0),(44541,1238,'vi','Lá»—i khi truy váº¥n thÃ´ng tin ngÆ°á»i bÃ¡n',0),(44542,1238,'af','Fout met Herwinning van Verskaffer Inligting.',0),(44543,1238,'ro','Eroare preluare furnizor de informaÅ£ii.',0),(44544,1238,'et','TÃµrge allalaadimisel hankijateabe.',0),(44545,1238,'si','Napaka pri pridobivanju podatke o dobavitelju.',0),(44546,1238,'ba','Kesalahan pengambilan informasi vendor.',0),(44547,1238,'nl','Fout ophalen leveranciersgegevens.',0),(44548,1238,'fi','Virhe noudettaessa toimittajatiedot.',0),(44549,1238,'no','Feil ved henting av leverandÃ¸rinformasjon.',0),(44550,1238,'da','Fejl under hentning af leverandÃ¸roplysninger.',0),(44551,1238,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ê³µê¸‰ ì—…ì²´ ì •ë³´ìž…ë‹ˆë‹¤.',0),(44552,1238,'he','×©×’×™××” ×‘××—×–×•×¨ ×ž×™×“×¢ ×”×¡×¤×§.',0),(44553,1238,'el','Î‘Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(44554,1238,'zh','é”™è¯¯æ£€ç´¢ä¾›åº”å•†ä¿¡æ¯ã€‚',0),(44555,1238,'sv','Fel vid hÃ¤mtning av leverantÃ¶rsinformation.',0),(44556,1238,'it','Errore durante il recupero informazioni di fornitore.',0),(44557,1238,'tl','',0),(44558,1238,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(44559,1238,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤²à¤¾à¤¤à¥‡ à¤¸à¤®à¤¯ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¥¤',0),(44560,1238,'ms','Ralat mendapatkan semula maklumat penjual.',0),(44561,1238,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¬Ù„Ø¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(44562,1238,'fr','RÃ©cupÃ©ration des informations Ã  fournisseur dâ€™erreur.',0),(44563,1238,'jp','æ¥­è€…æƒ…å ±ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(44564,1238,'pt','Erro recuperaÃ§Ã£o fornecedor de informaÃ§Ãµes.',0),(44565,1238,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°.',0),(44566,1238,'es','Error recogiendo informaciÃ³n de Proveedores',0),(44567,1238,'de','Fehler beim Abrufen Herstellerinformationen.',0),(44568,1238,'en','Error retrieving vendor information.',0),(44569,1239,'is','',0),(44570,1239,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ',0),(44571,1239,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ',0),(44572,1239,'tr','Hata alma satÄ±cÄ±larÄ±.',0),(44573,1239,'pl','BÅ‚Ä…d pobierania dostawcÃ³w.',0),(44574,1239,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸.',0),(44575,1239,'ur','Ù†Ù‚Øµ ÙˆÛŒÙ†ÚˆØ±Ø² Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’ Û”',0),(44576,1239,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ.',0),(44577,1239,'vi','Lá»—i truy váº¥n ngÆ°á»i bÃ¡n',0),(44578,1239,'af','Fout met opsporing van verskaffers.',0),(44579,1239,'ro','Eroare preluare furnizori.',0),(44580,1239,'et','Viga andete vastuvÃµtmisel',0),(44581,1239,'si','Napaka pri pridobivanju prodajalci.',0),(44582,1239,'ba','Kesalahan pengambilan vendor.',0),(44583,1239,'nl','Fout ophalen leveranciers.',0),(44584,1239,'fi','Virhe noudettaessa toimittajat.',0),(44585,1239,'no','Feil henting leverandÃ¸rer.',0),(44586,1239,'da','Fejl under hentning af kreditorer.',0),(44587,1239,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ì—…ì²´ìž…ë‹ˆë‹¤.',0),(44588,1239,'he','×©×’×™××” ×‘××—×–×•×¨ ×¡×¤×§×™×.',0),(44589,1239,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î½Î¬ÎºÏ„Î·ÏƒÎ·Ï‚ Ï€Ï‰Î»Î·Ï„Î­Ï‚.',0),(44590,1239,'zh','é”™è¯¯æ£€ç´¢ä¾›åº”å•†ã€‚',0),(44591,1239,'sv','Fel hÃ¤mtar leverantÃ¶rer.',0),(44592,1239,'it','Fornitori di errore durante il recupero.',0),(44593,1239,'tl','',0),(44594,1239,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(44595,1239,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚à¥¤',0),(44596,1239,'ms','Ralat mendapatkan semula vendor.',0),(44597,1239,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¬Ù„Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(44598,1239,'fr','Vendeurs de rÃ©cupÃ©ration erreur.',0),(44599,1239,'jp','æ¥­è€…ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(44600,1239,'pt','Fornecedores de recuperaÃ§Ã£o de erro.',0),(44601,1239,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð².',0),(44602,1239,'es','Error recogiendo Proveedores',0),(44603,1239,'de','Fehler beim Abrufen Anbieter.',0),(44604,1239,'en','Error retrieving vendors.',0),(44605,1240,'is','',0),(44606,1240,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø² Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø§ØµÙ„ÙŠ ',0),(44607,1240,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø² Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø§ØµÙ„ÙŠ ',0),(44608,1240,'tr','Ana veritabanÄ± fiÅŸ bilgisi alÄ±nÄ±rken hata oluÅŸtu.',0),(44609,1240,'pl','BÅ‚Ä…d podczas pobierania zaÅ‚Ä…cznikÃ³w informacji z gÅ‚Ã³wnej bazy danych.',0),(44610,1240,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¾Ñ‚ Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸.',0),(44611,1240,'ur','Ù†Ù‚Øµ ÙˆØ§Ø¤Ú†Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÛŒÙ† Ú©ÙˆØ§Ø¦ÙÛŒÛ Ø³Û’ Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Û”',0),(44612,1240,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¸Ð½Ñ„Ð¾ ÑÐ° Ð³Ð»Ð°Ð²Ð½Ð¾Ð¼ Ð±Ð°Ð·Ð¾Ð¼ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°.',0),(44613,1240,'vi','Truy váº¥n phiáº¿u tá»« dá»¯ liá»‡u chÃ­nh bá»‹ lá»—i',0),(44614,1240,'af','Fout met herwinning van bewysstuk inligting vanaf hoof databasis',0),(44615,1240,'ro','Eroare la regÄƒsirea voucher informaÅ£ii din baza de date principalÄƒ.',0),(44616,1240,'et','Kande info peamine andmebaasist toomisel tÃµrge.',0),(44617,1240,'si','Napaka pri pridobivanju voucher info iz glavne zbirke podatkov.',0),(44618,1240,'ba','Kesalahan mengambil voucher info dari database utama.',0),(44619,1240,'nl','Fout bij het ophalen van Bon info van de hoofddatabase.',0),(44620,1240,'fi','Virhe haettaessa tositteen tiedot pÃ¤Ã¤tietokantaan.',0),(44621,1240,'no','Feil under henting av bilag info fra hoveddatabasen.',0),(44622,1240,'da','Fejl under hentning af gavekort info fra hoveddatabasen.',0),(44623,1240,'ko','ì£¼ ë°ì´í„°ë² ì´ìŠ¤ì—ì„œ ë°”ìš°ì²˜ ì •ë³´ë¥¼ ê²€ìƒ‰ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(44624,1240,'he','×©×’×™××” ×‘×¢×ª ××—×–×•×¨ ×©×•×‘×¨ ×¤×¨×˜×™ ×ž×¡×“ ×”× ×ª×•× ×™× ×”×ž×¨×›×–×™.',0),(44625,1240,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Î±Ï€ÏŒ Ï„Î·Î½ ÎºÏÏÎ¹Î± Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½.',0),(44626,1240,'zh','ä»Žä¸»æ•°æ®åº“ä¸­é”™è¯¯æ£€ç´¢å‡­è¯ä¿¡æ¯ã€‚',0),(44627,1240,'sv','Fel vid hÃ¤mtning av verifikationen information frÃ¥n huvuddatabasen.',0),(44628,1240,'it','Errore nel recupero buono informazioni dal database principale.',0),(44629,1240,'tl','',0),(44630,1240,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3592;&#3634;&#3585;&#3600;&#3634;&#3',0),(44631,1240,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¥à¤–à¥à¤¯ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥‡ à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(44632,1240,'ms','Ralat mendapatkan baucer maklumat dari pangkalan data utama.',0),(44633,1240,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¬Ø§Ø¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù‚Ø³ÙŠÙ…Ø© Ù…Ù† Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©.',0),(44634,1240,'fr','Erreur rÃ©cupÃ©rer info de bon d\'achat de base de donnÃ©es principale.',0),(44635,1240,'jp','ãƒ¡ã‚¤ãƒ³ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?‹ã‚‰ã?®ä¼?ç¥¨æƒ…å ±å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(44636,1240,'pt','Erro ao recuperar informaÃ§Ã£o de comprovante de banco de dados principal.',0),(44637,1240,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ð¿ÑƒÑ‚ÐµÐ²ÐºÐ¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¸Ð· Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ….',0),(44638,1240,'es','Error recogiendo info de voucher de la base de datos principal',0),(44639,1240,'de','Fehler beim Abrufen der Gutschein Info aus Hauptdatenbank.',0),(44640,1240,'en','Error retrieving voucher info from main database.',0),(44641,1241,'is','',0),(44642,1241,'dr','Ø®Ø·Ø§ ÙŠ Ø¬Ø³ØªØ¬ÙˆÙŠ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(44643,1241,'pr','Ø®Ø·Ø§ ÙŠ Ø¬Ø³ØªØ¬ÙˆÙŠ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(44644,1241,'tr','VendorID iÃ§in arama hatasÄ±.',0),(44645,1241,'pl','BÅ‚Ä…d wyszukiwania vendorid.',0),(44646,1241,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ vendorid.',0),(44647,1241,'ur','Ù†Ù‚Øµ ÙˆØ§Ù†Ø¯ÙˆØ±ÛŒØ¯ Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(44648,1241,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð¿Ð¾Ñ‚Ñ€Ð°Ð·Ð¸ Ð·Ð° Ñƒ.',0),(44649,1241,'vi','Lá»—i tÃ¬m ID ngÆ°á»i bÃ¡n',0),(44650,1241,'af','Fout soek vir vendorid.',0),(44651,1241,'ro','Eroare de cÄƒutare pentru vendorid.',0),(44652,1241,'et','Vendori ID otsimisel tekkis viga',0),(44653,1241,'si','Napaka pri iskanju ID prodajalca.',0),(44654,1241,'ba','Kesalahan mencari vendorid.',0),(44655,1241,'nl','Fout bij het zoeken naar vendorid.',0),(44656,1241,'fi','Virhe VendorId-tietojen etsiminen.',0),(44657,1241,'no','Feil etter vendorid.',0),(44658,1241,'da','Fejl under sÃ¸gning efter vendorid.',0),(44659,1241,'ko','Vendorid ê²€ìƒ‰ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(44660,1241,'he','×©×’×™××ª ×—×™×¤×•×© ×ž×–×”×” ×¡×¤×§.',0),(44661,1241,'el','Î¤Î¿ Î»Î¬Î¸Î¿Ï‚ Ï€Î¿Ï… ÏˆÎ¬Ï‡Î½ÎµÎ¹ Î³Î¹Î± vendorid.',0),(44662,1241,'zh','æœç´¢ä¾›åº”å•†é”™è¯¯ã€‚\r\n',0),(44663,1241,'sv','Fel sÃ¶ka efter vendorid.',0),(44664,1241,'it','Errore ricerca per vendorid.',0),(44665,1241,'tl','',0),(44666,1241,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(44667,1241,'hi','Vendorid à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(44668,1241,'ms','Ralat mencari vendorid.',0),(44669,1241,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ù…Ø¹Ø±Ù‘Ù Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(44670,1241,'fr','Erreur vous cherchez vendorid.',0),(44671,1241,'jp','æ¥­è€…ï¼©ï¼¤ã?®æ¤œç´¢ã‚¨ãƒ©ãƒ¼',0),(44672,1241,'pt','Erro procurando vendorid.',0),(44673,1241,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð¸ÑÐºÐµ vendorid.',0),(44674,1241,'es','Error buscando el ID de Proveedor',0),(44675,1241,'de','Fehler beim Suchen nach Herstellerkennung.',0),(44676,1241,'en','Error searching for vendorid.',0),(44677,1242,'is','',0),(44678,1242,'dr',': Ø³Ø·Ø± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø²ÙŠØ§Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ ÙŠÙƒ Ú†Ùƒ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(44679,1242,'pr','Ø®Ø·Ø§ : Ø³Ø·Ø± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø²ÙŠØ§Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ ÙŠÙƒ Ú†Ùƒ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(44680,1242,'tr','Hata: Ã§ok fazla satÄ±r Ã¶ÄŸeleri iÃ§in bir kontrol edin.',0),(44681,1242,'pl','BÅ‚Ä…d: zbyt wiele elementÃ³w jednej kontroli.',0),(44682,1242,'bg','Ð“Ñ€ÐµÑˆÐºÐ°: Ñ‚Ð²ÑŠÑ€Ð´Ðµ Ð¼Ð½Ð¾Ð³Ð¾ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ð·Ð° ÐµÐ´Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°.',0),(44683,1242,'ur','Ù†Ù‚Øµ: Ù„Ø§Ø¦Ù† Ú©Û’ Ø¨ÛØª Ø²ÛŒØ§Ø¯Û Ø§Ø´ÛŒØ§Ø¡ Ø§ÛŒÚ© Ú†ÛŒÚ© Ú©Û’ Ù„Ø¦Û’ Û”',0),(44684,1242,'sr','Ð“Ñ€ÐµÑˆÐºÐ° : Ð¿Ñ€ÐµÐ²Ð¸ÑˆÐµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð° Ñ˜ÐµÐ´Ð°Ð½ Ñ‡ÐµÐº.',0),(44685,1242,'vi','Lá»—i: quÃ¡ nhiá»u dÃ²ng hÃ ng trong 1 láº§n kiá»ƒm tra',0),(44686,1242,'af','Fout:  te veel lynitems vir een tjek',0),(44687,1242,'ro','Eroare: prea multe elemente pentru un control.',0),(44688,1242,'et','TÃµrge: liiga palju kirjeid Ã¼he tÅ¡eki.',0),(44689,1242,'si','Napaka: preveÄ vrstiÄne postavke za en pregled.',0),(44690,1242,'ba','Kesalahan: item baris terlalu banyak untuk satu check.',0),(44691,1242,'nl','Fout: te veel regelitems voor Ã©Ã©n cheque.',0),(44692,1242,'fi','Virhe: liian monta rivinimikkeet yhden sekin.',0),(44693,1242,'no','Feil: for mange linjeelementer for en sjekk.',0),(44694,1242,'da','Fejl: for mange linjeelementer for en check.',0),(44695,1242,'ko','ì˜¤ë¥˜: 1 í™•ì¸ì— ëŒ€ í•œ ë„ˆë¬´ ë§Žì€ í’ˆëª©.',0),(44696,1242,'he','×©×’×™××”: ×¤×¨×™×˜×™ ×©×•×¨×” ×¨×‘×™× ×ž×“×™ ×¢×‘×•×¨ ×‘×“×™×§×” ××—×ª.',0),(44697,1242,'el','Î£Ï†Î¬Î»Î¼Î±: Ï€Î¬ÏÎ± Ï€Î¿Î»Î»Î¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚ Î³Î¹Î± Î¼Î¹Î± ÎµÏ€Î¹Ï„Î±Î³Î®.',0),(44698,1242,'zh','é”™è¯¯ï¼šä¸€æ¬¡æ£€æŸ¥å¤ªå¤šè¡Œé¡¹ç›®',0),(44699,1242,'sv','Fel: fÃ¶r mÃ¥nga poster fÃ¶r en check.',0),(44700,1242,'it','Errore: troppe voci per un controllo.',0),(44701,1242,'tl','',0),(44702,1242,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;: &#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3617;&#3634;&#3585;&#3648;&#3585;&#3636;&#3609;&#3652;&#3611;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3605;&#3619;&',0),(44703,1242,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿: à¤à¤• à¤šà¥‡à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥€ à¤•à¤ˆ à¤²à¤¾à¤‡à¤¨ à¤†à¤‡à¤Ÿà¤®à¥¤',0),(44704,1242,'ms','Ralat: terlalu banyak barang-barang talian untuk mendaftar satu.',0),(44705,1242,'ar','Ø®Ø·Ø£: Ø¨Ù†ÙˆØ¯ ÙƒØ«ÙŠØ±Ø© Ø¬Ø¯Ø§Ù‹ Ù„Ù„Ø§Ø®ØªÙŠØ§Ø± ÙˆØ§Ø­Ø¯.',0),(44706,1242,'fr','Erreur : trop de lignes de facturation d\'un seul chÃ¨que.',0),(44707,1242,'jp','ã‚¨ãƒ©ãƒ¼ï¼šä¸€ã?¤ãƒ?ã‚§ãƒƒã‚¯ã?«ãƒ©ã‚¤ãƒ³å“?ç›®ã?«å¤šã?™ã?Žã?¾ã?™',0),(44708,1242,'pt','Erro: muitos itens de linha para uma verificaÃ§Ã£o.',0),(44709,1242,'ru','ÐžÑˆÐ¸Ð±ÐºÐ°: ÑÐ»Ð¸ÑˆÐºÐ¾Ð¼ Ð¼Ð½Ð¾Ð³Ð¾ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¹ Ð´Ð»Ñ Ð¾Ð´Ð½Ð¾Ð¹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸.',0),(44710,1242,'es','Error: Demasiado items de linea para un cheque',0),(44711,1242,'de','Fehler: zu viele Posten fÃ¼r einen Scheck.',0),(44712,1242,'en','Error: too many line items for one check.',0),(44713,1243,'is','',0),(44714,1243,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨ ',0),(44715,1243,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨ ',0),(44716,1243,'tr','HesabÄ±nÄ±z gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(44717,1243,'pl','BÅ‚Ä…d aktualizacji konta',0),(44718,1243,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(44719,1243,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(44720,1243,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(44721,1243,'vi','Cáº­p Nháº­t TK Bá»‹ Lá»—i',0),(44722,1243,'af','Fout bywerking rekening',0),(44723,1243,'ro','Eroare la actualizarea cont',0),(44724,1243,'et','Viga ajakohastamine konto',0),(44725,1243,'si','Napaka pri posodabljanju raÄun',0),(44726,1243,'ba','Kesalahan memperbarui account',0),(44727,1243,'nl','Fout bij het bijwerken rekening',0),(44728,1243,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tili',0),(44729,1243,'no','Feil under oppdatering av konto',0),(44730,1243,'da','Fejl under opdatering af konto',0),(44731,1243,'ko','ê³„ì • ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(44732,1243,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×—×©×‘×•×Ÿ',0),(44733,1243,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(44734,1243,'zh','é”™è¯¯æ›´æ–°å¸æˆ·',0),(44735,1243,'sv','Gick inte att uppdatera konto',0),(44736,1243,'it','Errore di aggiornamento account',0),(44737,1243,'tl','',0),(44738,1243,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(44739,1243,'hi','à¤–à¤¾à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(44740,1243,'ms','Ralat dalam mengemas kini akaun',0),(44741,1243,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø­Ø³Ø§Ø¨',0),(44742,1243,'fr','Erreur mise Ã  jour de compte',0),(44743,1243,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(44744,1243,'pt','Erro ao atualizar a conta',0),(44745,1243,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(44746,1243,'es','Error actualizando cuenta',0),(44747,1243,'de','Fehler beim Aktualisieren des Kontos',0),(44748,1243,'en','Error updating account',0),(44749,1244,'is','',0),(44750,1244,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨',0),(44751,1244,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨',0),(44752,1244,'tr','Hata gÃ¼ncelleÅŸtirme hesap tÃ¼rÃ¼',0),(44753,1244,'pl','BÅ‚Ä…d aktualizacji konta typu',0),(44754,1244,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ‚Ð¸Ð¿ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(44755,1244,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(44756,1244,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(44757,1244,'vi','Cáº­p Nháº­t Loáº¡i TK Bá»‹ Lá»—i',0),(44758,1244,'af','Fout Outobywerking rekeningtipe',0),(44759,1244,'ro','Eroare actualizarea tip cont',0),(44760,1244,'et','Viga ajakohastamine kontotÃ¼Ã¼p',0),(44761,1244,'si','Posodabljanje raÄuna vrsta napake',0),(44762,1244,'ba','Jenis account memperbarui kesalahan',0),(44763,1244,'nl','Fout bijwerken accounttype',0),(44764,1244,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tilityyppi',0),(44765,1244,'no','Feil oppdatering kontotype',0),(44766,1244,'da','Fejl opdatering kontotype',0),(44767,1244,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ê³„ì • ìœ í˜•',0),(44768,1244,'he','×¡×•×’ ×—×©×‘×•×Ÿ ×”×ž×¢×“×›× ×ª ×©×’×™××”',0),(44769,1244,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï„ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(44770,1244,'zh','é”™è¯¯æ›´æ–°å¸æˆ·ç±»åž‹',0),(44771,1244,'sv','Feltyp av uppdatering',0),(44772,1244,'it','Tipo di errore aggiornamento account',0),(44773,1244,'tl','',0),(44774,1244,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(44775,1244,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(44776,1244,'ms','Ralat pengemaskinian akaun jenis',0),(44777,1244,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(44778,1244,'fr','Type de compte erreur mise Ã  jour',0),(44779,1244,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(44780,1244,'pt','Tipo de conta atualizaÃ§Ã£o erro',0),(44781,1244,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ñ‚Ð¸Ð¿Ð° ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(44782,1244,'es','Error actualizando tipo de cuenta',0),(44783,1244,'de','Fehler Update Kontotyp',0),(44784,1244,'en','Error updating account type',0),(44785,1245,'is','',0),(44786,1245,'dr','/  Ø§ÙØ²ÙˆØ¯Ù†  Ø³ÙŠØ³ØªÙ… Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­ ',0),(44787,1245,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù†/  Ø§ÙØ²ÙˆØ¯Ù†  Ø³ÙŠØ³ØªÙ… Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­ ',0),(44788,1245,'tr','GÃ¼ncelleÅŸtirme ekleme/biÃ§imlendirme kÃ¼me dÃ¼zey iÃ§in bir hata oluÅŸtu.',0),(44789,1245,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas aktualizowania/dodawania znacznikÃ³w ustawiÄ‡ poziom.',0),(44790,1245,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ/Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Markup ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚ Ð·Ð° Ð½Ð¸Ð²Ð¾.',0),(44791,1245,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’/Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ø³Ø·Ø­ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(44792,1245,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°/Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ Ð½Ð°Ð·Ð½Ð°ÐºÐµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½ Ð·Ð° Ð½Ð¸Ð²Ð¾.',0),(44793,1245,'vi','Cáº­p Nháº­t/thÃªm má»©c cá»™ng thÃªm bá»‹ lá»—i',0),(44794,1245,'af','Fout opdatering/voeg Markup stel vir vlak.',0),(44795,1245,'ro','Eroare la actualizarea/adÄƒugarea Markup stabilit pentru nivel.',0),(44796,1245,'et','Viga ajakohastamine/lisades mÃ¤rgistus seada tasemele.',0),(44797,1245,'si','Napaka posodabljanje/dodajanje oznake nastavite raven.',0),(44798,1245,'ba','Kesalahan update/menambahkan Markup Set untuk tingkat.',0),(44799,1245,'nl','Fout bijwerken/toevoegen Markup instellen voor niveau.',0),(44800,1245,'fi','Virhe pÃ¤ivittÃ¤minen/lisÃ¤ttÃ¤essÃ¤ Markup asettaa tasolle.',0),(44801,1245,'no','Feil oppdatering/legge Markup satt for nivÃ¥et.',0),(44802,1245,'da','Fejl ved opdatering/tilfÃ¸jelse Markup fastsatte niveau.',0),(44803,1245,'ko','ì—…ë°ì´íŠ¸/ì¶”ê°€ íƒœê·¸ ìˆ˜ì¤€ì— ëŒ€í•´ ì„¤ì • í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(44804,1245,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ/×”×•×¡×¤×ª ×¡×™×ž×•×Ÿ ×œ×”×’×“×™×¨ ×¨×ž×”.',0),(44805,1245,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·/Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ Ï€Î¿Ï… Î³Î¹Î± Ï„Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿.',0),(44806,1245,'zh','é”™è¯¯æ›´æ–°/æ·»åŠ çº§åˆ«æ ‡è®°é›†ã€‚',0),(44807,1245,'sv','Fel vid uppdatering/att Markup fÃ¶r nivÃ¥.',0),(44808,1245,'it','Errore aggiornamento/aggiunta di Markup impostato per il livello.',0),(44809,1245,'tl','',0),(44810,1245,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;/&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3633;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#',0),(44811,1245,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤•à¥‡ à¤¸à¥à¤¤à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚à¥¤',0),(44812,1245,'ms','Ralat mengemas kini/menambah penanda yang ditetapkan bagi tahap.',0),(44813,1245,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ«/Ø¥Ø¶Ø§ÙØ© \"Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©\" Ù„Ù„Ù…Ø³ØªÙˆÙ‰.',0),(44814,1245,'fr','Erreur mise Ã  jour/ajout de balisage mis Ã  niveau.',0),(44815,1245,'jp','ã??ã?®ãƒ¬ãƒ™ãƒ«ã?®å€¤ä¸Šã?’è¨­å®šæ›´æ–°/è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(44816,1245,'pt','Atualizando/adicionando marcaÃ§Ã£o definida para o nÃ­vel de erro.',0),(44817,1245,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ/Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ð´Ð»Ñ ÑƒÑ€Ð¾Ð²Ð½Ñ.',0),(44818,1245,'es','Error actualizando/agregando juego de encarecimineto para el nivel',0),(44819,1245,'de','Fehler beim Aktualisieren/hinzufÃ¼gen Markup fÃ¼r Ebene festgelegt.',0),(44820,1245,'en','Error updating/adding Markup Set for Level.',0),(44821,1246,'is','',0),(44822,1246,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(44823,1246,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(44824,1246,'tr','Hata gÃ¼ncelleÅŸtirme bill',0),(44825,1246,'pl','BÅ‚Ä…d aktualizacji ustawy',0),(44826,1246,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð±Ð¸Ð»',0),(44827,1246,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø¨Ù„',0),(44828,1246,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð‘Ð¸Ð»',0),(44829,1246,'vi','Cáº­p nháº­t hÃ³a Ä‘Æ¡n bá»‹ lá»—i',0),(44830,1246,'af','Fout Outobywerking Wetsontwerp',0),(44831,1246,'ro','Eroare de actualizare bill',0),(44832,1246,'et','Viga ajakohastamine bill',0),(44833,1246,'si','Napaka pri posodabljanju bill',0),(44834,1246,'ba','Kesalahan update tagihan',0),(44835,1246,'nl','Fout bijwerken bill',0),(44836,1246,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ bill',0),(44837,1246,'no','Feil oppdatering bill',0),(44838,1246,'da','Fejl opdatering bill',0),(44839,1246,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë¹Œ',0),(44840,1246,'he','×‘×™×œ ×”×ž×¢×“×›× ×ª ×©×’×™××”',0),(44841,1246,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(44842,1246,'zh','é”™è¯¯æ›´æ–°æ³•æ¡ˆ\r\n',0),(44843,1246,'sv','Fel uppdatering bill',0),(44844,1246,'it','Bill aggiornamento errore',0),(44845,1246,'tl','',0),(44846,1246,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3636;&#3621;',0),(44847,1246,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤¬à¤¿à¤²',0),(44848,1246,'ms','Ralat pengemaskinian bil',0),(44849,1246,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(44850,1246,'fr','Projet de loi mise Ã  jour erreur',0),(44851,1246,'jp','è«‹æ±‚æ›¸ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(44852,1246,'pt','Bill atualizaÃ§Ã£o de erro',0),(44853,1246,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð‘Ð¸Ð»Ð»',0),(44854,1246,'es','Error actualizando recibo',0),(44855,1246,'de','Fehler Update bill',0),(44856,1246,'en','Error updating bill',0),(44857,1247,'is','',0),(44858,1247,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(44859,1247,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(44860,1247,'tr','Hata gÃ¼ncelleme fatura ayrÄ±ntÄ±sÄ±',0),(44861,1247,'pl','BÅ‚Ä…d aktualizacji ustawy szczegÃ³Å‚owo',0),(44862,1247,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð±Ð¸Ð» Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(44863,1247,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø¨Ù„ ØªÙØµÛŒÙ„ Ù†Ù‚Øµ',0),(44864,1247,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð‘Ð¸Ð» Ð´ÐµÑ‚Ð°Ñ™',0),(44865,1247,'vi','Cáº­p nháº­t chi tiáº¿t hÃ³a Ä‘Æ¡n bá»‹ lá»—i',0),(44866,1247,'af','Fout Outobywerking Wetsontwerp detail',0),(44867,1247,'ro','Eroare de actualizare bill detaliu',0),(44868,1247,'et','Viga ajakohastamine arve Ã¼ksikasjad',0),(44869,1247,'si','Napaka posodabljanje zakona podrobno',0),(44870,1247,'ba','Kesalahan update tagihan detail',0),(44871,1247,'nl','Fout bijwerken bill detail',0),(44872,1247,'fi','PÃ¤ivitetÃ¤Ã¤n laskun virheestÃ¤',0),(44873,1247,'no','Feil oppdatering bill detaljer',0),(44874,1247,'da','Fejl opdatering bill detaljer',0),(44875,1247,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë¹Œ ì„¸ë¶€ ì‚¬í•­',0),(44876,1247,'he','×¤×™×¨×•×˜ ×”×—×©×‘×•×Ÿ ×”×ž×¢×“×›× ×ª ×©×’×™××”',0),(44877,1247,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(44878,1247,'zh','å¸å•çš„ç»†èŠ‚é”™è¯¯æ›´æ–°',0),(44879,1247,'sv','Fel uppdatering bill detalj',0),(44880,1247,'it','Dettaglio di errore aggiornamento bill',0),(44881,1247,'tl','',0),(44882,1247,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3610;&#3636;&#3621;',0),(44883,1247,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤¬à¤¿à¤² à¤µà¤¿à¤µà¤°à¤£',0),(44884,1247,'ms','Ralat pengemaskinian bil terperinci',0),(44885,1247,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« ØªÙØ§ØµÙŠÙ„ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(44886,1247,'fr','DÃ©tail de facture mise Ã  jour erreur',0),(44887,1247,'jp','è«‹æ±‚æ›¸è©³ç´°ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(44888,1247,'pt','Detalhe de bill atualizaÃ§Ã£o erro',0),(44889,1247,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð‘Ð¸Ð»Ð» Ð´ÐµÑ‚Ð°Ð»ÑŒ',0),(44890,1247,'es','Error actualizando detalle de recibo',0),(44891,1247,'de','Aktualisierung Bill Fehlerdetails.',0),(44892,1247,'en','Error updating bill detail',0),(44893,1248,'is','',0),(44894,1248,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(44895,1248,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(44896,1248,'tr','Hata gÃ¼ncelleme fatura Ã¶deme',0),(44897,1248,'pl','BÅ‚Ä…d aktualizacji rachunku pÅ‚atnoÅ›ci',0),(44898,1248,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(44899,1248,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(44900,1248,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(44901,1248,'vi','Cáº­p nháº­t thanh toÃ¡n hÃ³a Ä‘Æ¡n bá»‹ lá»—i',0),(44902,1248,'af','Fout Outobywerking Wetsontwerp betaling',0),(44903,1248,'ro','Eroare de actualizare plata factura',0),(44904,1248,'et','Viga ajakohastamine bill maksmine',0),(44905,1248,'si','Napaka posodabljanje obraÄun plaÄil',0),(44906,1248,'ba','Kesalahan update pembayaran tagihan',0),(44907,1248,'nl','Fout bijwerken factuur betaling',0),(44908,1248,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ laskun maksu',0),(44909,1248,'no','Feil oppdatering bill betaling',0),(44910,1248,'da','Fejl opdatering bill betaling',0),(44911,1248,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ìš”ê¸ˆ ë‚©ë¶€',0),(44912,1248,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×ª×©×œ×•× ×‘×™×œ',0),(44913,1248,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÎµÎ¾ÏŒÏ†Î»Î·ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(44914,1248,'zh','é”™è¯¯æ›´æ–°å¸å•æ”¯ä»˜\r\n',0),(44915,1248,'sv','Fel uppdatering bill betalning',0),(44916,1248,'it','Pagamento aggiornamento errore',0),(44917,1248,'tl','',0),(44918,1248,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(44919,1248,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(44920,1248,'ms','Ralat pengemaskinian bil pembayaran',0),(44921,1248,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø³Ø¯Ø§Ø¯ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(44922,1248,'fr','Paiement de facture erreur mise Ã  jour',0),(44923,1248,'jp','è«‹æ±‚æ›¸æ”¯æ‰•ã?„ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(44924,1248,'pt','Pagamento de contas atualizaÃ§Ã£o erro',0),(44925,1248,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÑ‡ÐµÑ‚Ð°',0),(44926,1248,'es','Error actualizando pago de recibo',0),(44927,1248,'de','Update Fehler-Ãœberweisungen',0),(44928,1248,'en','Error updating bill payment',0),(44929,1249,'is','',0),(44930,1249,'dr','( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(44931,1249,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØªØ§Ø¨Ø¹ ( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(44932,1249,'tr','Hata gÃ¼ncelleÅŸtirme baÄŸlayÄ±cÄ± iÅŸlev.',0),(44933,1249,'pl','BÅ‚Ä…d aktualizacji funkcji bazy danych bindery.',0),(44934,1249,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ.',0),(44935,1249,'ur','Ù†Ù‚Øµ Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ú©Ùˆ ØªØ§Ø²Û Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(44936,1249,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð±Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°.',0),(44937,1249,'vi','Cáº­p Nháº­t chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch bá»‹ lá»—i',0),(44938,1249,'af','Fout Outobywerking bindery funksie.',0),(44939,1249,'ro','Eroare de actualizare legatorie funcÅ£ia.',0),(44940,1249,'et','Viga ajakohastamine Kirjansitomo funktsiooni.',0),(44941,1249,'si','Posodabljanje Knjigoveznica funkcijo napake.',0),(44942,1249,'ba','Kesalahan update bindery fungsi.',0),(44943,1249,'nl','Fout bijwerken bindery functie.',0),(44944,1249,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ bindery-toimintoa.',0),(44945,1249,'no','Feil oppdatering bindery-funksjonen.',0),(44946,1249,'da','Fejl opdatering bindery funktion.',0),(44947,1249,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë°”ì¸ë”ë¦¬ ê¸°ëŠ¥ìž…ë‹ˆë‹¤.',0),(44948,1249,'he','×¤×•× ×§×¦×™×™×ª bindery ×”×ž×¢×“×›× ×ª ×”×©×’×™××”.',0),(44949,1249,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· bindery ÏƒÏ…Î½Î¬ÏÏ„Î·ÏƒÎ· ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚.',0),(44950,1249,'zh','é”™è¯¯æ›´æ–°è£…è®¢åŠŸèƒ½ã€‚',0),(44951,1249,'sv','Fel uppdatering bindery funktion.',0),(44952,1249,'it','Errore aggiornamento funzione della legatoria.',0),(44953,1249,'tl','',0),(44954,1249,'th','Error updating bindery function.',0),(44955,1249,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹à¥¤',0),(44956,1249,'ms','Ralat pengemaskinian fungsi bindery.',0),(44957,1249,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø¯Ø§Ù„Ø©.',0),(44958,1249,'fr','Fonction faÃ§onnage mise Ã  jour par erreur.',0),(44959,1249,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(44960,1249,'pt','FunÃ§Ã£o de bindery atualizaÃ§Ã£o de erro.',0),(44961,1249,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ.',0),(44962,1249,'es','Error actualizando funciÃ³n de encuadernaciÃ³n',0),(44963,1249,'de','Aktualisierung Buchbinderei Fehlerfunktion.',0),(44964,1249,'en','Error updating bindery function.',0),(44965,1250,'is','',0),(44966,1250,'dr','( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(44967,1250,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ ØªØ§Ø¨Ø¹ ( ÙØ¹Ø§Ù„ÙŠØª ) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(44968,1250,'tr','Hata gÃ¼ncelleÅŸtirme baÄŸlayÄ±cÄ± iÅŸlevi boyutu.',0),(44969,1250,'pl','BÅ‚Ä…d aktualizacji bazy danych bindery funkcja rozmiar.',0),(44970,1250,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(44971,1250,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø¨Ø§Ù†ÚˆØ±ÛŒ ÙØ¹Ù„ Ø³Ø§Ø¦Ø² Û”',0),(44972,1250,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð±Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ.',0),(44973,1250,'vi','Cáº­p Nháº­t cá»¡ chá»©c nÄƒng Ä‘Ã³ng sÃ¡ch bá»‹ lá»—i',0),(44974,1250,'af','Fout Outobywerking bindery funksie grootte.',0),(44975,1250,'ro','Eroare de actualizare legatorie funcÅ£ia dimensiunea.',0),(44976,1250,'et','Viga ajakohastamine Kirjansitomo funktsiooni suurus.',0),(44977,1250,'si','Napaka posodabljanje Knjigoveznica funkcijo velikosti.',0),(44978,1250,'ba','Kesalahan update bindery fungsi ukuran.',0),(44979,1250,'nl','Fout bijwerken bindery functie grootte.',0),(44980,1250,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ bindery tehtÃ¤vÃ¤ koko.',0),(44981,1250,'no','Feil oppdatering bindery funksjon stÃ¸rrelsen.',0),(44982,1250,'da','Fejl opdatering bindery funktion stÃ¸rrelse.',0),(44983,1250,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë°”ì¸ë”ë¦¬ í•¨ìˆ˜ í¬ê¸°ìž…ë‹ˆë‹¤.',0),(44984,1250,'he','×©×’×™××ª ×¢×“×›×•×Ÿ bindery ×¤×•× ×§×¦×™×” ×’×•×“×œ.',0),(44985,1250,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚.',0),(44986,1250,'zh','é”™è¯¯æ›´æ–°è£…è®¢åŠŸèƒ½çš„å¤§å°ã€‚',0),(44987,1250,'sv','Fel uppdatering bindery funktion storlek.',0),(44988,1250,'it','Dimensione di funzione della legatoria aggiornamento errore.',0),(44989,1250,'tl','',0),(44990,1250,'th','Error updating bindery function size.',0),(44991,1250,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤†à¤•à¤¾à¤°à¥¤',0),(44992,1250,'ms','Ralat pengemaskinian bindery fungsi saiz.',0),(44993,1250,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø­Ø¬Ù… ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(44994,1250,'fr','Erreur mise Ã  jour faÃ§onnage fonction taille.',0),(44995,1250,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚µã‚¤ã‚ºã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(44996,1250,'pt','Tamanho atualizaÃ§Ã£o da funÃ§Ã£o bindery de erro.',0),(44997,1250,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(44998,1250,'es','Error actualizando tamaÃ±o de la funciÃ³n de encuadernaciÃ³n',0),(44999,1250,'de','Fehler Update Buchbinderei Funktion GrÃ¶ÃŸe.',0),(45000,1250,'en','Error updating bindery function size.',0),(45001,1251,'is','',0),(45002,1251,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(45003,1251,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(45004,1251,'tr','BaÄŸlayÄ±cÄ± seÃ§eneÄŸi liste Ã¶ÄŸesi gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(45005,1251,'pl','BÅ‚Ä…d aktualizacji elementu listy opcji bazy danych bindery.',0),(45006,1251,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ð¾Ð¿Ñ†Ð¸Ñ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº.',0),(45007,1251,'ur','Ù†Ù‚Øµ Ø¨Ø§Ù†ÚˆØ±ÛŒ Ø§Ø®ØªÛŒØ§Ø± ÙÛØ±Ø³Øª Ø´Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(45008,1251,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð±Ð¸Ð½Ð´ÐµÑ€y ÑÑ‚Ð°Ð²ÐºÑƒ ÑÐ° Ð»Ð¸ÑÑ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°.',0),(45009,1251,'vi','Cáº­p nháº­t lá»±a chá»n Ä‘Ã³ng sÃ¡ch bá»‹ lá»—i',0),(45010,1251,'af','Fout met opdateer van boekbindery opsielys item.',0),(45011,1251,'ro','Eroare la actualizarea legatorie opÅ£iune element din listÄƒ.',0),(45012,1251,'et','Viga ajakohastamine Kirjansitomo variant loendiÃ¼ksuse.',0),(45013,1251,'si','Napaka pri posodabljanju Knjigoveznica moÅ¾nost element seznama.',0),(45014,1251,'ba','Kesalahan memperbarui bindery pilihan daftar item.',0),(45015,1251,'nl','Fout bij het bijwerken van bindery optie lijstitem.',0),(45016,1251,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ bindery luettelon vaihtoehdon.',0),(45017,1251,'no','Feil under oppdatering av bindery alternativet listeelementet.',0),(45018,1251,'da','Fejl under opdatering af bindery indstilling listeelementet.',0),(45019,1251,'ko','ë°”ì¸ë”ë¦¬ ì˜µì…˜ ëª©ë¡ í•­ëª©ì„ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(45020,1251,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¤×¨×™×˜ ×¨×©×™×ž×” ×©×œ ××¤×©×¨×•×™×•×ª ×’×™×ž×•×¨.',0),(45021,1251,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î»Î¯ÏƒÏ„Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î® bindery.',0),(45022,1251,'zh','é”™è¯¯æ›´æ–°è£…è®¢é€‰é¡¹åˆ—è¡¨é¡¹ã€‚',0),(45023,1251,'sv','Det gick inte att uppdatera listobjektet bindery alternativet.',0),(45024,1251,'it','Errore durante l\'aggiornamento la voce di elenco di opzione della legatoria.',0),(45025,1251,'tl','',0),(45026,1251,'th','Error updating bindery option list item.',0),(45027,1251,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(45028,1251,'ms','Ralat dalam mengemas kini bindery pilihan senarai item.',0),(45029,1251,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¹Ù†ØµØ± Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø®ÙŠØ§Ø± Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(45030,1251,'fr','Erreur mise Ã  jour d\'Ã©lÃ©ment de liste option faÃ§onnage.',0),(45031,1251,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚ªãƒ—ã‚·ãƒ§ãƒ³ãƒªã‚¹ãƒˆå“?ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45032,1251,'pt','Erro ao atualizar o item de lista de opÃ§Ã£o de encadernaÃ§Ã£o.',0),(45033,1251,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÑÐ¿Ð¸ÑÐºÐ° Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ bindery.',0),(45034,1251,'es','Error actualizando item de lista de opciones de la encuadernaciÃ³n',0),(45035,1251,'de','Fehler beim Aktualisieren der Buchbinderei Option Listenelement.',0),(45036,1251,'en','Error updating bindery option list item.',0),(45037,1252,'is','',0),(45038,1252,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(45039,1252,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†ÙˆØ¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª',0),(45040,1252,'tr','Hata gÃ¼ncelleÅŸtirme baÄŸlayÄ±cÄ± tÃ¼rÃ¼.',0),(45041,1252,'pl','BÅ‚Ä…d aktualizacji typ wiÄ…zaÅ„.',0),(45042,1252,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ‚Ð¸Ð¿.',0),(45043,1252,'ur','Ù†Ù‚Øµ Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚Ø³Ù… ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(45044,1252,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð±Ð¸Ð½Ð´ÐµÑ€y Ñ‚Ð¸Ð¿.',0),(45045,1252,'vi','Cáº­p Nháº­t loáº¡i Ä‘Ã³ng sÃ¡ch bá»‹ lá»—i',0),(45046,1252,'af','Outobywerking bindery fouttipe.',0),(45047,1252,'ro','Eroare actualizarea tip de legatorie.',0),(45048,1252,'et','Viga ajakohastamine Kirjansitomo tÃ¼Ã¼p.',0),(45049,1252,'si','Posodabljanje Knjigoveznica vrsta napake.',0),(45050,1252,'ba','Kesalahan update bindery tipe.',0),(45051,1252,'nl','Fout bijwerken bindery type.',0),(45052,1252,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ bindery tyyppi.',0),(45053,1252,'no','Feil oppdatering bindery type.',0),(45054,1252,'da','Fejltypen opdatering bindery.',0),(45055,1252,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë°”ì¸ë”ë¦¬ í˜•ì‹ìž…ë‹ˆë‹¤.',0),(45056,1252,'he','×©×’×™××” ×ž×¡×•×’ bindery ×”×ž×¢×“×›× ×ª.',0),(45057,1252,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï„ÏÏ€Î¿Ï… bindery.',0),(45058,1252,'zh','é”™è¯¯æ›´æ–°è£…è®¢ç±»åž‹ã€‚',0),(45059,1252,'sv','Uppdatera bindery feltyp.',0),(45060,1252,'it','Errore aggiornamento tipo della legatoria.',0),(45061,1252,'tl','',0),(45062,1252,'th','Error updating bindery type.',0),(45063,1252,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤•à¤¾à¤°à¥¤',0),(45064,1252,'ms','Ralat pengemaskinian jenis bindery.',0),(45065,1252,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ù†ÙˆØ¹.',0),(45066,1252,'fr','Erreur mise Ã  jour type de faÃ§onnage.',0),(45067,1252,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ã‚¿ã‚¤ãƒ—ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45068,1252,'pt','Tipo de encadernaÃ§Ã£o atualizaÃ§Ã£o de erro.',0),(45069,1252,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ‚Ð¸Ð¿Ð°.',0),(45070,1252,'es','Error actualizando tipo de encuadernaciÃ³n',0),(45071,1252,'de','Aktualisierung Buchbinderei Fehlertyp.',0),(45072,1252,'en','Error updating bindery type.',0),(45073,1253,'is','',0),(45074,1253,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(45075,1253,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(45076,1253,'tr','Hata gÃ¼ncelleÅŸtirme bÃ¼tÃ§e yÄ±lÄ± iÃ§in',0),(45077,1253,'pl','BÅ‚Ä…d aktualizacji budÅ¼etu na rok',0),(45078,1253,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(45079,1253,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø¨Ø¬Ù¹ Ø¨Ø±Ø§Ø¦Û’ Ø³Ø§Ù„',0),(45080,1253,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð±ÑƒÑŸÐµÑ‚ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(45081,1253,'vi','Cáº­p Nháº­t ngÃ¢n sÃ¡ch cho nÄƒm bá»‹ lá»—i',0),(45082,1253,'af','Fout met opdateer van begroting vir jaar.',0),(45083,1253,'ro','Eroare de actualizare bugetul pentru anul',0),(45084,1253,'et','Viga ajakohastamine aasta eelarve',0),(45085,1253,'si','Napaka pri posodabljanju proraÄuna za leto',0),(45086,1253,'ba','Kesalahan update anggaran untuk tahun',0),(45087,1253,'nl','Fout bijwerken begroting voor jaar',0),(45088,1253,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ vuoden talousarviossa',0),(45089,1253,'no','Feil oppdatering budsjettet for Ã¥ret',0),(45090,1253,'da','Fejl opdatering budget for Ã¥r',0),(45091,1253,'ko','1 ë…„ì— ëŒ€ í•œ ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì˜ˆì‚°',0),(45092,1253,'he','×©×’×™××” ×”×ž×¢×“×›× ×ª ×”×ª×§×¦×™×‘ ×œ×©× ×”',0),(45093,1253,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚',0),(45094,1253,'zh','é”™è¯¯æ›´æ–°çš„å¹´åº¦é¢„ç®—',0),(45095,1253,'sv','Fel uppdatering budget fÃ¶r Ã¥r',0),(45096,1253,'it','Bilancio aggiornamento errore per anno',0),(45097,1253,'tl','',0),(45098,1253,'th','Error updating budget for year',0),(45099,1253,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤œà¤Ÿ',0),(45100,1253,'ms','Ralat pengemaskinian belanjawan bagi tahun',0),(45101,1253,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù„Ù„Ø³Ù†Ø© ',0),(45102,1253,'fr','Bilan des erreurs mise Ã  jour pour l\'annÃ©e',0),(45103,1253,'jp','ã?“ã?®å¹´ã?®äºˆç®—ã?®æ›´æ–°ã?®ã‚¨ãƒ©ãƒ¼',0),(45104,1253,'pt','OrÃ§amento de atualizaÃ§Ã£o de erro para o ano',0),(45105,1253,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð³Ð¾Ð´Ð¾Ð²Ð¾Ð³Ð¾ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(45106,1253,'es','Error actualizando presupuesto del ejercicio',0),(45107,1253,'de','Fehler Update Haushalt fÃ¼r das Jahr',0),(45108,1253,'en','Error updating budget for year',0),(45109,1254,'is','',0),(45110,1254,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(45111,1254,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(45112,1254,'tr','Hata gÃ¼ncelleÅŸtirme taÅŸÄ±yÄ±cÄ±',0),(45113,1254,'pl','BÅ‚Ä…d aktualizacji przewoÅºnika',0),(45114,1254,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(45115,1254,'ur','Ù†Ù‚Øµ Ú©ÛŒØ±ÛŒØ¦Ø± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(45116,1254,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð½Ð¾ÑÐ°Ñ‡',0),(45117,1254,'vi','Cáº­p Nháº­t hÃ£ng váº­n chuyá»ƒn bá»‹ lá»—i',0),(45118,1254,'af','\'n Fout het onstaan met die opdatering van karweier',0),(45119,1254,'ro','Eroare de actualizare transportator',0),(45120,1254,'et','Viga ajakohastamine vedaja',0),(45121,1254,'si','Napaka posodabljanje prevoznik',0),(45122,1254,'ba','Kesalahan update pembawa',0),(45123,1254,'nl','Fout bijwerken vervoerder',0),(45124,1254,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ harjoittaja',0),(45125,1254,'no','Feil oppdatering transportÃ¸r',0),(45126,1254,'da','Fejl opdatering luftfartsselskab',0),(45127,1254,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ìºë¦¬ì–´',0),(45128,1254,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×ž× ×©×',0),(45129,1254,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(45130,1254,'zh','é”™è¯¯æ›´æ–°æ‰¿è¿å•†',0),(45131,1254,'sv','Fel uppdatering bÃ¤rare',0),(45132,1254,'it','Vettore aggiornamento errore',0),(45133,1254,'tl','',0),(45134,1254,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(45135,1254,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¾à¤¹à¤•',0),(45136,1254,'ms','Ralat pengemaskinian pembawa',0),(45137,1254,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù†Ø§Ù‚Ù„',0),(45138,1254,'fr','Support de mise Ã  jour erreur',0),(45139,1254,'jp','é…?é€?æ¥­è€…ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45140,1254,'pt','Transportadora atualizaÃ§Ã£o de erro',0),(45141,1254,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÑƒÑ€ÑŒÐµÑ€Ð°',0),(45142,1254,'es','Error actualizando transportador',0),(45143,1254,'de','Fehler Update TrÃ¤ger',0),(45144,1254,'en','Error updating carrier',0),(45145,1255,'is','',0),(45146,1255,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ú†Ùƒ',0),(45147,1255,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ú†Ùƒ',0),(45148,1255,'tr','Onay gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(45149,1255,'pl','BÅ‚Ä…d podczas aktualizowania wyboru',0),(45150,1255,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(45151,1255,'ur','Ú†ÛŒÚ© Ø§Ù† Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(45152,1255,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(45153,1255,'vi','Cáº­p nháº­t SÃ©c bá»‹ lá»—i',0),(45154,1255,'af','Fout bywerkings kontroleer',0),(45155,1255,'ro','Eroare la actualizarea verifica',0),(45156,1255,'et','Viga ajakohastamine sisse',0),(45157,1255,'si','Napaka pri posodabljanju potrdite',0),(45158,1255,'ba','Kesalahan update check',0),(45159,1255,'nl','Fout bij het bijwerken van selectievakje',0),(45160,1255,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ uloskirjautuminen',0),(45161,1255,'no','Feil under oppdatering av',0),(45162,1255,'da','Fejl under opdatering af check',0),(45163,1255,'ko','í™•ì¸ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(45164,1255,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¡×™×ž×•×Ÿ',0),(45165,1255,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(45166,1255,'zh','é”™è¯¯æ›´æ–°æ£€æŸ¥',0),(45167,1255,'sv','Gick inte att uppdatera check',0),(45168,1255,'it','Errore durante l\'aggiornamento di controllo',0),(45169,1255,'tl','',0),(45170,1255,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3594;&#3655;&#3588;',0),(45171,1255,'hi','à¤šà¥‡à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(45172,1255,'ms','Ralat dalam mengemas kini Daftar',0),(45173,1255,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„ØµÙ‘Ùƒ',0),(45174,1255,'fr','Erreur mise Ã  jour de vÃ©rification',0),(45175,1255,'jp','å°?åˆ‡æ‰‹ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45176,1255,'pt','Erro ao atualizar seleÃ§Ã£o',0),(45177,1255,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(45178,1255,'es','Error actualizando cheque',0),(45179,1255,'de','Fehler beim Aktualisieren der KontrollkÃ¤stchen',0),(45180,1255,'en','Error updating check',0),(45181,1256,'is','',0),(45182,1256,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(45183,1256,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(45184,1256,'tr','Hata gÃ¼ncelleÅŸtirme Ã§ek hesabÄ±',0),(45185,1256,'pl','BÅ‚Ä…d aktualizacji konta bankowego',0),(45186,1256,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(45187,1256,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹',0),(45188,1256,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(45189,1256,'vi','Cáº­p Nháº­t TK SÃ©c Bá»‹ Lá»—i',0),(45190,1256,'af','Fout met opdatering van tjekrekening',0),(45191,1256,'ro','Eroare de actualizare cont de verificare',0),(45192,1256,'et','Viga ajakohastamine pangakonto',0),(45193,1256,'si','Napaka pri posodabljanju preverjanje raÄuna',0),(45194,1256,'ba','Kesalahan update memeriksa rekening',0),(45195,1256,'nl','Fout bijwerken betaalrekening',0),(45196,1256,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tarkkailun huomioon',0),(45197,1256,'no','Feil oppdatering brukskonto',0),(45198,1256,'da','Fejl opdatering checkkonto',0),(45199,1256,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(45200,1256,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×—×©×‘×•×Ÿ ×‘× ×§',0),(45201,1256,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï„ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(45202,1256,'zh','é”™è¯¯æ›´æ–°æ”¯ç¥¨å¸æˆ·\r\n',0),(45203,1256,'sv','Fel uppdatering lÃ¶nekonto',0),(45204,1256,'it','Errore aggiornamento conto corrente',0),(45205,1256,'tl','',0),(45206,1256,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(45207,1256,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤œà¤¾à¤à¤š à¤–à¤¾à¤¤à¥‡',0),(45208,1256,'ms','Ralat pengemaskinian memeriksa akaun',0),(45209,1256,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø§Ø±ÙŠ',0),(45210,1256,'fr','Erreur mise Ã  jour sur le compte courant',0),(45211,1256,'jp','å½“åº§é ?é‡‘ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45212,1256,'pt','AtualizaÃ§Ã£o de conta de erro',0),(45213,1256,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(45214,1256,'es','Error actualizando cuenta de cheques',0),(45215,1256,'de','Fehler Update Girokonto',0),(45216,1256,'en','Error updating checking account',0),(45217,1257,'is','',0),(45218,1257,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø±Ù†Ú¯ ',0),(45219,1257,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø±Ù†Ú¯ ',0),(45220,1257,'tr','Renk gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(45221,1257,'pl','BÅ‚Ä…d podczas aktualizowania kolor.',0),(45222,1257,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†Ð²ÑÑ‚.',0),(45223,1257,'ur','Ø±Ù†Ú¯ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(45224,1257,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð±Ð¾Ñ˜Ð°.',0),(45225,1257,'vi','Lá»—i cáº­p nháº­t máº§u',0),(45226,1257,'af','Fout met opdatering van kleure.',0),(45227,1257,'ro','Eroare la actualizarea culoare.',0),(45228,1257,'et','Viga ajakohastamine vÃ¤rvi.',0),(45229,1257,'si','Napaka pri posodabljanju barvo.',0),(45230,1257,'ba','Kesalahan update warna.',0),(45231,1257,'nl','Fout bij het bijwerken van kleur.',0),(45232,1257,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ vÃ¤ri.',0),(45233,1257,'no','Feil under oppdatering av farge.',0),(45234,1257,'da','Fejl under opdatering af farve.',0),(45235,1257,'ko','ìƒ‰ì„ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(45236,1257,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¦×‘×¢.',0),(45237,1257,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï‡ÏÏŽÎ¼Î±.',0),(45238,1257,'zh','é”™è¯¯æ›´æ–°é¢œè‰²ã€‚\r\n',0),(45239,1257,'sv','Det gick inte att uppdatera fÃ¤rg.',0),(45240,1257,'it','Errore durante l\'aggiornamento di colore.',0),(45241,1257,'tl','',0),(45242,1257,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3637;',0),(45243,1257,'hi','à¤°à¤‚à¤— à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(45244,1257,'ms','Ralat dalam mengemas kini warna.',0),(45245,1257,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù„ÙˆÙ†.',0),(45246,1257,'fr','Erreur mise Ã  jour de couleur.',0),(45247,1257,'jp','è‰²ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45248,1257,'pt','Erro ao atualizar a cor.',0),(45249,1257,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ†Ð²ÐµÑ‚Ð°.',0),(45250,1257,'es','Error actualizando color',0),(45251,1257,'de','Fehler beim Aktualisieren der Farbe.',0),(45252,1257,'en','Error updating color.',0),(45253,1258,'is','',0),(45254,1258,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø´Ø±ÙƒØª',0),(45255,1258,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø´Ø±ÙƒØª',0),(45256,1258,'tr','Hata gÃ¼ncelleÅŸtiren ÅŸirket',0),(45257,1258,'pl','BÅ‚Ä…d aktualizacji firmy',0),(45258,1258,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(45259,1258,'ur','Ù†Ù‚Øµ Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(45260,1258,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(45261,1258,'vi','Cáº­p nháº­t cty bá»‹ lá»—i',0),(45262,1258,'af','Fout met opdatering van onderneming.',0),(45263,1258,'ro','Eroare de actualizare companiei',0),(45264,1258,'et','EttevÃµtte uuendamisel tekkis viga',0),(45265,1258,'si','Napaka posodabljanje podjetja',0),(45266,1258,'ba','Kesalahan update perusahaan',0),(45267,1258,'nl','Fout bijwerken bedrijf',0),(45268,1258,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ yritys',0),(45269,1258,'no','Feil oppdatering selskap',0),(45270,1258,'da','Fejl opdatering selskab',0),(45271,1258,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ íšŒì‚¬',0),(45272,1258,'he','×©×’×™××” ×‘×¢×“×›×•×Ÿ ×—×‘×¨×”',0),(45273,1258,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(45274,1258,'zh','é”™è¯¯æ›´æ–°å…¬å¸',0),(45275,1258,'sv','Fel uppdatering fÃ¶retag',0),(45276,1258,'it','Azienda aggiornamento errore',0),(45277,1258,'tl','',0),(45278,1258,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(45279,1258,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤‚à¤ªà¤¨à¥€',0),(45280,1258,'ms','Ralat pengemaskinian Syarikat',0),(45281,1258,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø´Ø±ÙƒØ©',0),(45282,1258,'fr','SociÃ©tÃ© de mise Ã  jour erreur',0),(45283,1258,'jp','ä¼šç¤¾ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45284,1258,'pt','Empresa atualizaÃ§Ã£o de erro',0),(45285,1258,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(45286,1258,'es','Error actualizando empresa',0),(45287,1258,'de','Fehler Update Firma',0),(45288,1258,'en','Error updating company',0),(45289,1259,'is','',0),(45290,1259,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØªØ±ÙƒÙŠØ¨ ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ  Ù…Ù‚Ø¯Ø§Ø± ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø± ',0),(45291,1259,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØªØ±ÙƒÙŠØ¨ ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ  Ù…Ù‚Ø¯Ø§Ø± ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø± ',0),(45292,1259,'tr','Hata gÃ¼ncelleÅŸtirme bileÅŸik Ã¼st madde eldeki miktar.',0),(45293,1259,'pl','BÅ‚Ä…d aktualizacji kompozytowe nadrzÄ™dnej pozycji z strony iloÅ›Ä‡.',0),(45294,1259,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¸ Ñ€Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð¾Ñ‚ ÑÑ‚Ñ€Ð°Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾.',0),(45295,1259,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø¬Ø§Ù…Ø¹ ÙˆØ§Ù„Ø¯ÛŒÙ† Ù…Ù‚Ø¯Ø§Ø± Ø¬Ø§Ù†Ø¨ Ø´Û’ ÛÛ’ Û”',0),(45296,1259,'sr','Ð“Ñ€ÐµÑˆÐºÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¸Ñ… Ð½Ð°Ð´Ñ€ÐµÑ’ÐµÐ½Ð¾Ð³ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°.',0),(45297,1259,'vi','Lá»—i cáº­p nháº­t sá»‘ lÆ°á»£ng thÃ nh pháº§n hÃ ng cha máº¹ cÃ³ sáºµn',0),(45298,1259,'af','Fout Outobywerking saamgestelde ouer item aan kant hoeveelheid.',0),(45299,1259,'ro','Eroare de actualizare compozit pÄƒrinte elementul pe parte cantitatea.',0),(45300,1259,'et','Viga ajakohastamine komposiit vanem kauba vaba koguse.',0),(45301,1259,'si','Napaka posodabljanje sestavljeni nadrejeni element na strani koliÄino.',0),(45302,1259,'ba','Kesalahan update komposit orangtua item di sisi kuantitas.',0),(45303,1259,'nl','Fout bijwerken samengestelde bovenliggende item aan kant hoeveelheid.',0),(45304,1259,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ komposiitti ylÃ¤tason nimikkeen varastosaldo mÃ¤Ã¤rÃ¤.',0),(45305,1259,'no','Feil oppdatering sammensatt overordnede element pÃ¥ siden antallet.',0),(45306,1259,'da','Fejl opdatering sammensatte overordnede punkt pÃ¥ side mÃ¦ngde.',0),(45307,1259,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë³µí•© ë¶€ëª¨ ì†ì—ì„œ ìˆ˜ëŸ‰ í•­ëª©.',0),(45308,1259,'he','×©×’×™××” ×”×ž×¢×“×›× ×ª ×”××‘ ×œ×œ× ×”×¤×¨×“×•×ª ×¦×‘×¢ ×¤×¨×™×˜ ×ž×¦×“ ×”×›×ž×•×ª.',0),(45309,1259,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÏƒÏÎ½Î¸ÎµÏ„Î± Î³Î¿Î½Î¹ÎºÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï† Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±.',0),(45310,1259,'zh','é”™è¯¯æ›´æ–°æ‰‹å¤´ä¸Šçš„æ•°é‡å¤åˆçˆ¶é¡¹',0),(45311,1259,'sv','Fel uppdatering sammansatta Ã¶verordnad punkt Ã¥ kvantitet.',0),(45312,1259,'it','Padre di composito aggiornamento errore d\' canto voce quantitÃ .',0),(45313,1259,'tl','',0),(45314,1259,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3621;&#3633;&#3585;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3',0),(45315,1259,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤®à¥à¤ªà¥‹à¤œà¤¿à¤Ÿ à¤ªà¥ˆà¤°à¥‡à¤‚à¤Ÿ à¤†à¤‡à¤Ÿà¤® à¤¹à¤¾à¤¥ à¤ªà¤° à¤®à¤¾à¤¤à¥à¤°à¤¾à¥¤',0),(45316,1259,'ms','Ibu bapa komposit ralat pengemaskinian butiran di tangan kuantiti.',0),(45317,1259,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø£ØµÙ„ Ù…Ø±ÙƒØ¨ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¨Ù†Ø¯ Ù…Ù† Ù†Ø§Ø­ÙŠØ© Ø§Ù„ÙƒÙ…ÙŠØ©.',0),(45318,1259,'fr','Parent de composite mise Ã  jour erreur point quant Ã  quantitÃ©.',0),(45319,1259,'jp','Error updating composite parent item on hand quantity.',0),(45320,1259,'pt','Pai composto atualizaÃ§Ã£o de erro por lado item quantidade.',0),(45321,1259,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ Ñ€Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾.',0),(45322,1259,'es','Error actualizando cantidad actual de item de compuesto principal',0),(45323,1259,'de','Fehler Update zusammengesetzte Ã¼bergeordneten Punkt auf Seite Menge.',0),(45324,1259,'en','Error updating composite parent item on hand quantity.',0),(45325,1260,'is','',0),(45326,1260,'dr','Error updating composite sub itemØ®Ø·Ø§ ÙŠ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙƒØ±Ø¯Ù† ØªØ±ÙƒÙŠØ¨ Ø¬Ù†Ø³ ÙØ±Ø¹ÙŠ  Ù…Ù‚Ø¯Ø§Ø± ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ú¯Ø¯Ø§Ù…',0),(45327,1260,'pr','Error updating composite sub itemØ®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØªØ±ÙƒÙŠØ¨ ÙƒØ§Ù„Ø§ÙŠ ÙØ±Ø¹ÙŠ  Ù…Ù‚Ø¯Ø§Ø± ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø±',0),(45328,1260,'tr','Hata gÃ¼ncelleÅŸtirme bileÅŸik alt taraftan miktar madde.',0),(45329,1260,'pl','BÅ‚Ä…d aktualizacji pod kompozytowe z strony pozycji iloÅ›Ä‡.',0),(45330,1260,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¸ Ð¿Ð¾Ð´ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ Ð¾Ñ‚ ÑÑ‚Ñ€Ð°Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾.',0),(45331,1260,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø¬Ø§Ù…Ø¹ Ø°ÛŒÙ„ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø¬Ø§Ù†Ø¨ Ø´Û’ ÛÛ’ Û”',0),(45332,1260,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¸Ñ… Ð¿Ð¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° ÑÐ° ÑÑ‚Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°.',0),(45333,1260,'vi','Cáº­p nháº­t sá»‘ lÆ°á»£ng hÃ ng composite phá»¥ bá»‹ lá»—i',0),(45334,1260,'af','Fout met opdateer van saamgestelde sub-item op hande hoeveelheid.',0),(45335,1260,'ro','Eroare de actualizare compozite sub elementul de pe parte cantitatea.',0),(45336,1260,'et','Viga ajakohastamine komposiit sub kauba vaba koguse.',0),(45337,1260,'si','Napaka posodabljanje kompozitni sub postavko na strani koliÄino.',0),(45338,1260,'ba','Kesalahan update komposit sub item di sisi kuantitas.',0),(45339,1260,'nl','Fout bijwerken samengestelde sub item aan kant hoeveelheid.',0),(45340,1260,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ komposiitti sub nimikkeen varastosaldo mÃ¤Ã¤rÃ¤.',0),(45341,1260,'no','Feil oppdatering sammensatt sub menyelementet pÃ¥ side antallet.',0),(45342,1260,'da','Fejl opdatering sammensatte sub element pÃ¥ side mÃ¦ngde.',0),(45343,1260,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë³µí•© í•˜ìœ„ í•­ëª© ìˆ˜ëŸ‰ì„ ì†ì—ì„œ.',0),(45344,1260,'he','×”×¦×•×œ×œ×ª ×ž×•×¨×›×‘ ×”×ž×¢×“×›× ×ª ×©×’×™××” ×¤×¨×™×˜ ×ž×¦×“ ×”×›×ž×•×ª.',0),(45345,1260,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÏƒÏÎ½Î¸ÎµÏ„Î± Ï…Ï€Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï† Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±.',0),(45346,1260,'zh','é”™è¯¯æ›´æ–°ç»¼åˆåˆ†åœ¨æ‰‹æ•°é‡çš„ç‰©å“ã€‚',0),(45347,1260,'sv','Fel uppdatering sammansatta sub punkt Ã¥ kvantitet.',0),(45348,1260,'it','Sub di composito aggiornamento errore d\' canto voce quantitÃ .',0),(45349,1260,'tl','',0),(45350,1260,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3618;&#3656;&#3629;&#3618;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3',0),(45351,1260,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤®à¥à¤ªà¥‹à¤œà¤¿à¤Ÿ à¤‰à¤ª à¤†à¤‡à¤Ÿà¤® à¤¹à¤¾à¤¥ à¤ªà¤° à¤®à¤¾à¤¤à¥à¤°à¤¾à¥¤',0),(45352,1260,'ms','Ralat pengemaskinian komposit kecil di tangan perkara kuantiti.',0),(45353,1260,'ar','Sub Ø®Ø·Ø£ Ù…Ø±ÙƒØ¨ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¨Ù†Ø¯ Ù…Ù† Ù†Ø§Ø­ÙŠØ© Ø§Ù„ÙƒÙ…ÙŠØ©.',0),(45354,1260,'fr','Erreur mise Ã  jour composite sous-point quant Ã  quantitÃ©.',0),(45355,1260,'jp','Error updating composite sub item on hand quantity.',0),(45356,1260,'pt','AtualizaÃ§Ã£o sub composto de erro por lado item quantidade.',0),(45357,1260,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ¾ÑÑ‚Ð°Ð²Ð½Ñ‹Ñ… sub Ñ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹ Ð¿ÑƒÐ½ÐºÑ‚ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾.',0),(45358,1260,'es','Error actualizando cantidad actual de compuesto de subitem',0),(45359,1260,'de','Fehler Update zusammengesetzten Sub item einerseits Menge.',0),(45360,1260,'en','Error updating composite sub item on hand quantity.',0),(45361,1261,'is','',0),(45362,1261,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(45363,1261,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(45364,1261,'tr','Maliyet merkezi gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(45365,1261,'pl','BÅ‚Ä…d podczas aktualizowania MPK',0),(45366,1261,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(45367,1261,'ur','Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ú©Ø² Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(45368,1261,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(45369,1261,'vi','Cáº­p nháº­t Cost Center bá»‹ lá»—i',0),(45370,1261,'af','Fout met opdatering van koste sentrum.',0),(45371,1261,'ro','Eroare la actualizarea centru de Cost',0),(45372,1261,'et','Kulukeskuse vÃ¤rskendamise tÃµrge',0),(45373,1261,'si','Napaka pri posodabljanju stroÅ¡kovno srediÅ¡Äe',0),(45374,1261,'ba','Kesalahan update biaya Pusat',0),(45375,1261,'nl','Fout bij het bijwerken van de kostenplaats',0),(45376,1261,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ kustannuspaikka',0),(45377,1261,'no','Feil under oppdatering av kostsenter',0),(45378,1261,'da','Fejl under opdatering af bÃ¦reren',0),(45379,1261,'ko','ë¹„ìš© ì„¼í„° ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(45380,1261,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×ž×¨×›×– ×¢×œ×•×™×•×ª',0),(45381,1261,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(45382,1261,'zh','é”™è¯¯æ›´æ–°æˆæœ¬ä¸­å¿ƒã€‚\r\n',0),(45383,1261,'sv','Gick inte att uppdatera kostnadsstÃ¤lle',0),(45384,1261,'it','Errore di aggiornamento centro di costo',0),(45385,1261,'tl','',0),(45386,1261,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;',0),(45387,1261,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(45388,1261,'ms','Ralat dalam mengemas kini Pusat kos',0),(45389,1261,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(45390,1261,'fr','Erreur mise Ã  jour de centre de coÃ»t',0),(45391,1261,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45392,1261,'pt','Erro ao atualizar o centro de custo',0),(45393,1261,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½Ñ‚Ñ€Ð° Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(45394,1261,'es','Error actualizando centro de costos',0),(45395,1261,'de','Fehler beim Aktualisieren der Kostenstelle',0),(45396,1261,'en','Error updating Cost Center',0),(45397,1262,'is','',0),(45398,1262,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(45399,1262,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(45400,1262,'tr','Maliyet Merkezi Aile gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(45401,1262,'pl','BÅ‚Ä…d podczas aktualizowania rodziny centrum kosztÃ³w',0),(45402,1262,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(45403,1262,'ur','Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ú©Ø² Ú©Û’ Ø®Ø§Ù†Ø¯Ø§Ù† Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(45404,1262,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ð·Ð° Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ñƒ',0),(45405,1262,'vi','Cáº­p nháº­t gia Ä‘Ã¬nh Cost Center bá»‹ lá»—i',0),(45406,1262,'af','Fout met opdatering van koste sentrum familie.',0),(45407,1262,'ro','Eroare la actualizarea familie de centru de Cost',0),(45408,1262,'et','Hind Center pere vÃ¤rskendamise tÃµrge',0),(45409,1262,'si','Napaka pri posodabljanju stroÅ¡kov Center druÅ¾ine',0),(45410,1262,'ba','Kesalahan update biaya pusat keluarga',0),(45411,1262,'nl','Fout bij het bijwerken van kosten Center familie',0),(45412,1262,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ kustannus Center-tuoteperheen',0),(45413,1262,'no','Feil under oppdatering av pris Center-produktfamilien',0),(45414,1262,'da','Fejl under opdatering af omkostninger Center familie',0),(45415,1262,'ko','ë¹„ìš© ì„¼í„° ê°€ì¡± ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(45416,1262,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¢×œ×•×ª ×ž×¨×›×– ×”×ž×©×¤×—×”',0),(45417,1262,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(45418,1262,'zh','é”™è¯¯æ›´æ–°æˆæœ¬ä¸­å¿ƒç³»åˆ—\r\n',0),(45419,1262,'sv','Gick inte att uppdatera kostnad Center familj',0),(45420,1262,'it','Errore di aggiornamento costo centro famiglia',0),(45421,1262,'tl','',0),(45422,1262,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;',0),(45423,1262,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(45424,1262,'ms','Ralat dalam mengemas kini keluarga Pusat kos',0),(45425,1262,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« \"Ø§Ù„Ø£Ø³Ø±Ø© Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©\"',0),(45426,1262,'fr','Erreur mise Ã  jour de la famille de centre de coÃ»t',0),(45427,1262,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ç³»çµ±ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45428,1262,'pt','Erro ao atualizar a famÃ­lia de centro de custo',0),(45429,1262,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ†ÐµÐ½Ñ‚Ñ€ ÑÐµÐ¼ÑŒÐ¸',0),(45430,1262,'es','Error actualizando familia de centro de costos',0),(45431,1262,'de','Fehler beim Aktualisieren der Cost-Center-Produktfamilie',0),(45432,1262,'en','Error updating Cost Center Family',0),(45433,1263,'is','',0),(45434,1263,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(45435,1263,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(45436,1263,'tr','Hata gÃ¼ncelleÅŸtirme mÃ¼ÅŸteri',0),(45437,1263,'pl','BÅ‚Ä…d aktualizacji klienta',0),(45438,1263,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(45439,1263,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú¯Ø§ÛÚ©',0),(45440,1263,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(45441,1263,'vi','Lá»—i cáº­p nháº­t khÃ¡ch hÃ ng',0),(45442,1263,'af','Fout met opdatering van KliÃ«nt/Klant',0),(45443,1263,'ro','Eroare client actualizare',0),(45444,1263,'et','Kliendi uuendamisel tekkis viga',0),(45445,1263,'si','Napaka posodabljanje kupca',0),(45446,1263,'ba','Kesalahan update pelanggan',0),(45447,1263,'nl','Fout bijwerken klant',0),(45448,1263,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ asiakkaan',0),(45449,1263,'no','Feil oppdatering kunde',0),(45450,1263,'da','Fejl opdatering kunde',0),(45451,1263,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ê³ ê°',0),(45452,1263,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×”×œ×§×•×—',0),(45453,1263,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(45454,1263,'zh','é”™è¯¯æ›´æ–°å®¢æˆ·\r\n',0),(45455,1263,'sv','Fel uppdatering kund',0),(45456,1263,'it','Cliente aggiornamento errore',0),(45457,1263,'tl','',0),(45458,1263,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(45459,1263,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(45460,1263,'ms','Ralat pengemaskinian pelanggan',0),(45461,1263,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(45462,1263,'fr','Client mise Ã  jour erreur',0),(45463,1263,'jp','é¡§å®¢ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45464,1263,'pt','Cliente de atualizaÃ§Ã£o de erro',0),(45465,1263,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(45466,1263,'es','Error actualizando cliente',0),(45467,1263,'de','Fehler Update Kunden',0),(45468,1263,'en','Error updating customer',0),(45469,1264,'is','',0),(45470,1264,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(45471,1264,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(45472,1264,'tr','MÃ¼ÅŸteri gemiye gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(45473,1264,'pl','BÅ‚Ä…d aktualizacji klienta statku',0),(45474,1264,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(45475,1264,'ur','Ú©Ø³Ù¹Ù…Ø± Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(45476,1264,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐºÑƒÐ¿Ñ†Ð° Ð´Ð° Ð±Ñ€Ð¾Ð´',0),(45477,1264,'vi','Lá»—i khi cáº­p nháº­t Ä‘á»‹a chá»‰ váº­n chuyá»ƒn',0),(45478,1264,'af','Fout met opdateer van KliÃ«nt/Klant Versend Aan',0),(45479,1264,'ro','Eroare la actualizarea nava clientului la',0),(45480,1264,'et','Kliendi tarneaadressi uuendamisel tekkis viga',0),(45481,1264,'si','Napaka pri posodabljanju kupec ladje',0),(45482,1264,'ba','Kesalahan update kapal pelanggan untuk',0),(45483,1264,'nl','Fout bij het bijwerken van klant schip',0),(45484,1264,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ asiakkaan aluksen',0),(45485,1264,'no','Feil under oppdatering av kunden skip',0),(45486,1264,'da','Fejl under opdatering af kunden skib til',0),(45487,1264,'ko','ê³ ê° ë°°ì†¡ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(45488,1264,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×”×œ×§×•×— ×œ×¡×¤×™× ×”',0),(45489,1264,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Ï€Î»Î¿Î¯Î¿ Î½Î±',0),(45490,1264,'zh','é”™è¯¯æ›´æ–°å®¢æˆ·æ”¶è´§åœ°\r\n',0),(45491,1264,'sv','Gick inte att uppdatera kund fartyget till',0),(45492,1264,'it','Errore di aggiornamento cliente nave a',0),(45493,1264,'tl','',0),(45494,1264,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3606;&#3',0),(45495,1264,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(45496,1264,'ms','Ralat dalam mengemas kini kapal pelanggan',0),(45497,1264,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(45498,1264,'fr','Erreur mise Ã  jour client navire Ã ',0),(45499,1264,'jp','é¡§å®¢é…?é€?å…ˆã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45500,1264,'pt','Erro ao atualizar o cliente navio para',0),(45501,1264,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(45502,1264,'es','Error actualizando cliente enviar a',0),(45503,1264,'de','Fehler beim Aktualisieren der Kunde Schiff',0),(45504,1264,'en','Error updating customer ship to',0),(45505,1265,'is','',0),(45506,1265,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ ØªØ®ÙÙŠÙ ',0),(45507,1265,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ ØªØ®ÙÙŠÙ ',0),(45508,1265,'tr','Hata gÃ¼ncelleÅŸtirme kesinti grubu',0),(45509,1265,'pl','BÅ‚Ä…d aktualizacji odliczenia Grupa',0),(45510,1265,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ð°',0),(45511,1265,'ur','Ù†Ù‚Øµ ÙˆØ¶Ø¹ Ú¯Ø±ÙˆÙ¾ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(45512,1265,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð³Ñ€ÑƒÐ¿Ðµ',0),(45513,1265,'vi','Lá»—i cáº­p nháº­t nhÃ³m giáº£m trá»«',0),(45514,1265,'af','Fout Outobywerking aftrekking groep',0),(45515,1265,'ro','Eroare de actualizare deducerea grup',0),(45516,1265,'et','Viga ajakohastamine mahaarvamise grupp',0),(45517,1265,'si','Napaka posodabljanje odbitek skupine',0),(45518,1265,'ba','Kesalahan update pengurangan kelompok',0),(45519,1265,'nl','Fout bijwerken aftrek groep',0),(45520,1265,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ vÃ¤hennys ryhmÃ¤',0),(45521,1265,'no','Feil oppdatering fradrag gruppe',0),(45522,1265,'da','Fejl opdatering fradrag gruppe',0),(45523,1265,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ê³µì œ ê·¸ë£¹',0),(45524,1265,'he','×§×‘×•×¦×ª × ×™×›×•×™ ×”×ž×¢×“×›× ×ª ×©×’×™××”',0),(45525,1265,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚ Î¿Î¼Î¬Î´Î±Ï‚',0),(45526,1265,'zh','é”™è¯¯æ›´æ–°æ‰£ç»„\r\n',0),(45527,1265,'sv','Fel uppdatering avdrag grupp',0),(45528,1265,'it','Gruppo di errore aggiornamento detrazione',0),(45529,1265,'tl','',0),(45530,1265,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3591;&#3636;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(45531,1265,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤¸à¤®à¥‚à¤¹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(45532,1265,'ms','Ralat pengemaskinian potongan Kumpulan',0),(45533,1265,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø®ØµÙ… Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(45534,1265,'fr','Groupe de dÃ©duction erreur mise Ã  jour',0),(45535,1265,'jp','æŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45536,1265,'pt','Grupo de deduÃ§Ã£o atualizaÃ§Ã£o erro',0),(45537,1265,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð²Ñ‹Ñ‡ÐµÑ‚ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(45538,1265,'es','Error actualizando grupo de deducciones',0),(45539,1265,'de','Fehler Update Abzug Gruppe',0),(45540,1265,'en','Error updating deduction group',0),(45541,1266,'is','',0),(45542,1266,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(45543,1266,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(45544,1266,'tr','Hata gÃ¼ncelleÅŸtirme detay iÅŸ tÃ¼rÃ¼',0),(45545,1266,'pl','BÅ‚Ä…d aktualizacji szczegÃ³Å‚Ã³w pracy typu',0),(45546,1266,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(45547,1266,'ur','ØªÙØµÛŒÙ„ Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ú©Ø§Ù… Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª',0),(45548,1266,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð´ÐµÑ‚Ð°Ñ™ Ð²Ñ€ÑÑ‚Ðµ Ñ€Ð°Ð´Ð°',0),(45549,1266,'vi','Lá»—i cáº­p nháº­t chi tiáº¿t loáº¡i cÃ´ng viá»‡c',0),(45550,1266,'af','Fout Outobywerking detail werk tipe',0),(45551,1266,'ro','Eroare de actualizare detaliu de lucru tip',0),(45552,1266,'et','Viga ajakohastamine detail tÃ¶Ã¶ tÃ¼Ã¼p',0),(45553,1266,'si','Posodablja podrobnosti napake dela tip',0),(45554,1266,'ba','Kesalahan update rinci bekerja jenis',0),(45555,1266,'nl','Fout bijwerken detail werksoort',0),(45556,1266,'fi','Virhe pÃ¤ivityksessÃ¤ yksityiskohtaisesti tyÃ¶n tyyppi',0),(45557,1266,'no','Oppdatere feildetaljer arbeidstype',0),(45558,1266,'da','Fejl opdatering detaljer arbejde type',0),(45559,1266,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì„¸ë¶€ ìž‘ì—… í˜•ì‹',0),(45560,1266,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×¤×¨×˜×™× ×œ×¢×‘×•×“ ×¡×•×’',0),(45561,1266,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î¤ÏÏ€Î¿Ï‚ Î­ÏÎ³Î¿Ï…',0),(45562,1266,'zh','é”™è¯¯æ›´æ–°ç»†èŠ‚å·¥ä½œç±»åž‹\r\n',0),(45563,1266,'sv','Fel uppdatering detalj arbetstyp',0),(45564,1266,'it','Tipo di lavoro dettaglio aggiornamento errore',0),(45565,1266,'tl','',0),(45566,1266,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3',0),(45567,1266,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤°',0),(45568,1266,'ms','Ralat pengemaskinian butiran kerja jenis',0),(45569,1266,'ar','Ø§Ù„ØªÙØµÙŠÙ„ ØªØ­Ø¯ÙŠØ« Ø®Ø·Ø£ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(45570,1266,'fr','DÃ©tail de mise Ã  jour erreur type travail',0),(45571,1266,'jp','ä»•äº‹å†…å®¹è©³ç´°ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45572,1266,'pt','Detalhes de atualizaÃ§Ã£o de erro tipo trabalho',0),(45573,1266,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð´ÐµÑ‚Ð°Ð»ÐµÐ¹ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(45574,1266,'es','Error actualizando tipo de trabajo detallado',0),(45575,1266,'de','Aktualisierung Fehlerdetails arbeiten Typ',0),(45576,1266,'en','Error updating detail work type',0),(45577,1267,'is','',0),(45578,1267,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙƒØ§Ø± Ù…Ù†Ø¯ ',0),(45579,1267,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙƒØ§Ø± Ù…Ù†Ø¯ ',0),(45580,1267,'tr','Hata gÃ¼ncelleÅŸtirme Ã§alÄ±ÅŸan',0),(45581,1267,'pl','BÅ‚Ä…d aktualizacji pracownika',0),(45582,1267,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(45583,1267,'ur','Ù†Ù‚Øµ Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(45584,1267,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(45585,1267,'vi','Lá»—i cáº­p nháº­t nhÃ¢n viÃªn',0),(45586,1267,'af','Fout met opdatering van Werknemer ',0),(45587,1267,'ro','Eroare de actualizare angajat',0),(45588,1267,'et','TÃ¶Ã¶taja uuendamisel tekkis viga',0),(45589,1267,'si','Napaka posodabljanje zaposlenega',0),(45590,1267,'ba','Kesalahan update karyawan',0),(45591,1267,'nl','Fout bijwerken werknemer',0),(45592,1267,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tyÃ¶ntekijÃ¤n',0),(45593,1267,'no','Feil oppdatering ansatt',0),(45594,1267,'da','Fejl opdatering medarbejder',0),(45595,1267,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì§ì›',0),(45596,1267,'he','×”×¢×•×‘×“ ×”×ž×¢×“×›× ×ª ×©×’×™××”',0),(45597,1267,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(45598,1267,'zh','é”™è¯¯æ›´æ–°å‘˜å·¥\r\n',0),(45599,1267,'sv','Fel uppdatering anstÃ¤lld',0),(45600,1267,'it','Dipendente aggiornamento errore',0),(45601,1267,'tl','',0),(45602,1267,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(45603,1267,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(45604,1267,'ms','Ralat pengemaskinian pekerja',0),(45605,1267,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆØ¸Ù',0),(45606,1267,'fr','EmployÃ© mise Ã  jour erreur',0),(45607,1267,'jp','å¾“æ¥­å“¡ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45608,1267,'pt','Empregado atualizaÃ§Ã£o de erro',0),(45609,1267,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(45610,1267,'es','Error actualizando empleado',0),(45611,1267,'de','Fehler Update Mitarbeiter',0),(45612,1267,'en','Error updating employee',0),(45613,1268,'is','',0),(45614,1268,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ\r\n ÙƒØ§Ø±Ù…Ù†Ø¯',0),(45615,1268,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ\r\n ÙƒØ§Ø±Ù…Ù†Ø¯',0),(45616,1268,'tr','Ã‡alÄ±ÅŸan gÃ¶zden geÃ§irme gÃ¼ncelleÅŸtirme hatasÄ±.',0),(45617,1268,'pl','BÅ‚Ä…d aktualizacji oceny pracownika.',0),(45618,1268,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´.',0),(45619,1268,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº Û”',0),(45620,1268,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ ÐºÑ€Ð¸Ñ‚Ð¸ÐºÐ°.',0),(45621,1268,'vi','Lá»—i cáº­p nháº­t Ä‘Ã¡nh giÃ¡ nhÃ¢n viÃªn',0),(45622,1268,'af','Fout met opdatering van Werknemer Oorsig.',0),(45623,1268,'ro','Eroare actualizarea opinie angajat.',0),(45624,1268,'et','TÃ¶Ã¶taja iseloomustuse uuendamisel tekkis viga',0),(45625,1268,'si','Napaka posodabljanje zaposlenega pregled.',0),(45626,1268,'ba','Kesalahan update karyawan review.',0),(45627,1268,'nl','Fout bijwerken werknemer beoordeling.',0),(45628,1268,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tyÃ¶ntekijÃ¤n uudelleen.',0),(45629,1268,'no','Feil oppdatering medarbeider vurdering.',0),(45630,1268,'da','Fejl opdatering medarbejder anmeldelse.',0),(45631,1268,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì§ì› ê²€í† ìž…ë‹ˆë‹¤.',0),(45632,1268,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×¡×§×™×¨×” ×”×¢×•×‘×“.',0),(45633,1268,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·.',0),(45634,1268,'zh','é”™è¯¯æ›´æ–°å‘˜å·¥å®¡æŸ¥ã€‚\r\n',0),(45635,1268,'sv','Fel uppdatering anstÃ¤lld Ã¶versyn.',0),(45636,1268,'it','Recensione di dipendente aggiornamento errore.',0),(45637,1268,'tl','',0),(45638,1268,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(45639,1268,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾à¥¤',0),(45640,1268,'ms','Ralat pengemaskinian pekerja kajian.',0),(45641,1268,'ar','Ø®Ø·Ø£ ØªØ­Ø¯ÙŠØ« Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ù…ÙˆØ¸Ù.',0),(45642,1268,'fr','Examen employÃ© mise Ã  jour par erreur.',0),(45643,1268,'jp','å¾“æ¥­å“¡è©•ä¾¡ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45644,1268,'pt','RevisÃ£o de empregado atualizaÃ§Ã£o de erro.',0),(45645,1268,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð·Ð¾Ñ€ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð².',0),(45646,1268,'es','Error actualizando revisiÃ³n de empleado',0),(45647,1268,'de','Fehler Update Mitarbeiter Ã¼berprÃ¼fen.',0),(45648,1268,'en','Error updating employee review.',0),(45649,1269,'is','',0),(45650,1269,'dr','( Ø¨Ø±Ø´ ) Ù…Ø¬Ù…ÙˆØ¹ÙŠ ',0),(45651,1269,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªØ®ÙÙŠÙ ( Ø¨Ø±Ø´ ) ÙƒÙ„ÙŠ ',0),(45652,1269,'tr','Genel kesme bilgileri gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(45653,1269,'pl','BÅ‚Ä…d podczas aktualizowania informacji ogÃ³lnych ciÄ™cia.',0),(45654,1269,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ð±Ñ‰Ð° Ñ€ÑÐ·Ð°Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(45655,1269,'ur','Ø¬Ù†Ø±Ù„ Ú©Ø§Ù¹Ù†Û’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ Û”',0),(45656,1269,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð³Ð»Ð°Ð²Ð½Ðµ ÑÐµÑ‡ÐµÑšÐµ Ð¸Ð½Ñ„Ð¾.',0),(45657,1269,'vi','Lá»—i khi cáº­p nháº­t thÃ´ng tin cáº¯t chung',0),(45658,1269,'af','Fout met opdatering van Algemene \"Cutting\" Inligting',0),(45659,1269,'ro','Eroare la actualizarea informaÅ£ii generale de tÄƒiere.',0),(45660,1269,'et','Viga ajakohastamine Ã¼ldise lÃµikamine info.',0),(45661,1269,'si','Napaka pri posodabljanju sploÅ¡na rezanje info.',0),(45662,1269,'ba','Kesalahan update info umum pemotongan.',0),(45663,1269,'nl','Fout bij het bijwerken van algemene snij info.',0),(45664,1269,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ yleinen leikkaus info.',0),(45665,1269,'no','Feil under oppdatering av generelle kutte info.',0),(45666,1269,'da','Fejl under opdatering af generelle skÃ¦ring info.',0),(45667,1269,'ko','ì¼ë°˜ì ì¸ ê°€ê³µ ì •ë³´ë¥¼ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(45668,1269,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¤×¨×˜×™ ×—×™×ª×•×š ×›×œ×œ×™.',0),(45669,1269,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³ÎµÎ½Î¹ÎºÎ­Ï‚ Ï„Î­Î¼Î½Î¿Ï…ÏƒÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚.',0),(45670,1269,'zh','é”™è¯¯æ›´æ–°ä¸€èˆ¬åˆ‡å‰²ä¿¡æ¯ã€‚\r\n',0),(45671,1269,'sv','Det gick inte att uppdatera allmÃ¤nna skÃ¤rning information.',0),(45672,1269,'it','Errore di aggiornamento informazioni di taglio generale.',0),(45673,1269,'tl','',0),(45674,1269,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(45675,1269,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤Ÿà¤¨à¥‡ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(45676,1269,'ms','Ralat dalam mengemas kini maklumat am memotong.',0),(45677,1269,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª \"Ø¹Ø§Ù…Ø© Ø´Ø§Ù…Ù„Ø©\".',0),(45678,1269,'fr','Erreur mise Ã  jour d\'informations gÃ©nÃ©rales coupe.',0),(45679,1269,'jp','ä¸€èˆ¬å€¤ä¸‹ã?’æƒ…å ±ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45680,1269,'pt','Erro ao atualizar a informaÃ§Ã£o de corte geral.',0),(45681,1269,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¾Ð±Ñ‰ÐµÐ³Ð¾ Ñ€ÐµÐ·ÐºÐ¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(45682,1269,'es','Error actualizando info de Recorte General',0),(45683,1269,'de','Fehler beim Aktualisieren der allgemeinen schneiden-Info.',0),(45684,1269,'en','Error updating General Cutting info.',0),(45685,1270,'is','',0),(45686,1270,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¹Ù…ÙˆÙ…ÙŠ',0),(45687,1270,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¹Ù…ÙˆÙ…ÙŠ',0),(45688,1270,'tr','Genel iÅŸ tÃ¼rÃ¼ gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(45689,1270,'pl','BÅ‚Ä…d podczas aktualizowania pracy ogÃ³lne typu',0),(45690,1270,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ð±Ñ‰Ð°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿',0),(45691,1270,'ur','Ø¹Ù…ÙˆÙ…ÛŒ Ú©Ø§Ù… Ù‚Ø³Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(45692,1270,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð²Ñ€ÑÑ‚Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ñ€Ð°Ð´Ð°',0),(45693,1270,'vi','Lá»—i cáº­p nháº­t loáº¡i cÃ´ng viá»‡c chung',0),(45694,1270,'af','Fout in opdatering van algemene werktipe',0),(45695,1270,'ro','Eroare la actualizarea lucrÄƒri generale tip',0),(45696,1270,'et','Viga ajakohastamine Ã¼ldise tÃ¶Ã¶ tÃ¼Ã¼p',0),(45697,1270,'si','Napaka pri posodabljanju Vrsta sploÅ¡nega dela',0),(45698,1270,'ba','Kesalahan update jenis pekerjaan umum',0),(45699,1270,'nl','Fout bij het bijwerken van algemene werksoort',0),(45700,1270,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ ehdot tyÃ¶n tyyppi',0),(45701,1270,'no','Feil under oppdatering av generelle arbeidstype',0),(45702,1270,'da','Fejl under opdatering af generelle arbejdstype',0),(45703,1270,'ko','ì¼ë°˜ ìž‘ì—… í˜•ì‹ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(45704,1270,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¡×•×’ ×¢×‘×•×“×” ×›×œ×œ×™',0),(45705,1270,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³ÎµÎ½Î¹ÎºÎ­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Ï„ÏÏ€Î¿Ï…',0),(45706,1270,'zh','ä¸€èˆ¬å·¥ä½œç±»åž‹é”™è¯¯æ›´æ–°\r\n',0),(45707,1270,'sv','Gick inte att uppdatera allmÃ¤nna arbetstyp',0),(45708,1270,'it','Errore di aggiornamento tipo lavoro generale',0),(45709,1270,'tl','',0),(45710,1270,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(45711,1270,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(45712,1270,'ms','Ralat dalam mengemas kini kerja-kerja am jenis',0),(45713,1270,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù…',0),(45714,1270,'fr','Erreur mise Ã  jour du type de travail gÃ©nÃ©rales',0),(45715,1270,'jp','ä¸€èˆ¬ä»•äº‹å†…å®¹ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45716,1270,'pt','Erro ao atualizar o tipo de trabalho geral',0),(45717,1270,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð³Ð¾ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(45718,1270,'es','Error actualizando tipo general de trabajo',0),(45719,1270,'de','Fehler beim Aktualisieren der allgemeine Arbeitstyp',0),(45720,1270,'en','Error updating general work type',0),(45721,1271,'is','',0),(45722,1271,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†Ù…ÙˆØ¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„ ',0),(45723,1271,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†Ù…ÙˆØ¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„ ',0),(45724,1271,'tr','GL pasta gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(45725,1271,'pl','BÅ‚Ä…d podczas aktualizowania GL koÅ‚owy',0),(45726,1271,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° GL Ð¿Ð°Ð¹',0),(45727,1271,'ur','Ø¬ÛŒØ¬Û’ Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(45728,1271,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð“Ð› Ð¿Ð¸Ñ‚Ñƒ',0),(45729,1271,'vi','Lá»—i cáº­p nháº­t á»‘ng sá»• cÃ¡i',0),(45730,1271,'af','Fout met opdatering van AG Sirkeldiagram',0),(45731,1271,'ro','Eroare la actualizarea GL plÄƒcintÄƒ',0),(45732,1271,'et','Viga ajakohastamine GL pirukas',0),(45733,1271,'si','Napaka pri posodabljanju GL pie',0),(45734,1271,'ba','Kesalahan update GL pie',0),(45735,1271,'nl','Fout bij het bijwerken van GL taart',0),(45736,1271,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ GL pie',0),(45737,1271,'no','Feil under oppdatering av GL pie',0),(45738,1271,'da','Fejl under opdatering af GL pie',0),(45739,1271,'ko','ì˜¤ë¥˜ GL íŒŒì´ ì—…ë°ì´íŠ¸',0),(45740,1271,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ GL ×¤××™',0),(45741,1271,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· GL Ï€Î¯Ï„Î±',0),(45742,1271,'zh','é”™è¯¯æ›´æ–°æ€»å¸é¥¼çŠ¶å›¾\r\n',0),(45743,1271,'sv','Gick inte att uppdatera GL paj',0),(45744,1271,'it','Errore di aggiornamento torta GL',0),(45745,1271,'tl','',0),(45746,1271,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; GL pie',0),(45747,1271,'hi','à¤œà¥€à¤à¤² à¤ªà¤¾à¤‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(45748,1271,'ms','Ralat dalam mengemas kini pai GL',0),(45749,1271,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« GL Ø¯Ø§Ø¦Ø±ÙŠ',0),(45750,1271,'fr','Erreur mise Ã  jour de tarte GL',0),(45751,1271,'jp','ï¼§ï¼¬ãƒ‘ã‚¤ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45752,1271,'pt','Erro ao atualizar a torta GL',0),(45753,1271,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ GL Ð¿Ð¸Ñ€Ð¾Ð³',0),(45754,1271,'es','Error actualizando LM grÃ¡fica pie',0),(45755,1271,'de','Fehler beim Aktualisieren der GL-Torte',0),(45756,1271,'en','Error updating GL pie',0),(45757,1272,'is','',0),(45758,1272,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„',0),(45759,1272,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„',0),(45760,1272,'tr','Hata gÃ¼ncelleÅŸtirme GL pasta dilimi',0),(45761,1272,'pl','BÅ‚Ä…d aktualizacji GL wycinek',0),(45762,1272,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ GL ÐºÑ€ÑŠÐ³Ð¾Ð²',0),(45763,1272,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ù¾Ø§Ø¦ÛŒ Ù‚Ø§Ø´',0),(45764,1272,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð“Ð› Ð¿Ð¸Ñ‚Ñƒ Ð¸ÑÐµÑ‡Ð°Ðº',0),(45765,1272,'vi','Lá»—i cáº­p nháº­t lÃ¡t cáº¯t á»‘ng sá»• cÃ¡i',0),(45766,1272,'af','Fout met opdatering van AG Sirkeldiagram skyf',0),(45767,1272,'ro','Eroare actualizarea felie de plÄƒcintÄƒ GL',0),(45768,1272,'et','Viga ajakohastamine GL pirukas viil',0),(45769,1272,'si','Napaka posodabljanje GL rezina tortnega grafikona',0),(45770,1272,'ba','Kesalahan update GL pie slice',0),(45771,1272,'nl','Fout bijwerken GL cirkelsegment',0),(45772,1272,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ GL ympyrÃ¤kaavion sektori',0),(45773,1272,'no','Feil oppdatering GL sektor',0),(45774,1272,'da','Fejl opdatering GL cirkeludsnit',0),(45775,1272,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ GL ì›í˜• ì¡°ê°',0),(45776,1272,'he','×©×’×™××ª ×¢×“×›×•×Ÿ GL ×¤×¨×•×¡×ª ×¢×•×’×”',0),(45777,1272,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ GL Ï†Î­Ï„Î±Ï‚ Ï€Î¯Ï„Î±Ï‚',0),(45778,1272,'zh','é”™è¯¯æ›´æ–°æ€»å¸é¥¼çŠ¶å›¾å—\r\n',0),(45779,1272,'sv','Fel uppdatering GL cirkelsektor',0),(45780,1272,'it','Aggiornamento fetta di torta GL errore',0),(45781,1272,'tl','',0),(45782,1272,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; GL pie slice',0),(45783,1272,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ GL à¤ªà¤¾à¤‡ à¤¸à¥à¤²à¤¾à¤‡à¤¸',0),(45784,1272,'ms','Ralat pengemaskinian GL pai slice',0),(45785,1272,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø´Ø±ÙŠØ­Ø© Ù…Ø®Ø·Ø· Ø¯Ø§Ø¦Ø±ÙŠ GL',0),(45786,1272,'fr','Mise Ã  jour tranche de tarte aux GL erreur',0),(45787,1272,'jp','ï¼§ï¼¬ãƒ‘ã‚¤ã‚¹ãƒ©ã‚¤ã‚¹ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45788,1272,'pt','Fatia de torta GL atualizaÃ§Ã£o erro',0),(45789,1272,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ GL ÑÐµÐºÑ‚Ð¾Ñ€Ð° ÐºÑ€ÑƒÐ³Ð¾Ð²Ð¾Ð¹ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¼Ñ‹',0),(45790,1272,'es','Error actualizando LM rebanada de grÃ¡fica pie',0),(45791,1272,'de','Fehler Update GL Kreissegment',0),(45792,1272,'en','Error updating GL pie slice',0),(45793,1273,'is','',0),(45794,1273,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„',0),(45795,1273,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„',0),(45796,1273,'tr','GL pasta dilimi ayrÄ±ntÄ± gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(45797,1273,'pl','BÅ‚Ä…d podczas aktualizowania szczegÃ³Å‚owo kawaÅ‚ek pie GL',0),(45798,1273,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° GL ÐºÑ€ÑŠÐ³Ð¾Ð²Ð° Ð¿Ð°Ñ€Ñ‡Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(45799,1273,'ur','Ø¬ÛŒØ¬Û’ Ù¾Ø§Ø¦ÛŒ Ù‚Ø§Ø´ ØªÙØµÛŒÙ„ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(45800,1273,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð“Ð› Ð¿Ð¸Ñ‚Ñƒ Ð¸ÑÐµÑ‡Ð°Ðº Ð´ÐµÑ‚Ð°Ñ™',0),(45801,1273,'vi','Lá»—i cáº­p nháº­t lÃ¡t cáº¯t á»‘ng sá»• cÃ¡i chi tiáº¿t',0),(45802,1273,'af','Fout met opdatering van AG Sirkeldiagram skyf detail',0),(45803,1273,'ro','Eroare la actualizarea GL plÄƒcintÄƒ felie detaliu',0),(45804,1273,'et','Viga ajakohastamine GL pirukas viil detail',0),(45805,1273,'si','Napaka pri posodabljanju GL pito rezine podrobnosti',0),(45806,1273,'ba','Kesalahan memperbarui GL pie slice detail',0),(45807,1273,'nl','Fout bij het bijwerken van GL taart segment detail',0),(45808,1273,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ GL kakku siivu yksityiskohtaisesti',0),(45809,1273,'no','Feil under oppdatering av GL pai skive detaljer',0),(45810,1273,'da','Fejl under opdatering af GL pie skive detaljer',0),(45811,1273,'ko','ì˜¤ë¥˜ GL íŒŒì´ ì¡°ê° ì„¸ë¶€ ì‚¬í•­ ì—…ë°ì´íŠ¸',0),(45812,1273,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ GL ×¤×™×¨×•×˜ ×¤×¨×•×¡×ª ×¤××™',0),(45813,1273,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· GL Ï€Î¯Ï„Î± Ï†Î­Ï„Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(45814,1273,'zh','é”™è¯¯æ›´æ–°æ€»å¸é¥¼çŠ¶å›¾å—ç»†èŠ‚\r\n',0),(45815,1273,'sv','Gick inte att uppdatera GL paj slice detalj',0),(45816,1273,'it','Errore di aggiornamento dettaglio fetta torta GL',0),(45817,1273,'tl','',0),(45818,1273,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604; GL pie slice',0),(45819,1273,'hi','à¤œà¥€à¤à¤² à¤ªà¤¾à¤‡ à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(45820,1273,'ms','Ralat dalam mengemas kini butiran hirisan pai GL',0),(45821,1273,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« GL Ø§Ù„ØªÙØµÙŠÙ„ Ø´Ø±ÙŠØ­Ø© Ø§Ù„ØªØ®Ø·ÙŠØ· Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠ',0),(45822,1273,'fr','Erreur mise Ã  jour de GL tarte tranche en dÃ©tail',0),(45823,1273,'jp','ï¼§ï¼¬ãƒ‘ã‚¤ã‚¹ãƒ©ã‚¤ã‚¹è©³ç´°ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45824,1273,'pt','Erro ao atualizar detalhes de fatia de torta GL',0),(45825,1273,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ GL ÐºÑ€ÑƒÐ³Ð¾Ð²Ð¾Ð¹ ÑÑ€ÐµÐ· Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(45826,1273,'es','Error actualizando detalle de LM rebanada de grÃ¡fica pie',0),(45827,1273,'de','Fehler beim Aktualisieren der GL Kreis-Scheibe detail',0),(45828,1273,'en','Error updating GL pie slice detail',0),(45829,1274,'is','',0),(45830,1274,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¬ÙˆÙ‡Ø±',0),(45831,1274,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¬ÙˆÙ‡Ø±',0),(45832,1274,'tr','MÃ¼rekkep gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(45833,1274,'pl','BÅ‚Ä…d podczas aktualizowania atramentu.',0),(45834,1274,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾.',0),(45835,1274,'ur','Ø§Ù†Ú© ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(45836,1274,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿ÐµÑ€Ð¾Ð¼.',0),(45837,1274,'vi','Lá»—i cáº­p nháº­t má»±c',0),(45838,1274,'af','Fout bywerking van ink.',0),(45839,1274,'ro','Eroare la actualizarea cernealÄƒ.',0),(45840,1274,'et','Viga ajakohastamine tinti.',0),(45841,1274,'si','Napaka pri posodabljanju Ärnila.',0),(45842,1274,'ba','Kesalahan update tinta.',0),(45843,1274,'nl','Fout bij het bijwerken van de inkt.',0),(45844,1274,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ muste.',0),(45845,1274,'no','Feil under oppdatering av blekk.',0),(45846,1274,'da','Fejl under opdatering af blÃ¦k.',0),(45847,1274,'ko','ìž‰í¬ë¥¼ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(45848,1274,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×“×™×•.',0),(45849,1274,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼ÎµÎ»Î¬Î½Î¹.',0),(45850,1274,'zh','é”™è¯¯æ›´æ–°æ²¹å¢¨ã€‚\r\n',0),(45851,1274,'sv','Det gick inte att uppdatera blÃ¤ck.',0),(45852,1274,'it','Errore durante l\'aggiornamento di inchiostro.',0),(45853,1274,'tl','',0),(45854,1274,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3638;&#3585;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(45855,1274,'hi','à¤‡à¤‚à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(45856,1274,'ms','Ralat dalam mengemas kini dakwat.',0),(45857,1274,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø­Ø¨Ø±.',0),(45858,1274,'fr','Erreur mise Ã  jour d\'encre.',0),(45859,1274,'jp','ã‚¤ãƒ³ã‚¯ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45860,1274,'pt','Erro ao atualizar a tinta.',0),(45861,1274,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ‡ÐµÑ€Ð½Ð¸Ð».',0),(45862,1274,'es','Error actualizando tinta',0),(45863,1274,'de','Fehler beim Aktualisieren der Tinte.',0),(45864,1274,'en','Error updating ink.',0),(45865,1275,'is','',0),(45866,1275,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª  Ø¬ÙˆÙ‡Ø± ',0),(45867,1275,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª  Ø¬ÙˆÙ‡Ø± ',0),(45868,1275,'tr','MÃ¼rekkep bilgi: gÃ¼ncelleÅŸtirme hatasÄ±.',0),(45869,1275,'pl','BÅ‚Ä…d aktualizacji informacji atramentu.',0),(45870,1275,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(45871,1275,'ur','Ù†Ù‚Øµ Ø§Ù†Ú© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(45872,1275,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾ ÑÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°Ð¼Ð°.',0),(45873,1275,'vi','Lá»—i khi cáº­p nháº­t thÃ´ng tin má»±c',0),(45874,1275,'af','Fout met opdateer van ink. Inligting',0),(45875,1275,'ro','Eroare de actualizare cernealÄƒ info.',0),(45876,1275,'et','Viga ajakohastamine tindi info.',0),(45877,1275,'si','Napaka posodabljanje Ärnilo info.',0),(45878,1275,'ba','Kesalahan update tinta info.',0),(45879,1275,'nl','Fout bijwerken inkt info.',0),(45880,1275,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ muste info.',0),(45881,1275,'no','Feil oppdatering blekk info.',0),(45882,1275,'da','Fejl opdatering blÃ¦k info.',0),(45883,1275,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ìž‰í¬ ì •ë³´ìž…ë‹ˆë‹¤.',0),(45884,1275,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×¤×¨×˜×™ ×“×™×•.',0),(45885,1275,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î¼ÎµÎ»Î¬Î½Î¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚.',0),(45886,1275,'zh','é”™è¯¯æ›´æ–°å¢¨æ°´ä¿¡æ¯ã€‚\r\n',0),(45887,1275,'sv','Fel uppdatering blÃ¤ck info.',0),(45888,1275,'it','Informazioni di inchiostro aggiornamento errore.',0),(45889,1275,'tl','',0),(45890,1275,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3627;&#3617;&#3638;&#3585;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(45891,1275,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€à¥¤',0),(45892,1275,'ms','Ralat pengemaskinian maklumat dakwat.',0),(45893,1275,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø­Ø¨Ø±.',0),(45894,1275,'fr','Info encre mise Ã  jour par erreur.',0),(45895,1275,'jp','ã‚¤ãƒ³ã‚¯æƒ…å ±ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45896,1275,'pt','InformaÃ§Ã£o de tinta atualizaÃ§Ã£o de erro.',0),(45897,1275,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‡ÐµÑ€Ð½Ð¸Ð».',0),(45898,1275,'es','Error actualizando info de tinta',0),(45899,1275,'de','Aktualisierung Tinte StÃ¶rungsinfo.',0),(45900,1275,'en','Error updating ink info.',0),(45901,1276,'is','',0),(45902,1276,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(45903,1276,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(45904,1276,'tr','PO gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(45905,1276,'pl','BÅ‚Ä…d podczas aktualizowania PO',0),(45906,1276,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° PO',0),(45907,1276,'ur','Ù¾Ùˆ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(45908,1276,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐŸÐž',0),(45909,1276,'vi','Cáº­p Nháº­t ÄÆ¡n Mua HÃ ng Bá»‹ Lá»—i',0),(45910,1276,'af','Fout met Opdatering van AB',0),(45911,1276,'ro','Eroare la actualizarea PO',0),(45912,1276,'et','Viga ajakohastamine PO',0),(45913,1276,'si','Napaka pri posodabljanju PO',0),(45914,1276,'ba','Kesalahan update PO',0),(45915,1276,'nl','Fout bij het bijwerken van PO',0),(45916,1276,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ PO',0),(45917,1276,'no','Feil under oppdatering av PO',0),(45918,1276,'da','Fejl under opdatering af PO',0),(45919,1276,'ko','í¬ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(45920,1276,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¤×•',0),(45921,1276,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· PO',0),(45922,1276,'zh','é”™è¯¯æ›´æ–°é‡‡è´­è®¢å•\r\n',0),(45923,1276,'sv','Gick inte att uppdatera PO',0),(45924,1276,'it','Errore di aggiornamento PO',0),(45925,1276,'tl','',0),(45926,1276,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(45927,1276,'hi','PO à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(45928,1276,'ms','Ralat dalam mengemas kini PO',0),(45929,1276,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¨Ùˆ',0),(45930,1276,'fr','Erreur mise Ã  jour PO',0),(45931,1276,'jp','POæ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45932,1276,'pt','Erro ao atualizar PO',0),(45933,1276,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ PO',0),(45934,1276,'es','Error actualizando OC',0),(45935,1276,'de','Fehler beim Aktualisieren der PO',0),(45936,1276,'en','Error updating PO',0),(45937,1277,'is','',0),(45938,1277,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ÙØ§ÙƒØªÙˆØ± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(45939,1277,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ÙØ§ÙƒØªÙˆØ± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(45940,1277,'tr','Stok PO bilgileri gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(45941,1277,'pl','BÅ‚Ä…d podczas aktualizowania spisu PO szczegÃ³Å‚y',0),(45942,1277,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ð¿Ð¸ÑÐ° PO Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(45943,1277,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù¾Ùˆ ØªÙØµÛŒÙ„Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(45944,1277,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð·Ð°Ð»Ð¸Ñ…Ð° ÐŸÐž Ð´ÐµÑ‚Ð°Ñ™Ð¸Ð¼Ð°',0),(45945,1277,'vi','Cáº­p Nháº­t Chi Tiáº¿t HÃ ng HÃ³a Cho ÄÆ¡n Mua HÃ ng Bá»‹ Lá»—i ',0),(45946,1277,'af','Fout met Opdatering van inventaris AB details',0),(45947,1277,'ro','Eroare la actualizarea inventarului PO detalii',0),(45948,1277,'et','Viga ajakohastamine varude PO Ã¼ksikasjad',0),(45949,1277,'si','Napaka pri posodabljanju zaloge PO podrobnosti',0),(45950,1277,'ba','Kesalahan memperbarui rincian persediaan PO',0),(45951,1277,'nl','Fout bij het bijwerken van de inventaris PO details',0),(45952,1277,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ inventoinnin PO',0),(45953,1277,'no','Feil under oppdatering av lagerinformasjon PO',0),(45954,1277,'da','Fejl under opdatering af lageret PO detaljer',0),(45955,1277,'ko','ìž¬ê³  PO ì„¸ë¶€ ì •ë³´ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(45956,1277,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¤×¨×˜×™× ×ž×œ××™ ×¤×•',0),(45957,1277,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ PO Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(45958,1277,'zh','é”™è¯¯æ›´æ–°åº“å­˜è®¢å•ç»†èŠ‚\r\n',0),(45959,1277,'sv','Gick inte att uppdatera lagret PO Detaljer',0),(45960,1277,'it','Errore di aggiornamento dettagli inventario PO',0),(45961,1277,'tl','',0),(45962,1277,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3',0),(45963,1277,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤ªà¥‹ à¤µà¤¿à¤µà¤°à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(45964,1277,'ms','Ralat dalam mengemas kini butiran inventori PO',0),(45965,1277,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¨Ùˆ',0),(45966,1277,'fr','Erreur mise Ã  jour des informations d\'inventaire PO',0),(45967,1277,'jp','åœ¨åº«ç™ºæ³¨æ›¸è©³ç´°ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(45968,1277,'pt','Erro ao atualizar detalhes de inventÃ¡rio PO',0),(45969,1277,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ð¹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð Ð¾',0),(45970,1277,'es','Error actualizando detalles de OC de inventario',0),(45971,1277,'de','Fehler beim Aktualisieren der Inventurdetails PO',0),(45972,1277,'en','Error updating inventory PO details',0),(45973,1278,'is','',0),(45974,1278,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙƒØªÙˆØ± ',0),(45975,1278,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙƒØªÙˆØ± ',0),(45976,1278,'tr','Hata gÃ¼ncelleme fatura',0),(45977,1278,'pl','BÅ‚Ä…d aktualizacji faktury',0),(45978,1278,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(45979,1278,'ur','Ù†Ù‚Øµ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(45980,1278,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(45981,1278,'vi','Lá»—i cáº­p nháº­t hÃ³a Ä‘Æ¡n',0),(45982,1278,'af','Fout met opdatering van faktuur',0),(45983,1278,'ro','Eroare de actualizare facturÄƒ',0),(45984,1278,'et','Viga ajakohastamine arve',0),(45985,1278,'si','Napaka pri posodabljanju raÄuna',0),(45986,1278,'ba','Kesalahan update faktur',0),(45987,1278,'nl','Fout bijwerken factuur',0),(45988,1278,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ laskun',0),(45989,1278,'no','Feil oppdatering faktura',0),(45990,1278,'da','Fejl opdatering faktura',0),(45991,1278,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì†¡ìž¥',0),(45992,1278,'he','×©×›×™××” ×‘×¢×“×›×•×Ÿ ×—×©×‘×•× ×™×ª',0),(45993,1278,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(45994,1278,'zh','é”™è¯¯æ›´æ–°å‘ç¥¨\r\n',0),(45995,1278,'sv','Fel uppdatering faktura',0),(45996,1278,'it','Fattura aggiornamento errore',0),(45997,1278,'tl','',0),(45998,1278,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(45999,1278,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤šà¤¾à¤²à¤¾à¤¨',0),(46000,1278,'ms','Ralat pengemaskinian invois',0),(46001,1278,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(46002,1278,'fr','Facture de mise Ã  jour erreur',0),(46003,1278,'jp','è«‹æ±‚æ›¸ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46004,1278,'pt','Factura de atualizaÃ§Ã£o de erro',0),(46005,1278,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÑ‡ÐµÑ‚Ð°',0),(46006,1278,'es','Error actualizando factura',0),(46007,1278,'de','Fehler Update Rechnung',0),(46008,1278,'en','Error updating invoice',0),(46009,1279,'is','',0),(46010,1279,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(46011,1279,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(46012,1279,'tr','Hata gÃ¼ncelleme fatura ÅŸartlarÄ±',0),(46013,1279,'pl','BÅ‚Ä…d aktualizacji faktury warunki',0),(46014,1279,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(46015,1279,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª',0),(46016,1279,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÑƒÑÐ»Ð¾Ð²Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(46017,1279,'vi','Lá»—i cáº­p nháº­t Ä‘iá»u kiá»‡n hÃ³a Ä‘Æ¡n',0),(46018,1279,'af','Fout met opdatering van faktuurterme',0),(46019,1279,'ro','Eroare de actualizare facturÄƒ termeni',0),(46020,1279,'et','Viga ajakohastamine arve tingimused',0),(46021,1279,'si','Napaka pogoje za posodabljanje raÄuna',0),(46022,1279,'ba','Kesalahan update faktur persyaratan',0),(46023,1279,'nl','Fout bijwerken factuur voorwaarden',0),(46024,1279,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ laskun ehtojen',0),(46025,1279,'no','Feil oppdatering faktureringsvilkÃ¥r',0),(46026,1279,'da','Fejl opdatering faktura vilkÃ¥r',0),(46027,1279,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì†¡ìž¥ ìš©ì–´',0),(46028,1279,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×—×©×‘×•× ×™×ª ×ª× ××™',0),(46029,1279,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(46030,1279,'zh','é”™è¯¯æ›´æ–°å‘ç¥¨æ¡æ¬¾\r\n',0),(46031,1279,'sv','Fel uppdatering faktura villkor',0),(46032,1279,'it','Condizioni di errore aggiornamento fattura',0),(46033,1279,'tl','',0),(46034,1279,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3',0),(46035,1279,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(46036,1279,'ms','Ralat pengemaskinian invois terma-terma',0),(46037,1279,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø´Ø±ÙˆØ· Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(46038,1279,'fr','Mise Ã  jour termes de facture d\'erreur',0),(46039,1279,'jp','è«‹æ±‚æ?¡ä»¶ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46040,1279,'pt','Termos de atualizaÃ§Ã£o de erro factura',0),(46041,1279,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð°',0),(46042,1279,'es','Error actualizando tÃ©rminos de factura',0),(46043,1279,'de','Fehler Update Rechnung hinsichtlich',0),(46044,1279,'en','Error updating invoice terms',0),(46045,1280,'is','',0),(46046,1280,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§ ',0),(46047,1280,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§ ',0),(46048,1280,'tr','GÃ¼ncelleÅŸtirme Ã¶ÄŸesi hatasÄ±',0),(46049,1280,'pl','BÅ‚Ä…d aktualizacji elementu',0),(46050,1280,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(46051,1280,'ur','Ù†Ù‚Øµ Ø´Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(46052,1280,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(46053,1280,'vi','Cáº­p nháº­t hÃ ng bá»‹ lá»—i',0),(46054,1280,'af','Fout met opdateer van item',0),(46055,1280,'ro','Eroare de actualizare articol',0),(46056,1280,'et','Toote uuendamisel ilmnes viga',0),(46057,1280,'si','Posodabljanje element napaka',0),(46058,1280,'ba','Kesalahan update item',0),(46059,1280,'nl','Fout bijwerken item',0),(46060,1280,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ kohteen',0),(46061,1280,'no','Feil oppdatering elementet',0),(46062,1280,'da','Fejl opdatering elementet',0),(46063,1280,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ í•­ëª©',0),(46064,1280,'he','×©×’×™××” ×‘×¢×“×›×•×Ÿ ×¤×¨×™×˜',0),(46065,1280,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(46066,1280,'zh','é”™è¯¯æ›´æ–°é¡¹ç›®\r\n',0),(46067,1280,'sv','Fel uppdatera objekt',0),(46068,1280,'it','Errore aggiornamento elemento',0),(46069,1280,'tl','',0),(46070,1280,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(46071,1280,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤†à¤‡à¤Ÿà¤®',0),(46072,1280,'ms','Ralat pengemaskinian item',0),(46073,1280,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„ØµÙ†Ù',0),(46074,1280,'fr','Erreur mise Ã  jour de l\'Ã©lÃ©ment',0),(46075,1280,'jp','å“?ç›®ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46076,1280,'pt','Item atualizaÃ§Ã£o de erro',0),(46077,1280,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(46078,1280,'es','Error actualizando item',0),(46079,1280,'de','Fehler Update Element',0),(46080,1280,'en','Error updating item',0),(46081,1281,'is','',0),(46082,1281,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ ',0),(46083,1281,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ ',0),(46084,1281,'tr','Hata gÃ¼ncelleme madde kategorisi.',0),(46085,1281,'pl','BÅ‚Ä…d aktualizacji pozycji kategorii.',0),(46086,1281,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ».',0),(46087,1281,'ur','Ù†Ù‚Øµ Ø´Û’ Ø²Ù…Ø±Û ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(46088,1281,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°.',0),(46089,1281,'vi','Cáº­p nháº­t thá»ƒ loáº¡i hÃ ng bá»‹ lá»—i',0),(46090,1281,'af','Fout met opdateer van item kategorie.',0),(46091,1281,'ro','Eroare de actualizare categorie de articole.',0),(46092,1281,'et','Tootekategooria uuendamisel ilmnes viga',0),(46093,1281,'si','Napaka posodabljanje kategoriji artikla.',0),(46094,1281,'ba','Kesalahan update item kategori.',0),(46095,1281,'nl','Fout bijwerken artikelcategorie.',0),(46096,1281,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ kohteen luokka.',0),(46097,1281,'no','Feil oppdatering varekategori.',0),(46098,1281,'da','Fejl opdatering varekategori.',0),(46099,1281,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ í•­ëª© ë²”ì£¼ìž…ë‹ˆë‹¤.',0),(46100,1281,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×¤×¨×™×˜ ×§×˜×’×•×¨×™×”.',0),(46101,1281,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ¹Î´ÏŽÎ½.',0),(46102,1281,'zh','é”™è¯¯æ›´æ–°é¡¹ç›®ç±»åˆ«ã€‚\r\n',0),(46103,1281,'sv','Fel uppdatering artikelkategori.',0),(46104,1281,'it','Aggiornamento categoria elemento di errore.',0),(46105,1281,'tl','',0),(46106,1281,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(46107,1281,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€à¥¤',0),(46108,1281,'ms','Ralat pengemaskinian item kategori.',0),(46109,1281,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« ØªØµÙ†ÙŠÙ Ø§Ù„ØµÙ†Ù',0),(46110,1281,'fr','Mise Ã  jour point catÃ©gorie d\'erreur.',0),(46111,1281,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46112,1281,'pt','Categoria de item atualizaÃ§Ã£o de erro.',0),(46113,1281,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð°.',0),(46114,1281,'es','Error actualizando categorÃ­a de item',0),(46115,1281,'de','Fehler Update Positionstyp.',0),(46116,1281,'en','Error updating item category.',0),(46117,1282,'is','',0),(46118,1282,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØªØ±ÙƒÙŠØ¨ ÙƒØ§Ù„Ø§',0),(46119,1282,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØªØ±ÙƒÙŠØ¨ ÙƒØ§Ù„Ø§',0),(46120,1282,'tr','Hata gÃ¼ncelleÅŸtirme Ã¶ÄŸesi kompozit',0),(46121,1282,'pl','BÅ‚Ä…d aktualizacji elementu kompozytÃ³w',0),(46122,1282,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚',0),(46123,1282,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø´Û’ Ù…Ø±Ú©Ø¨',0),(46124,1282,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(46125,1282,'vi','Cáº­p nháº­t hÃ ng composite bá»‹ lá»—i',0),(46126,1282,'af','Fout met opdateer van saamgestelde item.',0),(46127,1282,'ro','Eroare de actualizare articol compozit',0),(46128,1282,'et','Viga ajakohastamine kauba komposiit',0),(46129,1282,'si','Napaka posodabljanje element kompozitni',0),(46130,1282,'ba','Kesalahan update item komposit',0),(46131,1282,'nl','Fout bijwerken item composiet',0),(46132,1282,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ kohteen komposiitti',0),(46133,1282,'no','Feil oppdatering element kompositt',0),(46134,1282,'da','Fejl opdatering vare sammensatte',0),(46135,1282,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ í•­ëª© í•©ì„±',0),(46136,1282,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×¤×¨×™×˜ ×ž×•×¨×›×‘',0),(46137,1282,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÏÎ½Î¸ÎµÏ„Î¿',0),(46138,1282,'zh','é”™è¯¯æ›´æ–°é¡¹ç›®çš„ç»¼åˆ\r\n',0),(46139,1282,'sv','Fel uppdatera objektet komposit',0),(46140,1282,'it','Composito di elemento aggiornamento errore',0),(46141,1282,'tl','',0),(46142,1282,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3586;&#3',0),(46143,1282,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤†à¤‡à¤Ÿà¤® à¤•à¤®à¥à¤ªà¥‹à¤œà¤¿à¤Ÿ',0),(46144,1282,'ms','Ralat pengemaskinian butiran Komposit',0),(46145,1282,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« ØµÙ†Ù Ù…Ø±ÙƒÙ‘Ø¨',0),(46146,1282,'fr','Composite de point mise Ã  jour erreur',0),(46147,1282,'jp','è¤‡å?ˆå“?ç›®ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46148,1282,'pt','Composto de item atualizaÃ§Ã£o erro',0),(46149,1282,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚',0),(46150,1282,'es','Error actualizando compuesto de item',0),(46151,1282,'de','Fehler Update Element composite',0),(46152,1282,'en','Error updating item composite',0),(46153,1283,'is','',0),(46154,1283,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø­Ù„ ÙƒØ§Ù„Ø§',0),(46155,1283,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø­Ù„ ÙƒØ§Ù„Ø§',0),(46156,1283,'tr','Hata gÃ¼ncelleÅŸtirme Ã¶ÄŸesi konumu',0),(46157,1283,'pl','BÅ‚Ä…d aktualizacji lokalizacji elementu',0),(46158,1283,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¼ÐµÑÑ‚Ð¾Ð½Ð°Ñ…Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(46159,1283,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø´Û’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(46160,1283,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(46161,1283,'vi','Cáº­p nháº­t vá»‹ trÃ­ hÃ ng bá»‹ lá»—i',0),(46162,1283,'af','Fout met opdateer van item ligging.',0),(46163,1283,'ro','Eroare de actualizare articol locaÅ£ie',0),(46164,1283,'et','Toote asukoha uuendamisel ilmnes viga',0),(46165,1283,'si','Napaka pri posodabljanju mesto elementa',0),(46166,1283,'ba','Kesalahan memperbarui lokasi di-tempat',0),(46167,1283,'nl','Fout bijwerken objectlocatie',0),(46168,1283,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ kohteen sijainti',0),(46169,1283,'no','Feil oppdatering elementplasseringen',0),(46170,1283,'da','Fejl opdatering emnets placering',0),(46171,1283,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ í•­ëª© ìœ„ì¹˜',0),(46172,1283,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×ž×™×§×•× ×¤×¨×™×˜',0),(46173,1283,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¸Î­ÏƒÎ·',0),(46174,1283,'zh','é”™è¯¯æ›´æ–°é¡¹ç›®ä½ç½®\r\n',0),(46175,1283,'sv','Uppdatera objekt plats',0),(46176,1283,'it','Posizione elemento aggiornamento errore',0),(46177,1283,'tl','',0),(46178,1283,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(46179,1283,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨',0),(46180,1283,'ms','Ralat pengemaskinian butiran lokasi',0),(46181,1283,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù…ÙˆÙ‚Ø¹ Ø§Ù„ØµÙ†Ù',0),(46182,1283,'fr','Mise Ã  jour emplacement d\'Ã©lÃ©ment error',0),(46183,1283,'jp','å“?ç›®é…?ç½®ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46184,1283,'pt','LocalizaÃ§Ã£o de item atualizaÃ§Ã£o erro',0),(46185,1283,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(46186,1283,'es','Error actualizando ubicaciÃ³n de item',0),(46187,1283,'de','Fehler Update Artikelstandort',0),(46188,1283,'en','Error updating item location',0),(46189,1284,'is','',0),(46190,1284,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ ',0),(46191,1284,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ ',0),(46192,1284,'tr','Hata gÃ¼ncelleÅŸtirme Ã¶ÄŸenin konumu maliyet',0),(46193,1284,'pl','BÅ‚Ä…d aktualizacji pozycji lokalizacji kosztÃ³w',0),(46194,1284,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° ÑÐµÐ±ÐµÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(46195,1284,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø´Û’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(46196,1284,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(46197,1284,'vi','Cáº­p nháº­t giÃ¡ thÃ nh theo vá»‹ trÃ­ bá»‹ lá»—i',0),(46198,1284,'af','Fout met opdateer van item liggingkostes.',0),(46199,1284,'ro','Eroare de actualizare locaÅ£ie cost articol',0),(46200,1284,'et','Viga ajakohastamine kauba asukoha kulu',0),(46201,1284,'si','Napaka posodabljanje lokacije stroÅ¡ek artikla',0),(46202,1284,'ba','Kesalahan update item lokasi biaya',0),(46203,1284,'nl','Fout bijwerken kostprijs locatie',0),(46204,1284,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ sijainti nimikekustannus',0),(46205,1284,'no','Feil oppdatering plassering varekostnader',0),(46206,1284,'da','Fejl opdatering kostpris (placering)',0),(46207,1284,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ í•­ëª© ìœ„ì¹˜ ë¹„ìš©',0),(46208,1284,'he','×¢×œ×•×ª ×ž×™×§×•× ×”×¤×¨×™×˜ ×”×ž×¢×“×›× ×ª ×©×’×™××”',0),(46209,1284,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÎµÎ¯Î´Î¿Ï…Ï‚ Î¸Î­ÏƒÎ·',0),(46210,1284,'zh','é”™è¯¯æ›´æ–°é¡¹ç›®æ‰€åœ¨åœ°çš„æˆæœ¬\r\n',0),(46211,1284,'sv','Fel uppdatera artikelkostnad lÃ¤ge',0),(46212,1284,'it','Costo di posizione errore aggiornamento articolo',0),(46213,1284,'tl','',0),(46214,1284,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3',0),(46215,1284,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨ à¤²à¤¾à¤—à¤¤',0),(46216,1284,'ms','Ralat pengemaskinian butiran lokasi kos',0),(46217,1284,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¨Ù†Ø¯ Ù…ÙˆÙ‚Ø¹ Ø§Ù„ØªÙƒÙ„ÙØ©',0),(46218,1284,'fr','CoÃ»t de localisation sur l\'article mise Ã  jour erreur',0),(46219,1284,'jp','Error updating item location cost',0),(46220,1284,'pt','Custo de localizaÃ§Ã£o item atualizaÃ§Ã£o erro',0),(46221,1284,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(46222,1284,'es','Error actualizando costo de item ubicaciÃ³n',0),(46223,1284,'de','Fehler Update Lage Artikelkosten',0),(46224,1284,'en','Error updating item location cost',0),(46225,1285,'is','',0),(46226,1285,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± ÙƒØ§Ù„Ø§ÙŠ  Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø± ',0),(46227,1285,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± ÙƒØ§Ù„Ø§ÙŠ  Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø± ',0),(46228,1285,'tr','GÃ¼ncelleÅŸtirme hatasÄ± madde eldeki miktar.',0),(46229,1285,'pl','BÅ‚Ä…d podczas aktualizowania pozycji strony na iloÅ›Ä‡.',0),(46230,1285,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€ÑŠÐºÐ° Ñ‚Ð¾Ñ‡ÐºÐ° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾.',0),(46231,1285,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø´Û’ Ø¬Ø§Ù†Ø¨ Ù…Ù‚Ø¯Ø§Ø± ÛÛ’ Û”',0),(46232,1285,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÑÐ° ÑÑ‚Ñ€Ð°Ð½Ðµ ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ¸.',0),(46233,1285,'vi','Cáº­p nháº­t sá»‘ lÆ°á»£ng hÃ ng hiá»‡n cÃ³ bá»‹ lá»—i',0),(46234,1285,'af','Fout met opdatering van item hoeveelheid op hande.',0),(46235,1285,'ro','Eroare de actualizare pe parte elementul cantitatea.',0),(46236,1285,'et','Viga ajakohastamine kauba vaba koguse.',0),(46237,1285,'si','Napaka pri posodabljanju postavko na strani koliÄino.',0),(46238,1285,'ba','Kesalahan update item di sisi kuantitas.',0),(46239,1285,'nl','Fout bijwerken punt aan kant hoeveelheid.',0),(46240,1285,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ nimikkeen varastosaldo mÃ¤Ã¤rÃ¤.',0),(46241,1285,'no','Feil oppdatering element pÃ¥ siden antallet.',0),(46242,1285,'da','Fejl opdatering punkt pÃ¥ side mÃ¦ngde.',0),(46243,1285,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ í•­ëª© ìˆ˜ëŸ‰ì„ ì†ì—ì„œ.',0),(46244,1285,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×¤×¨×™×˜ ×ž×¦×“ ×”×›×ž×•×ª.',0),(46245,1285,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¬Î¸Î¿Ï…Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï† Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±.',0),(46246,1285,'zh','é”™è¯¯æ›´æ–°æ‰‹å¤´ä¸Šçš„é¡¹ç›®æ•°é‡\r\n',0),(46247,1285,'sv','Error uppdaterar punkt Ã¥ kvantitet.',0),(46248,1285,'it','Errore aggiornamento sul mano elemento quantitativo.',0),(46249,1285,'tl','',0),(46250,1285,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3617;&#3',0),(46251,1285,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤†à¤‡à¤Ÿà¤® à¤¹à¤¾à¤¥ à¤ªà¤° à¤®à¤¾à¤¤à¥à¤°à¤¾à¥¤',0),(46252,1285,'ms','Ralat pengemaskinian butiran di tangan kuantiti.',0),(46253,1285,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¨Ù†Ø¯ Ù…Ù† Ù†Ø§Ø­ÙŠØ© Ø§Ù„ÙƒÙ…ÙŠØ©.',0),(46254,1285,'fr','Erreur mise Ã  jour le point quant Ã  quantitÃ©.',0),(46255,1285,'jp','Error updating item on hand quantity.',0),(46256,1285,'pt','Quantidade de erro atualizando item por lado.',0),(46257,1285,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ñ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹ Ð¿ÑƒÐ½ÐºÑ‚ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾.',0),(46258,1285,'es','Error actualizando cantidad de items en reserva',0),(46259,1285,'de','Fehler beim Aktualisieren der Position auf Seite Menge.',0),(46260,1285,'en','Error updating item on hand quantity.',0),(46261,1286,'is','',0),(46262,1286,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø§Ø´ÙŠÙ† ',0),(46263,1286,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø§Ø´ÙŠÙ† ',0),(46264,1286,'tr','Hata gÃ¼ncelleÅŸtirme makine.',0),(46265,1286,'pl','BÅ‚Ä…d aktualizacji komputera.',0),(46266,1286,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð°.',0),(46267,1286,'ur','Ù†Ù‚Øµ Ù…Ø´ÛŒÙ† Ú©Ùˆ ØªØ§Ø²Û Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(46268,1286,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¼Ð°ÑˆÐ¸Ð½Ð°.',0),(46269,1286,'vi','Lá»—i cáº­p nháº­t mÃ¡y ',0),(46270,1286,'af','Fout Outobywerking masjien.',0),(46271,1286,'ro','Actualizarea de eroare maÅŸinÄƒ.',0),(46272,1286,'et','Viga ajakohastamine masin.',0),(46273,1286,'si','Napaka pri posodabljanju stroj.',0),(46274,1286,'ba','Kesalahan memperbarui mesin.',0),(46275,1286,'nl','Fout bijwerken machine.',0),(46276,1286,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ kone.',0),(46277,1286,'no','Feil oppdatering maskin.',0),(46278,1286,'da','Fejl opdatering maskine.',0),(46279,1286,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ê¸°ê³„ìž…ë‹ˆë‹¤.',0),(46280,1286,'he','×©×’×™××” ×ž×›×•× ×ª ×”×ž×¢×“×›× ×ª.',0),(46281,1286,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î¼Î·Ï‡Î±Î½Î®.',0),(46282,1286,'zh','é”™è¯¯æ›´æ–°æœºå™¨ã€‚\r\n',0),(46283,1286,'sv','Fel uppdatering maskin.',0),(46284,1286,'it','Macchina aggiornamento errore.',0),(46285,1286,'tl','',0),(46286,1286,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(46287,1286,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤®à¤¶à¥€à¤¨à¥¤',0),(46288,1286,'ms','Ralat pengemaskinian Mesin.',0),(46289,1286,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¬Ù‡Ø§Ø².',0),(46290,1286,'fr','Erreur mise Ã  jour l\'appareil.',0),(46291,1286,'jp','æ©Ÿæ¢°ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46292,1286,'pt','MÃ¡quina de atualizaÃ§Ã£o de erro.',0),(46293,1286,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹.',0),(46294,1286,'es','Error actualizando mÃ¡quina',0),(46295,1286,'de','Fehler Update Maschine.',0),(46296,1286,'en','Error updating machine.',0),(46297,1287,'is','',0),(46298,1287,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ ÙƒØ§Ù„Ø§ ',0),(46299,1287,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ ÙƒØ§Ù„Ø§ ',0),(46300,1287,'tr','YazdÄ±rÄ±lmayan madde madde ile gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(46301,1287,'pl','BÅ‚Ä…d podczas aktualizowania niedrukowalne materiaÅ‚u z przedmiotu',0),(46302,1287,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð½Ð¸Ñ‚Ðµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð» Ñ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(46303,1287,'ur','ØºÛŒØ± Ø·Ø¨Ø§Ø¹Øª Ù…Ø§Ø¯ÛŒ Ø´Û’ Ú©Û’ Ø³Ø§ØªÚ¾ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(46304,1287,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐºÐ¾Ñ˜Ð° ÑÐµ Ð½Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð» ÑÐ° ÑÑ‚Ð°Ð²ÐºÐ¾Ð¼',0),(46305,1287,'vi','Lá»—i cáº­p nháº­t nguyÃªn liá»‡u khÃ´ng in vá»›i hÃ ng',0),(46306,1287,'af','Fout nie-druk materiaal met item bywerking',0),(46307,1287,'ro','Eroare la actualizarea nu se imprimÄƒ materialul cu element',0),(46308,1287,'et','Viga ajakohastamine printimatu materjali kaubaga',0),(46309,1287,'si','Napaka pri posodabljanju tiskano gradivo z elementom',0),(46310,1287,'ba','Kesalahan update bebas-Percetakan bahan dengan item',0),(46311,1287,'nl','Fout bij het bijwerken van niet-afdrukbare materiaal met item',0),(46312,1287,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tulostumattomat materiaalia kohteen',0),(46313,1287,'no','Feil under oppdatering av ikke-utskrivbare materiale med element',0),(46314,1287,'da','Fejl under opdatering af trykfri materiale med varen',0),(46315,1287,'ko','í•­ëª© ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ìžë£Œë¥¼ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(46316,1287,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×—×•×ž×¨ ×ž×•×“×¤×¡ ×¢× ×¤×¨×™×˜',0),(46317,1287,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î¿ Ï…Î»Î¹ÎºÏŒ Î¼Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(46318,1287,'zh','é”™è¯¯æ›´æ–°é¡¹ç›®éžå°åˆ·ææ–™\r\n',0),(46319,1287,'sv','Gick inte att uppdatera icke utskrivbara material med objekt',0),(46320,1287,'it','Errore durante l\'aggiornamento di materiale non stampabili con elemento',0),(46321,1287,'tl','',0),(46322,1287,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3652;&#3617;&#3656;&#3614;&#3636;&#3617;&#3614;&#3660;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3',0),(46323,1287,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤¯à¥‹à¤—à¥à¤¯ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤¸à¤¾à¤¥ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(46324,1287,'ms','Ralat dalam mengemas kini bahan percetakan dengan perkara',0),(46325,1287,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆØ§Ø¯ ØºÙŠØ± Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© Ù…Ø¹ Ø§Ù„Ø¨Ù†Ø¯',0),(46326,1287,'fr','Erreur mise Ã  jour de matÃ©riel non imprimables avec point',0),(46327,1287,'jp','ã??ã?®å“?ç›®ã?¨ã?®é?žå?°åˆ·æ??æ–™ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46328,1287,'pt','Erro ao atualizar o material nÃ£o-imprimÃ­vel com item',0),(46329,1287,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð°-Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð¼',0),(46330,1287,'es','Error actualizando material de no-impresiÃ³n con el item',0),(46331,1287,'de','Fehler beim Aktualisieren nicht druckbaren Material mit Element',0),(46332,1287,'en','Error updating non-printing material with item',0),(46333,1288,'is','',0),(46334,1288,'dr','( Ø§Ø¬Ø±Ø§) Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(46335,1288,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¹Ù…Ù„ÙŠØ§Øª ( Ø§Ø¬Ø±Ø§) Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(46336,1288,'tr','BaskÄ±da operasyonun boyutu gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(46337,1288,'pl','BÅ‚Ä…d podczas aktualizowania niedrukowalne operacji rozmiar.',0),(46338,1288,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð½Ð¸Ñ‚Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(46339,1288,'ur','ØºÛŒØ± Ø·Ø¨Ø§Ø¹Øª Ø¢Ù¾Ø±ÛŒØ´Ù† Ø³Ø§Ø¦Ø² Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(46340,1288,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð° ÐºÐ¾Ñ˜Ð° ÑÐµ Ð½Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°.',0),(46341,1288,'vi','Lá»—i cáº­p nháº­t cá»¡ hoáº¡t Ä‘á»™ng khÃ´ng in',0),(46342,1288,'af','Kon werk nie-druk bewerking grootte.',0),(46343,1288,'ro','Eroare la actualizarea dimensiunea de operaÅ£iunea nu se imprimÄƒ.',0),(46344,1288,'et','Viga ajakohastamine printimatu operatsiooni suurus.',0),(46345,1288,'si','Napaka pri posodabljanju nenatisljivo delovanje velikost.',0),(46346,1288,'ba','Kesalahan update ukuran operasi bebas-printing.',0),(46347,1288,'nl','Fout bij het bijwerken van de niet-drukkende werking grootte.',0),(46348,1288,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tulostumattomat toiminta kokoa.',0),(46349,1288,'no','Feil under oppdatering av ikke-utskrivbare operasjonen stÃ¸rrelse.',0),(46350,1288,'da','Fejl under opdatering af trykfri operation stÃ¸rrelse.',0),(46351,1288,'ko','ë¹„ ì¸ì‡„ ìž‘ì—… í¬ê¸°ë¥¼ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(46352,1288,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×’×•×“×œ ×”×¤×¢×•×œ×” ×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×”.',0),(46353,1288,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚.',0),(46354,1288,'zh','é”™è¯¯æ›´æ–°éžæ‰“å°ä¸šåŠ¡è§„æ¨¡ã€‚\r\n',0),(46355,1288,'sv','Det gick inte att uppdatera icke utskrivbara drift storlek.',0),(46356,1288,'it','Errore di aggiornamento dimensione operazione non stampabili.',0),(46357,1288,'tl','',0),(46358,1288,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3652;&#3617;&#3656;&#3614;&#3636;&#3617;&#3614;&#3660;&#3586;&#3609;&#3634;&#3604;&#3585;&#3634;&#3619;&#3604;&#3',0),(46359,1288,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤ªà¤°à¥‡à¤¶à¤¨ à¤†à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(46360,1288,'ms','Ralat dalam mengemas kini saiz operasi-percetakan.',0),(46361,1288,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø­Ø¬Ù… Ø§Ù„Ø¹Ù…Ù„ÙŠØ© ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©.',0),(46362,1288,'fr','Erreur mise Ã  jour de taille d\'exploitation non imprimables.',0),(46363,1288,'jp','é?žå?°åˆ·ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã‚µã‚¤ã‚ºã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46364,1288,'pt','Erro ao atualizar o tamanho de operaÃ§Ã£o nÃ£o-imprimÃ­vel.',0),(46365,1288,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¾Ð¹ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸.',0),(46366,1288,'es','Error actualizando tamaÃ±o de operaciÃ³n de no-impresiÃ³n',0),(46367,1288,'de','Fehler beim Aktualisieren nicht druckbaren Betrieb GrÃ¶ÃŸe.',0),(46368,1288,'en','Error updating non-printing operation size.',0),(46369,1289,'is','',0),(46370,1289,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(46371,1289,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(46372,1289,'tr','Hata gÃ¼ncelleÅŸtirme yazdÄ±rÄ±lmayan fiyat listesi.',0),(46373,1289,'pl','Aktualizacja bÅ‚Ä…d techniczny Cennik.',0),(46374,1289,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°.',0),(46375,1289,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(46376,1289,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¾Ð¸Ð²Ð¸Ñ‡ÐµÐ½ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°.',0),(46377,1289,'vi','Lá»—i cáº­p nháº­t danh sÃ¡ch giÃ¡ khÃ´ng in',0),(46378,1289,'af','Fout Outobywerking nonprinting prys lys.',0),(46379,1289,'ro','Eroare de actualizare neimprimabile lista de preturi.',0),(46380,1289,'et','Viga ajakohastamine mitteprinditavad hinnakiri.',0),(46381,1289,'si','Napaka posodabljanje Nenatisljivi cenik.',0),(46382,1289,'ba','Kesalahan update daftar harga nonprinting.',0),(46383,1289,'nl','Fout bijwerken niet-afdrukbare prijslijst.',0),(46384,1289,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tulostumattomat hinnasto.',0),(46385,1289,'no','Feil oppdatering ikke-utskrivbare prisliste.',0),(46386,1289,'da','Fejl opdatering afsnitstegn prisliste.',0),(46387,1289,'ko','ê°€ê²© ëª©ë¡ì„ ì¸ì‡„í•  ìˆ˜ ì—†ëŠ” ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ìž…ë‹ˆë‹¤.',0),(46388,1289,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×” ×ž×—×™×¨×•×Ÿ.',0),(46389,1289,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»Î¯ÏƒÏ„Î± ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½ Ï„Î¹Î¼Î®.',0),(46390,1289,'zh','é”™è¯¯æ›´æ–°éžæ‰“å°ä»·æ ¼è¡¨ã€‚\r\n',0),(46391,1289,'sv','Fel uppdatering icke utskrivbar prislista.',0),(46392,1289,'it','Errore aggiornamento non stampabile listino.',0),(46393,1289,'tl','',0),(46394,1289,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3652;&#3617;&#3656;&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3',0),(46395,1289,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤—à¥ˆà¤° à¤®à¥à¤¦à¥à¤°à¤£à¥€à¤¯ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€à¥¤',0),(46396,1289,'ms','Ralat pengemaskinian nonprinting senarai harga.',0),(46397,1289,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© ØºÙŠØ± Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(46398,1289,'fr','Erreur mise Ã  jour non imprimable liste de prix.',0),(46399,1289,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46400,1289,'pt','Lista de preÃ§os de nÃ£o-imprimÃ­vel atualizaÃ§Ã£o erro.',0),(46401,1289,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ñ€Ð°Ð¹Ñ Ð»Ð¸ÑÑ‚.',0),(46402,1289,'es','Error actualizando lista de precios de no-impresiÃ³n',0),(46403,1289,'de','Fehler aktualisieren nicht druckbare Preisliste.',0),(46404,1289,'en','Error updating non-printing price list.',0),(46405,1290,'is','',0),(46406,1290,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡   Ù„ÙŠØ³Øª Ú¯Ø²ÙŠÙ†Ø´ Ø¹Ù…Ù„ÙŠØ§Øª ',0),(46407,1290,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡   Ù„ÙŠØ³Øª Ú¯Ø²ÙŠÙ†Ø´ Ø¹Ù…Ù„ÙŠØ§Øª ',0),(46408,1290,'tr','YazdÄ±rÄ±lmayan fiyat listesi iÅŸlemi SeÃ§imi liste Ã¶ÄŸesi gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(46409,1290,'pl','BÅ‚Ä…d podczas aktualizowania niedrukowane cena lista operacji wyboru listy pozycji.',0),(46410,1290,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ ÑÐ¿Ð¸ÑÑŠÐº ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°.',0),(46411,1290,'ur','Ù†Ù‚Øµ Ø·Ø¨Ø§Ø¹Øª Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø¢Ù¾Ø±ÛŒØ´Ù† Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª Ø´Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(46412,1290,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¾Ð¸Ð²Ð¸Ñ‡ÐµÐ½ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ñƒ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð»Ð¸ÑÑ‚Ðµ ÑÑ‚Ð°Ð²ÐºÑƒ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°.',0),(46413,1290,'vi','Lá»—i cáº­p nháº­t danh sÃ¡ch giÃ¡ cho hÃ ng khÃ´ng in Ä‘Ã£ chá»n',0),(46414,1290,'af','Fout bywerking nonprinting prys lys bewerking seleksie lys item.',0),(46415,1290,'ro','Eroare la actualizarea neimprimabile preÅ£ listÄƒ funcÅ£ionarea selecÅ£ie element din listÄƒ.',0),(46416,1290,'et','Mitteprinditavate operatsiooni valiku nimekirja hinnakirjaÃ¼ksuse vÃ¤rskendamise tÃµrge.',0),(46417,1290,'si','Napaka pri posodabljanju Nenatisljivi delovanje izbor seznam element cenika.',0),(46418,1290,'ba','Kesalahan memperbarui nonprinting harga daftar daftar item pilihan operasi.',0),(46419,1290,'nl','Fout bij het bijwerken van de niet-afdrukbare lijst bewerking selectie prijslijstitem.',0),(46420,1290,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tulostumattomat toiminnon valinta luettelon Hinnastonimike.',0),(46421,1290,'no','Feil under oppdatering av ikke-utskrivbare operasjonen utvalg liste prislisteelement.',0),(46422,1290,'da','Fejl under opdatering af afsnitstegn operation udvalg liste prislisteelement.',0),(46423,1290,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡ ìž‘ì—… ì„ íƒ ëª©ë¡ í•­ëª©ì„ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(46424,1290,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×” ×ž×‘×¦×¢ ×‘×—×™×¨×” ×‘×¨×©×™×ž×” ×¤×¨×™×˜ ×ž×—×™×¨×•×Ÿ.',0),(46425,1290,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚ Î»Î¯ÏƒÏ„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï….',0),(46426,1290,'zh','é”™è¯¯æ›´æ–°éžæ‰“å°ä»·æ ¼è¡¨æ“ä½œé€‰æ‹©åˆ—è¡¨é¡¹ã€‚\r\n',0),(46427,1290,'sv','Det gick inte att uppdatera icke utskrivbara lista drift urval prislisteobjekt.',0),(46428,1290,'it','Errore durante l\'aggiornamento non stampabile prezzo operazione selezione elenco elemento dell\'elenco.',0),(46429,1290,'tl','',0),(46430,1290,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3',0),(46431,1290,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤‘à¤ªà¤°à¥‡à¤¶à¤¨ à¤šà¤¯à¤¨ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(46432,1290,'ms','Ralat dalam mengemas kini nonprinting harga senarai operasi pilihan senarai item.',0),(46433,1290,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¹Ù…Ù„ÙŠØ© Ø§Ø®ØªÙŠØ§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø¹Ù†ØµØ± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©.',0),(46434,1290,'fr','Erreur mise Ã  jour non imprimables opÃ©ration sÃ©lection liste Ã©lÃ©ment tarifaire.',0),(46435,1290,'jp','Error updating nonprinting price list operation selection list item.',0),(46436,1290,'pt','Erro ao atualizar o item de lista de seleÃ§Ã£o de operaÃ§Ã£o do preÃ§o lista nÃ£o imprimÃ­veis.',0),(46437,1290,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐºÐ° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ Ð²Ñ‹Ð±Ð¾Ñ€Ð° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÑÐ¿Ð¸ÑÐºÐ°.',0),(46438,1290,'es','Error actualizando item de lista de selecciÃ³n de operaciÃ³n de la lista de precios de no-impresiÃ³n',0),(46439,1290,'de','Fehler beim Aktualisieren nicht druckbare Liste Vorgang Auswahl Preislistenelement.',0),(46440,1290,'en','Error updating non-printing price list operation selection list item.',0),(46441,1291,'is','',0),(46442,1291,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù†  Ú¯Ø²ÙŠÙ†Ù‡ â€“ Ø§Ù†Ø¯Ø§Ø²Ù‡  Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(46443,1291,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù†  Ú¯Ø²ÙŠÙ†Ù‡ â€“ Ø§Ù†Ø¯Ø§Ø²Ù‡  Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(46444,1291,'tr','SeÃ§enek-size fiyat haberdar etmek gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(46445,1291,'pl','BÅ‚Ä…d podczas aktualizowania rozmiar opcji Informacje cenowe',0),(46446,1291,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð¾Ð¿Ñ†Ð¸ÑÑ‚Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(46447,1291,'ur','Ø§Ø®ØªÛŒØ§Ø± Ø³Ø§Ø¦Ø² Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(46448,1291,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ†ÐµÐ½Ð° Ð¸Ð½Ñ„Ð¾ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ-Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð°',0),(46449,1291,'vi','Lá»—i khi cáº­p nháº­t thÃ´ng tin giÃ¡ cho cÃ¡c kÃ­ch cá»¡',0),(46450,1291,'af','Fout met opdatering van opsie-grootte prys inligting',0),(46451,1291,'ro','Eroare la actualizarea marimea opÅ£iunea informaÅ£ii tarifare',0),(46452,1291,'et','Suvandi suurus hindade info vÃ¤rskendamise tÃµrge',0),(46453,1291,'si','Napaka pri posodabljanju velikost moÅ¾nosti oblikovanja cen info',0),(46454,1291,'ba','Kesalahan update info harga opsi ukuran',0),(46455,1291,'nl','Fout bij het bijwerken van het tarief info optie-grootte',0),(46456,1291,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ vaihtoehto kokoinen hinnoittelun info',0),(46457,1291,'no','Feil under oppdatering av alternativ stÃ¸rrelse prisdetaljer info',0),(46458,1291,'da','Fejl under opdatering af option-stÃ¸rrelse prisfastsÃ¦ttelse info',0),(46459,1291,'ko','ì˜µì…˜ ì‚¬ì´ì¦ˆ ê°€ê²© ì •ë³´ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(46460,1291,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¤×¨×˜×™ ×ª×ž×—×•×¨-×’×•×“×œ',0),(46461,1291,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ ÏÏÎ¸Î¼Î¹ÏƒÎ·Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(46462,1291,'zh','é”™è¯¯æ›´æ–°é€‰é¡¹å°ºå¯¸ä»·æ ¼ä¿¡æ¯\r\n',0),(46463,1291,'sv','Gick inte att uppdatera alternativet-storlek prissÃ¤ttning info',0),(46464,1291,'it','Errore durante l\'aggiornamento di informazioni sui prezzi di opzione-dimensioni',0),(46465,1291,'tl','',0),(46466,1291,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3609;&#3634;&#3604;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3',0),(46467,1291,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª-à¤†à¤•à¤¾à¤° à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(46468,1291,'ms','Ralat dalam mengemas kini maklumat harga opsyen-saiz',0),(46469,1291,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø­Ø¬Ù… Ø§Ù„Ø®ÙŠØ§Ø±',0),(46470,1291,'fr','Erreur mise Ã  jour d\'option taille prix info',0),(46471,1291,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚µã‚¤ã‚ºä¾¡æ ¼è¨­å®šæƒ…å ±ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46472,1291,'pt','Erro ao atualizar a informaÃ§Ã£o de preÃ§os opÃ§Ã£o-tamanho',0),(46473,1291,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ Ð Ð°Ð·Ð¼ÐµÑ€ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ñ†ÐµÐ½Ð°Ñ…',0),(46474,1291,'es','Error actualizando opciÃ³n-tamaÃ±o info de precios',0),(46475,1291,'de','Fehler beim Aktualisieren der Option GrÃ¶ÃŸe Preise info',0),(46476,1291,'en','Error updating option-size pricing info',0),(46477,1292,'is','',0),(46478,1292,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†ÙˆØ¹ Ø­Ù‚ÙˆÙ‚',0),(46479,1292,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†ÙˆØ¹ Ø­Ù‚ÙˆÙ‚',0),(46480,1292,'tr','Ã–deme tipi gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(46481,1292,'pl','BÅ‚Ä…d podczas aktualizowania zapÅ‚aciÄ‡ typu',0),(46482,1292,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ñ‚Ð¸Ð¿',0),(46483,1292,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(46484,1292,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ñ‚Ð¸Ð¿',0),(46485,1292,'vi','Lá»—i cáº­p nháº­t loáº¡i thanh toÃ¡n',0),(46486,1292,'af','Fout het ontstaan met die Opdatering van Besoldigingstipe.',0),(46487,1292,'ro','Eroare la actualizarea plÄƒteascÄƒ tip',0),(46488,1292,'et','Viga ajakohastamine maksa tÃ¼Ã¼p',0),(46489,1292,'si','Napaka pri posodabljanju plaÄati tipa',0),(46490,1292,'ba','Memperbarui membayar jenis kesalahan',0),(46491,1292,'nl','Fout bij het bijwerken van betalen Type',0),(46492,1292,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ maksu-tyyppi',0),(46493,1292,'no','Feil under oppdatering av betale Type',0),(46494,1292,'da','Fejl under opdatering af betale Type',0),(46495,1292,'ko','ì§€ë¶ˆ í˜•ì‹ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(46496,1292,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¡×•×’ ×œ×©×œ×',0),(46497,1292,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Ï… Ï€Î»Î·ÏÏŽÏƒÎµÎ¹',0),(46498,1292,'zh','é”™è¯¯æ›´æ–°æ”¯ä»˜ç±»åž‹ã€‚\r\n',0),(46499,1292,'sv','Gick inte att uppdatera betala typ',0),(46500,1292,'it','Errore di aggiornamento tipo pagare',0),(46501,1292,'tl','',0),(46502,1292,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(46503,1292,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(46504,1292,'ms','Ralat dalam mengemas kini jenis membayar',0),(46505,1292,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« \"Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹\"',0),(46506,1292,'fr','Erreur mise Ã  jour de Type payer',0),(46507,1292,'jp','æ”¯æ‰•ã‚¿ã‚¤ãƒ—ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46508,1292,'pt','Erro ao atualizar tipo pagar',0),(46509,1292,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¸Ð¿Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°.',0),(46510,1292,'es','Error actualizando tipo de pago',0),(46511,1292,'de','Fehler beim Aktualisieren der Zahlen-Typ',0),(46512,1292,'en','Error updating Pay Type',0),(46513,1293,'is','',0),(46514,1293,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(46515,1293,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(46516,1293,'tr','PO gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(46517,1293,'pl','BÅ‚Ä…d podczas aktualizowania PO',0),(46518,1293,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° PO',0),(46519,1293,'ur','Ù¾Ùˆ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(46520,1293,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐŸÐž',0),(46521,1293,'vi','Lá»—i cáº­p nháº­t Ä‘Æ¡n mua hÃ ng',0),(46522,1293,'af','Fout met Opdatering van AB',0),(46523,1293,'ro','Eroare la actualizarea PO',0),(46524,1293,'et','Viga ajakohastamine PO',0),(46525,1293,'si','Napaka pri posodabljanju PO',0),(46526,1293,'ba','Kesalahan update PO',0),(46527,1293,'nl','Fout bij het bijwerken van PO',0),(46528,1293,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ PO',0),(46529,1293,'no','Feil under oppdatering av PO',0),(46530,1293,'da','Fejl under opdatering af PO',0),(46531,1293,'ko','í¬ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(46532,1293,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¤×•',0),(46533,1293,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· PO',0),(46534,1293,'zh','é”™è¯¯æ›´æ–°é‡‡è´­è®¢å•\r\n',0),(46535,1293,'sv','Gick inte att uppdatera PO',0),(46536,1293,'it','Errore di aggiornamento PO',0),(46537,1293,'tl','',0),(46538,1293,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(46539,1293,'hi','PO à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(46540,1293,'ms','Ralat dalam mengemas kini PO',0),(46541,1293,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¨Ùˆ',0),(46542,1293,'fr','Erreur mise Ã  jour PO',0),(46543,1293,'jp','POæ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46544,1293,'pt','Erro ao atualizar PO',0),(46545,1293,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ PO',0),(46546,1293,'es','Error actualizando OC',0),(46547,1293,'de','Fehler beim Aktualisieren der PO',0),(46548,1293,'en','Error updating PO',0),(46549,1294,'is','',0),(46550,1294,'dr','( Ù…Ø¹ÙƒÙˆØ³ Ø´Ø¯Ù‡',0),(46551,1294,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ ÙˆØ§Ú¯Ø°Ø§Ø± Ø´Ø¯Ù‡ ( Ù…Ø¹ÙƒÙˆØ³ Ø´Ø¯Ù‡',0),(46552,1294,'tr','Prbended gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(46553,1294,'pl','BÅ‚Ä…d podczas aktualizowania prbended',0),(46554,1294,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° prbended',0),(46555,1294,'ur','Ù¾Ø±Ø¨Ø§Ù†ÚˆÛŒØ¯ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(46556,1294,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ñ€Ð±ÐµÐ½Ð´ÐµÐ´',0),(46557,1294,'vi','Lá»—i cáº­p nháº­t ',0),(46558,1294,'af','Fout opdatering prbended',0),(46559,1294,'ro','Eroare la actualizarea prbended',0),(46560,1294,'et','Prbended vÃ¤rskendamise tÃµrge',0),(46561,1294,'si','Napaka pri posodabljanju prbended',0),(46562,1294,'ba','Kesalahan update prbended',0),(46563,1294,'nl','Fout bij het bijwerken van prbended',0),(46564,1294,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ prbended',0),(46565,1294,'no','Feil under oppdatering av prbended',0),(46566,1294,'da','Fejl under opdatering af prbended',0),(46567,1294,'ko','Prbended ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(46568,1294,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ prbended',0),(46569,1294,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· prbended',0),(46570,1294,'zh','é”™è¯¯æ›´æ–°è–ªèµ„ç¦åˆ©/æ‰£é™¤\r\n',0),(46571,1294,'sv','Gick inte att uppdatera prbended',0),(46572,1294,'it','Errore durante l\'aggiornamento prbended',0),(46573,1294,'tl','',0),(46574,1294,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3605;&#3633;&#3604;&#3611;&#3619;&#3632;&#3594;&#3634;&#3626;&#3633;&#3617;&#3614;&#3633;&#3',0),(46575,1294,'hi','Prbended à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(46576,1294,'ms','Ralat dalam mengemas kini prbended',0),(46577,1294,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¨Ø±Ø¨ÙŠÙ†Ø¯ÙŠØ¯',0),(46578,1294,'fr','Erreur mise Ã  jour de prbended',0),(46579,1294,'jp','Error updating prbended',0),(46580,1294,'pt','Erro na atualizaÃ§Ã£o prbended',0),(46581,1294,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ prbended',0),(46582,1294,'es','Error actualizando prbended',0),(46583,1294,'de','Fehler beim Aktualisieren der prbended',0),(46584,1294,'en','Error updating prbended',0),(46585,1295,'is','',0),(46586,1295,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ø´Ø±ÙƒØª ',0),(46587,1295,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ø´Ø±ÙƒØª ',0),(46588,1295,'tr','Prcompany gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(46589,1295,'pl','BÅ‚Ä…d podczas aktualizowania prcompany',0),(46590,1295,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° prcompany',0),(46591,1295,'ur','Ù¾Ø±Ú©ÙˆÙ…Ù¾Ø§Ù†ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(46592,1295,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ñ€Ñ†Ð¾Ð¼Ð¿Ð°Ð½y',0),(46593,1295,'vi','Cáº­p nháº­t cty bá»‹ lá»—i',0),(46594,1295,'af','Fout opdatering prcompany',0),(46595,1295,'ro','Eroare la actualizarea prcompany',0),(46596,1295,'et','Prcompany vÃ¤rskendamise tÃµrge',0),(46597,1295,'si','Napaka pri posodabljanju prcompany',0),(46598,1295,'ba','Kesalahan update prcompany',0),(46599,1295,'nl','Fout bij het bijwerken van prcompany',0),(46600,1295,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ prcompany',0),(46601,1295,'no','Feil under oppdatering av prcompany',0),(46602,1295,'da','Fejl under opdatering af prcompany',0),(46603,1295,'ko','Prcompany ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(46604,1295,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ prcompany',0),(46605,1295,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· prcompany',0),(46606,1295,'zh','é”™è¯¯æ›´æ–°å…¬å…³å…¬å¸\r\n',0),(46607,1295,'sv','Gick inte att uppdatera prcompany',0),(46608,1295,'it','Errore durante l\'aggiornamento prcompany',0),(46609,1295,'tl','',0),(46610,1295,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3594;&#3634;&#3626;&#3633;&#3617;&#3614;&#3633;&#3609;&#3608;&#3660;&#3',0),(46611,1295,'hi','Prcompany à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(46612,1295,'ms','Ralat dalam mengemas kini prcompany',0),(46613,1295,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¨Ø±ÙƒÙˆÙ…Ø¨Ø§Ù†ÙŠ',0),(46614,1295,'fr','Erreur mise Ã  jour de prcompany',0),(46615,1295,'jp','Error updating prcompany',0),(46616,1295,'pt','Erro na atualizaÃ§Ã£o prcompany',0),(46617,1295,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ prcompany',0),(46618,1295,'es','Error actualizando prempresa',0),(46619,1295,'de','Fehler beim Aktualisieren der prcompany',0),(46620,1295,'en','Error updating prcompany',0),(46621,1296,'is','',0),(46622,1296,'dr','( Ù…Ø·Ø¨ÙˆØ¹Ø§Øª',0),(46623,1296,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø¨Ø²Ø§Ø± ÙØ´Ø§Ø± ( Ù…Ø·Ø¨ÙˆØ¹Ø§Øª',0),(46624,1296,'tr','Hata gÃ¼ncelleme basÄ±n aracÄ±.',0),(46625,1296,'pl','BÅ‚Ä…d aktualizacji narzÄ™dzie.',0),(46626,1296,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚.',0),(46627,1296,'ur','Ù†Ù‚Øµ Ù¾Ø±ÛŒØ³ Ù¹ÙˆÙ„ ØªØ§Ø²Û Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(46628,1296,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ñ€ÐµÑ Ð°Ð»Ð°Ñ‚.',0),(46629,1296,'vi','Lá»—i cáº­p nháº­t cÃ´ng cá»¥ bÃ¡o chÃ­',0),(46630,1296,'af','Fout Outobywerking press instrument.',0),(46631,1296,'ro','Eroare de actualizare apÄƒsaÅ£i instrument.',0),(46632,1296,'et','Viga ajakohastamine stants.',0),(46633,1296,'si','Napaka posodabljanje press orodje.',0),(46634,1296,'ba','Kesalahan update tekan alat.',0),(46635,1296,'nl','Fout bijwerken pers hulpmiddel.',0),(46636,1296,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ paina tyÃ¶kalu.',0),(46637,1296,'no','Feil oppdatering trykk verktÃ¸y.',0),(46638,1296,'da','Fejl opdatering presse vÃ¦rktÃ¸j.',0),(46639,1296,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ í”„ë ˆìŠ¤ ë„êµ¬ìž…ë‹ˆë‹¤.',0),(46640,1296,'he','×›×œ×™ ×”×ª×§×©×•×¨×ª ×ž×¢×“×›×Ÿ ×©×’×™××•×ª.',0),(46641,1296,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï„ÏÏ€Î¿Ï….',0),(46642,1296,'zh','é”™è¯¯æ›´æ–°æŒ‰åŽ‹å·¥å…·ã€‚\r\n',0),(46643,1296,'sv','Fel uppdatering press verktyg.',0),(46644,1296,'it','Aggiornamento strumento errori di stampa.',0),(46645,1296,'tl','',0),(46646,1296,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3640;&#3656;&#3617;&#3585;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;',0),(46647,1296,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¥‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£à¥¤',0),(46648,1296,'ms','Ralat pengemaskinian tekan alat.',0),(46649,1296,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„ØµØ­Ø§ÙØ© Ø£Ø¯Ø§Ø©.',0),(46650,1296,'fr','Sertisseuse d\'erreur mise Ã  jour.',0),(46651,1296,'jp','ãƒ—ãƒ¬ã‚¹æ©Ÿå™¨ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46652,1296,'pt','Ferramenta de imprensa atualizaÃ§Ã£o de erro.',0),(46653,1296,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ñ€ÐµÑÑ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚.',0),(46654,1296,'es','Error actualizando herramienta de prensa',0),(46655,1296,'de','Fehler Update Einpress-Hilfe.',0),(46656,1296,'en','Error updating press tool.',0),(46657,1297,'is','',0),(46658,1297,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(46659,1297,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(46660,1297,'tr','Fiyat dÃ¼zeyi gÃ¼ncelleÅŸtirme hatasÄ±.',0),(46661,1297,'pl','BÅ‚Ä…d aktualizacji poziomu cen.',0),(46662,1297,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð¾ Ð½Ð¸Ð²Ð¾.',0),(46663,1297,'ur','Ù†Ù‚Øµ Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ú©Ùˆ ØªØ§Ø²Û Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(46664,1297,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð°.',0),(46665,1297,'vi','Lá»—i cáº­p nháº­t má»©c giÃ¡',0),(46666,1297,'af','Fout met opdatering van prysvlak.',0),(46667,1297,'ro','Eroare de actualizare nivel de preÅ£.',0),(46668,1297,'et','Viga ajakohastamine hinnatase.',0),(46669,1297,'si','Posodabljanje cen raven napak.',0),(46670,1297,'ba','Kesalahan update tingkat harga.',0),(46671,1297,'nl','Fout bijwerken prijsniveau.',0),(46672,1297,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ hintataso.',0),(46673,1297,'no','Feil oppdatering prisnivÃ¥et.',0),(46674,1297,'da','Fejl opdatering prisniveau.',0),(46675,1297,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ê°€ê²© ìˆ˜ì¤€ìž…ë‹ˆë‹¤.',0),(46676,1297,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×¨×ž×ª ×ž×—×™×¨×™×.',0),(46677,1297,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½.',0),(46678,1297,'zh','é”™è¯¯æ›´æ–°ä»·æ ¼æ°´å¹³\r\n',0),(46679,1297,'sv','Fel uppdatering prisnivÃ¥.',0),(46680,1297,'it','Livello di prezzo aggiornamento errore.',0),(46681,1297,'tl','',0),(46682,1297,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(46683,1297,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°à¥¤',0),(46684,1297,'ms','Ralat pengemaskinian peringkat harga.',0),(46685,1297,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(46686,1297,'fr','Mise Ã  jour niveau erreur de prix.',0),(46687,1297,'jp','ä¾¡æ ¼æ°´æº–ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46688,1297,'pt','NÃ­vel de preÃ§os atualizaÃ§Ã£o de erro.',0),(46689,1297,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑƒÑ€Ð¾Ð²Ð½Ñ Ñ†ÐµÐ½.',0),(46690,1297,'es','Error actualizando nivel de precios',0),(46691,1297,'de','Fehler Update Preisniveau.',0),(46692,1297,'en','Error updating price level.',0),(46693,1298,'is','',0),(46694,1298,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(46695,1298,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(46696,1298,'tr','Hata gÃ¼ncelleÅŸtirme fiyat listesi.',0),(46697,1298,'pl','BÅ‚Ä…d aktualizacji cennika.',0),(46698,1298,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°.',0),(46699,1298,'ur','Ù†Ù‚Øµ Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ú©Ùˆ ØªØ§Ø²Û Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(46700,1298,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°.',0),(46701,1298,'vi','Lá»—i cáº­p nháº­t danh sÃ¡ch giÃ¡',0),(46702,1298,'af','Fout met opdatering van pryslys.',0),(46703,1298,'ro','Eroare de actualizare lista de preÅ£uri.',0),(46704,1298,'et','Viga ajakohastamine hinnakiri.',0),(46705,1298,'si','Napaka pri posodabljanju cenik.',0),(46706,1298,'ba','Kesalahan update daftar harga.',0),(46707,1298,'nl','Fout bijwerken prijslijst.',0),(46708,1298,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ hinnasto.',0),(46709,1298,'no','Feil oppdatering prisliste.',0),(46710,1298,'da','Fejl opdatering prisliste.',0),(46711,1298,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ê°€ê²© ëª©ë¡ìž…ë‹ˆë‹¤.',0),(46712,1298,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×ž×—×™×¨ ×ž×—×™×¨×•×Ÿ.',0),(46713,1298,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿.',0),(46714,1298,'zh','é”™è¯¯æ›´æ–°çš„ä»·ç›®è¡¨ã€‚\r\n',0),(46715,1298,'sv','Fel uppdatering prislista.',0),(46716,1298,'it','Errore aggiornamento prezzo di listino.',0),(46717,1298,'tl','',0),(46718,1298,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(46719,1298,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€à¥¤',0),(46720,1298,'ms','Ralat pengemaskinian senarai harga.',0),(46721,1298,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±.',0),(46722,1298,'fr','Liste de prix mise Ã  jour erreur.',0),(46723,1298,'jp','ä¾¡æ ¼è¡¨ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46724,1298,'pt','Lista de preÃ§os atualizaÃ§Ã£o de erro.',0),(46725,1298,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚.',0),(46726,1298,'es','Error actualizando lista de precios',0),(46727,1298,'de','Fehler Update Preisliste.',0),(46728,1298,'en','Error updating price list.',0),(46729,1299,'is','',0),(46730,1299,'dr','( Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù… ',0),(46731,1299,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø³Ù‡Ø§Ù… ( Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(46732,1299,'tr','Fiyat listesi stok gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(46733,1299,'pl','BÅ‚Ä…d podczas aktualizowania cena lista zapasÃ³w.',0),(46734,1299,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð².',0),(46735,1299,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(46736,1299,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ.',0),(46737,1299,'vi','Lá»—i cáº­p nháº­t danh sÃ¡ch giÃ¡ hÃ ng tá»“n',0),(46738,1299,'af','Fout met opdatering van pryslysvoorraad.',0),(46739,1299,'ro','Eroare la actualizarea Pret lista stoc.',0),(46740,1299,'et','Viga ajakohastamine hind nimekirja stock.',0),(46741,1299,'si','Napaka pri posodabljanju cena seznam zalog.',0),(46742,1299,'ba','Kesalahan memperbarui daftar harga saham.',0),(46743,1299,'nl','Fout bij het bijwerken van prijs lijst voorraad.',0),(46744,1299,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ hinta luettelo varastossa.',0),(46745,1299,'no','Feil under oppdatering av pris liste lager.',0),(46746,1299,'da','Fejl under opdatering af listen aktiekurs.',0),(46747,1299,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³ ë¥¼ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(46748,1299,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™.',0),(46749,1299,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î§ÏÎ·Î¼Î±Ï„Î¹ÏƒÏ„Î®ÏÎ¹Î¿.',0),(46750,1299,'zh','é”™è¯¯æ›´æ–°ä»·æ ¼è¡¨è‚¡ç¥¨ã€‚\r\n',0),(46751,1299,'sv','Det gick inte att uppdatera pris lista lager.',0),(46752,1299,'it','Errore di aggiornamento magazzino elenco prezzi.',0),(46753,1299,'tl','',0),(46754,1299,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3',0),(46755,1299,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(46756,1299,'ms','Ralat dalam mengemas kini harga Senarai saham.',0),(46757,1299,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©.',0),(46758,1299,'fr','Erreur mise Ã  jour du stock de liste de prix.',0),(46759,1299,'jp','Error updating price list stock.',0),(46760,1299,'pt','Erro ao atualizar o estoque de lista de preÃ§o.',0),(46761,1299,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÐ¿Ð¸ÑÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ñ†ÐµÐ½Ð°.',0),(46762,1299,'es','Error actualizando lista de precios de stock',0),(46763,1299,'de','Fehler beim Aktualisieren der Preis Liste Lager.',0),(46764,1299,'en','Error updating price list stock.',0),(46765,1300,'is','',0),(46766,1300,'dr','( Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù… ) Ù…ØµØ±ÙÙŠ',0),(46767,1300,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø³Ù‡Ø§Ù… ( Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ) Ù…ØµØ±ÙÙŠ',0),(46768,1300,'tr','Fiyat listesi stok kullanÄ±mÄ± gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(46769,1300,'pl','BÅ‚Ä…d podczas aktualizowania ceny listy czas uÅ¼ytkowania.',0),(46770,1300,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¾ÑÐ½Ð¾Ð²ÐµÐ½ Ð¾Ñ‚Ð½Ð°ÑÑÐ½Ðµ.',0),(46771,1300,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(46772,1300,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¾Ð³ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ðµ.',0),(46773,1300,'vi','Lá»—i cáº­p nháº­t danh sÃ¡ch giÃ¡ dÃ¹ng hÃ ng tá»“n ',0),(46774,1300,'af','Fout met opdatering van gebruikte  voorraad pryslys.',0),(46775,1300,'ro','Eroare la actualizarea Pret lista stoc de utilizare.',0),(46776,1300,'et','Viga ajakohastamine hind nimekirja varude kasutamine.',0),(46777,1300,'si','Napaka pri posodabljanju cena seznam zalog navada.',0),(46778,1300,'ba','Kesalahan memperbarui daftar harga saham penggunaan.',0),(46779,1300,'nl','Fout bij het bijwerken van prijs lijst voorraad gebruik.',0),(46780,1300,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ hinta luetteloon kaluston kÃ¤yttÃ¶.',0),(46781,1300,'no','Feil under oppdatering av pris listen lagerforbruket.',0),(46782,1300,'da','Fejl under opdatering af prisen listen stock skik.',0),(46783,1300,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš©ë²•ì„ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(46784,1300,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™ ×”×©×™×ž×•×©.',0),(46785,1300,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎ·.',0),(46786,1300,'zh','é”™è¯¯æ›´æ–°ä»·æ ¼è¡¨è‚¡ç¥¨ä½¿ç”¨ã€‚\r\n',0),(46787,1300,'sv','Det gick inte att uppdatera pris lista lageranvÃ¤ndningen.',0),(46788,1300,'it','Errore di aggiornamento uso magazzino di elenco prezzi.',0),(46789,1300,'tl','',0),(46790,1300,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3',0),(46791,1300,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(46792,1300,'ms','Ralat dalam mengemas kini penggunaan stok senarai harga.',0),(46793,1300,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù….',0),(46794,1300,'fr','Erreur mise Ã  jour d\'utilisation stock liste de prix.',0),(46795,1300,'jp','Error updating price list stock usage.',0),(46796,1300,'pt','Erro ao atualizar o uso das aÃ§Ãµes da lista de preÃ§o.',0),(46797,1300,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½ ÑÐ¿Ð¸ÑÐºÐ° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ Ñ€Ð°ÑÑ…Ð¾Ð´Ð°.',0),(46798,1300,'es','Error actualizando uso de lista de precios de stock',0),(46799,1300,'de','Fehler beim Aktualisieren der Preis Liste hat Verwendung.',0),(46800,1300,'en','Error updating price list stock usage.',0),(46801,1301,'is','',0),(46802,1301,'dr','( Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù… ) Ù…ØµØ±ÙÙŠ Ù„ÙŠØ³Øª Ø³Ù‡Ø§Ù… ( Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù…)',0),(46803,1301,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø³Ù‡Ø§Ù… ( Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ) Ù…ØµØ±ÙÙŠ Ù„ÙŠØ³Øª Ø³Ù‡Ø§Ù… ( Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±)',0),(46804,1301,'tr','Fiyat listesi stok kullanÄ±mÄ± stok listesi gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(46805,1301,'pl','BÅ‚Ä…d podczas aktualizowania cena lista zapasÃ³w czas uÅ¼ytkowania.',0),(46806,1301,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ ÑÑŠÑÑ‚Ð°Ð².',0),(46807,1301,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ø³Ù¹Ø§Ú© ÙÛØ±Ø³Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ Û”',0),(46808,1301,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¾Ð³ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð»Ð°Ð³ÐµÑ€ Ð»Ð¸ÑÑ‚Ð°.',0),(46809,1301,'vi','Lá»—i cáº­p nháº­t danh sÃ¡ch giÃ¡ dÃ¹ng hÃ ng tá»“n ',0),(46810,1301,'af','Fout prys lys voorraad gebruik voorraad lys bygewerk.',0),(46811,1301,'ro','Eroare la actualizarea lista de stoc pret lista stoc de utilizare.',0),(46812,1301,'et','Vea hind nimekirja varude kasutamine varude nimekirja ajakohastamise.',0),(46813,1301,'si','Napaka pri posodabljanju cena seznam zalog seznam zalog uporabe.',0),(46814,1301,'ba','Kesalahan memperbarui daftar saham saham penggunaan daftar harga.',0),(46815,1301,'nl','Fout bij het bijwerken van de lijst voorraad gebruik voorraad prijslijst.',0),(46816,1301,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ hinnasto luettelon kaluston kÃ¤yttÃ¶ varastossa.',0),(46817,1301,'no','Feil under oppdatering av pris liste lagerforbruket lager liste.',0),(46818,1301,'da','Fejl under opdatering af prisliste liste stock skik stock.',0),(46819,1301,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš© ìž¬ê³  ëª©ë¡ì„ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(46820,1301,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¨×©×™×ž×ª ×©×™×ž×•×© ×ž× ×™×•×ª ×ž× ×™×•×ª ×ž×—×™×¨×•×Ÿ.',0),(46821,1301,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½.',0),(46822,1301,'zh','é”™è¯¯æ›´æ–°è‚¡ç¥¨ä»·æ ¼è¡¨çš„ä½¿ç”¨åº“å­˜æ¸…å•ã€‚\r\n',0),(46823,1301,'sv','Det gick inte att uppdatera listan lageranvÃ¤ndningen lager prislista.',0),(46824,1301,'it','Errore di aggiornamento lista stock utilizzo stock listino.',0),(46825,1301,'tl','',0),(46826,1301,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3',0),(46827,1301,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(46828,1301,'ms','Ralat dalam mengemas kini senarai saham saham penggunaan senarai harga.',0),(46829,1301,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø£Ø³Ù‡Ù….',0),(46830,1301,'fr','Erreur mise Ã  jour de la liste de stock stock utilisation prix de liste.',0),(46831,1301,'jp','Error updating price list stock usage stock list.',0),(46832,1301,'pt','Erro ao atualizar a lista de estoque preÃ§o lista aÃ§Ãµes de uso.',0),(46833,1301,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½ ÑÐ¿Ð¸ÑÐ¾Ðº Ð°ÐºÑ†Ð¸Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð·Ð°Ð¿Ð°ÑÐ¾Ð².',0),(46834,1301,'es','Error actualizando lista de uso de stock de lista de precios de stock',0),(46835,1301,'de','Fehler beim Aktualisieren der Preis Liste hat Verwendung Lagerliste.',0),(46836,1301,'en','Error updating price list stock usage stock list.',0),(46837,1302,'is','',0),(46838,1302,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ù…Ø³ØªÙ…Ø±ÙŠ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÙŠ ',0),(46839,1302,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ù…Ø³ØªÙ…Ø±ÙŠ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÙŠ ',0),(46840,1302,'tr','Prpension gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(46841,1302,'pl','BÅ‚Ä…d podczas aktualizowania prpension',0),(46842,1302,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° prpension',0),(46843,1302,'ur','Ù¾Ø±Ù¾Ø§Ù†Ø´Ù† Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(46844,1302,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ñ€Ð¿ÐµÐ½ÑÐ¸Ð¾Ð½',0),(46845,1302,'vi','Lá»—i cáº­p nháº­t lÆ°Æ¡ng hÆ°u',0),(46846,1302,'af','Fout opdatering prpension',0),(46847,1302,'ro','Eroare la actualizarea prpension',0),(46848,1302,'et','Prpension vÃ¤rskendamise tÃµrge',0),(46849,1302,'si','Napaka pri posodabljanju prpension',0),(46850,1302,'ba','Kesalahan update prpension',0),(46851,1302,'nl','Fout bij het bijwerken van prpension',0),(46852,1302,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ prpension',0),(46853,1302,'no','Feil under oppdatering av prpension',0),(46854,1302,'da','Fejl under opdatering af prpension',0),(46855,1302,'ko','Prpension ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(46856,1302,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ prpension',0),(46857,1302,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· prpension',0),(46858,1302,'zh','é”™è¯¯æ›´æ–°è–ªé‡‘é€€ä¼‘é‡‘\r\n',0),(46859,1302,'sv','Gick inte att uppdatera prpension',0),(46860,1302,'it','Errore durante l\'aggiornamento prpension',0),(46861,1302,'tl','',0),(46862,1302,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3610;&#3637;&#3657;&#3618;&#3648;&#3621;&#3637;&#3657;&#3618;&#3591;&#3594;&#3637;&#3614;',0),(46863,1302,'hi','Prpension à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(46864,1302,'ms','Ralat dalam mengemas kini prpension',0),(46865,1302,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¨Ø±Ø¨ÙŠÙ†Ø³ÙŠÙˆÙ†',0),(46866,1302,'fr','Erreur mise Ã  jour de prpension',0),(46867,1302,'jp','Error updating prpension',0),(46868,1302,'pt','Erro na atualizaÃ§Ã£o prpension',0),(46869,1302,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ prpension',0),(46870,1302,'es','Error actualizando prpensiÃ³n',0),(46871,1302,'de','Fehler beim Aktualisieren der prpension',0),(46872,1302,'en','Error updating prpension',0),(46873,1303,'is','',0),(46874,1303,'dr','( Ø±Ø®ØµØªÛŒ ',0),(46875,1303,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ ØªØ¹Ø·ÙŠÙ„Ø§Øª ( Ù…Ø±Ø®ØµÙŠ ',0),(46876,1303,'tr','Prvacation gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(46877,1303,'pl','BÅ‚Ä…d podczas aktualizowania prvacation',0),(46878,1303,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° prvacation',0),(46879,1303,'ur','Ù¾Ø±ÙˆØ§Ú©ÛŒØ´Ù† Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(46880,1303,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ñ€Ð²Ð°Ñ†Ð°Ñ‚Ð¸Ð¾Ð½',0),(46881,1303,'vi','Lá»—i cáº­p nháº­t ká»³ nghá»‰',0),(46882,1303,'af','Fout opdatering prvacation',0),(46883,1303,'ro','Eroare la actualizarea prvacation',0),(46884,1303,'et','Prvacation vÃ¤rskendamise tÃµrge',0),(46885,1303,'si','Napaka pri posodabljanju prvacation',0),(46886,1303,'ba','Kesalahan update prvacation',0),(46887,1303,'nl','Fout bij het bijwerken van prvacation',0),(46888,1303,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ prvacation',0),(46889,1303,'no','Feil under oppdatering av prvacation',0),(46890,1303,'da','Fejl under opdatering af prvacation',0),(46891,1303,'ko','Prvacation ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(46892,1303,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ prvacation',0),(46893,1303,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· prvacation',0),(46894,1303,'zh','é”™è¯¯æ›´æ–°è–ªé‡‘ä¼‘å‡\r\n',0),(46895,1303,'sv','Gick inte att uppdatera prvacation',0),(46896,1303,'it','Errore durante l\'aggiornamento prvacation',0),(46897,1303,'tl','',0),(46898,1303,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3623;&#3621;&#3634;&#3623;&#3656;&#3634;&#3591;',0),(46899,1303,'hi','Prvacation à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(46900,1303,'ms','Ralat dalam mengemas kini prvacation',0),(46901,1303,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¨Ø±ÙØ§ÙƒÙŠØ´Ù†',0),(46902,1303,'fr','Erreur mise Ã  jour de prvacation',0),(46903,1303,'jp','Error updating prvacation',0),(46904,1303,'pt','Erro na atualizaÃ§Ã£o prvacation',0),(46905,1303,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ prvacation',0),(46906,1303,'es','Error actualizando prvacaciÃ³n',0),(46907,1303,'de','Fehler beim Aktualisieren der prvacation',0),(46908,1303,'en','Error updating prvacation',0),(46909,1304,'is','',0),(46910,1304,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(46911,1304,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(46912,1304,'tr','Hata gÃ¼ncelleÅŸtirme alÄ±ntÄ±',0),(46913,1304,'pl','BÅ‚Ä…d aktualizacji oferty',0),(46914,1304,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(46915,1304,'ur','Ù†Ù‚Øµ Ø§Ù‚ØªØ¨Ø§Ø³ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(46916,1304,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(46917,1304,'vi','Lá»—i cáº­p nháº­t bÃ¡o giÃ¡',0),(46918,1304,'af','Fout met opdatering van kwotasie',0),(46919,1304,'ro','Eroare de actualizare citat',0),(46920,1304,'et','Viga ajakohastamine tsitaat',0),(46921,1304,'si','Napaka posodabljanje citat',0),(46922,1304,'ba','Kesalahan update kutipan',0),(46923,1304,'nl','Fout bijwerken offerte',0),(46924,1304,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ lainaus',0),(46925,1304,'no','Feil oppdatering tilbud',0),(46926,1304,'da','Fejl opdatering citat',0),(46927,1304,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ê²¬ì ',0),(46928,1304,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×”×¦×¢×ª ×ž×—×™×¨',0),(46929,1304,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(46930,1304,'zh','é”™è¯¯æ›´æ–°æŠ¥ä»·\r\n',0),(46931,1304,'sv','Fel uppdatering citat',0),(46932,1304,'it','Preventivo aggiornamento errore',0),(46933,1304,'tl','',0),(46934,1304,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(46935,1304,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¬à¥‹à¤²à¥€',0),(46936,1304,'ms','Ralat pengemaskinian quote',0),(46937,1304,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(46938,1304,'fr','Citation de mise Ã  jour erreur',0),(46939,1304,'jp','è¦‹ç©?ã‚‚ã‚Šã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46940,1304,'pt','CitaÃ§Ã£o de atualizaÃ§Ã£o de erro',0),(46941,1304,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(46942,1304,'es','Error actualizando cotizaciÃ³n',0),(46943,1304,'de','Fehler Update Angebot',0),(46944,1304,'en','Error updating quote',0),(46945,1305,'is','',0),(46946,1305,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†Ø¸Ø±Ø§Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(46947,1305,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†Ø¸Ø±Ø§Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(46948,1305,'tr','Hata gÃ¼ncelleÅŸtirme alÄ±ntÄ± yorum',0),(46949,1305,'pl','BÅ‚Ä…d aktualizacji cytat komentarz',0),(46950,1305,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(46951,1305,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø§Ù‚ØªØ¨Ø§Ø³ ØªØ¨ØµØ±Û',0),(46952,1305,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(46953,1305,'vi','Lá»—i cáº­p nháº­t nháº­n xÃ©t bÃ¡o giÃ¡',0),(46954,1305,'af','Fout met Opdatering van kwotasie kommentaar',0),(46955,1305,'ro','Eroare de actualizare citat comentariu',0),(46956,1305,'et','Viga ajakohastamine tsiteerida kommentaari',0),(46957,1305,'si','Napaka posodabljanje citiram komentar',0),(46958,1305,'ba','Kesalahan update kutipan komentar',0),(46959,1305,'nl','Fout bijwerken offerte commentaar',0),(46960,1305,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ lainaus kommentti',0),(46961,1305,'no','Feil oppdatering tilbud kommentar',0),(46962,1305,'da','Fejl opdatering citat kommentar',0),(46963,1305,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì¸ìš© ì½”ë©˜íŠ¸',0),(46964,1305,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×”×¦×¢×ª ×ž×—×™×¨ ×ª×’×•×‘×”',0),(46965,1305,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(46966,1305,'zh','é”™è¯¯æ›´æ–°æŠ¥ä»·è¯„è®º\r\n',0),(46967,1305,'sv','Fel uppdatering citat kommentar',0),(46968,1305,'it','Commento di preventivo aggiornamento errore',0),(46969,1305,'tl','',0),(46970,1305,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3623;&#3634;&#3617;&#3588;&#3636;&#3604;&#3648;&#3627;&#3655;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3',0),(46971,1305,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€',0),(46972,1305,'ms','Ralat pengemaskinian quote komen',0),(46973,1305,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« ØªØ¹Ù‚ÙŠØ¨ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(46974,1305,'fr','Commentaire de citation mise Ã  jour erreur',0),(46975,1305,'jp','è¦‹ç©?ã‚‚ã‚Šæ³¨é‡ˆã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(46976,1305,'pt','ComentÃ¡rio de citaÃ§Ã£o atualizaÃ§Ã£o erro',0),(46977,1305,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹',0),(46978,1305,'es','Error actualizando comentario de cotizaciÃ³n',0),(46979,1305,'de','Fehler Update Zitat Kommentar',0),(46980,1305,'en','Error updating quote comment',0),(46981,1306,'is','',0),(46982,1306,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ  Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(46983,1306,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ  Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(46984,1306,'tr','Quote Not gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(46985,1306,'pl','BÅ‚Ä…d podczas aktualizowania cytat notatki.',0),(46986,1306,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸.',0),(46987,1306,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†ÙˆÙ¹ÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(46988,1306,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ.',0),(46989,1306,'vi','Lá»—i cáº­p nháº­t ghi chÃº bÃ¡o giÃ¡',0),(46990,1306,'af','Fout met opdatering van Kwotasie Notas',0),(46991,1306,'ro','Eroare la actualizarea cita note.',0),(46992,1306,'et','MÃ¤rkused hinnapakkumise vÃ¤rskendamise tÃµrge.',0),(46993,1306,'si','Napaka pri posodabljanju citiram opombe.',0),(46994,1306,'ba','Kesalahan memperbarui catatan mengutip.',0),(46995,1306,'nl','Fout bij het bijwerken van citeer notities.',0),(46996,1306,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ lainata toteaa.',0),(46997,1306,'no','Feil under oppdatering av sitere notater.',0),(46998,1306,'da','Fejl under opdatering af citerer noter.',0),(46999,1306,'ko','ì¸ìš© ë…¸íŠ¸ë¥¼ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(47000,1306,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×ª×¢×•×“×•×ª ×œ×¦×˜×˜.',0),(47001,1306,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ ÎµÏ€Î¯ Î»Î­Î¾ÎµÎ¹.',0),(47002,1306,'zh','é”™è¯¯æ›´æ–°æŠ¥ä»·è¯´æ˜Žã€‚\r\n',0),(47003,1306,'sv','Det gick inte att uppdatera citerar anteckningar.',0),(47004,1306,'it','Errore di aggiornamento note citare.',0),(47005,1306,'tl','',0),(47006,1306,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3',0),(47007,1306,'hi','à¤¬à¥‹à¤²à¥€ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(47008,1306,'ms','Ralat dalam mengemas kini Nota-Nota sebut harga.',0),(47009,1306,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(47010,1306,'fr','Erreur mise Ã  jour des Notes de citer.',0),(47011,1306,'jp','è¦‹ç©?ã‚‚ã‚Šãƒ¡ãƒ¢ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47012,1306,'pt','Erro ao atualizar notas de citaÃ§Ã£o.',0),(47013,1306,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸.',0),(47014,1306,'es','Error actualizando Notas de CotizaciÃ³n',0),(47015,1306,'de','Fehler beim Aktualisieren der Hinweise zu zitieren.',0),(47016,1306,'en','Error updating Quote Notes.',0),(47017,1307,'is','',0),(47018,1307,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø±Ø³ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ',0),(47019,1307,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø±Ø³ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ',0),(47020,1307,'tr','Bu Ã¶ÄŸe iÃ§in makbuz gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(47021,1307,'pl','BÅ‚Ä…d podczas aktualizowania odbioru dla tego przedmiotu',0),(47022,1307,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(47023,1307,'ur','Ø§Ø³ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ø±Ø³ÛŒØ¯ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(47024,1307,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° Ð·Ð° Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(47025,1307,'vi','Lá»—i khi cáº­p nháº­t biÃªn nháº­n cho hÃ ng nÃ y',0),(47026,1307,'af','Fout met opdatering van ontvangs vir hierie item',0),(47027,1307,'ro','Eroare la actualizarea primirea pentru acest element',0),(47028,1307,'et','KÃ¤tte selle Ã¼ksuse vÃ¤rskendamise tÃµrge',0),(47029,1307,'si','Napaka pri posodabljanju prejema za ta element',0),(47030,1307,'ba','Kesalahan memperbarui tanda terima untuk item ini',0),(47031,1307,'nl','Fout bij het bijwerken van ontvangst voor dit item',0),(47032,1307,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ saamisesta tÃ¤lle kohteelle',0),(47033,1307,'no','Feil under oppdatering av kvittering pÃ¥ elementversjonen',0),(47034,1307,'da','Fejl under opdatering af kvittering for dette element',0),(47035,1307,'ko','ì´ í•­ëª©ì— ëŒ€ í•œ ì˜ìˆ˜ì¦ì„ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(47036,1307,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ××™×©×•×¨ ×¢×‘×•×¨ ×¤×¨×™×˜ ×–×”',0),(47037,1307,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ Ï€Î±ÏÎ±Î»Î±Î²Î®Ï‚ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(47038,1307,'zh','é”™è¯¯æ›´æ–°æ­¤é¡¹ç›®æ”¶æ®\r\n',0),(47039,1307,'sv','Gick inte att uppdatera inleverans fÃ¶r objektet',0),(47040,1307,'it','Errore di aggiornamento ricevuta per questo elemento',0),(47041,1307,'tl','',0),(47042,1307,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;',0),(47043,1307,'hi','à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¸à¥€à¤¦ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(47044,1307,'ms','Ralat dalam mengemas kini resit untuk item ini',0),(47045,1307,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« ØªÙ„Ù‚ÙŠ Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¨Ù†Ø¯',0),(47046,1307,'fr','Erreur mise Ã  jour de la rÃ©ception pour cet article',0),(47047,1307,'jp','ã?“ã?®å“?ç›®ã?®é ˜å?Žæ›¸æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47048,1307,'pt','Erro ao atualizar o recibo para este item',0),(47049,1307,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(47050,1307,'es','Error actualizando recibo de este item',0),(47051,1307,'de','Fehler beim Aktualisieren der Quittung fÃ¼r diesen Artikel',0),(47052,1307,'en','Error updating receipt for this item',0),(47053,1308,'is','',0),(47054,1308,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù†  Ø¯Ø±ÙŠØ§ÙØª Ø®Ø·Ø§ â€“ Ù„ØºÙˆ Ø«Ø¨Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(47055,1308,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù†  Ø¯Ø±ÙŠØ§ÙØª Ø®Ø·Ø§ â€“ Ù„ØºÙˆ Ø«Ø¨Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(47056,1308,'tr','GÃ¼ncelleÅŸtirme hatasÄ± aldÄ±ÄŸÄ±nÄ±z hata - fatura giriÅŸi iptal edildi.',0),(47057,1308,'pl','BÅ‚Ä…d podczas aktualizowania bÅ‚Ä…d - BILL zapis odwoÅ‚any',0),(47058,1308,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚Ðµ Ð³Ñ€ÐµÑˆÐºÐ° - Ð±Ð¸Ð» ÐžÐ¢ÐœÐ•ÐÐ•Ð Ð·Ð°Ð¿Ð¸Ñ',0),(47059,1308,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ ÙˆØµÙˆÙ„ Ù†Ù‚Øµ - Ø¨Ù„ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§ Û”',0),(47060,1308,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ñ€Ð¸Ð¼Ð¸Ñ‚Ð¸ Ð³Ñ€ÐµÑˆÐºÐ° - Ð‘Ð¸Ð» ÑÑ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð°',0),(47061,1308,'vi','Lá»—i cáº­p nháº­t nháº­n lá»—i - Nháº­p hÃ³a Ä‘Æ¡n há»§y',0),(47062,1308,'af','Fout - Wetsontwerp inskrywing GEKANSELLEER fout bywerking ontvang',0),(47063,1308,'ro','Eroare actualizarea primesc eroare - BILL intrare anulate',0),(47064,1308,'et','Viga ajakohastamine ilmneb tÃµrge - arve KANDE tÃ¼histatud',0),(47065,1308,'si','Napaka pri posodabljanju napaki - BILL vnos ODPOVEDAN',0),(47066,1308,'ba','Kesalahan update menerima kesalahan - BILL entri dibatalkan',0),(47067,1308,'nl','Fout bijwerken foutbericht - BILL post geannuleerd',0),(47068,1308,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ virhesanoma - BILL tapahtuma peruutetaan',0),(47069,1308,'no','Feil oppdatering feilmeldingen - BILL oppfÃ¸ring avbrutt',0),(47070,1308,'da','Fejl opdatering modtage fejl - BILL post aflyst',0),(47071,1308,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜ê°€-ë¹Œ í•­ëª© ì·¨ì†Œ',0),(47072,1308,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×œ×§×‘×œ ×©×’×™××” - ×‘×™×œ ×‘×™×˜×œ ×›× ×™×¡×”',0),(47073,1308,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¬Î¸Î¿Ï…Ï‚ - BILL ÎµÎ³Î³ÏÎ±Ï†Î® Î‘ÎšÎ¥Î¡ÎÎ˜Î—ÎšÎ•',0),(47074,1308,'zh','é”™è¯¯æ›´æ–°æ”¶åˆ°é”™è¯¯- æ’¤é”€å¸å•æ¡ç›®\r\n',0),(47075,1308,'sv','Fel uppdatering felmeddelande - BILL transaktionen AVBRÃ–TS',0),(47076,1308,'it','Errore aggiornamento ricevere errore - BILL voce cancellata',0),(47077,1308,'tl','',0),(47078,1308,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3633;&#3610;&#3610;&#3636;&#3621; - &#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3610;',0),(47079,1308,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¤à¥à¤°à¥à¤Ÿà¤¿ - à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(47080,1308,'ms','Mengemaskini ralat menerima ralat - Rang undang-undang penyertaan dibatalkan',0),(47081,1308,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« ØªÙ„Ù‚ÙŠ Ø®Ø·Ø£--\"Ø£Ù„ØºÙ‰ Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ø§Ù„Ø¯Ø®ÙˆÙ„\"',0),(47082,1308,'fr','Mise Ã  jour par erreur erreur - BILL entrÃ©e annulÃ©',0),(47083,1308,'jp','å?—é ˜ã‚¨ãƒ©ãƒ¼ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼ãƒ¼è«‹æ±‚æ›¸è¨˜å¸³ã?Œã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(47084,1308,'pt','Erro atualizando receber erro - BILL entrada cancelado',0),(47085,1308,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¾Ð± Ð¾ÑˆÐ¸Ð±ÐºÐµ - Ð‘Ð¸Ð»Ð» Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(47086,1308,'es','Error actualizando error de recepciÃ³n - ENTRADA DE RECIBO CANCELADA',0),(47087,1308,'de','Fehler beim Aktualisieren Fehlermeldung - BILL Eintrag abgesagt',0),(47088,1308,'en','Error updating receive error - BILL ENTRY CANCELLED',0),(47089,1309,'is','',0),(47090,1309,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø±ØªØ¨Ù‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(47091,1309,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø±ØªØ¨Ù‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(47092,1309,'tr','GÃ¶zden geÃ§irme derecelendirme gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(47093,1309,'pl','BÅ‚Ä…d podczas aktualizowania review ocena',0),(47094,1309,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(47095,1309,'ur','Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(47096,1309,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³Ð°',0),(47097,1309,'vi','Lá»—i cáº­p nháº­t thang Ä‘Ã¡nh giÃ¡',0),(47098,1309,'af','Fout werk hersien gradering',0),(47099,1309,'ro','Eroare la actualizarea rating de revizuire',0),(47100,1309,'et','Viga ajakohastamine lÃ¤bivaatamise reiting',0),(47101,1309,'si','Napaka pri posodabljanju pregled ocena',0),(47102,1309,'ba','Kesalahan memperbarui peringkat Tinjauan',0),(47103,1309,'nl','Fout bij het bijwerken van de herziening beoordeling',0),(47104,1309,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tarkistaa Luokitus',0),(47105,1309,'no','Feil oppdatering VurderingsnivÃ¥',0),(47106,1309,'da','Fejl under opdatering af anmeldelse rating',0),(47107,1309,'ko','ê²€í†  ë“±ê¸‰ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(47108,1309,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¡×§×™×¨×” ×“×™×¨×•×’',0),(47109,1309,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Î²Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î±',0),(47110,1309,'zh','é”™è¯¯æ›´æ–°å®¡æ ¸è¯„çº§\r\n',0),(47111,1309,'sv','Fel uppdatering recension betyg',0),(47112,1309,'it','Errore di aggiornamento recensione punteggio',0),(47113,1309,'tl','',0),(47114,1309,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3629;&#3633;&#3605;&#3619;&#3634;&#3607;&#3637;&#3656;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;',0),(47115,1309,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(47116,1309,'ms','Ralat dalam mengemas kini kajian penilaian',0),(47117,1309,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« ØªØµÙ†ÙŠÙ Ø§Ø³ØªØ¹Ø±Ø§Ø¶',0),(47118,1309,'fr','Erreur mise Ã  jour de prix |',0),(47119,1309,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼è©•ä¾¡ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47120,1309,'pt','Erro ao atualizar a classificaÃ§Ã£o de revisÃ£o',0),(47121,1309,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐžÐ±Ð·Ð¾Ñ€ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(47122,1309,'es','Error actualizando valuaciÃ³n de revisiÃ³n',0),(47123,1309,'de','Fehler beim Aktualisieren der Digitalkamera Test',0),(47124,1309,'en','Error updating review rating',0),(47125,1310,'is','',0),(47126,1310,'dr','( ÙØ±ÙˆØ´',0),(47127,1310,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù¾Ø±Ø³Ù†Ù„ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ( ÙØ±ÙˆØ´',0),(47128,1310,'tr','Hata gÃ¼ncelleme satÄ±ÅŸ personeli',0),(47129,1310,'pl','BÅ‚Ä…d aktualizacji personelu sprzedaÅ¼y',0),(47130,1310,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(47131,1310,'ur','Ù†Ù‚Øµ Ø³ÛŒÙ„Ø² Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø±',0),(47132,1310,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(47133,1310,'vi','Lá»—i cáº­p nháº­t nhÃ¢n viÃªn kinh doanh',0),(47134,1310,'af','Fout het ontstaan met die opdatering van Verkoopspersoneel',0),(47135,1310,'ro','Eroare de actualizare personal de vÃ¢nzÄƒri',0),(47136,1310,'et','Viga ajakohastamine mÃ¼Ã¼gipersonalile',0),(47137,1310,'si','Napaka pri posodabljanju prodajno osebje',0),(47138,1310,'ba','Kesalahan update penjualan personil',0),(47139,1310,'nl','Fout bijwerken verkooppersoneel',0),(47140,1310,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ myyntihenkilÃ¶stÃ¶Ã¤',0),(47141,1310,'no','Feil oppdatering salgspersonale',0),(47142,1310,'da','Fejl opdatering salgspersonale',0),(47143,1310,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ íŒë§¤ ì§ì›',0),(47144,1310,'he','×× ×©×™ ×ž×›×™×¨×•×ª ×”×ž×¢×“×›× ×ª ×©×’×™××”',0),(47145,1310,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Ï‰Î»Î·Ï„ÏŽÎ½',0),(47146,1310,'zh','é”™è¯¯æ›´æ–°é”€å”®äººå‘˜\r\n',0),(47147,1310,'sv','Fel uppdatering sÃ¤ljpersonal',0),(47148,1310,'it','Personale di vendita aggiornamento errore',0),(47149,1310,'tl','',0),(47150,1310,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(47151,1310,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚',0),(47152,1310,'ms','Kakitangan jualan pengemaskinian dengan ralat',0),(47153,1310,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø£ÙØ±Ø§Ø¯ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(47154,1310,'fr','Personnel de vente mise Ã  jour par erreur',0),(47155,1310,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¹ã‚¿ãƒƒãƒ•ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47156,1310,'pt','Pessoal de vendas atualizaÃ§Ã£o de erro',0),(47157,1310,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(47158,1310,'es','Error actualizando personal de ventas',0),(47159,1310,'de','Fehler Update Verkaufspersonal',0),(47160,1310,'en','Error updating sales personnel',0),(47161,1311,'is','',0),(47162,1311,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(47163,1311,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(47164,1311,'tr','SatÄ±ÅŸ vergisi gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(47165,1311,'pl','BÅ‚Ä…d podczas aktualizowania podatku',0),(47166,1311,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(47167,1311,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(47168,1311,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(47169,1311,'vi','Lá»—i cáº­p nháº­t thuáº¿ bÃ¡n hÃ ng',0),(47170,1311,'af','Fout bywerking verkoopsbelasting',0),(47171,1311,'ro','Eroare la actualizarea impozit pe vÃ¢nzÄƒri',0),(47172,1311,'et','Viga ajakohastamine kÃ¤ibemaksu',0),(47173,1311,'si','Napaka pri posodabljanju prometnega davka',0),(47174,1311,'ba','Kesalahan update pajak penjualan',0),(47175,1311,'nl','Fout bij het bijwerken van BTW',0),(47176,1311,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ arvonlisÃ¤vero',0),(47177,1311,'no','Feil under oppdatering av mva',0),(47178,1311,'da','Fejl under opdatering af moms',0),(47179,1311,'ko','íŒë§¤ ì„¸ê¸ˆ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(47180,1311,'he','×©×’×™××” ×‘×¢×“×›×•×Ÿ ×ž×¡ ×ž×›×™×¨×•×ª',0),(47181,1311,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(47182,1311,'zh','é”™è¯¯æ›´æ–°é”€å”®ç¨Ž\r\n',0),(47183,1311,'sv','Gick inte att uppdatera moms',0),(47184,1311,'it','Errore di aggiornamento IVA',0),(47185,1311,'tl','',0),(47186,1311,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3616;&#3634;&#3625;&#3637;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(47187,1311,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(47188,1311,'ms','Ralat dalam mengemas kini cukai jualan',0),(47189,1311,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(47190,1311,'fr','Erreur mise Ã  jour de taxe de vente',0),(47191,1311,'jp','å£²ä¸Šç¨Žã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47192,1311,'pt','Erro ao atualizar o imposto sobre vendas',0),(47193,1311,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¾Ð±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(47194,1311,'es','Error actualizando IVA',0),(47195,1311,'de','Fehler beim Aktualisieren der Umsatzsteuer',0),(47196,1311,'en','Error updating sales tax',0),(47197,1312,'is','',0),(47198,1312,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø±ÙˆØ´ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ',0),(47199,1312,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø±ÙˆØ´ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ',0),(47200,1312,'tr','Nakliye yÃ¶ntemi gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(47201,1312,'pl','BÅ‚Ä…d podczas aktualizowania metody wysyÅ‚ki',0),(47202,1312,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð°Ñ‡Ð¸Ð½ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(47203,1312,'ur','Ú©Ø´ØªÛŒ Ø±Ø§Ù†ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(47204,1312,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð½Ð°Ñ‡Ð¸Ð½ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(47205,1312,'vi','Lá»—i khi cáº­p nháº­t phÆ°Æ¡ng thá»©c váº­n chuyá»ƒn',0),(47206,1312,'af','Fout met opdatering van Versendingsmetode',0),(47207,1312,'ro','Eroare la actualizarea metoda de transport maritim',0),(47208,1312,'et','Tarneviisi uuendamisel tekkis viga',0),(47209,1312,'si','Napaka pri posodabljanju naÄin poÅ¡iljanja',0),(47210,1312,'ba','Kesalahan update metode pengiriman',0),(47211,1312,'nl','Fout bij het bijwerken van de verzendmethode',0),(47212,1312,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ toimitustapa',0),(47213,1312,'no','Feil under oppdatering av leveringsmÃ¥tene',0),(47214,1312,'da','Fejl under opdatering af shipping metode',0),(47215,1312,'ko','ë°°ì†¡ ë°©ë²• ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(47216,1312,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×©×™×˜×ª ×”×ž×©×œ×•×—',0),(47217,1312,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ Î¼ÎµÎ¸Î¿Î´Î¿Ï… Î‘Î ÎŸÎ£Î¤ÎŸÎ›Î—Î£',0),(47218,1312,'zh','é”™è¯¯æ›´æ–°é€è´§æ–¹å¼\r\n',0),(47219,1312,'sv','Gick inte att uppdatera leveranssÃ¤tt',0),(47220,1312,'it','Errore di aggiornamento metodo di spedizione',0),(47221,1312,'tl','',0),(47222,1312,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(47223,1312,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤ªà¤¦à¥à¤§à¤¤à¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(47224,1312,'ms','Ralat dalam mengemas kini kaedah penghantaran',0),(47225,1312,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø´Ø­Ù†',0),(47226,1312,'fr','Erreur mise Ã  jour du mode de livraison',0),(47227,1312,'jp','é…?é€?æ–¹æ³•ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47228,1312,'pt','Erro ao atualizar o mÃ©todo de envio',0),(47229,1312,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÐ¿Ð¾ÑÐ¾Ð±Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(47230,1312,'es','Error actualizando mÃ©todo de transporte',0),(47231,1312,'de','Fehler beim Aktualisieren der Versandart',0),(47232,1312,'en','Error updating shipping method',0),(47233,1313,'is','',0),(47234,1313,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø³ÙŠØ³ØªÙ… Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(47235,1313,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø³ÙŠØ³ØªÙ… Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(47236,1313,'tr','Standart biÃ§imlendirme kÃ¼me gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(47237,1313,'pl','BÅ‚Ä…d podczas aktualizowania standardowy zestaw znacznikÃ³w',0),(47238,1313,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð° Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ',0),(47239,1313,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(47240,1313,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð·Ð½Ð°ÐºÐµ Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ',0),(47241,1313,'vi','Lá»—i cáº­p nháº­t giÃ¡ cá»™ng thÃªm chuáº©n',0),(47242,1313,'af','Fout standaard Markup stel bywerking',0),(47243,1313,'ro','Eroare la actualizarea Set Standard de marcare',0),(47244,1313,'et','Viga ajakohastamine Standard mÃ¤rgistuskeel mÃ¤Ã¤ra',0),(47245,1313,'si','Napaka pri posodabljanju Standard oznaÄevalni Set',0),(47246,1313,'ba','Kesalahan update Standard Markup Set',0),(47247,1313,'nl','Fout bij het bijwerken Standard Markup Set',0),(47248,1313,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ Standard Markup Set',0),(47249,1313,'no','Feil under oppdatering av Standard Markup satt',0),(47250,1313,'da','Fejl under opdatering af Standard Markup sÃ¦t',0),(47251,1313,'ko','í‘œì¤€ íƒœê·¸ ì§‘í•© ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(47252,1313,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×”×’×“×¨ ×¡×™×ž×•×Ÿ ×¨×’×™×œ',0),(47253,1313,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ Î´Î­ÏƒÎ¼Î·Ï‚ Ï€ÏÎ¿Ï„ÏÏ€Ï‰Î½ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(47254,1313,'zh','é”™è¯¯æ›´æ–°çš„æ ‡å‡†æ ‡è®°é›†\r\n',0),(47255,1313,'sv','Gick inte att uppdatera Standard Markup ange',0),(47256,1313,'it','Errore durante l\'aggiornamento di Markup Standard Set',0),(47257,1313,'tl','',0),(47258,1313,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3',0),(47259,1313,'hi','à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(47260,1313,'ms','Ralat dalam mengemas kini Set penanda Standard',0),(47261,1313,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« \"ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©\"',0),(47262,1313,'fr','Erreur mise Ã  jour le balisage Standard Set',0),(47263,1313,'jp','æ¨™æº–å€¤ä¸Šã?’è¨­å®šã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47264,1313,'pt','Erro ao atualizar o conjunto padrÃ£o de marcaÃ§Ã£o',0),(47265,1313,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… Ð½Ð°Ð±Ð¾Ñ€Ð¾Ð² Ð¿Ð¾Ð¼ÐµÑ‚Ð¾Ðº',0),(47266,1313,'es','Error actualizando Juego de Encarecimiento EstÃ¡ndar',0),(47267,1313,'de','Fehler beim Aktualisieren der Standard Markup festgelegt',0),(47268,1313,'en','Error updating Standard Markup Set',0),(47269,1314,'is','',0),(47270,1314,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(47271,1314,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(47272,1314,'tr','Standart miktar gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(47273,1314,'pl','BÅ‚Ä…d podczas aktualizowania standardowa iloÅ›Ä‡.',0),(47274,1314,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾.',0),(47275,1314,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(47276,1314,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°.',0),(47277,1314,'vi','Lá»—i cáº­p nháº­t sá»‘ lÆ°á»£ng chuáº©n',0),(47278,1314,'af','Fout standaard hoeveelheid werk.',0),(47279,1314,'ro','Eroare la actualizarea cantitatea standard.',0),(47280,1314,'et','Viga ajakohastamine standard kogus.',0),(47281,1314,'si','Napaka pri posodabljanju standardne koliÄine.',0),(47282,1314,'ba','Kesalahan update kuantitas standar.',0),(47283,1314,'nl','Fout bij het bijwerken van standaard hoeveelheid.',0),(47284,1314,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ vakiomÃ¤Ã¤rÃ¤.',0),(47285,1314,'no','Feil under oppdatering av standard antall.',0),(47286,1314,'da','Fejl under opdatering af standard mÃ¦ngde.',0),(47287,1314,'ko','í‘œì¤€ ìˆ˜ëŸ‰ì„ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(47288,1314,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×›×ž×•×ª ×¡×˜× ×“×¨×˜×™×ª.',0),(47289,1314,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÏŒÏ„Ï…Ï€Î¿ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±.',0),(47290,1314,'zh','é”™è¯¯æ›´æ–°æ ‡å‡†æ•°é‡ã€‚\r\n',0),(47291,1314,'sv','Det gick inte att uppdatera standardkvantiteten.',0),(47292,1314,'it','Errore di aggiornamento standard quantitativo.',0),(47293,1314,'tl','',0),(47294,1314,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(47295,1314,'hi','à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(47296,1314,'ms','Ralat dalam mengemas kini bahan standard.',0),(47297,1314,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« ÙƒÙ…ÙŠØ© Ù‚ÙŠØ§Ø³ÙŠØ©.',0),(47298,1314,'fr','Erreur mise Ã  jour de quantitÃ© standard.',0),(47299,1314,'jp','æ¨™æº–æ•°é‡?ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47300,1314,'pt','Erro ao atualizar a quantidade normal.',0),(47301,1314,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð³Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°.',0),(47302,1314,'es','Error actualizando cantidad estÃ¡ndar',0),(47303,1314,'de','Fehler beim Aktualisieren der Standardmenge.',0),(47304,1314,'en','Error updating standard quantity.',0),(47305,1315,'is','',0),(47306,1315,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(47307,1315,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(47308,1315,'tr','Standart Ã¶lÃ§Ã¼ gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(47309,1315,'pl','BÅ‚Ä…d podczas aktualizowania standardowej wielkoÅ›ci.',0),(47310,1315,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(47311,1315,'ur','Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ø³Ø§Ø¦Ø² Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(47312,1315,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ðµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ.',0),(47313,1315,'vi','Lá»—i cáº­p nháº­t cá»¡ chuáº©n',0),(47314,1315,'af','Fout het ontstaan met die opdatering van standaard grootte.',0),(47315,1315,'ro','Eroare la actualizarea dimensiunea standard.',0),(47316,1315,'et','Standardformaadiga vÃ¤rskendamise tÃµrge.',0),(47317,1315,'si','Napaka pri posodabljanju standardne velikosti.',0),(47318,1315,'ba','Kesalahan update ukuran standar.',0),(47319,1315,'nl','Fout bij het bijwerken van standaard formaat.',0),(47320,1315,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ vakiokoko.',0),(47321,1315,'no','Feil under oppdatering av standard stÃ¸rrelse.',0),(47322,1315,'da','Fejl under opdatering af standard stÃ¸rrelse.',0),(47323,1315,'ko','í‘œì¤€ í¬ê¸°ë¥¼ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(47324,1315,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×‘×’×•×“×œ ×¡×˜× ×“×¨×˜×™.',0),(47325,1315,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… ÎºÎ±Î½Î¿Î½Î¹ÎºÎ¿Ï Î¼ÎµÎ³Î­Î¸Î¿Ï…Ï‚.',0),(47326,1315,'zh','é”™è¯¯æ›´æ–°æ ‡å‡†å°ºå¯¸ã€‚\r\n',0),(47327,1315,'sv','Det gick inte att uppdatera standard storlek.',0),(47328,1315,'it','Errore durante l\'aggiornamento di dimensioni standard.',0),(47329,1315,'tl','',0),(47330,1315,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3609;&#3634;&#3604;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;',0),(47331,1315,'hi','à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(47332,1315,'ms','Ralat dalam mengemas kini saiz standard.',0),(47333,1315,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ.',0),(47334,1315,'fr','Erreur mise Ã  jour de taille standard.',0),(47335,1315,'jp','æ¨™æº–ã‚µã‚¤ã‚ºã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47336,1315,'pt','Erro ao atualizar o tamanho padrÃ£o.',0),(47337,1315,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð³Ð¾ Ñ€Ð°Ð·Ð¼ÐµÑ€Ð°.',0),(47338,1315,'es','Error actualizando el tamaÃ±o estÃ¡ndar',0),(47339,1315,'de','Fehler beim Aktualisieren der StandardgrÃ¶ÃŸe.',0),(47340,1315,'en','Error updating standard size.',0),(47341,1316,'is','',0),(47342,1316,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù†  Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(47343,1316,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù†  Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(47344,1316,'tr','Stok gÃ¼ncelleÅŸtirme hatasÄ±.',0),(47345,1316,'pl','BÅ‚Ä…d podczas aktualizowania akcji.',0),(47346,1316,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´.',0),(47347,1316,'ur','Ø§Ø³Ù¹Ø§Ú© Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(47348,1316,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð°ÐºÑ†Ð¸Ñ˜Ðµ.',0),(47349,1316,'vi','Lá»—i cáº­p nháº­t hÃ ng tá»“n',0),(47350,1316,'af','Fout met opdatering van voorraad',0),(47351,1316,'ro','Eroare la actualizarea stoc.',0),(47352,1316,'et','Viga ajakohastamine stock.',0),(47353,1316,'si','Napaka pri posodabljanju parka.',0),(47354,1316,'ba','Kesalahan update saham.',0),(47355,1316,'nl','Fout bij het bijwerken van de voorraad.',0),(47356,1316,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ varastossa.',0),(47357,1316,'no','Feil under oppdatering av lager.',0),(47358,1316,'da','Fejl under opdatering af lager.',0),(47359,1316,'ko','ìž¬ê³ ë¥¼ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(47360,1316,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×ž×œ××™.',0),(47361,1316,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½.',0),(47362,1316,'zh','é”™è¯¯æ›´æ–°è‚¡ç¥¨ã€‚\r\n',0),(47363,1316,'sv','Det gick inte att uppdatera lager.',0),(47364,1316,'it','Errore di aggiornamento magazzino.',0),(47365,1316,'tl','',0),(47366,1316,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3605;&#3655;&#3629;&#3585;',0),(47367,1316,'hi','à¤¶à¥‡à¤¯à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(47368,1316,'ms','Ralat dalam mengemas kini stok.',0),(47369,1316,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø®Ø²ÙˆÙ†.',0),(47370,1316,'fr','Erreur mise Ã  jour du stock.',0),(47371,1316,'jp','åœ¨åº«ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47372,1316,'pt','Erro ao atualizar o estoque.',0),(47373,1316,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¾Ð².',0),(47374,1316,'es','Error actualizando stock',0),(47375,1316,'de','Fehler beim Aktualisieren der Lager.',0),(47376,1316,'en','Error updating stock.',0),(47377,1317,'is','',0),(47378,1317,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(47379,1317,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(47380,1317,'tr','alt grubu gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(47381,1317,'pl','bÅ‚Ä…d podczas aktualizowania podgrupy',0),(47382,1317,'bg','Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð°Ñ‚Ð°',0),(47383,1317,'ur','Ø³Ø¨Ú¯Ø±ÙˆÙ¾ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(47384,1317,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ñƒ',0),(47385,1317,'vi','Lá»—i cáº­p nháº­t nhÃ³m phá»¥',0),(47386,1317,'af','fout met opdatering van sub-groep',0),(47387,1317,'ro','Eroare la actualizarea subgrup',0),(47388,1317,'et','Viga ajakohastamine alarÃ¼hm',0),(47389,1317,'si','Napaka pri posodabljanju podskupini',0),(47390,1317,'ba','kesalahan update subgrup',0),(47391,1317,'nl','fout bij het bijwerken van subgroep',0),(47392,1317,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ alaryhmÃ¤',0),(47393,1317,'no','feil under oppdatering av undergruppe',0),(47394,1317,'da','fejl under opdatering af undergruppe',0),(47395,1317,'ko','í•˜ìœ„ ê·¸ë£¹ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(47396,1317,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×§×‘×•×¦×ª ×ž×©× ×”',0),(47397,1317,'el','ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï…Ï€Î¿Î¿Î¼Î¬Î´Î±',0),(47398,1317,'zh','é”™è¯¯æ›´æ–°åˆ†ç»„\r\n',0),(47399,1317,'sv','gick inte att uppdatera undergrupp',0),(47400,1317,'it','errore di aggiornamento sottogruppo',0),(47401,1317,'tl','',0),(47402,1317,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(47403,1317,'hi','à¤‰à¤ªà¤¸à¤®à¥‚à¤¹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(47404,1317,'ms','Ralat dalam mengemas kini subkumpulan',0),(47405,1317,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙØ±ÙŠÙ‚ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(47406,1317,'fr','erreur mise Ã  jour de sous-groupe',0),(47407,1317,'jp','ã‚µãƒ–ã‚°ãƒ«ãƒ¼ãƒ—ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47408,1317,'pt','erro ao atualizar subgrupo',0),(47409,1317,'ru','Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(47410,1317,'es','Error actualizando subgrupo',0),(47411,1317,'de','Fehler beim Aktualisieren der Untergruppe',0),(47412,1317,'en','error updating subgroup',0),(47413,1318,'is','',0),(47414,1318,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(47415,1318,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(47416,1318,'tr','Hata gÃ¼ncelleÅŸtirme vergi muafiyeti',0),(47417,1318,'pl','BÅ‚Ä…d aktualizacji zwolnienia z podatku',0),(47418,1318,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº',0),(47419,1318,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(47420,1318,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð±ÐµÐ· Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ†Ð°Ñ€Ð¸Ð½Ðµ',0),(47421,1318,'vi','Lá»—i cáº­p nháº­t miá»…n thuáº¿',0),(47422,1318,'af','Fout met opdatering van belasting vrystelling',0),(47423,1318,'ro','Eroare de actualizare scutire de impozit',0),(47424,1318,'et','Viga ajakohastamine maksuvabastus',0),(47425,1318,'si','Napaka posodabljanje davÄne oprostitve',0),(47426,1318,'ba','Kesalahan update Pembebasan pajak',0),(47427,1318,'nl','Fout bijwerken belastingvrijstelling',0),(47428,1318,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ verovapautus',0),(47429,1318,'no','Feil oppdatering skattefritak',0),(47430,1318,'da','Fejl opdatering skattefrihed',0),(47431,1318,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì„¸ê¸ˆ ë©´ì œ',0),(47432,1318,'he','×¤×˜×•×¨ ×ž×ž×¡ ×”×ž×¢×“×›× ×ª ×©×’×™××”',0),(47433,1318,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î±Ï€Î±Î»Î»Î±Î³Î® Î±Ï€ÏŒ Ï„Î¿ Ï†ÏŒÏÎ¿',0),(47434,1318,'zh','é”™è¯¯æ›´æ–°å…ç¨Ž\r\n',0),(47435,1318,'sv','Fel uppdatering skattebefrielse',0),(47436,1318,'it','Aggiornamento esenzione fiscale di errore',0),(47437,1318,'tl','',0),(47438,1318,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(47439,1318,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤° à¤›à¥‚à¤Ÿ',0),(47440,1318,'ms','Pengecualian cukai ralat pengemaskinian',0),(47441,1318,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ',0),(47442,1318,'fr','ExonÃ©ration de l\'impÃ´t erreur mise Ã  jour',0),(47443,1318,'jp','ç¨ŽæŽ§é™¤ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47444,1318,'pt','IsenÃ§Ã£o do imposto sobre atualizaÃ§Ã£o erro',0),(47445,1318,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ Ð¾Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(47446,1318,'es','Error actualizando exenciÃ³n de impuestos',0),(47447,1318,'de','Fehler Update Steuerbefreiung',0),(47448,1318,'en','Error updating tax exemption',0),(47449,1319,'is','',0),(47450,1319,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ ',0),(47451,1319,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ ',0),(47452,1319,'tr','Hata gÃ¼ncelleÅŸtirme birim adÄ±',0),(47453,1319,'pl','BÅ‚Ä…d aktualizacji nazwy jednostki',0),(47454,1319,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð¼Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(47455,1319,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ù†Ø§Ù…',0),(47456,1319,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð¼Ðµ',0),(47457,1319,'vi','Lá»—i cáº­p nháº­t tÃªn Ä‘Æ¡n vá»‹',0),(47458,1319,'af','Fout met opdatering van eenheidnaam',0),(47459,1319,'ro','Eroare nume de unitatea actualizarea',0),(47460,1319,'et','Viga ajakohastamine Ã¼hiku nimi',0),(47461,1319,'si','Napaka posodabljanje ime enote',0),(47462,1319,'ba','Nama unit memperbarui kesalahan',0),(47463,1319,'nl','Fout bijwerken eenheid naam',0),(47464,1319,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ yksikÃ¶n nimi',0),(47465,1319,'no','Feil oppdatering navn',0),(47466,1319,'da','Fejl opdatering enhed navn',0),(47467,1319,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë‹¨ìœ„ ì´ë¦„',0),(47468,1319,'he','×©×’×™××” ×‘×©× ×™×—×™×“×ª ×”×ž×¢×“×›× ×ª',0),(47469,1319,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î¼Î¿Î½Î¬Î´Î± ÏŒÎ½Î¿Î¼Î±',0),(47470,1319,'zh','é”™è¯¯æ›´æ–°å•ä½åç§°\r\n',0),(47471,1319,'sv','Fel uppdatering enhet namn',0),(47472,1319,'it','Errore aggiornamento nome unitÃ ',0),(47473,1319,'tl','',0),(47474,1319,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(47475,1319,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¾à¤®',0),(47476,1319,'ms','Ralat pengemaskinian unit nama',0),(47477,1319,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø¥Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø©',0),(47478,1319,'fr','Nom de l\'unitÃ© erreur mise Ã  jour',0),(47479,1319,'jp','å?˜ä½?å??ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47480,1319,'pt','Nome da unidade de atualizaÃ§Ã£o erro',0),(47481,1319,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ',0),(47482,1319,'es','Error actualizando nombre de unidad',0),(47483,1319,'de','Fehler aktualisieren GerÃ¤tename',0),(47484,1319,'en','Error updating unit name',0),(47485,1320,'is','',0),(47486,1320,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙƒØ§Ø±Ø¨Ø± ',0),(47487,1320,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙƒØ§Ø±Ø¨Ø± ',0),(47488,1320,'tr','Hata gÃ¼ncelleÅŸtirme kullanÄ±cÄ±',0),(47489,1320,'pl','BÅ‚Ä…d aktualizacji uÅ¼ytkownika',0),(47490,1320,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(47491,1320,'ur','Ù†Ù‚Øµ ØµØ§Ø±Ù Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(47492,1320,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(47493,1320,'vi','Cáº­p Nháº­t NgÆ°á»i Sá»­ Dá»¥ng Bá»‹ Lá»—i',0),(47494,1320,'af','Fout met opdateer van gebruiker',0),(47495,1320,'ro','Eroare actualizare utilizator',0),(47496,1320,'et','Kasutaja uuendamisel tekkis viga',0),(47497,1320,'si','Modernizirati uporabnik napaka',0),(47498,1320,'ba','Kesalahan update pengguna',0),(47499,1320,'nl','Fout bijwerken gebruiker',0),(47500,1320,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ kÃ¤yttÃ¤jÃ¤Ã¤',0),(47501,1320,'no','Feil oppdatering bruker',0),(47502,1320,'da','Fejl opdatering bruger',0),(47503,1320,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì‚¬ìš©ìž',0),(47504,1320,'he','×ž×©×ª×ž×© ×ž×¢×“×›×Ÿ ×©×’×™××”',0),(47505,1320,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·',0),(47506,1320,'zh','é”™è¯¯æ›´æ–°ç”¨æˆ·\r\n',0),(47507,1320,'sv','Fel uppdatering anvÃ¤ndaren',0),(47508,1320,'it','Aggiornamento utente errore',0),(47509,1320,'tl','',0),(47510,1320,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(47511,1320,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(47512,1320,'ms','Ralat pengemaskinian pengguna',0),(47513,1320,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(47514,1320,'fr','Erreur mise Ã  jour utilisateur',0),(47515,1320,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47516,1320,'pt','UsuÃ¡rio de erro atualizaÃ§Ã£o',0),(47517,1320,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(47518,1320,'es','Error actualizando usuario',0),(47519,1320,'de','Fehlermeldung aktualisieren user',0),(47520,1320,'en','Error updating user',0),(47521,1321,'is','',0),(47522,1321,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø± ',0),(47523,1321,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø± ',0),(47524,1321,'tr','KullanÄ±cÄ± haklarÄ± gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(47525,1321,'pl','BÅ‚Ä…d podczas aktualizowania praw uÅ¼ytkownika',0),(47526,1321,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ñ€Ð°Ð²Ð°',0),(47527,1321,'ur','ØµØ§Ø±Ù Ú©Û’ Ø­Ù‚ÙˆÙ‚ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(47528,1321,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸Ñ… Ð¿Ñ€Ð°Ð²Ð°',0),(47529,1321,'vi','Cáº­p Nháº­t PhÃ¢n Quyá»n NgÆ°á»i Sá»­ Dá»¥ng Bá»‹ Lá»—i',0),(47530,1321,'af','Fout met opdatering van gebruikerregte',0),(47531,1321,'ro','Eroare actualizare drepturi utilizator',0),(47532,1321,'et','Viga ajakohastamine kasutajaÃµigused',0),(47533,1321,'si','Napaka pri posodabljanju uporabniÅ¡ke pravice',0),(47534,1321,'ba','Kesalahan memperbarui hak pengguna',0),(47535,1321,'nl','Fout bij het bijwerken van gebruikersrechten',0),(47536,1321,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ kÃ¤yttÃ¶oikeuksia',0),(47537,1321,'no','Feil under oppdatering av brukerrettigheter',0),(47538,1321,'da','Fejl under opdatering af brugerrettigheder',0),(47539,1321,'ko','ì‚¬ìš©ìž ê¶Œí•œ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(47540,1321,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×–×›×•×™×•×ª ×ž×©×ª×ž×©',0),(47541,1321,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Î´Î¹ÎºÎ±Î¹Ï‰Î¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÏ„Î·',0),(47542,1321,'zh','é”™è¯¯æ›´æ–°ç”¨æˆ·æƒé™\r\n',0),(47543,1321,'sv','Gick inte att uppdatera anvÃ¤ndarrÃ¤ttigheter',0),(47544,1321,'it','Errore durante l\'aggiornamento dei diritti utente',0),(47545,1321,'tl','',0),(47546,1321,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3636;&#3607;&#3608;&#3636;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(47547,1321,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(47548,1321,'ms','Ralat dalam mengemas kini hak-hak pengguna',0),(47549,1321,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(47550,1321,'fr','Erreur mise Ã  jour des droits de l\'utilisateur',0),(47551,1321,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©é™?ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47552,1321,'pt','Erro na atualizaÃ§Ã£o de direitos de usuÃ¡rio',0),(47553,1321,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ñ€Ð°Ð² Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(47554,1321,'es','Error actualizando derechos de usuarios',0),(47555,1321,'de','Fehler beim Aktualisieren der Benutzerrechte',0),(47556,1321,'en','Error updating user rights',0),(47557,1322,'is','',0),(47558,1322,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(47559,1322,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(47560,1322,'tr','Hata gÃ¼ncelleÅŸtirme satÄ±cÄ±',0),(47561,1322,'pl','BÅ‚Ä…d aktualizacji dostawcy',0),(47562,1322,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(47563,1322,'ur','Ù†Ù‚Øµ ÙˆÛŒÙ†ÚˆØ± ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(47564,1322,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(47565,1322,'vi','Lá»—i cáº­p nháº­t ngÆ°á»i bÃ¡n',0),(47566,1322,'af','Fout met opdatering van verskaffer',0),(47567,1322,'ro','Eroare de actualizare furnizor',0),(47568,1322,'et','Tarnija uuendamisel tekkis viga',0),(47569,1322,'si','Napaka posodabljanje dobavitelja',0),(47570,1322,'ba','Kesalahan update Penjual',0),(47571,1322,'nl','Fout bijwerken leverancier',0),(47572,1322,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ toimittajan',0),(47573,1322,'no','Feil oppdatering leverandÃ¸r',0),(47574,1322,'da','Fejl opdatering leverandÃ¸r',0),(47575,1322,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ê³µê¸‰ ì—…ì²´',0),(47576,1322,'he','×”×¡×¤×§ ×”×ž×¢×“×›× ×ª ×©×’×™××”',0),(47577,1322,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(47578,1322,'zh','é”™è¯¯æ›´æ–°ä¾›åº”å•†\r\n',0),(47579,1322,'sv','Fel uppdatering leverantÃ¶r',0),(47580,1322,'it','Fornitore aggiornamento errore',0),(47581,1322,'tl','',0),(47582,1322,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(47583,1322,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(47584,1322,'ms','Ralat pengemaskinian Penjual',0),(47585,1322,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(47586,1322,'fr','Fournisseur de mise Ã  jour erreur',0),(47587,1322,'jp','æ¥­è€…ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47588,1322,'pt','Fornecedor de atualizaÃ§Ã£o de erro',0),(47589,1322,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(47590,1322,'es','Error actualizando Proveedor',0),(47591,1322,'de','Fehler Update Anbieter',0),(47592,1322,'en','Error updating vendor',0),(47593,1323,'is','',0),(47594,1323,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(47595,1323,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(47596,1323,'tr','Hata gÃ¼ncelleÅŸtirme satÄ±cÄ± maddesi bilgilerinde',0),(47597,1323,'pl','BÅ‚Ä…d aktualizacji dostawcy element informacji',0),(47598,1323,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(47599,1323,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ ÙˆÛŒÙ†ÚˆØ± Ø´Û’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(47600,1323,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ñƒ ÑÐ½Ð°Ð±Ð´ÐµÐ²Ð°Ñ‡Ð°',0),(47601,1323,'vi','Lá»—i khi cáº­p nháº­t thÃ´ng tin ngÆ°á»i bÃ¡n',0),(47602,1323,'af','Fout met opdatering van Verskaffer Item Inligting',0),(47603,1323,'ro','Eroare de actualizare furnizor articol informaÅ£ii',0),(47604,1323,'et','Viga ajakohastamine hankija kauba teabes',0),(47605,1323,'si','Napaka pri posodabljanju podatke o artiklu dobavitelja',0),(47606,1323,'ba','Kesalahan update informasi vendor item',0),(47607,1323,'nl','Fout bijwerken leverancier objectgegevens',0),(47608,1323,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ toimittajan nimiketietoihin',0),(47609,1323,'no','Feil oppdatering leverandÃ¸rvareopplysningene',0),(47610,1323,'da','Fejl opdatering kreditor vareoplysninger',0),(47611,1323,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ê³µê¸‰ ì—…ì²´ í•­ëª© ì •ë³´',0),(47612,1323,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×¤×¨×™×˜ ×ž×™×“×¢ ××•×“×•×ª ×¡×¤×§×™×',0),(47613,1323,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ ÎµÎ¯Î´Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(47614,1323,'zh','é”™è¯¯æ›´æ–°ä¾›åº”å•†é¡¹ç›®ä¿¡æ¯\r\n',0),(47615,1323,'sv','Fel uppdatering leverantÃ¶rens artikelinformation',0),(47616,1323,'it','Aggiornamento delle informazioni di elemento fornitore di errore',0),(47617,1323,'tl','',0),(47618,1323,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3612;&#3641;&#3657;&#3586;&#3',0),(47619,1323,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤†à¤‡à¤Ÿà¤® à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(47620,1323,'ms','Ralat pengemaskinian maklumat item Penjual',0),(47621,1323,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØµÙ†Ù Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(47622,1323,'fr','Erreur mise Ã  jour du vendeur point informations',0),(47623,1323,'jp','æ¥­è€…å“?ç›®æƒ…å ±ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47624,1323,'pt','Atualizando informaÃ§Ãµes de item fornecedor erro',0),(47625,1323,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸',0),(47626,1323,'es','Error actualizando informaciÃ³n de item de Proveedor',0),(47627,1323,'de','Fehler Update Element Herstellerinformationen',0),(47628,1323,'en','Error updating vendor item information',0),(47629,1324,'is','',0),(47630,1324,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(47631,1324,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(47632,1324,'tr','SatÄ±cÄ± aÃ§Ä±sÄ±ndan gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(47633,1324,'pl','BÅ‚Ä…d aktualizacji warunkÃ³w dostawcy',0),(47634,1324,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑƒÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(47635,1324,'ur','ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø· Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(47636,1324,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑƒÑÐ»Ð¾Ð²Ð¸',0),(47637,1324,'vi','Lá»—i cáº­p nháº­t Ä‘iá»u khoáº£n ngÆ°á»i bÃ¡n',0),(47638,1324,'af','Fout met opdatering van verskafferterme',0),(47639,1324,'ro','Eroare la actualizarea furnizor termeni',0),(47640,1324,'et','TÃµrge vÃ¤rskendamisel hankija tingimused',0),(47641,1324,'si','Napaka pri posodabljanju pogoji dobavitelja',0),(47642,1324,'ba','Kesalahan memperbarui persyaratan Vendor',0),(47643,1324,'nl','Fout bij het bijwerken van leverancier voorwaarden',0),(47644,1324,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ toimittajan',0),(47645,1324,'no','Feil under oppdatering av leverandÃ¸ren vilkÃ¥r',0),(47646,1324,'da','Fejl under opdatering af kreditor vilkÃ¥r',0),(47647,1324,'ko','ê³µê¸‰ ì—…ì²´ ì¡°ê±´ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(47648,1324,'he','×©×’×™××” ×‘×¢×“×›×•×Ÿ ×ª× ××™ ×¡×¤×§',0),(47649,1324,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(47650,1324,'zh','é”™è¯¯æ›´æ–°ä¾›åº”å•†çš„æ¡æ¬¾\r\n',0),(47651,1324,'sv','Fel vid uppdatering av leverantÃ¶rens villkor',0),(47652,1324,'it','Errore di aggiornamento termini di fornitore',0),(47653,1324,'tl','',0),(47654,1324,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(47655,1324,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(47656,1324,'ms','Ralat dalam mengemas kini pembekal terma',0),(47657,1324,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(47658,1324,'fr','Erreur mise Ã  jour des termes du vendeur',0),(47659,1324,'jp','æ¥­è€…å“?ç›®ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47660,1324,'pt','Erro ao atualizar termos de fornecedor',0),(47661,1324,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹',0),(47662,1324,'es','Error actualizando los tÃ©rminos de Proveedor',0),(47663,1324,'de','Fehler beim Aktualisieren der VerkÃ¤ufer-AGB',0),(47664,1324,'en','Error updating Vendor Terms',0),(47665,1325,'is','',0),(47666,1325,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(47667,1325,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(47668,1325,'tr','Hata gÃ¼ncelleÅŸtirme iÅŸ tÃ¼rÃ¼.',0),(47669,1325,'pl','BÅ‚Ä…d aktualizacji typu pracy.',0),(47670,1325,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ð°.',0),(47671,1325,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ú©Ø§Ù… Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª Û”',0),(47672,1325,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°.',0),(47673,1325,'vi','Lá»—i cáº­p nháº­t loáº¡i cÃ´ng viá»‡c',0),(47674,1325,'af','Fout met opdatering van werktipe.',0),(47675,1325,'ro','Eroare actualizarea tip de munca.',0),(47676,1325,'et','Viga ajakohastamine tÃ¶Ã¶ liik.',0),(47677,1325,'si','Posodabljanje delo vrste napak.',0),(47678,1325,'ba','Kesalahan update jenis pekerjaan.',0),(47679,1325,'nl','Fout bijwerken werksoort.',0),(47680,1325,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tyÃ¶tyyppi.',0),(47681,1325,'no','Feil oppdatering arbeidstype.',0),(47682,1325,'da','Fejl opdatering arbejdstype.',0),(47683,1325,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ìž‘ì—… í˜•ì‹ìž…ë‹ˆë‹¤.',0),(47684,1325,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×¡×•×’ ×¢×‘×•×“×”.',0),(47685,1325,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚.',0),(47686,1325,'zh','é”™è¯¯æ›´æ–°å·¥ä½œç±»åž‹ã€‚\r\n',0),(47687,1325,'sv','Fel uppdatering arbetstyp.',0),(47688,1325,'it','Tipo di lavoro aggiornamento errore.',0),(47689,1325,'tl','',0),(47690,1325,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(47691,1325,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°à¥¤',0),(47692,1325,'ms','Jenis kerja pengemaskinian ralat.',0),(47693,1325,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„.',0),(47694,1325,'fr','Type d\'erreur mise Ã  jour de travail.',0),(47695,1325,'jp','ä»•äº‹å†…å®¹ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47696,1325,'pt','Tipo de trabalho de atualizaÃ§Ã£o de erro.',0),(47697,1325,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹.',0),(47698,1325,'es','Error actualizando tipo de trabajo',0),(47699,1325,'de','Fehler Update Arbeitstyp.',0),(47700,1325,'en','Error updating work type.',0),(47701,1326,'is','',0),(47702,1326,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(47703,1326,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(47704,1326,'tr','Ä°ÅŸ tÃ¼rÃ¼ ek bilgiler gÃ¼ncelleÅŸtirilirken hata oluÅŸtu.',0),(47705,1326,'pl','BÅ‚Ä…d podczas aktualizowania pracy typu dodatkowe info.',0),(47706,1326,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð²Ð¸Ð´ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ.',0),(47707,1326,'ur','Ù†Ù‚Øµ Ú©Ø§Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø§Ø¶Ø§ÙÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù¹Ø§Ø¦Ù¾ Ú©Ø±ÛŒÚº Û”',0),(47708,1326,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ€Ð°Ð´ Ñ‚Ð¸Ð¿ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ.',0),(47709,1326,'vi','Lá»—i khi cáº­p nháº­t thÃ´ng tin loáº¡i cÃ´ng viá»‡c thÃªm',0),(47710,1326,'af','Fout met opdatering van werk-tipe addisionele inligting.',0),(47711,1326,'ro','Eroare la actualizarea de lucru tip informatii suplimentare.',0),(47712,1326,'et','TÃ¶Ã¶ tÃ¼Ã¼p Lisainfo vÃ¤rskendamise tÃµrge.',0),(47713,1326,'si','Napaka pri posodabljanju delo vrsta dodatne info.',0),(47714,1326,'ba','Kesalahan update info tambahan jenis pekerjaan.',0),(47715,1326,'nl','Fout bij het bijwerken werk Typ aanvullende info.',0),(47716,1326,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tyÃ¶n tyyppi lisÃ¤tiedot.',0),(47717,1326,'no','Feil under oppdatering av arbeid type tilleggsinformasjon.',0),(47718,1326,'da','Fejl under opdatering af arbejde type yderligere info.',0),(47719,1326,'ko','ìž‘ì—… ìœ í˜• ì¶”ê°€ ì •ë³´ë¥¼ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(47720,1326,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×ž×™×“×¢ × ×•×¡×£ ×©×œ ×¡×•×’ ×¢×‘×•×“×”.',0),(47721,1326,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï… Ï€ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚.',0),(47722,1326,'zh','é”™è¯¯æ›´æ–°å·¥ä½œç±»åž‹çš„å…¶ä»–ä¿¡æ¯ã€‚\r\n',0),(47723,1326,'sv','Det gick inte att uppdatera arbete typ ytterligare info.',0),(47724,1326,'it','Errore di aggiornamento lavoro tipo ulteriori info.',0),(47725,1326,'tl','',0),(47726,1326,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3648;&#3',0),(47727,1326,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(47728,1326,'ms','Ralat dalam mengemas kini maklumat tambahan jenis kerja.',0),(47729,1326,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ© Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„.',0),(47730,1326,'fr','Erreur mise Ã  jour des informations supplÃ©mentaires sur le type travail.',0),(47731,1326,'jp','ä»•äº‹å†…å®¹ä»˜åŠ æƒ…å ±ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(47732,1326,'pt','Erro ao atualizar informaÃ§Ãµes adicionais de tipo de trabalho.',0),(47733,1326,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð¹ Ð¸Ð½Ñ„Ð¾ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹.',0),(47734,1326,'es','Error actualizando info adicional de tipo de trabajo',0),(47735,1326,'de','Fehler beim Aktualisieren der Arbeit Typ Zusatzinfo.',0),(47736,1326,'en','Error updating work type additional info.',0),(47737,1327,'is','',0),(47738,1327,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ø§Ø²Ú¯Ø±Ø¯Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(47739,1327,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ø§Ø²Ú¯Ø±Ø¯Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(47740,1327,'tr','Hata satÄ±cÄ± bilgisi alÄ±nÄ±yor.',0),(47741,1327,'pl','BÅ‚Ä…d pobierania informacji dostawcy.',0),(47742,1327,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°.',0),(47743,1327,'ur','Ù†Ù‚Øµ ÙˆÛŒÙ†ÚˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’ Û”',0),(47744,1327,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ñƒ.',0),(47745,1327,'vi','Lá»—i truy váº¥n thÃ´ng tin ngÆ°á»i bÃ¡n',0),(47746,1327,'af','Fout herwinning handelaar Info.',0),(47747,1327,'ro','Eroare regÄƒsirea furnizor de informaÅ£ii.',0),(47748,1327,'et','TÃµrge allalaadimisel hankijate Info.',0),(47749,1327,'si','Napaka pri pridobivanju informacij o prodajalcu.',0),(47750,1327,'ba','Kesalahan mengambil Vendor Info.',0),(47751,1327,'nl','Fout ophalen Vendor Info.',0),(47752,1327,'fi','Virhe noudettaessa toimittajan Info.',0),(47753,1327,'no','Feil under henting av leverandÃ¸ren Info.',0),(47754,1327,'da','Fejl under hentning af leverandÃ¸r Info.',0),(47755,1327,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ê³µê¸‰ ì—…ì²´ ì •ë³´ìž…ë‹ˆë‹¤.',0),(47756,1327,'he','×©×’×™××” ×‘××—×–×•×¨ ×ž×™×“×¢ ×”×¡×¤×§.',0),(47757,1327,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Î»Î¬Î¸Î¿Ï‚.',0),(47758,1327,'zh','é”™è¯¯æ£€ç´¢ä¾›åº”å•†ä¿¡æ¯ã€‚\r\n',0),(47759,1327,'sv','Fel hÃ¤mtar leverantÃ¶r information.',0),(47760,1327,'it','Errore recuperando informazioni fornitore.',0),(47761,1327,'tl','',0),(47762,1327,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(47763,1327,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤ªà¥à¤¨à¤ƒà¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¥¤',0),(47764,1327,'ms','Ralat mendapatkan pembekal maklumat.',0),(47765,1327,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¬Ù„Ø¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(47766,1327,'fr','Erreur rÃ©cupÃ©rer Info de vendeur.',0),(47767,1327,'jp','æ¥­è€…æƒ…å ±ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(47768,1327,'pt','Erro Recuperando InformaÃ§Ã£o de fornecedor.',0),(47769,1327,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð’Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð˜Ð½Ñ„Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°.',0),(47770,1327,'es','Error Recogiendo',0),(47771,1327,'de','Fehler beim Abrufen Hersteller Info.',0),(47772,1327,'en','Error Retrieving Vendor Info.',0),(47773,1328,'is','',0),(47774,1328,'dr','- ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø¬Ù†Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(47775,1328,'pr','Ø®Ø·Ø§ - ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(47776,1328,'tr','Bunun iÃ§in satÄ±cÄ± madde zaten EXISTS<br>',0),(47777,1328,'pl','Dostawcy dla tego przedmiotu juÅ¼ istnieje<br>',0),(47778,1328,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°<br>',0),(47779,1328,'ur','Ø§Ø³ Ú©Û’ Ù„Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± Ø´Û’ Ù¾ÛÙ„Û’ ÛÛŒ ÛŒ<br>',0),(47780,1328,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¾Ð²Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð²ÐµÑ› Ð•xÐ¸ÑÑ‚Ñ<br>',0),(47781,1328,'vi','NgÆ°á»i bÃ¡n cho hÃ ng nÃ y Ä‘Ã£ tá»“n táº¡i',0),(47782,1328,'af','Verskaffers bestaan reeds vir hierdie Item<br>',0),(47783,1328,'ro','Furnizor pentru acest element deja Exists<br>',0),(47784,1328,'et','Hankija selle kauba juba on eksisteerinud<br>',0),(47785,1328,'si','Dobavitelja za ta element Å¾e obstaja<br>',0),(47786,1328,'ba','Penjual ini Item sudah Exists â€“ wujud<br>',0),(47787,1328,'nl','Leverancier voor dit object al bestaat<br>',0),(47788,1328,'fi','MyyjÃ¤ tÃ¤mÃ¤n tuotteen jo Exists<br>',0),(47789,1328,'no','LeverandÃ¸r for dette elementet allerede finnes<br>',0),(47790,1328,'da','LeverandÃ¸r til dette punkt allerede eksisterer<br>',0),(47791,1328,'ko','ì´ ëŒ€ í•œ ê³µê¸‰ ì—…ì²´ í•­ëª© ì´ë¯¸ Exists<br>',0),(47792,1328,'he','×¡×¤×§ ×–×” ×¤×¨×™×˜ ×©×›×‘×¨ ×§×™×™×<br>',0),(47793,1328,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î³Î¹Î± Î±Ï…Ï„ÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î®Î´Î· Ï…Ï€Î¬ÏÏ‡ÎµÎ¹<br>',0),(47794,1328,'zh','è¿™ä¸ªé¡¹ç›®çš„ä¾›åº”å•†å·²ç»å­˜åœ¨\r\n',0),(47795,1328,'sv','LeverantÃ¶r fÃ¶r detta objekt redan finns<br>',0),(47796,1328,'it','Fornitore per questo articolo giÃ  Exists<br>',0),(47797,1328,'tl','',0),(47798,1328,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3609;&#3637;&#3657;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3',0),(47799,1328,'hi','à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤†à¤‡à¤Ÿà¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ<br>',0),(47800,1328,'ms','Penjual ini perkara sudah Exists<br>',0),(47801,1328,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ù„Ù‡Ø°Ø§ Ø§Ù„ØµÙ†Ù Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(47802,1328,'fr','Fournisseur pour ce point dÃ©jÃ  Exists<br>',0),(47803,1328,'jp','ã?“ã?®å“?ç›®ã?®æ¥­è€…ã?¯ã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™<br>',0),(47804,1328,'pt','Vendedor para este Item jÃ¡ Exists<br>',0),(47805,1328,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¿ÑƒÐ½ÐºÑ‚Ð° ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚<br>',0),(47806,1328,'es','Proveedor para este item ya existe<br>',0),(47807,1328,'de','Anbieter fÃ¼r dieses Element bereits vorhanden<br>',0),(47808,1328,'en','Vendor for this Item already Exists<br>',0),(47809,1329,'is','',0),(47810,1329,'dr','- ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(47811,1329,'pr','Ø®Ø·Ø§ - ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(47812,1329,'tr','Hata satÄ±cÄ± bulunamadÄ±',0),(47813,1329,'pl','BÅ‚Ä…d dostawcy nie znaleziono',0),(47814,1329,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(47815,1329,'ur','Ù†Ù‚Øµ ÙˆÛŒÙ†ÚˆØ± Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(47816,1329,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(47817,1329,'vi','KhÃ´ng tháº¥y ngÆ°á»i bÃ¡n',0),(47818,1329,'af','Fout het ontstaan Verskaffer nie gevind',0),(47819,1329,'ro','Eroare furnizor negÄƒsit',0),(47820,1329,'et','Viga tarnijat ei leitud',0),(47821,1329,'si','Napaka prodajalca, ni mogoÄe najti',0),(47822,1329,'ba','Kesalahan Vendor tidak ditemukan',0),(47823,1329,'nl','Fout leverancier niet gevonden',0),(47824,1329,'fi','Virhe toimittajaa ei lÃ¶ydy',0),(47825,1329,'no','Feil leverandÃ¸r ikke funnet',0),(47826,1329,'da','Fejl kreditor blev ikke fundet',0),(47827,1329,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ì˜¤ë¥˜ ê³µê¸‰ ì—…ì²´',0),(47828,1329,'he','×”×¡×¤×§ ×©×’×™××” ×œ× × ×ž×¦×',0),(47829,1329,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(47830,1329,'zh','é”™è¯¯ï¼šä¾›åº”å•†æœªæ‰¾åˆ°\r\n',0),(47831,1329,'sv','Fel leverantÃ¶r hittades inte',0),(47832,1329,'it','Fornitore di errore non trovato',0),(47833,1329,'tl','',0),(47834,1329,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3652;&#3617;&#3656;&#3614;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(47835,1329,'hi','à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(47836,1329,'ms','Ralat Penjual tidak dijumpai',0),(47837,1329,'ar','Ø®Ø·Ø£ - Ø§Ù„ÙˆØ±Ù‘Ø¯ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(47838,1329,'fr','Fournisseur dâ€™erreur introuvable',0),(47839,1329,'jp','ã‚¨ãƒ©ãƒ¼/æ¥­è€…ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(47840,1329,'pt','Fornecedor de erro nÃ£o encontrado',0),(47841,1329,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(47842,1329,'es','Error Proveedor no se encontrÃ³',0),(47843,1329,'de','Fehler-Anbieter nicht gefunden',0),(47844,1329,'en','Error Vendor not found',0),(47845,1330,'is','',0),(47846,1330,'dr','Ø®Ø·Ø§ â€“ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ÙŠØ§ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª ',0),(47847,1330,'pr','Ø®Ø·Ø§ â€“ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ÙŠØ§ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª ',0),(47848,1330,'tr','Hata satÄ±cÄ± bulunamadÄ± veya satÄ±cÄ± aÃ§Ä±sÄ±ndan ayarlanmamÄ±ÅŸ',0),(47849,1330,'pl','BÅ‚Ä…d dostawcy nie znaleziono lub nie zestaw warunkÃ³w dostawcy',0),(47850,1330,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½ Ð¸Ð»Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð½Ðµ ÑÐ° Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¸',0),(47851,1330,'ur','Ù†Ù‚Øµ ÙˆÛŒÙ†ÚˆØ± Ù†ÛÛŒÚº Ù…Ù„ÛŒ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û Ø´Ø±Ø§Ø¦Ø· Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(47852,1330,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½ Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ð¼Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(47853,1330,'vi','KhÃ´ng tháº¥y ngÆ°á»i bÃ¡n hay Ä‘iá»u kiá»‡n ngÆ°á»i bÃ¡n chÆ°a Ä‘áº·t',0),(47854,1330,'af','Fout verkoper nie gevind of handelaar bepalings stel nie',0),(47855,1330,'ro','Furnizor de eroare nu a fost gÄƒsit sau furnizor termeni nu Set',0),(47856,1330,'et','Ei leitud viga hankija vÃµi hankija tingimusi seadmata',0),(47857,1330,'si','Napaka prodajalca ni mogoÄe najti ali dobavitelja izrazov ne doloÄijo',0),(47858,1330,'ba','Tidak ditemukan kesalahan Vendor atau Vendor persyaratan tidak diatur',0),(47859,1330,'nl','Fout leverancier niet gevonden of leverancier voorwaarden niet is ingesteld',0),(47860,1330,'fi','Virhe toimittaja ei lÃ¶ydy tai toimittajan aseteta',0),(47861,1330,'no','Feil leverandÃ¸r funnet ikke eller leverandÃ¸r vilkÃ¥r angitt ikke',0),(47862,1330,'da','Fejl kreditor blev ikke fundet eller kreditor vilkÃ¥r er ikke angivet',0),(47863,1330,'ko','ì˜¤ë¥˜ ê³µê¸‰ ì—…ì²´ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ë˜ëŠ” ê³µê¸‰ ì—…ì²´ ì¡°ê±´ ì„¤ì • í•˜ì§€',0),(47864,1330,'he','×©×’×™××” ×”×¡×¤×§ ×œ× × ×ž×¦× ××• ×ª× ××™ ×”×¡×¤×§ ××™× ×• ×ž×•×’×“×¨',0),(47865,1330,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏŒÏÎ¿Ï…Ï‚ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(47866,1330,'zh','é”™è¯¯ï¼šæ²¡æœ‰å‘çŽ°å–æ–¹æˆ–ä¾›åº”å•†æ¡æ¬¾ä¸èƒ½è®¾ç½®\r\n',0),(47867,1330,'sv','Fel leverantÃ¶r hittas inte eller leverantÃ¶r villkoren inte',0),(47868,1330,'it','Fornitore di errore non trovato o termini di fornitore non impostato',0),(47869,1330,'tl','',0),(47870,1330,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3652;&#3617;&#3656;&#3614;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3627;&#3619;&#3639;&#3629;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3605;&#3633;&#3',0),(47871,1330,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤•à¥‹ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(47872,1330,'ms','Ralat Penjual tidak dijumpai atau syarat-syarat Penjual tidak disetkan',0),(47873,1330,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ù…ÙˆØ±Ø¯ Ø®Ø·Ø£ Ø£Ùˆ Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† \"Ø§Ù„Ù…ÙˆØ±Ø¯ Ù…ØµØ·Ù„Ø­Ø§Øª\"',0),(47874,1330,'fr','Fournisseur dâ€™erreur introuvable ou conditions du vendeur pas dÃ©finie',0),(47875,1330,'jp','ã‚¨ãƒ©ãƒ¼/æ¥­è€…ã?Œè¦‹ã?¤ã?‹ã‚‰ã?ªã?„ã?‹æ¥­è€…æ?¡ä»¶ã?Œè¨­å®šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(47876,1330,'pt','Fornecedor de erro nÃ£o encontrado ou termos de fornecedor nÃ£o definido',0),(47877,1330,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½ Ð¸Ð»Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(47878,1330,'es','Error Proveedor no se encontrÃ³ o TÃ©rminos de Proveedor no Establecidos',0),(47879,1330,'de','Nicht gefunden Fehler Anbieter oder VerkÃ¤ufer nicht festgelegt',0),(47880,1330,'en','Error Vendor not found or Vendor Terms not Set',0),(47881,1331,'is','',0),(47882,1331,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† Ú†Ùƒ ',0),(47883,1331,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† Ú†Ùƒ ',0),(47884,1331,'tr','Onay geÃ§ersiz bir hata oluÅŸtu.',0),(47885,1331,'pl','BÅ‚Ä…d Anulowanie czeku.',0),(47886,1331,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‡ÐµÐº.',0),(47887,1331,'ur','Ù†Ù‚Øµ Ù¾Ú‘ØªØ§Ù„ ÙˆÙˆØ§Ø¯Ø§Ù†Ú¯ Û”',0),(47888,1331,'sr','Ð“Ñ€ÐµÑˆÐºÐ° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ Ñ‡ÐµÐºÐ°.',0),(47889,1331,'vi','XÃ³a SÃ©c bá»‹ lá»—i',0),(47890,1331,'af','Fout voiding kontroleer.',0),(47891,1331,'ro','Eroare la anularea verifica.',0),(47892,1331,'et','TÃµrge voiding sisse.',0),(47893,1331,'si','Napaka razveljavili Äek.',0),(47894,1331,'ba','Kesalahan membatalkan check.',0),(47895,1331,'nl','Fout bij het selectievakje ongeldig te verklaren.',0),(47896,1331,'fi','Virhe mitÃ¤tÃ¶ity sekki.',0),(47897,1331,'no','Feil kansellerer sjekk.',0),(47898,1331,'da','Fejl under annullering af check.',0),(47899,1331,'ko','í‘œë¥¼ ë¬´íš¨í™” í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(47900,1331,'he','×©×’×™××” ×”×¨×§×” ×”×¡×™×ž×•×Ÿ.',0),(47901,1331,'el','Î£Ï†Î¬Î»Î¼Î± Î¬ÎºÏ…ÏÎ· ÎµÏ€Î¹Ï„Î±Î³Î®.',0),(47902,1331,'zh','é”™è¯¯ï¼šæ— æ•ˆæ”¯ç¥¨ã€‚\r\n',0),(47903,1331,'sv','Fel makulera check.',0),(47904,1331,'it','Errore minzionale check.',0),(47905,1331,'tl','',0),(47906,1331,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3648;&#3594;&#3655;&#3588;&#3651;&#3594;&#3657;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;',0),(47907,1331,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¤¾à¤à¤š voiding.',0),(47908,1331,'ms','Ralat yang mengganggu semak.',0),(47909,1331,'ar','Ø®Ø·Ø£ ÙŠÙØ±Øº Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±.',0),(47910,1331,'fr','Erreur lors de l\'invalidation de cocher.',0),(47911,1331,'jp','ã‚¨ãƒ©ãƒ¼/å°?åˆ‡æ‰‹ã‚’ç ´æ£„ã?§ã??ã?¾ã?›ã‚“',0),(47912,1331,'pt','Erro de verificaÃ§Ã£o da micÃ§Ã£o.',0),(47913,1331,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐžÑ‚Ð¼ÐµÐ½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸.',0),(47914,1331,'es','Error anulando cheque',0),(47915,1331,'de','Fehler beim Storno Check.',0),(47916,1331,'en','Error voiding check.',0),(47917,1332,'is','',0),(47918,1332,'dr',':Ù†Ù…Ø¨Ø± Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯ ',0),(47919,1332,'pr','Ø®Ø·Ø§  :Ø´Ù†Ø§Ø³Ù‡ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯ ',0),(47920,1332,'tr','Hata: geÃ§ti fiÅŸ numarasÄ±',0),(47921,1332,'pl','BÅ‚Ä…d: Identyfikator Voucher nie przeszedÅ‚',0),(47922,1332,'bg','Ð“Ñ€ÐµÑˆÐºÐ°: Ð’Ð°ÑƒÑ‡ÑŠÑ€ ID Ð½Ðµ Ðµ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ»',0),(47923,1332,'ur','Ù†Ù‚Øµ: ÙˆØ§Ø¤Ú†Ø± Ø´Ù†Ø§Ø®Øª Ù†ÛÛŒÚº Ú¯Ø²Ø±Ø§',0),(47924,1332,'sr','Ð“Ñ€ÐµÑˆÐºÐ° : Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð˜Ð” Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾ÑˆÐ°Ð¾',0),(47925,1332,'vi','Lá»—i: ID phiáº¿u chÆ°a qua',0),(47926,1332,'af','Fout: Bewys ID nie geslaag',0),(47927,1332,'ro','Eroare: Voucher ID nu a trecut',0),(47928,1332,'et','Viga: Kande ID-d ei kanta',0),(47929,1332,'si','Napaka: Kupon ID ne prenesejo',0),(47930,1332,'ba','Kesalahan: Voucher ID tidak lulus',0),(47931,1332,'nl','Fout: Voucher ID niet doorgegeven',0),(47932,1332,'fi','Virhe: Tositetunnus siirretÃ¤',0),(47933,1332,'no','Feil: Bilags-IDen ikke bestÃ¥tt',0),(47934,1332,'da','Fejl: Voucher-ID ikke bestÃ¥et',0),(47935,1332,'ko','ì˜¤ë¥˜: ë°”ìš°ì²˜ ID ì „ë‹¬ ë˜ì§€',0),(47936,1332,'he','×©×’×™××”: ×©×•×‘×¨ ×ž×–×”×” ×œ× ×—×œ×¤×•',0),(47937,1332,'el','Î£Ï†Î¬Î»Î¼Î±: ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ ID Î´ÎµÎ½ Ï€Î­ÏÎ±ÏƒÎµ',0),(47938,1332,'zh','é”™è¯¯ï¼šä»˜æ¬¾å‡­è¯ç¼–å·æœªèƒ½é€šè¿‡\r\n',0),(47939,1332,'sv','Fel: Voucher ID inte klarat',0),(47940,1332,'it','Errore: Voucher ID non superato',0),(47941,1332,'tl','',0),(47942,1332,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;:&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;',0),(47943,1332,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿: à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤°à¤¿à¤¤ à¤µà¤¾à¤‰à¤šà¤° ID',0),(47944,1332,'ms','Ralat: ID baucer yang tidak diluluskan',0),(47945,1332,'ar','Ø®Ø·Ø£: Ù…Ø¹Ø±Ù Ø§Ù„Ø¥ÙŠØµØ§Ù„ Ù„Ù… ÙŠØ¬ØªØ²',0),(47946,1332,'fr','Erreur : Bon ID ne pas passÃ©',0),(47947,1332,'jp','ã‚¨ãƒ©ãƒ¼/ä¼?ç¥¨IDã?Œé€šé?Žã?—ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(47948,1332,'pt','Erro: ID Voucher nÃ£o passada',0),(47949,1332,'ru','ÐžÑˆÐ¸Ð±ÐºÐ°: Ð’Ð°ÑƒÑ‡ÐµÑ€ ID Ð½Ðµ Ð¿Ñ€Ð¾ÑˆÐ»Ð¾',0),(47950,1332,'es','Error: Voucher ID no pasÃ³',0),(47951,1332,'de','Fehler: Gutschein-ID nicht Ã¼bergeben',0),(47952,1332,'en','Error: Voucher ID not passed',0),(47953,1333,'is','',0),(47954,1333,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙƒÙ¾ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ ',0),(47955,1333,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙƒÙ¾ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ ',0),(47956,1333,'tr','KarÅŸÄ±ya yÃ¼klenen dosyayÄ± kopyalarken hata',0),(47957,1333,'pl','BÅ‚Ä…d podczas kopiowania pliku',0),(47958,1333,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‡ÐµÐ½Ð¸Ñ Ñ„Ð°Ð¹Ð»',0),(47959,1333,'ur','Ø¬Ø¨ Ø§Ù¾ Ù„ÙˆÚˆ Ù…Ø³Ù„ Ù†Ù‚Ù„ Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(47960,1333,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÐºÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐ° Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(47961,1333,'vi','Lá»—i khi sao chÃ©p há»“ sÆ¡ táº£i lÃªn',0),(47962,1333,'af','Fout wanneer opgelaai lÃªer te kopieer',0),(47963,1333,'ro','Eroare la copierea Ã®ncÄƒrcat dosar',0),(47964,1333,'et','TÃµrge Ã¼leslaaditud faili kopeerimisel',0),(47965,1333,'si','Napaka pri kopiranju uploaded pila',0),(47966,1333,'ba','Kesalahan saat menyalin file upload',0),(47967,1333,'nl','Fout bij het kopiÃ«ren van bestand geÃ¼pload',0),(47968,1333,'fi','Virhe kopioitaessa uploaded arkistoida',0),(47969,1333,'no','Feil ved kopiering opplastede filen',0),(47970,1333,'da','Fejl ved kopiering af uploadet fil',0),(47971,1333,'ko','ì—…ë¡œë“œ ëœ íŒŒì¼ì„ ë³µì‚¬í•  ë•Œ ì˜¤ë¥˜',0),(47972,1333,'he','×©×’×™××” ×‘×”×¢×ª×§×ª ×”×§×•×‘×¥ ×©×”×•×¢×œ×”',0),(47973,1333,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Ï„Î¹Î³ÏÎ±Ï†Î® Ï†Î¿ÏÏ„ÏŽÎ½Ï‰ Î±ÏÏ‡ÎµÎ¯Î¿',0),(47974,1333,'zh','ä¸Šä¼ çš„æ–‡ä»¶å¤åˆ¶æ—¶å‡ºé”™\r\n',0),(47975,1333,'sv','Fel vid kopiering uppladdad fil',0),(47976,1333,'it','Errore durante la copia file caricato',0),(47977,1333,'tl','',0),(47978,1333,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3586;&#3603;&#3632;&#3585;&#3635;&#3621;&#3633;&#3591;&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3585;&#3634;&#3619;&#3629;&#3633;&#3614;&#3650;&#3627;&#3621;&#3604;&#3652;&#3615;&#3621;&#3660;',0),(47979,1333,'hi','à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¥€ à¤—à¤ˆ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤¤à¥‡ à¤¸à¤®à¤¯ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(47980,1333,'ms','Ralat semasa menyalin fail yang dimuat naik',0),(47981,1333,'ar','Ø®Ø·Ø£ Ø¹Ù†Ø¯ Ù†Ø³Ø® Ø§Ù„Ù…Ù„ÙÙ‘ Ø§Ù„Ù…Ø­Ù…Ù‘Ù„',0),(47982,1333,'fr','Erreur lors de la copie de fichier uploadÃ©',0),(47983,1333,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ã?•ã‚Œã?Ÿãƒ•ã‚¡ã‚¤ãƒ«ã?®ã‚³ãƒ”ãƒ¼ä¸­ã?®ã‚¨ãƒ©ãƒ¼',0),(47984,1333,'pt','Erro ao copiar arquivo carregado',0),(47985,1333,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ð·Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ð¾Ð³Ð¾ Ñ„Ð°Ð¹Ð»Ð°',0),(47986,1333,'es','Error cuando copiar file subido',0),(47987,1333,'de','Fehler beim Kopieren von hochgeladenen Dateien',0),(47988,1333,'en','Error when copying uploaded file',0),(47989,1334,'is','',0),(47990,1334,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙƒÙ¾ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ ',0),(47991,1334,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙƒÙ¾ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ ',0),(47992,1334,'tr','KarÅŸÄ±ya yÃ¼klenen dosyayÄ± kopyalarken hata',0),(47993,1334,'pl','BÅ‚Ä…d podczas kopiowania pliku',0),(47994,1334,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‡ÐµÐ½Ð¸Ñ Ñ„Ð°Ð¹Ð»',0),(47995,1334,'ur','Ø¬Ø¨ Ø§Ù¾ Ù„ÙˆÚˆ Ù…Ø³Ù„ Ù†Ù‚Ù„ Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(47996,1334,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÐºÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐ° Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(47997,1334,'vi','Lá»—i khi sao chÃ©p há»“ sÆ¡ táº£i lÃªn',0),(47998,1334,'af','Fout wanneer opgelaai lÃªer te kopieer',0),(47999,1334,'ro','Eroare la copierea Ã®ncÄƒrcat dosar',0),(48000,1334,'et','TÃµrge Ã¼leslaaditud faili kopeerimisel',0),(48001,1334,'si','Napaka pri kopiranju uploaded pila',0),(48002,1334,'ba','Kesalahan saat menyalin file upload',0),(48003,1334,'nl','Fout bij het kopiÃ«ren van bestand geÃ¼pload',0),(48004,1334,'fi','Virhe kopioitaessa uploaded arkistoida',0),(48005,1334,'no','Feil ved kopiering opplastede filen',0),(48006,1334,'da','Fejl ved kopiering af uploadet fil',0),(48007,1334,'ko','ì—…ë¡œë“œ ëœ íŒŒì¼ì„ ë³µì‚¬í•  ë•Œ ì˜¤ë¥˜',0),(48008,1334,'he','×©×’×™××” ×‘×¢×ª ×”×¢×ª×§×ª ×”×§×•×‘×¥ ×©×”×•×¢×œ×”',0),(48009,1334,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Ï„Î¹Î³ÏÎ±Ï†Î® Ï†Î¿ÏÏ„ÏŽÎ½Ï‰ Î±ÏÏ‡ÎµÎ¯Î¿',0),(48010,1334,'zh','ä¸Šä¼ çš„æ–‡ä»¶å¤åˆ¶æ—¶å‡ºé”™\r\n',0),(48011,1334,'sv','Fel vid kopiering uppladdad fil',0),(48012,1334,'it','Errore durante la copia file caricato',0),(48013,1334,'tl','',0),(48014,1334,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3586;&#3603;&#3632;&#3607;&#3637;&#3656;&#3585;&#3635;&#3621;&#3633;&#3591;&#3629;&#3633;&#3614;&#3650;&#3627;&#3621;&#3604;&#3652;&#3615;&#3621;&#3660;',0),(48015,1334,'hi','à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¥€ à¤—à¤ˆ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤¤à¥‡ à¤¸à¤®à¤¯ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(48016,1334,'ms','Ralat semasa menyalin fail yang dimuat naik',0),(48017,1334,'ar','Ø®Ø·Ø£ Ø¹Ù†Ø¯ Ù†Ø³Ø® Ø§Ù„Ù…Ù„Ù Ø§Ù„Ø°ÙŠ ØªÙ… ØªØ­Ù…ÙŠÙ„Ù‡',0),(48018,1334,'fr','Erreur lors de la copie de fichier uploadÃ©',0),(48019,1334,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ãƒ•ã‚¡ã‚¤ãƒ«ã‚³ãƒ”ãƒ¼ä¸­ã?®ã‚¨ãƒ©ãƒ¼',0),(48020,1334,'pt','Erro ao copiar arquivo carregado',0),(48021,1334,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ð·Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ð¾Ð³Ð¾ Ñ„Ð°Ð¹Ð»Ð°',0),(48022,1334,'es','Error cuando copiar archivo subido',0),(48023,1334,'de','Fehler beim Kopieren von hochgeladenen Dateien',0),(48024,1334,'en','Error when copying uploaded file',0),(48025,1335,'is','',0),(48026,1335,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(48027,1335,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(48028,1335,'tr','EST.<br>SatÄ±lÄ±k Amt',0),(48029,1335,'pl','Est.<br>Amt sprzedaÅ¼',0),(48030,1335,'bg','EST.<br>ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð° Amt',0),(48031,1335,'ur','Est.<br>ÙØ±ÙˆØ®Øª Ø§Ù…Ù¹',0),(48032,1335,'sr','ÐŸÑ€Ð¾Ñ†.<br>ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° Ð Ð•Ð¤. Ð’Ð°Ð».',0),(48033,1335,'vi','Dá»± trÃ¹sá»‘ tiá»n bÃ¡n',0),(48034,1335,'af','Est<br>Verkoop Amt',0),(48035,1335,'ro','Est.<br>VÃ¢nzare Amt',0),(48036,1335,'et','EST.<br>MÃ¼Ã¼k Amt',0),(48037,1335,'si','EST.<br>Prodajo Amt',0),(48038,1335,'ba','Est.<br>Dijual Amt',0),(48039,1335,'nl','EST.<br>Verkoop Amt',0),(48040,1335,'fi','Est.<br>MyytÃ¤vÃ¤nÃ¤ Amt',0),(48041,1335,'no','EST.<br>Salg Amt',0),(48042,1335,'da','EST.<br>Salg Amt',0),(48043,1335,'ko','ë™ë¶€ í‘œì¤€ì‹œ.<br>íŒë§¤ Amt',0),(48044,1335,'he','Est.<br>×œ×ž×›×™×¨×” Amt',0),(48045,1335,'el','EST.<br>Î ÏŽÎ»Î·ÏƒÎ· Amt',0),(48046,1335,'zh','ä¼°è®¡é‡‘é¢\r\n',0),(48047,1335,'sv','Est.<br>FÃ¶rsÃ¤ljning Amt',0),(48048,1335,'it','Est.<br>Vendita Amt',0),(48049,1335,'tl','',0),(48050,1335,'th','&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;<br>&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(48051,1335,'hi','Est.<br>à¤¬à¤¿à¤•à¥à¤°à¥€ Amt',0),(48052,1335,'ms','Est.<br>Amt jualan',0),(48053,1335,'ar','Ù…Ø¤Ø³Ø³Ø©<br>Ø¨ÙŠØ¹ Ø§Ù„ØªÙˆÙ†Ø³ÙŠÙŠÙ†',0),(48054,1335,'fr','(HE).<br>Vente Amt',0),(48055,1335,'jp','è¦‹ç©?ã‚Š<br>è²©å£²é¡?',0),(48056,1335,'pt','Est.<br>Venda Amt',0),(48057,1335,'ru','EST.<br>ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° Amt',0),(48058,1335,'es','Estimado<br>monto de Venta',0),(48059,1335,'de','EST.<br>Verkauf-Amt',0),(48060,1335,'en','Est.<br>Sale Amt',0),(48061,1336,'is','',0),(48062,1336,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(48063,1336,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(48064,1336,'tr','Tahmini satÄ±ÅŸ Amt',0),(48065,1336,'pl','Amt sprzedaÅ¼ Est.',0),(48066,1336,'bg','EST. Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Amt',0),(48067,1336,'ur','Est. ÙØ±ÙˆØ®Øª Ø§Ù…Ù¹',0),(48068,1336,'sr','ÐŸÑ€Ð¾Ñ† . Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð Ð•Ð¤. Ð’Ð°Ð».',0),(48069,1336,'vi','Dá»± trÃ¹ sá»‘ tiá»n bÃ¡n',0),(48070,1336,'af','Est verkoop Amt',0),(48071,1336,'ro','VÃ¢nzare de Est. Amt',0),(48072,1336,'et','EST. mÃ¼Ã¼k Amt',0),(48073,1336,'si','EST. prodajo Amt',0),(48074,1336,'ba','Dijual Est. Amt',0),(48075,1336,'nl','EST. verkoop Amt',0),(48076,1336,'fi','Est. myytÃ¤vÃ¤nÃ¤ Amt',0),(48077,1336,'no','EST. salg Amt',0),(48078,1336,'da','EST. salg Amt',0),(48079,1336,'ko','í‘œì¤€ì‹œ íŒë§¤ Amt',0),(48080,1336,'he','×œ×ž×›×™×¨×” ×ž×©×•×¢×¨×ª Amt',0),(48081,1336,'el','Amt Ï€ÏŽÎ»Î·ÏƒÎ· EST.',0),(48082,1336,'zh','ä¼°è®¡é‡‘é¢2\r\n',0),(48083,1336,'sv','Est. fÃ¶rsÃ¤ljning Amt',0),(48084,1336,'it','Amt vendita est.',0),(48085,1336,'tl','',0),(48086,1336,'th','&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(48087,1336,'hi','Est. à¤¬à¤¿à¤•à¥à¤°à¥€ Amt',0),(48088,1336,'ms','Amt jualan Est.',0),(48089,1336,'ar','Ø¨ÙŠØ¹ Ù…Ø¤Ø³Ø³Ø© Ø§Ù„Ù‚Ø¶Ø§Ø© Ø§Ù„ØªÙˆÙ†Ø³ÙŠÙŠÙ†',0),(48090,1336,'fr','Amt vente est.',0),(48091,1336,'jp','è²©å£²é¡?ã?®è¦‹ç©?ã‚Š',0),(48092,1336,'pt','Est. venda Amt',0),(48093,1336,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° EST. Amt',0),(48094,1336,'es','Est Monto de Venta',0),(48095,1336,'de','EST.-Verkauf-Amt',0),(48096,1336,'en','Est. Sale Amt',0),(48097,1337,'is','',0),(48098,1337,'dr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ ',0),(48099,1337,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ ',0),(48100,1337,'tr','Tahmini',0),(48101,1337,'pl','Szacowany',0),(48102,1337,'bg','ÐžÑ†ÐµÐ½ÑÐ²Ð°',0),(48103,1337,'ur','Ø§Ù†Ø¯Ø§Ø²Û Ù„Ú¯Ø§ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(48104,1337,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸',0),(48105,1337,'vi','Dá»± trÃ¹',0),(48106,1337,'af','Geskatte',0),(48107,1337,'ro','Estimat',0),(48108,1337,'et','Hinnanguliselt',0),(48109,1337,'si','Ocenjena',0),(48110,1337,'ba','Diperkirakan',0),(48111,1337,'nl','Naar schatting',0),(48112,1337,'fi','Arvioitu',0),(48113,1337,'no','AnslÃ¥tt',0),(48114,1337,'da','AnslÃ¥et',0),(48115,1337,'ko','ì¶”ì •',0),(48116,1337,'he','×”×”×¢×¨×›×”',0),(48117,1337,'el','Î•ÎºÏ„Î¹Î¼Î¬Ï„Î±Î¹ ÏŒÏ„Î¹',0),(48118,1337,'zh','ä¼°è®¡\r\n',0),(48119,1337,'sv','BerÃ¤knad',0),(48120,1337,'it','Stimato',0),(48121,1337,'tl','',0),(48122,1337,'th','&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(48123,1337,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤',0),(48124,1337,'ms','Dianggarkan',0),(48125,1337,'ar','ÙˆÙ‚Ø¯Ø±',0),(48126,1337,'fr','EstimÃ©',0),(48127,1337,'jp','è¦‹ç©?ã‚‚ã‚Š',0),(48128,1337,'pt','Estima-se',0),(48129,1337,'ru','ÐŸÐ¾ Ð¾Ñ†ÐµÐ½ÐºÐ°Ð¼',0),(48130,1337,'es','Estimado',0),(48131,1337,'de','GeschÃ¤tzt',0),(48132,1337,'en','Estimated',0),(48133,1338,'is','',0),(48134,1338,'dr','Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ÙŠ ØªØ®Ù…ÙŠÙ†ÙŠ Ø¨Ù‡ ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(48135,1338,'pr','Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ÙŠ ØªØ®Ù…ÙŠÙ†ÙŠ Ø¨Ù‡ ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(48136,1338,'tr','Sevkiyat kodu zip iÃ§in tahmini',0),(48137,1338,'pl','Szacuje, wysyÅ‚ka do kod pocztowy',0),(48138,1338,'bg','ÐžÑ†ÐµÐ½ÑÐ²Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð¾ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(48139,1338,'ur','Ø²Ù¾ Ú©ÙˆÚˆ Ú©Û’ Ø´Ù¾Ù†Ú¯ Ú©Ø§ ØªØ®Ù…ÛŒÙ†Û',0),(48140,1338,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÑƒÑ˜Ðµ ÑÐµ Ð´Ð° Ð·Ð¸Ð¿ ÐºÐ¾Ð´Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(48141,1338,'vi','Dá»± trÃ¹ váº­n chuyá»ƒn Ä‘áº¿n mÃ£ Zip',0),(48142,1338,'af','Geskatte versending na zip kode',0),(48143,1338,'ro','Estimat de transport maritim pentru a zip code',0),(48144,1338,'et','Hinnanguliselt komplekteerimisel zip code',0),(48145,1338,'si','Ocenjena dostava ZIP kodo',0),(48146,1338,'ba','Diperkirakan pengiriman ke kode pos',0),(48147,1338,'nl','Geschatte verzending om zip code',0),(48148,1338,'fi','Arvioitu toimitus postinumero',0),(48149,1338,'no','AnslÃ¥tt frakt til zip kode',0),(48150,1338,'da','AnslÃ¥et shipping til zip-kode',0),(48151,1338,'ko','Zip ì½”ë“œ ë°°ì†¡ ì˜ˆìƒ',0),(48152,1338,'he','××•×ž×“×Ÿ ×ž×©×œ×•×— ×ž×™×§×•×“',0),(48153,1338,'el','Î•ÎºÏ„Î¹Î¼Î¬Ï„Î±Î¹ ÏŒÏ„Î¹ Î· Î½Î±Ï…Ï„Î¹Î»Î¯Î± Î½Î± Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(48154,1338,'zh','ä¼°è®¡èˆªè¿é‚®æ”¿ç¼–ç \r\n',0),(48155,1338,'sv','BerÃ¤knad frakt om du vill postnummer',0),(48156,1338,'it','Stima spedizione per zip codice',0),(48157,1338,'tl','',0),(48158,1338,'th','&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3605;&#3634;&#3617;&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3',0),(48159,1338,'hi','à¤œà¤¼à¤¿à¤ª à¤•à¥‹à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¤¾ à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(48160,1338,'ms','Dianggarkan penghantaran untuk zip kod',0),(48161,1338,'ar','ØªÙ‚Ø¯ÙŠØ± Ø§Ù„Ø´Ø­Ù† Ø¥Ù„Ù‰ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(48162,1338,'fr','EstimÃ© d\'expÃ©dition pour code postal',0),(48163,1338,'jp','ã??ã?®éƒµä¾¿ç•ªå?·ã?¾ã?§ã?®ç™ºé€?è¦‹ç©?ã‚‚ã‚Š',0),(48164,1338,'pt','Estimado de envio para CEP',0),(48165,1338,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ð°Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð² zip ÐºÐ¾Ð´',0),(48166,1338,'es','Estimado enviar a cÃ³digo postal',0),(48167,1338,'de','GeschÃ¤tzt, um zip-Code Versand',0),(48168,1338,'en','Estimated shipping to zip code',0),(48169,1339,'is','',0),(48170,1339,'dr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ÙŠ ',0),(48171,1339,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ÙŠ ',0),(48172,1339,'tr','Tahmin etme',0),(48173,1339,'pl','Szacowanie',0),(48174,1339,'bg','ÐžÑ†ÐµÐ½ÑÐ²Ð°Ð½Ðµ',0),(48175,1339,'ur','ØªØ®Ù…ÛŒÙ†Û',0),(48176,1339,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°',0),(48177,1339,'vi','Dá»± trÃ¹',0),(48178,1339,'af','Geraamde',0),(48179,1339,'ro','Estimarea',0),(48180,1339,'et','Hindamine',0),(48181,1339,'si','Ocenjevanje',0),(48182,1339,'ba','Memperkirakan',0),(48183,1339,'nl','Schatten',0),(48184,1339,'fi','Arvioidaan',0),(48185,1339,'no','Estimering',0),(48186,1339,'da','Estimering',0),(48187,1339,'ko','ì¶”ì •',0),(48188,1339,'he','×”×¢×¨×›×ª',0),(48189,1339,'el','Î•ÎºÏ„Î¯Î¼Î·ÏƒÎ·',0),(48190,1339,'zh','ä¼°è®¡\r\n',0),(48191,1339,'sv','Uppskatta',0),(48192,1339,'it','Stimando',0),(48193,1339,'tl','',0),(48194,1339,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;',0),(48195,1339,'hi','à¤•à¤¾ à¤†à¤•à¤²à¤¨',0),(48196,1339,'ms','Menganggarkan',0),(48197,1339,'ar','ØªÙ‚Ø¯ÙŠØ±',0),(48198,1339,'fr','Estimation',0),(48199,1339,'jp','è¦‹ç©?ã‚‚ã‚Š',0),(48200,1339,'pt','Estimando',0),(48201,1339,'ru','ÐžÑ†ÐµÐ½ÐºÐ¸',0),(48202,1339,'es','Estimando',0),(48203,1339,'de','SchÃ¤tzung',0),(48204,1339,'en','Estimating',0),(48205,1340,'is','',0),(48206,1340,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(48207,1340,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(48208,1340,'tr','AlÄ±ntÄ± tahmini ekleme',0),(48209,1340,'pl','Szacowanie cytat dodaÄ‡',0),(48210,1340,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¾Ñ†ÐµÐ½ÐºÐ° Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð°',0),(48211,1340,'ur','ØªØ®Ù…ÛŒÙ†Û Ø§Ù‚ØªØ¨Ø§Ø³ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(48212,1340,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð° Ð¿Ð¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐµ',0),(48213,1340,'vi','ThÃªm bÃ¡o giÃ¡ Dá»± trÃ¹',0),(48214,1340,'af','Voeg Geraamde aanhaling',0),(48215,1340,'ro','Estimarea citat Adauga',0),(48216,1340,'et','Prognoosimisel Quote lisada',0),(48217,1340,'si','Ocenjevanje ponudbo dodali',0),(48218,1340,'ba','Memperkirakan kutipan menambahkan',0),(48219,1340,'nl','Schatten offerte toevoegen',0),(48220,1340,'fi','Arvioitaessa tarjouksen lisÃ¤Ã¤',0),(48221,1340,'no','Estimere tilbud legge',0),(48222,1340,'da','Estimering citat tilfÃ¸je',0),(48223,1340,'ko','ì¶”ê°€ ê²¬ì  ê²¬ì ',0),(48224,1340,'he','×”×¢×¨×›×ª ×”×¦×¢×ª ×ž×—×™×¨ ×œ×”×•×¡×™×£',0),(48225,1340,'el','Î•ÎºÏ„Î¯Î¼Î·ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(48226,1340,'zh','æ–°å¢žä¼°ç®—æŠ¥ä»·\r\n',0),(48227,1340,'sv','Uppskatta citat lÃ¤gga',0),(48228,1340,'it','Aggiungi stimando la citazione',0),(48229,1340,'tl','',0),(48230,1340,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(48231,1340,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¤¾ à¤†à¤•à¤²à¤¨ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(48232,1340,'ms','Menganggarkan Quote Tambah',0),(48233,1340,'ar','ØªÙ‚Ø¯ÙŠØ± Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¥Ø¶Ø§ÙØ©',0),(48234,1340,'fr','Estimation devis ajouter',0),(48235,1340,'jp','è¦‹ç©?ã‚Šé¡?ã?®è¿½åŠ ',0),(48236,1340,'pt','Estimando a citaÃ§Ã£o adicionar',0),(48237,1340,'ru','ÐžÑ†ÐµÐ½Ð¸Ð²Ð°Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(48238,1340,'es','Estimando Agregar CotizaciÃ³n',0),(48239,1340,'de','SchÃ¤tzung Zitat hinzufÃ¼gen',0),(48240,1340,'en','Estimating Quote Add',0),(48241,1341,'is','',0),(48242,1341,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(48243,1341,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(48244,1341,'tr','Teklifi gÃ¼ncelleÅŸtirme tahmin etme',0),(48245,1341,'pl','Szacowanie cytat aktualizacja',0),(48246,1341,'bg','ÐžÑ†ÐµÐ½ÐºÐ° Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð° Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(48247,1341,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø§ ØªØ®Ù…ÛŒÙ†Û Ù„Ú¯Ø§ Ø±ÛØ§',0),(48248,1341,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð° Ð¿Ð¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(48249,1341,'vi','Cáº­p nháº­t dá»± toÃ¡n bÃ¡o giÃ¡',0),(48250,1341,'af','Geraamde aanhaling bywerking',0),(48251,1341,'ro','Estimarea citat Update',0),(48252,1341,'et','Sobiv tsiteerida Update',0),(48253,1341,'si','Ocenjevanje ponudbe posodobitev',0),(48254,1341,'ba','Memperkirakan kutipan Update',0),(48255,1341,'nl','Schatten citaat Update',0),(48256,1341,'fi','Arvioitaessa tarjouksen pÃ¤ivitys',0),(48257,1341,'no','Estimering tilbud oppdatering',0),(48258,1341,'da','Estimering citat opdatering',0),(48259,1341,'ko','ê²¬ì  ê²¬ì  ì—…ë°ì´íŠ¸',0),(48260,1341,'he','×”×¢×¨×›×ª ×¢×“×›×•×Ÿ ×”×¦×¢×ª ×ž×—×™×¨',0),(48261,1341,'el','Î•ÎºÏ„Î¯Î¼Î·ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(48262,1341,'zh','ä¼°ç®—æŠ¥ä»·æ›´æ–°\r\n',0),(48263,1341,'sv','Uppskatta citat uppdatering',0),(48264,1341,'it','Stima di preventivo aggiornamento',0),(48265,1341,'tl','',0),(48266,1341,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(48267,1341,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾ à¤†à¤•à¤²à¤¨',0),(48268,1341,'ms','Menganggarkan Quote Kemaskini',0),(48269,1341,'ar','ØªÙ‚Ø¯ÙŠØ± ØªØ­Ø¯ÙŠØ« Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(48270,1341,'fr','Estimation devis mise Ã  jour',0),(48271,1341,'jp','è¦‹ç©?ã‚Šé¡?ã?®æ›´æ–°',0),(48272,1341,'pt','Estimando a citaÃ§Ã£o de atualizaÃ§Ã£o',0),(48273,1341,'ru','ÐžÑ†ÐµÐ½Ð¸Ð²Ð°Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(48274,1341,'es','Estimando Actualizar CotizaciÃ³n',0),(48275,1341,'de','SchÃ¤tzung Zitat Update',0),(48276,1341,'en','Estimating Quote Update',0),(48277,1342,'is','',0),(48278,1342,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ØªØ®Ù…ÙŠÙ†ÙŠ   Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª  Ù‚ÙŠÙ…Øª  Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(48279,1342,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ØªØ®Ù…ÙŠÙ†ÙŠ   Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª  Ù‚ÙŠÙ…Øª  Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(48280,1342,'tr','estquotepricelistprice ekleme baÅŸarÄ±sÄ±z oldu.',0),(48281,1342,'pl','Wstaw estquotepricelistprice nie powiodÅ‚o siÄ™.',0),(48282,1342,'bg','estquotepricelistprice Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð½Ðµ ÑƒÑÐ¿Ñ.',0),(48283,1342,'ur','Ø§Ø³Ù¹Ù‚ÙˆÙˆÙ¹ÛŒÙ¾Ø±Ø§Ú©Ø§Ù„Ø³Ù¹Ù¾Ø±Ø§Ø³ÛŒ Ø¯Ø§Ø®Ù„ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§ Û”',0),(48284,1342,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ ÐµÑÑ‚qÑƒÐ¾Ñ‚ÐµÐ¿Ñ€Ð¸Ñ†ÐµÐ»Ð¸ÑÑ‚Ð¿Ñ€Ð¸Ñ†Ðµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÐ»Ð¾.',0),(48285,1342,'vi','ChÃ¨n bÃ¡o giÃ¡ dá»± trÃ¹ tháº¥t báº¡i',0),(48286,1342,'af','estquotepricelistprice insetsel het misluk.',0),(48287,1342,'ro','estquotepricelistprice Inserare nereuÈ™itÄƒ.',0),(48288,1342,'et','estquotepricelistprice lisamine nurjus.',0),(48289,1342,'si','Vstavljanje estquotepricelistprice ni uspelo.',0),(48290,1342,'ba','estquotepricelistprice Masukkan gagal.',0),(48291,1342,'nl','estquotepricelistprice invoegen mislukt.',0),(48292,1342,'fi','estquotepricelistprice lisÃ¤ys epÃ¤onnistui.',0),(48293,1342,'no','Sett inn estquotepricelistprice mislyktes.',0),(48294,1342,'da','estquotepricelistprice IndsÃ¦t mislykkedes.',0),(48295,1342,'ko','estquotepricelistprice ì‚½ìž… í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(48296,1342,'he','×”×•×¡×¤×” estquotepricelistprice × ×›×©×œ.',0),(48297,1342,'el','estquotepricelistprice ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ.',0),(48298,1342,'zh','é¢„ä¼°æŠ¥ä»·ä»·ç›®è¡¨æ’å…¥å¤±è´¥\r\n',0),(48299,1342,'sv','Det gick inte att infoga estquotepricelistprice.',0),(48300,1342,'it','Inserisci estquotepricelistprice non riuscita.',0),(48301,1342,'tl','',0),(48302,1342,'th','&#3649;&#3607;&#3619;&#3585;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3',0),(48303,1342,'hi','estquotepricelistprice à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾à¥¤',0),(48304,1342,'ms','Masukkan estquotepricelistprice yang gagal.',0),(48305,1342,'ar','ÙØ´Ù„ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ø³ØªÙ‚ÙˆØªÙŠØ¨Ø±ÙŠØ³ÙŠÙ„ÙŠØ³ØªØ¨Ø±ÙŠØ³ÙŠ.',0),(48306,1342,'fr','Ã©chouÃ© de l\'insertion estquotepricelistprice.',0),(48307,1342,'jp','estquotepricelistprice insert failed.',0),(48308,1342,'pt','inserir estquotepricelistprice falhou.',0),(48309,1342,'ru','estquotepricelistprice Ð²ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ðµ ÑƒÐ´Ð°Ð»Ð°ÑÑŒ.',0),(48310,1342,'es','Est precio de cotizaciÃ³n lista de precios inserciÃ³n fallÃ³',0),(48311,1342,'de','Estquotepricelistprice einfÃ¼gen ist fehlgeschlagen.',0),(48312,1342,'en','estquotepricelistprice insert failed.',0),(48313,1343,'is','',0),(48314,1343,'dr','ØªØ§Ø±ÙŠØ® Ø§Ø±Ø²ÙŠØ§Ø¨ÙŠ ',0),(48315,1343,'pr','ØªØ§Ø±ÙŠØ® Ø§Ø±Ø²ÙŠØ§Ø¨ÙŠ ',0),(48316,1343,'tr','DeÄŸerlendirme tarihi',0),(48317,1343,'pl','Data oceny',0),(48318,1343,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(48319,1343,'ur','Ø¬Ø§Ø¦Ø²Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(48320,1343,'sr','Ð•Ð²Ð°Ð»ÑƒÐ°Ñ†Ð¸Ñ˜Ð° Ð´Ð°Ñ‚ÑƒÐ¼',0),(48321,1343,'vi','NgÃ y Ä‘Ã¡nh giÃ¡',0),(48322,1343,'af','Waardasie Datum',0),(48323,1343,'ro','Data de evaluare',0),(48324,1343,'et','Atesteerimise aeg',0),(48325,1343,'si','Ocena datum',0),(48326,1343,'ba','Evaluasi tanggal',0),(48327,1343,'nl','Evaluatie datum',0),(48328,1343,'fi','Arvioinnin pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(48329,1343,'no','Evaluering dato',0),(48330,1343,'da','Evaluering aldersbestemme',0),(48331,1343,'ko','í‰ê°€ ë‚ ì§œ',0),(48332,1343,'he','×ª××¨×™×š ×”×”×¢×¨×›×”',0),(48333,1343,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(48334,1343,'zh','è¯„ä¼°æ—¥æœŸ\r\n',0),(48335,1343,'sv','UtvÃ¤rdering dagen',0),(48336,1343,'it','Data di valutazione',0),(48337,1343,'tl','',0),(48338,1343,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;',0),(48339,1343,'hi','à¤®à¥‚à¤²à¥à¤¯à¤¾à¤‚à¤•à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(48340,1343,'ms','Tarikh penilaian',0),(48341,1343,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙ‚ÙŠÙŠÙ…',0),(48342,1343,'fr','Date de l\'Ã©valuation',0),(48343,1343,'jp','è©•ä¾¡æ—¥',0),(48344,1343,'pt','Data de avaliaÃ§Ã£o',0),(48345,1343,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ñ†ÐµÐ½ÐºÐ¸',0),(48346,1343,'es','Fecha de EvaluaciÃ³n',0),(48347,1343,'de','Bewertung Datum',0),(48348,1343,'en','Evaluation Date',0),(48349,1344,'is','',0),(48350,1344,'dr','Ø§Ø±Ø²ÙŠØ§Ø¨ ',0),(48351,1344,'pr','Ø§Ø±Ø²ÙŠØ§Ø¨ ',0),(48352,1344,'tr','DeÄŸerlendirici',0),(48353,1344,'pl','Tester',0),(48354,1344,'bg','ÐžÑ†ÐµÐ½Ð¸Ñ‚ÐµÐ»',0),(48355,1344,'ur','Ø§ÛŒÙˆØ§Ù„ÙˆÛŒÙ¹Ø±',0),(48356,1344,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ ÑƒÑÑ‚Ð°',0),(48357,1344,'vi','NgÆ°á»i Ä‘Ã¡nh giÃ¡',0),(48358,1344,'af','Waardeerder',0),(48359,1344,'ro','Evaluatorul',0),(48360,1344,'et','Hindaja',0),(48361,1344,'si','Ocenjevalec',0),(48362,1344,'ba','Penilai',0),(48363,1344,'nl','Beoordelaar',0),(48364,1344,'fi','Arvioija',0),(48365,1344,'no','Evaluator',0),(48366,1344,'da','Evaluator',0),(48367,1344,'ko','ê³„ì‚°ê¸°',0),(48368,1344,'he','×”×ž××‘×—×Ÿ',0),(48369,1344,'el','Î‘Î¾Î¹Î¿Î»Î¿Î³Î·Ï„Î®',0),(48370,1344,'zh','è¯„ä¼°è€…\r\n',0),(48371,1344,'sv','UtvÃ¤rderaren',0),(48372,1344,'it','Valutatore',0),(48373,1344,'tl','',0),(48374,1344,'th','&#3612;&#3641;&#3657;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;',0),(48375,1344,'hi','Evaluator',0),(48376,1344,'ms','Penilai',0),(48377,1344,'ar','Ø§Ù„Ù…Ù‚ÙŠÙ‘Ù…',0),(48378,1344,'fr','Ã‰valuateur',0),(48379,1344,'jp','è©•ä¾¡è€…',0),(48380,1344,'pt','Avaliador',0),(48381,1344,'ru','Ð’Ñ‹Ñ‡Ð¸ÑÐ»Ð¸Ñ‚ÐµÐ»ÑŒ',0),(48382,1344,'es','Evaluador',0),(48383,1344,'de','Evaluator',0),(48384,1344,'en','Evaluator',0),(48385,1345,'is','',0),(48386,1345,'dr','Ù†Ø§Ù… Ø§Ø±Ø²ÙŠØ§Ø¨ ',0),(48387,1345,'pr','Ù†Ø§Ù… Ø§Ø±Ø²ÙŠØ§Ø¨ ',0),(48388,1345,'tr','DeÄŸerlendirici adÄ±',0),(48389,1345,'pl','Nazwa Tester',0),(48390,1345,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¾Ñ†ÐµÐ½Ð¸Ñ‚ÐµÐ»Ñ',0),(48391,1345,'ur','Ø§ÛŒÙˆØ§Ù„ÙˆÛŒÙ¹Ø± Ú©Û’ Ù†Ø§Ù…',0),(48392,1345,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ ÑƒÑÑ‚Ð° Ð¸Ð¼Ðµ',0),(48393,1345,'vi','TÃªn NgÆ°á»i Ä‘Ã¡nh giÃ¡',0),(48394,1345,'af','Evalueerder Naam',0),(48395,1345,'ro','Nume evaluator',0),(48396,1345,'et','Hindaja nimi',0),(48397,1345,'si','Ime ocenjevalca',0),(48398,1345,'ba','Nama penilai',0),(48399,1345,'nl','Beoordelaar naam',0),(48400,1345,'fi','Arvioijan nimi',0),(48401,1345,'no','Evaluator navn',0),(48402,1345,'da','Evaluator navn',0),(48403,1345,'ko','í‰ê°€ê¸° ì´ë¦„',0),(48404,1345,'he','×”×ž××‘×—×Ÿ ×©×',0),(48405,1345,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Î±Î¾Î¹Î¿Î»Î¿Î³Î·Ï„Î®',0),(48406,1345,'zh','è¯„ä¼°è€…å§“å\r\n',0),(48407,1345,'sv','UtvÃ¤rderaren namn',0),(48408,1345,'it','Nome del valutatore',0),(48409,1345,'tl','',0),(48410,1345,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;',0),(48411,1345,'hi','Evaluator à¤¨à¤¾à¤®',0),(48412,1345,'ms','Nama penilai',0),(48413,1345,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…Ù‚ÙŠÙ‘Ù…',0),(48414,1345,'fr','Nom de l\'Ã©valuateur',0),(48415,1345,'jp','è©•ä¾¡è€…å??',0),(48416,1345,'pt','Nome do avaliador',0),(48417,1345,'ru','Ð˜Ð¼Ñ Ð¾Ñ†ÐµÐ½Ñ‰Ð¸ÐºÐ°',0),(48418,1345,'es','Nombre de Evaluador',0),(48419,1345,'de','Bewerter Name',0),(48420,1345,'en','Evaluator Name',0),(48421,1346,'is','',0),(48422,1346,'dr','Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ â€“ Ø¯Ù„Ø§ÙŠÙ„ ',0),(48423,1346,'pr','Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ â€“ Ø¯Ù„Ø§ÙŠÙ„ ',0),(48424,1346,'tr','SatÄ±ÅŸ vergisi muafiyeti<br>Nedenleri',0),(48425,1346,'pl','Zwolnienie z podatku od sprzedaÅ¼y<br>PowodÃ³w',0),(48426,1346,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº<br>ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð¸',0),(48427,1346,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡<br>Ø§Ø³Ø¨Ø§Ø¨',0),(48428,1346,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¸Ð·ÑƒÐ·ÐµÑ›Ñƒ<br>Ð Ð°Ð·Ð»Ð¾Ð·Ð¸',0),(48429,1346,'vi','NguyÃªn nhÃ¢n miá»…n thuáº¿ bÃ¡n hÃ ng',0),(48430,1346,'af','Verkope belasting vrystelling<br>Redes',0),(48431,1346,'ro','Scutirea de impozitul pe vÃ¢nzÄƒri<br>Motive',0),(48432,1346,'et','KÃ¤ibemaksuvabastuse<br>PÃµhjused',0),(48433,1346,'si','Oprostitev od prometnega davka<br>Razlogov',0),(48434,1346,'ba','Pembebasan pajak penjualan<br>Alasan',0),(48435,1346,'nl','Vrijstelling van omzetbelasting<br>Redenen',0),(48436,1346,'fi','Verottomuuden<br>SyistÃ¤',0),(48437,1346,'no','Mva-unntak<br>Grunner',0),(48438,1346,'da','Sales Tax Exemption<br>Grunde',0),(48439,1346,'ko','íŒë§¤ì„¸ ë©´ì œ<br>ì´ìœ ',0),(48440,1346,'he','×¤×˜×•×¨ ×ž×ž×¢ ×ž<br>×¡×™×‘×•×ª',0),(48441,1346,'el','Î‘Ï€Î±Î»Î»Î±Î³Î® Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½<br>Î›ÏŒÎ³Î¿Ï…Ï‚',0),(48442,1346,'zh','å…å¾è¥ä¸šç¨ŽåŽŸå› \r\n',0),(48443,1346,'sv','Befrielsen frÃ¥n omsÃ¤ttningsskatt<br>SkÃ¤l',0),(48444,1346,'it','Esenzione dall\'imposta sulle vendite<br>Motivi',0),(48445,1346,'tl','',0),(48446,1346,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3604;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(48447,1346,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤›à¥‚à¤Ÿ<br>à¤•à¤¾à¤°à¤£à¥‹à¤‚ à¤¸à¥‡',0),(48448,1346,'ms','Pengecualian cukai jualan<br>Sebab-sebab',0),(48449,1346,'ar','Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ù…Ù† Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª<br>Ø§Ù„Ø£Ø³Ø¨Ø§Ø¨',0),(48450,1346,'fr','Exemption de la taxe de vente<br>Raisons',0),(48451,1346,'jp','å£²ä¸Šç¨ŽæŽ§é™¤<br>ç?†ç”±',0),(48452,1346,'pt','IsenÃ§Ã£o de imposto sobre vendas<br>RazÃµes',0),(48453,1346,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶<br>ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ñ‹',0),(48454,1346,'es','ExenciÃ³n de IVA<br>Razones\n',0),(48455,1346,'de','Umsatzsteuer-Befreiung<br>GrÃ¼nde',0),(48456,1346,'en','Sales Tax Exemption<br>Reasons',0),(48457,1347,'is','',0),(48458,1347,'dr','Ø¹Ø§Ù„ÙŠ',0),(48459,1347,'pr','Ø¹Ø§Ù„ÙŠ',0),(48460,1347,'tr','MÃ¼kemmel',0),(48461,1347,'pl','DoskonaÅ‚e',0),(48462,1347,'bg','ÐžÑ‚Ð»Ð¸Ñ‡ÐµÐ½',0),(48463,1347,'ur','Ø¹Ù…Ø¯Û',0),(48464,1347,'sr','ÐžÐ´Ð»Ð¸Ñ‡Ð°Ð½',0),(48465,1347,'vi','Tuyá»‡t vá»i',0),(48466,1347,'af','Uitstekend',0),(48467,1347,'ro','Excelent',0),(48468,1347,'et','SuurepÃ¤rane',0),(48469,1347,'si','OdliÄno',0),(48470,1347,'ba','Sangat baik',0),(48471,1347,'nl','Uitstekend',0),(48472,1347,'fi','Erinomainen',0),(48473,1347,'no','Utmerket',0),(48474,1347,'da','Fremragende',0),(48475,1347,'ko','ë§¤ìš° ë§Œì¡±',0),(48476,1347,'he','×ž×¦×•×™×Ÿ',0),(48477,1347,'el','Î•Î¾Î±Î¹ÏÎµÏ„Î¹ÎºÎ®',0),(48478,1347,'zh','ä¼˜ç§€\r\n',0),(48479,1347,'sv','UtmÃ¤rkt',0),(48480,1347,'it','Eccellente',0),(48481,1347,'tl','',0),(48482,1347,'th','&#3604;&#3637;&#3617;&#3634;&#3585;',0),(48483,1347,'hi','à¤‰à¤¤à¥à¤•à¥ƒà¤·à¥à¤Ÿ',0),(48484,1347,'ms','Cemerlang',0),(48485,1347,'ar','Ù…Ù…ØªØ§Ø²Ø©',0),(48486,1347,'fr','Excellente',0),(48487,1347,'jp','ã?™ã?°ã‚‰ã?—ã?„',0),(48488,1347,'pt','Excelente',0),(48489,1347,'ru','ÐžÑ‚Ð»Ð¸Ñ‡Ð½Ð¾',0),(48490,1347,'es','Ecelente',0),(48491,1347,'de','Ausgezeichnet',0),(48492,1347,'en','Excellent',0),(48493,1348,'is','',0),(48494,1348,'dr','Ù…Ø¹Ø§Ù ',0),(48495,1348,'pr','Ù…Ø¹Ø§Ù ',0),(48496,1348,'tr','Muafiyet',0),(48497,1348,'pl','Zwolniony',0),(48498,1348,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð´ÐµÐ½Ð¸',0),(48499,1348,'ur','Ù…Ø¨Ø±Ø§',0),(48500,1348,'sr','Ð˜Ð·ÑƒÐ·ÐµÑ‚Ð¸',0),(48501,1348,'vi','Loáº¡i trá»«',0),(48502,1348,'af','Vrygestel',0),(48503,1348,'ro','Scutite',0),(48504,1348,'et','Maksuvaba',0),(48505,1348,'si','OproÅ¡Äena',0),(48506,1348,'ba','Dibebaskan',0),(48507,1348,'nl','Vrijgesteld',0),(48508,1348,'fi','Vapauttaa',0),(48509,1348,'no','Fritatt',0),(48510,1348,'da','Undtaget',0),(48511,1348,'ko','ë©´ì œ',0),(48512,1348,'he','×¤×˜×•×¨',0),(48513,1348,'el','Î‘Ï€Î±Î»Î»Î¬ÏƒÏƒÎ¿Î½Ï„Î±Î¹',0),(48514,1348,'zh','è±å…\r\n',0),(48515,1348,'sv','Undantagna',0),(48516,1348,'it','Esenti',0),(48517,1348,'tl','',0),(48518,1348,'th','&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;',0),(48519,1348,'hi','à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(48520,1348,'ms','Dikecualikan',0),(48521,1348,'ar','Ù…Ø¹ÙÙŠ',0),(48522,1348,'fr','ExonÃ©rÃ©',0),(48523,1348,'jp','å…?é™¤',0),(48524,1348,'pt','Isentos',0),(48525,1348,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ñ‹',0),(48526,1348,'es','Exento',0),(48527,1348,'de','Ausgenommen',0),(48528,1348,'en','Exempt',0),(48529,1349,'is','',0),(48530,1349,'dr','Ù…Ø¹Ø§Ù ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´ Ù‡Ø§ ',0),(48531,1349,'pr','Ù…Ø¹Ø§Ù ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´ Ù‡Ø§ ',0),(48532,1349,'tr','Muaf satÄ±ÅŸ',0),(48533,1349,'pl','SprzedaÅ¼ zwolniona',0),(48534,1349,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð´ÐµÐ½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(48535,1349,'ur','Ù…Ø³ØªØ«Ù†ÛŒ Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(48536,1349,'sr','Ð˜Ð·ÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(48537,1349,'vi','Doanh sá»‘ Miá»…n trá»«',0),(48538,1349,'af','Vrygestelde Verkope',0),(48539,1349,'ro','VÃ¢nzÄƒri scutite',0),(48540,1349,'et','Maksuvaba mÃ¼Ã¼k',0),(48541,1349,'si','OproÅ¡Äene prodaje',0),(48542,1349,'ba','Penjualan dibebaskan',0),(48543,1349,'nl','Vrijgesteld verkoop',0),(48544,1349,'fi','Vapautettu myynti',0),(48545,1349,'no','Unnta salg',0),(48546,1349,'da','Afgiftsfri salg',0),(48547,1349,'ko','ë©´ì œ íŒë§¤',0),(48548,1349,'he','×ž×›×™×¨×•×ª ×¤×˜×•×¨×•×ª ×ž×ž×¢',0),(48549,1349,'el','Î‘Ï€Î±Î»Î»Î±ÏƒÏƒÏŒÎ¼ÎµÎ½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(48550,1349,'zh','å…ç¨Žé”€å”®\r\n',0),(48551,1349,'sv','Undanta fÃ¶rsÃ¤ljning',0),(48552,1349,'it','Vendite esenti',0),(48553,1349,'tl','',0),(48554,1349,'th','&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(48555,1349,'hi','à¤›à¥‚à¤Ÿ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(48556,1349,'ms','Jualan dikecualikan',0),(48557,1349,'ar','Ù…Ø¨ÙŠØ¹Ø§Øª Ù…Ø¹ÙØ§Ø©',0),(48558,1349,'fr','Ventes exonÃ©rÃ©es',0),(48559,1349,'jp','è²©å£²å…?é™¤',0),(48560,1349,'pt','Vendas isentas',0),(48561,1349,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ñ‹ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(48562,1349,'es','Ventas Exentas',0),(48563,1349,'de','Steuerbefreite UmsÃ¤tze',0),(48564,1349,'en','Exempt Sales',0),(48565,1350,'is','',0),(48566,1350,'dr','Ù…Ø¹Ø§Ù ÙƒØ±Ø¯Ù† Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(48567,1350,'pr','Ù…Ø¹Ø§Ù ÙƒØ±Ø¯Ù† Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(48568,1350,'tr','Muafiyet nakliye',0),(48569,1350,'pl','Zwolnieni, wysyÅ‚ka',0),(48570,1350,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð´ÐµÐ½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(48571,1350,'ur','Ù…Ø³ØªØ«Ù†ÛŒ Ø´Ù¾Ù†Ú¯',0),(48572,1350,'sr','ÐÐ•ÐžÐŸÐžÐ Ð•Ð—Ð˜Ð’Ð• Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(48573,1350,'vi','Miá»…n váº­n chuyá»ƒn',0),(48574,1350,'af','Vrygestelde Versending',0),(48575,1350,'ro','Scutite de transport maritim',0),(48576,1350,'et','Maksuvaba laevandus',0),(48577,1350,'si','OproÅ¡Äene dobave',0),(48578,1350,'ba','Dibebaskan pengiriman',0),(48579,1350,'nl','Vrijgesteld verzending',0),(48580,1350,'fi','Vapautettu toimitus',0),(48581,1350,'no','Unntatt frakt',0),(48582,1350,'da','Undtaget Shipping',0),(48583,1350,'ko','ë°°ì†¡ ì œì™¸',0),(48584,1350,'he','×ž×©×œ×•×— ×¤×˜×•×¨',0),(48585,1350,'el','Î‘Ï€Î±Î»Î»Î¬ÏƒÏƒÎ¿Î½Ï„Î±Î¹ Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(48586,1350,'zh','è±å…èˆªè¿\r\n',0),(48587,1350,'sv','Undanta sjÃ¶farten',0),(48588,1350,'it','Spedizione esente',0),(48589,1350,'tl','',0),(48590,1350,'th','&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(48591,1350,'hi','à¤®à¥à¤•à¥à¤¤ à¤¨à¥Œà¤µà¤¹à¤¨',0),(48592,1350,'ms','Perkapalan dikecualikan',0),(48593,1350,'ar','ÙŠØ¹ÙÙŠ Ù…Ù† Ø§Ù„Ø´Ø­Ù†',0),(48594,1350,'fr','ExonÃ©rÃ© d\'expÃ©dition',0),(48595,1350,'jp','ç™ºé€?å…?é™¤',0),(48596,1350,'pt','Isentos de frete',0),(48597,1350,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ñ‹ Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(48598,1350,'es','Transporte Exento',0),(48599,1350,'de','Ausgenommen Versand',0),(48600,1350,'en','Exempt Shipping',0),(48601,1351,'is','',0),(48602,1351,'dr','Ù…Ø¹Ø§ÙÙŠØª Ù‚Ø¨Ù„ Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ ',0),(48603,1351,'pr','Ù…Ø¹Ø§ÙÙŠØª Ù‚Ø¨Ù„ Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ ',0),(48604,1351,'tr','Ã–nce hesaplanan vergi muafiyeti',0),(48605,1351,'pl','Zwolnienie z przed oblicza podatek',0),(48606,1351,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ´Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð° Ð´Ð°Ð½ÑŠÐº',0),(48607,1351,'ur','Ù‚Ø¨Ù„ Ø§Ø³ Ú©Û’ Ú©Û Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø­Ø³Ø§Ø¨ Ú©Û’ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(48608,1351,'sr','Ð˜Ð·ÑƒÐ·ÐµÑ›Ðµ Ð¿Ñ€Ðµ Ð½ÐµÐ³Ð¾ ÑˆÑ‚Ð¾ ÑÐµ Ð¿Ð¾Ñ€ÐµÐ· Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°.',0),(48609,1351,'vi','Miá»…n trá»« trÆ°á»›c khi tÃ­nh thuáº¿',0),(48610,1351,'af','Vrygestelling voor belasting bereken word',0),(48611,1351,'ro','Scutirea Ã®nainte de taxa calculatÄƒ',0),(48612,1351,'et','Erandit enne kÃ¤ibemaksu',0),(48613,1351,'si','Oprostitev, preden izraÄuna davka',0),(48614,1351,'ba','Pembebasan sebelum pajak dihitung',0),(48615,1351,'nl','Vrijstelling voordat belasting berekend',0),(48616,1351,'fi','Poikkeuksen ennen veron laskemista',0),(48617,1351,'no','Fritak fÃ¸r skatt beregnes',0),(48618,1351,'da','Fritagelse fÃ¸r skat beregnes',0),(48619,1351,'ko','ì„¸ê¸ˆ ê³„ì‚° í•˜ê¸° ì „ì— ë©´ì œ',0),(48620,1351,'he','×¤×˜×•×¨ ×œ×¤× ×™ ×”×ž×¡ ×ž×—×•×©×‘',0),(48621,1351,'el','Î‘Ï€Î±Î»Î»Î±Î³Î® Ï€ÏÎ¹Î½ ÎµÎ¹ÏƒÎ­ÏÎµÏ…ÏƒÎ±Î½',0),(48622,1351,'zh','è®¡ç®—çº³ç¨Žå‰è±å…\r\n',0),(48623,1351,'sv','Undantag innan skatten berÃ¤knas',0),(48624,1351,'it','Esenzione prima imposta calcolata',0),(48625,1351,'tl','',0),(48626,1351,'th','&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3616;&#3634;&#3625;&#3637;',0),(48627,1351,'hi','à¤‡à¤¸à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤•à¤¿ à¤•à¤° à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤•à¥€ à¤›à¥‚à¤Ÿ',0),(48628,1351,'ms','Pengecualian sebelum cukai dikira',0),(48629,1351,'ar','Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ù‚Ø¨Ù„ Ø§Ø­ØªØ³Ø§Ø¨ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(48630,1351,'fr','Exemption avant taxe calculÃ©e',0),(48631,1351,'jp','ç¨Žè¨ˆç®—å‰?ã?®å…?é™¤',0),(48632,1351,'pt','IsenÃ§Ã£o antes imposto calculado',0),(48633,1351,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð´Ð¾ ÐºÐ°Ð»ÑŒÐºÑƒÐ»ÑÑ†Ð¸Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(48634,1351,'es','ExenciÃ³n antes que el impuesto se calculÃ³',0),(48635,1351,'de','Befreiung vor Steuer berechnet',0),(48636,1351,'en','Exemption before tax calculated',0),(48637,1352,'is','',0),(48638,1352,'dr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ ',0),(48639,1352,'pr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ ',0),(48640,1352,'tr','Muafiyetler',0),(48641,1352,'pl','Zwolnienia',0),(48642,1352,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ð¸Ñ',0),(48643,1352,'ur','Ø§Ø³ØªØ«Ù†Ø§Ø¦ÛŒÚº',0),(48644,1352,'sr','Ð˜Ð·ÑƒÐ·ÐµÑ›Ð°',0),(48645,1352,'vi','Miá»…n trá»«',0),(48646,1352,'af','Vrystellings',0),(48647,1352,'ro','Scutiri',0),(48648,1352,'et','Erandid',0),(48649,1352,'si','Izjeme',0),(48650,1352,'ba','Pengecualian',0),(48651,1352,'nl','Vrijstellingen',0),(48652,1352,'fi','Poikkeukset',0),(48653,1352,'no','Unntak',0),(48654,1352,'da','Undtagelser',0),(48655,1352,'ko','ë©´ì œ',0),(48656,1352,'he','×¤×˜×•×¨×™×',0),(48657,1352,'el','Î•Î¾Î±Î¹ÏÎ­ÏƒÎµÎ¹Ï‚',0),(48658,1352,'zh','è±å…\r\n',0),(48659,1352,'sv','Undantag',0),(48660,1352,'it','Esenzioni',0),(48661,1352,'tl','',0),(48662,1352,'th','&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;',0),(48663,1352,'hi','à¤®à¥‡à¤‚ à¤›à¥‚à¤Ÿ',0),(48664,1352,'ms','Pengecualian',0),(48665,1352,'ar','Ø§Ù„Ø¥Ø¹ÙØ§Ø¡Ø§Øª',0),(48666,1352,'fr','ExonÃ©rations',0),(48667,1352,'jp','å…?é™¤',0),(48668,1352,'pt','IsenÃ§Ãµes',0),(48669,1352,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ',0),(48670,1352,'es','Exenciones',0),(48671,1352,'de','Ausnahmen',0),(48672,1352,'en','Exemptions',0),(48673,1353,'is','',0),(48674,1353,'dr','Ù…Ø®Ø§Ø±Ø¬ ',0),(48675,1353,'pr','Ù…Ø®Ø§Ø±Ø¬ ',0),(48676,1353,'tr','Giderleri',0),(48677,1353,'pl','Koszty',0),(48678,1353,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(48679,1353,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(48680,1353,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(48681,1353,'vi','Chi phÃ­',0),(48682,1353,'af','Uitgawes',0),(48683,1353,'ro','Cheltuielile',0),(48684,1353,'et','Kulud',0),(48685,1353,'si','StroÅ¡ki',0),(48686,1353,'ba','Biaya',0),(48687,1353,'nl','Kosten',0),(48688,1353,'fi','Kulut',0),(48689,1353,'no','Utgifter',0),(48690,1353,'da','Udgifter',0),(48691,1353,'ko','ë¹„ìš©',0),(48692,1353,'he','×”×•×¦××•×ª',0),(48693,1353,'el','ÎˆÎ¾Î¿Î´Î±',0),(48694,1353,'zh','å¼€æ”¯\r\n',0),(48695,1353,'sv','Kostnader',0),(48696,1353,'it','Spese di',0),(48697,1353,'tl','',0),(48698,1353,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(48699,1353,'hi','à¤µà¥à¤¯à¤¯',0),(48700,1353,'ms','Perbelanjaan',0),(48701,1353,'ar','Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª',0),(48702,1353,'fr','Frais',0),(48703,1353,'jp','æ”¯å‡º',0),(48704,1353,'pt','Despesas',0),(48705,1353,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(48706,1353,'es','Gastos',0),(48707,1353,'de','Aufwendungen',0),(48708,1353,'en','Expenses',0),(48709,1354,'is','',0),(48710,1354,'dr','Ø§Ø±Ø³Ø§Ù„',0),(48711,1354,'pr','Ø§Ø±Ø³Ø§Ù„',0),(48712,1354,'tr','DÄ±ÅŸa aktarma',0),(48713,1354,'pl','Eksport',0),(48714,1354,'bg','Ð˜Ð·Ð½Ð¾Ñ',0),(48715,1354,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(48716,1354,'sr','Ð˜Ð·Ð²Ð¾Ð·',0),(48717,1354,'vi','Xuáº¥t kháº©u',0),(48718,1354,'af','Uitvoer',0),(48719,1354,'ro','Exportare',0),(48720,1354,'et','Ekspordi',0),(48721,1354,'si','Izvoz',0),(48722,1354,'ba','Ekspor',0),(48723,1354,'nl','Exporteren',0),(48724,1354,'fi','Vienti',0),(48725,1354,'no','Eksportere',0),(48726,1354,'da','Eksportere',0),(48727,1354,'ko','ë‚´ë³´ë‚´ê¸°',0),(48728,1354,'he','×™×¦×',0),(48729,1354,'el','Î•Î¾Î±Î³Ï‰Î³Î®',0),(48730,1354,'zh','å‡ºå£\r\n',0),(48731,1354,'sv','Exportera',0),(48732,1354,'it','Esportazione',0),(48733,1354,'tl','',0),(48734,1354,'th','&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;',0),(48735,1354,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(48736,1354,'ms','Eksport',0),(48737,1354,'ar','Ø§Ù„ØªØµØ¯ÙŠØ±',0),(48738,1354,'fr','Exportation',0),(48739,1354,'jp','ã‚¨ã‚¯ã‚¹ãƒ?ãƒ¼ãƒˆ',0),(48740,1354,'pt','ExportaÃ§Ã£o',0),(48741,1354,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(48742,1354,'es','Exportar',0),(48743,1354,'de','Export',0),(48744,1354,'en','Export',0),(48745,1355,'is','',0),(48746,1355,'dr','Ø§Ø±Ø³Ø§Ù„ Ø­Ø³Ø§Ø¨Ù‡Ø§',0),(48747,1355,'pr','Ø§Ø±Ø³Ø§Ù„ Ø­Ø³Ø§Ø¨Ù‡Ø§',0),(48748,1355,'tr','Hesap verme',0),(48749,1355,'pl','Eksportuj kont',0),(48750,1355,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(48751,1355,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(48752,1355,'sr','Ð˜Ð·Ð²Ð¾Ð· Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(48753,1355,'vi','Káº¿t Xuáº¥t TK',0),(48754,1355,'af','Uitvoer van Rekeninge',0),(48755,1355,'ro','Conturile de export',0),(48756,1355,'et','Ekspordi kontod',0),(48757,1355,'si','Izvoz raÄunov',0),(48758,1355,'ba','Ekspor account',0),(48759,1355,'nl','Exporteren van Accounts',0),(48760,1355,'fi','Viennin osuus',0),(48761,1355,'no','Eksportere kontoer',0),(48762,1355,'da','Eksportere konti',0),(48763,1355,'ko','ê³„ì • ë‚´ë³´ë‚´ê¸°',0),(48764,1355,'he','×™×¦× ×—×©×‘×•× ×•×ª',0),(48765,1355,'el','Î•Î¾Î±Î³Ï‰Î³Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(48766,1355,'zh','å‡ºå£è´¦æˆ·\r\n',0),(48767,1355,'sv','Exportera konton',0),(48768,1355,'it','Esportare gli account',0),(48769,1355,'tl','',0),(48770,1355,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;',0),(48771,1355,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤–à¤¾à¤¤à¥‹à¤‚',0),(48772,1355,'ms','Akaun eksport',0),(48773,1355,'ar','ØªØµØ¯ÙŠØ± Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(48774,1355,'fr','Exporter des comptes',0),(48775,1355,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆæ›¸ã??å‡ºã?—',0),(48776,1355,'pt','Exportar contas',0),(48777,1355,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(48778,1355,'es','Exportar Cuentas',0),(48779,1355,'de','Konten exportieren',0),(48780,1355,'en','Export Accounts',0),(48781,1356,'is','',0),(48782,1356,'dr','Ø§Ø±Ø³Ø§Ù„ Ú¯Ø²Ø§Ø±Ø´ â€“ Ù†Ø§Ù… ÙØ§ÙŠÙ„ ',0),(48783,1356,'pr','Ø§Ø±Ø³Ø§Ù„ Ú¯Ø²Ø§Ø±Ø´ â€“ Ù†Ø§Ù… ÙØ§ÙŠÙ„ ',0),(48784,1356,'tr','Dosya adÄ± <small>(dÄ±ÅŸa)</small>',0),(48785,1356,'pl','Plik nazwa <small>(jeÅ›li wywozu)</small>',0),(48786,1356,'bg','Ð¤Ð°Ð¹Ð» Ð¸Ð¼Ðµ <small>(Ð¿Ñ€Ð¸ ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ)</small>',0),(48787,1356,'ur','Ù…Ø³Ù„ Ù†Ø§Ù… <small>Ø§Ú¯Ø± (Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø± Ø±ÛØ§ ÛÛ’)</small>',0),(48788,1356,'sr','Ð˜Ð¼Ðµ <small>(Ð°ÐºÐ¾ Ñ˜Ðµ Ð¸Ð·Ð²Ð¾Ð·)</small>',0),(48789,1356,'vi','TÃªn há»“ sÆ¡ <small>(náº¿u xuáº¥t)</small>',0),(48790,1356,'af','Leernaam <small>(if exporting)</small>',0),(48791,1356,'ro','Raport complet',0),(48792,1356,'et','Faili nimi <small>(kui)</small>',0),(48793,1356,'si','Pila ime <small>(Äe izvozniki)</small>',0),(48794,1356,'ba','Mengajukan nama <small>(jika mengekspor)</small>',0),(48795,1356,'nl','Bestand naam <small>(als exporteren)</small>',0),(48796,1356,'fi','Tiedoston nimi <small>(Jos vientiÃ¤)</small>',0),(48797,1356,'no','Filen navnet <small>(hvis eksportere)</small>',0),(48798,1356,'da','Fil navn <small>(hvis eksport)</small>',0),(48799,1356,'ko','íŒŒì¼ ì´ë¦„ <small>(í•´ë‹¹ ë˜ëŠ” ê²½ìš° ë‚´ë³´ë‚´ê¸°)</small>',0),(48800,1356,'he','×§×•×‘×¥ ×©× <small>(×× ××ª×” ×ž×™×™×¦×)</small>',0),(48801,1356,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ ÏŒÎ½Î¿Î¼Î± <small>(ÎµÎ¬Î½ ÎµÎ¾Î±Î³Ï‰Î³Î®)</small>',0),(48802,1356,'zh','æ–‡ä»¶åé‰ãƒ¦ç°®ï¼ˆå¦‚å‡ºå£ï¼‰\r\n',0),(48803,1356,'sv','Fil namn <small>(om exporterande)</small>',0),(48804,1356,'it','File di nome <small>(se l\'esportatore)</small>',0),(48805,1356,'tl','',0),(48806,1356,'th','&#3594;&#3639;&#3656;&#3629;&#3649;&#3615;&#3657;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621; (&#3606;&#3657;&#3634;&#3617;&#3637;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;)',0),(48807,1356,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¾à¤® <small>à¤…à¤—à¤° (à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤)</small>',0),(48808,1356,'ms','Fail nama <small>(jika pengeksport)</small>',0),(48809,1356,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ù„Ù <small>((Ø¥Ø°Ø§ ÙƒØ§Ù† ØªØµØ¯ÙŠØ±))</small>',0),(48810,1356,'fr','DÃ©poser nom <small>(lors de l\'exportation)</small>',0),(48811,1356,'jp','ãƒ•ã‚¡ã‚¤ãƒ«å??<small>(ã‚‚ã?—ã‚¨ã‚¯ã‚¹ãƒ?ãƒ¼ãƒˆã?—ã?¦ã‚‹ã?ªã‚‰)</small>',0),(48812,1356,'pt','Arquivo nome <small>(se a exportaÃ§Ã£o)</small>',0),(48813,1356,'ru','Ð˜Ð¼Ñ Ð¤Ð°Ð¹Ð»Ñ (ÐµÑÐ»Ð¸ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐµÑ‚ÑÑ)',0),(48814,1356,'es','Nombre de Archivo <chico> (si exporta) </chico>',0),(48815,1356,'de','Datei Name <small>(wenn exportieren)</small>',0),(48816,1356,'en','File Name <small>(if exporting)</small>',0),(48817,1357,'is','',0),(48818,1357,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ ',0),(48819,1357,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ ',0),(48820,1357,'tr','GeniÅŸletilmiÅŸ<br>Fiyat',0),(48821,1357,'pl','Rozszerzone<br>Cena',0),(48822,1357,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½<br>Ð¦ÐµÐ½Ð°',0),(48823,1357,'ur','ØªÙˆØ³ÛŒØ¹ Ú©Ø± Ø¯ÛŒ<br>Ù‚ÛŒÙ…Øª',0),(48824,1357,'sr','ÐŸÑ€Ð¾ÑˆÐ¸Ñ€ÐµÐ½Ð¸<br>Ð¦ÐµÐ½Ð°',0),(48825,1357,'vi','Gia háº¡ngiÃ¡',0),(48826,1357,'af','Uitgebrei<br>Prys',0),(48827,1357,'ro','Extins<br>Pret',0),(48828,1357,'et','Laiendatud<br>Hind',0),(48829,1357,'si','PodaljÅ¡a<br>Cena',0),(48830,1357,'ba','Diperpanjang<br>Harga',0),(48831,1357,'nl','Uitgebreid<br>Prijs',0),(48832,1357,'fi','Laajennettu<br>Hinta',0),(48833,1357,'no','Utvidet<br>Pris',0),(48834,1357,'da','Udvidet<br>Pris',0),(48835,1357,'ko','í™•ìž¥<br>ê°€ê²©',0),(48836,1357,'he','×ž×•×¨×—×‘<br>×ž×—×™×¨',0),(48837,1357,'el','Î•Ï€ÎµÎºÏ„Î±Î¸ÎµÎ¯<br>Î¤Î¹Î¼Î®',0),(48838,1357,'zh','æ€»é¢\r\n',0),(48839,1357,'sv','Extended<br>Pris',0),(48840,1357,'it','Esteso<br>Prezzo',0),(48841,1357,'tl','',0),(48842,1357,'th','&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3586;&#3618;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(48843,1357,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°à¤¿à¤¤<br>à¤®à¥‚à¤²à¥à¤¯',0),(48844,1357,'ms','Dilanjutkan<br>Harga',0),(48845,1357,'ar','Ù…Ø¯Ø¯<br>Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(48846,1357,'fr','Ã‰tendu<br>Prix',0),(48847,1357,'jp','å»¶é•·<br>å€¤æ®µ',0),(48848,1357,'pt','Estendido<br>PreÃ§o',0),(48849,1357,'ru','Ð Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ð¹<br>Ð¦ÐµÐ½Ð°',0),(48850,1357,'es','Precio<br>Extendido',0),(48851,1357,'de','Erweitert<br>Preis',0),(48852,1357,'en','Extended<br>Price',0),(48853,1358,'is','',0),(48854,1358,'dr','ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÙŠ ',0),(48855,1358,'pr','ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÙŠ ',0),(48856,1358,'tr','istemci sayfasÄ±',0),(48857,1358,'pl','Strona klienta',0),(48858,1358,'bg','ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(48859,1358,'ur','ÙˆØµÙˆÙ„ Ú©Ø§Ø± ØµÙØ­Û',0),(48860,1358,'sr','ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(48861,1358,'vi','trang khÃ¡ch hÃ ng',0),(48862,1358,'af','kliÃ«nt bladsy',0),(48863,1358,'ro','Pagina clientului',0),(48864,1358,'et','klienti lehel',0),(48865,1358,'si','stran odjemalca',0),(48866,1358,'ba','Halaman klien',0),(48867,1358,'nl','pagina-client',0),(48868,1358,'fi','asiakas-sivua',0),(48869,1358,'no','klienten-side',0),(48870,1358,'da','klient side',0),(48871,1358,'ko','í´ë¼ì´ì–¸íŠ¸ íŽ˜ì´ì§€',0),(48872,1358,'he','×“×£ ×”×œ×§×•×—',0),(48873,1358,'el','ÏƒÎµÎ»Î¯Î´Î± Ï„Î¿Ï… Ï€ÏÎ¿Î³ÏÎ¬Î¼Î¼Î±Ï„Î¿Ï‚-Ï€ÎµÎ»Î¬Ï„Î·',0),(48874,1358,'zh','å®¢æˆ·ç«¯é¡µé¢\r\n',0),(48875,1358,'sv','klienten',0),(48876,1358,'it','pagina client',0),(48877,1358,'tl','',0),(48878,1358,'th','&#3627;&#3609;&#3657;&#3634;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(48879,1358,'hi','à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ à¤ªà¥ƒà¤·à¥à¤ ',0),(48880,1358,'ms','Laman pelanggan',0),(48881,1358,'ar','ØµÙØ­Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(48882,1358,'fr','page client',0),(48883,1358,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆãƒšãƒ¼ã‚¸',0),(48884,1358,'pt','pÃ¡gina do cliente',0),(48885,1358,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(48886,1358,'es','PÃ¡gina de Cliente',0),(48887,1358,'de','Clientseite',0),(48888,1358,'en','client page',0),(48889,1359,'is','',0),(48890,1359,'dr','ÙƒØ§Ø±Ø¨Ø± Ø®Ø§Ø±Ø¬ÙŠ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…  Ù…ØªØµÙ„ Ø§Ø³Øª ',0),(48891,1359,'pr','ÙƒØ§Ø±Ø¨Ø± Ø®Ø§Ø±Ø¬ÙŠ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…  Ù…ØªØµÙ„ Ø§Ø³Øª ',0),(48892,1359,'tr','DÄ±ÅŸ oturum aÃ§ma kullanÄ±cÄ± zaten var',0),(48893,1359,'pl','ZewnÄ™trzne logowania uÅ¼ytkownik juÅ¼ istnieje',0),(48894,1359,'bg','Ð’ÑŠÐ½ÑˆÐ½Ð¸Ñ‚Ðµ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(48895,1359,'ur','Ø®Ø§Ø±Ø¬ÛŒ Ù„Ø§Ú¯ Ø¢Ù† ØµØ§Ø±Ù Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(48896,1359,'sr','Ð¡Ð¿Ð¾Ñ™Ð½Ð¸ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ðµ',0),(48897,1359,'vi','NgÆ°á»i Sá»­ Dá»¥ng ÄÄƒng nháº­p tá»« bÃªn ngoÃ i Ä‘Ã£ tá»“n táº¡i',0),(48898,1359,'af','Eksterne Aantekengebruiker bestaan alreeds',0),(48899,1359,'ro','Externe Logon utilizator existÄƒ deja',0),(48900,1359,'et','VÃ¤line Sisselogiv kasutaja on juba olemas',0),(48901,1359,'si','Zunanje prijavni uporabnik Å¾e obstaja',0),(48902,1359,'ba','Eksternal Logon pengguna sudah ada',0),(48903,1359,'nl','Externe aanmelding gebruiker al bestaat',0),(48904,1359,'fi','Ulkoisen kÃ¤yttÃ¤jÃ¤n jo olemassa',0),(48905,1359,'no','Ekstern pÃ¥logging bruker allerede finnes',0),(48906,1359,'da','Eksterne Logonbrugeren allerede findes',0),(48907,1359,'ko','ì™¸ë¶€ ë¡œê·¸ì˜¨ ì‚¬ìš©ìž ì´ë¯¸ ì¡´ìž¬',0),(48908,1359,'he','×ž×©×ª×ž×© ×©×”×ª×—×‘×¨ ×—×™×¦×•× ×™×™× ×§×™×™×ž×™× ×›×‘×¨',0),(48909,1359,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î®Î´Î· ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÎ®Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·',0),(48910,1359,'zh','å¤–éƒ¨ç™»å½•ç”¨æˆ·å·²ç»å­˜åœ¨\r\n',0),(48911,1359,'sv','Extern inloggning anvÃ¤ndare redan finns',0),(48912,1359,'it','Esistono giÃ  utente di accesso esterno',0),(48913,1359,'tl','',0),(48914,1359,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3592;&#3634;&#3585;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(48915,1359,'hi','à¤¬à¤¾à¤¹à¥à¤¯ à¤²à¥‰à¤—à¤‘à¤¨ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦',0),(48916,1359,'ms','Pengguna log masuk luar sudah wujud',0),(48917,1359,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø®Ø§Ø±Ø¬ÙŠØ© Ù…ÙˆØ¬ÙˆØ¯Ø© Ø¨Ø§Ù„ÙØ¹Ù„',0),(48918,1359,'fr','Utilisateur externe existe dÃ©jÃ ',0),(48919,1359,'jp','å¤–éƒ¨ãƒ­ã‚°ã‚ªãƒ³ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?¯ã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(48920,1359,'pt','Externo de Logon usuÃ¡rio jÃ¡ existe.',0),(48921,1359,'ru','Ð’Ð½ÐµÑˆÐ½Ð¸Ð¹ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(48922,1359,'es','Usuario de Logon External Ya Existe',0),(48923,1359,'de','Externe Anmeldung Benutzer bereits vorhanden',0),(48924,1359,'en','External Logon User Already Exist',0),(48925,1360,'is','',0),(48926,1360,'dr','Ø§ØªØµØ§Ù„ Ø®Ø§Ø±Ø¬ÙŠ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ÙˆØ§Ø±Ø¯ Ø´Ø¯ â€“ Ø§Ù…Ø§ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÙŠ Ø´Ø±ÙƒØª  ÙŠØ§ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø´Ø±ÙƒØª Ù†ÙŠØ³Øª ',0),(48927,1360,'pr','Ø§ØªØµØ§Ù„ Ø®Ø§Ø±Ø¬ÙŠ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ÙˆØ§Ø±Ø¯ Ø´Ø¯ â€“ Ø§Ù…Ø§ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÙŠ Ø´Ø±ÙƒØª  ÙŠØ§ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø´Ø±ÙƒØª Ù†ÙŠØ³Øª ',0),(48928,1360,'tr','Extlogon, custcompanyid veya vendcompany kimliÄŸi geÃ§medi.',0),(48929,1360,'pl','Przekazany, ale id custcompanyid lub vendcompany nie Extlogon.',0),(48930,1360,'bg','Extlogon Ð¿Ñ€ÐµÐ¼Ð¸Ð½Ð°, Ð½Ð¾ Ð˜Ð” custcompanyid Ð¸Ð»Ð¸ vendcompany Ð½Ðµ.',0),(48931,1360,'ur','Ù¹Ù„ÙˆÚ¯Ø§ÙˆÙ†ØŒ Ú©Ø³Ù¹Ú©ÙˆÙ…Ù¾Ù†ÛŒØ§Ø¯ ÛŒØ§ ÙˆØ§Ù†Ø¯Ú©ÙˆÙ…Ù¾Ø§Ù†ÛŒ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª Ù„ÛŒÚ©Ù† Ù…Ù†Ø¸ÙˆØ± Ù†ÛÛŒÚº Û”',0),(48932,1360,'sr','Ð•xÑ‚Ð»Ð¾Ð³Ð¾Ð½ Ñ˜Ðµ Ð¿Ñ€ÐµÐ¼Ð¸Ð½ÑƒÐ¾, Ð°Ð»Ð¸ Ð¸Ð´ Ñ†ÑƒÑÑ‚Ñ†Ð¾Ð¼Ð¿Ð°Ð½yÐ¸Ð´ Ð¸Ð»Ð¸ Ð²ÐµÐ½Ð´Ñ†Ð¾Ð¼Ð¿Ð°Ð½y Ð½Ðµ.',0),(48933,1360,'vi','Logo qua nhÆ°ng id cty khÃ¡ch hÃ ng hay cty ngÆ°á»i bÃ¡n chÆ°a qua',0),(48934,1360,'af','Extlogon geslaag het, maar custcompanyid of vendcompany id nie.',0),(48935,1360,'ro','Extlogon a trecut, dar ID-ul custcompanyid sau vendcompany nu.',0),(48936,1360,'et','MÃ¶Ã¶dunud, kuid custcompanyid vÃµi vendcompany id ei Extlogon.',0),(48937,1360,'si','Extlogon opravili, vendar id custcompanyid ali vendcompany ni.',0),(48938,1360,'ba','Extlogon berlalu, tetapi custcompanyid atau vendcompany id tidak.',0),(48939,1360,'nl','Extlogon doorgegeven, maar custcompanyid of vendcompany-id niet.',0),(48940,1360,'fi','Extlogon kulunut, mutta custcompanyid tai vendcompany ole.',0),(48941,1360,'no','Extlogon gikk, men custcompanyid eller vendcompany-id ikke.',0),(48942,1360,'da','Extlogon bestÃ¥et, men custcompanyid eller vendcompany-id ikke.',0),(48943,1360,'ko','Extlogon ì „ë‹¬, custcompanyid ë˜ëŠ” vendcompany id í•˜ì§€.',0),(48944,1360,'he','Extlogon ×¢×‘×¨×•, ××‘×œ ×ž×–×”×” custcompanyid ××• vendcompany ×œ×.',0),(48945,1360,'el','Extlogon Ï€ÎµÏÎ¬ÏƒÎµÎ¹, Î±Î»Î»Î¬ custcompanyid Î® vendcompany id Î´ÎµÎ½.',0),(48946,1360,'zh','å¤–éƒ¨ç™»å½•é€šè¿‡ï¼Œä½†å®¢æˆ·çš„å…¬å¸èº«ä»½æˆ–é”€å”®å•†å…¬å¸èº«ä»½æœªé€šè¿‡ã€‚\r\n',0),(48947,1360,'sv','Extlogon passerade, men custcompanyid eller vendcompany-id inte.',0),(48948,1360,'it','Extlogon passato, ma id custcompanyid o vendcompany non.',0),(48949,1360,'tl','',0),(48950,1360,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3592;&#3634;&#3585;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585;&#3612;&#3656;&#3634;&#3609; &#3649;&#3605;&#3656;&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3610;&#3619;&#3636;&#',0),(48951,1360,'hi','Extlogon, custcompanyid à¤¯à¤¾ vendcompany id à¤²à¥‡à¤•à¤¿à¤¨ à¤ªà¤¾à¤°à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚à¥¤',0),(48952,1360,'ms','Extlogon diluluskan, tetapi id custcompanyid atau vendcompany tidak.',0),(48953,1360,'ar','Ù…Ø±ØªØŒ Ù„ÙƒÙ† Ù…Ø¹Ø±Ù ÙƒÙˆØ³ØªÙƒÙˆÙ…Ø¨Ø§Ù†ÙŠÙŠØ¯ Ø£Ùˆ ÙÙŠÙ†Ø¯ÙƒÙˆÙ…Ø¨Ø§Ù†ÙŠ Ù„Ø§ Ø§ÙƒØ³ØªÙ„ÙˆØ¬ÙˆÙ†.',0),(48954,1360,'fr','Extlogon passÃ©e, mais custcompanyid ou vendcompany id ne pas.',0),(48955,1360,'jp','è¿½åŠ ãƒ­ã‚°ã‚ªãƒ³ã?¯é€šé?Žã?—ã?¾ã?—ã?Ÿã?Œã€?é¡§å®¢ä¼šç¤¾ï¼©ï¼¤ã?¨æ¥­è€…ä¼šç¤¾ï¼©ï¼¤ã?Œé€šé?Žã?—ã?¾ã?›ã‚“',0),(48956,1360,'pt','Extlogon passado, mas custcompanyid ou vendcompany id nÃ£o.',0),(48957,1360,'ru','Extlogon Ð¿Ñ€Ð¾ÑˆÐ»Ð¾, Ð½Ð¾ custcompanyid Ð¸Ð»Ð¸ vendcompany id Ð½Ðµ.',0),(48958,1360,'es','Ext. logon pasÃ³, pero id de empresa persoalizada o id de Proveedor de empresa no pasÃ³',0),(48959,1360,'de','Extlogon bestanden, aber Custcompanyid oder Vendcompany-Id nicht.',0),(48960,1360,'en','Extlogon passed, but custcompanyid or vendcompany id not.',0),(48961,1361,'is','',0),(48962,1361,'dr','CIT Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ù¾Ø§ÙŠÙ‡ ',0),(48963,1361,'pr',' CIT Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ù¾Ø§ÙŠÙ‡ \r\n',0),(48964,1361,'tr','Ä°lave CIT temel',0),(48965,1361,'pl','Dodatkowe CIT na podstawie',0),(48966,1361,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ CIT, Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð°',0),(48967,1361,'ur','Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø± Ø§Ø¶Ø§ÙÛŒ Ø³Ù¹ÛŒØŒ ÛŒÙˆÙ¹Ø§Û',0),(48968,1361,'sr','Ð•ÐºÑÑ‚Ñ€Ð° Ð¦Ð˜Ð¢, Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ',0),(48969,1361,'vi','CIT thÃªm dá»±a trÃªn',0),(48970,1361,'af','Ekstra be gebaseer op',0),(48971,1361,'ro','CIT suplimentare pe baza',0),(48972,1361,'et','PÃµhineb eest CIT',0),(48973,1361,'si','Dodatno CIT, ki temelji na',0),(48974,1361,'ba','Tambahan CIT berdasarkan',0),(48975,1361,'nl','Extra CIT gebaseerd op',0),(48976,1361,'fi','Kun CIT perustuu',0),(48977,1361,'no','Ekstra CIT basert pÃ¥',0),(48978,1361,'da','Ekstra CIT baseret pÃ¥',0),(48979,1361,'ko','ì— ë”°ë¼ ì¶”ê°€ CIT',0),(48980,1361,'he','CIT × ×•×¡×£ ×”×ž×‘×•×¡×¡ ×¢×œ',0),(48981,1361,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ CIT Î¼Îµ Î²Î¬ÏƒÎ·',0),(48982,1361,'zh','åŸºäºŽé¢å¤–æ‰€å¾—ç¨Ž\r\n',0),(48983,1361,'sv','Extra CIT baserat pÃ¥',0),(48984,1361,'it','CIT supplementare sulla base',0),(48985,1361,'tl','',0),(48986,1361,'th','&#3586;&#3638;&#3657;&#3609;&#3629;&#3618;&#3641;&#3656;&#3585;&#3633;&#3610; CIT &#3614;&#3636;&#3648;&#3624;&#3625;',0),(48987,1361,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¸à¥€à¤†à¤ˆà¤Ÿà¥€ à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤°',0),(48988,1361,'ms','CIT tambahan berdasarkan',0),(48989,1361,'ar','CIT Ø¥Ø¶Ø§ÙÙŠØ© Ø§Ø³ØªÙ†Ø§Ø¯Ø§Ù‹ Ø¥Ù„Ù‰',0),(48990,1361,'fr','CIT supplÃ©mentaire basÃ©e sur',0),(48991,1361,'jp','ï½žã?«åŸºã?¥ã??è¿½åŠ CIT',0),(48992,1361,'pt','CIT extra com base em',0),(48993,1361,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÐœÐšÐ–Ð¢, Ð¾ÑÐ½Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹ Ð½Ð°',0),(48994,1361,'es','Extra CIT Basado En',0),(48995,1361,'de','ZusÃ¤tzliche CIT basierend auf',0),(48996,1361,'en','Extra CIT Based On',0),(48997,1362,'is','',0),(48998,1362,'dr','CIT Ø§Ø¶Ø§ÙÙŠ Ø¯Ø± Ù‡Ø± Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(48999,1362,'pr',' CIT Ø§Ø¶Ø§ÙÙŠ Ø¯Ø± Ù‡Ø± Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(49000,1362,'tr','Ã–deme dÃ¶nem baÅŸÄ±na ilave CIT',0),(49001,1362,'pl','Dodatkowe CIT za okresu rozliczeniowego',0),(49002,1362,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð—ÐšÐŸÐž Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(49003,1362,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¯Øª ÙÛŒ Ø§Ø¶Ø§ÙÛŒ Ø³Ù¹ÛŒØŒ ÛŒÙˆÙ¹Ø§Û',0),(49004,1362,'sr','Ð•ÐºÑÑ‚Ñ€Ð° Ð¦Ð˜Ð¢ Ð¿Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñƒ Ð¿Ð»Ð°Ñ‚Ðµ',0),(49005,1362,'vi','CIT thÃªm má»—i ká»³ thanh toÃ¡n',0),(49006,1362,'af','Ekstra be per betaal periode',0),(49007,1362,'ro','CIT suplimentare pe perioada de plata',0),(49008,1362,'et','Extra CIT tasuperioodi kohta',0),(49009,1362,'si','Dodatno CIT na plaÄi',0),(49010,1362,'ba','Tambahan CIT per periode membayar',0),(49011,1362,'nl','Extra CIT per periode van loon',0),(49012,1362,'fi','Kun CIT kohti.',0),(49013,1362,'no','Ekstra CIT per periode',0),(49014,1362,'da','Ekstra CIT pr. lÃ¸nperiode',0),(49015,1362,'ko','ì§€ë¶ˆ ê¸°ê°„ ë‹¹ ì¶”ê°€ CIT',0),(49016,1362,'he','CIT ×ª×•×¡×¤×ª ×”×©×›×¨ ×œ×ª×§×•×¤×”',0),(49017,1362,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ CIT Î±Î½Î¬ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿Ï„Î¹ÎºÎ®Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(49018,1362,'zh','æ¯æ¬¡æ”¯ä»˜æ—¶æœŸçš„é¢å¤–æ‰€å¾—ç¨Ž\r\n',0),(49019,1362,'sv','Extra CIT per lÃ¶neperiod',0),(49020,1362,'it','CIT supplementare per ogni periodo di paga',0),(49021,1362,'tl','',0),(49022,1362,'th','CIT &#3614;&#3636;&#3648;&#3624;&#3625;&#3605;&#3656;&#3629;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3592;&#3656;&#3634;&#3618;',0),(49023,1362,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¸à¥€à¤†à¤ˆà¤Ÿà¥€',0),(49024,1362,'ms','CIT Tambahan satu tempoh pembayaran gaji',0),(49025,1362,'ar','CIT Ø¥Ø¶Ø§ÙÙŠØ© ÙƒÙ„ ÙØªØ±Ø© Ø§Ù„Ø¯ÙØ¹',0),(49026,1362,'fr','CIT supplÃ©mentaire par pÃ©riode de paie',0),(49027,1362,'jp','æ”¯æ‰•æœŸé–“ã?”ã?¨ã?®è¿½åŠ CIT',0),(49028,1362,'pt','CIT extra por cada perÃ­odo de pagamento',0),(49029,1362,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÐœÐšÐ–Ð¢ Ð·Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(49030,1362,'es','Extra CIT por periÃ³do de pago',0),(49031,1362,'de','ZusÃ¤tzliche CIT pro Zahlungsperiode',0),(49032,1362,'en','Extra CIT per pay period',0),(49033,1363,'is','',0),(49034,1363,'dr','FIT',0),(49035,1363,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¯ÙˆÙ„ØªÙŠ Ø§Ø¶Ø§ÙÙŠ  Ø¨Ø± Ø§Ø³Ø§Ø³ FIT',0),(49036,1363,'tr','Ekstra temel alarak uygun',0),(49037,1363,'pl','Dodatkowe dopasowanie na podstawie',0),(49038,1363,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ ÑÐµ Ð’ÐŸÐ˜Ð¡Ð’ÐÐ¢ Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð°',0),(49039,1363,'ur','Ø§Ø¶Ø§ÙÛŒ Ù¾Ø± Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø± Ù…ÙˆØ²ÙˆÚº Ú©Ø±ÛŒÚº',0),(49040,1363,'sr','Ð•ÐºÑÑ‚Ñ€Ð° Ð´Ð° ÑÑ‚Ð°Ð½Ðµ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ',0),(49041,1363,'vi','FIT thÃªm dá»±a trÃªn',0),(49042,1363,'af','Ekstra pas gebaseer op',0),(49043,1363,'ro','Suplimentar se potrivesc bazate pe',0),(49044,1363,'et','Eriti SOBIVAKS aluseks',0),(49045,1363,'si','Ekstra FIT na podlagi',0),(49046,1363,'ba','Tambahan sesuai berdasarkan',0),(49047,1363,'nl','Extra passen op basis van',0),(49048,1363,'fi','ErittÃ¤in hyvÃ¤ssÃ¤ kunnossa perustuu',0),(49049,1363,'no','Ekstra passer basert pÃ¥',0),(49050,1363,'da','Ekstra passer baseret pÃ¥',0),(49051,1363,'ko','ì¶”ê°€ì— ë”°ë¼ ë§žëŠ”',0),(49052,1363,'he','×ª×•×¡×¤×ª ×ž×ª××™×ž×” ×‘×”×ª××',0),(49053,1363,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½, Î¤Î‘Î™Î¡Î™Î†Î–Î•Î™ Î¼Îµ Î²Î¬ÏƒÎ·',0),(49054,1363,'zh','é¢å¤–è”é‚¦æ”¶å…¥æ‰€å¾—ç¨Žæ˜¯åŸºäºŽ\r\n',0),(49055,1363,'sv','Extra passa utifrÃ¥n',0),(49056,1363,'it','Extra FIT sulla base',0),(49057,1363,'tl','',0),(49058,1363,'th','&#3586;&#3638;&#3657;&#3609;&#3629;&#3618;&#3641;&#3656;&#3585;&#3633;&#3610; FIT &#3614;&#3636;&#3648;&#3624;&#3625;',0),(49059,1363,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¤° à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤«à¤¿à¤Ÿ',0),(49060,1363,'ms','Lebih sesuai berdasarkan',0),(49061,1363,'ar','ØªÙ†Ø§Ø³Ø¨ Ø¥Ø¶Ø§ÙÙŠ Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³',0),(49062,1363,'fr','AJUSTEMENT supplÃ©mentaire sur la base',0),(49063,1363,'jp','ï½žã?«åŸºã?¥ã??è¿½åŠ FIT',0),(49064,1363,'pt','Extra se ENCAIXAM com base em',0),(49065,1363,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ Ð’ÐŸÐ˜Ð¡Ð«Ð’ÐÐ®Ð¢Ð¡Ð¯ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ð°Ð½Ð¸Ð¸',0),(49066,1363,'es','Extra FIT Basado En',0),(49067,1363,'de','Passen Sie besonders auf der Grundlage',0),(49068,1363,'en','Extra FIT Based On',0),(49069,1364,'is','',0),(49070,1364,'dr','FIT',0),(49071,1364,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¯ÙˆÙ„ØªÙŠ Ø§Ø¶Ø§ÙÙŠ Ø¯Ø± Ù‡Ø± Ø³Ø§Ù„  FIT',0),(49072,1364,'tr','Ekstra Ã¶deme dÃ¶nemine uygun',0),(49073,1364,'pl','Dodatkowe dopasowanie na okresie rozliczeniowym',0),(49074,1364,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ ÑÐµ Ð’ÐŸÐ˜Ð¡Ð’ÐÐ¢ Ð½Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(49075,1364,'ur','ÙØ§Ø¶Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¯Øª ÙÛŒ Ù…ÙˆØ²ÙˆÚº Ú©Ø±ÛŒÚº',0),(49076,1364,'sr','Ð•ÐºÑÑ‚Ñ€Ð° Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð° Ð·Ð° Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð¿Ð»Ð°Ñ‚Ðµ',0),(49077,1364,'vi','FIT thÃªm má»—i ká»³ thanh toÃ¡n',0),(49078,1364,'af','Ekstra pas per betaal periode',0),(49079,1364,'ro','Suplimentar se potrivesc pe perioada de plata',0),(49080,1364,'et','Eriti sobivad tasuperioodi kohta',0),(49081,1364,'si','Ekstra FIT na plaÄi',0),(49082,1364,'ba','Tambahan cocok per periode membayar',0),(49083,1364,'nl','Extra passen per periode van loon',0),(49084,1364,'fi','Extra sopii kohti.',0),(49085,1364,'no','Ekstra plass per periode',0),(49086,1364,'da','Ekstra plads pr. lÃ¸nperiode',0),(49087,1364,'ko','ì¶”ê°€ ì§€ë¶ˆ ê¸°ê°„ ë‹¹ ì í•©',0),(49088,1364,'he','×ž×ª××™× ×‘×ž×™×•×—×“ ×œ×›×œ ×ª×§×•×¤×ª ×”×ª×©×œ×•×',0),(49089,1364,'el','Î¤Î‘Î™Î¡Î™Î†Î–Î•Î™ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Î±Î½Î¬ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿Ï„Î¹ÎºÎ®Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(49090,1364,'zh','æ¯æ”¯ä»˜æœŸé¢å¤–çš„è”é‚¦æ”¶å…¥æ‰€å¾—ç¨Ž\r\n',0),(49091,1364,'sv','Extra passar per lÃ¶neperiod',0),(49092,1364,'it','Extra FIT per ogni periodo di paga',0),(49093,1364,'tl','',0),(49094,1364,'th','FIT &#3614;&#3636;&#3648;&#3624;&#3625;&#3605;&#3656;&#3629;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3592;&#3656;&#3634;&#3618;',0),(49095,1364,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿ à¤«à¤¿à¤Ÿ',0),(49096,1364,'ms','Lebih sesuai setiap tempoh pembayaran gaji',0),(49097,1364,'ar','ØªÙ†Ø§Ø³Ø¨ Ø¥Ø¶Ø§ÙÙŠ ÙƒÙ„ ÙØªØ±Ø© Ø§Ù„Ø¯ÙØ¹',0),(49098,1364,'fr','AJUSTEMENT supplÃ©mentaire par pÃ©riode de paie',0),(49099,1364,'jp','æ”¯æ‰•æœŸé–“ã?”ã?¨ã?®è¿½åŠ FIT',0),(49100,1364,'pt','AJUSTE extra por cada perÃ­odo de pagamento',0),(49101,1364,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ Ð’ÐŸÐ˜Ð¡Ð«Ð’ÐÐ®Ð¢Ð¡Ð¯ Ð² Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(49102,1364,'es','Extra FIT por periÃ³do de pago',0),(49103,1364,'de','Extra pro Zahlungsperiode passen',0),(49104,1364,'en','Extra FIT per pay period',0),(49105,1365,'is','',0),(49106,1365,'dr','LIT',0),(49107,1365,'pr',' Ø§Ø¶Ø§ÙÙŠ  Ø¨Ø±Ø§Ø³Ø§Ø³ LIT',0),(49108,1365,'tr','Ekstra temel alÄ±narak YAKTI',0),(49109,1365,'pl','Dodatkowe ZAPALIÅ na podstawie',0),(49110,1365,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ ÐžÐ¡Ð’Ð•Ð¢Ð•ÐÐ Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð°',0),(49111,1365,'ur','Ø§Ø¶Ø§ÙÛŒ Ù¾Ø± Ù…Ø¨Ù†ÛŒ Ø±ÙˆØ´Ù†',0),(49112,1365,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¾ Ñ˜Ðµ Ð—ÐÐŸÐÐ›Ð˜Ðž Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ',0),(49113,1365,'vi','LIT thÃªm dá»±a trÃªn',0),(49114,1365,'af','Ekstra AANGESTEEK gebaseer op',0),(49115,1365,'ro','Extra aprins pe baza',0),(49116,1365,'et','Ekstra valgustatud pÃµhjal',0),(49117,1365,'si','Ekstra LIT na podlagi',0),(49118,1365,'ba','Ekstra MENYALAKAN berdasarkan',0),(49119,1365,'nl','Extra verlicht op basis van',0),(49120,1365,'fi','Extra palaa perustuu',0),(49121,1365,'no','Ekstra tent basert pÃ¥',0),(49122,1365,'da','Ekstra tÃ¦ndt baseret pÃ¥',0),(49123,1365,'ko','ì¶”ê°€ì— ë”°ë¼ ì¡°ëª…',0),(49124,1365,'he','×ª×•×¡×¤×ª ×ž×•××¨ ×”×ž×‘×•×¡×¡ ×¢×œ',0),(49125,1365,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Ï†Ï‰Ï„Î¹ÏƒÎ¼ÏŒ Î¼Îµ Î²Î¬ÏƒÎ·',0),(49126,1365,'zh','é¢å¤–ä¼ è¾“æŸå¤±åŸºäºŽ\r\n',0),(49127,1365,'sv','Extra LIT baserat pÃ¥',0),(49128,1365,'it','Extra illuminato sulla base',0),(49129,1365,'tl','',0),(49130,1365,'th','&#3586;&#3638;&#3657;&#3609;&#3629;&#3618;&#3641;&#3656;&#3585;&#3633;&#3610; LIT &#3614;&#3636;&#3648;&#3624;&#3625;',0),(49131,1365,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¤° à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤œà¤²à¤¾à¤ˆ',0),(49132,1365,'ms','Tambahan DINYALAKAN berdasarkan',0),(49133,1365,'ar','Ø¥Ø¶Ø§Ø¡Ø© Ø¥Ø¶Ø§ÙÙŠØ© Ø§Ø³ØªÙ†Ø§Ø¯Ø§Ù‹ Ø¥Ù„Ù‰',0),(49134,1365,'fr','TrÃ¨s Ã©clairÃ© sur la base',0),(49135,1365,'jp','ï½žã?«åŸºã?¥ã??è¿½åŠ LIT',0),(49136,1365,'pt','Extra iluminado com base em',0),(49137,1365,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ Ð³Ð¾Ñ€Ð¸Ñ‚ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ',0),(49138,1365,'es','Extra LIT Basado En',0),(49139,1365,'de','Extra beleuchtet anhand',0),(49140,1365,'en','Extra LIT Based On',0),(49141,1366,'is','',0),(49142,1366,'dr','LIT',0),(49143,1366,'pr','Ø¶Ø§ÙÙŠ Ø¯Ø± Ù‡Ø± Ø¯ÙˆØ±Ù‡ LIT',0),(49144,1366,'tr','Ekstra Ã¶deme dÃ¶nemini YAKTI',0),(49145,1366,'pl','Dodatkowe ZAPALIÅ za okresu rozliczeniowego',0),(49146,1366,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ ÐžÐ¡Ð’Ð•Ð¢Ð•ÐÐ Ð½Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(49147,1366,'ur','ÙØ§Ø¶Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¯Øª ÙÛŒ Ø±ÙˆØ´Ù†',0),(49148,1366,'sr','Ð•ÐºÑÑ‚Ñ€Ð° Ð›Ð˜Ð¢ Ð¿Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñƒ Ð¿Ð»Ð°Ñ‚Ðµ',0),(49149,1366,'vi','LIT thÃªm má»—i ká»³ thanh toÃ¡n',0),(49150,1366,'af','Ekstra per betaal periode AANGESTEEK',0),(49151,1366,'ro','Extra aprins pe perioada de plata',0),(49152,1366,'et','Ekstra valgustatud tasuperioodi kohta',0),(49153,1366,'si','Ekstra LIT na plaÄi',0),(49154,1366,'ba','Ekstra MENYALAKAN per periode membayar',0),(49155,1366,'nl','Extra LIT per periode van loon',0),(49156,1366,'fi','Extra palaa kohti.',0),(49157,1366,'no','Ekstra tent per periode',0),(49158,1366,'da','Ekstra tÃ¦ndt pr. lÃ¸nperiode',0),(49159,1366,'ko','ì¶”ê°€ ì§€ë¶ˆ ê¸°ê°„ ë‹¹ ì¡°ëª…',0),(49160,1366,'he','×ž×•××¨ ×ª×•×¡×¤×ª ×”×©×›×¨ ×œ×ª×§×•×¤×”',0),(49161,1366,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ LIT Î±Î½Î¬ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿Ï„Î¹ÎºÎ®Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(49162,1366,'zh','æ¯æ”¯ä»˜æœŸé¢å¤–ä¼ è¾“æŸå¤±\r\n',0),(49163,1366,'sv','Extra LIT per lÃ¶neperiod',0),(49164,1366,'it','ILLUMINATO extra per ogni periodo di paga',0),(49165,1366,'tl','',0),(49166,1366,'th','LIT &#3614;&#3636;&#3648;&#3624;&#3625;&#3605;&#3656;&#3629;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3592;&#3656;&#3634;&#3618;',0),(49167,1366,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿ à¤œà¤²à¤¾à¤ˆ',0),(49168,1366,'ms','Tambahan DINYALAKAN satu tempoh pembayaran gaji',0),(49169,1366,'ar','Ø¥Ø¶Ø§Ø¡Ø© Ø¥Ø¶Ø§ÙÙŠØ© ÙƒÙ„ ÙØªØ±Ø© Ø§Ù„Ø¯ÙØ¹',0),(49170,1366,'fr','LIT supplÃ©mentaire par pÃ©riode de paie',0),(49171,1366,'jp','æ”¯æ‰•æœŸé–“ã?”ã?¨ã?®è¿½åŠ LIT',0),(49172,1366,'pt','LIT extra por cada perÃ­odo de pagamento',0),(49173,1366,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ Ð³Ð¾Ñ€Ð¸Ñ‚ Ð·Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(49174,1366,'es','Extra LIT por periÃ³do de Pago',0),(49175,1366,'de','Extra pro Zahlungsperiode LIT',0),(49176,1366,'en','Extra LIT per pay period',0),(49177,1367,'is','',0),(49178,1367,'dr','SIT',0),(49179,1367,'pr','Ø§Ø¶Ø§ÙÙŠ Ø¨Ø± Ø§Ø³Ø§Ø³ SIT',0),(49180,1367,'tr','Temel ilave SIT',0),(49181,1367,'pl','Dodatkowe siedzieÄ‡ na podstawie',0),(49182,1367,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ SIT, Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð°',0),(49183,1367,'ur','Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø± Ø§Ø¶Ø§ÙÛŒ Ø¨ÛŒÙ¹Ú¾Ùˆ',0),(49184,1367,'sr','Ð•ÐºÑÑ‚Ñ€Ð° ÑÐµÐ´Ð¸ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ',0),(49185,1367,'vi','SIT thÃªm dá»±a trÃªn',0),(49186,1367,'af','Ekstra SIT gebaseer op',0),(49187,1367,'ro','SIT suplimentare pe baza',0),(49188,1367,'et','PÃµhineb eest ISTUDA',0),(49189,1367,'si','Dodatno SIT, na podlagi',0),(49190,1367,'ba','DUDUK tambahan berdasarkan',0),(49191,1367,'nl','Extra SIT op basis van',0),(49192,1367,'fi','YlimÃ¤Ã¤rÃ¤inen ISTUA perustuu',0),(49193,1367,'no','Ekstra SIT basert pÃ¥',0),(49194,1367,'da','Ekstra sidde baseret pÃ¥',0),(49195,1367,'ko','ì— ë”°ë¼ ì¶”ê°€ ì•‰ì•„',0),(49196,1367,'he','×œ×©×‘×ª × ×•×¡×¤×ª ×”×ž×‘×•×¡×¡×ª ×¢×œ',0),(49197,1367,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ SIT Î¼Îµ Î²Î¬ÏƒÎ·',0),(49198,1367,'zh','é¢å¤–å›½å®¶æ”¶å…¥æ‰€å¾—ç¨ŽåŸºäºŽ\r\n',0),(49199,1367,'sv','Extra SIT baserat pÃ¥',0),(49200,1367,'it','SIT extra sulla base',0),(49201,1367,'tl','',0),(49202,1367,'th','&#3586;&#3638;&#3657;&#3609;&#3629;&#3618;&#3641;&#3656;&#3585;&#3633;&#3610; SIT &#3614;&#3636;&#3648;&#3624;&#3625;',0),(49203,1367,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤†à¤§à¤¾à¤° à¤ªà¤° à¤¬à¥ˆà¤ à¥‹',0),(49204,1367,'ms','DUDUK tambahan berdasarkan',0),(49205,1367,'ar','Ø§Ù„Ø¬Ù„ÙˆØ³ Ø¥Ø¶Ø§ÙÙŠØ© Ø§Ø³ØªÙ†Ø§Ø¯Ø§Ù‹ Ø¥Ù„Ù‰',0),(49206,1367,'fr','SIT supplÃ©mentaire basÃ©e sur',0),(49207,1367,'jp','ï½žã?«åŸºã?¥ã??è¿½åŠ SIT',0),(49208,1367,'pt','SIT extra com base em',0),(49209,1367,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÐ¸Ð´ÐµÑ‚ÑŒ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ',0),(49210,1367,'es','Extra SIT Basado En',0),(49211,1367,'de','ZusÃ¤tzliche SIT basierend auf',0),(49212,1367,'en','Extra SIT Based On',0),(49213,1368,'is','',0),(49214,1368,'dr','SIT',0),(49215,1368,'pr','Ø§Ø¶Ø§ÙÙŠ Ø¯Ø± Ù‡Ø± Ø¯ÙˆØ±Ù‡ SIT',0),(49216,1368,'tr','Ekstra Ã¶deme dÃ¶neminin oturmak',0),(49217,1368,'pl','SIEDZIEÄ† ekstra za okresu rozliczeniowego',0),(49218,1368,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ SIT Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(49219,1368,'ur','ÙØ§Ø¶Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¯Øª ÙÛŒ Ø¨ÛŒÙ¹Ú¾ Ú©Ø±',0),(49220,1368,'sr','Ð•ÐºÑÑ‚Ñ€Ð° ÑÐµÐ´Ð¸ Ð¿Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñƒ Ð¿Ð»Ð°Ñ‚Ðµ',0),(49221,1368,'vi','SIT thÃªm má»—i ká»³ thanh toÃ¡n',0),(49222,1368,'af','SIT ekstra per betaal periode',0),(49223,1368,'ro','SIT suplimentare pe perioada de plata',0),(49224,1368,'et','Eest ISTUDA tasuperioodi kohta',0),(49225,1368,'si','Dodatno SIT plaÄi',0),(49226,1368,'ba','DUDUK tambahan per periode membayar',0),(49227,1368,'nl','Extra SIT per periode van loon',0),(49228,1368,'fi','YlimÃ¤Ã¤rÃ¤inen ISTUA kohti.',0),(49229,1368,'no','Ekstra SIT per periode',0),(49230,1368,'da','Ekstra sidde pr. lÃ¸nperiode',0),(49231,1368,'ko','ì§€ë¶ˆ ê¸°ê°„ ë‹¹ ì¶”ê°€ ì•‰ì•„',0),(49232,1368,'he','×œ×©×‘×ª ×ª×•×¡×¤×ª ×”×©×›×¨ ×œ×ª×§×•×¤×”',0),(49233,1368,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ SIT Î±Î½Î¬ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿Ï„Î¹ÎºÎ®Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(49234,1368,'zh','æ¯æ”¯ä»˜æœŸé¢å¤–å›½å®¶æ”¶å…¥æ‰€å¾—ç¨Ž\r\n',0),(49235,1368,'sv','Extra SIT per lÃ¶neperiod',0),(49236,1368,'it','SIT extra per ogni periodo di paga',0),(49237,1368,'tl','',0),(49238,1368,'th','SIT &#3614;&#3636;&#3648;&#3624;&#3625;&#3605;&#3656;&#3629;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3592;&#3656;&#3634;&#3618;',0),(49239,1368,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¬à¥ˆà¤ à¥‹',0),(49240,1368,'ms','Tambahan setiap satu tempoh pembayaran gaji',0),(49241,1368,'ar','Ø§Ù„Ø¬Ù„ÙˆØ³ Ø¥Ø¶Ø§ÙÙŠØ© ÙƒÙ„ ÙØªØ±Ø© Ø§Ù„Ø¯ÙØ¹',0),(49242,1368,'fr','SIT supplÃ©mentaire par pÃ©riode de paie',0),(49243,1368,'jp','æ”¯æ‰•æœŸé–“ã?”ã?¨ã?®è¿½åŠ SIT',0),(49244,1368,'pt','Sente-se extra por cada perÃ­odo de pagamento',0),(49245,1368,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ ÑÐ¸Ð´ÐµÑ‚ÑŒ Ð·Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(49246,1368,'es','Extra SIT por periÃ³do de pago',0),(49247,1368,'de','ZusÃ¤tzliche SIT pro Zahlungsperiode',0),(49248,1368,'en','Extra SIT per pay period',0),(49249,1369,'is','',0),(49250,1369,'dr','Ø¯Ø±ØµØ¯ Ø³Ø±Ø¨Ø§Ø± Ú©Ø§Ø±Ø®Ø§Ù†Ù‡',0),(49251,1369,'pr','Ø¯Ø±ØµØ¯ Ø³Ø±Ø¨Ø§Ø± Ú©Ø§Ø±Ø®Ø§Ù†Ù‡',0),(49252,1369,'tr','Fabrika genel gider %',0),(49253,1369,'pl','Fabryka napowietrznych %',0),(49254,1369,'bg','Ð—Ð°Ð²Ð¾Ð´ Ñ‚Ð¸Ð¿ %',0),(49255,1369,'ur','ÙÛŒÚ©Ù¹Ø±ÛŒ ÛÛŒÚˆ %',0),(49256,1369,'sr','Ð¤Ð°Ð±Ñ€Ð¸ÐºÐ° Ð¸Ð½Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° %',0),(49257,1369,'vi','% Chi phÃ­ sá»± nghiá»‡p cá»§a nhÃ  mÃ¡y',0),(49258,1369,'af','Fakbriek Oorhoofse %',0),(49259,1369,'ro','Fabrica aeriene %',0),(49260,1369,'et','Tehase Ãµhuliini %',0),(49261,1369,'si','Tovarne reÅ¾ijske %',0),(49262,1369,'ba','% Overhead pabrik',0),(49263,1369,'nl','Fabriek Overhead %',0),(49264,1369,'fi','Tehtaan ylÃ¤puolella %',0),(49265,1369,'no','Fabrikken Overhead %',0),(49266,1369,'da','Fabrikken Overhead %',0),(49267,1369,'ko','ê³µìž¥ ì˜¤ë²„ í—¤ë“œ %',0),(49268,1369,'he','×ž×¤×¢×œ % ×ª×§×•×¨×”',0),(49269,1369,'el','Î•ÏÎ³Î¿ÏƒÏ„Î¬ÏƒÎ¹Î¿ Î“Î’Î• %',0),(49270,1369,'zh','å·¥åŽ‚ç®€ä»‹è´¹ç”¨ï¼…\r\n',0),(49271,1369,'sv','Fabriken Overhead %',0),(49272,1369,'it','Fabbrica basculante %',0),(49273,1369,'tl','',0),(49274,1369,'th','&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3651;&#3609;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3586;&#3629;&#3591;&#3650;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(49275,1369,'hi','à¤«à¥ˆà¤•à¥à¤Ÿà¤°à¥€ à¤‰à¤ªà¤°à¤¿ %',0),(49276,1369,'ms','% Overhed kilang',0),(49277,1369,'ar','Ù…ØµÙ†Ø¹ % Ø¹Ù„ÙˆÙŠØ©',0),(49278,1369,'fr','% Frais gÃ©nÃ©raux d\'usine',0),(49279,1369,'jp','å·¥å ´è«¸çµŒè²»æ¯”çŽ‡',0),(49280,1369,'pt','FÃ¡brica % Overhead',0),(49281,1369,'ru','Ð¤Ð°Ð±Ñ€Ð¸ÐºÐ° Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ñ‹Ðµ %',0),(49282,1369,'es','% de Costos Operativos de FÃ¡brica',0),(49283,1369,'de','Fabrik Overhead %',0),(49284,1369,'en','Factory Overhead %',0),(49285,1370,'is','',0),(49286,1370,'dr','!  Ù‡ÙŠÚ† Ø§Ø¬Ø§Ø²Ù‡ Ø§ÛŒ Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ´ØªÙ† Ø¯Ø± ',0),(49287,1370,'pr','Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ !  Ù‡ÙŠÚ† Ø§Ø¬Ø§Ø²Ù‡ Ø§ÛŒ Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ´ØªÙ† Ø¯Ø± ',0),(49288,1370,'tr','BaÅŸarÄ±sÄ±z!  Yazmak iÃ§in izin yok',0),(49289,1370,'pl','Nie powiodÅ‚o siÄ™!  Brak uprawnieÅ„ do zapisu',0),(49290,1370,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾!  ÐÑÐ¼Ð° Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð·Ð° Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð²',0),(49291,1370,'ur','Ù†Ø§Ú©Ø§Ù…!  Ú©Û’ Ù„Ø¦Û’ Ù„Ú©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ø§Ø¬Ø§Ø²Øª',0),(49292,1370,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾!  ÐÐµÐ¼Ð° Ð´Ð¾Ð·Ð²Ð¾Ð»Ðµ Ð´Ð° ÑƒÐ¿Ð¸ÑÑƒÑ˜ÐµÑ‚Ðµ',0),(49293,1370,'vi','Tháº¥t báº¡i! KhÃ´ng cÃ³ quyá»n viáº¿t tá»›i',0),(49294,1370,'af','Het misluk!  Geen toestemming na skryf',0),(49295,1370,'ro','Nu a reuÅŸit!  Permisiuni nu pentru a scrie la',0),(49296,1370,'et','Nurjus!  Kirjutamise Ãµigusi',0),(49297,1370,'si','Ni uspelo!  Brez dovoljenja za pisanje',0),(49298,1370,'ba','Gagal!  Tidak ada izin untuk menulis ke',0),(49299,1370,'nl','Mislukt!  Geen machtigingen om te schrijven naar',0),(49300,1370,'fi','EpÃ¤onnistui!  Ei ole oikeuksia kirjoittaa',0),(49301,1370,'no','Feil!  Ingen tillatelser til Ã¥ skrive til',0),(49302,1370,'da','Mislykkedes!  Ingen tilladelser til at skrive til',0),(49303,1370,'ko','ì‹¤íŒ¨!  ì“°ê¸° ê¶Œí•œ ì—†ìŒ',0),(49304,1370,'he','× ×›×©×œ×”!  ××™×Ÿ ×”×¨×©××•×ª ×›×ª×™×‘×”',0),(49305,1370,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ!  Î”ÎµÎ½ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ ÏƒÎµ',0),(49306,1370,'zh','å¤±è´¥ï¼æ²¡æœ‰æƒé™å†™å…¥\r\n',0),(49307,1370,'sv','Misslyckades!  Ingen behÃ¶righet att skriva till',0),(49308,1370,'it','Fallito!  Delle autorizzazioni di scrittura',0),(49309,1370,'tl','',0),(49310,1370,'th','&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623; &#3652;&#3617;&#3656;&#3651;&#3627;&#3657;&#3585;&#3634;&#3619;&#3618;&#3636;&#3609;&#3618;&#3629;&#3617;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3586;&#3637;&#3618;&#3609;&#3606;&#3638;&#3591;',0),(49311,1370,'hi','à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾!  à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¿à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤…à¤¨à¥à¤®à¤¤à¤¿à¤¯à¤¾à¤',0),(49312,1370,'ms','Gagal!  Tiada kebenaran untuk menulis ke',0),(49313,1370,'ar','ÙØ´Ù„!  Ù„ÙŠØ³ Ù„Ø¯ÙŠÙƒ Ø£Ø°ÙˆÙ†Ø§Øª Ø§Ù„ÙƒØªØ§Ø¨Ø© Ø¥Ù„Ù‰',0),(49314,1370,'fr','A Ã©chouÃ© !  Aucune autorisation d\'Ã©crire Ã ',0),(49315,1370,'jp','å¤±æ•—ã?—ã?¾ã?—ã?Ÿã€‚æ›¸ã??è¾¼ã‚€è¨±å?¯ã?Œã?‚ã‚Šã?¾ã?›ã‚“ã€‚',0),(49316,1370,'pt','Falhou!  NÃ£o hÃ¡ permissÃµes para gravar',0),(49317,1370,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ!  ÐÐµÑ‚ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÑŒ Ð²',0),(49318,1370,'es','Fallado! No hay permisos para escribir a',0),(49319,1370,'de','Fehlgeschlagen!  Keine Berechtigungen zum Schreiben in',0),(49320,1370,'en','Failed!  No permissions to write to',0),(49321,1371,'is','',0),(49322,1371,'dr','Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ Ø¯Ø± ØªØ±Ø§Ø² ÙƒØ±Ø¯Ù† ',0),(49323,1371,'pr','Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ Ø¯Ø± ØªØ±Ø§Ø² ÙƒØ±Ø¯Ù† ',0),(49324,1371,'tr','dengelemek baÅŸarÄ±sÄ±z oldu',0),(49325,1371,'pl','nie udaÅ‚o siÄ™ zrÃ³wnowaÅ¼yÄ‡',0),(49326,1371,'bg','Ð½Ðµ Ð¼Ð¾Ð¶Ð° Ð´Ð° ÑÐµ Ð±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð°Ñ‚',0),(49327,1371,'ur','ØªÙˆØ§Ø²Ù† Ù‚Ø§Ø¦Ù… Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛÛ’',0),(49328,1371,'sr','Ð±Ð°Ð»Ð°Ð½Ñ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÐ»Ð¾',0),(49329,1371,'vi','khÃ´ng cÃ¢n Ä‘á»‘i',0),(49330,1371,'af','faal om te balanseer',0),(49331,1371,'ro','nu a reuÅŸit sÄƒ echilibreze',0),(49332,1371,'et','ei suutnud leida tasakaal',0),(49333,1371,'si','bilance ni uspelo',0),(49334,1371,'ba','gagal untuk menyeimbangkan',0),(49335,1371,'nl','is mislukt om in evenwicht te',0),(49336,1371,'fi','ei tasapaino',0),(49337,1371,'no','mislyktes Ã¥ balansere',0),(49338,1371,'da','undladt at afbalancere',0),(49339,1371,'ko','ê· í˜•ì„ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(49340,1371,'he','×œ× ×”×¦×œ×™×— ×œ××–×Ÿ',0),(49341,1371,'el','Î±Ï€Î­Ï„Ï…Ï‡Îµ Î½Î± Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î®ÏƒÎµÎ¹',0),(49342,1371,'zh','ç»“ä½™å¤±è´¥\r\n',0),(49343,1371,'sv','Det gick inte att balansera',0),(49344,1371,'it','non Ã¨ riuscito a bilanciare',0),(49345,1371,'tl','',0),(49346,1371,'th','&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;&#3651;&#3609;&#3585;&#3634;&#3619;&#3607;&#3635;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(49347,1371,'hi','à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤«à¤²',0),(49348,1371,'ms','gagal untuk mengimbangi',0),(49349,1371,'ar','ÙØ´Ù„ ÙÙŠ ØªØ­Ù‚ÙŠÙ‚ Ø§Ù„ØªÙˆØ§Ø²Ù† Ø¨ÙŠÙ†',0),(49350,1371,'fr','Impossible d\'Ã©quilibrer',0),(49351,1371,'jp','ãƒ?ãƒ©ãƒ³ã‚¹ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(49352,1371,'pt','NÃ£o conseguiram equilibrar',0),(49353,1371,'ru','Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ ÑÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(49354,1371,'es','FallÃ³ balancear',0),(49355,1371,'de','Fehler beim balancieren',0),(49356,1371,'en','failed to balance',0),(49357,1372,'is','',0),(49358,1372,'dr','Ù…ØªÙˆØ³Ø·',0),(49359,1372,'pr','Ù…ØªÙˆØ³Ø·',0),(49360,1372,'tr','Fuar',0),(49361,1372,'pl','Targi',0),(49362,1372,'bg','ÐŸÐ°Ð½Ð°Ð¸Ñ€',0),(49363,1372,'ur','Ù…Ù†ØµÙØ§Ù†Û',0),(49364,1372,'sr','Ð¤ÐµÑ€',0),(49365,1372,'vi','CÃ´ng báº±ng',0),(49366,1372,'af','Redelik',0),(49367,1372,'ro','Echitabil',0),(49368,1372,'et','Ã•iglane',0),(49369,1372,'si','Sejem',0),(49370,1372,'ba','Adil',0),(49371,1372,'nl','Eerlijke',0),(49372,1372,'fi','Oikeudenmukainen',0),(49373,1372,'no','Rettferdig',0),(49374,1372,'da','Fair',0),(49375,1372,'ko','ê³µì •',0),(49376,1372,'he','×ž×ž×•×¦×¢',0),(49377,1372,'el','Î”Î¯ÎºÎ±Î¹Î·',0),(49378,1372,'zh','äº¤æ˜“ä¼š\r\n',0),(49379,1372,'sv','RÃ¤ttvis',0),(49380,1372,'it','Fiera',0),(49381,1372,'tl','',0),(49382,1372,'th','&#3611;&#3634;&#3609;&#3585;&#3621;&#3634;&#3591;',0),(49383,1372,'hi','à¤®à¥‡à¤²à¤¾',0),(49384,1372,'ms','Saksama',0),(49385,1372,'ar','Ø¹Ø§Ø¯Ù„',0),(49386,1372,'fr','Juste',0),(49387,1372,'jp','å…¬å¹³',0),(49388,1372,'pt','Justo',0),(49389,1372,'ru','Ð¯Ñ€Ð¼Ð°Ñ€ÐºÐ°',0),(49390,1372,'es','Justo',0),(49391,1372,'de','Fair',0),(49392,1372,'en','Fair',0),(49393,1373,'is','',0),(49394,1373,'dr','ÙÙƒØ³ ',0),(49395,1373,'pr','ÙÙƒØ³ ',0),(49396,1373,'tr','Faks',0),(49397,1373,'pl','Faks',0),(49398,1373,'bg','Ð¤Ð°ÐºÑ',0),(49399,1373,'ur','ÙÛŒÚ©Ø³',0),(49400,1373,'sr','Ð¤Ð°ÐºÑ',0),(49401,1373,'vi','Fax',0),(49402,1373,'af','Faks',0),(49403,1373,'ro','Fax',0),(49404,1373,'et','Faks',0),(49405,1373,'si','Faks',0),(49406,1373,'ba','Faks',0),(49407,1373,'nl','Fax',0),(49408,1373,'fi','Faksi',0),(49409,1373,'no','Faks',0),(49410,1373,'da','Fax',0),(49411,1373,'ko','íŒ©ìŠ¤',0),(49412,1373,'he','×¤×§×¡',0),(49413,1373,'el','Î¦Î±Î¾',0),(49414,1373,'zh','ä¼ çœŸ\r\n',0),(49415,1373,'sv','Fax',0),(49416,1373,'it','Fax',0),(49417,1373,'tl','',0),(49418,1373,'th','&#3650;&#3607;&#3619;&#3626;&#3634;&#3619;',0),(49419,1373,'hi','à¤«à¥ˆà¤•à¥à¤¸',0),(49420,1373,'ms','Perkhidmatan Faks',0),(49421,1373,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ù…ØµÙˆÙ‘Ø±',0),(49422,1373,'fr','TÃ©lÃ©copieur',0),(49423,1373,'jp','ãƒ•ã‚¡ãƒƒã‚¯ã‚¹',0),(49424,1373,'pt','Fax',0),(49425,1373,'ru','Ð¤Ð°ÐºÑ',0),(49426,1373,'es','Fax',0),(49427,1373,'de','Fax',0),(49428,1373,'en','Fax',0),(49429,1374,'is','',0),(49430,1374,'dr','ÙˆÙŠÚ˜Ú¯ÙŠ Ù‡Ø§ ',0),(49431,1374,'pr','ÙˆÙŠÚ˜Ú¯ÙŠ Ù‡Ø§ ',0),(49432,1374,'tr','Ã–zellikler',0),(49433,1374,'pl','Funkcje',0),(49434,1374,'bg','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(49435,1374,'ur','Ø®ØµÙˆØµÛŒØ§Øª',0),(49436,1374,'sr','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ',0),(49437,1374,'vi','Äáº·c tÃ­nh',0),(49438,1374,'af','Kenmerke',0),(49439,1374,'ro','Caracteristici',0),(49440,1374,'et','Funktsioonid',0),(49441,1374,'si','Funkcije',0),(49442,1374,'ba','Fitur',0),(49443,1374,'nl','Functies',0),(49444,1374,'fi','Ominaisuudet',0),(49445,1374,'no','Funksjoner',0),(49446,1374,'da','Funktioner',0),(49447,1374,'ko','ê¸°ëŠ¥',0),(49448,1374,'he','×ª×›×•× ×•×ª',0),(49449,1374,'el','Î§Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬',0),(49450,1374,'zh','ç‰¹ç‚¹\r\n',0),(49451,1374,'sv','Funktioner',0),(49452,1374,'it','Caratteristiche',0),(49453,1374,'tl','',0),(49454,1374,'th','&#3621;&#3633;&#3585;&#3625;&#3603;&#3632;&#3648;&#3604;&#3656;&#3609;',0),(49455,1374,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾à¤à¤',0),(49456,1374,'ms','Ciri-ciri',0),(49457,1374,'ar','Ù…ÙŠØ²Ø§Øª',0),(49458,1374,'fr','CaractÃ©ristiques',0),(49459,1374,'jp','ç‰¹å¾´',0),(49460,1374,'pt','CaracterÃ­sticas',0),(49461,1374,'ru','ÐžÑÐ¾Ð±ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(49462,1374,'es','Rasgos',0),(49463,1374,'de','Funktionen',0),(49464,1374,'en','Features',0),(49465,1375,'is','',0),(49466,1375,'dr','ÙÙˆØ±ÙŠÙ‡ ',0),(49467,1375,'pr','ÙÙˆØ±ÙŠÙ‡ ',0),(49468,1375,'tr','Åžubat',0),(49469,1375,'pl','Lutego',0),(49470,1375,'bg','Ð¤ÐµÐ²Ñ€ÑƒÐ°Ñ€Ð¸',0),(49471,1375,'ur','ÙØ±ÙˆØ±ÛŒ',0),(49472,1375,'sr','Ð¤ÐµÐ±Ñ€ÑƒÐ°Ñ€Ð°',0),(49473,1375,'vi','ThÃ¡ng hai',0),(49474,1375,'af','Februarie',0),(49475,1375,'ro','Februarie',0),(49476,1375,'et','Veebruar',0),(49477,1375,'si','Februarja',0),(49478,1375,'ba','Februari',0),(49479,1375,'nl','Februari',0),(49480,1375,'fi','Helmikuuta',0),(49481,1375,'no','Februar',0),(49482,1375,'da','Februar',0),(49483,1375,'ko','2 ì›”',0),(49484,1375,'he','×¤×‘×¨×•××¨',0),(49485,1375,'el','Î¦ÎµÎ²ÏÎ¿Ï…Î±ÏÎ¯Î¿Ï…',0),(49486,1375,'zh','äºŒæœˆ\r\n',0),(49487,1375,'sv','Februari',0),(49488,1375,'it','Febbraio',0),(49489,1375,'tl','',0),(49490,1375,'th','&#3585;&#3640;&#3617;&#3616;&#3634;&#3614;&#3633;&#3609;&#3608;&#3660;',0),(49491,1375,'hi','à¤«à¤¼à¤°à¤µà¤°à¥€',0),(49492,1375,'ms','Februari',0),(49493,1375,'ar','ÙØ¨Ø±Ø§ÙŠØ±',0),(49494,1375,'fr','FÃ©vrier',0),(49495,1375,'jp','2æœˆ',0),(49496,1375,'pt','Fevereiro',0),(49497,1375,'ru','Ð¤ÐµÐ²Ñ€Ð°Ð»ÑŒ',0),(49498,1375,'es','Febrero',0),(49499,1375,'de','Februar',0),(49500,1375,'en','February',0),(49501,1376,'is','',0),(49502,1376,'dr','(Ø¯ÙˆÙ„ØªÙŠ',0),(49503,1376,'pr','ÙØ¯Ø±Ø§Ù„ (Ø¯ÙˆÙ„ØªÙŠ',0),(49504,1376,'tr','Beslenen',0),(49505,1376,'pl','Karmione',0),(49506,1376,'bg','Ð¥Ñ€Ð°Ð½ÐµÐ½Ð¸',0),(49507,1376,'ur','Ú©Ú¾Ù„Ø§ÛŒØ§',0),(49508,1376,'sr','Ð¥Ñ€Ð°Ð½Ð¸Ð¾',0),(49509,1376,'vi','LiÃªn bang',0),(49510,1376,'af','Gevoer',0),(49511,1376,'ro','HrÄƒnite',0),(49512,1376,'et','Toidetud',0),(49513,1376,'si','Krmijo',0),(49514,1376,'ba','Makan',0),(49515,1376,'nl','Gevoed',0),(49516,1376,'fi','KyllÃ¤stynyt',0),(49517,1376,'no','Matet',0),(49518,1376,'da','Fodret',0),(49519,1376,'ko','ë¨¹ì´',0),(49520,1376,'he','× ×ž××¡',0),(49521,1376,'el','Î¤ÏÎ­Ï†Î¿Î½Ï„Î±Î¹',0),(49522,1376,'zh','ç¾Žè”å‚¨\r\n',0),(49523,1376,'sv','Matas',0),(49524,1376,'it','Alimentato',0),(49525,1376,'tl','',0),(49526,1376,'th','&#3651;&#3627;&#3657;&#3629;&#3634;&#3627;&#3634;&#3619;',0),(49527,1376,'hi','à¤¤à¤‚à¤— à¤† à¤—à¤¯à¤¾',0),(49528,1376,'ms','Diberi makan',0),(49529,1376,'ar','Ø¨Ù†Ùƒ Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠ Ø§Ù„ÙÙŠØ¯Ø±Ø§Ù„ÙŠ',0),(49530,1376,'fr','Nourris',0),(49531,1376,'jp','é€£é‚¦',0),(49532,1376,'pt','Alimentados',0),(49533,1376,'ru','ÐšÐ¾Ñ€Ð¼Ð¸Ð»Ð¸',0),(49534,1376,'es','Fed',0),(49535,1376,'de','GefÃ¼ttert',0),(49536,1376,'en','Fed',0),(49537,1377,'is','',0),(49538,1377,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ ',0),(49539,1377,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ ',0),(49540,1377,'tr','Fed. Vergi',0),(49541,1377,'pl','Karmione. Podatku',0),(49542,1377,'bg','Ð¥Ñ€Ð°Ð½ÐµÐ½Ð¸. Ð”Ð°Ð½ÑŠÐº',0),(49543,1377,'ur','Ú©Ú¾Ù„Ø§ÛŒØ§ Û” Ù¹ÛŒÚ©Ø³',0),(49544,1377,'sr','Ð”Ð¾ÑÑ‚Ð° Ð¼Ð¸ Ñ˜Ðµ. ÐŸÐ¾Ñ€ÐµÐ·',0),(49545,1377,'vi','Thuáº¿ LiÃªn bang',0),(49546,1377,'af','Gevoer. Belasting',0),(49547,1377,'ro','HrÄƒnite. Fiscale',0),(49548,1377,'et','SÃ¶Ã¶ta. Maks',0),(49549,1377,'si','Krmijo. DavÄne',0),(49550,1377,'ba','Diberi makan. Pajak',0),(49551,1377,'nl','Gevoed. Belasting',0),(49552,1377,'fi','KyllÃ¤stynyt. Vero',0),(49553,1377,'no','Matet. Skatt',0),(49554,1377,'da','Fodret. Skat',0),(49555,1377,'ko','ë¨¹ì¸ ë‹¤. ì„¸ê¸ˆ',0),(49556,1377,'he','× ×ž××¡. ×ž×¡',0),(49557,1377,'el','Î¤ÏÎ­Ï†Î¿Î½Ï„Î±Î¹. Î¦ÏŒÏÎ¿Ï…',0),(49558,1377,'zh','è”é‚¦ç¨Ž\r\n',0),(49559,1377,'sv','Matas. Skatt',0),(49560,1377,'it','Nutriti. Fiscale',0),(49561,1377,'tl','',0),(49562,1377,'th','&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;',0),(49563,1377,'hi','à¤¤à¤‚à¤— à¤† à¤—à¤¯à¤¾à¥¤ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(49564,1377,'ms','Diberi makan. Cukai',0),(49565,1377,'ar','Ø¨Ù†Ùƒ Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠ Ø§Ù„ÙÙŠØ¯Ø±Ø§Ù„ÙŠ. Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(49566,1377,'fr','Nourris. ImpÃ´t',0),(49567,1377,'jp','é€£é‚¦ç¨Ž',0),(49568,1377,'pt','Alimentados. Fiscal',0),(49569,1377,'ru','ÐšÐ¾Ñ€Ð¼Ð¸Ð»Ð¸. ÐÐ°Ð»Ð¾Ð³',0),(49570,1377,'es','Impuesto Federal',0),(49571,1377,'de','GefÃ¼ttert. Steuer',0),(49572,1377,'en','Fed. Tax',0),(49573,1378,'is','',0),(49574,1378,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ ',0),(49575,1378,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ ',0),(49576,1378,'tr','Fed. Vergi',0),(49577,1378,'pl','Karmione. Podatku',0),(49578,1378,'bg','Ð¥Ñ€Ð°Ð½ÐµÐ½Ð¸. Ð”Ð°Ð½ÑŠÐº',0),(49579,1378,'ur','Ú©Ú¾Ù„Ø§ÛŒØ§ Û” Ù¹ÛŒÚ©Ø³',0),(49580,1378,'sr','Ð”Ð¾ÑÑ‚Ð° Ð¼Ð¸ Ñ˜Ðµ. ÐŸÐ¾Ñ€ÐµÐ·',0),(49581,1378,'vi','Thuáº¿ LiÃªn bang',0),(49582,1378,'af','Gevoer. Belasting',0),(49583,1378,'ro','HrÄƒnite. Fiscale',0),(49584,1378,'et','SÃ¶Ã¶ta. Maks',0),(49585,1378,'si','Krmijo. DavÄne',0),(49586,1378,'ba','Diberi makan. Pajak',0),(49587,1378,'nl','Gevoed. Belasting',0),(49588,1378,'fi','KyllÃ¤stynyt. Vero',0),(49589,1378,'no','Matet. Skatt',0),(49590,1378,'da','Fodret. Skat',0),(49591,1378,'ko','ë¨¹ì¸ ë‹¤. ì„¸ê¸ˆ',0),(49592,1378,'he','× ×ž××¡. ×ž×¡',0),(49593,1378,'el','Î¤ÏÎ­Ï†Î¿Î½Ï„Î±Î¹. Î¦ÏŒÏÎ¿Ï…',0),(49594,1378,'zh','è”é‚¦ç¨Ž\r\n',0),(49595,1378,'sv','Matas. Skatt',0),(49596,1378,'it','Nutriti. Fiscale',0),(49597,1378,'tl','',0),(49598,1378,'th','&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;',0),(49599,1378,'hi','à¤¤à¤‚à¤— à¤† à¤—à¤¯à¤¾à¥¤ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(49600,1378,'ms','Diberi makan. Cukai',0),(49601,1378,'ar','Ø¨Ù†Ùƒ Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠ Ø§Ù„ÙÙŠØ¯Ø±Ø§Ù„ÙŠ. Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(49602,1378,'fr','Nourris. ImpÃ´t',0),(49603,1378,'jp','é€£é‚¦ç¨Ž',0),(49604,1378,'pt','Alimentados. Fiscal',0),(49605,1378,'ru','ÐšÐ¾Ñ€Ð¼Ð¸Ð»Ð¸. ÐÐ°Ð»Ð¾Ð³',0),(49606,1378,'es','Impuesto Federal',0),(49607,1378,'de','GefÃ¼ttert. Steuer',0),(49608,1378,'en','Fed. Tax',0),(49609,1379,'is','',0),(49610,1379,'dr','(Ø¯ÙˆÙ„ØªÙŠ ',0),(49611,1379,'pr','ÙØ¯Ø±Ø§Ù„ (Ø¯ÙˆÙ„ØªÙŠ ',0),(49612,1379,'tr','Federal',0),(49613,1379,'pl','Federalny',0),(49614,1379,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½',0),(49615,1379,'ur','ÙˆÙØ§Ù‚ÛŒ',0),(49616,1379,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸',0),(49617,1379,'vi','LiÃªn bang',0),(49618,1379,'af','Federale',0),(49619,1379,'ro','Federal',0),(49620,1379,'et','FÃ¶deraalne',0),(49621,1379,'si','Zvezni',0),(49622,1379,'ba','Federal',0),(49623,1379,'nl','Federaal',0),(49624,1379,'fi','Federal',0),(49625,1379,'no','Federal',0),(49626,1379,'da','Federal',0),(49627,1379,'ko','ì—°ë°©',0),(49628,1379,'he','×¤×“×¨×œ',0),(49629,1379,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ®',0),(49630,1379,'zh','è”é‚¦\r\n',0),(49631,1379,'sv','Federal',0),(49632,1379,'it','Federale',0),(49633,1379,'tl','',0),(49634,1379,'th','&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(49635,1379,'hi','à¤«à¥‡à¤¡à¤°à¤²',0),(49636,1379,'ms','Persekutuan',0),(49637,1379,'ar','Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(49638,1379,'fr','FÃ©dÃ©rale',0),(49639,1379,'jp','é€£é‚¦',0),(49640,1379,'pt','Federal',0),(49641,1379,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹',0),(49642,1379,'es','Federal',0),(49643,1379,'de','Federal',0),(49644,1379,'en','Federal',0),(49645,1380,'is','',0),(49646,1380,'dr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(49647,1380,'pr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(49648,1380,'tr','Federal muafiyetler',0),(49649,1380,'pl','Federalny zwolnieÅ„',0),(49650,1380,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð° Ð¸Ð·ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ',0),(49651,1380,'ur','ÙˆÙØ§Ù‚ÛŒ Ø§Ø³ØªØ«Ù†Ø§Ø¦ÛŒÚº',0),(49652,1380,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(49653,1380,'vi','Miá»…n trá»« LiÃªn bang',0),(49654,1380,'af','Federale vrystellings',0),(49655,1380,'ro','Federal scutiri',0),(49656,1380,'et','Saksamaa maksuvabastused',0),(49657,1380,'si','Zvezni izjeme',0),(49658,1380,'ba','Federal pengecualian',0),(49659,1380,'nl','Federale vrijstellingen',0),(49660,1380,'fi','Liittovaltion vapautukset',0),(49661,1380,'no','FÃ¸derale unntak',0),(49662,1380,'da','FÃ¸derale undtagelser',0),(49663,1380,'ko','ì—°ë°© ë©´ì œ',0),(49664,1380,'he','×¤×˜×•×¨×™× ×”×¤×“×¨×œ×™',0),(49665,1380,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® ÎµÎ¾Î±Î¹ÏÎ­ÏƒÎµÎ¹Ï‚',0),(49666,1380,'zh','è”é‚¦è±å…\r\n',0),(49667,1380,'sv','Federala undantag',0),(49668,1380,'it','Esenzioni federale',0),(49669,1380,'tl','',0),(49670,1380,'th','&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3586;&#3629;&#3591;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(49671,1380,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤®à¥‡à¤‚ à¤›à¥‚à¤Ÿ',0),(49672,1380,'ms','Pengecualian-pengecualian yang Persekutuan',0),(49673,1380,'ar','Ø§Ù„Ø¥Ø¹ÙØ§Ø¡Ø§Øª Ø§Ù„Ø¥ØªØ­Ø§Ø¯ÙŠØ©',0),(49674,1380,'fr','Exemptions fÃ©dÃ©rales',0),(49675,1380,'jp','é€£é‚¦æŽ§é™¤',0),(49676,1380,'pt','IsenÃ§Ãµes Federal',0),(49677,1380,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð»ÑŒÐ³Ð¾Ñ‚Ñ‹',0),(49678,1380,'es','Exenciones Federales',0),(49679,1380,'de','Bundesrepublik Ausnahmen',0),(49680,1380,'en','Federal Exemptions',0),(49681,1381,'is','',0),(49682,1381,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø¯ÙˆÙ„ØªÙŠ ',0),(49683,1381,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø¯ÙˆÙ„ØªÙŠ ',0),(49684,1381,'tr','Federal kimlik',0),(49685,1381,'pl','Federal ID',0),(49686,1381,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð˜Ð”',0),(49687,1381,'ur','ÙˆÙØ§Ù‚ÛŒ Ø´Ù†Ø§Ø®Øª',0),(49688,1381,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ðµ Ð˜Ð”',0),(49689,1381,'vi','ID LiÃªn bang',0),(49690,1381,'af','Federale ID',0),(49691,1381,'ro','Federal ID',0),(49692,1381,'et','Registrikood',0),(49693,1381,'si','Zvezni ID',0),(49694,1381,'ba','Federal ID',0),(49695,1381,'nl','Federal ID',0),(49696,1381,'fi','Liittovaltion tunnus',0),(49697,1381,'no','Federal ID',0),(49698,1381,'da','Federal ID',0),(49699,1381,'ko','ì—°ë°© ID',0),(49700,1381,'he','×ž×–×”×” ×”×¤×“×¨×œ×™',0),(49701,1381,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® ID',0),(49702,1381,'zh','è”é‚¦èº«ä»½è¯\r\n',0),(49703,1381,'sv','Federal ID',0),(49704,1381,'it','Federale ID',0),(49705,1381,'tl','',0),(49706,1381,'th','&#3619;&#3627;&#3633;&#3626;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(49707,1381,'hi','à¤«à¥‡à¤¡à¤°à¤² ID',0),(49708,1381,'ms','ID Persekutuan',0),(49709,1381,'ar','Ø§Ù„Ù…Ø¹Ø±Ù‘Ù Ø§Ù„Ø¥ØªØ­Ø§Ø¯ÙŠ',0),(49710,1381,'fr','FÃ©dÃ©rale ID',0),(49711,1381,'jp','é€£é‚¦ID',0),(49712,1381,'pt','Federal ID',0),(49713,1381,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÐºÐ¾Ð´',0),(49714,1381,'es','Federal ID',0),(49715,1381,'de','Federal-ID',0),(49716,1381,'en','Federal ID',0),(49717,1382,'is','',0),(49718,1382,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ø¯ÙˆÙ„ØªÙŠ ',0),(49719,1382,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ø¯ÙˆÙ„ØªÙŠ ',0),(49720,1382,'tr','Federal kimlik #',0),(49721,1382,'pl','Federal ID #',0),(49722,1382,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ ID #',0),(49723,1382,'ur','ÙˆÙØ§Ù‚ÛŒ Ø´Ù†Ø§Ø®Øª #',0),(49724,1382,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ðµ Ð˜Ð” #',0),(49725,1382,'vi','Sá»‘ ID LiÃªn bang',0),(49726,1382,'af','Federale ID #',0),(49727,1382,'ro','Federal ID #',0),(49728,1382,'et','Registrikood',0),(49729,1382,'si','Zvezni ID #',0),(49730,1382,'ba','Federal ID #',0),(49731,1382,'nl','Federal ID #',0),(49732,1382,'fi','Liittovaltion ID #',0),(49733,1382,'no','Federal ID-nummer',0),(49734,1382,'da','Federal ID #',0),(49735,1382,'ko','ì—°ë°© ID #',0),(49736,1382,'he','×”×¤×“×¨×œ×™ ×œ×–×”×•×ª #',0),(49737,1382,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® ID #',0),(49738,1382,'zh','è”é‚¦ç¼–å·ï¼š\r\n',0),(49739,1382,'sv','Federal ID #',0),(49740,1382,'it','Federale ID #',0),(49741,1382,'tl','',0),(49742,1382,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3619;&#3627;&#3633;&#3626;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(49743,1382,'hi','à¤«à¥‡à¤¡à¤°à¤² à¤†à¤ˆà¤¡à¥€ #',0),(49744,1382,'ms','Persekutuan ID #',0),(49745,1382,'ar','Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ù…Ø¹Ø±Ù #',0),(49746,1382,'fr','FÃ©dÃ©rale ID #',0),(49747,1382,'jp','é€£é‚¦ï¼©ï¼¤ç•ªå?·',0),(49748,1382,'pt','Federal ID #',0),(49749,1382,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ID #',0),(49750,1382,'es','Federal ID #',0),(49751,1382,'de','Federal ID #',0),(49752,1382,'en','Federal ID #',0),(49753,1383,'is','',0),(49754,1383,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ ',0),(49755,1383,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ ',0),(49756,1383,'tr','Federal gelir vergisi',0),(49757,1383,'pl','Federalnego podatku dochodowego',0),(49758,1383,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº Ð¾Ð±Ñ‰ Ð´Ð¾Ñ…Ð¾Ð´',0),(49759,1383,'ur','ÙˆÙØ§Ù‚ÛŒ Ø§Ù†Ú©Ù… Ù¹ÛŒÚ©Ø³',0),(49760,1383,'sr','Ð¡Ð°Ð²ÐµÐ·Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´',0),(49761,1383,'vi','Thuáº¿ thu nháº­p LiÃªn bang',0),(49762,1383,'af','Federale inkomstebelasting',0),(49763,1383,'ro','Federal impozitul pe venit',0),(49764,1383,'et','FÃ¶deraalse tulumaksu',0),(49765,1383,'si','Zveznega davka na dohodek',0),(49766,1383,'ba','Pajak pendapatan Federal',0),(49767,1383,'nl','Federale inkomstenbelasting',0),(49768,1383,'fi','Liittovaltion tuloveroa',0),(49769,1383,'no','FÃ¸derale inntektsskatt',0),(49770,1383,'da','FÃ¸derale indkomstskat',0),(49771,1383,'ko','ì—°ë°© ì†Œë“ì„¸',0),(49772,1383,'he','×ž×¡ ×”×›× ×¡×”',0),(49773,1383,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï… ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(49774,1383,'zh','è”é‚¦æ”¶å…¥ç¨Ž\r\n',0),(49775,1383,'sv','Federal inkomstskatt',0),(49776,1383,'it','Imposta federale sul reddito',0),(49777,1383,'tl','',0),(49778,1383,'th','&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(49779,1383,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤†à¤¯à¤•à¤°',0),(49780,1383,'ms','Cukai pendapatan Persekutuan',0),(49781,1383,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯Ø®Ù„ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(49782,1383,'fr','ImpÃ´t fÃ©dÃ©ral sur le revenu',0),(49783,1383,'jp','é€£é‚¦æ‰€å¾—ç¨Ž',0),(49784,1383,'pt','Imposto de renda federal',0),(49785,1383,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¿Ð¾Ð´Ð¾Ñ…Ð¾Ð´Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(49786,1383,'es','Impuesto Sobre la Renta Federal',0),(49787,1383,'de','Einkommenssteuer',0),(49788,1383,'en','Federal Income Tax',0),(49789,1384,'is','',0),(49790,1384,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(49791,1384,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(49792,1384,'tr','Federal gelir vergisi Ã¶denecek',0),(49793,1384,'pl','Federalnego podatku dochodowego pÅ‚atne',0),(49794,1384,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð´Ð¾Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(49795,1384,'ur','ÙˆÙØ§Ù‚ÛŒ Ø§Ù†Ú©Ù… Ù¹ÛŒÚ©Ø³ Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(49796,1384,'sr','ÐŸÐ»Ð°Ñ›Ð°Ñˆ ÑÐ°Ð²ÐµÐ·Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´',0),(49797,1384,'vi','Pháº£i Tráº£ Thuáº¿ Thu Nháº­p LiÃªn Bang',0),(49798,1384,'af','Federale inkomstebelasting betaalbaar',0),(49799,1384,'ro','Federal impozitul pe venit datorat',0),(49800,1384,'et','FÃ¶deraalse tulumaksu maksta',0),(49801,1384,'si','PlaÄa Zvezna dohodnini',0),(49802,1384,'ba','Hutang pajak pendapatan Federal',0),(49803,1384,'nl','Federale inkomstenbelasting te betalen',0),(49804,1384,'fi','Liittovaltion tuloveroa maksetaan',0),(49805,1384,'no','FÃ¸derale inntektsskatt betales',0),(49806,1384,'da','Forbundsrepublikken indkomstskatten skal betales',0),(49807,1384,'ko','ì—°ë°© ì†Œë“ì„¸ ì§€ë¶ˆ',0),(49808,1384,'he','×ž×¡ ×”×›× ×¡×” ×œ×ª×©×œ×•×',0),(49809,1384,'el','Î Î»Î·ÏÏ‰Ï„Î­Î¿Î¹ Î¿Î¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï… ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(49810,1384,'zh','åº”ç¼´è”é‚¦æ”¶å…¥ç¨Ž\r\n',0),(49811,1384,'sv','Federal inkomstskatt betalas',0),(49812,1384,'it','Imposta federale sul reddito pagabile',0),(49813,1384,'tl','',0),(49814,1384,'th','&#3592;&#3656;&#3634;&#3618;&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(49815,1384,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤†à¤¯à¤•à¤° à¤¦à¥‡à¤¯',0),(49816,1384,'ms','Persekutuan cukai yang perlu dibayar',0),(49817,1384,'ar','ØªØ¯ÙØ¹ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯Ø®Ù„ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(49818,1384,'fr','ImpÃ´t fÃ©dÃ©ral sur le revenu Ã  payer',0),(49819,1384,'jp','é€£é‚¦å¾´é›†æ‰€å¾—ç¨Ž',0),(49820,1384,'pt','Imposto de renda a pagar',0),(49821,1384,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð¿Ð¾Ð´Ð¾Ñ…Ð¾Ð´Ð½Ð¾Ð³Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(49822,1384,'es','Impuesto Sobre la Renta Federal Pagable',0),(49823,1384,'de','Einkommenssteuer zu zahlen',0),(49824,1384,'en','Federal Income Tax Payable',0),(49825,1385,'is','',0),(49826,1385,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ ',0),(49827,1385,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ ',0),(49828,1385,'tr','Federal vergi',0),(49829,1385,'pl','Federalnego podatku',0),(49830,1385,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº',0),(49831,1385,'ur','ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³',0),(49832,1385,'sr','Ð¡Ð°Ð²ÐµÐ·Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(49833,1385,'vi','Thuáº¿ LiÃªn bang',0),(49834,1385,'af','Federale belasting',0),(49835,1385,'ro','Impozitului federal',0),(49836,1385,'et','FÃ¶deraalse tulumaksu',0),(49837,1385,'si','Zvezni davek',0),(49838,1385,'ba','Pajak Federal',0),(49839,1385,'nl','Federale belasting',0),(49840,1385,'fi','Liittovaltion vero',0),(49841,1385,'no','FÃ¸deral skatt',0),(49842,1385,'da','Federal Tax',0),(49843,1385,'ko','ì—°ë°© ì„¸ê¸ˆ',0),(49844,1385,'he','×ž×¡ ×¤×“×¨×œ×™',0),(49845,1385,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÏŒÏ‚ Ï†ÏŒÏÎ¿Ï‚',0),(49846,1385,'zh','è”é‚¦ç¨Ž\r\n',0),(49847,1385,'sv','Federal skatt',0),(49848,1385,'it','Imposta federale',0),(49849,1385,'tl','',0),(49850,1385,'th','&#3616;&#3634;&#3625;&#3637;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(49851,1385,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(49852,1385,'ms','Cukai Persekutuan',0),(49853,1385,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(49854,1385,'fr','ImpÃ´t fÃ©dÃ©ral',0),(49855,1385,'jp','é€£é‚¦ç¨Ž',0),(49856,1385,'pt','Imposto federal',0),(49857,1385,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(49858,1385,'es','Impuesto Federal',0),(49859,1385,'de','Bundessteuer',0),(49860,1385,'en','Federal Tax',0),(49861,1386,'is','',0),(49862,1386,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ ',0),(49863,1386,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ ',0),(49864,1386,'tr','Federal vergi kimlik numarasÄ±',0),(49865,1386,'pl','Federalny NIP',0),(49866,1386,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸Ñ Ð´Ð°Ð½ÑŠÑ‡ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(49867,1386,'ur','ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³ Ø´Ù†Ø§Ø®Øª',0),(49868,1386,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð˜Ð”',0),(49869,1386,'vi','ID Thuáº¿ LiÃªn bang',0),(49870,1386,'af','Federale belasting ID',0),(49871,1386,'ro','ID-ul taxei federale',0),(49872,1386,'et','FÃ¶deraalse tulumaksu ID',0),(49873,1386,'si','Zvezni davek ID',0),(49874,1386,'ba','ID Pajak Federal',0),(49875,1386,'nl','Federale belasting ID',0),(49876,1386,'fi','Liittovaltion Verotunnusta',0),(49877,1386,'no','ID for fÃ¸deral skatt',0),(49878,1386,'da','Federal Tax ID',0),(49879,1386,'ko','ì—°ë°© ì„¸ ID',0),(49880,1386,'he','×–×™×”×•×™ ×ž×¡ ×¤×“×¨×œ×™',0),(49881,1386,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® Î‘Î¦Îœ',0),(49882,1386,'zh','è”é‚¦ç¨Žå·\r\n',0),(49883,1386,'sv','Federal Tax ID',0),(49884,1386,'it','Federal Tax ID',0),(49885,1386,'tl','',0),(49886,1386,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3616;&#3634;&#3625;&#3637;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(49887,1386,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤†à¤ˆà¤¡à¥€',0),(49888,1386,'ms','Persekutuan cukai ID',0),(49889,1386,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„ÙÙŠØ¯Ø±Ø§Ù„ÙŠØ©',0),(49890,1386,'fr','ID de l\'impÃ´t fÃ©dÃ©ral',0),(49891,1386,'jp','é€£é‚¦ç¨Žï¼©ï¼¤',0),(49892,1386,'pt','Federal Tax ID',0),(49893,1386,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½Ð½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(49894,1386,'es','Registro Federal de Contribuyente',0),(49895,1386,'de','Federal Tax ID',0),(49896,1386,'en','Federal Tax ID',0),(49897,1387,'is','',0),(49898,1387,'dr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ ',0),(49899,1387,'pr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ ',0),(49900,1387,'tr','Vergi yÃ¼zde',0),(49901,1387,'pl','Procent podatku federalnego',0),(49902,1387,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(49903,1387,'ur','ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³ ÙÛŒ ØµØ¯',0),(49904,1387,'sr','Ð¡Ð°Ð²ÐµÐ·Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð¿Ð¾ÑÑ‚Ð¾',0),(49905,1387,'vi','% Thuáº¿ LiÃªn bang',0),(49906,1387,'af','Federale belasting persent',0),(49907,1387,'ro','Impozitului federal la sutÄƒ',0),(49908,1387,'et','FÃ¶deraalse tulumaksu protsent',0),(49909,1387,'si','Zvezni davek odstotkov',0),(49910,1387,'ba','Persen pajak Federal',0),(49911,1387,'nl','Federal Tax procent',0),(49912,1387,'fi','Liittovaltion vero prosenttia',0),(49913,1387,'no','FÃ¸deral skatt prosent',0),(49914,1387,'da','Federal Tax procent',0),(49915,1387,'ko','ì—°ë°© ì„¸ê¸ˆì˜ %',0),(49916,1387,'he','××—×•×– ×ž×¡ ×¤×“×¨×œ×™',0),(49917,1387,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï„Î¿Ï… Î¿Î¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï…',0),(49918,1387,'zh','è”é‚¦ç¨Žæ”¶çš„ç™¾åˆ†æ¯”\r\n',0),(49919,1387,'sv','Federal skatt procent',0),(49920,1387,'it','Per cento di imposta federale',0),(49921,1387,'tl','',0),(49922,1387,'th','&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3586;&#3629;&#3591;&#3616;&#3634;&#3625;&#3637;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(49923,1387,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(49924,1387,'ms','Peratus cukai Persekutuan',0),(49925,1387,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(49926,1387,'fr','% De l\'impÃ´t fÃ©dÃ©ral',0),(49927,1387,'jp','é€£é‚¦ç¨ŽçŽ‡',0),(49928,1387,'pt','Por cento de imposto federal',0),(49929,1387,'ru','% Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(49930,1387,'es','Porcentaje de Impuesto Federal',0),(49931,1387,'de','Bundessteuer Prozent',0),(49932,1387,'en','Federal Tax Percent',0),(49933,1388,'is','',0),(49934,1388,'dr','Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(49935,1388,'pr','Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(49936,1388,'tr','Federal iÅŸsizlik sigortasÄ±',0),(49937,1388,'pl','Federalnego dla bezrobotnych',0),(49938,1388,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²ÐºÐ°',0),(49939,1388,'ur','ÙˆÙØ§Ù‚ÛŒ Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ø§Ù†Ø´ÙˆØ±Ù†Ø³',0),(49940,1388,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ ÑÐ¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐµ',0),(49941,1388,'vi','Báº£o hiá»ƒm tháº¥t nghiá»‡p LiÃªn bang',0),(49942,1388,'af','Federale werkloosheid versekering',0),(49943,1388,'ro','AsigurÄƒri de ÅŸomaj federale',0),(49944,1388,'et','FÃ¶deraalne tÃ¶Ã¶tuskindlustus',0),(49945,1388,'si','Zvezni brezposelnosti zavarovanja',0),(49946,1388,'ba','Asuransi pengangguran Federal',0),(49947,1388,'nl','Federale werkloosheidsverzekering',0),(49948,1388,'fi','Liittovaltion tyÃ¶ttÃ¶myysvakuutus',0),(49949,1388,'no','FÃ¸derale arbeidsledighet forsikring',0),(49950,1388,'da','FÃ¸derale arbejdslÃ¸shedsforsikring',0),(49951,1388,'ko','ì—°ë°© ì‹¤ì—… ë³´í—˜',0),(49952,1388,'he','×‘×™×˜×•×— ××‘×˜×œ×” ×¤×“×¨×œ×™',0),(49953,1388,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® Î±Î½ÎµÏÎ³Î¯Î±Ï‚',0),(49954,1388,'zh','è”é‚¦å¤±ä¸šä¿é™©\r\n',0),(49955,1388,'sv','Federala arbetslÃ¶shetsfÃ¶rsÃ¤kringen',0),(49956,1388,'it','Assicurazione contro la disoccupazione federale',0),(49957,1388,'tl','',0),(49958,1388,'th','&#3648;&#3610;&#3637;&#3657;&#3618;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3585;&#3634;&#3619;&#3623;&#3656;&#3634;&#3591;&#3591;&#3634;&#3609;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(49959,1388,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤¬à¥€à¤®à¤¾',0),(49960,1388,'ms','Insurans pengangguran Persekutuan',0),(49961,1388,'ar','Ø§Ù„ØªØ£Ù…ÙŠÙ† Ø¶Ø¯ Ø§Ù„Ø¨Ø·Ø§Ù„Ø© Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(49962,1388,'fr','Assurance-chÃ´mage fÃ©dÃ©rale',0),(49963,1388,'jp','é€£é‚¦å¤±æ¥­ä¿?é™º',0),(49964,1388,'pt','Seguro-desemprego Federal',0),(49965,1388,'ru','Ð¡Ñ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð½Ð° ÑÐ»ÑƒÑ‡Ð°Ð¹ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾',0),(49966,1388,'es','Seguro Federal de Desempleo',0),(49967,1388,'de','Bundesrepublik Arbeitslosenversicherung',0),(49968,1388,'en','Federal Unemployment Insurance',0),(49969,1389,'is','',0),(49970,1389,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(49971,1389,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(49972,1389,'tr','Federal iÅŸsizlik vergi',0),(49973,1389,'pl','Bezrobocie federalnego podatku',0),(49974,1389,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ð´Ð°Ð½ÑŠÐº',0),(49975,1389,'ur','Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ú©ÛŒ Ø´Ø±Ø­ ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³',0),(49976,1389,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(49977,1389,'vi','Thuáº¿ tháº¥t nghiá»‡p LiÃªn bang',0),(49978,1389,'af','Federale werkloosheid belasting',0),(49979,1389,'ro','Åžomaj federale fiscale',0),(49980,1389,'et','FÃ¶deraalne tÃ¶Ã¶tuskindlustusmakse',0),(49981,1389,'si','Zvezni brezposelnosti davka',0),(49982,1389,'ba','Pengangguran Federal pajak',0),(49983,1389,'nl','Federale werkloosheid belasting',0),(49984,1389,'fi','Federal tyÃ¶ttÃ¶myys vero',0),(49985,1389,'no','FÃ¸derale arbeidsledighet skatt',0),(49986,1389,'da','FÃ¸derale arbejdslÃ¸shed skat',0),(49987,1389,'ko','ì—°ë°© ì‹¤ì§ ì„¸ê¸ˆ',0),(49988,1389,'he','××‘×˜×œ×” ×¤×“×¨×œ×™ ×”×ž×¡',0),(49989,1389,'el','Î‘Î½ÎµÏÎ³Î¯Î±Ï‚ Î¿Î¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï…',0),(49990,1389,'zh','è”é‚¦å¤±ä¸šç¨Ž\r\n',0),(49991,1389,'sv','Federala arbetslÃ¶shet skatt',0),(49992,1389,'it','Disoccupazione federale fiscale',0),(49993,1389,'tl','',0),(49994,1389,'th','&#3616;&#3634;&#3625;&#3637;&#3585;&#3634;&#3619;&#3623;&#3656;&#3634;&#3591;&#3591;&#3634;&#3609;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(49995,1389,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(49996,1389,'ms','Cukai Persekutuan pengangguran',0),(49997,1389,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ù…Ù† Ø§Ù„Ø¨Ø·Ø§Ù„Ø©',0),(49998,1389,'fr','Cotisation d\'assurance fÃ©dÃ©rale',0),(49999,1389,'jp','é€£é‚¦å¤±æ¥­ç¨Ž',0),(50000,1389,'pt','Imposto federal de desemprego',0),(50001,1389,'ru','ÐÐ°Ð»Ð¾Ð³ Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹',0),(50002,1389,'es','Impuesto Federal de Desempleo',0),(50003,1389,'de','Bundesrepublik Arbeitslosigkeit Steuern',0),(50004,1389,'en','Federal Unemployment Tax',0),(50005,1390,'is','',0),(50006,1390,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(50007,1390,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(50008,1390,'tr','Federal iÅŸsizlik vergi gideri',0),(50009,1390,'pl','Bezrobocie federalnego podatku dochodowego',0),(50010,1390,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ð´Ð°Ð½ÑŠÑ‡ÐµÐ½ Ñ€Ð°Ð·Ñ…Ð¾Ð´',0),(50011,1390,'ur','Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ú©ÛŒ Ø´Ø±Ø­ ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³ Ø®Ø±Ú†Û’',0),(50012,1390,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð°',0),(50013,1390,'vi','Chi phÃ­ Thuáº¿ tháº¥t nghiá»‡p LiÃªn bang',0),(50014,1390,'af','Federale werkloosheid belasting uitgawe',0),(50015,1390,'ro','Cheltuieli de taxa FederalÄƒ de ÅŸomaj',0),(50016,1390,'et','FÃ¶deraal tÃ¶Ã¶tuse maksukulu',0),(50017,1390,'si','Odhodek za davek zvezni brezposelnosti',0),(50018,1390,'ba','Pengangguran Federal pajak biaya',0),(50019,1390,'nl','Federale werkloosheid belastinglasten',0),(50020,1390,'fi','Federal tyÃ¶ttÃ¶myys ALV-menot',0),(50021,1390,'no','FÃ¸derale arbeidsledighet skattekostnad',0),(50022,1390,'da','FÃ¸derale arbejdslÃ¸shed skatteudgifter',0),(50023,1390,'ko','ì—°ë°© ì‹¤ì§ ì„¸ê¸ˆ ë¹„ìš©',0),(50024,1390,'he','××‘×˜×œ×” ×¤×“×¨×œ×™ ×ž×¡ ×”×•×¦××•×ª',0),(50025,1390,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® Î±Î½ÎµÏÎ³Î¯Î±Ï‚ Ï„Î¿ Î­Î¾Î¿Î´Î¿ Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï…',0),(50026,1390,'zh','è”é‚¦å¤±ä¸šæ‰€å¾—ç¨Žè´¹ç”¨\r\n',0),(50027,1390,'sv','Federala arbetslÃ¶shet skattekostnad',0),(50028,1390,'it','Spese fiscali federali disoccupazione',0),(50029,1390,'tl','',0),(50030,1390,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3616;&#3634;&#3625;&#3637;&#3585;&#3634;&#3619;&#3623;&#3656;&#3634;&#3591;&#3591;&#3634;&#3609;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(50031,1390,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤µà¥à¤¯à¤¯',0),(50032,1390,'ms','Perbelanjaan cukai Persekutuan pengangguran',0),(50033,1390,'ar','Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ø§Ù„Ø¨Ø·Ø§Ù„Ø©',0),(50034,1390,'fr','Charge d\'impÃ´t de chÃ´mage fÃ©dÃ©rale',0),(50035,1390,'jp','é€£é‚¦å¤±æ¥­ç¨Žè²»ç”¨',0),(50036,1390,'pt','Despesa de imposto de desemprego Federal',0),(50037,1390,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ Ð¿Ð¾ Ð¿Ð¾Ð´Ð¾Ñ…Ð¾Ð´Ð½Ð¾Ð¼Ñƒ Ð½Ð°Ð»Ð¾Ð³Ñƒ',0),(50038,1390,'es','Gasto de Impuesto Federal de Desempleo',0),(50039,1390,'de','Bundesrepublik Arbeitslosigkeit Steueraufwand',0),(50040,1390,'en','Federal Unemployment Tax Expense',0),(50041,1391,'is','',0),(50042,1391,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(50043,1391,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(50044,1391,'tr','Federal iÅŸsizlik vergisi Ã¶denecek',0),(50045,1391,'pl','Bezrobocie federalnego podatku naleÅ¼nego',0),(50046,1391,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸Ñ Ð´Ð°Ð½ÑŠÐº',0),(50047,1391,'ur','Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ú©ÛŒ Ø´Ø±Ø­ ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³ Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(50048,1391,'sr','ÐŸÐ»Ð°Ñ›Ð°Ñˆ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¾Ð¼ Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚Ð¸',0),(50049,1391,'vi','Pháº£i Tráº£ Thuáº¿ Tháº¥t Nghiá»‡p LiÃªn Bang',0),(50050,1391,'af','Federale werkloosheid belasting betaalbaar',0),(50051,1391,'ro','Åžomaj federale impozitului datorat',0),(50052,1391,'et','FÃ¶deraal tÃ¶Ã¶tuse MaksuvÃµlad',0),(50053,1391,'si','Zvezni brezposelnosti davÄne obveznosti',0),(50054,1391,'ba','Pengangguran Federal pajak yang dibayar',0),(50055,1391,'nl','Federale werkloosheid belasting te betalen',0),(50056,1391,'fi','Federal tyÃ¶ttÃ¶myys maksettava vero',0),(50057,1391,'no','Betalbar skatt fÃ¸derale arbeidsledighet',0),(50058,1391,'da','FÃ¸derale arbejdslÃ¸shed skat',0),(50059,1391,'ko','ì—°ë°© ì‹¤ì§ ì„¸ê¸ˆ ì§€ê¸‰',0),(50060,1391,'he','××‘×˜×œ×” ×¤×“×¨×œ×™ ×”×ž×¡ ×œ×ª×©×œ×•×',0),(50061,1391,'el','ÎšÎ±Ï„Î±Î²Î»Î·Ï„Î­Î¿Ï‚ Ï†ÏŒÏÎ¿Ï‚ ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® Î±Î½ÎµÏÎ³Î¯Î±Ï‚',0),(50062,1391,'zh','åº”ç¼´è”é‚¦å¤±ä¸šç¨Ž\r\n',0),(50063,1391,'sv','Federala arbetslÃ¶shet skatt som skall betalas',0),(50064,1391,'it','Disoccupazione federale imposta da pagare',0),(50065,1391,'tl','',0),(50066,1391,'th','&#3592;&#3656;&#3634;&#3618;&#3616;&#3634;&#3625;&#3637;&#3585;&#3634;&#3619;&#3623;&#3656;&#3634;&#3591;&#3591;&#3634;&#3609;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(50067,1391,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¦à¥‡à¤¯',0),(50068,1391,'ms','Pengangguran Persekutuan cukai yang perlu dibayar',0),(50069,1391,'ar','Ø§Ù„Ø¨Ø·Ø§Ù„Ø© Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ø¶Ø±ÙŠØ¨Ø© Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(50070,1391,'fr','ChÃ´mage fÃ©dÃ©ral l\'impÃ´t Ã  payer',0),(50071,1391,'jp','é€£é‚¦å¤±æ¥­ç¨Žè²·æŽ›é‡‘',0),(50072,1391,'pt','Desemprego Federal imposto a pagar',0),(50073,1391,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(50074,1391,'es','Impuesto Federal de Desempleo Pagable',0),(50075,1391,'de','Bundesrepublik-Arbeitslosigkeit-Zahllast',0),(50076,1391,'en','Federal Unemployment Tax Payable',0),(50077,1392,'is','',0),(50078,1392,'dr','WH',0),(50079,1392,'pr',' Ø¯ÙˆÙ„ØªÙŠ WH',0),(50080,1392,'tr','Federal WH',0),(50081,1392,'pl','Federalny WH',0),(50082,1392,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ WH',0),(50083,1392,'ur','ÙˆÙØ§Ù‚ÛŒ ÙˆÛ',0),(50084,1392,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¨Ð¢',0),(50085,1392,'vi','Giá»¯ láº¡i cho LiÃªn bang',0),(50086,1392,'af','Federale WH',0),(50087,1392,'ro','Federal WH',0),(50088,1392,'et','Federal WH',0),(50089,1392,'si','Zvezni WH',0),(50090,1392,'ba','Federal WH',0),(50091,1392,'nl','Federale WH',0),(50092,1392,'fi','Liittovaltion WH',0),(50093,1392,'no','Federal WH',0),(50094,1392,'da','Federal WH',0),(50095,1392,'ko','ì—°ë°© WH',0),(50096,1392,'he','×”×¤×“×¨×œ×™ WH',0),(50097,1392,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® WH',0),(50098,1392,'zh','è”é‚¦ç“¦\r\n',0),(50099,1392,'sv','Federala WH',0),(50100,1392,'it','Federale WH',0),(50101,1392,'tl','',0),(50102,1392,'th','&#3619;&#3633;&#3600;&#3610;&#3634;&#3621; WH',0),(50103,1392,'hi','à¤«à¥‡à¤¡à¤°à¤² WH',0),(50104,1392,'ms','Persekutuan y',0),(50105,1392,'ar','Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ø°ÙˆÙŠ Ø§Ù„Ø®ÙˆØ°Ø§Øª Ø§Ù„Ø¨ÙŠØ¶Ø§Ø¡',0),(50106,1392,'fr','FÃ©dÃ©rale WH',0),(50107,1392,'jp','é€£é‚¦WH',0),(50108,1392,'pt','Federal WH',0),(50109,1392,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ WH',0),(50110,1392,'es','RetenciÃ³n Federal',0),(50111,1392,'de','Federal WH',0),(50112,1392,'en','Federal WH',0),(50113,1393,'is','',0),(50114,1393,'dr','Ø·ÙˆÙ„ Ø¨Ù‡  ÙÙˆØª ',0),(50115,1393,'pr','Ø·ÙˆÙ„ Ø¨Ù‡  ÙÙˆØª ',0),(50116,1393,'tr','Ayak uzunluÄŸu',0),(50117,1393,'pl','DÅ‚ugoÅ›Ä‡ stopy',0),(50118,1393,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð½Ð° Ð½Ð° ÐºÑ€Ð°ÐºÐ°Ñ‚Ð°',0),(50119,1393,'ur','ÙÙ¹ Ù„Ù…Ø¨Ø§Ø¦ÛŒ',0),(50120,1393,'sr','Ð”ÑƒÐ¶Ð¸Ð½Ð° ÑÑ‚Ð¾Ð¿Ð°Ð»Ð°',0),(50121,1393,'vi','Chiá»u dÃ i theo feet',0),(50122,1393,'af','Voete lengte',0),(50123,1393,'ro','Picioare lungime',0),(50124,1393,'et','Jala pikkus',0),(50125,1393,'si','DolÅ¾ina stopal',0),(50126,1393,'ba','Kaki panjang',0),(50127,1393,'nl','Voet lengte',0),(50128,1393,'fi','Jalkaa',0),(50129,1393,'no','FÃ¸tter lengde',0),(50130,1393,'da','FÃ¸dder lÃ¦ngde',0),(50131,1393,'ko','ë°œ ê¸¸ì´',0),(50132,1393,'he','×ž×˜×¨ ××•×¨×š',0),(50133,1393,'el','Î ÏŒÎ´Î¹Î± Î¼Î®ÎºÎ¿Ï‚',0),(50134,1393,'zh','è‹±å°ºé•¿\r\n',0),(50135,1393,'sv','FÃ¶tter lÃ¤ngd',0),(50136,1393,'it','Piedi di lunghezza',0),(50137,1393,'tl','',0),(50138,1393,'th','&#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623;&#3648;&#3607;&#3657;&#3634;',0),(50139,1393,'hi','à¤«à¥€à¤Ÿ à¤²à¤‚à¤¬à¤¾à¤ˆ',0),(50140,1393,'ms','Kaki panjang',0),(50141,1393,'ar','Ø·ÙˆÙ„ Ø§Ù„Ù‚Ø¯Ù…ÙŠÙ†',0),(50142,1393,'fr','Pieds de longueur',0),(50143,1393,'jp','Feet Length',0),(50144,1393,'pt','PÃ©s de comprimento',0),(50145,1393,'ru','Ð”Ð»Ð¸Ð½Ð° Ð½Ð¾Ð³Ð¸',0),(50146,1393,'es','Largo en Pies ',0),(50147,1393,'de','FuÃŸ LÃ¤nge',0),(50148,1393,'en','Feet Length',0),(50149,1394,'is','',0),(50150,1394,'dr','Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(50151,1394,'pr','Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(50152,1394,'tr','FICA',0),(50153,1394,'pl','FICA',0),(50154,1394,'bg','Ð“Ð•ÐžÐ Ð“Ð˜',0),(50155,1394,'ur','ÙØ§Ú©ÛŒ',0),(50156,1394,'sr','ÐžÐ”Ð Ð•Ð¡ÐšÐ£',0),(50157,1394,'vi','Luáº­t Báº£o Hiá»ƒm XÃ£ Há»™i Cá»§a LiÃªn Bang',0),(50158,1394,'af','FICA',0),(50159,1394,'ro','FICA',0),(50160,1394,'et','FICA',0),(50161,1394,'si','FICA',0),(50162,1394,'ba','FICA',0),(50163,1394,'nl','FICA',0),(50164,1394,'fi','FICA',0),(50165,1394,'no','FICA',0),(50166,1394,'da','FICA',0),(50167,1394,'ko','ê°€ ë´',0),(50168,1394,'he','×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™',0),(50169,1394,'el','Î£Î¥ÎœÎ’ÎŸÎ¥Î›Î‰',0),(50170,1394,'zh','è”é‚¦ä¿é™©æåŠ©æ¡ä¾‹\r\n',0),(50171,1394,'sv','FICA',0),(50172,1394,'it','FICA',0),(50173,1394,'tl','',0),(50174,1394,'th','&#3619;&#3632;&#3610;&#3610;&#3585;&#3629;&#3591;&#3607;&#3640;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;',0),(50175,1394,'hi','FICA',0),(50176,1394,'ms','FICA',0),(50177,1394,'ar','Ù…Ø­ÙƒÙ…ÙŠ',0),(50178,1394,'fr','FICA',0),(50179,1394,'jp','é€£é‚¦ä¿?é™ºå¯„ä¸Žæ³•',0),(50180,1394,'pt','FICA',0),(50181,1394,'ru','FICA',0),(50182,1394,'es','FICA',0),(50183,1394,'de','FICA',0),(50184,1394,'en','FICA',0),(50185,1395,'is','',0),(50186,1395,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ Ø´Ø±ÙƒØª',0),(50187,1395,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ Ø´Ø±ÙƒØª',0),(50188,1395,'tr','FICA ÅŸirket gideri',0),(50189,1395,'pl','Koszt firmy FICA',0),(50190,1395,'bg','FICA ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(50191,1395,'ur','ÙØ§Ú©ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø®Ø±Ú†Û’',0),(50192,1395,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° ÐžÐ”Ð Ð•Ð¡ÐšÐ£ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(50193,1395,'vi','Chi phÃ­ cá»§a Cty cho báº£o hiá»ƒm xÃ£ há»™i',0),(50194,1395,'af','FICA maatskappy uitgawe',0),(50195,1395,'ro','FICA compania cheltuieli',0),(50196,1395,'et','FICA firma kulul',0),(50197,1395,'si','FICA podjetje stroÅ¡ke',0),(50198,1395,'ba','Beban Perseroan FICA',0),(50199,1395,'nl','FICA bedrijf kosten',0),(50200,1395,'fi','FICA yrityksen kustannuksella',0),(50201,1395,'no','FICA selskapet bekostning',0),(50202,1395,'da','FICA selskabets regning',0),(50203,1395,'ko','ê°€ ë´ íšŒì‚¬ ë¹„ìš©',0),(50204,1395,'he','×”×•×¦××•×ª ×”×—×‘×¨×” ×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™',0),(50205,1395,'el','Î£Î¥ÎœÎ’ÎŸÎ¥Î›Î‰ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î´Î±Ï€Î¬Î½Î·',0),(50206,1395,'zh','è”é‚¦ä¿é™©æåŠ©æ¡ä¾‹å…¬å¸å¼€æ”¯\r\n',0),(50207,1395,'sv','FICA fÃ¶retag bekostnad',0),(50208,1395,'it','FICA azienda spese',0),(50209,1395,'tl','',0),(50210,1395,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3619;&#3632;&#3610;&#3610;&#3585;&#3629;&#3591;&#3607;&#3640;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3',0),(50211,1395,'hi','FICA à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¥à¤¯à¤¯',0),(50212,1395,'ms','Perbelanjaan Syarikat FICA',0),(50213,1395,'ar','Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø´Ø±ÙƒØ© Ù…Ø­ÙƒÙ…ÙŠ',0),(50214,1395,'fr','Frais de la sociÃ©tÃ© FICA',0),(50215,1395,'jp','é€£é‚¦ä¿?é™ºå¯„ä¸Žæ³•ä¼šç¤¾çµŒè²»',0),(50216,1395,'pt','Despesa da empresa FICA',0),(50217,1395,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ FICA ÑÑ‡ÐµÑ‚',0),(50218,1395,'es','FICA Gasto de Empresa',0),(50219,1395,'de','FICA Unternehmen Kosten',0),(50220,1395,'en','FICA Company Expense',0),(50221,1396,'is','',0),(50222,1396,'dr','Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(50223,1396,'pr','Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(50224,1396,'tr','FICA Ã¶denecek',0),(50225,1396,'pl','PÅ‚atne FICA',0),(50226,1396,'bg','FICA Ð¿Ð»Ð°Ñ‚Ð¸Ð¼Ð¸',0),(50227,1396,'ur','ÙØ§Ú©ÛŒ Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(50228,1396,'sr','ÐžÐ”Ð Ð•Ð¡ÐšÐ£ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(50229,1396,'vi','Báº£o hiá»ƒm xÃ£ há»™i Pháº£i Tráº£ ',0),(50230,1396,'af','FICA betaalbaar',0),(50231,1396,'ro','FICA de plÄƒtit',0),(50232,1396,'et','FICA makstav',0),(50233,1396,'si','FICA plaÄljive',0),(50234,1396,'ba','FICA hutang',0),(50235,1396,'nl','FICA te betalen',0),(50236,1396,'fi','FICA maksettava',0),(50237,1396,'no','FICA betales',0),(50238,1396,'da','FICA betales',0),(50239,1396,'ko','FICA ì§€ê¸‰',0),(50240,1396,'he','×–×›××™× ×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™',0),(50241,1396,'el','Î£Î¥ÎœÎ’ÎŸÎ¥Î›Î‰ Ï€Î»Î·ÏÏ‰Ï„Î­Î¿Î¹',0),(50242,1396,'zh','è”é‚¦ä¿é™©æåŠ©æ¡ä¾‹åº”ä»˜\r\n',0),(50243,1396,'sv','FICA betalas',0),(50244,1396,'it','Pagabile in FICA',0),(50245,1396,'tl','',0),(50246,1396,'th','&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3585;&#3629;&#3591;&#3607;&#3640;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;',0),(50247,1396,'hi','FICA à¤¦à¥‡à¤¯',0),(50248,1396,'ms','FICA yang perlu dibayar',0),(50249,1396,'ar','Ù…Ø­ÙƒÙ…ÙŠ Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(50250,1396,'fr','FICA Payable',0),(50251,1396,'jp','é€£é‚¦ä¿?é™ºå¯„ä¸Žæ³•è²·æŽ›é‡‘',0),(50252,1396,'pt','FICA a pagar',0),(50253,1396,'ru','FICA Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ',0),(50254,1396,'es','FICA Pagable',0),(50255,1396,'de','FICA zahlbar',0),(50256,1396,'en','FICA Payable',0),(50257,1397,'is','',0),(50258,1397,'dr','Ù…Ø§Ù„ÙŠØ§Øª  Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(50259,1397,'pr','Ù…Ø§Ù„ÙŠØ§Øª  Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(50260,1397,'tr','Vergi kesintisi',0),(50261,1397,'pl','Podatek FICA',0),(50262,1397,'bg','FICA Ð´Ð°Ð½ÑŠÐº',0),(50263,1397,'ur','ÙØ§Ú©ÛŒ Ù¹ÛŒÚ©Ø³',0),(50264,1397,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° ÐžÐ”Ð Ð•Ð¡ÐšÐ£',0),(50265,1397,'vi','Thuáº¿ báº£o hiá»ƒm xÃ£ há»™i',0),(50266,1397,'af','FICA belasting',0),(50267,1397,'ro','Taxe FICA',0),(50268,1397,'et','FICA maksu',0),(50269,1397,'si','FICA davka',0),(50270,1397,'ba','FICA pajak',0),(50271,1397,'nl','FICA belasting',0),(50272,1397,'fi','FICA vero',0),(50273,1397,'no','FICA skatt',0),(50274,1397,'da','FICA skat',0),(50275,1397,'ko','FICA ì„¸ê¸ˆ',0),(50276,1397,'he','×ž×¡ ×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™',0),(50277,1397,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Î£Î¥ÎœÎ’ÎŸÎ¥Î›Î‰',0),(50278,1397,'zh','è”é‚¦ä¿é™©æåŠ©æ¡ä¾‹ç¨Ž\r\n',0),(50279,1397,'sv','FICA skatt',0),(50280,1397,'it','Tassa di FICA',0),(50281,1397,'tl','',0),(50282,1397,'th','&#3616;&#3634;&#3625;&#3637;&#3585;&#3629;&#3591;&#3607;&#3640;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;',0),(50283,1397,'hi','FICA à¤Ÿà¥ˆà¤•à¥à¤¸',0),(50284,1397,'ms','FICA cukai',0),(50285,1397,'ar','Ù…Ø­ÙƒÙ…ÙŠ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(50286,1397,'fr','ImpÃ´t de FICA',0),(50287,1397,'jp','é€£é‚¦ä¿?é™ºå¯„ä¸Žæ³•ç¨Ž',0),(50288,1397,'pt','Imposto FICA',0),(50289,1397,'ru','Ð¡Ð¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(50290,1397,'es','FICA Impuesto',0),(50291,1397,'de','FICA Steuern',0),(50292,1397,'en','FICA Tax',0),(50293,1398,'is','',0),(50294,1398,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(50295,1398,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(50296,1398,'tr','FICA Ã¼cret',0),(50297,1398,'pl','PÅ‚ace FICA',0),(50298,1398,'bg','FICA Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(50299,1398,'ur','ÙØ§Ú©ÛŒ Ø§Ø¬Ø±Øª',0),(50300,1398,'sr','ÐžÐ´Ñ€ÐµÑÐºÑƒ Ð¿Ð»Ð°Ñ‚Ðµ',0),(50301,1398,'vi','LÆ°Æ¡ng báº£o hiá»ƒm xÃ£ há»™i',0),(50302,1398,'af','FICA lone',0),(50303,1398,'ro','Fica salariile',0),(50304,1398,'et','Fica palk',0),(50305,1398,'si','FICA plaÄe',0),(50306,1398,'ba','FICA upah',0),(50307,1398,'nl','Fica lonen',0),(50308,1398,'fi','Fica palkat',0),(50309,1398,'no','Fica lÃ¸nn',0),(50310,1398,'da','FICA lÃ¸n',0),(50311,1398,'ko','ê°€ ë´ ìž„ê¸ˆ',0),(50312,1398,'he','×—×•×‘×•×ª ×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™',0),(50313,1398,'el','Î£Ï…Î¼Î²Î¿Ï…Î»Î® Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(50314,1398,'zh','å¯Œé€šä¿é™©å·¥èµ„\r\n',0),(50315,1398,'sv','FICA lÃ¶ner',0),(50316,1398,'it','Fica salari',0),(50317,1398,'tl','',0),(50318,1398,'th','Fica Wages',0),(50319,1398,'hi','Fica à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(50320,1398,'ms','Fica upah',0),(50321,1398,'ar','Ø£Ø¬ÙˆØ± Ù…Ø­ÙƒÙ…ÙŠ',0),(50322,1398,'fr','FICA salaires',0),(50323,1398,'jp','é€£é‚¦ä¿?é™ºå¯„ä¸Žæ³•è³ƒé‡‘',0),(50324,1398,'pt','Fica salÃ¡rios',0),(50325,1398,'ru','FICA Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(50326,1398,'es','FICA Sueldos',0),(50327,1398,'de','FICA LÃ¶hne',0),(50328,1398,'en','Fica Wages',0),(50329,1399,'is','',0),(50330,1399,'dr','Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ\r\n WH',0),(50331,1399,'pr','Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ\r\n WH',0),(50332,1399,'tr','FICA WH',0),(50333,1399,'pl','FICA WH',0),(50334,1399,'bg','FICA WH',0),(50335,1399,'ur','ÙØ§Ú©ÛŒ ÙˆÛ',0),(50336,1399,'sr','ÐžÐ”Ð Ð•Ð¡ÐšÐ£ Ð¨Ð¢',0),(50337,1399,'vi','Giá»¯ báº£o hiá»ƒm xÃ£ há»™i do nhÃ¢n viÃªn Ä‘Ã³ng gÃ³p',0),(50338,1399,'af','FICA WH',0),(50339,1399,'ro','FICA WH',0),(50340,1399,'et','FICA WH',0),(50341,1399,'si','FICA WH',0),(50342,1399,'ba','FICA WH',0),(50343,1399,'nl','FICA WH',0),(50344,1399,'fi','FICA WH',0),(50345,1399,'no','FICA WH',0),(50346,1399,'da','FICA WH',0),(50347,1399,'ko','ê°€ ë´ WH',0),(50348,1399,'he','WH ×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™',0),(50349,1399,'el','Î£Î¥ÎœÎ’ÎŸÎ¥Î›Î‰ WH',0),(50350,1399,'zh','å¯Œé€šä¿é™©ç“¦\r\n',0),(50351,1399,'sv','FICA WH',0),(50352,1399,'it','FICA WH',0),(50353,1399,'tl','',0),(50354,1399,'th','FICA WH',0),(50355,1399,'hi','FICA à¤•',0),(50356,1399,'ms','FICA DIBERIK',0),(50357,1399,'ar','Ù…Ø­ÙƒÙ…ÙŠ Ø°ÙˆÙŠ Ø§Ù„Ø®ÙˆØ°Ø§Øª Ø§Ù„Ø¨ÙŠØ¶Ø§Ø¡',0),(50358,1399,'fr','FICA WH',0),(50359,1399,'jp','é€£é‚¦ä¿?é™ºå¯„ä¸Žæ³•ãƒ¯ãƒƒãƒˆã‚¢ãƒ¯ãƒ¼',0),(50360,1399,'pt','FICA WH',0),(50361,1399,'ru','FICA WH',0),(50362,1399,'es','FICA RetenciÃ³n',0),(50363,1399,'de','FICA WH',0),(50364,1399,'en','FICA WH',0),(50365,1400,'is','',0),(50366,1400,'dr','Ù¾Ø§Ù†Ø²Ø¯Ù‡ ',0),(50367,1400,'pr','Ù¾Ø§Ù†Ø²Ø¯Ù‡ ',0),(50368,1400,'tr','on beÅŸ',0),(50369,1400,'pl','piÄ™tnaÅ›cie',0),(50370,1400,'bg','Ð¿ÐµÑ‚Ð½Ð°Ð´ÐµÑÐµÑ‚',0),(50371,1400,'ur','Ù¾Ù†Ø¯Ø±Û',0),(50372,1400,'sr','ÐŸÐµÑ‚Ð½Ð°ÐµÑÑ‚',0),(50373,1400,'vi','mÆ°á»i lÄƒm',0),(50374,1400,'af','vyftien',0),(50375,1400,'ro','cincisprezece',0),(50376,1400,'et','viisteist',0),(50377,1400,'si','petnajst',0),(50378,1400,'ba','lima belas',0),(50379,1400,'nl','vijftien',0),(50380,1400,'fi','15',0),(50381,1400,'no','femten',0),(50382,1400,'da','femten',0),(50383,1400,'ko','15',0),(50384,1400,'he','×—×ž×© ×¢×©×¨×”',0),(50385,1400,'el','Î´ÎµÎºÎ±Ï€Î­Î½Ï„Îµ',0),(50386,1400,'zh','åäº”\r\n',0),(50387,1400,'sv','femton',0),(50388,1400,'it','quindici',0),(50389,1400,'tl','',0),(50390,1400,'th','&#3626;&#3636;&#3610;&#3627;&#3657;&#3634;',0),(50391,1400,'hi','à¤ªà¤‚à¤¦à¥à¤°à¤¹',0),(50392,1400,'ms','lima belas',0),(50393,1400,'ar','Ø®Ù…Ø³Ø© Ø¹Ø´Ø±Ø©',0),(50394,1400,'fr','quinze',0),(50395,1400,'jp','15',0),(50396,1400,'pt','quinze',0),(50397,1400,'ru','ÐŸÑÑ‚Ð½Ð°Ð´Ñ†Ð°Ñ‚ÑŒ',0),(50398,1400,'es','quince',0),(50399,1400,'de','fÃ¼nfzehn',0),(50400,1400,'en','fifteen',0),(50401,1401,'is','',0),(50402,1401,'dr','Ù¾Ù†Ø¬Ø§Ù‡ ',0),(50403,1401,'pr','Ù¾Ù†Ø¬Ø§Ù‡ ',0),(50404,1401,'tr','elli',0),(50405,1401,'pl','piÄ™Ä‡dziesiÄ…t',0),(50406,1401,'bg','Ð¿ÐµÑ‚Ð´ÐµÑÐµÑ‚',0),(50407,1401,'ur','Ù¾Ú†Ø§Ø³',0),(50408,1401,'sr','ÐŸÐµÐ´ÐµÑÐµÑ‚',0),(50409,1401,'vi','nÄƒm mÆ°Æ¡i',0),(50410,1401,'af','vyftig',0),(50411,1401,'ro','cincizeci',0),(50412,1401,'et','viiskÃ¼mmend',0),(50413,1401,'si','petdeset',0),(50414,1401,'ba','lima puluh',0),(50415,1401,'nl','vijftig',0),(50416,1401,'fi','viisikymmentÃ¤',0),(50417,1401,'no','femti',0),(50418,1401,'da','50',0),(50419,1401,'ko','50',0),(50420,1401,'he','×—×ž×™×©×™×',0),(50421,1401,'el','Ï€ÎµÎ½Î®Î½Ï„Î±',0),(50422,1401,'zh','äº”å\r\n',0),(50423,1401,'sv','femtio',0),(50424,1401,'it','cinquanta',0),(50425,1401,'tl','',0),(50426,1401,'th','&#3627;&#3657;&#3634;&#3626;&#3636;&#3610;',0),(50427,1401,'hi','à¤ªà¤šà¤¾à¤¸',0),(50428,1401,'ms','lima puluh',0),(50429,1401,'ar','Ø®Ù…Ø³ÙˆÙ†',0),(50430,1401,'fr','cinquante',0),(50431,1401,'jp','50',0),(50432,1401,'pt','CinqÃ¼enta',0),(50433,1401,'ru','Ð¿ÑÑ‚ÑŒÐ´ÐµÑÑÑ‚',0),(50434,1401,'es','cincuenta',0),(50435,1401,'de','fÃ¼nfzig',0),(50436,1401,'en','fifty',0),(50437,1402,'is','',0),(50438,1402,'dr','ÙØ§ÙŠÙ„ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ø§Ø² Ø´ÙˆØ¯ ',0),(50439,1402,'pr','ÙØ§ÙŠÙ„ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ø§Ø² Ø´ÙˆØ¯ ',0),(50440,1402,'tr','Dosya aÃ§Ä±lamadÄ±',0),(50441,1402,'pl','Nie moÅ¼na otworzyÄ‡ pliku',0),(50442,1402,'bg','Ð¤Ð°Ð¹Ð»ÑŠÑ‚ Ð½Ðµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(50443,1402,'ur','Ù…Ø³Ù„ Ù†ÛÛŒÚº Ú©Ú¾ÙˆÙ„ÛŒ Ø¬Ø§ Ø³Ú©ÛŒ',0),(50444,1402,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(50445,1402,'vi','KhÃ´ng má»Ÿ Ä‘Æ°á»£c Há»“ sÆ¡',0),(50446,1402,'af','LÃªers Wat Nie Opgemaak kon Word nie',0),(50447,1402,'ro','Imposibil de deschis fiÈ™ierul',0),(50448,1402,'et','Faili ei saanud avada',0),(50449,1402,'si','Datoteke ni mogoÄe odpreti',0),(50450,1402,'ba','File tidak bisa dibuka',0),(50451,1402,'nl','Bestand kan niet worden geopend',0),(50452,1402,'fi','Tiedostoa ei voi avata',0),(50453,1402,'no','Filen kan ikke Ã¥pnes',0),(50454,1402,'da','Filen kunne ikke Ã¥bnes',0),(50455,1402,'ko','íŒŒì¼ì„ ì—´ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(50456,1402,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×¤×ª×•×— ××ª ×”×§×•×‘×¥',0),(50457,1402,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Î´ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î±Î½Î¿Î¯Î¾ÎµÎ¹',0),(50458,1402,'zh','æ–‡ä»¶æ— æ³•è¢«æ‰“å¼€\r\n',0),(50459,1402,'sv','Filen kunde inte Ã¶ppnas',0),(50460,1402,'it','File non puÃ² essere aperto',0),(50461,1402,'tl','',0),(50462,1402,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3611;&#3636;&#3604;&#3652;&#3615;&#3621;&#3660;&#3652;&#3604;&#3657;',0),(50463,1402,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¥‹à¤²à¥€ à¤œà¤¾ à¤¸à¤•à¥€',0),(50464,1402,'ms','Fail tidak dapat dibuka',0),(50465,1402,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ÙØªØ­ Ø§Ù„Ù…Ù„ÙÙ‘',0),(50466,1402,'fr','Fichier n\'a pas pu Ãªtre ouvert',0),(50467,1402,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?Œé–‹ã?‘ã?¾ã?›ã‚“',0),(50468,1402,'pt','Arquivo nÃ£o pÃ´de ser aberto.',0),(50469,1402,'ru','Ð¤Ð°Ð¹Ð» ÐÐµ ÐœÐ¾Ð¶ÐµÑ‚ Ð‘Ñ‹Ñ‚ÑŒ ÐžÑ‚ÐºÑ€Ñ‹Ñ‚',0),(50470,1402,'es','File No Se PodÃ­a Abrir',0),(50471,1402,'de','Datei konnte nicht geÃ¶ffnet werden',0),(50472,1402,'en','File Could Not Be Opened',0),(50473,1403,'is','',0),(50474,1403,'dr','ÙØ§ÙŠÙ„ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(50475,1403,'pr','ÙØ§ÙŠÙ„ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(50476,1403,'tr','Dosya boÅŸ olmamalÄ±dÄ±r.',0),(50477,1403,'pl','Plik nie moÅ¼e byÄ‡ pusta.',0),(50478,1403,'bg','Ð¤Ð°Ð¹Ð»ÑŠÑ‚ Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ð¿Ñ€Ð°Ð·ÐµÐ½.',0),(50479,1403,'ur','Ù…Ø³Ù„ Ø®Ø§Ù„ÛŒ Ù†ÛÛŒÚº ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒØ¦Û’ Û”',0),(50480,1403,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð°Ð·Ð°Ð½.',0),(50481,1403,'vi','Há»“ sÆ¡ khÃ´ng thá»ƒ trá»‘ng',0),(50482,1403,'af','LÃªer moet nie leeg wees nie.',0),(50483,1403,'ro','FiÅŸier nu trebuie sÄƒ fie gol.',0),(50484,1403,'et','Fail ei tohi olla tÃ¼hi.',0),(50485,1403,'si','Datoteka ne sme biti prazen.',0),(50486,1403,'ba','File tidak boleh kosong.',0),(50487,1403,'nl','Bestand moet niet leeg zijn.',0),(50488,1403,'fi','Tiedoston on oltava tyhjÃ¤.',0),(50489,1403,'no','Filen mÃ¥ ikke vÃ¦re tomt.',0),(50490,1403,'da','Filen mÃ¥ ikke vÃ¦re tom.',0),(50491,1403,'ko','íŒŒì¼ì— ë¹ˆ ë˜ì§€ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(50492,1403,'he','×”×§×•×‘×¥ ××™× ×• ×™×›×•×œ ×œ×”×™×•×ª ×¨×™×§.',0),(50493,1403,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Î´ÎµÎ½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ½ÏŒ.',0),(50494,1403,'zh','æ–‡ä»¶ä¸èƒ½ä¸ºç©ºã€‚\r\n',0),(50495,1403,'sv','Filen fÃ¥r inte vara tom.',0),(50496,1403,'it','File non deve essere vuota.',0),(50497,1403,'tl','',0),(50498,1403,'th','&#3652;&#3615;&#3621;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3605;&#3657;&#3629;&#3591;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3591;&#3648;&#3611;&#3621;&#3656;&#3634;',0),(50499,1403,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤–à¤¾à¤²à¥€ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(50500,1403,'ms','Fail tidak boleh kosong.',0),(50501,1403,'ar','ÙŠØ¬Ø¨ Ø£Ù† Ù„Ø§ ÙŠÙƒÙˆÙ† Ø§Ù„Ù…Ù„ÙÙ‘ Ø®Ø§Ù„ÙŠØ§',0),(50502,1403,'fr','Fichier ne doit pas Ãªtre vide.',0),(50503,1403,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?Œç©ºã?§ã?™',0),(50504,1403,'pt','Arquivo nÃ£o deve ser vazio.',0),(50505,1403,'ru','Ð¤Ð°Ð¹Ð» Ð½Ðµ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð¿ÑƒÑÑ‚Ð¾Ð¹.',0),(50506,1403,'es','File no debe ser vacÃ­o',0),(50507,1403,'de','Datei darf nicht leer sein.',0),(50508,1403,'en','File must not be empty.',0),(50509,1404,'is','',0),(50510,1404,'dr','ÙØ§ÙŠÙ„ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(50511,1404,'pr','ÙØ§ÙŠÙ„ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(50512,1404,'tr','Dosya bulunamadÄ±.',0),(50513,1404,'pl','Nie znaleziono pliku.',0),(50514,1404,'bg','Ð¤Ð°Ð¹Ð»ÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(50515,1404,'ur','Ù…Ø³Ù„ Ù†ÛÛŒÚº Ù…Ù„ÛŒ Û”',0),(50516,1404,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°.',0),(50517,1404,'vi','KhÃ´ng tháº¥y Há»“ sÆ¡',0),(50518,1404,'af','LÃªer nie gevind.',0),(50519,1404,'ro','FiÈ™ier negÄƒsit.',0),(50520,1404,'et','Faili ei leitud',0),(50521,1404,'si','Datoteke ni mogoÄe najti.',0),(50522,1404,'ba','File tidak ditemukan.',0),(50523,1404,'nl','Bestand niet gevonden.',0),(50524,1404,'fi','Tiedostoa ei lÃ¶ydy.',0),(50525,1404,'no','Finner ikke filen.',0),(50526,1404,'da','Filen blev ikke fundet.',0),(50527,1404,'ko','íŒŒì¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(50528,1404,'he','.×”×§×•×‘×¥ ×œ× × ×ž×¦×',0),(50529,1404,'el','Î¤Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(50530,1404,'zh','æ–‡ä»¶æœªæ‰¾åˆ°ã€‚\r\n',0),(50531,1404,'sv','Filen hittades inte.',0),(50532,1404,'it','File non trovato.',0),(50533,1404,'tl','',0),(50534,1404,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3649;&#3615;&#3657;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(50535,1404,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€à¥¤',0),(50536,1404,'ms','Fail tidak dijumpai.',0),(50537,1404,'ar','Ø§Ù„Ù…Ù„Ù ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(50538,1404,'fr','Fichier non trouvÃ©.',0),(50539,1404,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(50540,1404,'pt','Arquivo nÃ£o encontrado.',0),(50541,1404,'ru','Ð¤Ð°Ð¹Ð» Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(50542,1404,'es','File no se encontrÃ³',0),(50543,1404,'de','Datei nicht gefunden.',0),(50544,1404,'en','File not found.',0),(50545,1405,'is','',0),(50546,1405,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙØ§ÙŠÙ„ ',0),(50547,1405,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙØ§ÙŠÙ„ ',0),(50548,1405,'tr','Dosya boyutu',0),(50549,1405,'pl','Rozmiar pliku',0),(50550,1405,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð°',0),(50551,1405,'ur','ÙØ§Ø¦Ù„ Ú©Ø§ Ø³Ø§Ø¦Ø²',0),(50552,1405,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(50553,1405,'vi','Cá»¡ Há»“ sÆ¡',0),(50554,1405,'af','LÃªergrootte',0),(50555,1405,'ro','Dimensiune fiÅŸier',0),(50556,1405,'et','Faili suurus',0),(50557,1405,'si','Velikost datoteke',0),(50558,1405,'ba','Ukuran file',0),(50559,1405,'nl','Bestandsgrootte',0),(50560,1405,'fi','Tiedostokoko',0),(50561,1405,'no','FilstÃ¸rrelse',0),(50562,1405,'da','FilstÃ¸rrelse',0),(50563,1405,'ko','íŒŒì¼ í¬ê¸°',0),(50564,1405,'he','×’×•×“×œ ×”×§×•×‘×¥',0),(50565,1405,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(50566,1405,'zh','æ–‡ä»¶å¤§å°\r\n',0),(50567,1405,'sv','Filstorlek',0),(50568,1405,'it','Dimensione del file',0),(50569,1405,'tl','',0),(50570,1405,'th','&#3586;&#3609;&#3634;&#3604;&#3649;&#3615;&#3657;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(50571,1405,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(50572,1405,'ms','Saiz fail',0),(50573,1405,'ar','Ø­Ø¬Ù… Ø§Ù„Ù…Ù„Ù',0),(50574,1405,'fr','Taille du fichier',0),(50575,1405,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‚µã‚¤ã‚º',0),(50576,1405,'pt','Tamanho do arquivo',0),(50577,1405,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ñ„Ð°Ð¹Ð»Ð°',0),(50578,1405,'es','TamaÃ±o de File',0),(50579,1405,'de','GrÃ¶ÃŸe der Datei',0),(50580,1405,'en','File size',0),(50581,1406,'is','',0),(50582,1406,'dr','ÙÙ‚Ø· Ø§Ø³Ø§Ù…ÙŠ ÙØ§ÙŠÙ„ ',0),(50583,1406,'pr','ÙÙ‚Ø· Ø§Ø³Ø§Ù…ÙŠ ÙØ§ÙŠÙ„ ',0),(50584,1406,'tr','YalnÄ±zca dosya adlarÄ±',0),(50585,1406,'pl','Tylko w nazwach plikÃ³w',0),(50586,1406,'bg','Ð¡Ð°Ð¼Ð¾ Ð¸Ð¼ÐµÐ½Ð° Ð½Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(50587,1406,'ur','ÙÙ„Ø§Ù†Ø§Ù…Ø§Ø³ ØµØ±Ù',0),(50588,1406,'sr','Ð¡Ð°Ð¼Ð¾ Ð¸Ð¼ÐµÐ½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(50589,1406,'vi','Chá»‰ tÃªn Há»“ sÆ¡',0),(50590,1406,'af','Slegs LÃªername',0),(50591,1406,'ro','Nume de fiÅŸiere numai',0),(50592,1406,'et','Ainult failinimesid',0),(50593,1406,'si','Le imena datotek',0),(50594,1406,'ba','Nama file hanya',0),(50595,1406,'nl','Alleen bestandsnamen',0),(50596,1406,'fi','Vain tiedostonimiÃ¤',0),(50597,1406,'no','Filnavn bare',0),(50598,1406,'da','Filnavne kun',0),(50599,1406,'ko','íŒŒì¼ëª…ë§Œ',0),(50600,1406,'he','×©×ž×•×ª ×§×‘×¦×™× ×‘×œ×‘×“',0),(50601,1406,'el','ÎŸÎ½ÏŒÎ¼Î±Ï„Î± Î±ÏÏ‡ÎµÎ¯Ï‰Î½ Î¼ÏŒÎ½Î¿',0),(50602,1406,'zh','åªæ–‡ä»¶å\r\n',0),(50603,1406,'sv','Filnamnen bara',0),(50604,1406,'it','Solo nomi di file',0),(50605,1406,'tl','',0),(50606,1406,'th','&#3594;&#3639;&#3656;&#3629;&#3652;&#3615;&#3621;&#3660;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(50607,1406,'hi','à¤•à¥‡à¤µà¤² Filenames',0),(50608,1406,'ms','Nama fail sahaja',0),(50609,1406,'ar','Ø£Ø³Ù…Ø§Ø¡ Ø§Ù„Ù…Ù„ÙØ§Øª ÙÙ‚Ø·',0),(50610,1406,'fr','Noms de fichiers uniquement',0),(50611,1406,'jp','ãƒ•ã‚¡ã‚¤ãƒ«å??ã?®ã?¿',0),(50612,1406,'pt','Nomes de arquivos somente',0),(50613,1406,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¸Ð¼Ñ Ñ„Ð°Ð¹Ð»Ð°',0),(50614,1406,'es','Nombres de Archivos solamente',0),(50615,1406,'de','Nur Dateinamen',0),(50616,1406,'en','Filenames only',0),(50617,1407,'is','',0),(50618,1407,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ Ø­Ø°Ù Ø´Ø¯Ù†Ø¯ ',0),(50619,1407,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ Ø­Ø°Ù Ø´Ø¯Ù†Ø¯ ',0),(50620,1407,'tr','kaldÄ±rÄ±lan dosya',0),(50621,1407,'pl','Pliki usuniÄ™te',0),(50622,1407,'bg','Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸',0),(50623,1407,'ur','Ù…Ø³Ù„ÛŒÚº ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(50624,1407,'sr','Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ñ˜Ðµ ÑƒÐºÐ»Ð¾ÑšÐµÐ½Ð°',0),(50625,1407,'vi','Há»“ sÆ¡ Ä‘Ã£ bá»',0),(50626,1407,'af','lÃªers verwyder',0),(50627,1407,'ro','fiÅŸierele eliminate',0),(50628,1407,'et','files eemaldatav',0),(50629,1407,'si','files daljni',0),(50630,1407,'ba','file yang dihapus',0),(50631,1407,'nl','bestanden zijn verwijderd',0),(50632,1407,'fi','tiedostot poistettu',0),(50633,1407,'no','filer fjernet',0),(50634,1407,'da','filer fjernet',0),(50635,1407,'ko','íŒŒì¼ ì œê±°',0),(50636,1407,'he','×”×§×‘×¦×™× ×™×•×¡×¨×•',0),(50637,1407,'el','Î±ÏÏ‡ÎµÎ¯Ï‰Î½ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎºÎ±Ï„Î±ÏÎ³Î·Î¸ÎµÎ¯',0),(50638,1407,'zh','æ–‡ä»¶ç§»é™¤\r\n',0),(50639,1407,'sv','filer tas bort',0),(50640,1407,'it','file rimossi',0),(50641,1407,'tl','',0),(50642,1407,'th','&#3652;&#3615;&#3621;&#3660;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3618;&#3657;&#3634;&#3618;&#3652;&#3611;&#3649;&#3621;&#3657;&#3623;',0),(50643,1407,'hi','à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤¨à¤¿à¤•à¤¾à¤²à¥€',0),(50644,1407,'ms','fail-fail yang dihapuskan',0),(50645,1407,'ar','Ø¥Ø²Ø§Ù„Ø© Ø§Ù„Ù…Ù„ÙØ§Øª',0),(50646,1407,'fr','fichiers supprimÃ©s',0),(50647,1407,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(50648,1407,'pt','arquivos removidos',0),(50649,1407,'ru','Ñ„Ð°Ð¹Ð»Ñ‹ Ð¿ÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ñ‹',0),(50650,1407,'es','Files eliminados',0),(50651,1407,'de','Dateien entfernt',0),(50652,1407,'en','files removed',0),(50653,1408,'is','',0),(50654,1408,'dr','Ø¢Ù…Ø§Ø¯Ù‡ Ø³Ø§Ø²ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(50655,1408,'pr','Ø¢Ù…Ø§Ø¯Ù‡ Ø³Ø§Ø²ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(50656,1408,'tr','Dolgu tamamlandÄ±',0),(50657,1408,'pl','WypeÅ‚nienie zakoÅ„czone',0),(50658,1408,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½',0),(50659,1408,'ur','Ù…Ú©Ù…Ù„ Ø¨Ú¾Ø±ÛŒÚº',0),(50660,1408,'sr','ÐŸÐ¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð°',0),(50661,1408,'vi','Äiá»n hoÃ n táº¥t',0),(50662,1408,'af','Vul voltooi',0),(50663,1408,'ro','Umple completat',0),(50664,1408,'et','TÃ¤itmine lÃµpetatud',0),(50665,1408,'si','Polnila, ki so zakljuÄili',0),(50666,1408,'ba','Mengisi selesai',0),(50667,1408,'nl','Opvulling voltooid',0),(50668,1408,'fi','TÃ¤ytÃ¤ valmiiksi',0),(50669,1408,'no','Fyll fullfÃ¸rt',0),(50670,1408,'da','Fyld afsluttet',0),(50671,1408,'ko','ì±„ìš°ê¸° ì™„ë£Œ',0),(50672,1408,'he','×ž×™×œ×•×™ ×”×•×©×œ×ž×”',0),(50673,1408,'el','Î“Î­Î¼Î¹ÏƒÎ¼Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(50674,1408,'zh','å¡«å†™å®Œæˆ\r\n',0),(50675,1408,'sv','Fyll avslutade',0),(50676,1408,'it','Riempimento completato',0),(50677,1408,'tl','',0),(50678,1408,'th','&#3585;&#3634;&#3619;&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(50679,1408,'hi','à¤ªà¥‚à¤°à¤¾ à¤­à¤°à¥‡à¤‚',0),(50680,1408,'ms','Mengisi lengkap',0),(50681,1408,'ar','Ù…Ù„Ø¡ Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø©',0),(50682,1408,'fr','Remplissage terminÃ©',0),(50683,1408,'jp','è¨˜å…¥ã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(50684,1408,'pt','Preenchimento concluÃ­do',0),(50685,1408,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¾',0),(50686,1408,'es','Llenar Completado',0),(50687,1408,'de','FÃ¼llung abgeschlossen',0),(50688,1408,'en','Fill Completed',0),(50689,1409,'is','',0),(50690,1409,'dr','Ù¾Ø± ÙƒØ±Ø¯Ù† ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ ',0),(50691,1409,'pr','Ù¾Ø± ÙƒØ±Ø¯Ù† ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ ',0),(50692,1409,'tr','Arama alanlarÄ± doldurun',0),(50693,1409,'pl','WypeÅ‚nij pola wyszukiwania',0),(50694,1409,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ Ð¿Ð¾Ð»ÐµÑ‚Ð°Ñ‚Ð° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(50695,1409,'ur','ØªÙ„Ø§Ø´ Ú©Û’ Ù„ÛŒÛ’ Ù‚Ø·Ø¹Ø§Øª Ø¨Ú¾Ø±ÛŒÚº',0),(50696,1409,'sr','ÐŸÐ¾Ð¿ÑƒÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ™Ð° Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(50697,1409,'vi','Äiá»n vÃ o trÆ°á»ng tÃ¬m kiáº¿m',0),(50698,1409,'af','Voer velde in vir soektog',0),(50699,1409,'ro','CompletaÅ£i cÃ¢mpurile de cÄƒutare',0),(50700,1409,'et','TÃ¤itke vÃ¤ljad otsing',0),(50701,1409,'si','Izpolnite polja za iskanje',0),(50702,1409,'ba','Mengisi kolom untuk pencarian',0),(50703,1409,'nl','Vul in de velden voor zoeken',0),(50704,1409,'fi','TÃ¤ytÃ¤ kentÃ¤t haku',0),(50705,1409,'no','Fyll ut feltene for sÃ¸k',0),(50706,1409,'da','Udfyld felterne for sÃ¸gning',0),(50707,1409,'ko','ê²€ìƒ‰ í•„ë“œì—ì„œ ì±„ìš°ê¸°',0),(50708,1409,'he','×ž×œ××• ××ª ×”×©×“×•×ª ×¢×‘×•×¨ ×—×™×¤×•×©',0),(50709,1409,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏŽÏƒÏ„Îµ Ï„Î± Ï€ÎµÎ´Î¯Î± Î³Î¹Î± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(50710,1409,'zh','å¡«å†™å­—æ®µä»¥æœç´¢\r\n',0),(50711,1409,'sv','Fyll i fÃ¤lten fÃ¶r sÃ¶kning',0),(50712,1409,'it','Compila i campi per la ricerca',0),(50713,1409,'tl','',0),(50714,1409,'th','&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3609;&#3594;&#3656;&#3629;&#3591;&#3623;&#3656;&#3634;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3588;&#3657;&#3609;&#3627;&#3634;',0),(50715,1409,'hi','à¤–à¥‹à¤œ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‡à¤¤à¥‹à¤‚ à¤®à¥‡à¤‚ à¤­à¤°à¥‡à¤‚',0),(50716,1409,'ms','Isikan medan untuk carian',0),(50717,1409,'ar','ØªØ¹Ø¨Ø¦Ø© Ø§Ù„Ø­Ù‚ÙˆÙ„ Ù„Ù„Ø¨Ø­Ø«',0),(50718,1409,'fr','Renseignez les champs de recherche',0),(50719,1409,'jp','æ¤œç´¢æƒ…å ±ã‚’è¨˜å…¥',0),(50720,1409,'pt','Preencher campos para pesquisa',0),(50721,1409,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð»Ñ Ð´Ð»Ñ Ð¿Ð¾Ð¸ÑÐºÐ°',0),(50722,1409,'es','Llenar los campos para la bÃºsqueda',0),(50723,1409,'de','FÃ¼llen Sie die Felder fÃ¼r die Suche',0),(50724,1409,'en','Fill in fields for search',0),(50725,1410,'is','',0),(50726,1410,'dr','/ Ù¾Ø§ÙŠØ§Ù† ',0),(50727,1410,'pr','Ø¢Ù…Ø§Ø¯Ù‡ Ø³Ø§Ø²ÙŠ Ø³ÙØ§Ø±Ø´  Ø´Ø±ÙˆØ¹  / Ù¾Ø§ÙŠØ§Ù† ',0),(50728,1410,'tr','SipariÅŸ Start/Stop doldurun',0),(50729,1410,'pl','WypeÅ‚nienie zamÃ³wienia Start/Stop',0),(50730,1410,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ Ñ€ÐµÐ´ ÑÑ‚Ð°Ñ€Ñ‚/ÑÑ‚Ð¾Ð¿',0),(50731,1410,'ur','ØªØ±ØªÛŒØ¨ Ø´Ø±ÙˆØ¹/Ø±ÙˆÚ©ÛŒÚº Ø¨Ú¾Ø±ÛŒÚº',0),(50732,1410,'sr','ÐŸÐ¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ð¾ÐºÑ€ÐµÑ‚Ð°ÑšÐµ/Ð·Ð°ÑƒÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ',0),(50733,1410,'vi','Báº¯t Ä‘áº§u/táº¡m ngÆ°ng Ä‘iá»n ÄÆ¡n Ä‘áº·t hÃ ng',0),(50734,1410,'af','Vul orde begin/Stop',0),(50735,1410,'ro','CompletaÅ£i comanda pornirea/oprirea',0),(50736,1410,'et','Tellimuse tÃ¤itmise alustamine ja lÃµpetamine',0),(50737,1410,'si','Izpolnite nalog Start/Stop',0),(50738,1410,'ba','Mengisi pesanan Start/Stop',0),(50739,1410,'nl','Vul de Order Start/Stop',0),(50740,1410,'fi','TÃ¤ytÃ¤ jÃ¤rjestyksessÃ¤ Start/Stop',0),(50741,1410,'no','Fyll for Start/stopp',0),(50742,1410,'da','Udfylde ordren Start/Stop',0),(50743,1410,'ko','ì±„ìš°ê¸° ìˆœì„œ ì‹œìž‘/ì¤‘ì§€',0),(50744,1410,'he','×œ×ž×œ× ×”×–×ž× ×”/×¢×¦×™×¨×”',0),(50745,1410,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏŽÏƒÏ„Îµ Ï„Î·Î½ ÎµÎ½Ï„Î¿Î»Î® Start/Stop',0),(50746,1410,'zh','å¡«å†™è®¢å•å¼€å§‹/åœæ­¢\r\n',0),(50747,1410,'sv','Fyll ordning Start/stopp',0),(50748,1410,'it','Riempire ordine Start/Stop',0),(50749,1410,'tl','',0),(50750,1410,'th','&#3648;&#3619;&#3636;&#3656;&#3617;/&#3627;&#3618;&#3640;&#3604;&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(50751,1410,'hi','à¤­à¤°à¤£ à¤•à¥à¤°à¤® à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ /',0),(50752,1410,'ms','Mengisi pesanan mula/tamat',0),(50753,1410,'ar','Ø´ØºÙ„ ØªØ±ØªÙŠØ¨ Ø¨Ø¯Ø¡/Ø¥ÙŠÙ‚Ø§Ù',0),(50754,1410,'fr','Remplir la commande marche/arrÃªt',0),(50755,1410,'jp','æ³¨æ–‡ã?®è¨˜å…¥é–‹å§‹/å?œæ­¢',0),(50756,1410,'pt','Preencher a ordem de iniciar/parar',0),(50757,1410,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ð° Ð¡Ñ‚Ð°Ñ€Ñ‚/Ð¡Ñ‚Ð¾Ð¿',0),(50758,1410,'es','Llenar Pedido Comenzar/Detener',0),(50759,1410,'de','FÃ¼llen Sie die Bestellung starten/stoppen',0),(50760,1410,'en','Fill Order Start/Stop',0),(50761,1411,'is','',0),(50762,1411,'dr','Ù†Ù‡Ø§ÙŠÙŠ ØŸ ',0),(50763,1411,'pr','Ù†Ù‡Ø§ÙŠÙŠ ØŸ ',0),(50764,1411,'tr','Final?',0),(50765,1411,'pl','KoÅ„cowe?',0),(50766,1411,'bg','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¾?',0),(50767,1411,'ur','Ø¢Ø®Ø±ÛŒØŸ',0),(50768,1411,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð°?',0),(50769,1411,'vi','Cuá»‘i cÃ¹ng?',0),(50770,1411,'af','Finale?',0),(50771,1411,'ro','FinalÄƒ?',0),(50772,1411,'et','LÃµplik?',0),(50773,1411,'si','KonÄni?',0),(50774,1411,'ba','Akhir?',0),(50775,1411,'nl','Laatste?',0),(50776,1411,'fi','Lopullinen?',0),(50777,1411,'no','Siste?',0),(50778,1411,'da','Endelige?',0),(50779,1411,'ko','ë§ˆì§€ë§‰?',0),(50780,1411,'he','?×¡×•×¤×™',0),(50781,1411,'el','Î¤ÎµÎ»Î¹ÎºÎ®;',0),(50782,1411,'zh','æœ€åŽ\r\n',0),(50783,1411,'sv','Sista?',0),(50784,1411,'it','Finale?',0),(50785,1411,'tl','',0),(50786,1411,'th','&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(50787,1411,'hi','à¤…à¤‚à¤¤à¤¿à¤®?',0),(50788,1411,'ms','Akhir?',0),(50789,1411,'ar','Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØŸ',0),(50790,1411,'fr','Finale ?',0),(50791,1411,'jp','æœ€çµ‚ã?§ã?™ã?‹ï¼Ÿ',0),(50792,1411,'pt','Final?',0),(50793,1411,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹?',0),(50794,1411,'es','Final?',0),(50795,1411,'de','Final?',0),(50796,1411,'en','Final?',0),(50797,1412,'is','',0),(50798,1412,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù†Ù‡Ø§ÙŠÙŠ ',0),(50799,1412,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù†Ù‡Ø§ÙŠÙŠ ',0),(50800,1412,'tr','Son miktar',0),(50801,1412,'pl','Ostateczna iloÅ›Ä‡',0),(50802,1412,'bg','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(50803,1412,'ur','Ø¢Ø®Ø±ÛŒ Ù‚ÛŒ',0),(50804,1412,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð¸ ÐšÐ¾Ð».',0),(50805,1412,'vi','Sá»‘ lÆ°á»£ng cuá»‘i cÃ¹ng',0),(50806,1412,'af','Finale Hoev.',0),(50807,1412,'ro','Cantit Ã®n finalÄƒ',0),(50808,1412,'et','LÃµplik kogus',0),(50809,1412,'si','KonÄna koliÄina',0),(50810,1412,'ba','Akhir Qty',0),(50811,1412,'nl','Uiteindelijke hoeveelheid',0),(50812,1412,'fi','Lopullinen mÃ¤Ã¤rÃ¤',0),(50813,1412,'no','Siste antall',0),(50814,1412,'da','Endelige antal',0),(50815,1412,'ko','ë§ˆì§€ë§‰ ìˆ˜ëŸ‰',0),(50816,1412,'he','×›×ž×•×ª ×”××—×¨×•× ×™×',0),(50817,1412,'el','Î¤ÎµÎ»Î¹ÎºÎ® Qty',0),(50818,1412,'zh','æœ€ç»ˆæ•°é‡\r\n',0),(50819,1412,'sv','Sista Kvt',0),(50820,1412,'it','Finale Qty',0),(50821,1412,'tl','',0),(50822,1412,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(50823,1412,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(50824,1412,'ms','Qty akhir',0),(50825,1412,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ©',0),(50826,1412,'fr','Qty final',0),(50827,1412,'jp','æœ€çµ‚æ•°é‡?',0),(50828,1412,'pt','Qty final',0),(50829,1412,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾Ð²Ð¾Ðµ ÐšÐ¾Ð»-Ð²Ð¾',0),(50830,1412,'es','Cant Final',0),(50831,1412,'de','EndgÃ¼ltige Qty',0),(50832,1412,'en','Final Qty',0),(50833,1413,'is','',0),(50834,1413,'dr','* ØµÙØ­Ø§Øª ',0),(50835,1413,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù†Ù‡Ø§ÙŠÙŠ * ØµÙØ­Ø§Øª ',0),(50836,1413,'tr','Son adet x sayfalar',0),(50837,1413,'pl','Ostateczna iloÅ›Ä‡ x stron',0),(50838,1413,'bg','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(50839,1413,'ur','Ø¢Ø®Ø±ÛŒ Ù‚ÛŒ ØµÙØ­Ø§Øª x',0),(50840,1413,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð¸ ÐšÐ¾Ð» x ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(50841,1413,'vi','Chá»‘t sá»‘ lÆ°á»£ng trang ',0),(50842,1413,'af','Finale Hoev. x Blaaie',0),(50843,1413,'ro','Cantit Ã®n final x pagini',0),(50844,1413,'et','LÃµplik kogus x lehekÃ¼ljed',0),(50845,1413,'si','KonÄna koliÄina x strani',0),(50846,1413,'ba','Akhir Qty x Halaman',0),(50847,1413,'nl','Definitieve aantal x pagina\'s',0),(50848,1413,'fi','Lopullinen mÃ¤Ã¤rÃ¤ x sivut',0),(50849,1413,'no','Siste antall x sider',0),(50850,1413,'da','Endelige antal x sider',0),(50851,1413,'ko','ìµœì¢… ìˆ˜ëŸ‰ íŽ˜ì´ì§€ x',0),(50852,1413,'he','×›×ž×•×ª ×”××—×¨×•× ×™× x ×“×¤×™×',0),(50853,1413,'el','Î¤ÎµÎ»Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± x ÏƒÎµÎ»Î¯Î´ÎµÏ‚',0),(50854,1413,'zh','æœ€ç»ˆæ•°é‡Xé¡µ\r\n',0),(50855,1413,'sv','Slutligt antal x sidor',0),(50856,1413,'it','Qty finale x pagine',0),(50857,1413,'tl','',0),(50858,1413,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618; * &#3627;&#3609;&#3657;&#3634;',0),(50859,1413,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ x',0),(50860,1413,'ms','Qty akhir x muka surat',0),(50861,1413,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© Ã— Ø§Ù„ØµÙØ­Ø§Øª',0),(50862,1413,'fr','Qty final x Pages',0),(50863,1413,'jp','æœ€çµ‚æ•°é‡?Ã—ãƒšãƒ¼ã‚¸æ•°',0),(50864,1413,'pt','Qty final x pÃ¡ginas',0),(50865,1413,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†',0),(50866,1413,'es','Cant Final x PÃ¡ginas',0),(50867,1413,'de','EndgÃ¼ltige Menge x Seiten',0),(50868,1413,'en','Final Qty x Pages',0),(50869,1414,'is','',0),(50870,1414,'dr','* ØµÙØ­Ø§Øª *Ø¬Ù‡ØªÙ‡Ø§ ',0),(50871,1414,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù†Ù‡Ø§ÙŠÙŠ * ØµÙØ­Ø§Øª *Ø¬Ù‡ØªÙ‡Ø§ ',0),(50872,1414,'tr','Son adet sayfa x x taraf',0),(50873,1414,'pl','Ostateczna iloÅ›Ä‡ x stron x stron',0),(50874,1414,'bg','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ x ÑÑ‚Ñ€Ð°Ð½Ð¸',0),(50875,1414,'ur','Ø¢Ø®Ø±ÛŒ Ù‚ÛŒ ØµÙØ­Ø§Øª x Ø§Ø·Ø±Ø§Ù x',0),(50876,1414,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð¸ ÐšÐ¾Ð» x ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° x ÑÑ‚Ñ€Ð°Ð½Ð°',0),(50877,1414,'vi','Chá»‘t sá»‘ lÆ°á»£ng trang vÃ  sá»‘ máº·t',0),(50878,1414,'af','Finale Hoev. x Blaaie x Kante',0),(50879,1414,'ro','Cantit Ã®n final x pagini x pÄƒrÅ£ile',0),(50880,1414,'et','LÃµplik kogus x lehekÃ¼lge x pool',0),(50881,1414,'si','KonÄna koliÄina x strani x straneh',0),(50882,1414,'ba','Akhir Qty x halaman x sisi',0),(50883,1414,'nl','Definitieve aantal x pagina\'s x zijden',0),(50884,1414,'fi','Lopullinen mÃ¤Ã¤rÃ¤ sivuja x x puolin',0),(50885,1414,'no','Siste antall x sider x sider',0),(50886,1414,'da','Endelige antal x sider x sider',0),(50887,1414,'ko','ìµœì¢… ìˆ˜ëŸ‰ íŽ˜ì´ì§€ x ë©´ x',0),(50888,1414,'he','×›×ž×•×ª ×”××—×¨×•× ×™× x ×“×¤×™× x ×”×¦×“×“×™×',0),(50889,1414,'el','Î¤ÎµÎ»Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± x ÏƒÎµÎ»Î¯Î´ÎµÏ‚ x Ï€Î»ÎµÏ…ÏÎ­Ï‚',0),(50890,1414,'zh','æœ€ç»ˆæ•°é‡Xé¡µxä¾§é¢\r\n',0),(50891,1414,'sv','Slutligt antal x sidor x sidor',0),(50892,1414,'it','Qty finale x pagine x i lati',0),(50893,1414,'tl','',0),(50894,1414,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618; * &#3627;&#3609;&#3657;&#3634; * &#3604;&#3657;&#3634;&#3609;',0),(50895,1414,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ x x à¤ªà¤•à¥à¤·à¥‹à¤‚',0),(50896,1414,'ms','Qty akhir x muka surat x belah',0),(50897,1414,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© Ã— ØµÙØ­Ø§Øª Ã— Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠÙ†',0),(50898,1414,'fr','Qty final x Pages x cÃ´tÃ©s',0),(50899,1414,'jp','æœ€çµ‚æ•°é‡?Ã—ãƒšãƒ¼ã‚¸æ•°Ã—å?´é?¢æ•°',0),(50900,1414,'pt','Qty final x pÃ¡ginas x lados',0),(50901,1414,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ† x ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(50902,1414,'es','Cant Final x PÃ¡ginas x Lados',0),(50903,1414,'de','EndgÃ¼ltige Menge x Seiten x Seiten',0),(50904,1414,'en','Final Qty x Pages x Sides',0),(50905,1415,'is','',0),(50906,1415,'dr','* Ù‚Ø³Ù…ØªÙ‡Ø§ ',0),(50907,1415,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù†Ù‡Ø§ÙŠÙŠ * Ù‚Ø³Ù…ØªÙ‡Ø§ ',0),(50908,1415,'tr','Son adet parÃ§a x',0),(50909,1415,'pl','Ostateczna iloÅ›Ä‡ x czÄ™Å›ci',0),(50910,1415,'bg','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x Ñ‡Ð°ÑÑ‚Ð¸',0),(50911,1415,'ur','Ø¢Ø®Ø±ÛŒ Ù‚ÛŒ Ø­ØµÛ’ x',0),(50912,1415,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð¸ ÐšÐ¾Ð» x Ð´ÐµÐ»Ð¾Ð²Ð°',0),(50913,1415,'vi','Sá»‘ lÆ°á»£ng cuá»‘i cÃ¹ng x Phá»¥ tÃ¹ng',0),(50914,1415,'af','Finale Hoev. x Onderdele',0),(50915,1415,'ro','Cantit Ã®n final x pÄƒrÅ£ile',0),(50916,1415,'et','LÃµplik kogus x osad',0),(50917,1415,'si','KonÄna koliÄina x delov',0),(50918,1415,'ba','Akhir Qty x bagian',0),(50919,1415,'nl','Definitieve aantal x delen',0),(50920,1415,'fi','Lopullinen mÃ¤Ã¤rÃ¤ x osat',0),(50921,1415,'no','Siste antall x deler',0),(50922,1415,'da','Endelige antal x dele',0),(50923,1415,'ko','ìµœì¢… ìˆ˜ëŸ‰ ë¶€í’ˆ x',0),(50924,1415,'he','×›×ž×•×ª ×”××—×¨×•× ×™× x ×—×œ×§×™',0),(50925,1415,'el','Î¤ÎµÎ»Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± x Î¼Î­ÏÎ·',0),(50926,1415,'zh','æœ€ç»ˆæ•°é‡Xéƒ¨åˆ†\r\n',0),(50927,1415,'sv','Slutligt antal x delar',0),(50928,1415,'it','Qty finale x parti',0),(50929,1415,'tl','',0),(50930,1415,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618; * &#3594;&#3636;&#3657;&#3609;&#3626;&#3656;&#3623;&#3609;',0),(50931,1415,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤­à¤¾à¤—à¥‹à¤‚ x',0),(50932,1415,'ms','Qty akhir x bahagian',0),(50933,1415,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© Ã— Ø£Ø¬Ø²Ø§Ø¡',0),(50934,1415,'fr','Qty final x piÃ¨ces',0),(50935,1415,'jp','æœ€çµ‚æ•°é‡?Ã—éƒ¨å“?æ•°',0),(50936,1415,'pt','Qty final x peÃ§as',0),(50937,1415,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x Ð—Ð°Ð¿Ñ‡Ð°ÑÑ‚Ð¸',0),(50938,1415,'es','Cant Final x Partes',0),(50939,1415,'de','EndgÃ¼ltige Menge x Teile',0),(50940,1415,'en','Final Qty x Parts',0),(50941,1416,'is','',0),(50942,1416,'dr','* Ø¬Ù‡ØªÙ‡Ø§ * Ù‚Ø³Ù…ØªÙ‡Ø§ ',0),(50943,1416,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù†Ù‡Ø§ÙŠÙŠ * Ø¬Ù‡ØªÙ‡Ø§ * Ù‚Ø³Ù…ØªÙ‡Ø§ ',0),(50944,1416,'tr','Son miktar iki x x parÃ§alarÄ±',0),(50945,1416,'pl','Ostateczna iloÅ›Ä‡ x stron x czÄ™Å›ci',0),(50946,1416,'bg','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x ÑÑ‚Ñ€Ð°Ð½Ð¸ x Ñ‡Ð°ÑÑ‚Ð¸',0),(50947,1416,'ur','Ø¢Ø®Ø±ÛŒ Ù‚ÛŒ Ø§Ø·Ø±Ø§Ù x x Ø­ØµÙˆÚº',0),(50948,1416,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð¸ ÐšÐ¾Ð» x ÑÑ‚Ñ€Ð°Ð½Ðµ x Ð´ÐµÐ»Ð¾Ð²Ð°',0),(50949,1416,'vi','Sá»‘ lÆ°á»£ng cuá»‘i cÃ¹ng x Máº·t x Phá»¥ tÃ¹ng',0),(50950,1416,'af','Finale Hoev. x Kante x Onderdele',0),(50951,1416,'ro','Cantit Ã®n final x pÄƒrÅ£i x pÄƒrÅ£ile',0),(50952,1416,'et','LÃµplik kogus x pool x osad',0),(50953,1416,'si','KonÄna koliÄina x straneh x delov',0),(50954,1416,'ba','Akhir Qty x sisi x bagian',0),(50955,1416,'nl','Definitieve aantal x zijden x delen',0),(50956,1416,'fi','Lopullinen mÃ¤Ã¤rÃ¤ x puolin x osat',0),(50957,1416,'no','Siste antall x sider x deler',0),(50958,1416,'da','Endelige antal x sider x dele',0),(50959,1416,'ko','ìµœì¢… ìˆ˜ëŸ‰ ì¸¡ë©´ x ë¶€í’ˆ x',0),(50960,1416,'he','×›×ž×•×ª ×”××—×¨×•× ×™× x ×”×¦×“×“×™× x ×—×œ×§×™',0),(50961,1416,'el','Î¤ÎµÎ»Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± x Ï€Î»ÎµÏ…ÏÎ­Ï‚ x Î¼Î­ÏÎ·',0),(50962,1416,'zh','æœ€ç»ˆæ•°é‡Xä¾§é¢Xéƒ¨åˆ†\r\n',0),(50963,1416,'sv','Slutligt antal x sidor x delar',0),(50964,1416,'it','Qty finale x i lati x parti',0),(50965,1416,'tl','',0),(50966,1416,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618; * &#3604;&#3657;&#3634;&#3609; * &#3594;&#3636;&#3657;&#3609;&#3626;&#3656;&#3623;&#3609;',0),(50967,1416,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¤•à¥à¤·à¥‹à¤‚ x x à¤­à¤¾à¤—à¥‹à¤‚',0),(50968,1416,'ms','Qty akhir x belah x bahagian',0),(50969,1416,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© Ã— Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠÙ† x Ø£Ø¬Ø²Ø§Ø¡',0),(50970,1416,'fr','Qty final x cÃ´tÃ©s x piÃ¨ces',0),(50971,1416,'jp','æœ€çµ‚æ•°é‡?Ã—å?´é?¢æ•°Ã—éƒ¨å“?æ•°',0),(50972,1416,'pt','Qty final x lados x peÃ§as',0),(50973,1416,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹ x Ð—Ð°Ð¿Ñ‡Ð°ÑÑ‚Ð¸',0),(50974,1416,'es','Cant Final x Lados x Partes',0),(50975,1416,'de','EndgÃ¼ltige Menge x Seiten x Teile',0),(50976,1416,'en','Final Qty x Sides x Parts',0),(50977,1417,'is','',0),(50978,1417,'dr','ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ù†Ù‡Ø§ÙŠÙŠ',0),(50979,1417,'pr','ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ù†Ù‡Ø§ÙŠÙŠ',0),(50980,1417,'tr','Son revizyonu',0),(50981,1417,'pl','Ostateczna wersja',0),(50982,1417,'bg','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¾ Ð¿Ñ€ÐµÑ€Ð°Ð·Ð³Ð»ÐµÐ¶Ð´Ð°Ð½Ðµ',0),(50983,1417,'ur','Ø­ØªÙ…ÛŒ Ù†Ø¸Ø± Ø«Ø§Ù†ÛŒ',0),(50984,1417,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ð°',0),(50985,1417,'vi','Chá»‰nh sá»­a cuá»‘i cÃ¹ng',0),(50986,1417,'af','Finale hersiening',0),(50987,1417,'ro','Revizie finalÄƒ',0),(50988,1417,'et','LÃµplik versioon',0),(50989,1417,'si','KonÄno revizijo',0),(50990,1417,'ba','Revisi akhir',0),(50991,1417,'nl','Laatste herziening',0),(50992,1417,'fi','Lopullinen tarkistus',0),(50993,1417,'no','Siste revisjon',0),(50994,1417,'da','Sidste Revision',0),(50995,1417,'ko','ìµœì¢… ìˆ˜ì •',0),(50996,1417,'he','×”×’×¨×¡×” ×”×¡×•×¤×™×ª',0),(50997,1417,'el','Î¤ÎµÎ»Î¹ÎºÎ® Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(50998,1417,'zh','æœ€åŽçš„ä¿®è®¢\r\n',0),(50999,1417,'sv','Sista revidering',0),(51000,1417,'it','Revisione finale',0),(51001,1417,'tl','',0),(51002,1417,'th','&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3588;&#3619;&#3633;&#3657;&#3591;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(51003,1417,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¸à¤‚à¤¶à¥‹à¤§à¤¨',0),(51004,1417,'ms','Semakan akhir',0),(51005,1417,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ù†Ù‡Ø§Ø¦ÙŠØ©',0),(51006,1417,'fr','RÃ©vision finale',0),(51007,1417,'jp','æœ€çµ‚è¨‚æ­£',0),(51008,1417,'pt','RevisÃ£o final',0),(51009,1417,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð¿ÐµÑ€ÐµÑÐ¼Ð¾Ñ‚Ñ€',0),(51010,1417,'es','RevisiÃ³n Final',0),(51011,1417,'de','EndgÃ¼ltige Revision',0),(51012,1417,'en','Final Revision',0),(51013,1418,'is','',0),(51014,1418,'dr','Ø¢Ø®Ø±ÙŠÙ† Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(51015,1418,'pr','Ø¢Ø®Ø±ÙŠÙ† Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(51016,1418,'tr','Son sevk irsaliyesi',0),(51017,1418,'pl','Ostatecznej wysyÅ‚ki',0),(51018,1418,'bg','Ð—Ð°ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¿Ñ€Ð°Ñ‚ÐºÐ°Ñ‚Ð°',0),(51019,1418,'ur','Ø¢Ø®Ø±ÛŒ Ú©Ú¾ÛŒÙ¾',0),(51020,1418,'sr','Ð—Ð°Ð´ÑšÐ° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(51021,1418,'vi','Chuyáº¿n hÃ ng cuá»‘i',0),(51022,1418,'af','Finale Versending',0),(51023,1418,'ro','Final de expediere',0),(51024,1418,'et','Viimane lÃ¤hetus',0),(51025,1418,'si','KonÄni dobavnice',0),(51026,1418,'ba','Akhir pengiriman',0),(51027,1418,'nl','Definitieve verzending',0),(51028,1418,'fi','Viimeinen lÃ¤hetys',0),(51029,1418,'no','Siste forsendelse',0),(51030,1418,'da','Endelige leverance',0),(51031,1418,'ko','ìµœì¢… ì„ ì ',0),(51032,1418,'he','×”×ž×©×œ×•×— ×”××—×¨×•×Ÿ',0),(51033,1418,'el','Î¤ÎµÎ»Î¹ÎºÎ® Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(51034,1418,'zh','æœ€åŽä¸€æ‰¹\r\n',0),(51035,1418,'sv','Sista transporten',0),(51036,1418,'it','Spedizione finale',0),(51037,1418,'tl','',0),(51038,1418,'th','&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(51039,1418,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤–à¥‡à¤ª',0),(51040,1418,'ms','Penghantaran akhir',0),(51041,1418,'ar','Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ',0),(51042,1418,'fr','Dernier envoi',0),(51043,1418,'jp','æœ€çµ‚é…?é€?å…ˆ',0),(51044,1418,'pt','ExpediÃ§Ã£o final',0),(51045,1418,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(51046,1418,'es','EnvÃ­o Final',0),(51047,1418,'de','Letzte Sendung',0),(51048,1418,'en','Final Shipment',0),(51049,1419,'is','',0),(51050,1419,'dr','Ø¢Ø®Ø±ÙŠÙ† Ù…Ø¬Ù…ÙˆØ¹',0),(51051,1419,'pr','Ø¢Ø®Ø±ÙŠÙ† Ù…Ø¬Ù…ÙˆØ¹',0),(51052,1419,'tr','Son toplamlar',0),(51053,1419,'pl','Sumy koÅ„cowe',0),(51054,1419,'bg','ÐšÑ€Ð°Ð¹Ð½Ð¸Ñ‚Ðµ Ð¾Ð±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸',0),(51055,1419,'ur','Ø¢Ø®Ø±ÛŒ Ù…ÛŒØ²Ø§Ù†',0),(51056,1419,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð¸ Ð·Ð±Ð¸Ñ€Ð¾Ð²Ð¸',0),(51057,1419,'vi','Tá»•ng cá»™ng cuá»‘i cÃ¹ng',0),(51058,1419,'af','Finale totale',0),(51059,1419,'ro','Totalurile finalÄƒ',0),(51060,1419,'et','LÃµplikud kokkuvÃµtted',0),(51061,1419,'si','KonÄni seÅ¡tevki',0),(51062,1419,'ba','Total akhir',0),(51063,1419,'nl','Definitieve totalen',0),(51064,1419,'fi','Lopullinen summa',0),(51065,1419,'no','Siste totaler',0),(51066,1419,'da','Endelige totaler',0),(51067,1419,'ko','ìµœì¢… í•©ê³„',0),(51068,1419,'he','×¡×™×›×•×ž×™× ×”×¡×•×¤×™',0),(51069,1419,'el','Î¤ÎµÎ»Î¹ÎºÎ® ÏƒÏÎ½Î¿Î»Î±',0),(51070,1419,'zh','æœ€åŽæ±‡æ€»\r\n',0),(51071,1419,'sv','Sista summor',0),(51072,1419,'it','Finali totali',0),(51073,1419,'tl','',0),(51074,1419,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(51075,1419,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¯à¥‹à¤—',0),(51076,1419,'ms','Jumlah akhir',0),(51077,1419,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹ Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ©',0),(51078,1419,'fr','Totaux finales',0),(51079,1419,'jp','æœ€çµ‚ç·?é¡?',0),(51080,1419,'pt','Totais finais',0),(51081,1419,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¸Ñ‚Ð¾Ð³Ð¸',0),(51082,1419,'es','Totales Finales',0),(51083,1419,'de','EndgÃ¼ltige Ergebnisse',0),(51084,1419,'en','Final Totals',0),(51085,1420,'is','',0),(51086,1420,'dr','Ù†Ù‡Ø§ÙŠÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(51087,1420,'pr','Ù†Ù‡Ø§ÙŠÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(51088,1420,'tr','YapÄ± sipariÅŸi son haline getir',0),(51089,1420,'pl','Finalizuj zamÃ³wienie budowaÄ‡',0),(51090,1420,'bg','Ð¤Ð¸Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ',0),(51091,1420,'ur','ØªØ¹Ù…ÛŒØ± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ø¢Ø®Ø±ÛŒ Ø´Ú©Ù„ Ø¯ÛŒÚº',0),(51092,1420,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐµ Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(51093,1420,'vi','Káº¿t thÃºc ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(51094,1420,'af','POMA bou orde',0),(51095,1420,'ro','Finalizeaza comanda Build',0),(51096,1420,'et','Build tellimuse lÃµpetamine',0),(51097,1420,'si','DokonÄanje izgradnje',0),(51098,1420,'ba','Menyelesaikan pesanan membangun',0),(51099,1420,'nl','Finaliseren opbouwvolgorde',0),(51100,1420,'fi','Viimeistele tilauksen mukaan',0),(51101,1420,'no','FullfÃ¸re bygge rekkefÃ¸lge',0),(51102,1420,'da','FÃ¦rdiggÃ¸r Byg efter ordre',0),(51103,1420,'ko','ë¹Œë“œ ìˆœì„œë¥¼ ë§ˆë¬´ë¦¬',0),(51104,1420,'he','×’×™×‘×•×© ×¡×•×¤×™ ×©×œ ×‘× ×™×” ×”×–×ž× ×”',0),(51105,1420,'el','ÎŸÎ»Î¿ÎºÎ»Î·ÏÏŽÏƒÎµÎ¹ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(51106,1420,'zh','æž„å»ºé¡ºåºæ•²å®š\r\n',0),(51107,1420,'sv','SlutfÃ¶ra bygga Order',0),(51108,1420,'it','Finalizzare l\'ordine di compilazione',0),(51109,1420,'tl','',0),(51110,1420,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3633;&#3657;&#3609;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(51111,1420,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤•à¥à¤°à¤® à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª',0),(51112,1420,'ms','Memuktamadkan perintah membina',0),(51113,1420,'ar','ÙˆØ¶Ø¹ Ø§Ù„ØµÙŠØºØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© Ù„ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(51114,1420,'fr','Finaliser l\'ordre de compilation',0),(51115,1420,'jp','çµ„ç«‹æ³¨æ–‡ã?®å®Œäº†',0),(51116,1420,'pt','Finalize a ordem de compilaÃ§Ã£o',0),(51117,1420,'ru','Ð”Ð¾Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(51118,1420,'es','Finalizar el Orden de ConstrucciÃ³n',0),(51119,1420,'de','Finalisieren Buildreihenfolge',0),(51120,1420,'en','Finalize Build Order',0),(51121,1421,'is','',0),(51122,1421,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ù†Ù‡Ø§ÙŠÙŠ Ø´Ø¯ ',0),(51123,1421,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ù†Ù‡Ø§ÙŠÙŠ Ø´Ø¯ ',0),(51124,1421,'tr','KesinleÅŸmiÅŸ inÅŸa sipariÅŸlerini rapora',0),(51125,1421,'pl','ZakoÅ„czone budowy zamÃ³wienia raportu',0),(51126,1421,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¸Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(51127,1421,'ur','Ø±Ø§Ø¬Ø¯Ú¾Ø§Ù†ÛŒ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(51128,1421,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÐŸÑ€Ð°Ð²Ð¾Ð±Ñ€Ð°Ð½Ð¸Ð»Ð°ÑˆÑ‚Ð²Ð° Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(51129,1421,'vi','Káº¿t thÃºc bÃ¡o cÃ¡o ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(51130,1421,'af','Finaliseer Geboude Bestellingsverslag',0),(51131,1421,'ro','Raport de comenzi finalizate construi',0),(51132,1421,'et','LÃµpule ehitada tellimuste aruanne',0),(51133,1421,'si','Zidava dokonÄana naroÄila poroÄilo',0),(51134,1421,'ba','Mengakhiri Laporan Pembuatan Pesanan',0),(51135,1421,'nl','Gefinaliseerde Build Orders verslag',0),(51136,1421,'fi','Valmiiksi rakentaa Tilaukset-raportti',0),(51137,1421,'no','Endelige bygge ordrene rapporten',0),(51138,1421,'da','FÃ¦rdiggjort bygge ordrer rapport',0),(51139,1421,'ko','ìµœì¢…ëœ ë¹Œë“œ ì£¼ë¬¸ ë³´ê³ ì„œ',0),(51140,1421,'he','×’×™×‘×•×© ×œ×‘× ×•×ª ×“×•×— ×”×–×ž× ×•×ª',0),(51141,1421,'el','ÎŸÏÎ¹ÏƒÏ„Î¹ÎºÎ® ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Î±Î½Î±Ï†Î¿ÏÎ¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(51142,1421,'zh','å»ºç«‹è®¢å•æŠ¥å‘Šå®šç¨¿\r\n',0),(51143,1421,'sv','Slutbehandlad bygga rapport',0),(51144,1421,'it','Report ordini Build finalizzato',0),(51145,1421,'tl','',0),(51146,1421,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3633;&#3657;&#3609;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(51147,1421,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¤¿à¤¯à¤¾ à¤¬à¤¿à¤²à¥à¤¡ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(51148,1421,'ms','Laporan pesanan membina dimuktamadkan',0),(51149,1421,'ar','ØªÙ‚Ø±ÙŠØ± Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡ Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ©',0),(51150,1421,'fr','Rapport de commandes de gÃ©nÃ©ration finalisÃ©',0),(51151,1421,'jp','çµ„ç«‹æ³¨æ–‡ãƒ¬ãƒ?ãƒ¼ãƒˆã?®å®Œäº†',0),(51152,1421,'pt','RelatÃ³rio de ordens de compilaÃ§Ã£o finalizado',0),(51153,1421,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ð¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(51154,1421,'es','Informe Finalizado de Ordenes de ConstrucciÃ³n',0),(51155,1421,'de','Abgeschlossene Build Orders-Bericht',0),(51156,1421,'en','Finalized Build Orders Report',0),(51157,1422,'is','',0),(51158,1422,'dr','Ù¾Ø§ÙŠØ§Ù† ',0),(51159,1422,'pr','Ù¾Ø§ÙŠØ§Ù† ',0),(51160,1422,'tr','BitiÅŸ',0),(51161,1422,'pl','WykoÅ„czenie',0),(51162,1422,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐ¸',0),(51163,1422,'ur','ØªÚ©Ù…ÛŒÙ„',0),(51164,1422,'sr','Ð—Ð°Ð²Ñ€ÑˆÐ¸',0),(51165,1422,'vi','Káº¿t thÃºc',0),(51166,1422,'af','Afwerking',0),(51167,1422,'ro','Finisaj',0),(51168,1422,'et','Viimistlus',0),(51169,1422,'si','ZakljuÄek',0),(51170,1422,'ba','Selesai',0),(51171,1422,'nl','Afwerking',0),(51172,1422,'fi','Valmis',0),(51173,1422,'no','FullfÃ¸r',0),(51174,1422,'da','Finish',0),(51175,1422,'ko','ë§ˆë¬´ë¦¬',0),(51176,1422,'he','×¡×™×•×',0),(51177,1422,'el','Î¦Î¹Î½Î¯ÏÎ¹ÏƒÎ¼Î±',0),(51178,1422,'zh','å®Œæˆ\r\n',0),(51179,1422,'sv','SlutfÃ¶r',0),(51180,1422,'it','Finitura',0),(51181,1422,'tl','',0),(51182,1422,'th','&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(51183,1422,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤•à¤°à¥‡à¤‚',0),(51184,1422,'ms','Selesai',0),(51185,1422,'ar','Ø¥Ù†Ù‡Ø§Ø¡',0),(51186,1422,'fr','Finition',0),(51187,1422,'jp','å®Œäº†',0),(51188,1422,'pt','Acabamento',0),(51189,1422,'ru','ÐžÑ‚Ð´ÐµÐ»ÐºÐ°',0),(51190,1422,'es','Terminar',0),(51191,1422,'de','Fertig stellen',0),(51192,1422,'en','Finish',0),(51193,1423,'is','',0),(51194,1423,'dr','ØªÙƒÙ…ÙŠÙ„ Ø§ÙØ²ÙˆØ¯Ù† ',0),(51195,1423,'pr','ØªÙƒÙ…ÙŠÙ„ Ø§ÙØ²ÙˆØ¯Ù† ',0),(51196,1423,'tr','BitiÅŸ Ekle',0),(51197,1423,'pl','DodaÄ‡ wykoÅ„czenie',0),(51198,1423,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¾',0),(51199,1423,'ur','ØªÚ©Ù…ÛŒÙ„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(51200,1423,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ð²Ñ€ÑˆÐ¸',0),(51201,1423,'vi','Káº¿t thÃºc thÃªm',0),(51202,1423,'af','Klaar, voeg',0),(51203,1423,'ro','Adauga finisaj',0),(51204,1423,'et','Valmis lisada',0),(51205,1423,'si','ZakljuÄek dodati',0),(51206,1423,'ba','Selesai menambahkan',0),(51207,1423,'nl','Afwerking toevoegen',0),(51208,1423,'fi','Valmis lisÃ¤Ã¤',0),(51209,1423,'no','FullfÃ¸r legge',0),(51210,1423,'da','UdfÃ¸r tilfÃ¸je',0),(51211,1423,'ko','ë§ˆë¬´ë¦¬ ì¶”ê°€',0),(51212,1423,'he','×¡×™×•× ×œ×”×•×¡×™×£',0),(51213,1423,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï†Î¹Î½Î¯ÏÎ¹ÏƒÎ¼Î±',0),(51214,1423,'zh','å®Œæˆæ·»åŠ \r\n',0),(51215,1423,'sv','SlutfÃ¶r lÃ¤gga till',0),(51216,1423,'it','Aggiungi finitura',0),(51217,1423,'tl','',0),(51218,1423,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3636;&#3657;&#3609;',0),(51219,1423,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤•à¤°à¥‡à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(51220,1423,'ms','Selesai menambah',0),(51221,1423,'ar','Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ù…Ù† Ø¥Ø¶Ø§ÙØ©',0),(51222,1423,'fr','Finition ajouter',0),(51223,1423,'jp','è¿½åŠ å®Œäº†',0),(51224,1423,'pt','Acabamento adicionar',0),(51225,1423,'ru','Ð“Ð¾Ñ‚Ð¾Ð²Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(51226,1423,'es','Terminar Agregar',0),(51227,1423,'de','Ziel hinzufÃ¼gen',0),(51228,1423,'en','Finish Add',0),(51229,1424,'is','',0),(51230,1424,'dr','Ú©Ø§Ù„Ø§Ù‡Ø§Ù‰ Ø§Ù…Ø§Ø¯Ù‡ ÙØ±ÙˆØ´',0),(51231,1424,'pr','Ú©Ø§Ù„Ø§Ù‡Ø§Ù‰ Ø§Ù…Ø§Ø¯Ù‡ ÙØ±ÙˆØ´',0),(51232,1424,'tr','Mamul mallar',0),(51233,1424,'pl','WyrobÃ³w gotowych',0),(51234,1424,'bg','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸ Ð¸Ð·Ð´ÐµÐ»Ð¸Ñ',0),(51235,1424,'ur','ØªÚ©Ù…ÛŒÙ„ Ø´Ø¯Û Ø³Ø§Ù…Ø§Ù†',0),(51236,1424,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸',0),(51237,1424,'vi','HÃ ng káº¿t thÃºc',0),(51238,1424,'af','Klaargoedere (gereed-vir-verkoop item)',0),(51239,1424,'ro','Produse finite',0),(51240,1424,'et','LÃµpetatud kaubad',0),(51241,1424,'si','Gotovi izdelki',0),(51242,1424,'ba','Barang jadi',0),(51243,1424,'nl','Eindproducten',0),(51244,1424,'fi','Valmiit tuotteet',0),(51245,1424,'no','Ferdige varer',0),(51246,1424,'da','FÃ¦rdigvarer',0),(51247,1424,'ko','ì™„ì„±í’ˆ',0),(51248,1424,'he','×¡×—×•×¨×•×ª',0),(51249,1424,'el','Î¤ÎµÎ»Î¹ÎºÏŽÎ½ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Ï‰Î½',0),(51250,1424,'zh','æˆå“\r\n',0),(51251,1424,'sv','FÃ¤rdiga varor',0),(51252,1424,'it','Prodotti finiti',0),(51253,1424,'tl','',0),(51254,1424,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;&#3619;&#3641;&#3611;',0),(51255,1424,'hi','à¤¤à¥ˆà¤¯à¤¾à¤° à¤®à¤¾à¤²',0),(51256,1424,'ms','Barangan siap',0),(51257,1424,'ar','Ù…Ù†ØªØ¬ Ø¬Ø§Ù‡Ø²',0),(51258,1424,'fr','Produits finis',0),(51259,1424,'jp','å®Œäº†å•†å“?',0),(51260,1424,'pt','Produtos acabados',0),(51261,1424,'ru','Ð“Ð¾Ñ‚Ð¾Ð²Ð¾Ð¹ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ†Ð¸Ð¸',0),(51262,1424,'es','Bienes Terminados',0),(51263,1424,'de','Fertige Erzeugnisse',0),(51264,1424,'en','Finished Goods',0),(51265,1425,'is','',0),(51266,1425,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ ',0),(51267,1425,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ ',0),(51268,1425,'tr','BitmiÅŸ boyutu',0),(51269,1425,'pl','Rozmiar',0),(51270,1425,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(51271,1425,'ur','Ù…Ú©Ù…Ù„ Ø³Ø§Ø¦Ø²',0),(51272,1425,'sr','ÐŸÑ€ÐµÐ´Ð²Ð¸Ñ’ÐµÐ½Ñƒ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(51273,1425,'vi','Cá»¡ Káº¿t thÃºc',0),(51274,1425,'af','Voltooide Groote',0),(51275,1425,'ro','Dimensiune finit',0),(51276,1425,'et','LÃµpetanud suurus',0),(51277,1425,'si','KonÄni velikosti',0),(51278,1425,'ba','Ukuran selesai',0),(51279,1425,'nl','Voltooide grootte',0),(51280,1425,'fi','Valmis pinta',0),(51281,1425,'no','Ferdig stÃ¸rrelse',0),(51282,1425,'da','FÃ¦rdig stÃ¸rrelse',0),(51283,1425,'ko','ì™„ì„± ëœ í¬ê¸°',0),(51284,1425,'he','×”×’×•×“×œ ×”×¡×•×¤×™',0),(51285,1425,'el','Î¤ÎµÎ»Î¹ÎºÏŒ Î¼Î­Î³ÎµÎ¸Î¿Ï‚',0),(51286,1425,'zh','æˆå“å°ºå¯¸\r\n',0),(51287,1425,'sv','FÃ¤rdig storlek',0),(51288,1425,'it','Dimensioni finite',0),(51289,1425,'tl','',0),(51290,1425,'th','&#3586;&#3609;&#3634;&#3604;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(51291,1425,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤†à¤•à¤¾à¤°',0),(51292,1425,'ms','Siap saiz',0),(51293,1425,'ar','Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ',0),(51294,1425,'fr','Dimension finie',0),(51295,1425,'jp','å®Œäº†ã‚µã‚¤ã‚º',0),(51296,1425,'pt','Tamanho final',0),(51297,1425,'ru','Ð“Ð¾Ñ‚Ð¾Ð²Ñ‹Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(51298,1425,'es','TamaÃ±o Terminado',0),(51299,1425,'de','GrÃ¶Be',0),(51300,1425,'en','Finished Size',0),(51301,1426,'is','',0),(51302,1426,'dr','ØªÙƒÙ…ÙŠÙ„ Ú¯Ø²ÙŠÙ†Ø´ ',0),(51303,1426,'pr','ØªÙƒÙ…ÙŠÙ„ Ú¯Ø²ÙŠÙ†Ø´ ',0),(51304,1426,'tr','SeÃ§im bitiÅŸ',0),(51305,1426,'pl','WybÃ³r wykoÅ„czenia',0),(51306,1426,'bg','Ð”Ð¾Ð²ÑŠÑ€ÑˆÐ¸Ñ‚ÐµÐ»Ð½Ð¸ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ',0),(51307,1426,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ø®ØªÙ…',0),(51308,1426,'sr','Ð”Ð½ÐµÐ²Ð½Ð° ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ð°',0),(51309,1426,'vi','Káº¿t thÃºc lá»±a chá»n',0),(51310,1426,'af','Afwerking seleksie',0),(51311,1426,'ro','SelecÅ£ie de finisare',0),(51312,1426,'et','Viimistlus valik',0),(51313,1426,'si','KonÄen izbor',0),(51314,1426,'ba','Menyelesaikan seleksi',0),(51315,1426,'nl','Afwerking selectie',0),(51316,1426,'fi','Viimeistely valinta',0),(51317,1426,'no','Etterbehandling utvalg',0),(51318,1426,'da','Efterbehandling udvalg',0),(51319,1426,'ko','ì„ íƒ ì™„ë£Œ',0),(51320,1426,'he','×’×™×ž×•×¨ ×œ×‘×—×™×¨×”',0),(51321,1426,'el','Î•Ï€Î¹Î»Î¿Î³Î® Ï†Î¹Î½Î¹ÏÎ¯ÏƒÎ¼Î±Ï„Î¿Ï‚',0),(51322,1426,'zh','å®Œæˆé€‰æ‹©\r\n',0),(51323,1426,'sv','Efterbehandling urval',0),(51324,1426,'it','Selezione di finitura',0),(51325,1426,'tl','',0),(51326,1426,'th','&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(51327,1426,'hi','à¤šà¤¯à¤¨ à¤ªà¤°à¤¿à¤·à¥à¤•à¤°à¤£',0),(51328,1426,'ms','Pilihan kemasan',0),(51329,1426,'ar','Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ù…Ù† Ø§Ù„ØªØ­Ø¯ÙŠØ¯',0),(51330,1426,'fr','SÃ©lection de finition',0),(51331,1426,'jp','é?¸æŠžã‚’å®Œäº†ã?—ã?¦ã?„ã?¾ã?™',0),(51332,1426,'pt','SeleÃ§Ã£o de acabamento',0),(51333,1426,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ðµ Ð’Ñ‹Ð±Ð¾Ñ€Ð°',0),(51334,1426,'es','Terminando SelecciÃ³n ',0),(51335,1426,'de','Abschluss Auswahl',0),(51336,1426,'en','Finishing Selection',0),(51337,1427,'is','',0),(51338,1427,'dr','Ø§ÙˆÙ„ÙŠÙ† ',0),(51339,1427,'pr','Ø§ÙˆÙ„ÙŠÙ† ',0),(51340,1427,'tr','Ä°lk',0),(51341,1427,'pl','Pierwszy',0),(51342,1427,'bg','ÐŸÑŠÑ€Ð²Ð¾',0),(51343,1427,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’',0),(51344,1427,'sr','ÐŸÑ€Ð²Ð¸',0),(51345,1427,'vi','Äáº§u tiÃªn',0),(51346,1427,'af','Voornaam',0),(51347,1427,'ro','Prima',0),(51348,1427,'et','Esimene',0),(51349,1427,'si','Prvi',0),(51350,1427,'ba','Pertama',0),(51351,1427,'nl','Eerste',0),(51352,1427,'fi','EnsimmÃ¤inen',0),(51353,1427,'no','FÃ¸rste',0),(51354,1427,'da','FÃ¸rste',0),(51355,1427,'ko','ì²« ë²ˆì§¸',0),(51356,1427,'he','×¨××©×•×Ÿ',0),(51357,1427,'el','Î ÏÏŽÏ„Î·',0),(51358,1427,'zh','ç¬¬ä¸€\r\n',0),(51359,1427,'sv','FÃ¶rsta',0),(51360,1427,'it','Primo',0),(51361,1427,'tl','',0),(51362,1427,'th','&#3621;&#3635;&#3604;&#3633;&#3610;&#3607;&#3637;&#3656;&#3627;&#3609;&#3638;&#3656;&#3591;',0),(51363,1427,'hi','à¤ªà¥à¤°à¤¥à¤®',0),(51364,1427,'ms','Pertama',0),(51365,1427,'ar','Ø§Ù„Ø£ÙˆÙ„',0),(51366,1427,'fr','PremiÃ¨re',0),(51367,1427,'jp','åˆ?æœŸ',0),(51368,1427,'pt','Primeiro',0),(51369,1427,'ru','ÐŸÐµÑ€Ð²Ñ‹Ð¹',0),(51370,1427,'es','Primero',0),(51371,1427,'de','Erste',0),(51372,1427,'en','First',0),(51373,1428,'is','',0),(51374,1428,'dr','Ø§ÙˆÙ„ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ ',0),(51375,1428,'pr','Ø§ÙˆÙ„ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ ',0),(51376,1428,'tr','Ä°lk maliyet',0),(51377,1428,'pl','Koszt pierwszego',0),(51378,1428,'bg','ÐŸÑŠÑ€Ð²Ð° Ñ†ÐµÐ½Ð°',0),(51379,1428,'ur','Ù¾ÛÙ„ÛŒ Ù‚ÛŒÙ…Øª',0),(51380,1428,'sr','ÐŸÑ€Ð²Ð¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(51381,1428,'vi','GiÃ¡ thÃ nh Ä‘áº§u tiÃªn',0),(51382,1428,'af','Eerste Koste',0),(51383,1428,'ro','Primul Cost',0),(51384,1428,'et','Esimene kulu',0),(51385,1428,'si','Prvo stroÅ¡kov',0),(51386,1428,'ba','Biaya pertama',0),(51387,1428,'nl','Eerste kosten',0),(51388,1428,'fi','EnsimmÃ¤inen kustannukset',0),(51389,1428,'no','FÃ¸rste prisen',0),(51390,1428,'da','FÃ¸rste omkostninger',0),(51391,1428,'ko','ì²« ë²ˆì§¸ ë¹„ìš©',0),(51392,1428,'he','×¢×œ×•×ª ×”×¨××©×•×Ÿ',0),(51393,1428,'el','Î ÏÏŽÏ„Î· ÎºÏŒÏƒÏ„Î¿Ï‚',0),(51394,1428,'zh','åˆæˆæœ¬\r\n',0),(51395,1428,'sv','FÃ¶rsta kostnad',0),(51396,1428,'it','Costo primo',0),(51397,1428,'tl','',0),(51398,1428,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3621;&#3635;&#3604;&#3633;&#3610;&#3649;&#3619;&#3585;',0),(51399,1428,'hi','à¤ªà¤¹à¤²à¥€ à¤²à¤¾à¤—à¤¤',0),(51400,1428,'ms','Kos yang pertama',0),(51401,1428,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(51402,1428,'fr','CoÃ»t premier',0),(51403,1428,'jp','åˆ?æœŸè²»ç”¨',0),(51404,1428,'pt','Primeiro custo',0),(51405,1428,'ru','ÐŸÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(51406,1428,'es','Costo Primero',0),(51407,1428,'de','Erste Kosten',0),(51408,1428,'en','First Cost',0),(51409,1429,'is','',0),(51410,1429,'dr','Ù†Ø§Ù… ',0),(51411,1429,'pr','Ù†Ø§Ù… ',0),(51412,1429,'tr','Ä°lk ad',0),(51413,1429,'pl','ImiÄ™',0),(51414,1429,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ Ð¸Ð¼Ðµ',0),(51415,1429,'ur','Ù¾ÛÙ„Ø§ Ù†Ø§Ù…',0),(51416,1429,'sr','ÐŸÑ€Ð²Ð¾ Ð¸Ð¼Ðµ',0),(51417,1429,'vi','TÃªn riÃªng',0),(51418,1429,'af','Voornaam',0),(51419,1429,'ro','Prenume',0),(51420,1429,'et','Eesnimi',0),(51421,1429,'si','Ime',0),(51422,1429,'ba','Nama pertama',0),(51423,1429,'nl','Voornaam',0),(51424,1429,'fi','Etunimi',0),(51425,1429,'no','Fornavn',0),(51426,1429,'da','Fornavn',0),(51427,1429,'ko','ì²« ë²ˆì§¸ ì´ë¦„',0),(51428,1429,'he','×©× ×¤×¨×˜×™',0),(51429,1429,'el','ÎŒÎ½Î¿Î¼Î±',0),(51430,1429,'zh','åå­—\r\n',0),(51431,1429,'sv','FÃ¶rnamn',0),(51432,1429,'it','Nome',0),(51433,1429,'tl','',0),(51434,1429,'th','&#3594;&#3639;&#3656;&#3629;&#3649;&#3619;&#3585;',0),(51435,1429,'hi','à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤®',0),(51436,1429,'ms','Nama pertama',0),(51437,1429,'ar','Ø§Ù„Ø¥Ø³Ù… Ø§Ù„Ø£ÙˆÙ„',0),(51438,1429,'fr','PrÃ©nom',0),(51439,1429,'jp','å??å‰?',0),(51440,1429,'pt','Primeiro nome',0),(51441,1429,'ru','Ð˜Ð¼Ñ',0),(51442,1429,'es','Primer Nombre',0),(51443,1429,'de','Vorname',0),(51444,1429,'en','First Name',0),(51445,1430,'is','',0),(51446,1430,'dr','Ø§ÙˆÙ„ÙŠÙ† Ø¨Ø§Ø²Ø®ÙˆØ§Ù†ÙŠ ',0),(51447,1430,'pr','Ø§ÙˆÙ„ÙŠÙ† Ø¨Ø§Ø²Ø®ÙˆØ§Ù†ÙŠ ',0),(51448,1430,'tr','Ä°lk okuma',0),(51449,1430,'pl','Najpierw przeczytaÄ‡ na',0),(51450,1430,'bg','ÐŸÑŠÑ€Ð²Ð¾ Ñ‡ÐµÑ‚ÐµÐ½Ðµ Ð½Ð°',0),(51451,1430,'ur','Ù¾Ø± Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ù¾Ú‘Ú¾ÛŒÚº',0),(51452,1430,'sr','ÐŸÑ€Ð²Ð¾ Ñ‡Ð¸Ñ‚Ð°ÑšÐµ Ð½Ð°',0),(51453,1430,'vi','Äá»c Ä‘áº§u tiÃªn',0),(51454,1430,'af','Eerste lees op',0),(51455,1430,'ro','Citi primul pe',0),(51456,1430,'et','Esimene Loe edasi',0),(51457,1430,'si','Prvo branje na',0),(51458,1430,'ba','Pertama membaca',0),(51459,1430,'nl','Eerste lezen op',0),(51460,1430,'fi','EnsimmÃ¤inen lukea',0),(51461,1430,'no','FÃ¸rste lese pÃ¥',0),(51462,1430,'da','FÃ¸rste LÃ¦s pÃ¥',0),(51463,1430,'ko','ì²« ë²ˆì§¸ ì½ê¸°ì—',0),(51464,1430,'he','×§×¨×™××” ×¨××©×•× ×”-',0),(51465,1430,'el','Î ÏÏŽÏ„Î· Î±Î½Î¬Î³Î½Ï‰ÏƒÎ· ÏƒÏ„Î¹Ï‚',0),(51466,1430,'zh','ç¬¬ä¸€ç»§ç»­é˜…è¯»\r\n',0),(51467,1430,'sv','FÃ¶rst lÃ¤sa pÃ¥',0),(51468,1430,'it','Prima lettura su',0),(51469,1430,'tl','',0),(51470,1430,'th','&#3629;&#3656;&#3634;&#3609;&#3605;&#3656;&#3629;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3592;&#3634;&#3585;&#3621;&#3635;&#3604;&#3633;&#3610;&#3649;&#3619;&#3585;',0),(51471,1430,'hi','à¤ªà¤° à¤ªà¤¹à¤²à¥€ à¤¬à¤¾à¤° à¤ªà¤¢à¤¼à¤¾',0),(51472,1430,'ms','Pertama Baca pada',0),(51473,1430,'ar','Ø§Ù„Ù‚Ø±Ø§Ø¡Ø© Ø§Ù„Ø£ÙˆÙ„Ù‰ ÙÙŠ',0),(51474,1430,'fr','PremiÃ¨re lecture sur',0),(51475,1430,'jp','First Read On',0),(51476,1430,'pt','Primeira leitura na',0),(51477,1430,'ru','ÐŸÐµÑ€Ð²Ñ‹Ð¹ Ñ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð½Ð°',0),(51478,1430,'es','Primera Lectura Prendida',0),(51479,1430,'de','Erste weiterlesen',0),(51480,1430,'en','First Read On',0),(51481,1431,'is','',0),(51482,1431,'dr','Ø§ÙˆÙ„ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ù…ØµØ±Ù ',0),(51483,1431,'pr','Ø§ÙˆÙ„ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ù…ØµØ±Ù ',0),(51484,1431,'tr','Ä°lk kullanÄ±m Ã¼creti',0),(51485,1431,'pl','Po raz pierwszy korzystaÄ‡ bezpÅ‚atnie',0),(51486,1431,'bg','ÐŸÑŠÑ€Ð²Ð¾ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð·Ð°Ñ€ÑÐ´',0),(51487,1431,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§Ù„Ø²Ø§Ù… Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(51488,1431,'sr','ÐŸÑ€Ð²Ð¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(51489,1431,'vi','PhÃ­ dÃ¹ng Ä‘áº§u tiÃªn',0),(51490,1431,'af','Gebruik eerste aanklag',0),(51491,1431,'ro','Prima taxa de utilizare',0),(51492,1431,'et','KÃµigepealt Kasuta kulu',0),(51493,1431,'si','Prvo polnjenje uporabe',0),(51494,1431,'ba','Pertama menggunakan biaya',0),(51495,1431,'nl','Eerste gebruik gratis',0),(51496,1431,'fi','EnsimmÃ¤inen kÃ¤yttÃ¶maksu',0),(51497,1431,'no','FÃ¸rste bruk Charge',0),(51498,1431,'da','FÃ¸rste brug afgift',0),(51499,1431,'ko','ì²« ë²ˆì§¸ ì‚¬ìš© ìš”ê¸ˆ',0),(51500,1431,'he','×ª×—×™×œ×” ×œ×”×©×ª×ž×© ×ª×©×œ×•×',0),(51501,1431,'el','Î ÏÏŽÏ„Î· Ï€Î¬Î³Î¹Î¿ Ï„Î­Î»Î¿Ï‚ Ï‡ÏÎ®ÏƒÎ·Ï‚',0),(51502,1431,'zh','ç¬¬ä¸€æ¬¡ä½¿ç”¨è´¹\r\n',0),(51503,1431,'sv','FÃ¶rst anvÃ¤nda avgift',0),(51504,1431,'it','Prima carica di uso',0),(51505,1431,'tl','',0),(51506,1431,'th','&#3585;&#3634;&#3619;&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3651;&#3609;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3588;&#3619;&#3633;&#3657;&#3591;&#3649;&#3619;&#3585;',0),(51507,1431,'hi','à¤ªà¥à¤°à¤¥à¤® à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¥‡ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(51508,1431,'ms','Caj penggunaan pertama',0),(51509,1431,'ar','Ø£ÙˆÙ„Ø§Ù‹ Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªÙ‡Ù…Ø©',0),(51510,1431,'fr','Tout d\'abord utiliser gratuitement',0),(51511,1431,'jp','åˆ?æœŸä½¿ç”¨æ–™',0),(51512,1431,'pt','Primeira carga de uso',0),(51513,1431,'ru','ÐŸÐµÑ€Ð²Ð¾Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð·Ð°Ñ€ÑÐ´Ð°',0),(51514,1431,'es','Carga para Primer Uso',0),(51515,1431,'de','Verwenden Sie zunÃ¤chst kostenlos',0),(51516,1431,'en','First Use Charge',0),(51517,1432,'is','',0),(51518,1432,'dr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ',0),(51519,1432,'pr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ',0),(51520,1432,'tr','Set mali yÄ±l',0),(51521,1432,'pl','Zestaw rok obrachunkowy',0),(51522,1432,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(51523,1432,'ur','Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„',0),(51524,1432,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(51525,1432,'vi','Äáº·t nÄƒm tÃ i chÃ­nh',0),(51526,1432,'af','Stel Fiskale jaar',0),(51527,1432,'ro','Set Anul Fiscal',0),(51528,1432,'et','Sea majandusaasta',0),(51529,1432,'si','Nastavite proraÄunsko leto',0),(51530,1432,'ba','Set tahun fiskal',0),(51531,1432,'nl','Boekjaar instellen',0),(51532,1432,'fi','MÃ¤Ã¤ritÃ¤ tilikauden',0),(51533,1432,'no','Angi regnskapsÃ¥r',0),(51534,1432,'da','Angiv regnskabsÃ¥ret',0),(51535,1432,'ko','ì„¤ì •ëœ íšŒê³„ ì—°ë„',0),(51536,1432,'he','×”×’×“×¨×ª ×©× ×ª ×”×›×¡×¤×™×',0),(51537,1432,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ ÎŸÎ™ÎšÎŸÎ.',0),(51538,1432,'zh','è®¾ç½®è´¢æ”¿å¹´\r\n',0),(51539,1432,'sv','Ange rÃ¤kenskapsÃ¥ret',0),(51540,1432,'it','Impostato l\'anno fiscale',0),(51541,1432,'tl','',0),(51542,1432,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3611;&#3637;&#3607;&#3634;&#3591;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;',0),(51543,1432,'hi','à¤¸à¥‡à¤Ÿ à¤µà¤¿à¤¤à¥à¤¤à¥€à¤¯ à¤µà¤°à¥à¤·',0),(51544,1432,'ms','Tahun fiskal yang ditetapkan',0),(51545,1432,'ar','ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(51546,1432,'fr','Set exercice',0),(51547,1432,'jp','å–¶æ¥­å¹´åº¦ã?®è¨­å®š',0),(51548,1432,'pt','ExercÃ­cio conjunto',0),(51549,1432,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´',0),(51550,1432,'es','Configurar Ejercicio Fiscal',0),(51551,1432,'de','Set GeschÃ¤ftsjahr',0),(51552,1432,'en','Set Fiscal Year',0),(51553,1433,'is','',0),(51554,1433,'dr','Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ ',0),(51555,1433,'pr','Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ ',0),(51556,1433,'tr','Mali baÅŸlangÄ±Ã§ ay',0),(51557,1433,'pl','Fiskalnej poczÄ…tek miesiÄ…ca',0),(51558,1433,'bg','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð¸ Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð¼ÐµÑÐµÑ†',0),(51559,1433,'ur','Ù…Ø§Ù„ÛŒ Ø´Ø±ÙˆØ¹ Ù…ÛÛŒÙ†Û',0),(51560,1433,'sr','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð¸ Ð‘ÐµÐ³Ð¸Ð½ Ð¼ÐµÑÐµÑ†Ð°',0),(51561,1433,'vi','ThÃ¡ng báº¯t Ä‘áº§u nÄƒm tÃ i chÃ­nh',0),(51562,1433,'af','Fisiese Beginmaand',0),(51563,1433,'ro','Fiscale Ã®ncepe luna',0),(51564,1433,'et','Finantsaasta algab kuu',0),(51565,1433,'si','Fiskalni zaÄetek meseca',0),(51566,1433,'ba','Fiskal dimulai bulan',0),(51567,1433,'nl','Fiscale Begin maand',0),(51568,1433,'fi','Julkisen talouden alkaa kuukauden',0),(51569,1433,'no','RegnskapsÃ¥ret begynner mÃ¥ned',0),(51570,1433,'da','Finanspolitiske Begin mÃ¥ned',0),(51571,1433,'ko','íšŒê³„ ì—°ë„ ì‹œìž‘ ë‹¬',0),(51572,1433,'he','×—×•×“×© ×‘×’×™×Ÿ ×”×›×¡×¤×™×',0),(51573,1433,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Begin Î¼Î®Î½Î±',0),(51574,1433,'zh','è´¢æ”¿å¼€å§‹æœˆ\r\n',0),(51575,1433,'sv','Finanspolitiska bÃ¶rja mÃ¥nad',0),(51576,1433,'it','Begin fiscale mese',0),(51577,1433,'tl','',0),(51578,1433,'th','&#3648;&#3604;&#3639;&#3629;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3607;&#3634;&#3591;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;',0),(51579,1433,'hi','à¤°à¤¾à¤œà¤•à¥‹à¤·à¥€à¤¯ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤®à¤¾à¤¹',0),(51580,1433,'ms','Mulakan fiskal bulan',0),(51581,1433,'ar','Ø´Ù‡Ø± Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(51582,1433,'fr','Mois de l\'exercice Begin',0),(51583,1433,'jp','è²¡å‹™é–‹å§‹æœˆ',0),(51584,1433,'pt','MÃªs fiscal Begin',0),(51585,1433,'ru','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð½Ð°Ñ‡Ð°Ð»Ð¾ Ð¼ÐµÑÑÑ†Ð°',0),(51586,1433,'es','Mes de Inicio Fiscal',0),(51587,1433,'de','Steuerliche Begin Monat',0),(51588,1433,'en','Fiscal Begin Month',0),(51589,1434,'is','',0),(51590,1434,'dr','Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ',0),(51591,1434,'pr','Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ',0),(51592,1434,'tr','Mali yÄ±l',0),(51593,1434,'pl','Rok obrachunkowy',0),(51594,1434,'bg','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(51595,1434,'ur','Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„',0),(51596,1434,'sr','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(51597,1434,'vi','NÄƒm tÃ i chÃ­nh',0),(51598,1434,'af','Fisiese Jaar',0),(51599,1434,'ro','Anul fiscal',0),(51600,1434,'et','Majandusaasta',0),(51601,1434,'si','Poslovno leto',0),(51602,1434,'ba','Tahun fiskal',0),(51603,1434,'nl','Boekjaar',0),(51604,1434,'fi','Tilikauden',0),(51605,1434,'no','RegnskapsÃ¥ret',0),(51606,1434,'da','RegnskabsÃ¥r',0),(51607,1434,'ko','íšŒê³„ ì—°ë„',0),(51608,1434,'he','×©× ×ª ×›×¡×¤×™×',0),(51609,1434,'el','ÎŸÎ™ÎšÎŸÎ.',0),(51610,1434,'zh','è´¢æ”¿å¹´åº¦\r\n',0),(51611,1434,'sv','RÃ¤kenskapsÃ¥r',0),(51612,1434,'it','Anno fiscale',0),(51613,1434,'tl','',0),(51614,1434,'th','&#3611;&#3637;&#3607;&#3634;&#3591;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;',0),(51615,1434,'hi','à¤µà¤¿à¤¤à¥à¤¤ à¤µà¤°à¥à¤·',0),(51616,1434,'ms','Tahun fiskal',0),(51617,1434,'ar','Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(51618,1434,'fr','Exercice',0),(51619,1434,'jp','ä¼šè¨ˆå¹´åº¦',0),(51620,1434,'pt','Ano fiscal',0),(51621,1434,'ru','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´',0),(51622,1434,'es','AÃ±o Fiscal',0),(51623,1434,'de','GeschÃ¤ftsjahr',0),(51624,1434,'en','Fiscal Year',0),(51625,1435,'is','',0),(51626,1435,'dr','Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ',0),(51627,1435,'pr','Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ',0),(51628,1435,'tr','Mali yÄ±lÄ±n baÅŸlangÄ±Ã§',0),(51629,1435,'pl','PoczÄ…tek roku obrachunkowego',0),(51630,1435,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(51631,1435,'ur','Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ú©Û’ Ø¢ØºØ§Ø²',0),(51632,1435,'sr','ÐžÐ·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(51633,1435,'vi','Báº¯t Ä‘áº§u nÄƒm tÃ i chÃ­nh',0),(51634,1435,'af','Fisiese Jaar Begin',0),(51635,1435,'ro','Inceput de an fiscal',0),(51636,1435,'et','Majandusaasta algus',0),(51637,1435,'si','ZaÄetek poslovnega leta',0),(51638,1435,'ba','Mulai tahun fiskal',0),(51639,1435,'nl','Begin van het boekjaar',0),(51640,1435,'fi','Tilikauden alku',0),(51641,1435,'no','RegnskapsÃ¥ret begynner',0),(51642,1435,'da','RegnskabsÃ¥ret begynder',0),(51643,1435,'ko','íšŒê³„ ì—°ë„ ì‹œìž‘',0),(51644,1435,'he','×‘×’×™×Ÿ ×©× ×ª ×”×›×¡×¤×™×',0),(51645,1435,'el','ÎˆÎ½Î±ÏÎ¾Î· Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÎ¿Ï Î­Ï„Î¿Ï…Ï‚',0),(51646,1435,'zh','è´¢æ”¿å¼€å§‹å¹´åº¦\r\n',0),(51647,1435,'sv','RÃ¤kenskapsÃ¥ret bÃ¶rjar',0),(51648,1435,'it','Begin anno fiscale',0),(51649,1435,'tl','',0),(51650,1435,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3611;&#3637;&#3607;&#3634;&#3591;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;',0),(51651,1435,'hi','à¤µà¤¿à¤¤à¥à¤¤à¥€à¤¯ à¤µà¤°à¥à¤· à¤•à¥‡ à¤¶à¥à¤°à¥‚',0),(51652,1435,'ms','Mulakan tahun fiskal',0),(51653,1435,'ar','Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(51654,1435,'fr','DÃ©but de l\'exercice',0),(51655,1435,'jp','ä¼šè¨ˆå¹´åº¦å§‹ã‚?',0),(51656,1435,'pt','InÃ­cio de ano fiscal',0),(51657,1435,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð¾Ð³Ð¾ Ð³Ð¾Ð´Ð°',0),(51658,1435,'es','Comienza el AÃ±o Fiscal',0),(51659,1435,'de','GeschÃ¤ftsjahr Begin',0),(51660,1435,'en','Fiscal Year Begin',0),(51661,1436,'is','',0),(51662,1436,'dr','Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø´Ø±ÙˆØ¹ Ù…ÙŠ Ø´ÙˆØ¯ Ø¯Ø± ',0),(51663,1436,'pr','Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø´Ø±ÙˆØ¹ Ù…ÙŠ Ø´ÙˆØ¯ Ø¯Ø± ',0),(51664,1436,'tr','Mali yÄ±l baÅŸlangÄ±cÄ±',0),(51665,1436,'pl','PoczÄ…tek roku obrachunkowego',0),(51666,1436,'bg','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð½Ð°',0),(51667,1436,'ur','Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ú©Ùˆ Ø´Ø±ÙˆØ¹ ÛÙˆØªØ§ ÛÛ’',0),(51668,1436,'sr','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð¿Ð¾Ñ‡Ð¸ÑšÐµ',0),(51669,1436,'vi','NÄƒm tÃ i chÃ­nh Báº¯t Ä‘áº§u vÃ o',0),(51670,1436,'af','Fisiese Jaar begin op',0),(51671,1436,'ro','Anul fiscal incepe pe',0),(51672,1436,'et','Majandusaasta algus',0),(51673,1436,'si','Poslovno leto se zaÄne na',0),(51674,1436,'ba','Tahun fiskal dimulai pada',0),(51675,1436,'nl','Fiscaal jaar begint op',0),(51676,1436,'fi','Tilivuoden alkupÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(51677,1436,'no','RegnskapsÃ¥ret begynner',0),(51678,1436,'da','RegnskabsÃ¥ret begynder pÃ¥',0),(51679,1436,'ko','íšŒê³„ ì—°ë„ ì‹œìž‘',0),(51680,1436,'he','×©× ×ª ×”×›×¡×¤×™× ×ž×ª×—×™×œ×” ×‘',0),(51681,1436,'el','ÎŸÎ¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚ Î±ÏÏ‡Î¯Î¶ÎµÎ¹ Ï„Î·Î½',0),(51682,1436,'zh','è´¢å¹´è‡ª\r\n',0),(51683,1436,'sv','RÃ¤kenskapsÃ¥ret startar pÃ¥',0),(51684,1436,'it','L\'anno fiscale inizia il',0),(51685,1436,'tl','',0),(51686,1436,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3611;&#3637;&#3607;&#3634;&#3591;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;&#3586;&#3629;&#3591;',0),(51687,1436,'hi','à¤ªà¤° à¤µà¤¿à¤¤à¥à¤¤à¥€à¤¯ à¤µà¤°à¥à¤· à¤•à¥‡ à¤¶à¥à¤°à¥‚ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ',0),(51688,1436,'ms','Tahun kewangan bermula pada',0),(51689,1436,'ar','ØªØ¨Ø¯Ø£ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© ÙÙŠ ',0),(51690,1436,'fr','Exercice commence sur',0),(51691,1436,'jp','å–¶æ¥­å¹´åº¦é–‹å§‹',0),(51692,1436,'pt','Ano fiscal comeÃ§a em',0),(51693,1436,'ru','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´ Ð½Ð°Ñ‡Ð¸Ð½Ð°ÐµÑ‚ÑÑ Ð½Ð°',0),(51694,1436,'es','Comienza el aÃ±o fiscal en',0),(51695,1436,'de','GeschÃ¤ftsjahr beginnt am',0),(51696,1436,'en','Fiscal year begins on',0),(51697,1437,'is','',0),(51698,1437,'dr','/ Ù…Ø§Ù‡ ',0),(51699,1437,'pr','Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ / Ù…Ø§Ù‡ ',0),(51700,1437,'tr','Mali yÄ±l/ay',0),(51701,1437,'pl','MiesiÄ…c/rok obrachunkowy',0),(51702,1437,'bg','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°/Ð¼ÐµÑÐµÑ†',0),(51703,1437,'ur','Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ù…ÛŒÚº Ø§ÛŒÚ© Ù…ÛÛŒÙ†Û',0),(51704,1437,'sr','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ/Ð¼ÐµÑÐµÑ†',0),(51705,1437,'vi','NÄƒm tÃ i chÃ­nh/ThÃ¡ng',0),(51706,1437,'af','Fisies Jaar/Maand',0),(51707,1437,'ro','Anul fiscal/luna',0),(51708,1437,'et','Majandusaasta/kuus',0),(51709,1437,'si','Poslovno leto/mesec',0),(51710,1437,'ba','Tahun fiskal/bulan',0),(51711,1437,'nl','Fiscale jaar/maand',0),(51712,1437,'fi','Tilikausi/kk',0),(51713,1437,'no','Ã…r/mÃ¥ned',0),(51714,1437,'da','RegnskabsÃ¥r/mÃ¥ned',0),(51715,1437,'ko','íšŒê³„ ì—°ë„/ì›”',0),(51716,1437,'he','×©× ×ª ×”×›×¡×¤×™×/×—×•×“×©',0),(51717,1437,'el','ÎŸÎ¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÎ¿Ï Î­Ï„Î¿Ï…Ï‚/Î¼Î®Î½Î±',0),(51718,1437,'zh','è´¢å¹´æœˆ\r\n',0),(51719,1437,'sv','RÃ¤kenskapsÃ¥r/mÃ¥nad',0),(51720,1437,'it','Anno fiscale/mese',0),(51721,1437,'tl','',0),(51722,1437,'th','&#3611;&#3637;/&#3648;&#3604;&#3639;&#3629;&#3609;&#3607;&#3634;&#3591;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;',0),(51723,1437,'hi','à¤µà¤¿à¤¤à¥à¤¤ à¤µà¤°à¥à¤·/à¤®à¤¾à¤¹',0),(51724,1437,'ms','Tahun fiskal/bulan',0),(51725,1437,'ar','Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© ÙÙŠ Ø§Ù„Ø´Ù‡Ø±',0),(51726,1437,'fr','Exercice/mois',0),(51727,1437,'jp','å–¶æ¥­å¹´åº¦/æœˆ',0),(51728,1437,'pt','MÃªs/ano fiscal',0),(51729,1437,'ru','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´/Ð¼ÐµÑÑÑ†',0),(51730,1437,'es','AÃ±o/Mes Fiscal',0),(51731,1437,'de','GeschÃ¤ftsjahr/Monat',0),(51732,1437,'en','Fiscal Year/Month',0),(51733,1438,'is','',0),(51734,1438,'dr','/ Ù…Ø¯Øª Ù…Ø§Ù‡',0),(51735,1438,'pr','Fiscal Year/Month Period',0),(51736,1438,'tr','Mali yÄ±l/ay vade',0),(51737,1438,'pl','Okresu roku podatkowego/miesiÄ…c',0),(51738,1438,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´ Ð½Ð° Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°/Ð¼ÐµÑÐµÑ†',0),(51739,1438,'ur','Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ù…ÛŒÚº Ø§ÛŒÚ© Ù…ÛÛŒÙ†Û Ú©ÛŒ Ù…Ø¯Øª',0),(51740,1438,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ/Ð¼ÐµÑÐµÑ†',0),(51741,1438,'vi','NÄƒm tÃ i chÃ­nh/Thá»i ká»³ ThÃ¡ng',0),(51742,1438,'af','Fisiese Jaar/Maand Periode',0),(51743,1438,'ro','Anul fiscal/lunÄƒ',0),(51744,1438,'et','Majandusaasta/kuu jooksul',0),(51745,1438,'si','Obdobje poslovnega leta/mesec',0),(51746,1438,'ba','Tahun fiskal/bulan',0),(51747,1438,'nl','Fiscale jaar/maand periode',0),(51748,1438,'fi','Vuoden/kuukauden aikana',0),(51749,1438,'no','Ã…r/mÃ¥neder',0),(51750,1438,'da','RegnskabsÃ¥r/mÃ¥ned periode',0),(51751,1438,'ko','íšŒê³„ ì—°ë„/ì›” ê¸°ê°„',0),(51752,1438,'he','×ª×§×•×¤×ª ×”×›×¡×¤×™×/×—×•×“×©',0),(51753,1438,'el','Î ÎµÏÎ¯Î¿Î´Î¿ Ï„Î¿Ï… Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÎ¿Ï Î­Ï„Î¿Ï…Ï‚/Î¼Î®Î½Î±',0),(51754,1438,'zh','è´¢æ”¿å¹´åº¦ä¸ªæœˆæœŸé—´\r\n',0),(51755,1438,'sv','RÃ¤kenskapsÃ¥r/mÃ¥nader',0),(51756,1438,'it','Periodo anno fiscale/mese',0),(51757,1438,'tl','',0),(51758,1438,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3611;&#3637;/&#3648;&#3604;&#3639;&#3629;&#3609;&#3607;&#3634;&#3591;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;',0),(51759,1438,'hi','à¤µà¤¿à¤¤à¥à¤¤ à¤µà¤°à¥à¤·/à¤®à¤¾à¤¹ à¤•à¥€ à¤…à¤µà¤§à¤¿',0),(51760,1438,'ms','Tempoh tahun fiskal/bulan',0),(51761,1438,'ar','ÙØªØ±Ø© Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© ÙÙŠ Ø§Ù„Ø´Ù‡Ø±',0),(51762,1438,'fr','Exercice/mois',0),(51763,1438,'jp','å–¶æ¥­å¹´åº¦/æœˆé–“',0),(51764,1438,'pt','PerÃ­odo do ano fiscal/mÃªs',0),(51765,1438,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´/Ð¼ÐµÑÑÑ†',0),(51766,1438,'es','PeriÃ³do de AÃ±o/Mes Fiscal',0),(51767,1438,'de','GeschÃ¤ftsjahr/Monate',0),(51768,1438,'en','Fiscal Year/Month Period',0),(51769,1439,'is','',0),(51770,1439,'dr','FIT   Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¯ÙˆÙ„ØªÙŠ',0),(51771,1439,'pr','FIT   Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¯ÙˆÙ„ØªÙŠ\r\n',0),(51772,1439,'tr','UYGUN',0),(51773,1439,'pl','PASUJE',0),(51774,1439,'bg','FIT',0),(51775,1439,'ur','Ù…ÙˆØ²ÙˆÚº',0),(51776,1439,'sr','Ð”Ð Ð¡Ð¢ÐÐÐ•',0),(51777,1439,'vi','FIT',0),(51778,1439,'af','PAS',0),(51779,1439,'ro','SE POTRIVESC',0),(51780,1439,'et','SOBIVAD',0),(51781,1439,'si','FIT',0),(51782,1439,'ba','COCOK',0),(51783,1439,'nl','PASSEN',0),(51784,1439,'fi','SOVI',0),(51785,1439,'no','PASSER',0),(51786,1439,'da','PASSER',0),(51787,1439,'ko','ì— ë§žê²Œ',0),(51788,1439,'he','×ž×ª××™×',0),(51789,1439,'el','Î¤Î‘Î™Î¡Î™Î†Î–Î•Î™',0),(51790,1439,'zh','è”é‚¦æ”¶å…¥æ‰€å¾—ç¨Ž\r\n',0),(51791,1439,'sv','PASSAR',0),(51792,1439,'it','MONTARE',0),(51793,1439,'tl','',0),(51794,1439,'th','FIT',0),(51795,1439,'hi','à¤«à¤¿à¤Ÿ',0),(51796,1439,'ms','PATUT',0),(51797,1439,'ar','ØªÙ†Ø§Ø³Ø¨',0),(51798,1439,'fr','S\'ADAPTER',0),(51799,1439,'jp','é€£é‚¦æ‰€å¾—ç¨Ž',0),(51800,1439,'pt','CABER',0),(51801,1439,'ru','FIT',0),(51802,1439,'es','FIT',0),(51803,1439,'de','PASSEN',0),(51804,1439,'en','FIT',0),(51805,1440,'is','',0),(51806,1440,'dr','Ù¾Ù†Ø¬ ',0),(51807,1440,'pr','Ù¾Ù†Ø¬ ',0),(51808,1440,'tr','beÅŸ',0),(51809,1440,'pl','piÄ™Ä‡',0),(51810,1440,'bg','Ð¿ÐµÑ‚',0),(51811,1440,'ur','Ù¾Ø§Ù†Ú†',0),(51812,1440,'sr','Ð¿ÐµÑ‚',0),(51813,1440,'vi','nÄƒm',0),(51814,1440,'af','vyf',0),(51815,1440,'ro','cinci',0),(51816,1440,'et','viis',0),(51817,1440,'si','pet',0),(51818,1440,'ba','lima',0),(51819,1440,'nl','vijf',0),(51820,1440,'fi','viisi',0),(51821,1440,'no','fem',0),(51822,1440,'da','fem',0),(51823,1440,'ko','5',0),(51824,1440,'he','×—×ž×©',0),(51825,1440,'el','Ï€Î­Î½Ï„Îµ',0),(51826,1440,'zh','äº”\r\n',0),(51827,1440,'sv','fem',0),(51828,1440,'it','cinque',0),(51829,1440,'tl','',0),(51830,1440,'th','&#3627;&#3657;&#3634;',0),(51831,1440,'hi','à¤ªà¤¾à¤‚à¤š',0),(51832,1440,'ms','lima',0),(51833,1440,'ar','Ø®Ù…Ø³Ø©',0),(51834,1440,'fr','cinq',0),(51835,1440,'jp','5',0),(51836,1440,'pt','cinco',0),(51837,1440,'ru','Ð¿ÑÑ‚ÑŒ',0),(51838,1440,'es','cinco',0),(51839,1440,'de','fÃ¼nf',0),(51840,1440,'en','five',0),(51841,1441,'is','',0),(51842,1441,'dr','Ø¯Ø§Ø±Ø§ÙŠÙ‰ Ù‡Ø§Ù‰ Ø«Ø§Ø¨Øª',0),(51843,1441,'pr','Ø¯Ø§Ø±Ø§ÙŠÙ‰ Ù‡Ø§Ù‰ Ø«Ø§Ø¨Øª',0),(51844,1441,'tr','Sabit kÄ±ymetler',0),(51845,1441,'pl','ÅšrodkÃ³w trwaÅ‚ych',0),(51846,1441,'bg','Ð”ÑŠÐ»Ð³Ð¾Ñ‚Ñ€Ð°Ð¹Ð½Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð¸',0),(51847,1441,'ur','ÙÚ©Ø³Úˆ Ø§Ø«Ø§Ø«Û Ø¬Ø§Øª',0),(51848,1441,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð° ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°',0),(51849,1441,'vi','TÃ i sáº£n cá»‘ Ä‘á»‹nh',0),(51850,1441,'af','Vaste Bates',0),(51851,1441,'ro','Mijloace fixe',0),(51852,1441,'et','PÃµhivara',0),(51853,1441,'si','Osnovna sredstva',0),(51854,1441,'ba','Aktiva tetap',0),(51855,1441,'nl','Vaste activa',0),(51856,1441,'fi','KÃ¤yttÃ¶omaisuuden',0),(51857,1441,'no','Anleggsmidler',0),(51858,1441,'da','AnlÃ¦gsaktiver',0),(51859,1441,'ko','ê³ ì •ëœ ìžì‚°',0),(51860,1441,'he','×¨×›×•×© ×§×‘×•×¢',0),(51861,1441,'el','Î Î±Î³Î¯Ï‰Î½ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¹Î±ÎºÏŽÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(51862,1441,'zh','å›ºå®šèµ„äº§\r\n',0),(51863,1441,'sv','AnlÃ¤ggningstillgÃ¥ngar',0),(51864,1441,'it','Cespiti',0),(51865,1441,'tl','',0),(51866,1441,'th','&#3626;&#3636;&#3609;&#3607;&#3619;&#3633;&#3614;&#3618;&#3660;&#3606;&#3634;&#3623;&#3619;',0),(51867,1441,'hi','à¤«à¤¿à¤•à¥à¤¸à¥à¤¡ à¤†à¤¸à¥à¤¤à¤¿à¤¯à¥‹à¤‚',0),(51868,1441,'ms','Aset tetap',0),(51869,1441,'ar','Ø§Ù„Ø£ØµÙˆÙ„ Ø§Ù„Ø«Ø§Ø¨ØªØ©',0),(51870,1441,'fr','Actifs fixes',0),(51871,1441,'jp','å›ºå®šè³‡ç”£',0),(51872,1441,'pt','Activos fixos',0),(51873,1441,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ðµ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°',0),(51874,1441,'es','Activos Fijos',0),(51875,1441,'de','AnlagevermÃ¶gen',0),(51876,1441,'en','Fixed Assets',0),(51877,1442,'is','',0),(51878,1442,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø§Ø¨Øª Ø¯Ù„Ø§Ø±',0),(51879,1442,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø§Ø¨Øª Ø¯Ù„Ø§Ø±',0),(51880,1442,'tr','Sabit tutarÄ±',0),(51881,1442,'pl','StaÅ‚ej kwoty w dolarach',0),(51882,1442,'bg','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ð° ÑÑƒÐ¼Ð° Ð·Ð° Ð´Ð¾Ð»Ð°Ñ€',0),(51883,1442,'ur','Ù…Ù‚Ø±Ø±Û ÚˆØ§Ù„Ø± Ú©ÛŒ Ù‚Ø¯Ø±',0),(51884,1442,'sr','Ð¤Ð¸ÐºÑÐ½Ð¸ Ð¸Ð·Ð½Ð¾Ñ Ð·Ð° Ð´Ð¾Ð»Ð°Ñ€',0),(51885,1442,'vi','Sá»‘ tiá»n dola cá»‘ Ä‘á»‹nh',0),(51886,1442,'af','Vaste Doller Bedrag',0),(51887,1442,'ro','SumÄƒ fixÄƒ de dolari',0),(51888,1442,'et','Dollar summa',0),(51889,1442,'si','Fiksni znesek v dolar',0),(51890,1442,'ba','Jumlah dolar yang tetap',0),(51891,1442,'nl','Vaste dollarbedrag',0),(51892,1442,'fi','KiinteÃ¤ dollarin summa',0),(51893,1442,'no','Fast dollarbelÃ¸p',0),(51894,1442,'da','Fast Dollar belÃ¸b',0),(51895,1442,'ko','ê³ ì • ëœ ë‹¬ëŸ¬ ê¸ˆì•¡',0),(51896,1442,'he','×¡×›×•× ×›×¡×£ ×§×‘×•×¢',0),(51897,1442,'el','Î£Ï„Î±Î¸ÎµÏÏŒ Ï€Î¿ÏƒÏŒ Î´Î¿Î»Î±ÏÎ¯Ï‰Î½',0),(51898,1442,'zh','å›ºå®šé‡‘é¢\r\n',0),(51899,1442,'sv','Fast Dollar belopp',0),(51900,1442,'it','Importo fisso del dollaro',0),(51901,1442,'tl','',0),(51902,1442,'th','&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3604;&#3629;&#3621;&#3621;&#3634;&#3619;&#3660;',0),(51903,1442,'hi','à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤¡à¥‰à¤²à¤° à¤•à¥€ à¤°à¤¾à¤¶à¤¿',0),(51904,1442,'ms','Jumlah dolar tetap',0),(51905,1442,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¯ÙˆÙ„Ø§Ø± Ø«Ø§Ø¨Øª',0),(51906,1442,'fr','Montant fixe',0),(51907,1442,'jp','å›ºå®šãƒ‰ãƒ«ç·?é¡?',0),(51908,1442,'pt','Quantidade fixa do dÃ³lar',0),(51909,1442,'ru','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð°Ñ ÑÑƒÐ¼Ð¼Ð° Ð² Ð´Ð¾Ð»Ð»Ð°Ñ€Ð°Ñ…',0),(51910,1442,'es','Monto en DÃ³lares Fijo',0),(51911,1442,'de','Dollarbetrag',0),(51912,1442,'en','Fixed Dollar Amount',0),(51913,1443,'is','',0),(51914,1443,'dr','Ø¯Ø±ØµØ¯ Ø«Ø§Ø¨Øª',0),(51915,1443,'pr','Ø¯Ø±ØµØ¯ Ø«Ø§Ø¨Øª',0),(51916,1443,'tr','DÃ¼z yÃ¼zde',0),(51917,1443,'pl','PÅ‚aski procent',0),(51918,1443,'bg','ÐŸÐ»Ð¾ÑÐºÐ¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(51919,1443,'ur','ÙÙ„ÛŒÙ¹ ØªÙ†Ø§Ø³Ø¨',0),(51920,1443,'sr','Ð Ð°Ð²Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚',0),(51921,1443,'vi','% 1 giÃ¡',0),(51922,1443,'af','Plat persentasie',0),(51923,1443,'ro','Procentul de plat',0),(51924,1443,'et','Korter protsent',0),(51925,1443,'si','PavÅ¡alni odstotek',0),(51926,1443,'ba','Persentase datar',0),(51927,1443,'nl','Platte percentage',0),(51928,1443,'fi','KiinteÃ¤ prosenttiosuus',0),(51929,1443,'no','Flatt prosent',0),(51930,1443,'da','Flad procentdel',0),(51931,1443,'ko','í”Œëž« ë¹„ìœ¨',0),(51932,1443,'he','××—×•×– ×©×˜×•×—',0),(51933,1443,'el','Î•Ï€Î¯Ï€ÎµÎ´Î· Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(51934,1443,'zh','å›ºå®šç™¾åˆ†æ¯”\r\n',0),(51935,1443,'sv','Platt procent',0),(51936,1443,'it','Percentuale piatta',0),(51937,1443,'tl','',0),(51938,1443,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3649;&#3609;&#3623;&#3609;&#3629;&#3609;',0),(51939,1443,'hi','à¤«à¥à¤²à¥ˆà¤Ÿ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(51940,1443,'ms','Peratusan yang rata',0),(51941,1443,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù…Ø³Ø·Ø­',0),(51942,1443,'fr','Pourcentage de plat',0),(51943,1443,'jp','å?‡ä¸€æ¯”çŽ‡',0),(51944,1443,'pt','Porcentagem plana',0),(51945,1443,'ru','ÐŸÐ»Ð¾ÑÐºÐ¸Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(51946,1443,'es','Porcentaje Fijo',0),(51947,1443,'de','Flache Prozentsatz',0),(51948,1443,'en','Flat percentage',0),(51949,1444,'is','',0),(51950,1444,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø«Ø§Ø¨Øª ',0),(51951,1444,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø«Ø§Ø¨Øª ',0),(51952,1444,'tr','DÃ¼z boyutu',0),(51953,1444,'pl','PÅ‚aski rozmiar',0),(51954,1444,'bg','ÐŸÐ»Ð¾ÑÑŠÐº Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(51955,1444,'ur','ÙÙ„ÛŒÙ¹ Ø³Ø§Ø¦Ø²',0),(51956,1444,'sr','Ð¡Ñ‚Ð°Ð½ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(51957,1444,'vi','1 cá»¡',0),(51958,1444,'af','Plat grootte',0),(51959,1444,'ro','Dimensiunea plat',0),(51960,1444,'et','Korter suurusega',0),(51961,1444,'si','Stanovanje velikosti',0),(51962,1444,'ba','Datar ukuran',0),(51963,1444,'nl','Vlakke grootte',0),(51964,1444,'fi','Tasainen pinta',0),(51965,1444,'no','Flat stÃ¸rrelse',0),(51966,1444,'da','Flad stÃ¸rrelse',0),(51967,1444,'ko','í‰ë©´ í¬ê¸°',0),(51968,1444,'he','×œ×’×•×“×œ ×”×“×™×¨×”',0),(51969,1444,'el','Î•Ï€Î¯Ï€ÎµÎ´Î· Î¼Î­Î³ÎµÎ¸Î¿Ï‚',0),(51970,1444,'zh','å›ºå®šé¢ç§¯\r\n',0),(51971,1444,'sv','Platt storlek',0),(51972,1444,'it','Dimensioni piatto',0),(51973,1444,'tl','',0),(51974,1444,'th','&#3586;&#3609;&#3634;&#3604;&#3649;&#3609;&#3623;&#3619;&#3634;&#3610;',0),(51975,1444,'hi','à¤«à¥à¤²à¥ˆà¤Ÿ à¤†à¤•à¤¾à¤°',0),(51976,1444,'ms','Leper saiz',0),(51977,1444,'ar','Ø§Ù„Ù…Ø³Ø§Ø­Ø© Ø§Ù„Ù…Ø³Ø·Ø­Ø©',0),(51978,1444,'fr','Taille plat',0),(51979,1444,'jp','å?‡ä¸€ã‚µã‚¤ã‚º',0),(51980,1444,'pt','Tamanho liso',0),(51981,1444,'ru','ÐŸÐ»Ð¾ÑÐºÐ¸Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(51982,1444,'es','TamaÃ±o Fijo',0),(51983,1444,'de','Flach GrÃ¶sse',0),(51984,1444,'en','Flat Size',0),(51985,1445,'is','',0),(51986,1445,'dr','Flexo Ø®Ù… ÙƒØ±Ø¯Ù†',0),(51987,1445,'pr','Flexo Ø®Ù… ÙƒØ±Ø¯Ù†',0),(51988,1445,'tr','Flexo',0),(51989,1445,'pl','Flexo',0),(51990,1445,'bg','Ð¤Ð»ÐµÐºÑÐ¾Ð¿ÐµÑ‡Ð°Ñ‚',0),(51991,1445,'ur','ÙÙ„ÛŒØ§Ùˆ',0),(51992,1445,'sr','Ð¤Ð»ÐµxÐ¾',0),(51993,1445,'vi','Flexo',0),(51994,1445,'af','Flexo',0),(51995,1445,'ro','Flexo',0),(51996,1445,'et','Kesksilindriga',0),(51997,1445,'si','Flexo',0),(51998,1445,'ba','Flexo',0),(51999,1445,'nl','Flexo',0),(52000,1445,'fi','Flexo',0),(52001,1445,'no','Flexo',0),(52002,1445,'da','Flexo',0),(52003,1445,'ko','Flexo',0),(52004,1445,'he','×¤×œ×§×¡×•',0),(52005,1445,'el','Flexo',0),(52006,1445,'zh','æŸ”å°\r\n',0),(52007,1445,'sv','Flexo',0),(52008,1445,'it','Flexo',0),(52009,1445,'tl','',0),(52010,1445,'th','Flexo',0),(52011,1445,'hi','Flexo',0),(52012,1445,'ms','Flexo',0),(52013,1445,'ar','Ù„ÙŠÙ†Ø©',0),(52014,1445,'fr','Flexo',0),(52015,1445,'jp','ãƒ•ãƒ¬ã‚­ã‚½å?°åˆ·',0),(52016,1445,'pt','Flexo',0),(52017,1445,'ru','Ð¤Ð»ÐµÐºÑÐ¾',0),(52018,1445,'es','Flexo',0),(52019,1445,'de','Flexo',0),(52020,1445,'en','Flexo',0),(52021,1446,'is','',0),(52022,1446,'dr','Ø¨Ø±Ø§ÙŠ ',0),(52023,1446,'pr','Ø¨Ø±Ø§ÙŠ ',0),(52024,1446,'tr','Ä°Ã§in',0),(52025,1446,'pl','Dla',0),(52026,1446,'bg','Ð—Ð°',0),(52027,1446,'ur','Ú©Û’ Ù„Ø¦Û’',0),(52028,1446,'sr','Ð—Ð°',0),(52029,1446,'vi','Cho ',0),(52030,1446,'af','Vir',0),(52031,1446,'ro','Pentru',0),(52032,1446,'et',':',0),(52033,1446,'si','Za',0),(52034,1446,'ba','Untuk',0),(52035,1446,'nl','Voor',0),(52036,1446,'fi','Varten',0),(52037,1446,'no','For',0),(52038,1446,'da','For',0),(52039,1446,'ko','ì— ëŒ€ í•œ',0),(52040,1446,'he','×¢×‘×•×¨',0),(52041,1446,'el','Î“Î¹Î±',0),(52042,1446,'zh','å¯¹äºŽ\r\n',0),(52043,1446,'sv','FÃ¶r',0),(52044,1446,'it','Per',0),(52045,1446,'tl','',0),(52046,1446,'th','&#3648;&#3614;&#3639;&#3656;&#3629;',0),(52047,1446,'hi','à¤•à¥‡ à¤²à¤¿à¤',0),(52048,1446,'ms','Bagi',0),(52049,1446,'ar','Ù…Ù† Ø£Ø¬Ù„',0),(52050,1446,'fr','Pour',0),(52051,1446,'jp','ï½žã?®',0),(52052,1446,'pt','Para',0),(52053,1446,'ru','Ð”Ð»Ñ',0),(52054,1446,'es','Para',0),(52055,1446,'de','FÃ¼r',0),(52056,1446,'en','For',0),(52057,1447,'is','',0),(52058,1447,'dr','Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ù…Ø­Ù„ Ù‡Ø§ ',0),(52059,1447,'pr','Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ù…Ø­Ù„ Ù‡Ø§ ',0),(52060,1447,'tr','TÃ¼m mekanlar iÃ§in',0),(52061,1447,'pl','Dla wszystkich miejsc',0),(52062,1447,'bg','Ð—Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(52063,1447,'ur','ØªÙ…Ø§Ù… Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Û’ Ù„ÛŒÛ’',0),(52064,1447,'sr','Ð—Ð° ÑÐ²Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(52065,1447,'vi','Cho táº¥t cáº£ vá»‹ trÃ­',0),(52066,1447,'af','Vir Alle Liggings',0),(52067,1447,'ro','Pentru toate locaÅ£iile',0),(52068,1447,'et','KÃµigi asukohtade',0),(52069,1447,'si','Za vse lokacije',0),(52070,1447,'ba','Untuk semua lokasi',0),(52071,1447,'nl','Voor alle locaties',0),(52072,1447,'fi','Kaikkien sijaintien',0),(52073,1447,'no','For alle lokasjoner',0),(52074,1447,'da','For alle lokationer',0),(52075,1447,'ko','ëª¨ë“  ìœ„ì¹˜ì— ëŒ€ í•œ',0),(52076,1447,'he','×¢×‘×•×¨ ×›×œ ×”×ž×™×§×•×ž×™×',0),(52077,1447,'el','Î“Î¹Î± ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î¸Î­ÏƒÎµÎ¹Ï‚',0),(52078,1447,'zh','æ‰€æœ‰åœ°ç‚¹\r\n',0),(52079,1447,'sv','FÃ¶r alla platser',0),(52080,1447,'it','Per tutte le sedi',0),(52081,1447,'tl','',0),(52082,1447,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(52083,1447,'hi','à¤¸à¤­à¥€ à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤',0),(52084,1447,'ms','Untuk semua lokasi',0),(52085,1447,'ar','Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…ÙˆØ§Ù‚Ø¹',0),(52086,1447,'fr','Pour tous les emplacements',0),(52087,1447,'jp','å…¨ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®',0),(52088,1447,'pt','Para todas as localizaÃ§Ãµes',0),(52089,1447,'ru','Ð”Ð»Ñ Ð’ÑÐµÑ… ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¹',0),(52090,1447,'es','Para Todas la Ubicaciones',0),(52091,1447,'de','FÃ¼r alle Orte',0),(52092,1447,'en','For All Locations',0),(52093,1448,'is','',0),(52094,1448,'dr','Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(52095,1448,'pr','Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(52096,1448,'tr','TaÅŸÄ±yÄ±cÄ± iÃ§in',0),(52097,1448,'pl','dla przewoÅºnika',0),(52098,1448,'bg','Ð·Ð° Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(52099,1448,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ú©Û’ Ù„Ø¦Û’',0),(52100,1448,'sr','Ð·Ð° Ð½Ð¾ÑÐ°Ñ‡',0),(52101,1448,'vi','Cho hÃ£ng váº­n chuyá»ƒn',0),(52102,1448,'af','vir Karweier',0),(52103,1448,'ro','pentru transport',0),(52104,1448,'et','vedaja',0),(52105,1448,'si','za prevoznika',0),(52106,1448,'ba','untuk operator',0),(52107,1448,'nl','voor vervoerder',0),(52108,1448,'fi','harjoittajan',0),(52109,1448,'no','for Carrier',0),(52110,1448,'da','for Carrier',0),(52111,1448,'ko','ìºë¦¬ì–´ì— ëŒ€ í•œ',0),(52112,1448,'he','×¦×œ×™×œ ×ª×§×©×•×¨×ª',0),(52113,1448,'el','Î³Î¹Î± Ï„Î¿Î½ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(52114,1448,'zh','å¯¹äºŽæ‰¿è¿äºº\r\n',0),(52115,1448,'sv','fÃ¶r transportÃ¶ren',0),(52116,1448,'it','per Carrier',0),(52117,1448,'tl','',0),(52118,1448,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(52119,1448,'hi','à¤µà¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤',0),(52120,1448,'ms','untuk pembekal',0),(52121,1448,'ar','Ù„Ù„Ù†Ø§Ù‚Ù„',0),(52122,1448,'fr','pour transporteur',0),(52123,1448,'jp','é…?é€?æ¥­è€…ã?®',0),(52124,1448,'pt','para transportadora',0),(52125,1448,'ru','Ð”Ð»Ñ ÐšÑƒÑ€ÑŒÐµÑ€Ð°',0),(52126,1448,'es','Para Transportador',0),(52127,1448,'de','fÃ¼r Carrier',0),(52128,1448,'en','for Carrier',0),(52129,1449,'is','',0),(52130,1449,'dr','(Ø¯ÛŒÙˆÙ† ) Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(52131,1449,'pr','Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ (Ø¨Ø¯Ù‡ÙŠ) Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(52132,1449,'tr','Faturalar',0),(52133,1449,'pl','Faktury ze wzglÄ™du',0),(52134,1449,'bg','Ð—Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ‚Ðµ Ð´ÑŠÐ»Ð¶Ð¸',0),(52135,1449,'ur','Ú©ÛŒ ÙˆØ¬Û Ø³Û’ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ù„Ø¦Û’',0),(52136,1449,'sr','Ð—Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ñ‚ÐµÑ€Ð¼Ð¸Ð½',0),(52137,1449,'vi','Cho hÃ³a Ä‘Æ¡n Ä‘áº¿n háº¡n',0),(52138,1449,'af','Vir Fakture Verskuldig',0),(52139,1449,'ro','Pentru facturile din cauza',0),(52140,1449,'et','Arvete tÃµttu',0),(52141,1449,'si','Za raÄune zaradi',0),(52142,1449,'ba','Untuk faktur karena',0),(52143,1449,'nl','Voor facturen verschuldigd',0),(52144,1449,'fi','Laskujen',0),(52145,1449,'no','For fakturaer grunn',0),(52146,1449,'da','For fakturaer forfalder',0),(52147,1449,'ko','ì¸í•´ ì¸ë³´ì´ìŠ¤ì— ëŒ€ í•œ',0),(52148,1449,'he','×¢×‘×•×¨ ×—×©×‘×•× ×™×•×ª ×‘×©×œ',0),(52149,1449,'el','Î“Î¹Î± Î¿Ï†ÎµÎ¹Î»ÏŒÎ¼ÎµÎ½Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(52150,1449,'zh','å‘ç¥¨åˆ°æœŸ\r\n',0),(52151,1449,'sv','FÃ¶r fakturor pÃ¥ grund',0),(52152,1449,'it','Per fatture dovute',0),(52153,1449,'tl','',0),(52154,1449,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(52155,1449,'hi','à¤•à¤¾à¤°à¤£ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤',0),(52156,1449,'ms','Bagi invois-invois hutang',0),(52157,1449,'ar','Ø¨Ø§Ù„Ù†Ø³Ø¨Ø© Ù„Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø©',0),(52158,1449,'fr','Pour les factures dues',0),(52159,1449,'jp','æœŸé™?ã?®è«‹æ±‚æ›¸',0),(52160,1449,'pt','Para faturas devido',0),(52161,1449,'ru','Ð”Ð»Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€ Ð·Ð°',0),(52162,1449,'es','Para Facturas vencidas',0),(52163,1449,'de','FÃ¼r fÃ¤llige Rechnungen',0),(52164,1449,'en','For Invoices Due',0),(52165,1450,'is','',0),(52166,1450,'dr','Ø¨Ø±Ø§ÙŠ Ù…ÙƒØ§Ù†Ù‡Ø§ ',0),(52167,1450,'pr','Ø¨Ø±Ø§ÙŠ Ù…ÙƒØ§Ù†Ù‡Ø§ ',0),(52168,1450,'tr','Konumu:',0),(52169,1450,'pl','Na miejscu:',0),(52170,1450,'bg','Ð—Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ:',0),(52171,1450,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø¨Ø±Ø§Ø¦Û’:',0),(52172,1450,'sr','Ð—Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ:',0),(52173,1450,'vi','Cho vá»‹ trÃ­',0),(52174,1450,'af','Vir Ligging:',0),(52175,1450,'ro','Pentru locatie:',0),(52176,1450,'et','Asukoht:',0),(52177,1450,'si','Za lokacijo:',0),(52178,1450,'ba','Lokasi:',0),(52179,1450,'nl','Locatie:',0),(52180,1450,'fi','Sijainti:',0),(52181,1450,'no','Beliggenhet:',0),(52182,1450,'da','Til placering:',0),(52183,1450,'ko','ìœ„ì¹˜:',0),(52184,1450,'he','×ž×™×§×•×:',0),(52185,1450,'el','Î“Î¹Î± Ï„Î·Î½ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±:',0),(52186,1450,'zh','é€‰å€ï¼š\r\n',0),(52187,1450,'sv','FÃ¶r plats:',0),(52188,1450,'it','Per localitÃ :',0),(52189,1450,'tl','',0),(52190,1450,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591; :',0),(52191,1450,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤:',0),(52192,1450,'ms','Lokasi:',0),(52193,1450,'ar','Ù„Ù„Ù…ÙˆÙ‚Ø¹:',0),(52194,1450,'fr','Emplacement :',0),(52195,1450,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®',0),(52196,1450,'pt','Para localizaÃ§Ã£o:',0),(52197,1450,'ru','Ð”Ð»Ñ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ:',0),(52198,1450,'es','Para UbicaciÃ³n',0),(52199,1450,'de','Standort:',0),(52200,1450,'en','For Location:',0),(52201,1451,'is','',0),(52202,1451,'dr','Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª ',0),(52203,1451,'pr','Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª ',0),(52204,1451,'tr','Fiyat seviyesi iÃ§in',0),(52205,1451,'pl','Dla poziomu cen',0),(52206,1451,'bg','Ð—Ð° Ð½Ð¸Ð²Ð¾ Ð½Ð° Ñ†ÐµÐ½Ð¸Ñ‚Ðµ',0),(52207,1451,'ur','Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ú©Û’ Ù„Ø¦Û’',0),(52208,1451,'sr','ÐÐ° Ð½Ð¸Ð²Ð¾Ñƒ Ñ†ÐµÐ½Ð°',0),(52209,1451,'vi','Cho má»©c giÃ¡',0),(52210,1451,'af','Vir Prysvlak',0),(52211,1451,'ro','Pentru nivelul preÅ£urilor',0),(52212,1451,'et','Hinnataseme',0),(52213,1451,'si','Za raven cen',0),(52214,1451,'ba','Untuk tingkat harga',0),(52215,1451,'nl','Voor prijsniveau',0),(52216,1451,'fi','Hintatason',0),(52217,1451,'no','For prisnivÃ¥',0),(52218,1451,'da','For prisniveau',0),(52219,1451,'ko','ê°€ê²© ìˆ˜ì¤€ì— ëŒ€ í•œ',0),(52220,1451,'he','×¢×‘×•×¨ ×¨×ž×ª ×ž×—×™×¨',0),(52221,1451,'el','Î“Î¹Î± Ï„Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½',0),(52222,1451,'zh','å¯¹äºŽä»·æ ¼æ°´å¹³\r\n',0),(52223,1451,'sv','FÃ¶r prisnivÃ¥n',0),(52224,1451,'it','Per livello di prezzo',0),(52225,1451,'tl','',0),(52226,1451,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(52227,1451,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤•à¥‡ à¤²à¤¿à¤',0),(52228,1451,'ms','Harga peringkat',0),(52229,1451,'ar','Ù„Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(52230,1451,'fr','Pour le niveau de prix',0),(52231,1451,'jp','ä¾¡æ ¼æ°´æº–ã?®',0),(52232,1451,'pt','Para o nÃ­vel de preÃ§os',0),(52233,1451,'ru','Ð”Ð»Ñ Ð£Ñ€Ð¾Ð²Ð½Ñ Ð¦ÐµÐ½',0),(52234,1451,'es','Para Nivel de Precios',0),(52235,1451,'de','FÃ¼r Preisniveau',0),(52236,1451,'en','For Price Level',0),(52237,1452,'is','',0),(52238,1452,'dr','Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(52239,1452,'pr','Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(52240,1452,'tr','Ä°ÅŸ tipi',0),(52241,1452,'pl','do pracy typu',0),(52242,1452,'bg','Ð·Ð° Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(52243,1452,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª Ú©Û’ Ù„Ø¦Û’',0),(52244,1452,'sr','Ð·Ð° Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð°',0),(52245,1452,'vi','cho Loáº¡i cÃ´ng viá»‡c',0),(52246,1452,'af','vir Werk Tipe',0),(52247,1452,'ro','pentru tipul de munca',0),(52248,1452,'et','TÃ¶Ã¶ tÃ¼Ã¼p',0),(52249,1452,'si','za vrsto dela',0),(52250,1452,'ba','untuk jenis pekerjaan',0),(52251,1452,'nl','voor werksoort',0),(52252,1452,'fi','tyÃ¶tyypille',0),(52253,1452,'no','for arbeidstypen',0),(52254,1452,'da','for arbejdstype',0),(52255,1452,'ko','ìž‘ì—… í˜•ì‹ì— ëŒ€ í•œ',0),(52256,1452,'he','×¢×‘×•×¨ ×¡×•×’ ×¢×‘×•×“×”',0),(52257,1452,'el','Î³Î¹Î± Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(52258,1452,'zh','å·¥ä½œç±»åž‹\r\n',0),(52259,1452,'sv','fÃ¶r arbetstyp',0),(52260,1452,'it','per tipo di lavoro',0),(52261,1452,'tl','',0),(52262,1452,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(52263,1452,'hi','à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤',0),(52264,1452,'ms','bagi jenis kerja',0),(52265,1452,'ar','Ù„Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(52266,1452,'fr','Type de travail',0),(52267,1452,'jp','ä»•äº‹å†…å®¹ã?®',0),(52268,1452,'pt','para tipo de trabalho',0),(52269,1452,'ru','Ð¿Ð¾ Ð¢Ð¸Ð¿Ñƒ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(52270,1452,'es','Para Tipo de Trabajo',0),(52271,1452,'de','fÃ¼r Arbeitstyp',0),(52272,1452,'en','for Work Type',0),(52273,1453,'is','',0),(52274,1453,'dr','Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ ',0),(52275,1453,'pr','Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ ',0),(52276,1453,'tr','YÄ±l iÃ§in',0),(52277,1453,'pl','za rok',0),(52278,1453,'bg','Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(52279,1453,'ur','Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’',0),(52280,1453,'sr','Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(52281,1453,'vi','cho NÄƒm',0),(52282,1453,'af','vir Jaar',0),(52283,1453,'ro','pentru anul',0),(52284,1453,'et','aasta',0),(52285,1453,'si','za leto',0),(52286,1453,'ba','untuk tahun',0),(52287,1453,'nl','voor jaar',0),(52288,1453,'fi','vuoden',0),(52289,1453,'no','for Ã¥r',0),(52290,1453,'da','for Ã¥r',0),(52291,1453,'ko','1 ë…„ ë™ì•ˆ',0),(52292,1453,'he','×‘×ž×©×š ×©× ×”',0),(52293,1453,'el','Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚',0),(52294,1453,'zh','å¹´ä»½\r\n',0),(52295,1453,'sv','fÃ¶r Ã¥r',0),(52296,1453,'it','per anno',0),(52297,1453,'tl','',0),(52298,1453,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3637;',0),(52299,1453,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤',0),(52300,1453,'ms','bagi tahun',0),(52301,1453,'ar','Ù„Ù„Ø³Ù†Ø©',0),(52302,1453,'fr','pour l\'annÃ©e',0),(52303,1453,'jp','å¹´ã?®',0),(52304,1453,'pt','para o ano',0),(52305,1453,'ru','Ð·Ð° Ð³Ð¾Ð´',0),(52306,1453,'es','Para AÃ±o',0),(52307,1453,'de','fÃ¼r das Jahr',0),(52308,1453,'en','for Year',0),(52309,1454,'is','',0),(52310,1454,'dr','Ø¢ÙŠØ§ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®ÙˆØ¯ Ø±Ø§ ÙØ±Ø§Ù…ÙˆØ´ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ØŸ ',0),(52311,1454,'pr','Ø¢ÙŠØ§ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®ÙˆØ¯ Ø±Ø§ ÙØ±Ø§Ù…ÙˆØ´ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ØŸ ',0),(52312,1454,'tr','ParolanÄ±zÄ± unuttunuz?',0),(52313,1454,'pl','ZapomnieÄ‡ hasÅ‚a?',0),(52314,1454,'bg','Ð—Ð°Ð±Ñ€Ð°Ð²ÐµÐ½Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°?',0),(52315,1454,'ur','Ø¢Ù¾ Ú©Ø§ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¨Ú¾ÙˆÙ„ Ú¯Ø¦Û’ ÛÛŒÚºØŸ',0),(52316,1454,'sr','Ð—Ð°Ð±Ð¾Ñ€Ð°Ð²Ð¸Ð»Ð¸ ÑÑ‚Ðµ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ?',0),(52317,1454,'vi','QuÃªn máº­t kháº©u?',0),(52318,1454,'af','Dalk u Wagwoord vergeet?',0),(52319,1454,'ro','Uitat parola?',0),(52320,1454,'et','Unusta salasÃµna?',0),(52321,1454,'si','Pozabili svoje geslo?',0),(52322,1454,'ba','Lupa Password Anda?',0),(52323,1454,'nl','Uw wachtwoord vergeten?',0),(52324,1454,'fi','Unohtanut salasanasi?',0),(52325,1454,'no','Glemt passordet?',0),(52326,1454,'da','Har glemt din adgangskode?',0),(52327,1454,'ko','ë¹„ë°€ ë²ˆí˜¸ë¥¼ ìžŠìœ¼ ì…¨ë‚˜ìš”?',0),(52328,1454,'he','×©×›×—×ª ××ª ×”×¡×™×¡×ž×?',0),(52329,1454,'el','ÎžÎµÏ‡Î±ÏƒÎ±Ï„Îµ Ï„Î¿Î½ ÎšÎ©Î”Î™ÎšÎŸ ÏƒÎ±Ï‚;',0),(52330,1454,'zh','å¿˜è®°å¯†ç ï¼Ÿ\r\n',0),(52331,1454,'sv','GlÃ¶mt ditt lÃ¶senord?',0),(52332,1454,'it','Dimentica la Password?',0),(52333,1454,'tl','',0),(52334,1454,'th','&#3621;&#3639;&#3617;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;',0),(52335,1454,'hi','à¤…à¤ªà¤¨à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤­à¥‚à¤² à¤—à¤ à¤¹à¥ˆà¤‚?',0),(52336,1454,'ms','Lupa kata laluan anda?',0),(52337,1454,'ar','Ù‡Ù„ Ù†Ø³ÙŠØª ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨ÙƒØŸ',0),(52338,1454,'fr','Oubliez votre mot de passe ?',0),(52339,1454,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å¿˜ã‚Œã?¾ã?—ã?Ÿã?‹ï¼Ÿ',0),(52340,1454,'pt','Esqueceu sua senha?',0),(52341,1454,'ru','Ð—Ð°Ð±Ñ‹Ð»Ð¸ Ð’Ð°Ñˆ ÐŸÐ°Ñ€Ð¾Ð»ÑŒ?',0),(52342,1454,'es','Se OlvidÃ³ su Clave',0),(52343,1454,'de','Vergessen Ihr Passwort?',0),(52344,1454,'en','Forget Your Password?',0),(52345,1455,'is','',0),(52346,1455,'dr','ÙØ±Ù… ØªØ±Ø§Ø² Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ÙØ±Ù… Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ',0),(52347,1455,'pr','ÙØ±Ù… ØªØ±Ø§Ø² Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ÙØ±Ù… Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ',0),(52348,1455,'tr','Form dengeli deÄŸil.  Åžu anda ÅŸeklidir',0),(52349,1455,'pl','Formularz nie jest zrÃ³wnowaÅ¼ona.  Formularz jest obecnie',0),(52350,1455,'bg','Ð¤Ð¾Ñ€Ð¼Ð° Ð½Ðµ Ðµ Ð±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð°Ð½Ð°.  Ð¤Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ðµ',0),(52351,1455,'ur','Ø´Ú©Ù„ Ù…ØªÙˆØ§Ø²Ù† Ù†ÛÛŒÚº ÛÛ’ Û”  Ø§Ø³ ÙˆÙ‚Øª ØµÙˆØ±Øª ÛÛ’',0),(52352,1455,'sr','ÐžÐ±Ñ€Ð°Ð·Ð°Ñ† Ð½Ð¸Ñ˜Ðµ Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÑ’ÐµÐ½.  ÐžÐ±Ñ€Ð°Ð·Ð°Ñ† ÑÐµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð½Ð°Ð»Ð°Ð·Ð¸',0),(52353,1455,'vi','CÃ´ng thá»©c khÃ´ng cÃ¢n. Máº«u quÃ¡ cÅ©',0),(52354,1455,'af','Vorm balanseer nie. Vorm is huidiglik',0),(52355,1455,'ro','Formularul nu este echilibrat.  Formular este Ã®n prezent',0),(52356,1455,'et','Vorm on tasakaalustatud.  Vorm on praegu',0),(52357,1455,'si','Obrazec ni uravnoteÅ¾ena.  Obrazec je trenutno',0),(52358,1455,'ba','Formulir yang tidak seimbang.  Bentuk sedang',0),(52359,1455,'nl','Formulier is niet evenwichtig.  Formulier is op dit moment',0),(52360,1455,'fi','Lomake ei ole tasapainoinen.  Lomake on tÃ¤llÃ¤ hetkellÃ¤',0),(52361,1455,'no','Skjemaet er ikke balansert.  Skjemaet er',0),(52362,1455,'da','Formularen er ikke afbalanceret.  Formen er i Ã¸jeblikket',0),(52363,1455,'ko','ì–‘ì‹ í•˜ì§€ ê· í˜• ì´ë‹¤.  í¼ì´ í˜„ìž¬',0),(52364,1455,'he','×˜×•×¤×¡ ×œ× ×ž××•×–× ×ª.  ×”×˜×•×¤×¡ × ×ž×¦× ×›×¢×ª',0),(52365,1455,'el','ÎœÎ¿ÏÏ†Î® Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î·Î¼Î­Î½Î·.  ÎœÎ¿ÏÏ†Î® ÎµÎ¯Î½Î±Î¹ ÎµÏ€Î¯ Ï„Î¿Ï… Ï€Î±ÏÏŒÎ½Ï„Î¿Ï‚',0),(52366,1455,'zh','è¡¨æ ¼ä¸å‡è¡¡ã€‚ç›®å‰è¡¨æ ¼\r\n',0),(52367,1455,'sv','FormulÃ¤ret Ã¤r inte balanserad.  Form Ã¤r fÃ¶r nÃ¤rvarande',0),(52368,1455,'it','Forma non Ã¨ equilibrato.  Forma Ã¨ attualmente',0),(52369,1455,'tl','',0),(52370,1455,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3617;&#3656;&#3626;&#3617;&#3604;&#3640;&#3621; &#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(52371,1455,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤¸à¤‚à¤¤à¥à¤²à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤  à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤®à¥‡à¤‚ à¤¹à¥ˆ',0),(52372,1455,'ms','Borang tidak seimbang.  Borang sedang',0),(52373,1455,'ar','Ø´ÙƒÙ„ ØºÙŠØ± Ù…ØªÙˆØ§Ø²Ù†.  Ø§Ù„Ù†Ù…ÙˆØ°Ø¬ Ø­Ø§Ù„ÙŠØ§',0),(52374,1455,'fr','Formulaire n\'est pas Ã©quilibrÃ©.  Formulaire est actuellement',0),(52375,1455,'jp','ãƒ•ã‚©ãƒ¼ãƒ ã?Œãƒ?ãƒ©ãƒ³ã‚¹ã?—ã?¦ã?„ã?¾ã?›ã‚“ã€‚ãƒ•ã‚©ãƒ¼ãƒ ã?¯ç?¾åœ¨',0),(52376,1455,'pt','FormulÃ¡rio nÃ£o estÃ¡ equilibrado.  FormulÃ¡rio Ã© atualmente',0),(52377,1455,'ru','Ð¤Ð¾Ñ€Ð¼Ð° Ð½Ðµ ÑÐ²Ð»ÑÐµÑ‚ÑÑ ÑÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð¾Ð¹.  Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ñ„Ð¾Ñ€Ð¼Ð°',0),(52378,1455,'es','Formulario no se balance. Formulario es actualmente',0),(52379,1455,'de','Form ist nicht ausgewogen.  Form ist derzeit',0),(52380,1455,'en','Form is not balanced.  Form is currently',0),(52381,1456,'is','',0),(52382,1456,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù… ',0),(52383,1456,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù… ',0),(52384,1456,'tr','Form numarasÄ±',0),(52385,1456,'pl','Numer formularza',0),(52386,1456,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€Ð°',0),(52387,1456,'ur','ÙØ§Ø±Ù… Ù†Ù…Ø¨Ø±',0),(52388,1456,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¾Ð±Ñ€Ð°ÑÑ†Ð°',0),(52389,1456,'vi','Máº«u sá»‘',0),(52390,1456,'af','Vorm Nommer',0),(52391,1456,'ro','Formularul numÄƒrul',0),(52392,1456,'et','Vormi Number',0),(52393,1456,'si','Å tevilka obrazca',0),(52394,1456,'ba','Formulir Nomor',0),(52395,1456,'nl','Formuliernummer',0),(52396,1456,'fi','Lomakkeen numero',0),(52397,1456,'no','Skjemanummer',0),(52398,1456,'da','Form nummer',0),(52399,1456,'ko','ì–‘ì‹ ë²ˆí˜¸',0),(52400,1456,'he','×ž×¡×¤×¨ ×˜×•×¤×¡',0),(52401,1456,'el','ÎœÎ¿ÏÏ†Î® Î±ÏÎ¹Î¸Î¼Î¿Ï',0),(52402,1456,'zh','è¡¨æ ¼ç¼–å·\r\n',0),(52403,1456,'sv','Nummer',0),(52404,1456,'it','Numero di forma',0),(52405,1456,'tl','',0),(52406,1456,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3615;&#3629;&#3619;&#3660;&#3617;',0),(52407,1456,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(52408,1456,'ms','Nombor borang',0),(52409,1456,'ar','Ø±Ù‚Ù… Ø§Ù„Ù†Ù…ÙˆØ°Ø¬',0),(52410,1456,'fr','NumÃ©ro du formulaire',0),(52411,1456,'jp','ãƒ•ã‚©ãƒ¼ãƒ ç•ªå?·',0),(52412,1456,'pt','NÃºmero do formulÃ¡rio',0),(52413,1456,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¤Ð¾Ñ€Ð¼Ñ‹',0),(52414,1456,'es','NÃºmero de Formulario',0),(52415,1456,'de','Formularnummer',0),(52416,1456,'en','Form Number',0),(52417,1457,'is','',0),(52418,1457,'dr','Ù‚Ø§Ù„Ø¨ ØªÙ†Ø¸ÙŠÙ…Ø§Øª ',0),(52419,1457,'pr','Ù‚Ø§Ù„Ø¨ ØªÙ†Ø¸ÙŠÙ…Ø§Øª ',0),(52420,1457,'tr','BiÃ§im ayarlarÄ±',0),(52421,1457,'pl','Ustawienia formatu',0),(52422,1457,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(52423,1457,'ur','ÙØ§Ø±Ù…ÛŒÙ¹ Ø³ÛŒÙ¹ Ø§Ù¾',0),(52424,1457,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð°',0),(52425,1457,'vi','Setup máº«u',0),(52426,1457,'af','Formateer Opstelling',0),(52427,1457,'ro','Format de instalare',0),(52428,1457,'et','Vormi seadistus',0),(52429,1457,'si','Oblika Setup',0),(52430,1457,'ba','Format Setup',0),(52431,1457,'nl','Indeling Setup',0),(52432,1457,'fi','Format Setup',0),(52433,1457,'no','Format oppsett',0),(52434,1457,'da','OpsÃ¦tning af format',0),(52435,1457,'ko','í˜•ì‹ ì„¤ì •',0),(52436,1457,'he','×”×’×“×¨×ª ×ª×‘× ×™×ª',0),(52437,1457,'el','ÎœÎ¿ÏÏ†Î® ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(52438,1457,'zh','æ ¼å¼è®¾å®š\r\n',0),(52439,1457,'sv','Format instÃ¤llningar',0),(52440,1457,'it','Formato Setup',0),(52441,1457,'tl','',0),(52442,1457,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(52443,1457,'hi','à¤¸à¥à¤µà¤°à¥‚à¤ª à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(52444,1457,'ms','Format persediaan',0),(52445,1457,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(52446,1457,'fr','Format configuration',0),(52447,1457,'jp','ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆè¨­å®š',0),(52448,1457,'pt','ConfiguraÃ§Ã£o de formato',0),(52449,1457,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚Ð°',0),(52450,1457,'es','ConfiguraciÃ³n de Formato',0),(52451,1457,'de','Format-Setup',0),(52452,1457,'en','Format Setup',0),(52453,1458,'is','',0),(52454,1458,'dr','Ú†Ù‡Ù„ ',0),(52455,1458,'pr','Ú†Ù‡Ù„ ',0),(52456,1458,'tr','KÄ±rk',0),(52457,1458,'pl','czterdzieÅ›ci',0),(52458,1458,'bg','Ñ‡ÐµÑ‚Ð¸Ñ€Ð¸Ð´ÐµÑÐµÑ‚',0),(52459,1458,'ur','Ú†Ø§Ù„ÛŒØ³',0),(52460,1458,'sr','40',0),(52461,1458,'vi','bá»‘n mÆ°Æ¡i',0),(52462,1458,'af','veertig',0),(52463,1458,'ro','patruzeci',0),(52464,1458,'et','nelikÃ¼mmend',0),(52465,1458,'si','Å¡tirideset',0),(52466,1458,'ba','empat puluh',0),(52467,1458,'nl','veertig',0),(52468,1458,'fi','neljÃ¤kymmentÃ¤',0),(52469,1458,'no','fÃ¸rti',0),(52470,1458,'da','fyrre',0),(52471,1458,'ko','40',0),(52472,1458,'he','××¨×‘×¢×™×',0),(52473,1458,'el','ÏƒÎ±ÏÎ¬Î½Ï„Î±',0),(52474,1458,'zh','å››å\r\n',0),(52475,1458,'sv','fyrtio',0),(52476,1458,'it','quaranta',0),(52477,1458,'tl','',0),(52478,1458,'th','&#3626;&#3637;&#3656;&#3626;&#3636;&#3610;',0),(52479,1458,'hi','à¤šà¤¾à¤²à¥€à¤¸',0),(52480,1458,'ms','empat puluh',0),(52481,1458,'ar','Ø§Ù„Ø£Ø±Ø¨Ø¹ÙˆÙ†',0),(52482,1458,'fr','quarante',0),(52483,1458,'jp','40',0),(52484,1458,'pt','quarenta',0),(52485,1458,'ru','ÑÐ¾Ñ€Ð¾Ðº',0),(52486,1458,'es','cuarenta',0),(52487,1458,'de','vierzig',0),(52488,1458,'en','forty',0),(52489,1459,'is','',0),(52490,1459,'dr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ ',0),(52491,1459,'pr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ ',0),(52492,1459,'tr','Bu kategoriler bulundu',0),(52493,1459,'pl','ZnalazÅ‚em te kategorie',0),(52494,1459,'bg','ÐÐ°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ñ‚ÐµÐ·Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(52495,1459,'ur','Ø§Ù† Ø²Ù…Ø±ÙˆÚº Ú©Ùˆ Ù¾Ø§ÛŒØ§',0),(52496,1459,'sr','ÐÐ°ÑˆÐ°Ð¾ Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(52497,1459,'vi','TÃ¬m tháº¥y nhá»¯ng thá»ƒ loáº¡i',0),(52498,1459,'af','Vind hierdie kategoriÃ« ',0),(52499,1459,'ro','GÄƒsit aceste categorii',0),(52500,1459,'et','Leiti need kategooriad',0),(52501,1459,'si','NaÅ¡el te kategorije',0),(52502,1459,'ba','Cari Kategori ini',0),(52503,1459,'nl','Gevonden deze categorieÃ«n',0),(52504,1459,'fi','LÃ¶ytyi nÃ¤mÃ¤ luokat',0),(52505,1459,'no','Fant disse kategoriene',0),(52506,1459,'da','Fandt disse kategorier',0),(52507,1459,'ko','ì´ëŸ¬í•œ ë²”ì£¼ë¥¼ ë°œê²¬',0),(52508,1459,'he','× ×ž×¦××• ×§×˜×’×•×¨×™×•×ª ××œ×”',0),(52509,1459,'el','Î’ÏÎ­Î¸Î·ÎºÎ±Î½ Î±Ï…Ï„Î­Ï‚ Ï„Î¹Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(52510,1459,'zh','å‘çŽ°è¿™äº›ç±»åˆ«\r\n',0),(52511,1459,'sv','Hittade dessa kategorier',0),(52512,1459,'it','Trovato queste categorie',0),(52513,1459,'tl','',0),(52514,1459,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3621;&#3635;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;&#3648;&#3627;&#3621;&#3656;&#3634;&#3609;&#3637;&#3657;',0),(52515,1459,'hi','à¤‡à¤¨ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(52516,1459,'ms','Mendapati kategori ini',0),(52517,1459,'ar','ÙˆØ¬Ø¯Øª Ù‡Ø°Ù‡ Ø§Ù„ÙØ¦Ø§Øª',0),(52518,1459,'fr','TrouvÃ© ces catÃ©gories',0),(52519,1459,'jp','ã?“ã‚Œã‚‰ã?®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?—ã?Ÿ',0),(52520,1459,'pt','Encontrei estas categorias',0),(52521,1459,'ru','ÐÐ°Ð¹Ñ‚Ð¸ Ð´Ð°Ð½Ð½Ñ‹Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(52522,1459,'es','Se encontrÃ³ estas categorÃ­as',0),(52523,1459,'de','Diese Kategorien gefunden',0),(52524,1459,'en','Found these categories',0),(52525,1460,'is','',0),(52526,1460,'dr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù…ÙˆØ¶ÙˆØ¹Ø§Øª ',0),(52527,1460,'pr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù…ÙˆØ¶ÙˆØ¹Ø§Øª ',0),(52528,1460,'tr','Bu konular bulundu',0),(52529,1460,'pl','ZnalazÅ‚em te tematy',0),(52530,1460,'bg','ÐÐ°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ñ‚ÐµÐ·Ð¸ Ñ‚ÐµÐ¼Ð¸',0),(52531,1460,'ur','ÛŒÛ Ù…ÙˆØ¶ÙˆØ¹Ø§Øª Ù¾Ø§ÛŒØ§',0),(52532,1460,'sr','ÐÐ°ÑˆÐ°Ð¾ Ð¾Ð²Ðµ Ñ‚ÐµÐ¼Ðµ',0),(52533,1460,'vi','TÃ¬m tháº¥y nhá»¯ng chá»§ Ä‘á»',0),(52534,1460,'af','Hierdie onderwerpe Gevind',0),(52535,1460,'ro','GÄƒsit aceste subiecte',0),(52536,1460,'et','Leiti need teemad',0),(52537,1460,'si','NaÅ¡el te teme',0),(52538,1460,'ba','Menemukan topik ini',0),(52539,1460,'nl','Deze onderwerpen gevonden',0),(52540,1460,'fi','LÃ¶ytyi nÃ¤istÃ¤ aiheista',0),(52541,1460,'no','Fant disse emnene',0),(52542,1460,'da','Har fundet disse emner',0),(52543,1460,'ko','ì´ ì£¼ì œë¥¼ ë°œê²¬',0),(52544,1460,'he','× ×ž×¦××• × ×•×©××™× ××œ×”',0),(52545,1460,'el','Î’ÏÎ­Î¸Î·ÎºÎ±Î½ Î±Ï…Ï„Î¬ Ï„Î± Î¸Î­Î¼Î±Ï„Î±',0),(52546,1460,'zh','å‘çŽ°è¿™äº›è¯é¢˜\r\n',0),(52547,1460,'sv','Hittade dessa Ã¤mnen',0),(52548,1460,'it','Trovato questi argomenti',0),(52549,1460,'tl','',0),(52550,1460,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;&#3648;&#3627;&#3621;&#3656;&#3634;&#3609;&#3637;&#3657;',0),(52551,1460,'hi','à¤‡à¤¨ à¤µà¤¿à¤·à¤¯à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(52552,1460,'ms','Mendapati topik-topik ini',0),(52553,1460,'ar','Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù‡Ø°Ù‡ Ø§Ù„Ù…ÙˆØ§Ø¶ÙŠØ¹',0),(52554,1460,'fr','TrouvÃ© ces sujets',0),(52555,1460,'jp','ã?“ã‚Œã‚‰ã?®ãƒˆãƒ”ãƒƒã‚¯ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?—ã?Ÿ',0),(52556,1460,'pt','Encontrei esses tÃ³picos',0),(52557,1460,'ru','ÐÐ°ÑˆÐ»Ð¸ ÑÑ‚Ð¸ Ñ‚ÐµÐ¼Ñ‹',0),(52558,1460,'es','Se encontrÃ³ estes Topicos',0),(52559,1460,'de','Diese Themen gefunden',0),(52560,1460,'en','Found these topics',0),(52561,1461,'is','',0),(52562,1461,'dr','Ú†Ù‡Ø§Ø± ',0),(52563,1461,'pr','Ú†Ù‡Ø§Ø± ',0),(52564,1461,'tr','DÃ¶rt',0),(52565,1461,'pl','Cztery',0),(52566,1461,'bg','Ð§ÐµÑ‚Ð¸Ñ€Ð¸',0),(52567,1461,'ur','Ú†Ø§Ø±',0),(52568,1461,'sr','Ð§ÐµÑ‚Ð¸Ñ€Ð¸',0),(52569,1461,'vi','Bá»‘n',0),(52570,1461,'af','Vier',0),(52571,1461,'ro','Patru',0),(52572,1461,'et','Neli',0),(52573,1461,'si','Å tiri',0),(52574,1461,'ba','Empat',0),(52575,1461,'nl','Vier',0),(52576,1461,'fi','NeljÃ¤',0),(52577,1461,'no','Fire',0),(52578,1461,'da','Fire',0),(52579,1461,'ko','4',0),(52580,1461,'he','××¨×‘×¢',0),(52581,1461,'el','Î¤Î­ÏƒÏƒÎµÏÎ¹Ï‚',0),(52582,1461,'zh','å››\r\n',0),(52583,1461,'sv','Fyra',0),(52584,1461,'it','Quattro',0),(52585,1461,'tl','',0),(52586,1461,'th','&#3626;&#3637;&#3656;',0),(52587,1461,'hi','à¤šà¤¾à¤°',0),(52588,1461,'ms','Empat',0),(52589,1461,'ar','Ø£Ø±Ø¨Ø¹Ø©',0),(52590,1461,'fr','Quatre',0),(52591,1461,'jp','4',0),(52592,1461,'pt','Quatro',0),(52593,1461,'ru','Ð§ÐµÑ‚Ñ‹Ñ€Ðµ',0),(52594,1461,'es','cuatro',0),(52595,1461,'de','Vier',0),(52596,1461,'en','Four',0),(52597,1462,'is','',0),(52598,1462,'dr','Ú†Ù‡Ø§Ø±Ø¯Ù‡ ',0),(52599,1462,'pr','Ú†Ù‡Ø§Ø±Ø¯Ù‡ ',0),(52600,1462,'tr','on dÃ¶rt',0),(52601,1462,'pl','CzternaÅ›cie',0),(52602,1462,'bg','Ñ‡ÐµÑ‚Ð¸Ñ€Ð¸Ð½Ð°Ð´ÐµÑÐµÑ‚',0),(52603,1462,'ur','Ú†ÙˆØ¯Û',0),(52604,1462,'sr','Ñ‡ÐµÑ‚Ñ€Ð½Ð°ÐµÑÑ‚',0),(52605,1462,'vi','mÆ°á»i bá»‘n',0),(52606,1462,'af','veertien',0),(52607,1462,'ro','paisprezece',0),(52608,1462,'et','Neliteist',0),(52609,1462,'si','Å¡tirinajst',0),(52610,1462,'ba','empat belas',0),(52611,1462,'nl','veertien',0),(52612,1462,'fi','neljÃ¤toista',0),(52613,1462,'no','fjorten',0),(52614,1462,'da','fjorten',0),(52615,1462,'ko','14',0),(52616,1462,'he','××¨×‘×¢ ×¢×©×¨×”',0),(52617,1462,'el','Î´ÎµÎºÎ±Ï„Î­ÏƒÏƒÎµÏÎ±',0),(52618,1462,'zh','åå››\r\n',0),(52619,1462,'sv','fjorton',0),(52620,1462,'it','quattordici',0),(52621,1462,'tl','',0),(52622,1462,'th','&#3626;&#3636;&#3610;&#3626;&#3637;&#3656;',0),(52623,1462,'hi','à¤šà¥Œà¤¦à¤¹',0),(52624,1462,'ms','empat belas',0),(52625,1462,'ar','Ø£Ø±Ø¨Ø¹Ø© Ø¹Ø´Ø±',0),(52626,1462,'fr','quatorze',0),(52627,1462,'jp','14',0),(52628,1462,'pt','catorze',0),(52629,1462,'ru','Ð§ÐµÑ‚Ñ‹Ñ€Ð½Ð°Ð´Ñ†Ð°Ñ‚ÑŒ',0),(52630,1462,'es','catorce',0),(52631,1462,'de','vierzehn',0),(52632,1462,'en','fourteen',0),(52633,1463,'is','',0),(52634,1463,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(52635,1463,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(52636,1463,'tr','Navlun',0),(52637,1463,'pl','Fracht',0),(52638,1463,'bg','Ð¢Ð¾Ð²Ð°Ñ€ÐµÐ½',0),(52639,1463,'ur','Ø³Ø§Ù…Ø§Ù†',0),(52640,1463,'sr','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð°',0),(52641,1463,'vi','Váº­n chuyá»ƒn',0),(52642,1463,'af','Vrag',0),(52643,1463,'ro','Transport de marfÄƒ',0),(52644,1463,'et','Kaubavedu',0),(52645,1463,'si','Tovorni promet',0),(52646,1463,'ba','Angkutan',0),(52647,1463,'nl','Goederenvervoer',0),(52648,1463,'fi','Rahti',0),(52649,1463,'no','Frakt',0),(52650,1463,'da','Fragt',0),(52651,1463,'ko','í™”ë¬¼',0),(52652,1463,'he','×”×•×‘×œ×”',0),(52653,1463,'el','Î•Î¼Ï€Î¿ÏÎµÏ…Î¼Î±Ï„Î¹ÎºÏŽÎ½ Î¼ÎµÏ„Î±Ï†Î¿ÏÏŽÎ½',0),(52654,1463,'zh','è´§è¿\r\n',0),(52655,1463,'sv','Frakt',0),(52656,1463,'it','Trasporto merci',0),(52657,1463,'tl','',0),(52658,1463,'th','&#3610;&#3619;&#3619;&#3607;&#3640;&#3585;',0),(52659,1463,'hi','à¤®à¤¾à¤² à¤¢à¥à¤²à¤¾à¤ˆ',0),(52660,1463,'ms','Pengangkutan',0),(52661,1463,'ar','Ø§Ù„Ø´Ø­Ù†',0),(52662,1463,'fr','Fret',0),(52663,1463,'jp','ç©ºè¼¸',0),(52664,1463,'pt','Frete',0),(52665,1463,'ru','ÐšÐ¾Ð½Ñ‚ÐµÐ¹Ð½ÐµÑ€Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·ÐºÐ¸',0),(52666,1463,'es','Flete',0),(52667,1463,'de','Fracht',0),(52668,1463,'en','Freight',0),(52669,1464,'is','',0),(52670,1464,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§Ù‰ Ø­Ù…Ù„',0),(52671,1464,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§Ù‰ Ø­Ù…Ù„',0),(52672,1464,'tr','Navlun Ã¼cretleri',0),(52673,1464,'pl','OpÅ‚aty frachtowe',0),(52674,1464,'bg','Ð¢Ð¾Ð²Ð°Ñ€ÐµÐ½ Ñ‚Ð°ÐºÑÐ¸',0),(52675,1464,'ur','Ø³Ø§Ù…Ø§Ù† Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(52676,1464,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð°',0),(52677,1464,'vi','CÆ°á»›c Váº­n chuyá»ƒn',0),(52678,1464,'af','Vragkostes',0),(52679,1464,'ro','Taxele de transport de marfÄƒ',0),(52680,1464,'et','Lasti tasu',0),(52681,1464,'si','StroÅ¡ki prevoza',0),(52682,1464,'ba','Biaya pengiriman',0),(52683,1464,'nl','Vrachtkosten',0),(52684,1464,'fi','Rahtikustannukset',0),(52685,1464,'no','Fraktkostnader',0),(52686,1464,'da','Fragtomkostninger',0),(52687,1464,'ko','ìš´ì†¡ ë¹„ìš©',0),(52688,1464,'he','×”×•×¦××•×ª ×”×•×‘×œ×”',0),(52689,1464,'el','ÎˆÎ¾Î¿Î´Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚',0),(52690,1464,'zh','è¿è´¹\r\n',0),(52691,1464,'sv','Fraktavgifter',0),(52692,1464,'it','Nolo',0),(52693,1464,'tl','',0),(52694,1464,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3651;&#3609;&#3585;&#3634;&#3619;&#3610;&#3619;&#3619;&#3607;&#3640;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(52695,1464,'hi','à¤®à¤¾à¤² à¤¢à¥à¤²à¤¾à¤ˆ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(52696,1464,'ms','Caj pengangkutan',0),(52697,1464,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø´Ø­Ù†',0),(52698,1464,'fr','Frais de transport',0),(52699,1464,'jp','é?‹é€?æ–™',0),(52700,1464,'pt','Despesas de frete',0),(52701,1464,'ru','Ð¢Ñ€Ð°Ð½ÑÐ¿Ð¾Ñ€Ñ‚Ð½Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(52702,1464,'es','Cargos de Flete',0),(52703,1464,'de','Frachtkosten',0),(52704,1464,'en','Freight Charges',0),(52705,1465,'is','',0),(52706,1465,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ ',0),(52707,1465,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ ',0),(52708,1465,'tr','Navlun gideri',0),(52709,1465,'pl','Koszt frachtu',0),(52710,1465,'bg','Ð¢Ð¾Ð²Ð°Ñ€Ð½Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(52711,1465,'ur','Ø³Ø§Ù…Ø§Ù† Ú©Ø§ Ø®Ø±Ú†Û',0),(52712,1465,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð°',0),(52713,1465,'vi','Chi phÃ­ Váº­n chuyá»ƒn',0),(52714,1465,'af','Vrag uitgawe',0),(52715,1465,'ro','Cheltuieli de transport de marfÄƒ',0),(52716,1465,'et','Kauba kulu',0),(52717,1465,'si','StroÅ¡ke prevoza',0),(52718,1465,'ba','Biaya pengiriman',0),(52719,1465,'nl','Goederenvervoer kosten',0),(52720,1465,'fi','Rahti kulut',0),(52721,1465,'no','Frakt kostnader',0),(52722,1465,'da','Fragt regning',0),(52723,1465,'ko','ìš´ì†¡ ë¹„ìš©',0),(52724,1465,'he','×”×•×¦××•×ª ×”×•×‘×œ×”',0),(52725,1465,'el','Î”Î±Ï€Î¬Î½Î· ÎµÎ¼Ï€Î¿ÏÎµÏ…Î¼Î±Ï„Î¹ÎºÏŽÎ½ Î¼ÎµÏ„Î±Ï†Î¿ÏÏŽÎ½',0),(52726,1465,'zh','è´§è¿è´¹ç”¨\r\n',0),(52727,1465,'sv','Frakt kostnad',0),(52728,1465,'it','Spese di trasporto',0),(52729,1465,'tl','',0),(52730,1465,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3651;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(52731,1465,'hi','à¤ªà¤°à¤¿à¤µà¤¹à¤¨ à¤µà¥à¤¯à¤¯',0),(52732,1465,'ms','Perbelanjaan pengangkutan',0),(52733,1465,'ar','Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø´Ø­Ù†',0),(52734,1465,'fr','Frais de transport',0),(52735,1465,'jp','é?‹é€?è²»ç”¨',0),(52736,1465,'pt','Despesa de frete',0),(52737,1465,'ru','Ð“Ñ€ÑƒÐ·Ð¾Ð²Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(52738,1465,'es','Gastos de Flete',0),(52739,1465,'de','Fracht-Kosten',0),(52740,1465,'en','Freight Expense',0),(52741,1466,'is','',0),(52742,1466,'dr','ÙØ±Ø§Ù†Ø³ÙˆÙŠ ',0),(52743,1466,'pr','ÙØ±Ø§Ù†Ø³ÙˆÙŠ ',0),(52744,1466,'tr','FransÄ±zca',0),(52745,1466,'pl','Francuski',0),(52746,1466,'bg','Ð¤Ñ€ÐµÐ½ÑÐºÐ¸',0),(52747,1466,'ur','ÙØ±Ù†Ú†',0),(52748,1466,'sr','Ñ„Ñ€Ð°Ð½Ñ†ÑƒÑÐºÐ¸',0),(52749,1466,'vi','Tiáº¿ng PhÃ¡p',0),(52750,1466,'af','Frans',0),(52751,1466,'ro','FrancezÄƒ',0),(52752,1466,'et','Prantsuse',0),(52753,1466,'si','francoÅ¡Äina',0),(52754,1466,'ba','Prancis',0),(52755,1466,'nl','Frans',0),(52756,1466,'fi','ranska',0),(52757,1466,'no','Fransk',0),(52758,1466,'da','fransk',0),(52759,1466,'ko','í”„ëž‘ìŠ¤ì–´',0),(52760,1466,'he','×¦×¨×¤×ª×™×ª',0),(52761,1466,'el','Î“Î±Î»Î»Î¹ÎºÎ¬',0),(52762,1466,'zh','æ³•å›½çš„\r\n',0),(52763,1466,'sv','Franska',0),(52764,1466,'it','Francese',0),(52765,1466,'tl','',0),(52766,1466,'th','&#3616;&#3634;&#3625;&#3634;&#3613;&#3619;&#3633;&#3656;&#3591;&#3648;&#3624;&#3626;',0),(52767,1466,'hi','à¥žà¥à¤°à¥‡à¤‚à¤š',0),(52768,1466,'ms','Perancis',0),(52769,1466,'ar','Ø§Ù„ÙØ±Ù†Ø³ÙŠØ©',0),(52770,1466,'fr','FranÃ§ais',0),(52771,1466,'jp','ãƒ•ãƒ©ãƒ³ã‚¹èªž',0),(52772,1466,'pt','FrancÃªs',0),(52773,1466,'ru','Ñ„Ñ€Ð°Ð½Ñ†ÑƒÐ·ÑÐºÐ¸Ð¹',0),(52774,1466,'es','FrancÃ©s',0),(52775,1466,'de','FranzÃ¶sisch',0),(52776,1466,'en','French',0),(52777,1467,'is','',0),(52778,1467,'dr','Ø§Ø² ',0),(52779,1467,'pr','Ø§Ø² ',0),(52780,1467,'tr','Kaynak',0),(52781,1467,'pl','Od',0),(52782,1467,'bg','ÐžÑ‚',0),(52783,1467,'ur','Ø³Û’',0),(52784,1467,'sr','Ð˜Ð·',0),(52785,1467,'vi','Tá»«',0),(52786,1467,'af','Vanaf',0),(52787,1467,'ro','La',0),(52788,1467,'et','Kellelt',0),(52789,1467,'si','Iz',0),(52790,1467,'ba','Dari',0),(52791,1467,'nl','Van',0),(52792,1467,'fi','Alkaen',0),(52793,1467,'no','Fra',0),(52794,1467,'da','Fra',0),(52795,1467,'ko','ë³´ë‚¸ ì‚¬ëžŒ',0),(52796,1467,'he','×ž××ª',0),(52797,1467,'el','Î‘Ï€ÏŒ',0),(52798,1467,'zh','ä»Ž\r\n',0),(52799,1467,'sv','FrÃ¥n',0),(52800,1467,'it','Da',0),(52801,1467,'tl','',0),(52802,1467,'th','&#3592;&#3634;&#3585;',0),(52803,1467,'hi','à¤¸à¥‡',0),(52804,1467,'ms','Dari',0),(52805,1467,'ar','Ù…Ù†',0),(52806,1467,'fr','De',0),(52807,1467,'jp','ã?‹ã‚‰',0),(52808,1467,'pt','De',0),(52809,1467,'ru','Ð˜Ð·',0),(52810,1467,'es','De, Desde',0),(52811,1467,'de','Von',0),(52812,1467,'en','From',0),(52813,1468,'is','',0),(52814,1468,'dr','(Ø¨Ø§Ù‚ÙŠØ¨ÛŒÙ„Ø§Ù†Ø³',0),(52815,1468,'pr','Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± ØªØ±Ø§Ø²(Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡',0),(52816,1468,'tr','dengede olmasÄ±.',0),(52817,1468,'pl','jest w rÃ³wnowadze.',0),(52818,1468,'bg','Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð² Ð±Ð°Ð»Ð°Ð½Ñ.',0),(52819,1468,'ur','ØªÙˆØ§Ø²Ù† Ù…ÛŒÚº ÛÙˆÙ†Û’ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ ÛÛ’ Û”',0),(52820,1468,'sr','Ð¸Ð· ÑÑ‚Ð°ÑšÐ° Ñƒ Ð±Ð°Ð»Ð°Ð½ÑÑƒ.',0),(52821,1468,'vi','tá»« sá»‘ dÆ°',0),(52822,1468,'af','om te balanseer.',0),(52823,1468,'ro','de a fi Ã®n echilibru.',0),(52824,1468,'et','alates on tasakaalus.',0),(52825,1468,'si','s bitje v ravnovesju.',0),(52826,1468,'ba','dari berada dalam keseimbangan.',0),(52827,1468,'nl','uit het zijn in evenwicht.',0),(52828,1468,'fi','on tasapainossa.',0),(52829,1468,'no','blir i balanse.',0),(52830,1468,'da','fra at vÃ¦re i balance.',0),(52831,1468,'ko','ê· í˜•ì—ì„œ ë˜ ê³ .',0),(52832,1468,'he','×ž×œ×”×™×•×ª ×©×™×•×•×™ ×ž×©×§×œ.',0),(52833,1468,'el','Î±Ï€ÏŒ Ï„Î¿ Î½Î± ÎµÎ¯Î½Î±Î¹ ÏƒÎµ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±.',0),(52834,1468,'zh','ä»Žå¹³è¡¡ã€‚\r\n',0),(52835,1468,'sv','frÃ¥n att vara i balans.',0),(52836,1468,'it','dall\'essere in equilibrio.',0),(52837,1468,'tl','',0),(52838,1468,'th','&#3592;&#3634;&#3585;&#3618;&#3629;&#3604;&#3651;&#3609;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(52839,1468,'hi','à¤¶à¥‡à¤· à¤®à¥‡à¤‚ à¤¸à¥‡ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤°à¤¹à¤¾à¥¤',0),(52840,1468,'ms','kerana kira-kira.',0),(52841,1468,'ar','Ù…Ù† ÙŠØ¬Ø±ÙŠ ÙÙŠ Ø§Ù„ØªÙˆØ§Ø²Ù†.',0),(52842,1468,'fr','d\'Ãªtre en Ã©quilibre.',0),(52843,1468,'jp','ãƒ?ãƒ©ãƒ³ã‚¹ã?—ã?¦ã‚‹ã?®ã?§',0),(52844,1468,'pt','de estar em equilÃ­brio.',0),(52845,1468,'ru','Ð¾Ñ‚ Ñ‚Ð¾Ð³Ð¾, Ð² Ñ€Ð°Ð²Ð½Ð¾Ð²ÐµÑÐ¸Ð¸.',0),(52846,1468,'es','Desde siendo en balance',0),(52847,1468,'de','aus dem Gleichgewicht.',0),(52848,1468,'en','from being in balance.',0),(52849,1469,'is','',0),(52850,1469,'dr','Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(52851,1469,'pr','Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(52852,1469,'tr','BaÅŸlangÄ±Ã§ tarihi',0),(52853,1469,'pl','Od daty',0),(52854,1469,'bg','ÐžÑ‚ Ð´Ð°Ñ‚Ð°',0),(52855,1469,'ur','ØªØ§Ø±ÛŒØ® Ø³Û’',0),(52856,1469,'sr','ÐžÐ´ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(52857,1469,'vi','Tá»« ngÃ y',0),(52858,1469,'af','Vanaf Datum',0),(52859,1469,'ro','De la data',0),(52860,1469,'et','Alates kuupÃ¤evast',0),(52861,1469,'si','Od datuma',0),(52862,1469,'ba','Dari tanggal',0),(52863,1469,'nl','Vanaf datum',0),(52864,1469,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤stÃ¤',0),(52865,1469,'no','Fra dato',0),(52866,1469,'da','Fra dato',0),(52867,1469,'ko','ë‚ ì§œì—ì„œ',0),(52868,1469,'he','×ž×ª××¨×™×š',0),(52869,1469,'el','Î‘Ï€ÏŒ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(52870,1469,'zh','ä»Žæ—¥æœŸ\r\n',0),(52871,1469,'sv','FrÃ¥n datum',0),(52872,1469,'it','Dalla data di',0),(52873,1469,'tl','',0),(52874,1469,'th','&#3592;&#3634;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(52875,1469,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¥‡',0),(52876,1469,'ms','Dari tarikh',0),(52877,1469,'ar','Ù…Ù† ',0),(52878,1469,'fr','De la Date',0),(52879,1469,'jp','ï½žæ—¥ä»˜ã?‹ã‚‰',0),(52880,1469,'pt','Partir da data',0),(52881,1469,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(52882,1469,'es','De la Fecha',0),(52883,1469,'de','Ab Datum',0),(52884,1469,'en','From Date',0),(52885,1470,'is','',0),(52886,1470,'dr','FUI Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ',0),(52887,1470,'pr','FUI Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ',0),(52888,1470,'tr','FUI',0),(52889,1470,'pl','FUI',0),(52890,1470,'bg','FUI',0),(52891,1470,'ur','ÙØ§',0),(52892,1470,'sr','Ð¡Ð˜Ð¢Ð',0),(52893,1470,'vi','FUI',0),(52894,1470,'af','FUI',0),(52895,1470,'ro','FUI',0),(52896,1470,'et','FUI',0),(52897,1470,'si','FUI',0),(52898,1470,'ba','FUI',0),(52899,1470,'nl','FUI',0),(52900,1470,'fi','FUI',0),(52901,1470,'no','FUI',0),(52902,1470,'da','FUI',0),(52903,1470,'ko','FUI',0),(52904,1470,'he','FUI',0),(52905,1470,'el','FUI',0),(52906,1470,'zh','å¸¸ç”¨æœ€åˆçš„\r\n',0),(52907,1470,'sv','FUI',0),(52908,1470,'it','FUI',0),(52909,1470,'tl','',0),(52910,1470,'th','FUI',0),(52911,1470,'hi','FUI',0),(52912,1470,'ms','FUI',0),(52913,1470,'ar','ÙÙŠ',0),(52914,1470,'fr','FUI',0),(52915,1470,'jp','FUI',0),(52916,1470,'pt','FUI',0),(52917,1470,'ru','FUI',0),(52918,1470,'es','FUI',0),(52919,1470,'de','FUI',0),(52920,1470,'en','FUI',0),(52921,1471,'is','',0),(52922,1471,'dr','FUI Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ',0),(52923,1471,'pr','FUI Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ\r\n',0),(52924,1471,'tr','FUI vergi',0),(52925,1471,'pl','FUI podatku',0),(52926,1471,'bg','FUI Ð´Ð°Ð½ÑŠÐº',0),(52927,1471,'ur','ÙØ§ Ù¹ÛŒÚ©Ø³',0),(52928,1471,'sr','Ð¡Ð¸Ñ‚Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(52929,1471,'vi','Thuáº¿ FUI',0),(52930,1471,'af','FUI belasting',0),(52931,1471,'ro','FUI fiscale',0),(52932,1471,'et','FUI maksu',0),(52933,1471,'si','FUI davka',0),(52934,1471,'ba','FUI pajak',0),(52935,1471,'nl','FUI belasting',0),(52936,1471,'fi','FUI vero',0),(52937,1471,'no','FUI skatt',0),(52938,1471,'da','FUI skat',0),(52939,1471,'ko','FUI ì„¸ê¸ˆ',0),(52940,1471,'he','FUI ×ž×¡',0),(52941,1471,'el','FUI Ï†ÏŒÏÎ¿Ï…',0),(52942,1471,'zh','å¸¸ç”¨æœ€åˆçš„ç¨Ž\r\n',0),(52943,1471,'sv','FUI skatt',0),(52944,1471,'it','FUI fiscale',0),(52945,1471,'tl','',0),(52946,1471,'th','&#3616;&#3634;&#3625;&#3637; FUI',0),(52947,1471,'hi','FUI à¤Ÿà¥ˆà¤•à¥à¤¸',0),(52948,1471,'ms','Cukai FUI',0),(52949,1471,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(52950,1471,'fr','FUI impÃ´t',0),(52951,1471,'jp','FUIç¨Ž',0),(52952,1471,'pt','FUI fiscal',0),(52953,1471,'ru','FUI Ð½Ð°Ð»Ð¾Ð³',0),(52954,1471,'es','FUI Impuesto',0),(52955,1471,'de','FUI Steuer',0),(52956,1471,'en','FUI Tax',0),(52957,1472,'is','',0),(52958,1472,'dr','Ø´Ø±Ø­ ÙƒØ§Ù…Ù„ ',0),(52959,1472,'pr','Ø´Ø±Ø­ ÙƒØ§Ù…Ù„ ',0),(52960,1472,'tr','Tam aÃ§Ä±klama',0),(52961,1472,'pl','PeÅ‚ny opis',0),(52962,1472,'bg','ÐŸÑŠÐ»Ð½Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(52963,1472,'ur','Ù…Ú©Ù…Ù„ ØªÙØµÛŒÙ„',0),(52964,1472,'sr','ÐŸÑƒÐ½ Ð¾Ð¿Ð¸Ñ',0),(52965,1472,'vi','Diá»…n giáº£i Ä‘áº§y Ä‘á»§',0),(52966,1472,'af','Volle Beskrywing',0),(52967,1472,'ro','Descriere completa',0),(52968,1472,'et','TÃ¤ielik kirjeldus',0),(52969,1472,'si','Popoln opis',0),(52970,1472,'ba','Deskripsi lengkap',0),(52971,1472,'nl','Volledige beschrijving',0),(52972,1472,'fi','TÃ¤ydellinen kuvaus',0),(52973,1472,'no','Full beskrivelse',0),(52974,1472,'da','Fuld beskrivelse',0),(52975,1472,'ko','ì „ì²´ ì„¤ëª…',0),(52976,1472,'he','×ª×™××•×¨ ×ž×œ×',0),(52977,1472,'el','Î Î»Î®ÏÎ·Ï‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(52978,1472,'zh','è¯¦ç»†æè¿°\r\n',0),(52979,1472,'sv','FullstÃ¤ndig beskrivning',0),(52980,1472,'it','Descrizione completa',0),(52981,1472,'tl','',0),(52982,1472,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3648;&#3605;&#3655;&#3617;',0),(52983,1472,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤µà¤¿à¤µà¤°à¤£',0),(52984,1472,'ms','Penerangan penuh',0),(52985,1472,'ar','ÙˆØµÙ ÙƒØ§Ù…Ù„',0),(52986,1472,'fr','Description complÃ¨te',0),(52987,1472,'jp','è©³ã?—ã?„è§£èª¬',0),(52988,1472,'pt','DescriÃ§Ã£o completa',0),(52989,1472,'ru','ÐŸÐ¾Ð»Ð½Ð¾Ðµ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(52990,1472,'es','DescripciÃ³n Completa',0),(52991,1472,'de','VollstÃ¤ndige Beschreibung',0),(52992,1472,'en','Full Description',0),(52993,1473,'is','',0),(52994,1473,'dr','Ú¯Ø§Ù„Ù†',0),(52995,1473,'pr','Ú¯Ø§Ù„Ù†',0),(52996,1473,'tr','Ilgar',0),(52997,1473,'pl','Galon',0),(52998,1473,'bg','Ð“Ð°Ð»Ð¾Ð½',0),(52999,1473,'ur','Ú¯ÛŒÙ„Ù†',0),(53000,1473,'sr','Ð“Ð°Ð»Ð¾Ð½',0),(53001,1473,'vi','Gallon',0),(53002,1473,'af','Gallon',0),(53003,1473,'ro','Galon',0),(53004,1473,'et','Gallon',0),(53005,1473,'si','Galono',0),(53006,1473,'ba','Galon',0),(53007,1473,'nl','Gallon',0),(53008,1473,'fi','Gallona',0),(53009,1473,'no','Gallon',0),(53010,1473,'da','Gallon',0),(53011,1473,'ko','ê°¤ëŸ°',0),(53012,1473,'he','×’×œ×•×Ÿ',0),(53013,1473,'el','Î“Î±Î»ÏŒÎ½Î¹',0),(53014,1473,'zh','åŠ ä»‘\r\n',0),(53015,1473,'sv','Gallon',0),(53016,1473,'it','Gallone',0),(53017,1473,'tl','',0),(53018,1473,'th','&#3649;&#3585;&#3621;&#3621;&#3629;&#3609;',0),(53019,1473,'hi','à¤—à¥ˆà¤²à¤¨',0),(53020,1473,'ms','Gelen',0),(53021,1473,'ar','Ø¬Ø§Ù„ÙˆÙ†',0),(53022,1473,'fr','Gallon',0),(53023,1473,'jp','ã‚¬ãƒ­ãƒ³',0),(53024,1473,'pt','GalÃ£o',0),(53025,1473,'ru','Ð“Ð°Ð»Ð»Ð¾Ð½',0),(53026,1473,'es','GalÃ³n',0),(53027,1473,'de','Gallone',0),(53028,1473,'en','Gallon',0),(53029,1474,'is','',0),(53030,1474,'dr','ÙØ§ØµÙ„Ù‡ Ø¨ÙŠÙ† Ø­ÙØ±Ù‡ Ù‡Ø§ ',0),(53031,1474,'pr','ÙØ§ØµÙ„Ù‡ Ø¨ÙŠÙ† Ø­ÙØ±Ù‡ Ù‡Ø§ ',0),(53032,1474,'tr','BoÅŸluklar arasÄ±nda boÅŸluk',0),(53033,1474,'pl','RÃ³Å¼nica miÄ™dzy jamy',0),(53034,1474,'bg','Ð Ð°Ð·Ð»Ð¸ÐºÐ°Ñ‚Ð° Ð¼ÐµÐ¶Ð´Ñƒ ÐºÑƒÑ…Ð¸Ð½Ð¸',0),(53035,1474,'ur','Ú©Ø§ÙˆØ§ØªÛŒØ³ Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† Ø®Ù„ÛŒØ¬',0),(53036,1474,'sr','ÐˆÐ°Ð· Ð¸Ð·Ð¼ÐµÑ’Ñƒ ÑˆÑƒÐ¿Ñ™Ð¸Ð½Ð°',0),(53037,1474,'vi','Khe há»Ÿ giá»¯a lá»— há»•ng',0),(53038,1474,'af','Gaping tussen holtes',0),(53039,1474,'ro','Decalajul dintre cavitatile',0),(53040,1474,'et','Vahe ÃµÃµnsused',0),(53041,1474,'si','Vrzel med votline',0),(53042,1474,'ba','Kesenjangan antara rongga',0),(53043,1474,'nl','Kloof tussen Holten',0),(53044,1474,'fi','Ero onteloita',0),(53045,1474,'no','Gapet mellom hulrom',0),(53046,1474,'da','KlÃ¸ften mellem hulrum',0),(53047,1474,'ko','êµ¬ë© ì‚¬ì´ì˜ ê°„ê²©',0),(53048,1474,'he','×”×¤×¢×¨ ×‘×™×Ÿ ×—×œ×œ×™×',0),(53049,1474,'el','Î§Î¬ÏƒÎ¼Î± Î¼ÎµÏ„Î±Î¾Ï ÎºÎ¿Î¹Î»ÏŒÏ„Î·Ï„ÎµÏ‚',0),(53050,1474,'zh','ç©ºç™½ä¹‹é—´çš„å·®è·\r\n',0),(53051,1474,'sv','Klyftan mellan hÃ¥lrum',0),(53052,1474,'it','Divario tra cavitÃ ',0),(53053,1474,'tl','',0),(53054,1474,'th','&#3619;&#3632;&#3618;&#3632;&#3627;&#3656;&#3634;&#3591;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3627;&#3621;&#3640;&#3617;',0),(53055,1474,'hi','Cavities à¤•à¥‡ à¤¬à¥€à¤š à¤…à¤‚à¤¤à¤°',0),(53056,1474,'ms','Jurang antara rongga',0),(53057,1474,'ar','Ø§Ù„ÙØ¬ÙˆØ© Ø¨ÙŠÙ† ØªØ¬Ø§ÙˆÙŠÙ',0),(53058,1474,'fr','Ã‰cart entre les cavitÃ©s',0),(53059,1474,'jp','ç©ºæ´žã?®éš™é–“ã?®ã‚®ãƒ£ãƒƒãƒ—',0),(53060,1474,'pt','Lacuna entre as cavidades',0),(53061,1474,'ru','Ð Ð°Ð·Ñ€Ñ‹Ð² Ð¼ÐµÐ¶Ð´Ñƒ Ð¿Ð¾Ð»Ð¾ÑÑ‚ÑÐ¼Ð¸',0),(53062,1474,'es','Espacio Entre Cavidades',0),(53063,1474,'de','LÃ¼cke zwischen HohlrÃ¤ume',0),(53064,1474,'en','Gap Between Cavities',0),(53065,1475,'is','',0),(53066,1475,'dr','(Ø¯Ù†Ø¯Ù‡',0),(53067,1475,'pr','Ù†Ø³Ø¨Øª Ø´ÙŠØ¨ Ù„ÙˆØ§Ø²Ù… (Ø¯Ù†Ø¯Ù‡',0),(53068,1475,'tr','Geat Pitch oranÄ±',0),(53069,1475,'pl','Geat stosunek skoku',0),(53070,1475,'bg','Geat ÑÑ‚ÑŠÐ¿ÐºÐ° ÑÑŠÐ¾Ñ‚Ð½Ð¾ÑˆÐµÐ½Ð¸Ðµ',0),(53071,1475,'ur','Ú¯ÛŒØ§Ù¹ Ù¾Ú† ØªÙ†Ø§Ø³Ø¨',0),(53072,1475,'sr','Ð˜Ð·Ð²Ñ€ÑÐ½Ð¾ Ð±Ð°Ñ†Ð°ÑšÐµ Ð¾Ð´Ð½Ð¾ÑÐ¾Ð¼',0),(53073,1475,'vi','Tá»· suáº¥t bÃ¡o cÃ¡o geat',0),(53074,1475,'af','Geat toonhoogte verhouding',0),(53075,1475,'ro','Raportul de Pitch geat',0),(53076,1475,'et','JÃ¤tta pigi suhe',0),(53077,1475,'si','Geat smola razmerje',0),(53078,1475,'ba','Geat Pitch rasio',0),(53079,1475,'nl','Geat Pitch verhouding',0),(53080,1475,'fi','Geat piki suhde',0),(53081,1475,'no','Geat Pitch forholdet',0),(53082,1475,'da','Gaut Pitch forholdet',0),(53083,1475,'ko','Geat í”¼ì¹˜ ë¹„ìœ¨',0),(53084,1475,'he','×™×—×¡ ×’×•×‘×” Geat',0),(53085,1475,'el','Geat Ï€Î¯ÏƒÏƒÎ± Î±Î½Î±Î»Î¿Î³Î¯Î±',0),(53086,1475,'zh','é½¿è½®é—´è·æ¯”å€¼\r\n',0),(53087,1475,'sv','Geat Pitch Ratio',0),(53088,1475,'it','Geat Pitch Ratio',0),(53089,1475,'tl','',0),(53090,1475,'th','&#3629;&#3640;&#3611;&#3585;&#3619;&#3603;&#3660;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3632;&#3604;&#3633;&#3610;&#3629;&#3633;&#3605;&#3619;&#3634;&#3626;&#3656;&#3623;&#3609;',0),(53091,1475,'hi','Geat à¤ªà¤¿à¤š à¤…à¤¨à¥à¤ªà¤¾à¤¤',0),(53092,1475,'ms','Geat Pitch nisbah',0),(53093,1475,'ar','Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ù„Ø¹Ø¨ Ø¬ÙŠØª',0),(53094,1475,'fr','Geat Pitch Ratio',0),(53095,1475,'jp','Geat Pitch Ratio',0),(53096,1475,'pt','RelaÃ§Ã£o de Pitch geat',0),(53097,1475,'ru','Ð¡Ð¾Ð¾Ñ‚Ð½Ð¾ÑˆÐµÐ½Ð¸Ðµ geat ÑˆÐ°Ð³',0),(53098,1475,'es','Engranaje Ratio de Grado de InclinaciÃ³n',0),(53099,1475,'de','Geat Pitch VerhÃ¤ltnis',0),(53100,1475,'en','Geat Pitch Ratio',0),(53101,1476,'is','',0),(53102,1476,'dr','ÙƒÙ„ÙŠ',0),(53103,1476,'pr','ÙƒÙ„ÙŠ',0),(53104,1476,'tr','Genel',0),(53105,1476,'pl','OgÃ³lne',0),(53106,1476,'bg','ÐžÐ±Ñ‰Ð¸',0),(53107,1476,'ur','Ø¹Ù…ÙˆÙ…ÛŒ',0),(53108,1476,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð»Ðµ',0),(53109,1476,'vi','Chung',0),(53110,1476,'af','Algemeen',0),(53111,1476,'ro','General',0),(53112,1476,'et','Ãœldine',0),(53113,1476,'si','SploÅ¡no',0),(53114,1476,'ba','Umum',0),(53115,1476,'nl','Algemene',0),(53116,1476,'fi','Ehdot',0),(53117,1476,'no','Generelt',0),(53118,1476,'da','Generelle',0),(53119,1476,'ko','ì¼ë°˜',0),(53120,1476,'he','×›×œ×œ×™',0),(53121,1476,'el','Î“ÎµÎ½Î¹ÎºÎ®',0),(53122,1476,'zh','ä¸€èˆ¬\r\n',0),(53123,1476,'sv','AllmÃ¤nna',0),(53124,1476,'it','Generale',0),(53125,1476,'tl','',0),(53126,1476,'th','&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53127,1476,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯',0),(53128,1476,'ms','Am',0),(53129,1476,'ar','Ø¹Ø§Ù…',0),(53130,1476,'fr','GÃ©nÃ©rales',0),(53131,1476,'jp','ä¸€èˆ¬',0),(53132,1476,'pt','Geral',0),(53133,1476,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ðµ',0),(53134,1476,'es','General',0),(53135,1476,'de','Allgemeine',0),(53136,1476,'en','General',0),(53137,1477,'is','',0),(53138,1477,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ  ØªØ®ÙÙŠÙ   Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(53139,1477,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ  ØªØ®ÙÙŠÙ   Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(53140,1477,'tr','Genel kesme bilgisi baÅŸarÄ±yla eklendi.',0),(53141,1477,'pl','Informacje ogÃ³lne ciÄ™cie dodane pomyÅ›lnie.',0),(53142,1477,'bg','ÐžÐ±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ€ÑÐ·Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(53143,1477,'ur','Ø¬Ù†Ø±Ù„ Ú©Ø§Ù¹Ù†Û’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(53144,1477,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÑÐµÑ‡ÐµÑšÐµ Ð˜Ð½Ñ„Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(53145,1477,'vi','ThÃ´ng tin cáº¯t chung thÃªm vÃ o thÃ nh cÃ´ng',0),(53146,1477,'af','Algemene \"Cutting\" Inligting suksesvol geskep.',0),(53147,1477,'ro','General de tÄƒiere Info adÄƒugat cu succes.',0),(53148,1477,'et','Ãœldinfo lÃµikamine lisatud.',0),(53149,1477,'si','General rezanje Info uspeÅ¡no dodana.',0),(53150,1477,'ba','Umum pemotongan Info ditambahkan berhasil.',0),(53151,1477,'nl','Algemene snijden Info toegevoegd.',0),(53152,1477,'fi','Leikkaus yleistÃ¤ lisÃ¤ttiin.',0),(53153,1477,'no','General kutte Info lagt til.',0),(53154,1477,'da','General skÃ¦ring Info tilfÃ¸jet.',0),(53155,1477,'ko','ì¼ë°˜ ì ˆë‹¨ ì •ë³´ëŠ” ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(53156,1477,'he','×ž×™×“×¢ ×›×œ×œ×™ ×—×™×ª×•×š × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(53157,1477,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎºÎ¿Ï€Î®Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(53158,1477,'zh','ä¸€èˆ¬åˆ‡å‰Šä¿¡æ¯æ·»åŠ æˆåŠŸã€‚\r\n',0),(53159,1477,'sv','AllmÃ¤nna skÃ¤rning information lagts till.',0),(53160,1477,'it','Info taglio generale aggiunto con successo.',0),(53161,1477,'tl','',0),(53162,1477,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3633;&#3604;&#3605;&#3656;&#3629;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(53163,1477,'hi','à¤œà¤¨à¤°à¤² à¤•à¤¾à¤Ÿà¤¨à¥‡ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(53164,1477,'ms','Maklumat am memotong berjaya menambah.',0),(53165,1477,'ar','ÙˆØ£Ø¶Ø§Ù Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø´Ø§Ù…Ù„Ø© Ø¹Ø§Ù…Ø© Ø¨Ù†Ø¬Ø§Ø­.',0),(53166,1477,'fr','Info coupe gÃ©nÃ©rale ajoutÃ© avec succÃ¨s.',0),(53167,1477,'jp','ä¸€èˆ¬å€¤å¼•ã??æƒ…å ±ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(53168,1477,'pt','InformaÃ§Ã£o de corte geral adicionado com Ãªxito.',0),(53169,1477,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ€ÐµÐ·ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(53170,1477,'es','Info General de Corte agregado exitosamente',0),(53171,1477,'de','Allgemeine schneiden-Info wurde erfolgreich hinzugefÃ¼gt.',0),(53172,1477,'en','General Cutting Info added successfully.',0),(53173,1478,'is','',0),(53174,1478,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ  ØªØ®ÙÙŠÙ   Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯ ',0),(53175,1478,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ  ØªØ®ÙÙŠÙ   Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯ ',0),(53176,1478,'tr','Genel kesme bilgisi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(53177,1478,'pl','Informacje ogÃ³lne ciÄ™cie pomyÅ›lnie zaktualizowana.',0),(53178,1478,'bg','ÐžÐ±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ€ÑÐ·Ð°Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(53179,1478,'ur','Ø¬Ù†Ø±Ù„ Ú©Ø§Ù¹Ù†Û’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Û”',0),(53180,1478,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÑÐµÑ‡ÐµÑšÐµ Ð˜Ð½Ñ„Ð¾ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(53181,1478,'vi','Cáº­p nháº­t thÃ´ng tin cáº¯t thÃ nh cÃ´ng.',0),(53182,1478,'af','Algmene \"Cutting\" Inligting suksesvol opdateer.',0),(53183,1478,'ro','General de tÄƒiere Info actualizat cu succes.',0),(53184,1478,'et','Ãœldinfo lÃµikamine vÃ¤rskendamine Ãµnnestus.',0),(53185,1478,'si','General rezanje Info uspeÅ¡no posodobljen.',0),(53186,1478,'ba','Umum pemotongan Info diperbarui berhasil.',0),(53187,1478,'nl','Algemene snijden Info bijgewerkt.',0),(53188,1478,'fi','Leikkaus yleistÃ¤ pÃ¤ivitys onnistui.',0),(53189,1478,'no','General kutte Info er oppdatert.',0),(53190,1478,'da','General skÃ¦ring Info opdateret.',0),(53191,1478,'ko','ì¼ë°˜ ì ˆë‹¨ ì •ë³´ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(53192,1478,'he','×ž×™×“×¢ ×›×œ×œ×™ ×—×™×ª×•×š ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(53193,1478,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎºÎ¿Ï€Î®Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(53194,1478,'zh','ä¸€èˆ¬åˆ‡å‰Šä¿¡æ¯æ›´æ–°æˆåŠŸã€‚\r\n',0),(53195,1478,'sv','AllmÃ¤nna skÃ¤rning information har uppdaterats.',0),(53196,1478,'it','Info taglio generale aggiornato con successo.',0),(53197,1478,'tl','',0),(53198,1478,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3633;&#3604;&#3605;&#3656;&#3629;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3626;&#3635;&#3648;&#3619;&#3',0),(53199,1478,'hi','à¤œà¤¨à¤°à¤² à¤•à¤¾à¤Ÿà¤¨à¥‡ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(53200,1478,'ms','Maklumat am memotong berjaya dikemas kini.',0),(53201,1478,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø´Ø§Ù…Ù„Ø© Ø¹Ø§Ù…Ø© Ø¨Ù†Ø¬Ø§Ø­.',0),(53202,1478,'fr','Info coupe gÃ©nÃ©ral mis Ã  jour avec succÃ¨s.',0),(53203,1478,'jp','ä¸€èˆ¬å€¤å¼•ã??æƒ…å ±ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(53204,1478,'pt','InformaÃ§Ã£o de corte geral atualizado com Ãªxito.',0),(53205,1478,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ€ÐµÐ·ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(53206,1478,'es','Info General de Corte actualizada exitosamente',0),(53207,1478,'de','Allgemeines schneiden aktualisiert erfolgreich.',0),(53208,1478,'en','General Cutting Info updated successfully.',0),(53209,1479,'is','',0),(53210,1479,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ  ØªØ®ÙÙŠÙ  ',0),(53211,1479,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ  ØªØ®ÙÙŠÙ  ',0),(53212,1479,'tr','Genel kesme bilgi',0),(53213,1479,'pl','Informacje ogÃ³lne ciÄ™cia',0),(53214,1479,'bg','ÐžÐ±Ñ‰Ð° Ñ€ÑÐ·Ð°Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(53215,1479,'ur','Ø¬Ù†Ø±Ù„ Ú©Ø§Ù¹Ù†Û’ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(53216,1479,'sr','ÐžÐ¿ÑˆÑ‚Ðµ ÑÐµÑ‡ÐµÑšÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(53217,1479,'vi','ThÃ´ng tin cáº¯t chung',0),(53218,1479,'af','Algemene \"Cutting\" Inligting',0),(53219,1479,'ro','InformaÅ£ii generale de tÄƒiere',0),(53220,1479,'et','Ãœldine lÃµikamine teave',0),(53221,1479,'si','Rezanje sploÅ¡ne informacije',0),(53222,1479,'ba','Informasi umum pemotongan',0),(53223,1479,'nl','Algemene snij informatie',0),(53224,1479,'fi','Tietojen yleinen leikkaaminen',0),(53225,1479,'no','De generelle kutte informasjon',0),(53226,1479,'da','Generelle skÃ¦ring oplysninger',0),(53227,1479,'ko','ì¼ë°˜ ê°€ê³µ ì •ë³´',0),(53228,1479,'he','×ž×™×“×¢ ×›×œ×œ×™ ×’×–×™×¨×”',0),(53229,1479,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï„Î­Î¼Î½Î¿Ï…ÏƒÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(53230,1479,'zh','ä¸€èˆ¬åˆ‡å‰²ä¿¡æ¯\r\n',0),(53231,1479,'sv','AllmÃ¤nna skÃ¤rning Information',0),(53232,1479,'it','Informazioni generali di taglio',0),(53233,1479,'tl','',0),(53234,1479,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3633;&#3604;&#3605;&#3656;&#3629;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53235,1479,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤Ÿà¤¨à¥‡ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(53236,1479,'ms','Maklumat am memotong',0),(53237,1479,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø© Ø´Ø§Ù…Ù„Ø©',0),(53238,1479,'fr','Informations gÃ©nÃ©rales de coupe',0),(53239,1479,'jp','ä¸€èˆ¬å€¤å¼•ã??æƒ…å ±',0),(53240,1479,'pt','InformaÃ§Ã£o geral de corte',0),(53241,1479,'ru','Ð ÐµÐ·ÐºÐ¸ ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(53242,1479,'es','InformaciÃ³n General de Corte',0),(53243,1479,'de','Allgemeine schneiden-Informationen',0),(53244,1479,'en','General Cutting Information',0),(53245,1480,'is','',0),(53246,1480,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ',0),(53247,1480,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ',0),(53248,1480,'tr','Genel bilgi',0),(53249,1480,'pl','Informacje ogÃ³lne',0),(53250,1480,'bg','ÐžÐ±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(53251,1480,'ur','Ø¬Ù†Ø±Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(53252,1480,'sr','ÐžÐ¿ÑˆÑ‚Ð¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸',0),(53253,1480,'vi','ThÃ´ng tin chung',0),(53254,1480,'af','Algemene Inligting',0),(53255,1480,'ro','Informatii generale',0),(53256,1480,'et','Ãœldised Andmed',0),(53257,1480,'si','SploÅ¡ne informacije',0),(53258,1480,'ba','Info Umum',0),(53259,1480,'nl','Algemene Info',0),(53260,1480,'fi','Yleistiedot',0),(53261,1480,'no','General Info',0),(53262,1480,'da','General Info',0),(53263,1480,'ko','ì¼ë°˜ ì •ë³´',0),(53264,1480,'he','×ž×™×“×¢ ×›×œ×œ×™',0),(53265,1480,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(53266,1480,'zh','ä¸€èˆ¬ä¿¡æ¯\r\n',0),(53267,1480,'sv','AllmÃ¤n Info',0),(53268,1480,'it','Informazioni generali',0),(53269,1480,'tl','',0),(53270,1480,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53271,1480,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(53272,1480,'ms','Maklumat am',0),(53273,1480,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø©',0),(53274,1480,'fr','Infos gÃ©nÃ©rales',0),(53275,1480,'jp','ä¸€èˆ¬æƒ…å ±',0),(53276,1480,'pt','InformaÃ§Ã£o geral',0),(53277,1480,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð°Ñ Ð˜Ð½Ñ„Ð¾',0),(53278,1480,'es','Info General',0),(53279,1480,'de','Allgemeine Infos',0),(53280,1480,'en','General Info',0),(53281,1481,'is','',0),(53282,1481,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ù„ÙŠÙ†Ùƒ',0),(53283,1481,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ù„ÙŠÙ†Ùƒ',0),(53284,1481,'tr','Genel mÃ¼rekkep INFO',0),(53285,1481,'pl','Informacje ogÃ³lne atrament',0),(53286,1481,'bg','ÐžÐ±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾',0),(53287,1481,'ur','Ø¬Ù†Ø±Ù„ Ø§Ù†Ú© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(53288,1481,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð˜Ð½Ðº Ð˜Ð½Ñ„Ð¾',0),(53289,1481,'vi','ThÃ´ng tin má»±c chung',0),(53290,1481,'af','Algemene Ink Inligting',0),(53291,1481,'ro','General cernealÄƒ Info',0),(53292,1481,'et','Tindi Ãœldinfo',0),(53293,1481,'si','General Ärnilo Info',0),(53294,1481,'ba','Tinta Umum',0),(53295,1481,'nl','Algemene inkt Info',0),(53296,1481,'fi','Muste yleistiedot',0),(53297,1481,'no','General blekk Info',0),(53298,1481,'da','General blÃ¦k Info',0),(53299,1481,'ko','ì¼ë°˜ ìž‰í¬ ì •ë³´',0),(53300,1481,'he','×ž×™×“×¢ ×›×œ×œ×™-×“×™×•',0),(53301,1481,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼ÎµÎ»Î¬Î½Î¹',0),(53302,1481,'zh','ä¸€èˆ¬æ²¹å¢¨ä¿¡æ¯\r\n',0),(53303,1481,'sv','General blÃ¤ck Info',0),(53304,1481,'it','Generale inchiostro Info',0),(53305,1481,'tl','',0),(53306,1481,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3627;&#3617;&#3638;&#3585;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53307,1481,'hi','à¤œà¤¨à¤°à¤² à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(53308,1481,'ms','Maklumat am dakwat',0),(53309,1481,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø© Ø§Ù„Ø­Ø¨Ø±',0),(53310,1481,'fr','GÃ©nÃ©ral d\'encre Info',0),(53311,1481,'jp','ä¸€èˆ¬ã‚¤ãƒ³ã‚¯æƒ…å ±',0),(53312,1481,'pt','InformaÃ§Ã£o de tinta geral',0),(53313,1481,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‡ÐµÑ€Ð½Ð¸Ð»',0),(53314,1481,'es','Info General de Tinta',0),(53315,1481,'de','Allgemeine Ink-Info',0),(53316,1481,'en','General Ink Info',0),(53317,1482,'is','',0),(53318,1482,'dr','Ø¯ÙØªØ± ÙƒÙ„',0),(53319,1482,'pr','Ø¯ÙØªØ± ÙƒÙ„',0),(53320,1482,'tr','Genel muhasebe',0),(53321,1482,'pl','KsiÄ™ga',0),(53322,1482,'bg','Ð¡Ñ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(53323,1482,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§',0),(53324,1482,'sr','Ð“Ð»Ð°Ð²Ð½Ð° ÐºÑšÐ¸Ð³Ð°',0),(53325,1482,'vi','Sá»• CÃ¡i Tá»•ng Há»£p',0),(53326,1482,'af','Algemene Grootboek',0),(53327,1482,'ro','Contabilitate',0),(53328,1482,'et','Pearaamat',0),(53329,1482,'si','Glavna knjiga',0),(53330,1482,'ba','General Ledger',0),(53331,1482,'nl','Grootboek',0),(53332,1482,'fi','General Ledger',0),(53333,1482,'no','Finans',0),(53334,1482,'da','General Ledger',0),(53335,1482,'ko','ì¼ë°˜ íšŒê³„ ìž¥ë¶€',0),(53336,1482,'he','×”×¡×¤×¨ ×”×¨××©×™',0),(53337,1482,'el','Î“ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®',0),(53338,1482,'zh','æ€»å¸\r\n',0),(53339,1482,'sv','Redovisning',0),(53340,1482,'it','ContabilitÃ  generale',0),(53341,1482,'tl','',0),(53342,1482,'th','&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53343,1482,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾à¤¬à¤¹à¥€',0),(53344,1482,'ms','Lejar Am',0),(53345,1482,'ar','Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(53346,1482,'fr','ComptabilitÃ© gÃ©nÃ©rale',0),(53347,1482,'jp','ç·?å‹˜å®šå…ƒå¸³',0),(53348,1482,'pt','General Ledger',0),(53349,1482,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÐšÐ½Ð¸Ð³Ð°',0),(53350,1482,'es','Libro Mayor',0),(53351,1482,'de','Finanzbuchhaltung',0),(53352,1482,'en','General Ledger',0),(53353,1483,'is','',0),(53354,1483,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(53355,1483,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(53356,1483,'tr','Genel muhasebe hesabÄ±',0),(53357,1483,'pl','Konto ksiÄ™gowe ogÃ³lne',0),(53358,1483,'bg','ÐžÐ±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(53359,1483,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(53360,1483,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(53361,1483,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p',0),(53362,1483,'af','Algemene Grootboek Rekening',0),(53363,1483,'ro','General Ledger cont',0),(53364,1483,'et','Pearaamatu konto',0),(53365,1483,'si','General Ledger raÄun',0),(53366,1483,'ba','General Ledger Account',0),(53367,1483,'nl','Generaal grootboekrekening',0),(53368,1483,'fi','Yleinen kirjanpitotili',0),(53369,1483,'no','General finanskonto',0),(53370,1483,'da','General finanskonto',0),(53371,1483,'ko','ì¼ë°˜ ë ˆì € ê³„ì •',0),(53372,1483,'he','×—×©×‘×•×Ÿ ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™',0),(53373,1483,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï„Î·Ï‚ Î³ÎµÎ½Î¹ÎºÎ®Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚',0),(53374,1483,'zh','æ€»å¸å¸æˆ·\r\n',0),(53375,1483,'sv','AllmÃ¤nna redovisningskonto',0),(53376,1483,'it','Conto di contabilitÃ  generale',0),(53377,1483,'tl','',0),(53378,1483,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53379,1483,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¤¾',0),(53380,1483,'ms','Akaun Lejar Am',0),(53381,1483,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(53382,1483,'fr','Comptes au grand livre',0),(53383,1483,'jp','ç·?å‹˜å®šå…ƒå¸³å‹˜å®š',0),(53384,1483,'pt','General Ledger conta',0),(53385,1483,'ru','Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ Ð“Ðš',0),(53386,1483,'es','Cuenta de Libro Mayor',0),(53387,1483,'de','General-Sachkonto',0),(53388,1483,'en','General Ledger Account',0),(53389,1484,'is','',0),(53390,1484,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¯Ø±  Ù…Ø§Ù‡ Ø¨Ø±Ø§ÙŠ',0),(53391,1484,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¯Ø±  Ù…Ø§Ù‡ Ø¨Ø±Ø§ÙŠ',0),(53392,1484,'tr','Genel muhasebe hesap ay tarafÄ±ndan',0),(53393,1484,'pl','Konto ksiÄ™gowe ogÃ³lne przez miesiÄ…c',0),(53394,1484,'bg','ÐžÐ±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ð¾ Ð¼ÐµÑÐµÑ†Ð¸ Ð·Ð°',0),(53395,1484,'ur','Ù…ÛÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(53396,1484,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð¿Ð¾ Ð¼ÐµÑÐµÑ†Ñƒ Ð·Ð°',0),(53397,1484,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Theo ThÃ¡ng cho',0),(53398,1484,'af','Algemene Grootboek Rekening per Maand vir',0),(53399,1484,'ro','General Ledger cont de lunÄƒ pentru',0),(53400,1484,'et','Ãœldised pearaamatu konto kuu eest',0),(53401,1484,'si','General Ledger raÄun za mesec za',0),(53402,1484,'ba','General Ledger Account dengan bulan untuk',0),(53403,1484,'nl','General Ledger Account per maand voor',0),(53404,1484,'fi','Yleinen kirjanpitotilin kuukausittain',0),(53405,1484,'no','General Ledger konto etter mÃ¥ned for',0),(53406,1484,'da','General Ledger konto pr. mÃ¥ned for',0),(53407,1484,'ko','ì¼ë°˜ ë ˆì € ê³„ì •ì— ëŒ€ í•œ ì›”ë³„',0),(53408,1484,'he','×—×©×‘×•×Ÿ ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™ ×œ×¤×™ ×—×•×“×©×™× ×¢×‘×•×¨',0),(53409,1484,'el','Î“ÎµÎ½Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î³/Î» Î±Î½Î¬ Î¼Î®Î½Î± Î³Î¹Î±',0),(53410,1484,'zh','æŒ‰æœˆæ€»å¸å¸æˆ·\r\n',0),(53411,1484,'sv','AllmÃ¤nna redovisningskonto per mÃ¥nad fÃ¶r',0),(53412,1484,'it','Conto di contabilitÃ  generale di mese per',0),(53413,1484,'tl','',0),(53414,1484,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3586;&#3629;&#3591;&#3648;&#3604;&#3639;&#3629;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(53415,1484,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(53416,1484,'ms','Akaun Lejar Am mengikut bulan bagi',0),(53417,1484,'ar','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ø¨Ø´Ù‡Ø±',0),(53418,1484,'fr','Comptes au grand livre par mois pour',0),(53419,1484,'jp','æœˆå‰²ã‚Šç·?å‹˜å®šå…ƒå¸³å‹˜å®š',0),(53420,1484,'pt','General Ledger conta por mÃªs para',0),(53421,1484,'ru','ÐžÐ±Ñ‰Ð¸Ð¹ ÑÑ‡ÐµÑ‚ Ð“Ðš Ð¿Ð¾ Ð¼ÐµÑÑÑ†Ð°Ð¼ Ð´Ð»Ñ',0),(53422,1484,'es','Cuenta de Libro Mayor por Mes para',0),(53423,1484,'de','General Ledger Konto per Monat fÃ¼r',0),(53424,1484,'en','General Ledger Account by Month for',0),(53425,1485,'is','',0),(53426,1485,'dr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(53427,1485,'pr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(53428,1485,'tr','Genel muhasebe hesap tÃ¼rÃ¼',0),(53429,1485,'pl','Konto ksiÄ™gowe ogÃ³lne typu',0),(53430,1485,'bg','ÐžÐ±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ ÑÐ¼ÐµÑ‚ÐºÐ° Ñ‚Ð¸Ð¿',0),(53431,1485,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(53432,1485,'sr','Ð¢Ð¸Ð¿ Ð³ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(53433,1485,'vi','Loáº¡i TK Sá»• CÃ¡i Tá»•ng Há»£p',0),(53434,1485,'af','Algemene Grootboek Rekeningtipe',0),(53435,1485,'ro','Tip de cont de Registrul general',0),(53436,1485,'et','Pearaamatu kontotÃ¼Ã¼bid',0),(53437,1485,'si','Vrsta sploÅ¡ne postavke raÄuna',0),(53438,1485,'ba','Jenis General Ledger Account',0),(53439,1485,'nl','General Ledger accounttype',0),(53440,1485,'fi','General Ledger tilityypin',0),(53441,1485,'no','General Ledger konto',0),(53442,1485,'da','General Ledger Account Type',0),(53443,1485,'ko','ì¼ë°˜ ë ˆì € ê³„ì • ìœ í˜•',0),(53444,1485,'he','×¡×•×’ ×—×©×‘×•×Ÿ ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™',0),(53445,1485,'el','Î¤ÏÏ€Î¿Ï‚ Î³ÎµÎ½Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î³/Î»',0),(53446,1485,'zh','æ€»å¸å¸æˆ·ç±»åž‹\r\n',0),(53447,1485,'sv','General Ledger kontotyp',0),(53448,1485,'it','Tipo di conto di contabilitÃ  generale',0),(53449,1485,'tl','',0),(53450,1485,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53451,1485,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(53452,1485,'ms','Jenis akaun Lejar Am',0),(53453,1485,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨ ÙÙŠ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(53454,1485,'fr','Type de comptes au grand livre',0),(53455,1485,'jp','ç·?å‹˜å®šå…ƒå¸³å‹˜å®šã‚¿ã‚¤ãƒ—',0),(53456,1485,'pt','Tipo de conta de contabilidade geral',0),(53457,1485,'ru','Ð¢Ð¸Ð¿ Ð¾Ð±Ñ‰ÐµÐ³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð“Ðš',0),(53458,1485,'es','Tipo de Cuenta de Libro Mayor',0),(53459,1485,'de','General Ledger Kontotyp',0),(53460,1485,'en','General Ledger Account Type',0),(53461,1486,'is','',0),(53462,1486,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù¾Ø³Øª ÙƒØ±Ø¯Ù† ',0),(53463,1486,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù¾Ø³Øª ÙƒØ±Ø¯Ù† ',0),(53464,1486,'tr','Genel muhasebe hesaplarÄ± deftere nakil iÃ§in',0),(53465,1486,'pl','OgÃ³lne kont ksiÄ™gowych do ksiÄ™gowania',0),(53466,1486,'bg','ÐžÐ±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ',0),(53467,1486,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾ÙˆØ³Ù¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(53468,1486,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ ÐºÐ¾Ð½Ñ‚Ð° Ð·Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐµ',0),(53469,1486,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p chá» káº¿t chuyá»ƒn',0),(53470,1486,'af','Algemene Grootboek Rekeninge vir Postering',0),(53471,1486,'ro','General Ledger conturi pentru a posta',0),(53472,1486,'et','Ãœldised pearaamatu kontode sisestamiseks',0),(53473,1486,'si','General Ledger konte za knjiÅ¾enje',0),(53474,1486,'ba','General Ledger account untuk Posting',0),(53475,1486,'nl','Generaal grootboekrekeningen voor het boeken van',0),(53476,1486,'fi','Yleiset kirjanpitotilit kirjausta varten',0),(53477,1486,'no','General Ledger kontoer for postering',0),(53478,1486,'da','General finanskonti til bogfÃ¸ring',0),(53479,1486,'ko','ê²Œì‹œì— ëŒ€ í•œ ì¼ë°˜ ì›ìž¥ ê³„ì •',0),(53480,1486,'he','×’× ×¨×œ ×—×©×‘×•× ×•×ª ×¡×¤×¨ ×¨××©×™ ×¢×‘×•×¨ ×¨×™×©×•×',0),(53481,1486,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï„Î·Ï‚ Î³ÎµÎ½Î¹ÎºÎ®Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚ Î³Î¹Î± Ï„Î·Î½ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ·',0),(53482,1486,'zh','æŠ•å¯„æ€»å¸å¸æˆ·\r\n',0),(53483,1486,'sv','AllmÃ¤nna redovisningskonton fÃ¶r bokfÃ¶ring',0),(53484,1486,'it','Conti di contabilitÃ  generale per la pubblicazione',0),(53485,1486,'tl','',0),(53486,1486,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3',0),(53487,1486,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‡ à¤ªà¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤— à¤•à¥‡ à¤²à¤¿à¤',0),(53488,1486,'ms','Akaun Lejar Am bagi Posting',0),(53489,1486,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ù„Ù„ØªØ±Ø­ÙŠÙ„',0),(53490,1486,'fr','Comptes du grand livre gÃ©nÃ©ral pour l\'affichage',0),(53491,1486,'jp','è¨ˆä¸Šã?™ã‚‹ç·?å‹˜å®šå…ƒå¸³',0),(53492,1486,'pt','General Ledger contas para postagem',0),(53493,1486,'ru','ÐžÐ±Ñ‰ÐµÐ³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð“Ðš Ð´Ð»Ñ Ñ€Ð°Ð·Ð½Ð¾ÑÐºÐ¸',0),(53494,1486,'es','Cuentas de Libro Mayor para Asentar',0),(53495,1486,'de','General Sachkonten fÃ¼r die Buchung',0),(53496,1486,'en','General Ledger Accounts for Posting',0),(53497,1487,'is','',0),(53498,1487,'dr','Ù†Ù…ÙˆØ¯Ø§Ø±  Ø¯ÙØªØ± ÙƒÙ„ ',0),(53499,1487,'pr','Ù†Ù…ÙˆØ¯Ø§Ø±  Ø¯ÙØªØ± ÙƒÙ„ ',0),(53500,1487,'tr','Genel muhasebe pasta grafiÄŸi',0),(53501,1487,'pl','General Ledger wykres koÅ‚owy',0),(53502,1487,'bg','ÐžÐ±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ ÐºÑ€ÑŠÐ³Ð¾Ð²Ð° Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð°',0),(53503,1487,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ù¾Ø§Ø¦ÛŒ Ú†Ø§Ø±Ù¹',0),(53504,1487,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ ÐšÑ€ÑƒÐ¶Ð½Ð¸ Ð´Ð¸Ñ˜Ð°Ð³Ñ€Ð°Ð¼',0),(53505,1487,'vi','Biá»ƒu Äá»“ Sá»• CÃ¡i Tá»•ng Há»£p Dáº¡ng TrÃ²n ',0),(53506,1487,'af','Algemene Grootboek Sirkeldiagram Grafiek',0),(53507,1487,'ro','General Ledger Pie Chart',0),(53508,1487,'et','Ãœldised pearaamatu sektordiagramm',0),(53509,1487,'si','General Ledger tortnega grafikona',0),(53510,1487,'ba','General Ledger Pie Chart',0),(53511,1487,'nl','General Ledger cirkeldiagram',0),(53512,1487,'fi','General Ledger ympyrÃ¤kaavio',0),(53513,1487,'no','General Ledger sektordiagram',0),(53514,1487,'da','General Ledger cirkeldiagram',0),(53515,1487,'ko','ì¼ë°˜ ë ˆì € ì›í˜• ì°¨íŠ¸',0),(53516,1487,'he','×ª×¨×©×™× ×¢×•×’×” ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™',0),(53517,1487,'el','Î“ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® Î³ÏÎ¬Ï†Î·Î¼Î± Ï€Î¯Ï„Î±Ï‚',0),(53518,1487,'zh','æ€»å¸é¥¼å›¾\r\n',0),(53519,1487,'sv','General Ledger cirkeldiagram',0),(53520,1487,'it','General Ledger grafico a torta',0),(53521,1487,'tl','',0),(53522,1487,'th','&#3649;&#3612;&#3609;&#3616;&#3641;&#3617;&#3636; Pie &#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(53523,1487,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤ªà¤¾à¤‡ à¤šà¤¾à¤°à¥à¤Ÿ',0),(53524,1487,'ms','Carta pai Lejar Am',0),(53525,1487,'ar','Ù…Ø®Ø·Ø· Ø¯Ø§Ø¦Ø±ÙŠ ÙÙŠ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(53526,1487,'fr','General Ledger camembert',0),(53527,1487,'jp','ç·?å‹˜å®šå…ƒå¸³ãƒ‘ã‚¤ãƒ?ãƒ£ãƒ¼ãƒˆ',0),(53528,1487,'pt','GrÃ¡fico de pizza do General Ledger',0),(53529,1487,'ru','Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð“Ðš ÐºÑ€ÑƒÐ³Ð¾Ð²Ð°Ñ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¼Ð°',0),(53530,1487,'es','Libro Mayor GrÃ¡fica Pie',0),(53531,1487,'de','General Ledger Kreisdiagramm',0),(53532,1487,'en','General Ledger Pie Chart',0),(53533,1488,'is','',0),(53534,1488,'dr','Ù…Ø´Ø®ØµØ§Øª Ù†Ù…ÙˆØ¯Ø§Ø±  Ø¯ÙØªØ± ÙƒÙ„',0),(53535,1488,'pr','Ù…Ø´Ø®ØµØ§Øª Ù†Ù…ÙˆØ¯Ø§Ø±  Ø¯ÙØªØ± ÙƒÙ„',0),(53536,1488,'tr','GENEL MUHASEBE PASTA GRAFÄ°K TANIMI',0),(53537,1488,'pl','DEFINICJA GENERAL LEDGER WYKRES KOÅOWY',0),(53538,1488,'bg','ÐžÐ‘Ð©Ð˜ Ð›Ð•Ð”Ð–ÐªÐ  ÐšÐ ÐªÐ“ÐžÐ’Ð Ð”Ð˜ÐÐ“Ð ÐÐœÐ Ð”Ð•Ð¤Ð˜ÐÐ˜Ð¦Ð˜Ð¯',0),(53539,1488,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ù¾Ø§Ø¦ÛŒ Ú†Ø§Ø±Ù¹ Ú©ÛŒ ØªØ¹Ø±ÛŒÙ',0),(53540,1488,'sr','Ð”Ð•Ð¤Ð˜ÐÐ˜Ð¦Ð˜ÐˆÐ Ð“Ð•ÐÐ•Ð ÐÐ› ÐšÐŠÐ˜Ð“Ð• ÐšÐ Ð£Ð–ÐÐ˜ Ð”Ð˜ÐˆÐÐ“Ð ÐÐœ',0),(53541,1488,'vi','Äá»ŠNH NGHÄ¨A Biá»ƒu Äá»“ Sá»• CÃ¡i Tá»•ng Há»£p Dáº¡ng TrÃ²n ',0),(53542,1488,'af','ALGEMENE GROOTBOEK SIRKELDIAGRAM GRAFIEK DEFINISIE',0),(53543,1488,'ro','DEFINIÅ¢IA GENERAL LEDGER PIE CHART',0),(53544,1488,'et','ÃœLDISED PEARAAMATU SEKTORDIAGRAMMI MÃ„Ã„RATLUS',0),(53545,1488,'si','OPREDELITEV GENERAL LEDGER TORTNEGA GRAFIKONA',0),(53546,1488,'ba','DEFINISI GENERAL LEDGER PIE CHART',0),(53547,1488,'nl','GENERAL LEDGER CIRKELDIAGRAM DEFINITIE',0),(53548,1488,'fi','GENERAL LEDGER YMPYRÃ„KAAVIO MÃ„Ã„RITELMÃ„',0),(53549,1488,'no','GENERAL LEDGER SEKTORDIAGRAM DEFINISJON',0),(53550,1488,'da','GENERAL LEDGER CIRKELDIAGRAM DEFINITION',0),(53551,1488,'ko','ì¼ë°˜ ë ˆì € ì›í˜• ì°¨íŠ¸ ì •ì˜',0),(53552,1488,'he','×”×’×“×¨×ª ×›×œ×œ×™ ×¡×¤×¨ ×¨××©×™ ×ª×¨×©×™× ×¢×•×’×”',0),(53553,1488,'el','ÎŸÎ¡Î™Î£ÎœÎŒÎ£ Î“Î•ÎÎ™ÎšÎŸÎŽ ÎšÎ‘Î˜ÎŸÎ›Î™ÎšÎŸÎŽ Î“Î¡Î†Î¦Î—ÎœÎ‘ Î ÎŠÎ¤Î‘Î£',0),(53554,1488,'zh','æ€»å¸é¥¼å›¾å®šä¹‰\r\n',0),(53555,1488,'sv','GENERAL LEDGER CIRKELDIAGRAM DEFINITION',0),(53556,1488,'it','DEFINIZIONE DI GRAFICO A TORTA CONTABILITÃ€ GENERALE',0),(53557,1488,'tl','',0),(53558,1488,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3649;&#3612;&#3609;&#3616;&#3641;&#3617;&#3636; Pie &#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(53559,1488,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤ªà¤¾à¤‡ à¤šà¤¾à¤°à¥à¤Ÿ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾',0),(53560,1488,'ms','DEFINISI CARTA PAI LEJAR AM',0),(53561,1488,'ar','ØªØ¹Ø±ÙŠÙ Ø§Ù„Ù…Ø®Ø·Ø· Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠ ÙÙŠ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(53562,1488,'fr','DÃ‰FINITION DE GENERAL LEDGER CAMEMBERT',0),(53563,1488,'jp','ç·?å‹˜å®šå…ƒå¸³ãƒ‘ã‚¤ãƒ?ãƒ£ãƒ¼ãƒˆå®šç¾©',0),(53564,1488,'pt','DEFINIÃ‡ÃƒO DE GRÃFICO DE PIZZA DO GENERAL LEDGER',0),(53565,1488,'ru','ÐžÐŸÐ Ð•Ð”Ð•Ð›Ð•ÐÐ˜Ð• ÐžÐ‘Ð©Ð•Ð“Ðž Ð“Ðš ÐšÐ Ð£Ð“ÐžÐ’ÐÐ¯ Ð”Ð˜ÐÐ“Ð ÐÐœÐœÐ',0),(53566,1488,'es','LIBRO MAYOR GRÃFICA PIE DEFINICIÃ“N',0),(53567,1488,'de','GENERAL LEDGER KREISDIAGRAMM DEFINITION',0),(53568,1488,'en','GENERAL LEDGER PIE CHART DEFINITION',0),(53569,1489,'is','',0),(53570,1489,'dr','Ù…Ø´Ø®ØµØ§Øª Ø¨Ø±Ø´  Ù†Ù…ÙˆØ¯Ø§Ø±  Ø¯ÙØªØ± ÙƒÙ„',0),(53571,1489,'pr','Ù…Ø´Ø®ØµØ§Øª Ø¨Ø±Ø´  Ù†Ù…ÙˆØ¯Ø§Ø±  Ø¯ÙØªØ± ÙƒÙ„',0),(53572,1489,'tr','GENEL MUHASEBE PASTA DÄ°LÄ°MÄ° TANIMI',0),(53573,1489,'pl','GENERAL LEDGER PIE KAWAÅEK DEFINICJI',0),(53574,1489,'bg','ÐžÐ‘Ð©Ð˜ Ð›Ð•Ð”Ð–ÐªÐ  ÐšÐ ÐªÐ“ÐžÐ’Ð ÐŸÐÐ Ð§Ð• Ð”Ð•Ð¤Ð˜ÐÐ˜Ð¦Ð˜Ð¯',0),(53575,1489,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ù¾Ø§Ø¦ÛŒ Ù‚Ø§Ø´ ØªØ¹Ø±ÛŒÙ',0),(53576,1489,'sr','Ð“Ð•ÐÐ•Ð ÐÐ› ÐšÐŠÐ˜Ð“Ð• ÐŸÐ˜Ð¢Ð£ Ð¡Ð›Ð˜Ð¦Ð• Ð”Ð•Ð¤Ð˜ÐÐ˜Ð¦Ð˜ÐˆÐ',0),(53577,1489,'vi','Äá»‹nh NghÄ©a CÃ¡c LÃ¡t TrÃªn Biá»ƒu Äá»“ Sá»• CÃ¡i Tá»•ng Há»£p',0),(53578,1489,'af','ALGEMENE GROOTBOEK SIRKELDIAGRAM SKYF DEFINISIE',0),(53579,1489,'ro','DEFINIÅ¢IE DE FELIE DE PLÄ‚CINTÄ‚ DE REGISTRUL GENERAL',0),(53580,1489,'et','ÃœLDISED PEARAAMATU PIRUKAS VIIL MÃ„Ã„RATLUS',0),(53581,1489,'si','GENERAL LEDGER PITO REZINE OPREDELITEV',0),(53582,1489,'ba','GENERAL LEDGER PIE IRIS DEFINISI',0),(53583,1489,'nl','GENERAL LEDGER PIE SEGMENT DEFINITIE',0),(53584,1489,'fi','GENERAL LEDGER PIE SEKTORIN MÃ„Ã„RITELMÃ„N',0),(53585,1489,'no','GENERAL LEDGER PIE SKIVE DEFINISJON',0),(53586,1489,'da','GENERAL LEDGER PIE SKIVE DEFINITION',0),(53587,1489,'ko','ì¼ë°˜ ë ˆì € íŒŒì´ ìŠ¬ë¼ì´ìŠ¤ ì •ì˜',0),(53588,1489,'he','×¢×•×’×ª ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™ ×¤×¨×•×¡×” ×”×’×“×¨×”',0),(53589,1489,'el','Î“Î•ÎÎ™ÎšÎ‰ Î›ÎŸÎ“Î™Î£Î¤Î™ÎšÎ‰ Î ÎŠÎ¤Î‘ Î¦ÎˆÎ¤Î‘ ÎŸÎ¡Î™Î£ÎœÎŒÎ£',0),(53590,1489,'zh','æ€»å¸é¥¼å›¾å—å®šä¹‰\r\n',0),(53591,1489,'sv','GENERAL LEDGER PAJ SLICE DEFINITION',0),(53592,1489,'it','DEFINIZIONE DI FETTA DI TORTA DI CONTABILITÃ€ GENERALE',0),(53593,1489,'tl','',0),(53594,1489,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3656;&#3591; Pie &#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(53595,1489,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤ªà¤¾à¤‡ à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾',0),(53596,1489,'ms','DEFINISI HIRISAN PAI LEJAR AM',0),(53597,1489,'ar','ØªØ¹Ø±ÙŠÙ Ø´Ø±ÙŠØ­Ø© Ø§Ù„ØªØ®Ø·ÙŠØ· Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠ ÙÙŠ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(53598,1489,'fr','DÃ‰FINITION DE TRANCHE DE TARTE GRAND LIVRE GÃ‰NÃ‰RAL',0),(53599,1489,'jp','ç·?å‹˜å®šå…ƒå¸³ãƒ‘ã‚¤ã‚¹ãƒ©ã‚¤ã‚¹å®šç¾©',0),(53600,1489,'pt','DEFINIÃ‡ÃƒO DE FATIA DE TORTA DE GENERAL LEDGER',0),(53601,1489,'ru','ÐžÐŸÐ Ð•Ð”Ð•Ð›Ð•ÐÐ˜Ð• Ð¤Ð ÐÐ“ÐœÐ•ÐÐ¢Ð Ð“Ð•ÐÐ•Ð ÐÐ›Ð¬ÐÐžÐ™ ÐšÐÐ˜Ð“Ð˜ ÐŸÐ˜Ð ÐžÐ“',0),(53602,1489,'es','LIBRO MAYOR REBANADA DE GRÃFICA PIE DEFINICIÃ“N',0),(53603,1489,'de','GENERAL LEDGER PIE SLICE-DEFINITION',0),(53604,1489,'en','GENERAL LEDGER PIE SLICE DEFINITION',0),(53605,1490,'is','',0),(53606,1490,'dr','Ø¯Ø±ØµØ¯ Ø³Ø±Ø¨Ø§Ø± ÙƒÙ„ÙŠ',0),(53607,1490,'pr','Ø¯Ø±ØµØ¯ Ø³Ø±Ø¨Ø§Ø± ÙƒÙ„ÙŠ',0),(53608,1490,'tr','Genel yÃ¼k %',0),(53609,1490,'pl','OgÃ³lne obciÄ…Å¼enie %',0),(53610,1490,'bg','ÐžÐ±Ñ‰Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ %',0),(53611,1490,'ur','Ø¬Ù†Ø±Ù„ ÛÛŒÚˆ %',0),(53612,1490,'sr','% Ð˜Ð½Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð»',0),(53613,1490,'vi','% chi phÃ­ sá»± nghiá»‡p Chung',0),(53614,1490,'af','Algemene Oorhoofse %',0),(53615,1490,'ro','General aeriene %',0),(53616,1490,'et','Ãœldine Overhead %',0),(53617,1490,'si','General reÅ¾ijske %',0),(53618,1490,'ba','% Overhead Umum',0),(53619,1490,'nl','Generaal Overhead %',0),(53620,1490,'fi','Yleinen ylÃ¤puolella %',0),(53621,1490,'no','General Overhead %',0),(53622,1490,'da','Generelt Overhead %',0),(53623,1490,'ko','ì¼ë°˜ ì˜¤ë²„ í—¤ë“œ %',0),(53624,1490,'he','% ×ª×§×•×¨×” ×›×œ×œ×™×ª',0),(53625,1490,'el','Î“ÎµÎ½Î¹ÎºÎ® ÎµÎ½Î±Î­ÏÎ¹Î± %',0),(53626,1490,'zh','æ€»å¼€é”€ï¼…\r\n',0),(53627,1490,'sv','AllmÃ¤nna omkostnader %',0),(53628,1490,'it','Sovraccarico generale %',0),(53629,1490,'tl','',0),(53630,1490,'th','&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3651;&#3609;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53631,1490,'hi','à¤œà¤¨à¤°à¤² à¤‰à¤ªà¤°à¤¿ %',0),(53632,1490,'ms','Overhed am %',0),(53633,1490,'ar','% Ù…Ù† Ø§Ù„Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø©',0),(53634,1490,'fr','Frais gÃ©nÃ©raux gÃ©nÃ©ral %',0),(53635,1490,'jp','ä¸€èˆ¬è«¸çµŒè²»ï¼…',0),(53636,1490,'pt','Sobrecarga geral %',0),(53637,1490,'ru','% ÐžÐ±Ñ‰ÐµÐ³Ð¾ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(53638,1490,'es','Gastos Fijos %',0),(53639,1490,'de','General Overhead %',0),(53640,1490,'en','General Overhead %',0),(53641,1491,'is','',0),(53642,1491,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(53643,1491,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(53644,1491,'tr','Genel PO bilgisi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(53645,1491,'pl','OgÃ³lne informacje PO pomyÅ›lnie zaktualizowana',0),(53646,1491,'bg','ÐžÐ±Ñ‰Ð° PO Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(53647,1491,'ur','Ø¬Ù†Ø±Ù„ Ù¾Ùˆ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(53648,1491,'sr','ÐžÐ¿ÑˆÑ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐŸÐž Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(53649,1491,'vi','ThÃ´ng tin Ä‘Æ¡n mua hÃ ng chung cáº­p nháº­t thÃ nh cÃ´ng',0),(53650,1491,'af','Algemene AB Inligting suksesvol Opdateer',0),(53651,1491,'ro','Informatii generale despre PO actualizat cu succes',0),(53652,1491,'et','Ãœldinfo PO vÃ¤rskendamine Ãµnnestus',0),(53653,1491,'si','SploÅ¡ne informacije PO uspeÅ¡no posodobljena',0),(53654,1491,'ba','Info Umum PO diperbarui berhasil',0),(53655,1491,'nl','Algemene PO Info bijgewerkt',0),(53656,1491,'fi','Yleinen PO Info pÃ¤ivitetty',0),(53657,1491,'no','Generell PO Info oppdatert',0),(53658,1491,'da','Generelle PO Info opdateret',0),(53659,1491,'ko','ì¼ë°˜ í¬ ì •ë³´ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(53660,1491,'he','×ž×™×“×¢ ×›×œ×œ×™ ×¤×• ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(53661,1491,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ PO ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(53662,1491,'zh','ä¸€èˆ¬è®¢å•ä¿¡æ¯æ›´æ–°æˆåŠŸ\r\n',0),(53663,1491,'sv','AllmÃ¤n PO Info uppdaterades',0),(53664,1491,'it','Info generali PO aggiornato con successo',0),(53665,1491,'tl','',0),(53666,1491,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(53667,1491,'hi','à¤†à¤® à¤ªà¥‹ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(53668,1491,'ms','Maklumat umum PO berjaya dikemas kini',0),(53669,1491,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø© Ø¨Ùˆ Ø¨Ù†Ø¬Ø§Ø­',0),(53670,1491,'fr','Infos gÃ©nÃ©rales de PO mis Ã  jour avec succÃ¨s',0),(53671,1491,'jp','ä¸€èˆ¬æ³¨æ–‡æ›¸æƒ…å ±ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(53672,1491,'pt','InformaÃ§Ã£o geral de PO atualizado com sucesso',0),(53673,1491,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ PO ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(53674,1491,'es','Info General de OC Actualizada exitosamente',0),(53675,1491,'de','Hauptinformationen PO erfolgreich aktualisiert',0),(53676,1491,'en','General PO Info Updated successfully',0),(53677,1492,'is','',0),(53678,1492,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø± ÙƒÙ„ÙŠ',0),(53679,1492,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø± ÙƒÙ„ÙŠ',0),(53680,1492,'tr','Genel iÅŸ tÃ¼rÃ¼',0),(53681,1492,'pl','OgÃ³lne pracy typu',0),(53682,1492,'bg','ÐžÐ±Ñ‰ Ð²Ð¸Ð´ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(53683,1492,'ur','Ø¬Ù†Ø±Ù„ Ú©Ø§Ù… Ù‚Ø³Ù…',0),(53684,1492,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(53685,1492,'vi','Loáº¡i cÃ´ng viá»‡c Chung',0),(53686,1492,'af','Algemene werk tipe',0),(53687,1492,'ro','Tip de muncÄƒ general',0),(53688,1492,'et','Ãœldine tÃ¶Ã¶ tÃ¼Ã¼p',0),(53689,1492,'si','Vrsta dela sploÅ¡ne',0),(53690,1492,'ba','Jenis pekerjaan umum',0),(53691,1492,'nl','Generaal werksoort',0),(53692,1492,'fi','Yleinen tyÃ¶n tyyppi',0),(53693,1492,'no','General arbeidstype',0),(53694,1492,'da','General arbejdstype',0),(53695,1492,'ko','ì¼ë°˜ ìž‘ì—… í˜•ì‹',0),(53696,1492,'he','×¡×•×’ ×¢×‘×•×“×” ×›×œ×œ×™',0),(53697,1492,'el','Î“ÎµÎ½Î¹ÎºÏŒÏ‚ Î¤ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(53698,1492,'zh','ä¸€èˆ¬å·¥ä½œç±»åž‹\r\n',0),(53699,1492,'sv','AllmÃ¤nna arbete typ',0),(53700,1492,'it','Tipo di lavoro generale',0),(53701,1492,'tl','',0),(53702,1492,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53703,1492,'hi','à¤œà¤¨à¤°à¤² à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤°',0),(53704,1492,'ms','Jenis kerja am',0),(53705,1492,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù…Ø©',0),(53706,1492,'fr','Type de travail gÃ©nÃ©ral',0),(53707,1492,'jp','ä¸€èˆ¬ä½œæ¥­ã‚¿ã‚¤ãƒ—',0),(53708,1492,'pt','Tipo de trabalho geral',0),(53709,1492,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(53710,1492,'es','Tipo General de Trabajo ',0),(53711,1492,'de','General Arbeitstyp',0),(53712,1492,'en','General Work Type',0),(53713,1493,'is','',0),(53714,1493,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø± ÙƒÙ„ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(53715,1493,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø± ÙƒÙ„ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(53716,1493,'tr','Genel iÅŸ tÃ¼rÃ¼ baÅŸarÄ±yla eklendi.',0),(53717,1493,'pl','OgÃ³lne pracy typu dodane pomyÅ›lnie.',0),(53718,1493,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(53719,1493,'ur','Ø¹Ø§Ù… Ú©Ø§Ù… Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(53720,1493,'sr','Ð’Ñ€ÑÑ‚Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ñ€Ð°Ð´Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(53721,1493,'vi','Loáº¡i cÃ´ng viá»‡c Chung thÃ nh cÃ´ng',0),(53722,1493,'af','Algemene werktipe suksesvol bygevoeg.',0),(53723,1493,'ro','LucrÄƒri generale de tip adÄƒugat cu succes.',0),(53724,1493,'et','Ãœldise tÃ¶Ã¶ tÃ¼Ã¼p edukalt lisatud.',0),(53725,1493,'si','Vrsta sploÅ¡nega dela uspeÅ¡no dodana.',0),(53726,1493,'ba','Jenis pekerjaan umum ditambahkan berhasil.',0),(53727,1493,'nl','Algemene werksoort met succes toegevoegd.',0),(53728,1493,'fi','Vakuutussopimusoikeuden tyyppi lisÃ¤Ã¤minen onnistui.',0),(53729,1493,'no','Generelt type lagt.',0),(53730,1493,'da','Generelle arbejdstype tilfÃ¸jet.',0),(53731,1493,'ko','ì¼ë°˜ ìž‘ì—… í˜•ì‹ì„ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(53732,1493,'he','×¡×•×’ ×¢×‘×•×“×” ×›×œ×œ×™×ª × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(53733,1493,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Ï„ÏÏ€Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(53734,1493,'zh','é€šç”¨å·¥ç§æ·»åŠ æˆåŠŸã€‚\r\n',0),(53735,1493,'sv','AllmÃ¤nna arbetstyp lagts.',0),(53736,1493,'it','Tipo di lavoro generale aggiunto con successo.',0),(53737,1493,'tl','',0),(53738,1493,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(53739,1493,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(53740,1493,'ms','Kerja-kerja am jenis berjaya menambah.',0),(53741,1493,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù… Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(53742,1493,'fr','Type de travail gÃ©nÃ©rales ajoutÃ© avec succÃ¨s.',0),(53743,1493,'jp','ä¸€èˆ¬ä½œæ¥­ã‚¿ã‚¤ãƒ—ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(53744,1493,'pt','Tipo de trabalho geral adicionado com Ãªxito.',0),(53745,1493,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(53746,1493,'es','Tipo general de trabajo agregado exitosamente',0),(53747,1493,'de','Allgemeine Arbeitstyp erfolgreich hinzugefÃ¼gt.',0),(53748,1493,'en','General work type added successfully.',0),(53749,1494,'is','',0),(53750,1494,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø± ÙƒÙ„ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(53751,1494,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø± ÙƒÙ„ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(53752,1494,'tr','Genel iÅŸ tÃ¼rÃ¼ baÅŸarÄ±yla silindi.',0),(53753,1494,'pl','OgÃ³lne pracy typu usuniÄ™te pomyÅ›lnie.',0),(53754,1494,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(53755,1494,'ur','Ø¹Ù…ÙˆÙ…ÛŒ Ú©Ø§Ù… Ù‚Ø³Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(53756,1494,'sr','Ð’Ñ€ÑÑ‚Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ñ€Ð°Ð´Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(53757,1494,'vi','XÃ³a Loáº¡i cÃ´ng viá»‡c Chung thÃ nh cÃ´ng',0),(53758,1494,'af','Algemene werktipe suksesvol geskrap.',0),(53759,1494,'ro','LucrÄƒri generale de tip ÅŸters cu succes.',0),(53760,1494,'et','Ãœldise tÃ¶Ã¶ tÃ¼Ã¼p edukalt kustutatud.',0),(53761,1494,'si','Vrsta sploÅ¡nega dela uspeÅ¡no izbrisana.',0),(53762,1494,'ba','Jenis pekerjaan umum berhasil dihapus.',0),(53763,1494,'nl','Algemene werksoort verwijderd.',0),(53764,1494,'fi','Vakuutussopimusoikeuden tyyppi poistettu.',0),(53765,1494,'no','Generelt type slettet.',0),(53766,1494,'da','Generelle arbejdstype slettet.',0),(53767,1494,'ko','ì¼ë°˜ ìž‘ì—… í˜•ì‹ì„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(53768,1494,'he','×¡×•×’ ×¢×‘×•×“×” ×›×œ×œ×™×ª × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(53769,1494,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Ï„ÏÏ€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(53770,1494,'zh','ä¸€èˆ¬å·¥ä½œç±»åž‹åˆ é™¤æˆåŠŸ\r\n',0),(53771,1494,'sv','AllmÃ¤nna arbetstyp raderades.',0),(53772,1494,'it','Tipo di lavoro generale eliminato con successo.',0),(53773,1494,'tl','',0),(53774,1494,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(53775,1494,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(53776,1494,'ms','Kerja-kerja am jenis dihapuskan dengan jayanya.',0),(53777,1494,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù… Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(53778,1494,'fr','Type de travail gÃ©nÃ©rales supprimÃ© avec succÃ¨s.',0),(53779,1494,'jp','ä¸€èˆ¬ä½œæ¥­ã‚¿ã‚¤ãƒ—ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(53780,1494,'pt','Tipo de trabalho geral excluÃ­do com sucesso.',0),(53781,1494,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½.',0),(53782,1494,'es','Tipo general de trabajo eliminado exitosamente',0),(53783,1494,'de','Allgemeine Arbeitstyp erfolgreich gelÃ¶scht.',0),(53784,1494,'en','General work type deleted successfully.',0),(53785,1495,'is','',0),(53786,1495,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø± ÙƒÙ„ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(53787,1495,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø± ÙƒÙ„ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(53788,1495,'tr','Genel iÅŸ tÃ¼rÃ¼ bulunamadÄ±',0),(53789,1495,'pl','Nie znaleziono typu ogÃ³lna praca',0),(53790,1495,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(53791,1495,'ur','Ø¹Ø§Ù… Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(53792,1495,'sr','Ð’Ñ€ÑÑ‚Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ñ€Ð°Ð´Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(53793,1495,'vi','KhÃ´ng tháº¥y Loáº¡i cÃ´ng viá»‡c Chung',0),(53794,1495,'af','Algemene werk tipe gevind nie',0),(53795,1495,'ro','LucrÄƒri generale de tip nu a fost gÄƒsit',0),(53796,1495,'et','Ãœldise tÃ¶Ã¶ tÃ¼Ã¼p ei leitud',0),(53797,1495,'si','Vrsta sploÅ¡nega dela, ni mogoÄe najti',0),(53798,1495,'ba','Jenis pekerjaan umum yang tidak ditemukan',0),(53799,1495,'nl','Algemene werksoort niet gevonden',0),(53800,1495,'fi','Vakuutussopimusoikeuden tyyppiÃ¤ ei lÃ¶ydy',0),(53801,1495,'no','Finner ikke generelt-typen',0),(53802,1495,'da','Generelle arbejdstype blev ikke fundet',0),(53803,1495,'ko','ì¼ë°˜ ìž‘ì—… í˜•ì‹ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(53804,1495,'he','×¡×•×’ ×¢×‘×•×“×” ×›×œ×œ×™×ª ×œ× × ×ž×¦×',0),(53805,1495,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Ï„ÏÏ€Î¿Ï… Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(53806,1495,'zh','æ€»çš„å·¥ä½œç±»åž‹æœªæ‰¾åˆ°\r\n',0),(53807,1495,'sv','AllmÃ¤nna arbetstyp hittades inte',0),(53808,1495,'it','Tipo di lavoro generale non trovato',0),(53809,1495,'tl','',0),(53810,1495,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53811,1495,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(53812,1495,'ms','Jenis kerja-kerja am yang tidak dijumpai',0),(53813,1495,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù…',0),(53814,1495,'fr','Type de travaux gÃ©nÃ©raux introuvable',0),(53815,1495,'jp','ä¸€èˆ¬ä½œæ¥­ã‚¿ã‚¤ãƒ—ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(53816,1495,'pt','Tipo de trabalho geral nÃ£o encontrado',0),(53817,1495,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(53818,1495,'es','Tipo general de trabajo no se encontrÃ³',0),(53819,1495,'de','Allgemeine Arbeitstyp nicht gefunden',0),(53820,1495,'en','General work type not found',0),(53821,1496,'is','',0),(53822,1496,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø± ÙƒÙ„ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø´Ø¯',0),(53823,1496,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø± ÙƒÙ„ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø´Ø¯',0),(53824,1496,'tr','Genel iÅŸ tÃ¼rÃ¼ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(53825,1496,'pl','OgÃ³lne pracy typu pomyÅ›lnie zaktualizowana.',0),(53826,1496,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(53827,1496,'ur','Ø¹Ø§Ù… Ú©Ø§Ù… Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Û”',0),(53828,1496,'sr','Ð’Ñ€ÑÑ‚Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ñ€Ð°Ð´Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(53829,1496,'vi','Cáº­p nháº­t loáº¡i cÃ´ng viá»‡c chung thÃ nh cÃ´ng',0),(53830,1496,'af','Algemene werktipe suksesvol opdateer.',0),(53831,1496,'ro','LucrÄƒri generale de tip actualizat cu succes.',0),(53832,1496,'et','Ãœldise tÃ¶Ã¶ tÃ¼Ã¼p vÃ¤rskendamine Ãµnnestus.',0),(53833,1496,'si','Vrsta sploÅ¡nega dela uspeÅ¡no posodobljena.',0),(53834,1496,'ba','Jenis pekerjaan umum diperbarui berhasil.',0),(53835,1496,'nl','Algemene werksoort bijgewerkt.',0),(53836,1496,'fi','Vakuutussopimusoikeuden tyyppi pÃ¤ivitettiin onnistuneesti.',0),(53837,1496,'no','Generelt type oppdatert.',0),(53838,1496,'da','Generelle arbejdstype opdateret.',0),(53839,1496,'ko','ì¼ë°˜ ìž‘ì—… í˜•ì‹ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(53840,1496,'he','×¡×•×’ ×¢×‘×•×“×” ×›×œ×œ×™×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(53841,1496,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Ï„ÏÏ€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(53842,1496,'zh','é€šç”¨å·¥ç§æ›´æ–°æˆåŠŸã€‚\r\n',0),(53843,1496,'sv','AllmÃ¤nna arbetstyp uppdaterats.',0),(53844,1496,'it','Tipo di lavoro generale aggiornato con successo.',0),(53845,1496,'tl','',0),(53846,1496,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(53847,1496,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(53848,1496,'ms','Kerja-kerja am jenis berjaya dikemas kini.',0),(53849,1496,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù… ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(53850,1496,'fr','Type de travail gÃ©nÃ©rales mis Ã  jour avec succÃ¨s.',0),(53851,1496,'jp','ä¸€èˆ¬ä½œæ¥­ã‚¿ã‚¤ãƒ—ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(53852,1496,'pt','Tipo de trabalho geral atualizado com Ãªxito.',0),(53853,1496,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½.',0),(53854,1496,'es','Tipo general de trabajo actualizado exitosamente',0),(53855,1496,'de','Allgemeine Arbeitstyp erfolgreich aktualisiert.',0),(53856,1496,'en','General work type updated successfully.',0),(53857,1497,'is','',0),(53858,1497,'dr','Ú¯Ø±ÙØªÙ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ù†Ù‡Ø§ÙŠÙŠ Ø´Ø¯Ù‡ ',0),(53859,1497,'pr','Ú¯Ø±ÙØªÙ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ù†Ù‡Ø§ÙŠÙŠ Ø´Ø¯Ù‡ ',0),(53860,1497,'tr','KesinleÅŸmiÅŸ yapÄ± sipariÅŸi al',0),(53861,1497,'pl','UzyskaÄ‡ zamÃ³wienie budowaÄ‡ zakoÅ„czone',0),(53862,1497,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½ ÑÑ‚Ñ€Ð¾Ñ Ñ€ÐµÐ´',0),(53863,1497,'ur','Ù…Ù†Ù¹Ø³ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Ø§ Ø¢Ø±ÚˆØ± Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(53864,1497,'sr','ÐŸÑ€Ð°Ð²Ð¾Ð±Ñ€Ð°Ð½Ð¸Ð»Ð°ÑˆÑ‚Ð²Ð° Ð±ÑƒÐ¸Ð»Ð´ Ð½Ð°Ð»Ð¾Ð³',0),(53865,1497,'vi','Káº¿t thÃºc ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(53866,1497,'af','Kry gefinaliseerde Boubestellings',0),(53867,1497,'ro','Ia pentru a construi finalizate',0),(53868,1497,'et','Saada lÃµpule ehitada jÃ¤rjekorras',0),(53869,1497,'si','Dobili konÄne izgradnje',0),(53870,1497,'ba','Mengakhiri pembuatan Pesanan',0),(53871,1497,'nl','Gefinaliseerde opbouwvolgorde krijgen',0),(53872,1497,'fi','Saada valmiiksi tilauksen mukaan',0),(53873,1497,'no','FÃ¥ endelige bygge rekkefÃ¸lgen',0),(53874,1497,'da','FÃ¥ fÃ¦rdiggjort Byg efter ordre',0),(53875,1497,'ko','ìµœì¢…ëœ ë¹Œë“œ ìˆœì„œë¥¼ ì–»ì„',0),(53876,1497,'he','×œ×§×‘×œ ×’×™×‘×•×© ×‘× ×™×” ×”×–×ž× ×”',0),(53877,1497,'el','Î Î¬ÏÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„Î¹ÎºÎ® ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® ÏƒÎµÎ¹ÏÎ¬',0),(53878,1497,'zh','å¾—åˆ°æœ€ç»ˆå»ºç«‹é¡ºåº\r\n',0),(53879,1497,'sv','FÃ¥ slutbehandlad bygga order',0),(53880,1497,'it','Ottenere l\'ordine di compilazione finalizzato',0),(53881,1497,'tl','',0),(53882,1497,'th','&#3652;&#3604;&#3657;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(53883,1497,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¤¿à¤¯à¤¾ à¤¬à¤¿à¤²à¥à¤¡ à¤•à¥à¤°à¤® à¤¹à¥‹ à¤œà¤¾à¤“',0),(53884,1497,'ms','Mendapatkan perintah membina dimuktamadkan',0),(53885,1497,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø£Ù…Ø± Ø¨Ù†Ø§Ø¡ Ø§Ù„ØµÙŠØºØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ©',0),(53886,1497,'fr','Mettre en ordre de construction finalisÃ©e',0),(53887,1497,'jp','çµ„ç«‹æ³¨æ–‡ã‚’å®Œäº†ã?•ã?›ã‚‹',0),(53888,1497,'pt','Obter a ordem de compilaÃ§Ã£o finalizado',0),(53889,1497,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð· Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ð¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(53890,1497,'es','Agarrar orden de ConstrucciÃ³n finalizado',0),(53891,1497,'de','Finalisierte Buildreihenfolge zu erhalten',0),(53892,1497,'en','Get finalized build order',0),(53893,1498,'is','',0),(53894,1498,'dr','(Ù‡Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„',0),(53895,1498,'pr','Ø¯Ø§Ø¯Ù† ØªØ®Ù…ÙŠÙ† Ù…Ø­Ù…ÙˆÙ„Ù‡ (Ù‡Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„',0),(53896,1498,'tr','Navlun tahmin vermek',0),(53897,1498,'pl','Fracht oszacowania',0),(53898,1498,'bg','Ð”Ð°Ð´Ðµ Ñ‚Ð¾Ð²Ð°Ñ€Ð½Ð¸ Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(53899,1498,'ur','ÙØ±Ø§Ø¦Ù¹ Ø§Ù†Ø¯Ø§Ø²Û’ Ø¯Û’',0),(53900,1498,'sr','Ð”Ð°Ñ˜ Ñ‚ÐµÑ€ÐµÑ‚Ð½Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°',0),(53901,1498,'vi','Dá»± trÃ¹ váº­n chuyá»ƒn',0),(53902,1498,'af','Gee Vragprys Skatting',0),(53903,1498,'ro','Da marfÄƒ estimare',0),(53904,1498,'et','Anda kaubaveo',0),(53905,1498,'si','Podajte oceno tovornega',0),(53906,1498,'ba','Memberikan perkiraan Freight',0),(53907,1498,'nl','Vracht risicoschatting',0),(53908,1498,'fi','Tavaraliikenteen arvio',0),(53909,1498,'no','Gi frakt anslag',0),(53910,1498,'da','Fragt skÃ¸n',0),(53911,1498,'ko','í™”ë¬¼ ê²¬ì ',0),(53912,1498,'he','×œ×ª×ª ×”×¢×¨×›×” ×ž×˜×¢× ×™×',0),(53913,1498,'el','Î•ÎºÏ„Î¯Î¼Î·ÏƒÎ· Ï†Î¿ÏÏ„Î¯Ï‰Î½',0),(53914,1498,'zh','ç»™äºˆè¿è´¹é¢„è®¡\r\n',0),(53915,1498,'sv','Ge frakt uppskattning',0),(53916,1498,'it','Dare la stima di merci',0),(53917,1498,'tl','',0),(53918,1498,'th','&#3651;&#3627;&#3657;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3588;&#3656;&#3634;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(53919,1498,'hi','à¤®à¤¾à¤² à¤¢à¥à¤²à¤¾à¤ˆ à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤¦à¥‡',0),(53920,1498,'ms','Memberi anggaran pengangkutan',0),(53921,1498,'ar','Ø¥Ø¹Ø·Ø§Ø¡ ØªÙ‚Ø¯ÙŠØ± Ø§Ù„Ø´Ø­Ù†',0),(53922,1498,'fr','Donner des estimation de fret',0),(53923,1498,'jp','é?‹é€?è²»ç”¨ã‚’è¦‹ç©?ã‚‚ã‚‹',0),(53924,1498,'pt','Dar estimativa de frete',0),(53925,1498,'ru','Ð”Ð°Ñ‚ÑŒ Ð¾Ñ†ÐµÐ½ÐºÑƒ Ð³Ñ€ÑƒÐ·Ð¾Ð²Ñ‹Ñ…',0),(53926,1498,'es','Dar EstimaciÃ³n de Flete',0),(53927,1498,'de','Fracht-SchÃ¤tzung zu geben',0),(53928,1498,'en','Give Freight Estimate',0),(53929,1499,'is','',0),(53930,1499,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(53931,1499,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(53932,1499,'tr','GL hesabÄ±',0),(53933,1499,'pl','Konto GL',0),(53934,1499,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(53935,1499,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(53936,1499,'sr','Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(53937,1499,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p ',0),(53938,1499,'af','AG Rekening',0),(53939,1499,'ro','GL cont',0),(53940,1499,'et','Pearaamatu konto',0),(53941,1499,'si','RaÄun glavne knjige',0),(53942,1499,'ba','GL Account',0),(53943,1499,'nl','GL Account',0),(53944,1499,'fi','Kirjanpitotilin pÃ¤Ã¤tilin',0),(53945,1499,'no','GI-konto',0),(53946,1499,'da','GL konto',0),(53947,1499,'ko','GL ê³„ì •',0),(53948,1499,'he','×—×©×‘×•×Ÿ GL',0),(53949,1499,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(53950,1499,'zh','æ€»å¸å¸æˆ·\r\n',0),(53951,1499,'sv','GL-konto',0),(53952,1499,'it','GL Account',0),(53953,1499,'tl','',0),(53954,1499,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53955,1499,'hi','GL à¤–à¤¾à¤¤à¥‡',0),(53956,1499,'ms','GL akaun',0),(53957,1499,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(53958,1499,'fr','Compte GL',0),(53959,1499,'jp','GLã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(53960,1499,'pt','Conta GL',0),(53961,1499,'ru','Ð¡Ñ‡ÐµÑ‚ GL',0),(53962,1499,'es','Cuenta de LM',0),(53963,1499,'de','Sako',0),(53964,1499,'en','GL Account',0),(53965,1500,'is','',0),(53966,1500,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(53967,1500,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(53968,1500,'tr','GL hesabÄ± bulunamadÄ±',0),(53969,1500,'pl','GL konta nie znaleziono',0),(53970,1500,'bg','GL Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(53971,1500,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(53972,1500,'sr','Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(53973,1500,'vi','KhÃ´ng TÃ¬m Tháº¥y TK Sá»• CÃ¡i Tá»•ng Há»£p',0),(53974,1500,'af','AG Rekening Nie Gevind',0),(53975,1500,'ro','GL contul nu a fost gÄƒsit',0),(53976,1500,'et','PR kontot ei leitud',0),(53977,1500,'si','GL raÄuna ni bilo mogoÄe najti',0),(53978,1500,'ba','GL Account tidak ditemukan',0),(53979,1500,'nl','GL Account niet gevonden',0),(53980,1500,'fi','GL tiliÃ¤ ei lÃ¶ydy',0),(53981,1500,'no','GI-konto ikke funnet',0),(53982,1500,'da','GL konto ikke fundet',0),(53983,1500,'ko','GL ê³„ì •ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(53984,1500,'he','×—×©×‘×•×Ÿ GL ×œ× × ×ž×¦×',0),(53985,1500,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(53986,1500,'zh','æ€»å¸å¸æˆ·æœªæ‰¾åˆ°\r\n',0),(53987,1500,'sv','GL konto hittades inte',0),(53988,1500,'it','GL Account non trovato',0),(53989,1500,'tl','',0),(53990,1500,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(53991,1500,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(53992,1500,'ms','GL akaun tidak dijumpai',0),(53993,1500,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ (ÙÙŠ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…)',0),(53994,1500,'fr','GL compte introuvable',0),(53995,1500,'jp','GLã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(53996,1500,'pt','Conta GL nÃ£o encontrada',0),(53997,1500,'ru','GL ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°',0),(53998,1500,'es','Cuenta LM No Se EncontrÃ³',0),(53999,1500,'de','Sako nicht gefunden',0),(54000,1500,'en','GL Account Not Found',0),(54001,1501,'is','',0),(54002,1501,'dr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(54003,1501,'pr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(54004,1501,'tr','GL hesap tÃ¼rÃ¼ baÅŸarÄ±yla silindi',0),(54005,1501,'pl','Typ konta GL przesâ”‚anie',0),(54006,1501,'bg','GL Ð²Ð¸Ð´ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(54007,1501,'ur','Ø¬ÛŒØ¬Û’ Ù‚Ø³Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(54008,1501,'sr','Ð’Ñ€ÑÑ‚Ð° ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð› ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(54009,1501,'vi','XÃ³a TK Sá»• CÃ¡i Tá»•ng Há»£p thÃ nh cÃ´ng',0),(54010,1501,'af','AG Rekeningtipe suksesvol geskrap',0),(54011,1501,'ro','Tip de cont GL eliminÄƒ cu succes',0),(54012,1501,'et','GL kontotÃ¼Ã¼p edukalt kustutatud',0),(54013,1501,'si','GL vrsta konta uspeÅ¡no izbrisana',0),(54014,1501,'ba','Jenis Account GL dihapus berhasil',0),(54015,1501,'nl','GL accounttype succesvol verwijderd',0),(54016,1501,'fi','GL tilityyppi poistettu',0),(54017,1501,'no','GL kontotypen slettet',0),(54018,1501,'da','GL kontotype slettet',0),(54019,1501,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” GL ê³„ì • ìœ í˜•',0),(54020,1501,'he','×¡×•×’ ×—×©×‘×•×Ÿ GL × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(54021,1501,'el','Î¤ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï GL Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(54022,1501,'zh','æ€»å¸å¸æˆ·ç±»åž‹åˆ é™¤æˆåŠŸ\r\n',0),(54023,1501,'sv','GL kontotyp raderades',0),(54024,1501,'it','Tipo di Account GL eliminato con successo',0),(54025,1501,'tl','',0),(54026,1501,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(54027,1501,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(54028,1501,'ms','GL jenis akaun yang dihapuskan dengan jayanya',0),(54029,1501,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ø¨Ù†Ø¬Ø§Ø­',0),(54030,1501,'fr','Type de compte GL supprimÃ© avec succÃ¨s',0),(54031,1501,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚¿ã‚¤ãƒ—ã?®æ¶ˆåŽ»ã?«æˆ?åŠŸ',0),(54032,1501,'pt','Tipo de conta GL apagado com sucesso',0),(54033,1501,'ru','Ð¢Ð¸Ð¿ ÑÑ‡ÐµÑ‚Ð° GL, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(54034,1501,'es','Tipo de Cuenta LM eliminado exitosamente',0),(54035,1501,'de','GL-Kontotyp erfolgreich gelÃ¶scht',0),(54036,1501,'en','GL Account Type deleted successfully',0),(54037,1502,'is','',0),(54038,1502,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54039,1502,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54040,1502,'tr','GL hesaplarÄ±n detay',0),(54041,1502,'pl','GL konta szczegÃ³Å‚y',0),(54042,1502,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(54043,1502,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(54044,1502,'sr','Ð”ÐµÑ‚Ð°Ñ™ ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð›',0),(54045,1502,'vi','Chi Tiáº¿t TK Sá»• CÃ¡i Tá»•ng Há»£p ',0),(54046,1502,'af','AG Rekeninge Detail',0),(54047,1502,'ro','Detaliile de conturi GL',0),(54048,1502,'et','GL ettevÃµtete Ã¼ksikasjad',0),(54049,1502,'si','Podrobnosti raÄunov GL',0),(54050,1502,'ba','Detail account GL',0),(54051,1502,'nl','GL Accounts Detail',0),(54052,1502,'fi','GL asiakkaiden tiedot',0),(54053,1502,'no','GL kontoer detaljer',0),(54054,1502,'da','GL konti detaljer',0),(54055,1502,'ko','GL ê³„ì • ì„¸ë¶€ ì‚¬í•­',0),(54056,1502,'he','×¤×™×¨×•×˜ ×—×©×‘×•× ×•×ª GL',0),(54057,1502,'el','GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(54058,1502,'zh','æ€»å¸å¸æˆ·æ˜Žç»†\r\n',0),(54059,1502,'sv','GL konton detalj',0),(54060,1502,'it','Dettaglio conti GL',0),(54061,1502,'tl','',0),(54062,1502,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(54063,1502,'hi','GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(54064,1502,'ms','Detail akaun GL',0),(54065,1502,'ar','ØªÙØ§ØµÙŠÙ„ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(54066,1502,'fr','DÃ©tail des comptes GL',0),(54067,1502,'jp','GLã‚¢ã‚«ã‚¦ãƒ³ãƒˆè©³ç´°',0),(54068,1502,'pt','Detalhe de contas GL',0),(54069,1502,'ru','GL ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(54070,1502,'es','Detalle de Cuentas de LM',0),(54071,1502,'de','GL-Konten-Detail',0),(54072,1502,'en','GL Accounts Detail',0),(54073,1503,'is','',0),(54074,1503,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54075,1503,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54076,1503,'tr','GL SMM hesabÄ±',0),(54077,1503,'pl','Konto KWS GL',0),(54078,1503,'bg','GL ÐžÐ¡ÐŸ ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð°',0),(54079,1503,'ur','Ø¬ÛŒØ¬Û’ Ú©Ø§ÙˆÚ¯Ø³ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(54080,1503,'sr','Ð“Ð› Ð¢ÐŸÐ  Ñ€Ð°Ñ‡ÑƒÐ½',0),(54081,1503,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p giÃ¡ thÃ nh hÃ ng bÃ¡n',0),(54082,1503,'af','AG KVGV Rekening',0),(54083,1503,'ro','Cont CBV GL',0),(54084,1503,'et','GL OMAHINNA konto',0),(54085,1503,'si','Konto porabe GL',0),(54086,1503,'ba','GL roda Account',0),(54087,1503,'nl','GL KPV Account',0),(54088,1503,'fi','GL myytyjen tuotteiden kustannusten tili',0),(54089,1503,'no','GI hjul-konto',0),(54090,1503,'da','GL vareforbrugskontoen',0),(54091,1503,'ko','GL ë§¤ì¶œ ì›ê°€ ê³„ì •',0),(54092,1503,'he','×—×©×‘×•×Ÿ ×”×—×•×–×™× GL',0),(54093,1503,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î Î©Î›Î—Î˜ÎˆÎÎ¤Î©Î Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(54094,1503,'zh','æ€»å¸é”€å”®æˆæœ¬å¸\r\n',0),(54095,1503,'sv','GL KSV',0),(54096,1503,'it','GL ingranaggi conto',0),(54097,1503,'tl','',0),(54098,1503,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(54099,1503,'hi','à¤œà¥€à¤à¤² COGS à¤–à¤¾à¤¤à¥‡',0),(54100,1503,'ms','Akaun salah satu alat GL',0),(54101,1503,'ar','Ø­Ø³Ø§Ø¨ ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(54102,1503,'fr','GL CMV compte',0),(54103,1503,'jp','GLã€€COGSã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(54104,1503,'pt','Conta de COGS GL',0),(54105,1503,'ru','GL Ð²Ð¸Ð½Ñ‚Ð¸ÐºÐ¸ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(54106,1503,'es','Cuenta COGS de LM',0),(54107,1503,'de','COGS Sako',0),(54108,1503,'en','GL COGS Account',0),(54109,1504,'is','',0),(54110,1504,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø´Ø±ÙƒØª ',0),(54111,1504,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø´Ø±ÙƒØª ',0),(54112,1504,'tr','GL ÅŸirket seÃ§enekleri',0),(54113,1504,'pl','Firma GL opcje',0),(54114,1504,'bg','GL ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(54115,1504,'ur','Ø¬ÛŒØ¬Û’ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(54116,1504,'sr','Ð“Ð› ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(54117,1504,'vi','Lá»±a chá»n cty sá»• cÃ¡i',0),(54118,1504,'af','AG Ondernemingsopsies',0),(54119,1504,'ro','Compania GL opÅ£iuni',0),(54120,1504,'et','GL firma Valikud',0),(54121,1504,'si','GL podjetje moÅ¾nosti',0),(54122,1504,'ba','Pilihan perusahaan GL',0),(54123,1504,'nl','GL bedrijf opties',0),(54124,1504,'fi','GL yhtiÃ¶lle vaihtoehtoja',0),(54125,1504,'no','GL selskapet alternativer',0),(54126,1504,'da','GL selskab indstillinger',0),(54127,1504,'ko','GL íšŒì‚¬ ì˜µì…˜',0),(54128,1504,'he','××¤×©×¨×•×™×•×ª ×”×—×‘×¨×” GL',0),(54129,1504,'el','GL ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(54130,1504,'zh','å‰å°”å…¬å¸é€‰é¡¹\r\n',0),(54131,1504,'sv','GL fÃ¶retag alternativ',0),(54132,1504,'it','Azienda GL opzioni',0),(54133,1504,'tl','',0),(54134,1504,'th','&#3607;&#3634;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(54135,1504,'hi','à¤œà¥€à¤à¤² à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(54136,1504,'ms','Pilihan Syarikat GL',0),(54137,1504,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø´Ø±ÙƒØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(54138,1504,'fr','Options de GL Company',0),(54139,1504,'jp','GL ä¼šç¤¾ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(54140,1504,'pt','OpÃ§Ãµes de empresa GL',0),(54141,1504,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ GL-Ð¾Ð¿Ñ†Ð¸Ð¸',0),(54142,1504,'es','LM Opciones de la Empresa',0),(54143,1504,'de','GL-Firma-Optionen',0),(54144,1504,'en','GL Company Options',0),(54145,1505,'is','',0),(54146,1505,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ú†Ùƒ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(54147,1505,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ú†Ùƒ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(54148,1505,'tr','GL giriÅŸler iÃ§in bu denetimi bulunamadÄ±.',0),(54149,1505,'pl','GL wpisÃ³w dla tego wyboru nie znaleziono.',0),(54150,1505,'bg','GL Ð·Ð°Ð¿Ð¸ÑÐ¸Ñ‚Ðµ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(54151,1505,'ur','Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Û’ Ù„ÛŒÛ’ ÛŒÛ Ù¾Ú‘ØªØ§Ù„ Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(54152,1505,'sr','Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐµ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ñ‡ÐµÐº Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(54153,1505,'vi','BÃºt toÃ¡n sá»• cÃ¡i cho SÃ©c nÃ y khÃ´ng tÃ¬m tháº¥y',0),(54154,1505,'af','AG Inskrywings vir hierdie tjek nie gevind.',0),(54155,1505,'ro','GL intrÄƒrile pentru aceastÄƒ verificare nu a fost gÄƒsit.',0),(54156,1505,'et','GL kanded sellel kontrollimisel ei leitud.',0),(54157,1505,'si','GL vnose za ta pregled, ni mogoÄe najti.',0),(54158,1505,'ba','GL entri untuk cek ini tidak ditemukan.',0),(54159,1505,'nl','GL vermeldingen voor deze controle niet gevonden.',0),(54160,1505,'fi','GL merkinnÃ¤t tÃ¤mÃ¤n sekin ei lÃ¶ydy.',0),(54161,1505,'no','GL oppfÃ¸ringer for denne kontrollen ikke funnet.',0),(54162,1505,'da','GL poster for denne check blev ikke fundet.',0),(54163,1505,'ko','ì´ ëŒ€ í•œ GL í•­ëª© í™•ì¸ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(54164,1505,'he','GL ×¢×¨×›×™× ×¢×‘×•×¨ ×‘×“×™×§×” ×–×• ×œ× × ×ž×¦××”.',0),(54165,1505,'el','GL ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿, Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(54166,1505,'zh','æ­¤æ”¯ç¥¨æ€»å¸æ¡ç›®æ²¡æœ‰æ‰¾åˆ°ã€‚\r\n',0),(54167,1505,'sv','GL poster fÃ¶r denna kontroll hittades inte.',0),(54168,1505,'it','Voci di GL per questa verifica non trovato.',0),(54169,1505,'tl','',0),(54170,1505,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621; GL &#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3648;&#3594;&#3655;&#3588;&#3609;&#3637;&#3657;',0),(54171,1505,'hi','à¤œà¥€à¤à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤šà¥‡à¤• à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(54172,1505,'ms','GL penyertaan untuk semakan ini tidak dijumpai.',0),(54173,1505,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª GL Ù„Ù‡Ø°Ø§ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(54174,1505,'fr','EntrÃ©es GL pour cette vÃ©rification introuvable.',0),(54175,1505,'jp','ã?“ã?®å°?åˆ‡æ‰‹ã?®ï¼§ï¼¬ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?¯è¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(54176,1505,'pt','Entradas de GL para esta verificaÃ§Ã£o nÃ£o foi encontrado.',0),(54177,1505,'ru','GL Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.',0),(54178,1505,'es','LM entradas para este cheque no se encontrÃ³',0),(54179,1505,'de','GL EintrÃ¤ge fÃ¼r diese ÃœberprÃ¼fung nicht gefunden.',0),(54180,1505,'en','GL entries for this check not found.',0),(54181,1506,'is','',0),(54182,1506,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54183,1506,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54184,1506,'tr','GL gider hesabÄ±',0),(54185,1506,'pl','GL rozchodowych',0),(54186,1506,'bg','GL Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(54187,1506,'ur','Ø¬ÛŒØ¬Û’ Ø®Ø±Ú†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(54188,1506,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð“Ð›',0),(54189,1506,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Chi PhÃ­',0),(54190,1506,'af','AG Uitgawe Rekening',0),(54191,1506,'ro','Contul de cheltuieli GL',0),(54192,1506,'et','GL Kulukonto',0),(54193,1506,'si','Konto stroÅ¡kov GL',0),(54194,1506,'ba','Rekening pengeluaran GL',0),(54195,1506,'nl','GL kostenrekening',0),(54196,1506,'fi','GL kulutili',0),(54197,1506,'no','GL kostnadskonto',0),(54198,1506,'da','GL udgiftskonto',0),(54199,1506,'ko','GL ë¹„ìš© ê³„ì •',0),(54200,1506,'he','×—×©×‘×•×Ÿ ×”×”×•×¦××•×ª GL',0),(54201,1506,'el','Î”Î±Ï€Î¬Î½Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(54202,1506,'zh','æ€»å¸è´¹ç”¨å¸æˆ·\r\n',0),(54203,1506,'sv','GL utgiftskonto',0),(54204,1506,'it','Conto spese GL',0),(54205,1506,'tl','',0),(54206,1506,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(54207,1506,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤–à¤°à¥à¤š',0),(54208,1506,'ms','GL perbelanjaan akaun',0),(54209,1506,'ar','Ø­Ø³Ø§Ø¨ Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(54210,1506,'fr','Compte de dÃ©penses GL',0),(54211,1506,'jp','GLçµŒè²»å‹˜å®š',0),(54212,1506,'pt','Conta de despesas GL',0),(54213,1506,'ru','Ð¡Ñ‡ÐµÑ‚ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð² GL',0),(54214,1506,'es','LM Cuenta de Gastos',0),(54215,1506,'de','GL Aufwandskonto',0),(54216,1506,'en','GL Expense Account',0),(54217,1507,'is','',0),(54218,1507,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø³Ù‡Ù… Ø´Ø±ÙƒØª ',0),(54219,1507,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø³Ù‡Ù… Ø´Ø±ÙƒØª ',0),(54220,1507,'tr','GL gider hesabÄ± iÃ§in ÅŸirket bÃ¶lÃ¼mÃ¼',0),(54221,1507,'pl','Konto koszt GL dla firmy czÄ™Å›Ä‡',0),(54222,1507,'bg','GL Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ñ‡Ð°ÑÑ‚',0),(54223,1507,'ur','Ø¬ÛŒØ¬Û’ Ø®Ø±Ú†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ù…Ù¾Ù†ÛŒ Ø­ØµÛ Ú©Û’ Ù„ÛŒÛ’',0),(54224,1507,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð“Ð› Ð·Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ Ð¿Ð¾Ñ€Ñ†Ð¸Ñ˜Ñƒ',0),(54225,1507,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Chi PhÃ­ cho Cty',0),(54226,1507,'af','AG Uitgawe Rekening vir onderneminggedeelte',0),(54227,1507,'ro','GL cont cheltuialÄƒ pentru compania parte',0),(54228,1507,'et','GL kulukonto ettevÃµtte osa',0),(54229,1507,'si','GL Konto stroÅ¡kov za podjetje del',0),(54230,1507,'ba','GL rekening pengeluaran untuk bagian perusahaan',0),(54231,1507,'nl','GL kostenrekening voor bedrijf gedeelte',0),(54232,1507,'fi','GL kulutili yrityksen osa',0),(54233,1507,'no','GL kostnadskonto for selskapet del',0),(54234,1507,'da','GL udgiftskonto for firma del',0),(54235,1507,'ko','íšŒì‚¬ ë¶€ë¶„ì— ëŒ€ í•œ GL ë¹„ìš© ê³„ì •',0),(54236,1507,'he','GL ×—×©×‘×•×Ÿ ×”×”×•×¦××•×ª ×¢×‘×•×¨ ×—×œ×§ ×”×—×‘×¨×”',0),(54237,1507,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÎµÎ¾ÏŒÎ´Ï‰Î½ Î³/Î» Î³Î¹Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î¼Î­ÏÎ¿Ï‚',0),(54238,1507,'zh','æ€»å¸è´¹ç”¨å¸æˆ·çš„å…¬å¸çš„ä¸€éƒ¨åˆ†\r\n',0),(54239,1507,'sv','GL utgiftskonto fÃ¶r fÃ¶retagets del',0),(54240,1507,'it','Conto spese GL per la parte di azienda',0),(54241,1507,'tl','',0),(54242,1507,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3',0),(54243,1507,'hi','à¤œà¥€à¤à¤² à¤µà¥à¤¯à¤¯ à¤–à¤¾à¤¤à¥‡ à¤•à¤‚à¤ªà¤¨à¥€ à¤­à¤¾à¤— à¤•à¥‡ à¤²à¤¿à¤',0),(54244,1507,'ms','GL akaun perbelanjaan bagi sebahagian Syarikat',0),(54245,1507,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ GL Ù„Ù„Ø´Ø±ÙƒØ© Ø¬Ø²Ø¡',0),(54246,1507,'fr','Compte de dÃ©penses de GL pour partie de l\'entreprise',0),(54247,1507,'jp','ä¼šç¤¾åˆ†ã?®ï¼§ï¼¬çµŒè²»å‹˜å®š',0),(54248,1507,'pt','GL conta de despesas por parte da empresa',0),(54249,1507,'ru','GL ÑÑ‡ÐµÑ‚ Ð´Ð»Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ñ‡Ð°ÑÑ‚ÑŒ',0),(54250,1507,'es','LM Cuenta de Gastos para porciÃ³n de la Empresa',0),(54251,1507,'de','GL Aufwandskonto fÃ¼r Unternehmen Teil',0),(54252,1507,'en','GL Expense Account for company portion',0),(54253,1508,'is','',0),(54254,1508,'dr','Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54255,1508,'pr','Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54256,1508,'tr','GL stok hesabÄ±',0),(54257,1508,'pl','Konto zapasÃ³w GL',0),(54258,1508,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð·Ð°Ð¿Ð°ÑÐ¸ Ð½Ð° GL',0),(54259,1508,'ur','Ø¬ÛŒØ¬Û’ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(54260,1508,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð“Ð›',0),(54261,1508,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p HÃ ng HÃ³a',0),(54262,1508,'af','AG Voorraadrekening',0),(54263,1508,'ro','Contul de stocuri GL',0),(54264,1508,'et','GL varude konto',0),(54265,1508,'si','Konto zaloge GL',0),(54266,1508,'ba','GL persediaan Account',0),(54267,1508,'nl','GL voorraadrekening',0),(54268,1508,'fi','GL varastotilin',0),(54269,1508,'no','GL lagerkontoen',0),(54270,1508,'da','GL lagerkontoen',0),(54271,1508,'ko','GL ìž¬ê³  ê³„ì •',0),(54272,1508,'he','×—×©×‘×•×Ÿ ×ž×œ××™ GL',0),(54273,1508,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(54274,1508,'zh','æ€»å¸ç›˜å­˜è´¦æˆ·\r\n',0),(54275,1508,'sv','GL lagerkontot',0),(54276,1508,'it','GL inventario conto',0),(54277,1508,'tl','',0),(54278,1508,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(54279,1508,'hi','à¤œà¥€à¤à¤² à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤–à¤¾à¤¤à¥‡',0),(54280,1508,'ms','Akaun inventori GL',0),(54281,1508,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(54282,1508,'fr','Compte de stock GL',0),(54283,1508,'jp','GLæ£šå?¸è³‡ç”£ä¼šè¨ˆ',0),(54284,1508,'pt','Conta de estoque GL',0),(54285,1508,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ GL',0),(54286,1508,'es','LM Cuenta de Inventario',0),(54287,1508,'de','GL Lagerkonto',0),(54288,1508,'en','GL Inventory Account',0),(54289,1509,'is','',0),(54290,1509,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(54291,1509,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(54292,1509,'tr','GL gÃ¼nlÃ¼ÄŸÃ¼ ekleme',0),(54293,1509,'pl','GL dziennika dodaÄ‡',0),(54294,1509,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð½ÐµÐ²Ð½Ð¸Ðº Ð¸Ð»Ð¸ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(54295,1509,'ur','Ø¬ÛŒØ¬Û’ Ø¬Ø±Ù†Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(54296,1509,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð“Ð›',0),(54297,1509,'vi','ThÃªm bÃºt toÃ¡n sá»• cÃ¡i',0),(54298,1509,'af','AG Joernaal Skep',0),(54299,1509,'ro','Adauga GL jurnal',0),(54300,1509,'et','GL tÃ¶Ã¶lehe lisamine',0),(54301,1509,'si','GL Journal dodate',0),(54302,1509,'ba','Tambahkan GL jurnal',0),(54303,1509,'nl','GL Journal toevoegen',0),(54304,1509,'fi','KP-pÃ¤ivÃ¤kirjassa lisÃ¤Ã¤',0),(54305,1509,'no','GL Journal legge',0),(54306,1509,'da','GL Journal tilfÃ¸je',0),(54307,1509,'ko','GL ì €ë„ ì¶”ê°€',0),(54308,1509,'he','×”×•×¡×£ ×™×•×ž×Ÿ GL',0),(54309,1509,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î³ / Î»',0),(54310,1509,'zh','å‰å°”æ‚å¿—æ–°å¢ž\r\n',0),(54311,1509,'sv','GL tidning lÃ¤gga till',0),(54312,1509,'it','Aggiungi GL Gazzetta',0),(54313,1509,'tl','',0),(54314,1509,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3617;&#3640;&#3604;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(54315,1509,'hi','GL à¤œà¤°à¥à¤¨à¤² à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(54316,1509,'ms','Jurnal GL Tambah',0),(54317,1509,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚ÙŠØ¯ ÙŠÙˆÙ…ÙŠØ©',0),(54318,1509,'fr','Ajouter Journal GL',0),(54319,1509,'jp','GLä»•è¨³å¸³è¿½åŠ ',0),(54320,1509,'pt','Adicionar diÃ¡rio GL',0),(54321,1509,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¶ÑƒÑ€Ð½Ð°Ð» GL',0),(54322,1509,'es','LM Diario Agregar',0),(54323,1509,'de','GL-Journal hinzufÃ¼gen',0),(54324,1509,'en','GL Journal Add',0),(54325,1510,'is','',0),(54326,1510,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54327,1510,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54328,1510,'tr','GL gÃ¼nlÃ¼k gÃ¼ncelleme',0),(54329,1510,'pl','GL aktualizacji arkusza',0),(54330,1510,'bg','GL Ð²ÐµÑÑ‚Ð½Ð¸Ðº Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(54331,1510,'ur','Ø¬ÛŒØ¬Û’ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(54332,1510,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð“Ð›',0),(54333,1510,'vi','Cáº­p nháº­t BÃºt ToÃ¡n Sá»• CÃ¡i Tá»•ng Há»£p',0),(54334,1510,'af','AG Joernaal Opdateer',0),(54335,1510,'ro','Actualizare de jurnal GL',0),(54336,1510,'et','GL uuendamise',0),(54337,1510,'si','GL Journal posodobitev',0),(54338,1510,'ba','GL jurnal pembaruan',0),(54339,1510,'nl','GL Journal Update',0),(54340,1510,'fi','GL kirjauskansion pÃ¤ivityksen',0),(54341,1510,'no','GL journaloppdateringen',0),(54342,1510,'da','GL kladdeopdateringen',0),(54343,1510,'ko','GL ì €ë„ ì—…ë°ì´íŠ¸',0),(54344,1510,'he','×¢×“×›×•×Ÿ ×”×™×•×ž×Ÿ GL',0),(54345,1510,'el','GL ÎµÏ†Î·Î¼ÎµÏÎ¯Î´Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(54346,1510,'zh','å‰å°”æ‚å¿—æ›´æ–°\r\n',0),(54347,1510,'sv','GL journaluppdateringen',0),(54348,1510,'it','Aggiornamento Journal GL',0),(54349,1510,'tl','',0),(54350,1510,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3617;&#3640;&#3604;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(54351,1510,'hi','à¤œà¥€à¤à¤² à¤ªà¤¤à¥à¤°à¤¿à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(54352,1510,'ms','Kemaskini jurnal GL',0),(54353,1510,'ar','ØªØ­Ø¯ÙŠØ« Ù‚ÙŠØ¯ ÙŠÙˆÙ…ÙŠØ©',0),(54354,1510,'fr','Mise Ã  jour du Journal de GL',0),(54355,1510,'jp','GLä»•è¨³å¸³æ›´æ–°',0),(54356,1510,'pt','AtualizaÃ§Ã£o do diÃ¡rio GL',0),(54357,1510,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¶ÑƒÑ€Ð½Ð°Ð»Ð° GL',0),(54358,1510,'es','LM Diario Actualizar',0),(54359,1510,'de','GL-Journal-Update',0),(54360,1510,'en','GL Journal Update',0),(54361,1511,'is','',0),(54362,1511,'dr','Ù…Ù†ÙˆÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54363,1511,'pr','Ù…Ù†ÙˆÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54364,1511,'tr','Genel muhasebe menÃ¼sÃ¼',0),(54365,1511,'pl','General Ledger Menu',0),(54366,1511,'bg','ÐžÐ±Ñ‰Ð¾ ÐºÐ½Ð¸Ð³Ð° Ð·Ð° Ð¼ÐµÐ½ÑŽ',0),(54367,1511,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ù…ÛŒÙ†ÛŒÙˆ',0),(54368,1511,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ Ð¼ÐµÐ½Ð¸Ñ˜Ð°',0),(54369,1511,'vi','TrÃ¬nh Ä‘Æ¡n sá»• cÃ¡i',0),(54370,1511,'af','Algemene Grootboek Menu',0),(54371,1511,'ro','General Ledger meniu',0),(54372,1511,'et','Pearaamatu menÃ¼Ã¼',0),(54373,1511,'si','General Ledger meni',0),(54374,1511,'ba','General Ledger Menu',0),(54375,1511,'nl','Menu grootboekposten',0),(54376,1511,'fi','General Ledger-valikossa',0),(54377,1511,'no','General Ledger menyen',0),(54378,1511,'da','General Ledger Menu',0),(54379,1511,'ko','ì¼ë°˜ ë ˆì € ë©”ë‰´',0),(54380,1511,'he','×ª×¤×¨×™×˜ ×¨××©×™ ×›×œ×œ×™',0),(54381,1511,'el','Î“ÎµÎ½Î¹ÎºÎ¿Ï ÎºÎ±Î¸Î¿Î»Î¹ÎºÎ¿Ï Î¼ÎµÎ½Î¿Ï',0),(54382,1511,'zh','æ€»å¸èœå•\r\n',0),(54383,1511,'sv','General Ledger menyn',0),(54384,1511,'it','Menu contabilitÃ  generale',0),(54385,1511,'tl','',0),(54386,1511,'th','&#3648;&#3617;&#3609;&#3641;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(54387,1511,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤®à¥‡à¤¨à¥‚',0),(54388,1511,'ms','Menu Lejar Am',0),(54389,1511,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(54390,1511,'fr','Menu comptabilitÃ©',0),(54391,1511,'jp','ç·?å‹˜å®šå…ƒå¸³ãƒ¡ãƒ‹ãƒ¥ãƒ¼',0),(54392,1511,'pt','General Ledger Menu',0),(54393,1511,'ru','Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð“Ðš Ð¼ÐµÐ½ÑŽ',0),(54394,1511,'es','MenÃº de Libro Mayor',0),(54395,1511,'de','Im MenÃ¼ Finanzbuchhaltung',0),(54396,1511,'en','General Ledger Menu',0),(54397,1512,'is','',0),(54398,1512,'dr','Ø­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(54399,1512,'pr','Ø­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(54400,1512,'tr','GL borÃ§ hesabÄ±',0),(54401,1512,'pl','GL pÅ‚atne konta',0),(54402,1512,'bg','GL Ð¿Ð»Ð°Ñ‚Ð¸Ð¼Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(54403,1512,'ur','Ø¬ÛŒØ¬Û’ Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(54404,1512,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð“Ð›',0),(54405,1512,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Pháº£i Tráº£',0),(54406,1512,'af','AG Betaalbaar Rekening',0),(54407,1512,'ro','Cont plÄƒtit GL',0),(54408,1512,'et','GL maksta konto',0),(54409,1512,'si','GL plaÄa raÄun',0),(54410,1512,'ba','GL dibayarkan Account',0),(54411,1512,'nl','GL betalend Account',0),(54412,1512,'fi','GL ostovelkojen tilin',0),(54413,1512,'no','GL betales konto',0),(54414,1512,'da','GL skal betales konto',0),(54415,1512,'ko','GL ì§€ë¶ˆ ê³„ì •',0),(54416,1512,'he','×—×©×‘×•× ×•×ª ×–×›××™× GL',0),(54417,1512,'el','GL Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(54418,1512,'zh','æ€»å¸åº”ä»˜å¸æˆ·\r\n',0),(54419,1512,'sv','GL LeverantÃ¶rsskulder',0),(54420,1512,'it','Conto fornitori GL',0),(54421,1512,'tl','',0),(54422,1512,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(54423,1512,'hi','GL à¤¦à¥‡à¤¯ à¤–à¤¾à¤¤à¤¾',0),(54424,1512,'ms','Akaun dibayar GL',0),(54425,1512,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¯Ø§Ø¦Ù†ÙŠÙ† ÙÙŠ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(54426,1512,'fr','Compte fournisseur GL',0),(54427,1512,'jp','GLè²·æŽ›é‡‘',0),(54428,1512,'pt','Pagar conta GL',0),(54429,1512,'ru','GL ÑÑ‡ÐµÑ‚',0),(54430,1512,'es','LM Cuenta de Cuentas por Pagar',0),(54431,1512,'de','GL-Kreditoren-Konto',0),(54432,1512,'en','GL Payable Account',0),(54433,1513,'is','',0),(54434,1513,'dr','Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(54435,1513,'pr','Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(54436,1513,'tr','GL pasta baÅŸarÄ±yla silindi',0),(54437,1513,'pl','GL Pie przesâ”‚anie',0),(54438,1513,'bg','GL Ð¿Ð°Ð¹ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(54439,1513,'ur','Ø¬ÛŒØ¬Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù¾Ø§Ø¦ÛŒ',0),(54440,1513,'sr','Ð“Ð› Ð¿Ð¸Ñ‚Ñƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(54441,1513,'vi','XÃ³a á»‘ng sá»• cÃ¡i thÃ nh cÃ´ng',0),(54442,1513,'af','AG Sirkeldiagram suksesvol geskrap',0),(54443,1513,'ro','GL Pie eliminÄƒ cu succes',0),(54444,1513,'et','GL pirukas edukalt kustutatud',0),(54445,1513,'si','GL Pie uspeÅ¡no izbrisana',0),(54446,1513,'ba','GL Pie dihapus berhasil',0),(54447,1513,'nl','GL Pie met succes verwijderd',0),(54448,1513,'fi','GL Pie poistettu',0),(54449,1513,'no','GL Pie slettet',0),(54450,1513,'da','GL Pie slettet',0),(54451,1513,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” GL íŒŒì´',0),(54452,1513,'he','×¤××™ GL × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(54453,1513,'el','GL Ï€Î¯Ï„Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(54454,1513,'zh','å‰å°”æ´¾åˆ é™¤æˆåŠŸ\r\n',0),(54455,1513,'sv','GL paj raderades',0),(54456,1513,'it','Torta GL eliminato con successo',0),(54457,1513,'tl','',0),(54458,1513,'th','&#3621;&#3610; GL Pie &#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(54459,1513,'hi','à¤œà¥€à¤à¤² à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤ˆ à¤ªà¤¾à¤ˆ',0),(54460,1513,'ms','Pai GL dihapuskan dengan jayanya',0),(54461,1513,'ar','ÙØ·ÙŠØ±Ø© GL Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(54462,1513,'fr','Tarte GL supprimÃ© avec succÃ¨s',0),(54463,1513,'jp','GLãƒ‘ã‚¤ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(54464,1513,'pt','Torta de GL apagado com sucesso',0),(54465,1513,'ru','GL Ð¿Ð¸Ñ€Ð¾Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(54466,1513,'es','LM GrÃ¡fica Pie eliminada exitosamente',0),(54467,1513,'de','GL Pie erfolgreich gelÃ¶scht',0),(54468,1513,'en','GL Pie  deleted successfully',0),(54469,1514,'is','',0),(54470,1514,'dr','Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(54471,1514,'pr','Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(54472,1514,'tr','GL pasta dilimi baÅŸarÄ±yla silindi',0),(54473,1514,'pl','GL wycinek przesâ”‚anie',0),(54474,1514,'bg','GL ÐºÑ€ÑŠÐ³Ð¾Ð² Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(54475,1514,'ur','Ø¬ÛŒØ¬Û’ Ù¾Ø§Ø¦ÛŒ Ù‚Ø§Ø´ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(54476,1514,'sr','Ð“Ð› Ð¿Ð¸Ñ‚Ñƒ Ð¡Ð»Ð¸Ñ†Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(54477,1514,'vi','XÃ³a lÃ¡t cáº¯t á»‘ng sá»• cÃ¡i thÃ nh cÃ´ng',0),(54478,1514,'af','AG Sirkeldiagram Skyf suksesvol geskrap',0),(54479,1514,'ro','Felie de plÄƒcintÄƒ GL eliminÄƒ cu succes',0),(54480,1514,'et','GL pirukas viil edukalt kustutatud',0),(54481,1514,'si','GL rezina tortnega grafikona uspeÅ¡no izbrisana',0),(54482,1514,'ba','GL Pie Slice dihapus berhasil',0),(54483,1514,'nl','GL cirkelsegment succesvol verwijderd',0),(54484,1514,'fi','GL ympyrÃ¤kaavion sektori poistettu',0),(54485,1514,'no','GL sektor slettet',0),(54486,1514,'da','GL cirkeludsnit slettet',0),(54487,1514,'ko','GL ì›í˜• ì¡°ê°ì„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(54488,1514,'he','×¤×¨×•×¡×ª ×¢×•×’×” GL × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(54489,1514,'el','GL Ï†Î­Ï„Î±Ï‚ Ï€Î¯Ï„Î±Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(54490,1514,'zh','æ€»å¸é¥¼å›¾å—åˆ é™¤æˆåŠŸ\r\n',0),(54491,1514,'sv','GL cirkelsektor raderades',0),(54492,1514,'it','Fetta di torta GL eliminato con successo',0),(54493,1514,'tl','',0),(54494,1514,'th','&#3621;&#3610; GL Pie Slice &#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(54495,1514,'hi','à¤œà¥€à¤à¤² à¤ªà¤¾à¤‡ à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(54496,1514,'ms','Hirisan pai GL dihapuskan dengan jayanya',0),(54497,1514,'ar','Ø´Ø±ÙŠØ­Ø© Ù…Ø®Ø·Ø· Ø¯Ø§Ø¦Ø±ÙŠ GL Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(54498,1514,'fr','Tranche de tarte aux GL supprimÃ© avec succÃ¨s',0),(54499,1514,'jp','GLãƒ‘ã‚¤ã‚¹ãƒ©ã‚¤ã‚¹ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(54500,1514,'pt','Fatia de torta de GL apagado com sucesso',0),(54501,1514,'ru','GL ÑÐµÐºÑ‚Ð¾Ñ€Ð° ÐºÑ€ÑƒÐ³Ð¾Ð²Ð¾Ð¹ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¼Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(54502,1514,'es','LM Rebanada de GrÃ¡fica Pie eliminado exitosamente',0),(54503,1514,'de','GL Kreissegment erfolgreich gelÃ¶scht',0),(54504,1514,'en','GL Pie Slice deleted successfully',0),(54505,1515,'is','',0),(54506,1515,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(54507,1515,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(54508,1515,'tr','GL pasta dilimi ayrÄ±ntÄ± baÅŸarÄ±yla silindi',0),(54509,1515,'pl','SzczegÃ³Å‚owo kawaÅ‚ek Pie GL przesâ”‚anie',0),(54510,1515,'bg','GL ÐºÑ€ÑŠÐ³Ð¾Ð²Ð° Ð¿Ð°Ñ€Ñ‡Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(54511,1515,'ur','Ø¬ÛŒØ¬Û’ Ù¾Ø§Ø¦ÛŒ Ù‚Ø§Ø´ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ ØªÙØµÛŒÙ„',0),(54512,1515,'sr','Ð“Ð› Ð¿Ð¸Ñ‚Ñƒ Ð¡Ð»Ð¸Ñ†Ðµ Ð´ÐµÑ‚Ð°Ñ™ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(54513,1515,'vi','XÃ³a chi tiáº¿t lÃ¡t cáº¯t á»‘ng sá»• cÃ¡i thÃ nh cÃ´ng',0),(54514,1515,'af','AG Sirkeldiagram \"Skyf Detail suksesvol geskrap',0),(54515,1515,'ro','GL Pie felie detaliu eliminÄƒ cu succes',0),(54516,1515,'et','GL pirukas viil Detail edukalt kustutatud',0),(54517,1515,'si','GL pito rezine podrobno uspeÅ¡no izbrisana',0),(54518,1515,'ba','GL Pie Slice Detail dihapus berhasil',0),(54519,1515,'nl','GL Pie segment Detail met succes verwijderd',0),(54520,1515,'fi','GL kakku siivu yksityiskohtaisesti poistettu',0),(54521,1515,'no','GL Pie skive detalj slettet',0),(54522,1515,'da','GL Pie skive detaljer slettet',0),(54523,1515,'ko','GL íŒŒì´ ì¡°ê° ì„¸ë¶€ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(54524,1515,'he','GL-×¤××™-×¤×¨×•×¡×”-×¤×™×¨×•×˜ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(54525,1515,'el','GL Ï€Î¯Ï„Î± Ï†Î­Ï„Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(54526,1515,'zh','æ€»å¸é¥¼å›¾å—æ˜Žç»†åˆ é™¤æˆåŠŸ\r\n',0),(54527,1515,'sv','GL paj Slice detalj raderades',0),(54528,1515,'it','Dettaglio fetta di torta GL eliminato con successo',0),(54529,1515,'tl','',0),(54530,1515,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604; GL Pie Slice &#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(54531,1515,'hi','à¤œà¥€à¤à¤² à¤ªà¤¾à¤‡ à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(54532,1515,'ms','GL pai Slice terperinci dihapuskan dengan jayanya',0),(54533,1515,'ar','ÙØ·ÙŠØ±Ø© GL Ø´Ø±ÙŠØ­Ø© Ø§Ù„ØªÙØµÙŠÙ„ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(54534,1515,'fr','DÃ©tail de tranche de tarte GL supprimÃ© avec succÃ¨s',0),(54535,1515,'jp','GLãƒ‘ã‚¤ã‚¹ãƒ©ã‚¤ã‚¹è©³ç´°ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(54536,1515,'pt','Detalhe de fatia de torta GL apagado com sucesso',0),(54537,1515,'ru','GL ÐºÑ€ÑƒÐ³Ð¾Ð²Ð¾Ð¹ ÑÑ€ÐµÐ· Ð´ÐµÑ‚Ð°Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(54538,1515,'es','LM detalle de Rebanada de GrÃ¡fica Pie eliminado exitosamente',0),(54539,1515,'de','GL Pie Slice Detail erfolgreich gelÃ¶scht',0),(54540,1515,'en','GL Pie Slice Detail deleted successfully',0),(54541,1516,'is','',0),(54542,1516,'dr','Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(54543,1516,'pr','Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(54544,1516,'tr','GL pasta baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(54545,1516,'pl','GL Pie pomyÅ›lnie zaktualizowana',0),(54546,1516,'bg','GL Ð¿Ð°Ð¹ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(54547,1516,'ur','Ø¬ÛŒØ¬Û’ Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(54548,1516,'sr','Ð“Ð› Ð¿Ð¸Ñ‚Ñƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(54549,1516,'vi','Cáº­p nháº­t Biá»ƒu Ä‘á»“ dáº¡ng trÃ²n cá»§a Sá»• CÃ¡i Tá»•ng Há»£p thÃ nh cÃ´ng',0),(54550,1516,'af','AG Sirkeldiagram suksesvol opdateer',0),(54551,1516,'ro','GL Pie actualizat cu succes',0),(54552,1516,'et','GL pirukas vÃ¤rskendatud',0),(54553,1516,'si','GL Pie uspeÅ¡no posodobljena',0),(54554,1516,'ba','GL Pie berhasil',0),(54555,1516,'nl','GL Pie bijgewerkt',0),(54556,1516,'fi','GL Pie pÃ¤ivitetty',0),(54557,1516,'no','GL Pie oppdatert',0),(54558,1516,'da','GL Pie opdateret',0),(54559,1516,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ GL íŒŒì´',0),(54560,1516,'he','×¤××™ GL ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(54561,1516,'el','GL Ï€Î¯Ï„Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(54562,1516,'zh','æ€»å¸é¥¼å›¾æˆåŠŸæ›´æ–°\r\n',0),(54563,1516,'sv','GL paj uppdaterats',0),(54564,1516,'it','Torta GL aggiornato con successo',0),(54565,1516,'tl','',0),(54566,1516,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; GL Pie &#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(54567,1516,'hi','à¤œà¥€à¤à¤² à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¤¾à¤ˆ',0),(54568,1516,'ms','Pai GL yang berjaya dikemas kini',0),(54569,1516,'ar','ÙØ·ÙŠØ±Ø© GL ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(54570,1516,'fr','GL Pie mis Ã  jour avec succÃ¨s',0),(54571,1516,'jp','GLãƒ‘ã‚¤ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(54572,1516,'pt','Torta de GL atualizado com sucesso',0),(54573,1516,'ru','GL Ð¿Ð¸Ñ€Ð¾Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(54574,1516,'es','LM Rebanada de GrÃ¡fica Pie eliminado exitosamente',0),(54575,1516,'de','GL-Pie, die erfolgreich aktualisiert',0),(54576,1516,'en','GL Pie updated successfully',0),(54577,1517,'is','',0),(54578,1517,'dr','Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ø¯ÙØªØ± ÙƒÙ„ ',0),(54579,1517,'pr','Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ø¯ÙØªØ± ÙƒÙ„ ',0),(54580,1517,'tr','GL mesaj',0),(54581,1517,'pl','GL Post',0),(54582,1517,'bg','GL Ð¿Ð¾ÑÑ‚',0),(54583,1517,'ur','Ø¬ÛŒØ¬Û’ Ù¾ÙˆØ³Ù¹',0),(54584,1517,'sr','Ð“Ð› ÐŸÐ¾ÑÑ‚',0),(54585,1517,'vi','Káº¿t chuyá»ƒn sá»• cÃ¡i',0),(54586,1517,'af','AG Pos',0),(54587,1517,'ro','GL Post',0),(54588,1517,'et','GL Post',0),(54589,1517,'si','GL objava',0),(54590,1517,'ba','GL posting',0),(54591,1517,'nl','GL Post',0),(54592,1517,'fi','GL Post',0),(54593,1517,'no','GL innlegg',0),(54594,1517,'da','GL indlÃ¦g',0),(54595,1517,'ko','GL ê²Œì‹œë¬¼',0),(54596,1517,'he','×¤×•×¡×˜ GL',0),(54597,1517,'el','GL Î¸Î­ÏƒÎ·',0),(54598,1517,'zh','åŒ–éªŒåŽ\r\n',0),(54599,1517,'sv','GL inlÃ¤gg',0),(54600,1517,'it','GL Post',0),(54601,1517,'tl','',0),(54602,1517,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(54603,1517,'hi','GL à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(54604,1517,'ms','GL Post',0),(54605,1517,'ar','ÙˆØ¸ÙŠÙØ© GL',0),(54606,1517,'fr','Poste GL',0),(54607,1517,'jp','GLè¨˜å¸³',0),(54608,1517,'pt','Post GL',0),(54609,1517,'ru','GL Ð¿Ð¾ÑÑ‚',0),(54610,1517,'es','LM Asentar',0),(54611,1517,'de','GL-Post',0),(54612,1517,'en','GL Post',0),(54613,1518,'is','',0),(54614,1518,'dr','Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ù…Ø¹ÙƒÙˆØ³ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54615,1518,'pr','Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ù…Ø¹ÙƒÙˆØ³ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54616,1518,'tr','GL ters yazÄ±',0),(54617,1518,'pl','OdwrÃ³Ä‡ Post GL',0),(54618,1518,'bg','GL Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð°Ñ‚Ð° Ð¿Ð¾ÑÑ‚',0),(54619,1518,'ur','Ø¬ÛŒØ¬Û’ Ø±ÛŒÙˆØ±Ø³ Ù¾ÙˆØ³Ù¹',0),(54620,1518,'sr','ÐžÐ±Ñ€Ð½ÑƒÑ‚Ð¸ ÐŸÐ¾ÑÑ‚ Ð“Ð›',0),(54621,1518,'vi','Káº¿t chuyá»ƒn viáº¿t ngÆ°á»£c sá»• cÃ¡i',0),(54622,1518,'af','AG Terugskryfde Pos',0),(54623,1518,'ro','GL inversÄƒ Post',0),(54624,1518,'et','GL pÃ¶Ã¶rdtehingud Post',0),(54625,1518,'si','GL povratne Post',0),(54626,1518,'ba','GL Reverse posting',0),(54627,1518,'nl','GL omgekeerde Post',0),(54628,1518,'fi','GL kÃ¤Ã¤nteinen Post',0),(54629,1518,'no','GL omvendt innlegg',0),(54630,1518,'da','GL omvendt indlÃ¦g',0),(54631,1518,'ko','GL ì—­ë°©í–¥ ê²Œì‹œë¬¼',0),(54632,1518,'he','×¤×•×¡×˜ ×”×¤×•×›×” GL',0),(54633,1518,'el','Î‘Î½Ï„Î¯ÏƒÏ„ÏÎ¿Ï†Î· Î¸Î­ÏƒÎ· GL',0),(54634,1518,'zh','åŒ–éªŒåŽåå‘\r\n',0),(54635,1518,'sv','GL omvÃ¤nd inlÃ¤gg',0),(54636,1518,'it','Post inverso GL',0),(54637,1518,'tl','',0),(54638,1518,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3605;&#3619;&#3591;&#3585;&#3633;&#3609;&#3586;&#3657;&#3634;&#3617;&#3607;&#3633;&#3',0),(54639,1518,'hi','à¤œà¥€à¤à¤² à¤°à¤¿à¤µà¤°à¥à¤¸ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(54640,1518,'ms','Post belakang GL',0),(54641,1518,'ar','ÙˆØ¸ÙŠÙØ© Ø¹ÙƒØ³ GL',0),(54642,1518,'fr','GL poste inversÃ©',0),(54643,1518,'jp','GLè¨ˆä¸Šå?–æ¶ˆã?—',0),(54644,1518,'pt','Post reversa GL',0),(54645,1518,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ñ‹Ð¹ Ð¿Ð¾ÑÑ‚ GL',0),(54646,1518,'es','LM Reversar Asiento',0),(54647,1518,'de','GL Reverse Post',0),(54648,1518,'en','GL Reverse Post',0),(54649,1519,'is','',0),(54650,1519,'dr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54651,1519,'pr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54652,1519,'tr','GL satÄ±ÅŸ hesabÄ±',0),(54653,1519,'pl','SprzedaÅ¼ konta GL',0),(54654,1519,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(54655,1519,'ur','Ø¬ÛŒØ¬Û’ Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(54656,1519,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð“Ð›',0),(54657,1519,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Doanh Thu HÃ ng BÃ¡n',0),(54658,1519,'af','AG Verkope Rekening',0),(54659,1519,'ro','GL vÃ¢nzÄƒri cont',0),(54660,1519,'et','GL MÃ¼Ã¼gikonto',0),(54661,1519,'si','Prodajni raÄun GL',0),(54662,1519,'ba','GL penjualan Account',0),(54663,1519,'nl','GL omzetrekening',0),(54664,1519,'fi','GL myynnin tili',0),(54665,1519,'no','GL salgskontoen',0),(54666,1519,'da','GL salg konto',0),(54667,1519,'ko','GL íŒë§¤ ê³„ì •',0),(54668,1519,'he','×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª GL',0),(54669,1519,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(54670,1519,'zh','æ€»å¸é”€å”®å¸æˆ·\r\n',0),(54671,1519,'sv','GL fÃ¶rsÃ¤ljningskontot',0),(54672,1519,'it','Sales Account GL',0),(54673,1519,'tl','',0),(54674,1519,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(54675,1519,'hi','à¤œà¥€à¤à¤² à¤µà¤¿à¤•à¥à¤°à¤¯ à¤–à¤¾à¤¤à¤¾',0),(54676,1519,'ms','Akaun jualan GL',0),(54677,1519,'ar','Ø­Ø³Ù€Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ù€Ø§Øª',0),(54678,1519,'fr','Compte de vente GL',0),(54679,1519,'jp','GLå£²ä¸Šå‹˜å®šã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(54680,1519,'pt','Conta de vendas de GL',0),(54681,1519,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ GL',0),(54682,1519,'es','LM Cuenta de Ventas',0),(54683,1519,'de','GL-Kundenkonto',0),(54684,1519,'en','GL Sales Account',0),(54685,1520,'is','',0),(54686,1520,'dr','Ø®Ù„Ø§ØµÙ‡ Ø³Ø§Ø²ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54687,1520,'pr','Ø®Ù„Ø§ØµÙ‡ Ø³Ø§Ø²ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(54688,1520,'tr','Genel muhasebe Ã¶zetleme',0),(54689,1520,'pl','KsiÄ™ga podsumowujÄ…ce',0),(54690,1520,'bg','Ð¡Ñ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ Ð¾Ð±Ð¾Ð±Ñ‰Ð°Ð²Ð°Ð½Ðµ',0),(54691,1520,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ú©Ø§ Ø®Ù„Ø§ØµÛ Ú©Ø± Ø±ÛØ§',0),(54692,1520,'sr','Ð“Ð»Ð°Ð²Ð½Ð° ÐºÑšÐ¸Ð³Ð° ÑÐ° Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ¾Ð¼',0),(54693,1520,'vi','Tá»•ng quÃ¡t sá»• cÃ¡i',0),(54694,1520,'af','Algemene Grootboek Opsomming',0),(54695,1520,'ro','Contabilitate rezumÄƒ',0),(54696,1520,'et','Linke Pearaamat ja kokkuvÃµtte tegemine',0),(54697,1520,'si','Glavna knjiga povzema',0),(54698,1520,'ba','General Ledger meringkas',0),(54699,1520,'nl','Grootboek samenvatten',0),(54700,1520,'fi','General Ledger Yhteenveto',0),(54701,1520,'no','General Ledger oppsummering',0),(54702,1520,'da','General Ledger sammenfatter',0),(54703,1520,'ko','ì´ê³„ì • ì›ìž¥ ìš”ì•½',0),(54704,1520,'he','×”×¡×¤×¨ ×”×¨××©×™ ×¡×™×›×•×',0),(54705,1520,'el','Î“ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® ÏƒÏ…Î½Î¿ÏˆÎ¯Î¶ÎµÎ¹',0),(54706,1520,'zh','æ€»å¸æ€»ç»“\r\n',0),(54707,1520,'sv','Redovisningen summerar',0),(54708,1520,'it','ContabilitÃ  generale che riassume',0),(54709,1520,'tl','',0),(54710,1520,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(54711,1520,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤•à¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¬à¤¨à¤¾à¤¨à¤¾',0),(54712,1520,'ms','Lejar Am ringkasan',0),(54713,1520,'ar','Ø®Ù„Ø§ØµØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(54714,1520,'fr','Grand livre rÃ©sumant',0),(54715,1520,'jp','ç·?å‹˜å®šå…ƒå¸³è¦?ç´„',0),(54716,1520,'pt','General Ledger Resumindo',0),(54717,1520,'ru','Ð“Ðš Ð¿Ð¾Ð´Ð²ÐµÐ´ÐµÐ½Ð¸Ðµ Ð¸Ñ‚Ð¾Ð³Ð¾Ð²',0),(54718,1520,'es','Sumarizando el Libro Mayor',0),(54719,1520,'de','Hauptbuch zusammenfassen',0),(54720,1520,'en','General Ledger Summarizing',0),(54721,1521,'is','',0),(54722,1521,'dr','( Ø¨Ø±Ø¯Ø§Ø´Øª Ø§Ø² Ø­Ø³Ø§Ø¨ ) Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù„ÛŒØ¬Ø± Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(54723,1521,'pr','Ù†ÙƒÙˆÙ„ ÙƒØ±Ø¯Ù† ( Ø¨Ø±Ø¯Ø§Ø´Øª Ø§Ø² Ø­Ø³Ø§Ø¨ ) Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(54724,1521,'tr','GL hareket backout baÅŸarÄ±sÄ±z oldu.',0),(54725,1521,'pl','GL backout transakcji nie powiodÅ‚o siÄ™.',0),(54726,1521,'bg','GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ backout Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(54727,1521,'ur','Ø¬ÛŒØ¬Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø¨Ø§Ú©Ú©Ø§Ù¹ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯Ø¦ÛŒ Û”',0),(54728,1521,'sr','Ð“Ð› Ð±Ð°Ñ†ÐºÐ¾ÑƒÑ‚ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿Ð¸Ð¾.',0),(54729,1521,'vi','Giao dá»‹ch sá»• cÃ¡i tá»•ng há»£p tháº¥t báº¡i',0),(54730,1521,'af','AG transaksies \"backout\" gefaal.',0),(54731,1521,'ro','GL tranzacÅ£ie backout nu a reuÈ™it.',0),(54732,1521,'et','GL tehingu backout nurjus.',0),(54733,1521,'si','GL posla backout ni uspelo.',0),(54734,1521,'ba','GL transaksi backout gagal.',0),(54735,1521,'nl','GL transactie backout is mislukt.',0),(54736,1521,'fi','GL tapahtuman Trace epÃ¤onnistui.',0),(54737,1521,'no','GL transaksjonen backout mislyktes.',0),(54738,1521,'da','GL transaktion backout mislykkedes.',0),(54739,1521,'ko','GL íŠ¸ëžœìž­ì…˜ ë°±ì•„ì›ƒ ì‹¤íŒ¨ í–ˆìŠµë‹ˆë‹¤.',0),(54740,1521,'he','×‘×™×˜×•×œ ×©×™× ×•×™×™ ×—×‘×¨×•×ª ×ª× ×•×¢×ª GL × ×›×©×œ.',0),(54741,1521,'el','GL ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® backout Î±Ï€Î­Ï„Ï…Ï‡Îµ.',0),(54742,1521,'zh','å‰å°”äº¤æ˜“å›žé€€å¤±è´¥ã€‚\r\n',0),(54743,1521,'sv','GL transaktionen backout misslyckades.',0),(54744,1521,'it','GL backout transazione non riuscita.',0),(54745,1521,'tl','',0),(54746,1521,'th','&#3585;&#3634;&#3619;&#3618;&#3657;&#3629;&#3609;&#3585;&#3621;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3',0),(54747,1521,'hi','GL à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ backout à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾à¥¤',0),(54748,1521,'ms','GL transaksi backout gagal.',0),(54749,1521,'ar','ÙØ´Ù„ GL Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ù„Ù…Ø®ÙÙ‚Ø©.',0),(54750,1521,'fr','GL transaction dÃ©sinstallation a Ã©chouÃ©.',0),(54751,1521,'jp','GLå?–å¼•ã?®ãƒ?ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(54752,1521,'pt','ReversÃ£o de transaÃ§Ã£o GL falhou.',0),(54753,1521,'ru','GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð° Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ.',0),(54754,1521,'es','Retroceder LM transacciÃ³n fallÃ³',0),(54755,1521,'de','GL Transaktion Backout ist fehlgeschlagen.',0),(54756,1521,'en','GL transaction backout failed.',0),(54757,1522,'is','',0),(54758,1522,'dr','( Ø¨Ø±Ø¯Ø§Ø´Øª Ø§Ø² Ø­Ø³Ø§Ø¨ ) Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ  Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù„ÛŒØ¬Ø± Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(54759,1522,'pr','Ù†ÙƒÙˆÙ„ ÙƒØ±Ø¯Ù† ( Ø¨Ø±Ø¯Ø§Ø´Øª Ø§Ø² Ø­Ø³Ø§Ø¨ ) Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ  Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(54760,1522,'tr','GL hareketin fiÅŸ backout baÅŸarÄ±sÄ±z oldu.',0),(54761,1522,'pl','GL backout zaÅ‚Ä…cznika transakcji nie powiodÅ‚o siÄ™.',0),(54762,1522,'bg','GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð²Ð°ÑƒÑ‡ÐµÑ€ backout Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(54763,1522,'ur','Ø¬ÛŒØ¬Û’ Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† ÙˆØ§Ø¤Ú†Ø± Ø¨Ø§Ú©Ú©Ø§Ù¹ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯Ø¦ÛŒ Û”',0),(54764,1522,'sr','Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð±Ð°Ñ†ÐºÐ¾ÑƒÑ‚ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÐ»Ð¾.',0),(54765,1522,'vi','Giao dá»‹ch sá»• cÃ¡i tá»•ng há»£p tháº¥t báº¡i',0),(54766,1522,'af','.',0),(54767,1522,'ro','GL tranzacÅ£ie voucher backout nu a reuÈ™it.',0),(54768,1522,'et','GL tehingu kviitungi backout nurjus.',0),(54769,1522,'si','GL transakcije bon backout ni uspelo.',0),(54770,1522,'ba','GL transaksi voucher backout gagal.',0),(54771,1522,'nl','GL transactie voucher backout is mislukt.',0),(54772,1522,'fi','GL tapahtuman tositteen Trace epÃ¤onnistui.',0),(54773,1522,'no','GL transaksjonen bilaget backout mislyktes.',0),(54774,1522,'da','GL transaktion voucher backout mislykkedes.',0),(54775,1522,'ko','GL íŠ¸ëžœìž­ì…˜ ë°”ìš°ì²˜ ë°±ì•„ì›ƒ ì‹¤íŒ¨ í–ˆìŠµë‹ˆë‹¤.',0),(54776,1522,'he','GL ×ª× ×•×¢×ª ×©×•×‘×¨ ×‘×™×˜×•×œ ×©×™× ×•×™×™ ×—×‘×¨×•×ª × ×›×©×œ.',0),(54777,1522,'el','GL ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ backout Î±Ï€Î­Ï„Ï…Ï‡Îµ.',0),(54778,1522,'zh','æ€»å¸äº¤æ˜“å‡­è¯å›žé€€å¤±è´¥ã€‚\r\n',0),(54779,1522,'sv','GL transaktionen verifikationen backout misslyckades.',0),(54780,1522,'it','GL transazioni giustificativo backout fallito.',0),(54781,1522,'tl','',0),(54782,1522,'th','&#3585;&#3634;&#3619;&#3618;&#3657;&#3629;&#3609;&#3585;&#3621;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3',0),(54783,1522,'hi','GL à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤µà¤¾à¤‰à¤šà¤° backout à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾à¥¤',0),(54784,1522,'ms','GL transaksi baucar backout gagal.',0),(54785,1522,'ar','ÙØ´Ù„ GL Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ù„Ø¥ÙŠØµØ§Ù„ Ø§Ù„Ù…Ø®ÙÙ‚Ø©.',0),(54786,1522,'fr','GL transaction bon dÃ©sinstallation a Ã©chouÃ©.',0),(54787,1522,'jp','GLå?–å¼•ä¼?ç¥¨ã?®ãƒ?ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(54788,1522,'pt','GL recuo de comprovante de transaÃ§Ã£o falhou.',0),(54789,1522,'ru','GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð° Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ.',0),(54790,1522,'es','Retroceder LM voucher de la transacciÃ³n fallÃ³',0),(54791,1522,'de','GL Transaktion Gutschein Backout ist fehlgeschlagen.',0),(54792,1522,'en','GL transaction voucher backout failed.',0),(54793,1523,'is','',0),(54794,1523,'dr','ØªÙ†Ø¸ÙŠÙ… Ø¯ÙØªØ± ÙƒÙ„',0),(54795,1523,'pr','ØªÙ†Ø¸ÙŠÙ… Ø¯ÙØªØ± ÙƒÙ„',0),(54796,1523,'tr','Genel muhasebe<br>Kurulum',0),(54797,1523,'pl','KsiÄ™ga<br>Instalator',0),(54798,1523,'bg','Ð¡Ñ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾<br>ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(54799,1523,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§<br>Ø³ÛŒÙ¹ Ø§Ù¾',0),(54800,1523,'sr','Ð“Ð»Ð°Ð²Ð½Ð° ÐºÑšÐ¸Ð³Ð°<br>ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(54801,1523,'vi','Setup sá»• cÃ¡i',0),(54802,1523,'af','Algemene grootboek<br>Opstelling',0),(54803,1523,'ro','Contabilitate<br>Programul de instalare',0),(54804,1523,'et','Pearaamat<br>Seadistamine',0),(54805,1523,'si','Glavna knjiga<br>Nastavitev',0),(54806,1523,'ba','General Ledger<br>Setup',0),(54807,1523,'nl','Grootboek<br>Setup',0),(54808,1523,'fi','General Ledger<br>Asetukset',0),(54809,1523,'no','Finans<br>Installasjonsprogrammet',0),(54810,1523,'da','General Ledger<br>OpsÃ¦tning',0),(54811,1523,'ko','ì¼ë°˜ íšŒê³„ ìž¥ë¶€<br>ì„¤ì¹˜',0),(54812,1523,'he','×”×¡×¤×¨ ×”×¨××©×™<br>×ª×•×›× ×™×ª ×”×”×ª×§× ×”',0),(54813,1523,'el','Î“ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®<br>Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(54814,1523,'zh','è®¾ç½®æ€»å¸\r\n',0),(54815,1523,'sv','Redovisning<br>Setup',0),(54816,1523,'it','ContabilitÃ  generale<br>Installazione',0),(54817,1523,'tl','',0),(54818,1523,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;<br>&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(54819,1523,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾à¤¬à¤¹à¥€<br>à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(54820,1523,'ms','Lejar Am<br>Persediaan',0),(54821,1523,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(54822,1523,'fr','ComptabilitÃ© gÃ©nÃ©rale<br>Programme d\'installation',0),(54823,1523,'jp','ç·?å‹˜å®šå…ƒå¸³<br>è¨­å®š',0),(54824,1523,'pt','General Ledger<br>InstalaÃ§Ã£o',0),(54825,1523,'ru','Ð“Ðš<br>Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ°',0),(54826,1523,'es','Libro Mayor<br>ConfiguraciÃ³n',0),(54827,1523,'de','Finanzbuchhaltung<br>Setup',0),(54828,1523,'en','General Ledger<br>Setup',0),(54829,1524,'is','',0),(54830,1524,'dr','GND',0),(54831,1524,'pr','GND',0),(54832,1524,'tr','GND',0),(54833,1524,'pl','GND',0),(54834,1524,'bg','GND',0),(54835,1524,'ur','Ú¯',0),(54836,1524,'sr','ÐÐÐ”ÐˆÐ•Ð›Ð',0),(54837,1524,'vi','GND',0),(54838,1524,'af','GELOOFSGROND',0),(54839,1524,'ro','GND',0),(54840,1524,'et','GND',0),(54841,1524,'si','GND',0),(54842,1524,'ba','GND',0),(54843,1524,'nl','GND',0),(54844,1524,'fi','GND',0),(54845,1524,'no','GND',0),(54846,1524,'da','GND',0),(54847,1524,'ko','GND',0),(54848,1524,'he','GND',0),(54849,1524,'el','GND',0),(54850,1524,'zh','èƒŒæ™¯\r\n',0),(54851,1524,'sv','GND',0),(54852,1524,'it','GND',0),(54853,1524,'tl','',0),(54854,1524,'th','GND',0),(54855,1524,'hi','GND',0),(54856,1524,'ms','GND',0),(54857,1524,'ar','GND',0),(54858,1524,'fr','GND',0),(54859,1524,'jp','GND',0),(54860,1524,'pt','GND',0),(54861,1524,'ru','GND',0),(54862,1524,'es','TIERRA',0),(54863,1524,'de','GND',0),(54864,1524,'en','GND',0),(54865,1525,'is','',0),(54866,1525,'dr','Ø¨Ø±Ú¯Ø±Ø¯ÙŠØ¯',0),(54867,1525,'pr','Ø¨Ø±Ú¯Ø±Ø¯ÙŠØ¯',0),(54868,1525,'tr','Geri Git',0),(54869,1525,'pl','PrzejdÅº wstecz',0),(54870,1525,'bg','Ð’ÑŠÑ€Ð½Ð¸ ÑÐµ Ð½Ð°Ð·Ð°Ð´',0),(54871,1525,'ur','ÙˆØ§Ù¾Ø³ Ø¬Ø§Ø¤',0),(54872,1525,'sr','Ð²Ñ€Ð°Ñ‚Ð¸ ÑÐµ',0),(54873,1525,'vi','Trá»Ÿ láº¡i',0),(54874,1525,'af','Gaan Terug',0),(54875,1525,'ro','Inapoi',0),(54876,1525,'et','Mine tagasi',0),(54877,1525,'si','vrni se',0),(54878,1525,'ba','Kembali',0),(54879,1525,'nl','Terug',0),(54880,1525,'fi','Mene takaisin',0),(54881,1525,'no','gÃ¥ tilbake',0),(54882,1525,'da','GÃ¥ tilbage',0),(54883,1525,'ko','ë’¤ë¡œ ì´ë™',0),(54884,1525,'he','×ª×—×–×•×¨',0),(54885,1525,'el','Î Î®Î³Î±Î¹Î½Îµ Ï€Î¯ÏƒÏ‰',0),(54886,1525,'zh','è¿”å›ž\r\n',0),(54887,1525,'sv','GÃ¥ tillbaka',0),(54888,1525,'it','Indietro',0),(54889,1525,'tl','',0),(54890,1525,'th','&#3585;&#3621;&#3633;&#3610;&#3652;&#3611;',0),(54891,1525,'hi','à¤ªà¤¸ à¤œà¤¾à¤“',0),(54892,1525,'ms','pergi balik',0),(54893,1525,'ar','Ø§Ù„Ø±Ø¬ÙˆØ¹ Ù„Ù„Ø®Ù„Ù',0),(54894,1525,'fr','Retour',0),(54895,1525,'jp','æˆ»ã‚‹',0),(54896,1525,'pt','Voltar',0),(54897,1525,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ ÐÐ°Ð·Ð°Ð´',0),(54898,1525,'es','Ir Atras',0),(54899,1525,'de','ZurÃ¼ck',0),(54900,1525,'en','Go Back',0),(54901,1526,'is','',0),(54902,1526,'dr','Ø¨Ø±Ú¯Ø±Ø¯ÙŠØ¯ Ø¨Ù‡ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(54903,1526,'pr','Ø¨Ø±Ú¯Ø±Ø¯ÙŠØ¯ Ø¨Ù‡ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(54904,1526,'tr','DÃ¼zenlemek iÃ§in geri dÃ¶n.',0),(54905,1526,'pl','WrÃ³Ä‡ do edycji',0),(54906,1526,'bg','Ð¡Ðµ Ð²ÑŠÑ€Ð½ÐµÑ‚Ðµ ÐºÑŠÐ¼ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(54907,1526,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ÙˆØ§Ù¾Ø³ Ø¬Ø§Ø¤',0),(54908,1526,'sr','Ð’Ñ€Ð°Ñ‚Ð¸ ÑÐµ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(54909,1526,'vi','Quay Láº¡i Chá»‰nh Sá»­a',0),(54910,1526,'af','Gaan na Terug na Redigeer',0),(54911,1526,'ro','Inapoi la editare',0),(54912,1526,'et','Naasmine rakenduse redigeerimine',0),(54913,1526,'si','Pojdite nazaj na urejanje',0),(54914,1526,'ba','Kembali untuk mengedit',0),(54915,1526,'nl','Ga terug naar bewerken',0),(54916,1526,'fi','Palaa Muokkaa',0),(54917,1526,'no','GÃ¥ tilbake til Rediger',0),(54918,1526,'da','GÃ¥ tilbage til at redigere',0),(54919,1526,'ko','íŽ¸ì§‘ìœ¼ë¡œ ëŒì•„ê°€',0),(54920,1526,'he','×œ×—×–×•×¨ ×œ×¢×¨×•×š',0),(54921,1526,'el','Î Î·Î³Î±Î¯Î½ÎµÏ„Îµ Ï€Î¯ÏƒÏ‰ ÏƒÏ„Î¿ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(54922,1526,'zh','è¿”å›žç¼–è¾‘\r\n',0),(54923,1526,'sv','GÃ¥ tillbaka till redigera',0),(54924,1526,'it','Tornare indietro per modificare',0),(54925,1526,'tl','',0),(54926,1526,'th','&#3585;&#3621;&#3633;&#3610;&#3652;&#3611;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(54927,1526,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤ªà¤¸ à¤œà¤¾à¤à¤',0),(54928,1526,'ms','Kembali untuk mengedit',0),(54929,1526,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ ØªØ­Ø±ÙŠØ±',0),(54930,1526,'fr','Revenir en arriÃ¨re pour modifier',0),(54931,1526,'jp','ç·¨é›†ç”»é?¢ã?¸æˆ»ã‚‹',0),(54932,1526,'pt','Voltar para editar',0),(54933,1526,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ ÐÐ°Ð·Ð°Ð´ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(54934,1526,'es','Ir Atras para Editar',0),(54935,1526,'de','Gehen Sie zurÃ¼ck zu bearbeiten',0),(54936,1526,'en','Go Back to Edit',0),(54937,1527,'is','',0),(54938,1527,'dr','Ø®Ø±ÙŠØ¯ Ø±ÙØªÙ†',0),(54939,1527,'pr','Ø®Ø±ÙŠØ¯ Ø±ÙØªÙ†',0),(54940,1527,'tr','AlÄ±ÅŸveriÅŸe gitmek',0),(54941,1527,'pl','Zakupy',0),(54942,1527,'bg','ÐžÑ‚Ð¸Ð´Ð¸ Ð¿Ð°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ',0),(54943,1527,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¬Ø§Ù†Û’',0),(54944,1527,'sr','Ð˜Ð´ÐµÐ¼ Ñƒ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ñƒ',0),(54945,1527,'vi','Äi Mua Sáº¯m',0),(54946,1527,'af','Gaan inkopies doen',0),(54947,1527,'ro','MergeÅ£i la cumpÄƒrÄƒturi',0),(54948,1527,'et','Poodidesse',0),(54949,1527,'si','Nakupovanje',0),(54950,1527,'ba','Pergi berbelanja',0),(54951,1527,'nl','Winkelen',0),(54952,1527,'fi','KÃ¤ydÃ¤ ostoksilla',0),(54953,1527,'no','Handle',0),(54954,1527,'da','GÃ¥ pÃ¥ indkÃ¸b',0),(54955,1527,'ko','ì‡¼í•‘ í•˜ ëŸ¬',0),(54956,1527,'he','×¦× ×œ×§× ×™×•×ª',0),(54957,1527,'el','Î Î¬Ï„Îµ Î³Î¹Î± ÏˆÏŽÎ½Î¹Î±',0),(54958,1527,'zh','åŽ»è´­ç‰©\r\n',0),(54959,1527,'sv','Shoppa',0),(54960,1527,'it','Fare Shopping',0),(54961,1527,'tl','',0),(54962,1527,'th','&#3652;&#3611;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(54963,1527,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤¨à¤¾',0),(54964,1527,'ms','Pergi membeli-belah',0),(54965,1527,'ar','Ø§Ø°Ù‡Ø¨ Ù„Ù„ØªØ³ÙˆÙ‚',0),(54966,1527,'fr','Faire du Shopping',0),(54967,1527,'jp','è²·ã?„ç‰©ã?¸è¡Œã??',0),(54968,1527,'pt','Ir Ã s compras',0),(54969,1527,'ru','Ð¥Ð¾Ð´Ð¸Ñ‚ÑŒ Ð¿Ð¾ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð°Ð¼',0),(54970,1527,'es','Ir de Compras',0),(54971,1527,'de','Einkaufen gehen',0),(54972,1527,'en','Go Shopping',0),(54973,1528,'is','',0),(54974,1528,'dr','Ø¨Ø±ÙˆÙŠØ¯  Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(54975,1528,'pr','Ø¨Ø±ÙˆÙŠØ¯  Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(54976,1528,'tr','TaÅŸÄ±yÄ±cÄ± seÃ§ime gitmek',0),(54977,1528,'pl','PrzejdÅº do wyboru',0),(54978,1528,'bg','ÐžÑ‚Ð¸Ð²Ð°Ð¼ ÐºÑŠÐ¼ Ð¸Ð·Ð±Ð¾Ñ€ Ð½Ð° Ð½Ð¾ÑÐ¸Ñ‚ÐµÐ»',0),(54979,1528,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ú©Û’ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù„ÛŒÛ’ Ø¬Ø§Ù†Ø§',0),(54980,1528,'sr','Ð˜Ð´Ð¸ Ð½Ð° Ð½Ð¾ÑÐ°Ñ‡ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ñƒ',0),(54981,1528,'vi','Äáº¿n lá»±a chá»n hÃ£ng váº­n chuyá»ƒn',0),(54982,1528,'af','Gaan na Karweier Seleksie',0),(54983,1528,'ro','Du-te la selectarea',0),(54984,1528,'et','Mine operaatori valik',0),(54985,1528,'si','Pojdi na izbiro',0),(54986,1528,'ba','Pergi ke seleksi pembawa',0),(54987,1528,'nl','Ga naar Carrier-selectie',0),(54988,1528,'fi','Siirry operaattorin valinta',0),(54989,1528,'no','GÃ¥ til Carrier utvalg',0),(54990,1528,'da','GÃ¥ til fast operatÃ¸rvalg',0),(54991,1528,'ko','ìºë¦¬ì–´ ì„ íƒ ì´ë™',0),(54992,1528,'he','×œ×œ×›×ª ×¢×œ × ×•×©× × ×‘×—×¨',0),(54993,1528,'el','Î Î·Î³Î±Î¯Î½ÎµÏ„Îµ ÏƒÏ„Î¿ Ï†Î¿ÏÎ­Î±',0),(54994,1528,'zh','å‰å¾€è½½ä½“é€‰æ‹©\r\n',0),(54995,1528,'sv','GÃ¥ till val',0),(54996,1528,'it','Vai alla selezione del vettore',0),(54997,1528,'tl','',0),(54998,1528,'th','&#3652;&#3611;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(54999,1528,'hi','à¤•à¥ˆà¤°à¤¿à¤¯à¤° à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤“',0),(55000,1528,'ms','Pergi ke pilihan pengangkut',0),(55001,1528,'ar','Ø§Ø°Ù‡Ø¨ Ø¥Ù„Ù‰ Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù†Ø§Ù‚Ù„',0),(55002,1528,'fr','Aller Ã  la sÃ©lection du transporteur',0),(55003,1528,'jp','é…?é€?æ¥­è€…é?¸æŠžã?¸è¡Œã??',0),(55004,1528,'pt','Ir Ã  selecÃ§Ã£o',0),(55005,1528,'ru','Ðš Ð’Ñ‹Ð±Ð¾Ñ€Ñƒ ÐšÑƒÑ€ÑŒÐµÑ€Ð°',0),(55006,1528,'es','Va a SelecciÃ³n de Transportador',0),(55007,1528,'de','Gehen Sie auf Carrier-Auswahl',0),(55008,1528,'en','Go to Carrier Selection',0),(55009,1529,'is','',0),(55010,1529,'dr','Ø¨Ø±ÙˆÙŠØ¯  Ø¨Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(55011,1529,'pr','Ø¨Ø±ÙˆÙŠØ¯  Ø¨Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(55012,1529,'tr','AyrÄ±ntÄ±lar iÃ§in git',0),(55013,1529,'pl','PrzejdÅº do szczegÃ³Å‚Ã³w',0),(55014,1529,'bg','Ð—Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(55015,1529,'ur','ØªÙØµÛŒÙ„Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ø¬Ø§Ù†Û’',0),(55016,1529,'sr','Ð˜Ð´Ð¸ Ð½Ð° Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(55017,1529,'vi','Äáº¿n chi tiáº¿t',0),(55018,1529,'af','Gaan na Details',0),(55019,1529,'ro','Du-te la detalii',0),(55020,1529,'et','Minna Ã¼ksikasjad',0),(55021,1529,'si','Pojdi na podrobnosti',0),(55022,1529,'ba','Pergi ke rincian',0),(55023,1529,'nl','Ga naar Details',0),(55024,1529,'fi','Siirry tiedot',0),(55025,1529,'no','GÃ¥ til detaljene',0),(55026,1529,'da','GÃ¥ til detaljer',0),(55027,1529,'ko','ì„¸ë¶€ ì‚¬í•­ì—ê°€ ì„œ',0),(55028,1529,'he','×œ×œ×›×ª ×¢×œ ×¤×¨×˜×™×',0),(55029,1529,'el','Î Î·Î³Î±Î¯Î½ÎµÏ„Îµ ÏƒÏ„Î¿ Details',0),(55030,1529,'zh','è¿›å…¥è¯¦ç»†\r\n',0),(55031,1529,'sv','GÃ¥ till Detaljer',0),(55032,1529,'it','Vai ai dettagli',0),(55033,1529,'tl','',0),(55034,1529,'th','&#3652;&#3611;&#3607;&#3637;&#3656;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(55035,1529,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤¨à¤¾',0),(55036,1529,'ms','Pergi ke butiran',0),(55037,1529,'ar','Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰ Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(55038,1529,'fr','Voir les dÃ©tails',0),(55039,1529,'jp','è©³ç´°ã?¸',0),(55040,1529,'pt','Ir para detalhes',0),(55041,1529,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ðº Ð”ÐµÑ‚Ð°Ð»ÑÐ¼',0),(55042,1529,'es','Va a los Detalles',0),(55043,1529,'de','Gehen Sie zu Details',0),(55044,1529,'en','Go to Details',0),(55045,1530,'is','',0),(55046,1530,'dr','Ø®ÙˆØ¨',0),(55047,1530,'pr','Ø®ÙˆØ¨',0),(55048,1530,'tr','Ä°yi',0),(55049,1530,'pl','Dobry',0),(55050,1530,'bg','Ð”Ð¾Ð±Ñ€Ðµ',0),(55051,1530,'ur','Ø§Ú†Ú¾Ø§',0),(55052,1530,'sr','Ð”Ð¾Ð±Ñ€Ð¾',0),(55053,1530,'vi','Tá»‘t',0),(55054,1530,'af','Goed',0),(55055,1530,'ro','bun',0),(55056,1530,'et','Hea',0),(55057,1530,'si','dobro',0),(55058,1530,'ba','Bagus',0),(55059,1530,'nl','Goede',0),(55060,1530,'fi','HyvÃ¤',0),(55061,1530,'no','bra',0),(55062,1530,'da','God',0),(55063,1530,'ko','ì¢‹ì€',0),(55064,1530,'he','×˜×•×‘',0),(55065,1530,'el','ÎšÎ±Î»ÏŒ',0),(55066,1530,'zh','å¥½\r\n',0),(55067,1530,'sv','Bra',0),(55068,1530,'it','Buona',0),(55069,1530,'tl','',0),(55070,1530,'th','&#3604;&#3637;',0),(55071,1530,'hi','à¤…à¤šà¥à¤›à¤¾',0),(55072,1530,'ms','Baik',0),(55073,1530,'ar','Ø¬ÙŠØ¯Ø©',0),(55074,1530,'fr','Bon',0),(55075,1530,'jp','ã‚ˆã?„',0),(55076,1530,'pt','Bom',0),(55077,1530,'ru','Ð¥Ð¾Ñ€Ð¾ÑˆÐ¸Ð¹',0),(55078,1530,'es','Bueno',0),(55079,1530,'de','Gute',0),(55080,1530,'en','Good',0),(55081,1531,'is','',0),(55082,1531,'dr','Ø¨Ø±Ùˆ Ø¨Ù‡ Ø´Ø±ÙƒØª Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(55083,1531,'pr','Ø¨Ø±Ùˆ Ø¨Ù‡ Ø´Ø±ÙƒØª Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(55084,1531,'tr','SeÃ§ili ÅŸirket iÃ§in gitmek',0),(55085,1531,'pl','PrzejdÅº do wybranej firmy',0),(55086,1531,'bg','ÐžÑ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð°Ñ‚Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(55087,1531,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ùˆ Ø¬Ø§Ù†Ø§',0),(55088,1531,'sr','Ð£ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾Ð¼ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ñƒ',0),(55089,1531,'vi','CÃ´ng ty Ä‘Ã£ chá»n',0),(55090,1531,'af','Gaan na geselekteerde onderneming',0),(55091,1531,'ro','Du-te la companie selectate',0),(55092,1531,'et','Mine valitud ettevÃµttele',0),(55093,1531,'si','Pojdi na izbranem podjetju',0),(55094,1531,'ba','Pergi ke perusahaan yang dipilih',0),(55095,1531,'nl','Ga naar geselecteerde bedrijf',0),(55096,1531,'fi','Siirry valitun yrityksen',0),(55097,1531,'no','GÃ¥ til valgte selskapet',0),(55098,1531,'da','GÃ¥ til valgte firma',0),(55099,1531,'ko','ì„ íƒí•œ íšŒì‚¬ì—ê°€ ì„œ',0),(55100,1531,'he','×¢×‘×•×¨ ×œ×—×‘×¨×” ×©× ×‘×—×¨×”',0),(55101,1531,'el','ÎœÎµÏ„Î±Î²ÎµÎ¯Ï„Îµ ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(55102,1531,'zh','å‰å¾€é€‰å®šçš„å…¬å¸\r\n',0),(55103,1531,'sv','GÃ¥ till markerade fÃ¶retag',0),(55104,1531,'it','Vai alla societÃ  selezionati',0),(55105,1531,'tl','',0),(55106,1531,'th','&#3652;&#3611;&#3607;&#3637;&#3656;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(55107,1531,'hi','à¤œà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¤‚à¤ªà¤¨à¥€',0),(55108,1531,'ms','Pergi ke syarikat terpilih',0),(55109,1531,'ar','Ø§Ø°Ù‡Ø¨ Ù„Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(55110,1531,'fr','Aller Ã  la sociÃ©tÃ© sÃ©lectionnÃ©e',0),(55111,1531,'jp','é?¸æŠžã?•ã‚Œã?Ÿä¼šç¤¾ã?¸è¡Œã??',0),(55112,1531,'pt','Ir a empresa selecionada',0),(55113,1531,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ðº Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(55114,1531,'es','Ir a la empresa seleccionada',0),(55115,1531,'de','Gehen Sie zu ausgewÃ¤hlten Unternehmen',0),(55116,1531,'en','Go to selected company',0),(55117,1532,'is','',0),(55118,1532,'dr','Ù…Ø¨Ø§Ù„Øº ÙƒÙ„ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ù„ÙŠØ³Øª Ø´Ø¯Ù‡ Ù‡Ø§ ',0),(55119,1532,'pr','Ù…Ø¨Ø§Ù„Øº ÙƒÙ„ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ù„ÙŠØ³Øª Ø´Ø¯Ù‡ Ù‡Ø§ ',0),(55120,1532,'tr','TÃ¼m listelenen iÃ§in genel toplam',0),(55121,1532,'pl','Sumy dla wszystkich wymienionych',0),(55122,1532,'bg','ÐžÐ±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸ Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¸Ð·Ð±Ñ€Ð¾ÐµÐ½Ð¸',0),(55123,1532,'ur','ØªÙ…Ø§Ù… ÙÛØ±Ø³Øª Ú©Û’ Ù„Ø¦Û’ Ú¯Ø±ÛŒÙ†Úˆ Ù…ÛŒØ²Ø§Ù†',0),(55124,1532,'sr','Ð¡Ð²ÐµÑƒÐºÑƒÐ¿Ð½Ð¸Ñ… Ð·Ð° ÑÐ²Ðµ Ð½Ð°Ð²ÐµÐ´ÐµÐ½Ðµ',0),(55125,1532,'vi','Tá»•ng sá»‘ cho táº¥t cáº£ liá»‡t kÃª',0),(55126,1532,'af','Groot Totale vir Hele Lys',0),(55127,1532,'ro','Totaluri pentru toate enumerate',0),(55128,1532,'et','KÃµik loetletud Ã¼ldkokkuvÃµtted',0),(55129,1532,'si','Vsote za vse naÅ¡tete',0),(55130,1532,'ba','Grand total untuk semua terdaftar',0),(55131,1532,'nl','Eindtotalen voor alle genoemde',0),(55132,1532,'fi','Loppusummien kaikki lueteltu',0),(55133,1532,'no','Totalsummer for alle oppfÃ¸rt',0),(55134,1532,'da','Hovedtotaler for alle anfÃ¸rte',0),(55135,1532,'ko','ë‚˜ì—´ ëœ ëª¨ë“  ì´í•©ê³„',0),(55136,1532,'he','×¡×›×•×ž×™× ×›×•×œ×œ×™× ×¢×‘×•×¨ ×›×œ ×¨×©×•×ž×”',0),(55137,1532,'el','Î‘Î¸ÏÎ¿Î¯ÏƒÎ¼Î±Ï„Î± Î³Î¹Î± ÏŒÎ»Î¿Ï…Ï‚ Ï€Î¿Ï… Î±Î½Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹',0),(55138,1532,'zh','æ‰€æœ‰åˆ—å‡ºé¡¹æ€»è®¡\r\n',0),(55139,1532,'sv','Totalsummor fÃ¶r alla listade',0),(55140,1532,'it','Totali complessivi per tutti elencati',0),(55141,1532,'tl','',0),(55142,1532,'th','&#3618;&#3629;&#3604;&#3648;&#3591;&#3636;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3621;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(55143,1532,'hi','à¤¸à¤­à¥€ à¤¸à¥‚à¤šà¥€à¤¬à¤¦à¥à¤§ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¹à¤¾à¤¯à¥‹à¤—',0),(55144,1532,'ms','Grand jumlah untuk semua yang disenaraikan',0),(55145,1532,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹ Ø§Ù„ÙƒÙ„ÙŠØ© Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù…Ø¯Ø±Ø¬Ø©',0),(55146,1532,'fr','Totaux gÃ©nÃ©raux pour tous rÃ©pertoriÃ©s',0),(55147,1532,'jp','å…¨ã?¦ã?®ãƒªã‚¹ãƒˆã?•ã‚Œã?Ÿé …ç›®ã?®ç·?å?ˆè¨ˆ',0),(55148,1532,'pt','Totais para todos listados',0),(55149,1532,'ru','ÐžÐ±Ñ‰Ð¸Ðµ Ð¸Ñ‚Ð¾Ð³Ð¸ Ð´Ð»Ñ Ð²ÑÐµÑ… Ð¿ÐµÑ€ÐµÑ‡Ð¸ÑÐ»ÐµÐ½Ð½Ñ‹Ñ…',0),(55150,1532,'es','Grandes Totales para Todo Listado',0),(55151,1532,'de','Das Gesamtergebnis fÃ¼r alle aufgefÃ¼hrten',0),(55152,1532,'en','Grand Totals for All Listed',0),(55153,1533,'is','',0),(55154,1533,'dr','Ú¯Ø±Ø§ÙÙŠÙƒ',0),(55155,1533,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ',0),(55156,1533,'tr','GrafiÄŸi',0),(55157,1533,'pl','Grafika',0),(55158,1533,'bg','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(55159,1533,'ur','Ú¯Ø±Ø§ÙÚ©',0),(55160,1533,'sr','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(55161,1533,'vi','Äá»“ Há»a',0),(55162,1533,'af','Grafika',0),(55163,1533,'ro','Grafic',0),(55164,1533,'et','Pilt',0),(55165,1533,'si','GrafiÄni',0),(55166,1533,'ba','Grafis',0),(55167,1533,'nl','Afbeelding',0),(55168,1533,'fi','Graafinen',0),(55169,1533,'no','Grafikk',0),(55170,1533,'da','Grafisk',0),(55171,1533,'ko','ê·¸ëž˜í”½',0),(55172,1533,'he','×’×¨×¤×™×§×”',0),(55173,1533,'el','Î“ÏÎ±Ï†Î¹ÎºÏŒ',0),(55174,1533,'zh','å›¾å½¢\r\n',0),(55175,1533,'sv','Grafik',0),(55176,1533,'it','Grafica',0),(55177,1533,'tl','',0),(55178,1533,'th','&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;',0),(55179,1533,'hi','à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤•',0),(55180,1533,'ms','Grafik',0),(55181,1533,'ar','Ø§Ù„Ø±Ø³Ù…',0),(55182,1533,'fr','Graphique',0),(55183,1533,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯',0),(55184,1533,'pt','GrÃ¡fico',0),(55185,1533,'ru','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(55186,1533,'es','GrÃ¡fica',0),(55187,1533,'de','Grafik',0),(55188,1533,'en','Graphic',0),(55189,1534,'is','',0),(55190,1534,'dr','Ú¯Ø±Ø§ÙÙŠÙƒ Ù‡Ø§',0),(55191,1534,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ Ù‡Ø§',0),(55192,1534,'tr','Grafik',0),(55193,1534,'pl','Grafika',0),(55194,1534,'bg','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(55195,1534,'ur','Ú¯Ø±Ø§ÙÚ©Ø³',0),(55196,1534,'sr','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(55197,1534,'vi','Äá»“ Há»a',0),(55198,1534,'af','Grafies',0),(55199,1534,'ro','Grafica',0),(55200,1534,'et','Graafika',0),(55201,1534,'si','Grafika',0),(55202,1534,'ba','Grafis',0),(55203,1534,'nl','Afbeeldingen',0),(55204,1534,'fi','Grafiikka',0),(55205,1534,'no','Grafikk',0),(55206,1534,'da','Grafik',0),(55207,1534,'ko','ê·¸ëž˜í”½',0),(55208,1534,'he','×’×¨×¤×™×§×”',0),(55209,1534,'el','Î“ÏÎ±Ï†Î¹ÎºÏŽÎ½',0),(55210,1534,'zh','å›¾å½¢\r\n',0),(55211,1534,'sv','Grafik',0),(55212,1534,'it','Grafica',0),(55213,1534,'tl','',0),(55214,1534,'th','&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;',0),(55215,1534,'hi','à¤—à¥à¤°à¤¾à¤«à¤¿à¤•à¥à¤¸',0),(55216,1534,'ms','Grafik',0),(55217,1534,'ar','Ø§Ù„Ø±Ø³ÙˆÙ…Ø§Øª',0),(55218,1534,'fr','Graphiques',0),(55219,1534,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯',0),(55220,1534,'pt','GrÃ¡ficos',0),(55221,1534,'ru','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(55222,1534,'es','GrÃ¡fica',0),(55223,1534,'de','Grafiken',0),(55224,1534,'en','Graphics',0),(55225,1535,'is','',0),(55226,1535,'dr','(Ù†Ø§ Ø®Ø§Ù„Øµ',0),(55227,1535,'pr','Ù†Ø§ ÙˆÙŠÚ˜Ù‡(Ù†Ø§ Ø®Ø§Ù„Øµ',0),(55228,1535,'tr','BrÃ¼t',0),(55229,1535,'pl','Brutto',0),(55230,1535,'bg','Ð‘Ñ€ÑƒÑ‚Ð¾',0),(55231,1535,'ur','Ø®Ø§Ù…',0),(55232,1535,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾',0),(55233,1535,'vi','Gá»™p',0),(55234,1535,'af','Bruto',0),(55235,1535,'ro','Brut',0),(55236,1535,'et','Gross',0),(55237,1535,'si','Bruto',0),(55238,1535,'ba','Kotor',0),(55239,1535,'nl','Bruto',0),(55240,1535,'fi','Brutto',0),(55241,1535,'no','Brutto',0),(55242,1535,'da','Brutto',0),(55243,1535,'ko','ì´',0),(55244,1535,'he','×ž×’×¢×™×œ',0),(55245,1535,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î¿',0),(55246,1535,'zh','æ¯›\r\n',0),(55247,1535,'sv','Brutto',0),(55248,1535,'it','Lordo',0),(55249,1535,'tl','',0),(55250,1535,'th','&#3585;&#3635;&#3652;&#3619;',0),(55251,1535,'hi','à¤¸à¤•à¤²',0),(55252,1535,'ms','Kasar',0),(55253,1535,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(55254,1535,'fr','Brut',0),(55255,1535,'jp','ç·?è¨ˆ',0),(55256,1535,'pt','Bruto',0),(55257,1535,'ru','Ð‘Ñ€ÑƒÑ‚Ñ‚Ð¾',0),(55258,1535,'es','Bruto',0),(55259,1535,'de','Brutto',0),(55260,1535,'en','Gross',0),(55261,1536,'is','',0),(55262,1536,'dr','Ù†Ø§ Ø®Ø§Ù„Øµ Ø­Ù‚ÙˆÙ‚ ',0),(55263,1536,'pr','Ù†Ø§ Ø®Ø§Ù„Øµ Ø­Ù‚ÙˆÙ‚ ',0),(55264,1536,'tr','BrÃ¼t Ã¶deme',0),(55265,1536,'pl','Wynagrodzenia brutto',0),(55266,1536,'bg','Ð‘Ñ€ÑƒÑ‚Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(55267,1536,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û',0),(55268,1536,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ',0),(55269,1536,'vi','LÆ°Æ¡ng gá»™p',0),(55270,1536,'af','Bruto Besoldiging',0),(55271,1536,'ro','Salariu brut',0),(55272,1536,'et','Brutopalk',0),(55273,1536,'si','Bruto plaÄa',0),(55274,1536,'ba','Gaji Bruto',0),(55275,1536,'nl','Brutoloon',0),(55276,1536,'fi','Bruttopalkasta',0),(55277,1536,'no','BruttolÃ¸nn',0),(55278,1536,'da','Brutto lÃ¸n',0),(55279,1536,'ko','ì´ ì§€ë¶ˆ',0),(55280,1536,'he','×©×›×¨ ×‘×¨×•×˜×•',0),(55281,1536,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î· Î±Î¼Î¿Î¹Î²Î®',0),(55282,1536,'zh','å·¥èµ„æ€»é¢\r\n',0),(55283,1536,'sv','BruttolÃ¶n',0),(55284,1536,'it','Paga lorda',0),(55285,1536,'tl','',0),(55286,1536,'th','&#3618;&#3629;&#3604;&#3592;&#3656;&#3634;&#3618;&#3619;&#3623;&#3617;',0),(55287,1536,'hi','à¤¸à¤•à¤² à¤µà¥‡à¤¤à¤¨',0),(55288,1536,'ms','Gaji kasar',0),(55289,1536,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(55290,1536,'fr','RÃ©munÃ©ration brute',0),(55291,1536,'jp','çµ¦ä¸Žç·?é¡?',0),(55292,1536,'pt','SalÃ¡rio bruto',0),(55293,1536,'ru','Ð’Ð°Ð»Ð¾Ð²Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(55294,1536,'es','Pago Bruto',0),(55295,1536,'de','Bruttogehalt',0),(55296,1536,'en','Gross Pay',0),(55297,1537,'is','',0),(55298,1537,'dr','/ Ø³Ø§Ù„',0),(55299,1537,'pr','Ù†Ø§ Ø®Ø§Ù„Øµ Ø­Ù‚ÙˆÙ‚ / Ø³Ø§Ù„',0),(55300,1537,'tr','BrÃ¼t maaÅŸ/yÄ±l',0),(55301,1537,'pl','Wynagrodzenia brutto/rok',0),(55302,1537,'bg','Ð‘Ñ€ÑƒÑ‚Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸/Yr',0),(55303,1537,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ ØªÙ†Ø®ÙˆØ§Û/Ø³Ø§Ù„',0),(55304,1537,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ð°/Ñ‚Ð²Ð¾Ñ˜',0),(55305,1537,'vi','LÆ°Æ¡ng gá»™p/nÄƒm',0),(55306,1537,'af','Bruto Besoldiging/Jr',0),(55307,1537,'ro','Salariu brut/an',0),(55308,1537,'et','Bruto tÃ¶Ã¶tasu aastas',0),(55309,1537,'si','Bruto plaÄa/Yr',0),(55310,1537,'ba','Bayar/Yr bruto',0),(55311,1537,'nl','Bruto loon/Yr',0),(55312,1537,'fi','Brutto palkka/Yr',0),(55313,1537,'no','Brutto lÃ¸nn/Yr',0),(55314,1537,'da','Brutto lÃ¸n/Yr',0),(55315,1537,'ko','ì´ ê¸‰ì—¬/Yr',0),(55316,1537,'he','×©×›×¨ ×‘×¨×•×˜×•/Yr',0),(55317,1537,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î· Î±Î¼Î¿Î¹Î²Î®/Yr',0),(55318,1537,'zh','å·¥èµ„æ€»é¢/å¹´\r\n',0),(55319,1537,'sv','Brutto lÃ¶n/Yr',0),(55320,1537,'it','Retribuzione lorda/Yr',0),(55321,1537,'tl','',0),(55322,1537,'th','&#3618;&#3629;&#3604;&#3592;&#3656;&#3634;&#3618;&#3619;&#3623;&#3617;&#3605;&#3656;&#3629;&#3611;&#3637;',0),(55323,1537,'hi','à¤¸à¤•à¤² à¤µà¥‡à¤¤à¤¨/Yr',0),(55324,1537,'ms','Gaji kasar/THN',0),(55325,1537,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø£Ø¬Ø±/Ø³Ù†Ø©',0),(55326,1537,'fr','Salaire brut/an',0),(55327,1537,'jp','çµ¦ä¸Žç·?é¡?/å¹´',0),(55328,1537,'pt','SalÃ¡rio bruto/ano',0),(55329,1537,'ru','Ð’Ð°Ð»Ð¾Ð²Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹/Ð³Ð¾Ð´',0),(55330,1537,'es','Pago Bruto/AÃ±o',0),(55331,1537,'de','Brutto Lohn/Jahr',0),(55332,1537,'en','Gross Pay/Yr',0),(55333,1538,'is','',0),(55334,1538,'dr','/ Ø³Ø§Ù„',0),(55335,1538,'pr','Ù†Ø§ Ø®Ø§Ù„Øµ / Ø³Ø§Ù„',0),(55336,1538,'tr','Gross/yÄ±l',0),(55337,1538,'pl','Brutto/rok',0),(55338,1538,'bg','Ð‘Ñ€ÑƒÑ‚Ð¾/Yr',0),(55339,1538,'ur','Ú¯Ø±ÙˆØ³/Ø³Ø§Ù„',0),(55340,1538,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾/Ñ‚Ð²Ð¾Ñ˜',0),(55341,1538,'vi','LÆ°Æ¡ng gá»™p/nÄƒm',0),(55342,1538,'af','Bruto/Jr',0),(55343,1538,'ro','Brut/an',0),(55344,1538,'et','Gross aastas',0),(55345,1538,'si','Bruto/Yr',0),(55346,1538,'ba','Kotor/Yr',0),(55347,1538,'nl','Bruto/Yr',0),(55348,1538,'fi','Brutto/Yr',0),(55349,1538,'no','Brutto/Yr',0),(55350,1538,'da','Brutto/Yr',0),(55351,1538,'ko','ì´/Yr',0),(55352,1538,'he','×’×¨×•×¡/Yr',0),(55353,1538,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î¿/Yr',0),(55354,1538,'zh','æ¯›/å¹´\r\n',0),(55355,1538,'sv','Brutto/Yr',0),(55356,1538,'it','Lordo/Yr',0),(55357,1538,'tl','',0),(55358,1538,'th','&#3585;&#3635;&#3652;&#3619;&#3605;&#3656;&#3629;&#3611;&#3637;',0),(55359,1538,'hi','à¤¸à¤•à¤²/Yr',0),(55360,1538,'ms','Kasar/THN',0),(55361,1538,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ/Ø³Ù†Ø©',0),(55362,1538,'fr','Brut/an',0),(55363,1538,'jp','ç·?è¨ˆ/å¹´',0),(55364,1538,'pt','Bruto/ano',0),(55365,1538,'ru','Ð‘Ñ€ÑƒÑ‚Ñ‚Ð¾/Ð³Ð¾Ð´',0),(55366,1538,'es','Renta En Bruto/AÃ±o',0),(55367,1538,'de','Brutto/Jahr',0),(55368,1538,'en','Gross/Yr',0),(55369,1539,'is','',0),(55370,1539,'dr','Ø³ÙˆØ¯ Ù†Ø§ Ø®Ø§Ù„Øµ ',0),(55371,1539,'pr','Ø³ÙˆØ¯ Ù†Ø§ Ø®Ø§Ù„Øµ ',0),(55372,1539,'tr','BrÃ¼t kar',0),(55373,1539,'pl','Zysk brutto',0),(55374,1539,'bg','Ð‘Ñ€ÑƒÑ‚Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(55375,1539,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ù…Ù†Ø§ÙØ¹',0),(55376,1539,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð°',0),(55377,1539,'vi','Lá»£i nhuáº­n gá»™p',0),(55378,1539,'af','Bruto Wins',0),(55379,1539,'ro','Profit brut',0),(55380,1539,'et','Brutokasum',0),(55381,1539,'si','Bruto dobiÄek',0),(55382,1539,'ba','Laba kotor',0),(55383,1539,'nl','Bruto winst',0),(55384,1539,'fi','Bruttovoitto',0),(55385,1539,'no','Bruttofortjeneste',0),(55386,1539,'da','Bruttofortjeneste',0),(55387,1539,'ko','ë§¤ì¶œ ì´ ì´ìµ',0),(55388,1539,'he','×¨×•×•×— ×’×•×œ×ž×™',0),(55389,1539,'el','ÎœÎ¹ÎºÏ„ÏŒ ÎºÎ­ÏÎ´Î¿Ï‚',0),(55390,1539,'zh','æ¯›åˆ©\r\n',0),(55391,1539,'sv','Bruttoresultat',0),(55392,1539,'it','Utile lordo',0),(55393,1539,'tl','',0),(55394,1539,'th','&#3585;&#3635;&#3652;&#3619;&#3586;&#3633;&#3657;&#3609;&#3605;&#3657;&#3609;',0),(55395,1539,'hi','à¤¸à¤•à¤² à¤²à¤¾à¤­',0),(55396,1539,'ms','Untung kasar',0),(55397,1539,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø±Ø¨Ø­',0),(55398,1539,'fr','Marge brute',0),(55399,1539,'jp','ç·?åˆ©ç›Š',0),(55400,1539,'pt','Lucro bruto',0),(55401,1539,'ru','Ð’Ð°Ð»Ð¾Ð²Ð°Ñ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ',0),(55402,1539,'es','Utilidad Bruto',0),(55403,1539,'de','Rohertrag',0),(55404,1539,'en','Gross Profit',0),(55405,1540,'is','',0),(55406,1540,'dr','Ú¯Ø±ÙˆÙ‡ ',0),(55407,1540,'pr','Ú¯Ø±ÙˆÙ‡ ',0),(55408,1540,'tr','Grup',0),(55409,1540,'pl','Grupa',0),(55410,1540,'bg','Ð“Ñ€ÑƒÐ¿Ð°',0),(55411,1540,'ur','Ú¯Ø±ÙˆÙ¾',0),(55412,1540,'sr','Ð“Ñ€ÑƒÐ¿Ð°',0),(55413,1540,'vi','NhÃ³m',0),(55414,1540,'af','Groep',0),(55415,1540,'ro','Grupa',0),(55416,1540,'et','Grupp',0),(55417,1540,'si','Skupina',0),(55418,1540,'ba','Kelompok',0),(55419,1540,'nl','Groep',0),(55420,1540,'fi','RyhmÃ¤',0),(55421,1540,'no','Gruppe',0),(55422,1540,'da','Gruppe',0),(55423,1540,'ko','ê·¸ë£¹',0),(55424,1540,'he','×§×‘×•×¦×”',0),(55425,1540,'el','ÎŸÎ¼Î¬Î´Î±',0),(55426,1540,'zh','é›†å›¢\r\n',0),(55427,1540,'sv','Grupp',0),(55428,1540,'it','Gruppo',0),(55429,1540,'tl','',0),(55430,1540,'th','&#3585;&#3621;&#3640;&#3656;&#3617;',0),(55431,1540,'hi','à¤¸à¤®à¥‚à¤¹',0),(55432,1540,'ms','Kumpulan',0),(55433,1540,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(55434,1540,'fr','Groupe',0),(55435,1540,'jp','ã‚°ãƒ«ãƒ¼ãƒ—',0),(55436,1540,'pt','Grupo',0),(55437,1540,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð°',0),(55438,1540,'es','Grupo',0),(55439,1540,'de','Gruppe',0),(55440,1540,'en','Group',0),(55441,1541,'is','',0),(55442,1541,'dr','(Ø§ÙØ²ÙˆØ¯Ù†',0),(55443,1541,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø¬Ù‡Øª Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù† (Ø§ÙØ²ÙˆØ¯Ù†',0),(55444,1541,'tr','Grup eklemek iÃ§in',0),(55445,1541,'pl','Aby objÄ…Ä‡',0),(55446,1541,'bg','Ð“Ñ€ÑƒÐ¿Ð° Ð´Ð° Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚',0),(55447,1541,'ur','Ú¯Ø±ÙˆÙ¾ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(55448,1541,'sr','Ð“Ñ€ÑƒÐ¿Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÐºÑ™ÑƒÑ‡Ð¸Ð»Ð¸',0),(55449,1541,'vi','NhÃ³m bao gá»“m',0),(55450,1541,'af','Groep om In te sluit',0),(55451,1541,'ro','Grupul a Include',0),(55452,1541,'et','Millist gruppi kaasata',0),(55453,1541,'si','Skupina vkljuÄuje',0),(55454,1541,'ba','Grup perusahaan yang meliputi',0),(55455,1541,'nl','Groep op te nemen',0),(55456,1541,'fi','RyhmÃ¤ myÃ¶s',0),(55457,1541,'no','Gruppe med',0),(55458,1541,'da','Gruppe, der skal omfatte',0),(55459,1541,'ko','í¬í•¨ í•˜ëŠ” ê·¸ë£¹',0),(55460,1541,'he','×§×‘×•×¦×” ×›×“×™ ×œ×›×œ×•×œ',0),(55461,1541,'el','ÎŸÎ¼Î¬Î´Î± Î½Î± Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½',0),(55462,1541,'zh','ç»„åŒ…æ‹¬\r\n',0),(55463,1541,'sv','Grupp att inkludera',0),(55464,1541,'it','Gruppo di includere',0),(55465,1541,'tl','',0),(55466,1541,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3607;&#3637;&#3656;&#3619;&#3623;&#3617;&#3648;&#3586;&#3657;&#3634;&#3652;&#3623;&#3657;',0),(55467,1541,'hi','à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(55468,1541,'ms','Kumpulan termasuk',0),(55469,1541,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© ØªØ´Ù…Ù„',0),(55470,1541,'fr','Groupe d\'inclure',0),(55471,1541,'jp','å?«ã‚?ã‚‹ã‚°ãƒ«ãƒ¼ãƒ—',0),(55472,1541,'pt','Grupo para incluir',0),(55473,1541,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ',0),(55474,1541,'es','Grupo para Incluir',0),(55475,1541,'de','Aufzunehmende Gruppe',0),(55476,1541,'en','Group to Include',0),(55477,1542,'is','',0),(55478,1542,'dr','Grp.Ú¯Ø±ÙˆÙ‡ ',0),(55479,1542,'pr','Grp.Ú¯Ø±ÙˆÙ‡ \r\n',0),(55480,1542,'tr','Grp.',0),(55481,1542,'pl','GRP.',0),(55482,1542,'bg','GRP.',0),(55483,1542,'ur','Ú¯Ø±Ù¾ Û”',0),(55484,1542,'sr','Ð˜Ð·Ð±Ñ€Ð¸Ñˆ.',0),(55485,1542,'vi','NhÃ³m',0),(55486,1542,'af','GRP.',0),(55487,1542,'ro','GRP.',0),(55488,1542,'et','GRP.',0),(55489,1542,'si','GRP.',0),(55490,1542,'ba','GRP.',0),(55491,1542,'nl','Grp.',0),(55492,1542,'fi','GRP.',0),(55493,1542,'no','Glassfiber.',0),(55494,1542,'da','Grp.',0),(55495,1542,'ko','Grpìž…ë‹ˆë‹¤.',0),(55496,1542,'he','Grp.',0),(55497,1542,'el','GRP.',0),(55498,1542,'zh','ç»„\r\n',0),(55499,1542,'sv','GRP.',0),(55500,1542,'it','GRP.',0),(55501,1542,'tl','',0),(55502,1542,'th','&#3585;&#3621;&#3640;&#3656;&#3617;',0),(55503,1542,'hi','Grp.',0),(55504,1542,'ms','Grp.',0),(55505,1542,'ar','Ø­ÙƒÙˆÙ…Ø© Ø¬Ù…Ù‡ÙˆØ±ÙŠØ© Ø§Ù„ÙÙ„Ø¨ÙŠÙ†.',0),(55506,1542,'fr','GRP.',0),(55507,1542,'jp','Grp.',0),(55508,1542,'pt','GRP.',0),(55509,1542,'ru','Ð’Ð ÐŸ.',0),(55510,1542,'es','Grp.',0),(55511,1542,'de','GRP.',0),(55512,1542,'en','Grp.',0),(55513,1543,'is','',0),(55514,1543,'dr','Ú†Ù‡Ø§Ø±Ù… Ø¬ÙˆÙ„Ø§ÙŠ Ù…Ø¨Ø§Ø±Ùƒ ',0),(55515,1543,'pr','Ú†Ù‡Ø§Ø±Ù… Ø¬ÙˆÙ„Ø§ÙŠ Ù…Ø¨Ø§Ø±Ùƒ ',0),(55516,1543,'tr','Mutlu 4 Temmuz',0),(55517,1543,'pl','SzczÄ™Å›liwy 4 lipca',0),(55518,1543,'bg','Ð§ÐµÑÑ‚Ð¸Ñ‚ 4 ÑŽÐ»Ð¸',0),(55519,1543,'ur','Ø®ÙˆØ´ Ø¬ÙˆÙ„Ø§Ø¦ÛŒ 4',0),(55520,1543,'sr','Ð¡Ñ€ÐµÑ‚Ð°Ð½ 4',0),(55521,1543,'vi','4 thÃ¡ng 7 vui váº»',0),(55522,1543,'af','Voorspoedige 4 Julie',0),(55523,1543,'ro','Happy 4 iulie',0),(55524,1543,'et','Ã•nnelik juuli 4.',0),(55525,1543,'si','SreÄna julija 4.',0),(55526,1543,'ba','Happy Juli 4',0),(55527,1543,'nl','Gelukkig 4 juli',0),(55528,1543,'fi','Happy 4 heinÃ¤kuu',0),(55529,1543,'no','Happy 4 juli',0),(55530,1543,'da','Happy 4 juli',0),(55531,1543,'ko','í–‰ë³µ í•œ 7 ì›” 4 ì¼',0),(55532,1543,'he','×‘-4 ×‘×™×•×œ×™ ×©×ž×—',0),(55533,1543,'el','Happy 4 Î™Î¿Ï…Î»Î¯Î¿Ï…',0),(55534,1543,'zh','7æœˆ4æ—¥å¿«ä¹\r\n',0),(55535,1543,'sv','Glad 4 juli',0),(55536,1543,'it','Felice 4 luglio',0),(55537,1543,'tl','',0),(55538,1543,'th','&#3626;&#3640;&#3586;&#3626;&#3633;&#3609;&#3605;&#3660;&#3623;&#3633;&#3609;&#3594;&#3634;&#3605;&#3636;',0),(55539,1543,'hi','à¤–à¥à¤¶ à¤œà¥à¤²à¤¾à¤ˆ 4',0),(55540,1543,'ms','Happy Julai 4',0),(55541,1543,'ar','Ø³Ø¹ÙŠØ¯ 4 ÙŠÙˆÙ„ÙŠÙˆ',0),(55542,1543,'fr','Le 4 juillet heureux',0),(55543,1543,'jp','ç‹¬ç«‹è¨˜å¿µæ—¥ã?Šã‚?ã?§ã?¨ã?†ã?”ã?–ã?„ã?¾ã?™',0),(55544,1543,'pt','Feliz 4 de julho',0),(55545,1543,'ru','Ð¡ 4 Ð˜ÑŽÐ»Ñ',0),(55546,1543,'es','Feliz 4 de julio',0),(55547,1543,'de','GlÃ¼cklich am 4. Juli',0),(55548,1543,'en','Happy July 4th',0),(55549,1544,'is','',0),(55550,1544,'dr','Ø³Ø§Ù„ Ù†Ùˆ Ù…Ø¨Ø§Ø±Ùƒ ',0),(55551,1544,'pr','Ø³Ø§Ù„ Ù†Ùˆ Ù…Ø¨Ø§Ø±Ùƒ ',0),(55552,1544,'tr','Yeni YÄ±lÄ±nÄ±z Kutlu Olsun',0),(55553,1544,'pl','SzczÄ™Å›liwego Nowego Roku',0),(55554,1544,'bg','Ð§ÐµÑÑ‚Ð¸Ñ‚Ð° ÐÐ¾Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(55555,1544,'ur','Ù†ÙŠØ§ Ø³Ø§Ù„ Ù…Ø¨Ø§Ø±Ú©',0),(55556,1544,'sr','ÑÑ€ÐµÑ›Ð½Ð° Ð½Ð¾Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(55557,1544,'vi','ChÃºc má»«ng nÄƒm má»›i',0),(55558,1544,'af','Voorspoedige Nuwe Jaar',0),(55559,1544,'ro','Un an nou fericit',0),(55560,1544,'et','Head uut aastat',0),(55561,1544,'si','SreÄno novo leto',0),(55562,1544,'ba','Selamat Tahun Baru',0),(55563,1544,'nl','Gelukkig Nieuwjaar',0),(55564,1544,'fi','HyvÃ¤Ã¤ uutta vuotta',0),(55565,1544,'no','Godt nytt Ã¥r',0),(55566,1544,'da','Godt nytÃ¥r',0),(55567,1544,'ko','ìƒˆí•´ ë³µ ë§Žì´ ë°›ìœ¼ì„¸ìš”',0),(55568,1544,'he','×©× ×” ×˜×•×‘×”',0),(55569,1544,'el','Î•Ï…Ï„Ï…Ï‡Î¹ÏƒÎ¼Î­Î½Î¿Ï‚ Î¿ ÎºÎ±Î¹Î½Î¿ÏÏÎ¹Î¿Ï‚ Ï‡ÏÏŒÎ½Î¿Ï‚',0),(55570,1544,'zh','æ–°å¹´å¿«ä¹\r\n',0),(55571,1544,'sv','Gott nytt Ã¥r',0),(55572,1544,'it','Felice Anno Nuovo',0),(55573,1544,'tl','',0),(55574,1544,'th','&#3626;&#3640;&#3586;&#3626;&#3633;&#3609;&#3605;&#3660;&#3623;&#3633;&#3609;&#3611;&#3637;&#3651;&#3627;&#3617;&#3656;',0),(55575,1544,'hi','à¤¨à¤µ à¤µà¤°à¥à¤· à¤•à¥€ à¤¶à¥à¤­à¤•à¤¾à¤®à¤¨à¤¾à¤à¤',0),(55576,1544,'ms','Selamat Tahun Baru',0),(55577,1544,'ar','Ø¹Ø§Ù… Ø¬Ø¯ÙŠØ¯ Ø³Ø¹ÙŠØ¯',0),(55578,1544,'fr','Bonne annÃ©e',0),(55579,1544,'jp','æ–°å¹´æ˜Žã?‘ã?¾ã?—ã?¦ã?Šã‚?ã?§ã?¨ã?†ã?”ã?–ã?„ã?¾ã?™',0),(55580,1544,'pt','Feliz Ano Novo',0),(55581,1544,'ru','Ð¡ ÐÐ¾Ð²Ñ‹Ð¼ Ð“Ð¾Ð´Ð¾Ð¼',0),(55582,1544,'es','Feliz AÃ±o Nuevo',0),(55583,1544,'de','Frohes neues Jahr',0),(55584,1544,'en','Happy New Year',0),(55585,1545,'is','',0),(55586,1545,'dr','Ø³Ø±Ù¾Ø±Ø³Øª Ø®Ø§Ù†ÙˆØ§Ø± ',0),(55587,1545,'pr','Ø³Ø±Ù¾Ø±Ø³Øª Ø®Ø§Ù†ÙˆØ§Ø± ',0),(55588,1545,'tr','Ev baÅŸkanÄ±',0),(55589,1545,'pl','GÅ‚owy gospodarstwa domowego',0),(55590,1545,'bg','Ð“Ð»Ð°Ð²Ð° Ð½Ð° Ð´Ð¾Ð¼Ð°ÐºÐ¸Ð½ÑÑ‚Ð²Ð¾',0),(55591,1545,'ur','Ú¯Ú¾Ø± Ú©Ø§ Ø³Ø±Ø¨Ø±Ø§Û',0),(55592,1545,'sr','Ð“Ð»Ð°Ð²Ð° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ðµ',0),(55593,1545,'vi','LÃ£nh Ä‘áº¡o cá»§a nhÃ ',0),(55594,1545,'af','Hoof van huishouding',0),(55595,1545,'ro','Capul gospodÄƒriei',0),(55596,1545,'et','Perekonna pea',0),(55597,1545,'si','Vodja gospodinjstva',0),(55598,1545,'ba','Kepala rumah tangga',0),(55599,1545,'nl','Hoofd van het huishouden',0),(55600,1545,'fi','Perhekunnan pÃ¤Ã¤mies',0),(55601,1545,'no','Leder av husholdningen',0),(55602,1545,'da','Husstandens overhoved',0),(55603,1545,'ko','ì„¸ëŒ€ ì£¼',0),(55604,1545,'he','×¨××© ×ž×©×§ ×”×‘×™×ª',0),(55605,1545,'el','Î•Ï€Î¹ÎºÎµÏ†Î±Î»Î®Ï‚ Ï„Î¿Ï… Î½Î¿Î¹ÎºÎ¿ÎºÏ…ÏÎ¹Î¿Ï',0),(55606,1545,'zh','æˆ·ä¸»\r\n',0),(55607,1545,'sv','Familjens Ã¶verhuvud',0),(55608,1545,'it','Capo famiglia',0),(55609,1545,'tl','',0),(55610,1545,'th','&#3627;&#3640;&#3657;&#3609;&#3626;&#3656;&#3623;&#3609;&#3651;&#3627;&#3597;&#3656;',0),(55611,1545,'hi','à¤˜à¤° à¤•à¥‡ à¤ªà¥à¤°à¤§à¤¾à¤¨',0),(55612,1545,'ms','Ketua isi rumah',0),(55613,1545,'ar','Ø±Ø¨ Ø§Ù„Ø£Ø³Ø±Ø©',0),(55614,1545,'fr','Chef de mÃ©nage',0),(55615,1545,'jp','ä¸–å¸¯ä¸»',0),(55616,1545,'pt','Chefe de famÃ­lia',0),(55617,1545,'ru','Ð“Ð»Ð°Ð²Ð° Ð´Ð¾Ð¼Ð¾Ñ…Ð¾Ð·ÑÐ¹ÑÑ‚Ð²Ð°',0),(55618,1545,'es','Amo/a de Casa',0),(55619,1545,'de','Haushaltsvorstand',0),(55620,1545,'en','Head of household',0),(55621,1546,'is','',0),(55622,1546,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§',0),(55623,1546,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§',0),(55624,1546,'tr','YardÄ±m',0),(55625,1546,'pl','Pomoc',0),(55626,1546,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰',0),(55627,1546,'ur','Ù…Ø¯Ø¯',0),(55628,1546,'sr','ÐŸÐ¾Ð¼Ð¾Ñ›',0),(55629,1546,'vi','Trá»£ GiÃºp',0),(55630,1546,'af','Hulp',0),(55631,1546,'ro','Ajutor',0),(55632,1546,'et','Abi',0),(55633,1546,'si','pomoÄ',0),(55634,1546,'ba','Tolong',0),(55635,1546,'nl','Help',0),(55636,1546,'fi','Apua',0),(55637,1546,'no','hjelp',0),(55638,1546,'da','HjÃ¦lp',0),(55639,1546,'ko','ë„ì›€ë§',0),(55640,1546,'he','×¢×–×¨×”',0),(55641,1546,'el','Î’Î¿Î®Î¸ÎµÎ¹Î±',0),(55642,1546,'zh','å¸®åŠ©\r\n',0),(55643,1546,'sv','HjÃ¤lp',0),(55644,1546,'it','Guida',0),(55645,1546,'tl','',0),(55646,1546,'th','&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(55647,1546,'hi','à¤®à¤¦à¤¦',0),(55648,1546,'ms','Membantu',0),(55649,1546,'ar','Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø©',0),(55650,1546,'fr','Aide',0),(55651,1546,'jp','ãƒ˜ãƒ«ãƒ—',0),(55652,1546,'pt','Ajuda',0),(55653,1546,'ru','ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ',0),(55654,1546,'es','Ayuda',0),(55655,1546,'de','Hilfe',0),(55656,1546,'en','Help',0),(55657,1547,'is','',0),(55658,1547,'dr','Ù…ÙˆÙ„ÙÙ‡ Ø±Ø§Ù‡Ù†Ù…Ø§ Ù†ØµØ¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª  ',0),(55659,1547,'pr','Ù…ÙˆÙ„ÙÙ‡ Ø±Ø§Ù‡Ù†Ù…Ø§ Ù†ØµØ¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª  ',0),(55660,1547,'tr','YardÄ±m modÃ¼l yÃ¼klÃ¼ deÄŸil!',0),(55661,1547,'pl','Pomoc moduÅ‚ nie jest zainstalowany!',0),(55662,1547,'bg','ÐœÐ¾Ð´ÑƒÐ» Ð·Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð½Ðµ Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½!',0),(55663,1547,'ur','Ù…Ø¯Ø¯ Ù…Ø§ÚˆÛŒÙˆÙ„ ØªÙ†ØµÛŒØ¨ Ù†ÛÛŒÚº ÛÛ’!',0),(55664,1547,'sr','ÐœÐ¾Ð´ÑƒÐ» Ð·Ð° Ð¿Ð¾Ð¼Ð¾Ñ› Ð½Ð¸Ñ˜Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½Ð°!',0),(55665,1547,'vi','Trá»£ giÃºp chÆ°a cÃ i Ä‘áº·t',0),(55666,1547,'af','Die Hulp Module is nie geinstalleer nie!',0),(55667,1547,'ro','Modul de ajutor nu este instalat!',0),(55668,1547,'et','Abimoodul pole installitud!',0),(55669,1547,'si','PomoÄ modul ni nameÅ¡Äen!',0),(55670,1547,'ba','Bantuan modul tidak terpasang!',0),(55671,1547,'nl','Help-module is niet geÃ¯nstalleerd!',0),(55672,1547,'fi','Apua moduulia ei ole asennettu!',0),(55673,1547,'no','Hjelp-modulen er ikke installert!',0),(55674,1547,'da','HjÃ¦lp-modulet er ikke installeret!',0),(55675,1547,'ko','ë„ì›€ë§ ëª¨ë“ˆì„ ì„¤ì¹˜ í•˜ì§€!',0),(55676,1547,'he','×¢×–×¨×” ×ž×•×“×•×œ ××™× ×• ×ž×•×ª×§×Ÿ!',0),(55677,1547,'el','Î•Î½ÏŒÏ„Î·Ï„Î± Î²Î¿Î®Î¸ÎµÎ¹Î± Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÎµÎ³ÎºÎ±Ï„ÎµÏƒÏ„Î·Î¼Î­Î½Î¿!',0),(55678,1547,'zh','å¸®åŠ©æ¨¡å—æ²¡æœ‰å®‰è£…å¥½äº†ï¼\r\n',0),(55679,1547,'sv','HjÃ¤lp-modulen Ã¤r inte installerad!',0),(55680,1547,'it','Aiuto modulo non Ã¨ installato!',0),(55681,1547,'tl','',0),(55682,1547,'th','&#3650;&#3617;&#3604;&#3641;&#3621;&#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;',0),(55683,1547,'hi','à¤®à¤¦à¤¦ à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤¸à¥à¤¥à¤¾à¤ªà¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ!',0),(55684,1547,'ms','Modul bantuan tidak dipasang!',0),(55685,1547,'ar','Ù„Ù… ÙŠØªÙ… ØªØ«Ø¨ÙŠØª Ø§Ù„ÙˆØ­Ø¯Ø© Ø§Ù„Ù†Ù…Ø·ÙŠØ© Ù„Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª!',0),(55686,1547,'fr','Module d\'aide n\'est pas installÃ© !',0),(55687,1547,'jp','ãƒ˜ãƒ«ãƒ—ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã?Œã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(55688,1547,'pt','MÃ³dulo de ajuda nÃ£o estÃ¡ instalado!',0),(55689,1547,'ru','ÐœÐ¾Ð´ÑƒÐ»ÑŒ Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð½Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð»Ð¸Ñ€Ð¾Ð²Ð°Ð½!',0),(55690,1547,'es','MÃ³dulo de Ayuda no esta instalado',0),(55691,1547,'de','Hilfemodul ist nicht installiert!',0),(55692,1547,'en','Help module is not installed!',0),(55693,1548,'is','',0),(55694,1548,'dr','Ù…Ø¯Ù„  Ø±Ø§Ù‡Ù†Ù…Ø§ Ø¯Ø± Ù…Ø¯Ù„ Ø¬Ø¯ÙˆÙ„ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(55695,1548,'pr','Ù…Ø¯Ù„  Ø±Ø§Ù‡Ù†Ù…Ø§ Ø¯Ø± Ù…Ø¯Ù„ Ø¬Ø¯ÙˆÙ„ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(55696,1548,'tr','ModÃ¼l <B>modÃ¼ller</B> tabloya eklenen yardÄ±m.',0),(55697,1548,'pl','ModuÅ‚ pomocy wstawione do tabela <B>moduÅ‚Ã³w</B> .',0),(55698,1548,'bg','ÐœÐ¾Ð´ÑƒÐ» Ð·Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰, Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð² Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° <B>Ð¼Ð¾Ð´ÑƒÐ»Ð¸</B> .',0),(55699,1548,'ur','Ù…Ø¯Ø¯ Ù…Ø§ÚˆÛŒÙˆÙ„ <B>Ù…Ø§ÚˆÛŒÙˆÙ„</B> Ø¬Ø¯ÙˆÙ„ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(55700,1548,'sr','ÐŸÐ¾Ð¼Ð¾Ñ› Ð¼Ð¾Ð´ÑƒÐ»Ð° ÑƒÐ¼ÐµÑ›Ñƒ Ñƒ <B>Ð¼Ð¾Ð´ÑƒÐ»Ðµ</B> Ñ‚Ð°Ð±ÐµÐ»Ðµ.',0),(55701,1548,'vi','Trá»£ giÃºp Ä‘Ã£ thÃªm vÃ o báº£ng <B>modules</B>.',0),(55702,1548,'af','Hulp module is ingevoer binne <B>modules</B> tabel.',0),(55703,1548,'ro','Ajutorul modulului inserate Ã®n tabelul de <B>module</B> .',0),(55704,1548,'et','Abimoodul <B>moodulite</B> tabeli lisada.',0),(55705,1548,'si','PomoÄ modul v tabeli <B>modulov</B> .',0),(55706,1548,'ba','Membantu modul yang dimasukkan ke dalam tabel <B>modul</B> .',0),(55707,1548,'nl','Help module in <B>modules</B> tabel ingevoegd.',0),(55708,1548,'fi','Apua moduuli lisÃ¤tÃ¤Ã¤n <B>moduulit</B> taulukkoon.',0),(55709,1548,'no','Hjelpemodul inn <B>moduler</B> tabell.',0),(55710,1548,'da','HjÃ¦lp modul indsat i <B>moduler</B> tabel.',0),(55711,1548,'ko','ë„ì›€ë§ ëª¨ë“ˆ <B>ëª¨ë“ˆ</B> í…Œì´ë¸”ì— ì‚½ìž… í•©ë‹ˆë‹¤.',0),(55712,1548,'he','×¢×–×¨×” ×ž×•×“×•×œ ×ž×•×›× ×¡ ×œ×ª×•×š ×˜×‘×œ×” <B>×ž×•×“×•×œ×™×</B> .',0),(55713,1548,'el','Î’Î¿Î®Î¸ÎµÎ¹Î± ÎµÎ½ÏŒÏ„Î·Ï„Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Î±Î¹ <B>ÎµÎ½ÏŒÏ„Î·Ï„ÎµÏ‚</B> Ï€Î¯Î½Î±ÎºÎ±.',0),(55714,1548,'zh','å¸®åŠ©æ¨¡å—åˆ°æ¨¡å—çš„<b>æ’å…¥â€œè¡¨æ ¼ã€‚\r\n',0),(55715,1548,'sv','HjÃ¤lp modul in i <B>moduler</B> tabell.',0),(55716,1548,'it','Aiuto modulo inserito nella tabella dei <B>moduli</B> .',0),(55717,1548,'tl','',0),(55718,1548,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3650;&#3617;&#3604;&#3641;&#3621;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3626;&#3641;&#3656;&#3605;&#3634;&#3619;&#3634;&#3591;',0),(55719,1548,'hi','à¤®à¤¦à¤¦ à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² <B>à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤²</B> à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤®à¥‡à¤‚ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤¿à¤ à¤—à¤à¥¤',0),(55720,1548,'ms','Modul bantuan yang dimasukkan ke dalam Jadual <B>modul</B> .',0),(55721,1548,'ar','ØªØ³Ø§Ø¹Ø¯ ÙˆØ­Ø¯Ø© Ø¥Ø¯Ø±Ø§Ø¬ ÙÙŠ Ø¬Ø¯ÙˆÙ„ <B>Ø§Ù„ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù†Ù…Ø·ÙŠØ©</B> .',0),(55722,1548,'fr','Aide module insÃ©rÃ©e dans la table de <B>modules</B> .',0),(55723,1548,'jp','ãƒ˜ãƒ«ãƒ—ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã?Œ<B>ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«</B>è¡¨ã?¸æŒ¿å…¥ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(55724,1548,'pt','Ajuda mÃ³dulo inserido na tabela de <B>mÃ³dulos</B> .',0),(55725,1548,'ru','ÐœÐ¾Ð´ÑƒÐ»ÑŒ Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð²ÑÑ‚Ð°Ð²Ð»ÐµÐ½ Ð² <B>modules</B> Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñƒ.',0),(55726,1548,'es','MÃ³dulo de ayuda insertado en<B>mÃ³dulos</B> Tabla.',0),(55727,1548,'de','Hilfemodul in <B>Module</B> -Tabelle eingefÃ¼gt.',0),(55728,1548,'en','Help module inserted into <B>modules</B> table.',0),(55729,1549,'is','',0),(55730,1549,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ ØªÙ†Ø¸ÙŠÙ… ',0),(55731,1549,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ ØªÙ†Ø¸ÙŠÙ… ',0),(55732,1549,'tr','Kurulum YardÄ±mÄ±',0),(55733,1549,'pl','Pomoc instalacji',0),(55734,1549,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ Ð·Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(55735,1549,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù…Ø¯Ø¯',0),(55736,1549,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ð¾Ð½Ð¸ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸',0),(55737,1549,'vi','Setup trá»£ giÃºp',0),(55738,1549,'af','Hulp Opstelling',0),(55739,1549,'ro','Ajutor configurare',0),(55740,1549,'et','Abiinfo seadistamine',0),(55741,1549,'si','PomoÄ Setup',0),(55742,1549,'ba','Bantuan Setup',0),(55743,1549,'nl','Help Setup',0),(55744,1549,'fi','Apua Setup',0),(55745,1549,'no','Hjelp for oppsett',0),(55746,1549,'da','HjÃ¦lp til opsÃ¦tning',0),(55747,1549,'ko','ë„ì›€ë§ ì„¤ì¹˜',0),(55748,1549,'he','×¢×–×¨×” ×”×ª×§× ×ª',0),(55749,1549,'el','Î’Î¿Î®Î¸ÎµÎ¹Î± ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(55750,1549,'zh','å¸®åŠ©å®‰è£…\r\n',0),(55751,1549,'sv','HjÃ¤lp Setup',0),(55752,1549,'it','Guida di installazione',0),(55753,1549,'tl','',0),(55754,1549,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(55755,1549,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤®à¤¦à¤¦',0),(55756,1549,'ms','Membantu persediaan',0),(55757,1549,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø©',0),(55758,1549,'fr','Aide configuration',0),(55759,1549,'jp','ãƒ˜ãƒ«ãƒ—ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(55760,1549,'pt','Ajuda de instalaÃ§Ã£o',0),(55761,1549,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° ÐŸÐ¾Ð¼Ð¾Ñ‰Ð¸',0),(55762,1549,'es','ConfiguraciÃ³n de Ayuda',0),(55763,1549,'de','Hilfe-Setup',0),(55764,1549,'en','Help Setup',0),(55765,1550,'is','',0),(55766,1550,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ Ù…ØªÙ† ',0),(55767,1550,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ Ù…ØªÙ† ',0),(55768,1550,'tr','YardÄ±m metni',0),(55769,1550,'pl','Tekst pomocy',0),(55770,1550,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ÐµÐ½ Ñ‚ÐµÐºÑÑ‚',0),(55771,1550,'ur','Ù…Ø¯Ø¯ Ù…ØªÙ†',0),(55772,1550,'sr','Ð¢ÐµÐºÑÑ‚ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸',0),(55773,1550,'vi','Ná»™i dung trá»£ giÃºp',0),(55774,1550,'af','Hulp teks',0),(55775,1550,'ro','Textul de ajutor',0),(55776,1550,'et','Ekraani allÃ¤Ã¤res nÃ¤idatav abitekst',0),(55777,1550,'si','Besedilo pomoÄi',0),(55778,1550,'ba','Membantu teks',0),(55779,1550,'nl','Help-tekst',0),(55780,1550,'fi','Ohjeteksti',0),(55781,1550,'no','Hjelp',0),(55782,1550,'da','HjÃ¦lp-tekst',0),(55783,1550,'ko','ë„ì›€ë§ í…ìŠ¤íŠ¸',0),(55784,1550,'he','×˜×§×¡×˜ ×¢×–×¨×”',0),(55785,1550,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Î²Î¿Î®Î¸ÎµÎ¹Î±Ï‚',0),(55786,1550,'zh','è¯´æ˜Žæ–‡å­—\r\n',0),(55787,1550,'sv','HjÃ¤lptext',0),(55788,1550,'it','Testo della guida',0),(55789,1550,'tl','',0),(55790,1550,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(55791,1550,'hi','à¤®à¤¦à¤¦ à¤ªà¤¾à¤ ',0),(55792,1550,'ms','Teks bantuan',0),(55793,1550,'ar','Ù†Øµ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(55794,1550,'fr','Texte d\'aide',0),(55795,1550,'jp','ãƒ˜ãƒ«ãƒ—ãƒ†ã‚­ã‚¹ãƒˆ',0),(55796,1550,'pt','Texto de ajuda',0),(55797,1550,'ru','Ð¢ÐµÐºÑÑ‚ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸',0),(55798,1550,'es','Texto de Ayuda',0),(55799,1550,'de','Hilfetext',0),(55800,1550,'en','Help text',0),(55801,1551,'is','',0),(55802,1551,'dr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† ØªÙÙƒÙŠÙƒ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡  ',0),(55803,1551,'pr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† ØªÙÙƒÙŠÙƒ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡  ',0),(55804,1551,'tr','Costcenter Breakdown sakla',0),(55805,1551,'pl','Ukryj podziaÅ‚ funkcja',0),(55806,1551,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Costcenter Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(55807,1551,'ur','Ú©ÙˆØ³Ù¹Ú©Ø§Ù†Ù¹ÛŒØ± Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(55808,1551,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð¦Ð¾ÑÑ‚Ñ†ÐµÐ½Ñ‚ÐµÑ€ ÑÐ»Ð¾Ð¼',0),(55809,1551,'vi','Giáº¥u Chi Tiáº¿t Cost Center',0),(55810,1551,'af','Verberg Koste Sentrum Ontleding',0),(55811,1551,'ro','Ascunde Costcenter defalcare',0),(55812,1551,'et','Peida Costcenter jaotus',0),(55813,1551,'si','Skriti Costcenter razÄlenitev',0),(55814,1551,'ba','Sembunyikan rincian Costcenter',0),(55815,1551,'nl','Costcenter verdeling te verbergen',0),(55816,1551,'fi','Piilota Costcenter erittely',0),(55817,1551,'no','Skjul Costcenter sammenbrudd',0),(55818,1551,'da','Skjule Costcenter opdeling',0),(55819,1551,'ko','Costcenter ì‹ ê²½ ì‡  ì•½ ì¦ì„¸ë¥¼ ìˆ¨ê¸°ê¸°',0),(55820,1551,'he','×”×¡×ª×¨ ×¤×™×¨×•×˜ Costcenter',0),(55821,1551,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Costcenter ÎºÎ±Ï„Î±Î½Î¿Î¼Î®',0),(55822,1551,'zh','éšè—æˆæœ¬ä¸­å¿ƒåˆ’åˆ†\r\n',0),(55823,1551,'sv','DÃ¶lja Costcenter fÃ¶rdelning',0),(55824,1551,'it','Nascondere il centro guasto',0),(55825,1551,'tl','',0),(55826,1551,'th','&#3595;&#3656;&#3629;&#3609;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3648;&#3610;&#3619;&#3588;&#3604;&#3634;&#3623;&#3609;&#3660;',0),(55827,1551,'hi','Costcenter à¤Ÿà¥‚à¤Ÿà¤¨à¥‡ à¤›à¥à¤ªà¤¾à¤à¤',0),(55828,1551,'ms','Menyembunyikan kerosakan Costcenter',0),(55829,1551,'ar','Ø¥Ø®ÙØ§Ø¡ ØªÙØ§ØµÙŠÙ„ ÙƒÙˆØ³ØªØ³ÙŠÙ†ØªÙŠØ±',0),(55830,1551,'fr','Cacher Costcenter ventilation',0),(55831,1551,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼å†…è¨³ã‚’ã?‹ã??ã?™',0),(55832,1551,'pt','Esconder Costcenter avaria',0),(55833,1551,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Costcenter Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(55834,1551,'es','Esconder Detalle de Centro de Costos',0),(55835,1551,'de','Ausblenden Costcenter AufschlÃ¼sselung',0),(55836,1551,'en','Hide Costcenter Breakdown',0),(55837,1552,'is','',0),(55838,1552,'dr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ',0),(55839,1552,'pr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ',0),(55840,1552,'tr','Maliyetleri gizle',0),(55841,1552,'pl','Ukryj kosztÃ³w',0),(55842,1552,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(55843,1552,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(55844,1552,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(55845,1552,'vi','Giáº¥u GiÃ¡ ThÃ nh',0),(55846,1552,'af','Verberg Kostes',0),(55847,1552,'ro','Ascunde costurile',0),(55848,1552,'et','Peida kulud',0),(55849,1552,'si','Skriti stroÅ¡ki',0),(55850,1552,'ba','Menyembunyikan biaya',0),(55851,1552,'nl','Kosten verbergen',0),(55852,1552,'fi','Piilota kustannukset',0),(55853,1552,'no','Skjule kostnader',0),(55854,1552,'da','Skjule omkostninger',0),(55855,1552,'ko','ë¹„ìš©ì„ ìˆ¨ê¸°ê¸°',0),(55856,1552,'he','×œ×”×¡×ª×™×¨ ××ª ×¢×œ×•×™×•×ª',0),(55857,1552,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÎºÏŒÏƒÏ„Î¿Ï‚',0),(55858,1552,'zh','éšè—æˆæœ¬\r\n',0),(55859,1552,'sv','DÃ¶lja kostnader',0),(55860,1552,'it','Nascondere i costi',0),(55861,1552,'tl','',0),(55862,1552,'th','&#3595;&#3656;&#3629;&#3609;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(55863,1552,'hi','à¤²à¤¾à¤—à¤¤ à¤›à¥à¤ªà¤¾à¤à¤',0),(55864,1552,'ms','Menyembunyikan kos',0),(55865,1552,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(55866,1552,'fr','Masquer les coÃ»ts',0),(55867,1552,'jp','ã‚³ã‚¹ãƒˆã‚’ã?‹ã??ã?™',0),(55868,1552,'pt','Esconder os custos',0),(55869,1552,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(55870,1552,'es','Esconder Costos',0),(55871,1552,'de','Verstecken Kosten',0),(55872,1552,'en','Hide Costs',0),(55873,1553,'is','',0),(55874,1553,'dr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† ØªØµØ§ÙˆÙŠØ± ',0),(55875,1553,'pr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† ØªØµØ§ÙˆÙŠØ± ',0),(55876,1553,'tr','Resimleri gizleme',0),(55877,1553,'pl','Schowaj Obrazki',0),(55878,1553,'bg','Ð¡ÐºÑ€Ð¸Ð¹ ÑÐ½Ð¸Ð¼ÐºÐ¸',0),(55879,1553,'ur','ØªØµØ§ÙˆÛŒØ± Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(55880,1553,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÑÐ»Ð¸ÐºÐµ',0),(55881,1553,'vi','Giáº¥u tranh',0),(55882,1553,'af','Verberg Prente',0),(55883,1553,'ro','Ascunde imagini',0),(55884,1553,'et','Peida pildid',0),(55885,1553,'si','Skriti slike',0),(55886,1553,'ba','Sembunyikan gambar',0),(55887,1553,'nl','Afbeeldingen verbergen',0),(55888,1553,'fi','Piilota kuvat',0),(55889,1553,'no','Skjule bilder',0),(55890,1553,'da','Skjule billeder',0),(55891,1553,'ko','ì‚¬ì§„ ìˆ¨ê¸°ê¸°',0),(55892,1553,'he','×”×¡×ª×¨ ×ª×ž×•× ×•×ª',0),(55893,1553,'el','Î‘Ï€Î¿ÎºÏÏÏˆÎµÏ„Îµ Ï„Î¹Ï‚ Ï†Ï‰Ï„Î¿Î³ÏÎ±Ï†Î¯ÎµÏ‚',0),(55894,1553,'zh','éšè—å›¾ç‰‡\r\n',0),(55895,1553,'sv','DÃ¶lja bilder',0),(55896,1553,'it','Nascondere immagini',0),(55897,1553,'tl','',0),(55898,1553,'th','&#3595;&#3656;&#3629;&#3609;&#3619;&#3641;&#3611;&#3616;&#3634;&#3614;',0),(55899,1553,'hi','à¤šà¤¿à¤¤à¥à¤°à¥‹à¤‚ à¤•à¥‹ à¤›à¤¿à¤ªà¤¾à¤¨à¥‡',0),(55900,1553,'ms','Menyembunyikan gambar',0),(55901,1553,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„ØµÙˆØ±',0),(55902,1553,'fr','Masquer les images',0),(55903,1553,'jp','ç”»åƒ?ã‚’ã?‹ã??ã?™',0),(55904,1553,'pt','Ocultar imagens',0),(55905,1553,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÐºÐ°Ñ€Ñ‚Ð¸Ð½ÐºÐ¸',0),(55906,1553,'es','Esconder Cuadros',0),(55907,1553,'de','Ausblenden von Bildern',0),(55908,1553,'en','Hide Pictures',0),(55909,1554,'is','',0),(55910,1554,'dr','Ø¢ÙŠØ§ Ø²Ù…Ø§Ù† Ú†Ø§Ù¾ Ù…Ø®ÙÙŠ Ø¨Ø§Ø´Ø¯ØŸ',0),(55911,1554,'pr','Ø¢ÙŠØ§ Ø²Ù…Ø§Ù† Ú†Ø§Ù¾ Ù…Ø®ÙÙŠ Ø¨Ø§Ø´Ø¯ØŸ',0),(55912,1554,'tr','YazdÄ±rÄ±rken gizlemek?',0),(55913,1554,'pl','Ukryj podczas drukowania?',0),(55914,1554,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚?',0),(55915,1554,'ur','Ú†Ú¾Ù¾Ø§ Ø¯ÛŒÚº Ø¬Ø¨ Ú†Ú¾Ø§Ù¾ Ø±ÛØ§ ÛÛ’ØŸ',0),(55916,1554,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ°?',0),(55917,1554,'vi','Giáº¥u khi in?',0),(55918,1554,'af','Verberg wanneer gedruk word?',0),(55919,1554,'ro','Ascunde atunci cÃ¢nd imprimarea?',0),(55920,1554,'et','Peida kui printimise?',0),(55921,1554,'si','KoÅ¾a pri tiskanju?',0),(55922,1554,'ba','Menyembunyikan ketika mencetak?',0),(55923,1554,'nl','Verbergen bij het afdrukken?',0),(55924,1554,'fi','Piilottaminen tulostettaessa?',0),(55925,1554,'no','Skjule utskrifter?',0),(55926,1554,'da','Skjul nÃ¥r der udskrives?',0),(55927,1554,'ko','ì¸ì‡„í•  ë•Œ ìˆ¨ê¸°ëŠ”?',0),(55928,1554,'he','×œ×”×¡×ª×™×¨ ×‘×¢×ª ×”×“×¤×¡×”?',0),(55929,1554,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·;',0),(55930,1554,'zh','åœ¨æ‰“å°æ—¶éšè—ï¼Ÿ\r\n',0),(55931,1554,'sv','DÃ¶lja vid utskrift?',0),(55932,1554,'it','Nascondere quando si stampa?',0),(55933,1554,'tl','',0),(55934,1554,'th','&#3595;&#3656;&#3629;&#3609;&#3586;&#3603;&#3632;&#3585;&#3635;&#3621;&#3633;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(55935,1554,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¤°à¤¤à¥‡ à¤¸à¤®à¤¯ à¤›à¤¿à¤ªà¤¾à¤à¤?',0),(55936,1554,'ms','Sembunyi apabila mencetak?',0),(55937,1554,'ar','Ø¥Ø®ÙØ§Ø¡ Ø¹Ù†Ø¯ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©ØŸ',0),(55938,1554,'fr','Cacher lors de l\'impression ?',0),(55939,1554,'jp','å?°åˆ·ä¸­ã?‹ã??ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(55940,1554,'pt','Esconder-se quando a impressÃ£o?',0),(55941,1554,'ru','Ð¡Ð¿Ñ€ÑÑ‚Ð°Ñ‚ÑŒ Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸?',0),(55942,1554,'es','Â¿Esconder cuando imprimir?',0),(55943,1554,'de','Beim Drucken ausblenden?',0),(55944,1554,'en','Hide when printing?',0),(55945,1555,'is','',0),(55946,1555,'dr','Ø²ÙŠØ§Ø¯ ',0),(55947,1555,'pr','Ø²ÙŠØ§Ø¯ ',0),(55948,1555,'tr','YÃ¼ksek',0),(55949,1555,'pl','Wysokie',0),(55950,1555,'bg','Ð’Ð¸ÑÐ¾ÐºÐ¾',0),(55951,1555,'ur','Ø§Ø¹Ù„ÛŒ',0),(55952,1555,'sr','Ð’Ð¸ÑÐ¾ÐºÐ¾',0),(55953,1555,'vi','Cao',0),(55954,1555,'af','Hoog',0),(55955,1555,'ro','Mare',0),(55956,1555,'et','KÃµrge',0),(55957,1555,'si','Visoko',0),(55958,1555,'ba','Tinggi',0),(55959,1555,'nl','Hoge',0),(55960,1555,'fi','Korkea',0),(55961,1555,'no','HÃ¸y',0),(55962,1555,'da','HÃ¸j',0),(55963,1555,'ko','ë†’ì€',0),(55964,1555,'he','×’×‘×•×”×”',0),(55965,1555,'el','Î¥ÏˆÎ·Î»Î®',0),(55966,1555,'zh','é«˜\r\n',0),(55967,1555,'sv','HÃ¶g',0),(55968,1555,'it','Alta',0),(55969,1555,'tl','',0),(55970,1555,'th','&#3588;&#3623;&#3634;&#3617;&#3626;&#3641;&#3591;',0),(55971,1555,'hi','à¤‰à¤šà¥à¤š',0),(55972,1555,'ms','Tinggi',0),(55973,1555,'ar','Ø¹Ø§Ù„ÙŠØ©',0),(55974,1555,'fr','Haute',0),(55975,1555,'jp','é«˜ã?„',0),(55976,1555,'pt','Alta',0),(55977,1555,'ru','Ð’Ñ‹ÑÐ¾ÐºÐ°Ñ',0),(55978,1555,'es','Alto',0),(55979,1555,'de','Hohe',0),(55980,1555,'en','High',0),(55981,1556,'is','',0),(55982,1556,'dr','ØªØ§Ø±ÙŠØ® Ø§Ø¬Ø§Ø±Ù‡',0),(55983,1556,'pr','ØªØ§Ø±ÙŠØ® Ø§Ø¬Ø§Ø±Ù‡',0),(55984,1556,'tr','Ä°ÅŸe alma tarihi',0),(55985,1556,'pl','Data zatrudnienia',0),(55986,1556,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾ÑÑ‚ÑŠÐ¿Ð²Ð°Ð½Ðµ',0),(55987,1556,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø®Ø¯Ù…Ø§Øª Ø­Ø§ØµÙ„',0),(55988,1556,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð¿Ð¾ÑˆÑ™Ð°Ð²Ð°ÑšÐ°',0),(55989,1556,'vi','NgÃ y thuÃª',0),(55990,1556,'af','Aanstellingsdatum',0),(55991,1556,'ro','Data de Ã®nchiriere',0),(55992,1556,'et','Palkamise kuupÃ¤ev',0),(55993,1556,'si','Datum zaposlitve',0),(55994,1556,'ba','Penyewaan tanggal',0),(55995,1556,'nl','Datum indiensttreding',0),(55996,1556,'fi','TyÃ¶suhteen alkamispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(55997,1556,'no','Ansettelsesdato',0),(55998,1556,'da','AnsÃ¦ttelsesdato',0),(55999,1556,'ko','ìž…ì‚¬ ë‚ ì§œ',0),(56000,1556,'he','×ª××¨×™×š ×”×¢×¡×§×”',0),(56001,1556,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€ÏÏŒÏƒÎ»Î·ÏˆÎ·Ï‚',0),(56002,1556,'zh','è˜ç”¨æ—¥æœŸ\r\n',0),(56003,1556,'sv','AnstÃ¤llningsdatum',0),(56004,1556,'it','Data di assunzione',0),(56005,1556,'tl','',0),(56006,1556,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3657;&#3634;&#3591; ',0),(56007,1556,'hi','à¤²à¥‡à¤¨à¥‡ à¤•à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(56008,1556,'ms','Tarikh sewa',0),(56009,1556,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙˆØ¸ÙŠÙ',0),(56010,1556,'fr','Date d\'embauche',0),(56011,1556,'jp','é›‡ç”¨æ—¥',0),(56012,1556,'pt','Data de contrataÃ§Ã£o',0),(56013,1556,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ñ€Ð¸ÐµÐ¼Ð° Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(56014,1556,'es','Fecha de emplear',0),(56015,1556,'de','Einstellungsdatum',0),(56016,1556,'en','Hire Date',0),(56017,1557,'is','',0),(56018,1557,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡',0),(56019,1557,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡',0),(56020,1557,'tr','GeÃ§miÅŸ',0),(56021,1557,'pl','Historia',0),(56022,1557,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(56023,1557,'ur','ØªØ§Ø±ÛŒØ®',0),(56024,1557,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð°',0),(56025,1557,'vi','Lá»‹ch sá»­ ',0),(56026,1557,'af','Geskiedenis',0),(56027,1557,'ro','Istorie',0),(56028,1557,'et','Ajalugu',0),(56029,1557,'si','Zgodovina',0),(56030,1557,'ba','Sejarah',0),(56031,1557,'nl','Geschiedenis',0),(56032,1557,'fi','Historia',0),(56033,1557,'no','Historie',0),(56034,1557,'da','Historie',0),(56035,1557,'ko','ì—­ì‚¬',0),(56036,1557,'he','×”×™×¡×˜×•×¨×™×”',0),(56037,1557,'el','Î™ÏƒÏ„Î¿ÏÎ¯Î±',0),(56038,1557,'zh','åŽ†å²\r\n',0),(56039,1557,'sv','Historia',0),(56040,1557,'it','Storia',0),(56041,1557,'tl','',0),(56042,1557,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3624;&#3634;&#3626;&#3605;&#3619;&#3660;',0),(56043,1557,'hi','à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(56044,1557,'ms','Sejarah',0),(56045,1557,'ar','Ø§Ù„Ø­Ø±ÙƒØ©',0),(56046,1557,'fr','Histoire',0),(56047,1557,'jp','å±¥æ­´',0),(56048,1557,'pt','HistÃ³ria',0),(56049,1557,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(56050,1557,'es','Historia',0),(56051,1557,'de','Geschichte',0),(56052,1557,'en','History',0),(56053,1558,'is','',0),(56054,1558,'dr','Ù†Ú¯Ù‡Ø¯Ø§Ø´ØªÙ†',0),(56055,1558,'pr','Ù†Ú¯Ù‡Ø¯Ø§Ø´ØªÙ†',0),(56056,1558,'tr','BasÄ±lÄ± tutun',0),(56057,1558,'pl','Przytrzymaj',0),(56058,1558,'bg','Ð—Ð°Ð´Ñ€ÑŠÐ¶Ñ‚Ðµ',0),(56059,1558,'ur','Ù¾Ú©Ú‘',0),(56060,1558,'sr','Ð”Ñ€Ð¶Ð¸Ñ‚Ðµ',0),(56061,1558,'vi','(NhÆ°ng)',0),(56062,1558,'af','Hou',0),(56063,1558,'ro','Å¢ineÅ£i',0),(56064,1558,'et','Hoidke',0),(56065,1558,'si','DrÅ¾ite',0),(56066,1558,'ba','Terus',0),(56067,1558,'nl','Houd',0),(56068,1558,'fi','PidÃ¤',0),(56069,1558,'no','Hold',0),(56070,1558,'da','Hold',0),(56071,1558,'ko','ë³´ë¥˜',0),(56072,1558,'he','. ×ª×—×–×™×§',0),(56073,1558,'el','ÎšÏÎ±Ï„Î®ÏƒÏ„Îµ',0),(56074,1558,'zh','ï¼ˆä¿æŒï¼‰\r\n',0),(56075,1558,'sv','HÃ¥ll',0),(56076,1558,'it','Tenere',0),(56077,1558,'tl','',0),(56078,1558,'th','(&#3605;&#3633;&#3623;&#3627;&#3609;&#3634;)',0),(56079,1558,'hi','à¤ªà¤•à¤¡à¤¼à¥‹',0),(56080,1558,'ms','Memegang',0),(56081,1558,'ar','Ø¹Ù‚Ø¯',0),(56082,1558,'fr','Cale',0),(56083,1558,'jp','ä¿?ç•™',0),(56084,1558,'pt','Segure',0),(56085,1558,'ru','Ð£Ð´ÐµÑ€Ð¶Ð¸Ð²Ð°Ð¹Ñ‚Ðµ',0),(56086,1558,'es','(Guardar)',0),(56087,1558,'de','Halten',0),(56088,1558,'en','Hold',0),(56089,1559,'is','',0),(56090,1559,'dr','Ø®Ø§Ù†Ù‡ ',0),(56091,1559,'pr','Ø®Ø§Ù†Ù‡ ',0),(56092,1559,'tr','Ana sayfa',0),(56093,1559,'pl','Strona gÅ‚Ã³wna',0),(56094,1559,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾',0),(56095,1559,'ur','Ú¯Ú¾Ø±',0),(56096,1559,'sr','Ð”Ð¾Ð¼',0),(56097,1559,'vi','Trang chá»§',0),(56098,1559,'af','Tuisblad',0),(56099,1559,'ro','AcasÄƒ',0),(56100,1559,'et','Kodu',0),(56101,1559,'si','Domov',0),(56102,1559,'ba','Rumah',0),(56103,1559,'nl','Huis',0),(56104,1559,'fi','Etusivu',0),(56105,1559,'no','Hjem',0),(56106,1559,'da','Hjem',0),(56107,1559,'ko','í™ˆ',0),(56108,1559,'he','×¨××©×™',0),(56109,1559,'el','Î£Ï€Î¯Ï„Î¹',0),(56110,1559,'zh','é¦–é¡µ\r\n',0),(56111,1559,'sv','Hem',0),(56112,1559,'it','Casa',0),(56113,1559,'tl','',0),(56114,1559,'th','&#3627;&#3609;&#3657;&#3634;&#3649;&#3619;&#3585;',0),(56115,1559,'hi','à¤¹à¥‹à¤®',0),(56116,1559,'ms','Rumah',0),(56117,1559,'ar','Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(56118,1559,'fr','Accueil',0),(56119,1559,'jp','ãƒ›ãƒ¼ãƒ ',0),(56120,1559,'pt','Casa',0),(56121,1559,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ',0),(56122,1559,'es','Hogar',0),(56123,1559,'de','Startseite',0),(56124,1559,'en','Home',0),(56125,1560,'is','',0),(56126,1560,'dr','Ù…ÙŠØ²Ø¨Ø§Ù†',0),(56127,1560,'pr','Ù…ÙŠØ²Ø¨Ø§Ù†',0),(56128,1560,'tr','ana bilgisayar',0),(56129,1560,'pl','hosta',0),(56130,1560,'bg','Ð´Ð¾Ð¼Ð°ÐºÐ¸Ð½',0),(56131,1560,'ur','Ù…ÛŒØ²Ø¨Ø§Ù†',0),(56132,1560,'sr','Ð´Ð¾Ð¼Ð°Ñ›Ð¸Ð½',0),(56133,1560,'vi','Host',0),(56134,1560,'af','gasheer',0),(56135,1560,'ro','gazdÄƒ',0),(56136,1560,'et','vastuvÃµtva',0),(56137,1560,'si','gostitelj',0),(56138,1560,'ba','tuan rumah',0),(56139,1560,'nl','host',0),(56140,1560,'fi','isÃ¤ntÃ¤',0),(56141,1560,'no','verten',0),(56142,1560,'da','vÃ¦rten',0),(56143,1560,'ko','í˜¸ìŠ¤íŠ¸',0),(56144,1560,'he','×ž××¨×—',0),(56145,1560,'el','Ï…Ï€Î¿Î´Î¿Ï‡Î®Ï‚',0),(56146,1560,'zh','ä¸»æœº\r\n',0),(56147,1560,'sv','vÃ¤rd',0),(56148,1560,'it','host',0),(56149,1560,'tl','',0),(56150,1560,'th','&#3650;&#3630;&#3626;&#3605;&#3660;',0),(56151,1560,'hi','à¤®à¥‡à¤œà¤¬à¤¾à¤¨',0),(56152,1560,'ms','tuan rumah',0),(56153,1560,'ar','Ø§Ù„Ù…Ø¶ÙŠÙ',0),(56154,1560,'fr','hÃ´te',0),(56155,1560,'jp','ãƒ›ã‚¹ãƒˆ',0),(56156,1560,'pt','host',0),(56157,1560,'ru','Ñ…Ð¾ÑÑ‚',0),(56158,1560,'es','host',0),(56159,1560,'de','Host',0),(56160,1560,'en','host',0),(56161,1561,'is','',0),(56162,1561,'dr','Ø³Ø§Ø¹ØªÙŠ ',0),(56163,1561,'pr','Ø³Ø§Ø¹ØªÙŠ ',0),(56164,1561,'tr','Saatlik',0),(56165,1561,'pl','Co godzinÄ™',0),(56166,1561,'bg','ÐŸÐ¾Ñ‡Ð°ÑÐ¾Ð²Ð°',0),(56167,1561,'ur','Ú¯Ú¾Ù†Ù¹Û Ú¯Ú¾Ø±',0),(56168,1561,'sr','ÐŸÐ¾ ÑÐ°Ñ‚Ñƒ',0),(56169,1561,'vi','HÃ ng giá»',0),(56170,1561,'af','Uurliks',0),(56171,1561,'ro','Pe orÄƒ',0),(56172,1561,'et','Tunnitasu',0),(56173,1561,'si','Urna',0),(56174,1561,'ba','Per jam',0),(56175,1561,'nl','Per uur',0),(56176,1561,'fi','Tunnin',0),(56177,1561,'no','Hver time',0),(56178,1561,'da','TimelÃ¸n',0),(56179,1561,'ko','ì‹œê°„ë³„',0),(56180,1561,'he','×›×œ ×©×¢×”',0),(56181,1561,'el','Î©ÏÎ¹Î±Î¯Î±',0),(56182,1561,'zh','æ¯å°æ—¶\r\n',0),(56183,1561,'sv','Varje timme',0),(56184,1561,'it','Oraria',0),(56185,1561,'tl','',0),(56186,1561,'th','&#3619;&#3634;&#3618;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(56187,1561,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾',0),(56188,1561,'ms','Setiap jam',0),(56189,1561,'ar','ÙƒÙ„Ù‘ Ø³Ø§Ø¹Ø©',0),(56190,1561,'fr','Horaire',0),(56191,1561,'jp','æ¯Žæ™‚',0),(56192,1561,'pt','Por hora',0),(56193,1561,'ru','ÐŸÐ¾Ñ‡Ð°ÑÐ¾Ð²Ð°Ñ',0),(56194,1561,'es','Por la Hora',0),(56195,1561,'de','StÃ¼ndliche',0),(56196,1561,'en','Hourly',0),(56197,1562,'is','',0),(56198,1562,'dr','Ø­Ù‚ÙˆÙ‚ Ø³Ø§Ø¹ØªÙŠ    ',0),(56199,1562,'pr','Ø­Ù‚ÙˆÙ‚ Ø³Ø§Ø¹ØªÙŠ    ',0),(56200,1562,'tr','Hrly/Slry',0),(56201,1562,'pl','Hrly/Slry',0),(56202,1562,'bg','Hrly/Slry',0),(56203,1562,'ur','ÛØ±/Ø³Ù„Ø±ÛŒ',0),(56204,1562,'sr','Ð¥Ñ€Ð»y/Ð¡Ð»Ñ€y',0),(56205,1562,'vi','Giá»/LÆ°Æ¡ng',0),(56206,1562,'af','Uurl./Sal.',0),(56207,1562,'ro','Hrly/Slry',0),(56208,1562,'et','Hrly/Slry',0),(56209,1562,'si','Hrly/Slry',0),(56210,1562,'ba','Hrly Slry',0),(56211,1562,'nl','Hrly/Slry',0),(56212,1562,'fi','Hrly/Slry',0),(56213,1562,'no','Hrly/Slry',0),(56214,1562,'da','Hrly/Slry',0),(56215,1562,'ko','Hrly/Slry',0),(56216,1562,'he','Hrly/Slry',0),(56217,1562,'el','Hrly/Slry',0),(56218,1562,'zh','æ¯å°æ—¶/è–ªé‡‘\r\n',0),(56219,1562,'sv','Hrly/Slry',0),(56220,1562,'it','Hrly/Slry',0),(56221,1562,'tl','',0),(56222,1562,'th','&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3619;&#3634;&#3618;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(56223,1562,'hi','Hrly/Slry',0),(56224,1562,'ms','Hrly/Slry',0),(56225,1562,'ar','Ù‡Ø±Ù„ÙŠ/Ø³Ù„Ø±ÙŠ',0),(56226,1562,'fr','Hrly/Slry',0),(56227,1562,'jp','æ™‚çµ¦',0),(56228,1562,'pt','Hrly/Slry',0),(56229,1562,'ru','Hrly/Slry',0),(56230,1562,'es','Por Hora/Salario',0),(56231,1562,'de','HRLY/Slry',0),(56232,1562,'en','Hrly/Slry',0),(56233,1563,'is','',0),(56234,1563,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³Ø§Ø¹ØªÙŠ ',0),(56235,1563,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³Ø§Ø¹ØªÙŠ ',0),(56236,1563,'tr','Saatlik Ã¼cret',0),(56237,1563,'pl','Wynagrodzenie godzinowe',0),(56238,1563,'bg','ÐŸÐ¾Ñ‡Ð°ÑÐ¾Ð²Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(56239,1563,'ur','ÙÛŒ Ú¯Ú¾Ù†Ù¹Û Ù…Ø²Ø¯ÙˆØ±ÛŒ',0),(56240,1563,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ Ð¿Ð¾ ÑÐ°Ñ‚Ñƒ',0),(56241,1563,'vi','LÆ°Æ¡ng giá»',0),(56242,1563,'af','Uurlikse besoldiging',0),(56243,1563,'ro','Plata pe orÄƒ',0),(56244,1563,'et','Tunnipalk',0),(56245,1563,'si','Urne mezde',0),(56246,1563,'ba','Upah per jam',0),(56247,1563,'nl','Uurlonen',0),(56248,1563,'fi','Tuntipalkasta',0),(56249,1563,'no','TimelÃ¸nn',0),(56250,1563,'da','TimelÃ¸n',0),(56251,1563,'ko','ì‹œê°„ë‹¹ ìž„ê¸ˆ',0),(56252,1563,'he','×©×›×¨ ×©×¢×ª×™',0),(56253,1563,'el','Î©ÏÎ¹Î±Î¯Î¿Ï… Î¼Î¹ÏƒÎ¸Î¿Ï',0),(56254,1563,'zh','æ¯å°æ—¶å·¥èµ„\r\n',0),(56255,1563,'sv','TimlÃ¶ner',0),(56256,1563,'it','Salari orari',0),(56257,1563,'tl','',0),(56258,1563,'th','&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3619;&#3634;&#3618;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(56259,1563,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(56260,1563,'ms','Upah setiap jam',0),(56261,1563,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± ÙÙŠ Ø§Ù„Ø³Ø§Ø¹Ø©',0),(56262,1563,'fr','Salaires horaires',0),(56263,1563,'jp','æ™‚çµ¦',0),(56264,1563,'pt','SalÃ¡rios',0),(56265,1563,'ru','ÐŸÐ¾Ñ‡Ð°ÑÐ¾Ð²Ð°Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(56266,1563,'es','Sueldos por hora',0),(56267,1563,'de','StundenlÃ¶hne',0),(56268,1563,'en','Hourly wages',0),(56269,1564,'is','',0),(56270,1564,'dr','Ø³Ø§Ø¹Ø§Øª ',0),(56271,1564,'pr','Ø³Ø§Ø¹Ø§Øª ',0),(56272,1564,'tr','Saat',0),(56273,1564,'pl','Godziny',0),(56274,1564,'bg','Ð§Ð°ÑÐ°',0),(56275,1564,'ur','Ú¯Ú¾Ù†Ù¹Û’',0),(56276,1564,'sr','Ð¡Ð°Ñ‚Ð¸',0),(56277,1564,'vi','Giá»',0),(56278,1564,'af','Ure',0),(56279,1564,'ro','Ore',0),(56280,1564,'et','Tundi',0),(56281,1564,'si','Ur',0),(56282,1564,'ba','Jam',0),(56283,1564,'nl','Uur',0),(56284,1564,'fi','Tuntia',0),(56285,1564,'no','Timer',0),(56286,1564,'da','Timer',0),(56287,1564,'ko','ì‹œê°„',0),(56288,1564,'he','×©×¢×•×ª',0),(56289,1564,'el','ÎÏÎµÏ‚',0),(56290,1564,'zh','æ—¶é—´\r\n',0),(56291,1564,'sv','Timmar',0),(56292,1564,'it','Ore',0),(56293,1564,'tl','',0),(56294,1564,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(56295,1564,'hi','à¤˜à¤‚à¤Ÿà¥‡',0),(56296,1564,'ms','Jam',0),(56297,1564,'ar','Ø³Ø§Ø¹Ø§Øª',0),(56298,1564,'fr','Heures',0),(56299,1564,'jp','å‹¤å‹™æ™‚é–“',0),(56300,1564,'pt','Horas',0),(56301,1564,'ru','Ð§Ð°ÑÑ‹',0),(56302,1564,'es','Horas',0),(56303,1564,'de','Stunden',0),(56304,1564,'en','Hours',0),(56305,1565,'is','',0),(56306,1565,'dr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ  Ø·Ø¨Ù‚ Ø±Ù†Ú¯ Ø·Ø¨Ù‚ Ø¬Ù‡Øª ',0),(56307,1565,'pr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ  Ø·Ø¨Ù‚ Ø±Ù†Ú¯ Ø·Ø¨Ù‚ Ø¬Ù‡Øª ',0),(56308,1565,'tr','Saatler Addl kurulum renkli yan baÅŸÄ±na Ã¼cret',0),(56309,1565,'pl','Godziny Addl ustawienie na kolor na stronie',0),(56310,1565,'bg','Ð§Ð°ÑÐ¾Ð²Ðµ Addl Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð° Ñ†Ð²ÑÑ‚ Ð²ÑÑÐºÐ° ÑÑ‚Ñ€Ð°Ð½Ð°',0),(56311,1565,'ur','Ú¯Ú¾Ù†Ù¹Û’ Ø§Ø¯Ø¯Ù„ Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ø·Ø±Ù ÙÛŒ Ø±Ù†Ú¯ ÙÛŒ',0),(56312,1565,'sr','ÐÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ ÑÐ°Ñ‚Ð¸ ÐÐ´Ð´Ð» Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ð¿Ð¾ Ð±Ð¾Ñ˜Ð¸ Ð½Ð° Ñ˜ÐµÐ´Ð½Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸',0),(56313,1565,'vi','Setup giá» thÃªm má»—i máº§u má»—i máº·t',0),(56314,1565,'af','Ure Addl opstel Per kleur Per kant',0),(56315,1565,'ro','Ore Addl configurare fiecare culoare pe fiecare parte',0),(56316,1565,'et','Tundides Addl Setup vÃ¤rvi Ã¼he kÃ¼lje kohta',0),(56317,1565,'si','Ure pokvariti se Setup na barvo na vsaki strani',0),(56318,1565,'ba','Jam Addl Setup warna Per sisi',0),(56319,1565,'nl','Uren Addl Setup Per kleur Per zijde',0),(56320,1565,'fi','Tunnin Addl asennus Per vÃ¤ri Per puoli',0),(56321,1565,'no','Timer Addl Setup Per farge Per Side',0),(56322,1565,'da','Timer Addl Setup pr. farve pr. Side',0),(56323,1565,'ko','Addl ì¸¡ ë‹¹ ìƒ‰ê¹” ë‹¹ ì„¤ì¹˜ í•˜ëŠ” ì‹œê°„',0),(56324,1565,'he','×©×¢×•×ª Addl ×”×ª×§× ×” ×œ×›×œ ×¦×‘×¢ ×‘×›×œ ×¦×“',0),(56325,1565,'el','ÎÏÎµÏ‚ Addl Î¿ÏÎ³Î¬Î½Ï‰ÏƒÎ· Î±Î½Î¬ Ï‡ÏÏŽÎ¼Î± Î±Î½Î¬ Ï€Î»ÎµÏ…ÏÎ¬',0),(56326,1565,'zh','æ¯ç§é¢œè‰²æ¯è¾¹æ—¶é—´é™„åŠ è®¾ç½®\r\n',0),(56327,1565,'sv','Timmar Addl Setup Per fÃ¤rg Per sida',0),(56328,1565,'it','Ore Addl Setup Per colore Per lato',0),(56329,1565,'tl','',0),(56330,1565,'th','&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3621;&#3632;&#3604;&#3657;&#3634;&#3609;&#3604;&#3657;&#3634;&#3609;&#3621;&#3632;&#3626;&#3637;',0),(56331,1565,'hi','à¤…à¤ªà¤° à¤¸à¥‡à¤Ÿà¤…à¤ª à¤ªà¤•à¥à¤· à¤ªà¥à¤°à¤¤à¤¿ à¤°à¤‚à¤— à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¥‡',0),(56332,1565,'ms','Jam Addl sediakan satu warna satu sisi',0),(56333,1565,'ar','Ø³Ø§Ø¹Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ© Ø¥Ø¹Ø¯Ø§Ø¯ ÙƒÙ„ Ù„ÙˆÙ† Ù…Ù† ÙƒÙ„ Ø¬Ø§Ù†Ø¨',0),(56334,1565,'fr','Heures Addl Setup par couleur par cÃ´tÃ©',0),(56335,1565,'jp','å?´é?¢ã?”ã?¨è‰²ã?”ã?¨ã?®è¿½åŠ è¨­å®šæ™‚é–“',0),(56336,1565,'pt','Horas Addl Setup pela cor por lado',0),(56337,1565,'ru','Ð§Ð°ÑÑ‹ Ð¿Ñ€Ð¸ÑÑ‚Ð°Ð²Ð½Ð¾Ð¹ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ ÐºÐ°Ð¶Ð´Ð¾Ð³Ð¾ Ñ†Ð²ÐµÑ‚Ð° ÐºÐ°Ð¶Ð´Ð¾Ð¹ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(56338,1565,'es','Horas Adicionales ConfiguraciÃ³n por ColÃ³r por Lado',0),(56339,1565,'de','Stunden Addl Setup pro Farbe pro Seite',0),(56340,1565,'en','Hours Addl Setup Per Color Per Side',0),(56341,1566,'is','',0),(56342,1566,'dr','Ø³Ø§Ø¹Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯',0),(56343,1566,'pr','Ø³Ø§Ø¹Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯',0),(56344,1566,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde hesaplanÄ±yor.',0),(56345,1566,'pl','Godziny oblicza siÄ™ pomyÅ›lnie.',0),(56346,1566,'bg','Ð§Ð°ÑÐ¾Ð²ÐµÑ‚Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(56347,1566,'ur','Ø§ÙˆÙ‚Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø³Ø§Ø¨ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(56348,1566,'sr','Ð¡Ð°Ñ‚Ð¸ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(56349,1566,'vi','TÃ­nh giá» thÃ nh cÃ´ng',0),(56350,1566,'af','Ure Suksesvol Bereken.',0),(56351,1566,'ro','Orele calculate cu succes.',0),(56352,1566,'et','Tundi kalkulatsioon Ãµnnestus.',0),(56353,1566,'si','Ur izraÄuna uspeÅ¡no.',0),(56354,1566,'ba','Jam dihitung berhasil.',0),(56355,1566,'nl','Uren berekend met succes.',0),(56356,1566,'fi','Tuntia laskenta onnistui.',0),(56357,1566,'no','Timer beregnet vellykket.',0),(56358,1566,'da','Timer beregnes korrekt.',0),(56359,1566,'ko','ì„±ê³µì ìœ¼ë¡œ ì‹œê°„ ê³„ì‚°.',0),(56360,1566,'he','×©×¢×•×ª ×ž×—×•×©×‘ ×‘×”×¦×œ×—×”.',0),(56361,1566,'el','ÎÏÎµÏ‚ Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(56362,1566,'zh','æ—¶é—´è®¡ç®—æˆåŠŸã€‚\r\n',0),(56363,1566,'sv','Timmar berÃ¤knas framgÃ¥ngsrikt.',0),(56364,1566,'it','Ore calcolato correttamente.',0),(56365,1566,'tl','',0),(56366,1566,'th','&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(56367,1566,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤—à¤£à¤¨à¤¾à¥¤',0),(56368,1566,'ms','Jam dikira berjaya.',0),(56369,1566,'ar','Ø­Ø³Ø§Ø¨ Ø³Ø§Ø¹Ø§Øª Ø¨Ù†Ø¬Ø§Ø­.',0),(56370,1566,'fr','Heures calculÃ©es avec succÃ¨s.',0),(56371,1566,'jp','å‹¤å‹™æ™‚é–“ã?Œè¨ˆç®—ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(56372,1566,'pt','Horas calculado com Ãªxito.',0),(56373,1566,'ru','Ð§Ð°ÑÑ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐºÐ°Ð»ÑŒÐºÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹.',0),(56374,1566,'es','Horas calculadas exitosamente',0),(56375,1566,'de','Stunden erfolgreich berechnet.',0),(56376,1566,'en','Hours calculated successfully.',0),(56377,1567,'is','',0),(56378,1567,'dr','Ø³Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(56379,1567,'pr','Ø³Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(56380,1567,'tr','Saat Ã¼cretli',0),(56381,1567,'pl','Godziny pÅ‚atne',0),(56382,1567,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ Ñ‡Ð°ÑÐ¾Ð²Ðµ',0),(56383,1567,'ur','Ú¯Ú¾Ù†Ù¹Û’ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(56384,1567,'sr','Ð¡Ð°Ñ‚Ð¸ Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾.',0),(56385,1567,'vi','Giá» Ä‘Ã£ tráº£',0),(56386,1567,'af','Ure Betaal',0),(56387,1567,'ro','Ore plÄƒtite',0),(56388,1567,'et','Tundi makstud',0),(56389,1567,'si','PlaÄanih ur',0),(56390,1567,'ba','Jam dibayar',0),(56391,1567,'nl','Uur betaald',0),(56392,1567,'fi','Tuntia maksaa',0),(56393,1567,'no','Timer betalt',0),(56394,1567,'da','Timer betales',0),(56395,1567,'ko','ì‹œê°„ ì§€ë¶ˆ',0),(56396,1567,'he','×©×¢×•×ª ×ª×©×œ×•×',0),(56397,1567,'el','ÎŸÎ¹ ÏŽÏÎµÏ‚ Ï€Î¿Ï… Î±Î¼ÎµÎ¯Ï†Î¸Î·ÎºÎ±Î½',0),(56398,1567,'zh','æ—¶æ•°æ‰€æ”¯ä»˜\r\n',0),(56399,1567,'sv','AvlÃ¶nade timmar',0),(56400,1567,'it','Ore pagate',0),(56401,1567,'tl','',0),(56402,1567,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;',0),(56403,1567,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(56404,1567,'ms','Jam dibayar',0),(56405,1567,'ar','Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(56406,1567,'fr','Heures payÃ©es',0),(56407,1567,'jp','æ™‚çµ¦',0),(56408,1567,'pt','Horas pagas',0),(56409,1567,'ru','Ð§Ð°ÑÐ¾Ð² Ð¿Ð»Ð°Ñ‚Ð½Ñ‹Ðµ',0),(56410,1567,'es','Horas Pagadas',0),(56411,1567,'de','Bezahlter Arbeitsstunden',0),(56412,1567,'en','Hours Paid',0),(56413,1568,'is','',0),(56414,1568,'dr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ø¹Ø§Øª',0),(56415,1568,'pr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ø¹Ø§Øª',0),(56416,1568,'tr','Saat kurulum',0),(56417,1568,'pl','Ustawienie godziny',0),(56418,1568,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ñ‡Ð°ÑÐ°',0),(56419,1568,'ur','Ú¯Ú¾Ù†Ù¹ÙˆÚº Ø³ÛŒÙ¹ Ø§Ù¾',0),(56420,1568,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÑÐ°Ñ‚Ð°',0),(56421,1568,'vi','Setup giá»',0),(56422,1568,'af','Ure Opstelling',0),(56423,1568,'ro','Ore de configurare',0),(56424,1568,'et','Tundi seadistamine',0),(56425,1568,'si','Ur Setup',0),(56426,1568,'ba','Jam Setup',0),(56427,1568,'nl','Uren instellen',0),(56428,1568,'fi','Tuntia Setup',0),(56429,1568,'no','Timer oppsett',0),(56430,1568,'da','Timer Setup',0),(56431,1568,'ko','ì‹œê°„ ì„¤ì •',0),(56432,1568,'he','×”×’×“×¨×ª ×©×¢×•×ª',0),(56433,1568,'el','Î£Ï„Î®ÏƒÎµÏ„Îµ ÏŽÏÎµÏ‚',0),(56434,1568,'zh','æ—¶é—´è®¾ç½®\r\n',0),(56435,1568,'sv','Timmar Setup',0),(56436,1568,'it','Ore di installazione',0),(56437,1568,'tl','',0),(56438,1568,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(56439,1568,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(56440,1568,'ms','Jam persediaan',0),(56441,1568,'ar','Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(56442,1568,'fr','Heures d\'installation',0),(56443,1568,'jp','å‹¤å‹™æ™‚é–“è¨­å®š',0),(56444,1568,'pt','Horas de instalaÃ§Ã£o',0),(56445,1568,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð§Ð°ÑÐ¾Ð²',0),(56446,1568,'es','ConfiguraciÃ³n de Horas',0),(56447,1568,'de','Stunden einrichten',0),(56448,1568,'en','Hours Setup',0),(56449,1569,'is','',0),(56450,1569,'dr','(Ù…Ø¬Ù…ÙˆØ¹ÙŠ)',0),(56451,1569,'pr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ø¹Ø§Øª (ÙƒÙ„ÙŠ)',0),(56452,1569,'tr','Saat (genel) Kurulum',0),(56453,1569,'pl','Godziny instalacji (ogÃ³lne)',0),(56454,1569,'bg','Ð§Ð°ÑÐ° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° (Ð¾Ð±Ñ‰Ð¾)',0),(56455,1569,'ur','(Ø¬Ù†Ø±Ù„) Ú©Ùˆ Ú¯Ú¾Ù†Ù¹ÙˆÚº Ø³ÛŒÙ¹ Ø§Ù¾',0),(56456,1569,'sr','Ð¡Ð°Ñ‚Ð¸ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° (ÐžÐ¿ÑˆÑ‚Ðµ)',0),(56457,1569,'vi','Setup giá» (Chung)',0),(56458,1569,'af','Ure Opstelling (Algemeen)',0),(56459,1569,'ro','Ore de configurare (generale)',0),(56460,1569,'et','Tundi Setup (Ã¼ldine)',0),(56461,1569,'si','Ur Setup (sploÅ¡no)',0),(56462,1569,'ba','Jam Setup (umum)',0),(56463,1569,'nl','Uur Setup (algemene)',0),(56464,1569,'fi','Tuntia Setup (yleis)',0),(56465,1569,'no','Timer oppsett (generelt)',0),(56466,1569,'da','Timer Setup (generel)',0),(56467,1569,'ko','ì‹œê°„ ì„¤ì • (ì¼ë°˜)',0),(56468,1569,'he','×©×¢×•×ª ×”×”×ª×§× ×” (×›×œ×œ×™)',0),(56469,1569,'el','ÎÏÎµÏ‚ Î¿ÏÎ³Î¬Î½Ï‰ÏƒÎ· (Î³ÎµÎ½Î¹ÎºÎ®)',0),(56470,1569,'zh','æ—¶é—´è®¾å®šï¼ˆä¸€èˆ¬ï¼‰\r\n',0),(56471,1569,'sv','Timmar Setup (allmÃ¤nna)',0),(56472,1569,'it','Ore di installazione (generale)',0),(56473,1569,'tl','',0),(56474,1569,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609; (&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;)',0),(56475,1569,'hi','à¤˜à¤‚à¤Ÿà¥‡ (à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯) à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(56476,1569,'ms','Jam persediaan (am)',0),(56477,1569,'ar','Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ (Ø¹Ø§Ù…Ø©)',0),(56478,1569,'fr','Heures de configuration (gÃ©nÃ©ral)',0),(56479,1569,'jp','å‹¤å‹™æ™‚é–“è¨­å®šï¼ˆä¸€èˆ¬ï¼‰',0),(56480,1569,'pt','Horas de instalaÃ§Ã£o (geral)',0),(56481,1569,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð§Ð°ÑÐ¾Ð² (ÐžÐ±Ñ‰Ð°Ñ)',0),(56482,1569,'es','ConfiguraciÃ³n de Horas (General)',0),(56483,1569,'de','Stunden einrichten (allgemein)',0),(56484,1569,'en','Hours Setup (General)',0),(56485,1570,'is','',0),(56486,1570,'dr','Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø± Ø´Ø¯Ù‡ ',0),(56487,1570,'pr','Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø± Ø´Ø¯Ù‡ ',0),(56488,1570,'tr','Ã‡alÄ±ÅŸÄ±lan saat',0),(56489,1570,'pl','Przepracowane godziny',0),(56490,1570,'bg','Ð§Ð°ÑÐ¾Ð²Ðµ',0),(56491,1570,'ur','Ú¯Ú¾Ù†Ù¹Û’ Ú©Ø§Ù… Ú©ÛŒØ§ Û”',0),(56492,1570,'sr','Ð Ð°Ð´Ð½Ð¸Ñ… Ñ‡Ð°ÑÐ¾Ð²Ð°',0),(56493,1570,'vi','Giá» lÃ m viá»‡c',0),(56494,1570,'af','Ure Gewerk',0),(56495,1570,'ro','Orele lucrate',0),(56496,1570,'et','TÃ¶Ã¶tatud tunnid',0),(56497,1570,'si','Opravljenih ur',0),(56498,1570,'ba','Jam bekerja',0),(56499,1570,'nl','Gewerkte uren',0),(56500,1570,'fi','TyÃ¶tunnit',0),(56501,1570,'no','Arbeidstimer',0),(56502,1570,'da','Arbejdstimer',0),(56503,1570,'ko','ì‹œê°„ ì¼',0),(56504,1570,'he','×©×¢×•×ª ×”×¢×‘×•×“×”',0),(56505,1570,'el','Î”ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½ÎµÏ‚ ÏŽÏÎµÏ‚',0),(56506,1570,'zh','å·¥ä½œæ—¶é—´\r\n',0),(56507,1570,'sv','Arbetade timmar',0),(56508,1570,'it','Ore lavorate',0),(56509,1570,'tl','',0),(56510,1570,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(56511,1570,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤•à¤¾à¤® à¤•à¤¿à¤¯à¤¾',0),(56512,1570,'ms','Jam bekerja',0),(56513,1570,'ar','Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„',0),(56514,1570,'fr','Les heures travaillÃ©es',0),(56515,1570,'jp','å‹¤å‹™æ™‚é–“',0),(56516,1570,'pt','Horas trabalhadas',0),(56517,1570,'ru','ÐžÑ‚Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½Ð½Ñ‹Ñ… Ñ‡Ð°ÑÐ¾Ð²',0),(56518,1570,'es','Horas Trabajadas',0),(56519,1570,'de','Der geleisteten Arbeitsstunden',0),(56520,1570,'en','Hours Worked',0),(56521,1571,'is','',0),(56522,1571,'dr','Ú†Ú¯ÙˆÙ†Ù‡ Ø´Ù…Ø§ Ø¨Ø¯ÙˆÙ† Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ù„Ø§ Ø¨Ù‡ Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø³ÙŠØ¯ÙŠØ¯ØŸ',0),(56523,1571,'pr','Ú†Ú¯ÙˆÙ†Ù‡ Ø´Ù…Ø§ Ø¨Ø¯ÙˆÙ† Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ù„Ø§ Ø¨Ù‡ Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø³ÙŠØ¯ÙŠØ¯ØŸ',0),(56524,1571,'tr','NasÄ±l burada hiÃ§bir Ã¶ÄŸe kimliÄŸi ile geldi mi?',0),(56525,1571,'pl','Jak przyjedziesz tu z nie identyfikator elementu?',0),(56526,1571,'bg','ÐšÐ°Ðº Ð»Ð¸ Ð¿Ñ€Ð¸ÑÑ‚Ð¸Ð³Ð½Ð° Ñ‚ÑƒÐº Ñ Ð½Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ Ð˜Ð”??',0),(56527,1571,'ur','Ú©Ø³ Ø·Ø±Ø­ Ø¢Ù¾ ÛŒÛØ§Úº Ú©Ø³ÛŒ Ø´Û’ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ù¾ÛÙ†Ú†ØªÛ’ ÛÛŒÚº Ú©ÛŒØ§??',0),(56528,1571,'sr','ÐšÐ°ÐºÐ¾ ÑÐ¸ ÑÑ‚Ð¸Ð³Ð°Ð¾ Ð¾Ð²Ð°Ð¼Ð¾ ÑÐ° Ð½ÐµÐ¼Ð° Ð¸Ð´ ÑÑ‚Ð°Ð²ÐºÐµ??',0),(56529,1571,'vi','Sao báº¡n cÃ³ thá»ƒ tá»›i Ä‘Ã¢y mÃ  khÃ´ng cÃ³ ID hÃ ng?',0),(56530,1571,'af','Hoe het jy kom hier met geen item id??',0),(56531,1571,'ro','Cum a ajuns aici cu nici un id element??',0),(56532,1571,'et','Kuidas kas sattusite siia pole Ã¼ksuse id-ga?',0),(56533,1571,'si','Kako did vi prihod tukaj brez ID elementa??',0),(56534,1571,'ba','Bagaimana Apakah Anda tiba di sini dengan id item tidak??',0),(56535,1571,'nl','Hoe u hier aankomen met geen objectnummer?',0),(56536,1571,'fi','Miten saavuitte tÃ¤nne ilman nimikkeen tunnusta?',0),(56537,1571,'no','Hvordan kom du hit med ingen IDen?',0),(56538,1571,'da','Hvordan du kommer her med ingen vare id??',0),(56539,1571,'ko','ì–´ë–»ê²Œ ë‹¹ì‹ ì´ ì—¬ê¸° í•­ëª© idì™€ í•¨ê»˜ ë„ì°© í–ˆ ì–´??',0),(56540,1571,'he','××™×š ×”×’×¢×ª ×”× ×” ××™×Ÿ ×–×™×”×•×™ ×¤×¨×™×˜??',0),(56541,1571,'el','Î ÏŽÏ‚ Î¸Î± Ï†Ï„Î¬ÏƒÎµÏ„Îµ ÎµÎ´ÏŽ Î¼Îµ ÎºÎ±Î¼Î¯Î± Î¸Î­ÏƒÎ· id?',0),(56542,1571,'zh','ä½ æ˜¯å¦‚ä½•åœ¨æ²¡æœ‰é¡¹ç›®IDçš„æƒ…å†µä¸‹åˆ°è¾¾è¿™é‡Œçš„ï¼Ÿ',0),(56543,1571,'sv','Hur kom du fram hÃ¤r med inget objekt-id??',0),(56544,1571,'it','Come sei arrivata qui con nessun elemento id??',0),(56545,1571,'tl','',0),(56546,1571,'th','&#3588;&#3640;&#3603;&#3617;&#3634;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3627;&#3633;&#3626;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;??',0),(56547,1571,'hi','à¤¤à¥à¤® à¤¯à¤¹à¤¾à¤ à¤•à¥ˆà¤¸à¥‡ à¤•à¥‹à¤ˆ à¤†à¤‡à¤Ÿà¤® à¤†à¤ˆà¤¡à¥€ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤à¤ à¤¥à¤¾??',0),(56548,1571,'ms','Bagaimana pula anda tiba di sini dengan tiada id item??',0),(56549,1571,'ar','ÙƒÙŠÙ ÙˆØµÙ„Øª Ø¥Ù„Ù‰ Ù‡Ù†Ø§ Ø¨Ø¯ÙˆÙ† Ù…Ø¹Ø±Ù‘Ù Ø§Ù„ØµÙ†Ù ØŸ',0),(56550,1571,'fr','Comment Ãªtes-vous arrivÃ© ici avec aucun id d\'Ã©lÃ©ment??',0),(56551,1571,'jp','å“?ç›®IDã?ªã?—ã?§ã?©ã?®ã‚ˆã?†ã?«ã?“ã?“ã?¾ã?§ã??ã?¾ã?—ã?Ÿã?‹ï¼Ÿ',0),(56552,1571,'pt','Como vocÃª chegou aqui com nenhuma id de item?',0),(56553,1571,'ru','ÐšÐ°Ðº Ð²Ñ‹ Ð¿Ñ€Ð¸ÑˆÐ»Ð¸ ÑÑŽÐ´Ð° Ñ Ð±ÐµÐ· ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° id??',0),(56554,1571,'es','Â¿Â¿Como llegÃ³ aqui sin un item ID??',0),(56555,1571,'de','Wie ist Sie hier mit keine Element-Id gekommen??',0),(56556,1571,'en','How did you arrive here with no item id??',0),(56557,1572,'is','',0),(56558,1572,'dr','Ú†Ú¯ÙˆÙ†Ù‡ Ø´Ù…Ø§ Ø¨Ù‡ Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø³ÙŠØ¯ÙŠØ¯ØŸ',0),(56559,1572,'pr','Ú†Ú¯ÙˆÙ†Ù‡ Ø´Ù…Ø§ Ø¨Ù‡ Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø³ÙŠØ¯ÙŠØ¯ØŸ',0),(56560,1572,'tr','Buraya nasÄ±l gelebildi?',0),(56561,1572,'pl','jak siÄ™ tu wziÄ…Å‚eÅ›?',0),(56562,1572,'bg','ÐšÐ°Ðº Ð²Ð»ÑÐ·Ð¾Ñ…Ñ‚Ðµ Ñ‚ÑƒÐº?',0),(56563,1572,'ur','Ú©Ø³ Ø·Ø±Ø­ Ø¢Ù¾ ÛŒÛØ§Úº Ø­Ø§ØµÙ„ Ú©ÛŒØ§ ØªÚ¾Ø§ØŸ',0),(56564,1572,'sr','ÐžÐ´Ð°ÐºÐ»Ðµ Ñ‚Ð¸ Ð¾Ð²Ð´Ðµ?',0),(56565,1572,'vi','Báº¡n Ä‘áº¿n Ä‘Ã¢y báº±ng cÃ¡ch nÃ o',0),(56566,1572,'af','Hoe het jy hier kry?',0),(56567,1572,'ro','cum ai ajuns aici?',0),(56568,1572,'et','kuidas olete siia jÃµudnud?',0),(56569,1572,'si','kako ste dobili tukaj?',0),(56570,1572,'ba','Bagaimana Apakah Anda dapatkan di sini?',0),(56571,1572,'nl','Hoe ben je hier?',0),(56572,1572,'fi','Miten pÃ¤Ã¤sit tÃ¤nne?',0),(56573,1572,'no','Hvordan kom du hit?',0),(56574,1572,'da','Hvordan fik du her?',0),(56575,1572,'ko','ë‹¹ì‹ ì€ ì–´ë–»ê²Œ ì—¬ê¸° ì–» ì—ˆ?',0),(56576,1572,'he','××™×š ×”×’×¢×ª ×œ×›××Ÿ?',0),(56577,1572,'el','Î ÏŽÏ‚ Î¼Ï€Î®ÎºÎµÏ‚ ÎµÎ´ÏŽ;',0),(56578,1572,'zh','ä½ æ€Žä¹ˆåœ¨è¿™é‡Œï¼Ÿ\r\n',0),(56579,1572,'sv','Hur kom du hit?',0),(56580,1572,'it','come sei arrivato qui?',0),(56581,1572,'tl','',0),(56582,1572,'th','&#3588;&#3640;&#3603;&#3617;&#3634;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3652;&#3604;&#3657;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3619;?',0),(56583,1572,'hi','à¤¯à¤¹à¤¾à¤ à¤†à¤ª à¤•à¥ˆà¤¸à¥‡ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤¿à¤¯à¤¾ à¤¥à¤¾?',0),(56584,1572,'ms','Bagaimana pula anda dapatkan di sini?',0),(56585,1572,'ar','ÙƒÙŠÙ ÙŠØ­ØµÙ„ Ù‡Ù†Ø§ØŸ',0),(56586,1572,'fr','Comment vous Ãªtes-vous ici ?',0),(56587,1572,'jp','ã?“ã?“ã?¾ã?§ã?©ã?®ã‚ˆã?†ã?«ã?—ã?¦ã?Ÿã?©ã‚Šç?€ã??ã?¾ã?—ã?Ÿã?‹ï¼Ÿ',0),(56588,1572,'pt','Como chegou aqui?',0),(56589,1572,'ru','ÐºÐ°Ðº Ð²Ñ‹ ÑÑŽÐ´Ð° Ð¿Ð¾Ð¿Ð°Ð»Ð¸?',0),(56590,1572,'es','Â¿ Como llegÃ³ aqui?',0),(56591,1572,'de','Wie kommen Sie hierher?',0),(56592,1572,'en','how did you get here?',0),(56593,1573,'is','',0),(56594,1573,'dr','Ú†Ú¯ÙˆÙ†Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ØŸ',0),(56595,1573,'pr','Ú†Ú¯ÙˆÙ†Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ØŸ',0),(56596,1573,'tr','NasÄ±l figÃ¼rlÃ¼',0),(56597,1573,'pl','Jak figurowe',0),(56598,1573,'bg','ÐšÐ°Ðº Ñ„Ð¸Ð³ÑƒÑ€Ð°',0),(56599,1573,'ur','Ú©Ø³ Ù†Û’ Ø³ÙˆÚ†Ø§',0),(56600,1573,'sr','ÐšÐ°ÐºÐ¾ ÑÐ°Ð¼ Ð¼Ð¸ÑÐ»Ð¸Ð¾',0),(56601,1573,'vi','HÃ¬nh tÆ°á»£ng nhÆ° tháº¿ nÃ o',0),(56602,1573,'af','Uitgepluis hoe',0),(56603,1573,'ro','Cum gÃ¢ndit',0),(56604,1573,'et','Kuidas nÃ¤itaja',0),(56605,1573,'si','Kako figuralnimi',0),(56606,1573,'ba','Bagaimana pikir',0),(56607,1573,'nl','Hoe dacht',0),(56608,1573,'fi','Miten kuviollisen',0),(56609,1573,'no','Hvordan skjÃ¸nte',0),(56610,1573,'da','Hvordan regnede',0),(56611,1573,'ko','ì–´ë–»ê²Œ ì•Œ ì•˜',0),(56612,1573,'he','×—×©×‘×ª×™ ××™×š',0),(56613,1573,'el','Î ÏŽÏ‚ ÎºÎ±Ï„Î¬Î»Î±Î²Î±',0),(56614,1573,'zh','å¦‚ä½•ä¼°è®¡\r\n',0),(56615,1573,'sv','Hur tÃ¤nkte',0),(56616,1573,'it','Come figurato',0),(56617,1573,'tl','',0),(56618,1573,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3605;&#3585;&#3649;&#3605;&#3656;&#3591;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3619;?',0),(56619,1573,'hi','à¤•à¥ˆà¤¸à¥‡ à¤¸à¥‹à¤šà¤¾',0),(56620,1573,'ms','Bagaimana langsing',0),(56621,1573,'ar','ÙƒÙŠÙ Ø¨Ø±Ø²Øª',0),(56622,1573,'fr','Comment faÃ§onnÃ©',0),(56623,1573,'jp','è¨ˆç®—æ–¹æ³•',0),(56624,1573,'pt','Como imaginei que',0),(56625,1573,'ru','ÐšÐ°Ðº Ñ„Ð¸Ð³ÑƒÑ€Ð½Ñ‹Ð¹',0),(56626,1573,'es','Como CaclculÃ³',0),(56627,1573,'de','Wie Figur-',0),(56628,1573,'en','How Figured',0),(56629,1574,'is','',0),(56630,1574,'dr','Ø³Ø§Ø¹ØªÙŠ ',0),(56631,1574,'pr','Ø³Ø§Ø¹ØªÙŠ ',0),(56632,1574,'tr','Hrly',0),(56633,1574,'pl','Hrly',0),(56634,1574,'bg','Hrly',0),(56635,1574,'ur','ÛØ±',0),(56636,1574,'sr','Ð¥Ñ€Ð»y',0),(56637,1574,'vi','HÃ ng giá»',0),(56638,1574,'af','Uurl.',0),(56639,1574,'ro','Hrly',0),(56640,1574,'et','Hrly',0),(56641,1574,'si','Hrly',0),(56642,1574,'ba','Hrly',0),(56643,1574,'nl','Hrly',0),(56644,1574,'fi','Hrly',0),(56645,1574,'no','Hrly',0),(56646,1574,'da','Hrly',0),(56647,1574,'ko','Hrly',0),(56648,1574,'he','Hrly',0),(56649,1574,'el','Hrly',0),(56650,1574,'zh','æ¯å°æ—¶\r\n',0),(56651,1574,'sv','Hrly',0),(56652,1574,'it','Hrly',0),(56653,1574,'tl','',0),(56654,1574,'th','&#3619;&#3634;&#3618;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(56655,1574,'hi','Hrly',0),(56656,1574,'ms','Hrly',0),(56657,1574,'ar','Ù‡Ø±Ù„ÙŠ',0),(56658,1574,'fr','Hrly',0),(56659,1574,'jp','æ™‚é–“æ¯Ž',0),(56660,1574,'pt','Hrly',0),(56661,1574,'ru','Hrly',0),(56662,1574,'es','Por Hora',0),(56663,1574,'de','HRLY',0),(56664,1574,'en','Hrly',0),(56665,1575,'is','',0),(56666,1575,'dr',':',0),(56667,1575,'pr','Ø³Ø§Ø¹Ø§Øª:',0),(56668,1575,'tr','GÃ¶nderilen:',0),(56669,1575,'pl','Godz:',0),(56670,1575,'bg','Ð§:',0),(56671,1575,'ur','Ú¯Ú¾Ù†Ù¹Û’:',0),(56672,1575,'sr','Ð§',0),(56673,1575,'vi','Giá»',0),(56674,1575,'af','Ure:',0),(56675,1575,'ro','Ore:',0),(56676,1575,'et','T. jooksul:',0),(56677,1575,'si','Ur:',0),(56678,1575,'ba','Jam:',0),(56679,1575,'nl','Uur:',0),(56680,1575,'fi','HRS:',0),(56681,1575,'no','Timer:',0),(56682,1575,'da','Timer:',0),(56683,1575,'ko','ì‹œê°„:',0),(56684,1575,'he','×©×¢×•×ª:',0),(56685,1575,'el','ÎÏÎµÏ‚:',0),(56686,1575,'zh','å°æ—¶',0),(56687,1575,'sv','Timmar:',0),(56688,1575,'it','HRS:',0),(56689,1575,'tl','',0),(56690,1575,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591; :',0),(56691,1575,'hi','à¤¬à¤œà¥‡:',0),(56692,1575,'ms','Jam:',0),(56693,1575,'ar','Ø³Ø§Ø¹Ø§Øª:',0),(56694,1575,'fr','Hrs :',0),(56695,1575,'jp','æ™‚é–“',0),(56696,1575,'pt','Hrs',0),(56697,1575,'ru','Ð§Ð°ÑÑ‹:',0),(56698,1575,'es','Horas',0),(56699,1575,'de','HRS',0),(56700,1575,'en','Hrs',0),(56701,1576,'is','',0),(56702,1576,'dr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ø¹Ø§Øª',0),(56703,1576,'pr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ø¹Ø§Øª',0),(56704,1576,'tr','Hrs.Setup',0),(56705,1576,'pl','Hrs.Setup',0),(56706,1576,'bg','Hrs.Setup',0),(56707,1576,'ur','Hrs.Setup',0),(56708,1576,'sr','Ð¥Ñ€Ñ.Ð¡ÐµÑ‚ÑƒÐ¿',0),(56709,1576,'vi','Setup giá»',0),(56710,1576,'af','Ure Opstelling',0),(56711,1576,'ro','Hrs.Setup',0),(56712,1576,'et','Hrs.Setup',0),(56713,1576,'si','Hrs.Setup',0),(56714,1576,'ba','Hrs.Setup',0),(56715,1576,'nl','Hrs.Setup',0),(56716,1576,'fi','Hrs.Setup',0),(56717,1576,'no','Hrs.Setup',0),(56718,1576,'da','Hrs.Setup',0),(56719,1576,'ko','Hrs.Setup',0),(56720,1576,'he','Hrs.Setup',0),(56721,1576,'el','Hrs.Setup',0),(56722,1576,'zh','æ—¶é—´è®¾ç½®\r\n',0),(56723,1576,'sv','Hrs.Setup',0),(56724,1576,'it','Hrs.Setup',0),(56725,1576,'tl','',0),(56726,1576,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(56727,1576,'hi','Hrs.Setup',0),(56728,1576,'ms','Hrs.Setup',0),(56729,1576,'ar','Hrs.Setup',0),(56730,1576,'fr','Hrs.Setup',0),(56731,1576,'jp','æ™‚é–“è¨­å®š',0),(56732,1576,'pt','Hrs.Setup',0),(56733,1576,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð§Ð°ÑÐ¾Ð²',0),(56734,1576,'es','Horas ConfiguraciÃ³n',0),(56735,1576,'de','Hrs.Setup',0),(56736,1576,'en','Hrs.Setup',0),(56737,1577,'is','',0),(56738,1577,'dr','ØµØ¯ ',0),(56739,1577,'pr','ØµØ¯ ',0),(56740,1577,'tr','yÃ¼z',0),(56741,1577,'pl','sto',0),(56742,1577,'bg','ÑÑ‚Ð¾',0),(56743,1577,'ur','Ø³Ùˆ',0),(56744,1577,'sr','ÑÑ‚Ð¾Ñ‚Ð¸Ð½Ð°',0),(56745,1577,'vi','trÄƒm',0),(56746,1577,'af','honderd',0),(56747,1577,'ro','sute',0),(56748,1577,'et','sada',0),(56749,1577,'si','sto',0),(56750,1577,'ba','ratus',0),(56751,1577,'nl','honderd',0),(56752,1577,'fi','SATA',0),(56753,1577,'no','hundre',0),(56754,1577,'da','hundrede',0),(56755,1577,'ko','ë°±',0),(56756,1577,'he','×ž××•×ª',0),(56757,1577,'el','ÎµÎºÎ±Ï„Î¿Î½Ï„Î¬Î´ÎµÏ‚',0),(56758,1577,'zh','ç™¾\r\n',0),(56759,1577,'sv','hundra',0),(56760,1577,'it','cento',0),(56761,1577,'tl','',0),(56762,1577,'th','&#3619;&#3657;&#3629;&#3618;',0),(56763,1577,'hi','à¤¸à¥Œ',0),(56764,1577,'ms','ratus',0),(56765,1577,'ar','Ù…Ø¦Ø§Øª',0),(56766,1577,'fr','cent',0),(56767,1577,'jp','ç™¾',0),(56768,1577,'pt','cem',0),(56769,1577,'ru','ÑÑ‚Ð¾',0),(56770,1577,'es','cien',0),(56771,1577,'de','hundert',0),(56772,1577,'en','hundred',0),(56773,1578,'is','',0),(56774,1578,'dr','Ø´Ù†Ø§Ø³Ù‡ ',0),(56775,1578,'pr','Ø´Ù†Ø§Ø³Ù‡ ',0),(56776,1578,'tr','KÄ°MLÄ°ÄžÄ°',0),(56777,1578,'pl','ID',0),(56778,1578,'bg','Ð˜Ð”',0),(56779,1578,'ur','Ø´Ù†Ø§Ø®Øª',0),(56780,1578,'sr','Ð˜Ð”',0),(56781,1578,'vi','ID',0),(56782,1578,'af','ID',0),(56783,1578,'ro','ID',0),(56784,1578,'et','ID',0),(56785,1578,'si','ID',0),(56786,1578,'ba','ID',0),(56787,1578,'nl','ID',0),(56788,1578,'fi','TUNNUS',0),(56789,1578,'no','ID',0),(56790,1578,'da','ID',0),(56791,1578,'ko','ID',0),(56792,1578,'he','×ž×–×”×”',0),(56793,1578,'el','ID',0),(56794,1578,'zh','èº«ä»½è¯\r\n',0),(56795,1578,'sv','ID',0),(56796,1578,'it','ID',0),(56797,1578,'tl','',0),(56798,1578,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;',0),(56799,1578,'hi','à¤†à¤ˆà¤¡à¥€',0),(56800,1578,'ms','ID',0),(56801,1578,'ar','Ø§Ù„Ù…Ø¹Ø±Ù‘Ù',0),(56802,1578,'fr','ID',0),(56803,1578,'jp','ID',0),(56804,1578,'pt','ID',0),(56805,1578,'ru','ID',0),(56806,1578,'es','ID',0),(56807,1578,'de','ID',0),(56808,1578,'en','ID',0),(56809,1579,'is','',0),(56810,1579,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø¯Ø± ÙØ§ÙŠÙ„ ØªØ·Ø§Ø¨Ù‚ Ù†Ø¯Ø§Ø±Ø¯ ',0),(56811,1579,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø¯Ø± ÙØ§ÙŠÙ„ ØªØ·Ø§Ø¨Ù‚ Ù†Ø¯Ø§Ø±Ø¯ ',0),(56812,1579,'tr','KimliÄŸi eÅŸleÅŸme dosyasÄ± yoksa.',0),(56813,1579,'pl','ID ma nie pasuje w pliku',0),(56814,1579,'bg','ID Ðµ Ð½Ðµ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð²ÑŠÐ² Ñ„Ð°Ð¹Ð»',0),(56815,1579,'ur','Ø´Ù†Ø§Ø®Øª Ù…Ø³Ù„ Ù…ÛŒÚº Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº ÛÛ’ Û”',0),(56816,1579,'sr','Ð˜Ð” Ð¸Ð¼Ð° Ð½ÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸',0),(56817,1579,'vi','ID khÃ´ng phÃ¹ há»£p',0),(56818,1579,'af','ID het nie \'n gelyke in die lÃªer',0),(56819,1579,'ro','ID are nici un meci Ã®n fiÅŸier',0),(56820,1579,'et','ID on vasteid faili',0),(56821,1579,'si','ID je brez tekmo v datoteko',0),(56822,1579,'ba','ID telah tidak cocok dalam file',0),(56823,1579,'nl','ID heeft geen match in bestand',0),(56824,1579,'fi','ID se ei vastaa tiedoston',0),(56825,1579,'no','ID ikke har noen tilsvarende i filen',0),(56826,1579,'da','ID har ingen match i fil',0),(56827,1579,'ko','IDëŠ” íŒŒì¼ì— ì¼ì¹˜',0),(56828,1579,'he','×‘×ž×–×”×” ××™×Ÿ ×”×ª××ž×” ×‘×§×•×‘×¥',0),(56829,1579,'el','ID Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ ÎºÎ±Î¼Î¯Î± Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯Î± ÏƒÏ„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(56830,1579,'zh','IDæœ‰æ²¡æœ‰æ–‡ä»¶åŒ¹é…\r\n',0),(56831,1579,'sv','ID har ingen match i filen',0),(56832,1579,'it','ID non ha alcuna corrispondenza nei file',0),(56833,1579,'tl','',0),(56834,1579,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3652;&#3617;&#3656;&#3605;&#3619;&#3591;&#3651;&#3609;&#3649;&#3615;&#3657;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(56835,1579,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤®à¥‡à¤‚ à¤•à¥‹à¤ˆ à¤®à¥‡à¤² ID à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(56836,1579,'ms','ID mempunyai padanan dalam fail',0),(56837,1579,'ar','Ù…Ø¹Ø±Ù Ù‚Ø¯ Ù„Ø§ ØªØ·Ø§Ø¨Ù‚ ÙÙŠ Ø§Ù„Ù…Ù„Ù',0),(56838,1579,'fr','ID n\'a pas de correspondance dans le fichier',0),(56839,1579,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?«ä¸€è‡´ã?™ã‚‹ï¼©ï¼¤ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(56840,1579,'pt','ID nÃ£o tem jogo no arquivo.',0),(56841,1579,'ru','ID Ð½Ðµ Ð¸Ð¼ÐµÐµÑ‚ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¸Ñ Ð² Ñ„Ð°Ð¹Ð»Ðµ',0),(56842,1579,'es','ID no tiene equivalente',0),(56843,1579,'de','ID hat keine Ãœbereinstimmung in Datei',0),(56844,1579,'en','ID has no match in file',0),(56845,1580,'is','',0),(56846,1580,'dr','Ø§Ú¯Ø± Ù‡Ø± ÙØ§ÙƒØªÙˆØ±ÙŠ Ù‚Ø¯ÙŠÙ…ÙŠ ØªØ± Ø§Ø² Ø§ÙŠÙ† ØªØ¹Ø¯Ø§Ø¯Ø±ÙˆØ²Ù‡Ø§ÙŠ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ø´Ø¯ Ù‡Ù…Ù‡ Ù…Ø¹ÙˆÙ‚ Ù‡Ø§ Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÙŠ Ø¯Ù‡Ø¯',0),(56847,1580,'pr','Ø§Ú¯Ø± Ù‡Ø± ÙØ§ÙƒØªÙˆØ±ÙŠ Ù‚Ø¯ÙŠÙ…ÙŠ ØªØ± Ø§Ø² Ø§ÙŠÙ† ØªØ¹Ø¯Ø§Ø¯Ø±ÙˆØ²Ù‡Ø§ÙŠ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ø´Ø¯ Ù‡Ù…Ù‡ Ù…Ø¹ÙˆÙ‚ Ù‡Ø§ Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÙŠ Ø¯Ù‡Ø¯',0),(56848,1580,'tr','(herhangi bir deyim-ecek gÃ¶stermek tÃ¼m gÃ¼n daha eski fatura kesiyorsanÄ±z bekleyen.)',0),(56849,1580,'pl','(jeÅ›li wszelkie faktury starsze niÅ¼ ta liczba dni instrukcja pokaÅ¼e wszystkie oczekujÄ…ce.)',0),(56850,1580,'bg','(Ð°ÐºÐ¾ Ð½ÑÐºÐ¾Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð¾-ÑÑ‚Ð°Ñ€Ð¸ Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ Ð±Ñ€Ð¾Ð¹ Ð´Ð½Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ñ‰Ðµ Ð¿Ð¾ÐºÐ°Ð¶Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð²Ð¸ÑÑÑ‰Ð¸.)',0),(56851,1580,'ur','(Ø§Ú¯Ø± Ú©Ø³ÛŒ Ù¾Ø±Ø§Ù†Û’ Ø¨ÛŒØ§Ù† Ø¯Ú©Ú¾Ø§ Ø¯Û’ Ú¯Ø§ ØªÙ…Ø§Ù… Ø¯Ù†ÙˆÚº Ú©ÛŒ Ø§Ø³ ØªØ¹Ø¯Ø§Ø¯ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø§Ù†ÙˆØ§Ø¦Ø³ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§.)',0),(56852,1580,'sr','(Ð°ÐºÐ¾ Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµÑ‚Ðµ ÑÑ‚Ð°Ñ€Ð¸Ñ˜Ðµ Ð¾Ð´ Ð¾Ð²Ð¾Ð³ Ð±Ñ€Ð¾Ñ˜Ð° Ð´Ð°Ð½Ð° Ð¸Ð·Ñ˜Ð°Ð²Ð° Ñ›Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ñ‚Ð¸ ÑÐ²Ðµ Ð½ÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ðµ.)',0),(56853,1580,'vi','(náº¿u cÃ³ hÃ³a Ä‘Æ¡n lÃ¢u hÆ¡n sá»‘ ngÃ y sao kÃª sáº½ hiá»ƒn thá»‹ táº¥t cáº£ Ä‘ang treo)',0),(56854,1580,'af','(as enige faktuur ouer as hierdie getal dae stelling sal Wys alle hangende.)',0),(56855,1580,'ro','(Ã®n cazul Ã®n care orice facturÄƒ mai Ã®n vÃ¢rstÄƒ decÃ¢t acest numÄƒr de zile declaraÅ£ie va arÄƒta toate Ã®n aÅŸteptare.)',0),(56856,1580,'et','(kui Ã¼kski arve on vanem kui Ã¼lalnimetatud, nÃ¤itab vÃ¤ljavÃµte kÃµiki ootel)',0),(56857,1580,'si','(Äe fakturirate vse starejÅ¡i od doloÄenega Å¡tevila dni, izjava bo pokazal vse ÄakajoÄe.)',0),(56858,1580,'ba','(jika ada faktur lebih tua dari jumlah hari pernyataan akan menunjukkan semua tertunda.)',0),(56859,1580,'nl','(als een factureert ouder dan dit aantal dagen verklaring zal Toon alle wachtende.)',0),(56860,1580,'fi','(jos mitÃ¤Ã¤n laskuttaa yli tietyksi pÃ¤ivÃ¤ksi ilmoitus nÃ¤kyy kaikki vireillÃ¤.)',0),(56861,1580,'no','(hvis noen fakturerer eldre enn dette antall dager setningen vil vise alle ventende.)',0),(56862,1580,'da','(hvis noget fakturere Ã¦ldre end dette antal dage erklÃ¦ring vil vise alle ventende.)',0),(56863,1580,'ko','(ëª¨ë“  ì†¡ìž¥ ì¼ ë¬¸ì€ ëª¨ë“  í‘œì‹œ ë©ë‹ˆë‹¤ì´ ê¸°ê°„ ë³´ë‹¤ ì˜¤ëž˜ ëœ ê²½ìš° ë³´ë¥˜ ì¤‘ì¸.)',0),(56864,1580,'he','(×× ×›×œ ×—×©×‘×•× ×™×ª ×©×’×™×œ×Ÿ ×¢×•×œ×” ×¢×œ ×ž×¡×¤×¨ ×™×ž×™× ×”×¦×”×¨×ª ×™×¨××” ×›×œ ×ž×ž×ª×™× ×”.)',0),(56865,1580,'el','(ÎµÎ¬Î½ Î¿Ï€Î¿Î¹Î±Î´Î®Ï€Î¿Ï„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¼ÎµÎ³Î±Î»ÏÏ„ÎµÏÎ± Î±Ï€ÏŒ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î·Î¼ÎµÏÏŽÎ½ Î´Î®Î»Ï‰ÏƒÎ· Î¸Î± Î´ÎµÎ¯Î¾ÎµÎ¹ ÏŒÎ»Î± ÎµÎºÎºÏÎµÎ¼ÎµÎ¯.)',0),(56866,1580,'zh','ï¼ˆå¦‚æœ‰å‘ç¥¨æ¯”è¿™å¤©æ•°çš„å£°æ˜Žæ—§å°†æ˜¾ç¤ºæ‰€æœ‰å¾…åŠžã€‚ï¼‰\r\n',0),(56867,1580,'sv','(om nÃ¥gon faktura Ã¤ldre Ã¤n detta antal dagar uttalande kommer att visa alla vÃ¤ntande.)',0),(56868,1580,'it','(se uno fattura piÃ¹ vecchi di questo numero di giorni di istruzione mostrerÃ  tutti in sospeso.)',0),(56869,1580,'tl','',0),(56870,1580,'th','(if any invoice older than this number of days statement will show all pending.)',0),(56871,1580,'hi','(à¤¯à¤¦à¤¿ à¤•à¥‹à¤ˆ à¤­à¥€ à¤¬à¤¯à¤¾à¤¨ à¤¸à¤­à¥€ à¤¦à¤¿à¤–à¤¾à¤à¤ à¤¹à¥‹à¤—à¤¾ à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥€ à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‡ à¤ªà¥à¤°à¤¾à¤¨à¥‡ à¤šà¤¾à¤²à¤¾à¤¨ à¤²à¤‚à¤¬à¤¿à¤¤.)',0),(56872,1580,'ms','(jika mana-mana invois lebih tua daripada bilangan hari penyata akan menunjukkan semua ini belum selesai.)',0),(56873,1580,'ar','(Ø¥Ø°Ø§ ÙƒØ§Ù† Ø£ÙŠ ÙØ§ØªÙˆØ±Ø© Ø£Ù‚Ø¯Ù… Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ø¹Ø¯Ø¯ Ù…Ù† Ø§Ù„Ø£ÙŠØ§Ù… Ø§Ù„Ø¨ÙŠØ§Ù† Ø³ÙˆÙ ØªØ¸Ù‡Ø± Ø¬Ù…ÙŠØ¹ Ù…Ø¹Ù„Ù‚.)',0),(56874,1580,'fr','(si aucune facture plus vieux que ce nombre de jours relevÃ© indiquera tous en attente.)',0),(56875,1580,'jp','ï¼ˆã?“ã?®è¨˜è¿°æ—¥æ•°ã‚ˆã‚Šã‚‚å?¤ã?„è«‹æ±‚æ›¸ã?Œã?‚ã‚Œã?°å…¨ã?¦ä¿?ç•™ä¸­ã?§è¡¨ç¤ºã?•ã‚Œã?¾ã?™ï¼‰',0),(56876,1580,'pt','(se qualquer fatura mais antigo que este nÃºmero de dias de instruÃ§Ã£o irÃ¡ mostrar todos os pendente.)',0),(56877,1580,'ru','(ÐµÑÐ»Ð¸ ÐºÐ°ÐºÐ¸Ðµ-Ð»Ð¸Ð±Ð¾ ÑÑ‡ÐµÑ‚Ð° ÑÑ‚Ð°Ñ€ÑˆÐµ ÑÑ‚Ð¾Ð³Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð´Ð½ÐµÐ¹ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÐºÐ°Ð¶ÐµÑ‚ Ð²ÑÐµ Ð¾Ð¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ.)',0),(56878,1580,'es','(si alguna factura mÃ¡s antigÃ¼o que este delaraciÃ³n de nÃºmero de dÃ­as mostrarÃ¡ todos pendientes',0),(56879,1580,'de','(wenn alle Ã¤lter als die angegebene Anzahl von Tagen Rechnung Anweisung alle zeigt ausstehenden.)',0),(56880,1580,'en','(if any invoice older than this number of days statement will show all pending.)',0),(56881,1581,'is','',0),(56882,1581,'dr','13 ÙˆØ§Ø¬Ø¯ Ø´Ø±Ø§ÙŠØ· Ø·Ø±Ø­ Ø§Ø³Øª / Ø­Ø±ÙˆÙ(Ù†Ø§Ù…Ù‡) Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ for W-2 print',0),(56883,1581,'pr','Ø§Ú¯Ø± Ù…ÙˆØ±Ø¯ 13 ÙˆØ§Ø¬Ø¯ Ø´Ø±Ø§ÙŠØ· Ø·Ø±Ø­ Ø§Ø³Øª / Ø­Ø±ÙˆÙ(Ù†Ø§Ù…Ù‡) Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ for W-2 print',0),(56884,1581,'tr','EÄŸer kutu 13 plan nitelikli / mektup W-2 yazdÄ±rmak iÃ§in',0),(56885,1581,'pl','JeÅ›li pole 13 wykwalifikowanych planu / list do druku W-2',0),(56886,1581,'bg','ÐÐºÐ¾ Ð³Ñ€Ð°Ñ„Ð° 13 ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð»Ð°Ð½ / Ð¿Ð¸ÑÐ¼Ð¾ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ W-2',0),(56887,1581,'ur','Ø§Ú¯Ø± Ù…Ù†ØµÙˆØ¨Û Ø®Ø§Ù†Û 13 Ú©ÙˆØ§Ù„ÛŒÙØ§Ø¦ÛŒ / Ø­Ø±Ù W-2 Ú©ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’',0),(56888,1581,'sr','ÐÐºÐ¾ Ð¾ÐºÐ²Ð¸Ñ€ 13 ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸ÐºÐ¾Ð²Ð°Ð½ Ð¿Ð»Ð°Ð½ / Ð›ÐµÑ‚Ñ‚ÐµÑ€ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ W-2',0),(56889,1581,'vi','Náº¿u káº¿ hoáº¡ch há»™p 13 Ä‘áº¡t / ThÆ° cho In W-2',0),(56890,1581,'af','As boks 13 gekwalifiseerde plan / brief vir W-2 druk',0),(56891,1581,'ro','ÃŽn cazul Ã®n care caseta 13 calificat planul / scrisoare pentru imprimare W-2',0),(56892,1581,'et','Kui lahtris 13 kvalifitseeritud plaan / W-2 printimiseks kirja',0);
INSERT INTO `langdef` VALUES (56893,1581,'si','ÄŒe polje 13 usposobljeni naÄrt / pismo za tiskanje W-2',0),(56894,1581,'ba','Jika Box 13 berkualitas rencana / surat untuk mencetak W-2',0),(56895,1581,'nl','Als vak 13 gekwalificeerd plan / brief voor W-2 afdrukken',0),(56896,1581,'fi','Jos laatikko 13 suunnitelma / kirje W-2 tulosta',0),(56897,1581,'no','Hvis boksen 13 kvalifisert plan / Letter for W-2 utskrift',0),(56898,1581,'da','Hvis boks 13 kvalificeret plan / brev til W-2 print',0),(56899,1581,'ko','ìƒìž 13 ìžê²©ì„ ê³„íš í•˜ëŠ” ê²½ìš° / W 2 ì¸ì‡„ì— ëŒ€ í•œ íŽ¸ì§€',0),(56900,1581,'he','×× ×ª×™×‘×ª 13 ×ž×•×¡×ž×›×™× ×ª×•×›× ×™×ª / ×ž×›×ª×‘ ×œ×”×“×¤×¡×” W-2',0),(56901,1581,'el','Î•Î¬Î½ Î· Î¸Î­ÏƒÎ· 13 Ï€ÏÎ¿ÏƒÏŒÎ½Ï„Î± ÏƒÏ‡Î­Î´Î¹Î¿ / ÎµÏ€Î¹ÏƒÏ„Î¿Î»Î® Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· W-2',0),(56902,1581,'zh','å¦‚æžœç¬¬13æ åˆæ ¼è®¡åˆ’/ä¿¡çš„W -2æ‰“å°\r\n',0),(56903,1581,'sv','Om fÃ¤lt 13 kvalificerad plan / brev fÃ¶r W-2 Tryck',0),(56904,1581,'it','Se il riquadro 13 qualificato piano / lettera per la stampa di W-2',0),(56905,1581,'tl','',0),(56906,1581,'th','If Box 13 qualified plan / Letter for W-2 print',0),(56907,1581,'hi','à¤¯à¤¦à¤¿ à¤¬à¥‰à¤•à¥à¤¸ 13 à¤¯à¥‹à¤—à¥à¤¯ à¤¯à¥‹à¤œà¤¨à¤¾ / à¤²à¥‡à¤Ÿà¤° W-2 à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤',0),(56908,1581,'ms','Jika kotak 13 layak pelan / Surat untuk mencetak W-2',0),(56909,1581,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ù…Ø±Ø¨Ø¹ 13 Ù…Ø¤Ù‡Ù„ Ø®Ø·Ø©/Ø±Ø³Ø§Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø© Ø«-2',0),(56910,1581,'fr','Si case 13 qualifiÃ© de plan / lettre pour l\'impression de W-2',0),(56911,1581,'jp','If Box 13 qualified plan / Letter for W-2 print',0),(56912,1581,'pt','Se a caixa 13 qualificado plano / carta para impressÃ£o de W-2',0),(56913,1581,'ru','Ð•ÑÐ»Ð¸ Ð¿Ð¾Ð»Ðµ 13 Ð¿Ð»Ð°Ð½ / Ð¿Ð¸ÑÑŒÐ¼Ð¾ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ W-2',0),(56914,1581,'es','Si Caja 13 Plan Calificado / Carta para W-2 impresiÃ³n',0),(56915,1581,'de','Wenn Feld 13 Plan qualifiziert / Brief fÃ¼r W-2-Print',0),(56916,1581,'en','If Box 13 qualified plan / Letter for W-2 print',0),(56917,1582,'is','',0),(56918,1582,'dr','Ø§Ú¯Ø± Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(56919,1582,'pr','Ø§Ú¯Ø± Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(56920,1582,'tr','Kredi kartÄ± numarasÄ±',0),(56921,1582,'pl','Numer karty kredytowej',0),(56922,1582,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(56923,1582,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù†Ù…Ø¨Ø±',0),(56924,1582,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(56925,1582,'vi','Sá»‘ tháº» tÃ­n dá»¥ng',0),(56926,1582,'af','Kredietkaartnommer',0),(56927,1582,'ro','NumÄƒrul cardului de credit',0),(56928,1582,'et','Krediitkaardi Number',0),(56929,1582,'si','Å tevilka kreditne kartice',0),(56930,1582,'ba','Nomor kartu kredit',0),(56931,1582,'nl','Credit cardnummer',0),(56932,1582,'fi','Luottokorttinumero',0),(56933,1582,'no','Kredittkortnummer',0),(56934,1582,'da','Kreditkortnummer',0),(56935,1582,'ko','ì‹ ìš© ì¹´ë“œ ë²ˆí˜¸',0),(56936,1582,'he','×ž×¡×¤×¨ ×›×¨×˜×™×¡ ××©×¨××™',0),(56937,1582,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(56938,1582,'zh','ä¿¡ç”¨å¡å·ç \r\n',0),(56939,1582,'sv','Kreditkortsnummer',0),(56940,1582,'it','Numero di carta di credito',0),(56941,1582,'tl','',0),(56942,1582,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(56943,1582,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¨à¤‚à¤¬à¤°',0),(56944,1582,'ms','Nombor kad kredit',0),(56945,1582,'ar','Ø±Ù‚Ù… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(56946,1582,'fr','NumÃ©ro de carte de crÃ©dit',0),(56947,1582,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ç•ªå?·',0),(56948,1582,'pt','NÃºmero de cartÃ£o de crÃ©dito',0),(56949,1582,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ñ‹',0),(56950,1582,'es','NÃºmero de Tarjeta de CrÃ©dito',0),(56951,1582,'de','Kreditkartennummer',0),(56952,1582,'en','Credit Card Number',0),(56953,1583,'is','',0),(56954,1583,'dr','Ø§Ú¯Ø± Ø§Ù†Ù‚Ø¶Ø§Ø¡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(56955,1583,'pr','Ø§Ú¯Ø± Ø§Ù†Ù‚Ø¶Ø§Ø¡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(56956,1583,'tr','KartÄ± sona erme',0),(56957,1583,'pl','DatÄ™ wygaÅ›niÄ™cia karty',0),(56958,1583,'bg','ÐšÐ°Ñ€Ñ‚Ð° Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ',0),(56959,1583,'ur','Ú©Ø§Ø±Úˆ Ø®ØªÙ… ÛÙˆÙ†Û’',0),(56960,1583,'sr','Ð Ð¾Ðº Ð²Ð°Ð¶ÐµÑšÐ° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(56961,1583,'vi','Tháº» háº¿t háº¡n',0),(56962,1583,'af','Kaart Vervaldatum',0),(56963,1583,'ro','Carte de expirare',0),(56964,1583,'et','Kaardi aegumise',0),(56965,1583,'si','Kartico poteka',0),(56966,1583,'ba','Kartu kadaluarsa',0),(56967,1583,'nl','Vervaldatum van de kaart',0),(56968,1583,'fi','Kortin voimassaolon',0),(56969,1583,'no','Kortet utlÃ¸per',0),(56970,1583,'da','Kort udlÃ¸b',0),(56971,1583,'ko','ì¹´ë“œ ë§Œë£Œ',0),(56972,1583,'he','×ª×•×§×£ ×”×›×¨×˜×™×¡',0),(56973,1583,'el','Î›Î®Î¾Î· ÎºÎ¬ÏÏ„Î±Ï‚',0),(56974,1583,'zh','å¡çš„åˆ°æœŸ\r\n',0),(56975,1583,'sv','Kort utgÃ¥ngsdatum',0),(56976,1583,'it','Scadenza carta',0),(56977,1583,'tl','',0),(56978,1583,'th','&#3610;&#3633;&#3605;&#3619;&#3627;&#3617;&#3604;&#3629;&#3634;&#3618;&#3640;',0),(56979,1583,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿',0),(56980,1583,'ms','Tamat tempoh Kad',0),(56981,1583,'ar','Ø§Ù†ØªÙ‡Ø§Ø¡ ØµÙ„Ø§Ø­ÙŠØ© Ø§Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(56982,1583,'fr','Expiration de la carte',0),(56983,1583,'jp','ã‚«ãƒ¼ãƒ‰æœ‰åŠ¹æœŸé™?',0),(56984,1583,'pt','ExpiraÃ§Ã£o do cartÃ£o',0),(56985,1583,'ru','Ð¡Ñ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(56986,1583,'es','Vencimiento de Tarjeta',0),(56987,1583,'de','Karte-Ablauf',0),(56988,1583,'en','Card Expiration',0),(56989,1584,'is','',0),(56990,1584,'dr','Ø§Ú¯Ø± Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(56991,1584,'pr','Ø§Ú¯Ø± Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(56992,1584,'tr','Gerekirse',0),(56993,1584,'pl','W razie potrzeby',0),(56994,1584,'bg','ÐÐºÐ¾ Ðµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾',0),(56995,1584,'ur','Ø§Ú¯Ø± Ø¶Ø±ÙˆØ±Øª ÛÙˆ ØªÙˆ',0),(56996,1584,'sr','ÐÐºÐ¾ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾',0),(56997,1584,'vi','Náº¿u cáº§n',0),(56998,1584,'af','Indien Benodig',0),(56999,1584,'ro','DacÄƒ este necesar',0),(57000,1584,'et','Vajadusel',0),(57001,1584,'si','ÄŒe je potrebno',0),(57002,1584,'ba','Jika diperlukan',0),(57003,1584,'nl','Indien nodig',0),(57004,1584,'fi','Tarvittaessa',0),(57005,1584,'no','Hvis nÃ¸dvendig',0),(57006,1584,'da','Hvis det er nÃ¸dvendigt',0),(57007,1584,'ko','í•„ìš”í•œ ê²½ìš°',0),(57008,1584,'he','×× ×™×© ×¦×•×¨×š',0),(57009,1584,'el','Î‘Î½ Ï‡ÏÎµÎ¹Î±ÏƒÏ„ÎµÎ¯',0),(57010,1584,'zh','å¦‚æžœéœ€è¦çš„è¯\r\n',0),(57011,1584,'sv','Om det behÃ¶vs',0),(57012,1584,'it','Se necessario',0),(57013,1584,'tl','',0),(57014,1584,'th','&#3606;&#3657;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(57015,1584,'hi','à¤¯à¤¦à¤¿ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥‹ à¤¤à¥‹',0),(57016,1584,'ms','Jika perlu',0),(57017,1584,'ar','Ø¥Ø°Ø§ Ù„Ø²Ù… Ø§Ù„Ø£Ù…Ø±',0),(57018,1584,'fr','Si nÃ©cessaire',0),(57019,1584,'jp','ã‚‚ã?—å¿…è¦?ã?§ã?‚ã‚Œã?°',0),(57020,1584,'pt','Se for necessÃ¡rio',0),(57021,1584,'ru','Ð•ÑÐ»Ð¸ ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾',0),(57022,1584,'es','Si se Necesita',0),(57023,1584,'de','Bei Bedarf',0),(57024,1584,'en','If Needed',0),(57025,1585,'is','',0),(57026,1585,'dr','Ø§Ú¯Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ØªØ§ÙƒÙ†ÙˆÙ† Ù†ØµØ¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ø¨Ø§ Ù…Ø±ÙˆØ±Ú¯Ø± Ø®ÙˆØ¯ Ø§Ø´Ø§Ø±Ù‡ ÙƒÙ†ÙŠØ¯ Ø¨Ù‡ Ø§ÙŠÙ†',0),(57027,1585,'pr','Ø§Ú¯Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ØªØ§ÙƒÙ†ÙˆÙ† Ù†ØµØ¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ø¨Ø§ Ù…Ø±ÙˆØ±Ú¯Ø± Ø®ÙˆØ¯ Ø§Ø´Ø§Ø±Ù‡ ÙƒÙ†ÙŠØ¯ Ø¨Ù‡ Ø§ÙŠÙ†',0),(57028,1585,'tr','Nola henÃ¼z yÃ¼klÃ¼ deÄŸilse, bu yÃ¶nlendirin:',0),(57029,1585,'pl','JeÅ›li Nola nie jest jeszcze zainstalowany, skieruj swojÄ… przeglÄ…darkÄ™ na to:',0),(57030,1585,'bg','ÐÐºÐ¾ Ð¾Ñ‰Ðµ Ð½Ðµ Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½ ÐÐ¾Ð»Ð°, Ð½Ð°ÑÐ¾Ñ‡ÐµÑ‚Ðµ Ð±Ñ€Ð°ÑƒÐ·ÑŠÑ€Ð° ÑÐ¸ ÐºÑŠÐ¼ Ñ‚Ð¾Ð²Ð°:',0),(57031,1585,'ur','Ù†Ø§ÙˆÙ„Û Ø§Ø¨Ú¾ÛŒ Ø§Ù†Ø³Ù¹Ø§Ù„ Ù†ÛÛŒÚº ÛÛ’ ØªÙˆØŒ Ø¢Ù¾ Ú©Û’ Ø¨Ø±Ø§Ø¤Ø²Ø± Ú©Ùˆ Ø§Ø³ Ú©ÛŒ Ø·Ø±Ù Ø§Ø´Ø§Ø±Û:',0),(57032,1585,'sr','ÐÐºÐ¾ ÐÐ¾Ð»Ð° Ñ˜Ð¾Ñˆ Ð½Ð¸Ñ˜Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½Ð°, Ð²Ð°Ñˆ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‡ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ð¾ÐºÐ°Ð·Ð¸Ð²Ð°Ñ‡ Ð½Ð° ÑÑ‚Ð°Ð²ÐºÑƒ Ð¾Ð²Ð¾:',0),(57033,1585,'vi','Náº¿u Nola chÆ°a láº¯p Ä‘áº·t, chá»‰ trÃ¬nh duyá»‡t cá»§a báº¡n tá»›i Ä‘Ã¢y',0),(57034,1585,'af','As waarhede nie nog geÃ¯nstalleer is nie, wys jou blaaier na hierdie:',0),(57035,1585,'ro','DacÄƒ Nola nu este instalat Ã®ncÄƒ, punctul de browser-ul la acest lucru:',0),(57036,1585,'et','Kui Nola pole veel installitud, punkt brauseri see:',0),(57037,1585,'si','ÄŒe Nola ni nameÅ¡Äen Å¡e, da to toÄko vaÅ¡ brskalnik:',0),(57038,1585,'ba','Jika Nola tidak diinstal yet, arahkan browser Anda ke ini:',0),(57039,1585,'nl','Als Nola nog niet is geÃ¯nstalleerd, gaat u uw browser naar dit:',0),(57040,1585,'fi','Jos Nola ei ole vielÃ¤ asennettu, kohta selaimesi tÃ¤stÃ¤:',0),(57041,1585,'no','Hvis Nola ikke er installert ennÃ¥, Pek nettleseren din til dette:',0),(57042,1585,'da','Hvis Nola endnu ikke er installeret, skal du pege din browser til dette:',0),(57043,1585,'ko','ë…¸ë¼ ì•„ì§ ì„¤ì¹˜ ë˜ì–´ ìžˆì§€ ì•Šìœ¼ë©´ì´ ë¸Œë¼ìš°ì €ë¥¼ ê°€ë¦¬í‚¨:',0),(57044,1585,'he','×× × ×•×œ×” ×˜×¨× ×”×•×ª×§×Ÿ, ×”×¦×‘×¢ ×”×“×¤×“×¤×Ÿ ×©×œ×š ×¢×œ ×–×”:',0),(57045,1585,'el','Î•Î¬Î½ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ ÎµÎ³ÎºÎ±Ï„Î±ÏƒÏ„Î±Î¸ÎµÎ¯ Î±ÎºÏŒÎ¼Î± Nola, ÏƒÎ·Î¼ÎµÎ¯Î¿ browser ÏƒÎ±Ï‚ Î³Î¹Î± Î±Ï…Ï„ÏŒ:',0),(57046,1585,'zh','å¦‚æžœNolaå°šæœªå®‰è£…ï¼Œè¯·å°†æµè§ˆå™¨æŒ‡å‘è¿™ä¸€ç‚¹ï¼š\r\n',0),(57047,1585,'sv','Om Nola inte Ã¤r installerat Ã¤nnu, peka din webblÃ¤sare till detta:',0),(57048,1585,'it','Se Nola non Ã¨ ancora installata, puntare il browser a questo:',0),(57049,1585,'tl','',0),(57050,1585,'th','If Nola is not installed yet, point your browser to this:',0),(57051,1585,'hi','Nola à¤…à¤­à¥€ à¤¤à¤• à¤¸à¥à¤¥à¤¾à¤ªà¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ, à¤¤à¥‹ à¤¯à¤¹ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤ªà¤¨à¥‡ à¤¬à¥à¤°à¤¾à¤‰à¤œà¤¼à¤° à¤¬à¤¿à¤‚à¤¦à¥:',0),(57052,1585,'ms','Jika Nola tidak dipasang lagi, Tunjuk pelayar anda ke:',0),(57053,1585,'ar','Ø¥Ø°Ø§ Ù„Ù… ÙŠØªÙ… ØªØ«Ø¨ÙŠØª Ù†ÙˆÙ„Ø§ Ø¨Ø¹Ø¯ØŒ Ø£Ø´Ø± Ø§Ù„Ù…Ø³ØªØ¹Ø±Ø¶ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø¥Ù„Ù‰ Ù‡Ø°Ø§:',0),(57054,1585,'fr','Si Nola n\'est pas encore installÃ©e, pointez votre navigateur sur ceci :',0),(57055,1585,'jp','ã‚‚ã?—Nolaã‚’ã?¾ã? ã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«ã?—ã?¦ã?„ã?ªã?„ã?ªã‚‰ã€?ãƒ–ãƒ©ã‚¦ã‚¶ã‚’ã?“ã?“ã?«å?‘ã?‘ã?¦ã??ã? ã?•ã?„',0),(57056,1585,'pt','Se Nola nÃ£o estiver instalada ainda, aponte seu navegador para isto:',0),(57057,1585,'ru','Ð•ÑÐ»Ð¸ ÐÐ¾Ð»Ð° Ð¿Ð¾ÐºÐ° Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð²Ð°Ñˆ Ð±Ñ€Ð°ÑƒÐ·ÐµÑ€ Ðº ÑÑ‚Ð¾Ð¼Ñƒ:',0),(57058,1585,'es','Si Nola TodavÃ­a no esta instalado, apunta su browser a este:',0),(57059,1585,'de','Wenn Nola noch nicht installiert ist, richten Sie Ihren Browser dazu:',0),(57060,1585,'en','If Nola is not installed yet, point your browser to this:',0),(57061,1586,'is','',0),(57062,1586,'dr','Ø§Ú¯Ø± ÙƒØ§Ù„Ø§ Ø¯Ø±  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù†Ø¨Ø§Ø´Ø¯ ',0),(57063,1586,'pr','Ø§Ú¯Ø± ÙƒØ§Ù„Ø§ Ø¯Ø±  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù†Ø¨Ø§Ø´Ø¯ ',0),(57064,1586,'tr','Yoksa stok maddesi',0),(57065,1586,'pl','JeÅ›li nie towar',0),(57066,1586,'bg','ÐÐºÐ¾ Ð½Ðµ ÑÐºÐ»Ð°Ð´Ð¾Ð² Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(57067,1586,'ur','Ø§Ú¯Ø± Ù†ÛÛŒÚº Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’',0),(57068,1586,'sr','ÐÐºÐ¾ Ð½Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(57069,1586,'vi','Náº¿u khÃ´ng cÃ³ hÃ ng hÃ³a',0),(57070,1586,'af','Indien nie Voorraaditem',0),(57071,1586,'ro','DacÄƒ nu este element de inventar',0),(57072,1586,'et','Kui mitte laokauba',0),(57073,1586,'si','ÄŒe ne zaloge artiklov',0),(57074,1586,'ba','Jika tidak persediaan barang',0),(57075,1586,'nl','Zoniet voorraadartikel',0),(57076,1586,'fi','Jos ei ole Varastotuote',0),(57077,1586,'no','Hvis ikke lagervare',0),(57078,1586,'da','Hvis ikke lagervare',0),(57079,1586,'ko','í•˜ì§€ ì•Šì„ ê²½ìš° ì¸ë²¤í† ë¦¬ í•­ëª©',0),(57080,1586,'he','×× ×œ× ×¤×¨×™×˜ ×”×ž×œ××™',0),(57081,1586,'el','Î‘Î½ Î´ÎµÎ½ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(57082,1586,'zh','å¦‚æžœæ²¡æœ‰åº“å­˜é¡¹ç›®\r\n',0),(57083,1586,'sv','Om inte lagerartikel',0),(57084,1586,'it','Se non l\'articolo di magazzino',0),(57085,1586,'tl','',0),(57086,1586,'th','&#3606;&#3657;&#3634;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(57087,1586,'hi','à¤…à¤—à¤° à¤¨à¤¹à¥€à¤‚ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤®',0),(57088,1586,'ms','Jika tidak inventori',0),(57089,1586,'ar','Ø¥Ù† Ù„Ù… ÙŠÙƒÙ† ØµÙ†Ù Ù…Ø®Ø²ÙˆÙ†',0),(57090,1586,'fr','Sinon article en stock',0),(57091,1586,'jp','åœ¨åº«å“?ç›®ã?§ã?ªã?‹ã?£ã?Ÿã‚‰',0),(57092,1586,'pt','Se nÃ£o for Item de inventÃ¡rio',0),(57093,1586,'ru','Ð•ÑÐ»Ð¸ Ð½Ðµ Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð¼',0),(57094,1586,'es','Si no es Item de Inventario',0),(57095,1586,'de','Wenn nicht-Lagerartikel',0),(57096,1586,'en','If not Inventory Item',0),(57097,1587,'is','',0),(57098,1587,'dr','ØªØµÙˆÙŠØ±',0),(57099,1587,'pr','ØªØµÙˆÙŠØ±',0),(57100,1587,'tr','GÃ¶rÃ¼ntÃ¼',0),(57101,1587,'pl','Obraz',0),(57102,1587,'bg','Ð˜Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(57103,1587,'ur','Ù†Ù‚Ø´',0),(57104,1587,'sr','Ð¡Ð»Ð¸ÐºÐ°',0),(57105,1587,'vi','HÃ¬nh áº£nh',0),(57106,1587,'af','Beeld',0),(57107,1587,'ro','Imagine',0),(57108,1587,'et','Pilt',0),(57109,1587,'si','Podoba',0),(57110,1587,'ba','Gambar',0),(57111,1587,'nl','Afbeelding',0),(57112,1587,'fi','Kuva',0),(57113,1587,'no','Bilde',0),(57114,1587,'da','Billede',0),(57115,1587,'ko','ì´ë¯¸ì§€',0),(57116,1587,'he','×ª×ž×•× ×”',0),(57117,1587,'el','Î•Î¹ÎºÏŒÎ½Î±',0),(57118,1587,'zh','å›¾ç‰‡\r\n',0),(57119,1587,'sv','Bild',0),(57120,1587,'it','Immagine',0),(57121,1587,'tl','',0),(57122,1587,'th','&#3619;&#3641;&#3611;&#3616;&#3634;&#3614;',0),(57123,1587,'hi','à¤›à¤µà¤¿',0),(57124,1587,'ms','Imej',0),(57125,1587,'ar','ØµÙˆØ±Ø© Ø´Ø¹Ø§Ø± Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(57126,1587,'fr','Image',0),(57127,1587,'jp','ã‚¤ãƒ¡ãƒ¼ã‚¸',0),(57128,1587,'pt','Imagem',0),(57129,1587,'ru','Ð˜Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(57130,1587,'es','Imagen',0),(57131,1587,'de','Bild',0),(57132,1587,'en','Image',0),(57133,1588,'is','',0),(57134,1588,'dr','ØªØµÙˆÙŠØ± ÙˆØ¨ Ø³Ø§ÙŠØª\r\n ',0),(57135,1588,'pr','ØªØµÙˆÙŠØ± ÙˆØ¨ Ø³Ø§ÙŠØª\r\n ',0),(57136,1588,'tr','Resim URL\'si',0),(57137,1588,'pl','Adres URL obrazu',0),(57138,1588,'bg','URL Ð°Ð´Ñ€ÐµÑ Ð½Ð° Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(57139,1588,'ur','Ù†Ù‚Ø´ URL',0),(57140,1588,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° ÑÐ»Ð¸ÐºÐµ',0),(57141,1588,'vi','ÄÆ°á»ng dáº«n hÃ¬nh áº£nh',0),(57142,1588,'af','Beeld BA (\"URL\")',0),(57143,1588,'ro','URL-ul imaginii',0),(57144,1588,'et','Pildi URL',0),(57145,1588,'si','Spletni naslov slike',0),(57146,1588,'ba','URL gambar',0),(57147,1588,'nl','Afbeeldings-URL',0),(57148,1588,'fi','Kuvan URL-osoite',0),(57149,1588,'no','Bildewebadresse',0),(57150,1588,'da','Billede URL',0),(57151,1588,'ko','ì´ë¯¸ì§€ URL',0),(57152,1588,'he','×›×ª×•×‘×ª ×”×ª×ž×•× ×”',0),(57153,1588,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· URL ÎµÎ¹ÎºÏŒÎ½Î±Ï‚',0),(57154,1588,'zh','å›¾ç‰‡ç½‘å€\r\n',0),(57155,1588,'sv','Bild-URL',0),(57156,1588,'it','URL dell\'immagine',0),(57157,1588,'tl','',0),(57158,1588,'th','&#3619;&#3641;&#3611;&#3616;&#3634;&#3614; URL',0),(57159,1588,'hi','à¤›à¤µà¤¿ URL',0),(57160,1588,'ms','URL imej',0),(57161,1588,'ar','Ø¹Ù†ÙˆØ§Ù† URL Ù„Ù„ØµÙˆØ±Ø©',0),(57162,1588,'fr','URL de l\'image',0),(57163,1588,'jp','ã‚¤ãƒ¡ãƒ¼ã‚¸ï¼µï¼²ï¼¬',0),(57164,1588,'pt','URL da imagem',0),(57165,1588,'ru','URL-Ð°Ð´Ñ€ÐµÑ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(57166,1588,'es','Imagen URL',0),(57167,1588,'de','Bild-URL',0),(57168,1588,'en','Image URL',0),(57169,1589,'is','',0),(57170,1589,'dr','Ø¨Ù„Ø§ÙØ§ØµÙ„Ù‡ ',0),(57171,1589,'pr','Ø¨Ù„Ø§ÙØ§ØµÙ„Ù‡ ',0),(57172,1589,'tr','Acil',0),(57173,1589,'pl','Natychmiastowe',0),(57174,1589,'bg','ÐÐµÐ·Ð°Ð±Ð°Ð²Ð½Ð¾',0),(57175,1589,'ur','ÙÙˆØ±ÛŒ Ø·ÙˆØ± Ù¾Ø±',0),(57176,1589,'sr','ÐÐµÐ¿Ð¾ÑÑ€ÐµÐ´Ð½Ðµ',0),(57177,1589,'vi','Ngay láº­p tá»©c',0),(57178,1589,'af','Onmiddellike',0),(57179,1589,'ro','ImediatÄƒ',0),(57180,1589,'et','Vahetu',0),(57181,1589,'si','TakojÅ¡nje',0),(57182,1589,'ba','Segera',0),(57183,1589,'nl','Onmiddellijke',0),(57184,1589,'fi','VÃ¤littÃ¶mÃ¤sti',0),(57185,1589,'no','Umiddelbar',0),(57186,1589,'da','Ã˜jeblikkelig',0),(57187,1589,'ko','ì¦‰ì‹œ',0),(57188,1589,'he','×ž×™×™×“×™',0),(57189,1589,'el','Î†Î¼ÎµÏƒÎ·',0),(57190,1589,'zh','ç«‹å³\r\n',0),(57191,1589,'sv','Omedelbar',0),(57192,1589,'it','Immediata',0),(57193,1589,'tl','',0),(57194,1589,'th','&#3648;&#3604;&#3637;&#3659;&#3618;&#3623;&#3609;&#3637;&#3657;',0),(57195,1589,'hi','à¤¤à¤¤à¥à¤•à¤¾à¤²',0),(57196,1589,'ms','Serta-merta',0),(57197,1589,'ar','ÙÙˆØ±ÙŠØ©',0),(57198,1589,'fr','ImmÃ©diate',0),(57199,1589,'jp','ä»Šã?™ã??ã?«',0),(57200,1589,'pt','Imediata',0),(57201,1589,'ru','ÐÐµÐ¼ÐµÐ´Ð»ÐµÐ½Ð½Ð¾Ðµ',0),(57202,1589,'es','Inmediato',0),(57203,1589,'de','Sofortige',0),(57204,1589,'en','Immediate',0),(57205,1590,'is','',0),(57206,1590,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ ',0),(57207,1590,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ ',0),(57208,1590,'tr','HesaplarÄ± al',0),(57209,1590,'pl','Importowania kont',0),(57210,1590,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(57211,1590,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(57212,1590,'sr','Ð£Ð²Ð¾Ð· Ð½Ð°Ð»Ð¾Ð³Ð°',0),(57213,1590,'vi','Káº¿t Chuyá»ƒn TK',0),(57214,1590,'af','Invoer van Rekenige',0),(57215,1590,'ro','Conturile de import',0),(57216,1590,'et','Impordi kontod',0),(57217,1590,'si','Uvozite raÄune',0),(57218,1590,'ba','Mengimpor account',0),(57219,1590,'nl','-Accounts importeren',0),(57220,1590,'fi','Tuo tilit',0),(57221,1590,'no','Importere kontoer',0),(57222,1590,'da','Importere konti',0),(57223,1590,'ko','ìˆ˜ìž… ê³„ì •',0),(57224,1590,'he','×™×‘× ×—×©×‘×•× ×•×ª',0),(57225,1590,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(57226,1590,'zh','å¯¼å…¥å¸æˆ·\r\n',0),(57227,1590,'sv','Importera konton',0),(57228,1590,'it','Importare account',0),(57229,1590,'tl','',0),(57230,1590,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(57231,1590,'hi','à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‹ à¤†à¤¯à¤¾à¤¤',0),(57232,1590,'ms','Import akaun',0),(57233,1590,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(57234,1590,'fr','Importer les comptes',0),(57235,1590,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å?–ã‚Šè¾¼ã‚€',0),(57236,1590,'pt','Contas de importaÃ§Ã£o',0),(57237,1590,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(57238,1590,'es','Cuentas de ImportaciÃ³n',0),(57239,1590,'de','Benutzerkonton',0),(57240,1590,'en','Import Accounts',0),(57241,1591,'is','',0),(57242,1591,'dr','ØªØ¹ÙŠÙŠÙ† Ù…Ø§Ù„ÙŠØ§Øª ',0),(57243,1591,'pr','ØªØ¹ÙŠÙŠÙ† Ù…Ø§Ù„ÙŠØ§Øª ',0),(57244,1591,'tr','Tarh',0),(57245,1591,'pl','NaÅ‚oÅ¼enie',0),(57246,1591,'bg','ÐÐ°Ð»Ð°Ð³Ð°Ð½ÐµÑ‚Ð¾',0),(57247,1591,'ur','ÚˆÙ†Úˆ',0),(57248,1591,'sr','ÐÐ°Ð¼ÐµÑ‚Ð°ÑšÐµ',0),(57249,1591,'vi','Sáº¯p chá»¯',0),(57250,1591,'af','Oplegging',0),(57251,1591,'ro','Impunerea',0),(57252,1591,'et','Kehtestamise',0),(57253,1591,'si','Uvedba',0),(57254,1591,'ba','Pengenaan',0),(57255,1591,'nl','Opleggen',0),(57256,1591,'fi','KÃ¤yttÃ¶Ã¶notto',0),(57257,1591,'no','Overtrykk',0),(57258,1591,'da','IndfÃ¸relsen',0),(57259,1591,'ko','ë¶€ê³¼',0),(57260,1591,'he','××™×ž×¤×•×–×™×¦×™×”',0),(57261,1591,'el','Î•Ï€Î¹Î²Î¿Î»Î®',0),(57262,1591,'zh','å¾æ”¶\r\n',0),(57263,1591,'sv','InfÃ¶randet',0),(57264,1591,'it','Imposizione',0),(57265,1591,'tl','',0),(57266,1591,'th','&#3585;&#3634;&#3619;&#3648;&#3585;&#3655;&#3610;&#3616;&#3634;&#3625;&#3637;',0),(57267,1591,'hi','à¤…à¤§à¤¿à¤°à¥‹à¤ªà¤£',0),(57268,1591,'ms','Pengenaan',0),(57269,1591,'ar','ÙØ±Ø¶',0),(57270,1591,'fr','Imposition',0),(57271,1591,'jp','è³¦èª²',0),(57272,1591,'pt','ImposiÃ§Ã£o',0),(57273,1591,'ru','Ð’Ð²ÐµÐ´ÐµÐ½Ð¸Ðµ',0),(57274,1591,'es','ImposiciÃ³n',0),(57275,1591,'de','EinfÃ¼hrung',0),(57276,1591,'en','Imposition',0),(57277,1592,'is','',0),(57278,1592,'dr','(Ú†Ø§Ù¾',0),(57279,1592,'pr','Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÙŠ (Ú†Ø§Ù¾',0),(57280,1592,'tr','GÃ¶sterimler',0),(57281,1592,'pl','WraÅ¼enia',0),(57282,1592,'bg','Ð˜Ð¼Ð¿Ñ€ÐµÑÐ¸Ð¸',0),(57283,1592,'ur','Ù†Ù‚ÙˆØ´',0),(57284,1592,'sr','Ð£Ñ‚Ð¸ÑÑ†Ð¸',0),(57285,1592,'vi','áº¤n tÆ°á»£ng',0),(57286,1592,'af','Indrukke',0),(57287,1592,'ro','Impresii',0),(57288,1592,'et','Muljed',0),(57289,1592,'si','Vtisi',0),(57290,1592,'ba','Tayangan',0),(57291,1592,'nl','Indrukken',0),(57292,1592,'fi','NÃ¤yttÃ¶kerrat',0),(57293,1592,'no','Visninger',0),(57294,1592,'da','Visninger',0),(57295,1592,'ko','ë…¸ì¶œ',0),(57296,1592,'he','×¨×©×ž×™×',0),(57297,1592,'el','Î•Î½Ï„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚',0),(57298,1592,'zh','å°è±¡\r\n',0),(57299,1592,'sv','Intryck',0),(57300,1592,'it','Impressioni',0),(57301,1592,'tl','',0),(57302,1592,'th','&#3591;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(57303,1592,'hi','à¤›à¤¾à¤ªà¥‡à¤‚',0),(57304,1592,'ms','Jejak',0),(57305,1592,'ar','Ø§Ù†Ø·Ø¨Ø§Ø¹Ø§Øª',0),(57306,1592,'fr','Impressions',0),(57307,1592,'jp','å?°è±¡',0),(57308,1592,'pt','ImpressÃµes',0),(57309,1592,'ru','Ð’Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸Ñ',0),(57310,1592,'es','Impresiones',0),(57311,1592,'de','Impressionen',0),(57312,1592,'en','Impressions',0),(57313,1593,'is','',0),(57314,1593,'dr','- Ø´Ù…Ø§ Ù†ÙŠØ§Ø² Ø¯Ø§Ø±ÙŠØ¯ ÙƒÙ‡ ÙØ§ÙŠÙ„ Ù¾ÙŠÙƒØ±Ø¨Ù†Ø¯ÙŠ Ø±Ø§ Ø§ØµÙ„Ø§Ø­  ÙƒÙ†ÙŠØ¯ . Ø¨Ø³ØªÙ‡ Ø¨Ù‡ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø´Ù…Ø§ â€“Ø§ÙŠÙ† Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¯Ø± Ø¬Ø§Ù‡Ø§ÙŠ Ù…Ø®ØªÙ„Ù Ø¨Ø§Ø´Ø¯ . Ø¨Ù‡ ',0),(57315,1593,'pr','Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±  - Ø´Ù…Ø§ Ù†ÙŠØ§Ø² Ø¯Ø§Ø±ÙŠØ¯ ÙƒÙ‡ ÙØ§ÙŠÙ„ Ù¾ÙŠÙƒØ±Ø¨Ù†Ø¯ÙŠ Ø±Ø§ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ†ÙŠØ¯ . Ø¨Ø³ØªÙ‡ Ø¨Ù‡ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø´Ù…Ø§ â€“Ø§ÙŠÙ† Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¯Ø± Ø¬Ø§Ù‡Ø§ÙŠ Ù…Ø®ØªÙ„Ù Ø¨Ø§Ø´Ø¯ . Ø¨Ù‡ Ø',0),(57316,1593,'tr','Nola kullanmak iÃ§in PHP adÄ±nda PHPs yapÄ±landÄ±rma dosyasÄ±nÄ± dÃ¼zenlemeniz gerekir.INI. Platformunuza baÄŸlÄ± olarak, farklÄ± yerlerde olabilir. Windows, Ã¶rneÄŸin, o bÃ¼yÃ¼k olasÄ±lÄ±kla iÃ§inde C:\\Windows klasÃ¶rÃ¼dÃ¼r.',0),(57317,1593,'pl','Aby uÅ¼yÄ‡ Nola, musisz edytowaÄ‡ plik konfiguracyjny jednych o nazwie PHP.INI. W zaleÅ¼noÅ›ci od platformy moÅ¼e byÄ‡ w rÃ³Å¼nych miejscach. W systemie Windows, na przykÅ‚ad, to najprawdopodobniej w C:\\Windows.',0),(57318,1593,'bg','Ð—Ð° Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ ÐÐ¾Ð»Ð°, Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ PHPs ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ð¾Ð½ÐµÐ½ Ñ„Ð°Ð¹Ð», Ð½Ð°Ñ€ÐµÑ‡ÐµÐ½ PHP.INI. Ð’ Ð·Ð°Ð²Ð¸ÑÐ¸Ð¼Ð¾ÑÑ‚ Ð¾Ñ‚ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð»Ð°Ñ‚Ñ„Ð¾Ñ€Ð¼Ð° Ñ‚Ñ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð½Ð° Ñ€Ð°Ð·Ð»Ð',0),(57319,1593,'ur','Ù†Ø§ÙˆÙ„Û Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¢Ù¾ Ù ØªØ±ØªÛŒØ¨ Ø¯ÛŒÙ†Û’ Ú©ÛŒ ÙØ§Ø¦Ù„ Ù¾ÛŒ Ø§ÛŒÚ† Ù¾ÛŒ Ú©Ø§ Ù†Ø§Ù… Ø§ÛŒÚˆÙ¹ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”INI ÛÛ’ Û” Ø§Ù¾Ù†Û’ Ù¾Ù„ÛŒÙ¹ ÙØ§Ø±Ù… Ù¾Ø± Ø§Ù†Ø­ØµØ§Ø± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ø§Ø³ Ù…ÛŒÚº Ù…Ø®ØªÙ„Ù',0),(57320,1593,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ð»Ð¸ ÐÐ¾Ð»Ð°, Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ ÑƒÑ€ÐµÐ´Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ñ˜Ðµ ÐŸÐ¥ÐŸÑ Ð¿Ð¾ Ð¸Ð¼ÐµÐ½Ñƒ ÐŸÐ¥ÐŸ. Ð˜ÐÐ˜. Ð£ Ð·Ð°Ð²Ð¸ÑÐ½Ð¾ÑÑ‚Ð¸ Ð¾Ð´ ÑÐ²Ð¾Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ñ„Ð¾Ñ€Ð¼Ðµ, Ð´Ð° Ñ˜Ðµ Ð½Ð° Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð¸Ñ‚Ð¸Ð¼ Ð',0),(57321,1593,'vi','Äá»ƒ cÃ³ thá»ƒ sá»­ dá»¥ng NolaPro báº¡n pháº£i sá»­a há»“ sÆ¡ chá»©c nÄƒng PHP tÃªn PHP.INI. Há»“ sÆ¡ nÃ y cÃ³ thá»ƒ á»Ÿ chá»— khÃ¡c nhau tÃ¹y vÃ o cáº¥u hÃ¬nh cá»§a báº¡n. VD á»¡ Window há»“ sÆ¡ nÃ y cÃ³ thá»ƒ á»Ÿ C:\\Windows.',0),(57322,1593,'af','Om Nola te gebruik, het u nodig om die PHPs struktuurlÃªer genaamd PHP.INI te redigeer. Afhangend van u bedryfstelsel, mag dit in verskillende plekke wees.  In Windows, byvoorbeeld, is dit heel moontlik in C:\\Windows.',0),(57323,1593,'ro','Pentru a utiliza Nola, trebuie sÄƒ editaÅ£i fiÅŸierul de configurare PHPs numit PHP.INI. ÃŽn funcÅ£ie de platforma, aceasta poate fi Ã®n locuri diferite. ÃŽn Windows, de exemplu, este cel mai probabil in C:\\Windows.',0),(57324,1593,'et','Nola kasutamiseks peate redigeerima PHPs konfiguratsiooni fail nimega PHP.INI. SÃµltuvalt oma platvormist vÃµib erinevates kohtades. OpsÃ¼steemis Windows nt seda tÃµenÃ¤oliselt C:\\Windows.',0),(57325,1593,'si','ÄŒe Å¾elite uporabljati Nola, vi potreba v izdajati PHPs zunanja podoba pila imenovan PHP.INI. Glede na svojo platformo, je lahko v razliÄnih krajih. V sistemu Windows, na primer, je najbolj verjetno v C:\\Windows.',0),(57326,1593,'ba','Untuk menggunakan Nola, Anda perlu mengedit file konfigurasi PHPs bernama PHP.INI. Bergantung dari platform Anda, mungkin di tempat yang berbeda. Di Windows, misalnya, sangat mungkin di C:\\Windows.',0),(57327,1593,'nl','Om te kunnen gebruiken Nola, moet u PHPs configuratiebestand met de naam PHP bewerken.INI. Afhankelijk van uw platform, kan zij in verschillende plaatsen. In Windows, bijvoorbeeld, is het meest waarschijnlijk in C:\\Windows.',0),(57328,1593,'fi','Jotta voit kÃ¤yttÃ¤Ã¤ Nola, sinun tÃ¤ytyy muokata PHPs kokoonpano arkistoida maine PHP.INI. Riippuen kÃ¤yttÃ¶ympÃ¤ristÃ¶stÃ¤ se voi olla eri paikoissa. Windows esimerkiksi, se on todennÃ¤kÃ¶isesti kansiossa C:\\Windows.',0),(57329,1593,'no','Bruke Nola, mÃ¥ du redigere PHPs konfigurasjonen arkiv benevnt PHP.INI. Avhengig av hvilken plattform, kan det vÃ¦re pÃ¥ forskjellige steder. I Windows, for eksempel er det sannsynligvis i C:\\Windows.',0),(57330,1593,'da','Bruge Nola, skal du redigere PHPs konfigurationsfil benÃ¦vnt PHP.INI. AfhÃ¦ngigt af din platform, kan det i forskellige steder. I Windows, for eksempel, er det sandsynligvis i C:\\Windows.',0),(57331,1593,'ko','ë…¸ë¼ë¥¼ ì‚¬ìš© í•˜ë ¤ë©´ PHP ë¼ëŠ” PHPs êµ¬ì„± íŒŒì¼ì„ íŽ¸ì§‘ í•´ì•¼ í•©ë‹ˆë‹¤.INIìž…ë‹ˆë‹¤. ì‚¬ìš© ì¤‘ì¸ í”Œëž«í¼ì— ë”°ë¼ ê·¸ê²ƒì€ ë‹¤ë¥¸ ìž¥ì†Œì— ìžˆì„ ìˆ˜ ìžˆìŠµë‹ˆë‹¤. Windowsì—ì„œ ì˜ˆë¥¼ ë“¤ë©´, ê·¸ê²ƒì€ ëŒ€ë¶€ë¶„ì˜ ì•„ë§ˆ C:\\Windows ì',0),(57332,1593,'he','×¢×œ ×ž× ×ª ×œ×”×©×ª×ž×© × ×•×œ×”, ×¢×œ×™×š ×œ×¢×¨×•×š ××ª ×§×•×‘×¥ ×”×ª×¦×•×¨×” PHPs ×‘×©× PHP.INI. ×‘×”×ª×× ×¤×œ×˜×¤×•×¨×ž×ª ×©×œ×š, ×–×” ×¢×©×•×™ ×œ×”×™×•×ª ×‘×ž×§×•×ž×•×ª ×©×•× ×™×. ×‘- Windows, ×œ×“×•×’×ž×”, ×–×” ×›×›×œ ×”× ×¨××” C:\\Windows.',0),(57333,1593,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ Nola, Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ PHPs Î±ÏÏ‡ÎµÎ¯Î¿ ÏÏ…Î¸Î¼Î¯ÏƒÎµÏ‰Î½ Ï€Î¿Ï… Î¿Î½Î¿Î¼Î¬Î¶ÎµÏ„Î±Î¹ PHP.INI. Î‘Î½Î¬Î»Î¿Î³Î± Î¼Îµ Ï„Î·Î½ Ï€Î»Î±Ï„Ï†ÏŒÏÎ¼Î± ÏƒÎ±Ï‚, Î¼Ï€Î¿ÏÎµÎ¯',0),(57334,1593,'zh','ä¸ºäº†ä½¿ç”¨Nolaï¼Œä½ éœ€è¦ç¼–è¾‘çš„åä¸ºphp.iniçš„ PHPçš„é…ç½®æ–‡ä»¶ã€‚æ ¹æ®æ‚¨çš„å¹³å°ï¼Œå®ƒå¯èƒ½ä¼šåœ¨ä¸åŒçš„åœ°æ–¹ã€‚åœ¨Windowsä¸­ï¼Œä¾‹å¦‚ï¼Œå®ƒæ˜¯æœ€æœ‰å¯èƒ½åœ¨Cï¼š\\Windowsã€‚\r\n',0),(57335,1593,'sv','AnvÃ¤nda Nola, mÃ¥ste du redigera PHPs konfigurationsfilen heter PHP.INI. Beroende pÃ¥ din plattform, kan det vara pÃ¥ olika stÃ¤llen. I Windows, till exempel, Ã¤r det troligen i C:\\Windows.',0),(57336,1593,'it','Per poter utilizzare Nola, Ã¨ necessario modificare file di configurazione PHPs denominato PHP.INI. A seconda della vostra piattaforma, puÃ² essere in luoghi diversi. In Windows, ad esempio, Ã¨ piÃ¹ probabilmente in C:\\Windows.',0),(57337,1593,'tl','',0),(57338,1593,'th','In order to use Nola, you need to edit PHPs configuration file named PHP.INI. Depending on your platform, it may be in different places. In Windows, for example, it is most probably in C:\\Windows.',0),(57339,1593,'hi','Nola à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤†à¤ª PHP à¤¨à¤¾à¤® PHPs à¤•à¥‰à¤¨à¥à¤«à¤¼à¤¿à¤—à¤°à¥‡à¤¶à¤¨ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥ˆà¥¤INI. à¤…à¤ªà¤¨à¥‡ à¤®à¤‚à¤š à¤•à¥‡ à¤†à¤§à¤',0),(57340,1593,'ms','Untuk menggunakan Nola, anda perlu untuk mengedit fail konfigurasi PHPs bernama PHP.INI. Bergantung kepada platform anda, ia mungkin di tempat yang berbeza. Dalam Windows, sebagai contoh, ia adalah yang paling di C:\\Windows.',0),(57341,1593,'ar','Ù…Ù† Ø£Ø¬Ù„ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù†ÙˆÙ„Ø§ØŒ ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ ØªØ­Ø±ÙŠØ± Ù…Ù„Ù Ø§Ù„ØªÙƒÙˆÙŠÙ† ÙŠÙŠØ³Ø± Ø§Ù„Ù…Ø³Ù…Ù‰ Ø¨ÙŠ.INI. Ø§Ø¹ØªÙ…Ø§Ø¯Ø§Ù‹ Ø¹Ù„Ù‰ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø£Ø³Ø§Ø³ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨ÙƒØŒ ÙØ¥Ù†Ù‡ Ù‚Ø¯ ÙŠÙƒÙˆÙ† ÙÙŠ Ø£Ù…Ø§ÙƒÙ† Ù…Ø®ØªÙ„ÙØ©. ÙÙŠ Window',0),(57342,1593,'fr','Pour pouvoir utiliser Nola, vous devez modifier le fichier de configuration de php nommÃ© PHP.INI. Selon votre plate-forme, il peut Ãªtre Ã  des endroits diffÃ©rents. Dans Windows, par exemple, il est trÃ¨s probablement dans C:\\Windows.',0),(57343,1593,'jp','Noraã‚’åˆ©ç”¨ã?™ã‚‹ã?Ÿã‚?ã?«ã?¯ã€?PHP.INI.ã?¨å??å‰?ã?®ã?¤ã?„ã?ŸPHPï½“ã‚³ãƒ³ãƒ•ã‚£ã‚®ãƒ¥ãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ç·¨é›†ã?—ã?ªã??ã?¦ã?¯ã?ªã‚Šã?¾ã?›ã‚“ã€‚ã??ã?®ãƒ•ã‚¡ã‚¤ãƒ«ã?¯ãƒ—ãƒ©ãƒƒãƒˆãƒ•ã‚©ãƒ¼ãƒ ã?«ã‚ˆã‚Šé?•ã?†å ´æ‰€ã?«ã?‚ã‚Šã?¾ã?™ã€‚ä¾‹ã?ˆã?°ã‚¦ã‚¤',0),(57344,1593,'pt','Para utilizar a Nola, vocÃª precisa editar PHPs arquivo de configuraÃ§Ã£o chamado PHP.INI. Dependendo da sua plataforma, pode ser em lugares diferentes. No Windows, por exemplo, Ã© mais provavelmente em C:\\Windows.',0),(57345,1593,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÐÐ¾Ð»Ð°, Ð²Ð°Ð¼ Ð½ÑƒÐ¶Ð½Ð¾ Ð¾Ñ‚Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ð¸ PHPs Ð¸Ð¼ÐµÐ½ÐµÐ¼ PHP.INI. Ð’ Ð·Ð°Ð²Ð¸ÑÐ¸Ð¼Ð¾ÑÑ‚Ð¸ Ð¾Ñ‚ Ð²Ð°ÑˆÐµÐ¹ Ð¿Ð»Ð°Ñ‚Ñ„Ð¾Ñ€Ð¼Ñ‹ ÑÑ‚Ð¾ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð² Ñ€Ð°Ð·Ð½',0),(57346,1593,'es','para usar Nola, necesita editar el file de configuraciÃ³n de PHP que se llama PHP:INI. Dependiendo de su plataforma, puede estar en diferentes lugares. En Windows, por ejemplo, probablamente esta en C:\\Windows.',0),(57347,1593,'de','Um Nola zu verwenden, mÃ¼ssen Sie PHPs-Konfigurationsdatei mit dem Namen PHP bearbeiten.INI. AbhÃ¤ngig von deiner Plattform kann es an verschiedenen Orten sein. Unter Windows ist es beispielsweise sehr wahrscheinlich in C:\\Windows.',0),(57348,1593,'en','In order to use Nola, you need to edit PHPs configuration file named PHP.INI. Depending on your platform, it may be in different places. In Windows, for example, it is most probably in C:\\Windows.',0),(57349,1594,'is','',0),(57350,1594,'dr','In PHP.INI, you need to set <B>register_globals</B> to <B>ON</B>.',0),(57351,1594,'pr','In PHP.INI, you need to set <B>register_globals</B> to <B>ON</B>.',0),(57352,1594,'tr','PHP\'de.INI, <B>register_globals</B> <B>ON</B>olarak ayarlamanÄ±z gerekir.',0),(57353,1594,'pl','W PHP.INI, ty potrzebowaÄ‡ wobec umieszczaÄ‡ <B>register_globals</B> <B>na</B>.',0),(57354,1594,'bg','Ð’ PHP.INI, Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ <B>register_globals</B> Ð´Ð° <B>Ð½</B>.',0),(57355,1594,'ur','Ù¾ÛŒ Ø§ÛŒÚ† Ù¾ÛŒ Ù…ÛŒÚº Û”INI, Ø¢Ù¾ <B>register_globals</B> Ú©Ø±Ù†Û’ <B>Ù¾Ø±</B>Ù…Ø±ØªØ¨ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(57356,1594,'sr','Ð£ ÐŸÐ¥ÐŸ. Ð˜ÐÐ˜ , Ñ‚Ñ€ÐµÐ±Ð°Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ð¸ <B>Ñ€ÐµÐ³Ð¸ÑÑ‚ÐµÑ€_Ð³Ð»Ð¾Ð±Ð°Ð»Ñ</B> Ð´Ð° <B>ÐžÐ</B>.',0),(57357,1594,'vi','Trong PHP.INI, báº¡n cáº§n setup <B>register_globals</B> to <B>ON</B>.',0),(57358,1594,'af','In PHP.INI, moet u <B>register_globals<b> stel na <B>ON</B>.',0),(57359,1594,'ro','ÃŽn PHP.INI, trebuie sÄƒ setaÅ£i <B>register_globals</B> <B>on</B>.',0),(57360,1594,'et','Php.INI, peate seadistama <B>register_globals</B> <B>ON</B>.',0),(57361,1594,'si','V PHP.INI, morate nastaviti <B>register_globals</B> <B>on</B>.',0),(57362,1594,'ba','Dalam PHP.INI, Anda perlu mengatur <B>register_globals</B> <B>on</B>.',0),(57363,1594,'nl','In PHP.INI, moet u instellen van <B>register_globals</B> <B>aan</B>.',0),(57364,1594,'fi','Php.INI sinun tÃ¤ytyy <B> <B>register_globals</B> -asennossa</B>.',0),(57365,1594,'no','I PHP.INI, mÃ¥ du angi <B>register_globals</B> <B>pÃ¥</B>.',0),(57366,1594,'da','I PHP.INI, skal du indstille <B>register_globals</B> til <B>ON</B>.',0),(57367,1594,'ko','Php.INI, <B>register_globals</B> <B>ON</B>ìœ¼ë¡œ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(57368,1594,'he','×‘- PHP.INI, ×¢×œ×™×š ×œ×”×’×“×™×¨ ××ª <B>register_globals</B> ×œ- <B>ON</B>.',0),(57369,1594,'el','Î£Ï„Î·Î½ PHP.INI, Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¯ÏƒÎµÏ„Îµ <B>register_globals</B> ÏƒÏ„Î¿ <B>ON</B>.',0),(57370,1594,'zh','åœ¨PHP.iniï¼Œä½ éœ€è¦è®¾ç½®çš„<b> register_globalsçš„ä¸º<b>æ‰“å¼€ã€‚\r\n',0),(57371,1594,'sv','I PHP.INI, mÃ¥ste du stÃ¤lla in <B>register_globals</B> <B>on</B>.',0),(57372,1594,'it','In PHP.INI, Ã¨ necessario impostare <B>register_globals</B> <B>on</B>.',0),(57373,1594,'tl','',0),(57374,1594,'th','In PHP.INI, you need to set <B>register_globals</B> to <B>ON</B>.',0),(57375,1594,'hi','PHP à¤®à¥‡à¤‚à¥¤INI, à¤†à¤ª <B>à¤°à¤œà¤¿à¤¸à¥à¤Ÿà¤° _ à¤—à¥à¤²à¥‹à¤¬à¤²à¥à¤¸</B> à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ <B>à¤ªà¤°</B>à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥ˆà¥¤',0),(57376,1594,'ms','Dalam Bahasa pengaturcaraan PHP.INI, anda perlu menyediakan <B>register_globals</B> untuk <B>ON</B>.',0),(57377,1594,'ar','ÙÙŠ Ø¨ÙŠ Ø¥ØªØ´ Ø¨ÙŠ.INIØŒ ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ ØªØ¹ÙŠÙŠÙ† <B>register_globals</B> <B>ON</B>.',0),(57378,1594,'fr','En PHP.INI, vous devrez rÃ©gler <B>register_globals</B> sur <B>ON</B>.',0),(57379,1594,'jp','PHP.INI.ã?®ä¸­ã?«<B>register_globals</B> to <B>ON</B>ã‚’è¨­å®šã?—ã?ªã??ã?¦ã?¯ã?ªã‚Šã?¾ã?›ã‚“ã€‚',0),(57380,1594,'pt','Em PHP.INI, vocÃª precisa definir o <B>register_globals</B> <B>on</B>.',0),(57381,1594,'ru','Ð’ PHP.INI, Ð²Ð°Ð¼ Ð½ÑƒÐ¶Ð½Ð¾ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ <B>register_globals</B> Ñ <B>ON</B>.',0),(57382,1594,'es','En PHP:INI necesita configurar <B>register_globals<B> to <B>ON</B>',0),(57383,1594,'de','In PHP.INI, mÃ¼ssen Sie <B>Register_globals</B> auf <B>ON</B>festgelegt.',0),(57384,1594,'en','In PHP.INI, you need to set <B>register_globals</B> to <B>ON</B>.',0),(57385,1595,'is','',0),(57386,1595,'dr','Ø¯Ø± Ù…Ø±Ø­Ù„Ù‡',0),(57387,1595,'pr','Ø¯Ø± Ù…Ø±Ø­Ù„Ù‡',0),(57388,1595,'tr','adÄ±mda',0),(57389,1595,'pl','w kroku',0),(57390,1595,'bg','Ð² ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(57391,1595,'ur','Ù…ÛŒÚº Ù‚Ø¯Ù…',0),(57392,1595,'sr','Ñƒ ÐºÐ¾Ñ€Ð°ÐºÑƒ',0),(57393,1595,'vi','theo bÆ°á»›c',0),(57394,1595,'af','in stap',0),(57395,1595,'ro','Ã®n pasul',0),(57396,1595,'et','juhises',0),(57397,1595,'si','v korak',0),(57398,1595,'ba','dalam langkah',0),(57399,1595,'nl','in stap',0),(57400,1595,'fi','vaiheessa',0),(57401,1595,'no','i trinn',0),(57402,1595,'da','i trin',0),(57403,1595,'ko','ë‹¨ê³„ì—ì„œ',0),(57404,1595,'he','×‘×©×œ×‘',0),(57405,1595,'el','ÏƒÏ„Î¿ Î²Î®Î¼Î±',0),(57406,1595,'zh','æœ‰æ­¥éª¤\r\n',0),(57407,1595,'sv','i steg',0),(57408,1595,'it','nel passaggio',0),(57409,1595,'tl','',0),(57410,1595,'th','&#3651;&#3609;&#3586;&#3633;&#3657;&#3609;&#3605;&#3629;&#3609;',0),(57411,1595,'hi','à¤šà¤°à¤£ à¤®à¥‡à¤‚',0),(57412,1595,'ms','dalam langkah',0),(57413,1595,'ar','ÙÙŠ Ø®Ø·ÙˆØ©',0),(57414,1595,'fr','Ã  l\'Ã©tape',0),(57415,1595,'jp','ä¸€è‡´',0),(57416,1595,'pt','na etapa',0),(57417,1595,'ru','Ð² Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¸',0),(57418,1595,'es','en paso',0),(57419,1595,'de','im Schritt',0),(57420,1595,'en','in step',0),(57421,1596,'is','',0),(57422,1596,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(57423,1596,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(57424,1596,'tr','Stok birimi',0),(57425,1596,'pl','Spis jednostek',0),(57426,1596,'bg','Ð ÐµÐºÐ»Ð°Ð¼Ð½Ð¸ Ð¼ÐµÑÑ‚Ð°',0),(57427,1596,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ ÛŒÙˆÙ†Ù¹Ø³',0),(57428,1596,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(57429,1596,'vi','ÄÆ¡n vá»‹ hÃ ng trong kho',0),(57430,1596,'af','Voorraad Eenhede',0),(57431,1596,'ro','UnitÄƒÅ£ile de stoc',0),(57432,1596,'et','LaoÃ¼hikute',0),(57433,1596,'si','Inventar enota',0),(57434,1596,'ba','Unit persediaan',0),(57435,1596,'nl','Eenheden van de inventaris',0),(57436,1596,'fi','VarastoyksikÃ¶issÃ¤',0),(57437,1596,'no','Lagerenheter',0),(57438,1596,'da','Lagerenheder',0),(57439,1596,'ko','ìž¬ê³  ë‹¨ìœ„',0),(57440,1596,'he','×™×—×™×“×•×ª ×ž×œ××™',0),(57441,1596,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(57442,1596,'zh','åº“å­˜å•ä½\r\n',0),(57443,1596,'sv','Lagerenheter',0),(57444,1596,'it','UnitÃ  di inventario',0),(57445,1596,'tl','',0),(57446,1596,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;',0),(57447,1596,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(57448,1596,'ms','Unit inventori',0),(57449,1596,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(57450,1596,'fr','UnitÃ©s de stock',0),(57451,1596,'jp','æ£šå?¸å?˜ä½?',0),(57452,1596,'pt','Unidades de estoque',0),(57453,1596,'ru','Ð•Ð´',0),(57454,1596,'es','Unidades de Inventario',0),(57455,1596,'de','Lagereinheiten',0),(57456,1596,'en','Inventory Units',0),(57457,1597,'is','',0),(57458,1597,'dr','Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(57459,1597,'pr','Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(57460,1597,'tr',' kullanÄ±mda',0),(57461,1597,'pl',' w uÅ¼yciu',0),(57462,1597,'bg',' Ð² ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(57463,1597,'ur',' Ø²ÛŒØ± Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(57464,1597,'sr',' Ñƒ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸',0),(57465,1597,'vi',' Ä‘ang sá»­ dá»¥ng',0),(57466,1597,'af',' in gebruik',0),(57467,1597,'ro',' Ã®n utilizarea',0),(57468,1597,'et',' kasutusel',0),(57469,1597,'si',' v uporabi',0),(57470,1597,'ba',' digunakan',0),(57471,1597,'nl',' in gebruik',0),(57472,1597,'fi',' kÃ¤ytÃ¶ssÃ¤',0),(57473,1597,'no',' i bruk',0),(57474,1597,'da',' i brug',0),(57475,1597,'ko',' ì‚¬ìš©',0),(57476,1597,'he',' ×‘×©×™×ž×•×©',0),(57477,1597,'el',' ÏƒÎµ Ï‡ÏÎ®ÏƒÎ·',0),(57478,1597,'zh','åœ¨ä½¿ç”¨\r\n',0),(57479,1597,'sv',' anvÃ¤nds',0),(57480,1597,'it',' in uso',0),(57481,1597,'tl','',0),(57482,1597,'th','&#3651;&#3609;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;',0),(57483,1597,'hi',' à¤‰à¤ªà¤¯à¥‹à¤— à¤®à¥‡à¤‚',0),(57484,1597,'ms',' dalam penggunaan',0),(57485,1597,'ar',' ÙÙŠ Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(57486,1597,'fr',' en cours d\'utilisation',0),(57487,1597,'jp','ä½¿ç”¨ä¸­',0),(57488,1597,'pt',' em uso',0),(57489,1597,'ru',' Ð² Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(57490,1597,'es','en uso',0),(57491,1597,'de',' im Einsatz',0),(57492,1597,'en',' in use',0),(57493,1598,'is','',0),(57494,1598,'dr','ØºÙŠØ± ÙØ¹Ø§Ù„ ',0),(57495,1598,'pr','ØºÙŠØ± ÙØ¹Ø§Ù„ ',0),(57496,1598,'tr','Etkin olmayan',0),(57497,1598,'pl','Nieaktywne',0),(57498,1598,'bg','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸',0),(57499,1598,'ur','ØºÛŒØ± ÙØ¹Ø§Ù„',0),(57500,1598,'sr','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð°',0),(57501,1598,'vi','KhÃ´ng hoáº¡t Ä‘á»™ng',0),(57502,1598,'af','Onaktief',0),(57503,1598,'ro','Inactiv',0),(57504,1598,'et','Passiivsed',0),(57505,1598,'si','Neaktivni',0),(57506,1598,'ba','Tidak aktif',0),(57507,1598,'nl','Inactief',0),(57508,1598,'fi','Passiivinen',0),(57509,1598,'no','Inaktiv',0),(57510,1598,'da','Inaktive',0),(57511,1598,'ko','ë¹„í™œì„±',0),(57512,1598,'he','×œ× ×¤×¢×™×œ',0),(57513,1598,'el','Î‘Î½ÎµÎ½ÎµÏÎ³ÏŒ',0),(57514,1598,'zh','å·²åœç”¨\r\n',0),(57515,1598,'sv','Inaktiva',0),(57516,1598,'it','Inattivo',0),(57517,1598,'tl','',0),(57518,1598,'th','&#3595;&#3638;&#3656;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(57519,1598,'hi','à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯',0),(57520,1598,'ms','Tidak aktif',0),(57521,1598,'ar','Ø®Ø§Ù…Ù„',0),(57522,1598,'fr','Inactif',0),(57523,1598,'jp','ä¸?æ´»å‹•',0),(57524,1598,'pt','Inativo',0),(57525,1598,'ru','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ð¹',0),(57526,1598,'es','Inactivo',0),(57527,1598,'de','Inaktiv',0),(57528,1598,'en','Inactive',0),(57529,1599,'is','',0),(57530,1599,'dr','Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù† ØŸ',0),(57531,1599,'pr','Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù† ØŸ',0),(57532,1599,'tr','Dahil edilsin mi?',0),(57533,1599,'pl','ZawieraÄ‡?',0),(57534,1599,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð°?',0),(57535,1599,'ur','Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚºØŸ',0),(57536,1599,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ?',0),(57537,1599,'vi','Bao gá»“m?',0),(57538,1599,'af','Ingesluit?',0),(57539,1599,'ro','Includ?',0),(57540,1599,'et','Kaasata?',0),(57541,1599,'si','VkljuÄujejo?',0),(57542,1599,'ba','Termasuk?',0),(57543,1599,'nl','Opnemen?',0),(57544,1599,'fi','SisÃ¤ltÃ¤Ã¤?',0),(57545,1599,'no','Ta?',0),(57546,1599,'da','Omfatter?',0),(57547,1599,'ko','í¬í•¨?',0),(57548,1599,'he','×”×× ×œ×›×œ×•×œ?',0),(57549,1599,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½;',0),(57550,1599,'zh','åŒ…æ‹¬ä»€ä¹ˆå‘¢ï¼Ÿ\r\n',0),(57551,1599,'sv','Inkludera?',0),(57552,1599,'it','Includere?',0),(57553,1599,'tl','',0),(57554,1599,'th','&#3619;&#3623;&#3617;&#3604;&#3657;&#3623;&#3618;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(57555,1599,'hi','à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚?',0),(57556,1599,'ms','Termasuk?',0),(57557,1599,'ar','Ø¥Ø¯Ø±Ø§Ø¬ ØŸ',0),(57558,1599,'fr','Inclure ?',0),(57559,1599,'jp','å?«ã‚?ã?¾ã?™ã?‹ï¼Ÿ',0),(57560,1599,'pt','Incluir?',0),(57561,1599,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ?',0),(57562,1599,'es','Incluir?',0),(57563,1599,'de','Enthalten?',0),(57564,1599,'en','Include?',0),(57565,1600,'is','',0),(57566,1600,'dr','Ø¨Ù‡Ø±Ù‡ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(57567,1600,'pr','Ø¨Ù‡Ø±Ù‡ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(57568,1600,'tr','Ã–nceden faiz dahil',0),(57569,1600,'pl','ObejmujÄ… wczeÅ›niejsze zainteresowania',0),(57570,1600,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð»Ð¸Ñ…Ð²Ð°',0),(57571,1600,'ur','Ù¾ÛŒØ´Ú¯ÛŒ Ø³ÙˆØ¯ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(57572,1600,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¸Ð³ÑƒÐ¼Ð°Ð½ ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(57573,1600,'vi','Bao gá»“m lÃ£i suáº¥t trÆ°á»›c',0),(57574,1600,'af','Sluit vooraf belangstelling',0),(57575,1600,'ro','Includ prealabilÄƒ interes',0),(57576,1600,'et','Kaasa eelnevad viivised',0),(57577,1600,'si','VkljuÄuje predhodno obresti',0),(57578,1600,'ba','Termasuk bunga sebelumnya',0),(57579,1600,'nl','Voorafgaande interesten',0),(57580,1600,'fi','SisÃ¤llytetÃ¤Ã¤n ennen korko',0),(57581,1600,'no','Inkluder fÃ¸r renter',0),(57582,1600,'da','Omfatte forudgÃ¥ende interesse',0),(57583,1600,'ko','ì´ì „ ì´ìž í¬í•¨',0),(57584,1600,'he','×›×•×œ×œ×•×ª ×¨×™×‘×™×ª ×ž×•×§×“×ž×ª',0),(57585,1600,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï„ÏŒÎºÎ¿Ï…Ï‚ ÎµÎº Ï„Ï‰Î½ Ï€ÏÎ¿Ï„Î­ÏÏ‰Î½',0),(57586,1600,'zh','åŒ…æ‹¬ä¼˜å…ˆæƒç›Š\r\n',0),(57587,1600,'sv','Inkludera tidigare intresse',0),(57588,1600,'it','Includono previo interesse',0),(57589,1600,'tl','',0),(57590,1600,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3607;&#3637;&#3656;&#3617;&#3637;&#3617;&#3634;&#3585;&#3656;&#3629;&#3609;',0),(57591,1600,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤¬à¥à¤¯à¤¾à¤œ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(57592,1600,'ms','Termasuk faedah terlebih dahulu',0),(57593,1600,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(57594,1600,'fr','Inclure les intÃ©rÃªts antÃ©rieurs',0),(57595,1600,'jp','å„ªå…ˆåˆ©å­?ã‚‚å?«ã‚?ã‚‹',0),(57596,1600,'pt','Incluem o interesse prÃ©vio',0),(57597,1600,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ñ€Ð°Ð½ÐµÐµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(57598,1600,'es','Incluir InterÃ©ses Anteriores',0),(57599,1600,'de','Sind vorherige Interesse',0),(57600,1600,'en','Include Prior Interest',0),(57601,1601,'is','',0),(57602,1601,'dr','(Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ Ù‡Ø§)Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ØŸ',0),(57603,1601,'pr','ÙØ³Ø® Ù‡Ø§ (Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ Ù‡Ø§)Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ØŸ',0),(57604,1601,'tr','BoÅŸluklar dahil edilsin mi?',0),(57605,1601,'pl','ObejmujÄ… pustki?',0),(57606,1601,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÐºÑƒÑ…Ð¸Ð½Ð¸?',0),(57607,1601,'ur','Ø¯Ø±Ø¬Ø§Øª Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚºØŸ',0),(57608,1601,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ðµ?',0),(57609,1601,'vi','Bao gá»“m há»§y?',0),(57610,1601,'af','Sluit leemtes?',0),(57611,1601,'ro','Includ goluri?',0),(57612,1601,'et','Kaasata tÃ¼hjad?',0),(57613,1601,'si','VkljuÄujejo praznin?',0),(57614,1601,'ba','Termasuk void?',0),(57615,1601,'nl','Omvatten vides?',0),(57616,1601,'fi','SisÃ¤llytÃ¤ tyhjÃ¤t?',0),(57617,1601,'no','Ta tomrom?',0),(57618,1601,'da','Omfatter brud?',0),(57619,1601,'ko','ê³µ ê·¹ì„ í¬í•¨?',0),(57620,1601,'he','×›×•×œ×œ ×—×œ×œ×™×?',0),(57621,1601,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ ÎºÎµÎ½Î¬;',0),(57622,1601,'zh','åŒ…æ‹¬æ— æ•ˆï¼Ÿ\r\n',0),(57623,1601,'sv','Inkludera hÃ¥ligheter?',0),(57624,1601,'it','Sono vuoti?',0),(57625,1601,'tl','',0),(57626,1601,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3604;&#3657;&#3623;&#3618;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(57627,1601,'hi','Voids à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚?',0),(57628,1601,'ms','Termasuk lompang?',0),(57629,1601,'ar','ØªØªØ¶Ù…Ù† ÙØ±Ø§ØºØ§ØªØŸ',0),(57630,1601,'fr','Inclure des vides ?',0),(57631,1601,'jp','ç„¡åŠ¹ã‚‚å?«ã‚?ã?¾ã?™ã?‹ï¼Ÿ',0),(57632,1601,'pt','Incluir espaÃ§os vazios?',0),(57633,1601,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ð¿ÑƒÑÑ‚Ð¾Ñ‚Ñ‹?',0),(57634,1601,'es','Incluir Anulados?',0),(57635,1601,'de','Enthalten HohlrÃ¤ume?',0),(57636,1601,'en','Include Voids?',0),(57637,1602,'is','',0),(57638,1602,'dr','(Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡)Ø¯Ø± Ø³Ø·Ø­  ',0),(57639,1602,'pr','Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´Ø¯Ù‡ (Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡)Ø¯Ø± Ø³Ø·Ø­  ',0),(57640,1602,'tr','DÃ¼zeyinin',0),(57641,1602,'pl','Zawarte w poziomie',0),(57642,1602,'bg','Ð’ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð² Ð½Ð¸Ð²Ð¾',0),(57643,1602,'ur','Ø³Ø·Ø­ Ù…ÛŒÚº Ø´Ø§Ù…Ù„',0),(57644,1602,'sr','Ð¡Ð°Ð´Ñ€Ð¶Ð¸ Ð½Ð¸Ð²Ð¾',0),(57645,1602,'vi','ÄÃ£ bao gá»“m trong má»©c',0),(57646,1602,'af','Ingesluit in Vlak',0),(57647,1602,'ro','Incluse Ã®n nivelul',0),(57648,1602,'et','Kaasatud tase',0),(57649,1602,'si','VkljuÄeni v ravni',0),(57650,1602,'ba','Termasuk dalam tingkat',0),(57651,1602,'nl','Opgenomen in niveau',0),(57652,1602,'fi','Tason mukaan',0),(57653,1602,'no','Inkludert i nivÃ¥',0),(57654,1602,'da','Inkluderet i niveau',0),(57655,1602,'ko','ìˆ˜ì¤€ì— í¬í•¨ ë¨',0),(57656,1602,'he','×›×œ×•×œ ×‘×¨×ž×”',0),(57657,1602,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿',0),(57658,1602,'zh','åŒ…æ‹¬åœ¨æ°´å¹³\r\n',0),(57659,1602,'sv','IngÃ¥r i nivÃ¥',0),(57660,1602,'it','Incluso nel livello',0),(57661,1602,'tl','',0),(57662,1602,'th','&#3619;&#3623;&#3617;&#3651;&#3609;&#3619;&#3632;&#3604;&#3633;&#3610;&#3609;&#3637;&#3657;&#3604;&#3657;&#3623;&#3618;',0),(57663,1602,'hi','à¤¸à¥à¤¤à¤° à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤²',0),(57664,1602,'ms','Termasuk di peringkat',0),(57665,1602,'ar','ÙˆØ´Ù…Ù„Øª ÙÙŠ Ù…Ø³ØªÙˆÙ‰',0),(57666,1602,'fr','Inclus dans le niveau',0),(57667,1602,'jp','ã??ã?®ãƒ¬ãƒ™ãƒ«ã?«å?«ã?¾ã‚Œã‚‹',0),(57668,1602,'pt','IncluÃ­dos no nÃ­vel',0),(57669,1602,'ru','Ð’ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ Ð² ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ',0),(57670,1602,'es','Incluido en Nivel',0),(57671,1602,'de','In Ebene enthalten',0),(57672,1602,'en','Included in Level',0),(57673,1603,'is','',0),(57674,1603,'dr','ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ ÙˆØ²ÙŠØ§Ù† Ø¨Ø±Ø§ÙŠ',0),(57675,1603,'pr','ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ ÙˆØ²ÙŠØ§Ù† Ø¨Ø±Ø§ÙŠ',0),(57676,1603,'tr','Gelir tablosu iÃ§in',0),(57677,1603,'pl','Rachunek zyskÃ³w istrat za',0),(57678,1603,'bg','ÐŸÑ€Ð¸Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð°',0),(57679,1603,'ur','Ø¢Ù…Ø¯Ù†ÛŒ Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(57680,1603,'sr','Ð‘Ð¸Ð»Ð°Ð½ÑÐ° Ð·Ð°',0),(57681,1603,'vi','BÃ¡o cÃ¡o thu nháº­p cho',0),(57682,1603,'af','Inkomste Staat vir',0),(57683,1603,'ro','DeclaraÅ£ia de venit pentru',0),(57684,1603,'et','Kasumiaruanne',0),(57685,1603,'si','Izkaz poslovnega izida za',0),(57686,1603,'ba','Laporan laba rugi untuk',0),(57687,1603,'nl','Winst-en verliesrekening voor',0),(57688,1603,'fi','Tuloslaskelman',0),(57689,1603,'no','Resultatregnskapet for',0),(57690,1603,'da','ResultatopgÃ¸relsen for',0),(57691,1603,'ko','ì†ìµ ê³„ì‚° ì„œì— ëŒ€ í•œ',0),(57692,1603,'he','×“×•×— ×¨×•×•×— ×•×”×¤×¡×“ ×¢×‘×•×¨',0),(57693,1603,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÏƒÏŒÎ´Ï‰Î½ ÎºÎ±Î¹ ÎµÎ¾ÏŒÎ´Ï‰Î½ Î³Î¹Î±',0),(57694,1603,'zh','æŸç›Šè¡¨\r\n',0),(57695,1603,'sv','ResultatrÃ¤kningen fÃ¶r',0),(57696,1603,'it','Conto economico per',0),(57697,1603,'tl','',0),(57698,1603,'th','&#3591;&#3610;&#3585;&#3635;&#3652;&#3619;&#3586;&#3634;&#3604;&#3607;&#3640;&#3609;&#3586;&#3629;&#3591;',0),(57699,1603,'hi','à¤†à¤¯ à¤¸à¥à¤Ÿà¥‡à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤',0),(57700,1603,'ms','Penyata pendapatan bagi',0),(57701,1603,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¯Ø®Ù„ Ù„Ù€',0),(57702,1603,'fr','Ã‰tat des rÃ©sultats pour',0),(57703,1603,'jp','å?Žå…¥æ±ºç®—æ›¸',0),(57704,1603,'pt','DemonstraÃ§Ã£o de resultados',0),(57705,1603,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑÑ… Ð¸ ÑƒÐ±Ñ‹Ñ‚ÐºÐ°Ñ… Ð·Ð°',0),(57706,1603,'es','DeclaraciÃ³n de Ingresos para',0),(57707,1603,'de','Gewinn-und Verlustrechnung',0),(57708,1603,'en','Income Statement for',0),(57709,1604,'is','',0),(57710,1604,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ù…Ù„ Ù†Ø´Ø¯Ù‡ ',0),(57711,1604,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ù…Ù„ Ù†Ø´Ø¯Ù‡ ',0),(57712,1604,'tr','Eksik veri!',0),(57713,1604,'pl','Niekompletne dane!',0),(57714,1604,'bg','ÐÐµÐ¿ÑŠÐ»Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸!',0),(57715,1604,'ur','Ù†Ø§Ù…Ú©Ù…Ù„ Ú©ÙˆØ§Ø¦Ù!',0),(57716,1604,'sr','ÐÐµÐ¿Ð¾Ñ‚Ð¿ÑƒÐ½Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ!',0),(57717,1604,'vi','Dá»¯ liá»‡u chÆ°a hoÃ n chá»‰nh',0),(57718,1604,'af','Onvolledige Data!',0),(57719,1604,'ro','Date incomplete!',0),(57720,1604,'et','MittetÃ¤ielikud andmed!',0),(57721,1604,'si','Nepopolnih podatkov!',0),(57722,1604,'ba','Data lengkap!',0),(57723,1604,'nl','Onvolledige gegevens!',0),(57724,1604,'fi','Puutteelliset tiedot!',0),(57725,1604,'no','Ufullstendige Data!',0),(57726,1604,'da','UfuldstÃ¦ndige Data!',0),(57727,1604,'ko','ë¶ˆì™„ì „ í•œ ë°ì´í„°!',0),(57728,1604,'he','×”× ×ª×•× ×™× ×œ× ×ž×œ××™×!',0),(57729,1604,'el','Î•Î»Î»Î¹Ï€Î® Î´ÎµÎ´Î¿Î¼Î­Î½Î±!',0),(57730,1604,'zh','ä¸å®Œæ•´çš„æ•°æ®ï¼\r\n',0),(57731,1604,'sv','OfullstÃ¤ndiga uppgifter!',0),(57732,1604,'it','Dati incompleti!',0),(57733,1604,'tl','',0),(57734,1604,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3652;&#3617;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(57735,1604,'hi','à¤…à¤ªà¥‚à¤°à¥à¤£ à¤¡à¥‡à¤Ÿà¤¾!',0),(57736,1604,'ms','Data yang tidak lengkap!',0),(57737,1604,'ar','Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ØºÙŠØ± Ù…ÙƒØªÙ…Ù„Ø©!',0),(57738,1604,'fr','DonnÃ©es incomplÃ¨tes !',0),(57739,1604,'jp','ä¸?å®Œå…¨ã?ªãƒ‡ãƒ¼ã‚¿ã?§ã?™ï¼?',0),(57740,1604,'pt','Dados incompletos!',0),(57741,1604,'ru','ÐÐµÐ¿Ð¾Ð»Ð½Ñ‹Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ!',0),(57742,1604,'es','Datos Incompletos',0),(57743,1604,'de','UnvollstÃ¤ndige Daten!',0),(57744,1604,'en','Incomplete Data!',0),(57745,1605,'is','',0),(57746,1605,'dr','Ø§Ù†Ø¯ÙˆÙ†Ø²ÙŠØ§ÙŠÙŠ',0),(57747,1605,'pr','Ø§Ù†Ø¯ÙˆÙ†Ø²ÙŠØ§ÙŠÙŠ',0),(57748,1605,'tr','Endonezya dili',0),(57749,1605,'pl','Indonezyjski',0),(57750,1605,'bg','Ð˜Ð½Ð´Ð¾Ð½ÐµÐ·Ð¸Ð¹ÑÐºÐ¸',0),(57751,1605,'ur','Ø§Ù†ÚˆÙˆÙ†ÙŠØ´ÙŠÙ†',0),(57752,1605,'sr','Ð¸Ð½Ð´Ð¾Ð½ÐµÐ¶Ð°Ð½ÑÐºÐ¸',0),(57753,1605,'vi','Indonesia',0),(57754,1605,'af','Indonesiese',0),(57755,1605,'ro','IndonezianÄƒ',0),(57756,1605,'et','Indoneesia',0),(57757,1605,'si','indonezijÅ¡Äina',0),(57758,1605,'ba','Indonesia',0),(57759,1605,'nl','Indonesisch',0),(57760,1605,'fi','indonesia',0),(57761,1605,'no','Indonesisk',0),(57762,1605,'da','indonesisk',0),(57763,1605,'ko','ì¸ë„ë„¤ì‹œì•„ì–´',0),(57764,1605,'he','××™× ×“×•× ×–×™×ª',0),(57765,1605,'el','Î™Î½Î´Î¿Î½Î·ÏƒÎ¹Î±ÎºÎ¬',0),(57766,1605,'zh','å°åº¦å°¼è¥¿äºš\r\n',0),(57767,1605,'sv','Indonesiska',0),(57768,1605,'it','Indonesiano',0),(57769,1605,'tl','',0),(57770,1605,'th','&#3594;&#3634;&#3623;&#3629;&#3636;&#3609;&#3650;&#3604;&#3609;&#3637;&#3648;&#3595;&#3637;&#3618;',0),(57771,1605,'hi','à¤‡à¤‚à¤¡à¥‹à¤¨à¥‡à¤¶à¤¿à¤¯à¤¾à¤ˆ',0),(57772,1605,'ms','Indonesia',0),(57773,1605,'ar','Ø§Ù„Ø¥Ù†Ø¯ÙˆÙ†ÙŠØ³ÙŠØ©',0),(57774,1605,'fr','IndonÃ©sien',0),(57775,1605,'jp','ã‚¤ãƒ³ãƒ‰ãƒ?ã‚·ã‚¢èªž',0),(57776,1605,'pt','IndonÃ©sio',0),(57777,1605,'ru','Ð¸Ð½Ð´Ð¾Ð½ÐµÐ·Ð¸Ð¹ÑÐºÐ¸Ð¹',0),(57778,1605,'es','Indonesio',0),(57779,1605,'de','Indonesisch',0),(57780,1605,'en','Indonesian',0),(57781,1606,'is','',0),(57782,1606,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(57783,1606,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(57784,1606,'tr','Bilgi:',0),(57785,1606,'pl','Informacji',0),(57786,1606,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(57787,1606,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(57788,1606,'sr','Ð˜Ð½Ñ„Ð¾',0),(57789,1606,'vi','ThÃ´ng Tin',0),(57790,1606,'af','Inligting',0),(57791,1606,'ro','Info',0),(57792,1606,'et','Info',0),(57793,1606,'si','Info',0),(57794,1606,'ba','Info',0),(57795,1606,'nl','Info',0),(57796,1606,'fi','Info',0),(57797,1606,'no','Info',0),(57798,1606,'da','Info',0),(57799,1606,'ko','ì •ë³´',0),(57800,1606,'he','×¤×¨×˜×™',0),(57801,1606,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(57802,1606,'zh','ä¿¡æ¯\r\n',0),(57803,1606,'sv','Information',0),(57804,1606,'it','Info',0),(57805,1606,'tl','',0),(57806,1606,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(57807,1606,'hi','à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(57808,1606,'ms','Maklumat',0),(57809,1606,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(57810,1606,'fr','Info',0),(57811,1606,'jp','æƒ…å ±',0),(57812,1606,'pt','InformaÃ§Ã£o',0),(57813,1606,'ru','Ð˜Ð½Ñ„Ð¾',0),(57814,1606,'es','Info',0),(57815,1606,'de','Info',0),(57816,1606,'en','Info',0),(57817,1607,'is','',0),(57818,1607,'dr','ØªÙ…Ø§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø²ÙŠØ± Ø§ÙŠÙ† Ù†Ù‚Ø·Ù‡ ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø§Ø³Øª',0),(57819,1607,'pr','ØªÙ…Ø§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø²ÙŠØ± Ø§ÙŠÙ† Ù†Ù‚Ø·Ù‡ ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø§Ø³Øª',0),(57820,1607,'tr','BU NOKTANIN ALTINDAKÄ° TÃœM BÄ°LGÄ°LERÄ° YALNIZCA YAZDIRMA Ã–ÄžELERÄ°NÄ° OLDUÄžUNU',0),(57821,1607,'pl','WSZYSTKIE INFORMACJE PONIÅ»EJ TEN PUNKT JEST TYLKO W POZYCJI WYDRUKU',0),(57822,1607,'bg','Ð¦Ð¯Ð›ÐÐ¢Ð Ð˜ÐÐ¤ÐžÐ ÐœÐÐ¦Ð˜Ð¯ ÐŸÐž-Ð”ÐžÐ›Ð£ Ð¢ÐÐ—Ð˜ Ð¢ÐžÐ§ÐšÐ Ð• Ð—Ð ÐŸÐ•Ð§ÐÐ¢ Ð¡ÐÐœÐž Ð•Ð›Ð•ÐœÐ•ÐÐ¢Ð˜',0),(57823,1607,'ur','ØªÙ…Ø§Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ø³ Ù†Ú©ØªÛ’ Ú©Û’ Ù†ÛŒÚ†Û’ ØµØ±Ù Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ù„ÛŒÛ’ ÛÛ’ Û”',0),(57824,1607,'sr','Ð¡Ð’Ð• Ð˜ÐÐ¤ÐžÐ ÐœÐÐ¦Ð˜ÐˆÐ• Ð˜Ð¡ÐŸÐžÐ” ÐžÐ’ÐžÐ“ Ð¢Ð Ð•ÐÐ£Ð¢ÐšÐ ÐˆÐ• Ð—Ð Ð¡ÐÐœÐž Ð¨Ð¢ÐÐœÐŸÐÐŠÐ• Ð¡Ð¢ÐÐ’ÐšÐ˜',0),(57825,1607,'vi','Táº¥t cáº£ ThÃ´ng Tin dÆ°á»›i Ä‘iá»ƒm nÃ y dÃ nh cho hÃ ng in',0),(57826,1607,'af','ALLE INLIGTING VERBY HIERDIE PUNT IS VIR DRUK ITEMS ALLEENLIK',0),(57827,1607,'ro','TOATE INFORMAÅ¢IILE DE MAI JOS ACEST PUNCT ESTE PENTRU IMPRIMARE ARTICOLE NUMAI',0),(57828,1607,'et','PRINDI KAUPADELE ON KOGU TEAVE ALLPOOL KÃ„ESOLEVAS PUNKTIS',0),(57829,1607,'si','VSE INFORMACIJE POD TO TOÄŒKO JE ZA TISKANJE ELEMENTOV LE',0),(57830,1607,'ba','SEMUA INFORMASI DI BAWAH INI POINT ADALAH UNTUK MENCETAK ITEM HANYA',0),(57831,1607,'nl','ALLE INFORMATIE ONDER DIT PUNT IS VOOR GEDRUKTE ITEMS ALLEEN',0),(57832,1607,'fi','KAIKKI TIEDOT TÃ„MÃ„N RAJAN ALLE ON VAIN TULOSTA KOHTEET',0),(57833,1607,'no','ALL INFORMASJON UNDER DETTE PUNKTET ER FOR SKRIVE UT VARER BARE',0),(57834,1607,'da','ALLE OPLYSNINGER UNDER DETTE PUNKT ER FOR PRINT VARER KUN',0),(57835,1607,'ko','ì´ ì´ë•Œ ì•„ëž˜ì˜ ëª¨ë“  ì •ë³´ëŠ” ì¸ì‡„ í•­ëª©ì—ë§Œ í•´ë‹¹',0),(57836,1607,'he','×›×œ ×”×ž×™×“×¢ ×ž×ª×—×ª ×œ× ×§×•×“×” ×–×• ×”×™× ×¢×‘×•×¨ ×¤×¨×™×˜×™× ×”×”×“×¤×¡×” ×‘×œ×‘×“',0),(57837,1607,'el','ÎŒÎ›Î‘ Î¤Î‘ Î£Î¤ÎŸÎ™Î§Î•ÎŠÎ‘ ÎšÎ†Î¤Î© Î‘Î ÎŒ Î‘Î¥Î¤ÎŒ Î¤ÎŸ Î£Î—ÎœÎ•ÎŠÎŸ Î•ÎŠÎÎ‘Î™ Î“Î™Î‘ Î•ÎšÎ¤Î¥Î ÎÎ£Î•Î™Î£ ÎœÎŒÎÎŸ',0),(57838,1607,'zh','æ‰€æœ‰ä½ŽäºŽæ­¤ç‚¹çš„ä¿¡æ¯ä»…ä½œæ‰“å°é¡¹ç›®\r\n',0),(57839,1607,'sv','ALL INFORMATION UNDER DENNA PUNKT Ã„R FÃ–R SKRIVA UT ARTIKLAR ENDAST',0),(57840,1607,'it','TUTTE LE INFORMAZIONI SOTTO QUESTO PUNTO SONO PER GLI ARTICOLI STAMPA SOLO',0),(57841,1607,'tl','',0),(57842,1607,'th','ALL INFORMATION BELOW THIS POINT IS FOR PRINT ITEMS ONLY',0),(57843,1607,'hi','à¤‡à¤¸ à¤¬à¤¿à¤‚à¤¦à¥ à¤•à¥‡ à¤¨à¥€à¤šà¥‡ à¤¸à¤­à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤®à¤¦à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¥€ à¤¹à¥ˆ',0),(57844,1607,'ms','SEMUA MAKLUMAT DI BAWAH INI ADALAH BAGI CETAKAN ITEM SAHAJA',0),(57845,1607,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø£Ø¯Ù†Ø§Ù‡ Ù‡Ø°Ù‡ Ø§Ù„Ù†Ù‚Ø·Ø© Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¹Ù†Ø§ØµØ± ÙÙ‚Ø·',0),(57846,1607,'fr','TOUTES LES INFORMATIONS SOUS CE POINT SONT POUR IMPRIMER UNIQUEMENT LES Ã‰LÃ‰MENTS',0),(57847,1607,'jp','ã?“ã?®ãƒ?ã‚¤ãƒ³ãƒˆã?®ä¸‹ã?®å…¨ã?¦ã?®æƒ…å ±ã?¯å?°åˆ·å“?ç›®ã?®ã?Ÿã‚?ã? ã?‘ã?§ã?™',0),(57848,1607,'pt','TODAS AS INFORMAÃ‡Ã•ES ABAIXO DESTE PONTO SÃƒO PARA APENAS IMPRIMIR ITENS',0),(57849,1607,'ru','Ð’Ð¡Ð¯ Ð˜ÐÐ¤ÐžÐ ÐœÐÐ¦Ð˜Ð¯ ÐÐ˜Ð–Ð• Ð­Ð¢ÐžÐ™ Ð¢ÐžÐ§ÐšÐ˜ â€” Ð¢ÐžÐ›Ð¬ÐšÐž Ð”Ð›Ð¯ ÐŸÐ•Ð§ÐÐ¢Ð˜',0),(57850,1607,'es','TODA INFORMACIÃ“N ABAJO DE ESTE PUNTO ES PARA IMPRIMIR ITEMS SOLAMENTE',0),(57851,1607,'de','ALLE INFORMATIONEN UNTER DIESEM PUNKT SIND FÃœR NUR DRUCKEN ARTIKEL',0),(57852,1607,'en','ALL INFORMATION BELOW THIS POINT IS FOR PRINT ITEMS ONLY',0),(57853,1608,'is','',0),(57854,1608,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§ÙˆÙ„ÙŠÙ‡ ',0),(57855,1608,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ÙˆÙ„ÙŠÙ‡ ',0),(57856,1608,'tr','BaÅŸlangÄ±Ã§ miktarÄ±',0),(57857,1608,'pl','PoczÄ…tkowa iloÅ›Ä‡',0),(57858,1608,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(57859,1608,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù‚ÛŒ',0),(57860,1608,'sr','Ð˜Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ ÐšÐ¾Ð».',0),(57861,1608,'vi','Sá»‘ lÆ°á»£ng ban Ä‘áº§u',0),(57862,1608,'af','Aanvanklike Hoev.',0),(57863,1608,'ro','Cantitate iniÅ£ialÄƒ',0),(57864,1608,'et','Algne kogus',0),(57865,1608,'si','ZaÄetna koliÄina',0),(57866,1608,'ba','Awal Qty',0),(57867,1608,'nl','Aanvankelijke hoeveelheid',0),(57868,1608,'fi','AlkuperÃ¤inen mÃ¤Ã¤rÃ¤',0),(57869,1608,'no','FÃ¸rste Ant',0),(57870,1608,'da','Indledende Qty',0),(57871,1608,'ko','ì´ˆê¸° ìˆ˜ëŸ‰',0),(57872,1608,'he','×›×ž×•×ª ×¨××©×•× ×™×ª',0),(57873,1608,'el','Î‘ÏÏ‡Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(57874,1608,'zh','åˆå§‹æ•°é‡\r\n',0),(57875,1608,'sv','Inledande Kvt',0),(57876,1608,'it','Qty iniziale',0),(57877,1608,'tl','',0),(57878,1608,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3648;&#3619;&#3636;&#3656;&#3617;&#3649;&#3619;&#3585;',0),(57879,1608,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(57880,1608,'ms','Qty awal',0),(57881,1608,'ar','Ø§Ù„ÙƒÙ…Ù‘ÙŠØ© Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(57882,1608,'fr','QuantitÃ© initiale',0),(57883,1608,'jp','åˆ?æœŸé‡?',0),(57884,1608,'pt','Qty inicial',0),(57885,1608,'ru','ÐŸÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¾Ð±ÑŠÐµÐ¼',0),(57886,1608,'es','Cant. Inicial',0),(57887,1608,'de','AnfÃ¤ngliche Qty',0),(57888,1608,'en','Initial Qty',0),(57889,1609,'is','',0),(57890,1609,'dr','NolaPro!',0),(57891,1609,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯ â€“ Ø¨Ø§ ØªØ´ÙƒØ± Ø§Ø² Ø´Ù…Ø§ Ø¨Ø±Ø§ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±  NolaPro!',0),(57892,1609,'tr','Kurulum tamamlandÄ± - NolaPro kullanarak iÃ§in teÅŸekkÃ¼r ederiz!',0),(57893,1609,'pl','Konfiguracja zakoÅ„czona - dziÄ™kujÄ™ za NolaPro!',0),(57894,1609,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸ - Ð‘Ð»Ð°Ð³Ð¾Ð´Ð°Ñ€Ñ Ð²Ð¸ Ð·Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ NolaPro!',0),(57895,1609,'ur','Ù…Ú©Ù…Ù„ - Ø´Ú©Ø±ÛŒÛ Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ø§Ù¾!',0),(57896,1609,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ð´Ð¾Ð²Ñ€ÑˆÐ¸ - Ð¥Ð²Ð°Ð»Ð° Ð²Ð°Ð¼ ÑˆÑ‚Ð¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾!',0),(57897,1609,'vi','HoÃ n táº¥t Setup - CÃ¡m Æ¡n Ä‘Ã£ sá»­ dá»¥ng NolaPro!',0),(57898,1609,'af','Opstelling is Voltooi - Dankie dat u NolaPro gebruik!',0),(57899,1609,'ro','Configurare completÄƒ - vÄƒ mulÅ£umesc pentru ajutorul NolaPro!',0),(57900,1609,'et','Setup Complete - TÃ¤nan teid kasutades NolaPro!',0),(57901,1609,'si','Setup Complete - hvala NolaPro!',0),(57902,1609,'ba','Setup Complete - terima kasih untuk menggunakan NolaPro!',0),(57903,1609,'nl','Setup voltooid - dank u voor het gebruik van NolaPro!',0),(57904,1609,'fi','Setup Complete - Thank you for using NolaPro!',0),(57905,1609,'no','Oppsett fullfÃ¸rt - takk for bruk av NolaPro!',0),(57906,1609,'da','Setup komplet - Tak fordi du bruger NolaPro!',0),(57907,1609,'ko','ì„¤ì¹˜ ì™„ë£Œ-NolaProë¥¼ ì‚¬ìš© í•˜ ì—¬ ì£¼ì…”ì„œ ê°ì‚¬ í•©ë‹ˆë‹¤!',0),(57908,1609,'he','×ª×•×›× ×™×ª ×”×”×ª×§× ×” ×”×•×©×œ× -. ×ª×•×“×” ×œ×š ×¢×œ ×©×™×ž×•×© NolaPro!',0),(57909,1609,'el','Î£Ï„Î®ÏƒÎµÏ„Îµ Ï€Î»Î®ÏÎ·Ï‚ - ÏƒÎ±Ï‚ ÎµÏ…Ï‡Î±ÏÎ¹ÏƒÏ„Î¿ÏÎ¼Îµ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Ï„Î¿ NolaPro!',0),(57910,1609,'zh','å®‰è£…å®Œæˆ-æ„Ÿè°¢æ‚¨ä½¿ç”¨NolaProï¼\r\n',0),(57911,1609,'sv','Setup komplett - tack fÃ¶r att anvÃ¤nda NolaPro!',0),(57912,1609,'it','Setup Complete - vi ringrazio per l\'utilizzo di NolaPro!',0),(57913,1609,'tl','',0),(57914,1609,'th','&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660; &#3586;&#3629;&#3610;&#3588;&#3640;&#3603;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657; Nolapro',0),(57915,1609,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤ªà¥‚à¤°à¥à¤£ - NolaPro à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤§à¤¨à¥à¤¯à¤µà¤¾à¤¦!',0),(57916,1609,'ms','Sediakan Complete - terima kasih kerana menggunakan NolaPro!',0),(57917,1609,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ ÙƒØ§Ù…Ù„Ø©--Ø´ÙƒØ±Ø§ Ù„Ùƒ Ø¹Ù„Ù‰ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ!',0),(57918,1609,'fr','Installation Complete - Merci d\'utiliser NolaPro !',0),(57919,1609,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—å®Œäº†-NolaProã?®ã?”åˆ©ç”¨ã?‚ã‚Šã?Œã?¨ã?†ã?”ã?–ã?„ã?¾ã?—ã?Ÿ',0),(57920,1609,'pt','InstalaÃ§Ã£o completa - Obrigado por usar o NolaPro!',0),(57921,1609,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Complete - Ð¡Ð¿Ð°ÑÐ¸Ð±Ð¾ Ð·Ð° Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ NolaPro!',0),(57922,1609,'es','ConfiguraciÃ³n Completa - Gracias para Usar NolaPro',0),(57923,1609,'de','Setup Complete - Thank You for using Artikel!',0),(57924,1609,'en','Setup Complete - Thank you for using NolaPro!',0),(57925,1610,'is','',0),(57926,1610,'dr','Ø¬ÙˆÙ‡Ø± ',0),(57927,1610,'pr','Ø¬ÙˆÙ‡Ø± ',0),(57928,1610,'tr','MÃ¼rekkep',0),(57929,1610,'pl','Atrament',0),(57930,1610,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾',0),(57931,1610,'ur','Ø³ÛŒØ§ÛÛŒ',0),(57932,1610,'sr','ÐŸÐµÑ€Ð¾Ð¼',0),(57933,1610,'vi','Má»±c',0),(57934,1610,'af','Ink',0),(57935,1610,'ro','CernealÄƒ',0),(57936,1610,'et','Tint',0),(57937,1610,'si','ÄŒrnilo',0),(57938,1610,'ba','Tinta',0),(57939,1610,'nl','Inkt',0),(57940,1610,'fi','Muste',0),(57941,1610,'no','Blekk',0),(57942,1610,'da','BlÃ¦k',0),(57943,1610,'ko','ìž‰í¬',0),(57944,1610,'he','×“×™×•',0),(57945,1610,'el','ÎœÎµÎ»Î¬Î½Î¹',0),(57946,1610,'zh','å¢¨\r\n',0),(57947,1610,'sv','BlÃ¤ck',0),(57948,1610,'it','Inchiostro',0),(57949,1610,'tl','',0),(57950,1610,'th','&#3627;&#3617;&#3638;&#3585;',0),(57951,1610,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€',0),(57952,1610,'ms','Dakwat',0),(57953,1610,'ar','Ø§Ù„Ø­Ø¨Ø±',0),(57954,1610,'fr','Encre',0),(57955,1610,'jp','ã‚¤ãƒ³ã‚¯',0),(57956,1610,'pt','Tinta',0),(57957,1610,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð°',0),(57958,1610,'es','Tinta',0),(57959,1610,'de','Tinte',0),(57960,1610,'en','Ink',0),(57961,1611,'is','',0),(57962,1611,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬ÙˆÙ‡Ø± ',0),(57963,1611,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬ÙˆÙ‡Ø± ',0),(57964,1611,'tr','MÃ¼rekkep Ekle',0),(57965,1611,'pl','DodaÄ‡ atrament',0),(57966,1611,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ',0),(57967,1611,'ur','Ø³ÛŒØ§ÛÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(57968,1611,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿ÐµÑ€Ð¾Ð¼',0),(57969,1611,'vi','ThÃªm má»±c',0),(57970,1611,'af','Ink voeg',0),(57971,1611,'ro','Adauga cernealÄƒ',0),(57972,1611,'et','Tindi lisamine',0),(57973,1611,'si','Dodajte Ärnilo',0),(57974,1611,'ba','Tambahkan tinta',0),(57975,1611,'nl','Inkt toevoegen',0),(57976,1611,'fi','KÃ¤sinkirjoituksen lisÃ¤Ã¤minen',0),(57977,1611,'no','Blekk legge',0),(57978,1611,'da','BlÃ¦k tilfÃ¸je',0),(57979,1611,'ko','ìž‰í¬ ì¶”ê°€',0),(57980,1611,'he','×œ×”×•×¡×™×£ ×“×™×•',0),(57981,1611,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î¼ÎµÎ»Î¬Î½Î¹',0),(57982,1611,'zh','æ²¹å¢¨æ·»åŠ \r\n',0),(57983,1611,'sv','BlÃ¤ck lÃ¤gga till',0),(57984,1611,'it','Aggiungi inchiostro',0),(57985,1611,'tl','',0),(57986,1611,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3638;&#3585;',0),(57987,1611,'hi','à¤‡à¤‚à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(57988,1611,'ms','Tambah dakwat',0),(57989,1611,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø­Ø¨Ø±',0),(57990,1611,'fr','Ajouter encre',0),(57991,1611,'jp','ã‚¤ãƒ³ã‚¯ã?®è¿½åŠ ',0),(57992,1611,'pt','Adicionar tinta',0),(57993,1611,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‡ÐµÑ€Ð½Ð¸Ð»',0),(57994,1611,'es','Tinta Agregar',0),(57995,1611,'de','Tinte hinzufÃ¼gen',0),(57996,1611,'en','Ink Add',0),(57997,1612,'is','',0),(57998,1612,'dr','Ø¬ÙˆÙ‡Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(57999,1612,'pr','Ø¬ÙˆÙ‡Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(58000,1612,'tr','MÃ¼rekkep baÅŸarÄ±yla eklendi.',0),(58001,1612,'pl','Atrament dodane pomyÅ›lnie.',0),(58002,1612,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(58003,1612,'ur','Ø§Ù†Ú© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(58004,1612,'sr','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(58005,1612,'vi','ThÃªm má»±c thÃ nh cÃ´ng',0),(58006,1612,'af','Ink suksesvol geskep.',0),(58007,1612,'ro','CernealÄƒ adÄƒugat cu succes.',0),(58008,1612,'et','Tint lisatakse edukalt.',0),(58009,1612,'si','UspeÅ¡no dodan je rokopis.',0),(58010,1612,'ba','Tinta ditambahkan berhasil.',0),(58011,1612,'nl','Inkt met succes toegevoegd.',0),(58012,1612,'fi','KÃ¤sinkirjoituksen lisÃ¤Ã¤minen onnistui.',0),(58013,1612,'no','Blekk ble lagt til.',0),(58014,1612,'da','BlÃ¦k tilfÃ¸jet.',0),(58015,1612,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ìž‰í¬.',0),(58016,1612,'he','×“×™×• × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(58017,1612,'el','ÎœÎµÎ»Î¬Î½Î¹ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(58018,1612,'zh','æ²¹å¢¨æ·»åŠ æˆåŠŸã€‚\r\n',0),(58019,1612,'sv','BlÃ¤ck lagts.',0),(58020,1612,'it','Inchiostro aggiunto con successo.',0),(58021,1612,'tl','',0),(58022,1612,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3638;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(58023,1612,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(58024,1612,'ms','Dakwat yang berjaya menambah.',0),(58025,1612,'ar','Ø§Ù„Ø­Ø¨Ø± Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(58026,1612,'fr','Encre ajoutÃ© avec succÃ¨s.',0),(58027,1612,'jp','ã‚¤ãƒ³ã‚¯ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(58028,1612,'pt','Tinta adicionada com Ãªxito.',0),(58029,1612,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(58030,1612,'es','Tinta agregada exitosamente',0),(58031,1612,'de','Tinte wurde erfolgreich hinzugefÃ¼gt.',0),(58032,1612,'en','Ink added successfully.',0),(58033,1613,'is','',0),(58034,1613,'dr','( Ù¾ÙˆØ´Ø´) Ø¬ÙˆÙ‡Ø± (Ù¾ÙˆØ´Ø´ Ù†Ø§Ù… Ø¬ÙˆÙ‡Ø±',0),(58035,1613,'pr','Ù†Ø§Ù… Ø¨Ø±Ø¢ÙˆØ±Ø¯ ( Ù¾ÙˆØ´Ø´) Ø¬ÙˆÙ‡Ø± (Ù¾ÙˆØ´Ø´ Ù†Ø§Ù… Ø¬ÙˆÙ‡Ø±',0),(58036,1613,'tr','MÃ¼rekkep kapsamÄ± adÄ±',0),(58037,1613,'pl','Nazwa zakresu atrament',0),(58038,1613,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾ Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ',0),(58039,1613,'ur','Ø§Ù†Ú© Ú©ÙˆØ±ÛŒØ¬ Ú©Ø§ Ù†Ø§Ù…',0),(58040,1613,'sr','Ð˜Ð¼Ðµ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð¿Ð¾ÐºÑ€Ð¸Ð²ÐµÐ½Ð¾ÑÑ‚',0),(58041,1613,'vi','TÃªn pháº¡m vi má»±c',0),(58042,1613,'af','Ink \"Coverage\" Naam',0),(58043,1613,'ro','Numele de acoperire de cernealÄƒ',0),(58044,1613,'et','Tindi laovarude nimi',0),(58045,1613,'si','Ime pokritost s Ärnilom',0),(58046,1613,'ba','Tinta cakupan nama',0),(58047,1613,'nl','Dekking inktnaam',0),(58048,1613,'fi','Muste kattavuus nimi',0),(58049,1613,'no','Blekk dekning navn',0),(58050,1613,'da','BlÃ¦k dÃ¦kning navn',0),(58051,1613,'ko','ìž‰í¬ ë²”ìœ„ ì´ë¦„',0),(58052,1613,'he','×©× ×›×™×¡×•×™ ×“×™×•',0),(58053,1613,'el','ÎœÎµÎ»Î¬Î½Î¹ ÎºÎ¬Î»Ï…ÏˆÎ· ÏŒÎ½Î¿Î¼Î±',0),(58054,1613,'zh','æ²¹å¢¨è¦†ç›–çŽ‡åç§°\r\n',0),(58055,1613,'sv','BlÃ¤ck tÃ¤ckning namn',0),(58056,1613,'it','Nome di copertura di inchiostro',0),(58057,1613,'tl','',0),(58058,1613,'th','&#3594;&#3639;&#3656;&#3629;&#3586;&#3629;&#3610;&#3648;&#3586;&#3605;&#3627;&#3617;&#3638;&#3585;',0),(58059,1613,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¤µà¤°à¥‡à¤œ à¤•à¤¾ à¤¨à¤¾à¤®',0),(58060,1613,'ms','Dakwat perlindungan nama',0),(58061,1613,'ar','Ø§Ø³Ù… ØªØºØ·ÙŠØ© Ø§Ù„Ø­Ø¨Ø±',0),(58062,1613,'fr','Nom de la couverture d\'encre',0),(58063,1613,'jp','ã‚¤ãƒ³ã‚¯å¯¾è±¡ç¯„å›²å??',0),(58064,1613,'pt','Nome de cobertura de tinta',0),(58065,1613,'ru','Ð˜Ð¼Ñ Ð¾Ñ…Ð²Ð°Ñ‚ Ñ‡ÐµÑ€Ð½Ð¸Ð»',0),(58066,1613,'es','Nombre de Cobertura de Tinta',0),(58067,1613,'de','Druckfarbennamen Abdeckung',0),(58068,1613,'en','Ink Coverage Name',0),(58069,1614,'is','',0),(58070,1614,'dr','Ø¬ÙˆÙ‡Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(58071,1614,'pr','Ø¬ÙˆÙ‡Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(58072,1614,'tr','MÃ¼rekkep baÅŸarÄ±yla silindi.',0),(58073,1614,'pl','Atrament usuniÄ™te pomyÅ›lnie.',0),(58074,1614,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(58075,1614,'ur','Ø§Ù†Ú© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(58076,1614,'sr','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(58077,1614,'vi','XÃ³a má»±c thÃ nh cÃ´ng',0),(58078,1614,'af','Ink suksesvol geskrap.',0),(58079,1614,'ro','CernealÄƒ ÅŸters cu succes.',0),(58080,1614,'et','Tindi edukalt kustutatud.',0),(58081,1614,'si','ÄŒrnilo uspeÅ¡no izbrisana.',0),(58082,1614,'ba','Tinta berhasil dihapus.',0),(58083,1614,'nl','Inkt verwijderd.',0),(58084,1614,'fi','Muste poistettu.',0),(58085,1614,'no','Blekk ble slettet.',0),(58086,1614,'da','BlÃ¦k slettet.',0),(58087,1614,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ìž‰í¬.',0),(58088,1614,'he','×“×™×• × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(58089,1614,'el','ÎœÎµÎ»Î¬Î½Î¹ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(58090,1614,'zh','å¢¨å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(58091,1614,'sv','BlÃ¤ck raderades.',0),(58092,1614,'it','Inchiostro cancellato con successo.',0),(58093,1614,'tl','',0),(58094,1614,'th','&#3621;&#3610;&#3627;&#3617;&#3638;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(58095,1614,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(58096,1614,'ms','Dakwat dihapuskan dengan jayanya.',0),(58097,1614,'ar','Ø§Ù„Ø­Ø¨Ø± Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(58098,1614,'fr','Encre supprimÃ© avec succÃ¨s.',0),(58099,1614,'jp','ã‚¤ãƒ³ã‚¯ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(58100,1614,'pt','Tinta excluÃ­da com sucesso.',0),(58101,1614,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(58102,1614,'es','Tinta eliminada exitosamente',0),(58103,1614,'de','Tinte wurde erfolgreich gelÃ¶scht.',0),(58104,1614,'en','Ink deleted successfully.',0),(58105,1615,'is','',0),(58106,1615,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬ÙˆÙ‡Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(58107,1615,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬ÙˆÙ‡Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(58108,1615,'tr','MÃ¼rekkep bilgisi baÅŸarÄ±yla eklendi.',0),(58109,1615,'pl','Atrament Info dodane pomyÅ›lnie.',0),(58110,1615,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(58111,1615,'ur','Ø§Ù†Ú© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(58112,1615,'sr','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð˜Ð½Ñ„Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(58113,1615,'vi','ThÃ´ng Tin má»±c thÃªm vÃ o thÃ nh cÃ´ng',0),(58114,1615,'af','Ink Inligting suksesvol geskep.',0),(58115,1615,'ro','CernealÄƒ Info adÄƒugat cu succes.',0),(58116,1615,'et','Tindi Info edukalt lisatud.',0),(58117,1615,'si','ÄŒrnilo Info uspeÅ¡no dodana.',0),(58118,1615,'ba','Tinta menambahkan berhasil Info.',0),(58119,1615,'nl','Inkt Info toegevoegd.',0),(58120,1615,'fi','Muste Info lisÃ¤Ã¤minen onnistui.',0),(58121,1615,'no','Blekk Info lagt.',0),(58122,1615,'da','BlÃ¦k Info tilfÃ¸jet.',0),(58123,1615,'ko','ìž‰í¬ ì •ë³´ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(58124,1615,'he','×”×“×™×• ×ž×™×“×¢ × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(58125,1615,'el','ÎœÎµÎ»Î¬Î½Î¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(58126,1615,'zh','æ°´å¢¨ä¿¡æ¯æ·»åŠ æˆåŠŸã€‚\r\n',0),(58127,1615,'sv','BlÃ¤ck information lagts.',0),(58128,1615,'it','Inchiostro Info aggiunto con successo.',0),(58129,1615,'tl','',0),(58130,1615,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3627;&#3617;&#3638;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(58131,1615,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(58132,1615,'ms','Dakwat maklumat berjaya menambah.',0),(58133,1615,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø­Ø¨Ø±.',0),(58134,1615,'fr','Encre Info ajoutÃ© avec succÃ¨s.',0),(58135,1615,'jp','ã‚¤ãƒ³ã‚¯æƒ…å ±ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(58136,1615,'pt','InformaÃ§Ã£o de tinta adicionada com Ãªxito.',0),(58137,1615,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(58138,1615,'es','Info de tinta agregado exitosamente',0),(58139,1615,'de','Tinte-Info wurde erfolgreich hinzugefÃ¼gt.',0),(58140,1615,'en','Ink Info added successfully.',0),(58141,1616,'is','',0),(58142,1616,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬ÙˆÙ‡Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(58143,1616,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬ÙˆÙ‡Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(58144,1616,'tr','MÃ¼rekkep bilgileri baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(58145,1616,'pl','Atrament Info pomyÅ›lnie zaktualizowana.',0),(58146,1616,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(58147,1616,'ur','Ø§Ù†Ú© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(58148,1616,'sr','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð˜Ð½Ñ„Ð¾ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(58149,1616,'vi','Cáº­p Nháº­t thÃ´ng tin Má»±c thÃ nh cÃ´ng',0),(58150,1616,'af','Ink Inligting suksesvol opdateer.',0),(58151,1616,'ro','CernealÄƒ informaÅ£ii actualizate cu succes.',0),(58152,1616,'et','Tindi Info vÃ¤rskendamine Ãµnnestus.',0),(58153,1616,'si','ÄŒrnilo Info uspeÅ¡no posodobljena.',0),(58154,1616,'ba','Tinta Info diperbarui berhasil.',0),(58155,1616,'nl','Inkt Info bijgewerkt.',0),(58156,1616,'fi','Muste Info pÃ¤ivitetty.',0),(58157,1616,'no','Blekk Info oppdatert.',0),(58158,1616,'da','BlÃ¦k Info opdateret.',0),(58159,1616,'ko','ìž‰í¬ ì •ë³´ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(58160,1616,'he','×¤×¨×˜×™ ×“×™×• ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(58161,1616,'el','ÎœÎµÎ»Î¬Î½Î¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(58162,1616,'zh','æ°´å¢¨ä¿¡æ¯æ›´æ–°æˆåŠŸã€‚\r\n',0),(58163,1616,'sv','BlÃ¤ck Info uppdaterades.',0),(58164,1616,'it','Inchiostro Info aggiornato con successo.',0),(58165,1616,'tl','',0),(58166,1616,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3627;&#3617;&#3638;&#3585;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(58167,1616,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(58168,1616,'ms','Dakwat maklumat berjaya dikemas kini.',0),(58169,1616,'ar','Ø§Ù„Ø­Ø¨Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(58170,1616,'fr','Encre d\'informations mis Ã  jour avec succÃ¨s.',0),(58171,1616,'jp','ã‚¤ãƒ³ã‚¯æƒ…å ±ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(58172,1616,'pt','Tinta informaÃ§Ã£o atualizada com Ãªxito.',0),(58173,1616,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(58174,1616,'es','Info de tinta actualizado exitosamente',0),(58175,1616,'de','Tinte Info erfolgreich aktualisiert.',0),(58176,1616,'en','Ink Info updated successfully.',0),(58177,1617,'is','',0),(58178,1617,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬ÙˆÙ‡Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(58179,1617,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬ÙˆÙ‡Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(58180,1617,'tr','MÃ¼rekkep bulunamadÄ±.',0),(58181,1617,'pl','Atrament nie znaleziono.',0),(58182,1617,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(58183,1617,'ur','Ø§Ù†Ú© Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(58184,1617,'sr','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(58185,1617,'vi','KhÃ´ng tháº¥y má»±c',0),(58186,1617,'af','Ink nie gevind nie.',0),(58187,1617,'ro','CernealÄƒ nu a fost gÄƒsit.',0),(58188,1617,'et','Tinti ei leitud.',0),(58189,1617,'si','ÄŒrnilo ni mogoÄe najti.',0),(58190,1617,'ba','Tinta tidak ditemukan.',0),(58191,1617,'nl','Inkt niet gevonden.',0),(58192,1617,'fi','Muste ei lÃ¶ydy.',0),(58193,1617,'no','Blekk ikke funnet.',0),(58194,1617,'da','BlÃ¦k blev ikke fundet.',0),(58195,1617,'ko','ìž‰í¬ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(58196,1617,'he','×“×™×• ×œ× × ×ž×¦×.',0),(58197,1617,'el','Î¤Î¿ Î¼ÎµÎ»Î¬Î½Î¹ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(58198,1617,'zh','å¢¨æœªæ‰¾åˆ°ã€‚\r\n',0),(58199,1617,'sv','BlÃ¤ck hittades inte.',0),(58200,1617,'it','Inchiostro non trovato.',0),(58201,1617,'tl','',0),(58202,1617,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3627;&#3617;&#3638;&#3585;',0),(58203,1617,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(58204,1617,'ms','Dakwat tidak ditemui.',0),(58205,1617,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø­Ø¨Ø±.',0),(58206,1617,'fr','Encre non trouvÃ©.',0),(58207,1617,'jp','ã‚¤ãƒ³ã‚¯ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(58208,1617,'pt','Tinta nÃ£o encontrada.',0),(58209,1617,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(58210,1617,'es','Tinta no se encontrÃ³',0),(58211,1617,'de','Tinte, die nicht gefunden werden.',0),(58212,1617,'en','Ink not found.',0),(58213,1618,'is','',0),(58214,1618,'dr',': Ø¬Ù‡Øª ',0),(58215,1618,'pr','Ø¬ÙˆÙ‡Ø± : Ø¬Ù‡Øª ',0),(58216,1618,'tr','MÃ¼rekkep: Side',0),(58217,1618,'pl','Atrament: Side',0),(58218,1618,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾: ÑÑ‚Ñ€Ð°Ð½Ð°',0),(58219,1618,'ur','Ø§Ù†Ú©: Ú©ÛŒ Ø·Ø±Ù',0),(58220,1618,'sr','Ð˜Ð½Ðº : ÑÑ‚Ñ€Ð°Ð½Ð¸',0),(58221,1618,'vi','Má»±c: Máº·t',0),(58222,1618,'af','Ink: kant',0),(58223,1618,'ro','CernealÄƒ: Side',0),(58224,1618,'et','Tint: Side',0),(58225,1618,'si','ÄŒrnila: strani',0),(58226,1618,'ba','Tinta: sisi',0),(58227,1618,'nl','Inkt: kant',0),(58228,1618,'fi','Muste: Side',0),(58229,1618,'no','Blekk: Side',0),(58230,1618,'da','BlÃ¦k: Side',0),(58231,1618,'ko','ìž‰í¬: ì¸¡ë©´',0),(58232,1618,'he','×“×™×•: ×¦×“',0),(58233,1618,'el','ÎœÎµÎ»Î¬Î½Î¹: Ï€Î»ÎµÏ…ÏÎ¬',0),(58234,1618,'zh','æ²¹å¢¨ï¼šä¾§é¢\r\n',0),(58235,1618,'sv','BlÃ¤ck: sida',0),(58236,1618,'it','Inchiostro: lato',0),(58237,1618,'tl','',0),(58238,1618,'th','&#3627;&#3617;&#3638;&#3585; : &#3604;&#3657;&#3634;&#3609;&#3586;&#3657;&#3634;&#3591;',0),(58239,1618,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€: à¤¸à¤¾à¤‡à¤¡',0),(58240,1618,'ms','Dakwat: sampingan',0),(58241,1618,'ar','Ø§Ù„Ø­Ø¨Ø±: Ø§Ù„Ø¬Ø§Ù†Ø¨',0),(58242,1618,'fr','Encre : cÃ´tÃ©',0),(58243,1618,'jp','ã‚¤ãƒ³ã‚¯ï¼šå?´é?¢',0),(58244,1618,'pt','Tinta: lado',0),(58245,1618,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð°: ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð°',0),(58246,1618,'es','Tinta: Lado',0),(58247,1618,'de','Tinte: Seite',0),(58248,1618,'en','Ink: Side',0),(58249,1619,'is','',0),(58250,1619,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬ÙˆÙ‡Ø± ',0),(58251,1619,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬ÙˆÙ‡Ø± ',0),(58252,1619,'tr','MÃ¼rekkep gÃ¼ncelleÅŸtirme',0),(58253,1619,'pl','Atrament aktualizacji',0),(58254,1619,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾',0),(58255,1619,'ur','Ø§Ù†Ú© ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(58256,1619,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿ÐµÑ€Ð¾Ð¼',0),(58257,1619,'vi','Cáº­p Nháº­t Má»±c',0),(58258,1619,'af','Ink bywerking',0),(58259,1619,'ro','CernealÄƒ Update',0),(58260,1619,'et','Tindi Update',0),(58261,1619,'si','ÄŒrnilo posodobitev',0),(58262,1619,'ba','Tinta Update',0),(58263,1619,'nl','Inkt Update',0),(58264,1619,'fi','Muste pÃ¤ivitys',0),(58265,1619,'no','Blekk oppdatering',0),(58266,1619,'da','BlÃ¦k opdatering',0),(58267,1619,'ko','ìž‰í¬ ì—…ë°ì´íŠ¸',0),(58268,1619,'he','×¢×“×›×•×Ÿ ×“×™×•',0),(58269,1619,'el','ÎœÎµÎ»Î¬Î½Î¹ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(58270,1619,'zh','æ²¹å¢¨æ›´æ–°\r\n',0),(58271,1619,'sv','BlÃ¤ck uppdatering',0),(58272,1619,'it','Aggiornamento di inchiostro',0),(58273,1619,'tl','',0),(58274,1619,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3638;&#3585;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(58275,1619,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(58276,1619,'ms','Kemaskini dakwat',0),(58277,1619,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø­Ø¨Ø±',0),(58278,1619,'fr','Mise Ã  jour de l\'encre',0),(58279,1619,'jp','ã‚¤ãƒ³ã‚¯ã?®æ›´æ–°',0),(58280,1619,'pt','AtualizaÃ§Ã£o de tinta',0),(58281,1619,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‡ÐµÑ€Ð½Ð¸Ð»',0),(58282,1619,'es','Tinta Actualizar',0),(58283,1619,'de','Tinte-Update',0),(58284,1619,'en','Ink Update',0),(58285,1620,'is','',0),(58286,1620,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬ÙˆÙ‡Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(58287,1620,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬ÙˆÙ‡Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(58288,1620,'tr','MÃ¼rekkep baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(58289,1620,'pl','Atrament pomyÅ›lnie zaktualizowana.',0),(58290,1620,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(58291,1620,'ur','Ø§Ù†Ú© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(58292,1620,'sr','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(58293,1620,'vi','Cáº­p Nháº­t Má»±c thÃ nh cÃ´ng',0),(58294,1620,'af','Ink suksesvol opdateer.',0),(58295,1620,'ro','CernealÄƒ actualizat cu succes.',0),(58296,1620,'et','Tindi vÃ¤rskendamine Ãµnnestus.',0),(58297,1620,'si','ÄŒrnilo je uspeÅ¡no posodobljena.',0),(58298,1620,'ba','Tinta diperbarui berhasil.',0),(58299,1620,'nl','Inkt bijgewerkt.',0),(58300,1620,'fi','Muste pÃ¤ivitettiin onnistuneesti.',0),(58301,1620,'no','Blekk oppdatert.',0),(58302,1620,'da','BlÃ¦k opdateret.',0),(58303,1620,'ko','ìž‰í¬ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(58304,1620,'he','×“×™×• ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(58305,1620,'el','ÎœÎµÎ»Î¬Î½Î¹ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(58306,1620,'zh','æ²¹å¢¨æ›´æ–°æˆåŠŸã€‚\r\n',0),(58307,1620,'sv','BlÃ¤ck uppdaterats.',0),(58308,1620,'it','Inchiostro aggiornato con successo.',0),(58309,1620,'tl','',0),(58310,1620,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3638;&#3585;&#3614;&#3636;&#3617;&#3614;&#3660;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(58311,1620,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(58312,1620,'ms','Dakwat yang berjaya dikemas kini.',0),(58313,1620,'ar','Ø§Ù„Ø­Ø¨Ø± Ø§Ù„ØªÙŠ ØªÙ… ØªØ­Ø¯ÙŠØ«Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­.',0),(58314,1620,'fr','Encre correctement mis Ã  jour.',0),(58315,1620,'jp','ã‚¤ãƒ³ã‚¯ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(58316,1620,'pt','Tinta atualizada com Ãªxito.',0),(58317,1620,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(58318,1620,'es','Tinta actualizada exitosamente',0),(58319,1620,'de','Tinte, die erfolgreich aktualisiert.',0),(58320,1620,'en','Ink updated successfully.',0),(58321,1621,'is','',0),(58322,1621,'dr','Ø¯Ø±Ø¬ ÙƒØ±Ø¯Ù† Ø«Ø¨Øª ',0),(58323,1621,'pr','Ø¯Ø±Ø¬ ÙƒØ±Ø¯Ù† Ø«Ø¨Øª ',0),(58324,1621,'tr','GiriÅŸi Ekle',0),(58325,1621,'pl','Wstawianie wpisu',0),(58326,1621,'bg','Ð’Ð¼ÑŠÐºÐ½Ð¸ Ð·Ð°Ð¿Ð¸Ñ',0),(58327,1621,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(58328,1621,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(58329,1621,'vi','ChÃ¨n Entry',0),(58330,1621,'af','Voer Inskrywing In',0),(58331,1621,'ro','Inserare intrare',0),(58332,1621,'et','Kirje lisamine',0),(58333,1621,'si','Vstavi vnos',0),(58334,1621,'ba','Memasukkan entri',0),(58335,1621,'nl','Fragment invoegen',0),(58336,1621,'fi','LisÃ¤Ã¤ merkintÃ¤',0),(58337,1621,'no','Sette inn oppfÃ¸ring',0),(58338,1621,'da','IndsÃ¦t post',0),(58339,1621,'ko','í•­ëª© ì‚½ìž…',0),(58340,1621,'he','×”×•×¡×¤×ª ×¢×¨×š',0),(58341,1621,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·',0),(58342,1621,'zh','æ’å…¥æ¡ç›®\r\n',0),(58343,1621,'sv','Infoga post',0),(58344,1621,'it','Inserire voce',0),(58345,1621,'tl','',0),(58346,1621,'th','&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3649;&#3607;&#3619;&#3585;',0),(58347,1621,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(58348,1621,'ms','Masukkan entri',0),(58349,1621,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø¥Ø¯Ø®Ø§Ù„',0),(58350,1621,'fr','InsÃ©rer une valeur',0),(58351,1621,'jp','ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?®æŒ¿å…¥',0),(58352,1621,'pt','Inserir entrada',0),(58353,1621,'ru','Ð’ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(58354,1621,'es','Insertar Entrada',0),(58355,1621,'de','Eintrag',0),(58356,1621,'en','Insert Entry',0),(58357,1622,'is','',0),(58358,1622,'dr','Ø¯Ø±Ø¬ ÙƒØ±Ø¯Ù† Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(58359,1622,'pr','Ø¯Ø±Ø¬ ÙƒØ±Ø¯Ù† Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(58360,1622,'tr','Ekleme baÅŸarÄ±sÄ±z',0),(58361,1622,'pl','Wstaw nie powiodÅ‚o siÄ™',0),(58362,1622,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð’Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ',0),(58363,1622,'ur','Ù†Ø§Ú©Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(58364,1622,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(58365,1622,'vi','ChÃ¨n tháº¥t báº¡i',0),(58366,1622,'af','Insetsel het misluk',0),(58367,1622,'ro','Inserare nereuÈ™itÄƒ',0),(58368,1622,'et','Lisamine nurjus',0),(58369,1622,'si','Vstavljanje ni uspela',0),(58370,1622,'ba','Masukkan gagal',0),(58371,1622,'nl','Invoegen mislukt',0),(58372,1622,'fi','LisÃ¤Ã¤ epÃ¤onnistui',0),(58373,1622,'no','Sett inn mislyktes',0),(58374,1622,'da','IndsÃ¦t mislykkedes',0),(58375,1622,'ko','ì‚½ìž… í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤',0),(58376,1622,'he','×”×•×¡×¤×” × ×›×©×œ',0),(58377,1622,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏ„Î®ÏƒÏ„Îµ Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(58378,1622,'zh','æ’å…¥å¤±è´¥\r\n',0),(58379,1622,'sv','Infoga misslyckades',0),(58380,1622,'it','Inserimento non riuscito',0),(58381,1622,'tl','',0),(58382,1622,'th','&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(58383,1622,'hi','à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(58384,1622,'ms','Masukkan yang gagal',0),(58385,1622,'ar','Ø¥Ø¯Ø±Ø§Ø¬ ÙØ´Ù„',0),(58386,1622,'fr','Ã‰chouÃ© de l\'insertion',0),(58387,1622,'jp','æŒ¿å…¥ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(58388,1622,'pt','Inserir falhado',0),(58389,1622,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð²ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ',0),(58390,1622,'es','Insertar fallÃ³',0),(58391,1622,'de','EinfÃ¼gen ist fehlgeschlagen',0),(58392,1622,'en','Insert failed',0),(58393,1623,'is','',0),(58394,1623,'dr','Ø¯Ø±Ø¬ ÙƒØ±Ø¯Ù† ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠÙ‡Ø§ ',0),(58395,1623,'pr','Ø¯Ø±Ø¬ ÙƒØ±Ø¯Ù† ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠÙ‡Ø§ ',0),(58396,1623,'tr','Yeni Stok sayÄ±mÄ± ekleyin',0),(58397,1623,'pl','Wstawianie nowej inwentaryzacji',0),(58398,1623,'bg','Ð’Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¾Ð¿Ð¸Ñ Ð³Ñ€Ð°Ñ„',0),(58399,1623,'ur','Ù†Ø¦Û’ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ø§ Ø´Ù…Ø§Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(58400,1623,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð¿Ð¾Ð¿Ð¸ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(58401,1623,'vi','ChÃ¨n Bá»™ Äáº¿m HÃ ng HÃ³a Má»›i',0),(58402,1623,'af','Voer Nuwe Inventaris Telling in',0),(58403,1623,'ro','IntroduceÅ£i numÄƒrul de inventar noi',0),(58404,1623,'et','Saate lisada uue lao krahv',0),(58405,1623,'si','Vstavite nov inventura',0),(58406,1623,'ba','Masukkan baru menghitung persediaan',0),(58407,1623,'nl','Invoegen van nieuwe inventaris tellen',0),(58408,1623,'fi','LisÃ¤Ã¤ uusi varaston inventointi',0),(58409,1623,'no','Sette inn nye Lageropptelling',0),(58410,1623,'da','IndsÃ¦tte nye lageroptÃ¦lling',0),(58411,1623,'ko','ìƒˆë¡œìš´ ìž¬ê³  ì¹´ìš´íŠ¸ ì‚½ìž…',0),(58412,1623,'he','×”×›× ×¡ ×¡×¤×™×¨×ª ×ž×œ××™ ×—×“×©',0),(58413,1623,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î½Î­Î± ÎºÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ· Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(58414,1623,'zh','æ’å…¥æ–°çš„åº“å­˜ç›˜ç‚¹\r\n',0),(58415,1623,'sv','Infoga ny lagerinventering',0),(58416,1623,'it','Inserire il nuovo numero di inventario',0),(58417,1623,'tl','',0),(58418,1623,'th','&#3649;&#3607;&#3619;&#3585;&#3605;&#3633;&#3623;&#3609;&#3635;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(58419,1623,'hi','à¤¨à¤ˆ à¤¸à¥‚à¤šà¥€ à¤—à¤¿à¤¨à¤¤à¥€ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(58420,1623,'ms','Masukkan pengiraan inventori baru',0),(58421,1623,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø¬Ø¯ÙŠØ¯ Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(58422,1623,'fr','InsÃ©rer le nouvel inventaire',0),(58423,1623,'jp','æ–°è¦?æ£šå?¸ã?®æŒ¿å…¥',0),(58424,1623,'pt','Inserir nova contagem de inventÃ¡rio',0),(58425,1623,'ru','Ð’ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð¾Ð²Ð¾Ð¹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(58426,1623,'es','Insertar Conteo de Nuevo Inventatio',0),(58427,1623,'de','Legen Sie neue InventurzÃ¤hlung',0),(58428,1623,'en','Insert New Inventory Count',0),(58429,1624,'is','',0),(58430,1624,'dr','Ù†ØµØ¨ ÙƒØ±Ø¯Ù† ',0),(58431,1624,'pr','Ù†ØµØ¨ ÙƒØ±Ø¯Ù† ',0),(58432,1624,'tr','YÃ¼klemek',0),(58433,1624,'pl','ZainstalowaÄ‡',0),(58434,1624,'bg','Ð˜Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½Ðµ',0),(58435,1624,'ur','ØªÙ†ØµÛŒØ¨ Ú©Ø±ÛŒÚº',0),(58436,1624,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ',0),(58437,1624,'vi','Láº¯p Ä‘áº·t',0),(58438,1624,'af','Installeer',0),(58439,1624,'ro','InstalaÅ£i',0),(58440,1624,'et','Paigaldada',0),(58441,1624,'si','Namestite',0),(58442,1624,'ba','Menginstal',0),(58443,1624,'nl','Installeren',0),(58444,1624,'fi','Asenna',0),(58445,1624,'no','Installere',0),(58446,1624,'da','Installere',0),(58447,1624,'ko','ì„¤ì¹˜',0),(58448,1624,'he','×”×ª×§×Ÿ',0),(58449,1624,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(58450,1624,'zh','å®‰è£…\r\n',0),(58451,1624,'sv','Installera',0),(58452,1624,'it','Installare',0),(58453,1624,'tl','',0),(58454,1624,'th','&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;',0),(58455,1624,'hi','à¤¸à¥à¤¥à¤¾à¤ªà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(58456,1624,'ms','Memasang',0),(58457,1624,'ar','ØªØ«Ø¨ÙŠØª',0),(58458,1624,'fr','Installer',0),(58459,1624,'jp','ã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«',0),(58460,1624,'pt','Instalar',0),(58461,1624,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(58462,1624,'es','Instalar',0),(58463,1624,'de','Installieren',0),(58464,1624,'en','Install',0),(58465,1625,'is','',0),(58466,1625,'dr','(Ù…ÙØ§Ø¯',0),(58467,1625,'pr','Ø¨Ù‡Ø±Ù‡ (Ø³ÙˆØ¯',0),(58468,1625,'tr','Faiz',0),(58469,1625,'pl','Zainteresowanie',0),(58470,1625,'bg','Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ',0),(58471,1625,'ur','Ø³ÙˆØ¯',0),(58472,1625,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ð°',0),(58473,1625,'vi','LÃ£i suáº¥t',0),(58474,1625,'af','Rente',0),(58475,1625,'ro','Dobanda',0),(58476,1625,'et','Viivis',0),(58477,1625,'si','Obresti',0),(58478,1625,'ba','Bunga',0),(58479,1625,'nl','Belang',0),(58480,1625,'fi','Korko',0),(58481,1625,'no','Interesse',0),(58482,1625,'da','Interesse',0),(58483,1625,'ko','ê´€ì‹¬',0),(58484,1625,'he','×¨×™×‘×™×ª',0),(58485,1625,'el','Î•Î½Î´Î¹Î±Ï†Î­ÏÎ¿Î½',0),(58486,1625,'zh','åˆ©æ¯\r\n',0),(58487,1625,'sv','Intresse',0),(58488,1625,'it','Interesse',0),(58489,1625,'tl','',0),(58490,1625,'th','&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618; ',0),(58491,1625,'hi','à¤¬à¥à¤¯à¤¾à¤œ',0),(58492,1625,'ms','Faedah',0),(58493,1625,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(58494,1625,'fr','IntÃ©rÃªt',0),(58495,1625,'jp','åˆ©å­?',0),(58496,1625,'pt','Interesse',0),(58497,1625,'ru','Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ',0),(58498,1625,'es','InterÃ©ses',0),(58499,1625,'de','Interesse',0),(58500,1625,'en','Interest',0),(58501,1626,'is','',0),(58502,1626,'dr','(Ù…ÙØ§Ø¯) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯ ',0),(58503,1626,'pr','Ø¨Ù‡Ø±Ù‡ (Ø³ÙˆØ¯) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯ ',0),(58504,1626,'tr','BaÅŸarÄ±yla uygulanan faiz',0),(58505,1626,'pl','Odsetki z powodzeniem stosowana',0),(58506,1626,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(58507,1626,'ur','Ø³ÙˆØ¯ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù„Ú¯Ø§Ø¦ÛŒ',0),(58508,1626,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¸Ð¼ÐµÑšÐµÐ½Ðµ',0),(58509,1626,'vi','Ãp dá»¥ng LÃ£i suáº¥t thÃ nh cÃ´ng',0),(58510,1626,'af','Rente Suksesvol Toegepas',0),(58511,1626,'ro','DobÃ¢nda aplicatÄƒ cu succes',0),(58512,1626,'et','Viivis lisatud edukalt',0),(58513,1626,'si','Obresti uspeÅ¡no',0),(58514,1626,'ba','Minat diterapkan berhasil',0),(58515,1626,'nl','Belang met succes toegepast',0),(58516,1626,'fi','Sovellettava onnistuneesti',0),(58517,1626,'no','Interesse aktivert',0),(58518,1626,'da','Renter anvendes med succes',0),(58519,1626,'ko','ì„±ê³µì ìœ¼ë¡œ ì ìš© í•˜ëŠ” ê´€ì‹¬',0),(58520,1626,'he','×¢× ×™×™×Ÿ ×ž×™×•×©× ×‘×”×¦×œ×—×”',0),(58521,1626,'el','Î¤ÏŒÎºÎ¿Ï‚ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(58522,1626,'zh','åˆ©æ¯æˆåŠŸåº”ç”¨\r\n',0),(58523,1626,'sv','Intresse tillÃ¤mpas framgÃ¥ngsrikt',0),(58524,1626,'it','Interesse applicato con successo',0),(58525,1626,'tl','',0),(58526,1626,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3618;&#3640;&#3585;&#3605;&#3660;&#3651;&#3594;&#3657;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(58527,1626,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤²à¤¾à¤—à¥‚ à¤¬à¥à¤¯à¤¾à¤œ',0),(58528,1626,'ms','Faedah yang dikenakan dengan jayanya',0),(58529,1626,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(58530,1626,'fr','IntÃ©rÃªt appliquÃ© avec succÃ¨s',0),(58531,1626,'jp','åˆ©å­?ã?Œé?©ç”¨ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(58532,1626,'pt','Interesse aplicado com Ãªxito',0),(58533,1626,'ru','Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÑÐµÑ‚ÑÑ',0),(58534,1626,'es','InterÃ©ses Aplicados Exitosamente',0),(58535,1626,'de','Interesse erfolgreich angewendet',0),(58536,1626,'en','Interest Applied Successfully',0),(58537,1627,'is','',0),(58538,1627,'dr',' Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ù‡Ø±Ù‡',0),(58539,1627,'pr',' Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ù‡Ø±Ù‡',0),(58540,1627,'tr','Faiz Gideri',0),(58541,1627,'pl','Koszty odsetek',0),(58542,1627,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð»Ð¸Ñ…Ð²Ð¸',0),(58543,1627,'ur','Ø³ÙˆØ¯ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(58544,1627,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(58545,1627,'vi','Chi phÃ­ LÃ£i suáº¥t',0),(58546,1627,'af','Rente Uitgawe',0),(58547,1627,'ro','Cheltuieli aferente dobanzilor',0),(58548,1627,'et','Intressikulu',0),(58549,1627,'si','Obrestni odhodki',0),(58550,1627,'ba','Biaya bunga',0),(58551,1627,'nl','Rentelasten',0),(58552,1627,'fi','Korkokulut',0),(58553,1627,'no','Rentekostnad',0),(58554,1627,'da','Renteudgift',0),(58555,1627,'ko','ì´ìž ë¹„ìš©',0),(58556,1627,'he','×”×•×¦××•×ª ×¨×™×‘×™×ª',0),(58557,1627,'el','Î¤ÏŒÎºÎ¿Î¹-Î­Î¾Î¿Î´Î±',0),(58558,1627,'zh','åˆ©æ¯æ”¯å‡º\r\n',0),(58559,1627,'sv','RÃ¤ntekostnader',0),(58560,1627,'it','Interessi passivi',0),(58561,1627,'tl','',0),(58562,1627,'th','&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3592;&#3656;&#3634;&#3618;',0),(58563,1627,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤µà¥à¤¯à¤¯',0),(58564,1627,'ms','Perbelanjaan faedah',0),(58565,1627,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(58566,1627,'fr','IntÃ©rÃªts dÃ©biteurs',0),(58567,1627,'jp','æ”¯æ‰•åˆ©æ?¯',0),(58568,1627,'pt','Despesa de juros',0),(58569,1627,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(58570,1627,'es','Gastos de InterÃ©ses',0),(58571,1627,'de','Zinsaufwand',0),(58572,1627,'en','Interest Expense',0),(58573,1628,'is','',0),(58574,1628,'dr','Ø¯Ø±Ø¢Ù…Ø¯ Ø¨Ù‡Ø±Ù‡ ',0),(58575,1628,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ø¨Ù‡Ø±Ù‡ ',0),(58576,1628,'tr','Faiz geliri',0),(58577,1628,'pl','Przychody z tytuÅ‚u odsetek',0),(58578,1628,'bg','ÐŸÑ€Ð¸Ñ…Ð¾Ð´Ð¸ Ð¾Ñ‚ Ð»Ð¸Ñ…Ð²Ð¸',0),(58579,1628,'ur','Ø³ÙˆØ¯ Ú©ÛŒ Ø¢Ù…Ø¯Ù†ÛŒ',0),(58580,1628,'sr','ÐŸÑ€Ð¸Ñ…Ð¾Ð´ Ð¾Ð´ ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(58581,1628,'vi','Thu nháº­p tá»« LÃ£i suáº¥t',0),(58582,1628,'af','Rente Inkomste',0),(58583,1628,'ro','Venituri aferente dobanzilor',0),(58584,1628,'et','Intressitulu',0),(58585,1628,'si','Obrestni prihodki',0),(58586,1628,'ba','Pendapatan bunga',0),(58587,1628,'nl','Rente-inkomsten',0),(58588,1628,'fi','Korkotuotot',0),(58589,1628,'no','Renteinntekter',0),(58590,1628,'da','RenteindtÃ¦gter',0),(58591,1628,'ko','ì´ìž ì†Œë“',0),(58592,1628,'he','×”×›× ×¡×” ×ª×¤×¢×•×œ×™×ª',0),(58593,1628,'el','ÎˆÏƒÎ¿Î´Î± Î±Ï€ÏŒ Ï„ÏŒÎºÎ¿Ï…Ï‚',0),(58594,1628,'zh','åˆ©æ¯æ”¶å…¥\r\n',0),(58595,1628,'sv','RÃ¤nteintÃ¤kter',0),(58596,1628,'it','Interessi attivi',0),(58597,1628,'tl','',0),(58598,1628,'th','&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3619;&#3633;&#3610;',0),(58599,1628,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤†à¤¯',0),(58600,1628,'ms','Pendapatan faedah',0),(58601,1628,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(58602,1628,'fr','Revenus d\'intÃ©rÃªts',0),(58603,1628,'jp','åˆ©æ?¯å?Žå…¥',0),(58604,1628,'pt','Receita de juros',0),(58605,1628,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ñ‹Ðµ Ð´Ð¾Ñ…Ð¾Ð´Ñ‹',0),(58606,1628,'es','Ingresos de InterÃ©ses',0),(58607,1628,'de','ZinsertrÃ¤ge',0),(58608,1628,'en','Interest Income',0),(58609,1629,'is','',0),(58610,1629,'dr','Ø¨Ù‡Ø±Ù‡  Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(58611,1629,'pr','Ø¨Ù‡Ø±Ù‡  Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(58612,1629,'tr','Ã–denen faiz',0),(58613,1629,'pl','ZapÅ‚acone odsetki',0),(58614,1629,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð°Ñ‚Ð° Ð»Ð¸Ñ…Ð²Ð°',0),(58615,1629,'ur','Ø³ÙˆØ¯ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(58616,1629,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ð° Ð¿Ð»Ð°Ñ›ÐµÐ½Ð°',0),(58617,1629,'vi','Tráº£ LÃ£i suáº¥t',0),(58618,1629,'af','Rente Reeds Betaal',0),(58619,1629,'ro','Dobanda achitata',0),(58620,1629,'et','Makstud intressid',0),(58621,1629,'si','PlaÄane obresti',0),(58622,1629,'ba','Bunga yang dibayarkan',0),(58623,1629,'nl','Betaalde rente',0),(58624,1629,'fi','Maksetut korot',0),(58625,1629,'no','Renten betalt',0),(58626,1629,'da','Betalte rente',0),(58627,1629,'ko','ì´ìž ì§€ê¸‰',0),(58628,1629,'he','×¨×™×‘×™×ª ×œ×©×œ×',0),(58629,1629,'el','Î¤ÏŒÎºÎ¿Î¹ Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹',0),(58630,1629,'zh','ä»˜åˆ©æ¯\r\n',0),(58631,1629,'sv','RÃ¤nta betalas',0),(58632,1629,'it','Interessi pagati',0),(58633,1629,'tl','',0),(58634,1629,'th','&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(58635,1629,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(58636,1629,'ms','Faedah yang dibayar',0),(58637,1629,'ar','Ø±Ø¨Ø§ - Ø²Ù‚ÙˆÙ…',0),(58638,1629,'fr','IntÃ©rÃªts payÃ©s',0),(58639,1629,'jp','æ”¯æ‰•åˆ©æ?¯',0),(58640,1629,'pt','Juros pagos',0),(58641,1629,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(58642,1629,'es','InterÃ©ses Pagados',0),(58643,1629,'de','Gezahlte Zinsen',0),(58644,1629,'en','Interest Paid',0),(58645,1630,'is','',0),(58646,1630,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯Ø§Ø®Ù„ÙŠ ',0),(58647,1630,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯Ø§Ø®Ù„ÙŠ ',0),(58648,1630,'tr','Dahili maliyet',0),(58649,1630,'pl','WewnÄ™trzne koszty',0),(58650,1630,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(58651,1630,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(58652,1630,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(58653,1630,'vi','GiÃ¡ ThÃ nh Ná»™i Bá»™',0),(58654,1630,'af','Interne Kostes',0),(58655,1630,'ro','Costuri interne',0),(58656,1630,'et','Sisemised kulud',0),(58657,1630,'si','Notranji stroÅ¡ki',0),(58658,1630,'ba','Biaya internal',0),(58659,1630,'nl','Interne kosten',0),(58660,1630,'fi','SisÃ¤iset kustannukset',0),(58661,1630,'no','Interne kostnader',0),(58662,1630,'da','Interne omkostninger',0),(58663,1630,'ko','ë‚´ë¶€ ë¹„ìš©',0),(58664,1630,'he','×¢×œ×•×™×•×ª ×¤× ×™×ž×™',0),(58665,1630,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ¿Ï ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(58666,1630,'zh','å†…éƒ¨æˆæœ¬\r\n',0),(58667,1630,'sv','Interna kostnader',0),(58668,1630,'it','Costi interni',0),(58669,1630,'tl','',0),(58670,1630,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3616;&#3634;&#3618;&#3651;&#3609;',0),(58671,1630,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤²à¤¾à¤—à¤¤',0),(58672,1630,'ms','Kos dalaman',0),(58673,1630,'ar','Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(58674,1630,'fr','CoÃ»ts internes',0),(58675,1630,'jp','å†…éƒ¨è²»ç”¨',0),(58676,1630,'pt','Custos internos',0),(58677,1630,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(58678,1630,'es','Costos Internales',0),(58679,1630,'de','Interne Kosten',0),(58680,1630,'en','Internal Costs',0),(58681,1631,'is','',0),(58682,1631,'dr','Ø®Ø·Ø§ÙŠ Ø³Ø±ÙˆØ± Ø¯Ø§Ø®Ù„ÙŠ â€“ Ù„Ø·ÙØ§ Ø¨Ø¹Ø¯Ø§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(58683,1631,'pr','Ø®Ø·Ø§ÙŠ Ø³Ø±ÙˆØ± Ø¯Ø§Ø®Ù„ÙŠ â€“ Ù„Ø·ÙØ§ Ø¨Ø¹Ø¯Ø§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(58684,1631,'tr','Ä°Ã§ sunucu hatasÄ±, lÃ¼tfen daha sonra yeniden deneyin.',0),(58685,1631,'pl','WewnÄ™trzny serwer bÅ‚Ä…d, sprÃ³buj ponownie pÃ³Åºniej.',0),(58686,1631,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð° Ð³Ñ€ÐµÑˆÐºÐ° Ð½Ð° ÑÑŠÑ€Ð²ÑŠÑ€Ð°, Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾ Ð¿Ð¾-ÐºÑŠÑÐ½Ð¾.',0),(58687,1631,'ur','Ø³Ø±ÙˆØ± Ú©ÛŒ Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ ØºÙ„Ø·ÛŒØŒ Ø¨Ø¹Ø¯ Ø§Ø²Ø§Úº Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº Û”',0),(58688,1631,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ° Ð³Ñ€ÐµÑˆÐºÐ° ÑÐµÑ€Ð²ÐµÑ€Ð°, Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ ÐºÐ°ÑÐ½Ð¸Ñ˜Ðµ.',0),(58689,1631,'vi','Lá»—i ná»™i bá»™, vui lÃ²ng thá»­ láº¡i',0),(58690,1631,'af','Interne bedienerfout, probeer asseblief weer later.',0),(58691,1631,'ro','Eroare internÄƒ de server, vÄƒ rugÄƒm sÄƒ Ã®ncercaÅ£i din nou mai tÃ¢rziu.',0),(58692,1631,'et','Internal server viga, Palun proovige hiljem uuesti.',0),(58693,1631,'si','Notranja napaka streÅ¾nika, poskusite znova pozneje.',0),(58694,1631,'ba','Kesalahan internal server, silakan coba lagi nanti.',0),(58695,1631,'nl','Interne serverfout, probeer het later opnieuw.',0),(58696,1631,'fi','SisÃ¤inen palvelinvirhe, yritÃ¤ myÃ¶hemmin uudelleen.',0),(58697,1631,'no','Intern feil, prÃ¸v igjen senere.',0),(58698,1631,'da','Intern serverfejl, prÃ¸v igen senere.',0),(58699,1631,'ko','ë‚´ë¶€ ì„œë²„ ì˜¤ë¥˜ë¥¼ ë‚˜ì¤‘ì— ë‹¤ì‹œ ì‹œë„ í•˜ì‹­ì‹œì˜¤.',0),(58700,1631,'he','×©×’×™××ª ×©×¨×ª ×¤× ×™×ž×™×ª, ×× × × ×¡×” ×©×•×‘ ×ž××•×—×¨ ×™×•×ª×¨.',0),(58701,1631,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÏŒ ÏƒÏ†Î¬Î»Î¼Î± Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î®, Ï€Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬ Î±ÏÎ³ÏŒÏ„ÎµÏÎ±.',0),(58702,1631,'zh','å†…éƒ¨æœåŠ¡å™¨é”™è¯¯ï¼Œè¯·ç¨åŽå†è¯•ã€‚\r\n',0),(58703,1631,'sv','Internt serverfel, vÃ¤nligen fÃ¶rsÃ¶k igen senare.',0),(58704,1631,'it','Errore interno del server, riprova piÃ¹ tardi.',0),(58705,1631,'tl','',0),(58706,1631,'th','server &#3616;&#3634;&#3618;&#3651;&#3609;&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604; &#3585;&#3619;&#3640;&#3603;&#3634;&#3621;&#3629;&#3591;&#3651;&#3627;&#3617;&#3656;&#3616;&#3634;&#3618;&#3627;&#',0),(58707,1631,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¸à¤°à¥à¤µà¤° à¤¤à¥à¤°à¥à¤Ÿà¤¿, à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚ à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚à¥¤',0),(58708,1631,'ms','Ralat pelayan dalaman, sila cuba lagi kemudian.',0),(58709,1631,'ar','Ø®Ø·Ø£ Ø¯Ø§Ø®Ù„ÙŠ ÙÙŠ Ø§Ù„Ù…Ù„Ù‚Ù…ØŒ Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„Ù…Ø­Ø§ÙˆÙ„Ø© Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ Ù„Ø§Ø­Ù‚Ø§Ù‹.',0),(58710,1631,'fr','Erreur interne du serveur, veuillez rÃ©essayer ultÃ©rieurement.',0),(58711,1631,'jp','å†…éƒ¨ã‚µãƒ¼ãƒ?ãƒ¼ã‚¨ãƒ©ãƒ¼ã€?å¾Œã?»ã?©ã‚‚ã?†ä¸€åº¦ã?Šè©¦ã?—ã??ã? ã?•ã?„',0),(58712,1631,'pt','Erro interno do servidor, por favor, tente novamente mais tarde.',0),(58713,1631,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÑÑ Ð¾ÑˆÐ¸Ð±ÐºÐ° ÑÐµÑ€Ð²ÐµÑ€Ð°, Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð¿Ñ‹Ñ‚ÐºÑƒ Ð¿Ð¾Ð·Ð¶Ðµ.',0),(58714,1631,'es','Error de Servidor internal, por facor intenta otra vez mÃ¡s tarde',0),(58715,1631,'de','Interner Serverfehler, bitte versuchen Sie es spÃ¤ter erneut.',0),(58716,1631,'en','Internal server error, please try again later.',0),(58717,1632,'is','',0),(58718,1632,'dr','Ø§ÙŠÙ†ØªØ±Ù†Øª ',0),(58719,1632,'pr','Ø§ÙŠÙ†ØªØ±Ù†Øª ',0),(58720,1632,'tr','Internet',0),(58721,1632,'pl','Internet',0),(58722,1632,'bg','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚',0),(58723,1632,'ur','Ø§Ù†Ù¹Ø±Ù†ÛŒÙ¹',0),(58724,1632,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚',0),(58725,1632,'vi','Internet',0),(58726,1632,'af','Internet',0),(58727,1632,'ro','Internet',0),(58728,1632,'et','Internet',0),(58729,1632,'si','Internet',0),(58730,1632,'ba','Internet',0),(58731,1632,'nl','Internet',0),(58732,1632,'fi','Internet',0),(58733,1632,'no','Internett',0),(58734,1632,'da','Internet',0),(58735,1632,'ko','ì¸í„°ë„·',0),(58736,1632,'he','××™× ×˜×¨× ×˜',0),(58737,1632,'el','Î”Î¹Î±Î´Î¯ÎºÏ„Ï…Î¿',0),(58738,1632,'zh','äº’è”ç½‘\r\n',0),(58739,1632,'sv','Internet',0),(58740,1632,'it','Internet',0),(58741,1632,'tl','',0),(58742,1632,'th','&#3629;&#3636;&#3609;&#3648;&#3605;&#3629;&#3619;&#3660;&#3648;&#3609;&#3655;&#3605;',0),(58743,1632,'hi','à¤‡à¤‚à¤Ÿà¤°à¤¨à¥‡à¤Ÿ',0),(58744,1632,'ms','Internet',0),(58745,1632,'ar','Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(58746,1632,'fr','Internet',0),(58747,1632,'jp','ã‚¤ãƒ³ã‚¿ãƒ¼ãƒ?ãƒƒãƒˆ',0),(58748,1632,'pt','Internet',0),(58749,1632,'ru','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚',0),(58750,1632,'es','Internet',0),(58751,1632,'de','Internet',0),(58752,1632,'en','Internet',0),(58753,1633,'is','',0),(58754,1633,'dr','ØªÙ†Ø¸ÙŠÙ… Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(58755,1633,'pr','ØªÙ†Ø¸ÙŠÙ… Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(58756,1633,'tr','Stok<br>Kurulum',0),(58757,1633,'pl','Spis<br>Instalator',0),(58758,1633,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸<br>ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(58759,1633,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ<br>Ø³ÛŒÙ¹ Ø§Ù¾',0),(58760,1633,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð°<br>ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(58761,1633,'vi','SetupHÃ ng trong kho',0),(58762,1633,'af','VoorraadOpstelling',0),(58763,1633,'ro','Inventarul<br>Programul de instalare',0),(58764,1633,'et','Varude<br>Seadistamine',0),(58765,1633,'si','Zaloge<br>Nastavitev',0),(58766,1633,'ba','Persediaan<br>Setup',0),(58767,1633,'nl','Inventaris<br>Setup',0),(58768,1633,'fi','Varaston<br>Asetukset',0),(58769,1633,'no','Lager<br>Installasjonsprogrammet',0),(58770,1633,'da','Lager<br>OpsÃ¦tning',0),(58771,1633,'ko','ìž¬ê³ <br>ì„¤ì¹˜',0),(58772,1633,'he','×ž×œ××™<br>×ª×•×›× ×™×ª ×”×”×ª×§× ×”',0),(58773,1633,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î®<br>Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(58774,1633,'zh','è®¾ç½®åº“å­˜\r\n',0),(58775,1633,'sv','Inventering<br>Setup',0),(58776,1633,'it','Inventario<br>Installazione',0),(58777,1633,'tl','',0),(58778,1633,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(58779,1633,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€<br>à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(58780,1633,'ms','Inventori<br>Persediaan',0),(58781,1633,'ar','Ø§Ù„Ù…Ø®Ø²ÙˆÙ†<br>Ø¨Ø±Ù†Ø§Ù…Ø¬ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(58782,1633,'fr','Inventaire<br>Programme d\'installation',0),(58783,1633,'jp','æ£šå?¸ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(58784,1633,'pt','InventÃ¡rio<br>InstalaÃ§Ã£o',0),(58785,1633,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ<br>Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ°',0),(58786,1633,'es','configuraciÃ³n<br>Inventario',0),(58787,1633,'de','Inventar<br>Setup',0),(58788,1633,'en','Inventory<br>Setup',0),(58789,1634,'is','',0),(58790,1634,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø§Ø¶Ø§ÙÙŠ ÙƒØ§Ø±Ø¨Ø± Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(58791,1634,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø§Ø¶Ø§ÙÙŠ ÙƒØ§Ø±Ø¨Ø± Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(58792,1634,'tr','GeÃ§ersiz entuserid',0),(58793,1634,'pl','NieprawidÅ‚owy entuserid',0),(58794,1634,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð° entuserid',0),(58795,1634,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ø§Ù†Ù¹ÙˆØ³Ø±Ø§Ø¯',0),(58796,1634,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ ÐµÐ½Ñ‚ÑƒÑÐµÑ€Ð¸Ð´',0),(58797,1634,'vi','ID NgÆ°á»i Sá»­ Dá»¥ng vÃ´ hiá»‡u lá»±c',0),(58798,1634,'af','Ongeldige \"entuserid\"',0),(58799,1634,'ro','Incorecte entuserid',0),(58800,1634,'et','Sobimatu entuserid',0),(58801,1634,'si','Neveljaven entuserid',0),(58802,1634,'ba','Entuserid tidak valid',0),(58803,1634,'nl','Ongeldige entuserid',0),(58804,1634,'fi','Virheellinen entuserid',0),(58805,1634,'no','Ugyldig entuserid',0),(58806,1634,'da','Ugyldigt entuserid',0),(58807,1634,'ko','ìž˜ëª» ëœ entuserid',0),(58808,1634,'he','Entuserid ×œ× ×—×•×§×™',0),(58809,1634,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· entuserid',0),(58810,1634,'zh','æ— æ•ˆçš„ç”¨æˆ·èº«ä»½è¯\r\n',0),(58811,1634,'sv','Ogiltig entuserid',0),(58812,1634,'it','Entuserid non valido',0),(58813,1634,'tl','',0),(58814,1634,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3648;&#3586;&#3657;&#3634;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(58815,1634,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ entuserid',0),(58816,1634,'ms','Entuserid tidak sah',0),(58817,1634,'ar','Ø§Ù†ØªÙˆØ³ÙŠØ±ÙŠØ¯ ØºÙŠØ± ØµØ§Ù„Ø­',0),(58818,1634,'fr','Entuserid non valide',0),(58819,1634,'jp','Invalid entuserid',0),(58820,1634,'pt','Entuserid invÃ¡lido',0),(58821,1634,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ entuserid',0),(58822,1634,'es','InvÃ¡lido ID de usuario',0),(58823,1634,'de','UngÃ¼ltige entuserid',0),(58824,1634,'en','Invalid entuserid',0),(58825,1635,'is','',0),(58826,1635,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø§Ø¶Ø§ÙÙŠ ÙƒØ§Ø±Ø¨Ø± Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(58827,1635,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø§Ø¶Ø§ÙÙŠ ÙƒØ§Ø±Ø¨Ø± Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(58828,1635,'tr','GeÃ§ersiz extuserid',0),(58829,1635,'pl','NieprawidÅ‚owy extuserid',0),(58830,1635,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð° extuserid',0),(58831,1635,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ù¹ÙˆØ³Ø±Ø§Ø¯',0),(58832,1635,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ ÐµxÑ‚ÑƒÑÐµÑ€Ð¸Ð´',0),(58833,1635,'vi','ID NgÆ°á»i Sá»­ Dá»¥ng vÃ´ hiá»‡u lá»±c',0),(58834,1635,'af','Ongeldige \"extuserid\"',0),(58835,1635,'ro','Incorecte extuserid',0),(58836,1635,'et','Lubamatu extuserid',0),(58837,1635,'si','Neveljaven extuserid',0),(58838,1635,'ba','Extuserid tidak valid',0),(58839,1635,'nl','Ongeldige extuserid',0),(58840,1635,'fi','Virheellinen extuserid',0),(58841,1635,'no','Ugyldig extuserid',0),(58842,1635,'da','Ugyldigt extuserid',0),(58843,1635,'ko','ìž˜ëª» ëœ extuserid',0),(58844,1635,'he','Extuserid ×œ× ×—×•×§×™',0),(58845,1635,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· extuserid',0),(58846,1635,'zh','åˆ†æœºç”¨èº«ä»½è¯æ— æ•ˆ\r\n',0),(58847,1635,'sv','Ogiltig extuserid',0),(58848,1635,'it','Extuserid non valido',0),(58849,1635,'tl','',0),(58850,1635,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3648;&#3586;&#3657;&#3634;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(58851,1635,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ extuserid',0),(58852,1635,'ms','Extuserid tidak sah',0),(58853,1635,'ar','Ø§ÙƒØ³ØªÙˆØ³ÙŠØ±ÙŠØ¯ ØºÙŠØ± ØµØ§Ù„Ø­Ø©',0),(58854,1635,'fr','Extuserid non valide',0),(58855,1635,'jp','Invalid extuserid',0),(58856,1635,'pt','Extuserid invÃ¡lido',0),(58857,1635,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ extuserid',0),(58858,1635,'es','InvÃ¡lido id de usuario external',0),(58859,1635,'de','UngÃ¼ltige extuserid',0),(58860,1635,'en','Invalid extuserid',0),(58861,1636,'is','',0),(58862,1636,'dr','Ø¹Ù…Ù„ÙŠØ§Øª Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª',0),(58863,1636,'pr','Ø¹Ù…Ù„ÙŠØ§Øª Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª',0),(58864,1636,'tr','GeÃ§ersiz iÅŸlem.',0),(58865,1636,'pl','NieprawidÅ‚owa operacja.',0),(58866,1636,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ.',0),(58867,1636,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ø¹Ù…Ù„ ÛÛ’ Û”',0),(58868,1636,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð°.',0),(58869,1636,'vi','Hoáº¡t Ä‘á»™ng vÃ´ hiá»‡u',0),(58870,1636,'af','Ongeldige bewerking.',0),(58871,1636,'ro','OperaÈ›iune nevalidÄƒ.',0),(58872,1636,'et','Sobimatu toiming.',0),(58873,1636,'si','Neveljavna operacija.',0),(58874,1636,'ba','Operasi tidak valid.',0),(58875,1636,'nl','Ongeldige bewerking.',0),(58876,1636,'fi','Toiminto ei kelpaa.',0),(58877,1636,'no','Ugyldig operasjon.',0),(58878,1636,'da','Ugyldig handling.',0),(58879,1636,'ko','ìž˜ëª» ëœ ìž‘ì—…ìž…ë‹ˆë‹¤.',0),(58880,1636,'he','×¤×¢×•×œ×” ×œ× ×—×•×§×™×ª.',0),(58881,1636,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±.',0),(58882,1636,'zh','æ— æ•ˆçš„æ“ä½œã€‚\r\n',0),(58883,1636,'sv','Ogiltig Ã¥tgÃ¤rd.',0),(58884,1636,'it','Operazione non valida.',0),(58885,1636,'tl','',0),(58886,1636,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(58887,1636,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆà¥¤',0),(58888,1636,'ms','Operasi tidak sah.',0),(58889,1636,'ar','Ø¹Ù…Ù„ÙŠØ© ØºÙŠØ± ØµØ§Ù„Ø­Ø©.',0),(58890,1636,'fr','OpÃ©ration non valide.',0),(58891,1636,'jp','ç„¡åŠ¹ã?ªã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³',0),(58892,1636,'pt','OperaÃ§Ã£o invÃ¡lida.',0),(58893,1636,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð°Ñ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ.',0),(58894,1636,'es','OperaciÃ³n InvÃ¡lido ',0),(58895,1636,'de','UngÃ¼ltiger Vorgang.',0),(58896,1636,'en','Invalid operation.',0),(58897,1637,'is','',0),(58898,1637,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù†Ù…ÙˆØ¯Ø§Ø± Ù†Ø§Ù…Ø¹ØªØ¨Ø± ',0),(58899,1637,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù†Ù…ÙˆØ¯Ø§Ø± Ù†Ø§Ù…Ø¹ØªØ¨Ø± ',0),(58900,1637,'tr','GeÃ§ersiz bir pasta kimliÄŸi',0),(58901,1637,'pl','NieprawidÅ‚owy identyfikator Pie',0),(58902,1637,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð˜Ð” Ð½Ð° Ð¿Ð°Ð¹',0),(58903,1637,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ù¾Ø§Ø¦ÛŒ Ø´Ù†Ø§Ø®Øª',0),(58904,1637,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ Ð˜Ð” Ð¿Ð¸Ñ‚Ñƒ',0),(58905,1637,'vi','ID á»‘ng vÃ´ hiá»‡u',0),(58906,1637,'af','Ongeldige Sirkeldiagram ID',0),(58907,1637,'ro','Invalid Pie ID',0),(58908,1637,'et','Pirukas ID ei sobi.',0),(58909,1637,'si','Neveljaven ID Pie',0),(58910,1637,'ba','Tidak valid Pie ID',0),(58911,1637,'nl','Ongeldige Pie ID',0),(58912,1637,'fi','Virheellinen kakku tunnus',0),(58913,1637,'no','Ugyldig Pie-ID',0),(58914,1637,'da','Ugyldigt Pie-ID',0),(58915,1637,'ko','ìž˜ëª» ëœ íŒŒì´ ID',0),(58916,1637,'he','×ž×–×”×” ×¢×•×’×” ×œ× ×—×•×§×™',0),(58917,1637,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€Î¯Ï„Î±',0),(58918,1637,'zh','æ— æ•ˆçš„é¥¼å›¾ID\r\n',0),(58919,1637,'sv','Ogiltigt ID fÃ¶r paj',0),(58920,1637,'it','ID non valido Pie',0),(58921,1637,'tl','',0),(58922,1637,'th','Pie ID &#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(58923,1637,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤ªà¤¾à¤‡ ID',0),(58924,1637,'ms','Tidak sah pai ID',0),(58925,1637,'ar','Ù…Ø¹Ø±Ù ØºÙŠØ± ØµØ§Ù„Ø­ Ø¯Ø§Ø¦Ø±ÙŠ',0),(58926,1637,'fr','ID non valide de Pie',0),(58927,1637,'jp','ç„¡åŠ¹ãƒ‘ã‚¤ID',0),(58928,1637,'pt','ID invÃ¡lido de torta',0),(58929,1637,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð¿Ð¸Ñ€Ð¾Ð³',0),(58930,1637,'es','GrÃ¡fica Pie ID InvÃ¡lida',0),(58931,1637,'de','UngÃ¼ltige Pie-ID',0),(58932,1637,'en','Invalid Pie ID',0),(58933,1638,'is','',0),(58934,1638,'dr','(Ù‚Ø³Ù…Øª) Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(58935,1638,'pr','Ø¨Ø±Ø´(Ù‚Ø³Ù…Øª) Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(58936,1638,'tr','GeÃ§ersiz dilim',0),(58937,1638,'pl','NieprawidÅ‚owy kawaÅ‚ek',0),(58938,1638,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð¿Ð°Ñ€Ñ‡Ðµ',0),(58939,1638,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ù‚Ø§Ø´',0),(58940,1638,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ Ð¸ÑÐµÑ‡Ð°Ðº',0),(58941,1638,'vi','LÃ¡t cáº¯t vÃ´ hiá»‡u',0),(58942,1638,'af','Ongeldige skyf',0),(58943,1638,'ro','Felie de invalid',0),(58944,1638,'et','Sobimatu viil',0),(58945,1638,'si','Neveljaven rezina',0),(58946,1638,'ba','Iris tidak valid',0),(58947,1638,'nl','Ongeldige segment',0),(58948,1638,'fi','Virheellinen siivu',0),(58949,1638,'no','Ugyldig sektor',0),(58950,1638,'da','Ugyldig skive',0),(58951,1638,'ko','ìž˜ëª» ëœ ìŠ¬ë¼ì´ìŠ¤',0),(58952,1638,'he','×¤×¨×•×¡×” ×œ× ×—×•×§×™',0),(58953,1638,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· Ï†Î­Ï„Î±',0),(58954,1638,'zh','æ— æ•ˆçš„åˆ‡ç‰‡\r\n',0),(58955,1638,'sv','Ogiltig segment',0),(58956,1638,'it','Fetta non valido',0),(58957,1638,'tl','',0),(58958,1638,'th','&#3626;&#3656;&#3623;&#3609;&#3609;&#3637;&#3657;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(58959,1638,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤¸à¥à¤²à¤¾à¤‡à¤¸',0),(58960,1638,'ms','Hirisan tidak sah',0),(58961,1638,'ar','Ø´Ø±ÙŠØ­Ø© ØºÙŠØ± ØµØ§Ù„Ø­Ø©',0),(58962,1638,'fr','Tranche non valide',0),(58963,1638,'jp','ç„¡åŠ¹ã‚¹ãƒ©ã‚¤ã‚¹',0),(58964,1638,'pt','Fatia invÃ¡lida',0),(58965,1638,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ Ñ„Ñ€Ð°Ð³Ð¼ÐµÐ½Ñ‚',0),(58966,1638,'es','Rebanada de grÃ¡fica pie InvÃ¡lida',0),(58967,1638,'de','UngÃ¼ltige Scheibe',0),(58968,1638,'en','Invalid slice',0),(58969,1639,'is','',0),(58970,1639,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(58971,1639,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(58972,1639,'tr','Stok',0),(58973,1639,'pl','Spis',0),(58974,1639,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸',0),(58975,1639,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(58976,1639,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð°',0),(58977,1639,'vi','HÃ ng HÃ³a',0),(58978,1639,'af','Voorraad',0),(58979,1639,'ro','Gestiune',0),(58980,1639,'et','Inventuur',0),(58981,1639,'si','Inventar',0),(58982,1639,'ba','Persediaan',0),(58983,1639,'nl','Inventaris',0),(58984,1639,'fi','Varaston',0),(58985,1639,'no','Lager',0),(58986,1639,'da','Lager',0),(58987,1639,'ko','ìž¬ê³ ',0),(58988,1639,'he','×ž×œ××™',0),(58989,1639,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î®',0),(58990,1639,'zh','åº“å­˜',0),(58991,1639,'sv','Inventering',0),(58992,1639,'it','Inventario',0),(58993,1639,'tl','',0),(58994,1639,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(58995,1639,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€',0),(58996,1639,'ms','Inventori',0),(58997,1639,'ar','Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(58998,1639,'fr','Inventaire',0),(58999,1639,'jp','åœ¨åº«å“?ç›®',0),(59000,1639,'pt','InventÃ¡rio',0),(59001,1639,'ru','Ð¡ÐºÐ»Ð°Ð´',0),(59002,1639,'es','Inventario',0),(59003,1639,'de','Inventar',0),(59004,1639,'en','Inventory',0),(59005,1640,'is','',0),(59006,1640,'dr','Ø§ØµÙ„Ø§Ø­ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59007,1640,'pr','Ø§ØµÙ„Ø§Ø­ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59008,1640,'tr','Stok DÃ¼zeltmesi',0),(59009,1640,'pl','Korekty zapasÃ³w',0),(59010,1640,'bg','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(59011,1640,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(59012,1640,'sr','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59013,1640,'vi','Chá»‰nh Sá»­a HÃ ng HÃ³a',0),(59014,1640,'af','Voorraad Aanpassing',0),(59015,1640,'ro','Ajustari Inventar',0),(59016,1640,'et','Lao korrigeerimine',0),(59017,1640,'si','Popravkov vrednosti zaloge',0),(59018,1640,'ba','Penyesuaian persediaan',0),(59019,1640,'nl','Voorraadherwaardering',0),(59020,1640,'fi','Varaston oikaisu',0),(59021,1640,'no','Lagerjustering',0),(59022,1640,'da','Lagerregulering',0),(59023,1640,'ko','ìž¬ê³  ì¡°ì •',0),(59024,1640,'he','×”×ª××ž×ª ×ž×œ××™',0),(59025,1640,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(59026,1640,'zh','åº“å­˜è°ƒæ•´',0),(59027,1640,'sv','Lagerjustering',0),(59028,1640,'it','Regolazione di inventario',0),(59029,1640,'tl','',0),(59030,1640,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59031,1640,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(59032,1640,'ms','Pelarasan Inventori',0),(59033,1640,'ar','ØªØ¹Ø¯ÙŠÙ„ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(59034,1640,'fr','Ajustement d\'inventaire',0),(59035,1640,'jp','åœ¨åº«èª¿æ•´',0),(59036,1640,'pt','Ajuste de inventÃ¡rio',0),(59037,1640,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(59038,1640,'es','Ajuste de Inventario',0),(59039,1640,'de','Lagerregulierung',0),(59040,1640,'en','Inventory Adjustment',0),(59041,1641,'is','',0),(59042,1641,'dr','ÙƒØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59043,1641,'pr','ÙƒØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59044,1641,'tr','Stok kodu',0),(59045,1641,'pl','Spis kod',0),(59046,1641,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(59047,1641,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÙˆÚˆ',0),(59048,1641,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59049,1641,'vi','MÃ£ HÃ ng HÃ³a',0),(59050,1641,'af','Voorraadkode',0),(59051,1641,'ro','Cod Inventar',0),(59052,1641,'et','Laokood',0),(59053,1641,'si','Zaloge kodo',0),(59054,1641,'ba','Kode persediaan',0),(59055,1641,'nl','Voorraad Code',0),(59056,1641,'fi','Varaston koodi',0),(59057,1641,'no','Lager koden',0),(59058,1641,'da','Lager kode',0),(59059,1641,'ko','ìž¬ê³  ì½”ë“œ',0),(59060,1641,'he','×§×•×“ ×ž×œ××™',0),(59061,1641,'el','ÎšÏ‰Î´Î¹ÎºÏŒ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(59062,1641,'zh','åº“å­˜ä»£ç \r\n',0),(59063,1641,'sv','Inventering kod',0),(59064,1641,'it','Codice inventario',0),(59065,1641,'tl','',0),(59066,1641,'th','&#3619;&#3627;&#3633;&#3626;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59067,1641,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤•à¥‹à¤¡',0),(59068,1641,'ms','Kod inventori',0),(59069,1641,'ar','Ø±Ù…Ø² Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(59070,1641,'fr','Code de l\'inventaire',0),(59071,1641,'jp','åœ¨åº«ã‚³ãƒ¼ãƒ‰',0),(59072,1641,'pt','CÃ³digo de inventÃ¡rio',0),(59073,1641,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÐºÐ¾Ð´',0),(59074,1641,'es','CÃ³digo de Inventario',0),(59075,1641,'de','Inventar-Code',0),(59076,1641,'en','Inventory Code',0),(59077,1642,'is','',0),(59078,1642,'dr','Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ ÙØ§ÙŠÙ„ Ø¶Ù…ÙŠÙ…Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59079,1642,'pr','Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ ÙØ§ÙŠÙ„ Ø¶Ù…ÙŠÙ…Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59080,1642,'tr','Envanter dosya eki BakÄ±mÄ±',0),(59081,1642,'pl','Spis plikÃ³w zaÅ‚Ä…cznikÃ³w konserwacji',0),(59082,1642,'bg','ÐŸÐ¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð½Ð° ÑÐºÐ»Ð°Ð´Ð° Ñ„Ð°Ð¹Ð» Ð¿Ñ€Ð¸ÐºÐ°Ñ‡ÐµÐ½ Ñ„Ð°Ð¹Ð»',0),(59083,1642,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø³Ù„ Ù…Ù†Ø³Ù„Ú©Û Ø¯ÛŒÚ©Ú¾ Ø¨Ú¾Ø§Ù„',0),(59084,1642,'sr','ÐžÐ´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¸Ð»Ð¾Ð³ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59085,1642,'vi','Báº£o DÆ°á»¡ng Há»“ SÆ¡ HÃ ng HÃ³a',0),(59086,1642,'af','Voorraad LÃªers Aanhegsel Onderhoud',0),(59087,1642,'ro','Inventarul fiÅŸierului ataÅŸament Ã®ntreÅ£inere',0),(59088,1642,'et','Varude faili manusena hooldus',0),(59089,1642,'si','VzdrÅ¾evanje zaloge datoteko Prilogo',0),(59090,1642,'ba','Pemeliharaan inventaris File Lampiran',0),(59091,1642,'nl','Inventaris bestand bijlage onderhoud',0),(59092,1642,'fi','Varaston tiedosto kiinnitys huolto',0),(59093,1642,'no','Lager fil vedlikehold',0),(59094,1642,'da','Lager-fil vedhÃ¦ftet fil vedligeholdelse',0),(59095,1642,'ko','ìž¬ê³  íŒŒì¼ ì²¨ë¶€ íŒŒì¼ ìœ ì§€ ê´€ë¦¬',0),(59096,1642,'he','×ž×œ××™ ×§×•×‘×¥ ×ž×¦×•×¨×£ ×ª×—×–×•×§×”',0),(59097,1642,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ· ÏƒÏ…Î½Î·Î¼Î¼Î­Î½Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(59098,1642,'zh','åº“å­˜æ–‡ä»¶é™„ä»¶ç»´ä¿®\r\n',0),(59099,1642,'sv','LagerunderhÃ¥ll fil bifogad fil',0),(59100,1642,'it','Inventario File allegato manutenzione',0),(59101,1642,'tl','',0),(59102,1642,'th','&#3585;&#3634;&#3619;&#3610;&#3635;&#3619;&#3640;&#3591;&#3619;&#3633;&#3585;&#3625;&#3634;&#3652;&#3615;&#3621;&#3660;&#3607;&#3637;&#3656;&#3649;&#3609;&#3610;&#3617;&#3634;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3',0),(59103,1642,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤¨à¥à¤²à¤—à¥à¤¨à¤• à¤°à¤–à¤°à¤–à¤¾à¤µ',0),(59104,1642,'ms','Penyelenggaraan lampiran fail inventori',0),(59105,1642,'ar','ØµÙŠØ§Ù†Ø© Ù…Ø±ÙÙ‚ Ù…Ù„Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(59106,1642,'fr','L\'inventaire fichier piÃ¨ce jointe entretien',0),(59107,1642,'jp','åœ¨åº«ãƒ•ã‚¡ã‚¤ãƒ«æ·»ä»˜ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹',0),(59108,1642,'pt','ManutenÃ§Ã£o de anexo de arquivo de inventÃ¡rio',0),(59109,1642,'ru','ÐžÐ±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ Ð²Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ñ„Ð°Ð¹Ð»Ð¾Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(59110,1642,'es','Mantenimiento de Anexo de File de Inventario',0),(59111,1642,'de','Wartung des Datei-Attachment Inventar',0),(59112,1642,'en','Inventory File Attachment Maintenance',0),(59113,1643,'is','',0),(59114,1643,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(59115,1643,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(59116,1643,'tr','Envanter gÃ¶nderildi',0),(59117,1643,'pl','ZapasÃ³w zostaÅ‚ zaksiÄ™gowany',0),(59118,1643,'bg','Ð—Ð°Ð¿Ð°Ñ Ðµ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½',0),(59119,1643,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù¾ÙˆØ³Ù¹ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(59120,1643,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ñ˜Ðµ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½.',0),(59121,1643,'vi','HÃ ng HÃ³a Ä‘Ã£ Ä‘Äƒng lÃªn',0),(59122,1643,'af','Inventaris is gepos',0),(59123,1643,'ro','Inventarul a fost postat',0),(59124,1643,'et','Lao konteeritud',0),(59125,1643,'si','Popis je bil objavljen',0),(59126,1643,'ba','Persediaan telah diposting',0),(59127,1643,'nl','Voorraad is geboekt',0),(59128,1643,'fi','Varasto on kirjattu',0),(59129,1643,'no','Beholdningen er bokfÃ¸rt',0),(59130,1643,'da','Lagerbeholdning er blevet bogfÃ¸rt',0),(59131,1643,'ko','ìž¬ê³  ê²Œì‹œ ë¨',0),(59132,1643,'he','×¤×•×¨×¡× ×ž×œ××™',0),(59133,1643,'el','Î‘Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î­Ï‡ÎµÎ¹ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¸ÎµÎ¯',0),(59134,1643,'zh','åº“å­˜å·²å‘å¸ƒ\r\n',0),(59135,1643,'sv','Inventeringen har bokfÃ¶rts',0),(59136,1643,'it','Inventario Ã¨ stato pubblicato',0),(59137,1643,'tl','',0),(59138,1643,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3652;&#3604;&#3657;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3621;&#3657;&#3623;',0),(59139,1643,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¨à¤¿à¤¯à¥à¤•à¥à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(59140,1643,'ms','Inventori telah dipaparkan',0),(59141,1643,'ar','ÙˆÙ‚Ø¯ ØªÙ… ØªØ±Ø­ÙŠÙ„ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(59142,1643,'fr','L\'inventaire a Ã©tÃ© publiÃ©',0),(59143,1643,'jp','åœ¨åº«ã?Œè¨ˆä¸Šã?•ã‚Œã?¾ã?—ã?Ÿ',0),(59144,1643,'pt','InventÃ¡rio foi Postado',0),(59145,1643,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð±Ñ‹Ð»Ð° Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð°',0),(59146,1643,'es','Inventario se AsentÃ³',0),(59147,1643,'de','Inventur gebucht wurde',0),(59148,1643,'en','Inventory has been posted',0),(59149,1644,'is','',0),(59150,1644,'dr','ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(59151,1644,'pr','ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(59152,1644,'tr','Stok maddesi',0),(59153,1644,'pl','Towar',0),(59154,1644,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð² Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(59155,1644,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’',0),(59156,1644,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(59157,1644,'vi','Danh Má»¥c hÃ ng hÃ³a',0),(59158,1644,'af','Voorraaditem',0),(59159,1644,'ro','Articol Inventar',0),(59160,1644,'et','Inventuuri toode',0),(59161,1644,'si','Artikla zaloge',0),(59162,1644,'ba','Persediaan barang',0),(59163,1644,'nl','Voorraadartikel',0),(59164,1644,'fi','Varastotuote',0),(59165,1644,'no','Lagervare',0),(59166,1644,'da','Lagervare',0),(59167,1644,'ko','ì¸ë²¤í† ë¦¬ í•­ëª©',0),(59168,1644,'he','×¤×¨×™×˜ ×ž×œ××™',0),(59169,1644,'el','Î•Î¯Î´Î¿Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(59170,1644,'zh','åº“å­˜é¡¹ç›®\r\n',0),(59171,1644,'sv','Lagerartikel',0),(59172,1644,'it','Articolo di magazzino',0),(59173,1644,'tl','',0),(59174,1644,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59175,1644,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤®',0),(59176,1644,'ms','Inventori',0),(59177,1644,'ar','ØµÙ†Ù Ù…Ø®Ø²ÙˆÙ†',0),(59178,1644,'fr','Article en stock',0),(59179,1644,'jp','åœ¨åº«å“?ç›®',0),(59180,1644,'pt','Item de inventÃ¡rio',0),(59181,1644,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(59182,1644,'es','Item de Inventario',0),(59183,1644,'de','Lagerartikel',0),(59184,1644,'en','Inventory Item',0),(59185,1645,'is','',0),(59186,1645,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(59187,1645,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(59188,1645,'tr','Stok Ã¶ÄŸesi etkinlik listeleri',0),(59189,1645,'pl','Spis pozycji aktywnoÅ›Ä‡ list',0),(59190,1645,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ ÑÐ¿Ð¸ÑÑŠÑ†Ð¸',0),(59191,1645,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(59192,1645,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð»Ð¸ÑÑ‚Ðµ',0),(59193,1645,'vi','Danh sÃ¡ch hoáº¡t Ä‘á»™ng hÃ ng hÃ³a',0),(59194,1645,'af','Voorraaditem Aktiwiteit Lyste',0),(59195,1645,'ro','Inventarul element activitate liste',0),(59196,1645,'et','Varude Ã¼ksuse tegevuse nimekirjad',0),(59197,1645,'si','Zaloge artikla dejavnosti seznamih',0),(59198,1645,'ba','Daftar kegiatan persediaan barang',0),(59199,1645,'nl','Inventaris objectenlijsten activiteit',0),(59200,1645,'fi','Varaston nimikkeen luetteloista',0),(59201,1645,'no','Lager elementlister aktivitet',0),(59202,1645,'da','Lager vare aktivitet lister',0),(59203,1645,'ko','ìž¬ê³  í•­ëª© í™œë™ ëª©ë¡',0),(59204,1645,'he','×¨×©×™×ž×•×ª ×ž×¦××™ ×¤×¨×™×˜ ×¤×¢×™×œ×•×ª',0),(59205,1645,'el','ÎšÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï…Ï‚ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(59206,1645,'zh','åº“å­˜é¡¹ç›®æ´»åŠ¨åˆ—è¡¨\r\n',0),(59207,1645,'sv','Inventering aktivitet objektlistor',0),(59208,1645,'it','Elenchi di attivitÃ  inventario',0),(59209,1645,'tl','',0),(59210,1645,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3588;&#3621;&#3639;&#3656;&#3629;&#3609;&#3652;&#3627;&#3',0),(59211,1645,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(59212,1645,'ms','Senarai aktiviti Item inventori',0),(59213,1645,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø¬Ø±Ø¯ Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ù†Ø´Ø§Ø·',0),(59214,1645,'fr','Listes d\'activitÃ© l\'inventaire',0),(59215,1645,'jp','åœ¨åº«å“?ç›®ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ãƒªã‚¹ãƒˆ',0),(59216,1645,'pt','Listas de inventÃ¡rio Item atividade',0),(59217,1645,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ ÑÐ¿Ð¸ÑÐºÐ¾Ð²',0),(59218,1645,'es','Lista de Actividad de Items de Inventario',0),(59219,1645,'de','Element Activity-Bestandslisten',0),(59220,1645,'en','Inventory Item Activity Lists',0),(59221,1646,'is','',0),(59222,1646,'dr','ÙˆØ§Ø­Ø¯ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(59223,1646,'pr','ÙˆØ§Ø­Ø¯ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(59224,1646,'tr','Stok birimi',0),(59225,1646,'pl','Pozycji magazynowej',0),(59226,1646,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð° Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(59227,1646,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ ÛŒÙˆÙ†Ù¹',0),(59228,1646,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(59229,1646,'vi','ÄÆ¡n Vá»‹ HÃ ng',0),(59230,1646,'af','Inventaris Item Eenheid',0),(59231,1646,'ro','Unitati articol Inventar',0),(59232,1646,'et','Kauba laoÃ¼hikus',0),(59233,1646,'si','Enote artikla zaloge',0),(59234,1646,'ba','Persediaan Item Unit',0),(59235,1646,'nl','Inventaris artikeleenheid',0),(59236,1646,'fi','Nimikkeen varastoyksikÃ¶n',0),(59237,1646,'no','Elementet lagerenheten',0),(59238,1646,'da','Lagerenheden element.',0),(59239,1646,'ko','ìž¬ê³  í’ˆëª© ë‹¨ìœ„',0),(59240,1646,'he','×™×—×™×“×ª ×¤×¨×™×˜ ×ž×œ××™',0),(59241,1646,'el','ÎœÎ¿Î½Î¬Î´Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(59242,1646,'zh','åº“å­˜é¡¹ç›®å•ä½\r\n',0),(59243,1646,'sv','Lagerenheten objekt',0),(59244,1646,'it','Inventario nell\'unitÃ ',0),(59245,1646,'tl','',0),(59246,1646,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59247,1646,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤‡à¤•à¤¾à¤ˆ',0),(59248,1646,'ms','Unit Item inventori',0),(59249,1646,'ar','ÙˆØ­Ø¯Ø© ØµÙ†Ù Ù…Ø®Ø²ÙˆÙ†',0),(59250,1646,'fr','UnitÃ© de point de stock',0),(59251,1646,'jp','åœ¨åº«å“?ç›®å?˜ä½?',0),(59252,1646,'pt','Unidade de Item de inventÃ¡rio',0),(59253,1646,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿ÑƒÐ½ÐºÑ‚ Ð“Ñ€ÑƒÐ¿Ð¿Ð°',0),(59254,1646,'es','Unidad de Item de Inventario',0),(59255,1646,'de','Element Lagereinheit',0),(59256,1646,'en','Inventory Item Unit',0),(59257,1647,'is','',0),(59258,1647,'dr','Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59259,1647,'pr','Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59260,1647,'tr','Stok konumu',0),(59261,1647,'pl','Lokalizacji zapasÃ³w',0),(59262,1647,'bg','ÐœÑÑÑ‚Ð¾ Ð·Ð° ÑÐºÐ»Ð°Ð´',0),(59263,1647,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(59264,1647,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59265,1647,'vi','Äá»‹a Äiá»ƒm Äá»ƒ HÃ ng',0),(59266,1647,'af','Voorraad Ligging',0),(59267,1647,'ro','Inventarul locaÅ£ie',0),(59268,1647,'et','Lao asukoha',0),(59269,1647,'si','Lokacijo zaloge',0),(59270,1647,'ba','Lokasi persediaan',0),(59271,1647,'nl','Voorraadvestiging',0),(59272,1647,'fi','Varaston sijainti',0),(59273,1647,'no','Lagerlokasjon',0),(59274,1647,'da','Lagerlokation',0),(59275,1647,'ko','ìž¬ê³  ìœ„ì¹˜',0),(59276,1647,'he','×ž×™×§×•× ×ž×œ××™',0),(59277,1647,'el','Î‘Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(59278,1647,'zh','åº“å­˜ä½ç½®\r\n',0),(59279,1647,'sv','LagerstÃ¤lle',0),(59280,1647,'it','Ubicazione di inventario',0),(59281,1647,'tl','',0),(59282,1647,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59283,1647,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨',0),(59284,1647,'ms','Lokasi inventori',0),(59285,1647,'ar','Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹',0),(59286,1647,'fr','Emplacement de l\'inventaire',0),(59287,1647,'jp','Inventory Location',0),(59288,1647,'pt','LocalizaÃ§Ã£o de inventÃ¡rio',0),(59289,1647,'ru','Ð¡ÐºÐ»Ð°Ð´Ðµ',0),(59290,1647,'es','UbicaciÃ³n de Inventario',0),(59291,1647,'de','Lagerort',0),(59292,1647,'en','Inventory Location',0),(59293,1648,'is','',0),(59294,1648,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59295,1648,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59296,1648,'tr','Stok konumu ekle',0),(59297,1648,'pl','Dodawanie lokalizacji zapasÃ³w',0),(59298,1648,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¼ÑÑÑ‚Ð¾ Ð·Ð° ÑÐºÐ»Ð°Ð´',0),(59299,1648,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(59300,1648,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59301,1648,'vi','ThÃªm Äá»‹a Äiá»ƒm Äá»ƒ HÃ ng',0),(59302,1648,'af','Voorraad Byvoeg',0),(59303,1648,'ro','Adauga inventar locaÅ£ie',0),(59304,1648,'et','Lao asukoha lisamine',0),(59305,1648,'si','Dodaj lokacijo zaloge',0),(59306,1648,'ba','Tambahkan lokasi persediaan',0),(59307,1648,'nl','Voorraadvestiging toevoegen',0),(59308,1648,'fi','Varastosijainnin lisÃ¤Ã¤',0),(59309,1648,'no','Lagerlokasjon legge',0),(59310,1648,'da','Lagerlokation tilfÃ¸je',0),(59311,1648,'ko','ìž¬ê³  ìœ„ì¹˜ ì¶”ê°€',0),(59312,1648,'he','×”×•×¡×¤×ª ×ž×™×§×•× ×”×ž×œ××™',0),(59313,1648,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î±Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(59314,1648,'zh','åº“å­˜ä½ç½®æ·»åŠ \r\n',0),(59315,1648,'sv','LagerstÃ¤lle lÃ¤gga till',0),(59316,1648,'it','Aggiungi Ubicazione di inventario',0),(59317,1648,'tl','',0),(59318,1648,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59319,1648,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(59320,1648,'ms','Tambah lokasi inventori',0),(59321,1648,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø³ØªÙˆØ¯Ø¹',0),(59322,1648,'fr','Ajouter emplacement de l\'inventaire',0),(59323,1648,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®è¿½åŠ ',0),(59324,1648,'pt','Adicionar LocalizaÃ§Ã£o de inventÃ¡rio',0),(59325,1648,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐºÐ»Ð°Ð´Ðµ',0),(59326,1648,'es','UbicaciÃ³n de Inventario Agregar',0),(59327,1648,'de','Lagerstandortes hinzufÃ¼gen',0),(59328,1648,'en','Inventory Location Add',0),(59329,1649,'is','',0),(59330,1649,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(59331,1649,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(59332,1649,'tr','Stok konumu baÅŸarÄ±yla eklendi',0),(59333,1649,'pl','PomyÅ›lnie dodano lokalizacji zapasÃ³w',0),(59334,1649,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(59335,1649,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(59336,1649,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(59337,1649,'vi','ThÃªm Äá»‹a Äiá»ƒm Äá»ƒ HÃ ng thÃ nh cÃ´ng',0),(59338,1649,'af','Voorraad Plek suksesvol geskep',0),(59339,1649,'ro','Inventarul locaÅ£ie adÄƒugat cu succes',0),(59340,1649,'et','Lao asukoha lisatud',0),(59341,1649,'si','Lokacijo zaloge, uspeÅ¡no dodani',0),(59342,1649,'ba','Lokasi persediaan ditambahkan berhasil',0),(59343,1649,'nl','Inventory-Location toegevoegd',0),(59344,1649,'fi','Varastosijainnin lisÃ¤Ã¤minen onnistui',0),(59345,1649,'no','Lagerlokasjon lagt',0),(59346,1649,'da','Lagerlokation tilfÃ¸jet',0),(59347,1649,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ìž¬ê³  ìœ„ì¹˜',0),(59348,1649,'he','×ž×™×§×•× ×ž×œ××™ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(59349,1649,'el','Î‘Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(59350,1649,'zh','åº“å­˜ä½ç½®æ·»åŠ æˆåŠŸ\r\n',0),(59351,1649,'sv','LagerstÃ¤lle som lagts',0),(59352,1649,'it','Ubicazione di inventario aggiunto con successo',0),(59353,1649,'tl','',0),(59354,1649,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(59355,1649,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(59356,1649,'ms','Lokasi inventori yang berjaya menambah',0),(59357,1649,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹ Ø¨Ù†Ø¬Ø§Ø­',0),(59358,1649,'fr','Emplacement de l\'inventaire ajoutÃ© avec succÃ¨s',0),(59359,1649,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(59360,1649,'pt','LocalizaÃ§Ã£o de inventÃ¡rio adicionada com sucesso',0),(59361,1649,'ru','Ð¡ÐºÐ»Ð°Ð´Ðµ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(59362,1649,'es','UbicaciÃ³n de Inventario agregada exitosamente',0),(59363,1649,'de','Lagerstandortes erfolgreich hinzugefÃ¼gt',0),(59364,1649,'en','Inventory Location added successfully',0),(59365,1650,'is','',0),(59366,1650,'dr','Ø­Ø°Ù Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(59367,1650,'pr','Ø­Ø°Ù Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(59368,1650,'tr','Stok konumu baÅŸarÄ±yla silindi',0),(59369,1650,'pl','Lokalizacji zapasÃ³w przesâ”‚anie',0),(59370,1650,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(59371,1650,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(59372,1650,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(59373,1650,'vi','XÃ³a ThÃªm Äá»‹a Äiá»ƒm Äá»ƒ HÃ ng thÃ nh cÃ´ng',0),(59374,1650,'af','Voorraad \"Location\" suksesvol geskrap',0),(59375,1650,'ro','Inventarul locaÅ£ie eliminÄƒ cu succes',0),(59376,1650,'et','Lao asukoha edukalt kustutatud',0),(59377,1650,'si','Lokacijo zaloge, uspeÅ¡no izbrisana',0),(59378,1650,'ba','Lokasi persediaan dihapus berhasil',0),(59379,1650,'nl','Voorraadvestiging succesvol verwijderd',0),(59380,1650,'fi','Varastosijainnin poistettu',0),(59381,1650,'no','Lagerlokasjon slettet',0),(59382,1650,'da','Lagerlokation slettet',0),(59383,1650,'ko','ìž¬ê³  ìœ„ì¹˜ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(59384,1650,'he','×ž×™×§×•× ×”×ž×œ××™ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(59385,1650,'el','Î‘Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(59386,1650,'zh','åº“å­˜ä½ç½®åˆ é™¤æˆåŠŸ\r\n',0),(59387,1650,'sv','LagerstÃ¤lle som raderades',0),(59388,1650,'it','Ubicazione di inventario eliminato con successo',0),(59389,1650,'tl','',0),(59390,1650,'th','&#3621;&#3610;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(59391,1650,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(59392,1650,'ms','Lokasi inventori dihapuskan dengan jayanya',0),(59393,1650,'ar','Ø­Ø°Ù Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹ Ø¨Ù†Ø¬Ø§Ø­',0),(59394,1650,'fr','Emplacement de l\'inventaire supprimÃ© avec succÃ¨s',0),(59395,1650,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(59396,1650,'pt','LocalizaÃ§Ã£o de inventÃ¡rio apagada com sucesso',0),(59397,1650,'ru','Ð¡ÐºÐ»Ð°Ð´Ðµ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(59398,1650,'es','UbicaciÃ³n de Inventario eliminada exitosamente',0),(59399,1650,'de','Lagerstandortes erfolgreich gelÃ¶scht',0),(59400,1650,'en','Inventory Location deleted successfully',0),(59401,1651,'is','',0),(59402,1651,'dr','Ù†Ø§Ù… Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59403,1651,'pr','Ù†Ø§Ù… Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59404,1651,'tr','Stok yeri adÄ±',0),(59405,1651,'pl','Nazwa lokalizacji zapasÃ³w',0),(59406,1651,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°',0),(59407,1651,'ur','Ù†Ø§Ù… Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(59408,1651,'sr','ÐÐ°Ð·Ð¸Ð² Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59409,1651,'vi','TÃªn Äá»‹a Äiá»ƒm Äá»ƒ HÃ ng',0),(59410,1651,'af','Voorraad Ligging Naam',0),(59411,1651,'ro','Inventarul denumirea',0),(59412,1651,'et','Lao asukoha nime',0),(59413,1651,'si','Inventar ime mesta',0),(59414,1651,'ba','Nama lokasi persediaan',0),(59415,1651,'nl','Inventaris locatienaam',0),(59416,1651,'fi','Varaston sijainnin nimi',0),(59417,1651,'no','Lager stedsnavn',0),(59418,1651,'da','Lageret lokationens navn',0),(59419,1651,'ko','ìž¬ê³  ìœ„ì¹˜ ì´ë¦„',0),(59420,1651,'he','×©× ×”×ž×™×§×•× ×ž×œ××™',0),(59421,1651,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±Ï‚ Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(59422,1651,'zh','åº“å­˜åœ°ç‚¹åç§°\r\n',0),(59423,1651,'sv','Platsnamnet fÃ¶r inventering',0),(59424,1651,'it','Nome di percorso inventario',0),(59425,1651,'tl','',0),(59426,1651,'th','&#3594;&#3639;&#3656;&#3629;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59427,1651,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¤¾ à¤¨à¤¾à¤®',0),(59428,1651,'ms','Nama lokasi inventori',0),(59429,1651,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹\r\n',0),(59430,1651,'fr','Nom d\'emplacement de l\'inventaire',0),(59431,1651,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³å??',0),(59432,1651,'pt','Nome da localidade de inventÃ¡rio',0),(59433,1651,'ru','Ð˜Ð¼Ñ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(59434,1651,'es','Nombre de UbicaciÃ³n de Inventario',0),(59435,1651,'de','Inventar Standortnamen',0),(59436,1651,'en','Inventory Location Name',0),(59437,1652,'is','',0),(59438,1652,'dr','Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(59439,1652,'pr','Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(59440,1652,'tr','Stok konumu bulunamadÄ±',0),(59441,1652,'pl','Lokalizacji zapasÃ³w nie znaleziono',0),(59442,1652,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(59443,1652,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ù‚Ø§Ù… Ù†ÛÙŠÚº Ù…Ù„Ø§',0),(59444,1652,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(59445,1652,'vi','Äá»‹a Äiá»ƒm Äá»ƒ HÃ ng KhÃ´ng TÃ¬m Tháº¥y',0),(59446,1652,'af','Inventaris Ligging nie gevind',0),(59447,1652,'ro','Inventarul locaÅ£ia nu a fost gÄƒsit',0),(59448,1652,'et','Lao asukohta ei leitud',0),(59449,1652,'si','Lokacijo zaloge, ni mogoÄe najti',0),(59450,1652,'ba','Persediaan lokasi tidak ditemukan',0),(59451,1652,'nl','Voorraadvestiging niet gevonden',0),(59452,1652,'fi','Varaston sijaintia ei lÃ¶ydy',0),(59453,1652,'no','Lagerlokasjonen ikke funnet',0),(59454,1652,'da','Lagerlokation ikke fundet',0),(59455,1652,'ko','ìž¬ê³  ìœ„ì¹˜ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(59456,1652,'he','×ž×™×§×•× ×”×ž×œ××™ ×œ× × ×ž×¦×',0),(59457,1652,'el','Î‘Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(59458,1652,'zh','åº“å­˜æœªæ‰¾åˆ°ä½ç½®\r\n',0),(59459,1652,'sv','LagerstÃ¤lle som hittades inte',0),(59460,1652,'it','Ubicazione di inventario non trovato',0),(59461,1652,'tl','',0),(59462,1652,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59463,1652,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(59464,1652,'ms','Lokasi inventori yang tidak dijumpai',0),(59465,1652,'ar','Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(59466,1652,'fr','Emplacement de l\'inventaire introuvable',0),(59467,1652,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(59468,1652,'pt','LocalizaÃ§Ã£o de inventÃ¡rio nÃ£o encontrada',0),(59469,1652,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(59470,1652,'es','UbicaciÃ³n de Inventario no se incontrÃ³',0),(59471,1652,'de','Lagerort nicht gefunden',0),(59472,1652,'en','Inventory Location not found',0),(59473,1653,'is','',0),(59474,1653,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(59475,1653,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(59476,1653,'tr','Stok konumunu gÃ¼ncelleÅŸtirme',0),(59477,1653,'pl','Aktualizacja lokalizacji zapasÃ³w',0),(59478,1653,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(59479,1653,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…ÛŒÚº ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(59480,1653,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59481,1653,'vi','Cáº­p Nháº­t Äá»‹a Äiá»ƒm Äá»ƒ HÃ ng',0),(59482,1653,'af','Inventaris Item Ligging Opdateer',0),(59483,1653,'ro','Actualizarea de locaÅ£ie inventarului',0),(59484,1653,'et','Lao asukoha uuendamine',0),(59485,1653,'si','Seznam mesto posodobitev',0),(59486,1653,'ba','Inventaris lokasi Update',0),(59487,1653,'nl','Inventaris locatie Update',0),(59488,1653,'fi','Varaston sijainnin pÃ¤ivitys',0),(59489,1653,'no','Lageroppdateringen plassering',0),(59490,1653,'da','Lageropdateringen placering',0),(59491,1653,'ko','ìž¬ê³  ìœ„ì¹˜ ì—…ë°ì´íŠ¸',0),(59492,1653,'he','×¢×“×›×•×Ÿ ×ž×™×§×•× ×”×ž×œ××™',0),(59493,1653,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Ï„Î¿Ï€Î¿Î¸ÎµÏ„ÏŽ ÎµÎºÏƒÏ…Î³Ï‡ÏÎ¿Î½Î¯Î¶Ï‰',0),(59494,1653,'zh','åº“å­˜ä½ç½®æ›´æ–°\r\n',0),(59495,1653,'sv','Lageruppdateringen lÃ¤ge',0),(59496,1653,'it','Aggiornamento di posizione di inventario',0),(59497,1653,'tl','',0),(59498,1653,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59499,1653,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(59500,1653,'ms','Kemaskini lokasi inventori',0),(59501,1653,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹',0),(59502,1653,'fr','Mise Ã  jour de l\'inventaire emplacement',0),(59503,1653,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®æ›´æ–°',0),(59504,1653,'pt','AtualizaÃ§Ã£o de localizaÃ§Ã£o de inventÃ¡rio',0),(59505,1653,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ ÑÐºÐ»Ð°Ð´Ð°',0),(59506,1653,'es','UbicaciÃ³n de Inventario Actualizar',0),(59507,1653,'de','Lage Lageraktualisierung',0),(59508,1653,'en','Inventory Location Update',0),(59509,1654,'is','',0),(59510,1654,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(59511,1654,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(59512,1654,'tr','Stok konumu baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(59513,1654,'pl','Lokalizacji zapasÃ³w pomyÅ›lnie zaktualizowana',0),(59514,1654,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(59515,1654,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(59516,1654,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(59517,1654,'vi','Cáº­p Nháº­t Äá»‹a Äiá»ƒm Äá»ƒ HÃ ng thÃ nh cÃ´ng',0),(59518,1654,'af','Voorraaditem Ligging suksesvol Opdateer',0),(59519,1654,'ro','LocaÅ£ie de inventar actualizat cu succes',0),(59520,1654,'et','Lao asukoha vÃ¤rskendatud',0),(59521,1654,'si','Lokacijo zaloge, uspeÅ¡no posodobljena',0),(59522,1654,'ba','Lokasi persediaan yang berhasil',0),(59523,1654,'nl','Voorraadvestiging bijgewerkt',0),(59524,1654,'fi','Varastosijainnin pÃ¤ivitetty',0),(59525,1654,'no','Lagerlokasjon oppdatert',0),(59526,1654,'da','Lagerlokation opdateret',0),(59527,1654,'ko','ìž¬ê³  ìœ„ì¹˜ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(59528,1654,'he','×ž×™×§×•× ×”×ž×œ××™ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(59529,1654,'el','Î‘Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(59530,1654,'zh','åº“å­˜ä½ç½®æ›´æ–°æˆåŠŸ\r\n',0),(59531,1654,'sv','LagerstÃ¤lle som uppdaterats',0),(59532,1654,'it','Ubicazione di inventario aggiornato con successo',0),(59533,1654,'tl','',0),(59534,1654,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(59535,1654,'hi','à¤¸à¥‚à¤šà¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥à¤¥à¤¾à¤¨',0),(59536,1654,'ms','Lokasi inventori dikemaskini berjaya',0),(59537,1654,'ar','Ø­Ø¯Ù‘Ø« Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¨Ù†Ø¬Ø§Ø­',0),(59538,1654,'fr','Emplacement de l\'inventaire mis Ã  jour avec succÃ¨s',0),(59539,1654,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(59540,1654,'pt','LocalizaÃ§Ã£o de inventÃ¡rio atualizada com sucesso',0),(59541,1654,'ru','Ð¡ÐºÐ»Ð°Ð´Ðµ, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(59542,1654,'es','UbicaciÃ³n de Inventario actualizada exitosamente',0),(59543,1654,'de','Lagerort, die erfolgreich aktualisiert',0),(59544,1654,'en','Inventory Location updated successfully',0),(59545,1655,'is','',0),(59546,1655,'dr','Ø²ÙŠØ§Ù† Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59547,1655,'pr','Ø²ÙŠØ§Ù† Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59548,1655,'tr','Stok zararÄ±',0),(59549,1655,'pl','Strat zapasÃ³w',0),(59550,1655,'bg','Ð—Ð°Ð³ÑƒÐ±Ð°Ñ‚Ð° Ð² ÑÐºÐ»Ð°Ð´Ð°',0),(59551,1655,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…ÛŒÚº Ú©Ù…ÛŒ',0),(59552,1655,'sr','Ð“ÑƒÐ±Ð¸Ñ‚Ð°Ðº Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59553,1655,'vi','Máº¥t HÃ ng',0),(59554,1655,'af','Voorraad Verlies',0),(59555,1655,'ro','Pierderea de inventar',0),(59556,1655,'et','Varude kaotus',0),(59557,1655,'si','ZmanjÅ¡anja zaloge',0),(59558,1655,'ba','Kehilangan persediaan',0),(59559,1655,'nl','Inventaris verlies',0),(59560,1655,'fi','Varastotappio',0),(59561,1655,'no','Lager tap',0),(59562,1655,'da','Beholdning tab',0),(59563,1655,'ko','ìž¬ê³  ì†ì‹¤',0),(59564,1655,'he','×ž×œ××™ ××•×‘×“×Ÿ',0),(59565,1655,'el','Î‘Ï€ÏŽÎ»ÎµÎ¹ÎµÏ‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(59566,1655,'zh','å­˜è´§æŸå¤±\r\n',0),(59567,1655,'sv','Inventering fÃ¶rlust',0),(59568,1655,'it','Perdita di inventario',0),(59569,1655,'tl','',0),(59570,1655,'th','&#3588;&#3623;&#3634;&#3617;&#3626;&#3641;&#3597;&#3648;&#3626;&#3637;&#3618;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59571,1655,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¹à¤¾à¤¨à¤¿',0),(59572,1655,'ms','Kehilangan inventori',0),(59573,1655,'ar','Ø§Ù„Ø®Ø³Ø§Ø¦Ø± ÙÙŠ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(59574,1655,'fr','Perte de l\'inventaire',0),(59575,1655,'jp','æ£šå?¸æ??',0),(59576,1655,'pt','Perda de inventÃ¡rio',0),(59577,1655,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿Ð¾Ñ‚ÐµÑ€Ð¸',0),(59578,1655,'es','PÃ©rdida de Inventario',0),(59579,1655,'de','Inventar-Verlust',0),(59580,1655,'en','Inventory Loss',0),(59581,1656,'is','',0),(59582,1656,'dr','Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§\r\n Picklist',0),(59583,1656,'pr','Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§\r\n Picklist',0),(59584,1656,'tr','Stok seÃ§im listesi',0),(59585,1656,'pl','Lista inwentaryzacji',0),(59586,1656,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð¿Ð°Ð´Ð°Ñ‰Ð¾ Ð¼ÐµÐ½ÑŽ',0),(59587,1656,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù¾Ø§Ú©Ù„Ø§Ø³Ù¹',0),(59588,1656,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¸Ð·Ð±Ð¾Ñ€Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59589,1656,'vi','Danh SÃ¡ch Chá»n HÃ ng',0),(59590,1656,'af','Voorraad Picklist',0),(59591,1656,'ro','Stoc listÄƒ verticalÄƒ',0),(59592,1656,'et','Varude mÃ¤rkeloendi',0),(59593,1656,'si','Seznam aktualnih podatkov popisa',0),(59594,1656,'ba','Picklist persediaan',0),(59595,1656,'nl','Inventaris selectielijst',0),(59596,1656,'fi','Varaston valintaluettelon',0),(59597,1656,'no','Lager valglisten',0),(59598,1656,'da','Lageret valgliste',0),(59599,1656,'ko','ìž¬ê³  ì„ íƒ ëª©ë¡',0),(59600,1656,'he','×¨×©×™×ž×ª ×ž×œ××™',0),(59601,1656,'el','Î›Î¯ÏƒÏ„Î± ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(59602,1656,'zh','åº“å­˜é€‰å–åˆ—è¡¨\r\n',0),(59603,1656,'sv','Lager plocklista',0),(59604,1656,'it','Inventario dell\'elenco a discesa',0),(59605,1656,'tl','',0),(59606,1656,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59607,1656,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤šà¤¯à¤¨à¤¸à¥‚à¤šà¥€',0),(59608,1656,'ms','Picklist inventori',0),(59609,1656,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¬Ø±Ø¯',0),(59610,1656,'fr','L\'inventaire liste de choix',0),(59611,1656,'jp','Inventory Picklist',0),(59612,1656,'pt','InventÃ¡rio lista de seleÃ§Ã£o',0),(59613,1656,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿Ð¾Ð»Ñ Ð²Ñ‹Ð±Ð¾Ñ€Ð°',0),(59614,1656,'es','Inventario Lista de SelecciÃ³n',0),(59615,1656,'de','Inventar-Auswahlliste',0),(59616,1656,'en','Inventory Pick List',0),(59617,1657,'is','',0),(59618,1657,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59619,1657,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59620,1657,'tr','Stok bitki konumunu gÃ¼ncelleÅŸtirme',0),(59621,1657,'pl','Spis roÅ›lin lokalizacji aktualizacji',0),(59622,1657,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ° Ñ€Ð°ÑÑ‚ÐµÐ½Ð¸Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(59623,1657,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù¾Ù„Ø§Ù†Ù¹ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(59624,1657,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð±Ð¸Ñ™ÐºÑƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59625,1657,'vi','Cáº­p Nháº­t Vá»‹ TrÃ­ Sáº£n Xuáº¥t HÃ ng',0),(59626,1657,'af','Voorraaditem Aanleg Ligging Opdateer',0),(59627,1657,'ro','Actualizarea inventarului plantÄƒ locaÅ£ia',0),(59628,1657,'et','Tehase asukoht vÃ¤rskendus',0),(59629,1657,'si','Popis rastlin Location Update',0),(59630,1657,'ba','Inventaris tanaman lokasi Update',0),(59631,1657,'nl','Inventaris Plant locatie Update',0),(59632,1657,'fi','VarastopÃ¤ivitys kasvi sijainti',0),(59633,1657,'no','Lageroppdateringen anlegget plassering',0),(59634,1657,'da','Lageropdateringen plante placering',0),(59635,1657,'ko','ìž¬ê³  ê³µìž¥ ìœ„ì¹˜ ì—…ë°ì´íŠ¸',0),(59636,1657,'he','×¢×“×›×•×Ÿ ×ž×™×§×•× ×”×ž×¤×¢×œ ×”×ž×œ××™',0),(59637,1657,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ ÎºÎ±Ï„Î±Î»ÏŒÎ³Ï‰Î½ ÎµÏÎ³Î¿ÏƒÏ„Î¬ÏƒÎ¹Î¿ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(59638,1657,'zh','åº“å­˜åŽ‚æˆ¿ä½ç½®æ›´æ–°\r\n',0),(59639,1657,'sv','Lageruppdateringen Plant lÃ¤ge',0),(59640,1657,'it','Inventario pianta posizione aggiornamento',0),(59641,1657,'tl','',0),(59642,1657,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59643,1657,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¤‚à¤¯à¤‚à¤¤à¥à¤° à¤¸à¥à¤¥à¤¾à¤¨ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(59644,1657,'ms','Kemaskini lokasi inventori loji',0),(59645,1657,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(59646,1657,'fr','Mise Ã  jour de l\'inventaire plante emplacement',0),(59647,1657,'jp','Inventory Plant Location Update',0),(59648,1657,'pt','AtualizaÃ§Ã£o de localizaÃ§Ã£o de planta de inventÃ¡rio',0),(59649,1657,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ ÑÐºÐ»Ð°Ð´Ð° Ð·Ð°Ð²Ð¾Ð´',0),(59650,1657,'es','UbicaciÃ³n de Planta de Inventario Actualizada',0),(59651,1657,'de','Werk Lage Lageraktualisierung',0),(59652,1657,'en','Inventory Plant Location Update',0),(59653,1658,'is','',0),(59654,1658,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59655,1658,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59656,1658,'tr','PO stok listesi',0),(59657,1658,'pl','Lista inwentaryzacji PO',0),(59658,1658,'bg','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿Ð¾ ÑÐ¿Ð¸ÑÑŠÐº',0),(59659,1658,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù¾Ùˆ ÙÛØ±Ø³Øª',0),(59660,1658,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° ÐŸÐž',0),(59661,1658,'vi','Danh SÃ¡ch ÄÆ¡n Mua HÃ ng ',0),(59662,1658,'af','Voorraad AB Lys',0),(59663,1658,'ro','Lista de inventar PO',0),(59664,1658,'et','Varude PO loend',0),(59665,1658,'si','Seznam zaloge PO',0),(59666,1658,'ba','Daftar inventaris PO',0),(59667,1658,'nl','Inventarislijst PO',0),(59668,1658,'fi','PO-Inventaarioluettelo',0),(59669,1658,'no','Inventarliste PO',0),(59670,1658,'da','Lagerliste PO',0),(59671,1658,'ko','ìž¬ê³  í¬ ëª©ë¡',0),(59672,1658,'he','×¨×©×™×ž×ª ×ž×œ××™ ×¤×•',0),(59673,1658,'el','Î›Î¯ÏƒÏ„Î± Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ PO',0),(59674,1658,'zh','åº“å­˜è®¢å•åˆ—è¡¨\r\n',0),(59675,1658,'sv','Inventarielista PO',0),(59676,1658,'it','Lista inventario PO',0),(59677,1658,'tl','',0),(59678,1658,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59679,1658,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤ªà¥‹ à¤¸à¥‚à¤šà¥€',0),(59680,1658,'ms','Senarai inventori PO',0),(59681,1658,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ø±Ø¯ Ø¨Ùˆ',0),(59682,1658,'fr','Liste d\'inventaire PO',0),(59683,1658,'jp','ç™ºæ³¨æ›¸ãƒªã‚¹ãƒˆ',0),(59684,1658,'pt','Lista de inventÃ¡rio PO',0),(59685,1658,'ru','ÐžÐ¿Ð¸ÑÑŒ PO',0),(59686,1658,'es','Lista OC de Inventario ',0),(59687,1658,'de','Inventarliste PO',0),(59688,1658,'en','Inventory PO List',0),(59689,1659,'is','',0),(59690,1659,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59691,1659,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59692,1659,'tr','PO #',0),(59693,1659,'pl','PO #',0),(59694,1659,'bg','ÐŸÐŸ #',0),(59695,1659,'ur','Ù¾Ùˆ #',0),(59696,1659,'sr','ÐŸÐž #',0),(59697,1659,'vi','ÄÆ¡n Mua HÃ ng Sá»‘ ',0),(59698,1659,'af','AB#',0),(59699,1659,'ro','PO #',0),(59700,1659,'et','PO #',0),(59701,1659,'si','Å TEVILKA NAROÄŒILNICE',0),(59702,1659,'ba','PO #',0),(59703,1659,'nl','PO #',0),(59704,1659,'fi','OSTOTILAUKSEN NUMERO',0),(59705,1659,'no','BESTILLINGSNUMMERET',0),(59706,1659,'da','PO #',0),(59707,1659,'ko','PO #',0),(59708,1659,'he','×ž×¡×¤×¨ ×ª× ×“×•××¨',0),(59709,1659,'el','# Î Î‘Î¡Î‘Î“Î“',0),(59710,1659,'zh','è®¢å•ï¼ƒ\r\n',0),(59711,1659,'sv','PO #',0),(59712,1659,'it','PO #',0),(59713,1659,'tl','',0),(59714,1659,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59715,1659,'hi','à¤ªà¥€à¤“ #',0),(59716,1659,'ms','PO #',0),(59717,1659,'ar','Øµ. Ø¨ #',0),(59718,1659,'fr','NÂ° BC',0),(59719,1659,'jp','POç•ªå?·',0),(59720,1659,'pt','PO #',0),(59721,1659,'ru','PO #',0),(59722,1659,'es','OC#',0),(59723,1659,'de','PO-',0),(59724,1659,'en','PO#',0),(59725,1660,'is','',0),(59726,1660,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(59727,1660,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(59728,1660,'tr','Stok PO numarasÄ± bulunamadÄ±.',0),(59729,1660,'pl','Numer zamÃ³wienia zapasÃ³w nie znaleziono.',0),(59730,1660,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð¿Ð¾ Ð±Ñ€Ð¾Ð¹ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(59731,1660,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(59732,1660,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐÐ°Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(59733,1660,'vi','KhÃ´ng TÃ¬m Tháº¥y Sá»‘ ÄÆ¡n Mua HÃ ng',0),(59734,1660,'af','Voorraad AB Nommer nie gevind.',0),(59735,1660,'ro','Inventarul PO numÄƒrul nu a fost gÄƒsit.',0),(59736,1660,'et','Varude PO numbrit ei leitud.',0),(59737,1660,'si','Å tevilka NaroÄilnice zaloge, ni mogoÄe najti.',0),(59738,1660,'ba','Persediaan nomor PO tidak ditemukan.',0),(59739,1660,'nl','PO inventarisnummer niet gevonden.',0),(59740,1660,'fi','Varaston PO numeroa ei lÃ¶ytynyt.',0),(59741,1660,'no','Lager innkjÃ¸psordrenummer ikke funnet.',0),(59742,1660,'da','Lageret PO-nummer ikke fundet.',0),(59743,1660,'ko','ìž¬ê³  PO ë²ˆí˜¸ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(59744,1660,'he','×ž×¡×¤×¨ ×”-PO ×”×ž×œ××™ ×œ× × ×ž×¦×.',0),(59745,1660,'el','PO Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(59746,1660,'zh','åº“å­˜è®¢å•å·ç æ²¡æœ‰æ‰¾åˆ°ã€‚\r\n',0),(59747,1660,'sv','PO inventarienummer hittades inte.',0),(59748,1660,'it','Numero di inventario PO non trovato.',0),(59749,1660,'tl','',0),(59750,1660,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59751,1660,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤ªà¥‹ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€à¥¤',0),(59752,1660,'ms','Inventori PO nombor tidak dijumpai.',0),(59753,1660,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ \"Ø±Ù‚Ù… Ø¨Ùˆ\" Ø§Ù„Ù…Ø®Ø²ÙˆÙ†.',0),(59754,1660,'fr','NumÃ©ro d\'inventaire PO introuvable.',0),(59755,1660,'jp','ç™ºæ³¨æ›¸ç•ªå?·ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(59756,1660,'pt','NÃºmero de inventÃ¡rio PO nÃ£o encontrado.',0),(59757,1660,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ PO Ð½Ð¾Ð¼ÐµÑ€ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(59758,1660,'es','OC NÃºmero de Inventario no se encontrÃ³',0),(59759,1660,'de','Inventarnummer PO nicht gefunden.',0),(59760,1660,'en','Inventory PO Number not found.',0),(59761,1661,'is','',0),(59762,1661,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ù‡ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù‡Ø§ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯ ',0),(59763,1661,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ù‡ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù‡Ø§ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯ ',0),(59764,1661,'tr','BorÃ§lar geÃ§iÅŸine PO',0),(59765,1661,'pl','PO przepustkÄ™ do zobowiÄ…zaÅ„',0),(59766,1661,'bg','PO Ð¿Ñ€Ð¾Ð¿ÑƒÑÐº Ð·Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(59767,1661,'ur','Ù¾Ùˆ Ú©Û’ Ù¾Ø§Ø³ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Û’ Ù„ÛŒÛ’',0),(59768,1661,'sr','ÐŸÐž Ð¿Ñ€Ð¾Ð¿ÑƒÑÐ½Ð¸Ñ†Ð° Ð·Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(59769,1661,'vi','ÄÆ¡n Mua HÃ ng Chuyá»ƒn Sang Pháº£i Tráº£',0),(59770,1661,'af','PO Pass na Waardedalingstoetse',0),(59771,1661,'ro','PO trece la datorii',0),(59772,1661,'et','PO edastamine tarnijatele',0),(59773,1661,'si','PO Pass za obveznosti',0),(59774,1661,'ba','PO Pass untuk hutang',0),(59775,1661,'nl','PO doorgeven aan schulden',0),(59776,1661,'fi','PO siirtyy Ostovelat',0),(59777,1661,'no','PO Pass til leverandÃ¸rgjeld',0),(59778,1661,'da','PO Pass til gÃ¦ld',0),(59779,1661,'ko','ë¯¸ì§€ê¸‰ê¸ˆì„ í¬ íŒ¨ìŠ¤',0),(59780,1661,'he','×¤×• ×ž×¢×‘×¨ ×œ×–×›××™×',0),(59781,1661,'el','PO Î½Î± Ï€ÎµÏÎ¬ÏƒÎµÎ¹ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(59782,1661,'zh','è®¢å•è½¬è‡³åº”ä»˜è´¦æ¬¾\r\n',0),(59783,1661,'sv','PO Pass till leverantÃ¶rsskulder',0),(59784,1661,'it','Pass PO ai debiti',0),(59785,1661,'tl','',0),(59786,1661,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3611;&#3618;&#3633;&#3591;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(59787,1661,'hi','PO Payables à¤•à¥‡ à¤ªà¤¾à¤¸',0),(59788,1661,'ms','PO Pas untuk pemiutang',0),(59789,1661,'ar','Øµ. Ø¨ ØªÙ…Ø±ÙŠØ± Ù„Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(59790,1661,'fr','PO Pass aux crÃ©diteurs',0),(59791,1661,'jp','POã‚’è²·æŽ›é‡‘ã?«ç§»å‹•',0),(59792,1661,'pt','Passe PO para contas a pagar',0),(59793,1661,'ru','PO Ð¿ÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(59794,1661,'es','OC Pasa a Cuentas por Pagar',0),(59795,1661,'de','PO-Pass zu Verbindlichkeiten',0),(59796,1661,'en','PO Pass to Payables',0),(59797,1662,'is','',0),(59798,1662,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(59799,1662,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(59800,1662,'tr','PO baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(59801,1662,'pl','PO pomyÅ›lnie zaktualizowana',0),(59802,1662,'bg','PO Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(59803,1662,'ur','Ù¾Ùˆ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(59804,1662,'sr','ÐŸÐž ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(59805,1662,'vi','Cáº­p Nháº­t ÄÆ¡n Mua HÃ ng ThÃ nh CÃ´ng ',0),(59806,1662,'af','AB suksesvol Opdateer',0),(59807,1662,'ro','PO actualizat cu succes',0),(59808,1662,'et','VÃ¤rskendatud PO',0),(59809,1662,'si','PO uspeÅ¡no posodobljena',0),(59810,1662,'ba','PO berhasil',0),(59811,1662,'nl','PO bijgewerkt',0),(59812,1662,'fi','PÃ¤ivitetty PO',0),(59813,1662,'no','PO oppdatert',0),(59814,1662,'da','PO opdateret',0),(59815,1662,'ko','ê°€ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(59816,1662,'he','×¤×• ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(59817,1662,'el','PO ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(59818,1662,'zh','è®¢å•æˆåŠŸæ›´æ–°\r\n',0),(59819,1662,'sv','PO uppdaterats',0),(59820,1662,'it','PO aggiornato con successo',0),(59821,1662,'tl','',0),(59822,1662,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3626;&#3635;&#3648;&#3619;&#3655;&#3',0),(59823,1662,'hi','PO à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(59824,1662,'ms','PO berjaya dikemas kini',0),(59825,1662,'ar','Øµ. Ø¨ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(59826,1662,'fr','PO mis Ã  jour avec succÃ¨s',0),(59827,1662,'jp','POã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(59828,1662,'pt','PO atualizado com sucesso',0),(59829,1662,'ru','PO, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(59830,1662,'es','OC actualizado exitosamente',0),(59831,1662,'de','PO erfolgreich aktualisiert',0),(59832,1662,'en','PO updated successfully',0),(59833,1663,'is','',0),(59834,1663,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59835,1663,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59836,1663,'tr','Stok standart GL hesaplarÄ±',0),(59837,1663,'pl','Magazynu kont standardowych GL',0),(59838,1663,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ Ð¿Ð¾ ÑÐºÐ»Ð°Ð´Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ GL',0),(59839,1663,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(59840,1663,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð“Ð› ÐºÐ¾Ð½Ñ‚Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59841,1663,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Chuáº©n HÃ ng Tá»“n Kho',0),(59842,1663,'af','Voorraad Standaard AG Rekening',0),(59843,1663,'ro','Inventarul Standard GL conturi',0),(59844,1663,'et','Varude Standard GL kontod',0),(59845,1663,'si','Konti zaloge Standard GL',0),(59846,1663,'ba','Persediaan GL standar account',0),(59847,1663,'nl','Standaard GL voorraadrekeningen',0),(59848,1663,'fi','Standard GL varastotilit',0),(59849,1663,'no','Standard GL lagerkontiene',0),(59850,1663,'da','Lagerkonti Standard GL',0),(59851,1663,'ko','ìž¬ê³  í‘œì¤€ GL ê³„ì •',0),(59852,1663,'he','×ž×œ××™ GL ×¡×˜× ×“×¨×˜×™ ×—×©×‘×•× ×•×ª',0),(59853,1663,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Ï€ÏÏŒÏ„Ï…Ï€Î¿ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(59854,1663,'zh','åº“å­˜æ ‡å‡†æ€»å¸å¸æˆ·\r\n',0),(59855,1663,'sv','Standard GL lagerkontona',0),(59856,1663,'it','Inventario Standard GL conti',0),(59857,1663,'tl','',0),(59858,1663,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(59859,1663,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‹à¤‚',0),(59860,1663,'ms','Akaun Standard GL inventori',0),(59861,1663,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ù„Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(59862,1663,'fr','Comptes de stock Standard GL',0),(59863,1663,'jp','åœ¨åº«æ¨™æº–GLã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(59864,1663,'pt','Contas de inventÃ¡rio padrÃ£o GL',0),(59865,1663,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð² ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ GL',0),(59866,1663,'es','Inventario Cuentas de LM EstÃ¡ndares',0),(59867,1663,'de','Standard GL Lagerkonten',0),(59868,1663,'en','Inventory Standard GL Accounts',0),(59869,1664,'is','',0),(59870,1664,'dr','Ø¢Ù…Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59871,1664,'pr','Ø¢Ù…Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59872,1664,'tr','Stok istatistikleri',0),(59873,1664,'pl','Statystyki zapasÃ³w',0),(59874,1664,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(59875,1664,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ÙˆØ´Ù…Ø§Ø±',0),(59876,1664,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59877,1664,'vi','Thá»‘ng KÃª HÃ ng HÃ³a',0),(59878,1664,'af','Voorraad Stats',0),(59879,1664,'ro','Inventarul statistici',0),(59880,1664,'et','Varude statistika',0),(59881,1664,'si','Statistika zaloge',0),(59882,1664,'ba','Persediaan Statistik',0),(59883,1664,'nl','Inventaris Stats',0),(59884,1664,'fi','Varaston tilastot',0),(59885,1664,'no','Lager statistikk',0),(59886,1664,'da','Lageret statistik',0),(59887,1664,'ko','ìž¬ê³  í†µê³„',0),(59888,1664,'he','×ž×œ××™ ×¡×˜×˜×™×¡×˜×™×§×”',0),(59889,1664,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î·Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(59890,1664,'zh','åº“å­˜ç»Ÿè®¡\r\n',0),(59891,1664,'sv','Inventering statistik',0),(59892,1664,'it','Statistiche di magazzino',0),(59893,1664,'tl','',0),(59894,1664,'th','&#3626;&#3616;&#3634;&#3614;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59895,1664,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤†à¤à¤•à¤¡à¤¼à¥‡',0),(59896,1664,'ms','Statistik inventori',0),(59897,1664,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(59898,1664,'fr','Stats de l\'inventaire',0),(59899,1664,'jp','åœ¨åº«çŠ¶æ³?',0),(59900,1664,'pt','EstatÃ­sticas de inventÃ¡rio',0),(59901,1664,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(59902,1664,'es','EstadÃ­sticas de Inventario',0),(59903,1664,'de','Inventar-Statistik',0),(59904,1664,'en','Inventory Stats',0),(59905,1665,'is','',0),(59906,1665,'dr','Ù„ÙŠØ³Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ ',0),(59907,1665,'pr','Ù„ÙŠØ³Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ ',0),(59908,1665,'tr','Stok hareket listesi iÃ§in',0),(59909,1665,'pl','Lista transakcji magazynowych',0),(59910,1665,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð·Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸ Ð·Ð°',0),(59911,1665,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’',0),(59912,1665,'sr','Ð›Ð¸ÑÑ‚Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð·Ð°',0),(59913,1665,'vi','Danh SÃ¡ch Chuyá»ƒn NhÆ°á»£ng hÃ ng hÃ³a cho',0),(59914,1665,'af','Inventaris Transaksielys vir',0),(59915,1665,'ro','Lista inventar tranzacÅ£ie',0),(59916,1665,'et','Kaubavaru kannete loendi jaoks',0),(59917,1665,'si','Inventurni seznam transakcij za',0),(59918,1665,'ba','Daftar transaksi inventaris untuk',0),(59919,1665,'nl','Inventarislijst van de transactie voor',0),(59920,1665,'fi','Varaston Tapahtumaluettelo',0),(59921,1665,'no','Lager transaksjonslisten for',0),(59922,1665,'da','Lageret transaktionslisten for',0),(59923,1665,'ko','ìž¬ê³  íŠ¸ëžœìž­ì…˜ ëª©ë¡',0),(59924,1665,'he','×ž×œ××™ ×¨×©×™×ž×ª ×”×˜×¨× ×–×§×¦×™×•×ª ×¢×‘×•×¨',0),(59925,1665,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎºÎ¹Î½Î®ÏƒÎµÏ‰Î½ Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î³Î¹Î±',0),(59926,1665,'zh','åº“å­˜äº¤æ˜“ç›®å½•\r\n',0),(59927,1665,'sv','Inventering Transaktionslista fÃ¶r',0),(59928,1665,'it','Elenco delle transazioni di inventario per',0),(59929,1665,'tl','',0),(59930,1665,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629; ',0),(59931,1665,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(59932,1665,'ms','Inventori senarai transaksi',0),(59933,1665,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø±ÙƒØ§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(59934,1665,'fr','Liste de transactions de l\'inventaire pour',0),(59935,1665,'jp','åœ¨åº«å‡¦ç?†ãƒªã‚¹ãƒˆ',0),(59936,1665,'pt','Lista de transaÃ§Ãµes de inventÃ¡rio para',0),(59937,1665,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ ÑÐ¿Ð¸ÑÐ¾Ðº Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ Ð´Ð»Ñ',0),(59938,1665,'es','Lista de Transacciones de Inventario para',0),(59939,1665,'de','Transaktion Inventarliste fÃ¼r',0),(59940,1665,'en','Inventory Transaction List for',0),(59941,1666,'is','',0),(59942,1666,'dr','Ù†ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59943,1666,'pr','Ù†ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59944,1666,'tr','Stok tipi',0),(59945,1666,'pl','Typ magazynu',0),(59946,1666,'bg','Ð¡ÐºÐ»Ð°Ð´ Ñ‚Ð¸Ð¿',0),(59947,1666,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(59948,1666,'sr','Ð’Ñ€ÑÑ‚Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59949,1666,'vi','Loáº¡i HÃ ng HÃ³a',0),(59950,1666,'af','Voorraad Tipe',0),(59951,1666,'ro','Tipul de inventar',0),(59952,1666,'et','Lao tÃ¼Ã¼p',0),(59953,1666,'si','Vrsta zaloge',0),(59954,1666,'ba','Jenis persediaan',0),(59955,1666,'nl','Inventaris Type',0),(59956,1666,'fi','Varaston tyyppi',0),(59957,1666,'no','Lager Type',0),(59958,1666,'da','Lageret Type',0),(59959,1666,'ko','ì¸ë²¤í† ë¦¬ ìœ í˜•',0),(59960,1666,'he','×¡×•×’ ×ž×œ××™',0),(59961,1666,'el','Î•Î¯Î´Î¿Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(59962,1666,'zh','åº“å­˜ç±»åž‹\r\n',0),(59963,1666,'sv','Inventering typ',0),(59964,1666,'it','Tipo di inventario',0),(59965,1666,'tl','',0),(59966,1666,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(59967,1666,'hi','à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(59968,1666,'ms','Jenis inventori',0),(59969,1666,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(59970,1666,'fr','Inventaire Type',0),(59971,1666,'jp','åœ¨åº«ã‚¿ã‚¤ãƒ—',0),(59972,1666,'pt','Tipo de inventÃ¡rio',0),(59973,1666,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ‚Ð¸Ð¿',0),(59974,1666,'es','Tio de Inventario',0),(59975,1666,'de','Lagertyp',0),(59976,1666,'en','Inventory Type',0),(59977,1667,'is','',0),(59978,1667,'dr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59979,1667,'pr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(59980,1667,'tr','Stok birimi adÄ±',0),(59981,1667,'pl','Nazwa jednostki zapasÃ³w',0),(59982,1667,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(59983,1667,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ù†Ø§Ù…',0),(59984,1667,'sr','Ð˜Ð¼Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(59985,1667,'vi','TÃªn ÄÆ¡n Vá»‹ HÃ ng HÃ³a',0),(59986,1667,'af','Inventaris Eenheidsnaam',0),(59987,1667,'ro','Nume de unitatea de inventar',0),(59988,1667,'et','Varude Ã¼hiku nimi',0),(59989,1667,'si','Inventar ime enote',0),(59990,1667,'ba','Nama Unit persediaan',0),(59991,1667,'nl','De naam van de eenheid van de inventaris',0),(59992,1667,'fi','Varaston yksikÃ¶n nimi',0),(59993,1667,'no','Navn pÃ¥ lager',0),(59994,1667,'da','Lager enhed navn',0),(59995,1667,'ko','ìž¬ê³  ë‹¨ìœ„ ì´ë¦„',0),(59996,1667,'he','×‘×©× ×™×—×™×“×ª ×ž×œ××™',0),(59997,1667,'el','ÎŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î±Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(59998,1667,'zh','åº“å­˜å•ä½åç§°\r\n',0),(59999,1667,'sv','Lager enhet namn',0),(60000,1667,'it','Nome di unitÃ  di inventario',0),(60001,1667,'tl','',0),(60002,1667,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(60003,1667,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤¨à¤¾à¤®',0),(60004,1667,'ms','Nama Unit inventori',0),(60005,1667,'ar','Ø§Ø³Ù… ÙˆØ­Ø¯Ø© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(60006,1667,'fr','Nom de l\'unitÃ© de l\'inventaire',0),(60007,1667,'jp','æ£šå?¸å?˜ä½?å??',0),(60008,1667,'pt','Nome da unidade de inventÃ¡rio',0),(60009,1667,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(60010,1667,'es','Nombre de Unidad de Inventario',0),(60011,1667,'de','Inventar-GerÃ¤tename',0),(60012,1667,'en','Inventory Unit Name',0),(60013,1668,'is','',0),(60014,1668,'dr','ÙØ§ÙƒØªÙˆØ±',0),(60015,1668,'pr','ÙØ§ÙƒØªÙˆØ±',0),(60016,1668,'tr','Fatura',0),(60017,1668,'pl','Faktury',0),(60018,1668,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60019,1668,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³',0),(60020,1668,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(60021,1668,'vi','HÃ³a Ä‘Æ¡n',0),(60022,1668,'af','Faktuur',0),(60023,1668,'ro','Factura',0),(60024,1668,'et','Arve nr.',0),(60025,1668,'si','RaÄuna',0),(60026,1668,'ba','Faktur',0),(60027,1668,'nl','Factuur',0),(60028,1668,'fi','Laskun',0),(60029,1668,'no','Faktura',0),(60030,1668,'da','Faktura',0),(60031,1668,'ko','ì†¡ìž¥',0),(60032,1668,'he','×—×©×‘×•× ×™×ª',0),(60033,1668,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(60034,1668,'zh','å‘ç¥¨\r\n',0),(60035,1668,'sv','Faktura',0),(60036,1668,'it','Fattura',0),(60037,1668,'tl','',0),(60038,1668,'th','&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;',0),(60039,1668,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸',0),(60040,1668,'ms','Invois',0),(60041,1668,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(60042,1668,'fr','Facture',0),(60043,1668,'jp','è«‹æ±‚æ›¸',0),(60044,1668,'pt','Fatura',0),(60045,1668,'ru','Ð¡Ñ‡ÐµÑ‚',0),(60046,1668,'es','Factura',0),(60047,1668,'de','Rechnung',0),(60048,1668,'en','Invoice',0),(60049,1669,'is','',0),(60050,1669,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ± ',0),(60051,1669,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ± ',0),(60052,1669,'tr','Fatura Ekle',0),(60053,1669,'pl','Dodawanie faktury',0),(60054,1669,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60055,1669,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(60056,1669,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60057,1669,'vi','ThÃªm HÃ³a Ä‘Æ¡n',0),(60058,1669,'af','Faktuur Byvoeg',0),(60059,1669,'ro','Adauga factura',0),(60060,1669,'et','Arve lisa',0),(60061,1669,'si','Dodajanje raÄuna',0),(60062,1669,'ba','Tambahkan faktur',0),(60063,1669,'nl','Factuur toevoegen',0),(60064,1669,'fi','Lasku lisÃ¤Ã¤',0),(60065,1669,'no','Faktura legge',0),(60066,1669,'da','Faktura tilfÃ¸je',0),(60067,1669,'ko','ì†¡ìž¥ ì¶”ê°€',0),(60068,1669,'he','×”×•×¡×¤×ª ×—×©×‘×•× ×™×ª',0),(60069,1669,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(60070,1669,'zh','å‘ç¥¨åœ°å€\r\n',0),(60071,1669,'sv','LÃ¤gg till faktura',0),(60072,1669,'it','Aggiungi fattura',0),(60073,1669,'tl','',0),(60074,1669,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60075,1669,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(60076,1669,'ms','Tambah invois',0),(60077,1669,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨',0),(60078,1669,'fr','Ajouter de la facture',0),(60079,1669,'jp','è«‹æ±‚æ›¸ã?®è¿½åŠ ',0),(60080,1669,'pt','Factura adicionar',0),(60081,1669,'ru','Ð¡Ñ‡ÐµÑ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(60082,1669,'es','Factura Agregar',0),(60083,1669,'de','Rechnung hinzufÃ¼gen',0),(60084,1669,'en','Invoice Add',0),(60085,1670,'is','',0),(60086,1670,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(60087,1670,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(60088,1670,'tr','Fatura baÅŸarÄ±yla eklendi.',0),(60089,1670,'pl','Faktura dodane pomyÅ›lnie.',0),(60090,1670,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(60091,1670,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(60092,1670,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(60093,1670,'vi','ThÃªm HÃ³a Ä‘Æ¡n thÃ nh cÃ´ng',0),(60094,1670,'af','Fakuur Suksesvol Geskep.',0),(60095,1670,'ro','Factura adaugata cu succes',0),(60096,1670,'et','Arve lisati edukalt',0),(60097,1670,'si','RaÄun uspeÅ¡no dodan.',0),(60098,1670,'ba','Faktur ditambahkan berhasil.',0),(60099,1670,'nl','Factuur toegevoegd.',0),(60100,1670,'fi','Lasku lisÃ¤ttiin.',0),(60101,1670,'no','Faktura lagt.',0),(60102,1670,'da','Faktura tilfÃ¸jet.',0),(60103,1670,'ko','ì†¡ìž¥ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(60104,1670,'he','.×—×©×‘×•× ×™×ª × ×•×¡×¤×” ×‘×”×¦×œ×—×”',0),(60105,1670,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(60106,1670,'zh','å‘ç¥¨æ·»åŠ æˆåŠŸã€‚\r\n',0),(60107,1670,'sv','Faktura lagts.',0),(60108,1670,'it','Fattura aggiunto con successo.',0),(60109,1670,'tl','',0),(60110,1670,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(60111,1670,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(60112,1670,'ms','Invois yang berjaya menambah.',0),(60113,1670,'ar','Ø£Ø¶ÙŠÙØª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(60114,1670,'fr','Facture ajoutÃ© avec succÃ¨s.',0),(60115,1670,'jp','è«‹æ±‚æ›¸ã‚’è¿½åŠ ã?—ã?¾ã?—ã?Ÿ',0),(60116,1670,'pt','Factura adicionada com Ãªxito.',0),(60117,1670,'ru','Ð¡Ñ‡ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(60118,1670,'es','Factura agregada exitosamente',0),(60119,1670,'de','Rechnung wurde erfolgreich hinzugefÃ¼gt.',0),(60120,1670,'en','Invoice added successfully.',0),(60121,1671,'is','',0),(60122,1671,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ÙØ§ÙƒØªÙˆØ± ',0),(60123,1671,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ÙØ§ÙƒØªÙˆØ± ',0),(60124,1671,'tr','Fatura baÅŸlangÄ±Ã§ tarihi',0),(60125,1671,'pl','Data rozpoczÄ™cia faktury',0),(60126,1671,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(60127,1671,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(60128,1671,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(60129,1671,'vi','NgÃ y báº¯t Ä‘áº§u HÃ³a Ä‘Æ¡n',0),(60130,1671,'af','Faktuur Begindatum',0),(60131,1671,'ro','Data de incepere factura',0),(60132,1671,'et','Arve alguskuupÃ¤ev',0),(60133,1671,'si','RaÄuna zaÄetni datum',0),(60134,1671,'ba','Tanggal mulai faktur',0),(60135,1671,'nl','Begin factuurdatum',0),(60136,1671,'fi','Laskun aloituspÃ¤ivÃ¤',0),(60137,1671,'no','Start fakturadatoen',0),(60138,1671,'da','Fakturadatoen Begin',0),(60139,1671,'ko','ì†¡ìž¥ ì‹œìž‘ ë‚ ì§œ',0),(60140,1671,'he','×ª××¨×™×š ×—×©×‘×•× ×™×ª ×‘×’×™×Ÿ',0),(60141,1671,'el','ÎˆÎ½Î±ÏÎ¾Î· Î—Î¼/Î½Î¯Î± Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(60142,1671,'zh','å‘ç¥¨å¼€å§‹æ—¥æœŸ\r\n',0),(60143,1671,'sv','BÃ¶rja fakturadatum',0),(60144,1671,'it','Fattura data Begin',0),(60145,1671,'tl','',0),(60146,1671,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60147,1671,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(60148,1671,'ms','Tarikh inbois yang mulakan',0),(60149,1671,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡ ÙÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(60150,1671,'fr','Date de dÃ©but de facturation',0),(60151,1671,'jp','è«‹æ±‚æ›¸é–‹å§‹æ—¥',0),(60152,1671,'pt','Data de inÃ­cio de fatura',0),(60153,1671,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° ÑÑ‡ÐµÑ‚Ð°',0),(60154,1671,'es','Factura Fecha de Comienzo',0),(60155,1671,'de','Begin Rechnungsdatum',0),(60156,1671,'en','Invoice Begin Date',0),(60157,1672,'is','',0),(60158,1672,'dr','ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± ',0),(60159,1672,'pr','ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± ',0),(60160,1672,'tr','Fatura tarihi',0),(60161,1672,'pl','Data faktury',0),(60162,1672,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60163,1672,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(60164,1672,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(60165,1672,'vi','NgÃ y HÃ³a Ä‘Æ¡n',0),(60166,1672,'af','Faktuurdatum',0),(60167,1672,'ro','Data facturii',0),(60168,1672,'et','Arve kuupÃ¤ev',0),(60169,1672,'si','Datum raÄuna',0),(60170,1672,'ba','Tanggal faktur',0),(60171,1672,'nl','Factuurdatum',0),(60172,1672,'fi','LaskutuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(60173,1672,'no','Fakturadatoen',0),(60174,1672,'da','Fakturadatoen',0),(60175,1672,'ko','ì†¡ìž¥ ë‚ ì§œ',0),(60176,1672,'he','×ª××¨×™×š ×—×©×‘×•× ×™×ª',0),(60177,1672,'el','Î—Î¼/Î½Î¯Î± Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(60178,1672,'zh','å‘ç¥¨æ—¥æœŸ\r\n',0),(60179,1672,'sv','Fakturadatum',0),(60180,1672,'it','Data fattura',0),(60181,1672,'tl','',0),(60182,1672,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60183,1672,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(60184,1672,'ms','Tarikh invois',0),(60185,1672,'ar','ØªØ§Ø±ÙŠØ® Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(60186,1672,'fr','Date de la facture',0),(60187,1672,'jp','è«‹æ±‚æ›¸æ—¥ä»˜',0),(60188,1672,'pt','Data da factura',0),(60189,1672,'ru','Ð”Ð°Ñ‚Ð° Ð¡Ñ‡ÐµÑ‚Ð°',0),(60190,1672,'es','Fecha de Factura',0),(60191,1672,'de','Rechnungsdatum',0),(60192,1672,'en','Invoice Date',0),(60193,1673,'is','',0),(60194,1673,'dr','ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(60195,1673,'pr','ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(60196,1673,'tr','Fatura baÅŸarÄ±yla silindi',0),(60197,1673,'pl','Faktura przesâ”‚anie',0),(60198,1673,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(60199,1673,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(60200,1673,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(60201,1673,'vi','XÃ³a HÃ³a Ä‘Æ¡n thÃ nh cÃ´ng',0),(60202,1673,'af','Faktuur Suksesvol Geskrap',0),(60203,1673,'ro','Factura stearsa cu succes',0),(60204,1673,'et','Arve kustutati edukalt',0),(60205,1673,'si','RaÄun uspeÅ¡no izbrisana',0),(60206,1673,'ba','Faktur dihapus berhasil',0),(60207,1673,'nl','Factuur met succes verwijderd',0),(60208,1673,'fi','Lasku poistettiin onnistuneesti',0),(60209,1673,'no','Fakturaen ble slettet',0),(60210,1673,'da','Faktura slettet',0),(60211,1673,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ì²­êµ¬ì„œ',0),(60212,1673,'he','×—×©×‘×•× ×™×ª × ×ž×—×§×” ×‘×”×¦×œ×—×”',0),(60213,1673,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(60214,1673,'zh','å‘ç¥¨æˆåŠŸåˆ é™¤\r\n',0),(60215,1673,'sv','Faktura raderades',0),(60216,1673,'it','Fattura eliminato con successo',0),(60217,1673,'tl','',0),(60218,1673,'th','&#3621;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(60219,1673,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(60220,1673,'ms','Invois yang dihapuskan dengan jayanya',0),(60221,1673,'ar','Ø­Ø°Ù Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(60222,1673,'fr','Facture supprimÃ© avec succÃ¨s',0),(60223,1673,'jp','è«‹æ±‚æ›¸ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(60224,1673,'pt','Factura apagada com sucesso',0),(60225,1673,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½Ñ‹',0),(60226,1673,'es','Factura Eliminada Exitosamente',0),(60227,1673,'de','Rechnung erfolgreich gelÃ¶scht',0),(60228,1673,'en','Invoice Deleted Successfully',0),(60229,1674,'is','',0),(60230,1674,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ÙØ§ÙƒØªÙˆØ±',0),(60231,1674,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ÙØ§ÙƒØªÙˆØ±',0),(60232,1674,'tr','Fatura bitiÅŸ tarihi',0),(60233,1674,'pl','Data koÅ„cowa faktura',0),(60234,1674,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60235,1674,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(60236,1674,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(60237,1674,'vi','NgÃ y cuá»‘i HÃ³a Ä‘Æ¡n ',0),(60238,1674,'af','Faktuur Enddatum',0),(60239,1674,'ro','Data de sfarsit factura',0),(60240,1674,'et','Arve lÃµppkuupÃ¤ev',0),(60241,1674,'si','Datum konca raÄuna',0),(60242,1674,'ba','Tanggal akhir faktur',0),(60243,1674,'nl','Factuur einddatum',0),(60244,1674,'fi','Laskun viimeinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(60245,1674,'no','Sluttdatoen for faktura',0),(60246,1674,'da','Slutdato for faktura',0),(60247,1674,'ko','ì†¡ìž¥ ë ë‚ ì§œ',0),(60248,1674,'he','×ª××¨×™×š ×¡×™×•× ×—×©×‘×•× ×™×ª',0),(60249,1674,'el','Î—Î¼/Î½Î¯Î± Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Ï„Î­Î»Î¿Ï‚',0),(60250,1674,'zh','å‘ç¥¨ç»“æŸæ—¥æœŸ\r\n',0),(60251,1674,'sv','Faktura slutdatum',0),(60252,1674,'it','Data di fine fattura',0),(60253,1674,'tl','',0),(60254,1674,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60255,1674,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤…à¤‚à¤¤à¤¿à¤® à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(60256,1674,'ms','Tarikh akhir invois',0),(60257,1674,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(60258,1674,'fr','Date de fin de facturation',0),(60259,1674,'jp','è«‹æ±‚æ›¸çµ‚äº†æ—¥',0),(60260,1674,'pt','Data de tÃ©rmino de factura',0),(60261,1674,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(60262,1674,'es','Factura Fecha de TerminaciÃ³n',0),(60263,1674,'de','Rechnungsdatum Ende',0),(60264,1674,'en','Invoice End Date',0),(60265,1675,'is','',0),(60266,1675,'dr','- Ø«Ø¨Øª Ø¨Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ø¬Ù†Ø³',0),(60267,1675,'pr','ÙØ§ÙƒØªÙˆØ±- Ø«Ø¨Øª Ø¨Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(60268,1675,'tr','Fatura malÄ±n maliyeti girin',0),(60269,1675,'pl','Faktura wprowadÅº koszt towarÃ³w',0),(60270,1675,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð° ÑÑ‚Ð¾ÐºÐ¸',0),(60271,1675,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ù„Ø§Ú¯Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(60272,1675,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ñ€Ð¾Ð±Ðµ',0),(60273,1675,'vi','Nháº­p GiÃ¡ HÃ ng Trong HÃ³a ÄÆ¡n',0),(60274,1675,'af','Faktuur Voer Koste van Verkope in',0),(60275,1675,'ro','Facturi intra costul produselor',0),(60276,1675,'et','Arve sisestada kauba maksumusest',0),(60277,1675,'si','RaÄuna vnesete stroÅ¡ek blaga',0),(60278,1675,'ba','Faktur masuk biaya barang',0),(60279,1675,'nl','Factuur kosten van goederen invoeren',0),(60280,1675,'fi','Laskun SyÃ¶tÃ¤ tuotteiden kustannukset',0),(60281,1675,'no','Fakturaen registrerer kostnaden av varer',0),(60282,1675,'da','Fakturaen angive omkostninger for varer',0),(60283,1675,'ko','ì†¡ìž¥ ìž…ë ¥ ìƒí’ˆì˜ ë¹„ìš©',0),(60284,1675,'he','×—×©×‘×•× ×™×ª ×œ×”×–×™×Ÿ ×¢×œ×•×ª ×”×ž×›×¨',0),(60285,1675,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ ÎšÎŸÎ£Î¤ÎŸÎ£ Î Î©Î›Î—Î˜Î•ÎÎ¤Î©Î',0),(60286,1675,'zh','å‘ç¥¨è¾“å…¥å•†å“æˆæœ¬\r\n',0),(60287,1675,'sv','Fakturan Ange kostnaden fÃ¶r varor',0),(60288,1675,'it','Fattura immettere il costo dei beni',0),(60289,1675,'tl','',0),(60290,1675,'th','&#3611;&#3657;&#3629;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3634;&#3618;',0),(60291,1675,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¤¾à¤² à¤•à¥€ à¤²à¤¾à¤—à¤¤ à¤¦à¤°à¥à¤œ',0),(60292,1675,'ms','Invois masukkan kos barangan',0),(60293,1675,'ar','Ø¥Ø¯Ø®Ø§Ù„ ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨',0),(60294,1675,'fr','Facture entrez le coÃ»t des marchandises',0),(60295,1675,'jp','å•†å“?åŽŸä¾¡å…¥åŠ›è«‹æ±‚æ›¸',0),(60296,1675,'pt','Fatura digite o custo das mercadorias',0),(60297,1675,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(60298,1675,'es','Factura Introducir Costo de Bienes',0),(60299,1675,'de','Rechnung eingeben Herstellkosten',0),(60300,1675,'en','Invoice Enter Cost of Goods',0),(60301,1676,'is','',0),(60302,1676,'dr','ÙØ§ÙƒØªÙˆØ± Ù†Ø±Ø® Ø¨Ù‡Ø±Ù‡ Ø¯Ø± Ù…Ø§Ù‡ ',0),(60303,1676,'pr','ÙØ§ÙƒØªÙˆØ± Ù†Ø±Ø® Ø¨Ù‡Ø±Ù‡ Ø¯Ø± Ù…Ø§Ù‡ ',0),(60304,1676,'tr','AylÄ±k fatura faiz oranÄ±',0),(60305,1676,'pl','Stopa procentowa faktury miesiÄ™cznie',0),(60306,1676,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð»Ð¸Ñ…Ð²Ð° Ð½Ð° Ð¼ÐµÑÐµÑ†',0),(60307,1676,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø³ÙˆØ¯ Ú©ÛŒ Ø´Ø±Ø­ ÙÛŒ Ù…ÛÛŒÙ†Û',0),(60308,1676,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÐ°Ð¼Ð°Ñ‚Ð½Ð° ÑÑ‚Ð¾Ð¿Ð°',0),(60309,1676,'vi','GiÃ¡ lÃ£i suáº¥t hÃ³a Ä‘Æ¡n má»—i thÃ¡ng',0),(60310,1676,'af','Faktuur Rentekoers per Maand',0),(60311,1676,'ro','Dobanada lunara factura',0),(60312,1676,'et','Arve viivise taks kuus',0),(60313,1676,'si','RaÄuna obrestno mero na mesec',0),(60314,1676,'ba','Faktur bunga per bulan',0),(60315,1676,'nl','Factuur rente per maand',0),(60316,1676,'fi','Lasku korko',0),(60317,1676,'no','Faktura rentesatsen per mÃ¥ned',0),(60318,1676,'da','Faktura rente pr. mÃ¥ned',0),(60319,1676,'ko','ë§¤ë‹¬ ì²­êµ¬ì„œ ê¸ˆë¦¬',0),(60320,1676,'he','×—×©×‘×•× ×™×ª ×”×¨×™×‘×™×ª ×œ×—×•×“×©',0),(60321,1676,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎµÏ€Î¹Ï„ÏŒÎºÎ¹Î¿ Î±Î½Î¬ Î¼Î®Î½Î±',0),(60322,1676,'zh','å‘ç¥¨æ¯æœˆåˆ©çŽ‡\r\n',0),(60323,1676,'sv','Faktura rÃ¤nta per mÃ¥nad',0),(60324,1676,'it','Tasso di interesse di fattura al mese',0),(60325,1676,'tl','',0),(60326,1676,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3605;&#3656;&#3629;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(60327,1676,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¬à¥à¤¯à¤¾à¤œ à¤¦à¤° à¤ªà¥à¤°à¤¤à¤¿ à¤®à¤¾à¤¹',0),(60328,1676,'ms','Kadar faedah invois sebulan',0),(60329,1676,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(60330,1676,'fr','Taux d\'intÃ©rÃªt de facture par mois',0),(60331,1676,'jp','æœˆæ¯Žåˆ©çŽ‡è«‹æ±‚æ›¸',0),(60332,1676,'pt','Taxa de juros de fatura por mÃªs',0),(60333,1676,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ð°Ñ ÑÑ‚Ð°Ð²ÐºÐ° Ð² Ð¼ÐµÑÑÑ†',0),(60334,1676,'es','Factura Tasa de InterÃ©ses por Mes',0),(60335,1676,'de','Rechnung-Zinssatz pro Monat',0),(60336,1676,'en','Invoice Interest Rate per Month',0),(60337,1677,'is','',0),(60338,1677,'dr','ÙØ§ÙƒØªÙˆØ± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(60339,1677,'pr','ÙØ§ÙƒØªÙˆØ± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(60340,1677,'tr','Fatura bulunamadÄ±',0),(60341,1677,'pl','Faktury nie znaleziono',0),(60342,1677,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(60343,1677,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(60344,1677,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(60345,1677,'vi','KhÃ´ng tháº¥y hÃ³a Ä‘Æ¡n',0),(60346,1677,'af','Faktuur nie gevind',0),(60347,1677,'ro','Factura nu a fost gÄƒsit',0),(60348,1677,'et','Arvet ei leitud',0),(60349,1677,'si','RaÄuna ni bilo mogoÄe najti',0),(60350,1677,'ba','Faktur tidak ditemukan',0),(60351,1677,'nl','Factuur niet gevonden',0),(60352,1677,'fi','Laskua ei lÃ¶ytynyt',0),(60353,1677,'no','Faktura ikke funnet',0),(60354,1677,'da','Faktura ikke fundet',0),(60355,1677,'ko','ì²­êµ¬ì„œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(60356,1677,'he','×—×©×‘×•× ×™×ª ×œ× × ×ž×¦××”',0),(60357,1677,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(60358,1677,'zh','å‘ç¥¨æœªæ‰¾åˆ°\r\n',0),(60359,1677,'sv','Faktura hittades inte',0),(60360,1677,'it','Fattura non trovato',0),(60361,1677,'tl','',0),(60362,1677,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60363,1677,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(60364,1677,'ms','Invois tidak dijumpai',0),(60365,1677,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(60366,1677,'fr','Facture introuvable',0),(60367,1677,'jp','è«‹æ±‚æ›¸ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(60368,1677,'pt','Factura nÃ£o encontrada',0),(60369,1677,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(60370,1677,'es','Factura no se encontrÃ³',0),(60371,1677,'de','Rechnung nicht gefunden',0),(60372,1677,'en','Invoice not found',0),(60373,1678,'is','',0),(60374,1678,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ±',0),(60375,1678,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ±',0),(60376,1678,'tr','Fatura #',0),(60377,1678,'pl','Faktura #',0),(60378,1678,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¾Ð¼ÐµÑ€',0),(60379,1678,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ #',0),(60380,1678,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ #',0),(60381,1678,'vi','HÃ³a Ä‘Æ¡n sá»‘',0),(60382,1678,'af','Faktuur #',0),(60383,1678,'ro','Factura #',0),(60384,1678,'et','Arve #',0),(60385,1678,'si','RaÄun #',0),(60386,1678,'ba','Faktur #',0),(60387,1678,'nl','Factuur #',0),(60388,1678,'fi','Laskun numero',0),(60389,1678,'no','Fakturanummer',0),(60390,1678,'da','Faktura #',0),(60391,1678,'ko','# ì†¡ìž¥',0),(60392,1678,'he','# ×—×©×‘×•× ×™×ª',0),(60393,1678,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ #',0),(60394,1678,'zh','å‘ç¥¨å·ç \r\n',0),(60395,1678,'sv','Fakturera #',0),(60396,1678,'it','Fattura #',0),(60397,1678,'tl','',0),(60398,1678,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60399,1678,'hi','à¤šà¤¾à¤²à¤¾à¤¨ #',0),(60400,1678,'ms','Invois #',0),(60401,1678,'ar','Ø±Ù‚Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(60402,1678,'fr','# La facture',0),(60403,1678,'jp','è«‹æ±‚æ›¸ï¼ƒ',0),(60404,1678,'pt','Invoice #',0),(60405,1678,'ru','Ð¡Ñ‡ÐµÑ‚ #',0),(60406,1678,'es','Factura #',0),(60407,1678,'de','# In Rechnung zu stellen',0),(60408,1678,'en','Invoice #',0),(60409,1679,'is','',0),(60410,1679,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯ ',0),(60411,1679,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯ ',0),(60412,1679,'tr','Fatura numarasÄ± geÃ§medi.',0),(60413,1679,'pl','Numer faktury nie przeszedÅ‚.',0),(60414,1679,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ðµ Ðµ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ».',0),(60415,1679,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù…Ù†Ø¸ÙˆØ± Ù†ÛÛŒÚº Ú©ÛŒØ§ Û”',0),(60416,1679,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾ÑˆÐ°Ð¾.',0),(60417,1679,'vi','Sá»‘ hÃ³a Ä‘Æ¡n chÆ°a qua',0),(60418,1679,'af','Faktuurnommer het nie geslaag.',0),(60419,1679,'ro','NumÄƒrul facturii nu a trecut.',0),(60420,1679,'et','Arve numbrit pole sooritanud.',0),(60421,1679,'si','Å tevilka raÄuna, ki ne prenesejo.',0),(60422,1679,'ba','Faktur jumlah tidak diberikan.',0),(60423,1679,'nl','Factuurnummer niet doorgegeven.',0),(60424,1679,'fi','Laskunumero, ei siirretÃ¤.',0),(60425,1679,'no','Fakturanummeret ikke bestÃ¥tt.',0),(60426,1679,'da','Fakturanummeret ikke bestÃ¥et.',0),(60427,1679,'ko','ì†¡ìž¥ ë²ˆí˜¸ ì „ë‹¬ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(60428,1679,'he','×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª ×œ× ×—×œ×¤×•.',0),(60429,1679,'el','Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£ Î´ÎµÎ½ Ï€Î­ÏÎ±ÏƒÎµ.',0),(60430,1679,'zh','å‘ç¥¨å·ç ä¸é€šè¿‡ã€‚\r\n',0),(60431,1679,'sv','Fakturanummer inte passerat.',0),(60432,1679,'it','Numero di fattura non passato.',0),(60433,1679,'tl','',0),(60434,1679,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;',0),(60435,1679,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤°à¤¿à¤¤ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(60436,1679,'ms','Nombor invois tidak diluluskan.',0),(60437,1679,'ar','Ù„Ø§ ØªÙ…Ø±ÙŠØ± Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©.',0),(60438,1679,'fr','NumÃ©ro de la facture ne pas passÃ©.',0),(60439,1679,'jp','è«‹æ±‚æ›¸ç•ªå?·ã?Œé€šé?Žã?—ã?¾ã?›ã‚“',0),(60440,1679,'pt','NÃºmero da fatura nÃ£o passou.',0),(60441,1679,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð½Ðµ Ð¿Ñ€Ð¾ÑˆÐµÐ».',0),(60442,1679,'es','NÃºmero de Factura no pasÃ³',0),(60443,1679,'de','Rechnungsnummer nicht Ã¼bergeben.',0),(60444,1679,'en','Invoice number not passed.',0),(60445,1680,'is','',0),(60446,1680,'dr','(Ø³Ø§Ø¨Ù‚Ù‡)Ø¯ÛŒÙˆÙ† - Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø¯Ù…Ø§Øª Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(60447,1680,'pr','ÙØ§ÙƒØªÙˆØ± Ø¨Ø¹Ø¯Ø§Ø²(Ø³Ø§Ø¨Ù‚Ù‡)Ø¨Ø¯Ù‡ÙŠ- Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø¯Ù…Ø§Øª Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(60448,1680,'tr','Fatura geÃ§miÅŸi nedeniyle servis Ã¼creti',0),(60449,1680,'pl','Faktury zalegÅ‚e opÅ‚aty',0),(60450,1680,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¼Ð¸Ð½Ð°Ð»Ð¾Ñ‚Ð¾ Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð°Ñ‚Ð° Ñ‚Ð°ÐºÑÐ° Ð·Ð° ÑƒÑÐ»ÑƒÐ³Ð°Ñ‚Ð°',0),(60451,1680,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø³Ø±ÙˆØ³ Ú†Ø§Ø±Ø¬ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ù…Ø§Ø¶ÛŒ',0),(60452,1680,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ Ð·Ð°Ð¿Ð°Ð´Ð»Ð¸Ñ… Ð½Ð°ÐºÐ½Ð°Ð´Ñƒ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(60453,1680,'vi','PhÃ­ dá»‹ch vá»¥ cho hÃ³a Ä‘Æ¡n quÃ¡ háº¡n',0),(60454,1680,'af','Faktuur het Verskuldige Diensfooi Oorskry',0),(60455,1680,'ro','Factura trecut din cauza taxa de serviciu',0),(60456,1680,'et','Arve Ã¼le tÃ¤htaja teenustasu',0),(60457,1680,'si','RaÄun zapadlih dolgovanih zaraÄunane storitve',0),(60458,1680,'ba','Faktur masa lalu karena biaya layanan',0),(60459,1680,'nl','Factuur verleden verschuldigde administratiekosten',0),(60460,1680,'fi','Laskun erÃ¤Ã¤ntyneiden Palvelumaksu',0),(60461,1680,'no','Fakturere forfalte serviceavgift',0),(60462,1680,'da','Fakturere forfaldne servicegebyr',0),(60463,1680,'ko','ì†¡ìž¥ ì„œë¹„ìŠ¤ ìš”ê¸ˆ ì—°ì²´',0),(60464,1680,'he','×—×©×‘×•× ×™×ª ×©×ž×•×¢×“ ×”×ª×©×œ×•× ×©×œ×”× ×“×ž×™ ×©×™×¨×•×ª',0),(60465,1680,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€Î±ÏÎµÎ»Î¸ÏŒÎ½ Î»ÏŒÎ³Ï‰ Ï‡ÏÎ­Ï‰ÏƒÎ· Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½',0),(60466,1680,'zh','é€¾æœŸæœåŠ¡å‘ç¥¨è®¡è´¹\r\n',0),(60467,1680,'sv','Fakturera fÃ¶rfallna serviceavgift',0),(60468,1680,'it','Fattura passato dovuto il costo del servizio',0),(60469,1680,'tl','',0),(60470,1680,'th','&#3588;&#3656;&#3634;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3592;&#3634;&#3585;&#3610;&#3619;&#3636;&#3585;&#3634;&#3',0),(60471,1680,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¤¿à¤›à¤²à¥€ à¤¬à¤•à¤¾à¤¯à¤¾ à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(60472,1680,'ms','Invois masa lalu disebabkan oleh Caj Perkhidmatan',0),(60473,1680,'ar','ÙØ§ØªÙˆØ±Ø© Ù…Ø³ØªØ­Ù‚Ø© Ù…Ù‚Ø§Ø¨Ù„ Ø§Ù„Ø®Ø¯Ù…Ø§Øª',0),(60474,1680,'fr','Facturer des frais de Service en souffrance',0),(60475,1680,'jp','æœŸæ—¥çµŒé?Žã‚µãƒ¼ãƒ“ã‚¹æ–™è«‹æ±‚æ›¸',0),(60476,1680,'pt','Fatura passado devido a taxa de serviÃ§o',0),(60477,1680,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð·Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(60478,1680,'es','Factura Carga de Servicio por estar Vencido',0),(60479,1680,'de','Rechnung Ã¼berfÃ¤llig ServicegebÃ¼hr',0),(60480,1680,'en','Invoice Past Due Service Charge',0),(60481,1681,'is','',0),(60482,1681,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(60483,1681,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(60484,1681,'tr','Fatura Ã¶deme baÅŸarÄ±yla eklendi',0),(60485,1681,'pl','PÅ‚atnoÅ›ci faktury dodano pomyÅ›lnie',0),(60486,1681,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(60487,1681,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(60488,1681,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(60489,1681,'vi','ThÃªm Thanh toÃ¡n hÃ³a Ä‘Æ¡n thÃ nh cÃ´ng',0),(60490,1681,'af','Faktuurbetaling Suksesvol bygevoeg',0),(60491,1681,'ro','Plata facturii adÄƒugat cu succes',0),(60492,1681,'et','Arve tasumise edukalt lisatud',0),(60493,1681,'si','RaÄun plaÄilo uspeÅ¡no dodani',0),(60494,1681,'ba','Pembayaran tagihan yang berhasil ditambahkan',0),(60495,1681,'nl','Factuur betaling toegevoegd',0),(60496,1681,'fi','Laskun maksu lisÃ¤Ã¤minen onnistui',0),(60497,1681,'no','Fakturabetalingen lagt',0),(60498,1681,'da','Fakturabetaling tilfÃ¸jet',0),(60499,1681,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì²­êµ¬ì„œ ì§€ë¶ˆ',0),(60500,1681,'he','×—×©×‘×•× ×™×ª ×ª×©×œ×•× × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(60501,1681,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(60502,1681,'zh','å‘ç¥¨ä»˜æ¬¾æˆåŠŸæ·»åŠ \r\n',0),(60503,1681,'sv','Fakturabetalning lagts',0),(60504,1681,'it','Pagamento fattura aggiunto con successo',0),(60505,1681,'tl','',0),(60506,1681,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(60507,1681,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(60508,1681,'ms','Pembayaran invois yang berjaya menambah',0),(60509,1681,'ar','Ø¯ÙØ¹ ÙØ§ØªÙˆØ±Ø© Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(60510,1681,'fr','Paiement de facture ajoutÃ© avec succÃ¨s',0),(60511,1681,'jp','è«‹æ±‚æ›¸æ”¯æ‰•ã?„ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(60512,1681,'pt','Pagamento de factura adicionado com sucesso',0),(60513,1681,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(60514,1681,'es','Pago de Factura agregado exitosamente',0),(60515,1681,'de','Rechnung Zahlung erfolgreich hinzugefÃ¼gt',0),(60516,1681,'en','Invoice Payment added successfully',0),(60517,1682,'is','',0),(60518,1682,'dr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ ',0),(60519,1682,'pr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ ',0),(60520,1682,'tr','Fatura Ã¶demeleri',0),(60521,1682,'pl','PÅ‚atnoÅ›ci faktury',0),(60522,1682,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(60523,1682,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(60524,1682,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(60525,1682,'vi','Thanh toÃ¡n hÃ³a Ä‘Æ¡n',0),(60526,1682,'af','Faktuur Betalings',0),(60527,1682,'ro','Plata facturilor',0),(60528,1682,'et','Ettemaksuarve maksed',0),(60529,1682,'si','PlaÄila raÄuna',0),(60530,1682,'ba','Faktur pembayaran',0),(60531,1682,'nl','Factuur betalingen',0),(60532,1682,'fi','Laskujen maksut',0),(60533,1682,'no','Faktura betalinger',0),(60534,1682,'da','Faktura betaling',0),(60535,1682,'ko','ì†¡ìž¥ ì§€ë¶ˆ',0),(60536,1682,'he','×ª×©×œ×•×ž×™ ×—×©×‘×•× ×™×ª',0),(60537,1682,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(60538,1682,'zh','å‘ç¥¨ä»˜æ¬¾\r\n',0),(60539,1682,'sv','Faktura betalningar',0),(60540,1682,'it','Pagamenti fattura',0),(60541,1682,'tl','',0),(60542,1682,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60543,1682,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(60544,1682,'ms','Pembayaran invois',0),(60545,1682,'ar','Ø¯ÙØ¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(60546,1682,'fr','Paiements de facture',0),(60547,1682,'jp','è«‹æ±‚æ›¸æ”¯æ‰•ã?„',0),(60548,1682,'pt','Pagamentos de fatura',0),(60549,1682,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(60550,1682,'es','Pagos de Factura',0),(60551,1682,'de','Rechnung Zahlungen',0),(60552,1682,'en','Invoice Payments',0),(60553,1683,'is','',0),(60554,1683,'dr','ÙØ§ÙƒØªÙˆØ± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù‡Ø§ ',0),(60555,1683,'pr','ÙØ§ÙƒØªÙˆØ± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù‡Ø§ ',0),(60556,1683,'tr','Fatura ifadeleri',0),(60557,1683,'pl','Faktura instrukcji',0),(60558,1683,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(60559,1683,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø¨ÛŒØ§Ù†Ø§Øª',0),(60560,1683,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(60561,1683,'vi','Sao kÃª hÃ³a Ä‘Æ¡n',0),(60562,1683,'af','Faktuur State',0),(60563,1683,'ro','DeclaraÅ£ii de facturÄƒ',0),(60564,1683,'et','Arvete vÃ¤ljavÃµte',0),(60565,1683,'si','RaÄun izjav',0),(60566,1683,'ba','Pernyataan faktur',0),(60567,1683,'nl','Factuur verklaringen',0),(60568,1683,'fi','Laskun lausunnot',0),(60569,1683,'no','Faktura-setninger',0),(60570,1683,'da','Faktura udtalelser',0),(60571,1683,'ko','ì†¡ìž¥ ë¬¸',0),(60572,1683,'he','×”×¦×”×¨×•×ª ×—×©×‘×•× ×™×ª',0),(60573,1683,'el','Î”Î·Î»ÏŽÏƒÎµÎ¹Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(60574,1683,'zh','å‘ç¥¨æŠ¥è¡¨\r\n',0),(60575,1683,'sv','Faktura uttalanden',0),(60576,1683,'it','Dichiarazioni di fattura',0),(60577,1683,'tl','',0),(60578,1683,'th','&#3585;&#3634;&#3619;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60579,1683,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤µà¤¿à¤µà¤°à¤£',0),(60580,1683,'ms','Penyata invois',0),(60581,1683,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(60582,1683,'fr','RelevÃ©s de facture',0),(60583,1683,'jp','è«‹æ±‚æ›¸æ˜Žç´°',0),(60584,1683,'pt','DeclaraÃ§Ãµes na factura',0),(60585,1683,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ñ',0),(60586,1683,'es','Declaraciones de Facturas',0),(60587,1683,'de','Rechnung-Anweisungen',0),(60588,1683,'en','Invoice Statements',0),(60589,1684,'is','',0),(60590,1684,'dr','Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ± ',0),(60591,1684,'pr','Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ± ',0),(60592,1684,'tr','Fatura Ã–zeti',0),(60593,1684,'pl','Podsumowanie faktury',0),(60594,1684,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(60595,1684,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø®Ù„Ø§ØµÛ',0),(60596,1684,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(60597,1684,'vi','Tá»•ng há»£p hÃ³a Ä‘Æ¡n',0),(60598,1684,'af','Faktuur Opsomming',0),(60599,1684,'ro','Rezumat facturÄƒ',0),(60600,1684,'et','Arvete kokkuvÃµte',0),(60601,1684,'si','Povzetek raÄuna',0),(60602,1684,'ba','Faktur ringkasan',0),(60603,1684,'nl','Factuuroverzicht',0),(60604,1684,'fi','Laskun Yhteenveto',0),(60605,1684,'no','Fakturasammendrag',0),(60606,1684,'da','Fakturaoversigt',0),(60607,1684,'ko','ì†¡ìž¥ ìš”ì•½',0),(60608,1684,'he','×¡×™×›×•× ×—×©×‘×•× ×™×ª',0),(60609,1684,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(60610,1684,'zh','å‘ç¥¨æ‘˜è¦\r\n',0),(60611,1684,'sv','Faktura Sammanfattning',0),(60612,1684,'it','Riepilogo fatture',0),(60613,1684,'tl','',0),(60614,1684,'th','&#3626;&#3619;&#3640;&#3611;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60615,1684,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(60616,1684,'ms','Ringkasan invois',0),(60617,1684,'ar','Ù…Ù„Ø®Ù‘Øµ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(60618,1684,'fr','Sommaire de la facture',0),(60619,1684,'jp','è«‹æ±‚æ›¸ã‚µãƒžãƒªãƒ¼',0),(60620,1684,'pt','Resumo da factura',0),(60621,1684,'ru','Ð¡Ð²Ð¾Ð´ÐºÐ° ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(60622,1684,'es','Sumario de Facturas',0),(60623,1684,'de','Rechnungszusammenfassung',0),(60624,1684,'en','Invoice Summary',0),(60625,1685,'is','',0),(60626,1685,'dr','Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(60627,1685,'pr','Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(60628,1685,'tr','Fatura ÅŸartlarÄ±',0),(60629,1685,'pl','Warunki faktury',0),(60630,1685,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60631,1685,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª',0),(60632,1685,'sr','Ð£ÑÐ»Ð¾Ð²Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(60633,1685,'vi','Äiá»u khoáº£n hÃ³a Ä‘Æ¡n',0),(60634,1685,'af','Faktuur Terme',0),(60635,1685,'ro','Termeni de facturÄƒ',0),(60636,1685,'et','Maksetingimused',0),(60637,1685,'si','Pogoje raÄuna',0),(60638,1685,'ba','Syarat-syarat faktur',0),(60639,1685,'nl','Factuur voorwaarden',0),(60640,1685,'fi','Laskun ehtojen',0),(60641,1685,'no','FaktureringsvilkÃ¥r',0),(60642,1685,'da','Faktura vilkÃ¥r',0),(60643,1685,'ko','ì†¡ìž¥ ìš©ì–´',0),(60644,1685,'he','×ª× ××™ ×—×©×‘×•× ×™×ª',0),(60645,1685,'el','Î¤Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(60646,1685,'zh','å‘ç¥¨æ¡æ¬¾\r\n',0),(60647,1685,'sv','Faktura villkor',0),(60648,1685,'it','Termini di fattura',0),(60649,1685,'tl','',0),(60650,1685,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60651,1685,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(60652,1685,'ms','Terma-terma invois',0),(60653,1685,'ar','Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(60654,1685,'fr','Termes de facture',0),(60655,1685,'jp','è«‹æ±‚æ›¸æ?¡ä»¶',0),(60656,1685,'pt','Termos de factura',0),(60657,1685,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(60658,1685,'es','TÃ©rminos de Factura',0),(60659,1685,'de','Rechnung-Begriffe',0),(60660,1685,'en','Invoice Terms',0),(60661,1686,'is','',0),(60662,1686,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(60663,1686,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(60664,1686,'tr','Yeni fatura ÅŸartlarÄ±',0),(60665,1686,'pl','Nowe warunki faktury',0),(60666,1686,'bg','ÐÐ¾Ð²Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60667,1686,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ù†Ø¦ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª',0),(60668,1686,'sr','ÐÐ¾Ð²Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(60669,1686,'vi','ThÃªm Äiá»u khoáº£n hÃ³a Ä‘Æ¡n',0),(60670,1686,'af','Faktuur Terme Byvoeg',0),(60671,1686,'ro','Termeni noi factura',0),(60672,1686,'et','Uus arve tingimused',0),(60673,1686,'si','Nove pogoje raÄuna',0),(60674,1686,'ba','Istilah-istilah baru faktur',0),(60675,1686,'nl','Nieuwe factuur voorwaarden',0),(60676,1686,'fi','Uuden laskun ehtojen',0),(60677,1686,'no','Nye faktureringsvilkÃ¥r',0),(60678,1686,'da','Ny faktura vilkÃ¥r',0),(60679,1686,'ko','ìƒˆ ì†¡ìž¥ ìš©ì–´',0),(60680,1686,'he','×”×•×¡×¤×ª ×ª× ××™ ×—×©×‘×•× ×™×ª',0),(60681,1686,'el','ÎÎ­Î¿Î¹ ÏŒÏÎ¿Î¹ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(60682,1686,'zh','æ–°å¢žæ¡æ¬¾å‘ç¥¨\r\n',0),(60683,1686,'sv','Nya faktura villkor',0),(60684,1686,'it','Nuovi termini di fattura',0),(60685,1686,'tl','',0),(60686,1686,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60687,1686,'hi','à¤¨à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(60688,1686,'ms','Terma-terma invois yang baru',0),(60689,1686,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(60690,1686,'fr','Nouvelles modalitÃ©s de facturation',0),(60691,1686,'jp','è«‹æ±‚æ?¡ä»¶ã?®è¿½åŠ ',0),(60692,1686,'pt','Novos termos de factura',0),(60693,1686,'ru','ÐÐ¾Ð²Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ñ‹',0),(60694,1686,'es','TÃ©rminos de Factura Agregar',0),(60695,1686,'de','Neue Rechnung-Begriffe',0),(60696,1686,'en','New Invoice Terms',0),(60697,1687,'is','',0),(60698,1687,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(60699,1687,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(60700,1687,'tr','Fatura ÅŸartlarÄ± baÅŸarÄ±yla eklendi',0),(60701,1687,'pl','Warunkach faktura dodane pomyÅ›lnie',0),(60702,1687,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(60703,1687,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(60704,1687,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ð»Ð¸ ÑƒÑÐ»Ð¾Ð²Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(60705,1687,'vi','ThÃªm Äiá»u khoáº£n hÃ³a Ä‘Æ¡n thÃ nh cÃ´ng',0),(60706,1687,'af','Faktuurterme Suksesvol bygevoeg',0),(60707,1687,'ro','Termeni de facturÄƒ adÄƒugat cu succes',0),(60708,1687,'et','Arve tingimused lisatud',0),(60709,1687,'si','UspeÅ¡no dodani pogoje raÄuna',0),(60710,1687,'ba','Faktur ketentuan ditambahkan berhasil',0),(60711,1687,'nl','Voorwaarden van de factuur toegevoegd',0),(60712,1687,'fi','Laskun ehtojen lisÃ¤Ã¤minen onnistui',0),(60713,1687,'no','FaktureringsvilkÃ¥r lagt',0),(60714,1687,'da','Faktura vilkÃ¥r tilfÃ¸jet',0),(60715,1687,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì†¡ìž¥ ìš©ì–´',0),(60716,1687,'he','×ª× ××™ ×—×©×‘×•× ×™×ª × ×•×¡×¤×• ×‘×”×¦×œ×—×”',0),(60717,1687,'el','Î¤Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(60718,1687,'zh','å‘ç¥¨æ¡æ¬¾æˆåŠŸæ·»åŠ \r\n',0),(60719,1687,'sv','Faktura villkoren lagts',0),(60720,1687,'it','Termini di fattura aggiunti con successo',0),(60721,1687,'tl','',0),(60722,1687,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(60723,1687,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(60724,1687,'ms','Terma-terma invois yang berjaya menambah',0),(60725,1687,'ar','Ø£Ø¶ÙŠÙØª Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(60726,1687,'fr','Termes de facture ajoutÃ©s avec succÃ¨s',0),(60727,1687,'jp','è«‹æ±‚æ?¡ä»¶ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(60728,1687,'pt','Termos de factura adicionados com sucesso',0),(60729,1687,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(60730,1687,'es','TÃ©rminos de Factura agregados exitosamente',0),(60731,1687,'de','Rechnung Bedingungen erfolgreich hinzugefÃ¼gt',0),(60732,1687,'en','Invoice Terms added successfully',0),(60733,1688,'is','',0),(60734,1688,'dr','Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(60735,1688,'pr','Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(60736,1688,'tr','Fatura ÅŸartlarÄ± zaten var',0),(60737,1688,'pl','Faktury wzglÄ™dem juÅ¼ istnieje',0),(60738,1688,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(60739,1688,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(60740,1688,'sr','Ð£ÑÐ»Ð¾Ð²Ð¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(60741,1688,'vi','Äiá»u khoáº£n hÃ³a Ä‘Æ¡n Ä‘Ã£ cÃ³',0),(60742,1688,'af','Faktuur Terme bestaan alreeds',0),(60743,1688,'ro','FacturÄƒ termeni deja exista',0),(60744,1688,'et','Arve juba olemas',0),(60745,1688,'si','Pogoje raÄuna Å¾e obstaja',0),(60746,1688,'ba','Faktur persyaratan sudah ada',0),(60747,1688,'nl','Factuur voorwaarden reeds bestaan',0),(60748,1688,'fi','Laskun ehtojen jo olemassa',0),(60749,1688,'no','FaktureringsvilkÃ¥r allerede finnes',0),(60750,1688,'da','Faktura vilkÃ¥r allerede findes',0),(60751,1688,'ko','ì†¡ìž¥ ìš©ì–´ ì´ë¯¸ ì¡´ìž¬',0),(60752,1688,'he','×”×ž×•× ×—×™× ×—×©×‘×•× ×™×ª ×©×›×‘×¨ ×§×™×™×ž×™×',0),(60753,1688,'el','Î¤Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€Î¿Ï… Î®Î´Î· Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½',0),(60754,1688,'zh','å‘ç¥¨æ¡æ¬¾å·²ç»å­˜åœ¨\r\n',0),(60755,1688,'sv','Faktura finns redan',0),(60756,1688,'it','Termini di fattura giÃ  esiste',0),(60757,1688,'tl','',0),(60758,1688,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;',0),(60759,1688,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤¿à¤¯à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦',0),(60760,1688,'ms','Terma-terma invois telah wujud',0),(60761,1688,'ar','Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯Ø© Ù…Ø³Ø¨Ù‚Ø§',0),(60762,1688,'fr','Conditions de facturation dÃ©jÃ  exister',0),(60763,1688,'jp','è«‹æ±‚æ?¡ä»¶ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(60764,1688,'pt','Termos de factura jÃ¡ existe',0),(60765,1688,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹ ÑƒÐ¶Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(60766,1688,'es','TÃ©rminos de Factura y existe',0),(60767,1688,'de','Rechnung Begriffe bereits vorhanden',0),(60768,1688,'en','Invoice Terms already exist',0),(60769,1689,'is','',0),(60770,1689,'dr','Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø­Ø°Ù Ø´Ø¯ ',0),(60771,1689,'pr','Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø­Ø°Ù Ø´Ø¯ ',0),(60772,1689,'tr','Fatura ÅŸartlarÄ± baÅŸarÄ±yla silindi',0),(60773,1689,'pl','Faktura warunki usuniÄ™te pomyÅ›lnie',0),(60774,1689,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(60775,1689,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø·',0),(60776,1689,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ ÑƒÑÐ»Ð¾Ð²Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(60777,1689,'vi','XÃ³a Äiá»u khoáº£n hÃ³a Ä‘Æ¡n thÃ nh cÃ´ng',0),(60778,1689,'af','Faktuurterme Suksesvol geskrap',0),(60779,1689,'ro','Termeni de facturÄƒ eliminÄƒ cu succes',0),(60780,1689,'et','Arve tingimusi edukalt kustutatud',0),(60781,1689,'si','RaÄuna izraze uspeÅ¡no izbrisana',0),(60782,1689,'ba','Syarat-syarat faktur yang berhasil dihapus',0),(60783,1689,'nl','Factuur voorwaarden met succes verwijderd',0),(60784,1689,'fi','Laskun ehtojen poistettu',0),(60785,1689,'no','FaktureringsvilkÃ¥r slettet',0),(60786,1689,'da','Faktura vilkÃ¥r slettet',0),(60787,1689,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ì²­êµ¬ì„œ ìš©ì–´',0),(60788,1689,'he','×ª× ××™ ×—×©×‘×•× ×™×ª × ×ž×—×§×” ×‘×”×¦×œ×—×”',0),(60789,1689,'el','Î¤Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(60790,1689,'zh','å‘ç¥¨æ¡æ¬¾åˆ é™¤æˆåŠŸ\r\n',0),(60791,1689,'sv','Faktura villkor raderades',0),(60792,1689,'it','Termini di fattura eliminati con successo',0),(60793,1689,'tl','',0),(60794,1689,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(60795,1689,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(60796,1689,'ms','Terma-terma invois yang dihapuskan dengan jayanya',0),(60797,1689,'ar','Ø­Ø°ÙØª Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(60798,1689,'fr','Termes de facture supprimÃ©s avec succÃ¨s',0),(60799,1689,'jp','è«‹æ±‚æ?¡ä»¶ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(60800,1689,'pt','Factura termos apagados com sucesso',0),(60801,1689,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(60802,1689,'es','TÃ©rminos de Factura eliminados exitosamente',0),(60803,1689,'de','Rechnung Bedingungen erfolgreich gelÃ¶scht',0),(60804,1689,'en','Invoice Terms deleted successfully',0),(60805,1690,'is','',0),(60806,1690,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(60807,1690,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± ',0),(60808,1690,'tr','Fatura ÅŸartlarÄ±nÄ± dÃ¼zenlemek',0),(60809,1690,'pl','Edytuj faktury warunki',0),(60810,1690,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60811,1690,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(60812,1690,'sr','Ð£Ñ€ÐµÐ´Ð¸Ñ‚Ð¸ ÑƒÑÐ»Ð¾Ð²Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(60813,1690,'vi','Cáº­p Nháº­t Äiá»u Khoáº£n HÃ³a ÄÆ¡n',0),(60814,1690,'af','Faktuur Terme Opdateer',0),(60815,1690,'ro','Edita termeni de facturÄƒ',0),(60816,1690,'et','Redigeeri arve tingimused',0),(60817,1690,'si','Uredi pogoje raÄuna',0),(60818,1690,'ba','Mengedit faktur persyaratan',0),(60819,1690,'nl','Factuur voorwaarden bewerken',0),(60820,1690,'fi','Muokkaa laskun ehtojen',0),(60821,1690,'no','Redigere faktureringsvilkÃ¥r',0),(60822,1690,'da','Redigere faktura vilkÃ¥r',0),(60823,1690,'ko','ì†¡ìž¥ ìš©ì–´ íŽ¸ì§‘',0),(60824,1690,'he','×¢×¨×™×›×ª ×ª× ××™ ×—×©×‘×•× ×™×ª',0),(60825,1690,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(60826,1690,'zh','å‘ç¥¨æ¡æ¬¾æ›´æ–°\r\n',0),(60827,1690,'sv','Redigera faktura villkor',0),(60828,1690,'it','Modificare i termini di fattura',0),(60829,1690,'tl','',0),(60830,1690,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60831,1690,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤¿à¤¯à¤® à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(60832,1690,'ms','Edit invois terma',0),(60833,1690,'ar','ØªØ­Ø¯ÙŠØ« Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(60834,1690,'fr','Modifier les termes de la facture',0),(60835,1690,'jp','è«‹æ±‚æ?¡ä»¶ã?®æ›´æ–°',0),(60836,1690,'pt','Editar a factura de termos',0),(60837,1690,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð°',0),(60838,1690,'es','TÃ©rminos de Factura Actualizar',0),(60839,1690,'de','Bearbeiten Rechnung Begriffe',0),(60840,1690,'en','Edit Invoice Terms',0),(60841,1691,'is','',0),(60842,1691,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(60843,1691,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(60844,1691,'tr','Fatura ÅŸartlarÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(60845,1691,'pl','Warunki faktury pomyÅ›lnie zaktualizowana',0),(60846,1691,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(60847,1691,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(60848,1691,'sr','Ð£ÑÐ»Ð¾Ð²Ð¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(60849,1691,'vi','Cáº­p Nháº­t Äiá»u Khoáº£n HÃ³a ÄÆ¡n thÃ nh cÃ´ng',0),(60850,1691,'af','Faktuur Terme suksesvol Opdateer',0),(60851,1691,'ro','Termeni de facturÄƒ actualizat cu succes',0),(60852,1691,'et','Arve tingimusi edukalt vÃ¤rskendatud',0),(60853,1691,'si','RaÄuna izraze uspeÅ¡no posodobljena',0),(60854,1691,'ba','Syarat-syarat faktur yang berhasil',0),(60855,1691,'nl','Factuur voorwaarden bijgewerkt',0),(60856,1691,'fi','Laskun ehtojen pÃ¤ivitetty',0),(60857,1691,'no','FaktureringsvilkÃ¥r oppdatert',0),(60858,1691,'da','Faktura vilkÃ¥r opdateret',0),(60859,1691,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì†¡ìž¥ ìš©ì–´',0),(60860,1691,'he','×ª× ××™ ×—×©×‘×•× ×™×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(60861,1691,'el','Î¤Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(60862,1691,'zh','å‘ç¥¨æ¡æ¬¾æ›´æ–°æˆåŠŸ\r\n',0),(60863,1691,'sv','Faktura villkoren uppdaterats',0),(60864,1691,'it','Termini di fattura aggiornati con successo',0),(60865,1691,'tl','',0),(60866,1691,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(60867,1691,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(60868,1691,'ms','Terma-terma invois yang berjaya dikemas kini',0),(60869,1691,'ar','Ø­Ø¯Ù‘Ø«Ù€Øª Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(60870,1691,'fr','Termes de facture correctement mis Ã  jour',0),(60871,1691,'jp','è«‹æ±‚æ?¡ä»¶ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(60872,1691,'pt','Termos de factura atualizados com sucesso',0),(60873,1691,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(60874,1691,'es','TÃ©rminos de Factura actualizados exitosamente',0),(60875,1691,'de','Rechnung Bedingungen erfolgreich aktualisiert',0),(60876,1691,'en','Invoice Terms updated successfully',0),(60877,1692,'is','',0),(60878,1692,'dr','Ø¬Ù…Ø¹ ÙØ§ÙƒØªÙˆØ±',0),(60879,1692,'pr','Ø¬Ù…Ø¹ ÙØ§ÙƒØªÙˆØ±',0),(60880,1692,'tr','Fatura toplam',0),(60881,1692,'pl','ÅÄ…czna kwota faktury',0),(60882,1692,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60883,1692,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ú©Ù„',0),(60884,1692,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(60885,1692,'vi','Tá»•ng cá»™ng hÃ³a Ä‘Æ¡n ',0),(60886,1692,'af','Faktuur Totaal',0),(60887,1692,'ro','Total factura',0),(60888,1692,'et','Arve kokku',0),(60889,1692,'si','Skupni znesek raÄuna.',0),(60890,1692,'ba','Total faktur',0),(60891,1692,'nl','Factuurtotaal',0),(60892,1692,'fi','Laskun summa',0),(60893,1692,'no','Fakturaens totalbelÃ¸p',0),(60894,1692,'da','Fakturatotalen',0),(60895,1692,'ko','ì²­êµ¬ì„œ í•©ê³„',0),(60896,1692,'he','×¡×›×•× ×—×©×‘×•× ×™×ª',0),(60897,1692,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(60898,1692,'zh','å‘ç¥¨æ±‡æ€»\r\n',0),(60899,1692,'sv','Fakturasumman',0),(60900,1692,'it','Totale fattura',0),(60901,1692,'tl','',0),(60902,1692,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60903,1692,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥à¤²',0),(60904,1692,'ms','Invois jumlah',0),(60905,1692,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(60906,1692,'fr','Total de la facture',0),(60907,1692,'jp','è«‹æ±‚æ›¸å?ˆè¨ˆ',0),(60908,1692,'pt','Total da factura',0),(60909,1692,'ru','Ð’ÑÐµÐ³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(60910,1692,'es','Factura Total',0),(60911,1692,'de','Rechnungssumme',0),(60912,1692,'en','Invoice Total',0),(60913,1693,'is','',0),(60914,1693,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(60915,1693,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(60916,1693,'tr','Fatura gÃ¼ncelleÅŸtirmesi',0),(60917,1693,'pl','Aktualizacji faktury',0),(60918,1693,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60919,1693,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(60920,1693,'sr','Ð£Ð¿Ð´Ð°Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60921,1693,'vi','Cáº­p Nháº­t HÃ³a ÄÆ¡n',0),(60922,1693,'af','Faktuur Opdateer',0),(60923,1693,'ro','FacturÄƒ Update',0),(60924,1693,'et','Arve uuendamist',0),(60925,1693,'si','Posodobitev raÄuna',0),(60926,1693,'ba','Faktur Update',0),(60927,1693,'nl','Factuur Update',0),(60928,1693,'fi','Laskun pÃ¤ivitys',0),(60929,1693,'no','Fakturaoppdatering',0),(60930,1693,'da','Fakturaopdatering',0),(60931,1693,'ko','ì†¡ìž¥ ì—…ë°ì´íŠ¸',0),(60932,1693,'he','×¢×“×›×•×Ÿ ×—×©×‘×•× ×™×ª',0),(60933,1693,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(60934,1693,'zh','å‘ç¥¨æ›´æ–°\r\n',0),(60935,1693,'sv','Fakturauppdatering',0),(60936,1693,'it','Aggiornamento di fattura',0),(60937,1693,'tl','',0),(60938,1693,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(60939,1693,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(60940,1693,'ms','Kemaskini invois',0),(60941,1693,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(60942,1693,'fr','Mise Ã  jour de la facture',0),(60943,1693,'jp','è«‹æ±‚æ›¸ã?®æ›´æ–°',0),(60944,1693,'pt','AtualizaÃ§Ã£o de factura',0),(60945,1693,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚',0),(60946,1693,'es','Factura Actualizar',0),(60947,1693,'de','Rechnung-Update',0),(60948,1693,'en','Invoice Update',0),(60949,1694,'is','',0),(60950,1694,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(60951,1694,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(60952,1694,'tr','Fatura baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(60953,1694,'pl','Faktura pomyÅ›lnie zaktualizowana',0),(60954,1694,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(60955,1694,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(60956,1694,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(60957,1694,'vi','Cáº­p Nháº­t HÃ³a ÄÆ¡n thÃ nh cÃ´ng',0),(60958,1694,'af','Faktuur suksesvol Opdateer',0),(60959,1694,'ro','FacturÄƒ actualizat cu succes',0),(60960,1694,'et','Arvega sisestatud edukalt',0),(60961,1694,'si','RaÄun uspeÅ¡no posodobljena',0),(60962,1694,'ba','Faktur yang berhasil',0),(60963,1694,'nl','Factuur bijgewerkt',0),(60964,1694,'fi','Laskun pÃ¤ivitys onnistui',0),(60965,1694,'no','Faktura oppdatert',0),(60966,1694,'da','Faktura opdateret',0),(60967,1694,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì†¡ìž¥',0),(60968,1694,'he','×—×©×‘×•× ×™×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(60969,1694,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(60970,1694,'zh','å‘ç¥¨å·²æˆåŠŸæ›´æ–°\r\n',0),(60971,1694,'sv','Faktura uppdaterats',0),(60972,1694,'it','Fattura aggiornato con successo',0),(60973,1694,'tl','',0),(60974,1694,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(60975,1694,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(60976,1694,'ms','Invois yang berjaya dikemas kini',0),(60977,1694,'ar','Ø­Ø¯Ù‘Ø«Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(60978,1694,'fr','Facture correctement mis Ã  jour',0),(60979,1694,'jp','è«‹æ±‚æ›¸ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(60980,1694,'pt','Fatura atualizada com sucesso',0),(60981,1694,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(60982,1694,'es','Factura Actualizada Exitosamente',0),(60983,1694,'de','Rechnung, die erfolgreich aktualisiert',0),(60984,1694,'en','Invoice Updated Successfully',0),(60985,1695,'is','',0),(60986,1695,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ± ØªØ¨Ø¯ÙŠÙ„ Ø´Ø¯',0),(60987,1695,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ± ØªØ¨Ø¯ÙŠÙ„ Ø´Ø¯',0),(60988,1695,'tr','SipariÅŸ faturaya baÅŸarÄ±yla deÄŸiÅŸtirildi',0),(60989,1695,'pl','PomyÅ›lnie zmieniono kolejnoÅ›Ä‡ do faktury',0),(60990,1695,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð±ÐµÑˆÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÐ½ ÐºÑŠÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(60991,1695,'ur','Ø¢Ø±ÚˆØ± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(60992,1695,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½ Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(60993,1695,'vi','ÄÆ¡n hÃ ng Ä‘á»•i sang hÃ³a Ä‘Æ¡n thÃ nh cÃ´ng',0),(60994,1695,'af','Bestelling Was Suksesvol Verander Na Faktuur',0),(60995,1695,'ro','Ordinul a fost modificat cu succes la factura',0),(60996,1695,'et','Tellimus on edukalt muudetud arve',0),(60997,1695,'si','Vrstni red je bil uspeÅ¡no spremenjen za fakturiranje',0),(60998,1695,'ba','Agar berhasil diubah menjadi faktur',0),(60999,1695,'nl','Orde werd met succes veranderd naar factuur',0),(61000,1695,'fi','Tilaus onnistui laskuun',0),(61001,1695,'no','RekkefÃ¸lgen ble endret til faktura',0),(61002,1695,'da','Ordren blev Ã¦ndret til faktura',0),(61003,1695,'ko','ì£¼ë¬¸ ì†¡ìž¥ì— ì„±ê³µì ìœ¼ë¡œ ë°”ë€Œì—ˆë‹¤',0),(61004,1695,'he','×¡×“×¨ ×©×•× ×ª×” ×‘×”×¦×œ×—×” ×—×©×‘×•× ×™×ª',0),(61005,1695,'el','Î£ÎµÎ¹ÏÎ¬ Î¬Î»Î»Î±Î¾Îµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± ÏƒÎµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(61006,1695,'zh','ä¸ºäº†æˆåŠŸåœ°æ›´æ”¹ä¸ºå‘ç¥¨\r\n',0),(61007,1695,'sv','Ordning har Ã¤ndrats till faktura',0),(61008,1695,'it','Ordine Ã¨ stato cambiato con successo in fattura',0),(61009,1695,'tl','',0),(61010,1695,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3648;&#3611;&#3655;&#3609;&#3',0),(61011,1695,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¦à¤² à¤¦à¤¿à¤¯à¤¾ à¤¥à¤¾',0),(61012,1695,'ms','Perintah telah berjaya ditukar kepada invois',0),(61013,1695,'ar','ØªÙ… ØªØºÙŠÙŠØ± Ø§Ù„Ù†Ø¸Ø§Ù… Ø¨Ù†Ø¬Ø§Ø­ Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(61014,1695,'fr','Ordre a Ã©tÃ© changÃ© avec succÃ¨s Ã  la facture',0),(61015,1695,'jp','æ³¨æ–‡ã?Œè«‹æ±‚æ›¸ã?«å¤‰æ›´ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(61016,1695,'pt','Ordem foi alterada com Ãªxito a factura',0),(61017,1695,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð±Ñ‹Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½ Ð½Ð° ÑÑ‡ÐµÑ‚Ð°',0),(61018,1695,'es','Orden Cambiado Exitosamente a Factura',0),(61019,1695,'de','Bestellung wurde erfolgreich auf Rechnung geÃ¤ndert.',0),(61020,1695,'en','Order Was Successfully Changed To Invoice',0),(61021,1696,'is','',0),(61022,1696,'dr','ÙƒØ§Ù„Ø§',0),(61023,1696,'pr','ÙƒØ§Ù„Ø§',0),(61024,1696,'tr','Madde',0),(61025,1696,'pl','Element',0),(61026,1696,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚',0),(61027,1696,'ur','Ø´Û’',0),(61028,1696,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ»Ð°',0),(61029,1696,'vi','HÃ ng',0),(61030,1696,'af','Item',0),(61031,1696,'ro','Element',0),(61032,1696,'et','Tooted',0),(61033,1696,'si','Element',0),(61034,1696,'ba','Item',0),(61035,1696,'nl','Item',0),(61036,1696,'fi','Kohde',0),(61037,1696,'no','Element',0),(61038,1696,'da','Varen',0),(61039,1696,'ko','í•­ëª©',0),(61040,1696,'he','×¤×¨×™×˜',0),(61041,1696,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(61042,1696,'zh','äº§å“',0),(61043,1696,'sv','Objekt',0),(61044,1696,'it','Elemento',0),(61045,1696,'tl','',0),(61046,1696,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(61047,1696,'hi','à¤†à¤‡à¤Ÿà¤®',0),(61048,1696,'ms','Item',0),(61049,1696,'ar','Ø§Ù„ØµÙ†Ù',0),(61050,1696,'fr','Ordre du jour',0),(61051,1696,'jp','å“?ç›®',0),(61052,1696,'pt','Item',0),(61053,1696,'ru','Ð¢Ð¾Ð²Ð°Ñ€',0),(61054,1696,'es','Item',0),(61055,1696,'de','Element',0),(61056,1696,'en','Item',0),(61057,1697,'is','',0),(61058,1697,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§',0),(61059,1697,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§',0),(61060,1697,'tr','Ã–ÄŸe Ekle',0),(61061,1697,'pl','Dodaj element',0),(61062,1697,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(61063,1697,'ur','Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(61064,1697,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(61065,1697,'vi','ThÃªm HÃ ng',0),(61066,1697,'af','Item Skep',0),(61067,1697,'ro','Adauga element',0),(61068,1697,'et','Toote lisamine',0),(61069,1697,'si','Dodajte element',0),(61070,1697,'ba','Tambahkan item',0),(61071,1697,'nl','Item toevoegen',0),(61072,1697,'fi','Kohteen lisÃ¤Ã¤minen',0),(61073,1697,'no','Elementet legger',0),(61074,1697,'da','Elementet TilfÃ¸j',0),(61075,1697,'ko','í•­ëª© ì¶”ê°€',0),(61076,1697,'he','×”×•×¡×¤×ª ×¤×¨×™×˜',0),(61077,1697,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(61078,1697,'zh','é¡¹ç›®æ–°å¢ž\r\n',0),(61079,1697,'sv','Artikel LÃ¤gg till',0),(61080,1697,'it','Aggiungi elemento',0),(61081,1697,'tl','',0),(61082,1697,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(61083,1697,'hi','à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(61084,1697,'ms','Menambah item',0),(61085,1697,'ar','Ø¥Ø¶Ø§ÙØ© ØµÙ†Ù',0),(61086,1697,'fr','Point ajouter',0),(61087,1697,'jp','å“?ç›®ã?®è¿½åŠ ',0),(61088,1697,'pt','Adicionar item',0),(61089,1697,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€',0),(61090,1697,'es','Item Agregar',0),(61091,1697,'de','Element hinzufÃ¼gen',0),(61092,1697,'en','Item Add',0),(61093,1698,'is','',0),(61094,1698,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(61095,1698,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(61096,1698,'tr','Ã–ÄŸe baÅŸarÄ±yla eklendi',0),(61097,1698,'pl','Pozycja dodana pomyÅ›lnie',0),(61098,1698,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(61099,1698,'ur','Ø´Û’ Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(61100,1698,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð´Ð¾Ð´Ð°Ñ‚Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(61101,1698,'vi','ThÃªm HÃ ng thÃ nh cÃ´ng',0),(61102,1698,'af','Item suksesvol Geskep',0),(61103,1698,'ro','Articol adÄƒugat cu succes',0),(61104,1698,'et','Toode lisati edukalt',0),(61105,1698,'si','Element dodan uspeÅ¡no',0),(61106,1698,'ba','Item yang ditambahkan berhasil',0),(61107,1698,'nl','Object met succes toegevoegd',0),(61108,1698,'fi','Kohteen lisÃ¤Ã¤minen onnistui',0),(61109,1698,'no','Elementet ble lagt til',0),(61110,1698,'da','Varen tilfÃ¸jet',0),(61111,1698,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ëœ í•­ëª©',0),(61112,1698,'he','×¤×¨×™×˜ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(61113,1698,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÏÎ¿ÏƒÏ„Î¯Î¸ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(61114,1698,'zh','é¡¹ç›®æˆåŠŸæ·»åŠ \r\n',0),(61115,1698,'sv','Objekt som lagts',0),(61116,1698,'it','Elemento aggiunto con successo',0),(61117,1698,'tl','',0),(61118,1698,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(61119,1698,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(61120,1698,'ms','Item yang berjaya menambah',0),(61121,1698,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(61122,1698,'fr','Ã‰lÃ©ment ajoutÃ© avec succÃ¨s',0),(61123,1698,'jp','å“?ç›®ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(61124,1698,'pt','Item adicionado com sucesso',0),(61125,1698,'ru','Ð¢Ð¾Ð²Ð°Ñ€ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(61126,1698,'es','Item agregado exitosamente',0),(61127,1698,'de','Element erfolgreich hinzugefÃ¼gt',0),(61128,1698,'en','Item added successfully',0),(61129,1699,'is','',0),(61130,1699,'dr','ÙƒØ§Ù„Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(61131,1699,'pr','ÙƒØ§Ù„Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(61132,1699,'tr','Ã–ÄŸe zaten',0),(61133,1699,'pl','Element juÅ¼ istnieje',0),(61134,1699,'bg','Ð’ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(61135,1699,'ur','Ø´Û’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(61136,1699,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(61137,1699,'vi','HÃ ng Ä‘Ã£ tá»“n táº¡i',0),(61138,1699,'af','Item bestaan alreeds',0),(61139,1699,'ro','Elementul existÄƒ deja',0),(61140,1699,'et','Toode on juba olemas',0),(61141,1699,'si','Element Å¾e obstaja',0),(61142,1699,'ba','Item sudah ada',0),(61143,1699,'nl','Item bestaat al',0),(61144,1699,'fi','Nimike on jo olemassa',0),(61145,1699,'no','Elementet finnes allerede',0),(61146,1699,'da','Varen findes allerede',0),(61147,1699,'ko','í•­ëª©ì´ ì´ë¯¸ ì¡´ìž¬',0),(61148,1699,'he','×¤×¨×™×˜ ×›×‘×¨ ×§×™×™×',0),(61149,1699,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î¿Ï… Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(61150,1699,'zh','é¡¹ç›®å·²ç»å­˜åœ¨\r\n',0),(61151,1699,'sv','Objektet finns redan',0),(61152,1699,'it','Elemento giÃ  esistente',0),(61153,1699,'tl','',0),(61154,1699,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(61155,1699,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(61156,1699,'ms','Item telah wujud',0),(61157,1699,'ar','Ø§Ù„ØµÙ†Ù Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(61158,1699,'fr','Ã‰lÃ©ment existe dÃ©jÃ ',0),(61159,1699,'jp','å“?ç›®ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(61160,1699,'pt','Item jÃ¡ existe',0),(61161,1699,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(61162,1699,'es','Item ya existe',0),(61163,1699,'de','Element ist bereits vorhanden',0),(61164,1699,'en','Item already exists',0),(61165,1700,'is','',0),(61166,1700,'dr','Ø¨Ø§Ø±ÙƒØ¯ ÙƒØ§Ù„Ø§ ',0),(61167,1700,'pr','Ø¨Ø§Ø±ÙƒØ¯ ÙƒØ§Ù„Ø§ ',0),(61168,1700,'tr','Maddenin barkod',0),(61169,1700,'pl','Kod kreskowy zapasu',0),(61170,1700,'bg','Ð‘Ð°Ñ€ÐºÐ¾Ð´ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(61171,1700,'ur','Ø´Û’ Ø¨Ø§Ø±Ú©ÙˆÚˆ',0),(61172,1700,'sr','Ð‘Ð°Ñ€ ÐºÐ¾Ð´Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(61173,1700,'vi','MÃ£ váº¡ch hÃ ng',0),(61174,1700,'af','Item Strepieskode',0),(61175,1700,'ro','Element de coduri de bare',0),(61176,1700,'et','Toote ribakood',0),(61177,1700,'si','ÄŒrtno kodo artikla',0),(61178,1700,'ba','Barang Barcode',0),(61179,1700,'nl','Item Barcode',0),(61180,1700,'fi','Nimikkeen viivakoodi',0),(61181,1700,'no','Vare-strekkode',0),(61182,1700,'da','Vare stregkode',0),(61183,1700,'ko','í’ˆëª© ë°”ì½”ë“œ',0),(61184,1700,'he','×¤×¨×™×˜ ×‘×¨×§×•×“',0),(61185,1700,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Barcode',0),(61186,1700,'zh','ç‰©å“æ¡ç \r\n',0),(61187,1700,'sv','Objektet streckkod',0),(61188,1700,'it','Elemento di codice a barre',0),(61189,1700,'tl','',0),(61190,1700,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3634;&#3619;&#3660;&#3650;&#3588;&#3657;&#3604;',0),(61191,1700,'hi','à¤†à¤‡à¤Ÿà¤® à¤¬à¤¾à¤°à¤•à¥‹à¤¡',0),(61192,1700,'ms','Item Kod Bar',0),(61193,1700,'ar','Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠ',0),(61194,1700,'fr','Item Barcode',0),(61195,1700,'jp','å“?ç›®ãƒ?ãƒ¼ã‚³ãƒ¼ãƒ‰',0),(61196,1700,'pt','Item cÃ³digo de barras',0),(61197,1700,'ru','Ð¨Ñ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(61198,1700,'es','Item CÃ³digo de Barras',0),(61199,1700,'de','Element-Barcode',0),(61200,1700,'en','Item Barcode',0),(61201,1701,'is','',0),(61202,1701,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(61203,1701,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(61204,1701,'tr','Madde kategorileri',0),(61205,1701,'pl','Kategorie towarÃ³w',0),(61206,1701,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(61207,1701,'ur','Ø´Û’ Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(61208,1701,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(61209,1701,'vi','Thá»ƒ loáº¡i hÃ ng',0),(61210,1701,'af','Item KategoriÃ«',0),(61211,1701,'ro','Articolul Categorii',0),(61212,1701,'et','Tootekategooriad',0),(61213,1701,'si','Kategorijah artiklov',0),(61214,1701,'ba','Kategori barang',0),(61215,1701,'nl','ArtikelcategorieÃ«n',0),(61216,1701,'fi','Nimikekategoriat',0),(61217,1701,'no','Kategorier',0),(61218,1701,'da','Varekategorier',0),(61219,1701,'ko','í•­ëª© ë²”ì£¼',0),(61220,1701,'he','×§×˜×’×•×¨×™×•×ª ×¤×¨×™×˜',0),(61221,1701,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ ÎµÎ¹Î´ÏŽÎ½',0),(61222,1701,'zh','é¡¹ç›®ç±»åˆ«\r\n',0),(61223,1701,'sv','Artikelkategorier',0),(61224,1701,'it','Articolo categorie',0),(61225,1701,'tl','',0),(61226,1701,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(61227,1701,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(61228,1701,'ms','Kategori item',0),(61229,1701,'ar','ÙØ¦Ø§Øª Ø§Ù„ØµÙ†Ù',0),(61230,1701,'fr','CatÃ©gories d\'articles',0),(61231,1701,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(61232,1701,'pt','Categorias de item',0),(61233,1701,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(61234,1701,'es','Item CategorÃ­as',0),(61235,1701,'de','Positionstypen',0),(61236,1701,'en','Item Categories',0),(61237,1702,'is','',0),(61238,1702,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ ',0),(61239,1702,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ ',0),(61240,1702,'tr','Arama kategorileri',0),(61241,1702,'pl','Szukaj Kategorie',0),(61242,1702,'bg','Ð¢ÑŠÑ€ÑÐ¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(61243,1702,'ur','ØªÙ„Ø§Ø´ Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(61244,1702,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(61245,1702,'vi','Thá»ƒ loáº¡i tÃ¬m kiáº¿m',0),(61246,1702,'af','Soek KategoriÃ«',0),(61247,1702,'ro','Categorii de cÄƒutare',0),(61248,1702,'et','Tootekategooria otsing',0),(61249,1702,'si','IÅ¡Äi kategorije',0),(61250,1702,'ba','Cari Kategori',0),(61251,1702,'nl','ZoekcategorieÃ«n',0),(61252,1702,'fi','Etsi Kategoriat',0),(61253,1702,'no','SÃ¸k etter kategori',0),(61254,1702,'da','Ransage kategorier',0),(61255,1702,'ko','ê²€ìƒ‰ ì¹´í…Œê³ ë¦¬',0),(61256,1702,'he','×—×¤×© ×‘×§×˜×’×•×¨×™×•×ª',0),(61257,1702,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¹ÏŽÎ½',0),(61258,1702,'zh','æœç´¢ç±»åˆ«\r\n',0),(61259,1702,'sv','SÃ¶kkategorier',0),(61260,1702,'it','Categorie di ricerca',0),(61261,1702,'tl','',0),(61262,1702,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(61263,1702,'hi','à¤–à¥‹à¤œ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(61264,1702,'ms','Kategori carian',0),(61265,1702,'ar','ÙØ¦Ø§Øª Ø§Ù„Ø¨Ø­Ø«',0),(61266,1702,'fr','CatÃ©gories de recherche',0),(61267,1702,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼æ¤œç´¢',0),(61268,1702,'pt','Pesquisar categorias',0),(61269,1702,'ru','ÐŸÐ¾Ð¸ÑÐº ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(61270,1702,'es','Busqueda CategorÃ­as',0),(61271,1702,'de','Suchkategorien',0),(61272,1702,'en','Search Categories',0),(61273,1703,'is','',0),(61274,1703,'dr','Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§',0),(61275,1703,'pr','Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§',0),(61276,1703,'tr','Madde kategorisi',0),(61277,1703,'pl','Kategorii zapasu',0),(61278,1703,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(61279,1703,'ur','Ø´Û’ Ø²Ù…Ø±Û',0),(61280,1703,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(61281,1703,'vi','Thá»ƒ loáº¡i hÃ ng',0),(61282,1703,'af','Item Kategorie',0),(61283,1703,'ro','Categorie de articole',0),(61284,1703,'et','Tootekategooria',0),(61285,1703,'si','Kategoriji artikla',0),(61286,1703,'ba','Kategori barang',0),(61287,1703,'nl','Artikelcategorie',0),(61288,1703,'fi','Nimikekategorian',0),(61289,1703,'no','Varekategori',0),(61290,1703,'da','Varekategori',0),(61291,1703,'ko','í•­ëª© ë²”ì£¼',0),(61292,1703,'he','×§×˜×’×•×¨×™×ª ×¤×¨×™×˜',0),(61293,1703,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ¹Î´ÏŽÎ½',0),(61294,1703,'zh','é¡¹ç›®ç±»åˆ«\r\n',0),(61295,1703,'sv','Artikelkategori',0),(61296,1703,'it','Categoria elemento',0),(61297,1703,'tl','',0),(61298,1703,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(61299,1703,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€',0),(61300,1703,'ms','Kategori item',0),(61301,1703,'ar','ØªØµÙ†ÙŠÙ Ø§Ù„ØµÙ†Ù',0),(61302,1703,'fr','CatÃ©gorie de l\'Ã©lÃ©ment',0),(61303,1703,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(61304,1703,'pt','Categoria de item',0),(61305,1703,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(61306,1703,'es','Item CategorÃ­a',0),(61307,1703,'de','Positionstyp',0),(61308,1703,'en','Item Category',0),(61309,1704,'is','',0),(61310,1704,'dr','Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(61311,1704,'pr','Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(61312,1704,'tr','Madde kategorisi baÅŸarÄ±yla eklendi.',0),(61313,1704,'pl','Kategorii dodane pomyÅ›lnie.',0),(61314,1704,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ», Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(61315,1704,'ur','Ø²Ù…Ø±Û Ø´Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(61316,1704,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(61317,1704,'vi','ThÃªm Thá»ƒ loáº¡i hÃ ng thÃ nh cÃ´ng',0),(61318,1704,'af','Item Kategorie suksesvol geskep',0),(61319,1704,'ro','Categorie de articole adÄƒugat cu succes.',0),(61320,1704,'et','Tootekategooria lisati edukalt',0),(61321,1704,'si','Kategoriji artikla uspeÅ¡no dodana.',0),(61322,1704,'ba','Kategori item ditambahkan berhasil.',0),(61323,1704,'nl','Rubriek van het object met succes toegevoegd.',0),(61324,1704,'fi','Luokan lisÃ¤Ã¤minen onnistui.',0),(61325,1704,'no','Varekategori lagt.',0),(61326,1704,'da','Varekategori tilfÃ¸jet.',0),(61327,1704,'ko','í•­ëª© ë²”ì£¼ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(61328,1704,'he','.×§×˜×’×•×¨×™×™×ª ×¤×¨×™×˜ × ×•×¡×¤×” ×‘×”×¦×œ×—×”',0),(61329,1704,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(61330,1704,'zh','é¡¹ç›®ç±»åˆ«æ·»åŠ æˆåŠŸã€‚\r\n',0),(61331,1704,'sv','Artikelkategori lagts.',0),(61332,1704,'it','Categoria dell\'elemento aggiunto con successo.',0),(61333,1704,'tl','',0),(61334,1704,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(61335,1704,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(61336,1704,'ms','Item kategori berjaya menambah.',0),(61337,1704,'ar','Ø£Ø¶ÙŠÙ ØªØµÙ†ÙŠÙ Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(61338,1704,'fr','CatÃ©gorie d\'Ã©lÃ©ment ajoutÃ©e avec succÃ¨s.',0),(61339,1704,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(61340,1704,'pt','Categoria de item adicionada com sucesso.',0),(61341,1704,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¢Ð¾Ð²Ð°Ñ€Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°.',0),(61342,1704,'es','Item categorÃ­a agregada exitosamente',0),(61343,1704,'de','Positionstyp erfolgreich hinzugefÃ¼gt.',0),(61344,1704,'en','Item category added successfully.',0),(61345,1705,'is','',0),(61346,1705,'dr','Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(61347,1705,'pr','Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(61348,1705,'tr','Madde kategorisi baÅŸarÄ±yla silindi.',0),(61349,1705,'pl','Kategoria element usuniÄ™ty pomyÅ›lnie.',0),(61350,1705,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(61351,1705,'ur','Ø²Ù…Ø±Û Ø´Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(61352,1705,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(61353,1705,'vi','XÃ³a Thá»ƒ loáº¡i hÃ ng thÃ nh cÃ´ng',0),(61354,1705,'af','Item Kategorie suksesvol geskrap',0),(61355,1705,'ro','Categorie de articole de ÅŸters cu succes.',0),(61356,1705,'et','Tootekategooria kustutati edukalt',0),(61357,1705,'si','Kategoriji artikla uspeÅ¡no izbrisana.',0),(61358,1705,'ba','Kategori item dihapus berhasil.',0),(61359,1705,'nl','Rubriek van het object met succes verwijderd.',0),(61360,1705,'fi','Nimikekategorian poistettu.',0),(61361,1705,'no','Varekategori slettet.',0),(61362,1705,'da','Varekategori slettet.',0),(61363,1705,'ko','í•­ëª© ë²”ì£¼ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(61364,1705,'he','×§×˜×’×•×¨×™×™×ª ×”×¤×¨×™×˜ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(61365,1705,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ¹Î´ÏŽÎ½ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(61366,1705,'zh','é¡¹ç›®ç±»åˆ«å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(61367,1705,'sv','Artikelkategori raderades.',0),(61368,1705,'it','Categoria dell\'elemento eliminato con successo.',0),(61369,1705,'tl','',0),(61370,1705,'th','&#3621;&#3610;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(61371,1705,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(61372,1705,'ms','Kategori item dihapuskan dengan jayanya.',0),(61373,1705,'ar','Ø­Ø°Ù ØªØµÙ†ÙŠÙ Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(61374,1705,'fr','CatÃ©gorie d\'Ã©lÃ©ment supprimÃ©e avec succÃ¨s.',0),(61375,1705,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(61376,1705,'pt','Categoria de item excluÃ­da com sucesso.',0),(61377,1705,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð°.',0),(61378,1705,'es','Item categorÃ­a eliminada exitosamente',0),(61379,1705,'de','Positionstyp erfolgreich gelÃ¶scht.',0),(61380,1705,'en','Item category deleted successfully.',0),(61381,1706,'is','',0),(61382,1706,'dr','Ù„ÙŠØ³Øª Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§',0),(61383,1706,'pr','Ù„ÙŠØ³Øª Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§',0),(61384,1706,'tr','Madde Kategori Listesi',0),(61385,1706,'pl','Lista kategorii elementÃ³w',0),(61386,1706,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸Ñ‚Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(61387,1706,'ur','Ø´Û’ Ø²Ù…Ø±Û ÙÛØ±Ø³Øª',0),(61388,1706,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(61389,1706,'vi','Danh sÃ¡ch thá»ƒ loáº¡i hÃ ng',0),(61390,1706,'af','Item Kategorie Lys',0),(61391,1706,'ro','Lista de categorie articol',0),(61392,1706,'et','Tootekategooria nimekiri',0),(61393,1706,'si','Element seznama zvrsti',0),(61394,1706,'ba','Daftar kategori item',0),(61395,1706,'nl','Categorie itemlijst',0),(61396,1706,'fi','Luokka Nimikeluettelo',0),(61397,1706,'no','Elementet kategorilisten',0),(61398,1706,'da','Kategori elementlisten',0),(61399,1706,'ko','í•­ëª© ë²”ì£¼ ëª©ë¡',0),(61400,1706,'he','×¨×©×™×ž×ª ×”×§×˜×’×•×¨×™×•×ª ×”×¤×¨×™×˜',0),(61401,1706,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ¹Î´ÏŽÎ½',0),(61402,1706,'zh','é¡¹ç›®åˆ†ç±»åˆ—è¡¨\r\n',0),(61403,1706,'sv','Kategori Artikellista',0),(61404,1706,'it','Elenco di elementi di categoria',0),(61405,1706,'tl','',0),(61406,1706,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(61407,1706,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¥‚à¤šà¥€',0),(61408,1706,'ms','Senarai kategori barangan',0),(61409,1706,'ar','Ù‚Ø§Ø¦Ù…Ø© ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„ØµÙ†Ù',0),(61410,1706,'fr','Liste d\'Ã©lÃ©ments de catÃ©gorie',0),(61411,1706,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ãƒªã‚¹ãƒˆ',0),(61412,1706,'pt','Lista de categoria de item',0),(61413,1706,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(61414,1706,'es','Item CategorÃ­a Lista',0),(61415,1706,'de','Artikelliste der Kategorie',0),(61416,1706,'en','Item Category List',0),(61417,1707,'is','',0),(61418,1707,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§',0),(61419,1707,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§',0),(61420,1707,'tr','Madde Kategori gÃ¼ncelleÅŸtirme',0),(61421,1707,'pl','Element kategorii aktualizacji',0),(61422,1707,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(61423,1707,'ur','Ø´Û’ Ø²Ù…Ø±Û ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(61424,1707,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(61425,1707,'vi','Cáº­p Nháº­t Thá»ƒ Loáº¡i Danh Má»¥c',0),(61426,1707,'af','Item Kategorie Opdateer',0),(61427,1707,'ro','Actualizare la categoria',0),(61428,1707,'et','Tootekategooria uuendamine',0),(61429,1707,'si','Element Kategorija posodobitev',0),(61430,1707,'ba','Item kategori Update',0),(61431,1707,'nl','Item categorie Update',0),(61432,1707,'fi','Kohteen luokka pÃ¤ivitys',0),(61433,1707,'no','Elementet kategori oppdatering',0),(61434,1707,'da','Vare kategori opdatering',0),(61435,1707,'ko','ì•„ì´í…œ ì¹´í…Œê³ ë¦¬ ì—…ë°ì´íŠ¸',0),(61436,1707,'he','×¢×“×›×•×Ÿ ×§×˜×’×•×¨×™×™×ª ×¤×¨×™×˜',0),(61437,1707,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(61438,1707,'zh','é¡¹ç›®ç±»åˆ«æ›´æ–°\r\n',0),(61439,1707,'sv','Objektet kategori uppdatering',0),(61440,1707,'it','Aggiornamento categoria oggetti',0),(61441,1707,'tl','',0),(61442,1707,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(61443,1707,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(61444,1707,'ms','Kemaskini kategori item',0),(61445,1707,'ar','ØªØ­Ø¯ÙŠØ« ØªØµÙ†ÙŠÙ Ø§Ù„ØµÙ†Ù',0),(61446,1707,'fr','Mise Ã  jour de la catÃ©gorie point',0),(61447,1707,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®æ›´æ–°',0),(61448,1707,'pt','ActualizaÃ§Ã£o de categoria do item',0),(61449,1707,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(61450,1707,'es','Item CategorÃ­a Actualizar',0),(61451,1707,'de','Artikel-Kategorie-Update',0),(61452,1707,'en','Item Category Update',0),(61453,1708,'is','',0),(61454,1708,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(61455,1708,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(61456,1708,'tr','Madde kategorisi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(61457,1708,'pl','Kategorii pomyÅ›lnie zaktualizowana.',0),(61458,1708,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(61459,1708,'ur','Ø²Ù…Ø±Û Ø´Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(61460,1708,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(61461,1708,'vi','Cáº­p Nháº­t Thá»ƒ Loáº¡i Danh Má»¥c thÃ nh cÃ´ng',0),(61462,1708,'af','Item Kategorie suksesvol Opdateer',0),(61463,1708,'ro','Categorie articol actualizat cu succes.',0),(61464,1708,'et','Tootekategooria uuendati edukalt',0),(61465,1708,'si','Kategoriji artikla je uspeÅ¡no posodobljena.',0),(61466,1708,'ba','Kategori barang yang berhasil.',0),(61467,1708,'nl','Rubriek van het object met succes bijgewerkt.',0),(61468,1708,'fi','Nimikekategorian pÃ¤ivitettiin onnistuneesti.',0),(61469,1708,'no','Varekategori oppdatert.',0),(61470,1708,'da','Varekategori opdateret.',0),(61471,1708,'ko','í•­ëª© ë²”ì£¼ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(61472,1708,'he','×§×˜×’×•×¨×™×™×ª ×”×¤×¨×™×˜ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(61473,1708,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ¹Î´ÏŽÎ½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(61474,1708,'zh','é¡¹ç›®ç±»åˆ«æ›´æ–°æˆåŠŸã€‚\r\n',0),(61475,1708,'sv','Artikelkategori uppdaterats.',0),(61476,1708,'it','Categoria elemento aggiornato con successo.',0),(61477,1708,'tl','',0),(61478,1708,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(61479,1708,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(61480,1708,'ms','Item kategori berjaya dikemas kini.',0),(61481,1708,'ar','Ø­Ø¯Ù‘Ø« ØªØµÙ†ÙŠÙ Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(61482,1708,'fr','CatÃ©gorie d\'article mis Ã  jour avec succÃ¨s.',0),(61483,1708,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(61484,1708,'pt','Categoria de item atualizada com Ãªxito.',0),(61485,1708,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¢Ð¾Ð²Ð°Ñ€Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°.',0),(61486,1708,'es','Item categorÃ­a actualizada exitosamente',0),(61487,1708,'de','Positionstyp erfolgreich aktualisiert.',0),(61488,1708,'en','Item category updated successfully.',0),(61489,1709,'is','',0),(61490,1709,'dr','ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(61491,1709,'pr','ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(61492,1709,'tr','Madde kodu',0),(61493,1709,'pl','Kod towaru',0),(61494,1709,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(61495,1709,'ur','Ø´Û’ Ú©ÙˆÚˆ',0),(61496,1709,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(61497,1709,'vi','MÃ£ hÃ ng',0),(61498,1709,'af','Itemkode',0),(61499,1709,'ro','Cod articol',0),(61500,1709,'et','Tootekood',0),(61501,1709,'si','Å ifra artikla',0),(61502,1709,'ba','Kode barang',0),(61503,1709,'nl','Artikelcode',0),(61504,1709,'fi','Nimikkeen koodi',0),(61505,1709,'no','Varekode',0),(61506,1709,'da','Varekode',0),(61507,1709,'ko','í•­ëª© ì½”ë“œ',0),(61508,1709,'he','×§×•×“ ×¤×¨×™×˜',0),(61509,1709,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚',0),(61510,1709,'zh','äº§å“ä»£ç \r\n',0),(61511,1709,'sv','Artikelkod',0),(61512,1709,'it','Codice articolo',0),(61513,1709,'tl','',0),(61514,1709,'th','&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(61515,1709,'hi','à¤®à¤¦ à¤•à¥‹à¤¡',0),(61516,1709,'ms','Kod item',0),(61517,1709,'ar','Ø±Ù…Ø² Ø§Ù„ØµÙ†Ù',0),(61518,1709,'fr','Code article',0),(61519,1709,'jp','å“?ç›®ã‚³ãƒ¼ãƒ‰',0),(61520,1709,'pt','CÃ³digo do artigo',0),(61521,1709,'ru','ÐšÐ¾Ð´ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(61522,1709,'es','Item CÃ³digo',0),(61523,1709,'de','Artikelcode',0),(61524,1709,'en','Item Code',0),(61525,1710,'is','',0),(61526,1710,'dr','ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(61527,1710,'pr','ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(61528,1710,'tr','MADDE KODU',0),(61529,1710,'pl','KOD TOWARU',0),(61530,1710,'bg','ÐšÐžÐ” ÐÐ ÐÐ Ð¢Ð˜ÐšÐ£Ð›',0),(61531,1710,'ur','Ø´Û’ Ú©ÙˆÚˆ',0),(61532,1710,'sr','Ð¨Ð˜Ð¤Ð Ð ÐÐ Ð¢Ð˜ÐšÐ›Ð',0),(61533,1710,'vi','MÃ£ HÃ ng',0),(61534,1710,'af','ITEMKODE',0),(61535,1710,'ro','COD ARTICOL',0),(61536,1710,'et','TOOTEKOOD',0),(61537,1710,'si','Å IFRA ARTIKLA',0),(61538,1710,'ba','KODE BARANG',0),(61539,1710,'nl','ARTIKELCODE',0),(61540,1710,'fi','NIMIKKEEN KOODI',0),(61541,1710,'no','VAREKODE',0),(61542,1710,'da','VAREKODE',0),(61543,1710,'ko','í•­ëª© ì½”ë“œ',0),(61544,1710,'he','×§×•×“ ×¤×¨×™×˜',0),(61545,1710,'el','ÎšÎ©Î”Î™ÎšÎŒÎ£',0),(61546,1710,'zh','äº§å“ä»£ç \r\n',0),(61547,1710,'sv','ARTIKELKOD',0),(61548,1710,'it','CODICE ARTICOLO',0),(61549,1710,'tl','',0),(61550,1710,'th','ITEM CODE',0),(61551,1710,'hi','à¤®à¤¦ à¤•à¥‹à¤¡',0),(61552,1710,'ms','KOD ITEM',0),(61553,1710,'ar','Ø±Ù…Ø² Ø§Ù„ØµÙ†Ù',0),(61554,1710,'fr','CODE ARTICLE',0),(61555,1710,'jp','å“?ç›®ã‚³ãƒ¼ãƒ‰',0),(61556,1710,'pt','CÃ“DIGO DO ARTIGO',0),(61557,1710,'ru','ÐšÐžÐ” Ð¢ÐžÐ’ÐÐ Ð',0),(61558,1710,'es','ITEM CÃ“DIGO',0),(61559,1710,'de','ARTIKELCODE',0),(61560,1710,'en','ITEM CODE',0),(61561,1711,'is','',0),(61562,1711,'dr','ÙƒØ§Ù„Ø§ Ø­Ø°Ù Ø´Ø¯ ',0),(61563,1711,'pr','ÙƒØ§Ù„Ø§ Ø­Ø°Ù Ø´Ø¯ ',0),(61564,1711,'tr','SÄ°LÄ°NMÄ°Åž Ã–ÄžE',0),(61565,1711,'pl','ELEMENT USUNIÄ˜TY',0),(61566,1711,'bg','Ð˜Ð—Ð¢Ð Ð˜Ð¢ Ð•Ð›Ð•ÐœÐ•ÐÐ¢',0),(61567,1711,'ur','Ø´Û’ Ø­Ø°Ù Ù†ÛÛŒÚº Ú©ÛŒ',0),(61568,1711,'sr','Ð˜Ð—Ð‘Ð Ð˜Ð¡ÐÐ¢Ð˜ Ð¡Ð¢ÐÐ’ÐšÐ£',0),(61569,1711,'vi','XÃ³a HÃ ng',0),(61570,1711,'af','ITEM GESKRAP',0),(61571,1711,'ro','ELEMENT ÅžTERS',0),(61572,1711,'et','TOODE KUSTUTATUD',0),(61573,1711,'si','ELEMENT IZBRISAN',0),(61574,1711,'ba','ITEM DIHAPUS',0),(61575,1711,'nl','ITEM VERWIJDERD',0),(61576,1711,'fi','KOHTEEN POISTAMINEN',0),(61577,1711,'no','ELEMENTET SLETTET',0),(61578,1711,'da','ELEMENT SLETTET',0),(61579,1711,'ko','í•­ëª© ì‚­ì œ',0),(61580,1711,'he','×œ×ž×—×•×§ ××ª ×¤×¨×™×˜',0),(61581,1711,'el','Î£Î¤ÎŸÎ™Î§Î•ÎŠÎŸ Î”Î™Î‘Î“Î¡Î†Î¦Î•Î¤Î‘Î™',0),(61582,1711,'zh','åˆ é™¤çš„é¡¹ç›®\r\n',0),(61583,1711,'sv','OBJEKTET BORT',0),(61584,1711,'it','ELEMENTO ELIMINATO',0),(61585,1711,'tl','',0),(61586,1711,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3621;&#3657;&#3623;',0),(61587,1711,'hi','à¤†à¤‡à¤Ÿà¤® à¤¹à¤Ÿà¤¾à¤ à¤—à¤',0),(61588,1711,'ms','ITEM DIHAPUSKAN',0),(61589,1711,'ar','Ø§Ù„ØµÙ†Ù Ù…Ø­Ø°ÙˆÙ',0),(61590,1711,'fr','Ã‰LÃ‰MENT SUPPRIMÃ‰',0),(61591,1711,'jp','å“?ç›®ã?®æ¶ˆåŽ»',0),(61592,1711,'pt','ITEM EXCLUÃDO',0),(61593,1711,'ru','Ð¢ÐžÐ’ÐÐ  Ð£Ð”ÐÐ›Ð•Ð',0),(61594,1711,'es','ITEM ELIMINADO',0),(61595,1711,'de','ELEMENT GELÃ–SCHT',0),(61596,1711,'en','ITEM DELETED',0),(61597,1712,'is','',0),(61598,1712,'dr','ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(61599,1712,'pr','ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(61600,1712,'tr','Madde baÅŸarÄ±yla silindi',0),(61601,1712,'pl','Element usuniÄ™ty',0),(61602,1712,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ», Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(61603,1712,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø´Ø¯Û Ø¢Ø¦Ù¹Ù…',0),(61604,1712,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(61605,1712,'vi','XÃ³a HÃ ng thÃ nh cÃ´ng',0),(61606,1712,'af','Item suksesvol Geskrap',0),(61607,1712,'ro','Element ÅŸters cu succes',0),(61608,1712,'et','Toode kustutati edukalt',0),(61609,1712,'si','Element uspeÅ¡no izbrisana',0),(61610,1712,'ba','Item dihapus berhasil',0),(61611,1712,'nl','Item met succes verwijderd',0),(61612,1712,'fi','Kohde poistettu',0),(61613,1712,'no','Elementet ble slettet',0),(61614,1712,'da','Element slettet',0),(61615,1712,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•­ëª©',0),(61616,1712,'he','×¤×¨×™×˜ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(61617,1712,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(61618,1712,'zh','é¡¹ç›®æˆåŠŸåˆ é™¤\r\n',0),(61619,1712,'sv','Objektet raderades',0),(61620,1712,'it','Elemento eliminato con successo',0),(61621,1712,'tl','',0),(61622,1712,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(61623,1712,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤†à¤‡à¤Ÿà¤®',0),(61624,1712,'ms','Item yang dihapuskan dengan jayanya',0),(61625,1712,'ar','Ø­Ø°Ù Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(61626,1712,'fr','Ã‰lÃ©ment supprimÃ© avec succÃ¨s',0),(61627,1712,'jp','å“?ç›®ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(61628,1712,'pt','Item excluÃ­do com Ãªxito',0),(61629,1712,'ru','Ð¢Ð¾Ð²Ð°Ñ€ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½',0),(61630,1712,'es','Item Eliminado Exitosamente',0),(61631,1712,'de','Element erfolgreich gelÃ¶scht',0),(61632,1712,'en','Item Deleted Successfully',0),(61633,1713,'is','',0),(61634,1713,'dr','Ø´Ø±Ø­ ÙƒØ§Ù„Ø§ ',0),(61635,1713,'pr','Ø´Ø±Ø­ ÙƒØ§Ù„Ø§ ',0),(61636,1713,'tr','Madde aÃ§Ä±klamasÄ±',0),(61637,1713,'pl','Opis przedmiotu',0),(61638,1713,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(61639,1713,'ur','Ø´Û’ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(61640,1713,'sr','ÐžÐ¿Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(61641,1713,'vi','MÃ´ táº£ hÃ ng',0),(61642,1713,'af','Item Beskrywings',0),(61643,1713,'ro','Descriere element',0),(61644,1713,'et','Toote kirjeldus',0),(61645,1713,'si','Opis artikla',0),(61646,1713,'ba','Deskripsi item',0),(61647,1713,'nl','Objectbeschrijving uitbreiden',0),(61648,1713,'fi','Nimikkeen kuvaus',0),(61649,1713,'no','Varebeskrivelse',0),(61650,1713,'da','Varebeskrivelse',0),(61651,1713,'ko','í•­ëª© ì„¤ëª…',0),(61652,1713,'he','×ª×™××•×¨ ×¤×¨×™×˜',0),(61653,1713,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(61654,1713,'zh','äº§å“æè¿°',0),(61655,1713,'sv','Artikelbeskrivning',0),(61656,1713,'it','Descrizione articolo',0),(61657,1713,'tl','',0),(61658,1713,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(61659,1713,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£',0),(61660,1713,'ms','Keterangan item',0),(61661,1713,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„ØµÙ†Ù',0),(61662,1713,'fr','Description de l\'objet',0),(61663,1713,'jp','å“?ç›®èª¬æ˜Ž',0),(61664,1713,'pt','DescriÃ§Ã£o do item',0),(61665,1713,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(61666,1713,'es','Item DescripciÃ³n',0),(61667,1713,'de','Artikelbeschreibung',0),(61668,1713,'en','Item Description',0),(61669,1714,'is','',0),(61670,1714,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ§Ø±ÙŠØ®Ú†Ù‡  ÙƒØ§Ù„Ø§',0),(61671,1714,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ§Ø±ÙŠØ®Ú†Ù‡  ÙƒØ§Ù„Ø§',0),(61672,1714,'tr','Ã–ÄžE AYRINTILARI',0),(61673,1714,'pl','SZCZEGÃ“ÅY POZYCJI',0),(61674,1714,'bg','ÐŸÐžÐ”Ð ÐžÐ‘ÐÐ˜Ð¢Ð• Ð”ÐÐÐÐ˜ Ð—Ð Ð•Ð›Ð•ÐœÐ•ÐÐ¢Ð',0),(61675,1714,'ur','Ø´Û’ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(61676,1714,'sr','Ð”Ð•Ð¢ÐÐ‰Ð˜ Ð¡Ð¢ÐÐ’ÐšÐ•',0),(61677,1714,'vi','Chi tiáº¿t hÃ ng',0),(61678,1714,'af','ITEM DETAILS',0),(61679,1714,'ro','ELEMENT DETALII',0),(61680,1714,'et','TOOTE DETAILID',0),(61681,1714,'si','PODROBNOSTI O ELEMENTU',0),(61682,1714,'ba','RINCIAN ITEM',0),(61683,1714,'nl','OBJECTGEGEVENS',0),(61684,1714,'fi','KOHTEEN TIEDOT',0),(61685,1714,'no','DETALJER',0),(61686,1714,'da','VAREDETALJER',0),(61687,1714,'ko','í•­ëª© ì„¸ë¶€ ì •ë³´',0),(61688,1714,'he','×¤×¨×˜×™ ×¤×¨×™×˜',0),(61689,1714,'el','Î›Î•Î Î¤ÎŸÎœÎˆÎ¡Î•Î™Î•Î£ Î£Î¤ÎŸÎ™Î§Î•ÎŠÎŸÎ¥',0),(61690,1714,'zh','é¡¹ç›®è¯¦ç»†\r\n',0),(61691,1714,'sv','ARTIKELDETALJER',0),(61692,1714,'it','DETTAGLI ELEMENTO',0),(61693,1714,'tl','',0),(61694,1714,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(61695,1714,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£',0),(61696,1714,'ms','BUTIR-BUTIR PERKARA',0),(61697,1714,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„ØµÙ†Ù',0),(61698,1714,'fr','LES DÃ‰TAILS SUR LES',0),(61699,1714,'jp','å“?ç›®è©³ç´°',0),(61700,1714,'pt','DETALHES DO ITEM',0),(61701,1714,'ru','Ð”Ð•Ð¢ÐÐ›Ð˜ Ð¢ÐžÐ’ÐÐ Ð',0),(61702,1714,'es','ITEM DETALLES',0),(61703,1714,'de','ARTIKELDETAILS',0),(61704,1714,'en','ITEM DETAILS',0),(61705,1715,'is','',0),(61706,1715,'dr','ØªØµÙˆÙŠØ± ÙƒØ§Ù„Ø§',0),(61707,1715,'pr','ØªØµÙˆÙŠØ± ÙƒØ§Ù„Ø§',0),(61708,1715,'tr','Madde resmi:',0),(61709,1715,'pl','Obraz przedmiotu:',0),(61710,1715,'bg','Ð˜Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸:',0),(61711,1715,'ur','Ø´Û’ Ú©ÛŒ ØªØµÙˆÛŒØ±:',0),(61712,1715,'sr','Ð¡Ð»Ð¸ÐºÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°:',0),(61713,1715,'vi','Tranh hÃ ng',0),(61714,1715,'af','Item Prent:',0),(61715,1715,'ro','Poze pentru articol:',0),(61716,1715,'et','Toote pilt:',0),(61717,1715,'si','Element sliko:',0),(61718,1715,'ba','Gambar item:',0),(61719,1715,'nl','Afbeelding van het artikel:',0),(61720,1715,'fi','Nimikkeen kuva:',0),(61721,1715,'no','Varebilde:',0),(61722,1715,'da','Vare billede:',0),(61723,1715,'ko','í•­ëª© ê·¸ë¦¼:',0),(61724,1715,'he',':×ª×ž×•× ×ª ×¤×¨×™×˜',0),(61725,1715,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÎ¹ÎºÏŒÎ½Î±:',0),(61726,1715,'zh','ç‰©å“å›¾ç‰‡ï¼š\r\n',0),(61727,1715,'sv','Artikelbild:',0),(61728,1715,'it','Foto di elemento:',0),(61729,1715,'tl','',0),(61730,1715,'th','&#3619;&#3641;&#3611;&#3616;&#3634;&#3614;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;:',0),(61731,1715,'hi','à¤†à¤‡à¤Ÿà¤® à¤šà¤¿à¤¤à¥à¤°:',0),(61732,1715,'ms','Gambar item:',0),(61733,1715,'ar','ØµÙˆØ±Ø© Ø§Ù„ØµÙ†Ù',0),(61734,1715,'fr','Photo de l\'article :',0),(61735,1715,'jp','å“?ç›®ç”»åƒ?ï¼š',0),(61736,1715,'pt','Imagens de item:',0),(61737,1715,'ru','ÐšÐ°Ñ€Ñ‚Ð¸Ð½ÐºÐ° Ð¢Ð¾Ð²Ð°Ñ€Ð°:',0),(61738,1715,'es','Item Imagen',0),(61739,1715,'de','Item Picture:',0),(61740,1715,'en','Item Picture:',0),(61741,1716,'is','',0),(61742,1716,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ ',0),(61743,1716,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ ',0),(61744,1716,'tr','Ã–ÄŸe listesi',0),(61745,1716,'pl','Element listy',0),(61746,1716,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(61747,1716,'ur','Ø´Û’ ÙÛØ±Ø³Øª',0),(61748,1716,'sr','Ð›Ð¸ÑÑ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(61749,1716,'vi','Danh sÃ¡ch hÃ ng',0),(61750,1716,'af','Item Lys',0),(61751,1716,'ro','Element listÄƒ',0),(61752,1716,'et','Toodete nimekiri',0),(61753,1716,'si','Seznam artiklov',0),(61754,1716,'ba','Daftar item',0),(61755,1716,'nl','Itemlijst',0),(61756,1716,'fi','Nimikeluettelo',0),(61757,1716,'no','Elementlisten',0),(61758,1716,'da','Elementlisten',0),(61759,1716,'ko','í•­ëª© ëª©ë¡',0),(61760,1716,'he','×¨×©×™×ž×ª ×¤×¨×™×˜×™×',0),(61761,1716,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ¹Î´ÏŽÎ½',0),(61762,1716,'zh','é¡¹ç›®æ¸…å•\r\n',0),(61763,1716,'sv','Artikellista',0),(61764,1716,'it','Elenco di elementi',0),(61765,1716,'tl','',0),(61766,1716,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(61767,1716,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€',0),(61768,1716,'ms','Senarai barangan',0),(61769,1716,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(61770,1716,'fr','Liste d\'Ã©lÃ©ments',0),(61771,1716,'jp','å“?ç›®ãƒªã‚¹ãƒˆ',0),(61772,1716,'pt','Item de lista',0),(61773,1716,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(61774,1716,'es','Item Lista',0),(61775,1716,'de','ArtikelÃ¼bersicht',0),(61776,1716,'en','Item List',0),(61777,1717,'is','',0),(61778,1717,'dr','- Ù„ÙŠØ³Øª Ø¬Ù†Ø³ ',0),(61779,1717,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ ÙƒØ§Ù„Ø§- Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ ',0),(61780,1717,'tr','Fiziksel stok - madde listesi',0),(61781,1717,'pl','Inwentaryzacja - elementu listy',0),(61782,1717,'bg','Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸ Ð·Ð°Ð¿Ð°ÑÐ¸ - ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(61783,1717,'ur','Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ - Ø´Û’ ÙÛØ±Ø³Øª',0),(61784,1717,'sr','ÐŸÐ¾Ð¿Ð¸Ñ Ð·Ð°Ð»Ð¸Ñ…Ð° - Ð›Ð¸ÑÑ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(61785,1717,'vi','Danh sÃ¡ch hÃ ng thá»±c táº¿',0),(61786,1717,'af','Fisiese Voorraad - Item Lys',0),(61787,1717,'ro','Inventar fizic - element listÄƒ',0),(61788,1717,'et','Inventuur - kauba loend',0),(61789,1717,'si','Popis zaloge - seznam artiklov',0),(61790,1717,'ba','Persediaan fisik - daftar Item',0),(61791,1717,'nl','Inventarisatie - itemlijst',0),(61792,1717,'fi','Inventointi - Nimikeluettelo',0),(61793,1717,'no','Vareopptelling - element-listen',0),(61794,1717,'da','LageropgÃ¸relse - elementlisten',0),(61795,1717,'ko','ì‹¤ì œ ìž¬ê³ -í•­ëª© ëª©ë¡',0),(61796,1717,'he','×ž×œ××™ ×¤×™×–×™ - ×¨×©×™×ž×ª ×¤×¨×™×˜×™×',0),(61797,1717,'el','Î¦Ï…ÏƒÎ¹ÎºÎ® Î±Ï€Î¿Î³ÏÎ±Ï†Î® - ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ¹Î´ÏŽÎ½',0),(61798,1717,'zh','åº“å­˜ç›˜ç‚¹- ç‰©å“æ¸…å•\r\n',0),(61799,1717,'sv','Inventering - Artikellista',0),(61800,1717,'it','Inventario fisico - elenco di elementi',0),(61801,1717,'tl','',0),(61802,1717,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3592;&#3619;&#3636;&#3591;',0),(61803,1717,'hi','à¤­à¥Œà¤¤à¤¿à¤• à¤¸à¥‚à¤šà¥€ - à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€',0),(61804,1717,'ms','Inventori fizikal - senarai barangan',0),(61805,1717,'ar','Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† - Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(61806,1717,'fr','Inventaire - liste d\'Ã©lÃ©ments',0),(61807,1717,'jp','æœŸæœ«æ£šå?¸ï¼?å“?ç›®ãƒªã‚¹ãƒˆ',0),(61808,1717,'pt','InventÃ¡rio fÃ­sico - lista de itens',0),(61809,1717,'ru','Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ°Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ - ÑÐ¿Ð¸ÑÐ¾Ðº ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(61810,1717,'es','Inventario Fisica - Item Lista',0),(61811,1717,'de','Inventur - ArtikelÃ¼bersicht',0),(61812,1717,'en','Physical Inventory - Item List',0),(61813,1718,'is','',0),(61814,1718,'dr','- Ù…ØµØ±Ù ',0),(61815,1718,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§- Ù…ØµØ±Ù ',0),(61816,1718,'tr','Ã–ÄŸe listesi - kullanÄ±m',0),(61817,1718,'pl','Pozycja listy - uÅ¼ycie',0),(61818,1718,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ - Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ',0),(61819,1718,'ur','Ø´Û’ ÙÛØ±Ø³Øª - Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(61820,1718,'sr','Ð›Ð¸ÑÑ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° - ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(61821,1718,'vi','Danh sÃ¡ch hÃ ng - Sá»­ dá»¥ng',0),(61822,1718,'af','Item Lys - Gebruik',0),(61823,1718,'ro','Element listÄƒ - utilizare',0),(61824,1718,'et','Kaupade loend - kasutus',0),(61825,1718,'si','Seznam artiklov - uporaba',0),(61826,1718,'ba','Daftar item - penggunaan',0),(61827,1718,'nl','Itemlijst - gebruik',0),(61828,1718,'fi','Nimikeluettelo - kÃ¤yttÃ¶',0),(61829,1718,'no','Vareoversikt - bruk',0),(61830,1718,'da','Vareliste - brug',0),(61831,1718,'ko','í•­ëª© ëª©ë¡-ì‚¬ìš©',0),(61832,1718,'he','×¨×©×™×ž×ª ×¤×¨×™×˜×™× - ×©×™×ž×•×©',0),(61833,1718,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ¹Î´ÏŽÎ½ - Ï‡ÏÎ®ÏƒÎ·',0),(61834,1718,'zh','é¡¹ç›®æ¸…å•- ä½¿ç”¨\r\n',0),(61835,1718,'sv','Artikellista - anvÃ¤ndning',0),(61836,1718,'it','Elenco di elementi - utilizzo',0),(61837,1718,'tl','',0),(61838,1718,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;',0),(61839,1718,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥‚à¤šà¥€ - à¤‰à¤ªà¤¯à¥‹à¤—',0),(61840,1718,'ms','Senarai barangan - penggunaan',0),(61841,1718,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£ØµÙ†Ø§Ù - Ø§Ù„Ø¥Ø³ØªØ¹Ù…Ø§Ù„',0),(61842,1718,'fr','Liste d\'Ã©lÃ©ments - utilisation',0),(61843,1718,'jp','å“?ç›®ãƒªã‚¹ãƒˆãƒ¼ä½¿ç”¨æ³•',0),(61844,1718,'pt','Lista de itens - uso',0),(61845,1718,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÑÐ¿Ð¸ÑÐºÐ° - Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(61846,1718,'es','Item Lista- Uso',0),(61847,1718,'de','ArtikelÃ¼bersicht - Nutzung',0),(61848,1718,'en','Item List - Usage',0),(61849,1719,'is','',0),(61850,1719,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ â€“ Ø§Ø±Ø²Ø´ Ú¯Ø°Ø§Ø±Ù‰',0),(61851,1719,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ â€“ Ø§Ø±Ø²Ø´ Ú¯Ø°Ø§Ø±Ù‰',0),(61852,1719,'tr','Ã–ÄŸe listesi - deÄŸerleme',0),(61853,1719,'pl','Pozycja listy - wycena',0),(61854,1719,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ - Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(61855,1719,'ur','Ø´Û’ ÙÛØ±Ø³Øª - Ù…ÙˆÙ„',0),(61856,1719,'sr','Ð›Ð¸ÑÑ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° - Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(61857,1719,'vi','Danh sÃ¡ch hÃ ng - ÄÃ¡nh giÃ¡',0),(61858,1719,'af','Itemlys - Waardasie',0),(61859,1719,'ro','Element listÄƒ - evaluare',0),(61860,1719,'et','Kaupade loend - hindamine',0),(61861,1719,'si','Seznam artiklov - vrednotenje',0),(61862,1719,'ba','Daftar item - penilaian',0),(61863,1719,'nl','Itemlijst - waardering',0),(61864,1719,'fi','Nimikeluettelo - arvostus',0),(61865,1719,'no','Vareoversikt - verdivurdering',0),(61866,1719,'da','Elementlisten - vÃ¦rdiansÃ¦ttelse',0),(61867,1719,'ko','í•­ëª© ëª©ë¡-í‰ê°€',0),(61868,1719,'he','×¨×©×™×ž×ª ×¤×¨×™×˜×™× - ×”×¢×¨×›×ª ×©×•×•×™',0),(61869,1719,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ¹Î´ÏŽÎ½ - Î±Ï€Î¿Ï„Î¯Î¼Î·ÏƒÎ·',0),(61870,1719,'zh','é¡¹ç›®æ¸…å•- ä¼°å€¼\r\n',0),(61871,1719,'sv','Artikellista - vÃ¤rdering',0),(61872,1719,'it','Elenco di elementi - valutazione',0),(61873,1719,'tl','',0),(61874,1719,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3619;&#3634;&#3588;&#3634;',0),(61875,1719,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥‚à¤šà¥€ - à¤®à¥‚à¤²à¥à¤¯à¤¾à¤‚à¤•à¤¨',0),(61876,1719,'ms','Senarai barangan - penilaian',0),(61877,1719,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¨Ù†Ø¯-Ø§Ù„ØªÙ‚ÙŠÙŠÙ…',0),(61878,1719,'fr','Liste d\'Ã©lÃ©ments - Ã©valuation',0),(61879,1719,'jp','å“?ç›®ãƒªã‚¹ãƒˆãƒ¼è©•ä¾¡',0),(61880,1719,'pt','Lista de itens - avaliaÃ§Ã£o',0),(61881,1719,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÑÐ¿Ð¸ÑÐºÐ° - Ð¾Ñ†ÐµÐ½ÐºÐ¸',0),(61882,1719,'es','Item Lista - ValuaciÃ³n',0),(61883,1719,'de','ArtikelÃ¼bersicht - Bewertung',0),(61884,1719,'en','Item List - Valuation',0),(61885,1720,'is','',0),(61886,1720,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ',0),(61887,1720,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ',0),(61888,1720,'tr','Ã–ÄŸe konumu eklemek iÃ§in',0),(61889,1720,'pl','Lokalizacja elementu Dodaj do',0),(61890,1720,'bg','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ñ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð´Ð¾Ð±Ð°Ð²ÑÑ‚ Ð·Ð°',0),(61891,1720,'ur','Ø´Û’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(61892,1720,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð·Ð°',0),(61893,1720,'vi','ThÃªm vá»‹ trÃ­ hÃ ng cho',0),(61894,1720,'af','Item Ligging Geskep vir',0),(61895,1720,'ro','Adauga element locaÅ£ie pentru',0),(61896,1720,'et','Kauba asukoha lisamine',0),(61897,1720,'si','Dodaj mesto elementa za',0),(61898,1720,'ba','Tambahkan lokasi untuk',0),(61899,1720,'nl','Locatie van het item toevoegen voor',0),(61900,1720,'fi','Nimikkeen sijainnin lisÃ¤Ã¤minen',0),(61901,1720,'no','Elementplasseringen legge for',0),(61902,1720,'da','Emnets placering tilfÃ¸je for',0),(61903,1720,'ko','í•­ëª© ìœ„ì¹˜ì— ëŒ€ í•œ ì¶”ê°€',0),(61904,1720,'he','×ž×™×§×•× ×”×¤×¨×™×˜ ×”×•×¡×£ ×¢×œ',0),(61905,1720,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¸Î­ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î³Î¹Î±',0),(61906,1720,'zh','é¡¹ç›®ä½ç½®æ·»åŠ \r\n',0),(61907,1720,'sv','Artikelplats lÃ¤gga till fÃ¶r',0),(61908,1720,'it','Percorso elemento Aggiungi per',0),(61909,1720,'tl','',0),(61910,1720,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;',0),(61911,1720,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(61912,1720,'ms','Tambah lokasi item bagi',0),(61913,1720,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø¹Ù†ØµØ±',0),(61914,1720,'fr','Emplacement de l\'Ã©lÃ©ment Ajouter pour',0),(61915,1720,'jp','å“?ç›®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®è¿½åŠ ',0),(61916,1720,'pt','Para adicionar o item LocalizaÃ§Ã£o',0),(61917,1720,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ð° Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ðš',0),(61918,1720,'es','Item UbicaciÃ³n Agregada para',0),(61919,1720,'de','Artikelstandort fÃ¼r hinzufÃ¼gen',0),(61920,1720,'en','Item Location Add for',0),(61921,1721,'is','',0),(61922,1721,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ù…Ø­Ù„ Ø¬Ù†Ø³ Ø¨Ø±Ø§ÙŠ ',0),(61923,1721,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ ',0),(61924,1721,'tr','Ã–ÄŸe konumu ekleme/gÃ¼ncelleme iÃ§in',0),(61925,1721,'pl','Element lokalizacji Dodaj/zaktualizuj dane o',0),(61926,1721,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð·Ð°',0),(61927,1721,'ur','Ø´Û’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’',0),(61928,1721,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð·Ð°',0),(61929,1721,'vi','ThÃªm/Cáº­p Nháº­t Äá»‹a Äiá»ƒm Danh Má»¥c cho',0),(61930,1721,'af','Skep/Opdateer Item Ligging vir',0),(61931,1721,'ro','LocaÅ£ie Adauga/actualizare pentru',0),(61932,1721,'et','Kauba asukoha lisamine/uuendamine jaoks',0),(61933,1721,'si','Element lokaciji Dodaj/posodobi za',0),(61934,1721,'ba','Item lokasi Tambahkan/Perbarui untuk',0),(61935,1721,'nl','Item locatie toevoegen/bijwerken voor',0),(61936,1721,'fi','Kohteen sijainti lisÃ¤Ã¤/pÃ¤ivitys',0),(61937,1721,'no','Elementet plassering Legg til/Oppdater for',0),(61938,1721,'da','Element placering TilfÃ¸j/Opdater for',0),(61939,1721,'ko','í•­ëª© ìœ„ì¹˜ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(61940,1721,'he','×¤×¨×™×˜ ×ž×™×§×•× ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ ×¢×‘×•×¨',0),(61941,1721,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¸Î­ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³Î¹Î±',0),(61942,1721,'zh','é¡¹ç›®ä½ç½®æ–°å¢ž/æ›´æ–°\r\n',0),(61943,1721,'sv','Punkt lÃ¤ge LÃ¤gg till/uppdatera fÃ¶r',0),(61944,1721,'it','Elemento Location aggiungere o aggiornare per',0),(61945,1721,'tl','',0),(61946,1721,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(61947,1721,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥‡ à¤²à¤¿à¤',0),(61948,1721,'ms','Item lokasi Tambah/Kemaskini bagi',0),(61949,1721,'ar','Ø§Ù„Ø¹Ù†ØµØ± Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(61950,1721,'fr','Ã‰lÃ©ment emplacement ajouter/mettre Ã  jour pour',0),(61951,1721,'jp','å“?ç›®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®è¿½åŠ /æ›´æ–°',0),(61952,1721,'pt','Item LocalizaÃ§Ã£o adicionar/atualizar para',0),(61953,1721,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ð° Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð´Ð»Ñ',0),(61954,1721,'es','Item UbicaciÃ³n Agregar/Actualizar para',0),(61955,1721,'de','Element Lage-hinzufÃ¼gen/aktualisieren fÃ¼r',0),(61956,1721,'en','Item Location Add/Update for',0),(61957,1722,'is','',0),(61958,1722,'dr','Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(61959,1722,'pr','Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(61960,1722,'tr','Ã–ÄŸe konumu zaten var',0),(61961,1722,'pl','Lokalizacja element juÅ¼ istnieje',0),(61962,1722,'bg','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ñ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(61963,1722,'ur','Ø´Û’ Ú©Ø§ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(61964,1722,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(61965,1722,'vi','Vá»‹ trÃ­ hÃ ng Ä‘Ã£ tá»“n táº¡i',0),(61966,1722,'af','Item Ligging bestaan reeds',0),(61967,1722,'ro','LocaÅ£ie element existÄƒ deja',0),(61968,1722,'et','Toote asukoht on juba olemas',0),(61969,1722,'si','Mesto elementa Å¾e obstaja',0),(61970,1722,'ba','Lokasi sudah ada',0),(61971,1722,'nl','Locatie van het item bestaat al',0),(61972,1722,'fi','Kohteen sijainti on jo olemassa',0),(61973,1722,'no','Elementplasseringen finnes allerede',0),(61974,1722,'da','Emnets placering findes allerede',0),(61975,1722,'ko','í•­ëª© ìœ„ì¹˜ëŠ” ì´ë¯¸ ì¡´ìž¬',0),(61976,1722,'he','×ž×™×§×•× ×¤×¨×™×˜ ×§×™×™× ×›×‘×¨',0),(61977,1722,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· ÎµÎ¯Î´Î¿Ï‚ Î±Ï€Î¿Î¸Î®ÎºÎ·',0),(61978,1722,'zh','é¡¹ç›®ä½ç½®å·²ç»å­˜åœ¨\r\n',0),(61979,1722,'sv','Redan finns objekt plats',0),(61980,1722,'it','Percorso elemento esiste giÃ ',0),(61981,1722,'tl','',0),(61982,1722,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(61983,1722,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(61984,1722,'ms','Lokasi item telah wujud',0),(61985,1722,'ar','Ù…ÙˆÙ‚Ø¹ Ø§Ù„ØµÙ†Ù Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(61986,1722,'fr','Emplacement de l\'Ã©lÃ©ment existe dÃ©jÃ ',0),(61987,1722,'jp','å“?ç›®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(61988,1722,'pt','LocalizaÃ§Ã£o de item jÃ¡ existe',0),(61989,1722,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ð° ÑƒÐ¶Ðµ ÑÐ¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ÑÑ',0),(61990,1722,'es','Item UbicaciÃ³n ya existe',0),(61991,1722,'de','Artikelstandort ist bereits vorhanden.',0),(61992,1722,'en','Item Location already exists',0),(61993,1723,'is','',0),(61994,1723,'dr','Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(61995,1723,'pr','Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(61996,1723,'tr','Ã–ÄŸe konumu baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(61997,1723,'pl','Lokalizacja przedmiotu pomyÅ›lnie zaktualizowana',0),(61998,1723,'bg','ÐœÐµÑÑ‚Ð¾Ð½Ð°Ñ…Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(61999,1723,'ur','Ø´Û’ Ú©Ø§ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(62000,1723,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(62001,1723,'vi','ThÃªm/Cáº­p Nháº­t Äá»‹a Äiá»ƒm Danh Má»¥c thÃ nh cÃ´ng',0),(62002,1723,'af','Item Ligging suksesvol Opdateer',0),(62003,1723,'ro','LocaÅ£ie articol actualizat cu succes',0),(62004,1723,'et','Toote asukoht uuendati edukalt',0),(62005,1723,'si','Mesto elementa uspeÅ¡no posodobljena',0),(62006,1723,'ba','Lokasi yang berhasil',0),(62007,1723,'nl','Locatie van het item succesvol bijgewerkt',0),(62008,1723,'fi','Nimikkeen sijainnin pÃ¤ivittÃ¤minen onnistui',0),(62009,1723,'no','Elementplasseringen oppdatert',0),(62010,1723,'da','Emnets placering opdateret',0),(62011,1723,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•­ëª© ìœ„ì¹˜',0),(62012,1723,'he','×ž×™×§×•× ×”×¤×¨×™×˜ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(62013,1723,'el','Î•Î¯Î´Î¿Ï‚ Î±Ï€Î¿Î¸Î®ÎºÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(62014,1723,'zh','é¡¹ç›®ä½ç½®æ›´æ–°æˆåŠŸ\r\n',0),(62015,1723,'sv','Artikelplats uppdaterats',0),(62016,1723,'it','Percorso di elemento aggiornato con successo',0),(62017,1723,'tl','',0),(62018,1723,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(62019,1723,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥à¤¥à¤¾à¤¨',0),(62020,1723,'ms','Lokasi item yang berjaya dikemas kini',0),(62021,1723,'ar','Ø­Ø¯Ù‘Ø« Ù…ÙˆÙ‚Ø¹ Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(62022,1723,'fr','Emplacement d\'Ã©lÃ©ment mis Ã  jour avec succÃ¨s',0),(62023,1723,'jp','å“?ç›®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(62024,1723,'pt','Item LocalizaÃ§Ã£o atualizada com sucesso',0),(62025,1723,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð½Ð¾',0),(62026,1723,'es','Item UbicaciÃ³n actualizada exitosamente',0),(62027,1723,'de','Artikelstandort erfolgreich aktualisiert',0),(62028,1723,'en','Item Location updated successfully',0),(62029,1724,'is','',0),(62030,1724,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§ ',0),(62031,1724,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§ ',0),(62032,1724,'tr','Ã–ÄŸe arama',0),(62033,1724,'pl','Element wyszukiwania',0),(62034,1724,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(62035,1724,'ur','Ø´Û’ Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(62036,1724,'sr','Ð—Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(62037,1724,'vi','TÃ¬m hÃ ng',0),(62038,1724,'af','Item Opsoek',0),(62039,1724,'ro','Element de cÄƒutare',0),(62040,1724,'et','Tooteotsing',0),(62041,1724,'si','Za iskanje artikla',0),(62042,1724,'ba','Item Lookup',0),(62043,1724,'nl','Object opzoeken',0),(62044,1724,'fi','Nimikkeen haku',0),(62045,1724,'no','Vareoppslaget',0),(62046,1724,'da','Vareopslaget',0),(62047,1724,'ko','í•­ëª© ì¡°íšŒ',0),(62048,1724,'he','×—×™×¤×•×© ×¤×¨×™×˜',0),(62049,1724,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(62050,1724,'zh','æŸ¥æ‰¾é¡¹ç›®\r\n',0),(62051,1724,'sv','ArtikelsÃ¶kningen',0),(62052,1724,'it','Elemento Lookup',0),(62053,1724,'tl','',0),(62054,1724,'th','&#3588;&#3657;&#3609;&#3604;&#3641;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(62055,1724,'hi','à¤†à¤‡à¤Ÿà¤® à¤²à¥à¤•à¤…à¤ª',0),(62056,1724,'ms','Cari item',0),(62057,1724,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† ØµÙ†Ù',0),(62058,1724,'fr','Recherche de point',0),(62059,1724,'jp','å“?ç›®èª¿ã?¹',0),(62060,1724,'pt','Pesquisa de item',0),(62061,1724,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ð¸ÑÐºÐ°',0),(62062,1724,'es','Item Buscar',0),(62063,1724,'de','Artikel-Suche',0),(62064,1724,'en','Item Lookup',0),(62065,1725,'is','',0),(62066,1725,'dr','Ø´Ø±Ø­ ÙƒØ§Ù„Ø§ ',0),(62067,1725,'pr','Ø´Ø±Ø­ ÙƒØ§Ù„Ø§ ',0),(62068,1725,'tr','Madde aÃ§Ä±klamasÄ±',0),(62069,1725,'pl','Opis przedmiotu',0),(62070,1725,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(62071,1725,'ur','Ø´Û’ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(62072,1725,'sr','ÐžÐ¿Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(62073,1725,'vi','MÃ´ táº£ hÃ ng',0),(62074,1725,'af','Item Beskrywing',0),(62075,1725,'ro','Descriere element',0),(62076,1725,'et','Toote kirjeldus',0),(62077,1725,'si','Opis artikla',0),(62078,1725,'ba','Deskripsi item',0),(62079,1725,'nl','Objectbeschrijving uitbreiden',0),(62080,1725,'fi','Nimikkeen kuvaus',0),(62081,1725,'no','Varebeskrivelse',0),(62082,1725,'da','Varebeskrivelse',0),(62083,1725,'ko','í•­ëª© ì„¤ëª…',0),(62084,1725,'he','×ª××•×¨ ×¤×¨×™×˜',0),(62085,1725,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(62086,1725,'zh','é¡¹ç›®è¯´æ˜Ž\r\n',0),(62087,1725,'sv','Artikelbeskrivning',0),(62088,1725,'it','Descrizione articolo',0),(62089,1725,'tl','',0),(62090,1725,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(62091,1725,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£',0),(62092,1725,'ms','Keterangan item',0),(62093,1725,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„ØµÙ†Ù',0),(62094,1725,'fr','Description de l\'objet',0),(62095,1725,'jp','å“?ç›®å??',0),(62096,1725,'pt','DescriÃ§Ã£o do item',0),(62097,1725,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(62098,1725,'es','Item Nombre',0),(62099,1725,'de','Artikelbeschreibung',0),(62100,1725,'en','Item Description',0),(62101,1726,'is','',0),(62102,1726,'dr','ÙƒØ§Ù„Ø§ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(62103,1726,'pr','ÙƒØ§Ù„Ø§ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(62104,1726,'tr','Ã–ÄŸe bulunamadÄ±',0),(62105,1726,'pl','Nie znaleziono elementu',0),(62106,1726,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(62107,1726,'ur','Ø´Û’ Ù†ÛÛŒÚº Ù…Ù„ÛŒ',0),(62108,1726,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°',0),(62109,1726,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ ng',0),(62110,1726,'af','Item nie gevind',0),(62111,1726,'ro','Element negÄƒsit',0),(62112,1726,'et','Toodet ei leitud',0),(62113,1726,'si','Elementa ni mogoÄe najti',0),(62114,1726,'ba','Item tidak ditemukan',0),(62115,1726,'nl','Object niet gevonden',0),(62116,1726,'fi','Kohdetta ei lÃ¶ytynyt',0),(62117,1726,'no','Finner ikke element',0),(62118,1726,'da','Elementet blev ikke fundet',0),(62119,1726,'ko','í•­ëª© ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(62120,1726,'he','×¤×¨×™×˜ ×œ× × ×ž×¦×',0),(62121,1726,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(62122,1726,'zh','æ‰¾ä¸åˆ°é¡¹ç›®\r\n',0),(62123,1726,'sv','Objektet hittades inte',0),(62124,1726,'it','Articolo non trovato',0),(62125,1726,'tl','',0),(62126,1726,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(62127,1726,'hi','à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(62128,1726,'ms','Perkara tidak dijumpai',0),(62129,1726,'ar','Ø§Ù„ØµÙ†Ù ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(62130,1726,'fr','Ã‰lÃ©ment introuvable',0),(62131,1726,'jp','å“?ç›®ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(62132,1726,'pt','Item nÃ£o encontrado',0),(62133,1726,'ru','Ð¢Ð¾Ð²Ð°Ñ€ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½',0),(62134,1726,'es','Item no se encontrÃ³',0),(62135,1726,'de','Element nicht gefunden',0),(62136,1726,'en','Item not found',0),(62137,1727,'is','',0),(62138,1727,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ù„Ø§ ',0),(62139,1727,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ù„Ø§ ',0),(62140,1727,'tr','ÃœrÃ¼n #',0),(62141,1727,'pl','Pozycja #',0),(62142,1727,'bg','Ð¢Ð¾Ñ‡ÐºÐ° #',0),(62143,1727,'ur','Ø´Û’ #',0),(62144,1727,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° #',0),(62145,1727,'vi','HÃ ng sá»‘',0),(62146,1727,'af','Item #',0),(62147,1727,'ro','Elementul #',0),(62148,1727,'et','Toote nr.',0),(62149,1727,'si','ToÄka #',0),(62150,1727,'ba','Barang #',0),(62151,1727,'nl','Objectnummer',0),(62152,1727,'fi','Kohta #',0),(62153,1727,'no','Elementet #',0),(62154,1727,'da','Post #',0),(62155,1727,'ko','# í•­ëª©',0),(62156,1727,'he','# ×¤×¨×™×˜',0),(62157,1727,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ #',0),(62158,1727,'zh','é¡¹ç›®ï¼š\r\n',0),(62159,1727,'sv','Produkt #',0),(62160,1727,'it','Articolo #',0),(62161,1727,'tl','',0),(62162,1727,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(62163,1727,'hi','à¤†à¤‡à¤Ÿà¤® #',0),(62164,1727,'ms','Perkara #',0),(62165,1727,'ar','Ø±Ù‚Ù… Ø§Ù„ØµÙ†Ù',0),(62166,1727,'fr','Item #',0),(62167,1727,'jp','å“?ç›®ç•ªå?·',0),(62168,1727,'pt','Artigo #',0),(62169,1727,'ru','Ð¢Ð¾Ð²Ð°Ñ€ #',0),(62170,1727,'es','Item #',0),(62171,1727,'de','Artikelnr.',0),(62172,1727,'en','Item #',0),(62173,1728,'is','',0),(62174,1728,'dr','- Ø¬Ù†Ø³ ØºÙŠØ± ÙØ¹Ø§Ù„ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ â€“ ÙŠØ§ Ù†Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ Ø§ØµÙ„Ø§Ø­  ÙƒÙ†ÙŠØ¯ Ùˆ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¢Ù†Ø±Ø§ ÙØ¹Ø§Ù„ ÙƒÙ†ÙŠØ¯ ÙŠØ§ ÙŠÙƒ Ù†Ø§Ù… Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø¬Ù†Ø³ Ø®ÙˆØ¯ Ø§ÙŠØ¬Ø§',0),(62175,1728,'pr','ÙØ¹Ø§Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ - ÙƒØ§Ù„Ø§ÙŠ ØºÙŠØ± ÙØ¹Ø§Ù„ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ â€“ ÙŠØ§ Ù†Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ†ÙŠØ¯ Ùˆ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¢Ù†Ø±Ø§ ÙØ¹Ø§Ù„ ÙƒÙ†ÙŠØ¯ ÙŠØ§ ÙŠÙƒ Ù†Ø§Ù… Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø®ÙˆØ¯ Ø§ÙŠØ¬Ø§',0),(62176,1728,'tr','Etkin olmayan Ã¶ÄŸe zaten var.<br><br>Varolan bir adÄ± dÃ¼zenleyin ve yeniden her iki (a),<br>veya (b) yeni Ã¶ÄŸe iÃ§in yeni bir ad oluÅŸturabilirsiniz.<br>',0),(62177,1728,'pl','Nieaktywne element juÅ¼ istnieje.<br><br>(A) edytowaÄ‡ nazwÄ™ istniejÄ…cego i reaktywowaÄ‡<br>lub (b), UtwÃ³rz nowÄ… nazwÄ™ dla nowego przedmiotu.<br>',0),(62178,1728,'bg','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°.<br><br>Ð‘ÑƒÐºÐ²Ð° Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ Ð¸ Ð³Ð¾, Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ<br>Ð¸Ð»Ð¸ (Ð±) ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð¸Ð¼Ðµ Ð·Ð° Ð½Ð¾Ð²Ð¸Ñ ÐµÐ»ÐµÐ¼Ð',0),(62179,1728,'ur','ØºÛŒØ± ÙØ¹Ø§Ù„ Ø´Û’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Û”<br><br>ÛŒØ§ ØªÙˆ (Ø§ÛŒÚ©) Ù…ÙˆØ¬ÙˆØ¯Û Ù†Ø§Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø§Ø³Û’ Ø¯ÙˆØ¨Ø§Ø±Û Ú†Ø§Ù„Ùˆ Ú©Ø±ÛŒÚºØŒ<br>ÛŒØ§ (b) Ø¢Ù¾ Ù†Ø¦ÛŒ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ù†ÛŒØ§ Ù†Ø§Ù… Ù†ÛÛŒÚº Ø¨Ù†Ø§ Û”<br>',0),(62180,1728,'sr','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.<br><br>Ð£ ÑÐ²Ð°ÐºÐ¾Ð¼ (Ð°) ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›ÐµÐ³ Ð¸Ð¼ÐµÐ½Ð° Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°,<br>Ð¸Ð»Ð¸ (Ð±) Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð»Ð¸ Ð½Ð¾Ð²Ð¾ Ð¸Ð¼Ðµ Ð·Ð° Ð½Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ.<br>',0),(62181,1728,'vi','HÃ ng khÃ´ng hoáº¡t Ä‘á»™ng Ä‘Ã£ tá»“n táº¡i.Hoáº·c (a) sá»­a tÃªn hiá»‡n táº¡i & kÃ­ch hoáº¡t láº¡i,hay (b) táº¡o tÃªn má»›i cho máº·t hÃ ng má»›i cá»§a báº¡n.',0),(62182,1728,'af','Onaktiewe item bestaal alreeds. Either (a) redigeer bestaande naam en heraktiveer dit,or (b) skep nuwe naam vir u nuwe item.',0),(62183,1728,'ro','Inactiv element existÄƒ deja.<br><br>Fie (a) edita numele existent si reactiva,<br>sau (b) creeazÄƒ un nou nume pentru elementul nou.<br>',0),(62184,1728,'et','Selline mitteaktiivne toode on juba olemas. <br><br>(a) Muuda olemasolevat nime ja reaktiveeri, <br>vÃµi (b)kasuta teist nime uuele tootele.<br>',0),(62185,1728,'si','Neaktivni artikla Å¾e obstaja.<br><br>(A) urediti obstojeÄe ime in aktiviral,<br>ali (b) ustvariti novo ime za nov element.<br>',0),(62186,1728,'ba','Item tidak aktif sudah ada.<br><br>Kedua (a) mengedit nama yang ada dan mengaktifkannya,<br>atau (b) menciptakan nama baru untuk item baru Anda.<br>',0),(62187,1728,'nl','Inactieve item bestaat al.<br><br>(A) bestaande naam bewerken en activeren<br>of (b) een nieuwe naam voor het nieuwe item maken.<br>',0),(62188,1728,'fi','On jo aktiivinen kohde.<br><br>Joko (a) muokata luodun nimeÃ¤ ja aktivoida sen,<br>tai (b) luo uuden kohteen uusi nimi.<br>',0),(62189,1728,'no','Inaktive elementet finnes allerede.<br><br>Enten (a) redigere eksisterende navn og aktivere den,<br>eller (b) opprette et nytt navn for den nye varen.<br>',0),(62190,1728,'da','Inaktive element findes allerede.<br><br>Enten (a) redigere eksisterende navn og genaktivere det,<br>eller (b) oprette et nyt navn til din nye vare.<br>',0),(62191,1728,'ko','ë¹„í™œì„± í•­ëª©ì´ ì´ë¯¸ ì¡´ìž¬í•©ë‹ˆë‹¤.<br><br>ì–´ëŠ ê²ƒì´ ë“  (a) ê¸°ì¡´ ì´ë¦„ì„ íŽ¸ì§‘ í•˜ ê³ , ê·¸ê²ƒì„ ë‹¤ì‹œ í™œì„±í™”<br>ë˜ëŠ” (b) ê·€í•˜ì˜ ìƒˆ í•­ëª©ì— ëŒ€ í•œ ìƒˆ ì´ë¦„ì„ ë§Œë“­ë‹ˆë‹¤.<br>',0),(62192,1728,'he','×¤×¨×™×˜ ××™× ×• ×¤×¢×™×œ ×›×‘×¨ ×§×™×™×.<br><br>×’× (×) ×©× ×§×™×™× ×•×œ×¢×¨×•×š ×ž×—×“×©<br>××• (b) ×œ×™×¦×•×¨ ×©× ×—×“×© ×¢×‘×•×¨ ×¤×¨×™×˜ ×—×“×©.<br>',0),(62193,1728,'el','Î‘Î½ÎµÎ½ÎµÏÎ³ÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿, Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·.<br><br>Î•Î¯Ï„Îµ (Î±) ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½ ÏŒÎ½Î¿Î¼Î± ÎºÎ±Î¹ Î½Î± ÎµÏ€Î±Î½ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹,<br>Î® (Î²) Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Î­Î½Î± Î½Î­Î¿ ÏŒÎ½Î¿Î¼Î± Î³Î¹Î± Ï„Î¿ Î',0),(62194,1728,'zh','éžæ´»åŠ¨é¡¹ç›®å·²ç»å­˜åœ¨ã€‚ è¦ä¹ˆï¼ˆä¸€ï¼‰ç¼–è¾‘çŽ°æœ‰çš„åç§°å’Œé‡æ–°å¯åŠ¨ï¼Œè¦ä¹ˆï¼ˆbï¼‰ä¸ºæ‚¨çš„æ–°é¡¹ç›®å»ºç«‹ä¸€ä¸ªæ–°åç§°ã€‚\r\n',0),(62195,1728,'sv','Inaktiva objektet finns redan.<br><br>Antingen (a) redigera befintliga namn och Ã¥teraktivera det<br>eller (b) skapa ett nytt namn fÃ¶r din nya artikel.<br>',0),(62196,1728,'it','Esiste giÃ  un elemento inattivo.<br><br>Sia (a) modifica il nome esistente e riattivarlo,<br>o (b) creare un nuovo nome per il nuovo elemento.<br>',0),(62197,1728,'tl','',0),(62198,1728,'th','Inactive item already exists.<br><br>Either (a) edit existing name and reactivate it,<br>or (b) create a new name for your new item.<br>',0),(62199,1728,'hi','à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯ à¤†à¤‡à¤Ÿà¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆà¥¤<br><br>à¤¯à¤¾ à¤¤à¥‹ (à¤•) à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¨à¤¾à¤® à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤‡à¤¸à¥‡ à¤ªà¥à¤¨: à¤¸à¤•à¥à¤°à¤¿à¤¯,<br>à¤¯à¤¾ (à¤–) à¤…à¤ª',0),(62200,1728,'ms','Aktif perkara telah pun wujud.<br><br>Sama ada (a) edit nama yang sedia ada dan mengaktifkan semula<br>atau (b) mewujudkan nama baru untuk item baru anda.<br>',0),(62201,1728,'ar','Ø§Ù„Ø¨Ù†Ø¯ ØºÙŠØ± Ù†Ø´Ø·Ø© Ø¨Ø§Ù„ÙØ¹Ù„.<br><br>Ø£Ù…Ø§ (Ø£) ØªØ­Ø±ÙŠØ± Ø§Ø³Ù… Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© ÙˆØªÙ†Ø´ÙŠØ·Ù‡ØŒ<br>Ø£Ùˆ (Ø¨) Ø¥Ù†Ø´Ø§Ø¡ Ø§Ø³Ù… Ø¬Ø¯ÙŠØ¯ Ù„Ù„Ø¹Ù†ØµØ± Ø§Ù„Ø¬Ø¯ÙŠØ¯ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ.<br>',0),(62202,1728,'fr','Ã‰lÃ©ment inactif existe dÃ©jÃ .<br><br>Soit (a) modifier nom existant et de le rÃ©activer,<br>ou (b) crÃ©er un nouveau nom pour votre nouveau point.<br>',0),(62203,1728,'jp','ä¸?æ´»å‹•å“?ç›®ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™ã€‚<br><br>(a)å­˜åœ¨ã?™ã‚‹å??å‰?ã‚’ç·¨é›†ã?™ã‚‹ã?‹å¾©æ´»ã?•ã?›ã?¦ã??ã? ã?•ã?„ã€‚<br>(b)ã‚‚ã?—ã??ã?¯æ–°è¦?å“?ç›®ã?®æ–°ã?—ã?„å??å‰?ã‚’ä½œæˆ?ã?—ã?¦ã??ã? ã?•ã?„ã€‚<br>',0),(62204,1728,'pt','Item inativo jÃ¡ existe.<br><br>(A) editar nome existente e reativÃ¡-lo,<br>ou (b) criar um novo nome para seu novo item.<br>',0),(62205,1728,'ru','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚.<br><br>Ð›Ð¸Ð±Ð¾ (a) Ð¸Ð·Ð¼ÐµÐ½ÑÑ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÐµÐµ Ð¸Ð¼Ñ Ð¸ Ð²Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐµÐ³Ð¾,<br>Ð¸Ð»Ð¸ (b) ÑÐ¾Ð·Ð´Ð°Ð²Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ð¾Ðµ Ð¸Ð¼Ñ Ð´Ð»Ñ Ð½Ð¾Ð²Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(62206,1728,'es','Item inactivo y existe.<br><br> (a) editar nombre existente y reactivarlo, <br>o (b) crear un nombre nuevo para su item nuevo.<br>',0),(62207,1728,'de','Inaktive Element ist bereits vorhanden.<br><br>(A) bestehende umbenennen und erneut aktivieren,<br>oder (b) einen neuen Namen fÃ¼r das neue Element zu erstellen.<br>',0),(62208,1728,'en','Inactive item already exists.<br><br>Either (a) edit existing name and reactivate it,<br>or (b) create a new name for your new item.<br>',0),(62209,1729,'is','',0),(62210,1729,'dr','ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯ Ø´Ø¯ ',0),(62211,1729,'pr','ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯ Ø´Ø¯ ',0),(62212,1729,'tr','Madde baÅŸarÄ±yla yeniden!',0),(62213,1729,'pl','Element pomyÅ›lnie reaktywowany!',0),(62214,1729,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ», Reactivated ÑƒÑÐ¿ÐµÑˆÐ½Ð¾!',0),(62215,1729,'ur','Ø´Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾Ú¾Ø± Ø²ÛŒØ± Ø¹Ù…Ù„!',0),(62216,1729,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ñ€ÐµÐ°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð»Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾!',0),(62217,1729,'vi','KÃ­ch hoáº¡t hÃ ng thÃ nh cÃ´ng!',0),(62218,1729,'af','Item suksesvolg Geheraktiveer!',0),(62219,1729,'ro','Element reactivat cu succes!',0),(62220,1729,'et','Toode reaktiveeriti edukalt!',0),(62221,1729,'si','Element uspeÅ¡no aktivirali!',0),(62222,1729,'ba','Item diaktifkan kembali berhasil!',0),(62223,1729,'nl','Object met succes opnieuw geactiveerd!',0),(62224,1729,'fi','Tuote aktivoitu onnistuneesti!',0),(62225,1729,'no','Elementet reaktivert vellykket!',0),(62226,1729,'da','Vare genaktiveret med succes!',0),(62227,1729,'ko','í•­ëª©ì„ ì„±ê³µì ìœ¼ë¡œ ë‹¤ì‹œ í™œì„±í™”!',0),(62228,1729,'he','×¤×¨×™×˜ ×ž×—×“×© ×‘×”×¦×œ×—×”!',0),(62229,1729,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ ÎµÎº Î½Î­Î¿Ï… Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±!',0),(62230,1729,'zh','é¡¹ç›®é‡æ–°æ¿€æ´»æˆåŠŸï¼\r\n',0),(62231,1729,'sv','Punkt reaktiveras framgÃ¥ngsrikt!',0),(62232,1729,'it','Elemento riattivato con successo!',0),(62233,1729,'tl','',0),(62234,1729,'th','&#3585;&#3634;&#3619;&#3607;&#3635;&#3651;&#3627;&#3657;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3621;&#3633;&#3610;&#3617;&#3634;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;&#3626;&#3635;&#3',0),(62235,1729,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤•à¥à¤°à¤¿à¤¯!',0),(62236,1729,'ms','Item telah diaktifkan semula berjaya!',0),(62237,1729,'ar','Ø¥Ø³ØªØ±Ø¬Ø¹ Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(62238,1729,'fr','Ã‰lÃ©ment rÃ©activÃ© avec succÃ¨s !',0),(62239,1729,'jp','å“?ç›®ã?Œå¾©æ´»ã?—ã?¾ã?—ã?Ÿ',0),(62240,1729,'pt','Item reativado com sucesso!',0),(62241,1729,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾!',0),(62242,1729,'es','Item Reactivado Exitosamente',0),(62243,1729,'de','Eintrag erfolgreich reaktiviert!',0),(62244,1729,'en','Item Reactivated Successfully!',0),(62245,1730,'is','',0),(62246,1730,'dr','Ù„ØºÙˆ Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(62247,1730,'pr','Ù„ØºÙˆ Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(62248,1730,'tr','Ã–ÄŸe alÄ±rsÄ±nÄ±z iptal baÅŸarÄ±sÄ±z oldu.',0),(62249,1730,'pl','Element otrzyma anulowanie nie powiodÅ‚o siÄ™.',0),(62250,1730,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð° Ð¾Ñ‚ÐºÐ°Ð· Ð½Ðµ ÑƒÑÐ¿Ñ.',0),(62251,1730,'ur','Ø´Û’ Ù…ÙˆØµÙˆÙ„ Ù…Ù†Ø³ÙˆØ® Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯Ø¦ÛŒ ÛÛ’ Û”',0),(62252,1730,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð´Ð¾Ð±Ð¸Ñ‚Ð¸\"ÐžÑ‚ÐºÐ°Ð¶Ð¸\" Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(62253,1730,'vi','XÃ³a nháº­n hÃ ng tháº¥t báº¡i',0),(62254,1730,'af','Item Ontvangs Kanselasie Gefaal.',0),(62255,1730,'ro','Element primi revocare a eÅŸuat.',0),(62256,1730,'et','Kauba vastuvÃµtmiseks ei Loobu.',0),(62257,1730,'si','Element prejme preklic ni uspel.',0),(62258,1730,'ba','Item menerima Batal gagal.',0),(62259,1730,'nl','Item ontvangen annuleren is mislukt.',0),(62260,1730,'fi','Nimikkeen saavat Peruuta epÃ¤onnistui.',0),(62261,1730,'no','Varen fÃ¥r Avbryt mislyktes.',0),(62262,1730,'da','Vare modtage Annuller mislykkedes.',0),(62263,1730,'ko','í•­ëª© ìˆ˜ì‹  ì·¨ì†Œ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(62264,1730,'he','×”×¤×¨×™×˜ ×§×‘×œ ×‘×™×˜×•×œ × ×›×©×œ×”.',0),(62265,1730,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ \"Î†ÎºÏ…ÏÎ¿\" Î±Ï€Î­Ï„Ï…Ï‡Îµ.',0),(62266,1730,'zh','é¡¹ç›®å–æ¶ˆæŽ¥æ”¶å¤±è´¥\r\n',0),(62267,1730,'sv','Artikeln fÃ¥r Avbryt misslyckades.',0),(62268,1730,'it','Elemento ricevere annulla non riuscita.',0),(62269,1730,'tl','',0),(62270,1730,'th','&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(62271,1730,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤«à¤² \' à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚ \' à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(62272,1730,'ms','Perkara menerima Batal yang gagal.',0),(62273,1730,'ar','Ø§Ù„Ø¨Ù†Ø¯ ØªÙ„Ù‚ÙŠ ÙØ´Ù„ \"Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø£Ù…Ø±\".',0),(62274,1730,'fr','Point recevoir annuler a Ã©chouÃ©.',0),(62275,1730,'jp','å“?ç›®å?—é ˜ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿã€‚',0),(62276,1730,'pt','Item receber cancelar falhou.',0),(62277,1730,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ.',0),(62278,1730,'es','Item recibir cancelaciÃ³n fallÃ³',0),(62279,1730,'de','\"Abbrechen\" Fehler angezeigt.',0),(62280,1730,'en','Item receive cancel failed.',0),(62281,1731,'is','',0),(62282,1731,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§  ',0),(62283,1731,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§  ',0),(62284,1731,'tr','Ã–ÄŸe arama',0),(62285,1731,'pl','Element wyszukiwania',0),(62286,1731,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(62287,1731,'ur','Ø´Û’ Ú©ÛŒ ØªÙ„Ø§Ø´',0),(62288,1731,'sr','Ð¢Ñ€Ð°Ð¶ÐµÑšÐµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(62289,1731,'vi','TÃ¬m hÃ ng',0),(62290,1731,'af','Soek Item',0),(62291,1731,'ro','Element de cÄƒutare',0),(62292,1731,'et','Toote otsing',0),(62293,1731,'si','Iskanje artikla',0),(62294,1731,'ba','Cari item',0),(62295,1731,'nl','Item zoeken',0),(62296,1731,'fi','Tuote haku',0),(62297,1731,'no','Elementet sÃ¸k',0),(62298,1731,'da','Elementet SÃ¸g',0),(62299,1731,'ko','í•­ëª© ê²€ìƒ‰',0),(62300,1731,'he','×—×™×¤×•×© ×¤×¨×™×˜',0),(62301,1731,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(62302,1731,'zh','é¡¹ç›®æœç´¢\r\n',0),(62303,1731,'sv','Objekt sÃ¶kning',0),(62304,1731,'it','Ricerca elemento',0),(62305,1731,'tl','',0),(62306,1731,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(62307,1731,'hi','à¤†à¤‡à¤Ÿà¤® à¤–à¥‹à¤œ',0),(62308,1731,'ms','Cari item',0),(62309,1731,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø¹Ù†ØµØ±',0),(62310,1731,'fr','Recherche de point',0),(62311,1731,'jp','å“?ç›®æ¤œç´¢',0),(62312,1731,'pt','Pesquisa de item',0),(62313,1731,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(62314,1731,'es','Item Buscar',0),(62315,1731,'de','Artikelsuche',0),(62316,1731,'en','Item Search',0),(62317,1732,'is','',0),(62318,1732,'dr','ÙˆØ¶Ø¹ÙŠØª  ÙƒØ§Ù„Ø§',0),(62319,1732,'pr','ÙˆØ¶Ø¹ÙŠØª  ÙƒØ§Ù„Ø§',0),(62320,1732,'tr','Ã–ÄŸe durumu',0),(62321,1732,'pl','Stan przedmiotu',0),(62322,1732,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(62323,1732,'ur','Ø´Û’ Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(62324,1732,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÑÑ‚Ð°Ð²ÐºÐµ',0),(62325,1732,'vi','TÃ¬nh tráº¡ng hÃ ng',0),(62326,1732,'af','Item Status',0),(62327,1732,'ro','Statutul de element',0),(62328,1732,'et','Toote staatus',0),(62329,1732,'si','Stanje artikla',0),(62330,1732,'ba','Item Status',0),(62331,1732,'nl','Artikelstatus',0),(62332,1732,'fi','Nimikkeen tila',0),(62333,1732,'no','En vare',0),(62334,1732,'da','Varestatus',0),(62335,1732,'ko','í•­ëª© ìƒíƒœ',0),(62336,1732,'he','×ž×¦×‘ ×¤×¨×™×˜',0),(62337,1732,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(62338,1732,'zh','é¡¹ç›®çŠ¶æ€\r\n',0),(62339,1732,'sv','Artikeln Status',0),(62340,1732,'it','Stato dell\'elemento',0),(62341,1732,'tl','',0),(62342,1732,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(62343,1732,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(62344,1732,'ms','Item Status',0),(62345,1732,'ar','Ø­Ø§Ù„Ø© Ø§Ù„ØµÙ†Ù',0),(62346,1732,'fr','Statut de l\'ordre du jour',0),(62347,1732,'jp','å“?ç›®çŠ¶æ³?',0),(62348,1732,'pt','Status do item',0),(62349,1732,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(62350,1732,'es','Item Status',0),(62351,1732,'de','Status von Elementen',0),(62352,1732,'en','Item Status',0),(62353,1733,'is','',0),(62354,1733,'dr','ÙƒØ§Ù„Ø§ Ø¬Ù‡Øª Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§ Ø­Ø°Ù ÙƒØ±Ø¯Ù† ',0),(62355,1733,'pr','ÙƒØ§Ù„Ø§ Ø¬Ù‡Øª Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§ Ø­Ø°Ù ÙƒØ±Ø¯Ù† ',0),(62356,1733,'tr','Ã–ÄŸe eklemek veya kaldÄ±rmak iÃ§in',0),(62357,1733,'pl','Element, aby dodaÄ‡ lub usunÄ…Ä‡',0),(62358,1733,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ',0),(62359,1733,'ur','Ø´Û’ Ú©Ø§ Ø§Ø¶Ø§ÙÛ ÛŒØ§ ÛÙ¹Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(62360,1733,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð¸Ð»Ð¸ ÑƒÐºÐ»Ð¾Ð½Ð¸Ð»Ð¸',0),(62361,1733,'vi','HÃ ng Ä‘á»ƒ thÃªm hoáº·c bá»',0),(62362,1733,'af','Item om te Skep of Verwyder',0),(62363,1733,'ro','Element pentru a adÄƒuga sau elimina',0),(62364,1733,'et','Toote lisamine vÃµi eemaldamine',0),(62365,1733,'si','Element dodati ali odstraniti',0),(62366,1733,'ba','Item untuk menambah atau menghapus',0),(62367,1733,'nl','Object toe te voegen of te verwijderen',0),(62368,1733,'fi','Tuotteen lisÃ¤Ã¤minen tai poistaminen',0),(62369,1733,'no','Elementet Fjern',0),(62370,1733,'da','Punkt for at tilfÃ¸je eller fjerne',0),(62371,1733,'ko','í•­ëª©ì„ ì¶”ê°€ í•˜ê±°ë‚˜ ì œê±° í•˜ë ¤ë©´',0),(62372,1733,'he','×¤×¨×™×˜ ×›×“×™ ×œ×”×•×¡×™×£ ××• ×œ×”×¡×™×¨',0),(62373,1733,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î® Î½Î± ÎºÎ±Ï„Î±ÏÎ³Î®ÏƒÎµÏ„Îµ',0),(62374,1733,'zh','æ·»åŠ æˆ–ç§»é™¤é¡¹ç›®\r\n',0),(62375,1733,'sv','Objekt att lÃ¤gga till eller ta bort',0),(62376,1733,'it','Elemento per aggiungere o rimuovere',0),(62377,1733,'tl','',0),(62378,1733,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3619;&#3639;&#3629;&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(62379,1733,'hi','à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤¯à¤¾ à¤¨à¤¿à¤•à¤¾à¤²à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(62380,1733,'ms','Perkara untuk menambah atau memadam',0),(62381,1733,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ù„Ø¥Ø¶Ø§ÙØ© Ø£Ùˆ Ø¥Ø²Ø§Ù„Ø©',0),(62382,1733,'fr','Pour ajouter ou supprimer le point',0),(62383,1733,'jp','è¿½åŠ /æ›´æ–°ã?™ã‚‹å“?ç›®',0),(62384,1733,'pt','Item para adicionar ou remover',0),(62385,1733,'ru','Ð¢Ð¾Ð²Ð°Ñ€ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð˜Ð»Ð¸ Ð£Ð±Ñ€Ð°Ñ‚ÑŒ',0),(62386,1733,'es','Item para agregar o eliminar',0),(62387,1733,'de','Element zum HinzufÃ¼gen oder entfernen',0),(62388,1733,'en','Item to Add or Remove',0),(62389,1734,'is','',0),(62390,1734,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ù„Ø§ ',0),(62391,1734,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ù„Ø§ ',0),(62392,1734,'tr','Ã–ÄŸeyi GÃ¼ncelleÅŸtir',0),(62393,1734,'pl','Aktualizacja pozycji',0),(62394,1734,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(62395,1734,'ur','Ø´Û’ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(62396,1734,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(62397,1734,'vi','Cáº­p Nháº­t Danh Má»¥c',0),(62398,1734,'af','Item Opdateer',0),(62399,1734,'ro','Actualizare',0),(62400,1734,'et','Ãœksuse vÃ¤rskendamine',0),(62401,1734,'si','Element posodobitve',0),(62402,1734,'ba','Item Update',0),(62403,1734,'nl','Object bijwerken',0),(62404,1734,'fi','Kohteen pÃ¤ivitys',0),(62405,1734,'no','Elementoppdatering',0),(62406,1734,'da','Vare opdatering',0),(62407,1734,'ko','í•­ëª© ì—…ë°ì´íŠ¸',0),(62408,1734,'he','×¢×“×›×•×Ÿ ×¤×¨×™×˜',0),(62409,1734,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(62410,1734,'zh','é¡¹ç›®çš„æ›´æ–°\r\n',0),(62411,1734,'sv','Objektet Update',0),(62412,1734,'it','Elemento Update',0),(62413,1734,'tl','',0),(62414,1734,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(62415,1734,'hi','à¤†à¤‡à¤Ÿà¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(62416,1734,'ms','Kemaskini butiran',0),(62417,1734,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ØµÙ†Ù',0),(62418,1734,'fr','Mise Ã  jour de l\'Ã©lÃ©ment',0),(62419,1734,'jp','å“?ç›®ã?®æ›´æ–°',0),(62420,1734,'pt','AtualizaÃ§Ã£o do item',0),(62421,1734,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€',0),(62422,1734,'es','Item Actualizar',0),(62423,1734,'de','Element-Update',0),(62424,1734,'en','Item Update',0),(62425,1735,'is','',0),(62426,1735,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(62427,1735,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(62428,1735,'tr','Madde baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(62429,1735,'pl','Element pomyÅ›lnie zaktualizowana',0),(62430,1735,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ»Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(62431,1735,'ur','Ø´Û’ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(62432,1735,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(62433,1735,'vi','Cáº­p Nháº­t Danh Má»¥c thÃ nh cÃ´ng',0),(62434,1735,'af','Item suksesvol Opdateer',0),(62435,1735,'ro','Articol actualizat cu succes',0),(62436,1735,'et','Ãœksuse vÃ¤rskendamine Ãµnnestus',0),(62437,1735,'si','Element uspeÅ¡no posodobljena',0),(62438,1735,'ba','Item yang berhasil',0),(62439,1735,'nl','Item succesvol bijgewerkt',0),(62440,1735,'fi','Kohde pÃ¤ivitetty',0),(62441,1735,'no','Vare oppdatert',0),(62442,1735,'da','Emnet opdateret',0),(62443,1735,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•­ëª©',0),(62444,1735,'he','×¤×¨×™×˜ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(62445,1735,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(62446,1735,'zh','é¡¹ç›®æˆåŠŸæ›´æ–°\r\n',0),(62447,1735,'sv','Artikeln uppdaterades',0),(62448,1735,'it','Articolo aggiornato con successo',0),(62449,1735,'tl','',0),(62450,1735,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(62451,1735,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(62452,1735,'ms','Item dikemaskini berjaya',0),(62453,1735,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(62454,1735,'fr','Article mis Ã  jour avec succÃ¨s',0),(62455,1735,'jp','å“?ç›®ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(62456,1735,'pt','Item atualizado com sucesso',0),(62457,1735,'ru','Ð¢Ð¾Ð²Ð°Ñ€ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(62458,1735,'es','Item actualizado exitosamente',0),(62459,1735,'de','Element erfolgreich aktualisiert',0),(62460,1735,'en','Item updated successfully',0),(62461,1736,'is','',0),(62462,1736,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(62463,1736,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(62464,1736,'tr','Madde SatÄ±cÄ± bilgilerini baÅŸarÄ±yla silindi.',0),(62465,1736,'pl','Pozycja dostawcy informacji usuniÄ™te pomyÅ›lnie.',0),(62466,1736,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(62467,1736,'ur','Ø´Û’ ÙˆÛŒÙ†ÚˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(62468,1736,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ñƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(62469,1736,'vi','XÃ³a thÃ´ng tin ngÆ°á»i bÃ¡n thÃ nh cÃ´ng',0),(62470,1736,'af','Item verskaffer informasie suksesvol geskrap.',0),(62471,1736,'ro','Articol furnizor de informaÅ£ii ÅŸters cu succes.',0),(62472,1736,'et','Toote hankija info kustutati edukalt',0),(62473,1736,'si','Artikel dobavitelj informacij uspeÅ¡no izbrisana.',0),(62474,1736,'ba','Informasi vendor item dihapus berhasil.',0),(62475,1736,'nl','Leverancier objectgegevens verwijderd.',0),(62476,1736,'fi','Nimikkeen toimittajatiedot poistettu.',0),(62477,1736,'no','Elementet leverandÃ¸rinformasjon slettet.',0),(62478,1736,'da','Vare kreditoroplysninger slettet.',0),(62479,1736,'ko','í•­ëª© ê³µê¸‰ ì—…ì²´ ì •ë³´ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(62480,1736,'he','×¤×¨×™×˜ ×ž×™×“×¢ ××•×“×•×ª ×¡×¤×§×™× ×©×œ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(62481,1736,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(62482,1736,'zh','ç‰©å“ä¾›åº”å•†ä¿¡æ¯åˆ é™¤æˆåŠŸã€‚\r\n',0),(62483,1736,'sv','LeverantÃ¶r av artikelinformation raderades.',0),(62484,1736,'it','Informazioni fornitore dell\'elemento eliminate con successo.',0),(62485,1736,'tl','',0),(62486,1736,'th','&#3621;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(62487,1736,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(62488,1736,'ms','Maklumat penjual item dihapuskan dengan jayanya.',0),(62489,1736,'ar','Ø­Ø°ÙØª Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÙˆØ±Ù‘Ø¯ Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(62490,1736,'fr','Point informations fournisseur supprimÃ©es avec succÃ¨s.',0),(62491,1736,'jp','å“?ç›®æ¥­è€…æƒ…å ±ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(62492,1736,'pt','InformaÃ§Ãµes do fornecedor de item excluÃ­das com sucesso.',0),(62493,1736,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(62494,1736,'es','Item informaciÃ³n de proveedor eliminado exitosamente',0),(62495,1736,'de','Element Herstellerinformationen erfolgreich gelÃ¶scht.',0),(62496,1736,'en','Item vendor information deleted successfully.',0),(62497,1737,'is','',0),(62498,1737,'dr','/ Ø§ØµÙ„Ø§Ø­   ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ù†Ø³ ',0),(62499,1737,'pr','Ø§ÙØ²ÙˆØ¯Ù† / ÙˆÙŠØ±Ø§ÙŠØ´  ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ ',0),(62500,1737,'tr','Madde SatÄ±cÄ± Ekle/DÃ¼zenle',0),(62501,1737,'pl','Dostawcy pozycji Dodaj/Edytuj',0),(62502,1737,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(62503,1737,'ur','Ø´Û’ ÙˆÛŒÙ†ÚˆØ± Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(62504,1737,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(62505,1737,'vi','ThÃªm/Sá»­a Danh Má»¥c NgÆ°á»i bÃ¡n',0),(62506,1737,'af','Skep/Opdateer Item Verskaffer',0),(62507,1737,'ro','Articol furnizor AdÄƒugare/Editare',0),(62508,1737,'et','Toote hankija Lisamine/Muutmine',0),(62509,1737,'si','Artikel dobavitelj dodati/urediti',0),(62510,1737,'ba','Item Penjual menambah/mengedit',0),(62511,1737,'nl','Item leverancier toevoegen/bewerken',0),(62512,1737,'fi','Nimikkeen toimittajan lisÃ¤ys/muokkaus',0),(62513,1737,'no','Vare/Rediger leverandÃ¸r',0),(62514,1737,'da','Elementet leverandÃ¸ren TilfÃ¸j/Rediger',0),(62515,1737,'ko','í•­ëª© ê³µê¸‰ ì—…ì²´ ì¶”ê°€/íŽ¸ì§‘',0),(62516,1737,'he','×”×•×¡×£/×¢×¨×•×š ×¡×¤×§ ×¤×¨×™×˜',0),(62517,1737,'el','Î•Î¯Î´Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(62518,1737,'zh','ç‰©å“ä¾›åº”å•†æ·»åŠ /ç¼–è¾‘\r\n',0),(62519,1737,'sv','Objektet leverantÃ¶r LÃ¤gg till/redigera',0),(62520,1737,'it','Elemento Vendor Aggiungi/modifica',0),(62521,1737,'tl','',0),(62522,1737,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(62523,1737,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(62524,1737,'ms','Butiran penjual Tambah/Edit',0),(62525,1737,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ† Ù„Ù„ØµÙ†Ù',0),(62526,1737,'fr','Ã‰lÃ©ment fournisseur ajouter/modifier',0),(62527,1737,'jp','å“?ç›®æ¥­è€…ã?®æ›´æ–°/è¿½åŠ ',0),(62528,1737,'pt','Fornecedor de item Adicionar/editar',0),(62529,1737,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð¢Ð¾Ð²Ð°Ñ€Ð° Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(62530,1737,'es','Item Proveedor Agregar/Editar',0),(62531,1737,'de','Element Anbieter hinzufÃ¼gen/bearbeiten',0),(62532,1737,'en','Item Vendor Add/Edit',0),(62533,1738,'is','',0),(62534,1738,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙˆØ²Ù† ÙƒØ§Ù„Ø§',0),(62535,1738,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙˆØ²Ù† ÙƒØ§Ù„Ø§',0),(62536,1738,'tr','Madde aÄŸÄ±rlÄ±k birimleri',0),(62537,1738,'pl','Jednostek masy towaru',0),(62538,1738,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ñ‚ÐµÐ³Ð»Ð¾ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸Ñ‚Ðµ',0),(62539,1738,'ur','Ø´Û’ Ú©Û’ ÙˆØ²Ù† Ú©Û’ ÛŒÙˆÙ†Ù¹Ø³',0),(62540,1738,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ñ‚ÐµÐ¶Ð¸Ð½Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(62541,1738,'vi','ÄÆ¡n vá»‹ cÃ¢n hÃ ng',0),(62542,1738,'af','Item Gewigeenhede',0),(62543,1738,'ro','UnitÄƒÅ£i de greutate element',0),(62544,1738,'et','Toote kaaluÃ¼hikud',0),(62545,1738,'si','TeÅ¾a enote artikla',0),(62546,1738,'ba','Unit berat barang',0),(62547,1738,'nl','Item gewicht eenheden',0),(62548,1738,'fi','Nimikkeen painon yksikÃ¶issÃ¤',0),(62549,1738,'no','Vekt vareenheter',0),(62550,1738,'da','Emne vÃ¦gtenheder',0),(62551,1738,'ko','í’ˆëª© ë¬´ê²Œ ë‹¨ìœ„',0),(62552,1738,'he','×™×—×™×“×•×ª ×ž×©×§×œ ×¤×¨×™×˜',0),(62553,1738,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î²Î¬ÏÎ¿Ï‚ Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(62554,1738,'zh','ç‰©å“é‡é‡å•ä½\r\n',0),(62555,1738,'sv','Vikt Artikelenheter',0),(62556,1738,'it','UnitÃ  di peso elemento',0),(62557,1738,'tl','',0),(62558,1738,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(62559,1738,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤œà¤¨ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(62560,1738,'ms','Unit berat item',0),(62561,1738,'ar','ÙˆØ­Ø¯Ø§Øª ÙˆØ²Ù† Ø§Ù„ØµÙ†Ù',0),(62562,1738,'fr','UnitÃ©s de poids de point',0),(62563,1738,'jp','å“?ç›®é‡?é‡?å?˜ä½?',0),(62564,1738,'pt','Unidades de peso de item',0),(62565,1738,'ru','Ð’ÐµÑ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(62566,1738,'es','Item Unidades de Peso',0),(62567,1738,'de','Artikeleinheiten Gewicht',0),(62568,1738,'en','Item Weight Units',0),(62569,1739,'is','',0),(62570,1739,'dr','ÙƒØ§Ù„Ø§',0),(62571,1739,'pr','ÙƒØ§Ù„Ø§',0),(62572,1739,'tr','MADDE',0),(62573,1739,'pl','ELEMENT',0),(62574,1739,'bg','Ð•Ð›Ð•ÐœÐ•ÐÐ¢',0),(62575,1739,'ur','Ø´Û’',0),(62576,1739,'sr','ÐÐ Ð¢Ð˜ÐšÐ›Ð',0),(62577,1739,'vi','HÃ€NG',0),(62578,1739,'af','ITEM',0),(62579,1739,'ro','ELEMENT',0),(62580,1739,'et','KAUBA',0),(62581,1739,'si','ELEMENT',0),(62582,1739,'ba','ITEM',0),(62583,1739,'nl','ITEM',0),(62584,1739,'fi','KOHDE',0),(62585,1739,'no','ELEMENT',0),(62586,1739,'da','VAREN',0),(62587,1739,'ko','í•­ëª©',0),(62588,1739,'he','×¤×¨×™×˜',0),(62589,1739,'el','Î£Î¤ÎŸÎ™Î§Î•ÎŠÎŸ',0),(62590,1739,'zh','é¡¹ç›®\r\n',0),(62591,1739,'sv','OBJEKT',0),(62592,1739,'it','ELEMENTO',0),(62593,1739,'tl','',0),(62594,1739,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(62595,1739,'hi','à¤†à¤‡à¤Ÿà¤®',0),(62596,1739,'ms','ITEM',0),(62597,1739,'ar','Ø§Ù„ØµÙ†Ù',0),(62598,1739,'fr','ORDRE DU JOUR',0),(62599,1739,'jp','å“?ç›®',0),(62600,1739,'pt','ITEM',0),(62601,1739,'ru','ÐŸÐ£ÐÐšÐ¢',0),(62602,1739,'es','ITEM',0),(62603,1739,'de','ELEMENT',0),(62604,1739,'en','ITEM',0),(62605,1740,'is','',0),(62606,1740,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§',0),(62607,1740,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§',0),(62608,1740,'tr','Ã–ÄŸeleri',0),(62609,1740,'pl','Elementy',0),(62610,1740,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(62611,1740,'ur','Ø§Ø´ÛŒØ§Ø¡',0),(62612,1740,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ',0),(62613,1740,'vi','HÃ ng',0),(62614,1740,'af','Items',0),(62615,1740,'ro','Elemente',0),(62616,1740,'et','Tooted',0),(62617,1740,'si','Elementi',0),(62618,1740,'ba','Item',0),(62619,1740,'nl','Artikelen',0),(62620,1740,'fi','Kohteita',0),(62621,1740,'no','Elementer',0),(62622,1740,'da','Elementer',0),(62623,1740,'ko','í•­ëª©',0),(62624,1740,'he','×¤×¨×™×˜×™×',0),(62625,1740,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(62626,1740,'zh','äº§å“',0),(62627,1740,'sv','Objekt',0),(62628,1740,'it','Elementi',0),(62629,1740,'tl','',0),(62630,1740,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(62631,1740,'hi','à¤†à¤‡à¤Ÿà¤®',0),(62632,1740,'ms','Item-item',0),(62633,1740,'ar','Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(62634,1740,'fr','Ã‰lÃ©ments',0),(62635,1740,'jp','å“?ç›®',0),(62636,1740,'pt','Itens',0),(62637,1740,'ru','Ð¢Ð¾Ð²Ð°Ñ€Ñ‹',0),(62638,1740,'es','Items',0),(62639,1740,'de','Elemente',0),(62640,1740,'en','Items',0),(62641,1741,'is','',0),(62642,1741,'dr','Ú˜Ø§Ù†ÙˆÙŠÙ‡ ',0),(62643,1741,'pr','Ú˜Ø§Ù†ÙˆÙŠÙ‡ ',0),(62644,1741,'tr','Ocak',0),(62645,1741,'pl','Stycznia',0),(62646,1741,'bg','Ð¯Ð½ÑƒÐ°Ñ€Ð¸',0),(62647,1741,'ur','Ø¬Ù†ÙˆØ±ÛŒ',0),(62648,1741,'sr','ÐˆÐ°Ð½ÑƒÐ°Ñ€Ð°',0),(62649,1741,'vi','ThÃ¡ng GiÃªng',0),(62650,1741,'af','Januarie',0),(62651,1741,'ro','Ianuarie',0),(62652,1741,'et','Jaanuar',0),(62653,1741,'si','Januarja',0),(62654,1741,'ba','Januari',0),(62655,1741,'nl','Januari',0),(62656,1741,'fi','Tammikuuta',0),(62657,1741,'no','Januar',0),(62658,1741,'da','Januar',0),(62659,1741,'ko','1 ì›”',0),(62660,1741,'he','×™× ×•××¨',0),(62661,1741,'el','Î™Î±Î½Î¿Ï…Î±ÏÎ¯Î¿Ï…',0),(62662,1741,'zh','ä¸€æœˆ\r\n',0),(62663,1741,'sv','Januari',0),(62664,1741,'it','Gennaio',0),(62665,1741,'tl','',0),(62666,1741,'th','&#3617;&#3585;&#3619;&#3634;&#3588;&#3617;',0),(62667,1741,'hi','à¤œà¤¨à¤µà¤°à¥€',0),(62668,1741,'ms','Januari',0),(62669,1741,'ar','ÙŠÙ†Ø§ÙŠØ±',0),(62670,1741,'fr','Janvier',0),(62671,1741,'jp','ï¼‘æœˆ',0),(62672,1741,'pt','Janeiro de',0),(62673,1741,'ru','Ð¯Ð½Ð²Ð°Ñ€ÑŒ',0),(62674,1741,'es','Enero',0),(62675,1741,'de','Januar',0),(62676,1741,'en','January',0),(62677,1742,'is','',0),(62678,1742,'dr','(ÙˆØ¸ÙŠÙÙ‡',0),(62679,1742,'pr','Ø´Ø±Ø­ Ø´ØºÙ„ (ÙˆØ¸ÙŠÙÙ‡',0),(62680,1742,'tr','Ä°ÅŸ tanÄ±mÄ±',0),(62681,1742,'pl','Opis pracy',0),(62682,1742,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(62683,1742,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(62684,1742,'sr','ÐžÐ¿Ð¸Ñ Ð¿Ð¾ÑÐ»Ð°',0),(62685,1742,'vi','MÃ´ Táº£ Job',0),(62686,1742,'af','Kontrakwerk Beskrwying',0),(62687,1742,'ro','Descrierea postului',0),(62688,1742,'et','TÃ¶Ã¶ kirjeldus',0),(62689,1742,'si','Opis dela',0),(62690,1742,'ba','Deskripsi pekerjaan',0),(62691,1742,'nl','Functieomschrijving',0),(62692,1742,'fi','TyÃ¶nkuvaus',0),(62693,1742,'no','Stillingsbeskrivelse',0),(62694,1742,'da','Jobbeskrivelse',0),(62695,1742,'ko','ìž‘ì—… ì„¤ëª…',0),(62696,1742,'he','×ª×™××•×¨ ×ª×¤×§×™×“',0),(62697,1742,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(62698,1742,'zh','èŒä½æè¿°\r\n',0),(62699,1742,'sv','Arbetsbeskrivning',0),(62700,1742,'it','Descrizione del lavoro',0),(62701,1742,'tl','',0),(62702,1742,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(62703,1742,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(62704,1742,'ms','Penghuraian kerja',0),(62705,1742,'ar','ÙˆØµÙ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(62706,1742,'fr','Description de l\'emploi',0),(62707,1742,'jp','è?·å‹™å†…å®¹',0),(62708,1742,'pt','DescriÃ§Ã£o do trabalho',0),(62709,1742,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(62710,1742,'es','Trabajo DescripciÃ³n',0),(62711,1742,'de','Stellenbeschreibung',0),(62712,1742,'en','Job Description',0),(62713,1743,'is','',0),(62714,1743,'dr','Ù†Ø§Ù… Ø´ØºÙ„ ',0),(62715,1743,'pr','Ù†Ø§Ù… Ø´ØºÙ„ ',0),(62716,1743,'tr','Ä°ÅŸ adÄ±',0),(62717,1743,'pl','Nazwa zadania',0),(62718,1743,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(62719,1743,'ur','Ø¬Ø§Ø¨ Ú©Ø§ Ù†Ø§Ù…',0),(62720,1743,'sr','ÐÐ°Ð·Ð¸Ð² Ð¿Ð¾ÑÐ»Ð°',0),(62721,1743,'vi','TÃªn Job',0),(62722,1743,'af','Werkstuk Naam',0),(62723,1743,'ro','Numele de Job',0),(62724,1743,'et','Ametinimetus',0),(62725,1743,'si','Ime posla',0),(62726,1743,'ba','Nama pekerjaan',0),(62727,1743,'nl','Taaknaam',0),(62728,1743,'fi','TyÃ¶n nimi',0),(62729,1743,'no','Jobbnavn',0),(62730,1743,'da','Jobnavn',0),(62731,1743,'ko','ìž‘ì—… ì´ë¦„',0),(62732,1743,'he','×©× ×”×ž×©×™×ž×”',0),(62733,1743,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(62734,1743,'zh','èŒä½åç§°\r\n',0),(62735,1743,'sv','Jobbnamn',0),(62736,1743,'it','Nome del lavoro',0),(62737,1743,'tl','',0),(62738,1743,'th','&#3594;&#3639;&#3656;&#3629;&#3591;&#3634;&#3609;',0),(62739,1743,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¨à¤¾à¤®',0),(62740,1743,'ms','Nama kerja',0),(62741,1743,'ar','Ø§Ø³Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(62742,1743,'fr','Nom du travail',0),(62743,1743,'jp','è?·å‹™å??',0),(62744,1743,'pt','Nome do trabalho',0),(62745,1743,'ru','Ð˜Ð¼Ñ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(62746,1743,'es','Trabajo Nombre',0),(62747,1743,'de','Jobname',0),(62748,1743,'en','Job Name',0),(62749,1744,'is','',0),(62750,1744,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø´ØºÙ„ ',0),(62751,1744,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø´ØºÙ„ ',0),(62752,1744,'tr','Ä°ÅŸ ayrÄ±ntÄ±larÄ±',0),(62753,1744,'pl','SzczegÃ³Å‚y pracy',0),(62754,1744,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(62755,1744,'ur','Ø¬Ø§Ø¨ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(62756,1744,'sr','ÐŸÐ¾ÑÐ°Ð¾-Ð´ÐµÑ‚Ð°Ñ™Ð¸',0),(62757,1744,'vi','Chi tiáº¿t Job',0),(62758,1744,'af','Werkstuk Details',0),(62759,1744,'ro','Detalii Job',0),(62760,1744,'et','TÃ¶Ã¶ Ã¼ksikasjad',0),(62761,1744,'si','Job podrobnosti',0),(62762,1744,'ba','Rincian pekerjaan',0),(62763,1744,'nl','Details vacature',0),(62764,1744,'fi','TyÃ¶n tiedot',0),(62765,1744,'no','Jobbdetaljer',0),(62766,1744,'da','Jobdetaljer',0),(62767,1744,'ko','ìž‘ì—… ì„¸ë¶€ ì‚¬í•­',0),(62768,1744,'he','×¤×¨×˜×™ ×¢×‘×•×“×”',0),(62769,1744,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(62770,1744,'zh','æ‹›è˜è¯¦æƒ…\r\n',0),(62771,1744,'sv','Jobbinformation',0),(62772,1744,'it','Particolari di lavoro',0),(62773,1744,'tl','',0),(62774,1744,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3591;&#3634;&#3609;',0),(62775,1744,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤µà¤¿à¤µà¤°à¤£',0),(62776,1744,'ms','Butir-butir kerja',0),(62777,1744,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(62778,1744,'fr','DÃ©tails sur l\'emploi',0),(62779,1744,'jp','è?·å‹™è©³ç´°',0),(62780,1744,'pt','Detalhes do emprego',0),(62781,1744,'ru','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð²Ð°ÐºÐ°Ð½ÑÐ¸Ð¸',0),(62782,1744,'es','Detalles de Trabajo',0),(62783,1744,'de','Job-Details',0),(62784,1744,'en','Job Details',0),(62785,1745,'is','',0),(62786,1745,'dr','Ø³ÙŠØ§Ù‡Ù‡ Ø¨Ø±Ø¯Ø§Ø±ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ² Ù†Ø§Ù…Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(62787,1745,'pr','Ø³ÙŠØ§Ù‡Ù‡ Ø¨Ø±Ø¯Ø§Ø±ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ² Ù†Ø§Ù…Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(62788,1745,'tr','GÃ¼nlÃ¼k iÃ§in listeleme',0),(62789,1745,'pl','Dziennik dla',0),(62790,1745,'bg','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº Ð·Ð°',0),(62791,1745,'ur','ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û',0),(62792,1745,'sr','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð·Ð°',0),(62793,1745,'vi','Liá»‡t kÃª BÃºt toÃ¡n cho',0),(62794,1745,'af','Tydskrif vir lys',0),(62795,1745,'ro','Jurnalul lista',0),(62796,1745,'et','TÃ¶Ã¶lehe kirje',0),(62797,1745,'si','Lista za kotacijo',0),(62798,1745,'ba','Jurnal kode untuk',0),(62799,1745,'nl','Dagboek van de lijst',0),(62800,1745,'fi','Lehden listalle',0),(62801,1745,'no','Journal som viser for',0),(62802,1745,'da','Journal fortegnelse for',0),(62803,1745,'ko','ì €ë„ì— ëŒ€ í•œ ëª©ë¡',0),(62804,1745,'he','×™×•×ž×Ÿ ×¨×™×©×•× ×¢×‘×•×¨',0),(62805,1745,'el','Î•Ï†Î·Î¼ÎµÏÎ¯Î´Î± Î»Î¯ÏƒÏ„Î± Î³Î¹Î±',0),(62806,1745,'zh','æ‚å¿—æ¸…å•\r\n',0),(62807,1745,'sv','Tidning fÃ¶r',0),(62808,1745,'it','Giornale di annunci per',0),(62809,1745,'tl','',0),(62810,1745,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(62811,1745,'hi','à¤œà¤°à¥à¤¨à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¿à¤¸à¥à¤Ÿà¤¿à¤‚à¤—',0),(62812,1745,'ms','Jurnal penyenaraian bagi',0),(62813,1745,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ© Ù„Ù€ ',0),(62814,1745,'fr','Journal annonces pour',0),(62815,1745,'jp','ï½žã?®ä»•è¨³å¸³ãƒªã‚¹ãƒˆ',0),(62816,1745,'pt','Jornal listagem para',0),(62817,1745,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ð´Ð»Ñ',0),(62818,1745,'es','Lista de Diariop para',0),(62819,1745,'de','Zeitschrift fÃ¼r auflisten',0),(62820,1745,'en','Journal Listing for',0),(62821,1746,'is','',0),(62822,1746,'dr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(62823,1746,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(62824,1746,'tr','GÃ¼nlÃ¼k fiÅŸi',0),(62825,1746,'pl','ZaÅ‚Ä…cznik arkusza',0),(62826,1746,'bg','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(62827,1746,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û ÙˆØ§Ø¤Ú†Ø±',0),(62828,1746,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(62829,1746,'vi','Phiáº¿u BÃºt toÃ¡n',0),(62830,1746,'af','Bewysstukke Joernaliseer',0),(62831,1746,'ro','Voucherul jurnal',0),(62832,1746,'et','TÃ¶Ã¶lehe kanne',0),(62833,1746,'si','Journal kupon',0),(62834,1746,'ba','Jurnal Voucher',0),(62835,1746,'nl','Dagboek Voucher',0),(62836,1746,'fi','Tosite',0),(62837,1746,'no','Journalbilaget',0),(62838,1746,'da','Kladdebilag',0),(62839,1746,'ko','ì €ë„ ì¿ í°',0),(62840,1746,'he','×©×•×‘×¨ ×™×•×ž×Ÿ',0),(62841,1746,'el','Î•Ï†Î·Î¼ÎµÏÎ¯Î´Î± ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(62842,1746,'zh','æ—¥å¿—å‡­è¯\r\n',0),(62843,1746,'sv','BokfÃ¶ringsorder',0),(62844,1746,'it','Voucher Journal',0),(62845,1746,'tl','',0),(62846,1746,'th','&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3610;&#3633;&#3597;&#3594;&#3637;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;',0),(62847,1746,'hi','à¤œà¤°à¥à¤¨à¤² à¤µà¤¾à¤‰à¤šà¤°',0),(62848,1746,'ms','Baucar jurnal',0),(62849,1746,'ar','Ø±Ù‚Ù… Ù…Ø³ØªÙ†Ø¯ Ø§Ù„Ù‚ÙŠØ¯',0),(62850,1746,'fr','PiÃ¨ce de journal',0),(62851,1746,'jp','ä»•è¨³å¸³ä¼?ç¥¨',0),(62852,1746,'pt','Journal Voucher',0),(62853,1746,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð“Ðš Ð¶ÑƒÑ€Ð½Ð°Ð»Ð°',0),(62854,1746,'es','Voucher del Diario',0),(62855,1746,'de','Erfassungsbeleg',0),(62856,1746,'en','Journal Voucher',0),(62857,1747,'is','',0),(62858,1747,'dr','Ø¬ÙˆÙ„Ø§ÙŠ ',0),(62859,1747,'pr','Ø¬ÙˆÙ„Ø§ÙŠ ',0),(62860,1747,'tr','Temmuz',0),(62861,1747,'pl','Lipca',0),(62862,1747,'bg','Ð®Ð»Ð¸',0),(62863,1747,'ur','Ø¬ÙˆÙ„Ø§Ø¦ÛŒ',0),(62864,1747,'sr','ÐˆÑƒÐ»Ð°',0),(62865,1747,'vi','ThÃ¡ng Báº£y',0),(62866,1747,'af','Julie',0),(62867,1747,'ro','Iulie',0),(62868,1747,'et','Juuli',0),(62869,1747,'si','Julija',0),(62870,1747,'ba','Juli',0),(62871,1747,'nl','Juli',0),(62872,1747,'fi','HeinÃ¤kuuta',0),(62873,1747,'no','Juli',0),(62874,1747,'da','Juli',0),(62875,1747,'ko','7 ì›”',0),(62876,1747,'he','×™×•×œ×™',0),(62877,1747,'el','Î™Î¿Ï…Î»Î¯Î¿Ï…',0),(62878,1747,'zh','ä¸ƒæœˆ\r\n',0),(62879,1747,'sv','Juli',0),(62880,1747,'it','Luglio',0),(62881,1747,'tl','',0),(62882,1747,'th','&#3585;&#3619;&#3585;&#3598;&#3634;&#3588;&#3617;',0),(62883,1747,'hi','à¤œà¥à¤²à¤¾à¤ˆ',0),(62884,1747,'ms','Julai',0),(62885,1747,'ar','ÙŠÙˆÙ„ÙŠÙˆ',0),(62886,1747,'fr','Juillet',0),(62887,1747,'jp','7æœˆ',0),(62888,1747,'pt','Julho',0),(62889,1747,'ru','Ð˜ÑŽÐ»ÑŒ',0),(62890,1747,'es','Julio',0),(62891,1747,'de','Juli',0),(62892,1747,'en','July',0),(62893,1748,'is','',0),(62894,1748,'dr','Ø¨Ù‡ ØµÙØ­Ù‡ ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ÙˆØ§Ø±Ø¯ Ø´ÙˆÙŠØ¯',0),(62895,1748,'pr','Ø¨Ù‡ ØµÙØ­Ù‡ ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ÙˆØ§Ø±Ø¯ Ø´ÙˆÙŠØ¯',0),(62896,1748,'tr','GL hesaplarÄ±nÄ± DÃ¼zenle',0),(62897,1748,'pl','Edycja kont GL',0),(62898,1748,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° GL ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(62899,1748,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(62900,1748,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð›',0),(62901,1748,'vi','Chuyá»ƒn Sang MÃ n HÃ¬nh Chá»‰nh Sá»­a TK Sá»• CÃ¡i Tá»•ng Há»£p',0),(62902,1748,'af','Beweeg na AG Rekening redigeerskerm',0),(62903,1748,'ro','Editare GL conturi',0),(62904,1748,'et','GL kontosid redigeerida',0),(62905,1748,'si','Urejanje raÄunov GL',0),(62906,1748,'ba','Mengedit account GL',0),(62907,1748,'nl','GL Accounts bewerken',0),(62908,1748,'fi','Muokkaa GL tilit',0),(62909,1748,'no','Redigere GL kontoer',0),(62910,1748,'da','Redigere GL konti',0),(62911,1748,'ko','GL ê³„ì • íŽ¸ì§‘',0),(62912,1748,'he','×¢×¨×™×›×ª ×—×©×‘×•× ×•×ª GL',0),(62913,1748,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ GL',0),(62914,1748,'zh','è·³è½¬åˆ°æ€»å¸å¸æˆ·ç¼–è¾‘ç”»é¢\r\n',0),(62915,1748,'sv','Redigera GL konton',0),(62916,1748,'it','Modificare account GL',0),(62917,1748,'tl','',0),(62918,1748,'th','&#3652;&#3611;&#3607;&#3637;&#3656;&#3627;&#3609;&#3657;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3652;&#3611;',0),(62919,1748,'hi','GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(62920,1748,'ms','Edit akaun GL',0),(62921,1748,'ar','Ø§Ù„Ù‚ÙØ² Ø¥Ù„Ù‰ ØªØ­Ø±ÙŠØ± Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(62922,1748,'fr','Modifier les comptes GL',0),(62923,1748,'jp','ç·?å‹˜å®šå…ƒå¸³ç·¨é›†ç”»é?¢ã?¸ç§»å‹•',0),(62924,1748,'pt','Editar contas GL',0),(62925,1748,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð² GL',0),(62926,1748,'es','Cambiar al Pantalla de EdiciÃ³n de la Cuenta LM',0),(62927,1748,'de','Bearbeiten von GL-Konten',0),(62928,1748,'en','Edit GL Accounts',0),(62929,1749,'is','',0),(62930,1749,'dr','Ú˜ÙˆØ¦Ù† ',0),(62931,1749,'pr','Ú˜ÙˆØ¦Ù† ',0),(62932,1749,'tr','Haziran',0),(62933,1749,'pl','Czerwca',0),(62934,1749,'bg','Ð®Ð½Ð¸',0),(62935,1749,'ur','Ø¬ÙˆÙ†',0),(62936,1749,'sr','ÐˆÑƒÐ½Ð°',0),(62937,1749,'vi','ThÃ¡ng SÃ¡u',0),(62938,1749,'af','Junie',0),(62939,1749,'ro','Iunie',0),(62940,1749,'et','Juuni',0),(62941,1749,'si','Junija',0),(62942,1749,'ba','Juni',0),(62943,1749,'nl','Juni',0),(62944,1749,'fi','KesÃ¤kuuta',0),(62945,1749,'no','Juni',0),(62946,1749,'da','Juni',0),(62947,1749,'ko','6 ì›”',0),(62948,1749,'he','×™×•× ×™',0),(62949,1749,'el','Î™Î¿Ï…Î½Î¯Î¿Ï…',0),(62950,1749,'zh','å…­æœˆ\r\n',0),(62951,1749,'sv','Juni',0),(62952,1749,'it','Giugno',0),(62953,1749,'tl','',0),(62954,1749,'th','&#3617;&#3636;&#3606;&#3640;&#3609;&#3634;&#3618;&#3609;',0),(62955,1749,'hi','à¤œà¥‚à¤¨',0),(62956,1749,'ms','Jun',0),(62957,1749,'ar','ÙŠÙˆÙ†ÙŠÙˆ',0),(62958,1749,'fr','Juin',0),(62959,1749,'jp','6æœˆ',0),(62960,1749,'pt','Junho de',0),(62961,1749,'ru','Ð˜ÑŽÐ½ÑŒ',0),(62962,1749,'es','Junio',0),(62963,1749,'de','Juni',0),(62964,1749,'en','June',0),(62965,1750,'is','',0),(62966,1750,'dr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ ',0),(62967,1750,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ ',0),(62968,1750,'tr','Etiketleri',0),(62969,1750,'pl','Etykiety',0),(62970,1750,'bg','Ð•Ñ‚Ð¸ÐºÐµÑ‚Ð¸',0),(62971,1750,'ur','Ù„ÛŒØ¨Ù„',0),(62972,1750,'sr','ÐžÐ·Ð½Ð°ÐºÐµ',0),(62973,1750,'vi','NhÃ£n ',0),(62974,1750,'af','Ettikette',0),(62975,1750,'ro','Etichete',0),(62976,1750,'et','Sildid',0),(62977,1750,'si','Nalepke',0),(62978,1750,'ba','Label',0),(62979,1750,'nl','Etiketten',0),(62980,1750,'fi','Tarrat',0),(62981,1750,'no','Etiketter',0),(62982,1750,'da','Etiketter',0),(62983,1750,'ko','ë ˆì´ë¸”',0),(62984,1750,'he','×ª×•×•×™×•×ª',0),(62985,1750,'el','Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚',0),(62986,1750,'zh','æ ‡ç­¾\r\n',0),(62987,1750,'sv','Etiketter',0),(62988,1750,'it','Etichette',0),(62989,1750,'tl','',0),(62990,1750,'th','&#3593;&#3621;&#3634;&#3585;',0),(62991,1750,'hi','à¤²à¥‡à¤¬à¤²à¥à¤¸',0),(62992,1750,'ms','Label',0),(62993,1750,'ar','ØªØ³Ù…ÙŠØ§Øª',0),(62994,1750,'fr','Ã‰tiquettes',0),(62995,1750,'jp','ãƒ©ãƒ™ãƒ«',0),(62996,1750,'pt','RÃ³tulos',0),(62997,1750,'ru','Ð­Ñ‚Ð¸ÐºÐµÑ‚ÐºÐ¸',0),(62998,1750,'es','Etiquetas',0),(62999,1750,'de','Etiketten',0),(63000,1750,'en','Labels',0),(63001,1751,'is','',0),(63002,1751,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯',0),(63003,1751,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯',0),(63004,1751,'tr','Emek',0),(63005,1751,'pl','Pracy',0),(63006,1751,'bg','Ð¢Ñ€ÑƒÐ´Ð°',0),(63007,1751,'ur','Ù…Ø²Ø¯ÙˆØ±ÛŒ',0),(63008,1751,'sr','Ð Ð°Ð´Ð½Ð° ÑÐ½Ð°Ð³Ð°',0),(63009,1751,'vi','NhÃ¢n cÃ´ng',0),(63010,1751,'af','Arbeid',0),(63011,1751,'ro','ForÅ£ei de muncÄƒ',0),(63012,1751,'et','Labor',0),(63013,1751,'si','Labor',0),(63014,1751,'ba','Tenaga kerja',0),(63015,1751,'nl','Arbeid',0),(63016,1751,'fi','TyÃ¶',0),(63017,1751,'no','Arbeiderpartiet',0),(63018,1751,'da','Arbejdskraft',0),(63019,1751,'ko','ë…¸ë™',0),(63020,1751,'he','×¢×‘×•×“×”',0),(63021,1751,'el','Î•ÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(63022,1751,'zh','åŠ³åŠ¨\r\n',0),(63023,1751,'sv','Labor',0),(63024,1751,'it','Labor',0),(63025,1751,'tl','',0),(63026,1751,'th','&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(63027,1751,'hi','à¤¶à¥à¤°à¤®',0),(63028,1751,'ms','Buruh',0),(63029,1751,'ar','Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ù„',0),(63030,1751,'fr','Labor',0),(63031,1751,'jp','åŠ´åƒ?',0),(63032,1751,'pt','Trabalho de parto',0),(63033,1751,'ru','Ð¢Ñ€ÑƒÐ´Ð°',0),(63034,1751,'es','Labor',0),(63035,1751,'de','Labor',0),(63036,1751,'en','Labor',0),(63037,1752,'is','',0),(63038,1752,'dr','Ø²Ø¨Ø§Ù† ',0),(63039,1752,'pr','Ø²Ø¨Ø§Ù† ',0),(63040,1752,'tr','Dil',0),(63041,1752,'pl','JÄ™zyk',0),(63042,1752,'bg','Ð•Ð·Ð¸Ðº',0),(63043,1752,'ur','Ø²Ø¨Ø§Ù†',0),(63044,1752,'sr','ÐˆÐµÐ·Ð¸Ðº',0),(63045,1752,'vi','NgÃ´n ngá»¯',0),(63046,1752,'af','Taal',0),(63047,1752,'ro','Limba',0),(63048,1752,'et','Keel',0),(63049,1752,'si','Jezik',0),(63050,1752,'ba','Bahasa',0),(63051,1752,'nl','Taal',0),(63052,1752,'fi','Kieli',0),(63053,1752,'no','SprÃ¥k',0),(63054,1752,'da','Sprog',0),(63055,1752,'ko','ì–¸ì–´',0),(63056,1752,'he','×©×¤×”',0),(63057,1752,'el','Î“Î»ÏŽÏƒÏƒÎ±',0),(63058,1752,'zh','è¯­è¨€\r\n',0),(63059,1752,'sv','SprÃ¥k',0),(63060,1752,'it','Lingua',0),(63061,1752,'tl','',0),(63062,1752,'th','&#3616;&#3634;&#3625;&#3634;',0),(63063,1752,'hi','à¤­à¤¾à¤·à¤¾',0),(63064,1752,'ms','Bahasa',0),(63065,1752,'ar','Ø§Ù„Ù„ØºØ©',0),(63066,1752,'fr','Langue',0),(63067,1752,'jp','è¨€èªž',0),(63068,1752,'pt','LÃ­ngua',0),(63069,1752,'ru','Ð¯Ð·Ñ‹Ðº',0),(63070,1752,'es','Lenguaje',0),(63071,1752,'de','Sprache',0),(63072,1752,'en','Language',0),(63073,1753,'is','',0),(63074,1753,'dr','Ø¯ÙˆÙ…',0),(63075,1753,'pr','Ø¯ÙˆÙ…',0),(63076,1753,'tr','Son',0),(63077,1753,'pl','Ostatnia',0),(63078,1753,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾',0),(63079,1753,'ur','Ø¢Ø®Ø±ÛŒ',0),(63080,1753,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸',0),(63081,1753,'vi','Cuá»‘i cÃ¹ng',0),(63082,1753,'af','Van',0),(63083,1753,'ro','Ultima',0),(63084,1753,'et','Kesta',0),(63085,1753,'si','Nazadnje',0),(63086,1753,'ba','Terakhir',0),(63087,1753,'nl','Laatste',0),(63088,1753,'fi','Viimeksi',0),(63089,1753,'no','Siste',0),(63090,1753,'da','Seneste',0),(63091,1753,'ko','ìµœê·¼',0),(63092,1753,'he','××—×¨×•×Ÿ',0),(63093,1753,'el','Î¤Î¿ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿',0),(63094,1753,'zh','æœ€åŽ\r\n',0),(63095,1753,'sv','Senaste',0),(63096,1753,'it','Ultima',0),(63097,1753,'tl','',0),(63098,1753,'th','&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(63099,1753,'hi','à¤…à¤‚à¤¤à¤¿à¤®',0),(63100,1753,'ms','Terakhir',0),(63101,1753,'ar','Ø§Ù„Ø£Ø®ÙŠØ±',0),(63102,1753,'fr','DerniÃ¨re',0),(63103,1753,'jp','æœ€å¾Œ',0),(63104,1753,'pt','Ãšltima',0),(63105,1753,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹',0),(63106,1753,'es','Ãšltimo',0),(63107,1753,'de','Letzter',0),(63108,1753,'en','Last',0),(63109,1754,'is','',0),(63110,1754,'dr','(Ø§Ù‚Ø¯Ø§Ù… ',0),(63111,1754,'pr','Ø¢Ø®Ø±ÙŠÙ†  ÙØ¹Ø§Ù„ÙŠØª(Ø§Ù‚Ø¯Ø§Ù… ',0),(63112,1754,'tr','Son eylemi',0),(63113,1754,'pl','OstatniÄ… akcjÄ™',0),(63114,1754,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(63115,1754,'ur','Ø¢Ø®Ø±ÛŒ Ø¹Ù…Ù„',0),(63116,1754,'sr','ÐŸÐ¾ÑÑ™ÐµÐ´ÑšÑƒ Ñ€Ð°Ð´ÑšÑƒ',0),(63117,1754,'vi','HÃ nh Ä‘á»™ng cuá»‘i',0),(63118,1754,'af','Laaste Aksie',0),(63119,1754,'ro','Ultima acÅ£iune',0),(63120,1754,'et','Viimane Toiming',0),(63121,1754,'si','Zadnje dejanje',0),(63122,1754,'ba','Tindakan terakhir',0),(63123,1754,'nl','Laatste actie',0),(63124,1754,'fi','Edellisen toiminnon',0),(63125,1754,'no','Siste handling',0),(63126,1754,'da','Sidste handling',0),(63127,1754,'ko','ë§ˆì§€ë§‰ ìž‘ì—…',0),(63128,1754,'he','×¤×¢×•×œ×” ××—×¨×•× ×”',0),(63129,1754,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎµÎ½Î­ÏÎ³ÎµÎ¹Î±',0),(63130,1754,'zh','æœ€åŽè¡ŒåŠ¨\r\n',0),(63131,1754,'sv','Senaste Ã¥tgÃ¤rden',0),(63132,1754,'it','Ultima azione',0),(63133,1754,'tl','',0),(63134,1754,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3588;&#3619;&#3633;&#3657;&#3591;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(63135,1754,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤•à¥à¤°à¤¿à¤¯à¤¾',0),(63136,1754,'ms','Tindakan terakhir',0),(63137,1754,'ar','Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡ Ø§Ù„Ø£Ø®ÙŠØ±',0),(63138,1754,'fr','DerniÃ¨re Action',0),(63139,1754,'jp','æœ€çµ‚ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(63140,1754,'pt','Ãšltima aÃ§Ã£o',0),(63141,1754,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(63142,1754,'es','AcciÃ³n Ãšltima',0),(63143,1754,'de','Letzte Aktion',0),(63144,1754,'en','Last Action',0),(63145,1755,'is','',0),(63146,1755,'dr','Ø§Ø®Ø±ÙŠÙ†  Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(63147,1755,'pr','Ø§Ø®Ø±ÙŠÙ†  Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(63148,1755,'tr','Son kontrol kullanÄ±lan #',0),(63149,1755,'pl','SprawdÅº # uÅ¼ywany',0),(63150,1755,'bg','Ð¡ÐµÑ‚Ð½Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ # Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°',0),(63151,1755,'ur','Ø¢Ø®Ø±ÛŒ Ú†ÛŒÚ© Ú©Ø±ØªÛ’ ØªÚ¾Û’ #',0),(63152,1755,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ # Ð¿Ð¾ÑÑ™.',0),(63153,1755,'vi','Sá»‘ SÃ©c cuá»‘i cÃ¹ng sá»­ dá»¥ng',0),(63154,1755,'af','Laaste Tjek # Gebruik',0),(63155,1755,'ro','VerificaÅ£i # utilizat ultima',0),(63156,1755,'et','Check # kasutati viimati',0),(63157,1755,'si','Preverite # roÃ¨no',0),(63158,1755,'ba','Terakhir Periksa # digunakan',0),(63159,1755,'nl','Laatst Controleer # gebruikt',0),(63160,1755,'fi','Viimeksi Tarkista # kÃ¤ytetty',0),(63161,1755,'no','Sjekk # brukt sist',0),(63162,1755,'da','Sidste tjek # bruges',0),(63163,1755,'ko','ë§ˆì§€ë§‰ ì²´í¬ # ì‚¬ìš©',0),(63164,1755,'he','×‘×“×•×§ # ×”×©×™×ž×•×© ×”××—×¨×•×Ÿ',0),(63165,1755,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎµÎ»Î­Î³Î¾Ï„Îµ # Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹',0),(63166,1755,'zh','æœ€åŽä¸€æ¬¡æ£€æŸ¥ï¼ƒä¸­ä½¿ç”¨\r\n',0),(63167,1755,'sv','Kolla # anvÃ¤ndes senast',0),(63168,1755,'it','Ultima verifica # usato',0),(63169,1755,'tl','',0),(63170,1755,'th','&#3651;&#3594;&#3657;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3588;&#3619;&#3633;&#3657;&#3591;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(63171,1755,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤œà¤¾à¤à¤š à¤‰à¤ªà¤¯à¥‹à¤— #',0),(63172,1755,'ms','Buat semak # digunakan',0),(63173,1755,'ar','Ø¢Ø®Ø± Ø±Ù‚Ù… ØµÙƒÙ‘ Ù…Ø³ØªØ®Ø¯Ù…',0),(63174,1755,'fr','VÃ©rifiez # utilisÃ© en dernier',0),(63175,1755,'jp','ä½¿ç”¨æ¸ˆå°?åˆ‡æ‰‹æœ€çµ‚ç•ªå?·',0),(63176,1755,'pt','Ãšltimo cheque # usado',0),(63177,1755,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð²Ñ‹ÐµÐ·Ð´ # Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ',0),(63178,1755,'es','Ãšltimo Cheque # Usado',0),(63179,1755,'de','Zuletzt verwendete Check #',0),(63180,1755,'en','Last Check # Used',0),(63181,1756,'is','',0),(63182,1756,'dr','(Ù‚ÙŠÙ…Øª',0),(63183,1756,'pr','Ø¢Ø®Ø±ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ (Ù‚ÙŠÙ…Øª',0),(63184,1756,'tr','Son maliyet',0),(63185,1756,'pl','Ostatni koszt',0),(63186,1756,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(63187,1756,'ur','Ø¢Ø®Ø±ÛŒ Ù„Ø§Ú¯Øª',0),(63188,1756,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(63189,1756,'vi','Chi phÃ­ cuá»‘i cÃ¹ng',0),(63190,1756,'af','Laste Koste',0),(63191,1756,'ro','Ultimul Cost',0),(63192,1756,'et','Viimane kulu',0),(63193,1756,'si','Zadnji stroÅ¡ek',0),(63194,1756,'ba','Biaya terakhir',0),(63195,1756,'nl','Laatste kosten',0),(63196,1756,'fi','Viimeinen kustannus',0),(63197,1756,'no','Siste kostnader',0),(63198,1756,'da','Sidste omkostning',0),(63199,1756,'ko','ìµœê·¼ ë¹„ìš©',0),(63200,1756,'he','×¢×œ×•×ª ×”××—×¨×•×Ÿ',0),(63201,1756,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(63202,1756,'zh','æœ€åŽæˆæœ¬\r\n',0),(63203,1756,'sv','Senaste kostnad',0),(63204,1756,'it','Ultimo costo',0),(63205,1756,'tl','',0),(63206,1756,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(63207,1756,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤²à¤¾à¤—à¤¤',0),(63208,1756,'ms','Kos lepas',0),(63209,1756,'ar','Ø¢Ø®Ø± ØªÙƒÙ„ÙØ©',0),(63210,1756,'fr','Dernier coÃ»t',0),(63211,1756,'jp','æœ€çµ‚è²»ç”¨',0),(63212,1756,'pt','Custo Ãºltimo',0),(63213,1756,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÑÑ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(63214,1756,'es','Ãšltimo Costo',0),(63215,1756,'de','Letzte Kosten',0),(63216,1756,'en','Last Cost',0),(63217,1757,'is','',0),(63218,1757,'dr','Ø¢Ø®Ø±ÙŠÙ† Ù¾ÙŠØºØ§Ù… ',0),(63219,1757,'pr','Ø¢Ø®Ø±ÙŠÙ† Ù¾ÙŠØºØ§Ù… ',0),(63220,1757,'tr','Son Mesaj',0),(63221,1757,'pl','Ostatnia wiadomoÅ›Ä‡',0),(63222,1757,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(63223,1757,'ur','Ø¢Ø®Ø±ÛŒ Ù¾ÛŒØºØ§Ù…',0),(63224,1757,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ° Ð¿Ð¾Ñ€ÑƒÐºÐ°',0),(63225,1757,'vi','Tin nháº¯n cuá»‘i',0),(63226,1757,'af','Laaste boodskap',0),(63227,1757,'ro','Ultimul mesaj',0),(63228,1757,'et','Eelmine sÃµnum',0),(63229,1757,'si','Zadnje sporoÄilo',0),(63230,1757,'ba','Pesan terakhir',0),(63231,1757,'nl','Laatste bericht',0),(63232,1757,'fi','Viimeinen viesti',0),(63233,1757,'no','Siste melding',0),(63234,1757,'da','Sidste besked',0),(63235,1757,'ko','ë§ˆì§€ë§‰ ë©”ì‹œì§€',0),(63236,1757,'he','×”×•×“×¢×” ××—×¨×•× ×”',0),(63237,1757,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ Î¼Î®Î½Ï…Î¼Î±',0),(63238,1757,'zh','æœ€åŽæ¶ˆæ¯\r\n',0),(63239,1757,'sv','Sista meddelandet',0),(63240,1757,'it','Ultimo messaggio',0),(63241,1757,'tl','',0),(63242,1757,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(63243,1757,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(63244,1757,'ms','Mesej terakhir',0),(63245,1757,'ar','Ø§Ù„Ø±Ø³Ø§Ù„Ø© Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(63246,1757,'fr','Dernier message',0),(63247,1757,'jp','æœ€çµ‚ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(63248,1757,'pt','Ãšltima mensagem',0),(63249,1757,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(63250,1757,'es','Ãšltima Mensaje',0),(63251,1757,'de','Letzte Meldung',0),(63252,1757,'en','Last message',0),(63253,1758,'is','',0),(63254,1758,'dr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ',0),(63255,1758,'pr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ',0),(63256,1758,'tr','SoyadÄ±',0),(63257,1758,'pl','Nazwisko',0),(63258,1758,'bg','Ð¤Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(63259,1758,'ur','Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù…',0),(63260,1758,'sr','ÐŸÑ€ÐµÐ·Ð¸Ð¼Ðµ',0),(63261,1758,'vi','Há»',0),(63262,1758,'af','Van',0),(63263,1758,'ro','Numele de familie',0),(63264,1758,'et','Perekonnanimi',0),(63265,1758,'si','Priimek',0),(63266,1758,'ba','Nama belakang',0),(63267,1758,'nl','Achternaam',0),(63268,1758,'fi','Sukunimi',0),(63269,1758,'no','Etternavn',0),(63270,1758,'da','Efternavn',0),(63271,1758,'ko','ë§ˆì§€ë§‰ ì´ë¦„',0),(63272,1758,'he','×©× ×ž×©×¤×—×”',0),(63273,1758,'el','Î•Ï€ÏŽÎ½Ï…Î¼Î¿',0),(63274,1758,'zh','å§“\r\n',0),(63275,1758,'sv','Efternamn',0),(63276,1758,'it','Cognome',0),(63277,1758,'tl','',0),(63278,1758,'th','&#3609;&#3634;&#3617;&#3626;&#3585;&#3640;&#3621;',0),(63279,1758,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤®',0),(63280,1758,'ms','Nama bapa/keluarga',0),(63281,1758,'ar','Ø§Ù„Ù„Ù‚Ø¨',0),(63282,1758,'fr','Nom de famille',0),(63283,1758,'jp','å§“å??',0),(63284,1758,'pt','Ãšltimo nome',0),(63285,1758,'ru','Ð¤Ð°Ð¼Ð¸Ð»Ð¼Ð¸Ñ',0),(63286,1758,'es','Apellido',0),(63287,1758,'de','Nachname',0),(63288,1758,'en','Last Name',0),(63289,1759,'is','',0),(63290,1759,'dr','(Ø§Ø®ÙŠØ±',0),(63291,1759,'pr','Ú¯Ø°Ø´ØªÙ‡ (Ø§Ø®ÙŠØ±',0),(63292,1759,'tr','GeÃ§',0),(63293,1759,'pl','Pod koniec',0),(63294,1759,'bg','ÐšÑŠÑÐ½Ð¾',0),(63295,1759,'ur','Ø¯ÛŒØ±',0),(63296,1759,'sr','ÐšÐ°ÑÐ½Ð¾',0),(63297,1759,'vi','Muá»™n',0),(63298,1759,'af','Laat',0),(63299,1759,'ro','TÃ¢rziu',0),(63300,1759,'et','Hilja',0),(63301,1759,'si','Pozno',0),(63302,1759,'ba','Akhir',0),(63303,1759,'nl','Laat',0),(63304,1759,'fi','MyÃ¶hÃ¤Ã¤n',0),(63305,1759,'no','Sent',0),(63306,1759,'da','Sent',0),(63307,1759,'ko','ëŠ¦ê²Œ',0),(63308,1759,'he','×ž××•×—×¨',0),(63309,1759,'el','Î‘ÏÎ³Î¬',0),(63310,1759,'zh','è¿Ÿåˆ°',0),(63311,1759,'sv','Sent',0),(63312,1759,'it','Tardi',0),(63313,1759,'tl','',0),(63314,1759,'th','&#3621;&#3656;&#3634;&#3594;&#3657;&#3634;',0),(63315,1759,'hi','à¤¦à¥‡à¤° à¤¸à¥‡',0),(63316,1759,'ms','Lewat',0),(63317,1759,'ar','ÙˆÙ‚Øª Ù…ØªØ£Ø®Ø±',0),(63318,1759,'fr','Vers la fin',0),(63319,1759,'jp','é?…å»¶',0),(63320,1759,'pt','Tarde',0),(63321,1759,'ru','ÐŸÐ¾Ð·Ð´Ð½Ð¾',0),(63322,1759,'es','Tarde',0),(63323,1759,'de','SpÃ¤t',0),(63324,1759,'en','Late',0),(63325,1760,'is','',0),(63326,1760,'dr','(Ø§Ø®ÙŠØ±',0),(63327,1760,'pr','Ø¯Ù„ÙŠÙ„ Ú¯Ø°Ø´ØªÙ‡ (Ø§Ø®ÙŠØ±',0),(63328,1760,'tr','GeÃ§ nedeni',0),(63329,1760,'pl','PowÃ³d pÃ³Åºno',0),(63330,1760,'bg','ÐšÑŠÑÐ½Ð¾ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(63331,1760,'ur','ØªØ§Ø®ÛŒØ± Ú©ÛŒ ÙˆØ¬Û',0),(63332,1760,'sr','ÐŸÐ¾ÐºÐ¾Ñ˜Ð½Ð¸ Ñ€Ð°Ð·Ð»Ð¾Ð³',0),(63333,1760,'vi','NguyÃªn nhÃ¢n muá»™n',0),(63334,1760,'af','Laat rede',0),(63335,1760,'ro','TÃ¢rziu motiv',0),(63336,1760,'et','Hilinemise pÃµhjus',0),(63337,1760,'si','Pozno razlog',0),(63338,1760,'ba','Alasan akhir',0),(63339,1760,'nl','Laat reden',0),(63340,1760,'fi','MyÃ¶hÃ¤Ã¤n syy',0),(63341,1760,'no','Sen grunn',0),(63342,1760,'da','Sen grund',0),(63343,1760,'ko','ëŠ¦ì€ ì´ìœ ',0),(63344,1760,'he','×”×¡×™×‘×” ×ž××•×—×¨',0),(63345,1760,'el','Î¤Î­Î»Î· Î»ÏŒÎ³Î¿Ï‚',0),(63346,1760,'zh','é€¾æœŸåŽŸå› \r\n',0),(63347,1760,'sv','Sen anledning',0),(63348,1760,'it','Motivo fine',0),(63349,1760,'tl','',0),(63350,1760,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3621;&#3656;&#3634;&#3594;&#3657;&#3634;',0),(63351,1760,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤•à¤¾à¤°à¤£',0),(63352,1760,'ms','Sebab lewat',0),(63353,1760,'ar','Ø³Ø¨Ø¨ Ø§Ù„ØªØ£Ø®Ø±',0),(63354,1760,'fr','Motif fin',0),(63355,1760,'jp','é?…å»¶ç?†ç”±',0),(63356,1760,'pt','RazÃ£o final',0),(63357,1760,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ð¾Ð·Ð´Ð½ÐµÐ³Ð¾',0),(63358,1760,'es','ExplicaciÃ³n Tarde',0),(63359,1760,'de','SpÃ¤ten Grund',0),(63360,1760,'en','Late Reason',0),(63361,1761,'is','',0),(63362,1761,'dr','Ø§Ø®Ø±Ø§Ø¬ ',0),(63363,1761,'pr','Ø§Ø®Ø±Ø§Ø¬ ',0),(63364,1761,'tr','Ara ver',0),(63365,1761,'pl','Odczep siÄ™',0),(63366,1761,'bg','Ð£Ð²Ð¾Ð»Ð½ÑÐ²Ð°Ð¼',0),(63367,1761,'ur','Ø§Ù„Ú¯ Ú©Ø±Ù†Ø§',0),(63368,1761,'sr','Ð¾Ñ‚Ð¿ÑƒÑÑ‚Ð¸Ñ‚Ð¸',0),(63369,1761,'vi','Sa tháº£i',0),(63370,1761,'af','Ontslaan',0),(63371,1761,'ro','las-o mai moale',0),(63372,1761,'et','Maha jÃ¤tma',0),(63373,1761,'si','odloÅ¾iti',0),(63374,1761,'ba','Jangan ikut campur',0),(63375,1761,'nl','Hou op',0),(63376,1761,'fi','Antaa lopputili',0),(63377,1761,'no','ligg unna',0),(63378,1761,'da','Hold op',0),(63379,1761,'ko','í•´ê³ í•˜ë‹¤',0),(63380,1761,'he','×œ×”×©×”×•×ª',0),(63381,1761,'el','Î†ÏƒÎµ Î¼Îµ Î®ÏƒÏ…Ï‡Î¿',0),(63382,1761,'zh','é£æ•£\r\n',0),(63383,1761,'sv','Sluta',0),(63384,1761,'it','Smettila',0),(63385,1761,'tl','',0),(63386,1761,'th','&#3648;&#3621;&#3636;&#3585;&#3592;&#3657;&#3634;&#3591;',0),(63387,1761,'hi','à¤¨à¤¿à¤•à¤¾à¤² à¤¦à¥‡à¤¨à¤¾',0),(63388,1761,'ms','berhenti',0),(63389,1761,'ar','ÙŠØªÙˆÙ‚Ù Ø¹Ù† Ø§Ù„Ø¥Ø²Ø¹Ø§Ø¬',0),(63390,1761,'fr','Licencier',0),(63391,1761,'jp','è§£é›‡',0),(63392,1761,'pt','Demitir',0),(63393,1761,'ru','Ð¥Ð²Ð°Ñ‚Ð¸Ñ‚',0),(63394,1761,'es','Despedir',0),(63395,1761,'de','Entlassen',0),(63396,1761,'en','Lay off',0),(63397,1762,'is','',0),(63398,1762,'dr','Lb  ÙˆØ§Ø­Ø¯ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ±ÙŠ ÙˆØ²Ù†  Ù…Ø¹Ø§Ø¯Ù„ 454 Ú¯Ø±Ù… ',0),(63399,1762,'pr','Lb  ÙˆØ§Ø­Ø¯ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ±ÙŠ ÙˆØ²Ù†  Ù…Ø¹Ø§Ø¯Ù„ 454 Ú¯Ø±Ù… ',0),(63400,1762,'tr','Lb',0),(63401,1762,'pl','LB',0),(63402,1762,'bg','LB',0),(63403,1762,'ur','Lb',0),(63404,1762,'sr','Ð›Ð‘',0),(63405,1762,'vi','Pao',0),(63406,1762,'af','Gesny',0),(63407,1762,'ro','Lb',0),(63408,1762,'et','LB',0),(63409,1762,'si','LB',0),(63410,1762,'ba','Lb',0),(63411,1762,'nl','Lb',0),(63412,1762,'fi','Lb',0),(63413,1762,'no','Lb',0),(63414,1762,'da','Lb',0),(63415,1762,'ko','íŒŒìš´ë“œ',0),(63416,1762,'he','Lb',0),(63417,1762,'el','Lb',0),(63418,1762,'zh','ç£…\r\n',0),(63419,1762,'sv','LB',0),(63420,1762,'it','LB',0),(63421,1762,'tl','',0),(63422,1762,'th','&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(63423,1762,'hi','à¤²à¥‡à¤—',0),(63424,1762,'ms','Lb',0),(63425,1762,'ar','Ø±Ø·Ù„',0),(63426,1762,'fr','Lb',0),(63427,1762,'jp','ãƒ?ãƒ³ãƒ‰',0),(63428,1762,'pt','Lb',0),(63429,1762,'ru','LB',0),(63430,1762,'es','Lb',0),(63431,1762,'de','LB',0),(63432,1762,'en','Lb',0),(63433,1763,'is','',0),(63434,1763,'dr','Lbs ÙˆØ§Ø­Ø¯ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ±ÙŠ ÙˆØ²Ù†  Ù…Ø¹Ø§Ø¯Ù„ 454 Ú¯Ø±Ù… ',0),(63435,1763,'pr','Lbs ÙˆØ§Ø­Ø¯ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ±ÙŠ ÙˆØ²Ù†  Ù…Ø¹Ø§Ø¯Ù„ 454 Ú¯Ø±Ù… ',0),(63436,1763,'tr','Lbs',0),(63437,1763,'pl','Kg',0),(63438,1763,'bg','LBS',0),(63439,1763,'ur','Ù¾ÙˆÙ†Úˆ',0),(63440,1763,'sr','ÐšÐ³',0),(63441,1763,'vi','Pao',0),(63442,1763,'af','LBS',0),(63443,1763,'ro','Lbs',0),(63444,1763,'et','Lbs',0),(63445,1763,'si','Lbs',0),(63446,1763,'ba','Lbs',0),(63447,1763,'nl','Lbs',0),(63448,1763,'fi','Lbs',0),(63449,1763,'no','Kg',0),(63450,1763,'da','Lbs',0),(63451,1763,'ko','íŒŒìš´ë“œ',0),(63452,1763,'he','×§ ×’',0),(63453,1763,'el','Lbs',0),(63454,1763,'zh','ç£…\r\n',0),(63455,1763,'sv','Lbs',0),(63456,1763,'it','Lbs',0),(63457,1763,'tl','',0),(63458,1763,'th','&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(63459,1763,'hi','à¤à¤²à¤¬à¥€à¤à¤¸',0),(63460,1763,'ms','Kg',0),(63461,1763,'ar','Ø±Ø·Ù„',0),(63462,1763,'fr','Lbs',0),(63463,1763,'jp','ãƒ?ãƒ³ãƒ‰',0),(63464,1763,'pt','Lbs',0),(63465,1763,'ru','Ð¤ÑƒÐ½Ñ‚Ð¾Ð²',0),(63466,1763,'es','Lbs',0),(63467,1763,'de','Lbs',0),(63468,1763,'en','Lbs',0),(63469,1764,'is','',0),(63470,1764,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ',0),(63471,1764,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ',0),(63472,1764,'tr','Kalite kurÅŸun',0),(63473,1764,'pl','OÅ‚Ã³w jakoÅ›ci',0),(63474,1764,'bg','ÐžÐ»Ð¾Ð²Ð¾ ÐºÐ°Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(63475,1764,'ur','Ù…Ø¹ÛŒØ§Ø± Ú©ÛŒ Ù‚ÛŒØ§Ø¯Øª',0),(63476,1764,'sr','Ð’Ð¾Ð´Ð¸ ÐºÐ²Ð°Ð»Ð¸Ñ‚ÐµÑ‚Ð°',0),(63477,1764,'vi','Cháº¥t lÆ°á»£ng Dáº«n Ä‘áº§u',0),(63478,1764,'af','Kwaliteit lei',0),(63479,1764,'ro','Duce calitatea',0),(63480,1764,'et','Plii kvaliteet',0),(63481,1764,'si','Svinec kakovosti',0),(63482,1764,'ba','Memimpin kualitas',0),(63483,1764,'nl','Lead kwaliteit',0),(63484,1764,'fi','Lead laatu',0),(63485,1764,'no','Lede kvalitet',0),(63486,1764,'da','FÃ¸re kvalitet',0),(63487,1764,'ko','ë¦¬ë“œ í’ˆì§ˆ',0),(63488,1764,'he','×ž×•×‘×™×œ×™× ×‘××™×›×•×ª',0),(63489,1764,'el','ÎŸÎ´Î·Î³Î®ÏƒÎµÎ¹ Ï„Î·Î½ Ï€Î¿Î¹ÏŒÏ„Î·Ï„Î±',0),(63490,1764,'zh','å¼•å¯¼è´¨é‡\r\n',0),(63491,1764,'sv','Leda kvalitet',0),(63492,1764,'it','Portare la qualitÃ ',0),(63493,1764,'tl','',0),(63494,1764,'th','&#3612;&#3641;&#3657;&#3609;&#3635;&#3588;&#3640;&#3603;&#3616;&#3634;&#3614;',0),(63495,1764,'hi','à¤—à¥à¤£à¤µà¤¤à¥à¤¤à¤¾ à¤•à¤¾ à¤¨à¥‡à¤¤à¥ƒà¤¤à¥à¤µ',0),(63496,1764,'ms','Membawa kualiti',0),(63497,1764,'ar','ØªØ¤Ø¯ÙŠ Ø§Ù„Ø¬ÙˆØ¯Ø©',0),(63498,1764,'fr','Plomb de qualitÃ©',0),(63499,1764,'jp','Lead Quality',0),(63500,1764,'pt','Levar qualidade',0),(63501,1764,'ru','Ð’ÐµÐ´ÑƒÑ‰Ð¸Ðµ ÐºÐ°Ñ‡ÐµÑÑ‚Ð²Ð°',0),(63502,1764,'es','Calidad Dirigente',0),(63503,1764,'de','QualitÃ¤t fÃ¼hren',0),(63504,1764,'en','Lead Quality',0),(63505,1765,'is','',0),(63506,1765,'dr','Ø·ÙˆÙ„ ',0),(63507,1765,'pr','Ø·ÙˆÙ„ ',0),(63508,1765,'tr','Uzunluk',0),(63509,1765,'pl','DÅ‚ugoÅ›Ä‡',0),(63510,1765,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð½Ð°',0),(63511,1765,'ur','Ù„Ù…Ø¨Ø§Ø¦ÛŒ',0),(63512,1765,'sr','Ð”ÑƒÐ¶Ð¸Ð½Ð°',0),(63513,1765,'vi','Chiá»u dÃ i',0),(63514,1765,'af','Lengte',0),(63515,1765,'ro','Lungime',0),(63516,1765,'et','Pikkus',0),(63517,1765,'si','DolÅ¾ina',0),(63518,1765,'ba','Panjang',0),(63519,1765,'nl','Lengte',0),(63520,1765,'fi','Pituus',0),(63521,1765,'no','Lengde',0),(63522,1765,'da','LÃ¦ngde',0),(63523,1765,'ko','ê¸¸ì´',0),(63524,1765,'he','××•×¨×š',0),(63525,1765,'el','ÎœÎ®ÎºÎ¿Ï‚',0),(63526,1765,'zh','é•¿\r\n',0),(63527,1765,'sv','LÃ¤ngd',0),(63528,1765,'it','Lunghezza',0),(63529,1765,'tl','',0),(63530,1765,'th','&#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623;',0),(63531,1765,'hi','à¤²à¤‚à¤¬à¤¾à¤ˆ',0),(63532,1765,'ms','Panjang',0),(63533,1765,'ar','Ø§Ù„Ø·ÙˆÙ„',0),(63534,1765,'fr','Longueur',0),(63535,1765,'jp','é•·ã?•',0),(63536,1765,'pt','Comprimento',0),(63537,1765,'ru','Ð”Ð»Ð¸Ð½Ð°',0),(63538,1765,'es','Largo',0),(63539,1765,'de','LÃ¤nge',0),(63540,1765,'en','Length',0),(63541,1766,'is','',0),(63542,1766,'dr','Ø³Ø·Ø­ ',0),(63543,1766,'pr','Ø³Ø·Ø­ ',0),(63544,1766,'tr','DÃ¼zeyi',0),(63545,1766,'pl','Poziom',0),(63546,1766,'bg','ÐÐ¸Ð²Ð¾',0),(63547,1766,'ur','Ø³Ø·Ø­',0),(63548,1766,'sr','ÐÐ¸Ð²Ð¾',0),(63549,1766,'vi','Má»©c',0),(63550,1766,'af','Vlak',0),(63551,1766,'ro','Nivel',0),(63552,1766,'et','Tase',0),(63553,1766,'si','Ravni',0),(63554,1766,'ba','Tingkat',0),(63555,1766,'nl','Niveau',0),(63556,1766,'fi','Taso',0),(63557,1766,'no','NivÃ¥',0),(63558,1766,'da','Niveau',0),(63559,1766,'ko','ìˆ˜ì¤€',0),(63560,1766,'he','×©×œ×‘',0),(63561,1766,'el','Î•Ï€Î¯Ï€ÎµÎ´Î¿',0),(63562,1766,'zh','çº§åˆ«\r\n',0),(63563,1766,'sv','NivÃ¥',0),(63564,1766,'it','Livello',0),(63565,1766,'tl','',0),(63566,1766,'th','&#3619;&#3632;&#3604;&#3633;&#3610;',0),(63567,1766,'hi','à¤¸à¥à¤¤à¤°',0),(63568,1766,'ms','Tahap',0),(63569,1766,'ar','Ù…Ø³ØªÙˆÙ‰',0),(63570,1766,'fr','Niveau',0),(63571,1766,'jp','ãƒ¬ãƒ™ãƒ«',0),(63572,1766,'pt','NÃ­vel',0),(63573,1766,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ',0),(63574,1766,'es','Nivel',0),(63575,1766,'de','Ebene',0),(63576,1766,'en','Level',0),(63577,1767,'is','',0),(63578,1767,'dr',': Ù†Ù…ÙˆÙ†Ù‡ Ù†Ù…Ø§ÙŠØ´ÙŠ ',0),(63579,1767,'pr','Ø³Ø·Ø­ ÙŠÙƒ : Ù†Ù…ÙˆÙ†Ù‡ Ù†Ù…Ø§ÙŠØ´ÙŠ ',0),(63580,1767,'tr',' Demo',0),(63581,1767,'pl',' Demo',0),(63582,1767,'bg',' Ð”ÐµÐ¼Ð¾',0),(63583,1767,'ur',' ÚˆÛŒÙ…Ùˆ',0),(63584,1767,'sr',' Ð”ÐµÐ¼Ð¾',0),(63585,1767,'vi',' Demo',0),(63586,1767,'af',' Demo',0),(63587,1767,'ro',' Demo',0),(63588,1767,'et',' Demo',0),(63589,1767,'si',' Demo',0),(63590,1767,'ba',' Demo',0),(63591,1767,'nl',' Demo',0),(63592,1767,'fi',' Demo',0),(63593,1767,'no',' Demo',0),(63594,1767,'da',' Demo',0),(63595,1767,'ko',' ë°ëª¨',0),(63596,1767,'he','×“×ž×•',0),(63597,1767,'el',' Demo',0),(63598,1767,'zh','æ¼”ç¤º\r\n',0),(63599,1767,'sv',' Demo',0),(63600,1767,'it',' Demo',0),(63601,1767,'tl','',0),(63602,1767,'th','&#3626;&#3634;&#3608;&#3636;&#3605;',0),(63603,1767,'hi',' à¤¡à¥‡à¤®à¥‹',0),(63604,1767,'ms',' Demo',0),(63605,1767,'ar',' Ø¹Ø±Ø¶ ØªØ¬Ø±ÙŠØ¨ÙŠ',0),(63606,1767,'fr',' DÃ©mo',0),(63607,1767,'jp','ãƒ‡ãƒ¢',0),(63608,1767,'pt',' Demo',0),(63609,1767,'ru',' Ð”ÐµÐ¼Ð¾',0),(63610,1767,'es','Demo',0),(63611,1767,'de',' Demo',0),(63612,1767,'en',' Demo',0),(63613,1768,'is','',0),(63614,1768,'dr',': ÙˆØ§Ø­Ø¯ ØªØ¬Ø§Ø±ØªÛŒ',0),(63615,1768,'pr','Ø³Ø·Ø­ Ø³Ù‡ : ÙˆØ§Ø­Ø¯ ØªØ¬Ø§Ø±ÙŠ',0),(63616,1768,'tr',' Kurumsal',0),(63617,1768,'pl',' PrzedsiÄ™biorstwo',0),(63618,1768,'bg',' ÐŸÑ€ÐµÐ´Ð¿Ñ€Ð¸ÑÑ‚Ð¸ÐµÑ‚Ð¾',0),(63619,1768,'ur',' Ø§Ù†Ù¹Ø±Ù¾Ø±Ø§Ø¦Ø²',0),(63620,1768,'sr',' Ð•Ð½Ñ‚ÐµÑ€Ð¿Ñ€Ð¸ÑÐµ',0),(63621,1768,'vi',' Doanh nghiá»‡p',0),(63622,1768,'af',' Onderneming',0),(63623,1768,'ro',' Intreprindere',0),(63624,1768,'et',' EttevÃµtte',0),(63625,1768,'si',' Podjetje',0),(63626,1768,'ba',' Perusahaan',0),(63627,1768,'nl',' Enterprise',0),(63628,1768,'fi',' Yrityksen',0),(63629,1768,'no',' Enterprise',0),(63630,1768,'da',' Enterprise',0),(63631,1768,'ko',' ì—”í„° í”„ ë¼ì´ì¦ˆ',0),(63632,1768,'he',' ×”××¨×’×•×Ÿ',0),(63633,1768,'el',' Î•Ï€Î¹Ï‡ÎµÎ¯ÏÎ·ÏƒÎ·',0),(63634,1768,'zh','ä¼ä¸š\r\n',0),(63635,1768,'sv',' Enterprise',0),(63636,1768,'it',' Enterprise',0),(63637,1768,'tl','',0),(63638,1768,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3591;&#3634;&#3609;',0),(63639,1768,'hi',' à¤‰à¤¦à¥à¤¯à¤®',0),(63640,1768,'ms',' Enterprise',0),(63641,1768,'ar',' Ø§Ù„Ù…Ø¤Ø³Ø³Ø©',0),(63642,1768,'fr',' Entreprise',0),(63643,1768,'jp','ä¼?æ¥­',0),(63644,1768,'pt',' Enterprise',0),(63645,1768,'ru',' ÐŸÑ€ÐµÐ´Ð¿Ñ€Ð¸ÑÑ‚Ð¸Ðµ',0),(63646,1768,'es','Empresa',0),(63647,1768,'de',' Enterprise',0),(63648,1768,'en',' Enterprise',0),(63649,1769,'is','',0),(63650,1769,'dr',': ØªØ¬Ø§Ø±Øª ',0),(63651,1769,'pr','Ø³Ø·Ø­ Ø¯Ùˆ : ØªØ¬Ø§Ø±Øª ',0),(63652,1769,'tr',' Ä°ÅŸ',0),(63653,1769,'pl',' Biznes',0),(63654,1769,'bg',' Ð‘Ð¸Ð·Ð½ÐµÑ',0),(63655,1769,'ur',' Ú©Ø§Ø±ÙˆØ¨Ø§Ø±',0),(63656,1769,'sr',' ÐŸÐ¾ÑÐ°Ð¾',0),(63657,1769,'vi',' Kinh doanh',0),(63658,1769,'af',' Besigheid',0),(63659,1769,'ro',' Afaceri',0),(63660,1769,'et',' Ã„ri',0),(63661,1769,'si',' Poslovni',0),(63662,1769,'ba',' Bisnis',0),(63663,1769,'nl',' Business',0),(63664,1769,'fi',' Liiketoiminnan',0),(63665,1769,'no',' Business',0),(63666,1769,'da',' Business',0),(63667,1769,'ko',' ë¹„ì¦ˆë‹ˆìŠ¤',0),(63668,1769,'he','×¢×¡×§',0),(63669,1769,'el',' Î•Ï€Î¹Ï‡ÎµÎ¹ÏÎ®ÏƒÎµÏ‰Î½',0),(63670,1769,'zh','å•†åŠ¡\r\n',0),(63671,1769,'sv',' Business',0),(63672,1769,'it',' Affari',0),(63673,1769,'tl','',0),(63674,1769,'th','&#3608;&#3640;&#3619;&#3585;&#3636;&#3592;',0),(63675,1769,'hi',' à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤°',0),(63676,1769,'ms',' Perniagaan',0),(63677,1769,'ar',' Ø§Ù„Ø£Ø¹Ù…Ø§Ù„ Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ©',0),(63678,1769,'fr',' Entreprise',0),(63679,1769,'jp','ãƒ“ã‚¸ãƒ?ã‚¹',0),(63680,1769,'pt',' NegÃ³cios',0),(63681,1769,'ru',' Ð‘Ð¸Ð·Ð½ÐµÑ',0),(63682,1769,'es','Negocio',0),(63683,1769,'de',' GeschÃ¤ft',0),(63684,1769,'en',' Business',0),(63685,1770,'is','',0),(63686,1770,'dr','Ø±Ø¯ÙŠÙ',0),(63687,1770,'pr','Ø±Ø¯ÙŠÙ',0),(63688,1770,'tr','Ã‡izgi',0),(63689,1770,'pl','Linia',0),(63690,1770,'bg','Ð›Ð¸Ð½Ð¸Ñ',0),(63691,1770,'ur','Ù„Ú©ÛŒØ±',0),(63692,1770,'sr','Ð›Ð¸Ð½Ð¸Ñ˜Ð°',0),(63693,1770,'vi','DÃ²ng',0),(63694,1770,'af','Lyn',0),(63695,1770,'ro','Linie',0),(63696,1770,'et','Rida',0),(63697,1770,'si','Line',0),(63698,1770,'ba','Garis',0),(63699,1770,'nl','Lijn',0),(63700,1770,'fi','Rivi',0),(63701,1770,'no','Linje',0),(63702,1770,'da','Linje',0),(63703,1770,'ko','ë¼ì¸',0),(63704,1770,'he','×©×•×¨×”',0),(63705,1770,'el','Î“ÏÎ±Î¼Î¼Î®',0),(63706,1770,'zh','è¡Œ\r\n',0),(63707,1770,'sv','Linje',0),(63708,1770,'it','Linea',0),(63709,1770,'tl','',0),(63710,1770,'th','&#3626;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;',0),(63711,1770,'hi','à¤°à¥‡à¤–à¤¾',0),(63712,1770,'ms','Talian',0),(63713,1770,'ar','Ø®Ø·',0),(63714,1770,'fr','Ligne',0),(63715,1770,'jp','ãƒ©ã‚¤ãƒ³',0),(63716,1770,'pt','Linha',0),(63717,1770,'ru','Ð¡Ñ‚Ñ€Ð¾ÐºÐ°',0),(63718,1770,'es','LÃ­nea',0),(63719,1770,'de','Linie',0),(63720,1770,'en','Line',0),(63721,1771,'is','',0),(63722,1771,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§ ',0),(63723,1771,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§ ',0),(63724,1771,'tr','SatÄ±r Ã¶ÄŸesi ayrÄ±ntÄ±larÄ±',0),(63725,1771,'pl','SzczegÃ³Å‚y elementu wiersza',0),(63726,1771,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(63727,1771,'ur','Ù„Ø§Ø¦Ù† Ø´Û’ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(63728,1771,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(63729,1771,'vi','Chi tiáº¿t dÃ²ng hÃ ng',0),(63730,1771,'af','Lynitem Detail',0),(63731,1771,'ro','Detalii linie element',0),(63732,1771,'et','ReaÃ¼ksuse Detail',0),(63733,1771,'si','Postavko podrobnosti',0),(63734,1771,'ba','Item baris Detail',0),(63735,1771,'nl','Line Item Detail',0),(63736,1771,'fi','Rivitiedot salliva',0),(63737,1771,'no','Linjeelement detaljer',0),(63738,1771,'da','Linjepost detaljer',0),(63739,1771,'ko','ì„  í•­ëª© ì„¸ë¶€ ì •ë³´',0),(63740,1771,'he','×©×•×¨×ª ×¤×¨×˜',0),(63741,1771,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(63742,1771,'zh','è¡Œé¡¹ç›®æ˜Žç»†\r\n',0),(63743,1771,'sv','Radartikel detalj',0),(63744,1771,'it','Dettaglio della voce',0),(63745,1771,'tl','',0),(63746,1771,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3626;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(63747,1771,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£',0),(63748,1771,'ms','Garisan butiran terperinci',0),(63749,1771,'ar','Ø¹Ù†ØµØ± Ø³Ø·Ø± Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(63750,1771,'fr','DÃ©tails de l\'article',0),(63751,1771,'jp','å‹˜å®šç§‘ç›®è©³ç´°',0),(63752,1771,'pt','Detalhes de Item de linha',0),(63753,1771,'ru','Ð¡Ñ‚Ñ€Ð¾ÐºÐ¸ Ð´ÐµÑ‚Ð°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(63754,1771,'es','Item de LÃ­nea Deatlle',0),(63755,1771,'de','Positionszeile Detail',0),(63756,1771,'en','Line Item Detail',0),(63757,1772,'is','',0),(63758,1772,'dr','Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(63759,1772,'pr','Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(63760,1772,'tr','SatÄ±r Ã¶ÄŸeleri',0),(63761,1772,'pl','Pozycje',0),(63762,1772,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ Ñ€ÐµÐ´Ð¾Ð²Ðµ',0),(63763,1772,'ur','Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§Ø¡',0),(63764,1772,'sr','Ð ÐµÐ´Ð° ÑÑ‚Ð°Ð²ÐºÐµ',0),(63765,1772,'vi','DÃ²ng hÃ ng',0),(63766,1772,'af','Lynitems',0),(63767,1772,'ro','Elementele rÃ¢nd',0),(63768,1772,'et','Kirjeid',0),(63769,1772,'si','VrstiÄne postavke',0),(63770,1772,'ba','Item baris',0),(63771,1772,'nl','Regelitems',0),(63772,1772,'fi','Nimikkeet',0),(63773,1772,'no','Linjeelementer',0),(63774,1772,'da','Linjeelementer',0),(63775,1772,'ko','í–‰ í•­ëª©',0),(63776,1772,'he','×¤×¨×™×˜×™ ×”×©×•×¨×”',0),(63777,1772,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(63778,1772,'zh','è¡Œé¡¹ç›®\r\n',0),(63779,1772,'sv','Radartiklar',0),(63780,1772,'it','Elementi pubblicitari',0),(63781,1772,'tl','',0),(63782,1772,'th','&#3626;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(63783,1772,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤®',0),(63784,1772,'ms','Butiran talian',0),(63785,1772,'ar','Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø³Ø·Ø±',0),(63786,1772,'fr','Lignes de facturation',0),(63787,1772,'jp','å‹˜å®šç§‘ç›®',0),(63788,1772,'pt','Itens de linha',0),(63789,1772,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÑÑ‚Ñ€Ð¾ÐºÐ¸',0),(63790,1772,'es','Items de LÃ­nea',0),(63791,1772,'de','Einzelposten',0),(63792,1772,'en','Line Items',0),(63793,1773,'is','',0),(63794,1773,'dr','Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(63795,1773,'pr','Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(63796,1773,'tr','SatÄ±r Ã¶ÄŸeleri sÄ±rayla #',0),(63797,1773,'pl','Pozycje w kolejnoÅ›ci #',0),(63798,1773,'bg','Ð¡ÑŠÑÑ‚Ð°Ð²ÑÑ‰Ð¸Ñ‚Ðµ Ñ€ÐµÐ´Ð¾Ð²Ðµ Ð² Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° #',0),(63799,1773,'ur','Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§Ø¡ ØªØ±ØªÛŒØ¨ Ù…ÛŒÚº #',0),(63800,1773,'sr','Ð ÐµÐ´Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ð¾ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´Ñƒ #',0),(63801,1773,'vi','DÃ²ng máº·t hÃ ng trong Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(63802,1773,'af','Lynitems in Bestelling #',0),(63803,1773,'ro','Elemente Ã®n ordinea #',0),(63804,1773,'et','Read tellimuses nr',0),(63805,1773,'si','Postavke v redu #',0),(63806,1773,'ba','Item baris agar #',0),(63807,1773,'nl','Regelitems in de Order #',0),(63808,1773,'fi','Tilauksen Rivikohtien #',0),(63809,1773,'no','Linjeelementer for #',0),(63810,1773,'da','Linjeelementer i Order #',0),(63811,1773,'ko','ìˆœì„œì— ë”°ë¼ ë¼ì¸ í•­ëª© #',0),(63812,1773,'he','×¤×¨×™×˜×™ ×”×©×•×¨×” ×¢×œ ×ž× ×ª #',0),(63813,1773,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± #',0),(63814,1773,'zh','è®¢å•å·è¡Œé¡¹ç›®\r\n',0),(63815,1773,'sv','Radobjekt i ordern #',0),(63816,1773,'it','Voci in ordine #',0),(63817,1773,'tl','',0),(63818,1773,'th','&#3626;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(63819,1773,'hi','à¤²à¤¾à¤‡à¤¨ à¤†à¤‡à¤Ÿà¤® à¤•à¥à¤°à¤® à¤®à¥‡à¤‚ #',0),(63820,1773,'ms','Laluan item dalam pesanan #',0),(63821,1773,'ar','Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø³Ø·Ø± ÙÙŠ ØªØ±ØªÙŠØ¨ #',0),(63822,1773,'fr','Articles de ligne de commande #',0),(63823,1773,'jp','æ³¨æ–‡ç•ªå?·ã?®å‹˜å®šç§‘ç›®',0),(63824,1773,'pt','Itens de linha na ordem #',0),(63825,1773,'ru','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ð¹ Ð² Ð·Ð°ÐºÐ°Ð·Ðµ #',0),(63826,1773,'es','Items de LÃ­nea en el Orden #',0),(63827,1773,'de','Einzelposten in Reihenfolge #',0),(63828,1773,'en','Line items in Order #',0),(63829,1774,'is','',0),(63830,1774,'dr','Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(63831,1774,'pr','Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(63832,1774,'tr','SatÄ±r Ã¶ÄŸeleri po #',0),(63833,1774,'pl','Pozycje w PO #',0),(63834,1774,'bg','Ð¡ÑŠÑÑ‚Ð°Ð²ÑÑ‰Ð¸Ñ‚Ðµ Ñ€ÐµÐ´Ð¾Ð²Ðµ Ð² PO #',0),(63835,1774,'ur','Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§Ø¡ Ù…ÛŒÚº Ù¾Ùˆ #',0),(63836,1774,'sr','Ð ÐµÐ´Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ ÐŸÐž #',0),(63837,1774,'vi','DÃ²ng hÃ ng trong Ä‘Æ¡n mua hÃ ng sá»‘',0),(63838,1774,'af','Lynitems in AB #',0),(63839,1774,'ro','Articolele din linia de op #',0),(63840,1774,'et','Read ostutellimuses nr',0),(63841,1774,'si','Postavke v PO #',0),(63842,1774,'ba','Item baris di PO #',0),(63843,1774,'nl','Regelitems in PO #',0),(63844,1774,'fi','Rivikohtien PO #',0),(63845,1774,'no','Linjeelementene i PO #',0),(63846,1774,'da','Linjeelementer i PO #',0),(63847,1774,'ko','í¬ ë¼ì¸ í•­ëª© #',0),(63848,1774,'he','×¤×¨×™×˜×™ ×”×©×•×¨×” ×¤×• #',0),(63849,1774,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ„Î·Î½ PO #',0),(63850,1774,'zh','é‡‡è´­è®¢å•å·è¡Œé¡¹ç›®\r\n',0),(63851,1774,'sv','Radartiklarna i PO #',0),(63852,1774,'it','Elementi di linea nel PO #',0),(63853,1774,'tl','',0),(63854,1774,'th','&#3626;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3',0),(63855,1774,'hi','à¤²à¤¾à¤‡à¤¨ à¤†à¤‡à¤Ÿà¤® à¤®à¥‡à¤‚ à¤ªà¥€à¤“ #',0),(63856,1774,'ms','Laluan item dalam PO #',0),(63857,1774,'ar','Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø³Ø·Ø± ÙÙŠ Øµ. Ø¨ #',0),(63858,1774,'fr','Articles d\'exÃ©cution PO #',0),(63859,1774,'jp','ç™ºæ³¨ç•ªå?·ã?®å‹˜å®šç§‘ç›®',0),(63860,1774,'pt','Itens de linha em PO #',0),(63861,1774,'ru','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ð¹ Ð² PO #',0),(63862,1774,'es','Items de LÃ­nea en el OC #',0),(63863,1774,'de','Einzelposten in PO #',0),(63864,1774,'en','Line items in PO #',0),(63865,1775,'is','',0),(63866,1775,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø±Ø¯ÙŠÙ',0),(63867,1775,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø±Ø¯ÙŠÙ',0),(63868,1775,'tr','# SatÄ±r',0),(63869,1775,'pl','Linia #',0),(63870,1775,'bg','Ð›Ð¸Ð½Ð¸Ñ #',0),(63871,1775,'ur','Ù„Ø§Ø¦Ù† Ù†Ù…Ø¨Ø±',0),(63872,1775,'sr','Ð›Ð¸Ð½Ð¸Ñ˜Ð° #',0),(63873,1775,'vi','DÃ²ng sá»‘',0),(63874,1775,'af','Lyn #',0),(63875,1775,'ro','Linie #',0),(63876,1775,'et','Rea nr',0),(63877,1775,'si','Line #',0),(63878,1775,'ba','Baris #',0),(63879,1775,'nl','Regel #',0),(63880,1775,'fi','Rivi',0),(63881,1775,'no','Linje nummer',0),(63882,1775,'da','Linje #',0),(63883,1775,'ko','# ë¼ì¸',0),(63884,1775,'he','×§×• #',0),(63885,1775,'el','Î“ÏÎ±Î¼Î¼Î® #',0),(63886,1775,'zh','è¡Œï¼ƒ\r\n',0),(63887,1775,'sv','Rad #',0),(63888,1775,'it','Linea #',0),(63889,1775,'tl','',0),(63890,1775,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3626;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(63891,1775,'hi','à¤²à¤¾à¤‡à¤¨ #',0),(63892,1775,'ms','Talian #',0),(63893,1775,'ar','Ø±Ù‚Ù… Ø§Ù„Ø³Ø·Ø±',0),(63894,1775,'fr','No de ligne',0),(63895,1775,'jp','ãƒ©ã‚¤ãƒ³ç•ªå?·',0),(63896,1775,'pt','Linha #',0),(63897,1775,'ru','Ð¡Ñ‚Ñ€Ð¾ÐºÐ° #',0),(63898,1775,'es','Linea #',0),(63899,1775,'de','Linie #',0),(63900,1775,'en','Line #',0),(63901,1776,'is','',0),(63902,1776,'dr','Ù„ÙŠØ³Øª ',0),(63903,1776,'pr','Ù„ÙŠØ³Øª ',0),(63904,1776,'tr','Liste',0),(63905,1776,'pl','Lista',0),(63906,1776,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº',0),(63907,1776,'ur','ÙÛØ±Ø³Øª',0),(63908,1776,'sr','Ð›Ð¸ÑÑ‚Ð°',0),(63909,1776,'vi','Danh sÃ¡ch',0),(63910,1776,'af','Lys',0),(63911,1776,'ro','Lista',0),(63912,1776,'et','Nimekiri',0),(63913,1776,'si','Seznam',0),(63914,1776,'ba','Daftar',0),(63915,1776,'nl','Lijst',0),(63916,1776,'fi','Luettelo',0),(63917,1776,'no','Liste',0),(63918,1776,'da','Liste',0),(63919,1776,'ko','ëª©ë¡',0),(63920,1776,'he','×¨×©×™×ž×”',0),(63921,1776,'el','Î›Î¯ÏƒÏ„Î±',0),(63922,1776,'zh','åˆ—è¡¨\r\n',0),(63923,1776,'sv','Lista',0),(63924,1776,'it','Elenco',0),(63925,1776,'tl','',0),(63926,1776,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(63927,1776,'hi','à¤¸à¥‚à¤šà¥€',0),(63928,1776,'ms','Senarai',0),(63929,1776,'ar','Ù‚Ø§Ø¦Ù…Ø©',0),(63930,1776,'fr','Liste',0),(63931,1776,'jp','ãƒªã‚¹ãƒˆ',0),(63932,1776,'pt','Lista',0),(63933,1776,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº',0),(63934,1776,'es','Lista ',0),(63935,1776,'de','Liste',0),(63936,1776,'en','List',0),(63937,1777,'is','',0),(63938,1777,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(63939,1777,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(63940,1777,'tr','FaturalandÄ±rÄ±lmamÄ±ÅŸ tÃ¼m sipariÅŸleri listesi',0),(63941,1777,'pl','Lista wszystkich zleceÅ„ nieopÅ‚aconych',0),(63942,1777,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Unbilled',0),(63943,1777,'ur','ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„ Ú©Û’ ØªÙ…Ø§Ù… Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(63944,1777,'sr','Ð›Ð¸ÑÑ‚Ð° ÑÐ²Ð¸Ñ… Ð£Ð½Ð±Ð¸Ð»Ð»ÐµÐ´ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(63945,1777,'vi','Liá»‡t kÃª táº¥t cáº£ cÃ¡c ÄÆ¡n HÃ ng ChÆ°a Ra HÃ³a ÄÆ¡n',0),(63946,1777,'af','Lys alle Ongefaktureerde Bestellings',0),(63947,1777,'ro','Lista toate comenzile Unbilled',0),(63948,1777,'et','Reasta kÃµik ilma arveta tellimused',0),(63949,1777,'si','Seznam vseh Unbilled naroÄila',0),(63950,1777,'ba','Daftar semua perintah yang belum ditagih',0),(63951,1777,'nl','Lijst van alle nog niet gefactureerde Orders',0),(63952,1777,'fi','Luettelo Unbilled tilauksista',0),(63953,1777,'no','Liste alle fakturert ordre',0),(63954,1777,'da','Liste over alle faktureret ordrer',0),(63955,1777,'ko','ëª¨ë“  ë° ì£¼ë¬¸ ëª©ë¡',0),(63956,1777,'he','×¤×¨×˜ ××ª ×›×œ ×”×”×–×ž× ×•×ª Unbilled',0),(63957,1777,'el','Î›Î¯ÏƒÏ„Î± ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Î±Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î·',0),(63958,1777,'zh','åˆ—è¡¨ä¸­çš„æ‰€æœ‰æœªå¼€å•è®¢å•\r\n',0),(63959,1777,'sv','Lista alla relaterade order',0),(63960,1777,'it','Elencare tutti gli ordini di attivitÃ  non ancora fatturati',0),(63961,1777,'tl','',0),(63962,1777,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3',0),(63963,1777,'hi','à¤¸à¤­à¥€ Unbilled à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(63964,1777,'ms','Senarai semua pesanan lepas',0),(63965,1777,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨ÙƒØ§ÙØ© Ø£ÙˆØ§Ù…Ø± ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(63966,1777,'fr','La liste de toutes les commandes non facturÃ©es',0),(63967,1777,'jp','å…¨æœªè«‹æ±‚æ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(63968,1777,'pt','Listar todas as ordens nÃ£o faturadas',0),(63969,1777,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð²ÑÐµÑ… Ð½ÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(63970,1777,'es','Listar Todos los Ordenes no Facturados',0),(63971,1777,'de','Liste aller noch nicht fakturierte AuftrÃ¤ge',0),(63972,1777,'en','List All Unbilled Orders',0),(63973,1778,'is','',0),(63974,1778,'dr','Ù†Ø§Ù… Ù„ÙŠØ³Øª ',0),(63975,1778,'pr','Ù†Ø§Ù… Ù„ÙŠØ³Øª ',0),(63976,1778,'tr','Liste adÄ±',0),(63977,1778,'pl','Nazwa listy',0),(63978,1778,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(63979,1778,'ur','ÙÛØ±Ø³Øª Ú©Ø§ Ù†Ø§Ù…',0),(63980,1778,'sr','Ð˜Ð¼Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(63981,1778,'vi','Danh sÃ¡ch tÃªn',0),(63982,1778,'af','Lys Naam',0),(63983,1778,'ro','Nume listÄƒ',0),(63984,1778,'et','Loendi nimi',0),(63985,1778,'si','Ime seznama',0),(63986,1778,'ba','Daftar nama',0),(63987,1778,'nl','Naam van lijst',0),(63988,1778,'fi','Luettelonimi',0),(63989,1778,'no','Listenavnet',0),(63990,1778,'da','Listenavnet',0),(63991,1778,'ko','ëª©ë¡ ì´ë¦„',0),(63992,1778,'he','×©× ×¨×©×™×ž×ª',0),(63993,1778,'el','ÎŒÎ½Î¿Î¼Î± Î»Î¯ÏƒÏ„Î±Ï‚',0),(63994,1778,'zh','åˆ—è¡¨åç§°\r\n',0),(63995,1778,'sv','Listnamn',0),(63996,1778,'it','Nome elenco',0),(63997,1778,'tl','',0),(63998,1778,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3594;&#3639;&#3656;&#3629;\n',0),(63999,1778,'hi','à¤¸à¥‚à¤šà¥€ à¤¨à¤¾à¤®',0),(64000,1778,'ms','Senarai nama',0),(64001,1778,'ar','Ø§Ø³Ù… Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(64002,1778,'fr','Nom de la liste',0),(64003,1778,'jp','ãƒªã‚¹ãƒˆå??',0),(64004,1778,'pt','Nome da lista',0),(64005,1778,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¡Ð¿Ð¸ÑÐºÐ°',0),(64006,1778,'es','Listar Nombre',0),(64007,1778,'de','Name der Liste',0),(64008,1778,'en','List Name',0),(64009,1779,'is','',0),(64010,1779,'dr','   Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø±Ø§ Ù„ÙŠØ³Øª ÙƒÙ†ÙŠØ¯ ',0),(64011,1779,'pr','   Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø±Ø§ Ù„ÙŠØ³Øª ÙƒÙ†ÙŠØ¯ ',0),(64012,1779,'tr','FaturalandÄ±rÄ±lmamÄ±ÅŸ tamamlanmÄ±ÅŸ sipariÅŸleri listesi',0),(64013,1779,'pl','Lista zleceÅ„ nieopÅ‚aconych zakoÅ„czone',0),(64014,1779,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Unbilled Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(64015,1779,'ur','ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„ Ù…Ú©Ù…Ù„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(64016,1779,'sr','Ð¡Ð¿Ð¸ÑÐ°Ðº Ð£Ð½Ð±Ð¸Ð»Ð»ÐµÐ´ Ð¿Ð¾Ð¿ÑƒÑšÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(64017,1779,'vi','Danh SÃ¡ch CÃ¡c ÄÆ¡n HÃ ng ÄÃ£ HoÃ n Táº¥t ChÆ°a Láº­p HÃ³a ÄÆ¡n',0),(64018,1779,'af','Lys Slegs Faktureerde Voltooide Bestellings',0),(64019,1779,'ro','Lista de comenzi finalizate Unbilled',0),(64020,1779,'et','Reasta ilma arveta lÃµpetatud tellimused',0),(64021,1779,'si','Seznam Unbilled dopolnil naroÄila',0),(64022,1779,'ba','Daftar tertagih menyelesaikan pesanan',0),(64023,1779,'nl','Lijst van ongefactureerde voltooide bestellingen',0),(64024,1779,'fi','Luettelo Unbilled valmiiksi saaduista tilauksista',0),(64025,1779,'no','Liste fakturert fullfÃ¸rt ordre',0),(64026,1779,'da','Liste over faktureret fÃ¦rdige ordrer',0),(64027,1779,'ko','ë° ì™„ë£Œ ëœ ì£¼ë¬¸ ëª©ë¡',0),(64028,1779,'he','×¨×©×™×ž×ª ×”×–×ž× ×•×ª ×©×”×•×©×œ×ž×• Unbilled',0),(64029,1779,'el','Î›Î¯ÏƒÏ„Î± Î±Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÏƒÏ…Î¼Ï€Î»Î·ÏÏ‰Î¸ÎµÎ¯',0),(64030,1779,'zh','åå•æœªå¼€å•å®Œæˆè®¢å•\r\n',0),(64031,1779,'sv','Lista Ã¶ver relaterade avslutade bestÃ¤llningar',0),(64032,1779,'it','Elencare le attivitÃ  non ancora fatturati ordini completati',0),(64033,1779,'tl','',0),(64034,1779,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3648;&#3619;&#3637;&#3',0),(64035,1779,'hi','Unbilled à¤ªà¥‚à¤°à¥à¤£ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(64036,1779,'ms','Senarai pesanan lengkap yang lepas',0),(64037,1779,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø© ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(64038,1779,'fr','La liste des commandes exÃ©cutÃ©es non facturÃ©s',0),(64039,1779,'jp','æœªè«‹æ±‚å®Œäº†æ¸ˆæ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(64040,1779,'pt','Lista de ordens concluÃ­das nÃ£o faturadas',0),(64041,1779,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð½ÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(64042,1779,'es','Listar Ordenes Incompletos No Facturados',0),(64043,1779,'de','Liste noch nicht fakturierte abgeschlossene AuftrÃ¤ge',0),(64044,1779,'en','List Unbilled Completed Orders',0),(64045,1780,'is','',0),(64046,1780,'dr','Ù„ÙŠØ³Øª Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ù…ÙŠ Ø´ÙˆØ¯ Ø·Ø¨Ù‚',0),(64047,1780,'pr','Ù„ÙŠØ³Øª Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ù…ÙŠ Ø´ÙˆØ¯ Ø·Ø¨Ù‚',0),(64048,1780,'tr','Listeyi sÄ±ralama Ã¶lÃ§Ã¼tÃ¼',0),(64049,1780,'pl','Sortowanie listy',0),(64050,1780,'bg','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¿Ð¾',0),(64051,1780,'ur','ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù†Ù¹ÛŒÚº Ø¨Ù…Ø·Ø§Ø¨Ù‚',0),(64052,1780,'sr','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ˜ Ð»Ð¸ÑÑ‚Ñƒ Ð¿Ð¾',0),(64053,1780,'vi','Danh sÃ¡ch sáº¯p xáº¿p theo',0),(64054,1780,'af','Sorteer Lys Volgens',0),(64055,1780,'ro','Sortarea listei de',0),(64056,1780,'et','Loendi Sortimisalus:',0),(64057,1780,'si','Seznam Razvrsti po',0),(64058,1780,'ba','Daftar Urutkan',0),(64059,1780,'nl','Lijst sorteren op',0),(64060,1780,'fi','Luettelon lajitteleminen',0),(64061,1780,'no','Listen Sorter etter',0),(64062,1780,'da','Listen Sorter efter',0),(64063,1780,'ko','ëª©ë¡ ì •ë ¬ ê¸°ì¤€',0),(64064,1780,'he','×”×¨×©×™×ž×” ×ž×™×™×Ÿ ×œ×¤×™',0),(64065,1780,'el','Î›Î¯ÏƒÏ„Î± Î¼Îµ Ï„Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ· ÎºÎ±Ï„Î¬',0),(64066,1780,'zh','åˆ—å‡ºåˆ†ç±»å› ç´ ',0),(64067,1780,'sv','Listan Sortera efter',0),(64068,1780,'it','Ordina elenco per',0),(64069,1780,'tl','',0),(64070,1780,'th','&#3592;&#3633;&#3604;&#3648;&#3619;&#3637;&#3618;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3650;&#3604;&#3618;',0),(64071,1780,'hi','à¤¸à¥‚à¤šà¥€ à¤¸à¥‡ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(64072,1780,'ms','Senarai Susun mengikut',0),(64073,1780,'ar','ÙØ±Ø² Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø¨',0),(64074,1780,'fr','Listes triÃ©es par',0),(64075,1780,'jp','ãƒªã‚¹ãƒˆã?®ä¸¦ã?¹æ›¿ã?ˆ',0),(64076,1780,'pt','Ordenar lista por',0),(64077,1780,'ru','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐŸÐ¾',0),(64078,1780,'es','Listar Sortear Por',0),(64079,1780,'de','Liste Sortieren nach',0),(64080,1780,'en','List Sort By',0),(64081,1781,'is','',0),(64082,1781,'dr','Ln # Ø´Ù…Ø§Ø±Ù‡ ÙˆØ§Ù…',0),(64083,1781,'pr','Ln # Ø´Ù…Ø§Ø±Ù‡ ÙˆØ§Ù…',0),(64084,1781,'tr','LN #',0),(64085,1781,'pl','Ln #',0),(64086,1781,'bg','LN #',0),(64087,1781,'ur','Ù„Ù† #',0),(64088,1781,'sr','Ð£ #',0),(64089,1781,'vi','Sá»‘ Ln',0),(64090,1781,'af','Ln #',0),(64091,1781,'ro','Ln #',0),(64092,1781,'et','Nr:',0),(64093,1781,'si','Ln #',0),(64094,1781,'ba','LN #',0),(64095,1781,'nl','LN #',0),(64096,1781,'fi','LN #',0),(64097,1781,'no','Ln #',0),(64098,1781,'da','LN #',0),(64099,1781,'ko','Ln #',0),(64100,1781,'he','Ln #',0),(64101,1781,'el','LN #',0),(64102,1781,'zh','ç¨€åœŸï¼ƒ\r\n',0),(64103,1781,'sv','Ln #',0),(64104,1781,'it','Ln #',0),(64105,1781,'tl','',0),(64106,1781,'th','Ln #',0),(64107,1781,'hi','Ln #',0),(64108,1781,'ms','Ln #',0),(64109,1781,'ar','Ln #',0),(64110,1781,'fr','Ln #',0),(64111,1781,'jp','ãƒ©ã‚¤ãƒ³ç•ªå?·',0),(64112,1781,'pt','Ln #',0),(64113,1781,'ru','LN #',0),(64114,1781,'es','Ln #',0),(64115,1781,'de','Ln #',0),(64116,1781,'en','Ln #',0),(64117,1782,'is','',0),(64118,1782,'dr','Ù…Ø­Ù„ÙŠ ',0),(64119,1782,'pr','Ù…Ø­Ù„ÙŠ ',0),(64120,1782,'tr','Yerel',0),(64121,1782,'pl','Lokalne',0),(64122,1782,'bg','ÐœÐµÑÑ‚Ð½Ð¸',0),(64123,1782,'ur','Ù…Ù‚Ø§Ù…ÛŒ',0),(64124,1782,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¸',0),(64125,1782,'vi','Äá»‹a phÆ°Æ¡ng',0),(64126,1782,'af','Plaaslik',0),(64127,1782,'ro','Locale',0),(64128,1782,'et','Kohaliku',0),(64129,1782,'si','Lokalni',0),(64130,1782,'ba','Lokal',0),(64131,1782,'nl','Lokale',0),(64132,1782,'fi','Paikallinen',0),(64133,1782,'no','Lokale',0),(64134,1782,'da','Lokale',0),(64135,1782,'ko','ì§€ì—­',0),(64136,1782,'he','×ž×§×•×ž×™',0),(64137,1782,'el','Î¤Î¿Ï€Î¹ÎºÎ®',0),(64138,1782,'zh','åœ°æ–¹\r\n',0),(64139,1782,'sv','Lokala',0),(64140,1782,'it','Locale',0),(64141,1782,'tl','',0),(64142,1782,'th','&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;',0),(64143,1782,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯',0),(64144,1782,'ms','Tempatan',0),(64145,1782,'ar','Ù…Ø­Ù„ÙŠ',0),(64146,1782,'fr','Local',0),(64147,1782,'jp','åœ°æ–¹',0),(64148,1782,'pt','Local',0),(64149,1782,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ðµ',0),(64150,1782,'es','Local',0),(64151,1782,'de','Lokale',0),(64152,1782,'en','Local',0),(64153,1783,'is','',0),(64154,1783,'dr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ÙŠ Ù…Ø­Ù„ÙŠ',0),(64155,1783,'pr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ÙŠ Ù…Ø­Ù„ÙŠ',0),(64156,1783,'tr','Yerel muafiyetler',0),(64157,1783,'pl','Lokalne zwolnienia',0),(64158,1783,'bg','ÐœÐµÑÑ‚Ð½Ð¸ Ð¸Ð·ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ',0),(64159,1783,'ur','Ù…Ù‚Ø§Ù…ÛŒ Ø§Ø³ØªØ«Ù†Ø§Ø¦ÛŒÚº',0),(64160,1783,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ðµ Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(64161,1783,'vi','Miá»…n trá»« Äá»‹a phÆ°Æ¡ng',0),(64162,1783,'af','Plaaslike Vrystellings',0),(64163,1783,'ro','Scutiri locale',0),(64164,1783,'et','Kohalike erandite',0),(64165,1783,'si','Lokalni izjeme',0),(64166,1783,'ba','Pengecualian lokal',0),(64167,1783,'nl','Lokale vrijstellingen',0),(64168,1783,'fi','Paikallisia Vapautukset',0),(64169,1783,'no','Lokale unntak',0),(64170,1783,'da','Lokale undtagelser',0),(64171,1783,'ko','ì§€ì—­ ë©´ì œ',0),(64172,1783,'he','×¤×˜×•×¨×™× ×ž×§×•×ž×™',0),(64173,1783,'el','Î¤Î¿Ï€Î¹ÎºÎ­Ï‚ ÎµÎ¾Î±Î¹ÏÎ­ÏƒÎµÎ¹Ï‚',0),(64174,1783,'zh','æœ¬åœ°è±å…\r\n',0),(64175,1783,'sv','Lokala undantag',0),(64176,1783,'it','Esenzioni locali',0),(64177,1783,'tl','',0),(64178,1783,'th','&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;',0),(64179,1783,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤®à¥‡à¤‚ à¤›à¥‚à¤Ÿ',0),(64180,1783,'ms','Pengecualian-pengecualian yang tempatan',0),(64181,1783,'ar','Ø§Ù„Ø¥Ø¹ÙØ§Ø¡Ø§Øª Ø§Ù„Ù…Ø­Ù„ÙŠØ©',0),(64182,1783,'fr','DÃ©rogations locales',0),(64183,1783,'jp','åœ°æ–¹æŽ§é™¤',0),(64184,1783,'pt','IsenÃ§Ãµes locais',0),(64185,1783,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ðµ Ð¸ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ',0),(64186,1783,'es','Exenciones Locales',0),(64187,1783,'de','Lokale Ausnahmen',0),(64188,1783,'en','Local Exemptions',0),(64189,1784,'is','',0),(64190,1784,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ø¯Ø§Ø®Ù„ÙŠ ',0),(64191,1784,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ø¯Ø§Ø®Ù„ÙŠ ',0),(64192,1784,'tr','Yerel gelir vergisi',0),(64193,1784,'pl','Podatek dochodowy',0),(64194,1784,'bg','ÐœÐµÑÑ‚ÐµÐ½ Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð´Ð¾Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(64195,1784,'ur','Ù…Ù‚Ø§Ù…ÛŒ Ø§Ù†Ú©Ù… Ù¹ÛŒÚ©Ø³',0),(64196,1784,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð´Ð¾Ñ…Ð¾Ð´Ð°Ðº',0),(64197,1784,'vi','Thuáº¿ thu nháº­p Äá»‹a phÆ°Æ¡ng',0),(64198,1784,'af','Plaaslike Inkomstebelasting',0),(64199,1784,'ro','Impozitul pe venit locale',0),(64200,1784,'et','Kohalik tulumaks',0),(64201,1784,'si','Lokalni davek od dohodka',0),(64202,1784,'ba','Pajak pendapatan daerah',0),(64203,1784,'nl','Lokale inkomstenbelasting',0),(64204,1784,'fi','Paikallista veroa',0),(64205,1784,'no','Inntektsskatten',0),(64206,1784,'da','Lokal indkomstskat',0),(64207,1784,'ko','í˜„ì§€ ì†Œë“ì„¸',0),(64208,1784,'he','×ž×¡ ×”×›× ×¡×” ×ž×§×•×ž×™',0),(64209,1784,'el','Î¤Î¿Ï€Î¹ÎºÏŒ Ï†ÏŒÏÎ¿ ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(64210,1784,'zh','åœ°æ–¹æ‰€å¾—ç¨Ž\r\n',0),(64211,1784,'sv','Lokal inkomstskatt',0),(64212,1784,'it','IRPEF locale',0),(64213,1784,'tl','',0),(64214,1784,'th','&#3616;&#3634;&#3625;&#3637;&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;',0),(64215,1784,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤†à¤¯à¤•à¤°',0),(64216,1784,'ms','Cukai pendapatan tempatan',0),(64217,1784,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯Ø®Ù„ Ø§Ù„Ù…Ø­Ù„ÙŠ',0),(64218,1784,'fr','ImpÃ´t sur le revenu local',0),(64219,1784,'jp','åœ°æ–¹æ‰€å¾—ç¨Ž',0),(64220,1784,'pt','Imposto de renda local',0),(64221,1784,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ðµ Ð¿Ð¾Ð´Ð¾Ñ…Ð¾Ð´Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(64222,1784,'es','Impuesto Sobre La Renta Local',0),(64223,1784,'de','Lokale Einkommensteuer',0),(64224,1784,'en','Local Income Tax',0),(64225,1785,'is','',0),(64226,1785,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø­Ù„ÙŠ ',0),(64227,1785,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø­Ù„ÙŠ ',0),(64228,1785,'tr','Yerel vergi',0),(64229,1785,'pl','Podatek',0),(64230,1785,'bg','ÐœÐµÑÑ‚ÐµÐ½ Ð´Ð°Ð½ÑŠÐº',0),(64231,1785,'ur','Ù„ÙˆÚ©Ù„ Ù¹ÛŒÚ©Ø³',0),(64232,1785,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¸Ñ… Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(64233,1785,'vi','Thuáº¿ Äá»‹a phÆ°Æ¡ng',0),(64234,1785,'af','Plaaslike Belasting',0),(64235,1785,'ro','Taxe locale',0),(64236,1785,'et','Kohalike maksude',0),(64237,1785,'si','Lokalni davek',0),(64238,1785,'ba','Pajak daerah',0),(64239,1785,'nl','Toeristenbelasting',0),(64240,1785,'fi','Paikallinen vero',0),(64241,1785,'no','Lokale',0),(64242,1785,'da','Lokal skat',0),(64243,1785,'ko','ì§€ë°© ì„¸',0),(64244,1785,'he','×ž×¡ ×ž×§×•×ž×™',0),(64245,1785,'el','Î”.Î¿.Ï…',0),(64246,1785,'zh','åœ°æ–¹ç¨Ž\r\n',0),(64247,1785,'sv','Lokal skatt',0),(64248,1785,'it','Tassa locale',0),(64249,1785,'tl','',0),(64250,1785,'th','&#3616;&#3634;&#3625;&#3637;&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;',0),(64251,1785,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(64252,1785,'ms','Cukai tempatan',0),(64253,1785,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø­Ù„ÙŠØ©',0),(64254,1785,'fr','Taxe locale',0),(64255,1785,'jp','åœ°æ–¹ç¨Ž',0),(64256,1785,'pt','Impostos locais',0),(64257,1785,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(64258,1785,'es','Impusto Local',0),(64259,1785,'de','Ortstaxe',0),(64260,1785,'en','Local Tax',0),(64261,1786,'is','',0),(64262,1786,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø­Ù„ÙŠ ',0),(64263,1786,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø­Ù„ÙŠ ',0),(64264,1786,'tr','Yerel vergi',0),(64265,1786,'pl','Podatek',0),(64266,1786,'bg','ÐœÐµÑÑ‚ÐµÐ½ Ð´Ð°Ð½ÑŠÐº',0),(64267,1786,'ur','Ù„ÙˆÚ©Ù„ Ù¹ÛŒÚ©Ø³',0),(64268,1786,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¸Ñ… Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(64269,1786,'vi','Thuáº¿ Äá»‹a phÆ°Æ¡ng',0),(64270,1786,'af','Plaaslike Belasting',0),(64271,1786,'ro','Taxe locale',0),(64272,1786,'et','Kohalike maksude',0),(64273,1786,'si','Lokalni davek',0),(64274,1786,'ba','Pajak daerah',0),(64275,1786,'nl','Toeristenbelasting',0),(64276,1786,'fi','Paikallinen vero',0),(64277,1786,'no','Lokale',0),(64278,1786,'da','Lokal skat',0),(64279,1786,'ko','ì§€ë°© ì„¸',0),(64280,1786,'he','×ž×¡ ×ž×§×•×ž×™',0),(64281,1786,'el','Î”.Î¿.Ï…',0),(64282,1786,'zh','åœ°æ–¹ç¨Ž\r\n',0),(64283,1786,'sv','Lokal skatt',0),(64284,1786,'it','Tassa locale',0),(64285,1786,'tl','',0),(64286,1786,'th','&#3616;&#3634;&#3625;&#3637;&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;',0),(64287,1786,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(64288,1786,'ms','Cukai tempatan',0),(64289,1786,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø­Ù„ÙŠØ©',0),(64290,1786,'fr','Taxe locale',0),(64291,1786,'jp','åœ°æ–¹ç¨Ž',0),(64292,1786,'pt','Impostos locais',0),(64293,1786,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(64294,1786,'es','Impuesto Local',0),(64295,1786,'de','Ortstaxe',0),(64296,1786,'en','Local Tax',0),(64297,1787,'is','',0),(64298,1787,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù‡Ø§ÙŠ Ù…Ø­Ù„ÙŠ ',0),(64299,1787,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù‡Ø§ÙŠ Ù…Ø­Ù„ÙŠ ',0),(64300,1787,'tr','Yerel Ã¼cretler',0),(64301,1787,'pl','Lokalne pÅ‚ace',0),(64302,1787,'bg','ÐœÐµÑÑ‚Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(64303,1787,'ur','Ù…Ù‚Ø§Ù…ÛŒ Ø§Ø¬Ø±Øª',0),(64304,1787,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð° Ð¿Ñ€Ð¸Ð¼Ð°ÑšÐ°',0),(64305,1787,'vi','LÆ°Æ¡ng Äá»‹a phÆ°Æ¡ng',0),(64306,1787,'af','Plaaslike Besoldiging',0),(64307,1787,'ro','Salarii locale',0),(64308,1787,'et','Kohalike palkade',0),(64309,1787,'si','Lokalne plaÄe',0),(64310,1787,'ba','Upah lokal',0),(64311,1787,'nl','Lokale lonen',0),(64312,1787,'fi','Paikalliset palkat',0),(64313,1787,'no','Lokal lÃ¸nn',0),(64314,1787,'da','Lokal lÃ¸n',0),(64315,1787,'ko','í˜„ì§€ ìž„ê¸ˆ',0),(64316,1787,'he','×©×›×¨ ×ž×§×•×ž×™',0),(64317,1787,'el','Î¤Î¿Ï€Î¹ÎºÏŒ Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(64318,1787,'zh','æœ¬åœ°å·¥èµ„\r\n',0),(64319,1787,'sv','Lokala lÃ¶ner',0),(64320,1787,'it','Salari locali',0),(64321,1787,'tl','',0),(64322,1787,'th','&#3588;&#3656;&#3634;&#3649;&#3619;&#3591;&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;',0),(64323,1787,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(64324,1787,'ms','Upah tempatan',0),(64325,1787,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± Ø§Ù„Ù…Ø­Ù„ÙŠØ©',0),(64326,1787,'fr','Salaires les',0),(64327,1787,'jp','åœ°æ–¹è³ƒé‡‘',0),(64328,1787,'pt','SalÃ¡rios locais',0),(64329,1787,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(64330,1787,'es','Sueldos Locales',0),(64331,1787,'de','Lokale LÃ¶hne',0),(64332,1787,'en','Local Wages',0),(64333,1788,'is','',0),(64334,1788,'dr','Ù…ÙƒØ§Ù† ',0),(64335,1788,'pr','Ù…ÙƒØ§Ù† ',0),(64336,1788,'tr','Konumu',0),(64337,1788,'pl','Lokalizacja',0),(64338,1788,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(64339,1788,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(64340,1788,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(64341,1788,'vi','Vá»‹ trÃ­',0),(64342,1788,'af','Ligging',0),(64343,1788,'ro','LocaÅ£ie',0),(64344,1788,'et','Asukoht',0),(64345,1788,'si','Lokacija',0),(64346,1788,'ba','Lokasi',0),(64347,1788,'nl','Locatie',0),(64348,1788,'fi','Sijainti',0),(64349,1788,'no','Beliggenhet',0),(64350,1788,'da','Beliggenhed',0),(64351,1788,'ko','ìœ„ì¹˜',0),(64352,1788,'he','×ž×™×§×•×',0),(64353,1788,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(64354,1788,'zh','åœ°ç‚¹\r\n',0),(64355,1788,'sv','LÃ¤ge',0),(64356,1788,'it','Posizione',0),(64357,1788,'tl','',0),(64358,1788,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(64359,1788,'hi','à¤¸à¥à¤¥à¤¾à¤¨',0),(64360,1788,'ms','Lokasi',0),(64361,1788,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(64362,1788,'fr','Emplacement',0),(64363,1788,'jp','é…?ç½®',0),(64364,1788,'pt','LocalizaÃ§Ã£o',0),(64365,1788,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(64366,1788,'es','UbicaciÃ³n',0),(64367,1788,'de','Lage',0),(64368,1788,'en','Location',0),(64369,1789,'is','',0),(64370,1789,'dr','Ù†Ø§Ù… Ù…ÙƒØ§Ù† ',0),(64371,1789,'pr','Ù†Ø§Ù… Ù…ÙƒØ§Ù† ',0),(64372,1789,'tr','Konum adÄ±',0),(64373,1789,'pl','Nazwa lokalizacji',0),(64374,1789,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(64375,1789,'ur','Ù†Ø§Ù… Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(64376,1789,'sr','ÐÐ°Ð·Ð¸Ð² Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(64377,1789,'vi','TÃªn Vá»‹ trÃ­',0),(64378,1789,'af','Liggingnaam',0),(64379,1789,'ro','Denumirea',0),(64380,1789,'et','Asukoha nime',0),(64381,1789,'si','Ime mesta',0),(64382,1789,'ba','Nama lokasi',0),(64383,1789,'nl','Locatienaam',0),(64384,1789,'fi','Sijainnin nimi',0),(64385,1789,'no','Stedsnavn',0),(64386,1789,'da','Lokationens navn',0),(64387,1789,'ko','ìœ„ì¹˜ ì´ë¦„',0),(64388,1789,'he','×©× ×”×ž×™×§×•×',0),(64389,1789,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±Ï‚',0),(64390,1789,'zh','åœ°ç‚¹åç§°\r\n',0),(64391,1789,'sv','Platsnamnet',0),(64392,1789,'it','Nome localitÃ ',0),(64393,1789,'tl','',0),(64394,1789,'th','&#3594;&#3639;&#3656;&#3629;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(64395,1789,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤¨à¤¾à¤®',0),(64396,1789,'ms','Nama lokasi',0),(64397,1789,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(64398,1789,'fr','Nom de l\'emplacement',0),(64399,1789,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³å??',0),(64400,1789,'pt','Nome local',0),(64401,1789,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(64402,1789,'es','Nombre de UbicaciÃ³n',0),(64403,1789,'de','Ortsname',0),(64404,1789,'en','Location Name',0),(64405,1790,'is','',0),(64406,1790,'dr','Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ',0),(64407,1790,'pr','Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ',0),(64408,1790,'tr','GÃ¼nlÃ¼k saat',0),(64409,1790,'pl','Dziennik godzin',0),(64410,1790,'bg','Ð ÐµÐ³Ð¸ÑÑ‚ÑŠÑ€ Ñ‡Ð°ÑÐ°',0),(64411,1790,'ur','Ù„Ø§Ú¯ Ø§Ù† Ú©Û’ Ø§ÙˆÙ‚Ø§Øª',0),(64412,1790,'sr','Ð•Ð²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ð° ÑÐ°Ñ‚Ð¸',0),(64413,1790,'vi','Giá» cháº¥m cÃ´ng',0),(64414,1790,'af','Log Ure',0),(64415,1790,'ro','Jurnal de ore',0),(64416,1790,'et','Log tundi',0),(64417,1790,'si','Dnevnik ur',0),(64418,1790,'ba','Jam log',0),(64419,1790,'nl','Log uren',0),(64420,1790,'fi','Loki tuntia',0),(64421,1790,'no','Logg timer',0),(64422,1790,'da','Log timer',0),(64423,1790,'ko','ë¡œê·¸ ì‹œê°„',0),(64424,1790,'he','×ª×¢×“ ×©×¢×•×ª',0),(64425,1790,'el','ÎÏÎµÏ‚ ÎºÎ±Ï„Î±Î³ÏÎ±Ï†Î®Ï‚',0),(64426,1790,'zh','æ—¥å¿—æ—¶é—´\r\n',0),(64427,1790,'sv','Log timmar',0),(64428,1790,'it','Registro ore',0),(64429,1790,'tl','',0),(64430,1790,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3619;&#3632;&#3610;&#3610;',0),(64431,1790,'hi','à¤²à¥‰à¤— à¤˜à¤‚à¤Ÿà¥‡',0),(64432,1790,'ms','Jam log',0),(64433,1790,'ar','Ø³Ø§Ø¹Ø§Øª Ø³Ø¬Ù„',0),(64434,1790,'fr','Journal des heures',0),(64435,1790,'jp','è¨˜éŒ²æ™‚é–“',0),(64436,1790,'pt','Horas de log',0),(64437,1790,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ñ‡Ð°ÑÐ¾Ð²',0),(64438,1790,'es','Horas Confirmadas',0),(64439,1790,'de','Melden Sie sich Stunden',0),(64440,1790,'en','Log Hours',0),(64441,1791,'is','',0),(64442,1791,'dr','Ø®Ø±ÙˆØ¬ Ø§Ø² Ø³ÙŠØ³ØªÙ…',0),(64443,1791,'pr','Ø®Ø±ÙˆØ¬ Ø§Ø² Ø³ÙŠØ³ØªÙ…',0),(64444,1791,'tr','Oturum sistem dÄ±ÅŸÄ±',0),(64445,1791,'pl','WylogowaÄ‡ siÄ™ z systemu',0),(64446,1791,'bg','Ð˜Ð·Ð»ÐµÐ·Ñ‚Ðµ Ð¾Ñ‚ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(64447,1791,'ur','Ù„Ø§Ú¯ Ø§Ù† Ú©Û’ Ù†Ø¸Ø§Ù… Ø³Û’ Ø¨Ø§ÛØ±',0),(64448,1791,'sr','ÐžÐ´Ñ˜Ð°Ð²Ð¸ Ð¸Ð· ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(64449,1791,'vi','Log Out khá»i há»‡ thá»‘ng',0),(64450,1791,'af','Sisteem Uittekening',0),(64451,1791,'ro','IeÅŸiÅ£i din sistem',0),(64452,1791,'et','SÃ¼steemi Logi',0),(64453,1791,'si','Log iz sistema',0),(64454,1791,'ba','Log out dari sistem',0),(64455,1791,'nl','Log uit systeem',0),(64456,1791,'fi','Kirjaudu ulos jÃ¤rjestelmÃ¤n',0),(64457,1791,'no','Logg ut av systemet',0),(64458,1791,'da','Log ud af systemet',0),(64459,1791,'ko','ì‹œìŠ¤í…œ ë¡œê·¸',0),(64460,1791,'he','×”×ª× ×ª×§ ×ž×”×ž×¢×¨×›×ª',0),(64461,1791,'el','Î‘Ï€Î¿ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Î±Ï€ÏŒ Ï„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(64462,1791,'zh','ç™»å‡ºç³»ç»Ÿ\r\n',0),(64463,1791,'sv','Logga ut frÃ¥n systemet',0),(64464,1791,'it','Disconnettersi dal sistema',0),(64465,1791,'tl','',0),(64466,1791,'th','&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3619;&#3632;&#3610;&#3610;',0),(64467,1791,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤²à¥‰à¤— à¤•à¤°à¥‡à¤‚',0),(64468,1791,'ms','Log keluar dari sistem',0),(64469,1791,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬ Ù…Ù† Ø§Ù„Ù†Ø¸Ø§Ù…',0),(64470,1791,'fr','DÃ©connecter du SystÃ¨me',0),(64471,1791,'jp','ã‚·ã‚¹ãƒ†ãƒ ã?®ãƒ­ã‚°ã‚¢ã‚¦ãƒˆ',0),(64472,1791,'pt','Sair do sistema',0),(64473,1791,'ru','Ð’Ñ‹Ð¹Ñ‚Ð¸ Ð¸Ð· Ð¡Ð¸ÑÑ‚ÐµÐ¼Ñ‹',0),(64474,1791,'es','Log Out del Sistema',0),(64475,1791,'de','System abmelden',0),(64476,1791,'en','Log Out of System',0),(64477,1792,'is','',0),(64478,1792,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(64479,1792,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(64480,1792,'tr','Oturum aÃ§ma baÅŸarÄ±sÄ±z oldu',0),(64481,1792,'pl','Logowanie nie powiodÅ‚o siÄ™',0),(64482,1792,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(64483,1792,'ur','Ù„Ø§Ú¯ Ø§Ù† Ù†Ø§Ú©Ø§Ù…',0),(64484,1792,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(64485,1792,'vi','ÄÄƒng nháº­p tháº¥t báº¡i',0),(64486,1792,'af','Aantekening het Gefaal',0),(64487,1792,'ro','Conectare a eÅŸuat',0),(64488,1792,'et','Sisselogimine nurjus',0),(64489,1792,'si','Prijava ni uspela',0),(64490,1792,'ba','Login gagal',0),(64491,1792,'nl','Login mislukt',0),(64492,1792,'fi','Kirjautuminen epÃ¤onnistui',0),(64493,1792,'no','PÃ¥loggingen mislyktes',0),(64494,1792,'da','Login mislykkedes',0),(64495,1792,'ko','ë¡œê·¸ì¸ ì‹¤íŒ¨',0),(64496,1792,'he','×”×”×ª×—×‘×¨×•×ª × ×›×©×œ×”',0),(64497,1792,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(64498,1792,'zh','ç™»å½•å¤±è´¥\r\n',0),(64499,1792,'sv','Inloggningen misslyckades',0),(64500,1792,'it','Login fallito',0),(64501,1792,'tl','',0),(64502,1792,'th','&#3621;&#3655;&#3629;&#3585;&#3629;&#3636;&#3609;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(64503,1792,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(64504,1792,'ms','Log masuk gagal',0),(64505,1792,'ar','ÙØ´Ù„ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(64506,1792,'fr','Connexion a Ã©chouÃ©',0),(64507,1792,'jp','ãƒ­ã‚°ã‚¤ãƒ³å¤±æ•—',0),(64508,1792,'pt','Falhado de logon',0),(64509,1792,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²Ñ…Ð¾Ð´Ð°',0),(64510,1792,'es','Login FallÃ³',0),(64511,1792,'de','Login fehlgeschlagen',0),(64512,1792,'en','Login Failed',0),(64513,1793,'is','',0),(64514,1793,'dr','Ø¯Ø³ØªØ±Ø³ÙŠ Ø§ØªØµØ§Ù„ Ø¨Ù‡ ÙƒØ§Ù…Ù¾ÙŠÙˆØªØ± ',0),(64515,1793,'pr','Ø¯Ø³ØªØ±Ø³ÙŠ Ø§ØªØµØ§Ù„ Ø¨Ù‡ ÙƒØ§Ù…Ù¾ÙŠÙˆØªØ± ',0),(64516,1793,'tr',' oturum aÃ§ma eriÅŸimi',0),(64517,1793,'pl',' dostÄ™p do logowania',0),(64518,1793,'bg',' Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð·Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(64519,1793,'ur',' Ù„Ø§Ú¯ Ø§Ù† ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ',0),(64520,1793,'sr',' Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ',0),(64521,1793,'vi',' Quyá»n ÄÄƒng nháº­p',0),(64522,1793,'af',' aanteken toegang',0),(64523,1793,'ro',' Log on acces',0),(64524,1793,'et',' sisselogimiseks juurdepÃ¤Ã¤su',0),(64525,1793,'si',' prijavo dostop',0),(64526,1793,'ba',' akses masuk',0),(64527,1793,'nl','Login toegang',0),(64528,1793,'fi',' Kirjautuminen',0),(64529,1793,'no',' pÃ¥loggingstilgang',0),(64530,1793,'da',' logon adgang',0),(64531,1793,'ko',' ë¡œê·¸ì˜¨ ì•¡ì„¸ìŠ¤',0),(64532,1793,'he',' ×’×™×©×ª ×›× ×™×¡×”',0),(64533,1793,'el',' Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚',0),(64534,1793,'zh','ç™»å½•è®¿é—®\r\n',0),(64535,1793,'sv',' inloggning tillgÃ¥ng',0),(64536,1793,'it',' accesso di accesso',0),(64537,1793,'tl','',0),(64538,1793,'th','&#3621;&#3655;&#3629;&#3585;&#3629;&#3629;&#3609;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(64539,1793,'hi',' à¤²à¥‰à¤—à¤‘à¤¨ à¤ªà¤¹à¥à¤à¤š',0),(64540,1793,'ms',' akses log masuk',0),(64541,1793,'ar','Ø­Ù‚Ù‘ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(64542,1793,'fr',' accÃ¨s d\'ouverture de session',0),(64543,1793,'jp','ãƒ­ã‚°ã‚¤ãƒ³ã‚¢ã‚¯ã‚»ã‚¹',0),(64544,1793,'pt',' acesso de logon',0),(64545,1793,'ru',' Ð´Ð¾ÑÑ‚ÑƒÐ¿ Ð²Ñ…Ð¾Ð´Ð°',0),(64546,1793,'es','Logon Acceso',0),(64547,1793,'de',' Anmeldezugriff',0),(64548,1793,'en',' logon access',0),(64549,1794,'is','',0),(64550,1794,'dr','Ø®Ø±ÙˆØ¬ Ø§Ø² Ø³ÙŠØ³ØªÙ…',0),(64551,1794,'pr','Ø®Ø±ÙˆØ¬ Ø§Ø² Ø³ÙŠØ³ØªÙ…',0),(64552,1794,'tr','Oturum kapatma',0),(64553,1794,'pl','Wyloguj',0),(64554,1794,'bg','Ð˜Ð·Ñ…Ð¾Ð´',0),(64555,1794,'ur','Ù„Ø§Ú¯ Ø¢ Ø¤Ù¹ ÛÙˆÚº',0),(64556,1794,'sr','Ð¡Ðµ Ð¾Ð´Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ',0),(64557,1794,'vi','thoÃ¡t ra',0),(64558,1794,'af','Uitteken',0),(64559,1794,'ro','Deconectare',0),(64560,1794,'et','Logi vÃ¤lja',0),(64561,1794,'si','Odjava',0),(64562,1794,'ba','Logout',0),(64563,1794,'nl','Log uit',0),(64564,1794,'fi','Kirjaudu ulos',0),(64565,1794,'no','Logg',0),(64566,1794,'da','Logout',0),(64567,1794,'ko','ë¡œê·¸ ì•„ì›ƒ',0),(64568,1794,'he','×”×ª× ×ª×§',0),(64569,1794,'el','Î‘Ï€Î¿ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(64570,1794,'zh','æ³¨é”€\r\n',0),(64571,1794,'sv','Logga ut',0),(64572,1794,'it','Logout',0),(64573,1794,'tl','',0),(64574,1794,'th','&#3621;&#3655;&#3629;&#3585;&#3648;&#3629;&#3634;&#3607;&#3660;',0),(64575,1794,'hi','à¤²à¥‰à¤— à¤†à¤‰à¤Ÿ',0),(64576,1794,'ms','Log keluar',0),(64577,1794,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬',0),(64578,1794,'fr','DÃ©connexion',0),(64579,1794,'jp','ãƒ­ã‚°ã‚¢ã‚¦ãƒˆ',0),(64580,1794,'pt','Logout',0),(64581,1794,'ru','Ð’Ñ‹Ñ…Ð¾Ð´',0),(64582,1794,'es','Logout',0),(64583,1794,'de','Logout',0),(64584,1794,'en','Logout',0),(64585,1795,'is','',0),(64586,1795,'dr','(Ø¶Ø±Ø± Ø¯ÙŠØ¯Ù‡',0),(64587,1795,'pr','Ù…ÙÙ‚ÙˆØ¯ (Ø²ÙŠØ§Ù† Ø¯ÙŠØ¯Ù‡',0),(64588,1795,'tr','KayÄ±p',0),(64589,1795,'pl','StraciÅ‚',0),(64590,1795,'bg','Ð˜Ð·Ð³ÑƒÐ±ÐµÐ½Ð¸',0),(64591,1795,'ur','Ú©Ú¾Ùˆ',0),(64592,1795,'sr','Ð˜Ð·Ð³ÑƒÐ±Ð¸Ð¾',0),(64593,1795,'vi','Máº¥t',0),(64594,1795,'af','Verlore',0),(64595,1795,'ro','Pierdut',0),(64596,1795,'et','Kadunud',0),(64597,1795,'si','Izgubil',0),(64598,1795,'ba','Kehilangan',0),(64599,1795,'nl','Verloren',0),(64600,1795,'fi','Lost',0),(64601,1795,'no','Mistet',0),(64602,1795,'da','Mistet',0),(64603,1795,'ko','ë¶„ì‹¤',0),(64604,1795,'he','××‘×•×“×™×',0),(64605,1795,'el','ÎˆÏ‡Î±ÏƒÎµ',0),(64606,1795,'zh','ä¸¢å¤±\r\n',0),(64607,1795,'sv','FÃ¶rlorade',0),(64608,1795,'it','Perso',0),(64609,1795,'tl','',0),(64610,1795,'th','&#3648;&#3626;&#3637;&#3618;&#3627;&#3634;&#3618;',0),(64611,1795,'hi','à¤–à¥‹à¤¯à¤¾',0),(64612,1795,'ms','Hilang',0),(64613,1795,'ar','ÙÙ‚Ø¯Øª',0),(64614,1795,'fr','Perdu',0),(64615,1795,'jp','Lost',0),(64616,1795,'pt','Perdeu',0),(64617,1795,'ru','ÐŸÐ¾Ñ‚ÐµÑ€ÑÐ»',0),(64618,1795,'es','Perdido',0),(64619,1795,'de','Verloren',0),(64620,1795,'en','Lost',0),(64621,1796,'is','',0),(64622,1796,'dr','Ø²ÙŠØ§Ø¯',0),(64623,1796,'pr','Ø²ÙŠØ§Ø¯',0),(64624,1796,'tr','Ã§ok',0),(64625,1796,'pl','duÅ¼o',0),(64626,1796,'bg','Ð¼Ð½Ð¾Ð³Ð¾',0),(64627,1796,'ur','Ø¨ÛØª',0),(64628,1796,'sr','ÑÐµÑ€Ð¸Ñ˜Ðµ',0),(64629,1796,'vi','lÃ´',0),(64630,1796,'af','baie',0),(64631,1796,'ro','mulÅ£ime',0),(64632,1796,'et','palju',0),(64633,1796,'si','veliko',0),(64634,1796,'ba','banyak',0),(64635,1796,'nl','veel',0),(64636,1796,'fi','paljon',0),(64637,1796,'no','mye',0),(64638,1796,'da','masse',0),(64639,1796,'ko','ë§Žì€',0),(64640,1796,'he','×”×¨×‘×”',0),(64641,1796,'el','Ï€Î¿Î»Î»Î¬',0),(64642,1796,'zh','å¾ˆå¤š\r\n',0),(64643,1796,'sv','hel',0),(64644,1796,'it','sacco',0),(64645,1796,'tl','',0),(64646,1796,'th','&#3617;&#3634;&#3585;',0),(64647,1796,'hi','à¤¬à¤¹à¥à¤¤ à¤•à¥à¤›',0),(64648,1796,'ms','Lot',0),(64649,1796,'ar','Ø§Ù„ÙƒØ«ÙŠØ±',0),(64650,1796,'fr','beaucoup',0),(64651,1796,'jp','lot',0),(64652,1796,'pt','Monte',0),(64653,1796,'ru','Ð¼Ð½Ð¾Ð³Ð¾',0),(64654,1796,'es','lote',0),(64655,1796,'de','viele',0),(64656,1796,'en','lot',0),(64657,1797,'is','',0),(64658,1797,'dr','ÙƒÙ…',0),(64659,1797,'pr','ÙƒÙ…',0),(64660,1797,'tr','DÃ¼ÅŸÃ¼k',0),(64661,1797,'pl','Niski',0),(64662,1797,'bg','ÐÐ¸ÑÐºÐ°',0),(64663,1797,'ur','Ù¾Ø³Øª',0),(64664,1797,'sr','ÐÐ¸ÑÐºÐ¾',0),(64665,1797,'vi','Tháº¥p',0),(64666,1797,'af','Laag',0),(64667,1797,'ro','Low',0),(64668,1797,'et','Madala',0),(64669,1797,'si','Nizko',0),(64670,1797,'ba','Rendah',0),(64671,1797,'nl','laag',0),(64672,1797,'fi','Matala',0),(64673,1797,'no','Lav',0),(64674,1797,'da','Lav',0),(64675,1797,'ko','ë‚®ì€',0),(64676,1797,'he','× ×ž×•×š',0),(64677,1797,'el','Î§Î±Î¼Î·Î»Î®',0),(64678,1797,'zh','ä½Ž\r\n',0),(64679,1797,'sv','LÃ¥g',0),(64680,1797,'it','Basso',0),(64681,1797,'tl','',0),(64682,1797,'th','&#3605;&#3656;&#3635;',0),(64683,1797,'hi','à¤•à¤®',0),(64684,1797,'ms','Rendah',0),(64685,1797,'ar','Ù…Ù†Ø®ÙØ¶',0),(64686,1797,'fr','Faible',0),(64687,1797,'jp','Low',0),(64688,1797,'pt','Baixa',0),(64689,1797,'ru','ÐÐ¸Ð·ÐºÐ¸Ð¹',0),(64690,1797,'es','Bajo',0),(64691,1797,'de','Low',0),(64692,1797,'en','Low',0),(64693,1798,'is','',0),(64694,1798,'dr','m',0),(64695,1798,'pr','m',0),(64696,1798,'tr','m',0),(64697,1798,'pl','m',0),(64698,1798,'bg','Ð¼',0),(64699,1798,'ur','Ù…Ù„ÛŒÙ†',0),(64700,1798,'sr','Ð¼',0),(64701,1798,'vi','m',0),(64702,1798,'af','m',0),(64703,1798,'ro','m',0),(64704,1798,'et','m',0),(64705,1798,'si','m',0),(64706,1798,'ba','m',0),(64707,1798,'nl','m',0),(64708,1798,'fi','m',0),(64709,1798,'no','m',0),(64710,1798,'da','m',0),(64711,1798,'ko','m',0),(64712,1798,'he','m',0),(64713,1798,'el','m',0),(64714,1798,'zh','ç±³\r\n',0),(64715,1798,'sv','m',0),(64716,1798,'it','m',0),(64717,1798,'tl','',0),(64718,1798,'th','m',0),(64719,1798,'hi','à¤®à¥€',0),(64720,1798,'ms','m',0),(64721,1798,'ar','m',0),(64722,1798,'fr','m',0),(64723,1798,'jp','m',0),(64724,1798,'pt','m',0),(64725,1798,'ru','m',0),(64726,1798,'es','m',0),(64727,1798,'de','m',0),(64728,1798,'en','m',0),(64729,1799,'is','',0),(64730,1799,'dr','Ù…Ø§Ø´ÙŠÙ† ',0),(64731,1799,'pr','Ù…Ø§Ø´ÙŠÙ† ',0),(64732,1799,'tr','Makine',0),(64733,1799,'pl','Maszyna',0),(64734,1799,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð°',0),(64735,1799,'ur','Ù…Ø´ÛŒÙ†',0),(64736,1799,'sr','ÐœÐ°ÑˆÐ¸Ð½Ð°',0),(64737,1799,'vi','MÃ¡y',0),(64738,1799,'af','Masjien',0),(64739,1799,'ro','Masina',0),(64740,1799,'et','Masin',0),(64741,1799,'si','Stroj',0),(64742,1799,'ba','Mesin',0),(64743,1799,'nl','Machine',0),(64744,1799,'fi','Kone',0),(64745,1799,'no','Maskinen',0),(64746,1799,'da','Maskine',0),(64747,1799,'ko','ê¸°ê³„',0),(64748,1799,'he','×ž×›×•× ×ª',0),(64749,1799,'el','ÎœÎ·Ï‡Î±Î½Î®',0),(64750,1799,'zh','æœº\r\n',0),(64751,1799,'sv','Maskin',0),(64752,1799,'it','Macchina',0),(64753,1799,'tl','',0),(64754,1799,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(64755,1799,'hi','à¤®à¤¶à¥€à¤¨',0),(64756,1799,'ms','Mesin',0),(64757,1799,'ar','Ø¢Ù„Ø©',0),(64758,1799,'fr','Machine',0),(64759,1799,'jp','æ©Ÿæ¢°',0),(64760,1799,'pt','MÃ¡quina',0),(64761,1799,'ru','ÐœÐ°ÑˆÐ¸Ð½Ð°',0),(64762,1799,'es','MÃ¡quina',0),(64763,1799,'de','Maschine',0),(64764,1799,'en','Machine',0),(64765,1800,'is','',0),(64766,1800,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ø´ÙŠÙ† ',0),(64767,1800,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ø´ÙŠÙ† ',0),(64768,1800,'tr','Makine ekleme',0),(64769,1800,'pl','Maszyny dodaÄ‡',0),(64770,1800,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(64771,1800,'ur','Ù…Ø´ÛŒÙ† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(64772,1800,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(64773,1800,'vi','ThÃªm MÃ¡y',0),(64774,1800,'af','Masjien Byvoeg',0),(64775,1800,'ro','Adauga maÅŸinÄƒ',0),(64776,1800,'et','Arvuti lisamine',0),(64777,1800,'si','Dodaj stroj',0),(64778,1800,'ba','Tambahkan mesin',0),(64779,1800,'nl','Machine toevoegen',0),(64780,1800,'fi','Kone lisÃ¤Ã¤',0),(64781,1800,'no','Maskinen legge',0),(64782,1800,'da','Maskine tilfÃ¸je',0),(64783,1800,'ko','ì»´í“¨í„° ì¶”ê°€',0),(64784,1800,'he','×ž×›×•× ×ª ×œ×”×•×¡×™×£',0),(64785,1800,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î·Ï‡Î±Î½Î®',0),(64786,1800,'zh','æ–°å¢žæœº\r\n',0),(64787,1800,'sv','Maskin lÃ¤gga till',0),(64788,1800,'it','Aggiungi macchina',0),(64789,1800,'tl','',0),(64790,1800,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(64791,1800,'hi','à¤®à¤¶à¥€à¤¨ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(64792,1800,'ms','Menambah Mesin',0),(64793,1800,'ar','Ø¥Ø¶Ø§ÙØ© Ø¢Ù„Ø©',0),(64794,1800,'fr','Ajouter de la machine',0),(64795,1800,'jp','æ©Ÿæ¢°ã?®è¿½åŠ ',0),(64796,1800,'pt','MÃ¡quina adicionar',0),(64797,1800,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¼Ð°ÑˆÐ¸Ð½Ñƒ',0),(64798,1800,'es','MÃ¡quina Agregar',0),(64799,1800,'de','Maschine hinzufÃ¼gen',0),(64800,1800,'en','Machine Add',0),(64801,1801,'is','',0),(64802,1801,'dr','Ù…Ø§Ø´ÙŠÙ† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(64803,1801,'pr','Ù…Ø§Ø´ÙŠÙ† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(64804,1801,'tr','Makine baÅŸarÄ±yla eklendi.',0),(64805,1801,'pl','Maszyna dodane pomyÅ›lnie.',0),(64806,1801,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(64807,1801,'ur','Ù…Ø´ÛŒÙ† Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(64808,1801,'sr','ÐœÐ°ÑˆÐ¸Ð½Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(64809,1801,'vi','ThÃªm MÃ¡y thÃ nh cÃ´ng',0),(64810,1801,'af','Masjien suksesvol bygevoeg.',0),(64811,1801,'ro','Masina de adÄƒugat cu succes.',0),(64812,1801,'et','Masin edukalt lisatud.',0),(64813,1801,'si','Stroj uspeÅ¡no dodana.',0),(64814,1801,'ba','Mesin ditambahkan berhasil.',0),(64815,1801,'nl','Machine toegevoegd.',0),(64816,1801,'fi','Kone lisÃ¤Ã¤minen onnistui.',0),(64817,1801,'no','Maskinen ble lagt til.',0),(64818,1801,'da','Maskine tilfÃ¸jet.',0),(64819,1801,'ko','ê¸°ê³„ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(64820,1801,'he','×ž×›×•× ×ª × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(64821,1801,'el','ÎœÎ·Ï‡Î±Î½Î® Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(64822,1801,'zh','æœºå™¨æ·»åŠ æˆåŠŸã€‚\r\n',0),(64823,1801,'sv','Maskin lagts.',0),(64824,1801,'it','Macchina aggiunto con successo.',0),(64825,1801,'tl','',0),(64826,1801,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(64827,1801,'hi','à¤®à¤¶à¥€à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(64828,1801,'ms','Mesin yang berjaya menambah.',0),(64829,1801,'ar','Ø¢Ù„Ø© Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(64830,1801,'fr','Machine a ajoutÃ© avec succÃ¨s.',0),(64831,1801,'jp','æ©Ÿæ¢°ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(64832,1801,'pt','MÃ¡quina adicionada com Ãªxito.',0),(64833,1801,'ru','ÐœÐ°ÑˆÐ¸Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(64834,1801,'es','MÃ¡quina agregada exitosamente',0),(64835,1801,'de','Maschine wurde erfolgreich hinzugefÃ¼gt.',0),(64836,1801,'en','Machine added successfully.',0),(64837,1802,'is','',0),(64838,1802,'dr','Ù…Ø§Ø´ÙŠÙ† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(64839,1802,'pr','Ù…Ø§Ø´ÙŠÙ† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(64840,1802,'tr','Makine baÅŸarÄ±yla silindi.',0),(64841,1802,'pl','UrzÄ…dzenie pomyÅ›lnie usuniÄ™ty.',0),(64842,1802,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(64843,1802,'ur','Ù…Ø´ÛŒÙ† Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(64844,1802,'sr','ÐœÐ°ÑˆÐ¸Ð½Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(64845,1802,'vi','XÃ³a MÃ¡y thÃ nh cÃ´ng',0),(64846,1802,'af','Masjien suksesvol geskrap.',0),(64847,1802,'ro','Masina de ÅŸters cu succes.',0),(64848,1802,'et','Masin edukalt kustutatud.',0),(64849,1802,'si','Stroj je bilo uspeÅ¡no izbrisano.',0),(64850,1802,'ba','Mesin berhasil dihapus.',0),(64851,1802,'nl','Machine met succes verwijderd.',0),(64852,1802,'fi','Kone poistettu.',0),(64853,1802,'no','Maskinen ble slettet.',0),(64854,1802,'da','Maskine slettet.',0),(64855,1802,'ko','ê¸°ê³„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(64856,1802,'he','×ž×›×•× ×ª × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(64857,1802,'el','ÎœÎ·Ï‡Î±Î½Î® Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(64858,1802,'zh','æœºå·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(64859,1802,'sv','Maskin raderades.',0),(64860,1802,'it','Macchina eliminato con successo.',0),(64861,1802,'tl','',0),(64862,1802,'th','&#3621;&#3610;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(64863,1802,'hi','à¤®à¤¶à¥€à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(64864,1802,'ms','Mesin dihapuskan dengan jayanya.',0),(64865,1802,'ar','Ø¢Ù„Ø© Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(64866,1802,'fr','Machine supprimÃ©e avec succÃ¨s.',0),(64867,1802,'jp','æ©Ÿæ¢°ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(64868,1802,'pt','MÃ¡quina excluÃ­da com sucesso.',0),(64869,1802,'ru','ÐœÐ°ÑˆÐ¸Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(64870,1802,'es','MÃ¡quina eliminada exitosamente',0),(64871,1802,'de','Maschine wurde erfolgreich gelÃ¶scht.',0),(64872,1802,'en','Machine deleted successfully.',0),(64873,1803,'is','',0),(64874,1803,'dr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(64875,1803,'pr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(64876,1803,'tr','Makine aile',0),(64877,1803,'pl','Maszyna rodziny',0),(64878,1803,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(64879,1803,'ur','Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù†',0),(64880,1803,'sr','ÐŸÐ¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(64881,1803,'vi','MÃ¡y Gia ÄÃ¬nh ',0),(64882,1803,'af','Masjien Familie',0),(64883,1803,'ro','Masina de familie',0),(64884,1803,'et','Kohapeal pere',0),(64885,1803,'si','Stroj druÅ¾ine',0),(64886,1803,'ba','Mesin keluarga',0),(64887,1803,'nl','Machine familie',0),(64888,1803,'fi','Kone perhe',0),(64889,1803,'no','Maskin familien',0),(64890,1803,'da','Maskine familie',0),(64891,1803,'ko','ê¸°ê³„ ê°€ì¡±',0),(64892,1803,'he','×ž×›×•× ×ª ×”×ž×©×¤×—×”',0),(64893,1803,'el','ÎŸÎ¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Î¼Î·Ï‡Î±Î½Î®',0),(64894,1803,'zh','æœºç³»åˆ—\r\n',0),(64895,1803,'sv','Maskin familj',0),(64896,1803,'it','Famiglia di macchina',0),(64897,1803,'tl','',0),(64898,1803,'th','&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(64899,1803,'hi','à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤°',0),(64900,1803,'ms','Keluarga Mesin',0),(64901,1803,'ar','Ø¢Ù„Ø© Ø§Ù„Ø£Ø³Ø±Ø©',0),(64902,1803,'fr','Famille de machine',0),(64903,1803,'jp','æ©Ÿæ¢°ç³»ç­‰',0),(64904,1803,'pt','FamÃ­lia de mÃ¡quina',0),(64905,1803,'ru','ÐœÐ°ÑˆÐ¸Ð½Ñ‹ ÑÐµÐ¼ÑŒÐ¸',0),(64906,1803,'es','Familia de MÃ¡quinas',0),(64907,1803,'de','Maschine Familie',0),(64908,1803,'en','Machine Family',0),(64909,1804,'is','',0),(64910,1804,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(64911,1804,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(64912,1804,'tr','Makine aile seÃ§imi',0),(64913,1804,'pl','Rodzina wybÃ³r maszyn',0),(64914,1804,'bg','Ð¡ÐµÐ¼ÐµÐ¹Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð·Ð° Ð¿Ð¾Ð´Ð±Ð¾Ñ€',0),(64915,1804,'ur','Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù† Ø§Ù†ØªØ®Ø§Ø¨',0),(64916,1804,'sr','ÐŸÐ¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ñƒ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(64917,1804,'vi','Chá»n MÃ¡y Gia ÄÃ¬nh ',0),(64918,1804,'af','Masjien familie seleksie',0),(64919,1804,'ro','Masina de familie selecÅ£ie',0),(64920,1804,'et','Masina pere valimine',0),(64921,1804,'si','Stroj druÅ¾inskega izbora',0),(64922,1804,'ba','Mesin keluarga seleksi',0),(64923,1804,'nl','Machine familie selector',0),(64924,1804,'fi','Koneen perheen valinta',0),(64925,1804,'no','Maskinen familie utvalg',0),(64926,1804,'da','Maskine familie udvalg',0),(64927,1804,'ko','ê¸°ê³„ ê°€ì¡± ì„ íƒ',0),(64928,1804,'he','×”×‘×—×™×¨×” ×”×ž×©×¤×—×ª×™×ª ×”×ž×›×•× ×”',0),(64929,1804,'el','ÎŸÎ¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ® ÎµÏ€Î¹Î»Î¿Î³Î® Î¼Î·Ï‡Î±Î½Î®',0),(64930,1804,'zh','æœºç³»åˆ—é€‰æ‹©\r\n',0),(64931,1804,'sv','Maskin familj urval',0),(64932,1804,'it','Selezione famiglia macchina',0),(64933,1804,'tl','',0),(64934,1804,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(64935,1804,'hi','à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤šà¤¯à¤¨',0),(64936,1804,'ms','Pilihan keluarga Mesin',0),(64937,1804,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø£Ø³Ø±Ø© Ø¢Ù„Ø©',0),(64938,1804,'fr','SÃ©lection famille machine',0),(64939,1804,'jp','æ©Ÿæ¢°ç³»çµ±é?¸æŠž',0),(64940,1804,'pt','SeleÃ§Ã£o de famÃ­lia de mÃ¡quina',0),(64941,1804,'ru','Ð¡ÐµÐ¼ÐµÐ¹Ð½Ñ‹Ð¹ Ð²Ñ‹Ð±Ð¾Ñ€ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹',0),(64942,1804,'es','SelecciÃ³n de Familia de MÃ¡quinas',0),(64943,1804,'de','Familie Kaffeemaschinenauswahl',0),(64944,1804,'en','Machine family selection',0),(64945,1805,'is','',0),(64946,1805,'dr','/ Ø¢Ù¾Ø¯ÛŒØª   Ù„ÙŠØ³Øª Ù…Ø§Ø´ÙŠÙ† ',0),(64947,1805,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ù„ÙŠØ³Øª Ù…Ø§Ø´ÙŠÙ† ',0),(64948,1805,'tr','Makine listesi Ekle/GÃ¼ncelle',0),(64949,1805,'pl','Maszyna listy Dodaj/Aktualizuj',0),(64950,1805,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ°',0),(64951,1805,'ur','Ù…Ø´ÛŒÙ† Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(64952,1805,'sr','ÐœÐ°ÑˆÐ¸Ð½Ð° Ð»Ð¸ÑÑ‚Ñƒ Ð”Ð¾Ð´Ð°Ñ˜/ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜',0),(64953,1805,'vi','ThÃªm/Cáº­p Nháº­t Danh SÃ¡ch mÃ¡y',0),(64954,1805,'af','Masjien Lys Byvoeg/Opdateer',0),(64955,1805,'ro','MaÅŸinÄƒ listÄƒ AdÄƒugaÅ£i/actualizaÅ£i',0),(64956,1805,'et','Masin nimekirja lisamine/uuendamine',0),(64957,1805,'si','Stroj seznamu Dodaj/posodobi',0),(64958,1805,'ba','Mesin Daftar Tambahkan/Perbarui',0),(64959,1805,'nl','Machine lijst toevoegen/bijwerken',0),(64960,1805,'fi','Koneen luettelon lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(64961,1805,'no','Maskinen listen Legg til/Oppdater',0),(64962,1805,'da','Maskine listen TilfÃ¸j/opdater',0),(64963,1805,'ko','ê¸°ê³„ ëª©ë¡ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(64964,1805,'he','×¨×©×™×ž×” ×©×œ ×ž×›×•× ×ª ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(64965,1805,'el','Î›Î¯ÏƒÏ„Î± Î¼Î·Ï‡Î±Î½Î® Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(64966,1805,'zh','æœºåˆ—è¡¨æ·»åŠ /æ›´æ–°\r\n',0),(64967,1805,'sv','Maskin listan LÃ¤gg till/uppdatera',0),(64968,1805,'it','Macchina lista Aggiungi/Aggiorna',0),(64969,1805,'tl','',0),(64970,1805,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(64971,1805,'hi','à¤®à¤¶à¥€à¤¨ à¤¸à¥‚à¤šà¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(64972,1805,'ms','Senarai Tambah/Kemaskini Mesin',0),(64973,1805,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ù‡Ø§Ø²',0),(64974,1805,'fr','Machine liste ajouter/mettre Ã  jour',0),(64975,1805,'jp','æ©Ÿæ¢°ãƒªã‚¹ãƒˆã?®è¿½åŠ /æ›´æ–°',0),(64976,1805,'pt','MÃ¡quina lista Adicionar/atualizar',0),(64977,1805,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(64978,1805,'es','Lista de MÃ¡quinas Agregar/Actualizar',0),(64979,1805,'de','Maschine Liste hinzufÃ¼gen/aktualisieren',0),(64980,1805,'en','Machine List Add/Update',0),(64981,1806,'is','',0),(64982,1806,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù…Ø§Ø´ÙŠÙ† ',0),(64983,1806,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù…Ø§Ø´ÙŠÙ† ',0),(64984,1806,'tr','Makine listesi gÃ¼ncelleme',0),(64985,1806,'pl','Aktualizacja listy maszyna',0),(64986,1806,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(64987,1806,'ur','Ù…Ø´ÛŒÙ† Ú©ÛŒ ÙÛØ±Ø³Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(64988,1806,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(64989,1806,'vi','Cáº­p Nháº­t Danh SÃ¡ch mÃ¡y',0),(64990,1806,'af','Masjien Lys Opdateer',0),(64991,1806,'ro','MaÅŸinÄƒ listÄƒ Update',0),(64992,1806,'et','Masin uuendamisel',0),(64993,1806,'si','Stroj seznam posodobitev',0),(64994,1806,'ba','Mesin daftar Update',0),(64995,1806,'nl','Machine lijst Update',0),(64996,1806,'fi','Koneen pÃ¤ivitys',0),(64997,1806,'no','Maskinen List oppdatering',0),(64998,1806,'da','Maskine liste Update',0),(64999,1806,'ko','ê¸°ê³„ ëª©ë¡ ì—…ë°ì´íŠ¸',0),(65000,1806,'he','×¢×“×›×•×Ÿ ×¨×©×™×ž×ª ×ž×›×•× ×•×ª',0),(65001,1806,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚ Î¼Î·Ï‡Î±Î½Î®',0),(65002,1806,'zh','æœºæ¸…å•æ›´æ–°\r\n',0),(65003,1806,'sv','Maskin uppdatering',0),(65004,1806,'it','Aggiornamento elenco macchina',0),(65005,1806,'tl','',0),(65006,1806,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(65007,1806,'hi','à¤®à¤¶à¥€à¤¨ à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(65008,1806,'ms','Kemaskini senarai Mesin',0),(65009,1806,'ar','ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ù‡Ø§Ø²',0),(65010,1806,'fr','Mise Ã  jour de liste de machine',0),(65011,1806,'jp','æ©Ÿæ¢°ãƒªã‚¹ãƒˆã?®æ›´æ–°',0),(65012,1806,'pt','ActualizaÃ§Ã£o da lista de mÃ¡quina',0),(65013,1806,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(65014,1806,'es','Lista de MÃ¡quinas Actualizar',0),(65015,1806,'de','Maschine Listenaktualisierung',0),(65016,1806,'en','Machine List Update',0),(65017,1807,'is','',0),(65018,1807,'dr','Ù…Ø§Ø´ÙŠÙ† Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(65019,1807,'pr','Ù…Ø§Ø´ÙŠÙ† Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(65020,1807,'tr','Makine bulunamadÄ±.',0),(65021,1807,'pl','Maszyna nie znaleziono.',0),(65022,1807,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð°Ñ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(65023,1807,'ur','Ù…Ø´ÛŒÙ† Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(65024,1807,'sr','ÐœÐ°ÑˆÐ¸Ð½Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°.',0),(65025,1807,'vi','KhÃ´ng tháº¥y mÃ¡y',0),(65026,1807,'af','Masjien Nie gevind.',0),(65027,1807,'ro','Masina nu a fost gÄƒsit.',0),(65028,1807,'et','Masin ei leitud.',0),(65029,1807,'si','Stroj, ni mogoÄe najti.',0),(65030,1807,'ba','Mesin tidak ditemukan.',0),(65031,1807,'nl','Machine niet gevonden.',0),(65032,1807,'fi','Laitetta ei lÃ¶ytynyt.',0),(65033,1807,'no','Maskinen ikke funnet.',0),(65034,1807,'da','Maskinen blev ikke fundet.',0),(65035,1807,'ko','ì»´í“¨í„° ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(65036,1807,'he','×”×ž×›×•× ×” ×œ× × ×ž×¦×.',0),(65037,1807,'el','ÎœÎ·Ï‡Î±Î½Î® Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(65038,1807,'zh','æœºæœªæ‰¾åˆ°ã€‚\r\n',0),(65039,1807,'sv','Maskin hittades inte.',0),(65040,1807,'it','Macchina non trovato.',0),(65041,1807,'tl','',0),(65042,1807,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(65043,1807,'hi','à¤®à¤¶à¥€à¤¨ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(65044,1807,'ms','Mesin tidak dijumpai.',0),(65045,1807,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø¬Ù‡Ø§Ø².',0),(65046,1807,'fr','Machine non trouvÃ©e.',0),(65047,1807,'jp','æ©Ÿæ¢°ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(65048,1807,'pt','MÃ¡quina nÃ£o encontrada.',0),(65049,1807,'ru','ÐœÐ°ÑˆÐ¸Ð½Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°.',0),(65050,1807,'es','MÃ¡quina no se encontrÃ³',0),(65051,1807,'de','Maschine nicht gefunden.',0),(65052,1807,'en','Machine not found.',0),(65053,1808,'is','',0),(65054,1808,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ø´ÙŠÙ† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(65055,1808,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ø´ÙŠÙ† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(65056,1808,'tr','Makine baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(65057,1808,'pl','UrzÄ…dzenie pomyÅ›lnie zaktualizowana.',0),(65058,1808,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(65059,1808,'ur','Ù…Ø´ÛŒÙ† Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(65060,1808,'sr','ÐœÐ°ÑˆÐ¸Ð½Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(65061,1808,'vi','Cáº­p Nháº­t mÃ¡y thÃ nh cÃ´ng',0),(65062,1808,'af','Masjien suksesvol opdateer.',0),(65063,1808,'ro','Masina actualizat cu succes.',0),(65064,1808,'et','Arvuti vÃ¤rskendamine Ãµnnestus.',0),(65065,1808,'si','Stroj je uspeÅ¡no posodobljena.',0),(65066,1808,'ba','Mesin diperbarui berhasil.',0),(65067,1808,'nl','Machine bijgewerkt.',0),(65068,1808,'fi','Kone pÃ¤ivitetty.',0),(65069,1808,'no','Maskinen oppdatert.',0),(65070,1808,'da','Maskine opdateret.',0),(65071,1808,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ê¸°ê³„.',0),(65072,1808,'he','×ž×›×•× ×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(65073,1808,'el','ÎœÎ·Ï‡Î±Î½Î® ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(65074,1808,'zh','æœºæ›´æ–°æˆåŠŸã€‚\r\n',0),(65075,1808,'sv','Maskin uppdaterats.',0),(65076,1808,'it','Macchina aggiornato con successo.',0),(65077,1808,'tl','',0),(65078,1808,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(65079,1808,'hi','à¤®à¤¶à¥€à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(65080,1808,'ms','Mesin yang berjaya dikemas kini.',0),(65081,1808,'ar','Ø¢Ù„Ø© ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(65082,1808,'fr','Machine mis Ã  jour avec succÃ¨s.',0),(65083,1808,'jp','æ©Ÿæ¢°ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(65084,1808,'pt','MÃ¡quina atualizada com Ãªxito.',0),(65085,1808,'ru','ÐœÐ°ÑˆÐ¸Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(65086,1808,'es','MÃ¡quina actualizada exitosamente',0),(65087,1808,'de','Maschine, die erfolgreich aktualisiert.',0),(65088,1808,'en','Machine updated successfully.',0),(65089,1809,'is','',0),(65090,1809,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯Ù‡ ',0),(65091,1809,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯Ù‡ ',0),(65092,1809,'tr','yapÄ±lan deÄŸiÅŸiklikler',0),(65093,1809,'pl','dokonane zmiany',0),(65094,1809,'bg','Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(65095,1809,'ur','Ø¨Ù†Ø§ÛŒØ§ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(65096,1809,'sr','Ð½Ð°Ð¿Ñ€Ð°Ð²Ñ™ÐµÐ½Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(65097,1809,'vi','thay Ä‘á»•i',0),(65098,1809,'af','veranderinge gemaak',0),(65099,1809,'ro','fÄƒcute modificÄƒri',0),(65100,1809,'et','tehtud muudatused',0),(65101,1809,'si','na spremembe',0),(65102,1809,'ba','perubahan',0),(65103,1809,'nl','gemaakte wijzigingen',0),(65104,1809,'fi','tehdyt muutokset',0),(65105,1809,'no','gjort endringer',0),(65106,1809,'da','lavet Ã¦ndringer',0),(65107,1809,'ko','ë§Œë“ ëœ ë³€ê²½',0),(65108,1809,'he','×¢×©×” ×©×™× ×•×™×™×',0),(65109,1809,'el','Î­ÎºÎ±Î½Îµ Î±Î»Î»Î±Î³Î­Ï‚',0),(65110,1809,'zh','æ‰€åšçš„æ›´æ”¹\r\n',0),(65111,1809,'sv','gjorda Ã¤ndringar',0),(65112,1809,'it','cambiamenti fatti',0),(65113,1809,'tl','',0),(65114,1809,'th','&#3607;&#3635;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(65115,1809,'hi','à¤•à¤¿à¤ à¤—à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(65116,1809,'ms','perubahan yang dibuat',0),(65117,1809,'ar','ØªØºÙŠÙŠØ±Ø§Øª',0),(65118,1809,'fr','modifications faites',0),(65119,1809,'jp','å¤‰æ›´ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(65120,1809,'pt','mudanÃ§as feitas',0),(65121,1809,'ru','Ð²Ð½ÐµÑÐµÐ½Ñ‹ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(65122,1809,'es','Se Hizo cambios',0),(65123,1809,'de','Ã„nderungen',0),(65124,1809,'en','made changes',0),(65125,1810,'is','',0),(65126,1810,'dr','Ù…Ø­Ù„ Ù†Ø§Ù…Ù‡ Ù†Ú¯Ø§Ø±ÙŠ ',0),(65127,1810,'pr','Ù…Ø­Ù„ Ù†Ø§Ù…Ù‡ Ù†Ú¯Ø§Ø±ÙŠ ',0),(65128,1810,'tr','Posta duraÄŸÄ±',0),(65129,1810,'pl','Stop poczty',0),(65130,1810,'bg','ÐŸÐ¾Ñ‰Ð° ÑÑ‚Ð¾Ð¿',0),(65131,1810,'ur','ÚˆØ§Ú© Ø±ÙˆÚ©',0),(65132,1810,'sr','Ð¡Ñ‚Ð°Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ð¾ÑˆÑ‚Ñƒ',0),(65133,1810,'vi','Há»™p thÆ°',0),(65134,1810,'af','E-pos Stop',0),(65135,1810,'ro','Oprire corespondenÅ£Äƒ',0),(65136,1810,'et','Mail stop number',0),(65137,1810,'si','PoÅ¡ta Stop',0),(65138,1810,'ba','Mail Stop',0),(65139,1810,'nl','Mail Stop',0),(65140,1810,'fi','Postilokeron',0),(65141,1810,'no','E stopp',0),(65142,1810,'da','Mail Stop',0),(65143,1810,'ko','ë©”ì¼ ì¤‘ì§€',0),(65144,1810,'he','×ª×—× ×ª ×“×•××¨',0),(65145,1810,'el','Î”Î¹Î±ÎºÎ¿Ï€Î® Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚',0),(65146,1810,'zh','é‚®ä»¶åœæ­¢\r\n',0),(65147,1810,'sv','E-Stop',0),(65148,1810,'it','Mail Stop',0),(65149,1810,'tl','',0),(65150,1810,'th','&#3605;&#3641;&#3657; &#3611;&#3603;.',0),(65151,1810,'hi','à¤®à¥‡à¤² à¤°à¥‹à¤•à¥‡à¤‚',0),(65152,1810,'ms','Hentian mel',0),(65153,1810,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(65154,1810,'fr','ArrÃªt postal',0),(65155,1810,'jp','éƒµä¾¿å?œæ­¢',0),(65156,1810,'pt','Mail Stop',0),(65157,1810,'ru','ÐžÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(65158,1810,'es','Parte adicional de CÃ³digo Postal',0),(65159,1810,'de','Post-Stop',0),(65160,1810,'en','Mail Stop',0),(65161,1811,'is','',0),(65162,1811,'dr','( Ù…ÙƒØ§Ù† Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(65163,1811,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ù…Ø±Ø§Ø³Ù„Ø§Øª ( Ù…ÙƒØ§Ù† Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(65164,1811,'tr','Posta etiketleri (mÃ¼ÅŸteri Mekanlar)',0),(65165,1811,'pl','Korespondencji etykiety (lokalizacji klienta)',0),(65166,1811,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸ (ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¼ÐµÑÑ‚Ð°)',0),(65167,1811,'ur','ØªØ±Ø³ÛŒÙ„ÛŒ Ù„ÛŒØ¨Ù„ (Ú©Ø³Ù¹Ù…Ø± Ù…Ù‚Ø§Ù…Ø§Øª)',0),(65168,1811,'sr','ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐµ Ð¾Ð·Ð½Ð°ÐºÐµ (ÐºÑƒÐ¿Ð°Ñ† Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ)',0),(65169,1811,'vi','NhÃ£n bao thÆ° (Ä‘á»‹a Ä‘iá»ƒm khÃ¡ch hÃ ng)',0),(65170,1811,'af','Posettikette (Klant/KliÃ«nt Ligging)',0),(65171,1811,'ro','Etichete (client locaÅ£ii) poÅŸtale',0),(65172,1811,'et','Aadressisiltide (klientide juurde)',0),(65173,1811,'si','Nalepke (kupec lokacijah)',0),(65174,1811,'ba','Mailing label (lokasi Customer)',0),(65175,1811,'nl','Adresetiketten (klantlocaties)',0),(65176,1811,'fi','Osoitetarrojen (asiakkaan sijainnit)',0),(65177,1811,'no','Adresseetiketter (kunde steder)',0),(65178,1811,'da','Adresseetiketter (kunde steder)',0),(65179,1811,'ko','ìš°íŽ¸ë¬¼ ë ˆì´ë¸” (ê³ ê° ìœ„ì¹˜)',0),(65180,1811,'he','×ª×•×•×™×•×ª (×œ×§×•×— ×ž×™×§×•×ž×™×) ×ž×¢×Ÿ',0),(65181,1811,'el','Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚ (Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚ Ï€ÎµÎ»Î¬Ï„Î·) Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚',0),(65182,1811,'zh','é‚®å¯„æ ‡ç­¾ï¼ˆå®¢æˆ·åœ°ç‚¹ï¼‰\r\n',0),(65183,1811,'sv','Adressetiketter (kunden platser)',0),(65184,1811,'it','Mailing etichette (sedi del cliente)',0),(65185,1811,'tl','',0),(65186,1811,'th','&#3593;&#3621;&#3634;&#3585;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3656;&#3591;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660; (&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;)',0),(65187,1811,'hi','à¤®à¥‡à¤²à¤¿à¤‚à¤— à¤²à¥‡à¤¬à¤²à¥à¤¸ (à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚)',0),(65188,1811,'ms','Surat menyurat label (lokasi pelanggan)',0),(65189,1811,'ar','Ø¹Ù†ÙˆÙ†Ø© (Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡)',0),(65190,1811,'fr','Ã‰tiquettes (emplacements de l\'abonnÃ©)',0),(65191,1811,'jp','å®›å??ãƒ©ãƒ™ãƒ«ï¼ˆé¡§å®¢ï¼‰',0),(65192,1811,'pt','(Locais de cliente) de etiquetas de endereÃ§amento',0),(65193,1811,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ðµ ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸ (Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°)',0),(65194,1811,'es','Etiquetas de EnvÃ­o (UbicaciÃ³n de Cliente)',0),(65195,1811,'de','Adressetiketten (Kundenstandorten)',0),(65196,1811,'en','Mailing Labels (Customer Locations)',0),(65197,1812,'is','',0),(65198,1812,'dr',':ÙØ±Ù…Ø§ÛŒØ´ Ø§Ø² Ù…Ø­Ù„ Ù‡Ø§ ',0),(65199,1812,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ù…Ø±Ø§Ø³Ù„Ø§Øª :Ø³ÙØ§Ø±Ø´ Ø§Ø² Ù…Ø­Ù„ Ù‡Ø§ ',0),(65200,1812,'tr','Posta etiketleri: SipariÅŸ yerlerden',0),(65201,1812,'pl','Etykiet wysyÅ‚kowych: ZamÃ³wienia od lokalizacji',0),(65202,1812,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸: Ð ÐµÐ´ Ð¾Ñ‚ Ð¼ÐµÑÑ‚Ð°',0),(65203,1812,'ur','ØªØ±Ø³ÛŒÙ„ÛŒ Ù„ÛŒØ¨Ù„: Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø³Û’ Ø¢Ø±ÚˆØ±',0),(65204,1812,'sr','ÐÐ°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ðµ ÑÐ° Ð°Ð´Ñ€ÐµÑÐ¾Ð¼: ÐÐ°Ð»Ð¾Ð³ ÑÐ° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(65205,1812,'vi','Äá»‹a chá»‰ gá»­i hÃ ng: ÄÆ¡n hÃ ng tá»« cÃ¡c Ä‘á»‹a Ä‘iá»ƒm',0),(65206,1812,'af','Posettikette:  Bestellings Vanaf Liggings',0),(65207,1812,'ro','Etichete poÅŸtale: Ordin la locatii',0),(65208,1812,'et','Aadressisiltidele printida: Hooldustellimuse asukohtadest',0),(65209,1812,'si','Nalepke z naslovi: Nalog iz lokacije',0),(65210,1812,'ba','Label Surat: Order dari lokasi',0),(65211,1812,'nl','Adresetiketten: Volgorde van locaties',0),(65212,1812,'fi','Osoitetarrojen: JÃ¤rjestys paikoista',0),(65213,1812,'no','Adresseetiketter: Ordre fra steder',0),(65214,1812,'da','Adresseetiketter: Ordre fra placeringer',0),(65215,1812,'ko','ìœ„ì¹˜ì—ì„œ ìš°íŽ¸ë¬¼ ë ˆì´ë¸”: ìˆœì„œ',0),(65216,1812,'he','×ª×•×•×™×•×ª ×ž×¢×Ÿ: ×¡×“×¨ ×ž×™×§×•×ž×™×',0),(65217,1812,'el','Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚ Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚: Î£ÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚',0),(65218,1812,'zh','é‚®ä»¶æ ‡ç­¾ï¼šä»Žä½ç½®è®¢å•\r\n',0),(65219,1812,'sv','Adressetiketter: Order frÃ¥n platser',0),(65220,1812,'it','Etichette postali: Ordine da posizioni',0),(65221,1812,'tl','',0),(65222,1812,'th','&#3611;&#3657;&#3634;&#3618;&#3605;&#3636;&#3604;&#3592;&#3604;&#3627;&#3617;&#3634;&#3618; : &#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3607;&#3637;&#3656;',0),(65223,1812,'hi','à¤®à¥‡à¤²à¤¿à¤‚à¤— à¤²à¥‡à¤¬à¤²: à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤¸à¥‡',0),(65224,1812,'ms','Surat menyurat Label: Perintah dari lokasi',0),(65225,1812,'ar','Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø¹Ù†ÙˆÙ†Ø© Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠØ©: ØªØ±ØªÙŠØ¨ Ù…Ù† Ø§Ù„Ù…ÙˆØ§Ù‚Ø¹',0),(65226,1812,'fr','Ã‰tiquettes de publipostage : Ordre des sites',0),(65227,1812,'jp','å®›å??ãƒ©ãƒ™ãƒ«ï¼šç™ºæ³¨å…ƒ',0),(65228,1812,'pt','Etiquetas de endereÃ§amento: Ordem de locais',0),(65229,1812,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ðµ ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸: ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¾Ñ‚ Ð¼ÐµÑÑ‚',0),(65230,1812,'es','Etiquetas de EnvÃ­o: Pedir de Colocaciones',0),(65231,1812,'de','Adressetiketten: Bestellung von Standorten',0),(65232,1812,'en','Mailing Labels: Order From Locations',0),(65233,1813,'is','',0),(65234,1813,'dr',': Ù¾Ø±Ø¯Ø§Ø®Øª (Ù…Ø¹Ø§Ø´) Ø¨Ù‡ Ù…Ø­Ù„ Ù‡Ø§',0),(65235,1813,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ù…Ø±Ø§Ø³Ù„Ø§Øª: Ù¾Ø±Ø¯Ø§Ø®Øª (Ø­Ù‚ÙˆÙ‚) Ø¨Ù‡ Ù…Ø­Ù„ Ù‡Ø§',0),(65236,1813,'tr','Posta etiketleri: Ã–deme mekanlar iÃ§in',0),(65237,1813,'pl','Etykiet adresowych: ZapÅ‚aciÄ‡ do lokalizacji',0),(65238,1813,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸: Ð—Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¼ÐµÑÑ‚Ð°',0),(65239,1813,'ur','ØªØ±Ø³ÛŒÙ„ÛŒ Ù„ÛŒØ¨Ù„: Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Û’ Ù„ÛŒÛ’ ØªÙ†Ø®ÙˆØ§Û',0),(65240,1813,'sr','ÐÐ°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ðµ ÑÐ° Ð°Ð´Ñ€ÐµÑÐ¾Ð¼: ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð¾ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(65241,1813,'vi','NhÃ£n bao thÆ°: Tráº£ theo vá»‹ trÃ­',0),(65242,1813,'af','Posettikette:  Betaal Aan Liggings',0),(65243,1813,'ro','Etichete poÅŸtale: Plata pentru locaÅ£ii',0),(65244,1813,'et','Postituse Sildid: Maksa asukohad',0),(65245,1813,'si','Nalepke z naslovi: PlaÄilo na lokacijah',0),(65246,1813,'ba','Mailing Labels: Membayar ke lokasi',0),(65247,1813,'nl','Adresetiketten: Betalen naar locaties',0),(65248,1813,'fi','Osoitetarrat: Maksu paikkoihin',0),(65249,1813,'no','Adresseetiketter: Betale til steder',0),(65250,1813,'da','AdressemÃ¦rkater: Betale til placeringer',0),(65251,1813,'ko','ìš°íŽ¸ë¬¼ ë ˆì´ë¸”: ìœ„ì¹˜ì— ì§€ë¶ˆ',0),(65252,1813,'he','×ª×•×•×™×•×ª ×ž×¢×Ÿ: ×œ×©×œ× ×ž×™×§×•×ž×™×',0),(65253,1813,'el','Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚ Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚: Î‘Î¼Î¿Î¹Î²Î® ÏƒÎµ Î¸Î­ÏƒÎµÎ¹Ï‚',0),(65254,1813,'zh','é‚®ä»¶æ ‡ç­¾ï¼šæ”¯ä»˜åˆ°ä½ç½®\r\n',0),(65255,1813,'sv','Adressetiketter: Betala till platser',0),(65256,1813,'it','Etichette postali: Pay per posizioni',0),(65257,1813,'tl','',0),(65258,1813,'th','&#3611;&#3657;&#3634;&#3618;&#3605;&#3636;&#3604;&#3592;&#3604;&#3627;&#3617;&#3634;&#3618; : &#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;',0),(65259,1813,'hi','à¤®à¥‡à¤²à¤¿à¤‚à¤— à¤²à¥‡à¤¬à¤²: à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚',0),(65260,1813,'ms','Label mel: Membayar ke lokasi',0),(65261,1813,'ar','Ø¨Ø·Ø§Ù‚Ø§Øª Ø¹Ù†ÙˆÙ†Ø© Ø¨Ø±ÙŠØ¯ÙŠØ©: Ø§Ù„Ø¯ÙØ¹ Ù„Ù„Ù…ÙˆØ§Ù‚Ø¹',0),(65262,1813,'fr','Des Ã©tiquettes de publipostage : Payer aux emplacements',0),(65263,1813,'jp','å®›å??ãƒ©ãƒ™ãƒ«ï¼šæ”¯æ‰•ã?„å…ˆ',0),(65264,1813,'pt','Etiquetas de endereÃ§amento: Pagar para locais',0),(65265,1813,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ðµ Ð½Ð°ÐºÐ»ÐµÐ¹ÐºÐ¸: ÐŸÐ»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð² Ð¼ÐµÑÑ‚Ð°',0),(65266,1813,'es','Etiquetas de EnvÃ­o: Pagar a Colocaciones',0),(65267,1813,'de','Adressetiketten: Zahlen Sie, um Standorte',0),(65268,1813,'en','Mailing Labels: Pay To Locations',0),(65269,1814,'is','',0),(65270,1814,'dr','( Ø­Ù…Ù„ Ø¨Ù‡ Ù…Ø­Ù„ Ù‡Ø§',0),(65271,1814,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ù…Ø±Ø§Ø³Ù„Ø§Øª( Ø­Ù…Ù„ Ø¨Ù‡ Ù…Ø­Ù„ Ù‡Ø§',0),(65272,1814,'tr','Posta etiketleri (konumlarÄ±na gemi)',0),(65273,1814,'pl','Etykiet adresowych (statek do lokalizacji)',0),(65274,1814,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸ (ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾ Ð¼ÐµÑÑ‚Ð°)',0),(65275,1814,'ur','ØªØ±Ø³ÛŒÙ„ÛŒ Ù„ÛŒØ¨Ù„ (Ø¬ÛØ§Ø² Ú©Û’ Ù…Ù‚Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’)',0),(65276,1814,'sr','ÐÐ°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ðµ ÑÐ° Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ (Ð±Ñ€Ð¾Ð´ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ)',0),(65277,1814,'vi','NhÃ£n bao thÆ° (chuyá»ƒn tá»›i Ä‘á»‹a Ä‘iá»ƒm)',0),(65278,1814,'af','Poslys Etikette (Versend Na Liggings)',0),(65279,1814,'ro','Etichete de corespondenÅ£Äƒ (navÄƒ locatii)',0),(65280,1814,'et','Aadressisiltide (laeva asukohad)',0),(65281,1814,'si','Nalepke (ladja na lokacijah)',0),(65282,1814,'ba','Mailing Labels (kapal ke lokasi)',0),(65283,1814,'nl','Adresetiketten (verzendlocaties)',0),(65284,1814,'fi','Osoitetarrojen (laiva paikkoihin)',0),(65285,1814,'no','Adresseetiketter (skip til steder)',0),(65286,1814,'da','Adresseetiketter (skib til placeringer)',0),(65287,1814,'ko','ìš°íŽ¸ë¬¼ ë ˆì´ë¸” (ìœ„ì¹˜ì— ë°°)',0),(65288,1814,'he','×ª×•×•×™×•×ª ×ž×¢×Ÿ (××•× ×™×™×” ×œ×ž×™×§×•×ž×™×)',0),(65289,1814,'el','Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚ Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚ (Ï€Î»Î¿Î¯Î¿ ÏƒÎµ Î¸Î­ÏƒÎµÎ¹Ï‚)',0),(65290,1814,'zh','é‚®å¯„æ ‡ç­¾ï¼ˆæ”¶è´§åœ°ç‚¹ï¼‰\r\n',0),(65291,1814,'sv','Adressetiketter (fartyg till platser)',0),(65292,1814,'it','Mailing etichette (nave a posizioni)',0),(65293,1814,'tl','',0),(65294,1814,'th','&#3593;&#3621;&#3634;&#3585;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3656;&#3591;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660; (&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3607;&#3637;&#3656;&#3605;&#3633;&',0),(65295,1814,'hi','à¤®à¥‡à¤²à¤¿à¤‚à¤— à¤²à¥‡à¤¬à¤²à¥à¤¸ (à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ)',0),(65296,1814,'ms','Surat menyurat label (kapal ke lokasi)',0),(65297,1814,'ar','Ø¨Ø·Ø§Ù‚Ø§Øª Ø¹Ù†ÙˆÙ†Ø© Ø¨Ø±ÙŠØ¯ÙŠØ© (Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù„Ù„Ù…ÙˆØ§Ù‚Ø¹)',0),(65298,1814,'fr','Ã‰tiquettes de publipostage (navire d\'emplacements)',0),(65299,1814,'jp','å®›å??ãƒ©ãƒ™ãƒ«ï¼ˆç™ºé€?å…ˆï¼‰',0),(65300,1814,'pt','(Navio para locais) de etiquetas de endereÃ§amento',0),(65301,1814,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ðµ Ð½Ð°ÐºÐ»ÐµÐ¹ÐºÐ¸ (ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð½Ð° Ð¼ÐµÑÑ‚Ð°Ñ…)',0),(65302,1814,'es','Etiquetas de EnvÃ­o (Enviar a Ubicaciones',0),(65303,1814,'de','Adressetiketten (Schiff zu Orten)',0),(65304,1814,'en','Mailing Labels (Ship To Locations)',0),(65305,1815,'is','',0),(65306,1815,'dr','ØªÙ„ÙÙ† Ø§Ø¯Ø§Ø±Ù‡ Ø§ØµÙ„ÙŠ',0),(65307,1815,'pr','ØªÙ„ÙÙ† Ø§Ø¯Ø§Ø±Ù‡ Ø§ØµÙ„ÙŠ',0),(65308,1815,'tr','Ana ofis',0),(65309,1815,'pl','Telefon centrali',0),(65310,1815,'bg','Ð“Ð»Ð°Ð²ÐµÐ½ Ð¾Ñ„Ð¸Ñ Ð½Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(65311,1815,'ur','Ù…Ø±Ú©Ø²ÛŒ Ø¯ÙØªØ± ÙÙˆÙ†',0),(65312,1815,'sr','Ð“Ð»Ð°Ð²Ð½Ð¸ ÐŸÐ¾ÑÐ»Ð¾Ð²Ð½Ð¸ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(65313,1815,'vi','Phone cá»§a vÄƒn phÃ²ng chÃ­nh',0),(65314,1815,'af','Hoofkantoor Foonnr.',0),(65315,1815,'ro','Biroul principal telefon',0),(65316,1815,'et','Peakontori telefon',0),(65317,1815,'si','Glavni urad telefon',0),(65318,1815,'ba','Telepon kantor',0),(65319,1815,'nl','Hoofdkantoor telefoon',0),(65320,1815,'fi','TÃ¤rkeimmÃ¤t Puhelin',0),(65321,1815,'no','Hovedkontor telefon',0),(65322,1815,'da','Hovedkontoret telefon',0),(65323,1815,'ko','ë³¸ì‚¬ ì „í™”',0),(65324,1815,'he','×˜×œ×¤×•×Ÿ ×ž×©×¨×“ ×¨××©×™',0),(65325,1815,'el','ÎšÎµÎ½Ï„ÏÎ¹ÎºÏŒ Î³ÏÎ±Ï†ÎµÎ¯Î¿ Ï„Î·Î»Î­Ï†Ï‰Î½Î¿',0),(65326,1815,'zh','ä¸»è¦åŠžå…¬ç”µè¯\r\n',0),(65327,1815,'sv','Huvudkontor telefon',0),(65328,1815,'it','Telefono ufficio principale',0),(65329,1815,'tl','',0),(65330,1815,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;&#3627;&#3621;&#3633;&#3585;',0),(65331,1815,'hi','à¤®à¥à¤–à¥à¤¯ à¤•à¤¾à¤°à¥à¤¯à¤¾à¤²à¤¯ à¤«à¥‹à¤¨',0),(65332,1815,'ms','Telefon pejabat',0),(65333,1815,'ar','Ù‡Ø§ØªÙ Ø§Ù„Ù…ÙƒØªØ¨ Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ',0),(65334,1815,'fr','TÃ©lÃ©phone de bureau principal',0),(65335,1815,'jp','ãƒ¡ã‚¤ãƒ³ã‚ªãƒ•ã‚£ã‚¹é›»è©±ç•ªå?·',0),(65336,1815,'pt','Telefone do escritÃ³rio principal',0),(65337,1815,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ Ð“Ð»Ð°Ð²Ð½Ð¾Ð³Ð¾ ÐžÑ„Ð¸ÑÐ°',0),(65338,1815,'es','TelÃ©fono de Oficina Principal',0),(65339,1815,'de','HauptbÃ¼ro Telefon',0),(65340,1815,'en','Main Office Phone',0),(65341,1816,'is','',0),(65342,1816,'dr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù†  Ø¯Ø± Ø¯Ø§Ø®Ù„ ÙŠÙƒ Ø³ÙØ§Ø±Ø´  ',0),(65343,1816,'pr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù†  Ø¯Ø± Ø¯Ø§Ø®Ù„ ÙŠÙƒ Ø³ÙØ§Ø±Ø´  ',0),(65344,1816,'tr','SipariÅŸe olun',0),(65345,1816,'pl','ZrobiÄ‡ na zamÃ³wienie',0),(65346,1816,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ð² Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(65347,1816,'ur','Ø§ÛŒÚ© Ù†Ø¸Ù… Ù…ÛŒÚº Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(65348,1816,'sr','ÐŸÑ€ÐµÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ð¸ Ñƒ Ð½Ð°Ð»Ð¾Ð³',0),(65349,1816,'vi','LÃ m vÃ o 1 Ä‘Æ¡n hÃ ng',0),(65350,1816,'af','Maak in \'n volgorde',0),(65351,1816,'ro','Face Ã®ntr-o ordine',0),(65352,1816,'et','Muuta tellimuseks',0),(65353,1816,'si','Da v naroÄilo',0),(65354,1816,'ba','Membuat ke perintah',0),(65355,1816,'nl','Een order maken',0),(65356,1816,'fi','Tee tilaus',0),(65357,1816,'no','GjÃ¸re om til en ordre',0),(65358,1816,'da','GÃ¸re til en ordre',0),(65359,1816,'ko','ì£¼ë¬¸ìœ¼ë¡œ',0),(65360,1816,'he','×œ×”×¤×•×š ×¤×§×•×“×”',0),(65361,1816,'el','ÎšÎ¬Î½ÎµÎ¹ ÏƒÎµ Î¼Î¹Î± ÏƒÎµÎ¹ÏÎ¬',0),(65362,1816,'zh','ä½¿ä¹‹æˆä¸ºä¸€ä¸ªå‘½ä»¤\r\n',0),(65363,1816,'sv','GÃ¶r till en order',0),(65364,1816,'it','Trasformare un ordine',0),(65365,1816,'tl','',0),(65366,1816,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3652;&#3611;&#3607;&#3637;&#3656;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(65367,1816,'hi','à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤à¤• à¤†à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚',0),(65368,1816,'ms','Bentukkan suatu perintah',0),(65369,1816,'ar','Ø¬Ø¹Ù„ Ø¥Ù„Ù‰ Ø£Ù…Ø±',0),(65370,1816,'fr','Faire dans un ordre',0),(65371,1816,'jp','é †ç•ªã?«ã?™ã‚‹',0),(65372,1816,'pt','Transforme uma ordem',0),(65373,1816,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(65374,1816,'es','Cambiar a un pedido',0),(65375,1816,'de','Machen Sie eine Bestellung',0),(65376,1816,'en','Make into an order',0),(65377,1817,'is','',0),(65378,1817,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(65379,1817,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(65380,1817,'tr','Yeni alÄ±ntÄ± yapmak',0),(65381,1817,'pl','Nowe ceny',0),(65382,1817,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ð½Ð¾Ð²Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(65383,1817,'ur','Ù†Ø¦Û’ Ø§Ù‚ØªØ¨Ø§Ø³ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(65384,1817,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ð½Ð¾Ð²Ñƒ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð°',0),(65385,1817,'vi','LÃ m bÃ¡o giÃ¡ má»›i',0),(65386,1817,'af','Maak nuwe kwotasie',0),(65387,1817,'ro','Face noi citat',0),(65388,1817,'et','Tee uus hinnapakkumine',0),(65389,1817,'si','Bi nove ponudbe',0),(65390,1817,'ba','Membuat baru kutipan',0),(65391,1817,'nl','Nieuwe offerte maken',0),(65392,1817,'fi','Uuden vertailu',0),(65393,1817,'no','Nye tilbud',0),(65394,1817,'da','GÃ¸re nye tilbud',0),(65395,1817,'ko','ìƒˆ ê²¬ì  í™•ì¸',0),(65396,1817,'he','×œ×™×¦×•×¨ ×”×¦×¢×ª ×ž×—×™×¨ ×—×“×©×”',0),(65397,1817,'el','ÎšÎ¬Î½Î¿Ï…Î½ Î½Î­Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(65398,1817,'zh','å»ºç«‹æ–°çš„æŠ¥ä»·\r\n',0),(65399,1817,'sv','GÃ¶ra ny offert',0),(65400,1817,'it','Nuovo preventivo',0),(65401,1817,'tl','',0),(65402,1817,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(65403,1817,'hi','à¤¨à¤ˆ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤¬à¤¨à¤¾à¤¨à¥‡',0),(65404,1817,'ms','Membuat sebut harga baru',0),(65405,1817,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ Ø¬Ø¯ÙŠØ¯',0),(65406,1817,'fr','Devir nouveau',0),(65407,1817,'jp','æ–°è¦?è¦‹ç©?ã‚‚ã‚Šä½œæˆ?',0),(65408,1817,'pt','Fazer nova cotaÃ§Ã£o',0),(65409,1817,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÑƒ',0),(65410,1817,'es','Hacer nueva cotizaciÃ³n',0),(65411,1817,'de','Neues Angebot zu machen',0),(65412,1817,'en','Make new quote',0),(65413,1818,'is','',0),(65414,1818,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø§Ø² Ù…Ø´Ø§Ø¨Ù‡ Ø¨Ø§Ù„Ø§ ',0),(65415,1818,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø§Ø² Ù…Ø´Ø§Ø¨Ù‡ Ø¨Ø§Ù„Ø§ ',0),(65416,1818,'tr','AynÄ± aynÄ± derecede yukarÄ±da',0),(65417,1818,'pl','Tak samo jak wyÅ¼ej',0),(65418,1818,'bg','Ð¡ÑŠÑ‰Ð¾Ñ‚Ð¾ ÐºÐ°Ñ‚Ð¾ Ð³Ð¾Ñ€Ðµ',0),(65419,1818,'ur','Ø§ÙˆÙ¾Ø± Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§ÛŒÚ© ÛÛŒ',0),(65420,1818,'sr','Ð˜ÑÑ‚Ð¾ ÐºÐ°Ð¾ Ð¸ Ð¸Ð·Ð½Ð°Ð´',0),(65421,1818,'vi','LÃ m Ä‘Æ¡n hÃ ng giá»‘ng nhÆ° trÃªn',0),(65422,1818,'af','Dieselfde As bogenoemde',0),(65423,1818,'ro','AceleaÅŸi ca mai sus',0),(65424,1818,'et','Sama, mis eelmine',0),(65425,1818,'si','Enako kot zgoraj',0),(65426,1818,'ba','Sama seperti di atas',0),(65427,1818,'nl','Hetzelfde als hierboven',0),(65428,1818,'fi','Sama kuin edellÃ¤',0),(65429,1818,'no','Samme som ovenfor',0),(65430,1818,'da','Samme som ovenfor',0),(65431,1818,'ko','ìœ„ì™€ ë™ì¼',0),(65432,1818,'he','×–×”×” ×œ×¢×™×œ',0),(65433,1818,'el','ÎŠÎ´Î¹Î¿ ÏŒÏ€Ï‰Ï‚ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰',0),(65434,1818,'zh','ä½¿è®¢è´­å¤„å¦‚ä¸Š\r\n',0),(65435,1818,'sv','Samma som ovan',0),(65436,1818,'it','Come sopra',0),(65437,1818,'tl','',0),(65438,1818,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3627;&#3617;&#3639;&#3629;&#3609;&#3585;&#3633;&#3610;&#3586;&#3657;&#3634;&#3591;&#3610;&#3609;',0),(65439,1818,'hi','à¤‡à¤¸à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¹à¥€',0),(65440,1818,'ms','Sama seperti di atas',0),(65441,1818,'ar','Ù†ÙØ³ Ø§Ù„Ù…Ø°ÙƒÙˆØ± Ø£Ø¹Ù„Ø§Ù‡',0),(65442,1818,'fr','Idem que ci-dessus',0),(65443,1818,'jp','ä¸Šã?¨å?Œã?˜ã‚‚ã?®ã?‹ã‚‰æ³¨æ–‡ã?™ã‚‹',0),(65444,1818,'pt','Mesmo que acima',0),(65445,1818,'ru','Ð¢Ð¾ Ð¶Ðµ ÑÐ°Ð¼Ð¾Ðµ',0),(65446,1818,'es','Hacer Pedido Del Mismo Como Arriba',0),(65447,1818,'de','Wie oben',0),(65448,1818,'en','Same As Above',0),(65449,1819,'is','',0),(65450,1819,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³Ø§ÙˆÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(65451,1819,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³Ø§ÙˆÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(65452,1819,'tr','Ã–denen Ã¶deme eÅŸit yap',0),(65453,1819,'pl','ZrobiÄ‡ rÃ³wne pÅ‚atnoÅ›ci wypÅ‚acane',0),(65454,1819,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÐµÐ´Ð½Ð°ÐºÐ²Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(65455,1819,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù…Ø³Ø§ÙˆÛŒ Ø§Ø¯Ø§ Ú©Ø±ÛŒÚº',0),(65456,1819,'sr','Ð£Ñ˜ÐµÐ´Ð½Ð°Ñ‡Ð°Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(65457,1819,'vi','LÃ m thanh toÃ¡n thÃ nh Ä‘Ã£ tráº£',0),(65458,1819,'af','Maak Betaling Gelykstaande aan Betalings Gemaak',0),(65459,1819,'ro','Face plata egale plÄƒtite',0),(65460,1819,'et','Teha makse vÃµrdsete makstud',0),(65461,1819,'si','IzenaÄi plaÄila plaÄana',0),(65462,1819,'ba','Membuat pembayaran sama dibayar',0),(65463,1819,'nl','Betaling gelijke betaald maken',0),(65464,1819,'fi','Tee maksu tasa maksettu',0),(65465,1819,'no','Utjevn betaling betalt',0),(65466,1819,'da','Foretage betaling lige betalt',0),(65467,1819,'ko','ì§€ë¶ˆ ì§€ë¶ˆ ë™ë“± í•˜ ê²Œ',0),(65468,1819,'he','×œ×”×¤×•×š ××ª ×ª×©×œ×•× ×©×•×•×” ×œ×©×œ×',0),(65469,1819,'el','ÎšÎ¬Î½Î¿Ï…Î½ Ï„Î·Î½ Î¯ÏƒÎ· Ï€Î»Î·ÏÏ‰Î¼Î® ÎºÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹',0),(65470,1819,'zh','ä½¿ä»˜æ¬¾ä¸Žåº”ä»˜æ¬¾ç›¸ç­‰\r\n',0),(65471,1819,'sv','GÃ¶r betalning lika betalt',0),(65472,1819,'it','Fare pagamento pari pagato',0),(65473,1819,'tl','',0),(65474,1819,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3648;&#3607;&#3656;&#3634;&#3585;&#3633;&#3610;&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3',0),(65475,1819,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¬à¤°à¤¾à¤¬à¤° à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¥‡à¤‚',0),(65476,1819,'ms','Membuat pembayaran sama dibayar',0),(65477,1819,'ar','Ø¬Ø¹Ù„ ØªÙƒØ§ÙØ¤ Ø§Ù„Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(65478,1819,'fr','Rendre Ã©gal de paiement versÃ©',0),(65479,1819,'jp','æ”¯æ‰•ã?„ã‚’æ”¯æ‰•ã?„æ¸ˆã?¨ç­‰ã?—ã??ã?™ã‚‹',0),(65480,1819,'pt','FaÃ§a igual pagamento pago',0),(65481,1819,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ Ñ€Ð°Ð²Ð½Ñ‹Ð¼Ð¸ Ð¿Ð»Ð°Ñ‚Ð½Ñ‹Ðµ',0),(65482,1819,'es','Hacer Pagos Iguales ',0),(65483,1819,'de','Machen Sie Zahlung gleich bezahlt',0),(65484,1819,'en','Make Payment Equal Paid',0),(65485,1820,'is','',0),(65486,1820,'dr','Ø§Ø¯Ø§Ø±Ù‡ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(65487,1820,'pr','Ø§Ø¯Ø§Ø±Ù‡ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(65488,1820,'tr','YapÄ± sipariÅŸleri yÃ¶netmek',0),(65489,1820,'pl','ZarzÄ…dzanie zamÃ³wieniami budowaÄ‡',0),(65490,1820,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(65491,1820,'ur','ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±ÛŒÚº',0),(65492,1820,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(65493,1820,'vi','Quáº£n lÃ½ Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(65494,1820,'af','Hanteer Geboude Bestellings',0),(65495,1820,'ro','Gestiona comenzi de a construi',0),(65496,1820,'et','Build tellimuste haldamine',0),(65497,1820,'si','Upravljanje graditi naroÄila',0),(65498,1820,'ba','Mengelola membangun pesanan',0),(65499,1820,'nl','Build bestellingen beheren',0),(65500,1820,'fi','Hallita rakentaa tilaukset',0),(65501,1820,'no','Behandle bygge',0),(65502,1820,'da','Administrere bygge ordrer',0),(65503,1820,'ko','ë¹Œë“œ ì˜¤ë” ê´€ë¦¬',0),(65504,1820,'he','× ×”×œ ×”×–×ž× ×•×ª ×‘× ×™×”',0),(65505,1820,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(65506,1820,'zh','ç®¡ç†æž„å»ºè®¢å•\r\n',0),(65507,1820,'sv','Hantera bygga order',0),(65508,1820,'it','Gestire la compilazione ordini',0),(65509,1820,'tl','',0),(65510,1820,'th','&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(65511,1820,'hi','à¤¬à¤¿à¤²à¥à¤¡ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¤¾ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨',0),(65512,1820,'ms','Menguruskan pesanan membina',0),(65513,1820,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(65514,1820,'fr','GÃ©rer les commandes de gÃ©nÃ©ration',0),(65515,1820,'jp','åˆ¶ä½œæ³¨æ–‡ã?®ç®¡ç?†',0),(65516,1820,'pt','Gerenciar ordens de construÃ§Ã£o',0),(65517,1820,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(65518,1820,'es','Manejar Ordenes de ConstrucciÃ³n',0),(65519,1820,'de','Build Bestellungen verwalten',0),(65520,1820,'en','Manage Build Orders',0),(65521,1821,'is','',0),(65522,1821,'dr','Ù…Ø§Ø±Ø³ ',0),(65523,1821,'pr','Ù…Ø§Ø±Ø³ ',0),(65524,1821,'tr','Mart',0),(65525,1821,'pl','Marca',0),(65526,1821,'bg','ÐœÐ°Ñ€Ñ‚',0),(65527,1821,'ur','Ù…Ø§Ø±Ú†',0),(65528,1821,'sr','ÐœÐ°Ñ€Ñ‚Ð°',0),(65529,1821,'vi','ThÃ¡ng Ba',0),(65530,1821,'af','Maart',0),(65531,1821,'ro','Martie',0),(65532,1821,'et','MÃ¤rts',0),(65533,1821,'si','Marca',0),(65534,1821,'ba','Maret',0),(65535,1821,'nl','Maart',0),(65536,1821,'fi','Maaliskuuta',0),(65537,1821,'no','Mars',0),(65538,1821,'da','Marts',0),(65539,1821,'ko','3 ì›”',0),(65540,1821,'he','×ž×¨×¥',0),(65541,1821,'el','ÎœÎ±ÏÏ„Î¯Î¿Ï…',0),(65542,1821,'zh','ä¸‰æœˆ\r\n',0),(65543,1821,'sv','Mars',0),(65544,1821,'it','Marzo',0),(65545,1821,'tl','',0),(65546,1821,'th','&#3617;&#3637;&#3609;&#3634;&#3588;&#3617;',0),(65547,1821,'hi','à¤®à¤¾à¤°à¥à¤š',0),(65548,1821,'ms','Mac',0),(65549,1821,'ar','Ù…Ø§Ø±Ø³',0),(65550,1821,'fr','Mars',0),(65551,1821,'jp','3æœˆ',0),(65552,1821,'pt','MarÃ§o de',0),(65553,1821,'ru','ÐœÐ°Ñ€Ñ‚',0),(65554,1821,'es','Marzo',0),(65555,1821,'de','MÃ¤rz',0),(65556,1821,'en','March',0),(65557,1822,'is','',0),(65558,1822,'dr','ÙˆØ¶Ø¹ ØªØ§Ù‡Ù„',0),(65559,1822,'pr','ÙˆØ¶Ø¹ ØªØ§Ù‡Ù„',0),(65560,1822,'tr','Medeni durum',0),(65561,1822,'pl','Stan cywilny',0),(65562,1822,'bg','Ð¡ÐµÐ¼ÐµÐ¹Ð½Ð¾ Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(65563,1822,'ur','Ø§Ø²Ø¯ÙˆØ§Ø¬ÛŒ Ø­ÛŒØ«ÛŒØª',0),(65564,1822,'sr','Ð‘Ñ€Ð°Ñ‡Ð½Ð¾ ÑÑ‚Ð°ÑšÐµ',0),(65565,1822,'vi','TÃ¬nh tráº¡ng hÃ´n nhÃ¢n',0),(65566,1822,'af','Huweliksstatus',0),(65567,1822,'ro','Starea civila',0),(65568,1822,'et','Perekonnaseis',0),(65569,1822,'si','Zakonski stan',0),(65570,1822,'ba','Status perkawinan',0),(65571,1822,'nl','Burgerlijke staat',0),(65572,1822,'fi','SiviilisÃ¤Ã¤ty',0),(65573,1822,'no','Sivilstand',0),(65574,1822,'da','Ã†gteskabelig status',0),(65575,1822,'ko','ê²°í˜¼ ìƒíƒœ',0),(65576,1822,'he','×ž×¦×‘ ×ž×©×¤×—×ª×™',0),(65577,1822,'el','ÎŸÎ¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(65578,1822,'zh','å©šå§»çŠ¶å†µ\r\n',0),(65579,1822,'sv','CivilstÃ¥nd',0),(65580,1822,'it','Stato civile',0),(65581,1822,'tl','',0),(65582,1822,'th','&#3626;&#3606;&#3634;&#3609;&#3616;&#3634;&#3614;&#3585;&#3634;&#3619;&#3626;&#3617;&#3619;&#3626;',0),(65583,1822,'hi','à¤µà¥ˆà¤µà¤¾à¤¹à¤¿à¤• à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(65584,1822,'ms','Status perkahwinan',0),(65585,1822,'ar','Ø§Ù„Ø­Ø§Ù„Ø© Ø§Ù„Ø¥Ø¬ØªÙ…Ø§Ø¹ÙŠØ©',0),(65586,1822,'fr','Ã‰tat matrimonial',0),(65587,1822,'jp','å©šå§»é–¢ä¿‚',0),(65588,1822,'pt','Estado civil',0),(65589,1822,'ru','Ð¡ÐµÐ¼ÐµÐ¹Ð½Ð¾Ðµ Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(65590,1822,'es','Estado Civil',0),(65591,1822,'de','Familienstand',0),(65592,1822,'en','Marital status',0),(65593,1823,'is','',0),(65594,1823,'dr','(Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡) Ø¹Ù„Ø§Ù…Øª Ø¨Ø²Ù†ÙŠØ¯ ',0),(65595,1823,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø±Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø²ÙŠØ§Ù†(Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡) Ø¹Ù„Ø§Ù…Øª Ø¨Ø²Ù†ÙŠØ¯ ',0),(65596,1823,'tr','KayÄ±p olarak alÄ±ntÄ± iÅŸaretle',0),(65597,1823,'pl','Oznacz cytat jako utracone',0),(65598,1823,'bg','ÐœÐ°Ñ€ÐºÐ¸Ñ€Ð°Ð¹ Ñ†Ð¸Ñ‚Ð°Ñ‚ ÐºÐ°Ñ‚Ð¾ Ð·Ð°Ð³ÑƒÐ±ÐµÐ½Ð°',0),(65599,1823,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: Ú¯Ù… Ø´Ø¯Û Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†Ø´Ø§Ù† Ø²Ø¯ Ú©Ø±ÛŒÚº',0),(65600,1823,'sr','ÐžÐ·Ð½Ð°Ñ‡Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚ ÐºÐ°Ð¾ Ð¸Ð·Ð³ÑƒÐ±Ñ™ÐµÐ½Ð¾',0),(65601,1823,'vi','ÄÃ¡nh dáº¥u bÃ¡o giÃ¡ lÃ  Ä‘Ã£ máº¥t',0),(65602,1823,'af','Merk aanhaling as verlore',0),(65603,1823,'ro','Marcaj de citat ca pierdute',0),(65604,1823,'et','MÃ¤rgi tsitaat kadumisest',0),(65605,1823,'si','OznaÄi citat kot izgubljeno',0),(65606,1823,'ba','Mark kutipan sebagai hilang',0),(65607,1823,'nl','Mark citaat als verloren',0),(65608,1823,'fi','Merkitse lainaus kadonneeksi',0),(65609,1823,'no','Mark tilbud som tapt',0),(65610,1823,'da','Mark citat som tabt',0),(65611,1823,'ko','ë¶„ì‹¤ë¡œ ë§ˆí¬ ê²¬ì ',0),(65612,1823,'he','×œ×¡×ž×Ÿ ×¦×™×˜×•×˜ ×›×”×¤×¡×“',0),(65613,1823,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î¼Îµ Ï„Î¿ Î½Î± Ï‡Î±Î¸ÎµÎ¯ Ï„Î¿ ÏƒÎ®Î¼Î±',0),(65614,1823,'zh','æ ‡è®°æŠ¥ä»·ä¸ºä¸¢å¤±\r\n',0),(65615,1823,'sv','Markera citat som fÃ¶rlorade',0),(65616,1823,'it','Citazione di Mark come perduto',0),(65617,1823,'tl','',0),(65618,1823,'th','&#3607;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3626;&#3641;&#3597;&#3627;&#3',0),(65619,1823,'hi','à¤®à¤¾à¤°à¥à¤• à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤–à¥‹ à¤—à¤¯à¤¾',0),(65620,1823,'ms','Tanda petikan sebagai hilang',0),(65621,1823,'ar','Ø¹Ù„Ø§Ù…Ø© Ø§Ù‚ØªØ¨Ø§Ø³ ÙƒÙÙ‚Ø¯Ø§Ù†',0),(65622,1823,'fr','Citation de Mark comme perdus',0),(65623,1823,'jp','è¦‹ç©?ã‚‚ã‚Šã‚’ç´›å¤±ã?¨è¨˜éŒ²ã?™ã‚‹',0),(65624,1823,'pt','CitaÃ§Ã£o de Mark como perdido',0),(65625,1823,'ru','ÐœÐ°Ñ€Ðº Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ°Ðº Ð¿Ð¾Ñ‚ÐµÑ€ÑÐ»',0),(65626,1823,'es','Marcar cotizaciÃ³n como perdida',0),(65627,1823,'de','Zitat von Mark verloren',0),(65628,1823,'en','Mark quote as lost',0),(65629,1824,'is','',0),(65630,1824,'dr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(65631,1824,'pr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(65632,1824,'tr','BiÃ§imlendirme',0),(65633,1824,'pl','Skomentuj',0),(65634,1824,'bg','ÐœÐ°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(65635,1824,'ur','Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­',0),(65636,1824,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ',0),(65637,1824,'vi','GiÃ¡ cá»™ng thÃªm',0),(65638,1824,'af','Markup',0),(65639,1824,'ro','Marcare',0),(65640,1824,'et','MÃ¤rgistus',0),(65641,1824,'si','Markup',0),(65642,1824,'ba','Markup',0),(65643,1824,'nl','Markup',0),(65644,1824,'fi','MerkinnÃ¤t',0),(65645,1824,'no','Markering',0),(65646,1824,'da','Markup',0),(65647,1824,'ko','íƒœê·¸',0),(65648,1824,'he','×¡×™×ž×•×Ÿ',0),(65649,1824,'el','Î£Î®Î¼Î±Î½ÏƒÎ·Ï‚',0),(65650,1824,'zh','æ ‡è®°\r\n',0),(65651,1824,'sv','Markup',0),(65652,1824,'it','Markup',0),(65653,1824,'tl','',0),(65654,1824,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(65655,1824,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª',0),(65656,1824,'ms','Penanda',0),(65657,1824,'ar','ØªÙˆØµÙŠÙ',0),(65658,1824,'fr','Balisage',0),(65659,1824,'jp','å€¤ä¸Šã?’',0),(65660,1824,'pt','MarcaÃ§Ã£o',0),(65661,1824,'ru','Ð Ð°Ð·Ð¼ÐµÑ‚ÐºÐ°',0),(65662,1824,'es','Encarecimiento',0),(65663,1824,'de','Markup',0),(65664,1824,'en','Markup',0),(65665,1825,'is','',0),(65666,1825,'dr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø± Ø§Ø³Ø§Ø³ ',0),(65667,1825,'pr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø± Ø§Ø³Ø§Ø³ ',0),(65668,1825,'tr','Temel biÃ§imlendirme',0),(65669,1825,'pl','Na podstawie znacznikÃ³w',0),(65670,1825,'bg','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸ Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð°',0),(65671,1825,'ur','Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø±',0),(65672,1825,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ',0),(65673,1825,'vi','GiÃ¡ cá»™ng thÃªm dá»±a trÃªn',0),(65674,1825,'af','Markup gebaseer op',0),(65675,1825,'ro','Marcare pe baza',0),(65676,1825,'et','MÃ¤rgistuse kohta',0),(65677,1825,'si','Markup ki temelji na',0),(65678,1825,'ba','Markup berdasarkan',0),(65679,1825,'nl','Aantekeningen op basis van',0),(65680,1825,'fi','MerkintÃ¶jen perusteella',0),(65681,1825,'no','Markering basert pÃ¥',0),(65682,1825,'da','Markup baseret pÃ¥',0),(65683,1825,'ko','íƒœê·¸ì— ë”°ë¼',0),(65684,1825,'he','×¡×™×ž×•×Ÿ ×”×ž×‘×•×¡×¡ ×¢×œ',0),(65685,1825,'el','Î£Î®Î¼Î±Î½ÏƒÎ·Ï‚ Î¼Îµ Î²Î¬ÏƒÎ·',0),(65686,1825,'zh','æ ‡è®°åŸºäºŽ\r\n',0),(65687,1825,'sv','Markup bygger pÃ¥',0),(65688,1825,'it','Markup basato su',0),(65689,1825,'tl','',0),(65690,1825,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3610;&#3609;&#3614;&#3639;&#3657;&#3609;&#3600;&#3634;&#3609;&#3586;&#3629;&#3591;',0),(65691,1825,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤°',0),(65692,1825,'ms','Berdasarkan penanda',0),(65693,1825,'ar','Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³',0),(65694,1825,'fr','Balisage fondÃ© sur',0),(65695,1825,'jp','ï½žã?«ã??ã?£ã?Ÿå€¤ä¸Šã?’',0),(65696,1825,'pt','MarcaÃ§Ã£o com base em',0),(65697,1825,'ru','Ð Ð°Ð·Ð¼ÐµÑ‚ÐºÐ° Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ',0),(65698,1825,'es','Encarecimiento Basado En',0),(65699,1825,'de','Auf der Grundlage von Markup',0),(65700,1825,'en','Markup Based On',0),(65701,1826,'is','',0),(65702,1826,'dr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ Ø®Ø§Ø±Ø¬ÙŠ',0),(65703,1826,'pr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ Ø®Ø§Ø±Ø¬ÙŠ',0),(65704,1826,'tr','DÄ±ÅŸ alÄ±mlarda % biÃ§imlendirme',0),(65705,1826,'pl','Skomentuj % w przypadku zakupÃ³w poza',0),(65706,1826,'bg','ÐœÐ°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ % Ð·Ð° Ð²ÑŠÐ½ÑˆÐ½Ð¸ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(65707,1826,'ur','Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­ % Ø¨Ø§ÛØ± Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ù„Ø¦Û’',0),(65708,1826,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ % Ð·Ð° Ð¸Ð·Ð²Ð°Ð½ Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(65709,1826,'vi','% GiÃ¡ cá»™ng thÃªm cho mua ngoÃ i',0),(65710,1826,'af','Markup % vir buite aankope',0),(65711,1826,'ro','Marcare % pentru achiziÅ£iile de exterior',0),(65712,1826,'et','Lisakulude % vÃ¤ljaspool ostmiseks',0),(65713,1826,'si','Markup % za nakupe zunaj',0),(65714,1826,'ba','Markup % untuk pembelian di luar',0),(65715,1826,'nl','Markup % voor buiten aankopen',0),(65716,1826,'fi','LisÃ¤ys-% ulkopuolella ostoksia',0),(65717,1826,'no','Markering % for utenfor kjÃ¸p',0),(65718,1826,'da','Markup % for uden for kÃ¸b',0),(65719,1826,'ko','ì™¸ë¶€ êµ¬ë§¤ì— ëŒ€ í•œ íƒœê·¸ %',0),(65720,1826,'he','×¡×™×ž×•×Ÿ % ×¢×‘×•×¨ ×¨×›×™×©×•×ª ×ž×‘×—×•×¥',0),(65721,1826,'el','% Î ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ ÎºÎ­ÏÎ´Î¿Ï…Ï‚ Î³Î¹Î± ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÎ­Ï‚ Î±Î³Î¿ÏÎ­Ï‚',0),(65722,1826,'zh','æ ‡è®°ï¼…çš„å¤–éƒ¨é‡‡è´­\r\n',0),(65723,1826,'sv','Markup % fÃ¶r utanfÃ¶r inkÃ¶p',0),(65724,1826,'it','Markup % per acquisti di fuori',0),(65725,1826,'tl','',0),(65726,1826,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3',0),(65727,1826,'hi','à¤¬à¤¾à¤¹à¤° à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤°à¥à¤•à¤…à¤ª %',0),(65728,1826,'ms','Penanda % bagi pembelian di luar',0),(65729,1826,'ar','ØªÙˆØµÙŠÙ % Ù„Ù„Ù…Ø´ØªØ±ÙŠØ§Øª Ø§Ù„Ø®Ø§Ø±Ø¬ÙŠØ©',0),(65730,1826,'fr','Balisage % pour les achats externes',0),(65731,1826,'jp','å¤–éƒ¨è³¼å…¥ã?®ã?Ÿã‚?ã?®å€¤ä¸Šã?’çŽ‡',0),(65732,1826,'pt','% De marcaÃ§Ã£o para compras do exteriores',0),(65733,1826,'ru','% Ð Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸ Ð´Ð»Ñ Ð²Ð½ÐµÑˆÐ½Ð¸Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(65734,1826,'es','Encarecimiento 5 para Compras Exteriores',0),(65735,1826,'de','Markup % fÃ¼r auÃŸen-EinkÃ¤ufe',0),(65736,1826,'en','Markup % for Outside Purchases',0),(65737,1827,'is','',0),(65738,1827,'dr','Ø¯Ø±ØµØ¯  Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(65739,1827,'pr','Ø¯Ø±ØµØ¯  Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(65740,1827,'tr','BiÃ§imlendirme %',0),(65741,1827,'pl','Skomentuj %',0),(65742,1827,'bg','ÐœÐ°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ %',0),(65743,1827,'ur','Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­ %',0),(65744,1827,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ %',0),(65745,1827,'vi','% GiÃ¡ cá»™ng thÃªm',0),(65746,1827,'af','Markup %',0),(65747,1827,'ro','Marcare %',0),(65748,1827,'et','Lisakulude %',0),(65749,1827,'si','Markup %',0),(65750,1827,'ba','Markup %',0),(65751,1827,'nl','Markup %',0),(65752,1827,'fi','LisÃ¤ys %',0),(65753,1827,'no','Markering %',0),(65754,1827,'da','Markup %',0),(65755,1827,'ko','íƒœê·¸ %',0),(65756,1827,'he','×¡×™×ž×•×Ÿ %',0),(65757,1827,'el','% Î ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ ÎºÎ­ÏÎ´Î¿Ï…Ï‚',0),(65758,1827,'zh','æ ‡è®°ï¼…\r\n',0),(65759,1827,'sv','Markup %',0),(65760,1827,'it','Markup %',0),(65761,1827,'tl','',0),(65762,1827,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;',0),(65763,1827,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª %',0),(65764,1827,'ms','Penanda %',0),(65765,1827,'ar','Ø§Ù„Ø²ÙŠØ§Ø¯Ø© %',0),(65766,1827,'fr','Balisage %',0),(65767,1827,'jp','å€¤ä¸Šã?’çŽ‡',0),(65768,1827,'pt','% De marcaÃ§Ã£o',0),(65769,1827,'ru','Ð Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸ %',0),(65770,1827,'es','Encarecimiento %',0),(65771,1827,'de','Markup %',0),(65772,1827,'en','Markup %',0),(65773,1828,'is','',0),(65774,1828,'dr','(Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(65775,1828,'pr','ØªÙ†Ø¸ÙŠÙ… (Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(65776,1828,'tr','BiÃ§imlendirme kÃ¼mesi',0),(65777,1828,'pl','Zestaw znacznikÃ³w',0),(65778,1828,'bg','ÐšÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸ Ð½Ð°Ð±Ð¾Ñ€',0),(65779,1828,'ur','Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹',0),(65780,1828,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ Ð¡ÐµÑ‚',0),(65781,1828,'vi','Bá»™ GiÃ¡ cá»™ng thÃªm',0),(65782,1828,'af','Markup stel',0),(65783,1828,'ro','Set de marcare',0),(65784,1828,'et','MÃ¤rgistuse komplekt',0),(65785,1828,'si','Komplet oznaÄevalnih',0),(65786,1828,'ba','Markup Set',0),(65787,1828,'nl','Markup Set',0),(65788,1828,'fi','Markup Set',0),(65789,1828,'no','Markering sett',0),(65790,1828,'da','Markup sÃ¦t',0),(65791,1828,'ko','íƒœê·¸ ì„¤ì •',0),(65792,1828,'he','×¢×¨×›×ª ×¡×™×ž×•×Ÿ',0),(65793,1828,'el','Î£ÏÎ½Î¿Î»Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(65794,1828,'zh','æ ‡è®°é›†\r\n',0),(65795,1828,'sv','Markup Set',0),(65796,1828,'it','Set di markup',0),(65797,1828,'tl','',0),(65798,1828,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(65799,1828,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ',0),(65800,1828,'ms','Set penanda',0),(65801,1828,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª',0),(65802,1828,'fr','Jeu d\'annotations',0),(65803,1828,'jp','å€¤ä¸Šã?’è¨­å®š',0),(65804,1828,'pt','Conjunto de marcaÃ§Ã£o',0),(65805,1828,'ru','ÐÐ°Ð±Ð¾Ñ€ Ð´Ð»Ñ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(65806,1828,'es','Juego de Encarecimiento',0),(65807,1828,'de','Markup-Set',0),(65808,1828,'en','Markup Set',0),(65809,1829,'is','',0),(65810,1829,'dr','(Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø­Ø°Ù Ø´Ø¯ ',0),(65811,1829,'pr','ØªÙ†Ø¸ÙŠÙ… (Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø­Ø°Ù Ø´Ø¯ ',0),(65812,1829,'tr','Silinen ayarla biÃ§imlendirme',0),(65813,1829,'pl','Znaczniki usuniÄ™te',0),(65814,1829,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð·Ð° Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(65815,1829,'ur','Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­ Ø­Ø°Ù Ø´Ø¯Û Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(65816,1829,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(65817,1829,'vi','XÃ³a Bá»™ GiÃ¡ cá»™ng thÃªm',0),(65818,1829,'af','Prysverhoging suksesvol geskrap',0),(65819,1829,'ro','Marcare Set deleted',0),(65820,1829,'et','MÃ¤rgistus seada kustutatud',0),(65821,1829,'si','Markup, nastavite izbrisanih',0),(65822,1829,'ba','Markup Set dihapus',0),(65823,1829,'nl','Markup verwijderde instellen',0),(65824,1829,'fi','Markup asettaa poistetut',0),(65825,1829,'no','Markering satt slettet',0),(65826,1829,'da','Markup indstille slettede',0),(65827,1829,'ko','íƒœê·¸ ì‚­ì œ ì„¤ì •',0),(65828,1829,'he','×¡×™×ž×•×Ÿ ×”×’×“×¨ ×©× ×ž×—×§×•',0),(65829,1829,'el','Î£Î®Î¼Î±Î½ÏƒÎ·Ï‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†ÎµÏ„Î±Î¹',0),(65830,1829,'zh','æ ‡è®°é›†å·²åˆ é™¤\r\n',0),(65831,1829,'sv','Markeringar som utgÃ¥r',0),(65832,1829,'it','Markup impostare eliminati',0),(65833,1829,'tl','',0),(65834,1829,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(65835,1829,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤¸à¥‡à¤Ÿ à¤®à¤¾à¤°à¥à¤•à¤…à¤ª',0),(65836,1829,'ms','Penanda yang menetapkan dihapuskan',0),(65837,1829,'ar','Ø¹Ù„Ø§Ù…Ø§Øª ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…Ø­Ø°ÙˆÙ',0),(65838,1829,'fr','Jeu supprimÃ©es d\'annotations',0),(65839,1829,'jp','å€¤ä¸Šã?’è¨­å®šã?®æ¶ˆåŽ»',0),(65840,1829,'pt','MarcaÃ§Ã£o definida excluÃ­da',0),(65841,1829,'ru','Ð Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸, ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ',0),(65842,1829,'es','Juego de Encarecimiento eliminado',0),(65843,1829,'de','Markup festlegen gelÃ¶schte',0),(65844,1829,'en','Markup Set deleted',0),(65845,1830,'is','',0),(65846,1830,'dr','(Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(65847,1830,'pr','ØªÙ†Ø¸ÙŠÙ… (Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(65848,1830,'tr','BiÃ§imlendirme baÅŸarÄ±yla silinen ayarlayÄ±n.',0),(65849,1830,'pl','Zestaw usuniÄ™te pomyÅ›lnie znacznikÃ³w.',0),(65850,1830,'bg','ÐšÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸, Ð·Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(65851,1830,'ur','Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­ Ø­Ø°Ù Ø´Ø¯Û Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø³ÛŒÙ¹ ÛÛ’ Û”',0),(65852,1830,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(65853,1830,'vi','XÃ³a Bá»™ GiÃ¡ cá»™ng thÃªm thÃ nh cÃ´ng',0),(65854,1830,'af','Prysverhogingstel suksesvol geskrap.',0),(65855,1830,'ro','Marcare Set ÅŸters cu succes.',0),(65856,1830,'et','MÃ¤rgistus seada edukalt kustutatud.',0),(65857,1830,'si','Markup nastavljena uspeÅ¡no izbrisana.',0),(65858,1830,'ba','Markup menetapkan berhasil dihapus.',0),(65859,1830,'nl','Markup instellen met succes verwijderd.',0),(65860,1830,'fi','Markup asetettu poistetaan.',0),(65861,1830,'no','Markering angitt slettet.',0),(65862,1830,'da','Markup indstille slettet med succes.',0),(65863,1830,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ëœ ì„¤ì • í•˜ëŠ” íƒœê·¸ìž…ë‹ˆë‹¤.',0),(65864,1830,'he','×¡×™×ž×•×Ÿ ×”×’×“×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(65865,1830,'el','Î£Î®Î¼Î±Î½ÏƒÎ· Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(65866,1830,'zh','æ ‡è®°é›†å·²æˆåŠŸåˆ é™¤',0),(65867,1830,'sv','Markering ange borttagna framgÃ¥ngsrikt.',0),(65868,1830,'it','Markup Set eliminato con successo.',0),(65869,1830,'tl','',0),(65870,1830,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(65871,1830,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤ˆ à¤—à¤ˆ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚à¥¤',0),(65872,1830,'ms','Penanda yang ditetapkan berjaya dihapuskan.',0),(65873,1830,'ar','Ø¹Ù„Ø§Ù…Ø§Øª ØªØ¹ÙŠÙŠÙ† Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(65874,1830,'fr','Balisage mis supprimÃ© avec succÃ¨s.',0),(65875,1830,'jp','å€¤ä¸Šã?’è¨­å®šã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(65876,1830,'pt','MarcaÃ§Ã£o definida excluÃ­da com sucesso.',0),(65877,1830,'ru','Ð Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸, ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(65878,1830,'es','Juego de Encarecimiento eliminado exitosamente',0),(65879,1830,'de','Markup erfolgreich gelÃ¶schte festgelegt.',0),(65880,1830,'en','Markup Set deleted successfully.',0),(65881,1831,'is','',0),(65882,1831,'dr','(Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(65883,1831,'pr','Ø´Ø±Ø­ ØªÙ†Ø¸ÙŠÙ… (Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(65884,1831,'tr','BiÃ§imlendirme kÃ¼mesi aÃ§Ä±klamasÄ±',0),(65885,1831,'pl','Opis zestawu znacznikÃ³w',0),(65886,1831,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð½Ð°Ð±Ð¾Ñ€ Ð¾Ñ‚ Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(65887,1831,'ur','Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ ØªØµØ±ÛŒØ­',0),(65888,1831,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸ Ð¾Ð¿Ð¸Ñ',0),(65889,1831,'vi','MÃ´ táº£ cá»™ng thÃªm',0),(65890,1831,'af','Markup stel Beskrywing',0),(65891,1831,'ro','Descriere Set de marcare',0),(65892,1831,'et','MÃ¤rgistuse kirjeldust',0),(65893,1831,'si','Opisa nabora oznak',0),(65894,1831,'ba','Deskripsi Set markup',0),(65895,1831,'nl','Markup instellen beschrijving',0),(65896,1831,'fi','Markup kuvaus',0),(65897,1831,'no','Markering angi beskrivelse',0),(65898,1831,'da','Markup sÃ¦t beskrivelse',0),(65899,1831,'ko','íƒœê·¸ ì„¤ì •ëœ ì„¤ëª…',0),(65900,1831,'he','×ª×™××•×¨ ×¢×¨×›×ª ×™×™×§×•×¨',0),(65901,1831,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(65902,1831,'zh','æ ‡è®°é›†çš„è¯´æ˜Ž\r\n',0),(65903,1831,'sv','Markup ange Beskrivning',0),(65904,1831,'it','Descrizione di insiemi di markup',0),(65905,1831,'tl','',0),(65906,1831,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(65907,1831,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤µà¤¿à¤µà¤°à¤£',0),(65908,1831,'ms','Perihalan Set penanda',0),(65909,1831,'ar','ÙˆØµÙ Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª',0),(65910,1831,'fr','Description Set de balisage',0),(65911,1831,'jp','å€¤ä¸Šã?’è¨­å®šã?®è§£èª¬',0),(65912,1831,'pt','DescriÃ§Ã£o de conjunto de marcaÃ§Ã£o',0),(65913,1831,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð°Ð±Ð¾Ñ€Ð° Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(65914,1831,'es','Juego de Encarecimiento DescripciÃ³n',0),(65915,1831,'de','Markup Beschreibung',0),(65916,1831,'en','Markup Set Description',0),(65917,1832,'is','',0),(65918,1832,'dr','(Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(65919,1832,'pr','ØªÙ†Ø¸ÙŠÙ… (Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(65920,1832,'tr','BiÃ§imlendirme kÃ¼me dÃ¼zey baÅŸarÄ±yla eklendi.',0),(65921,1832,'pl','Zestaw znacznikÃ³w do poziomu dodano pomyÅ›lnie.',0),(65922,1832,'bg','ÐšÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚ Ð·Ð° Ð½Ð¸Ð²Ð¾ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(65923,1832,'ur','Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒ Ø³Ø·Ø­ Ú©Û’ Ù„Ø¦Û’ Û”',0),(65924,1832,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ Ð¡ÐµÑ‚ Ð·Ð° Ð½Ð¸Ð²Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(65925,1832,'vi','ThÃªm Bá»™ GiÃ¡ cá»™ng thÃªm theo cáº¥p báº­c thÃ nh cÃ´ng',0),(65926,1832,'af','Prysverhogingstel vir Vlak, suksesvol bygevoeg.',0),(65927,1832,'ro','Set de marcaj pentru nivel adÄƒugat cu succes.',0),(65928,1832,'et','MÃ¤rgistuse komplekti lisatud tase.',0),(65929,1832,'si','Markup Set za ravni uspeÅ¡no dodana.',0),(65930,1832,'ba','Markup Set untuk tingkat berhasil ditambahkan.',0),(65931,1832,'nl','Markup Set voor niveau toegevoegd.',0),(65932,1832,'fi','Markup asettaa tason lisÃ¤Ã¤minen onnistui.',0),(65933,1832,'no','Markering sett for nivÃ¥ lagt.',0),(65934,1832,'da','Markup sÃ¦t for niveau tilfÃ¸jet.',0),(65935,1832,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ìˆ˜ì¤€ì— ëŒ€ í•œ íƒœê·¸ ì„¤ì •ìž…ë‹ˆë‹¤.',0),(65936,1832,'he','×¢×¨×›×ª ×¡×™×ž×•×Ÿ ×¢×‘×•×¨ ×¨×ž×ª × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(65937,1832,'el','Î£ÏÎ½Î¿Î»Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ Î³Î¹Î± ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(65938,1832,'zh','çº§åˆ«æ ‡è®°é›†æ·»åŠ æˆåŠŸã€‚\r\n',0),(65939,1832,'sv','Markup Set fÃ¶r nivÃ¥ lagts.',0),(65940,1832,'it','Set di markup per livello aggiunto con successo.',0),(65941,1832,'tl','',0),(65942,1832,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3619;&#3632;&#3604;&#3633;&#3610;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(65943,1832,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤¸à¥à¤¤à¤° à¤¸à¥‡à¤Ÿà¥¤',0),(65944,1832,'ms','Set penanda aras yang berjaya menambah.',0),(65945,1832,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¹Ù„Ø§Ù…Ø§Øª Ù„Ù…Ø³ØªÙˆÙ‰ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(65946,1832,'fr','Jeu d\'annotations pour niveau ajoutÃ© avec succÃ¨s.',0),(65947,1832,'jp','ã??ã?®ãƒ¬ãƒ™ãƒ«ã?®å€¤ä¸Šã?’è¨­å®šã‚’è¿½åŠ ã?—ã?¾ã?—ã?Ÿ',0),(65948,1832,'pt','Conjunto de marcaÃ§Ã£o para nÃ­vel adicionado com Ãªxito.',0),(65949,1832,'ru','ÐÐ°Ð±Ð¾Ñ€ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸ Ð´Ð»Ñ ÑƒÑ€Ð¾Ð²Ð½Ñ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(65950,1832,'es','Juego de Encarecimiento para Nivel agregado exitosamente',0),(65951,1832,'de','Markup-Set fÃ¼r Ebene erfolgreich hinzugefÃ¼gt.',0),(65952,1832,'en','Markup Set for Level added successfully.',0),(65953,1833,'is','',0),(65954,1833,'dr','(Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(65955,1833,'pr','ØªÙ†Ø¸ÙŠÙ… (Ù…Ø¬Ù…ÙˆØ¹Ù‡) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø­ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(65956,1833,'tr','DÃ¼zey iÃ§in biÃ§imlendirme kÃ¼mesi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(65957,1833,'pl','Zestaw znacznikÃ³w do poziomu pomyÅ›lnie zaktualizowana.',0),(65958,1833,'bg','ÐšÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚ Ð·Ð° Ð½Ð¸Ð²Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(65959,1833,'ur','Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ø³Ø·Ø­ Ú©Û’ Ù„Ø¦Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Û”',0),(65960,1833,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ Ð¡ÐµÑ‚ Ð·Ð° Ð½Ð¸Ð²Ð¾ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(65961,1833,'vi','Cáº­p Nháº­t Má»©c Cá»™ng ThÃªm Theo Tá»«ng Cáº¥p ThÃ nh CÃ´ng',0),(65962,1833,'af','Prysverhogingstel vir Vlak, suksesvol opdateer.',0),(65963,1833,'ro','Set de marcaj pentru nivel actualizat cu succes.',0),(65964,1833,'et','MÃ¤rgistuse komplekt taseme vÃ¤rskendamine Ãµnnestus.',0),(65965,1833,'si','Markup Set za ravni uspeÅ¡no posodobljen.',0),(65966,1833,'ba','Markup Set untuk tingkat perbaharui berhasil.',0),(65967,1833,'nl','Markup Set voor niveau succesvol bijgewerkt.',0),(65968,1833,'fi','Markup mÃ¤Ã¤rÃ¤tyn tason pÃ¤ivitys onnistui.',0),(65969,1833,'no','Markering sett for nivÃ¥et er oppdatert.',0),(65970,1833,'da','Markup sÃ¦t for niveau opdateret.',0),(65971,1833,'ko','ìˆ˜ì¤€ì— ëŒ€ í•œ íƒœê·¸ ì„¸íŠ¸ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(65972,1833,'he','×¢×¨×›×ª ×¡×™×ž×•×Ÿ ×¢×‘×•×¨ ×¨×ž×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(65973,1833,'el','Î£ÏÎ½Î¿Î»Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ Î³Î¹Î± ÎµÏ€Î¯Ï€ÎµÎ´Î¿ ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(65974,1833,'zh','çº§åˆ«æ ‡è®°é›†æ›´æ–°æˆåŠŸã€‚\r\n',0),(65975,1833,'sv','Markup Set fÃ¶r nivÃ¥ har uppdaterats.',0),(65976,1833,'it','Set di markup per livello aggiornato con successo.',0),(65977,1833,'tl','',0),(65978,1833,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3619;&#3632;&#3604;&#3633;&#3610;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(65979,1833,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤•à¥‡ à¤¸à¥à¤¤à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(65980,1833,'ms','Set penanda aras berjaya dikemas kini.',0),(65981,1833,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ù„Ù„Ù…Ø³ØªÙˆÙ‰ Ø¨Ù†Ø¬Ø§Ø­.',0),(65982,1833,'fr','Jeu d\'annotations pour niveau mis Ã  jour avec succÃ¨s.',0),(65983,1833,'jp','ã??ã?®ãƒ¬ãƒ™ãƒ«ã?®å€¤ä¸Šã?’è¨­å®šã‚’æ›´æ–°ã?—ã?¾ã?—ã?Ÿ',0),(65984,1833,'pt','Conjunto de marcaÃ§Ã£o para nÃ­vel atualizado com Ãªxito.',0),(65985,1833,'ru','ÐÐ°Ð±Ð¾Ñ€ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸ Ð´Ð»Ñ ÑƒÑ€Ð¾Ð²Ð½Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(65986,1833,'es','Juego de Encarecimiento para nivel actualizado exitosamente',0),(65987,1833,'de','Markup-Set fÃ¼r Ebene aktualisiert erfolgreich.',0),(65988,1833,'en','Markup Set for Level updated successfully.',0),(65989,1834,'is','',0),(65990,1834,'dr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø§Øµ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(65991,1834,'pr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø§Øµ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(65992,1834,'tr','Ã–zel sipariÅŸ Stok iÅŸaretleme %',0),(65993,1834,'pl','% ZnacznikÃ³w na specjalne zamÃ³wienie czas',0),(65994,1834,'bg','ÐœÐ°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ % Ð·Ð° ÑÐ¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑÑŠÑÑ‚Ð°Ð²',0),(65995,1834,'ur','Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­ % Ø®ØµÙˆØµÛŒ Ø­Ú©Ù… Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ù„Ø¦Û’',0),(65996,1834,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ % Ð·Ð° Ð¿Ð¾ÑÐµÐ±Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(65997,1834,'vi','% cÃ´ng thÃªm cho máº·t hÃ ng Ä‘áº·c biá»‡t',0),(65998,1834,'af','Markup % vir spesiale bestelling voorraad',0),(65999,1834,'ro','Marcare % pentru comanda speciala de stoc',0),(66000,1834,'et','Lisakulude % eritellimisel aktsia',0),(66001,1834,'si','Markup % za posebno naroÄilo zaloge',0),(66002,1834,'ba','Markup % saham pesanan khusus',0),(66003,1834,'nl','Markup % voor speciale bestelling voorraad',0),(66004,1834,'fi','Erityinen tilauskanta lisÃ¤ys %',0),(66005,1834,'no','Markering % spesialbestilling aksje',0),(66006,1834,'da','Markup % for specialordre lager',0),(66007,1834,'ko','íŠ¹ë³„ ì£¼ë¬¸ ìž¬ê³ ì— ëŒ€ í•œ íƒœê·¸ %',0),(66008,1834,'he','×¡×™×ž×•×Ÿ % ×¢×‘×•×¨ ×ž× ×™×” ×‘×”×–×ž× ×” ×ž×™×•×—×“×ª',0),(66009,1834,'el','% Î ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ ÎºÎ­ÏÎ´Î¿Ï…Ï‚ Î³Î¹Î± ÎµÎ¹Î´Î¹ÎºÎ® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(66010,1834,'zh','ç‰¹åˆ«è®¢å•åº“å­˜çš„æ ‡è®°ï¼…\r\n',0),(66011,1834,'sv','Markup % fÃ¶r specialorder lager',0),(66012,1834,'it','Markup % per Stock di ordine speciale',0),(66013,1834,'tl','',0),(66014,1834,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3605;&#3655;&#3629;&#3',0),(66015,1834,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤¶à¥‡à¤¯à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤°à¥à¤•à¤…à¤ª %',0),(66016,1834,'ms','Penanda % untuk stok tempahan khas',0),(66017,1834,'ar','ØªÙˆØµÙŠÙ % Ù„Ù„Ø£Ø³Ù‡Ù… Ø£Ù…Ø± Ø®Ø§Øµ',0),(66018,1834,'fr','Balisage % pour commande spÃ©ciale Stock',0),(66019,1834,'jp','ç‰¹åˆ¥æ³¨æ–‡åœ¨åº«ç”¨ã?®å€¤ä¸Šã?’çŽ‡',0),(66020,1834,'pt','% De marcaÃ§Ã£o para o estoque de ordem especial',0),(66021,1834,'ru','% Ð Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸ Ð´Ð»Ñ ÑÐ¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹',0),(66022,1834,'es','Encarecimiento % para Stock de Ordenes Especiales',0),(66023,1834,'de','Markup % fÃ¼r spezielle Kundenauftragsbestand',0),(66024,1834,'en','Markup % for Special Order Stock',0),(66025,1835,'is','',0),(66026,1835,'dr','(Ù…Ø´ØªØ±Ùƒ',0),(66027,1835,'pr','Ù…ØªØ§Ù‡Ù„ â€“ Ø¯Ùˆ Ø·Ø±ÙÙ‡ (Ù…Ø´ØªØ±Ùƒ',0),(66028,1835,'tr','Evli - ortak',0),(66029,1835,'pl','Å»onaty - wspÃ³lne',0),(66030,1835,'bg','Ð–ÐµÐ½ÐµÐ½ - ÑÑŠÐ²Ð¼ÐµÑÑ‚Ð½Ð¸',0),(66031,1835,'ur','Ø´Ø§Ø¯ÛŒ - Ù…Ø´ØªØ±Ú©Û',0),(66032,1835,'sr','ÐžÐ¶ÐµÑšÐµÐ½ - ÐˆÐ¾Ð¸Ð½Ñ‚',0),(66033,1835,'vi','Káº¿t hÃ´n - Chung',0),(66034,1835,'af','Getroud - Saamwoon',0),(66035,1835,'ro','CÄƒsÄƒtorit - Joint',0),(66036,1835,'et','Abielus - Ã¼hine',0),(66037,1835,'si','PoroÄena - skupno',0),(66038,1835,'ba','Menikah - Joint',0),(66039,1835,'nl','Getrouwd - Joint',0),(66040,1835,'fi','Naimisissa - yhteinen',0),(66041,1835,'no','Gift - felles',0),(66042,1835,'da','Gift - fÃ¦lles',0),(66043,1835,'ko','ê²°í˜¼-ì¡°ì¸íŠ¸',0),(66044,1835,'he','× ×©×•×™ - ×’\'×•×™× ×˜',0),(66045,1835,'el','Î Î±Î½Ï„ÏÎµÎ¼Î­Î½Î¿Ï‚ - ÎºÎ¿Î¹Î½Î®',0),(66046,1835,'zh','ç»“å©š- è”åˆ\r\n',0),(66047,1835,'sv','Gift - gemensamma',0),(66048,1835,'it','Sposato - Joint',0),(66049,1835,'tl','',0),(66050,1835,'th','&#3649;&#3605;&#3656;&#3591;&#3591;&#3634;&#3609;&#3649;&#3621;&#3657;&#3623; - &#3629;&#3618;&#3641;&#3656;&#3604;&#3657;&#3623;&#3618;&#3585;&#3633;&#3609;\n',0),(66051,1835,'hi','à¤µà¤¿à¤µà¤¾à¤¹à¤¿à¤¤ - à¤¸à¤‚à¤¯à¥à¤•à¥ à¤¤',0),(66052,1835,'ms','Berkahwin - bersama',0),(66053,1835,'ar','Ù…ØªØ²ÙˆØ¬-Ù…Ø´ØªØ±Ùƒ',0),(66054,1835,'fr','MariÃ© - Joint',0),(66055,1835,'jp','æ—¢å©šãƒ¼å…±æœ‰',0),(66056,1835,'pt','Casado - Joint',0),(66057,1835,'ru','Ð–ÐµÐ½Ð°Ñ‚ - ÑÐ¾Ð²Ð¼ÐµÑÑ‚Ð½Ð¾Ðµ',0),(66058,1835,'es','Casado - Junto',0),(66059,1835,'de','Verheiratet - Joint',0),(66060,1835,'en','Married - Joint',0),(66061,1836,'is','',0),(66062,1836,'dr','Ù…ØªØ§Ù‡Ù„ â€“ Ù…Ø¬Ø²Ø§ ',0),(66063,1836,'pr','Ù…ØªØ§Ù‡Ù„ â€“ Ù…Ø¬Ø²Ø§ ',0),(66064,1836,'tr','Evli - ayÄ±rmak',0),(66065,1836,'pl','Å»ona - oddzielne',0),(66066,1836,'bg','Ð–ÐµÐ½Ð¸ - Ð¾Ñ‚Ð´ÐµÐ»Ð½Ð¸',0),(66067,1836,'ur','Ø§Ù„Ú¯ Ø³Û’ Ø´Ø§Ø¯ÛŒ Ú©ÛŒ-',0),(66068,1836,'sr','Ð£ Ð±Ñ€Ð°ÐºÑƒ - Ñ€Ð°Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ',0),(66069,1836,'vi','Káº¿t hÃ´n - RiÃªng',0),(66070,1836,'af','Getroud - Geskei',0),(66071,1836,'ro','CÄƒsÄƒtorit - separat',0),(66072,1836,'et','Abielus - eraldi',0),(66073,1836,'si','PoroÄena - loÄeno',0),(66074,1836,'ba','Menikah - terpisah',0),(66075,1836,'nl','Getrouwd - scheiden',0),(66076,1836,'fi','Naimisissa - erillinen',0),(66077,1836,'no','Gift - skille',0),(66078,1836,'da','Gift - adskille',0),(66079,1836,'ko','ë³„ë„ ê²°í˜¼-',0),(66080,1836,'he','× ×©×•×™ - ×œ×”×¤×¨×™×“',0),(66081,1836,'el','Î Î±Î½Ï„ÏÎµÎ¼Î­Î½Î¿Ï‚ - Ï‡Ï‰ÏÎ¹ÏƒÏ„Î®',0),(66082,1836,'zh','å·²å©š- ç‹¬ç«‹\r\n',0),(66083,1836,'sv','Gift - separat',0),(66084,1836,'it','Sposato - separare',0),(66085,1836,'tl','',0),(66086,1836,'th','&#3649;&#3605;&#3656;&#3591;&#3591;&#3634;&#3609;&#3649;&#3621;&#3657;&#3623; - &#3649;&#3618;&#3585;&#3585;&#3633;&#3609;&#3629;&#3618;&#3641;&#3656;',0),(66087,1836,'hi','à¤¶à¤¾à¤¦à¥€ - à¤•à¥‹ à¤…à¤²à¤—',0),(66088,1836,'ms','Berkahwin - berasingan',0),(66089,1836,'ar','Ù…ØªØ²ÙˆØ¬--ÙØµÙ„',0),(66090,1836,'fr','MariÃ© - sÃ©parer',0),(66091,1836,'jp','æ—¢å©šãƒ¼åˆ†é›¢',0),(66092,1836,'pt','Casado - separar',0),(66093,1836,'ru','Ð—Ð°Ð¼ÑƒÐ¶ - Ð¾Ñ‚Ð´ÐµÐ»ÑŒÐ½Ñ‹Ðµ',0),(66094,1836,'es','Casado - Separado',0),(66095,1836,'de','Verheiratet - getrennt',0),(66096,1836,'en','Married - Separate',0),(66097,1837,'is','',0),(66098,1837,'dr','Ø§ØµÙ„ÙŠ',0),(66099,1837,'pr','Ø§ØµÙ„ÙŠ',0),(66100,1837,'tr','Master',0),(66101,1837,'pl','Master',0),(66102,1837,'bg','ÐœÐ°Ð¹ÑÑ‚Ð¾Ñ€',0),(66103,1837,'ur','Ù…Ø§Ø³Ù¹Ø±',0),(66104,1837,'sr','Ð“Ð¾ÑÐ¿Ð¾Ð´Ð°Ñ€',0),(66105,1837,'vi','Chá»§',0),(66106,1837,'af','Meester',0),(66107,1837,'ro','Master',0),(66108,1837,'et','Kapten',0),(66109,1837,'si','Mojster',0),(66110,1837,'ba','Master',0),(66111,1837,'nl','Master',0),(66112,1837,'fi','Master',0),(66113,1837,'no','Master',0),(66114,1837,'da','Master',0),(66115,1837,'ko','ë§ˆìŠ¤í„°',0),(66116,1837,'he','×ž××¡×˜×¨',0),(66117,1837,'el','Master',0),(66118,1837,'zh','æŽŒæ¡\r\n',0),(66119,1837,'sv','Master',0),(66120,1837,'it','Master',0),(66121,1837,'tl','',0),(66122,1837,'th','&#3627;&#3621;&#3633;&#3585;',0),(66123,1837,'hi','à¤®à¤¾à¤¸à¥à¤Ÿà¤°',0),(66124,1837,'ms','Sarjana',0),(66125,1837,'ar','Ù…Ø§Ø¬Ø³ØªÙŠØ±',0),(66126,1837,'fr','Master',0),(66127,1837,'jp','ãƒžã‚¹ã‚¿ãƒ¼',0),(66128,1837,'pt','Mestre',0),(66129,1837,'ru','ÐœÐ°ÑÑ‚ÐµÑ€',0),(66130,1837,'es','Maestro',0),(66131,1837,'de','Master',0),(66132,1837,'en','Master',0),(66133,1838,'is','',0),(66134,1838,'dr','ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(66135,1838,'pr','ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(66136,1838,'tr','Ana Ã¶ÄŸe',0),(66137,1838,'pl','GÅ‚Ã³wny element',0),(66138,1838,'bg','ÐœÐ°Ð³Ð¸ÑÑ‚ÑŠÑ€ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(66139,1838,'ur','Ù…Ø§Ø³Ù¹Ø± Ø´Û’',0),(66140,1838,'sr','ÐœÐ°ÑÑ‚ÐµÑ€ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(66141,1838,'vi','HÃ ng chá»§',0),(66142,1838,'af','Meester Item',0),(66143,1838,'ro','Element de Master',0),(66144,1838,'et','Kapten kaup',0),(66145,1838,'si','Glavni element',0),(66146,1838,'ba','Master Item',0),(66147,1838,'nl','Hoofditem',0),(66148,1838,'fi','Master kohde',0),(66149,1838,'no','Overordnet element',0),(66150,1838,'da','Master vare',0),(66151,1838,'ko','ë§ˆìŠ¤í„° í•­ëª©',0),(66152,1838,'he','×¤×¨×™×˜ ×ž××¡×˜×¨',0),(66153,1838,'el','ÎšÏÏÎ¹Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(66154,1838,'zh','æŽŒæ¡å®¢æˆ·\r\n',0),(66155,1838,'sv','Master objekt',0),(66156,1838,'it','Voce del padrone',0),(66157,1838,'tl','',0),(66158,1838,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3621;&#3633;&#3585;',0),(66159,1838,'hi','à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤†à¤‡à¤Ÿà¤®',0),(66160,1838,'ms','Item induk',0),(66161,1838,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ',0),(66162,1838,'fr','Master point',0),(66163,1838,'jp','ãƒžã‚¹ã‚¿ãƒ¼å“?ç›®',0),(66164,1838,'pt','Item mestre',0),(66165,1838,'ru','Ð“Ð»Ð°Ð²Ð½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(66166,1838,'es','Item Maestro',0),(66167,1838,'de','Stammartikel',0),(66168,1838,'en','Master Item',0),(66169,1839,'is','',0),(66170,1839,'dr','Ù…Ø·Ø§Ø¨Ù‚Øª Ù‡Ø§ Ù¾ÙŠØ¯Ø§ Ø´Ø¯ ',0),(66171,1839,'pr','Ù…Ø·Ø§Ø¨Ù‚Øª Ù‡Ø§ Ù¾ÙŠØ¯Ø§ Ø´Ø¯ ',0),(66172,1839,'tr','eÅŸleÅŸme bulundu',0),(66173,1839,'pl','Liczba znalezionych dopasowaÅ„:',0),(66174,1839,'bg','Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ñ',0),(66175,1839,'ur','Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(66176,1839,'sr','Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð¸Ñ… Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ°',0),(66177,1839,'vi','tÃ¬m tháº¥y dá»¯ liá»‡u phÃ¹ há»£p',0),(66178,1839,'af','gelyksoortige gevind',0),(66179,1839,'ro','meciuri gasit',0),(66180,1839,'et','leitud vasted',0),(66181,1839,'si','najdenih',0),(66182,1839,'ba','ditemukan',0),(66183,1839,'nl','overeenkomsten gevonden',0),(66184,1839,'fi','hakutuloksia',0),(66185,1839,'no','treff',0),(66186,1839,'da','kampe fandt',0),(66187,1839,'ko','ì¼ì¹˜ í•˜ëŠ” ê²°ê³¼',0),(66188,1839,'he','×”×”×ª××ž×•×ª ×©××•×ª×¨×•',0),(66189,1839,'el','Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ¯ÏƒÎºÎ¿Î½Ï„Î±Î¹',0),(66190,1839,'zh','æ‰¾åˆ°åŒ¹é…\r\n',0),(66191,1839,'sv','TRâ”œÃ±ffar hittades',0),(66192,1839,'it','corrispondenze trovate',0),(66193,1839,'tl','',0),(66194,1839,'th','&#3614;&#3610;&#3605;&#3619;&#3591;&#3585;&#3633;&#3609;',0),(66195,1839,'hi','à¤œà¥‹à¤¡à¤¼ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(66196,1839,'ms','padanan ditemui',0),(66197,1839,'ar','ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ø·Ø§Ø¨Ù‚Ø§Øª',0),(66198,1839,'fr','correspondances trouvÃ©es',0),(66199,1839,'jp','ä¸€è‡´ã?™ã‚‹ã‚‚ã?®ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?—ã?Ÿ',0),(66200,1839,'pt','correspondÃªncias encontradas',0),(66201,1839,'ru','ÐÐ°Ð¹Ð´ÐµÐ½Ð¾',0),(66202,1839,'es','Equivalencias se encontrÃ³',0),(66203,1839,'de','Treffer gefunden',0),(66204,1839,'en','matches found',0),(66205,1840,'is','',0),(66206,1840,'dr','Ø¯Ø±ØµØ¯ ØªØ·Ø§Ø¨Ù‚',0),(66207,1840,'pr','Ø¯Ø±ØµØ¯ ØªØ·Ø§Ø¨Ù‚',0),(66208,1840,'tr','EÅŸleÅŸen yÃ¼zdesi',0),(66209,1840,'pl','Dopasowanie procent',0),(66210,1840,'bg','Ð¡ÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(66211,1840,'ur','Ø´Ø±Ø­ ÙÛŒ ØµØ¯ Ø³Û’ Ù…Ø´Ø§Ø¨Û',0),(66212,1840,'sr','ÐžÐ´Ð³Ð¾Ð²Ð°Ñ€Ð°Ñ˜ÑƒÑ›Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚',0),(66213,1840,'vi','% phÃ¹ há»£p',0),(66214,1840,'af','Gelyksoortige persentasie',0),(66215,1840,'ro','Procentul de potrivire',0),(66216,1840,'et','Vastav protsent',0),(66217,1840,'si','Ujemanje odstotek',0),(66218,1840,'ba','Pencocokan persentase',0),(66219,1840,'nl','Overeenkomende percentage',0),(66220,1840,'fi','Vastaavan prosentin',0),(66221,1840,'no','Tilsvarende prosentandel',0),(66222,1840,'da','Tilsvarende procentdel',0),(66223,1840,'ko','ì¼ì¹˜ í•˜ëŠ” ë¹„ìœ¨',0),(66224,1840,'he','×”×ª××ž×ª ××—×•×–',0),(66225,1840,'el','Î‘Î½Ï„Î¯ÏƒÏ„Î¿Î¹Ï‡Î¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(66226,1840,'zh','åŒ¹é…çš„ç™¾åˆ†æ¯”\r\n',0),(66227,1840,'sv','Matchande procentsatsen',0),(66228,1840,'it','Percentuale di corrispondenza',0),(66229,1840,'tl','',0),(66230,1840,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3585;&#3634;&#3619;&#3592;&#3633;&#3610;&#3588;&#3641;&#3656;',0),(66231,1840,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤®à¤¿à¤²à¤¾à¤¨',0),(66232,1840,'ms','Peratusan yang sepadan',0),(66233,1840,'ar','Ù…Ø·Ø§Ø¨Ù‚Ø© Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ©',0),(66234,1840,'fr','Pourcentage correspondant',0),(66235,1840,'jp','ä¸€è‡´ã?—ã?¦ã?„ã‚‹ãƒ‘ãƒ¼ã‚»ãƒ³ãƒ†ãƒ¼ã‚¸',0),(66236,1840,'pt','Percentual correspondente',0),(66237,1840,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¸Ñ',0),(66238,1840,'es','Porcentaje Emparejado',0),(66239,1840,'de','Entsprechenden Prozentsatz',0),(66240,1840,'en','Matching percentage',0),(66241,1841,'is','',0),(66242,1841,'dr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(66243,1841,'pr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(66244,1841,'tr','Malzeme',0),(66245,1841,'pl','MateriaÅ‚',0),(66246,1841,'bg','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»',0),(66247,1841,'ur','Ù…ÙˆØ§Ø¯',0),(66248,1841,'sr','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»',0),(66249,1841,'vi','Váº­t liá»‡u',0),(66250,1841,'af','Materiaal',0),(66251,1841,'ro','Materialul',0),(66252,1841,'et','Materjali',0),(66253,1841,'si','Material',0),(66254,1841,'ba','Bahan',0),(66255,1841,'nl','Materiaal',0),(66256,1841,'fi','Materiaali',0),(66257,1841,'no','Materiale',0),(66258,1841,'da','Materiale',0),(66259,1841,'ko','ìž¬ë£Œ',0),(66260,1841,'he','×—×•×ž×¨',0),(66261,1841,'el','Î¥Î»Î¹ÎºÏŒ',0),(66262,1841,'zh','ææ–™\r\n',0),(66263,1841,'sv','Material',0),(66264,1841,'it','Materiale',0),(66265,1841,'tl','',0),(66266,1841,'th','&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(66267,1841,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€',0),(66268,1841,'ms','Bahan',0),(66269,1841,'ar','Ø§Ù„Ù…ÙˆØ§Ø¯',0),(66270,1841,'fr','MatÃ©riel',0),(66271,1841,'jp','æ??æ–™',0),(66272,1841,'pt','Material',0),(66273,1841,'ru','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»',0),(66274,1841,'es','Material',0),(66275,1841,'de','Material',0),(66276,1841,'en','Material',0),(66277,1842,'is','',0),(66278,1842,'dr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ù…ØµØ±Ù Ø´Ø¯Ù‡ Ù‡Ø± ÙˆÙ‚Øª ÙƒÙ‡',0),(66279,1842,'pr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ù…ØµØ±Ù Ø´Ø¯Ù‡ Ù‡Ø± ÙˆÙ‚Øª ÙƒÙ‡',0),(66280,1842,'tr','NE ZAMAN TÃœKETÄ°LEN MALZEMELER',0),(66281,1842,'pl','MATERIAÅY ZUÅ»YTE W KAÅ»DYM PRZYPADKU, GDY',0),(66282,1842,'bg','ÐœÐÐ¢Ð•Ð Ð˜ÐÐ›Ð˜, Ð˜Ð—ÐŸÐžÐ›Ð—Ð’ÐÐÐ˜ ÐŸÐ Ð˜',0),(66283,1842,'ur','Ø¬Ø¨ Ø¨Ú¾ÛŒ ÙÙ†Ø§ Ù…ÙˆØ§Ø¯',0),(66284,1842,'sr','ÐšÐÐ” Ð“ÐžÐ” Ð£Ð¢Ð ÐžÐ¨Ð•ÐÐ˜Ð¥ ÐœÐÐ¢Ð•Ð Ð˜ÐˆÐÐ›Ð',0),(66285,1842,'vi','Váº¬T LIá»†U TIÃŠU THá»¤ KHI',0),(66286,1842,'af','MATERIAAL VERBRUIK WANNEER',0),(66287,1842,'ro','MATERIALE CONSUMATE ORI DE CÃ‚TE ORI',0),(66288,1842,'et','KUI TARVITATUD MATERJAL',0),(66289,1842,'si','PORABLJENIH KADARKOLI',0),(66290,1842,'ba','BAHAN-BAHAN YANG DIKONSUMSI SETIAP KALI',0),(66291,1842,'nl','MATERIALEN DIE WORDEN VERBRUIKT WANNEER',0),(66292,1842,'fi','KUN AINETTA',0),(66293,1842,'no','MATERIALENE SOM FORBRUKES NÃ…R',0),(66294,1842,'da','MATERIALER, DER FORBRUGES HVER GANG',0),(66295,1842,'ko','ì–¸ì œ ë“  ì§€ ì†Œë¹„ í•˜ëŠ” ìžë£Œ',0),(66296,1842,'he','×•×”×—×•×ž×¨×™× ×”× ×¦×¨×›×™× ×‘×›×œ ×¤×¢×',0),(66297,1842,'el','Î¥Î›Î™ÎšÎ† Î ÎŸÎ¥ ÎˆÎ§ÎŸÎ¥Î ÎšÎ‘Î¤Î‘ÎÎ‘Î›Î©Î˜Î•ÎŠ Î‘Î ÎŒ ÎšÎ†Î˜Î• Î¦ÎŸÎ¡Î† Î ÎŸÎ¥',0),(66298,1842,'zh','æ’æ—¶æ¶ˆè€—çš„ææ–™\r\n',0),(66299,1842,'sv','MATERIAL SOM FÃ–RBRUKATS NÃ„R',0),(66300,1842,'it','MATERIALI CONSUMATI OGNI VOLTA',0),(66301,1842,'tl','',0),(66302,1842,'th','&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3607;&#3637;&#3656;&#3652;&#3627;&#3609;&#3585;&#3655;&#3605;&#3634;&#3617;',0),(66303,1842,'hi','à¤œà¤¬ à¤­à¥€ à¤–à¤ªà¤¤ à¤•à¥€ à¤—à¤ˆ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€',0),(66304,1842,'ms','BAHAN-BAHAN YANG DIMAKAN BILA-BILA MASA',0),(66305,1842,'ar','Ø§Ù„Ù…ÙˆØ§Ø¯ Ø§Ù„Ù…Ø³ØªÙ‡Ù„ÙƒØ© ÙƒÙ„Ù…Ø§',0),(66306,1842,'fr','MATÃ‰RIAUX CONSOMMÃ‰S CHAQUE FOIS QUE',0),(66307,1842,'jp','ã?„ã?¤ã?§ã‚‚æ¶ˆè²»ã?•ã‚Œã‚‹æ??æ–™',0),(66308,1842,'pt','MATERIAIS CONSUMIDOS, SEMPRE QUE',0),(66309,1842,'ru','ÐœÐÐ¢Ð•Ð Ð˜ÐÐ›ÐžÐ’, Ð˜Ð—Ð ÐÐ¡Ð¥ÐžÐ”ÐžÐ’ÐÐÐÐ«Ð¥ ÐŸÐ Ð˜',0),(66310,1842,'es','MATERIALES CONSUMIDOS SIEMPRE QUE ',0),(66311,1842,'de','MATERIALIEN, DIE BEI JEDEM VERBRAUCHT',0),(66312,1842,'en','MATERIALS CONSUMED WHENEVER',0),(66313,1843,'is','',0),(66314,1843,'dr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ù…ØµØ±Ù Ø´Ø¯Ù‡ Ù‡Ø± ÙˆÙ‚Øª ÙƒÙ‡ Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ ',0),(66315,1843,'pr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ù…ØµØ±Ù Ø´Ø¯Ù‡ Ù‡Ø± ÙˆÙ‚Øª ÙƒÙ‡ Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ ',0),(66316,1843,'tr','BU SEÃ‡ENEÄžÄ°N KULLANILACAÄžI ZAMAN TÃœKETÄ°LEN MALZEMELER',0),(66317,1843,'pl','MATERIAÅY ZUÅ»YWANE, GDY TA OPCJA UÅ»YWANA',0),(66318,1843,'bg','ÐœÐÐ¢Ð•Ð Ð˜ÐÐ›Ð˜, Ð˜Ð—Ð ÐÐ—Ð¥ÐžÐ”Ð’ÐÐÐ˜ ÐŸÐ Ð˜ Ð¢ÐÐ—Ð˜ ÐžÐŸÐ¦Ð˜Ð¯ Ð˜Ð—ÐŸÐžÐ›Ð—Ð’Ð',0),(66319,1843,'ur','Ø¬Ø¨ Ø§Ø³ Ø§Ø®ØªÛŒØ§Ø± Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø¨Ú¾ÛŒ ÙÙ†Ø§ Ù…ÙˆØ§Ø¯',0),(66320,1843,'sr','ÐœÐÐ¢Ð•Ð Ð˜ÐˆÐÐ› Ð£Ð¢Ð ÐžÐ¨Ð•Ð Ð¡Ð’ÐÐšÐ˜ ÐŸÐ£Ð¢ ÐšÐÐ”Ð ÐˆÐ• ÐžÐ’Ð ÐžÐŸÐ¦Ð˜ÐˆÐ ÐšÐžÐ Ð˜Ð¡Ð¢Ð˜',0),(66321,1843,'vi','Váº¬T LIá»†U TIÃŠU THá»¤ KHI DÃ™NG Lá»°A CHá»ŒN NÃ€Y',0),(66322,1843,'af','MATERIAAL VERBRUIK WANNEER HIERDIE OPSIE GEBRUIK',0),(66323,1843,'ro','MATERIALE CONSUMATE ORI DE CÃ‚TE ORI ACEASTÄ‚ OPÅ¢IUNE FOLOSIT',0),(66324,1843,'et','KUI SEDA VÃ•IMALUST KASUTATAKSE TARVITATUD MATERJAL',0),(66325,1843,'si','PORABLJENIH KADARKOLI TA MOÅ½NOST UPORABLJA',0),(66326,1843,'ba','BAHAN-BAHAN YANG DIKONSUMSI SETIAP KALI PILIHAN INI DIGUNAKAN',0),(66327,1843,'nl','MATERIALEN DIE WORDEN VERBRUIKT WANNEER DEZE OPTIE GEBRUIKT',0),(66328,1843,'fi','KUN TÃ„MÃ„ VAIHTOEHTO KÃ„YTTÃ„Ã„-AINETTA',0),(66329,1843,'no','MATERIALENE SOM FORBRUKES NÃ…R DETTE ALTERNATIVET BRUKES',0),(66330,1843,'da','MATERIALER FORBRUGES NÃ…R DENNE INDSTILLING BRUGES',0),(66331,1843,'ko','ì´ ì˜µì…˜ì„ ì‚¬ìš©í•  ë•Œë§ˆë‹¤ ì†Œëª¨ ìž¬ë£Œ',0),(66332,1843,'he','×•×”×—×•×ž×¨×™× ×”× ×¦×¨×›×™× ×‘×›×œ ×¤×¢× ×œ×”×©×ª×ž×© ×‘××¤×©×¨×•×ª ×–×•',0),(66333,1843,'el','Î¥Î›Î™ÎšÎ† Î ÎŸÎ¥ ÎšÎ‘Î¤Î‘ÎÎ‘Î›ÎÎÎ•Î¤Î‘Î™ ÎšÎ†Î˜Î• Î¦ÎŸÎ¡Î† Î ÎŸÎ¥ Î‘Î¥Î¤Î‰ Î— Î•Î Î™Î›ÎŸÎ“Î‰ Î§Î¡Î—Î£Î™ÎœÎŸÎ ÎŸÎ™Î•ÎŠÎ¤Î‘Î™',0),(66334,1843,'zh','ç‰©æ–™æ¶ˆè€—æ¯å½“è¿™ä¸ªé€‰é¡¹ä½¿ç”¨\r\n',0),(66335,1843,'sv','MATERIAL SOM FÃ–RBRUKATS NÃ„R DET HÃ„R ALTERNATIVET ANVÃ„NDS',0),(66336,1843,'it','MATERIE CONSUMATE OGNI VOLTA CHE SI UTILIZZA QUESTA OPZIONE',0),(66337,1843,'tl','',0),(66338,1843,'th','&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3607;&#3637;&#3656;&#3652;&#3627;&#3609;&#3585;&#3655;&#3605;&#3634;&#3617;&#3651;&#3594;&#3657;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3',0),(66339,1843,'hi','à¤œà¤¬ à¤­à¥€ à¤‡à¤¸ à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤–à¤ªà¤¤ à¤•à¥€ à¤—à¤ˆ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€',0),(66340,1843,'ms','BAHAN-BAHAN YANG DIGUNAKAN APABILA OPSYEN INI DIGUNAKAN',0),(66341,1843,'ar','Ø§Ù„Ù…ÙˆØ§Ø¯ Ø§Ù„Ù…Ø³ØªÙ‡Ù„ÙƒØ© Ø¹Ù†Ø¯ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù‡Ø°Ø§ Ø§Ù„Ø®ÙŠØ§Ø±',0),(66342,1843,'fr','MATÃ‰RIAUX CONSOMMÃ‰S CHAQUE FOIS QUE CETTE OPTION UTILISÃ‰E',0),(66343,1843,'jp','ã?“ã?®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?Œä½¿ç”¨ã?•ã‚Œã?Ÿæ™‚ã?«æ¶ˆè²»ã?•ã‚Œã‚‹æ??æ–™',0),(66344,1843,'pt','MATERIAIS CONSUMIDOS, SEMPRE QUE ESTA OPÃ‡ÃƒO USADA',0),(66345,1843,'ru','ÐœÐÐ¢Ð•Ð Ð˜ÐÐ›ÐžÐ’, Ð˜Ð—Ð ÐÐ¡Ð¥ÐžÐ”ÐžÐ’ÐÐÐÐ«Ð¥ Ð’Ð¡Ð¯ÐšÐ˜Ð™ Ð ÐÐ—, ÐšÐžÐ“Ð”Ð Ð­Ð¢ÐžÐ¢ ÐŸÐÐ ÐÐœÐ•Ð¢Ð  Ð˜Ð¡ÐŸÐžÐ›Ð¬Ð—Ð£Ð•Ð¢Ð¡Ð¯',0),(66346,1843,'es','MATERIALES CONSUMIDOS SIEMPRE QUE ESTA OPCIÃ“N SE USA',0),(66347,1843,'de','MATERIALIEN VERBRAUCHT, WENN DIESE OPTION VERWENDET',0),(66348,1843,'en','MATERIALS CONSUMED WHENEVER THIS OPTION USED',0),(66349,1844,'is','',0),(66350,1844,'dr','ÙÙ‚Ø· Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(66351,1844,'pr','ÙÙ‚Ø· Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(66352,1844,'tr','Sadece malzemeleri',0),(66353,1844,'pl','MateriaÅ‚y tylko',0),(66354,1844,'bg','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ ÑÐ°Ð¼Ð¾',0),(66355,1844,'ur','ØµØ±Ù Ù…ÙˆØ§Ø¯',0),(66356,1844,'sr','Ð¡Ð°Ð¼Ð¾ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð¸',0),(66357,1844,'vi','Chá»‰ Váº­t liá»‡u',0),(66358,1844,'af','Materiale Alleenlik',0),(66359,1844,'ro','Materiale numai',0),(66360,1844,'et','Ainult kaupadele',0),(66361,1844,'si','Materialov samo',0),(66362,1844,'ba','Bahan',0),(66363,1844,'nl','Materialen alleen',0),(66364,1844,'fi','Materiaaleja vain',0),(66365,1844,'no','Materialer bare',0),(66366,1844,'da','Kun materialer',0),(66367,1844,'ko','ìž¬ë£Œë§Œ',0),(66368,1844,'he','×—×•×ž×¨×™× ×‘×œ×‘×“',0),(66369,1844,'el','Î¥Î»Î¹ÎºÎ¬ Î¼ÏŒÎ½Î¿',0),(66370,1844,'zh','ææ–™åªæœ‰\r\n',0),(66371,1844,'sv','Material endast',0),(66372,1844,'it','Solo materiali',0),(66373,1844,'tl','',0),(66374,1844,'th','&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(66375,1844,'hi','à¤•à¥‡à¤µà¤² à¤¸à¤¾à¤®à¤—à¥à¤°à¥€',0),(66376,1844,'ms','Bahan-bahan yang hanya',0),(66377,1844,'ar','Ù…ÙˆØ§Ø¯ ÙÙ‚Ø·',0),(66378,1844,'fr','Uniquement des matÃ©riaux',0),(66379,1844,'jp','æ??æ–™ã?®ã?¿',0),(66380,1844,'pt','Materiais apenas',0),(66381,1844,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹',0),(66382,1844,'es','Materiales Solo',0),(66383,1844,'de','Nur Materialien',0),(66384,1844,'en','Materials Only',0),(66385,1845,'is','',0),(66386,1845,'dr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø§Ø±Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø¬Ù‡Øª ',0),(66387,1845,'pr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø§Ø±Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø¬Ù‡Øª ',0),(66388,1845,'tr','Boyut deÄŸerine kadar iÃ§in malzeme kullanÄ±lÄ±r',0),(66389,1845,'pl','MateriaÅ‚y uÅ¼ywane do wielkoÅ›ci do',0),(66390,1845,'bg','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð·Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð´Ð¾',0),(66391,1845,'ur','Ø³Ø§Ø¦Ø² Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú©Û’ Ù„Ø¦Û’ Ù…ÙˆØ§Ø¯ Used',0),(66392,1845,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ðµ Ð·Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ Ð´Ð¾',0),(66393,1845,'vi','Váº­t liá»‡u dÃ¹ng cho cá»¡ Ä‘áº¿n',0),(66394,1845,'af','Materiaal gebruik vir grootte tot',0),(66395,1845,'ro','Materialele folosite pentru dimensiunea pÃ¢nÄƒ la',0),(66396,1845,'et','Suurus kuni kasutatav materjal',0),(66397,1845,'si','Materialov, ki za velikosti do',0),(66398,1845,'ba','Bahan digunakan untuk ukuran hingga',0),(66399,1845,'nl','Materialen gebruikt voor grootte tot',0),(66400,1845,'fi','KÃ¤ytetyt materiaalit koko jalkeilla jotta',0),(66401,1845,'no','Materialer brukes for stÃ¸rrelsen til',0),(66402,1845,'da','Materialer brugt til stÃ¸rrelse op til',0),(66403,1845,'ko','ìµœëŒ€ í¬ê¸°ì— ì‚¬ìš© ë˜ëŠ” ìž¬ë£Œ',0),(66404,1845,'he','×—×•×ž×¨×™×-×ž×©×ž×© ×’×•×“×œ ×¢×“',0),(66405,1845,'el','Î¥Î»Î¹ÎºÎ¬ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î­Ï‰Ï‚',0),(66406,1845,'zh','æ‰€ç”¨ææ–™è§„æ¨¡è¾¾\r\n',0),(66407,1845,'sv','Material som anvÃ¤nds fÃ¶r storlek upp till',0),(66408,1845,'it','Materiali utilizzati per le dimensioni fino a',0),(66409,1845,'tl','',0),(66410,1845,'th','&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3651;&#3594;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3633;&#3610;&#3586;&#3609;&#3634;&#3604;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;&#3606;&#3638;&#3591;',0),(66411,1845,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤•à¤¾ à¤†à¤•à¤¾à¤° à¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¯à¥à¤•à¥à¤¤',0),(66412,1845,'ms','Bahan-bahan yang digunakan untuk saiz sehingga',0),(66413,1845,'ar','Ù…ÙˆØ§Ø¯ ØªØ³ØªØ®Ø¯Ù… Ù„Ø­Ø¬Ù… Ù…Ø§ ÙŠØµÙ„ Ø¥Ù„Ù‰',0),(66414,1845,'fr','MatÃ©riaux utilisÃ©s pour la taille jusqu\'au',0),(66415,1845,'jp','ï½žã?¾ã?§ã?®ã‚µã‚¤ã‚ºç”¨ã?«ä½¿ç”¨ã?•ã‚Œã‚‹æ??æ–™',0),(66416,1845,'pt','Materiais usados para o tamanho acima para',0),(66417,1845,'ru','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ðµ Ð´Ð»Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€Ð° Ð´Ð¾',0),(66418,1845,'es','Materiales Usados para TamaÃ±o hasta',0),(66419,1845,'de','Materialien benutzt fÃ¼r GrÃ¶ÃŸe bis zu',0),(66420,1845,'en','Materials Used for Size up to',0),(66421,1846,'is','',0),(66422,1846,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù…',0),(66423,1846,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù…',0),(66424,1846,'tr','Max',0),(66425,1846,'pl','Max',0),(66426,1846,'bg','ÐœÐ°ÐºÑ',0),(66427,1846,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(66428,1846,'sr','ÐœÐ°x',0),(66429,1846,'vi','Tá»‘i Ä‘a',0),(66430,1846,'af','Maks',0),(66431,1846,'ro','Max',0),(66432,1846,'et','Max',0),(66433,1846,'si','Max',0),(66434,1846,'ba','Max',0),(66435,1846,'nl','Max',0),(66436,1846,'fi','Max',0),(66437,1846,'no','Max',0),(66438,1846,'da','Max',0),(66439,1846,'ko','ë§¥ìŠ¤',0),(66440,1846,'he','×ž×§×¡',0),(66441,1846,'el','Max',0),(66442,1846,'zh','æœ€å¤§\r\n',0),(66443,1846,'sv','Max',0),(66444,1846,'it','Max',0),(66445,1846,'tl','',0),(66446,1846,'th','&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(66447,1846,'hi','à¤®à¥ˆà¤•à¥à¤¸',0),(66448,1846,'ms','Max',0),(66449,1846,'ar','Ø§Ù„Ø£Ù‚ØµÙ‰',0),(66450,1846,'fr','Max',0),(66451,1846,'jp','æœ€å¤§',0),(66452,1846,'pt','Max',0),(66453,1846,'ru','ÐœÐ°ÐºÑ.',0),(66454,1846,'es','Max',0),(66455,1846,'de','Max',0),(66456,1846,'en','Max',0),(66457,1847,'is','',0),(66458,1847,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ø¬Ø§Ø² ',0),(66459,1847,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ø¬Ø§Ø² ',0),(66460,1847,'tr','Ä°zin verilen en fazla',0),(66461,1847,'pl','Maksymalny dozwolony',0),(66462,1847,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¾ Ð´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð°Ñ‚Ð°',0),(66463,1847,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø§Ø¬Ø§Ø²Øª',0),(66464,1847,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¸ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¸',0),(66465,1847,'vi','Tá»‘i Ä‘a cho phÃ©p',0),(66466,1847,'af','Maksimum Toegelaat',0),(66467,1847,'ro','Maximul permis',0),(66468,1847,'et','Maksimaalselt lubatud',0),(66469,1847,'si','NajveÄjo dovoljeno',0),(66470,1847,'ba','Maksimum yang diperbolehkan',0),(66471,1847,'nl','Maximaal toegestane',0),(66472,1847,'fi','Suurin sallittu',0),(66473,1847,'no','Maksimalt tillatt',0),(66474,1847,'da','Maksimalt tilladte',0),(66475,1847,'ko','í—ˆìš© ë˜ëŠ” ìµœëŒ€',0),(66476,1847,'he','×”×ž×¨×‘×™ ×”×ž×•×ª×¨',0),(66477,1847,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· ÎµÏ€Î¹Ï„ÏÎµÏ€ÏŒÎ¼ÎµÎ½Î·',0),(66478,1847,'zh','æœ€å¤§å…è®¸\r\n',0),(66479,1847,'sv','Maximalt tillÃ¥tna',0),(66480,1847,'it','Massimo consentito',0),(66481,1847,'tl','',0),(66482,1847,'th','&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(66483,1847,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¥à¤µà¥€à¤•à¤¾à¤°à¥à¤¯',0),(66484,1847,'ms','Maksimum yang dibenarkan',0),(66485,1847,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(66486,1847,'fr','Maximale autorisÃ©e',0),(66487,1847,'jp','è¨±å?¯æ¸ˆæœ€å¤§å€¤',0),(66488,1847,'pt','MÃ¡ximo permitido',0),(66489,1847,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð¾ Ð´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð¾Ðµ',0),(66490,1847,'es','MÃ¡ximo Permitido',0),(66491,1847,'de','Maximal zulÃ¤ssige',0),(66492,1847,'en','Maximum Allowed',0),(66493,1848,'is','',0),(66494,1848,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ø¹Ø§ÙÙŠØª ',0),(66495,1848,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ø¹Ø§ÙÙŠØª ',0),(66496,1848,'tr','Max muafiyet',0),(66497,1848,'pl','Max zwolnienia',0),(66498,1848,'bg','ÐœÐ°ÐºÑ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ',0),(66499,1848,'ur','Ù…ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(66500,1848,'sr','ÐœÐ°x Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(66501,1848,'vi','Miá»…n trá»« tá»‘i Ä‘a',0),(66502,1848,'af','Maks vrystelling',0),(66503,1848,'ro','Max scutirea',0),(66504,1848,'et','Max erand',0),(66505,1848,'si','Max oprostitev',0),(66506,1848,'ba','Maks pengecualian',0),(66507,1848,'nl','Max vrijstelling',0),(66508,1848,'fi','Max vapautus',0),(66509,1848,'no','Max fritak',0),(66510,1848,'da','Max fritagelse',0),(66511,1848,'ko','ìµœëŒ€ ë©´ì œ',0),(66512,1848,'he','×ž×§×¡ ×¤×˜×•×¨',0),(66513,1848,'el','Max Î±Ï€Î±Î»Î»Î±Î³Î®',0),(66514,1848,'zh','æœ€é«˜è±å…\r\n',0),(66515,1848,'sv','Max befrielse',0),(66516,1848,'it','Esenzione di max',0),(66517,1848,'tl','',0),(66518,1848,'th','&#3586;&#3657;&#3629;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(66519,1848,'hi','à¤®à¥ˆà¤•à¥à¤¸ à¤›à¥‚à¤Ÿ',0),(66520,1848,'ms','Max pengecualian',0),(66521,1848,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ù„Ø¥Ø¹ÙØ§Ø¡',0),(66522,1848,'fr','Exemption de Max',0),(66523,1848,'jp','æœ€å¤§æŽ§é™¤',0),(66524,1848,'pt','IsenÃ§Ã£o de Max',0),(66525,1848,'ru','ÐœÐ°ÐºÑ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(66526,1848,'es','MÃ¡x exenciÃ³n',0),(66527,1848,'de','Max-Befreiung',0),(66528,1848,'en','Max exemption',0),(66529,1849,'is','',0),(66530,1849,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¹Ø§ÙÙŠØª Ø¯Ø± Ø³Ø§Ù„ ',0),(66531,1849,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¹Ø§ÙÙŠØª Ø¯Ø± Ø³Ø§Ù„ ',0),(66532,1849,'tr','Max muafiyet tutarÄ± her yÄ±l',0),(66533,1849,'pl','Max zwolnienia kwoty rocznie',0),(66534,1849,'bg','ÐœÐ°ÐºÑ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ ÑÑƒÐ¼Ð° Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¾',0),(66535,1849,'ur','Ù…ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ø±Ù‚Ù… Ø³Ø§Ù„Ø§Ù†Û',0),(66536,1849,'sr','ÐœÐ°x Ð¸Ð·ÑƒÐ·Ð¸Ð¼Ð°ÑšÐ° Ð¸Ð·Ð½Ð¾Ñ Ð³Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(66537,1849,'vi','Miá»…n trá»« tá»‘i Ä‘a má»—i nÄƒm',0),(66538,1849,'af','Maks vrygestelde bedrag per jaar',0),(66539,1849,'ro','Max scutirea suma pe an',0),(66540,1849,'et','Max maksuvabastuse summa aastas',0),(66541,1849,'si','Max oprostitev letno koliÄino',0),(66542,1849,'ba','Max jumlah per tahun',0),(66543,1849,'nl','Max vrijstelling bedrag per jaar',0),(66544,1849,'fi','Max vapautuksen mÃ¤Ã¤rÃ¤ vuodessa',0),(66545,1849,'no','Maks fritak belÃ¸p per Ã¥r',0),(66546,1849,'da','Max fritagelse belÃ¸b pr. Ã¥r',0),(66547,1849,'ko','ì—°ê°„ ìµœëŒ€ ê°ë©´ ê¸ˆì•¡',0),(66548,1849,'he','×ž×§×¡ ×¡×›×•× ×¤×˜×•×¨ ×œ×©× ×”',0),(66549,1849,'el','MÎ­Î³Î¹ÏƒÏ„Î¿ Ï€Î¿ÏƒÏŒ Î±Ï€Î±Î»Î»Î±Î³Î®Ï‚ Î±Î½Î¬ Î­Ï„Î¿Ï‚',0),(66550,1849,'zh','æ¯å¹´æœ€é«˜è±å…é¢\r\n',0),(66551,1849,'sv','Max undantaget belopp per Ã¥r',0),(66552,1849,'it','QuantitÃ  di esenzione max all\'anno',0),(66553,1849,'tl','',0),(66554,1849,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3605;&#3656;&#3629;&#3611;&#3637;',0),(66555,1849,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤· à¤…à¤§à¤¿à¤•à¤¤à¤® à¤›à¥‚à¤Ÿ à¤°à¤¾à¤¶à¤¿',0),(66556,1849,'ms','Amaun pengecualian Max setiap tahun',0),(66557,1849,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ù„ÙƒÙ„ Ø³Ù†Ø©',0),(66558,1849,'fr','Montant de l\'exonÃ©ration max par an',0),(66559,1849,'jp','å¹´æ¯Žæœ€å¤§æŽ§é™¤é¡?',0),(66560,1849,'pt','Quantidade de isenÃ§Ã£o Max por ano',0),(66561,1849,'ru','ÐœÐ°ÐºÑ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ ÑÑƒÐ¼Ð¼Ð° Ð·Ð° Ð³Ð¾Ð´',0),(66562,1849,'es','Max cant. de exenciÃ³n por aÃ±o',0),(66563,1849,'de','Max Freibetrag pro Jahr',0),(66564,1849,'en','Max exemption amount per year',0),(66565,1850,'is','',0),(66566,1850,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª',0),(66567,1850,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª',0),(66568,1850,'tr','Max arka mÃ¼rekkepler',0),(66569,1850,'pl','Max tusze z powrotem',0),(66570,1850,'bg','ÐœÐ°ÐºÑ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð½Ð°Ð·Ð°Ð´',0),(66571,1850,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù¾ÛŒÚ†Ú¾Û’ Ø§Ù†Ú©Ø³',0),(66572,1850,'sr','ÐœÐ°x Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð½Ð°Ð·Ð°Ð´',0),(66573,1850,'vi','Má»±c In Tá»‘i Äa',0),(66574,1850,'af','Max ink terug',0),(66575,1850,'ro','Max cerneluri spate',0),(66576,1850,'et','Max trÃ¼kivÃ¤rve tagasi',0),(66577,1850,'si','Max Ärnil nazaj',0),(66578,1850,'ba','Max tinta kembali',0),(66579,1850,'nl','Max inkt terug',0),(66580,1850,'fi','Max musteet takaisin',0),(66581,1850,'no','Max blekk tilbake',0),(66582,1850,'da','Max blÃ¦k tilbage',0),(66583,1850,'ko','ë§¥ìŠ¤ ìž‰í¬ ë‹¤ì‹œ',0),(66584,1850,'he','×ž×§×¡ ×¡×•×’×™ ×”×“×™×• ×‘×—×–×¨×”',0),(66585,1850,'el','Max Î¼ÎµÎ»Î¬Î½Î¹Î± Ï€Î¯ÏƒÏ‰',0),(66586,1850,'zh','æœ€å¤§æ²¹å¢¨è¿”å›ž\r\n',0),(66587,1850,'sv','Max blÃ¤ck tillbaka',0),(66588,1850,'it','Max inchiostri Back',0),(66589,1850,'tl','',0),(66590,1850,'th','&#3627;&#3617;&#3638;&#3585;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3604;&#3657;&#3634;&#3609;&#3627;&#3621;&#3633;&#3591;',0),(66591,1850,'hi','à¤®à¥ˆà¤•à¥à¤¸ à¤ªà¥€à¤  à¤¸à¥à¤¯à¤¾à¤¹à¥€',0),(66592,1850,'ms','Max dakwat belakang',0),(66593,1850,'ar','Ù…Ø§ÙƒØ³ Ø§Ù„Ø£Ø­Ø¨Ø§Ø± Ø§Ù„Ø®Ù„ÙÙŠ',0),(66594,1850,'fr','Max encres dos',0),(66595,1850,'jp','è£?é?¢ã?®ã‚¤ãƒ³ã‚¯æœ€å¤§å€¤',0),(66596,1850,'pt','Max tintas de volta',0),(66597,1850,'ru','ÐœÐ°ÐºÑ Ñ‡ÐµÑ€Ð½Ð¸Ð»Ð° Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾',0),(66598,1850,'es','Max Tintas Dorso',0),(66599,1850,'de','Max Tinten zurÃ¼ck',0),(66600,1850,'en','Max Inks Back',0),(66601,1851,'is','',0),(66602,1851,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø±Ùˆ Ø¨Ù‡ Ø¬Ù„Ùˆ ',0),(66603,1851,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø±Ùˆ Ø¨Ù‡ Ø¬Ù„Ùˆ ',0),(66604,1851,'tr','Max mÃ¼rekkepleri aÃ§Ä±k',0),(66605,1851,'pl','Max farb przÃ³d',0),(66606,1851,'bg','ÐœÐ°ÐºÑ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ñ„Ñ€Ð¾Ð½Ñ‚',0),(66607,1851,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Ø§Ù…Ù†Û’ Ø§Ù†Ú©Ø³',0),(66608,1851,'sr','ÐœÐ°x Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð¤Ñ€Ð¾Ð½Ñ‚',0),(66609,1851,'vi','Má»±c tá»‘i Ä‘a phÃ­a trÆ°á»›c',0),(66610,1851,'af','Max ink voor',0),(66611,1851,'ro','FaÅ£Äƒ de cerneluri Max',0),(66612,1851,'et','Max tindid ees',0),(66613,1851,'si','Max Ärnila spredaj',0),(66614,1851,'ba','Max tinta depan',0),(66615,1851,'nl','Max inkten Front',0),(66616,1851,'fi','Max musteet edessÃ¤',0),(66617,1851,'no','Max blekk foran',0),(66618,1851,'da','Max trykfarver Front',0),(66619,1851,'ko','ë§¥ìŠ¤ ìž‰í¬ ì•ž',0),(66620,1851,'he','×ž×§×¡ ×¦×‘×¢×™ ×—×–×™×ª',0),(66621,1851,'el','Max Î¼ÎµÎ»Î¬Î½Î¹Î± Î¼Î­Ï„Ï‰Ï€Î¿',0),(66622,1851,'zh','æœ€å¤§æ²¹å¢¨æ ‡é¢˜\r\n',0),(66623,1851,'sv','Max blÃ¤ck Front',0),(66624,1851,'it','Max inchiostri anteriore',0),(66625,1851,'tl','',0),(66626,1851,'th','&#3627;&#3617;&#3638;&#3585;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3604;&#3657;&#3634;&#3609;&#3627;&#3609;&#3657;&#3634;',0),(66627,1851,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤®à¥‹à¤°à¥à¤šà¤¾',0),(66628,1851,'ms','Max dakwat Penyambut',0),(66629,1851,'ar','Ù…Ø§ÙƒØ³ Ø§Ù„Ø£Ø­Ø¨Ø§Ø± Ø§Ù„Ø¬Ø¨Ù‡Ø©',0),(66630,1851,'fr','Max encres avant',0),(66631,1851,'jp','è¡¨é?¢ã?®ã‚¤ãƒ³ã‚¯æœ€å¤§å€¤',0),(66632,1851,'pt','Max tintas frente',0),(66633,1851,'ru','ÐœÐ°ÐºÑ ÐºÑ€Ð°ÑÐºÐ¸ Ñ„Ñ€Ð¾Ð½Ñ‚',0),(66634,1851,'es','Max Tintas Frente',0),(66635,1851,'de','Max-Tinten-Front',0),(66636,1851,'en','Max Inks Front',0),(66637,1852,'is','',0),(66638,1852,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø¯Ø± Ù‡Ø± Ù…Ø³ÙŠØ±',0),(66639,1852,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø¯Ø± Ù‡Ø± Ù…Ø³ÙŠØ±',0),(66640,1852,'tr','Max mÃ¼rekkepleri baÅŸÄ±na geÃ§mek',0),(66641,1852,'pl','Max farb na przeÅ‚Ä™czy',0),(66642,1852,'bg','ÐœÐ°ÐºÑ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð½Ð° Ð¿Ñ€Ð¾Ñ…Ð¾Ð´',0),(66643,1852,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù¾Ø§Ø³ ÙÛŒ Ø§Ù†Ú©Ø³',0),(66644,1852,'sr','ÐœÐ°x Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð¿Ð¾ Ð¿Ñ€Ð¾Ð»Ð°Ð·',0),(66645,1852,'vi','Má»±c tá»‘i Ä‘a má»—i tháº»',0),(66646,1852,'af','Max ink Per Pass',0),(66647,1852,'ro','Max cerneluri pe trecere',0),(66648,1852,'et','Max tindid kohta Pass',0),(66649,1852,'si','Max Ärnila na prelaz',0),(66650,1852,'ba','Max tinta Per Pass',0),(66651,1852,'nl','Max-inkten Per Pass',0),(66652,1852,'fi','Max musteet / Pass',0),(66653,1852,'no','Max blekk Per Pass',0),(66654,1852,'da','Max trykfarver Per Pass',0),(66655,1852,'ko','íŒ¨ìŠ¤ ë‹¹ ìµœëŒ€ ìž‰í¬',0),(66656,1852,'he','×ž×§×¡ ×“×™×• ×œ×›×œ ×ž×¢×‘×¨',0),(66657,1852,'el','ÎœÎµÎ»Î¬Î½Î¹Î± max Î±Î½Î¬ Ï€Î­ÏÎ±ÏƒÎ¼Î±',0),(66658,1852,'zh','æ¯æ¬¡é€šè¿‡æœ€å¤§æ²¹å¢¨\r\n',0),(66659,1852,'sv','Max blÃ¤ck Per Pass',0),(66660,1852,'it','Max inchiostri per ogni Pass',0),(66661,1852,'tl','',0),(66662,1852,'th','&#3627;&#3617;&#3638;&#3585;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;',0),(66663,1852,'hi','à¤¦à¤°à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¥à¤¯à¤¾à¤¹à¥€',0),(66664,1852,'ms','Dakwat Max satu Pas',0),(66665,1852,'ar','Ø£Ø­Ø¨Ø§Ø± Ù…Ø§ÙƒØ³ ÙÙŠ ØªÙ…Ø±ÙŠØ±',0),(66666,1852,'fr','Encres max par Pass',0),(66667,1852,'jp','ãƒ‘ã‚¹ã?”ã?¨ã?®ã‚¤ãƒ³ã‚¯æœ€å¤§å€¤',0),(66668,1852,'pt','Max tintas por Pass',0),(66669,1852,'ru','ÐœÐ°ÐºÑ ÐºÑ€Ð°ÑÐºÐ¸ Ð·Ð° Ð¿Ñ€Ð¾Ñ…Ð¾Ð´',0),(66670,1852,'es','Max Tintas por Paso',0),(66671,1852,'de','Max-Tinten pro Durchlauf',0),(66672,1852,'en','Max Inks Per Pass',0),(66673,1853,'is','',0),(66674,1853,'dr','Ø¨Ø¯ÙˆÙ† Ù…Ø­Ø¯ÙˆØ¯ÙŠØª Ú¯Ø±ÙˆÙ‡ ',0),(66675,1853,'pr','Ø¨Ø¯ÙˆÙ† Ù…Ø­Ø¯ÙˆØ¯ÙŠØª Ú¯Ø±ÙˆÙ‡ ',0),(66676,1853,'tr','Kategori sÄ±nÄ±rÄ± yok',0),(66677,1853,'pl','Bez limitÃ³w kategorii',0),(66678,1853,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸Ñ',0),(66679,1853,'ur','Ú©ÙˆØ¦ÛŒ Ø²Ù…Ø±Û Ú©ÛŒ Ø­Ø¯',0),(66680,1853,'sr','ÐÐµÐ¼Ð° Ð³Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð·Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(66681,1853,'vi','KhÃ´ng giá»›i háº¡n thá»ƒ loáº¡i',0),(66682,1853,'af','Geen Kategorie Limiete',0),(66683,1853,'ro','Nu limite, de categorie',0),(66684,1853,'et','Nr kategooria piirangud',0),(66685,1853,'si','Kategorija omejitev',0),(66686,1853,'ba','Tidak ada batas Kategori',0),(66687,1853,'nl','Geen categorie grenzen',0),(66688,1853,'fi','Luokkien ylÃ¤rajojen',0),(66689,1853,'no','Ingen kategori begrensninger',0),(66690,1853,'da','Ingen kategori grÃ¦nser',0),(66691,1853,'ko','ì¹´í…Œê³ ë¦¬ ì œí•œ ì—†ìŒ',0),(66692,1853,'he','××™×Ÿ ×’×‘×•×œ×•×ª ×”×§×˜×’×•×¨×™×”',0),(66693,1853,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ ÏŒÏÎ¹Î±',0),(66694,1853,'zh','æ²¡æœ‰ç±»åˆ«é™åˆ¶\r\n',0),(66695,1853,'sv','Ingen kategori grÃ¤nser',0),(66696,1853,'it','Senza limiti di categoria',0),(66697,1853,'tl','',0),(66698,1853,'th','&#3652;&#3617;&#3656;&#3592;&#3635;&#3585;&#3633;&#3604;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(66699,1853,'hi','à¤•à¥‹à¤ˆ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¥€à¤®à¤¾',0),(66700,1853,'ms','Tidak ada had kategori',0),(66701,1853,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø­Ø¯ÙˆØ¯ Ø§Ù„ÙØ¦Ø©',0),(66702,1853,'fr','Aucune limite de la catÃ©gorie',0),(66703,1853,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®åˆ¶é™?ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(66704,1853,'pt','Sem limites de categoria',0),(66705,1853,'ru','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸Ð¹ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(66706,1853,'es','No Limites de CategorÃ­a',0),(66707,1853,'de','Keine Kategorie-Grenzen',0),(66708,1853,'en','No Category Limits',0),(66709,1854,'is','',0),(66710,1854,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ Ù…Ù…ÙƒÙ† ',0),(66711,1854,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ Ù…Ù…ÙƒÙ† ',0),(66712,1854,'tr','Max ana Ã¶ÄŸeleri mÃ¼mkÃ¼n',0),(66713,1854,'pl','Max gÅ‚Ã³wnego elementy moÅ¼liwe',0),(66714,1854,'bg','ÐœÐ°ÐºÑ Ð¼Ð°Ð¹ÑÑ‚Ð¾Ñ€ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ðµ Ð²ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð¾',0),(66715,1854,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù…Ø§Ø³Ù¹Ø± Ø§Ø´ÛŒØ§Ø¡ Ù…Ù…Ú©Ù† ÛÙˆ',0),(66716,1854,'sr','ÐœÐ°x Ð³Ð¾ÑÐ¿Ð¾Ð´Ð°Ñ€ ÑÑ‚Ð°Ð²ÐºÐµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ',0),(66717,1854,'vi','Tá»‘i Ä‘a sá»‘ lÆ°á»£ng hÃ ng chá»§ cÃ³ thá»ƒ',0),(66718,1854,'af','Maks. Meester Items Moontlik',0),(66719,1854,'ro','Max Master elemente posibil',0),(66720,1854,'et','Max Master Ã¼ksuste vÃµimalik',0),(66721,1854,'si','Max Master elemente mogoÄe',0),(66722,1854,'ba','Max Master item mungkin',0),(66723,1854,'nl','Max Master Items mogelijk',0),(66724,1854,'fi','Max Master tuotteet mahdollista',0),(66725,1854,'no','Max Master elementer mulig',0),(66726,1854,'da','Max Master elementer muligt',0),(66727,1854,'ko','ë§¥ìŠ¤ ë§ˆìŠ¤í„° í•­ëª© ê°€ëŠ¥',0),(66728,1854,'he','×”××¤×©×¨ ×¤×¨×™×˜×™ ×ž××¡×˜×¨ ×ž×§×¡',0),(66729,1854,'el','Max Master ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î´Ï…Î½Î±Ï„ÏŒÎ½',0),(66730,1854,'zh','æœ€å¤§å¯èƒ½çš„ç®¡ç†é¡¹ç›®\r\n',0),(66731,1854,'sv','Max Master objekt mÃ¶jligt',0),(66732,1854,'it','Max Master elementi possibili',0),(66733,1854,'tl','',0),(66734,1854,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3621;&#3633;&#3585;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3607;&#3637;&#3656;&#3648;&#3611;&#3655;&#3609;&#3652;&#3611;&#3652;&#3604;&#3657;',0),(66735,1854,'hi','Max à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤¸à¤‚à¤­à¤µ',0),(66736,1854,'ms','Max Master item mungkin',0),(66737,1854,'ar','Ù…Ø§ÙƒØ³ Ù…Ù…ÙƒÙ† Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(66738,1854,'fr','Max Master Ã©lÃ©ments Possible',0),(66739,1854,'jp','å?¯èƒ½ãƒžã‚¹ã‚¿ãƒ¼å“?ç›®ã?®æœ€å¤§å€¤',0),(66740,1854,'pt','Max mestre itens possÃ­vel',0),(66741,1854,'ru','ÐœÐ°ÐºÑ ÐœÐ°ÑÑ‚ÐµÑ€ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð¼Ð¾Ð¶Ð½Ð¾',0),(66742,1854,'es','Max Items Maestro Posible',0),(66743,1854,'de','Max Master Elemente mÃ¶glich',0),(66744,1854,'en','Max Master Items Possible',0),(66745,1855,'is','',0),(66746,1855,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø´Ù…Ø§Ø±Ù‡ Ø±Ù†Ú¯Ù‡Ø§ ',0),(66747,1855,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø´Ù…Ø§Ø±Ù‡ Ø±Ù†Ú¯Ù‡Ø§ ',0),(66748,1855,'tr','Max # renkler',0),(66749,1855,'pl','# Maksymalna liczba kolorÃ³w',0),(66750,1855,'bg','ÐœÐ°ÐºÑ # Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(66751,1855,'ur','Ù…ÛŒÚ©Ø³ # Ø±Ù†Ú¯',0),(66752,1855,'sr','ÐœÐ°ÐºÑ # Ð±Ð¾Ñ˜Ðµ',0),(66753,1855,'vi','Tá»‘i Ä‘a sá»‘ náº§u',0),(66754,1855,'af','Max # kleure',0),(66755,1855,'ro','Max # culori',0),(66756,1855,'et','Max # vÃ¤rvid',0),(66757,1855,'si','# Barvami Max',0),(66758,1855,'ba','Max # warna',0),(66759,1855,'nl','Max # kleuren',0),(66760,1855,'fi','Max # vÃ¤rit',0),(66761,1855,'no','Max # farger',0),(66762,1855,'da','Max # farver',0),(66763,1855,'ko','ìµœëŒ€ # ìƒ‰ìƒ',0),(66764,1855,'he','×ž×§×¡ # ×¦×‘×¢×™×',0),(66765,1855,'el','Max # Ï‡ÏÏŽÎ¼Î±Ï„Î±',0),(66766,1855,'zh','æœ€å¤§ï¼ƒé¢œè‰²\r\n',0),(66767,1855,'sv','Max # fÃ¤rger',0),(66768,1855,'it','Max # colori',0),(66769,1855,'tl','',0),(66770,1855,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3626;&#3637;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(66771,1855,'hi','à¤®à¥ˆà¤•à¥à¤¸ # à¤°à¤‚à¤—',0),(66772,1855,'ms','Warna-warna # Max',0),(66773,1855,'ar','Ù…Ø§ÙƒØ³ # Ø§Ù„Ø£Ù„ÙˆØ§Ù†',0),(66774,1855,'fr','Max # couleurs',0),(66775,1855,'jp','è‰²ã?®æœ€å¤§æ•°',0),(66776,1855,'pt','Max # cores',0),(66777,1855,'ru','ÐœÐ°ÐºÑ # Ñ†Ð²ÐµÑ‚Ð°',0),(66778,1855,'es','Max # Colores',0),(66779,1855,'de','Max # Farben',0),(66780,1855,'en','Max # Colors',0),(66781,1856,'is','',0),(66782,1856,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø´Ù…Ø§Ø±Ù‡ ØµÙØ­Ø§Øª',0),(66783,1856,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø´Ù…Ø§Ø±Ù‡ ØµÙØ­Ø§Øª',0),(66784,1856,'tr','Max # sayfalarÄ±',0),(66785,1856,'pl','Max # stron',0),(66786,1856,'bg','ÐœÐ°ÐºÑ # ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(66787,1856,'ur','Ù…ÛŒÚ©Ø³ # ØµÙØ­Ø§Øª',0),(66788,1856,'sr','ÐœÐ°ÐºÑ # ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(66789,1856,'vi','Sá»‘ trang tá»‘i Ä‘a',0),(66790,1856,'af','Max # bladsye',0),(66791,1856,'ro','Max # pagini',0),(66792,1856,'et','Max # lehekÃ¼ljed',0),(66793,1856,'si','Max # strani',0),(66794,1856,'ba','Halaman # Max',0),(66795,1856,'nl','Max # pagina \'s',0),(66796,1856,'fi','Max # sivut',0),(66797,1856,'no','Max # sider',0),(66798,1856,'da','Max # sider',0),(66799,1856,'ko','ìµœëŒ€ # íŽ˜ì´ì§€',0),(66800,1856,'he','×ž×§×¡ # ×“×¤×™×',0),(66801,1856,'el','Max # ÏƒÎµÎ»Î¯Î´ÎµÏ‚',0),(66802,1856,'zh','æœ€å¤§ï¼ƒé¡µ\r\n',0),(66803,1856,'sv','Max # sidor',0),(66804,1856,'it','Max # pagine',0),(66805,1856,'tl','',0),(66806,1856,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3627;&#3609;&#3657;&#3634;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(66807,1856,'hi','à¤®à¥ˆà¤•à¥à¤¸ # à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚',0),(66808,1856,'ms','Muka surat # Max',0),(66809,1856,'ar','Ù…Ø§ÙƒØ³ # ØµÙØ­Ø§Øª',0),(66810,1856,'fr','Max # Pages',0),(66811,1856,'jp','ãƒšãƒ¼ã‚¸ã?®æœ€å¤§æ•°',0),(66812,1856,'pt','Max # pÃ¡ginas',0),(66813,1856,'ru','ÐœÐ°ÐºÑ # ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†',0),(66814,1856,'es','Max # PÃ¡ginas',0),(66815,1856,'de','Max # Seiten',0),(66816,1856,'en','Max # Pages',0),(66817,1857,'is','',0),(66818,1857,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø´Ù…Ø§Ø±Ù‡ Ø§Ù†Ø¨Ø§Ø±Ù‡Ø§ ',0),(66819,1857,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø´Ù…Ø§Ø±Ù‡ Ø§Ù†Ø¨Ø§Ø±Ù‡Ø§ ',0),(66820,1857,'tr','Max # stoklarÄ±',0),(66821,1857,'pl','Max # zapasÃ³w',0),(66822,1857,'bg','ÐœÐ°ÐºÑ # Ð·Ð°Ð¿Ð°ÑÐ¸',0),(66823,1857,'ur','Ù…ÛŒÚ©Ø³ # Ø§Ø³Ù¹Ø§Ú©',0),(66824,1857,'sr','ÐœÐ°ÐºÑ # Ð´Ð¸Ð¾Ð½Ð¸Ñ†Ðµ',0),(66825,1857,'vi','Tá»‘i Ä‘a sá»‘ hÃ ng tá»“',0),(66826,1857,'af','Maks # Voorrade',0),(66827,1857,'ro','Max # stocuri',0),(66828,1857,'et','Max # varud',0),(66829,1857,'si','# Max zalog',0),(66830,1857,'ba','Max # saham',0),(66831,1857,'nl','Max # voorraden',0),(66832,1857,'fi','Max # varastot',0),(66833,1857,'no','Max # aksjer',0),(66834,1857,'da','Max # bestande',0),(66835,1857,'ko','ìµœëŒ€ # ì£¼ì‹',0),(66836,1857,'he','×ž×§×¡ # ×ž× ×™×•×ª',0),(66837,1857,'el','Max # Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î±',0),(66838,1857,'zh','ï¼ƒæœ€å¤§å­˜è´§\r\n',0),(66839,1857,'sv','Max # bestÃ¥nd',0),(66840,1857,'it','Max # stock',0),(66841,1857,'tl','',0),(66842,1857,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3617;&#3637;&#3651;&#3609;&#3619;&#3657;&#3634;&#3609;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(66843,1857,'hi','à¤®à¥ˆà¤•à¥à¤¸ # à¤¸à¥à¤Ÿà¥‰à¤•à¥à¤¸',0),(66844,1857,'ms','Max # stok',0),(66845,1857,'ar','Ù…Ø§ÙƒØ³ # Ø§Ù„Ø£Ø±ØµØ¯Ø©',0),(66846,1857,'fr','Max # Stocks',0),(66847,1857,'jp','åœ¨åº«ã?®æœ€å¤§æ•°',0),(66848,1857,'pt','Max # aÃ§Ãµes',0),(66849,1857,'ru','ÐœÐ°ÐºÑ # Ð·Ð°Ð¿Ð°ÑÑ‹',0),(66850,1857,'es','Max # Stocks',0),(66851,1857,'de','Max # Aktien',0),(66852,1857,'en','Max # Stocks',0),(66853,1858,'is','',0),(66854,1858,'dr','(Ù†Ø±Ø® Ø§Ø¬Ø±Ø§',0),(66855,1858,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø³Ø±Ø¹Øª Ø¯Ùˆ (Ù†Ø±Ø® Ø§Ø¬Ø±Ø§',0),(66856,1858,'tr','Max.Run oranÄ±',0),(66857,1858,'pl','Stopy Max.Run',0),(66858,1858,'bg','Max.Run ÐºÑƒÑ€Ñ',0),(66859,1858,'ur','Max.Run Ú©ÛŒ Ø´Ø±Ø­',0),(66860,1858,'sr','ÐœÐ°x .Ð ÑƒÐ½ ÑÑ‚Ð¾Ð¿Ð°',0),(66861,1858,'vi','Cháº¡y giÃ¡ tá»‘i Ä‘a',0),(66862,1858,'af','Maks. Loopkoste',0),(66863,1858,'ro','Rata de Max.Run',0),(66864,1858,'et','Max.Run mÃ¤Ã¤r',0),(66865,1858,'si','Max.Run stopnja',0),(66866,1858,'ba','Tingkat Max.Run',0),(66867,1858,'nl','Max.Run tarief',0),(66868,1858,'fi','Max.Run mÃ¤Ã¤rÃ¤',0),(66869,1858,'no','Max.Run Rate',0),(66870,1858,'da','Max.Run sats',0),(66871,1858,'ko','Max.Run ì†ë„',0),(66872,1858,'he','Max.Run ×§×¦×‘',0),(66873,1858,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Max.Run',0),(66874,1858,'zh','æœ€å¤§è¿è¡Œé€Ÿåº¦\r\n',0),(66875,1858,'sv','Max.Run hastighet',0),(66876,1858,'it','Tasso di Max.Run',0),(66877,1858,'tl','',0),(66878,1858,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3623;&#3634;&#3617;&#3605;&#3656;&#3629;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(66879,1858,'hi','Max.Run à¤¦à¤°',0),(66880,1858,'ms','Kadar Max.Run',0),(66881,1858,'ar','Ù…Ø¹Ø¯Ù„ Max.Run',0),(66882,1858,'fr','Taux de Max.Run',0),(66883,1858,'jp','æœ€å¤§å®Ÿæ–½æ–™é‡‘',0),(66884,1858,'pt','Taxa de Max.Run',0),(66885,1858,'ru','Max.Run ÑÑ‚Ð°Ð²ÐºÐ°',0),(66886,1858,'es','Max Velocidad del Paso',0),(66887,1858,'de','Max.Run Rate',0),(66888,1858,'en','Max.Run Rate',0),(66889,1859,'is','',0),(66890,1859,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(66891,1859,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(66892,1859,'tr','Maksimum stok dÃ¼zeyi',0),(66893,1859,'pl','Max czas poziom',0),(66894,1859,'bg','ÐœÐ°ÐºÑ ÑÐºÐ»Ð°Ð´ Ð½Ð¸Ð²Ð¾',0),(66895,1859,'ur','Ù…ÛŒÚ©Ø³ Ø§Ø³Ù¹Ø§Ú© Ø³Ø·Ø­',0),(66896,1859,'sr','ÐœÐ°x Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð¸Ð²Ð¾',0),(66897,1859,'vi','Má»©c hÃ ng tá»“n tá»‘i Ä‘a',0),(66898,1859,'af','Maks Voorrade Vlak',0),(66899,1859,'ro','Stoc Max nivel',0),(66900,1859,'et','Max varude tase',0),(66901,1859,'si','Ravni Max zalog',0),(66902,1859,'ba','Max saham tingkat',0),(66903,1859,'nl','Max voorraad niveau',0),(66904,1859,'fi','Max kaluston taso',0),(66905,1859,'no','Max lager nivÃ¥',0),(66906,1859,'da','Max lager niveau',0),(66907,1859,'ko','ìµœëŒ€ ìž¬ê³  ìˆ˜ì¤€',0),(66908,1859,'he','×¨×ž×ª ×ž×§×¡ ×¡×˜×•×§',0),(66909,1859,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Max ÎµÏ€Î¯Ï€ÎµÎ´Î¿',0),(66910,1859,'zh','æœ€å¤§åº“å­˜æ°´å¹³\r\n',0),(66911,1859,'sv','Max lager nivÃ¥',0),(66912,1859,'it','Livello max Stock',0),(66913,1859,'tl','',0),(66914,1859,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3657;&#3634;&#3609;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(66915,1859,'hi','à¤®à¥ˆà¤•à¥à¤¸ à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥à¤¤à¤°',0),(66916,1859,'ms','Paras stok maksimum',0),(66917,1859,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù…Ø§ÙƒØ³',0),(66918,1859,'fr','Niveau de Stock de Max',0),(66919,1859,'jp','åœ¨åº«ãƒ¬ãƒ™ãƒ«ã?®æœ€å¤§å€¤',0),(66920,1859,'pt','NÃ­vel mÃ¡ximo de estoque',0),(66921,1859,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð·Ð°Ð¿Ð°Ñ',0),(66922,1859,'es','Max Nivel de Stock',0),(66923,1859,'de','Max Lagerbestand',0),(66924,1859,'en','Max Stock Level',0),(66925,1860,'is','',0),(66926,1860,'dr','SUI ',0),(66927,1860,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§ÙŠØ§Ù„ØªÙŠ Ø¯Ø± Ø³Ø§Ù„   SUI ',0),(66928,1860,'tr','Her yÄ±l Max SUI',0),(66929,1860,'pl','Max SUI rocznie',0),(66930,1860,'bg','ÐœÐ°ÐºÑ SUI Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¾',0),(66931,1860,'ur','ÛØ± Ø³Ø§Ù„ Ù…ÛŒÚ©Ø³ Ø³ÙˆØ¦ÛŒ',0),(66932,1860,'sr','ÐœÐ°x Ð¡Ð£Ð˜ Ð³Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(66933,1860,'vi','SUI tá»‘i Ä‘a má»—i nÄƒm',0),(66934,1860,'af','Max SUI per jaar',0),(66935,1860,'ro','Max SUI pe an',0),(66936,1860,'et','Max SUI aastas',0),(66937,1860,'si','Max SUI letno',0),(66938,1860,'ba','Max SUI per tahun',0),(66939,1860,'nl','Max SUI per jaar',0),(66940,1860,'fi','Max SUI vuodessa',0),(66941,1860,'no','Max SUI per Ã¥r',0),(66942,1860,'da','Max SUI pr. Ã¥r',0),(66943,1860,'ko','ì—°ê°„ ìµœëŒ€ ìˆ˜',0),(66944,1860,'he','×ž×§×¡ ×¡×•×•×™ ×œ×©× ×”',0),(66945,1860,'el','Max SUI Î±Î½Î¬ Î­Ï„Î¿Ï‚',0),(66946,1860,'zh','æ¯å¹´æœ€å¤šSUI\r\n',0),(66947,1860,'sv','Max SUI per Ã¥r',0),(66948,1860,'it','SUI max all\'anno',0),(66949,1860,'tl','',0),(66950,1860,'th','SUI &#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3605;&#3656;&#3629;&#3611;&#3637;',0),(66951,1860,'hi','à¤®à¥ˆà¤•à¥à¤¸ à¤¸à¥à¤‡ à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤·',0),(66952,1860,'ms','Max SUI setiap tahun',0),(66953,1860,'ar','Ù†ÙˆØ¹Ù‡ Ù…Ø§ÙƒØ³ ÙÙŠ Ø§Ù„Ø³Ù†Ø©',0),(66954,1860,'fr','SUI max par an',0),(66955,1860,'jp','å¹´æ¯ŽSUIã?®æœ€å¤§å€¤',0),(66956,1860,'pt','Max SUI por ano',0),(66957,1860,'ru','ÐœÐ°ÐºÑ Ð¡ÑƒÐ¹ Ð² Ð³Ð¾Ð´',0),(66958,1860,'es','Max SUI por aÃ±o',0),(66959,1860,'de','Max SUI pro Jahr',0),(66960,1860,'en','Max SUI per year',0),(66961,1861,'is','',0),(66962,1861,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø±ÙˆØ²Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ ',0),(66963,1861,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø±ÙˆØ²Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ ',0),(66964,1861,'tr','Max tatil gÃ¼nleri',0),(66965,1861,'pl','Dni urlopu max',0),(66966,1861,'bg','ÐœÐ°ÐºÑ Ð²Ð°ÐºÐ°Ð½Ñ†Ð¸Ñ Ð´Ð½Ð¸',0),(66967,1861,'ur','Ù…ÛŒÚ©Ø³ Ú†Ú¾Ù¹ÛŒ Ú©Û’ Ø¯Ù†',0),(66968,1861,'sr','ÐœÐ°ÐºÑ Ð¾Ð´Ð¼Ð¾Ñ€ Ð´Ð°Ð½Ð°',0),(66969,1861,'vi','NgÃ y tá»‘i Ä‘a cho ká»³ nghá»‰',0),(66970,1861,'af','Maks. Vakansiedae',0),(66971,1861,'ro','Zile Max de vacanÅ£Äƒ',0),(66972,1861,'et','Max puhkusepÃ¤evi',0),(66973,1861,'si','Max dopust dni',0),(66974,1861,'ba','Max liburan hari',0),(66975,1861,'nl','Max vakantie dagen',0),(66976,1861,'fi','Max lomapÃ¤iviÃ¤',0),(66977,1861,'no','Max feriedager',0),(66978,1861,'da','Max feriedage',0),(66979,1861,'ko','ìµœëŒ€ íœ´ê°€ ì¼',0),(66980,1861,'he','×™×ž×™ ×—×•×¤×©×” ×ž×§×¡',0),(66981,1861,'el','Î—Î¼Î­ÏÎµÏ‚ Î´Î¹Î±ÎºÎ¿Ï€ÏŽÎ½ Max',0),(66982,1861,'zh','æœ€å¤šå‡æœŸ\r\n',0),(66983,1861,'sv','Max semesterdagar',0),(66984,1861,'it','Giorni di vacanza di max',0),(66985,1861,'tl','',0),(66986,1861,'th','&#3623;&#3633;&#3609;&#3627;&#3618;&#3640;&#3604;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(66987,1861,'hi','à¤®à¥ˆà¤•à¥à¤¸ à¤›à¥à¤Ÿà¥à¤Ÿà¥€ à¤•à¥‡ à¤¦à¤¿à¤¨',0),(66988,1861,'ms','Hari-hari percutian Max',0),(66989,1861,'ar','Ø£ÙŠØ§Ù… Ø¹Ø·Ù„Ø© Ù…Ø§ÙƒØ³',0),(66990,1861,'fr','Jours de vacances de Max',0),(66991,1861,'jp','æœ€å¤§ä¼‘æš‡æ—¥æ•°',0),(66992,1861,'pt','Dias de fÃ©rias de Max',0),(66993,1861,'ru','ÐœÐ°ÐºÑ Ð”Ð½ÐµÐ¹ ÐžÑ‚Ð¿ÑƒÑÐºÐ°',0),(66994,1861,'es','Max DÃ­as Vacaionales',0),(66995,1861,'de','Max Urlaubstage',0),(66996,1861,'en','Max Vacation Days',0),(66997,1862,'is','',0),(66998,1862,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(66999,1862,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(67000,1862,'tr','Maks Ã¼cret',0),(67001,1862,'pl','Zarobki max',0),(67002,1862,'bg','ÐœÐ°ÐºÑ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(67003,1862,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø§Ø¬Ø±Øª',0),(67004,1862,'sr','ÐœÐ°x Ð¿Ð»Ð°Ñ‚Ðµ',0),(67005,1862,'vi','LÆ°Æ¡ng tá»‘i Ä‘a',0),(67006,1862,'af','Maks. Besoldiging',0),(67007,1862,'ro','Max salariile',0),(67008,1862,'et','Max palk',0),(67009,1862,'si','Max plaÄ',0),(67010,1862,'ba','Max upah',0),(67011,1862,'nl','Max lonen',0),(67012,1862,'fi','Max palkka',0),(67013,1862,'no','Max lÃ¸nn',0),(67014,1862,'da','Max lÃ¸n',0),(67015,1862,'ko','ìµœëŒ€ ìž„ê¸ˆ',0),(67016,1862,'he','×©×›×¨ ×ž×§×¡×™×ž×•×',0),(67017,1862,'el','Max Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(67018,1862,'zh','æœ€é«˜å·¥èµ„\r\n',0),(67019,1862,'sv','Max lÃ¶ner',0),(67020,1862,'it','Max salari',0),(67021,1862,'tl','',0),(67022,1862,'th','&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(67023,1862,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(67024,1862,'ms','Gaji Max',0),(67025,1862,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ù„Ø£Ø¬ÙˆØ±',0),(67026,1862,'fr','Salaire Max',0),(67027,1862,'jp','æœ€å¤§è³ƒé‡‘',0),(67028,1862,'pt','Max salÃ¡rios',0),(67029,1862,'ru','ÐœÐ°ÐºÑ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(67030,1862,'es','Max Sueldos',0),(67031,1862,'de','Max LÃ¶hne',0),(67032,1862,'en','Max Wages',0),(67033,1863,'is','',0),(67034,1863,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù…',0),(67035,1863,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù…',0),(67036,1863,'tr','Maksimum',0),(67037,1863,'pl','Maksymalna',0),(67038,1863,'bg','ÐœÐ°ÐºÑÐ¸Ð¼ÑƒÐ¼',0),(67039,1863,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(67040,1863,'sr','ÐœÐ°ÐºÑÐ¸Ð¼ÑƒÐ¼',0),(67041,1863,'vi','Tá»‘i thiá»ƒu',0),(67042,1863,'af','Maksimum',0),(67043,1863,'ro','Maxim',0),(67044,1863,'et','Maksimum',0),(67045,1863,'si','NajveÄ',0),(67046,1863,'ba','Maksimum',0),(67047,1863,'nl','Maximaal',0),(67048,1863,'fi','EnintÃ¤Ã¤n',0),(67049,1863,'no','Maksimalt',0),(67050,1863,'da','Maksimalt',0),(67051,1863,'ko','ìµœëŒ€',0),(67052,1863,'he','×œ×›×œ ×”×™×•×ª×¨',0),(67053,1863,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î¿',0),(67054,1863,'zh','æœ€å¤§\r\n',0),(67055,1863,'sv','Maximalt',0),(67056,1863,'it','Massimo',0),(67057,1863,'tl','',0),(67058,1863,'th','&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(67059,1863,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤®',0),(67060,1863,'ms','Maksimum',0),(67061,1863,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰',0),(67062,1863,'fr','Maximum',0),(67063,1863,'jp','æœ€å¤§',0),(67064,1863,'pt','MÃ¡ximo',0),(67065,1863,'ru','ÐœÐ°ÐºÑÐ¸Ð¼ÑƒÐ¼',0),(67066,1863,'es','MÃ¡ximo',0),(67067,1863,'de','Maximale',0),(67068,1863,'en','Maximum',0),(67069,1864,'is','',0),(67070,1864,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ  Ø¨Ø±Ø§ÙŠ ÙƒØ³Ø± ÙƒØ±Ø¯Ù† ',0),(67071,1864,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ø§Ù„ÙŠØ§Øª Ø¯ÙˆÙ„ØªÙŠ  Ø¨Ø±Ø§ÙŠ ÙƒØ³Ø± ÙƒØ±Ø¯Ù† ',0),(67072,1864,'tr','DÃ¼ÅŸmek iÃ§in en yÃ¼ksek vergi',0),(67073,1864,'pl','Maksymalna federalnego podatku do odliczenia',0),(67074,1864,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº Ð½Ð° Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(67075,1864,'ur','Ú©Ø§Ù¹Ù†Ø§ Ú©Û’ Ù„Ø¦Û’ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³',0),(67076,1864,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð·Ð° Ð¾Ð´Ð±Ð¸Ñ˜Ð°ÑšÐµ',0),(67077,1864,'vi','Thuáº¿ liÃªn bang tá»‘i Ä‘a Ä‘á»ƒ trá»«',0),(67078,1864,'af','Maksimum federale belasting aftrek',0),(67079,1864,'ro','Maxim impozitului Federal sÄƒ deducÄƒ',0),(67080,1864,'et','Maksimaalne fÃ¶deraalse tulumaksu maha arvata',0),(67081,1864,'si','NajveÄja zvezna davÄne do odbitka',0),(67082,1864,'ba','Maksimum Pajak Federal untuk mengurangi',0),(67083,1864,'nl','Maximale federale belasting op aftrek',0),(67084,1864,'fi','Suurin liittovaltion vero vÃ¤hentÃ¤Ã¤',0),(67085,1864,'no','Maksimal fÃ¸deral skatt trekke',0),(67086,1864,'da','Maksimale fÃ¸derale skat fradrag',0),(67087,1864,'ko','ìµœëŒ€ ì—°ë°© ì„¸ê¸ˆ ê³µì œ',0),(67088,1864,'he','×ž×¨×‘×™×ª ×ž×¡ ×¤×“×¨×œ×™ ×œ× ×›×•×ª',0),(67089,1864,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Î¿Î¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï…, Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(67090,1864,'zh','æœ€é«˜è”é‚¦ç¨Žä¸­æ‰£é™¤\r\n',0),(67091,1864,'sv','HÃ¶gsta Federal skatt att dra av',0),(67092,1864,'it','Fiscale federale massimo alla detrazione',0),(67093,1864,'tl','',0),(67094,1864,'th','&#3616;&#3634;&#3625;&#3637;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3607;&#3637;&#3656;&#3627;&#3633;&#3585;&#3652;&#3604;&#3657;',0),(67095,1864,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¤‚à¤˜à¥€à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤˜à¤Ÿà¤¾',0),(67096,1864,'ms','Cukai Persekutuan yang maksimum untuk memotong',0),(67097,1864,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(67098,1864,'fr','ImpÃ´t fÃ©dÃ©ral maximum Ã  dÃ©duire',0),(67099,1864,'jp','æœ€å¤§é€£é‚¦ç¨ŽæŽ§é™¤',0),(67100,1864,'pt','MÃ¡ximo imposto Federal para deduzir',0),(67101,1864,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð° Ð²Ñ‹Ñ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ',0),(67102,1864,'es','Impuesto Federal MÃ¡ximo para Deducir',0),(67103,1864,'de','Maximale Bundessteuer abziehen',0),(67104,1864,'en','Maximum Federal Tax to Deduct',0),(67105,1865,'is','',0),(67106,1865,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù…  Ø­Ù‚ÙˆÙ‚ Ù†Ø§Ø®Ø§Ù„Øµ Ø¨Ø±Ø§ÙŠ',0),(67107,1865,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù…  Ø­Ù‚ÙˆÙ‚ Ù†Ø§Ø®Ø§Ù„Øµ Ø¨Ø±Ø§ÙŠ',0),(67108,1865,'tr','Maksimum brÃ¼t Ã¶deme iÃ§in',0),(67109,1865,'pl','Maksymalna wynagrodzenia brutto dla',0),(67110,1865,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¾ Ð±Ñ€ÑƒÑ‚Ð½Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð·Ð°',0),(67111,1865,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù…Ø¬Ù…ÙˆØ¹ÛŒ ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ù„Ø¦Û’',0),(67112,1865,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð±Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ Ð·Ð°',0),(67113,1865,'vi','LÆ°Æ¡ng gá»™p tá»‘i Ä‘a cho',0),(67114,1865,'af','Maksimum Bruto Besoldiging vir',0),(67115,1865,'ro','Maxim salariu brut pentru',0),(67116,1865,'et','Maksimaalne brutopalga eest',0),(67117,1865,'si','NajviÅ¡je bruto plaÄe za',0),(67118,1865,'ba','Maksimum membayar bruto',0),(67119,1865,'nl','Maximale bruto loon voor',0),(67120,1865,'fi','Suurin brutto palkka',0),(67121,1865,'no','Maksimal bruttolÃ¸nn for',0),(67122,1865,'da','Maksimale brutto lÃ¸n for',0),(67123,1865,'ko','ì— ëŒ€ í•œ ìµœëŒ€ ì´ ì§€ë¶ˆ',0),(67124,1865,'he','×©×›×¨ ×‘×¨×•×˜×• ×ž×¨×‘×™ ×¢×‘×•×¨',0),(67125,1865,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Î±ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î· Î±Î¼Î¿Î¹Î²Î® Î³Î¹Î±',0),(67126,1865,'zh','æœ€å¤§æ€»æ”¯ä»˜\r\n',0),(67127,1865,'sv','Maximala brutto lÃ¶n fÃ¶r',0),(67128,1865,'it','Retribuzione lorda massima per',0),(67129,1865,'tl','',0),(67130,1865,'th','&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3619;&#3623;&#3617;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(67131,1865,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¤•à¤² à¤µà¥‡à¤¤à¤¨',0),(67132,1865,'ms','Gaji kasar maksimum bagi',0),(67133,1865,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø£Ù‚ØµÙ‰',0),(67134,1865,'fr','RÃ©munÃ©ration brute maximale pour',0),(67135,1865,'jp','ï½žã?®æœ€å¤§çµ¦ä¸Žç·?é¡?',0),(67136,1865,'pt','SalÃ¡rio bruto mÃ¡ximo para',0),(67137,1865,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð±Ñ€ÑƒÑ‚Ñ‚Ð¾ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð·Ð°',0),(67138,1865,'es','Sueldo Bruto MÃ¡ximo por',0),(67139,1865,'de','Maximale Bruttogehalt fÃ¼r',0),(67140,1865,'en','Maximum Gross Pay for',0),(67141,1866,'is','',0),(67142,1866,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù…  Ø­Ù‚ÙˆÙ‚ Ø³Ø§Ø¹ØªÙŠ Ø¨Ø±Ø§ÙŠ',0),(67143,1866,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù…  Ø­Ù‚ÙˆÙ‚ Ø³Ø§Ø¹ØªÙŠ Ø¨Ø±Ø§ÙŠ',0),(67144,1866,'tr','Maksimum Ã¶deme/saat',0),(67145,1866,'pl','Maksymalne wynagrodzenie na godzinÄ™ dla',0),(67146,1866,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¾Ñ‚Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ/Ñ‡Ð°Ñ Ð·Ð°',0),(67147,1866,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ØªÙ†Ø®ÙˆØ§Û/Ú¯Ú¾Ù†Ù¹Û’ Ú©Û’ Ù„Ø¦Û’',0),(67148,1866,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð¿Ð»Ð°Ñ‚Ðµ/ÑÐ°Ñ‚ Ð·Ð°',0),(67149,1866,'vi','LÆ°Æ¡ng tá»‘i Ä‘a/Giá» cho',0),(67150,1866,'af','Maksimum Besoldiging/Uur vir',0),(67151,1866,'ro','Plata/ora maximÄƒ pentru',0),(67152,1866,'et','Maksimaalne tasu/Hour',0),(67153,1866,'si','NajveÄje plaÄilo/uro za',0),(67154,1866,'ba','Bayar/jam maksimal untuk',0),(67155,1866,'nl','Maximale beloning/uur voor',0),(67156,1866,'fi','Suurin maksu/tunti',0),(67157,1866,'no','Maksimal lÃ¸nn/time for',0),(67158,1866,'da','Maksimal lÃ¸n/time for',0),(67159,1866,'ko','ì— ëŒ€ í•œ ìµœëŒ€ ì§€ë¶ˆ/ì‹œê°„',0),(67160,1866,'he','×”×©×›×¨ ×œ×©×¢×” ×”×ž×¨×‘×™ ×¢×‘×•×¨',0),(67161,1866,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Ï€Î»Î·ÏÏ‰Î¼Î®/ÏŽÏÎ±',0),(67162,1866,'zh','é¡¶è–ª/å°æ—¶\r\n',0),(67163,1866,'sv','HÃ¶gsta lÃ¶n/timme fÃ¶r',0),(67164,1866,'it','Pay/ora max per',0),(67165,1866,'tl','',0),(67166,1866,'th','&#3592;&#3656;&#3634;&#3618;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(67167,1866,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤­à¥à¤—à¤¤à¤¾à¤¨/à¤˜à¤‚à¤Ÿà¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(67168,1866,'ms','Gaji/jam maksimum bagi',0),(67169,1866,'ar','Ø§Ù„Ø£Ø¬Ø±/Ø³Ø§Ø¹Ø© ÙƒØ­Ø¯ Ø£Ù‚ØµÙ‰',0),(67170,1866,'fr','RÃ©munÃ©ration/heure maximum pour',0),(67171,1866,'jp','ï½žã?®æœ€å¤§æ™‚çµ¦',0),(67172,1866,'pt','SalÃ¡rio/hora mÃ¡xima para',0),(67173,1866,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð² Ñ‡Ð°Ñ Ð´Ð»Ñ',0),(67174,1866,'es','MÃ¡ximo Sueldo/Hora por',0),(67175,1866,'de','Maximale VergÃ¼tung pro Stunde fÃ¼r',0),(67176,1866,'en','Maximum Pay/Hour for',0),(67177,1867,'is','',0),(67178,1867,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø¯Ø±ØµØ¯ ØªØ·Ø¨ÙŠÙ‚ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ÙƒØ§Ø±ÙØ±Ù…Ø§',0),(67179,1867,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø¯Ø±ØµØ¯ ØªØ·Ø¨ÙŠÙ‚ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ÙƒØ§Ø±ÙØ±Ù…Ø§',0),(67180,1867,'tr','En fazla % iÅŸveren tarafÄ±ndan bahisler',0),(67181,1867,'pl','Maksymalny % dopasowane przez pracodawcÄ™',0),(67182,1867,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ %, ÑÑŠÐ¿Ñ€Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð¾Ñ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»',0),(67183,1867,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û % Ø¢Ø¬Ø± Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ø´Ø§Ø¨Û',0),(67184,1867,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¸ % Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð° Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð¸Ð½Ð²ÐµÑÑ‚Ð¸Ñ‚Ð¾Ñ€Ð°',0),(67185,1867,'vi','% tá»‘i Ä‘a chá»§ doanh nghiá»‡p pháº£i bÃ¹ tÆ°Æ¡ng á»©ng vá»›i nhÃ¢n viÃªn',0),(67186,1867,'af','Maksimum % gelyke deur werkgewer',0),(67187,1867,'ro','Maxim % egalatÄƒ de angajatorului',0),(67188,1867,'et','Maksimaalne % vastanud tÃ¶Ã¶andja',0),(67189,1867,'si','NajveÄ % pokrite z delodajalcem',0),(67190,1867,'ba','Maksimum % dicocokkan oleh majikan',0),(67191,1867,'nl','Maximale % geÃ«venaard door werkgever',0),(67192,1867,'fi','EnintÃ¤Ã¤n % hyvÃ¤ksytty tyÃ¶nantaja',0),(67193,1867,'no','Maksimum % matchet av arbeidsgiver',0),(67194,1867,'da','Maksimale % modsvares af arbejdsgiver',0),(67195,1867,'ko','ê³ ìš©ì£¼ì— ì˜í•´ ì¼ì¹˜ í•˜ëŠ” ìµœëŒ€ %',0),(67196,1867,'he','×ž×§×¡×™×ž×•× % ×ž×ª××™×ž×™× ×¢×œ ×™×“×™ ×”×ž×¢×¡×™×§',0),(67197,1867,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· % ÏƒÏ…Î½Î¿Î´ÎµÏÎ¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ ÎµÏÎ³Î¿Î´ÏŒÏ„Î·',0),(67198,1867,'zh','æœ€å¤šï¼…ç”±é›‡ä¸»åŒ¹é…\r\n',0),(67199,1867,'sv','HÃ¶gst % matchas av arbetsgivare',0),(67200,1867,'it','% Massimo rilevate dal datore di lavoro',0),(67201,1867,'tl','',0),(67202,1867,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3607;&#3637;&#3656;&#3648;&#3586;&#3657;&#3634;&#3585;&#3633;&#3610;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(67203,1867,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® % à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤®à¤¿à¤²à¤¾à¤¨',0),(67204,1867,'ms','% Maksimum yang dipadankan oleh majikan',0),(67205,1867,'ar','ÙŠÙ‚Ø§Ø¨Ù„ Ø±Ø¨ Ø§Ù„Ø¹Ù…Ù„ % ÙƒØ­Ø¯ Ø£Ù‚ØµÙ‰',0),(67206,1867,'fr','% Maximum mis en correspondance par l\'employeur',0),(67207,1867,'jp','å¾“æ¥­å“¡åˆ¥é?©å?ˆæœ€å¤§æ¯”çŽ‡',0),(67208,1867,'pt','MÃ¡ximo % correspondido pelo empregador',0),(67209,1867,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ñ‹Ð¹ % Ð¿Ð¾Ð´ÐºÑ€ÐµÐ¿Ð»ÐµÐ½Ñ‹ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»Ñ',0),(67210,1867,'es','MÃ¡ximo % emparejado por el patrÃ³n',0),(67211,1867,'de','Maximale % durch Arbeitgeber',0),(67212,1867,'en','Maximum % matched by employer',0),(67213,1868,'is','',0),(67214,1868,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± ØµØ¯ÙˆØ±',0),(67215,1868,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± ØµØ¯ÙˆØ±',0),(67216,1868,'tr','En Ã§ok qty.per pass',0),(67217,1868,'pl','Przebiegu maksymalne qty.per',0),(67218,1868,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° qty.per Ð¿Ñ€Ð¾Ñ…Ð¾Ð´',0),(67219,1868,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û qty.per Ú©Û’ Ù¾Ø§Ø³',0),(67220,1868,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° qÑ‚y.Ð¿ÐµÑ€ Ð¿Ñ€Ð¾Ð»Ð°Ð·',0),(67221,1868,'vi','Sá»‘ lÆ°á»£ng tá»‘i Ä‘a má»—i tháº»',0),(67222,1868,'af','Maksimum qty.per pass',0),(67223,1868,'ro','Maxim qty.per pass',0),(67224,1868,'et','Maksimaalne qty.per pass',0),(67225,1868,'si','NajveÄja qty.per pass',0),(67226,1868,'ba','Maksimum qty.per pass',0),(67227,1868,'nl','Maximale qty.per pass',0),(67228,1868,'fi','Suurin qty.per pass',0),(67229,1868,'no','Maksimal qty.per pass',0),(67230,1868,'da','Maksimal qty.per pass',0),(67231,1868,'ko','ìµœëŒ€ qty.per íŒ¨ìŠ¤',0),(67232,1868,'he','Qty.per ×ž×¨×‘×™ ×œ×¢×‘×•×¨',0),(67233,1868,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· qty.per Ï€Î­ÏÎ±ÏƒÎ¼Î±',0),(67234,1868,'zh','æ¯æ¬¡é€šè¿‡çš„æœ€å¤§æ•°é‡\r\n',0),(67235,1868,'sv','Maximal qty.per pass',0),(67236,1868,'it','Massimo qty.per pass',0),(67237,1868,'tl','',0),(67238,1868,'th','&#3588;&#3640;&#3603;&#3616;&#3634;&#3614;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;',0),(67239,1868,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® qty.per à¤¦à¤°à¥à¤°à¤¾',0),(67240,1868,'ms','Pas qty.per maksimum',0),(67241,1868,'ar','ØªÙ…Ø±ÙŠØ± Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ qty.per',0),(67242,1868,'fr','Maximale qty.per pass',0),(67243,1868,'jp','ãƒ‘ã‚¹ã?”ã?¨ã?®æœ€å¤§æ•°é‡?',0),(67244,1868,'pt','MÃ¡ximo qty.per pass',0),(67245,1868,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ qty.per Ð¿ÐµÑ€ÐµÐ²Ð°Ð»',0),(67246,1868,'es','MÃ¡xima cant. por paso',0),(67247,1868,'de','Maximale qty.per pass',0),(67248,1868,'en','Maximum qty.per pass',0),(67249,1869,'is','',0),(67250,1869,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰ Ù…Ø¬Ø§Ø² Ø¬Ù‡Øª Ø§Ù†Ø¨Ø§Ø´ØªÙ‡ Ø´Ø¯Ù† ',0),(67251,1869,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰ Ù…Ø¬Ø§Ø² Ø¬Ù‡Øª Ø§Ù†Ø¨Ø§Ø´ØªÙ‡ Ø´Ø¯Ù† ',0),(67252,1869,'tr','Tahakkuk izin verilen en fazla hastalÄ±k izni',0),(67253,1869,'pl','Maksymalna chorobowe mogÄ… przypaÅ›Ä‡',0),(67254,1869,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð¾Ñ‚Ð¿ÑƒÑÐº Ð¿Ð¾ Ð±Ð¾Ð»ÐµÑÑ‚ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° ÑÐµ Ð½Ð°Ñ‚Ñ€ÑƒÐ¿Ð²Ð°Ñ‚',0),(67255,1869,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø¨ÛŒÙ…Ø§Ø± Ú†Ú¾ÙˆÚ‘ÛŒÚº Ø§Ù¹Ú¾Ù†Ø§ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(67256,1869,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð±Ð¾Ð»Ð¾Ð²Ð°ÑšÐµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾ Ð´Ð° Ð¾ÑÑ‚Ð²Ð°Ñ€ÑƒÑ˜ÐµÑ‚Ðµ',0),(67257,1869,'vi','Giá» nghá»‰ bá»‡nh tá»‘i Ä‘a Ä‘Æ°á»£c cá»™ng dá»“n',0),(67258,1869,'af','Maksimum Siekverlof toegelaat vir ophoping',0),(67259,1869,'ro','Concediu medical maxim permis pentru a acumula',0),(67260,1869,'et','Maksimaalne lubatud lisanduma haiguslehel',0),(67261,1869,'si','NajviÅ¡ji bolniÅ¡ki dopust, dovoljena nastajale',0),(67262,1869,'ba','Cuti sakit maksimum yang diperbolehkan untuk bertambah',0),(67263,1869,'nl','Maximale ziekteverlof mag toenemen',0),(67264,1869,'fi','Suurin Sairausloma voi kertyÃ¤',0),(67265,1869,'no','Maksimal sykefravÃ¦r lov til Ã¥ akkumulere',0),(67266,1869,'da','Maksimale sygeorlov lov til at opsamle',0),(67267,1869,'ko','ë°œìƒì„ í—ˆìš© í•˜ëŠ” ìµœëŒ€ ë³‘ê°€',0),(67268,1869,'he','×ž×—×œ×” ×ž×¨×‘×™ ×ž×•×ª×¨ ×¦×‘×•×¨',0),(67269,1869,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Î±Î½Î±ÏÏÏ‰Ï„Î¹ÎºÎ® Î¬Î´ÎµÎ¹Î±, Ï„Î· Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„Î± Î½Î± Ï„ÏÎ­Ï‡Î¿Ï…Î½',0),(67270,1869,'zh','å…è®¸çš„æœ€å¤§ç—…å‡ç´¯è®¡\r\n',0),(67271,1869,'sv','HÃ¶gsta sjukfrÃ¥nvaro tillÃ¥tet att Periodisera',0),(67272,1869,'it','Assenze massime consentite a maturare',0),(67273,1869,'tl','',0),(67274,1869,'th','&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3621;&#3634;&#3611;&#3656;&#3623;&#3618;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3607;&#3637;&#3656;&#3618;&#3636;&#3609;&#3618;&#3629;&#3617;&#3651;&#3627;&#3657;&#3626;&#3632;&#3626;&#3',0),(67275,1869,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¬à¥€à¤®à¤¾à¤° à¤›à¥à¤Ÿà¥à¤Ÿà¥€ à¤®à¤¿à¤²à¤¨à¥‡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(67276,1869,'ms','Maksimum cuti sakit yang dibenarkan untuk terakru',0),(67277,1869,'ar','Ø§Ù„Ø¥Ø¬Ø§Ø²Ø© Ø§Ù„Ù…Ø±Ø¶ÙŠØ© Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡ Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(67278,1869,'fr','Maximale des congÃ©s de maladie a permis d\'accumuler des',0),(67279,1869,'jp','æœ€å¤§ç™ºç”Ÿå?¯èƒ½æœ‰çµ¦ä¼‘æš‡',0),(67280,1869,'pt','Afastamento mÃ¡ximo permitido acumular',0),(67281,1869,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¾Ñ‚Ð¿ÑƒÑÐº Ð¿Ð¾ Ð±Ð¾Ð»ÐµÐ·Ð½Ð¸, Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾ Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÑ‚ÑŒ',0),(67282,1869,'es','MÃ¡xima Ausencia por Enfermedad permitido acumular',0),(67283,1869,'de','Maximale Krankheitstage anfallen dÃ¼rfen',0),(67284,1869,'en','Maximum Sick Leave allowed to accrue',0),(67285,1870,'is','',0),(67286,1870,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯Ø±Ø³Øª Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø±',0),(67287,1870,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯Ø±Ø³Øª Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø±',0),(67288,1870,'tr','KullanÄ±cÄ± tarafÄ±ndan en fazla geÃ§erli giriÅŸ',0),(67289,1870,'pl','Maksymalna prawidÅ‚owy wpis przez uÅ¼ytkownika',0),(67290,1870,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð·Ð°Ð¿Ð¸Ñ Ð¾Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(67291,1870,'ur','ØµØ§Ø±Ù Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø¬Ø§Ø¦Ø² Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(67292,1870,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð¸ÑÐ¿Ñ€Ð°Ð²Ð°Ð½ ÑƒÐ½Ð¾Ñ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(67293,1870,'vi','Má»©c Entry há»¯u hiá»‡u tá»‘i Ä‘a cho user',0),(67294,1870,'af','Maksimale toelaatbare inskrywing deur gebruiker',0),(67295,1870,'ro','Maxima intrare validÄƒ de utilizator',0),(67296,1870,'et','Maksimaalne kehtiv kasutaja',0),(67297,1870,'si','NajveÄja veljaven vnos uporabnika',0),(67298,1870,'ba','Maksimum entri yang sah oleh pengguna',0),(67299,1870,'nl','Maximale geldige vermelding door gebruiker',0),(67300,1870,'fi','Suurin kelpaa kÃ¤yttÃ¤jÃ¤',0),(67301,1870,'no','Maksimal gyldig oppfÃ¸ring av bruker',0),(67302,1870,'da','Maksimal lovlig indrejse af bruger',0),(67303,1870,'ko','ì‚¬ìš©ìžê°€ ìµœëŒ€ ìœ íš¨í•œ í•­ëª©',0),(67304,1870,'he','×ž×¨×‘×™×ª ×—×•×§×™ ×›× ×™×¡×” ×¢×œ-×™×“×™ ×”×ž×©×ª×ž×©',0),(67305,1870,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Î­Î³ÎºÏ…ÏÎ· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î±Ï€ÏŒ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(67306,1870,'zh','ç”¨æˆ·è¾“å…¥æœ€é•¿æœ‰æ•ˆæœŸ\r\n',0),(67307,1870,'sv','Maximala giltig post av anvÃ¤ndare',0),(67308,1870,'it','Massima voce valida dall\'utente',0),(67309,1870,'tl','',0),(67310,1870,'th','&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3605;&#3634;&#3617;&#3585;&#3599;&#3627;&#3617;&#3634;&#3618;&#3650;&#3604;&#3',0),(67311,1870,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤®à¤¾à¤¨à¥à¤¯ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(67312,1870,'ms','Maksimum penyertaan sah oleh pengguna',0),(67313,1870,'ar','Ø¯Ø®ÙˆÙ„ ØµØ§Ù„Ø­Ø© ÙƒØ­Ø¯ Ø£Ù‚ØµÙ‰ Ø­Ø³Ø¨ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(67314,1870,'fr','EntrÃ©e valide maximale par utilisateur',0),(67315,1870,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?«ã‚ˆã‚‹æœ€å¤§æœ‰åŠ¹ã‚¨ãƒ³ãƒˆãƒªãƒ¼',0),(67316,1870,'pt','MÃ¡xima entrada vÃ¡lida por usuÃ¡rio',0),(67317,1870,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¼',0),(67318,1870,'es','MÃ¡xima entrada vÃ¡lida por usuario',0),(67319,1870,'de','Maximale gÃ¼ltigen EintrÃ¤ge durch Benutzer',0),(67320,1870,'en','Maximum valid entry by user',0),(67321,1871,'is','',0),(67322,1871,'dr','Ù…ÙŠ ',0),(67323,1871,'pr','Ù…ÙŠ ',0),(67324,1871,'tr','MayÄ±s',0),(67325,1871,'pl','MoÅ¼e',0),(67326,1871,'bg','ÐœÐ°Ð¹',0),(67327,1871,'ur','Ù…Ø¦ÛŒ',0),(67328,1871,'sr','ÐœÐ°Ñ˜Ð°',0),(67329,1871,'vi','ThÃ¡ng NÄƒm',0),(67330,1871,'af','Mei',0),(67331,1871,'ro','Poate',0),(67332,1871,'et','VÃµib',0),(67333,1871,'si','Maja',0),(67334,1871,'ba','Mungkin',0),(67335,1871,'nl','Mei',0),(67336,1871,'fi','Voi',0),(67337,1871,'no','Mai',0),(67338,1871,'da','Maj',0),(67339,1871,'ko','5 ì›”',0),(67340,1871,'he','×ž××™',0),(67341,1871,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î½Î±',0),(67342,1871,'zh','äº”æœˆ\r\n',0),(67343,1871,'sv','Kan',0),(67344,1871,'it','Maggio',0),(67345,1871,'tl','',0),(67346,1871,'th','&#3614;&#3620;&#3625;&#3616;&#3634;&#3588;&#3617;',0),(67347,1871,'hi','à¤®à¤ˆ',0),(67348,1871,'ms','Mungkin',0),(67349,1871,'ar','Ù…Ø§ÙŠÙˆ',0),(67350,1871,'fr','Mai',0),(67351,1871,'jp','5æœˆ',0),(67352,1871,'pt','Maio',0),(67353,1871,'ru','ÐœÐ°Ñ',0),(67354,1871,'es','Mayo',0),(67355,1871,'de','Mai',0),(67356,1871,'en','May',0),(67357,1872,'is','',0),(67358,1872,'dr','Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰',0),(67359,1872,'pr','Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰',0),(67360,1872,'tr','Medicare',0),(67361,1872,'pl','Medicare',0),(67362,1872,'bg','Medicare',0),(67363,1872,'ur','Ù…ÛŒÚˆÛŒ',0),(67364,1872,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚',0),(67365,1872,'vi','ChÄƒm sÃ³c Y táº¿',0),(67366,1872,'af','Medicare',0),(67367,1872,'ro','Medicare',0),(67368,1872,'et','Medicare',0),(67369,1872,'si','Medicare',0),(67370,1872,'ba','Medicare',0),(67371,1872,'nl','Medicare',0),(67372,1872,'fi','Medicare',0),(67373,1872,'no','Medicare',0),(67374,1872,'da','Medicare',0),(67375,1872,'ko','ë©”ë””ì¼€ì–´',0),(67376,1872,'he','×ž×“×™×§×¨',0),(67377,1872,'el','Medicare',0),(67378,1872,'zh','åŒ»ç–—ä¿é™©\r\n',0),(67379,1872,'sv','Medicare',0),(67380,1872,'it','Medicare',0),(67381,1872,'tl','',0),(67382,1872,'th','&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;',0),(67383,1872,'hi','à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤°',0),(67384,1872,'ms','Medicare',0),(67385,1872,'ar','Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(67386,1872,'fr','Assurance-maladie',0),(67387,1872,'jp','åŒ»ç™‚ä¿?é™º',0),(67388,1872,'pt','Medicare',0),(67389,1872,'ru','Medicare',0),(67390,1872,'es','Medicare',0),(67391,1872,'de','Medicare',0),(67392,1872,'en','Medicare',0),(67393,1873,'is','',0),(67394,1873,'dr','ÙƒØ§Ù‡Ø´ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰',0),(67395,1873,'pr','ÙƒØ§Ù‡Ø´ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰',0),(67396,1873,'tr','Medicare kesinti',0),(67397,1873,'pl','Medicare odliczenia',0),(67398,1873,'bg','Medicare Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(67399,1873,'ur','Ù…ÛŒÚˆÛŒ Ù…Ù†ÛØ§Ø¦ÛŒ',0),(67400,1873,'sr','Ð—Ð°ÐºÑ™ÑƒÑ‡Ð°Ðº Ñƒ Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚',0),(67401,1873,'vi','Giáº£m trá»« chÄƒm sÃ³c y táº¿',0),(67402,1873,'af','Medicare aftrekking',0),(67403,1873,'ro','Medicare deducerea',0),(67404,1873,'et','Medicare mahaarvamine',0),(67405,1873,'si','Medicare odbitek',0),(67406,1873,'ba','Pemotongan Medicare',0),(67407,1873,'nl','Medicare aftrek',0),(67408,1873,'fi','Medicare vÃ¤hennys',0),(67409,1873,'no','Medicare fradrag',0),(67410,1873,'da','Medicare fradrag',0),(67411,1873,'ko','ë©”ë””ì¼€ì–´ ê³µì œ',0),(67412,1873,'he','× ×™×›×•×™ ×ž×“×™×§×¨',0),(67413,1873,'el','Medicare Î±Ï†Î±Î¯ÏÎµÏƒÎ·',0),(67414,1873,'zh','æ‰£é™¤åŒ»ç–—ä¿é™©\r\n',0),(67415,1873,'sv','Medicare avdrag',0),(67416,1873,'it','Deduzione di Medicare',0),(67417,1873,'tl','',0),(67418,1873,'th','&#3627;&#3633;&#3585;&#3588;&#3656;&#3634;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;',0),(67419,1873,'hi','à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤° à¤•à¤Ÿà¥Œà¤¤à¥€',0),(67420,1873,'ms','Potongan Medicare',0),(67421,1873,'ar','Ø®ØµÙ… Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(67422,1873,'fr','DÃ©duction de l\'assurance-maladie',0),(67423,1873,'jp','åŒ»ç™‚ä¿?é™ºæŽ§é™¤',0),(67424,1873,'pt','DeduÃ§Ã£o de Medicare',0),(67425,1873,'ru','Medicare Ð²Ñ‹Ñ‡ÐµÑ‚',0),(67426,1873,'es','DeducciÃ³n de Medicare',0),(67427,1873,'de','Medicare-Abzug',0),(67428,1873,'en','Medicare Deduction',0),(67429,1874,'is','',0),(67430,1874,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰',0),(67431,1874,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰',0),(67432,1874,'tr','Medicare gider',0),(67433,1874,'pl','Medicare kosztem',0),(67434,1874,'bg','ÐœÐµÐ´Ð¸Ñ†Ð¸Ð½ÑÐºÐ¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(67435,1874,'ur','Ù…ÛŒÚˆÛŒ Ø®Ø±Ú†Û’',0),(67436,1874,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð°',0),(67437,1874,'vi','Chi phÃ­ chÄƒm sÃ³c y táº¿',0),(67438,1874,'af','Medicare uitgawe',0),(67439,1874,'ro','Medicare cheltuieli',0),(67440,1874,'et','Medicare kulutusi',0),(67441,1874,'si','Medicare stroÅ¡ke',0),(67442,1874,'ba','Medicare biaya',0),(67443,1874,'nl','Medicare kosten',0),(67444,1874,'fi','Medicare kustannuksia',0),(67445,1874,'no','Medicare regning',0),(67446,1874,'da','Medicare udgift',0),(67447,1874,'ko','ë©”ë””ì¼€ì–´ ë¹„ìš©',0),(67448,1874,'he','×”×•×¦××•×ª ×ž×“×™×§×¨',0),(67449,1874,'el','Medicare Î´Î±Ï€Î¬Î½Î·',0),(67450,1874,'zh','åŒ»ç–—è´¹ç”¨\r\n',0),(67451,1874,'sv','Medicare bekostnad',0),(67452,1874,'it','Spese di assistenza sanitaria statale',0),(67453,1874,'tl','',0),(67454,1874,'th','&#3588;&#3656;&#3634;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;',0),(67455,1874,'hi','à¤šà¤¿à¤•à¤¿à¤¤à¥à¤¸à¤¾ à¤µà¥à¤¯à¤¯',0),(67456,1874,'ms','Perbelanjaan Medicare',0),(67457,1874,'ar','Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(67458,1874,'fr','DÃ©penses de l\'assurance-maladie',0),(67459,1874,'jp','åŒ»ç™‚ä¿?é™ºè²»ç”¨',0),(67460,1874,'pt','Despesa de Medicare',0),(67461,1874,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ ÐœÐµÐ´Ð¸ÐºÑÑ€',0),(67462,1874,'es','Gasto de Medicare',0),(67463,1874,'de','Medicare-Kosten',0),(67464,1874,'en','Medicare Expense',0),(67465,1875,'is','',0),(67466,1875,'dr','Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(67467,1875,'pr','Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(67468,1875,'tr','Medicare Ã¶denecek',0),(67469,1875,'pl','Medicare pÅ‚atne',0),(67470,1875,'bg','Medicare Ð¿Ð»Ð°Ñ‚Ð¸Ð¼Ð¸',0),(67471,1875,'ur','Ù…ÛŒÚˆÛŒ Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(67472,1875,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(67473,1875,'vi','Dá»‹ch Vá»¥ Y Táº¿ Pháº£i Tráº£',0),(67474,1875,'af','Medicare betaalbaar',0),(67475,1875,'ro','Medicare de plÄƒtit',0),(67476,1875,'et','Medicare makstav',0),(67477,1875,'si','Medicare plaÄljive',0),(67478,1875,'ba','Medicare hutang',0),(67479,1875,'nl','Medicare te betalen',0),(67480,1875,'fi','Medicare maksettava',0),(67481,1875,'no','Medicare betales',0),(67482,1875,'da','Medicare betales',0),(67483,1875,'ko','ë©”ë””ì¼€ì–´ ì§€ê¸‰',0),(67484,1875,'he','Medicare ×–×›××™×',0),(67485,1875,'el','Medicare Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹',0),(67486,1875,'zh','åº”ä»˜åŒ»ç–—ä¿é™©\r\n',0),(67487,1875,'sv','Medicare betalas',0),(67488,1875,'it','Medicare pagabile',0),(67489,1875,'tl','',0),(67490,1875,'th','&#3588;&#3656;&#3634;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;&#3588;&#3657;&#3634;&#3591;&#3592;&#3656;&#3634;&#3618;',0),(67491,1875,'hi','à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤° à¤¦à¥‡à¤¯',0),(67492,1875,'ms','Medicare yang perlu dibayar',0),(67493,1875,'ar','Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ© Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(67494,1875,'fr','Assurance-santÃ© Ã  payer',0),(67495,1875,'jp','åŒ»ç™‚ä¿?é™ºè²·æŽ›é‡‘',0),(67496,1875,'pt','PagÃ¡vel de Medicare',0),(67497,1875,'ru','Medicare Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ',0),(67498,1875,'es','Medicare Pagable',0),(67499,1875,'de','Medicare Verbindlichkeit',0),(67500,1875,'en','Medicare Payable',0),(67501,1876,'is','',0),(67502,1876,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰',0),(67503,1876,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰',0),(67504,1876,'tr','Medicare Ã¼cret',0),(67505,1876,'pl','Medicare pÅ‚ace',0),(67506,1876,'bg','Medicare Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(67507,1876,'ur','Ù…ÛŒÚˆÛŒ Ø§Ø¬Ø±Øª',0),(67508,1876,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ð¿Ð»Ð°Ñ‚Ðµ',0),(67509,1876,'vi','LÆ°Æ¡ng chÄƒm sÃ³c y táº¿',0),(67510,1876,'af','Medicare lone',0),(67511,1876,'ro','Medicare salariile',0),(67512,1876,'et','Medicare palk',0),(67513,1876,'si','Medicare plaÄe',0),(67514,1876,'ba','Medicare upah',0),(67515,1876,'nl','Medicare lonen',0),(67516,1876,'fi','Medicare palkat',0),(67517,1876,'no','Medicare lÃ¸nn',0),(67518,1876,'da','Medicare lÃ¸n',0),(67519,1876,'ko','ë©”ë””ì¼€ì–´ ìž„ê¸ˆ',0),(67520,1876,'he','Medicare ×©×›×¨',0),(67521,1876,'el','Medicare Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(67522,1876,'zh','åŒ»ç–—ä¿é™©å·¥èµ„\r\n',0),(67523,1876,'sv','Medicare lÃ¶ner',0),(67524,1876,'it','Medicare salari',0),(67525,1876,'tl','',0),(67526,1876,'th','&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;',0),(67527,1876,'hi','à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤° à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(67528,1876,'ms','Upah Medicare',0),(67529,1876,'ar','Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ© Ù„Ù„Ø£Ø¬ÙˆØ±',0),(67530,1876,'fr','Cotisations assurance maladie',0),(67531,1876,'jp','åŒ»ç™‚ä¿?é™ºè³ƒé‡‘',0),(67532,1876,'pt','SalÃ¡rios de Medicare',0),(67533,1876,'ru','Medicare Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(67534,1876,'es','Sueldos de Medicare',0),(67535,1876,'de','Medicare-LÃ¶hne',0),(67536,1876,'en','Medicare Wages',0),(67537,1877,'is','',0),(67538,1877,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³Ø§Ø¹ØªÙŠ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰\r\n WH',0),(67539,1877,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³Ø§Ø¹ØªÙŠ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰\r\n WH',0),(67540,1877,'tr','Medicare WH',0),(67541,1877,'pl','Medicare WH',0),(67542,1877,'bg','Medicare WH',0),(67543,1877,'ur','Ù…ÛŒÚˆÛŒ ÙˆÛ',0),(67544,1877,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ð¨Ð¢',0),(67545,1877,'vi','ChÄƒm sÃ³c y táº¿ giá»¯ láº¡i',0),(67546,1877,'af','Medicare WH',0),(67547,1877,'ro','Medicare WH',0),(67548,1877,'et','Medicare WH',0),(67549,1877,'si','Medicare WH',0),(67550,1877,'ba','Medicare WH',0),(67551,1877,'nl','Medicare WH',0),(67552,1877,'fi','Medicare WH',0),(67553,1877,'no','Medicare WH',0),(67554,1877,'da','Medicare WH',0),(67555,1877,'ko','ë©”ë””ì¼€ì–´ WH',0),(67556,1877,'he','Medicare WH',0),(67557,1877,'el','Medicare WH',0),(67558,1877,'zh','Medicare WH å…»è€ä¿é™©\r\n',0),(67559,1877,'sv','Medicare WH',0),(67560,1877,'it','Medicare WH',0),(67561,1877,'tl','',0),(67562,1877,'th','&#3649;&#3612;&#3609;&#3626;&#3640;&#3586;&#3616;&#3634;&#3614; WH',0),(67563,1877,'hi','à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤° WH',0),(67564,1877,'ms','Medicare Diberik',0),(67565,1877,'ar','Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ© Ø°ÙˆÙŠ Ø§Ù„Ø®ÙˆØ°Ø§Øª Ø§Ù„Ø¨ÙŠØ¶Ø§Ø¡',0),(67566,1877,'fr','Medicare WH',0),(67567,1877,'jp','åŒ»ç™‚ä¿?é™ºãƒ¯ãƒƒãƒˆã‚¢ãƒ¯ãƒ¼',0),(67568,1877,'pt','Medicare WH',0),(67569,1877,'ru','Medicare WH',0),(67570,1877,'es','Ret. de Medicare',0),(67571,1877,'de','Medicare WH',0),(67572,1877,'en','Medicare WH',0),(67573,1878,'is','',0),(67574,1878,'dr','Ø±Ù†Ú¯ Ù†ÙˆØ§Ø± Ù…Ù†Ùˆ ',0),(67575,1878,'pr','Ø±Ù†Ú¯ Ù†ÙˆØ§Ø± Ù…Ù†Ùˆ ',0),(67576,1878,'tr','MenÃ¼ Ã§ubuÄŸunun rengi',0),(67577,1878,'pl','Kolor paska menu',0),(67578,1878,'bg','Ð¦Ð²ÑÑ‚ Ð½Ð° Ð»ÐµÐ½Ñ‚Ð° Ñ Ð¼ÐµÐ½ÑŽÑ‚Ð°',0),(67579,1878,'ur','Ù…ÛŒÙ†ÛŒÙˆ Ø¨Ø§Ø± Ø±Ù†Ú¯',0),(67580,1878,'sr','Ð¢Ñ€Ð°ÐºÐ° ÑÐ° Ð¼ÐµÐ½Ð¸Ñ˜Ð¸Ð¼Ð° Ð±Ð¾Ñ˜Ð°',0),(67581,1878,'vi','MÃ u thanh trÃ¬nh Ä‘Æ¡n',0),(67582,1878,'af','Kieslysbalk kleur',0),(67583,1878,'ro','Meniul culoare',0),(67584,1878,'et','MenÃ¼Ã¼ vÃ¤rv',0),(67585,1878,'si','Jedilnik zasova barva',0),(67586,1878,'ba','Menu Bar warna',0),(67587,1878,'nl','Menubalk kleur',0),(67588,1878,'fi','Valikkorivin vÃ¤ri',0),(67589,1878,'no','Menylinjen farge',0),(67590,1878,'da','Menulinjen farve',0),(67591,1878,'ko','ë©”ë‰´ í‘œì‹œì¤„ ìƒ‰',0),(67592,1878,'he','×¦×‘×¢ ×”×ª×¤×¨×™×˜×™×',0),(67593,1878,'el','Î“ÏÎ±Î¼Î¼Î® Î¼ÎµÎ½Î¿Ï Ï‡ÏÏŽÎ¼Î±',0),(67594,1878,'zh','èœå•æ é¢œè‰²\r\n',0),(67595,1878,'sv','Menyraden fÃ¤rg',0),(67596,1878,'it','Colore della barra di menu',0),(67597,1878,'tl','',0),(67598,1878,'th','&#3626;&#3637;&#3648;&#3617;&#3609;&#3641;',0),(67599,1878,'hi','à¤®à¥‡à¤¨à¥‚ à¤ªà¤Ÿà¥à¤Ÿà¥€ à¤°à¤‚à¤—',0),(67600,1878,'ms','Warna Menu Bar',0),(67601,1878,'ar','Ù„ÙˆÙ† Ø´Ø±ÙŠØ· Ø§Ù„Ù‚ÙˆØ§Ø¦Ù…',0),(67602,1878,'fr','Couleur de la barre de menu',0),(67603,1878,'jp','ãƒ¡ãƒ‹ãƒ¥ãƒ¼ãƒ?ãƒ¼ã‚«ãƒ©ãƒ¼',0),(67604,1878,'pt','Cor da barra de menu',0),(67605,1878,'ru','Ð¦Ð²ÐµÑ‚ ÐœÐµÐ½ÑŽ',0),(67606,1878,'es','MenÃº Color de Barra',0),(67607,1878,'de','MenÃ¼leiste Farbe',0),(67608,1878,'en','Menu Bar Color',0),(67609,1879,'is','',0),(67610,1879,'dr','ÙƒØ±ÙŠØ³Ù…Ø³ Ù…Ø¨Ø§Ø±Ùƒ ',0),(67611,1879,'pr','ÙƒØ±ÙŠØ³Ù…Ø³ Ù…Ø¨Ø§Ø±Ùƒ ',0),(67612,1879,'tr','Mutlu Noeller',0),(67613,1879,'pl','WesoÅ‚ych ÅšwiÄ…t BoÅ¼ego Narodzenia',0),(67614,1879,'bg','Ð’ÐµÑÐµÐ»Ð° ÐšÐ¾Ð»ÐµÐ´Ð°',0),(67615,1879,'ur','Ù…ÛŒØ±ÛŒ Ú©Ø±Ø³Ù…Ø³',0),(67616,1879,'sr','Ð¡Ñ€ÐµÑ›Ð°Ð½ Ð‘Ð¾Ð¶Ð¸Ñ›',0),(67617,1879,'vi','GiÃ¡ng Sinh Vui Váº»',0),(67618,1879,'af','GeseÃ«nde Kersfees',0),(67619,1879,'ro','CrÄƒciun fericit',0),(67620,1879,'et','HÃ¤id JÃµule',0),(67621,1879,'si','Vesel BoÅ¾iÄ',0),(67622,1879,'ba','Selama Natal',0),(67623,1879,'nl','Vrolijk kerstfeest',0),(67624,1879,'fi','Iloista joulua',0),(67625,1879,'no','God jul',0),(67626,1879,'da','GlÃ¦delig jul',0),(67627,1879,'ko','ë©”ë¦¬ í¬ë¦¬ìŠ¤ë§ˆìŠ¤',0),(67628,1879,'he','×—×’ ×©×ž×—',0),(67629,1879,'el','ÎšÎ±Î»Î¬ Î§ÏÎ¹ÏƒÏ„Î¿ÏÎ³ÎµÎ½Î½Î±',0),(67630,1879,'zh','åœ£è¯žèŠ‚å¿«ä¹\r\n',0),(67631,1879,'sv','God Jul',0),(67632,1879,'it','Buon Natale',0),(67633,1879,'tl','',0),(67634,1879,'th','&#3626;&#3640;&#3586;&#3626;&#3633;&#3609;&#3605;&#3660;&#3623;&#3633;&#3609;&#3588;&#3619;&#3636;&#3626;&#3617;&#3634;&#3626;',0),(67635,1879,'hi','à¤•à¥à¤°à¤¿à¤¸à¤®à¤¸ à¤®à¥à¤¬à¤¾à¤°à¤• à¤¹à¥‹',0),(67636,1879,'ms','Selamat Hari Krismas',0),(67637,1879,'ar','Ø¹ÙŠØ¯ Ù…ÙŠÙ„Ø§Ø¯ Ø³Ø¹ÙŠØ¯',0),(67638,1879,'fr','Joyeux NoÃ«l',0),(67639,1879,'jp','ãƒ¡ãƒªãƒ¼ã‚¯ãƒªã‚¹ãƒžã‚¹',0),(67640,1879,'pt','Feliz Natal',0),(67641,1879,'ru','Ð¡ Ð Ð¾Ð¶Ð´ÐµÑÑ‚Ð²Ð¾Ð¼',0),(67642,1879,'es','Feliz Navedad',0),(67643,1879,'de','Frohe Weihnachten',0),(67644,1879,'en','Merry Christmas',0),(67645,1880,'is','',0),(67646,1880,'dr','Ù¾ÙŠØºØ§Ù… ',0),(67647,1880,'pr','Ù¾ÙŠØºØ§Ù… ',0),(67648,1880,'tr','Ä°leti',0),(67649,1880,'pl','Komunikat',0),(67650,1880,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(67651,1880,'ur','Ù¾ÛŒØºØ§Ù…',0),(67652,1880,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐ°',0),(67653,1880,'vi','Tin Nháº¯n',0),(67654,1880,'af','Boodskap',0),(67655,1880,'ro','Mesaj',0),(67656,1880,'et','SÃµnum',0),(67657,1880,'si','SporoÄilo',0),(67658,1880,'ba','Pesan',0),(67659,1880,'nl','Bericht',0),(67660,1880,'fi','Viesti',0),(67661,1880,'no','Melding',0),(67662,1880,'da','Besked',0),(67663,1880,'ko','ë©”ì‹œì§€',0),(67664,1880,'he','×”×•×“×¢×”',0),(67665,1880,'el','ÎœÎ®Î½Ï…Î¼Î±',0),(67666,1880,'zh','æ¶ˆæ¯\r\n',0),(67667,1880,'sv','Meddelande',0),(67668,1880,'it','Messaggio',0),(67669,1880,'tl','',0),(67670,1880,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(67671,1880,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶',0),(67672,1880,'ms','Mesej',0),(67673,1880,'ar','Ø§Ù„Ø±Ø³Ø§Ù„Ø©',0),(67674,1880,'fr','Message',0),(67675,1880,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(67676,1880,'pt','Mensagem',0),(67677,1880,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(67678,1880,'es','Mensaje',0),(67679,1880,'de','Nachricht',0),(67680,1880,'en','Message',0),(67681,1881,'is','',0),(67682,1881,'dr','Ù…Ø±ÙƒØ² Ù¾ÙŠØºØ§Ù… ',0),(67683,1881,'pr','Ù…Ø±ÙƒØ² Ù¾ÙŠØºØ§Ù… ',0),(67684,1881,'tr','Mesaj Merkezi',0),(67685,1881,'pl','Centrum wiadomoÅ›ci',0),(67686,1881,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(67687,1881,'ur','Ù¾ÛŒØºØ§Ù… Ù…Ø±Ú©Ø²',0),(67688,1881,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ð·Ð° Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(67689,1881,'vi','Trung TÃ¢m Tin Nháº¯n',0),(67690,1881,'af','Boodskap Sentrum',0),(67691,1881,'ro','Centru de mesaje',0),(67692,1881,'et','SÃµnumikeskus',0),(67693,1881,'si','Vest srediÅ¡Äe',0),(67694,1881,'ba','Pusat pesan',0),(67695,1881,'nl','Berichtencentrum',0),(67696,1881,'fi','Viestikeskus',0),(67697,1881,'no','Beskjed senter',0),(67698,1881,'da','Beskedcentral',0),(67699,1881,'ko','ë©”ì‹œì§€ ì„¼í„°',0),(67700,1881,'he','×ž×¨×›×– ×”×•×“×¢×•×ª',0),(67701,1881,'el','ÎœÎ®Î½Ï…Î¼Î± ÎºÎ­Î½Ï„ÏÎ¿',0),(67702,1881,'zh','è®¯æ¯ä¸­å¿ƒ\r\n',0),(67703,1881,'sv','Message Center',0),(67704,1881,'it','Centro messaggi',0),(67705,1881,'tl','',0),(67706,1881,'th','&#3624;&#3641;&#3609;&#3618;&#3660;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(67707,1881,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(67708,1881,'ms','Pusat mesej',0),(67709,1881,'ar','Ù…Ø±ÙƒØ² Ø§Ù„Ø±Ø³Ø§Ø¦Ù„',0),(67710,1881,'fr','Centre de Message',0),(67711,1881,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚»ãƒ³ã‚¿ãƒ¼',0),(67712,1881,'pt','Centro de mensagens',0),(67713,1881,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹',0),(67714,1881,'es','Centro de Mensajes',0),(67715,1881,'de','Message Center',0),(67716,1881,'en','Message Center',0),(67717,1882,'is','',0),(67718,1882,'dr','Ù¾ÙŠØºØ§Ù… Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(67719,1882,'pr','Ù¾ÙŠØºØ§Ù… Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(67720,1882,'tr','Ä°leti bulunamadÄ±',0),(67721,1882,'pl','Komunikat nie znaleziono',0),(67722,1882,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¾',0),(67723,1882,'ur','Ù¾ÛŒØºØ§Ù… Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(67724,1882,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°',0),(67725,1882,'vi','KhÃ´ng tÃ¬m tháº¥y tin nháº¯n',0),(67726,1882,'af','Boodskap nie gevind',0),(67727,1882,'ro','Mesaj nu a fost gÄƒsit',0),(67728,1882,'et','Teadet ei leitud',0),(67729,1882,'si','SporoÄilo ni bilo mogoÄe najti',0),(67730,1882,'ba','Pesan tidak ditemukan',0),(67731,1882,'nl','Bericht niet gevonden',0),(67732,1882,'fi','ViestiÃ¤ ei lÃ¶ydy',0),(67733,1882,'no','Melding ikke funnet',0),(67734,1882,'da','Meddelelse ikke fundet',0),(67735,1882,'ko','ë©”ì‹œì§€ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(67736,1882,'he','×”×•×“×¢×” ×œ× × ×ž×¦××”',0),(67737,1882,'el','ÎœÎ®Î½Ï…Î¼Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(67738,1882,'zh','æ‰¾ä¸åˆ°æ¶ˆæ¯\r\n',0),(67739,1882,'sv','Meddelande hittades inte',0),(67740,1882,'it','Messaggio non trovato',0),(67741,1882,'tl','',0),(67742,1882,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(67743,1882,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(67744,1882,'ms','Mesej tidak dijumpai',0),(67745,1882,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø±Ø³Ø§Ù„Ø©',0),(67746,1882,'fr','Message non trouvÃ©',0),(67747,1882,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(67748,1882,'pt','Mensagem nÃ£o encontrada',0),(67749,1882,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(67750,1882,'es','Mensaje no se encontrÃ³',0),(67751,1882,'de','Nachricht nicht gefunden',0),(67752,1882,'en','Message not found',0),(67753,1883,'is','',0),(67754,1883,'dr','Ù¾ÙŠØºØ§Ù… ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ Ø¨Ù‡ ',0),(67755,1883,'pr','Ù¾ÙŠØºØ§Ù… ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ Ø¨Ù‡ ',0),(67756,1883,'tr','GÃ¶nderilen mesaj',0),(67757,1883,'pl','WiadomoÅ›Ä‡ wysÅ‚ana na',0),(67758,1883,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾ Ð´Ð¾',0),(67759,1883,'ur','Ù¾ÛŒØºØ§Ù… Ú©Û’ Ù„ÛŒÛ’ Ø¨Ú¾ÛŒØ¬Ø§ Û”',0),(67760,1883,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐ° ÑƒÐ¿ÑƒÑ›ÐµÐ½Ð°',0),(67761,1883,'vi','Tin nháº¯n gá»­i cho',0),(67762,1883,'af','Boodskap gestuur aan',0),(67763,1883,'ro','Trimite mesaj',0),(67764,1883,'et','SÃµnum saadetakse',0),(67765,1883,'si','SporoÄilo poslano',0),(67766,1883,'ba','Pesan yang dikirim ke',0),(67767,1883,'nl','Bericht verzonden naar',0),(67768,1883,'fi','Viesti lÃ¤hetetÃ¤Ã¤n',0),(67769,1883,'no','Meldingen sendt til',0),(67770,1883,'da','Meddelelse, der sendes til',0),(67771,1883,'ko','ë©”ì‹œì§€ ì „ì†¡',0),(67772,1883,'he','×”×•×“×¢×” × ×©×œ×—×” ××œ',0),(67773,1883,'el','ÎœÎ®Î½Ï…Î¼Î± Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»ÎµÏ„Î±Î¹',0),(67774,1883,'zh','æ¶ˆæ¯å‘é€åˆ°\r\n',0),(67775,1883,'sv','Meddelande som skickas till',0),(67776,1883,'it','Messaggio inviato a',0),(67777,1883,'tl','',0),(67778,1883,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3606;&#3641;&#3585;&#3626;&#3656;&#3591;&#3652;&#3611;&#3606;&#3638;&#3591;',0),(67779,1883,'hi','à¤•à¥‹ à¤­à¥‡à¤œà¥‡ à¤—à¤ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(67780,1883,'ms','Mesej yang dihantar kepada',0),(67781,1883,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø±Ø³Ø§Ù„Ø© Ø¥Ù„Ù‰',0),(67782,1883,'fr','Message envoyÃ© Ã ',0),(67783,1883,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸é€?ä¿¡å…ˆ',0),(67784,1883,'pt','Mensagem enviada para',0),(67785,1883,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(67786,1883,'es','Mensaje enviado a',0),(67787,1883,'de','Nachricht an',0),(67788,1883,'en','Message sent to',0),(67789,1884,'is','',0),(67790,1884,'dr','Ø±ÙˆØ´ ',0),(67791,1884,'pr','Ø±ÙˆØ´ ',0),(67792,1884,'tr','YÃ¶ntemi',0),(67793,1884,'pl','Metoda',0),(67794,1884,'bg','ÐœÐµÑ‚Ð¾Ð´',0),(67795,1884,'ur','Ø·Ø±ÛŒÙ‚Û',0),(67796,1884,'sr','ÐœÐµÑ‚Ð¾Ð´',0),(67797,1884,'vi','PhÆ°Æ¡ng Thá»©c',0),(67798,1884,'af','Metode',0),(67799,1884,'ro','Metoda',0),(67800,1884,'et','Meetod',0),(67801,1884,'si','Metoda',0),(67802,1884,'ba','Metode',0),(67803,1884,'nl','Methode',0),(67804,1884,'fi','MenetelmÃ¤',0),(67805,1884,'no','Metoden',0),(67806,1884,'da','Metode',0),(67807,1884,'ko','ë©”ì„œë“œ',0),(67808,1884,'he','×©×™×˜×”',0),(67809,1884,'el','ÎœÎ­Î¸Î¿Î´Î¿Ï‚',0),(67810,1884,'zh','æ–¹æ³•\r\n',0),(67811,1884,'sv','Metoden',0),(67812,1884,'it','Metodo',0),(67813,1884,'tl','',0),(67814,1884,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;',0),(67815,1884,'hi','à¤µà¤¿à¤§à¤¿',0),(67816,1884,'ms','Kaedah',0),(67817,1884,'ar','Ø§Ù„Ø·Ø±ÙŠÙ‚Ø©',0),(67818,1884,'fr','MÃ©thode',0),(67819,1884,'jp','æ–¹æ³•',0),(67820,1884,'pt','MÃ©todo',0),(67821,1884,'ru','ÐœÐµÑ‚Ð¾Ð´',0),(67822,1884,'es','MÃ©todo',0),(67823,1884,'de','Methode',0),(67824,1884,'en','Method',0),(67825,1885,'is','',0),(67826,1885,'dr','Ù…ÙŠØ§Ù†ÙŠ',0),(67827,1885,'pr','Ù…ÙŠØ§Ù†ÙŠ',0),(67828,1885,'tr','Orta',0),(67829,1885,'pl','PoÅ‚owy',0),(67830,1885,'bg','Ð¡Ñ€ÐµÐ´Ð°Ñ‚Ð°',0),(67831,1885,'ur','ÙˆØ³Ø·',0),(67832,1885,'sr','Ð¡Ñ€ÐµÐ´Ð¸Ð½Ð¾Ð¼',0),(67833,1885,'vi','Giá»¯a',0),(67834,1885,'af','Middel',0),(67835,1885,'ro','La mijlocul',0),(67836,1885,'et','Mid',0),(67837,1885,'si','Sredi',0),(67838,1885,'ba','Pertengahan',0),(67839,1885,'nl','Mid',0),(67840,1885,'fi','PuolivÃ¤lissÃ¤',0),(67841,1885,'no','Midt',0),(67842,1885,'da','Midten af',0),(67843,1885,'ko','ì¤‘ê°„',0),(67844,1885,'he','×‘××ž×¦×¢',0),(67845,1885,'el','ÎœÎ­ÏƒÎ± Ï„Î¿Ï…',0),(67846,1885,'zh','ä¸­\r\n',0),(67847,1885,'sv','Mitten av',0),(67848,1885,'it','MetÃ ',0),(67849,1885,'tl','',0),(67850,1885,'th','&#3585;&#3621;&#3634;&#3591;',0),(67851,1885,'hi','à¤®à¤§à¥à¤¯',0),(67852,1885,'ms','Mid',0),(67853,1885,'ar','Ù…Ù†ØªØµÙ',0),(67854,1885,'fr','Mid',0),(67855,1885,'jp','ä¸­é–“',0),(67856,1885,'pt','Meados',0),(67857,1885,'ru','Ð¡ÐµÑ€ÐµÐ´Ð¸Ð½Ðµ',0),(67858,1885,'es','Medio',0),(67859,1885,'de','Mitte',0),(67860,1885,'en','Mid',0),(67861,1886,'is','',0),(67862,1886,'dr','Mid  Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙŠØ§Ù†ÙŠ',0),(67863,1886,'pr','Mid  Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙŠØ§Ù†ÙŠ',0),(67864,1886,'tr','Orta maliyet',0),(67865,1886,'pl','Åšredni koszt',0),(67866,1886,'bg','Ð¡Ñ€ÐµÐ´Ð°Ñ‚Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(67867,1886,'ur','ÙˆØ³Ø· Ù„Ø§Ú¯Øª',0),(67868,1886,'sr','Ð¡Ñ€ÐµÐ´Ð¸Ð½Ð¾Ð¼ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(67869,1886,'vi','GiÃ¡ thÃ nh MID',0),(67870,1886,'af','Middel koste',0),(67871,1886,'ro','Mijlocul Cost',0),(67872,1886,'et','Keskmine kulu',0),(67873,1886,'si','Sredi stroÅ¡kov',0),(67874,1886,'ba','Biaya pertengahan',0),(67875,1886,'nl','Mid kosten',0),(67876,1886,'fi','PuolivÃ¤lissÃ¤ hinta',0),(67877,1886,'no','Midten av kostnader',0),(67878,1886,'da','Midten af omkostninger',0),(67879,1886,'ko','ì¤‘ê°„ ë¹„ìš©',0),(67880,1886,'he','×¢×œ×•×ª ×‘××ž×¦×¢',0),(67881,1886,'el','ÎœÎ­ÏƒÎ± Ï„Î¿Ï… ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(67882,1886,'zh','ä¸­ç­‰æˆæœ¬\r\n',0),(67883,1886,'sv','Mitten av kostnaden',0),(67884,1886,'it','Costo medio',0),(67885,1886,'tl','',0),(67886,1886,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3585;&#3621;&#3634;&#3591;',0),(67887,1886,'hi','à¤®à¤¿à¤¡ à¤²à¤¾à¤—à¤¤',0),(67888,1886,'ms','Kos pertengahan',0),(67889,1886,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„ØªÙƒÙ„ÙØ©',0),(67890,1886,'fr','CoÃ»t moyen',0),(67891,1886,'jp','Mid Cost',0),(67892,1886,'pt','Custo mÃ©dio',0),(67893,1886,'ru','Ð¡ÐµÑ€ÐµÐ´Ð¸Ð½Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(67894,1886,'es','Costo Medio',0),(67895,1886,'de','Mitte Kosten',0),(67896,1886,'en','Mid Cost',0),(67897,1887,'is','',0),(67898,1887,'dr','Ù…ÙŠÙ„ÙŠÙˆÙ† ',0),(67899,1887,'pr','Ù…ÙŠÙ„ÙŠÙˆÙ† ',0),(67900,1887,'tr','milyon',0),(67901,1887,'pl','milion',0),(67902,1887,'bg','Ð¼Ð¸Ð»Ð¸Ð¾Ð½',0),(67903,1887,'ur','Ø¯Ø³ Ù„Ø§Ú©Ú¾',0),(67904,1887,'sr','Ð¼Ð¸Ð»Ð¸Ð¾Ð½',0),(67905,1887,'vi','triá»‡u',0),(67906,1887,'af','miljoen',0),(67907,1887,'ro','milioane de euro',0),(67908,1887,'et','miljonit eurot',0),(67909,1887,'si','milijon',0),(67910,1887,'ba','juta',0),(67911,1887,'nl','miljoen',0),(67912,1887,'fi','miljoonaa euroa',0),(67913,1887,'no','millioner',0),(67914,1887,'da','millioner',0),(67915,1887,'ko','100ë§Œ',0),(67916,1887,'he','×ž×™×œ×™×•×Ÿ',0),(67917,1887,'el','ÎµÎºÎ±Ï„Î¿Î¼Î¼ÏÏÎ¹Î±',0),(67918,1887,'zh','ä¸‡\r\n',0),(67919,1887,'sv','miljoner',0),(67920,1887,'it','milioni',0),(67921,1887,'tl','',0),(67922,1887,'th','&#3621;&#3657;&#3634;&#3609;',0),(67923,1887,'hi','à¤¦à¤¸ à¤²à¤¾à¤–',0),(67924,1887,'ms','juta',0),(67925,1887,'ar','Ù…Ù„ÙŠÙˆÙ† Ø¯ÙˆÙ„Ø§Ø±',0),(67926,1887,'fr','millions',0),(67927,1887,'jp','ç™¾ä¸‡',0),(67928,1887,'pt','milhÃµes',0),(67929,1887,'ru','Ð¼Ð¸Ð»Ð»Ð¸Ð¾Ð½',0),(67930,1887,'es','milliÃ³n',0),(67931,1887,'de','Mio.',0),(67932,1887,'en','million',0),(67933,1888,'is','',0),(67934,1888,'dr','Ø­Ø¯Ø§Ù‚Ù„',0),(67935,1888,'pr','Ø­Ø¯Ø§Ù‚Ù„',0),(67936,1888,'tr','Min',0),(67937,1888,'pl','Min',0),(67938,1888,'bg','ÐœÐ¸Ð½',0),(67939,1888,'ur','Ú©Ù… Ø§Ø² Ú©Ù…',0),(67940,1888,'sr','ÐœÐ¸Ð½',0),(67941,1888,'vi','Tá»‘i thiá»ƒu',0),(67942,1888,'af','Min',0),(67943,1888,'ro','Min',0),(67944,1888,'et','Min',0),(67945,1888,'si','Min',0),(67946,1888,'ba','Min',0),(67947,1888,'nl','Min',0),(67948,1888,'fi','Min',0),(67949,1888,'no','Min',0),(67950,1888,'da','Min',0),(67951,1888,'ko','ë¶„',0),(67952,1888,'he','Min',0),(67953,1888,'el','Min',0),(67954,1888,'zh','æœ€å°\r\n',0),(67955,1888,'sv','Min',0),(67956,1888,'it','Min',0),(67957,1888,'tl','',0),(67958,1888,'th','&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(67959,1888,'hi','à¤®à¤¿à¤¨',0),(67960,1888,'ms','Min',0),(67961,1888,'ar','Ø§Ù„Ø£Ø¯Ù†Ù‰',0),(67962,1888,'fr','Min',0),(67963,1888,'jp','æœ€å°?',0),(67964,1888,'pt','Min',0),(67965,1888,'ru','ÐœÐ¸Ð½',0),(67966,1888,'es','Min',0),(67967,1888,'de','Min',0),(67968,1888,'en','Min',0),(67969,1889,'is','',0),(67970,1889,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(67971,1889,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(67972,1889,'tr','Minimum Ã¼cret',0),(67973,1889,'pl','Min. opÅ‚ata',0),(67974,1889,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(67975,1889,'ur','Ù…Ù†Ù¹ Ú†Ø§Ø±Ø¬',0),(67976,1889,'sr','ÐœÐ¸Ð½ . Ð¿ÑƒÑšÐµÑšÐµ',0),(67977,1889,'vi','PhÃ­ Tá»‘i thiá»ƒu',0),(67978,1889,'af','Min. las',0),(67979,1889,'ro','Min. taxa',0),(67980,1889,'et','Min. tasu',0),(67981,1889,'si','Min. dajatev',0),(67982,1889,'ba','Minimum Charge',0),(67983,1889,'nl','Min. gratis',0),(67984,1889,'fi','Min. ilmaiseksi',0),(67985,1889,'no','Min. gratis',0),(67986,1889,'da','Min. afgift',0),(67987,1889,'ko','ë¶„ ì¶©ì „',0),(67988,1889,'he','×ž×™× ×™×ž×•× ×”×˜×¢×™× ×”',0),(67989,1889,'el','Min. Î¦Î¿ÏÏ„Î¯ÏƒÏ„Îµ Ï„Î¿',0),(67990,1889,'zh','æœ€ä½Žæ”¶è´¹\r\n',0),(67991,1889,'sv','Min. kostnad',0),(67992,1889,'it','Carica di min.',0),(67993,1889,'tl','',0),(67994,1889,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(67995,1889,'hi','à¤®à¤¿. à¤ªà¥à¤°à¤­à¤¾à¤°à¥€',0),(67996,1889,'ms','Caj minimum',0),(67997,1889,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰',0),(67998,1889,'fr','Charge min.',0),(67999,1889,'jp','æœ€å°?æ–™é‡‘',0),(68000,1889,'pt','Carga de min.',0),(68001,1889,'ru','Ð—Ð°Ñ€ÑÐ´ Ð¼Ð¸Ð½.',0),(68002,1889,'es','Cargo MÃ­n.',0),(68003,1889,'de','Min. kostenlos',0),(68004,1889,'en','Min. Charge',0),(68005,1890,'is','',0),(68006,1890,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª ',0),(68007,1890,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª ',0),(68008,1890,'tr','Min mÃ¼rekkepleri geri',0),(68009,1890,'pl','Min farb powrÃ³t',0),(68010,1890,'bg','ÐœÐ¸Ð½ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾',0),(68011,1890,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø§Ù†Ú©Ø³ ÙˆØ§Ù¾Ø³',0),(68012,1890,'sr','ÐœÐ¸Ð½ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð½Ð°Ð·Ð°Ð´',0),(68013,1890,'vi','Má»±c In tá»‘i thiá»ƒu',0),(68014,1890,'af','Min ink terug',0),(68015,1890,'ro','Min cerneluri Ã®napoi',0),(68016,1890,'et','Min tindid tagasi',0),(68017,1890,'si','ÄŒrnila min nazaj',0),(68018,1890,'ba','Min tinta kembali',0),(68019,1890,'nl','Min inkten terug',0),(68020,1890,'fi','Min musteet takaisin',0),(68021,1890,'no','Min blekkfarger tilbake',0),(68022,1890,'da','Min blÃ¦k tilbage',0),(68023,1890,'ko','ë‹¤ì‹œ ë¶„ ìž‰í¬',0),(68024,1890,'he','×ž×™×Ÿ ×“×™×•.',0),(68025,1890,'el','ÎœÎµÎ»Î¬Î½Î¹Î± min Ï€Î¯ÏƒÏ‰',0),(68026,1890,'zh','æœ€å°‘æ²¹å¢¨è¿”å›ž\r\n',0),(68027,1890,'sv','Min blÃ¤ck tillbaka',0),(68028,1890,'it','Inchiostri min indietro',0),(68029,1890,'tl','',0),(68030,1890,'th','&#3626;&#3637;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;&#3604;&#3657;&#3634;&#3609;&#3627;&#3621;&#3633;&#3591;',0),(68031,1890,'hi','à¤®à¤¿à¤¨ à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤µà¤¾à¤ªà¤¸',0),(68032,1890,'ms','Dakwat min kembali',0),(68033,1890,'ar','Ø£Ø­Ø¨Ø§Ø± Ø¯Ù‚ÙŠÙ‚Ø© Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ±Ø§Ø¡',0),(68034,1890,'fr','Encres min retour',0),(68035,1890,'jp','è£?é?¢ã?®ã‚¤ãƒ³ã‚¯æœ€å°?å€¤',0),(68036,1890,'pt','Tintas min atrÃ¡s',0),(68037,1890,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð° min Ð½Ð°Ð·Ð°Ð´',0),(68038,1890,'es','Min Tintas Dorsal',0),(68039,1890,'de','Min Tinten zurÃ¼ck',0),(68040,1890,'en','Min Inks Back',0),(68041,1891,'is','',0),(68042,1891,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø¨Ø·Ø±Ù Ø¬Ù„Ùˆ ',0),(68043,1891,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø¨Ø·Ø±Ù Ø¬Ù„Ùˆ ',0),(68044,1891,'tr','Min mÃ¼rekkepleri aÃ§Ä±k',0),(68045,1891,'pl','Min farb przÃ³d',0),(68046,1891,'bg','ÐœÐ¸Ð½ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ñ„Ñ€Ð¾Ð½Ñ‚',0),(68047,1891,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø§Ù†Ú©Ø³ Ù…Ø­Ø§Ø°',0),(68048,1891,'sr','ÐœÐ¸Ð½ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð¤Ñ€Ð¾Ð½Ñ‚',0),(68049,1891,'vi','Má»±c trÆ°á»›c Tá»‘i thiá»ƒu',0),(68050,1891,'af','Min ink voor',0),(68051,1891,'ro','FaÅ£Äƒ de cerneluri min',0),(68052,1891,'et','Min tindid ees',0),(68053,1891,'si','Min Ärnila spredaj',0),(68054,1891,'ba','Min tinta depan',0),(68055,1891,'nl','Min inkten Front',0),(68056,1891,'fi','Min musteet edessÃ¤',0),(68057,1891,'no','Min blekkfarger foran',0),(68058,1891,'da','Min blÃ¦k Front',0),(68059,1891,'ko','ìµœì†Œ ìž‰í¬ ì•ž',0),(68060,1891,'he','×ž×™×Ÿ ×¦×‘×¢×™ ×—×–×™×ª',0),(68061,1891,'el','Min Î¼ÎµÎ»Î¬Î½Î¹Î± Î¼Î­Ï„Ï‰Ï€Î¿',0),(68062,1891,'zh','æœ€å°‘æ²¹å¢¨æ ‡é¢˜\r\n',0),(68063,1891,'sv','Min blÃ¤ck Front',0),(68064,1891,'it','Min inchiostri anteriore',0),(68065,1891,'tl','',0),(68066,1891,'th','&#3626;&#3637;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;&#3604;&#3657;&#3634;&#3609;&#3627;&#3609;&#3657;&#3634;',0),(68067,1891,'hi','à¤®à¤¿à¤¨ à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤®à¥‹à¤°à¥à¤šà¤¾',0),(68068,1891,'ms','Min dakwat Penyambut',0),(68069,1891,'ar','Ø§Ù„Ø¬Ø¨Ù‡Ø© Ø§Ù„Ø£Ø­Ø¨Ø§Ø± Ø¯Ù‚ÙŠÙ‚Ø©',0),(68070,1891,'fr','Min encres avant',0),(68071,1891,'jp','è¡¨é?¢ã?®ã‚¤ãƒ³ã‚¯æœ€å°?å€¤',0),(68072,1891,'pt','Frente de tintas de min',0),(68073,1891,'ru','Ð¤Ñ€Ð¾Ð½Ñ‚ ÐºÑ€Ð°ÑÐºÐ¸ Ð¼Ð¸Ð½',0),(68074,1891,'es','Min Tintas Frente',0),(68075,1891,'de','Min-Tinten-Front',0),(68076,1891,'en','Min Inks Front',0),(68077,1892,'is','',0),(68078,1892,'dr','Ø­Ø¯Ø§Ù‚Ù„ ØªØ¹Ø¯Ø§Ø¯ ØµÙØ­Ø§Øª ',0),(68079,1892,'pr','Ø­Ø¯Ø§Ù‚Ù„ ØªØ¹Ø¯Ø§Ø¯ ØµÙØ­Ø§Øª ',0),(68080,1892,'tr','Min # sayfalarÄ±',0),(68081,1892,'pl','Min # stron',0),(68082,1892,'bg','ÐœÐ¸Ð½ # ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(68083,1892,'ur','Ú©Ù… Ø§Ø² Ú©Ù… # ØµÙØ­Ø§Øª',0),(68084,1892,'sr','ÐœÐ¸Ð½ # ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(68085,1892,'vi','Sá»‘ trang tá»‘i thiá»ƒu',0),(68086,1892,'af','Min # bladsye',0),(68087,1892,'ro','Min # pagini',0),(68088,1892,'et','Min # lehekÃ¼ljed',0),(68089,1892,'si','# Strani min',0),(68090,1892,'ba','Halaman # min',0),(68091,1892,'nl','Min # pagina \'s',0),(68092,1892,'fi','Min # sivut',0),(68093,1892,'no','Min # sider',0),(68094,1892,'da','Min # sider',0),(68095,1892,'ko','ë¶„ # íŽ˜ì´ì§€',0),(68096,1892,'he','×ž×™×Ÿ # ×“×¤×™×',0),(68097,1892,'el','Min # ÏƒÎµÎ»Î¯Î´ÎµÏ‚',0),(68098,1892,'zh','æœ€å°‘ï¼ƒé¡µ\r\n',0),(68099,1892,'sv','Min # sidor',0),(68100,1892,'it','Pagine # min',0),(68101,1892,'tl','',0),(68102,1892,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(68103,1892,'hi','à¤®à¤¿à¤¨ # à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚',0),(68104,1892,'ms','Muka surat # min',0),(68105,1892,'ar','ØµÙØ­Ø§Øª # Ø¯Ù‚ÙŠÙ‚Ø©',0),(68106,1892,'fr','Min # Pages',0),(68107,1892,'jp','æœ€å°?ãƒšãƒ¼ã‚¸æ•°',0),(68108,1892,'pt','Min # pÃ¡ginas',0),(68109,1892,'ru','ÐœÐ¸Ð½ # Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†',0),(68110,1892,'es','Min # PÃ¡ginas',0),(68111,1892,'de','Min # Seiten',0),(68112,1892,'en','Min # Pages',0),(68113,1893,'is','',0),(68114,1893,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ø³Ø·Ø­ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(68115,1893,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ø³Ø·Ø­ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(68116,1893,'tr','Min stok dÃ¼zeyi',0),(68117,1893,'pl','Poziom zapasÃ³w min',0),(68118,1893,'bg','Min Ð½Ð¸Ð²Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(68119,1893,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø§Ø³Ù¹Ø§Ú© Ø³Ø·Ø­',0),(68120,1893,'sr','ÐœÐ¸Ð½ Ð½Ð¸Ð²Ð¾Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(68121,1893,'vi','HÃ ng tá»“n Tá»‘i thiá»ƒu',0),(68122,1893,'af','Min Voorrade Vlak',0),(68123,1893,'ro','Nivelul stocurilor min',0),(68124,1893,'et','Min laos tase',0),(68125,1893,'si','Raven zalog min',0),(68126,1893,'ba','Tingkat stok min',0),(68127,1893,'nl','Min voorraad',0),(68128,1893,'fi','Min tavallinen laakea',0),(68129,1893,'no','Min lager nivÃ¥',0),(68130,1893,'da','Min bestand niveau',0),(68131,1893,'ko','ìµœì†Œ ìž¬ê³  ìˆ˜ì¤€',0),(68132,1893,'he','×¨×ž×ª ×ž×œ××™ ×ž×™× ×™×ž×•×',0),(68133,1893,'el','Min ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(68134,1893,'zh','æœ€ä½Žåº“å­˜æ°´å¹³\r\n',0),(68135,1893,'sv','Min lagernivÃ¥n',0),(68136,1893,'it','Livello di scorte min',0),(68137,1893,'tl','',0),(68138,1893,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3626;&#3605;&#3655;&#3629;&#3585;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(68139,1893,'hi','à¤®à¤¿à¤¨ à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥à¤¤à¤°',0),(68140,1893,'ms','Min tahap stok',0),(68141,1893,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¯Ù‚ÙŠÙ‚Ø©',0),(68142,1893,'fr','Niveau de Stock min',0),(68143,1893,'jp','æœ€å°?ã‚¹ãƒˆãƒƒã‚¯ãƒ¬ãƒ™ãƒ«',0),(68144,1893,'pt','NÃ­vel de estoque de min',0),(68145,1893,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð¼Ð¸Ð½.',0),(68146,1893,'es','Min Nivel de Stock',0),(68147,1893,'de','Min-Lagerbestand',0),(68148,1893,'en','Min Stock Level',0),(68149,1894,'is','',0),(68150,1894,'dr','Ø­Ø¯Ø§Ù‚Ù„',0),(68151,1894,'pr','Ø­Ø¯Ø§Ù‚Ù„',0),(68152,1894,'tr','En az',0),(68153,1894,'pl','Minimalna',0),(68154,1894,'bg','ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼',0),(68155,1894,'ur','Ú©Ù… Ø§Ø² Ú©Ù…',0),(68156,1894,'sr','ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼',0),(68157,1894,'vi','Tá»‘i Ä‘a',0),(68158,1894,'af','Minimum',0),(68159,1894,'ro','Minim',0),(68160,1894,'et','Minimaalne',0),(68161,1894,'si','Najmanj',0),(68162,1894,'ba','Minimal',0),(68163,1894,'nl','Minimum',0),(68164,1894,'fi','VÃ¤hintÃ¤Ã¤n',0),(68165,1894,'no','Minimum',0),(68166,1894,'da','Minimum',0),(68167,1894,'ko','ìµœì†Œ',0),(68168,1894,'he','×ž×™× ×™×ž×•×',0),(68169,1894,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î¿',0),(68170,1894,'zh','æœ€ä½Ž\r\n',0),(68171,1894,'sv','Minimum',0),(68172,1894,'it','Minimo',0),(68173,1894,'tl','',0),(68174,1894,'th','&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(68175,1894,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤®',0),(68176,1894,'ms','Sekurang-kurangnya',0),(68177,1894,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰',0),(68178,1894,'fr','Minimum',0),(68179,1894,'jp','æœ€å°?',0),(68180,1894,'pt','MÃ­nimo',0),(68181,1894,'ru','ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼',0),(68182,1894,'es','MÃ­nimo',0),(68183,1894,'de','Mindestens',0),(68184,1894,'en','Minimum',0),(68185,1895,'is','',0),(68186,1895,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(68187,1895,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(68188,1895,'tr','Minimum Ã¼cret',0),(68189,1895,'pl','Minimalna opÅ‚ata',0),(68190,1895,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(68191,1895,'ur','Ú©Ù… Ø³Û’ Ú©Ù… Ú†Ø§Ø±Ø¬',0),(68192,1895,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ñ‚Ð°Ñ€Ð¸Ñ„Ð°',0),(68193,1895,'vi','PhÃ­ Tá»‘i thiá»ƒu',0),(68194,1895,'af','Minimum fooi',0),(68195,1895,'ro','Taxa minimÄƒ',0),(68196,1895,'et','Miinimumarve',0),(68197,1895,'si','NajmanjÅ¡a obraÄunska',0),(68198,1895,'ba','Biaya minimum',0),(68199,1895,'nl','Minimumbedrag',0),(68200,1895,'fi','Minimiveloitus',0),(68201,1895,'no','Lading',0),(68202,1895,'da','MindstebelÃ¸b',0),(68203,1895,'ko','ìµœì†Œ ì¶©ì „',0),(68204,1895,'he','×ª×©×œ×•× ×ž×™× ×™×ž×•×',0),(68205,1895,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î· Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(68206,1895,'zh','æœ€ä½Žæ”¶è´¹\r\n',0),(68207,1895,'sv','Minimidebitering',0),(68208,1895,'it','Carica minima',0),(68209,1895,'tl','',0),(68210,1895,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(68211,1895,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤ªà¥à¤°à¤­à¤¾à¤°',0),(68212,1895,'ms','Caj minimum',0),(68213,1895,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† ØªÙ‡Ù…Ø©',0),(68214,1895,'fr','Frais minimums',0),(68215,1895,'jp','æœ€å°?æ–™é‡‘',0),(68216,1895,'pt','Carga mÃ­nima',0),(68217,1895,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð·Ð°Ñ€ÑÐ´',0),(68218,1895,'es','Cargo MÃ­nimo',0),(68219,1895,'de','MindestgebÃ¼hr',0),(68220,1895,'en','Minimum Charge',0),(68221,1896,'is','',0),(68222,1896,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ø«Ø¨Øª Ù…Ø¹ØªØ¨Ø± ØªÙˆØ³Ø· Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(68223,1896,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ø«Ø¨Øª Ù…Ø¹ØªØ¨Ø± ØªÙˆØ³Ø· Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(68224,1896,'tr','KullanÄ±cÄ± tarafÄ±ndan en az geÃ§erli giriÅŸ',0),(68225,1896,'pl','Minimalne prawidÅ‚owy wpis przez uÅ¼ytkownika',0),(68226,1896,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð·Ð°Ð¿Ð¸Ñ Ð¾Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(68227,1896,'ur','ØµØ§Ø±Ù Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ú©Ù… Ø§Ø² Ú©Ù… Ø¬Ø§Ø¦Ø² Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(68228,1896,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð¸ÑÐ¿Ñ€Ð°Ð²Ð°Ð½ ÑƒÐ½Ð¾Ñ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(68229,1896,'vi','Má»©c Entry há»¯u hiá»‡u tá»‘i thiá»ƒu cho user',0),(68230,1896,'af','Minimum toelaatbare inskrywing deur gebruiker',0),(68231,1896,'ro','Minim intrare validÄƒ de utilizator',0),(68232,1896,'et','Minimaalne kehtiv kasutaja',0),(68233,1896,'si','Minimalno veljaven vnos uporabnika',0),(68234,1896,'ba','Berlaku ijin oleh pengguna',0),(68235,1896,'nl','Minimale geldige vermelding door gebruiker',0),(68236,1896,'fi','VÃ¤hintÃ¤Ã¤n kelpaa kÃ¤yttÃ¤jÃ¤',0),(68237,1896,'no','Minimum gyldig oppfÃ¸ring av bruker',0),(68238,1896,'da','Minimum gyldig post af bruger',0),(68239,1896,'ko','ì‚¬ìš©ìž ìµœì†Œ ìœ íš¨í•œ í•­ëª©',0),(68240,1896,'he','×ž×™× ×™×ž×•× ×›× ×™×¡×” ×—×•×§×™×™× ×¢×œ-×™×“×™ ×”×ž×©×ª×ž×©',0),(68241,1896,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î· Î­Î³ÎºÏ…ÏÎ· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î±Ï€ÏŒ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(68242,1896,'zh','ç”¨æˆ·è¾“å…¥çš„æœ€å°æœ‰æ•ˆå€¼\r\n',0),(68243,1896,'sv','Minsta giltig post av anvÃ¤ndare',0),(68244,1896,'it','Ingresso valido minimo dall\'utente',0),(68245,1896,'tl','',0),(68246,1896,'th','&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3605;&#3634;&#3617;&#3585;&#3599;&#3627;&#3617;&#3634;&#3618;&#3650;&#3604;&#3',0),(68247,1896,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤®à¤¾à¤¨à¥à¤¯ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(68248,1896,'ms','Minimum kemasukan yang sah oleh pengguna',0),(68249,1896,'ar','Ø¯Ø®ÙˆÙ„ ØµØ§Ù„Ø­Ø© Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(68250,1896,'fr','EntrÃ©e valide minimale par utilisateur',0),(68251,1896,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?«ã‚ˆã‚‹æœ€å°?æœ‰åŠ¹ã‚¨ãƒ³ãƒˆãƒªãƒ¼',0),(68252,1896,'pt','MÃ­nima vÃ¡lida entrada pelo usuÃ¡rio',0),(68253,1896,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ñ‹Ð¼ Ð´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¼ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¼',0),(68254,1896,'es','Entrada vÃ¡lida mÃ­nima por usuario',0),(68255,1896,'de','Minimale gÃ¼ltigen EintrÃ¤ge durch Benutzer',0),(68256,1896,'en','Minimum valid entry by user',0),(68257,1897,'is','',0),(68258,1897,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(68259,1897,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(68260,1897,'tr','Asgari Ã¼cret',0),(68261,1897,'pl','PÅ‚aca minimalna',0),(68262,1897,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð°',0),(68263,1897,'ur','Ù…Ù†ÛŒ Ù…Ù… ÙˆÛŒØ¬',0),(68264,1897,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð·Ð°Ñ€Ð°Ð´Ð°',0),(68265,1897,'vi','LÆ°Æ¡ng Tá»‘i thiá»ƒu',0),(68266,1897,'af','Minimum Besoldiging',0),(68267,1897,'ro','Salariul minim',0),(68268,1897,'et','Miinimumpalga',0),(68269,1897,'si','Minimalne plaÄe',0),(68270,1897,'ba','Upah minimum',0),(68271,1897,'nl','Minimumloon',0),(68272,1897,'fi','VÃ¤himmÃ¤ispalkka',0),(68273,1897,'no','MinstelÃ¸nn',0),(68274,1897,'da','MindstelÃ¸n',0),(68275,1897,'ko','ìµœì € ìž„ê¸ˆ',0),(68276,1897,'he','×©×›×¨ ×ž×™× ×™×ž×•×',0),(68277,1897,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î¿ Î¼Î¹ÏƒÎ¸ÏŒ',0),(68278,1897,'zh','æœ€ä½Žå·¥èµ„\r\n',0),(68279,1897,'sv','MinimilÃ¶nen',0),(68280,1897,'it','Salario minimo',0),(68281,1897,'tl','',0),(68282,1897,'th','&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(68283,1897,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤µà¥‡à¤¤à¤¨',0),(68284,1897,'ms','Gaji minimum',0),(68285,1897,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù„Ù„Ø£Ø¬ÙˆØ±',0),(68286,1897,'fr','Salaire minimum',0),(68287,1897,'jp','æœ€å°?è³ƒé‡‘',0),(68288,1897,'pt','SalÃ¡rio mÃ­nimo',0),(68289,1897,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(68290,1897,'es','Salario mÃ­nimo',0),(68291,1897,'de','Mindestlohn',0),(68292,1897,'en','Minimum Wage',0),(68293,1898,'is','',0),(68294,1898,'dr','(Ù…Ø¬Ù…ÙˆØ¹Ù‡) ØªØ®ÙÙŠÙ  ',0),(68295,1898,'pr','Ù…Ø®ØªÙ„Ù(Ù…Ø¬Ù…ÙˆØ¹Ù‡) ØªØ®ÙÙŠÙ  ',0),(68296,1898,'tr','Sair gider indirimi',0),(68297,1898,'pl','Odliczenie misc.',0),(68298,1898,'bg','Ð Ð°Ð·Ð½Ð¸ Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(68299,1898,'ur','Ù…ØªÙØ±Ù‚ Ù…Ù†ÛØ§Ø¦ÛŒ',0),(68300,1898,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð°',0),(68301,1898,'vi','Giáº£m trá»« láº·t váº·t',0),(68302,1898,'af','Misc. aftrekking',0),(68303,1898,'ro','Deducerea Misc.',0),(68304,1898,'et','Lisakulude mahaarvamist',0),(68305,1898,'si','Raznimi odbitek',0),(68306,1898,'ba','Pengurangan Misc.',0),(68307,1898,'nl','Misc. aftrek',0),(68308,1898,'fi','Muut vÃ¤hennys',0),(68309,1898,'no','Diverse fradrag',0),(68310,1898,'da','Div. fradrag',0),(68311,1898,'ko','ê¸°íƒ€ ê³µì œ',0),(68312,1898,'he','× ×™×›×•×™ ×—×™×•×‘×™× ×©×•× ×™×',0),(68313,1898,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ· Î´Î¹Î¬Ï†Î¿ÏÎ±.',0),(68314,1898,'zh','æ‚é¡¹ã€‚æ‰£é™¤\r\n',0),(68315,1898,'sv','Div. avdrag',0),(68316,1898,'it','Deduzione varie.',0),(68317,1898,'tl','',0),(68318,1898,'th','&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;',0),(68319,1898,'hi','Misc. à¤•à¤Ÿà¥Œà¤¤à¥€',0),(68320,1898,'ms','Potongan MISC.',0),(68321,1898,'ar','Ø®ØµÙ… Ø§Ù„Ù…ØªÙ†ÙˆØ¹Ø©',0),(68322,1898,'fr','DÃ©duction de divers.',0),(68323,1898,'jp','ã??ã?®ä»–æŽ§é™¤',0),(68324,1898,'pt','DeduÃ§Ã£o do misc.',0),(68325,1898,'ru','ÐŸÑ€Ð¾Ñ‡Ð¸Ðµ Ð²Ñ‹Ñ‡ÐµÑ‚',0),(68326,1898,'es','Deduccion Misc.',0),(68327,1898,'de','Sonstige Abzug',0),(68328,1898,'en','Misc. Deduction',0),(68329,1899,'is','',0),(68330,1899,'dr','ØªØ®ÙÙŠÙ Ù…Ø®ØªÙ„Ù Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(68331,1899,'pr','ØªØ®ÙÙŠÙ Ù…Ø®ØªÙ„Ù Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(68332,1899,'tr','Misc kesinti Ã¶denecek',0),(68333,1899,'pl','PÅ‚atne potrÄ…ceniem misc',0),(68334,1899,'bg','Ð Ð°Ð·Ð½Ð¸ Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¼Ð¸',0),(68335,1899,'ur','Ù…ØªÙØ±Ù‚ ÛÙˆÙ†Û’Ùˆ Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(68336,1899,'sr','ÐœÐ˜Ð¡Ð¦ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(68337,1899,'vi','CÃ¡c Khoáº£n Giáº£m Trá»« Phá»¥ Pháº£i Tráº£',0),(68338,1899,'af','Allerlei Aftrekkings Betaalbaar',0),(68339,1899,'ro','PlÄƒtit de deducere misc',0),(68340,1899,'et','Varia mahaarvamist makstav',0),(68341,1899,'si','Misc odbitek plaÄljive',0),(68342,1899,'ba','Misc pengurangan hutang',0),(68343,1899,'nl','Misc aftrek te betalen',0),(68344,1899,'fi','Muut vÃ¤hennetty maksettavat',0),(68345,1899,'no','Diverse fradrag betales',0),(68346,1899,'da','Misc fradrag skal betales',0),(68347,1899,'ko','ê¸°íƒ€ ê³µì œ ì§€ê¸‰',0),(68348,1899,'he','Misc × ×™×›×•×™ ×–×›××™×',0),(68349,1899,'el','Î Î»Î·ÏÏ‰Ï„Î­Î¿Î¹ Î±Ï†Î±Î¯ÏÎµÏƒÎ· misc',0),(68350,1899,'zh','æ‚é¡¹æ‰£é™¤åº”ä»˜\r\n',0),(68351,1899,'sv','Misc avdrag skall betalas',0),(68352,1899,'it','Pagabile in deduzione misc',0),(68353,1899,'tl','',0),(68354,1899,'th','&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;',0),(68355,1899,'hi','à¤µà¤¿à¤µà¤¿à¤§ à¤•à¤Ÿà¥Œà¤¤à¥€ à¤¦à¥‡à¤¯',0),(68356,1899,'ms','MISC potongan pembayaran',0),(68357,1899,'ar','Ù…ØªÙØ±Ù‚Ø§Øª Ø®ØµÙ… Ø§Ù„Ø¯ÙØ¹',0),(68358,1899,'fr','Misc dÃ©duction Payable',0),(68359,1899,'jp','ã??ã?®ä»–æŽ§é™¤è²·æŽ›é‡‘',0),(68360,1899,'pt','Misc deduÃ§Ã£o a pagar',0),(68361,1899,'ru','ÐŸÑ€Ð¾Ñ‡Ð¸Ðµ Ð²Ñ‹Ñ‡ÐµÑ‚ Ð²Ñ‹Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ',0),(68362,1899,'es','DeducciÃ³n Misc. Pagable',0),(68363,1899,'de','Misc Abzug zahlbar',0),(68364,1899,'en','Misc Deduction Payable',0),(68365,1900,'is','',0),(68366,1900,'dr','(Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(68367,1900,'pr','ØªØ®ÙÙŠÙØ§Øª Ù…Ø®ØªÙ„Ù(Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(68368,1900,'tr','Sair giderler kesintiler',0),(68369,1900,'pl','PotrÄ…cenia misc.',0),(68370,1900,'bg','Ð Ð°Ð·Ð½Ð¸ ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸',0),(68371,1900,'ur','Ù…ØªÙØ±Ù‚ Ú©Ù¹ÙˆØªÛŒ',0),(68372,1900,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸ Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ',0),(68373,1900,'vi','Giáº£m trá»« láº·t váº·t',0),(68374,1900,'af','Misc. aftrekkings',0),(68375,1900,'ro','Deduceri Misc.',0),(68376,1900,'et','Lisakulude mahaarvamised',0),(68377,1900,'si','Razne olajÅ¡ave',0),(68378,1900,'ba','Pengurangan Misc.',0),(68379,1900,'nl','Misc. inhoudingen',0),(68380,1900,'fi','Muut vÃ¤hennykset',0),(68381,1900,'no','Diverse fradrag',0),(68382,1900,'da','Div. fradrag',0),(68383,1900,'ko','ê¸°íƒ€ ê³µì œ',0),(68384,1900,'he','×—×™×•×‘×™× ×©×•× ×™× × ×™×›×•×™×™×',0),(68385,1900,'el','Î‘Ï†Î±Î¹ÏÎ­ÏƒÎµÎ¹Ï‚ Î´Î¹Î¬Ï†Î¿ÏÎ±.',0),(68386,1900,'zh','æ‚é¡¹ã€‚æ‰£é™¤\r\n',0),(68387,1900,'sv','Div. avdrag',0),(68388,1900,'it','Detrazioni varie.',0),(68389,1900,'tl','',0),(68390,1900,'th','&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;',0),(68391,1900,'hi','Misc. à¤•à¤Ÿà¥Œà¤¤à¤¿à¤¯à¤¾à¤‚',0),(68392,1900,'ms','Potongan MISC.',0),(68393,1900,'ar','Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª Ø§Ù„Ù…ØªÙ†ÙˆØ¹Ø©',0),(68394,1900,'fr','DÃ©ductions divers.',0),(68395,1900,'jp','ã??ã?®ä»–æŽ§é™¤',0),(68396,1900,'pt','Misc. deduÃ§Ãµes',0),(68397,1900,'ru','ÐŸÑ€Ð¾Ñ‡Ð¸Ðµ Ð²Ñ‹Ñ‡ÐµÑ‚Ñ‹',0),(68398,1900,'es','Deducciones Misc.',0),(68399,1900,'de','Sonstige AbzÃ¼ge',0),(68400,1900,'en','Misc. Deductions',0),(68401,1901,'is','',0),(68402,1901,'dr','(Ù…Ø¬Ù…ÙˆØ¹Ù‡ 2',0),(68403,1901,'pr','ØªØ®ÙÙŠÙØ§Øª Ù…Ø®ØªÙ„Ù(Ù…Ø¬Ù…ÙˆØ¹Ù‡ 2',0),(68404,1901,'tr','Sair giderler kesintiler',0),(68405,1901,'pl','PotrÄ…cenia misc.',0),(68406,1901,'bg','Ð Ð°Ð·Ð½Ð¸ ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸',0),(68407,1901,'ur','Ù…ØªÙØ±Ù‚ Ú©Ù¹ÙˆØªÛŒ',0),(68408,1901,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸ Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ',0),(68409,1901,'vi','Giáº£m trá»« láº·t váº·t',0),(68410,1901,'af','Misc. aftrekkings',0),(68411,1901,'ro','Deduceri Misc.',0),(68412,1901,'et','Lisakulude mahaarvamised',0),(68413,1901,'si','Razne olajÅ¡ave',0),(68414,1901,'ba','Pengurangan Misc.',0),(68415,1901,'nl','Misc. inhoudingen',0),(68416,1901,'fi','Muut vÃ¤hennykset',0),(68417,1901,'no','Diverse fradrag',0),(68418,1901,'da','Div. fradrag',0),(68419,1901,'ko','ê¸°íƒ€ ê³µì œ',0),(68420,1901,'he','×—×™×•×‘×™× ×©×•× ×™× × ×™×›×•×™×™×',0),(68421,1901,'el','Î‘Ï†Î±Î¹ÏÎ­ÏƒÎµÎ¹Ï‚ Î´Î¹Î¬Ï†Î¿ÏÎ±.',0),(68422,1901,'zh','æ‚é¡¹ã€‚æ‰£é™¤\r\n',0),(68423,1901,'sv','Div. avdrag',0),(68424,1901,'it','Detrazioni varie.',0),(68425,1901,'tl','',0),(68426,1901,'th','&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;',0),(68427,1901,'hi','Misc. à¤•à¤Ÿà¥Œà¤¤à¤¿à¤¯à¤¾à¤‚',0),(68428,1901,'ms','Potongan MISC.',0),(68429,1901,'ar','Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª Ø§Ù„Ù…ØªÙ†ÙˆØ¹Ø©',0),(68430,1901,'fr','DÃ©ductions divers.',0),(68431,1901,'jp','ã??ã?®ä»–æŽ§é™¤',0),(68432,1901,'pt','Misc. deduÃ§Ãµes',0),(68433,1901,'ru','ÐŸÑ€Ð¾Ñ‡Ð¸Ðµ Ð²Ñ‹Ñ‡ÐµÑ‚Ñ‹',0),(68434,1901,'es','Deducciones Misc.',0),(68435,1901,'de','Sonstige AbzÃ¼ge',0),(68436,1901,'en','Misc. Deductions',0),(68437,1902,'is','',0),(68438,1902,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(68439,1902,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(68440,1902,'tr','Sair giderler sigara vergiye tabi',0),(68441,1902,'pl','Opodatkowaniu nie misc.',0),(68442,1902,'bg','Ð Ð°Ð·Ð½Ð¸ Ð±ÐµÐ· Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾',0),(68443,1902,'ur','Ù…ØªÙØ±Ù‚ ØºÛŒØ± Ø¹Ø§Ø¦Ø¯',0),(68444,1902,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ñ˜Ðµ Ð½Ð¸ÑÑƒ Ð¿Ð»Ð°Ð¶Ð°',0),(68445,1902,'vi','Láº·t váº·t khÃ´ng chá»‹u thuáº¿',0),(68446,1902,'af','Misc. nie-belasbare',0),(68447,1902,'ro','Impozabile nu Misc.',0),(68448,1902,'et','Lisakulude mitte maksustatav',0),(68449,1902,'si','Raznimi davÄni',0),(68450,1902,'ba','Misc. bebas pajak',0),(68451,1902,'nl','Misc. niet belastbare',0),(68452,1902,'fi','Muut ei-verotettavat',0),(68453,1902,'no','Diverse ikke skattepliktig',0),(68454,1902,'da','Div. ikke afgiftspligtige',0),(68455,1902,'ko','ê¸°íƒ€ ë¹„ ê³¼ì„¸',0),(68456,1902,'he','×—×™×•×‘×™× ×©×•× ×™× ×©××™× ×• ×—×™×™×‘ ×‘×ž×¡',0),(68457,1902,'el','ÎœÎ· Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ ÏƒÎµ Î´Î¹Î¬Ï†Î¿ÏÎ±.',0),(68458,1902,'zh','æ‚é¡¹ã€‚éžåº”ç¨Ž\r\n',0),(68459,1902,'sv','Div. icke beskattningsbara',0),(68460,1902,'it','Soggetti passivi Non misc.',0),(68461,1902,'tl','',0),(68462,1902,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;',0),(68463,1902,'hi','Misc. à¤—à¥ˆà¤° à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯',0),(68464,1902,'ms','Cukai bebas MISC.',0),(68465,1902,'ar','Ù…ØªÙØ±Ù‚Ø§Øª ØºÙŠØ± Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(68466,1902,'fr','Divers Non imposable',0),(68467,1902,'jp','ã??ã?®ä»–é?žèª²ç¨Žå¯¾è±¡',0),(68468,1902,'pt','NÃ£o tributÃ¡veis misc.',0),(68469,1902,'ru','ÐÐµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼ Ð Ð°Ð·Ð½Ð¾Ðµ.',0),(68470,1902,'es','Misc. No Imponible',0),(68471,1902,'de','Sonstige nicht steuerpflichtige',0),(68472,1902,'en','Misc. Nontaxable',0),(68473,1903,'is','',0),(68474,1903,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª  Ø­Ù‚ÙˆÙ‚',0),(68475,1903,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª  Ø­Ù‚ÙˆÙ‚',0),(68476,1903,'tr','Sair giderler vergiye tabi olmayan Ã¶deme',0),(68477,1903,'pl','Misc. niepodlegajÄ…ce opodatkowaniu pÅ‚ac',0),(68478,1903,'bg','Ð Ð°Ð·Ð½Ð¸ Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(68479,1903,'ur','Ù…ØªÙØ±Ù‚ ØºÛŒØ± Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ ØªÙ†Ø®ÙˆØ§Û',0),(68480,1903,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ñ˜Ðµ Ð½Ð¸ÑÑƒ Ð¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ',0),(68481,1903,'vi','Thanh toÃ¡n khoáº£n láº·t váº·t khÃ´ng chá»‹u thuáº¿',0),(68482,1903,'af','Allerlei Nie-Belasbare Besoldiging',0),(68483,1903,'ro','Diverse Non-impozabilÄƒ plata',0),(68484,1903,'et','Lisakulude mitte maksustatav tÃ¶Ã¶tasu',0),(68485,1903,'si','Raznimi ni obdavÄljivega plaÄati',0),(68486,1903,'ba','Misc. membayar bebas pajak',0),(68487,1903,'nl','Misc. niet belastbare loon',0),(68488,1903,'fi','Muut veronalaista maksu',0),(68489,1903,'no','Diverse ikke skattepliktig lÃ¸nn',0),(68490,1903,'da','Div. ikke skattepligtige lÃ¸n',0),(68491,1903,'ko','ê¸°íƒ€ ë¹„ ê³¼ì„¸ ê¸‰ì—¬.',0),(68492,1903,'he','×—×™×•×‘×™× ×©×•× ×™× ×©××™× ×• ×—×™×™×‘ ×‘×ž×¡ ×©×›×¨',0),(68493,1903,'el','Î”Î¹Î¬Ï†Î¿ÏÎ±. Î¼Î· Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½',0),(68494,1903,'zh','æ‚é¡¹ã€‚éžåº”ç¨Žè–ªé…¬\r\n',0),(68495,1903,'sv','Div. icke beskattningsbara lÃ¶n',0),(68496,1903,'it','Varie Pay Non imponibili',0),(68497,1903,'tl','',0),(68498,1903,'th','&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;',0),(68499,1903,'hi','Misc. à¤—à¥ˆà¤° à¤•à¤°à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨',0),(68500,1903,'ms','MISC. gaji bebas cukai',0),(68501,1903,'ar','Ù…ØªÙØ±Ù‚Ø§Øª Ø§Ù„Ø£Ø¬ÙˆØ± ØºÙŠØ± Ø§Ù„Ø®Ø§Ø¶Ø¹Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(68502,1903,'fr','Divers de rÃ©munÃ©ration Non imposable.',0),(68503,1903,'jp','ã??ã?®ä»–é?žèª²ç¨Žå¯¾è±¡æ”¯æ‰•',0),(68504,1903,'pt','Misc. salÃ¡rio nÃ£o tributÃ¡vel',0),(68505,1903,'ru','ÐÐ°ÐºÐ»Ð°Ð´Ð½Ñ‹Ðµ Ð½Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð¾Ð³Ð¾ Ð²Ð¾Ð·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(68506,1903,'es','Pago Misc. No Imponible',0),(68507,1903,'de','Sonstige nicht steuerpflichtigen Lohn',0),(68508,1903,'en','Misc. Nontaxable Pay',0),(68509,1904,'is','',0),(68510,1904,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª  ',0),(68511,1904,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª  ',0),(68512,1904,'tr','Sair giderler sigara vergiye tabi',0),(68513,1904,'pl','Opodatkowaniu nie misc.',0),(68514,1904,'bg','Ð Ð°Ð·Ð½Ð¸ Ð±ÐµÐ· Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾',0),(68515,1904,'ur','Ù…ØªÙØ±Ù‚ ØºÛŒØ± Ø¹Ø§Ø¦Ø¯',0),(68516,1904,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ñ˜Ðµ Ð½Ð¸ÑÑƒ Ð¿Ð»Ð°Ð¶Ð°',0),(68517,1904,'vi','Láº·t váº·t khÃ´ng chá»‹u thuáº¿',0),(68518,1904,'af','Misc. nie-belasbare',0),(68519,1904,'ro','Impozabile nu Misc.',0),(68520,1904,'et','Lisakulude mitte maksustatav',0),(68521,1904,'si','Raznimi davÄni',0),(68522,1904,'ba','Misc. bebas pajak',0),(68523,1904,'nl','Misc. niet belastbare',0),(68524,1904,'fi','Muut ei-verotettavat',0),(68525,1904,'no','Diverse ikke skattepliktig',0),(68526,1904,'da','Div. ikke afgiftspligtige',0),(68527,1904,'ko','ê¸°íƒ€ ë¹„ ê³¼ì„¸',0),(68528,1904,'he','×—×™×•×‘×™× ×©×•× ×™× ×©××™× ×• ×—×™×™×‘ ×‘×ž×¡',0),(68529,1904,'el','ÎœÎ· Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ ÏƒÎµ Î´Î¹Î¬Ï†Î¿ÏÎ±.',0),(68530,1904,'zh','æ‚é¡¹ã€‚éžåº”ç¨Ž\r\n',0),(68531,1904,'sv','Div. icke beskattningsbara',0),(68532,1904,'it','Soggetti passivi Non misc.',0),(68533,1904,'tl','',0),(68534,1904,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;',0),(68535,1904,'hi','Misc. à¤—à¥ˆà¤° à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯',0),(68536,1904,'ms','Cukai bebas MISC.',0),(68537,1904,'ar','Ù…ØªÙØ±Ù‚Ø§Øª ØºÙŠØ± Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(68538,1904,'fr','Divers Non imposable',0),(68539,1904,'jp','ã??ã?®ä»–é?žèª²ç¨Žå¯¾è±¡',0),(68540,1904,'pt','NÃ£o tributÃ¡veis misc.',0),(68541,1904,'ru','ÐÐµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼ Ð Ð°Ð·Ð½Ð¾Ðµ.',0),(68542,1904,'es','Misc. No Imponible',0),(68543,1904,'de','Sonstige nicht steuerpflichtige',0),(68544,1904,'en','Misc. Nontaxable',0),(68545,1905,'is','',0),(68546,1905,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡  Ù…Ø¹Ø§Ù Ø§Ø²  Ù…Ø§Ù„ÙŠØ§Øª Ø­Ù‚ÙˆÙ‚',0),(68547,1905,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡  Ù…Ø¹Ø§Ù Ø§Ø²  Ù…Ø§Ù„ÙŠØ§Øª Ø­Ù‚ÙˆÙ‚',0),(68548,1905,'tr','Misc vergi muafiyet maaÅŸ gideri',0),(68549,1905,'pl','Misc podatku dochodowego zwolnione wynagrodzenia',0),(68550,1905,'bg','Ð Ð°Ð·Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð´ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(68551,1905,'ur','Ù…ØªÙØ±Ù‚ Ù¹ÛŒÚ©Ø³ Ù…Ø³ØªØ«Ù†ÛŒ ØªÙ†Ø®ÙˆØ§Û Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(68552,1905,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° ÐœÐ˜Ð¡Ð¦ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð¸Ð·ÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ',0),(68553,1905,'vi','Chi phÃ­ thanh toÃ¡n Láº·t váº·t Ä‘Æ°á»£c miá»…n thuáº¿',0),(68554,1905,'af','Allerlei Belasting Vrystellings Besoldigings Uitgawe',0),(68555,1905,'ro','Misc fiscale scutite de plata cheltuielilor',0),(68556,1905,'et','Varia maksukulu vabastatud tasu',0),(68557,1905,'si','Misc davka oproÅ¡Äena plaÄila stroÅ¡kov',0),(68558,1905,'ba','Misc pajak dibebaskan membayar biaya',0),(68559,1905,'nl','Misc belastinglasten vrijgesteld Pay',0),(68560,1905,'fi','Muut verot vapautettu maksu',0),(68561,1905,'no','Diverse skattekostnad unntatt lÃ¸nn',0),(68562,1905,'da','Misc skatteudgifter undtaget lÃ¸n',0),(68563,1905,'ko','ê¸°íƒ€ ì„¸ê¸ˆ ë©´ì œ ì§€ë¶ˆ ë¹„ìš©',0),(68564,1905,'he','×”×•×¦××•×ª ×©×›×¨ ×¤×˜×•×¨ ×ž×¡ ×©×•× ×•×ª',0),(68565,1905,'el','Î”Î±Ï€Î¬Î½Î· Î±Î¼Î¿Î¹Î²Î®Ï‚ Î±Ï€Î±Î»Î»Î¬ÏƒÏƒÎ¿Î½Ï„Î±Î¹ misc Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½',0),(68566,1905,'zh','æ‚é¡¹å…ç¨Žæ”¯ä»˜è´¹ç”¨\r\n',0),(68567,1905,'sv','Misc undantagna betala skattekostnad',0),(68568,1905,'it','Misc esente paga oneri',0),(68569,1905,'tl','',0),(68570,1905,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3618;&#3',0),(68571,1905,'hi','à¤µà¤¿à¤µà¤¿à¤§ à¤•à¤° à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤µà¥‡à¤¤à¤¨ à¤µà¥à¤¯à¤¯',0),(68572,1905,'ms','Perbelanjaan dikecualikan membayar cukai MISC',0),(68573,1905,'ar','Ù…ØªÙØ±Ù‚Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ù…Ù† Ø¯ÙØ¹ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª',0),(68574,1905,'fr','Charge de salaire exonÃ©rÃ© d\'impÃ´ts sur les misc',0),(68575,1905,'jp','ç¨ŽæŽ§é™¤æ‰•ã?„è«¸è²»ç”¨',0),(68576,1905,'pt','Misc imposto isentos de pagar custas',0),(68577,1905,'ru','Ð Ð°Ð·Ð½Ð¾Ðµ Ð½Ð°Ð»Ð¾Ð³Ñƒ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°ÑŽÑ‚ÑÑ Ð²Ð¾Ð·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(68578,1905,'es','Gastos de Misc. Pagos Exentos de Impuestos',0),(68579,1905,'de','Misc ausgenommen Pay Steueraufwand',0),(68580,1905,'en','Misc Tax Exempt Pay Expense',0),(68581,1906,'is','',0),(68582,1906,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(68583,1906,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(68584,1906,'tr','Sair giderler vergiye tabi',0),(68585,1906,'pl','Opodatkowaniu misc.',0),(68586,1906,'bg','Ð Ð°Ð·Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾',0),(68587,1906,'ur','Ù…ØªÙØ±Ù‚ Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ',0),(68588,1906,'sr','ÐŸÐ»Ð°Ð¶Ð° Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸',0),(68589,1906,'vi','Láº·t váº·t cÃ³ chá»‹u thuáº¿',0),(68590,1906,'af','Misc. belasbare',0),(68591,1906,'ro','Impozabile Misc.',0),(68592,1906,'et','Lisakulude maksustatav',0),(68593,1906,'si','Raznimi davÄni',0),(68594,1906,'ba','Pajak Misc.',0),(68595,1906,'nl','Misc. belastbare',0),(68596,1906,'fi','Muut verovelvollinen',0),(68597,1906,'no','Diverse skattepliktig',0),(68598,1906,'da','Div. afgiftspligtige',0),(68599,1906,'ko','ê¸°íƒ€ ê³¼ì„¸',0),(68600,1906,'he','×—×™×•×‘×™× ×©×•× ×™× ×—×™×™×‘ ×‘×ž×¡',0),(68601,1906,'el','Î¥Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ Î´Î¹Î¬Ï†Î¿ÏÎ±.',0),(68602,1906,'zh','æ‚é¡¹ã€‚åº”çº³ç¨Ž\r\n',0),(68603,1906,'sv','Div. beskattningsbara',0),(68604,1906,'it','Soggetti passivi varie.',0),(68605,1906,'tl','',0),(68606,1906,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;&#3607;&#3637;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;',0),(68607,1906,'hi','Misc. à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯',0),(68608,1906,'ms','Dikenakan cukai MISC.',0),(68609,1906,'ar','Ø§Ù„Ù…ØªÙ†ÙˆØ¹Ø© Ø§Ù„Ø®Ø§Ø¶Ø¹Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(68610,1906,'fr','Imposable des divers.',0),(68611,1906,'jp','ã??ã?®ä»–èª²ç¨Žå¯¾è±¡',0),(68612,1906,'pt','Misc. sujeito passivo',0),(68613,1906,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð Ð°Ð·Ð½Ð¾Ðµ.',0),(68614,1906,'es','Misc. Imponible',0),(68615,1906,'de','Sonstige Steuerpflichtige',0),(68616,1906,'en','Misc. Taxable',0),(68617,1907,'is','',0),(68618,1907,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø­Ù‚ÙˆÙ‚',0),(68619,1907,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø­Ù‚ÙˆÙ‚',0),(68620,1907,'tr','Sair giderler vergiye tabi Ã¶deme',0),(68621,1907,'pl','Misc. opodatkowaniu pÅ‚ac',0),(68622,1907,'bg','Ð Ð°Ð·Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(68623,1907,'ur','Ù…ØªÙØ±Ù‚ Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ ØªÙ†Ø®ÙˆØ§Û',0),(68624,1907,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð»Ð°Ð¶Ð° Ð¿Ð»Ð°Ñ‚Ñƒ',0),(68625,1907,'vi','Thanh toÃ¡n Láº·t váº·t cÃ³ chá»‹u thuáº¿',0),(68626,1907,'af','Allerlei Belasbare Besoldiging',0),(68627,1907,'ro','Plata Misc. impozabile',0),(68628,1907,'et','Lisakulude maksustatav tÃ¶Ã¶tasu',0),(68629,1907,'si','Raznimi davÄni zavezanec plaÄati',0),(68630,1907,'ba','Membayar pajak Misc.',0),(68631,1907,'nl','Misc. belastbare loon',0),(68632,1907,'fi','Muut veron maksu',0),(68633,1907,'no','Diverse skattepliktig lÃ¸nn',0),(68634,1907,'da','Div. skattepligtige lÃ¸n',0),(68635,1907,'ko','ê¸°íƒ€ ê³¼ì„¸ ì§€ë¶ˆ',0),(68636,1907,'he','×—×™×•×‘×™× ×©×•× ×™× ×—×™×™×‘ ×‘×ž×¡ ×©×›×¨',0),(68637,1907,'el','Pay misc. Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿',0),(68638,1907,'zh','æ‚é¡¹ã€‚åº”çº³ç¨Žç²®\r\n',0),(68639,1907,'sv','Div. beskattningsbara lÃ¶n',0),(68640,1907,'it','Retribuzione imponibile varie.',0),(68641,1907,'tl','',0),(68642,1907,'th','&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;&#3607;&#3637;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;',0),(68643,1907,'hi','Misc. à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨',0),(68644,1907,'ms','Membayar cukai MISC.',0),(68645,1907,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…ØªÙ†ÙˆØ¹Ø©',0),(68646,1907,'fr','RÃ©munÃ©ration imposable divers.',0),(68647,1907,'jp','ã??ã?®ä»–èª²ç¨Žå¯¾è±¡æ”¯æ‰•',0),(68648,1907,'pt','SalÃ¡rio tributÃ¡vel misc.',0),(68649,1907,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð Ð°Ð·Ð½Ð¾Ðµ.',0),(68650,1907,'es','Misc. Pagos Imponibles',0),(68651,1907,'de','Sonstige Steuerpflichtige Zahlen',0),(68652,1907,'en','Misc. Taxable Pay',0),(68653,1908,'is','',0),(68654,1908,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(68655,1908,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(68656,1908,'tr','Sair giderler vergiye tabi',0),(68657,1908,'pl','Opodatkowaniu misc.',0),(68658,1908,'bg','Ð Ð°Ð·Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾',0),(68659,1908,'ur','Ù…ØªÙØ±Ù‚ Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ',0),(68660,1908,'sr','ÐŸÐ»Ð°Ð¶Ð° Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸',0),(68661,1908,'vi','Láº·t váº·t cÃ³ chá»‹u thuáº¿',0),(68662,1908,'af','Misc. belasbare',0),(68663,1908,'ro','Impozabile Misc.',0),(68664,1908,'et','Lisakulude maksustatav',0),(68665,1908,'si','Raznimi davÄni',0),(68666,1908,'ba','Pajak Misc.',0),(68667,1908,'nl','Misc. belastbare',0),(68668,1908,'fi','Muut verovelvollinen',0),(68669,1908,'no','Diverse skattepliktig',0),(68670,1908,'da','Div. afgiftspligtige',0),(68671,1908,'ko','ê¸°íƒ€ ê³¼ì„¸',0),(68672,1908,'he','×—×™×•×‘×™× ×©×•× ×™× ×—×™×™×‘ ×‘×ž×¡',0),(68673,1908,'el','Î¥Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ Î´Î¹Î¬Ï†Î¿ÏÎ±.',0),(68674,1908,'zh','æ‚é¡¹ã€‚åº”çº³ç¨Ž\r\n',0),(68675,1908,'sv','Div. beskattningsbara',0),(68676,1908,'it','Soggetti passivi varie.',0),(68677,1908,'tl','',0),(68678,1908,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;&#3607;&#3637;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;',0),(68679,1908,'hi','Misc. à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯',0),(68680,1908,'ms','Dikenakan cukai MISC.',0),(68681,1908,'ar','Ø§Ù„Ù…ØªÙ†ÙˆØ¹Ø© Ø§Ù„Ø®Ø§Ø¶Ø¹Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(68682,1908,'fr','Imposable des divers.',0),(68683,1908,'jp','ã??ã?®ä»–èª²ç¨Žå¯¾è±¡',0),(68684,1908,'pt','Misc. sujeito passivo',0),(68685,1908,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð Ð°Ð·Ð½Ð¾Ðµ.',0),(68686,1908,'es','Misc. Imponible',0),(68687,1908,'de','Sonstige Steuerpflichtige',0),(68688,1908,'en','Misc. Taxable',0),(68689,1909,'is','',0),(68690,1909,'dr','Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡ Ø±ÙˆÙŠ ',0),(68691,1909,'pr','Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡ Ø±ÙˆÙŠ ',0),(68692,1909,'tr','DeÄŸiÅŸtirme tarihi',0),(68693,1909,'pl','Zmienione na',0),(68694,1909,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð°',0),(68695,1909,'ur','Ù¾Ø± Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ…',0),(68696,1909,'sr','ÐœÐ¾Ð´Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð° Ð½Ð°',0),(68697,1909,'vi','Chá»‰nh sá»­a vÃ o',0),(68698,1909,'af','Gewysig op',0),(68699,1909,'ro','Modificat pe',0),(68700,1909,'et','Muudetud',0),(68701,1909,'si','Spremenil na',0),(68702,1909,'ba','Diubah pada',0),(68703,1909,'nl','Bewerkt op',0),(68704,1909,'fi','Muutettu',0),(68705,1909,'no','Endret',0),(68706,1909,'da','Ã†ndret pÃ¥',0),(68707,1909,'ko','ì— ìˆ˜ì •',0),(68708,1909,'he','×©×•× ×” ×‘',0),(68709,1909,'el','Î¤ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®Î¸Î·ÎºÎµ ÏƒÏ„Î¹Ï‚',0),(68710,1909,'zh','ä¿®æ”¹\r\n',0),(68711,1909,'sv','Ã„ndras pÃ¥',0),(68712,1909,'it','Modificato su',0),(68713,1909,'tl','',0),(68714,1909,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3648;&#3617;&#3639;&#3656;&#3629;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(68715,1909,'hi','à¤ªà¤° à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤',0),(68716,1909,'ms','Kali terakhir',0),(68717,1909,'ar','ØªØ¹Ø¯ÙŠÙ„ Ø¹Ù„Ù‰',0),(68718,1909,'fr','ModifiÃ©e le',0),(68719,1909,'jp','ï½žã?®ä¿®æ­£',0),(68720,1909,'pt','Modificado em',0),(68721,1909,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ:',0),(68722,1909,'es','Modificado en',0),(68723,1909,'de','Datum der Ã„nderung',0),(68724,1909,'en','Modified on',0),(68725,1910,'is','',0),(68726,1910,'dr','Ø§ØµÙ„Ø§Ø­ ÙƒØ±Ø¯Ù† ',0),(68727,1910,'pr','Ø§ØµÙ„Ø§Ø­ ÙƒØ±Ø¯Ù† ',0),(68728,1910,'tr','DeÄŸiÅŸtirme',0),(68729,1910,'pl','Modyfikowanie',0),(68730,1910,'bg','ÐœÐ¾Ð´Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ðµ',0),(68731,1910,'ur','Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ… Ú©Ø±ÛŒÚº',0),(68732,1910,'sr','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ',0),(68733,1910,'vi','Chá»‰nh sá»­a',0),(68734,1910,'af','Wysig',0),(68735,1910,'ro','Modifica',0),(68736,1910,'et','Muuta',0),(68737,1910,'si','Spreminjanje',0),(68738,1910,'ba','Memodifikasi',0),(68739,1910,'nl','Wijzigen',0),(68740,1910,'fi','Muokkaa',0),(68741,1910,'no','Endre',0),(68742,1910,'da','Ã†ndre',0),(68743,1910,'ko','ìˆ˜ì •',0),(68744,1910,'he','×©× ×”',0),(68745,1910,'el','Î¤ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(68746,1910,'zh','ä¿®æ”¹\r\n',0),(68747,1910,'sv','Ã„ndra',0),(68748,1910,'it','Modificare',0),(68749,1910,'tl','',0),(68750,1910,'th','&#3649;&#3585;&#3657;&#3652;&#3586;',0),(68751,1910,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(68752,1910,'ms','Ubah suai',0),(68753,1910,'ar','ØªØ¹Ø¯ÙŠÙ„',0),(68754,1910,'fr','Modifier',0),(68755,1910,'jp','ä¿®æ­£',0),(68756,1910,'pt','Modificar',0),(68757,1910,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(68758,1910,'es','Modificar',0),(68759,1910,'de','Ã„ndern',0),(68760,1910,'en','Modify',0),(68761,1911,'is','',0),(68762,1911,'dr','Ù…Ø¯Ù„',0),(68763,1911,'pr','Ù…Ø¯Ù„',0),(68764,1911,'tr','ModÃ¼lÃ¼',0),(68765,1911,'pl','ModuÅ‚',0),(68766,1911,'bg','ÐœÐ¾Ð´ÑƒÐ»',0),(68767,1911,'ur','Ù…Ø§ÚˆÛŒÙˆÙ„',0),(68768,1911,'sr','ÐœÐ¾Ð´ÑƒÐ»',0),(68769,1911,'vi','Modun',0),(68770,1911,'af','Module',0),(68771,1911,'ro','Modul',0),(68772,1911,'et','Moodul',0),(68773,1911,'si','Modul',0),(68774,1911,'ba','Modul',0),(68775,1911,'nl','Module',0),(68776,1911,'fi','Moduuli',0),(68777,1911,'no','Modul',0),(68778,1911,'da','Modul',0),(68779,1911,'ko','ëª¨ë“ˆ',0),(68780,1911,'he','×ž×•×“×•×œ',0),(68781,1911,'el','Î•Î½ÏŒÏ„Î·Ï„Î±',0),(68782,1911,'zh','æ¨¡å—\r\n',0),(68783,1911,'sv','Modul',0),(68784,1911,'it','Modulo',0),(68785,1911,'tl','',0),(68786,1911,'th','&#3650;&#3617;&#3604;&#3641;&#3621;',0),(68787,1911,'hi','à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤²',0),(68788,1911,'ms','Modul',0),(68789,1911,'ar','Ø§Ù„ÙˆØ­Ø¯Ø©',0),(68790,1911,'fr','Module',0),(68791,1911,'jp','ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«',0),(68792,1911,'pt','MÃ³dulo',0),(68793,1911,'ru','ÐœÐ¾Ð´ÑƒÐ»ÑŒ',0),(68794,1911,'es','MÃ³dulo',0),(68795,1911,'de','Modul',0),(68796,1911,'en','Module',0),(68797,1912,'is','',0),(68798,1912,'dr','Ù…Ø¯Ù„ Ø¯Ø³ØªØ±Ø³ÙŠ ',0),(68799,1912,'pr','Ù…Ø¯Ù„ Ø¯Ø³ØªØ±Ø³ÙŠ ',0),(68800,1912,'tr','EriÅŸim ModÃ¼lÃ¼',0),(68801,1912,'pl','ModuÅ‚ dostÄ™pu',0),(68802,1912,'bg','ÐœÐ¾Ð´ÑƒÐ» Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(68803,1912,'ur','Ù…Ø§ÚˆÛŒÙˆÙ„ Ø±Ø³Ø§Ø¦ÛŒ',0),(68804,1912,'sr','ÐÑ†Ñ†ÐµÑÑ Ð¼Ð¾Ð´ÑƒÐ»',0),(68805,1912,'vi','Truy cáº­p Modun',0),(68806,1912,'af','Module Toegang',0),(68807,1912,'ro','Modul de acces',0),(68808,1912,'et','Moodul juurdepÃ¤Ã¤su',0),(68809,1912,'si','Modul dostop',0),(68810,1912,'ba','Modul akses',0),(68811,1912,'nl','Module toegang',0),(68812,1912,'fi','Moduuli Access',0),(68813,1912,'no','Modulen tilgang',0),(68814,1912,'da','Modul adgang',0),(68815,1912,'ko','ëª¨ë“ˆ ì•¡ì„¸ìŠ¤',0),(68816,1912,'he','×ž×•×“×•×œ ×’×™×©×”',0),(68817,1912,'el','Î•Î½ÏŒÏ„Î·Ï„Î± Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·',0),(68818,1912,'zh','æ¨¡å—è®¿é—®\r\n',0),(68819,1912,'sv','Modulen tillgÃ¥ng',0),(68820,1912,'it','Modulo accesso',0),(68821,1912,'tl','',0),(68822,1912,'th','&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3650;&#3617;&#3604;&#3641;&#3621;',0),(68823,1912,'hi','à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤ªà¤¹à¥à¤à¤š',0),(68824,1912,'ms','Modul akses',0),(68825,1912,'ar','Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ­Ø¯Ø© Ø§Ù„Ù†Ù…Ø·ÙŠØ©',0),(68826,1912,'fr','AccÃ¨s au module',0),(68827,1912,'jp','ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã‚¢ã‚¯ã‚»ã‚¹',0),(68828,1912,'pt','Acesso de mÃ³dulo',0),(68829,1912,'ru','ÐœÐ¾Ð´ÑƒÐ»ÑŒ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°',0),(68830,1912,'es','Acceso a MÃ³dulos',0),(68831,1912,'de','Modul Access',0),(68832,1912,'en','Module Access',0),(68833,1913,'is','',0),(68834,1913,'dr','Ù…Ø§Ù‡ ',0),(68835,1913,'pr','Ù…Ø§Ù‡ ',0),(68836,1913,'tr','Ay',0),(68837,1913,'pl','MiesiÄ…c',0),(68838,1913,'bg','ÐœÐµÑÐµÑ†',0),(68839,1913,'ur','Ù…Ø§Û',0),(68840,1913,'sr','ÐœÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(68841,1913,'vi','ThÃ¡ng',0),(68842,1913,'af','Maand',0),(68843,1913,'ro','LunÄƒ',0),(68844,1913,'et','Kuu',0),(68845,1913,'si','Mesec',0),(68846,1913,'ba','Bulan',0),(68847,1913,'nl','Maand',0),(68848,1913,'fi','Kuukausi',0),(68849,1913,'no','MÃ¥ned',0),(68850,1913,'da','MÃ¥ned',0),(68851,1913,'ko','ë‹¬',0),(68852,1913,'he','×—×•×“×©',0),(68853,1913,'el','ÎœÎ®Î½Î±',0),(68854,1913,'zh','æœˆ',0),(68855,1913,'sv','MÃ¥nad',0),(68856,1913,'it','Mese',0),(68857,1913,'tl','',0),(68858,1913,'th','&#3648;&#3604;&#3639;&#3629;&#3609;',0),(68859,1913,'hi','à¤®à¤¾à¤¹',0),(68860,1913,'ms','Bulan',0),(68861,1913,'ar','Ø§Ù„Ø´Ù‡Ø±',0),(68862,1913,'fr','Mois',0),(68863,1913,'jp','æœˆ',0),(68864,1913,'pt','MÃªs',0),(68865,1913,'ru','ÐœÐµÑÑÑ†',0),(68866,1913,'es','Mes',0),(68867,1913,'de','Monat',0),(68868,1913,'en','Month',0),(68869,1914,'is','',0),(68870,1914,'dr','Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ ',0),(68871,1914,'pr','Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ ',0),(68872,1914,'tr','YÄ±l iÃ§in aylÄ±k',0),(68873,1914,'pl','Co miesiÄ…c na rok',0),(68874,1914,'bg','ÐœÐµÑÐµÑ‡Ð½Ð¾ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(68875,1914,'ur','Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ Ù…Ø§ÛØ§Ù†Û',0),(68876,1914,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¾ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(68877,1914,'vi','HÃ ng thÃ¡ng cho NÄƒm',0),(68878,1914,'af','Maandliks vir die Jaar',0),(68879,1914,'ro','Lunare pentru anul',0),(68880,1914,'et','Igakuine aasta vÃ¤ltel',0),(68881,1914,'si','MeseÄno za leto',0),(68882,1914,'ba','Bulanan untuk tahun',0),(68883,1914,'nl','Maandelijks voor het jaar',0),(68884,1914,'fi','Kuukausittain vuoden',0),(68885,1914,'no','MÃ¥nedlig for Ã¥ret',0),(68886,1914,'da','MÃ¥nedligt for Ã¥ret',0),(68887,1914,'ko','1 ë…„ ë™ì•ˆ ì›”ê°„',0),(68888,1914,'he','×—×•×“×©×™ ×”×©× ×”',0),(68889,1914,'el','ÎšÎ¬Î¸Îµ Î¼Î®Î½Î± Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚',0),(68890,1914,'zh','æ¯æœˆçš„å¹´\r\n',0),(68891,1914,'sv','Varje mÃ¥nad fÃ¶r Ã¥r',0),(68892,1914,'it','Mensile per l\'anno',0),(68893,1914,'tl','',0),(68894,1914,'th','&#3619;&#3634;&#3618;&#3648;&#3604;&#3639;&#3629;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3637;',0),(68895,1914,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¸à¤¿à¤•',0),(68896,1914,'ms','Setiap bulan bagi tahun',0),(68897,1914,'ar','Ø§Ù„Ø´Ù‡Ø±ÙŠ Ù„Ù„Ø³Ù†Ø©',0),(68898,1914,'fr','Tous les mois pour l\'annÃ©e',0),(68899,1914,'jp','ã??ã?®å¹´ã?®æœˆã€…',0),(68900,1914,'pt','Mensal para o ano',0),(68901,1914,'ru','Ð•Ð¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ð¾ Ð·Ð° Ð³Ð¾Ð´',0),(68902,1914,'es','Mensual para el aÃ±o',0),(68903,1914,'de','Monatlich fÃ¼r das Jahr',0),(68904,1914,'en','Monthly for the Year',0),(68905,1915,'is','',0),(68906,1915,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(68907,1915,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(68908,1915,'tr','AylÄ±k rapor',0),(68909,1915,'pl','MiesiÄ™czny raport',0),(68910,1915,'bg','ÐœÐµÑÐµÑ‡ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(68911,1915,'ur','Ù…Ø§ÛØ§Ù†Û Ø±Ù¾ÙˆØ±Ù¹',0),(68912,1915,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(68913,1915,'vi','BÃ¡o cÃ¡o hÃ ng thÃ¡nh',0),(68914,1915,'af','Maandelikse Verslag',0),(68915,1915,'ro','Raport lunar',0),(68916,1915,'et','Kuuajane aruanne',0),(68917,1915,'si','MeseÄno poroÄilo',0),(68918,1915,'ba','Laporan bulanan',0),(68919,1915,'nl','Maandelijkse rapport',0),(68920,1915,'fi','Kuukausittainen raportti',0),(68921,1915,'no','MÃ¥nedlige rapporten',0),(68922,1915,'da','MÃ¥nedlig rapport',0),(68923,1915,'ko','ì›”ê°„ ë³´ê³ ì„œ',0),(68924,1915,'he','×“×•×— ×—×•×“×©×™',0),(68925,1915,'el','ÎœÎ·Î½Î¹Î±Î¯Î± Î­ÎºÎ¸ÎµÏƒÎ·',0),(68926,1915,'zh','æœˆæŠ¥\r\n',0),(68927,1915,'sv','MÃ¥nadsrapport',0),(68928,1915,'it','Rapporto mensile',0),(68929,1915,'tl','',0),(68930,1915,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(68931,1915,'hi','à¤®à¤¾à¤¸à¤¿à¤• à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(68932,1915,'ms','Laporan bulanan',0),(68933,1915,'ar','Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø´Ù‡Ø±ÙŠ',0),(68934,1915,'fr','Rapport mensuel',0),(68935,1915,'jp','æœˆæ¬¡å ±å‘Šæ›¸',0),(68936,1915,'pt','RelatÃ³rio mensal',0),(68937,1915,'ru','ÐœÐµÑÑÑ‡Ð½Ñ‹Ð¹ ÐžÑ‚Ñ‡ÐµÑ‚',0),(68938,1915,'es','Informe Mensual',0),(68939,1915,'de','Monatsbericht',0),(68940,1915,'en','Monthly Report',0),(68941,1916,'is','',0),(68942,1916,'dr','Ù…Ø§Ù‡ Ù‡Ø§ÙŠ Ø³Ø§Ù„',0),(68943,1916,'pr','Ù…Ø§Ù‡ Ù‡Ø§ÙŠ Ø³Ø§Ù„',0),(68944,1916,'tr','YÄ±lÄ±n ayÄ±',0),(68945,1916,'pl','MiesiÄ™cy w roku',0),(68946,1916,'bg','ÐœÐµÑÐµÑ†Ð° Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(68947,1916,'ur','Ø³Ø§Ù„ Ú©Û’ Ù…ÛÛŒÙ†Û’',0),(68948,1916,'sr','ÐœÐµÑÐµÑ†Ð¸ Ð¾Ð²Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(68949,1916,'vi','ThÃ¡ng cá»§a NÄƒm',0),(68950,1916,'af','Maande van die Jaar',0),(68951,1916,'ro','Luni ale anului',0),(68952,1916,'et','Kuu jooksul',0),(68953,1916,'si','Mesecih leta',0),(68954,1916,'ba','Bulan tahun',0),(68955,1916,'nl','Maanden van het jaar',0),(68956,1916,'fi','Kuukauden aikana',0),(68957,1916,'no','Ã…rets mÃ¥neder',0),(68958,1916,'da','MÃ¥neder af Ã¥ret',0),(68959,1916,'ko','ì˜¬í•´ì˜ ë‹¬',0),(68960,1916,'he','×—×•×“×©×™ ×”×©× ×”',0),(68961,1916,'el','ÎœÎ®Î½ÎµÏ‚ Ï„Î¿Ï… Î­Ï„Î¿Ï…Ï‚',0),(68962,1916,'zh','ä¸ªæœˆçš„å¹´\r\n',0),(68963,1916,'sv','MÃ¥nader av Ã¥ret',0),(68964,1916,'it','Mesi dell\'anno',0),(68965,1916,'tl','',0),(68966,1916,'th','&#3648;&#3604;&#3639;&#3629;&#3609;&#3586;&#3629;&#3591;&#3611;&#3637;',0),(68967,1916,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤®à¤¹à¥€à¤¨à¥‡',0),(68968,1916,'ms','Bulan tahun',0),(68969,1916,'ar','Ø£Ø´Ù‡Ø± Ø§Ù„Ø³Ù†Ø©',0),(68970,1916,'fr','Mois de l\'annÃ©e',0),(68971,1916,'jp','ã??ã?®å¹´ã?®æœˆæ•°',0),(68972,1916,'pt','Meses do ano',0),(68973,1916,'ru','ÐœÐµÑÑÑ†Ñ‹ Ð“Ð¾Ð´Ð°',0),(68974,1916,'es','Meses del aÃ±o',0),(68975,1916,'de','Monaten des Jahres',0),(68976,1916,'en','Months of the Year',0),(68977,1917,'is','',0),(68978,1917,'dr','Ø¨ÙŠØ´ØªØ± Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± ',0),(68979,1917,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± ',0),(68980,1917,'tr','Birden fazla mÃ¼rekkep',0),(68981,1917,'pl','WiÄ™cej niÅ¼ jednej farby',0),(68982,1917,'bg','ÐŸÐ¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð¸Ð½ Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ',0),(68983,1917,'ur','Ø§ÛŒÚ© ÛŒØ§ Ø²Ø§Ø¦Ø¯ Ø§Ù†Ú©',0),(68984,1917,'sr','Ð’Ð¸ÑˆÐµ Ð¾Ð´ Ñ˜ÐµÐ´Ð½Ð¾Ð³ Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿ÐµÑ€Ð¾Ð¼',0),(68985,1917,'vi','Nhiá»u hÆ¡n 1 loáº¡i má»±c',0),(68986,1917,'af','Meer as een Ink',0),(68987,1917,'ro','Mai mult de o cernealÄƒ',0),(68988,1917,'et','Rohkem kui Ã¼he tindi',0),(68989,1917,'si','VeÄ kot eno Ärnilo',0),(68990,1917,'ba','Lebih dari satu tinta',0),(68991,1917,'nl','Meer dan Ã©Ã©n inkt',0),(68992,1917,'fi','EnemmÃ¤n kuin yhden vÃ¤rin',0),(68993,1917,'no','Mer enn Ã©n trykkfarge',0),(68994,1917,'da','Mere end Ã©n trykfarve',0),(68995,1917,'ko','í•˜ë‚˜ ì´ìƒì˜ ìž‰í¬',0),(68996,1917,'he','×“×™×• ××—×“ ××• ×™×•×ª×¨',0),(68997,1917,'el','Î ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ± Î±Ï€ÏŒ Î­Î½Î± Î¼ÎµÎ»Î¬Î½Î¹Î±',0),(68998,1917,'zh','è¶…è¿‡ä¸€ä¸ªå¢¨æ°´\r\n',0),(68999,1917,'sv','Mer Ã¤n en tryckfÃ¤rg',0),(69000,1917,'it','PiÃ¹ di un inchiostro',0),(69001,1917,'tl','',0),(69002,1917,'th','&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3627;&#3609;&#3638;&#3656;&#3591;&#3627;&#3617;&#3638;&#3585;',0),(69003,1917,'hi','à¤à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¸à¥à¤¯à¤¾à¤¹à¥€',0),(69004,1917,'ms','Dakwat yang lebih daripada satu',0),(69005,1917,'ar','Ø­Ø¨Ø± ÙˆØ§Ø­Ø¯ Ø£Ùˆ Ø£ÙƒØ«Ø±',0),(69006,1917,'fr','Plus d\'une encre',0),(69007,1917,'jp','ä¸€è‰²ä»¥ä¸Š',0),(69008,1917,'pt','Mais de uma tinta',0),(69009,1917,'ru','Ð‘Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ð¾Ð´Ð½Ð¾Ð¹ ÐºÑ€Ð°ÑÐºÐ¸',0),(69010,1917,'es','MÃ¡s que Una Tinta',0),(69011,1917,'de','Mehr als eine Tinte',0),(69012,1917,'en','More than One Ink',0),(69013,1918,'is','',0),(69014,1918,'dr','Ø­Ø±ÙƒØª Ø¨Ù‡ Ø¹Ù‚Ø¨ ',0),(69015,1918,'pr','Ø­Ø±ÙƒØª Ø¨Ù‡ Ø¹Ù‚Ø¨ ',0),(69016,1918,'tr','Geri Ã§ekilin',0),(69017,1918,'pl','PrzenieÅ›Ä‡ z powrotem',0),(69018,1918,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸ Ð½Ð°Ð·Ð°Ð´',0),(69019,1918,'ur','ÙˆØ§Ù¾Ø³ Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(69020,1918,'sr','ÐšÐ¾Ñ€Ð°Ðº Ð½Ð°Ð·Ð°Ð´',0),(69021,1918,'vi','Trá»Ÿ láº¡i',0),(69022,1918,'af','Beweeg Terug',0),(69023,1918,'ro','Mutare Ã®napoi',0),(69024,1918,'et','Edasi-tagasi',0),(69025,1918,'si','Premakni nazaj',0),(69026,1918,'ba','Memindahkan kembali',0),(69027,1918,'nl','Teruggaan',0),(69028,1918,'fi','Siirry taaksepÃ¤in',0),(69029,1918,'no','Trekk tilbake',0),(69030,1918,'da','Flytte tilbage',0),(69031,1918,'ko','ë‹¤ì‹œ ì´ë™',0),(69032,1918,'he','×–×•×–×• ×œ××—×•×¨',0),(69033,1918,'el','ÎœÎµÏ„Î±ÎºÎ¯Î½Î·ÏƒÎ· Ï€ÏÎ¿Ï‚ Ï„Î± Ï€Î¯ÏƒÏ‰',0),(69034,1918,'zh','ç§»å›ž\r\n',0),(69035,1918,'sv','Flytta tillbaka',0),(69036,1918,'it','Spostare indietro',0),(69037,1918,'tl','',0),(69038,1918,'th','&#3606;&#3629;&#3618;&#3585;&#3621;&#3633;&#3610;',0),(69039,1918,'hi','à¤µà¤¾à¤ªà¤¸ à¤²à¥‡ à¤œà¤¾à¤à¤',0),(69040,1918,'ms','Kembali semula',0),(69041,1918,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ù„Ù„Ø®Ù„Ù',0),(69042,1918,'fr','Revenir en arriÃ¨re',0),(69043,1918,'jp','æˆ»ã‚‹',0),(69044,1918,'pt','Para trÃ¡s',0),(69045,1918,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ ÐÐ°Ð·Ð°Ð´',0),(69046,1918,'es','Mover AtrÃ¡s',0),(69047,1918,'de','ZurÃ¼ckbewegen',0),(69048,1918,'en','Move Back',0),(69049,1919,'is','',0),(69050,1919,'dr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ Ú¯Ø±ÙˆÙ‡ ',0),(69051,1919,'pr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ Ú¯Ø±ÙˆÙ‡ ',0),(69052,1919,'tr','Kategoriyi taÅŸÄ±mak',0),(69053,1919,'pl','PrzesuÅ„ kategoriÄ™',0),(69054,1919,'bg','Ð¥Ð¾Ð´ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(69055,1919,'ur','Ø²Ù…Ø±Û Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(69056,1919,'sr','ÐŸÐ¾Ñ‚ÐµÐ· ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(69057,1919,'vi','Chuyá»ƒn thá»ƒ loáº¡i',0),(69058,1919,'af','Kategorie beweeg',0),(69059,1919,'ro','MutÄƒ categoria',0),(69060,1919,'et','Liikuda kategooria',0),(69061,1919,'si','Premakniti Kategorija',0),(69062,1919,'ba','Memindahkan Kategori',0),(69063,1919,'nl','Categorie verplaatsen',0),(69064,1919,'fi','Siirry luokka',0),(69065,1919,'no','Flytte kategori',0),(69066,1919,'da','Flytte kategori',0),(69067,1919,'ko','ì¹´í…Œê³ ë¦¬ ì´ë™',0),(69068,1919,'he','×œ×”×¢×‘×™×¨ ×§×˜×’×•×¨×™×™×ª',0),(69069,1919,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎºÎ¯Î½Î·ÏƒÎ·',0),(69070,1919,'zh','ç§»åŠ¨åˆ†ç±»\r\n',0),(69071,1919,'sv','Flytta kategori',0),(69072,1919,'it','Spostare la categoria',0),(69073,1919,'tl','',0),(69074,1919,'th','&#3618;&#3657;&#3634;&#3618;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(69075,1919,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤²à¥‡ à¤œà¤¾à¤à¤',0),(69076,1919,'ms','Kategori langkah',0),(69077,1919,'ar','Ù†Ù‚Ù„ Ø§Ù„ÙØ¦Ø©',0),(69078,1919,'fr','CatÃ©gorie de dÃ©mÃ©nagement',0),(69079,1919,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®ç§»å‹•',0),(69080,1919,'pt','Mudar categoria',0),(69081,1919,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(69082,1919,'es','Mover categorÃ­a',0),(69083,1919,'de','Kategorie',0),(69084,1919,'en','Move category',0),(69085,1920,'is','',0),(69086,1920,'dr','Ø­Ø±ÙƒØª Ø¨Ù‡ Ø¬Ù„Ùˆ ',0),(69087,1920,'pr','Ø­Ø±ÙƒØª Ø¨Ù‡ Ø¬Ù„Ùˆ ',0),(69088,1920,'tr','Ä°leriye taÅŸÄ±mak',0),(69089,1920,'pl','IÅ›Ä‡ do przodu',0),(69090,1920,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸ Ð½Ð°Ð¿Ñ€ÐµÐ´',0),(69091,1920,'ur','Ø¢Ú¯Û’ Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(69092,1920,'sr','ÐšÑ€ÐµÐ½Ðµ Ð½Ð°Ð¿Ñ€ÐµÐ´',0),(69093,1920,'vi','Äi lÃªn',0),(69094,1920,'af','Beweeg vorentoe',0),(69095,1920,'ro','Mutare Ã®nainte',0),(69096,1920,'et','Edasi liikuda',0),(69097,1920,'si','Korak naprej',0),(69098,1920,'ba','Bergerak maju',0),(69099,1920,'nl','Vooruit',0),(69100,1920,'fi','EteenpÃ¤in',0),(69101,1920,'no','Fremover',0),(69102,1920,'da','Flytte fremad',0),(69103,1920,'ko','ì•žìœ¼ë¡œ ì´ë™',0),(69104,1920,'he','×œ× ×•×¢ ×§×“×™×ž×”',0),(69105,1920,'el','ÎœÎµÏ„Î±ÎºÎ¯Î½Î·ÏƒÎ· Ï€ÏÎ¿Ï‚ Ï„Î± ÎµÎ¼Ï€ÏÏŒÏ‚',0),(69106,1920,'zh','å‰è¿›\r\n',0),(69107,1920,'sv','GÃ¥ framÃ¥t',0),(69108,1920,'it','Andare avanti',0),(69109,1920,'tl','',0),(69110,1920,'th','&#3648;&#3604;&#3636;&#3609;&#3627;&#3609;&#3657;&#3634;',0),(69111,1920,'hi','à¤†à¤—à¥‡ à¤¬à¤¢à¤¼à¤¨à¤¾',0),(69112,1920,'ms','Bergerak ke hadapan',0),(69113,1920,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ø¥Ù„Ù‰ Ø§Ù„Ø£Ù…Ø§Ù…',0),(69114,1920,'fr','Aller de l\'avant',0),(69115,1920,'jp','é€²ã‚€',0),(69116,1920,'pt','Seguir em frente',0),(69117,1920,'ru','Ð”Ð²Ð¸Ð³Ð°Ñ‚ÑŒÑÑ Ð²Ð¿ÐµÑ€ÐµÐ´',0),(69118,1920,'es','Mover Adelante',0),(69119,1920,'de','VorwÃ¤rts',0),(69120,1920,'en','Move Forward',0),(69121,1921,'is','',0),(69122,1921,'dr','Ø¬Ø§Ø¨Ø¬Ø§ ÙƒÙ†ÙŠØ¯ Ø§ÙŠÙ† Ù…ÙˆØ¶ÙˆØ¹ Ø±Ø§ Ø¨Ù‡ Ø²ÙŠØ±',0),(69123,1921,'pr','Ø¬Ø§Ø¨Ø¬Ø§ ÙƒÙ†ÙŠØ¯ Ø§ÙŠÙ† Ù…ÙˆØ¶ÙˆØ¹ Ø±Ø§ Ø¨Ù‡ Ø²ÙŠØ±',0),(69124,1921,'tr','Bu konu altÄ±nda hareket...',0),(69125,1921,'pl','PrzenieÅ› ten temat pod...',0),(69126,1921,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸ Ñ‚Ð°Ð·Ð¸ Ñ‚ÐµÐ¼Ð° Ð¿Ð¾Ð´...',0),(69127,1921,'ur','Ø§Ø³ Ù…ÙˆØ¶ÙˆØ¹ Ú©Û’ ØªØ­Øª Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº...',0),(69128,1921,'sr','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸ Ð¾Ð²Ñƒ Ñ‚ÐµÐ¼Ñƒ Ð¿Ð¾Ð´...',0),(69129,1921,'vi','Chuyá»ƒn Ä‘á» tÃ i nÃ y dÆ°á»›i',0),(69130,1921,'af','Skuif hierdie onderwerp onder...',0),(69131,1921,'ro','Muta acest subiect sub...',0),(69132,1921,'et','Selle teema raames.',0),(69133,1921,'si','Premikanje to temo pod...',0),(69134,1921,'ba','Pindahkan topik di bawah.',0),(69135,1921,'nl','Dit onderwerp onder verplaatsen...',0),(69136,1921,'fi','SiirrÃ¤ tÃ¤mÃ¤n aiheen alle...',0),(69137,1921,'no','Flytte dette emnet under...',0),(69138,1921,'da','Flyt dette emne under...',0),(69139,1921,'ko','ì´ í•­ëª© ì´ë™...',0),(69140,1921,'he','×œ×”×¢×‘×™×¨ ××ª × ×•×©× ×–×” ×ª×—×ª.',0),(69141,1921,'el','ÎœÎµÏ„Î±ÎºÎ¯Î½Î·ÏƒÎ· ÎºÎ¬Ï„Ï‰ Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¸Î­Î¼Î±...',0),(69142,1921,'zh','ç§»åŠ¨æ­¤ä¸»é¢˜ä¸‹..\r\n',0),(69143,1921,'sv','Flytta detta Ã¤mne under...',0),(69144,1921,'it','Spostare questo argomento sotto...',0),(69145,1921,'tl','',0),(69146,1921,'th','&#3618;&#3657;&#3634;&#3618;&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;&#3609;&#3637;&#3657;&#3616;&#3634;&#3618;&#3651;&#3605;&#3657;',0),(69147,1921,'hi','à¤‡à¤¸ à¤µà¤¿à¤·à¤¯ à¤•à¥‡ à¤…à¤‚à¤¤à¤°à¥à¤—à¤¤ à¤²à¥‡ à¤œà¤¾à¤à¤...',0),(69148,1921,'ms','Mengalih topik ini di bawah.',0),(69149,1921,'ar','Ù†Ù‚Ù„ Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ¶ÙˆØ¹ ØªØ­Øª...',0),(69150,1921,'fr','DÃ©placer ce sujet sous...',0),(69151,1921,'jp','ã?“ã?®ãƒˆãƒ”ãƒƒã‚¯ã‚’ç§»å‹•',0),(69152,1921,'pt','Mover este tÃ³pico sob...',0),(69153,1921,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ Ñ‚ÐµÐ¼Ñƒ Ð¿Ð¾Ð´...',0),(69154,1921,'es','Mover este tÃ³pico bajo ..',0),(69155,1921,'de','Verschieben Sie Thema unter...',0),(69156,1921,'en','Move this topic under ..',0),(69157,1922,'is','',0),(69158,1922,'dr','MSI Ù…Ø¬ØªÙ…Ø¹ Ø³Ø§Ø²Ù‰ Ø¯Ø± Ù…Ù‚ÙŠØ§Ø³ Ù…ØªÙˆØ³Ø·',0),(69159,1922,'pr','MSI Ù…Ø¬ØªÙ…Ø¹ Ø³Ø§Ø²Ù‰ Ø¯Ø± Ù…Ù‚ÙŠØ§Ø³ Ù…ØªÙˆØ³Ø·',0),(69160,1922,'tr','MSI',0),(69161,1922,'pl','MSI',0),(69162,1922,'bg','MSI',0),(69163,1922,'ur','MSI',0),(69164,1922,'sr','ÐœÐ¡Ð˜',0),(69165,1922,'vi','MSI',0),(69166,1922,'af','MSI',0),(69167,1922,'ro','MSI',0),(69168,1922,'et','MSI',0),(69169,1922,'si','MSI',0),(69170,1922,'ba','MSI',0),(69171,1922,'nl','MSI',0),(69172,1922,'fi','MSI',0),(69173,1922,'no','MSI',0),(69174,1922,'da','MSI',0),(69175,1922,'ko','MSI',0),(69176,1922,'he','MSI',0),(69177,1922,'el','MSI',0),(69178,1922,'zh','å¾®æ˜Ÿ\r\n',0),(69179,1922,'sv','MSI',0),(69180,1922,'it','MSI',0),(69181,1922,'tl','',0),(69182,1922,'th','MSI',0),(69183,1922,'hi','MSI',0),(69184,1922,'ms','MSI',0),(69185,1922,'ar','MSI',0),(69186,1922,'fr','MSI',0),(69187,1922,'jp','MSI',0),(69188,1922,'pt','MSI',0),(69189,1922,'ru','MSI',0),(69190,1922,'es','MSI',0),(69191,1922,'de','MSI',0),(69192,1922,'en','MSI',0),(69193,1923,'is','',0),(69194,1923,'dr','Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ú†Ù†Ø¯ Ø´Ø±ÙƒØªÙŠ ',0),(69195,1923,'pr','Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ú†Ù†Ø¯ Ø´Ø±ÙƒØªÙŠ ',0),(69196,1923,'tr','Multicompany destek',0),(69197,1923,'pl','Wsparcie multicompany',0),(69198,1923,'bg','Multicompany Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(69199,1923,'ur','Ù…Ù„Ù¹Ú©ÙˆÙ…Ù¾Ù†ÛŒ Ú©ÛŒ Ø­Ù…Ø§ÛŒØª',0),(69200,1923,'sr','ÐœÑƒÐ»Ñ‚Ð¸Ñ†Ð¾Ð¼Ð¿Ð°Ð½y Ð¿Ð¾Ð´Ñ€ÑˆÐºÐ°',0),(69201,1923,'vi','Há»— trá»£ nhiá»u cty',0),(69202,1923,'af','Multicompany ondersteuning',0),(69203,1923,'ro','Multisocietate suport',0),(69204,1923,'et','Multicompany toetus',0),(69205,1923,'si','Multicompany podpora',0),(69206,1923,'ba','Multicompany dukungan',0),(69207,1923,'nl','Multicompany ondersteuning',0),(69208,1923,'fi','Multicompany tuki',0),(69209,1923,'no','Multicompany stÃ¸tte',0),(69210,1923,'da','Funktioner til flere Support',0),(69211,1923,'ko','Multicompany ì§€ì›',0),(69212,1923,'he','×ª×ž×™×›×” multicompany',0),(69213,1923,'el','Multicompany Ï…Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î·',0),(69214,1923,'zh','å¤šå…¬å¸æ”¯æŒ\r\n',0),(69215,1923,'sv','Multicompany stÃ¶d',0),(69216,1923,'it','Supporto multiempresa',0),(69217,1923,'tl','',0),(69218,1923,'th','&#3585;&#3634;&#3619;&#3626;&#3609;&#3633;&#3610;&#3626;&#3609;&#3640;&#3609;&#3627;&#3621;&#3634;&#3618;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(69219,1923,'hi','Multicompany à¤¸à¤®à¤°à¥à¤¥à¤¨',0),(69220,1923,'ms','Multicompany sokongan',0),(69221,1923,'ar','Ø§Ù„Ø¯Ø¹Ù… Ù…ÙˆÙ„ØªÙŠÙƒÙˆÙ…Ø¨Ø§Ù†ÙŠ',0),(69222,1923,'fr','Soutien multisociÃ©tÃ©',0),(69223,1923,'jp','è¤‡æ•°ä¼?æ¥­ã?«ã‚ˆã‚‹æ”¯æ?´',0),(69224,1923,'pt','Suporte multiempresa',0),(69225,1923,'ru','ÐœÐµÐ¶Ð´Ñƒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¸Ð¼Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÐ¼Ð¸ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ¸',0),(69226,1923,'es','Multiempresa Apoya',0),(69227,1923,'de','Multicompany UnterstÃ¼tzung',0),(69228,1923,'en','Multicompany Support',0),(69229,1924,'is','',0),(69230,1924,'dr','(Ø´Ù…Ø§Ø±Ù†Ø¯Ù‡',0),(69231,1924,'pr','Ù…Ø§Ø´ÙŠÙ† Ø­Ø³Ø§Ø¨(Ø´Ù…Ø§Ø±Ù†Ø¯Ù‡',0),(69232,1924,'tr','Ã‡arpanÄ±',0),(69233,1924,'pl','MnoÅ¼nik',0),(69234,1924,'bg','ÐœÐ½Ð¾Ð¶Ð¸Ñ‚ÐµÐ»',0),(69235,1924,'ur','Ø¶Ø§Ø±Ø¨',0),(69236,1924,'sr','ÐœÐ½Ð¾Ð¶Ð¸Ð»Ð°Ñ†',0),(69237,1924,'vi','Äa táº§ng',0),(69238,1924,'af','Vermenigvuldiger',0),(69239,1924,'ro','Multiplicator',0),(69240,1924,'et','Kordaja',0),(69241,1924,'si','Multiplikator',0),(69242,1924,'ba','Pengganda',0),(69243,1924,'nl','Vermenigvuldiger',0),(69244,1924,'fi','Kerroin',0),(69245,1924,'no','Multiplikator',0),(69246,1924,'da','Multiplikatoren',0),(69247,1924,'ko','ë©€í‹° í”Œë¼ì´ì–´',0),(69248,1924,'he','×ž×›×¤×™×œ',0),(69249,1924,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î®Ï‚',0),(69250,1924,'zh','å¢žåŠ è€…\r\n',0),(69251,1924,'sv','Multiplikator',0),(69252,1924,'it','Moltiplicatore',0),(69253,1924,'tl','',0),(69254,1924,'th','&#3605;&#3633;&#3623;&#3588;&#3641;&#3603;',0),(69255,1924,'hi','à¤—à¥à¤£à¤•',0),(69256,1924,'ms','Pengganda',0),(69257,1924,'ar','Ù…Ø¶Ø§Ø¹Ù',0),(69258,1924,'fr','Multiplicateur',0),(69259,1924,'jp','å€?çŽ‡',0),(69260,1924,'pt','Multiplicador',0),(69261,1924,'ru','ÐœÐ½Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒ',0),(69262,1924,'es','Multiplicador',0),(69263,1924,'de','Multiplikator',0),(69264,1924,'en','Multiplier',0),(69265,1925,'is','',0),(69266,1925,'dr','Ø´Ù…Ø§Ø±Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ¨Øª ÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ… ',0),(69267,1925,'pr','Ø´Ù…Ø§Ø±Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ¨Øª ÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ… ',0),(69268,1925,'tr','Ä°kinci vardiya iÃ§in Ã§arpanÄ±',0),(69269,1925,'pl','MnoÅ¼nik dla drugiej zmiany',0),(69270,1925,'bg','ÐœÐ½Ð¾Ð¶Ð¸Ñ‚ÐµÐ» Ð·Ð° Ð²Ñ‚Ð¾Ñ€Ð° ÑÐ¼ÑÐ½Ð°',0),(69271,1925,'ur','Ø¯ÙˆØ³Ø±ÛŒ Ø´ÙÙ¹ Ú©Û’ Ù„Ø¦Û’ Ø¶Ø§Ø±Ø¨',0),(69272,1925,'sr','ÐœÐ½Ð¾Ð¶Ð¸Ð»Ð°Ñ† Ð·Ð° Ð´Ñ€ÑƒÐ³Ð° ÑÐ¼ÐµÐ½Ð°',0),(69273,1925,'vi','Äa táº§ng cho ca 2',0),(69274,1925,'af','Vermenigvuldiger vir tweede skof',0),(69275,1925,'ro','Multiplicator pentru a doua schimbare',0),(69276,1925,'et','Teine muutus kordaja',0),(69277,1925,'si','Multiplikator za drugo izmeno',0),(69278,1925,'ba','Multiplier untuk perubahan kedua',0),(69279,1925,'nl','Multiplier voor tweede ploeg',0),(69280,1925,'fi','Toinen kerroin',0),(69281,1925,'no','Multiplikator for andre SKIFT',0),(69282,1925,'da','Multiplikator for anden Skift',0),(69283,1925,'ko','ë‘ ë²ˆì§¸ ë³€í™”ì— ëŒ€ í•œ ìŠ¹ìˆ˜',0),(69284,1925,'he','×ž×›×¤×™×œ ×œ×ž×©×ž×¨×ª ×”×©× ×™×™×”',0),(69285,1925,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î®Ï‚ Î³Î¹Î± Î´ÎµÏÏ„ÎµÏÎ· Î±Î»Î»Î±Î³Î®',0),(69286,1925,'zh','æ—¥ç­å¢žåŠ è€…\r\n',0),(69287,1925,'sv','Multiplikator fÃ¶r andra SKIFT',0),(69288,1925,'it','Moltiplicatore per il secondo turno',0),(69289,1925,'tl','',0),(69290,1925,'th','&#3605;&#3633;&#3623;&#3588;&#3641;&#3603;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3618;&#3657;&#3634;&#3618;&#3621;&#3635;&#3604;&#3633;&#3610;&#3607;&#3637;&#3656;&#3626;&#3629;&#3591;',0),(69291,1925,'hi','à¤¦à¥‚à¤¸à¤°à¥€ à¤¶à¤¿à¤«à¥à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤£à¤•',0),(69292,1925,'ms','Pengganda bagi kedua',0),(69293,1925,'ar','Ø§Ù„Ù…Ø¶Ø§Ø¹Ù Ù„Ù„ØªØ­ÙˆÙ„ Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(69294,1925,'fr','Multiplicateur pour le deuxiÃ¨me quart de travail',0),(69295,1925,'jp','ä¸­ã‚·ãƒ•ãƒˆã?®å€?çŽ‡',0),(69296,1925,'pt','Multiplicador para o segundo turno',0),(69297,1925,'ru','ÐœÐ½Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒ Ð´Ð»Ñ Ð²Ñ‚Ð¾Ñ€Ð¾Ð¹ ÑÐ¼ÐµÐ½Ñ‹',0),(69298,1925,'es','Multiplicador para el segundo turno',0),(69299,1925,'de','Multiplikator fÃ¼r die zweite Schicht',0),(69300,1925,'en','Multiplier for second shift',0),(69301,1926,'is','',0),(69302,1926,'dr','Ø´Ù…Ø§Ø±Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ¨Øª ÙƒØ§Ø±ÙŠ Ø³ÙˆÙ… ',0),(69303,1926,'pr','Ø´Ù…Ø§Ø±Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ¨Øª ÙƒØ§Ø±ÙŠ Ø³ÙˆÙ… ',0),(69304,1926,'tr','ÃœÃ§Ã¼ncÃ¼ vardiya iÃ§in Ã§arpanÄ±',0),(69305,1926,'pl','MnoÅ¼nik dla trzeciej zmiany',0),(69306,1926,'bg','ÐœÐ½Ð¾Ð¶Ð¸Ñ‚ÐµÐ» Ð·Ð° Ñ‚Ñ€ÐµÑ‚Ð° ÑÐ¼ÑÐ½Ð°',0),(69307,1926,'ur','ØªÛŒØ³Ø±ÛŒ Ø´ÙÙ¹ Ú©Û’ Ù„Ø¦Û’ Ø¶Ø§Ø±Ø¨',0),(69308,1926,'sr','ÐœÐ½Ð¾Ð¶Ð¸Ð»Ð°Ñ† Ð·Ð° Ñ‚Ñ€ÐµÑ›Ð° ÑÐ¼ÐµÐ½Ð°',0),(69309,1926,'vi','Äa táº§ng cho ca 3',0),(69310,1926,'af','Vermenigvuldiger vir derde skof',0),(69311,1926,'ro','Multiplicator pentru al treilea shift',0),(69312,1926,'et','Kolmas muutus kordaja',0),(69313,1926,'si','Multiplikator za tretji izmeni',0),(69314,1926,'ba','Multiplier untuk pergeseran ketiga',0),(69315,1926,'nl','Multiplier voor derde werktijd',0),(69316,1926,'fi','Kerroin kolmannen siirtyminen',0),(69317,1926,'no','Multiplikator for tredje SKIFT',0),(69318,1926,'da','Multiplikator for tredje Skift',0),(69319,1926,'ko','ì œ 3 ë³€í™”ì— ëŒ€ í•œ ìŠ¹ìˆ˜',0),(69320,1926,'he','×ž×›×¤×™×œ ×œ×ž×©×ž×¨×ª ×”×©×œ×™×©×™×ª',0),(69321,1926,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î® Î³Î¹Î± Ï„ÏÎ¯Ï„Î· Î²Î¬ÏÎ´Î¹Î±',0),(69322,1926,'zh','ç¬¬ä¸‰ç­å¢žåŠ è€…\r\n',0),(69323,1926,'sv','Multiplikator fÃ¶r tredje SKIFT',0),(69324,1926,'it','Moltiplicatore per terzo turno',0),(69325,1926,'tl','',0),(69326,1926,'th','&#3605;&#3633;&#3623;&#3588;&#3641;&#3603;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3618;&#3657;&#3634;&#3618;&#3621;&#3635;&#3604;&#3633;&#3610;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;',0),(69327,1926,'hi','à¤¤à¥€à¤¸à¤°à¥€ à¤ªà¤¾à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤£à¤•',0),(69328,1926,'ms','Pengganda bagi anjakan ketiga',0),(69329,1926,'ar','Ø§Ù„Ù…Ø¶Ø§Ø¹Ù Ù„Ù„ØªØ­ÙˆÙ„ Ø§Ù„Ø«Ø§Ù„Ø«',0),(69330,1926,'fr','Multiplicateur pour le troisiÃ¨me quart de travail',0),(69331,1926,'jp','é?…ã‚·ãƒ•ãƒˆã?®å€?çŽ‡',0),(69332,1926,'pt','Multiplicador para o terceiro turno',0),(69333,1926,'ru','ÐœÐ½Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒ Ð´Ð»Ñ Ñ‚Ñ€ÐµÑ‚ÑŒÐµÐ¹ ÑÐ¼ÐµÐ½Ñ‹',0),(69334,1926,'es','Multiplicador para el tercer turno',0),(69335,1926,'de','Multiplikator fÃ¼r dritte Schicht',0),(69336,1926,'en','Multiplier for third shift',0),(69337,1927,'is','',0),(69338,1927,'dr','Ø¨Ø§ÙŠØ¯ Ø§ÙˆÙ„ Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± ÙˆØ§Ø±Ø¯ Ø´ÙˆØ¯ ',0),(69339,1927,'pr','Ø¨Ø§ÙŠØ¯ Ø§ÙˆÙ„ Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± ÙˆØ§Ø±Ø¯ Ø´ÙˆØ¯ ',0),(69340,1927,'tr','Ä°ÅŸ tÃ¼rleri ilk girmeniz gerekir',0),(69341,1927,'pl','NaleÅ¼y wprowadziÄ‡ rodzaj pracy po raz pierwszy',0),(69342,1927,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð¸Ð´Ð¾Ð²ÐµÑ‚Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿ÑŠÑ€Ð²Ð¾',0),(69343,1927,'ur','Ú©Ø§Ù… Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù… Ù…ÛŒÚº Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(69344,1927,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¿Ñ€Ð²Ð¾ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð²Ñ€ÑÑ‚Ðµ Ñ€Ð°Ð´Ð°',0),(69345,1927,'vi','Pháº£i nháº­p loáº¡i cÃ´ng viá»‡c trÆ°á»›c',0),(69346,1927,'af','Moet werkstipes eers invoer',0),(69347,1927,'ro','Trebuie sÄƒ introduceÅ£i tipurile de lucru Ã®n primul rÃ¢nd',0),(69348,1927,'et','Peate sisestama kÃµigepealt tÃ¶Ã¶ liigid',0),(69349,1927,'si','Morate najprej vnesti vrste dela',0),(69350,1927,'ba','Harus memasukkan jenis pekerjaan pertama',0),(69351,1927,'nl','Werksoorten moet eerst invoeren',0),(69352,1927,'fi','Kirjoita tyÃ¶tyypit ensin',0),(69353,1927,'no','MÃ¥ angi arbeidstyper fÃ¸rst',0),(69354,1927,'da','Skal angive arbejdstyper fÃ¸rst',0),(69355,1927,'ko','ìž‘ì—… ì¢…ë¥˜ë¥¼ ë¨¼ì € ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(69356,1927,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×¡×•×’×™× ×¢×‘×•×“×” ×§×•×“×',0),(69357,1927,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„ÏÏ€Î¿Ï…Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€ÏÏŽÏ„Î±',0),(69358,1927,'zh','å¿…é¡»é¦–å…ˆè¾“å…¥å·¥ä½œç±»åž‹\r\n',0),(69359,1927,'sv','MÃ¥ste ange arbetstyper fÃ¶rst',0),(69360,1927,'it','Necessario immettere prima tipi di lavoro',0),(69361,1927,'tl','',0),(69362,1927,'th','&#3605;&#3657;&#3629;&#3591;&#3611;&#3657;&#3629;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;&#3585;&#3656;&#3629;&#3609;',0),(69363,1927,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¤¹à¤²à¥‡ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(69364,1927,'ms','Mesti masukkan jenis kerja terlebih dahulu',0),(69365,1927,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¹Ù…Ù„ Ø£ÙˆÙ„Ø§Ù‹',0),(69366,1927,'fr','Devez entrer les types de travail dâ€™abord',0),(69367,1927,'jp','ã?¾ã?šä»•äº‹å†…å®¹ã‚’å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(69368,1927,'pt','Deve entrar primeiro o tipos de trabalho',0),(69369,1927,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ñ‚Ð¸Ð¿Ñ‹ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(69370,1927,'es','Debe ingresar tipos de trabajo primero',0),(69371,1927,'de','Arbeitstypen muss zuerst eingezogen werden.',0),(69372,1927,'en','Must enter work types first',0),(69373,1928,'is','',0),(69374,1928,'dr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(69375,1928,'pr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(69376,1928,'tr','Bir satÄ±cÄ±, fatura tarihi ve fatura numarasÄ± olmasÄ± gerekir',0),(69377,1928,'pl','Musi mieÄ‡ dostawcy, faktury Data i numer faktury',0),(69378,1928,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð´Ð°Ñ‚Ð° Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(69379,1928,'ur','ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ Ø§ÛŒÚ© ÙˆÛŒÙ†ÚˆØ±ØŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§ÙˆØ± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(69380,1928,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð¼Ð°Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°, Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(69381,1928,'vi','Pháº£i cÃ³ 1 ngÆ°á»i bÃ¡n, ngÃ y hÃ³a Ä‘Æ¡n & sá»‘ hÃ³a Ä‘Æ¡n',0),(69382,1928,'af','Moet oor \'n Verskaffer, Faktuurdatum EN Faktuurnommer beskik',0),(69383,1928,'ro','Trebuie sÄƒ aibÄƒ un furnizor, facturÄƒ data ÅŸi numÄƒrul facturii',0),(69384,1928,'et','Peab olema tarnija, arve kuupÃ¤ev ja ostuarve number',0),(69385,1928,'si','Mora imeti dobavitelj, raÄuna datum in Å¡tevilko raÄuna',0),(69386,1928,'ba','Harus memiliki Vendor, nomor faktur faktur tanggal dan',0),(69387,1928,'nl','Moet beschikken over een leverancier, de datum van de factuur en het factuurnummer',0),(69388,1928,'fi','On toimittaja, laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n ja laskunumero',0),(69389,1928,'no','MÃ¥ ha en leverandÃ¸r, faktura og fakturanummeret',0),(69390,1928,'da','Skal have en kreditor, faktura dato og fakturanummer',0),(69391,1928,'ko','ê³µê¸‰ ì—…ì²´, ì†¡ìž¥ ë‚ ì§œ ë° ì†¡ìž¥ ë²ˆí˜¸ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(69392,1928,'he','×‘×˜×— ×™×© ×¡×¤×§, ×ª××¨×™×š ×”×—×©×‘×•× ×™×ª, ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(69393,1928,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î­Î½Î± Ï€Ï‰Î»Î·Ï„Î®, Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ±Î¹ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(69394,1928,'zh','å¿…é¡»å…·æœ‰ä¾›åº”å•†ï¼Œå‘ç¥¨æ—¥æœŸåŠå‘ç¥¨å·ç \r\n',0),(69395,1928,'sv','MÃ¥ste ha en leverantÃ¶r, faktura datum och fakturanummer',0),(69396,1928,'it','Necessario disporre di un fornitore, fattura data e numero della fattura',0),(69397,1928,'tl','',0),(69398,1928,'th','&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;, &#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657; &#3649;&#3621;&#3632;&#3627;&#3617;&#3634;&#3618;&#3648;',0),(69399,1928,'hi','à¤à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾, à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤”à¤° à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¤‚à¤¬à¤° à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(69400,1928,'ms','Mesti penjual, nombor invois tarikh invois dan',0),(69401,1928,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† ÙˆØ¬ÙˆØ¯ Ù…ÙˆØ±Ù‘Ø¯ Ùˆ Ø±Ù‚Ù… ÙˆØªØ§Ø±ÙŠØ® Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨',0),(69402,1928,'fr','Doit avoir un fournisseur, la Date de facture et le numÃ©ro de facture',0),(69403,1928,'jp','æ¥­è€…ã?®è«‹æ±‚æ›¸ç•ªå?·ã?¨è«‹æ±‚æ›¸æ—¥ä»˜ã?Œå¿…è¦?ã?§ã?™',0),(69404,1928,'pt','Deve ter um fornecedor, nota fiscal data e nÃºmero da fatura',0),(69405,1928,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¸Ð¼ÐµÑ‚ÑŒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°, ÑÑ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð”Ð°Ñ‚Ð° Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(69406,1928,'es','Debe tener un Proveedor, Fecha de Factura Y NÃºmero de Factura',0),(69407,1928,'de','Muss ein Hersteller, Rechnung DATUMUND Rechnungsnummer',0),(69408,1928,'en','Must have a Vendor, Invoice Date AND Invoice Number',0),(69409,1929,'is','',0),(69410,1929,'dr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø«Ø¨Øª Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(69411,1929,'pr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø«Ø¨Øª Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(69412,1929,'tr','Bir giriÅŸi olmasÄ± gerekir',0),(69413,1929,'pl','Musi istnieÄ‡ wpis',0),(69414,1929,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(69415,1929,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(69416,1929,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½ÐµÐºÑƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(69417,1929,'vi','Cáº§n pháº£i cÃ³ 1 Entry',0),(69418,1929,'af','Moet \'n Inskrywing HÃª',0),(69419,1929,'ro','Trebuie sÄƒ aibÄƒ o intrare',0),(69420,1929,'et','Peab olema mÃµni kirje',0),(69421,1929,'si','Mora imeti postavko',0),(69422,1929,'ba','Harus memiliki entri',0),(69423,1929,'nl','Moet een vermelding',0),(69424,1929,'fi','On oltava merkintÃ¤',0),(69425,1929,'no','MÃ¥ ha en oppfÃ¸ring',0),(69426,1929,'da','Skal Have en post',0),(69427,1929,'ko','í•­ëª©ì´ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(69428,1929,'he','×‘×˜×— ×™×© ×¢×¨×š',0),(69429,1929,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÎ¹ Î¼Î¹Î± ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·',0),(69430,1929,'zh','å¿…é¡»æœ‰ä¸€ä¸ªå…¥å£\r\n',0),(69431,1929,'sv','MÃ¥ste ha en post',0),(69432,1929,'it','Deve avere una voce',0),(69433,1929,'tl','',0),(69434,1929,'th','&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(69435,1929,'hi','à¤•à¤¿à¤¸à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥€ à¤¹à¥‹à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(69436,1929,'ms','Mesti ada kemasukan',0),(69437,1929,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø¥Ø¯Ø®Ø§Ù„',0),(69438,1929,'fr','Doit avoir une entrÃ©e',0),(69439,1929,'jp','å…¥åŠ›ã?Œã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(69440,1929,'pt','Deve ter uma entrada',0),(69441,1929,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾ Ð¸Ð¼ÐµÑ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(69442,1929,'es','Debe Tener una Entrada',0),(69443,1929,'de','Muss einen Eintrag enthalten',0),(69444,1929,'en','Must Have an Entry',0),(69445,1930,'is','',0),(69446,1930,'dr','Ø¨Ø§ÙŠØ¯ Ø§ÙˆÙ„ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ØªÙ†Ø¸ÙŠÙ… Ø¨Ø§Ø´Ø¯  ',0),(69447,1930,'pr','Ø¨Ø§ÙŠØ¯ Ø§ÙˆÙ„ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ØªÙ†Ø¸ÙŠÙ… Ø¨Ø§Ø´Ø¯  ',0),(69448,1930,'tr','SatÄ±cÄ± ÅŸartlarÄ± Ã¶nce ayarlamanÄ±z gerekir',0),(69449,1930,'pl','NaleÅ¼y zdefiniowaÄ‡ warunki sprzedawcy najpierw',0),(69450,1930,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¿ÑŠÑ€Ð²Ð¾',0),(69451,1930,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø· Ù¾ÛÙ„Û’ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(69452,1930,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¿Ñ€Ð²Ð¾ Ð´Ð° Ð¿Ð¾Ð´ÐµÑÐ¸Ñ‚Ðµ ÑƒÑÐ»Ð¾Ð²Ðµ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(69453,1930,'vi','Pháº£i setup Ä‘iá»u khoáº£n ngÆ°á»i bÃ¡n trÆ°á»›c',0),(69454,1930,'af','Moet eers Verskafferterme opstel',0),(69455,1930,'ro','Trebuie sÄƒ setaÅ£i un furnizor mai Ã®ntÃ¢i',0),(69456,1930,'et','Peate eelnevalt sisestama tarnetingimused',0),(69457,1930,'si','Morate nastaviti pogoje dobavitelja najprej',0),(69458,1930,'ba','Harus mengatur syarat Vendor pertama',0),(69459,1930,'nl','Leverancier voorwaarden moet eerst instellen',0),(69460,1930,'fi','On mÃ¤Ã¤ritettÃ¤vÃ¤ toimittajan ensin',0),(69461,1930,'no','MÃ¥ opprette leverandÃ¸ren betingelsene fÃ¸rst',0),(69462,1930,'da','FÃ¸rst skal angive leverandÃ¸ren vilkÃ¥r',0),(69463,1930,'ko','ê³µê¸‰ ì—…ì²´ ìš©ì–´ë¥¼ ë¨¼ì € ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(69464,1930,'he','×¢×œ×™×š ×œ×”×’×“×™×¨ ×¡×¤×§ ×ª× ××™ ×§×•×“×',0),(69465,1930,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¯ÏƒÎµÏ„Îµ Ï€ÏÏŽÏ„Î± Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(69466,1930,'zh','å¿…é¡»é¦–å…ˆè®¾ç½®ä¾›åº”å•†æ¡æ¬¾\r\n',0),(69467,1930,'sv','FÃ¶rst mÃ¥ste stÃ¤lla in villkor fÃ¶r leverantÃ¶r',0),(69468,1930,'it','Necessario impostare prima di termini fornitore',0),(69469,1930,'tl','',0),(69470,1930,'th','&#3605;&#3657;&#3629;&#3591;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3585;&#3656;&#3629;&#3609;',0),(69471,1930,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤•à¥‹ à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ à¤ªà¤¹à¤²à¥‡',0),(69472,1930,'ms','Mesti menyediakan syarat-syarat penjual terlebih dahulu',0),(69473,1930,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø¥Ø¹Ø¯Ø§Ø¯ Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø£ÙˆÙ„Ø§',0),(69474,1930,'fr','Devez configurer termes vendeur tout dâ€™abord',0),(69475,1930,'jp','æ¥­è€…æ?¡ä»¶ã‚’ã?¾ã?šè¨­å®šã?—ã?¦ã??ã? ã?•ã?„',0),(69476,1930,'pt','Deve configurar fornecedor termos primeiro',0),(69477,1930,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(69478,1930,'es','Debe configurar los TÃ©rminos de Proveedor primero',0),(69479,1930,'de','MÃ¼ssen Hersteller Bedingungen einrichten zuerst',0),(69480,1930,'en','Must set up Vendor Terms first',0),(69481,1931,'is','',0),(69482,1931,'dr','Ø¨Ø§ÙŠØ¯ Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÙŠØ¯ ',0),(69483,1931,'pr','Ø¨Ø§ÙŠØ¯ Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÙŠØ¯ ',0),(69484,1931,'tr','En az bir (1) satÄ±cÄ± olmasÄ± gerekir',0),(69485,1931,'pl','Musi mieÄ‡ co najmniej jeden (1) sprzedawca',0),(69486,1931,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð¿Ð¾Ð½Ðµ ÐµÐ´Ð¸Ð½ (1) Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(69487,1931,'ur','Ø§ÛŒÚ© Ú©Ù… Ø§Ø² Ú©Ù… (1) ÙˆÛŒÙ†ÚˆØ± ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(69488,1931,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½Ð°Ñ˜Ð¼Ð°ÑšÐµ Ñ˜ÐµÐ´Ð°Ð½ (1) Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(69489,1931,'vi','Pháº£i cÃ³ Ã­ nháº¥t 1 ngÆ°á»i bÃ¡n',0),(69490,1931,'af','Moet ten minste een (1) handelaar het',0),(69491,1931,'ro','Trebuie sÄƒ aveÅ£i cel puÅ£in unul 1 furnizor',0),(69492,1931,'et','Peab olema vÃ¤hemalt Ã¼ks (1) hankija',0),(69493,1931,'si','Mora imeti vsaj enega (1) prodajalec',0),(69494,1931,'ba','Harus memiliki setidaknya satu (1) Vendor',0),(69495,1931,'nl','Moet ten minste Ã©Ã©n (1) leverancier',0),(69496,1931,'fi','On oltava vÃ¤hintÃ¤Ã¤n yksi (1) toimittaja',0),(69497,1931,'no','MÃ¥ ha minst Ã©n (1) leverandÃ¸r',0),(69498,1931,'da','Skal have mindst Ã©n (1) leverandÃ¸r',0),(69499,1931,'ko','ì ì–´ë„ í•˜ë‚˜ì˜ (1) ê³µê¸‰ ì—…ì²´ê°€ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(69500,1931,'he','×—×™×™×‘ ×œ×”×™×•×ª ×œ×¤×—×•×ª ××—×“ (1) ×¡×¤×§',0),(69501,1931,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î­Î½Î± (1) Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(69502,1931,'zh','å¿…é¡»æœ‰è‡³å°‘ä¸€ï¼ˆ1ï¼‰ä¸ªä¾›åº”å•†\r\n',0),(69503,1931,'sv','MÃ¥ste ha minst en (1) leverantÃ¶r',0),(69504,1931,'it','Deve avere almeno uno 1 Fornitore',0),(69505,1931,'tl','',0),(69506,1931,'th','&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3629;&#3618;&#3656;&#3634;&#3591;&#3609;&#3657;&#3629;&#3618;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3627;&#3609;&#3638;&#3656;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(69507,1931,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• (1) à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(69508,1931,'ms','Mesti mempunyai sekurang-kurangnya satu (1) Penjual',0),(69509,1931,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯Ù‰ Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„ ÙˆØ§Ø­Ø¯ 1',0),(69510,1931,'fr','Doit avoir au moins un 1 fournisseur',0),(69511,1931,'jp','å°‘ã?ªã??ã?¦ã‚‚ä¸€ã?¤ã?®æ¥­è€…ã‚’å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(69512,1931,'pt','Deve ter pelo menos um 1 fornecedor',0),(69513,1931,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¸Ð¼ÐµÑ‚ÑŒ Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼ Ð¾Ð´Ð¸Ð½ (1) Ð¿Ñ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(69514,1931,'es','Debe Tener por lo menos un (1) Proveedor',0),(69515,1931,'de','Muss mindestens eine 1 Anbieter',0),(69516,1931,'en','Must have at least one (1) Vendor',0),(69517,1932,'is','',0),(69518,1932,'dr','MWT',0),(69519,1932,'pr','MWT',0),(69520,1932,'tr','MWT',0),(69521,1932,'pl','MWT',0),(69522,1932,'bg','MWT',0),(69523,1932,'ur','Ø§ØªÙˆÙ¹',0),(69524,1932,'sr','ÐœWÐ¢',0),(69525,1932,'vi','MWT',0),(69526,1932,'af','MWT',0),(69527,1932,'ro','MW TERMICI',0),(69528,1932,'et','MWT',0),(69529,1932,'si','MWT',0),(69530,1932,'ba','MWT',0),(69531,1932,'nl','MWT',0),(69532,1932,'fi','MWT',0),(69533,1932,'no','MWT',0),(69534,1932,'da','MWT',0),(69535,1932,'ko','MWT',0),(69536,1932,'he','MWT',0),(69537,1932,'el','MWT',0),(69538,1932,'zh','é‡é‡1000å¼ çº¸\r\n',0),(69539,1932,'sv','MWT',0),(69540,1932,'it','MWT',0),(69541,1932,'tl','',0),(69542,1932,'th','MWT',0),(69543,1932,'hi','MWT',0),(69544,1932,'ms','MWT',0),(69545,1932,'ar','MWT',0),(69546,1932,'fr','MWT',0),(69547,1932,'jp','MWT',0),(69548,1932,'pt','MWT',0),(69549,1932,'ru','ÐœÐ’Ð¢',0),(69550,1932,'es','MWT',0),(69551,1932,'de','MWT',0),(69552,1932,'en','MWT',0),(69553,1933,'is','',0),(69554,1933,'dr','N',0),(69555,1933,'pr','N',0),(69556,1933,'tr','N',0),(69557,1933,'pl','N',0),(69558,1933,'bg','N',0),(69559,1933,'ur','Ù†',0),(69560,1933,'sr','Ð',0),(69561,1933,'vi','N',0),(69562,1933,'af','N',0),(69563,1933,'ro','N',0),(69564,1933,'et','N',0),(69565,1933,'si','N',0),(69566,1933,'ba','N',0),(69567,1933,'nl','N',0),(69568,1933,'fi','N',0),(69569,1933,'no','N',0),(69570,1933,'da','N',0),(69571,1933,'ko','N',0),(69572,1933,'he','N',0),(69573,1933,'el','N',0),(69574,1933,'zh','N\r\n',0),(69575,1933,'sv','N',0),(69576,1933,'it','N',0),(69577,1933,'tl','',0),(69578,1933,'th','N',0),(69579,1933,'hi','à¤à¤¨',0),(69580,1933,'ms','N',0),(69581,1933,'ar','N',0),(69582,1933,'fr','N',0),(69583,1933,'jp','N',0),(69584,1933,'pt','N',0),(69585,1933,'ru','N',0),(69586,1933,'es','N',0),(69587,1933,'de','N',0),(69588,1933,'en','N',0),(69589,1934,'is','',0),(69590,1934,'dr','N/A',0),(69591,1934,'pr','N/A',0),(69592,1934,'tr','N/A',0),(69593,1934,'pl','N/D!',0),(69594,1934,'bg','N/A',0),(69595,1934,'ur','Ù„Ø§Ú¯Ùˆ Ù†ÛÛŒÚº',0),(69596,1934,'sr','Ð/Ð',0),(69597,1934,'vi','KhÃ´ng cÃ³',0),(69598,1934,'af','N.V.T.',0),(69599,1934,'ro','N/A',0),(69600,1934,'et','N/A',0),(69601,1934,'si','N /',0),(69602,1934,'ba','N/A',0),(69603,1934,'nl','N/B',0),(69604,1934,'fi','N/A',0),(69605,1934,'no','I/T',0),(69606,1934,'da','NIELSEN',0),(69607,1934,'ko','N/A',0),(69608,1934,'he','N/A',0),(69609,1934,'el','Î”/Î¥',0),(69610,1934,'zh','ä¸å¯ç”¨\r\n',0),(69611,1934,'sv','N/A',0),(69612,1934,'it','N/A',0),(69613,1934,'tl','',0),(69614,1934,'th','&#3652;&#3617;&#3656;&#3617;&#3637;',0),(69615,1934,'hi','N/A',0),(69616,1934,'ms','N/A',0),(69617,1934,'ar','ØºÙŠØ± Ù…ØªØ§Ø­',0),(69618,1934,'fr','N/A',0),(69619,1934,'jp','N/A',0),(69620,1934,'pt','N/A',0),(69621,1934,'ru','Ð/Ð”',0),(69622,1934,'es','N/A',0),(69623,1934,'de','N/A',0),(69624,1934,'en','N/A',0),(69625,1935,'is','',0),(69626,1935,'dr','Ù†Ø§Ù… ',0),(69627,1935,'pr','Ù†Ø§Ù… ',0),(69628,1935,'tr','AdÄ±',0),(69629,1935,'pl','Nazwa',0),(69630,1935,'bg','Ð˜Ð¼Ðµ',0),(69631,1935,'ur','Ù†Ø§Ù…',0),(69632,1935,'sr','Ð˜Ð¼Ðµ',0),(69633,1935,'vi','TÃªn',0),(69634,1935,'af','Naam',0),(69635,1935,'ro','Nume',0),(69636,1935,'et','Nimi',0),(69637,1935,'si','ime',0),(69638,1935,'ba','Nama',0),(69639,1935,'nl','Naam',0),(69640,1935,'fi','Nimi',0),(69641,1935,'no','navn',0),(69642,1935,'da','Navn',0),(69643,1935,'ko','ì´ë¦„',0),(69644,1935,'he','×©×',0),(69645,1935,'el','ÎŒÎ½Î¿Î¼Î±',0),(69646,1935,'zh','åç§°\r\n',0),(69647,1935,'sv','Namn',0),(69648,1935,'it','Nome',0),(69649,1935,'tl','',0),(69650,1935,'th','&#3594;&#3639;&#3656;&#3629;',0),(69651,1935,'hi','à¤¨à¤¾à¤®',0),(69652,1935,'ms','Nama',0),(69653,1935,'ar','Ø§Ù„Ø§Ø³Ù…',0),(69654,1935,'fr','Nom',0),(69655,1935,'jp','å??å‰?',0),(69656,1935,'pt','Nome',0),(69657,1935,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ',0),(69658,1935,'es','Nombre',0),(69659,1935,'de','Name',0),(69660,1935,'en','Name',0),(69661,1936,'is','',0),(69662,1936,'dr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† Ù‡Ø§ ',0),(69663,1936,'pr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† Ù‡Ø§ ',0),(69664,1936,'tr','Aile makine adÄ±',0),(69665,1936,'pl','Nazwa rodziny maszyn',0),(69666,1936,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾ Ð¾Ñ‚ Ð¼Ð°ÑˆÐ¸Ð½Ð¸',0),(69667,1936,'ur','Ù…Ø´ÛŒÙ†ÙˆÚº Ú©Û’ Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Ø§ Ù†Ø§Ù…',0),(69668,1936,'sr','Ð˜Ð¼Ðµ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(69669,1936,'vi','TÃªn cá»§a MÃ¡y Gia ÄÃ¬nh ',0),(69670,1936,'af','Naam van familie van masjiene',0),(69671,1936,'ro','Numele de familie de maÅŸini',0),(69672,1936,'et','Masinad perekonna nimi',0),(69673,1936,'si','Ime druÅ¾ine strojev',0),(69674,1936,'ba','Nama keluarga mesin',0),(69675,1936,'nl','Naam van familie van machines',0),(69676,1936,'fi','Nimi tuoteperhe',0),(69677,1936,'no','Navnet pÃ¥ av maskiner',0),(69678,1936,'da','Navn i familien af maskiner',0),(69679,1936,'ko','ê¸°ê³„ì˜ ê°€ì¡±ì˜ ì´ë¦„',0),(69680,1936,'he','×©× ×”×ž×©×¤×—×” ×©×œ ×ž×›×•× ×•×ª',0),(69681,1936,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±Ï‚ Ï„Ï‰Î½ Î¼Î·Ï‡Î±Î½ÏŽÎ½',0),(69682,1936,'zh','æœºå™¨ç³»åˆ—åç§°\r\n',0),(69683,1936,'sv','Namnet pÃ¥ familjen av maskiner',0),(69684,1936,'it','Nome della famiglia di macchine',0),(69685,1936,'tl','',0),(69686,1936,'th','&#3594;&#3639;&#3656;&#3629;&#3594;&#3640;&#3604;&#3586;&#3629;&#3591;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(69687,1936,'hi','à¤®à¤¶à¥€à¤¨à¥‹à¤‚ à¤•à¥‡ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤•à¥‡ à¤¨à¤¾à¤®',0),(69688,1936,'ms','Nama keluarga Mesin',0),(69689,1936,'ar','Ø§Ø³Ù… Ø§Ù„Ø¹Ø§Ø¦Ù„Ø© Ù„Ø¢Ù„Ø§Øª',0),(69690,1936,'fr','Nom de famille de machines',0),(69691,1936,'jp','æ©Ÿæ¢°ç³»çµ±å??',0),(69692,1936,'pt','Nome de famÃ­lia de mÃ¡quinas',0),(69693,1936,'ru','Ð˜Ð¼Ñ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð° Ð¼Ð°ÑˆÐ¸Ð½',0),(69694,1936,'es','Nombre de la familia de mÃ¡quinas',0),(69695,1936,'de','Name der Familie von Maschinen',0),(69696,1936,'en','Name of family of machines',0),(69697,1937,'is','',0),(69698,1937,'dr','Ù†Ø§Ù… Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø± Ø¯ÙŠÚ¯Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(69699,1937,'pr','Ù†Ø§Ù… Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø± Ø¯ÙŠÚ¯Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(69700,1937,'tr','Ad ve parola var baÅŸka bir kullanÄ±cÄ± iÃ§in',0),(69701,1937,'pl','Nazwa i hasÅ‚o dla innego uÅ¼ytkownika istnieje',0),(69702,1937,'bg','Ð˜Ð¼ÐµÑ‚Ð¾ Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð°Ñ‚Ð° Ð·Ð° Ð´Ñ€ÑƒÐ³ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(69703,1937,'ur','Ù†Ø§Ù… Ø§ÙˆØ± Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Ú©Ø³ÛŒ Ø¯ÙˆØ³Ø±Û’ ØµØ§Ø±Ù Ú©Û’ Ù„Ø¦Û’',0),(69704,1937,'sr','Ð˜Ð¼Ðµ Ð¸ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ð·Ð° Ð´Ñ€ÑƒÐ³Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(69705,1937,'vi','TÃªn & máº­t kháº©u cá»§a ngÆ°á»i sá»­ dá»¥ng khÃ¡c',0),(69706,1937,'af','Naam en Wagwoord Bestaan vir \'n ander gebruiker',0),(69707,1937,'ro','Numele ÅŸi parola existÄƒ pentru un alt utilizator',0),(69708,1937,'et','Nimi ja parool on olemas teine kasutaja',0),(69709,1937,'si','Ime in geslo za drug uporabnik obstaja',0),(69710,1937,'ba','Nama dan Password yang ada untuk pengguna lain',0),(69711,1937,'nl','Naam en wachtwoord bestaat voor een andere gebruiker',0),(69712,1937,'fi','Nimi ja salasana on toinen kÃ¤yttÃ¤jÃ¤',0),(69713,1937,'no','Navn og passord finnes for en annen bruker',0),(69714,1937,'da','Navn og adgangskode for en anden bruger',0),(69715,1937,'ko','ì´ë¦„ ë° ì•”í˜¸ëŠ” ë‹¤ë¥¸ ì‚¬ìš©ìžì— ëŒ€ í•œ ì¡´ìž¬',0),(69716,1937,'he','×©× ×•×§×™×™× ×¡×™×¡×ž×” ×¢×‘×•×¨ ×ž×©×ª×ž×© ××—×¨',0),(69717,1937,'el','ÎŒÎ½Î¿Î¼Î± ÎºÎ±Î¹ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï€Î¿Ï… Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î³Î¹Î± Î¬Î»Î»Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(69718,1937,'zh','åç§°å’Œå¯†ç å·²å­˜åœ¨ä¸Žå¦ä¸€åç”¨æˆ·\r\n',0),(69719,1937,'sv','Namn och lÃ¶senord finns fÃ¶r en annan anvÃ¤ndare',0),(69720,1937,'it','Nome e Password esiste per un altro utente',0),(69721,1937,'tl','',0),(69722,1937,'th','&#3594;&#3639;&#3656;&#3629;&#3649;&#3621;&#3632;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3609;&#3637;&#3657;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3612;&#3641;&#3',0),(69723,1937,'hi','à¤¨à¤¾à¤® à¤”à¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤',0),(69724,1937,'ms','Nama dan kata laluan wujud untuk pengguna lain',0),(69725,1937,'ar','Ø§Ù„Ø§Ø³Ù… ÙˆÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ù…ÙˆØ¬ÙˆØ¯Ø© Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¢Ø®Ø±',0),(69726,1937,'fr','Nom et mot de passe existe pour un autre utilisateur',0),(69727,1937,'jp','å??å‰?ã?¨ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(69728,1937,'pt','Nome e senha existe para outro usuÃ¡rio',0),(69729,1937,'ru','Ð˜Ð¼Ñ Ð¸ ÐŸÐ°Ñ€Ð¾Ð»ÑŒ Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð´Ð»Ñ Ð´Ñ€ÑƒÐ³Ð¾Ð³Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(69730,1937,'es','Nombre y Clave Existen para otro usuario',0),(69731,1937,'de','Name und Passwort vorhanden ist fÃ¼r einen anderen Benutzer',0),(69732,1937,'en','Name and Password Exists for another user',0),(69733,1938,'is','',0),(69734,1938,'dr','ØªØµØ§ÙˆÙŠØ± Ø´Ù…Ø§ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø¯Ø± ÙØ§ÙƒØªÙˆØ±  Ø¨Ø§ÙŠØ¯ Ø¯Ø± Ø§ÙŠÙ† Ù‚Ø§Ù„Ø¨ Ø¨Ø§Ø´Ø¯ \r\nJPEG',0),(69735,1938,'pr','ØªØµØ§ÙˆÙŠØ± Ø´Ù…Ø§ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø¯Ø± ÙØ§ÙƒØªÙˆØ±  Ø¨Ø§ÙŠØ¯ Ø¯Ø± Ø§ÙŠÙ† Ù‚Ø§Ù„Ø¨ Ø¨Ø§Ø´Ø¯ \r\nJPEG',0),(69736,1938,'tr','GÃ¶rÃ¼ntÃ¼nÃ¼zÃ¼ olmasÄ± gerekir.FaturayÄ± yazdÄ±rmak iÃ§in JPEG formatÄ±',0),(69737,1938,'pl','Obraz musi byÄ‡.Formacie JPEG do wydrukowania na fakturze',0),(69738,1938,'bg','Ð’Ð°ÑˆÐµÑ‚Ð¾ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ.JPEG Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð·Ð° Ð´Ð° Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(69739,1938,'ur','Ø¢Ù¾ Ú©ÛŒ ØªØµÙˆÛŒØ± Ù…ÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ Û”Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…ÛŒÚº Ú†Ú¾Ø§Ù¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ JPEG ÙØ§Ø±Ù…ÛŒÙ¹',0),(69740,1938,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ñ˜Ðµ Ñ‚Ð²Ð¾Ñ˜Ð° ÑÐ»Ð¸ÐºÐ° Ñƒ. ÐˆÐŸÐ•Ð“ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(69741,1938,'vi','áº¤n tÆ°á»£ng cá»§a báº¡n pháº£i lÃ  JPEG Ä‘á»ƒ in trong hÃ³a Ä‘Æ¡n',0),(69742,1938,'af','U beeld moet in .JPEG-formaat wees om op faktuur te druk',0),(69743,1938,'ro','Imaginea trebuie sÄƒ fie.Format JPEG pentru a imprima Ã®n facturÄƒ',0),(69744,1938,'et','Teie pilt peab olema.JPEG-vormingus arve printimiseks',0),(69745,1938,'si','VaÅ¡a slika mora biti v.JPEG format za tiskanje v raÄunu',0),(69746,1938,'ba','Gambar Anda harus dalam.Format JPEG untuk mencetak dalam faktur',0),(69747,1938,'nl','Uw afbeelding moet.JPEG-indeling af te drukken op factuur',0),(69748,1938,'fi','Kuvan on oltava.JPEG-muodossa tulostaa laskun',0),(69749,1938,'no','Bildet mÃ¥ vÃ¦re i.JPEG-format i fakturaen',0),(69750,1938,'da','Dit billede skal vÃ¦re i.JPEG format skal udskrives pÃ¥ fakturaen',0),(69751,1938,'ko','ì´ë¯¸ì§€ ì´ì–´ì•¼ í•©ë‹ˆë‹¤.ì¸ë³´ì´ìŠ¤ë¥¼ ì¸ì‡„ í•˜ë ¤ë©´ JPEG í¬ë§·',0),(69752,1938,'he','×”×ª×ž×•× ×” ×©×œ×š ×—×™×™×‘ ×œ×”×™×•×ª.×ª×‘× ×™×ª JPEG ×œ×”×“×¤×™×¡ ×—×©×‘×•× ×™×ª',0),(69753,1938,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÏƒÎ±Ï‚ ÎµÎ¹ÎºÏŒÎ½Î±.ÎœÎ¿ÏÏ†Î® JPEG Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(69754,1938,'zh','æ‚¨çš„å›¾ç‰‡å¿…é¡»æ˜¯ä»¥JPEGæ ¼å¼åœ¨å‘ç¥¨ä¸­æ‰“å°\r\n',0),(69755,1938,'sv','Bilden mÃ¥ste vara i.JPEG-format att skriva ut fakturan',0),(69756,1938,'it','L\'immagine deve essere.Formato JPEG per la stampa in fattura',0),(69757,1938,'tl','',0),(69758,1938,'th','&#3616;&#3634;&#3614;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610; JPEG &#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3614;&#36',0),(69759,1938,'hi','à¤…à¤ªà¤¨à¥€ à¤›à¤µà¤¿ à¤®à¥‡à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤JPEG à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¾à¤²à¤¾à¤¨ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(69760,1938,'ms','Imej mesti dalam.Format JPEG mencetak invois',0),(69761,1938,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙƒÙˆÙ† Ø§Ù„ØµÙˆØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ ÙÙŠ.ØªÙ†Ø³ÙŠÙ‚ JPEG Ù„Ø·Ø¨Ø§Ø¹Ø© ÙÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(69762,1938,'fr','Votre image doit avoir.Format JPEG Ã  imprimer dans la facture',0),(69763,1938,'jp','è«‹æ±‚æ›¸ã?®å?°åˆ·ã?«ã?¯ç”»åƒ?ã?¯ï¼ªï¼°ï¼¥ï¼§ã?§ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(69764,1938,'pt','Sua imagem deve estar em.Formato JPEG para imprimir em fatura',0),(69765,1938,'ru','Ð’Ð°ÑˆÐµ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ð².Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ JPEG Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð² ÑÑ‡ÐµÑ‚Ðµ-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(69766,1938,'es','Su imagen debe estar en el formato .JPEG para imprimir en la Factura',0),(69767,1938,'de','Dein Bild muss.JPEG-Format in Rechnung drucken',0),(69768,1938,'en','Your image must be in .JPEG format to print in invoice',0),(69769,1939,'is','',0),(69770,1939,'dr','Ø¶Ø±ÙˆØ±ÙŠ ',0),(69771,1939,'pr','Ø¶Ø±ÙˆØ±ÙŠ ',0),(69772,1939,'tr','Gerekli',0),(69773,1939,'pl','Potrzebne',0),(69774,1939,'bg','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸',0),(69775,1939,'ur','Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(69776,1939,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ',0),(69777,1939,'vi','Cáº§n ',0),(69778,1939,'af','Nodig',0),(69779,1939,'ro','Necesare',0),(69780,1939,'et','Vaja',0),(69781,1939,'si','Potrebno',0),(69782,1939,'ba','Diperlukan',0),(69783,1939,'nl','Nodig',0),(69784,1939,'fi','Tarvitaan',0),(69785,1939,'no','NÃ¸dvendig',0),(69786,1939,'da','Behov for',0),(69787,1939,'ko','í•„ìš”',0),(69788,1939,'he','×”×¦×•×¨×š',0),(69789,1939,'el','Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(69790,1939,'zh','éœ€è¦\r\n',0),(69791,1939,'sv','BehÃ¶vs',0),(69792,1939,'it','Necessari',0),(69793,1939,'tl','',0),(69794,1939,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(69795,1939,'hi','à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(69796,1939,'ms','Diperlukan',0),(69797,1939,'ar','Ø­Ø§Ø¬Ø©',0),(69798,1939,'fr','NÃ©cessaire',0),(69799,1939,'jp','å¿…è¦?ã?ª',0),(69800,1939,'pt','Precisava de',0),(69801,1939,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ',0),(69802,1939,'es','Necesitado',0),(69803,1939,'de','BenÃ¶tigt',0),(69804,1939,'en','Needed',0),(69805,1940,'is','',0),(69806,1940,'dr','(Ù…Ø¬Ù…ÙˆØ¹) Ø¶Ø±ÙˆØ±ÙŠ Ø§Ø³Øª ',0),(69807,1940,'pr','ÙƒÙ„(Ù…Ø¬Ù…ÙˆØ¹) Ø¶Ø±ÙˆØ±ÙŠ Ø§Ø³Øª ',0),(69808,1940,'tr','Gerekli toplam',0),(69809,1940,'pl','Potrzebne Å‚Ä…cznie',0),(69810,1940,'bg','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¾Ð±Ñ‰Ð¾',0),(69811,1940,'ur','Ø¶Ø±ÙˆØ±Øª ØªÚ¾ÛŒ Ú©Ù„',0),(69812,1940,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð¸Ñ… ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(69813,1940,'vi','Tá»•ng cáº§n',0),(69814,1940,'af','Nodig totaal',0),(69815,1940,'ro','Total necesar',0),(69816,1940,'et','Vaja kokku',0),(69817,1940,'si','Potrebno skupno',0),(69818,1940,'ba','Diperlukan Total',0),(69819,1940,'nl','Benodigde totaal',0),(69820,1940,'fi','Tarvitaan yhteensÃ¤',0),(69821,1940,'no','NÃ¸dvendig totalt',0),(69822,1940,'da','NÃ¸dvendige alt',0),(69823,1940,'ko','í•„ìš”í•œ ì´',0),(69824,1940,'he','×¡×” ×› ×”×“×¨×•×©',0),(69825,1940,'el','Î§ÏÎµÎ¹Î¬Î¶Î¿Î½Ï„Î±Î¹ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(69826,1940,'zh','æ‰€éœ€æ€»\r\n',0),(69827,1940,'sv','BehÃ¶vs totalt',0),(69828,1940,'it','Totale necessaria',0),(69829,1940,'tl','',0),(69830,1940,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;',0),(69831,1940,'hi','à¤œà¤°à¥‚à¤°à¥€ à¤•à¥à¤²',0),(69832,1940,'ms','Jumlah diperlukan',0),(69833,1940,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨',0),(69834,1940,'fr','Total nÃ©cessaire',0),(69835,1940,'jp','å¿…è¦?å?ˆè¨ˆ',0),(69836,1940,'pt','Total necessÃ¡ria',0),(69837,1940,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾Ð¹ Ð¾Ð±Ñ‰ÐµÐ¹',0),(69838,1940,'es','Total se Necesita',0),(69839,1940,'de','BenÃ¶tigte insgesamt',0),(69840,1940,'en','Needed Total',0),(69841,1941,'is','',0),(69842,1941,'dr','Ø¨Ø¯Ù‡ÙŠ Ø®Ø§Ù„Øµ',0),(69843,1941,'pr','Ø¨Ø¯Ù‡ÙŠ Ø®Ø§Ù„Øµ',0),(69844,1941,'tr','Net sÃ¼re',0),(69845,1941,'pl','Netto ze wzglÄ™du',0),(69846,1941,'bg','ÐÐµÑ‚Ð¾ Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾',0),(69847,1941,'ur','Ø¬Ø§Ù„ Ù…Ù‚Ø±Ø±Û',0),(69848,1941,'sr','ÐÐµÑ‚Ð¾ Ð´ÑƒÐ³',0),(69849,1941,'vi','Thuáº§n Ä‘áº¿n háº¡n',0),(69850,1941,'af','Netto Verskuldig',0),(69851,1941,'ro','Net cuvenit',0),(69852,1941,'et','Net nÃµuetekohaselt',0),(69853,1941,'si','Neto zaradi',0),(69854,1941,'ba','Karena bersih',0),(69855,1941,'nl','Netto Due',0),(69856,1941,'fi','NET asianmukaisesti',0),(69857,1941,'no','Netto grunn',0),(69858,1941,'da','Netto Due',0),(69859,1941,'ko','Net ì¸í•´',0),(69860,1941,'he','×¤×™×¨×¢×•×Ÿ × ×˜×•',0),(69861,1941,'el','ÎšÎ±Î¸Î±ÏÎ® Î´ÎµÏŒÎ½Ï„Ï‰Ï‚',0),(69862,1941,'zh','å‡€æˆªæ­¢\r\n',0),(69863,1941,'sv','Net vederbÃ¶rlig',0),(69864,1941,'it','Debito netto',0),(69865,1941,'tl','',0),(69866,1941,'th','&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3594;&#3635;&#3619;&#3632;&#3626;&#3640;&#3607;&#3608;&#3636;',0),(69867,1941,'hi','à¤¨à¥‡à¤Ÿ à¤¨à¤¿à¤¯à¤¤',0),(69868,1941,'ms','Wajar bersih',0),(69869,1941,'ar','Ø£ØµÙˆÙ„ ØµØ§ÙÙŠØ©',0),(69870,1941,'fr','NET Due',0),(69871,1941,'jp','æ­£å‘³æœŸé™?',0),(69872,1941,'pt','Vencimento lÃ­quido',0),(69873,1941,'ru','NET Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾',0),(69874,1941,'es','Neto Debido',0),(69875,1941,'de','NET Due',0),(69876,1941,'en','Net Due',0),(69877,1942,'is','',0),(69878,1942,'dr','Ø®Ø§Ù„Øµ Ø³Ø±Ø±Ø³ÙŠØ¯Ù‡Ø§',0),(69879,1942,'pr','Ø®Ø§Ù„Øµ Ø³Ø±Ø±Ø³ÙŠØ¯Ù‡Ø§',0),(69880,1942,'tr','NET son gÃ¼n',0),(69881,1942,'pl','Netto odpowiednim dni',0),(69882,1942,'bg','ÐÐµÑ‚Ð¾ Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾ Ð´Ð½Ð¸',0),(69883,1942,'ur','Ù†ÛŒÙ¹ Ù¾Ø± Ù…Ù‚Ø±Ø±Û Ø¯Ù†ÙˆÚº',0),(69884,1942,'sr','ÐÐµÑ‚Ð¾ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ð½Ð°',0),(69885,1942,'vi','NgÃ y thuáº§n Ä‘áº¿n háº¡n',0),(69886,1942,'af','Netto Dae Betaalbaar',0),(69887,1942,'ro','Net cuvenit zile',0),(69888,1942,'et','Net nÃµuetekohase pÃ¤ev',0),(69889,1942,'si','Neto zaradi dni',0),(69890,1942,'ba','Bersih karena hari',0),(69891,1942,'nl','Netto Due dagen',0),(69892,1942,'fi','NET asianmukaisesti pÃ¤ivÃ¤Ã¤',0),(69893,1942,'no','Netto grunn dager',0),(69894,1942,'da','Netto Due dage',0),(69895,1942,'ko','ì¸í•´ ìˆœ ì¼',0),(69896,1942,'he','× ×˜×• ×‘×©×œ ×™×ž×™×',0),(69897,1942,'el','ÎšÎ±Î¸Î±ÏÏŒ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼Î­ÏÎµÏ‚',0),(69898,1942,'zh','å‡€å¤©æ•°\r\n',0),(69899,1942,'sv','Net vederbÃ¶rlig dagar',0),(69900,1942,'it','Netto Due giorni',0),(69901,1942,'tl','',0),(69902,1942,'th','&#3623;&#3633;&#3609;&#3626;&#3640;&#3607;&#3608;&#3636;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(69903,1942,'hi','à¤¨à¥‡à¤Ÿ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨',0),(69904,1942,'ms','Bersih habis tempoh hari',0),(69905,1942,'ar','ØµØ§ÙÙŠ Ø£ØµÙˆÙ„ Ø§Ù„Ø£ÙŠØ§Ù…',0),(69906,1942,'fr','NET Due jours',0),(69907,1942,'jp','Net Due Days',0),(69908,1942,'pt','NET devido dias',0),(69909,1942,'ru','NET Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾ Ð´Ð½ÐµÐ¹',0),(69910,1942,'es','DÃ­as de Vencimiento neto',0),(69911,1942,'de','NET-Due Tage',0),(69912,1942,'en','Net Due Days',0),(69913,1943,'is','',0),(69914,1943,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø¯Ù‡ÙŠ Ø®Ø§Ù„Øµ',0),(69915,1943,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø¯Ù‡ÙŠ Ø®Ø§Ù„Øµ',0),(69916,1943,'tr','Net sÃ¼re sonu toplam',0),(69917,1943,'pl','Odpowiednim netto ogÃ³Å‚em',0),(69918,1943,'bg','ÐÐµÑ‚Ð¾ Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(69919,1943,'ur','Ù†ÛŒÙ¹ Ù¾Ø± Ù…Ù‚Ø±Ø±Û Ú©Ù„',0),(69920,1943,'sr','ÐÐµÑ‚Ð¾ ÐºÑ€Ð°Ñ˜ÑšÐ¸ ÑƒÐºÑƒÐ¿Ð°Ð½',0),(69921,1943,'vi','Tá»•ng sá»‘ thuáº§n Ä‘áº¿n háº¡n',0),(69922,1943,'af','Net Verskuldigde Totaal',0),(69923,1943,'ro','Net cuvenit totalÄƒ',0),(69924,1943,'et','Net nÃµuetekohaselt kokku',0),(69925,1943,'si','Neto zaradi skupne',0),(69926,1943,'ba','Bersih karena Total',0),(69927,1943,'nl','Netto Due totale',0),(69928,1943,'fi','NET asianmukaisesti yhteensÃ¤',0),(69929,1943,'no','Netto grunn totalt',0),(69930,1943,'da','Netto Due samlede',0),(69931,1943,'ko','ì¸í•´ ê·¸ë¬¼ ì´',0),(69932,1943,'he','× ×˜×• ×¤×™×¨×¢×•×Ÿ ×ž×•×—×œ×˜',0),(69933,1943,'el','ÎšÎ±Î¸Î±ÏÏŒ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ ÏƒÏ…Î½Î¿Î»Î¹ÎºÏŒ',0),(69934,1943,'zh','ç”±äºŽæ€»çš„å‡€\r\n',0),(69935,1943,'sv','Net vederbÃ¶rlig totala',0),(69936,1943,'it','Netto debito totale',0),(69937,1943,'tl','',0),(69938,1943,'th','&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3594;&#3635;&#3619;&#3632;&#3619;&#3623;&#3617;&#3626;&#3640;&#3607;&#3608;&#3636;',0),(69939,1943,'hi','à¤¨à¥‡à¤Ÿ à¤¨à¤¿à¤¯à¤¤ à¤•à¥à¤²',0),(69940,1943,'ms','Bersih wajar jumlah',0),(69941,1943,'ar','ØµØ§ÙÙŠ Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø§Ù„ÙƒÙ„ÙŠ',0),(69942,1943,'fr','NET respect Total',0),(69943,1943,'jp','Net Due Total',0),(69944,1943,'pt','NET devido Total',0),(69945,1943,'ru','NET Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾ Ð²ÑÐµÐ³Ð¾',0),(69946,1943,'es','Total de Neto Debido',0),(69947,1943,'de','NET-Due gesamt',0),(69948,1943,'en','Net Due Total',0),(69949,1944,'is','',0),(69950,1944,'dr','Ø®Ø§Ù„Øµ Ø¯Ø±Ø§Ù…Ø¯',0),(69951,1944,'pr','Ø®Ø§Ù„Øµ Ø¯Ø±Ø§Ù…Ø¯',0),(69952,1944,'tr','Net gelir',0),(69953,1944,'pl','DochÃ³d netto',0),(69954,1944,'bg','ÐÐµÑ‚ÐµÐ½ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´',0),(69955,1944,'ur','Ø®Ø§Ù„Øµ Ø¢Ù…Ø¯Ù†ÛŒ',0),(69956,1944,'sr','ÐÐµÑ‚Ð¾ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´',0),(69957,1944,'vi','Thu nháº­p thuáº§n',0),(69958,1944,'af','Netto Inkomste',0),(69959,1944,'ro','Venitul net',0),(69960,1944,'et','Puhaskasum',0),(69961,1944,'si','Neto dohodek',0),(69962,1944,'ba','Pendapatan bersih',0),(69963,1944,'nl','Netto-inkomsten',0),(69964,1944,'fi','Tilikauden voitto',0),(69965,1944,'no','Nettoinntekt',0),(69966,1944,'da','Nettoindkomst',0),(69967,1944,'ko','ë‹¹ê¸° ìˆœì´ìµ',0),(69968,1944,'he','×”×›× ×¡×” × ×˜×•',0),(69969,1944,'el','ÎšÎ±Î¸Î±ÏÏŒ ÎµÎ¹ÏƒÏŒÎ´Î·Î¼Î±',0),(69970,1944,'zh','å‡€åˆ©\r\n',0),(69971,1944,'sv','NettointÃ¤kter',0),(69972,1944,'it','Reddito netto',0),(69973,1944,'tl','',0),(69974,1944,'th','&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3626;&#3640;&#3607;&#3608;&#3636;',0),(69975,1944,'hi','à¤¶à¥à¤¦à¥à¤§ à¤†à¤¯',0),(69976,1944,'ms','Pendapatan bersih',0),(69977,1944,'ar','ØµØ§ÙÙŠ Ø§Ù„Ø¯Ø®Ù„',0),(69978,1944,'fr','BÃ©nÃ©fice net',0),(69979,1944,'jp','ç´”åˆ©ç›Š',0),(69980,1944,'pt','Lucro lÃ­quido',0),(69981,1944,'ru','Ð§Ð¸ÑÑ‚Ñ‹Ð¹ Ð´Ð¾Ñ…Ð¾Ð´',0),(69982,1944,'es','Ingreso Neto',0),(69983,1944,'de','JahresÃ¼berschuss',0),(69984,1944,'en','Net Income',0),(69985,1945,'is','',0),(69986,1945,'dr','Ø­Ù‚ÙˆÙ‚ Ø®Ø§Ù„Øµ',0),(69987,1945,'pr','Ø­Ù‚ÙˆÙ‚ Ø®Ø§Ù„Øµ',0),(69988,1945,'tr','NET Ã¶deme',0),(69989,1945,'pl','Wynagrodzenie netto',0),(69990,1945,'bg','ÐÐµÑ‚Ð½Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(69991,1945,'ur','Ø®Ø§Ù„Øµ ØªÙ†Ø®ÙˆØ§Û',0),(69992,1945,'sr','ÐÐµÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ',0),(69993,1945,'vi','LÆ°Æ¡ng thuáº§n',0),(69994,1945,'af','Netto Besoldiging',0),(69995,1945,'ro','Salariu net',0),(69996,1945,'et','Netopalk',0),(69997,1945,'si','Neto plaÄa',0),(69998,1945,'ba','Membayar bersih',0),(69999,1945,'nl','Nettoloon',0),(70000,1945,'fi','Nettopalkka',0),(70001,1945,'no','NettolÃ¸nn',0),(70002,1945,'da','NettolÃ¸n',0),(70003,1945,'ko','ì¸í„°ë„· ì§€ë¶ˆ',0),(70004,1945,'he','×”×©×›×¨ × ×˜×•',0),(70005,1945,'el','ÎšÎ±Î¸Î±ÏÎ­Ï‚ Î±Ï€Î¿Î´Î¿Ï‡Î­Ï‚',0),(70006,1945,'zh','å‡€å·¥èµ„\r\n',0),(70007,1945,'sv','NettolÃ¶n',0),(70008,1945,'it','Retribuzione netta',0),(70009,1945,'tl','',0),(70010,1945,'th','&#3592;&#3656;&#3634;&#3618;&#3626;&#3640;&#3607;&#3608;&#3636;',0),(70011,1945,'hi','à¤¨à¥‡à¤Ÿ à¤µà¥‡à¤¤à¤¨',0),(70012,1945,'ms','Gaji bersih',0),(70013,1945,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„ØµØ§ÙÙŠ',0),(70014,1945,'fr','Salaire net',0),(70015,1945,'jp','ç´”æ”¯æ‰•',0),(70016,1945,'pt','SalÃ¡rio lÃ­quido',0),(70017,1945,'ru','Ð§Ð¸ÑÑ‚Ð°Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(70018,1945,'es','Pago Neto',0),(70019,1945,'de','Nettolohn',0),(70020,1945,'en','Net Pay',0),(70021,1946,'is','',0),(70022,1946,'dr','Ø­Ù‚ÙˆÙ‚ Ø®Ø§Ù„Øµ',0),(70023,1946,'pr','Ø­Ù‚ÙˆÙ‚ Ø®Ø§Ù„Øµ',0),(70024,1946,'tr','NET Ã¶deme',0),(70025,1946,'pl','Wynagrodzenie netto',0),(70026,1946,'bg','ÐÐµÑ‚Ð½Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(70027,1946,'ur','Ø®Ø§Ù„Øµ ØªÙ†Ø®ÙˆØ§Û',0),(70028,1946,'sr','ÐÐµÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ',0),(70029,1946,'vi','LÆ°Æ¡ng thuáº§n',0),(70030,1946,'af','Netto Besoldiging',0),(70031,1946,'ro','Salariu net',0),(70032,1946,'et','Netopalk',0),(70033,1946,'si','Neto plaÄa',0),(70034,1946,'ba','Membayar bersih',0),(70035,1946,'nl','Nettoloon',0),(70036,1946,'fi','Nettopalkka',0),(70037,1946,'no','NettolÃ¸nn',0),(70038,1946,'da','NettolÃ¸n',0),(70039,1946,'ko','ì¸í„°ë„· ì§€ë¶ˆ',0),(70040,1946,'he','×”×©×›×¨ × ×˜×•',0),(70041,1946,'el','ÎšÎ±Î¸Î±ÏÎ­Ï‚ Î±Ï€Î¿Î´Î¿Ï‡Î­Ï‚',0),(70042,1946,'zh','å‡€å·¥èµ„\r\n',0),(70043,1946,'sv','NettolÃ¶n',0),(70044,1946,'it','Retribuzione netta',0),(70045,1946,'tl','',0),(70046,1946,'th','&#3592;&#3656;&#3634;&#3618;&#3626;&#3640;&#3607;&#3608;&#3636;',0),(70047,1946,'hi','à¤¨à¥‡à¤Ÿ à¤µà¥‡à¤¤à¤¨',0),(70048,1946,'ms','Gaji bersih',0),(70049,1946,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„ØµØ§ÙÙŠ',0),(70050,1946,'fr','Salaire net',0),(70051,1946,'jp','ç´”æ”¯æ‰•',0),(70052,1946,'pt','SalÃ¡rio lÃ­quido',0),(70053,1946,'ru','Ð§Ð¸ÑÑ‚Ð°Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(70054,1946,'es','Pago Neto',0),(70055,1946,'de','Nettolohn',0),(70056,1946,'en','Net Pay',0),(70057,1947,'is','',0),(70058,1947,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ÙŠ Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(70059,1947,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ÙŠ Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(70060,1947,'tr','Yeni ayarlanan vergi',0),(70061,1947,'pl','nowe podatki dostosowane',0),(70062,1947,'bg','Ð½Ð¾Ð²Ð¸ ÐºÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(70063,1947,'ur','Ù†Ø¦Û’ Ø¨Ù†Û’ Ù¹ÛŒÚ©Ø³',0),(70064,1947,'sr','ÐºÐ¾Ñ€Ð¸Ð³Ð¾Ð²Ð°Ð½Ð¸ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ·Ð¸',0),(70065,1947,'vi','thuáº¿ má»›i sá»­a',0),(70066,1947,'af','nuwe aangepaste belasting',0),(70067,1947,'ro','noi taxe ajustate',0),(70068,1947,'et','Uus korrigeeritud maksud',0),(70069,1947,'si','Novi prilagojeni davki',0),(70070,1947,'ba','Pajak disesuaikan baru',0),(70071,1947,'nl','nieuwe aangepaste belastingen',0),(70072,1947,'fi','uusia oikaistu veroja',0),(70073,1947,'no','nye justert skatter',0),(70074,1947,'da','nye justerede skatter',0),(70075,1947,'ko','ìƒˆë¡œìš´ ì¡°ì •ëœ ì„¸ê¸ˆ',0),(70076,1947,'he','×ž×™×¡×™× ×—×“×©×™× ×ž× ×•×›×™ ×¢×•× ×ª×™×•×ª',0),(70077,1947,'el','Î½Î­Î± Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· Ï†ÏŒÏÏ‰Î½',0),(70078,1947,'zh','æ–°è°ƒæ•´çš„ç¨Žæ”¶\r\n',0),(70079,1947,'sv','nya justerade skatter',0),(70080,1947,'it','nuove imposte rettificate',0),(70081,1947,'tl','',0),(70082,1947,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3616;&#3634;&#3625;&#3637;',0),(70083,1947,'hi','à¤¨à¤ˆ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¥‹à¤‚',0),(70084,1947,'ms','cukai-cukai baru yang diselaraskan',0),(70085,1947,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø§Ù„Ù…Ø¹Ø¯Ù„Ø©',0),(70086,1947,'fr','nouvelles taxes ajustÃ©s',0),(70087,1947,'jp','æ–°è¦?èª¿æ•´æ¸ˆç¨Ž',0),(70088,1947,'pt','novos impostos ajustados',0),(70089,1947,'ru','Ð½Ð¾Ð²Ñ‹Ðµ ÑÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(70090,1947,'es','nuevo impuestos ajustados',0),(70091,1947,'de','neuer angepasst Steuern',0),(70092,1947,'en','new adjusted taxes',0),(70093,1948,'is','',0),(70094,1948,'dr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(70095,1948,'pr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(70096,1948,'tr','Yeni yapÄ± dÃ¼zeni',0),(70097,1948,'pl','Nowy Build Order',0),(70098,1948,'bg','ÐÐ¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(70099,1948,'ur','Ù†Ø¦Û’ ØªØ¹Ù…ÛŒØ± Ø¢Ø±ÚˆØ±',0),(70100,1948,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº Ñƒ Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÐ¸',0),(70101,1948,'vi','ÄÆ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng má»›i',0),(70102,1948,'af','Nuwe Geboude Bestelling',0),(70103,1948,'ro','Noua ordine a construi',0),(70104,1948,'et','Uus tootmistellimus',0),(70105,1948,'si','Izgradnje nove',0),(70106,1948,'ba','Membangun Orde Baru',0),(70107,1948,'nl','Nieuwe opbouwvolgorde',0),(70108,1948,'fi','Uuden tilauksen mukaan',0),(70109,1948,'no','Ny',0),(70110,1948,'da','Ny Byg efter ordre',0),(70111,1948,'ko','ìƒˆë¡œìš´ ë¹Œë“œ ìˆœì„œ',0),(70112,1948,'he','×¡×“×¨ ×œ×‘× ×•×ª ×—×“×©',0),(70113,1948,'el','ÎÎ­Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Ï„Î¬Î¾Î·',0),(70114,1948,'zh','æ–°ç”Ÿæˆå¸å•\r\n',0),(70115,1948,'sv','Nya bygga Order',0),(70116,1948,'it','Nuovo ordine di compilazione',0),(70117,1948,'tl','',0),(70118,1948,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(70119,1948,'hi','à¤¨à¤ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤•à¥à¤°à¤®',0),(70120,1948,'ms','Perintah membina baru',0),(70121,1948,'ar','Ù†Ø¸Ø§Ù… Ø¨Ù†Ø§Ø¡ Ø¬Ø¯ÙŠØ¯',0),(70122,1948,'fr','Nouvelle Build Order',0),(70123,1948,'jp','æ–°è¦?çµ„ç«‹æ³¨æ–‡',0),(70124,1948,'pt','Nova ordem de compilaÃ§Ã£o',0),(70125,1948,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(70126,1948,'es','Nuevo Orden de ConstrucciÃ³n',0),(70127,1948,'de','Neue Buildreihenfolge',0),(70128,1948,'en','New Build Order',0),(70129,1949,'is','',0),(70130,1949,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(70131,1949,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(70132,1949,'tr','Yeni Stok sayÄ±mÄ±',0),(70133,1949,'pl','Nowe inwentaryzacji',0),(70134,1949,'bg','ÐÐ¾Ð² Ð±Ñ€Ð¾Ð¹ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(70135,1949,'ur','Ù†Ø¦Û’ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ø§ Ø´Ù…Ø§Ø±',0),(70136,1949,'sr','ÐÐ¾Ð²Ð¾Ð³ Ð¿Ð¾Ð¿Ð¸ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(70137,1949,'vi','Äáº¿m hÃ ng trong kho má»›i',0),(70138,1949,'af','Nuwe Voorraad Telling',0),(70139,1949,'ro','Noi conta inventar',0),(70140,1949,'et','Uue varude krahv',0),(70141,1949,'si','Nov inventura',0),(70142,1949,'ba','Baru menghitung persediaan',0),(70143,1949,'nl','Nieuwe inventaris tellen',0),(70144,1949,'fi','Uusi varaston inventointi',0),(70145,1949,'no','Nye Lageropptelling',0),(70146,1949,'da','Nye lageroptÃ¦lling',0),(70147,1949,'ko','ìƒˆë¡œìš´ ìž¬ê³  ì¹´ìš´íŠ¸',0),(70148,1949,'he','×¡×¤×™×¨×ª ×ž×œ××™ ×—×“×©',0),(70149,1949,'el','ÎÎ­Î± ÎºÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ· Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(70150,1949,'zh','æ–°çš„åº“å­˜ç›˜ç‚¹\r\n',0),(70151,1949,'sv','Ny lagerinventering',0),(70152,1949,'it','Nuovo conteggio inventario',0),(70153,1949,'tl','',0),(70154,1949,'th','&#3609;&#3633;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(70155,1949,'hi','à¤¨à¤ˆ à¤¸à¥‚à¤šà¥€ à¤—à¤¿à¤¨à¤¤à¥€',0),(70156,1949,'ms','Pengiraan inventori baru',0),(70157,1949,'ar','Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(70158,1949,'fr','Nouvel inventaire',0),(70159,1949,'jp','æ–°è¦?æ£šå?¸',0),(70160,1949,'pt','Nova contagem de inventÃ¡rio',0),(70161,1949,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(70162,1949,'es','Nuevo Conteo de Inventario',0),(70163,1949,'de','Neue InventurzÃ¤hlung',0),(70164,1949,'en','New Inventory Count',0),(70165,1950,'is','',0),(70166,1950,'dr','Ø¨Ù‡Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(70167,1950,'pr','Ø¨Ù‡Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(70168,1950,'tr','Yeni faiz',0),(70169,1950,'pl','Nowe zainteresowanie',0),(70170,1950,'bg','ÐÐ¾Ð² Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(70171,1950,'ur','Ù†Ø¦Û’ Ø¯Ù„Ú†Ø³Ù¾ÛŒ',0),(70172,1950,'sr','ÐÐ¾Ð²Ð¸ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(70173,1950,'vi','LÃ£i suáº¥t má»›i',0),(70174,1950,'af','Nuwe Rente',0),(70175,1950,'ro','Nou interes',0),(70176,1950,'et','Uus viivis',0),(70177,1950,'si','Novo zanimanje',0),(70178,1950,'ba','Minat baru',0),(70179,1950,'nl','Nieuwe interesse',0),(70180,1950,'fi','Uutta kiinnostusta',0),(70181,1950,'no','Ny interesse',0),(70182,1950,'da','Ny interesse',0),(70183,1950,'ko','ìƒˆë¡œìš´ ê´€ì‹¬',0),(70184,1950,'he','×¢× ×™×™×Ÿ ×—×“×©',0),(70185,1950,'el','ÎÎ­Î¿ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½',0),(70186,1950,'zh','æ–°çš„å…´è¶£\r\n',0),(70187,1950,'sv','Nytt intresse',0),(70188,1950,'it','Nuovo interesse',0),(70189,1950,'tl','',0),(70190,1950,'th','&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;',0),(70191,1950,'hi','à¤¨à¤ˆ à¤¬à¥à¤¯à¤¾à¤œ',0),(70192,1950,'ms','Faedah baru',0),(70193,1950,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(70194,1950,'fr','Nouvel intÃ©rÃªt',0),(70195,1950,'jp','æ–°è¦?åˆ©å­?',0),(70196,1950,'pt','Novo interesse',0),(70197,1950,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(70198,1950,'es','Nuevo InterÃ©s',0),(70199,1950,'de','Neues Interesse',0),(70200,1950,'en','New Interest',0),(70201,1951,'is','',0),(70202,1951,'dr','ØªØ¹Ø¯Ø§Ø¯ ÙƒØ§Ù„Ø§ Ø¬Ø¯ÙŠØ¯ ',0),(70203,1951,'pr','ØªØ¹Ø¯Ø§Ø¯ ÙƒØ§Ù„Ø§ Ø¬Ø¯ÙŠØ¯ ',0),(70204,1951,'tr','Yeni Ã¶ÄŸe sayÄ±sÄ±',0),(70205,1951,'pl','Nowy element Count',0),(70206,1951,'bg','ÐÐ¾Ð² Ð±Ñ€Ð¾Ð¹ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(70207,1951,'ur','Ù†Ø¦ÛŒ Ø´Û’ Ú©Ø§ Ø´Ù…Ø§Ø±',0),(70208,1951,'sr','ÐÐ¾Ð²Ð¸ Ð±Ñ€Ð¾Ñ˜ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(70209,1951,'vi','Äáº¿m hÃ ng má»›i',0),(70210,1951,'af','Nuwe Item Telling',0),(70211,1951,'ro','Noul element conta',0),(70212,1951,'et','Uute Ã¼ksuste arv',0),(70213,1951,'si','Å tevilo novih elementov',0),(70214,1951,'ba','Jumlah Item baru',0),(70215,1951,'nl','Nieuwe Item Count',0),(70216,1951,'fi','Uusien kohteiden mÃ¤Ã¤rÃ¤',0),(70217,1951,'no','Nye vareopptelling',0),(70218,1951,'da','Nye emnet tÃ¦ller',0),(70219,1951,'ko','ìƒˆ í•­ëª© ìˆ˜',0),(70220,1951,'he','×¡×¤×™×¨×ª ×¤×¨×™×˜ ×—×“×©',0),(70221,1951,'el','ÎÎ­Î¿ Ï€Î»Î®Î¸Î¿Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(70222,1951,'zh','æ–°é¡¹ç›®è®¡æ•°\r\n',0),(70223,1951,'sv','Nya objektet rÃ¤kna',0),(70224,1951,'it','Nuovo conteggio',0),(70225,1951,'tl','',0),(70226,1951,'th','&#3609;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3627;&#3617;&#3656;',0),(70227,1951,'hi','à¤¨à¤ à¤†à¤‡à¤Ÿà¤® à¤—à¤£à¤¨à¤¾',0),(70228,1951,'ms','Kiraan butiran baru',0),(70229,1951,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(70230,1951,'fr','Nombre d\'Ã©lÃ©ments nouveaux',0),(70231,1951,'jp','æ–°è¦?å“?ç›®å‹˜å®š',0),(70232,1951,'pt','Nova contagem de Item',0),(70233,1951,'ru','ÐÐ¾Ð²Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(70234,1951,'es','Nuevo Conteo de Items',0),(70235,1951,'de','Neue Elementanzahl',0),(70236,1951,'en','New Item Count',0),(70237,1952,'is','',0),(70238,1952,'dr','Ù…Ø¬Ù…ÙˆØ¹ ØªØ¹Ø¯Ø§Ø¯ ÙƒØ§Ù„Ø§ Ø¬Ø¯ÙŠØ¯ ',0),(70239,1952,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªØ¹Ø¯Ø§Ø¯ ÙƒØ§Ù„Ø§ Ø¬Ø¯ÙŠØ¯ ',0),(70240,1952,'tr','Yeni Ã¶ÄŸe sayÄ±sÄ± toplam',0),(70241,1952,'pl','Nowy element liczba caÅ‚kowita',0),(70242,1952,'bg','ÐÐ¾Ð² ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð±Ñ€Ð¾Ð¹ Ð¾Ð±Ñ‰Ð¾',0),(70243,1952,'ur','Ù†Ø¦ÛŒ Ø´Û’ Ú©Ø§ Ø´Ù…Ø§Ø± Ú©Ù„',0),(70244,1952,'sr','ÐÐ¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð³Ñ€Ð¾Ñ„ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(70245,1952,'vi','Tá»•ng sá»‘ hÃ ng má»›i Ä‘áº¿m',0),(70246,1952,'af','Nuwe Item Telling Totaal',0),(70247,1952,'ro','Noul element conta Total',0),(70248,1952,'et','Uue kirje arv kokku',0),(70249,1952,'si','Nov element Count Total',0),(70250,1952,'ba','Total jumlah Item baru',0),(70251,1952,'nl','Nieuwe Item Count totaal',0),(70252,1952,'fi','Uusi nimikkeen mÃ¤Ã¤rÃ¤ yhteensÃ¤',0),(70253,1952,'no','Nye antall totale',0),(70254,1952,'da','Nye vare tÃ¦ller alt',0),(70255,1952,'ko','ìƒˆ í•­ëª© ìˆ˜ ì´',0),(70256,1952,'he','×¡×š ×¡×¤×™×¨×ª ×¤×¨×™×˜ ×—×“×©',0),(70257,1952,'el','ÎÎ­Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ· ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(70258,1952,'zh','æ–°é¡¹ç›®è®¡æ•°å…±æœ‰\r\n',0),(70259,1952,'sv','Nya objekt rÃ¤knas totalt',0),(70260,1952,'it','Nuovo elemento conteggio totale',0),(70261,1952,'tl','',0),(70262,1952,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3609;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3627;&#3617;&#3656;',0),(70263,1952,'hi','à¤¨à¤ à¤†à¤‡à¤Ÿà¤® à¤—à¤£à¤¨à¤¾ à¤•à¥à¤²',0),(70264,1952,'ms','Jumlah keseluruhan bilangan Item baru',0),(70265,1952,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø¹Ø¯Ø¯ Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(70266,1952,'fr','Nouveau point nombre Total',0),(70267,1952,'jp','æ–°è¦?å“?ç›®å‹˜å®šå?ˆè¨ˆ',0),(70268,1952,'pt','Novo Item Contagem Total',0),(70269,1952,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð²ÑÐµÐ³Ð¾ Ð²ÑÐµÐ³Ð¾',0),(70270,1952,'es','Nuevo Conteo de Items Total',0),(70271,1952,'de','Neues Item Count Total',0),(70272,1952,'en','New Item Count Total',0),(70273,1953,'is','',0),(70274,1953,'dr','ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ù…Ø§Ù†Ù†Ø¯   ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(70275,1953,'pr','ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ù…Ø§Ù†Ù†Ø¯   ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(70276,1953,'tr','Yeni Ã¶ÄŸe aynÄ± satÄ±cÄ±',0),(70277,1953,'pl','Nowy element tego samego dostawcy',0),(70278,1953,'bg','ÐÐ¾Ð² ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÑÑŠÑ‰Ð¸Ñ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(70279,1953,'ur','Ù†Ø¦ÛŒ Ø´Û’ Ø§Ø³ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(70280,1953,'sr','ÐÐ¾Ð²Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð¸ÑÑ‚Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(70281,1953,'vi','CÃ¹ng ngÆ°á»i bÃ¡n cho hÃ ng má»›i',0),(70282,1953,'af','Nuwe Item Dieselfde Verskaffer',0),(70283,1953,'ro','Nou articol de acelaÅŸi furnizor',0),(70284,1953,'et','Uus toode samalt tarnijalt',0),(70285,1953,'si','Nov element iste prodajalec',0),(70286,1953,'ba','Vendor Item sama baru',0),(70287,1953,'nl','Nieuwe object dezelfde leverancier',0),(70288,1953,'fi','Uuden tuotteen saman toimittajan',0),(70289,1953,'no','Elementet samme leverandÃ¸r',0),(70290,1953,'da','Nye vare samme leverandÃ¸r',0),(70291,1953,'ko','ìƒˆë¡œìš´ í•­ëª© ê°™ì€ ê³µê¸‰ ì—…ì²´',0),(70292,1953,'he','×¡×¤×§ ×‘××•×ª×• ×¤×¨×™×˜ ×—×“×©',0),(70293,1953,'el','ÎÎ­Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¯Î´Î¹Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(70294,1953,'zh','åŒä¸€ä¾›åº”å•†çš„æ–°é¡¹ç›®\r\n',0),(70295,1953,'sv','Nya objekt samma leverantÃ¶r',0),(70296,1953,'it','Nuovo elemento stesso fornitore',0),(70297,1953,'tl','',0),(70298,1953,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3627;&#3617;&#3656;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3648;&#3604;&#3636;&#3617;',0),(70299,1953,'hi','à¤¨à¤ à¤†à¤‡à¤Ÿà¤® à¤à¤• à¤¹à¥€ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(70300,1953,'ms','Penjual perkara sama yang baru',0),(70301,1953,'ar','ØµÙ†Ù Ø¬Ø¯ÙŠØ¯ Ù„Ù†ÙØ³ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(70302,1953,'fr','Nouveau point mÃªme vendeur',0),(70303,1953,'jp','æ–°ã?—ã?„å“?ç›®å?Œã?˜æ¥­è€…',0),(70304,1953,'pt','Novo Item mesmo fornecedor',0),(70305,1953,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¢Ð¾Ð²Ð°Ñ€ Ð¢Ð¾Ð³Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(70306,1953,'es','Nuevo Item Mismo Proveedor',0),(70307,1953,'de','Neue Artikel desselben Anbieters',0),(70308,1953,'en','New Item Same Vendor',0),(70309,1954,'is','',0),(70310,1954,'dr','Ù„ÙŠØ³Øª Ø¬Ø¯ÙŠØ¯ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(70311,1954,'pr','Ù„ÙŠØ³Øª Ø¬Ø¯ÙŠØ¯ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(70312,1954,'tr','Yeni liste oluÅŸturuldu',0),(70313,1954,'pl','Nowy wykaz zostaÅ‚ wygenerowany',0),(70314,1954,'bg','Ð• Ð±Ð¸Ð» Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½ Ð½Ð¾Ð² ÑÐ¿Ð¸ÑÑŠÐº',0),(70315,1954,'ur','Ù†Ø¦ÛŒ ÙÛØ±Ø³Øª Ø¨Ù†Ø§Ø¦ÛŒ Ú¯Ø¦ÛŒ ÛÛ’',0),(70316,1954,'sr','ÐÐ¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð° Ñ˜Ðµ Ð³ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ð½',0),(70317,1954,'vi','Táº¡o danh sÃ¡ch má»›i',0),(70318,1954,'af','Nuwe Lys is Gegenereer',0),(70319,1954,'ro','Noua lista a fost generat',0),(70320,1954,'et','Uus nimekiri on loodud',0),(70321,1954,'si','Je bil ustvarjen nov seznam',0),(70322,1954,'ba','Daftar baru telah dihasilkan',0),(70323,1954,'nl','Nieuwe lijst is gegenereerd',0),(70324,1954,'fi','Uuden luettelon luonnin',0),(70325,1954,'no','Ny liste er generert',0),(70326,1954,'da','Ny liste er blevet genereret',0),(70327,1954,'ko','ìƒˆ ëª©ë¡ì´ ìƒì„± ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(70328,1954,'he','×”×¨×©×™×ž×” ×”×—×“×©×” × ×•×¦×¨×”',0),(70329,1954,'el','ÎˆÏ‡ÎµÎ¹ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸ÎµÎ¯ Î½Î­Î± Î»Î¯ÏƒÏ„Î±',0),(70330,1954,'zh','æ–°çš„åˆ—è¡¨å·²ç»äº§ç”Ÿ\r\n',0),(70331,1954,'sv','Ny lista har skapats',0),(70332,1954,'it','Nuova lista Ã¨ stata generata',0),(70333,1954,'tl','',0),(70334,1954,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3627;&#3617;&#3656;&#3606;&#3641;&#3585;&#3626;&#3619;&#3657;&#3634;&#3591;&#3586;&#3638;&#3657;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(70335,1954,'hi','à¤¨à¤ˆ à¤¸à¥‚à¤šà¥€ à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(70336,1954,'ms','Senarai baru telah dihasilkan',0),(70337,1954,'ar','Ù„Ù‚Ø¯ ØªÙ… Ø¥Ù†Ø´Ø§Ø¡ Ù‚Ø§Ø¦Ù…Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(70338,1954,'fr','Nouvelle liste a Ã©tÃ© gÃ©nÃ©rÃ©e',0),(70339,1954,'jp','æ–°è¦?ãƒªã‚¹ãƒˆã?Œä½œæˆ?ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(70340,1954,'pt','Nova lista foi gerada',0),(70341,1954,'ru','Ð‘Ñ‹Ð» ÑÑ„Ð¾Ñ€Ð¼Ð¸Ñ€Ð¾Ð²Ð°Ð½ Ð½Ð¾Ð²Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(70342,1954,'es','Nueva Lista Ha Sido Generada',0),(70343,1954,'de','Neue Liste wurde erzeugt',0),(70344,1954,'en','New List Has Been Generated',0),(70345,1955,'is','',0),(70346,1955,'dr','Ù¾ÙŠØºØ§Ù… Ø¬Ø¯ÙŠØ¯ ',0),(70347,1955,'pr','Ù¾ÙŠØºØ§Ù… Ø¬Ø¯ÙŠØ¯ ',0),(70348,1955,'tr','Yeni iletileri',0),(70349,1955,'pl','nowe wiadomoÅ›ci',0),(70350,1955,'bg','Ð½Ð¾Ð²Ð¸ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(70351,1955,'ur','Ù†Ø¦Û’ Ù¾ÛŒØºØ§Ù…Ø§Øª',0),(70352,1955,'sr','Ð½Ð¾Ð²Ðµ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(70353,1955,'vi','tin nháº¯n má»›i',0),(70354,1955,'af','nuwe boodskap(pe)',0),(70355,1955,'ro','mesaje noi',0),(70356,1955,'et','uued sÃµnumid',0),(70357,1955,'si','nova sporoÄila',0),(70358,1955,'ba','pesan baru',0),(70359,1955,'nl','nieuwe berichten',0),(70360,1955,'fi','uutta viestiÃ¤',0),(70361,1955,'no','nye melding(er)',0),(70362,1955,'da','nye meddelelse(r)',0),(70363,1955,'ko','ìƒˆ ë©”ì‹œì§€',0),(70364,1955,'he','×”×•×“×¢×•×ª ×—×“×©×•×ª',0),(70365,1955,'el','Î½Î­Î± Î¼Î·Î½ÏÎ¼Î±Ï„Î±',0),(70366,1955,'zh','æ–°çš„æ¶ˆæ¯ï¼ˆsï¼‰\r\n',0),(70367,1955,'sv','nya meddelanden',0),(70368,1955,'it','nuovi messaggi',0),(70369,1955,'tl','',0),(70370,1955,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3651;&#3627;&#3617;&#3656;',0),(70371,1955,'hi','à¤¨à¤¯à¤¾ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(70372,1955,'ms','mesej baru',0),(70373,1955,'ar','Ø±Ø³Ø§Ù„Ø©/Ø±Ø³Ø§Ø¦Ù„ Ø¬Ø¯ÙŠØ¯Ø©',0),(70374,1955,'fr','nouveaux messages',0),(70375,1955,'jp','æ–°è¦?ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(70376,1955,'pt','nova mensagem (ns)',0),(70377,1955,'ru','Ð½Ð¾Ð²Ð¾Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ(Ð¸Ð¸)',0),(70378,1955,'es','Nuevo(s) mensaje(s)',0),(70379,1955,'de','neue Nachricht(en)',0),(70380,1955,'en','new message(s)',0),(70381,1956,'is','',0),(70382,1956,'dr','Ù¾ÙŠØºØ§Ù… Ø¬Ø¯ÙŠØ¯  Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³Øª Ø´Ù…Ø§ ',0),(70383,1956,'pr','Ù¾ÙŠØºØ§Ù… Ø¬Ø¯ÙŠØ¯  Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³Øª Ø´Ù…Ø§ ',0),(70384,1956,'tr','yeni iletilerin gelen kutusu',0),(70385,1956,'pl','nowe wiadomoÅ›ci w skrzynce odbiorczej',0),(70386,1956,'bg','Ð½Ð¾Ð²Ð¸ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ Ð² Ð¿Ð°Ð¿ÐºÐ°Ñ‚Ð° \"Ð’Ñ…Ð¾Ð´ÑÑ‰Ð¸\"',0),(70387,1956,'ur','Ø¢Ù¾ Ú©Û’ Ø¢Ù…Ø¯ Ø®Ø§Ù†Û Ù…ÛŒÚº Ù†Ø¦Û’ Ù¾ÛŒØºØ§Ù…Ø§Øª',0),(70388,1956,'sr','Ð½Ð¾Ð²Ðµ Ð¿Ð¾Ñ€ÑƒÐºÐµ Ñƒ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¾Ð¼',0),(70389,1956,'vi','tin nháº¯n má»›i trong há»™p thÆ° cá»§a báº¡n',0),(70390,1956,'af','nuwe boodskap in u inboks',0),(70391,1956,'ro','mesaje noi Ã®n mesaje primite',0),(70392,1956,'et','uued sÃµnumid sinu postkastis',0),(70393,1956,'si','nova sporoÄila v mapi Prejeto',0),(70394,1956,'ba','pesan baru dalam kotak masuk Anda',0),(70395,1956,'nl','nieuwe berichten in uw postvak in',0),(70396,1956,'fi','uusia viestejÃ¤ Saapuneet',0),(70397,1956,'no','nye meldinger i innboksen',0),(70398,1956,'da','nye meddelelser i din indbakke',0),(70399,1956,'ko','ë°›ì€ íŽ¸ì§€í•¨ì˜ ìƒˆ ë©”ì‹œì§€',0),(70400,1956,'he','×”×•×“×¢×•×ª ×—×“×©×•×ª ×‘×ª×™×‘×ª ×”×“×•××¨ ×”× ×›× ×¡ ×©×œ×š',0),(70401,1956,'el','Î½Î­Ï‰Î½ Î¼Î·Î½Ï…Î¼Î¬Ï„Ï‰Î½ ÏƒÏ„Î± ÎµÎ¹ÏƒÎµÏÏ‡ÏŒÎ¼ÎµÎ½Î¬ ÏƒÎ±Ï‚',0),(70402,1956,'zh','æ–°é‚®ä»¶åœ¨æ‚¨çš„æ”¶ä»¶ç®±\r\n',0),(70403,1956,'sv','nya meddelanden i Inkorgen',0),(70404,1956,'it','nuovi messaggi nella posta in arrivo',0),(70405,1956,'tl','',0),(70406,1956,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3651;&#3627;&#3617;&#3656;&#3651;&#3609;&#3585;&#3621;&#3656;&#3629;&#3591;&#3586;&#3634;&#3648;&#3586;&#3657;&#3634;',0),(70407,1956,'hi','à¤…à¤ªà¤¨à¥‡ à¤‡à¤¨à¤¬à¥‰à¤•à¥ à¤¸ à¤®à¥‡à¤‚ à¤¨à¤ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(70408,1956,'ms','mesej-mesej baru dalam Peti Masuk anda',0),(70409,1956,'ar','Ø±Ø³Ø§Ø¦Ù„ Ø¬Ø¯ÙŠØ¯Ø© ÙÙŠ Ø¹Ù„Ø¨Ø© Ø§Ù„ÙˆØ§Ø±Ø¯ Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(70410,1956,'fr','nouveaux messages dans votre boÃ®te de rÃ©ception',0),(70411,1956,'jp','å?—ä¿¡ç®±ã?®æ–°è¦?ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(70412,1956,'pt','novas mensagens em sua caixa de entrada',0),(70413,1956,'ru','Ñƒ Ð²Ð°Ñ Ð½Ð¾Ð²Ñ‹Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(70414,1956,'es','nuevo mensaje en su inbox',0),(70415,1956,'de','neue Nachrichten im Posteingang',0),(70416,1956,'en','new messages in your inbox',0),(70417,1957,'is','',0),(70418,1957,'dr','1  ÙØ±Ù…Ø§ÛŒØ´ Ø¬Ø¯ÙŠØ¯ : Ø§ÙŠÙ† ÙŠÙƒ Ø¬Ù†Ø³ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³ Ø§Ø³Øª ',0),(70419,1957,'pr','ÙŠØºØ§Ù… 1  Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ : Ø§ÙŠÙ† ÙŠÙƒ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø§Ø³Øª ',0),(70420,1957,'tr','<div style=\"padding-right:10px;\">Stok maddesinin bu.</div>',0),(70421,1957,'pl','<div style=\"padding-right:10px;\">To jest towar.</div>',0),(70422,1957,'bg','<div style=\"padding-right:10px;\">Ð¢Ð¾Ð²Ð° Ðµ Ð¡ÐšÐ›ÐÐ”ÐžÐ’ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ».</div>',0),(70423,1957,'ur','<div style=\"padding-right:10px;\">ÛŒÛ Ø§ÛŒÚ© Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ ÛÛ’ Û”</div>',0),(70424,1957,'sr','<div style=\"padding-right:10px;\">ÐžÐ²Ð¾ Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð½Ð° Ð—ÐÐ›Ð˜Ð¥ÐÐœÐ.</div>',0),(70425,1957,'vi','<div style=\"padding-right:10px;\">ÄÃ¢y lÃ  má»™t máº·t hÃ ng trong kho.</div>',0),(70426,1957,'af','<div style=\"padding-right:10px;\">Dit is \'n INVENTARIS ITEM.</div>',0),(70427,1957,'ro','<div style=\"padding-right:10px;\">Acest lucru este un element de inventar.</div>',0),(70428,1957,'et','<div style=\"padding-right:10px;\">See on LAOKAUBA.</div>',0),(70429,1957,'si','<div style=\"padding-right:10px;\">To je ARTIKLA zaloge.</div>',0),(70430,1957,'ba','<div style=\"padding-right:10px;\">Ini adalah ITEM persediaan.</div>',0),(70431,1957,'nl','<div style=\"padding-right:10px;\">Dit is een VOORRAADARTIKEL.</div>',0),(70432,1957,'fi','<div style=\"padding-right:10px;\">TÃ¤mÃ¤ on VARASTOTUOTE.</div>',0),(70433,1957,'no','<div style=\"padding-right:10px;\">Dette er en LAGERVARE.</div>',0),(70434,1957,'da','<div style=\"padding-right:10px;\">Dette er en LAGERVARE.</div>',0),(70435,1957,'ko','<div style=\"padding-right:10px;\">ì´ê²ƒì€ ìž¬ê³  í•­ëª©ìž…ë‹ˆë‹¤.</div>',0),(70436,1957,'he','<div style=\"padding-right:10px;\">×–×”×• ×¤×¨×™×˜ ×ž×œ××™.</div>',0),(70437,1957,'el','<div style=\"padding-right:10px;\">Î ÏÏŒÎºÎµÎ¹Ï„Î±Î¹ Î³Î¹Î± Î­Î½Î± Î•ÎŠÎ”ÎŸÎ£ Î‘Î ÎŸÎ˜ÎˆÎœÎ‘Î¤ÎŸÎ£.</div>',0),(70438,1957,'zh','è¿™æ˜¯ä¸€ä¸ªè°ƒæŸ¥é¡¹ç›®ã€‚\r\n',0),(70439,1957,'sv','<div style=\"padding-right:10px;\">Detta Ã¤r en LAGERARTIKEL.</div>',0),(70440,1957,'it','<div style=\"padding-right:10px;\">Questo Ã¨ un articolo di magazzino.</div>',0),(70441,1957,'tl','',0),(70442,1957,'th','<div style=\"padding-right:10px;\">This is an INVENTORY ITEM.</div>',0),(70443,1957,'hi','<div style=\"padding-right:10px;\">à¤‡à¤¸ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤à¤• à¤†à¤‡à¤Ÿà¤® à¤¹à¥ˆà¥¤</div>',0),(70444,1957,'ms','<div style=\"padding-right:10px;\">Ini adalah satu ITEM inventori.</div>',0),(70445,1957,'ar','<div style=\"padding-right:10px;\">ÙˆÙ‡Ø°Ø§ Ù‡Ùˆ \"Ø¹Ù†ØµØ± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†\".</div>',0),(70446,1957,'fr','<div style=\"padding-right:10px;\">Il s\'agit d\'un article en stock.</div>',0),(70447,1957,'jp','<div style=\"padding-right:10px;\">ã?“ã‚Œã?¯åœ¨åº«å“?ç›®ã?§ã?™</div>',0),(70448,1957,'pt','<div style=\"padding-right:10px;\">Este Ã© um ITEM de inventÃ¡rio.</div>',0),(70449,1957,'ru','<div style=\"padding-right:10px;\">Ð­Ñ‚Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸.</div>',0),(70450,1957,'es','<div estilo=\"relleno-derecha:10px\") Esto es un ITEM DE INVENTARIO.</div>',0),(70451,1957,'de','<div style=\"padding-right:10px;\">Dies ist ein LAGERARTIKEL.</div>',0),(70452,1957,'en','<div style=\"padding-right:10px;\">This is an INVENTORY ITEM.</div>',0),(70453,1958,'is','',0),(70454,1958,'dr','2  ÙØ±Ù…Ø§ÛŒØ´ Ø¬Ø¯ÙŠØ¯ : ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯ÙƒØ§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(70455,1958,'pr','Ù¾ÙŠØºØ§Ù… 2  Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ : ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯ÙƒØ§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(70456,1958,'tr','<div style=\"padding-right:10px;\">GÃ¶sterilmeyen tÃ¼m alanlarÄ± otomatik olarak girilir.</div>',0),(70457,1958,'pl','<div style=\"padding-right:10px;\">Wszystkie pola, ktÃ³re nie sÄ… wprowadzane w automatycznie.</div>',0),(70458,1958,'bg','<div style=\"padding-right:10px;\">Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚, Ð½Ðµ ÑÐ° Ð²Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð² Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾.</div>',0),(70459,1958,'ur','<div style=\"padding-right:10px;\">ØªÙ…Ø§Ù… Ù‚Ø·Ø¹Ø§Øª Ù†ÛÛŒÚº Ø¯Ú©Ú¾Ø§ÛŒØ§ Ú¯ÛŒØ§ Ù…ÛŒÚº Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ Ø¯Ø§Ø®Ù„ ÛÙˆØ¦Û’ ÛÛŒÚº Û”</div>',0),(70460,1958,'sr','<div style=\"padding-right:10px;\">Ð¡Ð²Ð° Ð¿Ð¾Ñ™Ð° Ð½Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜Ñƒ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ ÑÐµ ÑƒÐ½Ð¾ÑÐµ Ñƒ.</div>',0),(70461,1958,'vi','<div style=\"padding-right:10px;\">Táº¥t cáº£ cÃ¡c trÆ°á»ng khÃ´ng hiá»ƒn thá»‹ Ä‘Æ°á»£c nháº­p tá»± Ä‘á»™ng.</div>',0),(70462,1958,'af','<div style=\"padding-right:10px;\">Alle velde nie getoon is ingeskryf outomaties.</div>',0),(70463,1958,'ro','<div style=\"padding-right:10px;\">Toate domeniile de activitate indicat nu sunt Ã®nscrise Ã®n mod automat.</div>',0),(70464,1958,'et','<div style=\"padding-right:10px;\">VÃ¤ljad ei juhul sisestatakse automaatselt.</div>',0),(70465,1958,'si','<div style=\"padding-right:10px;\">Vsa polja niso prikazani, vnesejo v samodejno.</div>',0),(70466,1958,'ba','<div style=\"padding-right:10px;\">Semua bidang yang tidak ditampilkan yang dimasukkan secara otomatis.</div>',0),(70467,1958,'nl','<div style=\"padding-right:10px;\">Alle velden niet weergegeven worden automatisch ingevoerd.</div>',0),(70468,1958,'fi','<div style=\"padding-right:10px;\">Kaikki kentÃ¤t eivÃ¤t nÃ¤y lisÃ¤tÃ¤Ã¤n automaattisesti.</div>',0),(70469,1958,'no','<div style=\"padding-right:10px;\">Alle felt vises ikke angis automatisk i.</div>',0),(70470,1958,'da','<div style=\"padding-right:10px;\">Alle felter ikke vist angives automatisk i.</div>',0),(70471,1958,'ko','<div style=\"padding-right:10px;\">í‘œì‹œ ë˜ì§€ ì•ŠëŠ” ëª¨ë“  í•„ë“œì— ìžë™ìœ¼ë¡œ ìž…ë ¥ ë©ë‹ˆë‹¤.</div>',0),(70472,1958,'he','<div style=\"padding-right:10px;\">×›×œ ×©×“×•×ª ××™× ×” ×ž×•×¦×’×ª ×ž×•×–× ×™× ××•×˜×•×ž×˜×™×ª.</div>',0),(70473,1958,'el','<div style=\"padding-right:10px;\">ÎŒÎ»Î± Ï„Î± Ï€ÎµÎ´Î¯Î± Ï€Î¿Ï… Î´ÎµÎ½ ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ ÎµÎ³Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î±.</div>',0),(70474,1958,'zh','æ‰€æœ‰æ æ²¡æœ‰æ˜¾ç¤ºåœ¨è‡ªåŠ¨è¾“å…¥ã€‚\r\n',0),(70475,1958,'sv','<div style=\"padding-right:10px;\">Alla fÃ¤lt som inte visas Ã¤r infÃ¶rda i automatiskt.</div>',0),(70476,1958,'it','<div style=\"padding-right:10px;\">Tutti i campi indicati non sono entrati automaticamente.</div>',0),(70477,1958,'tl','',0),(70478,1958,'th','<div style=\"padding-right:10px;\">All fields not shown are entered in automatically.</div>',0),(70479,1958,'hi','<div style=\"padding-right:10px;\">à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤–à¤¾à¤ à¤—à¤ à¤¸à¤­à¥€ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤®à¥‡à¤‚ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚à¥¤</div>',0),(70480,1958,'ms','<div style=\"padding-right:10px;\">Semua bidang yang tidak dimasukkan dalam secara automatik.</div>',0),(70481,1958,'ar','<div style=\"padding-right:10px;\">ÙŠØªÙ… Ø¥Ø¯Ø®Ø§Ù„ ÙƒØ§ÙØ© Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„ØªÙŠ Ù„Ø§ ØªØ¸Ù‡Ø± ÙÙŠ ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹.</div>',0),(70482,1958,'fr','<div style=\"padding-right:10px;\">Tous les champs non affichÃ©s sont automatiquement inscrits.</div>',0),(70483,1958,'jp','<div style=\"padding-right:10px;\">è¡¨ç¤ºã?•ã‚Œã?¦ã?„ã?ªã?„å…¨ã?¦ã?®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã?¯è‡ªå‹•çš„ã?«å…¥åŠ›ã?•ã‚Œã?¾ã?™</div>',0),(70484,1958,'pt','<div style=\"padding-right:10px;\">Todos os campos mostrados nÃ£o sÃ£o inseridos no automaticamente.</div>',0),(70485,1958,'ru','<div style=\"padding-right:10px;\">Ð’ÑÐµ Ð¿Ð¾Ð»Ñ Ð½Ðµ Ð²Ð²Ð¾Ð´ÑÑ‚ÑÑ Ð² Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸.</div>',0),(70486,1958,'es','<div estilo=\"relleno-derecha:10px\") Todos campos no mostrados se entra automaticamente.</div>',0),(70487,1958,'de','<div style=\"padding-right:10px;\">Alle Felder, die nicht angezeigt werden in automatisch eingegeben.</div>',0),(70488,1958,'en','<div style=\"padding-right:10px;\">All fields not shown are entered in automatically.</div>',0),(70489,1959,'is','',0),(70490,1959,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø¯ÙŠØ¯',0),(70491,1959,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø¯ÙŠØ¯',0),(70492,1959,'tr','Yeni rapor',0),(70493,1959,'pl','Nowy raport',0),(70494,1959,'bg','ÐÐ¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(70495,1959,'ur','Ù†Ø¦ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(70496,1959,'sr','ÐÐ¾Ð²Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(70497,1959,'vi','BÃ¡o cÃ¡o má»›i',0),(70498,1959,'af','Nuwe Verslag',0),(70499,1959,'ro','Nou raport',0),(70500,1959,'et','Uus aruanne',0),(70501,1959,'si','Novo poroÄilo',0),(70502,1959,'ba','Laporan baru',0),(70503,1959,'nl','Nieuw rapport',0),(70504,1959,'fi','Uusi raportti',0),(70505,1959,'no','Ny rapport',0),(70506,1959,'da','Ny rapport',0),(70507,1959,'ko','ìƒˆ ë³´ê³ ì„œ',0),(70508,1959,'he','×“×• ×— ×—×“×©',0),(70509,1959,'el','ÎÎ­Î± Î­ÎºÎ¸ÎµÏƒÎ·',0),(70510,1959,'zh','æ–°æŠ¥å‘Š\r\n',0),(70511,1959,'sv','Ny rapport',0),(70512,1959,'it','Nuovo report',0),(70513,1959,'tl','',0),(70514,1959,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3651;&#3627;&#3617;&#3656;',0),(70515,1959,'hi','à¤¨à¤ˆ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(70516,1959,'ms','Laporan baru',0),(70517,1959,'ar','ØªÙ‚Ø±ÙŠØ± Ø¬Ø¯ÙŠØ¯',0),(70518,1959,'fr','Nouveau rapport',0),(70519,1959,'jp','æ–°è¦?ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(70520,1959,'pt','Novo relatÃ³rio',0),(70521,1959,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(70522,1959,'es','Nuevo Informe',0),(70523,1959,'de','Neuer Bericht',0),(70524,1959,'en','New report',0),(70525,1960,'is','',0),(70526,1960,'dr','ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø­Ø±Ø§Ø¬ Ø¬Ø¯ÙŠØ¯ ',0),(70527,1960,'pr','ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø­Ø±Ø§Ø¬ Ø¬Ø¯ÙŠØ¯ ',0),(70528,1960,'tr','SeÃ§im listesi girdisi ekleme',0),(70529,1960,'pl','Dodaj wpis listy wyboru',0),(70530,1960,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€',0),(70531,1960,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(70532,1960,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ð»Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð±Ð¾Ñ€Ð°',0),(70533,1960,'vi','ThÃªm danh sÃ¡ch nháº­p Ä‘Ã£ chá»n',0),(70534,1960,'af','Voeg seleksie lys inskrywing',0),(70535,1960,'ro','AdÄƒugaÅ£i intrare Ã®n lista de selectare',0),(70536,1960,'et','Valik loendisse kirje lisamine',0),(70537,1960,'si','Dodati vnos v seznam izbire',0),(70538,1960,'ba','Tambahkan entri daftar pilihan',0),(70539,1960,'nl','Item uit de lijst selectie toevoegen',0),(70540,1960,'fi','LisÃ¤Ã¤ valinta luettelo-merkintÃ¤',0),(70541,1960,'no','Legge til utvalg oppfÃ¸ring',0),(70542,1960,'da','TilfÃ¸j udvalg liste post',0),(70543,1960,'ko','ì„ íƒ ëª©ë¡ í•­ëª© ì¶”ê°€',0),(70544,1960,'he','×œ×”×•×¡×™×£ ×¢×¨×š ×¨×©×™×ž×ª ×‘×—×™×¨×”',0),(70545,1960,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚',0),(70546,1960,'zh','æ·»åŠ é€‰æ‹©åˆ—è¡¨æ¡ç›®\r\n',0),(70547,1960,'sv','LÃ¤gg till val av lista',0),(70548,1960,'it','Aggiungere la voce di elenco di selezione',0),(70549,1960,'tl','',0),(70550,1960,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(70551,1960,'hi','à¤šà¤¯à¤¨ à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(70552,1960,'ms','Tambah entri senarai pilihan',0),(70553,1960,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø¯Ø®Ø§Ù„ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„ØªØ­Ø¯ÙŠØ¯',0),(70554,1960,'fr','Ajouter l\'entrÃ©e de liste de sÃ©lection',0),(70555,1960,'jp','é?¸æŠžãƒªã‚¹ãƒˆå…¥åŠ›ã?®è¿½åŠ ',0),(70556,1960,'pt','Adicionar a lista de seleÃ§Ã£o de entrada',0),(70557,1960,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð—Ð°Ð¿Ð¸ÑÑŒ Ð¡Ð¿Ð¸ÑÐºÐ° Ð’Ñ‹Ð±Ð¾Ñ€Ð°',0),(70558,1960,'es','Agregar Entrada de Lista de SelecciÃ³n',0),(70559,1960,'de','Auswahl-Liste-Eintrag hinzufÃ¼gen',0),(70560,1960,'en','Add Selection List Entry',0),(70561,1961,'is','',0),(70562,1961,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(70563,1961,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(70564,1961,'tr','Yeni satÄ±cÄ±',0),(70565,1961,'pl','Nowego dostawcy',0),(70566,1961,'bg','ÐÐ¾Ð² Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(70567,1961,'ur','Ù†Ø¦Û’ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(70568,1961,'sr','ÐÐ¾Ð²Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(70569,1961,'vi','NgÆ°á»i bÃ¡n má»›i',0),(70570,1961,'af','Nuwe Verskaffer',0),(70571,1961,'ro','Noul furnizor',0),(70572,1961,'et','Uus tarnija',0),(70573,1961,'si','Nov prodajalec',0),(70574,1961,'ba','Vendor baru',0),(70575,1961,'nl','Nieuwe leverancier',0),(70576,1961,'fi','Uusi toimittaja',0),(70577,1961,'no','Ny leverandÃ¸r',0),(70578,1961,'da','Ny leverandÃ¸r',0),(70579,1961,'ko','ìƒˆë¡œìš´ ê³µê¸‰ ì—…ì²´',0),(70580,1961,'he','×¡×¤×§ ×—×“×©',0),(70581,1961,'el','ÎÎ­Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(70582,1961,'zh','æ–°ä¾›åº”å•†\r\n',0),(70583,1961,'sv','Ny leverantÃ¶r',0),(70584,1961,'it','Nuovo fornitore',0),(70585,1961,'tl','',0),(70586,1961,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3651;&#3627;&#3617;&#3656;',0),(70587,1961,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(70588,1961,'ms','Penjual baru',0),(70589,1961,'ar','Ù…ÙˆØ±Ø¯ Ø¬Ø¯ÙŠØ¯',0),(70590,1961,'fr','Nouveau vendeur',0),(70591,1961,'jp','æ–°ã?—ã?„æ¥­è€…',0),(70592,1961,'pt','Vendedor novo',0),(70593,1961,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº',0),(70594,1961,'es','Nuevo Proveedor',0),(70595,1961,'de','Neue Anbieter',0),(70596,1961,'en','New Vendor',0),(70597,1962,'is','',0),(70598,1962,'dr','Ù†Ø³Ø®Ù‡ Ø¬Ø¯ÙŠØ¯',0),(70599,1962,'pr','Ù†Ø³Ø®Ù‡ Ø¬Ø¯ÙŠØ¯',0),(70600,1962,'tr','Yeni sÃ¼rÃ¼m',0),(70601,1962,'pl','Nowa wersja',0),(70602,1962,'bg','ÐÐ¾Ð²Ð° Ð²ÐµÑ€ÑÐ¸Ñ',0),(70603,1962,'ur','Ù†Ø¦Û’ ÙˆØ±Ú˜Ù†',0),(70604,1962,'sr','ÐÐ¾Ð²Ð° Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð°',0),(70605,1962,'vi','PhiÃªn báº£n má»›i',0),(70606,1962,'af','Nuwe Weergawe',0),(70607,1962,'ro','Noua versiune',0),(70608,1962,'et','Uus versioon',0),(70609,1962,'si','Nova razliÄica',0),(70610,1962,'ba','Versi baru',0),(70611,1962,'nl','Nieuwe versie',0),(70612,1962,'fi','Uusi versio',0),(70613,1962,'no','Ny versjon',0),(70614,1962,'da','Ny Version',0),(70615,1962,'ko','ìƒˆë¡œìš´ ë²„ì „',0),(70616,1962,'he','×’×™×¨×¡×” ×—×“×©×”',0),(70617,1962,'el','ÎÎ­Î± Î­ÎºÎ´Î¿ÏƒÎ·',0),(70618,1962,'zh','æ–°ç‰ˆæœ¬\r\n',0),(70619,1962,'sv','Ny Version',0),(70620,1962,'it','Nuova versione',0),(70621,1962,'tl','',0),(70622,1962,'th','&#3648;&#3623;&#3629;&#3619;&#3660;&#3594;&#3633;&#3656;&#3609;&#3651;&#3627;&#3617;&#3656;',0),(70623,1962,'hi','à¤¨à¤¯à¤¾ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(70624,1962,'ms','Versi baru',0),(70625,1962,'ar','Ø§Ù„Ø¥ØµØ¯Ø§Ø± Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(70626,1962,'fr','Nouvelle Version',0),(70627,1962,'jp','æ–°è¦?ãƒ?ãƒ¼ã‚¸ãƒ§ãƒ³',0),(70628,1962,'pt','Nova versÃ£o',0),(70629,1962,'ru','ÐÐ¾Ð²Ð°Ñ Ð²ÐµÑ€ÑÐ¸Ñ',0),(70630,1962,'es','Nueva VersiÃ³n',0),(70631,1962,'de','Neue Version',0),(70632,1962,'en','New Version',0),(70633,1963,'is','',0),(70634,1963,'dr','Ø¨Ø¹Ø¯ ',0),(70635,1963,'pr','Ø¨Ø¹Ø¯ ',0),(70636,1963,'tr','Sonraki',0),(70637,1963,'pl','NastÄ™pny',0),(70638,1963,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð°',0),(70639,1963,'ur','Ø§Ú¯Ù„Ø§',0),(70640,1963,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸',0),(70641,1963,'vi','Tiáº¿p theo',0),(70642,1963,'af','Volgende',0),(70643,1963,'ro','Urmatorul',0),(70644,1963,'et','Edasi',0),(70645,1963,'si','Naslednji',0),(70646,1963,'ba','Berikutnya',0),(70647,1963,'nl','Volgende',0),(70648,1963,'fi','Seuraava',0),(70649,1963,'no','Neste',0),(70650,1963,'da','NÃ¦ste',0),(70651,1963,'ko','ë‹¤ìŒ',0),(70652,1963,'he','×”×‘×',0),(70653,1963,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î·',0),(70654,1963,'zh','ä¸‹ä¸€æ­¥\r\n',0),(70655,1963,'sv','NÃ¤sta',0),(70656,1963,'it','Prossimo',0),(70657,1963,'tl','',0),(70658,1963,'th','&#3605;&#3656;&#3629;&#3652;&#3611;',0),(70659,1963,'hi','à¤…à¤—à¤²à¥‡',0),(70660,1963,'ms','Seterusnya',0),(70661,1963,'ar','Ø§Ù„ØªØ§Ù„ÙŠ',0),(70662,1963,'fr','Prochaine',0),(70663,1963,'jp','æ¬¡',0),(70664,1963,'pt','PrÃ³ximo',0),(70665,1963,'ru','Ð”Ð°Ð»ÐµÐµ',0),(70666,1963,'es','PrÃ³ximo',0),(70667,1963,'de','NÃ¤chste',0),(70668,1963,'en','Next',0),(70669,1964,'is','',0),(70670,1964,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø¹Ø¯ÙŠ ',0),(70671,1964,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¨Ø¹Ø¯ÙŠ ',0),(70672,1964,'tr','Sonraki Ã§alÄ±ÅŸan',0),(70673,1964,'pl','Kolejny pracownik',0),(70674,1964,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(70675,1964,'ur','Ø§Ú¯Ù„Û’ Ù…Ù„Ø§Ø²Ù…',0),(70676,1964,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸',0),(70677,1964,'vi','NhÃ¢n viÃªn tiáº¿p theo',0),(70678,1964,'af','Volgende Werknemer',0),(70679,1964,'ro','UrmÄƒtorii angajat',0),(70680,1964,'et','JÃ¤rgmine tÃ¶Ã¶taja',0),(70681,1964,'si','Naslednji zaposleni',0),(70682,1964,'ba','Berikutnya karyawan',0),(70683,1964,'nl','Volgende werknemer',0),(70684,1964,'fi','Seuraava tyÃ¶ntekijÃ¤',0),(70685,1964,'no','Neste ansatt',0),(70686,1964,'da','NÃ¦ste medarbejder',0),(70687,1964,'ko','ë‹¤ìŒ ì§ì›',0),(70688,1964,'he','×¢×•×‘×“ ×”×‘×',0),(70689,1964,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(70690,1964,'zh','ä¸‹ä¸€é›‡å‘˜\r\n',0),(70691,1964,'sv','NÃ¤sta medarbetare',0),(70692,1964,'it','Prossimo dipendente',0),(70693,1964,'tl','',0),(70694,1964,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(70695,1964,'hi','à¤…à¤—à¤²à¥‡ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(70696,1964,'ms','Pekerja seterusnya',0),(70697,1964,'ar','Ø§Ù„Ù…ÙˆØ¸Ù Ø§Ù„ØªØ§Ù„ÙŠ',0),(70698,1964,'fr','Prochain employÃ©',0),(70699,1964,'jp','æ¬¡ã?®å¾“æ¥­å“¡',0),(70700,1964,'pt','PrÃ³ximo empregado',0),(70701,1964,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº',0),(70702,1964,'es','PrÃ³ximo Empleado',0),(70703,1964,'de','NÃ¤chsten Mitarbeiter',0),(70704,1964,'en','Next Employee',0),(70705,1965,'is','',0),(70706,1965,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¨Ø¹Ø¯ÙŠ ',0),(70707,1965,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¨Ø¹Ø¯ÙŠ ',0),(70708,1965,'tr','Sonraki fatura numarasÄ±',0),(70709,1965,'pl','NastÄ™pny numer faktury',0),(70710,1965,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(70711,1965,'ur','Ø§Ú¯Ù„Ø§ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø±',0),(70712,1965,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(70713,1965,'vi','Sá»‘ hÃ³a Ä‘Æ¡n tiáº¿p theo',0),(70714,1965,'af','Volgende Faktuurnommer',0),(70715,1965,'ro','NumÄƒr facturÄƒ',0),(70716,1965,'et','JÃ¤rgmine arve number',0),(70717,1965,'si','Naslednja Å¡tevilka raÄuna',0),(70718,1965,'ba','Nomor Invoice berikutnya',0),(70719,1965,'nl','Volgende factuurnummer',0),(70720,1965,'fi','Seuraavan laskunumero',0),(70721,1965,'no','Neste fakturanummer',0),(70722,1965,'da','NÃ¦ste fakturanummer',0),(70723,1965,'ko','ë‹¤ìŒìœ¼ë¡œ ì†¡ìž¥ ë²ˆí˜¸',0),(70724,1965,'he','×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª ×”×‘××”',0),(70725,1965,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(70726,1965,'zh','ä¸‹ä¸€å¼ å‘ç¥¨å·ç \r\n',0),(70727,1965,'sv','NÃ¤sta fakturanummer',0),(70728,1965,'it','Prossimo numero di fattura',0),(70729,1965,'tl','',0),(70730,1965,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(70731,1965,'hi','à¤…à¤—à¤²à¥‡ à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(70732,1965,'ms','Nombor invois berikutnya',0),(70733,1965,'ar','Ø±Ù‚Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(70734,1965,'fr','Prochain numÃ©ro de la facture',0),(70735,1965,'jp','æ¬¡ã?®è«‹æ±‚æ›¸ç•ªå?·',0),(70736,1965,'pt','No prÃ³ximo nÃºmero da fatura',0),(70737,1965,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ Ð¡Ñ‡ÐµÑ‚Ð°',0),(70738,1965,'es','PrÃ³xima NÃºmero de Factura',0),(70739,1965,'de','NÃ¤chste Rechnungsnummer',0),(70740,1965,'en','Next Invoice Number',0),(70741,1966,'is','',0),(70742,1966,'dr','ÙØ¹Ø§Ù„ÙŠØª ÙØ±ÙˆØ´ Ø¨Ø¹Ø¯ÙŠ ',0),(70743,1966,'pr','ÙØ¹Ø§Ù„ÙŠØª ÙØ±ÙˆØ´ Ø¨Ø¹Ø¯ÙŠ ',0),(70744,1966,'tr','Sonraki satÄ±ÅŸ eylemi',0),(70745,1966,'pl','NastÄ™pnej sprzedaÅ¼y akcji',0),(70746,1966,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(70747,1966,'ur','Ø§Ú¯Ù„Û’ Ø³ÛŒÙ„Ø² Ø¹Ù…Ù„',0),(70748,1966,'sr','Ð”Ð°Ñ™Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(70749,1966,'vi','HÃ nh Ä‘á»™ng bÃ¡n hÃ ng tiáº¿p theo',0),(70750,1966,'af','Volgende Verkoopsaksie',0),(70751,1966,'ro','UrmÄƒtoarea acÅ£iune vÃ¢nzÄƒri',0),(70752,1966,'et','JÃ¤rgmise mÃ¼Ã¼gi tegevus',0),(70753,1966,'si','Naslednji prodajne akcije',0),(70754,1966,'ba','Tindakan penjualan berikutnya',0),(70755,1966,'nl','Volgende verkoop actie',0),(70756,1966,'fi','Seuraava myynti toiminto',0),(70757,1966,'no','Neste salg handling',0),(70758,1966,'da','NÃ¦ste salg handling',0),(70759,1966,'ko','ë‹¤ìŒ íŒë§¤ ìž‘ì—…',0),(70760,1966,'he','×”×¤×¢×•×œ×” ×”×‘××” ×ž×›×™×¨×•×ª',0),(70761,1966,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· ÎµÎ½Î­ÏÎ³ÎµÎ¹Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(70762,1966,'zh','ä¸‹ä¸€ä¸ªé”€å”®è¡ŒåŠ¨\r\n',0),(70763,1966,'sv','NÃ¤sta fÃ¶rsÃ¤ljning Ã¥tgÃ¤rd',0),(70764,1966,'it','Azione successiva vendita',0),(70765,1966,'tl','',0),(70766,1966,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(70767,1966,'hi','à¤…à¤—à¤²à¥‡ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(70768,1966,'ms','Seterusnya tindakan jualan',0),(70769,1966,'ar','Ø¹Ù…Ù„ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ù‚Ø§Ø¯Ù…Ø©',0),(70770,1966,'fr','Prochaine vente Action',0),(70771,1966,'jp','æ¬¡ã?®ã‚»ãƒ¼ãƒ«ã‚¹ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(70772,1966,'pt','PrÃ³xima aÃ§Ã£o de vendas',0),(70773,1966,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰ÐµÐµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(70774,1966,'es','PrÃ³xima AcciÃ³n de Ventas',0),(70775,1966,'de','NÃ¤chste Verkaufs-Aktion',0),(70776,1966,'en','Next Sales Action',0),(70777,1967,'is','',0),(70778,1967,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø¹Ø¯ÙŠ ',0),(70779,1967,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø¹Ø¯ÙŠ ',0),(70780,1967,'tr','Sonraki satÄ±cÄ±',0),(70781,1967,'pl','NastÄ™pnego Sprzedawca',0),(70782,1967,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡',0),(70783,1967,'ur','Ø§Ú¯Ù„Û’ Ø¨Ù†Ø§Ú©Ø±',0),(70784,1967,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(70785,1967,'vi','NhÃ¢n viÃªn kinh doanh tiáº¿p theo',0),(70786,1967,'af','Volgende Verkoopspersoon',0),(70787,1967,'ro','Agent de vÃ¢nzÄƒri viitoare',0),(70788,1967,'et','JÃ¤rgmine mÃ¼Ã¼gimees',0),(70789,1967,'si','Naslednji prodajalec',0),(70790,1967,'ba','Salesman berikutnya',0),(70791,1967,'nl','Volgende verkoper',0),(70792,1967,'fi','Seuraava myyjÃ¤',0),(70793,1967,'no','Neste selger',0),(70794,1967,'da','NÃ¦ste sÃ¦lger',0),(70795,1967,'ko','ë‹¤ìŒ ì„¸ì¼ì¦ˆ ë§¨',0),(70796,1967,'he','×ž×›×™×¨×•×ª ×”×‘×',0),(70797,1967,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Ï€Ï‰Î»Î·Ï„Î®Ï‚',0),(70798,1967,'zh','ä¸‹ä¸€ä¸ªæŽ¨é”€å‘˜\r\n',0),(70799,1967,'sv','NÃ¤sta fÃ¶rsÃ¤ljare',0),(70800,1967,'it','Venditore di prossimo',0),(70801,1967,'tl','',0),(70802,1967,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(70803,1967,'hi','à¤…à¤—à¤²à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(70804,1967,'ms','Jurujual yang seterusnya',0),(70805,1967,'ar','Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„ØªØ§Ù„ÙŠ',0),(70806,1967,'fr','Vendeur de prochain',0),(70807,1967,'jp','æ¬¡ã?®ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…',0),(70808,1967,'pt','Vendedor de prÃ³xima',0),(70809,1967,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(70810,1967,'es','Proximo Proveedor',0),(70811,1967,'de','NÃ¤chsten VerkÃ¤ufer',0),(70812,1967,'en','Next Salesman',0),(70813,1968,'is','',0),(70814,1968,'dr','ØªØ§Ø±ÙŠØ®  Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±ÙŠØ²ÙŠ Ø´Ø¯Ù‡ Ø¨Ø¹Ø¯ÙŠ ',0),(70815,1968,'pr','ØªØ§Ø±ÙŠØ®  Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±ÙŠØ²ÙŠ Ø´Ø¯Ù‡ Ø¨Ø¹Ø¯ÙŠ ',0),(70816,1968,'tr','Sonraki planlanan Tarih',0),(70817,1968,'pl','NastÄ™pnym zaplanowanym terminie',0),(70818,1968,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð° ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(70819,1968,'ur','Ø§Ú¯Ù„ÛŒ Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ ØªØ§Ø±ÛŒØ®',0),(70820,1968,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð¿Ð»Ð°Ð½Ð¸Ñ€Ð°Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(70821,1968,'vi','NgÃ y dá»± trÃ¹ tiáº¿p theo',0),(70822,1968,'af','Volgende Geskeduleerde Datum',0),(70823,1968,'ro','UrmÄƒtoarea datÄƒ programatÄƒ',0),(70824,1968,'et','JÃ¤rgmise plaanitud kuupÃ¤ev',0),(70825,1968,'si','Naslednji predvideni datum',0),(70826,1968,'ba','Berikutnya dijadwalkan tanggal',0),(70827,1968,'nl','Volgende geplande datum',0),(70828,1968,'fi','Seuraavan aikataulun',0),(70829,1968,'no','Neste planlagte dato',0),(70830,1968,'da','NÃ¦ste planlagte dato',0),(70831,1968,'ko','ë‹¤ìŒ ì˜ˆì•½ ëœ ë‚ ì§œ',0),(70832,1968,'he','×ª××¨×™×š ×”×ž×ª×•×–×ž×Ÿ ×”×‘×',0),(70833,1968,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Ï€ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÎ¼Î­Î½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(70834,1968,'zh','ä¸‹ä¸€ä¸ªé¢„å®šæ—¥æœŸ\r\n',0),(70835,1968,'sv','NÃ¤sta schemalagda datum',0),(70836,1968,'it','Prossima data prevista',0),(70837,1968,'tl','',0),(70838,1968,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(70839,1968,'hi','à¤…à¤—à¤²à¤¾ à¤¶à¥‡à¤¡à¥à¤¯à¥‚à¤² à¤•à¤¿à¤ à¤—à¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(70840,1968,'ms','Tarikh dijadualkan seterusnya',0),(70841,1968,'ar','Ø§Ù„Ù…ÙˆØ¹Ø¯ Ø§Ù„Ù‚Ø§Ø¯Ù…',0),(70842,1968,'fr','Prochaine Date prÃ©vue',0),(70843,1968,'jp','æ¬¡ã?®äºˆå®šæ—¥',0),(70844,1968,'pt','Data prevista para o prÃ³ximo',0),(70845,1968,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ¹ Ð·Ð°Ð¿Ð»Ð°Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð¾Ð¹ Ð´Ð°Ñ‚Ñ‹',0),(70846,1968,'es','PrÃ³xima Fecha Programada',0),(70847,1968,'de','NÃ¤chster Termin',0),(70848,1968,'en','Next Scheduled Date',0),(70849,1969,'is','',0),(70850,1969,'dr','ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ø¨Ø¹Ø¯ÙŠ ',0),(70851,1969,'pr','ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ø¨Ø¹Ø¯ÙŠ ',0),(70852,1969,'tr','Sonraki ekran',0),(70853,1969,'pl','NastÄ™pny ekran',0),(70854,1969,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ ÐµÐºÑ€Ð°Ð½',0),(70855,1969,'ur','Ø§Ú¯Ù„ÛŒ Ø³Ú©Ø±ÛŒÙ†',0),(70856,1969,'sr','Ð¡Ñ™ÐµÐ´ÐµÑ›Ð¸ ÐµÐºÑ€Ð°Ð½',0),(70857,1969,'vi','MÃ n hÃ¬nh tiáº¿p theo',0),(70858,1969,'af','Volgende skerm',0),(70859,1969,'ro','UrmÄƒtorul ecran',0),(70860,1969,'et','JÃ¤rgmine kuva',0),(70861,1969,'si','Naslednji zaslon',0),(70862,1969,'ba','Layar berikutnya',0),(70863,1969,'nl','Volgende scherm',0),(70864,1969,'fi','Seuraavassa nÃ¤ytÃ¶ssÃ¤',0),(70865,1969,'no','Neste skjermbilde',0),(70866,1969,'da','NÃ¦ste skÃ¦rmbillede',0),(70867,1969,'ko','ë‹¤ìŒ í™”ë©´',0),(70868,1969,'he','×‘×ž×¡×š ×”×‘×',0),(70869,1969,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Î¿Î¸ÏŒÎ½Î·',0),(70870,1969,'zh','ä¸‹ä¸€ä¸ªç”»é¢\r\n',0),(70871,1969,'sv','NÃ¤sta skÃ¤rm',0),(70872,1969,'it','Nella schermata successiva',0),(70873,1969,'tl','',0),(70874,1969,'th','&#3627;&#3609;&#3657;&#3634;&#3592;&#3629;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(70875,1969,'hi','à¤…à¤—à¤²à¥‡ à¤¸à¥à¤•à¥à¤°à¥€à¤¨',0),(70876,1969,'ms','Skrin seterusnya',0),(70877,1969,'ar','Ø§Ù„Ø´Ø§Ø´Ø© Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(70878,1969,'fr','Ã‰cran suivant',0),(70879,1969,'jp','æ¬¡ã?®ç”»é?¢',0),(70880,1969,'pt','PrÃ³xima tela',0),(70881,1969,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ ÑÐºÑ€Ð°Ð½',0),(70882,1969,'es','PrÃ³xima pantalla',0),(70883,1969,'de','NÃ¤chsten Bildschirm',0),(70884,1969,'en','Next screen',0),(70885,1970,'is','',0),(70886,1970,'dr','9',0),(70887,1970,'pr',' Ù†Ù‡ 9',0),(70888,1970,'tr','dokuz',0),(70889,1970,'pl','dziewiÄ™Ä‡',0),(70890,1970,'bg','Ð´ÐµÐ²ÐµÑ‚',0),(70891,1970,'ur','Ù†Ùˆ',0),(70892,1970,'sr','Ð´ÐµÐ²ÐµÑ‚',0),(70893,1970,'vi','cá»§a tÃ´i',0),(70894,1970,'af','nege',0),(70895,1970,'ro','nouÄƒ',0),(70896,1970,'et','Ã¼heksa',0),(70897,1970,'si','devet',0),(70898,1970,'ba','sembilan',0),(70899,1970,'nl','negen',0),(70900,1970,'fi','yhdeksÃ¤n',0),(70901,1970,'no','ni',0),(70902,1970,'da','ni',0),(70903,1970,'ko','9',0),(70904,1970,'he','×ª×©×¢',0),(70905,1970,'el','ÎµÎ½Î½Î­Î±',0),(70906,1970,'zh','ä¹\r\n',0),(70907,1970,'sv','nio',0),(70908,1970,'it','nove',0),(70909,1970,'tl','',0),(70910,1970,'th','&#3648;&#3585;&#3657;&#3634;',0),(70911,1970,'hi','à¤¨à¥Œ',0),(70912,1970,'ms','Sembilan',0),(70913,1970,'ar','ØªØ³Ø¹Ø©',0),(70914,1970,'fr','neuf',0),(70915,1970,'jp','9',0),(70916,1970,'pt','nove',0),(70917,1970,'ru','Ð´ÐµÐ²ÑÑ‚ÑŒ',0),(70918,1970,'es','Nueve',0),(70919,1970,'de','neun',0),(70920,1970,'en','nine',0),(70921,1971,'is','',0),(70922,1971,'dr','Ù†ÙˆØ²Ø¯Ù‡',0),(70923,1971,'pr','Ù†ÙˆØ²Ø¯Ù‡',0),(70924,1971,'tr','On dokuz',0),(70925,1971,'pl','dziewiÄ™tnaÅ›cie',0),(70926,1971,'bg','Ð´ÐµÐ²ÐµÑ‚Ð½Ð°Ð´ÐµÑÐµÑ‚',0),(70927,1971,'ur','Ø§Ù†ÛŒØ³',0),(70928,1971,'sr','Ð”ÐµÐ²ÐµÑ‚Ð½Ð°ÐµÑÑ‚',0),(70929,1971,'vi','mÆ°á»i chÃ­n',0),(70930,1971,'af','neentien',0),(70931,1971,'ro','nouÄƒsprezece',0),(70932,1971,'et','Ã¼heksateist',0),(70933,1971,'si','devetnajst',0),(70934,1971,'ba','sembilan belas',0),(70935,1971,'nl','negentien',0),(70936,1971,'fi','yhdeksÃ¤ntoista',0),(70937,1971,'no','nitten',0),(70938,1971,'da','nitten',0),(70939,1971,'ko','19',0),(70940,1971,'he','×ª×©×¢ ×¢×©×¨×”',0),(70941,1971,'el','Î´ÎµÎºÎ±ÎµÎ½Î½Î­Î±',0),(70942,1971,'zh','åä¹\r\n',0),(70943,1971,'sv','nitton',0),(70944,1971,'it','diciannove',0),(70945,1971,'tl','',0),(70946,1971,'th','&#3626;&#3636;&#3610;&#3648;&#3585;&#3657;&#3634;',0),(70947,1971,'hi','à¤‰à¤¨à¥à¤¨à¥€à¤¸',0),(70948,1971,'ms','Sembilan belas',0),(70949,1971,'ar','ØªØ³Ø¹Ø© Ø¹Ø´Ø±',0),(70950,1971,'fr','dix-neuf',0),(70951,1971,'jp','19',0),(70952,1971,'pt','dezenove',0),(70953,1971,'ru','Ð”ÐµÐ²ÑÑ‚Ð½Ð°Ð´Ñ†Ð°Ñ‚ÑŒ',0),(70954,1971,'es','diecinueve',0),(70955,1971,'de','neunzehn',0),(70956,1971,'en','nineteen',0),(70957,1972,'is','',0),(70958,1972,'dr','Ù†ÙˆØ¯',0),(70959,1972,'pr','Ù†ÙˆØ¯',0),(70960,1972,'tr','doksan',0),(70961,1972,'pl','dziewiÄ™Ä‡dziesiÄ…t',0),(70962,1972,'bg','Ð´ÐµÐ²ÐµÑ‚Ð´ÐµÑÐµÑ‚',0),(70963,1972,'ur','Ù†ÙˆÛ’',0),(70964,1972,'sr','90',0),(70965,1972,'vi','chÃ­n mÆ°Æ¡i',0),(70966,1972,'af','negentig',0),(70967,1972,'ro','nouÄƒzeci',0),(70968,1972,'et','Ã¼heksakÃ¼mmend',0),(70969,1972,'si','devetdeset',0),(70970,1972,'ba','sembilan puluh',0),(70971,1972,'nl','negentig',0),(70972,1972,'fi','yhdeksÃ¤nkymmentÃ¤',0),(70973,1972,'no','nitti',0),(70974,1972,'da','halvfems',0),(70975,1972,'ko','90',0),(70976,1972,'he','×ª×©×¢×™×',0),(70977,1972,'el','ÎµÎ½ÎµÎ½Î®Î½Ï„Î±',0),(70978,1972,'zh','ä¹å\r\n',0),(70979,1972,'sv','nittio',0),(70980,1972,'it','novant\'anni',0),(70981,1972,'tl','',0),(70982,1972,'th','&#3648;&#3585;&#3657;&#3634;&#3626;&#3636;&#3610;',0),(70983,1972,'hi','à¤¨à¤¬à¥à¤¬à¥‡',0),(70984,1972,'ms','90',0),(70985,1972,'ar','ØªØ³Ø¹ÙˆÙ†',0),(70986,1972,'fr','quatre vingt dix',0),(70987,1972,'jp','90',0),(70988,1972,'pt','90.',0),(70989,1972,'ru','Ð´ÐµÐ²ÑÐ½Ð¾ÑÑ‚Ð¾',0),(70990,1972,'es','noventa',0),(70991,1972,'de','neunzig',0),(70992,1972,'en','ninety',0),(70993,1973,'is','',0),(70994,1973,'dr','Ø®ÙŠØ±',0),(70995,1973,'pr','Ø®ÙŠØ±',0),(70996,1973,'tr','HayÄ±r',0),(70997,1973,'pl','Nr',0),(70998,1973,'bg','ÐÐµ',0),(70999,1973,'ur','Ù†ÛÙŠÚº',0),(71000,1973,'sr','Ð½Ðµ',0),(71001,1973,'vi','KhÃ´ng',0),(71002,1973,'af','Nee',0),(71003,1973,'ro','nu',0),(71004,1973,'et','Ei',0),(71005,1973,'si','ne',0),(71006,1973,'ba','Tidak',0),(71007,1973,'nl','No',0),(71008,1973,'fi','Ei',0),(71009,1973,'no','nei',0),(71010,1973,'da','Nej',0),(71011,1973,'ko','ì—†ìŒ',0),(71012,1973,'he','×œ×',0),(71013,1973,'el','ÎŒÏ‡Î¹',0),(71014,1973,'zh','æ— \r\n',0),(71015,1973,'sv','Nej',0),(71016,1973,'it','No',0),(71017,1973,'tl','',0),(71018,1973,'th','&#3652;&#3617;&#3656;',0),(71019,1973,'hi','à¤¨à¤¹à¥€à¤‚',0),(71020,1973,'ms','tidak',0),(71021,1973,'ar','Ù„Ø§',0),(71022,1973,'fr','Non',0),(71023,1973,'jp','ãƒŽãƒ¼',0),(71024,1973,'pt','NÃ£o',0),(71025,1973,'ru','ÐÐµÑ‚',0),(71026,1973,'es','No',0),(71027,1973,'de','Nein',0),(71028,1973,'en','No',0),(71029,1974,'is','',0),(71030,1974,'dr','Ø´Ù…Ø§ Ø¨Ù‡ Ø§ÙŠÙ† ØµÙØ­Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø¯Ø§Ø±ÙŠØ¯ ',0),(71031,1974,'pr','Ø´Ù…Ø§ Ø¨Ù‡ Ø§ÙŠÙ† ØµÙØ­Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø¯Ø§Ø±ÙŠØ¯ ',0),(71032,1974,'tr','Bu sayfaya eriÅŸimi yok',0),(71033,1974,'pl','Nie masz dostÄ™pu do tej strony',0),(71034,1974,'bg','Ð’Ð¸Ðµ Ð½ÑÐ¼Ð°Ñ‚Ðµ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ñ‚Ð°Ð·Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(71035,1974,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§Ø³ ØµÙØ­Û’ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ø­Ø§ØµÙ„ Ù†ÛÛŒÚº',0),(71036,1974,'sr','ÐÐµÐ¼Ð°Ñ‚Ðµ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¾Ð²Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(71037,1974,'vi','Báº¡n khÃ´ng cÃ³ quyá»n truy cáº­p vÃ o trang nÃ y',0),(71038,1974,'af','U het nie toegang tot hierdie blad nie',0),(71039,1974,'ro','Nu aveÅ£i acces la aceastÄƒ paginÄƒ',0),(71040,1974,'et','Sul ei ole ligipÃ¤Ã¤su sellele lehele',0),(71041,1974,'si','Nimate dostopa do te strani',0),(71042,1974,'ba','Anda tidak memiliki akses ke Halaman ini',0),(71043,1974,'nl','U hebt geen toegang tot deze pagina',0),(71044,1974,'fi','Sinulla ei ole pÃ¤Ã¤syÃ¤ tÃ¤lle sivulle',0),(71045,1974,'no','Du har ikke tilgang til denne siden',0),(71046,1974,'da','Du har ikke adgang til denne side',0),(71047,1974,'ko','ì´ íŽ˜ì´ì§€ì— ëŒ€ í•œ ì•¡ì„¸ìŠ¤ë¥¼ í•˜ì§€ ì•Šì•„ë„',0),(71048,1974,'he','××™×Ÿ ×œ×š ×’×™×©×” ×œ×“×£ ×–×”',0),(71049,1974,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ»Î¯Î´Î±',0),(71050,1974,'zh','æ‚¨æ²¡æœ‰è®¿é—®æ­¤é¡µ\r\n',0),(71051,1974,'sv','Du har inte tillgÃ¥ng till denna sida',0),(71052,1974,'it','Non hai accesso a questa pagina',0),(71053,1974,'tl','',0),(71054,1974,'th','&#3588;&#3640;&#3603;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3627;&#3609;&#3657;&#3634;&#3609;&#3637;&#3657;',0),(71055,1974,'hi','à¤†à¤ª à¤‡à¤¸ à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤— à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(71056,1974,'ms','Anda tidak mempunyai akses kepada Laman ini',0),(71057,1974,'ar','Ù„ÙŠØ³ Ù„Ø¯ÙŠÙƒ Ø­Ù‚ Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ù‡Ø°Ù‡ Ø§Ù„ØµÙØ­Ø©',0),(71058,1974,'fr','Vous n\'avez pas accÃ¨s Ã  cette page',0),(71059,1974,'jp','ã?“ã?®ãƒšãƒ¼ã‚¸ã?¸ã?®ã‚¢ã‚¯ã‚»ã‚¹æ¨©ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(71060,1974,'pt','VocÃª nÃ£o tem acesso a esta pÃ¡gina',0),(71061,1974,'ru','Ð£ Ð²Ð°Ñ Ð½ÐµÑ‚ Ð´Ð¾Ð¿ÑƒÑÐºÐ° Ðº Ð´Ð°Ð½Ð½Ð¾Ð¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(71062,1974,'es','No tiene que accesar a esta pÃ¡gina',0),(71063,1974,'de','Sie haben nicht Zugang zu dieser Seite',0),(71064,1974,'en','You do not have access to this page',0),(71065,1975,'is','',0),(71066,1975,'dr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡',0),(71067,1975,'pr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡',0),(71068,1975,'tr','SeÃ§ili hesap yok',0),(71069,1975,'pl','Nie konta wybranego',0),(71070,1975,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(71071,1975,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(71072,1975,'sr','Ð‘ÐµÐ· Ð½Ð°Ð»Ð¾Ð³Ð° ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½',0),(71073,1975,'vi','ChÆ°a Chá»n TK',0),(71074,1975,'af','Geen Rekening Geselekteer',0),(71075,1975,'ro','Nu cont selectate',0),(71076,1975,'et','Valitud konto',0),(71077,1975,'si','Ne upoÅ¡teva, izbrana',0),(71078,1975,'ba','Tidak ada Account yang dipilih',0),(71079,1975,'nl','Geen Account geselecteerd',0),(71080,1975,'fi','Valitulle tilille',0),(71081,1975,'no','Ingen konto valgt',0),(71082,1975,'da','Ingen konto, valgt',0),(71083,1975,'ko','ê³„ì • ì„ íƒ',0),(71084,1975,'he','××™×Ÿ ×œ×š ×—×©×‘×•×Ÿ ×©× ×‘×—×¨×•',0),(71085,1975,'el','ÎšÎ±Î¼Î¹Î¬ Ï€ÎµÏÎ¯Ï€Ï„Ï‰ÏƒÎ· ÎµÏ€Î¹Î»Î­Î¾ÎµÎ¹',0),(71086,1975,'zh','æ²¡æœ‰å·²é€‰çš„å¸æˆ·\r\n',0),(71087,1975,'sv','Inget konto som valts',0),(71088,1975,'it','Nessun conto selezionato',0),(71089,1975,'tl','',0),(71090,1975,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(71091,1975,'hi','à¤•à¥‹à¤ˆ à¤šà¤¯à¤¨à¤¿à¤¤ à¤–à¤¾à¤¤à¤¾',0),(71092,1975,'ms','Tiada akaun yang dipilih',0),(71093,1975,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(71094,1975,'fr','Aucun compte sÃ©lectionnÃ©',0),(71095,1975,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?Œé?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(71096,1975,'pt','Nenhuma conta selecionada',0),(71097,1975,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð°',0),(71098,1975,'es','No Hay Cuenta Asignada',0),(71099,1975,'de','Kein Konto ausgewÃ¤hlt',0),(71100,1975,'en','No Account Selected',0),(71101,1976,'is','',0),(71102,1976,'dr','Ù‡ÙŠÚ† ØªØºÙŠÙŠØ± Ø§Ø¶Ø§ÙÙŠ ',0),(71103,1976,'pr','Ù‡ÙŠÚ† ØªØºÙŠÙŠØ± Ø§Ø¶Ø§ÙÙŠ ',0),(71104,1976,'tr','HiÃ§bir Ã¼cret Addl.',0),(71105,1976,'pl','Bez opÅ‚at Addl.',0),(71106,1976,'bg','Addl. Ñ‚Ð°ÐºÑÐ°',0),(71107,1976,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø¯Ø¯Ù„. Ú†Ø§Ø±Ø¬',0),(71108,1976,'sr','Ð‘ÐµÐ· Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ ÐÐ´Ð´Ð».',0),(71109,1976,'vi','KhÃ´ng thÃªm chi phÃ­',0),(71110,1976,'af','Addl. kostelose',0),(71111,1976,'ro','Nici o taxÄƒ Addl.',0),(71112,1976,'et','Tasuta Addl.',0),(71113,1976,'si','BrezplaÄno pokvariti se.',0),(71114,1976,'ba','Cuma Addl.',0),(71115,1976,'nl','Zonder kosten Addl.',0),(71116,1976,'fi','Veloituksetta Addl.',0),(71117,1976,'no','Gratis Addl.',0),(71118,1976,'da','Gratis Addl.',0),(71119,1976,'ko','ë¬´ë£Œë¡œ Addlìž…ë‹ˆë‹¤.',0),(71120,1976,'he','×œ×œ× ×ª×©×œ×•× Addl.',0),(71121,1976,'el','Î§Ï‰ÏÎ¯Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ· Addl.',0),(71122,1976,'zh','æ²¡æœ‰é¢å¤–æ”¶è´¹\r\n',0),(71123,1976,'sv','Kostnadsfritt Addl.',0),(71124,1976,'it','Nessuna carica Addl.',0),(71125,1976,'tl','',0),(71126,1976,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(71127,1976,'hi','à¤•à¥‹à¤ˆ à¤…à¤ªà¤° à¤ªà¥à¤°à¤­à¤¾à¤°à¥€',0),(71128,1976,'ms','Bayaran Addl.',0),(71129,1976,'ar','Ø¯ÙˆÙ† Ø£ÙŠ Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ©.',0),(71130,1976,'fr','Aucune Charge Addl.',0),(71131,1976,'jp','è¿½åŠ æ–™é‡‘ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(71132,1976,'pt','Nenhuma carga Addl.',0),(71133,1976,'ru','Ð‘ÐµÐ· Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð”Ð¾Ð¿.',0),(71134,1976,'es','No Hay Carga Adicional',0),(71135,1976,'de','Kostenlos Addl.',0),(71136,1976,'en','No Addl. Charge',0),(71137,1977,'is','',0),(71138,1977,'dr','Ù‡ÙŠÚ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‚Ø¯ÙŠÙ…ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71139,1977,'pr','Ù‡ÙŠÚ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‚Ø¯ÙŠÙ…ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71140,1977,'tr','YaÅŸlanma banknot bulundu.',0),(71141,1977,'pl','Nie znaleziono rachunki starzenia siÄ™.',0),(71142,1977,'bg','ÐÐµ ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸.',0),(71143,1977,'ur','Ú©ÙˆØ¦ÛŒ Ø®Ø³ØªÛ Ø¨Ù„ Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ Û”',0),(71144,1977,'sr','ÐÐµÐ¼Ð° ÑÑ‚Ð°Ñ€ÐµÑšÐ° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð½Ð°ÑˆÐ°Ð¾.',0),(71145,1977,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ³a Ä‘Æ¡n cÃ³ tuá»“i ná»£',0),(71146,1977,'af','Geen verouderde rekeninge gevind.',0),(71147,1977,'ro','Nici facturile de imbatranire gÄƒsite.',0),(71148,1977,'et','No vananemist arveid leida.',0),(71149,1977,'si','No staranja menice naÅ¡el.',0),(71150,1977,'ba','Tagihan penuaan tidak ditemukan.',0),(71151,1977,'nl','Geen veroudering rekeningen gevonden.',0),(71152,1977,'fi','Ei ikÃ¤Ã¤ntymisen laskuja lÃ¶ytyi.',0),(71153,1977,'no','Ingen aldring regninger funnet.',0),(71154,1977,'da','Ingen aldring regninger fundet.',0),(71155,1977,'ko','ì•„ë‹ˆ ë…¸í™” ì§€í ë°œê²¬ìž…ë‹ˆë‹¤.',0),(71156,1977,'he','×‘×œ×™ ×—×©×‘×•× ×•×ª ×”×–×“×§× ×•×ª × ×ž×¦××•.',0),(71157,1977,'el','Î”ÎµÎ½ Î³Î®ÏÎ±Î½ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(71158,1977,'zh','æœªå‘çŽ°è¿‡æœŸå¸å•ã€‚\r\n',0),(71159,1977,'sv','Inga Ã¥ldrande rÃ¤kningar hittade.',0),(71160,1977,'it','No bollette di invecchiamento trovate.',0),(71161,1977,'tl','',0),(71162,1977,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(71163,1977,'hi','à¤•à¥‹à¤ˆ à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ à¤¬à¤¿à¤² à¤ªà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾à¥¤',0),(71164,1977,'ms','Tiada bil penuaan yang ditemui.',0),(71165,1977,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© ÙˆØ¬Ø¯Øª.',0),(71166,1977,'fr','Aucun projet de loi de vieillissement trouvÃ©.',0),(71167,1977,'jp','ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°è«‹æ±‚æ›¸ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(71168,1977,'pt','Sem notas de envelhecimento encontradas.',0),(71169,1977,'ru','ÐÐµ ÑÑ‚Ð°Ñ€ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð° Ð½Ð°ÑˆÐ»Ð¸.',0),(71170,1977,'es','No se encontrÃ³ recibos envejeciendo',0),(71171,1977,'de','Keine Alterung-Rechnungen gefunden.',0),(71172,1977,'en','No aging bills found.',0),(71173,1978,'is','',0),(71174,1978,'dr','Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ± Ù‚Ø¯ÙŠÙ…ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(71175,1978,'pr','Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ± Ù‚Ø¯ÙŠÙ…ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(71176,1978,'tr','YaÅŸlanma faturalar buldum.',0),(71177,1978,'pl','Nie znaleziono faktury starzenia siÄ™.',0),(71178,1978,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ.',0),(71179,1978,'ur','Ú©ÙˆØ¦ÛŒ Ø®Ø³ØªÛ ÙˆØ¨Ø¬Ù„ÛŒ Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(71180,1978,'sr','ÐÐµÐ¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÑÑ‚Ð°Ñ€ÐµÑšÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(71181,1978,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ³a Ä‘Æ¡n cÃ³ tuá»“i ná»£',0),(71182,1978,'af','Geen verouderde fakture gevind.',0),(71183,1978,'ro','Nici facturile de imbatranire gÄƒsite.',0),(71184,1978,'et','Ega Vananemine arveid leida.',0),(71185,1978,'si','No staranja raÄunov naÅ¡el.',0),(71186,1978,'ba','Faktur penuaan tidak ditemukan.',0),(71187,1978,'nl','Geen veroudering facturen gevonden.',0),(71188,1978,'fi','IkÃ¤Ã¤ntyminen laskuja ei lÃ¶ydy.',0),(71189,1978,'no','Ingen aldring fakturaer funnet.',0),(71190,1978,'da','Ingen aldring fakturaer fundet.',0),(71191,1978,'ko','ì•„ë‹ˆ ë…¸í™” ì†¡ìž¥ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(71192,1978,'he','×œ× × ×ž×¦××• ×—×©×‘×•× ×™×•×ª ×”×–×“×§× ×•×ª.',0),(71193,1978,'el','Î”ÎµÎ½ Î³Î®ÏÎ±Î½ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(71194,1978,'zh','æœªæ‰¾åˆ°è¿‡æœŸå‘ç¥¨ã€‚\r\n',0),(71195,1978,'sv','Inga Ã¥ldrande fakturor hittade.',0),(71196,1978,'it','Nessun fatture di invecchiamento trovate.',0),(71197,1978,'tl','',0),(71198,1978,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(71199,1978,'hi','à¤•à¥‹à¤ˆ à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(71200,1978,'ms','Tiada invois penuaan yang ditemui.',0),(71201,1978,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© ÙˆØ¬Ø¯Øª.',0),(71202,1978,'fr','Aucune facture de vieillissement trouvÃ©.',0),(71203,1978,'jp','ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°è«‹æ±‚æ›¸ã?Œã?¿ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(71204,1978,'pt','NÃ£o hÃ¡ facturas de envelhecimento encontradas.',0),(71205,1978,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÑÑ‚Ð°Ñ€ÐµÐ½Ð¸Ñ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.',0),(71206,1978,'es','No se encontrÃ³ facturas envejeciendo',0),(71207,1978,'de','Keine Alterung-Rechnungen gefunden.',0),(71208,1978,'en','No aging invoices found.',0),(71209,1979,'is','',0),(71210,1979,'dr','Ù‡ÙŠÚ† Ù†Ø¸Ø± Ù…ÙˆÙ„ÙÙŠ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(71211,1979,'pr','Ù‡ÙŠÚ† Ù†Ø¸Ø± Ù…ÙˆÙ„ÙÙŠ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(71212,1979,'tr','Yazar yorum yok',0),(71213,1979,'pl','Brak komentarzy autor dostÄ™pne',0),(71214,1979,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸ Ð°Ð²Ñ‚Ð¾Ñ€ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸',0),(71215,1979,'ur','Ú©ÙˆØ¦ÛŒ Ù…ØµÙ†Ù ØªØ¨ØµØ±Û Ø¯Ø³ØªÛŒØ§Ø¨',0),(71216,1979,'sr','ÐÐµÐ¼Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸Ñ… Ð°ÑƒÑ‚Ð¾Ñ€ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð°',0),(71217,1979,'vi','KhÃ´ng cÃ³ nháº­n xÃ©t cá»§a tÃ¡c giáº£',0),(71218,1979,'af','Geen outeurkommentaar beskikbaar',0),(71219,1979,'ro','Nici un comentariu autor disponibile',0),(71220,1979,'et','Autori kommentaarid saadaval',0),(71221,1979,'si','Ni avtor pripombe, ki so na voljo',0),(71222,1979,'ba','Tidak ada komentar penulis yang tersedia',0),(71223,1979,'nl','Geen auteur commentaar beschikbaar',0),(71224,1979,'fi','TekijÃ¤n kommentit on suljettu',0),(71225,1979,'no','Ingen Forfatter kommentarer tilgjengelig',0),(71226,1979,'da','Ingen forfatter kommentarer tilgÃ¦ngelige',0),(71227,1979,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” ì €ìž ì½”ë©˜íŠ¸ ì—†ìŒ',0),(71228,1979,'he','××™×Ÿ ×ª×’×•×‘×•×ª ×¡×•×¤×¨ ×–×ž×™×Ÿ',0),(71229,1979,'el','Î”ÎµÎ½ ÏƒÏ…Î³Î³ÏÎ±Ï†Î­Î±Ï‚ ÏƒÏ‡ÏŒÎ»Î¹Î± Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î±',0),(71230,1979,'zh','æ²¡æœ‰ä½œè€…æä¾›æ„è§\r\n',0),(71231,1979,'sv','Ingen fÃ¶rfattare kommentarer tillgÃ¤ngliga',0),(71232,1979,'it','Nessun autore commenti disponibili',0),(71233,1979,'tl','',0),(71234,1979,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3612;&#3641;&#3657;&#3648;&#3586;&#3637;&#3618;&#3609;&#3649;&#3626;&#3604;&#3591;&#3588;&#3623;&#3634;&#3617;&#3588;&#3636;&#3604;&#3648;&#3627;&#3655;&#3609;&#3607;&#3637;&#3656;&#3627;&#3634;&#3652;&#3604;&#3657;',0),(71235,1979,'hi','à¤•à¥‹à¤ˆ à¤²à¥‡à¤–à¤• à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¤¿à¤¯à¤¾à¤',0),(71236,1979,'ms','Tiada komen penulis yang disediakan',0),(71237,1979,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ ØªØ¹Ù„ÙŠÙ‚Ø§Øª ØµØ§Ø­Ø¨ Ø§Ù„Ø¨Ù„Ø§Øº Ù…ØªØ§Ø­Ø©',0),(71238,1979,'fr','Aucun commentaire de l\'auteur disponibles',0),(71239,1979,'jp','è‘—è€…ã?®ã‚³ãƒ¡ãƒ³ãƒˆã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(71240,1979,'pt','Sem comentarios do autor disponÃ­veis',0),(71241,1979,'ru','ÐÐµÑ‚ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ñ… ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸ÐµÐ² Ð°Ð²Ñ‚Ð¾Ñ€Ð°',0),(71242,1979,'es','no comentarios de autor disponibles',0),(71243,1979,'de','Kein Autor Kommentare vorhanden',0),(71244,1979,'en','No author comments available',0),(71245,1980,'is','',0),(71246,1980,'dr','Ù‡ÙŠÚ† Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø®ÙˆØ¯ÙƒØ§Ø±ÙŠ Ù†ÙŠØ³Øª ',0),(71247,1980,'pr','Ù‡ÙŠÚ† Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø®ÙˆØ¯ÙƒØ§Ø±ÙŠ Ù†ÙŠØ³Øª ',0),(71248,1980,'tr','HiÃ§bir otomatik fiyatlandÄ±rma',0),(71249,1980,'pl','Nie automatyczne ustalanie cen',0),(71250,1980,'bg','ÐÑÐ¼Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(71251,1980,'ur','Ú©ÙˆØ¦ÛŒ Ø®ÙˆØ¯Ú©Ø§Ø± Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(71252,1980,'sr','ÐÐµÐ¼Ð° Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾Ð³ Ð¾Ð´Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐ° Ñ†ÐµÐ½Ð°',0),(71253,1980,'vi','KhÃ´ng cÃ³ giÃ¡ tá»± Ä‘á»™ng',0),(71254,1980,'af','Geen outomatiese pryse',0),(71255,1980,'ro','Nu automatÄƒ de stabilire a preÅ£urilor',0),(71256,1980,'et','Automaatne hinnakujundus',0),(71257,1980,'si','Ne avtomatsko cenitev',0),(71258,1980,'ba','Harga tidak otomatis',0),(71259,1980,'nl','Geen automatische tarifering',0),(71260,1980,'fi','Ei automaattinen hinnoittelu',0),(71261,1980,'no','Ingen automatisk priser',0),(71262,1980,'da','Ingen automatisk prissÃ¦tning',0),(71263,1980,'ko','ìžë™ ê°€ê²© ì±…ì •',0),(71264,1980,'he','××™×Ÿ ×ª×ž×—×•×¨ ××•×˜×•×ž×˜×™',0),(71265,1980,'el','ÎšÎ±Î¼Î¯Î± Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(71266,1980,'zh','æ²¡æœ‰è‡ªåŠ¨å®šä»·\r\n',0),(71267,1980,'sv','Ingen automatisk prissÃ¤ttning',0),(71268,1980,'it','Nessuna tariffazione automatica',0),(71269,1980,'tl','',0),(71270,1980,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3588;&#3634;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;',0),(71271,1980,'hi','à¤•à¥‹à¤ˆ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(71272,1980,'ms','Harga automatik tidak',0),(71273,1980,'ar','Ù„Ø§ Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(71274,1980,'fr','Aucune tarification automatique',0),(71275,1980,'jp','è‡ªå‹•å€¤ä»˜ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(71276,1980,'pt','NÃ£o automÃ¡tico de preÃ§os',0),(71277,1980,'ru','ÐÐµÑ‚ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ð³Ð¾ Ñ†ÐµÐ½',0),(71278,1980,'es','No Hay CÃ¡lculos de Precios Automaticos',0),(71279,1980,'de','Keine automatische Preiskalkulation',0),(71280,1980,'en','No Automatic Pricing',0),(71281,1981,'is','',0),(71282,1981,'dr','Ù‡ÙŠÚ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71283,1981,'pr','Ù‡ÙŠÚ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71284,1981,'tr','HiÃ§bir bÃ¼tÃ§eleri seÃ§ili mali yÄ±l iÃ§in bulundu.',0),(71285,1981,'pl','Nie znaleziono budÅ¼etÃ³w dla wskazanego roku fiskalnego.',0),(71286,1981,'bg','ÐÑÐ¼Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸ Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð°Ñ‚Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°.',0),(71287,1981,'ur','Ù…Ù†ØªØ®Ø¨ Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(71288,1981,'sr','ÐÐµÐ¼Ð° Ð±ÑƒÑŸÐµÑ‚Ðµ Ð·Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ñƒ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ñƒ Ð³Ð¾Ð´Ð¸Ð½Ñƒ.',0),(71289,1981,'vi','KhÃ´ng tÃ¬m tháº¥y ngÃ¢n sÃ¡ch cho nÄƒm tÃ i chÃ­nh Ä‘Ã£ chá»n',0),(71290,1981,'af','Geen Begrotings gevind vir die verkose fisiese jaar.',0),(71291,1981,'ro','Nu bugetele pentru anul fiscal selectate.',0),(71292,1981,'et','Eelarved ei leitud valitud rahandusaasta.',0),(71293,1981,'si','Ni proraÄuni za izbrano proraÄunsko leto.',0),(71294,1981,'ba','Anggaran tidak ditemukan untuk tahun fiskal yang dipilih.',0),(71295,1981,'nl','Geen begrotingen gevonden voor het geselecteerde boekjaar.',0),(71296,1981,'fi','Budjetteja ei ole lÃ¶ytynyt valitulle tilikaudelle.',0),(71297,1981,'no','Ingen budsjetter funnet for det valgte regnskapsÃ¥ret.',0),(71298,1981,'da','Ingen budgetter ikke fundet for det valgte regnskabsÃ¥r.',0),(71299,1981,'ko','ì•„ë‹ˆ ì˜ˆì‚°ì„ ì„ íƒ ëœ íšŒê³„ ì—°ë„ ëŒ€ í•œ ë°œê²¬.',0),(71300,1981,'he','×ª×§×¦×™×‘×™× ×œ× × ×ž×¦× ×¢×‘×•×¨ ×©× ×ª ×”×›×¡×¤×™× ×©× ×‘×—×¨×”.',0),(71301,1981,'el','Î”ÎµÎ½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î³Î¹Î± Ï„Î¿ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎŸÎ™ÎšÎŸÎÎŸÎœ.',0),(71302,1981,'zh','æœªæ‰¾åˆ°å·²é€‰è´¢å¹´çš„é¢„ç®—ã€‚\r\n',0),(71303,1981,'sv','Inga budgetar fÃ¶r valt rÃ¤kenskapsÃ¥r.',0),(71304,1981,'it','Nessun budget trovato per l\'anno fiscale selezionato.',0),(71305,1981,'tl','',0),(71306,1981,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3637;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3',0),(71307,1981,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤µà¤¿à¤¤à¥à¤¤ à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤¬à¤œà¤Ÿ à¤®à¤¿à¤² à¤—à¤¯à¤¾à¥¤',0),(71308,1981,'ms','Belanjawan tidak ditemui untuk tahun fiskal yang terpilih.',0),(71309,1981,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ù„Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø§Ù„Ù…Ø®ØªØ§Ø±Ø©',0),(71310,1981,'fr','Pas trouvÃ©s pour l\'exercice sÃ©lectionnÃ© les Budgets.',0),(71311,1981,'jp','é?¸æŠžã?•ã‚Œã?Ÿä¼šè¨ˆå¹´åº¦ã?®äºˆç®—ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(71312,1981,'pt','NÃ£o hÃ¡ orÃ§amentos encontraram para o ano fiscal selecionado.',0),(71313,1981,'ru','ÐÐµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ñ‹ Ð½Ð°ÑˆÐ»Ð¸ Ð´Ð»Ñ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð¾Ð³Ð¾ Ð³Ð¾Ð´Ð°.',0),(71314,1981,'es','No se encontrÃ³ presupuestos para el ejercicio seleccionado',0),(71315,1981,'de','Kein Budget fÃ¼r das ausgewÃ¤hlte GeschÃ¤ftsjahr gefunden.',0),(71316,1981,'en','No Budgets found for the selected fiscal year.',0),(71317,1982,'is','',0),(71318,1982,'dr','Ù‡ÙŠÚ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ ØªÙ†Ø¸ÙŠÙ…  Ø´Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71319,1982,'pr','Ù‡ÙŠÚ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ ØªÙ†Ø¸ÙŠÙ…  Ø´Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71320,1982,'tr','HiÃ§bir bÃ¼tÃ§eleri, seÃ§ili mali yÄ±l iÃ§in ayarlayÄ±n.',0),(71321,1982,'pl','Nie ma ustawionych budÅ¼etÃ³w dla wskazanego roku fiskalnego.',0),(71322,1982,'bg','ÐÑÐ¼Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸ Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð°Ñ‚Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°.',0),(71323,1982,'ur','Ú©ÙˆØ¦ÛŒ ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) Ù…Ù†ØªØ®Ø¨ Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ ÛÛ’ Û”',0),(71324,1982,'sr','ÐÐµÐ¼Ð° Ð±ÑƒÑŸÐµÑ‚Ðµ Ð·Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ñƒ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ñƒ Ð³Ð¾Ð´Ð¸Ð½Ñƒ.',0),(71325,1982,'vi','NgÃ¢n sÃ¡ch khÃ´ng láº­p cho nÄƒm tÃ i chÃ­nh Ä‘Ã£ chá»n',0),(71326,1982,'af','Geen Begrotingsstel gevind vir die verkose fisiese jaar.',0),(71327,1982,'ro','Nu bugetele pentru anul fiscal selectate.',0),(71328,1982,'et','MÃ¤Ã¤ra valitud rahandusaasta eelarved.',0),(71329,1982,'si','Ni proraÄuni za izbrano proraÄunsko leto.',0),(71330,1982,'ba','Tidak ada anggaran yang ditetapkan untuk tahun fiskal yang dipilih.',0),(71331,1982,'nl','Geen budgetten instellen voor het geselecteerde boekjaar.',0),(71332,1982,'fi','Budjetteja ei ole mÃ¤Ã¤ritetty valitulle tilikaudelle.',0),(71333,1982,'no','Ingen budsjetter satt for det valgte regnskapsÃ¥ret.',0),(71334,1982,'da','Ingen budgetter, der er angivet for det valgte regnskabsÃ¥r.',0),(71335,1982,'ko','ì•„ë‹ˆ ì˜ˆì‚°ì„ ì„ íƒ ëœ íšŒê³„ ì—°ë„ ëŒ€ í•œ ì„¤ì •.',0),(71336,1982,'he','××™×Ÿ ×ª×§×¦×™×‘×™× ×œ×”×’×“×™×¨ ×¢×‘×•×¨ ×©× ×ª ×”×›×¡×¤×™× ×©× ×‘×—×¨×”.',0),(71337,1982,'el','Î”ÎµÎ½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Î¸Î± ÎºÎ±Î¸Î¿ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹ Î³Î¹Î± Ï„Î¿ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎŸÎ™ÎšÎŸÎÎŸÎœ.',0),(71338,1982,'zh','æœªè®¾ç½®å·²é€‰è´¢å¹´çš„é¢„ç®—ã€‚\r\n',0),(71339,1982,'sv','Inga budgetar fÃ¶r valt rÃ¤kenskapsÃ¥r.',0),(71340,1982,'it','Nessun budget impostato per l\'anno fiscale selezionato.',0),(71341,1982,'tl','',0),(71342,1982,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3637;&#3591;&#3610;&#3611;&#3619;&#3632;&#3',0),(71343,1982,'hi','à¤•à¥‹à¤ˆ à¤¬à¤œà¤Ÿ à¤šà¤¯à¤¨à¤¿à¤¤ à¤µà¤¿à¤¤à¥à¤¤ à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚à¥¤',0),(71344,1982,'ms','Bajet tidak ditetapkan untuk tahun fiskal yang terpilih.',0),(71345,1982,'ar','Ù„Ù… ØªØ¸Ø¨Ø· Ø£ÙŠ Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ù„Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø§Ù„Ù…Ø®ØªØ§Ø±Ø©',0),(71346,1982,'fr','Aucun budget pour l\'exercice sÃ©lectionnÃ©.',0),(71347,1982,'jp','é?¸æŠžã?•ã‚Œã?Ÿå–¶æ¥­å¹´ã?®äºˆç®—ã?Œè¨­å®šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(71348,1982,'pt','Sem orÃ§amento definido para o ano fiscal selecionado.',0),(71349,1982,'ru','ÐÐµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ñ‹ Ð´Ð»Ñ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð¾Ð³Ð¾ Ð³Ð¾Ð´Ð°.',0),(71350,1982,'es','No hay presupuestos configurados para el ejercicio fiscal seleccionado',0),(71351,1982,'de','Kein Budget fÃ¼r das ausgewÃ¤hlte GeschÃ¤ftsjahr festgelegt.',0),(71352,1982,'en','No budgets set for the selected fiscal year.',0),(71353,1983,'is','',0),(71354,1983,'dr','Ù‡ÙŠÚ† Ø³Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§ÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71355,1983,'pr','Ù‡ÙŠÚ† Ø³Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§ÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71356,1983,'tr','Hesaplanan hiÃ§ Ã¶denmemiÅŸ saat bulundu.',0),(71357,1983,'pl','Nie obliczone niezapÅ‚acone godziny znalezione.',0),(71358,1983,'bg','ÐÐµ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ‚Ðµ Ð½ÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ñ‡Ð°ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(71359,1983,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø­Ø³ÙˆØ¨ Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û Ú¯Ú¾Ù†Ù¹Û’ Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(71360,1983,'sr','ÐÐµÐ¼Ð° Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚Ðµ Ð½ÐµÐ¿Ð»Ð°Ñ›ÐµÐ½Ð¸Ñ… ÑÐ°Ñ‚Ð¸ Ð½Ð°ÑˆÐ°Ð¾.',0),(71361,1983,'vi','KhÃ´ng tÃ¬m tháº¥y tÃ­nh toÃ¡n giá» chÆ°a tráº£',0),(71362,1983,'af','Geen berekende onbetaalde ure gevind.',0),(71363,1983,'ro','GÄƒsit nici o orÄƒ calculat neplÄƒtite.',0),(71364,1983,'et','Ei arvutatud enne tundi leidsin.',0),(71365,1983,'si','Ni izraÄunana neplaÄanih ur naÅ¡el.',0),(71366,1983,'ba','Menemukan jam tidak dibayar tidak dihitung.',0),(71367,1983,'nl','Geen berekende onbetaalde uur gevonden.',0),(71368,1983,'fi','Ei ole laskettu palkaton tuntia perustaa.',0),(71369,1983,'no','Ingen beregnet ubetalte timer fant.',0),(71370,1983,'da','Ingen beregnede ubetalte timer fundet.',0),(71371,1983,'ko','ì—†ëŠ” ê³„ì‚° ëœ ë¬´ ë³´ìˆ˜ ì‹œê°„ì„ ë°œê²¬.',0),(71372,1983,'he','××™×Ÿ ×©×¢×•×ª ×œ×œ× ×©×›×¨ ×”×ž×—×•×©×‘ × ×ž×¦×.',0),(71373,1983,'el','Î”ÎµÎ½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Ï‡ÏÏŒÎ½Î¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î¬Î½ÎµÏ… Î±Ï€Î¿Î´Î¿Ï‡ÏŽÎ½ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(71374,1983,'zh','æ²¡æœ‰æ‰¾åˆ°è®¡ç®—æœªä»˜å°æ—¶æ•°ã€‚\r\n',0),(71375,1983,'sv','Inga berÃ¤knade obetalda timmar hittade.',0),(71376,1983,'it','Non trovano nessun calcolati ore non pagate.',0),(71377,1983,'tl','',0),(71378,1983,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3619;&#3634;&#3618;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3',0),(71379,1983,'hi','à¤•à¥‹à¤ˆ à¤ªà¤°à¤¿à¤•à¤²à¤¿à¤¤ à¤…à¤µà¥ˆà¤¤à¤¨à¤¿à¤• à¤˜à¤‚à¤Ÿà¥‡ à¤®à¤¿à¤² à¤—à¤¯à¤¾à¥¤',0),(71380,1983,'ms','Ditemui jam tanpa bayaran tidak dikira.',0),(71381,1983,'ar','Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø£ÙŠ Ø³Ø§Ø¹Ø© ØºÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© Ù…Ø­Ø³ÙˆØ¨.',0),(71382,1983,'fr','Aucuns heures non rÃ©munÃ©rÃ©es calculÃ©s ne trouvent.',0),(71383,1983,'jp','è¨ˆç®—æ¸ˆã?®ç„¡å ±é…¬å‹¤å‹™æ™‚é–“ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(71384,1983,'pt','Sem horas nÃ£o remuneradas calculadas encontraram.',0),(71385,1983,'ru','ÐÐµ Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ð½Ð½Ñ‹Ðµ Ð½ÐµÐ¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ñ‡Ð°ÑÐ¾Ð² Ð½Ð°ÑˆÐµÐ».',0),(71386,1983,'es','No se encontrÃ³ horas no pagadas calculadas',0),(71387,1983,'de','Keine berechneten unbezahlten Stunden gefunden.',0),(71388,1983,'en','No calculated unpaid hours found.',0),(71389,1984,'is','',0),(71390,1984,'dr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§Øª Ø´Ù‡Ø±ÙŠ ØªØ¹Ø±ÙŠÙ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(71391,1984,'pr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§Øª Ø´Ù‡Ø±ÙŠ ØªØ¹Ø±ÙŠÙ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(71392,1984,'tr','TanÄ±mlanan Åžehir vergi yok.',0),(71393,1984,'pl','Nie ma miasta podatkÃ³w okreÅ›lonych.',0),(71394,1984,'bg','ÐÐµ Ð³Ñ€Ð°Ð´ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ€Ð°Ð½Ð¸.',0),(71395,1984,'ur','Ø´ÛØ± Ú©Û’ Ù¹ÛŒÚ©Ø³ Ú©ÙˆØ¦ÛŒ Ù…ØªØ¹ÛŒÙ† Ú©ÛŒØ§ ÛÛ’ Û”',0),(71396,1984,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð³Ñ€Ð°Ð´ Ð½Ð¸Ñ˜Ðµ Ð´ÐµÑ„Ð¸Ð½Ð¸ÑÐ°Ð½.',0),(71397,1984,'vi','ChÆ°a dá»‹nh nghÄ©a thuáº¿ thÃ nh phá»‘',0),(71398,1984,'af','Geen Dorp/Stad belastings gedefinieer.',0),(71399,1984,'ro','Nu taxele de oraÅŸ definite.',0),(71400,1984,'et','Linn makse mÃ¤Ã¤ratletud.',0),(71401,1984,'si','Ne mesto davki opredeljena.',0),(71402,1984,'ba','Tidak ada pajak kota didefinisikan.',0),(71403,1984,'nl','Geen stad belastingen gedefinieerd.',0),(71404,1984,'fi','Kaupungin veroja mÃ¤Ã¤ritetty.',0),(71405,1984,'no','Ingen by skatt definert.',0),(71406,1984,'da','Ingen by skatter defineret.',0),(71407,1984,'ko','ì •ì˜ ì•„ë‹ˆ ì‹œ ì„¸ê¸ˆìž…ë‹ˆë‹¤.',0),(71408,1984,'he','. ××™×Ÿ ×ž×™×¡×™× ×”×¢×™×¨ ×ž×•×’×“×¨×ª.',0),(71409,1984,'el','Î”ÎµÎ½ Ï€ÏŒÎ»Î· Ï†ÏŒÏÎ¿Î¹ Ï€Î¿Ï… Î¿ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹.',0),(71410,1984,'zh','æ²¡æœ‰å·²å®šä¹‰çš„åŸŽå¸‚ç¨Žã€‚\r\n',0),(71411,1984,'sv','Ingen city skatt definieras.',0),(71412,1984,'it','Nessun tasse cittÃ  definite.',0),(71413,1984,'tl','',0),(71414,1984,'th','&#3652;&#3617;&#3656;&#3585;&#3635;&#3627;&#3609;&#3604;&#3616;&#3634;&#3625;&#3637;&#3648;&#3617;&#3639;&#3629;&#3591; ',0),(71415,1984,'hi','à¤•à¥‹à¤ˆ à¤¶à¤¹à¤° à¤•à¤°à¥‹à¤‚ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾à¥¤',0),(71416,1984,'ms','Tidak ada cukai bandar yang ditakrifkan.',0),(71417,1984,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø¶Ø±Ø§Ø¦Ø¨ Ù…Ø¯ÙŠÙ†Ø© Ø§Ù„Ù…Ø¹Ø±ÙØ©.',0),(71418,1984,'fr','Aucune taxe dÃ©finie.',0),(71419,1984,'jp','å¸‚ç¨Žã?Œå®šã‚?ã‚‰ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(71420,1984,'pt','Sem impostos da cidade definidos.',0),(71421,1984,'ru','ÐÐµ Ð³Ð¾Ñ€Ð¾Ð´ÑÐºÐ¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¸ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ñ‹.',0),(71422,1984,'es','No se DefiniÃ³ Impuestos Locales',0),(71423,1984,'de','Keine Stadt Steuern definiert.',0),(71424,1984,'en','No city taxes defined.',0),(71425,1985,'is','',0),(71426,1985,'dr','(Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù…) ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(71427,1985,'pr','Ù‡ÙŠÚ† Ø±Ù†Ú¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø³Ù‡Ø§Ù… (Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±) ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(71428,1985,'tr','Boya yok bu kaÄŸÄ±t iÃ§in girilen',0),(71429,1985,'pl','Kolory nie wszedÅ‚ na ten czas',0),(71430,1985,'bg','ÐÑÐ¼Ð° Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð·Ð°Ð¿Ð°Ñ',0),(71431,1985,'ur','Ú©ÙˆØ¦ÛŒ Ø±Ù†Ú¯ Ø§Ø³ Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ù„Ø¦Û’ Ø¯Ø§Ø®Ù„ ÛÙˆØ¦Û’ Û”',0),(71432,1985,'sr','ÐÐµÐ¼Ð° Ð±Ð¾Ñ˜Ðµ Ð·Ð° ÑƒÐ½ÐµÑÐµ Ð¾Ð²Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(71433,1985,'vi','ChÆ°a nháº­p máº§u cho hÃ ng tá»“n nÃ y',0),(71434,1985,'af','Geen Kleure Ingevoer vir hierdie Voorraad',0),(71435,1985,'ro','Nu intrat Ã®n culori pentru acest stoc',0),(71436,1985,'et','No vÃ¤rvid kantakse varude',0),(71437,1985,'si','Brez barve vnesli za tega staleÅ¾a',0),(71438,1985,'ba','Tidak ada warna dimasukkan untuk saham ini',0),(71439,1985,'nl','Geen kleuren ingevoerd voor dit bestand',0),(71440,1985,'fi','Ei vÃ¤rejÃ¤ tuli tÃ¤mÃ¤n kannan',0),(71441,1985,'no','Ingen farger angitt for dette lager',0),(71442,1985,'da','Ingen farver angivet for denne bestand',0),(71443,1985,'ko','ì´ ì£¼ì‹ì— ëŒ€ í•œ ìƒ‰ìƒ ìž…ë ¥',0),(71444,1985,'he','××™×Ÿ ×‘×• ×¦×‘×¢×™× ×©×”×•×–× ×• ×¢×‘×•×¨ ×”×ž× ×™×” ×”×–×•',0),(71445,1985,'el','Î”ÎµÎ½ Ï„Î­Î¸Î·ÎºÎµ Ï‡ÏÏŽÎ¼Î±Ï„Î± Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(71446,1985,'zh','æ­¤è‚¡æ²¡æœ‰è¾“å…¥çš„é¢œè‰²\r\n',0),(71447,1985,'sv','Inga fÃ¤rger angetts fÃ¶r detta bestÃ¥nd',0),(71448,1985,'it','No colori inseriti per questo Stock',0),(71449,1985,'tl','',0),(71450,1985,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3626;&#3637;&#3607;&#3637;&#3656;&#3611;&#3657;&#3629;&#3609;&#3586;&#3629;&#3591;&#3626;&#3605;&#3655;&#3629;&#3585;&#3609;&#3637;&#3657;',0),(71451,1985,'hi','à¤•à¥‹à¤ˆ à¤°à¤‚à¤— à¤‡à¤¸ à¤¶à¥‡à¤¯à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(71452,1985,'ms','Warna-warna yang tidak dimasukkan untuk stok ini',0),(71453,1985,'ar','Ø§Ù„Ø£Ù„ÙˆØ§Ù† Ù„Ø§ Ø¯Ø®Ù„ Ù„Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(71454,1985,'fr','Aucune entrÃ©e de couleurs pour ce Stock',0),(71455,1985,'jp','ã?“ã?®åœ¨åº«ã?«ã?¯è‰²ã?Œæœªå…¥åŠ›ã?§ã?™',0),(71456,1985,'pt','NÃ£o hÃ¡ cores entraram para esta unidade',0),(71457,1985,'ru','ÐÐµÑ‚ Ñ†Ð²ÐµÑ‚Ð¾Ð² Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð» Ð½Ð° ÑÑ‚Ð¾Ñ‚ Ð·Ð°Ð¿Ð°Ñ',0),(71458,1985,'es','No se EntrÃ³ Colores para Este Stock',0),(71459,1985,'de','Keine Farben fÃ¼r diesen Bestand eingetragen',0),(71460,1985,'en','No Colors Entered for this Stock',0),(71461,1986,'is','',0),(71462,1986,'dr','Ù‡ÙŠÚ† Ø´Ø±ÙƒØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ â€“ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ø¯Ø§Ù…Ù‡ Ù†ÙŠØ³Øª ',0),(71463,1986,'pr','Ù‡ÙŠÚ† Ø´Ø±ÙƒØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ â€“ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ø¯Ø§Ù…Ù‡ Ù†ÙŠØ³Øª ',0),(71464,1986,'tr','HiÃ§bir ÅŸirket buldum. Devam edemiyor.',0),(71465,1986,'pl','Nie znaleziono firm. Nie moÅ¼na kontynuowaÄ‡.',0),(71466,1986,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ñ„Ð¸Ñ€Ð¼Ð¸. ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸.',0),(71467,1986,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ù…Ù¾Ù†ÛŒØ§Úº Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ Û” Ø¬Ø§Ø±ÛŒ Ù†ÛÛŒÚº Ø±Ú©Ú¾ Ø³Ú©ØªØ§ Û”',0),(71468,1986,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð° Ð·Ð°. ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ð¸.',0),(71469,1986,'vi','KhÃ´ng tÃ¬m tháº¥y cty. KhÃ´ng thá»ƒ tiáº¿p tá»¥c',0),(71470,1986,'af','Geen Ondernemings gevind. Kan nie voortgaan.',0),(71471,1986,'ro','Nu companii gÄƒsite. Nu poate continua.',0),(71472,1986,'et','EttevÃµtted ei leitud. Ei saa jÃ¤tkata.',0),(71473,1986,'si','Ni najdena podjetja. Ne more nadaljevati.',0),(71474,1986,'ba','Tidak ada perusahaan yang ditemukan. Tidak dapat melanjutkan.',0),(71475,1986,'nl','Geen gevonden bedrijven. Kan niet doorgaan.',0),(71476,1986,'fi','Ei yrityksille. Ei voi jatkaa.',0),(71477,1986,'no','Noen selskaper funnet. Kan ikke fortsette.',0),(71478,1986,'da','Ingen fundet selskaber. Kan ikke fortsÃ¦tte.',0),(71479,1986,'ko','ì•„ë‹ˆ íšŒì‚¬ ë°œê²¬ìž…ë‹ˆë‹¤. ê³„ì†í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(71480,1986,'he','×—×‘×¨×•×ª ×œ× × ×ž×¦×. ××™×Ÿ ××¤×©×¨×•×ª ×œ×”×ž×©×™×š.',0),(71481,1986,'el','Î”ÎµÎ½ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½. Î”ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î½ÎµÏ‡Î¯ÏƒÎ¿Ï…Î¼Îµ.',0),(71482,1986,'zh','æœªå‘çŽ°å…¬å¸ã€‚æ— æ³•ç»§ç»­ã€‚\r\n',0),(71483,1986,'sv','Inga fÃ¶retag Funna. Kan inte fortsÃ¤tta.',0),(71484,1986,'it','Nessuna societÃ  trovata. Non puÃ² continuare.',0),(71485,1986,'tl','',0),(71486,1986,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607; &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3607;&#3635;&#3605;&#3656;&#3629;&#3652;&#3604;&#3657;',0),(71487,1986,'hi','à¤•à¥‹à¤ˆ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤ à¤œà¤¾à¤°à¥€ à¤¨à¤¹à¥€à¤‚ à¤°à¤– à¤¸à¤•à¤¤à¥‡à¥¤',0),(71488,1986,'ms','Tiada Syarikat yang dijumpai. Tidak dapat diteruskan.',0),(71489,1986,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙŠ Ø´Ø±ÙƒØ§Øª. Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø§Ø³ØªÙ…Ø±Ø§Ø±.',0),(71490,1986,'fr','Aucune Compagnie trouvÃ©e. Impossible de continuer.',0),(71491,1986,'jp','ä¼šç¤¾ã?Œè¦‹ã?¤ã?‹ã‚‰ã?šã€?å…ˆã?«å‹§ã‚?ã?¾ã?›ã‚“',0),(71492,1986,'pt','Nenhuma empresa encontrada. NÃ£o pode continuar.',0),(71493,1986,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¹. ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÑŒ.',0),(71494,1986,'es','No se encontrÃ³ las empresas. No puede continuar',0),(71495,1986,'de','Kein Unternehmen gefunden. Kann nicht fortgesetzt werden.',0),(71496,1986,'en','No companies found. Cannot continue.',0),(71497,1987,'is','',0),(71498,1987,'dr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠ Ù…Ø±ÙƒØ¨ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71499,1987,'pr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠ Ù…Ø±ÙƒØ¨ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71500,1987,'tr','BileÅŸik Ã¶ÄŸe bulunamadÄ±.',0),(71501,1987,'pl','Nie zÅ‚oÅ¼onych przedmioty znalezione.',0),(71502,1987,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ ÑÑŠÑÑ‚Ð°Ð²Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸.',0),(71503,1987,'ur','Ú©ÙˆØ¦ÛŒ Ø¬Ø§Ù…Ø¹ Ø§Ø´ÛŒØ§Ø¡ Ù†ÛÛŒÚº Ù…Ù„ÛŒ Û”',0),(71504,1987,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° Ð½Ð¸Ñ˜ÐµÐ´Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ°.',0),(71505,1987,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ ng composite',0),(71506,1987,'af','Geen saamgestelde items gevind.',0),(71507,1987,'ro','Compozit articole gÄƒsite.',0),(71508,1987,'et','Komposiit Ã¼ksusi ei leitud.',0),(71509,1987,'si','Ni sestavljeno najdenih elementov.',0),(71510,1987,'ba','Tidak ada item komposit yang ditemukan.',0),(71511,1987,'nl','Geen samengestelde items gevonden.',0),(71512,1987,'fi','Komposiitti kohteita ei lÃ¶ytynyt.',0),(71513,1987,'no','Ingen sammensatte elementer funnet.',0),(71514,1987,'da','Ingen sammensatte varer fundet.',0),(71515,1987,'ko','ë³µí•© í•­ëª©ì´ ì—†ìŠµë‹ˆë‹¤ ë°œê²¬.',0),(71516,1987,'he','×œ× × ×ž×¦××• ×¤×¨×™×˜×™× ×œ×œ× ×”×¤×¨×“×•×ª ×¦×‘×¢.',0),(71517,1987,'el','Î”ÎµÎ½ ÏƒÏÎ½Î¸ÎµÏ„Î± Î±Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(71518,1987,'zh','æœªå‘çŽ°å¤åˆé¡¹ç›®ã€‚\r\n',0),(71519,1987,'sv','Ingen sammansatt objekt hittades.',0),(71520,1987,'it','Nessun elemento composito trovato.',0),(71521,1987,'tl','',0),(71522,1987,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3586;&#3638;&#3657;&#3609;',0),(71523,1987,'hi','à¤•à¥‹à¤ˆ à¤¸à¤®à¤—à¥à¤° à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(71524,1987,'ms','Tiada item komposit yang ditemui.',0),(71525,1987,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ØµÙ†Ø§Ù Ù…Ø±ÙƒÙ‘Ø¨Ø©',0),(71526,1987,'fr','Aucun Ã©lÃ©ment composite trouvÃ©.',0),(71527,1987,'jp','è¤‡å?ˆå“?ç›®ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(71528,1987,'pt','Nenhum compostos itens encontrados.',0),(71529,1987,'ru','Ð¡Ð¾ÑÑ‚Ð°Ð²Ð½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(71530,1987,'es','No se encontrÃ³ items compuestos',0),(71531,1987,'de','Keine zusammengesetzte EintrÃ¤ge gefunden.',0),(71532,1987,'en','No composite items found.',0),(71533,1988,'is','',0),(71534,1988,'dr','(Ø§Ø¹Ø§Ù†Ù‡',0),(71535,1988,'pr','Ø¨Ø¯ÙˆÙ† ØªÙˆØ²ÙŠØ¹ÙŠ (Ø§Ø¹Ø§Ù†Ù‡',0),(71536,1988,'tr','HiÃ§bir katkÄ±',0),(71537,1988,'pl','Nie wkÅ‚adu',0),(71538,1988,'bg','Ð‘ÐµÐ· Ð¿Ñ€Ð¸Ð½Ð¾Ñ',0),(71539,1988,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø±Ø¯Ø§Ø±',0),(71540,1988,'sr','ÐÐµÐ¼Ð° Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾ÑÐ°',0),(71541,1988,'vi','KhÃ´ng Ä‘Ã³ng gÃ³p',0),(71542,1988,'af','Geen bydrae',0),(71543,1988,'ro','Nici o contribuÅ£ie',0),(71544,1988,'et','PÃµlengut',0),(71545,1988,'si','Brez prispevka',0),(71546,1988,'ba','Tidak ada kontribusi',0),(71547,1988,'nl','Geen bijdrage',0),(71548,1988,'fi','Ei ole',0),(71549,1988,'no','Ingen bidrag',0),(71550,1988,'da','Ingen bidrag',0),(71551,1988,'ko','ì•„ë¬´ ê¸°ì—¬',0),(71552,1988,'he','××™×Ÿ ×ª×¨×•×ž×”',0),(71553,1988,'el','Î”ÎµÎ½ ÏƒÏ…Î¼Î²Î¬Î»Î»ÎµÎ¹',0),(71554,1988,'zh','æ²¡æœ‰è´¡çŒ®\r\n',0),(71555,1988,'sv','Inget bidrag',0),(71556,1988,'it','Nessun contributo',0),(71557,1988,'tl','',0),(71558,1988,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3592;&#3634;&#3588;',0),(71559,1988,'hi','à¤•à¥‹à¤ˆ à¤…à¤‚à¤¶à¤¦à¤¾à¤¨',0),(71560,1988,'ms','Tiada sumbangan',0),(71561,1988,'ar','Ù„Ø§ Ù…Ø³Ø§Ù‡Ù…Ø©',0),(71562,1988,'fr','Aucune contribution',0),(71563,1988,'jp','è²¢çŒ®ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(71564,1988,'pt','Nenhuma contribuiÃ§Ã£o',0),(71565,1988,'ru','ÐÐµÑ‚ Ð²ÐºÐ»Ð°Ð´Ð°',0),(71566,1988,'es','No ContribuciÃ³n',0),(71567,1988,'de','Kein Beitrag',0),(71568,1988,'en','No contribution',0),(71569,1989,'is','',0),(71570,1989,'dr','/ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§ÙŠ',0),(71571,1989,'pr','Ù‡ÙŠÚ† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡  / Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§ÙŠ',0),(71572,1989,'tr','SeÃ§ilen maliyet merkezi ailesi',0),(71573,1989,'pl','Bez kosztÃ³w centrum rodziny wybrane',0),(71574,1989,'bg','ÐÑÐ¼Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(71575,1989,'ur','Ú©ÙˆØ¦ÛŒ Ù‚ÛŒÙ…Øª Ù…Ø±Ú©Ø² Ù…Ù†ØªØ®Ø¨ Ø®Ø§Ù†Ø¯Ø§Ù†',0),(71576,1989,'sr','Ð‘ÐµÐ· Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ðµ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸',0),(71577,1989,'vi','KhÃ´ng Cost Center/Chá»n Gia ÄÃ¬nh',0),(71578,1989,'af','Geen koste sentrum familie gekies',0),(71579,1989,'ro','Nici o familie de centrul de Cost selectat',0),(71580,1989,'et','Hind Center perekonna valitud',0),(71581,1989,'si','Brez stroÅ¡kov Center druÅ¾ine izbrana',0),(71582,1989,'ba','Tidak ada biaya keluarga pusat yang dipilih',0),(71583,1989,'nl','Geen kosten Center familie geselecteerd',0),(71584,1989,'fi','Ei kustannuksia Center perhe valittuna',0),(71585,1989,'no','Ingen kostnader Center familie valgt',0),(71586,1989,'da','Ingen Cost Center familie valgt',0),(71587,1989,'ko','ë¹„ìš© ì„¼í„° ê°€ì¡± ì„ ì •',0),(71588,1989,'he','××™×Ÿ ×ž×©×¤×—×” ×ž×¨×›×– ×¢×œ×•×ª ×©× ×‘×—×¨×•',0),(71589,1989,'el','ÎšÎ±Î¼Î¯Î± Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(71590,1989,'zh','æ— å·²é€‰çš„æˆæœ¬ä¸­å¿ƒ/å®¶åº­\r\n',0),(71591,1989,'sv','Ingen kostnad Center familjen valt',0),(71592,1989,'it','Nessun costo centro famiglia selezionata',0),(71593,1989,'tl','',0),(71594,1989,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;/&#3594;&#3640;&#3604;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(71595,1989,'hi','à¤•à¥‹à¤ˆ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤šà¤¯à¤¨à¤¿à¤¤ à¤ªà¤°à¤¿à¤µà¤¾à¤°',0),(71596,1989,'ms','Tiada keluarga Pusat kos yang dipilih',0),(71597,1989,'ar','Ù„Ø§ \"Ø§Ù„Ø£Ø³Ø±Ø© Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©\" Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(71598,1989,'fr','Aucune famille de centre de coÃ»t sÃ©lectionnÃ©',0),(71599,1989,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼/ç³»çµ±ã?Œé?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(71600,1989,'pt','Nenhuma famÃ­lia de centro de custos selecionado',0),(71601,1989,'ru','ÐÐµÑ‚ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ†ÐµÐ½Ñ‚Ñ€ ÑÐµÐ¼ÑŒÐ¸ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(71602,1989,'es','No Centro de Costos/Familia Seleccionados',0),(71603,1989,'de','Keine Kosten-Center-Familie ausgewÃ¤hlt',0),(71604,1989,'en','No Cost Center Family selected',0),(71605,1990,'is','',0),(71606,1990,'dr','Ù‡ÙŠÚ† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø§ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(71607,1990,'pr','Ù‡ÙŠÚ† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø§ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(71608,1990,'tr','SeÃ§ilen maliyet merkezi yok',0),(71609,1990,'pl','Nie MPK wybrane',0),(71610,1990,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(71611,1990,'ur','Ú©ÙˆØ¦ÛŒ Ù‚ÛŒÙ…Øª Ø³ÛŒÙ†Ù¹Ø± Ù…Ù†ØªØ®Ø¨',0),(71612,1990,'sr','ÐÐµÐ¼Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½ Ñ˜Ðµ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ð·Ð°',0),(71613,1990,'vi','ChÆ°a Chá»n Cost Center',0),(71614,1990,'af','Geen koste sentrum gekies',0),(71615,1990,'ro','Nici un centru de Cost selectat',0),(71616,1990,'et','Pole valitud Kulukeskus',0),(71617,1990,'si','Brez stroÅ¡kov Center izbrane',0),(71618,1990,'ba','Tidak ada biaya pusat yang dipilih',0),(71619,1990,'nl','Geen kosten Center geselecteerd',0),(71620,1990,'fi','Ei valittu kustannuspaikka',0),(71621,1990,'no','Ingen kostsenter valgt',0),(71622,1990,'da','Ingen Cost Center valgt',0),(71623,1990,'ko','ì•„ë¬´ ë¹„ìš© ì„¼í„° ì„ íƒ',0),(71624,1990,'he','××™×Ÿ ×ž×¨×›×– ×¢×œ×•×™×•×ª ×©× ×‘×—×¨×•',0),(71625,1990,'el','ÎšÎ±Î½Î­Î½Î± ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(71626,1990,'zh','æ²¡æœ‰å·²é€‰çš„æˆæœ¬ä¸­å¿ƒ\r\n',0),(71627,1990,'sv','Ingen kostnadsstÃ¤lle som valts',0),(71628,1990,'it','Nessun costo centro selezionato',0),(71629,1990,'tl','',0),(71630,1990,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(71631,1990,'hi','à¤•à¥‹à¤ˆ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤¨à¥à¤¦à¥à¤° à¤•à¤¾ à¤šà¤¯à¤¨',0),(71632,1990,'ms','Tiada Pusat kos yang dipilih',0),(71633,1990,'ar','Ù„Ù… ÙŠØ®ØªØ± Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ©',0),(71634,1990,'fr','Aucun centre de coÃ»t sÃ©lectionnÃ©',0),(71635,1990,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?Œé?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(71636,1990,'pt','Nenhum centro de custos selecionado',0),(71637,1990,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚, Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(71638,1990,'es','No Centro de Costos Seleccionado',0),(71639,1990,'de','Keine Kostenstelle ausgewÃ¤hlt',0),(71640,1990,'en','No Cost Center selected',0),(71641,1991,'is','',0),(71642,1991,'dr','Ù‡ÙŠÚ† Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71643,1991,'pr','Ù‡ÙŠÚ† Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71644,1991,'tr','MÃ¼ÅŸteri yok bulundu',0),(71645,1991,'pl','Nie znaleziono klientÃ³w',0),(71646,1991,'bg','ÐÑÐ¼Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(71647,1991,'ur','Ú©ÙˆØ¦ÛŒ Ú¯Ø§ÛÚ© Ù¾Ø§ÛŒØ§',0),(71648,1991,'sr','ÐÐµÐ¼Ð° ÐºÑƒÐ¿Ñ†Ð¸ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸',0),(71649,1991,'vi','KhÃ´ng tÃ¬m tháº¥y khÃ¡ch hÃ ng',0),(71650,1991,'af','Geen Klante/KliÃ«nte gevind',0),(71651,1991,'ro','Nici clienÅ£ii gÄƒsit',0),(71652,1991,'et','Kliente ei leitud',0),(71653,1991,'si','Ne stranke ugotovila',0),(71654,1991,'ba','Pelanggan tidak ditemukan',0),(71655,1991,'nl','Geen gevonden klanten',0),(71656,1991,'fi','Ei lÃ¶ydy asiakkaita',0),(71657,1991,'no','Ingen kunder funnet',0),(71658,1991,'da','Ingen kunder fundet',0),(71659,1991,'ko','ê³ ê° ë°œê²¬',0),(71660,1991,'he','×œ× × ×ž×¦××• ×œ×§×•×—×•×ª',0),(71661,1991,'el','Î”ÎµÎ½ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(71662,1991,'zh','å®¢æˆ·æœªæ‰¾åˆ°',0),(71663,1991,'sv','Inga kunder hittade',0),(71664,1991,'it','Clienti non trovati',0),(71665,1991,'tl','',0),(71666,1991,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(71667,1991,'hi','à¤•à¥‹à¤ˆ à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤¾à¤¯à¤¾',0),(71668,1991,'ms','Tidak ada pelanggan yang ditemui',0),(71669,1991,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø²Ø¨Ø§Ø¦Ù†',0),(71670,1991,'fr','Pas trouvÃ©s de clients',0),(71671,1991,'jp','é¡§å®¢ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(71672,1991,'pt','Nenhum cliente encontrado',0),(71673,1991,'ru','ÐÐµ Ð½Ð°ÑˆÐ»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(71674,1991,'es','No se encontrÃ³ ningunos clientes',0),(71675,1991,'de','Keine Kunden gefunden',0),(71676,1991,'en','No customers found',0),(71677,1992,'is','',0),(71678,1992,'dr','(Ø¨Ø¯ÙˆÙ† Ø®Ø· ÙØ§ØµÙ„Ù‡ )',0),(71679,1992,'pr','(Ø¨Ø¯ÙˆÙ† Ø®Ø· ÙØ§ØµÙ„Ù‡ )',0),(71680,1992,'tr','(Tire)',0),(71681,1992,'pl','(Nie kresek)',0),(71682,1992,'bg','(ÐÐµ Ñ‚Ð¸Ñ€ÐµÑ‚Ð°)',0),(71683,1992,'ur','(Ú©ÙˆØ¦ÛŒ ÚˆÛŒØ´)',0),(71684,1992,'sr','(Ð‘ÐµÐ· Ñ†Ñ€Ñ‚Ð¸Ñ†Ð°)',0),(71685,1992,'vi',' (khÃ´ng gáº¡ch ngang)',0),(71686,1992,'af','(Geen Strepies)',0),(71687,1992,'ro','(Nici o liniuÅ£e)',0),(71688,1992,'et','(Ilma tÃ¼hikuteta)',0),(71689,1992,'si','(Brez Ärtice)',0),(71690,1992,'ba','(Tidak ada tanda hubung)',0),(71691,1992,'nl','(Geen streepjes)',0),(71692,1992,'fi','(Ei ampaista)',0),(71693,1992,'no','(Ingen streker)',0),(71694,1992,'da','(Ikke tankestreger)',0),(71695,1992,'ko','(ëŒ€ì‹œ)',0),(71696,1992,'he','(×œ×œ× ×ž×§×¤×™×)',0),(71697,1992,'el','(Î”ÎµÎ½ Ï€Î±ÏÎ»ÎµÏ‚)',0),(71698,1992,'zh','ï¼ˆæ²¡æœ‰ç ´æŠ˜å·ï¼‰\r\n',0),(71699,1992,'sv','(Utan streck)',0),(71700,1992,'it','(Senza trattini)',0),(71701,1992,'tl','',0),(71702,1992,'th','(No Dashes)',0),(71703,1992,'hi','(à¤•à¥‹à¤ˆ à¤¡à¥ˆà¤¶)',0),(71704,1992,'ms','(Tanpa sengkang)',0),(71705,1992,'ar','(Ù„ÙŠØ³ Ø´Ø±Ø·)',0),(71706,1992,'fr','(Sans tiret)',0),(71707,1992,'jp','ï¼ˆãƒ€ãƒƒã‚·ãƒ¥ä¸?è¦?ï¼‰',0),(71708,1992,'pt','(Sem traÃ§os)',0),(71709,1992,'ru','(Ð‘ÐµÐ· Ñ‚Ð¸Ñ€Ðµ)',0),(71710,1992,'es','(No Guiones)',0),(71711,1992,'de','(Ohne Bindestriche)',0),(71712,1992,'en','(No Dashes)',0),(71713,1993,'is','',0),(71714,1993,'dr','Ù‡ÙŠÚ† Ø¯Ø§Ø¯Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71715,1993,'pr','Ù‡ÙŠÚ† Ø¯Ø§Ø¯Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71716,1993,'tr','Verisi bulunamadÄ±',0),(71717,1993,'pl','Nie danych',0),(71718,1993,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(71719,1993,'ur','Ú©ÙˆØ¦ÛŒ Ú©ÙˆØ§Ø¦Ù Ù¾Ø§ÛŒØ§',0),(71720,1993,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð½Ð°ÑˆÐ°Ð¾',0),(71721,1993,'vi','KhÃ´ng tÃ¬m tháº¥y dá»¯ liá»‡u',0),(71722,1993,'af','Geen Data Gevind',0),(71723,1993,'ro','Nu existÄƒ date gÄƒsite',0),(71724,1993,'et','Andmeid ei leitud',0),(71725,1993,'si','Podatki, ki niso naÅ¡li',0),(71726,1993,'ba','Tidak ada Data yang ditemukan',0),(71727,1993,'nl','Geen gevonden gegevens',0),(71728,1993,'fi','Ei tietoja ei lÃ¶ytynyt',0),(71729,1993,'no','Ingen Data funnet',0),(71730,1993,'da','Ingen Data fundet',0),(71731,1993,'ko','ë°ì´í„°ê°€ ë°œê²¬',0),(71732,1993,'he','×œ× × ×ž×¦××• × ×ª×•× ×™×',0),(71733,1993,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(71734,1993,'zh','æ•°æ®æœªæ‰¾åˆ°\r\n',0),(71735,1993,'sv','Inga Data hittades',0),(71736,1993,'it','Nessun dato trovato',0),(71737,1993,'tl','',0),(71738,1993,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(71739,1993,'hi','à¤•à¥‹à¤ˆ à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(71740,1993,'ms','Tiada Data yang didapati',0),(71741,1993,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¨ÙŠØ§Ù†Ø§Øª',0),(71742,1993,'fr','Aucune donnÃ©e trouvÃ©e',0),(71743,1993,'jp','ãƒ‡ãƒ¼ã‚¿ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(71744,1993,'pt','Nenhum dado encontrado',0),(71745,1993,'ru','Ð”Ð°Ð½Ð½Ñ‹Ñ… ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ð¾',0),(71746,1993,'es','No se EncontrÃ³ Datos',0),(71747,1993,'de','Keine Daten gefunden',0),(71748,1993,'en','No Data Found',0),(71749,1994,'is','',0),(71750,1994,'dr','Ù‡ÙŠÚ† ØªÙˆØ¶ÙŠØ­ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(71751,1994,'pr','Ù‡ÙŠÚ† ØªÙˆØ¶ÙŠØ­ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(71752,1994,'tr','AÃ§Ä±klamasÄ± yok',0),(71753,1994,'pl','Opisu brak',0),(71754,1994,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(71755,1994,'ur','Ú©ÙˆØ¦ÛŒ ØªØµØ±ÛŒØ­ Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº',0),(71756,1994,'sr','ÐžÐ¿Ð¸Ñ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½',0),(71757,1994,'vi','Diá»…n giáº£i khÃ´ng cÃ³',0),(71758,1994,'af','Geen beskrywing beskikbaar',0),(71759,1994,'ro','Nici o descriere disponibile',0),(71760,1994,'et','Kirjeldust pole saadaval',0),(71761,1994,'si','Opisa ni na voljo',0),(71762,1994,'ba','Tidak ada deskripsi yang tersedia',0),(71763,1994,'nl','Geen omschrijving beschikbaar',0),(71764,1994,'fi','Ei kuvausta',0),(71765,1994,'no','Ingen beskrivelse tilgjengelig',0),(71766,1994,'da','Ingen beskrivelse tilgÃ¦ngelig',0),(71767,1994,'ko','ì‚¬ìš© ê°€ëŠ¥í•œ ì•„ë¬´ ì„¤ëª…ë„ ì—†ê³ ',0),(71768,1994,'he','××™×Ÿ ×ª×™××•×¨ ×–×ž×™×Ÿ',0),(71769,1994,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(71770,1994,'zh','æ²¡æœ‰å¯ç”¨çš„æè¿°\r\n',0),(71771,1994,'sv','Ingen beskrivning tillgÃ¤nglig',0),(71772,1994,'it','Descrizione non disponibile',0),(71773,1994,'tl','',0),(71774,1994,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3652;&#3604;&#3657;',0),(71775,1994,'hi','à¤•à¥‹à¤ˆ à¤µà¤°à¥à¤£à¤¨ à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(71776,1994,'ms','Tidak terdapat Perihalan',0),(71777,1994,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ÙˆØµÙ Ù…ØªØ§Ø­',0),(71778,1994,'fr','Aucune description disponible',0),(71779,1994,'jp','è§£èª¬ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(71780,1994,'pt','Nenhuma descriÃ§Ã£o disponÃ­vel',0),(71781,1994,'ru','ÐÐµÐ¸ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾Ð³Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(71782,1994,'es','No descripciÃ³n disponible',0),(71783,1994,'de','Keine Beschreibung verfÃ¼gbar',0),(71784,1994,'en','No description available',0),(71785,1995,'is','',0),(71786,1995,'dr','Ù‡ÙŠÚ† ÙƒØ§Ø±Ù…Ù†Ø¯ÙŠ Ø¯Ø± Ø­Ø³Ø§Ø¨ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71787,1995,'pr','Ù‡ÙŠÚ† ÙƒØ§Ø±Ù…Ù†Ø¯ÙŠ Ø¯Ø± Ø­Ø³Ø§Ø¨ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(71788,1995,'tr','Bordro iÃ§inde bulunan hiÃ§bir Ã§alÄ±ÅŸanÄ±',0),(71789,1995,'pl','Brak pracownikÃ³w w liÅ›cie pÅ‚ac',0),(71790,1995,'bg','ÐÑÐ¼Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸, Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð² Ð¢Ð Ð—',0),(71791,1995,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ù…ÛŒÚº Ù¾Û’ Ø±ÙˆÙ„ Ù…Ù„Ø§',0),(71792,1995,'sr','ÐÐµÐ¼Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ñƒ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ',0),(71793,1995,'vi','KhÃ´ng tháº¥y nhÃ¢n viÃªn trong báº£ng lÆ°Æ¡ng',0),(71794,1995,'af','Geen Werknemers Gevind in Loonrol',0),(71795,1995,'ro','Nici angajaÅ£ii gÄƒsite Ã®n salarizare',0),(71796,1995,'et','Leitud palgal tÃ¶Ã¶tajaid pole',0),(71797,1995,'si','Brez zaposlenih v plaÄilni listi',0),(71798,1995,'ba','Tidak ada karyawan yang ditemukan dalam penggajian',0),(71799,1995,'nl','Geen werknemers gevonden op de salarislijst',0),(71800,1995,'fi','Ei tyÃ¶ntekijÃ¶itÃ¤ lÃ¶ydy palkanlaskennan',0),(71801,1995,'no','Ingen ansatte i lÃ¸nn',0),(71802,1995,'da','Ingen medarbejdere fundet i lÃ¸n',0),(71803,1995,'ko','ì•„ë¬´ ì§ì› ê¸‰ì—¬ì—ì„œ ë°œê²¬',0),(71804,1995,'he','×‘×œ×™ ×¢×•×‘×“×™× × ×ž×¦××• ×ž×©×›×•×¨×•×ª',0),(71805,1995,'el','Î”ÎµÎ½ Ï„Î¿Ï…Ï‚ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Î¿Ï…Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÏƒÏ„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(71806,1995,'zh','æœªåœ¨è–ªé‡‘ä¸­æ‰¾åˆ°å‘˜å·¥\r\n',0),(71807,1995,'sv','Inga anstÃ¤llda i lÃ¶n',0),(71808,1995,'it','Nessun trovato nel libro paga di dipendenti',0),(71809,1995,'tl','',0),(71810,1995,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3651;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(71811,1995,'hi','à¤•à¥‹à¤ˆ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤µà¥‡à¤¤à¤¨ à¤®à¥‡à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(71812,1995,'ms','Tiada pekerja yang di gaji',0),(71813,1995,'ar','Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ† Ù„Ø§ ÙˆØ¬Ø¯Øª ÙÙŠ ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(71814,1995,'fr','Aucun employÃ© dans la paie',0),(71815,1995,'jp','å¾“æ¥­å“¡å??ç°¿ã?«å¾“æ¥­å“¡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(71816,1995,'pt','NÃ£o hÃ¡ funcionÃ¡rios encontrados em folha de pagamento',0),(71817,1995,'ru','ÐÐµÑ‚ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹Ñ… Ð² ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð¾Ð¹ Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸',0),(71818,1995,'es','No se Encontraron Empleados en la NÃ³mina',0),(71819,1995,'de','Keine Mitarbeiter, die in der Abrechnung gefunden',0),(71820,1995,'en','No Employees Found in Payroll',0),(71821,1996,'is','',0),(71822,1996,'dr','Ù‡ÙŠÚ† ÙƒØ§Ø±Ù…Ù†Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(71823,1996,'pr','Ù‡ÙŠÚ† ÙƒØ§Ø±Ù…Ù†Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(71824,1996,'tr','Ã‡alÄ±ÅŸan bulundu.',0),(71825,1996,'pl','Nie znaleziono pracownikÃ³w.',0),(71826,1996,'bg','ÐÑÐ¼Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(71827,1996,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(71828,1996,'sr','ÐÐµÐ¼Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ñ˜Ðµ Ð½Ð°ÑˆÐ°Ð¾.',0),(71829,1996,'vi','KhÃ´ng tÃ¬m tháº¥y nhÃ¢n viÃªn',0),(71830,1996,'af','Geen Werknemers gevind.',0),(71831,1996,'ro','Nici angajaÅ£ii gÄƒsite.',0),(71832,1996,'et','TÃ¶Ã¶tajaid ei leitud',0),(71833,1996,'si','Brez zaposlenih naÅ¡el.',0),(71834,1996,'ba','Karyawan tidak ditemukan.',0),(71835,1996,'nl','Geen werknemers gevonden',0),(71836,1996,'fi','TyÃ¶ntekijÃ¤Ã¤ ei ole lÃ¶ytynyt.',0),(71837,1996,'no','Ingen ansatte funnet.',0),(71838,1996,'da','Ingen medarbejdere fundet.',0),(71839,1996,'ko','ì§ì›ì´ ì•„ë‹ˆ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(71840,1996,'he','.×œ× × ×ž×¦××• ×¢×•×‘×“×™×',0),(71841,1996,'el','Î”ÎµÎ½ Ï„Î¿Ï…Ï‚ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Î¿Ï…Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(71842,1996,'zh','æ²¡æœ‰å‘çŽ°å‘˜å·¥ã€‚\r\n',0),(71843,1996,'sv','Inga anstÃ¤llda hittade.',0),(71844,1996,'it','No dipendenti trovati.',0),(71845,1996,'tl','',0),(71846,1996,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(71847,1996,'hi','à¤•à¥‹à¤ˆ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤®à¤¿à¤² à¤—à¤¯à¤¾à¥¤',0),(71848,1996,'ms','Tiada kakitangan yang ditemui.',0),(71849,1996,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…ÙˆØ¸ÙÙŠÙ†',0),(71850,1996,'fr','Pas trouvÃ©s d\'employÃ©s.',0),(71851,1996,'jp','å¾“æ¥­å“¡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(71852,1996,'pt','NÃ£o hÃ¡ funcionÃ¡rios encontrados.',0),(71853,1996,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(71854,1996,'es','No se encontraron empleados',0),(71855,1996,'de','Keine Mitarbeiter gefunden.',0),(71856,1996,'en','No employees found.',0),(71857,1997,'is','',0),(71858,1997,'dr','Ù‡ÙŠÚ† Ø«Ø¨ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(71859,1997,'pr','Ù‡ÙŠÚ† Ø«Ø¨ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(71860,1997,'tr','HiÃ§bir girdi bulunamadÄ±',0),(71861,1997,'pl','Nie znaleziono wpisâ”œâ”‚w',0),(71862,1997,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(71863,1997,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù†ÛÛŒÚº Ù…Ù„Û’',0),(71864,1997,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð½Ð¸ÑÑƒ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ðµ',0),(71865,1997,'vi','KhÃ´ng tÃ¬m tháº¥y bÃºt toÃ¡n',0),(71866,1997,'af','Geen inskrywings gevind',0),(71867,1997,'ro','Nicio intrare gÄƒsitÄƒ',0),(71868,1997,'et','Sissekandeid ei leitud',0),(71869,1997,'si','Vnosov ni mogoÄe najti',0),(71870,1997,'ba','Tidak ada entri yang ditemukan',0),(71871,1997,'nl','Geen items gevonden',0),(71872,1997,'fi','Ei hakutuloksia',0),(71873,1997,'no','Finner ingen oppfÃ¸ringer',0),(71874,1997,'da','Ingen poster fundet',0),(71875,1997,'ko','ì°¾ì€ í•­ëª©ì´ ì—†ìŠµë‹ˆë‹¤.',0),(71876,1997,'he','×œ× × ×ž×¦××• ×¨×™×©×•×ž×™×',0),(71877,1997,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(71878,1997,'zh','æ²¡æœ‰æ‰¾åˆ°ä»»ä½•æ¡ç›®\r\n',0),(71879,1997,'sv','Inga poster hittades',0),(71880,1997,'it','Senza voci trovate',0),(71881,1997,'tl','',0),(71882,1997,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(71883,1997,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€à¤‚',0),(71884,1997,'ms','Tiada entri dijumpai',0),(71885,1997,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª',0),(71886,1997,'fr','Aucune entrÃ©e trouvÃ©e',0),(71887,1997,'jp','è¨˜å¸³ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(71888,1997,'pt','NÃ£o hÃ¡ entradas encontradas',0),(71889,1997,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(71890,1997,'es','No se encontraron entradas',0),(71891,1997,'de','Es wurden keine EintrÃ¤ge gefunden',0),(71892,1997,'en','No entries found',0),(71893,1998,'is','',0),(71894,1998,'dr','Ù‡ÙŠÚ† Ø«Ø¨ØªÙŠ ÙƒÙ‡ Ø¨Ø§ Ø§ÙŠÙ† Ù…Ø¹ÙŠØ§Ø±Ù‡Ø§ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø¨Ø§Ø´Ø¯  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(71895,1998,'pr','Ù‡ÙŠÚ† Ø«Ø¨ØªÙŠ ÙƒÙ‡ Ø¨Ø§ Ø§ÙŠÙ† Ù…Ø¹ÙŠØ§Ø±Ù‡Ø§ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø¨Ø§Ø´Ø¯  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(71896,1998,'tr','EÅŸleÅŸtirme Ã¶lÃ§Ã¼tlerini kurmak iÃ§in bir girdi yok',0),(71897,1998,'pl','Nie ma Å¼adnych wpisÃ³w znalazÅ‚em kryteria dopasowywania procesÃ³w',0),(71898,1998,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð°Ñ‰Ð¸ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(71899,1998,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù…Ø´Ø§Ø¨Û Ú©Ø³ÙˆÙ¹ÛŒ',0),(71900,1998,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð½Ð¸ÑÑƒ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ðµ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ñ˜ÑƒÐ¼Ðµ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ',0),(71901,1998,'vi','KhÃ´ng tÃ¬m tháº¥y bÃºt toÃ¡n phÃ¹ há»£p ',0),(71902,1998,'af','Geen inskrywings gevind wat harmonieer met die kriteria ',0),(71903,1998,'ro','Nicio intrare gÄƒsitÄƒ criterii de potrivire',0),(71904,1998,'et','Nr sissekanded leitud vastavaid kriteeriume',0),(71905,1998,'si','Vnosov ni ugotovljeno ujemanje merila',0),(71906,1998,'ba','Tidak ada entri yang ditemukan pencocokan kriteria',0),(71907,1998,'nl','Geen items gevonden vergelijkingscriteria',0),(71908,1998,'fi','Ei hakutuloksia hakuehtoja vastaavaa',0),(71909,1998,'no','Ingen oppfÃ¸ringer funnet samsvarsvilkÃ¥r',0),(71910,1998,'da','Ingen poster fundet matchende kriterier',0),(71911,1998,'ko','ì¼ì¹˜ í•˜ëŠ” ì¡°ê±´ì„ ë°œê²¬ í•˜ëŠ” í•­ëª©ì´ ì—†ìŠµë‹ˆë‹¤.',0),(71912,1998,'he','×œ× × ×ž×¦××• ×§×¨×™×˜×¨×™×•× ×™× ×ª×•××ž×™× ×¨×©×•×ž×•×ª',0),(71913,1998,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÎºÏÎ¹Ï„Î®ÏÎ¹Î± ÏƒÏ…Î¼Ï†Ï‰Î½Î¯Î±Ï‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(71914,1998,'zh','æ²¡æœ‰æ‰¾åˆ°ç¬¦åˆæ¡ä»¶çš„æ¡ç›®\r\n',0),(71915,1998,'sv','Inga poster hittades matchande kriterier',0),(71916,1998,'it','Senza voci trovati criteri di corrispondenza',0),(71917,1998,'tl','',0),(71918,1998,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3607;&#3637;&#3656;&#3648;&#3586;&#3657;&#3634;&#3588;&#3641;&#3656;&#3585;&#3633;&#3610;&#3648;&#3585;&#3603;&#3601;&#3660;&#3607;&#3637;&#3656;&#3605;&#3',0),(71919,1998,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤®à¥‡à¤² à¤–à¤¾à¤¤à¥‡ à¤®à¤¾à¤ªà¤¦à¤‚à¤¡ à¤®à¤¿à¤² à¤—à¤¯à¤¾',0),(71920,1998,'ms','Tiada masukan yang mendapati kriteria yang sepadan',0),(71921,1998,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ø¯Ø®Ù„Ø§Øª ØªØ·Ø§Ø¨Ù Ø§Ù„Ù…Ø¹Ø§ÙŠÙŠØ±',0),(71922,1998,'fr','Aucune entrÃ©e trouvÃ©e des critÃ¨res de filtrage',0),(71923,1998,'jp','åŸºæº–ã?«ä¸€è‡´ã?™ã‚‹å…¥åŠ›ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(71924,1998,'pt','NÃ£o hÃ¡ entradas encontradas critÃ©rios de correspondÃªncia',0),(71925,1998,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸ÑÐ¼ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(71926,1998,'es','No se encontraron entradas emparejando los criterios',0),(71927,1998,'de','Es wurden keine EintrÃ¤ge gefunden Ãœbereinstimmungskriterien',0),(71928,1998,'en','No entries found matching criteria',0),(71929,1999,'is','',0),(71930,1999,'dr','Ù‡ÙŠÚ† Ø«Ø¨ØªÙŠ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø¨Ø§ Ø¯ÙˆØ±Ù‡ ÙØ¹Ø§Ù„ÙŠØª Ø¬Ù‡Øª Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(71931,1999,'pr','Ù‡ÙŠÚ† Ø«Ø¨ØªÙŠ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø¨Ø§ Ø¯ÙˆØ±Ù‡ ÙØ¹Ø§Ù„ÙŠØª Ø¬Ù‡Øª Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(71932,1999,'tr','Raporu faaliyet dÃ¶nemine uyan hiÃ§bir girdi.',0),(71933,1999,'pl','Nie ma Å¼adnych wpisÃ³w mecz okresu dziaÅ‚alnoÅ›ci do raportu.',0),(71934,1999,'bg','ÐÑÐ¼Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð°Ñ‚ Ð½Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚.',0),(71935,1999,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù†ÛÛŒÚº Ø³Ø±Ú¯Ø±Ù…ÛŒ Ø¯ÙˆØ± Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ø³Û’ Ù…Ø´Ø§Ø¨Û ÛÛ’ Û”',0),(71936,1999,'sr','ÐÐµÐ¼Ð° ÑƒÐ½Ð¾ÑÐ° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐ° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜.',0),(71937,1999,'vi','KhÃ´ng cÃ³ cáº­p nháº­t nÃ o phÃ¹ há»£p vá»›i giai Ä‘oáº¡n hoáº¡t Ä‘á»™ng cá»§a bÃ¡o cÃ¡o',0),(71938,1999,'af','Geen inskrywings pas by die aktiwiteitperiode tot met verslag',0),(71939,1999,'ro','IntrÄƒri se potrivesc perioadei de activitate la raport.',0),(71940,1999,'et','Tegevuse perioodi aruanne vastab pole kirjeid.',0),(71941,1999,'si','Ni vnosov ustrezajo obdobju dejavnost za poroÄilo.',0),(71942,1999,'ba','Tidak ada entri cocok periode aktivitas laporan.',0),(71943,1999,'nl','Er worden geen posten overeenkomen met de periode van de activiteit verslag.',0),(71944,1999,'fi','Ei merkintÃ¶jÃ¤ vastaa toimintajakson ajan mietintÃ¶Ã¶n.',0),(71945,1999,'no','Ingen oppfÃ¸ringer samsvar med perioden som aktivitet rapport.',0),(71946,1999,'da','Ingen poster matcher perioden aktivitet til betÃ¦nkningen.',0),(71947,1999,'ko','í•­ëª©ì´ ë³´ê³ ì„œ í™œë™ ê¸°ê°„ì„ ì¼ì¹˜í•©ë‹ˆë‹¤.',0),(71948,1999,'he','××™×Ÿ ×¢×¨×›×™× ×ª×•××ž×™× ××ª ×ª×§×•×¤×ª ×”×¤×¢×™×œ×•×ª ×œ×“×•×•×—.',0),(71949,1999,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î´ÎµÎ½ Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¿ÏÎ½ ÏƒÏ„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚ ÏƒÏ„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ·.',0),(71950,1999,'zh','æ²¡æœ‰ä¸ŽæŠ¥å‘Šä¸­æ´»åŠ¨æœŸç›¸åŒ¹é…çš„æ¡ç›®ã€‚\r\n',0),(71951,1999,'sv','Inga poster matchar verksamhetsperioden betÃ¤nkande.',0),(71952,1999,'it','Voci non corrispondano il periodo di attivitÃ  di relazione.',0),(71953,1999,'tl','',0),(71954,1999,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3607;&#3637;&#3656;&#3605;&#3619;&#3591;&#3585;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3585;&#3636;&#3592;&#3585;&#3619;&#3',0),(71955,1999,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¨à¤¹à¥€à¤‚ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤…à¤µà¤§à¤¿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‡à¤² à¤–à¤¾à¤¤à¥€à¥¤',0),(71956,1999,'ms','Entri yang sepadan dengan tempoh aktiviti kepada laporan.',0),(71957,1999,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ù…Ø·Ø§Ø¨Ù‚Ø© ÙØªØ±Ø© Ù†Ø´Ø§Ø· Ù„Ù„ØªÙ‚Ø±ÙŠØ±.',0),(71958,1999,'fr','Aucune entrÃ©e correspond Ã  la pÃ©riode d\'activitÃ© au rapport.',0),(71959,1999,'jp','æ´»å‹•æœŸé–“ã?«é?©å?ˆã?™ã‚‹è¨˜å¸³ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(71960,1999,'pt','NÃ£o hÃ¡ entradas coincidir com o perÃ­odo de atividade ao relatÃ³rio.',0),(71961,1999,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‚ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñƒ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚.',0),(71962,1999,'es','No hay entradas que emparejar el perÃ­odo de actividad de reportar',0),(71963,1999,'de','Keine EintrÃ¤ge entsprechen den Zeitraum TÃ¤tigkeit zu berichten.',0),(71964,1999,'en','No entries match the activity period to report.',0),(71965,2000,'is','',0),(71966,2000,'dr','Ù‡ÙŠÚ† Ø«Ø¨ØªÙŠ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø¨Ø§ Ù…Ø¹ÙŠØ§Ø±Ù‡Ø§ÙŠ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(71967,2000,'pr','Ù‡ÙŠÚ† Ø«Ø¨ØªÙŠ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø¨Ø§ Ù…Ø¹ÙŠØ§Ø±Ù‡Ø§ÙŠ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(71968,2000,'tr','HiÃ§bir girdi rapor iÃ§in belirtilen Ã¶lÃ§Ã¼tlerle eÅŸleÅŸen.',0),(71969,2000,'pl','Nie ma Å¼adnych wpisÃ³w okreÅ›lonym kryteriom do raportu.',0),(71970,2000,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸, ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð°Ñ‰Ð¸ Ð½Ð° Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ð¸ Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚.',0),(71971,2000,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù†ÛÛŒÚº Ø±Ù¾ÙˆØ±Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø®ØªØµØ§ØµÛŒ Ú©Ø³ÙˆÙ¹ÛŒ Ø³Û’ Ù…Ø´Ø§Ø¨Û ÛÛ’ Û”',0),(71972,2000,'sr','ÐÐµÐ¼Ð° ÑƒÐ½Ð¾ÑÐ° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐ° Ð½Ð°Ð²ÐµÐ´ÐµÐ½Ð¸Ñ… ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ñ˜ÑƒÐ¼Ð° Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜.',0),(71973,2000,'vi','KhÃ´ng cÃ³ cáº­p nháº­t nÃ o phÃ¹ há»£p vá»›i tiÃªu chÃ­ cá»§a bÃ¡o cÃ¡o',0),(71974,2000,'af','Geen inskrywings pas by die gespesifiseerde kriteria om oor verslag te lewer',0),(71975,2000,'ro','IntrÄƒri se potrivesc criteriile specificate la raport.',0),(71976,2000,'et','Kirjeid pole vasta aruande mÃ¤Ã¤ratud kriteeriumidele.',0),(71977,2000,'si','Ni vnosov ustrezajo doloÄenim merilom za poroÄilo.',0),(71978,2000,'ba','Entri tidak cocok dengan kriteria yang ditentukan untuk laporan.',0),(71979,2000,'nl','Geen items aan de opgegeven criteria voldoen naar verslag.',0),(71980,2000,'fi','MietinnÃ¶n mÃ¤Ã¤ritettyjÃ¤ ehtoja vastaavia merkintÃ¶jÃ¤ ei ole.',0),(71981,2000,'no','Ingen poster oppfyller de angitte kriteriene for rapporten.',0),(71982,2000,'da','Ingen poster matcher de angivne kriterier til betÃ¦nkningen.',0),(71983,2000,'ko','í•­ëª©ì´ëŠ” ë³´ê³ ì„œì— ì§€ì • ëœ ì¡°ê±´ì— ë§žëŠ”.',0),(71984,2000,'he','××™×Ÿ ×¢×¨×›×™× ×ª×•××ž×™× ×œ×§×¨×™×˜×¨×™×•× ×™× ×©×¦×•×™× ×• ×œ×“×•×•×—.',0),(71985,2000,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î´ÎµÎ½ ÏƒÏ…Î¼Ï†Ï‰Î½ÎµÎ¯ Î¼Îµ Ï„Î± ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î± ÎºÏÎ¹Ï„Î®ÏÎ¹Î± ÏƒÏ„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ·.',0),(71986,2000,'zh','æ²¡æœ‰ä¸ŽæŠ¥å‘Šä¸­ç‰¹å®šæ ‡å‡†ç›¸åŒ¹é…çš„æ¡ç›®ã€‚\r\n',0),(71987,2000,'sv','Inga poster matchar de angivna villkoren till rapport.',0),(71988,2000,'it','Voci non corrispondono ai criteri specificati alla relazione.',0),(71989,2000,'tl','',0),(71990,2000,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3607;&#3637;&#3656;&#3605;&#3619;&#3591;&#3585;&#3633;&#3609;&#3585;&#3633;&#3610;&#3648;&#3585;&#3603;&#3601;&#3660;&#3648;&#3593;&#3614;&#3634;&#3632;&#3',0),(71991,2000,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¨à¤¹à¥€à¤‚ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤®à¤¾à¤ªà¤¦à¤‚à¤¡ à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¤à¤¾à¥¤',0),(71992,2000,'ms','Entri yang sepadan dengan kriteria yang ditentukan untuk laporan.',0),(71993,2000,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù‚ÙŠÙˆØ¯ ØªØ·Ø§Ø¨Ù‚ Ø§Ù„Ù…Ø¹Ø§ÙŠÙŠØ± Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(71994,2000,'fr','Aucuns entrÃ©es ne correspondent aux critÃ¨res spÃ©cifiÃ©s au rapport.',0),(71995,2000,'jp','ç‰¹å®šã?•ã‚Œã?ŸåŸºæº–ã?«é?©å?ˆã?™ã‚‹è¨˜å¸³ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(71996,2000,'pt','Sem entradas correspondem aos critÃ©rios especificados para o relatÃ³rio.',0),(71997,2000,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‚ ÑƒÐºÐ°Ð·Ð°Ð½Ð½Ñ‹Ð¼ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸ÑÐ¼ Ð´Ð»Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°.',0),(71998,2000,'es','No hay entradas que emparejan los criterios especificados para reportar',0),(71999,2000,'de','Keine EintrÃ¤ge entsprechen die angegebenen Kriterien zu berichten.',0),(72000,2000,'en','No entries match the specified criteria to report.',0),(72001,2001,'is','',0),(72002,2001,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ù†Ù‡Ø§ÙŠÙŠ Ø¯Ø± Ø§ÙŠÙ† Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(72003,2001,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ù†Ù‡Ø§ÙŠÙŠ Ø¯Ø± Ø§ÙŠÙ† Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(72004,2001,'tr','Verilen tarih aralÄ±ÄŸÄ±nda bulunan kesinleÅŸmiÅŸ yapÄ± emir',0),(72005,2001,'pl','Nie zakoÅ„czone budowy zamÃ³wieÅ„ w danym zakres dat',0),(72006,2001,'bg','ÐÑÐ¼Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½ Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð² Ð´Ð°Ð´ÐµÐ½ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(72007,2001,'ur','Ø¯ÛŒ Ú¯Ø¦ÛŒ ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…ÛŒÚº Ù…Ù„Ø§ Ú©ÙˆØ¦ÛŒ Ø±Ø§Ø¬Ø¯Ú¾Ø§Ù†ÛŒ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(72008,2001,'sr','ÐÐµÐ¼Ð° ÐŸÑ€Ð°Ð²Ð¾Ð±Ñ€Ð°Ð½Ð¸Ð»Ð°ÑˆÑ‚Ð²Ð° Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð½Ð°ÑˆÐ°Ð¾ Ñƒ Ð´Ð°Ñ‚Ð¾Ð¼ Ð¾Ð¿ÑÐµÐ³Ñƒ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(72009,2001,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng trong pháº¡m vi dá»¯ liá»‡u Ä‘Ã£ chá»n',0),(72010,2001,'af','Geen Gefinaliseerde Geboude Bestellings Gevind in die Gegewe Datumreeks',0),(72011,2001,'ro','Comenzi finalizate construi gÄƒsit Ã®n intervalul de Date dat',0),(72012,2001,'et','Pole lÃµpule ehitada tellimusi antud kuupÃ¤evavahemikku leitud',0),(72013,2001,'si','Brez konÄne Build naroÄil v danem datumskem obsegu',0),(72014,2001,'ba','Tidak ada order difinalisasi membangun yang ditemukan dalam rentang tanggal tertentu',0),(72015,2001,'nl','Geen gefinaliseerde Build Orders zijn gevonden in het opgegeven datumbereik',0),(72016,2001,'fi','TietyllÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤vÃ¤lillÃ¤ ei ole valmiiksi rakentaa tilauksista',0),(72017,2001,'no','Ingen endelige bygge bestillinger i angitt datointervall',0),(72018,2001,'da','Ikke fÃ¦rdiggjort bygge ordrer fundet i det angivne datointerval',0),(72019,2001,'ko','ì§€ì • ëœ ë‚ ì§œ ë²”ìœ„ì—ì„œ ë°œê²¬ ì—†ìŒ ìµœì¢…ëœ ë¹Œë“œ ìˆœì„œ',0),(72020,2001,'he','×¤×§×•×“×•×ª ×’×™×‘×•×© ×œ×‘× ×•×ª ×œ×ž×¦×•× ××ª ×˜×•×•×— ×”×ª××¨×™×›×™× × ×ª×•×Ÿ',0),(72021,2001,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„Î¹ÎºÎ® ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÏƒÎµ Î´ÎµÎ´Î¿Î¼Î­Î½Î· Ï‡ÏÎ¿Î½Î¹ÎºÎ®',0),(72022,2001,'zh','æ²¡æœ‰æœ€åŽç¡®å®šå»ºç«‹åœ¨æŒ‡å®šæ—¥æœŸèŒƒå›´å†…æ‰¾åˆ°è®¢å•\r\n',0),(72023,2001,'sv','Inga slutbehandlad bygga order i det angivna datumintervallet',0),(72024,2001,'it','Nessun ordine di compilazione finalizzato trovato in un determinato intervallo di Date',0),(72025,2001,'tl','',0),(72026,2001,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3633;&#3657;&#3609;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;&#3651;&#3609;&#3',0),(72027,2001,'hi','à¤•à¥‹à¤ˆ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¤¿à¤¯à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤ à¤—à¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤®à¥‡à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(72028,2001,'ms','Tiada perintah telah ditetapkan membina yang ditemui dalam julat tarikh yang diberikan',0),(72029,2001,'ar','Ù„Ø§ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡ Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø© ÙÙŠ Ù†Ø·Ø§Ù‚ ØªØ§Ø±ÙŠØ® Ù…Ø¹ÙŠÙ†',0),(72030,2001,'fr','Aucune commande Build finalisÃ© dans la plage de dates donnÃ©e',0),(72031,2001,'jp','ä¸Žã?ˆã‚‰ã‚Œã?Ÿæ—¥ä»˜ã?®ç¯„å›²ã?§å®Œäº†æ¸ˆçµ„ç«‹æ³¨æ–‡ã?¯ã?¿ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72032,2001,'pt','Sem ordens de construÃ§Ã£o finalizado encontrados na faixa determinada data',0),(72033,2001,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð½Ðµ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ð¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ, Ð² Ð·Ð°Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚',0),(72034,2001,'es','No se EncontrÃ³ Ordenes de ConstrucciÃ³n Finalizados en el Rango de datos Dado',0),(72035,2001,'de','Keine abgeschlossenen Build AuftrÃ¤ge gefunden in dem angegebenen Datumsbereich',0),(72036,2001,'en','No Finalized Build Orders Found in the Given Date Range',0),(72037,2002,'is','',0),(72038,2002,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(72039,2002,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(72040,2002,'tr','Bir genel muhasebe hesabÄ± seÃ§meniz gerekir.',0),(72041,2002,'pl','NaleÅ¼y wybraÄ‡ konto ksiÄ™gowe ogÃ³lne!',0),(72042,2002,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¾Ð±Ñ‰Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´Ð½Ð° ÐºÐ½Ð¸Ð³Ð°!',0),(72043,2002,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø¹Ù…ÙˆÙ…ÛŒ Ú©Ú¾Ø§ØªØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº!',0),(72044,2002,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð½Ñ‚Ð¾ ÐºÑšÐ¸Ð³Ðµ Ð³ÐµÐ½ÐµÑ€Ð°Ð»Ð°!',0),(72045,2002,'vi','Báº¡n pháº£i chá»n 1 TK sá»— cÃ¡i chung',0),(72046,2002,'af','U moet \'n Algemene Grootboekrekening kies!',0),(72047,2002,'ro','Trebuie sÄƒ selectaÅ£i un cont din registrul General!',0),(72048,2002,'et','Valige Ãœldised pearaamatu konto!',0),(72049,2002,'si','General Ledger raÄun, morate izbrati!',0),(72050,2002,'ba','Anda harus memilih sebuah General Ledger Account!',0),(72051,2002,'nl','U moet een algemene Grootboekrekening selecteren!',0),(72052,2002,'fi','Valitse yleinen kirjanpitotilin!',0),(72053,2002,'no','Du mÃ¥ velge en finanskonto for generelt!',0),(72054,2002,'da','Du skal vÃ¦lge en finanskonto, der generelt!',0),(72055,2002,'ko','ì¼ë°˜ ë ˆì € ê³„ì •ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤!',0),(72056,2002,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×—×©×‘×•×Ÿ ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™!',0),(72057,2002,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± Î³ÎµÎ½Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î³/Î»!',0),(72058,2002,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªæ€»å¸å¸æˆ·ï¼\r\n',0),(72059,2002,'sv','Du mÃ¥ste markera ett redovisningskonto fÃ¶r allmÃ¤nna!',0),(72060,2002,'it','Ãˆ necessario selezionare un conto di contabilitÃ  generale!',0),(72061,2002,'tl','',0),(72062,2002,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;!',0),(72063,2002,'hi','à¤†à¤ª à¤à¤• à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾!',0),(72064,2002,'ms','Anda mesti memilih akaun Lejar Am!',0),(72065,2002,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø¥Ø®ØªÙŠØ§Ø± Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(72066,2002,'fr','Vous devez sÃ©lectionner un compte du grand livre gÃ©nÃ©ral !',0),(72067,2002,'jp','ç·?å‹˜å®šå…ƒå¸³å‹˜å®šã‚’é?¸æŠžã?—ã?¦ã??ã? ã?•ã?„ï¼?',0),(72068,2002,'pt','VocÃª deve selecionar um General Ledger conta!',0),(72069,2002,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚ Ð“Ðš Ð¾Ð±Ñ‰ÐµÐ³Ð¾!',0),(72070,2002,'es','Debe seleccionar una cuenta de Libro Mayor',0),(72071,2002,'de','Sie mÃ¼ssen ein General Ledger Konto auswÃ¤hlen!',0),(72072,2002,'en','You must select a General Ledger Account!',0),(72073,2003,'is','',0),(72074,2003,'dr','Ù‡ÙŠÚ† Ø«Ø¨Øª Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72075,2003,'pr','Ù‡ÙŠÚ† Ø«Ø¨Øª Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72076,2003,'tr','GL gÃ¼nlÃ¼k girdisi bulunamadÄ±.',0),(72077,2003,'pl','Nie znaleziono pozycji dziennika GL.',0),(72078,2003,'bg','ÐÐµ GL Ð´Ð½ÐµÐ²Ð½Ð¸Ðº ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸.',0),(72079,2003,'ur','Ú©ÙˆØ¦ÛŒ Ø¬ÛŒØ¬Û’ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù†ÛÛŒÚº Ù…Ù„Û’ Û”',0),(72080,2003,'sr','ÐÐµÐ¼Ð° Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ Ð½Ð°ÑˆÐ°Ð¾.',0),(72081,2003,'vi','KhÃ´ng tÃ¬m tháº¥y bÃºt toÃ¡n sá»• cÃ¡i',0),(72082,2003,'af','Geen AG joernaanlinskrywings gevind.',0),(72083,2003,'ro','Nici o intrare de jurnal GL gÄƒsite.',0),(72084,2003,'et','GL tÃ¶Ã¶lehe kirjeid ei leitud.',0),(72085,2003,'si','GL journal vnosov ni naÅ¡el.',0),(72086,2003,'ba','Tidak ada GL entri jurnal ditemukan.',0),(72087,2003,'nl','Geen GL logboekitems gevonden.',0),(72088,2003,'fi','GL: ssÃ¤ tietoja ei lÃ¶ytynyt.',0),(72089,2003,'no','Fant ingen loggoppfÃ¸ringer for GL.',0),(72090,2003,'da','Ingen GL journal poster fundet.',0),(72091,2003,'ko','GL ì €ë„ í•­ëª©ì´ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(72092,2003,'he','××™×Ÿ GL ×¢×¨×›×™ ×™×•×ž×Ÿ ×©× ×ž×¦××•.',0),(72093,2003,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ ÎµÏ†Î·Î¼ÎµÏÎ¯Î´Î± GL.',0),(72094,2003,'zh','æ€»å¸æ—¥å¿—æ¡ç›®æ²¡æœ‰æ‰¾åˆ°ã€‚\r\n',0),(72095,2003,'sv','Inga GL journalposter hittades.',0),(72096,2003,'it','Nessun GL diario trovato.',0),(72097,2003,'tl','',0),(72098,2003,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3648;&#3586;&#3657;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;',0),(72099,2003,'hi','à¤•à¥‹à¤ˆ GL à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€à¤‚à¥¤',0),(72100,2003,'ms','Entri jurnal GL ditemui.',0),(72101,2003,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù‚ÙŠÙˆØ¯ ÙŠÙˆÙ…ÙŠØ©',0),(72102,2003,'fr','Aucune entrÃ©e de journal GL trouvÃ©e.',0),(72103,2003,'jp','GLä»•è¨³è¨˜å¸³åŠ›ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72104,2003,'pt','NÃ£o hÃ¡ entradas de diÃ¡rio GL encontradas.',0),(72105,2003,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ GL Ð¶ÑƒÑ€Ð½Ð°Ð».',0),(72106,2003,'es','No se encontro entradas de diario de LM',0),(72107,2003,'de','Keine GL-Journal-EintrÃ¤ge gefunden.',0),(72108,2003,'en','No GL journal entries found.',0),(72109,2004,'is','',0),(72110,2004,'dr','Ù‡ÙŠÚ† Ø§Ø·Ù„Ø§Ø¹Ø§ØªÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(72111,2004,'pr','Ù‡ÙŠÚ† Ø§Ø·Ù„Ø§Ø¹Ø§ØªÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(72112,2004,'tr','HiÃ§bir bilgi yok',0),(72113,2004,'pl','Brak informacji',0),(72114,2004,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(72115,2004,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº',0),(72116,2004,'sr','ÐÐµÐ¼Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸Ñ… Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾',0),(72117,2004,'vi','KhÃ´ng cÃ³ ThÃ´ng Tin',0),(72118,2004,'af','Geen Inligting beskikbaar',0),(72119,2004,'ro','Lipsa informatii',0),(72120,2004,'et','Teavet pole saadaval',0),(72121,2004,'si','Ni razpoloÅ¾ljivih podatkov',0),(72122,2004,'ba','Tidak ada informasi tersedia',0),(72123,2004,'nl','Geen informatie beschikbaar',0),(72124,2004,'fi','Tietoa ei ole kÃ¤ytettÃ¤vissÃ¤',0),(72125,2004,'no','Ingen informasjon tilgjengelig',0),(72126,2004,'da','Ingen tilgÃ¦ngelige oplysninger',0),(72127,2004,'ko','ì •ë³´ê°€ ì—†ìŠµë‹ˆë‹¤',0),(72128,2004,'he','××™×Ÿ ×ž×™×“×¢ ×–×ž×™×Ÿ',0),(72129,2004,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(72130,2004,'zh','æ²¡æœ‰å¯ç”¨çš„ä¿¡æ¯\r\n',0),(72131,2004,'sv','Ingen information tillgÃ¤nglig',0),(72132,2004,'it','Nessuna informazione disponibile',0),(72133,2004,'tl','',0),(72134,2004,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3652;&#3604;&#3657;',0),(72135,2004,'hi','à¤•à¥‹à¤ˆ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚',0),(72136,2004,'ms','Tiada maklumat tersedia',0),(72137,2004,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ØªØ§Ø­Ø©',0),(72138,2004,'fr','Aucune information disponible',0),(72139,2004,'jp','æƒ…å ±ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(72140,2004,'pt','NÃ£o hÃ¡ informaÃ§Ãµes disponÃ­veis',0),(72141,2004,'ru','ÐÐµÑ‚ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾Ð¹ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸',0),(72142,2004,'es','No hay informaciÃ³n disponible',0),(72143,2004,'de','Keine Informationen verfÃ¼gbar',0),(72144,2004,'en','No information available',0),(72145,2005,'is','',0),(72146,2005,'dr','Ù‡ÙŠÚ† Ù„ÙŠÙ†ÙƒÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(72147,2005,'pr','Ù‡ÙŠÚ† Ù„ÙŠÙ†ÙƒÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(72148,2005,'tr','HiÃ§bir mÃ¼rekkep bulundu',0),(72149,2005,'pl','Nie farb znaleziono',0),(72150,2005,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð°',0),(72151,2005,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ø§Ù†Ú©Ø³',0),(72152,2005,'sr','ÐÐµÐ¼Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(72153,2005,'vi','KhÃ´ng tÃ¬m tháº¥y má»±c',0),(72154,2005,'af','Geen ink gevind',0),(72155,2005,'ro','Nici cerneluri gÄƒsit',0),(72156,2005,'et','Ei leidnud tindid',0),(72157,2005,'si','Ni Ärnila naÅ¡el',0),(72158,2005,'ba','Tidak ada tinta yang ditemukan',0),(72159,2005,'nl','Geen inkten gevonden',0),(72160,2005,'fi','Ei ole musteita lÃ¶ytyi',0),(72161,2005,'no','Noen blekkfarger funnet',0),(72162,2005,'da','Ingen trykfarver fundet',0),(72163,2005,'ko','ì•„ë¬´ ìž‰í¬ ë°œê²¬',0),(72164,2005,'he','××™×Ÿ ×“×™×• × ×ž×¦××•',0),(72165,2005,'el','Î”ÎµÎ½ Î¼ÎµÎ»Î¬Î½Î¹Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(72166,2005,'zh','æ²¡æœ‰æ‰¾åˆ°æ²¹å¢¨\r\n',0),(72167,2005,'sv','Inget blÃ¤ck hittade',0),(72168,2005,'it','Nessun inchiostri trovati',0),(72169,2005,'tl','',0),(72170,2005,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3629;&#3640;&#3611;&#3585;&#3619;&#3603;&#3660;',0),(72171,2005,'hi','à¤•à¥‹à¤ˆ à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤ªà¤¾à¤',0),(72172,2005,'ms','Dakwat tidak ditemui',0),(72173,2005,'ar','Ø£Ø­Ø¨Ø§Ø± Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(72174,2005,'fr','Pas trouvÃ©s les encres',0),(72175,2005,'jp','ã‚¤ãƒ³ã‚¯ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72176,2005,'pt','Sem tintas encontradas',0),(72177,2005,'ru','ÐÐµ Ð½Ð°ÑˆÐµÐ» Ñ‡ÐµÑ€Ð½Ð¸Ð»Ð°',0),(72178,2005,'es','No se encontro tintas',0),(72179,2005,'de','Keine Farben gefunden',0),(72180,2005,'en','No inks found',0),(72181,2006,'is','',0),(72182,2006,'dr','(Ø¬Ø³ØªØ¬ÙˆÙŠ Ù†Ø§Ù…ÙˆÙÙ‚)',0),(72183,2006,'pr','Ù‡ÙŠÚ† Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯  (Ø¬Ø³ØªØ¬ÙˆÙŠ Ù†Ø§Ù…ÙˆÙÙ‚)',0),(72184,2006,'tr','Stok yerleÅŸimlerini bulundu. (sorgu baÅŸarÄ±sÄ±z)',0),(72185,2006,'pl','Nie znaleziono lokalizacji zasobÃ³w. (kwerenda nie powiodÅ‚a siÄ™)',0),(72186,2006,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÑÑ‚Ð° Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°. (Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð° Ð·Ð°ÑÐ²ÐºÐ°)',0),(72187,2006,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ù…Ù‚Ø§Ù…Ø§Øª Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ Û” (Ø·Ù„Ø¨ Ù†Ø§Ú©Ø§Ù…)',0),(72188,2006,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½ Ð½Ð¸ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°. (ÑƒÐ¿Ð¸Ñ‚ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ¾)',0),(72189,2006,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘á»‹a Ä‘iá»ƒm hÃ ng (truy váº¥n tháº¥t báº¡i)',0),(72190,2006,'af','Geen voorraad plekke gevind. (navraag het misluk)',0),(72191,2006,'ro','Nici un inventar de locaÅ£ii gÄƒsit. (interogare nu a reuÈ™it)',0),(72192,2006,'et','Ei leidnud laoasukohti. (pÃ¤ring nurjus)',0),(72193,2006,'si','Lokacijami inventarja ni naÅ¡el. (poizvedba ni uspela)',0),(72194,2006,'ba','Tidak ada persediaan lokasi ditemukan. (query gagal)',0),(72195,2006,'nl','Geen inventaris locaties gevonden. (query is mislukt)',0),(72196,2006,'fi','Varaston paikkakuntia ei lÃ¶ytynyt. (kysely epÃ¤onnistui)',0),(72197,2006,'no','Fant ingen lagerlokasjoner. (spÃ¸rring mislyktes)',0),(72198,2006,'da','Ingen lokaliteter med beholdning findes. (forespÃ¸rgslen mislykkedes)',0),(72199,2006,'ko','ì•„ë‹ˆ ì¸ë²¤í† ë¦¬ ìœ„ì¹˜ë¥¼ ë°œê²¬ìž…ë‹ˆë‹¤. (ì¿¼ë¦¬ ì‹¤íŒ¨)',0),(72200,2006,'he','×œ× × ×ž×¦××• ×‘×ž×§×•×ž×•×ª ×”×ž×œ××™. (×©××™×œ×ª×ª × ×›×©×œ)',0),(72201,2006,'el','Î”ÎµÎ½ Î¸Î­ÏƒÎµÎ¹Ï‚ ÎµÎ½Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ‰Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½. (ÎµÏÏŽÏ„Î·Î¼Î± Î±Ï€Î­Ï„Ï…Ï‡Îµ)',0),(72202,2006,'zh','æœªå‘çŽ°åº“å­˜åœ°ç‚¹ã€‚ ï¼ˆæŸ¥è¯¢å¤±è´¥ï¼‰\r\n',0),(72203,2006,'sv','Ingen inventarieplatser hittade. (frÃ¥gan misslyckades)',0),(72204,2006,'it','Nessuna localitÃ  inventario trovato. (query non riuscita)',0),(72205,2006,'tl','',0),(72206,2006,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629; (query failed)',0),(72207,2006,'hi','à¤•à¥‹à¤ˆ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤¾à¤¯à¤¾à¥¤ (à¤•à¥à¤µà¥‡à¤°à¥€ à¤µà¤¿à¤«à¤² à¤¹à¥à¤†)',0),(72208,2006,'ms','Tiada lokasi inventori yang ditemui. (pertanyaan gagal)',0),(72209,2006,'ar','Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰. (ÙØ´Ù„ Ø§Ù„Ø§Ø³ØªØ¹Ù„Ø§Ù…)',0),(72210,2006,'fr','Aucun emplacement de l\'inventaire trouvÃ©. (Ã©chouÃ©e de la requÃªte)',0),(72211,2006,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ï¼ˆæ¤œç´¢å¤±æ•—ï¼‰',0),(72212,2006,'pt','NÃ£o hÃ¡ posiÃ§Ãµes de inventÃ¡rio encontrei. (consulta falhada)',0),(72213,2006,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¼ÐµÑÑ‚Ð° Ð½Ðµ Ð½Ð°ÑˆÐµÐ». (ÑÐ±Ð¾Ð¹ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°)',0),(72214,2006,'es','No se encontrÃ³ ningunas Ubicaciones de Inventario',0),(72215,2006,'de','Keine Inventar-Standorte gefunden. (Abfrage fehlgeschlagen)',0),(72216,2006,'en','No inventory locations found. (query failed)',0),(72217,2007,'is','',0),(72218,2007,'dr','Ù‡ÙŠÚ† Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ÙŠÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72219,2007,'pr','Ù‡ÙŠÚ† Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ÙŠÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72220,2007,'tr','Madde kategorileri bulundu.',0),(72221,2007,'pl','Nie znaleziono kategorie towarÃ³w.',0),(72222,2007,'bg','ÐÑÐ¼Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(72223,2007,'ur','Ú©ÙˆØ¦ÛŒ Ø´Û’ Ø²Ù…Ø±Û’ Ù†ÛÛŒÚº Ù…Ù„Û’ Û”',0),(72224,2007,'sr','ÐÐ¸ÑÑƒ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°.',0),(72225,2007,'vi','KhÃ´ng tÃ¬m tháº¥y thá»ƒ loáº¡i hÃ ng ',0),(72226,2007,'af','Geen Item KategoriÃ« gevind.',0),(72227,2007,'ro','Nici un element categorii gÄƒsite.',0),(72228,2007,'et','Kaubakategooriate ei leitud.',0),(72229,2007,'si','Kategorijah artiklov ni naÅ¡el.',0),(72230,2007,'ba','Tidak ditemukan Item Kategori',0),(72231,2007,'nl','Geen artikelcategorieÃ«n gevonden.',0),(72232,2007,'fi','Nimikkeen luokkia ei lÃ¶ytynyt.',0),(72233,2007,'no','Ingen kategorier funnet.',0),(72234,2007,'da','Ingen varekategorier findes.',0),(72235,2007,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” í•­ëª© ë²”ì£¼.',0),(72236,2007,'he','.×œ× × ×ž×¦××• ×¤×¨×™×˜×™ ×§×˜×’×•×¨×™×”',0),(72237,2007,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ ÎµÎ¹Î´ÏŽÎ½ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72238,2007,'zh','æ²¡æœ‰å‘çŽ°é¡¹ç›®ç±»åˆ«ã€‚\r\n',0),(72239,2007,'sv','Ingen artikelkategorier hittade.',0),(72240,2007,'it','Nessuna categoria oggetti trovata.',0),(72241,2007,'tl','',0),(72242,2007,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(72243,2007,'hi','à¤•à¥‹à¤ˆ à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(72244,2007,'ms','Tiada kategori item yang ditemui.',0),(72245,2007,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù„Ø§ ÙØ¦Ø§Øª Ø§Ù„Ø¨Ù†Ø¯.',0),(72246,2007,'fr','Aucune catÃ©gorie d\'Ã©lÃ©ment trouvÃ©.',0),(72247,2007,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72248,2007,'pt','NÃ£o hÃ¡ categorias de item encontradas.',0),(72249,2007,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(72250,2007,'es','No se encontraron categorÃ­as de items',0),(72251,2007,'de','Keine Element-Kategorien gefunden.',0),(72252,2007,'en','No item categories found.',0),(72253,2008,'is','',0),(72254,2008,'dr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72255,2008,'pr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72256,2008,'tr','Ã–ÄŸe bulunamadÄ±.',0),(72257,2008,'pl','Nie znaleziono elementÃ³w.',0),(72258,2008,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸.',0),(72259,2008,'ur','Ú©ÙˆØ¦ÛŒ Ø¢Ø¦Ù¹Ù… Ù†ÛÙŠÚº Ù…Ù„Ø§ Û”',0),(72260,2008,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° Ð½Ð¸Ñ˜ÐµÐ´Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ°.',0),(72261,2008,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ ng ',0),(72262,2008,'af','Geen Items Gevind',0),(72263,2008,'ro','Articole gÄƒsite.',0),(72264,2008,'et','Tooteid ei leitud',0),(72265,2008,'si','Ni najdenih elementov.',0),(72266,2008,'ba','Tidak ada item yang ditemukan.',0),(72267,2008,'nl','Geen items gevonden.',0),(72268,2008,'fi','Kohteita ei lÃ¶ytynyt.',0),(72269,2008,'no','Ingen elementer.',0),(72270,2008,'da','Ingen fundne elementer.',0),(72271,2008,'ko','ì°¾ì€ í•­ëª©ì´ ì—†ìŠµë‹ˆë‹¤.',0),(72272,2008,'he','.×œ× × ×ž×¦××• ×¤×¨×™×˜×™×',0),(72273,2008,'el','Î”ÎµÎ½ Î±Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72274,2008,'zh','äº§å“æœªæ‰¾åˆ°',0),(72275,2008,'sv','Inga artiklar funna.',0),(72276,2008,'it','Nessun oggetto trovato',0),(72277,2008,'tl','',0),(72278,2008,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(72279,2008,'hi','à¤•à¥‹à¤ˆ à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(72280,2008,'ms','Tiada item ditemui.',0),(72281,2008,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¨Ù†ÙˆØ¯',0),(72282,2008,'fr','Aucun Ã©lÃ©ments trouvÃ©s.',0),(72283,2008,'jp','å“?ç›®ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72284,2008,'pt','Nenhum item encontrado.',0),(72285,2008,'ru','Ð¢Ð¾Ð²Ð°Ñ€Ñ‹ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹.',0),(72286,2008,'es','No se encontraron items',0),(72287,2008,'de','Keine EintrÃ¤ge gefunden.',0),(72288,2008,'en','No items found.',0),(72289,2009,'is','',0),(72290,2009,'dr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(72291,2009,'pr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(72292,2009,'tr','SeÃ§ili Ã¶ÄŸe yok.',0),(72293,2009,'pl','Nie wybrano Å¼adnych pozycji.',0),(72294,2009,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸.',0),(72295,2009,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø´ÛŒØ§ Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº Û”',0),(72296,2009,'sr','ÐÐµÐ¼Ð° Ð¾Ð´Ð°Ð±Ñ€Ð°Ð½Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸.',0),(72297,2009,'vi','HÃ ng chÆ°a chá»n',0),(72298,2009,'af','Geen Items Gekies.',0),(72299,2009,'ro','Articole selectate.',0),(72300,2009,'et','Ãœksusi pole valitud.',0),(72301,2009,'si','Ni izbranih elementov.',0),(72302,2009,'ba','Tidak ada item yang dipilih.',0),(72303,2009,'nl','Geen Items geselecteerd.',0),(72304,2009,'fi','Ei ole kohteita.',0),(72305,2009,'no','Ingen elementer.',0),(72306,2009,'da','Ingen markerede elementer.',0),(72307,2009,'ko','ì„ íƒ í•­ëª©ì´ ì—†ìŠµë‹ˆë‹¤.',0),(72308,2009,'he','.×œ× × ×‘×—×¨×• ×¤×¨×™×˜×™×',0),(72309,2009,'el','Î”ÎµÎ½ Î­Ï‡Î¿Ï…Î½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±.',0),(72310,2009,'zh','æœªé€‰å–ä»»ä½•é¡¹ç›®ã€‚\r\n',0),(72311,2009,'sv','Inga objekt Ã¤r markerade.',0),(72312,2009,'it','Nessun oggetto selezionato.',0),(72313,2009,'tl','',0),(72314,2009,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(72315,2009,'hi','à¤•à¥‹à¤ˆ à¤†à¤‡à¤Ÿà¤® à¤šà¤¯à¤¨à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚à¥¤',0),(72316,2009,'ms','Tiada item yang telah dipilih.',0),(72317,2009,'ar','Ù„Ø§ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©.',0),(72318,2009,'fr','Aucun Ã©lÃ©ment sÃ©lectionnÃ©.',0),(72319,2009,'jp','å“?ç›®ã?Œé?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(72320,2009,'pt','Nenhum item selecionado.',0),(72321,2009,'ru','ÐÐµÑ‚ Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð².',0),(72322,2009,'es','No se SeleccionÃ³ Items',0),(72323,2009,'de','Keine Artikel ausgewÃ¤hlt.',0),(72324,2009,'en','No Items Selected.',0),(72325,2010,'is','',0),(72326,2010,'dr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø­Ù„ÙŠ ØªØ¹ÙŠÙ† Ù†Ø´Ø¯Ù‡ ',0),(72327,2010,'pr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø­Ù„ÙŠ ØªØ¹ÙŠÙ† Ù†Ø´Ø¯Ù‡ ',0),(72328,2010,'tr','TanÄ±mlÄ± hiÃ§bir yerel vergiler.',0),(72329,2010,'pl','Nie okreÅ›lono podatkÃ³w lokalnych.',0),(72330,2010,'bg','ÐÑÐ¼Ð° Ð¼ÐµÑÑ‚Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸, Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸.',0),(72331,2010,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ù‚Ø§Ù…ÛŒ Ù¹ÛŒÚ©Ø³ Ù…ØªØ¹ÛŒÙ† Ú©ÛŒØ§ ÛÛ’ Û”',0),(72332,2010,'sr','ÐÐµÐ¼Ð° Ð»Ð¾ÐºÐ°Ð»Ð½Ð¸Ñ… Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð´ÐµÑ„Ð¸Ð½Ð¸ÑÐ°Ð½.',0),(72333,2010,'vi','ChÆ°a Ä‘á»‹nh nghÄ©a thuáº¿ Ä‘á»‹a phÆ°Æ¡ng',0),(72334,2010,'af','Geen plaaslike belasting gedefinieer',0),(72335,2010,'ro','Nici taxele locale definite.',0),(72336,2010,'et','Kohalikud maksud ei mÃ¤Ã¤ratletud.',0),(72337,2010,'si','Ni lokalnih davkov opredeljena.',0),(72338,2010,'ba','Tidak ada pajak lokal yang didefinisikan.',0),(72339,2010,'nl','Geen lokale belastingen gedefinieerd.',0),(72340,2010,'fi','Paikallisia veroja ei ole mÃ¤Ã¤ritetty.',0),(72341,2010,'no','Ingen lokale skatter definert.',0),(72342,2010,'da','Ingen lokale skatter defineret.',0),(72343,2010,'ko','ì•„ë‹ˆ ì§€ë°© ì„¸ ì •ì˜ìž…ë‹ˆë‹¤.',0),(72344,2010,'he','. ××™×Ÿ ×ž×™×¡×™× ×ž×§×•×ž×™×™× ×”×ž×•×’×“×¨×™×.',0),(72345,2010,'el','Î”ÎµÎ½ Ï„Î¿Ï€Î¹ÎºÎ¿ÏÏ‚ Ï†ÏŒÏÎ¿Ï…Ï‚ Ï€Î¿Ï… Î¿ÏÎ¯Î¶ÎµÏ„Î±Î¹.',0),(72346,2010,'zh','æ²¡æœ‰å·²å®šä¹‰çš„åœ°æ–¹ç¨Ž',0),(72347,2010,'sv','Inga lokala skatter definieras.',0),(72348,2010,'it','Nessuna tassa locale definita.',0),(72349,2010,'tl','',0),(72350,2010,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3616;&#3634;&#3625;&#3637;&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;',0),(72351,2010,'hi','à¤•à¥‹à¤ˆ à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤•à¤°à¥‹à¤‚ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾à¥¤',0),(72352,2010,'ms','Tidak ada cukai tempatan yang ditakrifkan.',0),(72353,2010,'ar','Ø£ÙŠ Ø¶Ø±Ø§Ø¦Ø¨ Ù…Ø­Ù„ÙŠØ© Ù…Ø­Ø¯Ø¯Ø©.',0),(72354,2010,'fr','Aucun impÃ´t local dÃ©fini.',0),(72355,2010,'jp','åœ°æ–¹ç¨Žã?Œå®šã‚?ã‚‰ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(72356,2010,'pt','Sem impostos locais definidos.',0),(72357,2010,'ru','ÐÐµ Ð¼ÐµÑÑ‚Ð½Ñ‹Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¸, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð±Ñ‹Ð»Ð¸ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ñ‹.',0),(72358,2010,'es','No se definieron Impuestos locales',0),(72359,2010,'de','Keine lokalen Steuern definiert.',0),(72360,2010,'en','No local taxes defined.',0),(72361,2011,'is','',0),(72362,2011,'dr','Ù‡ÙŠÚ† Ù…Ø­Ù„ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(72363,2011,'pr','Ù‡ÙŠÚ† Ù…Ø­Ù„ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(72364,2011,'tr','Eklenen konum',0),(72365,2011,'pl','Nie lokalizacje dodaje',0),(72366,2011,'bg','ÐÑÐ¼Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ Ð¼ÐµÑÑ‚Ð°',0),(72367,2011,'ur','Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ú©ÙˆØ¦ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(72368,2011,'sr','ÐÐ¸Ñ˜ÐµÐ´Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð¾',0),(72369,2011,'vi','KhÃ´ng thÃªm vá»‹ trÃ­',0),(72370,2011,'af','Geen Ligging bygevoeg',0),(72371,2011,'ro','Nici locaÅ£iile adÄƒugate',0),(72372,2011,'et','Ãœhtki asukohta lisada',0),(72373,2011,'si','Nobena lokacija, doda',0),(72374,2011,'ba','Lokasi tidak ditambahkan',0),(72375,2011,'nl','Geen locatie toegevoegd',0),(72376,2011,'fi','YhtÃ¤Ã¤n sijaintia lisÃ¤tty',0),(72377,2011,'no','Ingen steder lagt',0),(72378,2011,'da','Ingen steder tilfÃ¸jet',0),(72379,2011,'ko','ì•„ë‹ˆ ìœ„ì¹˜ ì¶”ê°€',0),(72380,2011,'he','××™×Ÿ ×ž×™×§×•×ž×™× × ×•×¡×¤×™×',0),(72381,2011,'el','Î”ÎµÎ½ Î¸Î­ÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÏ„Î¯Î¸ÎµÎ½Ï„Î±Î¹',0),(72382,2011,'zh','æ²¡æœ‰æ·»åŠ ä»»ä½•ä½ç½®\r\n',0),(72383,2011,'sv','Inga platser lÃ¤ggs',0),(72384,2011,'it','Nessuna locazione aggiunta',0),(72385,2011,'tl','',0),(72386,2011,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(72387,2011,'hi','à¤•à¥‹à¤ˆ à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾',0),(72388,2011,'ms','Tiada lokasi yang ditambah',0),(72389,2011,'ar','Ù„Ø§ Ø§Ù„Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ù…Ø¶Ø§ÙØ©',0),(72390,2011,'fr','Aucun emplacement ajoutÃ©',0),(72391,2011,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œè¿½åŠ ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(72392,2011,'pt','NÃ£o hÃ¡ locais adicionados',0),(72393,2011,'ru','ÐœÐµÑÑ‚Ð° Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(72394,2011,'es','No se Agregaron Ubicaciones',0),(72395,2011,'de','Keine Speicherorte hinzugefÃ¼gt',0),(72396,2011,'en','No Locations added',0),(72397,2012,'is','',0),(72398,2012,'dr','Ù‡ÙŠÚ† Ù…Ø­Ù„ÙŠ  Ø¯Ø± ÙØ§ÙŠÙ„ ',0),(72399,2012,'pr','Ù‡ÙŠÚ† Ù…Ø­Ù„ÙŠ  Ø¯Ø± ÙØ§ÙŠÙ„ ',0),(72400,2012,'tr','Dosya iÃ§inde konum',0),(72401,2012,'pl','Nie ma miejsca w pliku',0),(72402,2012,'bg','ÐÑÐ¼Ð° Ð¼ÐµÑÑ‚Ð° Ð²ÑŠÐ² Ñ„Ð°Ð¹Ð»',0),(72403,2012,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…Ø³Ù„',0),(72404,2012,'sr','ÐÐ¸Ñ˜ÐµÐ´Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸',0),(72405,2012,'vi','KhÃ´ng vá»‹ trÃ­ trong Há»“ sÆ¡',0),(72406,2012,'af','Geen Liggings in LÃªer',0),(72407,2012,'ro','Nici locaÅ£ii Ã®n dosarul',0),(72408,2012,'et','Ãœhtki asukohta failis',0),(72409,2012,'si','Nobena lokacija v datoteko',0),(72410,2012,'ba','Tidak ada lokasi di File',0),(72411,2012,'nl','Geen locaties in bestand',0),(72412,2012,'fi','YhtÃ¤Ã¤n sijaintia tiedoston',0),(72413,2012,'no','Ingen steder i filen',0),(72414,2012,'da','Ingen steder i fil',0),(72415,2012,'ko','íŒŒì¼ì˜ ì•„ë¬´ ìœ„ì¹˜',0),(72416,2012,'he','××™×Ÿ ×ž×™×§×•×ž×™× ×‘×§×•×‘×¥',0),(72417,2012,'el','Î”ÎµÎ½ Î¸Î­ÏƒÎµÎ¹Ï‚ ÏƒÏ„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(72418,2012,'zh','åœ¨æ–‡ä»¶ä¸­æ²¡æœ‰ä½ç½®\r\n',0),(72419,2012,'sv','Inga platser i filen',0),(72420,2012,'it','Nessuna locazione nel file',0),(72421,2012,'tl','',0),(72422,2012,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3651;&#3609;&#3652;&#3615;&#3621;&#3660;',0),(72423,2012,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤®à¥‡à¤‚ à¤•à¥‹à¤ˆ à¤¸à¥à¤¥à¤¾à¤¨',0),(72424,2012,'ms','Tiada lokasi dalam fail',0),(72425,2012,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…ÙˆØ§Ù‚Ø¹ ÙÙŠ Ø§Ù„Ù…Ù„Ù',0),(72426,2012,'fr','Aucun emplacement de fichier',0),(72427,2012,'jp','ãƒ•ã‚¡ã‚¤ãƒ«å†…ã?«é…?ç½®ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(72428,2012,'pt','NÃ£o hÃ¡ locais no arquivo.',0),(72429,2012,'ru','ÐÐµÑ‚ Ð¼ÐµÑÑ‚Ð° Ð² Ñ„Ð°Ð¹Ð»Ðµ',0),(72430,2012,'es','No hay Ubicaciones en este File',0),(72431,2012,'de','Keine Stellen in Datei',0),(72432,2012,'en','No Locations in File',0),(72433,2013,'is','',0),(72434,2013,'dr','Ù‡ÙŠÚ† Ù…Ø§Ø´ÙŠÙ†ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72435,2013,'pr','Ù‡ÙŠÚ† Ù…Ø§Ø´ÙŠÙ†ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72436,2013,'tr','Makine bulundu.',0),(72437,2013,'pl','Nie znaleziono zadanej maszyny.',0),(72438,2013,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸Ð½Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð¸.',0),(72439,2013,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´ÛŒÙ†ÛŒÚº Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ Û”',0),(72440,2013,'sr','ÐÐµÐ¼Ð° Ð¼Ð°ÑˆÐ¸Ð½Ðµ Ñ˜Ðµ Ð½Ð°ÑˆÐ°Ð¾.',0),(72441,2013,'vi','KhÃ´ng tháº¥y mÃ¡y',0),(72442,2013,'af','Geen masjiene gevind.',0),(72443,2013,'ro','Nici maÅŸini gÄƒsit.',0),(72444,2013,'et','Masinad ei leitud.',0),(72445,2013,'si','Ne stroji, naÅ¡el.',0),(72446,2013,'ba','Tidak ada mesin yang ditemukan.',0),(72447,2013,'nl','Geen machines gevonden.',0),(72448,2013,'fi','Ei koneiden.',0),(72449,2013,'no','Ingen maskiner funnet.',0),(72450,2013,'da','Ingen maskiner fundet.',0),(72451,2013,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” ê¸°ê³„.',0),(72452,2013,'he','×œ× × ×ž×¦××• ×ž×›×©×™×¨×™×',0),(72453,2013,'el','Î”ÎµÎ½ Î¼Î·Ï‡Î±Î½Î­Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72454,2013,'zh','æœªå‘çŽ°æœºã€‚\r\n',0),(72455,2013,'sv','Inga maskiner som finns.',0),(72456,2013,'it','Nessuna macchina trovata.',0),(72457,2013,'tl','',0),(72458,2013,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(72459,2013,'hi','à¤•à¥‹à¤ˆ à¤®à¤¶à¥€à¤¨à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(72460,2013,'ms','Tiada mesin yang ditemui.',0),(72461,2013,'ar','Ø¢Ù„Ø§Øª Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(72462,2013,'fr','Pas trouvÃ©s de machines.',0),(72463,2013,'jp','æ©Ÿæ¢°ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72464,2013,'pt','NÃ£o hÃ¡ mÃ¡quinas encontradas.',0),(72465,2013,'ru','ÐœÐ°ÑˆÐ¸Ð½Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(72466,2013,'es','No se encontraron maquinas',0),(72467,2013,'de','Keine Maschinen gefunden.',0),(72468,2013,'en','No machines found.',0),(72469,2014,'is','',0),(72470,2014,'dr',' ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72471,2014,'pr',' ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72472,2014,'tr','EÅŸleÅŸen fatura bulundu',0),(72473,2014,'pl','ZnaleÅºÄ‡ pasujÄ…ce rachunkÃ³w',0),(72474,2014,'bg','ÐÑÐ¼Ð° ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð°Ñ‰Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸',0),(72475,2014,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø¨Ù„ Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(72476,2014,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(72477,2014,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ³a Ä‘Æ¡n phÃ¹ há»£p ',0),(72478,2014,'af','Geen gepasde rekeninge gevind',0),(72479,2014,'ro','Nicio potrivire facturile gÄƒsit',0),(72480,2014,'et','Ei leidnud vastavaid arveid',0),(72481,2014,'si','Brez ujemanja menice naÅ¡el',0),(72482,2014,'ba','Tagihan tidak cocok ditemukan',0),(72483,2014,'nl','Geen overeenkomende rekeningen gevonden',0),(72484,2014,'fi','Ei lÃ¶ytynyt vastaavia laskuja',0),(72485,2014,'no','Ingen samsvarende regninger funnet',0),(72486,2014,'da','Ingen matchende regninger fundet',0),(72487,2014,'ko','ë°œê²¬ ì—†ìŒ ì¼ì¹˜ ê³„ì‚° ì„œ',0),(72488,2014,'he','×‘×œ×™ ×—×©×‘×•× ×•×ª ×ª×•××ž×•×ª × ×ž×¦××•',0),(72489,2014,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(72490,2014,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„å¸å•\r\n',0),(72491,2014,'sv','Inga matchande rÃ¤kningar hittade',0),(72492,2014,'it','Nessuna transazione corrispondente trovata.',0),(72493,2014,'tl','',0),(72494,2014,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(72495,2014,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤¬à¤¿à¤² à¤®à¤¿à¤²à¤¾',0),(72496,2014,'ms','Bil tiada padanan ditemui',0),(72497,2014,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ÙÙˆØ§ØªÙŠØ± Ù…Ø·Ø§Ø¨Ù‚Ø© ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(72498,2014,'fr','Aucun projet de loi correspondant trouvÃ©',0),(72499,2014,'jp','é?©å?ˆã?™ã‚‹è«‹æ±‚æ›¸ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72500,2014,'pt','Sem contas correspondentes encontradas',0),(72501,2014,'ru','ÐÐµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° Ð½Ð°ÑˆÐ»Ð¸',0),(72502,2014,'es','No se encontraron equivalencias en los recibos',0),(72503,2014,'de','Keine passenden Rechnungen gefunden',0),(72504,2014,'en','No matching bills found',0),(72505,2015,'is','',0),(72506,2015,'dr',' Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72507,2015,'pr',' Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72508,2015,'tr','EÅŸleÅŸen hiÃ§bir bÃ¼tÃ§eleri bulundu.',0),(72509,2015,'pl','Nie ma pasujÄ…cych budÅ¼etÃ³w.',0),(72510,2015,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(72511,2015,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø¨Ø¬Ù¹ Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(72512,2015,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð±ÑƒÑŸÐµÑ‚Ðµ Ð½Ð°ÑˆÐ°Ð¾.',0),(72513,2015,'vi','KhÃ´ng tÃ¬m tháº¥y ngÃ¢n sÃ¡ch phÃ¹ há»£p',0),(72514,2015,'af','Geen passende begrotings gevind.',0),(72515,2015,'ro','Nu bugetele potrivire gÄƒsite.',0),(72516,2015,'et','Vastavaid eelarveid ei leitud.',0),(72517,2015,'si','Brez ujemanja proraÄunov naÅ¡el.',0),(72518,2015,'ba','Tidak ada anggaran pencocokan yang ditemukan.',0),(72519,2015,'nl','Geen overeenkomende begrotingen gevonden.',0),(72520,2015,'fi','Vastaavia budjetteja ei ole lÃ¶ytynyt.',0),(72521,2015,'no','Ingen samsvarende budsjetter funnet.',0),(72522,2015,'da','Ingen matchende budgetter fundet.',0),(72523,2015,'ko','ì—†ìŒ ì¼ì¹˜ í•˜ ì˜ˆì‚° ë°œê²¬ìž…ë‹ˆë‹¤.',0);
INSERT INTO `langdef` VALUES (72524,2015,'he','.×œ× × ×ž×¦××• ×ª×§×¦×™×‘×™× ×ª×•××ž×™×',0),(72525,2015,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72526,2015,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„é¢„ç®—ã€‚\r\n',0),(72527,2015,'sv','Inga matchande budgetar hittade.',0),(72528,2015,'it','Nessun budget corrispondente trovato.',0),(72529,2015,'tl','',0),(72530,2015,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(72531,2015,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤¬à¤œà¤Ÿ à¤®à¤¿à¤² à¤—à¤¯à¤¾à¥¤',0),(72532,2015,'ms','Belanjawan tiada padanan ditemui.',0),(72533,2015,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(72534,2015,'fr','Pas trouvÃ©s les budgets correspondants.',0),(72535,2015,'jp','ä¸€è‡´ã?™ã‚‹äºˆç®—ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72536,2015,'pt','NÃ£o hÃ¡ orÃ§amentos correspondentes encontrados.',0),(72537,2015,'ru','Ð¡Ð¾Ð²Ð¿Ð°Ð´Ð°ÑŽÑ‰Ð¸Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(72538,2015,'es','No se encontraron presupuestos emparejados',0),(72539,2015,'de','Keine passenden Haushalte gefunden.',0),(72540,2015,'en','No matching budgets found.',0),(72541,2016,'is','',0),(72542,2016,'dr','Ú†Ùƒ Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72543,2016,'pr','Ú†Ùƒ Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72544,2016,'tr','EÅŸleÅŸen hiÃ§bir denetimleri bulundu.',0),(72545,2016,'pl','Nie pasujÄ…ce kontroli znaleÅºÄ‡.',0),(72546,2016,'bg','ÐÐµ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(72547,2016,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ú†ÛŒÚ© Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(72548,2016,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð½Ð°ÑˆÐ°Ð¾.',0),(72549,2016,'vi','KhÃ´ng tÃ¬m tháº¥y sÃ©c phÃ¹ há»£p',0),(72550,2016,'af','Geen passende kontroles gevind.',0),(72551,2016,'ro','Nicio potrivire controale gÄƒsite.',0),(72552,2016,'et','Vastavaid kontrolle ei leitud.',0),(72553,2016,'si','Ni ujemajoÄih kontrol naÅ¡el.',0),(72554,2016,'ba','Tidak ada pemeriksaan pencocokan yang ditemukan.',0),(72555,2016,'nl','Geen overeenkomende controles gevonden.',0),(72556,2016,'fi','Ei vastaavia tarkastuksia lÃ¶ytyi.',0),(72557,2016,'no','Ingen samsvarende kontroller funnet.',0),(72558,2016,'da','Ingen matchende kontrol fundet.',0),(72559,2016,'ko','ì¼ì¹˜ ê²€ì‚¬ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(72560,2016,'he','××™×Ÿ ×‘×“×™×§×ª ×”×ª××ž×ª × ×ž×¦××•.',0),(72561,2016,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72562,2016,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„æ£€æŸ¥ã€‚\r\n',0),(72563,2016,'sv','Inga matchande kontroller hittade.',0),(72564,2016,'it','Nessun assegno corrispondente trovato.',0),(72565,2016,'tl','',0),(72566,2016,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3648;&#3594;&#3655;&#3588;',0),(72567,2016,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤šà¥‡à¤• à¤®à¤¿à¤²à¤¾à¥¤',0),(72568,2016,'ms','Tiada pemeriksaan padanan yang ditemui.',0),(72569,2016,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ ØµÙƒÙˆÙƒ Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(72570,2016,'fr','Aucun chÃ¨que correspondant trouvÃ©.',0),(72571,2016,'jp','ä¸€è‡´ã?™ã‚‹å°?åˆ‡æ‰‹ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72572,2016,'pt','Nenhuma verificaÃ§Ã£o de correspondÃªncia encontrada.',0),(72573,2016,'ru','Ð¡Ð¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.',0),(72574,2016,'es','No se encontraron cheques emparejados',0),(72575,2016,'de','Keine passenden Kontrollen gefunden.',0),(72576,2016,'en','No matching checks found.',0),(72577,2017,'is','',0),(72578,2017,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72579,2017,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72580,2017,'tr','HiÃ§bir eÅŸleÅŸen MÃ¼ÅŸteri bulundu',0),(72581,2017,'pl','Klient nie pasujÄ…ce Znalezione',0),(72582,2017,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(72583,2017,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ú©Ø³Ù¹Ù…Ø± Ù¾Ø§ÛŒØ§',0),(72584,2017,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° ÐºÑƒÐ¿Ñ†Ð° Ð½Ð°ÑˆÐ»Ð¸',0),(72585,2017,'vi','KhÃ´ng tÃ¬m tháº¥y khÃ¡ch hÃ ng phÃ¹ há»£p',0),(72586,2017,'af','Geen passende Klant/KliÃ«nt gevind.',0),(72587,2017,'ro','Nici un client potrivire gÄƒsit',0),(72588,2017,'et','Sobivat klienti ei leitud',0),(72589,2017,'si','Brez ujemanja kupec naÅ¡el',0),(72590,2017,'ba','Pelanggan tidak cocok ditemukan',0),(72591,2017,'nl','Geen overeenkomende klant gevonden',0),(72592,2017,'fi','Ei lÃ¶ydy vastaavaa asiakkaan',0),(72593,2017,'no','Ingen samsvarende kunde funnet',0),(72594,2017,'da','Ingen matchende kunde fundet',0),(72595,2017,'ko','ì—†ìŒ ì¼ì¹˜ í•˜ ê³ ê° ë°œê²¬',0),(72596,2017,'he','×œ× × ×ž×¦× ×œ×§×•×— ×ª×•××',0),(72597,2017,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï€ÎµÎ»Î¬Ï„Î·Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(72598,2017,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„å®¢æˆ·\r\n',0),(72599,2017,'sv','Ingen matchande kund hittade',0),(72600,2017,'it','Nessun cliente corrispondente trovato.',0),(72601,2017,'tl','',0),(72602,2017,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(72603,2017,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤¾à¤¯à¤¾',0),(72604,2017,'ms','Pelanggan tiada padanan ditemui',0),(72605,2017,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø²Ø¨ÙˆÙ† ØªÙ†Ø·Ø¨Ù‚ Ø¹Ù„ÙŠÙ‡ Ø§Ù„Ø´Ø±ÙˆØ·',0),(72606,2017,'fr','Aucun client correspondant trouvÃ©',0),(72607,2017,'jp','ä¸€è‡´ã?™ã‚‹é¡§å®¢ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72608,2017,'pt','NÃ£o Ã© um cliente correspondente encontrado',0),(72609,2017,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð½Ð°ÑˆÐ»Ð¸',0),(72610,2017,'es','No se encontrÃ³ cliente emparejado',0),(72611,2017,'de','Kein passender Kunde gefunden',0),(72612,2017,'en','No matching customer found',0),(72613,2018,'is','',0),(72614,2018,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72615,2018,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72616,2018,'tr','EÅŸleÅŸen hiÃ§bir mÃ¼ÅŸteriler bulundu.',0),(72617,2018,'pl','Nie pasujÄ…ce klientÃ³w znalezionych.',0),(72618,2018,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(72619,2018,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ú¯Ø§ÛÚ©ÙˆÚº Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(72620,2018,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° ÐºÑƒÐ¿Ñ†Ð¸ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸.',0),(72621,2018,'vi','KhÃ´ng tÃ¬m tháº¥y khÃ¡ch hÃ ng phÃ¹ há»£p',0),(72622,2018,'af','Geen passende Klante/KliÃ«nte gevind.',0),(72623,2018,'ro','Nicio potrivire clienÅ£ii gÄƒsite.',0),(72624,2018,'et','Sobivaid kliente ei leitud',0),(72625,2018,'si','No ujemanje stranke naÅ¡el.',0),(72626,2018,'ba','Pelanggan tidak cocok ditemukan.',0),(72627,2018,'nl','Geen overeenkomende klanten gevonden.',0),(72628,2018,'fi','Ei vastaavia asiakkaita lÃ¶ytyy.',0),(72629,2018,'no','Ingen samsvarende kunder funnet.',0),(72630,2018,'da','Ingen matchende kunder fundet.',0),(72631,2018,'ko','ì¼ì¹˜ ê³ ê° ë°œê²¬ìž…ë‹ˆë‹¤.',0),(72632,2018,'he','.×œ× × ×ž×¦××• ×œ×§×•×—×•×ª ×ª×•××ž×™×',0),(72633,2018,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72634,2018,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„é¡¾å®¢',0),(72635,2018,'sv','Inga matchande kunder hittade.',0),(72636,2018,'it','Nessun cliente corrispondente trovato.',0),(72637,2018,'tl','',0),(72638,2018,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(72639,2018,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(72640,2018,'ms','Pelanggan tiada padanan ditemui.',0),(72641,2018,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø²Ø¨Ø§Ø¦Ù† ØªÙ†Ø·Ø¨Ù‚ Ø¹Ù„ÙŠÙ‡Ù… Ø§Ù„Ø´Ø±ÙˆØ·',0),(72642,2018,'fr','Pas trouvÃ©s de clients correspondants.',0),(72643,2018,'jp','ä¸€è‡´ã?™ã‚‹é¡§å®¢ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72644,2018,'pt','NÃ£o hÃ¡ clientes correspondÃªncia encontradas.',0),(72645,2018,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð½Ð°ÑˆÐ»Ð¸.',0),(72646,2018,'es','No se encontraron clientes emparejados',0),(72647,2018,'de','Keine passenden Kunden gefunden.',0),(72648,2018,'en','No matching customers found.',0),(72649,2019,'is','',0),(72650,2019,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72651,2019,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72652,2019,'tr','EÅŸleÅŸen hiÃ§bir GL hesap bulunamadÄ±.',0),(72653,2019,'pl','Nie pasujÄ…ce GL kont znaleÅºÄ‡.',0),(72654,2019,'bg','ÐÐµ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ GL Ð±ÑÑ…Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸.',0),(72655,2019,'ur','Ù…Ù„Ø§ Ù…Ø´Ø§Ø¨Û Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(72656,2019,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð“Ð› Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸.',0),(72657,2019,'vi','KhÃ´ng tÃ¬m tháº¥y TK Sá»• CÃ¡i Tá»•ng Há»£p phÃ¹ há»£p',0),(72658,2019,'af','Geen gepasde AG Rekening is gevind.',0),(72659,2019,'ro','Nicio potrivire GL conturi gÄƒsite.',0),(72660,2019,'et','Vastavaid GL kontosid leitud.',0),(72661,2019,'si','Ustreznih GL raÄunov ni mogoÄe najti.',0),(72662,2019,'ba','Ada account GL cocok ditemukan.',0),(72663,2019,'nl','Geen overeenkomende GL accounts gevonden.',0),(72664,2019,'fi','Vastaavia GL tilejÃ¤ lÃ¶ytyi.',0),(72665,2019,'no','Ingen samsvarende GL kontoer funnet.',0),(72666,2019,'da','Ingen matchende GL konti fundet.',0),(72667,2019,'ko','ì¼ì¹˜ GL ê³„ì •ì´ ì—†ëŠ” ë°œê²¬ìž…ë‹ˆë‹¤.',0),(72668,2019,'he','×œ× ×ª×•××ž×•×ª GL ×—×©×‘×•× ×•×ª × ×ž×¦××•.',0),(72669,2019,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72670,2019,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„æ€»å¸å¸æˆ·',0),(72671,2019,'sv','Inga matchande GL konton hittade.',0),(72672,2019,'it','Nessun account GL corrispondente trovato.',0),(72673,2019,'tl','',0),(72674,2019,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(72675,2019,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(72676,2019,'ms','Tiada padanan GL akaun ditemui.',0),(72677,2019,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø­Ø³Ø§Ø¨Ø§Øª Ø£Ø³ØªØ§Ø° Ø¹Ø§Ù… Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(72678,2019,'fr','Aucun compte GL correspondant trouvÃ©.',0),(72679,2019,'jp','é?©å?ˆã?™ã‚‹GLã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72680,2019,'pt','Sem contas GL correspondentes encontradas.',0),(72681,2019,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… GL ÑÑ‡ÐµÑ‚Ð° Ð½Ð°ÑˆÐ»Ð¸.',0),(72682,2019,'es','No se encontraron cuentas de LM emparejadas',0),(72683,2019,'de','Keine passenden GL-Konten, gefunden.',0),(72684,2019,'en','No matching GL accounts found.',0),(72685,2020,'is','',0),(72686,2020,'dr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(72687,2020,'pr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(72688,2020,'tr','EÅŸleÅŸen hiÃ§bir fatura Ã¶demeleri buldum.',0),(72689,2020,'pl','Nie pasujÄ…ce pÅ‚atnoÅ›ci faktury znalezione.',0),(72690,2020,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(72691,2020,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ÛÛ’ Û”',0),(72692,2020,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° ÐºÑšÐ¸Ð³Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð° Ð½Ð°ÑˆÐ°Ð¾.',0),(72693,2020,'vi','KhÃ´ng tÃ¬m tháº¥y thanh toÃ¡n hÃ³a Ä‘Æ¡n phÃ¹ há»£p',0),(72694,2020,'af','Vergesel wees van geen passende faktuur betalings gevind.',0),(72695,2020,'ro','Nicio potrivire plata facturilor gÄƒsite.',0),(72696,2020,'et','Vastavaid arve vÃ¤ljamakseid leitud.',0),(72697,2020,'si','Brez ujemanja raÄun plaÄila naÅ¡el.',0),(72698,2020,'ba','Tidak ada pembayaran tagihan cocok ditemukan.',0),(72699,2020,'nl','Geen overeenkomende factuur betalingen gevonden.',0),(72700,2020,'fi','Vastaavia laskun maksuja ei lÃ¶ytynyt.',0),(72701,2020,'no','Ingen samsvarende faktura betalinger funnet.',0),(72702,2020,'da','Ingen matchende fakturabetalinger fundet.',0),(72703,2020,'ko','ì—†ìŒ ì¼ì¹˜ í•˜ ì²­êµ¬ì„œ ì§€ë¶ˆ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(72704,2020,'he','×ª×©×œ×•×ž×™× ×œ×-×—×©×‘×•× ×™×ª ×ª×•××ž×•×ª × ×ž×¦××•.',0),(72705,2020,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72706,2020,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„å‘ç¥¨ä»˜æ¬¾ã€‚\r\n',0),(72707,2020,'sv','Inga matchande faktura betalningar hittade.',0),(72708,2020,'it','Nessun pagamento di fattura corrispondente trovato.',0),(72709,2020,'tl','',0),(72710,2020,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(72711,2020,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(72712,2020,'ms','Tiada padanan invois bayaran ditemui.',0),(72713,2020,'ar','Ù„Ø§ Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ù…Ø·Ø§Ø¨Ù‚Ø© ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(72714,2020,'fr','Aucun paiement de facture correspondant trouvÃ©.',0),(72715,2020,'jp','ä¸€è‡´ã?™ã‚‹è«‹æ±‚æ›¸æ”¯æ‰•ã?„ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72716,2020,'pt','Sem pagamentos de fatura correspondente encontrados.',0),(72717,2020,'ru','ÐÐµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(72718,2020,'es','No se encontraron pagos de facturas emparejados',0),(72719,2020,'de','Keine passende Rechnung Zahlungen gefunden.',0),(72720,2020,'en','No matching invoice payments found.',0),(72721,2021,'is','',0),(72722,2021,'dr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72723,2021,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72724,2021,'tr','HiÃ§bir eÅŸleÅŸen faturalarÄ±n bulundu',0),(72725,2021,'pl','Nie pasujÄ…ce faktury Znalezione',0),(72726,2021,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(72727,2021,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û ÙˆØ¨Ø¬Ù„ÛŒ Ù¾Ø§ÛŒØ§',0),(72728,2021,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(72729,2021,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ³a Ä‘Æ¡n phÃ¹ há»£p',0),(72730,2021,'af','Geen passende fakture gevind',0),(72731,2021,'ro','Nicio potrivire facturi gÄƒsit',0),(72732,2021,'et','Sobivaid arveid ei leitud',0),(72733,2021,'si','Brez ujemanja raÄunov naÅ¡el',0),(72734,2021,'ba','Faktur tidak cocok ditemukan',0),(72735,2021,'nl','Geen overeenkomende facturen gevonden',0),(72736,2021,'fi','Vastaavia laskuja ei lÃ¶ydy',0),(72737,2021,'no','Ingen samsvarende fakturaer funnet',0),(72738,2021,'da','Ingen matchende fakturaer fundet',0),(72739,2021,'ko','ì—†ìŒ ì¼ì¹˜ í•˜ ì²­êµ¬ì„œ ë°œê²¬',0),(72740,2021,'he','×œ× × ×ž×¦××• ×—×©×‘×•× ×™×•×ª ×ª×•××ž×•×ª',0),(72741,2021,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(72742,2021,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„å‘ç¥¨\r\n',0),(72743,2021,'sv','Inga matchande fakturor hittade',0),(72744,2021,'it','Nessun fatture corrispondenti trovate',0),(72745,2021,'tl','',0),(72746,2021,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(72747,2021,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤ªà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(72748,2021,'ms','Invois tiada padanan ditemui',0),(72749,2021,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(72750,2021,'fr','Aucune facture correspondant trouvÃ©',0),(72751,2021,'jp','é?©å?ˆè«‹æ±‚æ›¸ã?Œã‚¬è¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72752,2021,'pt','NÃ£o hÃ¡ facturas correspondentes encontradas',0),(72753,2021,'ru','Ð¡Ð¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(72754,2021,'es','No se encontraron facturas emparejados',0),(72755,2021,'de','Keine passenden Rechnungen gefunden',0),(72756,2021,'en','No matching invoices found',0),(72757,2022,'is','',0),(72758,2022,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72759,2022,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72760,2022,'tr','EÅŸleÅŸen Ã¶ÄŸe bulunamadÄ±.',0),(72761,2022,'pl','Nie pasujÄ…cych elementÃ³w znalezionych.',0),(72762,2022,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸.',0),(72763,2022,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø§Ø´ÛŒØ§Ø¡ Ù†ÛÛŒÚº Ù…Ù„ÛŒ Û”',0),(72764,2022,'sr','ÐŸÑ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° Ð½Ð¸Ñ˜ÐµÐ´Ð½Ð° Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð°Ñ˜ÑƒÑ›Ð° ÑÑ‚Ð°Ð²ÐºÐ°.',0),(72765,2022,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ ng phÃ¹ há»£p',0),(72766,2022,'af','Geen soortgelyke items gevind.',0),(72767,2022,'ro','Potrivire articole gÄƒsite.',0),(72768,2022,'et','Vastavaid Ã¼ksusi ei leitud.',0),(72769,2022,'si','Ustreznih elementov ni mogoÄe najti.',0),(72770,2022,'ba','Tidak ada item yang cocok ditemukan.',0),(72771,2022,'nl','Geen overeenkomende objecten gevonden.',0),(72772,2022,'fi','Vastineita ei lÃ¶ytynyt.',0),(72773,2022,'no','Ingen samsvarende elementer finnes.',0),(72774,2022,'da','Ingen tilsvarende varer fundet.',0),(72775,2022,'ko','ì—†ìŒ ì¼ì¹˜ í•˜ëŠ” í•­ëª©ì„ ë°œê²¬.',0),(72776,2022,'he','.×œ× × ×ž×¦××• ×¤×¨×™×˜×™× ×ª×•××ž×™×',0),(72777,2022,'el','Î”ÎµÎ½ ÎµÎ½Ï„Î¿Ï€Î¯ÏƒÏ„Î·ÎºÎ±Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72778,2022,'zh','æ²¡æœ‰æ‰¾åˆ°ç¬¦åˆæ¡ä»¶çš„ç‰©å“ã€‚\r\n',0),(72779,2022,'sv','Inga matchande objekt hittades.',0),(72780,2022,'it','Nessun elemento corrispondente trovato.',0),(72781,2022,'tl','',0),(72782,2022,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(72783,2022,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(72784,2022,'ms','Item padanan ditemui.',0),(72785,2022,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ØµÙ†Ø§Ù Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(72786,2022,'fr','Aucun Ã©lÃ©ment correspondant trouvÃ©.',0),(72787,2022,'jp','ä¸€è‡´ã?™ã‚‹å“?ç›®ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72788,2022,'pt','Nenhuma correspondÃªncia itens encontrados.',0),(72789,2022,'ru','Ð¡Ð¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(72790,2022,'es','No se encontraron items emparejados',0),(72791,2022,'de','Keine Ã¼bereinstimmenden Elemente gefunden.',0),(72792,2022,'en','No matching items found.',0),(72793,2023,'is','',0),(72794,2023,'dr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø¨Ø§Ø² Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72795,2023,'pr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø¨Ø§Ø² Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72796,2023,'tr','EÅŸleÅŸen hiÃ§bir aÃ§Ä±k bulunan sipariÅŸ oluÅŸturmak',0),(72797,2023,'pl','Nie moÅ¼na otworzyÄ‡ pasujÄ…ce budowaÄ‡ aby znaleÅºÄ‡',0),(72798,2023,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¸Ð·Ð³Ñ€Ð°Ð´Ð¸Ð¼ Ñ€ÐµÐ´ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(72799,2023,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø§ÙˆÙ¾Ù† ØªØ¹Ù…ÛŒØ± ØªØ±ØªÛŒØ¨ Ù¾Ø§ÛŒØ§',0),(72800,2023,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾Ð¼ Ð¸Ð·Ð³Ñ€Ð°Ð´Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(72801,2023,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng phÃ¹ há»£p',0),(72802,2023,'af','Geen passende oop bou orde gevind',0),(72803,2023,'ro','Nicio potrivire Open construi ordine gÄƒsit',0),(72804,2023,'et','Ãœhtegi sobivat avatud ehitada tellimuse leitud',0),(72805,2023,'si','Brez ujemanja odprto graditi naloga ustanavljati',0),(72806,2023,'ba','Tidak membuka pencocokan membangun urutan yang ditemukan',0),(72807,2023,'nl','Geen overeenkomende Open bouwen volgorde gevonden',0),(72808,2023,'fi','Ei ole vastaavia avoimina rakentaa jÃ¤rjestyksessÃ¤ lÃ¶ytyi',0),(72809,2023,'no','Ingen samsvarende Ã¥pne bygge ordre funnet',0),(72810,2023,'da','Ingen matchende Ã¥bne bygge rÃ¦kkefÃ¸lge fundet',0),(72811,2023,'ko','ì•„ë‹ˆ ì¼ì¹˜ ì˜¤í”ˆ ë¹Œë“œ ìˆœì„œ',0),(72812,2023,'he','××™×Ÿ ×¤×ª×— ×ª×•××ž×•×ª ×œ×‘× ×•×ª ×”×¡×“×¨',0),(72813,2023,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Î±Î½Î¿Î¹ÎºÏ„Î® Î¿Î¹ÎºÎ¿Î´Î¿Î¼Î®ÏƒÎ¿Ï…Î¼Îµ Î»Î±Î³Î¿ÎµÎ¹Î´ÏŽÎ½',0),(72814,2023,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„å¼€æ”¾å¼æž„å»ºé¡ºåº\r\n',0),(72815,2023,'sv','Inga matchande Ã¶ppna bygga ordning hittade',0),(72816,2023,'it','Nessuna corrispondenza aperta costruire ordine trovato',0),(72817,2023,'tl','',0),(72818,2023,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(72819,2023,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤–à¥à¤²à¤¾ à¤ªà¤¾à¤¯à¤¾ à¤•à¥à¤°à¤® à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(72820,2023,'ms','Terbuka sama ada membina perintah yang ditemui',0),(72821,2023,'ar','Ù„Ø§ ÙØªØ­ Ù…Ø·Ø§Ø¨Ù‚Ø© Ø¨Ù†Ø§Ø¡ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(72822,2023,'fr','Aucune contrepartie Open ne Build ordre trouvÃ©',0),(72823,2023,'jp','ä¸€è‡´ã?™ã‚‹ã‚ªãƒ¼ãƒ—ãƒ³çµ„ç«‹æ³¨æ–‡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72824,2023,'pt','Nenhuma correspondÃªncia aberta construir ordem encontrados',0),(72825,2023,'ru','ÐÐµÑ‚ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð¿Ð¾ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°',0),(72826,2023,'es','No se EncontrÃ³ Ordenes de ConstrucciÃ³n que se emparejan',0),(72827,2023,'de','Keine passenden Open Buildreihenfolge gefunden',0),(72828,2023,'en','No Matching Open Build Order Found',0),(72829,2024,'is','',0),(72830,2024,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72831,2024,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72832,2024,'tr','EÅŸleÅŸen hiÃ§bir emir bulundu',0),(72833,2024,'pl','Nie pasujÄ…ce zamÃ³wieÅ„ Znalezione',0),(72834,2024,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(72835,2024,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…Ù„Û’',0),(72836,2024,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(72837,2024,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n hÃ ng phÃ¹ há»£p',0),(72838,2024,'af','Geen \"matching\" bestellings gevind',0),(72839,2024,'ro','Comenzi potrivire gÄƒsit',0),(72840,2024,'et','Vastavaid tellimusi ei leitud',0),(72841,2024,'si','Brez ujemanja naroÄil naÅ¡el',0),(72842,2024,'ba','Tidak ada order yang cocok ditemukan',0),(72843,2024,'nl','Geen overeenkomende orders gevonden',0),(72844,2024,'fi','Vastaavia tilauksia ei lÃ¶ytynyt',0),(72845,2024,'no','Ingen samsvarende ordre funnet',0),(72846,2024,'da','Ingen matchende ordrer fundet',0),(72847,2024,'ko','ì•„ë‹ˆ ì¼ì¹˜ ìˆœì„œ ë°œê²¬',0),(72848,2024,'he','×œ× × ×ž×¦××• ×”×–×ž× ×•×ª ×ª×•××ž×•×ª',0),(72849,2024,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(72850,2024,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„è®¢å•\r\n',0),(72851,2024,'sv','Inga matchande order hittade',0),(72852,2024,'it','Nessun ordine corrispondente trovato',0),(72853,2024,'tl','',0),(72854,2024,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(72855,2024,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤†à¤¦à¥‡à¤¶ à¤ªà¤¾à¤¯à¤¾',0),(72856,2024,'ms','Pesanan Tiada padanan ditemui',0),(72857,2024,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø·Ù„Ø¨ÙŠØ§Øª Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(72858,2024,'fr','Aucune commande correspondant trouvÃ©',0),(72859,2024,'jp','ä¸€è‡´ã?™ã‚‹æ³¨æ–‡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72860,2024,'pt','Nenhuma ordem correspondente encontrado',0),(72861,2024,'ru','Ð¡Ð¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(72862,2024,'es','No se encontraron pedidos emparejados',0),(72863,2024,'de','Keine passende AuftrÃ¤ge gefunden',0),(72864,2024,'en','No matching orders found',0),(72865,2025,'is','',0),(72866,2025,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72867,2025,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72868,2025,'tr','EÅŸleÅŸen hiÃ§bir PO bulundu.',0),(72869,2025,'pl','Nie pasujÄ…cych PO znalezione.',0),(72870,2025,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ PO Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(72871,2025,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ù¾Ùˆ Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(72872,2025,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° ÐŸÐž Ð½Ð°ÑˆÐ°Ð¾.',0),(72873,2025,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n mua hÃ ng phÃ¹ há»£p',0),(72874,2025,'af','Geen passende PO gevind.',0),(72875,2025,'ro','Nu PO potrivire gÄƒsite.',0),(72876,2025,'et','Vastavaid PO ei leitud.',0),(72877,2025,'si','Brez ujemanja pad naÅ¡el.',0),(72878,2025,'ba','PO tidak cocok ditemukan.',0),(72879,2025,'nl','Geen overeenkomende PO gevonden.',0),(72880,2025,'fi','Ei vastaavia PO lÃ¶ytyi.',0),(72881,2025,'no','Ingen samsvarende PO funnet.',0),(72882,2025,'da','Ingen matchende PO fundet.',0),(72883,2025,'ko','ì—†ìŒ ì¼ì¹˜ í•˜ í¬ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(72884,2025,'he','××™×Ÿ ×¤×• ×ª×•××ž×•×ª × ×ž×¦××•.',0),(72885,2025,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ PO Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72886,2025,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„è®¢å•ã€‚\r\n',0),(72887,2025,'sv','Inga matchande PO hittade.',0),(72888,2025,'it','No PO corrispondente trovato.',0),(72889,2025,'tl','',0),(72890,2025,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3605;&#3619;&#3591;&#3585;&#3633;&#3609;',0),(72891,2025,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤ªà¥‹ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(72892,2025,'ms','PO tiada padanan ditemui.',0),(72893,2025,'ar','Ù„Ø§ Ø¨Ùˆ Ù…Ø·Ø§Ø¨Ù‚Ø© ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(72894,2025,'fr','Aucun correspondant PO trouvÃ©.',0),(72895,2025,'jp','é?©å?ˆã?™POã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72896,2025,'pt','NÃ£o PO correspondente encontrado.',0),(72897,2025,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… PO Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.',0),(72898,2025,'es','No se encontrÃ³ OC emparejado',0),(72899,2025,'de','Keine passenden PO gefunden.',0),(72900,2025,'en','No matching PO found.',0),(72901,2026,'is','',0),(72902,2026,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72903,2026,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72904,2026,'tr','EÅŸleÅŸen PO Ã¶ÄŸe bulunamadÄ±.',0),(72905,2026,'pl','Nie pasujÄ…cych elementÃ³w PO znalezione.',0),(72906,2026,'bg','ÐÑÐ¼Ð° PO Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸.',0),(72907,2026,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ù¾Ùˆ Ø§Ø´ÛŒØ§Ø¡ Ù†ÛÛŒÚº Ù…Ù„ÛŒ Û”',0),(72908,2026,'sr','ÐŸÐ¾Ð´ÑƒÐ´Ð°Ñ€Ð½Ð¸ ÐŸÐž Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° Ð½Ð¸Ñ˜ÐµÐ´Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ°.',0),(72909,2026,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ ng trong Ä‘Æ¡n hÃ ng phÃ¹ há»£p',0),(72910,2026,'af','Geen soortgelyke AB items gevind.',0),(72911,2026,'ro','Potrivire PO articole gÄƒsite.',0),(72912,2026,'et','Vastavaid PO Ã¼ksusi ei leitud.',0),(72913,2026,'si','Ustreznih PO elementov ni mogoÄe najti.',0),(72914,2026,'ba','Tidak ada item PO cocok ditemukan.',0),(72915,2026,'nl','Geen overeenkomende PO objecten gevonden.',0),(72916,2026,'fi','PO vastineita ei lÃ¶ytynyt.',0),(72917,2026,'no','Ingen samsvarende PO elementer funnet.',0),(72918,2026,'da','Ingen matchende PO poster fundet.',0),(72919,2026,'ko','ì¼ì¹˜ í¬ í•­ëª©ì´ ì—†ìŠµë‹ˆë‹¤ ë°œê²¬.',0),(72920,2026,'he','××™×Ÿ ×¤×• × ×ž×¦××• ×¤×¨×™×˜×™× ×ª×•××ž×™×.',0),(72921,2026,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ ÎºÎ±Î¹ Î±Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72922,2026,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„è®¢å•é¡¹ç›®ã€‚\r\n',0),(72923,2026,'sv','Inga matchande PO artiklar funna.',0),(72924,2026,'it','No PO gli elementi corrispondenti trovati.',0),(72925,2026,'tl','',0),(72926,2026,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(72927,2026,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤ªà¥‹ à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(72928,2026,'ms','Tiada padanan PO item dijumpai.',0),(72929,2026,'ar','Ù„Ø§ Ø¨Ùˆ Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¹Ù†Ø§ØµØ± Ù…Ø·Ø§Ø¨Ù‚Ø©.',0),(72930,2026,'fr','Aucun Ã©lÃ©ment correspondant ne PO trouvÃ©.',0),(72931,2026,'jp','ä¸€è‡´ã?™ã‚‹ç™ºæ³¨å“?ç›®ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72932,2026,'pt','NÃ£o hÃ¡ itens de PO correspondentes encontrados.',0),(72933,2026,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… PO Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.',0),(72934,2026,'es','No se encontraron items de OC emparejados',0),(72935,2026,'de','Keine passenden PO-EintrÃ¤ge gefunden.',0),(72936,2026,'en','No matching PO items found.',0),(72937,2027,'is','',0),(72938,2027,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72939,2027,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72940,2027,'tr','EÅŸleÅŸen hiÃ§bir POs bulundu.',0),(72941,2027,'pl','Nie pasujÄ…ce POs znalezione.',0),(72942,2027,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ POs Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(72943,2027,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† ÛÛ’ Û”',0),(72944,2027,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° ÐŸÐžÑ Ð½Ð°ÑˆÐ°Ð¾.',0),(72945,2027,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n mua hÃ ng phÃ¹ há»£p',0),(72946,2027,'af','Geen passende POs gevind.',0),(72947,2027,'ro','Nu POs potrivire gÄƒsite.',0),(72948,2027,'et','Vastavaid POs ei leitud.',0),(72949,2027,'si','Brez ujemanja POs naÅ¡el.',0),(72950,2027,'ba','POs tidak cocok ditemukan.',0),(72951,2027,'nl','Geen overeenkomende POs gevonden.',0),(72952,2027,'fi','Ei vastaavia POs lÃ¶ytyi.',0),(72953,2027,'no','Ingen samsvarende POs funnet.',0),(72954,2027,'da','Ingen matchende POs fundet.',0),(72955,2027,'ko','ì•„ë‹ˆ ì¼ì¹˜ POs ë°œê²¬ìž…ë‹ˆë‹¤.',0),(72956,2027,'he','×œ× × ×ž×¦××• POs ×ª×•××ž×•×ª.',0),(72957,2027,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ POs Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(72958,2027,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„é‡‡è´­è®¢å•ã€‚\r\n\r\n',0),(72959,2027,'sv','Inga matchande POs hittade.',0),(72960,2027,'it','No POs corrispondente trovato.',0),(72961,2027,'tl','',0),(72962,2027,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(72963,2027,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ POs à¤ªà¤¾à¤¯à¤¾à¥¤',0),(72964,2027,'ms','Tiada POs padanan yang ditemui.',0),(72965,2027,'ar','Ù„Ø§ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ù…Ø·Ø§Ø¨Ù‚Ø© ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(72966,2027,'fr','Aucune POs correspondants trouvÃ©s.',0),(72967,2027,'jp','é?©å?ˆPOã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(72968,2027,'pt','NÃ£o POs correspondentes encontrados.',0),(72969,2027,'ru','ÐŸÐ¾Ð· Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… Ð½Ð°Ð¹Ñ‚Ð¸.',0),(72970,2027,'es','No se encontraron OCs emparejados',0),(72971,2027,'de','Keine passenden POs gefunden.',0),(72972,2027,'en','No matching POs found.',0),(72973,2028,'is','',0),(72974,2028,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72975,2028,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(72976,2028,'tr','EÅŸleÅŸen hiÃ§bir tÄ±rnak bulundu',0),(72977,2028,'pl','Nie pasujÄ…cych ofert znaleÅºÄ‡',0),(72978,2028,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(72979,2028,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û ÙˆØ§ÙˆÛŒÙ†',0),(72980,2028,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° ÐºÐ¾Ñ˜Ðµ ÑÐµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ',0),(72981,2028,'vi','KhÃ´ng tÃ¬m tháº¥y bÃ¡o giÃ¡ phÃ¹ há»£p',0),(72982,2028,'af','Geen passende aanhalings gevind',0),(72983,2028,'ro','Nu citate potrivire gÄƒsit',0),(72984,2028,'et','Ei leidnud vastavaid hinnapakkumisi',0),(72985,2028,'si','Brez ujemanja narekovaji',0),(72986,2028,'ba','Tanpa tanda kutip pencocokan yang ditemukan',0),(72987,2028,'nl','Geen overeenkomende citaten gevonden',0),(72988,2028,'fi','Ei vastaavia lainauksia lÃ¶ytynyt',0),(72989,2028,'no','Ingen samsvarende sitater funnet',0),(72990,2028,'da','Ingen tilsvarende tilbud fundet',0),(72991,2028,'ko','ë°œê²¬ ì¼ì¹˜ ë”°ì˜´í‘œ',0),(72992,2028,'he','×œ× × ×ž×¦××• ×”×¦×¢×•×ª ×ž×—×™×¨ ×ª×•××ž×•×ª',0),(72993,2028,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(72994,2028,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„æŠ¥ä»·\r\n',0),(72995,2028,'sv','Inga matchande citationstecken hittade',0),(72996,2028,'it','Senza virgolette corrispondente trovati',0),(72997,2028,'tl','',0),(72998,2028,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(72999,2028,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤ªà¤¾à¤¯à¤¾',0),(73000,2028,'ms','Sebut harga tiada padanan yang ditemui',0),(73001,2028,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¹Ø±ÙˆØ¶ Ù…Ø¨Ø¯Ø¦ÙŠØ© Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(73002,2028,'fr','Sans guillemets correspondants trouvÃ©s',0),(73003,2028,'jp','ä¸€è‡´ã?™ã‚‹è¦‹ç©?ã‚‚ã‚Šã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73004,2028,'pt','Sem aspas correspondentes encontradas',0),(73005,2028,'ru','ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¸Ñ ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(73006,2028,'es','No se encontraron cotizaciones emparejados',0),(73007,2028,'de','Keine passenden Angebote gefunden',0),(73008,2028,'en','No matching quotes found',0),(73009,2029,'is','',0),(73010,2029,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(73011,2029,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(73012,2029,'tr','EÅŸleÅŸen hiÃ§bir sevkiyat bulundu.',0),(73013,2029,'pl','Nie pasujÄ…ce przesyÅ‚ek znalezione.',0),(73014,2029,'bg','ÐÐµ ÐºÐ¸Ð±Ñ€Ð¸Ñ‚ Ð¿Ñ€Ð°Ñ‚ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(73015,2029,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û ØªØ±Ø³ÛŒÙ„ Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(73016,2029,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð½Ð°ÑˆÐ°Ð¾.',0),(73017,2029,'vi','KhÃ´ng tÃ¬m tháº¥y chuyáº¿n hÃ ng phÃ¹ há»£p',0),(73018,2029,'af','Geen passende versendings gevind.',0),(73019,2029,'ro','Nicio potrivire transporturile gÄƒsite.',0),(73020,2029,'et','Vastavaid saadetised ei leitud.',0),(73021,2029,'si','Brez ujemanja poÅ¡iljke naÅ¡el.',0),(73022,2029,'ba','Tidak ada pengiriman yang cocok ditemukan.',0),(73023,2029,'nl','Geen overeenkomende zendingen gevonden.',0),(73024,2029,'fi','Vastaavia lÃ¤hetystÃ¤ ei lÃ¶ytynyt.',0),(73025,2029,'no','Ingen samsvarende forsendelser funnet.',0),(73026,2029,'da','Ingen matchende forsendelser fundet.',0),(73027,2029,'ko','ì—†ìŒ ì¼ì¹˜ í•˜ ì¶œí•˜ ëŸ‰ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(73028,2029,'he','××™×Ÿ ×ž×©×œ×•×—×™× ×ª×•××ž×•×ª × ×ž×¦××•.',0),(73029,2029,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Î¿Î¹ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(73030,2029,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„è´§ç‰©ã€‚\r\n',0),(73031,2029,'sv','Inga matchande transporter hittade.',0),(73032,2029,'it','No spedizioni corrispondente trovate.',0),(73033,2029,'tl','',0),(73034,2029,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(73035,2029,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤²à¤¦à¤¾à¤¨ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(73036,2029,'ms','Penghantaran tiada padanan ditemui.',0),(73037,2029,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø´Ø­Ù†Ø§Øª Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(73038,2029,'fr','Aucun envoi correspondant trouvÃ©.',0),(73039,2029,'jp','ä¸€è‡´ã?™ã‚‹é…?é€?ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73040,2029,'pt','Sem carregamentos correspondentes encontrados.',0),(73041,2029,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… Ð³Ñ€ÑƒÐ·Ð¾Ð² Ð½Ð°ÑˆÐ»Ð¸.',0),(73042,2029,'es','No se encontraron envÃ­os emparejados',0),(73043,2029,'de','Keine passenden Sendungen gefunden.',0),(73044,2029,'en','No matching shipments found.',0),(73045,2030,'is','',0),(73046,2030,'dr','_Ø­Ù…Ù„ Ø¨Ù‡_ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(73047,2030,'pr','Ø¢Ø¯Ø±Ø³ _Ø­Ù…Ù„ Ø¨Ù‡_ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(73048,2030,'tr','EÅŸleÅŸen hiÃ§bir gemi adreslerine bulundu.',0),(73049,2030,'pl','Å»aden statek pasujÄ…ce adresy znaleÅºÄ‡.',0),(73050,2030,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð° ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð°Ð´Ñ€ÐµÑÐ¸.',0),(73051,2030,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ù¾ØªØ§ Ø¬Ø§Øª Ù†ÛÛŒÚº Ù…Ù„Û’ Û”',0),(73052,2030,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð±Ñ€Ð¾Ð´Ð° Ð´Ð° Ð°Ð´Ñ€ÐµÑÐµ Ð½Ð¸ÑÑƒ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ðµ.',0),(73053,2030,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘á»‹a chá»‰ chuyá»ƒn hÃ ng phÃ¹ há»£p',0),(73054,2030,'af','Geen passende versending aan adresse gevind.',0),(73055,2030,'ro','Nici o navÄƒ potrivire la adresele de gÄƒsit.',0),(73056,2030,'et','No sobitamine laeva leitud aadressid.',0),(73057,2030,'si','Brez ujemanja ladje naslove mogoÄe najti.',0),(73058,2030,'ba','Tidak ada kapal yang cocok ke alamat yang ditemukan.',0),(73059,2030,'nl','Geen overeenkomende schip naar adressen gevonden.',0),(73060,2030,'fi','Ei ole vastaavaa aluksen lÃ¶ytyvien.',0),(73061,2030,'no','Ingen samsvarende skipet til adresser.',0),(73062,2030,'da','Ingen matchende skib til adresser fundet.',0),(73063,2030,'ko','ì—†ìŒ ì¼ì¹˜ í•˜ ìš´ì†¡ì§€ ì£¼ì†Œ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(73064,2030,'he','. ××™×Ÿ ×¡×¤×™× ×ª ×ª×•××ž×•×ª ×›×ª×•×‘×•×ª ×©× ×ž×¦××•.',0),(73065,2030,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï€Î»Î¿Î¯Î¿ ÏƒÎµ Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(73066,2030,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„æ”¶è´§åœ°å€ã€‚\r\n',0),(73067,2030,'sv','Inga matchande fartyget till adresser hittades.',0),(73068,2030,'it','Nessuna nave corrispondente agli indirizzi trovati.',0),(73069,2030,'tl','',0),(73070,2030,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(73071,2030,'hi','à¤ªà¤¾à¤¯à¤¾ à¤ªà¤¤à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤œà¤¹à¤¾à¤œà¥¤',0),(73072,2030,'ms','Tiada kapal yang sepadan ke alamat-alamat yang ditemui.',0),(73073,2030,'ar','Ø£ÙŠ Ø³ÙÙŠÙ†Ø© Ù…Ø·Ø§Ø¨Ù‚Ø© Ù„Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¹Ù†Ø§ÙˆÙŠÙ†.',0),(73074,2030,'fr','Aucun navire correspondant Ã  des adresses trouvÃ©es.',0),(73075,2030,'jp','ä¸€è‡´ã?™ã‚‹é…?é€?å…ˆä½?æ‰€ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73076,2030,'pt','Nenhum navio correspondente aos endereÃ§os encontrados.',0),(73077,2030,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿Ð¾ Ð½Ð°Ð¹Ð´ÐµÐ½Ð½Ñ‹Ð¼ Ð°Ð´Ñ€ÐµÑÐ°Ð¼.',0),(73078,2030,'es','No se encontraron direcciones de enviar-a  emparejados',0),(73079,2030,'de','Keine passende Schiff an Adressen gefunden.',0),(73080,2030,'en','No matching ship to addresses found.',0),(73081,2031,'is','',0),(73082,2031,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(73083,2031,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(73084,2031,'tr','EÅŸleÅŸen hiÃ§bir satÄ±cÄ±lar buldum.',0),(73085,2031,'pl','Nie ma zgodnych dostawcÃ³w.',0),(73086,2031,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(73087,2031,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û ÙˆÛŒÙ†ÚˆØ±Ø² Ù¾Ø§ÛŒØ§ Û”',0),(73088,2031,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸.',0),(73089,2031,'vi','KhÃ´ng tÃ¬m tháº¥y ngÆ°á»i bÃ¡n phÃ¹ há»£p',0),(73090,2031,'af','Geen soortgelyke verskaffers gevind.',0),(73091,2031,'ro','Nu vÃ¢nzÄƒtorii de potrivire gÄƒsite.',0),(73092,2031,'et','Sobivat tarnijat ei leitud',0),(73093,2031,'si','Brez ujemanja prodajalci naÅ¡el.',0),(73094,2031,'ba','Vendor tidak cocok ditemukan.',0),(73095,2031,'nl','Geen overeenkomende leveranciers gevonden.',0),(73096,2031,'fi','Liity vastaavia toimittajia lÃ¶ytyy.',0),(73097,2031,'no','Ingen samsvarende leverandÃ¸rer funnet.',0),(73098,2031,'da','Ingen matchende leverandÃ¸rer fundet.',0),(73099,2031,'ko','ì—†ìŒ ì¼ì¹˜ ê³µê¸‰ ì—…ì²´ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(73100,2031,'he','.×œ× × ×ž×¦××• ×¡×¤×§×™× ×ª×•××ž×™×',0),(73101,2031,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï€Ï‰Î»Î·Ï„Î­Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(73102,2031,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„ä¾›åº”å•†ã€‚\r\n',0),(73103,2031,'sv','Inga matchande leverantÃ¶rer hittade.',0),(73104,2031,'it','Nessun fornitori corrispondenti trovati.',0),(73105,2031,'tl','',0),(73106,2031,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(73107,2031,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚, à¤ªà¤¾à¤¯à¤¾à¥¤',0),(73108,2031,'ms','Vendor tiada padanan ditemui.',0),(73109,2031,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…ÙˆØ±Ø¯ÙˆÙ† ØªÙ†Ø·Ø¨Ù‚ Ø¹Ù„ÙŠÙ‡Ù… Ø§Ù„Ø´Ø±ÙˆØ·',0),(73110,2031,'fr','Aucun fournisseurs correspondants trouvÃ©s.',0),(73111,2031,'jp','ä¸€è‡´ã?™ã‚‹æ¥­è€…ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73112,2031,'pt','NÃ£o hÃ¡ fornecedores correspondentes encontrados.',0),(73113,2031,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð½Ð°Ð¹Ð´ÐµÐ½Ð½Ñ‹Ñ….',0),(73114,2031,'es','No se encontraron Proveedores emparejados',0),(73115,2031,'de','Keine passenden Anbieter gefunden.',0),(73116,2031,'en','No matching vendors found.',0),(73117,2032,'is','',0),(73118,2032,'dr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠ Ø¨Ø§Ø²ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73119,2032,'pr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠ Ø¨Ø§Ø²ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73120,2032,'tr','AÃ§Ä±k Ã¶ÄŸe bulunamadÄ±.',0),(73121,2032,'pl','Brak elementÃ³w otwarte znaleÅºÄ‡.',0),(73122,2032,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸.',0),(73123,2032,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ú¾Ù„ÛŒ Ø´Û’ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†ÚˆÛŒ',0),(73124,2032,'sr','ÐÐµÐ¼Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ðµ.',0),(73125,2032,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ ng má»Ÿ',0),(73126,2032,'af','Geen oop items gevind.',0),(73127,2032,'ro','Articole deschise gÄƒsite.',0),(73128,2032,'et','Avatud tooteid ei leitud',0),(73129,2032,'si','Ni odprtih najdenih elementov.',0),(73130,2032,'ba','Tidak ada item yang terbuka ditemukan.',0),(73131,2032,'nl','Geen open items gevonden.',0),(73132,2032,'fi','Avaa kohteita ei lÃ¶ytynyt.',0),(73133,2032,'no','Ingen Ã¥pne elementer funnet.',0),(73134,2032,'da','Ingen Ã¥bne elementer fundet.',0),(73135,2032,'ko','ë°œê²¬ ì˜¤í”ˆ í•­ëª©ì´ ì—†ìŠµë‹ˆë‹¤.',0),(73136,2032,'he','.×œ× × ×ž×¦××• ×¤×¨×™×˜×™× ×¤×ª×•×—×™×',0),(73137,2032,'el','Î”ÎµÎ½ Î±Î½Î¿Î¹Ï‡Ï„Î¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(73138,2032,'zh','æ²¡æœ‰æ‰¾åˆ°å¼€æ”¾é¡¹ç›®ã€‚\r\n',0),(73139,2032,'sv','Inga Ã¶ppna objekt hittades.',0),(73140,2032,'it','No Apri elementi trovati.',0),(73141,2032,'tl','',0),(73142,2032,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(73143,2032,'hi','à¤•à¥‹à¤ˆ à¤–à¥à¤²à¥‡ à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(73144,2032,'ms','Tiada item terbuka yang ditemui.',0),(73145,2032,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù„Ø§ Ø¹Ù†Ø§ØµØ± Ù…ÙØªÙˆØ­Ø©.',0),(73146,2032,'fr','Sans ouvrir les Ã©lÃ©ments trouvÃ©s.',0),(73147,2032,'jp','ã‚ªãƒ¼ãƒ—ãƒ³å“?ç›®ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73148,2032,'pt','NÃ£o abrir itens encontrados.',0),(73149,2032,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(73150,2032,'es','No se encontraron items abiertos',0),(73151,2032,'de','Keine offenen Posten gefunden.',0),(73152,2032,'en','No open items found.',0),(73153,2033,'is','',0),(73154,2033,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø²ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73155,2033,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø²ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73156,2033,'tr','HiÃ§bir aÃ§Ä±k sipariÅŸler bulundu.',0),(73157,2033,'pl','Nie zamÃ³wienia otwarte znaleÅºÄ‡.',0),(73158,2033,'bg','ÐÑÐ¼Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(73159,2033,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ú¾Ù„Û’ Ø¢Ø±ÚˆØ±Ø² Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(73160,2033,'sr','ÐÐµÐ¼Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð½Ð°ÑˆÐ°Ð¾.',0),(73161,2033,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n hÃ ng má»Ÿ',0),(73162,2033,'af','Geen oop bestellings gevind.',0),(73163,2033,'ro','Comenzi deschise gÄƒsite.',0),(73164,2033,'et','Avatud tellimusi ei leitud',0),(73165,2033,'si','Brez odprtih naroÄil naÅ¡el.',0),(73166,2033,'ba','Tidak ada perintah yang terbuka ditemukan.',0),(73167,2033,'nl','Geen open orders zijn gevonden.',0),(73168,2033,'fi','Avoimia tilauksia ei lÃ¶ytynyt.',0),(73169,2033,'no','Ingen Ã¥pne ordrer funnet.',0),(73170,2033,'da','Ingen Ã¥bne ordrer fundet.',0),(73171,2033,'ko','ì•„ë‹ˆ ì˜¤í”ˆ ìˆœì„œ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(73172,2033,'he','.×œ× × ×ž×¦××• ×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª',0),(73173,2033,'el','Î”ÎµÎ½ Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(73174,2033,'zh','å‘çŽ°æ²¡æœ‰å¼€æ”¾è®¢å•ã€‚\r\n',0),(73175,2033,'sv','Inga Ã¶ppna order hittade.',0),(73176,2033,'it','Nessun ordini aperti trovati.',0),(73177,2033,'tl','',0),(73178,2033,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(73179,2033,'hi','à¤•à¥‹à¤ˆ à¤–à¥à¤²à¤¾ à¤†à¤¦à¥‡à¤¶ à¤®à¤¿à¤²à¤¾à¥¤',0),(73180,2033,'ms','Tiada pesanan terbuka yang ditemui.',0),(73181,2033,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙˆØ§Ù…Ø± Ù…ÙØªÙˆØ­Ø© ÙˆØ¬Ø¯Øª.',0),(73182,2033,'fr','Aucune commande ouverte trouvÃ©.',0),(73183,2033,'jp','ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73184,2033,'pt','NÃ£o hÃ¡ pedidos abertos encontrados.',0),(73185,2033,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(73186,2033,'es','No se encontraron ordenes abiertos',0),(73187,2033,'de','Keine offenen AuftrÃ¤ge gefunden.',0),(73188,2033,'en','No open orders found.',0),(73189,2034,'is','',0),(73190,2034,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73191,2034,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73192,2034,'tr','Bulunan iÃ§in bir sipariÅŸ yok',0),(73193,2034,'pl','ZamÃ³wienia, nie znaleziono',0),(73194,2034,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(73195,2034,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø§Ø±ÛŒ',0),(73196,2034,'sr','ÐÐ¸ÐºÐ°ÐºÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ° Ð½Ð°ÑˆÐ°Ð¾',0),(73197,2034,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n hÃ ng',0),(73198,2034,'af','Geen Bestellings Gevind',0),(73199,2034,'ro','Comenzi gÄƒsit',0),(73200,2034,'et','Tellimusi ei leitud',0),(73201,2034,'si','Brez naroÄil, najti',0),(73202,2034,'ba','Tidak ada order yang ditemukan',0),(73203,2034,'nl','Geen Orders gevonden',0),(73204,2034,'fi','Tilauksia ei lÃ¶ytynyt',0),(73205,2034,'no','Ingen ordrer funnet',0),(73206,2034,'da','Ingen ordrer fundet',0),(73207,2034,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” ì£¼ë¬¸',0),(73208,2034,'he','×œ× × ×ž×¦××• ×”×–×ž× ×•×ª',0),(73209,2034,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(73210,2034,'zh','å®šå•æœªæ‰¾åˆ°',0),(73211,2034,'sv','Inga order som hittade',0),(73212,2034,'it','Nessun ordine trovato',0),(73213,2034,'tl','',0),(73214,2034,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(73215,2034,'hi','à¤•à¥‹à¤ˆ à¤‘à¤°à¥à¤¡à¤°à¥à¤¸ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(73216,2034,'ms','Tiada perintah yang ditemui',0),(73217,2034,'ar','Ø£ÙˆØ§Ù…Ø± Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(73218,2034,'fr','Aucun ordre trouvÃ©',0),(73219,2034,'jp','æ³¨æ–‡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73220,2034,'pt','Nenhuma ordem encontrada',0),(73221,2034,'ru','ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹*',0),(73222,2034,'es','No se Encontraron Ordenes',0),(73223,2034,'de','Keine AuftrÃ¤ge gefunden',0),(73224,2034,'en','No Orders Found',0),(73225,2035,'is','',0),(73226,2035,'dr','Ø¨Ø¯ÙˆÙ† Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±',0),(73227,2035,'pr','Ø¨Ø¯ÙˆÙ† Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±',0),(73228,2035,'tr','HayÄ±r ÅŸifre',0),(73229,2035,'pl','Bez hasÅ‚a',0),(73230,2035,'bg','Ð‘ÐµÐ· Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(73231,2035,'ur','Ú©ÙˆØ¦ÛŒ Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(73232,2035,'sr','Ð‘ÐµÐ· Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ',0),(73233,2035,'vi','KhÃ´ng máº­t kháº©u',0),(73234,2035,'af','Geen wagwoord',0),(73235,2035,'ro','Nici o parolÄƒ',0),(73236,2035,'et','Puudub salasÃµna',0),(73237,2035,'si','Brez gesla',0),(73238,2035,'ba','Tanpa password',0),(73239,2035,'nl','Geen wachtwoord',0),(73240,2035,'fi','Ei salasanaa',0),(73241,2035,'no','Ingen passord',0),(73242,2035,'da','Ingen adgangskode',0),(73243,2035,'ko','ì•”í˜¸ ì—†ìŒ',0),(73244,2035,'he','××™×Ÿ ×¡×™×¡×ž×”',0),(73245,2035,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(73246,2035,'zh','æ²¡æœ‰å¯†ç \r\n',0),(73247,2035,'sv','Inget lÃ¶senord',0),(73248,2035,'it','Nessuna password',0),(73249,2035,'tl','',0),(73250,2035,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;',0),(73251,2035,'hi','à¤•à¥‹à¤ˆ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡',0),(73252,2035,'ms','Tiada kata laluan',0),(73253,2035,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ ÙƒÙ„Ù…Ø© Ø§Ù„Ø³Ø±',0),(73254,2035,'fr','Aucun mot de passe',0),(73255,2035,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(73256,2035,'pt','Sem senha',0),(73257,2035,'ru','ÐÐµÑ‚ Ð¿Ð°Ñ€Ð¾Ð»Ñ',0),(73258,2035,'es','Ningun Clave',0),(73259,2035,'de','Kein Passwort',0),(73260,2035,'en','No password',0),(73261,2036,'is','',0),(73262,2036,'dr','= 4>Ù‡ÙŠÚ† Ù†ÙˆØ¹ Ù…Ø¹Ø§Ø´ÙŠ  ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡',0),(73263,2036,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚Ù„Ù… = 4>Ù‡ÙŠÚ† Ù†ÙˆØ¹ Ø­Ù‚ÙˆÙ‚ÙŠ  ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡',0),(73264,2036,'tr','<font size=\"4\">Ortada hiÃ§bir Ã¶deme tÃ¼rÃ¼nÃ¼ ayarlama</font>',0),(73265,2036,'pl','<font size=\"4\">Tu jest nie pÅ‚aciÄ‡ typu zestaw</font>',0),(73266,2036,'bg','<font size=\"4\">ÐÐµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ñ‚Ð¸Ð¿ Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐ½</font>',0),(73267,2036,'ur','<font size=\"4\">ÛÛ’ Ú©ÙˆØ¦ÛŒ Ø§Ø¯Ø§ Ù‚Ø³Ù… Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº</font>',0),(73268,2036,'sr','<font size=\"4\">ÐÐµ Ð¿Ð»Ð°Ñ‚Ð¸ Ñ‚Ð¸Ð¿ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½</font>',0),(73269,2036,'vi','KhÃ´ng Ä‘áº·t loáº¡i thanh toÃ¡n',0),(73270,2036,'af','Daar is geen Loontipe Gestel',0),(73271,2036,'ro','<font size=\"4\">Nu existÄƒ nici o plÄƒteascÄƒ tip Set</font>',0),(73272,2036,'et','<font size=\"4\">Ei ei maksa tÃ¼Ã¼p seada</font>',0),(73273,2036,'si','<font size=\"4\">Je ne plaÄa stavek lotiti</font>',0),(73274,2036,'ba','<font size=\"4\">Ada tidak membayar jenis Set</font>',0),(73275,2036,'nl','<font size=\"4\">Er is geen betalen Type instellen</font>',0),(73276,2036,'fi','<font size=\"4\">Ei ole maksu tyyppinÃ¤</font>',0),(73277,2036,'no','<font size=\"4\">Det er ingen betale Type sette</font>',0),(73278,2036,'da','<font size=\"4\">Der er ingen betale Type indstillet</font>',0),(73279,2036,'ko','<font size=\"4\">ì§€ë¶ˆ ì•„ë¬´ í˜•ì‹ ì„¤ì •ìž…ë‹ˆë‹¤.</font>',0),(73280,2036,'he','<font size=\"4\">×™×© ××™×Ÿ ×œ×©×œ× ×œ×”×’×“×™×¨ ×¡×•×’</font>',0),(73281,2036,'el','<font size=\"4\">Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î´ÎµÎ½ Ï€Î»Î·ÏÏŽÏƒÎµÎ¹ Ï„ÏÏ€Î¿Ï… Ï€Î¿Ï…</font>',0),(73282,2036,'zh','æ²¡æœ‰è–ªé…¬ç±»åž‹é›†\r\n',0),(73283,2036,'sv','<font size=\"4\">Det finns ingen betala typ stÃ¤lla</font>',0),(73284,2036,'it','<font size=\"4\">Non non c\'Ã¨ nessun tipo di pagare impostato</font>',0),(73285,2036,'tl','',0),(73286,2036,'th','<font size=4>&#3652;&#3617;&#3656;&#3617;&#3637;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3652;&#3623;&#3657;',0),(73287,2036,'hi','<font size=\"4\">à¤µà¤¹à¤¾à¤ à¤¹à¥ˆ à¤•à¥‹à¤ˆ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¥‡à¤Ÿ</font>',0),(73288,2036,'ms','<font size=\"4\">Terdapat tiada membayar jenis Set</font>',0),(73289,2036,'ar','<font size=\"4\">Ù„Ù… ÙŠÙƒÙ† Ù‡Ù†Ø§Ùƒ Ù„Ø§ \"Ø¯ÙØ¹ ØªØ¹ÙŠÙŠÙ† Ù†ÙˆØ¹\"</font>',0),(73290,2036,'fr','<font size=\"4\">Il n\'y a aucun Type de payer dÃ©fini</font>',0),(73291,2036,'jp','<font size=4>æ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—ã?®è¨­å®šã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(73292,2036,'pt','<font size=\"4\">NÃ£o hÃ¡ nenhum conjunto de tipo pagar</font>',0),(73293,2036,'ru','<font size=\"4\">Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð½Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð½Ð°Ð±Ð¾Ñ€Ð°</font>',0),(73294,2036,'es','<tamaÃ±o de fuente=4>No hay configuraciÃ³n de Tipo de Pago',0),(73295,2036,'de','<font size=\"4\">Es gibt keine Zahlen geben Sie Set</font>',0),(73296,2036,'en','<font size=4>There is no Pay Type Set',0),(73297,2037,'is','',0),(73298,2037,'dr',' Ú†Ùƒ Ù‡Ø§ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73299,2037,'pr',' Ú†Ùƒ Ù‡Ø§ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73300,2037,'tr','Bordro Ã§ek bulundu.',0),(73301,2037,'pl','Nie znaleziono kontroli pÅ‚ac.',0),(73302,2037,'bg','ÐÑÐ¼Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(73303,2037,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©Ø§ Ú†ÛŒÚ© Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ Û”',0),(73304,2037,'sr','ÐÐ¸Ñ˜Ðµ Ð½Ð°ÑˆÐ°Ð¾ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ.',0),(73305,2037,'vi','KhÃ´ng tÃ¬m tháº¥y sÃ©c tráº£ lÆ°Æ¡ng',0),(73306,2037,'af','Geen Loonrol tjeks gevind.',0),(73307,2037,'ro','Nici controale salarizare gÄƒsite.',0),(73308,2037,'et','Leitud tsekke palgal.',0),(73309,2037,'si','Ni payroll kontrol naÅ¡el.',0),(73310,2037,'ba','Tidak ada pemeriksaan penggajian yang ditemukan.',0),(73311,2037,'nl','Geen salarisadministratie controles gevonden.',0),(73312,2037,'fi','Palkkahallinnon tarkastusten ei lÃ¶ytynyt.',0),(73313,2037,'no','Ingen lÃ¸nn sjekker funnet.',0),(73314,2037,'da','Ingen lÃ¸n checks fundet.',0),(73315,2037,'ko','ê¸‰ì—¬ ê²€ì‚¬ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(73316,2037,'he','×”×ž×©×›×•×¨×•×ª ×œ× × ×ž×¦××•.',0),(73317,2037,'el','Î”ÎµÎ½ ÎµÏ€Î¹Ï„Î±Î³Î­Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(73318,2037,'zh','æ²¡æœ‰å‘çŽ°å·¥èµ„æ”¯ç¥¨ã€‚\r\n',0),(73319,2037,'sv','Inga lÃ¶ner kontroller hittade.',0),(73320,2037,'it','Non controlli sui salari trovati.',0),(73321,2037,'tl','',0),(73322,2037,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3648;&#3594;&#3655;&#3588;&#3592;&#3656;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(73323,2037,'hi','à¤•à¥‹à¤ˆ à¤ªà¥‡à¤°à¥‹à¤² à¤šà¥‡à¤• à¤®à¤¿à¤²à¤¾à¥¤',0),(73324,2037,'ms','Tiada cek gaji yang ditemui.',0),(73325,2037,'ar','Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(73326,2037,'fr','Aucun chÃ¨que de paie trouvÃ©.',0),(73327,2037,'jp','çµ¦ä¸Žå°?åˆ‡æ‰‹ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73328,2037,'pt','Sem cheques encontrados.',0),(73329,2037,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.',0),(73330,2037,'es','No se Encontraron Cheques de NÃ³mina',0),(73331,2037,'de','Keine Abrechnung-Kontrollen gefunden.',0),(73332,2037,'en','No payroll checks found.',0),(73333,2038,'is','',0),(73334,2038,'dr','Ù‡ÙŠÚ† Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(73335,2038,'pr','Ù‡ÙŠÚ† Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(73336,2038,'tr','HiÃ§bir bordro dÃ¶nemi iÃ§in bulundu.',0),(73337,2038,'pl','Nie znaleziono okres pÅ‚ac.',0),(73338,2038,'bg','ÐÐµ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°.',0),(73339,2038,'ur','Ú©ÙˆØ¦ÛŒ Ù¾Û’ Ø±ÙˆÙ„ Ù…Ø¯Øª Ú©Û’ Ù„Ø¦Û’ Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(73340,2038,'sr','ÐÐµÐ¼Ð° Ð¿Ð»Ð°Ñ‚Ð° Ñ˜Ðµ Ð½Ð°ÑˆÐ°Ð¾ Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´.',0),(73341,2038,'vi','KhÃ´ng tÃ¬m tháº¥y báº£ng lÆ°Æ¡ng cho giai Ä‘oáº¡n nÃ y',0),(73342,2038,'af','Geen Loonrol gevind vir periode.',0),(73343,2038,'ro','Nici o salarizare gÄƒsit perioadÄƒ.',0),(73344,2038,'et','No palgaarvestuse ajaks leitud.',0),(73345,2038,'si','Ne na izplaÄane plaÄe za obdobje.',0),(73346,2038,'ba','Gaji tidak ditemukan untuk periode.',0),(73347,2038,'nl','Geen loonlijst gevonden voor periode.',0),(73348,2038,'fi','Palkanlaskennan ei lÃ¶ytynyt ajan.',0),(73349,2038,'no','Ingen lÃ¸nn funnet for perioden.',0),(73350,2038,'da','Ingen lÃ¸n fundet for perioden.',0),(73351,2038,'ko','ì•„ë¬´ ê¸‰ì—¬ ê¸°ê°„ì— ëŒ€ í•œ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(73352,2038,'he','××™×Ÿ ×©×›×¨ ×©× ×ž×¦××• ×¢×‘×•×¨ ×”×ª×§×•×¤×”.',0),(73353,2038,'el','Î”ÎµÎ½ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î³Î¹Î± Ï€ÎµÏÎ¯Î¿Î´Î¿.',0),(73354,2038,'zh','æœŸé—´æ²¡æœ‰å‘çŽ°å·¥èµ„ã€‚\r\n',0),(73355,2038,'sv','Ingen lÃ¶n fÃ¶r perioden.',0),(73356,2038,'it','Nessun libro paga trovato per periodo.',0),(73357,2038,'tl','',0),(73358,2038,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(73359,2038,'hi','à¤•à¥‹à¤ˆ à¤ªà¥‡à¤°à¥‹à¤² à¤•à¥€ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾à¥¤',0),(73360,2038,'ms','Tiada gaji yang ditemui bagi tempoh.',0),(73361,2038,'ar','ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª Ù„Ø§ ÙˆØ¬Ø¯Øª Ù„ÙØªØ±Ø©.',0),(73362,2038,'fr','Aucune masse salariale trouve pour la pÃ©riode.',0),(73363,2038,'jp','ã?“ã?®æœŸé–“ã?®äººä»¶è²»ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73364,2038,'pt','Nenhuma folha de pagamento foi encontrada para o perÃ­odo.',0),(73365,2038,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ðµ Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(73366,2038,'es','No se encontrÃ³ la nÃ³mina para el perÃ­odo',0),(73367,2038,'de','Keine Abrechnung fÃ¼r Zeitraum gefunden.',0),(73368,2038,'en','No payroll found for period.',0),(73369,2039,'is','',0),(73370,2039,'dr','Ù‡ÙŠÚ† Ø§Ø³Ù†Ø§Ø¯ÙŠ  Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡',0),(73371,2039,'pr','Ù‡ÙŠÚ† Ø§Ø³Ù†Ø§Ø¯ÙŠ  Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡',0),(73372,2039,'tr','KayÄ±t yayÄ±nlanmÄ±ÅŸtÄ±r.',0),(73373,2039,'pl','Rekordy nie zostaÅ‚y zaksiÄ™gowane.',0),(73374,2039,'bg','ÐÑÐ¼Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸.',0),(73375,2039,'ur','Ú©ÙˆØ¦ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ù¾ÙˆØ³Ù¹ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(73376,2039,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÑÑƒ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸.',0),(73377,2039,'vi','ChÆ°a káº¿t chuyá»ƒn há»“ sÆ¡',0),(73378,2039,'af','Geen Rekords Is Gepos.',0),(73379,2039,'ro','Nu au fost postate.',0),(73380,2039,'et','Kirjeid ei konteeritud.',0),(73381,2039,'si','Ni zapisov, ki so bile knjiÅ¾ene.',0),(73382,2039,'ba','Tidak ada catatan telah diposting.',0),(73383,2039,'nl','Geen Records zijn geboekt.',0),(73384,2039,'fi','Tietueita ei ole lÃ¤hetetty.',0),(73385,2039,'no','Ingen poster er bokfÃ¸rt.',0),(73386,2039,'da','Ingen poster er blevet bogfÃ¸rt.',0),(73387,2039,'ko','ì•„ë¬´ ë ˆì½”ë“œ ê²Œì‹œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(73388,2039,'he','××™×Ÿ ×¨×©×•×ž×•×ª × ×¨×©×ž×•.',0),(73389,2039,'el','Î”ÎµÎ½ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î­Ï‡Î¿Ï…Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¸ÎµÎ¯.',0),(73390,2039,'zh','æ²¡æœ‰è®°å½•è¢«å…¬å¸ƒã€‚\r\n',0),(73391,2039,'sv','Inga poster har bokfÃ¶rts.',0),(73392,2039,'it','Nessun record Ã¨ stato registrato.',0),(73393,2039,'tl','',0),(73394,2039,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;',0),(73395,2039,'hi','à¤•à¥‹à¤ˆ à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¨à¤¹à¥€à¤‚ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(73396,2039,'ms','Tiada rekod telah diposkan.',0),(73397,2039,'ar','Ù„Ù… ÙŠØªÙ… Ù†Ø´Ø± Ø£ÙŠØ© Ø³Ø¬Ù„Ø§Øª.',0),(73398,2039,'fr','Aucun enregistrement n\'ont Ã©tÃ© validÃ©es.',0),(73399,2039,'jp','è¨˜éŒ²ã?Œè¨ˆä¸Šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(73400,2039,'pt','NÃ£o hÃ¡ registros foram postados.',0),(73401,2039,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ Ð±Ñ‹Ð»Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ñ‹.',0),(73402,2039,'es','No Han Sido Asentado Ningunos Records',0),(73403,2039,'de','Keine DatensÃ¤tze wurden verÃ¶ffentlicht.',0),(73404,2039,'en','No Records Have been Posted.',0),(73405,2040,'is','',0),(73406,2040,'dr','Ù‡ÙŠÚ† Ø³Ø·ÙˆØ­ Ù‚ÙŠÙ…ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(73407,2040,'pr','Ù‡ÙŠÚ† Ø³Ø·ÙˆØ­ Ù‚ÙŠÙ…ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(73408,2040,'tr','Fiyat seviyeleri bulundu.',0),(73409,2040,'pl','Nie znaleziono poziomu cen.',0),(73410,2040,'bg','ÐÑÐ¼Ð° Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ñ€Ð°Ð²Ð½Ð¸Ñ‰Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(73411,2040,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­ Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ Û”',0),(73412,2040,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½ Ð±ÐµÐ· Ð½Ð¸Ð²Ð¾Ð° Ñ†ÐµÐ½Ð°.',0),(73413,2040,'vi','ChÆ°a tháº¥y má»©c giÃ¡',0),(73414,2040,'af','Geen prysvlakke gevind.',0),(73415,2040,'ro','Nu nivelurile de preÈ› constatat.',0),(73416,2040,'et','Hinnataset ei leitud.',0),(73417,2040,'si','Ravni cen ni mogoÄe najti.',0),(73418,2040,'ba','Tingkat harga tidak ditemukan.',0),(73419,2040,'nl','Geen prijsniveaus gevonden.',0),(73420,2040,'fi','Hintataso ei lÃ¶ytynyt.',0),(73421,2040,'no','Fant ingen prisnivÃ¥.',0),(73422,2040,'da','Ingen prisniveauer fundet.',0),(73423,2040,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” ê°€ê²© ìˆ˜ì¤€.',0),(73424,2040,'he','×œ× × ×ž×¦××• ×¨×ž×•×ª ×ž×—×™×¨.',0),(73425,2040,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Ï„Î¹Î¼Î­Ï‚.',0),(73426,2040,'zh','æ²¡æœ‰æ‰¾åˆ°ä»·æ ¼æ°´å¹³ã€‚\r\n',0),(73427,2040,'sv','Ingen prisnivÃ¥er hittade.',0),(73428,2040,'it','No livelli di prezzo trovati.',0),(73429,2040,'tl','',0),(73430,2040,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(73431,2040,'hi','à¤•à¥‹à¤ˆ à¤•à¥€à¤®à¤¤ à¤¸à¥à¤¤à¤° à¤ªà¤¾à¤¯à¤¾à¥¤',0),(73432,2040,'ms','Tiada paras harga yang ditemui.',0),(73433,2040,'ar','Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(73434,2040,'fr','Aucun niveau de prix trouvÃ©.',0),(73435,2040,'jp','ä¾¡æ ¼æ°´æº–ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(73436,2040,'pt','NÃ£o hÃ¡ nÃ­veis de preÃ§o encontrados.',0),(73437,2040,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ñ†ÐµÐ½ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(73438,2040,'es','No se encontraron niveles de precios',0),(73439,2040,'de','Keine Preis-Werte festgestellt.',0),(73440,2040,'en','No price levels found.',0),(73441,2041,'is','',0),(73442,2041,'dr','Ù‡ÙŠÚ† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…ØªÙŠ  Ù…Ø´Ø®Øµ Ù†Ø´Ø¯Ù‡',0),(73443,2041,'pr','Ù‡ÙŠÚ† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…ØªÙŠ  Ù…Ø´Ø®Øµ Ù†Ø´Ø¯Ù‡',0),(73444,2041,'tr','Belirtilen fiyat listesi yok',0),(73445,2041,'pl','Nie Cennik okreÅ›lone',0),(73446,2041,'bg','ÐÑÐ¼Ð° Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð° Ð·Ð°Ð´Ð°Ð´ÐµÐ½',0),(73447,2041,'ur','Ø§Ø®ØªØµØ§ØµÛŒ Ú©ÙˆØ¦ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(73448,2041,'sr','ÐÐµÐ¼Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ð½Ð°Ð²ÐµÐ´ÐµÐ½',0),(73449,2041,'vi','ChÆ°a cÃ³ danh sÃ¡ch giÃ¡ cá»¥ thá»ƒ',0),(73450,2041,'af','Geen Pryslys Gespesifiseer',0),(73451,2041,'ro','Nici o listÄƒ de preÅ£uri specificate',0),(73452,2041,'et','Ãœkski nimetatud hinnakiri',0),(73453,2041,'si','Ne cenik doloÄeno',0),(73454,2041,'ba','Tidak ada daftar harga yang ditetapkan',0),(73455,2041,'nl','Geen prijslijst opgegeven',0),(73456,2041,'fi','Ei ole mÃ¤Ã¤ritetty hinnasto',0),(73457,2041,'no','Ingen prisliste angitt',0),(73458,2041,'da','Ingen prislisten angivet',0),(73459,2041,'ko','ì§€ì • ëœ ê°€ê²© ëª©ë¡',0),(73460,2041,'he','×œ× ×”×•×’×“×¨ ×ž×—×™×¨×•×Ÿ',0),(73461,2041,'el','Î”ÎµÎ½ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ Ï€Î¿Ï… ÎºÎ±Î¸Î¿ÏÎ¯Î¶ÎµÏ„Î±Î¹',0),(73462,2041,'zh','æ²¡æœ‰æŒ‡å®šçš„ä»·æ ¼åˆ—è¡¨\r\n',0),(73463,2041,'sv','Ingen prislista som anges',0),(73464,2041,'it','Nessun Listino prezzi specificato',0),(73465,2041,'tl','',0),(73466,2041,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3592;&#3634;&#3632;&#3592;&#3591;',0),(73467,2041,'hi','à¤•à¥‹à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ',0),(73468,2041,'ms','Ada senarai harga yang ditetapkan',0),(73469,2041,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(73470,2041,'fr','Aucune liste de prix spÃ©cifiÃ©e',0),(73471,2041,'jp','ä¾¡æ ¼è¡¨ã?Œç‰¹å®šã?§ã??ã?¾ã?›ã‚“',0),(73472,2041,'pt','Nenhuma lista de preÃ§o especificada',0),(73473,2041,'ru','ÐÐµ ÑƒÐºÐ°Ð·Ð°Ð½ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(73474,2041,'es','No habÃ­a Especificada una Lista de Precios',0),(73475,2041,'de','Keine Preisliste angegeben',0),(73476,2041,'en','No Price List Specified',0),(73477,2042,'is','',0),(73478,2042,'dr','Ù‡ÙŠÚ† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…ØªÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡',0),(73479,2042,'pr','Ù‡ÙŠÚ† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…ØªÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡',0),(73480,2042,'tr','Bulundu hiÃ§ fiyat listesi',0),(73481,2042,'pl','Å»adnych cennikÃ³w Znalezione',0),(73482,2042,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(73483,2042,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(73484,2042,'sr','ÐÐµÐ¼Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐµ Ð½Ð°ÑˆÐ°Ð¾',0),(73485,2042,'vi','ChÆ°a tháº¥y danh sÃ¡ch giÃ¡',0),(73486,2042,'af','Geen pryslys gevind.',0),(73487,2042,'ro','Nu liste de preÅ£uri gÄƒsit',0),(73488,2042,'et','Leitud hinnakirjad',0),(73489,2042,'si','Ne cenik palisada ustanavljati',0),(73490,2042,'ba','Daftar Harga tidak ditemukan',0),(73491,2042,'nl','Geen prijslijsten gevonden',0),(73492,2042,'fi','MitÃ¤Ã¤n hinnastoa lÃ¶ytyi',0),(73493,2042,'no','Ingen prislister funnet',0),(73494,2042,'da','Ingen prislister, fandt',0),(73495,2042,'ko','ì•„ë‹ˆ ê°€ê²©í‘œ ë°œê²¬',0),(73496,2042,'he','×œ× × ×¦××• ×ž×—×™×¨×•× ×™×',0),(73497,2042,'el','Î”ÎµÎ½ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï…Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(73498,2042,'zh','æ²¡æœ‰æ‰¾åˆ°ä»·ç›®è¡¨\r\n',0),(73499,2042,'sv','Inga prislistor som hittade',0),(73500,2042,'it','Listini prezzi non trovati',0),(73501,2042,'tl','',0),(73502,2042,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(73503,2042,'hi','à¤ªà¤¾à¤¯à¤¾ à¤•à¥‹à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(73504,2042,'ms','Ada senarai harga yang terdapat',0),(73505,2042,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„ØªÙŠ ÙˆØ¬Ø¯Øª',0),(73506,2042,'fr','Pas trouvÃ©s de listes de prix',0),(73507,2042,'jp','ä¾¡æ ¼è¡¨ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73508,2042,'pt','NÃ£o hÃ¡ listas de preÃ§os encontradas',0),(73509,2042,'ru','ÐŸÑ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(73510,2042,'es','No se encontraron listas de precios',0),(73511,2042,'de','Keine Preislisten gefunden',0),(73512,2042,'en','No price lists found',0),(73513,2043,'is','',0),(73514,2043,'dr','Ù‡ÙŠÚ† Ø±Ø³ÙŠØ¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(73515,2043,'pr','Ù‡ÙŠÚ† Ø±Ø³ÙŠØ¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(73516,2043,'tr','HiÃ§bir fiÅŸ bu satÄ±cÄ± iÃ§in bulduk.',0),(73517,2043,'pl','Potwierdzenia nie znaleziono dla tego dostawcy.',0),(73518,2043,'bg','ÐÑÐ¼Ð° Ð¿Ð¾ÑÑ‚ÑŠÐ¿Ð»ÐµÐ½Ð¸Ñ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº.',0),(73519,2043,'ur','Ú©ÙˆØ¦ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº Ø§Ø³ ÙˆÛŒÙ†ÚˆØ± Ú©Û’ Ù„Ø¦Û’ Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(73520,2043,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ Ð·Ð° Ð¾Ð²Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°.',0),(73521,2043,'vi','KhÃ´ng tÃ¬m tháº¥y biÃªn nháº­n cá»§a ngÆ°á»i bÃ¡n nÃ y',0),(73522,2043,'af','Geen kwitansies vir hierdie handelaar gevind.',0),(73523,2043,'ro','Nici Ã®ncasÄƒrile gÄƒsit pentru acest furnizor.',0),(73524,2043,'et','Ei laekunud selle hankija puhul.',0),(73525,2043,'si','Brez prejemkov za tega dobavitelja.',0),(73526,2043,'ba','Penerimaan tidak ditemukan untuk Penjual ini.',0),(73527,2043,'nl','Geen ontvangsten gevonden voor deze leverancier.',0),(73528,2043,'fi','Ei ole vastaanottoja lÃ¶ytynyt tÃ¤lle toimittajalle.',0),(73529,2043,'no','Ingen mottak funnet for denne leverandÃ¸ren.',0),(73530,2043,'da','Ingen kvitteringer fundet for denne kreditor.',0),(73531,2043,'ko','ì•„ë¬´ ì˜ìˆ˜ì¦ì´ ê³µê¸‰ì´ ì—…ì²´ì— ëŒ€ í•œ ë°œê²¬.',0),(73532,2043,'he','×§×‘×œ×•×ª ××™×Ÿ ×œ×ž×¦×•× ×¢×‘×•×¨ ×¡×¤×§ ×–×”.',0),(73533,2043,'el','Î‘Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®.',0),(73534,2043,'zh','æ²¡æœ‰æ‰¾åˆ°è¯¥ä¾›åº”å•†çš„ç¥¨æ®ã€‚\r\n',0),(73535,2043,'sv','Inga kvitton finns fÃ¶r den hÃ¤r leverantÃ¶ren.',0),(73536,2043,'it','Nessun entrate trovate per questo fornitore.',0),(73537,2043,'tl','',0),(73538,2043,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3619;&#3634;&#3618;&#3609;&#3637;&#3',0),(73539,2043,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(73540,2043,'ms','Resit tidak ditemui untuk penjual ini.',0),(73541,2043,'ar','Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù„Ø§ Ø¥ÙŠØµØ§Ù„Ø§Øª Ù„Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ±Ø¯.',0),(73542,2043,'fr','Aucun reÃ§u nâ€™est trouvÃ© pour ce fournisseur.',0),(73543,2043,'jp','ã?“ã?®æ¥­è€…ã?®é ˜å?Žæ›¸ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(73544,2043,'pt','NÃ£o hÃ¡ recibos encontraram para este fornecedor.',0),(73545,2043,'ru','ÐÐµÑ‚ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸, Ð½Ð°Ð¹Ð´ÐµÐ½Ð½Ñ‹Ñ… Ð´Ð»Ñ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°.',0),(73546,2043,'es','No se encontraron Recibos para este Proveedor',0),(73547,2043,'de','Keine Belege fÃ¼r diesen Lieferanten gefunden.',0),(73548,2043,'en','No Receipts found for this vendor.',0),(73549,2044,'is','',0),(73550,2044,'dr','(Ø¯ÙØ§ØªØ±) Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(73551,2044,'pr','Ù‡ÙŠÚ† Ø§Ø³Ù†Ø§Ø¯ÙŠ (Ø¯ÙØ§ØªØ±) Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(73552,2044,'tr','KayÄ±t bulunamadÄ±.',0),(73553,2044,'pl','Nie znaleziono Å¼adnych zasobÃ³w.',0),(73554,2044,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸.',0),(73555,2044,'ur','Ú©ÙˆØ¦ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ù†ÛÛŒÚº Ù…Ù„Ø§ ÛÛ’ Û”',0),(73556,2044,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð¸ÑÑƒ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð¸.',0),(73557,2044,'vi','KhÃ´ng tháº¥y há»“ sÆ¡',0),(73558,2044,'af','Geen Rekord Gevind.',0),(73559,2044,'ro','Nu s-au gasit inregistrari',0),(73560,2044,'et','Kirjeid ei leitud.',0),(73561,2044,'si','Ni najdenih zapisov.',0),(73562,2044,'ba','Tidak ada catatan ditemukan.',0),(73563,2044,'nl','Geen Records gevonden.',0),(73564,2044,'fi','Tietueita ei lÃ¶ytynyt.',0),(73565,2044,'no','Finner ingen poster.',0),(73566,2044,'da','Ingen poster fundet.',0),(73567,2044,'ko','ì°¾ì„ ë ˆì½”ë“œê°€ ì—†ìŠµë‹ˆë‹¤.',0),(73568,2044,'he','.×œ× × ×ž×¦××• ×¨×©×•×ž×•×ª',0),(73569,2044,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚.',0),(73570,2044,'zh','æ²¡æœ‰æ‰¾åˆ°è®°å½•ã€‚\r\n',0),(73571,2044,'sv','Hittade inga poster.',0),(73572,2044,'it','Nessun record trovato.',0),(73573,2044,'tl','',0),(73574,2044,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(73575,2044,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(73576,2044,'ms','Tiada rekod ditemui.',0),(73577,2044,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø³Ø¬Ù„Ù‘Ø§Øª',0),(73578,2044,'fr','Aucun enregistrement trouvÃ©.',0),(73579,2044,'jp','è¨˜éŒ²ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(73580,2044,'pt','Nenhum Registro Encontrado',0),(73581,2044,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(73582,2044,'es','No se Encontraron Records',0),(73583,2044,'de','Keine DatensÃ¤tze gefunden.',0),(73584,2044,'en','No Records Found.',0),(73585,2045,'is','',0),(73586,2045,'dr','Ù‡ÙŠÚ† Ø§Ø³Ù†Ø§Ø¯ÙŠ Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ Ø¨ÙˆØ¯ ',0),(73587,2045,'pr','Ù‡ÙŠÚ† Ø§Ø³Ù†Ø§Ø¯ÙŠ Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ Ø¨ÙˆØ¯ ',0),(73588,2045,'tr','KayÄ±t gÃ¶nderildi.',0),(73589,2045,'pl','Rekordy nie zostaÅ‚y zaksiÄ™gowane.',0),(73590,2045,'bg','ÐÑÐ¼Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸.',0),(73591,2045,'ur','Ú©ÙˆØ¦ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ ØªØ¹ÛŒÙ†Ø§Øª Ø±ÛÛ’ ØªÚ¾Û’ Û”',0),(73592,2045,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÑÑƒ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸.',0),(73593,2045,'vi','Há»“ sÆ¡ chÆ°a káº¿t chuyá»ƒn',0),(73594,2045,'af','Geen Rekords was gepos.',0),(73595,2045,'ro','Nu au fost postate.',0),(73596,2045,'et','No Records on konteeritud.',0),(73597,2045,'si','Ni zapisov, ki so bile knjiÅ¾ene.',0),(73598,2045,'ba','Tidak ada catatan yang diposting.',0),(73599,2045,'nl','Geen Records werden geplaatst.',0),(73600,2045,'fi','YhtÃ¤Ã¤n tietuetta ei kirjattu.',0),(73601,2045,'no','Ingen poster ble bokfÃ¸rt.',0),(73602,2045,'da','Ingen poster blev bogfÃ¸rt.',0),(73603,2045,'ko','ë ˆì½”ë“œê°€ ê²Œì‹œ ëœ í–ˆë‹¤.',0),(73604,2045,'he','××™×Ÿ ×¨×™×©×•×ž×™ ×¤×•×¨×¡×ž×•.',0),(73605,2045,'el','Î”ÎµÎ½ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®Î¸Î·ÎºÎ±Î½.',0),(73606,2045,'zh','æ²¡æœ‰è®°å½•è¢«å…¬å¸ƒã€‚\r\n',0),(73607,2045,'sv','Inga poster bokfÃ¶rts.',0),(73608,2045,'it','Nessun record sono stato postato.',0),(73609,2045,'tl','',0),(73610,2045,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;',0),(73611,2045,'hi','à¤•à¥‹à¤ˆ à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¤à¥ˆà¤¨à¤¾à¤¤ à¤¥à¥‡à¥¤',0),(73612,2045,'ms','Tiada rekod diposkan.',0),(73613,2045,'ar','ÙˆÙ‚Ø¯ Ù†Ø´Ø±Øª Ø£ÙŠØ© Ø³Ø¬Ù„Ø§Øª.',0),(73614,2045,'fr','Aucun enregistrement n\'ont Ã©tÃ© affichÃ©s.',0),(73615,2045,'jp','è¨˜éŒ²ã?Œè¨ˆä¸Šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(73616,2045,'pt','NÃ£o hÃ¡ registros foram postados.',0),(73617,2045,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ Ð±Ñ‹Ð»Ð¸ Ð¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ñ‹.',0),(73618,2045,'es','No se asentaron los Records',0),(73619,2045,'de','Keine EintrÃ¤ge gepostet wurden.',0),(73620,2045,'en','No Records were posted.',0),(73621,2046,'is','',0),(73622,2046,'dr','Ù‡ÙŠÚ† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø¨Ø§ Ø¬Ø³ØªØ¬Ùˆ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ù†ÙŠØ³Øª ',0),(73623,2046,'pr','Ù‡ÙŠÚ† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø¨Ø§ Ø¬Ø³ØªØ¬Ùˆ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ù†ÙŠØ³Øª ',0),(73624,2046,'tr','HiÃ§ gÃ¶rÃ¼ÅŸ aramanÄ±zla eÅŸleÅŸen.',0),(73625,2046,'pl','Nie Opinie zgodne Szukaj.',0),(73626,2046,'bg','ÐÑÐ¼Ð° Ð¾Ñ‚Ð·Ð¸Ð²Ð¸ Ð¼Ð°Ñ‡ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ.',0),(73627,2046,'ur','Ú©ÙˆØ¦ÛŒ Ø¬Ø§Ø¦Ø²Û ØªÙ„Ø§Ø´ Ú©ÛŒ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº Û”',0),(73628,2046,'sr','ÐÐµÐ¼Ð° ÐºÑ€Ð¸Ñ‚Ð¸ÐºÐµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐ° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ð¾Ð¼.',0),(73629,2046,'vi','KhÃ´ng tháº¥y Ä‘Ã¡nh giÃ¡ phÃ¹ há»£p',0),(73630,2046,'af','Geen resensies pas soektog.',0),(73631,2046,'ro','ClienÅ£ilor nu se potrivesc cÄƒutÄƒrii.',0),(73632,2046,'et','Otsingule ei vasta Ã¼htegi arvustust.',0),(73633,2046,'si','Iskanju ne ustreza noben gostov.',0),(73634,2046,'ba','Tidak ada ulasan cocok dengan pencarian.',0),(73635,2046,'nl','Geen beoordelingen overeenkomen met de zoekopdracht.',0),(73636,2046,'fi','Ei arvosteluja ottelu haku.',0),(73637,2046,'no','Ingen anmeldelser samsvarer med sÃ¸ket.',0),(73638,2046,'da','Ingen anmeldelser matcher sÃ¸gning.',0),(73639,2046,'ko','ê²€í†  ì—†ìŒ ê²€ìƒ‰ì„ ì¼ì¹˜í•©ë‹ˆë‹¤.',0),(73640,2046,'he','××™×Ÿ ×”×“×¢×ª ×ª×•××ž×ª ×—×™×¤×•×©.',0),(73641,2046,'el','Î£Ï‡ÏŒÎ»Î¹Î± Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Î¼Îµ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·.',0),(73642,2046,'zh','æ²¡æœ‰å¤æŸ¥åŒ¹é…æœç´¢ã€‚\r\n',0),(73643,2046,'sv','Inga recensioner matchar sÃ¶kningen.',0),(73644,2046,'it','Nessuna recensione corrispondono alla ricerca.',0),(73645,2046,'tl','',0),(73646,2046,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3652;&#3617;&#3656;&#3614;&#3610;',0),(73647,2046,'hi','à¤•à¥‹à¤ˆ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤–à¥‹à¤œ à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¤à¥‡à¥¤',0),(73648,2046,'ms','Tiada Ulasan yang padan dengan carian.',0),(73649,2046,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ù„Ø§ ØªØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ø§Ù„Ø¨Ø­Ø«.',0),(73650,2046,'fr','Aucun avis ne correspondant recherche.',0),(73651,2046,'jp','æ¤œç´¢ã?«ä¸€è‡´ã?™ã‚‹ãƒ¬ãƒ“ãƒ¥ãƒ¼ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(73652,2046,'pt','Sem comentÃ¡rios coincidir com a pesquisa.',0),(73653,2046,'ru','ÐÐµÑ‚ Ð¾Ñ‚Ð·Ñ‹Ð²Ð¾Ð² ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‚ Ð¿Ð¾Ð¸ÑÐºÐ°.',0),(73654,2046,'es','No hay revisiones que emparejan la busqueda',0),(73655,2046,'de','Suche lieferte keine Bewertungen.',0),(73656,2046,'en','No reviews match search.',0),(73657,2047,'is','',0),(73658,2047,'dr',': ÛŒÙˆØ²Ø± Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø±Ø§ Ù†Ø¯Ø§Ø±Ø¯ ',0),(73659,2047,'pr','Ø¹Ø¯Ù… ØµÙ„Ø§Ø­ÙŠØª Ù†Ø³Ø¨Øª Ø¨Ù‡ Ø´Ø±ÙƒØª: ÙƒØ§Ø±Ø¨Ø± Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø±Ø§ Ù†Ø¯Ø§Ø±Ø¯ ',0),(73660,2047,'tr','KullanÄ±cÄ±nÄ±n bu ÅŸirket iÃ§in eriÅŸim yok',0),(73661,2047,'pl','UÅ¼ytkownik nie ma dostÄ™pu do tej firmy',0),(73662,2047,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ð½ÑÐ¼Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ñ‚Ð°Ð·Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(73663,2047,'ur','ØµØ§Ø±Ù Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ø­Ø§ØµÙ„ Ù†ÛÛŒÚº ÛÛ’',0),(73664,2047,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð½ÐµÐ¼Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¾Ð²Ð¾Ñ˜ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð¸',0),(73665,2047,'vi','User khÃ´ng cÃ³ quyá»n truy cáº­p vÃ o cÃ´ng ty nÃ y',0),(73666,2047,'af','Gebruiker het nie toegang tot hierdie onderneming nie',0),(73667,2047,'ro','Utilizatorul nu are acces la aceasta companie',0),(73668,2047,'et','Selle ettevÃµtte jaoks puuduvad Ãµigused',0),(73669,2047,'si','Uporabnik nima dostopa do te druÅ¾be',0),(73670,2047,'ba','Pengguna tidak memiliki akses untuk perusahaan ini',0),(73671,2047,'nl','Gebruiker heeft geen toegang tot dit bedrijf',0),(73672,2047,'fi','KÃ¤yttÃ¤jÃ¤llÃ¤ ei ole pÃ¤Ã¤syÃ¤ tÃ¤mÃ¤n yrityksen',0),(73673,2047,'no','Brukeren har ikke tilgang til dette selskapet',0),(73674,2047,'da','Brugeren har ikke adgang til denne virksomhed',0),(73675,2047,'ko','ì‚¬ìš©ìžê°€ì´ íšŒì‚¬ì— ì•¡ì„¸ìŠ¤í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(73676,2047,'he','×œ×ž×©×ª×ž×© ××™×Ÿ ×’×™×©×” ×œ×—×‘×¨×” ×–×•',0),(73677,2047,'el','Î§ÏÎ®ÏƒÏ„Î·Ï‚ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÏ„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î®',0),(73678,2047,'zh','ç”¨æˆ·æ²¡æœ‰è®¿é—®è¯¥å…¬å¸\r\n',0),(73679,2047,'sv','AnvÃ¤ndaren har inte tillgÃ¥ng till detta fÃ¶retag',0),(73680,2047,'it','Utente non dispone dell\'accesso a questa societÃ ',0),(73681,2047,'tl','',0),(73682,2047,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3609;&#3637;&#3657;&#3652;&#3604;&#3657;',0),(73683,2047,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¹à¥à¤à¤š à¤•à¥‡ à¤ªà¤¾à¤¸ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(73684,2047,'ms','Pengguna tidak mempunyai akses ke Syarikat ini',0),(73685,2047,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù„ÙŠØ³ Ù„Ø¯ÙŠÙ‡ Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(73686,2047,'fr','L\'utilisateur n\'a pas accÃ¨s Ã  cette sociÃ©tÃ©',0),(73687,2047,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?¯ã?“ã?®ä¼šç¤¾ã?¸ã?®ã‚¢ã‚¯ã‚»ã‚¹ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(73688,2047,'pt','UsuÃ¡rio nÃ£o tem acesso a esta empresa',0),(73689,2047,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð½Ðµ Ð¸Ð¼ÐµÐµÑ‚ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ðº Ð´Ð°Ð½Ð½Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(73690,2047,'es','Usuario no tiene acceso a esta empresa',0),(73691,2047,'de','Benutzer keinen Zugriff auf diese Firma',0),(73692,2047,'en','User does not have access to this company',0),(73693,2048,'is','',0),(73694,2048,'dr','Ù‡ÙŠÚ† Ú¯Ø²ÙŠÙ†Ø´ÙŠ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯Ù‡ ',0),(73695,2048,'pr','Ù‡ÙŠÚ† Ú¯Ø²ÙŠÙ†Ø´ÙŠ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯Ù‡ ',0),(73696,2048,'tr','SeÃ§im yapÄ±ldÄ±.',0),(73697,2048,'pl','WybÃ³r nie zostaÅ‚ zÅ‚oÅ¼ony.',0),(73698,2048,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ð¾Ñ€ Ðµ Ð±Ð¸Ð» Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÐ½.',0),(73699,2048,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(73700,2048,'sr','ÐÐµÐ¼Ð° Ð¸Ð·Ð±Ð¾Ñ€ Ñ˜Ðµ Ð½Ð°Ð¿Ñ€Ð°Ð²Ñ™ÐµÐ½.',0),(73701,2048,'vi','ChÆ°a lá»±a chá»n',0),(73702,2048,'af','Geen Seleksies Is Gemaak.',0),(73703,2048,'ro','Nicio selecÅ£ie a fost fÄƒcutÄƒ.',0),(73704,2048,'et','Ãœkski valik on tehtud.',0),(73705,2048,'si','Izbor je bil doseÅ¾en.',0),(73706,2048,'ba','Tidak ada pilihan telah dibuat.',0),(73707,2048,'nl','Geen selectie is gemaakt.',0),(73708,2048,'fi','Ei ole valinnan.',0),(73709,2048,'no','Ingen valg er gjort.',0),(73710,2048,'da','Ingen valg er blevet gjort.',0),(73711,2048,'ko','ì•„ë‹ˆ ì„ íƒì´ í–ˆë‹¤.',0),(73712,2048,'he','×”×‘×—×™×¨×” ×œ× ×‘×•×¦×¢.',0),(73713,2048,'el','ÎˆÏ‡ÎµÎ¹ Î³Î¯Î½ÎµÎ¹ ÎºÎ±Î¼Î¯Î± ÎµÏ€Î¹Î»Î¿Î³Î®.',0),(73714,2048,'zh','æ²¡æœ‰é€‰æ‹©å·²ç»å½¢æˆã€‚\r\n',0),(73715,2048,'sv','Inget val har gjorts.',0),(73716,2048,'it','Ãˆ stata effettuata alcuna selezione.',0),(73717,2048,'tl','',0),(73718,2048,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3607;&#3637;&#3656;&#3626;&#3619;&#3657;&#3634;&#3591;&#3586;&#3638;&#3657;&#3609;',0),(73719,2048,'hi','à¤•à¥‹à¤ˆ à¤šà¤¯à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(73720,2048,'ms','Tiada pilihan telah dibuat.',0),(73721,2048,'ar','ÙˆÙ‚Ø¯ Ø£Ø­Ø±Ø² Ø¹Ø¯Ù… Ø§Ù„ØªØ­Ø¯ÙŠØ¯.',0),(73722,2048,'fr','Aucune sÃ©lection n\'a Ã©tÃ© effectuÃ©e.',0),(73723,2048,'jp','é?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(73724,2048,'pt','NÃ£o foi feita nenhuma seleÃ§Ã£o.',0),(73725,2048,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ ÐÐµ Ð‘Ñ‹Ð» Ð¡Ð´ÐµÐ»Ð°Ð½.',0),(73726,2048,'es','No Ha Sido Ninguna SelecciÃ³n',0),(73727,2048,'de','Keine Auswahl erzielt worden.',0),(73728,2048,'en','No Selection Has Been Made.',0),(73729,2049,'is','',0),(73730,2049,'dr','Ù‡ÙŠÚ† Ø§Ø¸Ù‡Ø§Ø± Ù†Ø§Ù…Ù‡ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ØªØ¹Ø±ÙŠÙ Ù†Ø´Ø¯Ù‡ ',0),(73731,2049,'pr','Ù‡ÙŠÚ† Ø§Ø¸Ù‡Ø§Ø± Ù†Ø§Ù…Ù‡ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ØªØ¹Ø±ÙŠÙ Ù†Ø´Ø¯Ù‡ ',0),(73732,2049,'tr','TanÄ±mlanan devlet vergi yok.',0),(73733,2049,'pl','Nie okreÅ›lono podatkÃ³w paÅ„stwowych.',0),(73734,2049,'bg','ÐÐµ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð½Ð¸Ñ‚Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ€Ð°Ð½Ð¸.',0),(73735,2049,'ur','Ú©ÙˆØ¦ÛŒ Ø±ÛŒØ§Ø³ØªÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª Û”',0),(73736,2049,'sr','ÐÐµÐ¼Ð° Ð´ÐµÑ„Ð¸Ð½Ð¸ÑÐ°Ð½Ð¸Ñ… Ð´Ñ€Ð¶Ð°Ð²Ð½Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ðµ.',0),(73737,2049,'vi','ChÆ°a Ä‘á»‹nh nghÄ©a thuáº¿ tiá»ƒu bang',0),(73738,2049,'af','Geen staat (landsgebied) belastings Bepaal.',0),(73739,2049,'ro','Nu taxele de stat definite.',0),(73740,2049,'et','Riiklike maksude pole mÃ¤Ã¤ratletud.',0),(73741,2049,'si','DrÅ¾avne davke ni opredeljeno.',0),(73742,2049,'ba','Tidak ada pajak negara yang didefinisikan.',0),(73743,2049,'nl','Geen staat belastingen gedefinieerd.',0),(73744,2049,'fi','Valtion veroja mÃ¤Ã¤ritetty.',0),(73745,2049,'no','Ingen statlig skatt definert.',0),(73746,2049,'da','Ingen statslige skatter defineret.',0),(73747,2049,'ko','ì •ì˜ ì•„ë‹ˆ ì£¼ ì„¸ìž…ë‹ˆë‹¤.',0),(73748,2049,'he','××™×Ÿ ×ž×™×¡×™× ×œ×ž×“×™× ×” ×©×”×•×’×“×¨×•.',0),(73749,2049,'el','Î”ÎµÎ½ ÎºÏÎ±Ï„Î¹ÎºÎ¿Î¯ Ï†ÏŒÏÎ¿Î¹ Ï€Î¿Ï… Î¿ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹.',0),(73750,2049,'zh','ä»»ä½•å›½å®¶ç¨Žæ”¶è§„å®šã€‚\r\n',0),(73751,2049,'sv','Ingen statlig skatt definieras.',0),(73752,2049,'it','Nessuna tassa di stata definita.',0),(73753,2049,'tl','',0),(73754,2049,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3616;&#3634;&#3625;&#3637;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(73755,2049,'hi','à¤•à¥‹à¤ˆ à¤°à¤¾à¤œà¥à¤¯ à¤•à¤°à¥‹à¤‚ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾à¥¤',0),(73756,2049,'ms','Tidak ada cukai negeri yang ditakrifkan.',0),(73757,2049,'ar','Ø£ÙŠ Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©.',0),(73758,2049,'fr','Aucune taxe d\'Ã©tat dÃ©finie.',0),(73759,2049,'jp','å·žç¨Žã?Œå®šã‚?ã‚‰ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(73760,2049,'pt','Sem impostos de estado definidos.',0),(73761,2049,'ru','Ð‘ÐµÐ· Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ñ… Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ñ‹.',0),(73762,2049,'es','No se definieron impuestos del estado',0),(73763,2049,'de','Keine staatlichen Steuern definiert.',0),(73764,2049,'en','No state taxes defined.',0),(73765,2050,'is','',0),(73766,2050,'dr','Ù‡ÙŠÚ† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(73767,2050,'pr','Ù‡ÙŠÚ† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(73768,2050,'tr','HiÃ§ hisse senetleri buldu.',0),(73769,2050,'pl','Nie znaleziono zapasÃ³w.',0),(73770,2050,'bg','ÐÑÐ¼Ð° Ð·Ð°Ð¿Ð°ÑÐ¸.',0),(73771,2050,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø³Ù¹Ø§Ú© Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(73772,2050,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð°ÑˆÐ»Ð¸.',0),(73773,2050,'vi','KhÃ´ng tháº¥y hÃ ng tá»“n',0),(73774,2050,'af','Geen voorraad gevind.',0),(73775,2050,'ro','Nici stocuri gÄƒsite.',0),(73776,2050,'et','Leitud varud.',0),(73777,2050,'si','Ne zaloge naÅ¡el.',0),(73778,2050,'ba','Ada saham yang ditemukan.',0),(73779,2050,'nl','Geen voorraden gevonden.',0),(73780,2050,'fi','Ei esiintyviÃ¤ kalakantoja.',0),(73781,2050,'no','Ingen aksjer funnet.',0),(73782,2050,'da','Ingen bestande fundet.',0),(73783,2050,'ko','ì•„ë‹ˆ ì£¼ì‹ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(73784,2050,'he','×‘×œ×™ ×ž× ×™×•×ª × ×ž×¦××•.',0),(73785,2050,'el','Î”ÎµÎ½ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(73786,2050,'zh','æ²¡æœ‰è‚¡ç¥¨å‘çŽ°ã€‚\r\n',0),(73787,2050,'sv','Inga aktier hittade.',0),(73788,2050,'it','No stock trovati.',0),(73789,2050,'tl','',0),(73790,2050,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(73791,2050,'hi','à¤•à¥‹à¤ˆ à¤¸à¥à¤Ÿà¥‰à¤•à¥à¤¸ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(73792,2050,'ms','Tiada stok yang ditemui.',0),(73793,2050,'ar','Ø§Ù„Ø£Ø±ØµØ¯Ø© Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(73794,2050,'fr','Pas trouvÃ©s de stocks.',0),(73795,2050,'jp','åœ¨åº«ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73796,2050,'pt','Estoques encontrados.',0),(73797,2050,'ru','Ð—Ð°Ð¿Ð°ÑÑ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.',0),(73798,2050,'es','No se Encontraron Stocks',0),(73799,2050,'de','Keine BestÃ¤nde gefunden.',0),(73800,2050,'en','No stocks found.',0),(73801,2051,'is','',0),(73802,2051,'dr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(73803,2051,'pr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(73804,2051,'tr','SeÃ§ili vergi',0),(73805,2051,'pl','Å»aden podatek nie wybrany',0),(73806,2051,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½ Ð´Ð°Ð½ÑŠÐº',0),(73807,2051,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ù¹ÛŒÚ©Ø³',0),(73808,2051,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾',0),(73809,2051,'vi','ChÆ°a chá»n thuáº¿',0),(73810,2051,'af','Geen Belasting Geselekteer',0),(73811,2051,'ro','Nici un impozit selectate',0),(73812,2051,'et','Ãœhtegi maksu pole valitud',0),(73813,2051,'si','Brez davka, izbrana',0),(73814,2051,'ba','Tidak ada pajak yang dipilih',0),(73815,2051,'nl','Geen belasting geselecteerd',0),(73816,2051,'fi','Veroa ei valittu',0),(73817,2051,'no','Ingen skatt valgt',0),(73818,2051,'da','Ingen skat valgt',0),(73819,2051,'ko','ì•„ë¬´ ì„¸ê¸ˆë„ ì„ ì •',0),(73820,2051,'he','×œ× × ×‘×—×¨ ×ž×¡',0),(73821,2051,'el','ÎšÎ±Î½Î­Î½Î±Ï‚ Ï†ÏŒÏÎ¿Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(73822,2051,'zh','æ— å·²é€‰çš„ç¨ŽåŠ¡\r\n',0),(73823,2051,'sv','Ingen skatt som valts',0),(73824,2051,'it','Nessuna imposta selezionata',0),(73825,2051,'tl','',0),(73826,2051,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(73827,2051,'hi','à¤•à¥‹à¤ˆ à¤•à¤° à¤¨à¤¹à¥€à¤‚ à¤šà¤¯à¤¨à¤¿à¤¤',0),(73828,2051,'ms','Tiada cukai yang dipilih',0),(73829,2051,'ar','Ù„Ù… ØªØ®ØªØ± Ø¶Ø±ÙŠØ¨Ø©',0),(73830,2051,'fr','Aucun impÃ´t de sÃ©lectionnÃ©s',0),(73831,2051,'jp','ç¨Žã?Œé?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(73832,2051,'pt','Nenhum imposto selecionado',0),(73833,2051,'ru','ÐÐµÑ‚ Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… ÐÐ°Ð»Ð¾Ð³Ð¾Ð²',0),(73834,2051,'es','No se SeleccionÃ³ un Impuesto',0),(73835,2051,'de','Keine Steuer ausgewÃ¤hlt',0),(73836,2051,'en','No Tax Selected',0),(73837,2052,'is','',0),(73838,2052,'dr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73839,2052,'pr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73840,2052,'tr','Bulunan vergi',0),(73841,2052,'pl','Podatki, nie znaleziono',0),(73842,2052,'bg','ÐÐ¸ÐºÐ°ÐºÐ²Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(73843,2052,'ur','Ú©ÙˆØ¦ÛŒ Ù¹ÛŒÚ©Ø³ Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(73844,2052,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°, Ð½Ð°ÑˆÐ°Ð¾',0),(73845,2052,'vi','KhÃ´ng tháº¥y thuáº¿',0),(73846,2052,'af','Geen belasting gevind',0),(73847,2052,'ro','Nici taxe gÄƒsit',0),(73848,2052,'et','Makse ei leitud',0),(73849,2052,'si','Ne davki, najti',0),(73850,2052,'ba','Tidak ada pajak yang ditemukan',0),(73851,2052,'nl','Geen belastingen gevonden',0),(73852,2052,'fi','Ei veroja lÃ¶ytyi',0),(73853,2052,'no','Ingen skatt funnet',0),(73854,2052,'da','Ingen skatter fandt',0),(73855,2052,'ko','ì•„ë¬´ ì„¸ê¸ˆë„ ë°œê²¬',0),(73856,2052,'he','×œ× × ×ž×¦××• ×ž×™×¡×™×',0),(73857,2052,'el','Î”ÎµÎ½ Ï„Î¿Ï…Ï‚ Ï†ÏŒÏÎ¿Ï…Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(73858,2052,'zh','æ²¡æœ‰å‘çŽ°ç¨Ž\r\n',0),(73859,2052,'sv','Inga skatter Funna',0),(73860,2052,'it','Nessun tasse trovate',0),(73861,2052,'tl','',0),(73862,2052,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(73863,2052,'hi','à¤•à¥‹à¤ˆ à¤•à¤°à¥‹à¤‚ à¤ªà¤¾à¤',0),(73864,2052,'ms','Tidak ada cukai yang ditemui',0),(73865,2052,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(73866,2052,'fr','Pas trouvÃ©s de taxes',0),(73867,2052,'jp','ç¨Žã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(73868,2052,'pt','Sem impostos encontrados',0),(73869,2052,'ru','ÐÐµÑ‚ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹Ñ… Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(73870,2052,'es','No se encontraron Impuestos',0),(73871,2052,'de','Keine Steuern gefunden',0),(73872,2052,'en','No taxes found',0),(73873,2053,'is','',0),(73874,2053,'dr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ù…Ø·Ù„Ø¨ ÙŠØ§ Ù†Ø§Ù… Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(73875,2053,'pr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ù…Ø·Ù„Ø¨ ÙŠØ§ Ù†Ø§Ù… Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(73876,2053,'tr','Konu kimlik veya verilen ad.',0),(73877,2053,'pl','Nie ma tematu id lub nazwa nadana.',0),(73878,2053,'bg','ÐÑÐ¼Ð° Ñ‚ÐµÐ¼Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð¸Ð»Ð¸ Ð½Ð°Ð¸Ð¼ÐµÐ½Ð¾Ð²Ð°Ð½Ð¸Ðµ.',0),(73879,2053,'ur','Ú©ÙˆØ¦ÛŒ Ù…ÙˆØ¶ÙˆØ¹ id ÛŒØ§ Ú©Ø§ Ù†Ø§Ù… Ø¯ÛŒØ§ ÛÛ’ Û”',0),(73880,2053,'sr','Ð‘ÐµÐ· Ñ‚ÐµÐ¼Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð°, Ð¸Ð»Ð¸ Ð´Ð°Ñ‚Ð¾ Ð¸Ð¼Ðµ.',0),(73881,2053,'vi','KhÃ´ng cÃ³ id chá»§ Ä‘á» hay tÃªn',0),(73882,2053,'af','Geen onderwerp id of naam gegee.',0),(73883,2053,'ro','Nici un subiect ID-ul sau numele dat.',0),(73884,2053,'et','No teema id vÃµi nime kohta.',0),(73885,2053,'si','Nobena tema id ali ime.',0),(73886,2053,'ba','Tidak ada topik id atau nama yang diberikan.',0),(73887,2053,'nl','Geen onderwerp-id of naam gegeven.',0),(73888,2053,'fi','Aiheen tunnus tai nimi.',0),(73889,2053,'no','Ingen emne id eller navn.',0),(73890,2053,'da','Intet emne-id eller navn.',0),(73891,2053,'ko','ì•„ë¬´ í•­ëª© id ë˜ëŠ” ì´ë¦„ìž…ë‹ˆë‹¤.',0),(73892,2053,'he','×œ× ×ž×–×”×” × ×•×©× ××• ×‘×©×ž×•.',0),(73893,2053,'el','ÎšÎ±Î½Î­Î½Î± Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î® Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï€Î¿Ï… Î´ÏŒÎ¸Î·ÎºÎµ.',0),(73894,2053,'zh','æ²¡æœ‰ä¸»é¢˜IDæˆ–åç§°å®šã€‚\r\n',0),(73895,2053,'sv','Inga avsnitts-id eller namn.',0),(73896,2053,'it','Nessun argomento id o nome dato.',0),(73897,2053,'tl','',0),(73898,2053,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;&#3627;&#3619;&#3639;&#3629;&#3594;&#3639;&#3656;&#3629;&#3607;&#3637;&#3656;&#3651;&#3627;&#3657;',0),(73899,2053,'hi','à¤•à¥‹à¤ˆ à¤µà¤¿à¤·à¤¯ id à¤¯à¤¾ à¤¨à¤¾à¤® à¤¦à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(73900,2053,'ms','Tiada topik id atau nama yang diberi.',0),(73901,2053,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…Ø¹Ø±Ù Ø§Ù„Ù…ÙˆØ¶ÙˆØ¹ Ø£Ùˆ Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ù…Ø¹Ø·Ù‰.',0),(73902,2053,'fr','Aucun id de rubrique ou le nom donnÃ©.',0),(73903,2053,'jp','ãƒˆãƒ”ãƒƒã‚¯IDã?‹å??å‰?ã?Œä¸Žã?ˆã‚‰ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(73904,2053,'pt','Nenhum tÃ³pico id ou nome dado.',0),(73905,2053,'ru','ÐÐµÑ‚ Ñ‚ÐµÐ¼Ð° id Ð¸Ð»Ð¸ Ð¸Ð¼Ñ.',0),(73906,2053,'es','No se diÃ³ un nombre o id de tÃ³pico',0),(73907,2053,'de','Kein Thema-Id oder Name gegeben.',0),(73908,2053,'en','No topic id or name given.',0),(73909,2054,'is','',0),(73910,2054,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(73911,2054,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(73912,2054,'tr','FaturalandÄ±rÄ±lmamÄ±ÅŸ emir adlÄ± biri yok.',0),(73913,2054,'pl','Nie zleceÅ„ nieopÅ‚aconych istnieje.',0),(73914,2054,'bg','ÐÑÐ¼Ð° unbilled Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°.',0),(73915,2054,'ur','Ú©ÙˆØ¦ÛŒ ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº Û”',0),(73916,2054,'sr','ÐÐµÐ¼Ð° ÑƒÐ½Ð±Ð¸Ð»Ð»ÐµÐ´ Ð½Ð°Ð»Ð¾Ð·Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ðµ.',0),(73917,2054,'vi','Ä‘Æ¡n hÃ ng chÆ°a ra hÃ³a Ä‘Æ¡n khÃ´ng tá»“n táº¡i',0),(73918,2054,'af','Daar is Geen ongefaktureerde bestellings.',0),(73919,2054,'ro','Comenzi unbilled exista.',0),(73920,2054,'et','Ilma arveta tellimusi pole',0),(73921,2054,'si','Brez unbilled naroÄil obstajajo.',0),(73922,2054,'ba','Ada tidak ada order yang belum ditagih.',0),(73923,2054,'nl','Geen nog niet gefactureerde orders bestaan.',0),(73924,2054,'fi','Unbilled tilauksia ei ole.',0),(73925,2054,'no','Det finnes ingen fakturert ordre.',0),(73926,2054,'da','Der findes ingen faktureret ordrer.',0),(73927,2054,'ko','ì•„ë¬´ ë° ìˆœì„œëŠ” ì¡´ìž¬ í•œë‹¤.',0),(73928,2054,'he','×¤×§×•×“×•×ª unbilled ×§×™×™×.',0),(73929,2054,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î´ÎµÎ½ Î±Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚.',0),(73930,2054,'zh','ä¸å­˜åœ¨æœªå…¥è´¦çš„è®¢å•',0),(73931,2054,'sv','Det finns inga relaterade order.',0),(73932,2054,'it','Non esistono nessun ordine di attivitÃ  non ancora fatturato.',0),(73933,2054,'tl','',0),(73934,2054,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3',0),(73935,2054,'hi','à¤•à¥‹à¤ˆ unbilled à¤†à¤¦à¥‡à¤¶ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆà¥¤',0),(73936,2054,'ms','Pesanan lepas tidak wujud.',0),(73937,2054,'ar','ØªÙˆØ¬Ø¯ Ø£ÙŠ Ø£ÙˆØ§Ù…Ø± ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø©.',0),(73938,2054,'fr','Aucune commande non facturÃ©s n\'existe.',0),(73939,2054,'jp','æœªè«‹æ±‚æ³¨æ–‡ã?¯å­˜åœ¨ã?—ã?¾ã?›ã‚“',0),(73940,2054,'pt','Existem ordens nÃ£o faturadas.',0),(73941,2054,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð±ÐµÐ· Ð¾Ð¿Ð»Ð°Ñ‚Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð².',0),(73942,2054,'es','No existe ordenes no facturados',0),(73943,2054,'de','Keine noch nicht fakturierte AuftrÃ¤ge vorhanden sind.',0),(73944,2054,'en','No unbilled orders exist.',0),(73945,2055,'is','',0),(73946,2055,'dr','Ù‡ÙŠÚ† Ø³Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73947,2055,'pr','Ù‡ÙŠÚ† Ø³Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73948,2055,'tr','Ã–denmemiÅŸ bir saat bulundu.',0),(73949,2055,'pl','NiezapÅ‚acone godziny nie znaleziono.',0),(73950,2055,'bg','ÐÑÐ¼Ð° Ð½ÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ñ‡Ð°ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(73951,2055,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û Ú¯Ú¾Ù†Ù¹Û’ Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(73952,2055,'sr','ÐÐµÐ¼Ð° Ð½ÐµÐ¿Ð»Ð°Ñ›ÐµÐ½Ð¸Ñ… ÑÐ°Ñ‚Ð¸ Ð½Ð°ÑˆÐ°Ð¾.',0),(73953,2055,'vi','KhÃ´ng tháº¥y giá» chÆ°a tráº£',0),(73954,2055,'af','Geen onbetaalde ure gevind.',0),(73955,2055,'ro','GÄƒsit nici o orÄƒ neachitate.',0),(73956,2055,'et','Tasumata tunde leitud.',0),(73957,2055,'si','Ni neplaÄanih ur naÅ¡el.',0),(73958,2055,'ba','Jam tidak dibayar tidak ditemukan.',0),(73959,2055,'nl','Geen niet-betaalde uren gevonden.',0),(73960,2055,'fi','Maksamattomat tuntia perustaa.',0),(73961,2055,'no','Ingen ubetalte timer fant.',0),(73962,2055,'da','Ingen betalte timer fundet.',0),(73963,2055,'ko','ì•„ë¬´ ë¬´ ë³´ìˆ˜ ì‹œê°„ì„ ë°œê²¬.',0),(73964,2055,'he','××™×Ÿ ×©×¢×•×ª ×©×œ× ×©×•×œ×ž×• ×ž×¦×.',0),(73965,2055,'el','Î§ÏÏŒÎ½Î¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î¬Î½ÎµÏ… Î±Ï€Î¿Î´Î¿Ï‡ÏŽÎ½ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(73966,2055,'zh','æ²¡æœ‰æ‰¾åˆ°æ— å¿å°æ—¶ã€‚\r\n',0),(73967,2055,'sv','Inga obetalda timmar hittade.',0),(73968,2055,'it','Non trovano nessun ore non pagate.',0),(73969,2055,'tl','',0),(73970,2055,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(73971,2055,'hi','à¤•à¥‹à¤ˆ à¤…à¤µà¥ˆà¤¤à¤¨à¤¿à¤• à¤˜à¤‚à¤Ÿà¥‡ à¤®à¤¿à¤² à¤—à¤¯à¤¾à¥¤',0),(73972,2055,'ms','Jam belum dibayar tidak ditemui.',0),(73973,2055,'ar','Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø£ÙŠ Ø³Ø§Ø¹Ø© ØºÙŠØ± Ø§Ù„Ù…Ø³Ø¯Ø¯Ø©.',0),(73974,2055,'fr','Aucuns heures non rÃ©munÃ©rÃ©es ne trouvent.',0),(73975,2055,'jp','æœªæ‰•ã?„å‹¤å‹™æ™‚é–“ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(73976,2055,'pt','Encontraram sem horas nÃ£o remuneradas.',0),(73977,2055,'ru','ÐÐµÑ‚ Ð½ÐµÐ¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ñ‡Ð°ÑÐ¾Ð² Ð½Ð°ÑˆÐµÐ».',0),(73978,2055,'es','No se encontraron horas no pagadas',0),(73979,2055,'de','Keine unbezahlten Stunden gefunden.',0),(73980,2055,'en','No unpaid hours found.',0),(73981,2056,'is','',0),(73982,2056,'dr','Ù‡ÙŠÚ† Ø³Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73983,2056,'pr','Ù‡ÙŠÚ† Ø³Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(73984,2056,'tr','Deftere nakledilmemiÅŸ eÅŸleÅŸme bulunamadÄ±!',0),(73985,2056,'pl','Nie znaleziono odpowiednikÃ³w niezaksiÄ™gowane!',0),(73986,2056,'bg','ÐÑÐ¼Ð° Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸Ñ‚Ðµ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ñ!',0),(73987,2056,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº Ù…Ù„Ø§!',0),(73988,2056,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð¸Ñ… Ð½ÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ°!',0),(73989,2056,'vi','KhÃ´ng tháº¥y chÆ°a káº¿t chuyá»ƒn phÃ¹ há»£p',0),(73990,2056,'af','Geen Unposted pasmaats gevind!',0),(73991,2056,'ro','Nicio potrivire neÃ®ncÄƒrcate gÄƒsit!',0),(73992,2056,'et','Sisestamata vasteid ei leitud!',0),(73993,2056,'si','Ni neknjiÅ¾enih zadetkov!',0),(73994,2056,'ba','Ada pertandingan Unposted ditemukan!',0),(73995,2056,'nl','Geen niet-doorgevoerde gevonden!',0),(73996,2056,'fi','Kirjaamattomia laskuja ei lÃ¶ytynyt!',0),(73997,2056,'no','Ingen ikke-posterte treff!',0),(73998,2056,'da','Ingen ikke-bogfÃ¸rte kampe fundet!',0),(73999,2056,'ko','ì‚¬í•­ê³¼ ì¼ì¹˜ ë°œê²¬!',0),(74000,2056,'he','. ××™×Ÿ ×”×ª××ž×•×ª ×©×œ× × ×¨×©×ž×• × ×ž×¦××•!',0),(74001,2056,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î¼Î· Î±Î½Î±ÏÏ„Î·Î¼Î­Î½ÎµÏ‚ Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÎµÏ‚!',0),(74002,2056,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…æœªå‘å¸ƒï¼\r\n',0),(74003,2056,'sv','Ingen obokade trâ”œÃ±ffar hittades!',0),(74004,2056,'it','No non registrate corrispondenze trovate!',0),(74005,2056,'tl','',0),(74006,2056,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(74007,2056,'hi','à¤•à¥‹à¤ˆ Unposted à¤œà¥‹à¤¡à¤¼ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾!',0),(74008,2056,'ms','Tiada padanan Unposted ditemui!',0),(74009,2056,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ø·Ø§Ø¨Ù‚Ø§Øª Ø§Ù„Ù…Ø±Ø­Ù„!',0),(74010,2056,'fr','Aucune correspondance non comptabilisÃ©s trouvÃ© !',0),(74011,2056,'jp','é?©å?ˆã?™ã‚‹æœªè¨ˆä¸Šã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(74012,2056,'pt','NÃ£o nÃ£o lanÃ§adas correspondÃªncias encontradas!',0),(74013,2056,'ru','ÐÐµÐ¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÑÐ¾Ð²Ð¿Ð°Ð´ÐµÐ½Ð¸Ð¹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾!',0),(74014,2056,'es','No se Encontraron Asientos No Emparejados',0),(74015,2056,'de','Keine ungebuchte Ergebnisse gefunden!',0),(74016,2056,'en','No Unposted Matches Found!',0),(74017,2057,'is','',0),(74018,2057,'dr','. Ù„Ø·ÙØ§ Ù…Ø±ÙˆØ±Ú¯Ø± Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÙŠØ¯ Ùˆ Ù…Ø¬Ø¯Ø¯Ø§ ÙˆØ§Ø±Ø¯ Ø³ÙŠØ³ØªÙ… Ø´ÙˆÙŠØ¯ ',0),(74019,2057,'pr',' Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ . Ù„Ø·ÙØ§ Ù…Ø±ÙˆØ±Ú¯Ø± Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÙŠØ¯ Ùˆ Ù…Ø¬Ø¯Ø¯Ø§ ÙˆØ§Ø±Ø¯ Ø³ÙŠØ³ØªÙ… Ø´ÙˆÙŠØ¯ ',0),(74020,2057,'tr','KullanÄ±cÄ± kimliÄŸi bulundu.  LÃ¼tfen tarayÄ±cÄ±nÄ±zÄ± kapatÄ±n ve kÃ¼tÃ¼k sÄ±rt iÃ§inde.',0),(74021,2057,'pl','Nie znaleziono identyfikatora uÅ¼ytkownika.  ProszÄ™ zamknÄ…Ä‡ przeglÄ…darkÄ™ i zaloguj ponownie.',0),(74022,2057,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð˜Ð” Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.  Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÑ‚Ðµ Ð±Ñ€Ð°ÑƒÐ·ÑŠÑ€Ð° ÑÐ¸ Ð¸ Ð²Ð»ÐµÐ·Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾ Ð².',0),(74023,2057,'ur','Ú©Ø³ÛŒ ØµØ§Ø±Ù Ù…Ù„Ø§ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª ÛÛ’ Û”  Ø¢Ù¾ Ú©Û’ Ø¨Ø±Ø§Ø¤Ø²Ø± Ú©Ùˆ Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù…ÛŒÚº Ø¯ÙˆØ¨Ø§Ø±Û Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº Û”',0),(74024,2057,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½ Ð˜Ð” ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°.  Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð²Ð°Ñˆ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‡ Ð¸ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ.',0),(74025,2057,'vi','KhÃ´ng tÃ¬m tháº¥y user ID. Vui lÃ²ng Ä‘Ã³ng cÃ´ng cá»¥ tÃ¬m kiáº¿m vÃ  log in láº¡i.',0),(74026,2057,'af','Geen gebruiker id gevind. Sluit asseblief u webleser en teken weer aan.',0),(74027,2057,'ro','Nici un ID de utilizator gÄƒsit.  VÄƒ rugÄƒm sÄƒ Ã®nchideÅ£i browser-ul ÅŸi log spate Ã®nÄƒuntru.',0),(74028,2057,'et','Kasutaja ID leitud.  Sulgege brauser ja uuesti sisse logida.',0),(74029,2057,'si','ID uporabnika ni mogoÄe najti.  Zaprite brskalnik in se prijavite nazaj.',0),(74030,2057,'ba','Tidak ada User ID ditemukan.  Silakan Tutup peramban dan log in kembali.',0),(74031,2057,'nl','Geen gebruikersnaam gevonden.  Sluit uw browser en log weer in.',0),(74032,2057,'fi','KÃ¤yttÃ¤jÃ¤tunnusta ei lÃ¶ytynyt.  Sulje selain ja kirjaudu takaisin sisÃ¤Ã¤n.',0),(74033,2057,'no','Ingen bruker-ID funnet.  Lukk webleseren og tilbake igjen.',0),(74034,2057,'da','Ingen bruger-ID fundet.  Luk din browser og logge pÃ¥ igen.',0),(74035,2057,'ko','ì‚¬ìš©ìž IDë¥¼ ë°œê²¬ìž…ë‹ˆë‹¤.  ë‹¹ì‹ ì˜ ë¸Œë¼ìš°ì €ë¥¼ ì¢…ë£Œ í•˜ ê³  ë‹¤ì‹œ ë¡œê·¸ì¸ í•˜ì‹­ì‹œì˜¤.',0),(74036,2057,'he','.×œ× × ×ž×¦× ×–×™×”×•×™ ×ž×©×ª×ž×©. ×× × ×¡×’×•×¨ ××ª ×”×“×¤×“×¤×Ÿ ×•×”×ª×—×‘×¨ ×©×•×‘',0),(74037,2057,'el','Î§Ï‰ÏÎ¯Ï‚ Ï„Î±Ï…Ï„ÏŒÏ„Î·Ï„Î± Ï‡ÏÎ®ÏƒÏ„Î· Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.  Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÎºÎ»ÎµÎ¯ÏƒÎµÏ„Îµ Ï„Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Ï€ÎµÏÎ¹Î®Î³Î·ÏƒÎ·Ï‚ ÎºÎ±Î¹ ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Î¾Î±Î½Î¬.',0),(74038,2057,'zh','æ²¡æœ‰æ‰¾åˆ°ç”¨æˆ·èº«ä»½è¯ã€‚è¯·å…³é—­æµè§ˆå™¨å¹¶é‡æ–°ç™»å½•\r\n',0),(74039,2057,'sv','Ingen anvÃ¤ndare-ID hittades.  StÃ¤ng webblÃ¤saren och logga in igen.',0),(74040,2057,'it','Nessun ID utente trovato.  Si prega di chiudere il browser e riaccedere.',0),(74041,2057,'tl','',0),(74042,2057,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3648;&#3621;&#3586;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657; &#3585;&#3619;&#3640;&#3603;&#3634;&#3611;&#3636;&#3604;&#3648;&#3610;&#3619;&#3634;&#3648;&#3595;&#3629;&#3619;&#3660;&#3586;&#3629;&#3591;&#3588;&#3640;&#',0),(74043,2057,'hi','à¤•à¥‹à¤ˆ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ ID à¤ªà¤¾à¤¯à¤¾à¥¤  à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤ªà¤¨à¥‡ à¤¬à¥à¤°à¤¾à¤‰à¤œà¤¼à¤° à¤•à¥‹ à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤µà¤¾à¤ªà¤¸ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¥‡à¤‚à¥¤',0),(74044,2057,'ms','Tiada ID pengguna yang ditemui.  Sila tutup browser anda dan log masuk kembali.',0),(74045,2057,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯. ÙØ¶Ù„Ø§Ù‹ Ø£ØºÙ„Ù‚ Ù…ØªØµÙØ­ Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª Ø«Ù… Ù‚Ù… Ø¨ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ù…Ø¬Ø¯Ø¯Ø§Ù‹.',0),(74046,2057,'fr','Aucun ID utilisateur trouvÃ©. Merci de fermer le navigateur et de vous reconnecter.',0),(74047,2057,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ï¼©ï¼¤ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã€‚ãƒ–ãƒ©ã‚¦ã‚¶ã‚’ã?¨ã?˜ã?¦ã€?ã‚‚ã?†ä¸€åº¦ãƒ­ã‚°ã‚¤ãƒ³ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(74048,2057,'pt','Nenhum ID de usuÃ¡rio encontrado.  Por favor, feche seu navegador e logar-se e volta.',0),(74049,2057,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ.  Ð—Ð°ÐºÑ€Ð¾Ð¹Ñ‚Ðµ Ð±Ñ€Ð°ÑƒÐ·ÐµÑ€ Ð¸ ÑÐ½Ð¾Ð²Ð° Ð²Ð¾Ð¹Ñ‚Ð¸ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ.',0),(74050,2057,'es','No se encontrÃ³ id de usuario. Por favor cierre su browser y login otra vez',0),(74051,2057,'de','Keine Benutzer-ID gefunden.  Bitte schlieÃŸen Sie Ihren Browser und wieder anmelden.',0),(74052,2057,'en','No User ID found.  Please close your browser and log back in.',0),(74053,2058,'is','',0),(74054,2058,'dr','ÙƒØ§Ø±Ø¨Ø± Ù‡ÙŠÚ† Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ù†Ø¯Ø§Ø±Ø¯ ',0),(74055,2058,'pr','ÙƒØ§Ø±Ø¨Ø± Ù‡ÙŠÚ† Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ù†Ø¯Ø§Ø±Ø¯ ',0),(74056,2058,'tr','KullanÄ±cÄ± bu ÅŸirket iÃ§in eriÅŸim yok',0),(74057,2058,'pl','UÅ¼ytkownik nie ma dostÄ™pu do tej firmy',0),(74058,2058,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ð¸Ð¼Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ñ‚Ð°Ð·Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(74059,2058,'ur','ØµØ§Ø±Ù Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø±Ø³Ø§Ø¦ÛŒ Ø­Ø§ØµÙ„ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(74060,2058,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð¸Ð¼Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¾Ð²Ð¾Ñ˜ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð¸',0),(74061,2058,'vi','User khÃ´ng cÃ³ quyá»n truy cáº­p vÃ o cÃ´ng ty nÃ y',0),(74062,2058,'af','Gebruiker het Geen Toegang to Hierdie Onderneming',0),(74063,2058,'ro','Utilizatorul nu are acces la aceasta companie',0),(74064,2058,'et','Kasutajal puudub juurdepÃ¤Ã¤s selle firma',0),(74065,2058,'si','Uporabnik nima dostopa do te druÅ¾be',0),(74066,2058,'ba','Pengguna tidak memiliki akses ke perusahaan ini',0),(74067,2058,'nl','Gebruiker heeft geen toegang tot dit bedrijf',0),(74068,2058,'fi','KÃ¤yttÃ¤jÃ¤ ei ole pÃ¤Ã¤syÃ¤ tÃ¤mÃ¤n yrityksen',0),(74069,2058,'no','Brukeren har ingen tilgang til dette selskapet',0),(74070,2058,'da','Brugeren har ikke adgang til denne virksomhed',0),(74071,2058,'ko','ì‚¬ìš©ìžê°€ì´ íšŒì‚¬ì— ì•¡ì„¸ìŠ¤í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(74072,2058,'he','×œ×ž×©×ª×ž×© ××™×Ÿ ×’×™×©×” ×œ×—×‘×¨×” ×–×•',0),(74073,2058,'el','Î§ÏÎ®ÏƒÏ„Î·Ï‚ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÏ„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î®',0),(74074,2058,'zh','ç”¨æˆ·ä¸èƒ½å¯¹æ­¤å…¬å¸è®¿é—®\r\n',0),(74075,2058,'sv','AnvÃ¤ndare har inte tillgÃ¥ng till detta fÃ¶retag',0),(74076,2058,'it','Utente non ha accesso a questa societÃ ',0),(74077,2058,'tl','',0),(74078,2058,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3609;&#3637;&#3657;',0),(74079,2058,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‹ à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¹à¥à¤à¤š à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(74080,2058,'ms','Pengguna mempunyai tiada akses ke Syarikat ini',0),(74081,2058,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù„ÙŠØ³ Ù„Ù‡ ØµÙ„Ø§Ø­ÙŠØ© Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø¥Ù„Ù‰ Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(74082,2058,'fr','L\'utilisateur n\'a aucun accÃ¨s pour cette compagnie.',0),(74083,2058,'jp','ã?“ã?®ä¼šç¤¾ã?«ã?¯ã‚¢ã‚¯ã‚»ã‚¹ã?§ã??ã?¾ã?›ã‚“',0),(74084,2058,'pt','UsuÃ¡rio nÃ£o tem acesso a esta empresa',0),(74085,2058,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ ÐÐµ Ð˜Ð¼ÐµÐµÑ‚ Ð”Ð¾ÑÑ‚ÑƒÐ¿ Ðš Ð­Ñ‚Ð¾Ð¹ Ð¤Ð¸Ñ€Ð¼Ðµ',0),(74086,2058,'es','Usuario No Tiene Acceso a Esta Empresa',0),(74087,2058,'de','Benutzer hat keinen Zugriff auf diese Firma',0),(74088,2058,'en','User Has No Access to This Company',0),(74089,2059,'is','',0),(74090,2059,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74091,2059,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74092,2059,'tr','KullanÄ±cÄ± ID deÄŸil kurmak.',0),(74093,2059,'pl','Nie znaleziono identyfikatora uÅ¼ytkownika.',0),(74094,2059,'bg','ÐÐµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½ Ð˜Ð” Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ».',0),(74095,2059,'ur','ØµØ§Ø±Ù ID Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(74096,2059,'sr','Ð˜Ð” ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°.',0),(74097,2059,'vi','KhÃ´ng tÃ¬m tháº¥y ID NgÆ°á»i Sá»­ Dá»¥ng',0),(74098,2059,'af','Gebruiker ID nie gevind.',0),(74099,2059,'ro','ID utilizator negÄƒsit.',0),(74100,2059,'et','Kasutaja ID-d ei leitud.',0),(74101,2059,'si','ID-ja uporabnika ni mogoÄe najti.',0),(74102,2059,'ba','ID pengguna tidak ditemukan.',0),(74103,2059,'nl','Gebruikers ID niet gevonden',0),(74104,2059,'fi','KÃ¤yttÃ¤jÃ¤tunnusta ei lÃ¶ytynyt.',0),(74105,2059,'no','Bruker-ID ikke funnet.',0),(74106,2059,'da','Bruger-ID blev ikke fundet.',0),(74107,2059,'ko','ì‚¬ìš©ìž IDë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(74108,2059,'he','×ž×–×”×” ×”×ž×©×ª×ž×© ×œ× × ×ž×¦×.',0),(74109,2059,'el','ID Ï‡ÏÎ®ÏƒÏ„Î· Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(74110,2059,'zh','ç”¨æˆ·èº«ä»½è¯æœªæ‰¾åˆ°',0),(74111,2059,'sv','AnvÃ¤ndar-ID hittades inte.',0),(74112,2059,'it','ID utente non trovato.',0),(74113,2059,'tl','',0),(74114,2059,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3648;&#3621;&#3586;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(74115,2059,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ ID à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(74116,2059,'ms','ID pengguna yang tidak dijumpai.',0),(74117,2059,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù….',0),(74118,2059,'fr','ID utilisateur introuvable.',0),(74119,2059,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼IDã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(74120,2059,'pt','ID de usuÃ¡rio nÃ£o encontrado.',0),(74121,2059,'ru','ID ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(74122,2059,'es','No se encontrÃ³ el ID de usuario',0),(74123,2059,'de','Benutzer-ID nicht gefunden.',0),(74124,2059,'en','User ID not found.',0),(74125,2060,'is','',0),(74126,2060,'dr','Ù‡ÙŠÚ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(74127,2060,'pr','Ù‡ÙŠÚ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(74128,2060,'tr','SeÃ§ilen geÃ§erli fatura.',0),(74129,2060,'pl','Nie waÅ¼ne rachunki zaznaczone.',0),(74130,2060,'bg','ÐÐ¸ÐºÐ°ÐºÑŠÐ² Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ ÑÐ¼ÐµÑ‚ÐºÐ° Ð¸Ð·Ð±Ñ€Ð°Ð½.',0),(74131,2060,'ur','Ú©ÙˆØ¦ÛŒ Ø¬Ø§Ø¦Ø² Ø¨Ù„ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ ÛÛ’ Û”',0),(74132,2060,'sr','ÐÐµÐ¼Ð° Ð²Ð°Ð¶ÐµÑ›Ð¸Ñ… Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°.',0),(74133,2060,'vi','chÆ°a chá»n bill cÃ³ hiá»‡u lá»±c',0),(74134,2060,'af','Geen geldige rekeninge gekies.',0),(74135,2060,'ro','Nici facturile valabil selectate.',0),(74136,2060,'et','Kehtiv arveid ei valitud.',0),(74137,2060,'si','Ni veljaven raÄuni, izbrani.',0),(74138,2060,'ba','Tagihan berlaku tidak dipilih.',0),(74139,2060,'nl','Geen geldige facturen geselecteerd.',0),(74140,2060,'fi','Ei voimassa laskuja valittuna.',0),(74141,2060,'no','Ingen gyldig regninger valgt.',0),(74142,2060,'da','Ingen gyldig regninger valgt.',0),(74143,2060,'ko','ì—†ìŒ ìœ íš¨í•œ ê³„ì‚° ì„œ ì„ íƒìž…ë‹ˆë‹¤.',0),(74144,2060,'he','×‘×œ×™ ×—×©×‘×•× ×•×ª ×—×•×§×™×™× × ×‘×—×¨×”.',0),(74145,2060,'el','Î”ÎµÎ½ Î¹ÏƒÏ‡ÏÎµÎ¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹.',0),(74146,2060,'zh','æ²¡æœ‰é€‰ä¸­çš„æœ‰æ•ˆç¥¨æ®ã€‚\r\n',0),(74147,2060,'sv','Inga giltiga rÃ¤kningar som valts.',0),(74148,2060,'it','No bollette valide selezionate.',0),(74149,2060,'tl','',0),(74150,2060,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3607;&#3637;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(74151,2060,'hi','à¤•à¥‹à¤ˆ à¤®à¤¾à¤¨à¥à¤¯ à¤¬à¤¿à¤²à¥‹à¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(74152,2060,'ms','Tiada bil sah yang dipilih.',0),(74153,2060,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ÙÙˆØ§ØªÙŠØ± ØµØ§Ù„Ø­Ø© Ø§Ù„Ù…Ø­Ø¯Ø¯.',0),(74154,2060,'fr','Aucun projet de loi valide sÃ©lectionnÃ©.',0),(74155,2060,'jp','æœ‰åŠ¹ã?ªè«‹æ±‚æ›¸ã?Œé?¸æŠžã?•ã‚Œã?¦ã?¾ã?›ã‚“',0),(74156,2060,'pt','Sem contas vÃ¡lidas selecionadas.',0),(74157,2060,'ru','ÐÐµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚Ð° Ð²Ñ‹Ð±Ñ€Ð°Ð½.',0),(74158,2060,'es','No se seleccionaron recibos vÃ¡lidos',0),(74159,2060,'de','Keine gÃ¼ltigen Rechnungen ausgewÃ¤hlt.',0),(74160,2060,'en','No valid bills selected.',0),(74161,2061,'is','',0),(74162,2061,'dr','Ù‡ÙŠÚ† ÙƒØ¯ Ù…Ø¹ØªØ¨Ø± Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74163,2061,'pr','Ù‡ÙŠÚ† ÙƒØ¯ Ù…Ø¹ØªØ¨Ø± Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74164,2061,'tr','GeÃ§erli biÃ§imlendirme kodlarÄ± buldum.',0),(74165,2061,'pl','Nie ma kodÃ³w znacznikÃ³w waÅ¼ne znaleÅºÄ‡.',0),(74166,2061,'bg','ÐÑÐ¼Ð° Ð²Ð°Ð»Ð¸Ð´Ð½Ð¸ ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð° ÐºÐ¾Ð´Ð¾Ð²Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(74167,2061,'ur','Ú©ÙˆØ¦ÛŒ Ø¬Ø§Ø¦Ø² Ù…Ø§Ø±Ú© Ø±Ù…ÙˆØ² Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(74168,2061,'sr','ÐÐµÐ¼Ð° Ð²Ð°Ð¶ÐµÑ›Ð¸Ñ… Ð½Ð°Ð·Ð½Ð°ÐºÐµ ÐºÐ¾Ð´Ð¾Ð²Ð° Ð½Ð°ÑˆÐ°Ð¾.',0),(74169,2061,'vi','KhÃ´ng tháº¥y mÃ£ cá»™ng thÃªm cÃ³ hiá»‡u lá»±c',0),(74170,2061,'af','Geen geldige prysverhogingkodes gevind.',0),(74171,2061,'ro','Nu codurile de marcare de valabil gÄƒsite.',0),(74172,2061,'et','Kehtiv lisakulude koodid leidsin.',0),(74173,2061,'si','Ni veljavno oznako kode naÅ¡el.',0),(74174,2061,'ba','Kode markup yang valid tidak ditemukan.',0),(74175,2061,'nl','Geen geldige markup codes gevonden.',0),(74176,2061,'fi','Sallittua merkintÃ¤koodia koodeja ei lÃ¶ydy.',0),(74177,2061,'no','Ingen gyldig kodesprÃ¥k koder funnet.',0),(74178,2061,'da','Ingen gyldig markup koder fundet.',0),(74179,2061,'ko','ìœ íš¨í•œ ë§ˆí¬ì—… ì½”ë“œ ì—†ì´ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(74180,2061,'he','×œ× × ×ž×¦××• ×§×•×“×™× ×¡×™×ž×•×Ÿ ×—×•×§×™.',0),(74181,2061,'el','ÎŸÎ§Î™ ÎšÎ©Î”Î™ÎšÎŸÎ™ Î­Î³ÎºÏ…ÏÎ· ÏƒÎ®Î¼Î±Î½ÏƒÎ· Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(74182,2061,'zh','æ²¡æœ‰æ‰¾åˆ°æœ‰æ•ˆçš„æ ‡è®°ä»£ç ã€‚\r\n',0),(74183,2061,'sv','Ingen giltig kod koder hittade.',0),(74184,2061,'it','Nessun codice di markup valido trovato.',0),(74185,2061,'tl','',0),(74186,2061,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(74187,2061,'hi','à¤•à¥‹à¤ˆ à¤®à¤¾à¤¨à¥à¤¯ à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤•à¥‹à¤¡à¥à¤¸ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(74188,2061,'ms','Tiada kod sah penanda yang ditemui.',0),(74189,2061,'ar','Ø±Ù…ÙˆØ² Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª ØµØ§Ù„Ø­Ø© Ù„Ø§ ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(74190,2061,'fr','Aucun code de balisage valide trouvÃ©.',0),(74191,2061,'jp','æœ‰åŠ¹ã?ªå€¤ä¸Šã?’ã‚³ãƒ¼ãƒ‰ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(74192,2061,'pt','Sem cÃ³digos de marcaÃ§Ã£o vÃ¡lido encontrados.',0),(74193,2061,'ru','ÐÐµ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð½Ð°Ñ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ° ÐºÐ¾Ð´Ñ‹ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(74194,2061,'es','No se encontraron cÃ³digos de encarecimiento',0),(74195,2061,'de','Keine gÃ¼ltige Markup-Codes gefunden.',0),(74196,2061,'en','No valid markup codes found.',0),(74197,2062,'is','',0),(74198,2062,'dr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74199,2062,'pr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74200,2062,'tr','SatÄ±cÄ± iÃ§in taÅŸÄ±yÄ±cÄ± bulmuÅŸ.',0),(74201,2062,'pl','Å»aden dostawca dla przewoÅºnika.',0),(74202,2062,'bg','ÐÐµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡, Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸ Ð·Ð° Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡.',0),(74203,2062,'ur','Ú©ÙˆØ¦ÛŒ ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒØ±ÛŒØ¦Ø± Ú©Û’ Ù„Ø¦Û’ Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(74204,2062,'sr','ÐÐµÐ¼Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð½Ð¾ÑÐ°Ñ‡.',0),(74205,2062,'vi','KhÃ´ng tháº¥y ngÆ°á»i cung cáº¥p cho hÃ£ng váº­n chuyá»ƒn',0),(74206,2062,'af','Geen verskaffer gevind vir karweier',0),(74207,2062,'ro','Nici un furnizor pentru transport.',0),(74208,2062,'et','Ole hankija vedaja ei leitud.',0),(74209,2062,'si','Nobena prodajalec za prevoznika.',0),(74210,2062,'ba','Penjual tidak ditemukan untuk operator.',0),(74211,2062,'nl','Geen leverancier gevonden voor vervoerder.',0),(74212,2062,'fi','Toimittajaa ei lÃ¶ytynyt harjoittaja.',0),(74213,2062,'no','Ingen leverandÃ¸rer funnet for transportÃ¸r.',0),(74214,2062,'da','Ingen leverandÃ¸r fundet for Flyselskabet.',0),(74215,2062,'ko','ì•„ë‹ˆ ê³µê¸‰ ì—…ì²´ ìºë¦¬ì–´ì— ëŒ€ í•œ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(74216,2062,'he','××™×Ÿ ×¡×¤×§ ×©× ×ž×¦××• ×¢×‘×•×¨ ×ž× ×©×.',0),(74217,2062,'el','ÎšÎ±Î½Î­Î½Î±Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®Ï‚ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î³Î¹Î± Ï†Î¿ÏÎ­Î±.',0),(74218,2062,'zh','æ²¡æœ‰ä¸ºæ‰¿è¿å•†æ‰¾åˆ°ä¾›åº”å•†ã€‚\r\n',0),(74219,2062,'sv','Ingen leverantÃ¶r hittade fÃ¶r transportÃ¶ren.',0),(74220,2062,'it','Nessun fornitore trovato per vettore.',0),(74221,2062,'tl','',0),(74222,2062,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(74223,2062,'hi','à¤•à¥‹à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤¹à¤• à¤ªà¤¾à¤¯à¤¾à¥¤',0),(74224,2062,'ms','Tiada penjual yang ditemui untuk pembekal.',0),(74225,2062,'ar','Ù„Ø§ Ø¨Ø§Ø¦Ø¹ ÙˆØ¬Ø¯Øª Ù„Ù„Ù†Ø§Ù‚Ù„.',0),(74226,2062,'fr','Aucun vendeur trouvÃ© pour le transporteur.',0),(74227,2062,'jp','ã?“ã?®é…?é€?æ¥­è€…ã?¸ã?®æ¥­è€…ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(74228,2062,'pt','Nenhum fornecedor foi encontrado para a transportadora.',0),(74229,2062,'ru','ÐÐ¸ Ð¾Ð´Ð¸Ð½ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº, Ð½Ð°ÑˆÐµÐ» Ð´Ð»Ñ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸ÐºÐ°.',0),(74230,2062,'es','No se encontrÃ³ Proveedor para este transportador',0),(74231,2062,'de','Kein Anbieter fÃ¼r TrÃ¤ger gefunden.',0),(74232,2062,'en','No vendor found for carrier.',0),(74233,2063,'is','',0),(74234,2063,'dr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74235,2063,'pr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74236,2063,'tr','SatÄ±cÄ±lar buldum.',0),(74237,2063,'pl','Nie dostawcÃ³w.',0),(74238,2063,'bg','ÐÑÐ¼Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.',0),(74239,2063,'ur','Ú©ÙˆØ¦ÛŒ ÙˆÛŒÙ†ÚˆØ±Ø² Ù¾Ø§ÛŒØ§ Û”',0),(74240,2063,'sr','ÐÐµÐ¼Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸.',0),(74241,2063,'vi','KhÃ´ng tháº¥y ngÆ°á»i bÃ¡n',0),(74242,2063,'af','Geen verskaffers gevind.',0),(74243,2063,'ro','Nu vÃ¢nzÄƒtorii de gÄƒsit.',0),(74244,2063,'et','Tarnijat ei leitud',0),(74245,2063,'si','Prodajalci, ki ni naÅ¡el.',0),(74246,2063,'ba','Vendor tidak ditemukan.',0),(74247,2063,'nl','Geen leveranciers gevonden.',0),(74248,2063,'fi','Ole myyjiÃ¤ lÃ¶ydy.',0),(74249,2063,'no','Ingen leverandÃ¸rer funnet.',0),(74250,2063,'da','Ingen kreditorer fundet.',0),(74251,2063,'ko','ì°¾ì„ ìˆ˜ ì—†ìŒ ê³µê¸‰ ì—…ì²´.',0),(74252,2063,'he','.×œ× × ×ž×¦××• ×¡×¤×§×™×',0),(74253,2063,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(74254,2063,'zh','æ²¡æœ‰æ‰¾åˆ°ä¾›åº”å•†ã€‚\r\n',0),(74255,2063,'sv','Inga leverantÃ¶rer hittades.',0),(74256,2063,'it','Nessun fornitori trovati.',0),(74257,2063,'tl','',0),(74258,2063,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(74259,2063,'hi','à¤•à¥‹à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(74260,2063,'ms','Vendor tidak ditemui.',0),(74261,2063,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…ÙˆØ±Ù‘Ø¯ÙˆÙ†',0),(74262,2063,'fr','Aucun fournisseurs trouvÃ©s.',0),(74263,2063,'jp','æ¥­è€…ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(74264,2063,'pt','NÃ£o hÃ¡ fornecedores encontrados.',0),(74265,2063,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹.',0),(74266,2063,'es','No se encontraron Proveedores',0),(74267,2063,'de','Keine Anbieter gefunden.',0),(74268,2063,'en','No vendors found.',0),(74269,2064,'is','',0),(74270,2064,'dr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ø¯Ø± ÙØ§ÙŠÙ„ Ù†ÙŠØ³Øª ',0),(74271,2064,'pr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ø¯Ø± ÙØ§ÙŠÙ„ Ù†ÙŠØ³Øª ',0),(74272,2064,'tr','Dosya yok satÄ±cÄ±lar',0),(74273,2064,'pl','Nie dostawcÃ³w w pliku',0),(74274,2064,'bg','ÐÑÐ¼Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð²ÑŠÐ² Ñ„Ð°Ð¹Ð»',0),(74275,2064,'ur','Ù…Ø³Ù„ Ù…ÛŒÚº Ú©ÙˆØ¦ÛŒ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº',0),(74276,2064,'sr','ÐÐµÐ¼Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(74277,2064,'vi','KhÃ´ng tháº¥y ngÆ°á»i bÃ¡n trong há»“ sÆ¡',0),(74278,2064,'af','Geen Verskaffers in LÃªer',0),(74279,2064,'ro','Nu vÃ¢nzÄƒtorii Ã®n fiÅŸier',0),(74280,2064,'et','Tarnijaid failis ei ole',0),(74281,2064,'si','Ni dobaviteljev v datoteko',0),(74282,2064,'ba','Tidak ada vendor di File',0),(74283,2064,'nl','Geen leveranciers in bestand',0),(74284,2064,'fi','Ole myyjiÃ¤ tiedosto',0),(74285,2064,'no','Ingen leverandÃ¸rer i filen',0),(74286,2064,'da','Ingen kreditorer i fil',0),(74287,2064,'ko','íŒŒì¼ì—ì„œ ì—†ìŒ ê³µê¸‰ ì—…ì²´',0),(74288,2064,'he','××™×Ÿ ×¡×¤×§×™× ×‘×§×•×‘×¥',0),(74289,2064,'el','ÎšÎ±Î¼Î¯Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ ÏƒÏ„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(74290,2064,'zh','åœ¨æ–‡ä»¶ä¸­æ²¡æœ‰ä¾›åº”å•†\r\n',0),(74291,2064,'sv','Inga leverantÃ¶rer i filen',0),(74292,2064,'it','Nessun fornitori nel File',0),(74293,2064,'tl','',0),(74294,2064,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3651;&#3609;&#3652;&#3615;&#3621;&#3660;',0),(74295,2064,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤®à¥‡à¤‚ à¤•à¥‹à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(74296,2064,'ms','Vendor tidak dalam fail',0),(74297,2064,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…ÙˆØ±Ù‘Ø¯ÙˆÙ† ÙÙŠ Ø§Ù„Ù…Ù„ÙÙ‘',0),(74298,2064,'fr','Aucun vendeurs dans fichier',0),(74299,2064,'jp','ãƒ•ã‚¡ã‚¤ãƒ«å†…ã?«æ¥­è€…ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(74300,2064,'pt','NÃ£o hÃ¡ vendedores no arquivo.',0),(74301,2064,'ru','Ð’ Ð¤Ð°Ð¹Ð»Ðµ ÐÐµÑ‚ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(74302,2064,'es','No hay Proveedores en el File',0),(74303,2064,'de','Kein Anbieter in Datei',0),(74304,2064,'en','No Vendors in File',0),(74305,2065,'is','',0),(74306,2065,'dr','Ù‡ÙŠÚ† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(74307,2065,'pr','Ù‡ÙŠÚ† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(74308,2065,'tr','SeÃ§ili hiÃ§bir fiÅŸ.',0),(74309,2065,'pl','Nie zaÅ‚Ä…cznika wybranego.',0),(74310,2065,'bg','ÐÐµ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð°.',0),(74311,2065,'ur','Ú©ÙˆØ¦ÛŒ ÙˆØ§Ø¤Ú†Ø± Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº Û”',0),(74312,2065,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°.',0),(74313,2065,'vi','ChÆ°a chá»n phiáº¿u',0),(74314,2065,'af','Geen Bewysstuk gekies.',0),(74315,2065,'ro','Nici un Voucher selectate.',0),(74316,2065,'et','Ãœkski kanne valitud.',0),(74317,2065,'si','Brez kupona, izbrani.',0),(74318,2065,'ba','Voucher tidak dipilih.',0),(74319,2065,'nl','Geen Voucher geselecteerd.',0),(74320,2065,'fi','Ei valittu tosite.',0),(74321,2065,'no','Ingen bilaget valgt.',0),(74322,2065,'da','Ingen Voucher valgt.',0),(74323,2065,'ko','ì•„ë‹ˆ ë°”ìš°ì²˜ ì„ ì •ìž…ë‹ˆë‹¤.',0),(74324,2065,'he','×”×©×•×‘×¨ ×œ× × ×‘×—×¨.',0),(74325,2065,'el','Î”ÎµÎ½ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹.',0),(74326,2065,'zh','æ— é€‰å®šçš„å‡­è¯ã€‚\r\n',0),(74327,2065,'sv','Ingen Verifikation markerat.',0),(74328,2065,'it','Nessun giustificativo selezionato.',0),(74329,2065,'tl','',0),(74330,2065,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3592;&#3656;&#3634;&#3618;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(74331,2065,'hi','à¤•à¥‹à¤ˆ à¤µà¤¾à¤‰à¤šà¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(74332,2065,'ms','Tiada baucar yang dipilih.',0),(74333,2065,'ar','Ù„Ø§ Ø§Ù„Ø¥ÙŠØµØ§Ù„ Ø§Ù„Ù…Ø­Ø¯Ø¯.',0),(74334,2065,'fr','Aucune piÃ¨ce justificative sÃ©lectionnÃ©.',0),(74335,2065,'jp','ä¼?ç¥¨ã?Œé?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(74336,2065,'pt','Nenhum Voucher selecionado.',0),(74337,2065,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½.',0),(74338,2065,'es','No se seleccionÃ³ un Voucher',0),(74339,2065,'de','Keine Voucher ausgewÃ¤hlt.',0),(74340,2065,'en','No Voucher selected.',0),(74341,2066,'is','',0),(74342,2066,'dr','Ù‡ÙŠÚ† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù…Ø·Ø§Ø¨Ù‚ Ù…Ø¹ÙŠØ§Ø±Ù‡Ø§ÙŠ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74343,2066,'pr','Ù‡ÙŠÚ† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù…Ø·Ø§Ø¨Ù‚ Ù…Ø¹ÙŠØ§Ø±Ù‡Ø§ÙŠ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74344,2066,'tr','FiÅŸ yok gÃ¶ndermek iÃ§in belirtilen Ã¶lÃ§Ã¼tlerle eÅŸleÅŸen.',0),(74345,2066,'pl','Bony nie okreÅ›lonym kryteriom post.',0),(74346,2066,'bg','ÐÐµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸ Ð¼Ð°Ñ‡ ÑƒÐºÐ°Ð·Ð°Ð½Ð¸ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ð¸ Ð·Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ.',0),(74347,2066,'ur','Ú©ÙˆØ¦ÛŒ ÙˆØ§Ø¤Ú†Ø± Ù¾ÙˆØ³Ù¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø®ØªØµØ§ØµÛŒ Ú©Ø³ÙˆÙ¹ÛŒ Ø³Û’ Ù…Ø´Ø§Ø¨Û ÛÛ’ Û”',0),(74348,2066,'sr','ÐÐµÐ¼Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ ÑÐ° Ð½Ð°Ð²ÐµÐ´ÐµÐ½Ð¸Ð¼ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ñ˜ÑƒÐ¼Ð¸Ð¼Ð° ÐºÑšÐ¸Ð¶Ð¸.',0),(74349,2066,'vi','KhÃ´ng tháº¥y phiáº¿u phÃ¹ há»£p vá»›i tiÃªu chÃ­ Ä‘á»ƒ káº¿t chuyá»ƒn',0),(74350,2066,'af','Geen bewyse pas die gespesifiseerde kriteria te plaas.',0),(74351,2066,'ro','Voucherele nu se potrivi criteriile specificate pentru a posta.',0),(74352,2066,'et','Kandeid vasta kindlaksmÃ¤Ã¤ratud kriteeriumide sisestamiseks.',0),(74353,2066,'si','Ni bonov ustrezajo doloÄenim merilom za objavo.',0),(74354,2066,'ba','Voucher tidak cocok dengan kriteria yang ditetapkan untuk posting.',0),(74355,2066,'nl','Geen cheques aan de opgegeven criteria voldoen om te posten.',0),(74356,2066,'fi','Tositteita ei vastaa mÃ¤Ã¤ritettyjÃ¤ ehtoja lÃ¤hettÃ¤Ã¤.',0),(74357,2066,'no','Ingen bilag oppfyller de angitte kriteriene bokfÃ¸re.',0),(74358,2066,'da','Ingen vouchers matcher de angivne kriterier skal bogfÃ¸res.',0),(74359,2066,'ko','ì•„ë¬´ ì¦ì¸ ê²Œì‹œë¬¼ì— ì§€ì • ëœ ì¡°ê±´ì— ë§žëŠ”.',0),(74360,2066,'he','××™×Ÿ ×©×•×‘×¨×™× ×œ×”×ª××™× ×œ×§×¨×™×˜×¨×™×•× ×™× ×©×¦×•×™× ×• ×œ×¤×¨×¡×.',0),(74361,2066,'el','Î¤Î± ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î± Î´ÎµÎ½ ÏƒÏ…Î¼Ï†Ï‰Î½ÎµÎ¯ Î¼Îµ Ï„Î± ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î± ÎºÏÎ¹Ï„Î®ÏÎ¹Î± Î³Î¹Î± Î½Î± Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏƒÎµÏ„Îµ.',0),(74362,2066,'zh','æ²¡æœ‰å‡­è¯ä¸Žé‚®å¯„ç‰¹å®šæ ‡å‡†åŒ¹é…ã€‚\r\n',0),(74363,2066,'sv','Inga kuponger stÃ¤mmer med angivna villkor att bokfÃ¶ra.',0),(74364,2066,'it','Buoni corrispondono ai criteri specificati per postare.',0),(74365,2066,'tl','',0),(74366,2066,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(74367,2066,'hi','à¤•à¥‹à¤ˆ à¤µà¤¾à¤‰à¤šà¤° à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤®à¤¾à¤ªà¤¦à¤‚à¤¡ à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¤à¤¾à¥¤',0),(74368,2066,'ms','Baucar tidak sepadan dengan kriteria yang ditentukan untuk menghantar.',0),(74369,2066,'ar','Ù‚Ø³Ø§Ø¦Ù… Ù„Ø§ ØªØ·Ø§Ø¨Ù‚ Ø§Ù„Ù…Ø¹Ø§ÙŠÙŠØ± Ø§Ù„Ù…Ø­Ø¯Ø¯Ø© ÙˆØ¸ÙŠÙØ©.',0),(74370,2066,'fr','Aucun bons ne correspondent aux critÃ¨res spÃ©cifiÃ©s pour poster.',0),(74371,2066,'jp','ç‰¹å®šã?•ã‚Œã?ŸåŸºæº–ã?«é?©å?ˆã?™ã‚‹ä¼?ç¥¨ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(74372,2066,'pt','NÃ£o vales correspondem aos critÃ©rios especificados para postar.',0),(74373,2066,'ru','ÐÐµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‚ ÑƒÐºÐ°Ð·Ð°Ð½Ð½Ñ‹Ð¼ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸ÑÐ¼ Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚.',0),(74374,2066,'es','No hay vouchers que emparejan los criterios especificados para asentar',0),(74375,2066,'de','Keine Gutscheine entsprechen die angegebenen Kriterien zu verÃ¶ffentlichen.',0),(74376,2066,'en','No vouchers match the specified criteria to post.',0),(74377,2067,'is','',0),(74378,2067,'dr','Ù‡ÙŠÚ† Ù†ÙˆØ¹ ÙƒØ§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74379,2067,'pr','Ù‡ÙŠÚ† Ù†ÙˆØ¹ ÙƒØ§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74380,2067,'tr','HiÃ§bir iÅŸ tÃ¼rÃ¼ bulundu',0),(74381,2067,'pl','Nie rodzaj pracy, znaleÅºÄ‡',0),(74382,2067,'bg','ÐÑÐ¼Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(74383,2067,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ú©Ø§Ù… Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(74384,2067,'sr','ÐÐµÐ¼Ð° Ð²Ñ€ÑÑ‚Ðµ Ñ€Ð°Ð´Ð° Ð½Ð°ÑˆÐ»Ð¸',0),(74385,2067,'vi','KhÃ´ng tháº¥y loáº¡i cÃ´ng viá»‡c',0),(74386,2067,'af','Gee werktipes gevind',0),(74387,2067,'ro','Nu tipuri de muncÄƒ gÄƒsit',0),(74388,2067,'et','Ei leidnud tÃ¶Ã¶liigid',0),(74389,2067,'si','Ne vrste dela, naÅ¡el',0),(74390,2067,'ba','Ada jenis pekerjaan yang ditemukan',0),(74391,2067,'nl','Geen werksoorten gevonden',0),(74392,2067,'fi','Ei lÃ¶ytynyt tyÃ¶tyypit',0),(74393,2067,'no','Ingen arbeidstyper funnet',0),(74394,2067,'da','Ingen arbejdstyper fundet',0),(74395,2067,'ko','ìž‘í’ˆ í˜•ì‹ì€ ë°œê²¬',0),(74396,2067,'he','×œ× × ×ž×¦××• ×¡×•×’×™ ×¢×‘×•×“×”',0),(74397,2067,'el','Î”ÎµÎ½ Ï„Î¿Ï…Ï‚ Ï„ÏÏ€Î¿Ï…Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(74398,2067,'zh','æ²¡æœ‰æ‰¾åˆ°å·¥ä½œç±»åž‹\r\n',0),(74399,2067,'sv','Ingen arbetstyper som hittade',0),(74400,2067,'it','Nessun tipo di lavoro trovato',0),(74401,2067,'tl','',0),(74402,2067,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(74403,2067,'hi','à¤•à¥‹à¤ˆ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¤¾à¤¯à¤¾',0),(74404,2067,'ms','Tiada jenis kerja yang ditemui',0),(74405,2067,'ar','Ù„Ø§ Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(74406,2067,'fr','Pas trouvÃ©s de types de travail',0),(74407,2067,'jp','ä»•äº‹å†…å®¹ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(74408,2067,'pt','Nenhum tipo de trabalho encontrado',0),(74409,2067,'ru','ÐÐµÑ‚ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹Ñ… Ñ‚Ð¸Ð¿Ð¾Ð² Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(74410,2067,'es','No se encontraron tipos de trabajo',0),(74411,2067,'de','Keine Arbeitstypen gefunden',0),(74412,2067,'en','No work types found',0),(74413,2068,'is','',0),(74414,2068,'dr','NolaPro   Ø§ÙŠÙ…ÙŠÙ„ Ø§Ø².',0),(74415,2068,'pr','NolaPro   Ø§ÙŠÙ…ÙŠÙ„ Ø§Ø².',0),(74416,2068,'tr','NolaPro e-posta',0),(74417,2068,'pl','NolaPro wiadomoÅ›ci E-mail',0),(74418,2068,'bg','NolaPro Ð¿Ð¾Ñ‰Ð° Ð¾Ñ‚',0),(74419,2068,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ø§ÛŒ Ù…ÛŒÙ„',0),(74420,2068,'sr','ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ðµ-Ð¿Ð¾ÑˆÑ‚Ñƒ',0),(74421,2068,'vi','Email cá»§a NolaPro tá»«',0),(74422,2068,'af','NolaPro E-pos vanaf',0),(74423,2068,'ro','NolaPro E-mail la',0),(74424,2068,'et','Nolapro e-kiri saatjalt',0),(74425,2068,'si','NolaPro e-poÅ¡to iz',0),(74426,2068,'ba','NolaPro E-mail dari',0),(74427,2068,'nl','NolaPro E-mail van',0),(74428,2068,'fi','NolaPro sÃ¤hkÃ¶posti',0),(74429,2068,'no','NolaPro e-post fra',0),(74430,2068,'da','NolaPro E-mail fra',0),(74431,2068,'ko','NolaPro ì „ìž ë©”ì¼',0),(74432,2068,'he','NolaPro ×“×•××¨ ××œ×§×˜×¨×•× ×™',0),(74433,2068,'el','NolaPro Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î±Ï€ÏŒ',0),(74434,2068,'zh','NolaProç”µå­é‚®ä»¶æ¥è‡ª\r\n',0),(74435,2068,'sv','NolaPro e-post frÃ¥n',0),(74436,2068,'it','NolaPro E-mail da',0),(74437,2068,'tl','',0),(74438,2068,'th','NolaPro &#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3592;&#3634;&#3585;',0),(74439,2068,'hi','NolaPro à¤ˆ-à¤®à¥‡à¤² à¤¸à¥‡',0),(74440,2068,'ms','NolaPro e-mel daripada',0),(74441,2068,'ar','Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù…Ù†',0),(74442,2068,'fr','Courriel NolaPro',0),(74443,2068,'jp','ï½žã?®NolaProEãƒ¡ãƒ¼ãƒ«',0),(74444,2068,'pt','NolaPro E-mail de',0),(74445,2068,'ru','NolaPro ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð¾Ñ‚',0),(74446,2068,'es','NolaPro Email de',0),(74447,2068,'de','Artikel E-mail von',0),(74448,2068,'en','NolaPro E-mail from',0),(74449,2069,'is','',0),(74450,2069,'dr','NolaPro Ø³Ø§ÙØª ÙˆÛŒØ± ',0),(74451,2069,'pr','NolaPro Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ',0),(74452,2069,'tr','NolaPro yazÄ±lÄ±m',0),(74453,2069,'pl','NolaPro oprogramowania',0),(74454,2069,'bg','NolaPro ÑÐ¾Ñ„Ñ‚ÑƒÐµÑ€',0),(74455,2069,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ø³Ø§ÙÙ¹ ÙˆÛŒØ¦Ø±',0),(74456,2069,'sr','ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ ÑÐ¾Ñ„Ñ‚Ð²ÐµÑ€',0),(74457,2069,'vi','Pháº§n má»m NolaPro',0),(74458,2069,'af','NolaPro Sagteware',0),(74459,2069,'ro','NolaPro Software',0),(74460,2069,'et','NolaPro tarkvara',0),(74461,2069,'si','Programska oprema NolaPro',0),(74462,2069,'ba','NolaPro perangkat lunak',0),(74463,2069,'nl','NolaPro Software',0),(74464,2069,'fi','NolaPro ohjelmisto',0),(74465,2069,'no','NolaPro programvare',0),(74466,2069,'da','NolaPro Software',0),(74467,2069,'ko','NolaPro ì†Œí”„íŠ¸ì›¨ì–´',0),(74468,2069,'he','NolaPro ×ª×•×›× ×ª',0),(74469,2069,'el','NolaPro Î»Î¿Î³Î¹ÏƒÎ¼Î¹ÎºÎ¿Ï',0),(74470,2069,'zh','NolaProè½¯ä»¶\r\n',0),(74471,2069,'sv','NolaPro programvara',0),(74472,2069,'it','NolaPro Software',0),(74473,2069,'tl','',0),(74474,2069,'th','NolaPro Software',0),(74475,2069,'hi','NolaPro à¤¸à¥‰à¤«à¥à¤Ÿà¤µà¥‡à¤¯à¤°',0),(74476,2069,'ms','Perisian NolaPro',0),(74477,2069,'ar','Ø¨Ø±Ø§Ù…Ø¬ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ',0),(74478,2069,'fr','Logiciel NolaPro',0),(74479,2069,'jp','NolaProã‚½ãƒ•ãƒˆã‚¦ã‚§ã‚¢',0),(74480,2069,'pt','NolaPro Software',0),(74481,2069,'ru','NolaPro Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ð½Ð¾Ðµ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ðµ',0),(74482,2069,'es','NolaPro Software',0),(74483,2069,'de','Artikel Software',0),(74484,2069,'en','NolaPro Software',0),(74485,2070,'is','',0),(74486,2070,'dr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù…',0),(74487,2070,'pr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù…',0),(74488,2070,'tr','hiÃ§biri',0),(74489,2070,'pl','Brak',0),(74490,2070,'bg','Ð½ÑÐ¼Ð°',0),(74491,2070,'ur','Ú©ÙˆØ¦ÛŒ Ù†ÛÛŒÚº',0),(74492,2070,'sr','ÐÐ¸ÐºÐ¾ Ð½Ð¸Ñ˜Ðµ',0),(74493,2070,'vi','khÃ´ng',0),(74494,2070,'af','geen',0),(74495,2070,'ro','nici unul',0),(74496,2070,'et','Ã¼kski',0),(74497,2070,'si','nobena',0),(74498,2070,'ba','tidak ada',0),(74499,2070,'nl','geen',0),(74500,2070,'fi','ei mitÃ¤Ã¤n',0),(74501,2070,'no','ingen',0),(74502,2070,'da','ingen',0),(74503,2070,'ko','ì—†ìŒ',0),(74504,2070,'he','×›×œ×•×',0),(74505,2070,'el','ÎºÎ±Î½Î­Î½Î±Ï‚',0),(74506,2070,'zh','æ— \r\n',0),(74507,2070,'sv','ingen',0),(74508,2070,'it','nessuno',0),(74509,2070,'tl','',0),(74510,2070,'th','&#3652;&#3617;&#3656;&#3617;&#3637;',0),(74511,2070,'hi','à¤•à¥‹à¤ˆ à¤¨à¤¹à¥€à¤‚',0),(74512,2070,'ms','Tiada seorang pun',0),(74513,2070,'ar','Ù„Ø§ Ø´ÙŠØ¡',0),(74514,2070,'fr','aucun',0),(74515,2070,'jp','ã?²ã?¨ã?¤ã‚‚ã?ªã?„',0),(74516,2070,'pt','nenhum',0),(74517,2070,'ru','Ð½ÐµÑ‚',0),(74518,2070,'es','ninguno',0),(74519,2070,'de','keine',0),(74520,2070,'en','none',0),(74521,2071,'is','',0),(74522,2071,'dr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(74523,2071,'pr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(74524,2071,'tr','HiÃ§biri seÃ§ili',0),(74525,2071,'pl','Brak zaznaczenia',0),(74526,2071,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½',0),(74527,2071,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ú¾ÛŒ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§',0),(74528,2071,'sr','ÐÐ¸ÑˆÑ‚Ð° Ð½Ð¸Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾',0),(74529,2071,'vi','ChÆ°a chá»n',0),(74530,2071,'af','Geen Geselekteer',0),(74531,2071,'ro','Nici unul selectate',0),(74532,2071,'et','Pole valitud',0),(74533,2071,'si','NiÄ ni izbrano',0),(74534,2071,'ba','Tidak ada yang dipilih',0),(74535,2071,'nl','Geen geselecteerd',0),(74536,2071,'fi','Ei valintaa',0),(74537,2071,'no','Ingen valgt',0),(74538,2071,'da','Ingen valgt',0),(74539,2071,'ko','ì„ íƒ ì—†ìŒ',0),(74540,2071,'he','×œ×œ× ×‘×—×™×¨×”',0),(74541,2071,'el','ÎšÎ±Î½Î­Î½Î±Ï‚ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯',0),(74542,2071,'zh','æœªé€‰æ‹©\r\n',0),(74543,2071,'sv','Ingen vald',0),(74544,2071,'it','Nessuna selezione',0),(74545,2071,'tl','',0),(74546,2071,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(74547,2071,'hi','à¤¸à¥‡ à¤•à¥‹à¤ˆ à¤­à¥€ à¤šà¤¯à¤¨à¤¿à¤¤',0),(74548,2071,'ms','Tiada butir dipilih.',0),(74549,2071,'ar','Ù„Ù… ØªØ®ØªØ± Ø£ÙŠ Ø´ÙŠØ¡',0),(74550,2071,'fr','Aucun sÃ©lectionnÃ©',0),(74551,2071,'jp','ä¸€ã?¤ã‚‚é?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(74552,2071,'pt','Nenhum selecionado',0),(74553,2071,'ru','ÐÐ¸ ÐžÐ´Ð¸Ð½ ÐÐµ Ð’Ñ‹Ð±Ñ€Ð°Ð½',0),(74554,2071,'es','Ninguno Seleccionado',0),(74555,2071,'de','Nichts ausgewÃ¤hlt',0),(74556,2071,'en','None Selected',0),(74557,2072,'is','',0),(74558,2072,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¹Ù…Ù„ÙŠØ§Øª Ø¹Ø¯Ù… Ú†Ø§Ù¾ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(74559,2072,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¹Ù…Ù„ÙŠØ§Øª Ø¹Ø¯Ù… Ú†Ø§Ù¾ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(74560,2072,'tr','Non-baskÄ± iÅŸlemi boyutu baÅŸarÄ±yla eklendi.',0),(74561,2072,'pl','Non wydruk operacji rozmiar dodane pomyÅ›lnie.',0),(74562,2072,'bg','Ð¡Ñ‚Ð°Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸ÑÑ‚Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(74563,2072,'ur','ØºÛŒØ±-Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº Ø¹Ù…Ù„ÛŒÛ Ø³Ø§Ø¦Ø² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(74564,2072,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð° Ð½Ð¾Ð½-Ð¿Ñ€Ð¸Ð½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(74565,2072,'vi','ThÃªm cá»¡ hÃ nh Ä‘á»™ng giÃ¡ khÃ´ng in thÃ nh cÃ´ng',0),(74566,2072,'af','Nie-Uitdrukbare Bewerkingsgrootte suksesvol opdateer.',0),(74567,2072,'ro','Non-imprimare funcÅ£ionarea dimensiunea adÄƒugat cu succes.',0),(74568,2072,'et','Non-Prindi operatsioon suurus edukalt lisatud.',0),(74569,2072,'si','Non-print delovanje velikost uspeÅ¡no dodana.',0),(74570,2072,'ba','Ukuran operasi bebas-cetak ditambahkan berhasil.',0),(74571,2072,'nl','Non-print operatie grootte toegevoegd.',0),(74572,2072,'fi','-Print toimintaa koko lisÃ¤Ã¤minen onnistui.',0),(74573,2072,'no','Ikke-drift utskriftsstÃ¸rrelse lagt.',0),(74574,2072,'da','Non-print Operation stÃ¸rrelse tilfÃ¸jet.',0),(74575,2072,'ko','ë¹„ ì¸ì‡„ ìž‘ì—… í¬ê¸°ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(74576,2072,'he','Non-×”×“×¤×¡ ×’×•×“×œ ×ž×‘×¦×¢ × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(74577,2072,'el','ÎœÎ·-print Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(74578,2072,'zh','éžå°åˆ·æ“ä½œè§„æ¨¡æ·»åŠ æˆåŠŸã€‚\r\n',0),(74579,2072,'sv','Icke-print drift storlek lagts.',0),(74580,2072,'it','Dimensioni di funzionamento non-stampa aggiunto con successo.',0),(74581,2072,'tl','',0),(74582,2072,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3609;&#3634;&#3604;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3',0),(74583,2072,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤ªà¤°à¥‡à¤¶à¤¨ à¤†à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(74584,2072,'ms','Saiz operasi bebas-cetak berjaya menambah.',0),(74585,2072,'ar','Ø¹Ø¯Ù… Ø·Ø¨Ø§Ø¹Ø© \"Ø­Ø¬Ù… Ø¹Ù…Ù„ÙŠØ©\" Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(74586,2072,'fr','OpÃ©ration de non impression taille ajoutÃ© avec succÃ¨s.',0),(74587,2072,'jp','é?žå?°åˆ·ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã‚µã‚¤ã‚ºã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(74588,2072,'pt','Tamanho de operaÃ§Ã£o sem impressÃ£o adicionado com Ãªxito.',0),(74589,2072,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ non Ð¿Ñ€Ð¸Ð½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(74590,2072,'es','OperaciÃ³n de No Imprimir agregado exitosamente',0),(74591,2072,'de','Non-Print-Operation-GrÃ¶ÃŸe wurde erfolgreich hinzugefÃ¼gt.',0),(74592,2072,'en','Non-print Operation Size added successfully.',0),(74593,2073,'is','',0),(74594,2073,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¹Ù…Ù„ÙŠØ§Øª Ø¹Ø¯Ù… Ú†Ø§Ù¾ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(74595,2073,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¹Ù…Ù„ÙŠØ§Øª Ø¹Ø¯Ù… Ú†Ø§Ù¾ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(74596,2073,'tr','Non-baskÄ± iÅŸlemi boyutu baÅŸarÄ±yla silindi.',0),(74597,2073,'pl','Non wydruk operacji rozmiar usuniÄ™te pomyÅ›lnie.',0),(74598,2073,'bg','Ð¡Ñ‚Ð°Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸ÑÑ‚Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(74599,2073,'ur','ØºÛŒØ±-Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº Ø¹Ù…Ù„ÛŒÛ Ø³Ø§Ø¦Ø² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(74600,2073,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð° Ð½Ð¾Ð½-Ð¿Ñ€Ð¸Ð½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(74601,2073,'vi','XÃ³a cá»¡ hÃ nh Ä‘á»™ng giÃ¡ khÃ´ng in thÃ nh cÃ´ng',0),(74602,2073,'af','Nie-Uitdrukbare Operasie Grootte is suksesvol geskrap.',0),(74603,2073,'ro','Non-imprimare funcÅ£ionarea dimensiunea ÅŸters cu succes.',0),(74604,2073,'et','Non-Prindi operatsioon suurus edukalt kustutatud.',0),(74605,2073,'si','Non-print delovanje velikost uspeÅ¡no izbrisana.',0),(74606,2073,'ba','Ukuran operasi bebas-cetak berhasil dihapus.',0),(74607,2073,'nl','Non-print operatie grootte met succes verwijderd.',0),(74608,2073,'fi','-Print toimintaa koko poistettu.',0),(74609,2073,'no','Ikke-drift utskriftsstÃ¸rrelse slettet.',0),(74610,2073,'da','Non-print Operation stÃ¸rrelse slettet.',0),(74611,2073,'ko','ë¹„ ì¸ì‡„ ìž‘ì—… í¬ê¸°ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(74612,2073,'he','Non-×”×“×¤×¡ ×ž×‘×¦×¢ ×’×•×“×œ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(74613,2073,'el','ÎœÎ·-print Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(74614,2073,'zh','éžå°åˆ·æ“ä½œè§„æ¨¡å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(74615,2073,'sv','Icke-print drift storlek raderades.',0),(74616,2073,'it','Dimensioni di funzionamento non-stampa eliminato con successo.',0),(74617,2073,'tl','',0),(74618,2073,'th','&#3621;&#3610;&#3586;&#3609;&#3634;&#3604;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3626;&#3635;&#3',0),(74619,2073,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤ªà¤°à¥‡à¤¶à¤¨ à¤†à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(74620,2073,'ms','Saiz operasi bebas-cetak dihapuskan dengan jayanya.',0),(74621,2073,'ar','Ø¹Ø¯Ù… Ø·Ø¨Ø§Ø¹Ø© \"Ø­Ø¬Ù… Ø¹Ù…Ù„ÙŠØ©\" Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(74622,2073,'fr','OpÃ©ration de non impression taille supprimÃ© avec succÃ¨s.',0),(74623,2073,'jp','é?žå?°åˆ·ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã‚µã‚¤ã‚ºã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(74624,2073,'pt','Tamanho de operaÃ§Ã£o sem impressÃ£o excluÃ­do com sucesso.',0),(74625,2073,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ non Ð¿Ñ€Ð¸Ð½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(74626,2073,'es','OperaciÃ³n de No Imprimir eliminado exitosamente',0),(74627,2073,'de','Non-Print-Operation-GrÃ¶ÃŸe erfolgreich gelÃ¶scht.',0),(74628,2073,'en','Non-print Operation Size deleted successfully.',0),(74629,2074,'is','',0),(74630,2074,'dr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØª Ú†Ø§Ù¾ Ø´Ø¯Ù‡ Ø§ÙŠ ',0),(74631,2074,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØª Ú†Ø§Ù¾ Ø´Ø¯Ù‡ Ø§ÙŠ ',0),(74632,2074,'tr','BaskÄ±da iÅŸlemi',0),(74633,2074,'pl','Operacja niedrukowalne',0),(74634,2074,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð½Ð¸Ñ‚Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ',0),(74635,2074,'ur','ØºÛŒØ± Ø·Ø¨Ø§Ø¹Øª Ø¢Ù¾Ø±ÛŒØ´Ù†',0),(74636,2074,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð° ÐºÐ¾Ñ˜Ð° ÑÐµ Ð½Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°',0),(74637,2074,'vi','HÃ nh Ä‘á»™ng chÆ°a in',0),(74638,2074,'af','Nie-druk bewerking',0),(74639,2074,'ro','OperaÈ›iunea nu se imprimÄƒ',0),(74640,2074,'et','Printimatu operatsiooni',0),(74641,2074,'si','Nenatisljivo delovanje',0),(74642,2074,'ba','Operasi bebas-Percetakan',0),(74643,2074,'nl','Niet-afdrukbare werking',0),(74644,2074,'fi','Tulostumattomat toiminta',0),(74645,2074,'no','Ikke-utskrivbare operasjon',0),(74646,2074,'da','Trykfri drift',0),(74647,2074,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ìž‘ì—…',0),(74648,2074,'he','×ž×‘×¦×¢ ×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×”',0),(74649,2074,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(74650,2074,'zh','éžå°åˆ·æ“ä½œ\r\n',0),(74651,2074,'sv','Icke utskrivbara drift',0),(74652,2074,'it','Operazione non stampabili',0),(74653,2074,'tl','',0),(74654,2074,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(74655,2074,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤ªà¤°à¥‡à¤¶à¤¨',0),(74656,2074,'ms','Operasi bebas-percetakan',0),(74657,2074,'ar','Ø§Ù„Ø¹Ù…Ù„ÙŠØ© ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(74658,2074,'fr','OpÃ©ration non imprimables',0),(74659,2074,'jp','é?žå?°åˆ·ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³',0),(74660,2074,'pt','OperaÃ§Ã£o nÃ£o-imprimÃ­veis',0),(74661,2074,'ru','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ñ-Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ',0),(74662,2074,'es','OperaciÃ³n No Imprimir',0),(74663,2074,'de','Nicht druckbare Betrieb',0),(74664,2074,'en','Non-printing Operation',0),(74665,2075,'is','',0),(74666,2075,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø¹Ù…Ù„ÙŠØ§Øª Ø¹Ø¯Ù… Ú†Ø§Ù¾ ',0),(74667,2075,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø¹Ù…Ù„ÙŠØ§Øª Ø¹Ø¯Ù… Ú†Ø§Ù¾ ',0),(74668,2075,'tr','YazdÄ±rÄ±lmayan iÅŸlemi seÃ§im listesi gÃ¼ncelleme',0),(74669,2075,'pl','Niedrukowalne aktualizacja listy wyboru operacji',0),(74670,2075,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ ÑÐ¿Ð¸ÑÑŠÐº Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(74671,2075,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ø¢Ù¾Ø±ÛŒØ´Ù† Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(74672,2075,'sr','ÐžÐ¸Ð²Ð¸Ñ‡ÐµÐ½ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ñƒ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð»Ð¸ÑÑ‚Ð° Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(74673,2075,'vi','Cáº­p Nháº­t Danh SÃ¡ch CÃ¡c Hoáº¡t Äá»™ng KhÃ´ng In',0),(74674,2075,'af','Nonprinting werking seleksie lys bywerking',0),(74675,2075,'ro','Neimprimabile funcÅ£ionarea selecÅ£ie lista actualizare',0),(74676,2075,'et','Mitteprinditavate operatsiooni valiku uuendamisel',0),(74677,2075,'si','Nenatisljivi delovanje izbor seznam posodobitev',0),(74678,2075,'ba','Nonprinting operasi pilihan daftar Update',0),(74679,2075,'nl','Niet-afdrukbare operatie selectie lijst Update',0),(74680,2075,'fi','Tulostumattomien toiminnon valinta pÃ¤ivitys',0),(74681,2075,'no','Ikke-utskrivbare operasjonen utvalg List oppdatering',0),(74682,2075,'da','Afsnitstegn Operation udvalg liste Update',0),(74683,2075,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ìž‘ì—… ì„ íƒ ëª©ë¡ ì—…ë°ì´íŠ¸',0),(74684,2075,'he','×¢×“×›×•×Ÿ ×¨×©×™×ž×ª ×‘×—×™×¨×” ×ž×‘×¦×¢ ×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×”',0),(74685,2075,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚',0),(74686,2075,'zh','éžæ‰“å°æ“ä½œé€‰æ‹©æ¸…å•æ›´æ–°\r\n',0),(74687,2075,'sv','Icke utskrivbara drift urval uppdatering',0),(74688,2075,'it','Operazione non stampabili selezione elenco aggiornamento',0),(74689,2075,'tl','',0),(74690,2075,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660; &#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3614;&#3639;&#',0),(74691,2075,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤‘à¤ªà¤°à¥‡à¤¶à¤¨ à¤šà¤¯à¤¨ à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(74692,2075,'ms','Nonprinting operasi pilihan senarai Kemaskini',0),(74693,2075,'ar','ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø¹Ù…Ù„ÙŠØ© ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(74694,2075,'fr','Non imprimables opÃ©ration sÃ©lection liste mise Ã  jour',0),(74695,2075,'jp','é?žå?°åˆ·ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³é?¸æŠžãƒªã‚¹ãƒˆã?®æ›´æ–°',0),(74696,2075,'pt','NÃ£o imprimÃ­veis atualizaÃ§Ã£o de lista de seleÃ§Ã£o de operaÃ§Ã£o',0),(74697,2075,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ð²Ñ‹Ð±Ð¾Ñ€Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(74698,2075,'es','ActualizaciÃ³n de la Lista de SelecciÃ³n de OperaciÃ³n No Imprimir',0),(74699,2075,'de','Nicht druckbare Betrieb Auswahl Liste Update',0),(74700,2075,'en','Non-printing Operation Selection List Update',0),(74701,2076,'is','',0),(74702,2076,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†Ø¯Ø§Ø²Ù‡  Ø¹Ù…Ù„ÙŠØ§Øª Ø¹Ø¯Ù… Ú†Ø§Ù¾ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74703,2076,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†Ø¯Ø§Ø²Ù‡  Ø¹Ù…Ù„ÙŠØ§Øª Ø¹Ø¯Ù… Ú†Ø§Ù¾ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74704,2076,'tr','Non-yazdÄ±rma iÅŸlemi boyutu baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(74705,2076,'pl','Niedrukowalne operacji rozmiar pomyÅ›lnie zaktualizowana.',0),(74706,2076,'bg','Ð¡Ñ‚Ð°Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸ÑÑ‚Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(74707,2076,'ur','ØºÛŒØ± Ø·Ø¨Ø§Ø¹Øª Ø¢Ù¾Ø±ÛŒØ´Ù† Ø³Ø§Ø¦Ø² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(74708,2076,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð° Ð½Ð¾Ð½-ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ.',0),(74709,2076,'vi','Cáº­p Nháº­t CÃ¡c KÃ­ch Cá»¡ Hoáº¡t Äá»™ng KhÃ´ng In thÃ nh cÃ´ng',0),(74710,2076,'af','Nie-Uitdrukbare Bewerkingsgrootte suksesvol opdateer.',0),(74711,2076,'ro','Non-tipÄƒrire funcÅ£ionarea dimensiunea actualizat cu succes.',0),(74712,2076,'et','Non-printimise operatsiooni maht vÃ¤rskendamine Ãµnnestus.',0),(74713,2076,'si','Non-tiskanje delovanje velikost uspeÅ¡no posodobljena.',0),(74714,2076,'ba','Ukuran operasi bebas-printing diperbarui berhasil.',0),(74715,2076,'nl','Niet-afdrukbare operatie grootte bijgewerkt.',0),(74716,2076,'fi','Tulostumaton toimintaa koko pÃ¤ivitettiin onnistuneesti.',0),(74717,2076,'no','Ikke skrives operasjonen stÃ¸rrelse oppdatert.',0),(74718,2076,'da','Ikke udskrives Operation stÃ¸rrelse opdateret.',0),(74719,2076,'ko','ë¹„ ì¸ì‡„ ìž‘ì—…ì´ í¬ê¸° ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(74720,2076,'he','×’×•×“×œ ×¤×¢×•×œ×” ×©××™× ×” ×ž×•×“×¤×¡×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(74721,2076,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(74722,2076,'zh','éžæ‰“å°æ“ä½œè§„æ¨¡å·²æˆåŠŸæ›´æ–°ã€‚\r\n',0),(74723,2076,'sv','Ej utskrivbar drift storlek uppdaterats.',0),(74724,2076,'it','Dimensioni di funzionamento non stampabili aggiornato con successo.',0),(74725,2076,'tl','',0),(74726,2076,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660; &#3652;&#3604;&#3657;&#3607;&#3635;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#',0),(74727,2076,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤ªà¤°à¥‡à¤¶à¤¨ à¤†à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(74728,2076,'ms','Saiz operasi bebas-percetakan berjaya dikemas kini.',0),(74729,2076,'ar','Ø¹Ø¯Ù… Ø·Ø¨Ø§Ø¹Ø© \"Ø­Ø¬Ù… Ø¹Ù…Ù„ÙŠØ©\" Ø§Ù„ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(74730,2076,'fr','Taille de fonctionnement non imprimable correctement mis Ã  jour.',0),(74731,2076,'jp','é?žå?°åˆ·ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã‚µã‚¤ã‚ºã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(74732,2076,'pt','Tamanho de operaÃ§Ã£o non-impressÃ£o atualizado com Ãªxito.',0),(74733,2076,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(74734,2076,'es','TamaÃ±o de la OperaciÃ³n No Imprimir actualizado exitosamente',0),(74735,2076,'de','Nicht druckbare Operation GrÃ¶ÃŸe erfolgreich aktualisiert.',0),(74736,2076,'en','Non-printing Operation Size updated successfully.',0),(74737,2077,'is','',0),(74738,2077,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(74739,2077,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(74740,2077,'tr','YazdÄ±rÄ±lmayan fiyat listesi',0),(74741,2077,'pl','Niedrukowalne Cennik',0),(74742,2077,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(74743,2077,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(74744,2077,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(74745,2077,'vi','Danh sÃ¡ch giÃ¡ khÃ´ng in',0),(74746,2077,'af','Nonprinting prys lys',0),(74747,2077,'ro','Lista de preturi neimprimabile',0),(74748,2077,'et','Mitteprinditavate hinnakiri',0),(74749,2077,'si','Nenatisljivi cenik',0),(74750,2077,'ba','Nonprinting daftar harga',0),(74751,2077,'nl','Niet-afdrukbare prijslijst',0),(74752,2077,'fi','Tulostumattomien hinnasto',0),(74753,2077,'no','Ikke-utskrivbare prisliste',0),(74754,2077,'da','Afsnitstegn prisliste',0),(74755,2077,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²©í‘œ',0),(74756,2077,'he','×ž×—×™×¨×•×Ÿ ×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×”',0),(74757,2077,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(74758,2077,'zh','éžæ‰“å°ä»·æ ¼è¡¨\r\n',0),(74759,2077,'sv','Icke utskrivbar prislista',0),(74760,2077,'it','Listino prezzi non stampabili',0),(74761,2077,'tl','',0),(74762,2077,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(74763,2077,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€',0),(74764,2077,'ms','Senarai Harga nonprinting',0),(74765,2077,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(74766,2077,'fr','Liste de prix non imprimables',0),(74767,2077,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨',0),(74768,2077,'pt','Lista de preÃ§o nÃ£o imprimÃ­veis',0),(74769,2077,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(74770,2077,'es','Lista de Precios de No Imprimir',0),(74771,2077,'de','Nicht druckbare Preisliste',0),(74772,2077,'en','Non-printing Price List',0),(74773,2078,'is','',0),(74774,2078,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(74775,2078,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(74776,2078,'tr','YazdÄ±rÄ±lmayan fiyat listesi ekleme',0),(74777,2078,'pl','Cena niedrukowane listy dodaÄ‡',0),(74778,2078,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð° Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(74779,2078,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(74780,2078,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ñ†ÐµÐ½Ð° Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ',0),(74781,2078,'vi','ThÃªm Danh sÃ¡ch giÃ¡ khÃ´ng in',0),(74782,2078,'af','Ongedrukte Pryslys Byvoeg',0),(74783,2078,'ro','Neimprimabile preÅ£ listÄƒ Adauga',0),(74784,2078,'et','Mitteprinditavate hind nimekirja lisada',0),(74785,2078,'si','Nenatisljivi cena seznam dodati',0),(74786,2078,'ba','Harga nonprinting menambahkan daftar',0),(74787,2078,'nl','Niet-afdrukbare prijs lijst toevoegen',0),(74788,2078,'fi','Tulostumattomien hinta luettelon lisÃ¤Ã¤minen',0),(74789,2078,'no','Ikke-utskrivbare pris listen Legg',0),(74790,2078,'da','Afsnitstegn pris liste tilfÃ¸je',0),(74791,2078,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡ ì¶”ê°€',0),(74792,2078,'he','×ž×—×™×¨ ×©××™× ×• × ×™×ª×Ÿ ×œ×”×“×¤×¡×” ×”×•×¡×£ ×¨×©×™×ž×”',0),(74793,2078,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Ï„Î¹Î¼Î® Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î»Î¯ÏƒÏ„Î±',0),(74794,2078,'zh','éžæ‰“å°ä»·æ ¼åˆ—è¡¨æ·»åŠ \r\n',0),(74795,2078,'sv','Icke utskrivbara pris lista lÃ¤gga till',0),(74796,2078,'it','Prezzo non stampabile elenco Aggiungi',0),(74797,2078,'tl','',0),(74798,2078,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(74799,2078,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(74800,2078,'ms','Nonprinting harga senarai Tambah',0),(74801,2078,'ar','Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø© Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø©',0),(74802,2078,'fr','Prix non imprimable liste ajouter',0),(74803,2078,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã?®è¿½åŠ ',0),(74804,2078,'pt','PreÃ§o nÃ£o-imprimÃ­vel lista Adicionar',0),(74805,2078,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐ¾Ðº Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(74806,2078,'es','Lista de Precios de No Imprimir Agregar',0),(74807,2078,'de','Nicht druckbare Preis Liste hinzufÃ¼gen',0),(74808,2078,'en','Non-printing Price List Add',0),(74809,2079,'is','',0),(74810,2079,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74811,2079,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74812,2079,'tr','YazdÄ±rÄ±lmayan fiyat listesi baÅŸarÄ±yla eklendi.',0),(74813,2079,'pl','Cennik niedrukowane dodane pomyÅ›lnie.',0),(74814,2079,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(74815,2079,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(74816,2079,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(74817,2079,'vi','ThÃªm Danh sÃ¡ch giÃ¡ khÃ´ng in thÃ nh cÃ´ng',0),(74818,2079,'af','Nie-Uitdrukbare Pryslys suksesvol bygevoeg.',0),(74819,2079,'ro','Lista de preturi neimprimabile adÄƒugat cu succes.',0),(74820,2079,'et','Mitteprinditavate hinnakirja lisatud.',0),(74821,2079,'si','Nenatisljivi cenik uspeÅ¡no dodana.',0),(74822,2079,'ba','Daftar harga nonprinting ditambahkan berhasil.',0),(74823,2079,'nl','Niet-afdrukbare prijslijst met succes toegevoegd.',0),(74824,2079,'fi','Tulostumattomien hinnasto lisÃ¤Ã¤minen onnistui.',0),(74825,2079,'no','Ikke-utskrivbare prisliste lagt.',0),(74826,2079,'da','Afsnitstegn prisliste tilfÃ¸jet.',0),(74827,2079,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²©í‘œëŠ” ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(74828,2079,'he','×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×” ×ž×—×™×¨×•×Ÿ × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(74829,2079,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(74830,2079,'zh','éžæ‰“å°ä»·æ ¼è¡¨æ·»åŠ æˆåŠŸ',0),(74831,2079,'sv','Icke utskrivbar prislista lagts.',0),(74832,2079,'it','Listino non stampabili aggiunto con successo.',0),(74833,2079,'tl','',0),(74834,2079,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3626;&#3635;&#3648;&#3619;&#3655;&#3',0),(74835,2079,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(74836,2079,'ms','Senarai Harga nonprinting yang berjaya menambah.',0),(74837,2079,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­ \"Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\" ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©.',0),(74838,2079,'fr','Liste de prix non imprimables ajoutÃ© avec succÃ¨s.',0),(74839,2079,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(74840,2079,'pt','Lista de preÃ§o nÃ£o imprimÃ­veis adicionado com Ãªxito.',0),(74841,2079,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(74842,2079,'es','Lista de Precios de No Imprimir agregada exitosamente',0),(74843,2079,'de','Nicht druckbare Preisliste wurde erfolgreich hinzugefÃ¼gt.',0),(74844,2079,'en','Non-printing Price List added successfully.',0),(74845,2080,'is','',0),(74846,2080,'dr','Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74847,2080,'pr','Ø­Ø°Ù Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74848,2080,'tr','YazdÄ±rÄ±lmayan fiyat listesi baÅŸarÄ±yla silindi.',0),(74849,2080,'pl','Cennik niedrukowane usuniÄ™te pomyÅ›lnie.',0),(74850,2080,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(74851,2080,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©ÛŒ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(74852,2080,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(74853,2080,'vi','XÃ³a Danh sÃ¡ch giÃ¡ khÃ´ng in thÃ nh cÃ´ng',0),(74854,2080,'af','Nie-Uitdrukbare Pryslys is suksesvol geskrap.',0),(74855,2080,'ro','Lista de preturi neimprimabile ÅŸters cu succes.',0),(74856,2080,'et','Mitteprinditavate hinnakirja edukalt kustutatud.',0),(74857,2080,'si','Nenatisljivi cenik uspeÅ¡no izbrisana.',0),(74858,2080,'ba','Daftar harga nonprinting berhasil dihapus.',0),(74859,2080,'nl','Niet-afdrukbare prijslijst verwijderd.',0),(74860,2080,'fi','Tulostumattomien hinnasto poistettu.',0),(74861,2080,'no','Ikke-utskrivbare prisliste slettet.',0),(74862,2080,'da','Afsnitstegn prisliste slettet.',0),(74863,2080,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²©í‘œëŠ” ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(74864,2080,'he','×¨×©×™×ž×ª ×ž×—×™×¨×™× ×©××™× × × ×™×ª× ×™× ×œ×”×“×¤×¡×” × ×ž×—×§×• ×‘×”×¦×œ×—×”.',0),(74865,2080,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(74866,2080,'zh','éžæ‰“å°ä»·æ ¼è¡¨å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(74867,2080,'sv','Icke utskrivbar prislista raderades.',0),(74868,2080,'it','Listino non stampabili eliminato con successo.',0),(74869,2080,'tl','',0),(74870,2080,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(74871,2080,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(74872,2080,'ms','Nonprinting senarai harga dihapuskan dengan jayanya.',0),(74873,2080,'ar','Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­ \"Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\" ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©.',0),(74874,2080,'fr','Liste de prix non imprimables supprimÃ© avec succÃ¨s.',0),(74875,2080,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(74876,2080,'pt','Lista de preÃ§o nÃ£o imprimÃ­veis excluÃ­do com sucesso.',0),(74877,2080,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(74878,2080,'es','Lista de Precios de No Imprimir eliminada exitosamente',0),(74879,2080,'de','Nicht druckbare Preisliste erfolgreich gelÃ¶scht.',0),(74880,2080,'en','Non-printing Price List deleted successfully.',0),(74881,2081,'is','',0),(74882,2081,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù†ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74883,2081,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù†ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(74884,2081,'tr','YazdÄ±rÄ±lmayan fiyat listesi bulunamadÄ±.',0),(74885,2081,'pl','Niedrukowalne Cennik nie znaleziono.',0),(74886,2081,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(74887,2081,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª Ù†ÛÛŒÚº Ù…Ù„Ø§ Ú©ÛŒ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(74888,2081,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ð¦Ñ˜ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ»ÑƒÐ³Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°.',0),(74889,2081,'vi','KhÃ´ng tháº¥y Danh sÃ¡ch giÃ¡ khÃ´ng in',0),(74890,2081,'af','Ongedrukte Pryslys nie gevind.',0),(74891,2081,'ro','Lista de preturi neimprimabile nu a fost gÄƒsit.',0),(74892,2081,'et','Mitteprinditavate Hinnakiri ei leitud.',0),(74893,2081,'si','Nenatisljivi cenika ni mogoÄe najti.',0),(74894,2081,'ba','Daftar harga nonprinting tidak ditemukan.',0),(74895,2081,'nl','Niet-afdrukbare prijslijst niet gevonden.',0),(74896,2081,'fi','Tulostumattomien hinnasto ei lÃ¶ydy.',0),(74897,2081,'no','Ikke-utskrivbare prisliste ikke funnet.',0),(74898,2081,'da','Afsnitstegn prisliste blev ikke fundet.',0),(74899,2081,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(74900,2081,'he','×¨×©×™×ž×ª ×ž×—×™×¨×™× ×©××™× × ×ž×•×“×¤×¡×™× ×œ× × ×ž×¦×.',0),(74901,2081,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(74902,2081,'zh','éžæ‰“å°ä»·æ ¼è¡¨æœªæ‰¾åˆ°ã€‚\r\n',0),(74903,2081,'sv','Icke utskrivbar prislista hittades inte.',0),(74904,2081,'it','Listino non stampabili non trovato.',0),(74905,2081,'tl','',0),(74906,2081,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(74907,2081,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€à¥¤',0),(74908,2081,'ms','Senarai Harga nonprinting yang tidak dijumpai.',0),(74909,2081,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ \"Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\" ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©.',0),(74910,2081,'fr','Liste de prix non imprimables introuvable.',0),(74911,2081,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(74912,2081,'pt','Lista de preÃ§o nÃ£o imprimÃ­veis nÃ£o encontrado.',0),(74913,2081,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(74914,2081,'es','Lista de Precios de No Imprimir no se encontrÃ³',0),(74915,2081,'de','Nicht druckbare Preisliste nicht gefunden.',0),(74916,2081,'en','Non-printing Price List not found.',0),(74917,2082,'is','',0),(74918,2082,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¹Ù…Ù„ÙŠØ§Øª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74919,2082,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¹Ù…Ù„ÙŠØ§Øª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74920,2082,'tr','YazdÄ±rÄ±lmayan fiyat listesi iÅŸlemi baÅŸarÄ±yla eklendi.',0),(74921,2082,'pl','Niedrukowalne cena lista operacji dodane pomyÅ›lnie.',0),(74922,2082,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸ÑÑ‚Ð° Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(74923,2082,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ø¢Ù¾Ø±ÛŒØ´Ù† ÛÛ’ Û”',0),(74924,2082,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ñƒ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(74925,2082,'vi','ThÃªm HÃ nh Ä‘á»™ng Danh sÃ¡ch giÃ¡ khÃ´ng in thÃ nh cÃ´ng',0),(74926,2082,'af','Nie-Uitdrukbare Pryslys is suksesvol opdateer.',0),(74927,2082,'ro','Neimprimabile preÅ£ listÄƒ funcÅ£ionarea adÄƒugat cu succes.',0),(74928,2082,'et','Mitteprinditavad hind nimekirja toiming edukalt lisatud.',0),(74929,2082,'si','Nenatisljivi cena seznam operacijo uspeÅ¡no dodana.',0),(74930,2082,'ba','Nonprinting harga daftar operasi ditambahkan berhasil.',0),(74931,2082,'nl','Niet-afdrukbare prijs lijst bewerking met succes toegevoegd.',0),(74932,2082,'fi','Tulostumattomien hinta luettelo-toiminto lisÃ¤Ã¤minen onnistui.',0),(74933,2082,'no','Ikke-utskrivbare pris liste-operasjon ble lagt til.',0),(74934,2082,'da','Afsnitstegn pris liste funktion tilfÃ¸jet.',0),(74935,2082,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡ ìž‘ì—…ì´ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(74936,2082,'he','×ž×‘×¦×¢ ×¨×©×™×ž×ª ×ž×—×™×¨ ×©××™× ×• × ×™×ª×Ÿ ×œ×”×“×¤×¡×” × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(74937,2082,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± List Ï„Î¹Î¼Î® Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(74938,2082,'zh','éžæ‰“å°ä»·æ ¼åˆ—è¡¨æ“ä½œæ·»åŠ æˆåŠŸã€‚\r\n',0),(74939,2082,'sv','Icke utskrivbara pris lista drift lagts.',0),(74940,2082,'it','Non stampabile prezzo elenco operazione aggiunto con successo.',0),(74941,2082,'tl','',0),(74942,2082,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3',0),(74943,2082,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤‘à¤ªà¤°à¥‡à¤¶à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(74944,2082,'ms','Nonprinting harga senarai operasi berjaya menambah.',0),(74945,2082,'ar','Ø§Ù„Ø³Ø¹Ø± ØºÙŠØ± Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© \"Ù‚Ø§Ø¦Ù…Ø© Ø¹Ù…Ù„ÙŠØ©\" Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(74946,2082,'fr','OpÃ©ration de liste prix non imprimables ajoutÃ© avec succÃ¨s.',0),(74947,2082,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(74948,2082,'pt','PreÃ§o lista operaÃ§Ã£o nÃ£o imprimÃ­veis adicionado com Ãªxito.',0),(74949,2082,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐºÐ° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(74950,2082,'es','Lista de Precios de No Imprimir OperaciÃ³n agregada exitosamente',0),(74951,2082,'de','Nicht druckbare Preis Listenoperation wurde erfolgreich hinzugefÃ¼gt.',0),(74952,2082,'en','Non-printing Price List Operation added successfully.',0),(74953,2083,'is','',0),(74954,2083,'dr','Ø­Ø°Ù Ø¹Ù…Ù„ÙŠØ§Øª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74955,2083,'pr','Ø­Ø°Ù Ø¹Ù…Ù„ÙŠØ§Øª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74956,2083,'tr','YazdÄ±rÄ±lmayan fiyat listesi iÅŸlemi baÅŸarÄ±yla silindi.',0),(74957,2083,'pl','Niedrukowalne cena lista operacji usuniÄ™te pomyÅ›lnie.',0),(74958,2083,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸ÑÑ‚Ð° Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(74959,2083,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ø´Ø¯Û Ø¹Ù…Ù„ÛŒÛ Û”',0),(74960,2083,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ñƒ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(74961,2083,'vi','XÃ³a HÃ nh Ä‘á»™ng Danh sÃ¡ch giÃ¡ khÃ´ng in thÃ nh cÃ´ng',0),(74962,2083,'af','Nie-Uitdrukbare Pryslys Operasie is suksesvol geskrap.',0),(74963,2083,'ro','Neimprimabile preÅ£ listÄƒ funcÅ£ionarea ÅŸters cu succes.',0),(74964,2083,'et','Mitteprinditavate hind nimekirja toiming edukalt kustutatud.',0),(74965,2083,'si','Nenatisljivi cena seznam operacijo uspeÅ¡no izbrisana.',0),(74966,2083,'ba','Nonprinting harga daftar operasi berhasil dihapus.',0),(74967,2083,'nl','Niet-afdrukbare prijs lijst bewerking met succes verwijderd.',0),(74968,2083,'fi','Tulostumattomien hinta luettelo-toiminto poistettu.',0),(74969,2083,'no','Ikke-utskrivbare pris liste-operasjon ble slettet.',0),(74970,2083,'da','Afsnitstegn pris liste Operation slettet.',0),(74971,2083,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡ ìž‘ì—…ì´ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(74972,2083,'he','×ž×‘×¦×¢ ×¨×©×™×ž×ª ×ž×—×™×¨ ×©××™× ×• × ×™×ª×Ÿ ×œ×”×“×¤×¡×” × ×ž×—×§×• ×‘×”×¦×œ×—×”.',0),(74973,2083,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± List Ï„Î¹Î¼Î® Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(74974,2083,'zh','éžæ‰“å°ä»·æ ¼åˆ—è¡¨æ“ä½œæˆåŠŸåˆ é™¤ã€‚\r\n',0),(74975,2083,'sv','Icke utskrivbara pris lista-Ã¥tgÃ¤rd raderades.',0),(74976,2083,'it','Non stampabile prezzo elenco operazione eliminato con successo.',0),(74977,2083,'tl','',0),(74978,2083,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3585;&#3634;&#3619;&#3',0),(74979,2083,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤‘à¤ªà¤°à¥‡à¤¶à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(74980,2083,'ms','Nonprinting harga senarai operasi dihapuskan dengan jayanya.',0),(74981,2083,'ar','Ø§Ù„Ø³Ø¹Ø± ØºÙŠØ± Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© \"Ù‚Ø§Ø¦Ù…Ø© Ø¹Ù…Ù„ÙŠØ©\" Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(74982,2083,'fr','OpÃ©ration de liste prix non imprimables supprimÃ© avec succÃ¨s.',0),(74983,2083,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(74984,2083,'pt','PreÃ§o lista operaÃ§Ã£o nÃ£o imprimÃ­veis excluÃ­do com sucesso.',0),(74985,2083,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐºÐ° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(74986,2083,'es','Lista de Precios de No Imprimir OperaciÃ³n eliminada exitosamente',0),(74987,2083,'de','Nicht druckbare Preis Liste Vorgang erfolgreich gelÃ¶scht.',0),(74988,2083,'en','Non-printing Price List Operation deleted successfully.',0),(74989,2084,'is','',0),(74990,2084,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¹Ù…Ù„ÙŠØ§Øª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74991,2084,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¹Ù…Ù„ÙŠØ§Øª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(74992,2084,'tr','YazdÄ±rÄ±lmayan fiyat listesi iÅŸlemi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(74993,2084,'pl','Niedrukowalne cena lista operacji pomyÅ›lnie zaktualizowana.',0),(74994,2084,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸ÑÑ‚Ð° Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(74995,2084,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø¹Ù…Ù„ÛŒÛ Û”',0),(74996,2084,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ñƒ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(74997,2084,'vi','Cáº­p Nháº­t Báº£ng GiÃ¡ Hoáº¡t Äá»™ng KhÃ´ng In thÃ nh cÃ´ng',0),(74998,2084,'af','Nie-Uitdrukbare Pryslys Operasie is suksesvol opdateer.',0),(74999,2084,'ro','Neimprimabile operaÅ£iunea de lista de pret actualizat cu succes.',0),(75000,2084,'et','Mitteprinditavate hind nimekirja operatsiooni vÃ¤rskendamine Ãµnnestus.',0),(75001,2084,'si','Nenatisljivi cena seznam operacijo uspeÅ¡no posodobljena.',0),(75002,2084,'ba','Nonprinting harga daftar operasi berhasil.',0),(75003,2084,'nl','Niet-afdrukbare prijs lijst bewerking met succes bijgewerkt.',0),(75004,2084,'fi','Tulostumattomien hinta luettelo-toiminto pÃ¤ivitetty.',0),(75005,2084,'no','Ikke-utskrivbare pris liste-operasjon oppdatert.',0),(75006,2084,'da','Afsnitstegn pris liste Operation opdateret.',0),(75007,2084,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡ ìž‘ì—…ì´ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(75008,2084,'he','×ž×‘×¦×¢ ×¨×©×™×ž×ª ×ž×—×™×¨ ×©××™× ×• × ×™×ª×Ÿ ×œ×”×“×¤×¡×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(75009,2084,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± List Ï„Î¹Î¼Î® ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(75010,2084,'zh','éžæ‰“å°ä»·æ ¼åˆ—è¡¨æ“ä½œå·²æˆåŠŸæ›´æ–°ã€‚\r\n',0),(75011,2084,'sv','Icke utskrivbara pris lista-Ã¥tgÃ¤rd uppdaterats.',0),(75012,2084,'it','Non stampabili operazione prezzo elenco aggiornato con successo.',0),(75013,2084,'tl','',0),(75014,2084,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3',0),(75015,2084,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤‘à¤ªà¤°à¥‡à¤¶à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(75016,2084,'ms','Nonprinting harga senarai operasi berjaya dikemas kini.',0),(75017,2084,'ar','Ø§Ù„Ø³Ø¹Ø± ØºÙŠØ± Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© \"Ù‚Ø§Ø¦Ù…Ø© Ø¹Ù…Ù„ÙŠØ©\" Ø§Ù„ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(75018,2084,'fr','Non imprimables opÃ©ration de liste de prix mis Ã  jour avec succÃ¨s.',0),(75019,2084,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(75020,2084,'pt','OperaÃ§Ã£o nÃ£o imprimÃ­veis preÃ§o lista atualizada com Ãªxito.',0),(75021,2084,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐºÐ° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(75022,2084,'es','Lista de Precios de No Imprimir OperaciÃ³n actualizada exitosamente',0),(75023,2084,'de','Nicht druckbare Preis Liste Vorgang erfolgreich aktualisiert.',0),(75024,2084,'en','Non-printing Price List Operation updated successfully.',0),(75025,2085,'is','',0),(75026,2085,'dr','Ø¹Ù…Ù„ÙŠØ§Øª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù†ÙŠ ',0),(75027,2085,'pr','Ø¹Ù…Ù„ÙŠØ§Øª Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù†ÙŠ ',0),(75028,2085,'tr','YazdÄ±rÄ±lmayan fiyat listesi iÅŸlemleri',0),(75029,2085,'pl','Niedrukowalne cena lista operacji',0),(75030,2085,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(75031,2085,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø¢Ù¾Ø±ÛŒØ´Ù†',0),(75032,2085,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ðµ Ð»Ð¸ÑÑ‚Ðµ Ñ†ÐµÐ½Ð°',0),(75033,2085,'vi','HÃ nh Ä‘á»™ng Danh sÃ¡ch giÃ¡ khÃ´ng in',0),(75034,2085,'af','Nonprinting prys lys bedrywighede',0),(75035,2085,'ro','Neimprimabile Pret lista operaÈ›iunilor',0),(75036,2085,'et','Mitteprinditavate hind tegevused',0),(75037,2085,'si','Nenatisljivi cena seznam operacij',0),(75038,2085,'ba','Nonprinting harga daftar operasi',0),(75039,2085,'nl','Niet-afdrukbare prijs lijst operaties',0),(75040,2085,'fi','Tulostumattomien hinta toiminnot',0),(75041,2085,'no','Ikke-utskrivbare pris List-operasjoner',0),(75042,2085,'da','Afsnitstegn pris liste operationer',0),(75043,2085,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡ ìž‘ì—…',0),(75044,2085,'he','×¤×¢×•×œ×•×ª ×¨×©×™×ž×” ×ž×—×™×¨ ×©××™× ×• × ×™×ª×Ÿ ×œ×”×“×¤×¡×”',0),(75045,2085,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± ÎµÏÎ³Î±ÏƒÎ¹ÏŽÎ½',0),(75046,2085,'zh','éžæ‰“å°ä»·æ ¼åˆ—è¡¨æ“ä½œ\r\n',0),(75047,2085,'sv','Icke utskrivbara pris lista verksamhet',0),(75048,2085,'it','Non stampabile prezzo elenco operazioni',0),(75049,2085,'tl','',0),(75050,2085,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3',0),(75051,2085,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤†à¤ªà¤°à¥‡à¤¶à¤¨',0),(75052,2085,'ms','Operasi senarai harga nonprinting',0),(75053,2085,'ar','Ø¹Ù…Ù„ÙŠØ§Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(75054,2085,'fr','OpÃ©rations de liste de prix non imprimables',0),(75055,2085,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³',0),(75056,2085,'pt','OperaÃ§Ãµes de lista de preÃ§o nÃ£o imprimÃ­veis',0),(75057,2085,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ ÐŸÑ€ÐµÐ¹ÑÐºÑƒÑ€Ð°Ð½Ñ‚ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(75058,2085,'es','Lista de Precios de No Imprimir Operaciones',0),(75059,2085,'de','Nicht druckbare Preis-Listen-Operationen',0),(75060,2085,'en','Non-printing Price List Operations',0),(75061,2086,'is','',0),(75062,2086,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡',0),(75063,2086,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡',0),(75064,2086,'tr','YazdÄ±rÄ±lmayan fiyat listesi gÃ¼ncelleme',0),(75065,2086,'pl','Niedrukowalne aktualizacja listy ceny',0),(75066,2086,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð·Ð° Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼ Ñ†ÐµÐ½Ð°',0),(75067,2086,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(75068,2086,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð¾Ð¸Ð²Ð¸Ñ‡ÐµÐ½ Ñ†ÐµÐ½Ðµ',0),(75069,2086,'vi','Cáº­p Nháº­t Báº£ng GiÃ¡ KhÃ´ng In',0),(75070,2086,'af','Ongedrukte Pryslys Opdateer',0),(75071,2086,'ro','Neimprimabile actualizare lista de preÅ£',0),(75072,2086,'et','Mitteprinditavate hind uuendamisel',0),(75073,2086,'si','Nenatisljivi seznam posodobitev cene',0),(75074,2086,'ba','Update daftar harga nonprinting',0),(75075,2086,'nl','Niet-afdrukbare prijs lijst Update',0),(75076,2086,'fi','Tulostumattomien hinnasto PÃ¤ivitÃ¤',0),(75077,2086,'no','Ikke-utskrivbare Prisoppdatering liste',0),(75078,2086,'da','Afsnitstegn pris liste Update',0),(75079,2086,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ëª©ë¡ ì—…ë°ì´íŠ¸',0),(75080,2086,'he','×¢×“×›×•×Ÿ ×¨×©×™×ž×ª ×ž×—×™×¨ ×©××™× ×• × ×™×ª×Ÿ ×œ×”×“×¤×¡×”',0),(75081,2086,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½',0),(75082,2086,'zh','éžæ‰“å°ä»·æ ¼è¡¨æ›´æ–°\r\n',0),(75083,2086,'sv','Icke utskrivbara prisuppdatering',0),(75084,2086,'it','Aggiornamento di elenco prezzi non stampabili',0),(75085,2086,'tl','',0),(75086,2086,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(75087,2086,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(75088,2086,'ms','Kemaskini senarai harga nonprinting',0),(75089,2086,'ar','ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(75090,2086,'fr','Non imprimables mise Ã  jour de liste de prix',0),(75091,2086,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨æ›´æ–°',0),(75092,2086,'pt','ActualizaÃ§Ã£o da lista de preÃ§o nÃ£o imprimÃ­veis',0),(75093,2086,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ð½ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¦ÐµÐ½Ð°',0),(75094,2086,'es','Lista de Precios de No Imprimir Actualizar',0),(75095,2086,'de','Nicht druckbare Liste Preisaktualisierung',0),(75096,2086,'en','Non-printing Price List Update',0),(75097,2087,'is','',0),(75098,2087,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(75099,2087,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(75100,2087,'tr','YazdÄ±rÄ±lmayan fiyat listesi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(75101,2087,'pl','Cennik niedrukowane pomyÅ›lnie zaktualizowana.',0),(75102,2087,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(75103,2087,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û Ù‚ÛŒÙ…Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©ÛŒ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(75104,2087,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(75105,2087,'vi','Cáº­p Nháº­t Báº£ng GiÃ¡ KhÃ´ng In thÃ nh cÃ´ng',0),(75106,2087,'af','Nie-Uitdrukbare Pryslys suksesvol opdateer.',0),(75107,2087,'ro','Neimprimabile lista de preÅ£uri actualizate cu succes.',0),(75108,2087,'et','Mitteprinditavate hinnakirja vÃ¤rskendamine Ãµnnestus.',0),(75109,2087,'si','Nenatisljivi cenik uspeÅ¡no posodobljena.',0),(75110,2087,'ba','Daftar harga nonprinting diperbarui berhasil.',0),(75111,2087,'nl','Niet-afdrukbare prijslijst bijgewerkt.',0),(75112,2087,'fi','Tulostumattomien hinnasto pÃ¤ivitetty.',0),(75113,2087,'no','Ikke-utskrivbare prisliste oppdatert.',0),(75114,2087,'da','Afsnitstegn prisliste opdateret.',0),(75115,2087,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²©í‘œëŠ” ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•©ë‹ˆë‹¤.',0),(75116,2087,'he','×¨×©×™×ž×ª ×ž×—×™×¨×™× ×©××™× × × ×™×ª× ×™× ×œ×”×“×¤×¡×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(75117,2087,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(75118,2087,'zh','éžå°åˆ·ä»·æ ¼è¡¨æ›´æ–°æˆåŠŸ\r\n',0),(75119,2087,'sv','Icke utskrivbar prislista uppdaterats.',0),(75120,2087,'it','Non stampabile Listino prezzi aggiornato con successo.',0),(75121,2087,'tl','',0),(75122,2087,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3626;&#3635;&#3',0),(75123,2087,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(75124,2087,'ms','Senarai Harga nonprinting yang berjaya dikemas kini.',0),(75125,2087,'ar','Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ« \"Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\" ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©.',0),(75126,2087,'fr','Liste de prix non imprimables mis Ã  jour avec succÃ¨s.',0),(75127,2087,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(75128,2087,'pt','Lista de preÃ§o nÃ£o imprimÃ­veis atualizado com Ãªxito.',0),(75129,2087,'ru','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(75130,2087,'es','Lista de Precios de No Imprimir actualizada exitosamente',0),(75131,2087,'de','Nicht druckbare Preisliste erfolgreich aktualisiert.',0),(75132,2087,'en','Non-printing Price List updated successfully.',0),(75133,2088,'is','',0),(75134,2088,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù†ÙŠ',0),(75135,2088,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù†ÙŠ',0),(75136,2088,'tr','BaskÄ±da fiyat gÃ¼ncelleÅŸtirme',0),(75137,2088,'pl','Aktualizacja cen-drukowanie',0),(75138,2088,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð½Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(75139,2088,'ur','ØºÛŒØ± Ø·Ø¨Ø§Ø¹Øª Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(75140,2088,'sr','Ð¦ÐµÐ½Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐºÐ¾Ñ˜Ð° ÑÐµ Ð½Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°',0),(75141,2088,'vi','Cáº­p nháº­t giÃ¡ khÃ´ng in',0),(75142,2088,'af','Nie-druk pryse bywerking',0),(75143,2088,'ro','Nu se imprimÄƒ tarifare Update',0),(75144,2088,'et','Printimatu hinnakujunduse Update',0),(75145,2088,'si','Nenatisljivo cen posodobitev',0),(75146,2088,'ba','Update harga bebas-Percetakan',0),(75147,2088,'nl','Niet-afdrukbare prijzen Update',0),(75148,2088,'fi','Tulostumattomat hinnoittelu pÃ¤ivitys',0),(75149,2088,'no','Ikke-utskrivbare priser oppdatering',0),(75150,2088,'da','Trykfri prissÃ¦tning opdatering',0),(75151,2088,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ì—…ë°ì´íŠ¸',0),(75152,2088,'he','×¢×“×›×•×Ÿ ×ª×ž×—×•×¨ ×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×”',0),(75153,2088,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(75154,2088,'zh','éžæ‰“å°ä»·æ ¼æ›´æ–°\r\n',0),(75155,2088,'sv','Icke utskrivbara prissÃ¤ttning uppdatering',0),(75156,2088,'it','Aggiornamento dei prezzi non stampabili',0),(75157,2088,'tl','',0),(75158,2088,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(75159,2088,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤¯à¥‹à¤—à¥à¤¯ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(75160,2088,'ms','Kemaskini harga Ling',0),(75161,2088,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ØªØ³Ø¹ÙŠØ± ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(75162,2088,'fr','Mise Ã  jour prix non imprimables',0),(75163,2088,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã?®æ›´æ–°',0),(75164,2088,'pt','AtualizaÃ§Ã£o de preÃ§os nÃ£o-imprimÃ­veis',0),(75165,2088,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½-Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ',0),(75166,2088,'es','Precios de No Imprimir Actualizar',0),(75167,2088,'de','Nicht druckbare Preisgestaltung Update',0),(75168,2088,'en','Non-printing Pricing Update',0),(75169,2089,'is','',0),(75170,2089,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ â€“ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ù…ØµØ±Ù Ø´Ø¯Ù‡ ',0),(75171,2089,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ â€“ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ù…ØµØ±Ù Ø´Ø¯Ù‡ ',0),(75172,2089,'tr','BaskÄ±da fiyatlandÄ±rma gÃ¼ncelleme - kullanÄ±lan malzemeler',0),(75173,2089,'pl','Niedrukowalne aktualizacji cen - materiaÅ‚y uÅ¼yte',0),(75174,2089,'bg','ÐÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð½Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ - Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸',0),(75175,2089,'ur','ØºÛŒØ± Ø·Ø¨Ø§Ø¹Øª Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ø§Ù¾ ÚˆÛŒÙ¹ - Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ù…ÙˆØ§Ø¯',0),(75176,2089,'sr','Ð¦ÐµÐ½Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐºÐ¾Ñ˜Ð° ÑÐµ Ð½Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð° - Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð¸ ÐºÐ¾Ñ˜Ð¸ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ðµ',0),(75177,2089,'vi','Cáº­p Nháº­t GiÃ¡ KhÃ´ng In - NguyÃªn Liá»‡u Sá»­ Dá»¥ng',0),(75178,2089,'af','Nie-druk pryse bywerking - materiaal gebruik',0),(75179,2089,'ro','Nu se imprimÄƒ tarifare Update - materialele utilizate',0),(75180,2089,'et','Printimatu hinnakujunduse Update - kasutatud materjalid',0),(75181,2089,'si','Nenatisljivo cen Update - uporabljeni materiali',0),(75182,2089,'ba','Bebas-Percetakan harga Update - bahan yang digunakan',0),(75183,2089,'nl','Niet-afdrukbare prijsstelling Update - gebruikte materialen',0),(75184,2089,'fi','Tulostumattomat hinnoittelu pÃ¤ivitys - materiaalit',0),(75185,2089,'no','Ikke-utskrivbare priser oppdatering - materialer',0),(75186,2089,'da','Trykfri prissÃ¦tning Update - materialer',0),(75187,2089,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ” ê°€ê²© ì—…ë°ì´íŠ¸-ì‚¬ìš© ë˜ëŠ” ìž¬ë£Œ',0),(75188,2089,'he','×¢×“×›×•×Ÿ ×ª×ž×—×•×¨ ×©××™× × ×ž×™×•×¢×“×™× ×œ×”×“×¤×¡×” - ×”×—×•×ž×¨×™× ×”×ž×©×ž×©×™×',0),(75189,2089,'el','ÎœÎ· ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· - Ï…Î»Î¹ÎºÎ¬ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹',0),(75190,2089,'zh','éžæ‰“å°å®šä»·æ›´æ–° -ææ–™ç”¨\r\n',0),(75191,2089,'sv','Icke utskrivbara prissÃ¤ttning uppdatering - material som anvÃ¤nds',0),(75192,2089,'it','Aggiornamento dei prezzi non stampabili - materiali utilizzati',0),(75193,2089,'tl','',0),(75194,2089,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660; - &#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3623;&#3633;',0),(75195,2089,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤£ à¤¯à¥‹à¤—à¥à¤¯ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨ - à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤²',0),(75196,2089,'ms','Ling penentuan harga Kemaskini - bahan-bahan yang digunakan',0),(75197,2089,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ØªØ³Ø¹ÙŠØ± ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©-Ø§Ù„Ù…ÙˆØ§Ø¯ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(75198,2089,'fr','Mise Ã  jour prix de non-impression - matÃ©riaux utilisÃ©s',0),(75199,2089,'jp','é?žå?°åˆ·ä¾¡æ ¼è¡¨ã?®æ›´æ–°ãƒ¼ä½¿ç”¨ã?•ã‚Œã?Ÿæ??æ–™',0),(75200,2089,'pt','AtualizaÃ§Ã£o de preÃ§os nÃ£o-imprimÃ­veis - materiais utilizados',0),(75201,2089,'ru','-ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ - Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ðµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹',0),(75202,2089,'es','Precios de No Imprimir ActualizaciÃ³n - Materiales Usados',0),(75203,2089,'de','Nicht druckbare Preisgestaltung Update - Werkstoffe',0),(75204,2089,'en','Non-printing Pricing Update - Materials Used',0),(75205,2090,'is','',0),(75206,2090,'dr','Ù†Ø±Ù…Ø§Ù„ ',0),(75207,2090,'pr','Ù†Ø±Ù…Ø§Ù„ ',0),(75208,2090,'tr','Normal',0),(75209,2090,'pl','Normalne',0),(75210,2090,'bg','ÐÐ¾Ñ€Ð¼Ð°Ð»ÐµÐ½',0),(75211,2090,'ur','Ø¹Ø§Ù… Û”',0),(75212,2090,'sr','ÐÐ¾Ñ€Ð¼Ð°Ð»Ð½Ð¾',0),(75213,2090,'vi','BÃ¬nh thÆ°á»ng ',0),(75214,2090,'af','Normaal',0),(75215,2090,'ro','Normal',0),(75216,2090,'et','Normaalne',0),(75217,2090,'si','Normalno',0),(75218,2090,'ba','Normal',0),(75219,2090,'nl','Normaal',0),(75220,2090,'fi','Normaali',0),(75221,2090,'no','Normal',0),(75222,2090,'da','Normal',0),(75223,2090,'ko','ì •ìƒ',0),(75224,2090,'he','×¨×’×™×œ',0),(75225,2090,'el','ÎšÎ±Î½Î¿Î½Î¹ÎºÎ®',0),(75226,2090,'zh','æ­£å¸¸\r\n',0),(75227,2090,'sv','Normal',0),(75228,2090,'it','Normale',0),(75229,2090,'tl','',0),(75230,2090,'th','&#3611;&#3585;&#3605;&#3636;',0),(75231,2090,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯',0),(75232,2090,'ms','Normal',0),(75233,2090,'ar','Ø¹Ø§Ø¯ÙŠ',0),(75234,2090,'fr','Normal',0),(75235,2090,'jp','é€šå¸¸',0),(75236,2090,'pt','Normal',0),(75237,2090,'ru','ÐÐ¾Ñ€Ð¼Ð°Ð»ÑŒÐ½Ñ‹Ð¹',0),(75238,2090,'es','Normal',0),(75239,2090,'de','Normal',0),(75240,2090,'en','Normal',0),(75241,2091,'is','',0),(75242,2091,'dr','Ø±Ø¯ÙŠÙ Ø§ÙˆÙ„ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(75243,2091,'pr','Ø±Ø¯ÙŠÙ Ø§ÙˆÙ„ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(75244,2091,'tr','Ä°lk satÄ±rÄ±nÄ± gÃ¶sterme',0),(75245,2091,'pl','Nie pokazuj pierwszÄ… liniÄ™',0),(75246,2091,'bg','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð¿ÑŠÑ€Ð²Ð¸Ñ Ñ€ÐµÐ´',0),(75247,2091,'ur','Ù¾ÛÙ„ÛŒ Ø³Ø·Ø± Ù†Ù…Ø§ÛŒØ´ Ù†Û Ú©Ø±ÛŒÚº',0),(75248,2091,'sr','ÐÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜ Ð¿Ñ€Ð²Ð¾Ð³ Ñ€ÐµÐ´Ð°',0),(75249,2091,'vi','ÄÃ¹ng hiá»ƒn thá»‹ dÃ²ng Ä‘áº§u tiÃªn',0),(75250,2091,'af','Moenie Eerste Lyn Wys',0),(75251,2091,'ro','Nu prezintÄƒ prima linie',0),(75252,2091,'et','Ã„ra nÃ¤ita esimest rida',0),(75253,2091,'si','Ne PokaÅ¾i prvo vrstico',0),(75254,2091,'ba','Tidak menunjukkan baris pertama',0),(75255,2091,'nl','Eerste regel niet weergeven',0),(75256,2091,'fi','Ã„lÃ¤ NÃ¤ytÃ¤ ensimmÃ¤inen rivi',0),(75257,2091,'no','Ikke Vis fÃ¸rste linje',0),(75258,2091,'da','Vis ikke fÃ¸rste linje',0),(75259,2091,'ko','ì²« ë²ˆì§¸ ì¤„ì„ í‘œì‹œ í•˜ì§€ ì•ŠìŒ',0),(75260,2091,'he','××œ ×ª×¦×™×’ ×”×©×•×¨×” ×”×¨××©×•× ×”',0),(75261,2091,'el','Î”ÎµÎ½ Î´ÎµÎ¯Ï‡Î½Î¿Ï…Î½ Ï€ÏÏŽÏ„Î· Î³ÏÎ±Î¼Î¼Î®',0),(75262,2091,'zh','ä¸æ˜¾ç¤ºç¬¬ä¸€è¡Œ\r\n',0),(75263,2091,'sv','Visa inte fÃ¶rsta raden',0),(75264,2091,'it','Non mostrare prima linea',0),(75265,2091,'tl','',0),(75266,2091,'th','&#3652;&#3617;&#3656;&#3605;&#3657;&#3629;&#3591;&#3649;&#3626;&#3604;&#3591;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3649;&#3619;&#3585;',0),(75267,2091,'hi','à¤ªà¤¹à¤²à¥€ à¤²à¤¾à¤‡à¤¨ à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(75268,2091,'ms','Jangan tunjuk baris pertama',0),(75269,2091,'ar','Ø¹Ø¯Ù… Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø³Ø·Ø± Ø§Ù„Ø£ÙˆÙ„',0),(75270,2091,'fr','Ne montrez pas de premiÃ¨re ligne',0),(75271,2091,'jp','1è¡Œç›®ã‚’è¡¨ç¤ºã?—ã?ªã?„',0),(75272,2091,'pt','NÃ£o mostrar a primeira linha',0),(75273,2091,'ru','ÐÐµ ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ ÐŸÐµÑ€Ð²ÑƒÑŽ Ð¡Ñ‚Ñ€Ð¾ÐºÑƒ',0),(75274,2091,'es','No Mostrar la Linea Primera',0),(75275,2091,'de','Erste Zeile nicht anzeigen',0),(75276,2091,'en','Do Not Show First Line',0),(75277,2092,'is','',0),(75278,2092,'dr','ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ ØµØ­ÙŠØ­ Ù†ÙŠØ³ØªÙ†Ø¯ ',0),(75279,2092,'pr','ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ ØµØ­ÙŠØ­ Ù†ÙŠØ³ØªÙ†Ø¯ ',0),(75280,2092,'tr','AlanlarÄ±n tÃ¼mÃ¼ geÃ§erli',0),(75281,2092,'pl','Nie wszystkie pola byÅ‚y waÅ¼ne',0),(75282,2092,'bg','ÐÐµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° ÑÐ° Ð±Ð¸Ð»Ð¸ Ð²Ð°Ð»Ð¸Ð´Ð½Ð¸',0),(75283,2092,'ur','ØªÙ…Ø§Ù… Ù‚Ø·Ø¹Ø§Øª Ø¬Ø§Ø¦Ø² ØªÚ¾Û’',0),(75284,2092,'sr','ÐÐµÐ¼Ð°Ñ˜Ñƒ ÑÐ²Ð° Ð¿Ð¾Ñ™Ð° Ð±Ð¸Ð»Ð¸ Ð²Ð°Ð»Ð¸Ð´Ð½Ð¸',0),(75285,2092,'vi','KhÃ´ng pháº£i táº¥t cáº£ cÃ¡c trÆ°á»ng Ä‘á»u há»¯u hiá»‡u',0),(75286,2092,'af','Nie alle velde was geldig nie',0),(75287,2092,'ro','Nu toate domeniile au fost valabile',0),(75288,2092,'et','KÃµik vÃ¤ljad ei sobinud',0),(75289,2092,'si','Nekatera polja ne bili veljavni',0),(75290,2092,'ba','Tidak semua bidang yang berlaku',0),(75291,2092,'nl','Niet alle velden waren geldig',0),(75292,2092,'fi','Kaikki kentÃ¤t kelpaa',0),(75293,2092,'no','Ikke alle var gyldig',0),(75294,2092,'da','Ikke alle felter var gyldige',0),(75295,2092,'ko','ëª¨ë“  í•„ë“œ ìœ íš¨ í–ˆë‹¤',0),(75296,2092,'he','×œ× ×›×œ ×”×©×“×•×ª ×”×™×• ×—×•×§×™×™×',0),(75297,2092,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏŒÎ»Î± Ï„Î± Ï€ÎµÎ´Î¯Î± Ï€Î¿Ï… Î¯ÏƒÏ‡Ï…Î±Î½',0),(75298,2092,'zh','ä¸æ˜¯æ‰€æœ‰çš„å­—æ®µæ˜¯æœ‰æ•ˆçš„\r\n',0),(75299,2092,'sv','Inte alla fÃ¤lt var giltiga',0),(75300,2092,'it','Non tutti i campi sono stati validi',0),(75301,2092,'tl','',0),(75302,2092,'th','&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3652;&#3617;&#3656;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(75303,2092,'hi','à¤¨à¤¹à¥€à¤‚ à¤¸à¤­à¥€ à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸ à¤®à¤¾à¤¨à¥à¤¯ à¤¥à¥‡',0),(75304,2092,'ms','Tidak semua bidang telah sah',0),(75305,2092,'ar','Ù„Ø§ ØªØ­ØªÙˆÙŠ ÙƒØ§ÙØ© Ø§Ù„Ø­Ù‚ÙˆÙ„ ÙƒØ§Ù†Øª ØµØ§Ù„Ø­Ø©',0),(75306,2092,'fr','Pas tous les champs Ã©taient valides',0),(75307,2092,'jp','å…¨ã?¦ã?®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã?Œæœ‰åŠ¹ã?§ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(75308,2092,'pt','Nem todos os campos foram vÃ¡lidos',0),(75309,2092,'ru','ÐÐµ Ð²ÑÐµ Ð¿Ð¾Ð»Ñ Ð±Ñ‹Ð»Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹',0),(75310,2092,'es','No todos los campos fueron vÃ¡lidos',0),(75311,2092,'de','Nicht alle Felder waren gÃ¼ltig.',0),(75312,2092,'en','Not all fields were valid',0),(75313,2093,'is','',0),(75314,2093,'dr','Ù…Ø¹Ø§Ù Ù†Ø´Ø¯Ù‡ ',0),(75315,2093,'pr','Ù…Ø¹Ø§Ù Ù†Ø´Ø¯Ù‡ ',0),(75316,2093,'tr','Muaf deÄŸil',0),(75317,2093,'pl','Nie wyÅ‚Ä…czaÄ‡',0),(75318,2093,'bg','ÐÐµ ÑÐµ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ñ‚',0),(75319,2093,'ur','Ù…Ø³ØªØ«Ù†ÛŒ Ù†ÛÛŒÚº',0),(75320,2093,'sr','ÐÐ¸Ñ˜Ðµ Ð¸Ð·ÑƒÐ·ÐµÑ‚.',0),(75321,2093,'vi','KhÃ´ng miá»…n trá»«',0),(75322,2093,'af','Nie Vrygestel',0),(75323,2093,'ro','Nu scutite',0),(75324,2093,'et','Vabasta',0),(75325,2093,'si','Ni izvzeto',0),(75326,2093,'ba','Tidak pengecualian',0),(75327,2093,'nl','Geen vrijstelling worden verleend',0),(75328,2093,'fi','Vapauta',0),(75329,2093,'no','Ikke unntak',0),(75330,2093,'da','Ikke fritage',0),(75331,2093,'ko','ë©´ì œ ë˜ì§€',0),(75332,2093,'he','×œ× ×¤×˜×•×¨',0),(75333,2093,'el','Î”ÎµÎ½ Î±Ï€Î±Î»Î»Î¬ÏƒÏƒÎ¿Î½Ï„Î±Î¹',0),(75334,2093,'zh','ä¸èƒ½å…é™¤\r\n',0),(75335,2093,'sv','Inte undanta',0),(75336,2093,'it','Non esenti',0),(75337,2093,'tl','',0),(75338,2093,'th','&#3652;&#3617;&#3656;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;',0),(75339,2093,'hi','à¤¨à¤¹à¥€à¤‚ à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(75340,2093,'ms','Tidak dikecualikan',0),(75341,2093,'ar','ØºÙŠØ± Ù…Ø¹ÙÙŠ',0),(75342,2093,'fr','Non exemptÃ©s',0),(75343,2093,'jp','å…?é™¤ã?•ã‚Œã?ªã?„',0),(75344,2093,'pt','NÃ£o isento',0),(75345,2093,'ru','ÐÐµ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°ÐµÑ‚',0),(75346,2093,'es','No es Exento',0),(75347,2093,'de','Nicht befreit',0),(75348,2093,'en','Not Exempt',0),(75349,2094,'is','',0),(75350,2094,'dr','Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(75351,2094,'pr','Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(75352,2094,'tr','bulunamadÄ±.',0),(75353,2094,'pl','nie znaleziono.',0),(75354,2094,'bg','Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(75355,2094,'ur','Ù†Û Ù…Ù„ Ø³Ú©Ø§ Û”',0),(75356,2094,'sr','Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(75357,2094,'vi','khÃ´ng tháº¥y',0),(75358,2094,'af','nie gevind.',0),(75359,2094,'ro','nu a fost gÄƒsit.',0),(75360,2094,'et','ei leitud',0),(75361,2094,'si','ni mogoÄe najti.',0),(75362,2094,'ba','tidak ditemukan.',0),(75363,2094,'nl','niet gevonden.',0),(75364,2094,'fi','ei lÃ¶ydy.',0),(75365,2094,'no','finner ikke.',0),(75366,2094,'da','ikke fundet.',0),(75367,2094,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(75368,2094,'he','.×œ× × ×ž×¦×',0),(75369,2094,'el','Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(75370,2094,'zh','æœªæ‰¾åˆ°ã€‚\r\n',0),(75371,2094,'sv','hittades inte.',0),(75372,2094,'it','non trovato.',0),(75373,2094,'tl','',0),(75374,2094,'th','&#3652;&#3617;&#3656;&#3614;&#3610;',0),(75375,2094,'hi','à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(75376,2094,'ms','tidak dijumpai.',0),(75377,2094,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(75378,2094,'fr','pas trouvÃ©.',0),(75379,2094,'jp','è¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(75380,2094,'pt','NÃ£o foi encontrado.',0),(75381,2094,'ru','Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.',0),(75382,2094,'es','No se encontrÃ³',0),(75383,2094,'de','nicht gefunden.',0),(75384,2094,'en','not found.',0),(75385,2095,'is','',0),(75386,2095,'dr','(Ø³Ø·Ø­) Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù†ÙŠØ§Ù…Ø¯Ù‡ Ø§Ø³Øª ',0),(75387,2095,'pr','Ø¯Ø±  ØªØ±Ø§Ø²(Ø³Ø·Ø­) Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù†ÙŠØ§Ù…Ø¯Ù‡ Ø§Ø³Øª ',0),(75388,2095,'tr','DÃ¼zeyinin deÄŸil',0),(75389,2095,'pl','Nie zawarte w poziomie',0),(75390,2095,'bg','ÐÐµ ÑÐ° Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð² Ð½Ð¸Ð²Ð¾',0),(75391,2095,'ur','Ø³Ø·Ø­ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ Ù†ÛÛŒÚº',0),(75392,2095,'sr','ÐÐ¸ÑÑƒ ÑƒÐºÑ™ÑƒÑ‡ÐµÐ½Ð¸ Ñƒ Ð½Ð¸Ð²Ð¾Ñƒ',0),(75393,2095,'vi','KhÃ´ng bao gá»“m trong Cáº¥p báº­c',0),(75394,2095,'af','Nie Ingesluit in Vlak',0),(75395,2095,'ro','Nu sunt incluse Ã®n nivelul',0),(75396,2095,'et','Ei kuulu tase',0),(75397,2095,'si','Niso vkljuÄeni v ravni',0),(75398,2095,'ba','Tidak termasuk dalam tingkat',0),(75399,2095,'nl','Niet opgenomen in niveau',0),(75400,2095,'fi','SisÃ¤lly taso',0),(75401,2095,'no','Ikke inkludert i nivÃ¥',0),(75402,2095,'da','Ikke inkluderet i niveau',0),(75403,2095,'ko','ìˆ˜ì¤€ì— í¬í•¨ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(75404,2095,'he','×œ× ×›×œ×•×œ ×‘×¨×ž×”',0),(75405,2095,'el','Î”ÎµÎ½ Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿',0),(75406,2095,'zh','æœªåˆ—å…¥çº§åˆ«\r\n',0),(75407,2095,'sv','Inte ingÃ¥r i nivÃ¥',0),(75408,2095,'it','Non incluso nel livello',0),(75409,2095,'tl','',0),(75410,2095,'th','&#3652;&#3617;&#3656;&#3619;&#3623;&#3617;&#3651;&#3609;&#3619;&#3632;&#3604;&#3633;&#3610;&#3609;&#3637;&#3657;',0),(75411,2095,'hi','à¤¸à¥à¤¤à¤° à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤¶à¤¾à¤®à¤¿à¤²',0),(75412,2095,'ms','Tidak termasuk di peringkat',0),(75413,2095,'ar','Ù„Ù… ØªØ¯Ø±Ø¬ ÙÙŠ Ø§Ù„Ù…Ø³ØªÙˆÙ‰',0),(75414,2095,'fr','Pas inclus dans le niveau',0),(75415,2095,'jp','ãƒ¬ãƒ™ãƒ«ã?«å?«ã?¾ã‚Œã?ªã?„',0),(75416,2095,'pt','NÃ£o incluÃ­do no nÃ­vel',0),(75417,2095,'ru','ÐÐµ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ Ð² ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ',0),(75418,2095,'es','No Incluido en el Nivel',0),(75419,2095,'de','Nicht enthalten in Ebene',0),(75420,2095,'en','Not Included in Level',0),(75421,2096,'is','',0),(75422,2096,'dr','Ù†ØµØ¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾Ø§Ùƒ ÙƒØ±Ø¯Ù† Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù†ØµØ¨ Ø´Ø¯Ù‡ Ù†ÙŠØ³Øª ',0),(75423,2096,'pr','Ù†ØµØ¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾Ø§Ùƒ ÙƒØ±Ø¯Ù† Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù†ØµØ¨ Ø´Ø¯Ù‡ Ù†ÙŠØ³Øª ',0),(75424,2096,'tr','DeÄŸil yÃ¼klÃ¼ - kaldÄ±rÄ±lamÄ±yor',0),(75425,2096,'pl','Nie zainstalowane - nie moÅ¼na odinstalowaÄ‡',0),(75426,2096,'bg','ÐÐµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½ - Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð´ÐµÐ¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ñ‚Ðµ',0),(75427,2096,'ur','ØªÙ†ØµÛŒØ¨ Ù†ÛÛŒÚº - Ù†Ø§ØªÙ†ØµÛŒØ¨ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(75428,2096,'sr','ÐÐ¸Ñ˜Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½, Ð½Ð¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´ÐµÐ¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ñ‚Ð¸',0),(75429,2096,'vi','ChÆ°a láº¯p Ä‘áº·t - khÃ´ng thá»ƒ bá» láº¯p Ä‘áº·t',0),(75430,2096,'af','Nie geinstalleer - kan nie verwyder',0),(75431,2096,'ro','Nu a instalat - abil uninstall',0),(75432,2096,'et','Pole installitud - ei saa desinstallida',0),(75433,2096,'si','Ni nameÅ¡Äen - ne more odstraniti',0),(75434,2096,'ba','Tidak diinstal - tidak dapat menghapus',0),(75435,2096,'nl','Niet geÃ¯nstalleerd - niet verwijderen',0),(75436,2096,'fi','Ei asennettu - ei voi poistaa',0),(75437,2096,'no','Ikke installert - kan ikke avinstallere',0),(75438,2096,'da','Ikke installeret - kan ikke afinstallere',0),(75439,2096,'ko','ì•„ë‹ˆ ì„¤ì¹˜-ì œê±°í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(75440,2096,'he','×œ× ×ž×•×ª×§×Ÿ - ××™×Ÿ ××¤×©×¨×•×ª ×œ×”×¡×™×¨ ××ª',0),(75441,2096,'el','Î”ÎµÎ½ ÎµÎ³ÎºÎ±Ï„Î±ÏƒÏ„Î±Î¸ÎµÎ¯ - Î½Î± ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î±Ï€ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(75442,2096,'zh','ä¸åŒ…æ‹¬åœ¨æŒ‰é‡‘æ”¯ç¥¨...\r\n',0),(75443,2096,'sv','Inte installerat - kan inte avinstallera',0),(75444,2096,'it','Non installato - non Ã¨ possibile disinstallare',0),(75445,2096,'tl','',0),(75446,2096,'th','&#3652;&#3617;&#3656;&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591; - &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;',0),(75447,2096,'hi','à¤¨à¤¹à¥€à¤‚ à¤¸à¥à¤¥à¤¾à¤ªà¤¿à¤¤ - à¤•à¥€ à¤¸à¥à¤¥à¤¾à¤ªà¤¨à¤¾ à¤°à¤¦à¥à¤¦ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(75448,2096,'ms','Tidak dipasang - tidak boleh mengeluarkan',0),(75449,2096,'ar','Ø¹Ø¯Ù… ØªØ«Ø¨ÙŠØª--Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ù„ØºØ§Ø¡',0),(75450,2096,'fr','Pas installÃ© - impossible de dÃ©sinstaller',0),(75451,2096,'jp','ã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“ã€‚ã‚¢ãƒ³ã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«ã?§ã??ã?¾ã?›ã‚“',0),(75452,2096,'pt','NÃ£o instalado - nÃ£o Ã© possÃ­vel desinstalar',0),(75453,2096,'ru','ÐÐµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð° - Ð½Ðµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ',0),(75454,2096,'es','No instalado - no se puede desinstalar',0),(75455,2096,'de','Nicht installiert - kann nicht deinstalliert werden',0),(75456,2096,'en','Not installed - cannot uninstall',0),(75457,2097,'is','',0),(75458,2097,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(75459,2097,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(75460,2097,'tr','SeÃ§ili deÄŸil',0),(75461,2097,'pl','Nie wybrane',0),(75462,2097,'bg','ÐÐµ ÑÐ° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(75463,2097,'ur','Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº',0),(75464,2097,'sr','ÐÐ¸Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(75465,2097,'vi','ChÆ°a chá»n',0),(75466,2097,'af','Nie gekies',0),(75467,2097,'ro','Nu selectat',0),(75468,2097,'et','Pole valitud',0),(75469,2097,'si','Ni izbrana',0),(75470,2097,'ba','Tidak dipilih',0),(75471,2097,'nl','Niet geselecteerd',0),(75472,2097,'fi','Ole valittu',0),(75473,2097,'no','Ikke valgt',0),(75474,2097,'da','Ikke markeret',0),(75475,2097,'ko','ì„ íƒ í•˜ì§€ ì•Šì€',0),(75476,2097,'he','×œ× × ×‘×—×¨',0),(75477,2097,'el','ÎœÎ· ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½o',0),(75478,2097,'zh','æœªé€‰æ‹©\r\n',0),(75479,2097,'sv','Inte markerad',0),(75480,2097,'it','Non selezionata',0),(75481,2097,'tl','',0),(75482,2097,'th','&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(75483,2097,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚',0),(75484,2097,'ms','Tidak dipilih',0),(75485,2097,'ar','ØºÙŠØ± Ù…Ø­Ø¯Ø¯',0),(75486,2097,'fr','Pas sÃ©lectionnÃ©',0),(75487,2097,'jp','é?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(75488,2097,'pt','NÃ£o selecionado',0),(75489,2097,'ru','ÐÐµ Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð¾',0),(75490,2097,'es','No Seleccionado',0),(75491,2097,'de','Nicht ausgewÃ¤hlt',0),(75492,2097,'en','Not Selected',0),(75493,2098,'is','',0),(75494,2098,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø´Ø¯Ù‡ ',0),(75495,2098,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø´Ø¯Ù‡ ',0),(75496,2098,'tr','gÃ¼ncellenmiÅŸ.',0),(75497,2098,'pl','nie aktualizowany.',0),(75498,2098,'bg','Ð½Ðµ ÑÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸.',0),(75499,2098,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†ÛÛŒÚº Ú©ÛŒ Û”',0),(75500,2098,'sr','Ð½Ð¸ÑÑƒ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ.',0),(75501,2098,'vi','chÆ°a cáº­p nháº­t.',0),(75502,2098,'af','nie Opdateer.',0),(75503,2098,'ro','nu actualizat.',0),(75504,2098,'et','ei uuendata.',0),(75505,2098,'si','niso posodobljeno.',0),(75506,2098,'ba','tidak diperbarui.',0),(75507,2098,'nl','niet bijgewerkt.',0),(75508,2098,'fi','ei pÃ¤ivitetÃ¤.',0),(75509,2098,'no','ikke oppdatert.',0),(75510,2098,'da','ikke opdateret.',0),(75511,2098,'ko','ì—…ë°ì´íŠ¸ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(75512,2098,'he','×œ× ×™×¢×•×“×›×Ÿ.',0),(75513,2098,'el','Î´ÎµÎ½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ.',0),(75514,2098,'zh','æ²¡æœ‰æ›´æ–°ã€‚\r\n\r\n',0),(75515,2098,'sv','inte uppdaterad.',0),(75516,2098,'it','non aggiornato.',0),(75517,2098,'tl','',0),(75518,2098,'th','&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(75519,2098,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(75520,2098,'ms','tidak dikemaskini.',0),(75521,2098,'ar','Ø¹Ø¯Ù… ØªØ­Ø¯ÙŠØ«.',0),(75522,2098,'fr','pas mis Ã  jour.',0),(75523,2098,'jp','æ›´æ–°ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(75524,2098,'pt','NÃ£o atualizado.',0),(75525,2098,'ru','Ð½Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(75526,2098,'es','no actualizado',0),(75527,2098,'de','nicht aktualisiert.',0),(75528,2098,'en','not updated.',0),(75529,2099,'is','',0),(75530,2099,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª',0),(75531,2099,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª',0),(75532,2099,'tr','Not',0),(75533,2099,'pl','Uwaga',0),(75534,2099,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(75535,2099,'ur','Ù†ÙˆÙ¹',0),(75536,2099,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(75537,2099,'vi','Ghi ChÃº',0),(75538,2099,'af','Nota',0),(75539,2099,'ro','NotÄƒ',0),(75540,2099,'et','MÃ¤rkus',0),(75541,2099,'si','Opomba',0),(75542,2099,'ba','Catatan',0),(75543,2099,'nl','Opmerking',0),(75544,2099,'fi','Huomautus',0),(75545,2099,'no','Merk',0),(75546,2099,'da','BemÃ¦rk',0),(75547,2099,'ko','ì°¸ê³ ',0),(75548,2099,'he','×”×¢×¨×”',0),(75549,2099,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(75550,2099,'zh','æ³¨æ„ï¼š\r\n',0),(75551,2099,'sv','Obs',0),(75552,2099,'it','Nota',0),(75553,2099,'tl','',0),(75554,2099,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(75555,2099,'hi','à¤¨à¥‹à¤Ÿ',0),(75556,2099,'ms','Nota',0),(75557,2099,'ar','Ù…Ù„Ø§Ø­Ø¸Ø©',0),(75558,2099,'fr','Remarque',0),(75559,2099,'jp','ãƒ¡ãƒ¢',0),(75560,2099,'pt','Nota',0),(75561,2099,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ°',0),(75562,2099,'es','Nota',0),(75563,2099,'de','Hinweis',0),(75564,2099,'en','Note',0),(75565,2100,'is','',0),(75566,2100,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡',0),(75567,2100,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡',0),(75568,2100,'tr','Not (iÃ§in gÃ¶zden geÃ§irme gÃ¼nlÃ¼ÄŸÃ¼',0),(75569,2100,'pl','Uwaga (dla wersji dziennika',0),(75570,2100,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° (Ð·Ð° Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸',0),(75571,2100,'ur','Ù†ÙˆÙ¹ (Ú©Û’ Ù„Ø¦Û’ Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº',0),(75572,2100,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° (Ð·Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ñƒ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ðµ',0),(75573,2100,'vi','Ghi ChÃº (cho nháº­t kÃ½ chá»‰nh sá»­a',0),(75574,2100,'af','Nota (vir herbesigtigingslog)',0),(75575,2100,'ro','NotÄƒ (pentru revizuirea log',0),(75576,2100,'et','MÃ¤rkus (muutmise logi jaoks',0),(75577,2100,'si','Opomba (za dnevniÅ¡kih',0),(75578,2100,'ba','Catatan (untuk log revisi',0),(75579,2100,'nl','Opmerking (voor herziening logboek',0),(75580,2100,'fi','Huomautus (ajaksi lokin',0),(75581,2100,'no','Merk (gjelder revisjon Logg',0),(75582,2100,'da','BemÃ¦rk (for revision log',0),(75583,2100,'ko','(ê°œì • ë¡œê·¸ì— ëŒ€ í•œ ì°¸ê³ ',0),(75584,2100,'he','×”×¢×¨×” (×¢×‘×•×¨ ×™×•×ž×Ÿ ×ª×™×§×•×Ÿ',0),(75585,2100,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· (Î³Î¹Î± Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ ÎºÎ±Ï„Î±Î³ÏÎ±Ï†Î®Ï‚ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(75586,2100,'zh','æ³¨ï¼ˆæ—¥å¿—ä¿®è®¢ï¼‰\r\n',0),(75587,2100,'sv','Obs (fÃ¶r revidering logg',0),(75588,2100,'it','Nota (per log di revisione',0),(75589,2100,'tl','',0),(75590,2100,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640; (&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;)',0),(75591,2100,'hi','(à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤²à¥‰à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥‹à¤Ÿ',0),(75592,2100,'ms','Nota (untuk semakan log',0),(75593,2100,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© (Ù„Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ø³Ø¬Ù„',0),(75594,2100,'fr','Remarque (pour Journal de rÃ©vision',0),(75595,2100,'jp','ãƒ¡ãƒ¢ï¼ˆè¨‚æ­£ãƒ­ã‚°ç”¨',0),(75596,2100,'pt','Nota (para registro de revisÃ£o',0),(75597,2100,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ (Ð´Ð»Ñ Ð¶ÑƒÑ€Ð½Ð°Ð»Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ð¹',0),(75598,2100,'es','Nota (para bitÃ¡cora de revisiÃ³n)',0),(75599,2100,'de','Hinweis (fÃ¼r Revision Protokoll',0),(75600,2100,'en','Note (for revision log',0),(75601,2101,'is','',0),(75602,2101,'dr',':Ø§Ú¯Ø± Ø§Ø² ØªÙ†Ø¸ÙŠÙ…  Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ Ø§ÙŠÙ† Ù‚Ø³Ù…Øª Ø±Ø§ Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(75603,2101,'pr','ØªÙˆØ¬Ù‡  :Ø§Ú¯Ø± Ø§Ø² ØªÙ†Ø¸ÙŠÙ…  Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ Ø§ÙŠÙ† Ù‚Ø³Ù…Øª Ø±Ø§ Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(75604,2101,'tr','(Not: kullanarak biÃ§imlendirme ayarlarsanÄ±z, bu bÃ¶lÃ¼mÃ¼ gÃ¶z ardÄ±)',0),(75605,2101,'pl','(Uwaga: JeÅ›li za pomocÄ… znacznikÃ³w, ignorowaÄ‡ tej sekcji)',0),(75606,2101,'bg','(Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ°: ÐÐºÐ¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸, Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð°Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ ÑÐµÐºÑ†Ð¸Ñ)',0),(75607,2101,'ur','(Ù†ÙˆÙ¹: Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº ØªÙˆ Ø§Ø³ Ø³ÛŒÚ©Ø´Ù† Ú©Ùˆ Ù†Ø¸Ø± Ø§Ù†Ø¯Ø§Ø² Ú©Ø±ÛŒÚº)',0),(75608,2101,'sr','(ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° : ÐÐºÐ¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚ÐµÑ›Ð¸ Ð½Ð°Ð·Ð½Ð°ÐºÐµ, Ð·Ð°Ð½ÐµÐ¼Ð°Ñ€Ð¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ð¾Ð´ÐµÑ™Ð°Ðº)',0),(75609,2101,'vi','(Ghi ChÃº: Náº¿u dÃ¹ng bá»™ giÃ¡ cÃ´ng thÃªm thÃ¬ bá» qua pháº§n nÃ y)',0),(75610,2101,'af','(Let wel: Indien gebruik Markup stel, Ignoreer hierdie artikel)',0),(75611,2101,'ro','(NotÄƒ: Ã®n cazul Ã®n care utilizarea de Markup Set, ignoraÅ£i aceastÄƒ secÅ£iune)',0),(75612,2101,'et','(MÃ¤rkus: kui kasutamine juurdehindlus, eirata kÃ¤esoleva)',0),(75613,2101,'si','(Opomba: Äe uporaba Markup, prezreti tega oddelka)',0),(75614,2101,'ba','(Catatan: Jika diatur menggunakan Markup, Abaikan bagian ini)',0),(75615,2101,'nl','(Opmerking: als gebruiken Markup ingesteld, negeert u deze sectie)',0),(75616,2101,'fi','(Huomautus: Jos kÃ¤yttÃ¤minen Markup, Ohita tÃ¤mÃ¤ vaihe)',0),(75617,2101,'no','(Merk: Hvis bruke Markup, ignorere denne delen)',0),(75618,2101,'da','(BemÃ¦rk: Hvis ved hjÃ¦lp af Markup, ignorere denne sektion)',0),(75619,2101,'ko','(ì°¸ê³ : ì‚¬ìš© í•˜ ì—¬ íƒœê·¸ë¥¼ ì„¤ì • í•˜ëŠ” ê²½ìš°ì´ ì„¹ì…˜ì„ ë¬´ì‹œ)',0),(75620,2101,'he','(×”×¢×¨×”: ×× ×”×’×“×¨×ª ×‘××ž×¦×¢×•×ª ×¡×™×ž×•×Ÿ, ×”×ª×¢×œ× ×ž×¡×¢×™×£ ×–×”)',0),(75621,2101,'el','(Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·: Î•Î¬Î½ Î¿ÏÎ¯ÏƒÎµÏ„Îµ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚, Î½Î± Î±Î³Î½Î¿Î®ÏƒÎ¿Ï…Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï„Î¼Î®Î¼Î±)',0),(75622,2101,'zh','ï¼ˆæ³¨ï¼šå¦‚æžœä½¿ç”¨æ ‡è®°é›†ï¼Œå¿½ç•¥æœ¬èŠ‚ï¼‰\r\n',0),(75623,2101,'sv','(Obs: om anvÃ¤nda uppmÃ¤rkning, ignorera detta avsnitt)',0),(75624,2101,'it','(Nota: se impostate utilizzando Markup, ignorare questa sezione)',0),(75625,2101,'tl','',0),(75626,2101,'th','(Note: If Using Markup Set, Ignore this section)',0),(75627,2101,'hi','(à¤§à¥à¤¯à¤¾à¤¨ à¤¦à¥‡à¤‚: à¤¯à¤¦à¤¿ à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤¸à¥‡à¤Ÿ, à¤‡à¤¸ à¤…à¤¨à¥à¤­à¤¾à¤— à¤ªà¤° à¤§à¥à¤¯à¤¾à¤¨ à¤¨ à¤¦à¥‡à¤‚)',0),(75628,2101,'ms','(Nota: jika menggunakan penanda menyediakan, abaikan seksyen ini)',0),(75629,2101,'ar','(Ù…Ù„Ø§Ø­Ø¸Ø©: Ø¥Ø°Ø§ ÙƒØ§Ù† ØªØ¹ÙŠÙŠÙ† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¹Ù„Ø§Ù…Ø§ØªØŒ ØªØ¬Ø§Ù‡Ù„ Ù‡Ø°Ø§ Ø§Ù„Ù‚Ø³Ù…)',0),(75630,2101,'fr','(Note : si la valeur de balisage Ã  l\'aide, ignorez cette section)',0),(75631,2101,'jp','ï¼ˆãƒ¡ãƒ¢ï¼šã‚‚ã?—å€¤ä¸Šã?’è¨­å®šã‚’ä½¿ç”¨ã?—ã?Ÿã‚‰ã€?ã?“ã?®ã‚»ã‚¯ã‚·ãƒ§ãƒ³ã?¯ç„¡è¦–ã?—ã?¦ã??ã? ã?•ã?„ï¼‰',0),(75632,2101,'pt','(Nota: se usando marcaÃ§Ã£o definida, Ignore esta seÃ§Ã£o)',0),(75633,2101,'ru','(ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ: Ð•ÑÐ»Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸, Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ñ€Ð°Ð·Ð´ÐµÐ»)',0),(75634,2101,'es','(Nota: Si Usa Juego de Encarecimiento, Ignorar este secciÃ³n)',0),(75635,2101,'de','(Hinweis: Wenn mit Markup festgelegt, diesen Abschnitt Ã¼berspringen)',0),(75636,2101,'en','(Note: If Using Markup Set, Ignore this section)',0),(75637,2102,'is','',0),(75638,2102,'dr',':  Ø¨Ø±Ø§ÙŠ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ø¨Ù‡ ÙƒØ§Ù…Ù¾ÙŠÙˆ ØªØ±Ø®ÙˆØ¯ â€“Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ Ø±Ø§Ø³Øª Ø±ÙˆÙŠ Ù†Ø§Ù… ',0),(75639,2102,'pr','ØªÙˆØ¬Ù‡ :  Ø¨Ø±Ø§ÙŠ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ø¨Ù‡ ÙƒØ§Ù…Ù¾ÙŠÙˆ ØªØ±Ø®ÙˆØ¯ â€“ÙƒÙ„ÙŠÙƒ Ø±Ø§Ø³Øª Ø±ÙˆÙŠ Ù†Ø§Ù… ',0),(75640,2102,'tr','NOT: > Sizin bilgisayarÄ±nÄ±za dosya indirmek iÃ§in Ã¼zerine saÄŸ tÄ±klayÄ±n!',0),(75641,2102,'pl','UWAGA: > Aby pobraÄ‡ plik na komputerze, kliknij prawym przyciskiem nazwÄ™!',0),(75642,2102,'bg','Ð—ÐÐ‘Ð•Ð›Ð•Ð–ÐšÐ: > Ð—Ð° Ð´Ð° Ð¸Ð·Ñ‚ÐµÐ³Ð»Ð¸Ñ‚Ðµ Ñ„Ð°Ð¹Ð»Ð° Ð½Ð° Ð²Ð°ÑˆÐ¸ÑÑ‚ ÐºÐ¾Ð¼Ð¿ÑŽÑ‚ÑŠÑ€, ÐºÐ»Ð¸ÐºÐ½ÐµÑ‚Ðµ Ñ Ð´ÐµÑÐ½Ð¸Ñ Ð±ÑƒÑ‚Ð¾Ð½ Ð²ÑŠÑ€Ñ…Ñƒ Ð¸Ð¼ÐµÑ‚Ð¾!',0),(75643,2102,'ur','Ù†ÙˆÙ¹: > Ù…Ø³Ù„ Ø¢Ù¾ Ú©Û’ Ú©Ù…Ù¾ÛŒÙˆÙ¹Ø± Ù¾Ø± ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ØŒ Ø¯Ø§ÛŒØ§Úº Ù†Ø§Ù… Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº!',0),(75644,2102,'sr','ÐÐÐŸÐžÐœÐ•ÐÐ : > Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÐ»Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð½Ð° Ñ‚Ð²Ð¾Ñ˜ ÐºÐ¾Ð¼Ð¿Ñ˜ÑƒÑ‚ÐµÑ€, ÐºÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð”Ð•Ð¡ÐÐ˜Ðœ Ñ‚Ð°ÑÑ‚ÐµÑ€Ð¾Ð¼ Ð¼Ð¸ÑˆÐ° Ð½Ð° Ð¸Ð¼Ðµ!',0),(75645,2102,'vi','Ghi ChÃº:>Äá»ƒ táº£i há»“ sÆ¡ vá» mÃ¡y cá»§a báº¡n nháº¥p chuá»™t pháº£i vÃ o tÃªn!',0),(75646,2102,'af','LET WEL:> Om \'n lÃªer af te laai na U rekenaar, REGSKLIEK op die naam!',0),(75647,2102,'ro','NOTÄ‚: > Pentru a descÄƒrca fiÅŸierul dumneavoastrÄƒ computer, faceÅ£i clic dreapta pe numele!',0),(75648,2102,'et','MÃ„RKUS: > Faili allalaadimiseks oma arvutisse PAREMKLÃ•PS nimi!',0),(75649,2102,'si','OPOMBA: > V travnato griÄevje pila v vaÅ¡ raÄunalo, desni klik na ime!',0),(75650,2102,'ba','CATATAN: MENGATAKAN Men-download file ke komputer Anda, klik kanan pada nama!',0),(75651,2102,'nl','OPMERKING: > Om te downloaden bestand op uw computer, klik met de rechtermuisknop op de naam!',0),(75652,2102,'fi','HUOMAUTUS: > Voit ladata tiedoston tietokoneen oikealla klikkaa nimi!',0),(75653,2102,'no','MERK: > For Ã¥ laste ned filen til din datamaskin, HÃ˜YREKLIKK pÃ¥ navnet!',0),(75654,2102,'da','BEMÃ†RK: > Du kan hente filen til din computer, HÃ¸jreklik pÃ¥ navnet!',0),(75655,2102,'ko','ì°¸ê³ : &GT; ë‹¹ì‹ ì˜ ì»´í“¨í„°ì— íŒŒì¼ì„ ë‹¤ìš´ë¡œë“œ í•˜ë ¤ë©´ ë§ˆìš°ìŠ¤ ì˜¤ë¥¸ìª½ ì´ë¦„ì„ í´ë¦­!',0),(75656,2102,'he','×”×¢×¨×”: > ×›×“×™ ×œ×”×•×¨×™×“ ××ª ×”×§×•×‘×¥ ×œ×ž×—×©×‘ ×©×œ×š, ×œ×—×¥ ×œ×—×™×¦×” ×™×ž× ×™×ª ×¢×œ ×”×©×!',0),(75657,2102,'el','Î£Î—ÎœÎ•ÎŠÎ©Î£Î—: > Î“Î¹Î± Î½Î± ÎºÎ±Ï„ÎµÎ²Î¬ÏƒÎµÏ„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ ÏƒÏ„Î¿Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„Î® Î£Î‘Î£, ÎºÎ¬Î½Ï„Îµ Î”Î•ÎžÎŠ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÏŒÎ½Î¿Î¼Î±!',0),(75658,2102,'zh','æ³¨æ„ï¼š>è¦ä¸‹è½½æ–‡ä»¶åˆ°ä½ çš„è®¡ç®—æœºä¸­ï¼Œå³é”®ç‚¹å‡»è¿™ä¸ªåç§°ï¼\r\n',0),(75659,2102,'sv','OBS: > Om du vill hÃ¤mta filen till din dator, HÃ–GERKLICKA pÃ¥ namnet!',0),(75660,2102,'it','NOTA: > Per scaricare il file per il tuo computer, fare clic destro sul nome!',0),(75661,2102,'tl','',0),(75662,2102,'th','NOTE:> To download file to YOUR computer, RIGHT CLICK on the name!',0),(75663,2102,'hi','à¤¨à¥‹à¤Ÿ: > à¤«à¤¼à¤¾à¤‡à¤² à¤†à¤ªà¤•à¥‡ à¤•à¤‚à¤ªà¥à¤¯à¥‚à¤Ÿà¤° à¤ªà¤° à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤¨à¤¾à¤® à¤ªà¤° à¤°à¤¾à¤‡à¤Ÿ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚!',0),(75664,2102,'ms','NOTA: > Untuk memuat turun fail ke komputer anda, klik kanan pada nama!',0),(75665,2102,'ar','Ù…Ù„Ø§Ø­Ø¸Ø©: > Ù„ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ù…Ù„Ù Ø¥Ù„Ù‰ Ø§Ù„ÙƒÙ…Ø¨ÙŠÙˆØªØ± Ø§Ù„Ø®Ø§Øµ Ø¨ÙƒØŒ Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„Ø­Ù‚ ÙÙŠ Ø§Ù„Ø§Ø³Ù…!',0),(75666,2102,'fr','REMARQUE: > Pour tÃ©lÃ©charger le fichier sur votre ordinateur, faites un clic droit sur le nom !',0),(75667,2102,'jp','ãƒ¡ãƒ¢:>ã‚³ãƒ³ãƒ”ãƒ¥ãƒ¼ã‚¿ãƒ¼ã?«ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã?™ã‚‹å ´å?ˆã?¯ã€?å??å‰?ã?®ä¸Šã‚’å?³ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(75668,2102,'pt','NOTA: > Para baixar o arquivo para seu computador, clique direito sobre o nome!',0),(75669,2102,'ru','ÐŸÐ Ð˜ÐœÐ•Ð§ÐÐÐ˜Ð•: Ð ÐÐ—Ð”Ð•Ð› ÐÐÐ¡Ð¢Ð ÐžÐ•Ðš Ð§Ñ‚Ð¾Ð±Ñ‹ Ð·Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» Ð½Ð° ÑÐ²Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿ÑŒÑŽÑ‚ÐµÑ€, Ñ‰ÐµÐ»ÐºÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð²Ð¾Ð¹ ÐºÐ½Ð¾Ð¿ÐºÐ¾Ð¹ Ð¼Ñ‹ÑˆÐ¸ Ð½Ð° Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ!',0),(75670,2102,'es','NOTA: Para descargar un file a su computadora, hace CLICK DERECHO en el Nombre!',0),(75671,2102,'de','HINWEIS: > Um die Datei auf Ihren Computer herunterladen, der rechten Maustaste auf den Namen!',0),(75672,2102,'en','NOTE:> To download file to YOUR computer, RIGHT CLICK on the name!',0),(75673,2103,'is','',0),(75674,2103,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(75675,2103,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(75676,2103,'tr','Notlar',0),(75677,2103,'pl','Notatki',0),(75678,2103,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(75679,2103,'ur','Ù†ÙˆÙ¹',0),(75680,2103,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(75681,2103,'vi','Ghi ChÃº',0),(75682,2103,'af','Notas',0),(75683,2103,'ro','Note',0),(75684,2103,'et','MÃ¤rkused',0),(75685,2103,'si','Opombe',0),(75686,2103,'ba','Catatan',0),(75687,2103,'nl','Notities',0),(75688,2103,'fi','Muistiinpanot',0),(75689,2103,'no','Notater',0),(75690,2103,'da','Noter',0),(75691,2103,'ko','ë…¸íŠ¸',0),(75692,2103,'he','×”×¢×¨×•×ª',0),(75693,2103,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(75694,2103,'zh','æ³¨é‡Š\r\n',0),(75695,2103,'sv','Anteckningar',0),(75696,2103,'it','Note',0),(75697,2103,'tl','',0),(75698,2103,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(75699,2103,'hi','à¤¨à¥‹à¤Ÿà¥à¤¸',0),(75700,2103,'ms','Nota-Nota',0),(75701,2103,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(75702,2103,'fr','Notes',0),(75703,2103,'jp','ãƒ¡ãƒ¢',0),(75704,2103,'pt','Notas',0),(75705,2103,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(75706,2103,'es','Notas',0),(75707,2103,'de','Notizen',0),(75708,2103,'en','Notes',0),(75709,2104,'is','',0),(75710,2104,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(75711,2104,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(75712,2104,'tr','Teklif iÃ§in notlar',0),(75713,2104,'pl','Uwagi do oferty',0),(75714,2104,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(75715,2104,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Û’ Ù„Ø¦Û’ Ù†ÙˆÙ¹Ø³',0),(75716,2104,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð·Ð° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(75717,2104,'vi','Ghi ChÃº cho bÃ¡o giÃ¡',0),(75718,2104,'af','Notas vir Kwotasie',0),(75719,2104,'ro','Note pentru citat',0),(75720,2104,'et','MÃ¤rkused hinnapakkumise',0),(75721,2104,'si','Opombe za ponudbo',0),(75722,2104,'ba','Catatan Penawaran',0),(75723,2104,'nl','Notities voor offerte',0),(75724,2104,'fi','Toteaa tarjouspyynnÃ¶n',0),(75725,2104,'no','Notater for tilbud',0),(75726,2104,'da','Noter om tilbud',0),(75727,2104,'ko','ê²¬ì ì— ëŒ€ í•œ ë©”ëª¨',0),(75728,2104,'he','×”×¢×¨×•×ª ×œ×”×¦×¢×ª ×ž×—×™×¨',0),(75729,2104,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î·Î½ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(75730,2104,'zh','æŠ¥ä»·é¡»çŸ¥\r\n',0),(75731,2104,'sv','Anteckningar fÃ¶r offert',0),(75732,2104,'it','Note per preventivo',0),(75733,2104,'tl','',0),(75734,2104,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(75735,2104,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(75736,2104,'ms','Nota-nota bagi sebut harga',0),(75737,2104,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(75738,2104,'fr','Notes pour devis',0),(75739,2104,'jp','è¦‹ç©?ã‚‚ã‚Šã?®ãƒ¡ãƒ¢',0),(75740,2104,'pt','Notas para citaÃ§Ã£o',0),(75741,2104,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ Ð´Ð»Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(75742,2104,'es','Notas para la CotizaciÃ³n',0),(75743,2104,'de','Hinweise fÃ¼r Angebot',0),(75744,2104,'en','Notes for Quote',0),(75745,2105,'is','',0),(75746,2105,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(75747,2105,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(75748,2105,'tr','AlÄ±ntÄ± gÃ¶stermek iÃ§in Not',0),(75749,2105,'pl','Zwraca uwagÄ™ na ofertÄ™',0),(75750,2105,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð¶Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(75751,2105,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù¾Ø± Ø¯Ú©Ú¾Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†ÙˆÙ¹',0),(75752,2105,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð½Ð° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(75753,2105,'vi','Ghi ChÃº hiá»ƒn thá»‹ trÃªn bÃ¡o giÃ¡',0),(75754,2105,'af','Notas om te wys op Kwotasie',0),(75755,2105,'ro','Notele la AratÄƒ pe citat',0),(75756,2105,'et','MÃ¤rkmete kuvamiseks on tsitaat',0),(75757,2105,'si','Ugotavlja, da kaÅ¾ejo na ponudbo',0),(75758,2105,'ba','Catatan untuk menunjukkan pada kutipan',0),(75759,2105,'nl','Notities te tonen op offerte',0),(75760,2105,'fi','Muistiinpanoja nÃ¤yttÃ¤Ã¤ Quote',0),(75761,2105,'no','Notater pÃ¥ tilbud',0),(75762,2105,'da','BemÃ¦rkninger til Vis pÃ¥ tilbud',0),(75763,2105,'ko','ê²¬ì ì— ë³´ì—¬ ë…¸íŠ¸',0),(75764,2105,'he','×”×¢×¨×•×ª ×¢×œ ×”×¦×¢×ª ×ž×—×™×¨',0),(75765,2105,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± Î½Î± Î´ÎµÎ¯Î¾ÎµÎ¹ ÏƒÎµ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(75766,2105,'zh','æ³¨é‡Šæ˜¾ç¤ºæŠ¥ä»·\r\n',0),(75767,2105,'sv','Noterar att visa pÃ¥ offert',0),(75768,2105,'it','Note per mostrare su preventivo',0),(75769,2105,'tl','',0),(75770,2105,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3607;&#3637;&#3656;&#3649;&#3626;&#3604;&#3591;&#3610;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(75771,2105,'hi','à¤¬à¥‹à¤²à¥€ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(75772,2105,'ms','Nota-nota untuk menunjukkan pada sebut harga',0),(75773,2105,'ar','Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ù„Ù„Ø¥Ø¸Ù‡Ø§Ø± ÙÙŠ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(75774,2105,'fr','Notes de montrer sur devis',0),(75775,2105,'jp','è¦‹ç©?ã‚‚ã‚Šã?«è¡¨ç¤ºã?•ã?›ã‚‹ãƒ¡ãƒ¢',0),(75776,2105,'pt','Notas para mostrar na citaÃ§Ã£o',0),(75777,2105,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(75778,2105,'es','Notas para mostrar en la CotizaciÃ³n',0),(75779,2105,'de','Hinweise auf Zitat anzeigen',0),(75780,2105,'en','Notes to show on Quote',0),(75781,2106,'is','',0),(75782,2106,'dr','Ù†ÙˆØ§Ù…Ø¨Ø± ',0),(75783,2106,'pr','Ù†ÙˆØ§Ù…Ø¨Ø± ',0),(75784,2106,'tr','KasÄ±m',0),(75785,2106,'pl','Listopada',0),(75786,2106,'bg','ÐÐ¾ÐµÐ¼Ð²Ñ€Ð¸',0),(75787,2106,'ur','Ù†ÙˆÙ…Ø¨Ø±',0),(75788,2106,'sr','ÐÐ¾Ð²ÐµÐ¼Ð±Ñ€Ð°',0),(75789,2106,'vi','ThÃ¡ng MÆ°á»i Má»™t',0),(75790,2106,'af','November',0),(75791,2106,'ro','Noiembrie',0),(75792,2106,'et','November',0),(75793,2106,'si','Novembra',0),(75794,2106,'ba','November',0),(75795,2106,'nl','November',0),(75796,2106,'fi','Marraskuuta',0),(75797,2106,'no','November',0),(75798,2106,'da','November',0),(75799,2106,'ko','11 ì›”',0),(75800,2106,'he','× ×•×‘×ž×‘×¨',0),(75801,2106,'el','ÎÎ¿ÎµÎ¼Î²ÏÎ¯Î¿Ï…',0),(75802,2106,'zh','åä¸€æœˆ\r\n',0),(75803,2106,'sv','November',0),(75804,2106,'it','Novembre',0),(75805,2106,'tl','',0),(75806,2106,'th','&#3614;&#3620;&#3624;&#3592;&#3636;&#3585;&#3634;&#3618;&#3609;',0),(75807,2106,'hi','à¤¨à¤µà¤®à¥à¤¬à¤°',0),(75808,2106,'ms','November',0),(75809,2106,'ar','Ù†ÙˆÙÙ…Ø¨Ø±',0),(75810,2106,'fr','Novembre',0),(75811,2106,'jp','ï¼‘ï¼‘æœˆ',0),(75812,2106,'pt','Novembro',0),(75813,2106,'ru','ÐÐ¾ÑÐ±Ñ€ÑŒ',0),(75814,2106,'es','Noviembre',0),(75815,2106,'de','November',0),(75816,2106,'en','November',0),(75817,2107,'is','',0),(75818,2107,'dr','( ÙƒØ§Ø±Ø¢Ù…ÙˆØ²Ø§Ù†',0),(75819,2107,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø³ØªÙŠØ§Ø±Ø§Ù†( ÙƒØ§Ø±Ø¢Ù…ÙˆØ²Ø§Ù†',0),(75820,2107,'tr','NUM yardÄ±mcÄ±larÄ±',0),(75821,2107,'pl','NUM asystentÃ³w',0),(75822,2107,'bg','NUM Ð¿Ð¾Ð¼Ð¾Ñ‰Ð½Ð¸Ñ†Ð¸',0),(75823,2107,'ur','Ù…Ø¹Ø§ÙˆÙ† Num',0),(75824,2107,'sr','ÐÐ£Ðœ Ð¿Ð¾Ð¼Ð¾Ñ›Ð½Ð¸Ñ†Ð¸',0),(75825,2107,'vi','Sá»‘ há»— trá»£',0),(75826,2107,'af','NUM assistente',0),(75827,2107,'ro','Num asistenÅ£i',0),(75828,2107,'et','NUM assistendid',0),(75829,2107,'si','NUM pomoÄniki',0),(75830,2107,'ba','Asisten num',0),(75831,2107,'nl','Num assistenten',0),(75832,2107,'fi','NUM avustajat',0),(75833,2107,'no','NUM assistenter',0),(75834,2107,'da','NUM assistenter',0),(75835,2107,'ko','Num ë„ìš°ë¯¸',0),(75836,2107,'he','Num ×¢×•×–×¨×™',0),(75837,2107,'el','NUM Î²Î¿Î·Î¸Î¿Î¯',0),(75838,2107,'zh','ç¼–å·åŠ©ç†\r\n',0),(75839,2107,'sv','NUM assistenter',0),(75840,2107,'it','Num assistenti',0),(75841,2107,'tl','',0),(75842,2107,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3594;&#3656;&#3623;&#3618;',0),(75843,2107,'hi','Num à¤¸à¤¹à¤¾à¤¯à¤•à¥‹à¤‚',0),(75844,2107,'ms','NUM Pembantu',0),(75845,2107,'ar','Ù…Ø³Ø§Ø¹Ø¯ÙŠÙ† Num',0),(75846,2107,'fr','Assistants de num',0),(75847,2107,'jp','ã‚¢ã‚·ã‚¹ã‚¿ãƒ³ãƒˆæ•°',0),(75848,2107,'pt','Assistentes num',0),(75849,2107,'ru','Num Ð¿Ð¾Ð¼Ð¾Ñ‰Ð½Ð¸ÐºÐ¸',0),(75850,2107,'es','Num. de Asistentes',0),(75851,2107,'de','NUM-Assistenten',0),(75852,2107,'en','Num Assistants',0),(75853,2108,'is','',0),(75854,2108,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø§Ù¾Ø±Ø§ØªÙˆØ±',0),(75855,2108,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø§Ù¾Ø±Ø§ØªÙˆØ±',0),(75856,2108,'tr','NUM operatÃ¶rleri',0),(75857,2108,'pl','Liczba podmiotÃ³w gospodarczych',0),(75858,2108,'bg','NUM Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ð¸',0),(75859,2108,'ur','Num Ø¢Ù¾Ø±ÛŒÙ¹Ø±Ø²',0),(75860,2108,'sr','ÐÐ£Ðœ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ð¸',0),(75861,2108,'vi','sá»‘ Ä‘iá»u hÃ nh',0),(75862,2108,'af','NUM operateurs',0),(75863,2108,'ro','Operatorii de num',0),(75864,2108,'et','NUM operaatorid',0),(75865,2108,'si','NUM operaterji',0),(75866,2108,'ba','Num operator',0),(75867,2108,'nl','Num exploitanten',0),(75868,2108,'fi','NUM toimijoiden',0),(75869,2108,'no','NUM operatÃ¸rer',0),(75870,2108,'da','NUM operatÃ¸rer',0),(75871,2108,'ko','Num ì—°ì‚°ìž',0),(75872,2108,'he','Num ××•×¤×¨×˜×•×¨×™×',0),(75873,2108,'el','NUM Ï†Î¿ÏÎµÎ¯Ï‚',0),(75874,2108,'zh','æ•°é‡æ“ä½œ\r\n',0),(75875,2108,'sv','NUM operatÃ¶rer',0),(75876,2108,'it','Operatori num',0),(75877,2108,'tl','',0),(75878,2108,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3612;&#3641;&#3657;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;',0),(75879,2108,'hi','Num à¤‘à¤ªà¤°à¥‡à¤Ÿà¤°à¥à¤¸',0),(75880,2108,'ms','NUM pengendali',0),(75881,2108,'ar','Ø¹ÙˆØ§Ù…Ù„ ØªØ´ØºÙŠÙ„ Num',0),(75882,2108,'fr','OpÃ©rateurs de num',0),(75883,2108,'jp','ã‚ªãƒšãƒ¬ãƒ¼ã‚¿ãƒ¼æ•°',0),(75884,2108,'pt','Operadores num',0),(75885,2108,'ru','Num Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ñ‹',0),(75886,2108,'es','Num. de Operadores',0),(75887,2108,'de','NUM-Operatoren',0),(75888,2108,'en','Num Operators',0),(75889,2109,'is','',0),(75890,2109,'dr','Ø´Ù…Ø§Ø±Ù‡ ',0),(75891,2109,'pr','Ø´Ù…Ø§Ø±Ù‡ ',0),(75892,2109,'tr','SayÄ±',0),(75893,2109,'pl','Numer',0),(75894,2109,'bg','ÐÐ¾Ð¼ÐµÑ€',0),(75895,2109,'ur','ØªØ¹Ø¯Ø§Ø¯',0),(75896,2109,'sr','Ð‘Ñ€Ð¾Ñ˜',0),(75897,2109,'vi','Sá»‘',0),(75898,2109,'af','Nommer',0),(75899,2109,'ro','NumÄƒrul',0),(75900,2109,'et','Number',0),(75901,2109,'si','Å tevilka',0),(75902,2109,'ba','Nomor',0),(75903,2109,'nl','Nummer',0),(75904,2109,'fi','Numero',0),(75905,2109,'no','Nummer',0),(75906,2109,'da','Antallet',0),(75907,2109,'ko','ë²ˆí˜¸',0),(75908,2109,'he','×ž×¡×¤×¨',0),(75909,2109,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(75910,2109,'zh','å·ç \r\n',0),(75911,2109,'sv','Antal',0),(75912,2109,'it','Numero',0),(75913,2109,'tl','',0),(75914,2109,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;',0),(75915,2109,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(75916,2109,'ms','Nombor',0),(75917,2109,'ar','Ø§Ù„Ø¹Ø¯Ø¯',0),(75918,2109,'fr','Nombre',0),(75919,2109,'jp','æ•°',0),(75920,2109,'pt','NÃºmero',0),(75921,2109,'ru','ÐÐ¾Ð¼ÐµÑ€',0),(75922,2109,'es','NÃºmero',0),(75923,2109,'de','Anzahl',0),(75924,2109,'en','Number',0),(75925,2110,'is','',0),(75926,2110,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±Ø§Ø³Ø±ÙŠ',0),(75927,2110,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±Ø§Ø³Ø±ÙŠ',0),(75928,2110,'tr','TakÄ±m karÅŸÄ±sÄ±nda',0),(75929,2110,'pl','Liczba w poziomie',0),(75930,2110,'bg','Ð‘Ñ€Ð¾Ð¹ Ð¿Ð¾ Ñ…Ð¾Ñ€Ð¸Ð·Ð¾Ð½Ñ‚Ð°Ð»Ð°',0),(75931,2110,'ur','Ø¨Ø§Ø± Ù†Ù…Ø¨Ø±',0),(75932,2110,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€ÐµÐºÐ¾',0),(75933,2110,'vi','Sá»‘ hÃ ng ngang',0),(75934,2110,'af','Getal oor',0),(75935,2110,'ro','NumÄƒr peste',0),(75936,2110,'et','Arv ristisuunas',0),(75937,2110,'si','Å tevilo Äez',0),(75938,2110,'ba','Nomor di seluruh',0),(75939,2110,'nl','Nummer over',0),(75940,2110,'fi','VierekkÃ¤in',0),(75941,2110,'no','Antall bortover',0),(75942,2110,'da','Antallet pÃ¥ tvÃ¦rs af',0),(75943,2110,'ko','ì „ì²´ ìˆ˜',0),(75944,2110,'he','×ž×¡×¤×¨ ×ž×¢×‘×¨',0),(75945,2110,'el','Î Î»Î®Î¸Î¿Ï‚ ÎºÎ±Ï„Î¬ Ï€Î»Î¬Ï„Î¿Ï‚',0),(75946,2110,'zh','åˆ—æ•°\r\n',0),(75947,2110,'sv','Antal Ã¶ver',0),(75948,2110,'it','Numero attraverso',0),(75949,2110,'tl','',0),(75950,2110,'th','&#3609;&#3633;&#3610;&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3634;&#3617;&#3586;&#3623;&#3634;&#3591;',0),(75951,2110,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤ªà¤¾à¤°',0),(75952,2110,'ms','Jumlah di seluruh',0),(75953,2110,'ar','Ø¹Ø¯Ø¯ Ø¹Ø¨Ø±',0),(75954,2110,'fr','Nombre Ã  travers',0),(75955,2110,'jp','ï½žä»¥ä¸Šã?®æ•°å­—',0),(75956,2110,'pt','NÃºmero do outro lado',0),(75957,2110,'ru','ÐÐ¾Ð¼ÐµÑ€ Ñ‡ÐµÑ€ÐµÐ·',0),(75958,2110,'es','NÃºmero al Otro Lado',0),(75959,2110,'de','Anzahl Ã¼ber',0),(75960,2110,'en','Number Across',0),(75961,2111,'is','',0),(75962,2111,'dr','Ø­Ø¯ÙˆØ¯ Ø´Ù…Ø§Ø±Ù‡',0),(75963,2111,'pr','Ø­Ø¯ÙˆØ¯ Ø´Ù…Ø§Ø±Ù‡',0),(75964,2111,'tr','SayÄ± Ã§evresinde',0),(75965,2111,'pl','Numer wokÃ³Å‚',0),(75966,2111,'bg','Ð‘Ñ€Ð¾Ð¹ Ð¾ÐºÐ¾Ð»Ð¾',0),(75967,2111,'ur','ØªØ¹Ø¯Ø§Ø¯ Ú©Û’ Ø§Ø±Ø¯ Ú¯Ø±Ø¯',0),(75968,2111,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¾ÐºÐ¾Ð»Ð¾',0),(75969,2111,'vi','Sá»‘ xung quanh',0),(75970,2111,'af','Nommer rondom',0),(75971,2111,'ro','NumÄƒrul Ã®n jurul',0),(75972,2111,'et','Number Ã¼mber',0),(75973,2111,'si','Å tevilo okoli',0),(75974,2111,'ba','Nomor di sekitar',0),(75975,2111,'nl','Nummer rond',0),(75976,2111,'fi','Useita ympÃ¤ri',0),(75977,2111,'no','Tall rundt',0),(75978,2111,'da','Antal omkring',0),(75979,2111,'ko','ì£¼ìœ„ ìˆ˜',0),(75980,2111,'he','×ž×¡×¤×¨ ×ž×¡×‘×™×‘',0),(75981,2111,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î³ÏÏÏ‰ Î±Ï€ÏŒ',0),(75982,2111,'zh','äººæ•°å¤§çº¦\r\n',0),(75983,2111,'sv','Antal runt',0),(75984,2111,'it','Numero intorno',0),(75985,2111,'tl','',0),(75986,2111,'th','&#3609;&#3633;&#3610;&#3592;&#3635;&#3609;&#3623;&#3609;&#3619;&#3629;&#3610; &#3654;',0),(75987,2111,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤†à¤¸à¤ªà¤¾à¤¸',0),(75988,2111,'ms','Jumlah sekitar',0),(75989,2111,'ar','Ø¹Ø¯Ø¯ Ø­ÙˆÙ„Ù‡Ø§',0),(75990,2111,'fr','Nombre entier',0),(75991,2111,'jp','ï½žä½?ã?®æ•°å­—',0),(75992,2111,'pt','NÃºmero em torno de',0),(75993,2111,'ru','Ð§Ð¸ÑÐ»Ð¾ Ð²Ð¾ÐºÑ€ÑƒÐ³',0),(75994,2111,'es','NÃºmero Alrededor',0),(75995,2111,'de','Zahl um',0),(75996,2111,'en','Number Around',0),(75997,2112,'is','',0),(75998,2112,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø¨ÙŠÙ† ',0),(75999,2112,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø¨ÙŠÙ† ',0),(76000,2112,'tr','ArasÄ±nda bir sayÄ±',0),(76001,2112,'pl','Numer miÄ™dzy',0),(76002,2112,'bg','Ð§Ð¸ÑÐ»Ð¾ Ð¼ÐµÐ¶Ð´Ñƒ',0),(76003,2112,'ur','Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† Ù†Ù…Ø¨Ø±',0),(76004,2112,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¸Ð·Ð¼ÐµÑ’Ñƒ',0),(76005,2112,'vi','Sá»‘ giá»¯a',0),(76006,2112,'af','Getal tussen',0),(76007,2112,'ro','NumÄƒr Ã®ntre',0),(76008,2112,'et','Vabadusastmete arv',0),(76009,2112,'si','Å tevilo med',0),(76010,2112,'ba','Angka antara',0),(76011,2112,'nl','Getal tussen',0),(76012,2112,'fi','VÃ¤liltÃ¤',0),(76013,2112,'no','Tall mellom',0),(76014,2112,'da','Tal mellem',0),(76015,2112,'ko','ì‚¬ì´ì˜ ìˆ«ìž',0),(76016,2112,'he','×ž×¡×¤×¨ ×‘×™×Ÿ',0),(76017,2112,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î¼ÎµÏ„Î±Î¾Ï',0),(76018,2112,'zh','æ•°é—´\r\n',0),(76019,2112,'sv','Nummer mellan',0),(76020,2112,'it','Numero tra',0),(76021,2112,'tl','',0),(76022,2112,'th','&#3609;&#3633;&#3610;&#3592;&#3635;&#3609;&#3623;&#3609;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;',0),(76023,2112,'hi','à¤•à¥‡ à¤¬à¥€à¤š à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(76024,2112,'ms','Nombor di antara',0),(76025,2112,'ar','Ø¹Ø¯Ø¯ Ø¨ÙŠÙ†',0),(76026,2112,'fr','Nombre compris entre',0),(76027,2112,'jp','ï½žã?®é–“ã?®æ•°å­—',0),(76028,2112,'pt','NÃºmero entre',0),(76029,2112,'ru','Ð§Ð¸ÑÐ»Ð¾ Ð¼ÐµÐ¶Ð´Ñƒ',0),(76030,2112,'es','NÃºmero Entre',0),(76031,2112,'de','Zahl zwischen',0),(76032,2112,'en','Number between',0),(76033,2113,'is','',0),(76034,2113,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(76035,2113,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(76036,2113,'tr','# Ã‡alÄ±ÅŸanlar',0),(76037,2113,'pl','# PracownikÃ³w',0),(76038,2113,'bg','# Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(76039,2113,'ur','# Ù…Ù„Ø§Ø²Ù…ÛŒÙ†',0),(76040,2113,'sr','# Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(76041,2113,'vi','Sá»‘ nhÃ¢n viÃªn',0),(76042,2113,'af','# Werknemers',0),(76043,2113,'ro','# AngajaÅ£i',0),(76044,2113,'et','# TÃ¶Ã¶tajaid',0),(76045,2113,'si','# Zaposlenih',0),(76046,2113,'ba','# Karyawan',0),(76047,2113,'nl','# Werknemers',0),(76048,2113,'fi','# TyÃ¶ntekijÃ¤t',0),(76049,2113,'no','# Ansatte',0),(76050,2113,'da','# Medarbejdere',0),(76051,2113,'ko','# ì§ì›',0),(76052,2113,'he','# ×¢×•×‘×“×™×',0),(76053,2113,'el','# Î•ÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(76054,2113,'zh','ï¼ƒé›‡å‘˜\r\n',0),(76055,2113,'sv','# AnstÃ¤llda',0),(76056,2113,'it','# Dipendenti',0),(76057,2113,'tl','',0),(76058,2113,'th','&#3609;&#3633;&#3610;&#3592;&#3635;&#3609;&#3623;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(76059,2113,'hi','# à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚',0),(76060,2113,'ms','# Pekerja',0),(76061,2113,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(76062,2113,'fr','# EmployÃ©s',0),(76063,2113,'jp','å¾“æ¥­å“¡æ•°',0),(76064,2113,'pt','# Empregados',0),(76065,2113,'ru','# Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(76066,2113,'es','# Empleados',0),(76067,2113,'de','-Mitarbeiter',0),(76068,2113,'en','# Employees',0),(76069,2114,'is','',0),(76070,2114,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø®Ø· ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(76071,2114,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø®Ø· ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(76072,2114,'tr','# SatÄ±r Ã¶ÄŸeleri',0),(76073,2114,'pl','# Pozycje',0),(76074,2114,'bg','# Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ Ñ€ÐµÐ´Ð¾Ð²Ðµ',0),(76075,2114,'ur','# Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§Ø¡',0),(76076,2114,'sr','# Ð¡Ñ‚Ð°Ð²ÐºÐ¸ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(76077,2114,'vi','Sá»‘ dÃ²ng hÃ ng',0),(76078,2114,'af','# Lynitems',0),(76079,2114,'ro','# Elemente',0),(76080,2114,'et','# Kirjeid',0),(76081,2114,'si','# VrstiÄne postavke',0),(76082,2114,'ba','# Item baris',0),(76083,2114,'nl','# Regelitems',0),(76084,2114,'fi','# Rivinimikkeet',0),(76085,2114,'no','# Linjeelementer',0),(76086,2114,'da','# Linjeelementer',0),(76087,2114,'ko','# í’ˆëª©',0),(76088,2114,'he','# ×¤×¨×™×˜×™ ×©×•×¨×”',0),(76089,2114,'el','# Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(76090,2114,'zh','ï¼ƒçº¿é¡¹ç›®\r\n',0),(76091,2114,'sv','# Radartiklar',0),(76092,2114,'it','# Voci',0),(76093,2114,'tl','',0),(76094,2114,'th','&#3609;&#3633;&#3610;&#3592;&#3635;&#3609;&#3623;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;',0),(76095,2114,'hi','# à¤°à¥‡à¤–à¤¾ à¤†à¤‡à¤Ÿà¤®',0),(76096,2114,'ms','# Item talian',0),(76097,2114,'ar','# Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø³Ø·Ø±',0),(76098,2114,'fr','# Lignes de facturation',0),(76099,2114,'jp','å“?ç›®å??æ•°',0),(76100,2114,'pt','# Itens de linha',0),(76101,2114,'ru','# ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ð¹',0),(76102,2114,'es','# Items de Linea',0),(76103,2114,'de','# Einzelposten',0),(76104,2114,'en','# Line Items',0),(76105,2115,'is','',0),(76106,2115,'dr','ØªØ¹Ø¯Ø§Ø¯',0),(76107,2115,'pr','ØªØ¹Ø¯Ø§Ø¯',0),(76108,2115,'tr','SayÄ±sÄ±',0),(76109,2115,'pl','Liczba',0),(76110,2115,'bg','Ð‘Ñ€Ð¾Ð¹ Ð½Ð°',0),(76111,2115,'ur','Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(76112,2115,'sr','Ð‘Ñ€Ð¾Ñ˜',0),(76113,2115,'vi','Sá»‘ cá»§a',0),(76114,2115,'af','Getal van',0),(76115,2115,'ro','NumÄƒrul de',0),(76116,2115,'et','Arv',0),(76117,2115,'si','Å tevilo',0),(76118,2115,'ba','Jumlah',0),(76119,2115,'nl','Aantal',0),(76120,2115,'fi','MÃ¤Ã¤rÃ¤',0),(76121,2115,'no','Antall',0),(76122,2115,'da','Antallet af',0),(76123,2115,'ko','ìˆ˜',0),(76124,2115,'he','×ž×¡×¤×¨',0),(76125,2115,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½',0),(76126,2115,'zh','æ•°\r\n',0),(76127,2115,'sv','Antal',0),(76128,2115,'it','Numero di',0),(76129,2115,'tl','',0),(76130,2115,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;',0),(76131,2115,'hi','à¤•à¤®à¤°à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(76132,2115,'ms','Bilangan',0),(76133,2115,'ar','Ø¹Ø¯Ø¯ Ù…Ù†',0),(76134,2115,'fr','Nombre de',0),(76135,2115,'jp','ï½žã?®æ•°',0),(76136,2115,'pt','NÃºmero de',0),(76137,2115,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(76138,2115,'es','NÃºmero de',0),(76139,2115,'de','Anzahl der',0),(76140,2115,'en','Number of',0),(76141,2116,'is','',0),(76142,2116,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ',0),(76143,2116,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ',0),(76144,2116,'tr','Gemi iÃ§in kutularÄ±',0),(76145,2116,'pl','Numer pola do statku',0),(76146,2116,'bg','Ð‘Ñ€Ð¾Ð¹ ÐºÐ°ÑˆÐ¾Ð½Ð¸ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(76147,2116,'ur','Ø¬ÛØ§Ø² ØªÚ© Ø®Ø§Ù†ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(76148,2116,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¾ÐºÐ²Ð¸Ñ€Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(76149,2116,'vi','Sá»‘ thÃ¹ng chuyá»ƒn',0),(76150,2116,'af','Aantal bokse om te versend',0),(76151,2116,'ro','NumÄƒrul de cutii pentru a navei',0),(76152,2116,'et','Kastide laevade arv',0),(76153,2116,'si','Å tevilo Å¡katle za ladje',0),(76154,2116,'ba','Jumlah kotak untuk kapal',0),(76155,2116,'nl','Aantal dozen om te verzenden',0),(76156,2116,'fi','Laatikoiden aluksen',0),(76157,2116,'no','Antall bokser til skip',0),(76158,2116,'da','Antallet af kasser til skibet',0),(76159,2116,'ko','ë°°ì†¡ ìƒìž',0),(76160,2116,'he','×ž×¡×¤×¨ ×§×•×¤×¡××•×ª ×œ×ž×©×œ×•×—',0),(76161,2116,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€Î»Î¿Î¯Ï‰Î½',0),(76162,2116,'zh','è¿é€ç®±æ•°\r\n',0),(76163,2116,'sv','Antal lÃ¥dor att fartyget',0),(76164,2116,'it','Numero di scatole per spedire',0),(76165,2116,'tl','',0),(76166,2116,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3585;&#3621;&#3656;&#3629;&#3591;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(76167,2116,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤•à¥à¤¸à¥‡ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(76168,2116,'ms','Bilangan kotak untuk kapal',0),(76169,2116,'ar','Ø¹Ø¯Ø¯ Ù…Ù† Ø§Ù„Ù…Ø±Ø¨Ø¹Ø§Øª Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(76170,2116,'fr','Nombre de boÃ®tes d\'expÃ©dier',0),(76171,2116,'jp','ç™ºé€?ã?™ã‚‹ç®±æ•°',0),(76172,2116,'pt','NÃºmero de caixas para enviar',0),(76173,2116,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÐ¾Ñ€Ð¾Ð±Ð¾Ðº Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(76174,2116,'es','NÃºmero de cajas para enviar',0),(76175,2116,'de','Anzahl der Boxen, Schiff',0),(76176,2116,'en','Number of boxes to ship',0),(76177,2117,'is','',0),(76178,2117,'dr','ØªØ¹Ø¯Ø§Ø¯ ØµÙØ­Ø§Øª',0),(76179,2117,'pr','ØªØ¹Ø¯Ø§Ø¯ ØµÙØ­Ø§Øª',0),(76180,2117,'tr','Sayfa sayÄ±sÄ±',0),(76181,2117,'pl','Liczba stron',0),(76182,2117,'bg','Ð‘Ñ€Ð¾Ð¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(76183,2117,'ur','ØµÙØ­Ø§Øª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(76184,2117,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(76185,2117,'vi','Sá»‘ Trang',0),(76186,2117,'af','Aantal Bladsye',0),(76187,2117,'ro','NumÄƒr de pagini',0),(76188,2117,'et','LehekÃ¼lgede arv',0),(76189,2117,'si','Å tevilo strani',0),(76190,2117,'ba','Jumlah halaman',0),(76191,2117,'nl','Aantal pagina \'s',0),(76192,2117,'fi','SivumÃ¤Ã¤rÃ¤',0),(76193,2117,'no','Antall sider',0),(76194,2117,'da','Antallet af sider',0),(76195,2117,'ko','íŽ˜ì´ì§€ ìˆ˜',0),(76196,2117,'he','×ž×¡×¤×¨ ×“×¤×™×',0),(76197,2117,'el','Î‘ÏiÎ¸Î¼ÏŒÏ‚ Î£ÎµÎ»Î¯Î´Ï‰Î½',0),(76198,2117,'zh','é¡µæ•°\r\n',0),(76199,2117,'sv','Antal sidor',0),(76200,2117,'it','Numero di pagine',0),(76201,2117,'tl','',0),(76202,2117,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3627;&#3609;&#3657;&#3634;',0),(76203,2117,'hi','à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(76204,2117,'ms','Bilangan muka surat',0),(76205,2117,'ar','Ø¹Ø¯Ø¯ Ø§Ù„ØµÙØ­Ø§Øª',0),(76206,2117,'fr','Nombre de Pages',0),(76207,2117,'jp','ãƒšãƒ¼ã‚¸æ•°',0),(76208,2117,'pt','NÃºmero de pÃ¡ginas',0),(76209,2117,'ru','Ð§Ð¸ÑÐ»Ð¾ Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†',0),(76210,2117,'es','NÃºmero de PÃ¡ginas',0),(76211,2117,'de','Anzahl der Seiten',0),(76212,2117,'en','Number of Pages',0),(76213,2118,'is','',0),(76214,2118,'dr','ØªØ¹Ø¯Ø§Ø¯ ØµÙØ­Ø§Øª Ø¯Ø± Ø§ÙŠÙ† ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ù…Ø³Ø§ÙˆÙŠ Ù†ÙŠØ³Øª Ø¨Ø§ ',0),(76215,2118,'pr','ØªØ¹Ø¯Ø§Ø¯ ØµÙØ­Ø§Øª Ø¯Ø± Ø§ÙŠÙ† ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ù…Ø³Ø§ÙˆÙŠ Ù†ÙŠØ³Øª Ø¨Ø§ ',0),(76216,2118,'tr','EÅŸit deÄŸildir bu ekrandaki sayfa sayÄ±sÄ±',0),(76217,2118,'pl','Liczba stron na ekranie nie jest rÃ³wny',0),(76218,2118,'bg','Ð‘Ñ€Ð¾Ð¹ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸Ñ‚Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ ÐµÐºÑ€Ð°Ð½ Ð½Ðµ Ðµ Ñ€Ð°Ð²Ð½Ð¾ Ð½Ð°',0),(76219,2118,'ur','ÛŒÛ Ø³Ú©Ø±ÛŒÙ† Ú©Û’ Ø¨Ø±Ø§Ø¨Ø± Ù†ÛÛŒÚº Ù¾Ø± ØµÙØ­Ø§Øª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(76220,2118,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð½Ð° Ð¾Ð²Ð¾Ð¼ ÐµÐºÑ€Ð°Ð½Ñƒ Ð½Ð¸Ñ˜Ðµ Ñ˜ÐµÐ´Ð½Ð°ÐºÐ¾',0),(76221,2118,'vi','Sá»‘ trang trÃªn mÃ n hÃ¬nh khÃ´ng báº±ng',0),(76222,2118,'af','Aantal bladsye op hierdie skerm is nie gelyk aan',0),(76223,2118,'ro','NumÄƒr de pagini de pe acest ecran nu este egal cu',0),(76224,2118,'et','LehekÃ¼lgi ei vÃµrdu ekraanil',0),(76225,2118,'si','Å tevilo strani na tem zaslonu ni enako',0),(76226,2118,'ba','Jumlah halaman di layar ini tidak sama dengan',0),(76227,2118,'nl','Aantal pagina\'s op dit scherm niet gelijk aan',0),(76228,2118,'fi','SivumÃ¤Ã¤rÃ¤ eri suuri kuin tÃ¤ssÃ¤ nÃ¤ytÃ¶ssÃ¤',0),(76229,2118,'no','Antall sider pÃ¥ skjermen ikke lik',0),(76230,2118,'da','Antallet af sider pÃ¥ denne skÃ¦rm ikke lig',0),(76231,2118,'ko','ì´ í™”ë©´ ê°™ì§€ì— íŽ˜ì´ì§€ì˜ ìˆ˜',0),(76232,2118,'he','×ž×¡×¤×¨ ×¢×ž×•×“×™× ×‘×ž×¡×š ×–×” ×œ× ×©×•×•×”',0),(76233,2118,'el','Î‘ÏiÎ¸Î¼ÏŒÏ‚ Î£ÎµÎ»Î¯Î´Ï‰Î½ ÏƒÎµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î¿Î¸ÏŒÎ½Î· Î´ÎµÎ½ Î¹ÏƒÎ¿ÏÏ„Î±Î¹ Î¼Îµ',0),(76234,2118,'zh','æ­¤å±å¹•ä¸Šçš„é¡µæ•°ä¸ç­‰äºŽ\r\n',0),(76235,2118,'sv','Antalet sidor pÃ¥ den hÃ¤r skÃ¤rmen inte lika med',0),(76236,2118,'it','Numero di pagine su questo schermo non Ã¨ uguale a',0),(76237,2118,'tl','',0),(76238,2118,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3627;&#3609;&#3657;&#3634;&#3610;&#3609;&#3627;&#3609;&#3657;&#3634;&#3592;&#3629;&#3609;&#3637;&#3657;&#3652;&#3617;&#3656;&#3648;&#3607;&#3656;&#3634;&#3585;&#3633;&#3610;',0),(76239,2118,'hi','à¤‡à¤¸ à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¥‡ à¤¬à¤°à¤¾à¤¬à¤° à¤ªà¤° à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(76240,2118,'ms','Bilangan muka surat di skrin ini tidak sama dengan',0),(76241,2118,'ar','Ø¹Ø¯Ø¯ Ø§Ù„ØµÙØ­Ø§Øª Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø§Ø´Ø© Ù‡Ø°Ø§ Ù„Ø§ ÙŠØ³Ø§ÙˆÙŠ',0),(76242,2118,'fr','Nombre de pages sur cet Ã©cran ne correspond pas Ã ',0),(76243,2118,'jp','ã?“ã?®ç”»é?¢ä¸Šã?®ãƒšãƒ¼ã‚¸æ•°ã?¯ï½žã?«ä¸€è‡´ã?—ã?¾ã?›ã‚“',0),(76244,2118,'pt','NÃºmero de pÃ¡ginas na tela nÃ£o Ã© igual a',0),(76245,2118,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ† Ð½Ð° ÑÑ‚Ð¾Ð¼ ÑÐºÑ€Ð°Ð½Ðµ Ð½Ðµ Ñ€Ð°Ð²Ð½Ð¾',0),(76246,2118,'es','NÃºmero de pÃ¡ginas en esta pantalla no es igual a',0),(76247,2118,'de','Anzahl der Seiten auf diesem Bildschirm nicht gleich',0),(76248,2118,'en','Number of pages on this screen not equal to',0),(76249,2119,'is','',0),(76250,2119,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù‚Ø³Ù…Øª Ù‡Ø§ ',0),(76251,2119,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù‚Ø³Ù…Øª Ù‡Ø§ ',0),(76252,2119,'tr','ParÃ§a sayÄ±sÄ±',0),(76253,2119,'pl','Numer czÄ™Å›ci',0),(76254,2119,'bg','Ð‘Ñ€Ð¾Ð¹ Ñ‡Ð°ÑÑ‚Ð¸',0),(76255,2119,'ur','Ø­ØµÙˆÚº Ú©Û’ Ù†Ù…Ø¨Ø±',0),(76256,2119,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð´ÐµÐ»Ð¾Ð²Ð°',0),(76257,2119,'vi','Sá»‘ phá»¥ tÃ¹ng',0),(76258,2119,'af','Aantal Onderdele',0),(76259,2119,'ro','NumÄƒrul de pÄƒrÅ£i',0),(76260,2119,'et','Osade arv',0),(76261,2119,'si','Å tevilo delov',0),(76262,2119,'ba','Jumlah bagian',0),(76263,2119,'nl','Aantal onderdelen',0),(76264,2119,'fi','Osien mÃ¤Ã¤rÃ¤',0),(76265,2119,'no','Antall deler',0),(76266,2119,'da','Antallet af dele',0),(76267,2119,'ko','ë¶€í’ˆì˜ ìˆ˜',0),(76268,2119,'he','×ž×¡×¤×¨ ×”×—×œ×§×™×',0),(76269,2119,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î¼ÎµÏÏŽÎ½',0),(76270,2119,'zh','é›¶ä»¶æ•°\r\n',0),(76271,2119,'sv','Antal delar',0),(76272,2119,'it','Numero di parti',0),(76273,2119,'tl','',0),(76274,2119,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3594;&#3636;&#3657;&#3609;&#3626;&#3656;&#3623;&#3609;',0),(76275,2119,'hi','à¤­à¤¾à¤—à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(76276,2119,'ms','Bilangan bahagian-bahagian',0),(76277,2119,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø£Ø¬Ø²Ø§Ø¡',0),(76278,2119,'fr','Nombre de piÃ¨ces',0),(76279,2119,'jp','éƒ¨å“?ã?®æ•°',0),(76280,2119,'pt','NÃºmero de peÃ§as',0),(76281,2119,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ‡Ð°ÑÑ‚ÐµÐ¹',0),(76282,2119,'es','NÃºmero de Partes',0),(76283,2119,'de','Anzahl der Teile',0),(76284,2119,'en','Number of Parts',0),(76285,2120,'is','',0),(76286,2120,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ Ø¯Ø± Ø³Ø§Ù„ Ø¨Ø§ÙŠØ¯ Ø¨ÙŠØ´ØªØ± Ø§Ø² ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(76287,2120,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ Ø¯Ø± Ø³Ø§Ù„ Ø¨Ø§ÙŠØ¯ Ø¨ÙŠØ´ØªØ± Ø§Ø² ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(76288,2120,'tr','# Her yÄ±l dÃ¶nemler > 0 olmalÄ±dÄ±r',0),(76289,2120,'pl','liczba okresÃ³w w ciÄ…gu roku musi byÄ‡ > 0',0),(76290,2120,'bg','# Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‚Ðµ Ð² Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ > 0',0),(76291,2120,'ur','# Ø³Ø§Ù„Ø§Ù†Û Ø¹Ø±ØµÙˆÚº Ú©ÛŒ > 0 ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒÛ’',0),(76292,2120,'sr','# Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ñ‚Ð¾ÐºÐ¾Ð¼ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ 0.',0),(76293,2120,'vi','Sá»‘ thá»i ká»³ má»—i nÄƒm pháº£i lá»›n hÆ¡n 0',0),(76294,2120,'af','# van die periodes per jaar moet > 0',0),(76295,2120,'ro','# de perioade pe an trebuie sÄƒ fie > 0',0),(76296,2120,'et','# perioodidel aastas tuleb > 0',0),(76297,2120,'si','# obdobij na leto mora biti > 0',0),(76298,2120,'ba','# periode per tahun harus mengatakan 0',0),(76299,2120,'nl','aantal termijnen per jaar moet worden > 0',0),(76300,2120,'fi','# maksukertojen on oltava > 0',0),(76301,2120,'no','antall perioder per Ã¥r mÃ¥ vÃ¦re > 0',0),(76302,2120,'da','antal perioder pr. Ã¥r skal > 0',0),(76303,2120,'ko','ë…„ ë‹¹ ê¸°ê°„ì˜ # &gt; 0 ì´ì–´ì•¼ í•©ë‹ˆë‹¤.',0),(76304,2120,'he','# ×ª×§×•×¤×•×ª ×‘×©× ×” ×—×™×™×‘ ×œ×”×™×•×ª > 0',0),(76305,2120,'el','# Ï„Ï‰Î½ Ï€ÎµÏÎ¹ÏŒÎ´Ï‰Î½ Î±Î½Î¬ Î­Ï„Î¿Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ > 0',0),(76306,2120,'zh','æ¯å¹´æ—¶æœŸï¼ƒå¿…é¡»>0\r\n',0),(76307,2120,'sv','# perioder per Ã¥r mÃ¥ste vara > 0',0),(76308,2120,'it','# dei periodi all\'anno deve essere > 0',0),(76309,2120,'tl','',0),(76310,2120,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3594;&#3656;&#3623;&#3591;&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3605;&#3656;&#3629;&#3611;&#3637;&#3605;&#3657;&#3629;&#3591;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634; 0',0),(76311,2120,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤· à¤…à¤µà¤§à¤¿à¤¯à¥‹à¤‚ à¤•à¥€ # > 0 à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(76312,2120,'ms','# dalam tempoh setahun mesti > 0',0),(76313,2120,'ar','# Ù„ÙØªØ±Ø§Øª ÙÙŠ Ø§Ù„Ø³Ù†Ø© ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† > 0',0),(76314,2120,'fr','nombre de pÃ©riodes par an doit Ãªtre > 0',0),(76315,2120,'jp','å¹´æ¯Žã?®æœŸé–“',0),(76316,2120,'pt','n Âº de perÃ­odos por ano deve ser > 0',0),(76317,2120,'ru','# Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¾Ð² Ð² Ð³Ð¾Ð´ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð·Ð´ÐµÐ» Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐº 0',0),(76318,2120,'es','# de perÃ­odos por aÃ±o debe ser > 0',0),(76319,2120,'de','Anzahl der Perioden pro Jahr muss > 0 sein.',0),(76320,2120,'en','# of periods per year must be > 0',0),(76321,2121,'is','',0),(76322,2121,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù‚Ø³Ù…Øª Ù‡Ø§ÙŠ Ù…Ù…ÙƒÙ† ',0),(76323,2121,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù‚Ø³Ù…Øª Ù‡Ø§ÙŠ Ù…Ù…ÙƒÙ† ',0),(76324,2121,'tr','OlasÄ± parÃ§alarÄ±n sayÄ±sÄ±nÄ±',0),(76325,2121,'pl','Liczba moÅ¼liwych czÄ™Å›ci',0),(76326,2121,'bg','Ð‘Ñ€Ð¾Ð¹ Ð²ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð¸ Ñ‡Ð°ÑÑ‚Ð¸',0),(76327,2121,'ur','Ù…Ù…Ú©Ù†Û Ø­ØµÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(76328,2121,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¼Ð¾Ð³ÑƒÑ›Ð¸Ñ… Ð´ÐµÐ»Ð¾Ð²Ð°',0),(76329,2121,'vi','Sá»‘ phá»¥ tÃ¹ng cÃ³ thá»ƒ',0),(76330,2121,'af','Aantal Moontlike Onderdele',0),(76331,2121,'ro','NumÄƒrul de piese posibile',0),(76332,2121,'et','VÃµimalik osade arvu',0),(76333,2121,'si','Å tevilo moÅ¾nih delov',0),(76334,2121,'ba','Jumlah mungkin bagian',0),(76335,2121,'nl','Aantal mogelijke onderdelen',0),(76336,2121,'fi','Mahdollista osien mÃ¤Ã¤rÃ¤',0),(76337,2121,'no','Antall mulige deler',0),(76338,2121,'da','Antallet af mulige dele',0),(76339,2121,'ko','ê°€ëŠ¥í•œ ë¶€í’ˆì˜ ìˆ˜',0),(76340,2121,'he','×ž×¡×¤×¨ ×”×—×œ×§×™× ×”××¤×©×¨×™×™×',0),(76341,2121,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½ Î´Ï…Î½Î±Ï„ÏŒÎ½ Î¼Î­ÏÎ·',0),(76342,2121,'zh','å¯èƒ½çš„é›¶ä»¶æ•°é‡\r\n',0),(76343,2121,'sv','Antalet mÃ¶jliga delar',0),(76344,2121,'it','Numero di parti possibili',0),(76345,2121,'tl','',0),(76346,2121,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3626;&#3656;&#3623;&#3609;&#3607;&#3637;&#3656;&#3648;&#3611;&#3655;&#3609;&#3652;&#3611;&#3652;&#3604;&#3657;',0),(76347,2121,'hi','à¤¸à¤‚à¤­à¤µ à¤­à¤¾à¤—à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(76348,2121,'ms','Bilangan bahagian-bahagian yang mungkin',0),(76349,2121,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø£Ø¬Ø²Ø§Ø¡ Ù…Ù…ÙƒÙ†',0),(76350,2121,'fr','Nombre de piÃ¨ces Possible',0),(76351,2121,'jp','å?¯èƒ½ã?ªéƒ¨å“?æ•°',0),(76352,2121,'pt','NÃºmero de peÃ§as possÃ­veis',0),(76353,2121,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ñ‹Ñ… Ð´ÐµÑ‚Ð°Ð»ÐµÐ¹',0),(76354,2121,'es','NÃºmero de partes possibles',0),(76355,2121,'de','Anzahl der mÃ¶glichen Teile',0),(76356,2121,'en','Number of Possible Parts',0),(76357,2122,'is','',0),(76358,2122,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¯Ù†Ø¯Ø§Ù† ',0),(76359,2122,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯Ù†Ø¯Ø§Ù† ',0),(76360,2122,'tr','DiÅŸ sayÄ±sÄ±',0),(76361,2122,'pl','Liczba zÄ™bÃ³w',0),(76362,2122,'bg','Ð‘Ñ€Ð¾Ð¹ Ð½Ð° Ð·ÑŠÐ±Ð¸Ñ‚Ðµ',0),(76363,2122,'ur','Ø¯Ø§Ù†ØªÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(76364,2122,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð·ÑƒÐ±Ð°',0),(76365,2122,'vi','Sá»‘ rÄƒng',0),(76366,2122,'af','Aantal Tande',0),(76367,2122,'ro','NumÄƒrul de dinÅ£i',0),(76368,2122,'et','Hammaste arv',0),(76369,2122,'si','Å tevilo zob',0),(76370,2122,'ba','Jumlah gigi',0),(76371,2122,'nl','Aantal tanden',0),(76372,2122,'fi','Hampaiden lukumÃ¤Ã¤rÃ¤',0),(76373,2122,'no','Antall tenner',0),(76374,2122,'da','Antallet af tÃ¦nder',0),(76375,2122,'ko','ì¹˜ì•„ì˜ ìˆ˜',0),(76376,2122,'he','×ž×¡×¤×¨ ×”×©×™× ×™×™×.',0),(76377,2122,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´Î¿Î½Ï„Î¹ÏŽÎ½',0),(76378,2122,'zh','é½¿æ•°\r\n',0),(76379,2122,'sv','Antal tÃ¤nder',0),(76380,2122,'it','Numero di denti',0),(76381,2122,'tl','',0),(76382,2122,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3615;&#3633;&#3609;',0),(76383,2122,'hi','à¤¦à¤¾à¤‚à¤¤à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(76384,2122,'ms','Bilangan gigi',0),(76385,2122,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø£Ø³Ù†Ø§Ù†',0),(76386,2122,'fr','Nombre de dents',0),(76387,2122,'jp','æ­¯ã?®æ•°',0),(76388,2122,'pt','NÃºmero de dentes',0),(76389,2122,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·ÑƒÐ±ÑŒÐµÐ²',0),(76390,2122,'es','NÃºmero de Dientes',0),(76391,2122,'de','Anzahl der ZÃ¤hne',0),(76392,2122,'en','Number of Teeth',0),(76393,2123,'is','',0),(76394,2123,'dr','ØªØ¹Ø¯Ø§Ø¯ ÙˆØ±Ù‚Ù‡ Ù‡Ø§ÙŠ Ù¾Ø±Ø³ Ø¯Ø± Ù‡Ø± ÙˆØ±Ù‚ Ø§ØµÙ„ÙŠ ',0),(76395,2123,'pr','ØªØ¹Ø¯Ø§Ø¯ ÙˆØ±Ù‚Ù‡ Ù‡Ø§ÙŠ Ù¾Ø±Ø³ Ø¯Ø± Ù‡Ø± ÙˆØ±Ù‚ Ø§ØµÙ„ÙŠ ',0),(76396,2123,'tr','BasÄ±n ana yaprak baÅŸÄ±na sayfa sayÄ±sÄ±',0),(76397,2123,'pl','Liczba prasy arkuszy blachy Master',0),(76398,2123,'bg','Ð‘Ñ€Ð¾Ð¹ Ð¿Ñ€ÐµÑÐ° Ð»Ð¸ÑÑ‚Ð¾Ð²Ðµ ÐµÐ´Ð¸Ð½ Ð¼Ð°Ð¹ÑÑ‚Ð¾Ñ€ Ð»Ð¸ÑÑ‚',0),(76399,2123,'ur','Ù¾Ø±ÛŒØ³ Ø§ÙˆØ±Ø§Ù‚ ÙÛŒ Ù…Ø§Ø³Ù¹Ø± ÙˆØ±Ù‚ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(76400,2123,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð»Ð¸ÑÑ‚Ð¾Ð²Ð° Ð·Ð° Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ Ð¿Ð¾ ÐœÐ°ÑÑ‚ÐµÑ€ Ð»Ð¸ÑÑ‚Ñƒ',0),(76401,2123,'vi','Sá»‘ trang bÃ¡o má»—i trang chá»§',0),(76402,2123,'af','Aantal Press velle per Meester vel',0),(76403,2123,'ro','NumÄƒrul de foi de presÄƒ pe maestru foaie',0),(76404,2123,'et','Kapten lehel vajutage lisalehtede arv',0),(76405,2123,'si','Å tevilo listov tiska na Master list',0),(76406,2123,'ba','Jumlah lembar pers per lembar Master',0),(76407,2123,'nl','Aantal pers vellen per Master blad',0),(76408,2123,'fi','Paina arkkeja Master arkille',0),(76409,2123,'no','Antall trykk ark per Master ark',0),(76410,2123,'da','Antallet af pressen ark pr. Master ark',0),(76411,2123,'ko','ë§ˆìŠ¤í„° ì‹œíŠ¸ ë‹¹ ê¸°ìž ìž¥ ìˆ˜',0),(76412,2123,'he','×ž×¡×¤×¨ ×’×œ×™×•× ×•×ª ×”×¢×™×ª×•× ×•×ª ×œ×’×™×œ×™×•×Ÿ ×ž××¡×˜×¨',0),(76413,2123,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´ÎµÎ»Ï„Î¯Ï‰Î½ Ï„ÏÏ€Î¿Ï… Î±Î½Î¬ Ï†ÏÎ»Î»Î¿ Master',0),(76414,2123,'zh','æ•°è¶…å‡º\r\n\r\n',0),(76415,2123,'sv','Antal tryck pÃ¥ ark per Master ark',0),(76416,2123,'it','Numero di fogli di stampa per foglio Master',0),(76417,2123,'tl','',0),(76418,2123,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3604;&#3649;&#3612;&#3656;&#3609;&#3605;&#3656;&#3629;&#3649;&#3612;&#3656;&#3609;&#3627;&#3621;&#3633;&#3585;',0),(76419,2123,'hi','à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤¶à¥€à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¥à¤°à¥‡à¤¸ à¤ªà¤¤à¥à¤°à¤•à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(76420,2123,'ms','Bilangan helaian akhbar setiap lembaran Master',0),(76421,2123,'ar','Ø¹Ø¯Ø¯ Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„ØµØ­Ù Ø§Ù„ÙˆØ±Ù‚Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(76422,2123,'fr','Nombre de feuilles de presse par maÃ®tre feuille',0),(76423,2123,'jp','ãƒžã‚¹ã‚¿ãƒ¼ã‚·ãƒ¼ãƒˆã?”ã?¨ã?®ãƒ—ãƒ¬ã‚¹ã‚·ãƒ¼ãƒˆæ•°',0),(76424,2123,'pt','NÃºmero de folhas de imprensa por folha de Master',0),(76425,2123,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð»Ð¸ÑÑ‚Ð¾Ð² Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð¼Ð°ÑÑ‚ÐµÑ€',0),(76426,2123,'es','NÃºmero de Hojas de ImpresiÃ³n por Hoja Maestra',0),(76427,2123,'de','Anzahl der Presse BlÃ¤tter pro Master-Blatt',0),(76428,2123,'en','Number of Press Sheets per Master Sheet',0),(76429,2124,'is','',0),(76430,2124,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø³ØªÙ‡ Ù‡Ø§ ',0),(76431,2124,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø³ØªÙ‡ Ù‡Ø§ ',0),(76432,2124,'tr','# Paketleri',0),(76433,2124,'pl','# Pakiety',0),(76434,2124,'bg','# ÐžÐ¿Ð°ÐºÐ¾Ð²ÐºÐ¸',0),(76435,2124,'ur','# Ù¾ÛŒÚ©Ø¬Ø²',0),(76436,2124,'sr','# ÐŸÐ°ÐºÐµÑ‚Ð¸',0),(76437,2124,'vi','Sá»‘ kiá»‡n',0),(76438,2124,'af','# Pakkette',0),(76439,2124,'ro','# Pachete',0),(76440,2124,'et','# Paketid',0),(76441,2124,'si','# Paketi',0),(76442,2124,'ba','# Paket',0),(76443,2124,'nl','# Pakketten',0),(76444,2124,'fi','# Paketit',0),(76445,2124,'no','# Pakker',0),(76446,2124,'da','# Pakker',0),(76447,2124,'ko','# íŒ¨í‚¤ì§€',0),(76448,2124,'he','# ×—×‘×™×œ×•×ª',0),(76449,2124,'el','# Î Î±ÎºÎ­Ï„Î±',0),(76450,2124,'zh','ï¼ƒè½¯ä»¶åŒ…\r\n',0),(76451,2124,'sv','# Paket',0),(76452,2124,'it','# Pacchetti',0),(76453,2124,'tl','',0),(76454,2124,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3627;&#3637;&#3610;&#3627;&#3656;&#3629;',0),(76455,2124,'hi','# à¤¸à¤‚à¤•à¥à¤²',0),(76456,2124,'ms','# Pakej-pakej',0),(76457,2124,'ar','# Ø§Ù„Ø­Ø²Ù…',0),(76458,2124,'fr','# Paquets',0),(76459,2124,'jp','ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸æ•°',0),(76460,2124,'pt','# Pacotes',0),(76461,2124,'ru','# ÐŸÐ°ÐºÐµÑ‚Ñ‹',0),(76462,2124,'es','# Paquetes',0),(76463,2124,'de','# Pakete',0),(76464,2124,'en','# Packages',0),(76465,2125,'is','',0),(76466,2125,'dr','(Ø´Ù…Ø§Ø±Ù‡) Ø¨Ø§Ù„Ø§ Ø±ÙˆÙŠ Ø¨Ø±Ú¯Ù‡',0),(76467,2125,'pr','ØªØ¹Ø¯Ø§Ø¯(Ø´Ù…Ø§Ø±Ù‡) Ø¨Ø§Ù„Ø§ Ø±ÙˆÙŠ Ø¨Ø±Ú¯Ù‡',0),(76468,2125,'tr','BasÄ±n sayfasÄ± numarasÄ±',0),(76469,2125,'pl','Numer siÄ™ na blachy Press',0),(76470,2125,'bg','Ð§Ð¸ÑÐ»Ð¾ Ð½Ð°Ð³Ð¾Ñ€Ðµ Ð² Ð¿Ñ€ÐµÑÐ°Ñ‚Ð° Ð»Ð¸ÑÑ‚',0),(76471,2125,'ur','Ø¹Ø¯Ø¯ Ú©Ùˆ Ù¾Ø±ÛŒØ³ ÙˆØ±Ù‚ Ù¾Ø±',0),(76472,2125,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½Ð°Ð²Ð¸ÑˆÐµ Ð½Ð° Ð»Ð¸ÑÑ‚ ÐŸÑ€ÐµÑÑ',0),(76473,2125,'vi','Sá»‘ lÃªn trÃªn trang bÃ¡o',0),(76474,2125,'af','Nommer op op Press vel',0),(76475,2125,'ro','NumÄƒrul pÃ¢nÄƒ pe foaie de presÄƒ',0),(76476,2125,'et','Numbri Ã¼les vajutage lehel',0),(76477,2125,'si','Å tevilo navzgor na list tiska',0),(76478,2125,'ba','Jumlah Up pada lembar pers',0),(76479,2125,'nl','Nummer omhoog op druk op blad',0),(76480,2125,'fi','Luvun ylÃ¶spÃ¤in painamalla arkille',0),(76481,2125,'no','Tall oppover pÃ¥ trykk',0),(76482,2125,'da','Nummer op pÃ¥ tryk pÃ¥ ark',0),(76483,2125,'ko','ì–¸ë¡  ìž¥ì— ìµœëŒ€ ìˆ˜',0),(76484,2125,'he','×ž×¡×¤×¨ ×ž×¢×œ×” ×‘×’×™×œ×™×•×Ÿ ×”×¢×™×ª×•× ×•×ª',0),(76485,2125,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Ï€ÏÎ¿Ï‚ Ï„Î± ÎµÏ€Î¬Î½Ï‰ ÏƒÏ„Î¿ Ï†ÏÎ»Î»Î¿ Ï„ÏÏ€Î¿Ï…',0),(76486,2125,'zh','å°åˆ·è¡¨ä¸Šæ•°é‡å¢žåŠ \r\n',0),(76487,2125,'sv','Nummer upp tryck pÃ¥ bladet',0),(76488,2125,'it','Numero fino sul foglio di stampa',0),(76489,2125,'tl','',0),(76490,2125,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3610;&#3609;&#3649;&#3612;&#3656;&#3609;&#3585;&#3604;',0),(76491,2125,'hi','à¤Šà¤ªà¤° à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¥à¤°à¥‡à¤¸ à¤ªà¤¤à¥à¤°à¤• à¤ªà¤°',0),(76492,2125,'ms','Nombor sehingga kira-kira Seluar',0),(76493,2125,'ar','Ø¹Ø¯Ø¯ ÙŠØµÙ„ ÙÙŠ ØµØ­ÙŠÙØ© Ø§Ù„ØµØ­Ø§ÙØ©',0),(76494,2125,'fr','Nombre vers le haut sur la feuille de presse',0),(76495,2125,'jp','Number Up On Press Sheet',0),(76496,2125,'pt','NÃºmero acima na folha da imprensa',0),(76497,2125,'ru','Ð§Ð¸ÑÐ»Ð¾ Ð²Ð²ÐµÑ€Ñ… Ð½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð¿Ñ€ÐµÑÑ',0),(76498,2125,'es','NÃºmero Mostrado En la Hoja de ImpresiÃ³n',0),(76499,2125,'de','Anzahl Up auf Presse-Blatt',0),(76500,2125,'en','Number Up On Press Sheet',0),(76501,2126,'is','',0),(76502,2126,'dr','1  - 12  ',0),(76503,2126,'pr','Ø¹Ø¯Ø¯ÙŠ ÙÙ‚Ø·   1  - 12  ',0),(76504,2126,'tr','yalnÄ±zca sayÄ±sal 1-12',0),(76505,2126,'pl','tylko numeryczne 1-12',0),(76506,2126,'bg','Ñ†Ð¸Ñ„Ñ€Ð¾Ð²Ð°Ñ‚Ð° 1-12 ÑÐ°Ð¼Ð¾',0),(76507,2126,'ur','Ù†Ù…Ø¨Ø±ÛŒ 1-12 ØµØ±Ù',0),(76508,2126,'sr','ÑÐ°Ð¼Ð¾ Ð½ÑƒÐ¼ÐµÑ€Ð¸Ñ‡ÐºÐµ 1-12',0),(76509,2126,'vi','chá»‰ sá»‘ 1-12',0),(76510,2126,'af','numeriese 1-12 net',0),(76511,2126,'ro','numericÄƒ 1-12 numai',0),(76512,2126,'et','ainult numbreid 1-12',0),(76513,2126,'si','le Å¡tevilÄni 1-12',0),(76514,2126,'ba','angka 1-12 hanya',0),(76515,2126,'nl','alleen numerieke 1-12',0),(76516,2126,'fi','vain numeerinen 1-12',0),(76517,2126,'no','numeriske 1-12 bare',0),(76518,2126,'da','numerisk 1-12 kun',0),(76519,2126,'ko','ìˆ«ìž 1-12',0),(76520,2126,'he','×¡×¤×¨×•×ª 1-12 ×‘×œ×‘×“',0),(76521,2126,'el','Î¼ÏŒÎ½Î¿ Î±ÏÎ¹Î¸Î¼Î·Ï„Î¹ÎºÏŒÏ‚ 1-12',0),(76522,2126,'zh','æ•°å­—åªæœ‰1-12\r\n',0),(76523,2126,'sv','numerisk 1-12 endast',0),(76524,2126,'it','numerico 1-12 solo',0),(76525,2126,'tl','',0),(76526,2126,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3586; 1-12 &#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(76527,2126,'hi','à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤• à¤•à¥‡à¤µà¤² 1-12',0),(76528,2126,'ms','angka 1-12 hanya',0),(76529,2126,'ar','1-12 Ø§Ù„Ø±Ù‚Ù…ÙŠØ© ÙÙ‚Ø·',0),(76530,2126,'fr','numÃ©rique 1-12 seulement',0),(76531,2126,'jp','æ•°å­—ï¼‘ï¼?ï¼‘ï¼’ã?®ã?¿',0),(76532,2126,'pt','numÃ©rico 1-12 sÃ³',0),(76533,2126,'ru','Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ‡Ð¸ÑÐ»Ð¾Ð²Ñ‹Ðµ 1-12',0),(76534,2126,'es','numÃ©rico 1-12 solamente',0),(76535,2126,'de','nur numerische 1-12',0),(76536,2126,'en','numeric 1-12 only',0),(76537,2127,'is','',0),(76538,2127,'dr','Ù…Ø§Ù‡ Ø¨Ø§ÙŠØ¯ Ø¹Ø¯Ø¯ÙŠ Ø¨Ø§Ø´Ø¯ â€“ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(76539,2127,'pr','Ù…Ø§Ù‡ Ø¨Ø§ÙŠØ¯ Ø¹Ø¯Ø¯ÙŠ Ø¨Ø§Ø´Ø¯ â€“ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(76540,2127,'tr','Ay-meli var olmak sayÄ±sal - yeniden deneyin',0),(76541,2127,'pl','MiesiÄ…ca musi byÄ‡ numeryczny - sprÃ³buj ponownie',0),(76542,2127,'bg','ÐœÐµÑÐµÑ† Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ñ‡Ð¸ÑÐ»Ð¾Ð²Ð° - Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(76543,2127,'ur','Ù…ÛÛŒÙ†Û ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ Ù†Ù…Ø¨Ø±ÛŒ - Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº',0),(76544,2127,'sr','ÐœÐµÑÐµÑ† Ð´Ð°Ð½Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð½ÑƒÐ¼ÐµÑ€Ð¸Ñ‡ÐºÐ° - Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(76545,2127,'vi','ThÃ¡ng pháº£i lÃ  sá»‘ - thá»­ láº¡i',0),(76546,2127,'af','Maand moet numeries wees - probeer weer',0),(76547,2127,'ro','Luna trebuie sÄƒ fie numerice - Ã®ncercaÅ£i din nou',0),(76548,2127,'et','Kuu formaat peab olema numbrites - proovi uuesti',0),(76549,2127,'si','Mesec mora biti Å¡tevilska - poskusite znova',0),(76550,2127,'ba','Bulan harus berupa angka - coba lagi',0),(76551,2127,'nl','Maand moet numeriek - probeer het opnieuw',0),(76552,2127,'fi','Kuukauden arvon on oltava numeerinen - yritÃ¤ uudelleen',0),(76553,2127,'no','MÃ¥ned mÃ¥ vÃ¦re numerisk - prÃ¸v igjen',0),(76554,2127,'da','MÃ¥ned skal vÃ¦re numerisk - prÃ¸v igen',0),(76555,2127,'ko','ë‹¬ ì—¬ì•¼ í•©ë‹ˆë‹¤-ë‹¤ì‹œ ì‹œë„',0),(76556,2127,'he','×¢×œ ×”×—×•×“×© ×œ×”×™×•×ª ×¡×¤×¨×” - × ×¡×” ×©×•×‘',0),(76557,2127,'el','ÎœÎ®Î½Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î±ÏÎ¹Î¸Î¼Î·Ï„Î¹ÎºÏŒ - Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(76558,2127,'zh','æœˆä»½å¿…é¡»æ˜¯æ•°å­—-å†è¯•ä¸€æ¬¡\r\n',0),(76559,2127,'sv','MÃ¥nad mÃ¥ste vara numeriska - fÃ¶rsÃ¶k igen',0),(76560,2127,'it','Mese deve essere numerico - riprovare',0),(76561,2127,'tl','',0),(76562,2127,'th','&#3648;&#3604;&#3639;&#3629;&#3609;&#3605;&#3657;&#3629;&#3591;&#3648;&#3611;&#3655;&#3609;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586; &#3621;&#3629;&#3591;&#3651;&#3627;&#3617;&#3656;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(76563,2127,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¸à¤‚à¤–à¥à¤¯à¤¾à¤¤à¥à¤®à¤• - à¤¹à¥‹ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾ à¤«à¤¿à¤° à¤¸à¥‡ à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚',0),(76564,2127,'ms','Bulan mesti angka - cuba lagi',0),(76565,2127,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø§Ù„Ø´Ù‡Ø± Ø§Ù„Ø±Ù‚Ù…ÙŠØ©--Ø­Ø§ÙˆÙ„ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(76566,2127,'fr','Mois doit Ãªtre numÃ©rique - essayez Ã  nouveau',0),(76567,2127,'jp','æœˆã?¯æ•°å­—ã?§ã?ªã??ã?¦ã?¯ã?ªã‚Šã?¾ã?›ã‚“ãƒ¼ã‚‚ã?†ä¸€åº¦ã?Šé¡˜ã?„ã?—ã?¾ã?™',0),(76568,2127,'pt','MÃªs devem ser numÃ©rico - tente novamente',0),(76569,2127,'ru','ÐœÐµÑÑÑ† Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ñ‡Ð¸ÑÐ»Ð¾Ð²Ñ‹Ð¼ - Ð¿Ð¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÐµÑ‰Ðµ Ñ€Ð°Ð·',0),(76570,2127,'es','Mes debe ser numÃ©rico - intenta otra vez',0),(76571,2127,'de','Monat muss numerisch - sein versuchen Sie es erneut',0),(76572,2127,'en','Month must be numeric - try again',0),(76573,2128,'is','',0),(76574,2128,'dr','Ù…ÙˆØ¶ÙˆØ¹ Ø¨Ø§ÙŠØ¯ Ø§Ø² Ù†ÙˆØ¹ \" ÙÙˆÙ†Øª ØªØ¹Ø¨ÙŠÙ‡ Ø´Ø¯Ù‡ \" Ø¨Ø§Ø´Ø¯ ',0),(76575,2128,'pr','Ù…ÙˆØ¶ÙˆØ¹ Ø¨Ø§ÙŠØ¯ Ø§Ø² Ù†ÙˆØ¹ \" ÙÙˆÙ†Øª ØªØ¹Ø¨ÙŠÙ‡ Ø´Ø¯Ù‡ \" Ø¨Ø§Ø´Ø¯ ',0),(76576,2128,'tr','Nesne tÃ¼rÃ¼ \'fontembed\' olmalÄ±dÄ±r',0),(76577,2128,'pl','Obiekt musi byÄ‡ typu \"fontembed\"',0),(76578,2128,'bg','ÐžÐ±ÐµÐºÑ‚ÑŠÑ‚ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¾Ñ‚ Ñ‚Ð¸Ð¿ \"fontembed\"',0),(76579,2128,'ur','Ø¢Ø¨Ø¬ÛŒÚ©Ù¹ Ú©ÛŒ Ù‚Ø³Ù… \'ÙÙˆÙ†Ù¹ÛŒÙ…Ø¨\' ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(76580,2128,'sr','ÐžÐ±Ñ˜ÐµÐºÐ°Ñ‚ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ñ‚Ð¸Ð¿Ð° \'Ñ„Ð¾Ð½Ñ‚ÐµÐ¼Ð±ÐµÐ´\'',0),(76581,2128,'vi','Váº­t thá»ƒ pháº£i lÃ  loáº¡i \'fontembed\'',0),(76582,2128,'af','Voorwerp moet wees van die tipe \'fontembed\'',0),(76583,2128,'ro','Obiect trebuie sÄƒ fie de tip \"fontembed\"',0),(76584,2128,'et','Objekt peab olema tÃ¼Ã¼p \"fontembed\"',0),(76585,2128,'si','Predmet mora biti tipa \"fontembed\"',0),(76586,2128,'ba','Objek harus tipe \'fontembed\'',0),(76587,2128,'nl','Object moet van het type \'fontembed\'',0),(76588,2128,'fi','Objektin on oltava tyyppiÃ¤ \'fontembed\'',0),(76589,2128,'no','Objektet mÃ¥ vÃ¦re av typen \"fontembed\"',0),(76590,2128,'da','Objektet skal vÃ¦re af typen \'fontembed\'',0),(76591,2128,'ko','ê°œì²´ ìœ í˜• \'fontembed\' ì´ì–´ì•¼',0),(76592,2128,'he','×¢×œ ×”××•×‘×™×™×§×˜ ×œ×”×™×•×ª ×ž×¡×•×’ \'fontembed\'',0),(76593,2128,'el','Î‘Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î¿ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Ï„ÏÏ€Î¿Ï… \'fontembed\'',0),(76594,2128,'zh','å¯¹è±¡å¿…é¡»æ˜¯ç±»åž‹\'å­—ä½“åµŒå…¥\'\r\n',0),(76595,2128,'sv','Objektet mÃ¥ste vara av typen \"fontembed\"',0),(76596,2128,'it','Oggetto deve essere di tipo \'fontembed\'',0),(76597,2128,'tl','',0),(76598,2128,'th','&#3623;&#3633;&#3605;&#3606;&#3640;&#3605;&#3657;&#3629;&#3591;&#3648;&#3611;&#3655;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607; fontembed',0),(76599,2128,'hi','à¤‘à¤¬à¥à¤œà¥‡à¤•à¥à¤Ÿ à¤•à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° \'fontembed\' à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(76600,2128,'ms','Objek mesti jenis \'fontembed\'',0),(76601,2128,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† ÙƒØ§Ø¦Ù† Ù…Ù† Ù†ÙˆØ¹ \'ÙÙˆÙ†ØªÙŠÙ…Ø¨ÙŠØ¯\'',0),(76602,2128,'fr','Objet doit Ãªtre de type Â« fontembed Â»',0),(76603,2128,'jp','å¯¾è±¡ã?¯ \'fontembed\'ã‚¿ã‚¤ãƒ—ã?§ã?ªã?‘ã‚Œã?°ã?„ã?‘ã?¾ã?›ã‚“',0),(76604,2128,'pt','Objeto deve ser do tipo \'fontembed\'',0),(76605,2128,'ru','ÐžÐ±ÑŠÐµÐºÑ‚ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð¼ÐµÑ‚ÑŒ Ñ‚Ð¸Ð¿ Â«fontembedÂ»',0),(76606,2128,'es','Objeto debe ser de tipo \'fuenteinsertar\'',0),(76607,2128,'de','Objekt muss vom Typ \'Fontembed\' sein.',0),(76608,2128,'en','Object must be of type \'fontembed\'',0),(76609,2129,'is','',0),(76610,2129,'dr','Ø§ÙƒØªØ¨Ø±',0),(76611,2129,'pr','Ø§ÙƒØªØ¨Ø±',0),(76612,2129,'tr','Ekim',0),(76613,2129,'pl','PaÅºdziernika',0),(76614,2129,'bg','ÐžÐºÑ‚Ð¾Ð¼Ð²Ñ€Ð¸',0),(76615,2129,'ur','Ø§Ú©ØªÙˆØ¨Ø±',0),(76616,2129,'sr','ÐžÐºÑ‚Ð¾Ð±Ñ€Ð°',0),(76617,2129,'vi','ThÃ¡ng mÆ°á»i',0),(76618,2129,'af','Oktober',0),(76619,2129,'ro','Octombrie',0),(76620,2129,'et','Oktoober',0),(76621,2129,'si','Oktobra',0),(76622,2129,'ba','Oktober',0),(76623,2129,'nl','Oktober',0),(76624,2129,'fi','Lokakuuta',0),(76625,2129,'no','Oktober',0),(76626,2129,'da','Oktober',0),(76627,2129,'ko','10 ì›”',0),(76628,2129,'he','××•×§×˜×•×‘×¨',0),(76629,2129,'el','ÎŸÎºÏ„Ï‰Î²ÏÎ¯Î¿Ï…',0),(76630,2129,'zh','åæœˆ\r\n',0),(76631,2129,'sv','Oktober',0),(76632,2129,'it','Ottobre',0),(76633,2129,'tl','',0),(76634,2129,'th','&#3605;&#3640;&#3621;&#3634;&#3588;&#3617;',0),(76635,2129,'hi','à¤…à¤•à¥à¤Ÿà¥‚à¤¬à¤°',0),(76636,2129,'ms','Oktober',0),(76637,2129,'ar','Ø£ÙƒØªÙˆØ¨Ø±',0),(76638,2129,'fr','Octobre',0),(76639,2129,'jp','ï¼‘ï¼?æœˆ',0),(76640,2129,'pt','Outubro',0),(76641,2129,'ru','ÐžÐºÑ‚ÑÐ±Ñ€ÑŒ',0),(76642,2129,'es','Octubre',0),(76643,2129,'de','Oktober',0),(76644,2129,'en','October',0),(76645,2130,'is','',0),(76646,2130,'dr','(ÙØ±ÙˆØ´)',0),(76647,2130,'pr','Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø­Ø±Ø§Ø¬(ÙØ±ÙˆØ´)',0),(76648,2130,'tr','SatÄ±ÅŸ Ã¼rÃ¼n (ler)',0),(76649,2130,'pl','SprzedaÅ¼ elementÃ³w',0),(76650,2130,'bg','Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(76651,2130,'ur','Ø³ÛŒÙ„Ø² Ø§Ø´ÛŒØ§ Ú©ÛŒ',0),(76652,2130,'sr','Ð¾Ð´ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(76653,2130,'vi','cá»§a hÃ ng bÃ¡n ',0),(76654,2130,'af','van Verkoopitem(s)',0),(76655,2130,'ro','de vÃ¢nzÄƒri elemente',0),(76656,2130,'et','ning mÃ¼Ã¼gi Ã¼ksused',0),(76657,2130,'si','od prodaje elemente',0),(76658,2130,'ba','Penjualan obyek',0),(76659,2130,'nl','van verkoop objecten',0),(76660,2130,'fi','ja myynti kohteet',0),(76661,2130,'no','av salg element(er)',0),(76662,2130,'da','af salg element(er)',0),(76663,2130,'ko','íŒë§¤ í•­ëª©ì˜',0),(76664,2130,'he','×¤×¨×™×˜×™× ×ž×›×™×¨×•×ª',0),(76665,2130,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Ï„Î·Ï‚',0),(76666,2130,'zh','é”€å”®é¡¹ç›®ï¼ˆï¼‰\r\n',0),(76667,2130,'sv','av fÃ¶rsÃ¤ljning objekt',0),(76668,2130,'it','della merce in vendita',0),(76669,2130,'tl','',0),(76670,2130,'th','&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(76671,2130,'hi','à¤®à¤¦ (s) à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(76672,2130,'ms','item jualan',0),(76673,2130,'ar','Ù„Ù„Ø¨ÙŠØ¹ Ø§Ù„Ø¹Ù†ØµØ± (Ø§Ù„Ø¹Ù†Ø§ØµØ±)',0),(76674,2130,'fr','de vente article (s)',0),(76675,2130,'jp','è²©å£²å“?ç›®ã?®',0),(76676,2130,'pt','de vendas Item (ns)',0),(76677,2130,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶ Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(76678,2130,'es','de Item(s) de Ventas',0),(76679,2130,'de','der Vertrieb Item(s)',0),(76680,2130,'en','of Sales Item(s)',0),(76681,2131,'is','',0),(76682,2131,'dr','Ø§Ø² Ø¯Ø³ØªÙ…Ø²Ø¯Ù‡Ø§ Ø¯Ø± Ø¯Ø±Ø§Ù…Ø¯ Ø³Ø§Ù„Ø§Ù†Ù‡ Ø¨ÙŠØ´ØªØ± ',0),(76683,2131,'pr','Ø§Ø² Ø¯Ø³ØªÙ…Ø²Ø¯Ù‡Ø§ Ø¯Ø± Ø¯Ø±Ø§Ù…Ø¯ Ø³Ø§Ù„Ø§Ù†Ù‡ Ø¨ÙŠØ´ØªØ± ',0),(76684,2131,'tr','YÄ±llÄ±k kazanÃ§ Ã¼cret',0),(76685,2131,'pl','Wynagrodzenia na roczne zarobki',0),(76686,2131,'bg','ÐÐ° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ Ð½Ð° Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸ Ð½Ð°Ð´',0),(76687,2131,'ur','Ú©ÛŒ Ù…Ø²Ø¯ÙˆØ±ÛŒ Ù¾Ø± Ø³Ø§Ù„Ø§Ù†Û Ø¢Ù…Ø¯Ù†ÛŒ Ù¾Ø±',0),(76688,2131,'sr','Ð”Ð¾Ñ…Ð¾Ð´Ð°ÐºÐ° Ð½Ð° Ð³Ð¾Ð´Ð¸ÑˆÑšÐ° Ð·Ð°Ñ€Ð°Ð´Ð° Ð¿Ñ€ÐµÐºÐ¾',0),(76689,2131,'vi','cá»§a lÆ°Æ¡ng vá»›i tá»•ng cá»™ng hÃ ng nÄƒm hÆ¡n',0),(76690,2131,'af','Van Besoldiging op jaarlikse verdienste Meer As',0),(76691,2131,'ro','A salariilor pe venitul anual peste',0),(76692,2131,'et','Palga kohta aastase tÃ¶Ã¶tasu Ã¼le',0),(76693,2131,'si','PlaÄ na letni zasluÅ¾ek nad',0),(76694,2131,'ba','Upah pada pendapatan tahunan lebih dari',0),(76695,2131,'nl','Van de lonen op de jaarlijkse winst over',0),(76696,2131,'fi','Palkkojen vuosiansioista',0),(76697,2131,'no','Av lÃ¸nn pÃ¥ Ã¥rlige inntekter over',0),(76698,2131,'da','Af lÃ¸nninger pÃ¥ Ã¥rlige indtjening over',0),(76699,2131,'ko','ìž„ê¸ˆ ì´ìƒì˜ ì—°ê°„ ìˆ˜ìž…ì—ì˜',0),(76700,2131,'he','×©×›×¨ ×¢×œ ×”×¨×•×•×—×™× ×”×©× ×ª×™×ª.',0),(76701,2131,'el','Î¤Ï‰Î½ Î¼Î¹ÏƒÎ¸ÏŽÎ½ ÏƒÏ„Î¹Ï‚ ÎµÏ„Î®ÏƒÎ¹ÎµÏ‚ Î±Ï€Î¿Î´Î¿Ï‡Î­Ï‚ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ',0),(76702,2131,'zh','å¯¹å¹´è¶…è¿‡å·¥èµ„æ”¶å…¥\r\n',0),(76703,2131,'sv','LÃ¶ner pÃ¥ Ã¥rslÃ¶n Ã¶ver',0),(76704,2131,'it','Dei salari su guadagni annuali sopra',0),(76705,2131,'tl','',0),(76706,2131,'th','&#3586;&#3629;&#3591;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3651;&#3609;&#3611;&#3637;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3635;&#3652;&#3619;',0),(76707,2131,'hi','à¤•à¥€ à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤µà¤¾à¤°à¥à¤·à¤¿à¤• à¤†à¤¯ à¤ªà¤°',0),(76708,2131,'ms','Upah atas pendapatan tahunan ke atas',0),(76709,2131,'ar','Ù„Ù„Ø£Ø¬ÙˆØ± ÙÙŠ Ø§Ù„Ø¯Ø®Ù„ Ø§Ù„Ø³Ù†ÙˆÙŠ Ø¹Ù„Ù‰ Ù…Ø¯Ù‰',0),(76710,2131,'fr','Des salaires sur les revenus annuels au-dessus',0),(76711,2131,'jp','ï½žä»¥ä¸Šã?®å¹´å?Žã?«ã‚ˆã‚‹è³ƒé‡‘ã?®',0),(76712,2131,'pt','De salÃ¡rio em salÃ¡rio anual sobre',0),(76713,2131,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð½Ð° ÐµÐ¶ÐµÐ³Ð¾Ð´Ð½Ñ‹Ðµ Ð´Ð¾Ñ…Ð¾Ð´Ñ‹ ÑÐ²Ñ‹ÑˆÐµ',0),(76714,2131,'es','De sueldos sobre utilidades anuales mÃ¡s alla que',0),(76715,2131,'de','Der LÃ¶hne auf Jahresverdienst Ã¼ber',0),(76716,2131,'en','Of wages on annual earnings over',0),(76717,2132,'is','',0),(76718,2132,'dr','(ØªØ¹Ø§Ø¯Ù„',0),(76719,2132,'pr','Ø¨Ø±Ú¯Ù‡ Ù¾Ø§ÙŠØ§Ù¾Ø§ÙŠ(ØªØ¹Ø§Ø¯Ù„',0),(76720,2132,'tr','Mahsup hesabÄ± - sac',0),(76721,2132,'pl','PrzesuniÄ™cie - arkusz',0),(76722,2132,'bg','Ð˜Ð·Ð¼ÐµÑÑ‚Ð²Ð°Ð½Ðµ â€“ Ð»Ð¸ÑÑ‚',0),(76723,2132,'ur','Ø¢ÙØ³Ù¹ - ÙˆØ±Ù‚',0),(76724,2132,'sr','ÐŸÐ¾Ð¼Ð°Ðº - Ð»Ð¸ÑÑ‚',0),(76725,2132,'vi','PhÃ¢n trang',0),(76726,2132,'af','Offset - vel',0),(76727,2132,'ro','Offset - foaie',0),(76728,2132,'et','OFFSET - leht',0),(76729,2132,'si','Odmik â€“ list',0),(76730,2132,'ba','Offset - lembar',0),(76731,2132,'nl','Verschuiving - blad',0),(76732,2132,'fi','Offset - taulukko',0),(76733,2132,'no','Forskyvning - ark',0),(76734,2132,'da','Offset - ark',0),(76735,2132,'ko','ì˜¤í”„ì…‹-ì‹œíŠ¸',0),(76736,2132,'he','×”×™×¡×˜ - ×’×™×œ×™×•×Ÿ',0),(76737,2132,'el','ÎŒÏ†ÏƒÎµÏ„ - Ï†ÏÎ»Î»Î¿',0),(76738,2132,'zh','åç§»- è¡¨\r\n',0),(76739,2132,'sv','Offset - blad',0),(76740,2132,'it','Offset - foglio',0),(76741,2132,'tl','',0),(76742,2132,'th','&#3594;&#3604;&#3648;&#3594;&#3618; - &#3649;&#3612;&#3656;&#3609;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(76743,2132,'hi','à¤‘à¤«à¤¼à¤¸à¥‡à¤Ÿ - à¤¶à¥€à¤Ÿ',0),(76744,2132,'ms','Ofset - lembaran',0),(76745,2132,'ar','Ø§Ù„Ø¥Ø²Ø§Ø­Ø©-ÙˆØ±Ù‚Ø©',0),(76746,2132,'fr','Offset - feuille',0),(76747,2132,'jp','ã‚ªãƒ•ã‚»ãƒƒãƒˆãƒ¼ã‚·ãƒ¼ãƒˆ',0),(76748,2132,'pt','Deslocamento - folha',0),(76749,2132,'ru','Ð¡Ð¼ÐµÑ‰ÐµÐ½Ð¸Ðµ - Ð»Ð¸ÑÑ‚',0),(76750,2132,'es','Offset - Hoja',0),(76751,2132,'de','Offset - Blatt',0),(76752,2132,'en','Offset - Sheet',0),(76753,2133,'is','',0),(76754,2133,'dr','(ØªØ¹Ø§Ø¯Ù„',0),(76755,2133,'pr','Ø´Ø¨ÙƒÙ‡ Ù¾Ø§ÙŠØ§Ù¾Ø§ÙŠ(ØªØ¹Ø§Ø¯Ù„',0),(76756,2133,'tr','Mahsup hesabÄ± - Web',0),(76757,2133,'pl','PrzesuniÄ™cie - www',0),(76758,2133,'bg','Ð˜Ð·Ð¼ÐµÑÑ‚Ð²Ð°Ð½Ðµ â€“ ÑƒÐµÐ±',0),(76759,2133,'ur','Ø¢ÙØ³Ù¹ - ÙˆÛŒØ¨',0),(76760,2133,'sr','ÐŸÐ¾Ð¼Ð°Ðº - WÐµÐ±',0),(76761,2133,'vi','PhÃ¢n web',0),(76762,2133,'af','Offset - Web',0),(76763,2133,'ro','Offset - Web',0),(76764,2133,'et','OFFSET - Web',0),(76765,2133,'si','Odmik â€“ spletni',0),(76766,2133,'ba','Offset - Web',0),(76767,2133,'nl','Verschuiving - Web',0),(76768,2133,'fi','SiirtymÃ¤ - Web',0),(76769,2133,'no','Forskyvning - Web',0),(76770,2133,'da','Offset - Web',0),(76771,2133,'ko','ì˜¤í”„ì…‹-ì›¹',0),(76772,2133,'he','×”×™×¡×˜ - ××™× ×˜×¨× ×˜',0),(76773,2133,'el','ÎŒÏ†ÏƒÎµÏ„ - Web',0),(76774,2133,'zh','åç§»- ç½‘é¡µ\r\n',0),(76775,2133,'sv','Offset - Web',0),(76776,2133,'it','Offset - Web',0),(76777,2133,'tl','',0),(76778,2133,'th','&#3594;&#3604;&#3648;&#3594;&#3618; - &#3648;&#3623;&#3655;&#3610;',0),(76779,2133,'hi','à¤‘à¤«à¤¼à¤¸à¥‡à¤Ÿ - à¤µà¥‡à¤¬',0),(76780,2133,'ms','Ofset - Web',0),(76781,2133,'ar','Ø§Ù„Ø¥Ø²Ø§Ø­Ø©-ÙˆÙŠØ¨',0),(76782,2133,'fr','Deport - Web',0),(76783,2133,'jp','ã‚ªãƒ•ã‚»ãƒƒãƒˆãƒ¼ã‚¦ã‚§ãƒ–',0),(76784,2133,'pt','Deslocamento - Web',0),(76785,2133,'ru','Ð¡Ð¼ÐµÑ‰ÐµÐ½Ð¸Ðµ - Web',0),(76786,2133,'es','Offset - Web',0),(76787,2133,'de','Offset - Web',0),(76788,2133,'en','Offset - Web',0),(76789,2134,'is','',0),(76790,2134,'dr','Ù‚Ø¨ÙˆÙ„ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒØ±Ø¯Ù†',0),(76791,2134,'pr','Ù‚Ø¨ÙˆÙ„ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒØ±Ø¯Ù†',0),(76792,2134,'tr','Tamam kullanmak iÃ§in',0),(76793,2134,'pl','Ok do wykorzystania',0),(76794,2134,'bg','Ð”Ð¾Ð±Ñ€Ðµ Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°',0),(76795,2134,'ur','Ù¹Ú¾ÙŠÚ© ÛÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Ø§',0),(76796,2134,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ð´Ð° ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(76797,2134,'vi','OK Ä‘á»ƒ dÃ¹ng',0),(76798,2134,'af','OK te gebruik',0),(76799,2134,'ro','OK de utilizare',0),(76800,2134,'et','OK kasutamine',0),(76801,2134,'si','Ok za uporabo',0),(76802,2134,'ba','OK untuk menggunakan',0),(76803,2134,'nl','O.k. aan gebruik',0),(76804,2134,'fi','Haluatko kÃ¤yttÃ¤Ã¤',0),(76805,2134,'no','OK Ã¥ bruk',0),(76806,2134,'da','OK til brug',0),(76807,2134,'ko','ì‚¬ìš© í™•ì¸',0),(76808,2134,'he','×˜×•×‘ ×œ×©×™×ž×•×©',0),(76809,2134,'el','Î•Î½Ï„Î¬Î¾ÎµÎ¹ Î½Î± Ï‡ÏÎ®ÏƒÎ·',0),(76810,2134,'zh','ç¡®å®šä½¿ç”¨\r\n',0),(76811,2134,'sv','OK att anvÃ¤nda',0),(76812,2134,'it','OK a uso',0),(76813,2134,'tl','',0),(76814,2134,'th','&#3605;&#3585;&#3621;&#3591;&#3651;&#3627;&#3657;&#3651;&#3594;&#3657;',0),(76815,2134,'hi','à¤ à¥€à¤• à¤¹à¥ˆ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(76816,2134,'ms','OK untuk kegunaan',0),(76817,2134,'ar','Ù…ÙˆØ§ÙÙ‚ Ù„Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(76818,2134,'fr','OK pour utilisation',0),(76819,2134,'jp','ä½¿ç”¨ã?§ã??ã?¾ã?™',0),(76820,2134,'pt','OK para uso',0),(76821,2134,'ru','ÐžÐš Ð´Ð»Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(76822,2134,'es','OK para Usar',0),(76823,2134,'de','Ordnung, Verwendung',0),(76824,2134,'en','Ok to Use',0),(76825,2135,'is','',0),(76826,2135,'dr','Ù†Ø³Ø®Ù‡ Ù‚Ø¨Ù„ÙŠ',0),(76827,2135,'pr','Ù†Ø³Ø®Ù‡ Ù‚Ø¨Ù„ÙŠ',0),(76828,2135,'tr','Eski sÃ¼rÃ¼m',0),(76829,2135,'pl','Stara wersja',0),(76830,2135,'bg','Ð¡Ñ‚Ð°Ñ€Ð° Ð²ÐµÑ€ÑÐ¸Ñ',0),(76831,2135,'ur','Ù¾Ø±Ø§Ù†Û’ ÙˆØ±Ú˜Ù†',0),(76832,2135,'sr','Ð¡Ñ‚Ð°Ñ€Ðµ Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ',0),(76833,2135,'vi','PhiÃªn báº£n cÅ©',0),(76834,2135,'af','Ou Weergawe',0),(76835,2135,'ro','Versiunea veche',0),(76836,2135,'et','Vana versioon',0),(76837,2135,'si','Staro razliÄico',0),(76838,2135,'ba','Versi lama',0),(76839,2135,'nl','Oude versie',0),(76840,2135,'fi','Vanha versio',0),(76841,2135,'no','Gammel versjon',0),(76842,2135,'da','Gammel Version',0),(76843,2135,'ko','ì´ì „ ë²„ì „',0),(76844,2135,'he','×’×¨×¡×” ×™×©× ×”',0),(76845,2135,'el','Î Î±Î»Î¹Î¬ Î­ÎºÎ´Î¿ÏƒÎ·',0),(76846,2135,'zh','æ—§ç‰ˆæœ¬\r\n',0),(76847,2135,'sv','Gammal Version',0),(76848,2135,'it','Vecchia versione',0),(76849,2135,'tl','',0),(76850,2135,'th','&#3648;&#3623;&#3629;&#3619;&#3660;&#3594;&#3633;&#3656;&#3609;&#3648;&#3585;&#3656;&#3634;',0),(76851,2135,'hi','à¤ªà¥à¤°à¤¾à¤¨à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(76852,2135,'ms','Versi lama',0),(76853,2135,'ar','Ø§Ù„Ø¥ØµØ¯Ø§Ø± Ø§Ù„Ù‚Ø¯ÙŠÙ…',0),(76854,2135,'fr','Ancienne Version',0),(76855,2135,'jp','å?¤ã?„ãƒ?ãƒ¼ã‚¸ãƒ§ãƒ³',0),(76856,2135,'pt','VersÃ£o antiga',0),(76857,2135,'ru','Ð¡Ñ‚Ð°Ñ€Ð°Ñ Ð²ÐµÑ€ÑÐ¸Ñ',0),(76858,2135,'es','VersiÃ³n Antigua',0),(76859,2135,'de','Alte Version',0),(76860,2135,'en','Old Version',0),(76861,2136,'is','',0),(76862,2136,'dr','Ø±ÙˆÙŠ',0),(76863,2136,'pr','Ø±ÙˆÙŠ',0),(76864,2136,'tr','Tarih',0),(76865,2136,'pl','na',0),(76866,2136,'bg','Ð½Ð°',0),(76867,2136,'ur','Ù¾Ø±',0),(76868,2136,'sr','Ð½Ð°',0),(76869,2136,'vi','vÃ o',0),(76870,2136,'af','Aanskakel',0),(76871,2136,'ro','pe',0),(76872,2136,'et','linna',0),(76873,2136,'si','na',0),(76874,2136,'ba','pada',0),(76875,2136,'nl','op',0),(76876,2136,'fi','jÃ¤senen',0),(76877,2136,'no','pÃ¥',0),(76878,2136,'da','pÃ¥',0),(76879,2136,'ko','ì—',0),(76880,2136,'he','×¢×œ',0),(76881,2136,'el','Î³Î¹Î±',0),(76882,2136,'zh','å…³äºŽ\r\n',0),(76883,2136,'sv','pÃ¥',0),(76884,2136,'it','su',0),(76885,2136,'tl','',0),(76886,2136,'th','&#3648;&#3611;&#3636;&#3604;',0),(76887,2136,'hi','à¤ªà¤°',0),(76888,2136,'ms','pada',0),(76889,2136,'ar','Ø¹Ù„Ù‰',0),(76890,2136,'fr','sur',0),(76891,2136,'jp','ï½žã?«é–¢ã?—ã?¦ã?®',0),(76892,2136,'pt','na',0),(76893,2136,'ru','Ð½Ð°',0),(76894,2136,'es','en',0),(76895,2136,'de','auf',0),(76896,2136,'en','on',0),(76897,2137,'is','',0),(76898,2137,'dr','Ù…ÙˆØ¬ÙˆØ¯',0),(76899,2137,'pr','Ù…ÙˆØ¬ÙˆØ¯',0),(76900,2137,'tr','Yandan',0),(76901,2137,'pl','Na rÄ™kÄ™',0),(76902,2137,'bg','ÐÐ° Ñ€ÑŠÐºÐ°',0),(76903,2137,'ur','ÛØ§ØªÚ¾ Ù¾Ø±',0),(76904,2137,'sr','ÐÐ° Ñ€ÑƒÑ†Ð¸',0),(76905,2137,'vi','CÃ³ sáºµn',0),(76906,2137,'af','Op Hande',0),(76907,2137,'ro','Pe mana',0),(76908,2137,'et','KÃ¤si',0),(76909,2137,'si','Na roko',0),(76910,2137,'ba','Di tangan',0),(76911,2137,'nl','Aan de kant',0),(76912,2137,'fi','KÃ¤sillÃ¤',0),(76913,2137,'no','PÃ¥ side',0),(76914,2137,'da','PÃ¥ hÃ¥nd',0),(76915,2137,'ko','ë°˜ë©´ì—',0),(76916,2137,'he','×¢×œ ×”×™×“',0),(76917,2137,'el','Î‘Ï†',0),(76918,2137,'zh','çŽ°æœ‰\r\n',0),(76919,2137,'sv','Ã…',0),(76920,2137,'it','Sulla mano',0),(76921,2137,'tl','',0),(76922,2137,'th','&#3607;&#3637;&#3656;&#3606;&#3639;&#3629;&#3629;&#3618;&#3641;&#3656;',0),(76923,2137,'hi','à¤¹à¤¾à¤¥ à¤ªà¤°',0),(76924,2137,'ms','Pada tangan',0),(76925,2137,'ar','ÙˆÙ…Ù† Ù†Ø§Ø­ÙŠØ©',0),(76926,2137,'fr','Sur la main',0),(76927,2137,'jp','æ‰‹æŒ?ã?¡ã?®<br><small>(å?Œã?˜ä¾¡å€¤ã‚’ä¿?ã?¤ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„)</small>',0),(76928,2137,'pt','Na mÃ£o',0),(76929,2137,'ru','ÐÐ° Ñ€ÑƒÐºÐµ',0),(76930,2137,'es','Disponible',0),(76931,2137,'de','Auf der Seite',0),(76932,2137,'en','On Hand',0),(76933,2138,'is','',0),(76934,2138,'dr','Ø·Ø¨Ù‚ Ù…Ù‚Ø§Ø¯ÙŠØ± Ø§Ø¶Ø§ÙÙŠ',0),(76935,2138,'pr','Ø·Ø¨Ù‚ Ù…Ù‚Ø§Ø¯ÙŠØ± Ø§Ø¶Ø§ÙÙŠ',0),(76936,2138,'tr','Miktarlar',0),(76937,2138,'pl','W iloÅ›ci ponad',0),(76938,2138,'bg','Ð—Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð½Ð°Ð´',0),(76939,2138,'ur','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø± Ù¾Ø±',0),(76940,2138,'sr','Ð—Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ Ð¿Ñ€ÐµÐºÐ¾',0),(76941,2138,'vi','Chá»‰ sá»‘ lÆ°á»£ng hÆ¡n',0),(76942,2138,'af','Op Hoeveelhede Meer As',0),(76943,2138,'ro','CantitÄƒÅ£ile peste',0),(76944,2138,'et','Koguste Ã¼le',0),(76945,2138,'si','O koliÄinah nad',0),(76946,2138,'ba','Pada jumlah lebih dari',0),(76947,2138,'nl','Op hoeveelheden Over',0),(76948,2138,'fi','MÃ¤Ã¤riÃ¤',0),(76949,2138,'no','PÃ¥ mengder Over',0),(76950,2138,'da','PÃ¥ mÃ¦ngder Over',0),(76951,2138,'ko','ì´ìƒ ìˆ˜ëŸ‰ì—',0),(76952,2138,'he','×¢×œ ×›×ž×•×™×•×ª.',0),(76953,2138,'el','Î£Ï‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î¹Ï‚ Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚ ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î¬ÏÎºÎµÎ¹Î±',0),(76954,2138,'zh','æ»¡é‡\r\n',0),(76955,2138,'sv','FÃ¶r kvantiteter Ã¶ver',0),(76956,2138,'it','Quantitativi sopra',0),(76957,2138,'tl','',0),(76958,2138,'th','&#3610;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;',0),(76959,2138,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¤°',0),(76960,2138,'ms','Pada kuantiti yang lebih',0),(76961,2138,'ar','Ø¹Ù„Ù‰ ÙƒÙ…ÙŠØ§Øª Ø£ÙƒØ«Ø±',0),(76962,2138,'fr','QuantitÃ©s plus',0),(76963,2138,'jp','ï½žä»¥ä¸Šã?®æ•°é‡?ã?®',0),(76964,2138,'pt','Em quantidades mais',0),(76965,2138,'ru','Ðž ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ðµ Ð½Ð°Ð´',0),(76966,2138,'es','En Cantidades MÃ¡s De',0),(76967,2138,'de','Bei einer Menge von Ã¼ber',0),(76968,2138,'en','On Quantities Over',0),(76969,2139,'is','',0),(76970,2139,'dr','Ø·Ø¨Ù‚ â€“ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´   Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(76971,2139,'pr','Ø·Ø¨Ù‚ â€“ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´   Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(76972,2139,'tr','Ekrandaki satÄ±cÄ± listesi',0),(76973,2139,'pl','Na ekranie Lista dostawcÃ³w',0),(76974,2139,'bg','Ð•ÐºÑ€Ð°Ð½Ð½Ð°Ñ‚Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ¿Ð¸ÑÑŠÐº',0),(76975,2139,'ur','Ø¢Ù† Ø³Ú©Ø±ÛŒÙ† ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ ÙÛØ±Ø³Øª',0),(76976,2139,'sr','ÐÐ° ÐµÐºÑ€Ð°Ð½Ñƒ Ð»Ð¸ÑÑ‚Ñƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(76977,2139,'vi','Danh sÃ¡ch Ä‘áº¡i lÃ½ trÃªn mÃ n hÃ¬nh ',0),(76978,2139,'af','Skerm Verskaffer Lys',0),(76979,2139,'ro','Lista de furnizor pe ecran',0),(76980,2139,'et','Ekraanil hankija nimekiri',0),(76981,2139,'si','Na zaslonu seznam dobaviteljev',0),(76982,2139,'ba','Layar daftar Vendor',0),(76983,2139,'nl','Op het scherm een lijst van leverancier',0),(76984,2139,'fi','NÃ¤ytÃ¶n toimittajan luettelo',0),(76985,2139,'no','PÃ¥ skjermen leverandÃ¸ren listen',0),(76986,2139,'da','PÃ¥ skÃ¦rmen leverandÃ¸r liste',0),(76987,2139,'ko','ê³µê¸‰ ì—…ì²´ ëª©ë¡ í™”ë©´',0),(76988,2139,'he','×¢×œ ×”×ž×¡×š ×¨×©×™×ž×” ×©×œ ×¡×¤×§×™×',0),(76989,2139,'el','Î£Ï„Î·Î½ Î¿Î¸ÏŒÎ½Î· Î»Î¯ÏƒÏ„Î±Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½',0),(76990,2139,'zh','å±å¹•ä¸Šçš„ä¾›åº”å•†åå•\r\n',0),(76991,2139,'sv','PÃ¥ skÃ¤rmen leverantÃ¶r lista',0),(76992,2139,'it','Sullo schermo Vendor List',0),(76993,2139,'tl','',0),(76994,2139,'th','&#3610;&#3609;&#3627;&#3609;&#3657;&#3634;&#3592;&#3629;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(76995,2139,'hi','à¤‘à¤¨-à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥‚à¤šà¥€',0),(76996,2139,'ms','Pada skrin Senarai Penjual',0),(76997,2139,'ar','Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø§Ø´Ø© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ†',0),(76998,2139,'fr','Sur lâ€™Ã©cran Liste fournisseur',0),(76999,2139,'jp','ç”»é?¢ä¸Šã?®æ¥­è€…ãƒªã‚¹ãƒˆ',0),(77000,2139,'pt','Na tela lista de fornecedor',0),(77001,2139,'ru','ÐÐ° ÑÐºÑ€Ð°Ð½Ðµ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(77002,2139,'es','Lista de Proveedores En Pantalla',0),(77003,2139,'de','On-Screen-Anbieter auflisten',0),(77004,2139,'en','On-Screen Vendor List',0),(77005,2140,'is','',0),(77006,2140,'dr','Ø¨Ù‡ Ù…ÙˆÙ‚Ø¹ ',0),(77007,2140,'pr','Ø¨Ù‡ Ù…ÙˆÙ‚Ø¹ ',0),(77008,2140,'tr','ZamanÄ±nda',0),(77009,2140,'pl','Na czas',0),(77010,2140,'bg','ÐŸÐ¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(77011,2140,'ur','ÙˆÙ‚Øª Ù¾Ø±',0),(77012,2140,'sr','ÐÐ° Ð²Ñ€ÐµÐ¼Ðµ',0),(77013,2140,'vi','ÄÃºng giá»',0),(77014,2140,'af','Op Tyd',0),(77015,2140,'ro','Pe timpul',0),(77016,2140,'et','Ã•igel ajal',0),(77017,2140,'si','Na Äas',0),(77018,2140,'ba','Tepat waktu',0),(77019,2140,'nl','Op tijd',0),(77020,2140,'fi','Ajoissa',0),(77021,2140,'no','Tid',0),(77022,2140,'da','PÃ¥ tid',0),(77023,2140,'ko','ì‹œê°„ì—',0),(77024,2140,'he','×‘×–×ž×Ÿ',0),(77025,2140,'el','Î“Î¹Î± Ï„Î·Î½ ÏŽÏÎ±',0),(77026,2140,'zh','æ—¶é—´\r\n',0),(77027,2140,'sv','PÃ¥ tid',0),(77028,2140,'it','Il tempo',0),(77029,2140,'tl','',0),(77030,2140,'th','&#3605;&#3619;&#3591;&#3605;&#3634;&#3617;&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3623;&#3621;&#3634;',0),(77031,2140,'hi','à¤¸à¤®à¤¯ à¤ªà¤°',0),(77032,2140,'ms','Pada masa yang ditetapkan',0),(77033,2140,'ar','ÙÙŠ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(77034,2140,'fr','Ã€ l\'heure',0),(77035,2140,'jp','å®šæ™‚',0),(77036,2140,'pt','Na hora',0),(77037,2140,'ru','ÐÐ° Ð²Ñ€ÐµÐ¼Ñ',0),(77038,2140,'es','En Tiempo',0),(77039,2140,'de','PÃ¼nktlich',0),(77040,2140,'en','On Time',0),(77041,2141,'is','',0),(77042,2141,'dr','Ø·Ø¨Ù‚ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§Ø¶Ø§ÙÙŠ',0),(77043,2141,'pr','Ø·Ø¨Ù‚ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§Ø¶Ø§ÙÙŠ',0),(77044,2141,'tr','On Ã¼cret',0),(77045,2141,'pl','Na wynagrodzenia na',0),(77046,2141,'bg','ÐÐ° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ·',0),(77047,2141,'ur','Ù¾Ø± Ø§Ø¬Ø±Øª Ù¾Ø±',0),(77048,2141,'sr','ÐÐ° Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ñ€ÐµÐºÐ¾',0),(77049,2141,'vi','TrÃªn lÆ°Æ¡ng hÆ¡n',0),(77050,2141,'af','Op Besoldigings Meer As',0),(77051,2141,'ro','Salariu peste',0),(77052,2141,'et','TÃ¶Ã¶tasusid Ã¼le',0),(77053,2141,'si','Na plaÄe nad',0),(77054,2141,'ba','Upah atas',0),(77055,2141,'nl','Op de lonen over',0),(77056,2141,'fi','Palkat',0),(77057,2141,'no','PÃ¥ lÃ¸nn over',0),(77058,2141,'da','PÃ¥ lÃ¸nninger over',0),(77059,2141,'ko','ì´ìƒ ìž„ê¸ˆ',0),(77060,2141,'he','×¢×œ ×©×›×¨ ×ž×¢×œ',0),(77061,2141,'el','Î•Ï€Î¯ Ï„Ï‰Î½ Î¼Î¹ÏƒÎ¸ÏŽÎ½ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ',0),(77062,2141,'zh','è¶…è¿‡å·¥èµ„\r\n',0),(77063,2141,'sv','PÃ¥ lÃ¶n Ã¶ver',0),(77064,2141,'it','Su stipendi oltre',0),(77065,2141,'tl','',0),(77066,2141,'th','&#3610;&#3609;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;',0),(77067,2141,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤ªà¤°',0),(77068,2141,'ms','Pada upah ke atas',0),(77069,2141,'ar','ÙÙŠ Ø§Ù„Ø£Ø¬ÙˆØ± Ø¹Ù„Ù‰ Ù…Ø¯Ù‰',0),(77070,2141,'fr','Sur les salaires sur',0),(77071,2141,'jp','ï½žä»¥ä¸Šã?®è³ƒé‡‘ã?«ã‚ˆã‚‹',0),(77072,2141,'pt','Sobre os salÃ¡rios mais',0),(77073,2141,'ru','Ðž Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ðµ Ð·Ð°',0),(77074,2141,'es','En sueldos mÃ¡s de',0),(77075,2141,'de','Auf die LÃ¶hne Ã¼ber',0),(77076,2141,'en','On wages over',0),(77077,2142,'is','',0),(77078,2142,'dr','Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø³Ù†Ø¯ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø±Ø§  ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù‡  Ø§Ø³Øª â€“ Ø´Ù…Ø§ Ù…Ù…ÙƒÙ† Ø§Ø³Øª ',0),(77079,2142,'pr','Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø³Ù†Ø¯ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø±Ø§  ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù‡  Ø§Ø³Øª â€“ Ø´Ù…Ø§ Ù…Ù…ÙƒÙ† Ø§Ø³Øª ',0),(77080,2142,'tr','Belge karÅŸÄ±dan yÃ¼klenmesi tamamlandÄ±ktan sonra sen olabilir',0),(77081,2142,'pl','Po zakoÅ„czeniu pobierania dokumentu moÅ¼e',0),(77082,2142,'bg','Ð¡Ð»ÐµÐ´ ÐºÐ°Ñ‚Ð¾ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ðµ Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸Ð» Ð¸Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ, Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð°',0),(77083,2142,'ur','Ø§ÛŒÚ© Ø¨Ø§Ø± Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆÙ†Ú¯ Ù…Ú©Ù…Ù„ ÛÛ’ØŒ ØªÙ… ÛÙˆ',0),(77084,2142,'sr','ÐšÐ°Ð´Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐ¸Ð¾ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ, Ð¼Ð¾Ð¶Ð´Ð° Ñ‚Ð¸',0),(77085,2142,'vi','Khi tÃ i liá»‡u Ä‘Ã£ táº£i xong báº¡n cÃ³ thá»ƒ',0),(77086,2142,'af','Sodra die dokument voltooi het om af te laai nie, jy mag',0),(77087,2142,'ro','DupÄƒ ce documentul a finalizat descÄƒrcare, vÄƒ poate',0),(77088,2142,'et','Kui dokument on lÃµpetanud alla, teil vÃµib',0),(77089,2142,'si','Ko dokument je celoten downloading, vam lahko',0),(77090,2142,'ba','Setelah dokumen telah selesai men-download, Anda mungkin',0),(77091,2142,'nl','Zodra het document is voltooid downloaden, zich kunt u',0),(77092,2142,'fi','Kun asiakirja on ladattu, voit',0),(77093,2142,'no','NÃ¥r dokumentet er ferdig dataoverfÃ¸rer, kan du',0),(77094,2142,'da','NÃ¥r dokumentet har fÃ¦rdig downloadet, kan du',0),(77095,2142,'ko','ë¬¸ì„œ ë‹¤ìš´ë¡œë“œ ì™„ë£Œ ë˜ ë©´ ìžˆìŠµë‹ˆë‹¤.',0),(77096,2142,'he','×‘×¨×’×¢ ×©×”×ž×¡×ž×š ×”×©×œ×ž×ª ×”×”×•×¨×“×”, ××ª×” ×™×›×•×œ',0),(77097,2142,'el','ÎœÏŒÎ»Î¹Ï‚ Ï„Î¿ Î­Î³Î³ÏÎ±Ï†Î¿ Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎµ Ï„Î· Î»Î®ÏˆÎ·, Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î±',0),(77098,2142,'zh','ä¸€æ—¦è¯¥æ–‡ä»¶å·²ç»å®Œæˆä¸‹è½½ï¼Œæ‚¨å¯èƒ½\r\n',0),(77099,2142,'sv','NÃ¤r dokumentet har avslutat nedladdning, kan du',0),(77100,2142,'it','Una volta che il documento ha completato il download, puÃ²',0),(77101,2142,'tl','',0),(77102,2142,'th','&#3648;&#3617;&#3639;&#3656;&#3629;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;,&#3588;&#3640;&#3603;&#3629;&#',0),(77103,2142,'hi','à¤à¤• à¤¬à¤¾à¤° à¤œà¤¬ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¤¨à¤¾ à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾ à¤¹à¥ˆ, à¤¤à¥à¤® à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥‹',0),(77104,2142,'ms','Setelah dokumen yang telah selesai memuat turun, anda boleh',0),(77105,2142,'ar','Ø¨Ù…Ø¬Ø±Ø¯ Ø§ÙƒØªÙ…Ø§Ù„ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ ØªØ­Ù…ÙŠÙ„ØŒ ÙŠØ¬ÙˆØ² Ù„Ùƒ',0),(77106,2142,'fr','Une fois le document tÃ©lÃ©chargement est terminÃ©, vous pouvez',0),(77107,2142,'jp','æ–‡æ›¸ã?Œãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã‚’å®Œäº†ã?—ã?Ÿã‚‰ã€?ï½žã?—ã?¦ã‚‚ã‚ˆã?„',0),(77108,2142,'pt','Uma vez que o documento foi concluÃ­do download, vocÃª pode...',0),(77109,2142,'ru','ÐŸÐ¾ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ð¸ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð²Ñ‹ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ',0),(77110,2142,'es','Una vez que el documento ha terminado de descargar, puede',0),(77111,2142,'de','Nachdem das Dokument herunterladen abgeschlossen ist, kÃ¶nnen Sie',0),(77112,2142,'en','Once the document has completed downloading, you may',0),(77113,2143,'is','',0),(77114,2143,'dr','ÙŠÙƒ',0),(77115,2143,'pr','ÙŠÙƒ',0),(77116,2143,'tr','Bir tane',0),(77117,2143,'pl','Jeden',0),(77118,2143,'bg','Ð•Ð´Ð¸Ð½',0),(77119,2143,'ur','Ø§ÛŒÚ©',0),(77120,2143,'sr','ÐˆÐµÐ´Ð°Ð½',0),(77121,2143,'vi','Má»™t',0),(77122,2143,'af','Een',0),(77123,2143,'ro','Unul',0),(77124,2143,'et','Ãœks',0),(77125,2143,'si','Ena',0),(77126,2143,'ba','Salah satu',0),(77127,2143,'nl','Een',0),(77128,2143,'fi','Yksi',0),(77129,2143,'no','En',0),(77130,2143,'da','En',0),(77131,2143,'ko','í•˜ë‚˜',0),(77132,2143,'he','××—×“',0),(77133,2143,'el','ÎˆÎ½Î±',0),(77134,2143,'zh','ä¸€\r\n',0),(77135,2143,'sv','En',0),(77136,2143,'it','Uno',0),(77137,2143,'tl','',0),(77138,2143,'th','&#3627;&#3609;&#3638;&#3656;&#3591;',0),(77139,2143,'hi','à¤à¤•',0),(77140,2143,'ms','Salah satu',0),(77141,2143,'ar','ÙˆØ§Ø­Ø¯',0),(77142,2143,'fr','Un',0),(77143,2143,'jp','1ã?¤',0),(77144,2143,'pt','Um',0),(77145,2143,'ru','ÐžÐ´Ð¸Ð½',0),(77146,2143,'es','Uno',0),(77147,2143,'de','Eine',0),(77148,2143,'en','One',0),(77149,2144,'is','',0),(77150,2144,'dr','ÙÙ‚Ø· ÙŠÙƒ Ø¬ÙˆÙ‡Ø± ',0),(77151,2144,'pr','ÙÙ‚Ø· ÙŠÙƒ Ø¬ÙˆÙ‡Ø± ',0),(77152,2144,'tr','Sadece bir mÃ¼rekkep',0),(77153,2144,'pl','Tylko jednej farby',0),(77154,2144,'bg','Ð•Ð´Ð¸Ð½ Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ ÑÐ°Ð¼Ð¾',0),(77155,2144,'ur','ØµØ±Ù Ø§ÛŒÚ© Ø§Ù†Ú©',0),(77156,2144,'sr','Ð¡Ð°Ð¼Ð¾ Ñ˜ÐµÐ´Ð½Ð° Ð±Ð¾Ñ˜Ð°',0),(77157,2144,'vi','Chá»‰ 1 má»±c',0),(77158,2144,'af','Slegs een Ink',0),(77159,2144,'ro','O cernealÄƒ de doar',0),(77160,2144,'et','Ãœhe tindi ainult',0),(77161,2144,'si','Samo eno Ärnilo',0),(77162,2144,'ba','Hanya satu tinta',0),(77163,2144,'nl','Een inkt alleen',0),(77164,2144,'fi','Yhden vÃ¤rin vain',0),(77165,2144,'no','En blekk',0),(77166,2144,'da','Ã‰n trykfarve kun',0),(77167,2144,'ko','ìž‰í¬ë§Œ',0),(77168,2144,'he','×“×™×• ××—×“ ×‘×œ×‘×“',0),(77169,2144,'el','ÎœÏŒÎ½Î¿ Î­Î½Î± Î¼ÎµÎ»Î¬Î½Î¹',0),(77170,2144,'zh','åªæœ‰ä¸€ä¸ªå¢¨æ°´\r\n',0),(77171,2144,'sv','En tryckfÃ¤rg endast',0),(77172,2144,'it','Un inchiostro solo',0),(77173,2144,'tl','',0),(77174,2144,'th','&#3627;&#3617;&#3638;&#3585;&#3626;&#3637;&#3648;&#3604;&#3637;&#3618;&#3623;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(77175,2144,'hi','à¤à¤• à¤‡à¤‚à¤• à¤•à¥‡à¤µà¤²',0),(77176,2144,'ms','Satu dakwat hanya',0),(77177,2144,'ar','Ø­Ø¨Ø± ÙˆØ§Ø­Ø¯ ÙÙ‚Ø·',0),(77178,2144,'fr','Une encre seulement',0),(77179,2144,'jp','ä¸€ã?¤ã?®ã‚¤ãƒ³ã‚¯ã?®ã?¿',0),(77180,2144,'pt','Uma tinta sÃ³',0),(77181,2144,'ru','ÐžÐ´Ð¸Ð½ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ‡ÐµÑ€Ð½Ð¸Ð»Ð°',0),(77182,2144,'es','Solamente Una Tinta',0),(77183,2144,'de','Nur eine einzige Druckfarbe',0),(77184,2144,'en','One Ink Only',0),(77185,2145,'is','',0),(77186,2145,'dr','(Ø´Ø±Ø·',0),(77187,2145,'pr','ÙŠÙƒ ØªØ²ÙŠÙŠÙ†(Ø´Ø±Ø·',0),(77188,2145,'tr','Bir Trim',0),(77189,2145,'pl','Jeden wykoÅ„czenia',0),(77190,2145,'bg','Ð•Ð´Ð¸Ð½ Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½',0),(77191,2145,'ur','Ø§ÛŒÚ© ØªØ±Ø§Ø´ÛŒÚº',0),(77192,2145,'sr','ÐˆÐµÐ´Ð°Ð½ Ð¢Ñ€Ð¸Ð¼',0),(77193,2145,'vi','Má»™t cáº¯t tá»‰a',0),(77194,2145,'af','Een sny',0),(77195,2145,'ro','Un Trim',0),(77196,2145,'et','Ãœks Trim',0),(77197,2145,'si','En Trim',0),(77198,2145,'ba','Satu Trim',0),(77199,2145,'nl','Een Trim',0),(77200,2145,'fi','Yksi KL',0),(77201,2145,'no','En Trim',0),(77202,2145,'da','En Trim',0),(77203,2145,'ko','í•œ íŠ¸ë¦¼',0),(77204,2145,'he','×—×™×ª×•×š ××—×“',0),(77205,2145,'el','ÎœÎ¹Î± Ï€ÎµÏÎ¹Ï€Î¿Î¯Î·ÏƒÎ·',0),(77206,2145,'zh','ä¸€æ¬¡ä¿®å‰ª\r\n',0),(77207,2145,'sv','En Trim',0),(77208,2145,'it','Un Trim',0),(77209,2145,'tl','',0),(77210,2145,'th','One Trim',0),(77211,2145,'hi','à¤à¤• à¤Ÿà¥à¤°à¤¿à¤® à¤•à¤° à¤¦à¥€à¤œà¤¿à¤',0),(77212,2145,'ms','Trim satu',0),(77213,2145,'ar','ØªÙ‚Ù„ÙŠÙ… ÙˆØ§Ø­Ø¯Ø©',0),(77214,2145,'fr','Un Trim',0),(77215,2145,'jp','ä¸€ã?¤ã?®è£…é£¾',0),(77216,2145,'pt','Uma guarniÃ§Ã£o',0),(77217,2145,'ru','ÐžÐ´Ð¸Ð½ Ð¾Ñ‚Ð´ÐµÐ»ÐºÐ¾Ð¹',0),(77218,2145,'es','Un Adorno',0),(77219,2145,'de','Eine Trim',0),(77220,2145,'en','One Trim',0),(77221,2146,'is','',0),(77222,2146,'dr','ÙÙ‚Ø· Ø³Ø§Ø¹ØªÙŠ ',0),(77223,2146,'pr','ÙÙ‚Ø· Ø³Ø§Ø¹ØªÙŠ ',0),(77224,2146,'tr','Tek saat Ã¼creti',0),(77225,2146,'pl','Tylko co godzinÄ™',0),(77226,2146,'bg','Ð¡Ð°Ð¼Ð¾ Ñ‡Ð°Ñ',0),(77227,2146,'ur','ÙˆØ§Ø­Ø¯ ÙÛŒ Ú¯Ú¾Ù†Ù¹Û',0),(77228,2146,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸ ÑÐ°Ñ‚Ð½Ð¸Ñ†Ð°',0),(77229,2146,'vi','Chá»‰ theo giá»',0),(77230,2146,'af','Slegs Uurliks',0),(77231,2146,'ro','Numai pe orÄƒ',0),(77232,2146,'et','Ainus tunnitasu',0),(77233,2146,'si','Samo uro',0),(77234,2146,'ba','Hanya per jam',0),(77235,2146,'nl','Alleen per uur',0),(77236,2146,'fi','Vain tunnin',0),(77237,2146,'no','Bare time',0),(77238,2146,'da','Kun timelÃ¸n',0),(77239,2146,'ko','ìœ ì¼í•œ ì‹œê°„ë³„',0),(77240,2146,'he','×ž×“×™ ×©×¢×” ×‘×œ×‘×“',0),(77241,2146,'el','ÎœÏŒÎ½Î¿ Ï‰ÏÎ¹Î±Î¯Î±',0),(77242,2146,'zh','åªæœ‰æ¯å°æ—¶\r\n',0),(77243,2146,'sv','Enda timme',0),(77244,2146,'it','Orario unico',0),(77245,2146,'tl','',0),(77246,2146,'th','&#3619;&#3634;&#3618;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(77247,2146,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾',0),(77248,2146,'ms','Jam sahaja',0),(77249,2146,'ar','ÙƒÙ„ Ø³Ø§Ø¹Ø© ÙÙ‚Ø·',0),(77250,2146,'fr','Toutes les heures seulement',0),(77251,2146,'jp','æ™‚é–“æ¯Žã?®ã?¿',0),(77252,2146,'pt','Cada Ãºnica hora',0),(77253,2146,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ð¾Ñ‡Ð°ÑÐ¾Ð²Ñ‹Ðµ',0),(77254,2146,'es','Solo por hora',0),(77255,2146,'de','Nur die Stunden',0),(77256,2146,'en','Only hourly',0),(77257,2147,'is','',0),(77258,2147,'dr','ÙÙ‚Ø· Ø§Ú¯Ø± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ÙƒØ§Ø±Ø¨Ø± Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(77259,2147,'pr','ÙÙ‚Ø· Ø§Ú¯Ø± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ÙƒØ§Ø±Ø¨Ø± Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(77260,2147,'tr','<sm>(yeni kullanÄ±cÄ± olarak girmemiÅŸ ise)</sm>',0),(77261,2147,'pl','<sm>(jeÅ›li nie wprowadzono jako nowy uÅ¼ytkownik)</sm>',0),(77262,2147,'bg','<sm>(Ð°ÐºÐ¾ Ð½Ðµ ÑÐµ Ð²ÑŠÐ²ÐµÐ´Ðµ ÐºÐ°Ñ‚Ð¾ Ð½Ð¾Ð² Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»)</sm>',0),(77263,2147,'ur','<sm>(Ù†ÛŒØ§ ØµØ§Ø±Ù Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ú¯Ø± Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ Ù†Û ÛÙˆÚº)</sm>',0),(77264,2147,'sr','<sm>(Ð°ÐºÐ¾ Ð½Ð¸Ñ˜Ðµ ÑƒÐ½ÐµÑÐµÐ½Ð° ÐºÐ°Ð¾ Ð½Ð¾Ð²Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº)</sm>',0),(77265,2147,'vi','(chá»‰ khi náº¿u khÃ´ng nháº­p lÃ  ngÆ°á»i sá»­ dá»¥ng rá»“i!)',0),(77266,2147,'af','(slegs indien nie reeds as \'n gebruiker ingevoer nie!)',0),(77267,2147,'ro','<sm>(Ã®n cazul Ã®n care nu a intrat ca utilizator nou)</sm>',0),(77268,2147,'et','<sm>(kui te ei sisesta uus kasutaja)</sm>',0),(77269,2147,'si','<sm>(Äe niste vnesli kot nov uporabnik)</sm>',0),(77270,2147,'ba','<sm>(jika tidak dimasukkan sebagai pengguna baru)</sm>',0),(77271,2147,'nl','<sm>(als niet ingevoerd als nieuwe gebruiker)</sm>',0),(77272,2147,'fi','<sm>(jos ei tullut uutena kÃ¤yttÃ¤jÃ¤nÃ¤)</sm>',0),(77273,2147,'no','<sm>(hvis ikke angis som ny bruker)</sm>',0),(77274,2147,'da','<sm>(hvis ikke indsat som ny bruger)</sm>',0),(77275,2147,'ko','<sm>(í•´ë‹¹ ë˜ëŠ” ê²½ìš° ìƒˆ ì‚¬ìš©ìžë¡œ ìž…ë ¥ í•˜ì§€)</sm>',0),(77276,2147,'he','<sm>(×× ×œ× × ×›× ×¡×• ×‘×ª×•×¨ ×ž×©×ª×ž×© ×—×“×©)</sm>',0),(77277,2147,'el','<sm>(Î±Î½ Î´ÎµÎ½ Ï„ÎµÎ¸ÎµÎ¯ Ï‰Ï‚ Î½Î­Î¿Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚)</sm>',0),(77278,2147,'zh','ï¼ˆä»…å½“æœªè¾“å…¥ä½œä¸ºç”¨æˆ·ï¼ï¼‰\r\n',0),(77279,2147,'sv','<sm>(om inte in som ny anvÃ¤ndare)</sm>',0),(77280,2147,'it','<sm>(se non inserito come nuovo utente)</sm>',0),(77281,2147,'tl','',0),(77282,2147,'th','(only if not entered as user already!)',0),(77283,2147,'hi','<sm>à¤¯à¤¦à¤¿ (à¤¨à¤¯à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤¨à¤¹à¥€à¤‚)</sm>',0),(77284,2147,'ms','<sm>(jika tidak dimasukkan sebagai pengguna baru)</sm>',0),(77285,2147,'ar','<sm>(Ø¥Ø°Ø§ Ù„Ù… ØªÙƒÙ† Ø¯Ø®Ù„Øª ÙƒÙ…Ø³ØªØ®Ø¯Ù… Ø¬Ø¯ÙŠØ¯)</sm>',0),(77286,2147,'fr','<sm>(si ne pas entrÃ© comme nouvel utilisateur)</sm>',0),(77287,2147,'jp','ï¼ˆãƒ¦ãƒ¼ã‚¶ãƒ¼ã?¨ã?—ã?¦ã?¾ã? å…¥åŠ›ã?—ã?¦ã?„ã?ªã?„å ´å?ˆã?®ã?¿ï¼‰',0),(77288,2147,'pt','<sm>(se nÃ£o entrou como novo usuÃ¡rio)</sm>',0),(77289,2147,'ru','(Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð½Ðµ Ð²Ð²ÐµÐ´ÐµÐ½ ÑƒÐ¶Ðµ ÐºÐ°Ðº Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ!)',0),(77290,2147,'es','(solo si no entrÃ³ como usuario previamente)',0),(77291,2147,'de','<sm>(wird nicht als neuer Benutzer eingegeben)</sm>',0),(77292,2147,'en','<sm>(if not entered as new user)</sm>',0),(77293,2148,'is','',0),(77294,2148,'dr','ÙÙ‚Ø· Ø±ÙˆÙŠ Ù…Ù‚Ø§Ø¯ÙŠØ± Ø¨Ø§Ù„Ø§ ',0),(77295,2148,'pr','ÙÙ‚Ø· Ø±ÙˆÙŠ Ù…Ù‚Ø§Ø¯ÙŠØ± Ø¨Ø§Ù„Ø§ ',0),(77296,2148,'tr','YalnÄ±zca miktarlar yukarÄ±da',0),(77297,2148,'pl','Tylko w iloÅ›ci powyÅ¼ej',0),(77298,2148,'bg','Ð¡Ð°Ð¼Ð¾ Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°, Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ',0),(77299,2148,'ur','ØµØ±Ù Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø± Ù…Ù†Ø¯Ø±Ø¬Û Ø¨Ø§Ù„Ø§',0),(77300,2148,'sr','Ð¡Ð°Ð¼Ð¾ Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ Ð¸Ð·Ð½Ð°Ð´',0),(77301,2148,'vi','Chá»‰ sá»‘ lÆ°á»£ng trÃªn',0),(77302,2148,'af','Slegs op bogenoemde hoeveelhede',0),(77303,2148,'ro','Numai pe cantitÄƒÅ£i mai sus',0),(77304,2148,'et','Ainult eespool nimetatud koguste kohta',0),(77305,2148,'si','Le na koliÄine zgoraj',0),(77306,2148,'ba','Hanya pada jumlah di atas',0),(77307,2148,'nl','Alleen op hoeveelheden hierboven',0),(77308,2148,'fi','Vain jÃ¤senen mÃ¤Ã¤rÃ¤t edellÃ¤',0),(77309,2148,'no','Bare pÃ¥ antall ovenfor',0),(77310,2148,'da','Kun pÃ¥ mÃ¦ngder ovenfor',0),(77311,2148,'ko','ìœ„ì˜ ìˆ˜ëŸ‰ì—ë§Œ',0),(77312,2148,'he','×¨×§ ×¢×œ ×›×ž×•×™×•×ª ×œ×¢×™×œ',0),(77313,2148,'el','ÎœÏŒÎ½Î¿ Î³Î¹Î± Ï„Î¹Ï‚ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚',0),(77314,2148,'zh','åªæœ‰åœ¨ä¸Šè¿°é‡\r\n',0),(77315,2148,'sv','Endast pÃ¥ kvantiteter ovan',0),(77316,2148,'it','Solo sulle quantitÃ  sopra',0),(77317,2148,'tl','',0),(77318,2148,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3657;&#3634;&#3591;&#3610;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(77319,2148,'hi','à¤•à¥‡à¤µà¤² à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¤° à¤‡à¤¸à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(77320,2148,'ms','Hanya pada kuantiti yang di atas',0),(77321,2148,'ar','ÙÙ‚Ø· Ø¹Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ§Øª Ø§Ù„Ù…Ø°ÙƒÙˆØ±Ø© Ø£Ø¹Ù„Ø§Ù‡',0),(77322,2148,'fr','Uniquement sur les quantitÃ©s ci-dessus',0),(77323,2148,'jp','ä¸Šè¨˜æ•°é‡?ã?®å ´å?ˆã?®ã?¿',0),(77324,2148,'pt','Somente em quantidades acima',0),(77325,2148,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ðµ Ð²Ñ‹ÑˆÐµ',0),(77326,2148,'es','Solo en Cantidades arriba',0),(77327,2148,'de','Nur auf Mengen oben',0),(77328,2148,'en','Only on Quantities above',0),(77329,2149,'is','',0),(77330,2149,'dr','ÙÙ‚Ø· Ø­Ù‚ÙˆÙ‚ ',0),(77331,2149,'pr','ÙÙ‚Ø· Ø­Ù‚ÙˆÙ‚ ',0),(77332,2149,'tr','Sadece maaÅŸ',0),(77333,2149,'pl','Tylko pensja',0),(77334,2149,'bg','Ð¡Ð°Ð¼Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð°',0),(77335,2149,'ur','ØµØ±Ù ØªÙ†Ø®ÙˆØ§Û',0),(77336,2149,'sr','Ð¡Ð°Ð¼Ð¾ Ð¿Ð»Ð°Ñ‚Ð°',0),(77337,2149,'vi','Chá»‰ lÆ°Æ¡ng',0),(77338,2149,'af','Salaris Alleenlik',0),(77339,2149,'ro','Doar salariu',0),(77340,2149,'et','Ainult palk',0),(77341,2149,'si','Samo plaÄe',0),(77342,2149,'ba','Hanya gaji',0),(77343,2149,'nl','Alleen salaris',0),(77344,2149,'fi','Vain palkkaa',0),(77345,2149,'no','Bare lÃ¸nn',0),(77346,2149,'da','Kun lÃ¸n',0),(77347,2149,'ko','ë§Œ ê¸‰ì—¬',0),(77348,2149,'he','×¨×§ ×ž×©×›×•×¨×ª',0),(77349,2149,'el','ÎœÏŒÎ½Î¿ Î¼Î¹ÏƒÎ¸ÏŒ',0),(77350,2149,'zh','åªæœ‰è–ªæ°´\r\n',0),(77351,2149,'sv','Endast lÃ¶n',0),(77352,2149,'it','Solo stipendio',0),(77353,2149,'tl','',0),(77354,2149,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(77355,2149,'hi','à¤•à¥‡à¤µà¤² à¤µà¥‡à¤¤à¤¨',0),(77356,2149,'ms','Hanya gaji',0),(77357,2149,'ar','Ø§Ù„Ù…Ø±ØªØ¨ ÙÙ‚Ø·',0),(77358,2149,'fr','Seulement le salaire',0),(77359,2149,'jp','çµ¦æ–™ã?®ã?¿',0),(77360,2149,'pt','Apenas o salÃ¡rio',0),(77361,2149,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð·Ð°Ñ€Ð¿Ð»Ð°Ñ‚Ð°',0),(77362,2149,'es','Solo salario',0),(77363,2149,'de','Nur Gehalt',0),(77364,2149,'en','Only salary',0),(77365,2150,'is','',0),(77366,2150,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù† Ø¨ÙØ±Ø³ØªÙŠØ¯ ',0),(77367,2150,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù† Ø¨ÙØ±Ø³ØªÙŠØ¯ ',0),(77368,2150,'tr','Faturalama iÃ§in faturalandÄ±rÄ±lmamÄ±ÅŸ sipariÅŸleri gÃ¶nderme tamamlandÄ±',0),(77369,2150,'pl','WyÅ›lij wypeÅ‚niony zleceÅ„ nieopÅ‚aconych do fakturowania',0),(77370,2150,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¿Ð¾Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ñ‚Ðµ Unbilled Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(77371,2150,'ur','Ù…Ú©Ù…Ù„ ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯ Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬',0),(77372,2150,'sr','Ð¢Ñ€Ð³Ð¾Ð²Ð°ÑšÐµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸Ñ… Ð£Ð½Ð±Ð¸Ð»Ð»ÐµÐ´ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(77373,2150,'vi','Gá»­i Ä‘Æ¡n hÃ ng hoÃ n táº¥t chÆ°a ra hÃ³a Ä‘Æ¡n sang HÃ³a ÄÆ¡n',0),(77374,2150,'af','Stuur Voltooide Ongefaktureerde Bestellings na Fakturering',0),(77375,2150,'ro','Trimite comenzi Unbilled completat pentru facturare',0),(77376,2150,'et','Saada lÃµpetatud ilma arveta tellimused arve koostamisele',0),(77377,2150,'si','PoÅ¡lji zakljuÄili Unbilled naroÄila za fakturiranje',0),(77378,2150,'ba','Kirim menyelesaikan pesanan yang belum ditagih ke faktur',0),(77379,2150,'nl','Voltooide ongefactureerde Orders verzenden facturering',0),(77380,2150,'fi','LÃ¤hetÃ¤ tÃ¤ytetty Unbilled tilaukset laskutukseen',0),(77381,2150,'no','Sending fullfÃ¸rt fakturert ordre om Ã¥ fakturering',0),(77382,2150,'da','Send udfyldt faktureret ordrer til fakturering',0),(77383,2150,'ko','ì™„ë£Œ ëœ ë° ì£¼ë¬¸ì„ ì¸ë³´ì´ìŠ¤ ë³´ë‚´ê¸°',0),(77384,2150,'he','×œ×©×œ×•×— ×—×©×‘×•× ×™×•×ª ×©×”×•×©×œ×ž×• ×”×–×ž× ×•×ª Unbilled',0),(77385,2150,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Ï„Î·Î½ Î±Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÏƒÏ…Î¼Ï€Î»Î·ÏÏ‰Î¸ÎµÎ¯ ÏƒÏ„Î·Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(77386,2150,'zh','å‘é€å·²å®Œæˆçš„æœªå…¥è´¦è®¢å•åˆ°å‘ç¥¨\r\n',0),(77387,2150,'sv','Skicka ifyllda relaterade order fÃ¶r fakturering',0),(77388,2150,'it','Inviare ordini completati attivitÃ  non ancora fatturati alla fatturazione',0),(77389,2150,'tl','',0),(77390,2150,'th','&#3626;&#3656;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3610;&#3636;&#3621;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3',0),(77391,2150,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‚à¤°à¥à¤£ Unbilled à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œà¥‡à¤‚',0),(77392,2150,'ms','Hantar pesanan lepas siap kepada invois',0),(77393,2150,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø£ÙˆØ§Ù…Ø± ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø© Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø© Ù„Ù„ÙÙˆØªØ±Ø©',0),(77394,2150,'fr','Envoyer des commandes non facturÃ©es exÃ©cutÃ©es Ã  la facturation',0),(77395,2150,'jp','å®Œäº†ã?—ã?Ÿæœªè«‹æ±‚æ³¨æ–‡ã‚’è«‹æ±‚é?Žç¨‹ã?¸é€?ã‚‹',0),(77396,2150,'pt','Enviar ordens nÃ£o faturadas concluÃ­das para facturaÃ§Ã£o',0),(77397,2150,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð½Ñ‹Ðµ Ð½ÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð´Ð»Ñ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(77398,2150,'es','Manda Ordenes Completos pero No Facturados a FacturaciÃ³n',0),(77399,2150,'de','Sendevorgang abgeschlossen noch nicht fakturierte AuftrÃ¤ge bis zur Fakturierung',0),(77400,2150,'en','Send Completed Unbilled Orders to Invoicing',0),(77401,2151,'is','',0),(77402,2151,'dr','Ø¨Ø§Ø²',0),(77403,2151,'pr','Ø¨Ø§Ø²',0),(77404,2151,'tr','AÃ§Ä±k',0),(77405,2151,'pl','Otwarte',0),(77406,2151,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½',0),(77407,2151,'ur','Ú©Ú¾Ù„Ø§',0),(77408,2151,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð°',0),(77409,2151,'vi','Má»Ÿ',0),(77410,2151,'af','Open',0),(77411,2151,'ro','Deschis',0),(77412,2151,'et','Avatud',0),(77413,2151,'si','Odprta',0),(77414,2151,'ba','Buka',0),(77415,2151,'nl','Open',0),(77416,2151,'fi','Avoinna',0),(77417,2151,'no','Ã…pne',0),(77418,2151,'da','Ã…ben',0),(77419,2151,'ko','ì˜¤í”ˆ',0),(77420,2151,'he','×¤×ª×—',0),(77421,2151,'el','Î‘Î½Î¿Î¹ÎºÏ„Î®',0),(77422,2151,'zh','æ‰“å¼€\r\n',0),(77423,2151,'sv','Ã–ppna',0),(77424,2151,'it','Aperto',0),(77425,2151,'tl','',0),(77426,2151,'th','&#3648;&#3611;&#3636;&#3604;',0),(77427,2151,'hi','à¤–à¥à¤²à¤¾',0),(77428,2151,'ms','Terbuka',0),(77429,2151,'ar','Ù…ÙØªÙˆØ­Ø©',0),(77430,2151,'fr','Ouvert',0),(77431,2151,'jp','é–‹ã??',0),(77432,2151,'pt','Aberto',0),(77433,2151,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ',0),(77434,2151,'es','Abrir',0),(77435,2151,'de','Offene',0),(77436,2151,'en','Open',0),(77437,2152,'is','',0),(77438,2152,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ÙŠ Ø¨Ø§Ø² Ø¨Ø±Ø§ÙŠ',0),(77439,2152,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ÙŠ Ø¨Ø§Ø² Ø¨Ø±Ø§ÙŠ',0),(77440,2152,'tr','AÃ§Ä±k Ã¶ÄŸe listesi iÃ§in',0),(77441,2152,'pl','OtwÃ³rz element listy',0),(77442,2152,'bg','ÐžÐ¢Ð’ÐÐ Ð¯ÐÐ• Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð°',0),(77443,2152,'ur','Ú©Ú¾Ù„ÛŒ Ø´Û’ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’',0),(77444,2152,'sr','ÐžÐ¢Ð’ÐžÐ Ð•ÐÐ Ð»Ð¸ÑÑ‚Ð° ÐÐ Ð¢Ð˜ÐšÐÐ›Ð Ð·Ð°',0),(77445,2152,'vi','Danh sÃ¡ch hÃ ng má»Ÿ cho',0),(77446,2152,'af','OOP ITEMLYS vir',0),(77447,2152,'ro','DeschideÅ£i lista de elemente pentru',0),(77448,2152,'et','AVATUD KAUBAARTIKLITE nimekirja puhul',0),(77449,2152,'si','Odpri seznam artiklov za',0),(77450,2152,'ba','Daftar ITEM terbuka untuk',0),(77451,2152,'nl','OPEN ITEMLIJST voor',0),(77452,2152,'fi','Avaa NIMIKELUETTELO',0),(77453,2152,'no','Ã…pne VAREOVERSIKT for',0),(77454,2152,'da','Ã…BEN ELEMENTLISTEN for',0),(77455,2152,'ko','ì—´ë¦° í•­ëª© ëª©ë¡ì— ëŒ€ í•œ',0),(77456,2152,'he','×¨×©×™×ž×ª ×¤×¨×™×˜×™× ×¤×ª×•×—×™× ×¢×‘×•×¨',0),(77457,2152,'el','Î‘ÎÎŸÎ™ÎšÎ¤Î‰ Î»Î¯ÏƒÏ„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³Î¹Î±',0),(77458,2152,'zh','æ‰“å¼€çš„é¡¹ç›®ç›®å½•\r\n',0),(77459,2152,'sv','Ã–ppna ARTIKELLISTAN fÃ¶r',0),(77460,2152,'it','ELENCO di elementi aperti per',0),(77461,2152,'tl','',0),(77462,2152,'th','&#3648;&#3611;&#3636;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(77463,2152,'hi','à¤–à¥à¤²à¥‡ à¤†à¤‡à¤Ÿà¤® à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(77464,2152,'ms','Senarai ITEM terbuka untuk',0),(77465,2152,'ar','ÙØªØ­ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¨Ù†Ø¯',0),(77466,2152,'fr','LISTE d\'Ã©lÃ©ments ouverts pour',0),(77467,2152,'jp','ï½žã?®ã‚ªãƒ¼ãƒ—ãƒ³å“?ç›®ãƒªã‚¹ãƒˆ',0),(77468,2152,'pt','Abrir lista de itens para',0),(77469,2152,'ru','ÐžÐ¢ÐšÐ Ð«Ð¢Ð¬ ÑÐ¿Ð¸ÑÐ¾Ðº ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð´Ð»Ñ',0),(77470,2152,'es','ABRIR LISTA DE ITEMS para',0),(77471,2152,'de','OFFENE Liste Element fÃ¼r',0),(77472,2152,'en','OPEN ITEM LIST for',0),(77473,2153,'is','',0),(77474,2153,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø§Ø²',0),(77475,2153,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø§Ø²',0),(77476,2153,'tr','AÃ§Ä±k Ã¶ÄŸeler',0),(77477,2153,'pl','Otwarte pozycje',0),(77478,2153,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(77479,2153,'ur','Ø§Ø´ÛŒØ§ Ú©Ú¾ÙˆÙ„ÛŒÚº',0),(77480,2153,'sr','ÐžÑ‚Ð²Ð°Ñ€Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(77481,2153,'vi','HÃ ng má»Ÿ',0),(77482,2153,'af','Oop Items',0),(77483,2153,'ro','Elemente deschise',0),(77484,2153,'et','Ãœksuste avamine',0),(77485,2153,'si','Odprte postavke',0),(77486,2153,'ba','Buka item',0),(77487,2153,'nl','Geopende Items',0),(77488,2153,'fi','Avaa Kohteet',0),(77489,2153,'no','Ã…pne elementer',0),(77490,2153,'da','Ã…bne elementer',0),(77491,2153,'ko','í•­ëª© ì—´ê¸°',0),(77492,2153,'he','×¤×ª×— ×¤×¨×™×˜×™×',0),(77493,2153,'el','Î‘Î½Î¿Î¹Ï‡Ï„Î¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(77494,2153,'zh','æ‰“å¼€é¡¹ç›®\r\n',0),(77495,2153,'sv','Ã–ppna poster',0),(77496,2153,'it','Elementi aperti',0),(77497,2153,'tl','',0),(77498,2153,'th','&#3648;&#3611;&#3636;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(77499,2153,'hi','à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤–à¥‹à¤²à¤¨à¤¾',0),(77500,2153,'ms','Item-item terbuka',0),(77501,2153,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…ÙØªÙˆØ­Ø©',0),(77502,2153,'fr','Postes ouverts',0),(77503,2153,'jp','ã‚ªãƒ¼ãƒ—ãƒ³å“?ç›®',0),(77504,2153,'pt','Itens abertos',0),(77505,2153,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹',0),(77506,2153,'es','Abrir Items',0),(77507,2153,'de','Offene Posten',0),(77508,2153,'en','Open Items',0),(77509,2154,'is','',0),(77510,2154,'dr','Ù‡ÙŠÚ† Ù…Ø­Ù…ÙˆÙ„Ù‡ ÙŠ Ø¨Ø§Ø²ÙŠ',0),(77511,2154,'pr','Ù‡ÙŠÚ† Ù…Ø­Ù…ÙˆÙ„Ù‡ ÙŠ Ø¨Ø§Ø²ÙŠ',0),(77512,2154,'tr','AÃ§Ä±k - hiÃ§bir gÃ¶nderiler',0),(77513,2154,'pl','Otwarte - nie przesyÅ‚ek',0),(77514,2154,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½ - Ð½ÑÐ¼Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(77515,2154,'ur','Ú©Ú¾ÙˆÙ„ÛŒÚº - Ù†ÛÛŒÚº Ù„ÛŒØªÛŒ',0),(77516,2154,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸ - Ð½ÐµÐ¼Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(77517,2154,'vi','Má»Ÿ - khÃ´ng chuyáº¿n hÃ ng',0),(77518,2154,'af','Oop - geen versendings',0),(77519,2154,'ro','Open - nu transporturile',0),(77520,2154,'et','Open - no saadetised',0),(77521,2154,'si','Open - ne poÅ¡iljke',0),(77522,2154,'ba','Open - pengiriman tidak',0),(77523,2154,'nl','Open - geen zendingen',0),(77524,2154,'fi','Open - lÃ¤hetystÃ¤ ei',0),(77525,2154,'no','Open - ingen forsendelser',0),(77526,2154,'da','Open - ingen overfÃ¸rsler',0),(77527,2154,'ko','ì˜¤í”ˆ-ì•„ë‹ˆ ì¶œí•˜',0),(77528,2154,'he','×”×¤×ª×•×—×” - ××™×Ÿ ×ž×©×œ×•×—×™×',0),(77529,2154,'el','Open - Î´ÎµÎ½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(77530,2154,'zh','æ‰“å¼€ -æ²¡æœ‰è´§ç‰©\r\n',0),(77531,2154,'sv','Ã–ppna - inga transporter',0),(77532,2154,'it','Apri - no spedizioni',0),(77533,2154,'tl','',0),(77534,2154,'th','&#3648;&#3611;&#3636;&#3604;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(77535,2154,'hi','à¤“à¤ªà¤¨ - à¤•à¥‹à¤ˆ à¤²à¤¦à¤¾à¤¨',0),(77536,2154,'ms','Terbuka - penghantaran tidak',0),(77537,2154,'ar','ÙØªØ­-Ù„Ø§ Ø´Ø­Ù†Ø§Øª',0),(77538,2154,'fr','Open - aucun envoi',0),(77539,2154,'jp','ã‚ªãƒ¼ãƒ—ãƒ³ãƒ¼ç™ºé€?ã?ªã?—',0),(77540,2154,'pt','Aberto - sem carregamentos',0),(77541,2154,'ru','Open - Ð½ÐµÑ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¾Ðº',0),(77542,2154,'es','Abrir - no envÃ­os',0),(77543,2154,'de','Ã–ffnen - keine Sendungen',0),(77544,2154,'en','Open - no shipments',0),(77545,2155,'is','',0),(77546,2155,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(77547,2155,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(77548,2155,'tr','AÃ§Ä±k SipariÅŸler',0),(77549,2155,'pl','Otwartych zamÃ³wieÅ„',0),(77550,2155,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(77551,2155,'ur','Ú©Ú¾Ù„Û’ Ø¢Ø±ÚˆØ±Ø²',0),(77552,2155,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(77553,2155,'vi','Má»Ÿ ÄÆ¡n HÃ ng',0),(77554,2155,'af','Oop Bestellings',0),(77555,2155,'ro','Ordinele deschise',0),(77556,2155,'et','Avatud tellimused',0),(77557,2155,'si','Odprti nalogi',0),(77558,2155,'ba','Perintah yang terbuka',0),(77559,2155,'nl','Open Orders',0),(77560,2155,'fi','Avoimet tilaukset',0),(77561,2155,'no','Ã…pne ordrer',0),(77562,2155,'da','Ã…bne ordrer',0),(77563,2155,'ko','ì—´ê¸° ëª…ë ¹',0),(77564,2155,'he','×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª',0),(77565,2155,'el','Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î±',0),(77566,2155,'zh','æœªç»“è®¢å•\r\n',0),(77567,2155,'sv','Ã–ppna order',0),(77568,2155,'it','Ordini aperti',0),(77569,2155,'tl','',0),(77570,2155,'th','&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(77571,2155,'hi','à¤–à¥‹à¤²à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(77572,2155,'ms','Perintah terbuka',0),(77573,2155,'ar','Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…ÙØªÙˆØ­Ø©',0),(77574,2155,'fr','Commandes ouvertes',0),(77575,2155,'jp','æ³¨æ–‡ã‚’é–‹ã??',0),(77576,2155,'pt','Encomendas abertas',0),(77577,2155,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(77578,2155,'es','Ordenes Abiertos',0),(77579,2155,'de','Offene AuftrÃ¤ge',0),(77580,2155,'en','Open Orders',0),(77581,2156,'is','',0),(77582,2156,'dr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(77583,2156,'pr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(77584,2156,'tr','AÃ§Ä±k SipariÅŸler yalnÄ±zca',0),(77585,2156,'pl','Tylko otwarte zamÃ³wienia',0),(77586,2156,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐ°Ð¼Ð¾',0),(77587,2156,'ur','Ú©Ú¾Ù„Û’ Ø¢Ø±ÚˆØ±Ø² ØµØ±Ù',0),(77588,2156,'sr','Ð¡Ð°Ð¼Ð¾ Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(77589,2156,'vi','Chá»‰ Ä‘Æ¡n hÃ ng má»Ÿ',0),(77590,2156,'af','Slegs Oop Bestellings',0),(77591,2156,'ro','Ordinele deschise numai',0),(77592,2156,'et','Ainult avatud tellimused',0),(77593,2156,'si','Odprte naloge le',0),(77594,2156,'ba','Perintah yang terbuka',0),(77595,2156,'nl','Open Orders alleen',0),(77596,2156,'fi','Avoimet tilaukset',0),(77597,2156,'no','Ã…pne ordrer bare',0),(77598,2156,'da','Ã…bne ordrer kun',0),(77599,2156,'ko','ì˜¤í”ˆ ì£¼ë¬¸ì—ë§Œ í•´ë‹¹',0),(77600,2156,'he','×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª ×‘×œ×‘×“',0),(77601,2156,'el','Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î± Î¼ÏŒÎ½Î¿',0),(77602,2156,'zh','ä»…æœªç»“è®¢å•\r\n',0),(77603,2156,'sv','Ã–ppna order endast',0),(77604,2156,'it','Solo gli ordini aperti',0),(77605,2156,'tl','',0),(77606,2156,'th','&#3648;&#3611;&#3636;&#3604;&#3648;&#3593;&#3614;&#3634;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(77607,2156,'hi','à¤–à¥à¤²à¤¾ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡à¤µà¤²',0),(77608,2156,'ms','Perintah-perintah yang terbuka sahaja',0),(77609,2156,'ar','Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…ÙØªÙˆØ­Ø© ÙÙ‚Ø·',0),(77610,2156,'fr','Commandes ouvertes seulement',0),(77611,2156,'jp','ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡ã?®ã?¿',0),(77612,2156,'pt','Encomendas abertas somente',0),(77613,2156,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(77614,2156,'es','Abrir Ordenes Solamente',0),(77615,2156,'de','Offene Bestellungen nur',0),(77616,2156,'en','Open Orders Only',0),(77617,2157,'is','',0),(77618,2157,'dr','Ø³ÙˆØ¯ Ø¹Ù…Ù„ÙŠØ§ØªÙŠ',0),(77619,2157,'pr','Ø³ÙˆØ¯ Ø¹Ù…Ù„ÙŠØ§ØªÙŠ',0),(77620,2157,'tr','Faaliyet karÄ±',0),(77621,2157,'pl','Zysk operacyjny',0),(77622,2157,'bg','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(77623,2157,'ur','Ø¢Ù¾Ø±ÛŒÙ¹Ù†Ú¯ Ù…Ù†Ø§ÙØ¹',0),(77624,2157,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ð¸ ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚',0),(77625,2157,'vi','Lá»£i nhuáº­n hoáº¡t Ä‘á»™ng',0),(77626,2157,'af','Bedryfswins',0),(77627,2157,'ro','Profit de operare',0),(77628,2157,'et','Ã„rikasum /-kahjum',0),(77629,2157,'si','DobiÄek iz poslovanja',0),(77630,2157,'ba','Laba operasional',0),(77631,2157,'nl','Bedrijfsresultaat',0),(77632,2157,'fi','Liikevoitto',0),(77633,2157,'no','Driftsresultat',0),(77634,2157,'da','Resultat af primÃ¦r drift',0),(77635,2157,'ko','ì˜ì—… ì´ìµ',0),(77636,2157,'he','×™×œ×•×¢×¤×ª×” ×—×•×•×¨×”',0),(77637,2157,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¹ÎºÎ¬ ÎºÎ­ÏÎ´Î·',0),(77638,2157,'zh','ç»è¥åˆ©æ¶¦\r\n',0),(77639,2157,'sv','RÃ¶relseresultat',0),(77640,2157,'it','Utile operativo',0),(77641,2157,'tl','',0),(77642,2157,'th','&#3585;&#3635;&#3652;&#3619;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;',0),(77643,2157,'hi','à¤¸à¤‚à¤šà¤¾à¤²à¤¨ à¤²à¤¾à¤­',0),(77644,2157,'ms','Keuntungan operasi',0),(77645,2157,'ar','Ø£Ø±Ø¨Ø§Ø­ Ø§Ù„ØªØ´ØºÙŠÙ„',0),(77646,2157,'fr','BÃ©nÃ©fice d\'exploitation',0),(77647,2157,'jp','å–¶æ¥­åˆ©ç›Š',0),(77648,2157,'pt','Lucro operacional',0),(77649,2157,'ru','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð°Ñ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ',0),(77650,2157,'es','Ganancia para Operar',0),(77651,2157,'de','Operatives Ergebnis',0),(77652,2157,'en','Operating Profit',0),(77653,2158,'is','',0),(77654,2158,'dr','Ø§Ù¾Ø±Ø§ØªÙˆØ±',0),(77655,2158,'pr','Ø§Ù¾Ø±Ø§ØªÙˆØ±',0),(77656,2158,'tr','OperatÃ¶r',0),(77657,2158,'pl','Operatora',0),(77658,2158,'bg','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€',0),(77659,2158,'ur','Ø¢Ù¾Ø±ÛŒÙ¹Ø±',0),(77660,2158,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ‚ÐµÑ€',0),(77661,2158,'vi','NgÆ°á»i Ä‘iá»u hÃ nh',0),(77662,2158,'af','Operateur',0),(77663,2158,'ro','Operatorul',0),(77664,2158,'et','Tegelev isik',0),(77665,2158,'si','Upravljavec',0),(77666,2158,'ba','Operator',0),(77667,2158,'nl','Exploitant',0),(77668,2158,'fi','Operaattori',0),(77669,2158,'no','OperatÃ¸r',0),(77670,2158,'da','OperatÃ¸r',0),(77671,2158,'ko','ì—°ì‚°ìž',0),(77672,2158,'he','××•×¤×¨×˜×•×¨',0),(77673,2158,'el','Î§ÎµÎ¹ÏÎ¹ÏƒÏ„Î®',0),(77674,2158,'zh','æ“ä½œå™¨\r\n',0),(77675,2158,'sv','OperatÃ¶r',0),(77676,2158,'it','Operatore',0),(77677,2158,'tl','',0),(77678,2158,'th','&#3612;&#3641;&#3657;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;',0),(77679,2158,'hi','à¤‘à¤ªà¤°à¥‡à¤Ÿà¤°',0),(77680,2158,'ms','Pengendali',0),(77681,2158,'ar','Ø¹Ø§Ù…Ù„ Ø§Ù„ØªØ´ØºÙŠÙ„',0),(77682,2158,'fr','OpÃ©rateur',0),(77683,2158,'jp','ã‚ªãƒšãƒ¬ãƒ¼ã‚¿ãƒ¼',0),(77684,2158,'pt','Operador',0),(77685,2158,'ru','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€',0),(77686,2158,'es','Operador',0),(77687,2158,'de','Operator',0),(77688,2158,'en','Operator',0),(77689,2159,'is','',0),(77690,2159,'dr','Ú¯Ø²ÙŠÙ†Ù‡ ',0),(77691,2159,'pr','Ú¯Ø²ÙŠÙ†Ù‡ ',0),(77692,2159,'tr','SeÃ§enek',0),(77693,2159,'pl','Opcja',0),(77694,2159,'bg','ÐžÐ¿Ñ†Ð¸Ñ',0),(77695,2159,'ur','Ø§Ø®ØªÛŒØ§Ø±',0),(77696,2159,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ð°',0),(77697,2159,'vi','Lá»±a chá»n',0),(77698,2159,'af','Opsie',0),(77699,2159,'ro','OpÅ£iune',0),(77700,2159,'et','Valik',0),(77701,2159,'si','MoÅ¾nost',0),(77702,2159,'ba','Opsi',0),(77703,2159,'nl','Optie',0),(77704,2159,'fi','Vaihtoehto',0),(77705,2159,'no','Alternativet',0),(77706,2159,'da','Indstilling',0),(77707,2159,'ko','ì˜µì…˜',0),(77708,2159,'he','××¤×©×¨×•×ª',0),(77709,2159,'el','Î•Ï€Î¹Î»Î¿Î³Î®',0),(77710,2159,'zh','é€‰é¡¹\r\n',0),(77711,2159,'sv','Alternativet',0),(77712,2159,'it','Opzione',0),(77713,2159,'tl','',0),(77714,2159,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(77715,2159,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª',0),(77716,2159,'ms','Opsyen',0),(77717,2159,'ar','Ø§Ù„Ø®ÙŠØ§Ø±',0),(77718,2159,'fr','Option',0),(77719,2159,'jp','é?¸æŠžè‚¢',0),(77720,2159,'pt','OpÃ§Ã£o',0),(77721,2159,'ru','Ð’Ð°Ñ€Ð¸Ð°Ð½Ñ‚',0),(77722,2159,'es','OpciÃ³n',0),(77723,2159,'de','Option',0),(77724,2159,'en','Option',0),(77725,2160,'is','',0),(77726,2160,'dr','Ø§Ø®ØªÙŠØ§Ø±ÙŠ',0),(77727,2160,'pr','Ø§Ø®ØªÙŠØ§Ø±ÙŠ',0),(77728,2160,'tr','Ä°steÄŸe baÄŸlÄ±',0),(77729,2160,'pl','Opcjonalne',0),(77730,2160,'bg','ÐŸÐ¾ Ð¸Ð·Ð±Ð¾Ñ€',0),(77731,2160,'ur','Ø§Ø®ØªÛŒØ§Ø±ÛŒ',0),(77732,2160,'sr','ÐžÐ¿Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð¸',0),(77733,2160,'vi','Lá»±a chá»n',0),(77734,2160,'af','Opsioneel',0),(77735,2160,'ro','OpÅ£ional',0),(77736,2160,'et','Vabatahtlik',0),(77737,2160,'si','Neobvezno',0),(77738,2160,'ba','Opsional',0),(77739,2160,'nl','Optioneel',0),(77740,2160,'fi','Valinnainen',0),(77741,2160,'no','Valgfritt',0),(77742,2160,'da','Valgfri',0),(77743,2160,'ko','(ì„ íƒ ì‚¬í•­)',0),(77744,2160,'he','×œ× ×—×•×‘×”',0),(77745,2160,'el','Î ÏÎ¿Î±Î¹ÏÎµÏ„Î¹ÎºÏŒ',0),(77746,2160,'zh','å¯é€‰\r\n',0),(77747,2160,'sv','Tillval',0),(77748,2160,'it','Opzionale',0),(77749,2160,'tl','',0),(77750,2160,'th','&#3607;&#3637;&#3656;&#3648;&#3611;&#3655;&#3609;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(77751,2160,'hi','à¤µà¥ˆà¤•à¤²à¥à¤ªà¤¿à¤•',0),(77752,2160,'ms','Pilihan',0),(77753,2160,'ar','Ø¥Ø®ØªÙŠØ§Ø±ÙŠ',0),(77754,2160,'fr','En option',0),(77755,2160,'jp','ä»»æ„?ã?®',0),(77756,2160,'pt','Opcional',0),(77757,2160,'ru','Ð¤Ð°ÐºÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ð¸Ð²Ð½Ñ‹Ð¹',0),(77758,2160,'es','Opcional',0),(77759,2160,'de','Optional',0),(77760,2160,'en','Optional',0),(77761,2161,'is','',0),(77762,2161,'dr','ØªÙ†Ø¸ÙŠÙ… Ø§Ø®ØªÙŠØ§Ø±ÙŠ Ø§Ø³Øª ',0),(77763,2161,'pr','ØªÙ†Ø¸ÙŠÙ… Ø§Ø®ØªÙŠØ§Ø±ÙŠ Ø§Ø³Øª ',0),(77764,2161,'tr','Kur\'un isteÄŸe baÄŸlÄ±',0),(77765,2161,'pl','Instalacja jest opcjonalna',0),(77766,2161,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ðµ Ð¿Ð¾ Ð¶ÐµÐ»Ð°Ð½Ð¸Ðµ',0),(77767,2161,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ø§Ø®ØªÛŒØ§Ø±ÛŒ ÛÛ’',0),(77768,2161,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ Ð¾Ð¿Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð°',0),(77769,2161,'vi','Setup khÃ´ng báº¯t buá»™c',0),(77770,2161,'af','Opstelling is opsioneel',0),(77771,2161,'ro','Setare este opÅ£ional',0),(77772,2161,'et','Seadistus ei ole kohustuslik',0),(77773,2161,'si','Nastavitev je izbirna',0),(77774,2161,'ba','Setup opsional',0),(77775,2161,'nl','Setup is optioneel',0),(77776,2161,'fi','On valinnainen',0),(77777,2161,'no','Installasjonen er valgfritt',0),(77778,2161,'da','OpsÃ¦tningen er valgfri',0),(77779,2161,'ko','ì„¤ì¹˜ëŠ” ì„ íƒ ì‚¬í•­',0),(77780,2161,'he','×”×”×ª×§× ×” ×œ× ×—×•×‘×”',0),(77781,2161,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹ Ï€ÏÎ¿Î±Î¹ÏÎµÏ„Î¹ÎºÏŒ',0),(77782,2161,'zh','å®‰è£…æ˜¯å¯é€‰çš„\r\n',0),(77783,2161,'sv','Installationen Ã¤r valfritt',0),(77784,2161,'it','Installazione Ã¨ opzionale',0),(77785,2161,'tl','',0),(77786,2161,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3607;&#3637;&#3656;&#3648;&#3611;&#3655;&#3609;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(77787,2161,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤µà¥ˆà¤•à¤²à¥à¤ªà¤¿à¤• à¤¹à¥ˆ',0),(77788,2161,'ms','Persediaan adalah pilihan',0),(77789,2161,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ø®ØªÙŠØ§Ø±ÙŠ',0),(77790,2161,'fr','Le programme d\'installation est facultative',0),(77791,2161,'jp','è¨­å®šã?¯ä»»æ„?ã?§ã?™',0),(77792,2161,'pt','A instalaÃ§Ã£o Ã© opcional',0),(77793,2161,'ru','ÐŸÑ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ð° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð½Ðµ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼',0),(77794,2161,'es','ConfiguraciÃ³n es opcional',0),(77795,2161,'de','Die Installation ist optional',0),(77796,2161,'en','Setup is optional',0),(77797,2162,'is','',0),(77798,2162,'dr','OR ÙŠØ§ ',0),(77799,2162,'pr','OR ÙŠØ§ ',0),(77800,2162,'tr','OR',0),(77801,2162,'pl','LUB',0),(77802,2162,'bg','Ð˜Ð›Ð˜',0),(77803,2162,'ur','ÛŒØ§',0),(77804,2162,'sr','ÐžÐ ',0),(77805,2162,'vi','Hay',0),(77806,2162,'af','OF',0),(77807,2162,'ro','SAU',0),(77808,2162,'et','OR',0),(77809,2162,'si','ALI',0),(77810,2162,'ba','ATAU',0),(77811,2162,'nl','OF',0),(77812,2162,'fi','TAI',0),(77813,2162,'no','ELLER',0),(77814,2162,'da','ELLER',0),(77815,2162,'ko','ë˜ëŠ”',0),(77816,2162,'he','××•',0),(77817,2162,'el','Î‰',0),(77818,2162,'zh','æˆ–\r\n',0),(77819,2162,'sv','ELLER',0),(77820,2162,'it','OR',0),(77821,2162,'tl','',0),(77822,2162,'th','&#3627;&#3619;&#3639;&#3629;',0),(77823,2162,'hi','OR',0),(77824,2162,'ms','ATAU',0),(77825,2162,'ar',' Ø£Ùˆ ',0),(77826,2162,'fr','OR',0),(77827,2162,'jp','å?ˆã?¯',0),(77828,2162,'pt','OU',0),(77829,2162,'ru','Ð˜Ð›Ð˜',0),(77830,2162,'es','O',0),(77831,2162,'de','OR',0),(77832,2162,'en','OR',0),(77833,2163,'is','',0),(77834,2163,'dr','ÙŠØ§ ÙŠÙƒÙŠ Ø¯ÙŠÚ¯Ø± Ø¯Ø± Ù¾Ø§ÙŠÙŠÙ† Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ',0),(77835,2163,'pr','ÙŠØ§ ÙŠÙƒÙŠ Ø¯ÙŠÚ¯Ø± Ø¯Ø± Ù¾Ø§ÙŠÙŠÙ† Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ',0),(77836,2163,'tr','Ya da aÅŸaÄŸÄ±da bir tane daha ekleyin',0),(77837,2163,'pl','Lub dodaÄ‡ inny, poniÅ¼ej',0),(77838,2163,'bg','Ð˜Ð»Ð¸ Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð° Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ',0),(77839,2163,'ur','ÛŒØ§ Ø¯ÙˆØ³Ø±Û’ Ù†ÛŒÚ†Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(77840,2163,'sr','Ð˜Ð»Ð¸ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð´Ñ€ÑƒÐ³Ð¸ Ð¸ÑÐ¿Ð¾Ð´',0),(77841,2163,'vi','hay thÃªm khÃ¡c dÆ°á»›i Ä‘Ã¢y',0),(77842,2163,'af','Of \'n Ander Onderaan Byvoeg',0),(77843,2163,'ro','Sau Adauga altul mai jos',0),(77844,2163,'et','VÃµi lisada teise alla',0),(77845,2163,'si','Ali dodate Å¡e en spodaj',0),(77846,2163,'ba','Atau menambahkan di bawah ini',0),(77847,2163,'nl','Of een andere hieronder toevoegen',0),(77848,2163,'fi','Tai lisÃ¤tÃ¤ toisen alla',0),(77849,2163,'no','Eller legge til en annen nedenfor',0),(77850,2163,'da','Eller tilfÃ¸je en anden nedenfor',0),(77851,2163,'ko','ë˜ ì•„ëž˜ì˜ ì¶”ê°€ ë˜ëŠ”',0),(77852,2163,'he','××• ×œ×”×•×¡×™×£ ×¢×•×“ ×œ×ž×˜×”',0),(77853,2163,'el','Î‰ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î¬Î»Î»Î· Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰',0),(77854,2163,'zh','æˆ–æ·»åŠ ä¸‹é¢çš„å…¶ä»–\r\n',0),(77855,2163,'sv','Eller lÃ¤gga till ytterligare nedan',0),(77856,2163,'it','O aggiungere un altro qui sotto',0),(77857,2163,'tl','',0),(77858,2163,'th','&#3627;&#3619;&#3639;&#3629;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3636;&#3656;&#3591;&#3629;&#3639;&#3656;&#3609;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;',0),(77859,2163,'hi','à¤¯à¤¾ à¤¨à¥€à¤šà¥‡ à¤¦à¥€ à¤—à¤ˆ à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(77860,2163,'ms','Atau tambah satu lagi di bawah',0),(77861,2163,'ar','Ø£Ùˆ Ø¥Ø¶Ø§ÙØ© Ø¢Ø®Ø± Ø£Ø¯Ù†Ø§Ù‡',0),(77862,2163,'fr','Ou ajouter un autre ci-dessous',0),(77863,2163,'jp','ã‚‚ã?—ã??ã?¯ä¸‹ã?¸ä»–ã‚’è¿½åŠ ',0),(77864,2163,'pt','Ou adicionar outro abaixo',0),(77865,2163,'ru','Ð˜Ð»Ð¸ Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð”Ñ€ÑƒÐ³Ð¾Ð¹ ÐÐ¸Ð¶Ðµ',0),(77866,2163,'es','O Agregar Otro Abajo',0),(77867,2163,'de','Oder fÃ¼gen Sie ein weiteres unten',0),(77868,2163,'en','Or Add Another Below',0),(77869,2164,'is','',0),(77870,2164,'dr','Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ú†Ø§Ù¾ ÙƒÙ†ÙŠØ¯ ',0),(77871,2164,'pr','Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ú†Ø§Ù¾ ÙƒÙ†ÙŠØ¯ ',0),(77872,2164,'tr','Veya kontrol olarak # yeni baskÄ±',0),(77873,2164,'pl','Lub przedruk jak sprawdziÄ‡ #',0),(77874,2164,'bg','Ð˜Ð»Ð¸ Ð¿Ñ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ ÐºÐ°Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸ #',0),(77875,2164,'ur','ÛŒØ§ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº Ø¬ÛŒØ³Û’ # Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹',0),(77876,2164,'sr','Ð˜Ð»Ð¸ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ ÐºÐ°Ð¾ Ð²Ð¸Ð´Ð¸ #',0),(77877,2164,'vi','hay In láº¡i nhÆ° lÃ  SÃ©c sá»‘',0),(77878,2164,'af','Of Herdruk as Tjek #',0),(77879,2164,'ro','Sau reimprimare ca verifica #',0),(77880,2164,'et','VÃµi kui vaadata #',0),(77881,2164,'si','Ali ponatis kot preverite #',0),(77882,2164,'ba','Atau cetak-ulang cek #',0),(77883,2164,'nl','Of herdruk als # controleren',0),(77884,2164,'fi','Tai lisÃ¤painos tarkistaa #',0),(77885,2164,'no','Eller opptrykk som sjekk #',0),(77886,2164,'da','Eller genoptryk som tjekke #',0),(77887,2164,'ko','ë˜ëŠ” ìž¬ë°œí–‰ # í™•ì¸',0),(77888,2164,'he','××• ×”×“×¤×¡×” ×ž×—×“×© ×›×¤×™ ×‘×“×•×§ #',0),(77889,2164,'el','Î‰ Î±Î½Î±Ï„ÏÏ€Ï‰ÏƒÎ· ÏŒÏ€Ï‰Ï‚ ÎµÎ»Î­Î³Î¾ÎµÏ„Îµ #',0),(77890,2164,'zh','æˆ–æ”¯ç¥¨é‡å°ï¼ƒ\r\n',0),(77891,2164,'sv','Eller nytryck kolla #',0),(77892,2164,'it','O ristampa come controllare #',0),(77893,2164,'tl','',0),(77894,2164,'th','&#3627;&#3619;&#3639;&#3629;&#3614;&#3636;&#3617;&#3614;&#3660;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;&#3605;&#3634;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&#3588;',0),(77895,2164,'hi','à¤¯à¤¾ à¤œà¤¾à¤à¤š à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ # à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£',0),(77896,2164,'ms','Atau pencetakan semula seperti menyemak #',0),(77897,2164,'ar','Ø£Ùˆ Ø·Ø¨Ø¹ ÙƒÙ…Ø§ ØªØ­Ù‚Ù‚ #',0),(77898,2164,'fr','Ou rÃ©impression comme vÃ©rifier #',0),(77899,2164,'jp','ã‚‚ã?—ã??ã?¯å°?åˆ‡æ‰‹ç•ªå?·ã?¨ã?—ã?¦å†?å?°åˆ·',0),(77900,2164,'pt','Ou reimpressÃ£o como verificar #',0),(77901,2164,'ru','Ð˜Ð»Ð¸ Ð¿ÐµÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚ÐºÐ° ÐºÐ°Ðº Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ #',0),(77902,2164,'es','O Reimprimir como Cheque #',0),(77903,2164,'de','Oder Nachdruck wie # zu Ã¼berprÃ¼fen',0),(77904,2164,'en','Or Reprint as Check #',0),(77905,2165,'is','',0),(77906,2165,'dr','Ø³ÙØ§Ø±Ø´ ',0),(77907,2165,'pr','Ø³ÙØ§Ø±Ø´ ',0),(77908,2165,'tr','SipariÅŸ',0),(77909,2165,'pl','ZamÃ³wienie',0),(77910,2165,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°',0),(77911,2165,'ur','ØªØ±ØªÛŒØ¨',0),(77912,2165,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´',0),(77913,2165,'vi','Äáº·t HÃ ng',0),(77914,2165,'af','Bestelling',0),(77915,2165,'ro','Comanda',0),(77916,2165,'et','Tellimus',0),(77917,2165,'si','Vrstni red',0),(77918,2165,'ba','Urutan',0),(77919,2165,'nl','Bestelling',0),(77920,2165,'fi','Tilaus',0),(77921,2165,'no','RekkefÃ¸lge',0),(77922,2165,'da','RÃ¦kkefÃ¸lge',0),(77923,2165,'ko','ìˆœì„œ',0),(77924,2165,'he','×”×–×ž× ×”',0),(77925,2165,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(77926,2165,'zh','å®šè´­',0),(77927,2165,'sv','Ordning',0),(77928,2165,'it','Ordine',0),(77929,2165,'tl','',0),(77930,2165,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(77931,2165,'hi','à¤†à¤¦à¥‡à¤¶',0),(77932,2165,'ms','Perintah',0),(77933,2165,'ar','Ø·Ù„Ø¨ÙŠØ©',0),(77934,2165,'fr','Ordre',0),(77935,2165,'jp','æ³¨æ–‡',0),(77936,2165,'pt','Ordem',0),(77937,2165,'ru','Ð—Ð°ÐºÐ°Ð·',0),(77938,2165,'es','Orden',0),(77939,2165,'de','Bestellung',0),(77940,2165,'en','Order',0),(77941,2166,'is','',0),(77942,2166,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ ',0),(77943,2166,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ ',0),(77944,2166,'tr','DÃ¼zen ekleme',0),(77945,2166,'pl','Aby dodaÄ‡',0),(77946,2166,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€ÐµÐ´',0),(77947,2166,'ur','Ø­Ú©Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(77948,2166,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(77949,2166,'vi','Äá»‹a chá»‰ Ä‘Æ¡n hÃ ng',0),(77950,2166,'af','Bestelling Skep',0),(77951,2166,'ro','Comanda Adauga',0),(77952,2166,'et','Tellimuse lisamine',0),(77953,2166,'si','NaroÄilo dodati',0),(77954,2166,'ba','Tambahkan perintah',0),(77955,2166,'nl','Bestelling toevoegen',0),(77956,2166,'fi','Tilaa lisÃ¤Ã¤',0),(77957,2166,'no','Bestill legge',0),(77958,2166,'da','Bestil tilfÃ¸je',0),(77959,2166,'ko','ì£¼ë¬¸ ì¶”ê°€',0),(77960,2166,'he','×¡×“×¨ ×œ×”×•×¡×™×£',0),(77961,2166,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(77962,2166,'zh','æ–°å¢žè®¢å•\r\n',0),(77963,2166,'sv','Ordning lÃ¤gga till',0),(77964,2166,'it','Ordine aggiungere',0),(77965,2166,'tl','',0),(77966,2166,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(77967,2166,'hi','à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(77968,2166,'ms','Menambah perintah',0),(77969,2166,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù…Ø±',0),(77970,2166,'fr','Ordre ajouter',0),(77971,2166,'jp','æ³¨æ–‡ã?®è¿½åŠ ',0),(77972,2166,'pt','Adicionar ordem',0),(77973,2166,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·',0),(77974,2166,'es','Orden Agregar',0),(77975,2166,'de','Bestellung hinzuzufÃ¼gen',0),(77976,2166,'en','Order Add',0),(77977,2167,'is','',0),(77978,2167,'dr','/ Ø§ØµÙ„Ø§Ø­   Ø®Ø· Ø§Ø·Ù„Ø§Ø¹Ø§Øª  Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Ø§ÛŒØ´ â€“ Ø®Ø·',0),(77979,2167,'pr','Ø§ÙØ²ÙˆØ¯Ù† / ÙˆÙŠØ±Ø§ÙŠØ´  Ø®Ø· Ø§Ø·Ù„Ø§Ø¹Ø§Øª  Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ â€“ Ø®Ø·',0),(77980,2167,'tr','SipariÅŸ - satÄ±r satÄ±r bilgisi Ekle/DÃ¼zenle =',0),(77981,2167,'pl','Dodaj/Edytuj informacje na temat wiersza zamÃ³wienia - linia =',0),(77982,2167,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ€ÐµÐ´ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° - Ð»Ð¸Ð½Ð¸Ñ =',0),(77983,2167,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/Ù„Ø§Ø¦Ù† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒÙ„Ø¦Û’ Ø¢Ø±ÚˆØ± - Ù„Ø§Ø¦Ù† ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº =',0),(77984,2167,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð˜Ð½Ñ„Ð¾ Ð»Ð¸Ð½Ð¸Ñ˜Ñƒ Ð·Ð° Ñ€ÐµÐ´ - Ñ€ÐµÐ´ =',0),(77985,2167,'vi','ThÃªm/sá»­a dÃ²ng thÃ´ng tin cho Ä‘Æ¡n hÃ ng - Line =',0),(77986,2167,'af','Skep/Redigeer Lyninligting vir Bestelling - Lyn =',0),(77987,2167,'ro','AdÄƒugare/Editare linie de informaÅ£ii pentru comandÄƒ - linie =',0),(77988,2167,'et','Lisa/Muuda rea infot tellimuses - rida =',0),(77989,2167,'si','Dodaj/Uredi vrstice Info za nalog - Line =',0),(77990,2167,'ba','Menambah/mengedit Info baris untuk Order - baris =',0),(77991,2167,'nl','Toevoegen/bewerken Line Info voor Order - lijn =',0),(77992,2167,'fi','LisÃ¤Ã¤ tai muokkaa rivin tiedot tilauksen - rivi =',0),(77993,2167,'no','Legge til eller redigere linje Info for ordre - linje =',0),(77994,2167,'da','TilfÃ¸j/redigÃ©r linje Info for ordre - linje =',0),(77995,2167,'ko','ì£¼ë¬¸-ë¼ì¸ì— ëŒ€ í•œ ì¤„ ì •ë³´ ì¶”ê°€/íŽ¸ì§‘ =',0),(77996,2167,'he','×”×•×¡×¤×”/×¢×¨×™×›×” ×©×œ ×§×• ×¤×¨×˜×™ ×¢×‘×•×¨ ×”×–×ž× ×” - ×§×• =',0),(77997,2167,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ ÎµÎ½Ï„Î¿Î»Î® - Î³ÏÎ±Î¼Î¼Î® =',0),(77998,2167,'zh','æ–°å¢ž/ç¼–è¾‘è¡Œä¿¡æ¯è®¢å•-è¡Œ=\r\n',0),(77999,2167,'sv','LÃ¤gg till/Redigera linje information fÃ¶r Order - linje =',0),(78000,2167,'it','Aggiungi/modifica Info Line per ordine - linea =',0),(78001,2167,'tl','',0),(78002,2167,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; -  &#36',0),(78003,2167,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤°à¥‡à¤–à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ - à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ =',0),(78004,2167,'ms','Tambah/Edit Info baris untuk perintah - Line =',0),(78005,2167,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¨Ù†Ø¯ Ù„Ù„Ø·Ù„Ø¨ÙŠØ© - Ø³Ø·Ø± = ',0),(78006,2167,'fr','Ajouter/modifier la ligne d\'informations pour la commande - ligne =',0),(78007,2167,'jp','Add/Edit Line Info for Order - Line =',0),(78008,2167,'pt','Adicionar/Editar informaÃ§Ãµes de linha de ordem - linha =',0),(78009,2167,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð»Ð¸Ð½Ð¸Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð° - Ð»Ð¸Ð½Ð¸Ñ =',0),(78010,2167,'es','Agregar/Editar Info de Linea para Orden - Linea=',0),(78011,2167,'de','HinzufÃ¼gen/Bearbeiten von Line-Info fÃ¼r Bestellung - Linie =',0),(78012,2167,'en','Add/Edit Line Info for Order - Line =',0),(78013,2168,'is','',0),(78014,2168,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(78015,2168,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(78016,2168,'tr','SipariÅŸ baÅŸarÄ±yla eklendi',0),(78017,2168,'pl','Aby pomyÅ›lnie dodane',0),(78018,2168,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(78019,2168,'ur','Ø¢Ø±ÚˆØ± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(78020,2168,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(78021,2168,'vi','ThÃªm Ä‘Æ¡n hÃ ng thÃ nh cÃ´ng',0),(78022,2168,'af','Bestelling suksesvol geskep',0),(78023,2168,'ro','Ordinul adÄƒugat cu succes',0),(78024,2168,'et','Lisatud jÃ¤rjekorras',0),(78025,2168,'si','Naloga uspeÅ¡no dodani',0),(78026,2168,'ba','Urutan ditambahkan berhasil',0),(78027,2168,'nl','Volgorde met succes toegevoegd',0),(78028,2168,'fi','Tilauksen lisÃ¤Ã¤minen onnistui',0),(78029,2168,'no','Bestillingen ble lagt til',0),(78030,2168,'da','Bestil tilfÃ¸jet',0),(78031,2168,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì£¼ë¬¸',0),(78032,2168,'he','×¡×“×¨ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(78033,2168,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(78034,2168,'zh','è®¢å•å¢žåŠ æˆåŠŸ\r\n',0),(78035,2168,'sv','Order lagts',0),(78036,2168,'it','Ordine aggiunto con successo',0),(78037,2168,'tl','',0),(78038,2168,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(78039,2168,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(78040,2168,'ms','Perintah yang berjaya menambah',0),(78041,2168,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„Ø·Ù„Ø¨ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(78042,2168,'fr','Ordre ajoutÃ© avec succÃ¨s',0),(78043,2168,'jp','æ³¨æ–‡ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(78044,2168,'pt','Ordem adicionado com sucesso',0),(78045,2168,'ru','Ð—Ð°ÐºÐ°Ð· ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(78046,2168,'es','Orden agregado exitosamente',0),(78047,2168,'de','Bestellung erfolgreich hinzugefÃ¼gt',0),(78048,2168,'en','Order added successfully',0),(78049,2169,'is','',0),(78050,2169,'dr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙƒÙ†ØªØ±Ù„ ÙˆØ±ÙˆØ¯  Ùˆ Ø®Ø±ÙˆØ¬ Ø´Ø¯ ',0),(78051,2169,'pr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙƒÙ†ØªØ±Ù„ ÙˆØ±ÙˆØ¯  Ùˆ Ø®Ø±ÙˆØ¬ Ø´Ø¯ ',0),(78052,2169,'tr','Zaten kontrol veya sipariÅŸ',0),(78053,2169,'pl','ZamÃ³wienie juÅ¼ wyewidencjonowany lub',0),(78054,2169,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°, Ð²ÐµÑ‡Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¸ Ð² Ð¸Ð»Ð¸ Ð¸Ð·Ð²ÑŠÐ½',0),(78055,2169,'ur','Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ø§Ù†Ø¯Ø± ÛŒØ§ Ø¨Ø§ÛØ± Ú©ÛŒ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(78056,2169,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ Ð²ÐµÑ› Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ð¾ Ð·Ð° Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ñ‚Ð¸Ð²',0),(78057,2169,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ Ä‘Ã¡nh dáº¥u vÃ o hay ra',0),(78058,2169,'af','Orde reeds gemerk in of uit',0),(78059,2169,'ro','Comanda deja verificate Ã®n sau Ã®n afara',0),(78060,2169,'et','JÃ¤rjekorras juba kontrollinud sisse vÃµi vÃ¤lja',0),(78061,2169,'si','Nalog Å¾e preverili, ali',0),(78062,2169,'ba','Pesanan yang sudah diperiksa atau memperkecil',0),(78063,2169,'nl','Volgorde al gecontroleerd in- of uitzoomen',0),(78064,2169,'fi','JÃ¤rjestyksessÃ¤ jo kuitattu sisÃ¤Ã¤n tai ulos',0),(78065,2169,'no','Orden sjekket allerede inn eller ut',0),(78066,2169,'da','Bestil tjekket allerede ind eller ud',0),(78067,2169,'ko','ì£¼ë¬¸ ì´ë¯¸ ì²´í¬ ì¸ ë˜ê±°ë‚˜ ì²´í¬ ì•„ì›ƒ',0),(78068,2169,'he','×¡×“×¨ ×›×‘×¨ ×‘×“×§×ª ××ª ×‘×¤× ×™× ××• ×‘×—×•×¥',0),(78069,2169,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± ÎµÎ»ÎµÎ³Ï‡Î¸ÎµÎ¯ Î®Î´Î· Î¼Î­ÏƒÎ± Î® Î­Î¾Ï‰',0),(78070,2169,'zh','è®¢å•å·²ç»åŠžç†æˆ–ç¼©å°\r\n',0),(78071,2169,'sv','Ordning checkat redan in eller ut',0),(78072,2169,'it','Ordine giÃ  controllato in o out',0),(78073,2169,'tl','',0),(78074,2169,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3604;&#3657;&#3621;&#3591;&#3607;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;&#3648;&#3586;&#3657;&#3634;&#3627;&#3619;&#3639;&#3629;&#3629;&#3629;&#3585;&#3648;&#3619;&#3637;&#3',0),(78075,2169,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥‡à¤‚ à¤¯à¤¾ à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(78076,2169,'ms','Perintah yang menandakan masuk atau keluar',0),(78077,2169,'ar','Ø£Ù…Ø± Ø¨Ø§Ù„ÙØ¹Ù„ Ø§Ù„ØªØ­Ù‚Ù‚ Ø£Ùˆ Ø§Ù„ØªØµØºÙŠØ±',0),(78078,2169,'fr','Ordre dÃ©jÃ  vÃ©rifiÃ© ou arriÃ¨re',0),(78079,2169,'jp','æ³¨æ–‡ã?Œã?™ã?§ã?«ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?‹ã‚¤ãƒ³ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(78080,2169,'pt','JÃ¡ verificada dentro ou fora de ordem',0),(78081,2169,'ru','Ð—Ð°ÐºÐ°Ð· ÑƒÐ¶Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ñ‹ Ð¸Ð»Ð¸',0),(78082,2169,'es','Orden ya checado in o out',0),(78083,2169,'de','Bestellung bereits ein- oder ausgecheckt',0),(78084,2169,'en','Order already checked in or out',0),(78085,2170,'is','',0),(78086,2170,'dr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚',0),(78087,2170,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚',0),(78088,2170,'tr','TarafÄ±ndan sipariÅŸ',0),(78089,2170,'pl','ZamÃ³wienia przez',0),(78090,2170,'bg','ÐŸÐ¾Ð´Ñ€ÐµÐ´Ð¸ Ð¿Ð¾',0),(78091,2170,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¢Ø±ÚˆØ±',0),(78092,2170,'sr','ÐŸÐ¾Ñ€ÐµÐ´Ð°Ñ˜ Ð¿Ð¾',0),(78093,2170,'vi','Äáº·t hÃ ng bá»Ÿi',0),(78094,2170,'af','Bestel Deur',0),(78095,2170,'ro','Comanda de',0),(78096,2170,'et','JÃ¤rjesta',0),(78097,2170,'si','RazvrÅ¡Äanje po',0),(78098,2170,'ba','Memesan dengan',0),(78099,2170,'nl','Bestellen door',0),(78100,2170,'fi','Tilata',0),(78101,2170,'no','Bestill ved',0),(78102,2170,'da','Bestille ved',0),(78103,2170,'ko','ì£¼ë¬¸',0),(78104,2170,'he','×”×–×ž× ×” ×‘××ž×¦×¢×•×ª',0),(78105,2170,'el','Î¤Î±Î¾Î¹Î½ÏŒÎ¼Î¹ÏƒÎ·',0),(78106,2170,'zh','æŽ’åº\r\n',0),(78107,2170,'sv','BestÃ¤ll genom',0),(78108,2170,'it','Ordine di',0),(78109,2170,'tl','',0),(78110,2170,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3650;&#3604;&#3618;',0),(78111,2170,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¥à¤°à¤®',0),(78112,2170,'ms','Susun mengikut',0),(78113,2170,'ar','ØªØ±ØªÙŠØ¨ Ø­Ø³Ø¨',0),(78114,2170,'fr','Commander par',0),(78115,2170,'jp','æ³¨æ–‡æ–¹æ³•',0),(78116,2170,'pt','Ordenar por',0),(78117,2170,'ru','Ð—Ð°ÐºÐ°Ð· ÐŸÐ¾',0),(78118,2170,'es','Ordenar Por',0),(78119,2170,'de','Bestellen Sie per',0),(78120,2170,'en','Order By',0),(78121,2171,'is','',0),(78122,2171,'dr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚',0),(78123,2171,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚',0),(78124,2171,'tr','TarafÄ±ndan sipariÅŸ',0),(78125,2171,'pl','ZamÃ³wienia przez',0),(78126,2171,'bg','ÐŸÐ¾Ð´Ñ€ÐµÐ´Ð¸ Ð¿Ð¾',0),(78127,2171,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¢Ø±ÚˆØ±',0),(78128,2171,'sr','ÐŸÐ¾Ñ€ÐµÐ´Ð°Ñ˜ Ð¿Ð¾',0),(78129,2171,'vi','Äáº·t hÃ ng bá»Ÿi',0),(78130,2171,'af','Bestel Deur',0),(78131,2171,'ro','Comanda de',0),(78132,2171,'et','JÃ¤rjesta',0),(78133,2171,'si','RazvrÅ¡Äanje po',0),(78134,2171,'ba','Memesan dengan',0),(78135,2171,'nl','Bestellen door',0),(78136,2171,'fi','Tilata',0),(78137,2171,'no','Bestill ved',0),(78138,2171,'da','Bestille ved',0),(78139,2171,'ko','ì£¼ë¬¸',0),(78140,2171,'he','×”×–×ž× ×” ×‘××ž×¦×¢×•×ª',0),(78141,2171,'el','Î¤Î±Î¾Î¹Î½ÏŒÎ¼Î¹ÏƒÎ·',0),(78142,2171,'zh','æŽ’åº\r\n',0),(78143,2171,'sv','BestÃ¤ll genom',0),(78144,2171,'it','Ordine di',0),(78145,2171,'tl','',0),(78146,2171,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3650;&#3604;&#3618;',0),(78147,2171,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¥à¤°à¤®',0),(78148,2171,'ms','Susun mengikut',0),(78149,2171,'ar','ØªØ±ØªÙŠØ¨ Ø­Ø³Ø¨',0),(78150,2171,'fr','Commander par',0),(78151,2171,'jp','æ³¨æ–‡è€…',0),(78152,2171,'pt','Ordenar por',0),(78153,2171,'ru','Ð—Ð°ÐºÐ°Ð· ÐŸÐ¾',0),(78154,2171,'es','Ordenar Por',0),(78155,2171,'de','Bestellen Sie per',0),(78156,2171,'en','Order By',0),(78157,2172,'is','',0),(78158,2172,'dr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† ÙƒÙ†ØªØ±Ù„ ÙˆØ±ÙˆØ¯  Ùˆ Ø®Ø±ÙˆØ¬ ',0),(78159,2172,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† ÙƒÙ†ØªØ±Ù„ ÙˆØ±ÙˆØ¯  Ùˆ Ø®Ø±ÙˆØ¬ ',0),(78160,2172,'tr','SipariÅŸ onay / Check Out',0),(78161,2172,'pl','Aby sprawdziÄ‡ odkÅ‚adania',0),(78162,2172,'bg','Ð Ð°Ð·Ð¿Ð¾Ñ€ÐµÐ´Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° /',0),(78163,2172,'ur','Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Ù…ÛŒÚº / Ú†ÛŒÚ© Ø¢Ø¤Ù¹ Ø¢Ø±ÚˆØ±',0),(78164,2172,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ñƒ / Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸ Ð½Ð°Ð¿Ð¾Ñ™Ñƒ',0),(78165,2172,'vi','ÄÆ¡n hÃ ng vÃ o/ra',0),(78166,2172,'af','Bestel kontroleer In / kontroleer uit',0),(78167,2172,'ro','Comanda Check In / Check Out',0),(78168,2172,'et','Tellimuse sisse MÃ¶lli sisse / vÃ¤lja',0),(78169,2172,'si','NaroÄilo potrdite / rezervacija zunaj',0),(78170,2172,'ba','Memesan Check di / cek keluar',0),(78171,2172,'nl','Check In-en uitchecken uit bestellen',0),(78172,2172,'fi','Tilaa LAN / lÃ¤htÃ¶',0),(78173,2172,'no','Bestille innsjekking / utsjekking',0),(78174,2172,'da','Bestil Check In / Check ud',0),(78175,2172,'ko','ì£¼ë¬¸ ì²´í¬ ì¸ / ì²´í¬ ì•„ì›ƒ',0),(78176,2172,'he','×ž×–×ž×™×Ÿ ×”×¡×™×ž×•×Ÿ In / Check Out',0),(78177,2172,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Ï„Î¿ Check In / Check Out',0),(78178,2172,'zh','ç™»å…¥/ç™»å‡ºè®¢å•\r\n',0),(78179,2172,'sv','BestÃ¤ll checka In / checka ut',0),(78180,2172,'it','Ordinare il Check In / Out',0),(78181,2172,'tl','',0),(78182,2172,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; &#3648;&#3586;&#3657;&#3634;/&#3629;&#3629;&#3585;',0),(78183,2172,'hi','à¤®à¥‡à¤‚ / à¤œà¤¾à¤à¤š à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤‚à¤š à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(78184,2172,'ms','Perintah Check In / semak Keluar',0),(78185,2172,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ÙÙŠ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±/Ø§Ù„Ø®Ø±ÙˆØ¬',0),(78186,2172,'fr','Commander le Check In et Check Out',0),(78187,2172,'jp','æ³¨æ–‡ãƒ?ã‚§ãƒƒã‚¯ã‚¤ãƒ³/ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆ',0),(78188,2172,'pt','Ordem de Check In / Check Out',0),(78189,2172,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÑƒ / Ð²Ñ‹ÐµÐ·Ð´ Ð¸Ð·',0),(78190,2172,'es','Ordenar Registrarse/Despedirse',0),(78191,2172,'de','Check In / Check Out bestellen',0),(78192,2172,'en','Order Check In/Check Out',0),(78193,2173,'is','',0),(78194,2173,'dr','Ø³ÙØ§Ø±Ø´ Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø´Ø±ÙƒØª ',0),(78195,2173,'pr','Ø³ÙØ§Ø±Ø´ Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø´Ø±ÙƒØª ',0),(78196,2173,'tr','SipariÅŸ ÅŸirket',0),(78197,2173,'pl','ZamÃ³wienie o firmie',0),(78198,2173,'bg','Ð¤Ð¸Ñ€Ð¼Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(78199,2173,'ur','Ø¢Ø±ÚˆØ± Ú©Ù…Ù¾Ù†ÛŒ',0),(78200,2173,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(78201,2173,'vi','Cty Ä‘áº·t hÃ ng',0),(78202,2173,'af','Bestel Onderneming',0),(78203,2173,'ro','Pentru companie',0),(78204,2173,'et','Korralduse ettevÃµte',0),(78205,2173,'si','Nalog podjetja',0),(78206,2173,'ba','Urutan perusahaan',0),(78207,2173,'nl','Volgorde bedrijf',0),(78208,2173,'fi','Tilaus yritys',0),(78209,2173,'no','For selskap',0),(78210,2173,'da','Bestil selskab',0),(78211,2173,'ko','ìˆœì„œ íšŒì‚¬',0),(78212,2173,'he','×‘×—×‘×¨×”',0),(78213,2173,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(78214,2173,'zh','è®¢å•å…¬å¸\r\n',0),(78215,2173,'sv','FÃ¶r fÃ¶retag',0),(78216,2173,'it','Ordine azienda',0),(78217,2173,'tl','',0),(78218,2173,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(78219,2173,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¤‚à¤ªà¤¨à¥€',0),(78220,2173,'ms','Syarikat arahan',0),(78221,2173,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø´Ø±ÙƒØ©',0),(78222,2173,'fr','Compagnie d\'ordonnance',0),(78223,2173,'jp','æ³¨æ–‡ä¼šç¤¾',0),(78224,2173,'pt','Empresa de ordem',0),(78225,2173,'ru','Ð—Ð°ÐºÐ°Ð· ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(78226,2173,'es','Ordenar Empresa',0),(78227,2173,'de','Bestellung-Unternehmen',0),(78228,2173,'en','Order Company',0),(78229,2174,'is','',0),(78230,2174,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ',0),(78231,2174,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ',0),(78232,2174,'tr','SipariÅŸ<br>Adres',0),(78233,2174,'pl','ZamÃ³wiÄ‡<br>Adres',0),(78234,2174,'bg','ÐŸÑ€Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚<br>ÐÐ´Ñ€ÐµÑ',0),(78235,2174,'ur','Ø³Û’ Ø¢Ø±ÚˆØ±<br>Ù¾ØªØ§',0),(78236,2174,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð¸Ð·<br>ÐÐ´Ñ€ÐµÑÐ°',0),(78237,2174,'vi','Äáº·t hÃ ng tá»«Äá»‹a chá»‰',0),(78238,2174,'af','Bestel vanaf<br>Adres',0),(78239,2174,'ro','Comanda de la<br>Adresa',0),(78240,2174,'et','Telli<br>Aadress',0),(78241,2174,'si','Naloga iz<br>Naslov',0),(78242,2174,'ba','Order dari<br>Alamat',0),(78243,2174,'nl','Bestellen<br>Adres',0),(78244,2174,'fi','Tilata<br>Osoite',0),(78245,2174,'no','Bestille fra<br>Adresse',0),(78246,2174,'da','Bestil fra<br>Adresse',0),(78247,2174,'ko','ì£¼ë¬¸<br>ì£¼ì†Œ',0),(78248,2174,'he','×¡×“×¨ ×ž×Ÿ<br>×›×ª×•×‘×ª',0),(78249,2174,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î±Ï€ÏŒ<br>Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(78250,2174,'zh','è®¢è´­æ¥è‡ªåœ°å€\r\n',0),(78251,2174,'sv','BestÃ¤ll frÃ¥n<br>Adress',0),(78252,2174,'it','Ordinare da<br>Indirizzo',0),(78253,2174,'tl','',0),(78254,2174,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;<br>&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(78255,2174,'hi','à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶<br>à¤ªà¤¤à¥‡',0),(78256,2174,'ms','Pesanan dari<br>Alamat',0),(78257,2174,'ar','Ù…Ù† Ø£Ø¬Ù„ Ù…Ù†<br>Ø¹Ù†ÙˆØ§Ù†',0),(78258,2174,'fr','Commander auprÃ¨s de<br>Adresse',0),(78259,2174,'jp','ã?‹ã‚‰ã?®æ³¨æ–‡<br>ä½?æ‰€',0),(78260,2174,'pt','Ordem de<br>EndereÃ§o',0),(78261,2174,'ru','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¾Ñ‚<br>ÐÐ´Ñ€ÐµÑ',0),(78262,2174,'es','Pedido de<br>DirecciÃ³n',0),(78263,2174,'de','Bestellen Sie bei<br>Adresse',0),(78264,2174,'en','Order from<br>Address',0),(78265,2175,'is','',0),(78266,2175,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø±ÙƒØª',0),(78267,2175,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø±ÙƒØª',0),(78268,2175,'tr','Firma bilgileri sipariÅŸ',0),(78269,2175,'pl','ZamÃ³wiÄ‡ Informacje o firmie',0),(78270,2175,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð°',0),(78271,2175,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø³Û’ ØªØ±ØªÛŒØ¨',0),(78272,2175,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¸Ð· ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð˜Ð½Ñ„Ð¾',0),(78273,2175,'vi','Äáº·t hÃ ng tá»« Cty - ThÃ´ng tin',0),(78274,2175,'af','Bestelling Van Onderneming Inligting',0),(78275,2175,'ro','Comanda de la compania Info',0),(78276,2175,'et','Tellimus: Firmast',0),(78277,2175,'si','Nalog iz podjetja Info',0),(78278,2175,'ba','Order dari Info Perusahaan',0),(78279,2175,'nl','Volgorde van Bedrijfsinfo',0),(78280,2175,'fi','Tilauksen Company Info',0),(78281,2175,'no','Bestill fra firmainformasjon',0),(78282,2175,'da','Ordre fra firma Info',0),(78283,2175,'ko','íšŒì‚¬ ì •ë³´ì—ì„œ ì£¼ë¬¸',0),(78284,2175,'he','×¡×“×¨ ×—×‘×¨×ª ×”×ž×™×“×¢',0),(78285,2175,'el','Î£ÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎ¯Î±',0),(78286,2175,'zh','æŒ‰å…¬å¸ä¿¡æ¯æŽ’åº\r\n',0),(78287,2175,'sv','BestÃ¤llning frÃ¥n fÃ¶retag information',0),(78288,2175,'it','Ordine da azienda Info',0),(78289,2175,'tl','',0),(78290,2175,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(78291,2175,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶',0),(78292,2175,'ms','Pesanan dari Info Syarikat',0),(78293,2175,'ar','Ø£Ù…Ø± Ù…Ù† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ©',0),(78294,2175,'fr','Ordre de la sociÃ©tÃ© d\'informations',0),(78295,2175,'jp','ã?‹ã‚‰ã?®æ³¨æ–‡ä¼šç¤¾æƒ…å ±',0),(78296,2175,'pt','Pedido de informaÃ§Ã£o da empresa',0),(78297,2175,'ru','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¾Ñ‚ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(78298,2175,'es','Ordenar de Info de Empresa',0),(78299,2175,'de','Auftrag von Firma Info',0),(78300,2175,'en','Order From Company Info',0),(78301,2176,'is','',0),(78302,2176,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø§ÙŠÙ…ÙŠÙ„ ',0),(78303,2176,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø§ÙŠÙ…ÙŠÙ„ ',0),(78304,2176,'tr','SipariÅŸ<br>E-posta',0),(78305,2176,'pl','ZamÃ³wiÄ‡<br>Adres e-mail',0),(78306,2176,'bg','ÐŸÑ€Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚<br>Ð˜Ð¼ÐµÐ¹Ð»',0),(78307,2176,'ur','Ø³Û’ Ø¢Ø±ÚˆØ±<br>Ø§ÛŒ Ù…ÛŒÙ„',0),(78308,2176,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð¸Ð·<br>Ð•-Ð¿Ð¾ÑˆÑ‚Ð°',0),(78309,2176,'vi','Äáº·t hÃ ng tá»«Email',0),(78310,2176,'af','Bestelling vanE-pos',0),(78311,2176,'ro','Comanda de la<br>E-mail',0),(78312,2176,'et','Telli<br>E-posti',0),(78313,2176,'si','Naloga iz<br>Email',0),(78314,2176,'ba','Order dari<br>Email',0),(78315,2176,'nl','Bestellen<br>E-mail',0),(78316,2176,'fi','Tilata<br>SÃ¤hkÃ¶posti',0),(78317,2176,'no','Bestille fra<br>E-post',0),(78318,2176,'da','Bestil fra<br>E-mail',0),(78319,2176,'ko','ì£¼ë¬¸<br>ë©”ì¼ ì£¼ì†Œ',0),(78320,2176,'he','×¡×“×¨ ×ž×Ÿ<br>×“×•×',0),(78321,2176,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î±Ï€ÏŒ<br>Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(78322,2176,'zh','æŒ‰ç”µå­é‚®ä»¶æŽ’åº\r\n',0),(78323,2176,'sv','BestÃ¤ll frÃ¥n<br>E-post',0),(78324,2176,'it','Ordinare da<br>Posta elettronica',0),(78325,2176,'tl','',0),(78326,2176,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3634;&#3591;<br>&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(78327,2176,'hi','à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶<br>à¤ˆà¤®à¥‡à¤²',0),(78328,2176,'ms','Pesanan dari<br>E-mel',0),(78329,2176,'ar','Ù…Ù† Ø£Ø¬Ù„ Ù…Ù†<br>Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(78330,2176,'fr','Commander auprÃ¨s de<br>Messagerie',0),(78331,2176,'jp','ã?‹ã‚‰ã?®æ³¨æ–‡<br>E-mail',0),(78332,2176,'pt','Ordem de<br>Email',0),(78333,2176,'ru','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¾Ñ‚<br>ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(78334,2176,'es','Ordenar de<br>Email',0),(78335,2176,'de','Bestellen Sie bei<br>E-Mail',0),(78336,2176,'en','Order from<br>Email',0),(78337,2177,'is','',0),(78338,2177,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ØªÙ„ÙÙ† ',0),(78339,2177,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ØªÙ„ÙÙ† ',0),(78340,2177,'tr','SipariÅŸ<br>Telefon',0),(78341,2177,'pl','ZamÃ³wiÄ‡<br>Telefon',0),(78342,2177,'bg','ÐŸÑ€Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚<br>Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(78343,2177,'ur','Ø³Û’ Ø¢Ø±ÚˆØ±<br>ÙÙˆÙ†',0),(78344,2177,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð¸Ð·<br>Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(78345,2177,'vi','Äáº·t hÃ ng tá»«Phone',0),(78346,2177,'af','Bestelling van<br>Foon',0),(78347,2177,'ro','Comanda prin telefon',0),(78348,2177,'et','Telli<br>Telefoni',0),(78349,2177,'si','Naloga iz<br>Telefon',0),(78350,2177,'ba','Order dari<br>Telepon',0),(78351,2177,'nl','Bestellen<br>Telefoon',0),(78352,2177,'fi','Tilata<br>Puhelin',0),(78353,2177,'no','Bestille fra<br>Telefon',0),(78354,2177,'da','Bestil fra<br>Telefon',0),(78355,2177,'ko','ì£¼ë¬¸<br>ì „í™”',0),(78356,2177,'he','×¡×“×¨ ×ž×Ÿ<br>×˜×œ×¤×•×Ÿ',0),(78357,2177,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î±Ï€ÏŒ<br>Î¤Î·Î»Î­Ï†Ï‰Î½Î¿',0),(78358,2177,'zh','ç”µè¯è®¢è´­\r\n',0),(78359,2177,'sv','BestÃ¤ll frÃ¥n<br>Telefon',0),(78360,2177,'it','Ordinare da<br>Telefono',0),(78361,2177,'tl','',0),(78362,2177,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3634;&#3591;<br>&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(78363,2177,'hi','à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶<br>à¤«à¥‹à¤¨',0),(78364,2177,'ms','Pesanan dari<br>Telefon',0),(78365,2177,'ar','Ù…Ù† Ø£Ø¬Ù„ Ù…Ù†<br>Ø§Ù„Ù‡Ø§ØªÙ',0),(78366,2177,'fr','Commander auprÃ¨s de<br>TÃ©lÃ©phone',0),(78367,2177,'jp','ã?‹ã‚‰ã?®æ³¨æ–‡<br>é›»è©±',0),(78368,2177,'pt','Ordem de<br>Telefone',0),(78369,2177,'ru','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¾Ñ‚<br>Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(78370,2177,'es','Ordenar de<br>TelÃ©fono',0),(78371,2177,'de','Bestellen Sie bei<br>Telefon',0),(78372,2177,'en','Order from<br>Phone',0),(78373,2178,'is','',0),(78374,2178,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(78375,2178,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(78376,2178,'tr','SatÄ±cÄ±dan sipariÅŸ',0),(78377,2178,'pl','KolejnoÅ›ci od dostawcy',0),(78378,2178,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(78379,2178,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û Ø³Û’ ØªØ±ØªÛŒØ¨',0),(78380,2178,'sr','ÐÐ°Ð»Ð¾Ð³Ð° Ð¾Ð´ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(78381,2178,'vi','Äáº·t hÃ ng tá»« ngÆ°á»i bÃ¡n',0),(78382,2178,'af','Bestelling Van Verskaffer',0),(78383,2178,'ro','Comanda de la vanzator',0),(78384,2178,'et','Tellimus tarnijalt',0),(78385,2178,'si','Od dobavitelja',0),(78386,2178,'ba','Order dari Vendor',0),(78387,2178,'nl','Volgorde van leverancier',0),(78388,2178,'fi','Tilaus toimittajalta',0),(78389,2178,'no','Ordre fra leverandÃ¸r',0),(78390,2178,'da','Ordre fra leverandÃ¸r',0),(78391,2178,'ko','ê³µê¸‰ ì—…ì²´ ë¡œë¶€í„° ì£¼ë¬¸',0),(78392,2178,'he','×¡×“×¨ ×ž×”×¡×¤×§',0),(78393,2178,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Ï€ÏŒ Ï„Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(78394,2178,'zh','ä»Žä¾›åº”å•†è®¢è´­\r\n',0),(78395,2178,'sv','Order frÃ¥n leverantÃ¶r',0),(78396,2178,'it','Ordine dal fornitore',0),(78397,2178,'tl','',0),(78398,2178,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(78399,2178,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶',0),(78400,2178,'ms','Pesanan daripada penjual',0),(78401,2178,'ar','Ø£Ù…Ø± Ù…Ù† Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(78402,2178,'fr','Commande Ã©manant du vendeur',0),(78403,2178,'jp','æ¥­è€…ã?‹ã‚‰ã?®æ³¨æ–‡',0),(78404,2178,'pt','Ordem de fornecedor',0),(78405,2178,'ru','Ð—Ð°ÐºÐ°Ð· ÐžÑ‚ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(78406,2178,'es','Ordenar De Proveedor',0),(78407,2178,'de','Bestellung von Lieferanten',0),(78408,2178,'en','Order From Vendor',0),(78409,2179,'is','',0),(78410,2179,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ ',0),(78411,2179,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ ',0),(78412,2179,'tr','SipariÅŸ listesi',0),(78413,2179,'pl','Lista zleceÅ„ dla',0),(78414,2179,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð°',0),(78415,2179,'ur','Ø¢Ø±ÚˆØ± ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’',0),(78416,2179,'sr','Ð›Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(78417,2179,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng cho',0),(78418,2179,'af','Bestellinglys vir',0),(78419,2179,'ro','ListÄƒ de comandÄƒ pentru',0),(78420,2179,'et','Hooldustellimuste loend',0),(78421,2179,'si','Seznam nalogov za',0),(78422,2179,'ba','Daftar urutan untuk',0),(78423,2179,'nl','Orderlijst voor',0),(78424,2179,'fi','Tilaa luettelo',0),(78425,2179,'no','Listen for',0),(78426,2179,'da','Bestil liste for',0),(78427,2179,'ko','ì£¼ë¬¸ ëª©ë¡',0),(78428,2179,'he','×¡×“×¨ ×”×¨×©×™×ž×” ×¢×‘×•×¨',0),(78429,2179,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ½Ï„Î¿Î»ÏŽÎ½ Î³Î¹Î±',0),(78430,2179,'zh','è®¢è´­ç›®å½•\r\n',0),(78431,2179,'sv','BestÃ¤llningslista fÃ¶r',0),(78432,2179,'it','Elenco ordine per',0),(78433,2179,'tl','',0),(78434,2179,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(78435,2179,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(78436,2179,'ms','Senarai pesanan untuk',0),(78437,2179,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù†Ø¸Ø§Ù…',0),(78438,2179,'fr','Liste des commandes pour',0),(78439,2179,'jp','æ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(78440,2179,'pt','Lista de encomendas para',0),(78441,2179,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð´Ð»Ñ',0),(78442,2179,'es','Lista de Ordenes para',0),(78443,2179,'de','Bestellliste fÃ¼r',0),(78444,2179,'en','Order List for',0),(78445,2180,'is','',0),(78446,2180,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ â€“ Ø¨Ø±Ø§ÙŠ  Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(78447,2180,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ â€“ Ø¨Ø±Ø§ÙŠ  Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(78448,2180,'tr','SipariÅŸ listesi - gÃ¶nderiler iÃ§in',0),(78449,2180,'pl','Lista zleceÅ„ - dla przesyÅ‚ek',0),(78450,2180,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ - Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(78451,2180,'ur','Ø¢Ø±ÚˆØ± ÙÛØ±Ø³Øª - ØªØ±Ø³ÛŒÙ„ Ú©Û’ Ù„ÛŒÛ’',0),(78452,2180,'sr','Ð›Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð° - Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(78453,2180,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng cho váº­n chuyá»ƒn',0),(78454,2180,'af','Bestelling Lys - vir Versendings',0),(78455,2180,'ro','Lista ordine - pentru transporturi',0),(78456,2180,'et','Hooldustellimuste loend - vedude',0),(78457,2180,'si','Seznam nalogov - za poÅ¡iljke',0),(78458,2180,'ba','Daftar permintaan - untuk pengiriman',0),(78459,2180,'nl','Orderlijst - voor zendingen',0),(78460,2180,'fi','Ostoskori - lÃ¤hetyksille',0),(78461,2180,'no','Oversikt over ordre - leveringer',0),(78462,2180,'da','Bestil liste - for forsendelser',0),(78463,2180,'ko','ë°°ì†¡ ì£¼ë¬¸ ëª©ë¡-',0),(78464,2180,'he','×¨×©×™×ž×ª ×¡×“×¨ - ×¢×‘×•×¨ ×ž×©×œ×•×—×™×',0),(78465,2180,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ½Ï„Î¿Î»ÏŽÎ½ - Î³Î¹Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(78466,2180,'zh','è®¢è´­æ¸…å• -ä¸ºå‘è´§\r\n',0),(78467,2180,'sv','BestÃ¤llningslista - fÃ¶r transporter',0),(78468,2180,'it','Elenco ordine - per le spedizioni',0),(78469,2180,'tl','',0),(78470,2180,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;-&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(78471,2180,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¥‚à¤šà¥€ - à¤²à¤¦à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤',0),(78472,2180,'ms','Senarai pesanan - untuk penghantaran',0),(78473,2180,'ar','ØªØ±ØªÙŠØ¨ Ù‚Ø§Ø¦Ù…Ø©--Ù„Ù„Ø´Ø­Ù†Ø§Øª',0),(78474,2180,'fr','Liste de commande - pour les envois',0),(78475,2180,'jp','æ³¨æ–‡ãƒªã‚¹ãƒˆãƒ¼ç™ºé€?ç”¨',0),(78476,2180,'pt','Lista de ordem - para remessas',0),(78477,2180,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°ÐºÐ°Ð·Ð¾Ð² - Ð´Ð»Ñ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·ÐºÐ¸ Ð³Ñ€ÑƒÐ·Ð¾Ð²',0),(78478,2180,'es','Lista de Ordenes - para EnvÃ­os',0),(78479,2180,'de','Bestellliste - fÃ¼r Sendungen',0),(78480,2180,'en','Order List - for Shipments',0),(78481,2181,'is','',0),(78482,2181,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ â€“ Ø¨Ø±Ø§ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¬Ø¯ÙŠØ¯ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‚Ø¨Ù„ÙŠ Ø±Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ†ÙŠØ¯',0),(78483,2181,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ â€“ Ø¨Ø±Ø§ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¬Ø¯ÙŠØ¯ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‚Ø¨Ù„ÙŠ Ø±Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ†ÙŠØ¯',0),(78484,2181,'tr','SipariÅŸ listesi - yeni sevk irsaliyesi/gÃ¶rÃ¼nÃ¼m Ã¶n sevkiyat seÃ§mek iÃ§in',0),(78485,2181,'pl','Lista zleceÅ„ - aby wybraÄ‡ nowe wydanie/widok przed wysyÅ‚kÄ…',0),(78486,2181,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ - Ð·Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ñ/Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¿Ñ€ÐµÐ´Ð¸ ÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ñ',0),(78487,2181,'ur','Ø¢Ø±ÚˆØ± ÙÛØ±Ø³Øª Ù†Ø¦ÛŒ Ú©Ú¾ÛŒÙ¾/Ù…Ù†Ø¸Ø± Ù¾ÛŒØ´Ú¯ÛŒ Ú©Ú¾ÛŒÙ¾ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’-',0),(78488,2181,'sr','Ð›Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð° - Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸ Ð½Ð¾Ð²Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ/Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(78489,2181,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng Ä‘á»ƒ chá»n Chuyáº¿n hÃ ng má»›i/Xem chuyáº¿n hÃ ng trÆ°á»›c',0),(78490,2181,'af','Bestellingslys - kies nuwe verskeping/bekyk vooraf verskeping',0),(78491,2181,'ro','Lista ordine - pentru a selecta noi de expediere/Vezi anterioare expedierii',0),(78492,2181,'et','Taotluste nimekiri - valige uue saadetise/Vaata enne saatmist',0),(78493,2181,'si','Seznam nalogov - izberite novo poÅ¡iljko/pogled predhodno dobavnico',0),(78494,2181,'ba','Daftar urutan - untuk memilih pengapalan/View sebelum pengiriman baru',0),(78495,2181,'nl','Orderlijst - nieuwe verzending/View voorafgaande verzending selecteren',0),(78496,2181,'fi','Ostoskori - Valitse uusi toimitus ja tarkastele ennen siirtoa',0),(78497,2181,'no','Oversikt over ordre - Ã¥ velge ny forsendelse/visning fÃ¸r forsendelse',0),(78498,2181,'da','Bestil liste - at vÃ¦lge ny forsendelse/Se forudgÃ¥ende forsendelse',0),(78499,2181,'ko','ì£¼ë¬¸ ëª©ë¡-ìƒˆë¡œìš´ ì„ ì /ë·° ì‚¬ì „ ì„ ì  ì„ íƒ',0),(78500,2181,'he','×¨×©×™×ž×ª ×¡×“×¨ - ×›×“×™ ×œ×‘×—×•×¨ ×ž×©×œ×•×— ×—×“×© ×ž×©×œ×•×—/×ª×¦×•×’×” ×ž×•×§×“×ž×ª',0),(78501,2181,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ½Ï„Î¿Î»ÏŽÎ½ - Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î½Î­Î± Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®/Ï€ÏÎ¿Î²Î¿Î»Î® Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(78502,2181,'zh','è®¢è´­åˆ—è¡¨ -é€‰æ‹©æ–°è´§/æŸ¥çœ‹ä¹‹å‰è£…è¿\r\n',0),(78503,2181,'sv','BestÃ¤llningslista - att vÃ¤lja ny utleverans/Visa fÃ¶re leverans',0),(78504,2181,'it','Elenco ordine - per selezionare la nuova spedizione previo spedizione/vista',0),(78505,2181,'tl','',0),(78506,2181,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;-&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3651;&#3627;&#',0),(78507,2181,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¥‚à¤šà¥€ à¤¨à¤¯à¤¾ à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ/à¤¦à¥ƒà¤¶à¥à¤¯ à¤ªà¤¹à¤²à¥‡ à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤-',0),(78508,2181,'ms','Senarai pesanan - untuk memilih baru penghantaran penghantaran atau melihat terlebih dahulu',0),(78509,2181,'ar','ØªØ±ØªÙŠØ¨ Ù‚Ø§Ø¦Ù…Ø©--Ù„ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø´Ø­Ù†Ø© Ù…Ø³Ø¨Ù‚Ø© Ø§Ù„Ø´Ø­Ù†/Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(78510,2181,'fr','Liste de commande - pour sÃ©lectionner le nouvel envoi prÃ©alable d\'expÃ©dition/vue',0),(78511,2181,'jp','æ³¨æ–‡ãƒªã‚¹ãƒˆãƒ¼æ–°è¦?ç™ºé€?ã?®é?¸æŠž/å‰?å›žã?®ç™ºé€?ã‚’è¦‹ã‚‹',0),(78512,2181,'pt','Lista de ordem - para selecionar o novo carregamento de carregamento/vista prÃ©via',0),(78513,2181,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°ÐºÐ°Ð·Ð¾Ð² - Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸/Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð¹ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(78514,2181,'es','Lista de Ordenes - para Seleccionar Nuevo EnvÃ­o/Ver EnvÃ­o Anterior',0),(78515,2181,'de','Bestellliste - neue Sendung/View vorherige Lieferung auswÃ¤hlen',0),(78516,2181,'en','Order List - to Select New Shipment/View Prior Shipment',0),(78517,2182,'is','',0),(78518,2182,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(78519,2182,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(78520,2182,'tr','SipariÅŸ No',0),(78521,2182,'pl','Nr zamÃ³wienia',0),(78522,2182,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° #',0),(78523,2182,'ur','# Ú©Ø§ Ø­Ú©Ù…',0),(78524,2182,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ #',0),(78525,2182,'vi','ÄÆ¡n hÃ ng sá»‘',0),(78526,2182,'af','Bestelling #',0),(78527,2182,'ro','Comanda #',0),(78528,2182,'et','Tellimus nr',0),(78529,2182,'si','NaroÄilo #',0),(78530,2182,'ba','Memesan #',0),(78531,2182,'nl','# Bestellen',0),(78532,2182,'fi','Tilauksen numero',0),(78533,2182,'no','Bestillingsnummer',0),(78534,2182,'da','Bestil #',0),(78535,2182,'ko','# ì£¼ë¬¸',0),(78536,2182,'he','# ×”×–×ž× ×”',0),(78537,2182,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± #',0),(78538,2182,'zh','è®¢å•ï¼ƒ\r\n',0),(78539,2182,'sv','Ordernr',0),(78540,2182,'it','Ordine #',0),(78541,2182,'tl','',0),(78542,2182,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(78543,2182,'hi','à¤†à¤¦à¥‡à¤¶ #',0),(78544,2182,'ms','Pesanan #',0),(78545,2182,'ar','Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(78546,2182,'fr','No de commande',0),(78547,2182,'jp','æ³¨æ–‡ï¼ƒ',0),(78548,2182,'pt','Ordem #',0),(78549,2182,'ru','Ð—Ð°ÐºÐ°Ð· #',0),(78550,2182,'es','Orden #',0),(78551,2182,'de','Auftragsnr.',0),(78552,2182,'en','Order #',0),(78553,2183,'is','',0),(78554,2183,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ù‚Ø¨ÙˆÙ„ Ù†Ø´Ø¯',0),(78555,2183,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ù‚Ø¨ÙˆÙ„ Ù†Ø´Ø¯',0),(78556,2183,'tr','SipariÅŸ numarasÄ± geÃ§ti',0),(78557,2183,'pl','Numer zamÃ³wienia, ktÃ³re nie przeszÅ‚y',0),(78558,2183,'bg','ÐŸÐ¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ðµ Ðµ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ»',0),(78559,2183,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ù†ÛÛŒÚº Ú¯Ø²Ø±Ø§',0),(78560,2183,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾ÑˆÐ°Ð¾',0),(78561,2183,'vi','ÄÆ¡n hÃ ng sá»‘ khÃ´ng chuyá»ƒn',0),(78562,2183,'af','Bestelling Nommer nie geslaag',0),(78563,2183,'ro','NumÄƒrul de ordine nu a trecut',0),(78564,2183,'et','Tootmistellimuse numbrit ei',0),(78565,2183,'si','Å tevilka naroÄila, ki ne prenesejo',0),(78566,2183,'ba','Nomor pesanan tidak lulus',0),(78567,2183,'nl','Bestelnummer niet doorgegeven',0),(78568,2183,'fi','Tilausnumeroa ei siirretÃ¤',0),(78569,2183,'no','Nummeret ikke bestÃ¥tt',0),(78570,2183,'da','Ordrenummer ikke bestÃ¥et',0),(78571,2183,'ko','ì£¼ë¬¸ ë²ˆí˜¸ë¥¼ í†µê³¼ í•˜ì§€',0),(78572,2183,'he','×ž×¡×¤×¨ ×”×–×ž× ×” ×œ× ×—×œ×¤×•',0),(78573,2183,'el','Î‘ÏÎ¾Ï‰Î½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´ÎµÎ½ Ï€Î­ÏÎ±ÏƒÎµ',0),(78574,2183,'zh','è®¢å•å·ä¸é€šè¿‡\r\n',0),(78575,2183,'sv','Ordernummer inte klarat',0),(78576,2183,'it','Numero d\'ordine non superato',0),(78577,2183,'tl','',0),(78578,2183,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;',0),(78579,2183,'hi','à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤°à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(78580,2183,'ms','Nombor pesanan yang tidak diluluskan',0),(78581,2183,'ar','Ø±Ù‚Ù… Ø£Ù…Ø± Ø¹Ø¯Ù… ØªÙ…Ø±ÙŠØ±',0),(78582,2183,'fr','NumÃ©ro de commande ne pas passÃ©',0),(78583,2183,'jp','æ³¨æ–‡ç•ªå?·ã?Œé€šé?Žã?—ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(78584,2183,'pt','NÃºmero de ordem passado nÃ£o',0),(78585,2183,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð—Ð°ÐºÐ°Ð·Ð° Ð½Ðµ Ð²Ð²ÐµÐ´ÐµÐ½',0),(78586,2183,'es','NÃºmero de Orden no pasÃ³',0),(78587,2183,'de','Bestellnummer nicht Ã¼bergeben',0),(78588,2183,'en','Order Number not passed',0),(78589,2184,'is','',0),(78590,2184,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(78591,2184,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(78592,2184,'tr','SÄ°PARÄ°Åž NO',0),(78593,2184,'pl','NR ZAMÃ“WIENIA',0),(78594,2184,'bg','ÐŸÐžÐ ÐªÐ§ÐšÐ #',0),(78595,2184,'ur','# Ú©Ø§ Ø­Ú©Ù…',0),(78596,2184,'sr','ÐÐÐ Ð•Ð”Ð˜ #',0),(78597,2184,'vi','ÄÆ¡n hÃ ng sá»‘',0),(78598,2184,'af','BESTELLING #',0),(78599,2184,'ro','COMANDA #',0),(78600,2184,'et','Tellimus nr',0),(78601,2184,'si','NAROÄŒILO #',0),(78602,2184,'ba','MEMESAN #',0),(78603,2184,'nl','# BESTELLEN',0),(78604,2184,'fi','TILAUKSEN NUMERO',0),(78605,2184,'no','BESTILLINGSNUMMER',0),(78606,2184,'da','BESTIL #',0),(78607,2184,'ko','# ì£¼ë¬¸',0),(78608,2184,'he','×¡×“×¨ #',0),(78609,2184,'el','Î Î‘Î¡Î‘Î“Î“Î•Î›ÎŠÎ‘ #',0),(78610,2184,'zh','è®¢å•ï¼ƒ\r\n',0),(78611,2184,'sv','ORDERNR',0),(78612,2184,'it','ORDINE #',0),(78613,2184,'tl','',0),(78614,2184,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(78615,2184,'hi','à¤†à¤¦à¥‡à¤¶ #',0),(78616,2184,'ms','PESANAN #',0),(78617,2184,'ar','Ø·Ù„Ø¨ÙŠØ© Ø±Ù‚Ù… ',0),(78618,2184,'fr','NO DE COMMANDE',0),(78619,2184,'jp','æ³¨æ–‡ç•ªå?·',0),(78620,2184,'pt','ORDEM #',0),(78621,2184,'ru','Ð—ÐÐšÐÐ— #',0),(78622,2184,'es','ORDEN #',0),(78623,2184,'de','AUFTRAGSNR.',0),(78624,2184,'en','ORDER #',0),(78625,2185,'is','',0),(78626,2185,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(78627,2185,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(78628,2185,'tr','SipariÅŸ numarasÄ±',0),(78629,2185,'pl','Numer zamÃ³wienia',0),(78630,2185,'bg','ÐŸÐ¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(78631,2185,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø±',0),(78632,2185,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(78633,2185,'vi','ÄÆ¡n hÃ ng sá»‘',0),(78634,2185,'af','Bestelling Nommer',0),(78635,2185,'ro','NumÄƒrul de ordine',0),(78636,2185,'et','Tellimuse kood',0),(78637,2185,'si','Å tevilka naloga',0),(78638,2185,'ba','Nomor pesanan',0),(78639,2185,'nl','Bestelnummer',0),(78640,2185,'fi','Tilausnumero',0),(78641,2185,'no','Ordrenummer',0),(78642,2185,'da','Ordrenummer',0),(78643,2185,'ko','ì£¼ë¬¸ ë²ˆí˜¸',0),(78644,2185,'he','×ž×¡×¤×¨ ×”×–×ž× ×”',0),(78645,2185,'el','Î‘ÏÎ¾Ï‰Î½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(78646,2185,'zh','è®¢å•å·\r\n',0),(78647,2185,'sv','Ordernummer',0),(78648,2185,'it','Numero d\'ordine',0),(78649,2185,'tl','',0),(78650,2185,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(78651,2185,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(78652,2185,'ms','Nombor pesanan',0),(78653,2185,'ar','Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(78654,2185,'fr','NumÃ©ro de commande',0),(78655,2185,'jp','æ³¨æ–‡ç•ªå?·',0),(78656,2185,'pt','NÃºmero de ordem',0),(78657,2185,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð—Ð°ÐºÐ°Ð·Ð°',0),(78658,2185,'es','NÃºmero de Orden',0),(78659,2185,'de','Bestell-Nr.',0),(78660,2185,'en','Order Number',0),(78661,2186,'is','',0),(78662,2186,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ ',0),(78663,2186,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ ',0),(78664,2186,'tr','SipariÅŸ Mkt.',0),(78665,2186,'pl','IloÅ›Ä‡ zamÃ³wienia',0),(78666,2186,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(78667,2186,'ur','Ø§Ù…Ø§Ù† Ú©Û’ Ù‚ÛŒ',0),(78668,2186,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÐšÐ¾Ð».',0),(78669,2186,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n hÃ ng',0),(78670,2186,'af','Bestelling Hoev.',0),(78671,2186,'ro','Cantit Ã®n ordinea',0),(78672,2186,'et','Tellimuse kogus',0),(78673,2186,'si','KoliÄina naloga',0),(78674,2186,'ba','Urutan Qty',0),(78675,2186,'nl','Afname',0),(78676,2186,'fi','Tilauksen mÃ¤Ã¤rÃ¤',0),(78677,2186,'no','For antall',0),(78678,2186,'da','Ordre antal',0),(78679,2186,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(78680,2186,'he','×›×ž×•×ª ×”×–×ž× ×”',0),(78681,2186,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(78682,2186,'zh','è®¢è´§é‡\r\n',0),(78683,2186,'sv','BestÃ¤ll antal',0),(78684,2186,'it','Ordine Qty',0),(78685,2186,'tl','',0),(78686,2186,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(78687,2186,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(78688,2186,'ms','Qty pesanan',0),(78689,2186,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(78690,2186,'fr','QuantitÃ© d\'ordre',0),(78691,2186,'jp','æ³¨æ–‡æ•°é‡?',0),(78692,2186,'pt','Qty da ordem',0),(78693,2186,'ru','Ð—Ð°ÐºÐ°Ð· ÐšÐ¾Ð»-Ð²Ð¾',0),(78694,2186,'es','Orden Cant.',0),(78695,2186,'de','Bestellmenge',0),(78696,2186,'en','Order Qty',0),(78697,2187,'is','',0),(78698,2187,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø± ',0),(78699,2187,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø± ',0),(78700,2187,'tr','SipariÅŸ Mkt.',0),(78701,2187,'pl','IloÅ›Ä‡ zamÃ³wienia w',0),(78702,2187,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð²',0),(78703,2187,'ur','Ù…ÛŒÚº Ø¢Ø±ÚˆØ± Ú©Û’ Qty.',0),(78704,2187,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ñƒ',0),(78705,2187,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n hÃ ng trong',0),(78706,2187,'af','Bestelling Hoev. in',0),(78707,2187,'ro','Cant. ordinea Ã®n',0),(78708,2187,'et','Tellimuse kogus on',0),(78709,2187,'si','KoliÄina nalog v',0),(78710,2187,'ba','Urutan Qty. di',0),(78711,2187,'nl','Volgorde veld in',0),(78712,2187,'fi','Tilauksen mÃ¤Ã¤rÃ¤ vuonna',0),(78713,2187,'no','Bestill Ant. i',0),(78714,2187,'da','Bestil antal i',0),(78715,2187,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰ì—',0),(78716,2187,'he','×›×ž×•×ª ×”×–×ž× ×” ×‘',0),(78717,2187,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± ÏƒÏ„Î·Î½',0),(78718,2187,'zh','è®¢è´§é‡ã€‚åœ¨\r\n',0),(78719,2187,'sv','Ordning Ant. i',0),(78720,2187,'it','QtÃ  ordine in',0),(78721,2187,'tl','',0),(78722,2187,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3611;&#3655;&#3609;',0),(78723,2187,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚',0),(78724,2187,'ms','Qty. perintah di',0),(78725,2187,'ar','Qty. Ø§Ù„Ù†Ø¸Ø§Ù… ÙÙŠ',0),(78726,2187,'fr','Dans quantitÃ© d\'ordre.',0),(78727,2187,'jp','æ³¨æ–‡æ•°é‡?',0),(78728,2187,'pt','Qtd. de ordem em',0),(78729,2187,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° Ð²',0),(78730,2187,'es','Orden Cant. en',0),(78731,2187,'de','Order Qty in.',0),(78732,2187,'en','Order Qty. in',0),(78733,2188,'is','',0),(78734,2188,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(78735,2188,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(78736,2188,'tr','SipariÅŸ sevk irsaliyesi ekleme baÅŸarÄ±sÄ±z',0),(78737,2188,'pl','WysyÅ‚ka zamÃ³wienia dodaÄ‡ nie powiodÅ‚o siÄ™',0),(78738,2188,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(78739,2188,'ur','ØªØ±ØªÛŒØ¨ Ú©Ú¾ÛŒÙ¾ Ù†Ø§Ú©Ø§Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(78740,2188,'sr','Ð ÐµÐ´ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¿Ð°Ð»Ð¸',0),(78741,2188,'vi','tháº¥t báº¡i khi thÃªm chuyáº¿n hÃ ng',0),(78742,2188,'af','Byvoeging van Bestelling Versending het gefaal',0),(78743,2188,'ro','Comenzii de expediere Adauga nu a reuÅŸit',0),(78744,2188,'et','Telli vedu lisamine nurjus',0),(78745,2188,'si','Dodaj nalog dobavnica ni',0),(78746,2188,'ba','Pesanan pengiriman menambahkan gagal',0),(78747,2188,'nl','Volgorde verzending toevoegen mislukte',0),(78748,2188,'fi','LÃ¤hetys lisÃ¤ys epÃ¤onnistui',0),(78749,2188,'no','Sending legge mislyktes',0),(78750,2188,'da','Bestil leverance tilfÃ¸je mislykkedes',0),(78751,2188,'ko','ì£¼ë¬¸ ì„ ì  ì¶”ê°€ ì‹¤íŒ¨',0),(78752,2188,'he','×”×–×ž× ×ª ×ž×©×œ×•×— ×œ×”×•×¡×™×£ ×©× ×›×©×œ×•',0),(78753,2188,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(78754,2188,'zh','è®¢å•è£…è¿æ·»åŠ å¤±è´¥\r\n',0),(78755,2188,'sv','BestÃ¤lla transport lÃ¤gga till misslyckades',0),(78756,2188,'it','Spedizione ordine aggiungere fallito',0),(78757,2188,'tl','',0),(78758,2188,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(78759,2188,'hi','à¤‘à¤°à¥à¤¡à¤° à¤ªà¥‹à¤¤à¤²à¤¦à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(78760,2188,'ms','Penghantaran pesanan Tambah gagal',0),(78761,2188,'ar','Ø´Ø­Ù† Ø£Ù…Ø± Ø¥Ø¶Ø§ÙØ© Ø§Ù„ÙØ§Ø´Ù„Ø©',0),(78762,2188,'fr','ExpÃ©dition de la commande Ajouter ayant Ã©chouÃ©',0),(78763,2188,'jp','æ³¨æ–‡ç™ºé€?ã?®è¿½åŠ ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(78764,2188,'pt','Ordem de carregamento Adicionar falha',0),(78765,2188,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(78766,2188,'es','Orden envÃ­o agregar fallÃ³',0),(78767,2188,'de','Bestellung Versand hinzufÃ¼gen fehlgeschlagen',0),(78768,2188,'en','Order shipment add failed',0),(78769,2189,'is','',0),(78770,2189,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ù…Ù„ Ø´Ø¯ ',0),(78771,2189,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ù…Ù„ Ø´Ø¯ ',0),(78772,2189,'tr','BaÅŸarÄ±yla gÃ¶nderilen sipariÅŸ!',0),(78773,2189,'pl','Zlecenia wysÅ‚ane pomyÅ›lnie!',0),(78774,2189,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾!',0),(78775,2189,'ur','Ø¢Ø±ÚˆØ± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§!',0),(78776,2189,'sr','ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾!',0),(78777,2189,'vi','ÄÆ¡n hÃ ng chuyá»ƒn thÃ nh cÃ´ng',0),(78778,2189,'af','Bestelling suksesvol versend!',0),(78779,2189,'ro','ComandÄƒ livrat cu succes!',0),(78780,2189,'et','Tellimuse veetud edukalt!',0),(78781,2189,'si','NaroÄilo poslano uspeÅ¡no!',0),(78782,2189,'ba','Pesanan dikirim berhasil!',0),(78783,2189,'nl','Verzendingen met succes!',0),(78784,2189,'fi','Tilaus toimitettu onnistuneesti!',0),(78785,2189,'no','Ordre som er sendt med hell!',0),(78786,2189,'da','Ordre sendt med succes!',0),(78787,2189,'ko','ì„±ê³µì ìœ¼ë¡œ ë°œì†¡ ì£¼ë¬¸!',0),(78788,2189,'he','×”×–×ž× ×” × ×©×œ×—×” ×‘×”×¦×œ×—×”!',0),(78789,2189,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€Î¿Ï… Î¸Î± ÏƒÏ„Î±Î»ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±!',0),(78790,2189,'zh','è®¢å•è£…è¿æˆåŠŸï¼\r\n',0),(78791,2189,'sv','Ordern levereras framgÃ¥ngsrikt!',0),(78792,2189,'it','Ordine spedito con successo!',0),(78793,2189,'tl','',0),(78794,2189,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3605;&#3634;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(78795,2189,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾!',0),(78796,2189,'ms','Pesanan yang dihantar telah berjaya!',0),(78797,2189,'ar','Ø´Ø­Ù†Øª Ø§Ù„Ø·Ù„Ø¨ÙŠÙ‘Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(78798,2189,'fr','Commande expÃ©diÃ©e avec succÃ¨s !',0),(78799,2189,'jp','æ³¨æ–‡ã?Œç™ºé€?ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(78800,2189,'pt','Pedido enviado com sucesso!',0),(78801,2189,'ru','Ð—Ð°ÐºÐ°Ð· ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½!',0),(78802,2189,'es','Orden enviado exitosamente',0),(78803,2189,'de','Erfolgreich versandte Bestellung!',0),(78804,2189,'en','Order shipped successfully!',0),(78805,2190,'is','',0),(78806,2190,'dr','Ù„ÙŠØ³Øª ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ',0),(78807,2190,'pr','Ù„ÙŠØ³Øª ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ',0),(78808,2190,'tr','SÄ°PARÄ°Åž durumu listesi iÃ§in',0),(78809,2190,'pl','Lista STATUS zamÃ³wienia',0),(78810,2190,'bg','Ð¡ÐŸÐ˜Ð¡ÐªÐš Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð°',0),(78811,2190,'ur','ØªØ±ØªÛŒØ¨ Ø­Ø§Ù„Øª ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’',0),(78812,2190,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¡Ð¢ÐÐ¢Ð£Ð¡Ð ÐÐÐ›ÐžÐ“Ð Ð·Ð°',0),(78813,2190,'vi','TÃ¬nh tráº¡ng Ä‘Æ¡n hÃ ng cho',0),(78814,2190,'af','BESTELLING STATUS LYS vir',0),(78815,2190,'ro','LISTÄ‚ de stare comandÄƒ pentru',0),(78816,2190,'et','TELLIMUSE STAATUSE NIMEKIRI:',0),(78817,2190,'si','STATUS seznam NALOGOV za',0),(78818,2190,'ba','Daftar STATUS ORDER untuk',0),(78819,2190,'nl','LIJST van de STATUS van de ORDER voor',0),(78820,2190,'fi','TILAUKSEN TILALUETTELO',0),(78821,2190,'no','ORDRE STATUS-listen for',0),(78822,2190,'da','ORDRE STATUSOVERSIGT for',0),(78823,2190,'ko','ì— ëŒ€ í•œ ì£¼ë¬¸ ìƒíƒœ ëª©ë¡',0),(78824,2190,'he','×¡×“×¨ ×¨×©×™×ž×ª ×ž×¦×‘ ×¢×‘×•×¨',0),(78825,2190,'el','ÎšÎ‘Î¤Î†Î›ÎŸÎ“ÎŸÎ£ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÎ½Ï„Î¿Î»ÏŽÎ½ Î³Î¹Î±',0),(78826,2190,'zh','è®¢å•çŠ¶æ€ä¸€è§ˆè¡¨\r\n',0),(78827,2190,'sv','ORDNING i listan STATUS fÃ¶r',0),(78828,2190,'it','ELENCO di stato ordine per',0),(78829,2190,'tl','',0),(78830,2190,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3606;&#3634;&#3609;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(78831,2190,'hi','à¤‘à¤°à¥à¤¡à¤° à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(78832,2190,'ms','Senarai STATUS pesanan untuk',0),(78833,2190,'ar','Ø£Ù…Ø± ÙˆØ¶Ø¹ Ù‚Ø§Ø¦Ù…Ø©',0),(78834,2190,'fr','LISTE de statut de commande pour',0),(78835,2190,'jp','æ³¨æ–‡çŠ¶æ³?ãƒªã‚¹ãƒˆ',0),(78836,2190,'pt','LISTA de STATUS de ordem de',0),(78837,2190,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð´Ð»Ñ',0),(78838,2190,'es','LISTA DE STATUS DE ORDENES para',0),(78839,2190,'de','BESTELLSTATUSLISTE fÃ¼r',0),(78840,2190,'en','ORDER STATUS LIST for',0),(78841,2191,'is','',0),(78842,2191,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙƒÙ†ØªØ±Ù„ ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ø´Ø¯ ',0),(78843,2191,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙƒÙ†ØªØ±Ù„ ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ø´Ø¯ ',0),(78844,2191,'tr','SipariÅŸ baÅŸarÄ±yla girip kontrol ettim.',0),(78845,2191,'pl','Aby pomyÅ›lnie wyewidencjonowany lub.',0),(78846,2191,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¸ Ð½Ð°Ð²ÑŠÐ½ Ð¸Ð»Ð¸ Ð½Ð°Ð²ÑŠÑ‚Ñ€Ðµ.',0),(78847,2191,'ur','Ø¢Ø±ÚˆØ± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ù†Ø¯Ø± ÛŒØ§ Ø¨Ø§ÛØ± Ú©ÛŒ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©ÛŒ.',0),(78848,2191,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ð¾ Ð·Ð° Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ñ‚Ð¸Ð².',0),(78849,2191,'vi','ÄÆ¡n hÃ ng chuyá»ƒn vÃ o/ra thÃ nh cÃ´ng',0),(78850,2191,'af','Orde suksesvol nagegaan in of uit.',0),(78851,2191,'ro','Comanda cu succes verificat Ã®n sau Ã®n afara.',0),(78852,2191,'et','Et edukalt kontrollida sisse vÃµi vÃ¤lja.',0),(78853,2191,'si','UspeÅ¡no preveriti ali nalog.',0),(78854,2191,'ba','Agar berhasil diperiksa atau memperkecil.',0),(78855,2191,'nl','Volgorde met succes gecontroleerd in of uit.',0),(78856,2191,'fi','Jotta onnistuneesti tarkastetaan sisÃ¤Ã¤n tai ulos.',0),(78857,2191,'no','Ordren ble sjekket inn eller ut.',0),(78858,2191,'da','Orden med held tjekket ind eller ud.',0),(78859,2191,'ko','ì£¼ë¬¸ ì„±ê³µì ìœ¼ë¡œ ì•ˆìœ¼ë¡œ ë˜ëŠ” ë°–ìœ¼ë¡œ ì²´í¬ìž…ë‹ˆë‹¤.',0),(78860,2191,'he','×¡×“×¨ ×‘×”×¦×œ×—×” ×‘×“×§ ×¤× ×™×ž×” ××• ×”×—×•×¦×”.',0),(78861,2191,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± ÎµÎ»ÎµÎ³Ï‡Î¸ÎµÎ¯ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚ Î¼Î­ÏƒÎ± Î® Î­Î¾Ï‰.',0),(78862,2191,'zh','è®¢å•ç™»å…¥/ç™»å‡ºæˆåŠŸ',0),(78863,2191,'sv','FÃ¶r framgÃ¥ngsrikt kollade in eller ut.',0),(78864,2191,'it','Ordine controllato con successo dentro o fuori.',0),(78865,2191,'tl','',0),(78866,2191,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3586;&#3657;&#3634;&#3627;&#3619;&#3639;&#3629;&#3629;&#3629;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(78867,2191,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤®à¥‡à¤‚ à¤¯à¤¾ à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¥€à¥¤',0),(78868,2191,'ms','Perintah berjaya didaftar masuk atau keluar.',0),(78869,2191,'ar','ØªØ±ØªÙŠØ¨ Ø¨Ù†Ø¬Ø§Ø­ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø¯Ø§Ø®Ù„ Ø£Ùˆ Ø§Ù„Ø®Ø§Ø±Ø¬.',0),(78870,2191,'fr','Ordre vÃ©rifiÃ©e avec succÃ¨s dedans ou dehors.',0),(78871,2191,'jp','æ³¨æ–‡ã?Œãƒ?ã‚§ãƒƒã‚¯ã‚¤ãƒ³/ã‚¢ã‚¦ãƒˆã?•ã‚Œã?¾ã?—ã?Ÿ',0),(78872,2191,'pt','Verificada com sucesso dentro ou fora de ordem.',0),(78873,2191,'ru','Ð—Ð°ÐºÐ°Ð· ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½ in Ð¸Ð»Ð¸ out.',0),(78874,2191,'es','Orden exitosamente checado in o out',0),(78875,2191,'de','Bestellung erfolgreich ein- oder ausgecheckt.',0),(78876,2191,'en','Order successfully checked in or out.',0),(78877,2192,'is','',0),(78878,2192,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´ ',0),(78879,2192,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´ ',0),(78880,2192,'tr','SipariÅŸ toplamÄ±',0),(78881,2192,'pl','Suma zamÃ³wienia',0),(78882,2192,'bg','Ð ÐµÐ´ Ð¾Ð±Ñ‰Ð¾',0),(78883,2192,'ur','Ù†Ø¸Ù… Ú©ÛŒ Ú©Ù„',0),(78884,2192,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(78885,2192,'vi','Tá»•ng cá»™ng Ä‘Æ¡n hÃ ng',0),(78886,2192,'af','Bestellingstotaal',0),(78887,2192,'ro','Ordine totalÄƒ',0),(78888,2192,'et','Tellimuse kogusumma',0),(78889,2192,'si','Skupnega zneska',0),(78890,2192,'ba','Urutan Total',0),(78891,2192,'nl','Ordertotaal',0),(78892,2192,'fi','Tilauksen',0),(78893,2192,'no','Bestillingstotalen',0),(78894,2192,'da','Samlede ordrebelÃ¸b',0),(78895,2192,'ko','ì£¼ë¬¸ í•©ê³„',0),(78896,2192,'he','×¡×™×›×•× ×”×–×ž× ×”',0),(78897,2192,'el','Î¤Î¿ ÏƒÏ…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(78898,2192,'zh','è®¢å•æ€»è®¡\r\n',0),(78899,2192,'sv','Ordersumman',0),(78900,2192,'it','Totale ordine',0),(78901,2192,'tl','',0),(78902,2192,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(78903,2192,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥à¤²',0),(78904,2192,'ms','Jumlah keseluruhan perintah',0),(78905,2192,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(78906,2192,'fr','Total de la commande',0),(78907,2192,'jp','æ³¨æ–‡å?ˆè¨ˆ',0),(78908,2192,'pt','Ordem Total',0),(78909,2192,'ru','ÐŸÑ€Ð¸ ÑÑƒÐ¼Ð¼Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(78910,2192,'es','Orden Total',0),(78911,2192,'de','Bestellsumme',0),(78912,2192,'en','Order Total',0),(78913,2193,'is','',0),(78914,2193,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø´Ø¯ ',0),(78915,2193,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø´Ø¯ ',0),(78916,2193,'tr','SipariÅŸ baÅŸarÄ±yla izleniyor.',0),(78917,2193,'pl','Aby skutecznie Å›ledzone.',0),(78918,2193,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(78919,2193,'ur','Ø¢Ø±ÚˆØ± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Ø§ Ø³Ø±Ø§Øº Ù„Ú¯Ø§ÛŒØ§ ÛÛ’ Û”',0),(78920,2193,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð°Ñ‚Ð¸Ð»Ð¸.',0),(78921,2193,'vi','TÃ¬m Ä‘Æ¡n hÃ ng thÃ nh cÃ´ng',0),(78922,2193,'af','Bestelling suksesvol opgespoor',0),(78923,2193,'ro','Ordinul urmÄƒritÄƒ cu succes.',0),(78924,2193,'et','Selleks jÃ¤lgitakse edukalt.',0),(78925,2193,'si','Naloga uspeÅ¡no gosenicami.',0),(78926,2193,'ba','Urutan dilacak berhasil.',0),(78927,2193,'nl','Volgorde bijgehouden met succes.',0),(78928,2193,'fi','Jotta jÃ¤ljittÃ¤Ã¤ onnistuneesti.',0),(78929,2193,'no','For sporet vellykket.',0),(78930,2193,'da','Ordren spores korrekt.',0),(78931,2193,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ì  ìˆœì„œìž…ë‹ˆë‹¤.',0),(78932,2193,'he','×”×–×ž× ×” ×œ××ª×¨ ×‘×”×¦×œ×—×”.',0),(78933,2193,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿Ï…Î¸Î¿ÏÎ½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(78934,2193,'zh','è®¢å•è·Ÿè¸ªæˆåŠŸ',0),(78935,2193,'sv','Ordning spÃ¥ras framgÃ¥ngsrikt.',0),(78936,2193,'it','Ordine rilevata correttamente.',0),(78937,2193,'tl','',0),(78938,2193,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(78939,2193,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¤° à¤¨à¤œà¤¼à¤° à¤°à¤–à¥€à¥¤',0),(78940,2193,'ms','Perintah yang dikesan berjaya.',0),(78941,2193,'ar','Ù†Ø¸Ø§Ù… ØªØ¹Ù‚Ø¨ Ø¨Ù†Ø¬Ø§Ø­.',0),(78942,2193,'fr','Ordre suivi avec succÃ¨s.',0),(78943,2193,'jp','æ³¨æ–‡ã?Œãƒˆãƒ©ãƒƒã‚¯ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(78944,2193,'pt','Ordem rastreado com Ãªxito.',0),(78945,2193,'ru','Ð—Ð°ÐºÐ°Ð· ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÑ‡Ð¸Ñ‚Ð°Ð½Ð¾.',0),(78946,2193,'es','Orden rastreado exitosamente',0),(78947,2193,'de','Bestellung erfolgreich verfolgt.',0),(78948,2193,'en','Order tracked successfully.',0),(78949,2194,'is','',0),(78950,2194,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(78951,2194,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(78952,2194,'tr','SipariÅŸ GÃ¼ncelleÅŸtirmesi',0),(78953,2194,'pl','ZamÃ³wienie aktualizacji',0),(78954,2194,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(78955,2194,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(78956,2194,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(78957,2194,'vi','Cáº­p Nháº­t ÄÆ¡n HÃ ng',0),(78958,2194,'af','Bestelling Opdateer',0),(78959,2194,'ro','Comanda Update',0),(78960,2194,'et','Tellimuse uuendamine',0),(78961,2194,'si','Da posodobitev',0),(78962,2194,'ba','Update pesanan',0),(78963,2194,'nl','Volgorde Update',0),(78964,2194,'fi','PÃ¤ivitys',0),(78965,2194,'no','Ordreoppdatering',0),(78966,2194,'da','Ordrevedligeholdelse.',0),(78967,2194,'ko','ì£¼ë¬¸ ì—…ë°ì´íŠ¸',0),(78968,2194,'he','×¢×“×›×•×Ÿ ×”×–×ž× ×”',0),(78969,2194,'el','Î”Î¹Î¬Ï„Î±Î¾Î· Update',0),(78970,2194,'zh','è®¢è´­æ›´æ–°\r\n',0),(78971,2194,'sv','Orderuppdatering',0),(78972,2194,'it','Aggiornamento ordine',0),(78973,2194,'tl','',0),(78974,2194,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(78975,2194,'hi','à¤•à¥à¤°à¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(78976,2194,'ms','Arahan Kemaskini',0),(78977,2194,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù†Ø¸Ø§Ù…',0),(78978,2194,'fr','Mise Ã  jour de la commande',0),(78979,2194,'jp','æ³¨æ–‡ã?®æ›´æ–°',0),(78980,2194,'pt','AtualizaÃ§Ã£o de ordem',0),(78981,2194,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·',0),(78982,2194,'es','Orden Actualizado',0),(78983,2194,'de','Bestellung-Update',0),(78984,2194,'en','Order Update',0),(78985,2195,'is','',0),(78986,2195,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(78987,2195,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(78988,2195,'tr','SipariÅŸ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(78989,2195,'pl','Aby pomyÅ›lnie zaktualizowana',0),(78990,2195,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(78991,2195,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(78992,2195,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(78993,2195,'vi','Cáº­p Nháº­t ÄÆ¡n HÃ ng thÃ nh cÃ´ng',0),(78994,2195,'af','Bestelling suksesvol Opdateer',0),(78995,2195,'ro','Ordinul actualizat cu succes',0),(78996,2195,'et','Tootmistellimuse vÃ¤rskendamine Ãµnnestus',0),(78997,2195,'si','NaroÄilo je uspeÅ¡no posodobljena',0),(78998,2195,'ba','Perintah yang berhasil',0),(78999,2195,'nl','Volgorde bijgewerkt',0),(79000,2195,'fi','Tilauksen pÃ¤ivittÃ¤minen onnistui',0),(79001,2195,'no','For oppdatert',0),(79002,2195,'da','Ordren opdateret',0),(79003,2195,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ìˆœì„œ',0),(79004,2195,'he','×¡×“×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(79005,2195,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± ÎµÎ½Î·Î¼ÎµÏÏ‰Î¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(79006,2195,'zh','è®¢å•æˆåŠŸæ›´æ–°\r\n',0),(79007,2195,'sv','Ordning uppdaterats',0),(79008,2195,'it','Ordine aggiornato con successo',0),(79009,2195,'tl','',0),(79010,2195,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(79011,2195,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(79012,2195,'ms','Perintah yang berjaya dikemas kini',0),(79013,2195,'ar','Ø­Ø¯Ù‘Ø«Øª Ø§Ù„Ø·Ù„Ø¨ÙŠÙ‘Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(79014,2195,'fr','Ordre mis Ã  jour avec succÃ¨s',0),(79015,2195,'jp','æ³¨æ–‡ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(79016,2195,'pt','Ordem atualizado com sucesso',0),(79017,2195,'ru','Ð—Ð°ÐºÐ°Ð· Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(79018,2195,'es','Orden Actualizado Exitosamente',0),(79019,2195,'de','Bestellung erfolgreich aktualisiert',0),(79020,2195,'en','Order Updated Successfully',0),(79021,2196,'is','',0),(79022,2196,'dr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ ',0),(79023,2196,'pr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ ',0),(79024,2196,'tr','SipariÅŸ giriÅŸi',0),(79025,2196,'pl','ZamÃ³wieÅ„.',0),(79026,2196,'bg','Ð’ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(79027,2196,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ Ø§Ù†Ù¹Ø±ÛŒ',0),(79028,2196,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(79029,2196,'vi','Nháº­p Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(79030,2196,'af','Bestellinginskrywing',0),(79031,2196,'ro','Ordine de intrare',0),(79032,2196,'et','Tellimuse kanne',0),(79033,2196,'si','NaroÄila',0),(79034,2196,'ba','Masuk pesanan',0),(79035,2196,'nl','Order Entry',0),(79036,2196,'fi','Tilauksen syÃ¶ttÃ¶',0),(79037,2196,'no','Bestilling',0),(79038,2196,'da','Ordreindtastning',0),(79039,2196,'ko','ì£¼ë¬¸ ìž…ë ¥',0),(79040,2196,'he','Order Entry',0),(79041,2196,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(79042,2196,'zh','å®šå•è¾“å…¥',0),(79043,2196,'sv','OrderlÃ¤ggning',0),(79044,2196,'it','Order Entry',0),(79045,2196,'tl','',0),(79046,2196,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(79047,2196,'hi','à¤•à¥à¤°à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(79048,2196,'ms','Perintah kemasukan',0),(79049,2196,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø£Ù…Ø±',0),(79050,2196,'fr','Saisie des commandes',0),(79051,2196,'jp','æ³¨æ–‡å…¥åŠ›',0),(79052,2196,'pt','Entrada de pedido',0),(79053,2196,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð—Ð°ÐºÐ°Ð·Ð°',0),(79054,2196,'es','Entrada de Orden',0),(79055,2196,'de','Auftragserfassung',0),(79056,2196,'en','Order Entry',0),(79057,2197,'is','',0),(79058,2197,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(79059,2197,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(79060,2197,'tr','Fatura bilgileri',0),(79061,2197,'pl','Inf. o',0),(79062,2197,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(79063,2197,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(79064,2197,'sr','Ð˜Ð½Ñ„Ð¾ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(79065,2197,'vi','ThÃ´ng tin gá»­i hÃ³a Ä‘Æ¡n',0),(79066,2197,'af','Fakturering Info',0),(79067,2197,'ro','Facturare Info',0),(79068,2197,'et','Arve Info',0),(79069,2197,'si','ZaraÄunavanje Info',0),(79070,2197,'ba','Informasi tagihan',0),(79071,2197,'nl','Facturering-Info',0),(79072,2197,'fi','Laskutustiedot',0),(79073,2197,'no','Fakturering Info',0),(79074,2197,'da','Fakturering Info',0),(79075,2197,'ko','ê²°ì œ ì •ë³´',0),(79076,2197,'he','×¤×¨×˜×™ ×—×™×•×‘',0),(79077,2197,'el','Î Î›Î—Î¡ÎŸÎ¦ÎŸÎ¡Î™Î•Î£ Î›ÎŸÎ“Î‘Î¡Î™Î‘Î£ÎœÎŸÎ¥',0),(79078,2197,'zh','å¸å•ä¿¡æ¯',0),(79079,2197,'sv','Fakturainfo',0),(79080,2197,'it','Informazioni di fatturazione',0),(79081,2197,'tl','',0),(79082,2197,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(79083,2197,'hi','à¤¬à¤¿à¤² à¤¸à¤®à¥à¤¬à¤‚à¤§à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(79084,2197,'ms','Bil maklumat',0),(79085,2197,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ÙÙˆØªØ±Ø©',0),(79086,2197,'fr','Infos facturation',0),(79087,2197,'jp','è«‹æ±‚æƒ…å ±',0),(79088,2197,'pt','InformaÃ§Ã£o de faturamento',0),(79089,2197,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°',0),(79090,2197,'es','Info de FacturaciÃ³n',0),(79091,2197,'de','Abrechnung-Info',0),(79092,2197,'en','Billing Info',0),(79093,2198,'is','',0),(79094,2198,'dr','(Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù†',0),(79095,2198,'pr','Ø³ÙØ§Ø±Ø´ (Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù†',0),(79096,2198,'tr','SÄ°PARÄ°Åž',0),(79097,2198,'pl','ZAMÃ“WIENIE',0),(79098,2198,'bg','ÐŸÐžÐ ÐªÐ§ÐšÐ',0),(79099,2198,'ur','ØªØ±ØªÛŒØ¨',0),(79100,2198,'sr','Ð Ð•Ð”ÐžÐ¡Ð›Ð•Ð”',0),(79101,2198,'vi','Äáº·t HÃ ng',0),(79102,2198,'af','BESTELLING',0),(79103,2198,'ro','COMANDA',0),(79104,2198,'et','TELLIMUSE',0),(79105,2198,'si','VRSTNI RED',0),(79106,2198,'ba','URUTAN',0),(79107,2198,'nl','BESTELLING',0),(79108,2198,'fi','TILAUS',0),(79109,2198,'no','REKKEFÃ˜LGE',0),(79110,2198,'da','RÃ†KKEFÃ˜LGE',0),(79111,2198,'ko','ìˆœì„œ',0),(79112,2198,'he','×¡×“×¨',0),(79113,2198,'el','Î Î‘Î¡Î‘Î“Î“Î•Î›ÎŠÎ‘',0),(79114,2198,'zh','å®šå•',0),(79115,2198,'sv','ORDNING',0),(79116,2198,'it','ORDINE',0),(79117,2198,'tl','',0),(79118,2198,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(79119,2198,'hi','à¤†à¤¦à¥‡à¤¶',0),(79120,2198,'ms','PERINTAH',0),(79121,2198,'ar','ØªØ±ØªÙŠØ¨',0),(79122,2198,'fr','ORDRE',0),(79123,2198,'jp','æ³¨æ–‡',0),(79124,2198,'pt','ORDEM',0),(79125,2198,'ru','Ð—ÐÐšÐÐ—',0),(79126,2198,'es','ORDEN',0),(79127,2198,'de','BESTELLUNG',0),(79128,2198,'en','ORDER',0),(79129,2199,'is','',0),(79130,2199,'dr','( Ù…Ø±ØªØ¨ Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(79131,2199,'pr','Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡( Ù…Ø±ØªØ¨ Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(79132,2199,'tr','SipariÅŸ',0),(79133,2199,'pl','ZamÃ³wiÄ‡',0),(79134,2199,'bg','ÐžÑÑŠÐ¶Ð´Ð°',0),(79135,2199,'ur','Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(79136,2199,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸Ð¾',0),(79137,2199,'vi','Äáº·t HÃ ng',0),(79138,2199,'af','Bestel',0),(79139,2199,'ro','Comandat',0),(79140,2199,'et','Tellitud',0),(79141,2199,'si','NaloÅ¾i',0),(79142,2199,'ba','Memerintahkan',0),(79143,2199,'nl','Besteld',0),(79144,2199,'fi','Tilattu',0),(79145,2199,'no','Bestilt',0),(79146,2199,'da','Bestilte',0),(79147,2199,'ko','ì£¼ë¬¸',0),(79148,2199,'he','×”×•×–×ž×Ÿ',0),(79149,2199,'el','Î”Î¹Î­Ï„Î±Î¾Îµ',0),(79150,2199,'zh','å·²å®šè´­',0),(79151,2199,'sv','BestÃ¤llde',0),(79152,2199,'it','Ordinato',0),(79153,2199,'tl','',0),(79154,2199,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(79155,2199,'hi','à¤•à¤¾ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾',0),(79156,2199,'ms','Mengarahkan',0),(79157,2199,'ar','ÙˆØ£Ù…Ø±Øª',0),(79158,2199,'fr','CommandÃ©',0),(79159,2199,'jp','æ³¨æ–‡ã?—ã?¾ã?—ã?Ÿ',0),(79160,2199,'pt','Ordenou',0),(79161,2199,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð¾',0),(79162,2199,'es','Ordenado',0),(79163,2199,'de','Bestellt',0),(79164,2199,'en','Ordered',0),(79165,2200,'is','',0),(79166,2200,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª',0),(79167,2200,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª',0),(79168,2200,'tr','SipariÅŸler',0),(79169,2200,'pl','ZamÃ³wienia',0),(79170,2200,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(79171,2200,'ur','Ø­Ú©Ù…',0),(79172,2200,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ',0),(79173,2200,'vi','Äáº·t HÃ ng',0),(79174,2200,'af','Bestellings',0),(79175,2200,'ro','Comenzi',0),(79176,2200,'et','Tellimused',0),(79177,2200,'si','NaroÄila',0),(79178,2200,'ba','Pesanan',0),(79179,2200,'nl','Bestellingen',0),(79180,2200,'fi','Tilaukset',0),(79181,2200,'no','Bestillinger',0),(79182,2200,'da','Ordrer',0),(79183,2200,'ko','ì£¼ë¬¸',0),(79184,2200,'he','×”×–×ž× ×•×ª',0),(79185,2200,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(79186,2200,'zh','å®šå•',0),(79187,2200,'sv','Order',0),(79188,2200,'it','Ordini',0),(79189,2200,'tl','',0),(79190,2200,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;(SO)',0),(79191,2200,'hi','à¤†à¤¦à¥‡à¤¶',0),(79192,2200,'ms','Perintah-perintah',0),(79193,2200,'ar','Ø§Ù„Ø·Ù„Ø¨ÙŠØ§Øª',0),(79194,2200,'fr','Commandes',0),(79195,2200,'jp','æ³¨æ–‡',0),(79196,2200,'pt','Ordens',0),(79197,2200,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(79198,2200,'es','Pedidos ',0),(79199,2200,'de','Bestellungen',0),(79200,2200,'en','Orders',0),(79201,2201,'is','',0),(79202,2201,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ ',0),(79203,2201,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ ',0),(79204,2201,'tr','DÃ¶nem iÃ§in alÄ±nan sipariÅŸler',0),(79205,2201,'pl','ZamÃ³wienia otrzymane przez okres',0),(79206,2201,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(79207,2201,'ur','ÙˆØµÙˆÙ„ Ú©ÛŒ Ù…Ø¯Øª Ú©Û’ Ù„Ø¦Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø§Ø±ÛŒ',0),(79208,2201,'sr','ÐÐ°Ð»Ð¾Ð·Ð¸ ÐŸÐ Ð˜ÐœÐ‰Ð•ÐÐ˜ Ð·Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(79209,2201,'vi','ÄÆ¡n hÃ ng nháº­n tá»«',0),(79210,2201,'af','Bestellings ONTVANG vir Periode',0),(79211,2201,'ro','Comenzile primite pentru perioada',0),(79212,2201,'et','Aja jooksul saadud tellimused',0),(79213,2201,'si','NaroÄil za obdobje',0),(79214,2201,'ba','Pesanan yang diterima untuk periode',0),(79215,2201,'nl','Bestellingen ontvangen voor de periode',0),(79216,2201,'fi','Kauden tilaukset',0),(79217,2201,'no','Bestillinger for periode',0),(79218,2201,'da','Ordrer modtaget for perioden',0),(79219,2201,'ko','ê¸°ê°„ ë™ì•ˆ ì ‘ìˆ˜ ëœ ì£¼ë¬¸',0),(79220,2201,'he','×”×–×ž× ×•×ª ×©×”×ª×§×‘×œ×• ×œ×ª×§×•×¤×”',0),(79221,2201,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î›Î‘ÎœÎ’Î†ÎÎŸÎÎ¤Î‘Î™ Î³Î¹Î± Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(79222,2201,'zh','æœŸé—´æ”¶åˆ°çš„è®¢å•\r\n',0),(79223,2201,'sv','OrderingÃ¥ngen fÃ¶r perioden',0),(79224,2201,'it','Ordini ricevuti per periodo',0),(79225,2201,'tl','',0),(79226,2201,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(79227,2201,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(79228,2201,'ms','Pesanan yang diterima bagi tempoh',0),(79229,2201,'ar','Ø£ÙˆØ§Ù…Ø± ØªÙ„Ù‚ÙŠ Ù„ÙØªØ±Ø©',0),(79230,2201,'fr','Commandes reÃ§ues pour la pÃ©riode',0),(79231,2201,'jp','æœŸé–“ä¸­ã?«å?—ã?‘ã?Ÿæ³¨æ–‡',0),(79232,2201,'pt','Ordens recebidas por perÃ­odo',0),(79233,2201,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ ÐŸÐžÐ›Ð£Ð§Ð•ÐÐÐ«Ð• Ð·Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(79234,2201,'es','Ordenes RECIBIDOS para el perÃ­odo',0),(79235,2201,'de','Auftragseingang fÃ¼r Zeitraum',0),(79236,2201,'en','Orders RECEIVED for Period',0),(79237,2202,'is','',0),(79238,2202,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ ',0),(79239,2202,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ ',0),(79240,2202,'tr','DÃ¶nem iÃ§in sevk edilen sipariÅŸler',0),(79241,2202,'pl','ZamÃ³wienia wysyÅ‚ane przez okres',0),(79242,2202,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð•ÐšÐ¡ÐŸÐ•Ð”Ð˜Ð ÐÐÐ˜ Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(79243,2202,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ù…Ø¯Øª Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(79244,2202,'sr','ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÐºÐ¾Ñ˜Ðµ ÑÐµ Ð¨ÐÐ‰Ð£ Ð·Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(79245,2202,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ chuyá»ƒn tá»«',0),(79246,2202,'af','Bestellings VERSEND vir Periode',0),(79247,2202,'ro','Comenzile expediate pentru perioada',0),(79248,2202,'et','Aja jooksul lÃ¤hetatud tellimuste',0),(79249,2202,'si','Nalogi DOBAVLJENI za obdobje',0),(79250,2202,'ba','Pesanan dikirim untuk periode',0),(79251,2202,'nl','Orders die zijn verzonden gedurende',0),(79252,2202,'fi','Ajan tilauksia',0),(79253,2202,'no','Ordrer for periode',0),(79254,2202,'da','Ordrer afsendt for perioden',0),(79255,2202,'ko','ê¸°ê°„ ë™ì•ˆ ì„ ì  ëœ ì£¼ë¬¸',0),(79256,2202,'he','×”×–×ž× ×•×ª ×©× ×©×œ×—×• ×œ×ª×§×•×¤×”',0),(79257,2202,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î£Î¤Î†Î›Î˜Î—ÎšÎ‘Î Î³Î¹Î± Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(79258,2202,'zh','æœŸé—´å‘è´§çš„è®¢å•\r\n',0),(79259,2202,'sv','BestÃ¤llningar levereras fÃ¶r perioden',0),(79260,2202,'it','Ordini inviati per periodo',0),(79261,2202,'tl','',0),(79262,2202,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(79263,2202,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(79264,2202,'ms','Pesanan yang dihantar bagi tempoh',0),(79265,2202,'ar','Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ù„Ù„ÙØªØ±Ø©',0),(79266,2202,'fr','Commandes expÃ©diÃ©es pour la pÃ©riode',0),(79267,2202,'jp','æœŸé–“ä¸­ã?«ç™ºé€?ã?—ã?Ÿæ³¨æ–‡',0),(79268,2202,'pt','Pedidos enviados por perÃ­odo',0),(79269,2202,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ ÐžÐ¢ÐŸÐ ÐÐ’Ð›Ð•ÐÐÐ«Ð• Ð·Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(79270,2202,'es','Ordenes Enviados para el perÃ­odo',0),(79271,2202,'de','Bestellungen fÃ¼r Zeitraum',0),(79272,2202,'en','Orders SHIPPED for Period',0),(79273,2203,'is','',0),(79274,2203,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(79275,2203,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(79276,2203,'tr','SipariÅŸleri faturalar iÃ§in',0),(79277,2203,'pl','ZamÃ³wienia do faktury',0),(79278,2203,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(79279,2203,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©Ø±Ù†Û’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(79280,2203,'sr','ÐÐ°Ð»Ð¾Ð·Ð¸Ð¼Ð° , Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð°',0),(79281,2203,'vi','ÄÆ¡n hÃ ng ra hÃ³a Ä‘Æ¡n',0),(79282,2203,'af','Bestellings na Fakture',0),(79283,2203,'ro','Ordinele de facturi',0),(79284,2203,'et','Arved tellimuste',0),(79285,2203,'si','NaroÄila za raÄune',0),(79286,2203,'ba','Perintah untuk faktur',0),(79287,2203,'nl','Bestellingen tot facturen',0),(79288,2203,'fi','Tilaukset laskuihin',0),(79289,2203,'no','Ordrer til fakturaer',0),(79290,2203,'da','Ordrer til fakturaer',0),(79291,2203,'ko','ì£¼ë¬¸ ì†¡ìž¥',0),(79292,2203,'he','×”×–×ž× ×•×ª ×œ×—×©×‘×•× ×™×•×ª',0),(79293,2203,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÏƒÏ„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(79294,2203,'zh','è®¢å•çš„å‘ç¥¨\r\n',0),(79295,2203,'sv','Order att fakturor',0),(79296,2203,'it','Ordini alle fatture',0),(79297,2203,'tl','',0),(79298,2203,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3611;&#3626;&#3641;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(79299,2203,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(79300,2203,'ms','Pesanan untuk invois',0),(79301,2203,'ar','Ø£ÙˆØ§Ù…Ø± Ù„Ù„ÙÙˆØ§ØªÙŠØ±',0),(79302,2203,'fr','Ordres de factures',0),(79303,2203,'jp','è«‹æ±‚ã?™ã‚‹æ³¨æ–‡',0),(79304,2203,'pt','Ordens de facturas',0),(79305,2203,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ðº Ð¡Ñ‡ÐµÑ‚Ð°Ð¼',0),(79306,2203,'es','Ordenes a Facturas',0),(79307,2203,'de','Bestellungen, Rechnungen',0),(79308,2203,'en','Orders to Invoices',0),(79309,2204,'is','',0),(79310,2204,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡ Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(79311,2204,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡ Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(79312,2204,'tr','Faturalar transfer emirleri',0),(79313,2204,'pl','ZamÃ³wienia zostaÅ‚yby przeniesione do faktury',0),(79314,2204,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÐµÐ½Ð¸ Ð² Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(79315,2204,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª ÙˆØ¨Ø¬Ù„ÛŒ Ù…ÛŒÚº Ù…Ù†ØªÙ‚Ù„ Ú©Ø± Ø¯ÛŒØ§',0),(79316,2204,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð¿Ñ€ÐµÐ±Ð°Ñ†Ð¸Ð¾ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð°',0),(79317,2204,'vi','ÄÆ¡n hÃ ng chuyá»ƒn sang hÃ³a Ä‘Æ¡n',0),(79318,2204,'af','Bestellings Oorgedra na Fakture',0),(79319,2204,'ro','Comenzi transferat Ã®n facturi',0),(79320,2204,'et','Ãœle arvete tellimuste',0),(79321,2204,'si','NaroÄila, ki se prenese v raÄunih',0),(79322,2204,'ba','Pesanan yang ditransfer ke faktur',0),(79323,2204,'nl','Bestellingen in facturen overgedragen',0),(79324,2204,'fi','Tilaus siirtyy edelleen laskuiksi',0),(79325,2204,'no','Ordrer overfÃ¸res til fakturaer',0),(79326,2204,'da','Ordrer overfÃ¸res til fakturaer',0),(79327,2204,'ko','ì£¼ë¬¸ ì†¡ìž¥ ì „ì†¡',0),(79328,2204,'he','×”×¤×§×•×“×•×ª ×”×•×¢×‘×¨×• ×œ×—×©×‘×•× ×™×•×ª',0),(79329,2204,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î¼ÎµÏ„Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹ ÏƒÏ„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(79330,2204,'zh','è®¢å•åˆ°å‘ç¥¨è½¬\r\n',0),(79331,2204,'sv','Order Ã¶verfÃ¶rs till fakturor',0),(79332,2204,'it','Ordini trasferiti in fatture',0),(79333,2204,'tl','',0),(79334,2204,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3650;&#3629;&#3609;&#3652;&#3611;&#3626;&#3641;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(79335,2204,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¤à¤¬à¤¾à¤¦à¤²à¤¾ à¤†à¤¦à¥‡à¤¶',0),(79336,2204,'ms','Perintah-perintah yang dipindahkan ke dalam invois',0),(79337,2204,'ar','Ø£ÙˆØ§Ù…Ø± Ù†Ù‚Ù„ Ø¥Ù„Ù‰ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(79338,2204,'fr','Commandes transfÃ©rÃ©es dans les factures',0),(79339,2204,'jp','è«‹æ±‚æ›¸ã?«ç§»ã?•ã‚Œã?Ÿæ³¨æ–‡',0),(79340,2204,'pt','Ordens transferidas para facturas',0),(79341,2204,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð¿ÐµÑ€ÐµÐ´Ð°Ð½Ñ‹ Ð² ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(79342,2204,'es','Ordenes Transferidos a Facturas',0),(79343,2204,'de','Bestellungen, die in Rechnungen Ã¼bertragen',0),(79344,2204,'en','Orders Transferred into Invoices',0),(79345,2205,'is','',0),(79346,2205,'dr','Ù†ÙˆØ¹ Ø³ÙØ§Ø±Ø´ ',0),(79347,2205,'pr','Ù†ÙˆØ¹ Ø³ÙØ§Ø±Ø´ ',0),(79348,2205,'tr','SipariÅŸ tipi',0),(79349,2205,'pl','Typ zamÃ³wienia',0),(79350,2205,'bg','Ð’Ð¸Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(79351,2205,'ur','Ø­Ú©Ù… Ù‚Ø³Ù…',0),(79352,2205,'sr','Ð’Ñ€ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(79353,2205,'vi','Loáº¡i Ä‘Æ¡n hÃ ng',0),(79354,2205,'af','Bestelling Tipe',0),(79355,2205,'ro','Ordinea tip',0),(79356,2205,'et','Tellimuse tÃ¼Ã¼p',0),(79357,2205,'si','Vrsto naloga',0),(79358,2205,'ba','Jenis order',0),(79359,2205,'nl','Ordetype',0),(79360,2205,'fi','Tilauksen tyyppi',0),(79361,2205,'no','Ordretypen',0),(79362,2205,'da','Ordretype',0),(79363,2205,'ko','ì£¼ë¬¸ íƒ€ìž…',0),(79364,2205,'he','×˜×™×¤×•×¡ ×¡×“×¨',0),(79365,2205,'el','Î¤ÏÏ€Î¿Ï… ÎµÎ½Ï„Î¿Î»Î®Ï‚',0),(79366,2205,'zh','è®¢å•ç±»åž‹\r\n',0),(79367,2205,'sv','Ordertypen',0),(79368,2205,'it','Tipo di ordine',0),(79369,2205,'tl','',0),(79370,2205,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(79371,2205,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(79372,2205,'ms','Jenis perintah',0),(79373,2205,'ar','Ù†ÙˆØ¹ Ø§Ù„ØªØ±ØªÙŠØ¨',0),(79374,2205,'fr','Type de commande',0),(79375,2205,'jp','æ³¨æ–‡ã‚¿ã‚¤ãƒ—',0),(79376,2205,'pt','Tipo de ordem',0),(79377,2205,'ru','Ð¢Ð¸Ð¿ Ð—Ð°ÐºÐ°Ð·Ð°',0),(79378,2205,'es','Tipo de Orden',0),(79379,2205,'de','Auftragsart',0),(79380,2205,'en','Order Type',0),(79381,2206,'is','',0),(79382,2206,'dr','Ø§ØµÙ„ ',0),(79383,2206,'pr','Ø§ØµÙ„ ',0),(79384,2206,'tr','Ã–zgÃ¼n',0),(79385,2206,'pl','OryginaÅ‚',0),(79386,2206,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÐµÐ½',0),(79387,2206,'ur','Ø§ØµÙ„',0),(79388,2206,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸',0),(79389,2206,'vi','NguyÃªn báº£n',0),(79390,2206,'af','Oorspronklik',0),(79391,2206,'ro','Original',0),(79392,2206,'et','Originaal',0),(79393,2206,'si','Original',0),(79394,2206,'ba','Asli',0),(79395,2206,'nl','Origineel',0),(79396,2206,'fi','AlkuperÃ¤inen',0),(79397,2206,'no','Opprinnelige',0),(79398,2206,'da','Oprindelige',0),(79399,2206,'ko','ì›ë¬¸ ì–¸ì–´',0),(79400,2206,'he','×ž×§×•×¨×™',0),(79401,2206,'el','Î‘ÏÏ‡Î¹ÎºÎ®',0),(79402,2206,'zh','åŽŸä»¶\r\n',0),(79403,2206,'sv','Ursprungliga',0),(79404,2206,'it','Originale',0),(79405,2206,'tl','',0),(79406,2206,'th','&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;',0),(79407,2206,'hi','à¤®à¥‚à¤²',0),(79408,2206,'ms','Asal',0),(79409,2206,'ar','Ø§Ù„Ù„ØºØ© Ø§Ù„Ø£ØµÙ„ÙŠØ©',0),(79410,2206,'fr','Langue source',0),(79411,2206,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«',0),(79412,2206,'pt','Original',0),(79413,2206,'ru','Ð˜ÑÑ…Ð¾Ð´Ð½Ñ‹Ð¹ Ñ‚ÐµÐºÑÑ‚',0),(79414,2206,'es','Original',0),(79415,2206,'de','Original',0),(79416,2206,'en','Original',0),(79417,2207,'is','',0),(79418,2207,'dr','(Ù‚Ø³Ø·) Ø§ÙˆÙ„ÙŠÙ‡',0),(79419,2207,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª(Ù‚Ø³Ø·) Ø§ÙˆÙ„ÙŠÙ‡',0),(79420,2207,'tr','Orijinal Ã¶deme',0),(79421,2207,'pl','Oryginalny pÅ‚atnoÅ›ci',0),(79422,2207,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÐµÐ½ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(79423,2207,'ur','Ø§ØµÙ„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(79424,2207,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(79425,2207,'vi','Thanh toÃ¡n gá»‘c',0),(79426,2207,'af','Oorsponklike Betaling',0),(79427,2207,'ro','Plata iniÅ£ialÄƒ',0),(79428,2207,'et','Algse makse',0),(79429,2207,'si','Original plaÄilo',0),(79430,2207,'ba','Pembayaran asli',0),(79431,2207,'nl','Oorspronkelijke betaling',0),(79432,2207,'fi','AlkuperÃ¤istÃ¤ maksua',0),(79433,2207,'no','Opprinnelige betalingen',0),(79434,2207,'da','Oprindelige betaling',0),(79435,2207,'ko','ì›ëž˜ ì§€ë¶ˆ',0),(79436,2207,'he','×ª×©×œ×•× ×ž×§×•×¨×™',0),(79437,2207,'el','Î‘ÏÏ‡Î¹ÎºÎ® Ï€Î»Î·ÏÏ‰Î¼Î®',0),(79438,2207,'zh','åŽŸå§‹ä»˜æ¬¾\r\n',0),(79439,2207,'sv','Ursprungliga betalningen',0),(79440,2207,'it','Pagamento originale',0),(79441,2207,'tl','',0),(79442,2207,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3604;&#3633;&#3657;&#3591;&#3648;&#3604;&#3636;&#3617;',0),(79443,2207,'hi','à¤®à¥‚à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(79444,2207,'ms','Bayaran asal',0),(79445,2207,'ar','Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø£ØµÙ„ÙŠ',0),(79446,2207,'fr','Paiement original',0),(79447,2207,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«æ”¯æ‰•ã?„',0),(79448,2207,'pt','Pagamento original',0),(79449,2207,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(79450,2207,'es','Pago Original',0),(79451,2207,'de','UrsprÃ¼ngliche Zahlung',0),(79452,2207,'en','Original Payment',0),(79453,2208,'is','',0),(79454,2208,'dr','Ø¯ÙŠÚ¯Ø±',0),(79455,2208,'pr','Ø¯ÙŠÚ¯Ø±',0),(79456,2208,'tr','DiÄŸer',0),(79457,2208,'pl','Inne',0),(79458,2208,'bg','Ð”Ñ€ÑƒÐ³Ð¸',0),(79459,2208,'ur','Ø¯ÛŒÚ¯Ø±',0),(79460,2208,'sr','Ð”Ñ€ÑƒÐ³Ðµ',0),(79461,2208,'vi','KhÃ¡c',0),(79462,2208,'af','Ander',0),(79463,2208,'ro','Alte',0),(79464,2208,'et','Muu',0),(79465,2208,'si','Drugih',0),(79466,2208,'ba','Lainnya',0),(79467,2208,'nl','Andere',0),(79468,2208,'fi','Muut',0),(79469,2208,'no','Andre',0),(79470,2208,'da','Andre',0),(79471,2208,'ko','ë‹¤ë¥¸',0),(79472,2208,'he','××—×¨',0),(79473,2208,'el','Î†Î»Î»ÎµÏ‚',0),(79474,2208,'zh','å…¶ä»–\r\n',0),(79475,2208,'sv','Andra',0),(79476,2208,'it','Altri',0),(79477,2208,'tl','',0),(79478,2208,'th','&#3629;&#3639;&#3656;&#3609;',0),(79479,2208,'hi','à¤…à¤¨à¥à¤¯',0),(79480,2208,'ms','Lain-lain',0),(79481,2208,'ar','Ø£Ø®Ø±Ù‰',0),(79482,2208,'fr','Autres',0),(79483,2208,'jp','ä»–',0),(79484,2208,'pt','Outros',0),(79485,2208,'ru','Ð”Ñ€ÑƒÐ³Ð¾Ð¹',0),(79486,2208,'es','Otro',0),(79487,2208,'de','Andere',0),(79488,2208,'en','Other',0),(79489,2209,'is','',0),(79490,2209,'dr','(ØªØ®ÙÙŠÙ Ù‡Ø§',0),(79491,2209,'pr','Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø´Ù‡Ø§ (ØªØ®ÙÙŠÙ Ù‡Ø§',0),(79492,2209,'tr','DiÄŸer kesim',0),(79493,2209,'pl','Inne ciÄ™cie',0),(79494,2209,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ñ€ÑÐ·Ð°Ð½Ðµ',0),(79495,2209,'ur','Ø¯ÛŒÚ¯Ø± Ú©Ø§Ù¹Ù†Û’',0),(79496,2209,'sr','Ð”Ñ€ÑƒÐ³Ðµ Ñ€ÐµÐ·Ð°ÑšÐ°',0),(79497,2209,'vi','Cáº¯t KhÃ¡c',0),(79498,2209,'af','Ander sny',0),(79499,2209,'ro','Alte tÄƒiere',0),(79500,2209,'et','Muu raie',0),(79501,2209,'si','Drugih rezanje',0),(79502,2209,'ba','Pemotongan lain',0),(79503,2209,'nl','Andere snijden',0),(79504,2209,'fi','Muilla leikkaavilla',0),(79505,2209,'no','Andre kutte',0),(79506,2209,'da','Andre skÃ¦re',0),(79507,2209,'ko','ë‹¤ë¥¸ ì ˆë‹¨',0),(79508,2209,'he','×—×™×ª×•×š ××—×¨×™×',0),(79509,2209,'el','Î†Î»Î»Î± ÎºÎ¿Ï€Î®Ï‚',0),(79510,2209,'zh','å…¶å®ƒå‰Šå‡\r\n',0),(79511,2209,'sv','Andra skÃ¤r',0),(79512,2209,'it','Altro taglio',0),(79513,2209,'tl','',0),(79514,2209,'th','&#3585;&#3634;&#3619;&#3605;&#3633;&#3604;&#3629;&#3639;&#3656;&#3609;',0),(79515,2209,'hi','à¤…à¤¨à¥à¤¯ à¤•à¤¾à¤Ÿà¤¨à¥‡',0),(79516,2209,'ms','Mengurangkan lain-lain',0),(79517,2209,'ar','Ø§Ù„Ù‚Ø·Ø¹ Ø§Ù„Ø£Ø®Ø±Ù‰',0),(79518,2209,'fr','Autre coupe',0),(79519,2209,'jp','ä»–ã?®å€¤ä¸‹ã?’',0),(79520,2209,'pt','Outro corte',0),(79521,2209,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ñ€ÐµÐ·ÐºÐ¸',0),(79522,2209,'es','Otro Recorte',0),(79523,2209,'de','Andere schneiden',0),(79524,2209,'en','Other Cutting',0),(79525,2210,'is','',0),(79526,2210,'dr','Ø¯Ø±Ø¢Ù…Ø¯Ù‡Ø§ Ùˆ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯ÙŠÚ¯Ø±',0),(79527,2210,'pr','Ø¯Ø±Ø¢Ù…Ø¯Ù‡Ø§ Ùˆ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯ÙŠÚ¯Ø±',0),(79528,2210,'tr','DiÄŸer gelir ve gider',0),(79529,2210,'pl','Innych przychodÃ³w i kosztÃ³w',0),(79530,2210,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸ Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(79531,2210,'ur','Ø¯ÛŒÚ¯Ø± Ø¢Ù…Ø¯Ù†ÛŒ Ø§ÙˆØ± Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(79532,2210,'sr','Ð”Ñ€ÑƒÐ³Ð¸Ñ… Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð° Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(79533,2210,'vi','Chi phÃ­ & thu nháº­p KhÃ¡c',0),(79534,2210,'af','Ander Inkomste en Uitgawes',0),(79535,2210,'ro','Alte venituri ÅŸi cheltuieli',0),(79536,2210,'et','Muud tulud ja kulud',0),(79537,2210,'si','Drugih prihodkov in odhodkov',0),(79538,2210,'ba','Pendapatan dan pengeluaran lainnya',0),(79539,2210,'nl','Overige baten en lasten',0),(79540,2210,'fi','Muut tuotot ja kulut',0),(79541,2210,'no','Andre inntekter og kostnader',0),(79542,2210,'da','Andre indtÃ¦gter og omkostninger',0),(79543,2210,'ko','ë‹¤ë¥¸ ì†Œë“ê³¼ ë¹„ìš©',0),(79544,2210,'he','××—×¨ ×”×”×›× ×¡×•×ª ×•×”×”×•×¦××•×ª',0),(79545,2210,'el','Î†Î»Î»Î± Î­ÏƒÎ¿Î´Î± ÎºÎ±Î¹ Î­Î¾Î¿Î´Î±',0),(79546,2210,'zh','å…¶ä»–æ”¶å…¥å’Œæ”¯å‡º\r\n',0),(79547,2210,'sv','Andra intÃ¤kter och kostnader',0),(79548,2210,'it','Altri proventi ed oneri',0),(79549,2210,'tl','',0),(79550,2210,'th','&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3649;&#3621;&#3632;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3629;&#3639;&#3656;&#3609;',0),(79551,2210,'hi','à¤…à¤¨à¥à¤¯ à¤†à¤¯ à¤”à¤° à¤µà¥à¤¯à¤¯',0),(79552,2210,'ms','Lain-lain pendapatan dan perbelanjaan',0),(79553,2210,'ar','Ù…ØµØ±ÙˆÙØ§Øª Ùˆ Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø£Ø®Ø±Ù‰',0),(79554,2210,'fr','Autres revenus et dÃ©penses',0),(79555,2210,'jp','ä»–ã?®å?Žå…¥ã?¨çµŒè²»',0),(79556,2210,'pt','Outros rendimentos e gastos',0),(79557,2210,'ru','ÐŸÑ€Ð¾Ñ‡Ð¸Ðµ Ð´Ð¾Ñ…Ð¾Ð´Ñ‹ Ð¸ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(79558,2210,'es','Otro Ingreso y Gasto',0),(79559,2210,'de','Sonstige Aufwendungen und ErtrÃ¤ge',0),(79560,2210,'en','Other Income and Expense',0),(79561,2211,'is','',0),(79562,2211,'dr','Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù„Ø§ ',0),(79563,2211,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù„Ø§ ',0),(79564,2211,'tr','YukarÄ±daki miktar bitti',0),(79565,2211,'pl','ponad powyÅ¼ej iloÅ›Ä‡',0),(79566,2211,'bg','Ð½Ð°Ð´ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(79567,2211,'ur','Ù‚ÛŒ Ú©Û’ Ø§ÙˆÙ¾Ø± Ø§ÛŒÚ© Ø§ÙˆÙˆØ±',0),(79568,2211,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¾ Ð¸Ð·Ð½Ð°Ð´ ÐšÐ¾Ð».',0),(79569,2211,'vi','quÃ¡ sá»‘ lÆ°á»£ng trÃªn',0),(79570,2211,'af','oor bogenoemde qty',0),(79571,2211,'ro','peste deasupra cantit',0),(79572,2211,'et','Ã¼le Ã¼le kogus',0),(79573,2211,'si','nad nad kol.',0),(79574,2211,'ba','lebih di atas qty',0),(79575,2211,'nl','over boven qty',0),(79576,2211,'fi','yli edellÃ¤ mÃ¤Ã¤rÃ¤',0),(79577,2211,'no','over over antall',0),(79578,2211,'da','over ovenfor qty',0),(79579,2211,'ko','qty ìœ„ ì´ìƒ',0),(79580,2211,'he','×ž×¢×œ ×ž×¢×œ ×›×ž×•×ª',0),(79581,2211,'el','Ï€Î¬Î½Ï‰ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Ï„Î¿ qty',0),(79582,2211,'zh','è¶…è¿‡ä¸Šè¿°æ•°é‡\r\n',0),(79583,2211,'sv','Ã¶ver ovan Kvt',0),(79584,2211,'it','over sopra qty',0),(79585,2211,'tl','',0),(79586,2211,'th','&#3648;&#3585;&#3636;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3657;&#3634;&#3591;&#3610;&#3609;',0),(79587,2211,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤Šà¤ªà¤°',0),(79588,2211,'ms','lebih ke atas qty',0),(79589,2211,'ar','Ø£ÙƒØ«Ø± Ø£Ø¹Ù„Ø§Ù‡ qty',0),(79590,2211,'fr','plus ci-dessus QtÃ©',0),(79591,2211,'jp','ä¸Šè¨˜æ•°é‡?ä»¥ä¸Š',0),(79592,2211,'pt','mais acima qty',0),(79593,2211,'ru','Ð±Ð¾Ð»ÐµÐµ Ð²Ñ‹ÑˆÐµ ÐšÐ¾Ð»-Ð²Ð¾',0),(79594,2211,'es','MÃ¡s que la cant. arriba',0),(79595,2211,'de','Ã¼ber oben qty',0),(79596,2211,'en','over above qty',0),(79597,2212,'is','',0),(79598,2212,'dr','Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù„Ø§ ',0),(79599,2212,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù„Ø§ ',0),(79600,2212,'tr','AÅŸÄ±rÄ± miktarda yukarÄ±da',0),(79601,2212,'pl','Ponad powyÅ¼ej iloÅ›ci',0),(79602,2212,'bg','ÐÐ°Ð´ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(79603,2212,'ur','Ø²ÛŒØ§Ø¯Û Ù…Ù‚Ø¯Ø§Ø± Ú©Û’ Ø§ÙˆÙ¾Ø±',0),(79604,2212,'sr','ÐŸÑ€ÐµÐºÐ¾ , Ð¸Ð·Ð½Ð°Ð´ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(79605,2212,'vi','QuÃ¡ sá»‘ lÆ°á»£ng trÃªn',0),(79606,2212,'af','Oor bogenoemde hoeveelhede',0),(79607,2212,'ro','Peste cantitÄƒÈ›ile de mai sus',0),(79608,2212,'et','Eespool nimetatud koguste Ã¼le',0),(79609,2212,'si','Nad nad koliÄine',0),(79610,2212,'ba','Lebih di atas jumlah',0),(79611,2212,'nl','Over boven hoeveelheden',0),(79612,2212,'fi','Yli mÃ¤Ã¤riÃ¤ edellÃ¤',0),(79613,2212,'no','Over over antall',0),(79614,2212,'da','Over ovennÃ¦vnte mÃ¦ngder',0),(79615,2212,'ko','ìˆ˜ëŸ‰ ì´ìƒ ì´ìƒ',0),(79616,2212,'he','×ž×¢×œ ×ž×¢×œ ×›×ž×•×™×•×ª',0),(79617,2212,'el','Î Î¬Î½Ï‰ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Ï„Î¹Ï‚ Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚',0),(79618,2212,'zh','è¶…è¿‡ä»¥ä¸Šæ•°é‡\r\n',0),(79619,2212,'sv','Ã–ver ovan kvantiteter',0),(79620,2212,'it','Over sopra la quantitÃ ',0),(79621,2212,'tl','',0),(79622,2212,'th','&#3648;&#3585;&#3636;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3657;&#3634;&#3591;&#3610;&#3609;',0),(79623,2212,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤Šà¤ªà¤°',0),(79624,2212,'ms','Lebih ke atas kuantiti yang',0),(79625,2212,'ar','Ø£ÙƒØ«Ø± Ø£Ø¹Ù„Ø§Ù‡ ÙƒÙ…ÙŠØ§Øª',0),(79626,2212,'fr','Plus de quantitÃ©s ci-dessus',0),(79627,2212,'jp','ä¸Šè¨˜æ•°é‡?ä»¥ä¸Š',0),(79628,2212,'pt','Mais acima as quantidades',0),(79629,2212,'ru','Ð‘Ð¾Ð»ÐµÐµ Ð²Ñ‹ÑˆÐµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(79630,2212,'es','MÃ¡s que las cantidades arriba',0),(79631,2212,'de','Mehr Ã¼ber Mengen',0),(79632,2212,'en','Over Above Quantities',0),(79633,2213,'is','',0),(79634,2213,'dr','Ø­Ø¯Ø§Ø«Ø± Ø­Ù‚ÙˆÙ‚ Ø¨ÙŠØ´ØªØ± Ø´Ø¯',0),(79635,2213,'pr','Ø­Ø¯Ø§Ø«Ø± Ø­Ù‚ÙˆÙ‚ Ø¨ÙŠØ´ØªØ± Ø´Ø¯',0),(79636,2213,'tr','Maksimum Ã¶deme aÅŸÄ±ldÄ±',0),(79637,2213,'pl','Maksymalne wynagrodzenia przekroczyÅ‚a',0),(79638,2213,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¾Ñ‚Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ²Ð¸ÑˆÐ°Ð²Ð°',0),(79639,2213,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ØªÙ†Ø®ÙˆØ§Û Ø³Û’ Ù…ØªØ¬Ø§ÙˆØ²',0),(79640,2213,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ñ€ÐµÐ¼Ð°ÑˆÐ¸Ð¾',0),(79641,2213,'vi','VÆ°á»›t quÃ¡ má»©c Thanh toÃ¡n tá»‘i Ä‘a ',0),(79642,2213,'af','Maksimum Besoldiging Oorskry',0),(79643,2213,'ro','Plata maximÄƒ depÄƒÅŸitÄƒ',0),(79644,2213,'et','Ãœletanud maksimaalse tasu',0),(79645,2213,'si','NajveÄje plaÄilo preseÅ¾ena',0),(79646,2213,'ba','Membayar maksimum melebihi',0),(79647,2213,'nl','Maximale Pay overschreden',0),(79648,2213,'fi','YlittÃ¤Ã¤ EnimmÃ¤ispalkan',0),(79649,2213,'no','Maksimal lÃ¸nn overskredet',0),(79650,2213,'da','Maksimal lÃ¸n overskredet',0),(79651,2213,'ko','ìµœëŒ€ ì§€ë¶ˆ ì´ˆê³¼',0),(79652,2213,'he','×”×ª×©×œ×•× ×”×ž×¨×‘×™ ×—×¨×™×’×”',0),(79653,2213,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Î±Î¼Î¿Î¹Î²Î® Ï…Ï€Î­ÏÎ²Î±ÏƒÎ·',0),(79654,2213,'zh','é¡¶è–ªè¶…å‡º\r\n',0),(79655,2213,'sv','HÃ¶gsta lÃ¶nen Ã¶versteg',0),(79656,2213,'it','Retribuzione massima superata',0),(79657,2213,'tl','',0),(79658,2213,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3585;&#3623;&#3656;&#3634;',0),(79659,2213,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤µà¥‡à¤¤à¤¨ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¹à¥‹ à¤—à¤ˆ',0),(79660,2213,'ms','Gaji maksimum melebihi',0),(79661,2213,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø£Ù‚ØµÙ‰ ØªØ¬Ø§ÙˆØ²Øª',0),(79662,2213,'fr','IndemnitÃ© maximale dÃ©passÃ©e',0),(79663,2213,'jp','æœ€å¤§çµ¦æ–™ã‚’è¶…ã?ˆã?¦ã?„ã?¾ã?™',0),(79664,2213,'pt','Pagamento mÃ¡ximo excedido',0),(79665,2213,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ð° Ð¿Ñ€ÐµÐ²Ñ‹ÑˆÐµÐ½Ð¸Ñ',0),(79666,2213,'es','Se ExcediÃ³ el Pago MÃ¡ximo',0),(79667,2213,'de','Maximale Pay Ã¼berschritten',0),(79668,2213,'en','Maximum Pay Exceeded',0),(79669,2214,'is','',0),(79670,2214,'dr','Ø³Ø±Ø¨Ø§Ø±',0),(79671,2214,'pr','Ø³Ø±Ø¨Ø§Ø±',0),(79672,2214,'tr','TepegÃ¶z',0),(79673,2214,'pl','ObciÄ…Å¼enie',0),(79674,2214,'bg','Ð ÐµÐ¶Ð¸Ð¹Ð½Ð¸',0),(79675,2214,'ur','ÛÛŒÚˆ',0),(79676,2214,'sr','Ð˜Ð½Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(79677,2214,'vi','HÃ nh chÃ­nh Sá»± nghiá»‡p',0),(79678,2214,'af','Oorhoofs',0),(79679,2214,'ro','Aeriene',0),(79680,2214,'et','Ãœldkulu',0),(79681,2214,'si','ReÅ¾ijske stroÅ¡ke',0),(79682,2214,'ba','Overhead',0),(79683,2214,'nl','Overhead',0),(79684,2214,'fi','YlÃ¤puolella',0),(79685,2214,'no','Overhead',0),(79686,2214,'da','Overhead',0),(79687,2214,'ko','ì˜¤ë²„ í—¤ë“œ',0),(79688,2214,'he','×ª×§×•×¨×”',0),(79689,2214,'el','Î“ÎµÎ½Î¹ÎºÎ¬',0),(79690,2214,'zh','é—´æŽ¥è´¹ç”¨\r\n',0),(79691,2214,'sv','Overhead',0),(79692,2214,'it','Lavagna',0),(79693,2214,'tl','',0),(79694,2214,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3651;&#3609;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;',0),(79695,2214,'hi','à¤­à¥‚à¤®à¤¿ à¤•à¥‡ à¤Šà¤ªà¤°',0),(79696,2214,'ms','Overhed',0),(79697,2214,'ar','Ø§Ù„Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø©',0),(79698,2214,'fr','Frais gÃ©nÃ©raux',0),(79699,2214,'jp','è«¸çµŒè²»',0),(79700,2214,'pt','Sobrecarga',0),(79701,2214,'ru','ÐÐ°ÐºÐ»Ð°Ð´Ð½Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(79702,2214,'es','Costos Operativos',0),(79703,2214,'de','Aufwand',0),(79704,2214,'en','Overhead',0),(79705,2215,'is','',0),(79706,2215,'dr','Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(79707,2215,'pr','Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(79708,2215,'tr','Fazla Ã¶deme',0),(79709,2215,'pl','NadpÅ‚aty',0),(79710,2215,'bg','ÐÐ°Ð´Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾',0),(79711,2215,'ur','Ø§ÙˆÙˆØ±Ù¾ÛŒÙ…Ø§Ù†Ù¹',0),(79712,2215,'sr','ÐŸÑ€ÐµÐºÐ¾Ð¼ÐµÑ€Ð½Ñƒ',0),(79713,2215,'vi','Tráº£ quÃ¡',0),(79714,2215,'af','Oorbetaling',0),(79715,2215,'ro','SumÄƒ suplimentarÄƒ',0),(79716,2215,'et','Enammaksed',0),(79717,2215,'si','PreplaÄilo',0),(79718,2215,'ba','Kelebihan pembayaran',0),(79719,2215,'nl','Overbetaling',0),(79720,2215,'fi','Liikaa',0),(79721,2215,'no','Overbetalingen',0),(79722,2215,'da','Overbetaling',0),(79723,2215,'ko','Overpayment',0),(79724,2215,'he','×ª×©×œ×•× ×™×ª×¨',0),(79725,2215,'el','Î‘Ï‡ÏÎµÏ‰ÏƒÏ„Î®Ï„Ï‰Ï‚ ÎºÎ±Ï„Î±Î²Î»Î·Î¸Î­Î½Ï„Î¿Ï‚',0),(79726,2215,'zh','å¤šç¼´\r\n',0),(79727,2215,'sv','Ã–verbetalning',0),(79728,2215,'it','Pagamento in eccesso',0),(79729,2215,'tl','',0),(79730,2215,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3585;&#3636;&#3609;&#3585;&#3623;&#3656;&#3634;',0),(79731,2215,'hi','Overpayment',0),(79732,2215,'ms','Berlebihan',0),(79733,2215,'ar','Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© Ø¨Ø§Ù„Ø²ÙŠØ§Ø¯Ø©',0),(79734,2215,'fr','Paiement excÃ©dentaire',0),(79735,2215,'jp','é?Žèª¤ç´?é‡‘',0),(79736,2215,'pt','Pagamento indevido',0),(79737,2215,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»Ð°Ñ‚Ð°',0),(79738,2215,'es','Pago Excesivo',0),(79739,2215,'de','Ãœberzahlung',0),(79740,2215,'en','Overpayment',0),(79741,2216,'is','',0),(79742,2216,'dr','Ø´Ø±Ø­ Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(79743,2216,'pr','Ø´Ø±Ø­ Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(79744,2216,'tr','Fazla Ã¶deme aÃ§Ä±klamasÄ±',0),(79745,2216,'pl','Opis nadpÅ‚aty',0),(79746,2216,'bg','ÐÐ°Ð´Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(79747,2216,'ur','Ø§ÙˆÙˆØ±Ù¾ÛŒÙ…Ø§Ù†Ù¹ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(79748,2216,'sr','ÐŸÑ€ÐµÐºÐ¾Ð¼ÐµÑ€Ð½Ñƒ Ð¾Ð¿Ð¸Ñ',0),(79749,2216,'vi','MÃ´ táº£ thanh toÃ¡n quÃ¡ ',0),(79750,2216,'af','Oorbetaling Beskrywing',0),(79751,2216,'ro','SumÄƒ suplimentarÄƒ Descriere',0),(79752,2216,'et','Enammaksed kirjeldus',0),(79753,2216,'si','PreplaÄilo opis',0),(79754,2216,'ba','Deskripsi kelebihan pembayaran',0),(79755,2216,'nl','Overbetaling beschrijving',0),(79756,2216,'fi','Liikaa kuvaus',0),(79757,2216,'no','Overbetalingen beskrivelse',0),(79758,2216,'da','Overbetaling beskrivelse',0),(79759,2216,'ko','Overpayment ì„¤ëª…',0),(79760,2216,'he','×ª×™××•×¨ ×™×ª×¨',0),(79761,2216,'el','Î‘Ï‡ÏÎµÏ‰ÏƒÏ„Î®Ï„Ï‰Ï‚ ÎºÎ±Ï„Î±Î²Î»Î·Î¸Î­Î½Ï„Î¿Ï‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(79762,2216,'zh','å¤šç¼´çš„è¯´æ˜Ž\r\n',0),(79763,2216,'sv','Ã–verbetalning Beskrivning',0),(79764,2216,'it','Descrizione di eccedenza',0),(79765,2216,'tl','',0),(79766,2216,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3585;&#3636;&#3609;&#3585;&#3623;&#3656;&#3634;',0),(79767,2216,'hi','Overpayment à¤µà¤¿à¤µà¤°à¤£',0),(79768,2216,'ms','Description/kawalan berlebihan',0),(79769,2216,'ar','Ø§Ù„ÙˆØµÙ Ø§Ù„Ø²Ø§Ø¦Ø¯',0),(79770,2216,'fr','Description du trop-payÃ©',0),(79771,2216,'jp','é?Žèª¤ç´?é‡‘è§£èª¬',0),(79772,2216,'pt','DescriÃ§Ã£o do pagamento indevido',0),(79773,2216,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿ÐµÑ€ÐµÐ¿Ð»Ð°Ñ‚Ñ‹',0),(79774,2216,'es','Pago Excesivo DescripciÃ³n',0),(79775,2216,'de','Ãœberzahlung Beschreibung',0),(79776,2216,'en','Overpayment Description',0),(79777,2217,'is','',0),(79778,2217,'dr','Ù…ØªØ¹Ù„Ù‚ Ø¨Ù‡ ',0),(79779,2217,'pr','Ù…ØªØ¹Ù„Ù‚ Ø¨Ù‡ ',0),(79780,2217,'tr','Sahip olduÄŸu',0),(79781,2217,'pl','WÅ‚asnoÅ›ciÄ…',0),(79782,2217,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð½Ð°',0),(79783,2217,'ur','Ù…Ù„Ú©ÛŒØª',0),(79784,2217,'sr','Ð£ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ñƒ',0),(79785,2217,'vi','Sá»Ÿ há»¯u bá»Ÿi',0),(79786,2217,'af','Besit deur',0),(79787,2217,'ro','DeÅ£inute de',0),(79788,2217,'et','Omanikuks',0),(79789,2217,'si','V lasti',0),(79790,2217,'ba','Dimiliki oleh',0),(79791,2217,'nl','Eigendom van',0),(79792,2217,'fi','Omistaa',0),(79793,2217,'no','Eies av',0),(79794,2217,'da','Ejes af',0),(79795,2217,'ko','ì†Œìœ  í•˜ ê³ ',0),(79796,2217,'he','×‘×‘×¢×œ×•×ª',0),(79797,2217,'el','Î‘Î½Î®ÎºÎµÎ¹',0),(79798,2217,'zh','æ‹¥æœ‰\r\n',0),(79799,2217,'sv','Ã„gs av',0),(79800,2217,'it','Di proprietÃ  di',0),(79801,2217,'tl','',0),(79802,2217,'th','&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3650;&#3604;&#3618;',0),(79803,2217,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤µà¤¾à¤²à¥€',0),(79804,2217,'ms','Dimiliki oleh',0),(79805,2217,'ar','Ø§Ù„ØªÙŠ ÙŠÙ…Ù„ÙƒÙ‡Ø§',0),(79806,2217,'fr','DÃ©tenue par',0),(79807,2217,'jp','æ‰€æœ‰è€…',0),(79808,2217,'pt','PossuÃ­do por',0),(79809,2217,'ru','Ð’ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(79810,2217,'es','Tenido por',0),(79811,2217,'de','Im Besitz von',0),(79812,2217,'en','Owned by',0),(79813,2218,'is','',0),(79814,2218,'dr','Ù…Ø§Ù„Ùƒ ',0),(79815,2218,'pr','Ù…Ø§Ù„Ùƒ ',0),(79816,2218,'tr','Sahibi',0),(79817,2218,'pl','WÅ‚aÅ›ciciel',0),(79818,2218,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸Ðº',0),(79819,2218,'ur','Ù…Ø§Ù„Ú©',0),(79820,2218,'sr','Ð’Ð»Ð°ÑÐ½Ð¸Ðº',0),(79821,2218,'vi','Chá»§ sá»Ÿ há»¯u',0),(79822,2218,'af','Eienaar',0),(79823,2218,'ro','Proprietar',0),(79824,2218,'et','Omanik',0),(79825,2218,'si','Lastnik',0),(79826,2218,'ba','Pemilik',0),(79827,2218,'nl','Eigenaar',0),(79828,2218,'fi','Omistaja',0),(79829,2218,'no','Eier',0),(79830,2218,'da','Ejer',0),(79831,2218,'ko','ì†Œìœ ìž',0),(79832,2218,'he','×‘×¢×œ×™×',0),(79833,2218,'el','Î™Î´Î¹Î¿ÎºÏ„Î®Ï„Î·Ï‚',0),(79834,2218,'zh','æ‹¥æœ‰è€…\r\n',0),(79835,2218,'sv','Ã„gare',0),(79836,2218,'it','Proprietario',0),(79837,2218,'tl','',0),(79838,2218,'th','&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;',0),(79839,2218,'hi','à¤¸à¥à¤µà¤¾à¤®à¥€',0),(79840,2218,'ms','Pemilik',0),(79841,2218,'ar','Ù…Ø§Ù„Ùƒ',0),(79842,2218,'fr','PropriÃ©taire',0),(79843,2218,'jp','ã‚ªãƒ¼ãƒŠãƒ¼',0),(79844,2218,'pt','ProprietÃ¡rio',0),(79845,2218,'ru','Ð’Ð»Ð°Ð´ÐµÐ»ÐµÑ†',0),(79846,2218,'es','DueÃ±o',0),(79847,2218,'de','EigentÃ¼mer',0),(79848,2218,'en','Owner',0),(79849,2219,'is','',0),(79850,2219,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø³ØªÙ‡ Ù‡Ø§',0),(79851,2219,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø³ØªÙ‡ Ù‡Ø§',0),(79852,2219,'tr','Paket #',0),(79853,2219,'pl','Pakiet #',0),(79854,2219,'bg','ÐŸÐ°ÐºÐµÑ‚ #',0),(79855,2219,'ur','Ù¾ÛŒÚ©Ø¬ Ú©ÛŒ #',0),(79856,2219,'sr','ÐŸÐ°ÐºÐµÑ‚ #',0),(79857,2219,'vi','Kiá»‡n sá»‘',0),(79858,2219,'af','Pakket #',0),(79859,2219,'ro','Pachet #',0),(79860,2219,'et','Pakett #',0),(79861,2219,'si','Paket #',0),(79862,2219,'ba','Paket #',0),(79863,2219,'nl','Pakket #',0),(79864,2219,'fi','Paketti #',0),(79865,2219,'no','Pakke #',0),(79866,2219,'da','Pakke #',0),(79867,2219,'ko','# íŒ¨í‚¤ì§€',0),(79868,2219,'he','×—×‘×™×œ×ª #',0),(79869,2219,'el','Î§Î‘Î¡Î¤/Î¤Î™ÎŸ #',0),(79870,2219,'zh','åŒ…ï¼ƒ\r\n',0),(79871,2219,'sv','Paketet #',0),(79872,2219,'it','Package #',0),(79873,2219,'tl','',0),(79874,2219,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;',0),(79875,2219,'hi','à¤ªà¥ˆà¤•à¥‡à¤œ #',0),(79876,2219,'ms','Pakej #',0),(79877,2219,'ar','Ø­Ø²Ù…Ø© #',0),(79878,2219,'fr','Forfait #',0),(79879,2219,'jp','ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸ç•ªå?·',0),(79880,2219,'pt','# Do pacote',0),(79881,2219,'ru','ÐŸÐ°ÐºÐµÑ‚ #',0),(79882,2219,'es','Paquete #',0),(79883,2219,'de','#-Paket',0),(79884,2219,'en','Package #',0),(79885,2220,'is','',0),(79886,2220,'dr','Ø¨Ø³ØªÙ‡ Ù‡Ø§',0),(79887,2220,'pr','Ø¨Ø³ØªÙ‡ Ù‡Ø§',0),(79888,2220,'tr','Paketleri',0),(79889,2220,'pl','Pakiety',0),(79890,2220,'bg','ÐŸÐ°ÐºÐµÑ‚Ð¸',0),(79891,2220,'ur','Ù¾ÛŒÚ©ÛŒØ¬',0),(79892,2220,'sr','ÐŸÐ°ÐºÐµÑ‚Ð¸',0),(79893,2220,'vi','Kiá»‡n hÃ ng ',0),(79894,2220,'af','Pakkette',0),(79895,2220,'ro','Pachete',0),(79896,2220,'et','Paketid',0),(79897,2220,'si','Paketi',0),(79898,2220,'ba','Paket',0),(79899,2220,'nl','Pakketten',0),(79900,2220,'fi','Paketit',0),(79901,2220,'no','Pakker',0),(79902,2220,'da','Pakker',0),(79903,2220,'ko','íŒ¨í‚¤ì§€',0),(79904,2220,'he','×—×‘×™×œ×•×ª',0),(79905,2220,'el','Î Î±ÎºÎ­Ï„Î±',0),(79906,2220,'zh','è½¯ä»¶åŒ…\r\n',0),(79907,2220,'sv','Paket',0),(79908,2220,'it','Pacchetti',0),(79909,2220,'tl','',0),(79910,2220,'th','&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;',0),(79911,2220,'hi','à¤¸à¤‚à¤•à¥à¤²',0),(79912,2220,'ms','Pakej-pakej',0),(79913,2220,'ar','Ø§Ù„Ø­Ø²Ù…',0),(79914,2220,'fr','Paquets',0),(79915,2220,'jp','ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸',0),(79916,2220,'pt','Pacotes',0),(79917,2220,'ru','ÐŸÐ°ÐºÐµÑ‚Ñ‹',0),(79918,2220,'es','Paquetes',0),(79919,2220,'de','Pakete',0),(79920,2220,'en','Packages',0),(79921,2221,'is','',0),(79922,2221,'dr','Ù„ÙŠØ³Øª Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ',0),(79923,2221,'pr','Ù„ÙŠØ³Øª Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ',0),(79924,2221,'tr','Ambalaj listesi',0),(79925,2221,'pl','LiÅ›cie zaÅ‚adunkowej',0),(79926,2221,'bg','ÐžÐ¿Ð°ÐºÐ¾Ð²ÐºÐ° ÑÐ¿Ð¸ÑÑŠÐº',0),(79927,2221,'ur','Ù¾ÛŒÚ©Ø§Ù†Ú¯ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(79928,2221,'sr','ÐŸÐ°ÐºÐ¾Ð²Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ð°',0),(79929,2221,'vi','Danh sÃ¡ch Ä‘Ã³ng hÃ ng',0),(79930,2221,'af','Packing lys',0),(79931,2221,'ro','Lista de ambalare',0),(79932,2221,'et','Pakkimiskeskuse loend',0),(79933,2221,'si','Pakiranje seznam',0),(79934,2221,'ba','Daftar Kemasan',0),(79935,2221,'nl','Verpakking lijst',0),(79936,2221,'fi','Pakkaus luettelo',0),(79937,2221,'no','Pakking liste',0),(79938,2221,'da','Pakning liste',0),(79939,2221,'ko','í¬ìž¥ ëª©ë¡',0),(79940,2221,'he','×ž×¢×˜×¤×•×ª ×¤×§×™× ×’ ×œ×™×¡×˜',0),(79941,2221,'el','Î£Ï…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î±Ï‚ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(79942,2221,'zh','è£…ç®±æ¸…å•\r\n',0),(79943,2221,'sv','FÃ¶rpackning lista',0),(79944,2221,'it','Elenco macchine per imballaggio',0),(79945,2221,'tl','',0),(79946,2221,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;',0),(79947,2221,'hi','à¤ªà¥ˆà¤•à¤¿à¤‚à¤— à¤¸à¥‚à¤šà¥€',0),(79948,2221,'ms','Senarai packing',0),(79949,2221,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„ØªØ¹Ø¨Ø¦Ø©',0),(79950,2221,'fr','Liste d\'emballage',0),(79951,2221,'jp','æ¢±åŒ…ãƒªã‚¹ãƒˆ',0),(79952,2221,'pt','Lista de embalagem',0),(79953,2221,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑƒÐ¿Ð°ÐºÐ¾Ð²ÐºÐ¸',0),(79954,2221,'es','Lista de Embalaje',0),(79955,2221,'de','Packing List',0),(79956,2221,'en','Packing List',0),(79957,2222,'is','',0),(79958,2222,'dr','Ù„Ø§ÙŠÙ‡ Ú†Ù¾',0),(79959,2222,'pr','Ù„Ø§ÙŠÙ‡ Ú†Ù¾',0),(79960,2222,'tr','Sayfa',0),(79961,2222,'pl','Strona',0),(79962,2222,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(79963,2222,'ur','ØµÙØ­Û',0),(79964,2222,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(79965,2222,'vi','Trang',0),(79966,2222,'af','Bladsy',0),(79967,2222,'ro','Filme',0),(79968,2222,'et','Leht',0),(79969,2222,'si','Strani',0),(79970,2222,'ba','Halaman',0),(79971,2222,'nl','Pagina',0),(79972,2222,'fi','Sivu',0),(79973,2222,'no','Siden',0),(79974,2222,'da','Side',0),(79975,2222,'ko','íŽ˜ì´ì§€',0),(79976,2222,'he','×“×£',0),(79977,2222,'el','Î£ÎµÎ»Î¯Î´Î±',0),(79978,2222,'zh','é¡µé¢\r\n',0),(79979,2222,'sv','Sida',0),(79980,2222,'it','Pagina',0),(79981,2222,'tl','',0),(79982,2222,'th','&#3627;&#3609;&#3657;&#3634;',0),(79983,2222,'hi','à¤ªà¥ƒà¤·à¥à¤ ',0),(79984,2222,'ms','Laman',0),(79985,2222,'ar','Ø§Ù„ØµÙØ­Ø©',0),(79986,2222,'fr','Page',0),(79987,2222,'jp','ãƒšãƒ¼ã‚¸',0),(79988,2222,'pt','PÃ¡gina de vÃ­deo',0),(79989,2222,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(79990,2222,'es','PÃ¡gina',0),(79991,2222,'de','Seite',0),(79992,2222,'en','Page',0),(79993,2223,'is','',0),(79994,2223,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµÙØ­Ù‡',0),(79995,2223,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµÙØ­Ù‡',0),(79996,2223,'tr','Sayfa boyutu',0),(79997,2223,'pl','Rozmiar strony',0),(79998,2223,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð°',0),(79999,2223,'ur','Ø³Ø§Ø¦Ø² ØµÙØ­Û',0),(80000,2223,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(80001,2223,'vi','KÃ­ch cá»¡ trang',0),(80002,2223,'af','Bladsy Grootte',0),(80003,2223,'ro','Dimensiunea paginii',0),(80004,2223,'et','Lehe suurus',0),(80005,2223,'si','Velikost strani',0),(80006,2223,'ba','Ukuran halaman',0),(80007,2223,'nl','Paginaformaat',0),(80008,2223,'fi','Sivun koko',0),(80009,2223,'no','SidestÃ¸rrelse',0),(80010,2223,'da','SidestÃ¸rrelse',0),(80011,2223,'ko','íŽ˜ì´ì§€ í¬ê¸°',0),(80012,2223,'he','×’×•×“×œ ×“×£',0),(80013,2223,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ ÏƒÎµÎ»Î¯Î´Î±Ï‚',0),(80014,2223,'zh','é¡µé¢å¤§å°\r\n',0),(80015,2223,'sv','Sidstorlek',0),(80016,2223,'it','Dimensioni della pagina',0),(80017,2223,'tl','',0),(80018,2223,'th','&#3586;&#3609;&#3634;&#3604;&#3627;&#3609;&#3657;&#3634;',0),(80019,2223,'hi','à¤ªà¥ƒà¤·à¥à¤  à¤†à¤•à¤¾à¤°',0),(80020,2223,'ms','Saiz muka',0),(80021,2223,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ù†ØªØ§Ø¦Ø¬ Ù„Ù„ØµÙØ­Ø©',0),(80022,2223,'fr','Taille de la page',0),(80023,2223,'jp','ãƒšãƒ¼ã‚¸ã‚µã‚¤ã‚º',0),(80024,2223,'pt','Tamanho da pÃ¡gina',0),(80025,2223,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹',0),(80026,2223,'es','TamaÃ±o de PÃ¡gina',0),(80027,2223,'de','SeitengrÃ¶ÃŸe',0),(80028,2223,'en','Page Size',0),(80029,2224,'is','',0),(80030,2224,'dr','ØµÙØ­Ø§Øª ',0),(80031,2224,'pr','ØµÙØ­Ø§Øª ',0),(80032,2224,'tr','SayfalarÄ±',0),(80033,2224,'pl','Stron',0),(80034,2224,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(80035,2224,'ur','ØµÙØ­Ø§Øª',0),(80036,2224,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(80037,2224,'vi','Trang',0),(80038,2224,'af','Bladsye',0),(80039,2224,'ro','Pagini',0),(80040,2224,'et','LehekÃ¼ljed',0),(80041,2224,'si','Strani',0),(80042,2224,'ba','Halaman',0),(80043,2224,'nl','Pagina \'s',0),(80044,2224,'fi','Sivut',0),(80045,2224,'no','Sider',0),(80046,2224,'da','Sider',0),(80047,2224,'ko','íŽ˜ì´ì§€',0),(80048,2224,'he','×“×¤×™×',0),(80049,2224,'el','Î£ÎµÎ»Î¯Î´ÎµÏ‚',0),(80050,2224,'zh','é¡µé¢\r\n',0),(80051,2224,'sv','Sidor',0),(80052,2224,'it','Pagine',0),(80053,2224,'tl','',0),(80054,2224,'th','&#3627;&#3609;&#3657;&#3634;',0),(80055,2224,'hi','à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚',0),(80056,2224,'ms','Muka Surat',0),(80057,2224,'ar','ØµÙØ­Ø§Øª',0),(80058,2224,'fr','Pages',0),(80059,2224,'jp','ãƒšãƒ¼ã‚¸',0),(80060,2224,'pt','PÃ¡ginas',0),(80061,2224,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†',0),(80062,2224,'es','PÃ¡ginas',0),(80063,2224,'de','Seiten',0),(80064,2224,'en','Pages',0),(80065,2225,'is','',0),(80066,2225,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(80067,2225,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(80068,2225,'tr','Ã–denen',0),(80069,2225,'pl','PÅ‚atne',0),(80070,2225,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸',0),(80071,2225,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(80072,2225,'sr','ÐŸÐ»Ð°Ñ‚Ð¸Ð¾',0),(80073,2225,'vi','ÄÃ£ tráº£',0),(80074,2225,'af','Betaal',0),(80075,2225,'ro','PlÄƒtit',0),(80076,2225,'et','Makstud',0),(80077,2225,'si','PlaÄa',0),(80078,2225,'ba','Dibayar',0),(80079,2225,'nl','Betaald',0),(80080,2225,'fi','Maksettu',0),(80081,2225,'no','Betalt',0),(80082,2225,'da','Betalt',0),(80083,2225,'ko','ì§€ë¶ˆ',0),(80084,2225,'he','×©×•×œ×',0),(80085,2225,'el','ÎšÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹',0),(80086,2225,'zh','ä»˜è´¹\r\n',0),(80087,2225,'sv','Betalas',0),(80088,2225,'it','Pagato',0),(80089,2225,'tl','',0),(80090,2225,'th','&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(80091,2225,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(80092,2225,'ms','Dibayar',0),(80093,2225,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(80094,2225,'fr','PayÃ©',0),(80095,2225,'jp','æ”¯æ‰•æ¸ˆã?¿',0),(80096,2225,'pt','Pago',0),(80097,2225,'ru','ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ',0),(80098,2225,'es','Pagado',0),(80099,2225,'de','Bezahlt',0),(80100,2225,'en','Paid',0),(80101,2226,'is','',0),(80102,2226,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ø§Ù„Ø§Ù†Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(80103,2226,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ø§Ù„Ø§Ù†Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(80104,2226,'tr','Ãœcretli YTD',0),(80105,2226,'pl','PÅ‚atne OPR',0),(80106,2226,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(80107,2226,'ur','Ø§Ø¯Ø§ ÛŒÙ¹Ø¯',0),(80108,2226,'sr','ÐŸÐ»Ð°Ñ›ÐµÐ½Ð¸ Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(80109,2226,'vi','Tráº£ tá»« Ä‘áº§u nÄƒm Ä‘áº¿n nay',0),(80110,2226,'af','Betaal JTD',0),(80111,2226,'ro','PlÄƒtit YTD',0),(80112,2226,'et','Paide YTD',0),(80113,2226,'si','PlaÄane YTD',0),(80114,2226,'ba','Dibayar YTD',0),(80115,2226,'nl','Betaalde YTD',0),(80116,2226,'fi','Maksettu vuoden alusta',0),(80117,2226,'no','Betalt YTD',0),(80118,2226,'da','Betalt Ã…TD',0),(80119,2226,'ko','ìœ ë£Œ YTD',0),(80120,2226,'he','×‘×ª×©×œ×•× ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(80121,2226,'el','Î Î»Î·ÏÏ‰Î¼Î­Î½Î· YTD',0),(80122,2226,'zh','å¹´åˆè‡³ä»Šæ”¯ä»˜\r\n',0),(80123,2226,'sv','Betald YTD',0),(80124,2226,'it','Pagato YTD',0),(80125,2226,'tl','',0),(80126,2226,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618; YTD',0),(80127,2226,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ YTD',0),(80128,2226,'ms','THK dibayar',0),(80129,2226,'ar','Ø§Ù„Ù…Ø³Ø¯Ø¯ Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(80130,2226,'fr','Depuis un an payÃ©',0),(80131,2226,'jp','å¹´é–“ç´¯ç©?æ”¯æ‰•',0),(80132,2226,'pt','YTD pago',0),(80133,2226,'ru','ÐŸÐ»Ð°Ñ‚Ð½Ñ‹Ðµ Ñ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð°',0),(80134,2226,'es','Pagado AAF',0),(80135,2226,'de','Bezahlte YTD',0),(80136,2226,'en','Paid YTD',0),(80137,2227,'is','',0),(80138,2227,'dr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(80139,2227,'pr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(80140,2227,'tr','Malzeme',0),(80141,2227,'pl','MateriaÅ‚',0),(80142,2227,'bg','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»',0),(80143,2227,'ur','Ù…ÙˆØ§Ø¯',0),(80144,2227,'sr','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»',0),(80145,2227,'vi','NguyÃªn váº­t liá»‡u',0),(80146,2227,'af','Materiaal',0),(80147,2227,'ro','Materialul',0),(80148,2227,'et','Materjali',0),(80149,2227,'si','Material',0),(80150,2227,'ba','Bahan',0),(80151,2227,'nl','Materiaal',0),(80152,2227,'fi','Materiaali',0),(80153,2227,'no','Materiale',0),(80154,2227,'da','Materiale',0),(80155,2227,'ko','ìž¬ë£Œ',0),(80156,2227,'he','×—×•×ž×¨',0),(80157,2227,'el','Î¥Î»Î¹ÎºÏŒ',0),(80158,2227,'zh','ææ–™\r\n',0),(80159,2227,'sv','Material',0),(80160,2227,'it','Materiale',0),(80161,2227,'tl','',0),(80162,2227,'th','&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(80163,2227,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€',0),(80164,2227,'ms','Bahan',0),(80165,2227,'ar','Ø§Ù„Ù…ÙˆØ§Ø¯',0),(80166,2227,'fr','MatÃ©riel',0),(80167,2227,'jp','è³‡æ–™',0),(80168,2227,'pt','Material',0),(80169,2227,'ru','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»',0),(80170,2227,'es','Material',0),(80171,2227,'de','Material',0),(80172,2227,'en','Material',0),(80173,2228,'is','',0),(80174,2228,'dr','Ù‚Ø³Ù…Øª',0),(80175,2228,'pr','Ù‚Ø³Ù…Øª',0),(80176,2228,'tr','BÃ¶lÃ¼m',0),(80177,2228,'pl','CzÄ™Å›Ä‡',0),(80178,2228,'bg','Ð§Ð°ÑÑ‚',0),(80179,2228,'ur','Ø­ØµÛ',0),(80180,2228,'sr','Ð”ÐµÐ¾',0),(80181,2228,'vi','Phá»¥ tÃ¹ng',0),(80182,2228,'af','Deel',0),(80183,2228,'ro','Parte',0),(80184,2228,'et','Osa',0),(80185,2228,'si','Del',0),(80186,2228,'ba','Bagian',0),(80187,2228,'nl','Deel',0),(80188,2228,'fi','Osa',0),(80189,2228,'no','Del',0),(80190,2228,'da','En del',0),(80191,2228,'ko','ë¶€ë¶„',0),(80192,2228,'he','×—×œ×§',0),(80193,2228,'el','ÎœÎ­ÏÎ¿Ï‚',0),(80194,2228,'zh','éƒ¨åˆ†\r\n',0),(80195,2228,'sv','Del',0),(80196,2228,'it','Parte',0),(80197,2228,'tl','',0),(80198,2228,'th','&#3626;&#3656;&#3623;&#3609;',0),(80199,2228,'hi','à¤­à¤¾à¤—',0),(80200,2228,'ms','Sebahagian',0),(80201,2228,'ar','Ø¬Ø²Ø¡',0),(80202,2228,'fr','Partie',0),(80203,2228,'jp','éƒ¨å“?',0),(80204,2228,'pt','Parte',0),(80205,2228,'ru','Ð§Ð°ÑÑ‚ÑŒ',0),(80206,2228,'es','Parte',0),(80207,2228,'de','Teil',0),(80208,2228,'en','Part',0),(80209,2229,'is','',0),(80210,2229,'dr','Ù†Ø§Ù… Ù‚Ø³Ù…Øª',0),(80211,2229,'pr','Ù†Ø§Ù… Ù‚Ø³Ù…Øª',0),(80212,2229,'tr','BÃ¶lÃ¼m adÄ±',0),(80213,2229,'pl','Nazwa czÄ™Å›ci',0),(80214,2229,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ‡Ð°ÑÑ‚',0),(80215,2229,'ur','Ø­ØµÛ Ú©Ø§ Ù†Ø§Ù…',0),(80216,2229,'sr','Ð”Ð¸Ð¾ Ð½Ð°Ð·Ð¸Ð²Ð°',0),(80217,2229,'vi','TÃªn phá»¥ tÃ¹ng',0),(80218,2229,'af','Onderdeel Naam',0),(80219,2229,'ro','Parte nume',0),(80220,2229,'et','Osa nimi',0),(80221,2229,'si','Ime dela',0),(80222,2229,'ba','Nama bagian',0),(80223,2229,'nl','Onderdeelnaam',0),(80224,2229,'fi','Osan nimi',0),(80225,2229,'no','Navn pÃ¥ webdel',0),(80226,2229,'da','Del navn',0),(80227,2229,'ko','ë¶€í’ˆ ì´ë¦„',0),(80228,2229,'he','×©× ×—×œ×§',0),(80229,2229,'el','Î¤Î¼Î®Î¼Î± ÏŒÎ½Î¿Î¼Î±',0),(80230,2229,'zh','éƒ¨ä»¶åç§°\r\n',0),(80231,2229,'sv','Namn pÃ¥ del',0),(80232,2229,'it','Nome di parte',0),(80233,2229,'tl','',0),(80234,2229,'th','&#3594;&#3639;&#3656;&#3629;&#3626;&#3656;&#3623;&#3609;',0),(80235,2229,'hi','à¤­à¤¾à¤— à¤•à¤¾ à¤¨à¤¾à¤®',0),(80236,2229,'ms','Nama bahagian',0),(80237,2229,'ar','Ø§Ø³Ù… Ø¬Ø²Ø¡',0),(80238,2229,'fr','Nom de la partie',0),(80239,2229,'jp','éƒ¨å“?å??',0),(80240,2229,'pt','Nome de parte',0),(80241,2229,'ru','Ð§Ð°ÑÑ‚ÑŒ Ð¸Ð¼ÐµÐ½Ð¸',0),(80242,2229,'es','Nombre de Parte',0),(80243,2229,'de','Teilenamen',0),(80244,2229,'en','Part Name',0),(80245,2230,'is','',0),(80246,2230,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø³Ù…Øª ',0),(80247,2230,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø³Ù…Øª ',0),(80248,2230,'tr','ParÃ§a numarasÄ±',0),(80249,2230,'pl','Numer katalogowy',0),(80250,2230,'bg','Ð§Ð°ÑÑ‚ Ð½Ð¾Ð¼ÐµÑ€',0),(80251,2230,'ur','Ø­ØµÛ Ù†Ù…Ø¨Ø±',0),(80252,2230,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð´ÐµÐ»Ð°',0),(80253,2230,'vi','Sá»‘ phá»¥ tÃ¹ng',0),(80254,2230,'af','Onderdeel Nommer',0),(80255,2230,'ro','NumÄƒrul de componentÄƒ',0),(80256,2230,'et','Osa Number',0),(80257,2230,'si','KataloÅ¡ka Å¡tevilka',0),(80258,2230,'ba','Nomor bagian',0),(80259,2230,'nl','Onderdeelnummer',0),(80260,2230,'fi','Osan numero',0),(80261,2230,'no','Delenummer',0),(80262,2230,'da','Reservedelsnummer',0),(80263,2230,'ko','ë¶€í’ˆ ë²ˆí˜¸',0),(80264,2230,'he','×ž×¡×¤×¨ ×—×œ×§',0),(80265,2230,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î¼ÎµÏÏŽÎ½',0),(80266,2230,'zh','éƒ¨ä»¶å·\r\n',0),(80267,2230,'sv','Delnummer',0),(80268,2230,'it','Numero di parte',0),(80269,2230,'tl','',0),(80270,2230,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3626;&#3656;&#3623;&#3609;',0),(80271,2230,'hi','à¤­à¤¾à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(80272,2230,'ms','Nombor bahagian',0),(80273,2230,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¬Ø²Ø¡',0),(80274,2230,'fr','NumÃ©ro de piÃ¨ce',0),(80275,2230,'jp','éƒ¨å“?ç•ªå?·',0),(80276,2230,'pt','NÃºmero da peÃ§a',0),(80277,2230,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(80278,2230,'es','NÃºmero de Parte',0),(80279,2230,'de','Teilenummer',0),(80280,2230,'en','Part Number',0),(80281,2231,'is','',0),(80282,2231,'dr','Ø¬Ø²Ø¦ÙŠ',0),(80283,2231,'pr','Ø¬Ø²Ø¦ÙŠ',0),(80284,2231,'tr','KÄ±smi',0),(80285,2231,'pl','CzÄ™Å›ciowe',0),(80286,2231,'bg','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð°',0),(80287,2231,'ur','Ø¬Ø²ÙˆÛŒ',0),(80288,2231,'sr','Ð”ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð°',0),(80289,2231,'vi','Má»™t pháº§n',0),(80290,2231,'af','Gedeetelik',0),(80291,2231,'ro','ParÅ£ialÄƒ',0),(80292,2231,'et','Osaline',0),(80293,2231,'si','Delno',0),(80294,2231,'ba','Parsial',0),(80295,2231,'nl','Gedeeltelijke',0),(80296,2231,'fi','Osittainen',0),(80297,2231,'no','Delvis',0),(80298,2231,'da','Delvis',0),(80299,2231,'ko','ë¶€ë¶„',0),(80300,2231,'he','×—×œ×§×™',0),(80301,2231,'el','ÎœÎµÏÎ¹ÎºÎ®',0),(80302,2231,'zh','éƒ¨åˆ†\r\n',0),(80303,2231,'sv','Partiell',0),(80304,2231,'it','Parziale',0),(80305,2231,'tl','',0),(80306,2231,'th','&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;',0),(80307,2231,'hi','à¤†à¤‚à¤¶à¤¿à¤•',0),(80308,2231,'ms','Separa',0),(80309,2231,'ar','Ø¬Ø²Ø¦ÙŠÙ‘',0),(80310,2231,'fr','Partielle',0),(80311,2231,'jp','ä¸€éƒ¨ã?®',0),(80312,2231,'pt','Parcial',0),(80313,2231,'ru','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð°Ñ',0),(80314,2231,'es','Parcial',0),(80315,2231,'de','Teilweise',0),(80316,2231,'en','Partial',0),(80317,2232,'is','',0),(80318,2232,'dr','Ø­Ù…Ù„ Ø¬Ø²Ø¦ÙŠ',0),(80319,2232,'pr','Ø­Ù…Ù„ Ø¬Ø²Ø¦ÙŠ',0),(80320,2232,'tr','KÄ±smi sevkiyat',0),(80321,2232,'pl','CzÄ™Å›ciowa',0),(80322,2232,'bg','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ñ',0),(80323,2232,'ur','Ø¬Ø²ÙˆÛŒ Ú©Ú¾ÛŒÙ¾',0),(80324,2232,'sr','Ð”ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(80325,2232,'vi','Váº­n chuyá»ƒn má»™t pháº§n',0),(80326,2232,'af','Gedeeltelike Versending',0),(80327,2232,'ro','Livrare parÅ£ialÄƒ',0),(80328,2232,'et','Osaline lÃ¤hetus',0),(80329,2232,'si','Delna dobava',0),(80330,2232,'ba','Pengiriman parsial',0),(80331,2232,'nl','Gedeeltelijke verzending',0),(80332,2232,'fi','Osittainen toimitus',0),(80333,2232,'no','Delleveranse',0),(80334,2232,'da','Delleverance',0),(80335,2232,'ko','ë¶€ë¶„ì ì¸ ì„ ì ',0),(80336,2232,'he','×ž×©×œ×•×— ×—×œ×§×™',0),(80337,2232,'el','ÎœÎµÏÎ¹ÎºÎ® Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(80338,2232,'zh','åˆ†æ‰¹è£…è¿\r\n',0),(80339,2232,'sv','Delleverans',0),(80340,2232,'it','Spedizione parziale',0),(80341,2232,'tl','',0),(80342,2232,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;',0),(80343,2232,'hi','à¤†à¤‚à¤¶à¤¿à¤• à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ',0),(80344,2232,'ms','Penghantaran separa',0),(80345,2232,'ar','Ø´Ø­Ù†Ø© Ù…Ø¬Ø²Ù‘Ø£Ø©',0),(80346,2232,'fr','Livraison partielle',0),(80347,2232,'jp','ä¸€éƒ¨ç™ºé€?',0),(80348,2232,'pt','Remessa parcial',0),(80349,2232,'ru','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð°Ñ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ°',0),(80350,2232,'es','EnvÃ­o Parcial',0),(80351,2232,'de','Teillieferung',0),(80352,2232,'en','Partial Shipment',0),(80353,2233,'is','',0),(80354,2233,'dr','ØªØ§ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§ÙŠ ÙƒØ§Ù…Ù„ ',0),(80355,2233,'pr','ØªØ§ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§ÙŠ ÙƒØ§Ù…Ù„ ',0),(80356,2233,'tr','KÄ±smen tamamlandÄ±',0),(80357,2233,'pl','CzÄ™Å›ciowo kompletna',0),(80358,2233,'bg','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¾',0),(80359,2233,'ur','Ø¬Ø²ÙˆÛŒ Ù…Ú©Ù…Ù„ Ú©Ø±Ø¯Û',0),(80360,2233,'sr','Ð”ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð¾ ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½',0),(80361,2233,'vi','HoÃ n táº¥t 1 pháº§n',0),(80362,2233,'af','Gedeetelik Voltooi',0),(80363,2233,'ro','ParÅ£ial finalizatÄƒ',0),(80364,2233,'et','Osaliselt lÃµpetatud',0),(80365,2233,'si','Delno dokonÄan',0),(80366,2233,'ba','Selesai sebagian',0),(80367,2233,'nl','Gedeeltelijk voltooid',0),(80368,2233,'fi','Osittain valmis',0),(80369,2233,'no','Delvis fullfÃ¸rt',0),(80370,2233,'da','Delvist fuldfÃ¸rt',0),(80371,2233,'ko','ë¶€ë¶„ì ìœ¼ë¡œ ì™„ë£Œ',0),(80372,2233,'he','×”×•×©×œ× ×—×œ×§×™×ª',0),(80373,2233,'el','ÎœÎµÏÎ¹ÎºÏŽÏ‚ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½Î·',0),(80374,2233,'zh','éƒ¨åˆ†å®Œæˆ\r\n',0),(80375,2233,'sv','Delvis slutfÃ¶rd',0),(80376,2233,'it','Parzialmente completa',0),(80377,2233,'tl','',0),(80378,2233,'th','&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;',0),(80379,2233,'hi','à¤†à¤‚à¤¶à¤¿à¤• à¤°à¥‚à¤ª à¤¸à¥‡ à¤ªà¥‚à¤°à¥à¤£',0),(80380,2233,'ms','Lengkap separa',0),(80381,2233,'ar','Ù…ÙƒØªÙ…Ù„ Ø¬Ø²Ø¦ÙŠÙ‘Ø§',0),(80382,2233,'fr','Partiellement complet',0),(80383,2233,'jp','ä¸€éƒ¨å®Œäº†',0),(80384,2233,'pt','Parcialmente completa',0),(80385,2233,'ru','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹',0),(80386,2233,'es','Parcialmente Completo',0),(80387,2233,'de','Teilweise abgeschlossen',0),(80388,2233,'en','Partially Complete',0),(80389,2234,'is','',0),(80390,2234,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ',0),(80391,2234,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ',0),(80392,2234,'tr','Åžifre',0),(80393,2234,'pl','HasÅ‚o',0),(80394,2234,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð°',0),(80395,2234,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(80396,2234,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ°',0),(80397,2234,'vi','Máº­t kháº©u',0),(80398,2234,'af','Wagwoord',0),(80399,2234,'ro','Parola',0),(80400,2234,'et','SalasÃµna',0),(80401,2234,'si','Geslo',0),(80402,2234,'ba','Sandi',0),(80403,2234,'nl','Wachtwoord',0),(80404,2234,'fi','Salasana',0),(80405,2234,'no','Passord',0),(80406,2234,'da','Adgangskode',0),(80407,2234,'ko','ë¹„ë°€ ë²ˆí˜¸',0),(80408,2234,'he','×¡×™×¡×ž×”',0),(80409,2234,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(80410,2234,'zh','å¯†ç \r\n',0),(80411,2234,'sv','LÃ¶senord',0),(80412,2234,'it','Password',0),(80413,2234,'tl','',0),(80414,2234,'th','Password',0),(80415,2234,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡',0),(80416,2234,'ms','Kata laluan',0),(80417,2234,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ø³Ø±Ù‘',0),(80418,2234,'fr','Mot de passe',0),(80419,2234,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰',0),(80420,2234,'pt','Senha',0),(80421,2234,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ:',0),(80422,2234,'es','ContraseÃ±a',0),(80423,2234,'de','Passwort',0),(80424,2234,'en','Password',0),(80425,2235,'is','',0),(80426,2235,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®Ø§Ù„ÙŠ Ø§Ø³Øª ',0),(80427,2235,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®Ø§Ù„ÙŠ Ø§Ø³Øª ',0),(80428,2235,'tr','Parola boÅŸ',0),(80429,2235,'pl','HasÅ‚o jest puste',0),(80430,2235,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð° Ðµ Ð¿Ñ€Ð°Ð·ÐµÐ½',0),(80431,2235,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø®Ø§Ù„ÛŒ ÛÛ’',0),(80432,2235,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ° Ñ˜Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð°',0),(80433,2235,'vi','Máº­t kháº©u trá»‘ng',0),(80434,2235,'af','Wagwoord is oop',0),(80435,2235,'ro','Parola este gol',0),(80436,2235,'et','SalasÃµna vÃ¤li on tÃ¼hi',0),(80437,2235,'si','Geslo je prazno',0),(80438,2235,'ba','Password kosong',0),(80439,2235,'nl','Wachtwoord is leeg',0),(80440,2235,'fi','Salasana on tyhjÃ¤',0),(80441,2235,'no','Passordet er tomt',0),(80442,2235,'da','Adgangskoden er tom',0),(80443,2235,'ko','ì•”í˜¸ëž€ì´ ë¹„ì–´',0),(80444,2235,'he','×”×¡×™×¡×ž×” ×”×™× ×¨×™×§×”',0),(80445,2235,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ½ÏŒÏ‚',0),(80446,2235,'zh','å¯†ç ä¸ºç©º\r\n',0),(80447,2235,'sv','LÃ¶senordet Ã¤r tomt',0),(80448,2235,'it','Password Ã¨ vuota',0),(80449,2235,'tl','',0),(80450,2235,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3623;&#3656;&#3634;&#3591;&#3648;&#3611;&#3621;&#3656;&#3634;',0),(80451,2235,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤°à¤¿à¤•à¥à¤¤ à¤¹à¥ˆ',0),(80452,2235,'ms','Kata laluan adalah kosong',0),(80453,2235,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ø³Ø± Ø®Ø§Ù„ÙŠØ©',0),(80454,2235,'fr','Mot de passe est vide',0),(80455,2235,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã?Œç©ºæ¬„ã?§ã?™',0),(80456,2235,'pt','Senha Ã© em branco',0),(80457,2235,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ Ð¿ÑƒÑÑ‚',0),(80458,2235,'es','ContraseÃ±a esta en blanco',0),(80459,2235,'de','Passwort ist leer',0),(80460,2235,'en','Password is blank',0),(80461,2236,'is','',0),(80462,2236,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯ ',0),(80463,2236,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯ ',0),(80464,2236,'tr','Åžifre teyit',0),(80465,2236,'pl','HasÅ‚o nie zostaÅ‚o potwierdzone',0),(80466,2236,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð°Ñ‚Ð° Ð½Ðµ Ðµ Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð°',0),(80467,2236,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ù†ÛÛŒÚº Ú©ÛŒ',0),(80468,2236,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð°',0),(80469,2236,'vi','Máº­t mÃ£ chÆ°a xÃ¡c nháº­n',0),(80470,2236,'af','Wagwoord is nie bevestig nie',0),(80471,2236,'ro','Parola nu confirmÄƒ',0),(80472,2236,'et','SalasÃµna ei ole kinnitatud',0),(80473,2236,'si','Geslo ni potrjena',0),(80474,2236,'ba','Sandi tidak dikonfirmasi',0),(80475,2236,'nl','Wachtwoord niet bevestigd',0),(80476,2236,'fi','Salasanaa ei ole vahvistettu',0),(80477,2236,'no','Passordet ble ikke bekreftet',0),(80478,2236,'da','Adgangskode ikke bekrÃ¦ftet',0),(80479,2236,'ko','ì•”í˜¸ í™•ì¸ ë˜ì§€',0),(80480,2236,'he','×”×¡×™×¡×ž×” ×œ× ××•×ž×ª×”',0),(80481,2236,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î´ÎµÎ½ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯',0),(80482,2236,'zh','æœªç¡®è®¤å¯†ç \r\n',0),(80483,2236,'sv','LÃ¶senord inte bekrÃ¤ftas',0),(80484,2236,'it','Password non confermato',0),(80485,2236,'tl','',0),(80486,2236,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(80487,2236,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¨à¤¹à¥€à¤‚ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¥€',0),(80488,2236,'ms','Kata laluan tidak disahkan',0),(80489,2236,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ø³Ø±Ù‘ ØºÙŠØ± Ù…Ø¤ÙƒÙ‘Ø¯Ø©',0),(80490,2236,'fr','Mot de passe n\'a ne pas confirmÃ©',0),(80491,2236,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã?Œç¢ºèª?ã?§ã??ã?¾ã?›ã‚“',0),(80492,2236,'pt','Senha nÃ£o confirmada',0),(80493,2236,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ Ð½Ðµ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½',0),(80494,2236,'es','ContraseÃ±a no confirmado',0),(80495,2236,'de','Passwort nicht bestÃ¤tigt',0),(80496,2236,'en','Password not confirmed',0),(80497,2237,'is','',0),(80498,2237,'dr','! Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(80499,2237,'pr','Ø±Ù…Ø²Ù‡Ø§ÙŠ Ø¹Ø¨ÙˆØ± Ù‡Ù…Ø®ÙˆØ§Ù†ÙŠ Ù†Ø¯Ø§Ø±Ø¯! Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(80500,2237,'tr','Parolalar uyuÅŸmuyor.  Yeniden Deneyin.',0),(80501,2237,'pl','HasÅ‚a nie pasujÄ…!  PrÃ³buj ponownie.',0),(80502,2237,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð¸Ñ‚Ðµ Ð½Ðµ ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‚!  ÐžÐ¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾.',0),(80503,2237,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº Û”  Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ Ú©Ø±Ùˆ.',0),(80504,2237,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐµ ÑÐµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ.  Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜ Ð¿Ð¾Ð½Ð¾Ð²Ð¾.',0),(80505,2237,'vi','Máº­t kháº©u khÃ´ng Ä‘Ãºng! Thá»­ láº¡i',0),(80506,2237,'af','Wagwoorde stem nie ooreen! Probeer weer.',0),(80507,2237,'ro','Parolele nu se potrivesc!  Ã®ncearcÄƒ din nou.',0),(80508,2237,'et','SalasÃµna ei ole Ãµige, proovi uuesti!',0),(80509,2237,'si','Gesli se ne ujemata!  poskusi znova.',0),(80510,2237,'ba','Password tidak cocok!  Coba lagi.',0),(80511,2237,'nl','Wachtwoorden komen niet overeen!  &Opnieuw.',0),(80512,2237,'fi','Salasanat eivÃ¤t tÃ¤smÃ¤Ã¤!  YritÃ¤ uudestaan.',0),(80513,2237,'no','Passordene samsvarer ikke!  prÃ¸v igjen.',0),(80514,2237,'da','Adgangskoderne er ikke ens!  PrÃ¸v igen.',0),(80515,2237,'ko','ì•”í˜¸ê°€ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤!  ë‹¤ì‹œ ì‹œë„.',0),(80516,2237,'he','×¡×™×¡×ž××•×ª ××™× ×Ÿ ×ž×ª××™×ž×•×ª!  × ×¡×” ×©×•×‘.',0),(80517,2237,'el','ÎšÏ‰Î´Î¹ÎºÎ¿Î¯ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½!  Î”Î¿ÎºÎ¯Î¼Î±ÏƒÎµ Î¾Î±Î½Î¬.',0),(80518,2237,'zh','å¯†ç ä¸åŒ¹é…ï¼å†è¯•ä¸€æ¬¡\r\n',0),(80519,2237,'sv','LÃ¶senorden matchar inte!  FÃ¶rsÃ¶k igen.',0),(80520,2237,'it','Le password non corrispondono!  Riprova.',0),(80521,2237,'tl','',0),(80522,2237,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591; &#3621;&#3629;&#3591;&#3651;&#3627;&#3617;&#3656;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(80523,2237,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚!  à¤«à¤¿à¤° à¤•à¥‹à¤¶à¤¿à¤¶ à¤•à¤°à¥‹.',0),(80524,2237,'ms','Kata laluan tidak padan!  cuba lagi.',0),(80525,2237,'ar','ÙƒÙ„Ù…ØªÙŠÙ‘ Ø§Ù„Ø³Ø±Ù‘ ØºÙŠØ± Ù…ØªØ·Ø§Ø¨Ù‚ØªÙŠÙ† , Ø£Ø¹Ø¯ Ø§Ù„Ù…Ø­Ø§ÙˆÙ„Ø©',0),(80526,2237,'fr','Mots de passe ne correspondent pas !  RÃ©essayez.',0),(80527,2237,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã?Œä¸€è‡´ã?—ã?¾ã?›ã‚“ã€‚ã‚‚ã?†ä¸€åº¦å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(80528,2237,'pt','As senhas nÃ£o coincidem!  Tentar novamente.',0),(80529,2237,'ru','ÐŸÐ°Ñ€Ð¾Ð»Ð¸ Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‚! ÐŸÐ¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÑÐ½Ð¾Ð²Ð°.',0),(80530,2237,'es','ContraseÃ±as no emparejan! Intenta Otra Vez',0),(80531,2237,'de','KennwÃ¶rter stimmen nicht Ã¼berein!  Wiederholen.',0),(80532,2237,'en','Passwords do not match!  Try again.',0),(80533,2238,'is','',0),(80534,2238,'dr','Ø­Ù‚ÙˆÙ‚',0),(80535,2238,'pr','Ø­Ù‚ÙˆÙ‚',0),(80536,2238,'tr','Ã–deme',0),(80537,2238,'pl','ZapÅ‚aciÄ‡',0),(80538,2238,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(80539,2238,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(80540,2238,'sr','ÐŸÐ»Ð°Ñ‚Ð¸',0),(80541,2238,'vi','Thanh ToÃ¡n',0),(80542,2238,'af','Besoldiging',0),(80543,2238,'ro','Plata',0),(80544,2238,'et','Maksma',0),(80545,2238,'si','PlaÄati',0),(80546,2238,'ba','Membayar',0),(80547,2238,'nl','Betalen',0),(80548,2238,'fi','Maksu',0),(80549,2238,'no','Betale',0),(80550,2238,'da','Betale',0),(80551,2238,'ko','ì§€ë¶ˆ',0),(80552,2238,'he','×©×œ×',0),(80553,2238,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹',0),(80554,2238,'zh','æ”¯ä»˜\r\n',0),(80555,2238,'sv','Betala',0),(80556,2238,'it','Pagare',0),(80557,2238,'tl','',0),(80558,2238,'th','&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(80559,2238,'hi','à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(80560,2238,'ms','Membayar',0),(80561,2238,'ar','Ø¯ÙØ¹',0),(80562,2238,'fr','Payer',0),(80563,2238,'jp','æ”¯æ‰•ã?„',0),(80564,2238,'pt','Pagar',0),(80565,2238,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ',0),(80566,2238,'es','Pagar',0),(80567,2238,'de','Zahlen',0),(80568,2238,'en','Pay',0),(80569,2239,'is','',0),(80570,2239,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚',0),(80571,2239,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚',0),(80572,2239,'tr','FaturalarÄ± Ã¶demek',0),(80573,2239,'pl','PÅ‚aciÄ‡ rachunki',0),(80574,2239,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(80575,2239,'ur','Ø¨Ù„ÙˆÚº Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(80576,2239,'sr','ÐŸÐ»Ð°Ñ›Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(80577,2239,'vi','Thanh toÃ¡n hÃ³a Ä‘Æ¡n',0),(80578,2239,'af','Betaal Rekeninge',0),(80579,2239,'ro','Plata facturilor',0),(80580,2239,'et','Maksa arveid',0),(80581,2239,'si','PlaÄilo menice',0),(80582,2239,'ba','Membayar tagihan',0),(80583,2239,'nl','Facturen betalen',0),(80584,2239,'fi','Maksaa laskut',0),(80585,2239,'no','Betale regninger',0),(80586,2239,'da','Betale regninger',0),(80587,2239,'ko','ì²­êµ¬ì„œë¥¼ ì§€ë¶ˆ',0),(80588,2239,'he','×œ×©×œ× ××ª ×”×—×©×‘×•× ×•×ª',0),(80589,2239,'el','Î Î»Î·ÏÏŽÏƒÎµÏ„Îµ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(80590,2239,'zh','æ”¯ä»˜è´¦å•\r\n',0),(80591,2239,'sv','Betala rÃ¤kningar',0),(80592,2239,'it','Pagare le bollette',0),(80593,2239,'tl','',0),(80594,2239,'th','&#3592;&#3656;&#3634;&#3618;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(80595,2239,'hi','à¤¬à¤¿à¤²à¥‹à¤‚ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(80596,2239,'ms','Membayar bil-bil',0),(80597,2239,'ar','Ø¯ÙØ¹ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(80598,2239,'fr','Payez vos factures',0),(80599,2239,'jp','è«‹æ±‚é¡?ã‚’æ”¯æ‰•ã?†',0),(80600,2239,'pt','Pagar contas',0),(80601,2239,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð°',0),(80602,2239,'es','Pagar Recibos',0),(80603,2239,'de','Rechnungen bezahlen',0),(80604,2239,'en','Pay Bills',0),(80605,2240,'is','',0),(80606,2240,'dr','ÙØ§ÙƒØªÙˆØ± Ø­Ù‚ÙˆÙ‚',0),(80607,2240,'pr','ÙØ§ÙƒØªÙˆØ± Ø­Ù‚ÙˆÙ‚',0),(80608,2240,'tr','Fatura Ã¶deme',0),(80609,2240,'pl','ZapÅ‚aty faktury',0),(80610,2240,'bg','ÐŸÐ»Ð°Ñ‰Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°',0),(80611,2240,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(80612,2240,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(80613,2240,'vi','Tráº£ hÃ³a Ä‘Æ¡n',0),(80614,2240,'af','Betaal Faktuur',0),(80615,2240,'ro','PlÄƒti factura',0),(80616,2240,'et','Maksa arve',0),(80617,2240,'si','PlaÄilo raÄuna',0),(80618,2240,'ba','Membayar faktur',0),(80619,2240,'nl','Factuur betalen',0),(80620,2240,'fi','Maksaa laskun',0),(80621,2240,'no','Betale fakturaen',0),(80622,2240,'da','Betale fakturaen',0),(80623,2240,'ko','ì²­êµ¬ì„œë¥¼ ì§€ë¶ˆ',0),(80624,2240,'he','×œ×©×œ× ××ª ×”×—×©×‘×•× ×™×ª',0),(80625,2240,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(80626,2240,'zh','æ”¯ä»˜å‘ç¥¨\r\n',0),(80627,2240,'sv','Betala faktura',0),(80628,2240,'it','Pagare la fattura',0),(80629,2240,'tl','',0),(80630,2240,'th','&#3592;&#3656;&#3634;&#3618;&#3605;&#3634;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(80631,2240,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(80632,2240,'ms','Membayar invois',0),(80633,2240,'ar','Ø¯ÙØ¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(80634,2240,'fr','Payer la facture',0),(80635,2240,'jp','è«‹æ±‚é¡?ã‚’æ”¯æ‰•ã?†',0),(80636,2240,'pt','Pagar fatura',0),(80637,2240,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚',0),(80638,2240,'es','Pagar Factura',0),(80639,2240,'de','Rechnung bezahlen',0),(80640,2240,'en','Pay Invoice',0),(80641,2241,'is','',0),(80642,2241,'dr',' Ø¨Ø¯ÙˆÙ† Ø­Ù‚ÙˆÙ‚',0),(80643,2241,'pr',' Ø¨Ø¯ÙˆÙ† Ø­Ù‚ÙˆÙ‚',0),(80644,2241,'tr','HiÃ§ Ã¶deme',0),(80645,2241,'pl','Brak zapÅ‚aty',0),(80646,2241,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ð½Ð¸Ñ‰Ð¾',0),(80647,2241,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ú¾ÛŒ Ø§Ø¯Ø§',0),(80648,2241,'sr','ÐÐ¸ÐºÐ¾ Ð½Ð¸Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(80649,2241,'vi','ChÆ°a tráº£',0),(80650,2241,'af','Geen Betaling Gemaak',0),(80651,2241,'ro','PlÄƒteascÄƒ nici unul',0),(80652,2241,'et','Maksma Ã¼kski',0),(80653,2241,'si','NiÄ plaÄali',0),(80654,2241,'ba','Membayar tidak ada',0),(80655,2241,'nl','Betalen geen',0),(80656,2241,'fi','Maksu ei',0),(80657,2241,'no','Betal ingen',0),(80658,2241,'da','Betale ingen',0),(80659,2241,'ko','ì—†ìŒ ì§€ë¶ˆ',0),(80660,2241,'he','×œ×©×œ× ××£ ××—×“',0),(80661,2241,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ ÎºÎ±Î½Î­Î½Î±Ï‚',0),(80662,2241,'zh','æ— æ”¯ä»˜\r\n',0),(80663,2241,'sv','Betala ingen',0),(80664,2241,'it','Pagare nessuno',0),(80665,2241,'tl','',0),(80666,2241,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(80667,2241,'hi','à¤•à¥‹à¤ˆ à¤­à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(80668,2241,'ms','Membayar tiada',0),(80669,2241,'ar','Ø¥ÙŠÙ‚Ø§Ù Ø§Ù„Ø³Ø¯Ø§Ø¯',0),(80670,2241,'fr','Payer aucun',0),(80671,2241,'jp','æœªæ‰•ã?„',0),(80672,2241,'pt','Pagar nenhum',0),(80673,2241,'ru','ÐŸÐ»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð½Ð¸ÐºÑ‚Ð¾ Ð½Ðµ',0),(80674,2241,'es','Pagar Ninguno',0),(80675,2241,'de','Zahlen Sie keine',0),(80676,2241,'en','Pay None',0),(80677,2242,'is','',0),(80678,2242,'dr','/ Ø¯ÙˆØ±Ù‡ ',0),(80679,2242,'pr','Ø­Ù‚ÙˆÙ‚ Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª / Ø¯ÙˆØ±Ù‡ ',0),(80680,2242,'tr','Saat/sÃ¼re Ã¶deme',0),(80681,2242,'pl','PÅ‚atne godziny /',0),(80682,2242,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ñ‡Ð°Ñ/Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(80683,2242,'ur','ÙÛŒ Ú¯Ú¾Ù†Ù¹Û/Ø¯ÙˆØ± Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(80684,2242,'sr','ÐŸÐ»Ð°Ñ‚Ð¸Ð¼ Ð¿Ð¾ ÑÐ°Ñ‚Ñƒ/ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(80685,2242,'vi','Tráº£ má»—i giá»/thá»i ká»³',0),(80686,2242,'af','Besoldiging Per Uur/Periode',0),(80687,2242,'ro','Plata pe orÄƒ/perioada',0),(80688,2242,'et','Pay per tund/periood',0),(80689,2242,'si','Pay per Hour/obdobje',0),(80690,2242,'ba','Membayar per jam periode',0),(80691,2242,'nl','Pay-per-uur/periode',0),(80692,2242,'fi','Pay per tunti-aikana',0),(80693,2242,'no','Betal per time /',0),(80694,2242,'da','Pay per time/periode',0),(80695,2242,'ko','ì‹œê°„/ê¸°ê°„ ë‹¹ ì§€ë¶ˆ',0),(80696,2242,'he','×œ×©×œ× ×”×ª×§×•×¤×ª×™/×©×¢×”',0),(80697,2242,'el','Pay per/Ï‰ÏÎ¿',0),(80698,2242,'zh','æ¯å°æ—¶æ”¶è´¹/æœŸ\r\n',0),(80699,2242,'sv','Betala per timme/Period',0),(80700,2242,'it','Pay-per-Hour/periodo',0),(80701,2242,'tl','',0),(80702,2242,'th','&#3592;&#3656;&#3634;&#3618;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;/&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(80703,2242,'hi','à¤˜à¤‚à¤Ÿà¤¾/à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(80704,2242,'ms','Membayar satu tempoh/jam',0),(80705,2242,'ar','Ø§Ù„Ø¯ÙØ¹ Ù„ÙƒÙ„ ÙØªØ±Ø© Ø³Ø§Ø¹Ø©/',0),(80706,2242,'fr','Payer par pÃ©riode/heures',0),(80707,2242,'jp','æ™‚é–“/æœŸé–“ã?”ã?¨ã?®æ”¯æ‰•ã?„',0),(80708,2242,'pt','Pagamento por hora/perÃ­odo',0),(80709,2242,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð² Ñ‡Ð°Ñ/Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(80710,2242,'es','Pago por Hora/PerÃ­odo',0),(80711,2242,'de','Pay-per-Stunden-Zeitraum',0),(80712,2242,'en','Pay per Hour/Period',0),(80713,2243,'is','',0),(80714,2243,'dr','Ø¯ÙˆØ±Ù‡ Ø­Ù‚ÙˆÙ‚  ',0),(80715,2243,'pr','Ø¯ÙˆØ±Ù‡ Ø­Ù‚ÙˆÙ‚  ',0),(80716,2243,'tr','Ã–deme dÃ¶nemi',0),(80717,2243,'pl','Okresu wypÅ‚aty',0),(80718,2243,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(80719,2243,'ur','Ø¯ÙˆØ± Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(80720,2243,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(80721,2243,'vi','Thá»i ká»³ tráº£',0),(80722,2243,'af','Vergoeding Periode',0),(80723,2243,'ro','PlÄƒteascÄƒ perioada',0),(80724,2243,'et','Maksmise perioodi',0),(80725,2243,'si','PlaÄati obdobje',0),(80726,2243,'ba','Membayar periode',0),(80727,2243,'nl','Betalen periode',0),(80728,2243,'fi','Palkanmaksu',0),(80729,2243,'no','Betale periode',0),(80730,2243,'da','Betale periode',0),(80731,2243,'ko','ì§€ë¶ˆ ê¸°ê°„',0),(80732,2243,'he','×œ×©×œ× ×ª×§×•×¤×”',0),(80733,2243,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(80734,2243,'zh','æ”¯ä»˜å‘¨æœŸ\r\n',0),(80735,2243,'sv','Betala Period',0),(80736,2243,'it','Periodo di paga',0),(80737,2243,'tl','',0),(80738,2243,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;',0),(80739,2243,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿',0),(80740,2243,'ms','Membayar tempoh',0),(80741,2243,'ar','ÙØªØ±Ø© Ø§Ù„Ø¯ÙØ¹',0),(80742,2243,'fr','PÃ©riode de paye',0),(80743,2243,'jp','æ”¯æ‰•æœŸé–“',0),(80744,2243,'pt','Pagar o perÃ­odo',0),(80745,2243,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´Ð°',0),(80746,2243,'es','PerÃ­odo de Pago',0),(80747,2243,'de','Zahlungsperiode',0),(80748,2243,'en','Pay Period',0),(80749,2244,'is','',0),(80750,2244,'dr','Ù†Ø±Ø® Ø­Ù‚ÙˆÙ‚',0),(80751,2244,'pr','Ù†Ø±Ø® Ø­Ù‚ÙˆÙ‚',0),(80752,2244,'tr','Ã–deme oranÄ±',0),(80753,2244,'pl','Stawka pÅ‚acowa',0),(80754,2244,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(80755,2244,'ur','Ø´Ø±Ø­ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(80756,2244,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ ÑÑ‚Ð¾Ð¿Ð°',0),(80757,2244,'vi','GiÃ¡ thanh toÃ¡n',0),(80758,2244,'af','Besoldigingskaal',0),(80759,2244,'ro','PlÄƒteascÄƒ rata',0),(80760,2244,'et','Maksma mÃ¤Ã¤r',0),(80761,2244,'si','PlaÄilo teÄaja',0),(80762,2244,'ba','Membayar TARIF',0),(80763,2244,'nl','Tarief betalen',0),(80764,2244,'fi','Taksa',0),(80765,2244,'no','LÃ¸nnssats',0),(80766,2244,'da','LÃ¸nsats',0),(80767,2244,'ko','ìš”ê¸ˆì„ ì§€ë¶ˆ',0),(80768,2244,'he','×œ×©×œ× ×ª×¢×¨×™×£',0),(80769,2244,'el','ÎœÎ¹ÏƒÎ¸ÏŒÏ‚',0),(80770,2244,'zh','å·¥èµ„çŽ‡\r\n',0),(80771,2244,'sv','LÃ¶nesats',0),(80772,2244,'it','Pagare la tariffa',0),(80773,2244,'tl','',0),(80774,2244,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(80775,2244,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤°',0),(80776,2244,'ms','Membayar kadar',0),(80777,2244,'ar','Ù…Ø¹Ø¯Ù„ Ø§Ù„Ø¯ÙØ¹',0),(80778,2244,'fr','Taux de rÃ©munÃ©ration',0),(80779,2244,'jp','æ”¯æ‰•ã?„ãƒ¬ãƒ¼ãƒˆ',0),(80780,2244,'pt','Pagar a taxa de',0),(80781,2244,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ ÐºÑƒÑ€Ñ',0),(80782,2244,'es','Tasa de Pago',0),(80783,2244,'de','Bezahlen',0),(80784,2244,'en','Pay Rate',0),(80785,2245,'is','',0),(80786,2245,'dr','Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(80787,2245,'pr','Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(80788,2245,'tr','Ã–deme ÅŸartlarÄ± zaten var',0),(80789,2245,'pl','Warunki wynagrodzenia juÅ¼ istnieje',0),(80790,2245,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(80791,2245,'ur','ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(80792,2245,'sr','ÐŸÐ»Ð°Ñ‚Ðµ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð¸ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ðµ',0),(80793,2245,'vi','Äiá»u khoáº£n thanh toÃ¡n Ä‘Ã£ tá»“n táº¡i',0),(80794,2245,'af','Besoldigingterme bestaan reeds',0),(80795,2245,'ro','Termeni de platÄƒ deja exista',0),(80796,2245,'et','TÃ¶Ã¶tasu tingimused juba olemas',0),(80797,2245,'si','PlaÄilo pogoji Å¾e obstajajo',0),(80798,2245,'ba','Bayar persyaratan sudah ada',0),(80799,2245,'nl','Betalen voorwaarden reeds bestaan',0),(80800,2245,'fi','Maksu ehdot jo olemassa',0),(80801,2245,'no','Betal vilkÃ¥r allerede finnes',0),(80802,2245,'da','Betalings betingelser allerede findes',0),(80803,2245,'ko','ì§€ë¶ˆ ìš©ì–´ ì´ë¯¸ ì¡´ìž¬',0),(80804,2245,'he','×ª× ××™ ×”×©×›×¨ ×›×‘×¨ ×§×™×™×',0),(80805,2245,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÏŒÏÎ¿Î¹ Î±Î¼Î¿Î¹Î²Î®Ï‚ Î®Î´Î·',0),(80806,2245,'zh','å·¥èµ„æ–¹é¢å­˜åœ¨\r\n',0),(80807,2245,'sv','LÃ¶n finns redan',0),(80808,2245,'it','Termini di pagamento giÃ  esiste',0),(80809,2245,'tl','',0),(80810,2245,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;',0),(80811,2245,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦',0),(80812,2245,'ms','Terma-terma gaji sudah wujud',0),(80813,2245,'ar','Ø´Ø±ÙˆØ· Ø§Ù„Ø¯ÙØ¹ Ù…ÙˆØ¬ÙˆØ¯Ø© Ù…Ø³Ø¨Ù‚Ø§',0),(80814,2245,'fr','Conditions de rÃ©munÃ©ration dÃ©jÃ  exister',0),(80815,2245,'jp','æ”¯æ‰•æ?¡ä»¶ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(80816,2245,'pt','Termos de pagamento jÃ¡ existe',0),(80817,2245,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(80818,2245,'es','TÃ©rminos de Pagos ya existen',0),(80819,2245,'de','Pay-Bedingungen bereits vorhanden',0),(80820,2245,'en','Pay Terms already exist',0),(80821,2246,'is','',0),(80822,2246,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ø¢Ø¯Ø±Ø³',0),(80823,2246,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ø¢Ø¯Ø±Ø³',0),(80824,2246,'tr','Ä°Ã§in Ã¶deme<br>Adres',0),(80825,2246,'pl','OpÅ‚aca siÄ™<br>Adres',0),(80826,2246,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð°<br>ÐÐ´Ñ€ÐµÑ',0),(80827,2246,'ur','Ø§Ø¯Ø§ Ú©Ø±Ù†Ø§<br>Ù¾ØªØ§',0),(80828,2246,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð°<br>ÐÐ´Ñ€ÐµÑÐ°',0),(80829,2246,'vi','Tráº£ choÄá»‹a chá»‰',0),(80830,2246,'af','Besoldiging Aan<br>Adres',0),(80831,2246,'ro','PlÄƒteascÄƒ<br>Adresa',0),(80832,2246,'et','Maksa<br>Aadress',0),(80833,2246,'si','PlaÄilo za<br>Naslov',0),(80834,2246,'ba','Membayar untuk<br>Alamat',0),(80835,2246,'nl','Betalen aan<br>Adres',0),(80836,2246,'fi','Maksaa<br>Osoite',0),(80837,2246,'no','Betale<br>Adresse',0),(80838,2246,'da','Betale til<br>Adresse',0),(80839,2246,'ko','ì§€ë¶ˆ<br>ì£¼ì†Œ',0),(80840,2246,'he','×œ×©×œ×<br>×›×ª×•×‘×ª',0),(80841,2246,'el','ÎÎ±<br>Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(80842,2246,'zh','æ”¯ä»˜åˆ°åœ°å€\r\n',0),(80843,2246,'sv','Betala till<br>Adress',0),(80844,2246,'it','Pagare per<br>Indirizzo',0),(80845,2246,'tl','',0),(80846,2246,'th','&#3592;&#3656;&#3634;&#3618;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(80847,2246,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨<br>à¤ªà¤¤à¥‡',0),(80848,2246,'ms','Membayar kepada<br>Alamat',0),(80849,2246,'ar','Ø¯ÙØ¹ Ø¥Ù„Ù‰<br>Ø¹Ù†ÙˆØ§Ù†',0),(80850,2246,'fr','Payer Ã <br>Adresse',0),(80851,2246,'jp','æ”¯æ‰•ã?„å…ˆ<br>ä½?æ‰€',0),(80852,2246,'pt','Pagar para<br>EndereÃ§o',0),(80853,2246,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ<br>ÐÐ´Ñ€ÐµÑ',0),(80854,2246,'es','Pagar a<br>DirecciÃ³n',0),(80855,2246,'de','Zollen<br>Adresse',0),(80856,2246,'en','Pay to<br>Address',0),(80857,2247,'is','',0),(80858,2247,'dr','- Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø±ÙƒØª',0),(80859,2247,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡- Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø±ÙƒØª',0),(80860,2247,'tr','Firma bilgileri iÃ§in Ã¶deme',0),(80861,2247,'pl','PÅ‚acÄ… PaÅ„stwo informacje o firmie',0),(80862,2247,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(80863,2247,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ø§Ø¯Ø§',0),(80864,2247,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð° Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(80865,2247,'vi','ThÃ´ng Tin thanh toÃ¡n cho Cty',0),(80866,2247,'af','Betaal Aan Onderneming Inligting',0),(80867,2247,'ro','Plata la compania Info',0),(80868,2247,'et','Maksta ettevÃµtte Info',0),(80869,2247,'si','PlaÄa druÅ¾bi Info',0),(80870,2247,'ba','Membayar untuk Info Perusahaan',0),(80871,2247,'nl','Betalen aan Bedrijfsinfo',0),(80872,2247,'fi','Yritys maksaa',0),(80873,2247,'no','Betale til firmainformasjon',0),(80874,2247,'da','Betale til firma Info',0),(80875,2247,'ko','íšŒì‚¬ ì •ë³´ë¥¼ ì§€ë¶ˆ',0),(80876,2247,'he','×œ×©×œ× ×¢×œ ×¤×¨×˜×™ ×”×—×‘×¨×”',0),(80877,2247,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Î³Î¹Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎ¯Î±',0),(80878,2247,'zh','æ”¶æ¬¾å…¬å¸ä¿¡æ¯\r\n',0),(80879,2247,'sv','Betala till fÃ¶retag information',0),(80880,2247,'it','Pagare all\'azienda Info',0),(80881,2247,'tl','',0),(80882,2247,'th','&#3592;&#3656;&#3634;&#3618;&#3651;&#3627;&#3657;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(80883,2247,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(80884,2247,'ms','Membayar kepada maklumat Syarikat',0),(80885,2247,'ar','Ø¯ÙØ¹ Ø¥Ù„Ù‰ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ©',0),(80886,2247,'fr','Payer Ã  la sociÃ©tÃ© d\'informations',0),(80887,2247,'jp','æ”¯æ‰•ã?„å…ˆä¼šç¤¾æƒ…å ±',0),(80888,2247,'pt','Prestar informaÃ§Ã£o de companhia',0),(80889,2247,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(80890,2247,'es','Info de Pagar a Empresa',0),(80891,2247,'de','Zollen Firmeninfo',0),(80892,2247,'en','Pay To Company Info',0),(80893,2248,'is','',0),(80894,2248,'dr','- Ø§ÙŠÙ…ÙŠÙ„',0),(80895,2248,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ - Ø§ÙŠÙ…ÙŠÙ„',0),(80896,2248,'tr','Ä°Ã§in Ã¶deme<br>E-posta',0),(80897,2248,'pl','OpÅ‚aca siÄ™<br>Adres e-mail',0),(80898,2248,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð°<br>Ð˜Ð¼ÐµÐ¹Ð»',0),(80899,2248,'ur','Ø§Ø¯Ø§ Ú©Ø±Ù†Ø§<br>Ø§ÛŒ Ù…ÛŒÙ„',0),(80900,2248,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð°<br>Ð•-Ð¿Ð¾ÑˆÑ‚Ð°',0),(80901,2248,'vi','Email tráº£ cho',0),(80902,2248,'af','Betaal AanE-pos',0),(80903,2248,'ro','PlÄƒteascÄƒ<br>E-mail',0),(80904,2248,'et','Maksa<br>E-posti',0),(80905,2248,'si','PlaÄilo za<br>Email',0),(80906,2248,'ba','Membayar untuk<br>Email',0),(80907,2248,'nl','Betalen aan<br>E-mail',0),(80908,2248,'fi','Maksaa<br>SÃ¤hkÃ¶posti',0),(80909,2248,'no','Betale<br>E-post',0),(80910,2248,'da','Betale til<br>E-mail',0),(80911,2248,'ko','ì§€ë¶ˆ<br>ë©”ì¼ ì£¼ì†Œ',0),(80912,2248,'he','×œ×©×œ×<br>×“×•×',0),(80913,2248,'el','ÎÎ±<br>Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(80914,2248,'zh','æ”¶æ¬¾äººç”µå­é‚®ä»¶\r\n',0),(80915,2248,'sv','Betala till<br>E-post',0),(80916,2248,'it','Pagare per<br>Posta elettronica',0),(80917,2248,'tl','',0),(80918,2248,'th','&#3592;&#3656;&#3634;&#3618;&#3651;&#3627;&#3657;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(80919,2248,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨<br>à¤ˆà¤®à¥‡à¤²',0),(80920,2248,'ms','Membayar kepada<br>E-mel',0),(80921,2248,'ar','Ø¯ÙØ¹ Ø¥Ù„Ù‰<br>Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(80922,2248,'fr','Payer Ã <br>Messagerie',0),(80923,2248,'jp','æ”¯æ‰•ã?„<br>ï¼¥-ï½?ï½?ï½‰ï½Œ',0),(80924,2248,'pt','Pagar para<br>Email',0),(80925,2248,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ<br>ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(80926,2248,'es','Pagar a<br>Email',0),(80927,2248,'de','Zollen<br>E-Mail',0),(80928,2248,'en','Pay to<br>Email',0),(80929,2249,'is','',0),(80930,2249,'dr','- ØªÛŒÙ„ÛŒÙÙˆÙ†',0),(80931,2249,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ - ØªÙ„ÙÙ†',0),(80932,2249,'tr','Ä°Ã§in Ã¶deme<br>Telefon',0),(80933,2249,'pl','OpÅ‚aca siÄ™<br>Telefon',0),(80934,2249,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð°<br>Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(80935,2249,'ur','Ø§Ø¯Ø§ Ú©Ø±Ù†Ø§<br>ÙÙˆÙ†',0),(80936,2249,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð°<br>Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(80937,2249,'vi','Tráº£ choPhone',0),(80938,2249,'af','Betaal Aan<br>Foon',0),(80939,2249,'ro','PlÄƒteascÄƒ<br>Telefon',0),(80940,2249,'et','Maksa<br>Telefoni',0),(80941,2249,'si','PlaÄilo za<br>Telefon',0),(80942,2249,'ba','Membayar untuk<br>Telepon',0),(80943,2249,'nl','Betalen aan<br>Telefoon',0),(80944,2249,'fi','Maksaa<br>Puhelin',0),(80945,2249,'no','Betale<br>Telefon',0),(80946,2249,'da','Betale til<br>Telefon',0),(80947,2249,'ko','ì§€ë¶ˆ<br>ì „í™”',0),(80948,2249,'he','×œ×©×œ×<br>×˜×œ×¤×•×Ÿ',0),(80949,2249,'el','ÎÎ±<br>Î¤Î·Î»Î­Ï†Ï‰Î½Î¿',0),(80950,2249,'zh','æ”¶æ¬¾äººç”µè¯\r\n',0),(80951,2249,'sv','Betala till<br>Telefon',0),(80952,2249,'it','Pagare per<br>Telefono',0),(80953,2249,'tl','',0),(80954,2249,'th','&#3592;&#3656;&#3634;&#3618;&#3651;&#3627;&#3657;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(80955,2249,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨<br>à¤«à¥‹à¤¨',0),(80956,2249,'ms','Membayar kepada<br>Telefon',0),(80957,2249,'ar','Ø¯ÙØ¹ Ø¥Ù„Ù‰<br>Ø§Ù„Ù‡Ø§ØªÙ',0),(80958,2249,'fr','Payer Ã <br>TÃ©lÃ©phone',0),(80959,2249,'jp','æ”¯æ‰•ã?„å…ˆ<br>é›»è©±',0),(80960,2249,'pt','Pagar para<br>Telefone',0),(80961,2249,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ<br>Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(80962,2249,'es','Pagar a<br>TelÃ©fono',0),(80963,2249,'de','Zollen<br>Telefon',0),(80964,2249,'en','Pay to<br>Phone',0),(80965,2250,'is','',0),(80966,2250,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(80967,2250,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(80968,2250,'tr','SatÄ±cÄ±ya Ã¶deme',0),(80969,2250,'pl','ZapÅ‚aciÄ‡ sprzedajÄ…cemu',0),(80970,2250,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(80971,2250,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û Ø³Û’ Ø§Ø¯Ø§ Ú©Ø±ØªÛ’ ÛÛŒÚº',0),(80972,2250,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ñƒ',0),(80973,2250,'vi','Tráº£ cho ngÆ°á»i bÃ¡n',0),(80974,2250,'af','Betaal Aan Verskaffer',0),(80975,2250,'ro','Plata furnizor',0),(80976,2250,'et','Maksa tarnijale',0),(80977,2250,'si','PlaÄati prodajalcu',0),(80978,2250,'ba','Membayar vendor',0),(80979,2250,'nl','Betalen aan leverancier',0),(80980,2250,'fi','Maksu toimittajalle',0),(80981,2250,'no','Betale leverandÃ¸ren',0),(80982,2250,'da','Betale til kreditor',0),(80983,2250,'ko','ê³µê¸‰ ì—…ì²´ ì§€ë¶ˆ',0),(80984,2250,'he','×©×œ× ×œ×¡×¤×§',0),(80985,2250,'el','Î Î»Î·ÏÏ‰Î¼Î® ÏƒÎµ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(80986,2250,'zh','æ”¶æ¬¾ä¾›åº”å•†\r\n',0),(80987,2250,'sv','Betala till leverantÃ¶ren',0),(80988,2250,'it','Pagare al fornitore',0),(80989,2250,'tl','',0),(80990,2250,'th','&#3592;&#3656;&#3634;&#3618;&#3651;&#3627;&#3657;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(80991,2250,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(80992,2250,'ms','Membayar kepada penjual.',0),(80993,2250,'ar','Ø§Ù„Ø¯ÙØ¹ Ù„Ù„Ù…ÙˆØ±Ø¯',0),(80994,2250,'fr','Payer au fournisseur',0),(80995,2250,'jp','æ”¯æ‰•ã?„å…ˆæ¥­è€…',0),(80996,2250,'pt','Pagar ao fornecedor',0),(80997,2250,'ru','ÐŸÐ»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÑƒ',0),(80998,2250,'es','Pagar a Proveedor',0),(80999,2250,'de','Zahlung an Lieferanten',0),(81000,2250,'en','Pay To Vendor',0),(81001,2251,'is','',0),(81002,2251,'dr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(81003,2251,'pr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(81004,2251,'tr','Ã–deme tipi',0),(81005,2251,'pl','Typ pÅ‚atnoÅ›ci',0),(81006,2251,'bg','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ‚Ð¸Ð¿',0),(81007,2251,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(81008,2251,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ‚Ð¸Ð¿',0),(81009,2251,'vi','Loáº¡i thanh toÃ¡n',0),(81010,2251,'af','Betaal Tipe',0),(81011,2251,'ro','PlÄƒteascÄƒ tip',0),(81012,2251,'et','Tasu tÃ¼Ã¼p',0),(81013,2251,'si','PlaÄati tipa',0),(81014,2251,'ba','Membayar jenis',0),(81015,2251,'nl','Type betalen',0),(81016,2251,'fi','Maksulaji',0),(81017,2251,'no','LÃ¸nnstype',0),(81018,2251,'da','LÃ¸nart',0),(81019,2251,'ko','ì§€ë¶ˆ ìœ í˜•',0),(81020,2251,'he','×¡×•×’ ×©×›×¨',0),(81021,2251,'el','Î¤ÏÏŒÏ€Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(81022,2251,'zh','æ”¯ä»˜ç±»åž‹\r\n',0),(81023,2251,'sv','LÃ¶netyp',0),(81024,2251,'it','Pagare tipo',0),(81025,2251,'tl','',0),(81026,2251,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(81027,2251,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(81028,2251,'ms','Membayar jenis',0),(81029,2251,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹',0),(81030,2251,'fr','Type de paiement',0),(81031,2251,'jp','æ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—',0),(81032,2251,'pt','Pagar tipo',0),(81033,2251,'ru','Ð¢Ð¸Ð¿ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(81034,2251,'es','Tipo de Pago',0),(81035,2251,'de','Lohnart',0),(81036,2251,'en','Pay Type',0),(81037,2252,'is','',0),(81038,2252,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(81039,2252,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(81040,2252,'tr','Ã–deme tipi baÅŸarÄ±yla eklendi',0),(81041,2252,'pl','PomyÅ›lnie dodano typ pÅ‚atnoÅ›ci',0),(81042,2252,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(81043,2252,'ur','Ù‚Ø³Ù… Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ø§Ø¯Ø§',0),(81044,2252,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ‚Ð¸Ð¿ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(81045,2252,'vi','ThÃªm Loáº¡i thanh toÃ¡n thÃ nh cÃ´ng',0),(81046,2252,'af','Betaal Tipe suksesvol Bygevoeg',0),(81047,2252,'ro','PlÄƒteascÄƒ tip adÄƒugat cu succes',0),(81048,2252,'et','Lisatud tasutÃ¼Ã¼p',0),(81049,2252,'si','PlaÄilo uspeÅ¡no dodana vrsta',0),(81050,2252,'ba','Membayar jenis ditambahkan berhasil',0),(81051,2252,'nl','Betalen Type toegevoegd',0),(81052,2252,'fi','Maksulaji lisÃ¤Ã¤minen onnistui',0),(81053,2252,'no','LÃ¸nnstype lagt',0),(81054,2252,'da','LÃ¸nart tilfÃ¸jet',0),(81055,2252,'ko','í˜•ì‹ì„ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì§€ë¶ˆ',0),(81056,2252,'he','×¡×•×’ × ×•×¡×£ ×‘×”×¦×œ×—×” ×©×›×¨',0),(81057,2252,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Ï„ÏÏ€Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(81058,2252,'zh','æ”¯ä»˜ç±»åž‹æ·»åŠ æˆåŠŸ\r\n',0),(81059,2252,'sv','LÃ¶netyp som lagts',0),(81060,2252,'it','Pagare tipo aggiunto con successo',0),(81061,2252,'tl','',0),(81062,2252,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(81063,2252,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(81064,2252,'ms','Membayar jenis berjaya menambah',0),(81065,2252,'ar','Ø¯ÙØ¹ Ù†ÙˆØ¹ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(81066,2252,'fr','Payer Type ajoutÃ© avec succÃ¨s',0),(81067,2252,'jp','æ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(81068,2252,'pt','Pagar tipo adicionado com sucesso',0),(81069,2252,'ru','Ð¢Ð¸Ð¿ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(81070,2252,'es','Tipo de Pago agregado exitosamente',0),(81071,2252,'de','Lohnart erfolgreich hinzugefÃ¼gt',0),(81072,2252,'en','Pay Type added successfully',0),(81073,2253,'is','',0),(81074,2253,'dr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(81075,2253,'pr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(81076,2253,'tr','Ã–deme tÃ¼rÃ¼ zaten var',0),(81077,2253,'pl','Typ pÅ‚atnoÅ›ci juÅ¼ istnieje',0),(81078,2253,'bg','Ð’ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ñ‚Ð¸Ð¿ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(81079,2253,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(81080,2253,'sr','ÐŸÐ»Ð°Ñ‚Ðµ Ñ‚Ð¸Ð¿ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(81081,2253,'vi','Loáº¡i thanh toÃ¡n Ä‘Ã£ tá»“n táº¡i',0),(81082,2253,'af','Betaal Tipe Bestaan Alreeds',0),(81083,2253,'ro','Tipul de plata existÄƒ deja',0),(81084,2253,'et','Tasu tÃ¼Ã¼p on juba olemas',0),(81085,2253,'si','PlaÄilo vrsta Å¾e obstaja',0),(81086,2253,'ba','Jenis membayar sudah ada',0),(81087,2253,'nl','Betalen Type bestaat al',0),(81088,2253,'fi','Maksulaji on jo olemassa',0),(81089,2253,'no','LÃ¸nnstypen finnes allerede',0),(81090,2253,'da','LÃ¸nart findes allerede',0),(81091,2253,'ko','ì´ë¯¸ ì§€ë¶ˆ ìœ í˜•',0),(81092,2253,'he','×¡×•×’ ×”×©×›×¨ ×›×‘×¨ ×§×™×™×',0),(81093,2253,'el','Î‘Î¼Î¿Î¹Î²Î® Ï„Î¿Ï… ÎµÎ¯Î´Î¿Ï…Ï‚ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(81094,2253,'zh','æ”¯ä»˜ç±»åž‹å·²å­˜åœ¨\r\n',0),(81095,2253,'sv','LÃ¶netyp finns redan',0),(81096,2253,'it','Tipo di retribuzione esiste giÃ ',0),(81097,2253,'tl','',0),(81098,2253,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(81099,2253,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(81100,2253,'ms','Membayar jenis telah wujud',0),(81101,2253,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹ Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„',0),(81102,2253,'fr','Type de salaire existe dÃ©jÃ ',0),(81103,2253,'jp','æ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(81104,2253,'pt','Tipo de pagamento jÃ¡ existe',0),(81105,2253,'ru','Ð¢Ð¸Ð¿ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð° ÑƒÐ¶Ðµ Ð¸Ð¼ÐµÐµÑ‚ÑÑ',0),(81106,2253,'es','Tipo de Pago y existe',0),(81107,2253,'de','Lohnart ist bereits vorhanden.',0),(81108,2253,'en','Pay Type already exists',0),(81109,2254,'is','',0),(81110,2254,'dr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(81111,2254,'pr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(81112,2254,'tr','Ã–deme tipi baÅŸarÄ±yla silindi',0),(81113,2254,'pl','UsuniÄ™ty typ pÅ‚atnoÅ›ci',0),(81114,2254,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ñ‚Ð¸Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(81115,2254,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù‚Ø³Ù… Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(81116,2254,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ‚Ð¸Ð¿ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(81117,2254,'vi','XÃ³a Loáº¡i thanh toÃ¡n thÃ nh cÃ´ng',0),(81118,2254,'af','Betaal Tipe suksesvol geskrap',0),(81119,2254,'ro','PlÄƒteascÄƒ tip eliminÄƒ cu succes',0),(81120,2254,'et','Tasu tÃ¼Ã¼p edukalt kustutatud',0),(81121,2254,'si','PlaÄati vrsto uspeÅ¡no izbrisana',0),(81122,2254,'ba','Membayar jenis dihapus berhasil',0),(81123,2254,'nl','Betalen Type met succes verwijderd',0),(81124,2254,'fi','Maksulaji, poistettu',0),(81125,2254,'no','LÃ¸nnstype slettet',0),(81126,2254,'da','LÃ¸nart slettet',0),(81127,2254,'ko','ì§€ë¶ˆ í˜•ì‹ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(81128,2254,'he','×¡×•×’ × ×ž×—×§ ×‘×”×¦×œ×—×” ×©×›×¨',0),(81129,2254,'el','Î¤ÏÏŒÏ€Î¿Ï‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(81130,2254,'zh','æ”¯ä»˜ç±»åž‹åˆ é™¤æˆåŠŸ\r\n',0),(81131,2254,'sv','LÃ¶netyp som raderades',0),(81132,2254,'it','Pagare tipo eliminato con successo',0),(81133,2254,'tl','',0),(81134,2254,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(81135,2254,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(81136,2254,'ms','Membayar jenis dihapuskan dengan jayanya',0),(81137,2254,'ar','Ø¯ÙØ¹ Ù†ÙˆØ¹ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(81138,2254,'fr','Payer Type supprimÃ© avec succÃ¨s',0),(81139,2254,'jp','æ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(81140,2254,'pt','Pagar tipo apagado com sucesso',0),(81141,2254,'ru','Ð¢Ð¸Ð¿ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(81142,2254,'es','Tipo de Pago eliminado exitosamente',0),(81143,2254,'de','Lohnart erfolgreich gelÃ¶scht',0),(81144,2254,'en','Pay Type deleted successfully',0),(81145,2255,'is','',0),(81146,2255,'dr','Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(81147,2255,'pr','Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(81148,2255,'tr','Ã–deme tipi oranÄ± baÅŸarÄ±yla silindi',0),(81149,2255,'pl','ZapÅ‚aciÄ‡ typu ocena przesâ”‚anie',0),(81150,2255,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ñ‚Ð¸Ð¿ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(81151,2255,'ur','Ù‚Ø³Ù… Ú©ÛŒ Ø±ÛŒÙ¹Ù†Ú¯ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(81152,2255,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ‚Ð¸Ð¿ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(81153,2255,'vi','XÃ³a ÄÃ¡nh giÃ¡ Loáº¡i thanh toÃ¡n thÃ nh cÃ´ng',0),(81154,2255,'af','Betaal Tipe Gradering suksesvol geskrap',0),(81155,2255,'ro','PlÄƒteascÄƒ evaluare de tip eliminÄƒ cu succes',0),(81156,2255,'et','Maksma tÃ¼Ã¼bipÃ¤devuse edukalt kustutatud',0),(81157,2255,'si','PlaÄati rating za tip, uspeÅ¡no izbrisana',0),(81158,2255,'ba','Membayar rating tipe yang berhasil dihapus',0),(81159,2255,'nl','Betalen Type rating met succes verwijderd',0),(81160,2255,'fi','Maksu tyyppikelpuutusta poistettu',0),(81161,2255,'no','Betale Type rating slettet',0),(81162,2255,'da','Betale Type rating slettet',0),(81163,2255,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ìœ í˜• ë“±ê¸‰ ì§€ë¶ˆ',0),(81164,2255,'he','×œ×©×œ× ×“×™×¨×•×’ ×¡×•×’ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(81165,2255,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Î¹ÎºÎ±Î½ÏŒÏ„Î·Ï„Î±Ï‚ Ï„ÏÏ€Î¿Ï… Ï‡ÎµÎ¹ÏÎ¹ÏƒÏ„Î¿Ï Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(81166,2255,'zh','åž‹åˆ«ç­‰çº§æ”¯ä»˜æˆåŠŸåˆ é™¤\r\n',0),(81167,2255,'sv','Betala typbehÃ¶righeten raderades',0),(81168,2255,'it','Pagare la valutazione di tipo eliminato con successo',0),(81169,2255,'tl','',0),(81170,2255,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(81171,2255,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(81172,2255,'ms','Membayar jenis penilaian dihapuskan dengan jayanya',0),(81173,2255,'ar','ØªØ¯ÙØ¹ ÙÙŠ ØªØµÙ†ÙŠÙ Ù†ÙˆØ¹ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(81174,2255,'fr','Payer la qualification de Type supprimÃ©e avec succÃ¨s',0),(81175,2255,'jp','æ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(81176,2255,'pt','Pagar a classificaÃ§Ã£o tipo apagada com sucesso',0),(81177,2255,'ru','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ñ‚Ð¸Ð¿Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(81178,2255,'es','ClasificaciÃ³n de tipo de pago eliminada exitosamente',0),(81179,2255,'de','Zahlen Sie Type Rating erfolgreich gelÃ¶scht',0),(81180,2255,'en','Pay Type rating deleted successfully',0),(81181,2256,'is','',0),(81182,2256,'dr','Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(81183,2256,'pr','Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(81184,2256,'tr','Ã–deme tipi oranÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(81185,2256,'pl','ZapÅ‚aciÄ‡ typu ocena pomyÅ›lnie zaktualizowana',0),(81186,2256,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ñ‚Ð¸Ð¿ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(81187,2256,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(81188,2256,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ‚Ð¸Ð¿ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(81189,2256,'vi','Cáº­p Nháº­t ÄÃ¡nh GiÃ¡ Loáº¡i LÆ°Æ¡ng thÃ nh cÃ´ng',0),(81190,2256,'af','Betaal Tipe Gradering suksesvol opdateer',0),(81191,2256,'ro','PlÄƒteascÄƒ evaluare de tip actualizat cu succes',0),(81192,2256,'et','Maksma tÃ¼Ã¼bipÃ¤devuse vÃ¤rskendatud',0),(81193,2256,'si','PlaÄati rating za tip, uspeÅ¡no posodobljena',0),(81194,2256,'ba','Membayar rating tipe yang berhasil',0),(81195,2256,'nl','Betalen Type rating bijgewerkt',0),(81196,2256,'fi','Maksu tyyppikelpuutusta pÃ¤ivitetty',0),(81197,2256,'no','Betale Type rating oppdatert',0),(81198,2256,'da','Betale Type rating opdateret',0),(81199,2256,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ìœ í˜• ë“±ê¸‰ ì§€ë¶ˆ',0),(81200,2256,'he','×œ×©×œ× ×“×™×¨×•×’ ×¡×•×’ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(81201,2256,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Î¹ÎºÎ±Î½ÏŒÏ„Î·Ï„Î±Ï‚ Ï„ÏÏ€Î¿Ï… Ï‡ÎµÎ¹ÏÎ¹ÏƒÏ„Î¿Ï ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(81202,2256,'zh','åž‹åˆ«ç­‰çº§æ”¯ä»˜æˆåŠŸæ›´æ–°\r\n',0),(81203,2256,'sv','Betala typbehÃ¶righeten uppdaterats',0),(81204,2256,'it','Pagare la valutazione di tipo aggiornato con successo',0),(81205,2256,'tl','',0),(81206,2256,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3',0),(81207,2256,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(81208,2256,'ms','Membayar jenis penilaian yang berjaya dikemas kini',0),(81209,2256,'ar','ØªØ¯ÙØ¹ ÙÙŠ ØªØµÙ†ÙŠÙ Ù†ÙˆØ¹ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(81210,2256,'fr','Qualification de Type mise Ã  jour rÃ©ussie de payer',0),(81211,2256,'jp','æ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(81212,2256,'pt','Pagar a classificaÃ§Ã£o tipo atualizada com sucesso',0),(81213,2256,'ru','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ñ‚Ð¸Ð¿Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(81214,2256,'es','ClasificaciÃ³n de tipo de pago actualizada exitosamente',0),(81215,2256,'de','Zahlen Sie Type Rating erfolgreich aktualisiert',0),(81216,2256,'en','Pay Type rating updated successfully',0),(81217,2257,'is','',0),(81218,2257,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(81219,2257,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(81220,2257,'tr','Ã–deme tipi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(81221,2257,'pl','Typ pomyÅ›lnie zaktualizowana pÅ‚atnoÅ›ci',0),(81222,2257,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ñ‚Ð¸Ð¿ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(81223,2257,'ur','Ù‚Ø³Ù… Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ø§Ø¯Ø§',0),(81224,2257,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ‚Ð¸Ð¿ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(81225,2257,'vi','Cáº­p Nháº­t Loáº¡i LÆ°Æ¡ng thÃ nh cÃ´ng',0),(81226,2257,'af','Betaal Tipe suksesvol opdateer',0),(81227,2257,'ro','PlÄƒteascÄƒ tip actualizat cu succes',0),(81228,2257,'et','Tasu tÃ¼Ã¼p vÃ¤rskendamine Ãµnnestus',0),(81229,2257,'si','PlaÄati vrsto uspeÅ¡no posodobljena',0),(81230,2257,'ba','Membayar jenis diperbarui berhasil',0),(81231,2257,'nl','Betalen Type bijgewerkt',0),(81232,2257,'fi','PÃ¤ivitetty maksulaji',0),(81233,2257,'no','LÃ¸nnstype oppdatert',0),(81234,2257,'da','LÃ¸nart opdateret',0),(81235,2257,'ko','ì§€ë¶ˆ í˜•ì‹ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(81236,2257,'he','×¡×•×’ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×” ×©×›×¨',0),(81237,2257,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Ï„ÏÏ€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(81238,2257,'zh','æ”¯ä»˜ç±»åž‹æˆåŠŸæ›´æ–°\r\n',0),(81239,2257,'sv','LÃ¶netyp som uppdaterats',0),(81240,2257,'it','Pagare tipo aggiornato con successo',0),(81241,2257,'tl','',0),(81242,2257,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(81243,2257,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(81244,2257,'ms','Membayar jenis berjaya dikemas kini',0),(81245,2257,'ar','Ø¯ÙØ¹ Ù†ÙˆØ¹ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(81246,2257,'fr','Payer Type mis Ã  jour avec succÃ¨s',0),(81247,2257,'jp','æ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(81248,2257,'pt','Pagar tipo atualizado com sucesso',0),(81249,2257,'ru','Ð¢Ð¸Ð¿ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(81250,2257,'es','Tipo de pago actualizado exitosamente',0),(81251,2257,'de','Lohnart erfolgreich aktualisiert',0),(81252,2257,'en','Pay Type updated successfully',0),(81253,2258,'is','',0),(81254,2258,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(81255,2258,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(81256,2258,'tr','BorÃ§lar',0),(81257,2258,'pl','ZobowiÄ…zania',0),(81258,2258,'bg','Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(81259,2258,'ur','ÙˆØ§Ø¬Ø¨Ù Ø§Ù„Ø§Ø¯Ø§',0),(81260,2258,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(81261,2258,'vi','TK Pháº£i Tráº£',0),(81262,2258,'af','Uitgawes (RB)',0),(81263,2258,'ro','Cheltuieli',0),(81264,2258,'et','Arvete maksmine',0),(81265,2258,'si','PlaÄila',0),(81266,2258,'ba','Hutang usaha',0),(81267,2258,'nl','Schulden',0),(81268,2258,'fi','Ostovelat',0),(81269,2258,'no','LeverandÃ¸rgjeld',0),(81270,2258,'da','Kreditorstyring',0),(81271,2258,'ko','ë¯¸ì§€ê¸‰ê¸ˆ',0),(81272,2258,'he','×œ×ª×©×œ×•×',0),(81273,2258,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(81274,2258,'zh','åº”ä»˜è´¦æ¬¾\r\n',0),(81275,2258,'sv','LeverantÃ¶rsskulder',0),(81276,2258,'it','Debiti',0),(81277,2258,'tl','',0),(81278,2258,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(81279,2258,'hi','Payables',0),(81280,2258,'ms','Pemiutang',0),(81281,2258,'ar','Ø§Ù„Ø¯Ø§Ø¦Ù†Ø©',0),(81282,2258,'fr','Comptes fournisseurs',0),(81283,2258,'jp','å‚µå‹™',0),(81284,2258,'pt','Contas a pagar',0),(81285,2258,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ°',0),(81286,2258,'es','Proveedores',0),(81287,2258,'de','Verbindlichkeiten',0),(81288,2258,'en','Payables',0),(81289,2259,'is','',0),(81290,2259,'dr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(81291,2259,'pr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(81292,2259,'tr','Ã–deme - fatura #',0),(81293,2259,'pl','PÅ‚atnoÅ›ci - faktury #',0),(81294,2259,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ - Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° #',0),(81295,2259,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù‚Ù… â€“ Ø§Ù†ÙˆØ§Ø¦Ø³ #',0),(81296,2259,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ - Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµÑ‚Ðµ #',0),(81297,2259,'vi','Thanh ToÃ¡n - HÃ³a Ä‘Æ¡n sá»‘',0),(81298,2259,'af','Betaling - Faktuur #',0),(81299,2259,'ro','Plata - factura #',0),(81300,2259,'et','Makse - Arve nr.',0),(81301,2259,'si','PlaÄilo - raÄun #',0),(81302,2259,'ba','Pembayaran - faktur #',0),(81303,2259,'nl','Betaling - factuur #',0),(81304,2259,'fi','Maksutavat - laskun numero',0),(81305,2259,'no','Betaling - fakturanummer',0),(81306,2259,'da','Betaling - faktura #',0),(81307,2259,'ko','ê²°ì œ-ì†¡ìž¥ #',0),(81308,2259,'he','×ª×©×œ×•× - ×—×©×‘×•× ×™×ª #',0),(81309,2259,'el','Î Î»Î·ÏÏ‰Î¼Î® - Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ #',0),(81310,2259,'zh','ä»˜æ¬¾ -å‘ç¥¨ï¼ƒ\r\n',0),(81311,2259,'sv','Betalning - faktura #',0),(81312,2259,'it','Pagamento - fattura #',0),(81313,2259,'tl','',0),(81314,2259,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;-&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(81315,2259,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ - à¤šà¤¾à¤²à¤¾à¤¨ #',0),(81316,2259,'ms','Pembayaran - invois #',0),(81317,2259,'ar','Ø§Ù„Ø¯ÙØ¹-Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(81318,2259,'fr','Paiement - facture #',0),(81319,2259,'jp','æ”¯æ‰•ã?„ãƒ¼è«‹æ±‚æ›¸ç•ªå?·',0),(81320,2259,'pt','Pagamento - Invoice #',0),(81321,2259,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶ - Ð¡Ñ‡ÐµÑ‚ #',0),(81322,2259,'es','Pago - Factura #',0),(81323,2259,'de','Zahlung - Rechnung #',0),(81324,2259,'en','Payment - Invoice #',0),(81325,2260,'is','',0),(81326,2260,'dr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(81327,2260,'pr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(81328,2260,'tr','Ã–deme yÃ¶ntemi',0),(81329,2260,'pl','Metody pÅ‚atnoÅ›ci',0),(81330,2260,'bg','ÐÐ°Ñ‡Ð¸Ð½ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(81331,2260,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø±',0),(81332,2260,'sr','ÐÐ°Ñ‡Ð¸Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(81333,2260,'vi','PhÆ°Æ¡ng thá»©c Thanh ToÃ¡n',0),(81334,2260,'af','Betaling Metode',0),(81335,2260,'ro','MetodÄƒ de platÄƒ',0),(81336,2260,'et','Makseviis',0),(81337,2260,'si','NaÄin plaÄila',0),(81338,2260,'ba','Metode pembayaran',0),(81339,2260,'nl','Betalingsmethode',0),(81340,2260,'fi','Maksutapa',0),(81341,2260,'no','BetalingsmÃ¥ten',0),(81342,2260,'da','Betalingsmetode',0),(81343,2260,'ko','ì§€ë¶ˆ ë°©ë²•',0),(81344,2260,'he','×©×™×˜×ª ×ª×©×œ×•×',0),(81345,2260,'el','ÎœÎ­Î¸Î¿Î´Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(81346,2260,'zh','ä»˜æ¬¾æ–¹å¼\r\n',0),(81347,2260,'sv','Betalningsmetod',0),(81348,2260,'it','Metodo di pagamento',0),(81349,2260,'tl','',0),(81350,2260,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(81351,2260,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤§à¤¿',0),(81352,2260,'ms','Kaedah pembayaran',0),(81353,2260,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(81354,2260,'fr','Mode de paiement',0),(81355,2260,'jp','æ”¯æ‰•æ–¹æ³•',0),(81356,2260,'pt','MÃ©todo de pagamento',0),(81357,2260,'ru','Ð¡Ð¿Ð¾ÑÐ¾Ð± ÐžÐ¿Ð»Ð°Ñ‚Ñ‹',0),(81358,2260,'es','MÃ©todo de Pago',0),(81359,2260,'de','Zahlungsmethode',0),(81360,2260,'en','Payment Method',0),(81361,2261,'is','',0),(81362,2261,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ ',0),(81363,2261,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ ',0),(81364,2261,'tr','AlÄ±nan Ã¶deme',0),(81365,2261,'pl','PÅ‚atnoÅ›ci otrzymane',0),(81366,2261,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(81367,2261,'ur','Ù¾ÛŒÙ…Ù†Ù¹ ÙˆØµÙˆÙ„ Ú©ÛŒ',0),(81368,2261,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ð°',0),(81369,2261,'vi','ÄÃ£ nháº­n Thanh ToÃ¡n',0),(81370,2261,'af','Betaling Ontvang',0),(81371,2261,'ro','Plata primite',0),(81372,2261,'et','Arve tasutud',0),(81373,2261,'si','PlaÄila, prejeta',0),(81374,2261,'ba','Pembayaran diterima',0),(81375,2261,'nl','Betaling ontvangen',0),(81376,2261,'fi','Maksu vastaanotettu',0),(81377,2261,'no','Betaling mottatt',0),(81378,2261,'da','Betaling modtaget',0),(81379,2261,'ko','ì§€ë¶ˆ ë°›ì€',0),(81380,2261,'he','×ª×©×œ×•× ×”×ª×§×‘×œ',0),(81381,2261,'el','Î Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… Î­Î»Î±Î²Îµ',0),(81382,2261,'zh','æ”¶åˆ°ä»˜æ¬¾\r\n',0),(81383,2261,'sv','Betalning mottagen',0),(81384,2261,'it','Pagamento ricevuto',0),(81385,2261,'tl','',0),(81386,2261,'th','&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(81387,2261,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(81388,2261,'ms','Bayaran yang diterima',0),(81389,2261,'ar','Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ø¯ÙØ¹',0),(81390,2261,'fr','Paiement reÃ§u',0),(81391,2261,'jp','å?—é ˜æ¸ˆæ”¯æ‰•ã?„',0),(81392,2261,'pt','Pagamento recebido',0),(81393,2261,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(81394,2261,'es','Pago Recibido',0),(81395,2261,'de','Zahlung erhalten',0),(81396,2261,'en','Payment Received',0),(81397,2262,'is','',0),(81398,2262,'dr','Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(81399,2262,'pr','Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(81400,2262,'tr','Ã–deme koÅŸullarÄ±',0),(81401,2262,'pl','Warunki pÅ‚atnoÅ›ci',0),(81402,2262,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(81403,2262,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø·',0),(81404,2262,'sr','Ð£ÑÐ»Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(81405,2262,'vi','Äiá»u khoáº£n Thanh ToÃ¡n',0),(81406,2262,'af','Betalingsterme',0),(81407,2262,'ro','CondiÅ£ii de platÄƒ',0),(81408,2262,'et','Maksetingimused',0),(81409,2262,'si','PlaÄilni pogoji',0),(81410,2262,'ba','Syarat-syarat pembayaran',0),(81411,2262,'nl','Betalingscondities',0),(81412,2262,'fi','Maksuehdot',0),(81413,2262,'no','Betalingsbetingelser',0),(81414,2262,'da','Betalingsbetingelser',0),(81415,2262,'ko','ì§€ë¶ˆ ì¡°ê±´',0),(81416,2262,'he','×ª× ××™ ×ª×©×œ×•×',0),(81417,2262,'el','ÎŒÏÎ¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(81418,2262,'zh','ä»˜æ¬¾æ¡æ¬¾\r\n',0),(81419,2262,'sv','Betalningsvillkor',0),(81420,2262,'it','Termini di pagamento',0),(81421,2262,'tl','',0),(81422,2262,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(81423,2262,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(81424,2262,'ms','Terma pembayaran',0),(81425,2262,'ar','Ø´Ø±ÙˆØ· Ø§Ù„Ø¯ÙØ¹',0),(81426,2262,'fr','Conditions de paiement',0),(81427,2262,'jp','æ”¯æ‰•ã?„æ?¡ä»¶',0),(81428,2262,'pt','CondiÃ§Ãµes de pagamento',0),(81429,2262,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(81430,2262,'es','TÃ©rminos de Pagos',0),(81431,2262,'de','Zahlungsbedingungen',0),(81432,2262,'en','Payment Terms',0),(81433,2263,'is','',0),(81434,2263,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(81435,2263,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(81436,2263,'tr','Ã–deme koÅŸullarÄ± ekleme',0),(81437,2263,'pl','Dodaj warunki pÅ‚atnoÅ›ci',0),(81438,2263,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(81439,2263,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø· Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(81440,2263,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑƒÑÐ»Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(81441,2263,'vi','ThÃªm Äiá»u khoáº£n Thanh ToÃ¡n',0),(81442,2263,'af','Betalingsterme Geskep',0),(81443,2263,'ro','Adauga condiÅ£ii de platÄƒ',0),(81444,2263,'et','Maksetingimuste lisamine',0),(81445,2263,'si','Dodaj PlaÄilni pogoji',0),(81446,2263,'ba','Menambahkan syarat-syarat pembayaran',0),(81447,2263,'nl','Betalingscondities toevoegen',0),(81448,2263,'fi','Maksuehdot lisÃ¤Ã¤',0),(81449,2263,'no','Betalingsbetingelser legge',0),(81450,2263,'da','Betalingsbetingelser tilfÃ¸je',0),(81451,2263,'ko','ì§€ë¶ˆ ì¡°ê±´ ì¶”ê°€',0),(81452,2263,'he','×”×•×¡×£ ×ª× ××™ ×ª×©×œ×•×',0),(81453,2263,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏŒÏÎ¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(81454,2263,'zh','ä»˜æ¬¾æ¡ä»¶æ·»åŠ \r\n',0),(81455,2263,'sv','Betalningsvillkor lÃ¤gga till',0),(81456,2263,'it','Aggiungere termini di pagamento',0),(81457,2263,'tl','',0),(81458,2263,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(81459,2263,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(81460,2263,'ms','Menambah syarat-syarat bayaran',0),(81461,2263,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙˆØ· Ø¯ÙØ¹',0),(81462,2263,'fr','Ajouter des conditions de paiement',0),(81463,2263,'jp','æ”¯æ‰•ã?„æ?¡ä»¶ã?®è¿½åŠ ',0),(81464,2263,'pt','Adicionar formas de pagamento',0),(81465,2263,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(81466,2263,'es','TÃ©rminos de Pagos Agregar',0),(81467,2263,'de','Zahlungsbedingungen hinzufÃ¼gen',0),(81468,2263,'en','Payment Terms Add',0),(81469,2264,'is','',0),(81470,2264,'dr','Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(81471,2264,'pr','Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(81472,2264,'tr','Ã–deme koÅŸullarÄ± baÅŸarÄ±yla silindi',0),(81473,2264,'pl','Warunki pÅ‚atnoÅ›ci przesâ”‚anie',0),(81474,2264,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(81475,2264,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø· Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(81476,2264,'sr','Ð£ÑÐ»Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(81477,2264,'vi','XÃ³a Äiá»u khoáº£n Thanh ToÃ¡n thÃ nh cÃ´ng',0),(81478,2264,'af','Betalingsterme suksesvol geskrap',0),(81479,2264,'ro','CondiÅ£ii de platÄƒ care eliminÄƒ cu succes',0),(81480,2264,'et','Edukalt kustutatud maksetingimused',0),(81481,2264,'si','PlaÄilni pogoji, uspeÅ¡no izbrisana',0),(81482,2264,'ba','Syarat-syarat pembayaran yang berhasil dihapus',0),(81483,2264,'nl','Betalingscondities succesvol verwijderd',0),(81484,2264,'fi','Maksuehdot poistettu',0),(81485,2264,'no','Betalingsbetingelser slettet',0),(81486,2264,'da','Betalingsbetingelser slettet',0),(81487,2264,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì§€ë¶ˆ ì¡°ê±´',0),(81488,2264,'he','×ª× ××™ ×”×ª×©×œ×•× × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(81489,2264,'el','ÎŒÏÎ¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚, Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(81490,2264,'zh','ä»˜æ¬¾æ¡æ¬¾åˆ é™¤æˆåŠŸ\r\n',0),(81491,2264,'sv','Betalningsvillkor raderades',0),(81492,2264,'it','Termini di pagamento eliminati con successo',0),(81493,2264,'tl','',0),(81494,2264,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3606;&#3641;&#3585;&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(81495,2264,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(81496,2264,'ms','Terma-terma pembayaran yang dihapuskan dengan jayanya',0),(81497,2264,'ar','Ø­Ø°ÙØª Ø´Ø±ÙˆØ· Ø§Ù„Ø¯ÙØ¹ Ø¨Ù†Ø¬Ø§Ø­',0),(81498,2264,'fr','Conditions de paiement supprimÃ©es avec succÃ¨s',0),(81499,2264,'jp','æ”¯æ‰•ã?„æ?¡ä»¶ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(81500,2264,'pt','Termos do pagamento excluÃ­dos com sucesso',0),(81501,2264,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(81502,2264,'es','TÃ©rminos de Pagos eliminados exitosamente',0),(81503,2264,'de','Zahlungsbedingungen erfolgreich gelÃ¶scht',0),(81504,2264,'en','Payment terms deleted successfully',0),(81505,2265,'is','',0),(81506,2265,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(81507,2265,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(81508,2265,'tr','Ã–deme ÅŸartlarÄ± gÃ¼ncelleme',0),(81509,2265,'pl','Aktualizacja terminÃ³w pÅ‚atnoÅ›ci',0),(81510,2265,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(81511,2265,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(81512,2265,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑƒÑÐ»Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(81513,2265,'vi','Cáº­p Nháº­t Äiá»u Khoáº£n Thanh ToÃ¡n',0),(81514,2265,'af','Opdateer Betalingsterme',0),(81515,2265,'ro','Actualizare de termenii de platÄƒ',0),(81516,2265,'et','Tasumise tingimused Update',0),(81517,2265,'si','PlaÄilni pogoji posodobitev',0),(81518,2265,'ba','Pembayaran syarat Update',0),(81519,2265,'nl','Betaling voorwaarden Update',0),(81520,2265,'fi','Maksu ehdot pÃ¤ivitys',0),(81521,2265,'no','Betaling vilkÃ¥rene oppdatering',0),(81522,2265,'da','Betaling vilkÃ¥r opdatering',0),(81523,2265,'ko','ì§€ë¶ˆ ì¡°ê±´ ì—…ë°ì´íŠ¸',0),(81524,2265,'he','×¢×“×›×•×Ÿ ×ª× ××™ ×ª×©×œ×•×',0),(81525,2265,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏŒÏÎ¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(81526,2265,'zh','ä»˜æ¬¾æ¡æ¬¾æ›´æ–°\r\n',0),(81527,2265,'sv','Betalning villkor uppdatering',0),(81528,2265,'it','Aggiornamento di termini di pagamento',0),(81529,2265,'tl','',0),(81530,2265,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(81531,2265,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(81532,2265,'ms','Kemaskini terma pembayaran',0),(81533,2265,'ar','ØªØ­Ø¯ÙŠØ« Ø´Ø±ÙˆØ· Ø§Ù„Ø¯ÙØ¹',0),(81534,2265,'fr','Mise Ã  jour des modalitÃ©s de paiement',0),(81535,2265,'jp','æ”¯æ‰•ã?„æ?¡ä»¶ã?®æ›´æ–°',0),(81536,2265,'pt','AtualizaÃ§Ã£o de termos de pagamento',0),(81537,2265,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(81538,2265,'es','TÃ©rminos de Pagos Actualizar',0),(81539,2265,'de','Zahlung Begriffe Update',0),(81540,2265,'en','Payment Terms Update',0),(81541,2266,'is','',0),(81542,2266,'dr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(81543,2266,'pr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(81544,2266,'tr','Ã–deme ÅŸekli',0),(81545,2266,'pl','Typ pÅ‚atnoÅ›ci',0),(81546,2266,'bg','Ð’Ð¸Ð´ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(81547,2266,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(81548,2266,'sr','Ð’Ñ€ÑÑ‚Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(81549,2266,'vi','Loáº¡i Thanh ToÃ¡n',0),(81550,2266,'af','Betalingstipe',0),(81551,2266,'ro','Tipul de platÄƒ',0),(81552,2266,'et','Makse tÃ¼Ã¼p',0),(81553,2266,'si','Vrsta plaÄila',0),(81554,2266,'ba','Jenis pembayaran',0),(81555,2266,'nl','Betalingstype',0),(81556,2266,'fi','Tyyppi',0),(81557,2266,'no','Betalingstypen',0),(81558,2266,'da','Betalingstype',0),(81559,2266,'ko','ì§€ë¶ˆ ìœ í˜•',0),(81560,2266,'he','×¡×•×’ ×ª×©×œ×•×',0),(81561,2266,'el','Î¤ÏÏŒÏ€Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(81562,2266,'zh','ä»˜æ¬¾æ–¹å¼\r\n',0),(81563,2266,'sv','Betalningstypen',0),(81564,2266,'it','Tipo di pagamento',0),(81565,2266,'tl','',0),(81566,2266,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(81567,2266,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(81568,2266,'ms','Jenis bayaran',0),(81569,2266,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹',0),(81570,2266,'fr','Type de paiement',0),(81571,2266,'jp','æ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—',0),(81572,2266,'pt','Tipo de pagamento',0),(81573,2266,'ru','Ð¢Ð¸Ð¿ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(81574,2266,'es','Tipo de Pago',0),(81575,2266,'de','Zahlungsart',0),(81576,2266,'en','Payment Type',0),(81577,2267,'is','',0),(81578,2267,'dr','(Ø§Ù‚Ø³Ø§Ø·',0),(81579,2267,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§(Ø§Ù‚Ø³Ø§Ø·',0),(81580,2267,'tr','Ã–demeler',0),(81581,2267,'pl','PÅ‚atnoÅ›ci',0),(81582,2267,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(81583,2267,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(81584,2267,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ',0),(81585,2267,'vi','Thanh ToÃ¡n',0),(81586,2267,'af','Betalings',0),(81587,2267,'ro','PlÄƒÅ£i',0),(81588,2267,'et','Maksed',0),(81589,2267,'si','PlaÄila',0),(81590,2267,'ba','Pembayaran',0),(81591,2267,'nl','Betalingen',0),(81592,2267,'fi','Maksut',0),(81593,2267,'no','Betalinger',0),(81594,2267,'da','Betalinger',0),(81595,2267,'ko','ì§€ë¶ˆ',0),(81596,2267,'he','×ª×©×œ×•×ž×™×',0),(81597,2267,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(81598,2267,'zh','ä»˜æ¬¾\r\n',0),(81599,2267,'sv','Betalningar',0),(81600,2267,'it','Pagamenti',0),(81601,2267,'tl','',0),(81602,2267,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(81603,2267,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(81604,2267,'ms','Pembayaran',0),(81605,2267,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(81606,2267,'fr','Paiements',0),(81607,2267,'jp','æ”¯æ‰•ã?„',0),(81608,2267,'pt','Pagamentos',0),(81609,2267,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸',0),(81610,2267,'es','Pagos',0),(81611,2267,'de','Zahlungen',0),(81612,2267,'en','Payments',0),(81613,2268,'is','',0),(81614,2268,'dr',': Ø¨Ø§Ø² ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨ â€“ Ú†Ùƒ Ø¨Ø§ ÙØ±Ù…Ø§ÛŒØ´- ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ø¨Ø§ ÙØ±Ù…Ø§ÛŒØ´ - Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ù‚Ø¯Ù‰ Ø¨Ù‡ Ù…Ø¬Ø±Ø¯ ØªØ­ÙˆÙŠÙ„ Ø¬Ù†Ø³ â€“ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ â€“ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø±ÙŠÙƒ â€“ Ùˆ ØºÙŠØ±Ù‡ ',0),(81615,2268,'pr','Ú¯Ø²ÙŠÙ†Ù‡  Ù¾Ø±Ø¯Ø§Ø®Øª  : Ø¨Ø§Ø² ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨ â€“ Ú†Ùƒ Ø¨Ø§ Ø³ÙØ§Ø±Ø´- ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ø¨Ø§ Ø³ÙØ§Ø±Ø´ - Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ù‚Ø¯Ù‰ Ø¨Ù‡ Ù…Ø¬Ø±Ø¯ ØªØ­ÙˆÙŠÙ„ Ú©Ø§Ù„Ø§ â€“ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ â€“ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø±ÙŠÙƒ â€“ Ùˆ ØºÙŠØ±Ù‡ ',0),(81616,2268,'tr','Hesap kontrol sipariÅŸ, sipariÅŸ, COD, kredi kartÄ±, Ã¶deme dostum, para ile aÃ§mak diÄŸer',0),(81617,2268,'pl','OtwÃ³rz konto, sprawdÅº z zamÃ³wienia, gotÃ³wka z zamÃ³wienia, dorsza, karta kredytowa, Pay Pal, inne',0),(81618,2268,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÑ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ°, Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°, Ð±Ñ€Ð¾Ð¹ Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°, Ñ‚Ñ€ÐµÑÐºÐ°, ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°, Pay Pal, Ð´Ñ€ÑƒÐ³Ð¸',0),(81619,2268,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ØŒ Ú†ÛŒÚ© Ú©Û’ Ø³Ø§ØªÚ¾ Ù†Ø¸Ù…ØŒ ØªØ±ØªÛŒØ¨ØŒ Ù…ÛŒØ«Ø§Ù‚ Ø¬Ù…ÛÙˆØ±ÛŒØªØŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±ÚˆØŒ Ù¾Û’ Ù¾Ø§Ù„ Ú©Û’ Ø³Ø§ØªÚ¾ Ù†Ù‚Ø¯ Ú©Ú¾ÙˆÙ„ÛŒÚº Ø¯ÛŒÚ¯Ø±',0),(81620,2268,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³, Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°, Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ñƒ ÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°, Ð‘Ð°ÐºÐ°Ð»Ð°Ñ€Ð°, ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ, Ð¿Ð»Ð°Ñ‚Ðµ ÐŸÐ°Ð», Ð´Ñ€ÑƒÐ³Ðµ',0),(81621,2268,'vi','Má»Ÿ TK, SÃ©c vá»›i Ä‘Æ¡n hÃ ng, Tiá»n máº·t vá»›i Ä‘Æ¡n hÃ ng, Thanh toÃ¡n khi giao hÃ ng, Tháº» tÃ­n dá»¥ng, Pay Pal, KhÃ¡c',0),(81622,2268,'af','Open Rekening,Tjek met Bestelling,Kontant met Bestelling,KBA,Kredietkaart,Ander',0),(81623,2268,'ro','Deschide cont, verificaÅ£i cu comanda, Cash cu comanda, COD, carte de Credit, amice Pay, alte',0),(81624,2268,'et','Avage konto, kontrollige tellimus, Kassa jÃ¤rjekorras, Tursavarude, krediitkaart, Pay Pal, koos teiste',0),(81625,2268,'si','Odprite raÄun, preverite z naroÄilom, gotovina s nalog, KPK, kreditne kartice, Pay Pal, druge',0),(81626,2268,'ba','Membuka akun, cek dengan urutan, kas dengan urutan, COD, kartu kredit, Pay Pal, lainnya',0),(81627,2268,'nl','Openen van Account, Controleer met Order, Cash met COD, volgorde, Credit Card, betalen Pal, andere',0),(81628,2268,'fi','Avaa tili, tarkista tilaus, COD, luottokortti, Pay Pal, kÃ¤teistÃ¤, jotta muut',0),(81629,2268,'no','Ã…pne konto, sjekk med ordre, kontanter med ordre, COD, kredittkort, Pay Pal, andre',0),(81630,2268,'da','Ã…bne konto, kontrollere med ordre, kontanter med ordre, COD, kreditkort, Pay Pal, andre',0),(81631,2268,'ko','ê³„ì¢Œ ê°œì„¤, ê²€ì‚¬ ìˆœì„œ, ìˆœì„œ, ì‚¬ì¸, ì‹ ìš© ì¹´ë“œ, ê¸‰ì—¬ Pal, í˜„ê¸ˆ ê¸°íƒ€',0),(81632,2268,'he','×¤×ª×— ×—×©×‘×•×Ÿ, ×‘×“×•×§ ×¢× ×¡×“×¨, ×›×¡×£ ×¢× ×¡×“×¨, ×‘×§×œ×”, ×›×¨×˜×™×¡ ××©×¨××™, Pay Pal, ××—×¨×™×',0),(81633,2268,'el','Î†Î½Î¿Î¹Î³Î¼Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï, ÎµÎ»Î­Î³Î¾Ï„Îµ Î¼Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±, Î¼ÎµÏ„ÏÎ·Ï„Î¬ Î¼Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±, COD, Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±, Pay Pal, Î¬Î»Î»ÎµÏ‚',0),(81634,2268,'zh','æ‰“å¼€å¸æˆ·ï¼Œè¯·ä¸Žæ²»å®‰ï¼Œç§©åºï¼ŒåŒ–å­¦éœ€æ°§é‡ï¼Œä¿¡ç”¨å¡ï¼Œæ”¶è´¹å¸•å°”ï¼Œå…¶ä»–çŽ°é‡‘\r\n',0),(81635,2268,'sv','Ã–ppna konto, kolla med bestÃ¤llning, kontanter med Order, torsk, kreditkort, Pay Pal, andra',0),(81636,2268,'it','Aprire conto, controlla con ordine, contanti con ordine, COD, carta di credito, Pay Pal, altri',0),(81637,2268,'tl','',0),(81638,2268,'th','Open Account,Check with Order,Cash with Order,COD,Credit Card,Pay Pal,Other',0),(81639,2268,'hi','à¤–à¤¾à¤¤à¥‡, à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶, à¤†à¤¦à¥‡à¤¶, à¤•à¥‰à¤¡, à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡, à¤ªà¥‡ à¤ªà¤¾à¤², à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¨à¤•à¤¦à¥€ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤–à¥‹à¤²à¥‡à¤‚ à¤…à¤¨à¥à¤¯',0),(81640,2268,'ms','Membuka akaun, semak dengan perintah, Wang Tunai dengan perintah, COD, kad kredit, membayar Pal, lain-lain',0),(81641,2268,'ar','ÙØªØ­ Ø§Ù„Ø­Ø³Ø§Ø¨ØŒ ØªØ­Ù‚Ù‚ Ù…Ø¹ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ù†Ù‚Ø¯ÙŠ Ù…Ø¹ Ø§Ù„Ù†Ø¸Ø§Ù…ØŒ ÙˆØ³Ù…Ùƒ Ø§Ù„Ù‚Ø¯ØŒ ÙˆØ¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†ØŒ Ø§Ù„Ø¯ÙØ¹ Ø¨Ø§Ù„ØŒ Ø£Ø®Ø±Ù‰',0),(81642,2268,'fr','Ouvrir le compte, vÃ©rifiez avec ordre, argent avec ordre, morue, carte de crÃ©dit, PayPal, autres',0),(81643,2268,'jp','ã‚ªãƒ¼ãƒ—ãƒ³ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã€?å°?åˆ‡æ‰‹æ”¯æ‰•ã?„æ³¨æ–‡ã€?ç?¾é‡‘æ”¯æ‰•æ³¨æ–‡ã€?ç?€æ‰•ã?„ã€?ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ã€?ãƒšã‚¤ãƒ‘ãƒ«ã€?ã??ã?®ä»–',0),(81644,2268,'pt','Abrir conta, verifique com ordem, dinheiro com ordem, COD, cartÃ£o de crÃ©dito, Pay Pal, outros',0),(81645,2268,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑ‡ÐµÑ‚, Ð²Ñ‹ÐµÐ·Ð´ Ñ Ð·Ð°ÐºÐ°Ð·Ð°, Ð´ÐµÐ½ÑŒÐ³Ð¸ Ñ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°, Ñ‚Ñ€ÐµÑÐºÐ°, ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚, Pay Pal, Ð´Ñ€ÑƒÐ³Ð¸Ðµ',0),(81646,2268,'es','Abrir cuenta, Cheque con el Orden, Efectivo con el Orden, COD, Tarjeta de CrÃ©dito, Pay Pal, Otro',0),(81647,2268,'de','Konto erÃ¶ffnen, Check Order, Cash mit Bestellung, COD, Kreditkarte, PayPal, andere',0),(81648,2268,'en','Open Account,Check with Order,Cash with Order,COD,Credit Card,Pay Pal,Other',0),(81649,2269,'is','',0),(81650,2269,'dr',': 1- 2 -3-4- 5 -6- 7',0),(81651,2269,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª  : 1- 2 -3-4- 5 -6- 7',0),(81652,2269,'tr','1,2,3,4,5,6,7',0),(81653,2269,'pl','1,2,3,4,5,6,7',0),(81654,2269,'bg','1,2,3,4,5,6,7',0),(81655,2269,'ur','1,2,3,4,5,6,7',0),(81656,2269,'sr','1,2,3,4,5,6,7',0),(81657,2269,'vi','1,2,3,4,5,6,7',0),(81658,2269,'af','1,2,3,4,5,6,7',0),(81659,2269,'ro','1,2,3,4,5,6,7',0),(81660,2269,'et','1,2,3,4,5,6,7',0),(81661,2269,'si','1,2,3,4,5,6,7',0),(81662,2269,'ba','1,2,3,4,5,6,7',0),(81663,2269,'nl','1,2,3,4,5,6,7',0),(81664,2269,'fi','1,2,3,4,5,6,7',0),(81665,2269,'no','1,2,3,4,5,6,7',0),(81666,2269,'da','1,2,3,4,5,6,7',0),(81667,2269,'ko','1,2,3,4,5,6,7',0),(81668,2269,'he','1,2,3,4,5,6,7',0),(81669,2269,'el','1,2,3,4,5,6,7',0),(81670,2269,'zh','è–ªé…¬æœŸæƒä»·å€¼\r\n',0),(81671,2269,'sv','1,2,3,4,5,6,7',0),(81672,2269,'it','1,2,3,4,5,6,7',0),(81673,2269,'tl','',0),(81674,2269,'th','1,2,3,4,5,6,7',0),(81675,2269,'hi','1,2,3,4,5,6,7',0),(81676,2269,'ms','1,2,3,4,5,6,7',0),(81677,2269,'ar','1,2,3,4,5,6,7',0),(81678,2269,'fr','1,2,3,4,5,6,7',0),(81679,2269,'jp','1,2,3,4,5,6,7',0),(81680,2269,'pt','1,2,3,4,5,6,7',0),(81681,2269,'ru','1,2,3,4,5,6,7',0),(81682,2269,'es','1,2,3,4,5,6,7',0),(81683,2269,'de','1,2,3,4,5,6,7',0),(81684,2269,'en','1,2,3,4,5,6,7',0),(81685,2270,'is','',0),(81686,2270,'dr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(81687,2270,'pr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(81688,2270,'tr','Bordro',0),(81689,2270,'pl','PÅ‚ace',0),(81690,2270,'bg','Ð¢Ð Ð—',0),(81691,2270,'ur','Ù¾Û’ Ø±ÙˆÙ„',0),(81692,2270,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº',0),(81693,2270,'vi','Báº£ng LÆ°Æ¡ng',0),(81694,2270,'af','Loonrol',0),(81695,2270,'ro','Personal',0),(81696,2270,'et','Palgaarvestus',0),(81697,2270,'si','PlaÄilna lista',0),(81698,2270,'ba','Penggajian',0),(81699,2270,'nl','Salarisadministratie',0),(81700,2270,'fi','Palkanlaskenta',0),(81701,2270,'no','LÃ¸nn',0),(81702,2270,'da','LÃ¸n',0),(81703,2270,'ko','ê¸‰ì—¬',0),(81704,2270,'he','×ž×©×›×•×¨×•×ª',0),(81705,2270,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(81706,2270,'zh','è–ªèµ„\r\n',0),(81707,2270,'sv','LÃ¶ne',0),(81708,2270,'it','Libro paga',0),(81709,2270,'tl','',0),(81710,2270,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(81711,2270,'hi','à¤ªà¥‡à¤°à¥‹à¤²',0),(81712,2270,'ms','Senarai gaji',0),(81713,2270,'ar','Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(81714,2270,'fr','Paie',0),(81715,2270,'jp','çµ¦æ–™',0),(81716,2270,'pt','Folha de pagamento',0),(81717,2270,'ru','ÐÐ°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ Ð—/ÐŸÐ»Ð°Ñ‚Ñ‹',0),(81718,2270,'es','NÃ³mina',0),(81719,2270,'de','Lohnabrechnung',0),(81720,2270,'en','Payroll',0),(81721,2271,'is','',0),(81722,2271,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒÙ„ÙŠ ÙƒØ³ÙˆØ±Ø§Øª Ùˆ Ù…Ø²Ø§ÙŠØ§ÙŠ  Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(81723,2271,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒÙ„ÙŠ ÙƒØ³ÙˆØ±Ø§Øª Ùˆ Ù…Ø²Ø§ÙŠØ§ÙŠ  Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(81724,2271,'tr','Bordro yararlarÄ± ve kesintiler genel veri',0),(81725,2271,'pl','KorzyÅ›ci wynagrodzeÅ„ i potrÄ…ceÅ„ ogÃ³lnych danych',0),(81726,2271,'bg','ÐžÐ±ÐµÐ·Ñ‰ÐµÑ‚ÐµÐ½Ð¸Ñ Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¸ ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸ Ð¾Ð±Ñ‰Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(81727,2271,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©Û’ ÙÙˆØ§Ø¦Ø¯ Ø§ÙˆØ± Ú©Ù¹ÙˆØªÛŒ Ø¬Ù†Ø±Ù„ Ú©ÙˆØ§Ø¦Ù',0),(81728,2271,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð±ÐµÐ½ÐµÑ„Ð¸Ñ†Ð¸Ñ˜Ðµ Ð¸ Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸',0),(81729,2271,'vi','Dá»¯ liá»‡u giáº£m trá»« & trá»£ cáº¥p lÆ°Æ¡ng',0),(81730,2271,'af','Loonrol Voordele en Aftrekkings Alagemene Data',0),(81731,2271,'ro','Beneficiile de salarizare ÅŸi deduceri General date',0),(81732,2271,'et','Palgaarvestus - Preemiad ja kinnipidamised - Ãœldised andmed',0),(81733,2271,'si','IzplaÄane plaÄe koristi in odbitki sploÅ¡ni podatki',0),(81734,2271,'ba','Manfaat penggajian dan pengurangan umum Data',0),(81735,2271,'nl','Payroll voordelen en inhoudingen algemene gegevens',0),(81736,2271,'fi','Palkanlaskennan edut ja vÃ¤hennykset yleistiedot',0),(81737,2271,'no','LÃ¸nn fordeler og fradrag generelt Data',0),(81738,2271,'da','LÃ¸nningslisten fordele og fradrag generelle Data',0),(81739,2271,'ko','ê¸‰ì—¬ í˜œíƒ ë° ê³µì œ ì¼ë°˜ ë°ì´í„°',0),(81740,2271,'he','×”×˜×‘×•×ª ×©×›×¨ ×•× ×ª×•× ×™× ×’× ×¨×œ × ×™×›×•×™×™×',0),(81741,2271,'el','ÎŸÏ†Î­Î»Î· Ï„Î·Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ ÎºÎ±Î¹ Ï„Ï‰Î½ ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½ Î³ÎµÎ½Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(81742,2271,'zh','è–ªé‡‘æ´¥è´´å’Œæ‰£é™¤ä¸€èˆ¬æ•°æ®\r\n',0),(81743,2271,'sv','LÃ¶nelistan fÃ¶rmÃ¥ner och avdrag allmÃ¤nna Data',0),(81744,2271,'it','Benefici di sui salari e dati generali di deduzioni',0),(81745,2271,'tl','',0),(81746,2271,'th','&#3612;&#3621;&#3611;&#3619;&#3632;&#3650;&#3618;&#3594;&#3609;&#3660;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3649;&#3621;&#3632;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3',0),(81747,2271,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤²à¤¾à¤­ à¤”à¤° à¤•à¤Ÿà¥Œà¤¤à¤¿à¤¯à¤¾à¤‚ à¤œà¤¨à¤°à¤² à¤¡à¥‡à¤Ÿà¤¾',0),(81748,2271,'ms','Faedah-faedah gaji dan potongan besar Data',0),(81749,2271,'ar','Ø§Ø³ØªØ­Ù‚Ø§Ù‚Ø§Øª Ø§Ù„Ø±ÙˆØ§ØªØ¨ ÙˆØ§Ù„Ø§Ø³ØªÙ‚Ø·Ø§Ø¹Ø§Øª Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø©',0),(81750,2271,'fr','Avantages sociaux et les donnÃ©es gÃ©nÃ©rales retenues',0),(81751,2271,'jp','çµ¦ä¸Žçµ¦ä»˜é‡‘ãƒ»æŽ§é™¤ä¸€èˆ¬ãƒ‡ãƒ¼ã‚¿',0),(81752,2271,'pt','BenefÃ­cios da folha de pagamento e dados gerais de deduÃ§Ãµes',0),(81753,2271,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð»ÑŒÐ³Ð¾Ñ‚Ñ‹ Ð¸ Ð²Ñ‹Ñ‡ÐµÑ‚Ñ‹ Ð¾Ð±Ñ‰Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(81754,2271,'es','Datos Generales de Beneficios y Deducciones de la NÃ³mina',0),(81755,2271,'de','Gehaltsabrechnung Vorteile und AbzÃ¼ge allgemeine Daten',0),(81756,2271,'en','Payroll Benefits and Deductions General Data',0),(81757,2272,'is','',0),(81758,2272,'dr','Ø³Ø§Ø¹Ø§Øª Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(81759,2272,'pr','Ø³Ø§Ø¹Ø§Øª Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(81760,2272,'tr','Bordro hesaplamak saat',0),(81761,2272,'pl','PÅ‚ac obliczania godzin',0),(81762,2272,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ñ‡Ð°ÑÐ°',0),(81763,2272,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(81764,2272,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð° ÑÐ°Ñ‚Ð¸',0),(81765,2272,'vi','Báº£ng lÆ°Æ¡ng tÃ­nh giá»',0),(81766,2272,'af','Loonrol Berekeningsure',0),(81767,2272,'ro','Salarizare calcula ore',0),(81768,2272,'et','Palga arvutamiseks tundi',0),(81769,2272,'si','IzplaÄane plaÄe izraÄuna ur',0),(81770,2272,'ba','Penggajian menghitung jam',0),(81771,2272,'nl','Payroll uren berekenen',0),(81772,2272,'fi','Palkanlaskennan laskea tuntia',0),(81773,2272,'no','LÃ¸nn beregne timer',0),(81774,2272,'da','LÃ¸nningslisten beregning timer',0),(81775,2272,'ko','ê¸‰ì—¬ ê³„ì‚° ì‹œê°„',0),(81776,2272,'he','×ž×©×›×•×¨×•×ª ×œ×—×©×‘ ×©×¢×•×ª',0),(81777,2272,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÎ¹ ÏŽÏÎµÏ‚',0),(81778,2272,'zh','è–ªèµ„è®¡ç®—æ—¶é—´\r\n',0),(81779,2272,'sv','LÃ¶nelistan berÃ¤kna timmar',0),(81780,2272,'it','Retribuzioni calcolare ore',0),(81781,2272,'tl','',0),(81782,2272,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(81783,2272,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤˜à¤‚à¤Ÿà¥‡',0),(81784,2272,'ms','Gaji kira jam',0),(81785,2272,'ar','ÙƒØ´ÙˆÙ Ø­Ø³Ø§Ø¨ Ø³Ø§Ø¹Ø§Øª',0),(81786,2272,'fr','Paie calculer heures',0),(81787,2272,'jp','çµ¦ä¸Žè¨ˆç®—æ™‚é–“',0),(81788,2272,'pt','Folha de pagamento calcular horas',0),(81789,2272,'ru','Ð§Ð°ÑÑ‹ Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ñ‹Ð²Ð°ÑŽÑ‚ÑÑ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(81790,2272,'es','Calcular Horas de NÃ³mina',0),(81791,2272,'de','Lohn-und Gehaltsabrechnung berechnen Stunden',0),(81792,2272,'en','Payroll Calculate Hours',0),(81793,2273,'is','',0),(81794,2273,'dr','ÙƒÙ…Ùƒ Ù‡Ø§ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø´Ø±ÙƒØª',0),(81795,2273,'pr','ÙƒÙ…Ùƒ Ù‡Ø§ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø´Ø±ÙƒØª',0),(81796,2273,'tr','Bordro ÅŸirketi katkÄ±larÄ±',0),(81797,2273,'pl','Firma listy pÅ‚ac skÅ‚adki',0),(81798,2273,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ Ð²Ð½Ð¾ÑÐºÐ¸',0),(81799,2273,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø§Ø¹Ø§Ù†Øª',0),(81800,2273,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾ÑÐ°',0),(81801,2273,'vi','LÆ°Æ¡ng Ä‘Ã³ng gÃ³p tá»« cty',0),(81802,2273,'af','Loonrol Onderneming Bydraes',0),(81803,2273,'ro','Compania salarizare contribuÅ£ii',0),(81804,2273,'et','Palgaarvestuse Ã¤riÃ¼hingu osamaksud',0),(81805,2273,'si','Prispevkov na izplaÄane plaÄe podjetja',0),(81806,2273,'ba','Kontribusi perusahaan penggajian',0),(81807,2273,'nl','Loonlijst bedrijf bijdragen',0),(81808,2273,'fi','Palkanlaskennan yrityksen maksut',0),(81809,2273,'no','LÃ¸nn selskapet bidrag',0),(81810,2273,'da','LÃ¸nningslisten selskab bidrag',0),(81811,2273,'ko','ê¸‰ì—¬ íšŒì‚¬ ê¸°ì—¬',0),(81812,2273,'he','×ª×¨×•×ž×•×ª ×”×—×‘×¨×” ×©×›×¨',0),(81813,2273,'el','Î•Î¹ÏƒÏ†Î¿ÏÎ­Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(81814,2273,'zh','è–ªèµ„å…¬å¸ææ¬¾\r\n',0),(81815,2273,'sv','LÃ¶nelistan fÃ¶retag bidrag',0),(81816,2273,'it','Azienda paghe contributi',0),(81817,2273,'tl','',0),(81818,2273,'th','&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3592;&#3634;&#3588;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(81819,2273,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤•à¤‚à¤ªà¤¨à¥€ à¤¯à¥‹à¤—à¤¦à¤¾à¤¨',0),(81820,2273,'ms','Sumbangan Syarikat gaji',0),(81821,2273,'ar','Ù…Ø³Ø§Ù‡Ù…Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ© ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(81822,2273,'fr','Contributions de la compagnie paie',0),(81823,2273,'jp','çµ¦ä¸Žä¼?æ¥­å¯„ä»˜é¡?',0),(81824,2273,'pt','Empresa de folha de pagamento contribuiÃ§Ãµes',0),(81825,2273,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð²Ð·Ð½Ð¾ÑÑ‹',0),(81826,2273,'es','NÃ³mina Contribuciones de la Empresa',0),(81827,2273,'de','Personalabrechnung Unternehmen BeitrÃ¤ge',0),(81828,2273,'en','Payroll Company Contributions',0),(81829,2274,'is','',0),(81830,2274,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù‡Ø´ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(81831,2274,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù‡Ø´ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(81832,2274,'tr','Yeni bir kesinti grubu',0),(81833,2274,'pl','Nowa grupa odliczenia',0),(81834,2274,'bg','ÐÐ¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð·Ð° Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(81835,2274,'ur','Ù†ÛŒØ§ ÛÙˆÙ†Û’Ùˆ Ú¯Ø±ÙˆÙ¾',0),(81836,2274,'sr','ÐÐ¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð°',0),(81837,2274,'vi','ThÃªm NhÃ³m Giáº£m Trá»« LÆ°Æ¡ng',0),(81838,2274,'af','Loonrol Aftrekkingsgroep Byvoeg',0),(81839,2274,'ro','Noul grup de deducere',0),(81840,2274,'et','Uue mahaarvamist rÃ¼hma',0),(81841,2274,'si','Novi odbitek skupine',0),(81842,2274,'ba','Grup pemotongan baru',0),(81843,2274,'nl','Nieuwe aftrek groep',0),(81844,2274,'fi','Uusi vÃ¤hennys ryhmÃ¤',0),(81845,2274,'no','Ny fradrag gruppe',0),(81846,2274,'da','Nye fradrag gruppe',0),(81847,2274,'ko','ìƒˆë¡œìš´ ê³µì œ ê·¸ë£¹',0),(81848,2274,'he','×§×‘×•×¦×ª × ×™×›×•×™ ×—×“×©×”',0),(81849,2274,'el','ÎÎ­Î± Î¿Î¼Î¬Î´Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(81850,2274,'zh','å·¥èµ„æ‰£é™¤é›†å›¢åœ°å€\r\n',0),(81851,2274,'sv','Nya avdrag grupp',0),(81852,2274,'it','Nuovo gruppo di deduzione',0),(81853,2274,'tl','',0),(81854,2274,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3621;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(81855,2274,'hi','à¤¨à¤ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(81856,2274,'ms','Kumpulan potongan baru',0),(81857,2274,'ar','ÙØ±ÙŠÙ‚ Ø®ØµÙ… Ø¬Ø¯ÙŠØ¯',0),(81858,2274,'fr','Nouveau groupe de dÃ©duction',0),(81859,2274,'jp','çµ¦ä¸ŽæŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—è¿½åŠ ',0),(81860,2274,'pt','Novo grupo de deduÃ§Ã£o',0),(81861,2274,'ru','ÐÐ¾Ð²Ð°Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ð° Ð²Ñ‹Ñ‡ÐµÑ‚',0),(81862,2274,'es','Agregar Grupo de Deducciones de la NÃ³mina',0),(81863,2274,'de','Neue Gruppe zum Abzug',0),(81864,2274,'en','New Deduction Group',0),(81865,2275,'is','',0),(81866,2275,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ ÙƒØ³ÙˆØ±Ø§Øª Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(81867,2275,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ ÙƒØ³ÙˆØ±Ø§Øª Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(81868,2275,'tr','Kesinti grubu DÃ¼zenle',0),(81869,2275,'pl','Edytuj grupÄ™ odliczenia',0),(81870,2275,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð·Ð° Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(81871,2275,'ur','ØªØ¯ÙˆÛŒÙ† ÛÙˆÙ†Û’Ùˆ Ú¯Ø±ÙˆÙ¾',0),(81872,2275,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ðµ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð°',0),(81873,2275,'vi','Cáº­p Nháº­t NhÃ³m Giáº£m Trá»« LÆ°Æ¡ng',0),(81874,2275,'af','Loonrol Aftrekkingsgroep Opdateer',0),(81875,2275,'ro','Grup de deducere editare',0),(81876,2275,'et','RÃ¼hma redigeerimine mahaarvamine',0),(81877,2275,'si','Urejanje odbitek skupine',0),(81878,2275,'ba','Edit pengurangan Group',0),(81879,2275,'nl','Aftrek groep bewerken',0),(81880,2275,'fi','Muokkaa vÃ¤hennys ryhmÃ¤Ã¤',0),(81881,2275,'no','Rediger fradrag gruppe',0),(81882,2275,'da','Rediger fradrag gruppe',0),(81883,2275,'ko','ê³µì œ ê·¸ë£¹ íŽ¸ì§‘',0),(81884,2275,'he','×§×‘×•×¦×ª × ×™×›×•×™ ×¢×¨×™×›×”',0),(81885,2275,'el','ÎŸÎ¼Î¬Î´Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(81886,2275,'zh','å·¥èµ„æ‰£é™¤ç»„æ›´æ–°\r\n',0),(81887,2275,'sv','Redigera avdrag grupp',0),(81888,2275,'it','Modifica gruppo deduzione',0),(81889,2275,'tl','',0),(81890,2275,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3621;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(81891,2275,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(81892,2275,'ms','Edit potongan Kumpulan',0),(81893,2275,'ar','ØªØ­Ø±ÙŠØ± Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø®ØµÙ…',0),(81894,2275,'fr','DÃ©duction pour modifier un groupe',0),(81895,2275,'jp','çµ¦ä¸ŽæŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—æ›´æ–°',0),(81896,2275,'pt','Editar grupo de deduÃ§Ã£o',0),(81897,2275,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð³Ñ€ÑƒÐ¿Ð¿Ñƒ Ð²Ñ‹Ñ‡ÐµÑ‚',0),(81898,2275,'es','Actualizar Grupo de Deducciones de la NÃ³mina',0),(81899,2275,'de','Abzug Gruppe bearbeiten',0),(81900,2275,'en','Edit Deduction Group',0),(81901,2276,'is','',0),(81902,2276,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(81903,2276,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(81904,2276,'tr','Bordro personel ekleme',0),(81905,2276,'pl','Dodaj listy pÅ‚ac pracownikÃ³w',0),(81906,2276,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð° Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ',0),(81907,2276,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(81908,2276,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(81909,2276,'vi','ThÃªm Báº£ng LÆ°Æ¡ng NhÃ¢n ViÃªn',0),(81910,2276,'af','Loonrol Werknemer Geskep',0),(81911,2276,'ro','Adauga salarizare angajat',0),(81912,2276,'et','Palk tÃ¶Ã¶taja lisamine',0),(81913,2276,'si','IzplaÄane plaÄe zaposlenih poveÄati',0),(81914,2276,'ba','Tambahkan penggajian karyawan',0),(81915,2276,'nl','Payroll werknemer toevoegen',0),(81916,2276,'fi','Palkanlaskenta tyÃ¶ntekijÃ¶iden lisÃ¤Ã¤',0),(81917,2276,'no','LÃ¸nn ansatte legge',0),(81918,2276,'da','LÃ¸nsum medarbejder tilfÃ¸je',0),(81919,2276,'ko','ê¸‰ì—¬ ì§ì› ì¶”ê°€',0),(81920,2276,'he','×©×›×¨ ×”×¢×•×‘×“ ×œ×”×•×¡×™×£',0),(81921,2276,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŒÏ‚',0),(81922,2276,'zh','æ–°å¢žé›‡å‘˜è–ªé‡‘\r\n',0),(81923,2276,'sv','LÃ¶n anstÃ¤lld lÃ¤gga till',0),(81924,2276,'it','Aggiungi dipendenti dei paghe',0),(81925,2276,'tl','',0),(81926,2276,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(81927,2276,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(81928,2276,'ms','Tambah gaji pekerja',0),(81929,2276,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ¸Ù Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(81930,2276,'fr','Ajouter employÃ© paie',0),(81931,2276,'jp','å¾“æ¥­å“¡å??ç°¿ã?¸ã?®å¾“æ¥­å“¡è¿½åŠ ',0),(81932,2276,'pt','Adicionar o empregado da folha de pagamento',0),(81933,2276,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½ÑƒÑŽ Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚ÑŒ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(81934,2276,'es','Empleado de NÃ³mina Agregar',0),(81935,2276,'de','Abrechnung Mitarbeiter hinzufÃ¼gen',0),(81936,2276,'en','Payroll Employee Add',0),(81937,2277,'is','',0),(81938,2277,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(81939,2277,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(81940,2277,'tr','Bordro personel gÃ¼ncelleme',0),(81941,2277,'pl','Aktualizacja listy pÅ‚ac pracownikÃ³w',0),(81942,2277,'bg','Ð¢Ð Ð— ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(81943,2277,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù…Ù„Ø§Ø²Ù… ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(81944,2277,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(81945,2277,'vi','Cáº­p Nháº­t LÆ°Æ¡ng NhÃ¢n ViÃªn',0),(81946,2277,'af','Loonrol Werknemer Opdateer',0),(81947,2277,'ro','Salarizare angajat Update',0),(81948,2277,'et','Palk tÃ¶Ã¶taja Update',0),(81949,2277,'si','IzplaÄane plaÄe zaposlenega posodobitev',0),(81950,2277,'ba','Penggajian karyawan Update',0),(81951,2277,'nl','Payroll werknemer Update',0),(81952,2277,'fi','Palkanlaskenta tyÃ¶ntekijÃ¶iden pÃ¤ivitys',0),(81953,2277,'no','LÃ¸nn ansatt oppdatering',0),(81954,2277,'da','LÃ¸nsum medarbejder opdatering',0),(81955,2277,'ko','ê¸‰ì—¬ ì§ì› ì—…ë°ì´íŠ¸',0),(81956,2277,'he','×¢×“×›×•×Ÿ ×©×›×¨ ×”×¢×•×‘×“',0),(81957,2277,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Ï…Ï€Î±Î»Î»Î®Î»Ï‰Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(81958,2277,'zh','å‘˜å·¥è–ªèµ„æ›´æ–°\r\n',0),(81959,2277,'sv','LÃ¶n anstÃ¤lld uppdatering',0),(81960,2277,'it','Aggiornamento di paghe dei dipendenti',0),(81961,2277,'tl','',0),(81962,2277,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(81963,2277,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(81964,2277,'ms','Gaji kakitangan kemas',0),(81965,2277,'ar','ØªØ­Ø¯ÙŠØ« ÙƒØ´ÙˆÙ Ù…Ø±ØªØ¨Ø§Øª Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(81966,2277,'fr','Mise Ã  jour de paie employÃ©',0),(81967,2277,'jp','å¾“æ¥­å“¡å??ç°¿ã?¸ã?®å¾“æ¥­å“¡æ›´æ–°',0),(81968,2277,'pt','AtualizaÃ§Ã£o de folha de pagamento dos empregados',0),(81969,2277,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½ÑƒÑŽ Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚ÑŒ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(81970,2277,'es','Actualizar Empleado de NÃ³mina',0),(81971,2277,'de','Abrechnung Mitarbeiter Update',0),(81972,2277,'en','Payroll Employee Update',0),(81973,2278,'is','',0),(81974,2278,'dr','(Ù…Ø¹Ø§Ø´) Ù„ÛŒØ³Øª Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡',0),(81975,2278,'pr','Ù…Ø²Ø§ÙŠØ§ÙŠ ÙƒÙ„ÙŠ (Ø­Ù‚ÙˆÙ‚) Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(81976,2278,'tr','Bordro genel yararlarÄ± (Ã¶deme)',0),(81977,2278,'pl','PÅ‚ace ogÃ³lne korzyÅ›ci (pÅ‚aciÄ‡)',0),(81978,2278,'bg','Ð¢Ð Ð— Ð³ÐµÐ½ÐµÑ€Ð°Ð» Ð¾Ð±ÐµÐ·Ñ‰ÐµÑ‚ÐµÐ½Ð¸Ñ (Pay)',0),(81979,2278,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©Û’ Ø¹Ù…ÙˆÙ…ÛŒ ÙÙˆØ§Ø¦Ø¯ (ØªÙ†Ø®ÙˆØ§Û)',0),(81980,2278,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð±ÐµÐ½ÐµÑ„Ð¸Ñ†Ð¸Ñ˜Ðµ (Ð¿Ð»Ð°Ñ‚Ðµ)',0),(81981,2278,'vi','Phá»¥ Cáº¥p LÆ°Æ¡ng Chung (LÆ°Æ¡ng)',0),(81982,2278,'af','Loonrol Algemene Voordele (Loon)',0),(81983,2278,'ro','Beneficiile generale de salarizare (plata)',0),(81984,2278,'et','Palgaarvestuse Ã¼ldine kasu (tasu)',0),(81985,2278,'si','IzplaÄane plaÄe sploÅ¡ne koristi (plaÄa)',0),(81986,2278,'ba','Manfaat penggajian Umum (membayar)',0),(81987,2278,'nl','Payroll algemene voordelen (Pay)',0),(81988,2278,'fi','Palkanlaskennan yleistÃ¤ hyÃ¶tyÃ¤ (Pay)',0),(81989,2278,'no','LÃ¸nn generelt fordeler (Pay)',0),(81990,2278,'da','LÃ¸nningslisten generelle fordele (lÃ¸n)',0),(81991,2278,'ko','ê¸‰ì—¬ ì¼ë°˜ í˜œíƒ (ìœ ë£Œ)',0),(81992,2278,'he','×”×˜×‘×•×ª ×”×©×›×¨ ×”×›×œ×œ×™ (×©×›×¨)',0),(81993,2278,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Î³ÎµÎ½Î¹ÎºÎ¬ Î¿Ï†Î­Î»Î· (Ï€Î»Î·ÏÏ‰Î¼Î®)',0),(81994,2278,'zh','è–ªé‡‘ï¼ˆå·¥èµ„ï¼‰ä¸€èˆ¬çš„åˆ©ç›Š\r\n',0),(81995,2278,'sv','LÃ¶nelistan allmÃ¤nna fÃ¶rmÃ¥ner (lÃ¶n)',0),(81996,2278,'it','Libro paga generale benefici (a pagamento)',0),(81997,2278,'tl','',0),(81998,2278,'th','&#3612;&#3621;&#3611;&#3619;&#3632;&#3650;&#3618;&#3594;&#3609;&#3660;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3651;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;(&#3592;&#3656;&#3634;&#3618;)',0),(81999,2278,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤œà¤¨à¤°à¤² à¤²à¤¾à¤­ (à¤­à¥à¤—à¤¤à¤¾à¤¨)',0),(82000,2278,'ms','Faedah-faedah besar gaji (gaji)',0),(82001,2278,'ar','Ø§Ù„Ù…Ù†Ø§ÙØ¹ Ø§Ù„Ø¹Ø§Ù…Ø© Ø§Ù„Ø±ÙˆØ§ØªØ¨ (Ø§Ù„Ø£Ø¬ÙˆØ±)',0),(82002,2278,'fr','Avantages gÃ©nÃ©ral paie (paye)',0),(82003,2278,'jp','çµ¦ä¸Žä¸€èˆ¬çµ¦ä»˜é‡‘ï¼ˆè³ƒé‡‘ï¼‰',0),(82004,2278,'pt','BenefÃ­cios gerais da folha de pagamento (pagar)',0),(82005,2278,'ru','ÐŸÑ€ÐµÐ¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð° Ð¾Ð±Ñ‰ÐµÐ³Ð¾ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ (Ð¾Ð¿Ð»Ð°Ñ‚Ð°)',0),(82006,2278,'es','Beneficios Generales de NÃ³mina (Sueldo)',0),(82007,2278,'de','Lohn-und Gehaltsabrechnung Allgemeine Vorteile (gebÃ¼hrenpflichtig)',0),(82008,2278,'en','Payroll General Benefits (Pay)',0),(82009,2279,'is','',0),(82010,2279,'dr','ÙƒØ³ÙˆØ±Ø§Øª ÙƒÙ„ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82011,2279,'pr','ÙƒØ³ÙˆØ±Ø§Øª ÙƒÙ„ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82012,2279,'tr','Bordro genel kesintiler',0),(82013,2279,'pl','OgÃ³lne wynagrodzeÅ„ potrÄ…ceÅ„',0),(82014,2279,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¾Ð±Ñ‰Ð¾ ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸',0),(82015,2279,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ø¬Ù†Ø±Ù„ Ú©Ù¹ÙˆØªÛŒ',0),(82016,2279,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ',0),(82017,2279,'vi','Giáº£m trá»« lÆ°Æ¡ng chung',0),(82018,2279,'af','Loonrol Algemene Aftrekkings',0),(82019,2279,'ro','General de salarizare deduceri',0),(82020,2279,'et','Palgaarvestuse Ã¼ldine mahaarvamised',0),(82021,2279,'si','IzplaÄane plaÄe sploÅ¡ne olajÅ¡ave',0),(82022,2279,'ba','Pemotongan gaji Umum',0),(82023,2279,'nl','Payroll algemene inhoudingen',0),(82024,2279,'fi','Palkanlaskennan yleiset vÃ¤hennykset',0),(82025,2279,'no','LÃ¸nn generelt fradrag',0),(82026,2279,'da','LÃ¸nningslisten generelle fradrag',0),(82027,2279,'ko','ê¸‰ì—¬ ì¼ë°˜ ê³µì œ',0),(82028,2279,'he','× ×™×›×•×™×™ ×©×›×¨ ×’× ×¨×œ',0),(82029,2279,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Î³ÎµÎ½Î¹ÎºÏŽÎ½ ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½',0),(82030,2279,'zh','ä¸€èˆ¬æ‰£é™¤è–ªé‡‘\r\n',0),(82031,2279,'sv','LÃ¶nelistan allmÃ¤nna avdrag',0),(82032,2279,'it','Trattenute sui salari generale',0),(82033,2279,'tl','',0),(82034,2279,'th','&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3621;&#3610;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3651;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(82035,2279,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤œà¤¨à¤°à¤² à¤•à¤Ÿà¥Œà¤¤à¤¿à¤¯à¤¾à¤‚',0),(82036,2279,'ms','Potongan gaji besar',0),(82037,2279,'ar','Ø§Ù‚ØªØ·Ø§Ø¹Ø§Øª Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø§Ù„Ø¹Ø§Ù…Ø©',0),(82038,2279,'fr','Masse salariale gÃ©nÃ©rale retenues',0),(82039,2279,'jp','çµ¦ä¸Žä¸€èˆ¬æŽ§é™¤',0),(82040,2279,'pt','DeduÃ§Ãµes de folha de pagamento geral',0),(82041,2279,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ðµ Ð£Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ñ… Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚ÐµÐ¹',0),(82042,2279,'es','Deducciones Generales de NÃ³mina',0),(82043,2279,'de','Lohn-und Gehaltsabrechnung allgemeine AbzÃ¼ge',0),(82044,2279,'en','Payroll General Deductions',0),(82045,2280,'is','',0),(82046,2280,'dr','Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82047,2280,'pr','Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82048,2280,'tr','Bordro gÃ¼nlÃ¼k saat',0),(82049,2280,'pl','Godziny dziennika pÅ‚ac',0),(82050,2280,'bg','Ð¢Ð Ð— Ñ€ÐµÐ³Ð¸ÑÑ‚ÑŠÑ€ Ñ‡Ð°ÑÐ°',0),(82051,2280,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù„Ø§Ú¯ Ú¯Ú¾Ù†Ù¹Û’',0),(82052,2280,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº ÐµÐ²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ðµ ÑÐ°Ñ‚Ð¸',0),(82053,2280,'vi','Nháº­t kÃ½ giá» lÆ°Æ¡ng',0),(82054,2280,'af','Loonrol Log Ure',0),(82055,2280,'ro','Ore de jurnal de salarizare',0),(82056,2280,'et','Palgaarvestuse Log tundi',0),(82057,2280,'si','IzplaÄane plaÄe dnevnik ur',0),(82058,2280,'ba','Penggajian Log jam',0),(82059,2280,'nl','Payroll Log uren',0),(82060,2280,'fi','Palkanlaskennan loki tuntia',0),(82061,2280,'no','LÃ¸nn Logg timer',0),(82062,2280,'da','LÃ¸nningslisten Log timer',0),(82063,2280,'ko','ê¸‰ì—¬ ë¡œê·¸ ì‹œê°„',0),(82064,2280,'he','×ž×©×›×•×¨×•×ª ×™×•×ž×Ÿ ×©×¢×•×ª',0),(82065,2280,'el','ÎÏÎµÏ‚ ÎºÎ±Ï„Î±Î³ÏÎ±Ï†Î®Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(82066,2280,'zh','è–ªèµ„ç™»å½•æ—¶é—´\r\n',0),(82067,2280,'sv','LÃ¶nelistan Log timmar',0),(82068,2280,'it','Paghe registro ore',0),(82069,2280,'tl','',0),(82070,2280,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3637;&#3656;&#3648;&#3586;&#3657;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(82071,2280,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤²à¥‰à¤— à¤˜à¤‚à¤Ÿà¥‡',0),(82072,2280,'ms','Gaji Log jam',0),(82073,2280,'ar','Ø³Ø§Ø¹Ø§Øª Ø³Ø¬Ù„ ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(82074,2280,'fr','Heures de journal de paie',0),(82075,2280,'jp','çµ¦ä¸Žãƒ­ã‚°æ™‚é–“',0),(82076,2280,'pt','Horas de Log de folha de pagamento',0),(82077,2280,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ñ‡Ð°ÑÐ¾Ð² Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(82078,2280,'es','Horas Tabulados de NÃ³mina',0),(82079,2280,'de','Personalabrechnung Log Stunden',0),(82080,2280,'en','Payroll Log Hours',0),(82081,2281,'is','',0),(82082,2281,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø­Ù‚ÙˆÙ‚ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82083,2281,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø­Ù‚ÙˆÙ‚ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82084,2281,'tr','Yeni Ã¶deme tipi',0),(82085,2281,'pl','Nowy typ pÅ‚acy',0),(82086,2281,'bg','ÐÐ¾Ð² Ñ‚Ð¸Ð¿ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(82087,2281,'ur','Ù†Ø¦ÛŒ ØªÙ†Ø®ÙˆØ§Û Ù‚Ø³Ù…',0),(82088,2281,'sr','ÐÐ¾Ð²Ð¸ Ñ‚Ð¸Ð¿ Ð¿Ð»Ð°Ñ‚Ðµ',0),(82089,2281,'vi','ThÃªm Loáº¡i báº£ng lÆ°Æ¡ng',0),(82090,2281,'af','Loonrol Besoldiging Tipes Byvoeg',0),(82091,2281,'ro','Noul tip de plata',0),(82092,2281,'et','Uus tasutÃ¼Ã¼p',0),(82093,2281,'si','Nova vrsta plaÄila',0),(82094,2281,'ba','Tipe membayar baru',0),(82095,2281,'nl','Nieuwe Pay-Type',0),(82096,2281,'fi','Uusi maksulaji',0),(82097,2281,'no','Nye lÃ¸nnstype',0),(82098,2281,'da','Ny lÃ¸nart',0),(82099,2281,'ko','ìƒˆë¡œìš´ ì§€ë¶ˆ ìœ í˜•',0),(82100,2281,'he','×¡×•×’ ×”×©×›×¨ ×”×—×“×©',0),(82101,2281,'el','ÎÎ­Î¿Ï‚ Ï„ÏÏ€Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(82102,2281,'zh','è–ªé‡‘æ”¯ä»˜é”®å…¥æ·»åŠ \r\n',0),(82103,2281,'sv','Nya lÃ¶netyp',0),(82104,2281,'it','Nuovo tipo di retribuzione',0),(82105,2281,'tl','',0),(82106,2281,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(82107,2281,'hi','à¤¨à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(82108,2281,'ms','Jenis gaji baru',0),(82109,2281,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(82110,2281,'fr','Nouveau Type de paiement',0),(82111,2281,'jp','çµ¦ä¸Žæ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—è¿½åŠ ',0),(82112,2281,'pt','Novo tipo de pagamento',0),(82113,2281,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ‚Ð¸Ð¿ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(82114,2281,'es','Agregar Tipo de Pago de NÃ³mina',0),(82115,2281,'de','Neue Lohnart',0),(82116,2281,'en','New Pay Type',0),(82117,2282,'is','',0),(82118,2282,'dr','(Ù…Ø¹Ø§Ø´) Ù„ÛŒØ³Øª Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡',0),(82119,2282,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª(Ø­Ù‚ÙˆÙ‚) Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82120,2282,'tr','Ã–deme tipi DÃ¼zenle',0),(82121,2282,'pl','EdytowaÄ‡ typ pÅ‚acy',0),(82122,2282,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(82123,2282,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(82124,2282,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ‚Ð¸Ð¿ Ð¿Ð»Ð°Ñ‚Ðµ',0),(82125,2282,'vi','Cáº­p Nháº­t Loáº¡i LÆ°Æ¡ng Cho Báº£ng LÆ°Æ¡ng',0),(82126,2282,'af','Loonrol Besoldiging Tipe Opdateer',0),(82127,2282,'ro','Editare tip de plata',0),(82128,2282,'et','Muuda tasu tÃ¼Ã¼p',0),(82129,2282,'si','Uredite plaÄilo vrsto',0),(82130,2282,'ba','Mengedit membayar jenis',0),(82131,2282,'nl','Pay Type bewerken',0),(82132,2282,'fi','Muokkaa maksulaji',0),(82133,2282,'no','Redigere lÃ¸nnstype',0),(82134,2282,'da','Redigere lÃ¸nart',0),(82135,2282,'ko','ì§€ë¶ˆ í˜•ì‹ íŽ¸ì§‘',0),(82136,2282,'he','×¢×¨×•×š ×¡×•×’ ×”×©×›×¨',0),(82137,2282,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï… Pay',0),(82138,2282,'zh','è–ªé‡‘æ”¯ä»˜ç±»åž‹æ›´æ–°\r\n',0),(82139,2282,'sv','Redigera lÃ¶netyp',0),(82140,2282,'it','Modificare il tipo di retribuzione',0),(82141,2282,'tl','',0),(82142,2282,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3',0),(82143,2282,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(82144,2282,'ms','Edit jenis gaji',0),(82145,2282,'ar','ØªØ­Ø±ÙŠØ± Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹',0),(82146,2282,'fr','Modifier le Type de paiement',0),(82147,2282,'jp','çµ¦ä¸Žæ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—æ›´æ–°',0),(82148,2282,'pt','Editar o tipo de pagamento',0),(82149,2282,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(82150,2282,'es','Actualizar Tipo de Pago de NÃ³mina',0),(82151,2282,'de','Bearbeiten Sie die Zahlungsart',0),(82152,2282,'en','Edit Pay Type',0),(82153,2283,'is','',0),(82154,2283,'dr','/ ÙƒØ§ÙÙ‡ ØªØ±ÙŠØ§ / Ø·Ø±Ø­ Ù¾Ø³ Ø§Ù†Ø¯Ø§Ø² ',0),(82155,2283,'pr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯Ù‰ / ÙƒØ§ÙÙ‡ ØªØ±ÙŠØ§ / Ø·Ø±Ø­ Ù¾Ø³ Ø§Ù†Ø¯Ø§Ø² ',0),(82156,2283,'tr','Bordro pansiyon-kafeterya-tasarruf planÄ±',0),(82157,2283,'pl','Plan oszczÄ™dnoÅ›ci emerytalnych/kawiarnia listy pÅ‚ac',0),(82158,2283,'bg','Ð¢Ð Ð— Ð¿ÐµÐ½ÑÐ¸Ñ/ÐºÐ°Ñ„ÐµÐ½Ðµ/ÑÐ¿ÐµÑÑ‚ÑÐ²Ð°Ð½Ð¸Ñ Ð¿Ð»Ð°Ð½',0),(82159,2283,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù¾Ù†Ø´Ù†/Ú©ÛŒÙÛŒÙ¹ÛŒØ±ÛŒØ§/Ø¨Ú†ØªÛŒ Ù…Ù†ØµÙˆØ¨Û',0),(82160,2283,'sr','ÐŸÐ»Ð°Ð½ Ð·Ð° Ð¿ÐµÐ½Ð·Ð¸Ñ˜Ñƒ/ÐºÐ°Ñ„ÐµÑ‚ÐµÑ€Ð¸Ñ˜Ð°/ÑˆÑ‚ÐµÐ´ÑšÐµ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ',0),(82161,2283,'vi','LÆ°Æ¡ng hÆ°u/Cafeteria/Káº¿ hoáº¡ch tiáº¿t kiá»‡m',0),(82162,2283,'af','Loonrol Pensioen/Kafeteria/Spaarplan',0),(82163,2283,'ro','Planul de pensii/cafenea/economii salarizare',0),(82164,2283,'et','TÃ¶Ã¶tasu Pension/kohvik/kokkuhoiu plaani',0),(82165,2283,'si','IzplaÄane plaÄe jedilnici/pokojnine/varÄevalnega naÄrta',0),(82166,2283,'ba','Penggajian Pension/kantin/tabungan rencana',0),(82167,2283,'nl','Payroll pensioen/cafetaria/spaarplan',0),(82168,2283,'fi','Palkanlaskennan Pension/kahvila/sÃ¤Ã¤stÃ¶t suunnitelma',0),(82169,2283,'no','LÃ¸nn Pension/kafÃ©/spareplan',0),(82170,2283,'da','LÃ¸nningslisten pensionsopsparing/Cafeteria Plan',0),(82171,2283,'ko','ê¸‰ì—¬ ì—°ê¸ˆ/ì¹´íŽ˜í…Œë¦¬ì•„/ì €ì¶• ê³„íš',0),(82172,2283,'he','×ª×›× ×™×ª ×¤× ×¡×™×”/×§×¤×™×˜×¨×™×”/×—×™×¡×›×•×Ÿ ×ž×©×›×•×¨×•×ª',0),(82173,2283,'el','Pension/ÎºÎ±Ï†ÎµÏ„Î­ÏÎ¹Î±/Î±Ï€Î¿Ï„Î±Î¼Î¹ÎµÏ…Ï„Î¹ÎºÏŒ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(82174,2283,'zh','è–ªèµ„é€€ä¼‘é‡‘/é¤åŽ…/å‚¨è“„è®¡åˆ’\r\n',0),(82175,2283,'sv','LÃ¶nelistan pensionssparande-Cafeteria Plan',0),(82176,2283,'it','Piano pensionistico/caffetteria/risparmio sui salari',0),(82177,2283,'tl','',0),(82178,2283,'th','&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609; &#3649;&#3612;&#3609;&#3610;&#3635;&#3609;&#3634;&#3597;/&#3649;&#3612;&#3609;&#3619;&#3657;&#3634;&#3609;&#3586;&#3634;&#3618;&#3629;&#3634;&#3627;&#3634;&#3619;/&#3649;&#3612;&#3609;&#3629;',0),(82179,2283,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤ªà¥‡à¤‚à¤¶à¤¨/à¤•à¥ˆà¤«à¥‡à¤Ÿà¥‡à¤°à¤¿à¤¯à¤¾/à¤¬à¤šà¤¤ à¤¯à¥‹à¤œà¤¨à¤¾',0),(82180,2283,'ms','Gaji pencen/kafeteria/simpanan pelan',0),(82181,2283,'ar','Ø®Ø·Ø© Ø§Ù„Ù…Ø¹Ø§Ø´Ø§Øª Ø§Ù„ØªÙ‚Ø§Ø¹Ø¯ÙŠØ©/ÙƒØ§ÙØªÙŠØ±ÙŠØ§/ØªØ­Ù‚ÙŠÙ‚ ÙˆÙÙˆØ±Ø§Øª Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(82182,2283,'fr','Plan de Pension/cafÃ©tÃ©ria/Ã©conomies de paie',0),(82183,2283,'jp','çµ¦ä¸Žå¹´é‡‘/ã‚«ãƒ•ã‚§ãƒ†ãƒªã‚¢/è²¯è“„ãƒ—ãƒ©ãƒ³',0),(82184,2283,'pt','Plano de pensÃ£o/cafetaria/poupanÃ§a de folha de pagamento',0),(82185,2283,'ru','ÐŸÐ»Ð°Ð½ Ð¿ÐµÐ½ÑÐ¸Ð¾Ð½Ð½Ð¾Ð³Ð¾/ÐºÐ°Ñ„Ðµ/ÑÐºÐ¾Ð½Ð¾Ð¼Ð¸Ð¸ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(82186,2283,'es','Plan de PensiÃ³n/CafeterÃ­a/Ahorros del Tipo de Pago de NÃ³mina',0),(82187,2283,'de','Personalabrechnung Pension/Cafeteria/Sparplan',0),(82188,2283,'en','Payroll Pension/Cafeteria/Savings Plan',0),(82189,2284,'is','',0),(82190,2284,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82191,2284,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82192,2284,'tr','Bordro<br>Kurulum',0),(82193,2284,'pl','Listy pÅ‚ac<br>Instalator',0),(82194,2284,'bg','Ð¢Ð Ð—<br>ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(82195,2284,'ur','Ù¾Û’ Ø±ÙˆÙ„<br>Ø³ÛŒÙ¹ Ø§Ù¾',0),(82196,2284,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº<br>ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(82197,2284,'vi','Setupbáº£ng lÆ°Æ¡ng',0),(82198,2284,'af','Loonrol<br>Opstelling',0),(82199,2284,'ro','Salarizare<br>Programul de instalare',0),(82200,2284,'et','Palgaarvestus<br>Seadistamine',0),(82201,2284,'si','IzplaÄane plaÄe<br>Nastavitev',0),(82202,2284,'ba','Penggajian<br>Setup',0),(82203,2284,'nl','Salarisadministratie<br>Setup',0),(82204,2284,'fi','Palkanlaskenta<br>Asetukset',0),(82205,2284,'no','LÃ¸nn<br>Installasjonsprogrammet',0),(82206,2284,'da','LÃ¸n<br>OpsÃ¦tning',0),(82207,2284,'ko','ê¸‰ì—¬<br>ì„¤ì¹˜',0),(82208,2284,'he','×ž×©×›×•×¨×•×ª<br>×ª×•×›× ×™×ª ×”×”×ª×§× ×”',0),(82209,2284,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚<br>Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(82210,2284,'zh','è–ªé‡‘è®¾ç½®\r\n',0),(82211,2284,'sv','LÃ¶ne<br>Setup',0),(82212,2284,'it','Libro paga<br>Installazione',0),(82213,2284,'tl','',0),(82214,2284,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;<br>&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(82215,2284,'hi','à¤ªà¥‡à¤°à¥‹à¤²<br>à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(82216,2284,'ms','Senarai gaji<br>Persediaan',0),(82217,2284,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(82218,2284,'fr','Paie<br>Programme d\'installation',0),(82219,2284,'jp','çµ¦ä¸Ž<br>è¨­å®š',0),(82220,2284,'pt','Folha de pagamento<br>InstalaÃ§Ã£o',0),(82221,2284,'ru','ÐÐ°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹<br>Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ°',0),(82222,2284,'es','Tipo de Pago de NÃ³mina<br>Configurar',0),(82223,2284,'de','Lohn-und Gehaltsabrechnung<br>Setup',0),(82224,2284,'en','Payroll<br>Setup',0),(82225,2285,'is','',0),(82226,2285,'dr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„ ',0),(82227,2285,'pr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„ ',0),(82228,2285,'tr','Bordro standart GL hesaplarÄ±',0),(82229,2285,'pl','PÅ‚ac GL standardowych kont',0),(82230,2285,'bg','Ð¢Ð Ð— ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ GL ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(82231,2285,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(82232,2285,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸Ñ… Ð“Ð› Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(82233,2285,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Chuáº©n LÆ°Æ¡ng',0),(82234,2285,'af','Loonrol Standaard AG Rekening',0),(82235,2285,'ro','Conturile de Standard GL salarizare',0),(82236,2285,'et','Palgaarvestuse Standard GL kontod',0),(82237,2285,'si','IzplaÄane plaÄe Standard GL raÄunov',0),(82238,2285,'ba','Gaji GL standar account',0),(82239,2285,'nl','Payroll standaard GL Accounts',0),(82240,2285,'fi','Standard GL palkanlaskentatileillÃ¤',0),(82241,2285,'no','Standard GL lÃ¸nnskontoer',0),(82242,2285,'da','Standard GL lÃ¸nkonti',0),(82243,2285,'ko','ê¸‰ì—¬ í‘œì¤€ GL ê³„ì •',0),(82244,2285,'he','×©×›×¨ ×¨×’×™×œ GL ×—×©×‘×•× ×•×ª',0),(82245,2285,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ GL Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(82246,2285,'zh','è–ªé‡‘æ ‡å‡†æ€»å¸å¸æˆ·\r\n',0),(82247,2285,'sv','Standard GL lÃ¶nekonton',0),(82248,2285,'it','Libro paga GL Standard conti',0),(82249,2285,'tl','',0),(82250,2285,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(82251,2285,'hi','à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤ªà¥‡à¤°à¥‹à¤²',0),(82252,2285,'ms','Gaji Standard GL akaun',0),(82253,2285,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø±ØªÙ‘Ø¨Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ Ù„Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(82254,2285,'fr','Comptes de paie Standard GL',0),(82255,2285,'jp','çµ¦ä¸Žæ¨™æº–GLå‹˜å®š',0),(82256,2285,'pt','Contas GL padrÃ£o de folha de pagamento',0),(82257,2285,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ GL ÑÑ‡ÐµÑ‚Ð¾Ð² Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(82258,2285,'es','Cuentas LM EstÃ¡ndares de la NÃ³mina',0),(82259,2285,'de','Standard GL Lohnkonten',0),(82260,2285,'en','Payroll Standard GL Accounts',0),(82261,2286,'is','',0),(82262,2286,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª  Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯   Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ',0),(82263,2286,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª  Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯   Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ',0),(82264,2286,'tr','Bordro vergisi genel bilgi ekleme',0),(82265,2286,'pl','Podatek od wynagrodzeÅ„ dodaÄ‡ informacje ogÃ³lne',0),(82266,2286,'bg','Ð¢Ð Ð— Ð´Ð°Ð½ÑŠÑ‡Ð½Ð°Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð¾Ð±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(82267,2286,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù¹ÛŒÚ©Ø³ Ø¬Ù†Ø±Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(82268,2286,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ñ˜ Ð»Ð¸ÑÑ‚Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð˜Ð½Ñ„Ð¾',0),(82269,2286,'vi','ThÃªm thÃ´ng tin thuáº¿ lÆ°Æ¡ng',0),(82270,2286,'af','Skep Loonrol Belasting Algemene Inligting',0),(82271,2286,'ro','Salarizare fiscalÄƒ Adauga informatii generale',0),(82272,2286,'et','Palgafondimaksu lisada Ãœldinfo',0),(82273,2286,'si','Davek na izplaÄane plaÄe dodati sploÅ¡ni Info',0),(82274,2286,'ba','Pajak gaji menambahkan Info Umum',0),(82275,2286,'nl','Bedrijfsvoorheffing toevoegen Algemene Info',0),(82276,2286,'fi','TyÃ¶nantajamaksu lisÃ¤Ã¤ General Info',0),(82277,2286,'no','Arbeidsgiveravgift legge til generell informasjon',0),(82278,2286,'da','LÃ¸nsumsafgift tilfÃ¸je General Info',0),(82279,2286,'ko','ì§€ê¸‰ ê¸‰ì—¬ ì„¸ ì¶”ê°€ ì¼ë°˜ ì •ë³´',0),(82280,2286,'he','×ž×¡ ×©×›×¨ ×œ×”×•×¡×™×£ ×ž×™×“×¢ ×›×œ×œ×™',0),(82281,2286,'el','Î¦ÏŒÏÎ¿ Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î³ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(82282,2286,'zh','å·¥èµ„ç¨Žæ–°å¢žä¸€èˆ¬ä¿¡æ¯\r\n',0),(82283,2286,'sv','LÃ¶neskatt lÃ¤gga till allmÃ¤n Info',0),(82284,2286,'it','Imposta sui salari aggiungere Info generale',0),(82285,2286,'tl','',0),(82286,2286,'th','&#3616;&#3634;&#3625;&#3637;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(82287,2286,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤•à¤° à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(82288,2286,'ms','Senarai gaji cukai Tambah Maklumat am',0),(82289,2286,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø©',0),(82290,2286,'fr','ImpÃ´t sur les salaires ajouter Infos gÃ©nÃ©rales',0),(82291,2286,'jp','çµ¦ä¸Žç¨Žè¿½åŠ ä¸€èˆ¬æƒ…å ±',0),(82292,2286,'pt','Imposto sobre os salÃ¡rios adicionar informaÃ§Ã£o geral',0),(82293,2286,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½ÑƒÑŽ Ð¿Ð»Ð°Ñ‚Ñƒ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(82294,2286,'es','Impuesto de NÃ³mina Agregar Info General',0),(82295,2286,'de','Lohnsteuer hinzufÃ¼gen Allgemeine Info',0),(82296,2286,'en','Payroll Tax Add General Info',0),(82297,2287,'is','',0),(82298,2287,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ù„ÛŒØ³Øª Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡',0),(82299,2287,'pr','Ø³Ù¾Ø±Ø¯Ù‡ (Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82300,2287,'tr','Bordro vergi Ã¶deme',0),(82301,2287,'pl','WpÅ‚aty podatku od pÅ‚ac',0),(82302,2287,'bg','Ð¢Ð Ð— Ð´Ð°Ð½ÑŠÑ‡Ð½Ð°Ñ‚Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(82303,2287,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù¹ÛŒÚ©Ø³ Ø¬Ù…Ø¹',0),(82304,2287,'sr','ÐŸÐ»Ð°Ñ‚Ðµ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(82305,2287,'vi','Tráº£ trÆ°á»›c thuáº¿ lÆ°Æ¡ng',0),(82306,2287,'af','Loonrol Belasting Deposito',0),(82307,2287,'ro','Depozit de impozit salarii',0),(82308,2287,'et','Palgafondi maksu tagatisraha',0),(82309,2287,'si','Depozit davka na izplaÄane plaÄe',0),(82310,2287,'ba','Penggajian pajak Deposit',0),(82311,2287,'nl','Payroll belastingen storting',0),(82312,2287,'fi','Palkanlaskennan vero talletus',0),(82313,2287,'no','LÃ¸nn skatt innskudd',0),(82314,2287,'da','Payroll Tax depositum',0),(82315,2287,'ko','ê¸‰ì—¬ ì„¸ê¸ˆ ìž…ê¸ˆ',0),(82316,2287,'he','×¤×™×§×“×•×Ÿ ×ž×¡ ×©×›×¨',0),(82317,2287,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï†ÏŒÏÎ¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½',0),(82318,2287,'zh','å·¥èµ„ç¨Žå­˜æ¬¾\r\n',0),(82319,2287,'sv','LÃ¶n skatt insÃ¤ttning',0),(82320,2287,'it','Deposito fiscale sui salari',0),(82321,2287,'tl','',0),(82322,2287,'th','&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3588;&#3656;&#3634;&#3616;&#3634;&#3625;&#3637;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(82323,2287,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤Ÿà¥ˆà¤•à¥à¤¸ à¤œà¤®à¤¾',0),(82324,2287,'ms','Deposit cukai gaji',0),(82325,2287,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(82326,2287,'fr','Virements de fonds impÃ´t',0),(82327,2287,'jp','çµ¦ä¸Žç¨Žé ?ã?‹ã‚Šé‡‘',0),(82328,2287,'pt','DepÃ³sito de imposto de folha de pagamento',0),(82329,2287,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð·Ð°Ð»Ð¾Ð³',0),(82330,2287,'es','DepÃ³sito de Impuesto de NÃ³mina',0),(82331,2287,'de','Gehaltsabrechnung Steuer Einzahlung',0),(82332,2287,'en','Payroll Tax Deposit',0),(82333,2288,'is','',0),(82334,2288,'dr','Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82335,2288,'pr','Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(82336,2288,'tr','Bordro vergi tablolarÄ±',0),(82337,2288,'pl','Tabele podatku od pÅ‚ac',0),(82338,2288,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð¸ Ð·Ð° Ð´Ð°Ð½ÑŠÐº Ð½Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(82339,2288,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù¹ÛŒÚ©Ø³ Ø¬Ø¯Ø§ÙˆÙ„',0),(82340,2288,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ',0),(82341,2288,'vi','Báº£ng thuáº¿ lÆ°Æ¡ng',0),(82342,2288,'af','Loonrol Belastingtabelle',0),(82343,2288,'ro','Tabele de impozit salarii',0),(82344,2288,'et','Palgaarvestuse maksutabelid',0),(82345,2288,'si','Tabel davka na izplaÄane plaÄe',0),(82346,2288,'ba','Penggajian pajak tabel',0),(82347,2288,'nl','Payroll belastingen tabellen',0),(82348,2288,'fi','Palkanlaskennan verotaulut',0),(82349,2288,'no','LÃ¸nn skattetabeller',0),(82350,2288,'da','Payroll Tax-tabeller',0),(82351,2288,'ko','ê¸‰ì—¬ ì„¸ê¸ˆ í…Œì´ë¸”',0),(82352,2288,'he','×˜×‘×œ××•×ª ×ž×¡ ×©×›×¨',0),(82353,2288,'el','Î Î¯Î½Î±ÎºÎµÏ‚ Ï†ÏŒÏÎ¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½',0),(82354,2288,'zh','å·¥èµ„ç¨Žè¡¨\r\n',0),(82355,2288,'sv','LÃ¶n skatt tabeller',0),(82356,2288,'it','Tabelle fiscali sui salari',0),(82357,2288,'tl','',0),(82358,2288,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3616;&#3634;&#3625;&#3637;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(82359,2288,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤Ÿà¥ˆà¤•à¥à¤¸ à¤Ÿà¥‡à¤¬à¤²à¥à¤¸',0),(82360,2288,'ms','Jadual cukai gaji',0),(82361,2288,'ar','Ø¬Ø¯Ø§ÙˆÙ„ Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(82362,2288,'fr','Tables d\'impÃ´t paie',0),(82363,2288,'jp','çµ¦ä¸Žç¨Žé¡?è¡¨',0),(82364,2288,'pt','Tabelas de imposto de folha de pagamento',0),(82365,2288,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹ ÐÐ°Ð»Ð¾Ð³Ð¾Ð² ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ñ… Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚ÐµÐ¹',0),(82366,2288,'es','Tablas de Impuestos de NÃ³mina',0),(82367,2288,'de','Payroll-Steuertabellen',0),(82368,2288,'en','Payroll Tax Tables',0),(82369,2289,'is','',0),(82370,2289,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ ',0),(82371,2289,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ ',0),(82372,2289,'tr','Bordro vergi Update genel bilgi',0),(82373,2289,'pl','Podatek od wynagrodzeÅ„ zaktualizowaÄ‡ informacje ogÃ³lne',0),(82374,2289,'bg','Ð¢Ð Ð— Ð´Ð°Ð½ÑŠÑ‡Ð½Ð°Ñ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¾Ð±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(82375,2289,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù¹ÛŒÚ©Ø³ Ø¬Ù†Ø±Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(82376,2289,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ð¸ Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð˜Ð½Ñ„Ð¾',0),(82377,2289,'vi','Cáº­p Nháº­t Thuáº¿ LÆ°Æ¡ng ThÃ´ng Tin Chung',0),(82378,2289,'af','Loonrol Belasting Opdatering Algemene Inligting',0),(82379,2289,'ro','Salarizare fiscale Update General Info',0),(82380,2289,'et','Palgafondi maksu Update Ãœldinfo',0),(82381,2289,'si','Davek na izplaÄane plaÄe posodobiti sploÅ¡ne informacije',0),(82382,2289,'ba','Pajak gaji memperbarui Info Umum',0),(82383,2289,'nl','Bedrijfsvoorheffing bijwerken Algemene Info',0),(82384,2289,'fi','TyÃ¶nantajamaksu pÃ¤ivittÃ¤Ã¤ yleistiedot',0),(82385,2289,'no','Arbeidsgiveravgift oppdatere General Info',0),(82386,2289,'da','LÃ¸nsumsafgift opdatere General Info',0),(82387,2289,'ko','ê¸‰ì—¬ ì„¸ê¸ˆ ì—…ë°ì´íŠ¸ ì¼ë°˜ ì •ë³´',0),(82388,2289,'he','×ž×¡ ×©×›×¨ ×œ×¢×“×›×Ÿ ×ž×™×“×¢ ×›×œ×œ×™',0),(82389,2289,'el','Î¦ÏŒÏÎ¿ Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(82390,2289,'zh','å·¥èµ„ç¨Žæ›´æ–°çš„ä¸€èˆ¬ä¿¡æ¯\r\n',0),(82391,2289,'sv','LÃ¶neskatt uppdatera allmÃ¤n Info',0),(82392,2289,'it','Imposta sui salari aggiornare informazioni generali',0),(82393,2289,'tl','',0),(82394,2289,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3651;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3',0),(82395,2289,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤Ÿà¥ˆà¤•à¥à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(82396,2289,'ms','Maklumat am Kemaskini cukai gaji',0),(82397,2289,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª Ø¨ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø©',0),(82398,2289,'fr','ImpÃ´t sur les salaires Ã  jour Infos gÃ©nÃ©rales',0),(82399,2289,'jp','çµ¦ä¸Žç¨Žæ›´æ–°ä¸€èˆ¬æƒ…å ±',0),(82400,2289,'pt','Imposto sobre os salÃ¡rios atualizar informaÃ§Ãµes gerais',0),(82401,2289,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½ÑƒÑŽ Ð¿Ð»Ð°Ñ‚Ñƒ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(82402,2289,'es','Impuesto de NÃ³mina Actualizar Info General',0),(82403,2289,'de','Lohnsteuer-aktualisieren-allgemeine Infos',0),(82404,2289,'en','Payroll Tax Update General Info',0),(82405,2290,'is','',0),(82406,2290,'dr','Ú†Ø§Ù¾ Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ',0),(82407,2290,'pr','Ú†Ø§Ù¾ Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ',0),(82408,2290,'tr','PDF formatÄ±nda yazdÄ±rÄ±n',0),(82409,2290,'pl','Druk w formacie PDF',0),(82410,2290,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð² PDF Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(82411,2290,'ur','Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ø±Ù…ÛŒÙ¹ Ù…ÛŒÚº Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(82412,2290,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñƒ ÐŸÐ”Ð¤ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(82413,2290,'vi','In dáº¡ng PDF',0),(82414,2290,'af','Druk in PDF formaat',0),(82415,2290,'ro','Imprimare in PDF format',0),(82416,2290,'et','Prindi PDF-formaadis',0),(82417,2290,'si','Tiskanje v PDF formatu',0),(82418,2290,'ba','Mencetak dalam PDF format',0),(82419,2290,'nl','Afdrukken in PDF-formaat',0),(82420,2290,'fi','Tulosta PDF-muodossa',0),(82421,2290,'no','Skrive ut i PDF-format',0),(82422,2290,'da','Udskrive i PDF-format',0),(82423,2290,'ko','PDF í˜•ì‹ìœ¼ë¡œ ì¸ì‡„',0),(82424,2290,'he','×œ×”×“×¤×™×¡ ×‘×¤×•×¨×ž×˜ PDF',0),(82425,2290,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÎµ Î¼Î¿ÏÏ†Î® PDF',0),(82426,2290,'zh','ä»¥PDFæ ¼å¼æ‰“å°\r\n',0),(82427,2290,'sv','Skriva ut i PDF-format',0),(82428,2290,'it','Stampare in formato PDF',0),(82429,2290,'tl','',0),(82430,2290,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610; PDF',0),(82431,2290,'hi','à¤ªà¥€à¤¡à¥€à¤à¤« à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(82432,2290,'ms','Mencetak dalam PDF format',0),(82433,2290,'ar','Ø·Ø¨Ø§Ø¹Ø© ÙÙŠ ØªÙ†Ø³ÙŠÙ‚ PDF',0),(82434,2290,'fr','Imprimer au format PDF',0),(82435,2290,'jp','PDFãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆã?§å?°åˆ·',0),(82436,2290,'pt','Imprimir em formato PDF',0),(82437,2290,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð² Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ PDF',0),(82438,2290,'es','Imprimir en Formato de PDF',0),(82439,2290,'de','Drucken im PDF-format',0),(82440,2290,'en','Print in PDF format',0),(82441,2291,'is','',0),(82442,2291,'dr','Ø·Ø±Ø­ Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÙŠ ',0),(82443,2291,'pr','Ø·Ø±Ø­ Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÙŠ ',0),(82444,2291,'tr','Emeklilik planÄ±',0),(82445,2291,'pl','System emerytalny',0),(82446,2291,'bg','ÐŸÐµÐ½ÑÐ¸Ð¾Ð½ÐµÐ½ Ð¿Ð»Ð°Ð½',0),(82447,2291,'ur','Ù¾Ù†Ø´Ù† Ù¾Ù„Ø§Ù†',0),(82448,2291,'sr','ÐŸÐµÐ½Ð·Ð¸Ñ˜Ð¾Ð¼',0),(82449,2291,'vi','Káº¿ hoáº¡ch hÆ°u trÃ­',0),(82450,2291,'af','Pensioenplan',0),(82451,2291,'ro','Plan de pensii',0),(82452,2291,'et','EttevÃµttepensioni plaan',0),(82453,2291,'si','Pokojninski naÄrt',0),(82454,2291,'ba','Program pensiun',0),(82455,2291,'nl','Pensioenplan',0),(82456,2291,'fi','Pension Plan',0),(82457,2291,'no','Pensjonsordning',0),(82458,2291,'da','Pensionsordning',0),(82459,2291,'ko','ì—°ê¸ˆ ê³„íš',0),(82460,2291,'he','×ª×•×›× ×™×ª ×¤× ×¡×™×”',0),(82461,2291,'el','Î£Ï…Î½Ï„Î±Î¾Î¹Î¿Î´Î¿Ï„Î¹ÎºÏŒ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î±',0),(82462,2291,'zh','é€€ä¼‘é‡‘è®¡åˆ’\r\n',0),(82463,2291,'sv','Pensionsplan',0),(82464,2291,'it','Piano pensionistico',0),(82465,2291,'tl','',0),(82466,2291,'th','&#3649;&#3612;&#3609;&#3648;&#3591;&#3636;&#3609;&#3610;&#3635;&#3609;&#3634;&#3597;',0),(82467,2291,'hi','à¤ªà¥‡à¤‚à¤¶à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾',0),(82468,2291,'ms','Pelan pencen',0),(82469,2291,'ar','Ø®Ø·Ø© Ø§Ù„Ù…Ø¹Ø§Ø´Ø§Øª Ø§Ù„ØªÙ‚Ø§Ø¹Ø¯ÙŠØ©',0),(82470,2291,'fr','RÃ©gime de retraite',0),(82471,2291,'jp','å¹´é‡‘åˆ¶åº¦',0),(82472,2291,'pt','Plano de previdÃªncia',0),(82473,2291,'ru','ÐŸÐµÐ½ÑÐ¸Ð¾Ð½Ð½Ñ‹Ð¹ Ð¿Ð»Ð°Ð½',0),(82474,2291,'es','Plan de PensiÃ³n',0),(82475,2291,'de','Pensionsplan',0),(82476,2291,'en','Pension Plan',0),(82477,2292,'is','',0),(82478,2292,'dr','(Ù…Ø´Ø±ÙˆØ·',0),(82479,2292,'pr','Ù…Ø¹Ù„Ù‚(Ù…Ø´Ø±ÙˆØ·',0),(82480,2292,'tr','Beklemede',0),(82481,2292,'pl','OczekujÄ…ce',0),(82482,2292,'bg','Ð§Ð°ÐºÐ°Ñ‰Ð¾',0),(82483,2292,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡',0),(82484,2292,'sr','ÐÐ° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(82485,2292,'vi','Äang treo',0),(82486,2292,'af','Afwagtend',0),(82487,2292,'ro','ÃŽn aÅŸteptare',0),(82488,2292,'et','Ootel',0),(82489,2292,'si','ÄŒakajoÄa',0),(82490,2292,'ba','Tertunda',0),(82491,2292,'nl','In behandeling',0),(82492,2292,'fi','VireillÃ¤',0),(82493,2292,'no','Ventende',0),(82494,2292,'da','Ventende',0),(82495,2292,'ko','ë³´ë¥˜ ì¤‘',0),(82496,2292,'he','×ž×ž×ª×™× ×”',0),(82497,2292,'el','Î£Îµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î±',0),(82498,2292,'zh','å¾…åŠžä¸­',0),(82499,2292,'sv','VÃ¤ntande',0),(82500,2292,'it','In sospeso',0),(82501,2292,'tl','',0),(82502,2292,'th','&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(82503,2292,'hi','à¤²à¤‚à¤¬à¤¿à¤¤',0),(82504,2292,'ms','Belum selesai',0),(82505,2292,'ar','Ù…Ø¹Ù„Ù‚Ø©',0),(82506,2292,'fr','En attente',0),(82507,2292,'jp','ä¿?ç•™',0),(82508,2292,'pt','Pendente',0),(82509,2292,'ru','Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(82510,2292,'es','Pendiente',0),(82511,2292,'de','Ausstehende',0),(82512,2292,'en','Pending',0),(82513,2293,'is','',0),(82514,2293,'dr','ÙÙ‚Ø· Ù…Ø¹ÙˆÙ‚ ',0),(82515,2293,'pr','ÙÙ‚Ø· Ù…Ø¹ÙˆÙ‚ ',0),(82516,2293,'tr','Sadece bekleyen',0),(82517,2293,'pl','Do czasu tylko',0),(82518,2293,'bg','Ð§Ð°ÐºÐ°Ñ‰Ð¸ ÑÐ°Ð¼Ð¾',0),(82519,2293,'ur','ØµØ±Ù Ø²ÛŒØ±Ù Ø§Ù„ØªÙˆØ§',0),(82520,2293,'sr','ÐÐ° Ñ‡ÐµÐºÐ°ÑšÑƒ Ñ˜Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸',0),(82521,2293,'vi','Chá»‰ Ä‘ang treo',0),(82522,2293,'af','Afwagtende Alleen',0),(82523,2293,'ro','ÃŽn aÅŸteptarea numai',0),(82524,2293,'et','Ainult ootel',0),(82525,2293,'si','NereÅ¡eno le',0),(82526,2293,'ba','Tertunda hanya',0),(82527,2293,'nl','In afwachting van enige',0),(82528,2293,'fi','Kunnes vain',0),(82529,2293,'no','Ventende bare',0),(82530,2293,'da','Indtil der kun',0),(82531,2293,'ko','ìœ ì¼í•œ ë³´ë¥˜',0),(82532,2293,'he','×”×ž×ª× ×” ×”×™×—×™×“×”',0),(82533,2293,'el','Î•Î½ Î±Î½Î±Î¼Î¿Î½Î® Î¼ÏŒÎ½Î¿',0),(82534,2293,'zh','ä»…å¾…åŠž\r\n',0),(82535,2293,'sv','Avvaktan pÃ¥ endast',0),(82536,2293,'it','In attesa di unico',0),(82537,2293,'tl','',0),(82538,2293,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(82539,2293,'hi','à¤•à¥‡à¤µà¤² à¤²à¤‚à¤¬à¤¿à¤¤',0),(82540,2293,'ms','Menunggu sahaja',0),(82541,2293,'ar','Ø§Ù†ØªØ¸Ø§Ø± ÙÙ‚Ø·',0),(82542,2293,'fr','En attendant la seule',0),(82543,2293,'jp','ä¿?ç•™ã?®ã?¿',0),(82544,2293,'pt','Pendente Ãºnica',0),(82545,2293,'ru','Ð’ Ð¾Ð¶Ð¸Ð´Ð°Ð½Ð¸Ð¸ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(82546,2293,'es','Pendiente Solo',0),(82547,2293,'de','Ausstehende nur',0),(82548,2293,'en','Pending Only',0),(82549,2294,'is','',0),(82550,2294,'dr','Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(82551,2294,'pr','Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(82552,2294,'tr','Emeklilik baÅŸarÄ±yla eklendi',0),(82553,2294,'pl','Pensjonat dodano pomyÅ›lnie',0),(82554,2294,'bg','ÐŸÐµÐ½ÑÐ¸Ñ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(82555,2294,'ur','Ù¾Ù†Ø´Ù† Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(82556,2294,'sr','ÐŸÐµÐ½Ð·Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(82557,2294,'vi','ThÃªm lÆ°Æ¡ng hÆ°u thÃ nh cÃ´ng',0),(82558,2294,'af','Pensioen suksesvol Bygevoeg',0),(82559,2294,'ro','Pensiunea adÄƒugat cu succes',0),(82560,2294,'et','Lisatud Pension',0),(82561,2294,'si','Pension uspeÅ¡no dodani',0),(82562,2294,'ba','Pension ditambahkan berhasil',0),(82563,2294,'nl','Pensioen toegevoegd',0),(82564,2294,'fi','Pension lisÃ¤Ã¤minen onnistui',0),(82565,2294,'no','Pension lagt',0),(82566,2294,'da','Pension tilfÃ¸jet',0),(82567,2294,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ì—°ê¸ˆ',0),(82568,2294,'he','×¤× ×¡×™×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(82569,2294,'el','Pension Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(82570,2294,'zh','é€€ä¼‘é‡‘æ·»åŠ æˆåŠŸ\r\n',0),(82571,2294,'sv','Pension lagts',0),(82572,2294,'it','Pensione aggiunto con successo',0),(82573,2294,'tl','',0),(82574,2294,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3591;&#3636;&#3609;&#3610;&#3635;&#3609;&#3634;&#3597;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(82575,2294,'hi','à¤ªà¥‡à¤‚à¤¶à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(82576,2294,'ms','Pencen yang berjaya menambah',0),(82577,2294,'ar','Ø§Ù„Ù…Ø¹Ø§Ø´ Ø§Ù„ØªÙ‚Ø§Ø¹Ø¯ÙŠ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(82578,2294,'fr','Pension ajoutÃ©e avec succÃ¨s',0),(82579,2294,'jp','å¹´é‡‘ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(82580,2294,'pt','PensÃ£o adicionado com sucesso',0),(82581,2294,'ru','ÐŸÐµÐ½ÑÐ¸Ð¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(82582,2294,'es','PensiÃ³n agregado exitosamente',0),(82583,2294,'de','Pension erfolgreich hinzugefÃ¼gt',0),(82584,2294,'en','Pension added successfully',0),(82585,2295,'is','',0),(82586,2295,'dr','Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯Ù‰ / Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø³ Ø§Ù†Ø¯Ø§Ø²',0),(82587,2295,'pr','Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯Ù‰ / Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø³ Ø§Ù†Ø¯Ø§Ø²',0),(82588,2295,'tr','Pansiyon/tasarruf planlarÄ±',0),(82589,2295,'pl','Plany gromadzenia oszczÄ™dnoÅ›ci emerytalnych',0),(82590,2295,'bg','ÐŸÐµÐ½ÑÐ¸Ñ/ÑÐ¿ÐµÑÑ‚Ð¾Ð²Ð½Ð¸ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(82591,2295,'ur','Ù¾Ù†Ø´Ù†/Ø¨Ú†ØªÛŒ Ù…Ù†ØµÙˆØ¨ÙˆÚº',0),(82592,2295,'sr','ÐŸÐ»Ð°Ð½Ð¾Ð²Ð¸ Ð·Ð° Ð¿ÐµÐ½Ð·Ð¸Ñ˜Ñƒ/ÑˆÑ‚ÐµÐ´ÑšÐ°',0),(82593,2295,'vi','LÆ¯Æ NG HÆ¯U/Káº¾ HOáº CH TIáº¾T KIá»†M',0),(82594,2295,'af','PENSIOEN/SPAARPLANNE',0),(82595,2295,'ro','Planurile de pensii/economii',0),(82596,2295,'et','Pensioni sÃ¤Ã¤ste',0),(82597,2295,'si','Pokojnine/konkuren',0),(82598,2295,'ba','Pension tabungan rencana',0),(82599,2295,'nl','Pensioensparen/plannen',0),(82600,2295,'fi','Pension sÃ¤Ã¤stÃ¶istÃ¤ suunnitelmat',0),(82601,2295,'no','Pension/spareplaner',0),(82602,2295,'da','Pensionsopsparing/planer',0),(82603,2295,'ko','ì—°ê¸ˆ/ì €ì¶• ê³„íš',0),(82604,2295,'he','×ª×•×›× ×™×•×ª ×—×¡×›×•×Ÿ/×¤× ×¡×™×•× ×™',0),(82605,2295,'el','Î£Ï…Î½Ï„Î±Î¾Î¹Î¿Î´ÏŒÏ„Î·ÏƒÎ·/Î±Ï€Î¿Ï„Î±Î¼Î¯ÎµÏ…ÏƒÎ·',0),(82606,2295,'zh','é€€ä¼‘é‡‘/å‚¨è“„è®¡åˆ’\r\n',0),(82607,2295,'sv','Pensionssparande/planer',0),(82608,2295,'it','Piani pensionistici/risparmio',0),(82609,2295,'tl','',0),(82610,2295,'th','&#3648;&#3591;&#3636;&#3609;&#3610;&#3635;&#3609;&#3634;&#3597;/&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3629;&#3629;&#3617;',0),(82611,2295,'hi','à¤ªà¥‡à¤‚à¤¶à¤¨/à¤¬à¤šà¤¤ à¤¯à¥‹à¤œà¤¨à¤¾',0),(82612,2295,'ms','Pelan-pelan persaraan/simpanan',0),(82613,2295,'ar','Ø®Ø·Ø· Ø§Ù„Ù…Ø¹Ø§Ø´Ø§Øª Ø§Ù„ØªÙ‚Ø§Ø¹Ø¯ÙŠØ©/Ø§Ù„Ø§Ø¯Ø®Ø§Ø±',0),(82614,2295,'fr','Retraite/Ã©pargne',0),(82615,2295,'jp','å¹´é‡‘/è²¯è“„åˆ¶åº¦',0),(82616,2295,'pt','Planos de poupanÃ§a-reforma',0),(82617,2295,'ru','ÐŸÐµÐ½ÑÐ¸Ñ/ÑÐ±ÐµÑ€ÐµÐ³Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¿Ð»Ð°Ð½Ñ‹',0),(82618,2295,'es','PENSIÃ“N/PLANES DE AHORROS',0),(82619,2295,'de','Pension/SparplÃ¤ne',0),(82620,2295,'en','Pension/Savings Plans',0),(82621,2296,'is','',0),(82622,2296,'dr','Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(82623,2296,'pr','Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(82624,2296,'tr','Emeklilik baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(82625,2296,'pl','Pensjonat pomyÅ›lnie zaktualizowana',0),(82626,2296,'bg','ÐŸÐµÐ½ÑÐ¸Ñ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(82627,2296,'ur','Ù¾Ù†Ø´Ù† Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(82628,2296,'sr','ÐŸÐµÐ½Ð·Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(82629,2296,'vi','Cáº­p Nháº­t LÆ°Æ¡ng HÆ°u thÃ nh cÃ´ng',0),(82630,2296,'af','Pensioen suksesvol Opdateer',0),(82631,2296,'ro','Pensiunea actualizat cu succes',0),(82632,2296,'et','VÃ¤rskendatud Pension',0),(82633,2296,'si','Pension uspeÅ¡no posodobljena',0),(82634,2296,'ba','Pension berhasil',0),(82635,2296,'nl','Pensioen bijgewerkt',0),(82636,2296,'fi','Pension pÃ¤ivitetty',0),(82637,2296,'no','Pension oppdatert',0),(82638,2296,'da','Pension opdateret',0),(82639,2296,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì—°ê¸ˆ',0),(82640,2296,'he','Pension ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(82641,2296,'el','Pension ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(82642,2296,'zh','é€€ä¼‘é‡‘æˆåŠŸæ›´æ–°\r\n',0),(82643,2296,'sv','Pension uppdaterats',0),(82644,2296,'it','Pensione aggiornato con successo',0),(82645,2296,'tl','',0),(82646,2296,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3633;&#3591;&#3648;&#3591;&#3636;&#3609;&#3610;&#3635;&#3609;&#3634;&#3597;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(82647,2296,'hi','à¤ªà¥‡à¤‚à¤¶à¤¨ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(82648,2296,'ms','Pencen yang berjaya dikemas kini',0),(82649,2296,'ar','Ø§Ù„Ù…Ø¹Ø§Ø´Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… ØªØ­Ø¯ÙŠØ«Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(82650,2296,'fr','Pension correctement mis Ã  jour',0),(82651,2296,'jp','å¹´é‡‘ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(82652,2296,'pt','PensÃ£o atualizado com sucesso',0),(82653,2296,'ru','ÐŸÐµÐ½ÑÐ¸Ð¸ Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(82654,2296,'es','PensiÃ³n actualizada exitosamente',0),(82655,2296,'de','Pension erfolgreich aktualisiert',0),(82656,2296,'en','Pension updated successfully',0),(82657,2297,'is','',0),(82658,2297,'dr','Ø¯Ø± Ù‡Ø± ',0),(82659,2297,'pr','Ø¯Ø± Ù‡Ø± ',0),(82660,2297,'tr','Ãœcret',0),(82661,2297,'pl','Na',0),(82662,2297,'bg','ÐÐ°',0),(82663,2297,'ur','ÙÛŒ',0),(82664,2297,'sr','ÐŸÐ¾',0),(82665,2297,'vi','Má»—i',0),(82666,2297,'af','Per',0),(82667,2297,'ro','Per',0),(82668,2297,'et','Inimese kohta',0),(82669,2297,'si','Na',0),(82670,2297,'ba','Per',0),(82671,2297,'nl','Per',0),(82672,2297,'fi','/ /',0),(82673,2297,'no','Per',0),(82674,2297,'da','Per',0),(82675,2297,'ko','ë‹¹',0),(82676,2297,'he','×œ×›×œ',0),(82677,2297,'el','Î‘Î½Î¬',0),(82678,2297,'zh','æ¯\r\n',0),(82679,2297,'sv','Per',0),(82680,2297,'it','Per ogni',0),(82681,2297,'tl','',0),(82682,2297,'th','&#3605;&#3656;&#3629;',0),(82683,2297,'hi','à¤ªà¥à¤°à¤¤à¤¿',0),(82684,2297,'ms','Setiap',0),(82685,2297,'ar','Ø§Ù„ÙˆØ§Ø­Ø¯Ø©',0),(82686,2297,'fr','Par',0),(82687,2297,'jp','ã?«ã?¤ã??',0),(82688,2297,'pt','Por',0),(82689,2297,'ru','Ð—Ð°',0),(82690,2297,'es','Por',0),(82691,2297,'de','Pro',0),(82692,2297,'en','Per',0),(82693,2298,'is','',0),(82694,2298,'dr','Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª Ø§Ø¶Ø§ÙÙ‡ ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ù‚Ø¨Ù„ ',0),(82695,2298,'pr','Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª Ø§Ø¶Ø§ÙÙ‡ ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ù‚Ø¨Ù„ ',0),(82696,2298,'tr','bir saatte ele geÃ§en miktar',0),(82697,2298,'pl','na godzinÄ™ w ciÄ…gu ostatnich iloÅ›Ä‡',0),(82698,2298,'bg','Ð² Ñ‡Ð°Ñ Ð½Ð°Ð´ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ ÐºÐ¾Ð»',0),(82699,2298,'ur','Ø¢Ø®Ø±ÛŒ Ù‚ÛŒ Ù¾Ø± ÙÛŒ Ú¯Ú¾Ù†Ù¹Û',0),(82700,2298,'sr','Ð½Ð° ÑÐ°Ñ‚ Ð¿Ñ€ÐµÐºÐ¾ Ð·Ð°Ð´ÑšÐ¸ ÐšÐ¾Ð».',0),(82701,2298,'vi','má»—i giá» trÃªn sá»‘ lÆ°á»£ng trÆ°á»›c',0),(82702,2298,'af','per uur oor laaste qty',0),(82703,2298,'ro','pe orÄƒ peste ultima cantitate',0),(82704,2298,'et','tund Ã¼le viimase kogus',0),(82705,2298,'si','na uro Äez zadnji kol',0),(82706,2298,'ba','per jam di atas terakhir qty',0),(82707,2298,'nl','per uur over laatste aantal',0),(82708,2298,'fi','tunnissa yli viime mÃ¤Ã¤rÃ¤',0),(82709,2298,'no','per time over siste antall',0),(82710,2298,'da','i timen over sidste qty',0),(82711,2298,'ko','ë§ˆì§€ë§‰ ìˆ˜ëŸ‰ ì´ìƒ ì‹œê°„ë‹¹',0),(82712,2298,'he','×œ×©×¢×” ×¢×œ ×›×ž×•×ª ×”××—×¨×•× ×™×',0),(82713,2298,'el','Î±Î½Î¬ ÏŽÏÎ± Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Ï„Î·Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± qty',0),(82714,2298,'zh','æ¯å°æ—¶è¶…è¿‡æœ€åŽæ•°é‡\r\n',0),(82715,2298,'sv','per timme Ã¶ver senaste Kvt',0),(82716,2298,'it','per ora negli ultimi qty',0),(82717,2298,'tl','',0),(82718,2298,'th','&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3637;&#3656;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3619;&#3633;&#3657;&#3591;&#3621;&#3656;&#3634;&#3626;&#3640;&#3',0),(82719,2298,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤ªà¤¿à¤›à¤²à¥‡ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(82720,2298,'ms','sejam lebih lepas qty',0),(82721,2298,'ar','ÙƒÙ„ Ø³Ø§Ø¹Ø© Ø¹Ù„Ù‰ Ø¢Ø®Ø± Ø§Ù„ÙƒÙ…ÙŠØ©',0),(82722,2298,'fr','Ã  l\'heure au cours de la derniÃ¨re quantitÃ©',0),(82723,2298,'jp','per hour over last qty',0),(82724,2298,'pt','por hora ao longo do Ãºltimo qty',0),(82725,2298,'ru','Ð² Ñ‡Ð°Ñ Ð·Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ ÐšÐ¾Ð»',0),(82726,2298,'es','por hora sobre la cant. ultima',0),(82727,2298,'de','pro Stunde Ã¼ber letzte qty',0),(82728,2298,'en','per hour over last qty',0),(82729,2299,'is','',0),(82730,2299,'dr','Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± ',0),(82731,2299,'pr','Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± ',0),(82732,2299,'tr','saat iÃ§in miktar kadar',0),(82733,2299,'pl','na godzinÄ™ do iloÅ›Ä‡',0),(82734,2299,'bg','Ð·Ð° Ñ‡Ð°Ñ Ð´Ð¾ ÐºÐ¾Ð»',0),(82735,2299,'ur','Ù‚ÛŒ ØªÚ© ÙÛŒ Ú¯Ú¾Ù†Ù¹Û',0),(82736,2299,'sr','Ð¿Ð¾ ÑÐ°Ñ‚Ñƒ Ð´Ð¾ ÐšÐ¾Ð».',0),(82737,2299,'vi','má»—i giá» Ä‘áº¿n sá»‘ lÆ°á»£ng',0),(82738,2299,'af','per uur tot qty',0),(82739,2299,'ro','pe orÄƒ pÃ¢nÄƒ la cantitate',0),(82740,2299,'et','tund kuni kogus',0),(82741,2299,'si','na uro do kol.',0),(82742,2299,'ba','setiap jam tambahan qty',0),(82743,2299,'nl','per uur tot aantal',0),(82744,2299,'fi','tunnissa jopa mÃ¤Ã¤rÃ¤',0),(82745,2299,'no','per time til antall',0),(82746,2299,'da','i timen op til antal',0),(82747,2299,'ko','qty ìµœëŒ€ ì‹œê°„ ë‹¹',0),(82748,2299,'he','×œ×©×¢×” ×¢×“ ×›×ž×•×ª',0),(82749,2299,'el','Î±Î½Î¬ ÏŽÏÎ± Î¼Î­Ï‡ÏÎ¹ qty',0),(82750,2299,'zh','æ¯å°æ—¶æ•°é‡æœ€å¤š\r\n',0),(82751,2299,'sv','per timme upp till Kvt',0),(82752,2299,'it','all\'ora fino a q. tÃ ',0),(82753,2299,'tl','',0),(82754,2299,'th','&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3605;&#3634;&#3617;&#3652;&#3611;&#3606;&#3638;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(82755,2299,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¤à¤• à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾',0),(82756,2299,'ms','setiap jam sehingga qty',0),(82757,2299,'ar','ÙƒÙ„ Ø³Ø§Ø¹Ø© Ø­ØªÙ‰ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(82758,2299,'fr','par heure jusqu\'Ã  QtÃ©',0),(82759,2299,'jp','per hour up to qty',0),(82760,2299,'pt','por hora atÃ© qty',0),(82761,2299,'ru','Ð² Ñ‡Ð°Ñ Ð´Ð¾ ÑˆÑ‚.',0),(82762,2299,'es','por hora hasta la cant.',0),(82763,2299,'de','pro Stunde bis zu der Menge:',0),(82764,2299,'en','per hour up to qty',0),(82765,2300,'is','',0),(82766,2300,'dr','= 454 Ú¯Ø±Ù… ',0),(82767,2300,'pr','Ù‡Ø± Ù¾ÙˆÙ†Ø¯ = 454 Ú¯Ø±Ù… ',0),(82768,2300,'tr','Lb',0),(82769,2300,'pl','Na Lb',0),(82770,2300,'bg','ÐŸÐ¾ Lb',0),(82771,2300,'ur','Lb ÙÛŒ',0),(82772,2300,'sr','ÐŸÐ¾ Ð›Ð±',0),(82773,2300,'vi','Má»—i pound',0),(82774,2300,'af','Per gesny',0),(82775,2300,'ro','Per Lb',0),(82776,2300,'et','Per Lb',0),(82777,2300,'si','Per Lb',0),(82778,2300,'ba','Per Lb',0),(82779,2300,'nl','Per pond',0),(82780,2300,'fi','Per naula',0),(82781,2300,'no','Per Lb',0),(82782,2300,'da','Per Lb',0),(82783,2300,'ko','íŒŒìš´ë“œ ë‹¹',0),(82784,2300,'he','×œ×›×œ ×§ ×’',0),(82785,2300,'el','Î‘Î½Î¬ Lb',0),(82786,2300,'zh','æ¯ç£…\r\n',0),(82787,2300,'sv','Per Lb',0),(82788,2300,'it','Per libbra',0),(82789,2300,'tl','',0),(82790,2300,'th','Per Lb',0),(82791,2300,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¥Œà¤‚à¤¡',0),(82792,2300,'ms','Satu paun',0),(82793,2300,'ar','ÙƒÙ„ Ø±Ø·Ù„',0),(82794,2300,'fr','Par Lb',0),(82795,2300,'jp','ãƒ?ãƒ³ãƒ‰ã?«ã?¤ã??',0),(82796,2300,'pt','Por Lb',0),(82797,2300,'ru','Ð—Ð° Ñ„ÑƒÐ½Ñ‚',0),(82798,2300,'es','Por Lb',0),(82799,2300,'de','Pro Lb',0),(82800,2300,'en','Per Lb',0),(82801,2301,'is','',0),(82802,2301,'dr','(Ø¯Ù‚ÙŠÙ‚Ù‡- Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(82803,2301,'pr','Ù‡Ø± Ù…ØªØ± (Ø¯Ù‚ÙŠÙ‚Ù‡- Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(82804,2301,'tr','M baÅŸÄ±na',0),(82805,2301,'pl','Na M',0),(82806,2301,'bg','ÐÐ° Ðœ',0),(82807,2301,'ur','Ù…ÛŒÙ¹Ø± ÙÛŒ',0),(82808,2301,'sr','ÐÐ° Ðœ',0),(82809,2301,'vi','Má»—i M',0),(82810,2301,'af','Per M',0),(82811,2301,'ro','Pe M',0),(82812,2301,'et','Ruutmeetri',0),(82813,2301,'si','Na M',0),(82814,2301,'ba','Per M',0),(82815,2301,'nl','Per M',0),(82816,2301,'fi','Per M',0),(82817,2301,'no','Per M',0),(82818,2301,'da','Per MÃ¸ller',0),(82819,2301,'ko','M ë‹¹',0),(82820,2301,'he','×œ×ž×˜×¨.',0),(82821,2301,'el','Î‘Î½Î¬ M',0),(82822,2301,'zh','æ¯å¨\r\n',0),(82823,2301,'sv','Per M',0),(82824,2301,'it','Per ogni M',0),(82825,2301,'tl','',0),(82826,2301,'th','Per M',0),(82827,2301,'hi','M à¤ªà¥à¤°à¤¤à¤¿',0),(82828,2301,'ms','Satu M',0),(82829,2301,'ar','ÙƒÙ„ Ù…',0),(82830,2301,'fr','Par M',0),(82831,2301,'jp','Mã?«ã?¤ã??',0),(82832,2301,'pt','Por M',0),(82833,2301,'ru','Ð—Ð° Ðœ',0),(82834,2301,'es','Por M',0),(82835,2301,'de','Pro M',0),(82836,2301,'en','Per M',0),(82837,2302,'is','',0),(82838,2302,'dr','(Ø¯Ù‚ÙŠÙ‚Ù‡- Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¬Ù‡Øª (ÙØ±Ù…Ø§ÛŒØ´ ) Ø´ØºÙ„',0),(82839,2302,'pr','Ù‡Ø± Ù…ØªØ± (Ø¯Ù‚ÙŠÙ‚Ù‡- Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¬Ù‡Øª (Ø³ÙØ§Ø±Ø´ ) Ø´ØºÙ„',0),(82840,2302,'tr','iÅŸ M',0),(82841,2302,'pl','na M do pracy',0),(82842,2302,'bg','Ð½Ð° M Ð´Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(82843,2302,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù„ÛŒÛ’ ÙÛŒ M',0),(82844,2302,'sr','Ð½Ð° Ðœ Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(82845,2302,'vi','Má»—i M tá»›i Job',0),(82846,2302,'af','per M te werk',0),(82847,2302,'ro','pe M la job',0),(82848,2302,'et','ruutmeetri tÃ¶Ã¶',0),(82849,2302,'si','na M za delo',0),(82850,2302,'ba','per M untuk pekerjaan',0),(82851,2302,'nl','per M van baan',0),(82852,2302,'fi','per M tyÃ¶tÃ¤',0),(82853,2302,'no','per M til jobben',0),(82854,2302,'da','per M til job',0),(82855,2302,'ko','ìž‘ì—…ì— M ë‹¹',0),(82856,2302,'he','×œ×ž×˜×¨. ×œ×¢×‘×•×“×”',0),(82857,2302,'el','Î±Î½Î¬ M ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(82858,2302,'zh','æ¯å¨çš„å·¥ä½œ\r\n',0),(82859,2302,'sv','per M till jobb',0),(82860,2302,'it','per ogni M di lavoro',0),(82861,2302,'tl','',0),(82862,2302,'th','per M to job',0),(82863,2302,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¤à¤¿ à¤®à¥€à¤Ÿà¤°',0),(82864,2302,'ms','satu juta untuk kerja',0),(82865,2302,'ar','ÙƒÙ„ Ù… Ù„Ù„ÙˆØ¸ÙŠÙØ©',0),(82866,2302,'fr','par M au travail',0),(82867,2302,'jp','per M to job',0),(82868,2302,'pt','por M para trabalho',0),(82869,2302,'ru','Ð·Ð° Ð¼ÐµÑ‚Ñ€ Ð´Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(82870,2302,'es','Por M al trabajo',0),(82871,2302,'de','pro M Job',0),(82872,2302,'en','per M to job',0),(82873,2303,'is','',0),(82874,2303,'dr','Ù‡Ø± ÙˆØ§Ø­Ø¯ Ø®Ø±ÙŠØ¯ ',0),(82875,2303,'pr','Ù‡Ø± ÙˆØ§Ø­Ø¯ Ø®Ø±ÙŠØ¯ ',0),(82876,2303,'tr','SatÄ±nalma birimi baÅŸÄ±na',0),(82877,2303,'pl','jednostkowa zakupu',0),(82878,2303,'bg','Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(82879,2303,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(82880,2303,'sr','Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(82881,2303,'vi','Má»—i Ä‘Æ¡n vá»‹ mua',0),(82882,2303,'af','per Aankoopeenheid',0),(82883,2303,'ro','per unitate de cumpÄƒrare',0),(82884,2303,'et','OstuÃ¼hiku kohta',0),(82885,2303,'si','na nakup enoto',0),(82886,2303,'ba','setiap pembelian Unit',0),(82887,2303,'nl','per aankoop eenheid',0),(82888,2303,'fi','ostoyksikkÃ¶Ã¤ kohden',0),(82889,2303,'no','pr. innkjÃ¸psenhet',0),(82890,2303,'da','pr. KÃ¸bsenhed',0),(82891,2303,'ko','êµ¬ë§¤ ë‹¨ìœ„ ë‹¹',0),(82892,2303,'he','×œ×™×—×™×“×ª ×”×¨×›×©',0),(82893,2303,'el','Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Î±Î³Î¿ÏÎ¬',0),(82894,2303,'zh','æ¯è´­ä¹°å•ä½\r\n',0),(82895,2303,'sv','per inkÃ¶psenhet',0),(82896,2303,'it','Acquisto unitario',0),(82897,2303,'tl','',0),(82898,2303,'th','&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(82899,2303,'hi','à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤•à¤¾à¤ˆ',0),(82900,2303,'ms','Setiap Unit pembelian',0),(82901,2303,'ar','ÙƒÙ„ ÙˆØ­Ø¯Ø© Ø§Ù„Ø´Ø±Ø§Ø¡',0),(82902,2303,'fr','Achat unitaire',0),(82903,2303,'jp','è³¼å…¥å?˜ä½?ã?«ã?¤ã??',0),(82904,2303,'pt','por unidade de compra',0),(82905,2303,'ru','Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(82906,2303,'es','Por Unidad de Compra',0),(82907,2303,'de','pro Bestelleinheit',0),(82908,2303,'en','per Purchase Unit',0),(82909,2304,'is','',0),(82910,2304,'dr','Ø¯Ø± Ù‡Ø± Ú†Ù‡ Ù…Ù‚Ø¯Ø§Ø± ',0),(82911,2304,'pr','Ø¯Ø± Ù‡Ø± Ú†Ù‡ Ù…Ù‚Ø¯Ø§Ø± ',0),(82912,2304,'tr','Ne miktar',0),(82913,2304,'pl','Za co iloÅ›Ä‡',0),(82914,2304,'bg','Ð—Ð° ÐºÐ°ÐºÐ²Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(82915,2304,'ur','ÙÛŒ Ú©Ø³ Ù‚ÛŒ',0),(82916,2304,'sr','ÐŸÐ¾ ÐºÐ°ÐºÐ°Ð² ÐšÐ¾Ð».',0),(82917,2304,'vi','Má»—i sá»‘ lÆ°á»£ng nÃ o',0),(82918,2304,'af','Watter Qty per',0),(82919,2304,'ro','Pe ce cantit',0),(82920,2304,'et','Milline kogus inimese kohta',0),(82921,2304,'si','Na kakÅ¡en kol.',0),(82922,2304,'ba','Per Qty apa',0),(82923,2304,'nl','Per wat aantal',0),(82924,2304,'fi','MitÃ¤ arvo suhteessa mÃ¤Ã¤rÃ¤Ã¤n',0),(82925,2304,'no','Per hva antall',0),(82926,2304,'da','Per hvad Qty',0),(82927,2304,'ko','ì–´ë–¤ ìˆ˜ëŸ‰ ë‹¹',0),(82928,2304,'he','×œ×›×œ ×ž×” ×›×ž×•×ª',0),(82929,2304,'el','Î‘Î½Î¬ Ï„Î¹ Qty',0),(82930,2304,'zh','æ¯ä»€ä¹ˆæ•°é‡\r\n',0),(82931,2304,'sv','Per vad Kvt',0),(82932,2304,'it','Per ogni cosa Qty',0),(82933,2304,'tl','',0),(82934,2304,'th','&#3605;&#3656;&#3629;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3651;&#3604;&#3654;',0),(82935,2304,'hi','à¤•à¥à¤¯à¤¾ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿',0),(82936,2304,'ms','Setiap Qty apa',0),(82937,2304,'ar','ÙƒÙ„ Ù…Ø§ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(82938,2304,'fr','Par quelle QtÃ©',0),(82939,2304,'jp','ã?©ã?®æ•°é‡?ã?«ã?¤ã??',0),(82940,2304,'pt','Por que Qty',0),(82941,2304,'ru','Ð—Ð° ÐºÐ°ÐºÐ¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(82942,2304,'es','Por Que cant.',0),(82943,2304,'de','Pro was Qty',0),(82944,2304,'en','Per What Qty',0),(82945,2305,'is','',0),(82946,2305,'dr','Ø¯Ø±ØµØ¯ Ø²Ù…Ø§Ù† Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ù…Ø§Ø´ÙŠÙ† â€“ Ø§Ù¾Ø±Ø§ØªÙˆØ±Ù‡Ø§ Ùˆ Ø¯Ø³ØªÙŠØ§Ø±Ø§Ù† ',0),(82947,2305,'pr','Ø¯Ø±ØµØ¯ Ø²Ù…Ø§Ù† Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ù…Ø§Ø´ÙŠÙ† â€“ Ø§Ù¾Ø±Ø§ØªÙˆØ±Ù‡Ø§ Ùˆ Ø¯Ø³ØªÙŠØ§Ø±Ø§Ù† ',0),(82948,2305,'tr','Zaman gerektiren operatÃ¶rler & yardÄ±mcÄ±lar yÃ¼zde makine',0),(82949,2305,'pl','Procent maszyna czasu wymagajÄ…cych operatorÃ³w & asystentÃ³w',0),(82950,2305,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð²Ñ€ÐµÐ¼Ðµ Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ñ‰Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ð¸ & Ð¿Ð¾Ð¼Ð¾Ñ‰Ð½Ð¸Ñ†Ð¸',0),(82951,2305,'ur','ÙÛŒØµØ¯ ÙˆÙ‚Øª Ø¢Ù¾Ø±ÛŒÙ¹Ø±Ø² Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª & Ù…Ø¹Ø§ÙˆÙ† Ù…Ø´ÛŒÙ†',0),(82952,2305,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ð¼Ð°ÑˆÐ¸Ð½ÑÐºÐ¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°ÑšÐµ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ð¸ & Ð¿Ð¾Ð¼Ð¾Ñ›Ð½Ð¸Ñ†Ð¸',0),(82953,2305,'vi','Pháº§n trÄƒm thá»i gian mÃ¡y yÃªu cáº§u váº­n hÃ nh & trá»£ giÃºp',0),(82954,2305,'af','Persent masjien tyd wat operateurs & assistente',0),(82955,2305,'ro','La sutÄƒ maÅŸinÄƒ operatorii care necesitÄƒ timp & asistenÅ£i',0),(82956,2305,'et','Protsenti masin aeg millega nÃµutakse ettevÃµtjatelt & assistendid',0),(82957,2305,'si','Odstotkov stroj Äas ki zahtevajo izvajalci & pomoÄniki',0),(82958,2305,'ba','Persen mesin waktu memerlukan operator &amp; asisten',0),(82959,2305,'nl','Procent machine tijd vereisen exploitanten & assistenten',0),(82960,2305,'fi','Prosenttia kone aika edellyttÃ¤Ã¤ toimijoiden & avustajat',0),(82961,2305,'no','Prosent maskin tid krever operatÃ¸rer & assistenter',0),(82962,2305,'da','Procent maskine tid krÃ¦ver operatÃ¸rer & assistenter',0),(82963,2305,'ko','% ì‹œê°„ í•„ìš”í•œ ì—°ì‚°ìž & ë³´ì¡° ê¸°ê³„',0),(82964,2305,'he','××—×•×– ×ž×›×•× ×ª ×ž×¤×¢×™×œ×™ ×“×¨×™×©×ª ×”×–×ž×Ÿ & ×¢×•×–×¨×™',0),(82965,2305,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Î¼Î·Ï‡Î±Î½Î® Ï‡ÏÏŒÎ½Î¿Ï… Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½ Ï†Î¿ÏÎµÎ¯Ï‚ & Î²Î¿Î·Î¸Î¿Î¯',0),(82966,2305,'zh','æœºå™¨æ—¶é—´ç™¾åˆ†æ¯”ï¼Œéœ€è¦æ“ä½œå‘˜åŠåŠ©ç†å‘˜',0),(82967,2305,'sv','Procent maskin tid som krÃ¤ver aktÃ¶rer & assistenter',0),(82968,2305,'it','Per cento della macchina che richiedono operatori tempo & assistenti',0),(82969,2305,'tl','',0),(82970,2305,'th','Percent machine time requiring operators & assistants',0),(82971,2305,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤®à¤¶à¥€à¤¨ à¤‘à¤ªà¤°à¥‡à¤Ÿà¤°à¥‹à¤‚ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤•à¥‡ à¤¸à¤®à¤¯ & à¤¸à¤¹à¤¾à¤¯à¤•à¥‹à¤‚',0),(82972,2305,'ms','Peratus Mesin masa memerlukan operator & Pembantu',0),(82973,2305,'ar','ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ø¢Ù„Ø© Ø§Ù„Ù…Ø´ØºÙ„ÙŠÙ† Ø§Ù„ØªÙŠ ØªØªØ·Ù„Ø¨ ÙˆÙ‚Øª Ø¢Ù†Ø¯ Ù…Ø³Ø§Ø¹Ø¯ÙŠÙ†',0),(82974,2305,'fr','Pour cent de la machine opÃ©rateurs nÃ©cessitant une fois & assistants',0),(82975,2305,'jp','ã‚ªãƒšãƒ¬ãƒ¼ã‚¿ãƒ¼ã?¨ã‚¢ã‚·ã‚¹ã‚¿ãƒ³ãƒˆã?Œå¿…è¦?ã?ªä½œæ¥­æ™‚é–“æ¯”çŽ‡',0),(82976,2305,'pt','Por cento da mÃ¡quina que requerem operadores tempo & assistentes',0),(82977,2305,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð² Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ñ‚Ñ€ÐµÐ±ÑƒÑŽÑ‰Ð¸Ñ… Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ñ‹ & Ð¿Ð¾Ð¼Ð¾Ñ‰Ð½Ð¸ÐºÐ¾Ð²',0),(82978,2305,'es','Porciento de Tiempo de mÃ¡quina que requieren operadores y asistentes',0),(82979,2305,'de','Prozent Maschine Zeit erfordern Operatoren & Assistenten',0),(82980,2305,'en','Percent machine time requiring operators & assistants',0),(82981,2306,'is','',0),(82982,2306,'dr','/ Ø²Ù…Ø§Ù† ÙƒØ§Ø± Ù…Ø§Ø´ÙŠÙ† ',0),(82983,2306,'pr','Ø¯Ø±ØµØ¯ Ø²Ù…Ø§Ù† ÙƒØ§Ø± ÙƒØ§Ø±Ù…Ù†Ø¯ / Ø²Ù…Ø§Ù† ÙƒØ§Ø± Ù…Ø§Ø´ÙŠÙ† ',0),(82984,2306,'tr','% Adam zaman / makine saati',0),(82985,2306,'pl','% Czasu czÅ‚owiek / maszyna czasu',0),(82986,2306,'bg','% ÐžÑ‚ Ð²Ñ€ÐµÐ¼ÐµÑ‚Ð¾ Ñ‡Ð¾Ð²ÐµÐº / Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð½Ð° Ð²Ñ€ÐµÐ¼ÐµÑ‚Ð¾',0),(82987,2306,'ur','ÙÛŒ ØµØ¯ Ù…Ø±Ø¯ ÙˆÙ‚Øª / ÙˆÙ‚Øª Ù…Ø´ÛŒÙ†',0),(82988,2306,'sr','% Ð’Ñ€ÐµÐ¼ÐµÐ½Ð° Ñ†Ð¾Ð²ÐµÐº / Ð¼Ð°ÑˆÐ¸Ð½ÑÐºÐ¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(82989,2306,'vi','& thá»i gian nhÃ¢n cÃ´ng / thá»i gian mÃ¡y ',0),(82990,2306,'af','% Man tyd / tyd masjien',0),(82991,2306,'ro','Timp de om % / maÅŸinÄƒ timp',0),(82992,2306,'et','% Mees aeg / masin korda',0),(82993,2306,'si','% ÄŒasa Älovek / stroj Äas',0),(82994,2306,'ba','% Pria waktu / mesin waktu',0),(82995,2306,'nl','% Man tijd / Time Machine',0),(82996,2306,'fi','% Mies aika koneen aika',0),(82997,2306,'no','% Mann tid / maskin tid',0),(82998,2306,'da','% Mand tid / maskine tid',0),(82999,2306,'ko','% ë‚¨ìž ì‹œê°„ / ì‹œê°„ ê¸°ê³„',0),(83000,2306,'he','×–×ž×Ÿ ××™×›×•×ª ×©×œ ×’×‘×¨×™× % / ×ž×›×•× ×ª ×–×ž×Ÿ',0),(83001,2306,'el','% Î§ÏÏŒÎ½Î¿Ï… Î¬Î½Î¸ÏÏ‰Ï€Î¿Ï‚ / Î¼Î·Ï‡Î±Î½Î® Ï„Î¿Ï… Ï‡ÏÏŒÎ½Î¿Ï…',0),(83002,2306,'zh','ï¼…äººçš„æ—¶é—´/æœºçš„æ—¶é—´\r\n',0),(83003,2306,'sv','% Man tid / maskin tid',0),(83004,2306,'it','% Tempo uomo / macchina tempo',0),(83005,2306,'tl','',0),(83006,2306,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3588;&#3609;&#3591;&#3634;&#3609;/&#3648;&#3623;&#3621;&#3634;&#3648;&#3588;&#3619;&#3639;&#',0),(83007,2306,'hi','% à¤†à¤¦à¤®à¥€ à¤¸à¤®à¤¯ à¤®à¤¶à¥€à¤¨ à¤¸à¤®à¤¯ /',0),(83008,2306,'ms','% Lelaki masa / Mesin masa',0),(83009,2306,'ar','% Ù„ÙˆÙ‚Øª Ø§Ù„Ø±Ø¬Ù„/Ø¢Ù„Ø© Ø§Ù„Ø²Ù…Ù†',0),(83010,2306,'fr','% Temps de l\'homme / Machine de temps',0),(83011,2306,'jp','ï¼…åŠ´åƒ?æ™‚é–“/æ©Ÿæ¢°ä½œæ¥­æ™‚é–“',0),(83012,2306,'pt','% Tempo de homem / mÃ¡quina do tempo',0),(83013,2306,'ru','% Ð’Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ñ‡ÐµÐ»Ð¾Ð²ÐµÐº / Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(83014,2306,'es','% Tiempo Hombre / Tiempo MÃ¡quina',0),(83015,2306,'de','% Mann Zeit / Time Machine',0),(83016,2306,'en','% Man Time / Machine Time',0),(83017,2307,'is','',0),(83018,2307,'dr','ØªÙ‡ÙŠÙ‡ Ø¯Ø±ØµØ¯ Ø¶Ø§ÙŠØ¹Ø§Øª',0),(83019,2307,'pr','ØªÙ‡ÙŠÙ‡ Ø¯Ø±ØµØ¯ Ø¶Ø§ÙŠØ¹Ø§Øª',0),(83020,2307,'tr','% Iskarta Kur',0),(83021,2307,'pl','% ZÅ‚om instalacji',0),(83022,2307,'bg','% Ð¡ÐºÑ€Ð°Ð¿ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(83023,2307,'ur','% Ø³Ú©Ø±ÛŒÙ¾ Ø³ÛŒÙ¹ Ø§Ù¾',0),(83024,2307,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ % ÑˆÐºÐ°Ñ€Ñ‚Ð°',0),(83025,2307,'vi','% setup pháº¿ liá»‡u',0),(83026,2307,'af','% Skrootyster Opstelling',0),(83027,2307,'ro','% Resturi Setup',0),(83028,2307,'et','% Praak seadistamine',0),(83029,2307,'si','% Izmeta Setup',0),(83030,2307,'ba','% Memo Setup',0),(83031,2307,'nl','% Uitval Setup',0),(83032,2307,'fi','% Romu asetukset',0),(83033,2307,'no','% Skrap oppsett',0),(83034,2307,'da','% Skrot Setup',0),(83035,2307,'ko','% ìŠ¤í¬ëž© ì„¤ì •',0),(83036,2307,'he','% ×’×¨×•×˜××•×ª ×”×”×ª×§× ×”',0),(83037,2307,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï†ÏÏÎ±Ï‚ %',0),(83038,2307,'zh','ï¼…åºŸæ–™è®¾ç½®\r\n',0),(83039,2307,'sv','% Skrot Setup',0),(83040,2307,'it','% Scarto Setup',0),(83041,2307,'tl','',0),(83042,2307,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3648;&#3619;&#3639;&#3656;&#3629;&#3591;&#3607;&#3637;&#3656;&#3626;&#3609;&#3651;&#3592;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;',0),(83043,2307,'hi','% à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(83044,2307,'ms','Persediaan sekerap %',0),(83045,2307,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø®Ø±Ø¯Ø© %',0),(83046,2307,'fr','Installation de ferraille %',0),(83047,2307,'jp','å»ƒæ£„è¨­å®šã?®æ¯”çŽ‡',0),(83048,2307,'pt','InstalaÃ§Ã£o de sucata %',0),(83049,2307,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° % Ð»Ð¾Ð¼Ð°',0),(83050,2307,'es','% ConfiguraciÃ³n de Desechos',0),(83051,2307,'de','% Schrott-Setup',0),(83052,2307,'en','% Scrap Setup',0),(83053,2308,'is','',0),(83054,2308,'dr','(Ù†Ø§Ù… Ù†ÙˆÙŠØ³ÙŠ',0),(83055,2308,'pr','Ø¯Ø±ØµØ¯ ØªØ§Ø®ÙŠØ± Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª (Ù†Ø§Ù… Ù†ÙˆÙŠØ³ÙŠ',0),(83056,2308,'tr','KayÄ±t iÃ§in yÃ¼zde yavaÅŸ aÅŸaÄŸÄ±',0),(83057,2308,'pl','Procent spowolnienie do rejestracji',0),(83058,2308,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð·Ð°Ð±Ð°Ð²ÑÐ½Ðµ Ð·Ð° Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(83059,2308,'ur','ÙÛŒ ØµØ¯ slow-down Ø±Ø¬Ø³Ù¹Ø±ÛŒØ´Ù† Ú©Û’ Ù„Ø¦Û’',0),(83060,2308,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ ÑƒÑÐ¿Ð¾Ñ€Ð°Ð²Ð°ÑšÐµÐ¼ Ð·Ð° Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(83061,2308,'vi','Pháº§n trÄƒm cháº­m láº¡i Ä‘á»ƒ Ä‘Äƒng kÃ½',0),(83062,2308,'af','Persentasie metabolisme vir registrasie',0),(83063,2308,'ro','ÃŽncetinire la sutÄƒ pentru Ã®nregistrare',0),(83064,2308,'et','Protsent aeglustumine registreerimine',0),(83065,2308,'si','Odstotek upoÄasnitev za registracijo',0),(83066,2308,'ba','Lambat-down persen untuk pendaftaran',0),(83067,2308,'nl','Percentage vertraging voor registratie',0),(83068,2308,'fi','Prosenttia hidastuminen rekisterÃ¶intiÃ¤',0),(83069,2308,'no','Prosent sakte ned for registrering',0),(83070,2308,'da','Procent nedgang for registrering',0),(83071,2308,'ko','ë“±ë¡ì— ëŒ€ í•œ ë°±ë¶„ìœ¨ ì†ë„ ì €í•˜',0),(83072,2308,'he','×”×”××˜×” ××—×•×– ×œ×¨×™×©×•×',0),(83073,2308,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎµÏ€Î¹Î²ÏÎ¬Î´Ï…Î½ÏƒÎ· Î³Î¹Î± ÎµÎ³Î³ÏÎ±Ï†Î®',0),(83074,2308,'zh','ç™¾åˆ†æ¯”æ”¾ç¼“ç™»è®°\r\n',0),(83075,2308,'sv','Procent nedgÃ¥ng fÃ¶r registrering',0),(83076,2308,'it','Rallentamento percentuale per la registrazione',0),(83077,2308,'tl','',0),(83078,2308,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3591;&#3607;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;&#3607;&#3637;&#3656;&#3594;&#3657;&#3634;&#3621;&#3591;',0),(83079,2308,'hi','à¤ªà¤‚à¤œà¥€à¤•à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¨à¥€à¤šà¥‡ à¤§à¥€à¤®à¤¾',0),(83080,2308,'ms','Peratus slow-down untuk pendaftaran',0),(83081,2308,'ar','ØªØ¨Ø§Ø·Ø¤ Ù†Ø³Ø¨Ø© Ù„Ù„ØªØ³Ø¬ÙŠÙ„',0),(83082,2308,'fr','Ralentissement pourcentage d\'enregistrement',0),(83083,2308,'jp','Percent slow-down for Registration',0),(83084,2308,'pt','DesaceleraÃ§Ã£o por cento para o registo',0),(83085,2308,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð·Ð°Ð¼ÐµÐ´Ð»ÐµÐ½Ð¸Ñ Ð´Ð»Ñ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸',0),(83086,2308,'es','Porciento DesacleraciÃ³n para RegistraciÃ³n',0),(83087,2308,'de','Prozent Verlangsamung fÃ¼r Registrierung',0),(83088,2308,'en','Percent slow-down for Registration',0),(83089,2309,'is','',0),(83090,2309,'dr','(Ù†Ø§Ù… Ù†ÙˆÙŠØ³ÙŠ ',0),(83091,2309,'pr','Ø¯Ø±ØµØ¯ ØªØ§Ø®ÙŠØ± Ø¬Ø¯ÙŠ  Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª (Ù†Ø§Ù… Ù†ÙˆÙŠØ³ÙŠ ',0),(83092,2309,'tr','YÃ¼zde yavaÅŸlama sÄ±kÄ± kayÄ±t',0),(83093,2309,'pl','Procent spowolnienie mocno rejestracji',0),(83094,2309,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð·Ð°Ð±Ð°Ð²ÑÐ½Ðµ Ð·Ð´Ñ€Ð°Ð²Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(83095,2309,'ur','ÙÛŒ ØµØ¯ Ø±ÙØªØ§Ø± ØªÙ†Ú¯ Ø±Ø¬Ø³Ù¹Ø±ÛŒØ´Ù†',0),(83096,2309,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ ÑƒÑÐ¿Ð¾Ñ€Ð°Ð²Ð°ÑšÐµ Ñ†Ð²Ñ€ÑÑ‚Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ð°',0),(83097,2309,'vi','Pháº§n trÄƒm Ä‘Äƒng kÃ½ cháº­m láº¡i ',0),(83098,2309,'af','Persentasie verlangsaming stywe registrasie',0),(83099,2309,'ro','ÃŽncetinire la sutÄƒ strans Ã®nregistrare',0),(83100,2309,'et','Protsent aeglustumine tihe registreerimine',0),(83101,2309,'si','Odstotek upoÄasnitev tesen registracije',0),(83102,2309,'ba','Perlambatan persen ketat pendaftaran',0),(83103,2309,'nl','Percentage vertraging strakke registratie',0),(83104,2309,'fi','Prosenttia hidastuminen tiukka rekisterÃ¶inti',0),(83105,2309,'no','Prosent nedgang stramme registrering',0),(83106,2309,'da','Procent nedgang stramme registrering',0),(83107,2309,'ko','% ë‘”í™” ê½‰ ë“±ë¡',0),(83108,2309,'he','×¨×™×©×•× ×—×–×§ ×”×”××˜×” ××—×•×–',0),(83109,2309,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎµÏ€Î¹Î²ÏÎ¬Î´Ï…Î½ÏƒÎ· ÏƒÏ†Î¹Ï‡Ï„ÏŒ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(83110,2309,'zh','æ”¾ç¼“ç´§å¯†ç™»è®°ç™¾åˆ†æ¯”\r\n',0),(83111,2309,'sv','Procent nedgÃ¥ng snÃ¤va registrering',0),(83112,2309,'it','Registrazione stretto rallentamento percentuale',0),(83113,2309,'tl','',0),(83114,2309,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3591;&#3607;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;&#3607;&#3637;&#3656;&#3594;&#3657;&#3634;&#3621;&#3591;&#3627;&#3634;&#3',0),(83115,2309,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤®à¤‚à¤¦à¥€ à¤¤à¤‚à¤— à¤ªà¤‚à¤œà¥€à¤•à¤°à¤£',0),(83116,2309,'ms','Peratus kelembapan ketat pendaftaran',0),(83117,2309,'ar','ØªØ¨Ø§Ø·Ø¤ Ù†Ø³Ø¨Ø© Ø§Ù„ØªØ³Ø¬ÙŠÙ„ Ø¶ÙŠÙ‚',0),(83118,2309,'fr','Pourcentage de ralentissement enregistrement serrÃ©',0),(83119,2309,'jp','Percent Slowdown Tight Registration',0),(83120,2309,'pt','Abrandamento por cento registo apertado',0),(83121,2309,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð·Ð°Ð¼ÐµÐ´Ð»ÐµÐ½Ð¸Ñ Ð¶ÐµÑÑ‚ÐºÐ¾Ð¹ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸',0),(83122,2309,'es','Porciento DesacleraciÃ³n para RegistraciÃ³n Restringida',0),(83123,2309,'de','Prozent AbschwÃ¤chung eng Registrierung',0),(83124,2309,'en','Percent Slowdown Tight Registration',0),(83125,2310,'is','',0),(83126,2310,'dr','Ø¯Ø±ØµØ¯ Ù¾ÙˆØ´Ø´',0),(83127,2310,'pr','Ø¯Ø±ØµØ¯ Ù¾ÙˆØ´Ø´',0),(83128,2310,'tr','YÃ¼zde kapsama',0),(83129,2310,'pl','Procentu pokrycia',0),(83130,2310,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ',0),(83131,2310,'ur','Ø´Ø±Ø­ ÙÛŒ ØµØ¯ Ú©ÙˆØ±ÛŒØ¬',0),(83132,2310,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð¿Ð¾ÐºÑ€Ð¸Ð²ÐµÐ½Ð¾ÑÑ‚Ð¸',0),(83133,2310,'vi','Pháº§n trÄƒm bao trÃ¹m',0),(83134,2310,'af','Persentasie Dekking',0),(83135,2310,'ro','Procentul de acoperire',0),(83136,2310,'et','HÃµlmatuse tase',0),(83137,2310,'si','Stopnja pokritja',0),(83138,2310,'ba','Persentase cakupan',0),(83139,2310,'nl','Percentage dekking',0),(83140,2310,'fi','Kattavuus',0),(83141,2310,'no','Prosent dekning',0),(83142,2310,'da','Procent dÃ¦kning',0),(83143,2310,'ko','ë°±ë¶„ìœ¨ ë²”ìœ„',0),(83144,2310,'he','××—×•×– ×›×™×¡×•×™',0),(83145,2310,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎºÎ¬Î»Ï…ÏˆÎ·Ï‚',0),(83146,2310,'zh','è¦†ç›–çŽ‡\r\n',0),(83147,2310,'sv','Procentuella tÃ¤ckningen',0),(83148,2310,'it','Percentuale di copertura',0),(83149,2310,'tl','',0),(83150,2310,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3648;&#3586;&#3605;&#3588;&#3640;&#3657;&#3617;&#3588;&#3619;&#3629;&#3591;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3616;&#3633;&#3618;',0),(83151,2310,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¤µà¤°à¥‡à¤œ',0),(83152,2310,'ms','Peratusan perlindungan',0),(83153,2310,'ar','Ù†Ø³Ø¨Ø© ØªØºØ·ÙŠØ©',0),(83154,2310,'fr','Pourcentage de couverture',0),(83155,2310,'jp','æ¯”çŽ‡ç¯„å›²',0),(83156,2310,'pt','Porcentagem de cobertura',0),(83157,2310,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¾Ñ…Ð²Ð°Ñ‚Ð°',0),(83158,2310,'es','Porcentaje de Cobertura',0),(83159,2310,'de','Prozentuale Abdeckung',0),(83160,2310,'en','Percentage Coverage',0),(83161,2311,'is','',0),(83162,2311,'dr','Ø¯Ø±ØµØ¯ Ø­Ù‚ÙˆÙ‚',0),(83163,2311,'pr','Ø¯Ø±ØµØ¯ Ø­Ù‚ÙˆÙ‚',0),(83164,2311,'tr','Ã–deme yÃ¼zdesi',0),(83165,2311,'pl','Procent wynagrodzenia',0),(83166,2311,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð½Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(83167,2311,'ur','ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ Ø´Ø±Ø­ ÙÛŒ ØµØ¯',0),(83168,2311,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð¾Ð´ Ð¿Ð»Ð°Ñ‚Ðµ',0),(83169,2311,'vi','Pháº§n trÄƒm lÆ°Æ¡ng',0),(83170,2311,'af','Persentasie van Besoldiging',0),(83171,2311,'ro','Procent de plata',0),(83172,2311,'et','Palga osa',0),(83173,2311,'si','Odstotek plaÄila',0),(83174,2311,'ba','Persentase gaji',0),(83175,2311,'nl','Percentage van loon',0),(83176,2311,'fi','Prosenttiosuus maksu',0),(83177,2311,'no','Prosent av lÃ¸nn',0),(83178,2311,'da','Procentdel af lÃ¸n',0),(83179,2311,'ko','ì§€ë¶ˆì˜ ë¹„ìœ¨',0),(83180,2311,'he','××—×•×– ×”×ª×©×œ×•×',0),(83181,2311,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï„Î·Ï‚ Î±Î¼Î¿Î¹Î²Î®Ï‚',0),(83182,2311,'zh','è–ªé…¬çš„ç™¾åˆ†æ¯”\r\n',0),(83183,2311,'sv','Procentandel av lÃ¶n',0),(83184,2311,'it','Percentuale della retribuzione',0),(83185,2311,'tl','',0),(83186,2311,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3632;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(83187,2311,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(83188,2311,'ms','Peratusan daripada gaji',0),(83189,2311,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù„Ù„Ø£Ø¬ÙˆØ±',0),(83190,2311,'fr','Pourcentage de la rÃ©munÃ©ration',0),(83191,2311,'jp','æ”¯æ‰•æ¯”çŽ‡',0),(83192,2311,'pt','Porcentagem de pagamento',0),(83193,2311,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(83194,2311,'es','Porcentaje de Pago',0),(83195,2311,'de','Prozentsatz des Entgelts',0),(83196,2311,'en','Percentage of Pay',0),(83197,2312,'is','',0),(83198,2312,'dr','Ø¯Ø±ØµØ¯ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(83199,2312,'pr','Ø¯Ø±ØµØ¯ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(83200,2312,'tr','Ãœcret yÃ¼zdesi',0),(83201,2312,'pl','Procent wynagrodzenia',0),(83202,2312,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð½Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ',0),(83203,2312,'ur','ØªÙ†Ø®ÙˆØ§ÛÙˆÚº Ú©Ø§ ØªÙ†Ø§Ø³Ø¨',0),(83204,2312,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð¾Ð´ Ð¿Ð»Ð°Ñ‚Ðµ',0),(83205,2312,'vi','Pháº§n trÄƒm thu nháº­p',0),(83206,2312,'af','Persentasie van Besoldiging',0),(83207,2312,'ro','Procent de plata',0),(83208,2312,'et','Palga osa',0),(83209,2312,'si','Odstotek plaÄe',0),(83210,2312,'ba','Persentase dari upah',0),(83211,2312,'nl','Percentage van de lonen',0),(83212,2312,'fi','Palkkojen osuus',0),(83213,2312,'no','Prosent av lÃ¸nn',0),(83214,2312,'da','Procentdel af lÃ¸nninger',0),(83215,2312,'ko','ìž„ê¸ˆì˜ ë°±ë¶„ìœ¨',0),(83216,2312,'he','××—×•×–×™ ×”×©×›×¨',0),(83217,2312,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï„Ï‰Î½ Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(83218,2312,'zh','å·¥èµ„çš„ç™¾åˆ†æ¯”\r\n',0),(83219,2312,'sv','Procentandel av lÃ¶ner',0),(83220,2312,'it','Percentuale dei salari',0),(83221,2312,'tl','',0),(83222,2312,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3586;&#3629;&#3591;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;',0),(83223,2312,'hi','à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤•à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(83224,2312,'ms','Peratusan daripada gaji',0),(83225,2312,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù„Ù„Ø£Ø¬ÙˆØ±',0),(83226,2312,'fr','Pourcentage du salaire',0),(83227,2312,'jp','è³ƒé‡‘æ¯”çŽ‡',0),(83228,2312,'pt','Percentagem do salÃ¡rio',0),(83229,2312,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¾Ñ‚ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(83230,2312,'es','Porcentaje de Sueldos ',0),(83231,2312,'de','Prozentsatz der LÃ¶hne',0),(83232,2312,'en','Percentage of Wages',0),(83233,2313,'is','',0),(83234,2313,'dr','(Ø±Ø³ÙˆØ® ÙƒÙ†Ù†Ø¯Ù‡',0),(83235,2313,'pr','Ø³ÙˆØ±Ø§Ø® Ú©Ù†(Ø±Ø³ÙˆØ® ÙƒÙ†Ù†Ø¯Ù‡',0),(83236,2313,'tr','Perforator',0),(83237,2313,'pl','Programu Perforator',0),(83238,2313,'bg','ÐŸÐµÑ€Ñ„Ð¾Ñ€Ð°Ñ‚Ð¾Ñ€Ð¸',0),(83239,2313,'ur','Ø³ÙˆØ¬Ø§',0),(83240,2313,'sr','ÐŸÐµÑ€Ñ„Ð¾Ñ€Ð°Ñ‚Ð¾Ñ€',0),(83241,2313,'vi','MÃ¡y khoan',0),(83242,2313,'af','Perforator',0),(83243,2313,'ro','Perforator',0),(83244,2313,'et','Perforator',0),(83245,2313,'si','Perforator',0),(83246,2313,'ba','Penggunaan',0),(83247,2313,'nl','Perforator',0),(83248,2313,'fi','Rei\'itin',0),(83249,2313,'no','Perforator',0),(83250,2313,'da','Perforator',0),(83251,2313,'ko','Perforator',0),(83252,2313,'he','×ž× ×§×‘',0),(83253,2313,'el','Î¤ÏÏÏ€Î±Î½Î¿',0),(83254,2313,'zh','å°„å­”æœº\r\n',0),(83255,2313,'sv','Perforator',0),(83256,2313,'it','Perforatore',0),(83257,2313,'tl','',0),(83258,2313,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3585;&#3619;&#3640;',0),(83259,2313,'hi','Perforator',0),(83260,2313,'ms','Perforator',0),(83261,2313,'ar','Ù…Ø®Ø±Ø²',0),(83262,2313,'fr','Perforator',0),(83263,2313,'jp','ç›®æ‰“ã?¡å™¨',0),(83264,2313,'pt','Perforator',0),(83265,2313,'ru','ÐŸÐµÑ€Ñ„Ð¾Ñ€Ð°Ñ‚Ð¾Ñ€',0),(83266,2313,'es','Perforador',0),(83267,2313,'de','Perforator',0),(83268,2313,'en','Perforator',0),(83269,2314,'is','',0),(83270,2314,'dr','Ù„ÙŠØ³Øª  Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ Ø¨Ø±Ø§ÙŠ',0),(83271,2314,'pr','Ù„ÙŠØ³Øª  Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ Ø¨Ø±Ø§ÙŠ',0),(83272,2314,'tr','PERFORMANS istatistikleri listesi iÃ§in',0),(83273,2314,'pl','Lista statystyki wydajnoÅ›ci dla',0),(83274,2314,'bg','Ð’ ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°',0),(83275,2314,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’',0),(83276,2314,'sr','ÐŸÐ•Ð Ð¤ÐžÐ ÐœÐÐÐ¡Ð• ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð»Ð¸ÑÑ‚Ðµ Ð·Ð°',0),(83277,2314,'vi','DANH SÃCH THá»NG KÃŠ THá»°C THI CÃ”NG VIá»†C cho',0),(83278,2314,'af','PRESTASIE STATISTIEKE LYS vir',0),(83279,2314,'ro','LISTÄ‚ de statistici de performanÅ£Äƒ pentru',0),(83280,2314,'et','TULEMUSLIKKUSE statistika loend',0),(83281,2314,'si','SEZNAM s statistiko uspeÅ¡nosti za',0),(83282,2314,'ba','Daftar statistik kinerja untuk',0),(83283,2314,'nl','PERFORMANCE statistieken lijst voor',0),(83284,2314,'fi','SUORITUSKYVYN tilastot luettelo',0),(83285,2314,'no','YTELSEN statistikk liste for',0),(83286,2314,'da','YDEEVNE statistikker liste for',0),(83287,2314,'ko','ì— ëŒ€ í•œ ì„±ëŠ¥ í†µê³„ ëª©ë¡',0),(83288,2314,'he','×¨×©×™×ž×ª ×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™× ×¢×‘×•×¨',0),(83289,2314,'el','ÎšÎ‘Î¤Î†Î›ÎŸÎ“ÎŸÎ£ ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î‘Î ÎŒÎ”ÎŸÎ£Î—Î£ Î³Î¹Î±',0),(83290,2314,'zh','æ€§èƒ½ç»Ÿè®¡ç›®å½•\r\n',0),(83291,2314,'sv','PRESTANDA statistik lista fÃ¶r',0),(83292,2314,'it','ELENCO di statistiche di prestazioni per',0),(83293,2314,'tl','',0),(83294,2314,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(83295,2314,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤à¤•à¤¡à¤¼à¥‡ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(83296,2314,'ms','Senarai statistik prestasi untuk',0),(83297,2314,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡',0),(83298,2314,'fr','Liste des statistiques de PERFORMANCE pour',0),(83299,2314,'jp','ï½žã?®æ¥­ç¸¾çŠ¶æ³?ãƒªã‚¹ãƒˆ',0),(83300,2314,'pt','LISTA de estatÃ­sticas de desempenho para',0),(83301,2314,'ru','Ð¡Ð¢ÐÐ¢Ð˜Ð¡Ð¢Ð˜ÐšÐ ÐŸÐ ÐžÐ˜Ð—Ð’ÐžÐ”Ð˜Ð¢Ð•Ð›Ð¬ÐÐžÐ¡Ð¢Ð˜ Ð·Ð°',0),(83302,2314,'es','LISTA DE ESTADÃSTAS DE DESEMPEÃ‘O para',0),(83303,2314,'de','Liste der PERFORMANCE-Statistiken fÃ¼r',0),(83304,2314,'en','PERFORMANCE STATISTICS LIST for',0),(83305,2315,'is','',0),(83306,2315,'dr','Ø¯ÙˆØ±Ù‡ ',0),(83307,2315,'pr','Ø¯ÙˆØ±Ù‡ ',0),(83308,2315,'tr','DÃ¶nem',0),(83309,2315,'pl','Okres',0),(83310,2315,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(83311,2315,'ur','Ø¹Ø±ØµÛ',0),(83312,2315,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(83313,2315,'vi','Thá»i ká»³',0),(83314,2315,'af','Periode',0),(83315,2315,'ro','Perioada',0),(83316,2315,'et','Perioodi',0),(83317,2315,'si','Obdobje',0),(83318,2315,'ba','Periode',0),(83319,2315,'nl','Periode',0),(83320,2315,'fi','Ajan',0),(83321,2315,'no','Periode',0),(83322,2315,'da','Periode',0),(83323,2315,'ko','ê¸°ê°„',0),(83324,2315,'he','×ª×§×•×¤×”',0),(83325,2315,'el','Î ÎµÏÎ¯Î¿Î´Î¿',0),(83326,2315,'zh','æœŸ\r\n',0),(83327,2315,'sv','Period',0),(83328,2315,'it','Periodo',0),(83329,2315,'tl','',0),(83330,2315,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(83331,2315,'hi','à¤…à¤µà¤§à¤¿',0),(83332,2315,'ms','Tempoh',0),(83333,2315,'ar','Ø§Ù„ÙØªØ±Ø©',0),(83334,2315,'fr','PÃ©riode',0),(83335,2315,'jp','æœŸé–“',0),(83336,2315,'pt','PerÃ­odo',0),(83337,2315,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(83338,2315,'es','PerÃ­odo',0),(83339,2315,'de','Zeitraum',0),(83340,2315,'en','Period',0),(83341,2316,'is','',0),(83342,2316,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ ',0),(83343,2316,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ ',0),(83344,2316,'tr','DÃ¶nem baÅŸlangÄ±Ã§ tarihi',0),(83345,2316,'pl','Data rozpoczÄ™cia okresu',0),(83346,2316,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(83347,2316,'ur','Ø¯ÙˆØ± Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(83348,2316,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(83349,2316,'vi','NgÃ y báº¯t Ä‘áº§u Thá»i ká»³',0),(83350,2316,'af','Periode Begin Datum',0),(83351,2316,'ro','ÃŽncepe perioada data',0),(83352,2316,'et','Perioodi alguskuupÃ¤ev',0),(83353,2316,'si','Obdobje zaÄetni datum',0),(83354,2316,'ba','Periode mulai tanggal',0),(83355,2316,'nl','Periode begindatum',0),(83356,2316,'fi','Kauden aloituspÃ¤ivÃ¤',0),(83357,2316,'no','Perioden begynner dato',0),(83358,2316,'da','Perioden begynder dato',0),(83359,2316,'ko','ê¸°ê°„ ì‹œìž‘ ë‚ ì§œ',0),(83360,2316,'he','×‘×’×™×Ÿ ×”×ª×§×•×¤×” ×ª××¨×™×š',0),(83361,2316,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(83362,2316,'zh','æœŸé—´å¼€å§‹æ—¥æœŸ\r\n',0),(83363,2316,'sv','Perioden bÃ¶rjar datum',0),(83364,2316,'it','Data inizio periodo',0),(83365,2316,'tl','',0),(83366,2316,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(83367,2316,'hi','à¤…à¤µà¤§à¤¿ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(83368,2316,'ms','Mulakan tempoh tarikh',0),(83369,2316,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©',0),(83370,2316,'fr','Date de dÃ©but de pÃ©riode',0),(83371,2316,'jp','æœŸé–“é–‹å§‹æ—¥',0),(83372,2316,'pt','Data de inÃ­cio do perÃ­odo',0),(83373,2316,'ru','ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ð°Ñ Ð”Ð°Ñ‚Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´Ð°',0),(83374,2316,'es','Fecha de Comienza del PerÃ­odo',0),(83375,2316,'de','Zeitraum Anfangsdatum',0),(83376,2316,'en','Period Begin Date',0),(83377,2317,'is','',0),(83378,2317,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ ',0),(83379,2317,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ ',0),(83380,2317,'tr','DÃ¶nem bitiÅŸ tarihi',0),(83381,2317,'pl','Data koÅ„cowa okresu',0),(83382,2317,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐºÑ€Ð°Ð¹ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(83383,2317,'ur','Ø¹Ø±ØµÛ Ø§Ø®ØªØªØ§Ù… ØªØ§Ø±ÛŒØ®',0),(83384,2317,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(83385,2317,'vi','NgÃ y cuá»‘i Thá»i ká»³',0),(83386,2317,'af','Periode End Datum',0),(83387,2317,'ro','SfÃ¢rÅŸit perioadÄƒ datÄƒ',0),(83388,2317,'et','Perioodi lÃµppkuupÃ¤ev',0),(83389,2317,'si','KonÄni datum obdobja',0),(83390,2317,'ba','Tanggal akhir periode',0),(83391,2317,'nl','Datum van het einde van de periode',0),(83392,2317,'fi','Kauden pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(83393,2317,'no','Periodens sluttdato',0),(83394,2317,'da','Slutdato',0),(83395,2317,'ko','ê¸°ê°„ ì¢…ë£Œ ë‚ ì§œ',0),(83396,2317,'he','×ª××¨×™×š ×¡×™×•× ×©×œ ×ª×§×•×¤×ª',0),(83397,2317,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(83398,2317,'zh','æœŸé—´ç»“æŸæ—¥æœŸ\r\n',0),(83399,2317,'sv','Slutdatum',0),(83400,2317,'it','Data di fine periodo',0),(83401,2317,'tl','',0),(83402,2317,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(83403,2317,'hi','à¤…à¤µà¤§à¤¿ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(83404,2317,'ms','Tarikh tamat tempoh',0),(83405,2317,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©',0),(83406,2317,'fr','Date de fin de pÃ©riode',0),(83407,2317,'jp','æœŸé–“çµ‚äº†æ—¥',0),(83408,2317,'pt','Data de fim do perÃ­odo',0),(83409,2317,'ru','ÐšÐ¾Ð½ÐµÑ† ÐŸÐµÑ€Ð¸Ð¾Ð´Ð°',0),(83410,2317,'es','Fecha de TÃ©rminaciÃ³n del PerÃ­odo',0),(83411,2317,'de','Abschnittenddatum',0),(83412,2317,'en','Period End Date',0),(83413,2318,'is','',0),(83414,2318,'dr','Ø¯ÙˆØ±Ù‡ ',0),(83415,2318,'pr','Ø¯ÙˆØ±Ù‡ ',0),(83416,2318,'tr','DÃ¶nem',0),(83417,2318,'pl','Okres',0),(83418,2318,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(83419,2318,'ur','Ø¹Ø±ØµÛ',0),(83420,2318,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(83421,2318,'vi','Thá»i ká»³',0),(83422,2318,'af','Maand Periode',0),(83423,2318,'ro','Perioada',0),(83424,2318,'et','Periood',0),(83425,2318,'si','Obdobje',0),(83426,2318,'ba','Periode',0),(83427,2318,'nl','Periode',0),(83428,2318,'fi','Ajan',0),(83429,2318,'no','Periode',0),(83430,2318,'da','Periode',0),(83431,2318,'ko','ê¸°ê°„',0),(83432,2318,'he','×ª×§×•×¤×ª',0),(83433,2318,'el','Î ÎµÏÎ¯Î¿Î´Î¿',0),(83434,2318,'zh','æœŸ\r\n',0),(83435,2318,'sv','Period',0),(83436,2318,'it','Periodo',0),(83437,2318,'tl','',0),(83438,2318,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(83439,2318,'hi','à¤…à¤µà¤§à¤¿',0),(83440,2318,'ms','Tempoh',0),(83441,2318,'ar','Ø§Ù„ÙØªØ±Ø©',0),(83442,2318,'fr','PÃ©riode',0),(83443,2318,'jp','æœŸé–“',0),(83444,2318,'pt','PerÃ­odo',0),(83445,2318,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(83446,2318,'es','PerÃ­odo',0),(83447,2318,'de','Zeitraum',0),(83448,2318,'en','Period',0),(83449,2319,'is','',0),(83450,2319,'dr','Ø¯ÙˆØ±Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(83451,2319,'pr','Ø¯ÙˆØ±Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(83452,2319,'tr','DÃ¶nem bulunamadÄ±.',0),(83453,2319,'pl','Okres nie znaleziono.',0),(83454,2319,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(83455,2319,'ur','Ø¯ÙˆØ± Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ Û”',0),(83456,2319,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ñƒ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(83457,2319,'vi','KhÃ´ng tÃ¬m tháº¥y Thá»i ká»³',0),(83458,2319,'af','Periode nie gevind.',0),(83459,2319,'ro','Perioada nu a fost gÄƒsit.',0),(83460,2319,'et','Perioodi ei leitud.',0),(83461,2319,'si','Obdobju ni mogoÄe najti.',0),(83462,2319,'ba','Periode tidak ditemukan.',0),(83463,2319,'nl','Periode niet gevonden.',0),(83464,2319,'fi','Aikana ei lÃ¶ytynyt.',0),(83465,2319,'no','Perioden ikke funnet.',0),(83466,2319,'da','Periode blev ikke fundet.',0),(83467,2319,'ko','ê¸°ê°„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(83468,2319,'he','×ª×§×•×¤×” ×œ× × ×ž×¦×.',0),(83469,2319,'el','Î ÎµÏÎ¯Î¿Î´Î¿ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(83470,2319,'zh','æ²¡æœ‰æ‰¾åˆ°æœŸé—´ã€‚\r\n',0),(83471,2319,'sv','Perioden hittades inte.',0),(83472,2319,'it','Periodo non trovato.',0),(83473,2319,'tl','',0),(83474,2319,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(83475,2319,'hi','à¤…à¤µà¤§à¤¿ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(83476,2319,'ms','Tempoh tidak dijumpai.',0),(83477,2319,'ar','Ø§Ù„ÙØªØ±Ø© Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(83478,2319,'fr','PÃ©riode introuvable.',0),(83479,2319,'jp','æœŸé–“ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(83480,2319,'pt','PerÃ­odo nÃ£o foi encontrado.',0),(83481,2319,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(83482,2319,'es','No se encontrÃ³ el perÃ­odo',0),(83483,2319,'de','Zeitraum nicht gefunden.',0),(83484,2319,'en','Period not found.',0),(83485,2320,'is','',0),(83486,2320,'dr','Ø³Ø§Ù„ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(83487,2320,'pr','Ø³Ø§Ù„ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(83488,2320,'tr','YTD',0),(83489,2320,'pl','OD POCZÄ„TKU ROKU',0),(83490,2320,'bg','ÐžÐ¢ ÐÐÐ§ÐÐ›ÐžÐ¢Ðž ÐÐ Ð“ÐžÐ”Ð˜ÐÐÐ¢Ð',0),(83491,2320,'ur','ÛŒÙ¹Ø¯',0),(83492,2320,'sr','Ð“ÐžÐ”Ð˜ÐÐ Ð”Ðž Ð”ÐÐ¢Ð£ÐœÐ',0),(83493,2320,'vi','Tá»•ng tá»« Ä‘áº§u nÄƒm Ä‘áº¿n nay',0),(83494,2320,'af','JTD',0),(83495,2320,'ro','YTD',0),(83496,2320,'et','YTD',0),(83497,2320,'si','YTD',0),(83498,2320,'ba','YTD',0),(83499,2320,'nl','YTD',0),(83500,2320,'fi','VUODEN ALUSTA',0),(83501,2320,'no','HITTIL I Ã…R',0),(83502,2320,'da','Ã…TD',0),(83503,2320,'ko','YTD',0),(83504,2320,'he','×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(83505,2320,'el','YTD',0),(83506,2320,'zh','å¹´åˆè‡³ä»Š\r\n',0),(83507,2320,'sv','YTD',0),(83508,2320,'it','YTD',0),(83509,2320,'tl','',0),(83510,2320,'th','YTD',0),(83511,2320,'hi','YTD',0),(83512,2320,'ms','THK',0),(83513,2320,'ar','Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(83514,2320,'fr','DEPUIS UN AN',0),(83515,2320,'jp','å¹´/æœˆ/æ—¥',0),(83516,2320,'pt','ACUMULADO NO ANO',0),(83517,2320,'ru','Ð¡ ÐÐÐ§ÐÐ›Ð Ð“ÐžÐ”Ð',0),(83518,2320,'es','AAF',0),(83519,2320,'de','YTD',0),(83520,2320,'en','YTD',0),(83521,2321,'is','',0),(83522,2321,'dr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ ',0),(83523,2321,'pr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ ',0),(83524,2321,'tr','DÃ¶nemleri',0),(83525,2321,'pl','Okresy',0),(83526,2321,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸',0),(83527,2321,'ur','Ù…Ø®ØªÙ„Ù Ø§Ø¯ÙˆØ§Ø±',0),(83528,2321,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ðµ',0),(83529,2321,'vi','Thá»i ká»³',0),(83530,2321,'af','Periodes',0),(83531,2321,'ro','Perioadele',0),(83532,2321,'et','Perioodide',0),(83533,2321,'si','Obdobja',0),(83534,2321,'ba','Periode',0),(83535,2321,'nl','Perioden',0),(83536,2321,'fi','Kaudet',0),(83537,2321,'no','Perioder',0),(83538,2321,'da','Perioder',0),(83539,2321,'ko','ê¸°ê°„',0),(83540,2321,'he','×ª×§×•×¤×•×ª',0),(83541,2321,'el','Î ÎµÏÎ¹ÏŒÎ´Î¿Ï…Ï‚',0),(83542,2321,'zh','æœŸ\r\n',0),(83543,2321,'sv','Perioder',0),(83544,2321,'it','Periodi',0),(83545,2321,'tl','',0),(83546,2321,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(83547,2321,'hi','à¤…à¤µà¤§à¤¿',0),(83548,2321,'ms','Tempoh',0),(83549,2321,'ar','Ø§Ù„ÙØªØ±Ø§Øª',0),(83550,2321,'fr','PÃ©riodes',0),(83551,2321,'jp','æœŸé–“',0),(83552,2321,'pt','PerÃ­odos',0),(83553,2321,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´Ñ‹',0),(83554,2321,'es','PerÃ­odos',0),(83555,2321,'de','Perioden',0),(83556,2321,'en','Periods',0),(83557,2322,'is','',0),(83558,2322,'dr','Ø§ÙŠØ±Ø§Ù†ÙŠ ',0),(83559,2322,'pr','Ø§ÙŠØ±Ø§Ù†ÙŠ ',0),(83560,2322,'tr','FarsÃ§a',0),(83561,2322,'pl','Perski',0),(83562,2322,'bg','ÐŸÐµÑ€ÑÐ¸Ð¹ÑÐºÐ¸',0),(83563,2322,'ur','ÙØ§Ø±Ø³ÛŒ',0),(83564,2322,'sr','Ð¿ÐµÑ€ÑÐ¸Ñ˜ÑÐºÐ¸',0),(83565,2322,'vi','Ba tÆ°',0),(83566,2322,'af','Persiese',0),(83567,2322,'ro','PersanÄƒ',0),(83568,2322,'et','PÃ¤rsia',0),(83569,2322,'si','perzijÅ¡Äina',0),(83570,2322,'ba','Farsi',0),(83571,2322,'nl','Perzisch',0),(83572,2322,'fi','persia',0),(83573,2322,'no','Persisk',0),(83574,2322,'da','Persisk',0),(83575,2322,'ko','íŽ˜ë¥´ì‹œì•„ì–´',0),(83576,2322,'he','×¤×¨×¡×™×ª',0),(83577,2322,'el','Î ÎµÏÏƒÎ¹ÎºÎ¬',0),(83578,2322,'zh','æ³¢æ–¯è¯­\r\n',0),(83579,2322,'sv','Persiska',0),(83580,2322,'it','Farsi',0),(83581,2322,'tl','',0),(83582,2322,'th','&#3594;&#3634;&#3623;&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3637;&#3618;',0),(83583,2322,'hi','à¥žà¤¾à¤°à¤¸à¥€',0),(83584,2322,'ms','Parsi',0),(83585,2322,'ar','Ø§Ù„ÙØ§Ø±Ø³ÙŠØ©',0),(83586,2322,'fr','Perse',0),(83587,2322,'jp','ãƒšãƒ«ã‚·ã‚¢èªž',0),(83588,2322,'pt','Persa',0),(83589,2322,'ru','Ð¿ÐµÑ€ÑÐ¸Ð´ÑÐºÐ¸Ð¹',0),(83590,2322,'es','Persiano',0),(83591,2322,'de','Persisch',0),(83592,2322,'en','Persian',0),(83593,2323,'is','',0),(83594,2323,'dr','Ø´Ø®Øµ ',0),(83595,2323,'pr','Ø´Ø®Øµ ',0),(83596,2323,'tr','KiÅŸi',0),(83597,2323,'pl','Osoba',0),(83598,2323,'bg','Ð›Ð¸Ñ†Ðµ',0),(83599,2323,'ur','Ø´Ø®Øµ',0),(83600,2323,'sr','ÐžÑÐ¾Ð±Ð°',0),(83601,2323,'vi','NgÆ°á»i',0),(83602,2323,'af','Persoon',0),(83603,2323,'ro','PersoanÄƒ',0),(83604,2323,'et','Isik',0),(83605,2323,'si','Oseba',0),(83606,2323,'ba','Orang',0),(83607,2323,'nl','Persoon',0),(83608,2323,'fi','HenkilÃ¶',0),(83609,2323,'no','Person',0),(83610,2323,'da','Person',0),(83611,2323,'ko','ì‚¬ëžŒ',0),(83612,2323,'he','××“×',0),(83613,2323,'el','Î ÏÏŒÏƒÏ‰Ï€Î¿',0),(83614,2323,'zh','äºº\r\n',0),(83615,2323,'sv','Person',0),(83616,2323,'it','Persona',0),(83617,2323,'tl','',0),(83618,2323,'th','&#3610;&#3640;&#3588;&#3588;&#3621;',0),(83619,2323,'hi','à¤µà¥à¤¯à¤•à¥à¤¤à¤¿',0),(83620,2323,'ms','Orang',0),(83621,2323,'ar','Ø§Ù„Ø´Ø®Øµ',0),(83622,2323,'fr','Personne',0),(83623,2323,'jp','äºº',0),(83624,2323,'pt','Pessoa',0),(83625,2323,'ru','Ð§ÐµÐ»Ð¾Ð²ÐµÐº',0),(83626,2323,'es','Persona',0),(83627,2323,'de','Person',0),(83628,2323,'en','Person',0),(83629,2324,'is','',0),(83630,2324,'dr','ØªÙ„ÙÙ†',0),(83631,2324,'pr','ØªÙ„ÙÙ†',0),(83632,2324,'tr','Telefon',0),(83633,2324,'pl','Telefon',0),(83634,2324,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(83635,2324,'ur','ÙÙˆÙ†',0),(83636,2324,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(83637,2324,'vi','Phone',0),(83638,2324,'af','Telefoon',0),(83639,2324,'ro','Telefon',0),(83640,2324,'et','Telefon',0),(83641,2324,'si','Telefon',0),(83642,2324,'ba','Telepon',0),(83643,2324,'nl','Telefoon',0),(83644,2324,'fi','Puhelin',0),(83645,2324,'no','Telefon',0),(83646,2324,'da','Telefon',0),(83647,2324,'ko','ì „í™”',0),(83648,2324,'he','×˜×œ×¤×•×Ÿ',0),(83649,2324,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿',0),(83650,2324,'zh','ç”µè¯\r\n',0),(83651,2324,'sv','Telefon',0),(83652,2324,'it','Telefono',0),(83653,2324,'tl','',0),(83654,2324,'th','&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(83655,2324,'hi','à¤«à¥‹à¤¨',0),(83656,2324,'ms','Telefon',0),(83657,2324,'ar','Ø§Ù„Ù‡Ø§ØªÙ',0),(83658,2324,'fr','TÃ©lÃ©phone',0),(83659,2324,'jp','é›»è©±',0),(83660,2324,'pt','Telefone',0),(83661,2324,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€',0),(83662,2324,'es','TelÃ©fono',0),(83663,2324,'de','Telefon',0),(83664,2324,'en','Phone',0),(83665,2325,'is','',0),(83666,2325,'dr','Ù†Ø¸Ø± ØªÙ„ÙÙ†ÙŠ ',0),(83667,2325,'pr','Ù†Ø¸Ø± ØªÙ„ÙÙ†ÙŠ ',0),(83668,2325,'tr','Telefonu nasÄ±l',0),(83669,2325,'pl','Telefon komentarz',0),(83670,2325,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(83671,2325,'ur','ÙÙˆÙ† ØªØ¨ØµØ±Û',0),(83672,2325,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(83673,2325,'vi','Nháº­n xÃ©t Phone',0),(83674,2325,'af','Telefoon Opmerking',0),(83675,2325,'ro','Comentariu de telefon',0),(83676,2325,'et','Telefoni kommentaar',0),(83677,2325,'si','Telefon komentar',0),(83678,2325,'ba','Telepon komentar',0),(83679,2325,'nl','Telefoon commentaar',0),(83680,2325,'fi','Puhelimen kommentti',0),(83681,2325,'no','Telefon kommentar',0),(83682,2325,'da','Telefon kommentar',0),(83683,2325,'ko','ì „í™” ëŒ“ê¸€',0),(83684,2325,'he','×ª×’×•×‘×” ×˜×œ×¤×•×Ÿ',0),(83685,2325,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(83686,2325,'zh','ç”µè¯è¯„è®º\r\n',0),(83687,2325,'sv','Telefon kommentar',0),(83688,2325,'it','Commento di telefono',0),(83689,2325,'tl','',0),(83690,2325,'th','&#3649;&#3626;&#3604;&#3591;&#3588;&#3623;&#3634;&#3617;&#3588;&#3636;&#3604;&#3648;&#3627;&#3655;&#3609;&#3607;&#3634;&#3591;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(83691,2325,'hi','à¤«à¥‹à¤¨ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€',0),(83692,2325,'ms','Komen telefon',0),(83693,2325,'ar','ØªØ¹Ù„ÙŠÙ‚ Ø§Ù„Ù‡Ø§ØªÙ',0),(83694,2325,'fr','Commentaire de tÃ©lÃ©phone',0),(83695,2325,'jp','é›»è©±ã‚³ãƒ¡ãƒ³ãƒˆ',0),(83696,2325,'pt','ComentÃ¡rio de telefone',0),(83697,2325,'ru','ÐšÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¸ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ð¾Ð³Ð¾ ÐÐ¾Ð¼ÐµÑ€Ð°',0),(83698,2325,'es','Comentario de TelÃ©fono',0),(83699,2325,'de','Telefon Kommentar',0),(83700,2325,'en','Phone Comment',0),(83701,2326,'is','',0),(83702,2326,'dr','Ø´Ø±Ø­ ØªÙ„ÙÙ† ',0),(83703,2326,'pr','Ø´Ø±Ø­ ØªÙ„ÙÙ† ',0),(83704,2326,'tr','Telefon aÃ§Ä±klamasÄ±',0),(83705,2326,'pl','Opis telefon',0),(83706,2326,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(83707,2326,'ur','ÙÙˆÙ† Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(83708,2326,'sr','ÐžÐ¿Ð¸Ñ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(83709,2326,'vi','MÃ´ táº£ phone',0),(83710,2326,'af','Telefoon Beskrywing',0),(83711,2326,'ro','Telefon Descriere',0),(83712,2326,'et','Telefoni kirjeldus',0),(83713,2326,'si','Opis telefona',0),(83714,2326,'ba','Deskripsi telepon',0),(83715,2326,'nl','Beschrijving van de telefoon',0),(83716,2326,'fi','Puhelimen kuvaus',0),(83717,2326,'no','Telefon beskrivelse',0),(83718,2326,'da','Telefon beskrivelse',0),(83719,2326,'ko','ì „í™” ì„¤ëª…',0),(83720,2326,'he','×ª×™××•×¨ ×˜×œ×¤×•×Ÿ',0),(83721,2326,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(83722,2326,'zh','ç”µè¯æè¿°\r\n',0),(83723,2326,'sv','Telefon Beskrivning',0),(83724,2326,'it','Descrizione del telefono',0),(83725,2326,'tl','',0),(83726,2326,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(83727,2326,'hi','à¤«à¤¼à¥‹à¤¨ à¤µà¤¿à¤µà¤°à¤£',0),(83728,2326,'ms','Description/kawalan telefon',0),(83729,2326,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ù‡Ø§ØªÙ',0),(83730,2326,'fr','Description du tÃ©lÃ©phone',0),(83731,2326,'jp','é›»è©±è§£èª¬',0),(83732,2326,'pt','DescriÃ§Ã£o de telefone',0),(83733,2326,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ð¾Ð³Ð¾ ÐÐ¾Ð¼ÐµÑ€Ð°',0),(83734,2326,'es','DescripciÃ³n de TelÃ©fono',0),(83735,2326,'de','Telefon Beschreibung',0),(83736,2326,'en','Phone Description',0),(83737,2327,'is','',0),(83738,2327,'dr','4',0),(83739,2327,'pr','ØªÙ„ÙÙ† 4',0),(83740,2327,'tr','DÃ¶rt telefon',0),(83741,2327,'pl','Telefon cztery',0),(83742,2327,'bg','Ð§ÐµÑ‚Ð¸Ñ€Ð¸ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(83743,2327,'ur','Ú†Ø§Ø± ÙÙˆÙ†',0),(83744,2327,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 4',0),(83745,2327,'vi','Phone 4',0),(83746,2327,'af','Telefoon Vier',0),(83747,2327,'ro','Telefon patru',0),(83748,2327,'et','Telefon 4',0),(83749,2327,'si','Telefon Å¡tiri',0),(83750,2327,'ba','Telepon empat',0),(83751,2327,'nl','Telefoon vier',0),(83752,2327,'fi','Puhelimen neljÃ¤',0),(83753,2327,'no','Telefonen fire',0),(83754,2327,'da','Telefon fire',0),(83755,2327,'ko','4 ì „í™”',0),(83756,2327,'he','×˜×œ×¤×•×Ÿ ××¨×‘×¢',0),(83757,2327,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ Ï„Î­ÏƒÏƒÎµÏÎ¹Ï‚',0),(83758,2327,'zh','ç”µè¯å››\r\n',0),(83759,2327,'sv','Telefon fyra',0),(83760,2327,'it','Telefonare a quattro',0),(83761,2327,'tl','',0),(83762,2327,'th','&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3607;&#3637;&#3656; 4',0),(83763,2327,'hi','à¤šà¤¾à¤° à¤«à¥‹à¤¨',0),(83764,2327,'ms','Telefon empat',0),(83765,2327,'ar','Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ø±Ø§Ø¨Ø¹',0),(83766,2327,'fr','TÃ©lÃ©phone quatre',0),(83767,2327,'jp','é›»è©±ã€€4',0),(83768,2327,'pt','Telefone-quatro',0),(83769,2327,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ Ð§ÐµÑ‚Ñ‹Ñ€Ðµ',0),(83770,2327,'es','TelÃ©fono Cuatro',0),(83771,2327,'de','Telefon vier',0),(83772,2327,'en','Phone Four',0),(83773,2328,'is','',0),(83774,2328,'dr','Ø´Ù…Ø§Ø±Ù‡ ØªÙ„ÙÙ† ',0),(83775,2328,'pr','Ø´Ù…Ø§Ø±Ù‡ ØªÙ„ÙÙ† ',0),(83776,2328,'tr','Telefon numarasÄ±',0),(83777,2328,'pl','Telefon #',0),(83778,2328,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ÐµÐ½ â„–',0),(83779,2328,'ur','ÙÙˆÙ† #',0),(83780,2328,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(83781,2328,'vi','Phone sá»‘',0),(83782,2328,'af','Telefoon #',0),(83783,2328,'ro','Telefon #',0),(83784,2328,'et','Telefoninumber',0),(83785,2328,'si','Telefonski Å¡tevilki',0),(83786,2328,'ba','Telepon #',0),(83787,2328,'nl','Telefoon #',0),(83788,2328,'fi','Puhelin #',0),(83789,2328,'no','Telefonnr.',0),(83790,2328,'da','Telefon #',0),(83791,2328,'ko','ì „í™” #',0),(83792,2328,'he','# ×˜×œ×¤×•×Ÿ',0),(83793,2328,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ #',0),(83794,2328,'zh','ç”µè¯å·ç \r\n',0),(83795,2328,'sv','Telefonnummer #',0),(83796,2328,'it','Telefono #',0),(83797,2328,'tl','',0),(83798,2328,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(83799,2328,'hi','à¤«à¤¼à¥‹à¤¨ #',0),(83800,2328,'ms','Telefon #',0),(83801,2328,'ar','Ø±Ù‚Ù… Ø§Ù„Ù‡Ø§ØªÙ',0),(83802,2328,'fr','# De tÃ©lÃ©phone',0),(83803,2328,'jp','é›»è©±ç•ªå?·',0),(83804,2328,'pt','Telefone #',0),(83805,2328,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð° #',0),(83806,2328,'es','TelÃ©fono #',0),(83807,2328,'de','Telefonnr.',0),(83808,2328,'en','Phone #',0),(83809,2329,'is','',0),(83810,2329,'dr','1',0),(83811,2329,'pr','ØªÙ„ÙÙ† 1',0),(83812,2329,'tr','Bir telefon',0),(83813,2329,'pl','Jeden telefon',0),(83814,2329,'bg','Ð•Ð´Ð¸Ð½ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(83815,2329,'ur','Ø§ÛŒÚ© ÙÙˆÙ†',0),(83816,2329,'sr','ÐˆÐµÐ´Ð°Ð½ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½.',0),(83817,2329,'vi','Phone 1',0),(83818,2329,'af','Telefoon Een',0),(83819,2329,'ro','Telefon unul',0),(83820,2329,'et','Telefon 1',0),(83821,2329,'si','Telefon eden',0),(83822,2329,'ba','Telepon satu',0),(83823,2329,'nl','Een telefoon',0),(83824,2329,'fi','Puhelimen yksi',0),(83825,2329,'no','Ring et',0),(83826,2329,'da','Telefonen en',0),(83827,2329,'ko','í•˜ë‚˜ ì „í™”',0),(83828,2329,'he','×˜×œ×¤×•×Ÿ ××—×“',0),(83829,2329,'el','ÎˆÎ½Î± Ï„Î·Î»Î­Ï†Ï‰Î½Î¿',0),(83830,2329,'zh','ç”µè¯1\r\n',0),(83831,2329,'sv','Telefonen en',0),(83832,2329,'it','Telefono uno',0),(83833,2329,'tl','',0),(83834,2329,'th','&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3607;&#3637;&#3656; 1 ',0),(83835,2329,'hi','à¤à¤• à¤«à¥‹à¤¨',0),(83836,2329,'ms','Telefon salah satu',0),(83837,2329,'ar','Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ø£ÙˆÙ„',0),(83838,2329,'fr','Un tÃ©lÃ©phone',0),(83839,2329,'jp','é›»è©±ã€€ï¼‘',0),(83840,2329,'pt','Um telefone',0),(83841,2329,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ ÐžÐ´Ð¸Ð½',0),(83842,2329,'es','TelÃ©fono Uno',0),(83843,2329,'de','Telefon eins',0),(83844,2329,'en','Phone One',0),(83845,2330,'is','',0),(83846,2330,'dr','3 ',0),(83847,2330,'pr','ØªÙ„ÙÙ†  3 ',0),(83848,2330,'tr','ÃœÃ§ telefon',0),(83849,2330,'pl','Telefon trzy',0),(83850,2330,'bg','Ð¢Ñ€Ð¸ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ð¸',0),(83851,2330,'ur','ØªÛŒÙ† ÙÙˆÙ†',0),(83852,2330,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 3',0),(83853,2330,'vi','Phone 3',0),(83854,2330,'af','Telefoon Drie',0),(83855,2330,'ro','Trei telefon',0),(83856,2330,'et','Telefon 3',0),(83857,2330,'si','Telefon tri',0),(83858,2330,'ba','Telepon tiga',0),(83859,2330,'nl','Telefoon drie',0),(83860,2330,'fi','Puhelimen kolme',0),(83861,2330,'no','Telefon tre',0),(83862,2330,'da','Telefon tre',0),(83863,2330,'ko','3 ì „í™”',0),(83864,2330,'he','×˜×œ×¤×•×Ÿ ×©×œ×™×©×™',0),(83865,2330,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ Ï„ÏÎµÎ¹Ï‚',0),(83866,2330,'zh','ç”µè¯ä¸‰\r\n',0),(83867,2330,'sv','Telefon tre',0),(83868,2330,'it','Telefono tre',0),(83869,2330,'tl','',0),(83870,2330,'th','&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3607;&#3637;&#3656; 3 ',0),(83871,2330,'hi','à¤¤à¥€à¤¨ à¤«à¥‹à¤¨',0),(83872,2330,'ms','Telefon tiga',0),(83873,2330,'ar','Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ø«Ø§Ù„Ø«',0),(83874,2330,'fr','TÃ©lÃ©phone trois',0),(83875,2330,'jp','é›»è©±ã€€3',0),(83876,2330,'pt','Telefone-3',0),(83877,2330,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ Ð¢Ñ€Ð¸',0),(83878,2330,'es','TelÃ©fono Tres',0),(83879,2330,'de','Telefon drei',0),(83880,2330,'en','Phone Three',0),(83881,2331,'is','',0),(83882,2331,'dr','2',0),(83883,2331,'pr','ØªÙ„ÙÙ†  2',0),(83884,2331,'tr','Ä°ki telefon',0),(83885,2331,'pl','Telefon dwa',0),(83886,2331,'bg','Ð”Ð²Ðµ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ð¸',0),(83887,2331,'ur','Ø¯Ùˆ ÙÙˆÙ†',0),(83888,2331,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 2',0),(83889,2331,'vi','Phone 2',0),(83890,2331,'af','Telefoon Twee',0),(83891,2331,'ro','DouÄƒ telefoane',0),(83892,2331,'et','Telefon 2',0),(83893,2331,'si','Dva telefon',0),(83894,2331,'ba','Telepon dua',0),(83895,2331,'nl','Telefoon twee',0),(83896,2331,'fi','Puhelimen kaksi',0),(83897,2331,'no','Telefon to',0),(83898,2331,'da','Telefon to',0),(83899,2331,'ko','2 ì „í™”',0),(83900,2331,'he','×˜×œ×¤×•×Ÿ ×©× ×™',0),(83901,2331,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ Î´ÏÎ¿',0),(83902,2331,'zh','ç”µè¯2\r\n',0),(83903,2331,'sv','Telefon tvÃ¥',0),(83904,2331,'it','Telefonare a due',0),(83905,2331,'tl','',0),(83906,2331,'th','&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3607;&#3637;&#3656; 2',0),(83907,2331,'hi','à¤¦à¥‹ à¤«à¥‹à¤¨',0),(83908,2331,'ms','Telefon dua',0),(83909,2331,'ar','Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(83910,2331,'fr','TÃ©lÃ©phone Ã  deux',0),(83911,2331,'jp','é›»è©±ã€€2',0),(83912,2331,'pt','Telefone dois',0),(83913,2331,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ Ð”Ð²Ð°',0),(83914,2331,'es','TelÃ©fono Dos',0),(83915,2331,'de','Telefon zwei',0),(83916,2331,'en','Phone Two',0),(83917,2332,'is','',0),(83918,2332,'dr','PHP',0),(83919,2332,'pr',' Ù¾ÙŠÙƒØ±Ø¨Ù†Ø¯ÙŠ  ØªÙ„ÙÙ† Ù‚Ø§Ø¨Ù„ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø®ØµÙŠ Ù‡Ù†ÙˆØ² Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª PHP',0),(83920,2332,'tr','PHP yapÄ±landÄ±rma bitmiÅŸ deÄŸil henÃ¼z.',0),(83921,2332,'pl','Konfiguracja PHP nie zrobiÅ‚y.',0),(83922,2332,'bg','PHP ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ñ Ð²ÑÐµ Ð¾Ñ‰Ðµ Ð½Ðµ ÑÐ° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð¸.',0),(83923,2332,'ur','Ù¾ÛŒ Ø§ÛŒÚ† Ù¾ÛŒ Ú©ÛŒ ØªØ´Ú©ÛŒÙ„ Ø§Ø¨Ú¾ÛŒ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§ØªØ§ Û”',0),(83924,2332,'sr','ÐŸÐ¥ÐŸ ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ñ˜Ð° Ñ˜Ð¾Ñˆ Ð½Ð¸Ñ˜Ðµ Ð³Ð¾Ñ‚Ð¾Ð².',0),(83925,2332,'vi','Cáº¥u hÃ¬nh PHP chÆ°a lÃ m',0),(83926,2332,'af','PHP konfigurasie nog nie gedoen.',0),(83927,2332,'ro','Configurarea PHP-ului nu a fost Ã®ncÄƒ realizat.',0),(83928,2332,'et','PHP konfiguratsioon ei ole veel teinud.',0),(83929,2332,'si','PHP konfiguracija Å¡e niso storile.',0),(83930,2332,'ba','Konfigurasi PHP belum dilakukan.',0),(83931,2332,'nl','PHP configuratie nog niet gedaan.',0),(83932,2332,'fi','PHP kokoonpano ei vielÃ¤.',0),(83933,2332,'no','PHP-konfigurasjonen er ennÃ¥ ikke gjort.',0),(83934,2332,'da','PHP konfiguration endnu ikke gjort.',0),(83935,2332,'ko','PHP êµ¬ì„±ì„ ì•„ì§ ìˆ˜í–‰ìž…ë‹ˆë‹¤.',0),(83936,2332,'he','×§×‘×™×¢×ª ×ª×¦×•×¨×” ×©×œ PHP ×¢×“×™×™×Ÿ ×œ× × ×¢×©×”.',0),(83937,2332,'el','PHP ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Î´ÎµÎ½ Î­Ï‡Î¿Ï…Î½ Î±ÎºÏŒÎ¼Î· Î³Î¯Î½ÎµÎ¹.',0),(83938,2332,'zh','PHPå‚æ•°è¿˜æ²¡æœ‰å®Œæˆ\r\n',0),(83939,2332,'sv','PHP-konfigurationen som Ã¤nnu inte gjort.',0),(83940,2332,'it','Configurazione di PHP non ancora fatta.',0),(83941,2332,'tl','',0),(83942,2332,'th','&#3650;&#3588;&#3619;&#3591;&#3626;&#3619;&#3657;&#3634;&#3591;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585; PHP &#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3636;&#3657;&#3609;&#3605;&#3629;&#3609;&#3609;&#3637;h',0),(83943,2332,'hi','PHP à¤µà¤¿à¤¨à¥à¤¯à¤¾à¤¸ à¤…à¤­à¥€ à¤¤à¤• à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾à¥¤',0),(83944,2332,'ms','Konfigurasi PHP yang belum dilakukan.',0),(83945,2332,'ar','ØªÙƒÙˆÙŠÙ† Ø¨ÙŠ Ù„Ù… ØªÙØ¹Ù„.',0),(83946,2332,'fr','Configuration de PHP pas encore faite.',0),(83947,2332,'jp','PHPã‚³ãƒ³ãƒ•ã‚£ã‚®ãƒ¥ãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã?Œã?¾ã? çµ‚ã‚?ã?£ã?¦ã?„ã?¾ã?›ã‚“',0),(83948,2332,'pt','ConfiguraÃ§Ã£o de PHP ainda nÃ£o feita.',0),(83949,2332,'ru','ÐšÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ñ PHP ÐµÑ‰Ðµ Ð½Ðµ ÑÐ´ÐµÐ»Ð°Ð»Ð¸.',0),(83950,2332,'es','ConfiguraciÃ³n de PHP ya no se hizo',0),(83951,2332,'de','PHP-Konfiguration noch nicht getan.',0),(83952,2332,'en','PHP configuration not yet done.',0),(83953,2333,'is','',0),(83954,2333,'dr','ÙÙŠØ²ÙŠÙƒÙŠ',0),(83955,2333,'pr','ÙÙŠØ²ÙŠÙƒÙŠ',0),(83956,2333,'tr','Fiziksel',0),(83957,2333,'pl','Fizyczne',0),(83958,2333,'bg','Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸',0),(83959,2333,'ur','Ø¬Ø³Ù…Ø§Ù†ÛŒ',0),(83960,2333,'sr','Ð¤Ð¸Ð·Ð¸Ñ‡ÐºÐ¸',0),(83961,2333,'vi','Váº­t lÃ½',0),(83962,2333,'af','Fisiese (Rou Materiale)',0),(83963,2333,'ro','Fizice',0),(83964,2333,'et','FÃ¼Ã¼silise',0),(83965,2333,'si','FiziÄni',0),(83966,2333,'ba','Fisik',0),(83967,2333,'nl','Fysieke',0),(83968,2333,'fi','Fyysinen',0),(83969,2333,'no','Fysisk',0),(83970,2333,'da','Fysiske',0),(83971,2333,'ko','ë¬¼ë¦¬ì ',0),(83972,2333,'he','×¤×™×–×™',0),(83973,2333,'el','Î¦Ï…ÏƒÎ¹ÎºÎ®',0),(83974,2333,'zh','å®žé™…çš„\r\n',0),(83975,2333,'sv','Fysiska',0),(83976,2333,'it','Fisica',0),(83977,2333,'tl','',0),(83978,2333,'th','&#3607;&#3634;&#3591;&#3585;&#3634;&#3618;&#3616;&#3634;&#3614;',0),(83979,2333,'hi','à¤¶à¤¾à¤°à¥€à¤°à¤¿à¤•',0),(83980,2333,'ms','Fizikal',0),(83981,2333,'ar','Ù…ÙˆØ§Ø¯ Ø®Ø§Ù…',0),(83982,2333,'fr','Physique',0),(83983,2333,'jp','å®Ÿéš›ã?®',0),(83984,2333,'pt','FÃ­sica',0),(83985,2333,'ru','Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ',0),(83986,2333,'es','FÃ­sico',0),(83987,2333,'de','KÃ¶rperliche',0),(83988,2333,'en','Physical',0),(83989,2334,'is','',0),(83990,2334,'dr','Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ ',0),(83991,2334,'pr','Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ ',0),(83992,2334,'tr','SeÃ§im listesi',0),(83993,2334,'pl','Wybierz lista',0),(83994,2334,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ¿Ð¸ÑÑŠÐº',0),(83995,2334,'ur','ÙÛØ±Ø³Øª Ú†Ù†ÛŒÚº',0),(83996,2334,'sr','ÐŸÐ¾ Ð»Ð¸ÑÑ‚Ð¸',0),(83997,2334,'vi','Chá»n danh sÃ¡ch',0),(83998,2334,'af','Kies lys',0),(83999,2334,'ro','Alege lista',0),(84000,2334,'et','Vali loendist',0),(84001,2334,'si','Izberite seznam',0),(84002,2334,'ba','Memilih daftar',0),(84003,2334,'nl','Keuzelijst',0),(84004,2334,'fi','Poimintojen luettelo',0),(84005,2334,'no','Plukklisten',0),(84006,2334,'da','Plukliste',0),(84007,2334,'ko','ëª©ë¡ ì„ íƒ',0),(84008,2334,'he','×œ×‘×—×•×¨ ×¨×©×™×ž×”',0),(84009,2334,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î· Î»Î¯ÏƒÏ„Î±',0),(84010,2334,'zh','é€‰æ‹©åˆ—è¡¨\r\n',0),(84011,2334,'sv','Plocka lista',0),(84012,2334,'it','Scegliere elenco',0),(84013,2334,'tl','',0),(84014,2334,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(84015,2334,'hi','à¤¸à¥‚à¤šà¥€ à¤‰à¤ à¤¾à¤“',0),(84016,2334,'ms','Pilih senarai',0),(84017,2334,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù†ØªÙ‚Ø§Ø¡',0),(84018,2334,'fr','La liste de sÃ©lection',0),(84019,2334,'jp','é?¸æŠžãƒªã‚¹ãƒˆ',0),(84020,2334,'pt','Lista de seleÃ§Ã£o',0),(84021,2334,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¡Ð¿Ð¸ÑÐ¾Ðº',0),(84022,2334,'es','Lista de SelecciÃ³n',0),(84023,2334,'de','Auswahlliste',0),(84024,2334,'en','Pick List',0),(84025,2335,'is','',0),(84026,2335,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø§Ù‡ ',0),(84027,2335,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø§Ù‡ ',0),(84028,2335,'tr','Ay seÃ§in',0),(84029,2335,'pl','Wybierz miesiÄ…c',0),(84030,2335,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¼ÐµÑÐµÑ†',0),(84031,2335,'ur','Ù…Ø§Û Ú†Ù†ÛŒÚº',0),(84032,2335,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸ Ð¼ÐµÑÐµÑ†',0),(84033,2335,'vi','Chá»n thÃ¡ng',0),(84034,2335,'af','Maand kies',0),(84035,2335,'ro','Alege luna',0),(84036,2335,'et','Vali kuu',0),(84037,2335,'si','Izberite mesec',0),(84038,2335,'ba','Pilih bulan',0),(84039,2335,'nl','Kies maand',0),(84040,2335,'fi','Valitse kuukausi',0),(84041,2335,'no','Velg mÃ¥ned',0),(84042,2335,'da','VÃ¦lg mÃ¥ned',0),(84043,2335,'ko','ì„ íƒ ë‹¬',0),(84044,2335,'he','×‘×—×¨ ×—×•×“×©',0),(84045,2335,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î®Î½Î±',0),(84046,2335,'zh','é€‰æ‹©æœˆ\r\n',0),(84047,2335,'sv','VÃ¤lja mÃ¥nad',0),(84048,2335,'it','Scegli il mese',0),(84049,2335,'tl','',0),(84050,2335,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(84051,2335,'hi','à¤®à¤¾à¤¹ à¤šà¥à¤¨à¥‡à¤‚',0),(84052,2335,'ms','Pilih bulan',0),(84053,2335,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø´Ù‡Ø±',0),(84054,2335,'fr','Choisir le mois',0),(84055,2335,'jp','æœˆã?®é?¸æŠž',0),(84056,2335,'pt','Escolher mÃªs',0),(84057,2335,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐœÐµÑÑÑ†',0),(84058,2335,'es','Mes de SelecciÃ³n',0),(84059,2335,'de','WÃ¤hlen Sie Monat',0),(84060,2335,'en','Pick Month',0),(84061,2336,'is','',0),(84062,2336,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‚Ø³Ù…Øª ',0),(84063,2336,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‚Ø³Ù…Øª ',0),(84064,2336,'tr','Dilim seÃ§',0),(84065,2336,'pl','Pobranie wycinka',0),(84066,2336,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð°Ñ€Ñ‡Ðµ',0),(84067,2336,'ur','Ù‚Ø§Ø´ Ú†Ù†ÛŒÚº',0),(84068,2336,'sr','Ð˜Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ Ð¸ÑÐµÑ‡Ð°ÐºÐ°',0),(84069,2336,'vi','Chá»n lÃ¡t cáº¯t',0),(84070,2336,'af','Sny tel',0),(84071,2336,'ro','Alege felii',0),(84072,2336,'et','Vali lÃµik',0),(84073,2336,'si','Pick rezina',0),(84074,2336,'ba','Memilih Slice',0),(84075,2336,'nl','Kies Slice',0),(84076,2336,'fi','Valita Slice',0),(84077,2336,'no','Velg sektor',0),(84078,2336,'da','VÃ¦lge udsnit',0),(84079,2336,'ko','ìŠ¬ë¼ì´ìŠ¤ë¥¼ ì„ íƒ',0),(84080,2336,'he','×œ×‘×—×•×¨ ×¤×¨×•×¡×”',0),(84081,2336,'el','Î”Î¹Î±Î»Î­Î¾Ï„Îµ Ï†Î­Ï„Î±',0),(84082,2336,'zh','é€‰æ‹©ç‰‡\r\n',0),(84083,2336,'sv','Plocka segment',0),(84084,2336,'it','Prendere la fetta',0),(84085,2336,'tl','',0),(84086,2336,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3656;&#3591;',0),(84087,2336,'hi','à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤‰à¤ à¤¾à¤“',0),(84088,2336,'ms','Bentuk hirisan',0),(84089,2336,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø´Ø±ÙŠØ­Ø©',0),(84090,2336,'fr','Choisir la tranche',0),(84091,2336,'jp','ã‚¹ãƒ©ã‚¤ã‚¹ã?®é?¸æŠž',0),(84092,2336,'pt','Escolher a fatia',0),(84093,2336,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ñ„Ñ€Ð°Ð³Ð¼ÐµÐ½Ñ‚',0),(84094,2336,'es','Rebanada de Pie de GrÃ¡fica ',0),(84095,2336,'de','WÃ¤hlen Sie Slice',0),(84096,2336,'en','Pick Slice',0),(84097,2337,'is','',0),(84098,2337,'dr','ØªØµÙˆÙŠØ± ',0),(84099,2337,'pr','ØªØµÙˆÙŠØ± ',0),(84100,2337,'tr','Resim',0),(84101,2337,'pl','Obraz',0),(84102,2337,'bg','ÐšÐ°Ñ€Ñ‚Ð¸Ð½Ð°',0),(84103,2337,'ur','ØªØµÙˆÛŒØ±',0),(84104,2337,'sr','Ð¡Ð»Ð¸ÐºÐ°',0),(84105,2337,'vi','Photo',0),(84106,2337,'af','Foto',0),(84107,2337,'ro','Poze pentru',0),(84108,2337,'et','Pilt',0),(84109,2337,'si','Slika',0),(84110,2337,'ba','Gambar',0),(84111,2337,'nl','Foto',0),(84112,2337,'fi','Kuva',0),(84113,2337,'no','Bilde',0),(84114,2337,'da','Billede',0),(84115,2337,'ko','ê·¸ë¦¼',0),(84116,2337,'he','×”×ª×ž×•× ×•×ª',0),(84117,2337,'el','Î•Î¹ÎºÏŒÎ½Î±',0),(84118,2337,'zh','ç…§ç‰‡\r\n',0),(84119,2337,'sv','Bild',0),(84120,2337,'it','Foto',0),(84121,2337,'tl','',0),(84122,2337,'th','&#3619;&#3641;&#3611;&#3606;&#3656;&#3634;&#3618;',0),(84123,2337,'hi','à¤šà¤¿à¤¤à¥à¤°',0),(84124,2337,'ms','Gambar',0),(84125,2337,'ar','Ø§Ù„ØµÙˆØ±Ø©',0),(84126,2337,'fr','Photo',0),(84127,2337,'jp','å†™çœŸ',0),(84128,2337,'pt','Imagens',0),(84129,2337,'ru','Ð¤Ð¾Ñ‚Ð¾Ð³Ñ€Ð°Ñ„Ð¸Ñ',0),(84130,2337,'es','Foto',0),(84131,2337,'de','Bild',0),(84132,2337,'en','Picture',0),(84133,2338,'is','',0),(84134,2338,'dr','/ Ú†Ø§Ù¾',0),(84135,2338,'pr','Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ Ø¬Ù‡Øª ÙˆÙŠØ±Ø§ÙŠØ´ / Ú†Ø§Ù¾',0),(84136,2338,'tr','Pasta grafiÄŸi DÃ¼zenle/baskÄ±',0),(84137,2338,'pl','Wykres koÅ‚owy do edycji i wydruku',0),(84138,2338,'bg','ÐšÑ€ÑŠÐ³Ð¾Ð²Ð° Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð°, Ð·Ð° Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ð¿ÐµÑ‡Ð°Ñ‚',0),(84139,2338,'ur','Ù¾Ø§Ø¦ÛŒ Ú†Ø§Ø±Ù¹ ØªØ¯ÙˆÛŒÙ†/Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’',0),(84140,2338,'sr','ÐšÑ€ÑƒÐ¶Ð½Ð¸ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ¾Ð½ Ð´Ð° Ð£Ñ€ÐµÐ´Ð¸/ÐŸÑ€Ð¸Ð½Ñ‚',0),(84141,2338,'vi','Sá»­a/In Biá»ƒu Äá»“ Dáº¡ng TrÃ²n',0),(84142,2338,'af','Sirkeldiagram Grafiek Vir Redigering/Uidruk',0),(84143,2338,'ro','Diagrama de structurÄƒ radialÄƒ pentru editare/tipÄƒrire',0),(84144,2338,'et','Sektordiagrammi Edit/Prindi',0),(84145,2338,'si','Tortni grafikon Edit/tisk',0),(84146,2338,'ba','Pie Chart untuk Edit/cetak',0),(84147,2338,'nl','Cirkeldiagram te bewerken/afdrukken',0),(84148,2338,'fi','YmpyrÃ¤kaavio Edit/Print',0),(84149,2338,'no','Sektordiagram til Rediger/ut',0),(84150,2338,'da','Cirkeldiagram til Rediger/Print',0),(84151,2338,'ko','ì›í˜• ì°¨íŠ¸ íŽ¸ì§‘/ì¸ì‡„',0),(84152,2338,'he','×ª×¨×©×™× ×¢×•×’×” ×›×“×™ ×¢×¨×™×›×”/×”×“×¤×¡×”',0),(84153,2338,'el','Î“ÏÎ¬Ï†Î·Î¼Î± Ï€Î¯Ï„Î±Ï‚ Î³Î¹Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±/ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(84154,2338,'zh','é¥¼å›¾ç¼–è¾‘/æ‰“å°\r\n',0),(84155,2338,'sv','Cirkeldiagram att redigera/Skriv ut',0),(84156,2338,'it','Grafico a torta per Modifica/stampa',0),(84157,2338,'tl','',0),(84158,2338,'th','&#3649;&#3585;&#3657;&#3652;&#3586;/&#3614;&#3636;&#3617;&#3614;&#3660;&#3649;&#3612;&#3609;&#3616;&#3641;&#3617;&#3636;&#3623;&#3591;&#3585;&#3621;&#3617;',0),(84159,2338,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚/à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤ˆ à¤šà¤¾à¤°à¥à¤Ÿ',0),(84160,2338,'ms','Carta pai untuk Edit/cetakan',0),(84161,2338,'ar','Ø§Ù„Ù…Ø®Ø·Ø· Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠ Ù„ØªØ­Ø±ÙŠØ±/Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(84162,2338,'fr','Camembert Ã  modifier/imprimer',0),(84163,2338,'jp','ç·¨é›†/å?°åˆ·ã?™ã‚‹ãƒ‘ã‚¤ãƒ?ãƒ£ãƒ¼ãƒˆ',0),(84164,2338,'pt','GrÃ¡fico de pizza para editar/imprimir',0),(84165,2338,'ru','ÐšÑ€ÑƒÐ³Ð¾Ð²Ð°Ñ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¼Ð° Ð´Ð»Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(84166,2338,'es','GrÃ¡ficos Circulares para Editar/Imprimir',0),(84167,2338,'de','Kreisdiagramm zu bearbeiten/drucken',0),(84168,2338,'en','Pie Chart To Edit/Print',0),(84169,2339,'is','',0),(84170,2339,'dr','Ø´Ø±Ø­ Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ',0),(84171,2339,'pr','Ø´Ø±Ø­ Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ',0),(84172,2339,'tr','Pasta aÃ§Ä±klamasÄ±',0),(84173,2339,'pl','Opis koÅ‚owy',0),(84174,2339,'bg','ÐšÑ€ÑŠÐ³Ð¾Ð²Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(84175,2339,'ur','Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(84176,2339,'sr','ÐžÐ¿Ð¸Ñ Ð¿Ð¸Ñ‚Ñƒ',0),(84177,2339,'vi','MÃ´ táº£ biá»ƒu Ä‘á»“ Ä‘áº¡ng á»‘ng',0),(84178,2339,'af','Sirkeldiagram Beskrywing',0),(84179,2339,'ro','Descriere placinta',0),(84180,2339,'et','Pirukas kirjeldus',0),(84181,2339,'si','Opis Pie',0),(84182,2339,'ba','Deskripsi Pie',0),(84183,2339,'nl','Beschrijving van de taart',0),(84184,2339,'fi','Pie kuvaus',0),(84185,2339,'no','Pie beskrivelse',0),(84186,2339,'da','Pie beskrivelse',0),(84187,2339,'ko','íŒŒì´ ì„¤ëª…',0),(84188,2339,'he','×ª×™××•×¨ ×¤××™',0),(84189,2339,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï€Î¯Ï„Î±',0),(84190,2339,'zh','é¥¼å›¾æè¿°\r\n',0),(84191,2339,'sv','Paj Beskrivning',0),(84192,2339,'it','Torta Descrizione',0),(84193,2339,'tl','',0),(84194,2339,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3649;&#3612;&#3609;&#3616;&#3641;&#3617;&#3636;&#3623;&#3591;&#3585;&#3621;&#3617;',0),(84195,2339,'hi','à¤ªà¤¾à¤‡ à¤µà¤¿à¤µà¤°à¤£',0),(84196,2339,'ms','Description/kawalan pai',0),(84197,2339,'ar','ÙˆØµÙ Ø¯Ø§Ø¦Ø±ÙŠ',0),(84198,2339,'fr','Description de la tarte',0),(84199,2339,'jp','ãƒ‘ã‚¤è§£èª¬',0),(84200,2339,'pt','DescriÃ§Ã£o de torta',0),(84201,2339,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¸Ñ€Ð¾Ð³',0),(84202,2339,'es','GrÃ¡fica Pie Descripcion',0),(84203,2339,'de','Kuchen-Beschreibung',0),(84204,2339,'en','Pie Description',0),(84205,2340,'is','',0),(84206,2340,'dr','Ù†Ø§Ù… Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ ',0),(84207,2340,'pr','Ù†Ø§Ù… Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ ',0),(84208,2340,'tr','Pasta adÄ±',0),(84209,2340,'pl','NazwÄ™ koÅ‚owy',0),(84210,2340,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¿Ð°Ð¹',0),(84211,2340,'ur','Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù†Ø§Ù…',0),(84212,2340,'sr','Ð˜Ð¼Ðµ Ð¿Ð¸Ñ‚Ñƒ',0),(84213,2340,'vi','TÃªn á»‘ng',0),(84214,2340,'af','Sirkeldiagram Naam',0),(84215,2340,'ro','PlÄƒcintÄƒ cu numele',0),(84216,2340,'et','Pirukas nimi',0),(84217,2340,'si','Ime Pie',0),(84218,2340,'ba','Nama Pie',0),(84219,2340,'nl','Naam van de taart',0),(84220,2340,'fi','Pie nimi',0),(84221,2340,'no','Pie navn',0),(84222,2340,'da','Pie navn',0),(84223,2340,'ko','ì›í˜• ì´ë¦„',0),(84224,2340,'he','×”×©× ×¤××™',0),(84225,2340,'el','ÎŒÎ½Î¿Î¼Î± Ï€Î¯Ï„Î±',0),(84226,2340,'zh','é¥¼å›¾åç§°\r\n',0),(84227,2340,'sv','Paj namn',0),(84228,2340,'it','Nome della torta',0),(84229,2340,'tl','',0),(84230,2340,'th','&#3594;&#3639;&#3656;&#3629;&#3649;&#3612;&#3609;&#3616;&#3641;&#3617;&#3636;&#3623;&#3591;&#3585;&#3621;&#3617;',0),(84231,2340,'hi','à¤ªà¤¾à¤‡ à¤•à¤¾ à¤¨à¤¾à¤®',0),(84232,2340,'ms','Nama pai',0),(84233,2340,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…Ø®Ø·Ù‘Ø· Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠ',0),(84234,2340,'fr','Nom de la Pie',0),(84235,2340,'jp','ãƒ‘ã‚¤å??',0),(84236,2340,'pt','Nome de torta',0),(84237,2340,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¸Ñ€Ð¾Ð³Ð°',0),(84238,2340,'es','Nombre de GrÃ¡fica Pie',0),(84239,2340,'de','Kuchen-Name',0),(84240,2340,'en','Pie Name',0),(84241,2341,'is','',0),(84242,2341,'dr','Ù†Ù…ÙˆØ¯Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(84243,2341,'pr','Ù†Ù…ÙˆØ¯Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(84244,2341,'tr','Pasta baÅŸarÄ±yla silindi',0),(84245,2341,'pl','PomyÅ›lnie usuniÄ™to z pie',0),(84246,2341,'bg','ÐšÑ€ÑŠÐ³Ð¾Ð²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð°',0),(84247,2341,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù¾Ø§Ø¦ÛŒ',0),(84248,2341,'sr','ÐŸÐ¸Ñ‚Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(84249,2341,'vi','XÃ³a á»‘ng thÃ nh cÃ´ng',0),(84250,2341,'af','\"Pie\" suksesvol geskrap',0),(84251,2341,'ro','Placinta ÅŸtearsÄƒ cu succes',0),(84252,2341,'et','Kustutas pirukas',0),(84253,2341,'si','Pie uspeÅ¡no izbrisana',0),(84254,2341,'ba','Pie berhasil dihapus.',0),(84255,2341,'nl','Taart met succes verwijderd',0),(84256,2341,'fi','Kakku onnistui',0),(84257,2341,'no','Pie slettet',0),(84258,2341,'da','Pie slettet',0),(84259,2341,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” íŒŒì´',0),(84260,2341,'he','×¤××™ ×ž×—×§ ×‘×”×¦×œ×—×”',0),(84261,2341,'el','Î Î¯Ï„Î± Î´Î¹Î­Î³ÏÎ±ÏˆÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(84262,2341,'zh','é¥¼å›¾æˆåŠŸåˆ é™¤\r\n',0),(84263,2341,'sv','Pie har tagits bort',0),(84264,2341,'it','Torta eliminato correttamente',0),(84265,2341,'tl','',0),(84266,2341,'th','&#3621;&#3610;&#3649;&#3612;&#3609;&#3616;&#3641;&#3617;&#3636;&#3623;&#3591;&#3585;&#3621;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(84267,2341,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤ªà¤¾à¤ˆ',0),(84268,2341,'ms','Pai yang berjaya dihapuskan',0),(84269,2341,'ar','Ø­Ø°Ù Ø§Ù„Ù…Ø®Ø·Ù‘Ø· Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(84270,2341,'fr','Tarte a Ã©tÃ© correctement supprimÃ©',0),(84271,2341,'jp','ãƒ‘ã‚¤ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(84272,2341,'pt','Torta excluÃ­da com Ãªxito',0),(84273,2341,'ru','ÐŸÐ¸Ñ€Ð¾Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(84274,2341,'es','GrÃ¡fica Pie eliminada exitosamente',0),(84275,2341,'de','Pie erfolgreich gelÃ¶scht',0),(84276,2341,'en','Pie successfully deleted',0),(84277,2342,'is','',0),(84278,2342,'dr','Ù†Ø§Ù…  Ø·Ø±Ø­ ',0),(84279,2342,'pr','Ù†Ø§Ù…  Ø·Ø±Ø­ ',0),(84280,2342,'tr','Plan adÄ±',0),(84281,2342,'pl','Nazwa planu',0),(84282,2342,'bg','ÐŸÐ»Ð°Ð½ Ð¸Ð¼Ðµ',0),(84283,2342,'ur','Ù†Ø§Ù… Ù…Ù†ØµÙˆØ¨Û',0),(84284,2342,'sr','Ð˜Ð¼Ðµ Ð¿Ð»Ð°Ð½Ð°',0),(84285,2342,'vi','TÃªn káº¿ hoáº¡ch',0),(84286,2342,'af','Plan Naam',0),(84287,2342,'ro','Planul de nume',0),(84288,2342,'et','Plaani nimi',0),(84289,2342,'si','Ime naÄrta',0),(84290,2342,'ba','Nama rencana',0),(84291,2342,'nl','Plan naam',0),(84292,2342,'fi','Suunnitelman nimi',0),(84293,2342,'no','Plan navn',0),(84294,2342,'da','Planen navn',0),(84295,2342,'ko','ê³„íš ì´ë¦„',0),(84296,2342,'he','×©× ×ª×•×›× ×™×ª',0),(84297,2342,'el','Î£Ï‡Î­Î´Î¹Î¿ ÏŒÎ½Î¿Î¼Î±',0),(84298,2342,'zh','è®¡åˆ’åç§°\r\n',0),(84299,2342,'sv','Namn pÃ¥',0),(84300,2342,'it','Nome del piano',0),(84301,2342,'tl','',0),(84302,2342,'th','&#3594;&#3639;&#3656;&#3629;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;',0),(84303,2342,'hi','à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¤¾ à¤¨à¤¾à¤®',0),(84304,2342,'ms','Nama pelan',0),(84305,2342,'ar','Ø¥Ø³Ù… Ø§Ù„Ø®Ø·Ø©',0),(84306,2342,'fr','Nom de plan',0),(84307,2342,'jp','ãƒ—ãƒ©ãƒ³å??',0),(84308,2342,'pt','Nome do plano',0),(84309,2342,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð»Ð°Ð½Ð°',0),(84310,2342,'es','Nombre de Plan ',0),(84311,2342,'de','Der Name',0),(84312,2342,'en','Plan Name',0),(84313,2343,'is','',0),(84314,2343,'dr','1',0),(84315,2343,'pr','Ø·Ø±Ø­  1',0),(84316,2343,'tr','Bir planÄ±',0),(84317,2343,'pl','ZaplanowaÄ‡ jeden',0),(84318,2343,'bg','Ð•Ð´Ð¸Ð½ Ð¿Ð»Ð°Ð½',0),(84319,2343,'ur','Ø§ÛŒÚ© Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(84320,2343,'sr','ÐŸÑ€Ð²Ð¸ Ð¿Ð»Ð°Ð½',0),(84321,2343,'vi','Káº¿ hoáº¡ch 1',0),(84322,2343,'af','Plan Een',0),(84323,2343,'ro','Planul de unul',0),(84324,2343,'et','Plaani Ã¼ks',0),(84325,2343,'si','Ena naÄrt',0),(84326,2343,'ba','Merencanakan satu',0),(84327,2343,'nl','Plan een',0),(84328,2343,'fi','Suunnitella sellaisen',0),(84329,2343,'no','Planlegge en',0),(84330,2343,'da','PlanlÃ¦gge en',0),(84331,2343,'ko','í•œ ê³„íš',0),(84332,2343,'he','×ª×•×›× ×™×ª ××—×ª',0),(84333,2343,'el','ÎˆÎ½Î± ÏƒÏ‡Î­Î´Î¹Î¿',0),(84334,2343,'zh','è®¡åˆ’ä¸€\r\n',0),(84335,2343,'sv','Planera en',0),(84336,2343,'it','Piano uno',0),(84337,2343,'tl','',0),(84338,2343,'th','&#3649;&#3612;&#3609;&#3627;&#3609;&#3638;&#3656;&#3591;',0),(84339,2343,'hi','à¤à¤• à¤¯à¥‹à¤œà¤¨à¤¾',0),(84340,2343,'ms','Merancang satu',0),(84341,2343,'ar','Ø§Ù„Ø®Ø·Ø© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(84342,2343,'fr','Un plan',0),(84343,2343,'jp','ãƒ—ãƒ©ãƒ³ã€€ï¼‘',0),(84344,2343,'pt','Um plano',0),(84345,2343,'ru','ÐŸÐ»Ð°Ð½ Ð¾Ð´Ð¸Ð½',0),(84346,2343,'es','Plan Uno',0),(84347,2343,'de','Planen Sie eine',0),(84348,2343,'en','Plan One',0),(84349,2344,'is','',0),(84350,2344,'dr','2',0),(84351,2344,'pr','Ø·Ø±Ø­  2',0),(84352,2344,'tr','Ä°ki plan',0),(84353,2344,'pl','2 planu',0),(84354,2344,'bg','ÐŸÐ»Ð°Ð½ Ð·Ð° Ð´Ð²Ðµ',0),(84355,2344,'ur','Ø¯Ùˆ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(84356,2344,'sr','ÐŸÐ»Ð°Ð½ Ð´Ð²Ð°',0),(84357,2344,'vi','Káº¿ hoáº¡ch 2',0),(84358,2344,'af','Plan Twee',0),(84359,2344,'ro','Planul doi',0),(84360,2344,'et','Kavas kaks',0),(84361,2344,'si','Dva naÄrta',0),(84362,2344,'ba','Rencana dua',0),(84363,2344,'nl','Plan twee',0),(84364,2344,'fi','Suunnitelma kaksi',0),(84365,2344,'no','Planlegg',0),(84366,2344,'da','PlanlÃ¦gge to',0),(84367,2344,'ko','2 ê³„íš',0),(84368,2344,'he','×ª×•×›× ×™×ª 2',0),(84369,2344,'el','Î£Ï‡Î­Î´Î¹Î¿ Î´ÏÎ¿',0),(84370,2344,'zh','è®¡åˆ’äºŒ\r\n',0),(84371,2344,'sv','Planera tvÃ¥',0),(84372,2344,'it','Piano due',0),(84373,2344,'tl','',0),(84374,2344,'th','&#3649;&#3612;&#3609;&#3626;&#3629;&#3591;',0),(84375,2344,'hi','à¤¦à¥‹ à¤¯à¥‹à¤œà¤¨à¤¾',0),(84376,2344,'ms','Merancang dua',0),(84377,2344,'ar','Ø§Ù„Ø®Ø·Ø© Ø§Ù„Ø«Ø§Ù†ÙŠØ©',0),(84378,2344,'fr','Plan de deux',0),(84379,2344,'jp','ãƒ—ãƒ©ãƒ³ã€€ï¼’',0),(84380,2344,'pt','Plano dois',0),(84381,2344,'ru','ÐŸÐ»Ð°Ð½ 2',0),(84382,2344,'es','Plan Dos',0),(84383,2344,'de','Plan zwei',0),(84384,2344,'en','Plan Two',0),(84385,2345,'is','',0),(84386,2345,'dr','Ù…Ø­Ù„ Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡',0),(84387,2345,'pr','Ù…Ø­Ù„ Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡',0),(84388,2345,'tr','Bitki Mekanlar',0),(84389,2345,'pl','Lokalizacje produkcji',0),(84390,2345,'bg','Ð Ð°ÑÑ‚Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¼ÐµÑÑ‚Ð°',0),(84391,2345,'ur','Ù¾Ù„Ø§Ù†Ù¹ Ú©Û’ Ù…Ù‚Ø§Ù…Ø§Øª',0),(84392,2345,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° ÐµÐ»ÐµÐºÑ‚Ñ€Ð°Ð½Ðµ',0),(84393,2345,'vi','Vá»‹ trÃ­ nhÃ  mÃ¡y',0),(84394,2345,'af','Plant liggings',0),(84395,2345,'ro','LocaÅ£ii de plante',0),(84396,2345,'et','Taimede asukohad',0),(84397,2345,'si','Obrat lokacijah',0),(84398,2345,'ba','Lokasi pabrik',0),(84399,2345,'nl','Plant locaties',0),(84400,2345,'fi','Kasvi sijainnit',0),(84401,2345,'no','Anlegget steder',0),(84402,2345,'da','Plante steder',0),(84403,2345,'ko','ê³µìž¥ ìœ„ì¹˜',0),(84404,2345,'he','×¦×ž×— ×ž×™×§×•×ž×™×',0),(84405,2345,'el','Î¦Ï…Ï„ÏŒ Î¸Î­ÏƒÎµÎ¹Ï‚',0),(84406,2345,'zh','å·¥åŽ‚ä½ç½®\r\n',0),(84407,2345,'sv','AnlÃ¤ggningen platser',0),(84408,2345,'it','Pianta posizioni',0),(84409,2345,'tl','',0),(84410,2345,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3650;&#3619;&#3591;&#3591;&#3634;&#3609;&#3629;&#3640;&#3605;&#3626;&#3634;&#3627;&#3585;&#3619;&#3619;&#3617;',0),(84411,2345,'hi','à¤¸à¤‚à¤¯à¤‚à¤¤à¥à¤° à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚',0),(84412,2345,'ms','Lokasi loji',0),(84413,2345,'ar','Ù…ÙˆØ§Ù‚Ø¹ Ù…ØµÙ†Ø¹',0),(84414,2345,'fr','Lieux d\'usine',0),(84415,2345,'jp','å·¥å ´æ‰€åœ¨åœ°',0),(84416,2345,'pt','Locais de planta',0),(84417,2345,'ru','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð·Ð°Ð²Ð¾Ð´Ð°',0),(84418,2345,'es','Ubicaciones de FÃ¡brica',0),(84419,2345,'de','Pflanze-Standorte',0),(84420,2345,'en','Plant Locations',0),(84421,2346,'is','',0),(84422,2346,'dr',':  Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚Ù„Ù… = 2    Ù†ÙˆØ¹=   ØªØ§Ù‡Ù…Ø§    Ø±Ù†Ú¯ = Ù‚Ø±Ù…Ø²  Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ØªÙ…Ø§Ù… Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ØªÙ†Ø¸ÙŠÙ… Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² Ø¯Ø³ØªÙŠØ§Ø¨ÙŠ Ø¨Ù‡ Ù…Ù†Ùˆ  ÙƒØ§Ù…Ù„ ÙƒÙ†ÙŠØ¯ . Ù„Ø·ÙØ§ Ú¯Ø²ÙŠÙ†Ù‡  Ø¬Ø¯Ø§ÙˆÙ„ Ø­Ø³Ø§Ø¨Ù‡Ø§ Ø±Ø§ Ø¯',0),(84423,2346,'pr','Ù„Ø·ÙØ§  :  Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚Ù„Ù… = 2    Ù†ÙˆØ¹=   ØªØ§Ù‡Ù…Ø§    Ø±Ù†Ú¯ = Ù‚Ø±Ù…Ø²  Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ØªÙ…Ø§Ù… Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ØªÙ†Ø¸ÙŠÙ… Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² Ø¯Ø³ØªÙŠØ§Ø¨ÙŠ Ø¨Ù‡ Ù…Ù†Ùˆ  ÙƒØ§Ù…Ù„ ÙƒÙ†ÙŠØ¯ . Ù„Ø·ÙØ§ Ú¯Ø²ÙŠÙ†Ù‡  Ø¬Ø¯Ø§ÙˆÙ„ Ø­Ø³Ø§Ø¨Ù‡Ø§ Ø±Ø§ Ø¯Ø',0),(84424,2346,'tr','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>YukarÄ±daki menÃ¼den eriÅŸmeden Ã¶nce tÃ¼m kurulum bÃ¶lÃ¼mleri tamamlamanÄ±z gerekir.<br><br><i>LÃ¼tfen ilk hesap bÃ¶lÃ¼mÃ¼ tamamlayÄ±n.</i></font>',0),(84425,2346,'pl','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Wszystkie odcinki instalacji naleÅ¼y wykonaÄ‡ przed uzyskaniem dostÄ™pu do menu powyÅ¼ej.<br><br><i>ProszÄ™ wypeÅ‚niÄ‡ po raz pierwszy w sekcji Plan kont!</i></font>',0),(84426,2346,'bg','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ð¼ÐµÐ½ÑŽÑ‚Ð¾ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ.<br><br><i>ÐœÐ¾Ð»Ñ, Ð¿Ð¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ Ñ€Ð°Ð·Ð´ÐµÐ» Ð¾Ñ‚ ÑÐ¼ÐµÑ‚ÐºÐ¾',0),(84427,2346,'ur','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Ø¢Ù¾ Ú©Ùˆ Ù…ÛŒÙ†ÛŒÙˆ Ú©Û’ Ø¨Ø§Ù„Ø§ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ø­Ø§ØµÙ„ Ú©Ø±Ù†Û’ Ø³Û’ Ù¾ÛÙ„Û’ Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Û’ ØªÙ…Ø§Ù… Ø´Ø¹Ø¨ÙˆÚº Ù…Ú©Ù…Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’ Û”<br><br><i>Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ú©Û’ Ú†Ø§Ø±Ù¹ Ú©Û’ Ø§Ú©Ø',0),(84428,2346,'sr','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ð¿ÑƒÐ½Ð¸Ñ‚Ð¸ ÑÐ²Ð° Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐ° ÑÐµÐºÑ†Ð¸Ñ˜Ðµ Ð¿Ñ€Ðµ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð°ÑšÐ° Ñƒ Ð¼ÐµÐ½Ð¸Ñ˜Ñƒ Ð¸Ð·Ð½Ð°Ð´.<br><br><i>ÐŸÑ€Ð²Ð¾ , Ð¸ÑÐ¿ÑƒÐ½Ð¸Ñ‚Ðµ Ð¾Ð´ÐµÑ™ÐºÑƒ ÐºÐ¾Ð½Ñ‚Ð½Ð¸ Ð¿Ð»Ð°Ð½!</i></fo',0),(84429,2346,'vi','Báº¡n pháº£i hoÃ n táº¥t pháº§n setup trÆ°á»›c khi truy cáº­p trÃ¬nh Ä‘Æ¡n trÃªn.<i>Vui lÃ²ng hoÃ n táº¥t pháº§n biá»ƒu Ä‘á»“ TK trÆ°á»›c!</i>',0),(84430,2346,'af','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Jy moet voltooi alle afdelings van die opstelling voor toegang tot die bostaande spyskaart.<br><br><i>Voltooi asseblief die tabel van rekeninge afdeling eerste!</i></font>',0),(84431,2346,'ro','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>ÃŽnainte de a accesa meniul de mai sus, trebuie sÄƒ completaÅ£i toate secÅ£iunile de configurare.<br><br><i>VÄƒ rugÄƒm sÄƒ completaÅ£i secÅ£iunea de conturi Ã®n primul rÃ¢nd!</i></font>',0),(84432,2346,'et','<br>Te peate eelnevalt hÃ¤Ã¤lestama oma ettevÃµtte seadistused, kui saate hakata programmi kasutama.<br><br><i>Palun seadistage kÃµigepealt kontoplaan!</i>',0),(84433,2346,'si','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Vsi oddelki namestitev morate dokonÄati pred dostopom do menija zgoraj.<br><br><i>Prosimo, izpolnite oddelek Kontni naÄrt prvi!</i></font>',0),(84434,2346,'ba','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Anda harus menyelesaikan semua bagian pengaturan sebelum mengakses menu di atas.<br><br><i>Harap lengkapi bagian Chart of account pertama!</i></font>',0),(84435,2346,'nl','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>U moet alle setup secties voltooien voordat toegang tot het menu hierboven.<br><br><i>Vul de sectie van het rekeningschema eerst!</i></font>',0),(84436,2346,'fi','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Kaikki asetukset osastot on tÃ¤ytettÃ¤vÃ¤ ennen kÃ¤yttÃ¶Ã¤ valikosta.<br><br><i>Ensin tÃ¤yttÃ¤mÃ¤Ã¤n Tilikartta-osiossa!</i></font>',0),(84437,2346,'no','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Du mÃ¥ fullfÃ¸re alle oppsett inndelinger fÃ¸r du Ã¥pner menyen ovenfor.<br><br><i>Fyll delen av fÃ¸rst!</i></font>',0),(84438,2346,'da','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Du skal udfylde alle setup sektioner fÃ¸r adgang til menuen ovenfor.<br><br><i>Udfyld venligst afsnittet kontoplan fÃ¸rst!</i></font>',0),(84439,2346,'ko','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>ìœ„ì˜ ë©”ë‰´ì— ì•¡ì„¸ìŠ¤ í•˜ê¸° ì „ì— ëª¨ë“  ì„¤ì¹˜ ì„¹ì…˜ì„ ì™„ë£Œ í•´ì•¼ í•©ë‹ˆë‹¤.<br><br><i>ì°¨íŠ¸ì˜ ê³„ì • ì„¹ì…˜ì„ ë¨¼ì € ì™„ë£Œ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤!</i></font>',0),(84440,2346,'he','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>×¢×œ×™×š ×œ×”×©×œ×™× ×›×œ ×”×ž×§×˜×¢×™× ×”×”×ª×§× ×” ×œ×¤× ×™ ×œ×’×©×ª ×œ×ª×¤×¨×™×˜ ×œ×¢×™×œ.<br><br><i>× × ×œ×”×©×œ×™× ×‘×—×œ×§ ×”×ª×¨×©×™× ×©×œ ×—×©×‘×•× ×•×ª ×§×•×“×!</i></font>',0),(84441,2346,'el','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÏƒÎµÏ„Îµ ÏŒÎ»Î± Ï„Î± Ï„Î¼Î®Î¼Î±Ï„Î± ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÏ„Î¿ Î¼ÎµÎ½Î¿Ï Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰.<br><br><i>Î Î±ÏÎ±ÎºÎ±Î»ÎµÎ¯ÏƒÎ¸Îµ Î½Î±',0),(84442,2346,'zh','æ‚¨è®¿é—®ä¸Šé¢èœå•ä¹‹å‰ï¼Œå¿…é¡»å®Œæˆæ‰€æœ‰è®¾ç½®é€‰é¡¹ã€‚ <i>è¯·é¦–å…ˆå®Œæˆå¸æˆ·éƒ¨åˆ†å›¾è¡¨ï¼â€œ\r\n',0),(84443,2346,'sv','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Du mÃ¥ste slutfÃ¶ra alla setup sektioner innan menyn ovan.<br><br><i>Fyll avsnittet Kontoplan fÃ¶rst!</i></font>',0),(84444,2346,'it','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Ãˆ necessario completare tutte le sezioni di configurazione prima di accedere al menu in alto.<br><br><i>Si prega di compilare la sezione del piano dei conti prima!</i></font>',0),(84445,2346,'tl','',0),(84446,2346,'th','<font size=2 type=tahoma color=red><br>You must complete all setup sections before accessing the menu above.<br><br><i>Please complete the Chart of Accounts section first!</font></i>',0),(84447,2346,'hi','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>à¤†à¤ª à¤‡à¤¸à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤®à¥‡à¤¨à¥‚ à¤¤à¤• à¤ªà¤¹à¥à¤à¤šà¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¥‡ à¤¸à¤­à¥€ à¤µà¤°à¥à¤—à¥‹à¤‚ à¤•à¥‹ à¤ªà¥‚à¤°à¤¾ à¤•à¤°à¤¨à¤¾ à¤¹à',0),(84448,2346,'ms','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Sila lengkapkan semua bahagian Persediaan sebelum mengakses menu di atas.<br><br><i>Sila lengkapkan bahagian Carta akaun pertama!</i></font>',0),(84449,2346,'ar','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥ÙƒÙ…Ø§Ù„ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…Ù‚Ø§Ø·Ø¹ Ù‚Ø¨Ù„ Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø£Ø¹Ù„Ø§Ù‡.<br><br><i>Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥ÙƒÙ…Ø§Ù„ Ø§Ù„Ù…Ù‚Ø·Ø¹ \"Ù…Ø®Ø·Ø· Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª\" Ø£ÙˆÙ„Ø§Ù‹!</i>',0),(84450,2346,'fr','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Vous devez remplir toutes les sections de configuration avant d\'accÃ©der au menu ci-dessus.<br><br><i>Veuillez remplir la section comptable de premiÃ¨re !</i></font>',0),(84451,2346,'jp','<font size=2 type=tahoma color=red><br>ä¸Šã?®ãƒ¡ãƒ‹ãƒ¥ãƒ¼ã?«ã‚¢ã‚¯ã‚»ã‚¹ã?™ã‚‹å‰?ã?«å…¨ã?¦ã?®è¨­å®šç®‡æ‰€ã‚’å®Œäº†ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“ã€‚<br><br><i>ã?¾ã?šæœ€åˆ?ã?«ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚»ã‚¯ã‚·ãƒ§ãƒ³ã?®ãƒ?ãƒ£ãƒ¼ãƒˆã‚’å®Œäº†ã?•ã?›ã?¦ã??ã? ã?•ã?„ã€‚</fo',0),(84452,2346,'pt','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>VocÃª deve completar todas as seÃ§Ãµes de configuraÃ§Ã£o antes de acessar o menu acima.<br><br><i>Por favor, preencha a seÃ§Ã£o do plano de contas primeiro!</i></font>',0),(84453,2346,'ru','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð·Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð²ÑÐµ ÑÐµÐºÑ†Ð¸Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð¿ÐµÑ€ÐµÐ´ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð¾Ð¼ Ðº Ð¼ÐµÐ½ÑŽ Ð²Ñ‹ÑˆÐµ.<br><br><i>ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð·Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ð´ÐµÐ» ÑÑ‡ÐµÑ‚Ð¾Ð²!</i></f',0),(84454,2346,'es','<tamaÃ±o de fuente=2 fuente=tahoma color=rojo>Tiene cumplir con todas las secciones de configuraciÃ³n antes que accesar el menÃº arriba.<br><br><i>Por favor completar la secciÃ³n de CatÃ¡logo de Cuentas primero!</fuente></i>',0),(84455,2346,'de','<font size=\"2\" type=\"tahoma\" color=\"red\"><br>Allen Bereichen der Einrichtung muss vor dem Zugriff auf das MenÃ¼ oben abgeschlossen werden.<br><br><i>Bitte fÃ¼llen Sie den Kontenplan-Abschnitt zuerst!</i></font>',0),(84456,2346,'en','<font size=2 type=tahoma color=red><br>You must complete all setup sections before accessing the menu above.<br><br><i>Please complete the Chart of Accounts section first!</font></i>',0),(84457,2347,'is','',0),(84458,2347,'dr','Ù„Ø·ÙØ§ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø±Ø³ÙŠ Ùˆ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†ÙŠØ¯ ',0),(84459,2347,'pr','Ù„Ø·ÙØ§ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø±Ø³ÙŠ Ùˆ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†ÙŠØ¯ ',0),(84460,2347,'tr','LÃ¼tfen kontrol edin ve verileri doÄŸrulayÄ±n.',0),(84461,2347,'pl','ProszÄ™ sprawdziÄ‡ i potwierdziÄ‡ dane.',0),(84462,2347,'bg','ÐœÐ¾Ð»Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¸ Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ.',0),(84463,2347,'ur','Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ú©ÙˆØ§Ø¦Ù Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ú©Ø±ÛŒÚº Û”',0),(84464,2347,'sr','ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ.',0),(84465,2347,'vi','Vui lÃ²ng kiá»ƒm tra & xÃ¡c nháº­n dá»¯ liá»‡u',0),(84466,2347,'af','Kontroleer asseblief en data bevestig.',0),(84467,2347,'ro','VÄƒ rugÄƒm sÄƒ verificaÅ£i ÅŸi confirmaÅ£i datele.',0),(84468,2347,'et','Kontrollida ning kinnitada andmed.',0),(84469,2347,'si','Prosim preveri in potrdi podatke.',0),(84470,2347,'ba','Silakan periksa dan mengkonfirmasi data.',0),(84471,2347,'nl','Controleer en bevestig gegevens.',0),(84472,2347,'fi','Tarkista ja Vahvista tiedot.',0),(84473,2347,'no','Sjekk og bekrefte dataene.',0),(84474,2347,'da','Venligst kontrollere og bekrÃ¦fte data.',0),(84475,2347,'ko','í™•ì¸ í•˜ ê³  ë°ì´í„°ë¥¼ í™•ì¸ í•˜ì‹­ì‹œì˜¤.',0),(84476,2347,'he','×× × ×‘×“×•×§ ×•××©×¨ × ×ª×•× ×™×.',0),(84477,2347,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ»Î­Î³Î¾Ï„Îµ ÎºÎ±Î¹ ÎµÏ€Î¹ÎºÏ…ÏÏŽÏƒÏ„Îµ Î´ÎµÎ´Î¿Î¼Î­Î½Î±.',0),(84478,2347,'zh','è¯·æ£€æŸ¥å¹¶ç¡®è®¤æ•°æ®ã€‚\r\n',0),(84479,2347,'sv','Kontrollera och bekrÃ¤fta data.',0),(84480,2347,'it','Controllare e confermare i dati.',0),(84481,2347,'tl','',0),(84482,2347,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(84483,2347,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤¡à¥‡à¤Ÿà¤¾ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚à¥¤',0),(84484,2347,'ms','Sila semak dan mengesahkan data.',0),(84485,2347,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„ØªØ­Ù‚Ù‚ ÙˆØ§Ù„ØªØ£ÙƒØ¯ Ù…Ù† Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(84486,2347,'fr','S\'il vous plaÃ®t vÃ©rifier et confirmer les donnÃ©es.',0),(84487,2347,'jp','ãƒ‡ãƒ¼ã‚¿ã‚’ç¢ºèª?ã?—ã?¦ã??ã? ã?•ã?„',0),(84488,2347,'pt','Por favor verificar e confirmar os dados.',0),(84489,2347,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð¸ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ.',0),(84490,2347,'es','Por favor checar y confirmar los datos',0),(84491,2347,'de','Bitte Ã¼berprÃ¼fen und bestÃ¤tigen von Daten.',0),(84492,2347,'en','Please check and confirm data.',0),(84493,2348,'is','',0),(84494,2348,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ù…Ø¹ØªØ¨Ø± Ø¨Ø±Ø§ÙŠ Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµÙØ­Ù‡ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(84495,2348,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ù…Ø¹ØªØ¨Ø± Ø¨Ø±Ø§ÙŠ Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµÙØ­Ù‡ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(84496,2348,'tr','LÃ¼tfen sayfa boyutu iÃ§in geÃ§erli bir sayÄ± girin.',0),(84497,2348,'pl','WprowadÅº prawidÅ‚owy numer rozmiar strony.',0),(84498,2348,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€Ð° Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð°.',0),(84499,2348,'ur','ØµÙØ­Û Ø³Ø§Ø¦Ø² Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ø¬Ø§Ø¦Ø² Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(84500,2348,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð²Ð°Ð¶ÐµÑ›Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð·Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ.',0),(84501,2348,'vi','Vui lÃ²ng nháº­p tÃªn cÃ³ hiá»‡u lá»±c cho cá»¡ trang',0),(84502,2348,'af','Voer asblief \'n geldige syfer vir dei bladsy-grootte in.',0),(84503,2348,'ro','Va rugam introduceti un numar valabil pentru dimensiunea.',0),(84504,2348,'et','Palun sisesta Ãµige formaat lehe suuruse mÃ¤Ã¤ramiseks',0),(84505,2348,'si','Vnesite veljavno Å¡tevilko za velikost strani.',0),(84506,2348,'ba','Silakan masukkan nomor yang valid untuk ukuran halaman.',0),(84507,2348,'nl','Voer een geldige waarde voor het paginaformaat.',0),(84508,2348,'fi','Kirjoita kelvollinen sivun koko.',0),(84509,2348,'no','Skriv inn et gyldig tall for sidestÃ¸rrelsen.',0),(84510,2348,'da','Angiv et gyldigt tal for sidestÃ¸rrelsen.',0),(84511,2348,'ko','íŽ˜ì´ì§€ í¬ê¸°ì— ëŒ€ í•œ ì˜¬ë°”ë¥¸ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤.',0),(84512,2348,'he','× × ×”×–×Ÿ ×ž×¡×¤×¨ ×ª×§×£ ×¢×‘×•×¨ ×’×•×“×œ ×”×¢×ž×•×“.',0),(84513,2348,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ Î­Î³ÎºÏ…ÏÎ¿ Î±ÏÎ¹Î¸Î¼ÏŒ Î³Î¹Î± Ï„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Ï„Î·Ï‚ ÏƒÎµÎ»Î¯Î´Î±Ï‚.',0),(84514,2348,'zh','è¯·è¾“å…¥ä¸€ä¸ªæœ‰æ•ˆæ•°å­—ç”¨ä½œé¡µé¢å¤§å°ã€‚\r\n',0),(84515,2348,'sv','VÃ¤nligen ange ett giltigt nummer fÃ¶r sidstorlek.',0),(84516,2348,'it','Inserisci un numero valido per le dimensioni della pagina.',0),(84517,2348,'tl','',0),(84518,2348,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3611;&#3657;&#3629;&#3609;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3586;&#3609;&#3634;&#3604;&#3627;&#3',0),(84519,2348,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥ƒà¤·à¥à¤  à¤†à¤•à¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤®à¤¾à¤¨à¥à¤¯ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(84520,2348,'ms','Sila masukkan nombor yang sah untuk saiz halaman.',0),(84521,2348,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø¹Ø¯Ø¯ ØµØ­ÙŠØ­ Ù„Ø­Ø¬Ù… Ø§Ù„ØµÙØ­Ø©.',0),(84522,2348,'fr','Veuillez entrer un numÃ©ro valide pour la taille de la page.',0),(84523,2348,'jp','ãƒšãƒ¼ã‚¸ã‚µã‚¤ã‚ºã?«ã?¯æœ‰åŠ¹ã?ªæ•°å­—ã‚’å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(84524,2348,'pt','Por favor, insira um nÃºmero vÃ¡lido para o tamanho da pÃ¡gina.',0),(84525,2348,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ Ð´Ð»Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹.',0),(84526,2348,'es','Por favor ingresar un nÃºmero vÃ¡lido para el tamaÃ±o de la pÃ¡gina',0),(84527,2348,'de','Bitte geben Sie eine gÃ¼ltige Zahl fÃ¼r die SeitengrÃ¶ÃŸe.',0),(84528,2348,'en','Please enter a valid number for the page size.',0),(84529,2349,'is','',0),(84530,2349,'dr','Ù„Ø·ÙØ§ ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø±Ø§ Ù¾Ø± ÙƒÙ†ÙŠØ¯ ',0),(84531,2349,'pr','Ù„Ø·ÙØ§ ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø±Ø§ Ù¾Ø± ÙƒÙ†ÙŠØ¯ ',0),(84532,2349,'tr','LÃ¼tfen tÃ¼m gerekli alanlarÄ± doldurun',0),(84533,2349,'pl','WypeÅ‚nij wszystkie wymagane pola',0),(84534,2349,'bg','ÐœÐ¾Ð»Ñ, Ð¿Ð¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(84535,2349,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ØªÙ…Ø§Ù… Ù…Ø·Ù„ÙˆØ¨Û Ù‚Ø·Ø¹Ø§Øª Ø¨Ø§ÛØ± Ø¨Ú¾Ø±ÛŒÚº',0),(84536,2349,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° Ð¿Ð¾Ð¿ÑƒÐ½Ð¸Ñ‚Ðµ ÑÐ²Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð¿Ð¾Ñ™Ð°',0),(84537,2349,'vi','Vui lÃ²ng Ä‘iá»n vÃ o táº¥t cáº£ cÃ¡c trÆ°á»ng yÃªu cáº§u',0),(84538,2349,'af','Vul Asseblief Alle Benodigde Velde In',0),(84539,2349,'ro','Va rugam sa completati toate campurile necesare',0),(84540,2349,'et','Palun tÃ¤ida kÃµik nÃµutud vÃ¤ljad',0),(84541,2349,'si','Izpolnite vsa zahtevana polja',0),(84542,2349,'ba','Silahkan mengisi semua bidang yang wajib',0),(84543,2349,'nl','Vul alle vereiste velden',0),(84544,2349,'fi','TÃ¤ytÃ¤ kaikki pakolliset kentÃ¤t',0),(84545,2349,'no','Fyll ut alle obligatoriske felt',0),(84546,2349,'da','Udfyld venligst alle nÃ¸dvendige felter',0),(84547,2349,'ko','í•„ìš”í•œ ëª¨ë“  í•„ë“œë¥¼ ê¸°ìž… í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(84548,2349,'he','× × ×œ×ž×œ× ××ª ×›×œ ×”×©×“×•×ª ×”× ×“×¨×©×™×',0),(84549,2349,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÏƒÏ„Îµ ÏŒÎ»Î± Ï„Î± Î±Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½Î± Ï€ÎµÎ´Î¯Î±',0),(84550,2349,'zh','è¯·å¡«å†™æ‰€æœ‰å¿…å¡«å­—æ®µ\r\n',0),(84551,2349,'sv','Fyll i alla obligatoriska fÃ¤lt',0),(84552,2349,'it','Si prega di compilare tutti i campi richiesti',0),(84553,2349,'tl','',0),(84554,2349,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3639;&#3656;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(84555,2349,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¤­à¥€ à¤†à¤µà¤¶à¥à¤¯à¤• à¤«à¤¼à¥€à¤²à¥à¤¡ à¤­à¤°à¥‡à¤‚',0),(84556,2349,'ms','Sila isi semua bidang',0),(84557,2349,'ar','ÙŠØ±Ø¬Ù‰ Ù…Ù„Ø¡ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© ÙƒÙ„Ù‡Ø§',0),(84558,2349,'fr','Merci de remplir tous les champs obligatoires',0),(84559,2349,'jp','ã?™ã?¹ã?¦ã?®å¿…è¦?ã?ªãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã?«å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(84560,2349,'pt','Por favor, preencha os campos necessÃ¡rios',0),(84561,2349,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð·Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚Ðµ Ð²ÑÐµ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¿Ð¾Ð»Ñ',0),(84562,2349,'es','Por Favor Llenar Todos Los Campos Requeridos',0),(84563,2349,'de','Bitte fÃ¼llen Sie alle Pflichtfelder',0),(84564,2349,'en','Please Fill Out All Required Fields',0),(84565,2350,'is','',0),(84566,2350,'dr','Ù„Ø·ÙØ§ Ø¨Ø§Ø²Ú¯Ø±Ø¯ÙŠØ¯ Ùˆ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(84567,2350,'pr','Ù„Ø·ÙØ§ Ø¨Ø§Ø²Ú¯Ø±Ø¯ÙŠØ¯ Ùˆ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(84568,2350,'tr','LÃ¼tfen geri dÃ¶nÃ¼n ve verilerinizi kontrol edin.',0),(84569,2350,'pl','ProszÄ™ wrÃ³ciÄ‡ i sprawdziÄ‡ swoje dane.',0),(84570,2350,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÑ€Ð½ÐµÑ‚Ðµ Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ ÑÐ¸.',0),(84571,2350,'ur','ÙˆØ§Ù¾Ø³ Ø¬Ø§Ø¦ÛŒÚº Ø§ÙˆØ± Ø§Ù¾Ù†Û’ Ú©ÙˆØ§Ø¦Ù Ú©ÛŒ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº Û”',0),(84572,2350,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð²Ñ€Ð°Ñ‚Ð¸ ÑÐµ Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸ Ð²Ð°ÑˆÐµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ.',0),(84573,2350,'vi','Quay láº¡i & kiá»ƒm tra dá»¯ liá»‡u',0),(84574,2350,'af','Gaan asseblief terug en kontroleer u data.',0),(84575,2350,'ro','VÄƒ rugÄƒm sÄƒ mergeÅ£i Ã®napoi ÅŸi verifica datele dvs.',0),(84576,2350,'et','Palun logi panka sisse ja kontrolli andmeid',0),(84577,2350,'si','Prosim pojdite nazaj in preverite vaÅ¡e podatke.',0),(84578,2350,'ba','Silakan kembali dan memeriksa data Anda.',0),(84579,2350,'nl','Ga terug en controleer uw gegevens.',0),(84580,2350,'fi','Mene takaisin ja tarkista tiedot.',0),(84581,2350,'no','Vennligst gÃ¥ tilbake og sjekke dataene.',0),(84582,2350,'da','GÃ¥ tilbage og tjekke dine data.',0),(84583,2350,'ko','ë‹¤ì‹œ ì´ë™ í•˜ ê³  ë°ì´í„°ë¥¼ í™•ì¸ í•˜ì‹­ì‹œì˜¤.',0),(84584,2350,'he','×‘×‘×§×©×” ×œ×—×–×•×¨ ×•×œ×‘×“×•×§ ××ª ×”× ×ª×•× ×™× ×©×œ×š.',0),(84585,2350,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹ÏƒÏ„ÏÎ­ÏˆÏ„Îµ ÎºÎ±Î¹ ÎµÎ»Î­Î³Î¾Ï„Îµ Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± ÏƒÎ±Ï‚.',0),(84586,2350,'zh','è¯·è¿”å›žå¹¶æ£€æŸ¥æ‚¨çš„æ•°æ®\r\n',0),(84587,2350,'sv','GÃ¥ tillbaka och kontrollera dina data.',0),(84588,2350,'it','Si prega di tornare indietro e controllare i vostri dati.',0),(84589,2350,'tl','',0),(84590,2350,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3606;&#3629;&#3618;&#3585;&#3621;&#3633;&#3610;&#3649;&#3621;&#3632;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(84591,2350,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤µà¤¾à¤ªà¤¸ à¤œà¤¾à¤à¤ à¤”à¤° à¤…à¤ªà¤¨à¥‡ à¤¡à¥‡à¤Ÿà¤¾ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚à¥¤',0),(84592,2350,'ms','Sila kembali dan semak data anda.',0),(84593,2350,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„Ø°Ù‡Ø§Ø¨ Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ±Ø§Ø¡ØŒ ÙˆØ§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(84594,2350,'fr','Veuillez revenir en arriÃ¨re et vÃ©rifier vos donnÃ©es.',0),(84595,2350,'jp','æˆ»ã?£ã?¦ãƒ‡ãƒ¼ã‚¿ã‚’ç¢ºèª?ã?—ã?¦ã??ã? ã?•ã?„',0),(84596,2350,'pt','Por favor, volte e verifique seus dados.',0),(84597,2350,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²ÐµÑ€Ð½Ð¸Ñ‚ÐµÑÑŒ Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð²Ð°ÑˆÐ¸ Ð´Ð°Ð½Ð½Ñ‹Ðµ.',0),(84598,2350,'es','Por favor regresar y checar todo sus datos',0),(84599,2350,'de','Bitte gehen Sie zurÃ¼ck und Ã¼berprÃ¼fen Sie Ihre Daten.',0),(84600,2350,'en','Please go back and check your data.',0),(84601,2351,'is','',0),(84602,2351,'dr','Ù„Ø·ÙØ§ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹Ù‰ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ Ø¬Ù‡Øª Ø§Ø¯Ø§Ù…Ù‡ ',0),(84603,2351,'pr','Ù„Ø·ÙØ§ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹Ù‰ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ Ø¬Ù‡Øª Ø§Ø¯Ø§Ù…Ù‡ ',0),(84604,2351,'tr','LÃ¼tfen devam etmek iÃ§in sosyal gÃ¼venlik veya Govt kimlik numarasÄ±nÄ± iÃ§erir.',0),(84605,2351,'pl','Prosimy o podanie numeru ubezpieczenia spoÅ‚ecznego lub Govt ID aby kontynuowaÄ‡.',0),(84606,2351,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ ÑÐ¾Ñ†Ð¸Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€ÑÐ²Ð°Ð½Ðµ Ð¸Ð»Ð¸ Govt Ð˜Ð” Ð½Ð¾Ð¼ÐµÑ€, Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸Ñ‚Ðµ.',0),(84607,2351,'ur','Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø³ÙˆØ´Ù„ Ø³Ú©ÛŒÙˆØ±Ù¹ÛŒ ÛŒØ§ Ø­Ú©ÙˆÙ…Øª Ø´Ù†Ø§Ø®Øª Ù†Ù…Ø¨Ø± Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”',0),(84608,2351,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð±Ñ€Ð¾Ñ˜ ÑÐ¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾Ð³ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ° Ð¸Ð»Ð¸ Ð“Ð¾Ð²Ñ‚ Ð˜Ð” Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸.',0),(84609,2351,'vi','Vui lÃ²ng bao gá»“m Sá»‘ An Sinh XÃ£ Há»™i Ä‘á»ƒ tiáº¿p tá»¥c',0),(84610,2351,'af','Sluit asseblief maatskaplike sekuriteit of Govt ID nommer om voort te gaan.',0),(84611,2351,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i numÄƒrul de securitate socialÄƒ sau guvern ID pentru a continua.',0),(84612,2351,'et','* Palun lisa sotsiaalkindlustuse number',0),(84613,2351,'si','Prosimo, da vkljuÄite Å¡e socialne varnosti ali Govt ID Å¡tevilko.',0),(84614,2351,'ba','Harap sertakan nomor jaminan sosial atau ID pemerintah untuk melanjutkan.',0),(84615,2351,'nl','Gelieve te omvatten sociale zekerheid of Govt ID nummer om door te gaan.',0),(84616,2351,'fi','LiitÃ¤ mukaan sosiaaliturva- tai Govt ID numero jatkaa.',0),(84617,2351,'no','Vennligst oppgi personnummer eller Govt ID for Ã¥ fortsette.',0),(84618,2351,'da','Behage omfatte Social sikring eller Govt ID nummer for at fortsÃ¦tte.',0),(84619,2351,'ko','ê³„ì† ì‚¬íšŒ ë³´ìž¥ ë˜ëŠ” ì •ë¶€ ID ë²ˆí˜¸ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤.',0),(84620,2351,'he','×× × ×¦×™×™× ×• ×ž×¡×¤×¨ ×‘×™×˜×•×— ×œ××•×ž×™ ××• ×ž×–×”×” Govt ×›×“×™ ×œ×”×ž×©×™×š.',0),(84621,2351,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÎºÎ®Ï‚ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚ Î® Govt ID Î½Î± ÏƒÏ…Î½ÎµÏ‡Î¯ÏƒÎµÎ¹.',0),(84622,2351,'zh','è¯·åº“å°”æœ‰ç¤¾ä¼šä¿éšœä»¥ç»§ç»­ã€‚\r\n',0),(84623,2351,'sv','VÃ¤nligen inkludera Social trygghet eller prop ID nummer att fortsÃ¤tta.',0),(84624,2351,'it','Si prega di includere numero di sicurezza sociale o Govt ID per continuare.',0),(84625,2351,'tl','',0),(84626,2351,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3',0),(84627,2351,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤œà¤¾à¤°à¥€ à¤°à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤®à¤¾à¤œà¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤¯à¤¾ à¤¸à¤°à¤•à¤¾à¤° à¤†à¤ˆà¤¡à¥€ à¤¨à¤‚à¤¬à¤° à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚à¥¤',0),(84628,2351,'ms','Sila sertakan nombor keselamatan sosial atau ID Kerajaan terus.',0),(84629,2351,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† Ø±Ù‚Ù… Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ø£Ùˆ Ù…Ø¹Ø±Ù Ø­ÙƒÙˆÙ…ÙŠ Ù„Ù„Ø§Ø³ØªÙ…Ø±Ø§Ø±.',0),(84630,2351,'fr','S\'il vous plaÃ®t inclure numÃ©ro de sÃ©curitÃ© sociale ou Govt ID pour continuer.',0),(84631,2351,'jp','ç¶šã?‘ã‚‹ã?«ã?¯ç¤¾ä¼šä¿?éšœã‚’å?«ã‚?ã?¦ã??ã? ã?•ã?„',0),(84632,2351,'pt','Por favor, inclua o nÃºmero de SeguranÃ§a Social ou Govt ID para continuar.',0),(84633,2351,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ ÑÐ¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ñ Ð¸Ð»Ð¸ ID Ð»ÐµÐ¹ Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð² Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð°Ñ‚ÑŒ.',0),(84634,2351,'es','Por favor incluir nÃºmero de Seguro Social para continuar',0),(84635,2351,'de','Bitte geben Sie soziale Sicherheit oder Govt ID-Nummer weiter.',0),(84636,2351,'en','Please include Social Security or Govt ID number to continue.',0),(84637,2352,'is','',0),(84638,2352,'dr','(Ù„Ø·ÙØ§ ØªØ®ÙÙŠÙ Ø¯Ù‡ÙŠØ¯ Ø¨Ù‡',0),(84639,2352,'pr','Ù„Ø·ÙØ§ ÙˆØ¬Ù‡ Ø±Ø§ Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯ Ø¨Ù‡ (Ù„Ø·ÙØ§ ØªØ®ÙÙŠÙ Ø¯Ù‡ÙŠØ¯ Ø¨Ù‡',0),(84640,2352,'tr','LÃ¼tfen iÃ§in havale et',0),(84641,2352,'pl','Prosimy o przekazanie do',0),(84642,2352,'bg','ÐœÐ¾Ð»Ñ ÑÐµ Ð¾Ñ‚Ð½Ð°ÑÑ Ð´Ð¾',0),(84643,2352,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ú©Ùˆ Ú†Ú¾ÙˆÚ‘Ù†Ø§',0),(84644,2352,'sr','Ð”Ð¾Ð·Ð½Ð°Ñ‡Ð¸Ñ‚Ðµ Ð´Ð°',0),(84645,2352,'vi','Vui lÃ²ng chuyá»ƒn khoáº£n vÃ o',0),(84646,2352,'af','Terugverwys Asseblief na',0),(84647,2352,'ro','VÄƒ rugÄƒm sÄƒ remitÄƒ la',0),(84648,2352,'et','Palun saata',0),(84649,2352,'si','Prosim pristojnosti',0),(84650,2352,'ba','Silakan mengirimkan ke',0),(84651,2352,'nl','Gelieve terugverwijzen naar',0),(84652,2352,'fi','Haluta palauttaa',0),(84653,2352,'no','Behage oversende til',0),(84654,2352,'da','Venligst henvise til',0),(84655,2352,'ko','ì— ì†¡ê¸ˆ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(84656,2352,'he','×‘×‘×§×©×” ××©××œ',0),(84657,2352,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Î½Î± Î±Î½Î±Ï€Î­Î¼ÏˆÎµÎ¹ ÏƒÏ„Î¿',0),(84658,2352,'zh','è¯·æ±‡è‡³\r\n',0),(84659,2352,'sv','VÃ¤nligen remittera till',0),(84660,2352,'it','Per favore rimettere a',0),(84661,2352,'tl','',0),(84662,2352,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3626;&#3656;&#3591;&#3648;&#3591;&#3636;&#3609;&#3652;&#3611;&#3651;&#3627;&#3657;',0),(84663,2352,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤°à¤¿à¤¹à¤¾à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(84664,2352,'ms','Sila membayar kepada',0),(84665,2352,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­ÙˆÙŠÙ„ Ø¥Ù„Ù‰',0),(84666,2352,'fr','S\'il vous plaÃ®t remettre au',0),(84667,2352,'jp','ï½žã?«é€?é‡‘ã?—ã?¦ã??ã? ã?•ã?„',0),(84668,2352,'pt','Por favor remeter para',0),(84669,2352,'ru','ÐŸÑ€Ð¾ÑÑŒÐ±Ð° Ð¿ÐµÑ€ÐµÑ‡Ð¸ÑÐ»ÑÑ‚ÑŒ',0),(84670,2352,'es','Por favor remitir a',0),(84671,2352,'de','Ãœberweisen Sie bitte an',0),(84672,2352,'en','Please remit to',0),(84673,2353,'is','',0),(84674,2353,'dr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø±Ø§ Ø¯Ø± Ø¨Ø§Ù„Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(84675,2353,'pr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø±Ø§ Ø¯Ø± Ø¨Ø§Ù„Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(84676,2353,'tr','Stok tipi yukarÄ±daki seÃ§iniz...',0),(84677,2353,'pl','ProszÄ™ wybraÄ‡ typ powyÅ¼ej...',0),(84678,2353,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð±Ð¾Ñ€ÑÐ¾Ð² Ñ‚Ð¸Ð¿ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ...',0),(84679,2353,'ur','Ø§Ø³Ù¹Ø§Ú© Ù‚Ø³Ù… Ù…Ø°Ú©ÙˆØ±Û Ø¨Ø§Ù„Ø§ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº...',0),(84680,2353,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¸Ð·Ð½Ð°Ð´ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ñ‚Ð¸Ð¿...',0),(84681,2353,'vi','Chá»n loáº¡i hÃ ng tá»“n trÃªn',0),(84682,2353,'af','Kies asseblief die voorraadtipe hierbo...',0),(84683,2353,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i tip stoc de mai sus...',0),(84684,2353,'et','Palun valige paberi tÃ¼Ã¼p eespool...',0),(84685,2353,'si','Izberite zalog tip zgoraj...',0),(84686,2353,'ba','Silakan pilih stock tipe di atas...',0),(84687,2353,'nl','Selecteer hierboven het soort promotievak voorraad...',0),(84688,2353,'fi','Valitse varaston laji edellÃ¤...',0),(84689,2353,'no','Velg lager ovenfor...',0),(84690,2353,'da','VÃ¦lg lager type ovenfor...',0),(84691,2353,'ko','ìŠ¤í†¡ ìœ í˜• ìœ„ì˜ ì„ íƒ í•˜ì‹­ì‹œì˜¤...',0),(84692,2353,'he','× × ×‘×—×¨ ×¡×•×’ ×”×ž× ×™×•×ª ×”×  ×œ...',0),(84693,2353,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Ï„ÏÏ€Î¿Ï‚ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰...',0),(84694,2353,'zh','è¯·é€‰æ‹©ä»¥ä¸Šè‚¡ç¥¨åž‹...\r\n',0),(84695,2353,'sv','VÃ¤lj lager typ ovan...',0),(84696,2353,'it','Si prega di selezionare tipo dipinga sopra...',0),(84697,2353,'tl','',0),(84698,2353,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3609;&#3629;&#3585;&#3652;&#3611;&#3585;&#3623;&#3656;&#3634;...',0),(84699,2353,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¶à¥‡à¤¯à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤‡à¤¸à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚...',0),(84700,2353,'ms','Sila pilih saham jenis di atas...',0),(84701,2353,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ù†ÙˆØ¹ Ø§Ù„Ø£Ø³Ù‡Ù… Ø£Ø¹Ù„Ø§Ù‡...',0),(84702,2353,'fr','Veuillez sÃ©lectionner ci-dessus stock type...',0),(84703,2353,'jp','ä¸Šã?®åœ¨åº«ã‚¿ã‚¤ãƒ—ã‚’é?¸æŠžã?—ã?¦ã??ã? ã?•ã?„',0),(84704,2353,'pt','Por favor, selecione o tipo de estoque acima...',0),(84705,2353,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑˆÑ‚Ð¾ÐºÐ° Ñ‚Ð¸Ð¿Ð° Ð²Ñ‹ÑˆÐµ...',0),(84706,2353,'es','Por favor seleccionar tipo de stock arriba...',0),(84707,2353,'de','Bitte wÃ¤hlen Sie oben Bestandsart...',0),(84708,2353,'en','Please select stock type above...',0),(84709,2354,'is','',0),(84710,2354,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù‡Ø²ÙŠÙ†Ù‡ Ø±Ø§ Ù…Ø´Ø®Øµ ÙƒÙ†ÙŠØ¯ ',0),(84711,2354,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù‡Ø²ÙŠÙ†Ù‡ Ø±Ø§ Ù…Ø´Ø®Øµ ÙƒÙ†ÙŠØ¯ ',0),(84712,2354,'tr','LÃ¼tfen bir maliyet belirtin',0),(84713,2354,'pl','ProszÄ™ podaÄ‡ koszt',0),(84714,2354,'bg','ÐœÐ¾Ð»Ñ, Ð¿Ð¾ÑÐ¾Ñ‡ÐµÑ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(84715,2354,'ur','Ù„Ø§Ú¯Øª Ú©Ø§ Ø§Ø®ØªØµØ§Øµ Ú©Ø±ÛŒÚº',0),(84716,2354,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° Ð½Ð°Ð²ÐµÐ´ÐµÑ‚Ðµ Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(84717,2354,'vi','Vui lÃ²ng chá»‰ Ä‘á»‹nh 1 chi phÃ­',0),(84718,2354,'af','Spesifeer Asseblief \'n Koste',0),(84719,2354,'ro','VÄƒ rugÄƒm sÄƒ specificaÅ£i un Cost',0),(84720,2354,'et','Palun tÃ¤psusta hind',0),(84721,2354,'si','Navedite stroÅ¡ek',0),(84722,2354,'ba','Silakan tentukan biaya',0),(84723,2354,'nl','Geef een kostprijs',0),(84724,2354,'fi','MÃ¤Ã¤ritÃ¤ kustannus',0),(84725,2354,'no','Angi en kostnad',0),(84726,2354,'da','Angiv en pris',0),(84727,2354,'ko','ë¹„ìš©ì„ ì§€ì • í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(84728,2354,'he','×× × ×¦×™×™×Ÿ ×¢×œ×•×ª',0),(84729,2354,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Ï€ÏÎ¿ÏƒÎ´Î¹Î¿ÏÎ¯ÏƒÎµÏ„Îµ Ï„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(84730,2354,'zh','è¯·æŒ‡å®šä¸€ä¸ªæˆæœ¬\r\n',0),(84731,2354,'sv','Ange en kostnad',0),(84732,2354,'it','Si prega di specificare un costo',0),(84733,2354,'tl','',0),(84734,2354,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3619;&#3632;&#3610;&#3640;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(84735,2354,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤²à¤¾à¤—à¤¤ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(84736,2354,'ms','Sila nyatakan kos',0),(84737,2354,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ ØªÙƒÙ„ÙØ©',0),(84738,2354,'fr','Veuillez prÃ©ciser un coÃ»t',0),(84739,2354,'jp','è²»ç”¨ã‚’ç‰¹å®šã?—ã?¦ã??ã? ã?•ã?„',0),(84740,2354,'pt','Por favor, especifique um custo',0),(84741,2354,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(84742,2354,'es','Por favor especificar un Cost',0),(84743,2354,'de','Bitte geben Sie einen Preis',0),(84744,2354,'en','Please specify a Cost',0),(84745,2355,'is','',0),(84746,2355,'dr','Ù„Ø·ÙØ§ Ø®ØµÙˆØµÙŠØª ØªØ¹ÙŠÙŠÙ† Ù…Ø±Ø² Ø±Ø§ Ù…Ø´Ø®Øµ ÙƒÙ†ÙŠØ¯ ',0),(84747,2355,'pr','Ù„Ø·ÙØ§ Ø®ØµÙˆØµÙŠØª ØªØ¹ÙŠÙŠÙ† Ù…Ø±Ø² Ø±Ø§ Ù…Ø´Ø®Øµ ÙƒÙ†ÙŠØ¯ ',0),(84748,2355,'tr','SÄ±nÄ±rlayÄ±cÄ± karakter',0),(84749,2355,'pl','Znak ogranicznika',0),(84750,2355,'bg','Ð—Ð° Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»',0),(84751,2355,'ur','ØªØ­Ø¯ÛŒØ¯ Ú©Ø§Ø± Ú©Ø±ÛŒÚ©Ù¹Ø±',0),(84752,2355,'sr','Ð—Ð½Ð°Ðº Ð·Ð° Ñ€Ð°Ð·Ð³Ñ€Ð°Ð½Ð¸Ñ‡Ð°Ð²Ð°ÑšÐµ',0),(84753,2355,'vi','KÃ½ tá»± dáº¥u tÃ¡ch',0),(84754,2355,'af','Skeidingsteken Karakter',0),(84755,2355,'ro','Caracterul separator',0),(84756,2355,'et','Eraldaja mÃ¤rk',0),(84757,2355,'si','Znak loÄila',0),(84758,2355,'ba','Pembatas karakter',0),(84759,2355,'nl','Scheidingsteken',0),(84760,2355,'fi','Erotin',0),(84761,2355,'no','Skilletegn',0),(84762,2355,'da','AfgrÃ¦nsningstegnet',0),(84763,2355,'ko','êµ¬ë¶„ ë¬¸ìž',0),(84764,2355,'he','×”×ª×• ×”×ž×¤×¨×™×“',0),(84765,2355,'el','Î§Î±ÏÎ±ÎºÏ„Î®ÏÎ±-Î¿ÏÎ¹Î¿Î¸Î­Ï„Î·',0),(84766,2355,'zh','åˆ†éš”ç¬¦\r\n',0),(84767,2355,'sv','AvgrÃ¤nsartecken',0),(84768,2355,'it','Carattere delimitatore',0),(84769,2355,'tl','',0),(84770,2355,'th','&#3592;&#3635;&#3585;&#3633;&#3604;&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3633;&#3623;&#3629;&#3633;&#3585;&#3625;&#3619;',0),(84771,2355,'hi','à¤¸à¥€à¤®à¤¾à¤‚à¤•à¤• à¤µà¤°à¥à¤£',0),(84772,2355,'ms','Ciri-ciri delimiter',0),(84773,2355,'ar','Ø­Ø±Ù Ù…Ø­Ø¯Ø¯',0),(84774,2355,'fr','CaractÃ¨re dÃ©limiteur',0),(84775,2355,'jp','åŒºåˆ‡ã‚Šæ–‡å­—',0),(84776,2355,'pt','Caractere delimitador',0),(84777,2355,'ru','Ð¡Ð¸Ð¼Ð²Ð¾Ð»-Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑŒ',0),(84778,2355,'es','CarÃ¡cter Delimitador',0),(84779,2355,'de','Trennzeichen',0),(84780,2355,'en','Delimiter Character',0),(84781,2356,'is','',0),(84782,2356,'dr','Ù„Ø·ÙØ§ Ø§ÙŠÙ† ÙÙŠÙ„Ø¯ Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†ÙŠØ¯ ',0),(84783,2356,'pr','Ù„Ø·ÙØ§ Ø§ÙŠÙ† ÙÙŠÙ„Ø¯ Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†ÙŠØ¯ ',0),(84784,2356,'tr','LÃ¼tfen bu alanÄ± doÄŸrula',0),(84785,2356,'pl','ProszÄ™ SprawdÅº to pole',0),(84786,2356,'bg','ÐœÐ¾Ð»Ñ ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐ²Ð°Ð¹ Ñ‚Ð¾Ð²Ð° Ð¿Ð¾Ð»Ðµ',0),(84787,2356,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§Ø³ Ù‚Ø·Ø¹Û’ Ú©Ø§ Ø¬ÙˆØ§Ø² Ø¯ÛŒÚº',0),(84788,2356,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸ Ð²Ð°Ñ™Ð°Ð½Ð¾ÑÑ‚ Ð¾Ð²Ð¾Ð³ Ð¿Ð¾Ñ™Ð°',0),(84789,2356,'vi','Vui lÃ²ng lÃ m hiá»‡u lá»±c trÆ°á»ng nÃ y',0),(84790,2356,'af','Maak hierdie veld asseblief geldig',0),(84791,2356,'ro','ValidaÈ›i acest cÃ¢mp',0),(84792,2356,'et','Palun kinnita vÃ¤i',0),(84793,2356,'si','Preverite veljavnost polju',0),(84794,2356,'ba','Harap validasi bidang ini',0),(84795,2356,'nl','Gelieve dit veld valideren',0),(84796,2356,'fi','Tarkista tÃ¤mÃ¤ kenttÃ¤',0),(84797,2356,'no','Behage bekrefte dette feltet',0),(84798,2356,'da','Please validere feltet',0),(84799,2356,'ko','ì´ í•„ë“œì˜ ìœ íš¨ì„±ì„ ê²€ì‚¬ í•˜ì‹­ì‹œì˜¤',0),(84800,2356,'he','× × ×œ××ž×ª ×©×“×” ×–×”',0),(84801,2356,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÏ€Î¹ÎºÏ…ÏÏŽÏƒÏ„Îµ Ï„Î¿ Ï€ÎµÎ´Î¯Î¿',0),(84802,2356,'zh','è¯·éªŒè¯è¿™ä¸€å­—æ®µ\r\n',0),(84803,2356,'sv','VÃ¤nligen verifiera fÃ¤ltet',0),(84804,2356,'it','Prego convalidare questo campo',0),(84805,2356,'tl','',0),(84806,2356,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3607;&#3635;&#3649;&#3615;&#3657;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3627;&#3657;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(84807,2356,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤‡à¤¸ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤•à¥‹ à¤®à¤¾à¤¨à¥à¤¯',0),(84808,2356,'ms','Sila mengesahkan bidang ini',0),(84809,2356,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† ØµØ­Ø© Ù‡Ø°Ø§ Ø§Ù„Ø­Ù‚Ù„',0),(84810,2356,'fr','Veuillez valider ce champ',0),(84811,2356,'jp','ã?“ã?®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’æœ‰åŠ¹ã?«ã?—ã?¦ã??ã? ã?•ã?„',0),(84812,2356,'pt','Por favor validar este campo',0),(84813,2356,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾ Ð¿Ð¾Ð»Ðµ',0),(84814,2356,'es','Por favor validar este campo',0),(84815,2356,'de','Bitte Ã¼berprÃ¼fen Sie in diesem Feld',0),(84816,2356,'en','Please validate this field',0),(84817,2357,'is','',0),(84818,2357,'dr','Ø¨Ø¹Ù„Ø§ÙˆÙ‡ ',0),(84819,2357,'pr','Ø¨Ø¹Ù„Ø§ÙˆÙ‡ ',0),(84820,2357,'tr','ArtÄ±',0),(84821,2357,'pl','Plus',0),(84822,2357,'bg','ÐŸÐ»ÑŽÑ',0),(84823,2357,'ur','Ù¾Ù„Ø³',0),(84824,2357,'sr','ÐŸÐ»ÑƒÑ',0),(84825,2357,'vi','Cá»™ng',0),(84826,2357,'af','Plus',0),(84827,2357,'ro','Plus',0),(84828,2357,'et','Plus',0),(84829,2357,'si','Plus',0),(84830,2357,'ba','Plus',0),(84831,2357,'nl','Plus',0),(84832,2357,'fi','Plus',0),(84833,2357,'no','Plus',0),(84834,2357,'da','Plus',0),(84835,2357,'ko','í”ŒëŸ¬ìŠ¤',0),(84836,2357,'he','×¤×œ×•×¡',0),(84837,2357,'el','Î£Ï…Î½',0),(84838,2357,'zh','åŠ \r\n',0),(84839,2357,'sv','Plus',0),(84840,2357,'it','Plus',0),(84841,2357,'tl','',0),(84842,2357,'th','&#3610;&#3623;&#3585;',0),(84843,2357,'hi','à¤ªà¥à¤²à¤¸',0),(84844,2357,'ms','Plus',0),(84845,2357,'ar','Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰',0),(84846,2357,'fr','Plus',0),(84847,2357,'jp','ãƒ—ãƒ©ã‚¹',0),(84848,2357,'pt','Plus',0),(84849,2357,'ru','ÐŸÐ»ÑŽÑ',0),(84850,2357,'es','MÃ¡s',0),(84851,2357,'de','Plus',0),(84852,2357,'en','Plus',0),(84853,2358,'is','',0),(84854,2358,'dr','Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…Ø§Ù„ÙŠØ§Øª',0),(84855,2358,'pr','Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…Ø§Ù„ÙŠØ§Øª',0),(84856,2358,'tr','ArtÄ± vergi',0),(84857,2358,'pl','Plus podatek',0),(84858,2358,'bg','ÐŸÐ»ÑŽÑ Ð´Ð°Ð½ÑŠÐº',0),(84859,2358,'ur','Ø¹Ù„Ø§ÙˆÛ Ù¹ÛŒÚ©Ø³',0),(84860,2358,'sr','ÐŸÐ»ÑƒÑ Ð¿Ð¾Ñ€ÐµÐ·',0),(84861,2358,'vi','Cá»™ng thuáº¿',0),(84862,2358,'af','Plus belasting',0),(84863,2358,'ro','Plus taxe',0),(84864,2358,'et','Pluss kÃ¤ibemaks',0),(84865,2358,'si','Plus davek',0),(84866,2358,'ba','Ditambah pajak',0),(84867,2358,'nl','Plus belasting',0),(84868,2358,'fi','Plus verot',0),(84869,2358,'no','Pluss skatt',0),(84870,2358,'da','Plus moms',0),(84871,2358,'ko','í”ŒëŸ¬ìŠ¤ ì„¸ê¸ˆ',0),(84872,2358,'he','×¤×œ×•×¡ ×ž×¡',0),(84873,2358,'el','Î£Ï…Î½ Ï„Î¿ Ï†ÏŒÏÎ¿',0),(84874,2358,'zh','åŠ ç¨Ž\r\n',0),(84875,2358,'sv','Plus skatt',0),(84876,2358,'it','PiÃ¹ tasse',0),(84877,2358,'tl','',0),(84878,2358,'th','&#3610;&#3623;&#3585;&#3616;&#3634;&#3625;&#3637;',0),(84879,2358,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤Ÿà¥ˆà¤•à¥à¤¸',0),(84880,2358,'ms','Dengan cukai',0),(84881,2358,'ar','Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(84882,2358,'fr','Taxes en sus',0),(84883,2358,'jp','ãƒ—ãƒ©ã‚¹ç¨Ž',0),(84884,2358,'pt','Mais impostos',0),(84885,2358,'ru','ÐŸÐ»ÑŽÑ Ð½Ð°Ð»Ð¾Ð³',0),(84886,2358,'es','MÃ¡s Impuesto',0),(84887,2358,'de','Zzgl. MwSt.',0),(84888,2358,'en','Plus tax',0),(84889,2359,'is','',0),(84890,2359,'dr','PMS Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª ØªÙˆÙ„ÙŠØ¯',0),(84891,2359,'pr','PMS Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª ØªÙˆÙ„ÙŠØ¯',0),(84892,2359,'tr','PMS',0),(84893,2359,'pl','PMS',0),(84894,2359,'bg','PMS',0),(84895,2359,'ur','ÙˆØ²Ø±Ø§Ø¦Û’ Ø§Ø¹Ø¸Ù… Ú©Ø§',0),(84896,2359,'sr','ÐŸÐœÐ¡',0),(84897,2359,'vi','PMS',0),(84898,2359,'af','PMS',0),(84899,2359,'ro','PMS',0),(84900,2359,'et','PMS',0),(84901,2359,'si','PMS',0),(84902,2359,'ba','PMS',0),(84903,2359,'nl','PMS',0),(84904,2359,'fi','PMS',0),(84905,2359,'no','PMS',0),(84906,2359,'da','PMS',0),(84907,2359,'ko','PMS',0),(84908,2359,'he','×ª×¡×ž×•× ×ª ×§×“× ×•×¡×ª×™×ª',0),(84909,2359,'el','PMS',0),(84910,2359,'zh','â€œå½©é€šé…è‰²ç³»ç»Ÿâ€œ\r\n',0),(84911,2359,'sv','PMS',0),(84912,2359,'it','PMS',0),(84913,2359,'tl','',0),(84914,2359,'th','PMS',0),(84915,2359,'hi','à¤ªà¥€à¤à¤®à¤à¤¸',0),(84916,2359,'ms','PMS',0),(84917,2359,'ar','Ø§Ù„Ø¯ÙˆØ±Ø© Ø§Ù„Ø´Ù‡Ø±ÙŠØ©',0),(84918,2359,'fr','PMS',0),(84919,2359,'jp','PMS',0),(84920,2359,'pt','PMS',0),(84921,2359,'ru','PMS',0),(84922,2359,'es','PMS',0),(84923,2359,'de','PMS',0),(84924,2359,'en','PMS',0),(84925,2360,'is','',0),(84926,2360,'dr','PMS #Ø´Ù…Ø§Ø±Ù‡ Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª ØªÙˆÙ„ÙŠØ¯',0),(84927,2360,'pr','PMS #Ø´Ù…Ø§Ø±Ù‡ Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª ØªÙˆÙ„ÙŠØ¯',0),(84928,2360,'tr','PMS #',0),(84929,2360,'pl','PMS #',0),(84930,2360,'bg','PMS #',0),(84931,2360,'ur','ÙˆØ²Ø±Ø§Ø¦Û’ Ø§Ø¹Ø¸Ù… Ú©Ø§ #',0),(84932,2360,'sr','ÐŸÐœÐ¡ #',0),(84933,2360,'vi','Sá»‘ OMS',0),(84934,2360,'af','PMS #',0),(84935,2360,'ro','PMS #',0),(84936,2360,'et','PMS #',0),(84937,2360,'si','PMS #',0),(84938,2360,'ba','PMS #',0),(84939,2360,'nl','PMS #',0),(84940,2360,'fi','PMS #',0),(84941,2360,'no','PMS #',0),(84942,2360,'da','PMS #',0),(84943,2360,'ko','PMS #',0),(84944,2360,'he','×ª×¡×ž×•× ×ª ×§×“× ×•×¡×ª×™×ª #',0),(84945,2360,'el','PMS #',0),(84946,2360,'zh','â€œå½©é€šé…è‰²ç³»ç»Ÿâ€œ#',0),(84947,2360,'sv','PMS #',0),(84948,2360,'it','PMS #',0),(84949,2360,'tl','',0),(84950,2360,'th','PMS #',0),(84951,2360,'hi','à¤ªà¥€à¤à¤®à¤à¤¸ #',0),(84952,2360,'ms','PMS #',0),(84953,2360,'ar','Ø§Ù„Ø¯ÙˆØ±Ø© Ø§Ù„Ø´Ù‡Ø±ÙŠØ© #',0),(84954,2360,'fr','PMS #',0),(84955,2360,'jp','PMS ç•ªå?·',0),(84956,2360,'pt','PMS #',0),(84957,2360,'ru','PMS #',0),(84958,2360,'es','PMS #',0),(84959,2360,'de','PMS #',0),(84960,2360,'en','PMS #',0),(84961,2361,'is','',0),(84962,2361,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(84963,2361,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(84964,2361,'tr','PO',0),(84965,2361,'pl','PO',0),(84966,2361,'bg','PO',0),(84967,2361,'ur','Ù¾Ùˆ',0),(84968,2361,'sr','ÐŸÐž-Ð',0),(84969,2361,'vi','ÄÆ¡n mua hÃ ng',0),(84970,2361,'af','AB',0),(84971,2361,'ro','PO',0),(84972,2361,'et','PO',0),(84973,2361,'si','PO',0),(84974,2361,'ba','PO',0),(84975,2361,'nl','PO',0),(84976,2361,'fi','PO',0),(84977,2361,'no','PO',0),(84978,2361,'da','PO',0),(84979,2361,'ko','í¬',0),(84980,2361,'he','×¤×•',0),(84981,2361,'el','PO',0),(84982,2361,'zh','é‡‡è´­è®¢å•\r\n',0),(84983,2361,'sv','PO',0),(84984,2361,'it','PO',0),(84985,2361,'tl','',0),(84986,2361,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(84987,2361,'hi','à¤ªà¥€à¤“',0),(84988,2361,'ms','PO',0),(84989,2361,'ar','Øµ. Ø¨.',0),(84990,2361,'fr','PO',0),(84991,2361,'jp','PO',0),(84992,2361,'pt','PO',0),(84993,2361,'ru','PO',0),(84994,2361,'es','OC',0),(84995,2361,'de','PO',0),(84996,2361,'en','PO',0),(84997,2362,'is','',0),(84998,2362,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(84999,2362,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(85000,2362,'tr','PO baÅŸarÄ±yla gÃ¼ncelleÅŸtirilmiÅŸ bilgi',0),(85001,2362,'pl','PO szczegÃ³Å‚y zaktualizowany pomyÅ›lnie',0),(85002,2362,'bg','PO Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(85003,2362,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù¾Ùˆ ØªÙØµÛŒÙ„Ø§Øª',0),(85004,2362,'sr','ÐŸÐž Ð´ÐµÑ‚Ð°Ñ™Ð½Ð¾ Ð¾Ð¿Ð¸ÑÑƒÑ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¾',0),(85005,2362,'vi','Cáº­p Nháº­t Chi Tiáº¿t ÄÆ¡n Mua HÃ ng thÃ nh CÃ´ng',0),(85006,2362,'af','AB Besonderhede suksesvol Opdateer',0),(85007,2362,'ro','PO detalii actualizat cu succes',0),(85008,2362,'et','PO andmed uuendatud edukalt',0),(85009,2362,'si','PO podrobnosti posodobljeno uspeÅ¡no',0),(85010,2362,'ba','PO rincian berhasil diperbarui.',0),(85011,2362,'nl','PO Details bijgewerkt met succes',0),(85012,2362,'fi','PO tiedot pÃ¤ivitetty onnistuneesti',0),(85013,2362,'no','PO detaljer oppdatert vellykket',0),(85014,2362,'da','PO detaljer opdateret med succes',0),(85015,2362,'ko','ê°€ëŠ” ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ë‚´ìš©ì„',0),(85016,2362,'he','×¤×• ×ž×¤×¨×˜ ×ž×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(85017,2362,'el','PO Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(85018,2362,'zh','è®¢å•è¯¦ç»†ä¿¡æ¯æ›´æ–°æˆåŠŸ\r\n',0),(85019,2362,'sv','PO Detaljer uppdaterad framgÃ¥ngsrikt',0),(85020,2362,'it','PO dettagli aggiornato con successo',0),(85021,2362,'tl','',0),(85022,2362,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(85023,2362,'hi','PO à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(85024,2362,'ms','PO butiran dikemaskinikan berjaya',0),(85025,2362,'ar','Øµ. Ø¨ ØªÙØ§ØµÙŠÙ„ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(85026,2362,'fr','PO dÃ©tails mis Ã  jour avec succÃ¨s',0),(85027,2362,'jp','ç™ºæ³¨æ›¸è©³ç´°ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(85028,2362,'pt','PO detalha atualizado com sucesso',0),(85029,2362,'ru','PO Ð´ÐµÑ‚Ð°Ð»Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(85030,2362,'es','OC Detalles Actualizados Exitosamente',0),(85031,2362,'de','PO Details erfolgreich aktualisiert.',0),(85032,2362,'en','PO Details Updated successfully',0),(85033,2363,'is','',0),(85034,2363,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(85035,2363,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(85036,2363,'tr','PO #',0),(85037,2363,'pl','PO #',0),(85038,2363,'bg','PO #',0),(85039,2363,'ur','Ù¾Ùˆ #',0),(85040,2363,'sr','ÐŸÐž #',0),(85041,2363,'vi','Sá»‘ Ä‘Æ¡n mua hÃ ng',0),(85042,2363,'af','AB #',0),(85043,2363,'ro','PO #',0),(85044,2363,'et','PO #',0),(85045,2363,'si','PO #',0),(85046,2363,'ba','PO #',0),(85047,2363,'nl','PO #',0),(85048,2363,'fi','PO #',0),(85049,2363,'no','PO #',0),(85050,2363,'da','PO #',0),(85051,2363,'ko','PO #',0),(85052,2363,'he','×¤×• #',0),(85053,2363,'el','PO #',0),(85054,2363,'zh','è®¢å•ï¼ƒ\r\n',0),(85055,2363,'sv','PO #',0),(85056,2363,'it','PO #',0),(85057,2363,'tl','',0),(85058,2363,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(85059,2363,'hi','à¤ªà¥€à¤“ #',0),(85060,2363,'ms','PO #',0),(85061,2363,'ar','Øµ. Ø¨ #',0),(85062,2363,'fr','PO #',0),(85063,2363,'jp','PO#',0),(85064,2363,'pt','PO #',0),(85065,2363,'ru','PO #',0),(85066,2363,'es','OC #',0),(85067,2363,'de','PO #',0),(85068,2363,'en','PO #',0),(85069,2364,'is','',0),(85070,2364,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(85071,2364,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(85072,2364,'tr','PO NUMARASI',0),(85073,2364,'pl','NUMER ZAMÃ“WIENIA',0),(85074,2364,'bg','ÐÐžÐœÐ•Ð  ÐÐ ÐŸÐžÐ ÐªÐ§ÐšÐ',0),(85075,2364,'ur','Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø±',0),(85076,2364,'sr','Ð‘Ð ÐžÐˆ ÐÐÐ Ð£ÐÐ‘Ð•ÐÐ˜Ð¦Ð•',0),(85077,2364,'vi','Sá»‘ Ä‘Æ¡n mua hÃ ng',0),(85078,2364,'af','AB NOMMER',0),(85079,2364,'ro','NUMÄ‚RUL BONULUI DE COMANDÄ‚',0),(85080,2364,'et','PO NUMBER',0),(85081,2364,'si','Å TEVILKA NAROÄŒILNICE',0),(85082,2364,'ba','NOMOR PO',0),(85083,2364,'nl','PO-NUMMER',0),(85084,2364,'fi','OSTOTILAUKSEN NUMERO',0),(85085,2364,'no','INNKJÃ˜PSORDRENUMMER',0),(85086,2364,'da','PO-NUMMER',0),(85087,2364,'ko','ì£¼ë¬¸ì„œ ë²ˆí˜¸',0),(85088,2364,'he','×ž×¡×¤×¨ ×”-PO',0),(85089,2364,'el','Î‘Î¡ Î Î‘Î¡Î‘Î“Î“',0),(85090,2364,'zh','è®¢å•å·\r\n',0),(85091,2364,'sv','INKÃ–PSORDERNUMMER',0),(85092,2364,'it','NUMERO DI PO',0),(85093,2364,'tl','',0),(85094,2364,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(85095,2364,'hi','à¤ªà¥‹ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(85096,2364,'ms','NOMBOR PO',0),(85097,2364,'ar','Ø±Ù‚Ù… Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(85098,2364,'fr','NOMBRE DE PO',0),(85099,2364,'jp','POç•ªå?·',0),(85100,2364,'pt','NÃšMERO DE PO',0),(85101,2364,'ru','ÐÐžÐœÐ•Ð  Ð—ÐÐšÐÐ—Ð',0),(85102,2364,'es','NÃšMERO DE OC',0),(85103,2364,'de','BESTELLNUMMER',0),(85104,2364,'en','PO NUMBER',0),(85105,2365,'is','',0),(85106,2365,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ ',0),(85107,2365,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ ',0),(85108,2365,'tr','BaÅŸarÄ±yla alÄ±nan PO.',0),(85109,2365,'pl','PO pomyÅ›lnie odebrane.',0),(85110,2365,'bg','PO, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(85111,2365,'ur','Ù¾Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ù…Ù„ÛŒ ÛÛ’ Û”',0),(85112,2365,'sr','Ð¢Ð¾ Ñ˜Ðµ Ð¿Ð¾ÐµÐ·Ð¸Ñ˜Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½.',0),(85113,2365,'vi','Nháº­n ÄÆ¡n mua hÃ ng thÃ nh cÃ´ng',0),(85114,2365,'af','AB Suksesvol Ontvang.',0),(85115,2365,'ro','PO primite cu succes.',0),(85116,2365,'et','PO sai edukalt.',0),(85117,2365,'si','PO uspeÅ¡no sprejeta.',0),(85118,2365,'ba','PO berhasil diterima.',0),(85119,2365,'nl','PO ontvangen met succes.',0),(85120,2365,'fi','PO vastaanottamisen onnistumisesta.',0),(85121,2365,'no','PO mottatt.',0),(85122,2365,'da','PO modtaget med succes.',0),(85123,2365,'ko','í¬ëŠ” ì„±ê³µì ìœ¼ë¡œ ë°›ì•˜ìŠµë‹ˆë‹¤.',0),(85124,2365,'he','×¤×• ×”×ª×§×‘×œ×” ×‘×”×¦×œ×—×”.',0),(85125,2365,'el','PO Î­Î»Î±Î²Îµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(85126,2365,'zh','æˆåŠŸæŽ¥æ”¶é‡‡è´­è®¢å•',0),(85127,2365,'sv','PO fÃ¥tt framgÃ¥ngsrikt.',0),(85128,2365,'it','PO ricevuto con successo.',0),(85129,2365,'tl','',0),(85130,2365,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3649;&#3621;&#3657;&#3623;',0),(85131,2365,'hi','PO à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤¿à¤¯à¤¾à¥¤',0),(85132,2365,'ms','PO diterima berjaya.',0),(85133,2365,'ar','Øµ. Ø¨ ØªÙ„Ù‚ÙŠ Ø¨Ù†Ø¬Ø§Ø­.',0),(85134,2365,'fr','PO a reÃ§u avec succÃ¨s.',0),(85135,2365,'jp','POã‚’å?—é ˜ã?—ã?¾ã?—ã?Ÿ',0),(85136,2365,'pt','PO recebido com sucesso.',0),(85137,2365,'ru','ÐžÐž Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(85138,2365,'es','OC recibido exitosamente',0),(85139,2365,'de','PO erfolgreich empfangen.',0),(85140,2365,'en','PO received successfully.',0),(85141,2366,'is','',0),(85142,2366,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(85143,2366,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(85144,2366,'tr','PO baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(85145,2366,'pl','PO pomyÅ›lnie zaktualizowana',0),(85146,2366,'bg','PO Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(85147,2366,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ù¾ÙˆØ³Ù¹ Ø§Ù¾ ÚˆÛŒÙ¹',0),(85148,2366,'sr','ÐŸÐž Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(85149,2366,'vi','Cáº­p Nháº­t ÄÆ¡n Mua HÃ ng thÃ nh CÃ´ng',0),(85150,2366,'af','AB Suksesvol Opdateer',0),(85151,2366,'ro','PO actualizat cu succes',0),(85152,2366,'et','PO vÃ¤rskendamine Ãµnnestus',0),(85153,2366,'si','PO uspeÅ¡no posodobljena',0),(85154,2366,'ba','PO diperbarui berhasil',0),(85155,2366,'nl','PO bijgewerkt',0),(85156,2366,'fi','PO pÃ¤ivitetty',0),(85157,2366,'no','PO oppdatert',0),(85158,2366,'da','PO opdateret',0),(85159,2366,'ko','ê°€ëŠ” ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(85160,2366,'he','×¤×• ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(85161,2366,'el','PO ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(85162,2366,'zh','è®¢å•æˆåŠŸæ›´æ–°\r\n',0),(85163,2366,'sv','PO uppdaterats',0),(85164,2366,'it','PO aggiornato con successo',0),(85165,2366,'tl','',0),(85166,2366,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(85167,2366,'hi','PO à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(85168,2366,'ms','PO berjaya dikemas kini',0),(85169,2366,'ar','Øµ. Ø¨ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(85170,2366,'fr','PO mis Ã  jour avec succÃ¨s',0),(85171,2366,'jp','POã‚’æ›´æ–°ã?—ã?¾ã?—ã?Ÿ',0),(85172,2366,'pt','PO atualizado com sucesso',0),(85173,2366,'ru','PO ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(85174,2366,'es','OC Actualizado exitosamente',0),(85175,2366,'de','PO erfolgreich aktualisiert',0),(85176,2366,'en','PO Updated successfully',0),(85177,2367,'is','',0),(85178,2367,'dr','Ø¯Ø³ØªÙˆØ± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ \r\nPOD\r\n',0),(85179,2367,'pr','Ø¯Ø³ØªÙˆØ± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ \r\nPOD\r\n',0),(85180,2367,'tr','POD',0),(85181,2367,'pl','POD',0),(85182,2367,'bg','POD',0),(85183,2367,'ur','Ù¾Ú¾Ù„ÛŒ',0),(85184,2367,'sr','ÐšÐÐŸÐ¡Ð£Ð›Ð',0),(85185,2367,'vi','Chá»©ng nháº­n giao hÃ ng',0),(85186,2367,'af','POA (Produseer op Aanvraag)',0),(85187,2367,'ro','POD',0),(85188,2367,'et','POD',0),(85189,2367,'si','POD',0),(85190,2367,'ba','POD',0),(85191,2367,'nl','POD',0),(85192,2367,'fi','POD',0),(85193,2367,'no','POD',0),(85194,2367,'da','POD',0),(85195,2367,'ko','í¬ë“œ',0),(85196,2367,'he','×¤×•×“',0),(85197,2367,'el','POD',0),(85198,2367,'zh','è´§åˆ°ä»˜æ¬¾\r\n',0),(85199,2367,'sv','POD',0),(85200,2367,'it','POD',0),(85201,2367,'tl','',0),(85202,2367,'th','POD',0),(85203,2367,'hi','à¤«à¤²à¥€',0),(85204,2367,'ms','POD',0),(85205,2367,'ar','ØªØµÙ†ÙŠØ¹ Ø¨Ø§Ù„Ø·Ù„Ø¨',0),(85206,2367,'fr','POD',0),(85207,2367,'jp','POD',0),(85208,2367,'pt','POD',0),(85209,2367,'ru','POD',0),(85210,2367,'es','POD',0),(85211,2367,'de','POD',0),(85212,2367,'en','POD',0),(85213,2368,'is','',0),(85214,2368,'dr','Ø¶Ø¹ÙŠÙ',0),(85215,2368,'pr','Ø¶Ø¹ÙŠÙ',0),(85216,2368,'tr','ZavallÄ±',0),(85217,2368,'pl','Biedny',0),(85218,2368,'bg','Ð‘ÐµÐ´Ð½Ð¸Ñ‚Ðµ',0),(85219,2368,'ur','ØºØ±ÛŒØ¨',0),(85220,2368,'sr','ÐˆÐ°Ð´Ð½Ð¸',0),(85221,2368,'vi','Tá»“i',0),(85222,2368,'af','Swak',0),(85223,2368,'ro','SÄƒraci',0),(85224,2368,'et','Kehv',0),(85225,2368,'si','Slaba',0),(85226,2368,'ba','Miskin',0),(85227,2368,'nl','Arme',0),(85228,2368,'fi','Huono',0),(85229,2368,'no','DÃ¥rlig',0),(85230,2368,'da','DÃ¥rlig',0),(85231,2368,'ko','ë¶ˆ ìŒ í•œ',0),(85232,2368,'he','×”×ž×¡×›×Ÿ',0),(85233,2368,'el','ÎšÎ±ÎºÎ®',0),(85234,2368,'zh','è´«ç©·çš„\r\n',0),(85235,2368,'sv','DÃ¥lig',0),(85236,2368,'it','Povero',0),(85237,2368,'tl','',0),(85238,2368,'th','&#3649;&#3618;&#3656;',0),(85239,2368,'hi','à¤—à¤°à¥€à¤¬',0),(85240,2368,'ms','Miskin',0),(85241,2368,'ar','Ø§Ù„ÙÙ‚Ø±Ø§Ø¡',0),(85242,2368,'fr','Pauvre',0),(85243,2368,'jp','æ‚ªã?„',0),(85244,2368,'pt','Pobre',0),(85245,2368,'ru','Ð‘ÐµÐ´Ð½Ñ‹Ðµ',0),(85246,2368,'es','Pobre',0),(85247,2368,'de','Arme',0),(85248,2368,'en','Poor',0),(85249,2369,'is','',0),(85250,2369,'dr','Ù¾Ø±ØªØºØ§Ù„ÙŠ',0),(85251,2369,'pr','Ù¾Ø±ØªØºØ§Ù„ÙŠ',0),(85252,2369,'tr','Portekizce',0),(85253,2369,'pl','Portugalski',0),(85254,2369,'bg','ÐŸÐ¾Ñ€Ñ‚ÑƒÐ³Ð°Ð»ÑÐºÐ¸',0),(85255,2369,'ur','Ù¾Ø±ØªÚ¯Ø§Ù„',0),(85256,2369,'sr','Ð¿Ð¾Ñ€Ñ‚ÑƒÐ³Ð°Ð»ÑÐºÐ¸',0),(85257,2369,'vi','Bá»“ Ä‘Ã o nha',0),(85258,2369,'af','Portugees',0),(85259,2369,'ro','PortughezÄƒ',0),(85260,2369,'et','Portugali',0),(85261,2369,'si','portugalÅ¡Äina',0),(85262,2369,'ba','Portugis',0),(85263,2369,'nl','Portugees',0),(85264,2369,'fi','portugali',0),(85265,2369,'no','Portugisisk',0),(85266,2369,'da','portugisisk',0),(85267,2369,'ko','í¬ë¥´íˆ¬ê°ˆì–´',0),(85268,2369,'he','×¤×•×¨×˜×•×’×–×™×ª',0),(85269,2369,'el','Î Î¿ÏÏ„Î¿Î³Î±Î»Î¹ÎºÎ¬',0),(85270,2369,'zh','è‘¡è„ç‰™\r\n',0),(85271,2369,'sv','Portugisiska',0),(85272,2369,'it','Portoghese',0),(85273,2369,'tl','',0),(85274,2369,'th','&#3594;&#3634;&#3623;&#3650;&#3611;&#3619;&#3605;&#3640;&#3648;&#3585;&#3626;',0),(85275,2369,'hi','à¤ªà¥à¤°à¥à¤¤à¤—à¤¾à¤²à¥€',0),(85276,2369,'ms','Portugis',0),(85277,2369,'ar','Ø§Ù„Ø¨Ø±ØªØºØ§Ù„ÙŠØ©',0),(85278,2369,'fr','Portugais',0),(85279,2369,'jp','ãƒ?ãƒ«ãƒˆã‚¬ãƒ«èªž',0),(85280,2369,'pt','PortuguÃªs',0),(85281,2369,'ru','Ð¿Ð¾Ñ€Ñ‚ÑƒÐ³Ð°Ð»ÑŒÑÐºÐ¸Ð¹',0),(85282,2369,'es','PortuguÃ©s',0),(85283,2369,'de','Portugiesisch',0),(85284,2369,'en','Portuguese',0),(85285,2370,'is','',0),(85286,2370,'dr','Ù…ÙˆÙ‚Ø¹ÙŠØª',0),(85287,2370,'pr','Ù…ÙˆÙ‚Ø¹ÙŠØª',0),(85288,2370,'tr','Pozisyon',0),(85289,2370,'pl','Stanowisko',0),(85290,2370,'bg','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ñ',0),(85291,2370,'ur','Ù¾ÙˆØ²ÛŒØ´Ù†',0),(85292,2370,'sr','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ñ˜Ð°',0),(85293,2370,'vi','Chá»©c danh',0),(85294,2370,'af','Posisie',0),(85295,2370,'ro','PoziÅ£ia',0),(85296,2370,'et','Positsioon',0),(85297,2370,'si','PoloÅ¾aj',0),(85298,2370,'ba','Posisi',0),(85299,2370,'nl','Positie',0),(85300,2370,'fi','Sijainti',0),(85301,2370,'no','Posisjon',0),(85302,2370,'da','Position',0),(85303,2370,'ko','ìœ„ì¹˜',0),(85304,2370,'he','×ž×™×§×•×',0),(85305,2370,'el','Î˜Î­ÏƒÎ·',0),(85306,2370,'zh','ä½ç½®\r\n',0),(85307,2370,'sv','Position',0),(85308,2370,'it','Posizione',0),(85309,2370,'tl','',0),(85310,2370,'th','&#3605;&#3635;&#3649;&#3627;&#3609;&#3656;&#3591;',0),(85311,2370,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(85312,2370,'ms','Kedudukan',0),(85313,2370,'ar','Ù…ÙˆÙ‚Ù',0),(85314,2370,'fr','Position',0),(85315,2370,'jp','ãƒ?ã‚¸ã‚·ãƒ§ãƒ³',0),(85316,2370,'pt','PosiÃ§Ã£o',0),(85317,2370,'ru','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ñ',0),(85318,2370,'es','PosiciÃ³n',0),(85319,2370,'de','Position',0),(85320,2370,'en','Position',0),(85321,2371,'is','',0),(85322,2371,'dr','Ù¾Ø³Øª',0),(85323,2371,'pr','Ù¾Ø³Øª',0),(85324,2371,'tr','YayÄ±nla',0),(85325,2371,'pl','Post',0),(85326,2371,'bg','ÐŸÐ¾ÑÑ‚',0),(85327,2371,'ur','Ù¾ÙˆØ³Ù¹',0),(85328,2371,'sr','ÐŸÐ¾ÑÑ‚',0),(85329,2371,'vi','Káº¿t chuyá»ƒn',0),(85330,2371,'af','Pos',0),(85331,2371,'ro','Post',0),(85332,2371,'et','Post',0),(85333,2371,'si','Post',0),(85334,2371,'ba','Posting',0),(85335,2371,'nl','Verzenden',0),(85336,2371,'fi','Viesti',0),(85337,2371,'no','Innlegg',0),(85338,2371,'da','IndlÃ¦g',0),(85339,2371,'ko','ì˜¬ë¦¬ê¸°',0),(85340,2371,'he','×¤×•×¡×˜',0),(85341,2371,'el','Î˜Î­ÏƒÎ·',0),(85342,2371,'zh','é‚®æ”¿\r\n',0),(85343,2371,'sv','InlÃ¤gg',0),(85344,2371,'it','Inserisci',0),(85345,2371,'tl','',0),(85346,2371,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(85347,2371,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(85348,2371,'ms','Post',0),(85349,2371,'ar','Ø¥Ø±Ø³Ø§Ù„/Ø¥Ø¹Ù„Ø§Ù†',0),(85350,2371,'fr','Publier',0),(85351,2371,'jp','è¨ˆä¸Š',0),(85352,2371,'pt','Postar',0),(85353,2371,'ru','ÐŸÐ¾Ð¼ÐµÑÑ‚Ð¸Ñ‚ÑŒ',0),(85354,2371,'es','Asentar',0),(85355,2371,'de','Bereitstellen',0),(85356,2371,'en','Post',0),(85357,2372,'is','',0),(85358,2372,'dr','Ù¾Ø³Øª Ø§Ø² ',0),(85359,2372,'pr','Ù¾Ø³Øª Ø§Ø² ',0),(85360,2372,'tr','Deftere nakil',0),(85361,2372,'pl','Post z',0),(85362,2372,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚',0),(85363,2372,'ur','Ø³Û’ Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº',0),(85364,2372,'sr','ÐšÑšÐ¸Ð¶ÐµÑšÐµ Ð¸Ð·',0),(85365,2372,'vi','Káº¿t chuyá»ƒn tá»«',0),(85366,2372,'af','Pos Vanuit',0),(85367,2372,'ro','Post de la',0),(85368,2372,'et','Post:',0),(85369,2372,'si','Post iz',0),(85370,2372,'ba','Posting dari',0),(85371,2372,'nl','Post uit',0),(85372,2372,'fi','LÃ¤hettÃ¤Ã¤',0),(85373,2372,'no','Innlegg fra',0),(85374,2372,'da','Post fra',0),(85375,2372,'ko','ê²Œì‹œ',0),(85376,2372,'he','×¤×•×¡×˜ ×ž',0),(85377,2372,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎµÎ¯Ï„Îµ',0),(85378,2372,'zh','å‘å¸ƒæ¥è‡ª\r\n',0),(85379,2372,'sv','Post frÃ¥n',0),(85380,2372,'it','Post da',0),(85381,2372,'tl','',0),(85382,2372,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3592;&#3634;&#3585;',0),(85383,2372,'hi','à¤¸à¥‡ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(85384,2372,'ms','Post dari',0),(85385,2372,'ar','Ø§Ù„ØªØ±Ø­ÙŠÙ„ Ù…Ù†',0),(85386,2372,'fr','Poster de',0),(85387,2372,'jp','ï½žã?‹ã‚‰è¨ˆä¸Š',0),(85388,2372,'pt','Post de',0),(85389,2372,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¾Ñ‚',0),(85390,2372,'es','Asentar De',0),(85391,2372,'de','Post von',0),(85392,2372,'en','Post From',0),(85393,2373,'is','',0),(85394,2373,'dr','Ø§ÙƒÙ†ÙˆÙ† Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯ ',0),(85395,2373,'pr','Ø§ÙƒÙ†ÙˆÙ† Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯ ',0),(85396,2373,'tr','Åžimdi yazÄ±',0),(85397,2373,'pl','Post teraz',0),(85398,2373,'bg','ÐŸÐ¾ÑÑ‚ ÑÐµÐ³Ð°',0),(85399,2373,'ur','Ø§Ø¨ Ù¾ÙˆØ³Ù¹',0),(85400,2373,'sr','Ð¡Ð°Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°',0),(85401,2373,'vi','Káº¿t chuyá»ƒn bÃ¢y giá»',0),(85402,2373,'af','Pos Nou',0),(85403,2373,'ro','Post acum',0),(85404,2373,'et','Sisesta kohe',0),(85405,2373,'si','Post zdaj',0),(85406,2373,'ba','Posting sekarang',0),(85407,2373,'nl','Post nu',0),(85408,2373,'fi','Kirjaa nyt',0),(85409,2373,'no','Innlegg nÃ¥',0),(85410,2373,'da','Post nu',0),(85411,2373,'ko','ì§€ê¸ˆ ê²Œì‹œë¬¼',0),(85412,2373,'he','×”×”×•×“×¢×” ×•×¢×›×©×™×•',0),(85413,2373,'el','Î˜Î­ÏƒÎ· Ï„ÏŽÏÎ±',0),(85414,2373,'zh','ç«‹å³å‘å¸ƒ\r\n',0),(85415,2373,'sv','InlÃ¤gget nu',0),(85416,2373,'it','Post ora',0),(85417,2373,'tl','',0),(85418,2373,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3604;&#3637;&#3659;&#3618;&#3623;&#3609;&#3637;&#3657;',0),(85419,2373,'hi','à¤…à¤¬ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(85420,2373,'ms','Jawatan sekarang',0),(85421,2373,'ar','Ø±Ø­Ù‘Ù„ Ø§Ù„Ø¢Ù†',0),(85422,2373,'fr','Post maintenant',0),(85423,2373,'jp','ç›´ã?¡ã?«è¨ˆä¸Š',0),(85424,2373,'pt','Post agora',0),(85425,2373,'ru','ÐŸÐ¾ÑÑ‚ ÑÐµÐ¹Ñ‡Ð°Ñ',0),(85426,2373,'es','Asentar Ahora',0),(85427,2373,'de','Post jetzt',0),(85428,2373,'en','Post Now',0),(85429,2374,'is','',0),(85430,2374,'dr','/ Ú†Ø§Ù¾ Ø§ÙŠÙ† Ø¨ÛŒØ¬Ú© ',0),(85431,2374,'pr','Ø§Ø±Ø³Ø§Ù„  / Ú†Ø§Ù¾ Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(85432,2374,'tr','Post/bu FaturayÄ± yazdÄ±r',0),(85433,2374,'pl','Post/druk faktura ta',0),(85434,2374,'bg','/ ÐŸÐµÑ‡Ð°Ñ‚ Ñ‚Ð°Ð·Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(85435,2374,'ur','Ù¾ÙˆØ³Ù¹/Ø§Ø³ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(85436,2374,'sr','ÐžÐ²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶Ð¸/ÐŸÑ€Ð¸Ð½Ñ‚',0),(85437,2374,'vi','Káº¿t chuyá»ƒn/In hÃ³a Ä‘Æ¡n nÃ y',0),(85438,2374,'af','Pos/Druk hierdie faktuur',0),(85439,2374,'ro','Post/imprimare aceastÄƒ facturÄƒ',0),(85440,2374,'et','Post/Prindi see arve',0),(85441,2374,'si','Post/Natisni raÄun',0),(85442,2374,'ba','Posting/cetak faktur ini',0),(85443,2374,'nl','Post/Print deze factuur',0),(85444,2374,'fi','Post/Tulosta lasku',0),(85445,2374,'no','Innlegget/skrive ut fakturaen',0),(85446,2374,'da','Post/Print denne faktura',0),(85447,2374,'ko','ê²Œì‹œë¬¼/ì¸ì‡„ê°€ì´ ì†¡ìž¥',0),(85448,2374,'he','×¤×•×¡×˜/×”×“×¤×¡ ×—×©×‘×•× ×™×ª ×–×•',0),(85449,2374,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¸Î­ÏƒÎ·/ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(85450,2374,'zh','å‘å¸ƒ/æ‰“å°å‘ç¥¨\r\n',0),(85451,2374,'sv','Post och utskrift denna faktura',0),(85452,2374,'it','Post/stampa questa fattura',0),(85453,2374,'tl','',0),(85454,2374,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;/&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3609;&#3637;&#3657;',0),(85455,2374,'hi','à¤ªà¤¦/à¤‡à¤¸ à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(85456,2374,'ms','Pos/cetak invois ini',0),(85457,2374,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ©/Ø·Ø¨Ø§Ø¹Ø© Ù‡Ø°Ù‡ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(85458,2374,'fr','Post/imprimer cette facture',0),(85459,2374,'jp','ã?“ã?®è«‹æ±‚æ›¸ã‚’è¨ˆä¸Š/å?°åˆ·',0),(85460,2374,'pt','Post/imprimir esta fatura',0),(85461,2374,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾ÑÑ‚ÑŒ/Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ ÑÑ‡ÐµÑ‚',0),(85462,2374,'es','Asentar/Imprimir esta factura',0),(85463,2374,'de','Post/Drucken dieser Rechnung',0),(85464,2374,'en','Post/Print this invoice',0),(85465,2375,'is','',0),(85466,2375,'dr','Ø¢ÙŠØ§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø§Ø±Ø³Ø§Ù„ Ø´ÙˆØ¯ØŸ',0),(85467,2375,'pr','Ø¢ÙŠØ§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø§Ø±Ø³Ø§Ù„ Ø´ÙˆØ¯ØŸ',0),(85468,2375,'tr','BorÃ§lar mesaja?',0),(85469,2375,'pl','Post do zobowiÄ…zania?',0),(85470,2375,'bg','ÐŸÐ¾ÑÑ‚ Ð´Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ?',0),(85471,2375,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Ùˆ Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚºØŸ',0),(85472,2375,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶Ð¸ Ñƒ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°?',0),(85473,2375,'vi','Káº¿t Chuyá»ƒn vÃ o TK Pháº£i Tráº£?',0),(85474,2375,'af','Pos na Uitgawes (RB)?',0),(85475,2375,'ro','Post pentru datorii?',0),(85476,2375,'et','Post vÃµlad?',0),(85477,2375,'si','Post, da obveznosti?',0),(85478,2375,'ba','Posting untuk hutang?',0),(85479,2375,'nl','Post naar schulden?',0),(85480,2375,'fi','Ostojen postitse?',0),(85481,2375,'no','Innlegg i gjeld?',0),(85482,2375,'da','IndlÃ¦g til kreditorstyring?',0),(85483,2375,'ko','ê²Œì‹œë¬¼ ë¯¸ì§€ê¸‰ê¸ˆì„?',0),(85484,2375,'he','×¤×•×¡×˜ ×–×›××™×?',0),(85485,2375,'el','Î˜Î­ÏƒÎ· Î½Î± Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½;',0),(85486,2375,'zh','å‘å¸ƒåˆ°åº”ä»˜æ¬¾ï¼Ÿ\r\n',0),(85487,2375,'sv','Post till leverantÃ¶rsskulder?',0),(85488,2375,'it','Post per debiti?',0),(85489,2375,'tl','',0),(85490,2375,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3611;&#3618;&#3633;&#3591;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(85491,2375,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¸à¥‡ Payables?',0),(85492,2375,'ms','Pos kepada pemiutang?',0),(85493,2375,'ar','ÙˆØ¸ÙŠÙØ© Ù„Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹ØŸ',0),(85494,2375,'fr','Message aux crÃ©diteursÂ ?',0),(85495,2375,'jp','è²·æŽ›é‡‘å‹˜å®šã?¸è¨ˆä¸Šã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(85496,2375,'pt','Post para contas a pagar?',0),(85497,2375,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð´Ð»Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸?',0),(85498,2375,'es','Asentar a Cuentas por Pagar',0),(85499,2375,'de','Post an Verbindlichkeiten?',0),(85500,2375,'en','Post to Payables?',0),(85501,2376,'is','',0),(85502,2376,'dr','ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(85503,2376,'pr','ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(85504,2376,'tr','Posta kodu',0),(85505,2376,'pl','Kod pocztowy',0),(85506,2376,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(85507,2376,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÙˆÚˆ',0),(85508,2376,'sr','ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(85509,2376,'vi','MÃ£ BÆ°u Äiá»‡n',0),(85510,2376,'af','Poskode',0),(85511,2376,'ro','Cod poÈ™tal',0),(85512,2376,'et','Postiindeks',0),(85513,2376,'si','PoÅ¡tna Å¡tevilka',0),(85514,2376,'ba','Kode pos',0),(85515,2376,'nl','Postcode',0),(85516,2376,'fi','Postinumero',0),(85517,2376,'no','Postnummer',0),(85518,2376,'da','Postnummer',0),(85519,2376,'ko','ìš°íŽ¸ ë²ˆí˜¸',0),(85520,2376,'he','×ž×™×§×•×“',0),(85521,2376,'el','Î¤Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(85522,2376,'zh','é‚®æ”¿ç¼–ç \r\n',0),(85523,2376,'sv','Postnummer',0),(85524,2376,'it','Codice postale',0),(85525,2376,'tl','',0),(85526,2376,'th','&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;',0),(85527,2376,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿà¤² à¤•à¥‹à¤¡',0),(85528,2376,'ms','Poskod',0),(85529,2376,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(85530,2376,'fr','Code postal',0),(85531,2376,'jp','éƒµä¾¿ç•ªå?·',0),(85532,2376,'pt','CÃ³digo postal',0),(85533,2376,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ Ð˜Ð½Ð´ÐµÐºÑ',0),(85534,2376,'es','CÃ³digo Postal',0),(85535,2376,'de','Postleitzahl',0),(85536,2376,'en','Postal Code',0),(85537,2377,'is','',0),(85538,2377,'dr','Ù¾Ø³Øª Ø´Ø¯Ù‡ ',0),(85539,2377,'pr','Ù¾Ø³Øª Ø´Ø¯Ù‡ ',0),(85540,2377,'tr','YayÄ±nlanan',0),(85541,2377,'pl','WysÅ‚any',0),(85542,2377,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾',0),(85543,2377,'ur','Ù…ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(85544,2377,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸',0),(85545,2377,'vi','ÄÃ£ káº¿t chuyá»ƒn',0),(85546,2377,'af','Gepos',0),(85547,2377,'ro','AdÄƒugatÄƒ pe site',0),(85548,2377,'et','Postitatud',0),(85549,2377,'si','Objavljeno',0),(85550,2377,'ba','Dikirim',0),(85551,2377,'nl','Gepost',0),(85552,2377,'fi','LÃ¤hetetty',0),(85553,2377,'no','Postet',0),(85554,2377,'da','BogfÃ¸rt',0),(85555,2377,'ko','ë°°ì¹˜ í•˜ëŠ”',0),(85556,2377,'he','×¤×•×¨×¡×',0),(85557,2377,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®Î¸Î·ÎºÎµ',0),(85558,2377,'zh','å‘å¸ƒ\r\n',0),(85559,2377,'sv','Inlagd',0),(85560,2377,'it','Inviato',0),(85561,2377,'tl','',0),(85562,2377,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3621;&#3657;&#3623;',0),(85563,2377,'hi','à¤ªà¥à¤°à¤•à¤¾à¤¶à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¥à¤¾',0),(85564,2377,'ms','Posted',0),(85565,2377,'ar','Ù…Ø±Ø³Ù„Ø© ',0),(85566,2377,'fr','PostÃ©',0),(85567,2377,'jp','è¨ˆä¸Šæ¸ˆã?¿',0),(85568,2377,'pt','Postado',0),(85569,2377,'ru','ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¾',0),(85570,2377,'es','Asentado',0),(85571,2377,'de','Geschrieben',0),(85572,2377,'en','Posted',0),(85573,2378,'is','',0),(85574,2378,'dr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø³Øª Ø´Ø¯ ',0),(85575,2378,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø³Øª Ø´Ø¯ ',0),(85576,2378,'tr','FiÅŸ baÅŸarÄ±yla gÃ¶nderildi.',0),(85577,2378,'pl','PomyÅ›lnie wysÅ‚any kupon.',0),(85578,2378,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾ Ð²Ð°ÑƒÑ‡ÐµÑ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(85579,2378,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(85580,2378,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€.',0),(85581,2378,'vi','Phiáº¿u káº¿t chuyá»ƒn thÃ nh cÃ´ng',0),(85582,2378,'af','Bewysstuk suksesvol geposteer.',0),(85583,2378,'ro','Postat voucher cu succes.',0),(85584,2378,'et','Konteeritud kande edukalt.',0),(85585,2378,'si','UspeÅ¡no objavljen kupon.',0),(85586,2378,'ba','Posted voucher berhasil.',0),(85587,2378,'nl','Bon met succes geplaatst.',0),(85588,2378,'fi','LÃ¤hetetty tositteen onnistuneesti.',0),(85589,2378,'no','BokfÃ¸rt bilag vellykket.',0),(85590,2378,'da','BogfÃ¸rt voucher med succes.',0),(85591,2378,'ko','ë°”ìš°ì²˜ë¥¼ ì„±ê³µì ìœ¼ë¡œ ê²Œì‹œ ë¨.',0),(85592,2378,'he','×¤×•×¨×¡× ×©×•×‘×¨ ×‘×”×¦×œ×—×”.',0),(85593,2378,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Ï„Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹.',0),(85594,2378,'zh','å‘è¡¨å‡­è¯æˆåŠŸã€‚\r\n',0),(85595,2378,'sv','Postat verifikationen framgÃ¥ngsrikt.',0),(85596,2378,'it','Inviato il voucher con successo.',0),(85597,2378,'tl','',0),(85598,2378,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(85599,2378,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¥à¤°à¤•à¤¾à¤¶à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¥à¤¾à¥¤',0),(85600,2378,'ms','Hantar baucer berjaya.',0),(85601,2378,'ar','Ø£Ø±Ø³Ù„Øª Ø§Ù„Ø¥ÙŠØµØ§Ù„ Ø¨Ù†Ø¬Ø§Ø­.',0),(85602,2378,'fr','PostÃ© le voucher avec succÃ¨s.',0),(85603,2378,'jp','ä¼?ç¥¨ã‚’è¨ˆä¸Šã?—ã?¾ã?—ã?Ÿ',0),(85604,2378,'pt','Voucher Postado com sucesso.',0),(85605,2378,'ru','ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¾ Ð²Ð°ÑƒÑ‡ÐµÑ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(85606,2378,'es','Voucher asentado exitosamente',0),(85607,2378,'de','Gutschein erfolgreich gebucht.',0),(85608,2378,'en','Posted voucher successfully.',0),(85609,2379,'is','',0),(85610,2379,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(85611,2379,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(85612,2379,'tr','Prbended ekleme baÅŸarÄ±sÄ±z',0),(85613,2379,'pl','Wstaw Prbended nie powiodÅ‚o siÄ™',0),(85614,2379,'bg','Prbended Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(85615,2379,'ur','Ù†Ø§Ú©Ø§Ù… Ù¾Ø±Ø¨Ø§Ù†ÚˆÛŒØ¯ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(85616,2379,'sr','ÐŸÑ€Ð±ÐµÐ½Ð´ÐµÐ´ Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(85617,2379,'vi','ChÃ¨n Prbended tháº¥t báº¡i',0),(85618,2379,'af','Prbended insetsel het misluk',0),(85619,2379,'ro','Prbended Inserare nereuÈ™itÄƒ',0),(85620,2379,'et','Prbended lisamine nurjus',0),(85621,2379,'si','Vstavljanje Prbended ni uspela',0),(85622,2379,'ba','Masukkan Prbended gagal',0),(85623,2379,'nl','Prbended invoegen mislukt',0),(85624,2379,'fi','Prbended lisÃ¤Ã¤ epÃ¤onnistui',0),(85625,2379,'no','Prbended sett inn mislyktes',0),(85626,2379,'da','Prbended IndsÃ¦t mislykkedes',0),(85627,2379,'ko','Prbended ì‚½ìž… ì‹¤íŒ¨',0),(85628,2379,'he','×”×•×¡×¤×” Prbended × ×›×©×œ',0),(85629,2379,'el','Prbended ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(85630,2379,'zh','é¢„é›†ä¸­æ’å…¥å¤±è´¥\r\n',0),(85631,2379,'sv','Prbended infoga misslyckades',0),(85632,2379,'it','Inserimento di Prbended non riuscito',0),(85633,2379,'tl','',0),(85634,2379,'th','Prbended insert failed',0),(85635,2379,'hi','Prbended à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(85636,2379,'ms','Masukkan Prbended yang gagal',0),(85637,2379,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø¨Ø±Ø¨ÙŠÙ†Ø¯ÙŠØ¯ ÙØ´Ù„',0),(85638,2379,'fr','Ã‰chouÃ© de l\'insertion Prbended',0),(85639,2379,'jp','Prbended insert failed',0),(85640,2379,'pt','Inserir Prbended falhado',0),(85641,2379,'ru','Prbended Ð²ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(85642,2379,'es','FallÃ³ la inserciÃ³n de Pre doblado',0),(85643,2379,'de','Prbended einfÃ¼gen ist fehlgeschlagen',0),(85644,2379,'en','Prbended insert failed',0),(85645,2380,'is','',0),(85646,2380,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(85647,2380,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(85648,2380,'tr','Prdepositcheck ekleme baÅŸarÄ±sÄ±z oldu.',0),(85649,2380,'pl','Wstaw Prdepositcheck nie powiodÅ‚o siÄ™.',0),(85650,2380,'bg','Prdepositcheck Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð½Ðµ ÑƒÑÐ¿Ñ.',0),(85651,2380,'ur','Ù¾Ø±Ø¯Ù¾ÙˆØ³Ø§Ù¹Ú©ÛÛŒÚ© Ø¯Ø§Ø®Ù„ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§ Û”',0),(85652,2380,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ ÐŸÑ€Ð´ÐµÐ¿Ð¾ÑÐ¸Ñ‚Ñ†Ñ…ÐµÑ†Ðº Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÐ»Ð¾.',0),(85653,2380,'vi','ChÃ¨n SÃ©c Ä‘áº·t trÆ°á»›c tháº¥t báº¡i',0),(85654,2380,'af','Prdepositcheck insetsel het misluk.',0),(85655,2380,'ro','Prdepositcheck Inserare nereuÈ™itÄƒ.',0),(85656,2380,'et','Prdepositcheck lisamine nurjus.',0),(85657,2380,'si','Vstavljanje Prdepositcheck ni uspelo.',0),(85658,2380,'ba','Prdepositcheck Masukkan gagal.',0),(85659,2380,'nl','Prdepositcheck invoegen mislukt.',0),(85660,2380,'fi','Prdepositcheck lisÃ¤ys epÃ¤onnistui.',0),(85661,2380,'no','Sett inn Prdepositcheck mislyktes.',0),(85662,2380,'da','Prdepositcheck IndsÃ¦t mislykkedes.',0),(85663,2380,'ko','Prdepositcheck ì‚½ìž… í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(85664,2380,'he','×”×•×¡×¤×” Prdepositcheck × ×›×©×œ.',0),(85665,2380,'el','Prdepositcheck ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ.',0),(85666,2380,'zh','é¢„å­˜æ¬¾æ£€æŸ¥æ’å…¥å¤±è´¥ã€‚\r\n',0),(85667,2380,'sv','Det gick inte att infoga Prdepositcheck.',0),(85668,2380,'it','Inserisci Prdepositcheck non riuscita.',0),(85669,2380,'tl','',0),(85670,2380,'th','Prdepositcheck insert failed.',0),(85671,2380,'hi','Prdepositcheck à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾à¥¤',0),(85672,2380,'ms','Masukkan Prdepositcheck yang gagal.',0),(85673,2380,'ar','ÙØ´Ù„ Ø¥Ø¯Ø±Ø§Ø¬ Ø¨Ø±Ø¯ÙŠØ¨ÙˆØ³ÙŠØªØ´ÙŠÙƒ.',0),(85674,2380,'fr','Ã‰chouÃ© de l\'insertion Prdepositcheck.',0),(85675,2380,'jp','Prdepositcheck insert failed.',0),(85676,2380,'pt','Inserir Prdepositcheck falhou.',0),(85677,2380,'ru','Prdepositcheck Ð²ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ðµ ÑƒÐ´Ð°Ð»Ð°ÑÑŒ.',0),(85678,2380,'es','FallÃ³ la inserciÃ³n de Pre cheque de depÃ³sito',0),(85679,2380,'de','Prdepositcheck einfÃ¼gen ist fehlgeschlagen.',0),(85680,2380,'en','Prdepositcheck insert failed.',0),(85681,2381,'is','',0),(85682,2381,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù‡ÙØªÙ‡ Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85683,2381,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù‡ÙØªÙ‡ Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85684,2381,'tr','Premplweek ekleme baÅŸarÄ±sÄ±z oldu.',0),(85685,2381,'pl','Wstaw Premplweek nie powiodÅ‚o siÄ™.',0),(85686,2381,'bg','Premplweek Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð½Ðµ ÑƒÑÐ¿Ñ.',0),(85687,2381,'ur','Ù¾Ø±ÛŒÙ…Ù¾Ù„ÙˆÛŒÚ© Ø¯Ø§Ø®Ù„ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§ Û”',0),(85688,2381,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ ÐŸÑ€ÐµÐ¼Ð¿Ð»wÐµÐµÐº Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÐ»Ð¾.',0),(85689,2381,'vi','ChÃ¨n Premplweek tháº¥t báº¡i',0),(85690,2381,'af','Premplweek insetsel het misluk.',0),(85691,2381,'ro','Premplweek Inserare nereuÈ™itÄƒ.',0),(85692,2381,'et','Premplweek lisamine nurjus.',0),(85693,2381,'si','Vstavljanje Premplweek ni uspelo.',0),(85694,2381,'ba','Premplweek Masukkan gagal.',0),(85695,2381,'nl','Premplweek invoegen mislukt.',0),(85696,2381,'fi','Premplweek lisÃ¤ys epÃ¤onnistui.',0),(85697,2381,'no','Sett inn Premplweek mislyktes.',0),(85698,2381,'da','Premplweek IndsÃ¦t mislykkedes.',0),(85699,2381,'ko','Premplweek ì‚½ìž… í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(85700,2381,'he','×”×•×¡×¤×” Premplweek × ×›×©×œ.',0),(85701,2381,'el','Premplweek ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ.',0),(85702,2381,'zh','é¢„è˜ç”¨å‘¨æ’å…¥å¤±è´¥ã€‚\r\n\r\n\r\n\r\n',0),(85703,2381,'sv','Det gick inte att infoga Premplweek.',0),(85704,2381,'it','Inserisci Premplweek non riuscita.',0),(85705,2381,'tl','',0),(85706,2381,'th','Premplweek insert failed.',0),(85707,2381,'hi','Premplweek à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾à¥¤',0),(85708,2381,'ms','Masukkan Premplweek yang gagal.',0),(85709,2381,'ar','ÙØ´Ù„ Ø¥Ø¯Ø±Ø§Ø¬ Ø¨Ø±ÙŠÙ…Ø¨Ù„ÙˆÙŠÙƒ.',0),(85710,2381,'fr','Ã‰chouÃ© de l\'insertion Premplweek.',0),(85711,2381,'jp','Premplweek insert failed.',0),(85712,2381,'pt','Inserir Premplweek falhou.',0),(85713,2381,'ru','Premplweek Ð²ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ðµ ÑƒÐ´Ð°Ð»Ð°ÑÑŒ.',0),(85714,2381,'es','InserciÃ³n de pre semana de empleado',0),(85715,2381,'de','Premplweek einfÃ¼gen ist fehlgeschlagen.',0),(85716,2381,'en','Premplweek insert failed.',0),(85717,2382,'is','',0),(85718,2382,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù‡ÙØªÙ‡ Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85719,2382,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù‡ÙØªÙ‡ Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85720,2382,'tr','Premplweek gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu.',0),(85721,2382,'pl','Premplweek aktualizacja nie powiodÅ‚a siÄ™.',0),(85722,2382,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Premplweek.',0),(85723,2382,'ur','Ù¾Ø±ÛŒÙ…Ù¾Ù„ÙˆÛŒÚ© Ø§Ù¾ ÚˆÛŒÙ¹ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§ Û”',0),(85724,2382,'sr','ÐŸÑ€ÐµÐ¼Ð¿Ð»wÐµÐµÐº Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(85725,2382,'vi','Cáº­p nháº­t tháº¥t báº¡i',0),(85726,2382,'af','Premplweek bywerking het misluk.',0),(85727,2382,'ro','Premplweek actualizare nu a reuÅŸit.',0),(85728,2382,'et','Premplweek vÃ¤rskendamine nurjus.',0),(85729,2382,'si','Premplweek ni mogoÄe posodobiti.',0),(85730,2382,'ba','Premplweek gagal update.',0),(85731,2382,'nl','Premplweek bijwerken is mislukt.',0),(85732,2382,'fi','Premplweek pÃ¤ivitys epÃ¤onnistui.',0),(85733,2382,'no','Premplweek oppdatering mislyktes.',0),(85734,2382,'da','Opdatering af Premplweek mislykkedes.',0),(85735,2382,'ko','Premplweek ì—…ë°ì´íŠ¸ë¥¼ ì‹¤íŒ¨ í–ˆìŠµë‹ˆë‹¤.',0),(85736,2382,'he','×¢×“×›×•×Ÿ Premplweek × ×›×©×œ.',0),(85737,2382,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Premplweek.',0),(85738,2382,'zh','è˜ç”¨å‰ä¸€å‘¨æ›´æ–°å¤±è´¥ã€‚\r\nè˜ç”¨å‰ä¸€å‘¨æ›´æ–°å¤±è´¥ã€‚\r\n\r\nè˜ç”¨å‰ä¸€å‘¨æ›´æ–°å¤±è´¥ã€‚\r\n\r\nè˜ç”¨å‰ä¸€å‘¨æ›´æ–°å¤±è´¥ã€‚\r\n\r\nè˜ç”¨å‰ä¸€å‘¨æ›´æ–°å¤±è´¥ã€‚\r\n\r\nè˜ç”¨å‰ä¸€å‘¨æ›´æ–°å¤±è´¥ã€‚\r\n',0),(85739,2382,'sv','Det gick inte att uppdatera Premplweek.',0),(85740,2382,'it','Premplweek aggiornamento non riuscito.',0),(85741,2382,'tl','',0),(85742,2382,'th','Premplweek update failed.',0),(85743,2382,'hi','Premplweek à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¥‡à¥¤',0),(85744,2382,'ms','Premplweek kemas kini gagal.',0),(85745,2382,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø¨Ø±ÙŠÙ…Ø¨Ù„ÙˆÙŠÙƒ.',0),(85746,2382,'fr','Premplweek mise Ã  jour a Ã©chouÃ©.',0),(85747,2382,'jp','Premplweek update failed.',0),(85748,2382,'pt','Premplweek falhada na atualizaÃ§Ã£o.',0),(85749,2382,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Premplweek.',0),(85750,2382,'es','ActualizaciÃ³n de pre semana de empleado fallÃ³',0),(85751,2382,'de','Premplweek-Aktualisierung fehlgeschlagen.',0),(85752,2382,'en','Premplweek update failed.',0),(85753,2383,'is','',0),(85754,2383,'dr','/  Ø±Ø®ØµØªÛŒ Ø¹Ø§Ø¬Ù„ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85755,2383,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù‡ÙØªÙ‡ Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯  Ù…Ø±Ø®ØµÙŠ /  Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85756,2383,'tr','Premployeeweek tatil/hasta gÃ¼ncelleme baÅŸarÄ±sÄ±z bÄ±rakÄ±n.',0),(85757,2383,'pl','Premployeeweek wakacje/chorych pozostawiÄ‡ aktualizacji nie powiodÅ‚o siÄ™.',0),(85758,2383,'bg','Premployeeweek Ð²Ð°ÐºÐ°Ð½Ñ†Ð¸Ñ/Ð¾Ñ‚Ð¿ÑƒÑÐº Ð¿Ð¾ Ð±Ð¾Ð»ÐµÑÑ‚ ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ.',0),(85759,2383,'ur','Ù¾Ø±ÛŒÙ…Ø§ÛŒÛŒÙˆÛŒÚ© Ú†Ú¾Ù¹ÛŒ/Ø¨ÛŒÙ…Ø§Ø± Ù†Ø§Ú©Ø§Ù… Ø§Ù¾ ÚˆÛŒÙ¹ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº Û”',0),(85760,2383,'sr','ÐŸÑ€ÐµÐ¼Ð¿Ð»Ð¾yÐµÐµwÐµÐµÐº Ð¾Ð´Ð¼Ð¾Ñ€/Ð±Ð¾Ð»Ð¾Ð²Ð°ÑšÐ° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(85761,2383,'vi','Cáº­p nháº­t ká»³ nghá»‰ Premployeeweek/nghá»‰ bá»‡nh tháº¥t báº¡i',0),(85762,2383,'af','Premployeeweek vakansie/siekteverlof bywerking het misluk.',0),(85763,2383,'ro','Premployeeweek vacanta/concediu concediu actualizarea nu a reuÈ™it.',0),(85764,2383,'et','Premployeeweek puhkus/haige jÃ¤ta vÃ¤rskendamine nurjus.',0),(85765,2383,'si','Premployeeweek dopust/bolniÅ¡kih ni mogoÄe posodobiti.',0),(85766,2383,'ba','Premployeeweek liburan/sakit meninggalkan gagal update.',0),(85767,2383,'nl','Premployeeweek vakantie/ziek laat update is mislukt.',0),(85768,2383,'fi','Premployeeweek loma/Sairausloma pÃ¤ivitys epÃ¤onnistui.',0),(85769,2383,'no','Premployeeweek ferie/sykedager la oppdatering mislyktes.',0),(85770,2383,'da','Premployeeweek ferie/syg efterlade opdatering mislykkedes.',0),(85771,2383,'ko','Premployeeweek íœ´ê°€/ì•„í”ˆ ë‘ê³  ì—…ë°ì´íŠ¸ ì‹¤íŒ¨.',0),(85772,2383,'he','Premployeeweek × ×•×¤×©/×—×•×œ×” ×œ×”×©××™×¨ ×”×¢×“×›×•×Ÿ × ×›×©×œ.',0),(85773,2383,'el','Premployeeweek Î´Î¹Î±ÎºÎ¿Ï€Î­Ï‚/Î±Î½Î±ÏÏÏ‰Ï„Î¹ÎºÎ® Î¬Î´ÎµÎ¹Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ.',0),(85774,2383,'zh','å‰é›‡å‘˜æ˜ŸæœŸçš„ä¼‘å‡/ç—…å‡æ›´æ–°å¤±è´¥ã€‚\r\n',0),(85775,2383,'sv','Premployeeweek sjukfrÃ¥nvaro semester /, gick inte att uppdatera.',0),(85776,2383,'it','Premployeeweek vacanza/malato lasciare aggiornamento non riuscito.',0),(85777,2383,'tl','',0),(85778,2383,'th','Premployeeweek vacation/sick leave update failed.',0),(85779,2383,'hi','Premployeeweek à¤…à¤µà¤•à¤¾à¤¶/à¤¬à¥€à¤®à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤² à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚à¥¤',0),(85780,2383,'ms','Premployeeweek percutian/sakit meninggalkan kemas kini gagal.',0),(85781,2383,'ar','Ø¨Ø±ÙŠÙ…Ø¨Ù„ÙˆÙŠÙŠÙˆÙŠÙƒ Ø¹Ø·Ù„Ø©/Ø§Ù„Ù…Ø±Ø¶Ù‰ Ù…ØºØ§Ø¯Ø±Ø© ÙØ´Ù„ ØªØ­Ø¯ÙŠØ«.',0),(85782,2383,'fr','Premployeeweek vacances/congÃ© de mise Ã  jour a Ã©chouÃ©.',0),(85783,2383,'jp','Premployeeweek vacation/sick leave update failed.',0),(85784,2383,'pt','Premployeeweek fÃ©rias/doente sair atualizaÃ§Ã£o falhada.',0),(85785,2383,'ru','Premployeeweek Ð¾Ñ‚Ð¿ÑƒÑÐºÐ°/Ð±Ð¾Ð»ÐµÐ·Ð½Ð¸ Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ.',0),(85786,2383,'es','Pre semana de empleado vacaciones/vacaciones de enfermedad Fallaron',0),(85787,2383,'de','Premployeeweek Urlaub/Kranke lassen Update fehlgeschlagen.',0),(85788,2383,'en','Premployeeweek vacation/sick leave update failed.',0),(85789,2384,'is','',0),(85790,2384,'dr','Ù…Ø§Ø´ÙŠÙ† Ù…Ù…ØªØ§Ø²',0),(85791,2384,'pr','Ù…Ø§Ø´ÙŠÙ† Ù…Ù…ØªØ§Ø²',0),(85792,2384,'tr','Tercih edilen makine',0),(85793,2384,'pl','Preferowana maszyna',0),(85794,2384,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(85795,2384,'ur','ØªØ±Ø¬ÛŒØ­ÛŒ Ù…Ø´ÛŒÙ†',0),(85796,2384,'sr','ÐŸÑ€ÐµÑ„ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(85797,2384,'vi','MÃ¡y Æ°a thÃ­ch',0),(85798,2384,'af','Verkiesde Masjien',0),(85799,2384,'ro','Masina de preferat',0),(85800,2384,'et','Eelistatud masin',0),(85801,2384,'si','Raje stroj',0),(85802,2384,'ba','Pilihan mesin',0),(85803,2384,'nl','Voorkeur Machine',0),(85804,2384,'fi','Ensisijainen kone',0),(85805,2384,'no','Foretrukket maskin',0),(85806,2384,'da','Foretrukne maskine',0),(85807,2384,'ko','ì„ í˜¸ ê¸°ê³„',0),(85808,2384,'he','×ž×›×©×™×¨ ×ž×•×¢×“×£',0),(85809,2384,'el','Î ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î¼Î·Ï‡Î±Î½Î®',0),(85810,2384,'zh','é¦–é€‰æœº\r\n',0),(85811,2384,'sv','Rekommenderad maskin',0),(85812,2384,'it','Macchina preferito',0),(85813,2384,'tl','',0),(85814,2384,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(85815,2384,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤®à¤¶à¥€à¤¨',0),(85816,2384,'ms','Pilihan Mesin',0),(85817,2384,'ar','Ø§Ù„Ø¬Ù‡Ø§Ø² Ø§Ù„Ù…ÙØ¶Ù„',0),(85818,2384,'fr','Machine prÃ©fÃ©rÃ©e',0),(85819,2384,'jp','å„ªå…ˆæ©Ÿæ¢°',0),(85820,2384,'pt','MÃ¡quina preferencial',0),(85821,2384,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(85822,2384,'es','MÃ¡quina Prefirida',0),(85823,2384,'de','Bevorzugte Maschine',0),(85824,2384,'en','Preferred Machine',0),(85825,2385,'is','',0),(85826,2385,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ú†Ø§Ù¾ Ù…Ù…ØªØ§Ø²',0),(85827,2385,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ú†Ø§Ù¾ Ù…Ù…ØªØ§Ø²',0),(85828,2385,'tr','Tercih edilen yazdÄ±rma seÃ§eneÄŸi',0),(85829,2385,'pl','Preferowana opcja wydruku',0),(85830,2385,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½Ð° Ð¾Ð¿Ñ†Ð¸Ñ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(85831,2385,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø§Ø®ØªÛŒØ§Ø± Ú©Ùˆ ØªØ±Ø¬ÛŒØ­ Ø¯ÛŒ',0),(85832,2385,'sr','Ð–ÐµÑ™ÐµÐ½Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ°',0),(85833,2385,'vi','Lá»±a chá»n in Æ°a thÃ­ch',0),(85834,2385,'af','Druk opsie verkies',0),(85835,2385,'ro','OpÅ£iunea preferatÄƒ de imprimare',0),(85836,2385,'et','Eelistatud printimise suvand',0),(85837,2385,'si','NajprimernejÅ¡a moÅ¾nost tiskanja',0),(85838,2385,'ba','Pilihan pilihan cetak',0),(85839,2385,'nl','Gewenste afdrukoptie',0),(85840,2385,'fi','Ensisijainen Tulosta vaihtoehto',0),(85841,2385,'no','Ã˜nsket utskriften valgmuligheten',0),(85842,2385,'da','Foretrukne udskriftsindstillingen',0),(85843,2385,'ko','ì›í•˜ëŠ” ì¸ì‡„ ì˜µì…˜',0),(85844,2385,'he','××¤×©×¨×•×ª ×”×“×¤×¡×” ×ž×•×¢×“×¤×ª',0),(85845,2385,'el','Î ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· ÎµÏ€Î¹Î»Î¿Î³Î® ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(85846,2385,'zh','é¦–é€‰æ‰“å°é€‰é¡¹\r\n',0),(85847,2385,'sv','Rekommenderad utskriftsalternativet',0),(85848,2385,'it','Opzione di stampa preferito',0),(85849,2385,'tl','',0),(85850,2385,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(85851,2385,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤®à¥à¤¦à¥à¤°à¤£ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(85852,2385,'ms','Pilihan pilihan cetak',0),(85853,2385,'ar','ÙŠÙØ¶Ù„ Ø®ÙŠØ§Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(85854,2385,'fr','Option d\'impression prÃ©fÃ©rÃ©e',0),(85855,2385,'jp','å„ªå…ˆå?°åˆ·ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(85856,2385,'pt','OpÃ§Ã£o de impressÃ£o preferencial',0),(85857,2385,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ ÐŸÐµÑ‡Ð°Ñ‚Ð¸',0),(85858,2385,'es','OpciÃ³n de ImpresiÃ³n Preferida',0),(85859,2385,'de','Bevorzugte Druckoption',0),(85860,2385,'en','Preferred Print Option',0),(85861,2386,'is','',0),(85862,2386,'dr','(ØªØ±Ø¬ÛŒØ­ÛŒ ',0),(85863,2386,'pr','Ù‚Ø¨Ù„ Ø§Ø² Ù¾Ø±ÙˆØ§Ø² (Ù…Ù…ØªØ§Ø²',0),(85864,2386,'tr','Ã–n kontrol',0),(85865,2386,'pl','WstÄ™pna',0),(85866,2386,'bg','Ð˜Ð·Ð²ÑŠÑ€ÑˆÐ²Ð°Ð¹Ñ‚Ðµ Ñ‚ÐµÑ…Ð½Ð¸Ñ Ñ„Ð¸Ð½Ð°Ð»ÐµÐ½ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(85867,2386,'ur','Ù¾Ø±ÛŒÙÙ„Ú¯ÛÙ¹',0),(85868,2386,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° Ð¿Ñ€Ðµ Ð»ÐµÑ‚Ð°',0),(85869,2386,'vi','TrÆ°á»›c chuyáº¿n bay',0),(85870,2386,'af','Preflight',0),(85871,2386,'ro','Verificare',0),(85872,2386,'et','Eelkontroll',0),(85873,2386,'si','Preverjanje pred tiskom',0),(85874,2386,'ba','Preflight',0),(85875,2386,'nl','Preflight',0),(85876,2386,'fi','Esitarkastus',0),(85877,2386,'no','ForhÃ¥ndskontroll',0),(85878,2386,'da','ForhÃ¥ndskontrol',0),(85879,2386,'ko','í”„ë¦¬í”Œë¼ì´íŠ¸',0),(85880,2386,'he','×‘×“×™×§×ª ××™×›×•×ª',0),(85881,2386,'el','Î ÏÎ¿ÎºÎ±Ï„Î±ÏÎºÏ„Î¹ÎºÏŒÏ‚ Î­Î»ÎµÎ³Ï‡Î¿Ï‚',0),(85882,2386,'zh','è´§è¿å‰\r\n',0),(85883,2386,'sv','Preflight',0),(85884,2386,'it','Verifica preliminare',0),(85885,2386,'tl','',0),(85886,2386,'th','&#3648;&#3607;&#3637;&#3656;&#3618;&#3623;&#3610;&#3636;&#3609;&#3585;&#3656;&#3629;&#3609;',0),(85887,2386,'hi','Preflight',0),(85888,2386,'ms','Preflight',0),(85889,2386,'ar','Ø§Ù„Ø§Ø®ØªØ¨Ø§Ø± Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(85890,2386,'fr','ContrÃ´le en amont',0),(85891,2386,'jp','é£›è¡Œå‰?',0),(85892,2386,'pt','ComprovaÃ§Ã£o',0),(85893,2386,'ru','ÐŸÑ€ÐµÐ´Ð¿ÐµÑ‡Ð°Ñ‚Ð½Ð°Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(85894,2386,'es','Prevuelo InspecciÃ³n',0),(85895,2386,'de','Preflight-PrÃ¼fung',0),(85896,2386,'en','Preflight',0),(85897,2387,'is','',0),(85898,2387,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ³ÙˆØ±Ø§Øª Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85899,2387,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ³ÙˆØ±Ø§Øª Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85900,2387,'tr','Prempldeduction gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu.',0),(85901,2387,'pl','Prempldeduction aktualizacja nie powiodÅ‚a siÄ™.',0),(85902,2387,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Prempldeduction.',0),(85903,2387,'ur','Ù¾Ø±ÛŒÙ…Ù¾Ù„ÚˆØ§Ø¯ÙˆÚ©Ø´Ù† Ø§Ù¾ ÚˆÛŒÙ¹ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§ Û”',0),(85904,2387,'sr','ÐŸÑ€ÐµÐ¼Ð¿Ð»Ð´ÐµÐ´ÑƒÑ†Ñ‚Ð¸Ð¾Ð½ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(85905,2387,'vi','Cáº­p nháº­t tháº¥t báº¡i',0),(85906,2387,'af','Prempldeduction bywerking het misluk.',0),(85907,2387,'ro','Prempldeduction actualizare nu a reuÅŸit.',0),(85908,2387,'et','Prempldeduction vÃ¤rskendamine nurjus.',0),(85909,2387,'si','Prempldeduction ni mogoÄe posodobiti.',0),(85910,2387,'ba','Prempldeduction gagal update.',0),(85911,2387,'nl','Prempldeduction bijwerken is mislukt.',0),(85912,2387,'fi','Prempldeduction pÃ¤ivitys epÃ¤onnistui.',0),(85913,2387,'no','Prempldeduction oppdatering mislyktes.',0),(85914,2387,'da','Opdatering af Prempldeduction mislykkedes.',0),(85915,2387,'ko','Prempldeduction ì—…ë°ì´íŠ¸ë¥¼ ì‹¤íŒ¨ í–ˆìŠµë‹ˆë‹¤.',0),(85916,2387,'he','×¢×“×›×•×Ÿ Prempldeduction × ×›×©×œ.',0),(85917,2387,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Prempldeduction.',0),(85918,2387,'zh','é¢„æ‰£çš„MPLæ›´æ–°å¤±è´¥',0),(85919,2387,'sv','Det gick inte att uppdatera Prempldeduction.',0),(85920,2387,'it','Prempldeduction aggiornamento non riuscito.',0),(85921,2387,'tl','',0),(85922,2387,'th','Prempldeduction update failed.',0),(85923,2387,'hi','Prempldeduction à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¥‡à¥¤',0),(85924,2387,'ms','Prempldeduction kemas kini gagal.',0),(85925,2387,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø¨Ø±ÙŠÙ…Ø¨Ù„Ø¯ÙŠØ¯ÙˆÙƒØ´Ù†.',0),(85926,2387,'fr','Prempldeduction mise Ã  jour a Ã©chouÃ©.',0),(85927,2387,'jp','Prempldeduction update failed.',0),(85928,2387,'pt','Prempldeduction falhada na atualizaÃ§Ã£o.',0),(85929,2387,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Prempldeduction.',0),(85930,2387,'es','ActualizaciÃ³n de Pre deducciÃ³n de empleado fallÃ³',0),(85931,2387,'de','Prempldeduction-Aktualisierung fehlgeschlagen.',0),(85932,2387,'en','Prempldeduction update failed.',0),(85933,2388,'is','',0),(85934,2388,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85935,2388,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85936,2388,'tr','Premployee gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu.',0),(85937,2388,'pl','Premployee aktualizacja nie powiodÅ‚a siÄ™.',0),(85938,2388,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Premployee.',0),(85939,2388,'ur','Ù¾Ø±ÛŒÙ…Ù¾Ù„ÙˆÛŒÛŒ Ø§Ù¾ ÚˆÛŒÙ¹ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§ Û”',0),(85940,2388,'sr','ÐŸÑ€ÐµÐ¼Ð¿Ð»Ð¾yÐµÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(85941,2388,'vi','Cáº­p nháº­t tháº¥t báº¡i',0),(85942,2388,'af','Werknemer opdatering gefaal.',0),(85943,2388,'ro','Premployee actualizare nu a reuÅŸit.',0),(85944,2388,'et','Premployee vÃ¤rskendamine nurjus.',0),(85945,2388,'si','Premployee ni mogoÄe posodobiti.',0),(85946,2388,'ba','Premployee gagal update.',0),(85947,2388,'nl','Premployee bijwerken is mislukt.',0),(85948,2388,'fi','PREmployee pÃ¤ivitys epÃ¤onnistui.',0),(85949,2388,'no','IRAnsatt oppdatering mislyktes.',0),(85950,2388,'da','PREmployee opdateringen mislykkedes.',0),(85951,2388,'ko','Premployee ì—…ë°ì´íŠ¸ë¥¼ ì‹¤íŒ¨ í–ˆìŠµë‹ˆë‹¤.',0),(85952,2388,'he','×¢×“×›×•×Ÿ Premployee × ×›×©×œ.',0),(85953,2388,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Premployee.',0),(85954,2388,'zh','æœªæ¥é›‡å‘˜æ›´æ–°å¤±è´¥ã€‚\r\n',0),(85955,2388,'sv','PREmployee uppdateringen misslyckades.',0),(85956,2388,'it','PREmployee aggiornamento non riuscito.',0),(85957,2388,'tl','',0),(85958,2388,'th','Premployee update failed.',0),(85959,2388,'hi','Premployee à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¥‡à¥¤',0),(85960,2388,'ms','Premployee kemas kini gagal.',0),(85961,2388,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Premployee.',0),(85962,2388,'fr','PREmployee mise Ã  jour a Ã©chouÃ©.',0),(85963,2388,'jp','Premployee update failed.',0),(85964,2388,'pt','Premployee falhada na atualizaÃ§Ã£o.',0),(85965,2388,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Premployee.',0),(85966,2388,'es','ActualizaciÃ³n de Pre Empleado fallÃ³',0),(85967,2388,'de','Premployee-Aktualisierung fehlgeschlagen.',0),(85968,2388,'en','Premployee update failed.',0),(85969,2389,'is','',0),(85970,2389,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ³ÙˆØ±Ø§Øª Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85971,2389,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ³ÙˆØ±Ø§Øª Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(85972,2389,'tr','Premplweekdeddetail gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu.',0),(85973,2389,'pl','Premplweekdeddetail aktualizacja nie powiodÅ‚a siÄ™.',0),(85974,2389,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Premplweekdeddetail.',0),(85975,2389,'ur','Ù¾Ø±ÛŒÙ…Ù¾Ù„ÙˆÛŒÚ©Ø¯ÛŒÚˆÛŒÙ¹Ø§Ø§Ù„ Ø§Ù¾ ÚˆÛŒÙ¹ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§ Û”',0),(85976,2389,'sr','ÐŸÑ€ÐµÐ¼Ð¿Ð»wÐµÐµÐºÐ´ÐµÐ´Ð´ÐµÑ‚Ð°Ð¸Ð» Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(85977,2389,'vi','Cáº­p nháº­t tháº¥t báº¡i',0),(85978,2389,'af','Premplweekdeddetail bywerking het misluk.',0),(85979,2389,'ro','Premplweekdeddetail actualizare nu a reuÅŸit.',0),(85980,2389,'et','Premplweekdeddetail vÃ¤rskendamine nurjus.',0),(85981,2389,'si','Premplweekdeddetail ni mogoÄe posodobiti.',0),(85982,2389,'ba','Premplweekdeddetail gagal update.',0),(85983,2389,'nl','Premplweekdeddetail bijwerken is mislukt.',0),(85984,2389,'fi','Premplweekdeddetail pÃ¤ivitys epÃ¤onnistui.',0),(85985,2389,'no','Premplweekdeddetail oppdatering mislyktes.',0),(85986,2389,'da','Opdatering af Premplweekdeddetail mislykkedes.',0),(85987,2389,'ko','Premplweekdeddetail ì—…ë°ì´íŠ¸ë¥¼ ì‹¤íŒ¨ í–ˆìŠµë‹ˆë‹¤.',0),(85988,2389,'he','×¢×“×›×•×Ÿ Premplweekdeddetail × ×›×©×œ.',0),(85989,2389,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Premplweekdeddetail.',0),(85990,2389,'zh','ä¸€å‘¨å‰è˜è¯·å¾·è¯¦ç»†æ›´æ–°å¤±è´¥\r\n',0),(85991,2389,'sv','Det gick inte att uppdatera Premplweekdeddetail.',0),(85992,2389,'it','Premplweekdeddetail aggiornamento non riuscito.',0),(85993,2389,'tl','',0),(85994,2389,'th','Premplweekdeddetail update failed.',0),(85995,2389,'hi','Premplweekdeddetail à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¥‡à¥¤',0),(85996,2389,'ms','Premplweekdeddetail kemas kini gagal.',0),(85997,2389,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø¨Ø±ÙŠÙ…Ø¨Ù„ÙˆÙŠÙƒØ¯ÙŠØ¯ÙŠØªØ§ÙŠÙ„.',0),(85998,2389,'fr','Premplweekdeddetail mise Ã  jour a Ã©chouÃ©.',0),(85999,2389,'jp','Premplweekdeddetail update failed.',0),(86000,2389,'pt','Premplweekdeddetail falhada na atualizaÃ§Ã£o.',0),(86001,2389,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Premplweekdeddetail.',0),(86002,2389,'es','ActualizaciÃ³n de Pre empleado semana de detalle fallÃ³',0),(86003,2389,'de','Premplweekdeddetail-Aktualisierung fehlgeschlagen.',0),(86004,2389,'en','Premplweekdeddetail update failed.',0),(86005,2390,'is','',0),(86006,2390,'dr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(86007,2390,'pr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(86008,2390,'tr','Ã–n Ã¶demeli',0),(86009,2390,'pl','Pre Paid',0),(86010,2390,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(86011,2390,'ur','Ù‚Ø¨Ù„ Ø§Ø² Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(86012,2390,'sr','ÐŸÐ»Ð°Ñ‚Ð¸Ð¾ ÑƒÐ½Ð°Ð¿Ñ€ÐµÐ´',0),(86013,2390,'vi','Tráº£ trÆ°á»›c',0),(86014,2390,'af','Vooruitbetaal',0),(86015,2390,'ro','Pre-plÄƒtit',0),(86016,2390,'et','Ettemaksuga',0),(86017,2390,'si','Vnaprej plaÄane',0),(86018,2390,'ba','Pra-bayar',0),(86019,2390,'nl','Vooraf betaalde',0),(86020,2390,'fi','Prepaid',0),(86021,2390,'no','ForhÃ¥ndsbetalt',0),(86022,2390,'da','Forudbetalt',0),(86023,2390,'ko','ì„ ë¶ˆ',0),(86024,2390,'he','×‘×ª×©×œ×•× ×ž×¨××©',0),(86025,2390,'el','Î ÏÎ¿Ï€Î»Î·ÏÏ‰Î¼Î­Î½Î· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(86026,2390,'zh','é¢„ä»˜è´¹\r\n',0),(86027,2390,'sv','FÃ¶rbetalda',0),(86028,2390,'it','Pre-pagato',0),(86029,2390,'tl','',0),(86030,2390,'th','&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3585;&#3656;&#3629;&#3609;',0),(86031,2390,'hi','à¤ªà¥‚à¤°à¥à¤µ-à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(86032,2390,'ms','Bayar dahulu',0),(86033,2390,'ar','Ù…Ø¯ÙÙˆØ¹ Ù…Ø³Ø¨Ù‚Ø§',0),(86034,2390,'fr','Pre-Paid',0),(86035,2390,'jp','ãƒ—ãƒªãƒšã‚¤ãƒ‰',0),(86036,2390,'pt','PrÃ©-pago',0),(86037,2390,'ru','ÐŸÑ€ÐµÐ´Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(86038,2390,'es','Pre-Pagado',0),(86039,2390,'de','Pre-Paid',0),(86040,2390,'en','Pre-Paid',0),(86041,2391,'is','',0),(86042,2391,'dr','Ú†Ø§Ù¾ Ø§ÙˆÙ„ÙŠÙ‡',0),(86043,2391,'pr','Ú†Ø§Ù¾ Ø§ÙˆÙ„ÙŠÙ‡',0),(86044,2391,'tr','BaskÄ± Ã¶ncesi',0),(86045,2391,'pl','Przygotowanie do druku',0),(86046,2391,'bg','ÐŸÑ€ÐµÐ´Ð¿ÐµÑ‡Ð°Ñ‚',0),(86047,2391,'ur','Ù‚Ø¨Ù„ Ø·Ø¨Ø§Ø¹Øª',0),(86048,2391,'sr','ÐŸÑ€Ð¸Ð¿Ñ€ÐµÐ¼Ð° Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ñƒ',0),(86049,2391,'vi','TrÆ°á»›c khi in',0),(86050,2391,'af','Voor\"press\"',0),(86051,2391,'ro','Prepress',0),(86052,2391,'et','TrÃ¼kieelne tÃ¶Ã¶tlus',0),(86053,2391,'si','Priprava za tisk',0),(86054,2391,'ba','Prepress',0),(86055,2391,'nl','Prepress',0),(86056,2391,'fi','Prepress',0),(86057,2391,'no','FÃ¸rtrykk',0),(86058,2391,'da','Prepress',0),(86059,2391,'ko','ì‹œí—˜ ì¸ì‡„',0),(86060,2391,'he','×§×“× ×“×¤×•×¡',0),(86061,2391,'el','Î ÏÎ¿ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(86062,2391,'zh','å°å‰\r\n',0),(86063,2391,'sv','Prepress',0),(86064,2391,'it','Prestampa',0),(86065,2391,'tl','',0),(86066,2391,'th','&#3585;&#3656;&#3629;&#3609;&#3585;&#3604;',0),(86067,2391,'hi','Prepress',0),(86068,2391,'ms','Prepress',0),(86069,2391,'ar','Ù…Ø§ Ù‚Ø¨Ù„ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(86070,2391,'fr','PrÃ©presse',0),(86071,2391,'jp','è£½ç‰ˆ',0),(86072,2391,'pt','PrÃ©-impressÃ£o',0),(86073,2391,'ru','Ð”Ð¾Ð¿ÐµÑ‡Ð°Ñ‚Ð½Ð°Ñ Ð¿Ð¾Ð´Ð³Ð¾Ñ‚Ð¾Ð²ÐºÐ°',0),(86074,2391,'es','Pre ImpresiÃ³n',0),(86075,2391,'de','Druckvorstufe',0),(86076,2391,'en','Prepress',0),(86077,2392,'is','',0),(86078,2392,'dr','Ù…Ù‚Ø¯Ø§Ø± Ú†Ø§Ù¾ \r\n',0),(86079,2392,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú†Ø§Ù¾ \r\n',0),(86080,2392,'tr','BasÄ±n Mkt.',0),(86081,2392,'pl','IloÅ›Ä‡ prasy',0),(86082,2392,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÐºÐ¾Ð»',0),(86083,2392,'ur','Ù‚ÛŒ Ø¯Ø¨Ø§Ø¦ÛŒÚº',0),(86084,2392,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ ÐšÐ¾Ð».',0),(86085,2392,'vi','Sá»‘ lÆ°á»£ng bÃ¡o',0),(86086,2392,'af','Druk Qty',0),(86087,2392,'ro','Cantit Ã®n presÄƒ',0),(86088,2392,'et','Vajutage kogus',0),(86089,2392,'si','Pritisnite kol.',0),(86090,2392,'ba','Tekan Qty',0),(86091,2392,'nl','Druk op aantal',0),(86092,2392,'fi','Paina mÃ¤Ã¤rÃ¤',0),(86093,2392,'no','Trykk Ant',0),(86094,2392,'da','Tryk pÃ¥ antal',0),(86095,2392,'ko','ë³´ë„ ìˆ˜ëŸ‰',0),(86096,2392,'he','×”×§×© ×¢×œ ×›×ž×•×ª',0),(86097,2392,'el','Î¤ÏÏ€Î¿Ï‚ Î Î¿Ïƒ.',0),(86098,2392,'zh','å°åˆ·æ•°é‡\r\n',0),(86099,2392,'sv','Tryck pÃ¥ antal',0),(86100,2392,'it','Premere q. tÃ ',0),(86101,2392,'tl','',0),(86102,2392,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3585;&#3604;',0),(86103,2392,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(86104,2392,'ms','Tekan Qty',0),(86105,2392,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(86106,2392,'fr','QtÃ© de presse',0),(86107,2392,'jp','ãƒ—ãƒ¬ã‚¹æ•°é‡?',0),(86108,2392,'pt','Qtde de imprensa',0),(86109,2392,'ru','Qty Ð¿Ñ€ÐµÑÑ',0),(86110,2392,'es','Prensa cant.',0),(86111,2392,'de','Presse Qty',0),(86112,2392,'en','Press Qty',0),(86113,2393,'is','',0),(86114,2393,'dr','* Ø±Ù†Ú¯Ù‡Ø§',0),(86115,2393,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú†Ø§Ù¾ * Ø±Ù†Ú¯Ù‡Ø§',0),(86116,2393,'tr','BasÄ±n miktar Renkler x',0),(86117,2393,'pl','NaciÅ›nij iloÅ›Ä‡ x kolory',0),(86118,2393,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(86119,2393,'ur','Ø¯Ø¨Ø§Ø¦ÛŒÚº Ù‚ÛŒ Ø±Ù†Ú¯ x',0),(86120,2393,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ ÐšÐ¾Ð» x Ð±Ð¾Ñ˜Ðµ',0),(86121,2393,'vi','Sá»‘ lÆ°á»£ng bÃ¡o x Máº§u',0),(86122,2393,'af','Druk Qty x kleure',0),(86123,2393,'ro','ApÄƒsaÅ£i cantit x culori',0),(86124,2393,'et','Vajutage kogus x vÃ¤rvid',0),(86125,2393,'si','Pritisnite koliÄina x barve',0),(86126,2393,'ba','Tekan Qty x warna',0),(86127,2393,'nl','Druk op aantal x kleuren',0),(86128,2393,'fi','Paina mÃ¤Ã¤rÃ¤ x vÃ¤rit',0),(86129,2393,'no','Trykk antall x farger',0),(86130,2393,'da','Tryk pÃ¥ antal x farver',0),(86131,2393,'ko','Qtyë¥¼ ëˆŒëŸ¬ ìƒ‰ x',0),(86132,2393,'he','×”×§×© ×¢×œ ×›×ž×•×ª x ×¦×‘×¢×™×',0),(86133,2393,'el','Î Î±Ï„Î®ÏƒÏ„Îµ Qty x Ï‡ÏÏŽÎ¼Î±Ï„Î±',0),(86134,2393,'zh','å°åˆ·æ•°é‡xé¢œè‰²\r\n',0),(86135,2393,'sv','Tryck pÃ¥ antal x fÃ¤rger',0),(86136,2393,'it','Premere q. tÃ  x colori',0),(86137,2393,'tl','',0),(86138,2393,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3585;&#3604; x &#3626;&#3637;',0),(86139,2393,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤°à¤‚à¤— x',0),(86140,2393,'ms','Tekan Qty x warna',0),(86141,2393,'ar','Ø§Ø¶ØºØ· Qty Ã— Ø£Ù„ÙˆØ§Ù†',0),(86142,2393,'fr','Appuyez sur QtÃ© x couleurs',0),(86143,2393,'jp','ãƒ—ãƒ¬ã‚¹æ•°é‡?Ã—è‰²æ•°',0),(86144,2393,'pt','Pressione Qtde x cores',0),(86145,2393,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐšÐ¾Ð»-Ð²Ð¾ Ñ†Ð²ÐµÑ‚Ð¾Ð²',0),(86146,2393,'es','Prensa Cant x Colores',0),(86147,2393,'de','DrÃ¼cken Sie die Menge x Farben',0),(86148,2393,'en','Press Qty x Colors',0),(86149,2394,'is','',0),(86150,2394,'dr','* Ø¬Ù‡Øª Ù‡Ø§',0),(86151,2394,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú†Ø§Ù¾ * Ø¬Ù‡Øª Ù‡Ø§',0),(86152,2394,'tr','BasÄ±n miktar x taraf',0),(86153,2394,'pl','NaciÅ›nij iloÅ›Ä‡ x stron',0),(86154,2394,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x ÑÑ‚Ñ€Ð°Ð½Ð¸',0),(86155,2394,'ur','Ø¯Ø¨Ø§Ø¦ÛŒÚº Ù‚ÛŒ Ø§Ø·Ø±Ø§Ù x',0),(86156,2394,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ ÐšÐ¾Ð» x ÑÑ‚Ñ€Ð°Ð½Ð°',0),(86157,2394,'vi','Sá»‘ lÆ°á»£ng bÃ¡o x Máº·t',0),(86158,2394,'af','Druk Qty x kante',0),(86159,2394,'ro','ApÄƒsaÅ£i cantit x pÄƒrÅ£ile',0),(86160,2394,'et','Vajutage kogus x pool',0),(86161,2394,'si','Pritisnite koliÄina x straneh',0),(86162,2394,'ba','Tekan Qty x sisi',0),(86163,2394,'nl','Druk op aantal x zijden',0),(86164,2394,'fi','Paina mÃ¤Ã¤rÃ¤ x puolin',0),(86165,2394,'no','Trykk antall x sider',0),(86166,2394,'da','Tryk pÃ¥ antal x sider',0),(86167,2394,'ko','Qtyë¥¼ ëˆŒëŸ¬ ë©´ x',0),(86168,2394,'he','×”×§×© ×¢×œ ×›×ž×•×ª x ×”×¦×“×“×™×',0),(86169,2394,'el','Î Î±Ï„Î®ÏƒÏ„Îµ Qty x Ï€Î»ÎµÏ…ÏÎ­Ï‚',0),(86170,2394,'zh','å°åˆ·æ•°é‡xä¾§é¢\r\n',0),(86171,2394,'sv','Tryck pÃ¥ antal x sidor',0),(86172,2394,'it','Premere q. tÃ  x i lati',0),(86173,2394,'tl','',0),(86174,2394,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3585;&#3604; x &#3604;&#3657;&#3634;&#3609;',0),(86175,2394,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¤•à¥à¤·à¥‹à¤‚ x',0),(86176,2394,'ms','Tekan Qty x belah',0),(86177,2394,'ar','Ø§Ø¶ØºØ· Qty Ã— Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠÙ†',0),(86178,2394,'fr','Appuyez sur QtÃ© x cÃ´tÃ©s',0),(86179,2394,'jp','ãƒ—ãƒ¬ã‚¹æ•°é‡?Ã—å?´é?¢æ•°',0),(86180,2394,'pt','Pressione Qtde x lados',0),(86181,2394,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Qty x ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(86182,2394,'es','Prensa Cant x Lados',0),(86183,2394,'de','DrÃ¼cken Sie die Menge x Seiten',0),(86184,2394,'en','Press Qty x Sides',0),(86185,2395,'is','',0),(86186,2395,'dr','Ø­Ø°Ù Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86187,2395,'pr','Ø­Ø°Ù Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86188,2395,'tr','AraÃ§ baÅŸarÄ±yla silindi basÄ±n.',0),(86189,2395,'pl','NaciÅ›nij narzÄ™dzie pomyÅ›lnie usuniÄ™ty.',0),(86190,2395,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(86191,2395,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©Û’ Ø¢Ù„Û’ Ø¯Ø¨Ø§Ø¦ÛŒÚº Û”',0),(86192,2395,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ Ð°Ð»Ð°Ñ‚ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(86193,2395,'vi','XÃ³a cÃ´ng cá»¥ bÃ¡o thÃ nh cÃ´ng',0),(86194,2395,'af','Druk instrument suksesvol geskrap.',0),(86195,2395,'ro','ApÄƒsaÅ£i instrument de ÅŸters cu succes.',0),(86196,2395,'et','Vajutage tÃ¶Ã¶riista edukalt kustutatud.',0),(86197,2395,'si','Pritisnite orodje uspeÅ¡no izbrisana.',0),(86198,2395,'ba','Tekan alat berhasil dihapus.',0),(86199,2395,'nl','Druk op de Tool met succes verwijderd.',0),(86200,2395,'fi','Paina tyÃ¶kalu poistettu.',0),(86201,2395,'no','Trykk verktÃ¸yet slettet.',0),(86202,2395,'da','Tryk pÃ¥ vÃ¦rktÃ¸j slettet.',0),(86203,2395,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë„êµ¬ë¥¼ ëˆ„ë¦…ë‹ˆë‹¤.',0),(86204,2395,'he','×œ×—×¥ ×¢×œ ×”×›×œ×™ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(86205,2395,'el','Î Î±Ï„Î®ÏƒÏ„Îµ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(86206,2395,'zh','æ‰“å°å·¥å…·å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(86207,2395,'sv','Tryck verktyget raderades.',0),(86208,2395,'it','Premere strumento eliminato con successo.',0),(86209,2395,'tl','',0),(86210,2395,'th','&#3621;&#3610;&#3611;&#3640;&#3656;&#3617;&#3585;&#3604;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(86211,2395,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(86212,2395,'ms','Tekan alat dihapuskan dengan jayanya.',0),(86213,2395,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø£Ø¯Ø§Ø© Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(86214,2395,'fr','Appuyez sur outil supprimÃ© avec succÃ¨s.',0),(86215,2395,'jp','ãƒ—ãƒ¬ã‚¹ãƒ„ãƒ¼ãƒ«ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(86216,2395,'pt','Pressione a ferramenta excluÃ­da com sucesso.',0),(86217,2395,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(86218,2395,'es','Herramienta de Prensa eliminada exitosamente',0),(86219,2395,'de','DrÃ¼cken Sie Tool erfolgreich gelÃ¶scht.',0),(86220,2395,'en','Press Tool deleted successfully.',0),(86221,2396,'is','',0),(86222,2396,'dr','Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(86223,2396,'pr','Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(86224,2396,'tr','AraÃ§ bulunamadÄ± basÄ±n.',0),(86225,2396,'pl','NaciÅ›nij narzÄ™dzie nie znaleziono.',0),(86226,2396,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(86227,2396,'ur','Ø¢Ù„Û Ù†ÛÛŒÚº Ù…Ù„Ø§ Ø¯Ø¨Ø§Ø¦ÛŒÚº Û”',0),(86228,2396,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ Ð°Ð»Ð°Ñ‚ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(86229,2396,'vi','KhÃ´ng tÃ¬m tháº¥y cÃ´ng cá»¥ bÃ¡o',0),(86230,2396,'af','Druk instrument gevind nie.',0),(86231,2396,'ro','ApÄƒsaÅ£i instrument nu a fost gÄƒsit.',0),(86232,2396,'et','Vajutage tÃ¶Ã¶riist ei leitud.',0),(86233,2396,'si','Pritisnite orodje, ni mogoÄe najti.',0),(86234,2396,'ba','Tekan alat tidak ditemukan.',0),(86235,2396,'nl','Druk op de Tool niet gevonden.',0),(86236,2396,'fi','Paina tyÃ¶kalu ei lÃ¶ydy.',0),(86237,2396,'no','Trykk verktÃ¸yet finnes ikke.',0),(86238,2396,'da','Tryk pÃ¥ vÃ¦rktÃ¸j ikke fundet.',0),(86239,2396,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ë„êµ¬ë¥¼ ëˆ„ë¦…ë‹ˆë‹¤.',0),(86240,2396,'he','×œ×—×¥ ×¢×œ ×”×›×œ×™ ×œ× × ×ž×¦×.',0),(86241,2396,'el','Î Î±Ï„Î®ÏƒÏ„Îµ Ï„Î¿ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(86242,2396,'zh','æ‰“å°å·¥å…·æœªæ‰¾åˆ°ã€‚\r\n',0),(86243,2396,'sv','Tryck verktyget hittades inte.',0),(86244,2396,'it','Premere strumento non trovato.',0),(86245,2396,'tl','',0),(86246,2396,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3611;&#3640;&#3656;&#3617;&#3585;&#3604;',0),(86247,2396,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(86248,2396,'ms','Tekan alat yang tidak dijumpai.',0),(86249,2396,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø§Ù„Ø£Ø¯Ø§Ø© Ø§Ù„ØªÙŠ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(86250,2396,'fr','Appuyez sur outil introuvable.',0),(86251,2396,'jp','ãƒ—ãƒ¬ã‚¹ãƒ„ãƒ¼ãƒ«ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(86252,2396,'pt','Pressione a ferramenta nÃ£o encontrada.',0),(86253,2396,'ru','ÐŸÑ€ÐµÑÑ-Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(86254,2396,'es','Herramienta de Prensa no se encontrÃ³',0),(86255,2396,'de','DrÃ¼cken Sie Werkzeug nicht gefunden.',0),(86256,2396,'en','Press Tool not found.',0),(86257,2397,'is','',0),(86258,2397,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86259,2397,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86260,2397,'tr','BasÄ±n aracÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(86261,2397,'pl','NarzÄ™dzie pomyÅ›lnie zaktualizowana.',0),(86262,2397,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(86263,2397,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù¹ÙˆÙ„ Ø¯Ø¨Ø§Ø¦ÛŒÚº Û”',0),(86264,2397,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ Ð°Ð»Ð°Ñ‚ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(86265,2397,'vi','Cáº­p Nháº­t CÃ´ng Cá»¥ In thÃ nh cÃ´ng',0),(86266,2397,'af','Druk instrument suksesvol opgedateer.',0),(86267,2397,'ro','Instrument de presÄƒ actualizate cu succes.',0),(86268,2397,'et','Stants vÃ¤rskendamine Ãµnnestus.',0),(86269,2397,'si','Pritisnite orodje uspeÅ¡no posodobljena.',0),(86270,2397,'ba','Tekan alat diperbarui berhasil.',0),(86271,2397,'nl','Druk op hulpprogramma met succes bijgewerkt.',0),(86272,2397,'fi','Paina tyÃ¶kalu pÃ¤ivitettiin onnistuneesti.',0),(86273,2397,'no','Trykk verktÃ¸yet oppdatert.',0),(86274,2397,'da','Tryk pÃ¥ vÃ¦rktÃ¸j opdateret.',0),(86275,2397,'ko','ë„êµ¬ê°€ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ë¥¼ ëˆ„ë¦…ë‹ˆë‹¤.',0),(86276,2397,'he','×œ×—×¥ ×¢×œ ×”×›×œ×™ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(86277,2397,'el','Î•ÏÎ³Î±Î»ÎµÎ¯Î¿ Ï„ÏÏ€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(86278,2397,'zh','æ‰“å°å·¥å…·æ›´æ–°æˆåŠŸ',0),(86279,2397,'sv','Tryck verktyget uppdaterats.',0),(86280,2397,'it','Strumento di stampa aggiornato con successo.',0),(86281,2397,'tl','',0),(86282,2397,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3640;&#3656;&#3617;&#3585;&#3604;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(86283,2397,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(86284,2397,'ms','Tekan alat yang berjaya dikemas kini.',0),(86285,2397,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø£Ø¯Ø§Ø© ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(86286,2397,'fr','Sertisseuse correctement mis Ã  jour.',0),(86287,2397,'jp','ãƒ—ãƒ¬ã‚¹ãƒ„ãƒ¼ãƒ«ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(86288,2397,'pt','Ferramenta de imprensa atualizada com Ãªxito.',0),(86289,2397,'ru','ÐŸÑ€ÐµÑÑ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(86290,2397,'es','Herramienta de Prensa actualizada exitosamente',0),(86291,2397,'de','Einpress-Hilfe erfolgreich aktualisiert.',0),(86292,2397,'en','Press tool updated successfully.',0),(86293,2398,'is','',0),(86294,2398,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ ',0),(86295,2398,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ ',0),(86296,2398,'tr','BasÄ±n araÃ§larÄ± ekleme',0),(86297,2398,'pl','NaciÅ›nij przycisk narzÄ™dzia Dodaj',0),(86298,2398,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(86299,2398,'ur','Ù¾Ø±ÛŒØ³ Ú©Û’ Ø§ÙˆØ²Ø§Ø± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(86300,2398,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð°Ð»Ð°Ñ‚ÐºÐµ Ð·Ð° Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ',0),(86301,2398,'vi','ThÃªm cÃ´ng cá»¥ bÃ¡o',0),(86302,2398,'af','Press gereedskap voeg',0),(86303,2398,'ro','Adauga instrumente de presÄƒ',0),(86304,2398,'et','Vajutage Tools lisamine',0),(86305,2398,'si','Dodaj Press orodja',0),(86306,2398,'ba','Tekan alat Tambahkan',0),(86307,2398,'nl','Druk op Tools toevoegen',0),(86308,2398,'fi','PuristustyÃ¶kalujen lisÃ¤Ã¤',0),(86309,2398,'no','Trykk pÃ¥ verktÃ¸y legge',0),(86310,2398,'da','Tryk pÃ¥ vÃ¦rktÃ¸jer tilfÃ¸je',0),(86311,2398,'ko','ë³´ë„ ë„êµ¬ ì¶”ê°€',0),(86312,2398,'he','×›×œ×™ ×”×ª×§×©×•×¨×ª ×œ×”×•×¡×™×£',0),(86313,2398,'el','Î¤ÏÏ€Î¿Ï… ÎµÏÎ³Î±Î»ÎµÎ¯Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(86314,2398,'zh','å°åˆ·å·¥å…·æ·»åŠ \r\n',0),(86315,2398,'sv','Tryck pÃ¥ verktyg lÃ¤gga',0),(86316,2398,'it','Aggiungere strumenti di stampa',0),(86317,2398,'tl','',0),(86318,2398,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3640;&#3656;&#3617;&#3585;&#3604;',0),(86319,2398,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(86320,2398,'ms','Tekan alat Tambah',0),(86321,2398,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ø¯ÙˆØ§Øª Ø§Ù„ØµØ­Ø§ÙØ©',0),(86322,2398,'fr','Ajouter des outillages de presse',0),(86323,2398,'jp','ãƒ—ãƒ¬ã‚¹ãƒ„ãƒ¼ãƒ«ã?®è¿½åŠ ',0),(86324,2398,'pt','Adicionar ferramentas de imprensa',0),(86325,2398,'ru','ÐŸÑ€ÐµÑÑ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(86326,2398,'es','Agregar herramientas de Prensa',0),(86327,2398,'de','Presse Tools hinzufÃ¼gen',0),(86328,2398,'en','Press Tools Add',0),(86329,2399,'is','',0),(86330,2399,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ ',0),(86331,2399,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø¨Ø²Ø§Ø± Ú†Ø§Ù¾ ',0),(86332,2399,'tr','BasÄ±n AraÃ§larÄ± GÃ¼ncelleÅŸtirmesi',0),(86333,2399,'pl','Aktualizacja narzÄ™dzia do prasy',0),(86334,2399,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(86335,2399,'ur','Ù¾Ø±ÛŒØ³ Ú©Û’ Ø§ÙˆØ²Ø§Ø± ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(86336,2399,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ Ð£Ð¿Ð´Ð°Ñ‚Ðµ Ð°Ð»Ð°Ñ‚ÐºÐµ',0),(86337,2399,'vi','Cáº­p Nháº­t CÃ´ng Cá»¥ In',0),(86338,2399,'af','Press gereedskap bywerking',0),(86339,2399,'ro','Actualizare de instrumente de presÄƒ',0),(86340,2399,'et','Vajutage Tools Update',0),(86341,2399,'si','Pritisnite posodobitev orodja',0),(86342,2399,'ba','Tekan perkakas Update',0),(86343,2399,'nl','Druk Tools Update',0),(86344,2399,'fi','Paina Tools-pÃ¤ivityksen',0),(86345,2399,'no','Trykk verktÃ¸y Oppdater',0),(86346,2399,'da','Tryk pÃ¥ vÃ¦rktÃ¸jer opdatering',0),(86347,2399,'ko','ë³´ë„ ë„êµ¬ ì—…ë°ì´íŠ¸',0),(86348,2399,'he','×¢×“×›×•×Ÿ ×œ×›×œ×™ ×”×ª×§×©×•×¨×ª',0),(86349,2399,'el','Î¤ÏÏ€Î¿Ï… ÎµÏÎ³Î±Î»ÎµÎ¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(86350,2399,'zh','å°åˆ·å·¥å…·æ›´æ–°\r\n',0),(86351,2399,'sv','Tryck pÃ¥ verktyg uppdatering',0),(86352,2399,'it','Aggiornamento di strumenti di stampa',0),(86353,2399,'tl','',0),(86354,2399,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3640;&#3656;&#3617;&#3585;&#3604;',0),(86355,2399,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(86356,2399,'ms','Tekan alat Kemaskini',0),(86357,2399,'ar','ØªØ­Ø¯ÙŠØ« Ø£Ø¯ÙˆØ§Øª Ø§Ù„ØµØ­Ø§ÙØ©',0),(86358,2399,'fr','Mise Ã  jour des outils de presse',0),(86359,2399,'jp','ãƒ—ãƒ¬ã‚¹ãƒ„ãƒ¼ãƒ«ã?®æ›´æ–°',0),(86360,2399,'pt','AtualizaÃ§Ã£o das ferramentas de imprensa',0),(86361,2399,'ru','ÐŸÑ€ÐµÑÑ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(86362,2399,'es','Herramientas de Prensa Actualizar',0),(86363,2399,'de','Presse Tools Update',0),(86364,2399,'en','Press Tools Update',0),(86365,2400,'is','',0),(86366,2400,'dr','Ù¾ÙŠØ´ Ù†Ù…Ø§ÙŠØ´',0),(86367,2400,'pr','Ù¾ÙŠØ´ Ù†Ù…Ø§ÙŠØ´',0),(86368,2400,'tr','Ã–nizleme',0),(86369,2400,'pl','PodglÄ…d',0),(86370,2400,'bg','Ð’Ð¸Ð·ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(86371,2400,'ur','Ù¾ÛŒØ´ Ù…Ù†Ø¸Ø±',0),(86372,2400,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´',0),(86373,2400,'vi','Duyá»‡t',0),(86374,2400,'af','Voorskou',0),(86375,2400,'ro','Previzualizare',0),(86376,2400,'et','Eelvaade',0),(86377,2400,'si','Predogled',0),(86378,2400,'ba','Tinjauan',0),(86379,2400,'nl','Voorbeeld',0),(86380,2400,'fi','Esikatselu',0),(86381,2400,'no','ForhÃ¥ndsvisning',0),(86382,2400,'da','Preview',0),(86383,2400,'ko','ë¯¸ë¦¬ ë³´ê¸°',0),(86384,2400,'he','×ª×¦×•×’×” ×ž×§×“×™×ž×”',0),(86385,2400,'el','Î ÏÎ¿ÎµÏ€Î¹ÏƒÎºÏŒÏ€Î·ÏƒÎ·',0),(86386,2400,'zh','é¢„è§ˆ\r\n',0),(86387,2400,'sv','FÃ¶rhandsgranskning',0),(86388,2400,'it','Anteprima',0),(86389,2400,'tl','',0),(86390,2400,'th','&#3649;&#3626;&#3604;&#3591;',0),(86391,2400,'hi','à¤ªà¥‚à¤°à¥à¤µà¤¾à¤µà¤²à¥‹à¤•à¤¨',0),(86392,2400,'ms','Pratonton',0),(86393,2400,'ar','Ù…Ø¹Ø§ÙŠÙ†Ø©',0),(86394,2400,'fr','AperÃ§u',0),(86395,2400,'jp','ãƒ—ãƒ¬ãƒ“ãƒ¥ãƒ¼',0),(86396,2400,'pt','Visualizar',0),(86397,2400,'ru','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€',0),(86398,2400,'es','vista previa',0),(86399,2400,'de','Vorschau',0),(86400,2400,'en','Preview',0),(86401,2401,'is','',0),(86402,2401,'dr','Ù‚Ø¨Ù„ÙŠ ',0),(86403,2401,'pr','Ù‚Ø¨Ù„ÙŠ ',0),(86404,2401,'tr','Ã–nceki',0),(86405,2401,'pl','Poprzedni',0),(86406,2401,'bg','ÐŸÑ€ÐµÐ´Ð¸ÑˆÐ½Ð°',0),(86407,2401,'ur','Ù¾Ú†Ú¾Ù„Ø§',0),(86408,2401,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¸',0),(86409,2401,'vi','TrÆ°á»›c',0),(86410,2401,'af','Vorige',0),(86411,2401,'ro','Anterioare',0),(86412,2401,'et','Eelmine',0),(86413,2401,'si','PrejÅ¡nje',0),(86414,2401,'ba','Sebelumnya',0),(86415,2401,'nl','Vorige',0),(86416,2401,'fi','Edellinen',0),(86417,2401,'no','Tidligere',0),(86418,2401,'da','Tidligere',0),(86419,2401,'ko','ì´ì „',0),(86420,2401,'he','×§×•×“×',0),(86421,2401,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î·',0),(86422,2401,'zh','ä¸Šä¸€é¡µ\r\n',0),(86423,2401,'sv','Tidigare',0),(86424,2401,'it','Precedente',0),(86425,2401,'tl','',0),(86426,2401,'th','&#3585;&#3656;&#3629;&#3609;&#3627;&#3609;&#3657;&#3634;',0),(86427,2401,'hi','à¤ªà¤¿à¤›à¤²à¤¾',0),(86428,2401,'ms','Sebelumnya',0),(86429,2401,'ar','Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(86430,2401,'fr','PrÃ©cÃ©dent',0),(86431,2401,'jp','ä»¥å‰?',0),(86432,2401,'pt','Anterior',0),(86433,2401,'ru','ÐŸÑ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ð¹',0),(86434,2401,'es','Previo',0),(86435,2401,'de','Vorherige',0),(86436,2401,'en','Previous',0),(86437,2402,'is','',0),(86438,2402,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠ Ù‚Ø¨Ù„ÙŠ ',0),(86439,2402,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠ Ù‚Ø¨Ù„ÙŠ ',0),(86440,2402,'tr','Ã–nceki gÃ¶nderiler',0),(86441,2402,'pl','Poprzednie wydania',0),(86442,2402,'bg','ÐŸÑ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¸',0),(86443,2402,'ur','Ù¾Ú†Ú¾Ù„Ø§ ØªØ±Ø³ÛŒÙ„',0),(86444,2402,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(86445,2402,'vi','Chuyáº¿n hÃ ng trÆ°á»›c',0),(86446,2402,'af','Vorige Versendings',0),(86447,2402,'ro','Transporturile anterioare',0),(86448,2402,'et','Eelmiste vedude',0),(86449,2402,'si','PrejÅ¡nje poÅ¡iljke',0),(86450,2402,'ba','Pengiriman sebelumnya',0),(86451,2402,'nl','Eerdere zendingen',0),(86452,2402,'fi','Edellinen lÃ¤hetykset',0),(86453,2402,'no','Tidligere forsendelser',0),(86454,2402,'da','Tidligere overfÃ¸rsler',0),(86455,2402,'ko','ì´ì „ ì¶œí•˜',0),(86456,2402,'he','×ž×©×œ×•×—×™× ×§×•×“×ž×™×',0),(86457,2402,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(86458,2402,'zh','ä»¥å¾€å‡ºè´§\r\n',0),(86459,2402,'sv','Tidigare sÃ¤ndningar',0),(86460,2402,'it','Spedizioni precedenti',0),(86461,2402,'tl','',0),(86462,2402,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3605;&#3656;&#3585;&#3656;&#3629;&#3609;',0),(86463,2402,'hi','à¤ªà¤¿à¤›à¤²à¤¾ à¤²à¤¦à¤¾à¤¨',0),(86464,2402,'ms','Sebelum penghantaran',0),(86465,2402,'ar','Ø§Ù„Ø´Ø­Ù†Ø§Øª Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(86466,2402,'fr','ExpÃ©ditions prÃ©cÃ©dentes',0),(86467,2402,'jp','ä»¥å‰?ã?®é…?é€?',0),(86468,2402,'pt','ExpediÃ§Ãµes anteriores',0),(86469,2402,'ru','ÐŸÑ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(86470,2402,'es','EnvÃ­os Previos',0),(86471,2402,'de','Vorherige Sendungen',0),(86472,2402,'en','Previous Shipments',0),(86473,2403,'is','',0),(86474,2403,'dr','Ù‚Ø¨Ù„Ø§',0),(86475,2403,'pr','Ù‚Ø¨Ù„Ø§',0),(86476,2403,'tr','Daha Ã¶nce',0),(86477,2403,'pl','WczeÅ›niej',0),(86478,2403,'bg','ÐŸÐ¾-Ñ€Ð°Ð½Ð¾',0),(86479,2403,'ur','Ù‚Ø¨Ù„ Ø§Ø²ÛŒÚº',0),(86480,2403,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾',0),(86481,2403,'vi','TrÆ°á»›c khi',0),(86482,2403,'af','Voorheen',0),(86483,2403,'ro','Anterior',0),(86484,2403,'et','Varem',0),(86485,2403,'si','Prej',0),(86486,2403,'ba','Sebelumnya',0),(86487,2403,'nl','Eerder',0),(86488,2403,'fi','Aiemmin',0),(86489,2403,'no','Tidligere',0),(86490,2403,'da','Tidligere',0),(86491,2403,'ko','ì´ì „',0),(86492,2403,'he','×‘×¢×‘×¨',0),(86493,2403,'el','Î ÏÎ¿Î·Î³Î¿Ï…Î¼Î­Î½Ï‰Ï‚',0),(86494,2403,'zh','ä»¥å‰\r\n',0),(86495,2403,'sv','Tidigare',0),(86496,2403,'it','In precedenza',0),(86497,2403,'tl','',0),(86498,2403,'th','&#3649;&#3605;&#3656;&#3585;&#3656;&#3629;&#3609;',0),(86499,2403,'hi','à¤ªà¤¹à¤²à¥‡',0),(86500,2403,'ms','Sebelum ini',0),(86501,2403,'ar','Ø³Ø§Ø¨Ù‚Ø§',0),(86502,2403,'fr','PrÃ©cÃ©demment',0),(86503,2403,'jp','ä»¥å‰?',0),(86504,2403,'pt','Anteriormente',0),(86505,2403,'ru','Ð Ð°Ð½ÐµÐµ',0),(86506,2403,'es','Previamente',0),(86507,2403,'de','Zuvor',0),(86508,2403,'en','Previously',0),(86509,2404,'is','',0),(86510,2404,'dr','Ù‚ÙŠÙ…Øª ',0),(86511,2404,'pr','Ù‚ÙŠÙ…Øª ',0),(86512,2404,'tr','Fiyat',0),(86513,2404,'pl','Cena',0),(86514,2404,'bg','Ð¦ÐµÐ½Ð°',0),(86515,2404,'ur','Ù‚ÛŒÙ…Øª',0),(86516,2404,'sr','Ð¦ÐµÐ½Ð°',0),(86517,2404,'vi','GiÃ¡',0),(86518,2404,'af','Prys',0),(86519,2404,'ro','Pret',0),(86520,2404,'et','Hind',0),(86521,2404,'si','Cena',0),(86522,2404,'ba','Harga',0),(86523,2404,'nl','Prijs',0),(86524,2404,'fi','Hinta',0),(86525,2404,'no','Pris',0),(86526,2404,'da','Pris',0),(86527,2404,'ko','ê°€ê²©',0),(86528,2404,'he','×ž×—×™×¨',0),(86529,2404,'el','Î¤Î¹Î¼Î®',0),(86530,2404,'zh','ä»·æ ¼\r\n',0),(86531,2404,'sv','Pris',0),(86532,2404,'it','Prezzo',0),(86533,2404,'tl','',0),(86534,2404,'th','&#3619;&#3634;&#3588;&#3634;',0),(86535,2404,'hi','à¤®à¥‚à¤²à¥à¤¯',0),(86536,2404,'ms','Harga',0),(86537,2404,'ar','Ø§Ù„Ø³Ø¹Ø±',0),(86538,2404,'fr','Prix',0),(86539,2404,'jp','å€¤æ®µ',0),(86540,2404,'pt','PreÃ§o',0),(86541,2404,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(86542,2404,'es','Precio',0),(86543,2404,'de','Preis',0),(86544,2404,'en','Price',0),(86545,2405,'is','',0),(86546,2405,'dr','Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(86547,2405,'pr','Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(86548,2405,'tr','Fiyat dÃ¼zeyi',0),(86549,2405,'pl','Poziom cen',0),(86550,2405,'bg','ÐÐ¸Ð²Ð¾ Ð½Ð° Ñ†ÐµÐ½Ð¸Ñ‚Ðµ',0),(86551,2405,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­',0),(86552,2405,'sr','ÐÐ¸Ð²Ð¾ Ñ†ÐµÐ½Ð°',0),(86553,2405,'vi','Má»©c giÃ¡',0),(86554,2405,'af','Prysvlak',0),(86555,2405,'ro','Nivelul preÅ£urilor',0),(86556,2405,'et','Hinnatase',0),(86557,2405,'si','Raven cen',0),(86558,2405,'ba','Tingkat harga',0),(86559,2405,'nl','Prijsniveau',0),(86560,2405,'fi','Hintataso',0),(86561,2405,'no','PrisnivÃ¥',0),(86562,2405,'da','Prisniveau',0),(86563,2405,'ko','ê°€ê²© ìˆ˜ì¤€',0),(86564,2405,'he','×¨×ž×ª ×ž×—×™×¨×™×',0),(86565,2405,'el','Î•Ï€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½',0),(86566,2405,'zh','ä»·æ ¼æ°´å¹³\r\n',0),(86567,2405,'sv','PrisnivÃ¥n',0),(86568,2405,'it','Livello di prezzo',0),(86569,2405,'tl','',0),(86570,2405,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(86571,2405,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°',0),(86572,2405,'ms','Paras harga',0),(86573,2405,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(86574,2405,'fr','Niveau de prix',0),(86575,2405,'jp','ä¾¡æ ¼æ°´æº–',0),(86576,2405,'pt','NÃ­vel de preÃ§o',0),(86577,2405,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð¦ÐµÐ½',0),(86578,2405,'es','Nivel de Precios',0),(86579,2405,'de','Preisniveau',0),(86580,2405,'en','Price Level',0),(86581,2406,'is','',0),(86582,2406,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(86583,2406,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(86584,2406,'tr','Yeni fiyat dÃ¼zeyi',0),(86585,2406,'pl','Nowy poziom cen',0),(86586,2406,'bg','ÐÐ¾Ð²Ð¾ Ñ†ÐµÐ½Ð¾Ð²Ð¾ Ð½Ð¸Ð²Ð¾',0),(86587,2406,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ø³Ø·Ø­',0),(86588,2406,'sr','ÐÐ¾Ð²Ð¸ Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð°',0),(86589,2406,'vi','ThÃªm Má»©c giÃ¡',0),(86590,2406,'af','Prysvlak Skep',0),(86591,2406,'ro','Noul nivel de preÅ£',0),(86592,2406,'et','Uus tase',0),(86593,2406,'si','Nova raven cen',0),(86594,2406,'ba','Tingkat harga baru',0),(86595,2406,'nl','Nieuwe prijsniveau',0),(86596,2406,'fi','Uudesta hintatasosta',0),(86597,2406,'no','Nye prisnivÃ¥',0),(86598,2406,'da','Ny prisniveau',0),(86599,2406,'ko','ìƒˆë¡œìš´ ê°€ê²© ìˆ˜ì¤€',0),(86600,2406,'he','×¨×ž×ª ×ž×—×™×¨×™× ×—×“×©',0),(86601,2406,'el','ÎÎ­Î± Ï„Î¹Î¼Î® ÎµÏ€Î¯Ï€ÎµÎ´Î¿',0),(86602,2406,'zh','ä»·æ ¼æ°´å¹³æ·»åŠ \r\n',0),(86603,2406,'sv','Nya prisnivÃ¥n',0),(86604,2406,'it','Nuovo livello di prezzo',0),(86605,2406,'tl','',0),(86606,2406,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(86607,2406,'hi','à¤¨à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°',0),(86608,2406,'ms','Tahap harga yang baru',0),(86609,2406,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(86610,2406,'fr','Nouveau niveau de prix',0),(86611,2406,'jp','ä¾¡æ ¼æ°´æº–ã?®è¿½åŠ ',0),(86612,2406,'pt','Novo nÃ­vel de preÃ§o',0),(86613,2406,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð¦ÐµÐ½',0),(86614,2406,'es','Agrgar Nivel de Precios',0),(86615,2406,'de','Neue Preisniveau',0),(86616,2406,'en','New Price Level',0),(86617,2407,'is','',0),(86618,2407,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86619,2407,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86620,2407,'tr','Fiyat dÃ¼zeyi baÅŸarÄ±yla eklendi.',0),(86621,2407,'pl','Poziom cen dodane pomyÅ›lnie.',0),(86622,2407,'bg','ÐÐ¸Ð²Ð¾ Ð½Ð° Ñ†ÐµÐ½Ð¸Ñ‚Ðµ, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(86623,2407,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(86624,2407,'sr','ÐÐ¸Ð²Ð¾ Ñ†ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(86625,2407,'vi','ThÃªm Má»©c giÃ¡ thÃ nh cÃ´ng',0),(86626,2407,'af','Prysvlak suksesvol geskep',0),(86627,2407,'ro','Nivel de preÅ£ adÄƒugat cu succes.',0),(86628,2407,'et','Lisatud hinnatase.',0),(86629,2407,'si','Raven cen, uspeÅ¡no dodana.',0),(86630,2407,'ba','Tingkat harga ditambahkan berhasil.',0),(86631,2407,'nl','Prijsniveau met succes toegevoegd.',0),(86632,2407,'fi','Hintataso lisÃ¤Ã¤minen onnistui.',0),(86633,2407,'no','PrisnivÃ¥ lagt.',0),(86634,2407,'da','Prisniveau tilfÃ¸jet.',0),(86635,2407,'ko','ê°€ê²© ìˆ˜ì¤€ì— ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(86636,2407,'he','×¨×ž×ª ×ž×—×™×¨ × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(86637,2407,'el','Î•Ï€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(86638,2407,'zh','ä»·æ ¼æ°´å¹³æ·»åŠ æˆåŠŸã€‚\r\n',0),(86639,2407,'sv','PrisnivÃ¥n lagts.',0),(86640,2407,'it','Livello di prezzo aggiunto con successo.',0),(86641,2407,'tl','',0),(86642,2407,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3649;&#3621;&#3657;&#3623;',0),(86643,2407,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(86644,2407,'ms','Paras harga yang berjaya menambah.',0),(86645,2407,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(86646,2407,'fr','Niveau de prix ajoutÃ© avec succÃ¨s.',0),(86647,2407,'jp','ä¾¡æ ¼æ°´æº–ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(86648,2407,'pt','NÃ­vel de preÃ§o adicionado com Ãªxito.',0),(86649,2407,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð¦ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(86650,2407,'es','Nivel de Precios agregado exitosamente',0),(86651,2407,'de','Preisniveau wurde erfolgreich hinzugefÃ¼gt.',0),(86652,2407,'en','Price Level added successfully.',0),(86653,2408,'is','',0),(86654,2408,'dr','Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¨Ø§ Ø§ÙŠÙ† Ø´Ø±Ø­ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(86655,2408,'pr','Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¨Ø§ Ø§ÙŠÙ† Ø´Ø±Ø­ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(86656,2408,'tr','Fiyat dÃ¼zeyi, zaten bu tarife ile var',0),(86657,2408,'pl','Ceny juÅ¼ z tego opisu',0),(86658,2408,'bg','Ð Ð°Ð²Ð½Ð¸Ñ‰Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¸Ñ‚Ðµ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ñ Ñ‚Ð¾Ð²Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(86659,2408,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­ Ú©Ùˆ Ù¾ÛÙ„Û’ ÛÛŒ Ø§Ø³ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(86660,2408,'sr','Ð¡Ð° Ñ‚Ð¾Ð¼ Ð¾Ð¿Ð¸ÑÑƒ Ð½Ð¸Ð²Ð¾Ñƒ Ñ†ÐµÐ½Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(86661,2408,'vi','Má»©c giÃ¡ Ä‘Ã£ tá»“n táº¡i vá»›i mÃ´ táº£ nÃ y',0),(86662,2408,'af','Prysvlak bestaan alreeds met daardie beskrywing',0),(86663,2408,'ro','Nivelul preÅ£urilor existÄƒ deja cu aceastÄƒ descriere',0),(86664,2408,'et','Hinnatase on juba olemas selle kirjeldus',0),(86665,2408,'si','Raven cen Å¾e obstaja s tem opisom',0),(86666,2408,'ba','Tingkat harga yang sudah ada dengan deskripsi',0),(86667,2408,'nl','Prijsniveau bestaat al met deze beschrijving',0),(86668,2408,'fi','Hintataso on jo ettÃ¤ kuvaus',0),(86669,2408,'no','PrisnivÃ¥ finnes allerede med denne beskrivelsen',0),(86670,2408,'da','Prisniveau findes allerede med denne beskrivelse',0),(86671,2408,'ko','ê°€ê²© ìˆ˜ì¤€ì€ ì´ë¯¸ ê·¸ ì„¤ëª…',0),(86672,2408,'he','×¨×ž×ª ×ž×—×™×¨ ×›×‘×¨ ×§×™×™× ×¢× ×”×ª×™××•×¨ ×”×–×”',0),(86673,2408,'el','Î•Ï€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½ Ï€Î¿Ï… Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Îµ ÏŒÏ„Î¹ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(86674,2408,'zh','æœ‰è¿™ç§æè¿°çš„ä»·æ ¼æ°´å¹³å·²ç»å­˜åœ¨\r\n',0),(86675,2408,'sv','PrisnivÃ¥n finns redan med denna beskrivning',0),(86676,2408,'it','Livello di prezzo esiste giÃ  con tale descrizione',0),(86677,2408,'tl','',0),(86678,2408,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3',0),(86679,2408,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ à¤•à¤¿ à¤µà¤°à¥à¤£à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(86680,2408,'ms','Tingkat harga telah wujud dengan huraian yang',0),(86681,2408,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¨Ø§Ù„ÙØ¹Ù„ Ù…Ø¹ Ù‡Ø°Ø§ Ø§Ù„ÙˆØµÙ',0),(86682,2408,'fr','Niveau de prix existe dÃ©jÃ  avec cette description',0),(86683,2408,'jp','ã??ã?®è§£èª¬ã?¨ã?®ä¾¡æ ¼æ°´æº–ã?¯ã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(86684,2408,'pt','NÃ­vel de preÃ§o jÃ¡ existe com essa descriÃ§Ã£o',0),(86685,2408,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð¦ÐµÐ½ Ñ Ñ‚Ð°ÐºÐ¸Ð¼ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸ÐµÐ¼ ÑƒÐ¶Ðµ Ð¸Ð¼ÐµÐµÑ‚ÑÑ',0),(86686,2408,'es','Nivel de Precios ya existe con este descripciÃ³n',0),(86687,2408,'de','Preisniveau mit dieser Beschreibung ist bereits vorhanden.',0),(86688,2408,'en','Price Level already exists with that description',0),(86689,2409,'is','',0),(86690,2409,'dr','Ø­Ø°Ù Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86691,2409,'pr','Ø­Ø°Ù Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86692,2409,'tr','Fiyat dÃ¼zeyi baÅŸarÄ±yla silindi.',0),(86693,2409,'pl','Cena, przesâ”‚anie.',0),(86694,2409,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð¾ Ð½Ð¸Ð²Ð¾ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(86695,2409,'ur','Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(86696,2409,'sr','ÐÐ¸Ð²Ð¾ Ñ†ÐµÐ½Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(86697,2409,'vi','XÃ³a Má»©c giÃ¡ thÃ nh cÃ´ng',0),(86698,2409,'af','Prysvlak suksesvol geskrap.',0),(86699,2409,'ro','Nivelul preÅ£urilor ÅŸters cu succes.',0),(86700,2409,'et','Hinnatase on edukalt kustutatud.',0),(86701,2409,'si','Raven cen, uspeÅ¡no izbrisana.',0),(86702,2409,'ba','Tingkat harga berhasil dihapus.',0),(86703,2409,'nl','Prijsniveau met succes verwijderd.',0),(86704,2409,'fi','Hintataso poistettu.',0),(86705,2409,'no','PrisnivÃ¥ slettet.',0),(86706,2409,'da','Prisniveau slettet.',0),(86707,2409,'ko','ê°€ê²© ìˆ˜ì¤€ì„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(86708,2409,'he','×¨×ž×ª ×ž×—×™×¨×™× × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(86709,2409,'el','Î•Ï€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(86710,2409,'zh','ä»·æ ¼æ°´å¹³å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(86711,2409,'sv','PrisnivÃ¥n raderades.',0),(86712,2409,'it','Livello di prezzo cancellato con successo.',0),(86713,2409,'tl','',0),(86714,2409,'th','&#3621;&#3610;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(86715,2409,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(86716,2409,'ms','Harga tahap dihapuskan dengan jayanya.',0),(86717,2409,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(86718,2409,'fr','Niveau de prix supprimÃ© avec succÃ¨s.',0),(86719,2409,'jp','ä¾¡æ ¼æ°´æº–ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(86720,2409,'pt','NÃ­vel de preÃ§o excluÃ­do com sucesso.',0),(86721,2409,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ñ†ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½.',0),(86722,2409,'es','Nivel de Precios eliminado exitosamente',0),(86723,2409,'de','Preisniveau erfolgreich gelÃ¶scht.',0),(86724,2409,'en','Price level deleted successfully.',0),(86725,2410,'is','',0),(86726,2410,'dr','Ø­Ø°Ù Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86727,2410,'pr','Ø­Ø°Ù Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86728,2410,'tr','Fiyat dÃ¼zeyi aÃ§Ä±klamasÄ±',0),(86729,2410,'pl','Opis poziomu cen',0),(86730,2410,'bg','Ð¦ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(86731,2410,'ur','Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(86732,2410,'sr','ÐžÐ¿Ð¸Ñ Ð½Ð¸Ð²Ð¾Ð° Ñ†ÐµÐ½Ð°',0),(86733,2410,'vi','MÃ´ táº£ má»©c giÃ¡',0),(86734,2410,'af','Prysvlakbeskrywing',0),(86735,2410,'ro','Pret nivel Descriere',0),(86736,2410,'et','Hindade taseme kirjeldus',0),(86737,2410,'si','Opis ravni cene',0),(86738,2410,'ba','Harga Level Deskripsi',0),(86739,2410,'nl','Prijs niveau beschrijving',0),(86740,2410,'fi','Hinta tason kuvaus',0),(86741,2410,'no','Beskrivelse av pris',0),(86742,2410,'da','Pris niveau beskrivelse',0),(86743,2410,'ko','ê°€ê²© ìˆ˜ì¤€ ì„¤ëª…',0),(86744,2410,'he','×ª×™××•×¨ ×¨×ž×ª ×ž×—×™×¨',0),(86745,2410,'el','Î¤Î¹Î¼Î® ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(86746,2410,'zh','ä»·æ ¼æ°´å¹³çš„æè¿°\r\n',0),(86747,2410,'sv','Beskrivning pris nivÃ¥',0),(86748,2410,'it','Livello Descrizione prezzo',0),(86749,2410,'tl','',0),(86750,2410,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(86751,2410,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤•à¥‡ à¤µà¤¿à¤µà¤°à¤£',0),(86752,2410,'ms','Harga peringkat penerangan',0),(86753,2410,'ar','ÙˆØµÙ Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(86754,2410,'fr','Description de niveau de prix',0),(86755,2410,'jp','ä¾¡æ ¼æ°´æº–ã?®è§£èª¬',0),(86756,2410,'pt','DescriÃ§Ã£o de nÃ­vel de preÃ§o',0),(86757,2410,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð£Ñ€Ð¾Ð²Ð½Ñ Ð¦ÐµÐ½',0),(86758,2410,'es','DescripciÃ³n de Nivel de Precios',0),(86759,2410,'de','Preis Beschreibung',0),(86760,2410,'en','Price Level Description',0),(86761,2411,'is','',0),(86762,2411,'dr','Ø´Ø±Ø­ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª ØµØ­ÙŠØ­ Ù†ÙŠØ³Øª ',0),(86763,2411,'pr','Ø´Ø±Ø­ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª ØµØ­ÙŠØ­ Ù†ÙŠØ³Øª ',0),(86764,2411,'tr','Fiyat dÃ¼zeyi aÃ§Ä±klamasÄ± geÃ§ersiz',0),(86765,2411,'pl','NieprawidÅ‚owy opis poziomu cen',0),(86766,2411,'bg','Ð¦ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½ÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½',0),(86767,2411,'ur','Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ ØªØµØ±ÛŒØ­ Ù†Ø§Ø¬Ø§Ø¦Ø²',0),(86768,2411,'sr','Ð¦ÐµÐ½Ð° Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ Ð¾Ð¿Ð¸Ñ Ð½Ð¸Ð²Ð¾Ð°',0),(86769,2411,'vi','MÃ´ táº£ má»©c giÃ¡ vÃ´ hiá»‡u',0),(86770,2411,'af','Prysvlakbeskrywing Ongeldig',0),(86771,2411,'ro','Pret nivel Descriere nevalidÄƒ',0),(86772,2411,'et','Hindade taseme kirjeldus ei sobi',0),(86773,2411,'si','Neveljaven opis ravni cene',0),(86774,2411,'ba','Harga valid Level Deskripsi',0),(86775,2411,'nl','Prijs niveau beschrijving ongeldig',0),(86776,2411,'fi','Hinta tason kuvaus virheellinen',0),(86777,2411,'no','Pris beskrivelse ugyldig',0),(86778,2411,'da','Pris niveau beskrivelse ugyldig',0),(86779,2411,'ko','ê°€ê²© ìˆ˜ì¤€ ì„¤ëª… ìž˜ëª» ëœ',0),(86780,2411,'he','×ž×—×™×¨ ×ª×™××•×¨ ×¨×ž×ª ×—×•×§×™',0),(86781,2411,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î®',0),(86782,2411,'zh','ä»·æ ¼æ°´å¹³è¯´æ˜Žæ— æ•ˆ\r\n',0),(86783,2411,'sv','Pris Beskrivning nivÃ¥ ogiltig',0),(86784,2411,'it','Prezzo livello Descrizione invalido',0),(86785,2411,'tl','',0),(86786,2411,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(86787,2411,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤•à¥‡ à¤µà¤¿à¤µà¤°à¤£',0),(86788,2411,'ms','Harga peringkat keterangan tidak sah dan tidak',0),(86789,2411,'ar','ØµØ§Ù„Ø­ ÙˆØµÙ Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(86790,2411,'fr','Prix niveau Description non valide',0),(86791,2411,'jp','ç„¡åŠ¹ã?ªä¾¡æ ¼æ°´æº–ã?®è§£èª¬',0),(86792,2411,'pt','PreÃ§o DescriÃ§Ã£o nÃ­vel invÃ¡lido',0),(86793,2411,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð¾Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¦ÐµÐ½Ð°',0),(86794,2411,'es','DescripciÃ³n de Nivel de Precios Invalido',0),(86795,2411,'de','Preis Beschreibung ungÃ¼ltig',0),(86796,2411,'en','Price Level Description Invalid',0),(86797,2412,'is','',0),(86798,2412,'dr','Ù„ÙŠØ³Øª Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(86799,2412,'pr','Ù„ÙŠØ³Øª Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(86800,2412,'tr','DÃ¼zey fiyat listesi',0),(86801,2412,'pl','Poziom Cennik',0),(86802,2412,'bg','Ð¦ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾ ÑÐ¿Ð¸ÑÑŠÐº',0),(86803,2412,'ur','Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(86804,2412,'sr','Ð¦ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ð½Ð¸Ð²Ð¾Ð°',0),(86805,2412,'vi','Danh sÃ¡ch Má»©c giÃ¡',0),(86806,2412,'af','Prysvlakbeskrywing Lys',0),(86807,2412,'ro','Lista de preÅ£uri nivel',0),(86808,2412,'et','Taseme hinnakiri',0),(86809,2412,'si','Cenik ravni',0),(86810,2412,'ba','Daftar tingkat harga',0),(86811,2412,'nl','Niveau prijslijst',0),(86812,2412,'fi','Tason hinnasto',0),(86813,2412,'no','NivÃ¥ prisliste',0),(86814,2412,'da','Pris niveau liste',0),(86815,2412,'ko','ê°€ê²© ìˆ˜ì¤€ ëª©ë¡',0),(86816,2412,'he','×ž×—×™×¨×•×Ÿ ×‘×¨×ž×”',0),(86817,2412,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± ÎµÏ€Î¹Ï€Î­Î´Ï‰Î½',0),(86818,2412,'zh','ä»·æ ¼çº§åˆ«åˆ—è¡¨\r\n',0),(86819,2412,'sv','NivÃ¥ prislista',0),(86820,2412,'it','Listino prezzi livello',0),(86821,2412,'tl','',0),(86822,2412,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(86823,2412,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤¸à¥‚à¤šà¥€',0),(86824,2412,'ms','Senarai Harga peringkat',0),(86825,2412,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù„Ù…Ø³ØªÙˆÙ‰',0),(86826,2412,'fr','Niveau Tarif',0),(86827,2412,'jp','ä¾¡æ ¼æ°´æº–ãƒªã‚¹ãƒˆ',0),(86828,2412,'pt','Lista de nÃ­veis de preÃ§o',0),(86829,2412,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð£Ñ€Ð¾Ð²Ð½Ñ Ð¦ÐµÐ½',0),(86830,2412,'es','Lista de Nivel de Precios ',0),(86831,2412,'de','Preis Liste \"Ebene\"',0),(86832,2412,'en','Price Level List',0),(86833,2413,'is','',0),(86834,2413,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(86835,2413,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(86836,2413,'tr','Fiyat dÃ¼zeyini DÃ¼zenle',0),(86837,2413,'pl','Edytuj poziom cen',0),(86838,2413,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð¸Ð²Ð¾ Ð½Ð° Ñ†ÐµÐ½Ð¸Ñ‚Ðµ',0),(86839,2413,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(86840,2413,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð°',0),(86841,2413,'vi','Cáº­p nháº­t biá»ƒu giÃ¡',0),(86842,2413,'af','Prysvlak Opdateer',0),(86843,2413,'ro','Editare nivel de preÅ£',0),(86844,2413,'et','Redigeeri hinnatase',0),(86845,2413,'si','Uredite raven cen',0),(86846,2413,'ba','Mengedit tingkat harga',0),(86847,2413,'nl','Prijsniveau bewerken',0),(86848,2413,'fi','Muokkaa hintataso',0),(86849,2413,'no','Redigere prisnivÃ¥',0),(86850,2413,'da','Redigere prisniveau',0),(86851,2413,'ko','ê°€ê²© ìˆ˜ì¤€ì„ íŽ¸ì§‘í•©ë‹ˆë‹¤',0),(86852,2413,'he','×¢×¨×™×›×ª ×¨×ž×ª ×ž×—×™×¨',0),(86853,2413,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Î¼Î® ÎµÏ€Î¯Ï€ÎµÎ´Î¿',0),(86854,2413,'zh','ä»·æ ¼æ°´å¹³çš„æ›´æ–°\r\n',0),(86855,2413,'sv','Redigera prisnivÃ¥n',0),(86856,2413,'it','Modificare il livello di prezzo',0),(86857,2413,'tl','',0),(86858,2413,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(86859,2413,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(86860,2413,'ms','Edit paras harga',0),(86861,2413,'ar','ØªØ­Ø±ÙŠØ± Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(86862,2413,'fr','Modifier le niveau de prix',0),(86863,2413,'jp','ä¾¡æ ¼æ°´æº–ã?®æ›´æ–°',0),(86864,2413,'pt','Editar o nÃ­vel de preÃ§os',0),(86865,2413,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð¦ÐµÐ½',0),(86866,2413,'es','Actualizar Nivel de Precios ',0),(86867,2413,'de','Preisniveau zu bearbeiten',0),(86868,2413,'en','Edit Price Level',0),(86869,2414,'is','',0),(86870,2414,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86871,2414,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86872,2414,'tr','Fiyat dÃ¼zeyi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(86873,2414,'pl','Poziom cen pomyÅ›lnie zaktualizowana.',0),(86874,2414,'bg','ÐÐ¸Ð²Ð¾ Ð½Ð° Ñ†ÐµÐ½Ð¸Ñ‚Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(86875,2414,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(86876,2414,'sr','ÐÐ¸Ð²Ð¾ Ñ†ÐµÐ½Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(86877,2414,'vi','Cáº­p nháº­t biá»ƒu giÃ¡ thÃ nh cÃ´ng',0),(86878,2414,'af','Prysvlak suksesvol geopdateer.',0),(86879,2414,'ro','Nivel de pret actualizat cu succes.',0),(86880,2414,'et','Hinnatase vÃ¤rskendamine Ãµnnestus.',0),(86881,2414,'si','Raven cen, uspeÅ¡no posodobljena.',0),(86882,2414,'ba','Tingkat harga diperbarui berhasil.',0),(86883,2414,'nl','Prijsniveau bijgewerkt.',0),(86884,2414,'fi','Hintataso pÃ¤ivitettiin onnistuneesti.',0),(86885,2414,'no','PrisnivÃ¥ oppdatert.',0),(86886,2414,'da','Prisniveau opdateret.',0),(86887,2414,'ko','ê°€ê²© ìˆ˜ì¤€ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(86888,2414,'he','×¨×ž×ª ×”×ž×—×™×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(86889,2414,'el','Î•Ï€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½ Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(86890,2414,'zh','ä»·æ ¼æ°´å¹³å·²æˆåŠŸæ›´æ–°ã€‚\r\n',0),(86891,2414,'sv','PrisnivÃ¥n uppdaterats.',0),(86892,2414,'it','Livello di prezzo aggiornato con successo.',0),(86893,2414,'tl','',0),(86894,2414,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(86895,2414,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(86896,2414,'ms','Paras harga yang berjaya dikemas kini.',0),(86897,2414,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(86898,2414,'fr','Niveau de prix mis Ã  jour avec succÃ¨s.',0),(86899,2414,'jp','ä¾¡æ ¼æ°´æº–ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(86900,2414,'pt','NÃ­vel de preÃ§o atualizado com Ãªxito.',0),(86901,2414,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð¦ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½.',0),(86902,2414,'es','Nivel de Precios Actualizado exitosamente',0),(86903,2414,'de','Preisniveau erfolgreich aktualisiert.',0),(86904,2414,'en','Price Level updated successfully.',0),(86905,2415,'is','',0),(86906,2415,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(86907,2415,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(86908,2415,'tr','Fiyat listesi',0),(86909,2415,'pl','Cennik',0),(86910,2415,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(86911,2415,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(86912,2415,'sr','Ð¦Ñ˜ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ»ÑƒÐ³Ð°',0),(86913,2415,'vi','Báº£ng giÃ¡',0),(86914,2415,'af','Pryslys',0),(86915,2415,'ro','Lista de preturi',0),(86916,2415,'et','Hindade nimekiri',0),(86917,2415,'si','Cenik',0),(86918,2415,'ba','Daftar harga',0),(86919,2415,'nl','Prijslijst',0),(86920,2415,'fi','Hinnasto',0),(86921,2415,'no','Prisliste',0),(86922,2415,'da','Prisliste',0),(86923,2415,'ko','ê°€ê²© ëª©ë¡',0),(86924,2415,'he','×ž×—×™×¨×•×Ÿ',0),(86925,2415,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚',0),(86926,2415,'zh','ä»·æ ¼è¡¨\r\n',0),(86927,2415,'sv','Prislista',0),(86928,2415,'it','Prezzo di listino',0),(86929,2415,'tl','',0),(86930,2415,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(86931,2415,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€',0),(86932,2415,'ms','Senarai Harga',0),(86933,2415,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(86934,2415,'fr','Liste des prix',0),(86935,2415,'jp','ä¾¡æ ¼è¡¨',0),(86936,2415,'pt','Lista de preÃ§os',0),(86937,2415,'ru','ÐŸÑ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(86938,2415,'es','Lista de Precios',0),(86939,2415,'de','Preisliste',0),(86940,2415,'en','Price List',0),(86941,2416,'is','',0),(86942,2416,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(86943,2416,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(86944,2416,'tr','Fiyat listesi ekleme',0),(86945,2416,'pl','Cennik Dodaj',0),(86946,2416,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(86947,2416,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(86948,2416,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(86949,2416,'vi','ThÃªm Báº£ng giÃ¡',0),(86950,2416,'af','Pryslys Skep',0),(86951,2416,'ro','Adauga lista de preturi',0),(86952,2416,'et','Hinnakirja lisamine',0),(86953,2416,'si','Cenik dodati',0),(86954,2416,'ba','Tambahkan daftar harga',0),(86955,2416,'nl','Prijslijst toevoegen',0),(86956,2416,'fi','Hinnasto lisÃ¤Ã¤',0),(86957,2416,'no','Prisliste legge',0),(86958,2416,'da','Prisliste tilfÃ¸je',0),(86959,2416,'ko','ê°€ê²© ëª©ë¡ ì¶”ê°€',0),(86960,2416,'he','×”×•×¡×£ ×ž×—×™×¨×•×Ÿ',0),(86961,2416,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚, Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(86962,2416,'zh','ä»·æ ¼åˆ—è¡¨æ·»åŠ \r\n',0),(86963,2416,'sv','Prislista lÃ¤gga till',0),(86964,2416,'it','Aggiungi Listino prezzi',0),(86965,2416,'tl','',0),(86966,2416,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(86967,2416,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(86968,2416,'ms','Tambah senarai harga',0),(86969,2416,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø£Ø³Ø¹Ø§Ø±',0),(86970,2416,'fr','Liste des prix',0),(86971,2416,'jp','ä¾¡æ ¼è¡¨ã?®è¿½åŠ ',0),(86972,2416,'pt','Adicionar lista de preÃ§o',0),(86973,2416,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(86974,2416,'es','Agregar Lista de Precios',0),(86975,2416,'de','Preisliste hinzufÃ¼gen',0),(86976,2416,'en','Price List Add',0),(86977,2417,'is','',0),(86978,2417,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86979,2417,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(86980,2417,'tr','Fiyat listesi baÅŸarÄ±yla eklendi.',0),(86981,2417,'pl','Cennik dodane pomyÅ›lnie.',0),(86982,2417,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(86983,2417,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(86984,2417,'sr','Ð¦Ñ˜ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ»ÑƒÐ³Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(86985,2417,'vi','ThÃªm Báº£ng giÃ¡ thÃ nh cÃ´ng ',0),(86986,2417,'af','Pryslys suksesvol geskep',0),(86987,2417,'ro','Lista de preturi adÄƒugat cu succes.',0),(86988,2417,'et','Hinnakirja lisatud.',0),(86989,2417,'si','Cenik uspeÅ¡no dodana.',0),(86990,2417,'ba','Daftar harga ditambahkan berhasil.',0),(86991,2417,'nl','Prijslijst toegevoegd.',0),(86992,2417,'fi','Hinnasto lisÃ¤Ã¤minen onnistui.',0),(86993,2417,'no','Prisliste lagt.',0),(86994,2417,'da','Prisliste tilfÃ¸jet.',0),(86995,2417,'ko','ê°€ê²©í‘œê°€ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(86996,2417,'he','.×”×¦×¢×ª ×ž×—×™×¨ × ×•×¡×¤×” ×‘×”×¦×œ×—×”',0),(86997,2417,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(86998,2417,'zh','ä»·æ ¼è¡¨æ·»åŠ æˆåŠŸã€‚\r\n',0),(86999,2417,'sv','Prislista lagts.',0),(87000,2417,'it','Listino prezzi aggiunti correttamente.',0),(87001,2417,'tl','',0),(87002,2417,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(87003,2417,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(87004,2417,'ms','Senarai harga yang berjaya menambah.',0),(87005,2417,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(87006,2417,'fr','Liste des prix ajoutÃ© avec succÃ¨s.',0),(87007,2417,'jp','ä¾¡æ ¼è¡¨ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(87008,2417,'pt','Lista de preÃ§os adicionado com Ãªxito.',0),(87009,2417,'ru','ÐŸÑ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87010,2417,'es','Lista de Precios agregada exitosamente',0),(87011,2417,'de','Preisliste wurde erfolgreich hinzugefÃ¼gt.',0),(87012,2417,'en','Price List added successfully.',0),(87013,2418,'is','',0),(87014,2418,'dr','Ø­Ø°Ù  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(87015,2418,'pr','Ø­Ø°Ù  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(87016,2418,'tr','Fiyat listesi baÅŸarÄ±yla silindi.',0),(87017,2418,'pl','Cennik usuniÄ™te pomyÅ›lnie.',0),(87018,2418,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87019,2418,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(87020,2418,'sr','Ð¦Ñ˜ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ»ÑƒÐ³Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(87021,2418,'vi','XÃ³a Báº£ng giÃ¡ thÃ nh cÃ´ng ',0),(87022,2418,'af','Pryslys suksesvol geskrap.',0),(87023,2418,'ro','Lista de preturi ÅŸters cu succes.',0),(87024,2418,'et','Hinnakiri on edukalt kustutatud.',0),(87025,2418,'si','Cenik uspeÅ¡no izbrisana.',0),(87026,2418,'ba','Daftar harga berhasil dihapus.',0),(87027,2418,'nl','Prijslijst verwijderd.',0),(87028,2418,'fi','Hinnasto poistettu.',0),(87029,2418,'no','Prisliste slettet.',0),(87030,2418,'da','Prisliste slettet.',0),(87031,2418,'ko','ê°€ê²©í‘œê°€ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(87032,2418,'he','.×ž×—×™×¨×•×Ÿ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(87033,2418,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(87034,2418,'zh','ä»·æ ¼è¡¨å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(87035,2418,'sv','Prislista raderades.',0),(87036,2418,'it','Prezzo di listino eliminato con successo.',0),(87037,2418,'tl','',0),(87038,2418,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(87039,2418,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(87040,2418,'ms','Senarai Harga dihapuskan dengan jayanya.',0),(87041,2418,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(87042,2418,'fr','Liste des prix supprimÃ© avec succÃ¨s.',0),(87043,2418,'jp','ä¾¡æ ¼è¡¨ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(87044,2418,'pt','Lista de preÃ§o excluÃ­do com sucesso.',0),(87045,2418,'ru','ÐŸÑ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(87046,2418,'es','Lista de Precios eliminada exitosamente',0),(87047,2418,'de','Preisliste erfolgreich gelÃ¶scht.',0),(87048,2418,'en','Price List deleted successfully.',0),(87049,2419,'is','',0),(87050,2419,'dr','Ù†Ø§Ù… Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(87051,2419,'pr','Ù†Ø§Ù… Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(87052,2419,'tr','FÄ°YAT LÄ°STESÄ° ADI',0),(87053,2419,'pl','NAZWA LISTY CENA',0),(87054,2419,'bg','Ð¦Ð•ÐÐ ÐÐ Ð˜ÐœÐ• ÐÐ Ð¡ÐŸÐ˜Ð¡ÐªÐš',0),(87055,2419,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ú©Ø§ Ù†Ø§Ù…',0),(87056,2419,'sr','Ð˜ÐœÐ• Ð›Ð˜Ð¡Ð¢Ð• Ð¦Ð•ÐÐ',0),(87057,2419,'vi','TÃŠN Báº¢NG GIÃ',0),(87058,2419,'af','PRYSLYS NAAM',0),(87059,2419,'ro','PRET LISTA NUME',0),(87060,2419,'et','HIND NIMI',0),(87061,2419,'si','CENA SEZNAM IME',0),(87062,2419,'ba','NAMA DAFTAR HARGA',0),(87063,2419,'nl','DE NAAM VAN DE LIJST VAN DE PRIJS',0),(87064,2419,'fi','HINTA NIMI',0),(87065,2419,'no','NAVN PÃ… PRIS',0),(87066,2419,'da','PRIS LISTENAVN',0),(87067,2419,'ko','ê°€ê²© ëª©ë¡ ì´ë¦„',0),(87068,2419,'he','×©× ×ž×—×™×¨×•×Ÿ',0),(87069,2419,'el','ÎŒÎÎŸÎœÎ‘ Î›ÎŠÎ£Î¤Î‘Î£ Î¤Î™ÎœÎÎ',0),(87070,2419,'zh','ä»·æ ¼åˆ—è¡¨åç§°\r\n',0),(87071,2419,'sv','PRIS LISTA NAMN',0),(87072,2419,'it','NOME ELENCO PREZZI',0),(87073,2419,'tl','',0),(87074,2419,'th','&#3594;&#3639;&#3656;&#3629;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(87075,2419,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤•à¤¾ à¤¨à¤¾à¤®',0),(87076,2419,'ms','HARGA SENARAI NAMA',0),(87077,2419,'ar','Ø¥Ø³Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(87078,2419,'fr','NOM DE LISTE DE PRIX',0),(87079,2419,'jp','ä¾¡æ ¼è¡¨å??',0),(87080,2419,'pt','NOME DA LISTA DE PREÃ‡O',0),(87081,2419,'ru','Ð˜ÐœÐ¯ Ð¡ÐŸÐ˜Ð¡ÐšÐ Ð¦Ð•ÐÐ',0),(87082,2419,'es','NOMBRE DE LISTA DE PRECIOS',0),(87083,2419,'de','PREISE LISTE-NAMEN',0),(87084,2419,'en','PRICE LIST NAME',0),(87085,2420,'is','',0),(87086,2420,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(87087,2420,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(87088,2420,'tr','Fiyat listesi bulunamadÄ±.',0),(87089,2420,'pl','Cennik nie znaleziono.',0),(87090,2420,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(87091,2420,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ù†ÛÛŒÚº Ù…Ù„ÛŒ Û”',0),(87092,2420,'sr','Ð¦Ñ˜ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ»ÑƒÐ³Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°.',0),(87093,2420,'vi','KhÃ´ng tÃ¬m tháº¥y báº£ng giÃ¡',0),(87094,2420,'af','Pryslys nie gevind.',0),(87095,2420,'ro','Lista de preturi nu a fost gÄƒsit.',0),(87096,2420,'et','Hinnakiri ei leitud.',0),(87097,2420,'si','Cenika ni mogoÄe najti.',0),(87098,2420,'ba','Daftar Harga tidak ditemukan.',0),(87099,2420,'nl','Prijslijst niet gevonden.',0),(87100,2420,'fi','Hinnasto ei lÃ¶ydy.',0),(87101,2420,'no','Prisliste mangler.',0),(87102,2420,'da','Prisliste blev ikke fundet.',0),(87103,2420,'ko','ê°€ê²© ëª©ë¡ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(87104,2420,'he','.×œ× × ×ž×¦× ×ž×—×™×¨×•×Ÿ',0),(87105,2420,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(87106,2420,'zh','ä»·æ ¼è¡¨æœªæ‰¾åˆ°ã€‚\r\n',0),(87107,2420,'sv','Prislista hittades inte.',0),(87108,2420,'it','Prezzo di listino non trovato.',0),(87109,2420,'tl','',0),(87110,2420,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(87111,2420,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€à¥¤',0),(87112,2420,'ms','Senarai harga tidak dijumpai.',0),(87113,2420,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ \"Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\".',0),(87114,2420,'fr','Liste des prix introuvable.',0),(87115,2420,'jp','ä¾¡æ ¼è¡¨ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(87116,2420,'pt','Lista de preÃ§o nÃ£o foi encontrado.',0),(87117,2420,'ru','ÐŸÑ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(87118,2420,'es','Lista de Precios no se encontrÃ³',0),(87119,2420,'de','Preisliste nicht gefunden.',0),(87120,2420,'en','Price List not found.',0),(87121,2421,'is','',0),(87122,2421,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø®Ø´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(87123,2421,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø®Ø´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(87124,2421,'tr','Fiyat listesi bÃ¶lÃ¼mÃ¼ fiyatlandÄ±rma',0),(87125,2421,'pl','Cennik Cennik czÄ™Å›ci',0),(87126,2421,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð° Ñ‡Ð°ÑÑ‚ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(87127,2421,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø­ØµÛ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(87128,2421,'sr','Ð¢Ð°Ñ€Ð¸Ñ„Ð½Ð¸Ðº ÑƒÐ»Ð¾Ð³Ñƒ Ñƒ Ð¾Ð´Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÑƒ Ñ†ÐµÐ½Ð°',0),(87129,2421,'vi','Báº£ng giÃ¡ phá»¥ tÃ¹ng',0),(87130,2421,'af','Pryslys Gedeeltelike Prysing',0),(87131,2421,'ro','Lista de pret parte preturi',0),(87132,2421,'et','Hinnakiri osa hinnakujundus',0),(87133,2421,'si','Cenik del cene',0),(87134,2421,'ba','Daftar harga bagian harga',0),(87135,2421,'nl','Prijslijst deel prijzen',0),(87136,2421,'fi','Hinnasto osa hinnoittelu',0),(87137,2421,'no','Prisliste del priser',0),(87138,2421,'da','Prisliste del prissÃ¦tning',0),(87139,2421,'ko','ê°€ê²©í‘œ ë¶€ë¶„ ê°€ê²©',0),(87140,2421,'he','×ž×—×™×¨×•×Ÿ ×—×œ×§ ×ª×ž×—×•×¨',0),(87141,2421,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î¼Î­ÏÎ¿Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(87142,2421,'zh','ä»·æ ¼æ¸…å•çš„ä¸€éƒ¨åˆ†å®šä»·\r\n',0),(87143,2421,'sv','Prislista del prissÃ¤ttning',0),(87144,2421,'it','Listino prezzi di parte',0),(87145,2421,'tl','',0),(87146,2421,'th','&#3626;&#3656;&#3623;&#3609;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(87147,2421,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤­à¤¾à¤— à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(87148,2421,'ms','Harga senarai harga sebahagian',0),(87149,2421,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø¬Ø²Ø¡',0),(87150,2421,'fr','Liste des prix prix de la partie',0),(87151,2421,'jp','Price List Part Pricing',0),(87152,2421,'pt','Lista de preÃ§os preÃ§os de parte',0),(87153,2421,'ru','ÐŸÑ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ Ñ†ÐµÐ½Ñ‹ Ñ‡Ð°ÑÑ‚ÑŒ',0),(87154,2421,'es','Precios de Partes de la Lista de Precios',0),(87155,2421,'de','Preisliste Teil Preise',0),(87156,2421,'en','Price List Part Pricing',0),(87157,2422,'is','',0),(87158,2422,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø®Ø´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(87159,2422,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø®Ø´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(87160,2422,'tr','Fiyat listesi bÃ¶lÃ¼mÃ¼ baÅŸarÄ±yla silindi fiyatlandÄ±rma.',0),(87161,2422,'pl','Cena lista czÄ™Å›ci ceny usuniÄ™te pomyÅ›lnie.',0),(87162,2422,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ñ‡Ð°ÑÑ‚ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87163,2422,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø­ØµÛ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† ÛÛ’ Û”',0),(87164,2422,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð° ÑÐµÐ³Ð¼ÐµÐ½Ñ‚Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(87165,2422,'vi','XÃ³a Báº£ng giÃ¡ phá»¥ tÃ¹ng thÃ nh cÃ´ng ',0),(87166,2422,'af','Pryslys Gedeeltelik Prysing suksesvol geskrap.',0),(87167,2422,'ro','Pret lista parte preturi ÅŸters cu succes.',0),(87168,2422,'et','Hind nimekirja osa hinnakujunduse, edukalt kustutatud.',0),(87169,2422,'si','Cena seznam del cene uspeÅ¡no izbrisana.',0),(87170,2422,'ba','Harga daftar bagian harga berhasil dihapus.',0),(87171,2422,'nl','Prijs lijst deel prijzen met succes verwijderd.',0),(87172,2422,'fi','Hinta luettelon osa hinnoittelu poistettu.',0),(87173,2422,'no','Pris liste del prising slettet.',0),(87174,2422,'da','Pris liste del priser slettet.',0),(87175,2422,'ko','ê°€ê²© ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ëª©ë¡ ë¶€ë¶„ ê°€ê²©ìž…ë‹ˆë‹¤.',0),(87176,2422,'he','×ž×—×™×¨ ×”×¨×©×™×ž×” ×—×œ×§ ×ª×ž×—×•×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(87177,2422,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î¼Î­ÏÎ¿Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(87178,2422,'zh','ä»·ç›®è¡¨éƒ¨åˆ†å®šä»·å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(87179,2422,'sv','Pris lista del prissÃ¤ttning raderades.',0),(87180,2422,'it','Prezzo elenco prezzi parte eliminato con successo.',0),(87181,2422,'tl','',0),(87182,2422,'th','&#3621;&#3610;&#3626;&#3656;&#3623;&#3609;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3',0),(87183,2422,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤­à¤¾à¤— à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(87184,2422,'ms','Harga senarai sebahagian harga dihapuskan dengan jayanya.',0),(87185,2422,'ar','Ø³Ø¹Ø± Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø¬Ø²Ø¡ Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(87186,2422,'fr','Prix liste partie tarification supprimÃ© avec succÃ¨s.',0),(87187,2422,'jp','Price List Part Pricing deleted successfully.',0),(87188,2422,'pt','PreÃ§o lista parte preÃ§os excluÃ­do com sucesso.',0),(87189,2422,'ru','Ð¦ÐµÐ½Ð° Ñ†ÐµÐ½Ñ‹ Ñ‡Ð°ÑÑ‚ÑŒ ÑÐ¿Ð¸ÑÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(87190,2422,'es','Precios de Partes de la Lista de Precios eliminados exitosamente',0),(87191,2422,'de','Preis Liste Teil Preise erfolgreich gelÃ¶scht.',0),(87192,2422,'en','Price List Part Pricing deleted successfully.',0),(87193,2423,'is','',0),(87194,2423,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø®Ø´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯  ',0),(87195,2423,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø®Ø´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯  ',0),(87196,2423,'tr','Fiyat listesi bÃ¶lÃ¼mÃ¼ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi fiyatlandÄ±rma.',0),(87197,2423,'pl','Cena lista czÄ™Å›Ä‡ ceny, pomyÅ›lnie zaktualizowana.',0),(87198,2423,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ñ‡Ð°ÑÑ‚ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87199,2423,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø­ØµÛ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† ÛÛ’ Û”',0),(87200,2423,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð° ÑÐµÐ³Ð¼ÐµÐ½Ñ‚Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(87201,2423,'vi','Cáº­p nháº­t biá»ƒu giÃ¡ tá»«ng pháº§n thÃ nh cÃ´ng',0),(87202,2423,'af','Pryslys Gedeeltelik Prysing suksesvol opdateer.',0),(87203,2423,'ro','Pret lista parte preturi actualizate cu succes.',0),(87204,2423,'et','Hind nimekirja osa hinnakujunduse, vÃ¤rskendamine Ãµnnestus.',0),(87205,2423,'si','Cena seznam del cene uspeÅ¡no posodobljena.',0),(87206,2423,'ba','Harga daftar bagian harga diperbarui berhasil.',0),(87207,2423,'nl','Prijs lijst deel prijzen bijgewerkt.',0),(87208,2423,'fi','Hinta luettelon osa hinnoittelu pÃ¤ivitettiin onnistuneesti.',0),(87209,2423,'no','Pris liste del prising oppdatert.',0),(87210,2423,'da','Pris liste del priser opdateret.',0),(87211,2423,'ko','ê°€ê²© ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ëª©ë¡ ë¶€ë¶„ ê°€ê²©ìž…ë‹ˆë‹¤.',0),(87212,2423,'he','×ž×—×™×¨ ×”×¨×©×™×ž×” ×—×œ×§ ×ª×ž×—×•×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(87213,2423,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î¼Î­ÏÎ¿Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(87214,2423,'zh','ä»·ç›®è¡¨éƒ¨åˆ†å®šä»·å·²æˆåŠŸæ›´æ–°',0),(87215,2423,'sv','Pris lista del prissÃ¤ttning uppdaterats.',0),(87216,2423,'it','Prezzo elenco prezzi parte aggiornato con successo.',0),(87217,2423,'tl','',0),(87218,2423,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3656;&#3623;&#3609;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3',0),(87219,2423,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤­à¤¾à¤— à¤•à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(87220,2423,'ms','Harga senarai sebahagian harga berjaya dikemas kini.',0),(87221,2423,'ar','Ø³Ø¹Ø± Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø¬Ø²Ø¡ Ø§Ù„ØªØ³Ø¹ÙŠØ± ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(87222,2423,'fr','Prix liste partie prix mis Ã  jour avec succÃ¨s.',0),(87223,2423,'jp','Price List Part Pricing updated successfully.',0),(87224,2423,'pt','PreÃ§o lista parte preÃ§os atualizado com Ãªxito.',0),(87225,2423,'ru','Ð¦ÐµÐ½Ð° Ñ†ÐµÐ½Ñ‹ Ñ‡Ð°ÑÑ‚ÑŒ ÑÐ¿Ð¸ÑÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(87226,2423,'es','Precios de Partes de la Lista de Precios actualizados exitosamente',0),(87227,2423,'de','Preis Liste Teil Preise erfolgreich aktualisiert.',0),(87228,2423,'en','Price List Part Pricing updated successfully.',0),(87229,2424,'is','',0),(87230,2424,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨Ø®Ø´ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(87231,2424,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨Ø®Ø´ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(87232,2424,'tr','Fiyat listesinin parÃ§asÄ± gÃ¼ncelleÅŸtirme',0),(87233,2424,'pl','Cena lista czÄ™Å›ci aktualizacji',0),(87234,2424,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ñ‡Ð°ÑÑ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(87235,2424,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø­ØµÛ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(87236,2424,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð´ÐµÐ¾ Ð»Ð¸ÑÑ‚Ðµ Ñ†ÐµÐ½Ðµ',0),(87237,2424,'vi','Cáº­p nháº­t biá»ƒu giÃ¡ tá»«ng pháº§n',0),(87238,2424,'af','Pryslys Gedeeltelik Opdateer',0),(87239,2424,'ro','Pret lista parte actualizare',0),(87240,2424,'et','Hinna osas uuendamisel',0),(87241,2424,'si','Cena seznam del posodobitev',0),(87242,2424,'ba','Harga daftar bagian Update',0),(87243,2424,'nl','Prijs lijst deel Update',0),(87244,2424,'fi','Hinnasto osa PÃ¤ivitÃ¤',0),(87245,2424,'no','Prisoppdatering liste del',0),(87246,2424,'da','Pris liste del opdatering',0),(87247,2424,'ko','ê°€ê²© ëª©ë¡ ë¶€ë¶„ ì—…ë°ì´íŠ¸',0),(87248,2424,'he','×ž×—×™×¨ ×¢×“×›×•×Ÿ ×¨×©×™×ž×ª ×—×œ×§',0),(87249,2424,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î­ÏÎ¿Ï‚ Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½',0),(87250,2424,'zh','ä»·æ ¼è¡¨éƒ¨åˆ†æ›´æ–°\r\n',0),(87251,2424,'sv','Pris lista del uppdatering',0),(87252,2424,'it','Aggiornamento di parte elenco prezzi',0),(87253,2424,'tl','',0),(87254,2424,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3656;&#3623;&#3609;&#3607;&#3637;&#3656;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(87255,2424,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¹à¤¿à¤¸à¥à¤¸à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(87256,2424,'ms','Harga senarai bahagian Kemaskini',0),(87257,2424,'ar','ØªØ­Ø¯ÙŠØ« Ø¬Ø²Ø¡ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(87258,2424,'fr','Prix liste partie mise Ã  jour',0),(87259,2424,'jp','Price List Part Update',0),(87260,2424,'pt','AtualizaÃ§Ã£o de parte de lista de preÃ§o',0),(87261,2424,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ñ‡Ð°ÑÑ‚ÑŒ Ñ†ÐµÐ½Ñ‹',0),(87262,2424,'es','Partes de la Lista de Precios Actualizar',0),(87263,2424,'de','Liste Teil Preisaktualisierung',0),(87264,2424,'en','Price List Part Update',0),(87265,2425,'is','',0),(87266,2425,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87267,2425,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87268,2425,'tr','Fiyat listesi stok Ekle',0),(87269,2425,'pl','Cena lista akcji Dodaj',0),(87270,2425,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð²',0),(87271,2425,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(87272,2425,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(87273,2425,'vi','ThÃªm Báº£ng giÃ¡ hÃ ng tá»“n',0),(87274,2425,'af','Pryslys Voorraad Byvoeg',0),(87275,2425,'ro','Adauga Pret lista stoc',0),(87276,2425,'et','Hind nimekirja Stock lisamine',0),(87277,2425,'si','Cena seznam zalog poveÄati',0),(87278,2425,'ba','Tambahkan saham daftar harga',0),(87279,2425,'nl','Prijs lijst voorraad toevoegen',0),(87280,2425,'fi','Hinta haluttaa varastossa lisÃ¤Ã¤',0),(87281,2425,'no','Pris liste lager legge',0),(87282,2425,'da','Pris liste Stock tilfÃ¸je',0),(87283,2425,'ko','ê°€ê²© ëª©ë¡ ì‚¬ì§„ ì¶”ê°€',0),(87284,2425,'he','×”×•×¡×¤×ª ×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™',0),(87285,2425,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½',0),(87286,2425,'zh','ä»·æ ¼è¡¨åº“å­˜å¢žåŠ \r\n',0),(87287,2425,'sv','Pris lista lager lÃ¤gga till',0),(87288,2425,'it','Aggiungi prezzo Stock List',0),(87289,2425,'tl','',0),(87290,2425,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3607;&#3637;&#3656;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(87291,2425,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(87292,2425,'ms','Tambah harga senarai stok',0),(87293,2425,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø£Ø³Ù‡Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(87294,2425,'fr','Prix liste Stock ajouter',0),(87295,2425,'jp','ä¾¡æ ¼è¡¨åœ¨åº«ã?®è¿½åŠ ',0),(87296,2425,'pt','PreÃ§o lista Stock adicionar',0),(87297,2425,'ru','Ð¦ÐµÐ½Ð° Ð°ÐºÑ†Ð¸Ð¸ ÑÐ¿Ð¸ÑÐ¾Ðº Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(87298,2425,'es','Agregar Stock de la Lista de Precios',0),(87299,2425,'de','Preis Liste Lager hinzufÃ¼gen',0),(87300,2425,'en','Price List Stock Add',0),(87301,2426,'is','',0),(87302,2426,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87303,2426,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87304,2426,'tr','Fiyat listesi stok baÅŸarÄ±yla eklendi',0),(87305,2426,'pl','Cena akcji listy dodany pomyÅ›lnie',0),(87306,2426,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(87307,2426,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(87308,2426,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(87309,2426,'vi','ThÃªm Báº£ng giÃ¡ hÃ ng tá»“n thÃ nh cÃ´ng',0),(87310,2426,'af','Pryslys Voorraad suksesvol bygevoeg.',0),(87311,2426,'ro','Pret lista stoc adÄƒugat cu succes',0),(87312,2426,'et','Hind nimekirja Stock lisatud',0),(87313,2426,'si','Cena seznam zalog uspeÅ¡no dodani',0),(87314,2426,'ba','Daftar harga saham ditambahkan berhasil',0),(87315,2426,'nl','Prijs lijst voorraad toegevoegd',0),(87316,2426,'fi','Hinta haluttaa varastossa lisÃ¤Ã¤minen onnistui',0),(87317,2426,'no','Pris liste lager lagt',0),(87318,2426,'da','Aktiekurs liste tilfÃ¸jet',0),(87319,2426,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ê°€ê²© ëª©ë¡ ì‚¬ì§„',0),(87320,2426,'he','×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(87321,2426,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(87322,2426,'zh','ä»·ç›®è¡¨åº“å­˜å¢žåŠ æˆåŠŸ\r\n',0),(87323,2426,'sv','Pris lista lager lagts',0),(87324,2426,'it','Prezzo Stock di elenco aggiunto con successo',0),(87325,2426,'tl','',0),(87326,2426,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(87327,2426,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤¸à¥à¤Ÿà¥‰à¤•',0),(87328,2426,'ms','Harga Senarai saham berjaya menambah',0),(87329,2426,'ar','Ø³Ø¹Ø± Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(87330,2426,'fr','Prix liste Stock ajoutÃ© avec succÃ¨s',0),(87331,2426,'jp','ä¾¡æ ¼è¡¨åœ¨åº«ã‚’è¿½åŠ ã?—ã?¾ã?—ã?Ÿ',0),(87332,2426,'pt','PreÃ§o lista estoque adicionado com sucesso',0),(87333,2426,'ru','Ð¦ÐµÐ½Ð° Ð°ÐºÑ†Ð¸Ð¸ ÑÐ¿Ð¸ÑÐ¾Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(87334,2426,'es','Stock de la Lista de Precios agregado exitosamente',0),(87335,2426,'de','Preis Liste Lager erfolgreich hinzugefÃ¼gt',0),(87336,2426,'en','Price List Stock added successfully',0),(87337,2427,'is','',0),(87338,2427,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø±Ù†Ú¯ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87339,2427,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø±Ù†Ú¯ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87340,2427,'tr','Fiyat listesi stok renk seÃ§imleri',0),(87341,2427,'pl','Cena lista pieÅ„ koloru zaznaczenia',0),(87342,2427,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¾ÑÐ½Ð¾Ð²ÐµÐ½ Ñ†Ð²ÑÑ‚ Ð¸Ð·Ð±Ð¾Ñ€',0),(87343,2427,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø±Ù†Ú¯ Ø§Ù†ØªØ®Ø§Ø¨',0),(87344,2427,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¾Ð³ Ð±Ð¾Ñ˜Ñƒ Ð¾Ð´Ð°Ð±Ð¸Ñ€Ðµ',0),(87345,2427,'vi','Lá»±a chá»n máº§u cho Báº£ng giÃ¡ hÃ ng tá»“n',0),(87346,2427,'af','Pryslys Voorraad Kleur Seleksies',0),(87347,2427,'ro','Pret lista stoc culoarea selecÅ£ii',0),(87348,2427,'et','Hind nimekirja Stock vÃ¤rvi Valikud',0),(87349,2427,'si','Cena seznam zalog barva izborov',0),(87350,2427,'ba','Harga daftar saham warna pilihan',0),(87351,2427,'nl','Prijs lijst voorraad kleurselecties',0),(87352,2427,'fi','Hinta haluttaa varastossa vÃ¤rivalinnat',0),(87353,2427,'no','Pris liste lager fargevalg',0),(87354,2427,'da','Pris liste Stock farvevalg',0),(87355,2427,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ìƒ‰ìƒ ì„ íƒ',0),(87356,2427,'he','×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™ ×¦×‘×¢ ×‘×—×™×¨×•×ª',0),(87357,2427,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÏŽÎ¼Î± ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(87358,2427,'zh','ä»·æ ¼è¡¨åº“å­˜çš„é¢œè‰²é€‰æ‹©\r\n',0),(87359,2427,'sv','Pris lista lager fÃ¤rgval',0),(87360,2427,'it','Prezzo Lista magazzino colore selezioni',0),(87361,2427,'tl','',0);
INSERT INTO `langdef` VALUES (87362,2427,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3637;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(87363,2427,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤°à¤‚à¤— à¤šà¤¯à¤¨',0),(87364,2427,'ms','Harga senarai stok warna pilihan',0),(87365,2427,'ar','Ø§Ø®ØªÙŠØ§Ø±Ø§Øª Ø§Ù„Ù„ÙˆÙ† Ø§Ù„Ø£Ø³Ù‡Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(87366,2427,'fr','Prix liste couleur Stock sÃ©lections',0),(87367,2427,'jp','ä¾¡æ ¼è¡¨åœ¨åº«è‰²é?¸æŠž',0),(87368,2427,'pt','PreÃ§o lista estoque cor seleÃ§Ãµes',0),(87369,2427,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… Ñ†Ð²ÐµÑ‚Ð¾Ð² Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐ¾Ðº',0),(87370,2427,'es','Stock de la Lista de Precios selecciones de colores',0),(87371,2427,'de','Preis Liste hat Farbauswahl',0),(87372,2427,'en','Price List Stock Color Selections',0),(87373,2428,'is','',0),(87374,2428,'dr','Ø­Ø°Ù  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87375,2428,'pr','Ø­Ø°Ù  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87376,2428,'tr','Fiyat listesi stok baÅŸarÄ±yla silindi.',0),(87377,2428,'pl','Cena listy czas usuniÄ™te pomyÅ›lnie.',0),(87378,2428,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87379,2428,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(87380,2428,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(87381,2428,'vi','XÃ³a Báº£ng giÃ¡ hÃ ng tá»“n thÃ nh cÃ´ng',0),(87382,2428,'af','Voorraad Pryslys suksesvol geskrap.',0),(87383,2428,'ro','Pret lista stoc ÅŸters cu succes.',0),(87384,2428,'et','Hind nimekirja Stock edukalt kustutatud.',0),(87385,2428,'si','Cena seznam zalog uspeÅ¡no izbrisana.',0),(87386,2428,'ba','Daftar harga saham berhasil dihapus.',0),(87387,2428,'nl','Prijs lijst voorraad verwijderd.',0),(87388,2428,'fi','Hinta haluttaa varastossa poistettu.',0),(87389,2428,'no','Pris liste lager slettet.',0),(87390,2428,'da','Pris liste Stock slettet.',0),(87391,2428,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(87392,2428,'he','×ž×—×™×¨ ×¨×©×™×ž×ª ×”×ž× ×™×•×ª × ×ž×—×§×• ×‘×”×¦×œ×—×”.',0),(87393,2428,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(87394,2428,'zh','ä»·æ ¼è¡¨åº“å­˜å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(87395,2428,'sv','Pris lista lager raderades.',0),(87396,2428,'it','Prezzo Stock List eliminato con successo.',0),(87397,2428,'tl','',0),(87398,2428,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(87399,2428,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(87400,2428,'ms','Harga Senarai saham dihapuskan dengan jayanya.',0),(87401,2428,'ar','Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(87402,2428,'fr','Liste de prix Stock supprimÃ© avec succÃ¨s.',0),(87403,2428,'jp','ä¾¡æ ¼è¡¨åœ¨åº«ã‚’æ¶ˆåŽ»ã?—ã?¾ã?—ã?Ÿ',0),(87404,2428,'pt','PreÃ§o lista estoque excluÃ­do com sucesso.',0),(87405,2428,'ru','Ð¦ÐµÐ½Ð° Ð°ÐºÑ†Ð¸Ð¸ ÑÐ¿Ð¸ÑÐ¾Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(87406,2428,'es','Stock de la Lista de Precios eliminado exitosamente',0),(87407,2428,'de','Preis Liste Lager erfolgreich gelÃ¶scht.',0),(87408,2428,'en','Price List Stock deleted successfully.',0),(87409,2429,'is','',0),(87410,2429,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(87411,2429,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(87412,2429,'tr','Fiyat listesi stok bulunamadÄ±.',0),(87413,2429,'pl','Cena lista zapasÃ³w nie znaleziono.',0),(87414,2429,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(87415,2429,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(87416,2429,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°.',0),(87417,2429,'vi','KhÃ´ng tÃ¬m tháº¥y Báº£ng giÃ¡ hÃ ng tá»“n',0),(87418,2429,'af','Pryslys Voorraad nie gevind.',0),(87419,2429,'ro','Pret lista stoc nu a fost gÄƒsit.',0),(87420,2429,'et','Hind nimekirja laos ei leidu.',0),(87421,2429,'si','Cena seznam zalog ni mogoÄe najti.',0),(87422,2429,'ba','Daftar harga saham tidak ditemukan.',0),(87423,2429,'nl','Prijs lijst voorraad niet gevonden.',0),(87424,2429,'fi','Hinta haluttaa varastosta ei lÃ¶ydy.',0),(87425,2429,'no','Pris liste lager ikke funnet.',0),(87426,2429,'da','Pris liste lager blev ikke fundet.',0),(87427,2429,'ko','ê°€ê²© ëª©ë¡ ì£¼ì‹ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(87428,2429,'he','×¨×©×™×ž×ª ×ž×—×™×¨ ×”×ž× ×™×” ×œ× × ×ž×¦×.',0),(87429,2429,'el','Î¤Î¹Î¼Î® Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î»Î¯ÏƒÏ„Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(87430,2429,'zh','ä»·æ ¼è¡¨åº“å­˜æœªæ‰¾åˆ°ã€‚\r\n',0),(87431,2429,'sv','Pris lista lager hittades inte.',0),(87432,2429,'it','Prezzo Stock List non trovato.',0),(87433,2429,'tl','',0),(87434,2429,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(87435,2429,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(87436,2429,'ms','Harga Senarai saham tidak dijumpai.',0),(87437,2429,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ \"Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ÙÙŠ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\".',0),(87438,2429,'fr','Liste de prix Stock introuvable.',0),(87439,2429,'jp','ä¾¡æ ¼è¡¨åœ¨åº«ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(87440,2429,'pt','PreÃ§o lista estoque nÃ£o encontrado.',0),(87441,2429,'ru','Ð¦ÐµÐ½Ð° Ð°ÐºÑ†Ð¸Ð¸ ÑÐ¿Ð¸ÑÐ¾Ðº Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(87442,2429,'es','Stock de la Lista de Precios no se encontrÃ³',0),(87443,2429,'de','Preis Liste Lager nicht gefunden.',0),(87444,2429,'en','Price List Stock not found.',0),(87445,2430,'is','',0),(87446,2430,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87447,2430,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87448,2430,'tr','Fiyat listesi stok GÃ¼ncelleÅŸtirmesi',0),(87449,2430,'pl','Cena listy czas aktualizacji',0),(87450,2430,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(87451,2430,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(87452,2430,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ†ÐµÐ½Ðµ Ð»Ð¸ÑÑ‚Ð°',0),(87453,2430,'vi','Cáº­p nháº­t biá»ƒu giÃ¡ hÃ ng tá»“n',0),(87454,2430,'af','Voorraad Pryslys Opdateer',0),(87455,2430,'ro','Pret lista actualizare stoc',0),(87456,2430,'et','Hinda varude uuendamisel',0),(87457,2430,'si','Cena seznam zalog posodobitev',0),(87458,2430,'ba','Daftar harga saham Update',0),(87459,2430,'nl','Prijs lijst voorraad Update',0),(87460,2430,'fi','Hinnasto varastossa PÃ¤ivitÃ¤',0),(87461,2430,'no','Prisoppdatering liste lager',0),(87462,2430,'da','Pris liste aktieopdatering',0),(87463,2430,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì—…ë°ì´íŠ¸',0),(87464,2430,'he','×¢×“×›×•×Ÿ ×ž×œ××™ ×©×œ ×¨×©×™×ž×ª ×ž×—×™×¨',0),(87465,2430,'el','Î‘Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½',0),(87466,2430,'zh','ä»·æ ¼è¡¨åº“å­˜æ›´æ–°\r\n',0),(87467,2430,'sv','Prisuppdatering lista lager',0),(87468,2430,'it','Prezzo List aggiornamento magazzino',0),(87469,2430,'tl','',0),(87470,2430,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(87471,2430,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(87472,2430,'ms','Kemaskini stok senarai harga',0),(87473,2430,'ar','Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø£Ø³Ù‡Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(87474,2430,'fr','Mise Ã  jour Stock de la liste de prix',0),(87475,2430,'jp','ä¾¡æ ¼è¡¨åœ¨åº«ã?®æ›´æ–°',0),(87476,2430,'pt','PreÃ§o lista aÃ§Ãµes Update',0),(87477,2430,'ru','Ð¦ÐµÐ½Ð° Ð°ÐºÑ†Ð¸Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ°',0),(87478,2430,'es','Stock de la Lista de Precios Actualizar',0),(87479,2430,'de','Preis Liste Bestandsfortschreibung',0),(87480,2430,'en','Price List Stock Update',0),(87481,2431,'is','',0),(87482,2431,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87483,2431,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87484,2431,'tr','Fiyat listesi stok baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(87485,2431,'pl','Cena lista akcji pomyÅ›lnie zaktualizowana',0),(87486,2431,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(87487,2431,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(87488,2431,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(87489,2431,'vi','Cáº­p nháº­t biá»ƒu giÃ¡ hÃ ng tá»“n thÃ nh cÃ´ng',0),(87490,2431,'af','Pryslys Voorraad suksesvol bygevoeg.',0),(87491,2431,'ro','Pret lista stoc actualizat cu succes',0),(87492,2431,'et','Hind nimekirja Stock vÃ¤rskendatud',0),(87493,2431,'si','Cena seznam zalog uspeÅ¡no posodobljena',0),(87494,2431,'ba','Daftar harga saham diperbarui berhasil',0),(87495,2431,'nl','Prijs lijst voorraad bijgewerkt',0),(87496,2431,'fi','Hinta haluttaa kalusto pÃ¤ivitetty',0),(87497,2431,'no','Pris liste lager oppdatert',0),(87498,2431,'da','Pris liste lager opdateret',0),(87499,2431,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ëœ ê°€ê²© ëª©ë¡ ì‚¬ì§„',0),(87500,2431,'he','×¨×©×™×ž×ª ×ž×—×™×¨ ×”×ž× ×™×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(87501,2431,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î±Ï€ÏŒÎ¸ÎµÎ¼Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(87502,2431,'zh','ä»·æ ¼è¡¨åº“å­˜æ›´æ–°æˆåŠŸ\r\n',0),(87503,2431,'sv','Pris lista lager uppdaterats',0),(87504,2431,'it','Prezzo Stock di elenco aggiornato con successo',0),(87505,2431,'tl','',0),(87506,2431,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(87507,2431,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¶à¥‡à¤¯à¤°',0),(87508,2431,'ms','Harga Senarai saham berjaya dikemas kini',0),(87509,2431,'ar','Ø³Ø¹Ø± Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(87510,2431,'fr','Prix liste Stock mis Ã  jour avec succÃ¨s',0),(87511,2431,'jp','ä¾¡æ ¼è¡¨åœ¨åº«ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(87512,2431,'pt','PreÃ§o lista estoque atualizado com sucesso',0),(87513,2431,'ru','Ð¦ÐµÐ½Ð° Ð°ÐºÑ†Ð¸Ð¸ ÑÐ¿Ð¸ÑÐ¾Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(87514,2431,'es','Stock de la Lista de Precios actualizado exitosamente',0),(87515,2431,'de','Preis Liste Lager erfolgreich aktualisiert',0),(87516,2431,'en','Price List Stock updated successfully',0),(87517,2432,'is','',0),(87518,2432,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(87519,2432,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(87520,2432,'tr','Fiyat listesi stok kullanÄ±mÄ± Ekle',0),(87521,2432,'pl','Cena lista zwyczaj czas dodaÄ‡',0),(87522,2432,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ',0),(87523,2432,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(87524,2432,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ñ†ÐµÐ½Ð°',0),(87525,2432,'vi','ThÃªm sá»­ dá»¥ng Báº£ng giÃ¡ hÃ ng tá»“n',0),(87526,2432,'af','Gebruikte Voorraad Pryslys Byvoeg',0),(87527,2432,'ro','Pret lista stoc utilizare Adauga',0),(87528,2432,'et','Hind nimekirja varude kasutamine lisamine',0),(87529,2432,'si','Cena seznam zalog navada dodati',0),(87530,2432,'ba','Daftar harga saham penggunaan menambahkan',0),(87531,2432,'nl','Prijs lijst voorraad gebruik toevoegen',0),(87532,2432,'fi','Hinta haluttaa kaluston kÃ¤yttÃ¶ lisÃ¤Ã¤',0),(87533,2432,'no','Pris listen lagerforbruket legge',0),(87534,2432,'da','Pris liste Stock skik tilfÃ¸je',0),(87535,2432,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš© ì¶”ê°€',0),(87536,2432,'he','×”×•×¡×£ ×¨×©×™×ž×” ×ž×—×™×¨ ×”×©×™×ž×•×© ×ž× ×™×•×ª',0),(87537,2432,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎ· Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ',0),(87538,2432,'zh','æ–°å¢žä»·æ ¼è¡¨åº“å­˜ä½¿ç”¨\r\n',0),(87539,2432,'sv','Pris lista lageranvÃ¤ndningen lÃ¤gga till',0),(87540,2432,'it','Prezzo Lista magazzino uso Add',0),(87541,2432,'tl','',0),(87542,2432,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3651;&#3594;&#3657;',0),(87543,2432,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(87544,2432,'ms','Menambah penggunaan stok senarai harga',0),(87545,2432,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø£Ø³Ø¹Ø§Ø± Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù…',0),(87546,2432,'fr','Prix liste Stock utilisation Add',0),(87547,2432,'jp','ä¾¡æ ¼è¡¨åœ¨åº«åˆ©ç”¨ã?®è¿½åŠ ',0),(87548,2432,'pt','Adicionar o uso das aÃ§Ãµes da lista de preÃ§o',0),(87549,2432,'ru','Ð¦ÐµÐ½Ð° Ð°ÐºÑ†Ð¸Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑÐ¿Ð¸ÑÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(87550,2432,'es','Uso de Stock de la Lista de Precios Agregar',0),(87551,2432,'de','Preis Liste hat Verwendung hinzufÃ¼gen',0),(87552,2432,'en','Price List Stock Usage Add',0),(87553,2433,'is','',0),(87554,2433,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(87555,2433,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(87556,2433,'tr','Fiyat listesi stok kullanÄ±mÄ± baÅŸarÄ±yla eklendi.',0),(87557,2433,'pl','Cena listy czas uÅ¼ytkowania dodane pomyÅ›lnie.',0),(87558,2433,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87559,2433,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ø§Ø³ØªØ¹Ù…Ø§Ù„ ÛÛ’ Û”',0),(87560,2433,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(87561,2433,'vi','ThÃªm sá»­ dá»¥ng Báº£ng giÃ¡ hÃ ng tá»“n thÃ nh cÃ´ng',0),(87562,2433,'af','Gebruikte Voorraad Pryslys suksesvol bygevoeg.',0),(87563,2433,'ro','Pret de lista stoc utilizare adÄƒugat cu succes.',0),(87564,2433,'et','Hind nimekirja varu kasutamine edukalt lisatud.',0),(87565,2433,'si','Cena seznam zalog navada uspeÅ¡no dodana.',0),(87566,2433,'ba','Daftar harga saham penggunaan ditambahkan berhasil.',0),(87567,2433,'nl','Prijs lijst voorraad gebruik met succes toegevoegd.',0),(87568,2433,'fi','Hinta haluttaa kaluston kÃ¤yttÃ¶ lisÃ¤Ã¤minen onnistui.',0),(87569,2433,'no','Pris liste lager bruk lagt.',0),(87570,2433,'da','Pris liste Stock skik tilfÃ¸jet.',0),(87571,2433,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš© ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(87572,2433,'he','×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™ ×©×™×ž×•×© × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(87573,2433,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î§ÏÎ·Î¼Î±Ï„Î¹ÏƒÏ„Î®ÏÎ¹Î¿ Ï‡ÏÎ®ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(87574,2433,'zh','ä»·æ ¼è¡¨åº“å­˜ä½¿ç”¨æ·»åŠ æˆåŠŸã€‚\r\n',0),(87575,2433,'sv','Pris lista lager anvÃ¤ndning lagts.',0),(87576,2433,'it','Utilizzo di Stock List prezzo aggiunto con successo.',0),(87577,2433,'tl','',0),(87578,2433,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3651;&#3594;&#3657;&#3626;&#3',0),(87579,2433,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(87580,2433,'ms','Penggunaan stok senarai harga berjaya menambah.',0),(87581,2433,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(87582,2433,'fr','Utilisation de Stock Prix liste ajoutÃ© avec succÃ¨s.',0),(87583,2433,'jp','ä¾¡æ ¼è¡¨åœ¨åº«åˆ©ç”¨ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(87584,2433,'pt','PreÃ§o lista estoque uso adicionado com Ãªxito.',0),(87585,2433,'ru','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(87586,2433,'es','Uso de Stock de la Lista de Precios agregado exitosamente',0),(87587,2433,'de','Preis Liste Lager Verwendung wurde erfolgreich hinzugefÃ¼gt.',0),(87588,2433,'en','Price List Stock Usage added successfully.',0),(87589,2434,'is','',0),(87590,2434,'dr','Ø­Ø°Ù  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87591,2434,'pr','Ø­Ø°Ù  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87592,2434,'tr','Fiyat listesi stok kullanÄ±mÄ± baÅŸarÄ±yla silindi.',0),(87593,2434,'pl','Cena listy czas uÅ¼ytkowania usuniÄ™te pomyÅ›lnie.',0),(87594,2434,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87595,2434,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø§Ø³ØªØ¹Ù…Ø§Ù„ ÛÛ’ Û”',0),(87596,2434,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(87597,2434,'vi','XÃ³a sá»­ dá»¥ng Báº£ng giÃ¡ hÃ ng tá»“n thÃ nh cÃ´ng',0),(87598,2434,'af','Gebruikte Voorraad Pryslys suksesvol geskrap.',0),(87599,2434,'ro','Pret de lista stoc utilizare ÅŸters cu succes.',0),(87600,2434,'et','Hind nimekirja varu kasutamine edukalt kustutatud.',0),(87601,2434,'si','Cena seznam zalog navada uspeÅ¡no izbrisana.',0),(87602,2434,'ba','Daftar harga saham penggunaan berhasil dihapus.',0),(87603,2434,'nl','Prijs lijst voorraad gebruik met succes verwijderd.',0),(87604,2434,'fi','Hinta haluttaa kaluston kÃ¤yttÃ¶ poistettu.',0),(87605,2434,'no','Pris liste lager bruk slettet.',0),(87606,2434,'da','Pris liste Stock skik slettet.',0),(87607,2434,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš©ì„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(87608,2434,'he','×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™ ×©×™×ž×•×© × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(87609,2434,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î§ÏÎ·Î¼Î±Ï„Î¹ÏƒÏ„Î®ÏÎ¹Î¿ Ï‡ÏÎ®ÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(87610,2434,'zh','ä»·æ ¼è¡¨çš„åº“å­˜ä½¿ç”¨å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(87611,2434,'sv','Pris lista lager anvÃ¤ndning raderades.',0),(87612,2434,'it','Prezzo lista Stock utilizzo eliminato con successo.',0),(87613,2434,'tl','',0),(87614,2434,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3651;&#3594;&#3657;&#3626;&#3635;&#3648;&#3619;&#3',0),(87615,2434,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(87616,2434,'ms','Penggunaan stok senarai harga dihapuskan dengan jayanya.',0),(87617,2434,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(87618,2434,'fr','Utilisation de Stock Prix liste supprimÃ© avec succÃ¨s.',0),(87619,2434,'jp','ä¾¡æ ¼è¡¨åœ¨åº«åˆ©ç”¨ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(87620,2434,'pt','PreÃ§o lista estoque uso excluÃ­do com sucesso.',0),(87621,2434,'ru','Ð¦ÐµÐ½Ð° Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ñ… ÑÐ¿Ð¸ÑÐ¾Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(87622,2434,'es','Uso de Stock de la Lista de Precios eliminado exitosamente',0),(87623,2434,'de','Preis Liste Lager Verwendung erfolgreich gelÃ¶scht.',0),(87624,2434,'en','Price List Stock Usage deleted successfully.',0),(87625,2435,'is','',0),(87626,2435,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(87627,2435,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(87628,2435,'tr','Fiyat listesi stok kullanÄ±mÄ± bulunamadÄ±.',0),(87629,2435,'pl','Cena listy czas uÅ¼ytkowania nie znaleziono.',0),(87630,2435,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°ÐµÐ¼Ð¾ÑÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(87631,2435,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ù†ÛÛŒÚº Ù…Ù„Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ ÛÛ’ Û”',0),(87632,2435,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(87633,2435,'vi','KhÃ´ng tÃ¬m tháº¥y sá»­ dá»¥ng Báº£ng giÃ¡ hÃ ng tá»“n',0),(87634,2435,'af','Pryslys Voorraadgebruik nie gevind.',0),(87635,2435,'ro','Pret de lista stoc utilizare nu a fost gÄƒsit.',0),(87636,2435,'et','Hind nimekirja Stock kasutust ei leidnud.',0),(87637,2435,'si','Cena seznam zalog uporabe ni mogoÄe najti.',0),(87638,2435,'ba','Daftar harga saham penggunaan tidak ditemukan.',0),(87639,2435,'nl','Prijs lijst voorraad gebruik niet gevonden.',0),(87640,2435,'fi','Hinta haluttaa kaluston kÃ¤yttÃ¶ ei lÃ¶ydy.',0),(87641,2435,'no','Pris liste lager bruk ikke funnet.',0),(87642,2435,'da','Pris liste Stock skik blev ikke fundet.',0),(87643,2435,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš©ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(87644,2435,'he','×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™ ×”×©×™×ž×•×© ×œ× × ×ž×¦×.',0),(87645,2435,'el','Î¤Î¹Î¼Î® Ï‡ÏÎ®ÏƒÎ·Ï‚ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î»Î¯ÏƒÏ„Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(87646,2435,'zh','ä»·æ ¼è¡¨çš„åº“å­˜ä½¿ç”¨æ²¡æœ‰æ‰¾åˆ°ã€‚\r\n',0),(87647,2435,'sv','Pris lista lager anvÃ¤ndning hittades inte.',0),(87648,2435,'it','Prezzo lista Stock utilizzo non trovato.',0),(87649,2435,'tl','',0),(87650,2435,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(87651,2435,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(87652,2435,'ms','Penggunaan stok senarai harga tidak dijumpai.',0),(87653,2435,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(87654,2435,'fr','Utilisation de Stock Prix liste introuvable.',0),(87655,2435,'jp','ä¾¡æ ¼è¡¨åœ¨åº«åˆ©ç”¨ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(87656,2435,'pt','Uso de estoque de lista de preÃ§o nÃ£o foi encontrado.',0),(87657,2435,'ru','Ð¦ÐµÐ½Ð° Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ñ… ÑÐ¿Ð¸ÑÐºÐ° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(87658,2435,'es','Uso de Stock de la Lista de Precios no se encontrÃ³',0),(87659,2435,'de','Preis Liste Lager Verwendung nicht gefunden.',0),(87660,2435,'en','Price List Stock Usage not found.',0),(87661,2436,'is','',0),(87662,2436,'dr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87663,2436,'pr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87664,2436,'tr','Fiyat listesi stok kullanÄ±mÄ± fiyatlandÄ±rma',0),(87665,2436,'pl','Cennik ceny czas uÅ¼ytkowania',0),(87666,2436,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð° ÑÑŠÑÑ‚Ð°Ð² Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(87667,2436,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(87668,2436,'sr','Ð¢Ð°Ñ€Ð¸Ñ„Ð½Ð¸Ðº Ñ†ÐµÐ½Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ðµ',0),(87669,2436,'vi','Báº£ng giÃ¡ sá»­ dá»¥ng hÃ ng tá»“n',0),(87670,2436,'af','Pryslys Voorraadgebruik Prysing',0),(87671,2436,'ro','Lista de pret stoc Usage de stabilire a preÅ£urilor',0),(87672,2436,'et','Hinnakiri varude kasutamine hinnakujundus',0),(87673,2436,'si','Cenik zalog navada cen',0),(87674,2436,'ba','Daftar harga saham penggunaan harga',0),(87675,2436,'nl','Prijslijst voorraad gebruik prijzen',0),(87676,2436,'fi','Hinnasto kaluston kÃ¤ytÃ¶n hinnoittelu',0),(87677,2436,'no','Prisliste lagerforbruket priser',0),(87678,2436,'da','Prisliste Stock skik prissÃ¦tning',0),(87679,2436,'ko','ê°€ê²©í‘œ ì‚¬ì§„ ì‚¬ìš© ê°€ê²©',0),(87680,2436,'he','×ž×—×™×¨×•×Ÿ ×©×™×ž×•×© ×ž× ×™×•×ª ×ª×ž×—×•×¨',0),(87681,2436,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(87682,2436,'zh','ä»·ç›®è¡¨çš„åº“å­˜ä½¿ç”¨å®šä»·\r\n',0),(87683,2436,'sv','Prislista lageranvÃ¤ndningen prissÃ¤ttning',0),(87684,2436,'it','Listino prezzi uso magazzino',0),(87685,2436,'tl','',0),(87686,2436,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3',0),(87687,2436,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(87688,2436,'ms','Harga senarai harga saham penggunaan',0),(87689,2436,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù…',0),(87690,2436,'fr','Liste de prix utilisation Stock prix',0),(87691,2436,'jp','ä¾¡æ ¼è¡¨åœ¨åº«åˆ©ç”¨ä¾¡æ ¼è¨­å®š',0),(87692,2436,'pt','Lista de preÃ§os preÃ§os de uso das aÃ§Ãµes',0),(87693,2436,'ru','ÐŸÑ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ Ñ†ÐµÐ½Ñ‹ Ð°ÐºÑ†Ð¸Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(87694,2436,'es','Precios del Uso de Stock de la Lista de Precios ',0),(87695,2436,'de','Preisliste hat Verwendung fÃ¼r Preise',0),(87696,2436,'en','Price List Stock Usage Pricing',0),(87697,2437,'is','',0),(87698,2437,'dr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(87699,2437,'pr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(87700,2437,'tr','Fiyat listesi stok kullanÄ±mÄ± fiyatlandÄ±rma baÅŸarÄ±yla silindi.',0),(87701,2437,'pl','Cena listy czas uÅ¼ytkowania ceny usuniÄ™te pomyÅ›lnie.',0),(87702,2437,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87703,2437,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† ÛÛ’ Û”',0),(87704,2437,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(87705,2437,'vi','XÃ³a Báº£ng giÃ¡ sá»­ dá»¥ng hÃ ng tá»“n thÃ nh cÃ´ng',0),(87706,2437,'af','Gebruikte Voorraad Prysberekenings Pryslys suksesvol geskrap.',0),(87707,2437,'ro','Pret lista stoc utilizare preturi ÅŸters cu succes.',0),(87708,2437,'et','Hind nimekirja varu kasutamine hinnakujunduse edukalt kustutatud.',0),(87709,2437,'si','Cena seznam zalog navada cenitev uspeÅ¡no izbrisana.',0),(87710,2437,'ba','Harga daftar saham penggunaan harga berhasil dihapus.',0),(87711,2437,'nl','Prijs lijst voorraad gebruik prijzen met succes verwijderd.',0),(87712,2437,'fi','Hinta luetteloon kaluston kÃ¤ytÃ¶n hinnoittelu poistettu.',0),(87713,2437,'no','Pris liste lager bruk priser slettet.',0),(87714,2437,'da','Pris liste Stock skik priser slettet.',0),(87715,2437,'ko','ê°€ê²© ëª©ë¡ ì‚¬ì§„ ì‚¬ìš© ê°€ê²© ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(87716,2437,'he','×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™ ×”×©×™×ž×•×© ×ª×ž×—×•×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(87717,2437,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î§ÏÎ·Î¼Î±Ï„Î¹ÏƒÏ„Î®ÏÎ¹Î¿ Ï‡ÏÎ®ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(87718,2437,'zh','ä»·æ ¼è¡¨çš„åº“å­˜ä½¿ç”¨å®šä»·æˆåŠŸåˆ é™¤',0),(87719,2437,'sv','Pris lista lager anvÃ¤ndning prissÃ¤ttning raderades.',0),(87720,2437,'it','Prezzo lista Stock utilizzo Pricing eliminato con successo.',0),(87721,2437,'tl','',0),(87722,2437,'th','&#3621;&#3610;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3606;&#3',0),(87723,2437,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£à¥¤',0),(87724,2437,'ms','Harga Senarai saham penggunaan harga dihapuskan dengan jayanya.',0),(87725,2437,'ar','Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(87726,2437,'fr','Prix liste Stock utilisation prix supprimÃ© avec succÃ¨s.',0),(87727,2437,'jp','ä¾¡æ ¼è¡¨åœ¨åº«åˆ©ç”¨ä¾¡æ ¼è¨­å®šã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(87728,2437,'pt','PreÃ§o lista estoque uso preÃ§os excluÃ­do com sucesso.',0),(87729,2437,'ru','Ð¦ÐµÐ½Ð° Ð¡Ð¿Ð¸ÑÐ¾Ðº Ñ„Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ñ… Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(87730,2437,'es','Precios del Uso de Stock de la Lista de Precios eliminados exitosamente',0),(87731,2437,'de','Preis Liste Lager Nutzung Preise erfolgreich gelÃ¶scht.',0),(87732,2437,'en','Price List Stock Usage Pricing deleted successfully.',0),(87733,2438,'is','',0),(87734,2438,'dr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯ ',0),(87735,2438,'pr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯ ',0),(87736,2438,'tr','Fiyat listesi stok kullanÄ±mÄ± fiyatlandÄ±rma baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(87737,2438,'pl','Cena listy czas uÅ¼ytkowania ceny pomyÅ›lnie zaktualizowana.',0),(87738,2438,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87739,2438,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† ÛÛ’ Û”',0),(87740,2438,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(87741,2438,'vi','Cáº­p nháº­t giÃ¡ cho biá»ƒu giÃ¡ hÃ ng tá»“n thÃ nh cÃ´ng',0),(87742,2438,'af','Pryslys Voorraadgebruik Prys suksesvol bygevoeg.',0),(87743,2438,'ro','Pret lista stoc utilizare preturi actualizate cu succes.',0),(87744,2438,'et','Hind nimekirja varu kasutamine hinnakujunduse vÃ¤rskendamine Ãµnnestus.',0),(87745,2438,'si','Cena seznam zalog navada cenitev uspeÅ¡no posodobljena.',0),(87746,2438,'ba','Harga daftar saham penggunaan harga diperbarui berhasil.',0),(87747,2438,'nl','Prijs lijst voorraad gebruik prijzen bijgewerkt.',0),(87748,2438,'fi','Hinta luettelon kaluston kÃ¤ytÃ¶n hinnoittelu pÃ¤ivitettiin onnistuneesti.',0),(87749,2438,'no','Pris liste lager bruk priser oppdatert.',0),(87750,2438,'da','Pris liste Stock skik priser opdateret.',0),(87751,2438,'ko','ê°€ê²© ëª©ë¡ ì‚¬ì§„ ì‚¬ìš© ê°€ê²© ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(87752,2438,'he','×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™ ×”×©×™×ž×•×© ×ª×ž×—×•×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(87753,2438,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î§ÏÎ·Î¼Î±Ï„Î¹ÏƒÏ„Î®ÏÎ¹Î¿ Ï‡ÏÎ®ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(87754,2438,'zh','ä»·æ ¼è¡¨çš„åº“å­˜ä½¿ç”¨å®šä»·æ›´æ–°æˆåŠŸã€‚\r\n',0),(87755,2438,'sv','Pris lista lager anvÃ¤ndning prissÃ¤ttning uppdaterats.',0),(87756,2438,'it','Prezzo lista Stock utilizzo prezzi aggiornati correttamente.',0),(87757,2438,'tl','',0),(87758,2438,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3',0),(87759,2438,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£à¥¤',0),(87760,2438,'ms','Harga Senarai saham penggunaan harga berjaya dikemas kini.',0),(87761,2438,'ar','Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„ØªØ³Ø¹ÙŠØ± ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(87762,2438,'fr','Prix liste Stock utilisation prix mis Ã  jour avec succÃ¨s.',0),(87763,2438,'jp','ä¾¡æ ¼è¡¨åœ¨åº«åˆ©ç”¨ä¾¡æ ¼è¨­å®šã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(87764,2438,'pt','PreÃ§o lista estoque uso preÃ§os atualizado com Ãªxito.',0),(87765,2438,'ru','Ð¦ÐµÐ½Ð° Ð¡Ð¿Ð¸ÑÐ¾Ðº Ñ„Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ñ… Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(87766,2438,'es','Precios del Uso de Stock de la Lista de Precios actualizados exitosamente',0),(87767,2438,'de','Preis Liste Lager Nutzung Preise erfolgreich aktualisiert.',0),(87768,2438,'en','Price List Stock Usage Pricing updated successfully.',0),(87769,2439,'is','',0),(87770,2439,'dr','Ø§ÙØ²ÙˆØ¯Ù†  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±    Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87771,2439,'pr','Ø§ÙØ²ÙˆØ¯Ù†  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±    Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87772,2439,'tr','Fiyat listesi stok kullanÄ±mÄ± Stok Listesi Ekle',0),(87773,2439,'pl','Cena lista zapasÃ³w czas uÅ¼ytkowania dodaÄ‡',0),(87774,2439,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° ÑÐºÐ»Ð°Ð´',0),(87775,2439,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ø³Ù¹Ø§Ú© ÙÛØ±Ø³Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(87776,2439,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ†ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¾Ð³ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð»Ð°Ð³ÐµÑ€ Ð»Ð¸ÑÑ‚Ð°',0),(87777,2439,'vi','ThÃªm danh sÃ¡ch Báº£ng giÃ¡ sá»­ dá»¥ng hÃ ng tá»“n',0),(87778,2439,'af','Pryslys Voorraadgebruik Voorraadlys Byvoeg',0),(87779,2439,'ro','Adauga Pret lista stoc utilizare stoc listÄƒ',0),(87780,2439,'et','Hind nimekirja varude kasutamine varude nimekirja',0),(87781,2439,'si','Cena seznam zalog seznam zalog uporabe dodati',0),(87782,2439,'ba','Tambahkan daftar saham saham penggunaan daftar harga',0),(87783,2439,'nl','Prijslijst voorraad gebruik voorraad toevoegen',0),(87784,2439,'fi','Hinta varastossa kÃ¤yttÃ¶ varastossa luettelo lisÃ¤Ã¤',0),(87785,2439,'no','Lager av prisliste pÃ¥ listen av lagerforbruket legge',0),(87786,2439,'da','Pris liste Stock skik bestanden listen TilfÃ¸j',0),(87787,2439,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš© ìž¬ê³  ëª©ë¡ ì¶”ê°€',0),(87788,2439,'he','×œ×”×•×¡×™×£ ×¨×©×™×ž×ª ×©×™×ž×•×© ×ž× ×™×•×ª ×ž× ×™×•×ª ×ž×—×™×¨×•×Ÿ',0),(87789,2439,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï„Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(87790,2439,'zh','ä»·ç›®è¡¨åº“å­˜ä½¿ç”¨åº“å­˜åˆ—è¡¨æ·»åŠ \r\n',0),(87791,2439,'sv','Pris lista lageranvÃ¤ndningen lager lista lÃ¤gga till',0),(87792,2439,'it','Aggiungi prezzo lista Stock utilizzo Stock List',0),(87793,2439,'tl','',0),(87794,2439,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(87795,2439,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(87796,2439,'ms','Tambah senarai saham saham penggunaan senarai harga',0),(87797,2439,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø£Ø³Ù‡Ù…',0),(87798,2439,'fr','Liste de prix utilisation Stock Stock liste ajouter',0),(87799,2439,'jp','Price List Stock Usage Stock List Add',0),(87800,2439,'pt','PreÃ§o lista lista de estoque estoque uso adicionar',0),(87801,2439,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‹ ÑÐ¿Ð¸ÑÐ¾Ðº Ð°ÐºÑ†Ð¸Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(87802,2439,'es','Lista de Precios del Uso de Stock de la Lista de Stock Agregada',0),(87803,2439,'de','Preis Liste hat Verwendung Bestandsliste hinzufÃ¼gen',0),(87804,2439,'en','Price List Stock Usage Stock List Add',0),(87805,2440,'is','',0),(87806,2440,'dr','Ø§ÙØ²ÙˆØ¯Ù†  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±    Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87807,2440,'pr','Ø§ÙØ²ÙˆØ¯Ù†  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±    Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87808,2440,'tr','Fiyat listesi stok kullanÄ±mÄ± stok listesi baÅŸarÄ±yla eklendi.',0),(87809,2440,'pl','Cena listy czas uÅ¼ytkowania czas listy dodane pomyÅ›lnie.',0),(87810,2440,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² ÑÑŠÑÑ‚Ð°Ð² ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87811,2440,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ø³Ù¹Ø§Ú© Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(87812,2440,'sr','Ð›Ð¸ÑÑ‚Ð° Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(87813,2440,'vi','ThÃªm danh sÃ¡ch Báº£ng giÃ¡ sá»­ dá»¥ng hÃ ng tá»“n thÃ nh cÃ´ng',0),(87814,2440,'af','Pryslys Voorraadgebruik Voorraadlys suksesvol bygevoeg.',0),(87815,2440,'ro','Pret lista stoc utilizare stoc listÄƒ adÄƒugat cu succes.',0),(87816,2440,'et','Hind nimekirja varu kasutamine varude nimekirja lisatud.',0),(87817,2440,'si','Seznam zalog navada Stock cenik uspeÅ¡no dodana.',0),(87818,2440,'ba','Harga saham penggunaan saham daftar ditambahkan berhasil.',0),(87819,2440,'nl','Prijs lijst voorraad gebruik Stock lijst toegevoegd.',0),(87820,2440,'fi','Luettelo kaluston kÃ¤yttÃ¶ varastossa hinnasto lisÃ¤Ã¤minen onnistui.',0),(87821,2440,'no','Listen lager bruk lager prisliste lagt.',0),(87822,2440,'da','Pris liste Stock skik bestand liste tilfÃ¸jet.',0),(87823,2440,'ko','ê°€ê²© ëª©ë¡ ì£¼ì‹ ì‚¬ìš© ìž¬ê³  ëª©ë¡ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(87824,2440,'he','×¨×©×™×ž×ª ×”×ž× ×™×•×ª ×©×™×ž×•×© ×‘×ž×œ××™ ×ž×—×™×¨×•×Ÿ × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(87825,2440,'el','Î›Î¯ÏƒÏ„Î± Î§ÏÎ·Î¼Î±Ï„Î¹ÏƒÏ„Î®ÏÎ¹Î¿ Ï‡ÏÎ®ÏƒÎ· Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(87826,2440,'zh','ä»·ç›®è¡¨åº“å­˜ä½¿ç”¨åº“å­˜åˆ—è¡¨æ·»åŠ æˆåŠŸã€‚\r\n',0),(87827,2440,'sv','Pris lista lager lager anvÃ¤ndningslista lagts.',0),(87828,2440,'it','Lista Stock utilizzo Stock listino aggiunto con successo.',0),(87829,2440,'tl','',0),(87830,2440,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3',0),(87831,2440,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¶à¥‡à¤¯à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤¸à¥‚à¤šà¥€à¥¤',0),(87832,2440,'ms','Senarai stok penggunaan stok senarai harga berjaya menambah.',0),(87833,2440,'ar','Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(87834,2440,'fr','Prix liste Stock utilisation Stock liste ajoutÃ© avec succÃ¨s.',0),(87835,2440,'jp','Price List Stock Usage Stock List added successfully.',0),(87836,2440,'pt','PreÃ§o lista estoque uso estoque lista adicionado com Ãªxito.',0),(87837,2440,'ru','Ð¦ÐµÐ½Ð° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð³Ð¾ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ñ… ÑÐ¿Ð¸ÑÐ¾Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(87838,2440,'es','Lista de Precios del Uso de Stock de la Lista de Stock agregada exitosamente',0),(87839,2440,'de','Preis Liste Lager Lager Einsatzliste erfolgreich hinzugefÃ¼gt.',0),(87840,2440,'en','Price List Stock Usage Stock List added successfully.',0),(87841,2441,'is','',0),(87842,2441,'dr','Ø­Ø°Ù  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±    Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87843,2441,'pr','Ø­Ø°Ù  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±    Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87844,2441,'tr','Fiyat listesi stok kullanÄ±mÄ± stok listesi baÅŸarÄ±yla silindi.',0),(87845,2441,'pl','Cena czas uÅ¼ytkowania czas lista usuniÄ™te pomyÅ›lnie.',0),(87846,2441,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² ÑÑŠÑÑ‚Ð°Ð² ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87847,2441,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ø³Ù¹Ø§Ú© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(87848,2441,'sr','Ð›Ð¸ÑÑ‚Ð° Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(87849,2441,'vi','XÃ³a danh sÃ¡ch Báº£ng giÃ¡ sá»­ dá»¥ng hÃ ng tá»“n thÃ nh cÃ´ng',0),(87850,2441,'af','Gebruikte Voorraadlys Pryslys suksesvol geskrap.',0),(87851,2441,'ro','Lista stoc utilizare stoc lista de preturi ÅŸters cu succes.',0),(87852,2441,'et','Hind nimekirja varu kasutamine varude nimekirja edukalt kustutatud.',0),(87853,2441,'si','Seznam zalog navada Stock cenik uspeÅ¡no izbrisana.',0),(87854,2441,'ba','Harga saham penggunaan saham daftar berhasil dihapus.',0),(87855,2441,'nl','Prijs lijst voorraad gebruik Stock lijst verwijderd.',0),(87856,2441,'fi','Luettelo kaluston kÃ¤yttÃ¶ varastossa hinnasto poistettu.',0),(87857,2441,'no','Listen lager bruk lager prisliste slettet.',0),(87858,2441,'da','Pris liste Stock skik bestanden listen slettet.',0),(87859,2441,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš© ìž¬ê³  ëª©ë¡ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(87860,2441,'he','×¨×©×™×ž×ª ×”×ž× ×™×•×ª ×©×™×ž×•×© ×‘×ž×œ××™ ×ž×—×™×¨×•×Ÿ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(87861,2441,'el','Î›Î¯ÏƒÏ„Î± Î§ÏÎ·Î¼Î±Ï„Î¹ÏƒÏ„Î®ÏÎ¹Î¿ Ï‡ÏÎ®ÏƒÎ· Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(87862,2441,'zh','ä»·ç›®è¡¨åº“å­˜ä½¿ç”¨åº“å­˜åˆ—è¡¨åˆ é™¤æˆåŠŸã€‚\r\n',0),(87863,2441,'sv','Pris lista lager lager anvÃ¤ndningslista raderades.',0),(87864,2441,'it','Lista Stock utilizzo Stock listino eliminato con successo.',0),(87865,2441,'tl','',0),(87866,2441,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(87867,2441,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¶à¥‡à¤¯à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¥€ à¤¸à¥‚à¤šà¥€à¥¤',0),(87868,2441,'ms','Senarai stok penggunaan stok senarai harga dihapuskan dengan jayanya.',0),(87869,2441,'ar','Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(87870,2441,'fr','Prix liste Stock utilisation Stock liste supprimÃ© avec succÃ¨s.',0),(87871,2441,'jp','Price List Stock Usage Stock List deleted successfully.',0),(87872,2441,'pt','PreÃ§o lista estoque uso estoque lista excluÃ­do com sucesso.',0),(87873,2441,'ru','Ð¦ÐµÐ½Ñ‹ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ñ… Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(87874,2441,'es','Lista de Precios del Uso de Stock de la Lista de Stock eliminada exitosamente',0),(87875,2441,'de','Preis Liste Lager Lager Einsatzliste erfolgreich gelÃ¶scht.',0),(87876,2441,'en','Price List Stock Usage Stock List deleted successfully.',0),(87877,2442,'is','',0),(87878,2442,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±    Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87879,2442,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±    Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(87880,2442,'tr','Fiyat listesi stok kullanÄ±mÄ± stok listesi gÃ¼ncelleme',0),(87881,2442,'pl','Cena lista zapasÃ³w zwyczaj lista aktualizacji',0),(87882,2442,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° ÑÐºÐ»Ð°Ð´ ÑÐ¿Ð¸ÑÑŠÐº Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(87883,2442,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø³Ù¹Ø§Ú© Ú©ÛŒ ÙÛØ±Ø³Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(87884,2442,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¾Ð³ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð»Ð°Ð³ÐµÑ€ Ð»Ð¸ÑÑ‚Ð° Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(87885,2442,'vi','Cáº­p nháº­t biá»ƒu giÃ¡ hÃ ng tá»“n sá»­ dá»¥nh danh sÃ¡ch hÃ ng tá»“n',0),(87886,2442,'af','Pryslys Voorraadgebruik Voorraadlys Opdateer',0),(87887,2442,'ro','Actualizare stoc listÄƒ preÅ£ listÄƒ stoc de utilizare',0),(87888,2442,'et','Hinda varude kasutamise nimestik uuendamisel',0),(87889,2442,'si','Cena seznam zalog uporabe zalog seznam posodobitev',0),(87890,2442,'ba','Harga daftar penggunaan saham saham daftar Update',0),(87891,2442,'nl','Prijs lijst voorraad gebruik voorraad lijst Update',0),(87892,2442,'fi','Hinnasto kaluston kÃ¤yttÃ¶ Osakeluettelo PÃ¤ivitÃ¤',0),(87893,2442,'no','Pris liste lager lager listen oppdatering',0),(87894,2442,'da','Pris liste Stock skik bestanden listen opdatering',0),(87895,2442,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš© ìž¬ê³  ëª©ë¡ ì—…ë°ì´íŠ¸',0),(87896,2442,'he','×¢×“×›×•×Ÿ ×¨×©×™×ž×ª ×ž×œ××™ ×©×œ ×©×™×ž×•×© ×ž×œ××™ ×¨×©×™×ž×ª ×ž×—×™×¨',0),(87897,2442,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Ï‡ÏÎ®ÏƒÎ·Ï‚ Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½',0),(87898,2442,'zh','ä»·ç›®è¡¨åº“å­˜ä½¿ç”¨åº“å­˜æ¸…å•æ›´æ–°\r\n',0),(87899,2442,'sv','Prisuppdatering lista lageranvÃ¤ndningen lagerlista',0),(87900,2442,'it','Prezzo lista Stock utilizzo Stock List Update',0),(87901,2442,'tl','',0),(87902,2442,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(87903,2442,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(87904,2442,'ms','Harga senarai stok penggunaan senarai stok Kemaskini',0),(87905,2442,'ar','ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(87906,2442,'fr','Prix liste utilisation Stock Stock liste mise Ã  jour',0),(87907,2442,'jp','Price List Stock Usage Stock List Update',0),(87908,2442,'pt','PreÃ§o lista uso estoque estoque lista atualizaÃ§Ã£o',0),(87909,2442,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐºÐ»Ð°Ð´Ð° ÑÐºÐ»Ð°Ð´Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑÐ¿Ð¸ÑÐºÐ° Ð¦ÐµÐ½Ð°',0),(87910,2442,'es','Lista de Precios del Uso de Stock de la Lista de Stock Actualizar',0),(87911,2442,'de','Liste hat Verwendung Lagerliste Preisaktualisierung',0),(87912,2442,'en','Price List Stock Usage Stock List Update',0),(87913,2443,'is','',0),(87914,2443,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±    Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87915,2443,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±    Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87916,2443,'tr','Fiyat listesi stok kullanÄ±mÄ± stok listesi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(87917,2443,'pl','Cena czas uÅ¼ytkowania czas lista pomyÅ›lnie zaktualizowana.',0),(87918,2443,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² ÑÑŠÑÑ‚Ð°Ð² ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87919,2443,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ø³Ù¹Ø§Ú© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©ÛŒ ÙÛØ±Ø³Øª ÛÛ’ Û”',0),(87920,2443,'sr','Ð›Ð¸ÑÑ‚Ð° Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(87921,2443,'vi','Cáº­p nháº­t biá»ƒu giÃ¡ hÃ ng tá»“n sá»­ dá»¥nh danh sÃ¡ch hÃ ng tá»“n thÃ nh cÃ´ng',0),(87922,2443,'af','Pryslys Voorraadgebruik Voorraadlys suksesvol opdateer.',0),(87923,2443,'ro','Lista stoc utilizare stoc lista de preÅ£uri actualizate cu succes.',0),(87924,2443,'et','Hind nimekirja varu kasutamine varude nimekirja vÃ¤rskendamine Ãµnnestus.',0),(87925,2443,'si','Cena seznam Stock Stock seznam uporab uspeÅ¡no posodobljena.',0),(87926,2443,'ba','Harga saham penggunaan saham daftar diperbarui berhasil.',0),(87927,2443,'nl','Prijs lijst voorraad gebruik Stock lijst bijgewerkt.',0),(87928,2443,'fi','Luettelo kaluston kÃ¤yttÃ¶ varastossa hinnasto pÃ¤ivitetty.',0),(87929,2443,'no','Listen lager bruk lager prisliste oppdatert.',0),(87930,2443,'da','Pris liste Stock skik bestand liste opdateret.',0),(87931,2443,'ko','ê°€ê²© ëª©ë¡ ì£¼ì‹ ì‚¬ìš© ì£¼ì‹ ëª©ë¡ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(87932,2443,'he','×¨×©×™×ž×ª ×”×ž× ×™×•×ª ×©×™×ž×•×© ×‘×ž×œ××™ ×ž×—×™×¨×•×Ÿ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(87933,2443,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± Î§ÏÎ·Î¼Î±Ï„Î¹ÏƒÏ„Î®ÏÎ¹Î¿ Ï‡ÏÎ®ÏƒÎ· Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î»Î¯ÏƒÏ„Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(87934,2443,'zh','ä»·ç›®è¡¨åº“å­˜ä½¿ç”¨åº“å­˜åˆ—è¡¨æ›´æ–°æˆåŠŸã€‚\r\n',0),(87935,2443,'sv','Pris lista lager lager anvÃ¤ndningslista uppdaterats.',0),(87936,2443,'it','Lista Stock utilizzo Stock Listino prezzi aggiornato con successo.',0),(87937,2443,'tl','',0),(87938,2443,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3',0),(87939,2443,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¶à¥‡à¤¯à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥‚à¤šà¥€à¥¤',0),(87940,2443,'ms','Senarai stok penggunaan stok senarai harga berjaya dikemas kini.',0),(87941,2443,'ar','Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(87942,2443,'fr','Prix liste Stock utilisation Stock liste mise Ã  jour avec succÃ¨s.',0),(87943,2443,'jp','Price List Stock Usage Stock List updated successfully.',0),(87944,2443,'pt','PreÃ§o lista estoque uso estoque lista atualizada com Ãªxito.',0),(87945,2443,'ru','Ð¦ÐµÐ½Ñ‹ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ñ… Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(87946,2443,'es','Lista de Precios del Uso de Stock de la Lista de Stock actualizada exitosamente',0),(87947,2443,'de','Preis Liste Lager Lager Einsatzliste erfolgreich aktualisiert.',0),(87948,2443,'en','Price List Stock Usage Stock List updated successfully.',0),(87949,2444,'is','',0),(87950,2444,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87951,2444,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(87952,2444,'tr','Fiyat listesi stok kullanÄ±mÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(87953,2444,'pl','Cena listy czas uÅ¼ytkowania pomyÅ›lnie zaktualizowana.',0),(87954,2444,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑÑ‚Ð°Ð² Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(87955,2444,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø§Ø³Ù¹Ø§Ú© Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ ÛÛ’ Û”',0),(87956,2444,'sr','Ð¦ÐµÐ½Ð° Ð»Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(87957,2444,'vi','Biá»ƒu GiÃ¡ HÃ ng Tá»“n Cáº­p Nháº­t ThÃ nh CÃ´ng',0),(87958,2444,'af','Pryslys Voorraadgebruik suksesvol opdateer.',0),(87959,2444,'ro','Pret de lista stoc utilizare actualizat cu succes.',0),(87960,2444,'et','Hind nimekirja varu kasutamine vÃ¤rskendamine Ãµnnestus.',0),(87961,2444,'si','Cena seznam zalog navada uspeÅ¡no posodobljena.',0),(87962,2444,'ba','Daftar harga saham penggunaan diperbarui berhasil.',0),(87963,2444,'nl','Prijs lijst voorraad gebruik bijgewerkt.',0),(87964,2444,'fi','Hinta luetteloon kaluston kÃ¤yttÃ¶ pÃ¤ivitettiin onnistuneesti.',0),(87965,2444,'no','Pris liste lager bruk oppdatert.',0),(87966,2444,'da','Pris liste Stock skik opdateret.',0),(87967,2444,'ko','ê°€ê²© ëª©ë¡ ìž¬ê³  ì‚¬ìš© ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(87968,2444,'he','×ž×—×™×¨ ×¨×©×™×ž×ª ×ž×œ××™ ×”×©×™×ž×•×© ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(87969,2444,'el','Î¤Î¹Î¼Î® Ï‡ÏÎ®ÏƒÎ·Ï‚ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î»Î¯ÏƒÏ„Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(87970,2444,'zh','ä»·æ ¼è¡¨çš„åº“å­˜ä½¿ç”¨å·²æˆåŠŸæ›´æ–°ã€‚\r\n',0),(87971,2444,'sv','Pris lista lager anvÃ¤ndning uppdaterats.',0),(87972,2444,'it','Prezzo lista Stock utilizzo aggiornato con successo.',0),(87973,2444,'tl','',0),(87974,2444,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(87975,2444,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(87976,2444,'ms','Penggunaan stok senarai harga berjaya dikemas kini.',0),(87977,2444,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(87978,2444,'fr','Utilisation de Stock Prix liste mise Ã  jour avec succÃ¨s.',0),(87979,2444,'jp','ä¾¡æ ¼è¡¨åœ¨åº«åˆ©ç”¨ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(87980,2444,'pt','PreÃ§o lista estoque uso atualizado com Ãªxito.',0),(87981,2444,'ru','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(87982,2444,'es','Lista de Precios del Uso de Stock  agregada exitosamente',0),(87983,2444,'de','Preis Liste Lager Verwendung erfolgreich aktualisiert.',0),(87984,2444,'en','Price List Stock Usage updated successfully.',0),(87985,2445,'is','',0),(87986,2445,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(87987,2445,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(87988,2445,'tr','Fiyat listesini gÃ¼ncelleÅŸtirme',0),(87989,2445,'pl','Aktualizacja listy ceny',0),(87990,2445,'bg','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(87991,2445,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(87992,2445,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ñ†ÐµÐ½Ðµ',0),(87993,2445,'vi','Cáº­p Nháº­t Biá»ƒu GiÃ¡',0),(87994,2445,'af','Pryslys Opdateer',0),(87995,2445,'ro','Pret lista actualizare',0),(87996,2445,'et','Hind uuendamisel',0),(87997,2445,'si','Cena seznam posodobitev',0),(87998,2445,'ba','Update daftar harga',0),(87999,2445,'nl','Prijs lijst Update',0),(88000,2445,'fi','Hinnasto PÃ¤ivitÃ¤',0),(88001,2445,'no','Listen Prisoppdatering',0),(88002,2445,'da','Pris liste Update',0),(88003,2445,'ko','ê°€ê²© ëª©ë¡ ì—…ë°ì´íŠ¸',0),(88004,2445,'he','×¢×“×›×•×Ÿ ×ž×—×™×¨×•×Ÿ',0),(88005,2445,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚ Ï„Î¹Î¼ÏŽÎ½',0),(88006,2445,'zh','ä»·æ ¼è¡¨æ›´æ–°\r\n',0),(88007,2445,'sv','Prisuppdatering',0),(88008,2445,'it','Aggiornamento elenco prezzi',0),(88009,2445,'tl','',0),(88010,2445,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(88011,2445,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(88012,2445,'ms','Kemas kini senarai harga',0),(88013,2445,'ar','ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(88014,2445,'fr','Mise Ã  jour de liste de prix',0),(88015,2445,'jp','ä¾¡æ ¼è¡¨ã?®æ›´æ–°',0),(88016,2445,'pt','ActualizaÃ§Ã£o da lista de preÃ§o',0),(88017,2445,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ñ†ÐµÐ½',0),(88018,2445,'es','Lista de Precios Actualizar',0),(88019,2445,'de','Preis Liste Update',0),(88020,2445,'en','Price List Update',0),(88021,2446,'is','',0),(88022,2446,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(88023,2446,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(88024,2446,'tr','Fiyat listesi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(88025,2446,'pl','Cennik pomyÅ›lnie zaktualizowana.',0),(88026,2446,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(88027,2446,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(88028,2446,'sr','Ð¦Ñ˜ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ»ÑƒÐ³Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(88029,2446,'vi','Cáº­p Nháº­t Biá»ƒu GiÃ¡ ThÃ nh CÃ´ng',0),(88030,2446,'af','Pryslys suksesvol opdateer',0),(88031,2446,'ro','Lista de preÅ£uri actualizate cu succes.',0),(88032,2446,'et','Hinnakirja vÃ¤rskendamine Ãµnnestus.',0),(88033,2446,'si','Cenik uspeÅ¡no posodobljena.',0),(88034,2446,'ba','Daftar harga diperbarui berhasil.',0),(88035,2446,'nl','Prijslijst bijgewerkt.',0),(88036,2446,'fi','Hinnasto pÃ¤ivitetty.',0),(88037,2446,'no','Prisliste oppdatert.',0),(88038,2446,'da','Prisliste opdateret.',0),(88039,2446,'ko','ê°€ê²© ëª©ë¡ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(88040,2446,'he','.×ž×—×™×¨×•×Ÿ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(88041,2446,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(88042,2446,'zh','ä»·æ ¼è¡¨æ›´æ–°æˆåŠŸã€‚\r\n',0),(88043,2446,'sv','Prislista uppdaterats.',0),(88044,2446,'it','Listino prezzi aggiornato con successo.',0),(88045,2446,'tl','',0),(88046,2446,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(88047,2446,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨à¥¤',0),(88048,2446,'ms','Senarai Harga berjaya dikemas kini.',0),(88049,2446,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(88050,2446,'fr','Liste des prix mis Ã  jour avec succÃ¨s.',0),(88051,2446,'jp','ä¾¡æ ¼è¡¨ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(88052,2446,'pt','Lista de preÃ§os atualizada com Ãªxito.',0),(88053,2446,'ru','ÐŸÑ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(88054,2446,'es','Lista de Precios actualizada exitosamente',0),(88055,2446,'de','Preisliste erfolgreich aktualisiert.',0),(88056,2446,'en','Price List updated successfully.',0),(88057,2447,'is','',0),(88058,2447,'dr','Ù‚ÙŠÙ…Øª  Ø¯Ø± Ù‡Ø± Ø´ØºÙ„',0),(88059,2447,'pr','Ù‚ÙŠÙ…Øª  Ø¯Ø± Ù‡Ø± Ø´ØºÙ„',0),(88060,2447,'tr','Fiyat / iÅŸ',0),(88061,2447,'pl','Cena / praca',0),(88062,2447,'bg','Ð¦ÐµÐ½Ð° / Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(88063,2447,'ur','Ù‚ÛŒÙ…Øª / Ø¬Ø§Ø¨',0),(88064,2447,'sr','Ð¦ÐµÐ½Ð° / Ð¿Ð¾ÑÐ°Ð¾',0),(88065,2447,'vi','GiÃ¡ / Job',0),(88066,2447,'af','Prys / Werkstuk',0),(88067,2447,'ro','Pret / de locuri de muncÄƒ',0),(88068,2447,'et','Hind / tÃ¶Ã¶',0),(88069,2447,'si','Cena / delo',0),(88070,2447,'ba','Harga / Job',0),(88071,2447,'nl','Prijs / baan',0),(88072,2447,'fi','Hinta / tyÃ¶',0),(88073,2447,'no','Pris / jobb',0),(88074,2447,'da','Pris / Job',0),(88075,2447,'ko','ê°€ê²© / ì¼',0),(88076,2447,'he','×ž×—×™×¨ / ×¢×‘×•×“×”',0),(88077,2447,'el','Î¤Î¹Î¼Î® / Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(88078,2447,'zh','ä»·æ ¼/å·¥ä½œ\r\n',0),(88079,2447,'sv','Pris / jobb',0),(88080,2447,'it','Prezzo / lavoro',0),(88081,2447,'tl','',0),(88082,2447,'th','&#3619;&#3634;&#3588;&#3634;/&#3591;&#3634;&#3609;',0),(88083,2447,'hi','à¤•à¥€à¤®à¤¤ / à¤…à¤¯à¥à¤¯à¥‚à¤¬',0),(88084,2447,'ms','Harga / kerja',0),(88085,2447,'ar','Ø§Ù„Ø³Ø¹Ø±/ÙˆØ¸ÙŠÙØ©',0),(88086,2447,'fr','Prix / emploi',0),(88087,2447,'jp','ä¾¡æ ¼/ä»•äº‹',0),(88088,2447,'pt','PreÃ§o / trabalho',0),(88089,2447,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ / Ð Ð°Ð±Ð¾Ñ‚Ð°',0),(88090,2447,'es','Precio / Trabajo',0),(88091,2447,'de','Preis- / Job',0),(88092,2447,'en','Price / Job',0),(88093,2448,'is','',0),(88094,2448,'dr','(Ø¯Ù‚ÙŠÙ‚Ù‡',0),(88095,2448,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø± Ù…ÙˆØ§Ø¯Ø§ÙˆÙ„ÙŠÙ‡(Ø¯Ù‚ÙŠÙ‚Ù‡',0),(88096,2448,'tr','Fiyat / M',0),(88097,2448,'pl','Cena / M',0),(88098,2448,'bg','Ð¦ÐµÐ½Ð° / M',0),(88099,2448,'ur','Ù‚ÛŒÙ…Øª / M',0),(88100,2448,'sr','Ð¦ÐµÐ½Ð° / Ðœ',0),(88101,2448,'vi','GiÃ¡ / M',0),(88102,2448,'af','Prys / M',0),(88103,2448,'ro','Pret / M',0),(88104,2448,'et','Hind / M',0),(88105,2448,'si','Cena / M',0),(88106,2448,'ba','Harga / M',0),(88107,2448,'nl','Prijs / M',0),(88108,2448,'fi','Hinta / M',0),(88109,2448,'no','Pris / M',0),(88110,2448,'da','Pris / M',0),(88111,2448,'ko','ê°€ê²© / M',0),(88112,2448,'he','×ž×—×™×¨ / M',0),(88113,2448,'el','Î¤Î¹Î¼Î® / M',0),(88114,2448,'zh','ä»·æ ¼/åƒ\r\n',0),(88115,2448,'sv','Pris / M',0),(88116,2448,'it','Prezzo / M',0),(88117,2448,'tl','',0),(88118,2448,'th','&#3619;&#3634;&#3588;&#3634;/M',0),(88119,2448,'hi','à¤•à¥€à¤®à¤¤ / M',0),(88120,2448,'ms','Harga / M',0),(88121,2448,'ar','Ø§Ù„Ø³Ø¹Ø±/Ù…',0),(88122,2448,'fr','Prix / M',0),(88123,2448,'jp','ä¾¡æ ¼/M',0),(88124,2448,'pt','PreÃ§o / M',0),(88125,2448,'ru','Ð¦ÐµÐ½Ð° / Ðœ',0),(88126,2448,'es','Precio / M',0),(88127,2448,'de','Preis / M',0),(88128,2448,'en','Price / M',0),(88129,2449,'is','',0),(88130,2449,'dr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª Ú†Ø§Ù¾',0),(88131,2449,'pr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª Ú†Ø§Ù¾',0),(88132,2449,'tr','BasÄ±n saat fiyat',0),(88133,2449,'pl','Cena za godzinÄ™ naciÅ›nij',0),(88134,2449,'bg','Ð¦ÐµÐ½Ð° Ð·Ð° Ð¿Ñ€ÐµÑÐ°Ñ‚Ð° Ñ‡Ð°Ñ',0),(88135,2449,'ur','Ù‚ÛŒÙ…Øª ÙÛŒ Ú¯Ú¾Ù†Ù¹Û Ù¾Ø±ÛŒØ³',0),(88136,2449,'sr','Ð¦ÐµÐ½Ð° Ð¿Ð¾ ÑÐ°Ñ‚Ñƒ Ð·Ð° Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ',0),(88137,2449,'vi','GiÃ¡ má»—i giá» in áº¥n',0),(88138,2449,'af','Prys Per uur Press',0),(88139,2449,'ro','PreÅ£ pe orÄƒ de presÄƒ',0),(88140,2449,'et','Vajutage tunni',0),(88141,2449,'si','Cena na uro Press',0),(88142,2449,'ba','Harga Per jam tekan',0),(88143,2449,'nl','Prijs Per uur van de pers',0),(88144,2449,'fi','Hinta paina tunnissa',0),(88145,2449,'no','Pris Per trykk time',0),(88146,2449,'da','Pris pr. Tryk pÃ¥ timer',0),(88147,2449,'ko','ë³´ë„ ì‹œê°„ ë‹¹ ê°€ê²©',0),(88148,2449,'he','×ž×—×™×¨ ×œ×©×¢×” ×”×¢×™×ª×•× ×•×ª',0),(88149,2449,'el','Î¤Î¹Î¼Î® Î±Î½Î¬ ÏŽÏÎ± Ï„ÏÏ€Î¿Ï…',0),(88150,2449,'zh','ä»·æ ¼æ¯å°åˆ·ä¸€å°æ—¶\r\n',0),(88151,2449,'sv','Pris Per Tryck timme',0),(88152,2449,'it','Costo Per ora di stampa',0),(88153,2449,'tl','',0),(88154,2449,'th','&#3619;&#3634;&#3588;&#3634;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3648;&#3619;&#3656;&#3591;&#3619;&#3637;&#3610;',0),(88155,2449,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¥à¤°à¥‡à¤¸ à¤˜à¤‚à¤Ÿà¤¾',0),(88156,2449,'ms','Harga setiap jam Seluar',0),(88157,2449,'ar','Ø³Ø¹Ø± ÙƒÙ„ Ø³Ø§Ø¹Ø© Ø§Ù„ØµØ­Ø§ÙØ©',0),(88158,2449,'fr','Prix par heure de presse',0),(88159,2449,'jp','ãƒ—ãƒ¬ã‚¹æ™‚é–“æ¯Žä¾¡æ ¼',0),(88160,2449,'pt','PreÃ§o por hora de imprensa',0),(88161,2449,'ru','Ð¦ÐµÐ½Ð° Ð·Ð° Ñ‡Ð°Ñ Ð¿Ñ€ÐµÑÑ',0),(88162,2449,'es','Precio Por Hora de Prensa',0),(88163,2449,'de','Preis pro Stunde Presse',0),(88164,2449,'en','Price Per Press Hour',0),(88165,2450,'is','',0),(88166,2450,'dr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± Ù…Ù‚Ø¯Ø§Ø± Ú†Ø§Ù¾',0),(88167,2450,'pr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± Ù…Ù‚Ø¯Ø§Ø± Ú†Ø§Ù¾',0),(88168,2450,'tr','BasÄ±n miktar baÅŸÄ±na fiyat',0),(88169,2450,'pl','Cena za iloÅ›Ä‡ prasy',0),(88170,2450,'bg','Ð¦ÐµÐ½Ð° Ð·Ð° Ð¿Ñ€ÐµÑÐ°Ñ‚Ð° ÐºÐ¾Ð»',0),(88171,2450,'ur','Ù¾Ø±ÛŒØ³ Ù‚ÛŒ ÙÛŒ Ù‚ÛŒÙ…Øª',0),(88172,2450,'sr','Ð¦ÐµÐ½Ð° Ð¿Ð¾ Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ ÐšÐ¾Ð».',0),(88173,2450,'vi','GiÃ¡ má»—i sá»‘ lÆ°á»£ng in',0),(88174,2450,'af','Prys Per Press Qty',0),(88175,2450,'ro','Pret pe presa cantit',0),(88176,2450,'et','Vajutage kogus hind',0),(88177,2450,'si','Cena tiska kol',0),(88178,2450,'ba','Harga Per tekan Qty',0),(88179,2450,'nl','Prijs Per pers Qty',0),(88180,2450,'fi','Paina kpl hinta',0),(88181,2450,'no','Prisen Per trykk Ant',0),(88182,2450,'da','Pris pr. Tryk Qty',0),(88183,2450,'ko','ë³´ë„ ìˆ˜ëŸ‰ ë‹¹ ê°€ê²©',0),(88184,2450,'he','×ž×—×™×¨ ×œ×›×œ ×›×ž×•×ª ×©×œ ×”×¢×™×ª×•× ×•×ª',0),(88185,2450,'el','Î¤Î¹Î¼Î® Î±Î½Î¬ Ï„ÏÏ€Î¿ Qty',0),(88186,2450,'zh','ä»·æ ¼æ¯å°åˆ·æ•°é‡\r\n',0),(88187,2450,'sv','Pris Per Tryck Kvt',0),(88188,2450,'it','Prezzo Per stampa Qty',0),(88189,2450,'tl','',0),(88190,2450,'th','&#3619;&#3634;&#3588;&#3634;&#3605;&#3656;&#3629;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3648;&#3619;&#3656;&#3591;&#3619;&#3637;&#3610;',0),(88191,2450,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤®à¥‚à¤²à¥à¤¯',0),(88192,2450,'ms','Harga setiap Qty Seluar',0),(88193,2450,'ar','Ø§Ù„Ø³Ø¹Ø± Ø­Ø³Ø¨ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØµØ­Ø§ÙØ©',0),(88194,2450,'fr','Prix par quantitÃ© de presse',0),(88195,2450,'jp','ãƒ—ãƒ¬ã‚¹æ•°é‡?æ¯Žä¾¡æ ¼',0),(88196,2450,'pt','PreÃ§o por imprensa Qty',0),(88197,2450,'ru','Ð¦ÐµÐ½Ð° Ð·Ð° ÑˆÑ‚. Ð¿Ñ€ÐµÑÑ',0),(88198,2450,'es','Precio Por Cantidad de Prensa',0),(88199,2450,'de','Preis pro Press Qty',0),(88200,2450,'en','Price Per Press Qty',0),(88201,2451,'is','',0),(88202,2451,'dr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ ',0),(88203,2451,'pr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ ',0),(88204,2451,'tr','Birim fiyatÄ±',0),(88205,2451,'pl','Cena za sztukÄ™',0),(88206,2451,'bg','Ð¦ÐµÐ½Ð° Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(88207,2451,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù‚ÛŒÙ…Øª',0),(88208,2451,'sr','Ð¦ÐµÐ½Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(88209,2451,'vi','GiÃ¡ má»—i Ä‘Æ¡n vá»‹',0),(88210,2451,'af','Prys Per Eenheid',0),(88211,2451,'ro','PreÈ›ul pe unitatea de',0),(88212,2451,'et','Hind Ã¼hiku kohta',0),(88213,2451,'si','Cena na enoto',0),(88214,2451,'ba','Harga Per Unit',0),(88215,2451,'nl','Prijs Per eenheid',0),(88216,2451,'fi','YksikkÃ¶hinta',0),(88217,2451,'no','Pris Per enhet',0),(88218,2451,'da','Pris pr. enhed',0),(88219,2451,'ko','ë‹¨ìœ„ ë‹¹ ê°€ê²©',0),(88220,2451,'he','×ž×—×™×¨ ×œ×™×—×™×“×”',0),(88221,2451,'el','Î¤Î¹Î¼Î® Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î±',0),(88222,2451,'zh','æ¯å•ä½ä»·æ ¼\r\n',0),(88223,2451,'sv','Pris Per enhet',0),(88224,2451,'it','Prezzo unitario',0),(88225,2451,'tl','',0),(88226,2451,'th','&#3619;&#3634;&#3588;&#3634;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(88227,2451,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤•à¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯',0),(88228,2451,'ms','Harga seunit',0),(88229,2451,'ar','Ø§Ù„Ø³Ø¹Ø± Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø©',0),(88230,2451,'fr','Prix unitaire',0),(88231,2451,'jp','å?˜ä¾¡',0),(88232,2451,'pt','PreÃ§o por unidade',0),(88233,2451,'ru','Ð¦ÐµÐ½Ð° Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(88234,2451,'es','Precio por Unidad',0),(88235,2451,'de','Preis pro StÃ¼ck',0),(88236,2451,'en','Price Per Unit',0),(88237,2452,'is','',0),(88238,2452,'dr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(88239,2452,'pr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(88240,2452,'tr','KullanÄ±m baÅŸÄ±na fiyat',0),(88241,2452,'pl','Cena za korzystanie',0),(88242,2452,'bg','Ð¦ÐµÐ½Ð° Ð·Ð° Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ',0),(88243,2452,'ur','Ù‚ÛŒÙ…Øª ÙÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(88244,2452,'sr','Ð¦ÐµÐ½Ð° Ð¿Ð¾ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸',0),(88245,2452,'vi','GiÃ¡ má»—i láº§n sá»­ dá»¥ng',0),(88246,2452,'af','Prys Per Gebruik',0),(88247,2452,'ro','Pret Per utilizare',0),(88248,2452,'et','Hind Ã¼hele kasutamine',0),(88249,2452,'si','Cena za uporabo',0),(88250,2452,'ba','Harga Per gunakan',0),(88251,2452,'nl','Prijs Per gebruik',0),(88252,2452,'fi','Hinta / kÃ¤yttÃ¶',0),(88253,2452,'no','Prisen Per bruk',0),(88254,2452,'da','Pris pr. gang',0),(88255,2452,'ko','ì‚¬ìš© ë‹¹ ê°€ê²©',0),(88256,2452,'he','×ž×—×™×¨ ×œ×›×œ ×©×™×ž×•×©',0),(88257,2452,'el','Î¤Î¹Î¼Î® Î±Î½Î¬ Ï‡ÏÎ®ÏƒÎ·',0),(88258,2452,'zh','ä»·æ ¼æ¯ä½¿ç”¨\r\n',0),(88259,2452,'sv','Pris Per anvÃ¤ndning',0),(88260,2452,'it','Prezzo Per uso',0),(88261,2452,'tl','',0),(88262,2452,'th','&#3619;&#3634;&#3588;&#3634;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;',0),(88263,2452,'hi','à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤®à¥‚à¤²à¥à¤¯',0),(88264,2452,'ms','Setiap penggunaan',0),(88265,2452,'ar','Ø§Ù„Ø³Ø¹Ø± Ù„ÙƒÙ„ Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(88266,2452,'fr','Prix par utilisation',0),(88267,2452,'jp','ä½¿ç”¨æ¯Žä¾¡æ ¼',0),(88268,2452,'pt','PreÃ§o por uso',0),(88269,2452,'ru','Ð¦ÐµÐ½Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(88270,2452,'es','Precio Por Uso',0),(88271,2452,'de','Preis pro Nutzung',0),(88272,2452,'en','Price Per Use',0),(88273,2453,'is','',0),(88274,2453,'dr','ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(88275,2453,'pr','ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(88276,2453,'tr','Fiyat birimi',0),(88277,2453,'pl','Cena jednostki',0),(88278,2453,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð°',0),(88279,2453,'ur','Ù‚ÛŒÙ…Øª ÛŒÙˆÙ†Ù¹',0),(88280,2453,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð°',0),(88281,2453,'vi','ÄÆ¡n vá»‹ giÃ¡',0),(88282,2453,'af','Pryseenheid',0),(88283,2453,'ro','Pret unitar',0),(88284,2453,'et','HinnaÃ¼hik',0),(88285,2453,'si','Enota cene',0),(88286,2453,'ba','Harga Unit',0),(88287,2453,'nl','Prijs eenheid',0),(88288,2453,'fi','YksikkÃ¶',0),(88289,2453,'no','Prisenhet',0),(88290,2453,'da','Prisenhed',0),(88291,2453,'ko','ê°€ê²© ë‹¨ìœ„',0),(88292,2453,'he','×ž×—×™×¨ ×œ×™×—×™×“×”',0),(88293,2453,'el','Î¤Î¹Î¼Î® Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(88294,2453,'zh','ä»·æ ¼å•ä½\r\n',0),(88295,2453,'sv','Prisenhet',0),(88296,2453,'it','UnitÃ  di prezzo',0),(88297,2453,'tl','',0),(88298,2453,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(88299,2453,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤•à¤¾à¤ˆ',0),(88300,2453,'ms','Unit harga',0),(88301,2453,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„Ø³Ø¹Ø±',0),(88302,2453,'fr','Prix unitÃ©',0),(88303,2453,'jp','å?˜ä¾¡',0),(88304,2453,'pt','PreÃ§o unidade',0),(88305,2453,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ñ†ÐµÐ½Ñ‹',0),(88306,2453,'es','Unidad de Precio ',0),(88307,2453,'de','Preiseinheit',0),(88308,2453,'en','Price Unit',0),(88309,2454,'is','',0),(88310,2454,'dr','ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(88311,2454,'pr','ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(88312,2454,'tr','Fatura iÃ§in fiyat birimi',0),(88313,2454,'pl','Cena jednostki do faktury',0),(88314,2454,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(88315,2454,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„Ø¦Û’ Ù‚ÛŒÙ…Øª ÛŒÙˆÙ†Ù¹',0),(88316,2454,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(88317,2454,'vi','ÄÆ¡n vá»‹ giÃ¡ cho hÃ³a Ä‘Æ¡n',0),(88318,2454,'af','Pryseenheid vir Faktuur',0),(88319,2454,'ro','PreÅ£ unitar pentru facturÄƒ',0),(88320,2454,'et','Hind Ã¼hiku eest arve',0),(88321,2454,'si','Enota cene za raÄun',0),(88322,2454,'ba','Harga Unit untuk faktur',0),(88323,2454,'nl','Prijs eenheid voor factuur',0),(88324,2454,'fi','HintayksikkÃ¶Ã¤ laskun',0),(88325,2454,'no','Prisenheten for faktura',0),(88326,2454,'da','Prisenhed for faktura',0),(88327,2454,'ko','ì†¡ìž¥ì— ëŒ€ í•œ ê°€ê²© ë‹¨ìœ„',0),(88328,2454,'he','×ž×—×™×¨ ×™×—×™×“×” ×¢×‘×•×¨ ×—×©×‘×•× ×™×ª',0),(88329,2454,'el','Î¤Î¹Î¼Î® Î¼Î¿Î½Î¬Î´Î±Ï‚ Î³Î¹Î± Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(88330,2454,'zh','ä»·æ ¼å•ä½å‘ç¥¨\r\n',0),(88331,2454,'sv','Prisenhet fÃ¶r faktura',0),(88332,2454,'it','UnitÃ  di prezzo per fattura',0),(88333,2454,'tl','',0),(88334,2454,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(88335,2454,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤•à¤¾à¤ˆ',0),(88336,2454,'ms','Harga Unit bagi invois',0),(88337,2454,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„Ø³Ø¹Ø± Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(88338,2454,'fr','Prix unitÃ© de facture',0),(88339,2454,'jp','è«‹æ±‚æ›¸ç”¨å?˜ä¾¡',0),(88340,2454,'pt','Unidade de preÃ§o de factura',0),(88341,2454,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ñ†ÐµÐ½Ñ‹ Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð°',0),(88342,2454,'es','Unidad de Precio para la Factura',0),(88343,2454,'de','Preiseinheit fÃ¼r Rechnung',0),(88344,2454,'en','Price Unit for Invoice',0),(88345,2455,'is','',0),(88346,2455,'dr','ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(88347,2455,'pr','ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(88348,2455,'tr','Birim fiyat',0),(88349,2455,'pl','Ceny jednostki',0),(88350,2455,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(88351,2455,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(88352,2455,'sr','Ð¦ÐµÐ½Ðµ Ñƒ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(88353,2455,'vi','ÄÆ¡n vá»‹ giÃ¡',0),(88354,2455,'af','Pryse van eenheid',0),(88355,2455,'ro','Unitatea de tarifare',0),(88356,2455,'et','Hindade Ã¼hik',0),(88357,2455,'si','Cene enote',0),(88358,2455,'ba','Harga Unit',0),(88359,2455,'nl','Prijzen eenheid',0),(88360,2455,'fi','Hinnoittelu yksikkÃ¶',0),(88361,2455,'no','Priser enhet',0),(88362,2455,'da','PrissÃ¦tning enhed',0),(88363,2455,'ko','ê°€ê²© ë‹¨ìœ„',0),(88364,2455,'he','×ª×ž×—×•×¨ ×™×—×™×“×”',0),(88365,2455,'el','ÎœÎ¿Î½Î¬Î´Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(88366,2455,'zh','è®¡ä»·å•ä½\r\n',0),(88367,2455,'sv','PrissÃ¤ttning enhet',0),(88368,2455,'it','Prezzi unitÃ ',0),(88369,2455,'tl','',0),(88370,2455,'th','&#3619;&#3634;&#3588;&#3634;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(88371,2455,'hi','à¤‡à¤•à¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(88372,2455,'ms','Harga Unit',0),(88373,2455,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(88374,2455,'fr','UnitÃ© de tarification',0),(88375,2455,'jp','ä¾¡æ ¼è¨­å®šå?˜ä¾¡',0),(88376,2455,'pt','Unidade de preÃ§os',0),(88377,2455,'ru','Ð¦ÐµÐ½Ð¾Ð²Ð°Ñ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(88378,2455,'es','Unidad de Precios',0),(88379,2455,'de','Preise Einheit',0),(88380,2455,'en','Pricing Unit',0),(88381,2456,'is','',0),(88382,2456,'dr','Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(88383,2456,'pr','Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(88384,2456,'tr','Fiyat dÃ¼zeyi',0),(88385,2456,'pl','Poziom cen',0),(88386,2456,'bg','Ð¦ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¸Ð²Ð¾',0),(88387,2456,'ur','Ø³Ø·Ø­ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(88388,2456,'sr','Ð¦ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ð½Ð¸Ð²Ð¾',0),(88389,2456,'vi','Má»©c giÃ¡',0),(88390,2456,'af','Pryse vlak',0),(88391,2456,'ro','Nivel de preÅ£uri',0),(88392,2456,'et','Hindade tase',0),(88393,2456,'si','Cen ravni',0),(88394,2456,'ba','Tingkat harga',0),(88395,2456,'nl','Prijzen van niveau',0),(88396,2456,'fi','Hintatasoa',0),(88397,2456,'no','Pris nivÃ¥',0),(88398,2456,'da','PrissÃ¦tning plan',0),(88399,2456,'ko','ê°€ê²© ìˆ˜ì¤€',0),(88400,2456,'he','×¨×ž×ª ×ª×ž×—×•×¨',0),(88401,2456,'el','Î•Ï€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(88402,2456,'zh','å®šä»·æ°´å¹³\r\n',0),(88403,2456,'sv','PrissÃ¤ttning nivÃ¥',0),(88404,2456,'it','Livello dei prezzi',0),(88405,2456,'tl','',0),(88406,2456,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;',0),(88407,2456,'hi','à¤¸à¥à¤¤à¤° à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(88408,2456,'ms','Harga tahap',0),(88409,2456,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(88410,2456,'fr','Niveau de prix',0),(88411,2456,'jp','ä¾¡æ ¼è¨­å®šæ°´æº–',0),(88412,2456,'pt','NÃ­vel de preÃ§os',0),(88413,2456,'ru','Ð¦ÐµÐ½Ð¾Ð²Ð¾Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ',0),(88414,2456,'es','Nivel de FijaciÃ³n de Precios',0),(88415,2456,'de','Preisniveau',0),(88416,2456,'en','Pricing Level',0),(88417,2457,'is','',0),(88418,2457,'dr','-Ø§ØµÙ„ÙŠ',0),(88419,2457,'pr','Ø³Ø±Ù…Ø§ÙŠÙ‡ Ø§ØµÙ„Ù‰-Ø§ØµÙ„ÙŠ',0),(88420,2457,'tr','AsÄ±l',0),(88421,2457,'pl','GÅ‚Ã³wny',0),(88422,2457,'bg','ÐžÑÐ½Ð¾Ð²Ð½Ð¸',0),(88423,2457,'ur','Ø§ØµÙˆÙ„ÛŒ',0),(88424,2457,'sr','Ð“Ð»Ð°Ð²Ð½Ð¸',0),(88425,2457,'vi','Chá»§',0),(88426,2457,'af','Prinsipaal',0),(88427,2457,'ro','Principalul',0),(88428,2457,'et','Peamine',0),(88429,2457,'si','Glavni',0),(88430,2457,'ba','Kepala sekolah',0),(88431,2457,'nl','Belangrijkste',0),(88432,2457,'fi','PÃ¤Ã¤asiallinen',0),(88433,2457,'no','Rektor',0),(88434,2457,'da','Vigtigste',0),(88435,2457,'ko','ì£¼',0),(88436,2457,'he','×¢×™×§×¨×•×Ÿ',0),(88437,2457,'el','ÎšÏÏÎ¹Î±',0),(88438,2457,'zh','é¦–å¸­\r\n',0),(88439,2457,'sv','Rektor',0),(88440,2457,'it','Principali',0),(88441,2457,'tl','',0),(88442,2457,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(88443,2457,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤¸à¤¿à¤ªà¤²',0),(88444,2457,'ms','Utama',0),(88445,2457,'ar','Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(88446,2457,'fr','Principal',0),(88447,2457,'jp','å…ƒé‡‘',0),(88448,2457,'pt','Principal',0),(88449,2457,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ðµ',0),(88450,2457,'es','Principal',0),(88451,2457,'de','Principal',0),(88452,2457,'en','Principal',0),(88453,2458,'is','',0),(88454,2458,'dr','Ø¨Ø¯Ù‡ÙŠ Ø§ØµÙ„ÙŠ',0),(88455,2458,'pr','Ø¨Ø¯Ù‡ÙŠ Ø§ØµÙ„ÙŠ',0),(88456,2458,'tr','AsÄ±l adÄ± nedeniyle',0),(88457,2458,'pl','Podmiot Due',0),(88458,2458,'bg','ÐŸÐ°Ð´ÐµÐ¶ Ð½Ð° Ð³Ð»Ð°Ð²Ð½Ð¸Ñ†Ð°Ñ‚Ð°',0),(88459,2458,'ur','Ù¾Ø±Ù†Ø³Ù¾Ù„ Ù…Ù‚Ø±Ø±Û',0),(88460,2458,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€ ÐºÑ€Ð°Ñ˜ÑšÐ¸',0),(88461,2458,'vi','Äáº¿n háº¡n ',0),(88462,2458,'af','Skoolhoof behoorlike',0),(88463,2458,'ro','Principal din cauza',0),(88464,2458,'et','Printsipaal nÃµuetekohaselt',0),(88465,2458,'si','Zapadlosti glavnice',0),(88466,2458,'ba','Karena kepala sekolah',0),(88467,2458,'nl','Principal Due',0),(88468,2458,'fi','Rehtori asianmukaisesti',0),(88469,2458,'no','Viktigste grunn',0),(88470,2458,'da','Principal Due',0),(88471,2458,'ko','êµìž¥ ë•Œë¬¸',0),(88472,2458,'he','×ž× ×”×œ ×ª×§×™×Ÿ',0),(88473,2458,'el','ÎšÏÏÎ¹Î¿Ï‚ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚',0),(88474,2458,'zh','ä¸»è¦ç”±äºŽ\r\n',0),(88475,2458,'sv','Rektor vederbÃ¶rlig',0),(88476,2458,'it','Principale dovuta',0),(88477,2458,'tl','',0),(88478,2458,'th','&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3594;&#3635;&#3619;&#3632;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(88479,2458,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤¸à¤¿à¤ªà¤² à¤¨à¤¿à¤¯à¤¤',0),(88480,2458,'ms','Disebabkan oleh Pengetua',0),(88481,2458,'ar','Ø§Ù„ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ',0),(88482,2458,'fr','Principal Due',0),(88483,2458,'jp','å…ƒé‡‘æœŸé™?',0),(88484,2458,'pt','Principal devido',0),(88485,2458,'ru','Ð“Ð»Ð°Ð²Ð½Ñ‹Ð¹ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾',0),(88486,2458,'es','Debido el Principal',0),(88487,2458,'de','Principal Due',0),(88488,2458,'en','Principal Due',0),(88489,2459,'is','',0),(88490,2459,'dr','Ú†Ø§Ù¾ ',0),(88491,2459,'pr','Ú†Ø§Ù¾ ',0),(88492,2459,'tr','YazdÄ±r',0),(88493,2459,'pl','Drukuj',0),(88494,2459,'bg','ÐŸÐµÑ‡Ð°Ñ‚',0),(88495,2459,'ur','Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº',0),(88496,2459,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜',0),(88497,2459,'vi','In ',0),(88498,2459,'af','Uitdruk',0),(88499,2459,'ro','Imprimare',0),(88500,2459,'et','TrÃ¼ki',0),(88501,2459,'si','Print',0),(88502,2459,'ba','Cetak',0),(88503,2459,'nl','Afdrukken',0),(88504,2459,'fi','Tulosta',0),(88505,2459,'no','Skriv ut',0),(88506,2459,'da','Udskriv',0),(88507,2459,'ko','ì¸ì‡„',0),(88508,2459,'he','×”×“×¤×¡',0),(88509,2459,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(88510,2459,'zh','æ‰“å°\r\n',0),(88511,2459,'sv','Skriv ut',0),(88512,2459,'it','Stampa',0),(88513,2459,'tl','',0),(88514,2459,'th','&#3614;&#3636;&#3617;&#3614;&#3660;',0),(88515,2459,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(88516,2459,'ms','Cetak',0),(88517,2459,'ar','Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(88518,2459,'fr','Imprimer',0),(88519,2459,'jp','è«‹æ±‚é¡?ã‚’æ”¯æ‰•ã?†',0),(88520,2459,'pt','ImpressÃ£o',0),(88521,2459,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ',0),(88522,2459,'es','Imprimir',0),(88523,2459,'de','Drucken',0),(88524,2459,'en','Print',0),(88525,2460,'is','',0),(88526,2460,'dr','941',0),(88527,2460,'pr','Ú†Ø§Ù¾ 941',0),(88528,2460,'tr','BaskÄ± 941s',0),(88529,2460,'pl','Druk 941s',0),(88530,2460,'bg','ÐŸÐµÑ‡Ð°Ñ‚ 941s',0),(88531,2460,'ur','Ù¾Ø±Ù†Ù¹ 941s',0),(88532,2460,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ 941Ñ',0),(88533,2460,'vi','In 941',0),(88534,2460,'af','Druk 941s',0),(88535,2460,'ro','Imprimare 941s',0),(88536,2460,'et','Prindi 941s',0),(88537,2460,'si','Tiskanje 941s',0),(88538,2460,'ba','Cetak 941s',0),(88539,2460,'nl','Afgedrukt van 941s',0),(88540,2460,'fi','Tulosta kuiden parissa',0),(88541,2460,'no','Skrive ut 941s',0),(88542,2460,'da','Udskrive 941s',0),(88543,2460,'ko','ì¸ì‡„ 941s',0),(88544,2460,'he','×”×“×¤×¡×” 941s',0),(88545,2460,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· 941s',0),(88546,2460,'zh','æ‰“å°941s\r\n',0),(88547,2460,'sv','Skriva ut 941s',0),(88548,2460,'it','Stampa 941s',0),(88549,2460,'tl','',0),(88550,2460,'th','&#3614;&#3636;&#3617;&#3614;&#3660; 941s',0),(88551,2460,'hi','941s à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(88552,2460,'ms','Cetak 941s',0),(88553,2460,'ar','Ø·Ø¨Ø§Ø¹Ø© 941s',0),(88554,2460,'fr','Impression 941s',0),(88555,2460,'jp','941ï½“ã?®å?°åˆ·',0),(88556,2460,'pt','Imprimir 941s',0),(88557,2460,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ 941Ñ',0),(88558,2460,'es','Imprimir 941s',0),(88559,2460,'de','Drucken 941s',0),(88560,2460,'en','Print 941s',0),(88561,2461,'is','',0),(88562,2461,'dr','Ú†Ø§Ù¾ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§',0),(88563,2461,'pr','Ú†Ø§Ù¾ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§',0),(88564,2461,'tr','TÃ¼m Ã§ekleri yazdÄ±rma',0),(88565,2461,'pl','Drukuj wszystkie kontrole',0),(88566,2461,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(88567,2461,'ur','ØªÙ…Ø§Ù… Ù¾Ú‘ØªØ§Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(88568,2461,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑÐ²Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(88569,2461,'vi','In táº¥t cáº£ SÃ©c',0),(88570,2461,'af','Druk alle Tjeks',0),(88571,2461,'ro','Toate verificÄƒrile de imprimare',0),(88572,2461,'et','Prindi kÃµik kontrollid',0),(88573,2461,'si','Natisniti vse Äeke',0),(88574,2461,'ba','Mencetak cek semua',0),(88575,2461,'nl','Alle cheques afdrukken',0),(88576,2461,'fi','Tulostaa kaikki tarkastukset',0),(88577,2461,'no','Skrive ut alle sjekker',0),(88578,2461,'da','Udskrive alle Checks',0),(88579,2461,'ko','ëª¨ë“  ê²€ì‚¬ë¥¼ ì¸ì‡„',0),(88580,2461,'he','×”×“×¤×¡ ×›×œ ×”×¦\'×§×™×',0),(88581,2461,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ ÏŒÎ»Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚',0),(88582,2461,'zh','æ‰“å°æ‰€æœ‰çš„æ”¯ç¥¨\r\n',0),(88583,2461,'sv','Skriva ut alla kontroller',0),(88584,2461,'it','Stampare tutte le verifiche',0),(88585,2461,'tl','',0),(88586,2461,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3594;&#3655;&#3588;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(88587,2461,'hi','à¤¸à¤­à¥€ à¤šà¥‡à¤• à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(88588,2461,'ms','Mencetak semua cek',0),(88589,2461,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø¬Ù…ÙŠØ¹',0),(88590,2461,'fr','Imprimer toutes les vÃ©rifications',0),(88591,2461,'jp','Print all checks',0),(88592,2461,'pt','ImpressÃ£o de todos os cheques',0),(88593,2461,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð²ÑÐµ Ð§ÐµÐºÐ¸',0),(88594,2461,'es','Imprimir Todos los Cheques',0),(88595,2461,'de','Drucken Sie alle PrÃ¼fungen',0),(88596,2461,'en','Print all Checks',0),(88597,2462,'is','',0),(88598,2462,'dr','Ú†Ø§Ù¾ Ú†Ùƒ ',0),(88599,2462,'pr','Ú†Ø§Ù¾ Ú†Ùƒ ',0),(88600,2462,'tr','Ã‡ek yazdÄ±rmak',0),(88601,2462,'pl','Drukowanie wyboru',0),(88602,2462,'bg','ÐŸÑ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚: Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(88603,2462,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù¾Ú‘ØªØ§Ù„',0),(88604,2462,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ñ‡ÐµÐº',0),(88605,2462,'vi','In SÃ©c',0),(88606,2462,'af','Druk Tjek',0),(88607,2462,'ro','Imprimare cec',0),(88608,2462,'et','Prindi tÅ¡ekk',0),(88609,2462,'si','Natisni Äek',0),(88610,2462,'ba','Mencetak Check',0),(88611,2462,'nl','Cheque afdrukken',0),(88612,2462,'fi','Tulosta sekki',0),(88613,2462,'no','Skrive ut sjekk',0),(88614,2462,'da','Udskriv Check',0),(88615,2462,'ko','ì¸ì‡„ í™•ì¸',0),(88616,2462,'he','×”×¡×™×ž×•×Ÿ ×”×“×¤×¡×”',0),(88617,2462,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(88618,2462,'zh','æ‰“å°æ”¯ç¥¨\r\n',0),(88619,2462,'sv','Skriva ut Check',0),(88620,2462,'it','Stampa Check',0),(88621,2462,'tl','',0),(88622,2462,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3594;&#3655;&#3588;',0),(88623,2462,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤šà¥‡à¤•',0),(88624,2462,'ms','Semak cetakan',0),(88625,2462,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(88626,2462,'fr','Imprimer chÃ¨que',0),(88627,2462,'jp','æ”¯æ‰•ã?„æ¸ˆã?¿ã?®è«‹æ±‚æ›¸ã‚’å?°åˆ·',0),(88628,2462,'pt','Imprimir seleÃ§Ã£o',0),(88629,2462,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð§ÐµÐº',0),(88630,2462,'es','Imprimir Cheque',0),(88631,2462,'de','Scheck drucken',0),(88632,2462,'en','Print Check',0),(88633,2463,'is','',0),(88634,2463,'dr','Ú†Ø§Ù¾ Ú†Ùƒ Ù‡Ø§ ',0),(88635,2463,'pr','Ú†Ø§Ù¾ Ú†Ùƒ Ù‡Ø§ ',0),(88636,2463,'tr','BaskÄ± kontrol',0),(88637,2463,'pl','Drukowania kontroli',0),(88638,2463,'bg','Ð”Ð° Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ñ‚Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(88639,2463,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù¾Ú‘ØªØ§Ù„',0),(88640,2463,'sr','Ð”Ð° Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ‚Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(88641,2463,'vi','In SÃ©c',0),(88642,2463,'af','Druk Tjeks',0),(88643,2463,'ro','Imprimare controale',0),(88644,2463,'et','Prindi tÅ¡ekid',0),(88645,2463,'si','Natisk Äek',0),(88646,2463,'ba','Cetak cek',0),(88647,2463,'nl','Afdrukken controles',0),(88648,2463,'fi','Tulosta shekit',0),(88649,2463,'no','Skrive ut sjekker',0),(88650,2463,'da','Udskriv kontrol',0),(88651,2463,'ko','ì¸ì‡„ ê²€ì‚¬',0),(88652,2463,'he','×”×“×¤×¡ ×¦\'×§×™×',0),(88653,2463,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Ï„Ï‰Î½ ÎµÎ»Î­Î³Ï‡Ï‰Î½',0),(88654,2463,'zh','æ‰“å°æ”¯ç¥¨\r\n',0),(88655,2463,'sv','Skriva ut checkar',0),(88656,2463,'it','Stampa assegni',0),(88657,2463,'tl','',0),(88658,2463,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3594;&#3655;&#3588;',0),(88659,2463,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(88660,2463,'ms','Semakan cetakan',0),(88661,2463,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª',0),(88662,2463,'fr','Impression de chÃ¨ques',0),(88663,2463,'jp','Print Checks',0),(88664,2463,'pt','ImpressÃ£o de cheques',0),(88665,2463,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð§ÐµÐºÐ¸',0),(88666,2463,'es','Imprimir Cheques',0),(88667,2463,'de','Druck-PrÃ¼fungen',0),(88668,2463,'en','Print Checks',0),(88669,2464,'is','',0),(88670,2464,'dr','Ú†Ø§Ù¾ ÙØ§ÙƒØªÙˆØ±',0),(88671,2464,'pr','Ú†Ø§Ù¾ ÙØ§ÙƒØªÙˆØ±',0),(88672,2464,'tr','Fatura YazdÄ±r',0),(88673,2464,'pl','Drukuj fakturÄ™',0),(88674,2464,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(88675,2464,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(88676,2464,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(88677,2464,'vi','In hÃ³a Ä‘Æ¡n',0),(88678,2464,'af','Druk Faktuur',0),(88679,2464,'ro','Imprimare facturÄƒ',0),(88680,2464,'et','Prindi arve',0),(88681,2464,'si','Natisni raÄun',0),(88682,2464,'ba','Faktur cetak',0),(88683,2464,'nl','Factuur afdrukken',0),(88684,2464,'fi','Tulosta lasku',0),(88685,2464,'no','Skriver ut faktura',0),(88686,2464,'da','Udskriv faktura',0),(88687,2464,'ko','ì²­êµ¬ì„œ ì¸ì‡„',0),(88688,2464,'he','×”×“×¤×¡ ×—×©×‘×•× ×™×ª',0),(88689,2464,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(88690,2464,'zh','æ‰“å°å‘ç¥¨\r\n',0),(88691,2464,'sv','Skriva ut faktura',0),(88692,2464,'it','Stampa fattura',0),(88693,2464,'tl','',0),(88694,2464,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(88695,2464,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(88696,2464,'ms','Mencetak invois',0),(88697,2464,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(88698,2464,'fr','Imprimer une facture',0),(88699,2464,'jp','è«‹æ±‚æ›¸ã?®å?°åˆ·',0),(88700,2464,'pt','Imprimir factura',0),(88701,2464,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð°',0),(88702,2464,'es','Imprimir Factura',0),(88703,2464,'de','Rechnung zu drucken',0),(88704,2464,'en','Print Invoice',0),(88705,2465,'is','',0),(88706,2465,'dr','(Ù…Ø¬ÙˆØ²) Ø´ØºÙ„',0),(88707,2465,'pr','Ú†Ø§Ù¾ Ø¨Ù„ÙŠØ·(Ù…Ø¬ÙˆØ²) Ø´ØºÙ„',0),(88708,2465,'tr','YazdÄ±rma iÅŸi Bilet',0),(88709,2465,'pl','Zadanie drukowania biletÃ³w',0),(88710,2465,'bg','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð±Ð¸Ð»ÐµÑ‚',0),(88711,2465,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¬Ø§Ø¨ Ù¹Ú©Ù¹',0),(88712,2465,'sr','ÐšÐ°Ñ€Ñ‚Ð° Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(88713,2465,'vi','In Phiáº¿u Job',0),(88714,2465,'af','Druktaak kaartjie',0),(88715,2465,'ro','Bilet de tipÄƒrire',0),(88716,2465,'et','PrinditÃ¶Ã¶ Piletite',0),(88717,2465,'si','Tiskalni posel vozovnice',0),(88718,2465,'ba','Pencetakan tiket',0),(88719,2465,'nl','Afdruktaak Ticket',0),(88720,2465,'fi','TulostustyÃ¶n lippu',0),(88721,2465,'no','Utskriftsjobben billett',0),(88722,2465,'da','Udskrive jobbillet',0),(88723,2465,'ko','ì¸ì‡„ ìž‘ì—… í‹°ì¼“',0),(88724,2465,'he','×”×“×¤×¡ ×›×¨×˜×™×¡ ×¢×‘×•×“×”',0),(88725,2465,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Job Ticket',0),(88726,2465,'zh','æ‰“å°ä½œä¸šå•\r\n',0),(88727,2465,'sv','Utskriftsjobb biljett',0),(88728,2465,'it','Processo di stampa biglietto',0),(88729,2465,'tl','',0),(88730,2465,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3633;&#3659;&#3623;&#3591;&#3634;&#3609;',0),(88731,2465,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¤¾à¤°à¥à¤¯ à¤Ÿà¤¿à¤•à¤Ÿ',0),(88732,2465,'ms','Kerja cetakan Tiket.',0),(88733,2465,'ar','ØªØ°ÙƒØ±Ø© Ù…Ù‡Ù…Ø© Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(88734,2465,'fr','Imprimer le bon de travail',0),(88735,2465,'jp','ä½œæ¥­è¡¨ã?®å?°åˆ·',0),(88736,2465,'pt','Trabalho de impressÃ£o de Ticket',0),(88737,2465,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð±Ð¸Ð»ÐµÑ‚Ð°',0),(88738,2465,'es','Imprimir Boleto de Trabajo',0),(88739,2465,'de','Job-Ticket drucken',0),(88740,2465,'en','Print Job Ticket',0),(88741,2466,'is','',0),(88742,2466,'dr','Ú†Ø§Ù¾ Ù…Ø­Ù„ ',0),(88743,2466,'pr','Ú†Ø§Ù¾ Ù…Ø­Ù„ ',0),(88744,2466,'tr','YazÄ±cÄ± konumu',0),(88745,2466,'pl','Lokalizacja wydruku',0),(88746,2466,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(88747,2466,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(88748,2466,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(88749,2466,'vi','Vá»‹ trÃ­ in',0),(88750,2466,'af','Uitdrukbare Punte',0),(88751,2466,'ro','Imprimare locaÅ£ie',0),(88752,2466,'et','Prindi asukoht',0),(88753,2466,'si','Tiskanje mesto',0),(88754,2466,'ba','Cetak lokasi',0),(88755,2466,'nl','Afdrukpositie',0),(88756,2466,'fi','Tulosta sijainnin',0),(88757,2466,'no','Utskriftsplassering',0),(88758,2466,'da','Udskrive placering',0),(88759,2466,'ko','ì¸ì‡„ ìœ„ì¹˜',0),(88760,2466,'he','×”×“×¤×¡ ×ž×™×§×•×',0),(88761,2466,'el','Î˜Î­ÏƒÎ·Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(88762,2466,'zh','æ‰“å°ä½ç½®\r\n',0),(88763,2466,'sv','Skriva ut lÃ¤ge',0),(88764,2466,'it','Area di stampa',0),(88765,2466,'tl','',0),(88766,2466,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(88767,2466,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¸à¥à¤¥à¤¾à¤¨',0),(88768,2466,'ms','Lokasi cetakan',0),(88769,2466,'ar','Ù…ÙˆÙ‚Ø¹ Ø·Ø¨Ø§Ø¹Ø©',0),(88770,2466,'fr','Emplacement de l\'impression',0),(88771,2466,'jp','å?°åˆ·ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(88772,2466,'pt','Local de impressÃ£o',0),(88773,2466,'ru','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(88774,2466,'es','UbicaciÃ³n de Imprenta',0),(88775,2466,'de','Lage zu drucken',0),(88776,2466,'en','Print Location',0),(88777,2467,'is','',0),(88778,2467,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú†Ø§Ù¾ Ù…Ø­Ù„ ',0),(88779,2467,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú†Ø§Ù¾ Ù…Ø­Ù„ ',0),(88780,2467,'tr','YazdÄ±rma konumu ekle',0),(88781,2467,'pl','Lokalizacja wydruku dodaÄ‡',0),(88782,2467,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(88783,2467,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(88784,2467,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð´Ð¾Ð´Ð°Ñ‚Ðµ',0),(88785,2467,'vi','ThÃªm Vá»‹ trÃ­ in',0),(88786,2467,'af','Uitdrukbare Punt Byvoeg',0),(88787,2467,'ro','Adauga imprimare locaÅ£ie',0),(88788,2467,'et','Prindi asukoha lisamine',0),(88789,2467,'si','Dodaj mesto tiskanja',0),(88790,2467,'ba','Tambahkan Cetak lokasi',0),(88791,2467,'nl','Afdrukpositie toevoegen',0),(88792,2467,'fi','Tulosta sijainnin lisÃ¤Ã¤minen',0),(88793,2467,'no','Utskriftsplassering legge',0),(88794,2467,'da','Print placering tilfÃ¸je',0),(88795,2467,'ko','ì¸ì‡„ ìœ„ì¹˜ ì¶”ê°€',0),(88796,2467,'he','×”×•×¡×¤×ª ×ž×™×§×•× ×”×”×“×¤×¡×”',0),(88797,2467,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¸Î­ÏƒÎ·Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(88798,2467,'zh','æ‰“å°ä½ç½®æ·»åŠ \r\n',0),(88799,2467,'sv','Skriv ut platsen lÃ¤gga till',0),(88800,2467,'it','Aggiungi posizione stampa',0),(88801,2467,'tl','',0),(88802,2467,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(88803,2467,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(88804,2467,'ms','Tambah lokasi cetakan',0),(88805,2467,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹ Ø·Ø¨Ø§Ø¹Ø©',0),(88806,2467,'fr','Ajouter emplacement d\'impression',0),(88807,2467,'jp','å?°åˆ·ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®è¿½åŠ ',0),(88808,2467,'pt','Adicionar o local de impressÃ£o',0),(88809,2467,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(88810,2467,'es','UbicaciÃ³n de ImpresiÃ³n Agregar',0),(88811,2467,'de','Drucken Speicherort hinzugefÃ¼gt werden',0),(88812,2467,'en','Print Location Add',0),(88813,2468,'is','',0),(88814,2468,'dr','Ø­Ø°Ù Ú†Ø§Ù¾ Ù…Ø­Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(88815,2468,'pr','Ø­Ø°Ù Ú†Ø§Ù¾ Ù…Ø­Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(88816,2468,'tr','YazdÄ±rma konumu baÅŸarÄ±yla silindi',0),(88817,2468,'pl','Wydruku lokalizacji usuniÄ™te pomyÅ›lnie',0),(88818,2468,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(88819,2468,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(88820,2468,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(88821,2468,'vi','XÃ³a Vá»‹ trÃ­ in thÃ nh cÃ´ng',0),(88822,2468,'af','Uitdrukbare Punt Suksesvol Geskrap.',0),(88823,2468,'ro','Imprimare locaÅ£ie eliminÄƒ cu succes',0),(88824,2468,'et','Prindi asukoht edukalt kustutatud',0),(88825,2468,'si','Tiskanje mesto uspeÅ¡no izbrisana',0),(88826,2468,'ba','Cetak lokasi dihapus berhasil',0),(88827,2468,'nl','Afdrukpositie met succes verwijderd',0),(88828,2468,'fi','Tulosta sijainnin poistettu',0),(88829,2468,'no','Utskriftsplassering slettet',0),(88830,2468,'da','Udskrive placering slettet',0),(88831,2468,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì¸ì‡„ ìœ„ì¹˜',0),(88832,2468,'he','×ž×™×§×•× ×”×”×“×¤×¡×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(88833,2468,'el','Î˜Î­ÏƒÎ·Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(88834,2468,'zh','æ‰“å°ä½ç½®åˆ é™¤æˆåŠŸ\r\n',0),(88835,2468,'sv','Skriva ut lÃ¤ge raderades',0),(88836,2468,'it','Area di stampa eliminato con successo',0),(88837,2468,'tl','',0),(88838,2468,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(88839,2468,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(88840,2468,'ms','Cetak lokasi dihapuskan dengan jayanya',0),(88841,2468,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(88842,2468,'fr','Emplacement d\'impression supprimÃ©e avec succÃ¨s',0),(88843,2468,'jp','å?°åˆ·ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(88844,2468,'pt','Local de impressÃ£o excluÃ­do com sucesso',0),(88845,2468,'ru','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(88846,2468,'es','UbicaciÃ³n de ImpresiÃ³n Eliminada Exitosamente',0),(88847,2468,'de','Print Location erfolgreich gelÃ¶scht',0),(88848,2468,'en','Print Location Deleted Successfully',0),(88849,2469,'is','',0),(88850,2469,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ú†Ø§Ù¾ ',0),(88851,2469,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ú†Ø§Ù¾ ',0),(88852,2469,'tr','YazdÄ±rma seÃ§eneÄŸi',0),(88853,2469,'pl','Opcja drukowania',0),(88854,2469,'bg','ÐžÐ¿Ñ†Ð¸Ñ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(88855,2469,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(88856,2469,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ°',0),(88857,2469,'vi','Lá»±a chá»n in',0),(88858,2469,'af','Druk Opsie',0),(88859,2469,'ro','OpÅ£iune de imprimare',0),(88860,2469,'et','Prindi valik',0),(88861,2469,'si','MoÅ¾nost tiskanja',0),(88862,2469,'ba','Pilihan cetak',0),(88863,2469,'nl','Afdrukoptie',0),(88864,2469,'fi','Tulosta vaihtoehto',0),(88865,2469,'no','Utskriftsalternativ',0),(88866,2469,'da','Udskriftsindstillingen',0),(88867,2469,'ko','ì¸ì‡„ ì˜µì…˜',0),(88868,2469,'he','××¤×©×¨×•×ª ×”×“×¤×¡×”',0),(88869,2469,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(88870,2469,'zh','æ‰“å°é€‰é¡¹\r\n',0),(88871,2469,'sv','Avtrycken valen',0),(88872,2469,'it','Opzione di stampa',0),(88873,2469,'tl','',0),(88874,2469,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(88875,2469,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(88876,2469,'ms','Pilihan cetak',0),(88877,2469,'ar','Ø®ÙŠØ§Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(88878,2469,'fr','Option d\'impression',0),(88879,2469,'jp','å?°åˆ·ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(88880,2469,'pt','OpÃ§Ã£o de impressÃ£o',0),(88881,2469,'ru','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ ÐŸÐµÑ‡Ð°Ñ‚Ð¸',0),(88882,2469,'es','OpciÃ³n de Imprimir',0),(88883,2469,'de','Druckoption',0),(88884,2469,'en','Print Option',0),(88885,2470,'is','',0),(88886,2470,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ú†Ø§Ù¾ ',0),(88887,2470,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ú†Ø§Ù¾ ',0),(88888,2470,'tr','YazdÄ±rma seÃ§enekleri',0),(88889,2470,'pl','Opcje drukowania',0),(88890,2470,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(88891,2470,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(88892,2470,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ°',0),(88893,2470,'vi','Lá»±a chá»n in',0),(88894,2470,'af','Druk Opsies',0),(88895,2470,'ro','OpÈ›iuni de imprimare',0),(88896,2470,'et','Printimise Valikud',0),(88897,2470,'si','MoÅ¾nosti tiskanja',0),(88898,2470,'ba','Pilihan cetak',0),(88899,2470,'nl','Afdrukopties',0),(88900,2470,'fi','Tulostusasetukset',0),(88901,2470,'no','Utskriftsalternativer',0),(88902,2470,'da','Udskriftsindstillinger',0),(88903,2470,'ko','ì¸ì‡„ ì˜µì…˜',0),(88904,2470,'he','××¤×©×¨×•×™×•×ª ×”×“×¤×¡×”',0),(88905,2470,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(88906,2470,'zh','æ‰“å°é€‰é¡¹\r\n',0),(88907,2470,'sv','Utskriftsalternativ',0),(88908,2470,'it','Opzioni di stampa',0),(88909,2470,'tl','',0),(88910,2470,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(88911,2470,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(88912,2470,'ms','Pilihan cetakan',0),(88913,2470,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(88914,2470,'fr','Options d\'impression',0),(88915,2470,'jp','å?°åˆ·ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(88916,2470,'pt','OpÃ§Ãµes de impressÃ£o',0),(88917,2470,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÐŸÐµÑ‡Ð°Ñ‚Ð¸',0),(88918,2470,'es','Opciones de Imprimir',0),(88919,2470,'de','Druckoptionen',0),(88920,2470,'en','Print Options',0),(88921,2471,'is','',0),(88922,2471,'dr','(Ù…Ø¬ÙˆØ²) ÙØ±Ù…Ø§ÛŒØ´',0),(88923,2471,'pr','Ú†Ø§Ù¾ Ø¨Ù„ÙŠØ·(Ù…Ø¬ÙˆØ²) Ø³ÙØ§Ø±Ø´',0),(88924,2471,'tr','YazdÄ±rma sÄ±rasÄ±nÄ± Bilet',0),(88925,2471,'pl','KolejnoÅ›Ä‡ drukowania biletÃ³w',0),(88926,2471,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð±Ð¸Ð»ÐµÑ‚',0),(88927,2471,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù¹Ú©Ù¹',0),(88928,2471,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°Ñ˜ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(88929,2471,'vi','VÃ© in',0),(88930,2471,'af','Orde kaartjie druk',0),(88931,2471,'ro','Bilet de ordine de imprimare',0),(88932,2471,'et','Tellimuse Piletite printimine',0),(88933,2471,'si','Vrstni red tiskanja vozovnice',0),(88934,2471,'ba','Order cetak Tiket',0),(88935,2471,'nl','Afdrukvolgorde Ticket',0),(88936,2471,'fi','TulostusjÃ¤rjestyksen lippu',0),(88937,2471,'no','UtskriftsrekkefÃ¸lge billett',0),(88938,2471,'da','Udskrive ordre billet',0),(88939,2471,'ko','ì¸ì‡„ ìˆœì„œ í‹°ì¼“',0),(88940,2471,'he','×”×“×¤×¡ ×›×¨×˜×™×¡ ×”×–×ž× ×”',0),(88941,2471,'el','Î•Î¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(88942,2471,'zh','æ‰“å°è®¢å•ç¥¨æ®\r\n',0),(88943,2471,'sv','Utskriftsordning biljett',0),(88944,2471,'it','Ordine stampa biglietto',0),(88945,2471,'tl','',0),(88946,2471,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3633;&#3659;&#3623;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(88947,2471,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤Ÿà¤¿à¤•à¤Ÿ',0),(88948,2471,'ms','Cetak Tiket.',0),(88949,2471,'ar','Ø£Ù…Ø± Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(88950,2471,'fr','Billet de l\'ordre d\'impression',0),(88951,2471,'jp','æ³¨æ–‡ç¥¨ã?®å?°åˆ·',0),(88952,2471,'pt','Ordem de impressÃ£o de Ticket',0),(88953,2471,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð±Ð¸Ð»ÐµÑ‚Ð°',0),(88954,2471,'es','Boleto de Orden de Orden de Imprimir',0),(88955,2471,'de','Print Order Ticket',0),(88956,2471,'en','Print Order Ticket',0),(88957,2472,'is','',0),(88958,2472,'dr','Ú†Ø§Ù¾ Ú†Ùƒ Ù‡Ø§ Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ',0),(88959,2472,'pr','Ú†Ø§Ù¾ Ú†Ùƒ Ù‡Ø§ Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ',0),(88960,2472,'tr','YazdÄ±r PDF formatÄ±nda kontrol eder.',0),(88961,2472,'pl','Sprawdza wydruku w formacie PDF',0),(88962,2472,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð² PDF Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(88963,2472,'ur','Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ø±Ù…ÛŒÙ¹ Ù…ÛŒÚº Ú†Ú¾Ø§Ù¾ÛŒÚº Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’',0),(88964,2472,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð° Ñƒ ÐŸÐ”Ð¤ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(88965,2472,'vi','In SÃ©c dáº¡ng PDF',0),(88966,2472,'af','Uitdruk van Tjeks in PDF Formaat',0),(88967,2472,'ro','Imprimare controale Ã®n PDF Format',0),(88968,2472,'et','Prindi kontrollib PDF formaadis',0),(88969,2472,'si','Natisni Äek v PDF formatu',0),(88970,2472,'ba','Cetak cek dalam PDF Format',0),(88971,2472,'nl','Afdrukken van controles in PDF-formaat',0),(88972,2472,'fi','Tulosta tarkistaa PDF-muodossa',0),(88973,2472,'no','Skriv ut sjekker i PDF-Format',0),(88974,2472,'da','Udskriv kontrol i PDF-Format',0),(88975,2472,'ko','ì¸ì‡„ëŠ” PDF í˜•ì‹ìœ¼ë¡œ ê²€ì‚¬',0),(88976,2472,'he','PDF ×”×“×¤×¡ ×¦\'×§×™× ×‘×¤×•×¨×ž×˜',0),(88977,2472,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÎ»Î­Î³Ï‡ÎµÎ¹ ÏƒÎµ Î¼Î¿ÏÏ†Î® PDF',0),(88978,2472,'zh','ä»¥PDFæ ¼å¼æ‰“å°æ£€æŸ¥\r\n',0),(88979,2472,'sv','Skriv ut check i PDF-Format',0),(88980,2472,'it','Controlli di stampa in formato PDF',0),(88981,2472,'tl','',0),(88982,2472,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3594;&#3655;&#3588;&#3651;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610; PDF',0),(88983,2472,'hi','PDF à¤«à¥‰à¤°à¥à¤®à¥‡à¤Ÿ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤œà¤¾à¤à¤š à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(88984,2472,'ms','Cetak menyemak dalam PDF Format',0),(88985,2472,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø¨ØªÙ†Ø³ÙŠÙ‚ PDF',0),(88986,2472,'fr','Impression vÃ©rifie en Format PDF',0),(88987,2472,'jp','Print Checks in PDF Format',0),(88988,2472,'pt','VerificaÃ§Ãµes de impressÃ£o em formato PDF',0),(88989,2472,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð§ÐµÐºÐ¾Ð² Ð² PDF Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ',0),(88990,2472,'es','Imprimir Cheques en el Formato de PDF',0),(88991,2472,'de','Ãœberweisungen drucken im PDF-Format',0),(88992,2472,'en','Print Checks in PDF Format',0),(88993,2473,'is','',0),(88994,2473,'dr','Ú†Ø§Ù¾ ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ ÙØ±Ù…Øª Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ',0),(88995,2473,'pr','Ú†Ø§Ù¾ ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ ÙØ±Ù…Øª Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ',0),(88996,2473,'tr','PDF formatÄ±nda fatura yazdÄ±r',0),(88997,2473,'pl','Drukuj fakturÄ™ w formacie PDF',0),(88998,2473,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð² PDF Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(88999,2473,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ø±Ù…ÛŒÙ¹ Ù…ÛŒÚº Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(89000,2473,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ñƒ ÐŸÐ”Ð¤ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(89001,2473,'vi','In hÃ³a Ä‘Æ¡n theo dáº¡ng PDF',0),(89002,2473,'af','Druk Faktuur in PDF-formaat',0),(89003,2473,'ro','Imprima factura Ã®n PDF format',0),(89004,2473,'et','Prindi arve PDF formaadis',0),(89005,2473,'si','Natisnili raÄun v PDF formatu',0),(89006,2473,'ba','Mencetak faktur dalam PDF format',0),(89007,2473,'nl','Factuur afdrukken in PDF-formaat',0),(89008,2473,'fi','Tulostaa laskun PDF-muodossa',0),(89009,2473,'no','Skriver ut faktura i PDF-format',0),(89010,2473,'da','Udskriv faktura i PDF-format',0),(89011,2473,'ko','PDF í˜•ì‹ì—ì„œ ì†¡ìž¥ ì¸ì‡„',0),(89012,2473,'he','PDF ×”×“×¤×¡ ×—×©×‘×•× ×™×ª ×‘×ª×‘× ×™×ª',0),(89013,2473,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÎµ Î¼Î¿ÏÏ†Î® PDF',0),(89014,2473,'zh','æ‰“å°PDFæ ¼å¼å‘ç¥¨\r\n',0),(89015,2473,'sv','Skriva ut faktura i PDF-format',0),(89016,2473,'it','Stampare la fattura in formato PDF',0),(89017,2473,'tl','',0),(89018,2473,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3651;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610; PDF',0),(89019,2473,'hi','à¤ªà¥€à¤¡à¥€à¤à¤« à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¾à¤²à¤¾à¤¨ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(89020,2473,'ms','Mencetak invois dalam PDF format',0),(89021,2473,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙÙŠ ØªÙ†Ø³ÙŠÙ‚ PDF',0),(89022,2473,'fr','Imprimer une facture en format PDF',0),(89023,2473,'jp','ï¼°ï¼¤ï¼¦ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆã?§è«‹æ±‚æ›¸ã‚’å?°åˆ·',0),(89024,2473,'pt','Imprimir factura em formato PDF',0),(89025,2473,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð² Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ PDF',0),(89026,2473,'es','Imprimir Factura en el formato PDF',0),(89027,2473,'de','Drucken der Rechnung im PDF-format',0),(89028,2473,'en','Print Invoice in PDF format',0),(89029,2474,'is','',0),(89030,2474,'dr','Ú†Ø§Ù¾ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡',0),(89031,2474,'pr','Ú†Ø§Ù¾ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡',0),(89032,2474,'tr','Bitki konumunu gÃ¼ncelleÅŸtirme YazdÄ±r',0),(89033,2474,'pl','Drukuj aktualizacja lokalizacji zakÅ‚adu',0),(89034,2474,'bg','Ð Ð°ÑÑ‚Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(89035,2474,'ur','Ù¾Ù„Ø§Ù†Ù¹ Ú©Û’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(89036,2474,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð£Ð¿Ð´Ð°Ñ‚Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ ÐµÐ»ÐµÐºÑ‚Ñ€Ð°Ð½Ð°',0),(89037,2474,'vi','Cáº­p Nháº­t Äá»‹a Äiá»ƒm NhÃ  MÃ¡y In',0),(89038,2474,'af','Uitdrukbare Toestelpunt Opdateer',0),(89039,2474,'ro','Imprima plantÄƒ locaÅ£ia Update',0),(89040,2474,'et','Prindi tehase asukoht Update',0),(89041,2474,'si','Tiskanje rastlin Location Update',0),(89042,2474,'ba','Cetak tanaman lokasi Update',0),(89043,2474,'nl','Afdrukken Plant locatie Update',0),(89044,2474,'fi','Tulostaa kasvi asema ajantasaistaa',0),(89045,2474,'no','Skrive ut anlegget plassering oppdatering',0),(89046,2474,'da','Udskrive anlÃ¦g beliggenhed Update',0),(89047,2474,'ko','ì¸ì‡„ ê³µìž¥ ìœ„ì¹˜ ì—…ë°ì´íŠ¸',0),(89048,2474,'he','×”×“×¤×¡ ×¢×“×›×•×Ÿ ×ž×™×§×•× ×”×ž×¤×¢×œ',0),(89049,2474,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÏÎ³Î¿ÏƒÏ„Î¬ÏƒÎ¹Î¿ Ï„Î¿Ï€Î¿Î¸ÎµÏ„ÏŽ ÎµÎºÏƒÏ…Î³Ï‡ÏÎ¿Î½Î¯Î¶Ï‰',0),(89050,2474,'zh','æ‰“å°è®¾å¤‡ä½ç½®æ›´æ–°\r\n',0),(89051,2474,'sv','Skriva ut Plant lÃ¤ge uppdatering',0),(89052,2474,'it','Stampare la pianta posizione aggiornamento',0),(89053,2474,'tl','',0),(89054,2474,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3650;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(89055,2474,'hi','à¤¸à¤‚à¤¯à¤‚à¤¤à¥à¤° à¤¸à¥à¤¥à¤¾à¤¨ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(89056,2474,'ms','Cetak Kemaskini lokasi loji',0),(89057,2474,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªØ­Ø¯ÙŠØ« Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…ØµÙ†Ø¹',0),(89058,2474,'fr','Imprimer la plante emplacement mise Ã  jour',0),(89059,2474,'jp','å?°åˆ·å·¥å ´æ‰€åœ¨åœ°ã?®æ›´æ–°',0),(89060,2474,'pt','Imprimir planta localizaÃ§Ã£o atualizaÃ§Ã£o',0),(89061,2474,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°Ð²Ð¾Ð´ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(89062,2474,'es','UbicaciÃ³n de FÃ¡brica de ImpresiÃ³n Actualizada',0),(89063,2474,'de','Drucken Pflanze Location Update',0),(89064,2474,'en','Print Plant Location Update',0),(89065,2475,'is','',0),(89066,2475,'dr','Ø¢ÙŠØ§ Ø§ÙŠÙ† ÙŠÙƒ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ú†Ø§Ù¾ Ø§Ø³ØªØŸ',0),(89067,2475,'pr','Ø¢ÙŠØ§ Ø§ÙŠÙ† ÙŠÙƒ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ú†Ø§Ù¾ Ø§Ø³ØªØŸ',0),(89068,2475,'tr','Bu bir baskÄ± Ã§alÄ±ÅŸma alanÄ± mÄ±?',0),(89069,2475,'pl','Jest to obszar pracy drukowania?',0),(89070,2475,'bg','Ð¢Ð¾Ð²Ð° Ðµ Ð¿ÐµÑ‡Ð°Ñ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð¾Ð½Ð°?',0),(89071,2475,'ur','ÛŒÛ Ø§ÛŒÚ© Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Ø§Ù… Ø¹Ù„Ø§Ù‚Û ÛÛ’ØŸ',0),(89072,2475,'sr','Ð”Ð° Ð»Ð¸ Ñ˜Ðµ Ð¾Ð²Ð¾ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð¿Ñ€Ð¾ÑÑ‚Ð¾Ñ€Ð°?',0),(89073,2475,'vi','ÄÃ¢y cÃ³ pháº£i lÃ  khu vá»±c cÃ´ng viá»‡c in',0),(89074,2475,'af','Is dit \'n druk werk Area?',0),(89075,2475,'ro','Aceasta este o zonÄƒ de lucru de imprimare?',0),(89076,2475,'et','Kas seda Print tÃ¶Ã¶ala?',0),(89077,2475,'si','To je delovno obmoÄje tiskanja?',0),(89078,2475,'ba','Ini adalah Area kerja cetak?',0),(89079,2475,'nl','Is dit een afdrukbereik werk?',0),(89080,2475,'fi','TÃ¤mÃ¤ on tulosta tyÃ¶skentelyalue?',0),(89081,2475,'no','Er dette et utskriftsomrÃ¥de arbeid?',0),(89082,2475,'da','Er dette et Print arbejdsomrÃ¥de?',0),(89083,2475,'ko','ì´ ì¸ì‡„ ìž‘ì—… ì˜ì—­ ì¸ê°€?',0),(89084,2475,'he','×–×” ××–×•×¨ ×¢×‘×•×“×” ×”×“×¤×¡×”?',0),(89085,2475,'el','Î ÏÏŒÎºÎµÎ¹Ï„Î±Î¹ Î³Î¹Î± Î¼Î¹Î± Ï€ÎµÏÎ¹Î¿Ï‡Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚;',0),(89086,2475,'zh','è¿™æ˜¯ä¸€ä¸ªæ‰“å°å·¥ä½œåŒºï¼Ÿ\r\n',0),(89087,2475,'sv','Ã„r detta arbete ett utskriftsomrÃ¥de?',0),(89088,2475,'it','Si tratta di un\'Area di lavoro di stampa?',0),(89089,2475,'tl','',0),(89090,2475,'th','&#3609;&#3637;&#3656;&#3588;&#3639;&#3629;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3614;&#3636;&#3617;&#3614;&#3660;&#3591;&#3634;&#3609;&#3651;&#3594;&#3656;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(89091,2475,'hi','à¤¯à¤¹ à¤à¤• à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤¹à¥ˆ?',0),(89092,2475,'ms','Adakah ini kawasan kerja cetak?',0),(89093,2475,'ar','Ù‡Ø°Ø§ Ù‡Ùˆ \"Ù…Ù†Ø·Ù‚Ø© Ø¹Ù…Ù„ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©\"ØŸ',0),(89094,2475,'fr','C\'est un espace de travail d\'impression ?',0),(89095,2475,'jp','ã?“ã‚Œã?¯å?°åˆ·ä½œæ¥­ç¯„å›²ã?§ã?™ã?‹ï¼Ÿ',0),(89096,2475,'pt','Esta Ã© uma Ã¡rea de trabalho de impressÃ£o?',0),(89097,2475,'ru','Ð­Ñ‚Ð¾ Ð¾Ð±Ð»Ð°ÑÑ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸?',0),(89098,2475,'es','Â¿Es Aqui Una Ãrea de Trabajo de Imprimir?',0),(89099,2475,'de','Ist das ein Print-Arbeitsbereich?',0),(89100,2475,'en','Is this a Print Work Area?',0),(89101,2476,'is','',0),(89102,2476,'dr','Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø± ',0),(89103,2476,'pr','Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø± ',0),(89104,2476,'tr','YazdÄ±rma Mkt.',0),(89105,2476,'pl','WydrukowaÄ‡ iloÅ›Ä‡',0),(89106,2476,'bg','ÐšÐ¾Ð»-Ð²Ð¾ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(89107,2476,'ur','Ù‚ÛŒ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(89108,2476,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐšÐ¾Ð».',0),(89109,2476,'vi','Sá»‘ lÆ°á»£ng in',0),(89110,2476,'af','Druk Hoev.',0),(89111,2476,'ro','Imprimare cantit',0),(89112,2476,'et','Prindi kogus',0),(89113,2476,'si','Tiskanje kol.',0),(89114,2476,'ba','Mencetak Qty',0),(89115,2476,'nl','Aantal afdrukken',0),(89116,2476,'fi','Tulosta mÃ¤Ã¤rÃ¤',0),(89117,2476,'no','Skrive ut antall',0),(89118,2476,'da','Udskrive Qty',0),(89119,2476,'ko','ì¸ì‡„ ìˆ˜ëŸ‰',0),(89120,2476,'he','×œ×”×“×¤×™×¡ ×›×ž×•×ª',0),(89121,2476,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Qty',0),(89122,2476,'zh','æ‰“å°æ•°é‡\r\n',0),(89123,2476,'sv','Skriv ut antal',0),(89124,2476,'it','Stampa Qty',0),(89125,2476,'tl','',0),(89126,2476,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(89127,2476,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(89128,2476,'ms','Qty cetakan',0),(89129,2476,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ÙƒÙ…ÙŠØ©',0),(89130,2476,'fr','Impression QtÃ©',0),(89131,2476,'jp','å?°åˆ·æ•°é‡?',0),(89132,2476,'pt','Imprimir Qty',0),(89133,2476,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ ÐšÐ¾Ð»-Ð²Ð¾',0),(89134,2476,'es','Cant. de Imprimir',0),(89135,2476,'de','Qty drucken',0),(89136,2476,'en','Print Qty',0),(89137,2477,'is','',0),(89138,2477,'dr','Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø±  Ø·ÙˆÙ„  Ù…Ø¬Ù…ÙˆØ¹ ',0),(89139,2477,'pr','Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø±  Ø·ÙˆÙ„  Ù…Ø¬Ù…ÙˆØ¹ ',0),(89140,2477,'tr','Miktar Uzunluk toplamÄ± yazdÄ±rmak',0),(89141,2477,'pl','CaÅ‚kowita dÅ‚ugoÅ›Ä‡ wydruku iloÅ›Ä‡',0),(89142,2477,'bg','ÐŸÐµÑ‡Ð°Ñ‚ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´ÑŠÐ»Ð¶Ð¸Ð½Ð° Ð¾Ð±Ñ‰Ð¾',0),(89143,2477,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù‚ÛŒ Ú©ÛŒ Ú©Ù„ Ù„Ù…Ø¨Ø§Ø¦ÛŒ',0),(89144,2477,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð´ÑƒÐ¶Ð¸Ð½Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ðµ ÐšÐ¾Ð».',0),(89145,2477,'vi','Tá»•ng sá»‘ Ä‘á»™ dÃ i Sá»‘ lÆ°á»£ng in',0),(89146,2477,'af','Druk Hoev. Lengte Totaal',0),(89147,2477,'ro','Cantit Ã®n lungime totalÄƒ de imprimare',0),(89148,2477,'et','Prindi tk pikkus kokku',0),(89149,2477,'si','Skupno dolÅ¾ino tiskanja kol',0),(89150,2477,'ba','Cetak Qty panjang Total',0),(89151,2477,'nl','Afdrukken Qty lengte totaal',0),(89152,2477,'fi','Tulosta mÃ¤Ã¤rÃ¤ pituus',0),(89153,2477,'no','Skrive ut antall lengde Total',0),(89154,2477,'da','Udskrive Qty lÃ¦ngde Total',0),(89155,2477,'ko','ì¸ì‡„ ìˆ˜ëŸ‰ ê¸¸ì´ ì´',0),(89156,2477,'he','×¡×” ×› ××•×¨×š ×›×ž×•×ª ×”×“×¤×¡×”',0),(89157,2477,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î¼Î®ÎºÎ¿Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Qty',0),(89158,2477,'zh','æ‰“å°æ•°é‡é•¿åº¦æ€»è®¡\r\n',0),(89159,2477,'sv','Skriv ut antal lÃ¤ngd totalt',0),(89160,2477,'it','Stampa Qty lunghezza totale',0),(89161,2477,'tl','',0),(89162,2477,'th','&#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(89163,2477,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤²à¤‚à¤¬à¤¾à¤ˆ à¤•à¥à¤² à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(89164,2477,'ms','Jumlah panjang Qty cetakan',0),(89165,2477,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø·ÙˆÙ„ Qty',0),(89166,2477,'fr','Impression QtÃ© longueur Total',0),(89167,2477,'jp','å?°åˆ·æ•°é‡?é•·ã?•å?ˆè¨ˆ',0),(89168,2477,'pt','Imprimir Qty Comprimento Total',0),(89169,2477,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð´Ð»Ð¸Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Qty',0),(89170,2477,'es','Largo Total de Cant. de Imprimir',0),(89171,2477,'de','Drucken Qty LÃ¤nge gesamt',0),(89172,2477,'en','Print Qty Length Total',0),(89173,2478,'is','',0),(89174,2478,'dr','* Ø±Ù†Ú¯Ù‡Ø§',0),(89175,2478,'pr','Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø± * Ø±Ù†Ú¯Ù‡Ø§',0),(89176,2478,'tr','Miktar baskÄ± Renkler x',0),(89177,2478,'pl','WydrukowaÄ‡ iloÅ›Ä‡ x kolory',0),(89178,2478,'bg','ÐŸÐµÑ‡Ð°Ñ‚ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(89179,2478,'ur','Ù‚ÛŒ Ù¾Ø±Ù†Ù¹ Ø±Ù†Ú¯ x',0),(89180,2478,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐšÐ¾Ð» x Ð±Ð¾Ñ˜Ðµ',0),(89181,2478,'vi','Sá»‘ lÆ°á»£ng in x Máº§u',0),(89182,2478,'af','Druk Hoev. x Kleure',0),(89183,2478,'ro','Imprima cantit x culori',0),(89184,2478,'et','Prindi kogus x vÃ¤rvid',0),(89185,2478,'si','Tiskanje koliÄina x barve',0),(89186,2478,'ba','Mencetak Qty x warna',0),(89187,2478,'nl','Aantal afdrukken x kleuren',0),(89188,2478,'fi','Tulosta mÃ¤Ã¤rÃ¤ x vÃ¤rit',0),(89189,2478,'no','Skrive ut antall x farger',0),(89190,2478,'da','Udskrive Qty x farver',0),(89191,2478,'ko','ì¸ì‡„ ìˆ˜ëŸ‰ ìƒ‰ìƒ x',0),(89192,2478,'he','×œ×”×“×¤×™×¡ ×›×ž×•×ª x ×¦×‘×¢×™×',0),(89193,2478,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Qty x Ï‡ÏÏŽÎ¼Î±Ï„Î±',0),(89194,2478,'zh','æ‰“å°æ•°é‡xé¢œè‰²\r\n',0),(89195,2478,'sv','Skriv ut antal x fÃ¤rger',0),(89196,2478,'it','Q. tÃ  di stampa x colori',0),(89197,2478,'tl','',0),(89198,2478,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660; x &#3626;&#3637;',0),(89199,2478,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤°à¤‚à¤— x',0),(89200,2478,'ms','Cetak Qty x warna',0),(89201,2478,'ar','Ø·Ø¨Ø§Ø¹Ø© Qty Ã— Ø£Ù„ÙˆØ§Ù†',0),(89202,2478,'fr','Imprimer QtÃ© x couleurs',0),(89203,2478,'jp','å?°åˆ·æ•°é‡?Ã—è‰²',0),(89204,2478,'pt','Imprimir Qtde x cores',0),(89205,2478,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ ÐšÐ¾Ð»-Ð²Ð¾ Ñ†Ð²ÐµÑ‚Ð¾Ð²',0),(89206,2478,'es','Cant. de Imprimir x Colores',0),(89207,2478,'de','Drucken Qty x Farben',0),(89208,2478,'en','Print Qty x Colors',0),(89209,2479,'is','',0),(89210,2479,'dr','* Ø¬Ù‡Øª Ù‡Ø§',0),(89211,2479,'pr','Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø± * Ø¬Ù‡Øª Ù‡Ø§',0),(89212,2479,'tr','Miktar yazdÄ±rmak taraf x',0),(89213,2479,'pl','WydrukowaÄ‡ iloÅ›Ä‡ x stron',0),(89214,2479,'bg','ÐŸÐµÑ‡Ð°Ñ‚ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x ÑÑ‚Ñ€Ð°Ð½Ð¸',0),(89215,2479,'ur','Ù‚ÛŒ Ù¾Ø±Ù†Ù¹ Ø§Ø·Ø±Ø§Ù x',0),(89216,2479,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐšÐ¾Ð» x ÑÑ‚Ñ€Ð°Ð½Ð°',0),(89217,2479,'vi','Sá»‘ lÆ°á»£ng in x Máº·t',0),(89218,2479,'af','Druk Hoev. x Kante',0),(89219,2479,'ro','Imprima cantit x pÄƒrÅ£ile',0),(89220,2479,'et','Prindi kogus x pool',0),(89221,2479,'si','Tiskanje koliÄina x straneh',0),(89222,2479,'ba','Mencetak Qty x sisi',0),(89223,2479,'nl','Aantal afdrukken x zijden',0),(89224,2479,'fi','Tulosta mÃ¤Ã¤rÃ¤ x puolin',0),(89225,2479,'no','Skrive ut antall x sider',0),(89226,2479,'da','Udskrive Qty x sider',0),(89227,2479,'ko','ì¸ì‡„ ìˆ˜ëŸ‰ ì¸¡ë©´ x',0),(89228,2479,'he','×œ×”×“×¤×™×¡ ×›×ž×•×ª x ×”×¦×“×“×™×',0),(89229,2479,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Qty x Ï€Î»ÎµÏ…ÏÎ­Ï‚',0),(89230,2479,'zh','æ‰“å°æ•°é‡xä¾§é¢\r\n',0),(89231,2479,'sv','Skriv ut antal x sidor',0),(89232,2479,'it','Q. tÃ  di stampa x i lati',0),(89233,2479,'tl','',0),(89234,2479,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660; x &#3604;&#3657;&#3634;&#3609;',0),(89235,2479,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤ªà¤•à¥à¤·à¥‹à¤‚ x',0),(89236,2479,'ms','Cetak Qty x belah',0),(89237,2479,'ar','Ø·Ø¨Ø§Ø¹Ø© Qty Ã— Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠÙ†',0),(89238,2479,'fr','Imprimer QtÃ© x cÃ´tÃ©s',0),(89239,2479,'jp','å?°åˆ·æ•°é‡?Ã—å?´é?¢',0),(89240,2479,'pt','Imprimir Qtde x lados',0),(89241,2479,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ ÐšÐ¾Ð»-Ð²Ð¾ x ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(89242,2479,'es','Cant. de Imprimir x Lados',0),(89243,2479,'de','Drucken Qty x Seiten',0),(89244,2479,'en','Print Qty x Sides',0),(89245,2480,'is','',0),(89246,2480,'dr','Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(89247,2480,'pr','Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(89248,2480,'tr','Teklifi yazdÄ±r',0),(89249,2480,'pl','Drukuj ofertÄ™',0),(89250,2480,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(89251,2480,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(89252,2480,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(89253,2480,'vi','BÃ¡o giÃ¡ in',0),(89254,2480,'af','Druk Kwotasie',0),(89255,2480,'ro','Citat de imprimare',0),(89256,2480,'et','Prindi pakkumine',0),(89257,2480,'si','Natisni ponudbo',0),(89258,2480,'ba','Mencetak kutipan',0),(89259,2480,'nl','Offerte afdrukt',0),(89260,2480,'fi','Tulosta tarjous',0),(89261,2480,'no','Skrive ut tilbud',0),(89262,2480,'da','Udskrive tilbud',0),(89263,2480,'ko','ì¸ì‡„ ê²¬ì ',0),(89264,2480,'he','×”×“×¤×¡ ×”×¦×¢×ª ×ž×—×™×¨',0),(89265,2480,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(89266,2480,'zh','æ‰“å°æŠ¥ä»·\r\n',0),(89267,2480,'sv','Skriv ut offert',0),(89268,2480,'it','Stampa preventivo',0),(89269,2480,'tl','',0),(89270,2480,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(89271,2480,'hi','à¤•à¥‹à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(89272,2480,'ms','Cetak Quote',0),(89273,2480,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(89274,2480,'fr','Imprimer Devis',0),(89275,2480,'jp','è¦‹ç©?ã‚‚ã‚Šã?®å?°åˆ·',0),(89276,2480,'pt','Imprimir cotaÃ§Ã£o',0),(89277,2480,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(89278,2480,'es','CotizaciÃ³n de ImpresiÃ³n',0),(89279,2480,'de','Angebot drucken',0),(89280,2480,'en','Print Quote',0),(89281,2481,'is','',0),(89282,2481,'dr','Ú†Ø§Ù¾ Ø§ÙŠÙ† Ù„ÙŠØ³Øª Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ ',0),(89283,2481,'pr','Ú†Ø§Ù¾ Ø§ÙŠÙ† Ù„ÙŠØ³Øª Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ ',0),(89284,2481,'tr','Bu paket listesi YazdÄ±r',0),(89285,2481,'pl','Drukowanie listy tego opakowania',0),(89286,2481,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ñ‚Ð¾Ð·Ð¸ ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° Ð¾Ð¿Ð°ÐºÐ¾Ð²Ð°Ð½Ðµ',0),(89287,2481,'ur','ÛŒÛ Ù¾ÛŒÚ©Ù†Ú¯ ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(89288,2481,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¾Ð²Ñƒ Ñ‚Ð¾Ð²Ð°Ñ€Ð½Ð¸ Ð»Ð¸ÑÑ‚',0),(89289,2481,'vi','In danh sÃ¡ch Ä‘Ã³ng gÃ³i',0),(89290,2481,'af','Druk hierdie verpakkingslys',0),(89291,2481,'ro','Imprima aceastÄƒ listÄƒ de ambalare',0),(89292,2481,'et','Prindi see pakkeleht',0),(89293,2481,'si','Natisnite seznam pakiranje',0),(89294,2481,'ba','Mencetak daftar Kemasan ini',0),(89295,2481,'nl','Deze verpakking afdruklijst',0),(89296,2481,'fi','Tulosta tÃ¤mÃ¤ pakkausluettelo',0),(89297,2481,'no','Skrive ut denne innpakning',0),(89298,2481,'da','Udskrive denne pakkeliste',0),(89299,2481,'ko','ì´ íŒ¨í‚¹ ë¦¬ìŠ¤íŠ¸ë¥¼ ì¸ì‡„',0),(89300,2481,'he','×”×“×¤×¡ ××ª ×¨×©×™×ž×ª ××¨×™×–×”',0),(89301,2481,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒ ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÏƒÏ…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î±Ï‚',0),(89302,2481,'zh','æ‰“å°æ­¤è£…ç®±æ¸…å•\r\n',0),(89303,2481,'sv','Skriv ut denna packlista',0),(89304,2481,'it','Stampare questa lista di imballaggio',0),(89305,2481,'tl','',0),(89306,2481,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;&#3609;&#3637;&#3657;',0),(89307,2481,'hi','à¤‡à¤¸ à¤ªà¥ˆà¤•à¤¿à¤‚à¤— à¤¸à¥‚à¤šà¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(89308,2481,'ms','Mencetak senarai pembungkusan',0),(89309,2481,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚Ø§Ø¦Ù…Ø© Ø¨Ù‡Ø°Ù‡ Ø§Ù„ØªØ¹Ø¨Ø¦Ø©',0),(89310,2481,'fr','Imprimer cette liste de colisage',0),(89311,2481,'jp','ã?“ã?®æ¢±åŒ…æ˜Žç´°æ›¸ã‚’å?°åˆ·ã?™ã‚‹',0),(89312,2481,'pt','Imprima esta lista de embalagem',0),(89313,2481,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ ÑÑ‚Ð¾Ñ‚ ÑÐ¿Ð¸ÑÐ¾Ðº ÑƒÐ¿Ð°ÐºÐ¾Ð²ÐºÐ¸',0),(89314,2481,'es','Imptimir esta lista de empaque',0),(89315,2481,'de','Drucken Sie diese Packliste',0),(89316,2481,'en','Print this packing list',0),(89317,2482,'is','',0),(89318,2482,'dr','Ú†Ø§Ù¾ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(89319,2482,'pr','Ú†Ø§Ù¾ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(89320,2482,'tr','Basmak bu posta',0),(89321,2482,'pl','Drukowanie PO tym',0),(89322,2482,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ñ‚Ð¾Ð·Ð¸ PO',0),(89323,2482,'ur','Ø§Ø³ Ù¾Ùˆ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(89324,2482,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¾Ð²Ñƒ ÐŸÐž',0),(89325,2482,'vi','In dÆ¡n mua hÃ ng nÃ y',0),(89326,2482,'af','Druk hierdie AB',0),(89327,2482,'ro','ImprimaÅ£i acest PO',0),(89328,2482,'et','Prindi see PO',0),(89329,2482,'si','Natisni ta PO',0),(89330,2482,'ba','Cetak ini PO',0),(89331,2482,'nl','Deze PO afdrukken',0),(89332,2482,'fi','Tulosta tÃ¤mÃ¤ PO',0),(89333,2482,'no','Skrive ut denne PO',0),(89334,2482,'da','Udskrive denne PO',0),(89335,2482,'ko','ì´ í¬ ì¸ì‡„',0),(89336,2482,'he','×”×“×¤×¡×” ×¤×• ×”×–×”',0),(89337,2482,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒ PO',0),(89338,2482,'zh','æ‰“å°æ­¤è®¢å•\r\n',0),(89339,2482,'sv','Skriv ut denna PO',0),(89340,2482,'it','Stampare questo PO',0),(89341,2482,'tl','',0),(89342,2482,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;',0),(89343,2482,'hi','à¤‡à¤¸ à¤ªà¥‹ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(89344,2482,'ms','Cetak PO ini',0),(89345,2482,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‡Ø°Ø§ Ø¨Ùˆ',0),(89346,2482,'fr','Imprimer ce PO',0),(89347,2482,'jp','ã?“ã?®POã‚’å?°åˆ·',0),(89348,2482,'pt','Imprimir esta PO',0),(89349,2482,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ PO',0),(89350,2482,'es','Imptimir este OC',0),(89351,2482,'de','Drucken dieser PO',0),(89352,2482,'en','Print this PO',0),(89353,2483,'is','',0),(89354,2483,'dr','  Ú†Ø§Ù¾  \r\n W-2s',0),(89355,2483,'pr','  Ú†Ø§Ù¾  \r\n W-2s',0),(89356,2483,'tr','W-2s YazdÄ±r',0),(89357,2483,'pl','W druku-2s',0),(89358,2483,'bg','ÐŸÐµÑ‡Ð°Ñ‚ W-2s',0),(89359,2483,'ur','W-2s Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(89360,2483,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ W-2Ñ',0),(89361,2483,'vi','In W-2s',0),(89362,2483,'af','Druk W-2s',0),(89363,2483,'ro','Imprimare W-2s',0),(89364,2483,'et','Prindi W-2s',0),(89365,2483,'si','Tiskanje W-2s',0),(89366,2483,'ba','W-2s cetak',0),(89367,2483,'nl','Afdrukken van W-2s',0),(89368,2483,'fi','Tulostaa W-2s',0),(89369,2483,'no','Skrive ut W-2s',0),(89370,2483,'da','Udskrive W-2s',0),(89371,2483,'ko','W-2ë¥¼ ì¸ì‡„',0),(89372,2483,'he','×œ×”×“×¤×™×¡ ××ª ×˜×¤×¡×™ ×ž×™×¡×™×.',0),(89373,2483,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ W-2s',0),(89374,2483,'zh','æ‰“å°çš„W -2s\r\n',0),(89375,2483,'sv','Skriva ut W-2s',0),(89376,2483,'it','Stampa W-2s',0),(89377,2483,'tl','',0),(89378,2483,'th','&#3614;&#3636;&#3617;&#3614;&#3660; W-2s',0),(89379,2483,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤¡à¤¬à¥à¤²à¥à¤¯à¥‚ 2s',0),(89380,2483,'ms','W-2s cetakan',0),(89381,2483,'ar','Ø«-2s Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(89382,2483,'fr','Imprimer les W-2',0),(89383,2483,'jp','W-2s ã‚’å?°åˆ·',0),(89384,2483,'pt','Imprimir o W-2s',0),(89385,2483,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ W-2Ñ',0),(89386,2483,'es','Imprimir W-2s',0),(89387,2483,'de','Drucken Sie W-2 s',0),(89388,2483,'en','Print W-2s',0),(89389,2484,'is','',0),(89390,2484,'dr','Ú†Ø§Ù¾ Ø¹Ø±Ø¶',0),(89391,2484,'pr','Ú†Ø§Ù¾ Ø¹Ø±Ø¶',0),(89392,2484,'tr','BaskÄ± geniÅŸliÄŸi',0),(89393,2484,'pl','SzerokoÅ›Ä‡ wydruku',0),(89394,2484,'bg','Ð¨Ð¸Ñ€Ð¸Ð½Ð° Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(89395,2484,'ur','Ú†ÙˆÚ‘Ø§Ø¦ÛŒ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(89396,2484,'sr','Ð¨Ð¸Ñ€Ð¸Ð½Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ðµ',0),(89397,2484,'vi','Äá»™ rá»™ng in',0),(89398,2484,'af','Druk breedte',0),(89399,2484,'ro','LÄƒÅ£imea de imprimare',0),(89400,2484,'et','Prindi laius',0),(89401,2484,'si','Å irina tiska',0),(89402,2484,'ba','Lebar cetak',0),(89403,2484,'nl','Printbreedte',0),(89404,2484,'fi','Tulostusleveys',0),(89405,2484,'no','Papirbredden',0),(89406,2484,'da','Udskrive bredde',0),(89407,2484,'ko','ì¸ì‡„ í­',0),(89408,2484,'he','×¨×•×—×‘ ×”×“×¤×¡×”',0),(89409,2484,'el','Î Î»Î¬Ï„Î¿Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(89410,2484,'zh','æ‰“å°å®½åº¦\r\n',0),(89411,2484,'sv','Skriva ut bredd',0),(89412,2484,'it','Larghezza di stampa',0),(89413,2484,'tl','',0),(89414,2484,'th','&#3588;&#3623;&#3634;&#3617;&#3585;&#3623;&#3657;&#3634;&#3591;&#3651;&#3609;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(89415,2484,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ',0),(89416,2484,'ms','Cetak lebar',0),(89417,2484,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(89418,2484,'fr','Largeur d\'impression',0),(89419,2484,'jp','å?°å­—å¹…',0),(89420,2484,'pt','Largura de impressÃ£o',0),(89421,2484,'ru','Ð¨Ð¸Ñ€Ð¸Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(89422,2484,'es','Anchra de ImpresiÃ³n',0),(89423,2484,'de','Druckbreite',0),(89424,2484,'en','Print Width',0),(89425,2485,'is','',0),(89426,2485,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ú†Ø§Ù¾',0),(89427,2485,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ú†Ø§Ù¾',0),(89428,2485,'tr','Teklif yazdÄ±rma',0),(89429,2485,'pl','Druk oferty',0),(89430,2485,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(89431,2485,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú†Ú¾Ø§Ù¾ Ø±ÛØ§ ÛÛ’ Û”',0),(89432,2485,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(89433,2485,'vi','Äang in bÃ¡o giÃ¡',0),(89434,2485,'af','Besig om Kwotasie te Druk',0),(89435,2485,'ro','Citat de imprimare',0),(89436,2485,'et','Hinnapakkumise printimine',0),(89437,2485,'si','Tiskanje citat',0),(89438,2485,'ba','Mencetak kutipan',0),(89439,2485,'nl','Offerte afdrukken',0),(89440,2485,'fi','Tarjouksen tulostaminen',0),(89441,2485,'no','Utskrift av tilbud',0),(89442,2485,'da','Udskrivning af tilbud',0),(89443,2485,'ko','ì¸ì‡„ ê²¬ì ',0),(89444,2485,'he','×ž×“×¤×™×¡ ×”×¦×¢×ª ×ž×—×™×¨',0),(89445,2485,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(89446,2485,'zh','æ‰“å°æŠ¥ä»·\r\n',0),(89447,2485,'sv','Utskrift av offert',0),(89448,2485,'it','Preventivo di stampa',0),(89449,2485,'tl','',0),(89450,2485,'th','&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(89451,2485,'hi','à¤•à¥‹à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(89452,2485,'ms','Percetakan Quote',0),(89453,2485,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(89454,2485,'fr','Impression Devis',0),(89455,2485,'jp','è¦‹ç©?ã‚‚ã‚Šã?®å?°åˆ·ä¸­',0),(89456,2485,'pt','CitaÃ§Ã£o de impressÃ£o',0),(89457,2485,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(89458,2485,'es','CotizaciÃ³n de Imprenta',0),(89459,2485,'de','Angebot drucken',0),(89460,2485,'en','Printing Quote',0),(89461,2486,'is','',0),(89462,2486,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ú†Ø§Ù¾ ',0),(89463,2486,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ú†Ø§Ù¾ ',0),(89464,2486,'tr','BaskÄ± teklif e-posta',0),(89465,2486,'pl','Druk oferty E-mail',0),(89466,2486,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð·Ð° ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ð¿Ð¾Ñ‰Ð°',0),(89467,2486,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: Ø§ÛŒ Ù…ÛŒÙ„ Ù¾Ø±Ù†Ù¹Ù†Ú¯',0),(89468,2486,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ðµ-Ð¿Ð¾ÑˆÑ‚Ñƒ',0),(89469,2486,'vi','Email bÃ¡o giÃ¡ in',0),(89470,2486,'af','Druk Kwotasie E-posse',0),(89471,2486,'ro','Imprimarea citat de E-mail',0),(89472,2486,'et','TrÃ¼ki hinnapakkumine E-mail',0),(89473,2486,'si','Tiskanje ponudbo E-mail',0),(89474,2486,'ba','Percetakan kutipan E-mail',0),(89475,2486,'nl','Afdrukken citaat E-mail',0),(89476,2486,'fi','Tulostaminen tarjous sÃ¤hkÃ¶postitse',0),(89477,2486,'no','Utskrift sitatet e-post',0),(89478,2486,'da','Udskrivning citat E-mail',0),(89479,2486,'ko','ì¸ì‡„ ê²¬ì  ì „ìž ë©”ì¼',0),(89480,2486,'he','×“×•××¨ ××œ×§×˜×¨×•× ×™ ×”×¦×¢×ª ×ž×—×™×¨ ×”×“×¤×¡×”',0),(89481,2486,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€Î±ÏÎ±Î¸Î­Ï„Ï‰ E-mail',0),(89482,2486,'zh','æ‰“å°æŠ¥ä»·ç”µå­é‚®ä»¶\r\n',0),(89483,2486,'sv','Utskrift offert e-post',0),(89484,2486,'it','Stampa preventivo E-mail',0),(89485,2486,'tl','',0),(89486,2486,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(89487,2486,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¬à¥‹à¤²à¥€ à¤ˆ-à¤®à¥‡à¤²',0),(89488,2486,'ms','Sebut harga mencetak e-mel',0),(89489,2486,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¹Ø±Ø¶ Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(89490,2486,'fr','E-mail devis d\'imprimerie',0),(89491,2486,'jp','è¦‹ç©?ã‚‚ã‚ŠE-mailã?®å?°åˆ·ä¸­',0),(89492,2486,'pt','Imprimir cotaÃ§Ã£o E-mail',0),(89493,2486,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð¾Ð¹ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(89494,2486,'es','Email de CotizaciÃ³n de Imprenta',0),(89495,2486,'de','Druckerei Angebot E-mail',0),(89496,2486,'en','Printing Quote E-mail',0),(89497,2487,'is','',0),(89498,2487,'dr','Ú†Ø§Ù¾ ',0),(89499,2487,'pr','Ú†Ø§Ù¾ ',0),(89500,2487,'tr','YazdÄ±rma',0),(89501,2487,'pl','Drukowanie',0),(89502,2487,'bg','ÐŸÐµÑ‡Ð°Ñ‚',0),(89503,2487,'ur','Ø·Ø¨Ø§Ø¹Øª',0),(89504,2487,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(89505,2487,'vi','In ',0),(89506,2487,'af','Besig op te Druk',0),(89507,2487,'ro','Imprimare',0),(89508,2487,'et','Printimine',0),(89509,2487,'si','Tiskanje',0),(89510,2487,'ba','Percetakan',0),(89511,2487,'nl','Afdrukken',0),(89512,2487,'fi','Tulostaminen',0),(89513,2487,'no','Utskrift',0),(89514,2487,'da','Udskrivning',0),(89515,2487,'ko','ì¸ì‡„',0),(89516,2487,'he','×ž×“×¤×™×¡',0),(89517,2487,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(89518,2487,'zh','æ‰“å°\r\n',0),(89519,2487,'sv','Utskrift',0),(89520,2487,'it','Stampa',0),(89521,2487,'tl','',0),(89522,2487,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;/&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(89523,2487,'hi','à¤®à¥à¤¦à¥à¤°à¤£',0),(89524,2487,'ms','Percetakan',0),(89525,2487,'ar','Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(89526,2487,'fr','Impression',0),(89527,2487,'jp','å?°åˆ·ä¸­',0),(89528,2487,'pt','ImpressÃ£o',0),(89529,2487,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(89530,2487,'es','Imprenta',0),(89531,2487,'de','Drucken',0),(89532,2487,'en','Printing',0),(89533,2488,'is','',0),(89534,2488,'dr','Ø§ÙˆÙ„ÙˆÙŠØª ',0),(89535,2488,'pr','Ø§ÙˆÙ„ÙˆÙŠØª ',0),(89536,2488,'tr','Ã–ncelik',0),(89537,2488,'pl','Priorytet',0),(89538,2488,'bg','ÐŸÑ€Ð¸Ð¾Ñ€Ð¸Ñ‚ÐµÑ‚',0),(89539,2488,'ur','ØªØ±Ø¬ÛŒØ­',0),(89540,2488,'sr','ÐŸÑ€Ð¸Ð¾Ñ€Ð¸Ñ‚ÐµÑ‚',0),(89541,2488,'vi','Æ¯u tiÃªn',0),(89542,2488,'af','Prioriteit',0),(89543,2488,'ro','Prioritate',0),(89544,2488,'et','Prioriteet',0),(89545,2488,'si','Prednost',0),(89546,2488,'ba','Prioritas',0),(89547,2488,'nl','Prioriteit',0),(89548,2488,'fi','Prioriteetti',0),(89549,2488,'no','Prioritet',0),(89550,2488,'da','Prioritet',0),(89551,2488,'ko','ìš°ì„  ìˆœìœ„',0),(89552,2488,'he','×¢×“×™×¤×•×ª',0),(89553,2488,'el','Î ÏÎ¿Ï„ÎµÏÎ±Î¹ÏŒÏ„Î·Ï„Î±',0),(89554,2488,'zh','ä¼˜å…ˆ\r\n',0),(89555,2488,'sv','Prioritet',0),(89556,2488,'it','PrioritÃ ',0),(89557,2488,'tl','',0),(89558,2488,'th','&#3626;&#3636;&#3607;&#3608;&#3636;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(89559,2488,'hi','à¤ªà¥à¤°à¤¾à¤¥à¤®à¤¿à¤•à¤¤à¤¾',0),(89560,2488,'ms','Keutamaan',0),(89561,2488,'ar','Ø£ÙˆÙ„ÙˆÙŠØ©',0),(89562,2488,'fr','PrioritÃ©',0),(89563,2488,'jp','å„ªå…ˆé †ä½?',0),(89564,2488,'pt','Prioridade',0),(89565,2488,'ru','ÐŸÑ€Ð¸Ð¾Ñ€Ð¸Ñ‚ÐµÑ‚',0),(89566,2488,'es','Prioridad',0),(89567,2488,'de','PrioritÃ¤t',0),(89568,2488,'en','Priority',0),(89569,2489,'is','',0),(89570,2489,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(89571,2489,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(89572,2489,'tr','Ä°ÅŸlem baÅŸarÄ±yla eklendi',0),(89573,2489,'pl','Proces pomyÅ›lnie dodane',0),(89574,2489,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑ, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(89575,2489,'ur','Ø¹Ù…Ù„ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(89576,2489,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(89577,2489,'vi','ThÃªm xá»­ lÃ½ thÃ nh cÃ´ng',0),(89578,2489,'af','Proses suksesvol bygevoeg',0),(89579,2489,'ro','Procesul de adÄƒugat cu succes',0),(89580,2489,'et','Lisatud protsess',0),(89581,2489,'si','Proces uspeÅ¡no dodani',0),(89582,2489,'ba','Proses ditambahkan berhasil',0),(89583,2489,'nl','Proces met succes toegevoegd',0),(89584,2489,'fi','Prosessin lisÃ¤Ã¤minen onnistui',0),(89585,2489,'no','Prosessen ble lagt til',0),(89586,2489,'da','Processen tilfÃ¸jet',0),(89587,2489,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” í”„ë¡œì„¸ìŠ¤',0),(89588,2489,'he','×ª×”×œ×™×š × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(89589,2489,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(89590,2489,'zh','è¿‡ç¨‹æ·»åŠ æˆåŠŸ\r\n',0),(89591,2489,'sv','Process lagts',0),(89592,2489,'it','Processo aggiunto con successo',0),(89593,2489,'tl','',0),(89594,2489,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(89595,2489,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(89596,2489,'ms','Proses yang berjaya menambah',0),(89597,2489,'ar','Ø¹Ù…Ù„ÙŠØ© Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(89598,2489,'fr','Processus ajoutÃ© avec succÃ¨s',0),(89599,2489,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(89600,2489,'pt','Processo adicionado com sucesso',0),(89601,2489,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(89602,2489,'es','Proceso agregado exitosamente',0),(89603,2489,'de','Prozess erfolgreich hinzugefÃ¼gt',0),(89604,2489,'en','Process added successfully',0),(89605,2490,'is','',0),(89606,2490,'dr','Ø­Ø°Ù  Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(89607,2490,'pr','Ø­Ø°Ù  Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(89608,2490,'tr','Ä°ÅŸlem baÅŸarÄ±yla silindi',0),(89609,2490,'pl','Proces przesâ”‚anie',0),(89610,2490,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑ, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(89611,2490,'ur','Ø¹Ù…Ù„ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(89612,2490,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(89613,2490,'vi','XÃ³a xá»­ lÃ½ thÃ nh cÃ´ng',0),(89614,2490,'af','Proses suksesvol geskrap',0),(89615,2490,'ro','Procesul de ÅŸters cu succes',0),(89616,2490,'et','Protsess edukalt kustutatud',0),(89617,2490,'si','Proces uspeÅ¡no izbrisana',0),(89618,2490,'ba','Proses dihapus berhasil',0),(89619,2490,'nl','Proces met succes verwijderd',0),(89620,2490,'fi','Prosessin poistettu',0),(89621,2490,'no','Prosessen ble slettet',0),(89622,2490,'da','Processen slettet',0),(89623,2490,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” í”„ë¡œì„¸ìŠ¤',0),(89624,2490,'he','×ª×”×œ×™×š × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(89625,2490,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(89626,2490,'zh','å¤„ç†å·²æˆåŠŸåˆ é™¤\r\n',0),(89627,2490,'sv','Processen raderades',0),(89628,2490,'it','Processo cancellato con successo',0),(89629,2490,'tl','',0),(89630,2490,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(89631,2490,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(89632,2490,'ms','Proses dihapuskan dengan jayanya',0),(89633,2490,'ar','Ø¹Ù…Ù„ÙŠØ© Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(89634,2490,'fr','Processus supprimÃ© avec succÃ¨s',0),(89635,2490,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(89636,2490,'pt','Processo apagado com sucesso',0),(89637,2490,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(89638,2490,'es','Procesar eliminado exitosamente',0),(89639,2490,'de','Prozess erfolgreich gelÃ¶scht',0),(89640,2490,'en','Process deleted successfully',0),(89641,2491,'is','',0),(89642,2491,'dr','Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙØ±ÙˆØ´ Ø¯Ø§Ø±Ø¯ ',0),(89643,2491,'pr','Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙØ±ÙˆØ´ Ø¯Ø§Ø±Ø¯ ',0),(89644,2491,'tr','Bu mÃ¼ÅŸteri zaten bir satÄ±ÅŸ iÅŸlemi girdi',0),(89645,2491,'pl','To klient ma juÅ¼ wpis procesu sprzedaÅ¼y',0),(89646,2491,'bg','Ð¢Ð¾Ð·Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð²ÐµÑ‡Ðµ Ð¸Ð¼Ð° Ð·Ð°Ð¿Ð¸Ñ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(89647,2491,'ur','Ø§Ø³ Ú¯Ø§ÛÚ© Ù¾ÛÙ„Û’ ÛÛŒ Ø§ÛŒÚ© Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ÙØ±ÙˆØ®Øª Ú©Û’ Ø¹Ù…Ù„ ÛÛ’ Û”',0),(89648,2491,'sr','ÐžÐ²Ð°Ñ˜ ÐºÑƒÐ¿Ð°Ñ† Ð²ÐµÑ› Ð¸Ð¼Ð° ÑƒÐ½Ð¾ÑÐ° Ñƒ Ð¿Ñ€Ð¾Ñ†ÐµÑÑƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(89649,2491,'vi','KhÃ¡ch hÃ ng nÃ y Ä‘Ã£ cÃ³ má»™t xá»­ lÃ½ bÃ¡n hÃ ng',0),(89650,2491,'af','Hierdie klient / klant het alreeds \'n Verkoopsproses inskrywing',0),(89651,2491,'ro','Acest client are deja o intrare de proces de vÃ¢nzÄƒri',0),(89652,2491,'et','See klient on juba mÃ¼Ã¼gi protsess kanne',0),(89653,2491,'si','Ta kupec Å¾e ima prodajni proces vstopa',0),(89654,2491,'ba','Pelanggan ini sudah memiliki sebuah catatan proses penjualan',0),(89655,2491,'nl','Deze klant al een verkoopproces vermelding',0),(89656,2491,'fi','TÃ¤mÃ¤ asiakas on jo myyntiprosessin merkintÃ¤',0),(89657,2491,'no','Denne kunden har allerede en salgsprosess oppfÃ¸ring',0),(89658,2491,'da','Denne kunde har allerede en salgsproces post',0),(89659,2491,'ko','ì´ ê³ ê°ì€ ì´ë¯¸ íŒë§¤ í”„ë¡œì„¸ìŠ¤ í•­ëª©',0),(89660,2491,'he','×”×œ×§×•×— ×”×–×” ×™×© ×›×‘×¨ ×¢×¨×š ×ª×”×œ×™×š ×ž×›×™×¨×•×ª',0),(89661,2491,'el','Î‘Ï…Ï„ÏŒÏ‚ Î¿ Ï€ÎµÎ»Î¬Ï„Î·Ï‚ Î­Ï‡ÎµÎ¹ Î®Î´Î· Î¼Î¹Î± ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(89662,2491,'zh','æ­¤å®¢æˆ·å·²æœ‰ä¸€ä¸ªé”€å”®å¤„ç†æ¡ç›®\r\n',0),(89663,2491,'sv','Kunden har redan en fÃ¶rsÃ¤ljningsprocess post',0),(89664,2491,'it','Questo cliente ha giÃ  una voce processo di vendite',0),(89665,2491,'tl','',0),(89666,2491,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3619;&#3634;&#3618;&#3609;&#3637;&#3657;&#3617;&#3637;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3',0),(89667,2491,'hi','à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤à¤• à¤¬à¤¿à¤•à¥à¤°à¥€ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¹à¥ˆ',0),(89668,2491,'ms','Baca ini sudah masuk proses jualan',0),(89669,2491,'ar','Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù…ÙŠÙ„ Ù‚Ø¯ Ø³Ø¨Ù‚ Ø¥Ø¯Ø®Ø§Ù„ \"Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª\"',0),(89670,2491,'fr','Ce client a dÃ©jÃ  une entrÃ©e de processus de ventes',0),(89671,2491,'jp','ã?“ã?®é¡§å®¢ã?¯ã?™ã?§ã?«ã‚»ãƒ¼ãƒ«ã‚¹ãƒ—ãƒ­ã‚»ã‚¹ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?Œã?‚ã‚Šã?¾ã?™',0),(89672,2491,'pt','Este cliente jÃ¡ tem uma entrada de processo de vendas',0),(89673,2491,'ru','Ð­Ñ‚Ð¾Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÑƒÐ¶Ðµ Ð¸Ð¼ÐµÐµÑ‚ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(89674,2491,'es','Este cliente ya tiene una entrada de Proceso de Ventas',0),(89675,2491,'de','Dieser Kunde hat bereits einen Vertriebsprozess-Eintrag',0),(89676,2491,'en','This customer already has a Sales Process entry',0),(89677,2492,'is','',0),(89678,2492,'dr','Ù„Ø·ÙØ§ Ø¨Ø±Ú¯Ø±Ø¯ÙŠØ¯ Ùˆ Ø§ÙŠÙ† Ù…ÙˆØ±Ø¯ Ø±Ø§ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ†ÙŠØ¯ ',0),(89679,2492,'pr','Ù„Ø·ÙØ§ Ø¨Ø±Ú¯Ø±Ø¯ÙŠØ¯ Ùˆ Ø§ÙŠÙ† Ù…ÙˆØ±Ø¯ Ø±Ø§ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ†ÙŠØ¯ ',0),(89680,2492,'tr','LÃ¼tfen geri gidin ve varolan bir',0),(89681,2492,'pl','ProszÄ™ wrÃ³ciÄ‡ i edytowaÄ‡ istniejÄ…cy',0),(89682,2492,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÑ€Ð½ÐµÑ‚Ðµ Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð° Ñ‚Ð°ÐºÐ°Ð²Ð°',0),(89683,2492,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÙˆØ§Ù¾Ø³ Ø¬Ø§Ø¤ Ø§ÙˆØ± Ù…ÙˆØ¬ÙˆØ¯Û Ø§ÛŒÚ© ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(89684,2492,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð²Ñ€Ð°Ñ‚Ð¸ ÑÐµ Ð¸ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›ÐµÐ³',0),(89685,2492,'vi','Vui lÃ²ng quay láº¡i & chá»‰nh sá»­a cÃ¡i hiá»‡n cÃ³',0),(89686,2492,'af','Gaan asseblief terug en redigeer die bestaande een',0),(89687,2492,'ro','VÄƒ rugÄƒm sÄƒ mergeÅ£i Ã®napoi ÅŸi editaÅ£i unul existent',0),(89688,2492,'et','Palun Mine tagasi ja muuta olemasoleva',0),(89689,2492,'si','Prosim pojdite nazaj in uredite obstojeÄega',0),(89690,2492,'ba','Silakan kembali dan mengedit yang sudah ada',0),(89691,2492,'nl','Ga terug en de bestaande te bewerken',0),(89692,2492,'fi','Palaa takaisin ja Muokkaa olemassa olevaa',0),(89693,2492,'no','Vennligst gÃ¥ tilbake og redigere den eksisterende',0),(89694,2492,'da','GÃ¥ tilbage og redigere den eksisterende',0),(89695,2492,'ko','ë‹¤ì‹œê°€ ì„œ í•˜ì‹œê³  ê¸°ì¡´ íŽ¸ì§‘',0),(89696,2492,'he','×‘×‘×§×©×” ×œ×—×–×•×¨ ×•×œ×ª×§×Ÿ ×”××—×“ ×§×™×™×',0),(89697,2492,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï€Î·Î³Î±Î¯Î½ÎµÏ„Îµ Ï€Î¯ÏƒÏ‰ ÎºÎ±Î¹ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Î®Î´Î· Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎ±',0),(89698,2492,'zh','è¯·è¿”å›žå¹¶ç¼–è¾‘çŽ°æœ‰çš„ä¸€ä¸ª\r\n',0),(89699,2492,'sv','GÃ¥ tillbaka och redigera en befintlig',0),(89700,2492,'it','Si prega di tornare indietro e modificare quello esistente',0),(89701,2492,'tl','',0),(89702,2492,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3585;&#3621;&#3633;&#3610;&#3652;&#3611;&#3649;&#3621;&#3632;&#3649;&#3585;&#3657;&#3652;&#3586;&#3629;&#3633;&#3609;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(89703,2492,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤µà¤¾à¤ªà¤¸ à¤œà¤¾à¤à¤ à¤”à¤° à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤à¤• à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(89704,2492,'ms','Sila kembali dan mengedit yang sedia ada',0),(89705,2492,'ar','ÙŠØ±Ø¬Ù‰ Ø§Ù„Ø¹ÙˆØ¯Ø© ÙˆØªØ­Ø±ÙŠØ± ÙˆØ§Ø­Ø¯Ø© Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(89706,2492,'fr','Veuillez revenir en arriÃ¨re et modifier l\'existant',0),(89707,2492,'jp','æˆ»ã?£ã?¦ã?™ã?§ã?«å­˜åœ¨ã?™ã‚‹ã‚‚ã?®ã‚’ç·¨é›†ã?—ã?¦ã??ã? ã?•ã?„',0),(89708,2492,'pt','Por favor, voltar e editar existente',0),(89709,2492,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²ÐµÑ€Ð½Ð¸Ñ‚ÐµÑÑŒ Ð½Ð°Ð·Ð°Ð´ Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹',0),(89710,2492,'es','Por favor regresar y editar el existente',0),(89711,2492,'de','Bitte gehen Sie zurÃ¼ck und bearbeiten Sie einer vorhandenen',0),(89712,2492,'en','Please go back and edit the existing one',0),(89713,2493,'is','',0),(89714,2493,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(89715,2493,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(89716,2493,'tr','Ä°ÅŸlem baÅŸarÄ±yla kaydedildi',0),(89717,2493,'pl','Proces pomyÅ›lnie zapisany',0),(89718,2493,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑ, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(89719,2493,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ø¹Ù…Ù„',0),(89720,2493,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(89721,2493,'vi','Sao lÆ°u quÃ¡ trÃ¬nh thÃ nh cÃ´ng',0),(89722,2493,'af','Verwerking suksesvol gestoor',0),(89723,2493,'ro','Procesul de salvat cu succes',0),(89724,2493,'et','Protsess salvestati edukalt',0),(89725,2493,'si','Proces uspeÅ¡no shranjen',0),(89726,2493,'ba','Proses disimpan berhasil',0),(89727,2493,'nl','Proces succesvol opgeslagen',0),(89728,2493,'fi','Prosessi tallennus onnistui',0),(89729,2493,'no','Prosessen lagret',0),(89730,2493,'da','Processen gemt med succes',0),(89731,2493,'ko','í”„ë¡œì„¸ìŠ¤ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(89732,2493,'he','×ª×”×œ×™×š ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(89733,2493,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(89734,2493,'zh','å¤„ç†ä¿å­˜æˆåŠŸ\r\n',0),(89735,2493,'sv','Process som sparats',0),(89736,2493,'it','Processo salvato correttamente',0),(89737,2493,'tl','',0),(89738,2493,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(89739,2493,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(89740,2493,'ms','Proses yang berjaya disimpan',0),(89741,2493,'ar','Ø¹Ù…Ù„ÙŠØ© Ø­ÙØ¸ Ø¨Ù†Ø¬Ø§Ø­',0),(89742,2493,'fr','Processus enregistrÃ© avec succÃ¨s',0),(89743,2493,'jp','å‡¦ç?†ã?Œä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(89744,2493,'pt','Processo salvo com sucesso',0),(89745,2493,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(89746,2493,'es','Proceso guardado exitosamente',0),(89747,2493,'de','Prozess erfolgreich gespeichert',0),(89748,2493,'en','Process saved successfully',0),(89749,2494,'is','',0),(89750,2494,'dr','Ø³ÙˆØ¯',0),(89751,2494,'pr','Ø³ÙˆØ¯',0),(89752,2494,'tr','Kar',0),(89753,2494,'pl','Zysk',0),(89754,2494,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð°',0),(89755,2494,'ur','Ù…Ù†Ø§ÙØ¹',0),(89756,2494,'sr','Ð”Ð¾Ð±Ð¸Ñ‚',0),(89757,2494,'vi','Lá»£i nhuáº­n',0),(89758,2494,'af','Wins',0),(89759,2494,'ro','Profit',0),(89760,2494,'et','Kasum',0),(89761,2494,'si','DobiÄek',0),(89762,2494,'ba','Keuntungan',0),(89763,2494,'nl','Winst',0),(89764,2494,'fi','Voitto',0),(89765,2494,'no','Fortjeneste',0),(89766,2494,'da','Profit',0),(89767,2494,'ko','ì´ìµ',0),(89768,2494,'he','×¨×•×•×—',0),(89769,2494,'el','ÎšÎ­ÏÎ´Î¿Ï‚',0),(89770,2494,'zh','åˆ©æ¶¦\r\n',0),(89771,2494,'sv','Vinst',0),(89772,2494,'it','Profitto',0),(89773,2494,'tl','',0),(89774,2494,'th','&#3585;&#3635;&#3652;&#3619;',0),(89775,2494,'hi','à¤²à¤¾à¤­',0),(89776,2494,'ms','Keuntungan',0),(89777,2494,'ar','Ø§Ù„Ø±Ø¨Ø­',0),(89778,2494,'fr','Profit',0),(89779,2494,'jp','åˆ©ç›Š',0),(89780,2494,'pt','Lucro',0),(89781,2494,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ',0),(89782,2494,'es','Utilidad',0),(89783,2494,'de','Gewinn',0),(89784,2494,'en','Profit',0),(89785,2495,'is','',0),(89786,2495,'dr','ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÙŠØ§Ù† Ø¨Ø±Ø§ÙŠ',0),(89787,2495,'pr','ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÙŠØ§Ù† Ø¨Ø±Ø§ÙŠ',0),(89788,2495,'tr','Kar & kÃ¢r-zarar tablosu',0),(89789,2495,'pl','Zysk & strat dla',0),(89790,2495,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð° & Ð·Ð°Ð³ÑƒÐ±Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð°',0),(89791,2495,'ur','Ù…Ù†Ø§ÙØ¹ & Ù†Ù‚ØµØ§Ù† Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(89792,2495,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð°Ðº Ð¸ Ð³ÑƒÐ±Ð¸Ñ‚Ð°Ðº Ð¸Ð·Ñ˜Ð°Ð²Ñƒ Ð·Ð°',0),(89793,2495,'vi','BÃ¡o cÃ¡o lá»i lá»— cho',0),(89794,2495,'af','Wins-en-Verlies Staat vir',0),(89795,2495,'ro','Profitul & declaraÅ£ie de pierdere pentru',0),(89796,2495,'et','Kasum & kahjumiaruande jaoks',0),(89797,2495,'si','DobiÄek & izgubo izjavo za',0),(89798,2495,'ba','Keuntungan & rugi untuk',0),(89799,2495,'nl','Winst & verliesrekening voor',0),(89800,2495,'fi','Voitto & tappio-lauseen',0),(89801,2495,'no','Fortjeneste & tap setningen for',0),(89802,2495,'da','Profit & tab redegÃ¸relse for',0),(89803,2495,'ko','ì´ìµ &ì— ëŒ€ í•œ ê³„ì‚° ì„œ',0),(89804,2495,'he','×¨×•×•×— & ××•×‘×“×Ÿ ×¡×™×¡×‘',0),(89805,2495,'el','ÎšÎ­ÏÎ´Î¿Ï‚ & ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î±Ï€Î¿Ï„ÎµÎ»ÎµÏƒÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎµÏ‰Ï‚ Î³Î¹Î±',0),(89806,2495,'zh','æŸç›Šè¡¨çš„\r\n',0),(89807,2495,'sv','Vinst & resultatrÃ¤kning fÃ¶r',0),(89808,2495,'it','Profitto & dichiarazione di perdita per',0),(89809,2495,'tl','',0),(89810,2495,'th','&#3591;&#3610;&#3585;&#3635;&#3652;&#3619;&#3586;&#3634;&#3604;&#3607;&#3640;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3629;&#3610;&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;',0),(89811,2495,'hi','à¤²à¤¾à¤­ & à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¤¾à¤¨à¤¿ à¤¬à¤¯à¤¾à¤¨',0),(89812,2495,'ms','Keuntungan & kerugian penyata bagi',0),(89813,2495,'ar','Ø§Ù„Ø±Ø¨Ø­ Ø¢Ù†Ø¯ Ø¨ÙŠØ§Ù† Ø§Ù„Ø®Ø³Ø§Ø±Ø© Ø¹Ù†',0),(89814,2495,'fr','Profit & dÃ©claration de perte pour',0),(89815,2495,'jp','æ??ç›Šæ±ºç®—æ›¸',0),(89816,2495,'pt','Lucro & declaraÃ§Ã£o de perda de',0),(89817,2495,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ & ÑƒÐ±Ñ‹Ñ‚ÐºÐ°Ñ… Ð·Ð°',0),(89818,2495,'es','Estado de Resultados para',0),(89819,2495,'de','Gewinn & Verlustrechnung fÃ¼r',0),(89820,2495,'en','Profit & Loss Statement for',0),(89821,2496,'is','',0),(89822,2496,'dr','Ø³ÙˆØ¯ Ø­Ø§ØµÙ„ Ø§Ø² ÙØ±ÙˆØ´',0),(89823,2496,'pr','Ø³ÙˆØ¯ Ø­Ø§ØµÙ„ Ø§Ø² ÙØ±ÙˆØ´',0),(89824,2496,'tr','Sadece satÄ±ÅŸÄ±ndan kar',0),(89825,2496,'pl','Zysk ze sprzedaÅ¼y tylko',0),(89826,2496,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð° Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÑÐ°Ð¼Ð¾',0),(89827,2496,'ur','ØµØ±Ù ÙØ±ÙˆØ®Øª Ø³Û’ ÙØ§Ø¦Ø¯Û',0),(89828,2496,'sr','Ð”Ð¾Ð±Ð¸Ñ‚ Ð¾Ð´ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÑÐ°Ð¼Ð¾',0),(89829,2496,'vi','Chá»‰ lá»£i nhuáº­n tá»« bÃ¡n hÃ ng ',0),(89830,2496,'af','Wins slegs van verkope',0),(89831,2496,'ro','Profit de la vÃ¢nzare numai',0),(89832,2496,'et','Ainult mÃ¼Ã¼gikasum',0),(89833,2496,'si','DobiÄek od prodaje samo',0),(89834,2496,'ba','Keuntungan dari penjualan hanya',0),(89835,2496,'nl','Winst uit verkoop alleen',0),(89836,2496,'fi','Myynti vain voitto',0),(89837,2496,'no','Fortjeneste fra bare',0),(89838,2496,'da','Overskud fra salg kun',0),(89839,2496,'ko','ë§Œ íŒë§¤ì—ì„œ ì´ìµ',0),(89840,2496,'he','×¨×•×•×— ×ž×ž×›×™×¨×ª ×‘×œ×‘×“',0),(89841,2496,'el','ÎšÎ­ÏÎ´Î¿Ï‚ Î±Ï€ÏŒ Ï€ÏŽÎ»Î·ÏƒÎ· Î¼ÏŒÎ½Î¿',0),(89842,2496,'zh','ä»…é”€å”®åˆ©æ¶¦\r\n',0),(89843,2496,'sv','Vinst frÃ¥n fÃ¶rsÃ¤ljning',0),(89844,2496,'it','Profitto dalla vendita solo',0),(89845,2496,'tl','',0),(89846,2496,'th','&#3585;&#3635;&#3652;&#3619;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(89847,2496,'hi','à¤•à¥‡à¤µà¤² à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¥‡ à¤²à¤¾à¤­',0),(89848,2496,'ms','Keuntungan daripada jualan sahaja',0),(89849,2496,'ar','Ø£Ø±Ø¨Ø§Ø­ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ÙÙ‚Ø·',0),(89850,2496,'fr','Tirer profit de la vente uniquement',0),(89851,2496,'jp','è²©å£²ã?®ã?¿ã?‹ã‚‰ã?®åˆ©ç›Š',0),(89852,2496,'pt','Lucrar com venda apenas',0),(89853,2496,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(89854,2496,'es','Utilidad de la Venta Solamente',0),(89855,2496,'de','Gewinn aus Verkauf nur',0),(89856,2496,'en','Profit from sale only',0),(89857,2497,'is','',0),(89858,2497,'dr','Ù…Ø¯Ø±Ùƒ',0),(89859,2497,'pr','Ù…Ø¯Ø±Ùƒ',0),(89860,2497,'tr','KanÄ±t',0),(89861,2497,'pl','DowÃ³d',0),(89862,2497,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(89863,2497,'ur','Ø«Ø¨ÙˆØª',0),(89864,2497,'sr','Ð”Ð¾ÐºÐ°Ð·',0),(89865,2497,'vi','Báº£n in thá»­',0),(89866,2497,'af','Proef',0),(89867,2497,'ro','Dovada',0),(89868,2497,'et','TÃµend',0),(89869,2497,'si','Dokaz',0),(89870,2497,'ba','Bukti',0),(89871,2497,'nl','Bewijs',0),(89872,2497,'fi','Todiste',0),(89873,2497,'no','Bevis',0),(89874,2497,'da','Bevis',0),(89875,2497,'ko','ì¦ê±°',0),(89876,2497,'he','×”×•×›×—×”',0),(89877,2497,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î·',0),(89878,2497,'zh','è¯æ˜Ž\r\n',0),(89879,2497,'sv','Bevis',0),(89880,2497,'it','Prova',0),(89881,2497,'tl','',0),(89882,2497,'th','&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(89883,2497,'hi','à¤¸à¤¬à¥‚à¤¤',0),(89884,2497,'ms','Bukti',0),(89885,2497,'ar','Ø§Ù„Ø¥Ø«Ø¨Ø§Øª',0),(89886,2497,'fr','Preuve',0),(89887,2497,'jp','è¨¼æ˜Ž',0),(89888,2497,'pt','Prova',0),(89889,2497,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾',0),(89890,2497,'es','Prueba de ImpresiÃ³n',0),(89891,2497,'de','Nachweis',0),(89892,2497,'en','Proof',0),(89893,2498,'is','',0),(89894,2498,'dr','(Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù…) Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯ ',0),(89895,2498,'pr','Ø³Ù‡Ù… ÙŠØ§ Ø´Ù†Ø§Ø³Ù‡ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø³Ù‡Ø§Ù… (Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±) Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯ ',0),(89896,2498,'tr','proption veya stockusageid geÃ§irilen deÄŸil',0),(89897,2498,'pl','proption lub stockusageid nie przeszÅ‚y',0),(89898,2498,'bg','proption Ð¸Ð»Ð¸ stockusageid Ð½Ðµ Ðµ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ»',0),(89899,2498,'ur','Ù¾Ø±ÙˆÙ¾Ø´Ù† ÛŒØ§ Ø³Ù¹ÙˆÚ©ÙˆØ³Ú¯ÛŒØ¯ Ú©Ø§ Ú¯Ø²Ø± Ù†ÛÛŒÚº',0),(89900,2498,'sr','Ð¿Ñ€Ð¾Ð¿Ñ‚Ð¸Ð¾Ð½ Ð¸Ð»Ð¸ ÑÑ‚Ð¾Ñ†ÐºÑƒÑÐ°Ð³ÐµÐ¸Ð´ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾ÑˆÐ°Ð¾',0),(89901,2498,'vi','lá»±a chá»n hay id sá»­ dá»¥ng hÃ ng tá»“n chÆ°a qua',0),(89902,2498,'af','proption of stockusageid nie geslaag',0),(89903,2498,'ro','proption sau stockusageid nu a trecut',0),(89904,2498,'et','proption vÃµi stockusageid pole lÃ¤binud',0),(89905,2498,'si','proption ali stockusageid, ki ne prenesejo',0),(89906,2498,'ba','proption atau stockusageid yang belum lulus',0),(89907,2498,'nl','proption of stockusageid niet doorgegeven',0),(89908,2498,'fi','proption tai stockusageid ei enÃ¤Ã¤',0),(89909,2498,'no','proption eller stockusageid ikke bestÃ¥tt',0),(89910,2498,'da','proption eller stockusageid ikke bestÃ¥et',0),(89911,2498,'ko','proption ë˜ëŠ” stockusageidë¥¼ í†µê³¼ í•˜ì§€',0),(89912,2498,'he','proption ××• stockusageid ×œ× ×—×œ×¤×•',0),(89913,2498,'el','proption Î® stockusageid Ï€Î¿Ï… Î´ÎµÎ½ Ï€Î­ÏÎ±ÏƒÎµ',0),(89914,2498,'zh','æ”¯æŒæˆ–åº“å­˜ä½¿ç”¨çš„IDæœªé€šè¿‡\r\n',0),(89915,2498,'sv','proption eller stockusageid inte gÃ¥tt',0),(89916,2498,'it','proption o stockusageid non superato',0),(89917,2498,'tl','',0),(89918,2498,'th','proption or stockusageid not passed',0),(89919,2498,'hi','proption à¤¯à¤¾ stockusageid à¤ªà¤¾à¤°à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚',0),(89920,2498,'ms','proption atau stockusageid yang tidak diluluskan',0),(89921,2498,'ar','Ø¨Ø±ÙˆØ¨Ø´Ù† Ø£Ùˆ Ø³ØªÙˆÙƒÙˆØ³Ø§Ø¬ÙŠØ¯ Ù„Ø§ ØªÙ…Ø±ÙŠØ±',0),(89922,2498,'fr','proption ou stockusageid ne pas passÃ©',0),(89923,2498,'jp','proption or stockusageid not passed',0),(89924,2498,'pt','proption ou stockusageid nÃ£o passou',0),(89925,2498,'ru','proption Ð¸Ð»Ð¸ stockusageid Ð½Ðµ Ð¿Ñ€Ð¾ÑˆÐ»Ð¾',0),(89926,2498,'es','opciÃ³n de PR o ID de uso de stock no pasado',0),(89927,2498,'de','Proption oder Stockusageid nicht bestanden',0),(89928,2498,'en','proption or stockusageid not passed',0),(89929,2499,'is','',0),(89930,2499,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù‚ÙŠÙ…Øª Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯ ',0),(89931,2499,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù‚ÙŠÙ…Øª Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯ ',0),(89932,2499,'tr','kabul prprice kimliÄŸi',0),(89933,2499,'pl','Identyfikator prprice nie przeszÅ‚y',0),(89934,2499,'bg','prprice id Ð½Ðµ Ðµ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ»',0),(89935,2499,'ur','Ù¾Ø±Ù¾Ø±Ø§Ø³ÛŒ Ø´Ù†Ø§Ø®Øª Ù†ÛÛŒÚº Ú¯Ø²Ø±Ø§',0),(89936,2499,'sr','Ð¿Ñ€Ð¿Ñ€Ð¸Ñ†Ðµ Ð¸Ð´ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾ÑˆÐ°Ð¾',0),(89937,2499,'vi','id giÃ¡ chÆ°a qua',0),(89938,2499,'af','prprice id nie geslaag',0),(89939,2499,'ro','prprice ID-ul nu a trecut',0),(89940,2499,'et','prprice id pole lÃ¤binud',0),(89941,2499,'si','prprice id ne prenesejo',0),(89942,2499,'ba','prprice id tidak lulus',0),(89943,2499,'nl','prprice id niet doorgegeven',0),(89944,2499,'fi','prprice tunnus ei',0),(89945,2499,'no','prprice id ikke bestÃ¥tt',0),(89946,2499,'da','prprice id ikke bestÃ¥et',0),(89947,2499,'ko','prprice id ì „ë‹¬ ë˜ì§€',0),(89948,2499,'he','prprice ×ž×–×”×” ×œ× ×—×œ×¤×•',0),(89949,2499,'el','Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ prprice Î´ÎµÎ½ Ï€Î­ÏÎ±ÏƒÎµ',0),(89950,2499,'zh','ä»·æ ¼ç¼–å·ä¸é€šè¿‡é¢„\r\n',0),(89951,2499,'sv','prprice-id inte klarat',0),(89952,2499,'it','prprice id non passato',0),(89953,2499,'tl','',0),(89954,2499,'th','prprice id not passed',0),(89955,2499,'hi','prprice id à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤°à¤¿à¤¤',0),(89956,2499,'ms','id prprice yang tidak diluluskan',0),(89957,2499,'ar','Ù…Ø¹Ø±Ù Ø¨Ø±Ø¨Ø±ÙŠØ³ÙŠ Ø¹Ø¯Ù… ØªÙ…Ø±ÙŠØ±',0),(89958,2499,'fr','prprice id ne pas passÃ©',0),(89959,2499,'jp','prprice id not passed',0),(89960,2499,'pt','identificaÃ§Ã£o de prprice nÃ£o passado',0),(89961,2499,'ru','prprice id Ð½Ðµ Ð¿Ñ€Ð¾ÑˆÐ»Ð¾',0),(89962,2499,'es','Precio de PR no pasado',0),(89963,2499,'de','Prprice-Id nicht Ã¼bergeben',0),(89964,2499,'en','prprice id not passed',0),(89965,2500,'is','',0),(89966,2500,'dr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ â€“ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ ÙƒØ¯ ÙƒØ§Ù„Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(89967,2500,'pr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ â€“ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ ÙƒØ¯ ÙƒØ§Ù„Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(89968,2500,'tr','<small>* Ã‡eker Ã¼zerinden ne zaman stok Ã¶ÄŸesi kod kullanÄ±lmÄ±ÅŸ</small>',0),(89969,2500,'pl','<small>* ÅšciÄ…ga z zapasÃ³w gdy przedmiot uÅ¼ywany kod</small>',0),(89970,2500,'bg','<small>* Ð”ÑŠÑ€Ð¿Ð° Ð¾Ñ‚ ÑÐºÐ»Ð°Ð´Ð° ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» ÐºÐ¾Ð´ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸</small>',0),(89971,2500,'ur','<small>* Ø·Ø±Ù Ø³Û’ Ø³ÛÙˆÙ„ÛŒØ§Øª Ú©Ø¨ Ø´Û’ Ú©ÙˆÚˆ Used</small>',0),(89972,2500,'sr','<small>* ÐŸÐ¾Ð²Ð»Ð°Ð¸Ð¸ Ð¸Ð· Ð·Ð°Ð»Ð¸Ñ…Ð° Ð´Ð° ÐºÐ°Ð´Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñ™ÐµÐ½Ð¾ Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°</small>',0),(89973,2500,'vi','*Láº¥y tá»« HÃ ng Trong Kho Khi Sá»­ Dá»¥ng MÃ£ HÃ ng',0),(89974,2500,'af','<small>* Aantrekkingskragte van voorraad wanneer Item kode gebruik</small>',0),(89975,2500,'ro','<small>* Trage din inventar cÃ¢nd element folosit codul</small>',0),(89976,2500,'et','<small>* TÃµmbab alates lao kui kauba kood kasutatud</small>',0),(89977,2500,'si','<small>* Potegne iz zaloge, ko element uporablja kodo</small>',0),(89978,2500,'ba','<small>* Menarik dari persediaan ketika Item digunakan kode</small>',0),(89979,2500,'nl','<small>* Trekt uit voorraad wanneer object Code gebruikt</small>',0),(89980,2500,'fi','<small>* VetÃ¤Ã¤ pÃ¤Ã¤ssÃ¤ varastoon, kun tuotteen koodi kÃ¤ytetyt</small>',0),(89981,2500,'no','<small>* Trekker fra lagerbeholdningen nÃ¥r element kode brukt</small>',0),(89982,2500,'da','<small>* TrÃ¦kker fra lageret nÃ¥r varen kode bruges</small>',0),(89983,2500,'ko','<small>*ì—ì„œ ëŒì–´ ìž¬ê³  ë•Œ í•­ëª© ì½”ë“œ ì‚¬ìš©</small>',0),(89984,2500,'he','<small>* ×ž×•×©×š ×ž×Ÿ ×”×ž×œ××™ ×›××©×¨ ×¤×¨×™×˜ ×§×•×“ ×‘×©×™×ž×•×©</small>',0),(89985,2500,'el','<small>* Î¤ÏÎ±Î²Î¬ Î±Ï€ÏŒ Î±Ï€Î¿Î³ÏÎ±Ï†Î® ÏŒÏ„Î±Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚</small>',0),(89986,2500,'zh','*å½“ç‰©å“ä»£ç ä½¿ç”¨æ—¶ï¼Œä»Žåº“å­˜ä¸­æ‹‰å‡º\r\n',0),(89987,2500,'sv','<small>* Drar frÃ¥n lagret nÃ¤r objektet koden anvÃ¤nds</small>',0),(89988,2500,'it','<small>* Tira dall\'inventario quando voce codice usato</small>',0),(89989,2500,'tl','',0),(89990,2500,'th','<small>*&#3604;&#3638;&#3591;&#3592;&#3634;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;&#3648;&#3617;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#',0),(89991,2500,'hi','<small>* à¤–à¥€à¤‚à¤šà¤¤à¤¾à¤¨ à¤¸à¥‡ à¤¸à¥‚à¤šà¥€ à¤•à¤¬ à¤®à¤¦ à¤•à¥‹à¤¡ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¹à¥ˆ</small>',0),(89992,2500,'ms','<small>* Berbalas daripada inventori apabila Item digunakan kod</small>',0),(89993,2500,'ar','<small>* ØªØ³Ø­Ø¨ Ù…Ù† Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¹Ù†Ø¯ Ø¹Ù†ØµØ± Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©</small>',0),(89994,2500,'fr','<small>* Tire de stocks lors Item Code utilisÃ© (s)</small>',0),(89995,2500,'jp',' <small>*Pulls from Bill when Item Code Used</small>',0),(89996,2500,'pt','<small>* TraÃ§Ãµes de inventÃ¡rio quando o Item cÃ³digo usado</small>',0),(89997,2500,'ru','<small>* Ð¢ÑÐ½ÐµÑ‚ Ð¾Ñ‚ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð½Ñ‹Ð¹ ÐºÐ¾Ð³Ð´Ð° Ð¿ÑƒÐ½ÐºÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ ÐºÐ¾Ð´</small>',0),(89998,2500,'es','<small>*Sacado de Inventario cuando se Usa el CÃ³digo del Item</small>',0),(89999,2500,'de','<small>* Zieht aus Inventar wenn Item Code verwendet</small>',0),(90000,2500,'en',' <small>*Pulls from Inventory when Item Code Used</small>',0),(90001,2501,'is','',0),(90002,2501,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(90003,2501,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(90004,2501,'tr','SatÄ±nalma sipariÅŸi',0),(90005,2501,'pl','ZamÃ³wienie zakupu',0),(90006,2501,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(90007,2501,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ±',0),(90008,2501,'sr','ÐŸÐ¾Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ð°',0),(90009,2501,'vi','ÄÆ¡n Mua HÃ ng',0),(90010,2501,'af','Aankoopbestelling',0),(90011,2501,'ro','ComandÄƒ cumpÄƒrare',0),(90012,2501,'et','Ostutellimus',0),(90013,2501,'si','Nabavni nalog',0),(90014,2501,'ba','Order Pembelian',0),(90015,2501,'nl','Inkooporder',0),(90016,2501,'fi','Ostotilaus',0),(90017,2501,'no','Bestilling',0),(90018,2501,'da','IndkÃ¸bsordre',0),(90019,2501,'ko','êµ¬ë§¤ ì£¼ë¬¸',0),(90020,2501,'he','×”×–×ž× ×ª ×¨×›×™×©×‘',0),(90021,2501,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(90022,2501,'zh','é‡‡è´­è®¢å•\r\n',0),(90023,2501,'sv','InkÃ¶psorder',0),(90024,2501,'it','Ordine di acquisto',0),(90025,2501,'tl','',0),(90026,2501,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(90027,2501,'hi','à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(90028,2501,'ms','Pesanan belian',0),(90029,2501,'ar','Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(90030,2501,'fr','Bon de commande',0),(90031,2501,'jp','ç™ºæ³¨æ›¸',0),(90032,2501,'pt','Ordem de compra',0),(90033,2501,'ru','Ð—Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(90034,2501,'es','Orden de Compra',0),(90035,2501,'de','Bestellung',0),(90036,2501,'en','Purchase Order',0),(90037,2502,'is','',0),(90038,2502,'dr','Ø´Ù…Ø§Ø±Ù‡  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(90039,2502,'pr','Ø´Ù…Ø§Ø±Ù‡  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(90040,2502,'tr','SatÄ±nalma sipariÅŸi No',0),(90041,2502,'pl','Zakup nr zamÃ³wienia',0),(90042,2502,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ñ€Ð°Ð·Ð¿Ð¾Ñ€ÐµÐ´Ð¸ #',0),(90043,2502,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Ø§ Ø¢Ø±ÚˆØ± #',0),(90044,2502,'sr','ÐÐ°Ð±Ð°Ð²ÐºÐµ Ð½Ð°Ñ€ÐµÐ´Ð¸ #',0),(90045,2502,'vi','ÄÆ¡n Mua HÃ ng sá»‘',0),(90046,2502,'af','Aankoopbestelling #',0),(90047,2502,'ro','CumpÄƒrare comanda #',0),(90048,2502,'et','Ostu tellimuse nr',0),(90049,2502,'si','Nakup naroÄilo #',0),(90050,2502,'ba','Pembelian Order #',0),(90051,2502,'nl','Aankoop bestellen #',0),(90052,2502,'fi','Osto tilaus',0),(90053,2502,'no','KjÃ¸p bestillingsnummer',0),(90054,2502,'da','KÃ¸b Bestil #',0),(90055,2502,'ko','êµ¬ë§¤ ì£¼ë¬¸ #',0),(90056,2502,'he','×¨×›×™×©×” ×œ×”×–×ž×™×Ÿ #',0),(90057,2502,'el','Î‘Î³Î¿ÏÎ¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± #',0),(90058,2502,'zh','é‡‡è´­è®¢å•ï¼ƒ\r\n',0),(90059,2502,'sv','KÃ¶p Ordernr',0),(90060,2502,'it','Acquisto ordine #',0),(90061,2502,'tl','',0),(90062,2502,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(90063,2502,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ #',0),(90064,2502,'ms','Pembelian perintah #',0),(90065,2502,'ar','Ø±Ù‚Ù… Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(90066,2502,'fr','Achat no de commande',0),(90067,2502,'jp','ç™ºæ³¨æ›¸ç•ªå?·',0),(90068,2502,'pt','Compra ordem #',0),(90069,2502,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð·Ð°ÐºÐ°Ð· #',0),(90070,2502,'es','Orden de Compra #',0),(90071,2502,'de','Kauf Auftragsnr.',0),(90072,2502,'en','Purchase Order #',0),(90073,2503,'is','',0),(90074,2503,'dr','ÙˆØ§Ø­Ø¯ Ø®Ø±ÙŠØ¯ ',0),(90075,2503,'pr','ÙˆØ§Ø­Ø¯ Ø®Ø±ÙŠØ¯ ',0),(90076,2503,'tr','SatÄ±nalma birimi',0),(90077,2503,'pl','Zakup jednostki',0),(90078,2503,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(90079,2503,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ ÛŒÙˆÙ†Ù¹',0),(90080,2503,'sr','Ð˜Ð·Ð»Ð°Ð·Ð½Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(90081,2503,'vi','ÄÆ¡n vá»‹ mua',0),(90082,2503,'af','Aankoop Eenheid',0),(90083,2503,'ro','Unitate de cumpÄƒrare',0),(90084,2503,'et','OstuÃ¼hik',0),(90085,2503,'si','Enote',0),(90086,2503,'ba','Pembelian Unit',0),(90087,2503,'nl','Aankoop eenheid',0),(90088,2503,'fi','OstoyksikkÃ¶',0),(90089,2503,'no','InnkjÃ¸psenheten',0),(90090,2503,'da','KÃ¸bsenhed',0),(90091,2503,'ko','êµ¬ë§¤ ë‹¨ìœ„',0),(90092,2503,'he','×™×—×™×“×ª ×¨×›×™×©×”',0),(90093,2503,'el','Î‘Î³Î¿ÏÎ¬ Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(90094,2503,'zh','é‡‡è´­å•ä½\r\n',0),(90095,2503,'sv','InkÃ¶psenhet',0),(90096,2503,'it','UnitÃ  di acquisto',0),(90097,2503,'tl','',0),(90098,2503,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(90099,2503,'hi','à¤–à¤°à¥€à¤¦ à¤‡à¤•à¤¾à¤ˆ',0),(90100,2503,'ms','Pembelian Unit',0),(90101,2503,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„Ø´Ø±Ø§Ø¡',0),(90102,2503,'fr','UnitÃ© d\'achat',0),(90103,2503,'jp','è³¼å…¥å?˜ä½?',0),(90104,2503,'pt','Unidade de compra',0),(90105,2503,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð°ÐºÑƒÐ¿ÐºÐ¸',0),(90106,2503,'es','Unidad de Compra',0),(90107,2503,'de','Bestelleinheit',0),(90108,2503,'en','Purchase Unit',0),(90109,2504,'is','',0),(90110,2504,'dr','(Ø­ÙˆØ§Ù„Ù‡)Ù…ÙØ§Ø¯ Ø®Ø§Øµ',0),(90111,2504,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ (Ø­ÙˆØ§Ù„Ù‡)Ù…ÙØ§Ø¯ Ø®Ø§Øµ',0),(90112,2504,'tr','Ã–zel amaÃ§lÄ± atama',0),(90113,2504,'pl','PrzydziaÅ‚u specjalnego przeznaczenia',0),(90114,2504,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¾ Ð¿Ñ€ÐµÐ´Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(90115,2504,'ur','Ø®Ø§Øµ Ù…Ù‚ØµØ¯ Ú©ÛŒ ØªÙÙˆÛŒØ¶',0),(90116,2504,'sr','Ð—Ð°Ð´Ð°Ñ‚Ð°Ðº Ð·Ð° Ð¿Ð¾ÑÐµÐ±Ð½Ðµ Ð½Ð°Ð¼ÐµÐ½Ðµ',0),(90117,2504,'vi','CÃ´ng viá»‡c cÃ³ má»¥c Ä‘Ã­ch Ä‘áº·c biá»‡t',0),(90118,2504,'af','Spesiale doel opdrag',0),(90119,2504,'ro','Scop special cesiune',0),(90120,2504,'et','Eriotstarbelised loovutamine',0),(90121,2504,'si','Namen posebne dodelitve',0),(90122,2504,'ba','Penetapan tujuan khusus',0),(90123,2504,'nl','Special Purpose toewijzing',0),(90124,2504,'fi','ErityistÃ¤ tarkoitusta varten tehtÃ¤vÃ¤n',0),(90125,2504,'no','Spesielle oppdrag',0),(90126,2504,'da','Special Purpose tildeling',0),(90127,2504,'ko','íŠ¹ìˆ˜ ëª©ì  ìž„ë¬´',0),(90128,2504,'he','×”×ž×©×™×ž×” ×œ×ž×©×™×ž×•×ª ×ž×™×•×—×“×•×ª',0),(90129,2504,'el','Î‘Î½Î¬Î¸ÎµÏƒÎ· ÎµÎ¹Î´Î¹ÎºÎ¿Ï ÏƒÎºÎ¿Ï€Î¿Ï',0),(90130,2504,'zh','ç‰¹æ®Šç”¨é€”åˆ†é…\r\n',0),(90131,2504,'sv','SÃ¤rskilda Ã¤ndamÃ¥l tilldelning',0),(90132,2504,'it','Assegnazione di scopo speciale',0),(90133,2504,'tl','',0),(90134,2504,'th','&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3617;&#3637;&#3627;&#3609;&#3657;&#3634;&#3607;&#3637;&#3656;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(90135,2504,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤ªà¥à¤°à¤¯à¥‹à¤œà¤¨ à¤…à¤¸à¤¾à¤‡à¤¨à¤®à¥‡à¤‚à¤Ÿ',0),(90136,2504,'ms','Tugasan tujuan Khas',0),(90137,2504,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø£ØºØ±Ø§Ø¶ Ø§Ù„Ø®Ø§ØµØ©',0),(90138,2504,'fr','Cession d\'usage spÃ©cial',0),(90139,2504,'jp','ç‰¹æ®Šç›®çš„ã?®å‰²ã‚Šå½“ã?¦',0),(90140,2504,'pt','AtribuiÃ§Ã£o de finalidade especial',0),(90141,2504,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ ÑÐ¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(90142,2504,'es','AsignaciÃ³n para PropÃ³sito Especial',0),(90143,2504,'de','Zweckgesellschaft-Zuordnung',0),(90144,2504,'en','Special Purpose Assignment',0),(90145,2505,'is','',0),(90146,2505,'dr','ØªÙˆØµÙŠÙ Ù…ÙØ§Ø¯',0),(90147,2505,'pr','ØªÙˆØµÙŠÙ Ù…ÙØ§Ø¯',0),(90148,2505,'tr','AmaÃ§ aÃ§Ä±klamasÄ±',0),(90149,2505,'pl','WyjaÅ›nienie celu',0),(90150,2505,'bg','ÐžÐ±ÑÑÐ½ÐµÐ½Ð¸Ðµ Ð½Ð° Ñ†ÐµÐ»Ñ‚Ð°',0),(90151,2505,'ur','Ù…Ù‚ØµØ¯ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(90152,2505,'sr','ÐžÐ±Ñ˜Ð°ÑˆÑšÐµÑšÐµ Ð¾ ÑÐ²Ñ€ÑÐ¸',0),(90153,2505,'vi','Giáº£i thÃ­ch má»¥c Ä‘Ã­ch',0),(90154,2505,'af','Verduideliking van Doel',0),(90155,2505,'ro','ExplicaÅ£ie a scopului',0),(90156,2505,'et','Selgitus eesmÃ¤rgi',0),(90157,2505,'si','Razlaga namena',0),(90158,2505,'ba','Penjelasan tentang tujuan',0),(90159,2505,'nl','Verklaring van het doel',0),(90160,2505,'fi','Selvityksen tarkoitus',0),(90161,2505,'no','Forklaring formÃ¥l',0),(90162,2505,'da','Forklaring af formÃ¥let',0),(90163,2505,'ko','ëª©ì  ì„¤ëª…',0),(90164,2505,'he','×”×¡×‘×¨ ×¢×œ ×ž×˜×¨×”',0),(90165,2505,'el','Î•Î¾Î®Î³Î·ÏƒÎ· Ï„Î¿Ï… ÏƒÎºÎ¿Ï€Î¿Ï',0),(90166,2505,'zh','ç›®çš„è§£é‡Š\r\n',0),(90167,2505,'sv','FÃ¶rklaring av syftet',0),(90168,2505,'it','Spiegazione dello scopo',0),(90169,2505,'tl','',0),(90170,2505,'th','&#3585;&#3634;&#3619;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3586;&#3629;&#3591;&#3627;&#3609;&#3657;&#3634;&#3607;&#3637;&#3656;',0),(90171,2505,'hi','à¤‰à¤¦à¥à¤¦à¥‡à¤¶à¥à¤¯ à¤•à¥‡ à¤µà¤¿à¤µà¤°à¤£',0),(90172,2505,'ms','Penerangan tentang tujuan',0),(90173,2505,'ar','Ø´Ø±Ø­ Ù„Ù„ØºØ±Ø¶',0),(90174,2505,'fr','Explication du but',0),(90175,2505,'jp','ç›®çš„ã?®èª¬æ˜Ž',0),(90176,2505,'pt','ExplicaÃ§Ã£o da finalidade',0),(90177,2505,'ru','ÐžÐ±ÑŠÑÑÐ½ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ»Ð¸',0),(90178,2505,'es','ExplicaciÃ³n de PropÃ³sito',0),(90179,2505,'de','ErlÃ¤uterung der Zweck',0),(90180,2505,'en','Explanation of Purpose',0),(90181,2506,'is','',0),(90182,2506,'dr','-    Ø§Ú¯Ø± Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±Ù‡Ø§ Ø®Ø§Ù„ÙŠ Ú¯Ø°Ø§Ø´ØªÙ‡ Ø´ÙˆÙ†Ø¯ Ø±Ù…Ø²Ù‚Ø¯ÙŠÙ…ÙŠ Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(90183,2506,'pr','Ù…ØªÙ† Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±-    Ø§Ú¯Ø± Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±Ù‡Ø§ Ø®Ø§Ù„ÙŠ Ú¯Ø°Ø§Ø´ØªÙ‡ Ø´ÙˆÙ†Ø¯ Ø±Ù…Ø²Ù‚Ø¯ÙŠÙ…ÙŠ Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(90184,2506,'tr','(Parola boÅŸ bÄ±raktÄ±ysanÄ±z,<br>eski bir tutulacaktÄ±r)',0),(90185,2506,'pl','(JeÅ¼eli pusta hasÅ‚a<br>stary zostanÄ… zachowane)',0),(90186,2506,'bg','(ÐÐºÐ¾ Ð¿Ð°Ñ€Ð¾Ð»Ð¸ Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð¾ Ð¿Ñ€Ð°Ð·Ð½Ð¾<br>Ñ‰Ðµ ÑÐµ ÑÑŠÑ…Ñ€Ð°Ð½ÑÐ²Ð° ÑÑ‚Ð°Ñ€Ð¸Ñ)',0),(90187,2506,'ur','Ø§Ú¯Ø± (Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒØ§<br>Ù¾Ø±Ø§Ù†Û’) Ø§ÛŒÚ© Ø±Ú©Ú¾Ø§ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(90188,2506,'sr','(ÐÐºÐ¾ Ñ˜Ðµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾<br>ÑÑ‚Ð°Ñ€Ð¸ Ñ›Ðµ Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°Ñ‚Ð¸)',0),(90189,2506,'vi','(Náº¿u máº­t kháº©u Ä‘á»ƒ trá»‘ngmáº­t kháº©u cÅ© sáº½ giá»¯)',0),(90190,2506,'af','(As wagwoorde blanko gelaat<br>ou een sal gehou word)',0),(90191,2506,'ro','(ÃŽn cazul Ã®n care parolele rÄƒmÃ¢ne necompletat<br>vor fi pÄƒstrate cel vechi)',0),(90192,2506,'et','(Kui paroolid tÃ¼hjaks<br>vana hoitakse)',0),(90193,2506,'si','(ÄŒe gesla prazno<br>starega bo treba hraniti)',0),(90194,2506,'ba','(Jika password dibiarkan kosong<br>lama akan tetap)',0),(90195,2506,'nl','(Als wachtwoorden leeg<br>oude zal worden gehouden)',0),(90196,2506,'fi','(Jos salasanat tyhjÃ¤<br>vanha pysyy)',0),(90197,2506,'no','(Hvis tomt passord<br>gamle beholdes)',0),(90198,2506,'da','(Hvis adgangskoder tomt<br>gamle vil blive holdt)',0),(90199,2506,'ko','(ì•”í˜¸ ë¹„ì–´ ìžˆìœ¼ë©´<br>ì˜¤ëž˜ ëœ ê²ƒì„ ë³´ê´€ ë©ë‹ˆë‹¤)',0),(90200,2506,'he','(×× ×¡×™×¡×ž××•×ª × ×©××¨ ×¨×™×§<br>×™×©×Ÿ ××—×“ ×™×©×ž×¨)',0),(90201,2506,'el','(Î‘Î½ Ï„Î¿Ï…Ï‚ ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î¼ÎµÎ¯Î½ÎµÎ¹ ÎºÎµÎ½ÏŒ<br>Î¸Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î´Î¹Î±Ï„Î·ÏÎ¿ÏÎ½Ï„Î±Î¹ Ï€Î±Î»Î±Î¹ÏŒÏ„ÎµÏÎ¿Ï…)',0),(90202,2506,'zh','ï¼ˆå¦‚æžœå¯†ç ç•™ç©ºæ—§å¯†ç ä¼šè¢«ä¿ç•™ï¼‰\r\n',0),(90203,2506,'sv','(Om lÃ¶senord tomt<br>gamla kommer att hÃ¥llas)',0),(90204,2506,'it','(Se le password vuoto<br>sarÃ  tenuto quello vecchio)',0),(90205,2506,'tl','',0),(90206,2506,'th','(If passwords left blank<br>old one will be kept)',0),(90207,2506,'hi','à¤…à¤—à¤° (à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼à¤¾<br>à¤à¤• à¤ªà¥à¤°à¤¾à¤¨à¥‡ à¤°à¤–à¤¾ à¤œà¤¾à¤à¤—à¤¾)',0),(90208,2506,'ms','(Jika kata laluan kosong<br>lama akan disimpan)',0),(90209,2506,'ar','(Ø¥Ø°Ø§ ØªØ±ÙƒØª ÙƒÙ„Ù…Ø§Øª Ù…Ø±ÙˆØ± ÙØ§Ø±ØºØ©<br>Ø³ÙŠØªÙ… Ø§Ù„Ø§Ø­ØªÙØ§Ø¸ Ø¨Ø§Ù„Ù‚Ø¯ÙŠÙ…)',0),(90210,2506,'fr','(Si le mot de passe vide<br>ancien est conservÃ©)',0),(90211,2506,'jp','ï¼ˆã‚‚ã?—ã‚‚ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã?Œç©ºæ¬„ã?®ã?¾ã?¾ã?ªã‚‰<br>å?¤ã?„ã‚‚ã?®ã?Œä¿?å­˜ã?•ã‚Œã?¾ã?™ï¼‰',0),(90212,2506,'pt','(Se as senhas deixaram em branco<br>antigo serÃ¡ mantido)',0),(90213,2506,'ru','(Ð•ÑÐ»Ð¸ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿ÑƒÑÑ‚Ñ‹Ð¼<br>Ð¡Ñ‚Ð°Ñ€Ñ‹Ð¹ Ð±ÑƒÐ´ÐµÑ‚ Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒÑÑ)',0),(90214,2506,'es','( Si las contraseÃ±as se dejan en blanco<br>se guardarÃ¡ la vieja',0),(90215,2506,'de','(Wenn Sie PasswÃ¶rter leer lassen<br>alte wird einbehalten)',0),(90216,2506,'en','(If passwords left blank<br>old one will be kept)',0),(90217,2507,'is','',0),(90218,2507,'dr','QC ÙƒÙ†ØªØ±Ù„ ÙƒÙŠÙÙŠØª ',0),(90219,2507,'pr','QC ÙƒÙ†ØªØ±Ù„ ÙƒÙŠÙÙŠØª ',0),(90220,2507,'tr','QC',0),(90221,2507,'pl','QC',0),(90222,2507,'bg','QC',0),(90223,2507,'ur','QC',0),(90224,2507,'sr','\"ÐŸÐš\"',0),(90225,2507,'vi','QC',0),(90226,2507,'af','QC',0),(90227,2507,'ro','QC',0),(90228,2507,'et','QC',0),(90229,2507,'si','QC',0),(90230,2507,'ba','QC',0),(90231,2507,'nl','QC',0),(90232,2507,'fi','QC',0),(90233,2507,'no','QC',0),(90234,2507,'da','QC',0),(90235,2507,'ko','QC',0),(90236,2507,'he','QC',0),(90237,2507,'el','QC',0),(90238,2507,'zh','è´¨é‡æŽ§åˆ¶\r\n',0),(90239,2507,'sv','QC',0),(90240,2507,'it','QC',0),(90241,2507,'tl','',0),(90242,2507,'th','&#3585;&#3634;&#3619;&#3588;&#3623;&#3610;&#3588;&#3640;&#3617;&#3588;&#3640;&#3603;&#3616;&#3634;&#3614;',0),(90243,2507,'hi','QC',0),(90244,2507,'ms','QC',0),(90245,2507,'ar','Ù…Ø±Ø§Ù‚Ø¨Ø© Ø§Ù„Ø¬ÙˆØ¯Ø©',0),(90246,2507,'fr','QC',0),(90247,2507,'jp','QC',0),(90248,2507,'pt','QC',0),(90249,2507,'ru','ÐšÐš',0),(90250,2507,'es','QC',0),(90251,2507,'de','QC',0),(90252,2507,'en','QC',0),(90253,2508,'is','',0),(90254,2508,'dr','Ù…Ù‚Ø¯Ø§Ø±',0),(90255,2508,'pr','Ù…Ù‚Ø¯Ø§Ø±',0),(90256,2508,'tr','Miktar',0),(90257,2508,'pl','IloÅ›Ä‡',0),(90258,2508,'bg','ÐšÐ¾Ð»-Ð²Ð¾',0),(90259,2508,'ur','Ù‚ÛŒ',0),(90260,2508,'sr','ÐšÐ¾Ð».',0),(90261,2508,'vi','Sá»‘ lÆ°á»£ng',0),(90262,2508,'af','Hoev.',0),(90263,2508,'ro','Cantit',0),(90264,2508,'et','Kogus',0),(90265,2508,'si','KoliÄina',0),(90266,2508,'ba','Qty',0),(90267,2508,'nl','Aantal',0),(90268,2508,'fi','MÃ¤Ã¤rÃ¤',0),(90269,2508,'no','Antall',0),(90270,2508,'da','Antal',0),(90271,2508,'ko','ìˆ˜ëŸ‰',0),(90272,2508,'he','×›×ž×•×ª',0),(90273,2508,'el','Î Î¿Ïƒ.',0),(90274,2508,'zh','æ•°é‡\r\n',0),(90275,2508,'sv','Kvt',0),(90276,2508,'it','Q. tÃ ',0),(90277,2508,'tl','',0),(90278,2508,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(90279,2508,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(90280,2508,'ms','Qty',0),(90281,2508,'ar','Ø§Ù„ÙƒÙ…ÙŠØ©',0),(90282,2508,'fr','QtÃ©',0),(90283,2508,'jp','é‡?',0),(90284,2508,'pt','Qty',0),(90285,2508,'ru','ÐšÐ¾Ð»-Ð²Ð¾',0),(90286,2508,'es','Cant.',0),(90287,2508,'de','Qty',0),(90288,2508,'en','Qty',0),(90289,2509,'is','',0),(90290,2509,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(90291,2509,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(90292,2509,'tr','KullanÄ±labilir miktar',0),(90293,2509,'pl','IloÅ›Ä‡ dostÄ™pnych',0),(90294,2509,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð°',0),(90295,2509,'ur','Ù‚ÛŒ Ø¯Ø³ØªÛŒØ§Ø¨',0),(90296,2509,'sr','ÐšÐ¾Ð» Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð°',0),(90297,2509,'vi','Sá»‘ lÆ°á»£ng cÃ³ sáºµn',0),(90298,2509,'af','Hoev. Beskikbaar',0),(90299,2509,'ro','Cantit disponibilÄƒ',0),(90300,2509,'et','Saadaval',0),(90301,2509,'si','RazpoloÅ¾ljiva koliÄina',0),(90302,2509,'ba','Qty tersedia',0),(90303,2509,'nl','Beschikbaar aantal',0),(90304,2509,'fi','MÃ¤Ã¤rÃ¤, saatavilla',0),(90305,2509,'no','Ant tilgjengelig',0),(90306,2509,'da','Antal tilgÃ¦ngelige',0),(90307,2509,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” ìˆ˜ëŸ‰',0),(90308,2509,'he','×›×ž×•×ª ×–×ž×™× ×”',0),(90309,2509,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(90310,2509,'zh','å¯ç”¨æ•°é‡\r\n',0),(90311,2509,'sv','Antal tillgÃ¤ngliga',0),(90312,2509,'it','Q. tÃ  disponibile',0),(90313,2509,'tl','',0),(90314,2509,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3652;&#3604;&#3657;',0),(90315,2509,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(90316,2509,'ms','Qty yang disediakan',0),(90317,2509,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(90318,2509,'fr','QtÃ© disponible',0),(90319,2509,'jp','å…¥æ‰‹å?¯èƒ½æ•°é‡?',0),(90320,2509,'pt','Qty disponÃ­vel',0),(90321,2509,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾Ðµ ÐšÐ¾Ð»-Ð²Ð¾',0),(90322,2509,'es','Cant. Disponible',0),(90323,2509,'de','VerfÃ¼gbare Menge:',0),(90324,2509,'en','Qty Available',0),(90325,2510,'is','',0),(90326,2510,'dr','Qty BO  Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÙˆØ¬ÙŠ( Ø¯ÙˆØ¯ÙˆØ¦ÙŠ) ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(90327,2510,'pr','Qty BO  Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÙˆØ¬ÙŠ( Ø¯ÙˆØ¯ÙˆØ¦ÙŠ) ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(90328,2510,'tr','Miktar BO',0),(90329,2510,'pl','IloÅ›Ä‡ BO',0),(90330,2510,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð‘Ð¾',0),(90331,2510,'ur','Ù‚ÛŒ Ø¨Ùˆ',0),(90332,2510,'sr','ÐšÐ¾Ð» Ð‘Ðž',0),(90333,2510,'vi','Sá»‘ lÆ°á»£ng BO',0),(90334,2510,'af','Hoev. \"BO\"',0),(90335,2510,'ro','Cantit BO',0),(90336,2510,'et','Kogus BO',0),(90337,2510,'si','Kol BO',0),(90338,2510,'ba','Qty BO',0),(90339,2510,'nl','Aantal BO',0),(90340,2510,'fi','MÃ¤Ã¤rÃ¤ BO',0),(90341,2510,'no','Antall BO',0),(90342,2510,'da','Antal BO',0),(90343,2510,'ko','ìˆ˜ëŸ‰ ë³´',0),(90344,2510,'he','×›×ž×•×ª ×‘×•',0),(90345,2510,'el','Qty BO',0),(90346,2510,'zh','æ•°é‡å…¬æŠ¥\r\n',0),(90347,2510,'sv','Antal BO',0),(90348,2510,'it','Q. tÃ  BO',0),(90349,2510,'tl','',0),(90350,2510,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603; BO',0),(90351,2510,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¬à¥‹',0),(90352,2510,'ms','Qty BO',0),(90353,2510,'ar','Qty Ø¨Ùˆ',0),(90354,2510,'fr','Qty BO',0),(90355,2510,'jp','å…¥è?·å¾…ã?¡æ•°é‡?',0),(90356,2510,'pt','Qty BO',0),(90357,2510,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð±Ð¾',0),(90358,2510,'es','Cant. BO',0),(90359,2510,'de','Qty BO',0),(90360,2510,'en','Qty BO',0),(90361,2511,'is','',0),(90362,2511,'dr','Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(90363,2511,'pr','Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(90364,2511,'tr','Ä°ÅŸlenen miktar',0),(90365,2511,'pl','IloÅ›Ä‡ popeÅ‚nionych',0),(90366,2511,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¸Ð·Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸',0),(90367,2511,'ur','Ù‚ÛŒ Ú©Ø§ Ø§Ø±ØªÚ©Ø§Ø¨ Ú©ÛŒØ§',0),(90368,2511,'sr','ÐšÐ¾Ð» Ð¿Ð¾Ñ‡Ð¸Ð½Ð¸Ð¾',0),(90369,2511,'vi','Sá»‘ lÆ°á»£ng cam káº¿t',0),(90370,2511,'af','Hoev. Toegewys',0),(90371,2511,'ro','Cantit comise',0),(90372,2511,'et','Toime pandud kogus',0),(90373,2511,'si','KoliÄina, storjeno',0),(90374,2511,'ba','Qty berkomitmen',0),(90375,2511,'nl','Aantal begaan',0),(90376,2511,'fi','Sidottu mÃ¤Ã¤rÃ¤',0),(90377,2511,'no','Antall forpliktet',0),(90378,2511,'da','Antal begÃ¥et',0),(90379,2511,'ko','íˆ¬ìž… ìˆ˜ëŸ‰',0),(90380,2511,'he','×›×ž×•×ª ×‘×™×¦×¢',0),(90381,2511,'el','Qty Î´Î¹Î±Ï€ÏÎ¬Î¾ÎµÎ¹',0),(90382,2511,'zh','æ•°é‡æ‰¿è¯º\r\n',0),(90383,2511,'sv','Antal begÃ¥tt',0),(90384,2511,'it','Qty commesso',0),(90385,2511,'tl','',0),(90386,2511,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;',0),(90387,2511,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§',0),(90388,2511,'ms','Qty yang komited',0),(90389,2511,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ Ø§Ø±ØªÙƒØ¨Øª',0),(90390,2511,'fr','Qty commis',0),(90391,2511,'jp','ç™ºæ³¨æ¸ˆæ•°é‡?',0),(90392,2511,'pt','Qty comprometida',0),(90393,2511,'ru','ÐšÐ¾Ð»-Ð²Ð¾ ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ñ…',0),(90394,2511,'es','Cant. Comprometida',0),(90395,2511,'de','Qty begangen',0),(90396,2511,'en','Qty Committed',0),(90397,2512,'is','',0),(90398,2512,'dr','Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ Ø¨Ø§Ø² ',0),(90399,2512,'pr','Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ Ø¨Ø§Ø² ',0),(90400,2512,'tr','Ä°ÅŸlediÄŸi AÃ§Ä±k miktar',0),(90401,2512,'pl','Otwarte iloÅ›Ä‡ popeÅ‚nionych',0),(90402,2512,'bg','ÐžÑ‚Ð²Ð¾Ñ€Ð¸ ÐºÐ¾Ð» Ð¸Ð·Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸',0),(90403,2512,'ur','Ú©Ú¾Ù„ÛŒ Ù‚ÛŒ Ú©Ø§ Ø§Ø±ØªÚ©Ø§Ø¨ Ú©ÛŒØ§',0),(90404,2512,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð° ÐšÐ¾Ð» Ð¿Ð¾Ñ‡Ð¸Ð½Ð¸Ð¾',0),(90405,2512,'vi','Má»Ÿ Sá»‘ lÆ°á»£ng cam káº¿t',0),(90406,2512,'af','Oop Hoev. Toegewys',0),(90407,2512,'ro','Cantit deschis comise',0),(90408,2512,'et','Avatud kogus toime',0),(90409,2512,'si','Odprta kol, storjeno',0),(90410,2512,'ba','Buka Qty berkomitmen',0),(90411,2512,'nl','Open Qty begaan',0),(90412,2512,'fi','Avoin mÃ¤Ã¤rÃ¤ sitoutunut',0),(90413,2512,'no','Ã…pne antall forpliktet',0),(90414,2512,'da','Ã…ben Qty begÃ¥et',0),(90415,2512,'ko','ì»¤ë°‹ ì—´ê¸° Qty',0),(90416,2512,'he','×›×ž×•×ª ×¤×ª×•×— ×‘×™×¦×¢',0),(90417,2512,'el','Î‘Î½Î¿Î¹ÎºÏ„Î® Qty Î´Î¹Î±Ï€ÏÎ¬Î¾ÎµÎ¹',0),(90418,2512,'zh','æ‰“å¼€æ•°é‡æ‰¿è¯º\r\n',0),(90419,2512,'sv','Ã–ppna Kvt begÃ¥tt',0),(90420,2512,'it','Aperto Qty commesso',0),(90421,2512,'tl','',0),(90422,2512,'th','&#3648;&#3611;&#3636;&#3604;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;',0),(90423,2512,'hi','à¤–à¥à¤²à¤¾ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§',0),(90424,2512,'ms','Terbuka Qty yang komited',0),(90425,2512,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ù…ÙØªÙˆØ­Ø© Ø§Ø±ØªÙƒØ¨Øª',0),(90426,2512,'fr','QtÃ© ouverte commise',0),(90427,2512,'jp','ç™ºæ³¨æ¸ˆã‚ªãƒ¼ãƒ—ãƒ³æ•°é‡?',0),(90428,2512,'pt','Qty aberto comprometida',0),(90429,2512,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ ÐšÐ¾Ð»-Ð²Ð¾ ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ñ…',0),(90430,2512,'es','Cant. Abierta Comprometido',0),(90431,2512,'de','Offene Menge begangen',0),(90432,2512,'en','Open Qty Committed',0),(90433,2513,'is','',0),(90434,2513,'dr','Ø²ÙŠØ± Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(90435,2513,'pr','Ø²ÙŠØ± Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(90436,2513,'tr','KaydedilmiÅŸ alt Mkt.',0),(90437,2513,'pl','IloÅ›Ä‡ sub popeÅ‚nione',0),(90438,2513,'bg','Sub ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¸Ð·Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸',0),(90439,2513,'ur','Ø°ÛŒÙ„ÛŒ Ù‚ÛŒ Ú©Ø§ Ø§Ø±ØªÚ©Ø§Ø¨ Ú©ÛŒØ§',0),(90440,2513,'sr','Ð¡ÑƒÐ± ÐšÐ¾Ð» Ð¿Ð¾Ñ‡Ð¸Ð½Ð¸Ð¾',0),(90441,2513,'vi','Sá»‘ lÆ°á»£ng phá»¥ cam káº¿t',0),(90442,2513,'af','Oop Hoev. Toegewys',0),(90443,2513,'ro','Sub cantit comise',0),(90444,2513,'et','Sub kogus toime',0),(90445,2513,'si','Sub kol zavezala',0),(90446,2513,'ba','Sub Qty berkomitmen',0),(90447,2513,'nl','Sub Qty begaan',0),(90448,2513,'fi','Sub mÃ¤Ã¤rÃ¤ sitoutunut',0),(90449,2513,'no','Sub Ant forpliktet',0),(90450,2513,'da','Sub Qty begÃ¥et',0),(90451,2513,'ko','í•˜ìœ„ Qty íˆ¬ìž…',0),(90452,2513,'he','×›×ž×•×ª sub ×‘×™×¦×¢',0),(90453,2513,'el','Î¥Ï€Î¿ Qty Î´Î¹Î±Ï€ÏÎ¬Î¾ÎµÎ¹',0),(90454,2513,'zh','å­æ•°é‡æ‰¿è¯º\r\n',0),(90455,2513,'sv','Sub antal begÃ¥tt',0),(90456,2513,'it','Sub Qty commesso',0),(90457,2513,'tl','',0),(90458,2513,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3618;&#3656;&#3629;&#3618;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;',0),(90459,2513,'hi','à¤‰à¤ª à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§',0),(90460,2513,'ms','Qty sub yang komited',0),(90461,2513,'ar','Sub Qty Ø§Ø±ØªÙƒØ¨Øª',0),(90462,2513,'fr','Void Qty commis',0),(90463,2513,'jp','ç™ºæ³¨æ¸ˆæ•°é‡?å°?è¨ˆ',0),(90464,2513,'pt','Qtde de sub comprometida',0),(90465,2513,'ru','Sub Qty ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ',0),(90466,2513,'es','Sub Cant. Comprometida',0),(90467,2513,'de','Sub Qty begangen',0),(90468,2513,'en','Sub Qty Committed',0),(90469,2514,'is','',0),(90470,2514,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(90471,2514,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(90472,2514,'tr','Ä°ÅŸlenen Toplam Mkt.',0),(90473,2514,'pl','CaÅ‚kowita iloÅ›Ä‡ popeÅ‚nionych',0),(90474,2514,'bg','ÐžÐ±Ñ‰Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¸Ð·Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸',0),(90475,2514,'ur','Ú©Ù„ Ù‚ÛŒ Ú©Ø§ Ø§Ø±ØªÚ©Ø§Ø¨ Ú©ÛŒØ§',0),(90476,2514,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÐºÐ¾Ð» Ð¿Ð¾Ñ‡Ð¸Ð½Ð¸Ð¾',0),(90477,2514,'vi','Tá»•ng cá»™ng Sá»‘ lÆ°á»£ng cam káº¿t',0),(90478,2514,'af','Bereken Hoev. Toegewys',0),(90479,2514,'ro','Cantitate totalÄƒ comise',0),(90480,2514,'et','Kokku kogus toime',0),(90481,2514,'si','Skupna koliÄina, storjeno',0),(90482,2514,'ba','Total Qty berkomitmen',0),(90483,2514,'nl','Totale aantal begaan',0),(90484,2514,'fi','YhteensÃ¤ kpl sitoutunut',0),(90485,2514,'no','Totalt antall forpliktet',0),(90486,2514,'da','Samlede antal begÃ¥et',0),(90487,2514,'ko','ì»¤ë°‹ëœ ì´ ìˆ˜ëŸ‰',0),(90488,2514,'he','×¡×” ×› ×›×ž×•×ª ×‘×™×¦×¢',0),(90489,2514,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î´Î¹Î±Ï€ÏÎ¬Î¾ÎµÎ¹',0),(90490,2514,'zh','æ€»æ•°é‡æ‰¿è¯º\r\n',0),(90491,2514,'sv','Totalt antal begÃ¥tt',0),(90492,2514,'it','Q. tÃ  totale impegnato',0),(90493,2514,'tl','',0),(90494,2514,'th','&#3619;&#3623;&#3617;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;',0),(90495,2514,'hi','à¤•à¥à¤² à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§',0),(90496,2514,'ms','Jumlah Qty yang komited',0),(90497,2514,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ Ø§Ø±ØªÙƒØ¨Øª',0),(90498,2514,'fr','Total Qty commis',0),(90499,2514,'jp','ç™ºæ³¨æ¸ˆæ•°é‡?å?ˆè¨ˆ',0),(90500,2514,'pt','Qtde total comprometido',0),(90501,2514,'ru','ÐžÐ±Ñ‰ÐµÐµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ñ…',0),(90502,2514,'es','Cant. Total Comprometida',0),(90503,2514,'de','Total Qty begangen',0),(90504,2514,'en','Total Qty Committed',0),(90505,2515,'is','',0),(90506,2515,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(90507,2515,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(90508,2515,'tr','Eldeki miktar',0),(90509,2515,'pl','IloÅ›Ä‡ zapasÃ³w',0),(90510,2515,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ñ€ÑŠÐºÐ°',0),(90511,2515,'ur','Ù‚ÛŒ Ù¾Ø± ÛØ§ØªÚ¾',0),(90512,2515,'sr','ÐšÐ¾Ð» ÐºÐ¾Ð´ ÑÐµÐ±Ðµ',0),(90513,2515,'vi','Sá»‘ lÆ°á»£ng sáºµn cÃ³',0),(90514,2515,'af','Hoev. Op Hande',0),(90515,2515,'ro','Cantit pe-o parte',0),(90516,2515,'et','Kogus vaba',0),(90517,2515,'si','KoliÄina na roko',0),(90518,2515,'ba','Qty di tangan',0),(90519,2515,'nl','Qty op Hand-',0),(90520,2515,'fi','MÃ¤Ã¤rÃ¤ kÃ¤ytettÃ¤vissÃ¤',0),(90521,2515,'no','Ant pÃ¥ lager',0),(90522,2515,'da','Antal pÃ¥ hÃ¥nd',0),(90523,2515,'ko','Qtyì— ì†',0),(90524,2515,'he','×›×ž×•×ª ×‘× ×ž×¦×',0),(90525,2515,'el','Qty ÎµÏ€Î¬Î½Ï‰-Ï‡Î­ÏÎ¹',0),(90526,2515,'zh','çŽ°æœ‰æ•°é‡\r\n',0),(90527,2515,'sv','Antal pÃ¥-Hand',0),(90528,2515,'it','Q. tÃ  a portata di mano',0),(90529,2515,'tl','',0),(90530,2515,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3617;&#3639;&#3629;',0),(90531,2515,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¤°-à¤¹à¤¾à¤¥',0),(90532,2515,'ms','Qty bertugas',0),(90533,2515,'ar','Ø§Ù„ÙƒÙ…ÙŠÙ‘Ø© Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(90534,2515,'fr','QtÃ© en stock',0),(90535,2515,'jp','æ‰‹æŒ?ã?¡æ•°é‡?',0),(90536,2515,'pt','Qty Ã  mÃ£o',0),(90537,2515,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð² Ð½Ð°Ð»Ð¸Ñ‡Ð¸Ð¸',0),(90538,2515,'es','Cant. En Reserva',0),(90539,2515,'de','VerfÃ¼gbare Menge:',0),(90540,2515,'en','Qty On-Hand',0),(90541,2516,'is','',0),(90542,2516,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ ',0),(90543,2516,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ ',0),(90544,2516,'tr','SipariÅŸteki Miktar',0),(90545,2516,'pl','IloÅ›Ä‡ na zamÃ³wieniu',0),(90546,2516,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(90547,2516,'ur','Ù‚ÛŒ Ú©Û’ Ø­Ú©Ù… Ù¾Ø±',0),(90548,2516,'sr','ÐŸÐ¾Ñ€ÑƒÑ‡ÐµÐ½Ð°',0),(90549,2516,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n hÃ ng',0),(90550,2516,'af','Hoev. Op Bestelling',0),(90551,2516,'ro','Cantit pe comandÄƒ',0),(90552,2516,'et','Eraldatud tellimustele',0),(90553,2516,'si','KoliÄina naroÄila',0),(90554,2516,'ba','Qty pesanan',0),(90555,2516,'nl','Aantal op bestelling',0),(90556,2516,'fi','TilausmÃ¤Ã¤rÃ¤',0),(90557,2516,'no','Antall i ordre',0),(90558,2516,'da','Antal i ordre',0),(90559,2516,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(90560,2516,'he','×›×ž×•×ª ×‘×”×–×ž× ×”',0),(90561,2516,'el','Î Î¿Ïƒ / Ï„Î± ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(90562,2516,'zh','è®¢è´­æ•°é‡\r\n',0),(90563,2516,'sv','Antal pÃ¥ bestÃ¤llning',0),(90564,2516,'it','Qty su ordine',0),(90565,2516,'tl','',0),(90566,2516,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(90567,2516,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°',0),(90568,2516,'ms','Qty dengan arahan',0),(90569,2516,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø¹Ù„Ù‰ Ø§Ù„ØªØ±ØªÙŠØ¨',0),(90570,2516,'fr','QtÃ© sur commande',0),(90571,2516,'jp','ç™ºæ³¨æ¸ˆæ•°é‡?',0),(90572,2516,'pt','Qty na ordem',0),(90573,2516,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð’ Ð—Ð°ÐºÐ°Ð·Ðµ',0),(90574,2516,'es','Cant. en Orden',0),(90575,2516,'de','Qty auf Bestellung',0),(90576,2516,'en','Qty On Order',0),(90577,2517,'is','',0),(90578,2517,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ ',0),(90579,2517,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ ',0),(90580,2517,'tr','Miktar Ord',0),(90581,2517,'pl','IloÅ›Ä‡ Ord',0),(90582,2517,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ord',0),(90583,2517,'ur','Ù‚ÛŒ Ø§ÙˆØ±Úˆ',0),(90584,2517,'sr','ÐžÑ€Ð´ ÐšÐ¾Ð».',0),(90585,2517,'vi','Sá»‘ lÆ°á»£ng Ä‘áº·t hÃ ng',0),(90586,2517,'af','Hoev. Bestel',0),(90587,2517,'ro','Cantit Ord',0),(90588,2517,'et','Kogus Ord',0),(90589,2517,'si','KoliÄina Ord',0),(90590,2517,'ba','Qty Ord',0),(90591,2517,'nl','Qty Ord',0),(90592,2517,'fi','MÃ¤Ã¤rÃ¤ Ord',0),(90593,2517,'no','Antall Ord',0),(90594,2517,'da','Antal Ord',0),(90595,2517,'ko','Qty ì˜¤ë“œ',0),(90596,2517,'he','×›×ž×•×ª Ord',0),(90597,2517,'el','Qty Ord',0),(90598,2517,'zh','æ•°é‡æŽ’åº\r\n',0),(90599,2517,'sv','Antal Ord',0),(90600,2517,'it','Q. tÃ  Ord',0),(90601,2517,'tl','',0),(90602,2517,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(90603,2517,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ Ord',0),(90604,2517,'ms','Qty biasa',0),(90605,2517,'ar','Qty Ord',0),(90606,2517,'fr','Qty Ord',0),(90607,2517,'jp','æ³¨æ–‡æ•°é‡?',0),(90608,2517,'pt','Qty Ord',0),(90609,2517,'ru','Qty ÐžÑ€Ð´',0),(90610,2517,'es','Cant. Ord',0),(90611,2517,'de','Qty Ord',0),(90612,2517,'en','Qty Ord',0),(90613,2518,'is','',0),(90614,2518,'dr','/ Ø¨Ø³ØªÙ‡',0),(90615,2518,'pr','Ù…Ù‚Ø¯Ø§Ø± / Ø¨Ø³ØªÙ‡',0),(90616,2518,'tr','Adet/paket',0),(90617,2518,'pl','IloÅ›Ä‡/pakiet',0),(90618,2518,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾/Ð¿Ð°ÐºÐµÑ‚',0),(90619,2518,'ur','Ù‚ÛŒ/Ù¾ÛŒÚ©ÛŒØ¬',0),(90620,2518,'sr','ÐšÐ¾Ð»/Ð¿Ð°ÐºÐµÑ‚',0),(90621,2518,'vi','Sá»‘ lÆ°á»£ng/gÃ³i',0),(90622,2518,'af','Hoev./Pakket',0),(90623,2518,'ro','Cantitate/pachet',0),(90624,2518,'et','Tk/pakend',0),(90625,2518,'si','KoliÄina/paket',0),(90626,2518,'ba','Qty paket',0),(90627,2518,'nl','Aantal/pakket',0),(90628,2518,'fi','Kpl/Paketti',0),(90629,2518,'no','Antall Dobbeltrom',0),(90630,2518,'da','Antal/pakke',0),(90631,2518,'ko','ìˆ˜ëŸ‰/íŒ¨í‚¤ì§€',0),(90632,2518,'he','×›×ž×•×ª/×—×‘×™×œ×”',0),(90633,2518,'el','Qty/Ï€Î±ÎºÎ­Ï„Î¿',0),(90634,2518,'zh','æ•°é‡/åŒ…\r\n',0),(90635,2518,'sv','Antal per fÃ¶rpackning',0),(90636,2518,'it','Qty/pacchetto',0),(90637,2518,'tl','',0),(90638,2518,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;/&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;',0),(90639,2518,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾/à¤ªà¥ˆà¤•à¥‡à¤œ',0),(90640,2518,'ms','Qty/pakej',0),(90641,2518,'ar','Ø§Ù„ÙƒÙ…ÙŠØ©/Ø­Ø²Ù…Ø©',0),(90642,2518,'fr','QuantitÃ©/paquet',0),(90643,2518,'jp','æ•°é‡?/ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸',0),(90644,2518,'pt','Qty/pacote',0),(90645,2518,'ru','Ð¨Ñ‚/Ð¿Ð°ÐºÐµÑ‚',0),(90646,2518,'es','Cant./Paquete',0),(90647,2518,'de','Qty/Paket',0),(90648,2518,'en','Qty/Package',0),(90649,2519,'is','',0),(90650,2519,'dr','/ Ø¨Ø³ØªÙ‡ Ø¨Ø±Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ù‡  ÙˆØ²Ù†',0),(90651,2519,'pr','Ù…Ù‚Ø¯Ø§Ø± / Ø¨Ø³ØªÙ‡ Ø¨Ø±Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ù‡  ÙˆØ²Ù†\r\n calcs',0),(90652,2519,'tr','Adet/paket aÄŸÄ±rlÄ±ÄŸÄ± calcs iÃ§in',0),(90653,2519,'pl','IloÅ›Ä‡/pakiet dla wagi calcs',0),(90654,2519,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾/Ð¿Ð°ÐºÐµÑ‚ Ð·Ð° Ñ‚ÐµÐ³Ð»Ð¾ calcs',0),(90655,2519,'ur','Ù‚ÛŒ/ÙˆØ²Ù† Ú©Ø§Ù„Ú©Ø³ Ú©Û’ Ù„ÛŒÛ’ Ù¾ÛŒÚ©Ø¬',0),(90656,2519,'sr','ÐšÐ¾Ð» /Ð¿Ð°ÐºÐµÑ‚ Ð·Ð° Ñ‚ÐµÐ¶Ð¸Ð½Ñƒ Ñ†Ð°Ð»Ñ†Ñ',0),(90657,2519,'vi','Sá»‘ lÆ°á»£ng/gÃ³i Ä‘á»ƒ tÃ­nh trá»ng lÆ°á»£ng',0),(90658,2519,'af','Hoev./Pakket vir gewigberekening',0),(90659,2519,'ro','Cantitate/pachet pentru calcs greutate',0),(90660,2519,'et','Tk/pakendi kaal calcs',0),(90661,2519,'si','KoliÄina/paket za hujÅ¡anje calcs',0),(90662,2519,'ba','Qty/paket untuk berat calcs',0),(90663,2519,'nl','Aantal/pakket voor gewicht GR \'s',0),(90664,2519,'fi','Kpl/Paketti paino calcs',0),(90665,2519,'no','Antall/pakke for vekt calcs',0),(90666,2519,'da','Antal/pakke for vÃ¦gt calcs',0),(90667,2519,'ko','ìˆ˜ëŸ‰/ì¤‘ëŸ‰ calcs íŒ¨í‚¤ì§€',0),(90668,2519,'he','×›×ž×•×ª/××¨×™×–×” ×¢×‘×•×¨ ×ž×©×§×œ calcs',0),(90669,2519,'el','Qty/Ï€Î±ÎºÎ­Ï„Î¿ Î³Î¹Î± Î²Î¬ÏÎ¿Ï‚ calcs',0),(90670,2519,'zh','æ•°é‡/åŒ…é‡é‡è®¡ç®—\r\n',0),(90671,2519,'sv','Antal per fÃ¶rpackning fÃ¶r vikt calcs',0),(90672,2519,'it','Per peso calcs Qty/pacchetto',0),(90673,2519,'tl','',0),(90674,2519,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;/&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3609;&#3623;&#3603;&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;',0),(90675,2519,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾/à¤µà¤œà¤¨ calcs à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥ˆà¤•à¥‡à¤œ',0),(90676,2519,'ms','Qty/pakej untuk berat badan calcs',0),(90677,2519,'ar','Ø§Ù„ÙƒÙ…ÙŠØ©/Ø­Ø²Ù…Ø© Ù„Ù„ÙˆØ²Ù† ÙƒØ§Ù„ÙƒØ³',0),(90678,2519,'fr','QuantitÃ©/paquet pour poids Calc',0),(90679,2519,'jp','æ•°é‡?/é‡?é‡?è¨ˆç®—ç”¨ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸',0),(90680,2519,'pt','Qty/pacote para peso calcs',0),(90681,2519,'ru','ÐšÐ¾Ð»-Ð²Ð¾/Ð¿Ð°ÐºÐµÑ‚ Ð´Ð»Ñ Ð²ÐµÑÐ° Ð¡ÐŸÐ Ð—',0),(90682,2519,'es','Cant./Paquete para calculos de pesa',0),(90683,2519,'de','Qty pauschal fÃ¼r Gewicht calcs',0),(90684,2519,'en','Qty/Package for weight calcs',0),(90685,2520,'is','',0),(90686,2520,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ø´Ø¯Ù‡ ',0),(90687,2520,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ø´Ø¯Ù‡ ',0),(90688,2520,'tr','SatÄ±n alÄ±nan miktar',0),(90689,2520,'pl','IloÅ›Ä‡ zakupionych',0),(90690,2520,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð°ÐºÑƒÐ¿ÐµÐ½Ð¸',0),(90691,2520,'ur','Ù‚ÛŒ Ø®Ø±ÛŒØ¯Ø§',0),(90692,2520,'sr','ÐšÑƒÐ¿Ñ™ÐµÐ½Ð° ÐšÐ¾Ð».',0),(90693,2520,'vi','Sá»‘ lÆ°á»£ng mua',0),(90694,2520,'af','Hoev. Aangekoop',0),(90695,2520,'ro','Cantit achiziÅ£ionate',0),(90696,2520,'et','Ostetud kogus',0),(90697,2520,'si','KoliÄina kupljenih',0),(90698,2520,'ba','Qty dibeli',0),(90699,2520,'nl','Aantal gekocht',0),(90700,2520,'fi','MÃ¤Ã¤rÃ¤, ostettu',0),(90701,2520,'no','Ant kjÃ¸pt',0),(90702,2520,'da','Antal kÃ¸bte',0),(90703,2520,'ko','êµ¬ìž… ìˆ˜ëŸ‰',0),(90704,2520,'he','×›×ž×•×ª ×¨×›×©',0),(90705,2520,'el','Î‘Î³Î¿ÏÎ±ÏƒÎ¼Î­Î½Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(90706,2520,'zh','è´­ä¹°æ•°é‡\r\n',0),(90707,2520,'sv','Antal kÃ¶pta',0),(90708,2520,'it','Qty acquistato',0),(90709,2520,'tl','',0),(90710,2520,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3595;&#3639;&#3657;&#3629;&#3617;&#3634;',0),(90711,2520,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤–à¤°à¥€à¤¦à¥€',0),(90712,2520,'ms','Qty yang dibeli',0),(90713,2520,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø´ØªØ±Ø§Ø©',0),(90714,2520,'fr','QuantitÃ© achetÃ©e',0),(90715,2520,'jp','è³¼å…¥æ•°é‡?',0),(90716,2520,'pt','Qty comprado',0),(90717,2520,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€Ð¸Ð¾Ð±Ñ€ÐµÑ‚ÐµÐ½Ð½Ñ‹Ñ…',0),(90718,2520,'es','Cant. Comprada',0),(90719,2520,'de','Qty gekauft',0),(90720,2520,'en','Qty Purchased',0),(90721,2521,'is','',0),(90722,2521,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ú¯Ø´Øª Ø´Ø¯Ù‡ ',0),(90723,2521,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ú¯Ø´Øª Ø´Ø¯Ù‡ ',0),(90724,2521,'tr','Ä°ade Mkt.',0),(90725,2521,'pl','IloÅ›Ä‡ zwracanych',0),(90726,2521,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸',0),(90727,2521,'ur','Ù‚ÛŒ Ù„ÙˆÙ¹ Ø¢Ø¦Û’',0),(90728,2521,'sr','ÐšÐ¾Ð» ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾',0),(90729,2521,'vi','Sá»‘ lÆ°á»£ng hoÃ n tráº£',0),(90730,2521,'af','Hoev. Terugbesorg',0),(90731,2521,'ro','Cantitate s-a Ã®ntors',0),(90732,2521,'et','Tagastatud kogus',0),(90733,2521,'si','KoliÄina vrnil',0),(90734,2521,'ba','Qty kembali',0),(90735,2521,'nl','Aantal geretourneerd',0),(90736,2521,'fi','Palautettu mÃ¤Ã¤rÃ¤',0),(90737,2521,'no','Antall returnerte',0),(90738,2521,'da','Antal returnerede',0),(90739,2521,'ko','Qty ë°˜í™˜',0),(90740,2521,'he','×›×ž×•×ª ×—×–×¨',0),(90741,2521,'el','Qty ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ',0),(90742,2521,'zh','æ•°é‡è¿”å›ž\r\n',0),(90743,2521,'sv','Antal Ã¥tervÃ¤nde',0),(90744,2521,'it','Qty restituito',0),(90745,2521,'tl','',0),(90746,2521,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3617;&#3634;',0),(90747,2521,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤²à¥Œà¤Ÿà¥‡',0),(90748,2521,'ms','Qty kembali',0),(90749,2521,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø±Ø¯ÙˆØ¯Ø§Øª',0),(90750,2521,'fr','Qty retournÃ©',0),(90751,2521,'jp','è¿”å“?æ•°é‡?',0),(90752,2521,'pt','Qtd retornada',0),(90753,2521,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ',0),(90754,2521,'es','Cant. Devuelta',0),(90755,2521,'de','Qty zurÃ¼ckgegeben',0),(90756,2521,'en','Qty Returned',0),(90757,2522,'is','',0),(90758,2522,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(90759,2522,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(90760,2522,'tr','SatÄ±lan miktar',0),(90761,2522,'pl','IloÅ›Ä‡ sprzedanych',0),(90762,2522,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¸',0),(90763,2522,'ur','ÙØ±ÙˆØ®Øª Ù‚ÛŒ',0),(90764,2522,'sr','ÐšÐ¾Ð» Ñ˜Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¾',0),(90765,2522,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ bÃ¡n',0),(90766,2522,'af','Hoev. Verkoop',0),(90767,2522,'ro','Cantit vÃ¢ndute',0),(90768,2522,'et','MÃ¼Ã¼dud kogus',0),(90769,2522,'si','KoliÄina prodaje',0),(90770,2522,'ba','Qty dijual',0),(90771,2522,'nl','Aantal verkocht',0),(90772,2522,'fi','MÃ¤Ã¤rÃ¤, myyty',0),(90773,2522,'no','Antall solgt',0),(90774,2522,'da','Antal solgte',0),(90775,2522,'ko','íŒë§¤ ìˆ˜ëŸ‰',0),(90776,2522,'he','×›×ž×•×ª × ×ž×›×¨',0),(90777,2522,'el','Î Î¿Ï…Î»Î·Î¼Î­Î½Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(90778,2522,'zh','é”€å”®æ•°é‡\r\n',0),(90779,2522,'sv','Antal sÃ¥lda',0),(90780,2522,'it','Q. tÃ  venduto',0),(90781,2522,'tl','',0),(90782,2522,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3586;&#3634;&#3618;',0),(90783,2522,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¬à¥‡à¤šà¤¾',0),(90784,2522,'ms','Qty yang dijual',0),(90785,2522,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¨Ø§Ø¹Ø©',0),(90786,2522,'fr','QuantitÃ© vendue',0),(90787,2522,'jp','è²©å£²æ•°é‡?',0),(90788,2522,'pt','Qtde vendida',0),(90789,2522,'ru','ÐšÐ¾Ð»-Ð²Ð¾ ÐŸÑ€Ð¾Ð´Ð°Ð½Ð¾',0),(90790,2522,'es','Cant. Vendida',0),(90791,2522,'de','Qty verkauft',0),(90792,2522,'en','Qty Sold',0),(90793,2523,'is','',0),(90794,2523,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ÙƒØ±Ø¯Ù† ',0),(90795,2523,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ÙƒØ±Ø¯Ù† ',0),(90796,2523,'tr','Sevk edilecek Mkt.',0),(90797,2523,'pl','IloÅ›Ä‡ na statku',0),(90798,2523,'bg','ÐšÐ¾Ð»-Ð²Ð¾ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(90799,2523,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ Ù‚ÛŒ',0),(90800,2523,'sr','ÐšÐ¾Ð» . Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(90801,2523,'vi','Sá»‘ lÆ°á»£ng Ä‘á»ƒ chuyá»ƒn',0),(90802,2523,'af','Hoev. om te Versend',0),(90803,2523,'ro','Cantit navÄƒ',0),(90804,2523,'et','Kogus laeval',0),(90805,2523,'si','KoliÄina za dobavo',0),(90806,2523,'ba','Qty kapal',0),(90807,2523,'nl','Aantal te verzenden',0),(90808,2523,'fi','MÃ¤Ã¤rÃ¤ aluksen',0),(90809,2523,'no','Ant Ã¥ skip',0),(90810,2523,'da','Antal til skib',0),(90811,2523,'ko','ë°° í•˜ ìˆ˜ëŸ‰',0),(90812,2523,'he','×›×ž×•×ª ×©×œ ×”×¡×¤×™× ×”',0),(90813,2523,'el','Qty Ï€Î»Î¿Î¯Î¿',0),(90814,2523,'zh','å‘è¿æ•°é‡\r\n',0),(90815,2523,'sv','Kvt att fartyget',0),(90816,2523,'it','Qty per nave',0),(90817,2523,'tl','',0),(90818,2523,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3648;&#3614;&#3639;&#3656;&#3629;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(90819,2523,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(90820,2523,'ms','Qty ke kapal',0),(90821,2523,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø¥Ù„Ù‰ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(90822,2523,'fr','QtÃ© Ã  expÃ©dier',0),(90823,2523,'jp','ç™ºé€?æ•°é‡?',0),(90824,2523,'pt','Qtde de navio',0),(90825,2523,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(90826,2523,'es','Cant.para Transportar',0),(90827,2523,'de','Menge: Schiff',0),(90828,2523,'en','Qty To Ship',0),(90829,2524,'is','',0),(90830,2524,'dr','ÙˆØ§Ø­Ø¯ Ù…Ù‚Ø¯Ø§Ø± ',0),(90831,2524,'pr','ÙˆØ§Ø­Ø¯ Ù…Ù‚Ø¯Ø§Ø± ',0),(90832,2524,'tr','Birim miktarÄ±',0),(90833,2524,'pl','Qty. Unit',0),(90834,2524,'bg','ÐšÐ¾Ð»-Ð²Ð¾ Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(90835,2524,'ur','Qty. ÛŒÙˆÙ†Ù¹',0),(90836,2524,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(90837,2524,'vi','ÄÆ¡n vá»‹ Sá»‘ lÆ°á»£ng',0),(90838,2524,'af','Hoev. Eenheid',0),(90839,2524,'ro','Unitate de cant.',0),(90840,2524,'et','Kogus Ã¼hik',0),(90841,2524,'si','KoliÄina enota',0),(90842,2524,'ba','Qty. Unit',0),(90843,2524,'nl','Aantal Unit',0),(90844,2524,'fi','MÃ¤Ã¤rÃ¤ yksikÃ¶ssÃ¤',0),(90845,2524,'no','Antall enhet',0),(90846,2524,'da','Antal enhed',0),(90847,2524,'ko','ìˆ˜ëŸ‰ ë‹¨ìœ„',0),(90848,2524,'he','×›×ž×•×ª ×™×—×™×“×”',0),(90849,2524,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(90850,2524,'zh','æ•°é‡ã€‚å•ä½\r\n',0),(90851,2524,'sv','Ant. enhet',0),(90852,2524,'it','QtÃ  unitÃ ',0),(90853,2524,'tl','',0),(90854,2524,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(90855,2524,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤‡à¤•à¤¾à¤ˆ',0),(90856,2524,'ms','Qty. Unit',0),(90857,2524,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„ÙƒÙ…Ø¨Ø©',0),(90858,2524,'fr','UnitÃ© QtÃ©',0),(90859,2524,'jp','å?˜ä½?æ•°é‡?',0),(90860,2524,'pt','Unidade Qtd.',0),(90861,2524,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð±Ð»Ð¾ÐºÐ°',0),(90862,2524,'es','Cant. Unidad',0),(90863,2524,'de','Menge Einheit',0),(90864,2524,'en','Qty. Unit',0),(90865,2525,'is','',0),(90866,2525,'dr','ÙˆØ§Ø­Ø¯ Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(90867,2525,'pr','ÙˆØ§Ø­Ø¯ Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(90868,2525,'tr','Fatura iÃ§in birim miktarÄ±',0),(90869,2525,'pl','IloÅ›Ä‡ jednostek do faktury',0),(90870,2525,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(90871,2525,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©ÛŒ Ø§Ú©Ø§Ø¦ÛŒ',0),(90872,2525,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(90873,2525,'vi','ÄÆ¡n vá»‹ Sá»‘ lÆ°á»£ng cho hÃ³a Ä‘Æ¡n',0),(90874,2525,'af','Hoeveelheid Eenheid vir Faktuur',0),(90875,2525,'ro','Unitatea de cantitate pentru facturÄƒ',0),(90876,2525,'et','Arve kogus Ã¼hik',0),(90877,2525,'si','KoliÄina enoto za raÄun',0),(90878,2525,'ba','Jumlah Unit untuk faktur',0),(90879,2525,'nl','Hoeveelheidseenheid voor factuur',0),(90880,2525,'fi','MÃ¤Ã¤rÃ¤n yksikkÃ¶ laskun',0),(90881,2525,'no','Antall enhet for faktura',0),(90882,2525,'da','Antal enhed for fakturaen',0),(90883,2525,'ko','ì†¡ìž¥ì— ëŒ€ í•œ ìˆ˜ëŸ‰ ë‹¨ìœ„',0),(90884,2525,'he','×›×ž×•×ª ×™×—×™×“×” ×¢×‘×•×¨ ×—×©×‘×•× ×™×ª',0),(90885,2525,'el','ÎœÎ¿Î½Î¬Î´Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±Ï‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(90886,2525,'zh','å‘ç¥¨æ•°é‡å•ä½\r\n',0),(90887,2525,'sv','Antal enhet fÃ¶r faktura',0),(90888,2525,'it','UnitÃ  di quantitÃ  per fattura',0),(90889,2525,'tl','',0),(90890,2525,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(90891,2525,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤•à¤¾à¤ˆ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(90892,2525,'ms','Unit Kuantiti bagi invois',0),(90893,2525,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„ÙƒÙ…ÙŠØ© Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(90894,2525,'fr','UnitÃ© de quantitÃ© de facture',0),(90895,2525,'jp','è«‹æ±‚æ›¸ç”¨å?˜ä½?æ•°é‡?',0),(90896,2525,'pt','Unidade de quantidade de nota fiscal',0),(90897,2525,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑƒÑÑ‚Ñ€Ð¾Ð¹ÑÑ‚Ð²Ð¾ Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð°',0),(90898,2525,'es','Unidad de Cant. para la Factura',0),(90899,2525,'de','Mengeneinheit fÃ¼r Rechnung',0),(90900,2525,'en','Quantity Unit for Invoice',0),(90901,2526,'is','',0),(90902,2526,'dr','ÙˆØ§Ø­Ø¯ Ù…Ù‚Ø¯Ø§Ø± Ù‡Ø±',0),(90903,2526,'pr','ÙˆØ§Ø­Ø¯ Ù…Ù‚Ø¯Ø§Ø± Ù‡Ø±',0),(90904,2526,'tr','Miktar birim /',0),(90905,2526,'pl','IloÅ›Ä‡ jednostek /',0),(90906,2526,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° /',0),(90907,2526,'ur','Ù‚ÛŒ ÛŒÙˆÙ†Ù¹ /',0),(90908,2526,'sr','ÐšÐ¾Ð» Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° /',0),(90909,2526,'vi','ÄÆ¡n vá»‹ Sá»‘ lÆ°á»£ng/',0),(90910,2526,'af','Hoev. Eenheide/',0),(90911,2526,'ro','Unitatea de cantitate /',0),(90912,2526,'et','Koguse Ã¼hik/',0),(90913,2526,'si','KoliÄina enot /',0),(90914,2526,'ba','Qty Unit /',0),(90915,2526,'nl','Qty eenheid /',0),(90916,2526,'fi','MÃ¤Ã¤rÃ¤ yksikkÃ¶ /',0),(90917,2526,'no','Antall enhet /',0),(90918,2526,'da','Antal enhed /',0),(90919,2526,'ko','ìˆ˜ëŸ‰ ë‹¨ìœ„ /',0),(90920,2526,'he','×›×ž×•×ª ×™×—×™×“×” /',0),(90921,2526,'el','ÎœÎ¿Î½Î¬Î´Î± Qty /',0),(90922,2526,'zh','æ•°é‡å•ä½/\r\n',0),(90923,2526,'sv','Antal enhet /',0),(90924,2526,'it','UnitÃ  di Qty /',0),(90925,2526,'tl','',0),(90926,2526,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;/',0),(90927,2526,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¯à¥‚à¤¨à¤¿à¤Ÿ /',0),(90928,2526,'ms','Qty Unit /',0),(90929,2526,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„ÙƒÙ…ÙŠØ©/',0),(90930,2526,'fr','UnitÃ© QtÃ© /',0),(90931,2526,'jp','å?˜ä½?æ•°é‡?/',0),(90932,2526,'pt','Unidade de Qty /',0),(90933,2526,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° ÐšÐ¾Ð»-Ð²Ð¾ /',0),(90934,2526,'es','Cant. Unidad/',0),(90935,2526,'de','Qty Unit /',0),(90936,2526,'en','Qty Unit/',0),(90937,2527,'is','',0),(90938,2527,'dr','/ ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª',0),(90939,2527,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…Ù‚Ø¯Ø§Ø±/ ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª',0),(90940,2527,'tr','Miktar birimleri/fiyat birimi',0),(90941,2527,'pl','IloÅ›Ä‡ sztuk/cena jednostki',0),(90942,2527,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸/Ñ†ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(90943,2527,'ur','Ù‚ÛŒ ÛŒÙˆÙ†Ù¹Ø³/Ù‚ÛŒÙ…Øª ÛŒÙˆÙ†Ù¹',0),(90944,2527,'sr','ÐšÐ¾Ð» Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ/Ñ†ÐµÐ½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(90945,2527,'vi','ÄÆ¡n vá»‹ Sá»‘ lÆ°á»£ng/ÄÆ¡n vá»‹ giÃ¡',0),(90946,2527,'af','Hoev. Eenhede/Pryseenhede',0),(90947,2527,'ro','UnitÄƒÅ£i de cantitate/pret unitar',0),(90948,2527,'et','Kogus Ã¼hikute/HinnaÃ¼hik',0),(90949,2527,'si','KoliÄina enot/cena enote',0),(90950,2527,'ba','Qty unit harga satuan',0),(90951,2527,'nl','Aantal eenheden prijs/eenheid',0),(90952,2527,'fi','MÃ¤Ã¤rÃ¤ yksikkÃ¶Ã¤/HintayksikkÃ¶',0),(90953,2527,'no','Antall enheter/prisenhet',0),(90954,2527,'da','Antal enheder/prisenhed',0),(90955,2527,'ko','ìˆ˜ëŸ‰ ë‹¨ìœ„/ê°€ê²© ë‹¨ìœ„',0),(90956,2527,'he','×›×ž×•×ª ×™×—×™×“×•×ª ×ž×—×™×¨ ×™×—×™×“×”',0),(90957,2527,'el','ÎœÎ¿Î½Î¬Î´Î± Î¼Î¿Î½Î¬Î´ÎµÏ‚ Qty/Ï„Î¹Î¼Î®',0),(90958,2527,'zh','æ•°é‡å•ä½/ä»·æ ¼å•ä½\r\n',0),(90959,2527,'sv','Antal enheter/prisenhet',0),(90960,2527,'it','UnitÃ  unitÃ  Qty/prezzo',0),(90961,2527,'tl','',0),(90962,2527,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;/&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(90963,2527,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚/à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤•à¤¾à¤ˆ',0),(90964,2527,'ms','Unit Qty unit/harga',0),(90965,2527,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„ÙƒÙ…ÙŠØ©/ÙˆØ­Ø¯Ø© Ø§Ù„Ø³Ø¹Ø±',0),(90966,2527,'fr','Qty d\'unitÃ©s / Prix d\'unitÃ©',0),(90967,2527,'jp','å?˜ä½?æ•°é‡?/å?˜ä½?ä¾¡æ ¼',0),(90968,2527,'pt','Unidades de Qty/preÃ§o unidade',0),(90969,2527,'ru','ÐšÐ¾Ð»-Ð²Ð¾ ÐµÐ´Ð¸Ð½Ð¸Ñ†/ÐµÐ´',0),(90970,2527,'es','Cant. Unidad de Unidades/Precio',0),(90971,2527,'de','Qty Einheiten/Preiseinheit',0),(90972,2527,'en','Qty Units/Price Unit',0),(90973,2528,'is','',0),(90974,2528,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(90975,2528,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(90976,2528,'tr','KullanÄ±lan miktar',0),(90977,2528,'pl','IloÅ›Ä‡ uÅ¼ywane',0),(90978,2528,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½',0),(90979,2528,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ Ù‚ÛŒ',0),(90980,2528,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(90981,2528,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ dÃ¹ng',0),(90982,2528,'af','Hoev. Gebruik',0),(90983,2528,'ro','Cantitate utilizatÄƒ',0),(90984,2528,'et','Kasutatav kogus',0),(90985,2528,'si','Kol, uporabljene',0),(90986,2528,'ba','Qty digunakan',0),(90987,2528,'nl','Aantal gebruikt',0),(90988,2528,'fi','KÃ¤ytetty mÃ¤Ã¤rÃ¤',0),(90989,2528,'no','Antall brukes',0),(90990,2528,'da','Antal anvendte',0),(90991,2528,'ko','ì‚¬ìš© ìˆ˜ëŸ‰',0),(90992,2528,'he','×›×ž×•×ª ×‘×©×™×ž×•×©',0),(90993,2528,'el','Qty Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹',0),(90994,2528,'zh','ä½¿ç”¨æ•°é‡\r\n',0),(90995,2528,'sv','Antal anvÃ¤nds',0),(90996,2528,'it','Qty usato',0),(90997,2528,'tl','',0),(90998,2528,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;',0),(90999,2528,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(91000,2528,'ms','Qty yang digunakan',0),(91001,2528,'ar','Ø§Ù„ÙƒÙ…Ù‘ÙŠØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(91002,2528,'fr','QuantitÃ© utilisÃ©e',0),(91003,2528,'jp','ä½¿ç”¨æ¸ˆæ•°é‡?',0),(91004,2528,'pt','Qty usado',0),(91005,2528,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð½Ð¾Ðµ ÐšÐ¾Ð»-Ð²Ð¾',0),(91006,2528,'es','Cant. Usada',0),(91007,2528,'de','Qty verwendet',0),(91008,2528,'en','Qty Used',0),(91009,2529,'is','',0),(91010,2529,'dr','Ù…Ù‚Ø¯Ø§Ø±',0),(91011,2529,'pr','Ù…Ù‚Ø¯Ø§Ø±',0),(91012,2529,'tr','Miktar',0),(91013,2529,'pl','IloÅ›Ä‡',0),(91014,2529,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(91015,2529,'ur','Ù…Ù‚Ø¯Ø§Ø±',0),(91016,2529,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(91017,2529,'vi','Sá»‘ lÆ°á»£ng ',0),(91018,2529,'af','Hoeveelheid',0),(91019,2529,'ro','Cantitatea',0),(91020,2529,'et','Kogus',0),(91021,2529,'si','KoliÄina',0),(91022,2529,'ba','Kuantitas',0),(91023,2529,'nl','Hoeveelheid',0),(91024,2529,'fi','MÃ¤Ã¤rÃ¤',0),(91025,2529,'no','Antall',0),(91026,2529,'da','MÃ¦ngde',0),(91027,2529,'ko','ìˆ˜ëŸ‰',0),(91028,2529,'he','×›×ž×•×ª',0),(91029,2529,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(91030,2529,'zh','æ•°é‡\r\n',0),(91031,2529,'sv','Kvantitet',0),(91032,2529,'it','QuantitÃ ',0),(91033,2529,'tl','',0),(91034,2529,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(91035,2529,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(91036,2529,'ms','Kuantiti',0),(91037,2529,'ar','Ø§Ù„ÙƒÙ…ÙŠØ©',0),(91038,2529,'fr','QuantitÃ©',0),(91039,2529,'jp','é‡?',0),(91040,2529,'pt','Quantidade',0),(91041,2529,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(91042,2529,'es','Cantidad',0),(91043,2529,'de','Menge',0),(91044,2529,'en','Quantity',0),(91045,2530,'is','',0),(91046,2530,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(91047,2530,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(91048,2530,'tr','Geri sipariÅŸ miktarÄ±',0),(91049,2530,'pl','IloÅ›Ä‡ zamÃ³wiona powrÃ³t',0),(91050,2530,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(91051,2530,'ur','ÙˆØ§Ù¾Ø³ Ø­Ú©Ù… Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(91052,2530,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñƒ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸Ð¼ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°Ð¼Ð°',0),(91053,2530,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n hÃ ng chÆ°a thá»±c hiá»‡n ngay',0),(91054,2530,'af','Hoeveelheid Teruggehoue /Agterstallige Bestelling',0),(91055,2530,'ro','Cantitatea comandata Ã®napoi',0),(91056,2530,'et','TÃ¤itmata tellimuse kogus',0),(91057,2530,'si','KoliÄina v zaostalem naroÄilu',0),(91058,2530,'ba','Kuantitas yang dipesan kembali',0),(91059,2530,'nl','Hoeveelheid terug besteld',0),(91060,2530,'fi','Takaisin tilattu mÃ¤Ã¤rÃ¤',0),(91061,2530,'no','Antall i restordre',0),(91062,2530,'da','MÃ¦ngde i restordre',0),(91063,2530,'ko','ë‹¤ì‹œ ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(91064,2530,'he','×”×›×ž×•×ª ×©×”×•×–×ž× ×”.',0),(91065,2530,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î·Ï‚',0),(91066,2530,'zh','æ¬ äº¤è®¢è´§æ•°é‡\r\n',0),(91067,2530,'sv','Tillbaka BestÃ¤lld kvantitet',0),(91068,2530,'it','QuantitÃ  ordinata indietro',0),(91069,2530,'tl','',0),(91070,2530,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3627;&#3621;&#3633;&#3591;',0),(91071,2530,'hi','à¤µà¤¾à¤ªà¤¸ à¤‘à¤°à¥à¤¡à¤° à¤•à¥€ à¤—à¤ˆ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(91072,2530,'ms','Kuantiti yang dipesan kembali',0),(91073,2530,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(91074,2530,'fr','QuantitÃ© en commande diffÃ©rÃ©e',0),(91075,2530,'jp','å…¥è?·å¾…ã?¡æ•°é‡?',0),(91076,2530,'pt','Quantidade encomendada de volta',0),(91077,2530,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð½Ð¾Ðµ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾',0),(91078,2530,'es','Cantidad de Pedidos Postergados',0),(91079,2530,'de','Bestellmenge zurÃ¼ck',0),(91080,2530,'en','Quantity Back Ordered',0),(91081,2531,'is','',0),(91082,2531,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø´Ø¯Ù‡ ',0),(91083,2531,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø´Ø¯Ù‡ ',0),(91084,2531,'tr','SipariÅŸ edilen miktar',0),(91085,2531,'pl','IloÅ›Ä‡ zamÃ³wiona',0),(91086,2531,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(91087,2531,'ur','Ù…Ù‚Ø¯Ø§Ø± Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(91088,2531,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾',0),(91089,2531,'vi','Sá»‘ lÆ°á»£ng Ä‘áº·t hÃ ng',0),(91090,2531,'af','Hoev. Bestelling',0),(91091,2531,'ro','Cantitatea comandata',0),(91092,2531,'et','Tellitud kogus',0),(91093,2531,'si','NaroÄena koliÄina',0),(91094,2531,'ba','Kuantitas yang dipesan',0),(91095,2531,'nl','Bestelde hoeveelheid',0),(91096,2531,'fi','Tilattu mÃ¤Ã¤rÃ¤',0),(91097,2531,'no','Bestilt antall',0),(91098,2531,'da','Bestilte antal',0),(91099,2531,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(91100,2531,'he','×”×›×ž×•×ª ×©×”×•×–×ž× ×”',0),(91101,2531,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¸ÎµÎ¯ÏƒÎ± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(91102,2531,'zh','è®¢è´­æ•°é‡\r\n',0),(91103,2531,'sv','BestÃ¤lld kvantitet',0),(91104,2531,'it','QuantitÃ  ordinata',0),(91105,2531,'tl','',0),(91106,2531,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(91107,2531,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¥€ à¤—à¤ˆ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(91108,2531,'ms','Kuantiti yang dipesan',0),(91109,2531,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(91110,2531,'fr','QuantitÃ© commandÃ©e',0),(91111,2531,'jp','æ³¨æ–‡æ•°é‡?',0),(91112,2531,'pt','Quantidade encomendada',0),(91113,2531,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð½Ð¾Ðµ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(91114,2531,'es','Cantidad Pedido',0),(91115,2531,'de','Bestellmenge',0),(91116,2531,'en','Quantity Ordered',0),(91117,2532,'is','',0),(91118,2532,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡ Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ',0),(91119,2532,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡ Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ',0),(91120,2532,'tr','Miktar/kutu nakliye',0),(91121,2532,'pl','IloÅ›Ä‡/pole do wysyÅ‚ki',0),(91122,2532,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾/ÐºÑƒÑ‚Ð¸Ñ Ð·Ð° ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½Ðµ',0),(91123,2532,'ur','Ø¬ÛØ§Ø² Ø±Ø§Ù†ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù‚Ø¯Ø§Ø±/Ø®Ø§Ù†Û',0),(91124,2532,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° /ÐºÑƒÑ‚Ð¸Ñ˜Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(91125,2532,'vi','Sá»‘ lÆ°á»£ng/thÃ¹ng Ä‘á»ƒ chuyá»ƒn',0),(91126,2532,'af','Hoeveelheid/Boks vir Versending',0),(91127,2532,'ro','Cantitate/cutie pentru transport maritim',0),(91128,2532,'et','Kogus/kasti laevaliikluse',0),(91129,2532,'si','KoliÄina/polje za ladijski promet',0),(91130,2532,'ba','Kuantitas/Box untuk pengiriman',0),(91131,2532,'nl','Hoeveelheid/Box voor verzending',0),(91132,2532,'fi','MÃ¤Ã¤rÃ¤/laatikko toimitus',0),(91133,2532,'no','Antall/boks for Norge',0),(91134,2532,'da','MÃ¦ngde/boks for forsendelse',0),(91135,2532,'ko','ìˆ˜ëŸ‰/ë°•ìŠ¤ ë°°ì†¡',0),(91136,2532,'he','×›×ž×•×ª/×ª×™×‘×ª ×¢×‘×•×¨ ×”×ž×©×œ×•×—',0),(91137,2532,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î±/ÎºÎ¹Î²ÏŽÏ„Î¹Î¿ Î³Î¹Î± Ï„Î· Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(91138,2532,'zh','è£…è¿æ•°é‡/ç®±\r\n',0),(91139,2532,'sv','Antal/lÃ¥da fÃ¶r sjÃ¶farten',0),(91140,2532,'it','Scatola di quantitÃ  per spedizione',0),(91141,2532,'tl','',0),(91142,2532,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;/&#3585;&#3621;&#3656;&#3629;&#3591; &#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(91143,2532,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾/à¤¬à¥‰à¤•à¥à¤¸ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¥‡ à¤²à¤¿à¤',0),(91144,2532,'ms','Kuantiti/kotak untuk penghantaran',0),(91145,2532,'ar','Ø§Ù„ÙƒÙ…ÙŠØ©/Ù…Ø±Ø¨Ø¹ Ù„Ù„Ø´Ø­Ù†',0),(91146,2532,'fr','QuantitÃ©/boÃ®te pour l\'expÃ©dition',0),(91147,2532,'jp','æ•°é‡?/ç™ºé€?ç”¨ç®±',0),(91148,2532,'pt','Quantidade/caixa para transporte',0),(91149,2532,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð² ÐºÐ¾Ñ€Ð¾Ð±ÐºÐµ Ð´Ð»Ñ ÑÑƒÐ´Ð¾Ñ…Ð¾Ð´ÑÑ‚Ð²Ð°',0),(91150,2532,'es','Cantidad/Caja para Enviar',0),(91151,2532,'de','Menge/Karton fÃ¼r den Versand',0),(91152,2532,'en','Quantity/Box for Shipping',0),(91153,2533,'is','',0),(91154,2533,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(91155,2533,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(91156,2533,'tr','Gereken miktar',0),(91157,2533,'pl','IloÅ›Ä‡ wymaganych',0),(91158,2533,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾',0),(91159,2533,'ur','Ù…Ø·Ù„ÙˆØ¨Û Ù…Ù‚Ø¯Ø§Ø±',0),(91160,2533,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ',0),(91161,2533,'vi','Sá»‘ lÆ°á»£ng yÃªu cáº§u',0),(91162,2533,'af','Hoeveelheid Benodig',0),(91163,2533,'ro','Cantitatea necesarÄƒ',0),(91164,2533,'et','Vajalik kogus',0),(91165,2533,'si','KoliÄina, potrebna',0),(91166,2533,'ba','Kuantitas yang diperlukan',0),(91167,2533,'nl','Vereiste aantal',0),(91168,2533,'fi','Tarvittava mÃ¤Ã¤rÃ¤',0),(91169,2533,'no','Antall',0),(91170,2533,'da','MÃ¦ngde, der krÃ¦ves',0),(91171,2533,'ko','í•„ìš” ìˆ˜ëŸ‰',0),(91172,2533,'he','×”×›×ž×•×ª ×”×“×¨×•×©×”',0),(91173,2533,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(91174,2533,'zh','æ‰€éœ€æ•°é‡\r\n',0),(91175,2533,'sv','Kvantitet som krÃ¤vs',0),(91176,2533,'it','QuantitÃ  richiesta',0),(91177,2533,'tl','',0),(91178,2533,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;',0),(91179,2533,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(91180,2533,'ms','Kuantiti yang diperlukan',0),(91181,2533,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(91182,2533,'fr','QuantitÃ© requise',0),(91183,2533,'jp','å¿…è¦?æ•°é‡?',0),(91184,2533,'pt','Quantidade necessÃ¡ria',0),(91185,2533,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÐ¼Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(91186,2533,'es','Cantidad Requerido',0),(91187,2533,'de','BenÃ¶tigte Menge',0),(91188,2533,'en','Quantity Required',0),(91189,2534,'is','',0),(91190,2534,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(91191,2534,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(91192,2534,'tr','Sevk edilen miktar',0),(91193,2534,'pl','IloÅ›ci dostarczane',0),(91194,2534,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(91195,2534,'ur','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(91196,2534,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(91197,2534,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ chuyá»ƒn',0),(91198,2534,'af','Hoeveelheid Versend',0),(91199,2534,'ro','Cantitatea de livrat',0),(91200,2534,'et','Tarnitud kogus',0),(91201,2534,'si','Dobavljena koliÄina',0),(91202,2534,'ba','Jumlah dikirimkan',0),(91203,2534,'nl','Hoeveelheid verzonden',0),(91204,2534,'fi','Toimitettu mÃ¤Ã¤rÃ¤',0),(91205,2534,'no','Antall levert',0),(91206,2534,'da','Antal leveret',0),(91207,2534,'ko','ì¶œí•˜ ìˆ˜ëŸ‰',0),(91208,2534,'he','×›×ž×•×ª ×©× ×©×œ×—×•',0),(91209,2534,'el','Î‘Ï€ÎµÏƒÏ„Î±Î»Î¼Î­Î½Î· Î Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(91210,2534,'zh','è£…è¿æ•°é‡\r\n',0),(91211,2534,'sv','Kvantitet levereras',0),(91212,2534,'it','QuantitÃ  spedita',0),(91213,2534,'tl','',0),(91214,2534,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(91215,2534,'hi','à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(91216,2534,'ms','Kuantiti yang dihantar',0),(91217,2534,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(91218,2534,'fr','QuantitÃ© expÃ©diÃ©e',0),(91219,2534,'jp','ç™ºé€?æ•°é‡?',0),(91220,2534,'pt','Quantidade fornecida',0),(91221,2534,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÑÐµÑ‚ÑÑ',0),(91222,2534,'es','Cantidad Enviada',0),(91223,2534,'de','Gelieferte Menge',0),(91224,2534,'en','Quantity Shipped',0),(91225,2535,'is','',0),(91226,2535,'dr','Ù…Ø¯Øª Ø³Ù‡ Ù…Ø§Ù‡',0),(91227,2535,'pr','Ù…Ø¯Øª Ø³Ù‡ Ù…Ø§Ù‡',0),(91228,2535,'tr','ÃœÃ§ aylÄ±k dÃ¶nem',0),(91229,2535,'pl','KwartaÅ‚',0),(91230,2535,'bg','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(91231,2535,'ur','Ø³Û Ù…Ø§ÛÛŒ',0),(91232,2535,'sr','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(91233,2535,'vi','QuÃ½',0),(91234,2535,'af','Kwartaal',0),(91235,2535,'ro','Trimestru',0),(91236,2535,'et','Kvartalis',0),(91237,2535,'si','ÄŒetrtletju',0),(91238,2535,'ba','Kuartal',0),(91239,2535,'nl','Kwartaal',0),(91240,2535,'fi','NeljÃ¤nneksen',0),(91241,2535,'no','Kvartal',0),(91242,2535,'da','Kvartal',0),(91243,2535,'ko','ë¶„ê¸°',0),(91244,2535,'he','×”×¨×•×‘×¢',0),(91245,2535,'el','Î¤ÏÎ¯Î¼Î·Î½Î¿',0),(91246,2535,'zh','å­£\r\n',0),(91247,2535,'sv','Kvartalet',0),(91248,2535,'it','Quarto',0),(91249,2535,'tl','',0),(91250,2535,'th','&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;',0),(91251,2535,'hi','à¤¤à¤¿à¤®à¤¾à¤¹à¥€',0),(91252,2535,'ms','Suku',0),(91253,2535,'ar','Ø§Ù„Ø±Ø¨Ø¹',0),(91254,2535,'fr','Trimestre',0),(91255,2535,'jp','4åˆ†ã?®1',0),(91256,2535,'pt','Trimestre',0),(91257,2535,'ru','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(91258,2535,'es','Trimestre',0),(91259,2535,'de','Quartal',0),(91260,2535,'en','Quarter',0),(91261,2536,'is','',0),(91262,2536,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³Ù‡ Ù…Ø§Ù‡Ù‡',0),(91263,2536,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³Ù‡ Ù…Ø§Ù‡Ù‡',0),(91264,2536,'tr','ÃœÃ§ aylÄ±k rapor',0),(91265,2536,'pl','Raport kwartalny',0),(91266,2536,'bg','Ð¢Ñ€Ð¸Ð¼ÐµÑÐµÑ‡ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(91267,2536,'ur','Ø³Û Ù…Ø§ÛÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(91268,2536,'sr','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð½Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(91269,2536,'vi','BÃ¡o cÃ¡o quÃ½',0),(91270,2536,'af','Kwartaarlikse Verslag',0),(91271,2536,'ro','Raport trimestrial',0),(91272,2536,'et','Kvartaalne aruanne',0),(91273,2536,'si','ÄŒetrtletno poroÄilo',0),(91274,2536,'ba','Laporan Triwulan',0),(91275,2536,'nl','Kwartaalbericht',0),(91276,2536,'fi','NeljÃ¤nnesvuosittainen raportti',0),(91277,2536,'no','Kvartalsrapport',0),(91278,2536,'da','Kvartalsrapport',0),(91279,2536,'ko','ë¶„ê¸°ë³„ ë³´ê³ ì„œ',0),(91280,2536,'he','×“×•×— ×¨×‘×¢×•× ×™',0),(91281,2536,'el','Î¤ÏÎ¹Î¼Î·Î½Î¹Î±Î¯Î± Î­ÎºÎ¸ÎµÏƒÎ·',0),(91282,2536,'zh','å­£åº¦æŠ¥å‘Š\r\n',0),(91283,2536,'sv','Kvartalsrapport',0),(91284,2536,'it','Relazione trimestrale',0),(91285,2536,'tl','',0),(91286,2536,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;',0),(91287,2536,'hi','à¤¤à¥à¤°à¥ˆà¤®à¤¾à¤¸à¤¿à¤• à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(91288,2536,'ms','Laporan suku tahunan',0),(91289,2536,'ar','Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø±Ø¨Ø¹ Ø§Ù„Ø³Ù†ÙˆÙŠ',0),(91290,2536,'fr','Rapport trimestriel',0),(91291,2536,'jp','å››å?ŠæœŸ',0),(91292,2536,'pt','RelatÃ³rio trimestral',0),(91293,2536,'ru','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÐžÑ‚Ñ‡ÐµÑ‚',0),(91294,2536,'es','Informe Trimestral',0),(91295,2536,'de','Quartalsbericht',0),(91296,2536,'en','Quarterly Report',0),(91297,2537,'is','',0),(91298,2537,'dr','Ø¬Ø³ØªØ¬Ùˆ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(91299,2537,'pr','Ø¬Ø³ØªØ¬Ùˆ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(91300,2537,'tr','Sorgu baÅŸarÄ±sÄ±z',0),(91301,2537,'pl','Kwerenda nie powiodÅ‚a siÄ™',0),(91302,2537,'bg','Ð—Ð°ÑÐ²ÐºÐ°Ñ‚Ð° Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(91303,2537,'ur','Ø·Ù„Ø¨ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(91304,2537,'sr','Ð£Ð¿Ð¸Ñ‚ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ¾',0),(91305,2537,'vi','Truy váº¥n tháº¥t báº¡i',0),(91306,2537,'af','Navraag het misluk',0),(91307,2537,'ro','Interogare a eÅŸuat',0),(91308,2537,'et','PÃ¤ring nurjus',0),(91309,2537,'si','Poizvedba ni uspela',0),(91310,2537,'ba','Permintaan gagal',0),(91311,2537,'nl','-Query is mislukt',0),(91312,2537,'fi','Kysely epÃ¤onnistui',0),(91313,2537,'no','SpÃ¸rringen mislyktes',0),(91314,2537,'da','ForespÃ¸rgslen mislykkedes',0),(91315,2537,'ko','ì¿¼ë¦¬ ì‹¤íŒ¨',0),(91316,2537,'he','×”×©××™×œ×ª×” × ×›×©×œ×”',0),(91317,2537,'el','Î•ÏÏŽÏ„Î·Î¼Î± Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(91318,2537,'zh','æŸ¥è¯¢å¤±è´¥\r\n',0),(91319,2537,'sv','FrÃ¥gan misslyckades',0),(91320,2537,'it','Query non riuscita',0),(91321,2537,'tl','',0),(91322,2537,'th','&#3588;&#3636;&#3623;&#3619;&#3637;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(91323,2537,'hi','à¤•à¥à¤µà¥‡à¤°à¥€ à¤µà¤¿à¤«à¤²',0),(91324,2537,'ms','Pertanyaan yang gagal',0),(91325,2537,'ar','ÙØ´Ù„ Ø§Ù„Ø§Ø³ØªØ¹Ù„Ø§Ù…',0),(91326,2537,'fr','Ã‰chouÃ© de la requÃªte',0),(91327,2537,'jp','æ¤œç´¢å¤±æ•—',0),(91328,2537,'pt','Consulta falhada',0),(91329,2537,'ru','Ð¡Ð±Ð¾Ð¹ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(91330,2537,'es','Query fallÃ³',0),(91331,2537,'de','Abfrage fehlgeschlagen',0),(91332,2537,'en','Query failed',0),(91333,2538,'is','',0),(91334,2538,'dr','Ø³ÙˆØ§Ù„ ',0),(91335,2538,'pr','Ø³ÙˆØ§Ù„ ',0),(91336,2538,'tr','Soru',0),(91337,2538,'pl','Pytanie',0),(91338,2538,'bg','Ð’ÑŠÐ¿Ñ€Ð¾Ñ',0),(91339,2538,'ur','Ø³ÙˆØ§Ù„',0),(91340,2538,'sr','ÐŸÐ¸Ñ‚Ð°ÑšÐµ',0),(91341,2538,'vi','Há»i',0),(91342,2538,'af','Vraag',0),(91343,2538,'ro','ÃŽntrebare',0),(91344,2538,'et','KÃ¼simus',0),(91345,2538,'si','VpraÅ¡anje',0),(91346,2538,'ba','Pertanyaan',0),(91347,2538,'nl','Vraag',0),(91348,2538,'fi','Kysymys',0),(91349,2538,'no','SpÃ¸rsmÃ¥l',0),(91350,2538,'da','SpÃ¸rgsmÃ¥l',0),(91351,2538,'ko','ì§ˆë¬¸',0),(91352,2538,'he','×©××œ×”',0),(91353,2538,'el','Î•ÏÏŽÏ„Î·ÏƒÎ·',0),(91354,2538,'zh','é—®é¢˜\r\n',0),(91355,2538,'sv','FrÃ¥ga',0),(91356,2538,'it','Domanda',0),(91357,2538,'tl','',0),(91358,2538,'th','&#3588;&#3635;&#3606;&#3634;&#3617;',0),(91359,2538,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨',0),(91360,2538,'ms','Soalan',0),(91361,2538,'ar','Ø³Ø¤Ø§Ù„',0),(91362,2538,'fr','Question',0),(91363,2538,'jp','è³ªå•?',0),(91364,2538,'pt','Pergunta',0),(91365,2538,'ru','Ð’Ð¾Ð¿Ñ€Ð¾Ñ',0),(91366,2538,'es','Pregunta',0),(91367,2538,'de','Frage',0),(91368,2538,'en','Question',0),(91369,2539,'is','',0),(91370,2539,'dr','Ø¢ÙŠØ§ Ø³ÙˆØ§Ù„ Ø¯Ø§Ø±ÙŠØ¯ ØŸ',0),(91371,2539,'pr','Ø¢ÙŠØ§ Ø³ÙˆØ§Ù„ Ø¯Ø§Ø±ÙŠØ¯ ØŸ',0),(91372,2539,'tr','Soru?',0),(91373,2539,'pl','Pytanie?',0),(91374,2539,'bg','Ð’ÑŠÐ¿Ñ€Ð¾Ñ?',0),(91375,2539,'ur','Ø³ÙˆØ§Ù„:?',0),(91376,2539,'sr','ÐŸÐ¸Ñ‚Ð°ÑšÐµ?',0),(91377,2539,'vi','Há»i?',0),(91378,2539,'af','Vraag',0),(91379,2539,'ro','ÃŽntrebare?',0),(91380,2539,'et','KÃ¼simus?',0),(91381,2539,'si','VpraÅ¡anje?',0),(91382,2539,'ba','Pertanyaan?',0),(91383,2539,'nl','Vraag?',0),(91384,2539,'fi','Kysymys?',0),(91385,2539,'no','SpÃ¸rsmÃ¥l?',0),(91386,2539,'da','SpÃ¸rgsmÃ¥l?',0),(91387,2539,'ko','ì§ˆë¬¸?',0),(91388,2539,'he','?×©××œ×”',0),(91389,2539,'el','Î•ÏÏŽÏ„Î·ÏƒÎ·;',0),(91390,2539,'zh','é—®é¢˜ï¼Ÿ\r\n',0),(91391,2539,'sv','FrÃ¥ga?',0),(91392,2539,'it','Domanda?',0),(91393,2539,'tl','',0),(91394,2539,'th','&#3588;&#3635;&#3606;&#3634;&#3617;?',0),(91395,2539,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨?',0),(91396,2539,'ms','Soalan?',0),(91397,2539,'ar','Ø³Ø¤Ø§Ù„ØŸ',0),(91398,2539,'fr','Question ?',0),(91399,2539,'jp','è³ªå•?ï¼Ÿ',0),(91400,2539,'pt','Pergunta?',0),(91401,2539,'ru','Ð’Ð¾Ð¿Ñ€Ð¾Ñ?',0),(91402,2539,'es','Â¿Pregunta?',0),(91403,2539,'de','Frage?',0),(91404,2539,'en','Question?',0),(91405,2540,'is','',0),(91406,2540,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(91407,2540,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(91408,2540,'tr','Fiyat teklifi',0),(91409,2540,'pl','Cytat',0),(91410,2540,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð°',0),(91411,2540,'ur','Ø§Ù‚ØªØ¨Ø§Ø³',0),(91412,2540,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ðµ',0),(91413,2540,'vi','BÃ¡o giÃ¡',0),(91414,2540,'af','Kwotasie',0),(91415,2540,'ro','Citat',0),(91416,2540,'et','Tsitaat',0),(91417,2540,'si','Citat',0),(91418,2540,'ba','Kutipan',0),(91419,2540,'nl','Offerte',0),(91420,2540,'fi','Lainaus',0),(91421,2540,'no','Tilbud',0),(91422,2540,'da','Citat',0),(91423,2540,'ko','ê²¬ì ',0),(91424,2540,'he','×”×¦×¢×ª ×ž×—×™×¨',0),(91425,2540,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(91426,2540,'zh','æŠ¥ä»·\r\n',0),(91427,2540,'sv','Citat',0),(91428,2540,'it','Citazione',0),(91429,2540,'tl','',0),(91430,2540,'th','&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(91431,2540,'hi','à¤¬à¥‹à¤²à¥€',0),(91432,2540,'ms','Sebut harga',0),(91433,2540,'ar','Ø¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ',0),(91434,2540,'fr','Citation',0),(91435,2540,'jp','è¦‹ç©?ã‚‚ã‚Š',0),(91436,2540,'pt','CitaÃ§Ã£o',0),(91437,2540,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð°',0),(91438,2540,'es','CotizaciÃ³n',0),(91439,2540,'de','Zitat',0),(91440,2540,'en','Quote',0),(91441,2541,'is','',0),(91442,2541,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(91443,2541,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(91444,2541,'tr','Teklif baÅŸarÄ±yla eklendi.',0),(91445,2541,'pl','Oferty dodane pomyÅ›lnie.',0),(91446,2541,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(91447,2541,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(91448,2541,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(91449,2541,'vi','ThÃªm bÃ¡o giÃ¡ thÃ nh cÃ´ng',0),(91450,2541,'af','Kwotasie suksesvol bygevoeg.',0),(91451,2541,'ro','Citat adÄƒugat cu succes.',0),(91452,2541,'et','Hinnapakkumise edukalt lisatud.',0),(91453,2541,'si','Ponudbo uspeÅ¡no dodana.',0),(91454,2541,'ba','Kutipan ditambahkan berhasil.',0),(91455,2541,'nl','Offerte met succes toegevoegd.',0),(91456,2541,'fi','Lainaus lisÃ¤Ã¤minen onnistui.',0),(91457,2541,'no','Sitat lagt.',0),(91458,2541,'da','Tilbud tilfÃ¸jet.',0),(91459,2541,'ko','ê²¬ì  ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(91460,2541,'he','×¦×™×˜×•×˜ × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(91461,2541,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(91462,2541,'zh','æŠ¥ä»·æ·»åŠ æˆåŠŸã€‚\r\n',0),(91463,2541,'sv','Citat lagts.',0),(91464,2541,'it','Citazione aggiunti correttamente.',0),(91465,2541,'tl','',0),(91466,2541,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(91467,2541,'hi','à¤¬à¥‹à¤²à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(91468,2541,'ms','Quote berjaya menambah.',0),(91469,2541,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(91470,2541,'fr','Citation ajoutÃ©e avec succÃ¨s.',0),(91471,2541,'jp','è¦‹ç©?ã‚‚ã‚Šã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(91472,2541,'pt','CitaÃ§Ã£o adicionada com Ãªxito.',0),(91473,2541,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(91474,2541,'es','CotizaciÃ³n agregada exitosamente',0),(91475,2541,'de','Zitat wurde erfolgreich hinzugefÃ¼gt.',0),(91476,2541,'en','Quote added successfully.',0),(91477,2542,'is','',0),(91478,2542,'dr',' Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¬Ù‡Øª Ø§Ø·Ù„Ø§Ø¹',0),(91479,2542,'pr',' Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¬Ù‡Øª Ø§Ø·Ù„Ø§Ø¹',0),(91480,2542,'tr','Attn alÄ±ntÄ±',0),(91481,2542,'pl','Oferta kontakt',0),(91482,2542,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð½Ð° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸ÐµÑ‚Ð¾',0),(91483,2542,'ur','Ø§Ù¹Ù¹Ù† Ø³Û’ Ø§Ù‚ØªØ¨Ø§Ø³',0),(91484,2542,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° ÐÑ‚Ñ‚Ð½',0),(91485,2542,'vi','BÃ¡o giÃ¡ tá»›i',0),(91486,2542,'af','Kwotasie Aandag',0),(91487,2542,'ro','Citat Attn',0),(91488,2542,'et','Hinnapakkumise teadmiseks',0),(91489,2542,'si','Citat v vednost',0),(91490,2542,'ba','Attn kutipan',0),(91491,2542,'nl','Offerte T.a.v.',0),(91492,2542,'fi','Huom Quote',0),(91493,2542,'no','Tilbud Attn',0),(91494,2542,'da','Citat ATT',0),(91495,2542,'ko','ê²¬ì  ë‹´ë‹¹ìž',0),(91496,2542,'he','×”×¦×¢×ª ×ž×—×™×¨ ×”×•×‘×œ×”',0),(91497,2542,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Attn',0),(91498,2542,'zh','æŠ¥ä»·ç»åŠžäºº\r\n',0),(91499,2542,'sv','Citera att.',0),(91500,2542,'it','All\'attenzione di citazione',0),(91501,2542,'tl','',0),(91502,2542,'th','&#3649;&#3592;&#3657;&#3591;&#3606;&#3638;&#3591;',0),(91503,2542,'hi','Attn à¤¬à¥‹à¤²à¥€',0),(91504,2542,'ms','U.p. quote',0),(91505,2542,'ar','ØªÙˆØ¬ÙŠÙ‡ Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(91506,2542,'fr','Citation Attn',0),(91507,2542,'jp','è¦‹ç©?ã‚‚ã‚Šå®›å??',0),(91508,2542,'pt','Ã€ atenÃ§Ã£o de citaÃ§Ã£o',0),(91509,2542,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Attn',0),(91510,2542,'es','CotizaciÃ³n AtenciÃ³n',0),(91511,2542,'de','Zitat Attn',0),(91512,2542,'en','Quote Attn',0),(91513,2543,'is','',0),(91514,2543,'dr','ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(91515,2543,'pr','ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(91516,2543,'tr','Yorum alÄ±ntÄ±',0),(91517,2543,'pl','Cytat komentarz',0),(91518,2543,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(91519,2543,'ur','ØªØ¨ØµØ±Û Ø§Ù‚ØªØ¨Ø§Ø³',0),(91520,2543,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(91521,2543,'vi','Nháº­n xÃ©t bÃ¡o giÃ¡',0),(91522,2543,'af','Kwotasie Komentaar',0),(91523,2543,'ro','Citat comentariu',0),(91524,2543,'et','Quote Comment',0),(91525,2543,'si','Citiram komentar',0),(91526,2543,'ba','Mengutip komentar',0),(91527,2543,'nl','Quote Comment',0),(91528,2543,'fi','Quote kommentti',0),(91529,2543,'no','Quote Comment',0),(91530,2543,'da','Quote Comment',0),(91531,2543,'ko','ì¸ìš© ì½”ë©˜íŠ¸',0),(91532,2543,'he','×”×¦×¢×ª ×ž×—×™×¨ ×ª×’×•×‘×”',0),(91533,2543,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(91534,2543,'zh','æŠ¥ä»·è¯„è®º\r\n',0),(91535,2543,'sv','Quote Comment',0),(91536,2543,'it','Commento di citazione',0),(91537,2543,'tl','',0),(91538,2543,'th','&#3649;&#3592;&#3657;&#3591;&#3588;&#3635;&#3605;&#3636;&#3594;&#3617;',0),(91539,2543,'hi','à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€',0),(91540,2543,'ms','Quote Comment',0),(91541,2543,'ar','ØªØ¹Ù‚ÙŠØ¨ Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦Ø¨Ø©',0),(91542,2543,'fr','Commentaire de citation',0),(91543,2543,'jp','è¦‹ç©?ã‚‚ã‚Šã‚³ãƒ¡ãƒ³ãƒˆ',0),(91544,2543,'pt','ComentÃ¡rio de citaÃ§Ã£o',0),(91545,2543,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹',0),(91546,2543,'es','Comentario de CotizaciÃ³n',0),(91547,2543,'de','Kommentar zu zitieren',0),(91548,2543,'en','Quote Comment',0),(91549,2544,'is','',0),(91550,2544,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(91551,2544,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(91552,2544,'tr','Yeni teklif yorum',0),(91553,2544,'pl','Nowy cytat komentarz',0),(91554,2544,'bg','ÐÐ¾Ð²Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð·Ð° ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(91555,2544,'ur','Ù†Ø¦Û’ Ø§Ù‚ØªØ¨Ø§Ø³ ØªØ¨ØµØ±Û',0),(91556,2544,'sr','ÐÐ¾Ð²Ð° Ð¿Ð¾Ð½ÑƒÐ´Ð° Ð·Ð° ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(91557,2544,'vi','ThÃªm Nháº­n xÃ©t bÃ¡o giÃ¡',0),(91558,2544,'af','Kwotasie Komentare Byvoeg',0),(91559,2544,'ro','Nou citat comentariu',0),(91560,2544,'et','Uus hinnapakkumise kommentaar',0),(91561,2544,'si','Nov citat komentar',0),(91562,2544,'ba','Komentar baru kutipan',0),(91563,2544,'nl','Nieuwe offerte commentaar',0),(91564,2544,'fi','Uusi lainaus kommentti',0),(91565,2544,'no','Ny tilbud kommentar',0),(91566,2544,'da','Nye tilbud kommentar',0),(91567,2544,'ko','ìƒˆë¡œìš´ ì¸ìš© ì½”ë©˜íŠ¸',0),(91568,2544,'he','×”×¢×¨×” ×”×¦×¢×ª ×ž×—×™×¨ ×—×“×©×”',0),(91569,2544,'el','ÎÎ­Î¿Ï‚ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(91570,2544,'zh','æŠ¥ä»·è¯„è®ºæ·»åŠ \r\n',0),(91571,2544,'sv','Nya citat kommentar',0),(91572,2544,'it','Nuovo commento di citazione',0),(91573,2544,'tl','',0),(91574,2544,'th','&#3649;&#3592;&#3657;&#3591;&#3588;&#3635;&#3605;&#3636;&#3594;&#3617;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(91575,2544,'hi','à¤¨à¤ˆ à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€',0),(91576,2544,'ms','Komen sebut harga baru',0),(91577,2544,'ar','Ø¥Ø¶Ø§ÙØ© ØªØ¹Ù‚ÙŠØ¨ Ø¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ',0),(91578,2544,'fr','Nouveau commentaire de citation',0),(91579,2544,'jp','è¦‹ç©?ã‚‚ã‚Šã‚³ãƒ¡ãƒ³ãƒˆã?®è¿½åŠ ',0),(91580,2544,'pt','Novo comentÃ¡rio de citaÃ§Ã£o',0),(91581,2544,'ru','ÐÐ¾Ð²Ð°Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹',0),(91582,2544,'es','Comentario de CotizaciÃ³n Agregar',0),(91583,2544,'de','Neues Angebot-Kommentar',0),(91584,2544,'en','New Quote Comment',0),(91585,2545,'is','',0),(91586,2545,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(91587,2545,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(91588,2545,'tr','AlÄ±ntÄ± yorum baÅŸarÄ±yla eklendi',0),(91589,2545,'pl','Cytat komentarz dodany pomyÅ›lnie',0),(91590,2545,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€ Ð´Ð¾Ð±Ð°Ð²Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(91591,2545,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ ØªØ¨ØµØ±Û Ø§Ù‚ØªØ¨Ø§Ø³',0),(91592,2545,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(91593,2545,'vi','ThÃªm Nháº­n xÃ©t bÃ¡o giÃ¡ thÃ nh cÃ´ng',0),(91594,2545,'af','Kwotasie Kommentaar suksesvol bygevoeg',0),(91595,2545,'ro','Cita comentariu adaugat cu succes',0),(91596,2545,'et','Tsiteerida kommentaar lisatud',0),(91597,2545,'si','Citiram komentar uspeÅ¡no dodani',0),(91598,2545,'ba','Mengutip Komentar ditambahkan berhasil',0),(91599,2545,'nl','Offerte commentaar toegevoegd',0),(91600,2545,'fi','Quote kommentti lisÃ¤Ã¤minen onnistui',0),(91601,2545,'no','Quote Comment lagt',0),(91602,2545,'da','Citat Kommentar tilfÃ¸jet',0),(91603,2545,'ko','ì¸ìš© ì½”ë©˜íŠ¸ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(91604,2545,'he','×”×¢×¨×” ×¦×™×˜×•×˜ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(91605,2545,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ ÏƒÏ‡ÏŒÎ»Î¹Î¿ Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(91606,2545,'zh','æŠ¥ä»·è¯„è®ºæ·»åŠ æˆåŠŸ\r\n',0),(91607,2545,'sv','Quote Comment lagts',0),(91608,2545,'it','Citazione commento aggiunto con successo',0),(91609,2545,'tl','',0),(91610,2545,'th','&#3649;&#3592;&#3657;&#3591;&#3588;&#3635;&#3605;&#3636;&#3594;&#3617;&#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(91611,2545,'hi','à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(91612,2545,'ms','Quote Comment yang berjaya menambah',0),(91613,2545,'ar','Ø£Ø¶ÙŠÙ ØªØ¹Ù‚ÙŠØ¨ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(91614,2545,'fr','Citer le Commentaire ajoutÃ© avec succÃ¨s',0),(91615,2545,'jp','è¦‹ç©?ã‚‚ã‚Šã‚³ãƒ¡ãƒ³ãƒˆã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(91616,2545,'pt','Citar o ComentÃ¡rio adicionado com sucesso',0),(91617,2545,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(91618,2545,'es','Comentario de CotizaciÃ³n agregado exitosamente',0),(91619,2545,'de','Quote Kommentar wurde erfolgreich hinzugefÃ¼gt',0),(91620,2545,'en','Quote Comment added successfully',0),(91621,2546,'is','',0),(91622,2546,'dr','ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(91623,2546,'pr','ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(91624,2546,'tr','AlÄ±ntÄ± yorum zaten var',0),(91625,2546,'pl','Cytat komentarz juÅ¼ istnieje',0),(91626,2546,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(91627,2546,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: ØªØ¨ØµØ±Û Ú©ÛŒ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(91628,2546,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(91629,2546,'vi','Nháº­n xÃ©t bÃ¡o giÃ¡ Ä‘Ã£ tá»“n táº¡i',0),(91630,2546,'af','Aanhaling kommentaar bestaan reeds',0),(91631,2546,'ro','Citat comentariu existÄƒ deja',0),(91632,2546,'et','Quote Comment on juba olemas',0),(91633,2546,'si','Citiram komentar Å¾e obstaja',0),(91634,2546,'ba','Mengutip komentar sudah ada',0),(91635,2546,'nl','Citaat bestaat commentaar al',0),(91636,2546,'fi','Lainaus kommentti jo',0),(91637,2546,'no','Kommentar finnes allerede',0),(91638,2546,'da','Citat findes kommentar allerede',0),(91639,2546,'ko','ì¸ìš© ì½”ë©˜íŠ¸ ì´ë¯¸',0),(91640,2546,'he','×¦×™×˜×•×˜ ×ª×’×•×‘×” ×›×‘×¨ ×§×™×™×',0),(91641,2546,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï„Î¿ ÏƒÏ‡ÏŒÎ»Î¹Î¿ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(91642,2546,'zh','è¯„è®ºå¼•ç”¨å·²å­˜åœ¨\r\n',0),(91643,2546,'sv','Citat finns kommentar redan',0),(91644,2546,'it','Citazione commento esiste giÃ ',0),(91645,2546,'tl','',0),(91646,2546,'th','&#3649;&#3592;&#3657;&#3591;&#3588;&#3635;&#3605;&#3636;&#3594;&#3617;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;',0),(91647,2546,'hi','à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(91648,2546,'ms','Petikan komen telah wujud',0),(91649,2546,'ar','ØªØ¹Ù‚ÙŠØ¨ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(91650,2546,'fr','Citation commentaire existe dÃ©jÃ ',0),(91651,2546,'jp','è¦‹ç©?ã‚‚ã‚Šã‚³ãƒ¡ãƒ³ãƒˆã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(91652,2546,'pt','Cito o comentÃ¡rio jÃ¡ existe',0),(91653,2546,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(91654,2546,'es','Comentario de CotizaciÃ³n ya existe',0),(91655,2546,'de','Zitat Kommentar ist bereits vorhanden.',0),(91656,2546,'en','Quote Comment already exists',0),(91657,2547,'is','',0),(91658,2547,'dr','Ø­Ø°Ù ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(91659,2547,'pr','Ø­Ø°Ù ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(91660,2547,'tr','AlÄ±ntÄ± yorum baÅŸarÄ±yla silindi',0),(91661,2547,'pl','Cytat komentarz usuniÄ™ty',0),(91662,2547,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(91663,2547,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ ØªØ¨ØµØ±Û Ø§Ù‚ØªØ¨Ø§Ø³',0),(91664,2547,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(91665,2547,'vi','XÃ³a Nháº­n xÃ©t bÃ¡o giÃ¡ thÃ nh cÃ´ng',0),(91666,2547,'af','Kwotasie Opmerking suskesvol geskrap',0),(91667,2547,'ro','Citat comentariu ÅŸters cu succes',0),(91668,2547,'et','Quote Comment edukalt kustutatud',0),(91669,2547,'si','Citiram komentar izbriÅ¡e uspeÅ¡no',0),(91670,2547,'ba','Mengutip komentar berhasil dihapus',0),(91671,2547,'nl','Offerte commentaar succesvol verwijderd',0),(91672,2547,'fi','Quote kommentti poistettu',0),(91673,2547,'no','Quote Comment slettet',0),(91674,2547,'da','Citat kommentar slettet',0),(91675,2547,'ko','ì¸ìš© ì½”ë©˜íŠ¸ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(91676,2547,'he','×¦×™×˜×•×˜ ×ª×’×•×‘×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(91677,2547,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ ÏƒÏ‡ÏŒÎ»Î¹Î¿ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(91678,2547,'zh','æŠ¥ä»·è¯„è®ºåˆ é™¤æˆåŠŸ\r\n',0),(91679,2547,'sv','Citera: kommentar raderades',0),(91680,2547,'it','Cito il commento cancellato con successo',0),(91681,2547,'tl','',0),(91682,2547,'th','&#3649;&#3592;&#3657;&#3591;&#3588;&#3635;&#3605;&#3636;&#3594;&#3617;&#3606;&#3641;&#3585;&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(91683,2547,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤¬à¥‹à¤²à¥€',0),(91684,2547,'ms','Quote Comment dihapuskan dengan jayanya',0),(91685,2547,'ar','Ø­Ø°Ù ØªØ¹Ù‚ÙŠØ¨ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(91686,2547,'fr','Citer le commentaire supprimÃ© avec succÃ¨s',0),(91687,2547,'jp','è¦‹ç©?ã‚‚ã‚Šã‚³ãƒ¡ãƒ³ãƒˆã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(91688,2547,'pt','Citar comentÃ¡rio apagado com sucesso',0),(91689,2547,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(91690,2547,'es','Comentario de CotizaciÃ³n eliminado exitosamente',0),(91691,2547,'de','Quote Kommentar wurde gelÃ¶scht',0),(91692,2547,'en','Quote Comment deleted successfully',0),(91693,2548,'is','',0),(91694,2548,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(91695,2548,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(91696,2548,'tr','AlÄ±ntÄ± yorum dÃ¼zenlemek',0),(91697,2548,'pl','Edytuj cytat komentarz',0),(91698,2548,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(91699,2548,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ ØªØ¨ØµØ±Û Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(91700,2548,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð° Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(91701,2548,'vi','Cáº­p Nháº­t Nháº­n XÃ©t Vá» BÃ¡o GiÃ¡',0),(91702,2548,'af','Kwotasie Opmerking Opdateer',0),(91703,2548,'ro','Editare citat comentariu',0),(91704,2548,'et','Redigeeri tsiteerida kommentaari',0),(91705,2548,'si','Uredite citat komentar',0),(91706,2548,'ba','Mengedit komentar kutipan',0),(91707,2548,'nl','Offerte Opmerking bewerken',0),(91708,2548,'fi','Muokkaa lainaus kommentti',0),(91709,2548,'no','Redigere tilbud kommentar',0),(91710,2548,'da','Redigere citat kommentar',0),(91711,2548,'ko','ì¸ìš© ì½”ë©˜íŠ¸ íŽ¸ì§‘',0),(91712,2548,'he','×¢×¨×•×š ×”×¢×¨×•×ª ×œ×”×¦×¢×ª ×ž×—×™×¨',0),(91713,2548,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï€Î±ÏÎ¬Î¸ÎµÏƒÎ· ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(91714,2548,'zh','æŠ¥ä»·è¯„è®ºæ›´æ–°\r\n',0),(91715,2548,'sv','Redigera citat kommentar',0),(91716,2548,'it','Modificare il commento di citazione',0),(91717,2548,'tl','',0),(91718,2548,'th','&#3649;&#3592;&#3657;&#3591;&#3588;&#3635;&#3605;&#3636;&#3594;&#3617;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(91719,2548,'hi','à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(91720,2548,'ms','Edit Quote komen',0),(91721,2548,'ar','ØªØ­Ø¯ÙŠØ« ØªØ¹Ù‚ÙŠØ¨ Ø¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ',0),(91722,2548,'fr','Modifier le commentaire de la citation',0),(91723,2548,'jp','è¦‹ç©?ã‚‚ã‚Šã‚³ãƒ¡ãƒ³ãƒˆã?®æ›´æ–°',0),(91724,2548,'pt','Editar comentÃ¡rio de citaÃ§Ã£o',0),(91725,2548,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(91726,2548,'es','Comentario de CotizaciÃ³n Actualizar',0),(91727,2548,'de','Zitat Kommentar bearbeiten',0),(91728,2548,'en','Edit Quote Comment',0),(91729,2549,'is','',0),(91730,2549,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(91731,2549,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(91732,2549,'tr','AlÄ±ntÄ± yorum baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(91733,2549,'pl','Cytat komentarz pomyÅ›lnie zaktualizowana',0),(91734,2549,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(91735,2549,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ ØªØ¨ØµØ±Û Ø§Ù‚ØªØ¨Ø§Ø³',0),(91736,2549,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(91737,2549,'vi','Cáº­p Nháº­t Nháº­n XÃ©t Vá» BÃ¡o GiÃ¡ thÃ nh cÃ´ng',0),(91738,2549,'af','Kwotasie Opmerking suksesvol Opdateer',0),(91739,2549,'ro','Comentariu de citat actualizat cu succes',0),(91740,2549,'et','Tsiteerides kommentaari vÃ¤rskendamine Ãµnnestus',0),(91741,2549,'si','Citiram komentar uspeÅ¡no posodobljena',0),(91742,2549,'ba','Mengutip komentar berhasil',0),(91743,2549,'nl','Quote Comment bijgewerkt',0),(91744,2549,'fi','Quote Kommentti pÃ¤ivitetty',0),(91745,2549,'no','Quote Comment oppdatert',0),(91746,2549,'da','Quote Comment opdateret',0),(91747,2549,'ko','ì¸ìš© ì½”ë©˜íŠ¸ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(91748,2549,'he','×ª×’×•×‘×” ×”×¦×¢×ª ×”×ž×—×™×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(91749,2549,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ ÏƒÏ‡ÏŒÎ»Î¹Î¿ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(91750,2549,'zh','æŠ¥ä»·è¯„è®ºæ›´æ–°æˆåŠŸ\r\n',0),(91751,2549,'sv','Quote Comment uppdaterats',0),(91752,2549,'it','Commento di preventivo aggiornato con successo',0),(91753,2549,'tl','',0),(91754,2549,'th','&#3649;&#3592;&#3657;&#3591;&#3588;&#3635;&#3605;&#3636;&#3594;&#3617;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(91755,2549,'hi','à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(91756,2549,'ms','Quote Comment yang berjaya dikemas kini',0),(91757,2549,'ar','Ø­Ø¯Ù‘Ø« ØªØ¹Ù‚ÙŠØ¨ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(91758,2549,'fr','Commentaire de citation correctement mis Ã  jour',0),(91759,2549,'jp','è¦‹ç©?ã‚‚ã‚Šã‚³ãƒ¡ãƒ³ãƒˆã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(91760,2549,'pt','Citar comentÃ¡rio atualizado com sucesso',0),(91761,2549,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(91762,2549,'es','Comentario de CotizaciÃ³n actualizado exitosamente',0),(91763,2549,'de','Quote Comment erfolgreich aktualisiert',0),(91764,2549,'en','Quote Comment updated successfully',0),(91765,2550,'is','',0),(91766,2550,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(91767,2550,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(91768,2550,'tr','Teklif tamamlandÄ±',0),(91769,2550,'pl','PeÅ‚nÄ… ofertÄ™',0),(91770,2550,'bg','ÐŸÑŠÐ»Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(91771,2550,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù…Ú©Ù…Ù„',0),(91772,2550,'sr','ÐšÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð° Ð¿Ð¾Ð½ÑƒÐ´Ð°',0),(91773,2550,'vi','HoÃ n táº¥t bÃ¡o giÃ¡',0),(91774,2550,'af','Kwotasie Voltooi',0),(91775,2550,'ro','Citat complet',0),(91776,2550,'et','Pakkumine lÃµpetatud',0),(91777,2550,'si','Ponudba popolna',0),(91778,2550,'ba','Kutipan lengkap',0),(91779,2550,'nl','Volledige offerte',0),(91780,2550,'fi','Tarjous valmis',0),(91781,2550,'no','Tilbud komplett',0),(91782,2550,'da','Tilbud komplet',0),(91783,2550,'ko','ê²¬ì  ì™„ë£Œ',0),(91784,2550,'he','×”×¦×¢×ª ×ž×—×™×¨ ×ž×œ××”',0),(91785,2550,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï€Î»Î®ÏÎ·',0),(91786,2550,'zh','æŠ¥ä»·å®Œæˆ\r\n',0),(91787,2550,'sv','Offert komplett',0),(91788,2550,'it','Citazione completa',0),(91789,2550,'tl','',0),(91790,2550,'th','&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(91791,2550,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(91792,2550,'ms','Sebut harga yang lengkap',0),(91793,2550,'ar','Ø§Ù‚ØªØ¨Ø§Ø³ ÙƒØ§Ù…Ù„',0),(91794,2550,'fr','Citation complÃ¨te',0),(91795,2550,'jp','è¦‹ç©?ã‚Šå®Œäº†',0),(91796,2550,'pt','CitaÃ§Ã£o completa',0),(91797,2550,'ru','ÐŸÐ¾Ð»Ð½Ð°Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(91798,2550,'es','CotizaciÃ³n Completa',0),(91799,2550,'de','Angebot komplett',0),(91800,2550,'en','Quote Complete',0),(91801,2551,'is','',0),(91802,2551,'dr','Ø­Ø°Ù Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(91803,2551,'pr','Ø­Ø°Ù Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(91804,2551,'tr','BaÅŸarÄ±yla silindi alÄ±ntÄ±',0),(91805,2551,'pl','Cytat przesâ”‚anie',0),(91806,2551,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(91807,2551,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø§Ù‚ØªØ¨Ø§Ø³',0),(91808,2551,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(91809,2551,'vi','XÃ³a bÃ¡o giÃ¡ thÃ nh cÃ´ng',0),(91810,2551,'af','Kwotasie suskesvol geskrap',0),(91811,2551,'ro','Citat eliminÄƒ cu succes',0),(91812,2551,'et','Hinnapakkumise edukalt kustutatud',0),(91813,2551,'si','Ponudbo uspeÅ¡no izbrisana',0),(91814,2551,'ba','Mengutip dihapus berhasil',0),(91815,2551,'nl','Offerte met succes verwijderd',0),(91816,2551,'fi','Lainaus poistettu',0),(91817,2551,'no','Tilbud slettet',0),(91818,2551,'da','Citat slettet',0),(91819,2551,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ëœ ì¸ìš©',0),(91820,2551,'he','×”×¦×¢×ª ×ž×—×™×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(91821,2551,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(91822,2551,'zh','æŠ¥ä»·åˆ é™¤æˆåŠŸ\r\n',0),(91823,2551,'sv','Citat raderades',0),(91824,2551,'it','Citazione eliminato con successo',0),(91825,2551,'tl','',0),(91826,2551,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(91827,2551,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¥€ à¤¬à¥‹à¤²à¥€',0),(91828,2551,'ms','Quote dihapuskan dengan jayanya',0),(91829,2551,'ar','Ø­Ø°Ù Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(91830,2551,'fr','Citation supprimÃ©e avec succÃ¨s',0),(91831,2551,'jp','è¦‹ç©?ã‚‚ã‚Šã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(91832,2551,'pt','CitaÃ§Ã£o apagada com sucesso',0),(91833,2551,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(91834,2551,'es','CotizaciÃ³n eliminada exitosamente',0),(91835,2551,'de','Zitat erfolgreich gelÃ¶scht',0),(91836,2551,'en','Quote deleted successfully',0),(91837,2552,'is','',0),(91838,2552,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†ÙŠØ³Øª ',0),(91839,2552,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†ÙŠØ³Øª ',0),(91840,2552,'tr','Teklif kimliÄŸi geÃ§ti',0),(91841,2552,'pl','Identyfikator oferty nie przeszedÅ‚',0),(91842,2552,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° id Ð½Ðµ Ðµ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ»',0),(91843,2552,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø´Ù†Ø§Ø®Øª Ù†ÛÛŒÚº Ú¯Ø²Ø±Ø§',0),(91844,2552,'sr','Ð˜Ð´ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾ÑˆÐ°Ð¾ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(91845,2552,'vi','BÃ¡o giÃ¡ id chÆ°a qua',0),(91846,2552,'af','Kwotasie id het nie geslaag',0),(91847,2552,'ro','ID-ul citat nu a trecut',0),(91848,2552,'et','Hinnapakkumise id pole lÃ¤binud',0),(91849,2552,'si','Id ni sprejel ponudbe',0),(91850,2552,'ba','Mengutip id tidak lulus',0),(91851,2552,'nl','Offerte-id niet doorgegeven',0),(91852,2552,'fi','TarjouspyynnÃ¶n tunnus ei',0),(91853,2552,'no','Sitat-IDen ikke bestÃ¥tt',0),(91854,2552,'da','Citat id ikke bestÃ¥et',0),(91855,2552,'ko','ê²¬ì  id ì „ë‹¬ ë˜ì§€',0),(91856,2552,'he','×ž×–×”×” ×”×¦×¢×ª ×ž×—×™×¨ ×œ× ×—×œ×¤×•',0),(91857,2552,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Ï„Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Î´ÎµÎ½',0),(91858,2552,'zh','æŠ¥ä»·ç¼–å·ä¸é€šè¿‡\r\n',0),(91859,2552,'sv','Offert-id inte klarat',0),(91860,2552,'it','Citazione id non superato',0),(91861,2552,'tl','',0),(91862,2552,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3609;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;',0),(91863,2552,'hi','à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤†à¤ˆà¤¡à¥€ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤°à¤¿à¤¤',0),(91864,2552,'ms','Nyatakan ID id yang tidak diluluskan',0),(91865,2552,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³ Ù„Ù… ÙŠØ¬ØªØ²',0),(91866,2552,'fr','Devis id ne pas passÃ©',0),(91867,2552,'jp','è¦‹ç©?ã‚‚ã‚ŠIDã?Œ',0),(91868,2552,'pt','CitaÃ§Ã£o id nÃ£o passada',0),(91869,2552,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° id Ð½Ðµ Ð¿Ñ€Ð¾ÑˆÐ»Ð¾',0),(91870,2552,'es','ID de cotizaciÃ³n no pasÃ³',0),(91871,2552,'de','Zitat-Id nicht Ã¼bergeben',0),(91872,2552,'en','Quote id not passed',0),(91873,2553,'is','',0),(91874,2553,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(91875,2553,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(91876,2553,'tr','AlÄ±ntÄ± deÄŸil kurmak',0),(91877,2553,'pl','Cytat, nie znaleziono',0),(91878,2553,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(91879,2553,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(91880,2553,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°',0),(91881,2553,'vi','KhÃ´ng tÃ¬m tháº¥y BÃ¡o giÃ¡ ',0),(91882,2553,'af','Kwotasie nie gevind',0),(91883,2553,'ro','Citat nu a fost gÄƒsit',0),(91884,2553,'et','Tsitaat ei leitud',0),(91885,2553,'si','Citat, ni mogoÄe najti',0),(91886,2553,'ba','Mengutip tidak ditemukan',0),(91887,2553,'nl','Citeer niet gevonden',0),(91888,2553,'fi','Lainaus ei lÃ¶ydy',0),(91889,2553,'no','Sitere ikke funnet',0),(91890,2553,'da','Citere ikke fundet',0),(91891,2553,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” ì¸ìš©',0),(91892,2553,'he','×¦×™×˜×•×˜ ×œ× × ×ž×¦×',0),(91893,2553,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(91894,2553,'zh','æŠ¥ä»·æ²¡æœ‰æ‰¾åˆ°\r\n',0),(91895,2553,'sv','Citera hittades inte',0),(91896,2553,'it','Citazione non trovato',0),(91897,2553,'tl','',0),(91898,2553,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(91899,2553,'hi','à¤¬à¥‹à¤²à¥€ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(91900,2553,'ms','Sebut harga tidak dijumpai',0),(91901,2553,'ar','Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(91902,2553,'fr','Cite introuvable',0),(91903,2553,'jp','è¦‹ç©?ã‚‚ã‚Šã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(91904,2553,'pt','Citar nÃ£o encontrado',0),(91905,2553,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(91906,2553,'es','CotizaciÃ³n no se encontrÃ³',0),(91907,2553,'de','Zitat nicht gefunden',0),(91908,2553,'en','Quote not found',0),(91909,2554,'is','',0),(91910,2554,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(91911,2554,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(91912,2554,'tr','Not alÄ±ntÄ±',0),(91913,2554,'pl','Uwaga cytat',0),(91914,2554,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(91915,2554,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†ÙˆÙ¹',0),(91916,2554,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(91917,2554,'vi','Ghi chÃº BÃ¡o giÃ¡',0),(91918,2554,'af','Kwotasie Nota',0),(91919,2554,'ro','Nota citat',0),(91920,2554,'et','Hinnapakkumise MÃ¤rkus',0),(91921,2554,'si','Opomba quote',0),(91922,2554,'ba','Catatan Penawaran',0),(91923,2554,'nl','Offerte Opmerking',0),(91924,2554,'fi','Lainaus Huomautus',0),(91925,2554,'no','Merk sitat',0),(91926,2554,'da','Citat BemÃ¦rk',0),(91927,2554,'ko','ê²¬ì  ì°¸ê³ ',0),(91928,2554,'he','×”×¢×¨×” ×¦×™×˜×•×˜',0),(91929,2554,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(91930,2554,'zh','æŠ¥ä»·è¯´æ˜Ž\r\n',0),(91931,2554,'sv','Citat Obs',0),(91932,2554,'it','Citazione nota',0),(91933,2554,'tl','',0),(91934,2554,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(91935,2554,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤¨à¥‹à¤Ÿ',0),(91936,2554,'ms','Petikan Nota',0),(91937,2554,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(91938,2554,'fr','Note de citation',0),(91939,2554,'jp','è¦‹ç©?ã‚‚ã‚Šãƒ¡ãƒ¢',0),(91940,2554,'pt','Nota de citaÃ§Ã£o',0),(91941,2554,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(91942,2554,'es','Nota de CotizaciÃ³n',0),(91943,2554,'de','Hinweis zu zitieren',0),(91944,2554,'en','Quote Note',0),(91945,2555,'is','',0),(91946,2555,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(91947,2555,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(91948,2555,'tr','Quote not bulunamadÄ±.',0),(91949,2555,'pl','Cytat nie znalezione.',0),(91950,2555,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ð±ÐµÐ»ÐµÐ¶ÐºÐ° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(91951,2555,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†ÙˆÙ¹ Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(91952,2555,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ð¿Ð¾Ñ€ÑƒÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°.',0),(91953,2555,'vi','KhÃ´ng tÃ¬m tháº¥y ghi chÃº BÃ¡o giÃ¡ ',0),(91954,2555,'af','Kwotasie Nota nie gevind.',0),(91955,2555,'ro','Cita notÄƒ nu a fost gÄƒsit.',0),(91956,2555,'et','Tsitaat mÃ¤rkus ei leitud.',0),(91957,2555,'si','Citiram Opomba ni mogoÄe najti.',0),(91958,2555,'ba','Mengutip catatan tidak ditemukan.',0),(91959,2555,'nl','Citeer opmerking niet gevonden.',0),(91960,2555,'fi','Lainaus huomautus ei lÃ¶ydy.',0),(91961,2555,'no','Sitat ikke funnet.',0),(91962,2555,'da','Citere ikke fundet.',0),(91963,2555,'ko','ì°¸ê³  ì°¾ì„ ìˆ˜ ì—†ëŠ” ì¸ìš©.',0),(91964,2555,'he','×¦×™×˜×•×˜ ×”×¢×¨×” ×œ× × ×ž×¦×.',0),(91965,2555,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï„Î· ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ· Ï€Î¿Ï… Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(91966,2555,'zh','æŠ¥ä»·è¯´æ˜Žæ²¡æœ‰æ‰¾åˆ°ã€‚\r\n',0),(91967,2555,'sv','Citera Obs hittades inte.',0),(91968,2555,'it','Citazione nota non trovato.',0),(91969,2555,'tl','',0),(91970,2555,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(91971,2555,'hi','à¤¬à¥‹à¤²à¥€ à¤¨à¥‹à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(91972,2555,'ms','Sebut harga nota yang tidak dijumpai.',0),(91973,2555,'ar','Ø§Ù‚ØªØ¨Ø³ Ø¹Ù„Ù…Ø§ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(91974,2555,'fr','Cite Note introuvable.',0),(91975,2555,'jp','è¦‹ç©?ã‚‚ã‚Šãƒ¡ãƒ¢ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(91976,2555,'pt','Cite a nota nÃ£o foi encontrada.',0),(91977,2555,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÐºÐ¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.',0),(91978,2555,'es','Nota de CotizaciÃ³n no se encontrÃ³',0),(91979,2555,'de','Zitat nicht gefunden.',0),(91980,2555,'en','Quote Note not found.',0),(91981,2556,'is','',0),(91982,2556,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(91983,2556,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(91984,2556,'tr','TÄ±rnak notlarÄ± ekle',0),(91985,2556,'pl','Oferty Dodaj notatki',0),(91986,2556,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(91987,2556,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: Ù†ÙˆÙ¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(91988,2556,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ñƒ Ð·Ð° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(91989,2556,'vi','ThÃªm ghi chÃº BÃ¡o giÃ¡',0),(91990,2556,'af','Kwotasie Notas Skep',0),(91991,2556,'ro','Citat adÄƒuga note',0),(91992,2556,'et','Tsitaat mÃ¤rkmete lisamine',0),(91993,2556,'si','Ponudbo dodali opombe',0),(91994,2556,'ba','Kutipan menambahkan catatan',0),(91995,2556,'nl','Citaat toevoegen notities',0),(91996,2556,'fi','Lainaus toteaa lisÃ¤Ã¤',0),(91997,2556,'no','Sitat legge notater',0),(91998,2556,'da','Citat tilfÃ¸je noter',0),(91999,2556,'ko','ë…¸íŠ¸ ì¶”ê°€ ê²¬ì ',0),(92000,2556,'he','×¦×™×˜×•×˜ ×œ×”×•×¡×™×£ ×”×¢×¨×•×ª',0),(92001,2556,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(92002,2556,'zh','æŠ¥ä»·è¯´æ˜Žæ·»åŠ \r\n',0),(92003,2556,'sv','Citat anteckningar lÃ¤gga till',0),(92004,2556,'it','Citazione aggiungere note',0),(92005,2556,'tl','',0),(92006,2556,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(92007,2556,'hi','à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(92008,2556,'ms','Petikan Nota Tambah',0),(92009,2556,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ',0),(92010,2556,'fr','Citation ajouter des Notes',0),(92011,2556,'jp','è¦‹ç©?ã‚‚ã‚Šãƒ¡ãƒ¢ã?®è¿½åŠ ',0),(92012,2556,'pt','Abre aspas adicionar notas',0),(92013,2556,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(92014,2556,'es','Notas de CotizaciÃ³n Agregar',0),(92015,2556,'de','Zitat hinzufÃ¼gen Notizen',0),(92016,2556,'en','Quote Notes Add',0),(92017,2557,'is','',0),(92018,2557,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(92019,2557,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(92020,2557,'tr','AlÄ±ntÄ± notlar baÅŸarÄ±yla eklendi.',0),(92021,2557,'pl','Cytat notatki dodane pomyÅ›lnie.',0),(92022,2557,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(92023,2557,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†ÙˆÙ¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(92024,2557,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(92025,2557,'vi','ThÃªm ghi chÃº BÃ¡o giÃ¡ thÃ nh cÃ´ng',0),(92026,2557,'af','Kwotasie Notas suksesvol geskep',0),(92027,2557,'ro','Note de citat adÄƒugat cu succes.',0),(92028,2557,'et','Hinnapakkumise mÃ¤rgib edukalt lisatud.',0),(92029,2557,'si','Citat ugotavlja uspeÅ¡no dodana.',0),(92030,2557,'ba','Kutipan catatan ditambahkan berhasil.',0),(92031,2557,'nl','Offerte notities toegevoegd.',0),(92032,2557,'fi','Lainaus toteaa lisÃ¤Ã¤minen onnistui.',0),(92033,2557,'no','Tilbud merknader lagt.',0),(92034,2557,'da','Citat noter tilfÃ¸jet.',0),(92035,2557,'ko','ê²¬ì  ë…¸íŠ¸ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(92036,2557,'he','×”×¢×¨×•×ª ×œ×”×¦×¢×ª ×ž×—×™×¨ × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(92037,2557,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(92038,2557,'zh','æŠ¥ä»·è¯´æ˜Žæ·»åŠ æˆåŠŸã€‚\r\n',0),(92039,2557,'sv','Citat anteckningar lagts.',0),(92040,2557,'it','Citazione note aggiunte con successo.',0),(92041,2557,'tl','',0),(92042,2557,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(92043,2557,'hi','à¤¬à¥‹à¤²à¥€ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(92044,2557,'ms','Petikan Nota-nota yang berjaya menambah.',0),(92045,2557,'ar','Ø£Ø¶ÙŠÙØª Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(92046,2557,'fr','Notes de citation ajoutÃ©s avec succÃ¨s.',0),(92047,2557,'jp','è¦‹ç©?ã‚‚ã‚Šãƒ¡ãƒ¢ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(92048,2557,'pt','Notas de citaÃ§Ã£o adicionadas com Ãªxito.',0),(92049,2557,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð¾Ñ‚Ð¼ÐµÑ‡Ð°ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(92050,2557,'es','Notas de CotizaciÃ³n agregada exitosamente',0),(92051,2557,'de','Zitat Notes erfolgreich hinzugefÃ¼gt.',0),(92052,2557,'en','Quote Notes added successfully.',0),(92053,2558,'is','',0),(92054,2558,'dr','Ø­Ø°Ù  ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(92055,2558,'pr','Ø­Ø°Ù  ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(92056,2558,'tr','AlÄ±ntÄ± notlar baÅŸarÄ±yla silindi.',0),(92057,2558,'pl','Notatki wycenÄ™ usuniÄ™te pomyÅ›lnie.',0),(92058,2558,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(92059,2558,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†ÙˆÙ¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(92060,2558,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(92061,2558,'vi','XÃ³a ghi chÃº BÃ¡o giÃ¡ thÃ nh cÃ´ng',0),(92062,2558,'af','Kwotasie Notas suksesvol geskrap',0),(92063,2558,'ro','Citat note ÅŸters cu succes.',0),(92064,2558,'et','Hinnapakkumise mÃ¤rgib edukalt kustutatud.',0),(92065,2558,'si','Citat ugotavlja uspeÅ¡no izbrisana.',0),(92066,2558,'ba','Kutipan catatan dihapus berhasil.',0),(92067,2558,'nl','Offerte notities verwijderd.',0),(92068,2558,'fi','Lainaus toteaa poistettu.',0),(92069,2558,'no','Tilbud notater slettet.',0),(92070,2558,'da','Citat noter slettet.',0),(92071,2558,'ko','ê²¬ì  ë…¸íŠ¸ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(92072,2558,'he','×”×¢×¨×•×ª ×œ×”×¦×¢×ª ×ž×—×™×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(92073,2558,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(92074,2558,'zh','æŠ¥ä»·è¯´æ˜Žåˆ é™¤æˆåŠŸã€‚\r\n',0),(92075,2558,'sv','Citat anteckningar raderades.',0),(92076,2558,'it','Note citazione eliminate con successo.',0),(92077,2558,'tl','',0),(92078,2558,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(92079,2558,'hi','à¤¬à¥‹à¤²à¥€ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(92080,2558,'ms','Petikan Nota-nota yang dihapuskan dengan jayanya.',0),(92081,2558,'ar','Ø­Ø°ÙØª Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(92082,2558,'fr','Notes de citation supprimÃ©s avec succÃ¨s.',0),(92083,2558,'jp','è¦‹ç©?ã‚‚ã‚Šãƒ¡ãƒ¢ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(92084,2558,'pt','Notas de citaÃ§Ã£o excluÃ­das com sucesso.',0),(92085,2558,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð¾Ñ‚Ð¼ÐµÑ‡Ð°ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(92086,2558,'es','Notas de CotizaciÃ³n eliminada exitosamente',0),(92087,2558,'de','Zitat Notes erfolgreich gelÃ¶scht.',0),(92088,2558,'en','Quote Notes deleted successfully.',0),(92089,2559,'is','',0),(92090,2559,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(92091,2559,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(92092,2559,'tr','Not gÃ¼ncelleÅŸtirme alÄ±ntÄ±',0),(92093,2559,'pl','Cytat aktualizacja notatki',0),(92094,2559,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(92095,2559,'ur','Ù†ÙˆÙ¹ ØªØ¬Ø¯ÛŒØ¯ Ø§Ù‚ØªØ¨Ø§Ø³',0),(92096,2559,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(92097,2559,'vi','Cáº­p Nháº­t Ghi ChÃº Vá» BÃ¡o GiÃ¡',0),(92098,2559,'af','Kwotasie Notas Opdateer',0),(92099,2559,'ro','Cita notele de actualizare',0),(92100,2559,'et','Tsitaat mÃ¤rgib Update',0),(92101,2559,'si','Citiram opombe modernizirati',0),(92102,2559,'ba','Mengutip catatan Update',0),(92103,2559,'nl','Citeer notities Update',0),(92104,2559,'fi','Lainaus toteaa pÃ¤ivitys',0),(92105,2559,'no','Sitere notater oppdatering',0),(92106,2559,'da','Citere noter opdatering',0),(92107,2559,'ko','ì¸ìš© ë…¸íŠ¸ ì—…ë°ì´íŠ¸',0),(92108,2559,'he','×”×¦×¢×ª ×ž×—×™×¨ ×¢×“×›×•×Ÿ ×”×¢×¨×•×ª',0),(92109,2559,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(92110,2559,'zh','æŠ¥ä»·è¯´æ˜Žæ›´æ–°\r\n',0),(92111,2559,'sv','Citera anteckningar uppdatering',0),(92112,2559,'it','Citare le note di aggiornamento',0),(92113,2559,'tl','',0),(92114,2559,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;',0),(92115,2559,'hi','à¤¨à¥‹à¤Ÿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¬à¥‹à¤²à¥€',0),(92116,2559,'ms','Sebut harga kemas kini Nota-Nota',0),(92117,2559,'ar','Ø§Ù‚ØªØ¨Ø³ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(92118,2559,'fr','Cite des informations sur la mise Ã  jour',0),(92119,2559,'jp','è¦‹ç©?ã‚‚ã‚Šãƒ¡ãƒ¢ã?®æ›´æ–°',0),(92120,2559,'pt','AtualizaÃ§Ã£o de notas de citaÃ§Ã£o',0),(92121,2559,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€ÑƒÑŽ Ð¾Ñ‚Ð¼ÐµÑ‡Ð°ÐµÑ‚ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(92122,2559,'es','Notas de CotizaciÃ³n Actualizar',0),(92123,2559,'de','Zitat von Notes Update',0),(92124,2559,'en','Quote Notes Update',0),(92125,2560,'is','',0),(92126,2560,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(92127,2560,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(92128,2560,'tr','Quote Not baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(92129,2560,'pl','Notatki wycenÄ™ pomyÅ›lnie zaktualizowana.',0),(92130,2560,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(92131,2560,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†ÙˆÙ¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(92132,2560,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(92133,2560,'vi','Cáº­p Nháº­t Ghi ChÃº Vá» BÃ¡o GiÃ¡ thÃ nh cÃ´ng',0),(92134,2560,'af','Kwotasie Notas suksesvol opdateer.',0),(92135,2560,'ro','Citat note actualizat cu succes.',0),(92136,2560,'et','Hinnapakkumise mÃ¤rgib vÃ¤rskendamine Ãµnnestus.',0),(92137,2560,'si','Citat ugotavlja uspeÅ¡no posodobljena.',0),(92138,2560,'ba','Catatan Penawaran diperbarui berhasil.',0),(92139,2560,'nl','Offerte notities bijgewerkt.',0),(92140,2560,'fi','Lainaus toteaa pÃ¤ivitettiin onnistuneesti.',0),(92141,2560,'no','Tilbud notater oppdatert.',0),(92142,2560,'da','Citat noter opdateret.',0),(92143,2560,'ko','ê²¬ì  ë…¸íŠ¸ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(92144,2560,'he','×”×¢×¨×•×ª ×œ×”×¦×¢×ª ×ž×—×™×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(92145,2560,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(92146,2560,'zh','æŠ¥ä»·è¯´æ˜Žæ›´æ–°æˆåŠŸ',0),(92147,2560,'sv','Citat anteckningar uppdaterats.',0),(92148,2560,'it','Note citazione aggiornate con successo.',0),(92149,2560,'tl','',0),(92150,2560,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(92151,2560,'hi','à¤¬à¥‹à¤²à¥€ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(92152,2560,'ms','Petikan Nota-nota yang berjaya dikemas kini.',0),(92153,2560,'ar','Ø­Ø¯Ù‘Ø«Øª Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(92154,2560,'fr','Citation Notes de mise Ã  jour avec succÃ¨s.',0),(92155,2560,'jp','è¦‹ç©?ã‚‚ã‚Šãƒ¡ãƒ¢ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(92156,2560,'pt','Notas de citaÃ§Ã£o atualizadas com Ãªxito.',0),(92157,2560,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð¾Ñ‚Ð¼ÐµÑ‡Ð°ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(92158,2560,'es','Notas de CotizaciÃ³n actualizada exitosamente',0),(92159,2560,'de','Zitat Notes erfolgreich aktualisiert.',0),(92160,2560,'en','Quote Notes updated successfully.',0),(92161,2561,'is','',0),(92162,2561,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(92163,2561,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(92164,2561,'tr','Teklif #',0),(92165,2561,'pl','Cytat #',0),(92166,2561,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° #',0),(92167,2561,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ #',0),(92168,2561,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ #',0),(92169,2561,'vi','BÃ¡o giÃ¡ sá»‘',0),(92170,2561,'af','Kwotasie #',0),(92171,2561,'ro','Citat #',0),(92172,2561,'et','Tsiteeri #',0),(92173,2561,'si','Citiram #',0),(92174,2561,'ba','Mengutip #',0),(92175,2561,'nl','Citeer #',0),(92176,2561,'fi','Lainata #',0),(92177,2561,'no','Sitere #',0),(92178,2561,'da','Citere #',0),(92179,2561,'ko','# ì¸ìš©',0),(92180,2561,'he','×¦×™×˜×•×˜ #',0),(92181,2561,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ #',0),(92182,2561,'zh','æŠ¥ä»·ï¼ƒ\r\n',0),(92183,2561,'sv','Citera #',0),(92184,2561,'it','Citazione #',0),(92185,2561,'tl','',0),(92186,2561,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;',0),(92187,2561,'hi','à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ #',0),(92188,2561,'ms','Quote #',0),(92189,2561,'ar','Ø¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ Ø±Ù‚Ù… ',0),(92190,2561,'fr','Cite #',0),(92191,2561,'jp','è¦‹ç©?ã‚‚ã‚Šç•ªå?·',0),(92192,2561,'pt','CitaÃ§Ã£o #',0),(92193,2561,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° #',0),(92194,2561,'es','CotizaciÃ³n #',0),(92195,2561,'de','Zitat #',0),(92196,2561,'en','Quote #',0),(92197,2562,'is','',0),(92198,2562,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ØªÙ‡ÙŠÙ‡ Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(92199,2562,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ØªÙ‡ÙŠÙ‡ Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(92200,2562,'tr','TarafÄ±ndan saÄŸlanan alÄ±ntÄ±',0),(92201,2562,'pl','Oferta Å›wiadczonych przez',0),(92202,2562,'bg','Ð¦Ð¸Ñ‚Ð°Ñ‚ Ð¾Ñ‚',0),(92203,2562,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ÙØ±Ø§ÛÙ… Ú©ÛŒ',0),(92204,2562,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ðµ ÐºÐ¾Ñ˜Ðµ ÑÑ‚Ðµ Ð´Ð¾Ð±Ð¸Ð»Ð¸ Ð¾Ð´',0),(92205,2562,'vi','BÃ¡o giÃ¡ cung cáº¥p bá»Ÿi',0),(92206,2562,'af','Kwotasie Verskaf Deur',0),(92207,2562,'ro','Citat de',0),(92208,2562,'et','Pakkumise poolt',0),(92209,2562,'si','Ponudbe, ki jih',0),(92210,2562,'ba','Kutipan yang disediakan oleh',0),(92211,2562,'nl','Geboden door: offerte',0),(92212,2562,'fi','Tarjouksen esittÃ¤nyt',0),(92213,2562,'no','Sitat fra',0),(92214,2562,'da','Citat fra',0),(92215,2562,'ko','ê²¬ì  ì œê³µ',0),(92216,2562,'he','×”×¦×¢×ª ×”×ž×—×™×¨ ×©×¡×•×¤×§×• ×¢×œ-×™×“×™',0),(92217,2562,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Ï€Î¿Ï… Ï€Î±ÏÎ­Ï‡Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ',0),(92218,2562,'zh','æä¾›æŠ¥ä»·\r\n',0),(92219,2562,'sv','Citat frÃ¥n',0),(92220,2562,'it','Citazione fornito da',0),(92221,2562,'tl','',0),(92222,2562,'th','&#3651;&#3610;&#3648;&#3626;&#3609;&#3629;&#3619;&#3634;&#3588;&#3634;&#3650;&#3604;&#3618;',0),(92223,2562,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥à¤°à¤¦à¤¾à¤¨ à¤•à¥€',0),(92224,2562,'ms','Petikan yang disediakan oleh',0),(92225,2562,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ù…Ù‚Ø¯Ù…Ø© Ù…Ù†',0),(92226,2562,'fr','Devis fournis par',0),(92227,2562,'jp','è¦‹ç©?ã‚‚ã‚Šè€…',0),(92228,2562,'pt','CitaÃ§Ã£o fornecida pelo',0),(92229,2562,'ru','ÐŸÑ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÑÐµÐ¼Ð¾Ð¹ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(92230,2562,'es','CotizaciÃ³n Proporcionada Por',0),(92231,2562,'de','Zitat von bereitgestellten',0),(92232,2562,'en','Quote Provided By',0),(92233,2563,'is','',0),(92234,2563,'dr','Ø¬Ø¯ÙˆÙ„ ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(92235,2563,'pr','Ø¬Ø¯ÙˆÙ„ ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(92236,2563,'tr','AlÄ±ntÄ± yorum tablosu',0),(92237,2563,'pl','Cytat komentarz tabeli',0),(92238,2563,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(92239,2563,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ ØªØ¨ØµØ±Û Ø¬Ø¯ÙˆÙ„',0),(92240,2563,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(92241,2563,'vi','Báº£ng Ä‘Ã¡nh giÃ¡ bÃ¡o giÃ¡',0),(92242,2563,'af','Aanhaling kommentaar tabel',0),(92243,2563,'ro','Tabel de comentariu citat',0),(92244,2563,'et','Quote Comment tabel',0),(92245,2563,'si','Citiram komentar tabele',0),(92246,2563,'ba','Mengutip komentar tabel',0),(92247,2563,'nl','Offerte commentaar tabel',0),(92248,2563,'fi','Lainaus kommenttitaulu',0),(92249,2563,'no','Tilbud Merknad-tabellen',0),(92250,2563,'da','Citat bemÃ¦rkningstabellen',0),(92251,2563,'ko','ì¸ìš© ì½”ë©˜íŠ¸ í…Œì´ë¸”',0),(92252,2563,'he','×¦×™×˜×•×˜ ×ª×’×•×‘×” ×˜×‘×œ×”',0),(92253,2563,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï„Î¿ ÏƒÏ‡ÏŒÎ»Î¹Î¿ Ï„Î¿Ï… Ï€Î¯Î½Î±ÎºÎ±',0),(92254,2563,'zh','è¯„è®ºæŠ¥ä»·è¡¨\r\n',0),(92255,2563,'sv','Citera kommentar tabell',0),(92256,2563,'it','Citazione commento tabella',0),(92257,2563,'tl','',0),(92258,2563,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3588;&#3635;&#3605;&#3636;&#3594;&#3617;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(92259,2563,'hi','à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(92260,2563,'ms','Quote komen Jadual',0),(92261,2563,'ar','Ø¬Ø¯ÙˆÙ„ ØªØ¹Ù‚ÙŠØ¨Ø§Øª Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(92262,2563,'fr','Citation commentaire Table',0),(92263,2563,'jp','ã‚³ãƒ¡ãƒ³ãƒˆè¡¨ã?®è¦‹ç©?',0),(92264,2563,'pt','Tabela do comentÃ¡rio de citaÃ§Ã£o',0),(92265,2563,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(92266,2563,'es','Tabla de Comentarios de la CotizaciÃ³n',0),(92267,2563,'de','Zitat von Kommentar-Tabelle',0),(92268,2563,'en','Quote Comment Table',0),(92269,2564,'is','',0),(92270,2564,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ØªÙˆØ³Ø·',0),(92271,2564,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ØªÙˆØ³Ø·',0),(92272,2564,'tr','AlÄ±ntÄ±',0),(92273,2564,'pl','Cytowany przez',0),(92274,2564,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð½ Ð¾Ñ‚',0),(92275,2564,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¨ÛŒØ§Ù† Ú©Û’ Ø­ÙˆØ§Ù„Û’ Ø³Û’',0),(92276,2564,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°',0),(92277,2564,'vi','BÃ¡o giÃ¡ bá»Ÿi',0),(92278,2564,'af','Gekwoteer deur',0),(92279,2564,'ro','Citat de',0),(92280,2564,'et','Noteeringu jÃ¤rgi',0),(92281,2564,'si','Citiral',0),(92282,2564,'ba','Dikutip oleh',0),(92283,2564,'nl','Geciteerd door',0),(92284,2564,'fi','Mainitsemat',0),(92285,2564,'no','Sitert av',0),(92286,2564,'da','Citeret af',0),(92287,2564,'ko','ì— ì˜í•´ ì¸ìš©',0),(92288,2564,'he','×ž×¦×•×˜×˜ ×¢×œ ×™×“×™',0),(92289,2564,'el','Î‘Î½Î±Ï†Î­ÏÎµÏ„Î±Î¹ Î±Ï€ÏŒ',0),(92290,2564,'zh','å¼•è¿°\r\n',0),(92291,2564,'sv','Citerat av',0),(92292,2564,'it','Citato da',0),(92293,2564,'tl','',0),(92294,2564,'th','&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3649;&#3621;&#3657;&#3623;&#3650;&#3604;&#3618;',0),(92295,2564,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‰à¤¦à¥à¤§à¥ƒà¤¤',0),(92296,2564,'ms','Disebut oleh',0),(92297,2564,'ar','ÙˆÙ†Ù‚Ù„Øª Ø¹Ù†',0),(92298,2564,'fr','CitÃ© par',0),(92299,2564,'jp','è¦‹ç©?æ›¸',0),(92300,2564,'pt','Citado por',0),(92301,2564,'ru','ÐŸÑ€Ð¾Ñ†Ð¸Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¾',0),(92302,2564,'es','Cotizado por',0),(92303,2564,'de','Zitiert nach',0),(92304,2564,'en','Quoted by',0),(92305,2565,'is','',0),(92306,2565,'dr','(Ø³Ø±Ø¹Øª',0),(92307,2565,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª',0),(92308,2565,'tr','OranÄ±',0),(92309,2565,'pl','Stawki',0),(92310,2565,'bg','ÐšÑƒÑ€Ñ',0),(92311,2565,'ur','Ø´Ø±Ø­',0),(92312,2565,'sr','Ð¡Ñ‚Ð¾Ð¿Ð°',0),(92313,2565,'vi','GiÃ¡',0),(92314,2565,'af','Tarief',0),(92315,2565,'ro','Rata',0),(92316,2565,'et','MÃ¤Ã¤r',0),(92317,2565,'si','Stopnja',0),(92318,2565,'ba','Tingkat',0),(92319,2565,'nl','Tarief',0),(92320,2565,'fi','Korko',0),(92321,2565,'no','Rate',0),(92322,2565,'da','Sats',0),(92323,2565,'ko','ì†ë„',0),(92324,2565,'he','×§×¦×‘',0),(92325,2565,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(92326,2565,'zh','çŽ‡\r\n',0),(92327,2565,'sv','RÃ¤nta',0),(92328,2565,'it','Tasso',0),(92329,2565,'tl','',0),(92330,2565,'th','&#3629;&#3633;&#3605;&#3619;&#3634;',0),(92331,2565,'hi','à¤¦à¤°',0),(92332,2565,'ms','Kadar',0),(92333,2565,'ar','Ù…Ø¹Ø¯Ù„',0),(92334,2565,'fr','Taux',0),(92335,2565,'jp','æ–™é‡‘',0),(92336,2565,'pt','Taxa de',0),(92337,2565,'ru','ÐšÑƒÑ€Ñ',0),(92338,2565,'es','Tasa/Tarifa',0),(92339,2565,'de','Preis',0),(92340,2565,'en','Rate',0),(92341,2566,'is','',0),(92342,2566,'dr','Ø³Ø±Ø¹Øª Ø§Ø¬Ø±Ø§ ',0),(92343,2566,'pr','Ø³Ø±Ø¹Øª Ø§Ø¬Ø±Ø§ ',0),(92344,2566,'tr','Ã‡alÄ±ÅŸma hÄ±zÄ±',0),(92345,2566,'pl','SzybkoÅ›Ä‡ wykonywania',0),(92346,2566,'bg','Ð¡ÐºÐ¾Ñ€Ð¾ÑÑ‚ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(92347,2566,'ur','Ø´Ø±Ø­ Ù…ÛŒÚº Ú†Ù„Ù†Û’',0),(92348,2566,'sr','ÐžÑ†ÐµÐ½Ð¸Ñ‚Ðµ Ð¸Ð·Ð²Ð¾Ñ’ÐµÑšÐ°',0),(92349,2566,'vi','Cháº¡y giÃ¡',0),(92350,2566,'af','Tarief Loopkoste',0),(92351,2566,'ro','Rata Run',0),(92352,2566,'et','Kiirus joosta',0),(92353,2566,'si','Stopnja Run',0),(92354,2566,'ba','Menilai menjalankan',0),(92355,2566,'nl','Tarief Run',0),(92356,2566,'fi','Nopeus Run',0),(92357,2566,'no','Rate kjÃ¸re',0),(92358,2566,'da','Vurder kÃ¸re',0),(92359,2566,'ko','ì†ë„ ì‹¤í–‰',0),(92360,2566,'he','×©×™×¢×•×¨ ×‘× ×™×”×•×œ',0),(92361,2566,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎµÎºÏ„Î­Î»ÎµÏƒÎ·Ï‚',0),(92362,2566,'zh','æ¯”çŽ‡è¿è¡Œ\r\n',0),(92363,2566,'sv','BetygsÃ¤tt kÃ¶r',0),(92364,2566,'it','Tasso Run',0),(92365,2566,'tl','',0),(92366,2566,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3585;&#3634;&#3619;&#3648;&#3604;&#3636;&#3609;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;',0),(92367,2566,'hi','à¤¦à¤° à¤°à¤¨',0),(92368,2566,'ms','Dikendalikan oleh kadar',0),(92369,2566,'ar','Ù…Ø¹Ø¯Ù„ ØªØ´ØºÙŠÙ„',0),(92370,2566,'fr','Taux Run',0),(92371,2566,'jp','å®Ÿæ–½æ–™é‡‘',0),(92372,2566,'pt','ExecuÃ§Ã£o de taxa',0),(92373,2566,'ru','Ð¡ÐºÐ¾Ñ€Ð¾ÑÑ‚ÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(92374,2566,'es','Velocidad de ImpresiÃ³n',0),(92375,2566,'de','Bewerten Sie laufen',0),(92376,2566,'en','Rate Run',0),(92377,2567,'is','',0),(92378,2567,'dr','Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯Ù‰',0),(92379,2567,'pr','Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯Ù‰',0),(92380,2567,'tr','Derecelendirme Ã¶lÃ§eÄŸi',0),(92381,2567,'pl','Skala ocen',0),(92382,2567,'bg','Ð¡ÐºÐ°Ð»Ð° Ð·Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(92383,2567,'ur','Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©Û’ Ù¾ÛŒÙ…Ø§Ù†Û’',0),(92384,2567,'sr','Ð¡ÐºÐ°Ð»Ð°',0),(92385,2567,'vi','Cáº¥p báº­c giÃ¡',0),(92386,2567,'af','Tariewe Skaal',0),(92387,2567,'ro','Scala de evaluare',0),(92388,2567,'et','Skaala',0),(92389,2567,'si','Ocenjevalna lestvica',0),(92390,2567,'ba','Skala rating',0),(92391,2567,'nl','Beoordelingsschaal',0),(92392,2567,'fi','Arviointiasteikko',0),(92393,2567,'no','Vurderingsskala',0),(92394,2567,'da','BedÃ¸mmelsesskala',0),(92395,2567,'ko','í‰ê°€ ì²™ë„',0),(92396,2567,'he','×¡×•×œ× ×“×™×¨×•×’',0),(92397,2567,'el','ÎšÎ»Î¯Î¼Î±ÎºÎ± Î²Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î±Ï‚',0),(92398,2567,'zh','è¯„å®šé‡è¡¨\r\n',0),(92399,2567,'sv','Skattningsskala',0),(92400,2567,'it','Scala di valutazione',0),(92401,2567,'tl','',0),(92402,2567,'th','&#3626;&#3648;&#3585;&#3621;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;',0),(92403,2567,'hi','à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¸à¥à¤•à¥‡à¤²',0),(92404,2567,'ms','Skala penilaian',0),(92405,2567,'ar','Ù…Ù‚ÙŠØ§Ø³ Ø§Ù„ØªØµÙ†ÙŠÙ',0),(92406,2567,'fr','Ã‰chelle de cotation',0),(92407,2567,'jp','è©•å®šå°ºåº¦',0),(92408,2567,'pt','Escala de classificaÃ§Ã£o',0),(92409,2567,'ru','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³Ð¾Ð²Ð°Ñ ÑˆÐºÐ°Ð»Ð°',0),(92410,2567,'es','Escala de CategorÃ­a',0),(92411,2567,'de','Rating-Skala',0),(92412,2567,'en','Rating Scale',0),(92413,2568,'is','',0),(92414,2568,'dr','(Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø³Ø§Ø¹Øª) Ø§ÙŠÙ†Ú† . Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø±  Ht. ',0),(92415,2568,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø³Ø§Ø¹Øª) Ø§ÙŠÙ†Ú† . Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø±  Ht. ',0),(92416,2568,'tr','Ä°nÃ§ Ht. basÄ±n miktar oranÄ±',0),(92417,2568,'pl','OceÅ„ razy iloÅ›Ä‡ cale Ht. Press',0),(92418,2568,'bg','ÐžÑ†ÐµÐ½Ð¸Ñ‚Ðµ Ð¿ÑŠÑ‚Ð¸ Ð¸Ð½Ñ‡Ð° Ht. Ð½Ð°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÐºÐ¾Ð»',0),(92419,2568,'ur','Ø§Ù†Ú† Ø§ÛŒÚ† Ù¹ÛŒ Û” Ù¾Ø±ÛŒØ³ Ù‚ÛŒ Ø§ÙˆÙ‚Ø§Øª Ú©ÛŒ Ø´Ø±Ø­',0),(92420,2568,'sr','ÐžÑ†ÐµÐ½Ð¸Ñ‚Ðµ Ð¿ÑƒÑ‚Ð° Ð¸Ð½Ñ‡Ð° Ð¥Ñ‚. ÐŸÑ€ÐµÑÑ ÐšÐ¾Ð».',0),(92421,2568,'vi','Biá»ƒu giÃ¡ thá»i gian chiá»u cao inches Sá»‘ lÆ°á»£ng In',0),(92422,2568,'af','Bepaal tye Duime Ht. Drukpers Hoev.',0),(92423,2568,'ro','Rata ori inci Ht. apÄƒsaÅ£i cantit',0),(92424,2568,'et','Hinnake alati tolli Ht. Press kogus',0),(92425,2568,'si','Ocenite krat koliÄina palcev Ht. Press',0),(92426,2568,'ba','Menilai kali inci Ht. Tekan Qty',0),(92427,2568,'nl','Stem op tijden Inches Ht. Druk op aantal',0),(92428,2568,'fi','Luokitus times tuumaa Ht. Paina mÃ¤Ã¤rÃ¤',0),(92429,2568,'no','Rangere ganger Inches Ht. Trykk Ant',0),(92430,2568,'da','Vurder gange Inches Ht. Tryk Qty',0),(92431,2568,'ko','ì¸ì¹˜ Ht. ë³´ë„ Qty ì‹œê°„ í‰ê°€',0),(92432,2568,'he','×©×™×¢×•×¨ ×›×¤×•×œ ×›×ž×•×ª ×‘××™× ×¦\'×™× Ht. ×”×¢×™×ª×•× ×•×ª',0),(92433,2568,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï†Î¿ÏÎ­Ï‚ Î¯Î½Ï„ÏƒÎµÏ‚ Ht. Î Î±Ï„Î®ÏƒÏ„Îµ Qty',0),(92434,2568,'zh','æ¯”çŽ‡ä¹˜ä»¥è‹±å¯¸è£…å¸ä¸Žè¿è¾“ã€‚æŒ‰å°åˆ·æ•°é‡\r\n',0),(92435,2568,'sv','BetygsÃ¤tt gÃ¥nger Inches Ht. Tryck Kvt',0),(92436,2568,'it','Votare volte Qty pollici Ht. Press',0),(92437,2568,'tl','',0),(92438,2568,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3641;&#3603;&#3609;&#3636;&#3657;&#3623; &#3585;&#3604;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(92439,2568,'hi','à¤Ÿà¤¾à¤‡à¤®à¥à¤¸ à¤‡à¤‚à¤š à¤à¤šà¤Ÿà¥€. à¤ªà¥à¤°à¥‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¥‡à¤‚',0),(92440,2568,'ms','Kadar masa Qty inci Ht. Tekan',0),(92441,2568,'ar','Ù…Ø¹Ø¯Ù„ Ù…Ø±Ø§Øª Qty Ø¨ÙˆØµØ© Ht-Ø§Ù„ØµØ­Ø§ÙØ©',0),(92442,2568,'fr','Taux fois pouces Ht. Press QtÃ©',0),(92443,2568,'jp','Rate times Inches Ht. Press Qty',0),(92444,2568,'pt','Taxa vezes Qty polegadas Ht. Press',0),(92445,2568,'ru','ÐžÑ†ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´ÑŽÐ¹Ð¼Ð¾Ð² Ht. Ð¿Ñ€ÐµÑÑ',0),(92446,2568,'es','Velocidad por Altura en Pulgadas y Cantidad de ImpresiÃ³n',0),(92447,2568,'de','Bewerten Sie mal Zoll Ht. Press Qty',0),(92448,2568,'en','Rate times Inches Ht. Press Qty',0),(92449,2569,'is','',0),(92450,2569,'dr','(Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø³Ø§Ø¹Øª) Ø·ÙˆÙ„ . Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø±',0),(92451,2569,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø³Ø§Ø¹Øª) Ø·ÙˆÙ„ . Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø±',0),(92452,2569,'tr','OranÄ± uzunluÄŸu basÄ±n miktar kez',0),(92453,2569,'pl','OceÅ„ razy dÅ‚ugoÅ›Ä‡ prasy iloÅ›Ä‡',0),(92454,2569,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð²Ñ€ÐµÐ¼Ðµ Ð´ÑŠÐ»Ð¶Ð¸Ð½Ð° Ð¿Ñ€ÐµÑÐ° ÐºÐ¾Ð»',0),(92455,2569,'ur','Ø´Ø±Ø­ Ú©ÛŒ Ù„Ù…Ø¨Ø§Ø¦ÛŒ Ù¾Ø±ÛŒØ³ Ù‚ÛŒ Ù¹Ø§Ø¦Ù…Ø²',0),(92456,2569,'sr','Ð¡Ñ‚Ð¾Ð¿Ð° Ð¿ÑƒÑ‚Ð° Ð´ÑƒÐ¶Ð¸Ð½Ðµ Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ ÐšÐ¾Ð».',0),(92457,2569,'vi','Biá»ƒu giÃ¡ thá»i gian chiá»u dÃ i Sá»‘ lÆ°á»£ng In',0),(92458,2569,'af','Bepaal tye Lengte Drukpers Hoev.',0),(92459,2569,'ro','Rata ori cantit de presÄƒ lungimea',0),(92460,2569,'et','Rate aeg pikkus Press kogus',0),(92461,2569,'si','Stopnja krat dolÅ¾ina tiska kol',0),(92462,2569,'ba','Tingkat kali panjang tekan Qty',0),(92463,2569,'nl','Stem op tijden lengte Press Qty',0),(92464,2569,'fi','MÃ¤Ã¤rÃ¤ kertaa pituus painamalla mÃ¤Ã¤rÃ¤',0),(92465,2569,'no','Rate ganger lengden trykk Ant',0),(92466,2569,'da','Vurder gange lÃ¦ngden presse Qty',0),(92467,2569,'ko','ê¸¸ì´ ì–¸ë¡  Qty ì‹œê°„ í‰ê°€',0),(92468,2569,'he','×©×™×¢×•×¨ ×›×¤×•×œ ××•×¨×š ×”×¢×™×ª×•× ×•×ª ×›×ž×•×ª',0),(92469,2569,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï†Î¿ÏÎ­Ï‚ Î¼Î®ÎºÎ¿Ï‚ Ï„ÏÏ€Î¿Ï… Qty',0),(92470,2569,'zh','æ¯”çŽ‡ä¹˜ä»¥é•¿åº¦æŒ‰å°åˆ·æ•°é‡\r\n',0),(92471,2569,'sv','BetygsÃ¤tt gÃ¥nger lÃ¤ngden Press Kvt',0),(92472,2569,'it','Tasso volte lunghezza stampa Qty',0),(92473,2569,'tl','',0),(92474,2569,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3641;&#3603;&#3588;&#3623;&#3634;&#3617;&#3626;&#3641;&#3591; &#3585;&#3604;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(92475,2569,'hi','à¤²à¤‚à¤¬à¤¾à¤ˆ à¤ªà¥à¤°à¥‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¤° à¤Ÿà¤¾à¤‡à¤®à¥à¤¸',0),(92476,2569,'ms','Kadar masa Qty Seluar panjang',0),(92477,2569,'ar','Ù…Ø¹Ø¯Ù„ Ù…Ø±Ø§Øª Ø·ÙˆÙ„ Qty Ø§Ù„ØµØ­Ø§ÙØ©',0),(92478,2569,'fr','Taux de longueur presse Qty fois',0),(92479,2569,'jp','Rate times Length Press Qty',0),(92480,2569,'pt','Taxa vezes comprimento imprensa Qty',0),(92481,2569,'ru','ÐšÑƒÑ€Ñ Ñ€Ð°Ð·Ð° Ð´Ð»Ð¸Ð½Ð° Ð¿Ñ€ÐµÑÑ ÑˆÑ‚',0),(92482,2569,'es','Velocidad por Largo Cantidad de ImpresiÃ³n',0),(92483,2569,'de','Rate mal LÃ¤nge Presse Qty',0),(92484,2569,'en','Rate times Length Press Qty',0),(92485,2570,'is','',0),(92486,2570,'dr','(Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø³Ø§Ø¹Øª) ÙŠÙƒ ',0),(92487,2570,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø³Ø§Ø¹Øª) ÙŠÙƒ ',0),(92488,2570,'tr','Bir oranÄ±',0),(92489,2570,'pl','OceÅ„ razy jeden',0),(92490,2570,'bg','ÐžÑ†ÐµÐ½Ð¸Ñ‚Ðµ Ð¿ÑŠÑ‚Ð¸ ÐµÐ´Ð¸Ð½',0),(92491,2570,'ur','Ø§ÛŒÚ© Ø¨Ø§Ø± Ú©ÛŒ Ø´Ø±Ø­',0),(92492,2570,'sr','ÐžÑ†ÐµÐ½Ð¸Ñ‚Ðµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸Ð¼Ð°',0),(92493,2570,'vi','Biá»ƒu giÃ¡ thá»i gian má»™t',0),(92494,2570,'af','Bepaal tye Een',0),(92495,2570,'ro','Rata ori una',0),(92496,2570,'et','Ãœks korda hinda',0),(92497,2570,'si','Ocenite krat eden',0),(92498,2570,'ba','Menilai kali satu',0),(92499,2570,'nl','Stem op tijden een',0),(92500,2570,'fi','Luokitus times yksi',0),(92501,2570,'no','Rangere ganger en',0),(92502,2570,'da','Vurder gange en',0),(92503,2570,'ko','í•œ ì‹œê°„ ë¹„ìœ¨',0),(92504,2570,'he','×©×™×¢×•×¨ ×›×¤×•×œ ××—×“',0),(92505,2570,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï‡ÏÏŒÎ½Î¿Î¹ Î­Î½Î±',0),(92506,2570,'zh','æ¯”çŽ‡ä¹˜ä»¥ä¹‹ä¸€\r\n',0),(92507,2570,'sv','BetygsÃ¤tt gÃ¥nger en',0),(92508,2570,'it','Votare volte una',0),(92509,2570,'tl','',0),(92510,2570,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3641;&#3603;&#3627;&#3609;&#3638;&#3656;&#3591;',0),(92511,2570,'hi','à¤à¤• à¤¬à¤¾à¤° à¤¦à¥‡à¤‚',0),(92512,2570,'ms','Kadar masa salah satu',0),(92513,2570,'ar','Ù…Ø¹Ø¯Ù„ Ù…Ø±Ø© ÙˆØ§Ø­Ø¯Ø©',0),(92514,2570,'fr','Taux de reprises un',0),(92515,2570,'jp','Rate times One',0),(92516,2570,'pt','Taxa vezes um',0),(92517,2570,'ru','ÐžÑ†ÐµÐ½Ð¸Ñ‚ÑŒ Ñ€Ð°Ð· Ð¾Ð´Ð½Ð¾Ð¼Ñƒ',0),(92518,2570,'es','Velocidad por Uno',0),(92519,2570,'de','Zeiten einer bewerten',0),(92520,2570,'en','Rate times One',0),(92521,2571,'is','',0),(92522,2571,'dr','(Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø³Ø§Ø¹Øª) Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø±',0),(92523,2571,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø³Ø§Ø¹Øª) Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø±',0),(92524,2571,'tr','OranÄ± basÄ±n miktar kez',0),(92525,2571,'pl','OceÅ„ razy iloÅ›Ä‡ prasy',0),(92526,2571,'bg','ÐšÑƒÑ€Ñ Ð¿ÑŠÑ‚Ð¸ Ð½Ð°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÐºÐ¾Ð»',0),(92527,2571,'ur','Ø´Ø±Ø­ Ù¾Ø±ÛŒØ³ Ù‚ÛŒ Ù¹Ø§Ø¦Ù…Ø²',0),(92528,2571,'sr','Ð¡Ñ‚Ð¾Ð¿Ð° Ð¿ÑƒÑ‚Ð° Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ ÐšÐ¾Ð».',0),(92529,2571,'vi','Biá»ƒu giÃ¡ thá»i gian Sá»‘ lÆ°á»£ng In',0),(92530,2571,'af','Bepaal tye Druk Hoev.',0),(92531,2571,'ro','Rata ori presa cantit',0),(92532,2571,'et','MÃ¤Ã¤ra korda Press kogus',0),(92533,2571,'si','Stopnja krat koliÄina Press',0),(92534,2571,'ba','Tingkat kali tekan Qty',0),(92535,2571,'nl','Stem op tijden Press Qty',0),(92536,2571,'fi','Luokitus times Press mÃ¤Ã¤rÃ¤',0),(92537,2571,'no','Rate ganger trykk Ant',0),(92538,2571,'da','Vurder gange presse Qty',0),(92539,2571,'ko','ë³´ë„ ìˆ˜ëŸ‰ ì‹œê°„ í‰ê°€',0),(92540,2571,'he','×©×™×¢×•×¨ ×›×¤×•×œ ×›×ž×•×ª ×©×œ ×”×¢×™×ª×•× ×•×ª',0),(92541,2571,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï†Î¿ÏÎ­Ï‚ Ï„ÏÏ€Î¿Ï… Qty',0),(92542,2571,'zh','æ¯”çŽ‡ä¹˜ä»¥æŒ‰å°åˆ·æ•°é‡\r\n',0),(92543,2571,'sv','BetygsÃ¤tt gÃ¥nger Tryck Kvt',0),(92544,2571,'it','Tasso volte stampa Qty',0),(92545,2571,'tl','',0),(92546,2571,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;&#3607;&#3637;&#3656;&#3585;&#3604;',0),(92547,2571,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¤° à¤Ÿà¤¾à¤‡à¤®à¥à¤¸',0),(92548,2571,'ms','Kadar masa Qty Seluar',0),(92549,2571,'ar','Ù…Ø¹Ø¯Ù„ Ù…Ø±Ø§Øª Qty Ø§Ù„ØµØ­Ø§ÙØ©',0),(92550,2571,'fr','Taux fois presse QtÃ©',0),(92551,2571,'jp','Rate times Press Qty',0),(92552,2571,'pt','Taxa vezes Qty de imprensa',0),(92553,2571,'ru','ÐžÑ†ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ Qty Ð¿Ñ€ÐµÑÑ',0),(92554,2571,'es','Velocidad por Cantidad de ImpresiÃ³n',0),(92555,2571,'de','Preis mal Menge Presse:',0),(92556,2571,'en','Rate times Press Qty',0),(92557,2572,'is','',0),(92558,2572,'dr','(Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø³Ø§Ø¹Øª)   Ù…Ù‚Ø¯Ø§Ø± / Ø¯Ù‚ÙŠÙ‚Ù‡(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(92559,2572,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø³Ø§Ø¹Øª)   Ù…Ù‚Ø¯Ø§Ø± / Ø¯Ù‚ÙŠÙ‚Ù‡(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(92560,2572,'tr','Miktar/M oranÄ± kez',0),(92561,2572,'pl','OceÅ„ razy iloÅ›Ä‡/M',0),(92562,2572,'bg','ÐšÑƒÑ€Ñ Ð¿ÑŠÑ‚Ð¸ ÐºÐ¾Ð»/M',0),(92563,2572,'ur','Ø´Ø±Ø­ Ù‚ÛŒ/Ù„Ø§Ú©Ú¾ Ø¨Ø§Ø±',0),(92564,2572,'sr','Ð¡Ñ‚Ð¾Ð¿Ð° Ð¿ÑƒÑ‚Ð° ÐšÐ¾Ð»/Ðœ',0),(92565,2572,'vi','Sá»‘ lÆ°á»£ng Biá»ƒu giÃ¡ thá»i gian/M',0),(92566,2572,'af','Bepaal tye Druk Hoev./M',0),(92567,2572,'ro','Rata ori cantitate/M',0),(92568,2572,'et','MÃ¤Ã¤ra korda tk/M',0),(92569,2572,'si','Stopnja krat koliÄina/M',0),(92570,2572,'ba','Tingkat kali Qty/M',0),(92571,2572,'nl','Stem op tijden Qty/M',0),(92572,2572,'fi','MÃ¤Ã¤rÃ¤ kertaa kpl/M',0),(92573,2572,'no','Rate ganger antall/M',0),(92574,2572,'da','Vurder gange antal/M',0),(92575,2572,'ko','ì†ë„ ë°° ìˆ˜ëŸ‰/M',0),(92576,2572,'he','×©×™×¢×•×¨ ×›×¤×•×œ ×›×ž×•×ª/M',0),(92577,2572,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï†Î¿ÏÎ­Ï‚ Qty/M',0),(92578,2572,'zh','æ¯”çŽ‡ä¹˜ä»¥æ•°é‡/ MæœŸ\r\n',0),(92579,2572,'sv','BetygsÃ¤tt gÃ¥nger antal/M',0),(92580,2572,'it','Tasso volte Qty/M',0),(92581,2572,'tl','',0),(92582,2572,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;/M',0),(92583,2572,'hi','à¤¦à¤° à¤®à¤¾à¤¤à¥à¤°à¤¾/M à¤Ÿà¤¾à¤‡à¤®à¥à¤¸',0),(92584,2572,'ms','Kadar masa Qty/M',0),(92585,2572,'ar','Ù…Ø¹Ø¯Ù„ Ù…Ø±Ø§Øª Qty/M',0),(92586,2572,'fr','Taux fois Qty/M',0),(92587,2572,'jp','Rate times Qty/M',0),(92588,2572,'pt','Taxa vezes Qty/M',0),(92589,2572,'ru','ÐžÑ†ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ ÑˆÑ‚/Ðœ',0),(92590,2572,'es','Velocidad por Cant./M',0),(92591,2572,'de','Preis mal Menge/M',0),(92592,2572,'en','Rate times Qty/M',0),(92593,2573,'is','',0),(92594,2573,'dr','(Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø²Ù…Ø§Ù†) Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§ ',0),(92595,2573,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø²Ù…Ø§Ù†) Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§ ',0),(92596,2573,'tr','OranÄ± adet/NumberUp defa',0),(92597,2573,'pl','OceÅ„ razy iloÅ›Ä‡/NumberUp',0),(92598,2573,'bg','ÐšÑƒÑ€Ñ Ð¿ÑŠÑ‚Ð¸ ÐºÐ¾Ð»/NumberUp',0),(92599,2573,'ur','Ø´Ø±Ø­ Ù‚ÛŒ/Ù†ÙˆÙ…Ø¨Ø±ÙˆÙ¾ Ù¹Ø§Ø¦Ù…Ø²',0),(92600,2573,'sr','Ð¡Ñ‚Ð¾Ð¿Ð° Ð¿ÑƒÑ‚Ð° ÐšÐ¾Ð»/ÐÑƒÐ¼Ð±ÐµÑ€Ð£Ð¿',0),(92601,2573,'vi','Sá»‘ lÆ°á»£ng Biá»ƒu giÃ¡ thá»i gian/Sá»‘ lÃªn',0),(92602,2573,'af','Koers tye Qty/NumberUp',0),(92603,2573,'ro','Rata ori cantitate/NumberUp',0),(92604,2573,'et','MÃ¤Ã¤ra korda tk/NumberUp',0),(92605,2573,'si','Stopnja krat koliÄina/NumberUp',0),(92606,2573,'ba','Tingkat kali Qty NumberUp',0),(92607,2573,'nl','Stem op tijden Qty/NumberUp',0),(92608,2573,'fi','MÃ¤Ã¤rÃ¤ kertaa mÃ¤Ã¤rÃ¤/NumberUp',0),(92609,2573,'no','Rate ganger antall/NumberUp',0),(92610,2573,'da','Vurder gange antal/NumberUp',0),(92611,2573,'ko','ì†ë„ ë°° ìˆ˜ëŸ‰/NumberUp',0),(92612,2573,'he','×©×™×¢×•×¨ ×›×¤×•×œ ×›×ž×•×ª/NumberUp',0),(92613,2573,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï†Î¿ÏÎ­Ï‚ Qty/NumberUp',0),(92614,2573,'zh','æ¯”çŽ‡ä¹˜ä»¥æ•°é‡/å¢žåŠ æ•°é‡\r\n',0),(92615,2573,'sv','BetygsÃ¤tt gÃ¥nger antal/NumberUp',0),(92616,2573,'it','Tasso volte Qty/NumberUp',0),(92617,2573,'tl','',0),(92618,2573,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;/&#3648;&#3614;&#3636;&#3656;&#3617;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(92619,2573,'hi','à¤¦à¤° à¤®à¤¾à¤¤à¥à¤°à¤¾/NumberUp à¤Ÿà¤¾à¤‡à¤®à¥à¤¸',0),(92620,2573,'ms','Kadar masa Qty/NumberUp',0),(92621,2573,'ar','Ù…Ø¹Ø¯Ù„ Ù…Ø±Ø§Øª Qty/Ù†ÙˆÙ…Ø¨ÙŠØ±ÙˆØ¨',0),(92622,2573,'fr','Taux fois Qty/NumberUp',0),(92623,2573,'jp','Rate times Qty/NumberUp',0),(92624,2573,'pt','Taxa vezes Qty/jÃªrsei',0),(92625,2573,'ru','ÐžÑ†ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ ÐšÐ¾Ð»-Ð²Ð¾/NumberUp',0),(92626,2573,'es','Velocidad por Cant./NÃºmero Total',0),(92627,2573,'de','Preis mal Menge/NumberUp',0),(92628,2573,'en','Rate times Qty/NumberUp',0),(92629,2574,'is','',0),(92630,2574,'dr','(Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø²Ù…Ø§Ù†) Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø±Ø¬ÙˆØ§Ø¨ ',0),(92631,2574,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø²Ù…Ø§Ù†) Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø±Ø¬ÙˆØ§Ø¨ ',0),(92632,2574,'tr','Miktar/yanÄ±t oranÄ± kez',0),(92633,2574,'pl','OceÅ„ razy iloÅ›Ä‡/odpowiedz',0),(92634,2574,'bg','ÐšÑƒÑ€Ñ Ð¿ÑŠÑ‚Ð¸ ÐºÐ¾Ð»/Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(92635,2574,'ur','Ø´Ø±Ø­ Ù‚ÛŒ/Ø¬ÙˆØ§Ø¨ Ø¨Ø§Ø±',0),(92636,2574,'sr','Ð¡Ñ‚Ð¾Ð¿Ð° Ð¿ÑƒÑ‚Ð° ÐšÐ¾Ð»/Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€',0),(92637,2574,'vi','Sá»‘ lÆ°á»£ng Biá»ƒu giÃ¡ thá»i gian/Tráº£ lá»i',0),(92638,2574,'af','Skaal tye Hoev./Beantwoord',0),(92639,2574,'ro','Rata ori cantitate/rÄƒspuns',0),(92640,2574,'et','MÃ¤Ã¤ra korda tk/vastus',0),(92641,2574,'si','Stopnja krat koliÄina/odgovor',0),(92642,2574,'ba','Tingkat kali Qty Balasan',0),(92643,2574,'nl','Stem op tijden Qty/antwoord',0),(92644,2574,'fi','MÃ¤Ã¤rÃ¤ kertaa mÃ¤Ã¤rÃ¤/Reply',0),(92645,2574,'no','Rate ganger antall/svar',0),(92646,2574,'da','Vurder gange antal/svar',0),(92647,2574,'ko','ìˆ˜ëŸ‰/ì‘ë‹µ ì‹œê°„ í‰ê°€',0),(92648,2574,'he','×©×™×¢×•×¨ ×›×¤×•×œ ×›×ž×•×ª/×ª×’×•×‘×”',0),(92649,2574,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï†Î¿ÏÎ­Ï‚ Qty/Î±Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(92650,2574,'zh','æ¯”çŽ‡ä¹˜ä»¥æ•°é‡/å›žå¤\r\n',0),(92651,2574,'sv','BetygsÃ¤tt gÃ¥nger antal/svar',0),(92652,2574,'it','Tasso volte Qty/risposta',0),(92653,2574,'tl','',0),(92654,2574,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;/&#3585;&#3634;&#3619;&#3605;&#3629;&#3610;',0),(92655,2574,'hi','à¤Ÿà¤¾à¤‡à¤®à¥à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾/à¤‰à¤¤à¥à¤¤à¤° à¤¦à¥‡à¤‚',0),(92656,2574,'ms','Kadar masa Qty/jawapan',0),(92657,2574,'ar','Ù…Ø¹Ø¯Ù„ Ù…Ø±Ø§Øª Qty/Ø§Ù„Ø±Ø¯',0),(92658,2574,'fr','Taux fois Qty/rÃ©ponse',0),(92659,2574,'jp','Rate times Qty/Reply',0),(92660,2574,'pt','Taxa vezes Qty/resposta',0),(92661,2574,'ru','ÐžÑ†ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ ÐšÐ¾Ð»-Ð²Ð¾/Ð¾Ñ‚Ð²ÐµÑ‚',0),(92662,2574,'es','Velocidad por Cant./Respuesta',0),(92663,2574,'de','Preis mal Menge/Antwort',0),(92664,2574,'en','Rate times Qty/Reply',0),(92665,2575,'is','',0),(92666,2575,'dr','(Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø²Ù…Ø§Ù†)  Ù…Ù‚Ø¯Ø§Ø± Ø¯ÙØ¹Ø§Øª  Ù‚Ø³Ù…ØªÙ‡Ø§ Ø¯Ø± Ù‡Ø±  Ø¯Ù‚ÙŠÙ‚Ù‡ (Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(92667,2575,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø²Ù…Ø§Ù†)  Ù…Ù‚Ø¯Ø§Ø± Ø¯ÙØ¹Ø§Øª  Ù‚Ø³Ù…ØªÙ‡Ø§ Ø¯Ø± Ù‡Ø±  Ø¯Ù‚ÙŠÙ‚Ù‡ (Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(92668,2575,'tr','OranÄ± kez miktar kez parÃ§alar/M',0),(92669,2575,'pl','OceÅ„ razy iloÅ›Ä‡ razy czÄ™Å›ci/M',0),(92670,2575,'bg','ÐšÑƒÑ€Ñ Ð¿ÑŠÑ‚Ð¸ ÐºÐ¾Ð» Ð¿ÑŠÑ‚Ð¸ Ñ‡Ð°ÑÑ‚Ð¸/M',0),(92671,2575,'ur','Ø´Ø±Ø­ Ø¨Ø§Ø± Ù‚ÛŒ Ø¨Ø§Ø± Ø­ØµÙˆÚº/M',0),(92672,2575,'sr','Ð¡Ñ‚Ð¾Ð¿Ð° Ð¿ÑƒÑ‚Ð° ÐšÐ¾Ð» Ð¿ÑƒÑ‚Ð° Ð´ÐµÐ»Ð¾Ð²Ð°/Ðœ',0),(92673,2575,'vi','Sá»‘ lÆ°á»£ng Biá»ƒu giÃ¡ thá»i gian, thá»i gian phá»¥ tÃ¹ng/M',0),(92674,2575,'af','Skaal tye hoev. kere onderdele/M',0),(92675,2575,'ro','Rata ori cantit ori pÄƒrÅ£i/M',0),(92676,2575,'et','MÃ¤Ã¤ra korda kogus korda osad/M',0),(92677,2575,'si','Stopnja krat koliÄina krat deli/M',0),(92678,2575,'ba','Tingkat kali qty kali bagian/M',0),(92679,2575,'nl','Stem op tijden aantal keer delen/M',0),(92680,2575,'fi','MÃ¤Ã¤rÃ¤ kertaa mÃ¤Ã¤rÃ¤ kertaa osat/M',0),(92681,2575,'no','Rate ganger antall ganger deler/M',0),(92682,2575,'da','Sats gange antal gange dele/M',0),(92683,2575,'ko','ì†ë„ ë°° ìˆ˜ëŸ‰ ë²ˆ ë¶€í’ˆ/M',0),(92684,2575,'he','×§×¦×‘ ×¤×¢×ž×™× ×›×ž×•×ª ×¤×¢×ž×™× ×—×œ×§×™×/M',0),(92685,2575,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï†Î¿ÏÎ­Ï‚ qty Ï†Î¿ÏÎ­Ï‚ Î¼Î­ÏÎ·/M',0),(92686,2575,'zh','æ¯”çŽ‡ä¹˜ä»¥æ•°é‡ä¹˜ä»¥é›¶ä»¶/ MæœŸ\r\n',0),(92687,2575,'sv','BetygsÃ¤tt gÃ¥nger antal gÃ¥nger delar/M',0),(92688,2575,'it','Tasso volte qty volte pezzi/M',0),(92689,2575,'tl','',0),(92690,2575,'th','Rate times qty times parts/M',0),(92691,2575,'hi','à¤¦à¤° à¤¬à¤¾à¤° à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¬à¤¾à¤° à¤­à¤¾à¤—à¥‹à¤‚/M',0),(92692,2575,'ms','Kadar times qty times bahagian/M',0),(92693,2575,'ar','Ù…Ø¹Ø¯Ù„ Ù…Ø±Ø§Øª qty Ø§Ù„Ø£ÙˆÙ‚Ø§Øª Ø£Ø¬Ø²Ø§Ø¡ Ø§Ù„Ù…ØªØ±',0),(92694,2575,'fr','Taux fois qty fois piÃ¨ces/M',0),(92695,2575,'jp','Rate times qty times parts/M',0),(92696,2575,'pt','Taxa vezes qty vezes peÃ§as/M',0),(92697,2575,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ñ€Ð°Ð· Ñ€Ð°Ð· Ñ‡Ð°ÑÑ‚ÐµÐ¹/Ðœ',0),(92698,2575,'es','Velocidad por Cant. por partes/M',0),(92699,2575,'de','Preis mal Menge mal Teile/M',0),(92700,2575,'en','Rate times qty times parts/M',0),(92701,2576,'is','',0),(92702,2576,'dr','(Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø²Ù…Ø§Ù†) Ù…Ù‚Ø¯Ø§Ø± Ø¯ÙØ¹Ø§Øª  Ø¬Ù‡Øª Ù‡Ø§Ø¯Ø± Ù‡Ø±  Ø¯Ù‚ÙŠÙ‚Ù‡(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(92703,2576,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø²Ù…Ø§Ù†) Ù…Ù‚Ø¯Ø§Ø± Ø¯ÙØ¹Ø§Øª  Ø¬Ù‡Øª Ù‡Ø§Ø¯Ø± Ù‡Ø±  Ø¯Ù‚ÙŠÙ‚Ù‡(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(92704,2576,'tr','OranÄ± kez miktar kez taraf/M',0),(92705,2576,'pl','OceÅ„ razy razy iloÅ›Ä‡ stron/M',0),(92706,2576,'bg','ÐšÑƒÑ€Ñ Ð¿ÑŠÑ‚Ð¸ ÐºÐ¾Ð» Ð¿ÑŠÑ‚Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸/M',0),(92707,2576,'ur','Ø´Ø±Ø­ Ø¨Ø§Ø± Ù‚ÛŒ Ø¨Ø§Ø± Ø§Ø·Ø±Ø§Ù/M',0),(92708,2576,'sr','Ð¡Ñ‚Ð¾Ð¿Ð° Ð¿ÑƒÑ‚Ð° ÐšÐ¾Ð» Ð¿ÑƒÑ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ðµ/Ðœ',0),(92709,2576,'vi','GiÃ¡ thá»i gian sá»‘ lÆ°á»£ng thá»i gian máº·t/M',0),(92710,2576,'af','Skaal tye hoev. kere skuif/M',0),(92711,2576,'ro','Rata ori cantit ori pÄƒrÅ£i/M',0),(92712,2576,'et','MÃ¤Ã¤ra korda kogus korda pool/M',0),(92713,2576,'si','Stopnja krat koliÄina krat straneh/M',0),(92714,2576,'ba','Tingkat kali qty kali sisi/M',0),(92715,2576,'nl','Stem op tijden aantal keer zijden/M',0),(92716,2576,'fi','MÃ¤Ã¤rÃ¤ kertaa mÃ¤Ã¤rÃ¤ kertaa puolin/M',0),(92717,2576,'no','Rate ganger antall ganger sider/M',0),(92718,2576,'da','Sats gange antal gange sider/M',0),(92719,2576,'ko','ì†ë„ ë°° ìˆ˜ëŸ‰ ë²ˆ ì¸¡ë©´/M',0),(92720,2576,'he','×§×¦×‘ ×¤×¢×ž×™× ×›×ž×•×ª ×¤×¢×ž×™× ×”×¦×“×“×™×/M',0),(92721,2576,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï†Î¿ÏÎ­Ï‚ qty Ï†Î¿ÏÎ­Ï‚ Ï€Î»ÎµÏ…ÏÎ­Ï‚/M',0),(92722,2576,'zh','æ¯”çŽ‡ä¹˜ä»¥æ•°é‡ä¹˜ä»¥é¢æ•°/ MæœŸ\r\n',0),(92723,2576,'sv','BetygsÃ¤tt gÃ¥nger antal gÃ¥nger sidor/M',0),(92724,2576,'it','Tasso volte qty volte lati/M',0),(92725,2576,'tl','',0),(92726,2576,'th','Rate times qty times parts/M',0),(92727,2576,'hi','à¤¦à¤° à¤¬à¤¾à¤° à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¬à¤¾à¤° à¤ªà¤•à¥à¤·à¥‹à¤‚/M',0),(92728,2576,'ms','Kadar times qty times sisi/M',0),(92729,2576,'ar','Ù…Ø¹Ø¯Ù„ Ù…Ø±Ø§Øª qty Ù…Ø±Ø§Øª Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠÙ†/M',0),(92730,2576,'fr','Taux fois qty fois cÃ´tÃ©s/M',0),(92731,2576,'jp','Rate times qty times sides/M',0),(92732,2576,'pt','Taxa vezes qty vezes lados/M',0),(92733,2576,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ñ€Ð°Ð· Ñ€Ð°Ð· ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹/Ðœ',0),(92734,2576,'es','Velocidad por Cant. por lados/M',0),(92735,2576,'de','Preis mal Menge mal Seiten/M',0),(92736,2576,'en','Rate times qty times sides/M',0),(92737,2577,'is','',0),(92738,2577,'dr','(Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø²Ù…Ø§Ù†) Ø¬ÙˆØ§Ø¨',0),(92739,2577,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª) Ø¯ÙØ¹Ø§Øª(Ø²Ù…Ø§Ù†) Ø¬ÙˆØ§Ø¨',0),(92740,2577,'tr','YanÄ±t oranÄ±',0),(92741,2577,'pl','OceÅ„ czasy odpowiedzi',0),(92742,2577,'bg','ÐžÑ†ÐµÐ½Ð¸Ñ‚Ðµ Ð¿ÑŠÑ‚Ð¸ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(92743,2577,'ur','Ø¬ÙˆØ§Ø¨ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª Ú©ÛŒ Ø´Ø±Ø­',0),(92744,2577,'sr','ÐžÑ†ÐµÐ½Ð¸Ñ‚Ðµ Ð¿ÑƒÑ‚Ð° Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€',0),(92745,2577,'vi','Tráº£ lá»i GiÃ¡ thá»i gian ',0),(92746,2577,'af','Skaaltye Beantwoord',0),(92747,2577,'ro','Rata ori rÄƒspunsul',0),(92748,2577,'et','Hinnake alati vastus',0),(92749,2577,'si','Ocenite Äas odgovora',0),(92750,2577,'ba','Menilai kali Balasan',0),(92751,2577,'nl','Stem op keer antwoord',0),(92752,2577,'fi','Luokitus vastaa times',0),(92753,2577,'no','Rangere ganger svar',0),(92754,2577,'da','Vurder gange svar',0),(92755,2577,'ko','ì‘ë‹µ ì‹œê°„ í‰ê°€',0),(92756,2577,'he','×§×¦×‘ ×¤×¢×ž×™× ×ª×’×•×‘×”',0),(92757,2577,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï†Î¿ÏÎ­Ï‚ Î±Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(92758,2577,'zh','åˆ©çŽ‡ä¹˜ä»¥å›žå¤\r\n',0),(92759,2577,'sv','BetygsÃ¤tt gÃ¥nger svar',0),(92760,2577,'it','Tasso di tempi di risposta',0),(92761,2577,'tl','',0),(92762,2577,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3619;&#3633;&#3657;&#3591;&#3607;&#3637;&#3656;&#3605;&#3629;&#3610;',0),(92763,2577,'hi','à¤•à¤ˆ à¤¬à¤¾à¤° à¤œà¤µà¤¾à¤¬ à¤¦à¥‡à¤‚',0),(92764,2577,'ms','Kadar masa Reply',0),(92765,2577,'ar','Ù…Ø¹Ø¯Ù„ Ù…Ø±Ø§Øª Ø§Ù„Ø±Ø¯',0),(92766,2577,'fr','Taux de temps de rÃ©ponse',0),(92767,2577,'jp','Rate times Reply',0),(92768,2577,'pt','Taxa de tempos de resposta',0),(92769,2577,'ru','ÐžÑ†ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ Ð¾Ñ‚Ð²ÐµÑ‚Ð°',0),(92770,2577,'es','Velocidad por Respuesta',0),(92771,2577,'de','Bewerten mal Antwort',0),(92772,2577,'en','Rate times Reply',0),(92773,2578,'is','',0),(92774,2578,'dr','(Ù†Ø±Ø® Ø¨Ù†Ø¯ÙŠ',0),(92775,2578,'pr','Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ (Ù†Ø±Ø® Ø¨Ù†Ø¯ÙŠ',0),(92776,2578,'tr','Oy verin',0),(92777,2578,'pl','Ocena',0),(92778,2578,'bg','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(92779,2578,'ur','Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ',0),(92780,2578,'sr','Ð ÐµÑ˜Ñ‚Ð¸Ð½Ð³',0),(92781,2578,'vi','GiÃ¡',0),(92782,2578,'af','Gradering',0),(92783,2578,'ro','Evaluare',0),(92784,2578,'et','Reiting',0),(92785,2578,'si','Ocena',0),(92786,2578,'ba','Peringkat',0),(92787,2578,'nl','Rating',0),(92788,2578,'fi','Luokitus',0),(92789,2578,'no','Vurdering',0),(92790,2578,'da','Rating',0),(92791,2578,'ko','ë“±ê¸‰',0),(92792,2578,'he','×“×™×¨×•×’',0),(92793,2578,'el','Î’Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î±',0),(92794,2578,'zh','è¯„åˆ†\r\n',0),(92795,2578,'sv','Betyg',0),(92796,2578,'it','Valutazione',0),(92797,2578,'tl','',0),(92798,2578,'th','&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;',0),(92799,2578,'hi','à¤°à¥‡à¤Ÿà¤¿à¤‚à¤—',0),(92800,2578,'ms','Penarafan',0),(92801,2578,'ar','ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(92802,2578,'fr','Notation',0),(92803,2578,'jp','è©•ä¾¡',0),(92804,2578,'pt','ClassificaÃ§Ã£o',0),(92805,2578,'ru','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(92806,2578,'es','ValuaciÃ³n',0),(92807,2578,'de','Bewertung',0),(92808,2578,'en','Rating',0),(92809,2579,'is','',0),(92810,2579,'dr','(Ù†Ø±Ø® Ø¨Ù†Ø¯ÙŠ) Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(92811,2579,'pr','Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ (Ù†Ø±Ø® Ø¨Ù†Ø¯ÙŠ) Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(92812,2579,'tr','Bu isimde zaten puan var',0),(92813,2579,'pl','Ocena juÅ¼ istnieje pod tÄ… nazwÄ…',0),(92814,2579,'bg','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ñ Ñ‚Ð¾Ð²Ð° Ð¸Ð¼Ðµ',0),(92815,2579,'ur','Ø§Ø³ Ù†Ø§Ù… Ú©ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(92816,2579,'sr','Ð ÐµÑ˜Ñ‚Ð¸Ð½Ð³ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð¿Ð¾Ð´ Ñ‚Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼',0),(92817,2579,'vi','GiÃ¡ Ä‘Ã£ tá»“n táº¡i theo tÃªn nÃ y',0),(92818,2579,'af','\"Ratting\" bestaan alreeds vir daardie naam',0),(92819,2579,'ro','Evaluare deja existÄƒ de acest nume',0),(92820,2579,'et','Hinnang juba olemas nimega',0),(92821,2579,'si','Ocena Å¾e obstaja s tem imenom',0),(92822,2579,'ba','Rating sudah ada dengan nama itu',0),(92823,2579,'nl','Met die naam bestaat al rating',0),(92824,2579,'fi','Pisteet jo olemassa samanniminen',0),(92825,2579,'no','Vurdering allerede finnes med det navnet',0),(92826,2579,'da','Rating allerede findes ved navnet',0),(92827,2579,'ko','ê·¸ ì´ë¦„ í•˜ ì—¬ ì¡´ìž¬ ì´ë¯¸ ë“±ê¸‰',0),(92828,2579,'he','×“×™×¨×•×’ ×›×‘×¨ ×§×™×™× ×‘×©× ×”×–×”',0),(92829,2579,'el','Î’Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± Î®Î´Î· Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(92830,2579,'zh','è¯„åˆ†å·²ç»å­˜åœ¨è¯¥åç§°\r\n',0),(92831,2579,'sv','Betyg redan finns genom det namnet',0),(92832,2579,'it','Analoghe giÃ  esiste con questo nome',0),(92833,2579,'tl','',0),(92834,2579,'th','&#3592;&#3633;&#3604;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;&#3605;&#3634;&#3617;&#3594;&#3639;&#3656;&#3629;',0),(92835,2579,'hi','à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‰à¤¸ à¤¨à¤¾à¤® à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(92836,2579,'ms','Penarafan telah wujud dengan nama itu',0),(92837,2579,'ar','ØªØµÙ†ÙŠÙ Ø§Ù„ÙØ¹Ù„ Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ù‡Ø°Ø§ Ø§Ù„Ø§Ø³Ù…',0),(92838,2579,'fr','Notation dÃ©jÃ  existe sous ce nom',0),(92839,2579,'jp','ã??ã?®å??å‰?ã?®è©•ä¾¡ã?¯ã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(92840,2579,'pt','AvaliaÃ§Ã£o jÃ¡ existe com esse nome',0),(92841,2579,'ru','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ñ Ñ‚Ð°ÐºÐ¸Ð¼ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸ÐµÐ¼ ÑƒÐ¶Ðµ ÑÐ¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ÑÑ',0),(92842,2579,'es','ValuaciÃ³n ya existe por ese nombre',0),(92843,2579,'de','Mit diesem Namen existiert bereits die Gesamtwertung',0),(92844,2579,'en','Rating already exists by that name',0),(92845,2580,'is','',0),(92846,2580,'dr','_ Ø§Ú¯Ø± Ø¨Ù‡ Ø§ÙŠÙ† ØªÙ†Ø¸ÙŠÙ… Ø±Ø³ÙŠØ¯ÙŠØ¯ Ù†Ú¯Ø±Ø§Ù† Ù†Ø´ÙˆÙŠØ¯ â€“Ù…Ø­Ù„ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡  -Ù†Ø§Ù… ÛŒÙˆØ²Ø±ÙŠ- Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ÙˆÙ†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡  Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§ÙŠÙ† ÙØµÙ„ Ù…Ø´',0),(92847,2580,'pr','ØµÙØ­Ù‡ Ø¨Ù‡ Ø¯Ø³Øª Ø¢Ù…Ø¯Ù‡ â€“ Ù…Ø±ÙƒØ²_ Ø§Ú¯Ø± Ø¨Ù‡ Ø§ÙŠÙ† ØªÙ†Ø¸ÙŠÙ… Ø±Ø³ÙŠØ¯ÙŠØ¯ Ù†Ú¯Ø±Ø§Ù† Ù†Ø´ÙˆÙŠØ¯ â€“Ù…Ø­Ù„ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡  -Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ- Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ÙˆÙ†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡  Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§ÙŠÙ† ÙØµÙ„ Ù…Ø´Ø',0),(92848,2580,'tr','<p><center><br>EÄŸer aradÄ±ÄŸÄ±nÄ±z panik bu kur yapma.<br>VeritabanÄ± konumu, kullanÄ±cÄ± adÄ±, parola ve veritabanÄ± adÄ± denetleyin.<br>Bu arabirim, size doÄŸru yolda almak iÃ§in Ã§alÄ±ÅŸacaÄŸÄ±z!<p></center>',0),(92849,2580,'pl','<p><center><br>JeÅ›li masz osiÄ…gnÄ…Å‚ ten Instalator nie panikuj.<br>SprawdÅº lokalizacjÄ™ bazy danych, Username, hasÅ‚o i nazwÄ™ bazy danych.<br>Ten interfejs sprÃ³buje ci udaÅ‚ siÄ™ w dobrym kierunku!<p></center>',0),(92850,2580,'bg','<p><center><br>ÐÐºÐ¾ ÑÑ‚Ðµ Ð´Ð¾ÑÑ‚Ð¸Ð³Ð½Ð°Ð»Ð¸ Ñ‚Ð°Ð·Ð¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ðµ ÑÐµ Ð¿Ð°Ð½Ð¸ÐºÑŒÐ¾ÑÐ²Ð°Ð¹Ñ‚Ðµ.<br>ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° Database Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ, Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ, Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ð±',0),(92851,2580,'ur','<p><center><br>Ù¾ÛÙ†Ú† Ú¯Ø¦Û’ ÛÛŒÚº ØªÙˆ ÛŒÛ Ø³ÛŒÙ¹ Ø§Ù¾ ÛØ±Ø§Ø³Ø§Úº Ù†ÛÛŒÚº Û”<br>Ø§Ù¾Ù†Û’ Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ØŒ ØµØ§Ø±Ù Ù†Ø§Ù…ØŒ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø§ÙˆØ± Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù†Ø§Ù… Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Û”<br>Ø§Ø³ Ù…ÙˆØ§Ø¬Û Ø¢Ù¾ ØµØ­ÛŒØ­ Ø³Ù…Øª Ù…ÛŒÚ',0),(92852,2580,'sr','<p><center><br>ÐÐºÐ¾ ÑÑ‚Ðµ Ð´Ð¾ÑÑ‚Ð¸Ð³Ð»Ð¸ ÐžÐ²Ð° Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ð±ÐµÐ· Ð¿Ð°Ð½Ð¸ÐºÐµ.<br>ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°, ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ, Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ð¸ Ð¸Ð¼Ðµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°.<br>ÐžÐ²Ð°',0),(92853,2580,'vi','<p>Äá»«ng sá»£ náº¿u báº¡n Ä‘áº¿n pháº§n Setup nÃ y.  HÃ£y kiá»ƒm tra vá»‹ trÃ­ dá»¯ liá»‡u, ngÆ°á»i sá»­ dá»¥ng, máº­t mÃ£ vÃ  tÃªn dá»¯ liá»‡u. Giao diá»‡n nÃ y Ä‘ang hÆ°á»›ng báº¡n Ä‘i Ä‘Ãºng Ä‘Æ°á»ng!</p>',0),(92854,2580,'af','<p><center><br>As jy bereik het hierdie opstelling Moenie paniekerig raak nie.<br>Kontroleer jou databasis ligging, gebruikersnaam, wagwoord en databasis naam.<br>Hierdie koppelvlak sal probeer om jou pad in die regte rigting te kry!<p></center>',0),(92855,2580,'ro','<p><center><br>DacÄƒ aÅ£i ajuns la acest setup nu intraÅ£i Ã®n panicÄƒ.<br>Verifica baza de date locatia, utilizator, parola, si numele bazei de date.<br>AceastÄƒ interfaÅ£Äƒ vor Ã®ncerca sÄƒ te condus Ã®n direcÅ£ia cea bunÄƒ!<p></center>',0),(92856,2580,'et','<p><center><br>Kui oled jÃµudnud selle seadistamise Ã¤ra paanitse.<br>Kontrollige andmebaasi asukoht, kasutajanimi, parool ja andmebaasinimi.<br>Selle liidese Ã¼ritavad panna teid juhib Ãµiges suunas!<p></center>',0),(92857,2580,'si','<p><center><br>ÄŒe ste dosegli ta nastavitev ni panike.<br>Preverite lokacijo baze podatkov, uporabniÅ¡ko ime, geslo in ime zbirke podatkov.<br>Ta vmesnik bo poskusil priti vodil v pravo smer!<p></center>',0),(92858,2580,'ba','<p><center><br>Jika Anda telah mencapai konfigurasi ini jangan panik.<br>Periksa lokasi Database, Username, Password, dan nama Database.<br>Antarmuka ini akan mencoba untuk mendapatkan Anda menuju ke arah yang tepat!<p></center>',0),(92859,2580,'nl','<p><center><br>Als u hebt bereikt deze setup niet paniek.<br>Controleer uw locatie van Database, gebruikersnaam, wachtwoord en databasenaam.<br>Deze interface zal proberen om je hoofd in de juiste richting!<p></center>',0),(92860,2580,'fi','<p><center><br>Jos olet saavuttanut tÃ¤mÃ¤n setup ei paniikkia.<br>Tarkista tietokannan sijainti, kÃ¤yttÃ¤jÃ¤tunnus, salasana ja tietokannan nimi.<br>TÃ¤mÃ¤ kÃ¤yttÃ¶liittymÃ¤ yrittÃ¤Ã¤ saada olet menossa oikeaan suuntaan!<p></center>',0),(92861,2580,'no','<p><center><br>Hvis du har nÃ¥dd dette oppsettet ikke fÃ¥ panikk.<br>Sjekk din databaseplassering, brukernavn, passord og databasenavn.<br>Dette grensesnittet vil prÃ¸ve Ã¥ fÃ¥ deg pÃ¥ vei i riktig retning!<p></center>',0),(92862,2580,'da','<p><center><br>Hvis du har nÃ¥et denne opsÃ¦tning ikke panik.<br>Tjek din databaseplaceringen, Username, Password og databasenavn.<br>Denne grÃ¦nseflade vil forsÃ¸ge at fÃ¥ dig pÃ¥ vej i den rigtige retning!<p></center>',0),(92863,2580,'ko','<p><center><br>ì— ë„ë‹¬ í•˜ë©´ì´ ì„¤ì • ë‹¹í™© í•˜ì§€ ë§ˆì‹­ì‹œì˜¤.<br>ë°ì´í„°ë² ì´ìŠ¤ ìœ„ì¹˜, ì‚¬ìš©ìž ì´ë¦„, ì•”í˜¸ ë° ë°ì´í„°ë² ì´ìŠ¤ ì´ë¦„ì„ í™•ì¸ í•©ë‹ˆë‹¤.<br>ì´ ì¸í„°íŽ˜ì´ìŠ¤ëŠ” ì˜¬ë°”ë¥¸ ë°©í–¥ìœ¼ë¡œ ê³  ë‹¹ì‹ ì´ ì¢€ í•˜ë ¤ê³  í',0),(92864,2580,'he','<p><center><br>×× ×”×’×¢×ª× ××œ ×ª×™×œ×—×¦×™ ×ª×•×›× ×™×ª ×”×ª×§× ×” ×–×•.<br>×‘×“×•×§ ××ª ×”×ž×™×§×•× ×©×œ ×ž×¡×“, ×©× ×”×ž×©×ª×ž×©, ×”×¡×™×¡×ž×” ×•×©× ×ž×¡×“ × ×ª×•× ×™×.<br>×ž×ž×©×§ ×–×” ×™× ×¡×” ×œ×”×‘×™× ×œ×š ×‘×›×™×•×•×Ÿ ×”× ×›×•×Ÿ!<p></ce',0),(92865,2580,'el','<p><center><br>Î•Î¬Î½ Î­Ï‡ÎµÏ„Îµ Ï†Î¸Î¬ÏƒÎµÎ¹ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î¼Î·Î½ Ï€Î±Î½Î¹ÎºÎ¿Î²Î»Î·Î¸ÎµÎ¯Ï„Îµ.<br>Î•Î»Î­Î³Î¾Ï„Îµ ÏƒÎ±Ï‚ Î¸Î­ÏƒÎ· Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½, ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î·, ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒ',0),(92866,2580,'zh','<p>å¦‚æžœæ‚¨é‡åˆ°è¿™ä¸ªè®¾ç½®ä¸è¦æƒŠæ…Œã€‚æŸ¥çœ‹æ•°æ®åº“çš„ä½ç½®ï¼Œç”¨æˆ·åï¼Œå¯†ç å’Œæ•°æ®åº“åç§°ã€‚æ­¤ç•Œé¢å°†å°è¯•å¼•å¯¼æ‚¨åˆ°æ­£ç¡®çš„æ–¹å‘ï¼\r\n',0),(92867,2580,'sv','<p><center><br>Om du har nÃ¥tt denna instÃ¤llning inte panik.<br>Kontrollera din databasen, anvÃ¤ndarnamn, lÃ¶senord och databasens namn.<br>Detta grÃ¤nssnitt kommer att fÃ¶rsÃ¶ka fÃ¥ dig i rÃ¤tt riktning!<p></center>',0),(92868,2580,'it','<p><center><br>Se avete raggiunto questa configurazione non ti preoccupare.<br>Verifica il tuo percorso del Database, Username, Password e nome Database.<br>Questa interfaccia cercherÃ  di ottenere si diresse nella direzione giusta!<p></center>',0),(92869,2580,'tl','',0),(92870,2580,'th','<p><center><br>If you have reached this setup don\'t panic.<br> Check your Database Location, Username, Password, and Database Name.<br> This interface will try to get you headed in the right direction!</p>',0),(92871,2580,'hi','<p><center><br>à¤¯à¤¦à¤¿ à¤†à¤ª à¤¤à¤• à¤ªà¤¹à¥à¤à¤š à¤šà¥à¤•à¥‡ à¤¹à¥ˆà¤‚ à¤‡à¤¸ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤˜à¤¬à¤°à¤¾à¤“ à¤®à¤¤à¥¤<br>à¤…à¤ªà¤¨à¥‡ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨, à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤®, à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡, à¤”à¤° à',0),(92872,2580,'ms','<p><center><br>Jika anda telah mencapai persediaan ini jangan panik.<br>Semak lokasi pangkalan data, nama pengguna, kata laluan, dan nama pangkalan data.<br>Antaramuka ini akan cuba untuk mendapatkan anda diketuai dalam arah yang betul!<p></center>',0),(92873,2580,'ar','<p>ÙˆØµÙˆÙ„Ùƒ Ø¥Ù„Ù‰ Ù‡Ø°Ù‡ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ù„Ø§ ÙŠØ³ØªØ¯Ø¹ÙŠ Ø§Ù„Ø´Ø¹ÙˆØ± Ø¨Ø§Ù„Ø°Ø¹Ø±. ØªØ£ÙƒØ¯ Ù…Ù† ØµØ­Ø© Ø§Ù„Ù…ÙˆÙ‚Ø¹ØŒ ÙˆØ§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ØŒ ÙˆÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ±ØŒ ÙˆØ§Ø³Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª. Ø³ØªØ­Ø§ÙˆÙ„ Ù‡Ø°Ù‡ Ø§Ù„ÙˆØ§Ø¬Ù‡Ø© ',0),(92874,2580,'fr','<p><center><br>Cette configuration ne paniquez pas si vous avez atteint.<br>VÃ©rifier votre emplacement de base de donnÃ©es, nom d\'utilisateur, mot de passe et nom de base de donnÃ©es.<br>Cette interface va essayer de vous sur la bonne voie !<p></center>',0),(92875,2580,'jp','<p><center><br>ã‚‚ã?—ã?“ã?®è¨­å®šã?«ã?Ÿã?©ã‚Šç?€ã?„ã?¦ã‚‚æ…Œã?¦ã?ªã?„ã?§ä¸‹ã?•ã?„ã€‚<br>ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã€?ãƒ¦ãƒ¼ã‚¶ãƒ¼å??ã€?ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã€?ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹å??ã‚’ç¢ºèª?ã?—ã?¦ã??ã? ã?•ã?„ã€‚<br>ã?“ã?®ã‚¤ãƒ³ã‚¿ãƒ¼ãƒ•ã‚§ãƒ¼ã‚¹ã?¯æ­£ã',0),(92876,2580,'pt','<p><center><br>Se vocÃª ligou para esta configuraÃ§Ã£o nÃ£o entre em pÃ¢nico.<br>Verificar o seu local de banco de dados de usuÃ¡rio, senha e nome do banco de dados.<br>Essa interface vai tentar pegar vocÃª na direÃ§Ã£o certa!<p></center>',0),(92877,2580,'ru','<p><center><br>Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð´Ð¾ÑÑ‚Ð¸Ð³Ð»Ð¸ ÑÑ‚Ð¾Ð¹ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð½Ðµ Ð¿Ð°Ð½Ð¸ÐºÑƒÐ¹Ñ‚Ðµ.<br>ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…, Ð¸Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ, Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð¸ Ð¸Ð¼Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ….<br>Ð­Ñ‚',0),(92878,2580,'es','<p>Si ha alcanzado esta configuraciÃ³n no este en panico. Checar la LocaciÃ³n de Base de Datos, Nombre de Usuario, ContraseÃ±a, y Nombre de Base de Datos. Este interfase intentarÃ¡ dirigirle en el rumbo correcto!</p>',0),(92879,2580,'de','<p><center><br>Wenn Sie erreicht haben dieses Setup keine Panik.<br>ÃœberprÃ¼fen Sie Ihre Datenbankpfad, Benutzername, Kennwort und Datenbanknamen.<br>Diese Schnittstelle wird versuchen, Sie in die richtige Richtung geleitet!<p></center>',0),(92880,2580,'en','<p><center><br>If you have reached this setup don\'t panic.<br> Check your Database Location, Username, Password, and Database Name.<br> This interface will try to get you headed in the right direction!</p>',0),(92881,2581,'is','',0),(92882,2581,'dr','Ø®ÙˆØ§Ù†Ø¯Ù† ',0),(92883,2581,'pr','Ø®ÙˆØ§Ù†Ø¯Ù† ',0),(92884,2581,'tr','Oku',0),(92885,2581,'pl','Czytaj',0),(92886,2581,'bg','ÐŸÑ€Ð¾Ñ‡ÐµÑ‚Ð¸',0),(92887,2581,'ur','Ù…Ø·Ø§Ù„Ø¹Û',0),(92888,2581,'sr','Ð§Ð¸Ñ‚Ð°ÑšÐµ',0),(92889,2581,'vi','Äá»c',0),(92890,2581,'af','Lees',0),(92891,2581,'ro','Citeste',0),(92892,2581,'et','Loe',0),(92893,2581,'si','Branje',0),(92894,2581,'ba','Baca',0),(92895,2581,'nl','Lezen',0),(92896,2581,'fi','Lue',0),(92897,2581,'no','Les',0),(92898,2581,'da','LÃ¦s',0),(92899,2581,'ko','ì½ê¸°',0),(92900,2581,'he','×§×¨×™××”',0),(92901,2581,'el','Î‘Î½Î¬Î³Î½Ï‰ÏƒÎ·',0),(92902,2581,'zh','é˜…è¯»\r\n',0),(92903,2581,'sv','LÃ¤s',0),(92904,2581,'it','Lettura',0),(92905,2581,'tl','',0),(92906,2581,'th','&#3629;&#3656;&#3634;&#3609;',0),(92907,2581,'hi','à¤ªà¤¢à¤¼à¥‡à¤‚',0),(92908,2581,'ms','Baca',0),(92909,2581,'ar','Ù‚Ø±Ø§Ø¡Ø©',0),(92910,2581,'fr','Lire',0),(92911,2581,'jp','èª­ã‚€',0),(92912,2581,'pt','Leitura',0),(92913,2581,'ru','Ð§Ð¸Ñ‚Ð°Ñ‚ÑŒ',0),(92914,2581,'es','Leer',0),(92915,2581,'de','Lesen',0),(92916,2581,'en','Read',0),(92917,2582,'is','',0),(92918,2582,'dr','Ø®ÙˆØ§Ù†Ø¯Ù† Ù¾ÙŠØºØ§Ù… ',0),(92919,2582,'pr','Ø®ÙˆØ§Ù†Ø¯Ù† Ù¾ÙŠØºØ§Ù… ',0),(92920,2582,'tr','iletileri okuma',0),(92921,2582,'pl','Przeczytaj wiadomoÅ›ci',0),(92922,2582,'bg','Ñ‡ÐµÑ‚ÐµÐ½Ðµ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(92923,2582,'ur','Ù¾ÛŒØºØ§Ù…Ø§Øª Ù…Ø·Ø§Ù„Ø¹Û',0),(92924,2582,'sr','Ð¸Ð¸Ñ‚Ð°Ð¼ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(92925,2582,'vi','Ä‘á»c tin nháº¯n',0),(92926,2582,'af','lees boodskap (pe)',0),(92927,2582,'ro','Citeste mesajele',0),(92928,2582,'et','Loe sÃµnumit',0),(92929,2582,'si','branje sporoÄil',0),(92930,2582,'ba','membaca pesan',0),(92931,2582,'nl','berichten lezen',0),(92932,2582,'fi','Lue viestit',0),(92933,2582,'no','lese melding(er)',0),(92934,2582,'da','LÃ¦s meddelelse(r)',0),(92935,2582,'ko','ë©”ì‹œì§€ ì½ê¸°',0),(92936,2582,'he','×§×¨× ×”×•×“×¢×”/×•×ª',0),(92937,2582,'el','Î±Î½Î¬Î³Î½Ï‰ÏƒÎ· Î¼Î·Î½Ï…Î¼Î¬Ï„Ï‰Î½',0),(92938,2582,'zh','è¯»æ¶ˆæ¯ï¼ˆsï¼‰\r\n',0),(92939,2582,'sv','lÃ¤sa meddelanden',0),(92940,2582,'it','leggere messaggi',0),(92941,2582,'tl','',0),(92942,2582,'th','&#3629;&#3656;&#3634;&#3609;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(92943,2582,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤ªà¤¢à¤¼à¥‡à¤‚',0),(92944,2582,'ms','Baca mesej',0),(92945,2582,'ar','Ù‚Ø±Ø§Ø¡Ø© Ø§Ù„Ø±Ø³Ø§Ù„Ø© (Ø§Ù„Ø±Ø³Ø§Ø¦Ù„)',0),(92946,2582,'fr','lire les messages',0),(92947,2582,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’èª­ã‚€',0),(92948,2582,'pt','Leia a mensagem (ns)',0),(92949,2582,'ru','Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ(Ñ)',0),(92950,2582,'es','Leer mensaje(s)',0),(92951,2582,'de','Nachricht(en) gelesen',0),(92952,2582,'en','read message(s)',0),(92953,2583,'is','',0),(92954,2583,'dr','Ø¯Ù„ÙŠÙ„ ',0),(92955,2583,'pr','Ø¯Ù„ÙŠÙ„ ',0),(92956,2583,'tr','Nedeni',0),(92957,2583,'pl','PowÃ³d',0),(92958,2583,'bg','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(92959,2583,'ur','ÙˆØ¬Û',0),(92960,2583,'sr','Ð Ð°Ð·Ð»Ð¾Ð³',0),(92961,2583,'vi','NguyÃªn nhÃ¢n',0),(92962,2583,'af','Rede',0),(92963,2583,'ro','Motivul',0),(92964,2583,'et','PÃµhjus',0),(92965,2583,'si','Razlog',0),(92966,2583,'ba','Alasan',0),(92967,2583,'nl','Reden',0),(92968,2583,'fi','Syy',0),(92969,2583,'no','Grunn',0),(92970,2583,'da','Grund',0),(92971,2583,'ko','ì´ìœ ',0),(92972,2583,'he','×¡×™×‘×”',0),(92973,2583,'el','Î›ÏŒÎ³Î¿Ï‚',0),(92974,2583,'zh','åŽŸå› \r\n',0),(92975,2583,'sv','Anledning',0),(92976,2583,'it','Motivo',0),(92977,2583,'tl','',0),(92978,2583,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;',0),(92979,2583,'hi','à¤•à¤¾à¤°à¤£',0),(92980,2583,'ms','Sebab',0),(92981,2583,'ar','ÙˆØ§Ù„Ø³Ø¨Ø¨',0),(92982,2583,'fr','Raison',0),(92983,2583,'jp','ç?†ç”±',0),(92984,2583,'pt','RazÃ£o',0),(92985,2583,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(92986,2583,'es','RazÃ³n',0),(92987,2583,'de','Grund',0),(92988,2583,'en','Reason',0),(92989,2584,'is','',0),(92990,2584,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬Ø¯Ø¯',0),(92991,2584,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬Ø¯Ø¯',0),(92992,2584,'tr','Yeniden hesapla',0),(92993,2584,'pl','Oblicz ponownie',0),(92994,2584,'bg','ÐŸÑ€ÐµÐ¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ',0),(92995,2584,'ur','Ú©Ø§ Ù¾Ú¾Ø± Ø­Ø³Ø§Ø¨ Ù„Ú¯Ø§Ø¦ÛŒÚº',0),(92996,2584,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð½Ð¾ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ',0),(92997,2584,'vi','TÃ­nh láº¡i',0),(92998,2584,'af','Herbereken',0),(92999,2584,'ro','Recalculare',0),(93000,2584,'et','Arvuta Ã¼mber',0),(93001,2584,'si','IzraÄunaj znova',0),(93002,2584,'ba','Menghitung ulang',0),(93003,2584,'nl','Herberekenen',0),(93004,2584,'fi','Laske uudelleen',0),(93005,2584,'no','Omberegne',0),(93006,2584,'da','Genberegne',0),(93007,2584,'ko','ë‹¤ì‹œ ê³„ì‚°',0),(93008,2584,'he','×—×©×‘ ×©×•×‘',0),(93009,2584,'el','ÎÎ­Î¿Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚',0),(93010,2584,'zh','é‡æ–°è®¡ç®—\r\n',0),(93011,2584,'sv','BerÃ¤kna om',0),(93012,2584,'it','Ricalcolare',0),(93013,2584,'tl','',0),(93014,2584,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3651;&#3627;&#3617;&#3656;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(93015,2584,'hi','à¤«à¤¿à¤° à¤¸à¥‡ à¤ªà¤°à¤¿à¤•à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(93016,2584,'ms','Recalculate',0),(93017,2584,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø­Ø³Ø§Ø¨',0),(93018,2584,'fr','Recalculer',0),(93019,2584,'jp','å†?è¨ˆç®—',0),(93020,2584,'pt','Recalcular',0),(93021,2584,'ru','ÐŸÐµÑ€ÐµÑÑ‡ÐµÑ‚',0),(93022,2584,'es','Recalcular',0),(93023,2584,'de','Neu berechnen',0),(93024,2584,'en','Recalculate',0),(93025,2585,'is','',0),(93026,2585,'dr','Ø±Ø³ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± ÙØ§ÙŠÙ„ Ø§Ø³Øª ',0),(93027,2585,'pr','Ø±Ø³ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± ÙØ§ÙŠÙ„ Ø§Ø³Øª ',0),(93028,2585,'tr','GiriÅŸ dosyasÄ± zaten bu madde.',0),(93029,2585,'pl','Odbioru dla tego elementu juÅ¼ w pliku.',0),(93030,2585,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð²ÐµÑ‡Ðµ Ð²ÑŠÐ² Ñ„Ð°Ð¹Ð»Ð°.',0),(93031,2585,'ur','Ù…Ø³Ù„ Ù…ÛŒÚº Ù¾ÛÙ„Û’ ÛÛŒ Ø§Ø³ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ø±Ø³ÛŒØ¯ Û”',0),(93032,2585,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð²ÐµÑ› Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ.',0),(93033,2585,'vi','BiÃªn nháº­n cho hÃ ng nÃ y Ä‘Ã£ cÃ³ trong há»“ sÆ¡',0),(93034,2585,'af','Kwitansie vir hierdie item alreeds in lÃªer.',0),(93035,2585,'ro','Confirmare pentru acest element deja Ã®n fiÅŸier.',0),(93036,2585,'et','Seda Ã¼ksust juba faili kÃ¤tte.',0),(93037,2585,'si','Potrdilo za ta element Å¾e v datoteki.',0),(93038,2585,'ba','Tanda terima untuk item ini sudah dalam file.',0),(93039,2585,'nl','Ontvangst voor dit object al in bestand.',0),(93040,2585,'fi','Vastaanoton nimikkeelle jo tiedosto.',0),(93041,2585,'no','Kvittering pÃ¥ elementversjonen allerede i filen.',0),(93042,2585,'da','Kvitteringen for den pÃ¥gÃ¦ldende vare allerede i filen.',0),(93043,2585,'ko','ì´ë¯¸ íŒŒì¼ì—ì—ì„œì´ í•­ëª©ì— ëŒ€ í•œ ì˜ìˆ˜ì¦ìž…ë‹ˆë‹¤.',0),(93044,2585,'he','××™×©×•×¨ ×¢×‘×•×¨ ×¤×¨×™×˜ ×–×” ×›×‘×¨ ×‘×§×•×‘×¥.',0),(93045,2585,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î®Î´Î· ÏƒÏ„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿.',0),(93046,2585,'zh','è¿™ä¸ªé¡¹ç›®çš„æ”¶æ®å·²ç»åœ¨æ–‡ä»¶ä¸­ã€‚\r\n',0),(93047,2585,'sv','Kvitto fÃ¶r artikeln redan i filen.',0),(93048,2585,'it','Ricevuta per questa voce giÃ  nel file.',0),(93049,2585,'tl','',0),(93050,2585,'th','&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;&#3651;&#3609;&#3649;&#3615;&#3657;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3649;&#3621;&#3657;&#3623;',0),(93051,2585,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤®à¥‡à¤‚ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¸à¥€à¤¦à¥¤',0),(93052,2585,'ms','Resit untuk item ini sudah ada dalam fail.',0),(93053,2585,'ar','Ø§Ø³ØªÙ„Ø§Ù… Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù†ØµØ± Ù…Ø³Ø¨Ù‚Ø§Ù‹ ÙÙŠ Ø§Ù„Ù…Ù„Ù.',0),(93054,2585,'fr','RÃ©ception pour cette question dÃ©jÃ  dans le fichier.',0),(93055,2585,'jp','ã?“ã?®å“?ç›®ã?®é ˜å?Žæ›¸ã?¯ã?™ã?§ã?«ãƒ•ã‚¡ã‚¤ãƒ«ã?«ã?‚ã‚Šã?¾ã?™',0),(93056,2585,'pt','Recibo para este item jÃ¡ em arquivo.',0),(93057,2585,'ru','ÐšÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ñ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¿ÑƒÐ½ÐºÑ‚Ð° ÑƒÐ¶Ðµ Ð² Ñ„Ð°Ð¹Ð»Ðµ.',0),(93058,2585,'es','Recibo para este item ya esta en el file',0),(93059,2585,'de','Eingang fÃ¼r dieses Element bereits in Datei.',0),(93060,2585,'en','Receipt for this item already in file.',0),(93061,2586,'is','',0),(93062,2586,'dr','( Ù…Ø·Ø§Ù„Ø¨Ø§Øª',0),(93063,2586,'pr','Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠÙ‡Ø§ ( Ù…Ø·Ø§Ù„Ø¨Ø§Øª',0),(93064,2586,'tr','Alacaklar',0),(93065,2586,'pl','NaleÅ¼noÅ›ci',0),(93066,2586,'bg','Ð’Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ',0),(93067,2586,'ur','Ø±ÛŒÚ©ÛŒÙˆØ§Ø¨Ù„Ø§Ø³',0),(93068,2586,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(93069,2586,'vi','Pháº£i Thu',0),(93070,2586,'af','Bedrae ontvangbaar',0),(93071,2586,'ro','CreanÅ£e',0),(93072,2586,'et','NÃµuded',0),(93073,2586,'si','Terjatve',0),(93074,2586,'ba','Piutang',0),(93075,2586,'nl','Vorderingen',0),(93076,2586,'fi','Saamiset',0),(93077,2586,'no','Fordringer',0),(93078,2586,'da','Tilgodehavender',0),(93079,2586,'ko','ë¯¸ìˆ˜ê¸ˆ',0),(93080,2586,'he','×—×©×‘×•× ×•×ª ×—×™×™×‘×™×',0),(93081,2586,'el','Î•Î¹ÏƒÏ€ÏÎ±ÎºÏ„Î­Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(93082,2586,'zh','åº”æ”¶è´¦æ¬¾\r\n',0),(93083,2586,'sv','Fordringar',0),(93084,2586,'it','Crediti',0),(93085,2586,'tl','',0),(93086,2586,'th','&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(93087,2586,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¥‹à¤‚',0),(93088,2586,'ms','Penghutang',0),(93089,2586,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¯ÙŠÙ†ÙŠÙ†',0),(93090,2586,'fr','CrÃ©ances',0),(93091,2586,'jp','å?—å?–å‹˜å®š',0),(93092,2586,'pt','Contas a receber',0),(93093,2586,'ru','Ð”ÐµÐ±Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ',0),(93094,2586,'es','Cuentas por Cobrar',0),(93095,2586,'de','Forderungen',0),(93096,2586,'en','Receivables',0),(93097,2587,'is','',0),(93098,2587,'dr','Ø¯Ø±ÙŠØ§ÙØª Ø¨Ø¯ÙˆÙ† Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(93099,2587,'pr','Ø¯Ø±ÙŠØ§ÙØª Ø¨Ø¯ÙˆÙ† Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(93100,2587,'tr','PO bir liste almak',0),(93101,2587,'pl','Nie lista PO',0),(93102,2587,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚ Ð½ÑÐ¼Ð° PO ÑÐ¿Ð¸ÑÑŠÐº',0),(93103,2587,'ur','Ù†Û Ù¾Ùˆ ÙÛØ±Ø³Øª Ù…ÙˆØµÙˆÙ„',0),(93104,2587,'sr','ÐŸÑ€Ð¸Ð¼Ð¸ Ð½ÐµÐ¼Ð° ÐŸÐž Ð»Ð¸ÑÑ‚Ð¸',0),(93105,2587,'vi','Danh sÃ¡ch nháº­n khÃ´ng cÃ³ Ä‘Æ¡n mua hÃ ng',0),(93106,2587,'af','Geen AB Lys Ontvang',0),(93107,2587,'ro','Primi nici o listÄƒ de PO',0),(93108,2587,'et','Saada nr PO nimekirja',0),(93109,2587,'si','Prejeli seznam ni PO',0),(93110,2587,'ba','Menerima tidak ada daftar PO',0),(93111,2587,'nl','Ontvangen geen PO-lijst',0),(93112,2587,'fi','Vastaanottaa PO listan',0),(93113,2587,'no','Motta ingen PO',0),(93114,2587,'da','Modtag ingen PO liste',0),(93115,2587,'ko','ì•„ë‹ˆ í¬ ëª©ë¡ ë°›ê¸°',0),(93116,2587,'he','×œ×§×‘×œ ×©×•× ×¨×©×™×ž×” ×¤×•',0),(93117,2587,'el','Î›Î¬Î²ÎµÏ„Îµ ÎºÎ±Î¼Î¯Î± Î»Î¯ÏƒÏ„Î± PO',0),(93118,2587,'zh','å¾—ä¸åˆ°è®¢å•åˆ—è¡¨\r\n',0),(93119,2587,'sv','FÃ¥r ingen PO-lista',0),(93120,2587,'it','Non ricevere alcun elenco di PO',0),(93121,2587,'tl','',0),(93122,2587,'th','&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(93123,2587,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¹à¥€à¤‚ PO à¤¸à¥‚à¤šà¥€',0),(93124,2587,'ms','Menerima senarai PO tidak',0),(93125,2587,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù‚Ø§Ø¦Ù…Ø© Ù„Ø§ Ø¨Ùˆ',0),(93126,2587,'fr','Ne recevoir aucune liste de PO',0),(93127,2587,'jp','æ³¨æ–‡æ›¸ãƒªã‚¹ãƒˆã‚’å?—å?–ã?£ã?¦ã?„ã?¾ã?›ã‚“',0),(93128,2587,'pt','NÃ£o receber nenhuma lista de PO',0),(93129,2587,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº Ð½Ðµ PO',0),(93130,2587,'es','Recibir No. Lista de OC',0),(93131,2587,'de','Erhalten Sie keine PO-Liste',0),(93132,2587,'en','Receive No PO List',0),(93133,2588,'is','',0),(93134,2588,'dr','Ø¯Ø±ÙŠØ§ÙØª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(93135,2588,'pr','Ø¯Ø±ÙŠØ§ÙØª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(93136,2588,'tr','SipariÅŸ alma',0),(93137,2588,'pl','OtrzymujÄ… PO',0),(93138,2588,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° PO',0),(93139,2588,'ur','Ù¾Ùˆ ÙˆØµÙˆÙ„ Ú©Ø±ÛŒÚº',0),(93140,2588,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð¸ ÐŸÐž',0),(93141,2588,'vi','Nháº­n Ä‘Æ¡n mua hÃ ng',0),(93142,2588,'af','Ontvang AB',0),(93143,2588,'ro','Primi PO',0),(93144,2588,'et','Saada PO',0),(93145,2588,'si','Prejemajo pad',0),(93146,2588,'ba','Menerima PO',0),(93147,2588,'nl','Ontvangen PO',0),(93148,2588,'fi','Saada PO',0),(93149,2588,'no','Motta PO',0),(93150,2588,'da','Modtage PO',0),(93151,2588,'ko','í¬ë¥¼ ë°›ì„',0),(93152,2588,'he','×œ×§×‘×œ ×¤×•',0),(93153,2588,'el','Î›Î¬Î²ÎµÏ„Îµ PO',0),(93154,2588,'zh','æŽ¥æ”¶è®¢å•\r\n',0),(93155,2588,'sv','FÃ¥ PO',0),(93156,2588,'it','Ricevere PO',0),(93157,2588,'tl','',0),(93158,2588,'th','&#3619;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(93159,2588,'hi','PO à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(93160,2588,'ms','Menerima PO',0),(93161,2588,'ar','ØªÙ„Ù‚ÙŠ Ø¨Ùˆ',0),(93162,2588,'fr','Recevoir les PO',0),(93163,2588,'jp','POã‚’å?—é ˜',0),(93164,2588,'pt','Receber PO',0),(93165,2588,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ PO',0),(93166,2588,'es','Recibir OC',0),(93167,2588,'de','PO zu empfangen',0),(93168,2588,'en','Receive PO',0),(93169,2589,'is','',0),(93170,2589,'dr','Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(93171,2589,'pr','Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(93172,2589,'tr','AlÄ±nan',0),(93173,2589,'pl','OtrzymaÅ‚',0),(93174,2589,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸',0),(93175,2589,'ur','Ù…ÙˆØµÙˆÙ„',0),(93176,2589,'sr','ÐŸÑ€Ð¸Ð¼Ð¸Ð¾',0),(93177,2589,'vi','ÄÃ£ nháº­n',0),(93178,2589,'af','Ontvang',0),(93179,2589,'ro','Primit',0),(93180,2589,'et','Saadud',0),(93181,2589,'si','Prejel',0),(93182,2589,'ba','Menerima',0),(93183,2589,'nl','Ontvangen',0),(93184,2589,'fi','Saanut',0),(93185,2589,'no','Mottatt',0),(93186,2589,'da','Modtaget',0),(93187,2589,'ko','ë°›ì€',0),(93188,2589,'he','×”×ª×§×‘×œ',0),(93189,2589,'el','ÎˆÎ»Î±Î²Îµ',0),(93190,2589,'zh','æ”¶æ¬¾\r\n',0),(93191,2589,'sv','Fick',0),(93192,2589,'it','Ricevuto',0),(93193,2589,'tl','',0),(93194,2589,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(93195,2589,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(93196,2589,'ms','Diterima',0),(93197,2589,'ar','ÙˆØªÙ„Ù‚Ù‰',0),(93198,2589,'fr','ReÃ§u',0),(93199,2589,'jp','å?—é ˜æ¸ˆã?¿',0),(93200,2589,'pt','Recebido',0),(93201,2589,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ð»',0),(93202,2589,'es','Recibido',0),(93203,2589,'de','Empfangen',0),(93204,2589,'en','Received',0),(93205,2590,'is','',0),(93206,2590,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(93207,2590,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(93208,2590,'tr','AlÄ±nan sipariÅŸler',0),(93209,2590,'pl','Otrzymane zamÃ³wienia',0),(93210,2590,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(93211,2590,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…ÙˆØµÙˆÙ„',0),(93212,2590,'sr','ÐÐ°Ð»Ð¾Ð·Ð¸ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð¸',0),(93213,2590,'vi','ÄÃ£ nháº­n Ä‘Æ¡n hÃ ng',0),(93214,2590,'af','Bestellings Ontvang',0),(93215,2590,'ro','Comenzile primite',0),(93216,2590,'et','Saadud tellimused',0),(93217,2590,'si','Prejetih naroÄil',0),(93218,2590,'ba','Pesanan yang diterima',0),(93219,2590,'nl','Orders ontvangen',0),(93220,2590,'fi','Saadut tilaukset',0),(93221,2590,'no','Bestillinger',0),(93222,2590,'da','Ordrer modtaget',0),(93223,2590,'ko','ì ‘ìˆ˜ ëœ ì£¼ë¬¸',0),(93224,2590,'he','×”×”×–×ž× ×•×ª ×”×ª×§×‘×œ×•',0),(93225,2590,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹',0),(93226,2590,'zh','è®¢å•æ”¶åˆ°\r\n',0),(93227,2590,'sv','OrderingÃ¥ng',0),(93228,2590,'it','Ordini ricevuti',0),(93229,2590,'tl','',0),(93230,2590,'th','&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(93231,2590,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(93232,2590,'ms','Pesanan yang diterima',0),(93233,2590,'ar','ØªÙ„Ù‚ÙŠ Ø£ÙˆØ§Ù…Ø±',0),(93234,2590,'fr','Commandes recus',0),(93235,2590,'jp','å?—é ˜æ¸ˆæ³¨æ–‡',0),(93236,2590,'pt','Ordens recebidas',0),(93237,2590,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(93238,2590,'es','Ordenes Recibidos',0),(93239,2590,'de','Auftragseingang',0),(93240,2590,'en','Orders Received',0),(93241,2591,'is','',0),(93242,2591,'dr','Ø¯Ø±ÙŠØ§ÙØª ÙƒÙ†Ù†Ø¯Ù‡',0),(93243,2591,'pr','Ø¯Ø±ÙŠØ§ÙØª ÙƒÙ†Ù†Ø¯Ù‡',0),(93244,2591,'tr','AlÄ±cÄ±',0),(93245,2591,'pl','Odbiornik',0),(93246,2591,'bg','ÐŸÑ€Ð¸ÐµÐ¼Ð½Ð¸Ðº',0),(93247,2591,'ur','ÙˆØµÙˆÙ„Û',0),(93248,2591,'sr','ÐŸÑ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ðº',0),(93249,2591,'vi','NgÆ°á»i nháº­n',0),(93250,2591,'af','Ontvanger',0),(93251,2591,'ro','Receptor',0),(93252,2591,'et','VastuvÃµtja',0),(93253,2591,'si','Sprejemnik',0),(93254,2591,'ba','Penerima',0),(93255,2591,'nl','Ontvanger',0),(93256,2591,'fi','Vastaanotin',0),(93257,2591,'no','Mottaker',0),(93258,2591,'da','Modtager',0),(93259,2591,'ko','ìˆ˜ì‹ ê¸°',0),(93260,2591,'he','×ž×§×œ×˜',0),(93261,2591,'el','Î”Î­ÎºÏ„Î·',0),(93262,2591,'zh','æŽ¥æ”¶å™¨\r\n',0),(93263,2591,'sv','Mottagare',0),(93264,2591,'it','Ricevitore',0),(93265,2591,'tl','',0),(93266,2591,'th','&#3612;&#3641;&#3657;&#3619;&#3633;&#3610;',0),(93267,2591,'hi','à¤°à¤¿à¤¸à¥€à¤µà¤°',0),(93268,2591,'ms','Penerima',0),(93269,2591,'ar','Ø¬Ù‡Ø§Ø² Ø§Ù„Ø§Ø³ØªÙ‚Ø¨Ø§Ù„',0),(93270,2591,'fr','RÃ©cepteur',0),(93271,2591,'jp','å?—é ˜è€…',0),(93272,2591,'pt','Receptor',0),(93273,2591,'ru','ÐŸÑ€Ð¸ÐµÐ¼Ð½Ð¸Ðº',0),(93274,2591,'es','Receptor',0),(93275,2591,'de','Receiver',0),(93276,2591,'en','Receiver',0),(93277,2592,'is','',0),(93278,2592,'dr','- Ù†Ø§Ù… ÛŒÙˆØ²Ø±ÙŠ Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ',0),(93279,2592,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ù…Ø¬Ø¯Ø¯ â€“ Ø¨Ø±Ø±Ø³ÙŠ Ù…Ø¬Ø¯Ø¯  Ù…Ø­Ù„ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ â€“ Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§- Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ',0),(93280,2592,'tr','VeritabanÄ± konumu, veritabanÄ± adÄ±, kullanÄ±cÄ± adÄ± ve ÅŸifre tekrar kontrol',0),(93281,2592,'pl','SprawdÅº lokalizacjÄ™ bazy danych, nazwÄ™ bazy danych, nazwÄ™ uÅ¼ytkownika i hasÅ‚o',0),(93282,2592,'bg','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Database Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ, Ð¸Ð¼Ðµ Ð½Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸, Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(93283,2592,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ØŒ Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù†Ø§Ù…ØŒ ØµØ§Ø±Ù Ù†Ø§Ù… Ø§ÙˆØ± Ù¾Ø§Ø³ ÙˆØ±Úˆ Ú©ÛŒ Ù¾Ú¾Ø± Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(93284,2592,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°, Ð¸Ð¼Ðµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°, ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ Ð¸ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ',0),(93285,2592,'vi','Kiá»ƒm tra láº¡i vá»‹ trÃ­ dá»¯ liá»‡u, tÃªn, ngÆ°á»i sá»­ dá»¥ng vÃ  máº­t kháº©u',0),(93286,2592,'af','Recheck databasis ligging, databasis naam, gebruikersnaam en wagwoord',0),(93287,2592,'ro','VerificaÅ£i din nou locaÅ£ia bazei de date, numele bazei de date, numele de utilizator ÅŸi parola',0),(93288,2592,'et','Kontrolli andmebaasi asukoht, andmebaasi nimi, kasutajanimi ja parool',0),(93289,2592,'si','Ponovno preverite lokacijo baze podatkov, ime zbirke podatkov, uporabniÅ¡ko ime in geslo',0),(93290,2592,'ba','Memeriksa lokasi Database, nama Database, Username, dan Password',0),(93291,2592,'nl','Controleer de locatie van Database, databasenaam, gebruikersnaam en wachtwoord',0),(93292,2592,'fi','Tarkista tietokannan sijainti, tietokannan nimi, kÃ¤yttÃ¤jÃ¤tunnus ja salasana',0),(93293,2592,'no','Kontroller plasseringen databasen, databasenavn, brukernavn og passord',0),(93294,2592,'da','Recheck databaseplaceringen, databasenavn, Brugernavn og adgangskode',0),(93295,2592,'ko','ë°ì´í„°ë² ì´ìŠ¤ ìœ„ì¹˜, ë°ì´í„°ë² ì´ìŠ¤ ì´ë¦„, ì‚¬ìš©ìž ì´ë¦„ ë° ì•”í˜¸ë¥¼ ë‹¤ì‹œ í™•ì¸',0),(93296,2592,'he','×‘×“×•×§ ××ª ×ž×™×§×•× ×ž×¡×“ ×”× ×ª×•× ×™×, ×©× ×ž×¡×“ × ×ª×•× ×™×, ×ž×©×ª×ž×© ×•×¡×™×¡×ž×”',0),(93297,2592,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î¾Î±Î½Î¬ Ï„Î· Î¸Î­ÏƒÎ· Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½, Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ ÏŒÎ½Î¿Î¼Î±, ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· ÎºÎ±Î¹ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(93298,2592,'zh','é‡æ–°æ£€æŸ¥æ•°æ®åº“ä½ç½®ï¼Œæ•°æ®åº“åï¼Œç”¨æˆ·åå’Œå¯†ç \r\n',0),(93299,2592,'sv','Kontrollera databasen, databasnamn, anvÃ¤ndarnamn och lÃ¶senord',0),(93300,2592,'it','Ricontrollare la posizione del Database, nome del Database, Username e Password',0),(93301,2592,'tl','',0),(93302,2592,'th','Recheck Database Location, Database Name, Username, and Password',0),(93303,2592,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨, à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¨à¤¾à¤®, à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤”à¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤ªà¥à¤¨: à¤œà¤¾à¤à¤šà¥‡à¤‚',0),(93304,2592,'ms','Recheck lokasi pangkalan data, pangkalan data nama, nama pengguna dan kata laluan',0),(93305,2592,'ar','ØªØ£ÙƒØ¯ Ø«Ø§Ù†ÙŠØ© Ù…Ù† ØµØ­Ø© Ù…ÙˆÙ‚Ø¹ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§ØªØŒ ÙˆØ§Ø³Ù…Ù‡Ø§ØŒ ÙˆØ§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ØŒ ÙˆÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ±',0),(93306,2592,'fr','VÃ©rifiez l\'emplacement de la base de donnÃ©es, nom de base de donnÃ©es, nom d\'utilisateur et mot de passe',0),(93307,2592,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã€?ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹å??ã€?ãƒ¦ãƒ¼ã‚¶ãƒ¼å??ã€?ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã?®å†?ç¢ºèª?',0),(93308,2592,'pt','Verifique novamente o banco de dados local, nome do banco de dados, Username e senha',0),(93309,2592,'ru','Ð•Ñ‰Ðµ Ñ€Ð°Ð· Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…, Ð¸Ð¼Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…, Ð¸Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð¸ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ',0),(93310,2592,'es','Rechecar ColocaciÃ³n de Base de Datos, Nombre de Base de Datos, Nombre de Usuario y ContraseÃ±a',0),(93311,2592,'de','ÃœberprÃ¼fen Sie Speicherort der Datenbank, Datenbankname, Benutzername und Passwort',0),(93312,2592,'en','Recheck Database Location, Database Name, Username, and Password',0),(93313,2593,'is','',0),(93314,2593,'dr','(Ø«Ø¨Øª Ø³Ø§Ø¨Ù‚Ù‡ Ø¢ÙˆÛŒØ²',0),(93315,2593,'pr','Ø´Ù…Ø§Ø±Ø´ Ø±Ú©ÙˆØ±Ø¯(Ø«Ø¨Øª Ø³Ø§Ø¨Ù‚Ù‡ Ù…Ø¯Ø±Ùƒ',0),(93316,2593,'tr','KayÄ±t sayÄ±sÄ±',0),(93317,2593,'pl','Liczba rekordÃ³w',0),(93318,2593,'bg','Ð‘Ñ€Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(93319,2593,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§ Ø´Ù…Ø§Ø±',0),(93320,2593,'sr','Ð‘Ñ€Ð¾Ñ˜Ð°ÑšÐµ Ð·Ð°Ð¿Ð¸ÑÐ°',0),(93321,2593,'vi','Äáº¿m há»“ sÆ¡',0),(93322,2593,'af','Rekord tellings',0),(93323,2593,'ro','NumÄƒrul de Ã®nregistrare',0),(93324,2593,'et','Kirjete',0),(93325,2593,'si','Å tevilo zapisov',0),(93326,2593,'ba','Jumlah record',0),(93327,2593,'nl','Record Count',0),(93328,2593,'fi','Tietueiden mÃ¤Ã¤rÃ¤',0),(93329,2593,'no','Antall poster',0),(93330,2593,'da','Post Count',0),(93331,2593,'ko','ë ˆì½”ë“œ ìˆ˜',0),(93332,2593,'he','×¡×¤×™×¨×ª ×¨×©×•×ž×•×ª',0),(93333,2593,'el','Î Î»Î®Î¸Î¿Ï‚ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(93334,2593,'zh','è®°å½•è®¡æ•°\r\n',0),(93335,2593,'sv','Antal poster',0),(93336,2593,'it','Conteggio record',0),(93337,2593,'tl','',0),(93338,2593,'th','&#3609;&#3633;&#3610;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;',0),(93339,2593,'hi','à¤…à¤­à¤¿à¤²à¥‡à¤– à¤—à¤£à¤¨à¤¾',0),(93340,2593,'ms','Rekod kiraan',0),(93341,2593,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø³Ø¬Ù„Ù‘Ø§Øª',0),(93342,2593,'fr','Nombre d\'enregistrements',0),(93343,2593,'jp','è¨˜éŒ²ã‚«ã‚¦ãƒ³ãƒˆ',0),(93344,2593,'pt','Contagem de registro',0),(93345,2593,'ru','Ð§Ð¸ÑÐ»Ð¾ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(93346,2593,'es','Records Conteo',0),(93347,2593,'de','Anzahl der DatensÃ¤tze',0),(93348,2593,'en','Record Count',0),(93349,2594,'is','',0),(93350,2594,'dr','Ø§Ø³Ù†Ø§Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø³Øª Ø´Ø¯',0),(93351,2594,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø³Øª Ø´Ø¯',0),(93352,2594,'tr','KayÄ±t baÅŸarÄ±yla deftere nakledildi',0),(93353,2594,'pl','Rekordy zostaÅ‚y pomyÅ›lnie zaksiÄ™gowane',0),(93354,2594,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸Ñ‚Ðµ ÑÐ° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(93355,2594,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ØªÚ¾Ø§',0),(93356,2594,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÑÑƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸.',0),(93357,2594,'vi','Káº¿t chuyá»ƒn há»“ sÆ¡ thÃ nh cÃ´ng',0),(93358,2594,'af','Rekords was suksesvol gepos',0),(93359,2594,'ro','ÃŽnregistrÄƒrile au fost postate cu succes',0),(93360,2594,'et','Dokumendid konteeriti edukalt',0),(93361,2594,'si','Zapisi so bile uspeÅ¡no knjiÅ¾ene',0),(93362,2594,'ba','Catatan diposting berhasil',0),(93363,2594,'nl','Records zijn met succes geboekt',0),(93364,2594,'fi','Tietueet on kirjattu onnistuneesti',0),(93365,2594,'no','Poster ble bokfÃ¸rt vellykket',0),(93366,2594,'da','Posterne blev bogfÃ¸rt med succes',0),(93367,2594,'ko','ë ˆì½”ë“œê°€ëŠ” ì„±ê³µì ìœ¼ë¡œ ê²Œì‹œ ëœ',0),(93368,2594,'he','×¨×©×•×ž×•×ª ×¤×•×¨×¡×ž×• ×‘×”×¦×œ×—×”',0),(93369,2594,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ Ï€Î¿Ï… ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®Î¸Î·ÎºÎ±Î½ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(93370,2594,'zh','è®°å½•æˆåŠŸå‘å¸ƒ\r\n',0),(93371,2594,'sv','Poster bokfÃ¶rts framgÃ¥ngsrikt',0),(93372,2594,'it','Record sono stati inseriti con successo',0),(93373,2594,'tl','',0),(93374,2594,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(93375,2594,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¤à¥ˆà¤¨à¤¾à¤¤ à¤¥à¥‡',0),(93376,2594,'ms','Rekod yang dihantar telah berjaya',0),(93377,2594,'ar','Ø±Ø­Ù‘Ù„Øª Ø§Ù„Ø³Ø¬Ù„Ù‘Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(93378,2594,'fr','Dossiers ont Ã©tÃ© comptabilisÃ©es avec succÃ¨s',0),(93379,2594,'jp','è¨˜éŒ²ã?¯è¨ˆä¸Šã?•ã‚Œã?¾ã?—ã?Ÿ',0),(93380,2594,'pt','Registros foram postados com sucesso',0),(93381,2594,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ñ‹',0),(93382,2594,'es','Records se asentaron exitosamente',0),(93383,2594,'de','DatensÃ¤tze wurden erfolgreich verÃ¶ffentlicht.',0),(93384,2594,'en','Records were posted successfully',0),(93385,2595,'is','',0),(93386,2595,'dr','( Ø«Ø¨Øª',0),(93387,2595,'pr','ØªØ§Ø±ÙŠØ® Ø¯Ø±ÙŠØ§ÙØª ( Ø«Ø¨Øª',0),(93388,2595,'tr','Recv tarihi',0),(93389,2595,'pl','Recv Data',0),(93390,2595,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸ Ð´Ð°Ñ‚Ð°',0),(93391,2595,'ur','ÙˆØµÙˆÙ„ÛŒÚº ØªØ§Ø±ÛŒØ®',0),(93392,2595,'sr','ÐŸÑ€Ð¸Ð¼Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(93393,2595,'vi','NgÃ y nháº­n',0),(93394,2595,'af','Datum ontvang',0),(93395,2595,'ro','Data de primire',0),(93396,2595,'et','VÃµta vastu kuupÃ¤ev',0),(93397,2595,'si','Prejmi datum',0),(93398,2595,'ba','Tanggal recv',0),(93399,2595,'nl','Recv datum',0),(93400,2595,'fi','Vastaanota pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(93401,2595,'no','Recv dato',0),(93402,2595,'da','Recv dato',0),(93403,2595,'ko','Recv ë‚ ì§œ',0),(93404,2595,'he','×§×‘×œ ×ª××¨×™×š',0),(93405,2595,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®ÏˆÎ·',0),(93406,2595,'zh','æŽ¥æ”¶æ—¥æœŸ\r\n',0),(93407,2595,'sv','Recv datum',0),(93408,2595,'it','Recv data',0),(93409,2595,'tl','',0),(93410,2595,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(93411,2595,'hi','Recv à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(93412,2595,'ms','Tarikh terima',0),(93413,2595,'ar','ØªØ§Ø±ÙŠØ® Recv',0),(93414,2595,'fr','Recv Date',0),(93415,2595,'jp','å?—é ˜æ—¥',0),(93416,2595,'pt','Recv data',0),(93417,2595,'ru','Recv Ð”Ð°Ñ‚Ð°',0),(93418,2595,'es','Fecha de Recibir',0),(93419,2595,'de','Recv Datum',0),(93420,2595,'en','Recv Date',0),(93421,2596,'is','',0),(93422,2596,'dr','( Ø«Ø¨Øª) ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÙŠØ¯',0),(93423,2596,'pr','Ø¯Ø±ÙŠØ§ÙØª ( Ø«Ø¨Øª) Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(93424,2596,'tr','Recv PO',0),(93425,2596,'pl','Odebrano PO',0),(93426,2596,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ°',0),(93427,2596,'ur','ÙˆØµÙˆÙ„ÛŒÚº Ù¾Ùˆ',0),(93428,2596,'sr','ÐŸÑ€Ð¸Ð¼Ð¸ ÐŸÐž',0),(93429,2596,'vi','ÄÆ¡n mua hÃ ng Ä‘Ã£ nháº­n',0),(93430,2596,'af','Ontvang PO',0),(93431,2596,'ro','Primire PO',0),(93432,2596,'et','VÃµta vastu PO',0),(93433,2596,'si','Prejmi PO',0),(93434,2596,'ba','Recv PO',0),(93435,2596,'nl','Recv PO',0),(93436,2596,'fi','Vastaanota PO',0),(93437,2596,'no','Recv PO',0),(93438,2596,'da','Recv PO',0),(93439,2596,'ko','Recv í¬',0),(93440,2596,'he','×§×‘×œ ×¤×•',0),(93441,2596,'el','Î›Î®ÏˆÎ· PO',0),(93442,2596,'zh','æŽ¥æ”¶è®¢å•\r\n',0),(93443,2596,'sv','Recv PO',0),(93444,2596,'it','Recv PO',0),(93445,2596,'tl','',0),(93446,2596,'th','&#3619;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(93447,2596,'hi','Recv à¤ªà¥‹',0),(93448,2596,'ms','Terima PO',0),(93449,2596,'ar','Recv Ø¨Ùˆ',0),(93450,2596,'fr','Recv PO',0),(93451,2596,'jp','Receive PO',0),(93452,2596,'pt','Recv PO',0),(93453,2596,'ru','Recv PO',0),(93454,2596,'es','Recibir OC',0),(93455,2596,'de','Recv PO',0),(93456,2596,'en','Recv PO',0),(93457,2597,'is','',0),(93458,2597,'dr','( Ø«Ø¨Øª',0),(93459,2597,'pr','ÙˆØ§Ø­Ø¯ Ø¯Ø±ÙŠØ§ÙØª ( Ø«Ø¨Øª',0),(93460,2597,'tr','Recv birimi',0),(93461,2597,'pl','Recv jednostki',0),(93462,2597,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(93463,2597,'ur','ÙˆØµÙˆÙ„ÛŒÚº ÛŒÙˆÙ†Ù¹',0),(93464,2597,'sr','ÐŸÑ€Ð¸Ð¼Ð¸ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(93465,2597,'vi','ÄÆ¡n vá»‹ nháº­n',0),(93466,2597,'af','Ontvang eenheid',0),(93467,2597,'ro','Unitate de primire',0),(93468,2597,'et','VÃµta vastu Ã¼ksus',0),(93469,2597,'si','Prejmi enota',0),(93470,2597,'ba','Recv Unit',0),(93471,2597,'nl','Recv eenheid',0),(93472,2597,'fi','Vastaanota yksikkÃ¶',0),(93473,2597,'no','Recv enhet',0),(93474,2597,'da','Recv enhed',0),(93475,2597,'ko','Recv ë‹¨ìœ„',0),(93476,2597,'he','×§×‘×œ ×™×—×™×“×”',0),(93477,2597,'el','Î›Î®ÏˆÎ· Î¼Î¿Î½Î¬Î´Î±',0),(93478,2597,'zh','æŽ¥æ”¶å•ä½\r\n',0),(93479,2597,'sv','Recv enhet',0),(93480,2597,'it','Recv unitÃ ',0),(93481,2597,'tl','',0),(93482,2597,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(93483,2597,'hi','Recv à¤‡à¤•à¤¾à¤ˆ',0),(93484,2597,'ms','Unit terima',0),(93485,2597,'ar','ÙˆØ­Ø¯Ø© Recv',0),(93486,2597,'fr','UnitÃ© de recv',0),(93487,2597,'jp','å?—é ˜å?˜ä½?',0),(93488,2597,'pt','Unidade recv',0),(93489,2597,'ru','Recv Ð±Ð»Ð¾Ðº',0),(93490,2597,'es','Unidad de RecepciÃ³n',0),(93491,2597,'de','Recv-Einheit',0),(93492,2597,'en','Recv Unit',0),(93493,2598,'is','',0),(93494,2598,'dr','REDRAW  Ø±Ø³Ù… Ù…Ø¬Ø¯Ø¯',0),(93495,2598,'pr','REDRAW  Ø±Ø³Ù… Ù…Ø¬Ø¯Ø¯',0),(93496,2598,'tr','YENÄ°DEN Ã‡Ä°ZME',0),(93497,2598,'pl','PRZERYSUJ',0),(93498,2598,'bg','ÐŸÐ Ð•Ð¥Ð’ÐªÐ Ð›Ð˜Ð¢Ð•',0),(93499,2598,'ur','Ø±ÛŒÚˆØ±Ø§Ùˆ',0),(93500,2598,'sr','Ð˜Ð¡Ð¦Ð Ð¢ÐÐ’ÐÐŠÐ•',0),(93501,2598,'vi','Äá» nguyÃªn',0),(93502,2598,'af','TEKEN',0),(93503,2598,'ro','ASPIRA',0),(93504,2598,'et','JOONISTA',0),(93505,2598,'si','NARIÅ I',0),(93506,2598,'ba','REDRAW',0),(93507,2598,'nl','VERNIEUWEN',0),(93508,2598,'fi','PIIRTÃ„Ã„',0),(93509,2598,'no','TILBAKETREKKING',0),(93510,2598,'da','GENTEGNING',0),(93511,2598,'ko','ë‹¤ì‹œ ê·¸ë¦¬ê¸°',0),(93512,2598,'he','×œ×¦×™×™×¨ ×ž×—×“×©',0),(93513,2598,'el','Î‘ÎÎ‘Î£Î§Î•Î”ÎŠÎ‘Î£Î—Î£',0),(93514,2598,'zh','é‡åˆ’\r\n',0),(93515,2598,'sv','RITA',0),(93516,2598,'it','RIDISEGNARE',0),(93517,2598,'tl','',0),(93518,2598,'th','&#3607;&#3635;&#3651;&#3627;&#3657;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(93519,2598,'hi','REDRAW',0),(93520,2598,'ms','REDRAW',0),(93521,2598,'ar','ØªØ­Ø¯ÙŠØ«',0),(93522,2598,'fr','REDESSINER',0),(93523,2598,'jp','ä½œã‚Šç›´ã?—',0),(93524,2598,'pt','REDESENHAR',0),(93525,2598,'ru','ÐŸÐ•Ð Ð•Ð Ð˜Ð¡ÐžÐ’ÐšÐ',0),(93526,2598,'es','REDIBUJAR',0),(93527,2598,'de','NEUZEICHNEN',0),(93528,2598,'en','REDRAW',0),(93529,2599,'is','',0),(93530,2599,'dr','- ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¬Ø¯ÙŠØ¯ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(93531,2599,'pr','Ø´Ø±Ø­ Ø±Ø³Ù… Ù…Ø¬Ø¯Ø¯ â€“ Ø¨Ø±Ø§ÙŠ Ø¯ÙŠØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ - ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¬Ø¯ÙŠØ¯ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(93532,2599,'tr','Yeni eklenen vergiler, satÄ±ÅŸ temsilcileri, vb gÃ¶rmek iÃ§in burayÄ± tÄ±klatÄ±n.',0),(93533,2599,'pl','Kliknij tutaj, aby zobaczyÄ‡ nowo dodane podatkÃ³w, sprzedawcÃ³w, itp.',0),(93534,2599,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¾Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ Ð´Ð°Ð½ÑŠÑ†Ð¸, Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡Ð¸ Ð¸ Ð´Ñ€.',0),(93535,2599,'ur','Ù†Ùˆ Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Ù…Ø²ÛŒØ¯ Ù¹ÛŒÚ©Ø³ØŒ Ø³Ø§Ù„Ø§Ø³Ù¾Ø±Ø³Ù†Ø³ØŒ ÙˆØºÛŒØ±Û Û”',0),(93536,2599,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ñ‚ÐµÐº Ð´Ð¾Ð´Ð°Ñ‚ Ð¿Ð¾Ñ€ÐµÐ·, Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð¸ Ð¸Ñ‚Ð´.',0),(93537,2599,'vi','Nháº¥n vÃ o Ä‘Ã¢y xem thuáº¿, nhÃ¢n viÃªn kinh doanh vv má»›i thÃªm',0),(93538,2599,'af','Klik hier om te sien nuut bygevoeg belasting, salespersons, ens.',0),(93539,2599,'ro','Click aici pentru a vedea nou adÄƒugat taxe, agenÅ£ii de vÃ¢nzÄƒri, etc.',0),(93540,2599,'et','Siit leiad Ã¤sja lisatud maksud, mÃ¼Ã¼giesindajad jne.',0),(93541,2599,'si','Kliknite tukaj za prikaz novo dodani davki, prodajalci, itd.',0),(93542,2599,'ba','Klik di sini untuk melihat pajak baru ditambahkan, pramuniaga, dll.',0),(93543,2599,'nl','Klik hier voor nieuw toegevoegde belastingen, verkopers, enz.',0),(93544,2599,'fi','Klikkaa tÃ¤stÃ¤ nÃ¤hdÃ¤ksesi uusia veroja, myyjÃ¤t, jne.',0),(93545,2599,'no','Klikk her for Ã¥ se nylig tillagte skatter, selgere, etc.',0),(93546,2599,'da','Klik her for at se nytilfÃ¸jede skatter, sÃ¦lgere, osv.',0),(93547,2599,'ko','ìƒˆë¡œ ì¶”ê°€ ëœ ì„¸ê¸ˆ, ì˜ì—… ì‚¬ì› ë“±ì„ ë³¼ ìˆ˜ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(93548,2599,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×¨××•×ª ×ž×™×¡×™× ×—×“×©×™× ×©× ×•×¡×¤×•, ×× ×©×™ ×ž×›×™×¨×•×ª, ×•×›×• \'.',0),(93549,2599,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Ï€ÏÏŒÏƒÏ†Î±Ï„Î± Ï†ÏŒÏÎ¿Ï…Ï‚, Ï€Ï‰Î»Î·Ï„ÏŽÎ½, ÎºÎ»Ï€.',0),(93550,2599,'zh','ç‚¹å‡»è¿™é‡Œçœ‹æ–°å¢žçš„ç¨Žï¼Œé”€å”®å‘˜ç­‰\r\n',0),(93551,2599,'sv','Klicka hÃ¤r fÃ¶r att se nytillagda skatter, fÃ¶rsÃ¤ljare, etc.',0),(93552,2599,'it','Clicca qui per vedere le tasse appena aggiunte, commessi, ecc.',0),(93553,2599,'tl','',0),(93554,2599,'th','Click here to see newly added taxes, salespersons, etc.',0),(93555,2599,'hi','à¤¨à¤ à¤œà¥‹à¤¡à¤¼à¥‡ à¤—à¤ à¤•à¤°à¥‹à¤‚, salespersons, à¤†à¤¦à¤¿ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚à¥¤',0),(93556,2599,'ms','Klik di sini untuk melihat baru ditambah cukai, tenaga, dan sebagainya.',0),(93557,2599,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ù…Ø´Ø§Ù‡Ø¯Ø© Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø¶Ø§ÙØ© Ø­Ø¯ÙŠØ«Ø§ØŒ ÙˆØ¨Ø§Ø¦Ø¹Ø§ØªØŒ Ø¥Ù„Ø®.',0),(93558,2599,'fr','Cliquez ici pour voir des impÃ´ts nouvellement ajoutÃ©s, vendeurs, etc..',0),(93559,2599,'jp','æ–°è¦?ã?«è¿½åŠ ã?•ã‚Œã?Ÿç¨Žã€?ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…ã?ªã?©ã‚’è¦‹ã‚‹ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ã??ã? ã?•ã?„',0),(93560,2599,'pt','Clique aqui para ver os impostos adicionados recentemente, vendedores, etc.',0),(93561,2599,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑƒÐ²Ð¸Ð´ÐµÑ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¸, salespersons Ð¸ Ð´Ñ€.',0),(93562,2599,'es','Hace click aqui para ver impuestos nuevamente agregados, Proveedores, etc.',0),(93563,2599,'de','Klicken Sie hier, um zu sehen, neu hinzugefÃ¼gte steuern, VerkÃ¤ufer, etc..',0),(93564,2599,'en','Click here to see newly added taxes, salespersons, etc.',0),(93565,2600,'is','',0),(93566,2600,'dr','+ Ø§Ø¶Ø§ÙÙ‡ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ Ø±ÙˆÙŠ Ø¯ÙƒÙ…Ù‡ Ø±Ø³Ù… Ù…Ø¬Ø¯Ø¯ Ø¨Ø±Ø§ÙŠ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ø¢Ù† Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(93567,2600,'pr','Ù…ØªÙ† Ø±Ø³Ù… Ù…Ø¬Ø¯Ø¯ â€“ Ø§Ú¯Ø± Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø±Ø§ Ø¨Ø§ Ù†Ø´Ø§Ù†Ù‡ + Ø§Ø¶Ø§ÙÙ‡ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ Ø±ÙˆÙŠ Ø¯ÙƒÙ…Ù‡ Ø±Ø³Ù… Ù…Ø¬Ø¯Ø¯ Ø¨Ø±Ø§ÙŠ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ø¢Ù† ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(93568,2600,'tr','<small>(EÄŸer bilgi (+) ile ekleyerek simgesi,<br>Ã§izmeye gÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klatÄ±n)</small>',0),(93569,2600,'pl','<small>(jeÅ›li dodanie informacji z (+) ikonÄ™,<br>Kliknij przycisk odÅ›wieÅ¼ania, aby go wyÅ›wietliÄ‡)</small>',0),(93570,2600,'bg','<small>(Ð°ÐºÐ¾ Ð´Ð¾Ð±Ð°Ð²ÑÐ½ÐµÑ‚Ð¾ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ (+) Ð¸ÐºÐ¾Ð½Ð°,<br>Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»Ð¸Ñ‚Ðµ Ð´Ð° Ð³Ð¾ Ð¿Ð¾ÐºÐ°Ð¶ÐµÑ‚Ðµ)</small>',0),(93571,2600,'ur','<small>((+) Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’ ØªÙˆ Ø´Ø¨ÛŒÛØŒ<br>ÛŒÛ Ø¸Ø§ÛØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø±ÛŒÚˆØ±Ø§Ùˆ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº)</small>',0),(93572,2600,'sr','<small>(Ð°ÐºÐ¾ Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ Ð¸Ð½Ñ„Ð¾ ÑÐ° (+) Ð¸ÐºÐ¾Ð½Ð°,<br>ÐºÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð³Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð½Ð°Ñ†Ñ€Ñ‚Ð°Ñ‚Ð¸)</small>',0),(93573,2600,'vi','(náº¿u thÃªm thÃ´ng tin vá»›i biá»ƒu tÆ°á»£ng (+),nháº¥n Ä‘á» nguyÃªn Ä‘á»ƒ hiá»‡n thá»‹)',0),(93574,2600,'af','<small>(as voeg inligting met die (+) ikoon,<br>Klik teken om te wys dit)</small>',0),(93575,2600,'ro','<small>(dacÄƒ adÄƒugarea de informaÅ£ii cu (+) pictograma,<br>faceÅ£i clic pe carte ajutÄƒtoare pentru a afiÅŸa)</small>',0),(93576,2600,'et','<small>(kui lisada info (+) ikooni,<br>KlÃµpsake selle kuvamiseks vÃ¤rskendatakse)</small>',0),(93577,2600,'si','<small>(Äe seÅ¡tevanje zavijati s (+) ikona,<br>kliknite OsveÄ¾i razpoloÅ¾iti to)</small>',0),(93578,2600,'ba','<small>(jika menambahkan info dengan (+) ikon,<br>Klik redraw untuk menampilkannya)</small>',0),(93579,2600,'nl','<small>(als het toevoegen van info met het (+) pictogram,<br>Klik op vernieuwen om het weer te geven)</small>',0),(93580,2600,'fi','<small>(jos kartuttava neuvonta (+)-kuvaketta<br>Klikkaa hyvitys jotta nÃ¤yttÃ¤Ã¤)</small>',0),(93581,2600,'no','<small>(hvis tilfÃ¸yer info med (+)-ikonet<br>Klikk tegne for Ã¥ vise den)</small>',0),(93582,2600,'da','<small>(hvis tilfÃ¸jer info med (+) symbol,<br>Klik pÃ¥ gentegning for at vise det)</small>',0),(93583,2600,'ko','<small>((+) ì •ë³´ë¥¼ ì¶”ê°€ í•˜ëŠ” ê²½ìš° ì•„ì´ì½˜ì„<br>ê·¸ê²ƒì„ í‘œì‹œ í•˜ë ¤ë©´ ê·¸ë¦¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤)</small>',0),(93584,2600,'he','<small>(×× ×”×•×¡×¤×ª ×¤×¨×˜×™ ×¢× (+) ×¡×ž×œ,<br>×œ×—×¥ ×¢×œ ××™×©×•×¨×™× ×›×“×™ ×œ×”×¦×™×’×”)</small>',0),(93585,2600,'el','<small>(Î±Î½ Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÏŽ Î¼Îµ Ï„Î¿ (+) ÎµÎ¹ÎºÎ¿Î½Î¯Î´Î¹Î¿,<br>ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÎºÎ¿Ï…Î¼Ï€Î¯ Î±Î½Î±ÏƒÏ‡ÎµÎ´Î¯Î±ÏƒÎ·Ï‚ Î½Î± Ï„Î¿ ÎµÎ¼Ï†Î±Î½Î¯ÏƒÎµÏ„Îµ)</small>',0),(93586,2600,'zh','ï¼ˆå¦‚æžœåŠ ä¸Šä¸Žï¼ˆ+ï¼‰å›¾æ ‡ä¿¡æ¯ï¼Œç‚¹å‡»é‡åˆ’æ˜¾ç¤ºï¼‰\r\n',0),(93587,2600,'sv','<small>(om du lÃ¤gger till information med (+)-ikonen<br>Klicka pÃ¥ rita om du vill visa det)</small>',0),(93588,2600,'it','<small>(se l\'aggiunta di informazioni con il (+) icona,<br>fare clic su ridisegna per visualizzarla)</small>',0),(93589,2600,'tl','',0),(93590,2600,'th','<small>(if adding info with the (+) icon,<br>click redraw to display it)</small>',0),(93591,2600,'hi','<small>(à¤¯à¤¦à¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ (+) à¤•à¥‡ à¤¸à¤¾à¤¥ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤šà¤¿à¤¹à¥à¤¨,<br>redraw à¤‡à¤¸à¥‡ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚)</small>',0),(93592,2600,'ms','<small>(jika menambah maklumat dengan (+) ikon,<br>klik redraw untuk memaparkan ia)</small>',0),(93593,2600,'ar','<small>(ÙÙŠ Ø­Ø§Ù„Ø© Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø¹ (+) Ø§Ù„Ø±Ù…Ø²ØŒ<br>Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø±Ø³Ù… Ù„Ø¹Ø±Ø¶ Ø¹Ù„ÙŠÙ‡)</small>',0),(93594,2600,'fr','<small>(si vous ajoutez des infos avec le signe (+) icÃ´ne,<br>Cliquez sur nouveau dessin afin de l\'afficher)</small>',0),(93595,2600,'jp','<small>((+)ã‚¢ã‚¤ã‚³ãƒ³ã‚’ä½¿ã?£ã?Ÿæƒ…å ±ã‚’è¿½åŠ ã?™ã‚‹ã?ªã‚‰,<br>ã??ã‚Œã‚’è¡¨ç¤ºã?•ã?›ã‚‹ã?Ÿã‚?ã?«ä½œã‚Šç›´ã?—ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„ã€‚)</small>',0),(93596,2600,'pt','<small>(se adicionando informaÃ§Ã£o com o (+) Ã­cone,<br>Clique o redesenho de tela para exibi-la)</small>',0),(93597,2600,'ru','<small>(ÐµÑÐ»Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ (+) Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð½Ð°Ñ‡Ð¾Ðº,<br>ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐºÐ½Ð¾Ð¿ÐºÑƒ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð´Ð»Ñ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ)</small>',0),(93598,2600,'es','<chico>(si agregar info con el signo (+), <br>hace click en redibujar para desplegarlo)</chico>',0),(93599,2600,'de','<small>(wenn Info mit der (+) hinzufÃ¼gen-Symbol,<br>Klicken Sie auf neu zeichnen, um es anzuzeigen)</small>',0),(93600,2600,'en','<small>(if adding info with the (+) icon,<br>click redraw to display it)</small>',0),(93601,2601,'is','',0),(93602,2601,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø¹Ø±Ù',0),(93603,2601,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø¹Ø±Ù',0),(93604,2601,'tr','Referans numarasÄ±',0),(93605,2601,'pl','Numer referencyjny',0),(93606,2601,'bg','Ð ÐµÑ„ÐµÑ€ÐµÐ½Ñ‚ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(93607,2601,'ur','Ø­ÙˆØ§Ù„Û Ù†Ù…Ø¨Ø±',0),(93608,2601,'sr','Ð ÐµÑ„ÐµÑ€ÐµÐ½Ñ‚Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(93609,2601,'vi','Sá»‘ Tham kháº£o',0),(93610,2601,'af','Verwysing Nommer',0),(93611,2601,'ro','NumÄƒrul de referinÈ›Äƒ',0),(93612,2601,'et','Viitenumber',0),(93613,2601,'si','ReferenÄna Å¡tevilka',0),(93614,2601,'ba','Nomor referensi',0),(93615,2601,'nl','Referentienummer',0),(93616,2601,'fi','Viitenumero',0),(93617,2601,'no','Referansenummeret',0),(93618,2601,'da','Referencenummer',0),(93619,2601,'ko','ì°¸ì¡° ë²ˆí˜¸',0),(93620,2601,'he','×ž×¡×¤×¨ ×¡×™×ž×•×›×™×Ÿ',0),(93621,2601,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(93622,2601,'zh','å‚è€ƒå·ç \r\n',0),(93623,2601,'sv','Referensnummer',0),(93624,2601,'it','Numero di riferimento',0),(93625,2601,'tl','',0),(93626,2601,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3629;&#3657;&#3634;&#3591;&#3629;&#3636;&#3591;',0),(93627,2601,'hi','à¤¸à¤‚à¤¦à¤°à¥à¤­ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(93628,2601,'ms','Nombor rujukan',0),(93629,2601,'ar','Ø§Ù„Ø±Ù‚Ù… Ø§Ù„Ù…Ø±Ø¬Ø¹ÙŠ',0),(93630,2601,'fr','NumÃ©ro de rÃ©fÃ©rence',0),(93631,2601,'jp','å?‚ç…§ç•ªå?·',0),(93632,2601,'pt','NÃºmero de referÃªncia',0),(93633,2601,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑÑ‹Ð»ÐºÐ¸',0),(93634,2601,'es','NÃºmero de Referencia',0),(93635,2601,'de','Referenznummer',0),(93636,2601,'en','Reference Number',0),(93637,2602,'is','',0),(93638,2602,'dr','+ Ø±ÙˆØ²Ø§Ù†Ù‡ + Ø§Ù†ØªØ®Ø§Ø¨',0),(93639,2602,'pr','Ø¹Ø§Ø¯ÙŠ + Ø±ÙˆØ²Ø§Ù†Ù‡ + Ø§Ù†ØªØ®Ø§Ø¨',0),(93640,2602,'tr','Normal + gÃ¼nlÃ¼k + pikap',0),(93641,2602,'pl','Regularne + codziennie + Pickup',0),(93642,2602,'bg','Ð ÐµÐ´Ð¾Ð²Ð½Ð¸ + Ð´Ð½ÐµÐ²Ð½Ð¾ + Ð¿Ð¸ÐºÐ°Ð¿',0),(93643,2602,'ur','Ø¨Ø§Ù‚Ø§Ø¹Ø¯Û + Ø±ÙˆØ²Ø§Ù†Û + Ø§Ù¹Ú¾Ø§ Ù„ÛŒÙ†Ø§ Û”',0),(93644,2602,'sr','Ð ÐµÐ³ÑƒÐ»Ð°Ñ€Ð½Ð° + Ð´Ð½ÐµÐ²Ð½Ð¸ + Ð¿Ð¸ÐºÐ°Ð¿.',0),(93645,2602,'vi','ThÃ´ng thÆ°á»ng+HÃ ng ngÃ y+Nháº­n hÃ ng',0),(93646,2602,'af','Gereelde+Daaglikse+\"Pickup\"',0),(93647,2602,'ro','Regulate + zi + Pickup',0),(93648,2602,'et','Regulaarne + iga pÃ¤ev + pikap',0),(93649,2602,'si','Redno + dnevno + Pickup',0),(93650,2602,'ba','Biasa + harian + Pickup',0),(93651,2602,'nl','Regelmatige + dagelijks + Pickup',0),(93652,2602,'fi','SÃ¤Ã¤nnÃ¶llinen + pÃ¤ivittÃ¤in + Pickup',0),(93653,2602,'no','Vanlig + daglig + Pickup',0),(93654,2602,'da','RegelmÃ¦ssig + daglig + Pickup',0),(93655,2602,'ko','ì¼ë°˜ + ì¼ìƒ + í”½ì—…',0),(93656,2602,'he','×¨×’×™×œ + ×™×•×ž×™ + ××™×¡×•×£',0),(93657,2602,'el','Î¤Î±ÎºÏ„Î¹ÎºÎ® + ÎºÎ±Î¸Î·Î¼ÎµÏÎ¹Î½Î¬ + Pickup',0),(93658,2602,'zh','ä¾‹è¡Œ+æ¯æ—¥+æŽ¥é€\r\n',0),(93659,2602,'sv','Regelbunden + dagligen + Pickup',0),(93660,2602,'it','Regolare + quotidiano + Pickup',0),(93661,2602,'tl','',0),(93662,2602,'th','&#3608;&#3619;&#3619;&#3617;&#3604;&#3634;+&#3607;&#3640;&#3585;&#3623;&#3633;&#3609;+&#3610;&#3619;&#3619;&#3607;&#3640;&#3585;',0),(93663,2602,'hi','à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ + à¤¦à¥ˆà¤¨à¤¿à¤• + à¤¬à¤Ÿà¥‹à¤°à¤¨à¤¾',0),(93664,2602,'ms','Biasa + harian + pikap',0),(93665,2602,'ar','Ø§Ù„Ø¹Ø§Ø¯ÙŠØ© + Ø§Ù„ÙŠÙˆÙ…ÙŠØ© + Ø¨ÙŠÙƒ Ø¢Ø¨',0),(93666,2602,'fr','Tous les jours + rÃ©gulier + ramassage',0),(93667,2602,'jp','å®šæœŸ+æ¯Žæ—¥+å?Žé›†',0),(93668,2602,'pt','Regular + diÃ¡ria + Pickup',0),(93669,2602,'ru','Ð ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ñ‹Ðµ + ÐµÐ¶ÐµÐ´Ð½ÐµÐ²Ð½Ð¾ + Ð¿Ð¸ÐºÐ°Ð¿',0),(93670,2602,'es','Regular+Diario+Recoger',0),(93671,2602,'de','RegelmÃ¤ÃŸige + tÃ¤glich + Pickup',0),(93672,2602,'en','Regular+Daily+Pickup',0),(93673,2603,'is','',0),(93674,2603,'dr','(Ù…Ø±ØªØ¨Ø·) ÙˆØ§Ø¨Ø³ØªÙ‡ ',0),(93675,2603,'pr','ÙƒØ§Ù„Ø§ÙŠ(Ù…Ø±ØªØ¨Ø·) ÙˆØ§Ø¨Ø³ØªÙ‡ ',0),(93676,2603,'tr','Ä°lgili madde',0),(93677,2603,'pl','PowiÄ…zanego element',0),(93678,2603,'bg','Ð¡Ð²ÑŠÑ€Ð·Ð°Ð½ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(93679,2603,'ur','Ù…ØªØ¹Ù„Ù‚Û Ø¢Ø¦Ù¹Ù…',0),(93680,2603,'sr','Ð¡Ñ€Ð¾Ð´Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(93681,2603,'vi','HÃ ng liÃªn quan',0),(93682,2603,'af','Verwante Item',0),(93683,2603,'ro','Element de legÄƒturÄƒ',0),(93684,2603,'et','Seonduva kauba',0),(93685,2603,'si','Sorodni element',0),(93686,2603,'ba','Item terkait',0),(93687,2603,'nl','Gerelateerde Item',0),(93688,2603,'fi','Kohteen',0),(93689,2603,'no','Beslektet element',0),(93690,2603,'da','Relaterede vares',0),(93691,2603,'ko','ê´€ë ¨ëœ í•­ëª©',0),(93692,2603,'he','×”×¤×¨×™×˜ ×§×©×•×¨×™×',0),(93693,2603,'el','Î£Ï‡ÎµÏ„Î¹ÎºÏŽÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(93694,2603,'zh','ç›¸å…³é¡¹ç›®\r\n',0),(93695,2603,'sv','Relaterade objekt',0),(93696,2603,'it','Articolo correlato',0),(93697,2603,'tl','',0),(93698,2603,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591;&#3585;&#3633;&#3609;',0),(93699,2603,'hi','à¤¸à¤‚à¤¬à¤‚à¤§à¤¿à¤¤ à¤†à¤‡à¤Ÿà¤®',0),(93700,2603,'ms','Item berkaitan',0),(93701,2603,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ù…ØªØµÙ„ Ø¨Ø§Ù„Ù…ÙˆØ¶ÙˆØ¹',0),(93702,2603,'fr','Article connexe',0),(93703,2603,'jp','é–¢é€£å“?ç›®',0),(93704,2603,'pt','Item relacionado',0),(93705,2603,'ru','Ð¡Ð²ÑÐ·Ð°Ð½Ð½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(93706,2603,'es','Item Relacionado',0),(93707,2603,'de','Verwandte Artikel',0),(93708,2603,'en','Related Item',0),(93709,2604,'is','',0),(93710,2604,'dr','(Ù…Ø±ØªØ¨Ø·)ÙˆØ§Ø¨Ø³ØªÙ‡ ',0),(93711,2604,'pr','ÙƒØ¯ ÙƒØ§Ù„Ø§ÙŠ (Ù…Ø±ØªØ¨Ø·)ÙˆØ§Ø¨Ø³ØªÙ‡ ',0),(93712,2604,'tr','Ä°lgili madde kodu',0),(93713,2604,'pl','Kod towaru zwiÄ…zane z',0),(93714,2604,'bg','ÐšÐ¾Ð´ Ð½Ð° ÑÐ²ÑŠÑ€Ð·Ð°Ð½Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(93715,2604,'ur','Ù…ØªØ¹Ù„Ù‚Û Ø´Û’ Ú©ÙˆÚˆ',0),(93716,2604,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð¿Ð¾Ð²ÐµÐ·Ð°Ð½Ð¸Ñ… Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(93717,2604,'vi','MÃ£ hÃ ng liÃªn quan',0),(93718,2604,'af','Verwante Item Kode',0),(93719,2604,'ro','Cod articol legate',0),(93720,2604,'et','Seonduva kauba kood',0),(93721,2604,'si','Sorodni element koda',0),(93722,2604,'ba','Kode Item terkait',0),(93723,2604,'nl','Gerelateerde Item Code',0),(93724,2604,'fi','LiittyvÃ¤n nimikkeen koodi',0),(93725,2604,'no','Relaterte Varekode',0),(93726,2604,'da','Relaterede varekode',0),(93727,2604,'ko','ê´€ë ¨ëœ í•­ëª© ì½”ë“œ',0),(93728,2604,'he','×§×•×“ ×¤×¨×™×˜ ×”×§×©×•×¨',0),(93729,2604,'el','Î£Ï‡ÎµÏ„Î¹ÎºÏŽÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ ÎºÏŽÎ´Î¹ÎºÎ±',0),(93730,2604,'zh','æœ‰å…³é¡¹ç›®çš„ä»£ç \r\n',0),(93731,2604,'sv','Relaterade Artikelkod',0),(93732,2604,'it','Codice articolo correlato',0),(93733,2604,'tl','',0),(93734,2604,'th','&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591;&#3585;&#3633;&#3609;',0),(93735,2604,'hi','à¤¸à¤‚à¤¬à¤‚à¤§à¤¿à¤¤ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡',0),(93736,2604,'ms','Kod Item berkaitan',0),(93737,2604,'ar','ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù Ø°Ø§Øª Ø§Ù„ØµÙ„Ø©',0),(93738,2604,'fr','Code article connexes',0),(93739,2604,'jp','é–¢é€£å“?ç›®ã‚³ãƒ¼ãƒ‰',0),(93740,2604,'pt','CÃ³digo do Item relacionado',0),(93741,2604,'ru','Ð¡Ð²ÑÐ·Ð°Ð½Ð½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÐ¾Ð´Ð°',0),(93742,2604,'es','CÃ³digo de Item Relacionado',0),(93743,2604,'de','Verwandte Artikelcode',0),(93744,2604,'en','Related Item Code',0),(93745,2605,'is','',0),(93746,2605,'dr','(Ù…Ø±ØªØ¨Ø·) ÙˆØ§Ø¨Ø³ØªÙ‡ ',0),(93747,2605,'pr','Ù…ÙˆØ¶ÙˆØ¹Ø§Øª(Ù…Ø±ØªØ¨Ø·) ÙˆØ§Ø¨Ø³ØªÙ‡ ',0),(93748,2605,'tr','Ä°lgili konular',0),(93749,2605,'pl','Tematy pokrewne',0),(93750,2605,'bg','Ð¡Ð²ÑŠÑ€Ð·Ð°Ð½Ð¸ Ñ‚ÐµÐ¼Ð¸',0),(93751,2605,'ur','Ù…ØªØ¹Ù„Ù‚Û Ù…ÙˆØ¶ÙˆØ¹Ø§Øª',0),(93752,2605,'sr','Ð¡Ñ€Ð¾Ð´Ð½Ðµ Ñ‚ÐµÐ¼Ðµ',0),(93753,2605,'vi','Chá»§ Ä‘á» liÃªn quan',0),(93754,2605,'af','Verwante onderwerpe',0),(93755,2605,'ro','Subiecte conexe',0),(93756,2605,'et','Seotud teemadel',0),(93757,2605,'si','Sorodne teme',0),(93758,2605,'ba','Topik terkait',0),(93759,2605,'nl','Verwante onderwerpen',0),(93760,2605,'fi','Aiheeseen liittyviÃ¤',0),(93761,2605,'no','Beslektede emner',0),(93762,2605,'da','Relaterede emner',0),(93763,2605,'ko','ê´€ë ¨ëœ í•­ëª©',0),(93764,2605,'he','× ×•×©××™× ×§×©×•×¨×™×',0),(93765,2605,'el','Î£Ï‡ÎµÏ„Î¹ÎºÎ¬ Î¸Î­Î¼Î±Ï„Î±',0),(93766,2605,'zh','ç›¸å…³ä¸»é¢˜\r\n',0),(93767,2605,'sv','NÃ¤rliggande information',0),(93768,2605,'it','Argomenti correlati',0),(93769,2605,'tl','',0),(93770,2605,'th','&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591;&#3585;&#3633;&#3609;',0),(93771,2605,'hi','à¤¸à¤‚à¤¬à¤‚à¤§à¤¿à¤¤ à¤µà¤¿à¤·à¤¯',0),(93772,2605,'ms','Topik-topik berkaitan',0),(93773,2605,'ar','Ù…ÙˆØ§Ø¶ÙŠØ¹ Ø°Ø§Øª ØµÙ„Ø©',0),(93774,2605,'fr','Sujets connexes',0),(93775,2605,'jp','é–¢é€£ãƒˆãƒ”ãƒƒã‚¯',0),(93776,2605,'pt','TÃ³picos relacionados',0),(93777,2605,'ru','Ð¡Ð²ÑÐ·Ð°Ð½Ð½Ñ‹Ðµ Ñ‚ÐµÐ¼Ñ‹',0),(93778,2605,'es','TÃ³picos Relacionados',0),(93779,2605,'de','Verwandte Themen',0),(93780,2605,'en','Related topics',0),(93781,2606,'is','',0),(93782,2606,'dr','Ø¨Ø§Ù‚ÙŠ Ù…Ø§Ù†Ø¯Ù‡',0),(93783,2606,'pr','Ø¨Ø§Ù‚ÙŠ Ù…Ø§Ù†Ø¯Ù‡',0),(93784,2606,'tr','Kalan',0),(93785,2606,'pl','PozostaÅ‚e',0),(93786,2606,'bg','ÐžÑÑ‚Ð°Ð½Ð°Ð»Ð¸Ñ‚Ðµ',0),(93787,2606,'ur','Ø¨Ø§Ù‚ÛŒ',0),(93788,2606,'sr','ÐŸÑ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾',0),(93789,2606,'vi','CÃ²n láº¡i',0),(93790,2606,'af','Oorblywend',0),(93791,2606,'ro','RÄƒmase',0),(93792,2606,'et','ÃœlejÃ¤Ã¤nud',0),(93793,2606,'si','Preostale',0),(93794,2606,'ba','Sisa',0),(93795,2606,'nl','Resterende',0),(93796,2606,'fi','JÃ¤ljellÃ¤',0),(93797,2606,'no','GjenvÃ¦rende',0),(93798,2606,'da','Resterende',0),(93799,2606,'ko','ë‚¨ì€',0),(93800,2606,'he','×”× ×•×ª×¨×™×',0),(93801,2606,'el','Î‘Ï€Î¿Î¼Î­Î½Î¿Ï…Î½',0),(93802,2606,'zh','å‰©ä½™\r\n',0),(93803,2606,'sv','Ã…terstÃ¥ende',0),(93804,2606,'it','Rimanendo',0),(93805,2606,'tl','',0),(93806,2606,'th','&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(93807,2606,'hi','à¤¶à¥‡à¤·',0),(93808,2606,'ms','Baki',0),(93809,2606,'ar','Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(93810,2606,'fr','Restant',0),(93811,2606,'jp','æ®‹ã‚Šã?®',0),(93812,2606,'pt','Restantes',0),(93813,2606,'ru','ÐžÑÑ‚Ð°Ð²ÑˆÐ¸ÐµÑÑ',0),(93814,2606,'es','Restante',0),(93815,2606,'de','Nummer(n)',0),(93816,2606,'en','Remaining',0),(93817,2607,'is','',0),(93818,2607,'dr','Ø¨Ù‡ ÙŠØ§Ø¯ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÙŠØ¯ ÙƒÙ‡ Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø´Ù…Ø§ Ø§Ø³Øª',0),(93819,2607,'pr','Ø¨Ù‡ ÙŠØ§Ø¯ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÙŠØ¯ ÙƒÙ‡ Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø´Ù…Ø§ Ø§Ø³Øª',0),(93820,2607,'tr','Sizin mali baÅŸlar unutmayÄ±n ayÄ±dÄ±r',0),(93821,2607,'pl','PamiÄ™taj, aby rozpoczÄ…Ä‡ swÃ³j finansowy jest miesiÄ…c',0),(93822,2607,'bg','ÐÐµ Ð·Ð°Ð±Ñ€Ð°Ð²ÑÐ¹Ñ‚Ðµ, Ñ‡Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð½Ð°Ñ‚ Ð¼ÐµÑÐµÑ† Ðµ',0),(93823,2607,'ur','ÛŒØ§Ø¯ Ø±ÛÛ’ Ú©Û Ø¢Ù¾ Ù…Ø§Ù„ÛŒ Ú©Ø§ Ø¢ØºØ§Ø² Ù…ÛÛŒÙ†Û ÛÛ’',0),(93824,2607,'sr','Ð—Ð°Ð¿Ð°Ð¼Ñ‚Ð¸ Ð´Ð° Ñ˜Ðµ Ñ‚Ð²Ð¾Ñ˜ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð¿Ð¾Ñ‡ÐµÑ‚Ð¸ Ñ˜Ðµ Ð¼ÐµÑÐµÑ†',0),(93825,2607,'vi','Ghi nhá»› thÃ¡ng báº¯t Ä‘áº§u nÄƒm tÃ i chÃ­nh cá»§a báº¡n lÃ ',0),(93826,2607,'af','Onthou dat jou Fiskale begin maand is',0),(93827,2607,'ro','AmintiÅ£i-vÄƒ cÄƒ vÄƒ fiscale Ã®ncepe luna este',0),(93828,2607,'et','Pea meeles, et teie majandusaasta algab kuu on',0),(93829,2607,'si','Ne pozabite, da vaÅ¡e poslovno zaÄeli mesec je',0),(93830,2607,'ba','Ingat bahwa fiskal Anda mulai bulan adalah',0),(93831,2607,'nl','Vergeet niet dat uw fiscale beginnen maand is',0),(93832,2607,'fi','Muista, ettÃ¤ sinun tilikauden alkaa kuukausi on',0),(93833,2607,'no','Husk at din regnskapsÃ¥ret begynner mÃ¥neden er',0),(93834,2607,'da','Husk at din skatte begynde mÃ¥ned er',0),(93835,2607,'ko','ë‹¹ì‹ ì˜ íšŒê³„ ì‹œìž‘ ê¸°ì–µ ë‹¬ìž…ë‹ˆë‹¤',0),(93836,2607,'he','×–×›×•×¨ ×›×™ ×”×›×¡×¤×™× ×©×œ×š ×œ×”×ª×—×™×œ ×”×—×•×“×©',0),(93837,2607,'el','Î˜Ï…Î¼Î·Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ Ï„Î¿ Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ ÏƒÎ±Ï‚ Î±ÏÏ‡Î¯ÏƒÎµÎ¹ Î¼Î®Î½Î± ÎµÎ¯Î½Î±Î¹',0),(93838,2607,'zh','è®°ä½ï¼Œä½ çš„è´¢æ”¿å¼€å§‹æœˆä¸º\r\n',0),(93839,2607,'sv','Kom ihÃ¥g att ditt rÃ¤kenskapsÃ¥r bÃ¶rjar mÃ¥nad Ã¤r',0),(93840,2607,'it','Ricordate che vostro fiscale iniziano il mese Ã¨',0),(93841,2607,'tl','',0),(93842,2607,'th','&#3592;&#3635;&#3652;&#3623;&#3657;&#3623;&#3656;&#3634;&#3648;&#3604;&#3639;&#3629;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3611;&#3637;&#3588;&#3639;&#3629;',0),(93843,2607,'hi','à¤¯à¤¾à¤¦ à¤¹à¥ˆ à¤•à¤¿ à¤…à¤ªà¤¨à¥‡ à¤µà¤¿à¤¤à¥à¤¤à¥€à¤¯ à¤µà¤°à¥à¤· à¤¶à¥à¤°à¥‚ à¤¹à¥‹ à¤®à¤¹à¥€à¤¨à¤¾ à¤¹à¥ˆ',0),(93844,2607,'ms','Ingat bahawa fiskal anda mula bulan adalah',0),(93845,2607,'ar','ØªØ°ÙƒØ± Ø£Ù† ØªØ¨Ø¯Ø£ Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø§Ù„Ø´Ù‡Ø±',0),(93846,2607,'fr','N\'oubliez pas que votre exercice commencer mois est',0),(93847,2607,'jp','ä¼šè¨ˆå¹´åº¦ã?®é–‹å§‹æœˆã?¯',0),(93848,2607,'pt','Lembre-se que seu fiscal comeÃ§ar mÃªs Ã©',0),(93849,2607,'ru','ÐŸÐ¾Ð¼Ð½Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾ Ð½Ð°Ñ‡Ð°Ñ‚ÑŒ Ð²Ð°Ñˆ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð¼ÐµÑÑÑ†',0),(93850,2607,'es','Tener presente que su mes fiscal de comienza es',0),(93851,2607,'de','Beachten Sie, dass Ihr GeschÃ¤ftsjahr beginnen Monat ist',0),(93852,2607,'en','Remember that your fiscal begin month is',0),(93853,2608,'is','',0),(93854,2608,'dr','Ø­Ø°Ù ÙÙŠÙ„Ø¯Ù‡Ø§',0),(93855,2608,'pr','Ø­Ø°Ù ÙÙŠÙ„Ø¯Ù‡Ø§',0),(93856,2608,'tr','DosyalarÄ± kaldÄ±rma',0),(93857,2608,'pl','UsuÅ„ pliki',0),(93858,2608,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(93859,2608,'ur','Ù…Ø³Ù„ÛŒÚº Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(93860,2608,'sr','Ð£ÐºÐ»Ð°ÑšÐ°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(93861,2608,'vi','Bá» há»“ sÆ¡',0),(93862,2608,'af','Verwyder LÃªers',0),(93863,2608,'ro','EliminaÅ£i fiÅŸierele',0),(93864,2608,'et','Failide eemaldamine',0),(93865,2608,'si','Odstranjevanje datotek',0),(93866,2608,'ba','Hapus file',0),(93867,2608,'nl','Bestanden verwijderen',0),(93868,2608,'fi','Poista tiedostot',0),(93869,2608,'no','Fjerne filer',0),(93870,2608,'da','Fjerne filer',0),(93871,2608,'ko','íŒŒì¼ì„ ì œê±°',0),(93872,2608,'he','×”×¡×¨ ×§×‘×¦×™×',0),(93873,2608,'el','ÎšÎ±Ï„Î±ÏÎ³Î®ÏƒÎµÏ„Îµ Î±ÏÏ‡ÎµÎ¯Î±',0),(93874,2608,'zh','ç§»é™¤æ–‡ä»¶\r\n',0),(93875,2608,'sv','Ta bort filer',0),(93876,2608,'it','Rimuovere i file',0),(93877,2608,'tl','',0),(93878,2608,'th','&#3621;&#3610;&#3652;&#3615;&#3621;&#3660;',0),(93879,2608,'hi','à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚',0),(93880,2608,'ms','Alih keluar fail',0),(93881,2608,'ar','Ø¥Ø²Ø§Ù„Ø© Ø§Ù„Ù…Ù„ÙÙ‘Ø§Øª',0),(93882,2608,'fr','Supprimer les fichiers',0),(93883,2608,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?®å‰Šé™¤',0),(93884,2608,'pt','Remover arquivos',0),(93885,2608,'ru','Ð£Ð±Ñ€Ð°Ñ‚ÑŒ Ð¤Ð°Ð¹Ð»Ñ‹',0),(93886,2608,'es','Eliminar Files',0),(93887,2608,'de','Dateien entfernen',0),(93888,2608,'en','Remove Files',0),(93889,2609,'is','',0),(93890,2609,'dr','Ù†Ø§Ù… Ú¯Ø°Ø§Ø±ÙŠ Ù…Ø¬Ø¯Ø¯',0),(93891,2609,'pr','Ù†Ø§Ù… Ú¯Ø°Ø§Ø±ÙŠ Ù…Ø¬Ø¯Ø¯',0),(93892,2609,'tr','Yeniden adlandÄ±rÄ±lmÄ±ÅŸ',0),(93893,2609,'pl','Przemianowany',0),(93894,2609,'bg','ÐŸÑ€ÐµÐ¸Ð¼ÐµÐ½ÑƒÐ²Ð°Ð½',0),(93895,2609,'ur','Ù†ÛŒØ§ Ù†Ø§Ù… Ø¯Û’ Ø¯ÛŒØ§',0),(93896,2609,'sr','ÐŸÑ€ÐµÐ¸Ð¼ÐµÐ½Ð¾Ð²Ð°Ð½Ð°',0),(93897,2609,'vi','Äáº·t tÃªn láº¡i',0),(93898,2609,'af','Herbenoem',0),(93899,2609,'ro','Redenumit',0),(93900,2609,'et','Ãœmber nimetatud',0),(93901,2609,'si','Preimenovati',0),(93902,2609,'ba','Berganti nama menjadi',0),(93903,2609,'nl','Hernoemd',0),(93904,2609,'fi','Nimetty uudelleen',0),(93905,2609,'no','Nytt navn',0),(93906,2609,'da','OmdÃ¸bt',0),(93907,2609,'ko','ê°œëª…',0),(93908,2609,'he','×œ×©× ×•×ª ××ª ×©×ž×',0),(93909,2609,'el','ÎœÎµÏ„Î¿Î½Î¿Î¼Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÎµ',0),(93910,2609,'zh','æ›´å\r\n',0),(93911,2609,'sv','Bytt namn',0),(93912,2609,'it','Rinominato',0),(93913,2609,'tl','',0),(93914,2609,'th','&#3605;&#3633;&#3657;&#3591;&#3594;&#3639;&#3656;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(93915,2609,'hi','à¤¨à¤¾à¤® à¤¬à¤¦à¤²à¤¾',0),(93916,2609,'ms','Dinamakan semula sebagai',0),(93917,2609,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªØ³Ù…ÙŠØ©',0),(93918,2609,'fr','RebaptisÃ©',0),(93919,2609,'jp','æ”¹å??æ¸ˆ',0),(93920,2609,'pt','Renomeado',0),(93921,2609,'ru','ÐŸÐµÑ€ÐµÐ¸Ð¼ÐµÐ½Ð¾Ð²Ð°Ð½',0),(93922,2609,'es','Renombrado',0),(93923,2609,'de','Umbenannt',0),(93924,2609,'en','Renamed',0),(93925,2610,'is','',0),(93926,2610,'dr','Ø¯ÙˆØ±Ù‡ ØªÙ†Ø§ÙˆØ¨',0),(93927,2610,'pr','Ø¯ÙˆØ±Ù‡ ØªÙ†Ø§ÙˆØ¨',0),(93928,2610,'tr','Yineleme uzunluÄŸu',0),(93929,2610,'pl','PowtÃ³rz dÅ‚ugoÅ›ci',0),(93930,2610,'bg','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÐµÑ‚Ðµ Ð´ÑŠÐ»Ð¶Ð¸Ð½Ð°',0),(93931,2610,'ur','Ú©ÛŒ Ù„Ù…Ø¨Ø§Ø¦ÛŒ Ú©Ùˆ Ú©Ø§Ù… Ø¯ÛØ±Ø§Ø¦ÙŠÚº',0),(93932,2610,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ð´ÑƒÐ¶Ð¸Ð½Ð°',0),(93933,2610,'vi','Chiá»u dÃ i nháº¯c láº¡i',0),(93934,2610,'af','Herhaal Lengte',0),(93935,2610,'ro','RepetaÅ£i lungime',0),(93936,2610,'et','Korrake pikkus',0),(93937,2610,'si','Ponovite dolÅ¾ina',0),(93938,2610,'ba','Ulangi panjang',0),(93939,2610,'nl','Herhaal lengte',0),(93940,2610,'fi','Toista pituus',0),(93941,2610,'no','Gjenta lengde',0),(93942,2610,'da','Gentag lÃ¦ngde',0),(93943,2610,'ko','ê¸¸ì´ ë°˜ë³µ',0),(93944,2610,'he','×—×–×•×¨ ×¢×œ ××•×¨×š',0),(93945,2610,'el','Î•Ï€Î±Î½Î±Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ Î¼Î®ÎºÎ¿Ï‚',0),(93946,2610,'zh','é‡å¤é•¿åº¦\r\n',0),(93947,2610,'sv','Upprepa lÃ¤ngd',0),(93948,2610,'it','Ripetere la lunghezza',0),(93949,2610,'tl','',0),(93950,2610,'th','&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3585;&#3634;&#3619;&#3607;&#3635;&#3595;&#3657;&#3635;',0),(93951,2610,'hi','à¤²à¤‚à¤¬à¤¾à¤ˆ à¤•à¥‹ à¤¦à¥‹à¤¹à¤°à¤¾à¤¨à¥‡',0),(93952,2610,'ms','Ulang panjang',0),(93953,2610,'ar','ÙƒØ±Ø± Ø·ÙˆÙ„',0),(93954,2610,'fr','Longueur',0),(93955,2610,'jp','å??å¾©é•·',0),(93956,2610,'pt','Repita o comprimento',0),(93957,2610,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð¸Ñ‚ÑŒ Ð´Ð»Ð¸Ð½Ð°',0),(93958,2610,'es','Repetir Largo',0),(93959,2610,'de','Wiederholen Sie die LÃ¤nge',0),(93960,2610,'en','Repeat Length',0),(93961,2611,'is','',0),(93962,2611,'dr','Ø¬ÙˆØ§Ø¨ ',0),(93963,2611,'pr','Ø¬ÙˆØ§Ø¨ ',0),(93964,2611,'tr','YanÄ±t',0),(93965,2611,'pl','Odpowiedz',0),(93966,2611,'bg','ÐžÑ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(93967,2611,'ur','Ø¬ÙˆØ§Ø¨ Ø¯ÛŒÚº',0),(93968,2611,'sr','ÐžÐ´Ð³Ð¾Ð²Ð¾Ñ€',0),(93969,2611,'vi','Tráº£ lá»i',0),(93970,2611,'af','Beantwoord',0),(93971,2611,'ro','RÄƒspuns',0),(93972,2611,'et','Vastus',0),(93973,2611,'si','Odgovor',0),(93974,2611,'ba','Balasan',0),(93975,2611,'nl','Antwoord',0),(93976,2611,'fi','Vastaus',0),(93977,2611,'no','Svar',0),(93978,2611,'da','Svar',0),(93979,2611,'ko','ì‘ë‹µ',0),(93980,2611,'he','×ª×’×•×‘×”',0),(93981,2611,'el','Î‘Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(93982,2611,'zh','å›žå¤\r\n',0),(93983,2611,'sv','Svar',0),(93984,2611,'it','Risposta',0),(93985,2611,'tl','',0),(93986,2611,'th','&#3605;&#3629;&#3610;&#3585;&#3621;&#3633;&#3610;',0),(93987,2611,'hi','à¤‰à¤¤à¥à¤¤à¤° à¤¦à¥‡à¤‚',0),(93988,2611,'ms','Jawapan',0),(93989,2611,'ar','Ø§Ù„Ø±Ø¯',0),(93990,2611,'fr','RÃ©ponse',0),(93991,2611,'jp','è¿”ä¿¡',0),(93992,2611,'pt','Resposta',0),(93993,2611,'ru','ÐžÑ‚Ð²ÐµÑ‚',0),(93994,2611,'es','Contestar',0),(93995,2611,'de','Antwort',0),(93996,2611,'en','Reply',0),(93997,2612,'is','',0),(93998,2612,'dr','Ú¯Ø²Ø§Ø±Ø´ ',0),(93999,2612,'pr','Ú¯Ø²Ø§Ø±Ø´ ',0),(94000,2612,'tr','Rapor',0),(94001,2612,'pl','Raport',0),(94002,2612,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´',0),(94003,2612,'ur','Ø±Ù¾ÙˆØ±Ù¹',0),(94004,2612,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(94005,2612,'vi','BÃ¡o CÃ¡o',0),(94006,2612,'af','Verslag',0),(94007,2612,'ro','Raport',0),(94008,2612,'et','Aruanne',0),(94009,2612,'si','PoroÄilo',0),(94010,2612,'ba','Laporan',0),(94011,2612,'nl','Verslag',0),(94012,2612,'fi','Raportti',0),(94013,2612,'no','Rapporten',0),(94014,2612,'da','Rapport',0),(94015,2612,'ko','ë³´ê³ ì„œ',0),(94016,2612,'he','×“×•×—',0),(94017,2612,'el','ÎˆÎºÎ¸ÎµÏƒÎ·',0),(94018,2612,'zh','æŠ¥å‘Š\r\n',0),(94019,2612,'sv','Rapport',0),(94020,2612,'it','Relazione',0),(94021,2612,'tl','',0),(94022,2612,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(94023,2612,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(94024,2612,'ms','Laporan',0),(94025,2612,'ar','ØªÙØ±ÙŠØ±',0),(94026,2612,'fr','Rapport',0),(94027,2612,'jp','ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(94028,2612,'pt','RelatÃ³rio',0),(94029,2612,'ru','ÐžÑ‚Ñ‡ÐµÑ‚',0),(94030,2612,'es','Informe',0),(94031,2612,'de','Bericht',0),(94032,2612,'en','Report',0),(94033,2613,'is','',0),(94034,2613,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚ Ù†Ù…ÙˆÙ†Ù‡ ',0),(94035,2613,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚ Ù†Ù…ÙˆÙ†Ù‡ ',0),(94036,2613,'tr','Rapor modÃ¼lÃ¼',0),(94037,2613,'pl','Sprawozdanie na temat moduÅ‚u',0),(94038,2613,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð·Ð° Ð¼Ð¾Ð´ÑƒÐ»',0),(94039,2613,'ur','Ù…Ø§ÚˆÛŒÙˆÙ„ Ù¾Ø± Ø±Ù¾ÙˆØ±Ù¹',0),(94040,2613,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ ÑÐµ Ð½Ð° Ð¼Ð¾Ð´ÑƒÐ»',0),(94041,2613,'vi','BÃ¡o cÃ¡o theo modun',0),(94042,2613,'af','Verslag lewer van Module',0),(94043,2613,'ro','Raport privind modul de',0),(94044,2613,'et','RAPORT moodul',0),(94045,2613,'si','PoroÄilo o modul',0),(94046,2613,'ba','Laporan modul',0),(94047,2613,'nl','Verslag over Module',0),(94048,2613,'fi','Kertomus moduuli',0),(94049,2613,'no','Rapport om modulen',0),(94050,2613,'da','Rapport om modul',0),(94051,2613,'ko','ëª¨ë“ˆì— ëŒ€ í•œ ë³´ê³ ì„œ',0),(94052,2613,'he','×”×“×• ×— ×¢×œ ×ž×•×“×•×œ',0),(94053,2613,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î³Î¹Î± Ï„Î·Î½ ÎµÎ½ÏŒÏ„Î·Ï„Î±',0),(94054,2613,'zh','æŠ¥å‘Šæ¨¡å—\r\n',0),(94055,2613,'sv','Rapport om modul',0),(94056,2613,'it','Relazione sul modulo',0),(94057,2613,'tl','',0),(94058,2613,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3605;&#3634;&#3617;&#3627;&#3621;&#3633;&#3585;&#3626;&#3641;&#3605;&#3619;',0),(94059,2613,'hi','à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤ªà¤° à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(94060,2613,'ms','Laporan modul',0),(94061,2613,'ar','ØªÙ‚Ø±ÙŠØ± Ø¹Ù† Ø§Ù„ÙˆØ­Ø¯Ø© Ø§Ù„Ù†Ù…Ø·ÙŠØ©',0),(94062,2613,'fr','Rapport sur le Module',0),(94063,2613,'jp','ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã‚’ãƒ¬ãƒ?ãƒ¼ãƒˆã?™ã‚‹',0),(94064,2613,'pt','RelatÃ³rio sobre o mÃ³dulo',0),(94065,2613,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð² ÐœÐ¾Ð´ÑƒÐ»Ðµ',0),(94066,2613,'es','Informe de MÃ³dulo',0),(94067,2613,'de','Bericht Ã¼ber Modul',0),(94068,2613,'en','Report on Module',0),(94069,2614,'is','',0),(94070,2614,'dr','Ø³Ø§Ù„ Ø¨Ø±Ø§ÙŠ Ú¯Ø²Ø§Ø±Ø´ ',0),(94071,2614,'pr','Ø³Ø§Ù„ Ø¨Ø±Ø§ÙŠ Ú¯Ø²Ø§Ø±Ø´ ',0),(94072,2614,'tr','YÄ±l iÃ§in rapor',0),(94073,2614,'pl','Roku do raportu',0),(94074,2614,'bg','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(94075,2614,'ur','Ø³Ø§Ù„Ø§Ù†Û Ø±Ù¾ÙˆØ±Ù¹',0),(94076,2614,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(94077,2614,'vi','NÄƒm BÃ¡o cÃ¡o',0),(94078,2614,'af','Verslag Jaar',0),(94079,2614,'ro','An pentru raport',0),(94080,2614,'et','Aasta aruanne',0),(94081,2614,'si','Leto za poroÄilo',0),(94082,2614,'ba','Tahun untuk laporan',0),(94083,2614,'nl','Jaar voor verslag',0),(94084,2614,'fi','Vuosi raportti',0),(94085,2614,'no','Ã…r for rapport',0),(94086,2614,'da','Ã…r for rapport',0),(94087,2614,'ko','ë³´ê³ ì„œì— ëŒ€ í•œ 1 ë…„',0),(94088,2614,'he','×©× ×” ×‘×©×‘×™×œ ×”×“×• ×—',0),(94089,2614,'el','ÎˆÏ„Î¿Ï‚ Î³Î¹Î± Ï„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ·',0),(94090,2614,'zh','å¹´æŠ¥å‘Š\r\n',0),(94091,2614,'sv','Ã…r fÃ¶r rapport',0),(94092,2614,'it','Anno per la relazione',0),(94093,2614,'tl','',0),(94094,2614,'th','&#3611;&#3637;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(94095,2614,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤°à¥à¤·',0),(94096,2614,'ms','Pada tahun laporan',0),(94097,2614,'ar','Ø§Ù„Ø¹Ø§Ù… Ù„Ù„ØªÙ‚Ø±ÙŠØ±',0),(94098,2614,'fr','AnnÃ©e de rapport',0),(94099,2614,'jp','ãƒ¬ãƒ?ãƒ¼ãƒˆã?®å¹´',0),(94100,2614,'pt','Ano para relatÃ³rio',0),(94101,2614,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð“Ð¾Ð´',0),(94102,2614,'es','AÃ±o para Informe',0),(94103,2614,'de','Jahr fÃ¼r Bericht',0),(94104,2614,'en','Year for Report',0),(94105,2615,'is','',0),(94106,2615,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯',0),(94107,2615,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯',0),(94108,2615,'tr','Yeni baskÄ±',0),(94109,2615,'pl','Przedruk',0),(94110,2615,'bg','ÐŸÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ',0),(94111,2615,'ur','Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹',0),(94112,2615,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜',0),(94113,2615,'vi','In láº¡i',0),(94114,2615,'af','Herdruk',0),(94115,2615,'ro','RetipÄƒrire',0),(94116,2615,'et','KordustrÃ¼kk',0),(94117,2615,'si','Ponatis',0),(94118,2615,'ba','Cetak ulang',0),(94119,2615,'nl','Herdruk',0),(94120,2615,'fi','Uusintapainos',0),(94121,2615,'no','Opptrykk',0),(94122,2615,'da','Genoptryk',0),(94123,2615,'ko','ë¬´ë‹¨ ì „ìž¬',0),(94124,2615,'he','×”×“×¤×¡ ×©×•×‘',0),(94125,2615,'el','Î•Ï€Î±Î½ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(94126,2615,'zh','é‡å°\r\n',0),(94127,2615,'sv','Reprint',0),(94128,2615,'it','Ristampa',0),(94129,2615,'tl','',0),(94130,2615,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(94131,2615,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£',0),(94132,2615,'ms','Pencetakan semula',0),(94133,2615,'ar','Ø·Ø¨Ø¹',0),(94134,2615,'fr','RÃ©impression',0),(94135,2615,'jp','å†?å?°åˆ·',0),(94136,2615,'pt','ReimpressÃ£o',0),(94137,2615,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(94138,2615,'es','Reimprimir',0),(94139,2615,'de','Nachdruck',0),(94140,2615,'en','Reprint',0),(94141,2616,'is','',0),(94142,2616,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(94143,2616,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(94144,2616,'tr','TarafÄ±ndan talep edilen',0),(94145,2616,'pl','ZgÅ‚oszony przez',0),(94146,2616,'bg','ÐŸÐ¾Ð¸ÑÐºÐ°Ð½Ð¸ Ð¾Ñ‚',0),(94147,2616,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ù†Ø¬Ø§Ù†Ø¨',0),(94148,2616,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°Ð¾',0),(94149,2616,'vi','YÃªu cáº§u bá»Ÿi',0),(94150,2616,'af','Versoek Deur',0),(94151,2616,'ro','Solicitate de',0),(94152,2616,'et','NÃµutud',0),(94153,2616,'si','Zahteval',0),(94154,2616,'ba','Diminta oleh',0),(94155,2616,'nl','Hierom',0),(94156,2616,'fi','PyytÃ¤mÃ¤t',0),(94157,2616,'no','Forespurt av',0),(94158,2616,'da','Anmodet af',0),(94159,2616,'ko','ìš”ì²­',0),(94160,2616,'he','×”×ž×‘×•×§×© ×¢×œ ×™×“×™',0),(94161,2616,'el','Î–Î·Ï„Î®Î¸Î·ÎºÎµ Î±Ï€ÏŒ',0),(94162,2616,'zh','è¯·æ±‚äºº\r\n',0),(94163,2616,'sv','BegÃ¤rts av',0),(94164,2616,'it','Richiesto da',0),(94165,2616,'tl','',0),(94166,2616,'th','&#3585;&#3634;&#3619;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3650;&#3604;&#3618;',0),(94167,2616,'hi','à¤‡à¤¸à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§à¤¿à¤¤',0),(94168,2616,'ms','Diminta oleh',0),(94169,2616,'ar','ÙˆØ·Ù„Ø¨Øª Ù…Ù†',0),(94170,2616,'fr','DemandÃ© par',0),(94171,2616,'jp','ä¾?é ¼è€…',0),(94172,2616,'pt','Solicitado pelo',0),(94173,2616,'ru','ÐŸÑ€Ð¾ÑÐ¸Ð»Ð°',0),(94174,2616,'es','Solicitado Por',0),(94175,2616,'de','Geforderten',0),(94176,2616,'en','Requested By',0),(94177,2617,'is','',0),(94178,2617,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù„Ø§Ø²Ù… Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(94179,2617,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù„Ø§Ø²Ù… Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(94180,2617,'tr','gerekli bilgi geÃ§ti.',0),(94181,2617,'pl','wymagane informacje nie sÄ… przekazywane.',0),(94182,2617,'bg','Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð°Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð½Ðµ Ðµ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ».',0),(94183,2617,'ur','Ù…Ø·Ù„ÙˆØ¨Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù†ÛÛŒÚº Ú¯Ø²Ø±Ø§ Û”',0),(94184,2617,'sr','Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾ÑˆÐ°Ð¾.',0),(94185,2617,'vi','cáº§n thÃ´ng tin chÆ°a chuyá»ƒn',0),(94186,2617,'af','vereiste inligting nie deurgegee',0),(94187,2617,'ro','informaÅ£ii necesare nu a trecut.',0),(94188,2617,'et','vajalik info edasi andmata.',0),(94189,2617,'si','zahteva info, ne prenesejo.',0),(94190,2617,'ba','info diperlukan belum lulus.',0),(94191,2617,'nl','vereiste info niet doorgegeven.',0),(94192,2617,'fi','tarvittavat tiedot siirretÃ¤.',0),(94193,2617,'no','nÃ¸dvendig informasjon ikke bestÃ¥tt.',0),(94194,2617,'da','nÃ¸dvendige info ikke bestÃ¥et.',0),(94195,2617,'ko','í•„ìš”í•œ ì •ë³´ëŠ” ì „ë‹¬ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(94196,2617,'he','×¤×¨×˜×™ ×—×•×‘×” ×œ× ×—×œ×¤×•.',0),(94197,2617,'el','Î±Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î´ÎµÎ½ Ï€Î­ÏÎ±ÏƒÎµ.',0),(94198,2617,'zh','æ‰€éœ€ä¿¡æ¯æ²¡æœ‰é€šè¿‡ã€‚\r\n',0),(94199,2617,'sv','krÃ¤vs information inte klarat.',0),(94200,2617,'it','richiesto informazioni non passato.',0),(94201,2617,'tl','',0),(94202,2617,'th','&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;',0),(94203,2617,'hi','à¤†à¤µà¤¶à¥à¤¯à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤°à¤¿à¤¤ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(94204,2617,'ms','maklumat yang diperlukan tidak diluluskan.',0),(94205,2617,'ar','Ù„Ø§ ØªÙ…Ø±ÙŠØ± Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©.',0),(94206,2617,'fr','info nÃ©cessaire ne pas passÃ©.',0),(94207,2617,'jp','å¿…è¦?ã?ªæƒ…å ±ã?Œé€šé?Žã?—ã?¾ã?›ã‚“',0),(94208,2617,'pt','informaÃ§Ã£o exigida nÃ£o passada.',0),(94209,2617,'ru','Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð½Ðµ Ð¿ÐµÑ€ÐµÐ´Ð°ÐµÑ‚ÑÑ.',0),(94210,2617,'es','info requerida no pasÃ³',0),(94211,2617,'de','erforderlichen Informationen nicht weitergegeben.',0),(94212,2617,'en','required info not passed.',0),(94213,2618,'is','',0),(94214,2618,'dr','Ø¨ÛŒØ¬Ú© Ù„Ø§Ø²Ù…<span style=\"font-size:8pt; font-weight:normal;\">(Required)</span>',0),(94215,2618,'pr','ÙØ§ÙƒØªÙˆØ± Ù„Ø§Ø²Ù…<span style=\"font-size:8pt; font-weight:normal;\">(Required)</span>',0),(94216,2618,'tr','<span style=\"font-size:8pt; font-weight:normal;\">(Gerekli)</span>',0),(94217,2618,'pl','<span style=\"font-size:8pt; font-weight:normal;\">(Wymagane)</span>',0),(94218,2618,'bg','<span style=\"font-size:8pt; font-weight:normal;\">(Ð—Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¾)</span>',0),(94219,2618,'ur','<span style=\"font-size:8pt; font-weight:normal;\">(Ø¶Ø±ÙˆØ±Øª)</span>',0),(94220,2618,'sr','<span style=\"font-size:8pt; font-weight:normal;\">(ÐžÐ±Ð°Ð²ÐµÐ·Ð½Ð¾)</span>',0),(94221,2618,'vi','(YÃªu cáº§u)',0),(94222,2618,'af','<span style=\"font-size:8pt; font-weight:normal;\">(Vereis)</span>',0),(94223,2618,'ro','<span style=\"font-size:8pt; font-weight:normal;\">(Obligatoriu)</span>',0),(94224,2618,'et','<span style=\"font-size:8pt; font-weight:normal;\">(Kohustuslik)</span>',0),(94225,2618,'si','<span style=\"font-size:8pt; font-weight:normal;\">(Zahtevano)</span>',0),(94226,2618,'ba','<span style=\"font-size:8pt; font-weight:normal;\">(Diperlukan)</span>',0),(94227,2618,'nl','<span style=\"font-size:8pt; font-weight:normal;\">(Vereist)</span>',0),(94228,2618,'fi','<span style=\"font-size:8pt; font-weight:normal;\">(Vaaditaan)</span>',0),(94229,2618,'no','<span style=\"font-size:8pt; font-weight:normal;\">(Obligatorisk)</span>',0),(94230,2618,'da','<span style=\"font-size:8pt; font-weight:normal;\">(PÃ¥krÃ¦vet)</span>',0),(94231,2618,'ko','<span style=\"font-size:8pt; font-weight:normal;\">(í•„ìˆ˜)</span>',0),(94232,2618,'he','<span style=\"font-size:8pt; font-weight:normal;\">(×“×¨×•×©)</span>',0),(94233,2618,'el','<span style=\"font-size:8pt; font-weight:normal;\">(Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹)</span>',0),(94234,2618,'zh','ï¼ˆå¿…éœ€ï¼‰\r\n',0),(94235,2618,'sv','<span style=\"font-size:8pt; font-weight:normal;\">(KrÃ¤vs)</span>',0),(94236,2618,'it','<span style=\"font-size:8pt; font-weight:normal;\">(Obbligatorio)</span>',0),(94237,2618,'tl','',0),(94238,2618,'th','<span style=\"font-size:8pt; font-weight:normal;\">(Required)</span>',0),(94239,2618,'hi','<span style=\"font-size:8pt; font-weight:normal;\">(à¤†à¤µà¤¶à¥à¤¯à¤•)</span>',0),(94240,2618,'ms','<span style=\"font-size:8pt; font-weight:normal;\">(Wajib)</span>',0),(94241,2618,'ar','<span style=\"font-size:8pt; font-weight:normal;\">(Ù…Ø·Ù„ÙˆØ¨)</span>',0),(94242,2618,'fr','<span style=\"font-size:8pt; font-weight:normal;\">(Obligatoire)</span>',0),(94243,2618,'jp','<span style=\"font-size:8pt; font-weight:normal;\">(å¿…è¦?)</span>',0),(94244,2618,'pt','<span style=\"font-size:8pt; font-weight:normal;\">(ObrigatÃ³rio)</span>',0),(94245,2618,'ru','<span style=\"font-size:8pt; font-weight:normal;\">(ÐžÐ±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾)</span>',0),(94246,2618,'es','<span style=\"font-size:8pt; font-weight:normal;\">(Required)</span>',0),(94247,2618,'de','<span style=\"font-size:8pt; font-weight:normal;\">(Erforderlich)</span>',0),(94248,2618,'en','<span style=\"font-size:8pt; font-weight:normal;\">(Required)</span>',0),(94249,2619,'is','',0),(94250,2619,'dr','ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²<span style=\"font-size:8pt; font-weight:normal;\">(Required for Non-Inventory Items)</span>',0),(94251,2619,'pr','ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²<span style=\"font-size:8pt; font-weight:normal;\">(Required for Non-Inventory Items)</span>',0),(94252,2619,'tr','<span style=\"font-size:8pt; font-weight:normal;\">(Non-stok maddeleri iÃ§in gerekli)</span>',0),(94253,2619,'pl','<span style=\"font-size:8pt; font-weight:normal;\">(Wymagane dla zapasÃ³w)</span>',0),(94254,2619,'bg','<span style=\"font-size:8pt; font-weight:normal;\">(Ð˜Ð·Ð¸ÑÐºÐ²Ð° ÑÐµ Ð·Ð° Ð½Ðµ ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸)</span>',0),(94255,2619,'ur','<span style=\"font-size:8pt; font-weight:normal;\">(ØºÛŒØ± Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ù„ÛŒÛ’ Ø¶Ø±ÙˆØ±Øª)</span>',0),(94256,2619,'sr','<span style=\"font-size:8pt; font-weight:normal;\">(ÐžÐ±Ð°Ð²ÐµÐ·Ð½Ð¾ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ ÐºÐ¾Ñ˜Ð¸ Ð½Ð¸ÑÑƒ Ð·Ð°Ð»Ð¸Ñ…Ð°)</span>',0),(94257,2619,'vi','<span style=\"font-size:8pt; font-weight:normal;\">(Cáº§n Cho nhá»¯ng mÃ£ hÃ ng khÃ´ng pháº£i hÃ ng trong kho)</span>',0),(94258,2619,'af','<span style=\"font-size:8pt; font-weight:normal;\">(Vereis vir nie-voorraad Items)</span>',0),(94259,2619,'ro','<span style=\"font-size:8pt; font-weight:normal;\">(Necesar pentru Non-stoc elemente)</span>',0),(94260,2619,'et','<span style=\"font-size:8pt; font-weight:normal;\">(NÃµutav-laokaupade puhul)</span>',0),(94261,2619,'si','<span style=\"font-size:8pt; font-weight:normal;\">(Zahteva za artikle brez zaloge)</span>',0),(94262,2619,'ba','<span style=\"font-size:8pt; font-weight:normal;\">(Diperlukan untuk bebas-persediaan barang)</span>',0),(94263,2619,'nl','<span style=\"font-size:8pt; font-weight:normal;\">(Vereist voor niet-voorraadartikelen)</span>',0),(94264,2619,'fi','<span style=\"font-size:8pt; font-weight:normal;\">(Vaaditaan ei-varastotuotteiden)</span>',0),(94265,2619,'no','<span style=\"font-size:8pt; font-weight:normal;\">(NÃ¸dvendig for ikke-beholdningsvarer)</span>',0),(94266,2619,'da','<span style=\"font-size:8pt; font-weight:normal;\">(KrÃ¦ves for ikke-lagervarer)</span>',0),(94267,2619,'ko','<span style=\"font-size:8pt; font-weight:normal;\">(ë¹„-ì¸ë²¤í† ë¦¬ í•­ëª©ì— í•„ìš”)</span>',0),(94268,2619,'he','<span style=\"font-size:8pt; font-weight:normal;\">(×“×¨×•×© ×¢×‘×•×¨ ×¤×¨×™×˜×™× ×©××™× × ×ž×œ××™)</span>',0),(94269,2619,'el','<span style=\"font-size:8pt; font-weight:normal;\">(Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î¼Î·-Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚)</span>',0),(94270,2619,'zh','ï¼ˆå¿…éœ€éžåº“å­˜é¡¹ç›®ï¼‰\r\n',0),(94271,2619,'sv','<span style=\"font-size:8pt; font-weight:normal;\">(KrÃ¤vs fÃ¶r icke-lagerartiklar)</span>',0),(94272,2619,'it','<span style=\"font-size:8pt; font-weight:normal;\">(Obbligatorio per articoli Non a magazzino)</span>',0),(94273,2619,'tl','',0),(94274,2619,'th','<span style=\"font-size:8pt; font-weight:normal;\">(Required for Non-Inventory Items)</span>',0),(94275,2619,'hi','<span style=\"font-size:8pt; font-weight:normal;\">(à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥ˆà¤°-à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾)</span>',0),(94276,2619,'ms','<span style=\"font-size:8pt; font-weight:normal;\">(Diperlukan untuk item bebas-inventori)</span>',0),(94277,2619,'ar','<span style=\"font-size:8pt; font-weight:normal;\">(Ù…Ø·Ù„ÙˆØ¨ Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†)</span>',0),(94278,2619,'fr','<span style=\"font-size:8pt; font-weight:normal;\">(Obligatoire pour les articles hors stock)</span>',0),(94279,2619,'jp','<span style=\"font-size:8pt; font-weight:normal;\">(é?žåœ¨åº«å“?ç›®ã?«å¿…è¦?)</span>',0),(94280,2619,'pt','<span style=\"font-size:8pt; font-weight:normal;\">(NecessÃ¡rio para itens nÃ£o-inventÃ¡rio)</span>',0),(94281,2619,'ru','<span style=\"font-size:8pt; font-weight:normal;\">(Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð¾Ð¼ÐµÐ½ÐºÐ»Ð°Ñ‚ÑƒÑ€Ñ‹)</span>',0),(94282,2619,'es','<span style=\"font-size:8pt; font-weight:normal;\">(Required for Non-Inventory Items)</span>',0),(94283,2619,'de','<span style=\"font-size:8pt; font-weight:normal;\">(Erforderlich fÃ¼r nicht-Lagerartikel)</span>',0),(94284,2619,'en','<span style=\"font-size:8pt; font-weight:normal;\">(Required for Non-Inventory Items)</span>',0),(94285,2620,'is','',0),(94286,2620,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙƒØ§Ù„Ø§ Ø§Ø² Ø§Ù†Ø¨Ø§Ø±',0),(94287,2620,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙƒØ§Ù„Ø§ Ø§Ø² Ø§Ù†Ø¨Ø§Ø±',0),(94288,2620,'tr','Talep #',0),(94289,2620,'pl','Zapotrzebowania #',0),(94290,2620,'bg','Ð˜Ð·Ð·ÐµÐ¼Ð²Ð°Ð½Ðµ #',0),(94291,2620,'ur','Ù†ÙˆØªØ§ #',0),(94292,2620,'sr','Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°ÑšÐ° #',0),(94293,2620,'vi','ÄÆ¡n xin sá»‘',0),(94294,2620,'af','# Requisition',0),(94295,2620,'ro','Aprovizionare #',0),(94296,2620,'et','Tellimus #',0),(94297,2620,'si','# Zahtevnice',0),(94298,2620,'ba','Permintaan #',0),(94299,2620,'nl','Inkoopbeheer #',0),(94300,2620,'fi','Hankintalistan #',0),(94301,2620,'no','Rekvisisjon #',0),(94302,2620,'da','Rekvisition #',0),(94303,2620,'ko','# ì§•',0),(94304,2620,'he','×œ×”×¤×§×™×¢ #',0),(94305,2620,'el','Î•Ï€Î¯Ï„Î±Î¾Î· #',0),(94306,2620,'zh','ç”³è¯·ï¼ƒ\r\n',0),(94307,2620,'sv','Rekvisition #',0),(94308,2620,'it','Richiesta #',0),(94309,2620,'tl','',0),(94310,2620,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3619;&#3657;&#3629;&#3591;',0),(94311,2620,'hi','à¤®à¤¾à¤à¤— #',0),(94312,2620,'ms','Permintaan #',0),(94313,2620,'ar','Ø·Ù„Ø¨ #',0),(94314,2620,'fr','Demande #',0),(94315,2620,'jp','è¦?è«‹ç•ªå?·',0),(94316,2620,'pt','RequisiÃ§Ã£o #',0),(94317,2620,'ru','Ð—Ð°ÑÐ²ÐºÐ° #',0),(94318,2620,'es','RequisiciÃ³n #',0),(94319,2620,'de','Bestellanforderung #',0),(94320,2620,'en','Requisition #',0),(94321,2621,'is','',0),(94322,2621,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙƒØ§Ù„Ø§ Ø§Ø² Ø§Ù†Ø¨Ø§Ø±',0),(94323,2621,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙƒØ§Ù„Ø§ Ø§Ø² Ø§Ù†Ø¨Ø§Ø±',0),(94324,2621,'tr','Talep numarasÄ±',0),(94325,2621,'pl','Numer zapotrzebowania',0),(94326,2621,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ°',0),(94327,2621,'ur','Ù†ÙˆØªØ§ Ù†Ù…Ø¨Ø±',0),(94328,2621,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°ÑšÐ°',0),(94329,2621,'vi','Sá»‘ ÄÆ¡n xin ',0),(94330,2621,'af','Requisition nommer',0),(94331,2621,'ro','NumÄƒrul de aprovizionare',0),(94332,2621,'et','Ostutellimuse kood',0),(94333,2621,'si','Å tevilka zahtevka za nabavo',0),(94334,2621,'ba','Jumlah permintaan',0),(94335,2621,'nl','Inkoopvoorstel nummer',0),(94336,2621,'fi','Tilausnumero',0),(94337,2621,'no','Rekvisisjonsnummer',0),(94338,2621,'da','Rekvisitionsnummer',0),(94339,2621,'ko','ìš”ì²­ ì„œ ë²ˆí˜¸',0),(94340,2621,'he','×ž×¡×¤×¨ ×‘×§×©×”',0),(94341,2621,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Î½Î±Ï€Î»Î®ÏÏ‰ÏƒÎ·Ï‚',0),(94342,2621,'zh','ç”³è¯·å·\r\n',0),(94343,2621,'sv','Rekvisitionsnummer',0),(94344,2621,'it','Numero della richiesta',0),(94345,2621,'tl','',0),(94346,2621,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3619;&#3657;&#3629;&#3591;',0),(94347,2621,'hi','à¤®à¤¾à¤à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(94348,2621,'ms','Jumlah permintaan',0),(94349,2621,'ar','Ø±Ù‚Ù… Ø·Ù„Ø¨',0),(94350,2621,'fr','NumÃ©ro de demande',0),(94351,2621,'jp','è¦?è«‹ï¼ƒ',0),(94352,2621,'pt','NÃºmero da requisiÃ§Ã£o',0),(94353,2621,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð°ÑÐ²ÐºÐ¸',0),(94354,2621,'es','NÃºmero de RequisiciÃ³n',0),(94355,2621,'de','Materialanforderungsnummer',0),(94356,2621,'en','Requisition Number',0),(94357,2622,'is','',0),(94358,2622,'dr','ØªÙ†Ø¸ÙŠÙ… Ù…Ø¬Ø¯Ø¯',0),(94359,2622,'pr','ØªÙ†Ø¸ÙŠÙ… Ù…Ø¬Ø¯Ø¯',0),(94360,2622,'tr','SÄ±fÄ±rlama',0),(94361,2622,'pl','Badanie',0),(94362,2622,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(94363,2622,'ur','Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(94364,2622,'sr','ÐŸÐ¾Ð½Ð¸ÑˆÑ‚Ð¸',0),(94365,2622,'vi','Äáº·t láº¡i',0),(94366,2622,'af','Stel terug',0),(94367,2622,'ro','Resetare',0),(94368,2622,'et','LÃ¤htestamine',0),(94369,2622,'si','Ponastavitev',0),(94370,2622,'ba','Reset',0),(94371,2622,'nl','Reset',0),(94372,2622,'fi','Palauta',0),(94373,2622,'no','Tilbakestille',0),(94374,2622,'da','Nulstille',0),(94375,2622,'ko','ë¦¬ì…‹',0),(94376,2622,'he','××™×¤×•×¡',0),(94377,2622,'el','Î•Ï€Î±Î½Î±Ï†Î¿ÏÎ¬',0),(94378,2622,'zh','é‡è®¾\r\n',0),(94379,2622,'sv','Ã…terstÃ¤lla',0),(94380,2622,'it','Reset',0),(94381,2622,'tl','',0),(94382,2622,'th','&#3619;&#3637;&#3648;&#3595;&#3605;',0),(94383,2622,'hi','à¤°à¥€à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(94384,2622,'ms','Set semula',0),(94385,2622,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ†',0),(94386,2622,'fr','Remise Ã  zÃ©ro',0),(94387,2622,'jp','ãƒªã‚»ãƒƒãƒˆ',0),(94388,2622,'pt','Redefinir',0),(94389,2622,'ru','Ð¡Ð±Ñ€Ð¾Ñ',0),(94390,2622,'es','Reiniciar',0),(94391,2622,'de','ZurÃ¼cksetzen',0),(94392,2622,'en','Reset',0),(94393,2623,'is','',0),(94394,2623,'dr','Ù…Ù‚Ø§Ø¯ÙŠØ± ØªÙ†Ø¸ÙŠÙ… Ù…Ø¬Ø¯Ø¯',0),(94395,2623,'pr','Ù…Ù‚Ø§Ø¯ÙŠØ± ØªÙ†Ø¸ÙŠÙ… Ù…Ø¬Ø¯Ø¯',0),(94396,2623,'tr','DeÄŸerleri SÄ±fÄ±rla',0),(94397,2623,'pl','Resetowanie wartoÅ›ci',0),(94398,2623,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸',0),(94399,2623,'ur','Ù‚Ø¯Ø±ÛŒÚº Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(94400,2623,'sr','ÐŸÐ¾Ð½Ð¸ÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(94401,2623,'vi','Äáº·t láº¡i giÃ¡ trá»‹',0),(94402,2623,'af','Waardes Terugstel',0),(94403,2623,'ro','Reseta valorile',0),(94404,2623,'et','LÃ¤htesta vÃ¤Ã¤rtused',0),(94405,2623,'si','Ponastavitev vrednosti',0),(94406,2623,'ba','Nilai-nilai ulang',0),(94407,2623,'nl','Waarden resetten',0),(94408,2623,'fi','Palauta arvot',0),(94409,2623,'no','Tilbakestille verdiene',0),(94410,2623,'da','Nulstille vÃ¦rdierne',0),(94411,2623,'ko','ê°’ì„ ë‹¤ì‹œ ì„¤ì •',0),(94412,2623,'he','×œ××¤×¡ ×”×¢×¨×›×™×',0),(94413,2623,'el','Î•Ï€Î±Î½Î±Ï†Î¿ÏÎ¬ Ï„Î¹Î¼ÏŽÎ½',0),(94414,2623,'zh','é‡è®¾å€¼\r\n',0),(94415,2623,'sv','Ã…terstÃ¤lla vÃ¤rdena',0),(94416,2623,'it','Reimpostare i valori',0),(94417,2623,'tl','',0),(94418,2623,'th','&#3619;&#3637;&#3648;&#3595;&#3605;&#3588;&#3656;&#3634;',0),(94419,2623,'hi','à¤®à¤¾à¤¨à¥‹à¤‚ à¤•à¥‹ à¤°à¥€à¤¸à¥‡à¤Ÿ',0),(94420,2623,'ms','Set semula nilai-nilai',0),(94421,2623,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù‚ÙŠÙ…',0),(94422,2623,'fr','RÃ©initialiser les valeurs',0),(94423,2623,'jp','ä¾¡æ ¼ã‚’ãƒªã‚»ãƒƒãƒˆ',0),(94424,2623,'pt','Redefinir os valores',0),(94425,2623,'ru','Ð¡Ð±Ñ€Ð¾Ñ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ð¹',0),(94426,2623,'es','Reconfigurar Valores',0),(94427,2623,'de','Werte zurÃ¼cksetzen',0),(94428,2623,'en','Reset Values',0),(94429,2624,'is','',0),(94430,2624,'dr',': Ø¹Ø¯Ø¯ÙŠ  Ø¨Ù„Ù‡ / Ø®ÙŠØ± _ Ù…ØªÙ† â€“ Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨- Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨  Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…ØªÙ†- Ø®ÙˆØ¯ÙƒØ§Ø±( ÙÙ‚Ø· Ú†Ø§Ù¾',0),(94431,2624,'pr','Ù†ÙˆØ¹ ÙˆØ¶ÙˆØ­: Ø¹Ø¯Ø¯ÙŠ  Ø¨Ù„Ù‡ / Ø®ÙŠØ± _ Ù…ØªÙ† â€“ Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨- Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨  Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…ØªÙ†- Ø®ÙˆØ¯ÙƒØ§Ø±( ÙÙ‚Ø· Ú†Ø§Ù¾',0),(94432,2624,'tr','SayÄ±sal, Evet/HayÄ±r, metin, seÃ§im listesi, seÃ§imi metin, otomatik (yalnÄ±zca yazdÄ±rÄ±rken) listesi',0),(94433,2624,'pl','Numeryczne, tak/nie, tekst, listy wyboru, wyboru listy oraz tekst, automatyczne (tylko wydruk)',0),(94434,2624,'bg','Ð¦Ð¸Ñ„Ñ€Ð¾Ð²Ð¸, Ð´Ð°/Ð½Ðµ, Ñ‚ÐµÐºÑÑ‚, ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€, Ð¸Ð·Ð±Ð¾Ñ€ ÑÐ¿Ð¸ÑÑŠÐº Ð¿Ð»ÑŽÑ Ñ‚ÐµÐºÑÑ‚, Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÐ½ (ÑÐ°Ð¼Ð¾ Ð¿ÐµÑ‡Ð°Ñ‚)',0),(94435,2624,'ur','Ù†Ù…Ø¨Ø±ÛŒØŒ ÛØ§Úº Ù†ÛÛŒÚºØŒ Ù…ØªÙ†ØŒ Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³ØªØŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù…ØªÙ† Ù¾Ù„Ø³ Ø®ÙˆØ¯Ú©Ø§Ø± (ØµØ±Ù Ù¾Ø±Ù†Ù¹) Ú©ÛŒ ÙÛØ±Ø³Øª',0),(94436,2624,'sr','ÐÑƒÐ¼ÐµÑ€Ð¸Ñ‡ÐºÐ¸ , Ð´Ð°/Ð½Ðµ, Ñ‚ÐµÐºÑÑ‚, Ð»Ð¸ÑÑ‚Ð° Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€, Ð¸Ð·Ð±Ð¾Ñ€ Ð»Ð¸ÑÑ‚Ð° ÐŸÐ»ÑƒÑ Ñ‚ÐµÐºÑÑ‚Ð°, Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ (ÑÐ°Ð¼Ð¾ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ)',0),(94437,2624,'vi','Sá»‘, CÃ³/KhÃ´ng, VÄƒn báº£n, Chá»n danh sÃ¡ch, Chá»n danh sÃ¡ch & chá»¯, Tá»± Ä‘á»™ng (chá»‰ cho in) ',0),(94438,2624,'af','Numeriese, Ja/Nee, teks, seleksie lys seleksie lys Plus teks, outomatiese (slegs druk)',0),(94439,2624,'ro','Numerice, da/nu, Text, lista de selecÅ£ie, selecÅ£ie lista Plus Text, automatÄƒ (doar pentru imprimare)',0),(94440,2624,'et','Numbriline, jah/ei, teksti, valikuloendis, valiku nimekirja pluss tekst, automaat (Prindi ainult)',0),(94441,2624,'si','Å tevilÄno, da/ne, besedilo, seznam za izbiro, izbor seznam Plus besedilo, Avtomatika (samo tiskanje)',0),(94442,2624,'ba','Numerik, ya/tidak, teks, daftar pilihan, pilihan daftar ditambah teks, otomatis (cetak)',0),(94443,2624,'nl','Numeriek, Ja/Nee, tekst, keuzelijst, selectie lijst Plus tekst, automatisch (alleen Print)',0),(94444,2624,'fi','Numeerinen, kyllÃ¤, teksti, valintaluettelo, valinta luettelo Plus teksti, automaattinen (Tulosta)',0),(94445,2624,'no','Numerisk, ja/nei, tekst, valglisten, utvalg liste pluss tekst automatisk (bare Print)',0),(94446,2624,'da','Numerisk, ja/nej, tekst, valgliste, udvalg liste Plus tekst, automatisk (Udskriv kun)',0),(94447,2624,'ko','ìˆ«ìž, ì˜ˆ/ì•„ë‹ˆìš”, í…ìŠ¤íŠ¸, ì„ íƒ ëª©ë¡, ì„ íƒ ëª©ë¡ í…ìŠ¤íŠ¸, ìžë™ (ì¸ì‡„) í”ŒëŸ¬ìŠ¤',0),(94448,2624,'he','×ž×¡×¤×¨×™×™×, ×›×Ÿ/×œ×, ×˜×§×¡×˜, ×¨×©×™×ž×” ×¢× ××¤×©×¨×•×™×•×ª ×‘×—×™×¨×”, ×”×‘×—×™×¨×” ×‘×¨×©×™×ž×” ×‘×ª×•×¡×¤×ª ×˜×§×¡×˜ ××•×˜×•×ž×˜×™ (×”×“×¤×¡×” ×‘×œ×‘×“)',0),(94449,2624,'el','Î‘ÏÎ¹Î¸Î¼Î·Ï„Î¹ÎºÎ®, Î½Î±Î¹/ÏŒÏ‡Î¹, ÎºÎµÎ¯Î¼ÎµÎ½Î¿, Î»Î¯ÏƒÏ„Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½, ÎµÏ€Î¹Î»Î¿Î³Î® Î»Î¯ÏƒÏ„Î± ÏƒÏ…Î½ ÎºÎµÎ¯Î¼ÎµÎ½Î¿, Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· (Î¼ÏŒÎ½Î¿ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·)',0),(94450,2624,'zh','å“åº”ç±»åž‹ï¼šæ•°å€¼ï¼Œæ˜¯/å¦ï¼Œæ–‡æœ¬ï¼Œé€‰é¡¹è¡¨ï¼Œé€‰é¡¹è¡¨åŠ æ–‡æœ¬ï¼Œè‡ªåŠ¨ï¼ˆä»…æ‰“å°ï¼‰\r\n',0),(94451,2624,'sv','Numeriska, ja/nej, Text, listan, Val av lista Plus Text, automatisk (endast utskrift)',0),(94452,2624,'it','Numerico, SÃ¬/No, testo, elenco di selezione, selezione elencare piÃ¹ testo, automatica (solo stampa)',0),(94453,2624,'tl','',0),(94454,2624,'th','Numeric,Yes/No,Text,Selection List,Selection List Plus Text,Automatic (Print Only)',0),(94455,2624,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾à¤¤à¥à¤®à¤•, à¤¹à¤¾à¤/à¤¨à¤¹à¥€à¤‚, à¤ªà¤¾à¤ , à¤šà¤¯à¤¨ à¤¸à¥‚à¤šà¥€, à¤šà¤¯à¤¨ à¤ªà¤¾à¤  à¤ªà¥à¤²à¤¸, à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ (à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥‡à¤µà¤²) à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(94456,2624,'ms','Angka, ya/tidak, teks, senarai pilihan, pilihan senarai Plus teks, automatik (cetak sahaja)',0),(94457,2624,'ar','Ø±Ù‚Ù…ÙŠØ©ØŒ Ù†Ø¹Ù…/Ù„Ø§ØŒ Ø§Ù„Ù†Øµ ÙˆÙ‚Ø§Ø¦Ù…Ø© Ø§Ù†ØªÙ‚Ø§Ø¡ ÙˆØ§Ø®ØªÙŠØ§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ù†Øµ ØªÙ„Ù‚Ø§Ø¦ÙŠ (Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© ÙÙ‚Ø·)',0),(94458,2624,'fr','NumÃ©rique, oui/non, texte, liste de sÃ©lection, sÃ©lection liste Plus texte, automatique (impression uniquement)',0),(94459,2624,'jp','ç•ªå?·ã€?ã?¯ã?„/ã?„ã?„ã?ˆã€?æ–‡ç« ã€?é?¸æŠžãƒªã‚¹ãƒˆã€?æ–‡ç« ä»˜é?¸æŠžãƒªã‚¹ãƒˆã€?è‡ªå‹•ï¼ˆå?°åˆ·ã?®ã?¿ï¼‰',0),(94460,2624,'pt','NumÃ©rico, sim/nÃ£o, texto, lista de seleÃ§Ã£o, seleÃ§Ã£o lista mais texto, automÃ¡tico (somente impressÃ£o)',0),(94461,2624,'ru','Ð§Ð¸ÑÐ»Ð¾Ð²Ð¾Ðµ, Ð´Ð°/Ð½ÐµÑ‚, Ñ‚ÐµÐºÑÑ‚, ÑÐ¿Ð¸ÑÐ¾Ðº Ð²Ñ‹Ð±Ð¾Ñ€Ð°, Ð²Ñ‹Ð±Ð¾Ñ€Ð° ÑÐ¿Ð¸ÑÐºÐ° Ð¿Ð»ÑŽÑ Ñ‚ÐµÐºÑÑ‚, Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ (Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸)',0),(94462,2624,'es','Numerico,Si/No,Texto,Lista de SelecciÃ³n MÃ¡s Texto, AutomÃ¡tico (Imprimir Solo)',0),(94463,2624,'de','Numerische, Liste Ja/Nein, Text, Auswahlliste, Auswahl Plus Text, Automatik (nur Print)',0),(94464,2624,'en','Numeric,Yes/No,Text,Selection List,Selection List Plus Text,Automatic (Print Only)',0),(94465,2625,'is','',0),(94466,2625,'dr',': 1-2-3-4-5-6',0),(94467,2625,'pr','Ù…Ù‚Ø§Ø¯ÙŠØ± ÙˆØ¶ÙˆØ­ : 1-2-3-4-5-6',0),(94468,2625,'tr','1,2,3,4,5,6',0),(94469,2625,'pl','1,2,3,4,5,6',0),(94470,2625,'bg','1,2,3,4,5,6',0),(94471,2625,'ur','1,2,3,4,5,6',0),(94472,2625,'sr','1,2,3,4,5,6',0),(94473,2625,'vi','1,2,3,4,5,6',0),(94474,2625,'af','1,2,3,4,5,6',0),(94475,2625,'ro','1,2,3,4,5,6',0),(94476,2625,'et','1,2,3,4,5,6',0),(94477,2625,'si','Äasi 1,2,3,4,5,6',0),(94478,2625,'ba','1,2,3,4,5,6',0),(94479,2625,'nl','1,2,3,4,5,6',0),(94480,2625,'fi','1,2,3,4,5,6',0),(94481,2625,'no','1,2,3,4,5,6',0),(94482,2625,'da','1,2,3,4,5,6',0),(94483,2625,'ko','1,2,3,4,5,6',0),(94484,2625,'he','1,2,3,4,5,6',0),(94485,2625,'el','1,2,3,4,5,6',0),(94486,2625,'zh','å“åº”ç±»åž‹å€¼ï¼š1ï¼Œ2ï¼Œ3ï¼Œ4ï¼Œ5ï¼Œ6\r\n',0),(94487,2625,'sv','1,2,3,4,5,6',0),(94488,2625,'it','1,2,3,4,5,6',0),(94489,2625,'tl','',0),(94490,2625,'th','1,2,3,4,5,6',0),(94491,2625,'hi','1,2,3,4,5,6',0),(94492,2625,'ms','1,2,3,4,5,6',0),(94493,2625,'ar','1,2,3,4,5,6',0),(94494,2625,'fr','1,2,3,4,5,6',0),(94495,2625,'jp','1,2,3,4,5,6',0),(94496,2625,'pt','1.2.3.4.5.6',0),(94497,2625,'ru','1,2,3,4,5,6',0),(94498,2625,'es','1,2,3,4,5,6',0),(94499,2625,'de','1,2,3,4,5,6',0),(94500,2625,'en','1,2,3,4,5,6',0),(94501,2626,'is','',0),(94502,2626,'dr','Ù†ØªØ§ÙŠØ¬ ',0),(94503,2626,'pr','Ù†ØªØ§ÙŠØ¬ ',0),(94504,2626,'tr','SonuÃ§larÄ±',0),(94505,2626,'pl','Wyniki',0),(94506,2626,'bg','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸',0),(94507,2626,'ur','Ú©Û’ Ù†ØªØ§Ø¦Ø¬',0),(94508,2626,'sr','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸',0),(94509,2626,'vi','Káº¿t quáº£',0),(94510,2626,'af','Resultate',0),(94511,2626,'ro','Rezultatele',0),(94512,2626,'et','Tulemused',0),(94513,2626,'si','Rezultati',0),(94514,2626,'ba','Hasil',0),(94515,2626,'nl','Resultaten',0),(94516,2626,'fi','Tulokset',0),(94517,2626,'no','Resultater',0),(94518,2626,'da','Resultater',0),(94519,2626,'ko','ê²°ê³¼',0),(94520,2626,'he','×ª×•×¦××•×ª',0),(94521,2626,'el','Î‘Ï€Î¿Ï„ÎµÎ»Î­ÏƒÎ¼Î±Ï„Î±',0),(94522,2626,'zh','ç»“æžœ\r\n',0),(94523,2626,'sv','Resultat',0),(94524,2626,'it','Risultati',0),(94525,2626,'tl','',0),(94526,2626,'th','&#3612;&#3621;&#3621;&#3633;&#3614;&#3608;&#3660;',0),(94527,2626,'hi','à¤ªà¤°à¤¿à¤£à¤¾à¤®',0),(94528,2626,'ms','Keputusan',0),(94529,2626,'ar','Ø§Ù„Ù†ØªØ§Ø¦Ø¬',0),(94530,2626,'fr','RÃ©sultats',0),(94531,2626,'jp','çµ?æžœ',0),(94532,2626,'pt','Resultados',0),(94533,2626,'ru','Ð ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ñ‹',0),(94534,2626,'es','Resultados',0),(94535,2626,'de','Ergebnisse',0),(94536,2626,'en','Results',0),(94537,2627,'is','',0),(94538,2627,'dr','Ù†ØªØ§ÙŠØ¬ Ø¯Ø± Ù‡Ø± ØµÙØ­Ù‡',0),(94539,2627,'pr','Ù†ØªØ§ÙŠØ¬ Ø¯Ø± Ù‡Ø± ØµÙØ­Ù‡',0),(94540,2627,'tr','Sayfa baÅŸÄ±na sonuÃ§',0),(94541,2627,'pl','Wyniki na stronie',0),(94542,2627,'bg','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(94543,2627,'ur','Ù†ØªØ§Ø¦Ø¬ ÙÛŒ ØµÙØ­Û',0),(94544,2627,'sr','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸ Ð¿Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(94545,2627,'vi','Káº¿t quáº£ tá»«ng trang',0),(94546,2627,'af','Resultate Per Bladsy',0),(94547,2627,'ro','Rezultate pe pagina',0),(94548,2627,'et','Tulemusi lehe kohta',0),(94549,2627,'si','Rezultatov na stran',0),(94550,2627,'ba','Hasil Per halaman',0),(94551,2627,'nl','Resultaten Per pagina',0),(94552,2627,'fi','Tulosta / sivu',0),(94553,2627,'no','Pr. side',0),(94554,2627,'da','Resultater pr. side',0),(94555,2627,'ko','íŽ˜ì´ì§€ ë‹¹ ê²°ê³¼',0),(94556,2627,'he','×ª×•×¦××•×ª ×œ×“×£',0),(94557,2627,'el','Î‘Ï€Î¿Ï„ÎµÎ»Î­ÏƒÎ¼Î±Ï„Î± Î±Î½Î¬ ÏƒÎµÎ»Î¯Î´Î±',0),(94558,2627,'zh','ç»“æžœæ¯é¡µ\r\n',0),(94559,2627,'sv','Resultat Per sida',0),(94560,2627,'it','Risultati Per pagina',0),(94561,2627,'tl','',0),(94562,2627,'th','&#3612;&#3621;&#3621;&#3633;&#3614;&#3608;&#3660;&#3605;&#3656;&#3629;&#3627;&#3609;&#3657;&#3634;',0),(94563,2627,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤°à¤¿à¤£à¤¾à¤®',0),(94564,2627,'ms','Keputusan setiap muka',0),(94565,2627,'ar','Ø§Ù„Ù†ØªØ§Ø¦Ø¬ ÙÙŠ Ø§Ù„ØµÙØ­Ø© Ø§Ù„ÙˆØ§Ø­Ø¯Ø©',0),(94566,2627,'fr','RÃ©sultats par Page',0),(94567,2627,'jp','ãƒšãƒ¼ã‚¸ã?”ã?¨ã?®çµ?æžœ',0),(94568,2627,'pt','Resultados por pÃ¡gina',0),(94569,2627,'ru','Ð ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ñ‹ ÐÐ° Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(94570,2627,'es','Resultados Por PÃ¡gina',0),(94571,2627,'de','Ergebnisse pro Seite',0),(94572,2627,'en','Results Per Page',0),(94573,2628,'is','',0),(94574,2628,'dr','Ø¨Ø±Ú¯Ø´Øª ',0),(94575,2628,'pr','Ø¨Ø±Ú¯Ø´Øª ',0),(94576,2628,'tr','Geri dÃ¶nmek',0),(94577,2628,'pl','PowrÃ³t',0),(94578,2628,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ',0),(94579,2628,'ur','ÙˆØ§Ù¾Ø³ Ø¬Ø§Ø¦ÛŒÚº',0),(94580,2628,'sr','ÐŸÐ¾Ð²Ñ€Ð°Ñ‚Ð°Ðº',0),(94581,2628,'vi','Trá»Ÿ láº¡i',0),(94582,2628,'af','Opbrengs',0),(94583,2628,'ro','Reveni',0),(94584,2628,'et','Edasi-tagasi',0),(94585,2628,'si','Vrnitev',0),(94586,2628,'ba','Kembali',0),(94587,2628,'nl','Terugkeer',0),(94588,2628,'fi','Paluu',0),(94589,2628,'no','Avkastning',0),(94590,2628,'da','Tilbagevenden',0),(94591,2628,'ko','ë°˜í™˜',0),(94592,2628,'he','×”×—×–×¨',0),(94593,2628,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(94594,2628,'zh','è¿”å›ž\r\n',0),(94595,2628,'sv','Avkastning',0),(94596,2628,'it','Ritorno',0),(94597,2628,'tl','',0),(94598,2628,'th','&#3588;&#3639;&#3609;',0),(94599,2628,'hi','à¤µà¤¾à¤ªà¤¸ à¤œà¤¾à¤à¤',0),(94600,2628,'ms','Kembali',0),(94601,2628,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø©',0),(94602,2628,'fr','Retour',0),(94603,2628,'jp','æˆ»ã‚‹',0),(94604,2628,'pt','Retorno',0),(94605,2628,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ',0),(94606,2628,'es','Regresar',0),(94607,2628,'de','RÃ¼ckkehr',0),(94608,2628,'en','Return',0),(94609,2629,'is','',0),(94610,2629,'dr','(Ø¨Ù‡ Ø§Ù…Ø§Ù†Øª Ú¯Ø±ÙØªÙ†',0),(94611,2629,'pr','Ø¨Ø±Ú¯Ø´Øª Ø§Ø² ÙˆØ§Ø±Ø³Ù‰ (Ø¨Ù‡ Ø§Ù…Ø§Ù†Øª Ú¯Ø±ÙØªÙ†',0),(94612,2629,'tr','Checkout dÃ¶nmek',0),(94613,2629,'pl','PowrÃ³t z kasy',0),(94614,2629,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ Ð¾Ñ‚ ÐºÐ°ÑÐ°Ñ‚Ð°',0),(94615,2629,'ur','Ø®Ø§Ø±Ø¬ Ø³Û’ ÙˆØ§Ù¾Ø³ÛŒ',0),(94616,2629,'sr','Ð’Ñ€Ð°Ñ›Ð°Ñ˜Ñƒ Ð¸Ð· Ð±Ð»Ð°Ð³Ð°Ñ˜Ð½Ðµ',0),(94617,2629,'vi','Quay láº¡i tá»« trá»Ÿ ra',0),(94618,2629,'af','Terugkeer van afhandeling',0),(94619,2629,'ro','Reveni la Checkout',0),(94620,2629,'et','Tulu kassasse',0),(94621,2629,'si','Donos v Checkout',0),(94622,2629,'ba','Kembali dari Checkout',0),(94623,2629,'nl','Retourneren van Checkout',0),(94624,2629,'fi','Palaa kassalle',0),(94625,2629,'no','Tilbake fra kassa',0),(94626,2629,'da','Vende tilbage fra kassen',0),(94627,2629,'ko','ì²´í¬ ì•„ì›ƒì—ì„œ ë°˜í™˜',0),(94628,2629,'he','×—×–×¨×” ×ž×”×•×¦××”',0),(94629,2629,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î±Ï€ÏŒ Ï„Î·Î½ Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(94630,2629,'zh','ä»Žç»“å¸è¿”å›ž\r\n',0),(94631,2629,'sv','Tillbaka frÃ¥n kassan',0),(94632,2629,'it','Ritorno da Checkout',0),(94633,2629,'tl','',0),(94634,2629,'th','&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3629;&#3629;&#3585;',0),(94635,2629,'hi','à¤šà¥‡à¤•à¤†à¤‰à¤Ÿ à¤¸à¥‡ à¤µà¤¾à¤ªà¤¸à¥€',0),(94636,2629,'ms','Balik dari Checkout',0),(94637,2629,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ù…Ù† Ø§Ù„Ø®Ø±ÙˆØ¬',0),(94638,2629,'fr','Retour de Checkout',0),(94639,2629,'jp','ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?‹ã‚‰æˆ»ã‚‹',0),(94640,2629,'pt','Retorno de Checkout',0),(94641,2629,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ð¸Ð· Ð²Ñ‹Ð¿Ð¸ÑÐ°Ð½Ð½Ñ‹Ñ…',0),(94642,2629,'es','Regresar de FinalizaciÃ³n de la Compra',0),(94643,2629,'de','Von Kasse zurÃ¼ckgeben',0),(94644,2629,'en','Return from Checkout',0),(94645,2630,'is','',0),(94646,2630,'dr','(Ø¨Ù‡ Ø§Ù…Ø§Ù†Øª Ú¯Ø±ÙØªÙ†',0),(94647,2630,'pr','Ø¨Ø±Ú¯Ø´Øª Ø³ÙØ§Ø±Ø´ Ø§Ø² ÙˆØ§Ø±Ø³Ù‰ (Ø¨Ù‡ Ø§Ù…Ø§Ù†Øª Ú¯Ø±ÙØªÙ†',0),(94648,2630,'tr','Ä°ade sipariÅŸinden Check Out',0),(94649,2630,'pl','ZamÃ³wienie zwrotu z SprawdÅº',0),(94650,2630,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ñ€ÐµÐºÐ»Ð°Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ñ‚ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½ÐµÑ‚Ð¾',0),(94651,2630,'ur','Ú†ÛŒÚ© Ø¢Ø¤Ù¹ Ø³Û’ Ø¢Ø±ÚˆØ± ÙˆØ§Ù¾Ø³',0),(94652,2630,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ›Ð°Ñ˜ Ð¾Ð´ Ð¾Ð´Ñ˜Ð°Ð²Ðµ',0),(94653,2630,'vi','Quay láº¡i Ä‘Æ¡n hÃ ng tá»« trá»Ÿ ra',0),(94654,2630,'af','Orde terug uit Check',0),(94655,2630,'ro','ComandÄƒ de retur la Check-Out',0),(94656,2630,'et','Tutvu tagastustellimus',0),(94657,2630,'si','VraÄilni nalog iz Check Out',0),(94658,2630,'ba','Kembali urutan dari memeriksa',0),(94659,2630,'nl','Retourorder van uitchecken',0),(94660,2630,'fi','Tutustu palautustilaus',0),(94661,2630,'no','Returordren fra utsjekking',0),(94662,2630,'da','Returordre fra tjek',0),(94663,2630,'ko','ì²´í¬ ì•„ì›ƒì—ì„œ ìˆœì„œë¥¼ ë°˜í™˜',0),(94664,2630,'he','×”×–×ž× ×ª ×”×—×–×¨×” ×©×œ ×‘×™×¦×•×¢ ×”×¦\'×§-×××•×˜',0),(94665,2630,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î±Ï€ÏŒ Ï„Î¿ Check Out',0),(94666,2630,'zh','ä»Žç™»å‡ºè¿”å›žè®¢å•\r\n',0),(94667,2630,'sv','Returordern frÃ¥n kolla',0),(94668,2630,'it','Ordine di reso da controllare',0),(94669,2630,'tl','',0),(94670,2630,'th','&#3585;&#3621;&#3633;&#3610;&#3617;&#3634;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3637;&#3585;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3629;&#3629;&#3585;&#3652;&#3611;&#3649;&#3621;&#3657;&#3623;',0),(94671,2630,'hi','à¤šà¥‡à¤• à¤¬à¤¾à¤¹à¤° à¤¸à¥‡ à¤‘à¤°à¥à¤¡à¤° à¤µà¤¾à¤ªà¤¸',0),(94672,2630,'ms','Kembali perintah Keluar',0),(94673,2630,'ar','Ø£Ù…Ø± Ø§Ù„Ø¥Ø±Ø¬Ø§Ø¹ Ù…Ù† Ø§Ù„Ù…ØºØ§Ø¯Ø±Ø©',0),(94674,2630,'fr','Commande de retour de Check-Out',0),(94675,2630,'jp','ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?‹ã‚‰æ³¨æ–‡ã?¸æˆ»ã‚‹',0),(94676,2630,'pt','DevoluÃ§Ã£o de Check-Out',0),(94677,2630,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ',0),(94678,2630,'es','Regresar Orden Desde FinalizaciÃ³n de la Compra',0),(94679,2630,'de','Reklamation von Check-Out',0),(94680,2630,'en','Return Order From Check Out',0),(94681,2631,'is','',0),(94682,2631,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª Ø§Ù†ØªØ®Ø§Ø¨',0),(94683,2631,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª Ø§Ù†ØªØ®Ø§Ø¨',0),(94684,2631,'tr','AyrÄ±ntÄ± seÃ§ime dÃ¶nmek',0),(94685,2631,'pl','PowrÃ³t do wyboru szczegÃ³Å‚Ã³w',0),(94686,2631,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð° ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ',0),(94687,2631,'ur','ØªÙØµÛŒÙ„ Ú©Û’ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù„ÛŒÛ’ ÙˆØ§Ù¾Ø³',0),(94688,2631,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ñƒ Ð¸Ð·Ð±Ð¾Ñ€ Ð´ÐµÑ‚Ð°Ñ™Ð°',0),(94689,2631,'vi','Trá»Ÿ láº¡i chá»n lá»±a chi tiáº¿t',0),(94690,2631,'af','Keer terug na detail seleksie',0),(94691,2631,'ro','Reveni la detaliu selecÅ£ie',0),(94692,2631,'et','Naaske detail valik',0),(94693,2631,'si','Vrniti podrobno izbiro',0),(94694,2631,'ba','Kembali ke seleksi detail',0),(94695,2631,'nl','Terug naar detail selectie',0),(94696,2631,'fi','Palaa yksityiskohtaisesti',0),(94697,2631,'no','GÃ¥ tilbake til detalj utvalg',0),(94698,2631,'da','Vend tilbage til detaljeret udvÃ¦lgelse',0),(94699,2631,'ko','ì„¸ë¶€ ì„ íƒì— ë°˜í™˜',0),(94700,2631,'he','×œ×—×–×•×¨ ×¢×œ ×”×¤×™×¨×•×˜ ×”× ×‘×—×¨',0),(94701,2631,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(94702,2631,'zh','è¿”å›žè¯¦ç»†é€‰æ‹©\r\n',0),(94703,2631,'sv','Ã…tergÃ¥ till detalj urval',0),(94704,2631,'it','Tornare alla selezione del dettaglio',0),(94705,2631,'tl','',0),(94706,2631,'th','&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(94707,2631,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥Œà¤Ÿà¥‡à¤‚',0),(94708,2631,'ms','Kembali ke pilihan terperinci',0),(94709,2631,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(94710,2631,'fr','Retour Ã  la sÃ©lection de dÃ©tail',0),(94711,2631,'jp','é?¸æŠžè‚¢è©³ç´°ã?¸æˆ»ã‚‹',0),(94712,2631,'pt','Regressar Ã  selecÃ§Ã£o de detalhe',0),(94713,2631,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ð´ÐµÑ‚Ð°Ð»ÑŒÐ½Ð¾Ð¼Ñƒ Ð²Ñ‹Ð±Ð¾Ñ€Ñƒ',0),(94714,2631,'es','Regresar a la selecciÃ³n detallada',0),(94715,2631,'de','ZurÃ¼ck zur Detailauswahl',0),(94716,2631,'en','Return to detail selection',0),(94717,2632,'is','',0),(94718,2632,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(94719,2632,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(94720,2632,'tr','Detay iÅŸ tÃ¼rÃ¼ne geri dÃ¶nmek',0),(94721,2632,'pl','PowrÃ³t do szczegÃ³Å‚Ã³w pracy typu',0),(94722,2632,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿',0),(94723,2632,'ur','ØªÙØµÛŒÙ„ Ú©Û’ Ú©Ø§Ù… Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª Ù…ÛŒÚº ÙˆØ§Ù¾Ø³ÛŒ',0),(94724,2632,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ñƒ Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð° Ð´ÐµÑ‚Ð°Ñ™',0),(94725,2632,'vi','Trá»Ÿ láº¡i loáº¡i cÃ´ng viá»‡c chi tiáº¿t',0),(94726,2632,'af','Keer terug na detail werk tipe',0),(94727,2632,'ro','Reveni la detaliu locul de muncÄƒ tip',0),(94728,2632,'et','Naaske detail tÃ¶Ã¶ tÃ¼Ã¼p',0),(94729,2632,'si','Vrne vrsto dela podrobno',0),(94730,2632,'ba','Kembali ke jenis pekerjaan detail',0),(94731,2632,'nl','Terug naar detail werksoort',0),(94732,2632,'fi','Palata yksityiskohtaisesti tyÃ¶n tyyppi',0),(94733,2632,'no','GÃ¥ tilbake til detalj arbeidstype',0),(94734,2632,'da','Vend tilbage til detaljeret arbejdstype',0),(94735,2632,'ko','ì„¸ë¶€ ìž‘ì—… í˜•ì‹ ë°˜í™˜',0),(94736,2632,'he','×œ×—×–×•×¨ ×¤×™×¨×•×˜ ×¡×•×’ ×¢×‘×•×“×”',0),(94737,2632,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ­ÏˆÏ„Îµ Ï„Î·Î½ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(94738,2632,'zh','è¿”å›žçš„ç»†èŠ‚å·¥ä½œç±»åž‹\r\n',0),(94739,2632,'sv','Ã…tergÃ¥ till detalj arbetstyp',0),(94740,2632,'it','Tornare al tipo di lavoro di dettaglio',0),(94741,2632,'tl','',0),(94742,2632,'th','&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3626;&#3641;&#3656;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(94743,2632,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤ªà¤¸ à¤œà¤¾à¤à¤',0),(94744,2632,'ms','Kembali ke jenis kerja terperinci',0),(94745,2632,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(94746,2632,'fr','Revenir Ã  type de travaux de dÃ©tail',0),(94747,2632,'jp','ä»•äº‹å†…å®¹è©³ç´°ã?¸æˆ»ã‚‹',0),(94748,2632,'pt','Retornar ao tipo de trabalho de detalhe',0),(94749,2632,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ð´ÐµÑ‚Ð°Ð»ÑÐ¼ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(94750,2632,'es','Regresar a tipo de trabajo detallada',0),(94751,2632,'de','ZurÃ¼ck zur Detail-Arbeit-Typ',0),(94752,2632,'en','Return to detail work type',0),(94753,2633,'is','',0),(94754,2633,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(94755,2633,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(94756,2633,'tr','Ä°ade iÅŸlemi iÃ§in boyut fiyatlandÄ±rma',0),(94757,2633,'pl','PowrÃ³t do operacji wielkoÅ›ci ceny',0),(94758,2633,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(94759,2633,'ur','ÙˆØ§Ù¾Ø³ÛŒ Ú©Û’ Ø¹Ù…Ù„ Ù¾Ø± Ø³Ø§Ø¦Ø² Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(94760,2633,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ñƒ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ñƒ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(94761,2633,'vi','Trá»Ÿ láº¡i kÃ­ch cá»¡ giÃ¡ hoáº¡t Ä‘á»™ng ',0),(94762,2633,'af','Keer terug na bewerking grootte pryse',0),(94763,2633,'ro','Reveni la funcÅ£ionarea dimensiune preturi',0),(94764,2633,'et','Naasta tÃ¶Ã¶ maht hindade',0),(94765,2633,'si','Vrnitev k delovanju velikost cen',0),(94766,2633,'ba','Kembali ke operasi ukuran harga',0),(94767,2633,'nl','Terug naar operatie grootte prijzen',0),(94768,2633,'fi','Palaa toiminta kokoa hinnoittelu',0),(94769,2633,'no','GÃ¥ tilbake til operasjonen stÃ¸rrelse priser',0),(94770,2633,'da','Vende tilbage til Operation stÃ¸rrelse prissÃ¦tning',0),(94771,2633,'ko','ìž‘ì—… ë°˜í™˜ í¬ê¸° ê°€ê²©',0),(94772,2633,'he','×œ×—×–×•×¨ ××œ ×¤×¢×•×œ×ª ×ª×ž×—×•×¨ ×’×•×“×œ',0),(94773,2633,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÏƒÏ„Î·Î½ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(94774,2633,'zh','è¿”å›žä¸šåŠ¡è§„æ¨¡å®šä»·\r\n',0),(94775,2633,'sv','Ã…tergÃ¥ till drift storlek prissÃ¤ttning',0),(94776,2633,'it','Tornare al funzionamento dimensioni prezzi',0),(94777,2633,'tl','',0),(94778,2633,'th','&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;',0),(94779,2633,'hi','à¤²à¥Œà¤Ÿà¤¨à¥‡ à¤•à¥‡ à¤†à¤ªà¤°à¥‡à¤¶à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‡ à¤†à¤•à¤¾à¤°',0),(94780,2633,'ms','Kembali ke operasi saiz harga',0),(94781,2633,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø§Ù„Ø­Ø¬Ù…',0),(94782,2633,'fr','Revenir en mode taille prix',0),(94783,2633,'jp','ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã‚µã‚¤ã‚ºå€¤ä»˜ã?‘ã?¸æˆ»ã‚‹',0),(94784,2633,'pt','Voltar ao funcionamento tamanho preÃ§os',0),(94785,2633,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ð² Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ñ†ÐµÐ½Ñ‹',0),(94786,2633,'es','Regresar al Precios de TamaÃ±o de  OperaciÃ³n ',0),(94787,2633,'de','ZurÃ¼ck zu Operation GrÃ¶ÃŸe Preise',0),(94788,2633,'en','Return to Operation Size Pricing',0),(94789,2634,'is','',0),(94790,2634,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ù‚Ø³Ù…Øª Ø§Ù†ØªØ®Ø§Ø¨ ',0),(94791,2634,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ù‚Ø³Ù…Øª Ø§Ù†ØªØ®Ø§Ø¨ ',0),(94792,2634,'tr','BÃ¶lÃ¼m seÃ§imi dÃ¶ndÃ¼rmek',0),(94793,2634,'pl','PowrÃ³t do wyboru czÄ™Å›ci',0),(94794,2634,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ñ‡Ð°ÑÑ‚ Ð¸Ð·Ð±Ð¾Ñ€',0),(94795,2634,'ur','Ø­ØµÛ Ø§Ù†ØªØ®Ø§Ø¨ Ù¾Ø± ÙˆØ§Ù¾Ø³ Ø¬Ø§Ø¦ÛŒÚº',0),(94796,2634,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ñƒ ÑƒÐ»Ð¾Ð³Ñƒ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ñƒ',0),(94797,2634,'vi','Trá»Ÿ láº¡i pháº§n chá»n phá»¥ tÃ¹ng',0),(94798,2634,'af','Keer terug na deel seleksie',0),(94799,2634,'ro','A reveni la partea de selecÅ£ie',0),(94800,2634,'et','Tagastab osa valik',0),(94801,2634,'si','Vrniti del izbiro',0),(94802,2634,'ba','Kembali ke bagian pilihan',0),(94803,2634,'nl','Terug naar deel selectie',0),(94804,2634,'fi','Palaa osa',0),(94805,2634,'no','GÃ¥ tilbake til delutvalget',0),(94806,2634,'da','Vende tilbage til en del udvalg',0),(94807,2634,'ko','ì¼ë¶€ ì„ íƒ ì˜ì—­ì„ ë°˜í™˜',0),(94808,2634,'he','×œ×—×–×•×¨ ×¢×œ ×”×—×œ×§ ×”× ×‘×—×¨',0),(94809,2634,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® Î¼Î­ÏÎ¿Ï‚',0),(94810,2634,'zh','è¿”å›žåˆ°éƒ¨åˆ†é€‰é¡¹\r\n',0),(94811,2634,'sv','Tillbaka till del val',0),(94812,2634,'it','Tornare alla selezione di parte',0),(94813,2634,'tl','',0),(94814,2634,'th','&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3656;&#3623;&#3609;',0),(94815,2634,'hi','à¤­à¤¾à¤— à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥Œà¤Ÿà¥‡à¤‚',0),(94816,2634,'ms','Kembali ke bahagian pilihan',0),(94817,2634,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø¬Ø²Ø¡ Ø§Ù„ØªØ­Ø¯ÙŠØ¯',0),(94818,2634,'fr','Retour Ã  la sÃ©lection d\'un composant',0),(94819,2634,'jp','éƒ¨å“?é?¸æŠžã?¸æˆ»ã‚‹',0),(94820,2634,'pt','Regressar Ã  selecÃ§Ã£o de parte',0),(94821,2634,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾Ð¼Ñƒ Ð’Ñ‹Ð±Ð¾Ñ€Ñƒ',0),(94822,2634,'es','Regresar a la SelecciÃ³n de Partes',0),(94823,2634,'de','ZurÃ¼ck zu Teilauswahl',0),(94824,2634,'en','Return to Part Selection',0),(94825,2635,'is','',0),(94826,2635,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ ',0),(94827,2635,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ ',0),(94828,2635,'tr','SeÃ§ime dÃ¶nmek',0),(94829,2635,'pl','PowrÃ³t do wyboru',0),(94830,2635,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ',0),(94831,2635,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ù¾Ø± ÙˆØ§Ù¾Ø³ Ø¬Ø§Ø¦ÛŒÚº',0),(94832,2635,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ñƒ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ð¸',0),(94833,2635,'vi','Trá»Ÿ láº¡i pháº§n lá»±a chá»n',0),(94834,2635,'af','Terug na Seleksie',0),(94835,2635,'ro','A reveni la selecÅ£ia',0),(94836,2635,'et','Tagasi valikusse',0),(94837,2635,'si','Vrniti izbiro',0),(94838,2635,'ba','Kembali ke seleksi',0),(94839,2635,'nl','Terug naar selectie',0),(94840,2635,'fi','Palaa',0),(94841,2635,'no','GÃ¥ tilbake til valg',0),(94842,2635,'da','Vende tilbage til udvalg',0),(94843,2635,'ko','ì„ íƒ ì˜ì—­ì„ ë°˜í™˜',0),(94844,2635,'he','×—×–×•×¨ ××œ ×”×‘×—×™×¨×”',0),(94845,2635,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î®',0),(94846,2635,'zh','è¿”å›žåˆ°é€‰é¡¹\r\n',0),(94847,2635,'sv','Tillbaka till val',0),(94848,2635,'it','Tornare alla selezione',0),(94849,2635,'tl','',0),(94850,2635,'th','&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(94851,2635,'hi','à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥Œà¤Ÿà¥‡à¤‚',0),(94852,2635,'ms','Kembali ke pilihan',0),(94853,2635,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ù„Ø¥Ø®ØªÙŠØ§Ø±',0),(94854,2635,'fr','Retour Ã  la sÃ©lection',0),(94855,2635,'jp','é?¸æŠžè‚¢ã?¸æˆ»ã‚‹',0),(94856,2635,'pt','Regressar Ã  selecÃ§Ã£o',0),(94857,2635,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ð’Ñ‹Ð±Ð¾Ñ€Ñƒ',0),(94858,2635,'es','Regresar a la SelecciÃ³n',0),(94859,2635,'de','ZurÃ¼ck zur Auswahl',0),(94860,2635,'en','Return to Selection',0),(94861,2636,'is','',0),(94862,2636,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ù†Ø¨Ø§Ø± ÙØ±Ø¹ÙŠ ',0),(94863,2636,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ù†Ø¨Ø§Ø± ÙØ±Ø¹ÙŠ ',0),(94864,2636,'tr','Hisse senedi DÃ¼zenle alt geri dÃ¶nÃ¼n',0),(94865,2636,'pl','PowrÃ³t do sub edit pieÅ„',0),(94866,2636,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð¿Ð¾Ð´ ÑÐºÐ»Ð°Ð´ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(94867,2636,'ur','Ø§Ø³Ù¹Ø§Ú© ØªØ¯ÙˆÛŒÙ† Ø³Ø¨ Ø²ÛŒØ±ÙˆÛ ÙˆØ§Ù¾Ø³ÛŒ',0),(94868,2636,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ñƒ Ð¿Ð¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐ°',0),(94869,2636,'vi','Quay Láº¡i Chá»‰nh Sá»­a NhÃ³m HÃ ng Tá»“n Kho Phá»¥',0),(94870,2636,'af','Keer terug na sub voorraad redigeer',0),(94871,2636,'ro','Reveni la sub editare stoc',0),(94872,2636,'et','Naaske sub stock edit',0),(94873,2636,'si','Vrnitev v sub zalog Uredi',0),(94874,2636,'ba','Kembali ke sub saham edit',0),(94875,2636,'nl','Terug naar sub voorraad bewerken',0),(94876,2636,'fi','Palaa osa varastossa muokkaus',0),(94877,2636,'no','GÃ¥ tilbake til sub lager Rediger',0),(94878,2636,'da','Vende tilbage til sub stock Rediger',0),(94879,2636,'ko','ì‚¬ì§„ íŽ¸ì§‘ì„ í•˜ìœ„ ë°˜í™˜',0),(94880,2636,'he','×œ×—×–×•×¨ ×¡××‘ ×¢×¨×™×›×” ×ž× ×™×•×ª',0),(94881,2636,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÏƒÏ„Î·Î½ Ï…Ï€Î¿ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(94882,2636,'zh','è¿”å›žå­åº“å­˜ç¼–è¾‘\r\n',0),(94883,2636,'sv','Ã…tergÃ¥ till sub lager edit',0),(94884,2636,'it','Ritorno a sub dipinga modifica',0),(94885,2636,'tl','',0),(94886,2636,'th','&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3626;&#3605;&#3658;&#3629;&#3585;&#3618;&#3656;&#3629;&#3618;',0),(94887,2636,'hi','à¤‰à¤ª à¤¶à¥‡à¤¯à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥Œà¤Ÿà¥‡à¤‚',0),(94888,2636,'ms','Kembali ke sub edit saham',0),(94889,2636,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ sub ØªØ­Ø±ÙŠØ± Ø§Ù„Ø£Ø³Ù‡Ù…',0),(94890,2636,'fr','Retourner void / edit stock',0),(94891,2636,'jp','ã‚µãƒ–ã‚¹ãƒˆãƒƒã‚¯ã?®ç·¨é›†ã?¸æˆ»ã‚‹',0),(94892,2636,'pt','Retornar para sub editar aÃ§Ãµes',0),(94893,2636,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ðº ÑŽÐ³Ñƒ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(94894,2636,'es','Regresar a la ediciÃ³n de sub stock',0),(94895,2636,'de','ZurÃ¼ck zu Lager bearbeiten sub',0),(94896,2636,'en','Return to sub stock edit',0),(94897,2637,'is','',0),(94898,2637,'dr','- Ø§ÙˆÙ„ Ø°Ø®ÙŠØ±Ù‡ ÙƒÙ†ÙŠØ¯',0),(94899,2637,'pr','Ø¢ÙŠØ§ Ø¨Ù‡  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø¨Ø²Ø§Ø± Ø¨Ø±Ú¯Ø±Ø¯Ø¯ØŸ - Ø§ÙˆÙ„ Ø°Ø®ÙŠØ±Ù‡ ÙƒÙ†ÙŠØ¯',0),(94900,2637,'tr','AraÃ§larÄ± gÃ¼ncelleÅŸtirmek iÃ§in dÃ¶nmek mi? -Ä°LK KURTARIN!',0),(94901,2637,'pl','PowrÃ³t do aktualizacji narzÄ™dzia? -ZAPISAÄ† PIERWSZY!',0),(94902,2637,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Update Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¸? -Ð—ÐÐŸÐÐ—Ð’ÐÐÐ• ÐÐ ÐŸÐªÐ Ð’Ðž ÐœÐ¯Ð¡Ð¢Ðž!',0),(94903,2637,'ur','Ù¹ÙˆÙ„Ø² Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒØŸ -Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº!',0),(94904,2637,'sr','ÐŸÐ¾Ð²Ñ€Ð°Ñ‚Ð°Ðº Ð½Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ð¸ Ð°Ð»Ð°Ñ‚? -Ð¡ÐÐ§Ð£Ð’ÐÐˆ ÐŸÐ Ð’Ð˜!',0),(94905,2637,'vi','Quay Láº¡i CÃ´ng Cá»¥ Cáº­p Nháº­t? - SAO LÆ¯U TRÆ¯á»šC',0),(94906,2637,'af','Terugkeer na die gereedskap werk? -STOOR EERSTE!',0),(94907,2637,'ro','ÃŽntoarcere la spre Update UnealtÄƒ? -SALVAÅ¢I PRIMUL!',0),(94908,2637,'et','Tagasi muudetud tÃ¶Ã¶riistad? -SALVESTADA ESIMENE!',0),(94909,2637,'si','Vrnitev za posodobitev orodja? -SHRANITE PRVI!',0),(94910,2637,'ba','Kembali untuk memperbarui alat? -SIMPAN PERTAMA!',0),(94911,2637,'nl','Terug naar Update Tools? -BEWAAR EERSTE!',0),(94912,2637,'fi','Palata pÃ¤ivittÃ¤Ã¤ tyÃ¶kalut? -TALLENNA ENSIMMÃ„INEN!',0),(94913,2637,'no','Tilbake til oppdatere verktÃ¸y? -LAGRE FÃ˜RSTE!',0),(94914,2637,'da','Tilbagevenden til opdatere vÃ¦rktÃ¸jer? -SPAR FÃ˜RSTE!',0),(94915,2637,'ko','ë„êµ¬ë¥¼ ì—…ë°ì´íŠ¸ í•˜ë ¤ë©´ ë°˜í™˜? -ì²« ë²ˆì§¸ ì €ìž¥!',0),(94916,2637,'he','×œ×—×–×•×¨ ×œ×¢×“×›×Ÿ ×›×œ×™×? -×œ×”×¦×™×œ ××ª ×”×¨××©×•×Ÿ!',0),(94917,2637,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î³Î¹Î± Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏÎ³Î±Î»ÎµÎ¯Î±; -Î‘Î ÎŸÎ˜Î—ÎšÎ•ÎŽÎ£Î•Î¤Î• Î¤Î—Î Î Î¡ÎÎ¤Î—!',0),(94918,2637,'zh','è¿”å›žåˆ°æ›´æ–°å·¥å…·ï¼Ÿ -å…ˆå­˜ç›˜ï¼\r\n',0),(94919,2637,'sv','Ã…tergÃ¥ng till uppdatera verktyg? -SPARA FÃ–RSTA!',0),(94920,2637,'it','Ritorno ad aggiornare gli strumenti? -SALVARE IL PRIMO!',0),(94921,2637,'tl','',0),(94922,2637,'th','&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;&#3627;&#3619;&#3639;&#3629;&#3652;&#3',0),(94923,2637,'hi','à¤‰à¤ªà¤•à¤°à¤£à¥‹à¤‚ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥Œà¤Ÿà¥‡à¤‚? -à¤ªà¥à¤°à¤¥à¤® à¤¬à¤šà¤¾à¤“!',0),(94924,2637,'ms','Kembali ke kini alat? -SIMPAN PERTAMA!',0),(94925,2637,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ ØªØ­Ø¯ÙŠØ« Ø£Ø¯ÙˆØ§ØªØŸ -Ø­ÙØ¸ Ø£ÙˆÙ„!',0),(94926,2637,'fr','Retour mise Ã  jour des outils ? -ENREGISTRER LE PREMIER !',0),(94927,2637,'jp','ãƒ„ãƒ¼ãƒ«ã?®æ›´æ–°ã?¸æˆ»ã‚Šã?¾ã?™ã?‹ï¼Ÿï¼?ã?¾ã?šä¿?å­˜ã?—ã?¦ã??ã? ã?•ã?„ï¼?',0),(94928,2637,'pt','Retornar para atualizar ferramentas? -SALVE PRIMEIRO!',0),(94929,2637,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ð´Ð»Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²? -Ð¡ÐžÐ¥Ð ÐÐÐ˜Ð¢Ð• ÐŸÐ•Ð Ð’Ð«Ð™!',0),(94930,2637,'es','Regresar a las Herramientas de Actualizar - GUARDAR PRIMERO',0),(94931,2637,'de','RÃ¼ckkehr nach Tools zu aktualisieren? -SPAREN SIE ERSTER!',0),(94932,2637,'en','Return to Update Tools? - SAVE FIRST!',0),(94933,2638,'is','',0),(94934,2638,'dr','Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(94935,2638,'pr','Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(94936,2638,'tr','DÃ¶ndÃ¼rÃ¼len',0),(94937,2638,'pl','WrÃ³ciÅ‚',0),(94938,2638,'bg','Ð’Ñ€ÑŠÑ‰Ð°',0),(94939,2638,'ur','Ù„ÙˆÙ¹',0),(94940,2638,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ð¾ ÑÐµ',0),(94941,2638,'vi','ÄÃ£ trá»Ÿ láº¡i',0),(94942,2638,'af','Teruggekeer',0),(94943,2638,'ro','S-a Ã®ntors',0),(94944,2638,'et','Tagastatud',0),(94945,2638,'si','Vrnil',0),(94946,2638,'ba','Kembali',0),(94947,2638,'nl','Terug',0),(94948,2638,'fi','Palauttaa',0),(94949,2638,'no','Returnert',0),(94950,2638,'da','Returneret',0),(94951,2638,'ko','ë°˜í™˜',0),(94952,2638,'he','×”×•×—×–×¨',0),(94953,2638,'el','Î•Ï€Î­ÏƒÏ„ÏÎµÏˆÎµ',0),(94954,2638,'zh','è¿”å›ž\r\n',0),(94955,2638,'sv','Ã…tervÃ¤nde',0),(94956,2638,'it','Restituito',0),(94957,2638,'tl','',0),(94958,2638,'th','&#3588;&#3639;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(94959,2638,'hi','à¤²à¥Œà¤Ÿà¥‡',0),(94960,2638,'ms','Kembali',0),(94961,2638,'ar','Ø¹Ø§Ø¯',0),(94962,2638,'fr','RetournÃ©',0),(94963,2638,'jp','æˆ»ã‚Šã?¾ã?—ã?Ÿ',0),(94964,2638,'pt','Retornado',0),(94965,2638,'ru','Ð’ÐµÑ€Ð½ÑƒÐ»ÑÑ',0),(94966,2638,'es','Regresado',0),(94967,2638,'de','ZurÃ¼ckgegeben',0),(94968,2638,'en','Returned',0),(94969,2639,'is','',0),(94970,2639,'dr','ØªÙ…Ø§Ù… Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ÙƒÙ‡ Ø¯Ø±ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ù…Ø¹ÙŠÙ† Ù¾Ø³Øª Ø´Ø¯Ù‡  Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯',0),(94971,2639,'pr','ØªÙ…Ø§Ù… Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ÙƒÙ‡ Ø¯Ø±ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ù…Ø¹ÙŠÙ† Ù¾Ø³Øª Ø´Ø¯Ù‡  Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯',0),(94972,2639,'tr','Belirli bir tarihte deftere nakledilen tÃ¼m fiÅŸler ters',0),(94973,2639,'pl','OdwrÃ³ciÄ‡ wszystkie zaÅ‚Ä…czniki zamieszczone w okreÅ›lonym dniu',0),(94974,2639,'bg','ÐžÑ‚Ð¼ÐµÐ½Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸, Ð¿ÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½ Ð½Ð° Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð° Ð´Ð°Ñ‚Ð°',0),(94975,2639,'ur','Ù…ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ù¾Ø± Ú©Ø³ÛŒ Ù…Ø®ØµÙˆØµ ØªØ§Ø±ÛŒØ® Ú©Û’ ØªÙ…Ø§Ù… ÙˆØ§Ø¤Ú†Ø± Ù…Ø¹Ú©ÙˆØ³ Ú©Ø±ÛŒÚº',0),(94976,2639,'sr','ÐžÐ±Ñ€Ð½ÑƒÑ‚Ð¸ ÑÐ²Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¾Ð³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(94977,2639,'vi','Viáº¿t ngÆ°á»£c táº¥t cáº£ cÃ¡c phiáº¿u Ä‘Ã£ Ä‘Äƒng trong ngÃ y cá»¥ thá»ƒ',0),(94978,2639,'af','Terugskrywing van Alle Bewysstukke Gepos OP \'n Spesifieke Datum',0),(94979,2639,'ro','Reverse toate voucherele postat pe o anumitÄƒ datÄƒ',0),(94980,2639,'et','Reverse kindlal KUUPÃ„EVAL konteeritud kanded',0),(94981,2639,'si','Reverse vse kupone, objavljene na doloÄen datum',0),(94982,2639,'ba','Membalikkan semua voucher yang dikirim pada tanggal tertentu',0),(94983,2639,'nl','Omkeren van alle Vouchers geplaatst op een specifieke datum',0),(94984,2639,'fi','KÃ¤Ã¤ntÃ¤Ã¤ kaikki tositteet lÃ¤hetetty tiettynÃ¤ pÃ¤ivÃ¤nÃ¤',0),(94985,2639,'no','Omvendt alle bilag som er bokfÃ¸rt pÃ¥ en bestemt dato',0),(94986,2639,'da','TilbagefÃ¸re alle gavekort sendt oven pÃ¥ en bestemt dato',0),(94987,2639,'ko','íŠ¹ì • ë‚ ì§œì— ê²Œì‹œ ëœ ëª¨ë“  ìƒí’ˆê¶Œ ì—­',0),(94988,2639,'he','×”×¤×•×š ×›×œ ×”×©×•×‘×¨×™× ×¤×•×¨×¡× ×‘×ª××¨×™×š ×ž×¡×•×™×',0),(94989,2639,'el','Î‘Î½Ï„Î¹ÏƒÏ„ÏÎ­ÏˆÎµÏ„Îµ ÏŒÎ»Î± Ï„Î± ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î± Ï€Î¿Ï… Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏ„Î·ÎºÎµ ÏƒÎµ ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(94990,2639,'zh','é€†å‘æ‰€æœ‰ç¤¼åˆ¸å‘å¸ƒäºŽç‰¹å®šæ—¥æœŸ\r\n',0),(94991,2639,'sv','VÃ¤nda alla verifikationer postat pÃ¥ ett visst datum',0),(94992,2639,'it','Invertire tutti i voucher inviato in una data specifica',0),(94993,2639,'tl','',0),(94994,2639,'th','&#3585;&#3621;&#3633;&#3610;&#3604;&#3657;&#3634;&#3609;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3',0),(94995,2639,'hi','à¤¸à¤­à¥€ à¤µà¤¾à¤‰à¤šà¤° à¤à¤• à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤¤à¤¿à¤¥à¤¿ à¤ªà¤° à¤¤à¥ˆà¤¨à¤¾à¤¤ à¤°à¤¿à¤µà¤°à¥à¤¸',0),(94996,2639,'ms','Berbalik semua baucar yang dihantar pada tarikh tertentu',0),(94997,2639,'ar','Ø¹ÙƒØ³ ÙƒØ§ÙØ© Ø§Ù„Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„ØªÙŠ Ù†Ø´Ø±Øª ÙÙŠ ØªØ§Ø±ÙŠØ® Ù…Ø­Ø¯Ø¯',0),(94998,2639,'fr','Inverser tous les chÃ¨ques envoyÃ©s Ã  une Date spÃ©cifique',0),(94999,2639,'jp','ç‰¹å®šã?®æ—¥ã?«è¨ˆä¸Šã?—ã?Ÿä¼?ç¥¨ã‚’å?–ã‚Šæ¶ˆã?™',0),(95000,2639,'pt','Reverter todos os Vouchers postados em uma data especÃ­fica',0),(95001,2639,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹, Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð° Ð½Ð° Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½ÑƒÑŽ Ð´Ð°Ñ‚Ñƒ',0),(95002,2639,'es','Reversar Todos Los Vouchers Asentados EN una Fecha EspecÃ­fica',0),(95003,2639,'de','Umkehren Sie alle Gutscheine, die an einem bestimmten Datum geschrieben',0),(95004,2639,'en','Reverse All Vouchers Posted ON a Specific Date',0),(95005,2640,'is','',0),(95006,2640,'dr','ØªÙ…Ø§Ù… Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ÙƒÙ‡ Ø¨Ù‡ ÙŠÙƒ Ù…Ø§Ù‡ Ù…Ø¹ÙŠÙ† Ù¾Ø³Øª Ø´Ø¯Ù‡  Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯',0),(95007,2640,'pr','ØªÙ…Ø§Ù… Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ÙƒÙ‡ Ø¨Ù‡ ÙŠÙƒ Ù…Ø§Ù‡ Ù…Ø¹ÙŠÙ† Ù¾Ø³Øª Ø´Ø¯Ù‡  Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯',0),(95008,2640,'tr','Belirli bir ay iÃ§in yayÄ±nlanan tÃ¼m fiÅŸler ters',0),(95009,2640,'pl','OdwrÃ³ciÄ‡ wszystkie zaÅ‚Ä…czniki zamieszczone na dany miesiÄ…c',0),(95010,2640,'bg','ÐžÑ‚Ð¼ÐµÐ½Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸, Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ ÐºÑŠÐ¼ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ð¼ÐµÑÐµÑ†',0),(95011,2640,'ur','ØªÙ…Ø§Ù… ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ Ø´Ú©Ù„ Ù…ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ø§ÛŒÚ© Ù…Ø®ØµÙˆØµ Ù…ÛÛŒÙ†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø¹Ú©ÙˆØ³ Ú©Ø±ÛŒÚº',0),(95012,2640,'sr','ÐžÐ±Ñ€Ð½ÑƒÑ‚Ð¸ ÑÐ²Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ Ñƒ Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¾Ð¼ Ð¼ÐµÑÐµÑ†Ñƒ',0),(95013,2640,'vi','Viáº¿t ngÆ°á»£c táº¥t cáº£ cÃ¡c phiáº¿u Ä‘Ã£ Ä‘Äƒng trong thÃ¡ng cá»¥ thá»ƒ',0),(95014,2640,'af','Terugskrywing van Alle Bewysstukke Gepos NA \'n Spesifieke Maand',0),(95015,2640,'ro','Reverse toate voucherele postat la o anumitÄƒ lunÄƒ',0),(95016,2640,'et','Reverse kuusse sisestatud kanded',0),(95017,2640,'si','Reverse vse kupone Objavljeno poseben mesec',0),(95018,2640,'ba','Membalikkan semua voucher yang dikirim sebulan tertentu',0),(95019,2640,'nl','Alle bonnen Gepost naar een specifieke maand omkeren',0),(95020,2640,'fi','KÃ¤Ã¤ntÃ¤Ã¤ kaikki tositteet kirjataan tietyn kuukauden',0),(95021,2640,'no','Omvendt alle bilag posteres til en bestemt mÃ¥ned',0),(95022,2640,'da','TilbagefÃ¸re alle gavekort sendt til en bestemt mÃ¥ned',0),(95023,2640,'ko','íŠ¹ì • ì›”ì— ê²Œì‹œ ëœ ëª¨ë“  ìƒí’ˆê¶Œ ì—­',0),(95024,2640,'he','×”×¤×•×š ×›×œ ×”×©×•×‘×¨×™× ×¤×•×¨×¡× ×œ×—×•×“×© ×¡×¤×¦×™×¤×™',0),(95025,2640,'el','Î‘Î½Ï„Î¹ÏƒÏ„ÏÎ­ÏˆÎµÏ„Îµ ÏŒÎ»Î± Ï„Î± ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î± Ï€Î¿Ï… Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏ„Î·ÎºÎµ ÏƒÎµ Î­Î½Î± ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Î¼Î®Î½Î±',0),(95026,2640,'zh','ä½ æƒ³æ‰€æœ‰ä¼˜æƒ åˆ¸å‘å¸ƒåˆ°ç‰¹å®šæœˆä»½\r\n',0),(95027,2640,'sv','VÃ¤nda alla verifikationer bokfÃ¶rs en viss mÃ¥nad',0),(95028,2640,'it','Invertire tutti i voucher inviato a un mese specifico',0),(95029,2640,'tl','',0),(95030,2640,'th','&#3585;&#3621;&#3633;&#3610;&#3604;&#3657;&#3634;&#3609;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3',0),(95031,2640,'hi','à¤¸à¤­à¥€ à¤µà¤¾à¤‰à¤šà¤° à¤à¤• à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¨à¤¾à¤¤ à¤°à¤¿à¤µà¤°à¥à¤¸',0),(95032,2640,'ms','Berbalik semua baucar yang dihantar kepada satu bulan tertentu',0),(95033,2640,'ar','Ø¹ÙƒØ³ ÙƒØ§ÙØ© Ø§Ù„Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… ØªØ±Ø­ÙŠÙ„Ù‡Ø§ Ø¥Ù„Ù‰ Ø´Ù‡Ø± Ù…Ø¹ÙŠÙ†',0),(95034,2640,'fr','Inverser tous les volets, postÃ©s Ã  un mois spÃ©cifique',0),(95035,2640,'jp','ç‰¹å®šã?®æœˆã?¸è¨ˆä¸Šã?—ã?Ÿä¼?ç¥¨ã‚’å?–ã‚Šæ¶ˆã?™',0),(95036,2640,'pt','Reverter todos os Vouchers postados para um mÃªs especÃ­fico',0),(95037,2640,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹, Ð½Ð°Ð¿Ð¸ÑÐ°Ð» Ð´Ð»Ñ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ð¾Ð³Ð¾ Ð¼ÐµÑÑÑ†Ð°',0),(95038,2640,'es','Reversar Todos Los Vouchers Asentados A una Mes EspecÃ­fico',0),(95039,2640,'de','Umkehren Sie alle Gutscheine auf einen bestimmten Monat gebucht',0),(95040,2640,'en','Reverse All Vouchers Posted TO a Specific Month',0),(95041,2641,'is','',0),(95042,2641,'dr','Ù¾Ø³Øª  Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯',0),(95043,2641,'pr','Ù¾Ø³Øª  Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯',0),(95044,2641,'tr','Ters yazÄ±',0),(95045,2641,'pl','OdwrÃ³ciÄ‡ Post',0),(95046,2641,'bg','ÐžÐ±Ñ€Ð°Ñ‚ÐµÐ½ Ð¿Ð¾ÑÑ‚',0),(95047,2641,'ur','Ù¾ÙˆØ³Ù¹ Ù…Ø¹Ú©ÙˆØ³ Ú©Ø±ÛŒÚº',0),(95048,2641,'sr','ÐžÐ±Ñ€Ð½ÑƒÑ‚Ð¸ ÐŸÐ¾ÑÑ‚',0),(95049,2641,'vi','Viáº¿t ngÆ°á»£c káº¿t chuyá»ƒn',0),(95050,2641,'af','Terugskryf van Pos',0),(95051,2641,'ro','Inversa Post',0),(95052,2641,'et','PÃ¶Ã¶rdtehingud Post',0),(95053,2641,'si','Reverse Post',0),(95054,2641,'ba','Membalikkan posting',0),(95055,2641,'nl','Omgekeerde Post',0),(95056,2641,'fi','Peruuta viesti',0),(95057,2641,'no','Omvendt innlegg',0),(95058,2641,'da','Omvendt indlÃ¦g',0),(95059,2641,'ko','ì—­ë°©í–¥ ê²Œì‹œë¬¼',0),(95060,2641,'he','×¤×•×¡×˜ ×”×¤×•×›×”',0),(95061,2641,'el','Î‘Î½Ï„Î¯ÏƒÏ„ÏÎ¿Ï†Î· Î¸Î­ÏƒÎ·',0),(95062,2641,'zh','åå‘é‚®æ”¿\r\n',0),(95063,2641,'sv','OmvÃ¤nd inlÃ¤gg',0),(95064,2641,'it','Invertire Post',0),(95065,2641,'tl','',0),(95066,2641,'th','&#3606;&#3629;&#3618;&#3585;&#3621;&#3633;&#3610;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(95067,2641,'hi','à¤°à¤¿à¤µà¤°à¥à¤¸ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(95068,2641,'ms','Berbalik Post',0),(95069,2641,'ar','Ø¹ÙƒØ³ ÙˆØ¸ÙŠÙØ©',0),(95070,2641,'fr','Poste inversÃ©',0),(95071,2641,'jp','è¨ˆä¸Šå?–ã‚Šæ¶ˆã?—',0),(95072,2641,'pt','Post reversa',0),(95073,2641,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ñ‹Ð¹ Ð¿Ð¾ÑÑ‚',0),(95074,2641,'es','Reversar Asentar',0),(95075,2641,'de','Reverse Post',0),(95076,2641,'en','Reverse Post',0),(95077,2642,'is','',0),(95078,2642,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ù¾Ø³Øª â€“ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ',0),(95079,2642,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ù¾Ø³Øª â€“ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ',0),(95080,2642,'tr','Ä°nceleme ve Post - fiziksel stok',0),(95081,2642,'pl','PrzeglÄ…d i Post - inwentaryzacja',0),(95082,2642,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¸ Ð¿Ð¾ÑÑ‚ - Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(95083,2642,'ur','Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ø§ÙˆØ± Ù¾ÙˆØ³Ù¹ - Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(95084,2642,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¸ ÐŸÐ¾ÑÑ‚ - Ð¿Ð¾Ð¿Ð¸ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(95085,2642,'vi','ÄÃ¡nh giÃ¡ & káº¿t chuyá»ƒn - HÃ ng tá»“n thá»±c táº¿',0),(95086,2642,'af','Besigtig en Pos - Fisiese Voorraad',0),(95087,2642,'ro','Revizuirea ÅŸi Post - inventar fizic',0),(95088,2642,'et','LÃ¤bivaatamine ja Post - inventuur',0),(95089,2642,'si','Pregled in Post - popisa zaloge',0),(95090,2642,'ba','Review dan Post - persediaan fisik',0),(95091,2642,'nl','Beoordeling en Post - inventarisatie',0),(95092,2642,'fi','Tarkastelu ja Post - inventointi',0),(95093,2642,'no','Gjennomgang og Post - vareopptelling',0),(95094,2642,'da','Anmeldelse og Post - lageropgÃ¸relse',0),(95095,2642,'ko','ê²€í†  ë° ê²Œì‹œë¬¼-ì‹¤ì œ ìž¬ê³ ',0),(95096,2642,'he','×¡×§×™×¨×” ×©×œ ×¤×•×¡×˜ - ×ž×œ××™ ×¤×™×–×™',0),(95097,2642,'el','Î‘Î½Î±ÏƒÎºÏŒÏ€Î·ÏƒÎ· ÎºÎ±Î¹ Î¼ÎµÏ„Î± - Ï†Ï…ÏƒÎ¹ÎºÎ®Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(95098,2642,'zh','å¤å®¡ä¸Žå‘å¸ƒ -å®žåœ°ç›˜ç‚¹\r\n',0),(95099,2642,'sv','Ã–versyn och Post - inventering',0),(95100,2642,'it','Recensione e Post - inventario fisico',0),(95101,2642,'tl','',0),(95102,2642,'th','&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3649;&#3621;&#3632;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; - &#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;&#3607;&#3637;&#3656;&#3617;',0),(95103,2642,'hi','à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤ªà¥‹à¤¸à¥à¤Ÿ - à¤­à¥Œà¤¤à¤¿à¤• à¤¸à¥‚à¤šà¥€',0),(95104,2642,'ms','Kajian dan pos - inventori fizikal',0),(95105,2642,'ar','Ø§Ù„Ø§Ø³ØªØ¹Ø±Ø§Ø¶ ÙˆØ§Ù„Ø¨Ø±ÙŠØ¯-Ø§Ù„Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø§Ø¯ÙŠ',0),(95106,2642,'fr','L\'examen et la Post - inventaire physique',0),(95107,2642,'jp','è¦‹ç›´ã?—ã?¦è¨ˆä¸Šï¼?æœŸæœ«æ£šå?¸',0),(95108,2642,'pt','RevisÃ£o e Post - inventÃ¡rio fÃ­sico',0),(95109,2642,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð¸ Ð¿Ð¾ÑÑ‚ - Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¾Ð¹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(95110,2642,'es','Revisar y Asentar - Inventario FÃ­sico',0),(95111,2642,'de','ÃœberprÃ¼fung und Post - Inventur',0),(95112,2642,'en','Review and Post - Physical Inventory',0),(95113,2643,'is','',0),(95114,2643,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(95115,2643,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(95116,2643,'tr','Ä°nceleme ve sÃ¼reÃ§ stok',0),(95117,2643,'pl','PrzeglÄ…d i proces inwentaryzacji',0),(95118,2643,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð½Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(95119,2643,'ur','Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ø§ÙˆØ± Ø¹Ù…Ù„ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(95120,2643,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(95121,2643,'vi','Xem Láº¡i & Xá»­ LÃ½ HÃ ng Trong Kho',0),(95122,2643,'af','Herbesigtig en Prosesseer Inventaris',0),(95123,2643,'ro','Revizuirea ÅŸi procesul de inventar',0),(95124,2643,'et','LÃ¤bivaatamine ja protsess laoseisu',0),(95125,2643,'si','Pregled in popis procesa',0),(95126,2643,'ba','Review dan proses persediaan',0),(95127,2643,'nl','Beoordeling en proces inventaris',0),(95128,2643,'fi','Tarkastelu ja prosessin varaston',0),(95129,2643,'no','Gjennomgang og prosess lager',0),(95130,2643,'da','Anmeldelse og proces lager',0),(95131,2643,'ko','ê²€í†  ë° í”„ë¡œì„¸ìŠ¤ ìž¬ê³ ',0),(95132,2643,'he','×¡×§×™×¨×” ×©×œ ×ª×”×œ×™×š ×ž×œ××™',0),(95133,2643,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· ÎºÎ±Î¹ Î· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(95134,2643,'zh','å®¡æŸ¥å’Œå¤„ç†åº“å­˜\r\n',0),(95135,2643,'sv','Ã–versyn och processen inventering',0),(95136,2643,'it','Recensione e inventario di processo',0),(95137,2643,'tl','',0),(95138,2643,'th','&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3649;&#3621;&#3632;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3588;&#3621;&#3633;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(95139,2643,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¸à¥‚à¤šà¥€ à¤”à¤° à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(95140,2643,'ms','Kajian dan proses inventori',0),(95141,2643,'ar','Ø§Ù„Ø§Ø³ØªØ¹Ø±Ø§Ø¶ ÙˆØ¹Ù…Ù„ÙŠØ© Ø§Ù„Ø¬Ø±Ø¯',0),(95142,2643,'fr','L\'examen et l\'inventaire de processus',0),(95143,2643,'jp','åœ¨åº«ã‚’è¦‹ç›´ã?—ã?¦å‡¦ç?†',0),(95144,2643,'pt','AvaliaÃ§Ã£o e inventÃ¡rio de processo',0),(95145,2643,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑÑ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(95146,2643,'es','Revisar y Procesar Inventario',0),(95147,2643,'de','ÃœberprÃ¼fung und Prozess-Inventar',0),(95148,2643,'en','Review and Process Inventory',0),(95149,2644,'is','',0),(95150,2644,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª',0),(95151,2644,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª',0),(95152,2644,'tr','GÃ¶zden geÃ§irme yapÄ± sipariÅŸler',0),(95153,2644,'pl','PrzeglÄ…d wykonania zamÃ³wienia',0),(95154,2644,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(95155,2644,'ur','Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(95156,2644,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(95157,2644,'vi','BÃ¬nh duyá»‡t ÄÆ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(95158,2644,'af','Oorsig van Geboude Bestellings',0),(95159,2644,'ro','Ordinele de a construi de revizuire',0),(95160,2644,'et','Ãœlevaade ehitada tellimused',0),(95161,2644,'si','Pregled graditi naroÄila',0),(95162,2644,'ba','Tinjauan membangun perintah',0),(95163,2644,'nl','Beoordeling Build Orders',0),(95164,2644,'fi','Tilausten kasittely rakentaa',0),(95165,2644,'no','Bygge Ordredetaljer',0),(95166,2644,'da','Anmeldelse Byg ordrer',0),(95167,2644,'ko','ê²€í†  ë¹Œë“œ ìˆœì„œ',0),(95168,2644,'he','×‘×—×•×Ÿ ×”×–×ž× ×•×ª ×‘× ×™×”',0),(95169,2644,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(95170,2644,'zh','å›žé¡¾ç”Ÿæˆè®¢å•\r\n',0),(95171,2644,'sv','Recension bygga order',0),(95172,2644,'it','Recensione compilazione ordini',0),(95173,2644,'tl','',0),(95174,2644,'th','&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(95175,2644,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤†à¤¦à¥‡à¤¶',0),(95176,2644,'ms','Kajian membina pesanan',0),(95177,2644,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(95178,2644,'fr','Examen Build Orders',0),(95179,2644,'jp','çµ„ç«‹æ³¨æ–‡ã?®è¦‹ç›´ã?—',0),(95180,2644,'pt','RevisÃ£o de ordens de construÃ§Ã£o',0),(95181,2644,'ru','ÐžÐ±Ð·Ð¾Ñ€ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(95182,2644,'es','Revisar Ordenes de ConstrucciÃ³n',0),(95183,2644,'de','Bewertung Build Orders',0),(95184,2644,'en','Review Build Orders',0),(95185,2645,'is','',0),(95186,2645,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(95187,2645,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(95188,2645,'tr','FiyatlarÄ± gÃ¶zden',0),(95189,2645,'pl','PrzeglÄ…d cen',0),(95190,2645,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ñ†ÐµÐ½Ð¸',0),(95191,2645,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(95192,2645,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ñ†ÐµÐ½Ðµ',0),(95193,2645,'vi','Xem xÃ©t giÃ¡',0),(95194,2645,'af','Hersien pryse',0),(95195,2645,'ro','PreÅ£urile de revizuire',0),(95196,2645,'et','Ãœlevaade hindadest',0),(95197,2645,'si','Pregled cen',0),(95198,2645,'ba','Meninjau harga',0),(95199,2645,'nl','Bekijk prijzen',0),(95200,2645,'fi','Arvostelu hinnat',0),(95201,2645,'no','Se priser',0),(95202,2645,'da','Anmeld priser',0),(95203,2645,'ko','ê°€ê²© ê²€í† ',0),(95204,2645,'he','×‘×—×Ÿ ×ž×—×™×¨×™×',0),(95205,2645,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Ï„Î¹Î¼ÏŽÎ½',0),(95206,2645,'zh','å¤å®¡ä»·æ ¼\r\n',0),(95207,2645,'sv','Granska priser',0),(95208,2645,'it','Revisione prezzi',0),(95209,2645,'tl','',0),(95210,2645,'th','&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3619;&#3634;&#3588;&#3634;',0),(95211,2645,'hi','à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(95212,2645,'ms','Mengkaji semula harga',0),(95213,2645,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(95214,2645,'fr','Prix de l\'examen',0),(95215,2645,'jp','å€¤æ®µã?®è¦‹ç›´ã?—',0),(95216,2645,'pt','RevisÃ£o de preÃ§os',0),(95217,2645,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ñ†ÐµÐ½',0),(95218,2645,'es','Revisar Precios',0),(95219,2645,'de','Bewertung Preise',0),(95220,2645,'en','Review Prices',0),(95221,2646,'is','',0),(95222,2646,'dr','(Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(95223,2646,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù†Ø±Ø® Ø¨Ù†Ø¯ÙŠ(Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(95224,2646,'tr','GÃ¶zden geÃ§irme derecelendirme baÅŸarÄ±yla eklendi',0),(95225,2646,'pl','PrzeglÄ…d Ocena dodano pomyÅ›lnie',0),(95226,2646,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(95227,2646,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(95228,2646,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(95229,2646,'vi','ThÃªm thang Ä‘Ã¡nh giÃ¡ thÃ nh cÃ´ng',0),(95230,2646,'af','Oorsig \"rating\" suksesvol bygevoeg',0),(95231,2646,'ro','Review Scor adÄƒugat cu succes',0),(95232,2646,'et','Review hinnang lisatud',0),(95233,2646,'si','Pregled ocena uspeÅ¡no dodani',0),(95234,2646,'ba','Meninjau peringkat berhasil ditambahkan',0),(95235,2646,'nl','Review beoordeling toegevoegd',0),(95236,2646,'fi','Review luokitus lisÃ¤Ã¤minen onnistui',0),(95237,2646,'no','VurderingsnivÃ¥ lagt',0),(95238,2646,'da','Anmeld rating tilfÃ¸jet',0),(95239,2646,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ê²€í†  ë“±ê¸‰',0),(95240,2646,'he','×¡×§×™×¨×” ×“×™×¨×•×’ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(95241,2646,'el','Î’Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(95242,2646,'zh','å¤å®¡è¯„çº§æ·»åŠ æˆåŠŸ\r\n',0),(95243,2646,'sv','Recension betyg lagts',0),(95244,2646,'it','Recensione punteggio aggiunto con successo',0),(95245,2646,'tl','',0),(95246,2646,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(95247,2646,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(95248,2646,'ms','Mengkaji penilaian yang berjaya menambah',0),(95249,2646,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶ ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(95250,2646,'fr','Avis note ajoutÃ©e avec succÃ¨s',0),(95251,2646,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼è©•ä¾¡ã‚’è¿½åŠ ã?—ã?¾ã?—ã?Ÿ',0),(95252,2646,'pt','ClassificaÃ§Ã£o de revisÃ£o adicionada com sucesso',0),(95253,2646,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(95254,2646,'es','Revisar evaluaciÃ³n agregada exitosamente',0),(95255,2646,'de','Digitalkamera Test erfolgreich hinzugefÃ¼gt',0),(95256,2646,'en','Review rating added successfully',0),(95257,2647,'is','',0),(95258,2647,'dr','(Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(95259,2647,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù†Ø±Ø® Ø¨Ù†Ø¯ÙŠ(Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(95260,2647,'tr','BaÅŸarÄ±yla silinen Puan gÃ¶zden geÃ§irin',0),(95261,2647,'pl','PrzeglÄ…d Ocena usuniÄ™te pomyÅ›lnie',0),(95262,2647,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(95263,2647,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ø´Ø¯Û Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(95264,2647,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¾Ñ†ÐµÐ½Ð¸ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(95265,2647,'vi','XoÃ¡ thang Ä‘Ã¡nh giÃ¡ thÃ nh cÃ´ng',0),(95266,2647,'af','Oorsig \"rating\" suksesvol geskrap',0),(95267,2647,'ro','Revizuirea rating ÅŸtearsÄƒ cu succes',0),(95268,2647,'et','Review hinnang kustutatud edukalt',0),(95269,2647,'si','Pregled ocena uspeÅ¡no izbrisana',0),(95270,2647,'ba','Meninjau peringkat berhasil dihapus',0),(95271,2647,'nl','Review beoordeling met succes verwijderd',0),(95272,2647,'fi','Arvostelu arvostelu poistettu onnistuneesti',0),(95273,2647,'no','Se gjennom vurdering slettede vellykket',0),(95274,2647,'da','Anmeld rating slettet med succes',0),(95275,2647,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ëœ í‰ê°€ ê²€í† ',0),(95276,2647,'he','×¡×§×™×¨×ª ×“×™×¨×•×’ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(95277,2647,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Î²Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(95278,2647,'zh','å¤å®¡è¯„çº§æˆåŠŸåˆ é™¤\r\n',0),(95279,2647,'sv','Granska betyg borttagna framgÃ¥ngsrikt',0),(95280,2647,'it','Rivedere la valutazione cancellati con successo',0),(95281,2647,'tl','',0),(95282,2647,'th','&#3621;&#3610;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(95283,2647,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(95284,2647,'ms','Mengkaji semula rating berjaya dipadam',0),(95285,2647,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶ ØªØµÙ†ÙŠÙ Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(95286,2647,'fr','Revoir la notation supprimÃ©e avec succÃ¨s',0),(95287,2647,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼è©•ä¾¡ã‚’æ¶ˆåŽ»ã?—ã?¾ã?—ã?Ÿ',0),(95288,2647,'pt','Rever a classificaÃ§Ã£o excluÃ­do com Ãªxito',0),(95289,2647,'ru','ÐžÐ±Ð·Ð¾Ñ€, Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(95290,2647,'es','Revisar evaluaciÃ³n eliminada exitosamente',0),(95291,2647,'de','Bewertung Bewertung erfolgreich gelÃ¶scht',0),(95292,2647,'en','Review rating deleted successfully',0),(95293,2648,'is','',0),(95294,2648,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯Ù‰ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(95295,2648,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯Ù‰ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(95296,2648,'tr','GÃ¶zden geÃ§irme derecelendirme baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(95297,2648,'pl','PrzeglÄ…d Ocena pomyÅ›lnie zaktualizowana',0),(95298,2648,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(95299,2648,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’',0),(95300,2648,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(95301,2648,'vi','Cáº­p Nháº­t Má»©c ÄÃ¡nh GiÃ¡ BÃ¬nh Duyá»‡t thÃ nh cÃ´ng',0),(95302,2648,'af','Oorsig \"rating\" suksesvol opdateer',0),(95303,2648,'ro','Rating de revizuire actualizat cu succes',0),(95304,2648,'et','Review Reiting vÃ¤rskendatud',0),(95305,2648,'si','Pregled ocena uspeÅ¡no posodobljena',0),(95306,2648,'ba','Review nilai diperbarui berhasil',0),(95307,2648,'nl','Review beoordeling bijgewerkt',0),(95308,2648,'fi','Review luokitus pÃ¤ivitetty',0),(95309,2648,'no','Gjennomgang rating oppdatert',0),(95310,2648,'da','Anmeldelse rating opdateret',0),(95311,2648,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ê²€í†  ë“±ê¸‰',0),(95312,2648,'he','×“×™×¨×•×’ ×¡×§×™×¨×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(95313,2648,'el','Î’Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(95314,2648,'zh','å¤å®¡è¯„çº§æˆåŠŸæ›´æ–°\r\n',0),(95315,2648,'sv','Recension betyg uppdaterats',0),(95316,2648,'it','Recensione punteggio aggiornato con successo',0),(95317,2648,'tl','',0),(95318,2648,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3592;&#3633;&#3604;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(95319,2648,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(95320,2648,'ms','Kajian penilaian berjaya dikemas kini',0),(95321,2648,'ar','ØªØµÙ†ÙŠÙ Ø§Ø³ØªØ¹Ø±Ø§Ø¶ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(95322,2648,'fr','Avis note correctement mis Ã  jour',0),(95323,2648,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼è©•ä¾¡ã‚’æ›´æ–°ã?—ã?¾ã?—ã?Ÿ',0),(95324,2648,'pt','ClassificaÃ§Ã£o de revisÃ£o atualizada com Ãªxito',0),(95325,2648,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(95326,2648,'es','Revisar evaluaciÃ³n agregada exitosamente',0),(95327,2648,'de','Digitalkamera-Test erfolgreich aktualisiert',0),(95328,2648,'en','Review rating updated successfully',0),(95329,2649,'is','',0),(95330,2649,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø§ØµÙ„Ø§Ø­',0),(95331,2649,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø§ØµÙ„Ø§Ø­',0),(95332,2649,'tr','DÃ¼zeltme geÃ§miÅŸi',0),(95333,2649,'pl','â€“ Historia wersji',0),(95334,2649,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð²ÐµÑ€ÑÐ¸Ð¸Ñ‚Ðµ',0),(95335,2649,'ur','Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(95336,2649,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ð°',0),(95337,2649,'vi','Lá»‹ch sá»­ Chá»‰nh sá»­a',0),(95338,2649,'af','Hersieningsgeskiedenis',0),(95339,2649,'ro','Revizia istoricului',0),(95340,2649,'et','LÃ¤bivaatuse ajalugu',0),(95341,2649,'si','Zgodovina revizij',0),(95342,2649,'ba','Riwayat revisi',0),(95343,2649,'nl','Revisiegeschiedenis',0),(95344,2649,'fi','Muutoshistoriaa',0),(95345,2649,'no','Revisjonen historie',0),(95346,2649,'da','Revisionsoversigten',0),(95347,2649,'ko','ê°œì • ì—­ì‚¬',0),(95348,2649,'he','×”×™×¡×˜×•×¨×™×™×ª',0),(95349,2649,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î±Î»Î»Î±Î³ÏŽÎ½',0),(95350,2649,'zh','ä¿®è®¢åŽ†å²\r\n',0),(95351,2649,'sv','Versionshistorik',0),(95352,2649,'it','Cronologia delle revisioni',0),(95353,2649,'tl','',0),(95354,2649,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(95355,2649,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(95356,2649,'ms','Sejarah semakan',0),(95357,2649,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(95358,2649,'fr','Historique des rÃ©visions',0),(95359,2649,'jp','ä¿®æ­£å±¥æ­´',0),(95360,2649,'pt','HistÃ³rico de revisÃ£o',0),(95361,2649,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(95362,2649,'es','Historia de Revisiones',0),(95363,2649,'de','Revision History',0),(95364,2649,'en','Revision History',0),(95365,2650,'is','',0),(95366,2650,'dr','Ø­Ù‚ÙˆÙ‚',0),(95367,2650,'pr','Ø­Ù‚ÙˆÙ‚',0),(95368,2650,'tr','haklarÄ±',0),(95369,2650,'pl','prawa',0),(95370,2650,'bg','Ð¿Ñ€Ð°Ð²Ð°',0),(95371,2650,'ur','Ø­Ù‚ÙˆÙ‚',0),(95372,2650,'sr','Ð¿Ñ€Ð°Ð²Ð°',0),(95373,2650,'vi','quyá»n ',0),(95374,2650,'af','regte',0),(95375,2650,'ro','drepturile',0),(95376,2650,'et','Ãµigused',0),(95377,2650,'si','pravice',0),(95378,2650,'ba','hak',0),(95379,2650,'nl','rechten',0),(95380,2650,'fi','oikeudet',0),(95381,2650,'no','rettigheter',0),(95382,2650,'da','rettigheder',0),(95383,2650,'ko','ê¶Œë¦¬',0),(95384,2650,'he','×–×›×•×™×•×ª',0),(95385,2650,'el','Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î±',0),(95386,2650,'zh','æƒåˆ©\r\n',0),(95387,2650,'sv','rÃ¤ttigheter',0),(95388,2650,'it','diritti',0),(95389,2650,'tl','',0),(95390,2650,'th','&#3626;&#3636;&#3607;&#3608;&#3636;&#3660;',0),(95391,2650,'hi','à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(95392,2650,'ms','hak-hak',0),(95393,2650,'ar','Ø­Ù‚ÙˆÙ‚',0),(95394,2650,'fr','droits',0),(95395,2650,'jp','æ¨©åˆ©',0),(95396,2650,'pt','direitos',0),(95397,2650,'ru','Ð¿Ñ€Ð°Ð²Ð°',0),(95398,2650,'es','derechos',0),(95399,2650,'de','Rechte',0),(95400,2650,'en','rights',0),(95401,2651,'is','',0),(95402,2651,'dr',' Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ â€“ Ø®Ø±ÙŠØ¯',0),(95403,2651,'pr',' Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ â€“ Ø®Ø±ÙŠØ¯',0),(95404,2651,'tr','RMA - satÄ±n alma',0),(95405,2651,'pl','RMA - zakup',0),(95406,2651,'bg','Ð Ð¡Ðž - Ð·Ð°ÐºÑƒÐ¿ÑƒÐ²Ð°Ð½Ðµ',0),(95407,2651,'ur','Ø±Ù… - Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(95408,2651,'sr','ÐžÐ¿Ñ - Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ',0),(95409,2651,'vi','RMA - Mua',0),(95410,2651,'af','RMA - aankoop',0),(95411,2651,'ro','RMA - cumpÄƒrare',0),(95412,2651,'et','RMA - ostmine',0),(95413,2651,'si','RMA - nakup',0),(95414,2651,'ba','RMA - pembelian',0),(95415,2651,'nl','RMA - aankoop',0),(95416,2651,'fi','RMA - osto',0),(95417,2651,'no','RMA - innkjÃ¸p',0),(95418,2651,'da','RMA - indkÃ¸b',0),(95419,2651,'ko','ë°˜í’ˆ-êµ¬ë§¤',0),(95420,2651,'he','RMA - ×¨×›×™×©×ª',0),(95421,2651,'el','RMA - Î±Î³Î¿ÏÎ¬',0),(95422,2651,'zh','è¿”å›žå•†å“æŽˆæƒ- é‡‡è´­\r\n',0),(95423,2651,'sv','RMA - inkÃ¶p',0),(95424,2651,'it','RMA - acquisto',0),(95425,2651,'tl','',0),(95426,2651,'th','&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629; - RMA ',0),(95427,2651,'hi','RMA - à¤•à¥à¤°à¤¯',0),(95428,2651,'ms','RMA - pembelian',0),(95429,2651,'ar','Ø§Ù„Ø¬ÙŠØ´ Ø§Ù„Ù…Ù„ÙƒÙŠ Ø§Ù„Ù…ØºØ±Ø¨ÙŠ-Ø´Ø±Ø§Ø¡',0),(95430,2651,'fr','RMA - achat',0),(95431,2651,'jp','RMAï¼?è³¼å…¥',0),(95432,2651,'pt','RMA - compra',0),(95433,2651,'ru','RMA - ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ°',0),(95434,2651,'es','RMA - Compras',0),(95435,2651,'de','RMA - Einkauf',0),(95436,2651,'en','RMA - Purchasing',0),(95437,2652,'is','',0),(95438,2652,'dr','Roll Ø·Ø§Ù‚Ù‡ (ÙÙ‡Ø±Ø³Øª-Ø«Ø¨Øª ',0),(95439,2652,'pr','Roll Ø·Ø§Ù‚Ù‡ (ÙÙ‡Ø±Ø³Øª-Ø«Ø¨Øª ',0),(95440,2652,'tr','Rulo',0),(95441,2652,'pl','Rolki',0),(95442,2652,'bg','Ð Ð¾Ð»ÐºÐ°',0),(95443,2652,'ur','Ø±ÙˆÙ„',0),(95444,2652,'sr','Ð Ð¾Ð»',0),(95445,2652,'vi','Cuá»™n trÃ²n',0),(95446,2652,'af','Rol',0),(95447,2652,'ro','Rola',0),(95448,2652,'et','Rulli',0),(95449,2652,'si','Roll',0),(95450,2652,'ba','Roll',0),(95451,2652,'nl','Roll',0),(95452,2652,'fi','Roll',0),(95453,2652,'no','Roll',0),(95454,2652,'da','Roll',0),(95455,2652,'ko','ë¡¤',0),(95456,2652,'he','×¨×•×œ',0),(95457,2652,'el','Î¡Î¿Î»ÏŒ',0),(95458,2652,'zh','è¡¨\r\n',0),(95459,2652,'sv','Rulle',0),(95460,2652,'it','Rotolo',0),(95461,2652,'tl','',0),(95462,2652,'th','&#3627;&#3617;&#3640;&#3609;',0),(95463,2652,'hi','à¤°à¥‹à¤²',0),(95464,2652,'ms','Roll',0),(95465,2652,'ar','Ù„ÙØ©',0),(95466,2652,'fr','Rouleau',0),(95467,2652,'jp','ãƒ­ãƒ¼ãƒ«',0),(95468,2652,'pt','Rolo',0),(95469,2652,'ru','Ð Ð¾Ð»Ð»',0),(95470,2652,'es','Rollo',0),(95471,2652,'de','Roll',0),(95472,2652,'en','Roll',0),(95473,2653,'is','',0),(95474,2653,'dr','/ ÙˆØ±Ù‚/  ....Ea',0),(95475,2653,'pr','Ø·Ø§Ù‚Ù‡ / ÙˆØ±Ù‚/  ....Ea',0),(95476,2653,'tr','Levha-roll-Ea',0),(95477,2653,'pl','Rolki/Sheet/Ea',0),(95478,2653,'bg','Ð Ð¾Ð»ÐºÐ°/Ð»Ð¸ÑÑ‚/Ea',0),(95479,2653,'ur','Ø±ÙˆÙ„/ÙˆØ±Ù‚/Ea',0),(95480,2653,'sr','Ð Ð¾Ð»/Ð»Ð¸ÑÑ‚/Ð•Ð°',0),(95481,2653,'vi','Cuá»™ng trÃ²n/Táº¥m/Má»—i',0),(95482,2653,'af','Rol/laken/Ea',0),(95483,2653,'ro','Rola/foaie/Ea',0),(95484,2653,'et','Rull/leht/Ea',0),(95485,2653,'si','List/roll/Ea',0),(95486,2653,'ba','Roll/Sheet/Ea',0),(95487,2653,'nl','Roll/blad/Ea',0),(95488,2653,'fi','Rulla/arkki/Ea',0),(95489,2653,'no','Roll/ark/Ea',0),(95490,2653,'da','Roll/ark/Ea',0),(95491,2653,'ko','ë¡¤/ì‹œíŠ¸/Ea',0),(95492,2653,'he','×¨×•×œ/×’×™×œ×™×•×Ÿ/Ea',0),(95493,2653,'el','Î–Î±ÏÎ¹Î¬/Ï†ÏÎ»Î»Î¿/Ea',0),(95494,2653,'zh','è¡¨/å•/ æ¯\r\n',0),(95495,2653,'sv','Rulle/blad/Ea',0),(95496,2653,'it','Rotolo/foglio/Ea',0),(95497,2653,'tl','',0),(95498,2653,'th','Roll/Sheet/Ea',0),(95499,2653,'hi','à¤°à¥‹à¤²/à¤ªà¤¤à¥à¤°à¤•/Ea',0),(95500,2653,'ms','Roll/lembaran/Ea',0),(95501,2653,'ar','Ù„ÙØ©/ÙˆØ±Ù‚Ø©/Ø¹ØµØ§Ù…',0),(95502,2653,'fr','Feuille/rouleau/Ea',0),(95503,2653,'jp','ãƒ­ãƒ¼ãƒ«/ã‚·ãƒ¼ãƒˆ/Ea',0),(95504,2653,'pt','Rolo/folha/AE',0),(95505,2653,'ru','Ð ÑƒÐ»Ð¾Ð½/Ð»Ð¸ÑÑ‚/Ea',0),(95506,2653,'es','Rollo/Hoja/Cada Uno',0),(95507,2653,'de','Roll/Blatt/Ea',0),(95508,2653,'en','Roll/Sheet/Ea',0),(95509,2654,'is','',0),(95510,2654,'dr','Root Ø±ÙŠØ´Ù‡ ',0),(95511,2654,'pr','Root Ø±ÙŠØ´Ù‡ ',0),(95512,2654,'tr','KÃ¶k',0),(95513,2654,'pl','KorzeÅ„',0),(95514,2654,'bg','ÐšÐ¾Ñ€ÐµÐ½',0),(95515,2654,'ur','Ø§Ø³Ø§Ø³',0),(95516,2654,'sr','ÐšÐ¾Ñ€ÐµÐ½',0),(95517,2654,'vi','Rá»…',0),(95518,2654,'af','Wortel',0),(95519,2654,'ro','RÄƒdÄƒcinÄƒ',0),(95520,2654,'et','Juur',0),(95521,2654,'si','Koren',0),(95522,2654,'ba','Akar',0),(95523,2654,'nl','Root',0),(95524,2654,'fi','Root',0),(95525,2654,'no','Rot',0),(95526,2654,'da','Roden',0),(95527,2654,'ko','ë£¨íŠ¸',0),(95528,2654,'he','×©×•×¨×©',0),(95529,2654,'el','Î¡Î¯Î¶Î±',0),(95530,2654,'zh','æ ¹\r\n',0),(95531,2654,'sv','Rot',0),(95532,2654,'it','Radice',0),(95533,2654,'tl','',0),(95534,2654,'th','&#3619;&#3634;&#3585;',0),(95535,2654,'hi','à¤°à¥‚à¤Ÿ',0),(95536,2654,'ms','Akar',0),(95537,2654,'ar','Ø§Ù„Ø¬Ø°Ø±',0),(95538,2654,'fr','Racine',0),(95539,2654,'jp','åŸºç¤Ž',0),(95540,2654,'pt','Raiz',0),(95541,2654,'ru','ÐšÐ¾Ñ€ÐµÐ½ÑŒ',0),(95542,2654,'es','RaÃ­z',0),(95543,2654,'de','Root',0),(95544,2654,'en','Root',0),(95545,2655,'is','',0),(95546,2655,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¯ÙŠÚ¯Ø±ÙŠ Ø±Ø§ Ø§Ø¬Ø±Ø§ ÙƒÙ†ÙŠØ¯ ',0),(95547,2655,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¯ÙŠÚ¯Ø±ÙŠ Ø±Ø§ Ø§Ø¬Ø±Ø§ ÙƒÙ†ÙŠØ¯ ',0),(95548,2655,'tr','BaÅŸka bir raporu Ã§alÄ±ÅŸtÄ±rma',0),(95549,2655,'pl','UruchomiÄ‡ kolejny raport',0),(95550,2655,'bg','Ð¢Ð¸Ñ‡Ð°Ð¼ Ð´Ñ€ÑƒÐ³ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(95551,2655,'ur','Ú©ÙˆØ¦ÛŒ Ø§ÙˆØ± Ø±Ù¾ÙˆØ±Ù¹ Ú†Ù„Ø§Ø¦ÙŠÚº',0),(95552,2655,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸ Ð´Ñ€ÑƒÐ³Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(95553,2655,'vi','Cháº¡y bÃ¡o cÃ¡o khÃ¡c',0),(95554,2655,'af','Loop \'n Ander Verslag',0),(95555,2655,'ro','Rula un alt raport',0),(95556,2655,'et','Teise aruande kÃ¤itamine',0),(95557,2655,'si','ZaÅ¾enite drugo poroÄilo',0),(95558,2655,'ba','Menjalankan laporan lain',0),(95559,2655,'nl','Een ander rapport uitvoeren',0),(95560,2655,'fi','Toinen raportti',0),(95561,2655,'no','KjÃ¸re en rapport',0),(95562,2655,'da','KÃ¸r en anden rapport',0),(95563,2655,'ko','ë‹¤ë¥¸ ë³´ê³ ì„œ ì‹¤í–‰',0),(95564,2655,'he','×”×¤×¢×œ ×“×•×— ××—×¨',0),(95565,2655,'el','Î•ÎºÏ„ÎµÎ»Î­ÏƒÏ„Îµ Î¼Î¹Î± Î¬Î»Î»Î· Î±Î½Î±Ï†Î¿ÏÎ¬',0),(95566,2655,'zh','è¿è¡Œå¦ä¸€ä¸ªæŠ¥å‘Š\r\n',0),(95567,2655,'sv','KÃ¶r en annan rapport',0),(95568,2655,'it','Eseguire un altro rapporto',0),(95569,2655,'tl','',0),(95570,2655,'th','&#3605;&#3656;&#3629;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3652;&#3611;&#3607;&#3637;&#3656;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(95571,2655,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤šà¤²à¤¾à¤à¤',0),(95572,2655,'ms','Jalankan laporan lain',0),(95573,2655,'ar','ØªØ´ØºÙŠÙ„ ØªÙ‚Ø±ÙŠØ± Ø¢Ø®Ø±',0),(95574,2655,'fr','ExÃ©cutez un autre rapport',0),(95575,2655,'jp','ä»–ã?®ãƒ¬ãƒ?ãƒ¼ãƒˆã‚’å®Ÿè¡Œã?™ã‚‹',0),(95576,2655,'pt','Executar outro relatÃ³rio',0),(95577,2655,'ru','Ð•Ñ‰Ðµ Ð¾Ð´Ð¸Ð½ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(95578,2655,'es','Correr Otro Informe',0),(95579,2655,'de','Ein weiterer Bericht ausfÃ¼hren',0),(95580,2655,'en','Run Another Report',0),(95581,2656,'is','',0),(95582,2656,'dr','ØªØ§Ø±ÙŠØ® Ø§Ø¬Ø±Ø§',0),(95583,2656,'pr','ØªØ§Ø±ÙŠØ® Ø§Ø¬Ø±Ø§',0),(95584,2656,'tr','Ã‡alÄ±ÅŸtÄ±rma tarihi',0),(95585,2656,'pl','Data uruchomienia',0),(95586,2656,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(95587,2656,'ur','ØªØ§Ø±ÛŒØ® Ú†Ù„Ø§Ø¦ÙŠÚº',0),(95588,2656,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(95589,2656,'vi','Cháº¡y ngÃ y',0),(95590,2656,'af','Loop datum',0),(95591,2656,'ro','Rula data',0),(95592,2656,'et','KÃ¤itamise kuupÃ¤ev',0),(95593,2656,'si','Datuma zagona',0),(95594,2656,'ba','Menjalankan tanggal',0),(95595,2656,'nl','Uitvoeren van datum',0),(95596,2656,'fi','Suorituksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(95597,2656,'no','KjÃ¸re dato',0),(95598,2656,'da','KÃ¸re dato',0),(95599,2656,'ko','ì‹¤í–‰ ë‚ ì§œ',0),(95600,2656,'he','×ª××¨×™×š ×”×¤×¢×œ×ª',0),(95601,2656,'el','Î•ÎºÏ„ÎµÎ»Î­ÏƒÏ„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(95602,2656,'zh','è¿è¡Œæ—¥æœŸ\r\n',0),(95603,2656,'sv','KÃ¶rningsdatum',0),(95604,2656,'it','Data di esecuzione',0),(95605,2656,'tl','',0),(95606,2656,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3605;&#3656;&#3629;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;',0),(95607,2656,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤šà¤²à¤¾à¤à¤',0),(95608,2656,'ms','Jalankan tarikh',0),(95609,2656,'ar','ØªØ´ØºÙŠÙ„ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(95610,2656,'fr','ExÃ©cutez Date',0),(95611,2656,'jp','èµ·å‹•æ—¥ä»˜',0),(95612,2656,'pt','Executar data',0),(95613,2656,'ru','Ð”Ð°Ñ‚Ð° Ð·Ð°Ð¿ÑƒÑÐºÐ°',0),(95614,2656,'es','Correr Fecha',0),(95615,2656,'de','FÃ¼hren Sie Datum',0),(95616,2656,'en','Run Date',0),(95617,2657,'is','',0),(95618,2657,'dr','Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø§Ø¯Ù† ',0),(95619,2657,'pr','Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø§Ø¯Ù† ',0),(95620,2657,'tr','Ãœzerinde Ã§alÄ±ÅŸan',0),(95621,2657,'pl','UruchomiÄ‡',0),(95622,2657,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(95623,2657,'ur','Ú†Ù„Øª Ú©Ø±ÛŒÚº Ø¨Ø±',0),(95624,2657,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚Ð°ÑšÐµ Ð½Ð°',0),(95625,2657,'vi','Cháº¡y vÃ o',0),(95626,2657,'af','Loop',0),(95627,2657,'ro','Rula pe',0),(95628,2657,'et','KÃ¤ivita',0),(95629,2657,'si','TeÄi',0),(95630,2657,'ba','Berjalan di',0),(95631,2657,'nl','Uitgevoerd op',0),(95632,2657,'fi','Ajaa',0),(95633,2657,'no','KjÃ¸r pÃ¥',0),(95634,2657,'da','KÃ¸re',0),(95635,2657,'ko','ì‹¤í–‰',0),(95636,2657,'he','×œ×¨×•×¥ ×¢×œ',0),(95637,2657,'el','Î¤ÏÎ­Ï‡ÎµÎ¹ ÏƒÎµ',0),(95638,2657,'zh','ç»§ç»­\r\n',0),(95639,2657,'sv','KÃ¶r pÃ¥',0),(95640,2657,'it','Eseguire',0),(95641,2657,'tl','',0),(95642,2657,'th','&#3605;&#3656;&#3629;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3652;&#3611;',0),(95643,2657,'hi','à¤šà¤²à¤¾à¤à¤',0),(95644,2657,'ms','Dijalankan pada',0),(95645,2657,'ar','ØªØ´ØºÙŠÙ„ Ø¹Ù„Ù‰',0),(95646,2657,'fr','ExÃ©cuter sur',0),(95647,2657,'jp','ç¶™ç¶š',0),(95648,2657,'pt','Executado em',0),(95649,2657,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð°Ñ‚ÑŒ Ð½Ð°',0),(95650,2657,'es','Correr En',0),(95651,2657,'de','FÃ¼hren Sie auf',0),(95652,2657,'en','Run on',0),(95653,2658,'is','',0),(95654,2658,'dr','Ø³Ø±Ø¹Øª Ø§Ø¬Ø±Ø§ ',0),(95655,2658,'pr','Ø³Ø±Ø¹Øª Ø§Ø¬Ø±Ø§ ',0),(95656,2658,'tr','HÄ±zÄ± Ã§alÄ±ÅŸtÄ±rÄ±n',0),(95657,2658,'pl','Kurs prowadzony',0),(95658,2658,'bg','Ð¢Ð¸Ñ‡Ð°Ð¼ ÑÐºÐ¾Ñ€Ð¾ÑÑ‚',0),(95659,2658,'ur','Ø´Ø±Ø­ Ú†Ù„Øª Ú©Ø±ÛŒÚº',0),(95660,2658,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸ ÑÑ‚Ð¾Ð¿Ð°',0),(95661,2658,'vi','Cháº¡y giÃ¡',0),(95662,2658,'af','Loopkoste Tarief',0),(95663,2658,'ro','Alerga rata',0),(95664,2658,'et','KÃ¤ivitage mÃ¤Ã¤r',0),(95665,2658,'si','TeÄi stopnja',0),(95666,2658,'ba','Menjalankan tingkat',0),(95667,2658,'nl','Run Rate',0),(95668,2658,'fi','Vuositasolla',0),(95669,2658,'no','Run Rate',0),(95670,2658,'da','KÃ¸re sats',0),(95671,2658,'ko','ì†ë„ ì‹¤í–‰',0),(95672,2658,'he','×”×¤×¢×œ×ª ×§×¦×‘',0),(95673,2658,'el','Î•ÎºÏ„ÎµÎ»Î­ÏƒÏ„Îµ Ï„Î¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(95674,2658,'zh','è¿è¡ŒçŽ‡\r\n',0),(95675,2658,'sv','GenomsnittskontovÃ¤rde',0),(95676,2658,'it','Eseguire tasso',0),(95677,2658,'tl','',0),(95678,2658,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3605;&#3656;&#3629;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;',0),(95679,2658,'hi','à¤°à¤¨ à¤°à¥‡à¤Ÿ',0),(95680,2658,'ms','Jalankan kadar',0),(95681,2658,'ar','ØªØ´ØºÙŠÙ„ Ù…Ø¹Ø¯Ù„',0),(95682,2658,'fr','ExÃ©cuter des taux',0),(95683,2658,'jp','å®Ÿæ–½æ–™é‡‘',0),(95684,2658,'pt','Executar a taxa',0),(95685,2658,'ru','Ð—Ð°Ð¿ÑƒÑÐº ÐºÑƒÑ€ÑÐ°',0),(95686,2658,'es','Velocidad de Corrida',0),(95687,2658,'de','FÃ¼hren Sie Rate',0),(95688,2658,'en','Run Rate',0),(95689,2659,'is','',0),(95690,2659,'dr','Ø³Ø±Ø¹Øª Ø§Ø¬Ø±Ø§ Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(95691,2659,'pr','Ø³Ø±Ø¹Øª Ø§Ø¬Ø±Ø§ Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(95692,2659,'tr','Uygulanan Ã§alÄ±ÅŸma hÄ±zÄ±',0),(95693,2659,'pl','Kurs stosowany do prowadzony',0),(95694,2659,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½Ð¸ ÑÑ‚Ð°Ð²ÐºÐ°, Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°Ð½Ð° Ð·Ð°',0),(95695,2659,'ur','Ø¬Ø³ Ú©Ø§ Ø§Ø·Ù„Ø§Ù‚ Ø´Ø±Ø­ Ú†Ù„Øª Ú©Ø±ÛŒÚº',0),(95696,2659,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸ ÑÑ‚Ð¾Ð¿Ð° Ð¿Ñ€Ð¸Ð¼ÐµÑšÑƒÑ˜Ðµ',0),(95697,2659,'vi','Cháº¡y giÃ¡ Ã¡p dá»¥ng tá»›i',0),(95698,2659,'af','Loopkoste tarief toegepas aan',0),(95699,2659,'ro','AplicatÄƒ pentru a alerga',0),(95700,2659,'et','KÃ¤ituse alusel, mida kohaldati',0),(95701,2659,'si','TeÄi stopnji za',0),(95702,2659,'ba','Angka dijalankan yang diterapkan',0),(95703,2659,'nl','Tarief voor uitvoeren',0),(95704,2659,'fi','Suorita korko',0),(95705,2659,'no','KjÃ¸re hastigheten pÃ¥',0),(95706,2659,'da','KÃ¸re sats for',0),(95707,2659,'ko','ì‹¤í–‰ëœ ì†ë„ì— ì ìš©',0),(95708,2659,'he','×¨×™×¦×” ×§×¦×‘ ×©×”×•×—×œ',0),(95709,2659,'el','Î•ÎºÏ„ÎµÎ»Î­ÏƒÏ„Îµ Ï„Î¿ ÎµÏ€Î¹Ï„ÏŒÎºÎ¹Î¿ Ï€Î¿Ï… ÎµÏ†Î±ÏÎ¼ÏŒÎ¶ÎµÏ„Î±Î¹ Î³Î¹Î± Î½Î±',0),(95710,2659,'zh','è¿è¡Œæ¯”çŽ‡é€‚ç”¨äºŽ\r\n',0),(95711,2659,'sv','KÃ¶r som tillÃ¤mpats',0),(95712,2659,'it','Eseguire il tasso applicato al',0),(95713,2659,'tl','',0),(95714,2659,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3605;&#3656;&#3629;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3611;&#3619;&#3632;&#3618;&#3640;&#3585;&#3605;&#3660;&#3651;&#3594;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(95715,2659,'hi','à¤°à¤¨ à¤°à¥‡à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤µà¥‡à¤¦à¤¨ à¤•à¤¿à¤¯à¤¾',0),(95716,2659,'ms','Kadar yang digunakan untuk menjalankan',0),(95717,2659,'ar','ØªØ´ØºÙŠÙ„ ØªØ·Ø¨ÙŠÙ‚ Ø¨Ø³Ø¹Ø±',0),(95718,2659,'fr','ExÃ©cutez le taux appliquÃ© aux',0),(95719,2659,'jp','ï½žã?«é?©ç”¨ã?™ã‚‹å®Ÿæ–½æ–™é‡‘',0),(95720,2659,'pt','Taxa aplicada a',0),(95721,2659,'ru','Ð—Ð°Ð¿ÑƒÑÐº ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÑÐµÑ‚ÑÑ Ðº',0),(95722,2659,'es','Velocidad de corrida aplicado a',0),(95723,2659,'de','Laufrate auf angewendet',0),(95724,2659,'en','Run rate applied to',0),(95725,2660,'is','',0),(95726,2660,'dr','Ø²Ù…Ø§Ù† Ø§Ø¬Ø±Ø§ Ú†Ú¯ÙˆÙ†Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯',0),(95727,2660,'pr','Ø²Ù…Ø§Ù† Ø§Ø¬Ø±Ø§ Ú†Ú¯ÙˆÙ†Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯',0),(95728,2660,'tr','Ã‡alÄ±ÅŸma zamanÄ±nda nasÄ±l hesaplanÄ±r',0),(95729,2660,'pl','Jak obliczyÄ‡ czas',0),(95730,2660,'bg','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð° ÐºÐ°Ðº',0),(95731,2660,'ur','Ú©Ø³ Ø·Ø±Ø­ Ø­Ø³Ø§Ø¨ ÙˆÙ‚Øª Ú†Ù„Ø§Ø¦ÛŒÚº',0),(95732,2660,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð° ÐºÐ¾Ð»Ð¸ÐºÐ¾ Ñ˜Ðµ Ð²Ñ€ÐµÐ¼Ðµ Ð¸Ð·Ð²Ð¾Ñ’ÐµÑšÐ°',0),(95733,2660,'vi','Cháº¡y thá»i gian tÃ­nh nhÆ° tháº¿ nÃ o',0),(95734,2660,'af','Hoe is Loop Tyd Bereken',0),(95735,2660,'ro','Timp calculat cum a alerga',0),(95736,2660,'et','Kuidas arvutada KÃ¤itusaeg',0),(95737,2660,'si','Kako izraÄunati Äas izdelave',0),(95738,2660,'ba','Menjalankan waktu dihitung berapa',0),(95739,2660,'nl','Bewerkingstijd berekend hoe',0),(95740,2660,'fi','Ajoaika lasketaan kuinka',0),(95741,2660,'no','KjÃ¸retid beregnet hvor',0),(95742,2660,'da','Operationstiden beregnes hvordan',0),(95743,2660,'ko','ì‹¤í–‰ ì‹œê°„ ê³„ì‚° ë°©ë²•',0),(95744,2660,'he','××™×š ×ž×—×•×©×‘ ×‘×–×ž×Ÿ ×¨×™×¦×”',0),(95745,2660,'el','Run Ï‡ÏÏŒÎ½Î¿Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÏ„Î±Î¹ Ï€ÏŽÏ‚',0),(95746,2660,'zh','å¦‚ä½•è¿è¡Œæ—¶é—´è®¡ç®—\r\n',0),(95747,2660,'sv','Bearbetningstid berÃ¤knas hur',0),(95748,2660,'it','Fase di esecuzione, calcolato come',0),(95749,2660,'tl','',0),(95750,2660,'th','&#3648;&#3623;&#3621;&#3634;&#3605;&#3656;&#3629;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3588;&#3635;&#3609;&#3623;&#3603;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3619;',0),(95751,2660,'hi','à¤•à¥ˆà¤¸à¥‡ à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤¸à¤®à¤¯ à¤šà¤²à¤¾à¤à¤',0),(95752,2660,'ms','Jalankan masa dikira bagaimana',0),(95753,2660,'ar','ÙƒÙŠÙÙŠØ© Ø­Ø³Ø§Ø¨ ÙˆÙ‚Øª Ø§Ù„ØªØ´ØºÙŠÙ„',0),(95754,2660,'fr','CalculÃ© combien de temps d\'exÃ©cution',0),(95755,2660,'jp','å®Ÿæ–½æ™‚é–“è¨ˆç®—æ³•',0),(95756,2660,'pt','Executar tempo calculado como',0),(95757,2660,'ru','ÐšÐ°Ðº Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(95758,2660,'es','Tiempo de Corrida Calculado CÃ³mo',0),(95759,2660,'de','Laufzeit berechnet wie',0),(95760,2660,'en','Run Time Calculated How',0),(95761,2661,'is','',0),(95762,2661,'dr','Rush Ø³Ø±Ø¹Øª ',0),(95763,2661,'pr','Rush Ø³Ø±Ø¹Øª ',0),(95764,2661,'tr','Rush',0),(95765,2661,'pl','Rush',0),(95766,2661,'bg','Ð ÑŠÑˆ',0),(95767,2661,'ur','Ø±Ø´',0),(95768,2661,'sr','Ð ÑƒÑÑ…',0),(95769,2661,'vi','Vá»™i',0),(95770,2661,'af','Stormloop',0),(95771,2661,'ro','Rush',0),(95772,2661,'et','Rush',0),(95773,2661,'si','Rush',0),(95774,2661,'ba','Rush',0),(95775,2661,'nl','Rush',0),(95776,2661,'fi','Rush',0),(95777,2661,'no','Rush',0),(95778,2661,'da','Rush',0),(95779,2661,'ko','ëŸ¬ì‰¬',0),(95780,2661,'he','×”×¢×•×ž×¡',0),(95781,2661,'el','Î’Î¹Î±ÏƒÏÎ½Î·',0),(95782,2661,'zh','èµ¶\r\n',0),(95783,2661,'sv','Rush',0),(95784,2661,'it','Rush',0),(95785,2661,'tl','',0),(95786,2661,'th','&#3585;&#3634;&#3619;&#3648;&#3619;&#3656;&#3591;&#3619;&#3637;&#3610;',0),(95787,2661,'hi','à¤°à¤¶',0),(95788,2661,'ms','Tergesa-gesa',0),(95789,2661,'ar','Ø±Ø§Ø´',0),(95790,2661,'fr','Rush',0),(95791,2661,'jp','æ€¥ã?Ž',0),(95792,2661,'pt','Rush',0),(95793,2661,'ru','Ð Ð°Ñˆ',0),(95794,2661,'es','RÃ¡pida',0),(95795,2661,'de','Rush',0),(95796,2661,'en','Rush',0),(95797,2662,'is','',0),(95798,2662,'dr','Ø­Ù‚ÙˆÙ‚',0),(95799,2662,'pr','Ø­Ù‚ÙˆÙ‚',0),(95800,2662,'tr','Sal',0),(95801,2662,'pl','Sal',0),(95802,2662,'bg','Ð¡Ð°Ð»',0),(95803,2662,'ur','Ù¾Ú‘Ú¾Ùˆ',0),(95804,2662,'sr','Ð¡Ð°Ð»',0),(95805,2662,'vi','LÆ°Æ¡ng',0),(95806,2662,'af','Sal',0),(95807,2662,'ro','Sal',0),(95808,2662,'et','SAL',0),(95809,2662,'si','Sal',0),(95810,2662,'ba','Sal',0),(95811,2662,'nl','Sal',0),(95812,2662,'fi','Sal',0),(95813,2662,'no','Sal',0),(95814,2662,'da','Sal',0),(95815,2662,'ko','ìƒ',0),(95816,2662,'he','×¡××œ',0),(95817,2662,'el','Sal',0),(95818,2662,'zh','å·¥èµ„\r\n',0),(95819,2662,'sv','Sal',0),(95820,2662,'it','Sal',0),(95821,2662,'tl','',0),(95822,2662,'th','&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(95823,2662,'hi','à¤¸à¤¾à¤²',0),(95824,2662,'ms','Sal',0),(95825,2662,'ar','Ø³Ø£Ù„',0),(95826,2662,'fr','SAL',0),(95827,2662,'jp','Sal',0),(95828,2662,'pt','Sal',0),(95829,2662,'ru','Ð¡Ð°Ð»',0),(95830,2662,'es','Salario',0),(95831,2662,'de','SAL',0),(95832,2662,'en','Sal',0),(95833,2663,'is','',0),(95834,2663,'dr','Ø­Ù‚ÙˆÙ‚',0),(95835,2663,'pr','Ø­Ù‚ÙˆÙ‚',0),(95836,2663,'tr','MaaÅŸ',0),(95837,2663,'pl','Wynagrodzenia',0),(95838,2663,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð°',0),(95839,2663,'ur','ØªÙ†Ø®ÙˆØ§Û',0),(95840,2663,'sr','ÐŸÐ»Ð°Ñ‚Ð°',0),(95841,2663,'vi','LÆ°Æ¡ng',0),(95842,2663,'af','Salaris',0),(95843,2663,'ro','Salariu',0),(95844,2663,'et','Palk',0),(95845,2663,'si','PlaÄe',0),(95846,2663,'ba','Gaji',0),(95847,2663,'nl','Salaris',0),(95848,2663,'fi','Palkka',0),(95849,2663,'no','LÃ¸nn',0),(95850,2663,'da','LÃ¸n',0),(95851,2663,'ko','ì—°ë´‰',0),(95852,2663,'he','×ž×©×›×•×¨×ª',0),(95853,2663,'el','ÎœÎ¹ÏƒÎ¸ÏŒÏ‚',0),(95854,2663,'zh','è–ªé…¬\r\n',0),(95855,2663,'sv','LÃ¶n',0),(95856,2663,'it','Stipendio',0),(95857,2663,'tl','',0),(95858,2663,'th','&#3619;&#3634;&#3618;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(95859,2663,'hi','à¤µà¥‡à¤¤à¤¨',0),(95860,2663,'ms','Gaji',0),(95861,2663,'ar','Ø§Ù„Ù…Ø±ØªØ¨',0),(95862,2663,'fr','Salaire',0),(95863,2663,'jp','çµ¦æ–™',0),(95864,2663,'pt','SalÃ¡rio',0),(95865,2663,'ru','Ð—Ð°Ñ€Ð¿Ð»Ð°Ñ‚Ð°',0),(95866,2663,'es','Salario',0),(95867,2663,'de','Gehalt',0),(95868,2663,'en','Salary',0),(95869,2664,'is','',0),(95870,2664,'dr','Ø­Ø±Ø§Ø¬ Ù‡Ø§',0),(95871,2664,'pr','Ø­Ø±Ø§Ø¬ Ù‡Ø§',0),(95872,2664,'tr','SatÄ±ÅŸ',0),(95873,2664,'pl','SprzedaÅ¼y',0),(95874,2664,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(95875,2664,'ur','ÙØ±ÙˆØ®Øª',0),(95876,2664,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð°',0),(95877,2664,'vi','BÃ¡n hÃ ng',0),(95878,2664,'af','Verkope',0),(95879,2664,'ro','Vanzari',0),(95880,2664,'et','MÃ¼Ã¼k',0),(95881,2664,'si','Prodaja',0),(95882,2664,'ba','Penjualan',0),(95883,2664,'nl','Verkoop',0),(95884,2664,'fi','Myynti',0),(95885,2664,'no','Salg',0),(95886,2664,'da','Salg',0),(95887,2664,'ko','íŒë§¤',0),(95888,2664,'he','×ž×›×™×¨×•×ª',0),(95889,2664,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(95890,2664,'zh','é”€å”®\r\n',0),(95891,2664,'sv','FÃ¶rsÃ¤ljning',0),(95892,2664,'it','Vendite',0),(95893,2664,'tl','',0),(95894,2664,'th','&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(95895,2664,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€',0),(95896,2664,'ms','Jualan',0),(95897,2664,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(95898,2664,'fr','Ventes',0),(95899,2664,'jp','ã‚»ãƒ¼ãƒ«ã‚¹',0),(95900,2664,'pt','Vendas',0),(95901,2664,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸',0),(95902,2664,'es','Ventas',0),(95903,2664,'de','Vertrieb',0),(95904,2664,'en','Sales',0),(95905,2665,'is','',0),(95906,2665,'dr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(95907,2665,'pr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(95908,2665,'tr','SatÄ±ÅŸ hesabÄ±',0),(95909,2665,'pl','SprzedaÅ¼ konta',0),(95910,2665,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(95911,2665,'ur','Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(95912,2665,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(95913,2665,'vi','TK BÃ¡n HÃ ng',0),(95914,2665,'af','Verkope Rekening',0),(95915,2665,'ro','Cont de vÃ¢nzare',0),(95916,2665,'et','MÃ¼Ã¼gikonto',0),(95917,2665,'si','Prodajni raÄun',0),(95918,2665,'ba','Penjualan Account',0),(95919,2665,'nl','Omzetrekening',0),(95920,2665,'fi','Myynnin tili',0),(95921,2665,'no','Salgskonto',0),(95922,2665,'da','Salg konto',0),(95923,2665,'ko','ì˜ì—… ê³„ì •',0),(95924,2665,'he','×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª',0),(95925,2665,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(95926,2665,'zh','é”€å”®å¸æˆ·\r\n',0),(95927,2665,'sv','FÃ¶rsÃ¤ljning konto',0),(95928,2665,'it','Sales Account',0),(95929,2665,'tl','',0),(95930,2665,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3586;&#3634;&#3618;',0),(95931,2665,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤–à¤¾à¤¤à¤¾',0),(95932,2665,'ms','Akaun jualan',0),(95933,2665,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(95934,2665,'fr','Compte de vente',0),(95935,2665,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(95936,2665,'pt','Conta de vendas',0),(95937,2665,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(95938,2665,'es','Cuenta de Ventas',0),(95939,2665,'de','Kundenkonto',0),(95940,2665,'en','Sales Account',0),(95941,2666,'is','',0),(95942,2666,'dr','Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(95943,2666,'pr','Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(95944,2666,'tr','SatÄ±ÅŸ eylem',0),(95945,2666,'pl','SprzedaÅ¼y akcji',0),(95946,2666,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(95947,2666,'ur','Ø³ÛŒÙ„Ø² Ø¹Ù…Ù„',0),(95948,2666,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(95949,2666,'vi','Hoáº¡t Ä‘á»™ng bÃ¡n hÃ ng',0),(95950,2666,'af','Verkope Aksie',0),(95951,2666,'ro','VÃ¢nzÄƒri de acÅ£iune',0),(95952,2666,'et','MÃ¼Ã¼gi tegevus',0),(95953,2666,'si','Prodajne akcije',0),(95954,2666,'ba','Aksi penjualan',0),(95955,2666,'nl','Verkoop actie',0),(95956,2666,'fi','Myynnin toiminta',0),(95957,2666,'no','Salg handling',0),(95958,2666,'da','Salg indsats',0),(95959,2666,'ko','íŒë§¤ ìž‘ì—…',0),(95960,2666,'he','×¤×¢×•×œ×ª ×ž×›×™×¨×”',0),(95961,2666,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î´ÏÎ¬ÏƒÎ·',0),(95962,2666,'zh','é”€å”®åŠ¨ä½œ\r\n',0),(95963,2666,'sv','FÃ¶rsÃ¤ljning Ã¥tgÃ¤rder',0),(95964,2666,'it','Azione di vendita',0),(95965,2666,'tl','',0),(95966,2666,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(95967,2666,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(95968,2666,'ms','Tindakan jualan',0),(95969,2666,'ar','Ø¹Ù…Ù„ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(95970,2666,'fr','Vente Action',0),(95971,2666,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(95972,2666,'pt','AÃ§Ã£o de vendas',0),(95973,2666,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(95974,2666,'es','AcciÃ³n de Ventas',0),(95975,2666,'de','Verkaufs-Aktion',0),(95976,2666,'en','Sales Action',0),(95977,2667,'is','',0),(95978,2667,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´  Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´',0),(95979,2667,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´  Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´',0),(95980,2667,'tr','SatÄ±ÅŸ iÅŸlemi dÃ¼zenlemek iÃ§in seÃ§in',0),(95981,2667,'pl','Wybierz sprzedaÅ¼y akcji do edycji',0),(95982,2667,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(95983,2667,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ„Ø² Ø¹Ù…Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(95984,2667,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(95985,2667,'vi','Chá»n HÃ nh Äá»™ng BÃ¡n HÃ ng Äá»ƒ Chá»‰nh Sá»­a',0),(95986,2667,'af','Kies verkope aksie om te redigeer',0),(95987,2667,'ro','SelectaÅ£i vÃ¢nzÄƒri de acÅ£iune pentru a edita',0),(95988,2667,'et','Valige mÃ¼Ã¼gi toimingu redigeerimine',0),(95989,2667,'si','Izberite prodajne akcije za urejanje',0),(95990,2667,'ba','Pilih aksi penjualan untuk mengedit',0),(95991,2667,'nl','Selecteer verkoop actie om te bewerken',0),(95992,2667,'fi','Valitse myynti toiminto Muokkaa',0),(95993,2667,'no','Velg salg handling Ã¥ redigere',0),(95994,2667,'da','VÃ¦lg salg handling at redigere',0),(95995,2667,'ko','íŽ¸ì§‘ í•˜ë ¤ë©´ íŒë§¤ ìž‘ì—… ì„ íƒ',0),(95996,2667,'he','×‘×—×¨ ×¤×¢×•×œ×ª ×ž×›×™×¨×•×ª ×œ×¢×¨×™×›×”',0),(95997,2667,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ ÎµÎ½Î­ÏÎ³ÎµÎ¹Î± Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(95998,2667,'zh','ç¼–è¾‘é€‰æ‹©é”€å”®è¡Œä¸º\r\n',0),(95999,2667,'sv','VÃ¤lj fÃ¶rsÃ¤ljning Ã¥tgÃ¤rd att redigera',0),(96000,2667,'it','Selezionare azione vendita da modificare',0),(96001,2667,'tl','',0),(96002,2667,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(96003,2667,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(96004,2667,'ms','Pilih tindakan jualan untuk Edit',0),(96005,2667,'ar','Ø­Ø¯Ø¯ Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„ØªÙˆØ±ÙŠØ¯ Ù„ØªØ­Ø±ÙŠØ±',0),(96006,2667,'fr','SÃ©lectionnez Action vente Ã  modifier',0),(96007,2667,'jp','ç·¨é›†ã?™ã‚‹ã‚»ãƒ¼ãƒ«ã‚¹ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã‚’é?¸æŠž',0),(96008,2667,'pt','Selecionar aÃ§Ã£o de vendas para editar',0),(96009,2667,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÐŸÑ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(96010,2667,'es','Seleccionar Accion de Ventas para Editar',0),(96011,2667,'de','WÃ¤hlen Sie Sales Aktion Bearbeiten',0),(96012,2667,'en','Select Sales Action to Edit',0),(96013,2668,'is','',0),(96014,2668,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(96015,2668,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(96016,2668,'tr','SatÄ±ÅŸ eylem raporu',0),(96017,2668,'pl','Raport sprzedaÅ¼y akcji',0),(96018,2668,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(96019,2668,'ur','Ø³ÛŒÙ„Ø² Ø§ÛŒÚ©Ø´Ù† Ø±Ù¾ÙˆØ±Ù¹',0),(96020,2668,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¸ Ð°ÐºÑ†Ð¸Ñ˜Ð°',0),(96021,2668,'vi','BÃ¡o cÃ¡o hoáº¡t Ä‘á»™ng kinh doanh',0),(96022,2668,'af','Verkoopsaksie Verslag',0),(96023,2668,'ro','VÃ¢nzÄƒri de acÅ£iune raport',0),(96024,2668,'et','MÃ¼Ã¼gi tegevuse aruanne',0),(96025,2668,'si','Ugodno poroÄilo',0),(96026,2668,'ba','Laporan Aksi penjualan',0),(96027,2668,'nl','Verkoop actie verslag',0),(96028,2668,'fi','Myynnin toimintakertomus',0),(96029,2668,'no','Salg handling rapport',0),(96030,2668,'da','Salg rapport',0),(96031,2668,'ko','ì˜ì—… í™œë™ ë³´ê³ ì„œ',0),(96032,2668,'he','×“×• ×— ×¤×¢×•×œ×” ×ž×›×™×¨×•×ª',0),(96033,2668,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î´ÏÎ¬ÏƒÎ·',0),(96034,2668,'zh','é”€å”®è¡Œä¸ºçš„æŠ¥å‘Š\r\n',0),(96035,2668,'sv','FÃ¶rsÃ¤ljning Ã¥tgÃ¤rd rapport',0),(96036,2668,'it','Report vendite azione',0),(96037,2668,'tl','',0),(96038,2668,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(96039,2668,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(96040,2668,'ms','Laporan tindakan jualan',0),(96041,2668,'ar','ØªÙ‚Ø±ÙŠØ± Ø¹Ù…Ù„ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96042,2668,'fr','Rapport de vente Action',0),(96043,2668,'jp','è²©å£²è¡Œå‹•ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(96044,2668,'pt','RelatÃ³rio de aÃ§Ã£o de vendas',0),(96045,2668,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(96046,2668,'es','Informe de Acciones de Ventas',0),(96047,2668,'de','Verkauf Aktion Bericht',0),(96048,2668,'en','Sales Action Report',0),(96049,2669,'is','',0),(96050,2669,'dr','Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(96051,2669,'pr','Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(96052,2669,'tr','SATIÅž EYLEM',0),(96053,2669,'pl','SPRZEDAÅ»Y AKCJI',0),(96054,2669,'bg','ÐŸÐ ÐžÐ”ÐÐ–Ð‘Ð˜ Ð”Ð•Ð™Ð¡Ð¢Ð’Ð˜Ð•',0),(96055,2669,'ur','Ø³ÛŒÙ„Ø² Ø¹Ù…Ù„',0),(96056,2669,'sr','ÐŸÐ ÐžÐ”ÐÐˆÐ• ÐÐšÐ¦Ð˜ÐˆÐ•',0),(96057,2669,'vi','Hoáº¡t Äá»™ng BÃ¡n HÃ ng',0),(96058,2669,'af','VERKOOPSAKSIE',0),(96059,2669,'ro','VÃ‚NZÄ‚RI DE ACÅ¢IUNE',0),(96060,2669,'et','MÃœÃœGI TEGEVUS',0),(96061,2669,'si','PRODAJNE AKCIJE',0),(96062,2669,'ba','AKSI PENJUALAN',0),(96063,2669,'nl','VERKOOP ACTIE',0),(96064,2669,'fi','MYYNNIN TOIMINTA',0),(96065,2669,'no','SALG HANDLING',0),(96066,2669,'da','SALG INDSATS',0),(96067,2669,'ko','íŒë§¤ ìž‘ì—…',0),(96068,2669,'he','×¤×¢×•×œ×ª ×ž×›×™×¨×”',0),(96069,2669,'el','Î Î©Î›Î‰Î£Î•Î©Î Î”Î¡Î†Î£Î—',0),(96070,2669,'zh','é”€å”®è¡Œä¸º\r\n',0),(96071,2669,'sv','FÃ–RSÃ„LJNING Ã…TGÃ„RDER',0),(96072,2669,'it','AZIONE DI VENDITA',0),(96073,2669,'tl','',0),(96074,2669,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(96075,2669,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(96076,2669,'ms','TINDAKAN JUALAN',0),(96077,2669,'ar','Ø¹Ù…Ù„ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96078,2669,'fr','VENTE ACTION',0),(96079,2669,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(96080,2669,'pt','AÃ‡ÃƒO DE VENDAS',0),(96081,2669,'ru','Ð”Ð•Ð™Ð¡Ð¢Ð’Ð˜Ð• ÐŸÐ ÐžÐ”ÐÐ–',0),(96082,2669,'es','ACCIÃ“N DE VENTAS',0),(96083,2669,'de','VERKAUFS-AKTION',0),(96084,2669,'en','SALES ACTION',0),(96085,2670,'is','',0),(96086,2670,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ ',0),(96087,2670,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ ',0),(96088,2670,'tr','SatÄ±ÅŸ tutarÄ±',0),(96089,2670,'pl','Kwota sprzedaÅ¼y',0),(96090,2670,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(96091,2670,'ur','ÙØ±ÙˆØ®Øª Ú©ÛŒ Ø±Ù‚Ù…',0),(96092,2670,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(96093,2670,'vi','Sá»‘ tiá»n doanh thu',0),(96094,2670,'af','Verkoopsbedrag',0),(96095,2670,'ro','SumÄƒ vÃ¢nzÄƒri',0),(96096,2670,'et','MÃ¼Ã¼gisumma',0),(96097,2670,'si','Znesek prodaje',0),(96098,2670,'ba','Jumlah penjualan',0),(96099,2670,'nl','Verkoopbedrag',0),(96100,2670,'fi','Myyntisumma',0),(96101,2670,'no','SalgsbelÃ¸p',0),(96102,2670,'da','SalgsbelÃ¸b',0),(96103,2670,'ko','íŒë§¤ ê¸ˆì•¡',0),(96104,2670,'he','×¡×›×•× ×ž×›×™×¨×•×ª',0),(96105,2670,'el','Î Î¿ÏƒÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96106,2670,'zh','é”€å”®é‡‘é¢\r\n',0),(96107,2670,'sv','FÃ¶rsÃ¤ljningsbelopp',0),(96108,2670,'it','Importo vendite',0),(96109,2670,'tl','',0),(96110,2670,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3634;&#3618;',0),(96111,2670,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤°à¤¾à¤¶à¤¿',0),(96112,2670,'ms','Jumlah jualan',0),(96113,2670,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96114,2670,'fr','Montant des ventes',0),(96115,2670,'jp','å£²ä¸Šé«˜',0),(96116,2670,'pt','Quantidade de vendas',0),(96117,2670,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(96118,2670,'es','Monto de Ventas',0),(96119,2670,'de','Verkaufsbetrag',0),(96120,2670,'en','Sales Amount',0),(96121,2671,'is','',0),(96122,2671,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ',0),(96123,2671,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ',0),(96124,2671,'tr','SatÄ±ÅŸ Kategoriler',0),(96125,2671,'pl','SprzedaÅ¼y kategorii',0),(96126,2671,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(96127,2671,'ur','Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(96128,2671,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(96129,2671,'vi','Thá»ƒ loáº¡i bÃ¡n hÃ ng',0),(96130,2671,'af','VerkoopskategoriÃ« ',0),(96131,2671,'ro','VÃ¢nzÄƒri categorii',0),(96132,2671,'et','Tootekategooria',0),(96133,2671,'si','Prodaja kategorije',0),(96134,2671,'ba','Kategori Penjualan',0),(96135,2671,'nl','Verkoopcategorie',0),(96136,2671,'fi','Myynti luokka',0),(96137,2671,'no','Salg kategorier',0),(96138,2671,'da','Salg kategorier',0),(96139,2671,'ko','íŒë§¤ ì¹´í…Œê³ ë¦¬',0),(96140,2671,'he','×§×˜×’×•×¨×™×•×ª ×ž×›×™×¨×•×ª',0),(96141,2671,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96142,2671,'zh','é”€å”®ç±»åˆ«\r\n',0),(96143,2671,'sv','FÃ¶rsÃ¤ljningskategori',0),(96144,2671,'it','Categorie vendite',0),(96145,2671,'tl','',0),(96146,2671,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(96147,2671,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚',0),(96148,2671,'ms','Kategori jualan',0),(96149,2671,'ar','ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96150,2671,'fr','CatÃ©gories de ventes',0),(96151,2671,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(96152,2671,'pt','Categorias vendas',0),(96153,2671,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(96154,2671,'es','CategorÃ­as de Ventas',0),(96155,2671,'de','Vertrieb Kategorien',0),(96156,2671,'en','Sales Categories',0),(96157,2672,'is','',0),(96158,2672,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´',0),(96159,2672,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´',0),(96160,2672,'tr','DÃ¼zenlemek iÃ§in satÄ±ÅŸ kategorisini seÃ§in',0),(96161,2672,'pl','Wybierz kategoriÄ™ sprzedaÅ¼y do edycji',0),(96162,2672,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(96163,2672,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(96164,2672,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑƒÐ»Ð°Ð·Ð½Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÑ€ÐµÐ´Ð¸Ð»Ð¸',0),(96165,2672,'vi','Chá»n Thá»ƒ Loáº¡i BÃ¡n HÃ ng Äá»ƒ Chá»‰nh Sá»­a',0),(96166,2672,'af','Kies verkope kategorie om te redigeer',0),(96167,2672,'ro','SelectaÅ£i categoria de vÃ¢nzÄƒri pentru a edita',0),(96168,2672,'et','MÃ¼Ã¼k kategooria redigeerimiseks valige',0),(96169,2672,'si','Izberite prodajni kategorijo urediti',0),(96170,2672,'ba','Pilih kategori penjualan untuk mengedit',0),(96171,2672,'nl','Selecteer verkoop categorie bewerken',0),(96172,2672,'fi','Valitse Myyntiluokan muokkaaminen',0),(96173,2672,'no','Velg salg kategori redigere',0),(96174,2672,'da','VÃ¦lg salgskategori til at redigere',0),(96175,2672,'ko','íŒë§¤ ë²”ì£¼ íŽ¸ì§‘ë¥¼ ì„ íƒí•©ë‹ˆë‹¤',0),(96176,2672,'he','×‘×—×¨ ×§×˜×’×•×¨×™×ª ×ž×›×™×¨×•×ª ×œ×¢×¨×™×›×”',0),(96177,2672,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î³Î¹Î± Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(96178,2672,'zh','é€‰æ‹©é”€å”®ç±»ç¼–è¾‘\r\n',0),(96179,2672,'sv','VÃ¤lj fÃ¶rsÃ¤ljningskategori redigera',0),(96180,2672,'it','Selezionare la categoria Sales per modificare',0),(96181,2672,'tl','',0),(96182,2672,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(96183,2672,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(96184,2672,'ms','Pilih kategori jualan untuk mengedit',0),(96185,2672,'ar','ØªØ­Ø±ÙŠØ± ØªØµÙ†ÙŠÙ Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96186,2672,'fr','SÃ©lectionnez la catÃ©gorie de ventes Ã  modifier',0),(96187,2672,'jp','ç·¨é›†ã?™ã‚‹ã‚»ãƒ¼ãƒ«ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’é?¸æŠž',0),(96188,2672,'pt','Selecione a categoria de vendas para editar',0),(96189,2672,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ ÐŸÑ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(96190,2672,'es','Seleccionar CategorÃ­a de Ventas para Editar',0),(96191,2672,'de','WÃ¤hlen Sie Verkauf Kategorie bearbeiten',0),(96192,2672,'en','Select Sales Category to Edit',0),(96193,2673,'is','',0),(96194,2673,'dr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ ',0),(96195,2673,'pr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ ',0),(96196,2673,'tr','SatÄ±ÅŸ GL hesabÄ±',0),(96197,2673,'pl','Konto sprzedaÅ¼y GL',0),(96198,2673,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ GL',0),(96199,2673,'ur','Ø³ÛŒÙ„Ø² Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(96200,2673,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð“Ð›',0),(96201,2673,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p HÃ ng BÃ¡n',0),(96202,2673,'af','AG Verkoperekening',0),(96203,2673,'ro','Cont de vÃ¢nzare GL',0),(96204,2673,'et','MÃ¼Ã¼gi pearaamatukontole',0),(96205,2673,'si','RaÄun prodaje GL',0),(96206,2673,'ba','Penjualan GL Account',0),(96207,2673,'nl','Verkoop GL Account',0),(96208,2673,'fi','Myynnin Kirjanpitotilin pÃ¤Ã¤tilin',0),(96209,2673,'no','Salg gi-konto',0),(96210,2673,'da','Salg GL konto',0),(96211,2673,'ko','íŒë§¤ GL ê³„ì •',0),(96212,2673,'he','×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª GL',0),(96213,2673,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³/Î»',0),(96214,2673,'zh','é”€å”®æ€»åˆ†ç±»å¸\r\n',0),(96215,2673,'sv','FÃ¶rsÃ¤ljning GL konto',0),(96216,2673,'it','GL Sales Account',0),(96217,2673,'tl','',0),(96218,2673,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(96219,2673,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ GL à¤–à¤¾à¤¤à¥‡',0),(96220,2673,'ms','Akaun jualan GL',0),(96221,2673,'ar','Ø­Ø³Ø§Ø¨ Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(96222,2673,'fr','Compte de vente GL',0),(96223,2673,'jp','å£²ä¸Šç·?å‹˜å®šå…ƒå¸³',0),(96224,2673,'pt','Conta de vendas GL',0),(96225,2673,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ GL',0),(96226,2673,'es','Cuenta LM de Ventas',0),(96227,2673,'de','Vertrieb Sako',0),(96228,2673,'en','Sales GL Account',0),(96229,2674,'is','',0),(96230,2674,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ„ÙŠ ÙØ±ÙˆØ´ ',0),(96231,2674,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ„ÙŠ ÙØ±ÙˆØ´ ',0),(96232,2674,'tr','SatÄ±ÅŸ Ã–zeti raporu',0),(96233,2674,'pl','Raport sprzedaÅ¼y przeglÄ…d',0),(96234,2674,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(96235,2674,'ur','Ø³ÛŒÙ„Ø² Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ø±Ù¾ÙˆØ±Ù¹',0),(96236,2674,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¸ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(96237,2674,'vi','BÃ¡o cÃ¡o tá»•ng quÃ¡t bÃ¡n hÃ ng',0),(96238,2674,'af','Verkope Oorsig Verslag',0),(96239,2674,'ro','Raport de vÃ¢nzÄƒri de ansamblu',0),(96240,2674,'et','MÃ¼Ã¼gi Ã¼levaatearuanne',0),(96241,2674,'si','PoroÄilo prodaje pregled',0),(96242,2674,'ba','Laporan Penjualan Ikhtisar',0),(96243,2674,'nl','Verkoop overzichtsrapport',0),(96244,2674,'fi','Myynnin yhteenvetoraportti',0),(96245,2674,'no','Salg oversiktsrapporten',0),(96246,2674,'da','Salg oversigtsrapport',0),(96247,2674,'ko','ì˜ì—… ê°œìš” ë³´ê³ ì„œ',0),(96248,2674,'he','×“×•×— ×¡×§×™×¨×” ×¢×œ ×ž×›×™×¨×•×ª',0),(96249,2674,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎµÏ€Î¹ÏƒÎºÏŒÏ€Î·ÏƒÎ·',0),(96250,2674,'zh','é”€å”®æ¦‚è¿°æŠ¥å‘Š\r\n',0),(96251,2674,'sv','FÃ¶rsÃ¤ljning Ã¶versiktsrapport',0),(96252,2674,'it','Rapporto vendite panoramica',0),(96253,2674,'tl','',0),(96254,2674,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3650;&#3604;&#3618;&#3626;&#3633;&#3591;&#3648;&#3586;&#3611;',0),(96255,2674,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤…à¤µà¤²à¥‹à¤•à¤¨ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(96256,2674,'ms','Laporan tinjauan jualan',0),(96257,2674,'ar','Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ù†Ø¸Ø±Ø© Ø¹Ø§Ù…Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96258,2674,'fr','Vente aperÃ§u gÃ©nÃ©ral',0),(96259,2674,'jp','è²©å£²æ¦‚è¦?',0),(96260,2674,'pt','RelatÃ³rio Resumo de vendas',0),(96261,2674,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶ Ð¾Ð±Ð·Ð¾Ñ€Ð½Ñ‹Ð¹ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(96262,2674,'es','Informe de VisiÃ³n General de Ventas',0),(96263,2674,'de','VerkaufsÃ¼bersicht Bericht',0),(96264,2674,'en','Sales Overview Report',0),(96265,2675,'is','',0),(96266,2675,'dr','Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ ',0),(96267,2675,'pr','Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ ',0),(96268,2675,'tr','SatÄ±ÅŸ personeli',0),(96269,2675,'pl','Personel sprzedaÅ¼y',0),(96270,2675,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(96271,2675,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø±',0),(96272,2675,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(96273,2675,'vi','NhÃ¢n viÃªn kinh doanh',0),(96274,2675,'af','Verkope personeel',0),(96275,2675,'ro','Personal de vÃ¢nzÄƒri',0),(96276,2675,'et','MÃ¼Ã¼giga tegelevad tÃ¶Ã¶tajad',0),(96277,2675,'si','Prodajno osebje',0),(96278,2675,'ba','Personil penjualan',0),(96279,2675,'nl','Verkooppersoneel',0),(96280,2675,'fi','MyyntihenkilÃ¶stÃ¶Ã¤',0),(96281,2675,'no','Selgere',0),(96282,2675,'da','Salgspersonale',0),(96283,2675,'ko','íŒë§¤ ì§ì›',0),(96284,2675,'he','×¦×•×•×ª ×ž×›×™×¨×•×ª',0),(96285,2675,'el','Î ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ¿Ï Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96286,2675,'zh','é”€å”®äººå‘˜\r\n',0),(96287,2675,'sv','FÃ¶rsÃ¤ljningspersonal',0),(96288,2675,'it','Personale di vendita',0),(96289,2675,'tl','',0),(96290,2675,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(96291,2675,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚',0),(96292,2675,'ms','Kakitangan jualan',0),(96293,2675,'ar','Ø£ÙØ±Ø§Ø¯ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96294,2675,'fr','Personnel de vente',0),(96295,2675,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¹ã‚¿ãƒƒãƒ•',0),(96296,2675,'pt','Pessoal de vendas',0),(96297,2675,'ru','Ð¢Ð¾Ñ€Ð³Ð¾Ð²Ñ‹Ð¹ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(96298,2675,'es','Personal de Ventas',0),(96299,2675,'de','Verkaufspersonal',0),(96300,2675,'en','Sales Personnel',0),(96301,2676,'is','',0),(96302,2676,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(96303,2676,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(96304,2676,'tr','SatÄ±ÅŸ temsilcisi',0),(96305,2676,'pl','Sprzedawcy',0),(96306,2676,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð»Ð¸Ñ†Ðµ',0),(96307,2676,'ur','Ø³ÛŒÙ„Ø² Ø´Ø®Øµ',0),(96308,2676,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(96309,2676,'vi','NhÃ¢n viÃªn kinh doanh',0),(96310,2676,'af','Verkoopspersoon',0),(96311,2676,'ro','PersoanÄƒ de vÃ¢nzÄƒri',0),(96312,2676,'et','MÃ¼Ã¼gimees',0),(96313,2676,'si','Pultom',0),(96314,2676,'ba','Orang penjualan',0),(96315,2676,'nl','Verkoop persoon',0),(96316,2676,'fi','MyyjÃ¤',0),(96317,2676,'no','Selger',0),(96318,2676,'da','Salg Person',0),(96319,2676,'ko','ì˜ì—… ì‚¬ì›',0),(96320,2676,'he','××™×© ×ž×›×™×¨×•×ª',0),(96321,2676,'el','Î ÏÏŒÏƒÏ‰Ï€Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96322,2676,'zh','é”€å”®äººå‘˜\r\n',0),(96323,2676,'sv','SÃ¤ljare',0),(96324,2676,'it','Persona di vendite',0),(96325,2676,'tl','',0),(96326,2676,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(96327,2676,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿',0),(96328,2676,'ms','Orang jualan',0),(96329,2676,'ar','Ù…ÙˆØ¸Ù Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96330,2676,'fr','Personne de ventes',0),(96331,2676,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¹ã‚¿ãƒƒãƒ•',0),(96332,2676,'pt','Pessoa de vendas',0),(96333,2676,'ru','ÐŸÐ¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°Ð¼',0),(96334,2676,'es','Vendedor',0),(96335,2676,'de','Vertriebsmitarbeiter',0),(96336,2676,'en','Sales Person',0),(96337,2677,'is','',0),(96338,2677,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ ',0),(96339,2677,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ ',0),(96340,2677,'tr','SatÄ±ÅŸ personeli Ekle',0),(96341,2677,'pl','Personel sprzedaÅ¼y dodaÄ‡',0),(96342,2677,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(96343,2677,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø±ÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(96344,2677,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(96345,2677,'vi','ThÃªm NhÃ¢n viÃªn kinh doanh',0),(96346,2677,'af','Verkoopspersoneel Skep',0),(96347,2677,'ro','Adauga personal de vÃ¢nzÄƒri',0),(96348,2677,'et','MÃ¼Ã¼gipersonali lisamine',0),(96349,2677,'si','Dodaj prodajno osebje',0),(96350,2677,'ba','Tambahkan personil penjualan',0),(96351,2677,'nl','Verkooppersoneel toevoegen',0),(96352,2677,'fi','MyyntihenkilÃ¶stÃ¶n lisÃ¤Ã¤minen',0),(96353,2677,'no','Selgerne legge',0),(96354,2677,'da','Salgspersonalet tilfÃ¸je',0),(96355,2677,'ko','ì˜ì—… ì¸ë ¥ ì¶”ê°€',0),(96356,2677,'he','×”×•×¡×£ ×¦×•×•×ª ×ž×›×™×¨×•×ª',0),(96357,2677,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96358,2677,'zh','é”€å”®äººå‘˜æ·»åŠ \r\n',0),(96359,2677,'sv','SÃ¤ljpersonal lÃ¤gger till',0),(96360,2677,'it','Aggiungi personale di vendita',0),(96361,2677,'tl','',0),(96362,2677,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(96363,2677,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(96364,2677,'ms','Menambah kakitangan jualan',0),(96365,2677,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ¸Ù Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96366,2677,'fr','Ajoute du Personnel de vente',0),(96367,2677,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¹ã‚¿ãƒƒãƒ•ã?®è¿½åŠ ',0),(96368,2677,'pt','Adiciona o pessoal de vendas',0),(96369,2677,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(96370,2677,'es','Agregar Personal de Ventas',0),(96371,2677,'de','Verkaufspersonal hinzufÃ¼gen',0),(96372,2677,'en','Sales Personnel Add',0),(96373,2678,'is','',0),(96374,2678,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(96375,2678,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(96376,2678,'tr','SatÄ±ÅŸ personeli baÅŸarÄ±yla eklendi',0),(96377,2678,'pl','Personel sprzedaÅ¼y dodano pomyÅ›lnie',0),(96378,2678,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð», Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(96379,2678,'ur','Ø³ÛŒÙ„Ø² Ø§ÛÙ„Ú©Ø§Ø±ÙˆÚº Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(96380,2678,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(96381,2678,'vi','ThÃªm NhÃ¢n viÃªn kinh doanh thÃ nh cÃ´ng',0),(96382,2678,'af','Verkoopspersoneel suksesvol geskep',0),(96383,2678,'ro','Personal de vÃ¢nzÄƒri adÄƒugat cu succes',0),(96384,2678,'et','MÃ¼Ã¼gipersonal lisati edukalt',0),(96385,2678,'si','Prodajno osebje, ki uspeÅ¡no dodani',0),(96386,2678,'ba','Personil penjualan ditambahkan berhasil',0),(96387,2678,'nl','Verkooppersoneel met succes toegevoegd',0),(96388,2678,'fi','MyyntihenkilÃ¶stÃ¶n lisÃ¤Ã¤minen onnistui',0),(96389,2678,'no','Selgerne lagt',0),(96390,2678,'da','Salgspersonalet tilfÃ¸jet',0),(96391,2678,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ íŒë§¤ ì§ì›',0),(96392,2678,'he','×¦×•×•×ª ×ž×›×™×¨×•×ª × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(96393,2678,'el','Î ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ¿Ï Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(96394,2678,'zh','é”€å”®äººå‘˜æ·»åŠ æˆåŠŸ\r\n',0),(96395,2678,'sv','FÃ¶rsÃ¤ljningspersonal lagts',0),(96396,2678,'it','Personale di vendita aggiunti con successo',0),(96397,2678,'tl','',0),(96398,2678,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(96399,2678,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(96400,2678,'ms','Kakitangan jualan yang berjaya menambah',0),(96401,2678,'ar','Ø£Ø¶ÙŠÙ Ù…ÙˆØ¸Ù Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(96402,2678,'fr','Personnel de vente ajoutÃ© avec succÃ¨s',0),(96403,2678,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¹ã‚¿ãƒƒãƒ•ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(96404,2678,'pt','Pessoal de vendas adicionado com sucesso',0),(96405,2678,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ† ÑƒÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(96406,2678,'es','Personal de Ventas agregado exitosamente',0),(96407,2678,'de','Verkaufspersonal erfolgreich hinzugefÃ¼gt',0),(96408,2678,'en','Sales Personnel added successfully',0),(96409,2679,'is','',0),(96410,2679,'dr','Ø­Ø°Ù Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(96411,2679,'pr','Ø­Ø°Ù Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(96412,2679,'tr','SatÄ±ÅŸ personeli baÅŸarÄ±yla silindi',0),(96413,2679,'pl','Personel sprzedaÅ¼y przesâ”‚anie',0),(96414,2679,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð», Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(96415,2679,'ur','Ø³ÛŒÙ„Ø² Ø§ÛÙ„Ú©Ø§Ø±ÙˆÚº Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(96416,2679,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(96417,2679,'vi','XÃ³a NhÃ¢n viÃªn kinh doanh thÃ nh cÃ´ng',0),(96418,2679,'af','Verkoopspersoneel suskesvol geskrap',0),(96419,2679,'ro','Personal de vÃ¢nzÄƒri eliminÄƒ cu succes',0),(96420,2679,'et','MÃ¼Ã¼gipersonal kustutati edukalt',0),(96421,2679,'si','Prodajno osebje, ki uspeÅ¡no izbrisana',0),(96422,2679,'ba','Personil penjualan yang berhasil dihapus',0),(96423,2679,'nl','Verkooppersoneel met succes verwijderd',0),(96424,2679,'fi','MyyntihenkilÃ¶stÃ¶Ã¤ poistettu',0),(96425,2679,'no','Selgerne slettet',0),(96426,2679,'da','Salgspersonalet slettet',0),(96427,2679,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” íŒë§¤ ì§ì›',0),(96428,2679,'he','×¦×•×•×ª ×ž×›×™×¨×•×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(96429,2679,'el','Î ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ¿Ï Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(96430,2679,'zh','é”€å”®äººå‘˜å·²æˆåŠŸåˆ é™¤\r\n',0),(96431,2679,'sv','FÃ¶rsÃ¤ljningspersonal raderades',0),(96432,2679,'it','Personale di vendita eliminati con successo',0),(96433,2679,'tl','',0),(96434,2679,'th','&#3621;&#3610;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(96435,2679,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(96436,2679,'ms','Kakitangan jualan dihapuskan dengan jayanya',0),(96437,2679,'ar','Ø­Ø°Ù Ù…ÙˆØ¸Ù Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(96438,2679,'fr','Personnel de vente supprimÃ© avec succÃ¨s',0),(96439,2679,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¹ã‚¿ãƒƒãƒ•ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(96440,2679,'pt','Pessoal de vendas apagado com sucesso',0),(96441,2679,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ† ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(96442,2679,'es','Personal de Ventas eliminado exitosamente',0),(96443,2679,'de','Verkaufspersonal erfolgreich gelÃ¶scht',0),(96444,2679,'en','Sales Personnel deleted successfully',0),(96445,2680,'is','',0),(96446,2680,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´',0),(96447,2680,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´',0),(96448,2680,'tr','SatÄ±ÅŸ personeli gÃ¼ncelleÅŸtirme',0),(96449,2680,'pl','Personel sprzedaÅ¼y aktualizacji',0),(96450,2680,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸Ñ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(96451,2680,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø±ÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(96452,2680,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(96453,2680,'vi','Cáº­p Nháº­t nhÃ¢n viÃªn kinh doanh',0),(96454,2680,'af','Verkoopspersoneel Opdateer',0),(96455,2680,'ro','Personal de vÃ¢nzÄƒri Update',0),(96456,2680,'et','MÃ¼Ã¼gipersonali uuendamine',0),(96457,2680,'si','Prodajno osebje posodobitev',0),(96458,2680,'ba','Penjualan personil Update',0),(96459,2680,'nl','Verkooppersoneel Update',0),(96460,2680,'fi','MyyntihenkilÃ¶stÃ¶Ã¤ pÃ¤ivitys',0),(96461,2680,'no','Selgerne oppdatering',0),(96462,2680,'da','Salgspersonalet opdatering',0),(96463,2680,'ko','ì˜ì—… ì¸ë ¥ ì—…ë°ì´íŠ¸',0),(96464,2680,'he','×¢×“×›×•×Ÿ ×¦×•×•×ª ×ž×›×™×¨×•×ª',0),(96465,2680,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Ï‰Î»Î·Ï„ÏŽÎ½',0),(96466,2680,'zh','é”€å”®äººå‘˜æ›´æ–°\r\n',0),(96467,2680,'sv','FÃ¶rsÃ¤ljningspersonal uppdatering',0),(96468,2680,'it','Aggiornamento del personale di vendita',0),(96469,2680,'tl','',0),(96470,2680,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(96471,2680,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(96472,2680,'ms','Kemaskini Terakhir kakitangan jualan',0),(96473,2680,'ar','ØªØ­Ø¯ÙŠØ« Ù…ÙˆØ¸Ù Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96474,2680,'fr','Mise Ã  jour du Personnel de vente',0),(96475,2680,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¹ã‚¿ãƒƒãƒ•ã?®æ›´æ–°',0),(96476,2680,'pt','AtualizaÃ§Ã£o do pessoal de vendas',0),(96477,2680,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(96478,2680,'es','Personal de Ventas Actualizar',0),(96479,2680,'de','Verkaufspersonal Update',0),(96480,2680,'en','Sales Personnel Update',0),(96481,2681,'is','',0),(96482,2681,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(96483,2681,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(96484,2681,'tr','SatÄ±ÅŸ personeli baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(96485,2681,'pl','Personel sprzedaÅ¼y pomyÅ›lnie zaktualizowana',0),(96486,2681,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð», Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(96487,2681,'ur','Ø³ÛŒÙ„Ø² Ø§ÛÙ„Ú©Ø§Ø±ÙˆÚº Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(96488,2681,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(96489,2681,'vi','Cáº­p Nháº­t nhÃ¢n viÃªn kinh doanh thÃ nh cÃ´ng',0),(96490,2681,'af','Verkoopspersoneel suksesvol Opdateer',0),(96491,2681,'ro','Personal de vÃ¢nzÄƒri actualizat cu succes',0),(96492,2681,'et','MÃ¼Ã¼gipersonal uuendati edukalt',0),(96493,2681,'si','Prodajno osebje posodobljena uspeÅ¡no',0),(96494,2681,'ba','Personil penjualan yang berhasil',0),(96495,2681,'nl','Verkooppersoneel bijgewerkt',0),(96496,2681,'fi','PÃ¤ivitetty myyntihenkilÃ¶stÃ¶Ã¤',0),(96497,2681,'no','Salgspersonale oppdatert',0),(96498,2681,'da','Salgspersonalet opdateret',0),(96499,2681,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” íŒë§¤ ì§ì›',0),(96500,2681,'he','×¦×•×•×ª ×ž×›×™×¨×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(96501,2681,'el','Î ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ¿Ï Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(96502,2681,'zh','é”€å”®äººå‘˜æˆåŠŸæ›´æ–°\r\n',0),(96503,2681,'sv','FÃ¶rsÃ¤ljningspersonal uppdaterats',0),(96504,2681,'it','Personale di vendita aggiornati con successo',0),(96505,2681,'tl','',0),(96506,2681,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(96507,2681,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(96508,2681,'ms','Kakitangan jualan yang berjaya dikemas kini',0),(96509,2681,'ar','Ø­Ø¯Ù‘Ø« Ù…ÙˆØ¸Ù Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(96510,2681,'fr','Personnel de vente mis Ã  jour avec succÃ¨s',0),(96511,2681,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¹ã‚¿ãƒƒãƒ•ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(96512,2681,'pt','Pessoal de vendas atualizado com sucesso',0),(96513,2681,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ† ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(96514,2681,'es','Personal de Ventas actualizado exitosamente',0),(96515,2681,'de','Verkaufspersonal erfolgreich aktualisiert',0),(96516,2681,'en','Sales Personnel updated successfully',0),(96517,2682,'is','',0),(96518,2682,'dr','/ Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(96519,2682,'pr','Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ / Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(96520,2682,'tr','SatÄ±ÅŸ/fiyat birimi adÄ±',0),(96521,2682,'pl','Nazwa jednostki sprzedaÅ¼y/Cennik',0),(96522,2682,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸/Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð¸Ð¼Ðµ Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(96523,2682,'ur','Ø³ÛŒÙ„Ø²/Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù…',0),(96524,2682,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° /Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ð¸Ð¼Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(96525,2682,'vi','TÃªn Ä‘Æ¡n vá»‹ giÃ¡/bÃ¡n hÃ ng',0),(96526,2682,'af','Verkope/pryse eenheid naam',0),(96527,2682,'ro','Nume de unitatea de vÃ¢nzÄƒri/preturi',0),(96528,2682,'et','MÃ¼Ã¼gi/hind Ã¼hiku nimi',0),(96529,2682,'si','Prodaja/cene enote ime',0),(96530,2682,'ba','Nama Unit penjualan/harga',0),(96531,2682,'nl','Naam van de eenheid van de verkoop/prijzen',0),(96532,2682,'fi','Myynti/hinnoittelu yksikÃ¶n nimi',0),(96533,2682,'no','Navn pÃ¥ salg/priser',0),(96534,2682,'da','Salg/prissÃ¦tning enhed navn',0),(96535,2682,'ko','íŒë§¤/ê°€ê²© ë‹¨ìœ„ ì´ë¦„',0),(96536,2682,'he','×©× ×™×—×™×“×ª ×ž×›×™×¨×•×ª/×ª×ž×—×•×¨',0),(96537,2682,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚/Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÏŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(96538,2682,'zh','é”€å”®/è®¡ä»·å•ä½åç§°\r\n',0),(96539,2682,'sv','FÃ¶rsÃ¤ljning/prissÃ¤ttning enhet namn',0),(96540,2682,'it','Nome dell\'unitÃ  vendite/prezzi',0),(96541,2682,'tl','',0),(96542,2682,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;/&#3605;&#3633;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(96543,2682,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¾à¤® à¤¬à¤¿à¤•à¥à¤°à¥€/à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(96544,2682,'ms','Nama Unit jualan/harga',0),(96545,2682,'ar','Ø¥Ø³Ù… ÙˆØ­Ø¯Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª/Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(96546,2682,'fr','Nom de l\'unitÃ© ventes/tarification',0),(96547,2682,'jp','ã‚»ãƒ¼ãƒ«ã‚¹/å€¤ä»˜ã?‘å?˜ä½?å??',0),(96548,2682,'pt','Nome da unidade de vendas/preÃ§os',0),(96549,2682,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¸ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(96550,2682,'es','Ventas/Precio Nombre de Unidad',0),(96551,2682,'de','Name der Organisationseinheit Sales/Preise',0),(96552,2682,'en','Sales/Pricing Unit Name',0),(96553,2683,'is','',0),(96554,2683,'dr','ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ ',0),(96555,2683,'pr','ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ ',0),(96556,2683,'tr','SATIÅž Ä°ÅžLEMÄ°',0),(96557,2683,'pl','PROCES SPRZEDAÅ»Y',0),(96558,2683,'bg','ÐŸÐ ÐžÐ¦Ð•Ð¡ ÐÐ ÐŸÐ ÐžÐ”ÐÐ–Ð‘Ð',0),(96559,2683,'ur','ÙØ±ÙˆØ®Øª Ú©Û’ Ø¹Ù…Ù„',0),(96560,2683,'sr','ÐŸÐ ÐžÐ¦Ð•Ð¡ ÐŸÐ ÐžÐ”ÐÐˆÐ•',0),(96561,2683,'vi','Quy trÃ¬nh bÃ¡n hÃ ng',0),(96562,2683,'af','VERKOOPSPROSES',0),(96563,2683,'ro','PROCESUL DE VANZARE',0),(96564,2683,'et','MÃœÃœGIPROTSESSI',0),(96565,2683,'si','PRODAJNI PROCES',0),(96566,2683,'ba','PROSES PENJUALAN',0),(96567,2683,'nl','VERKOOPPROCES',0),(96568,2683,'fi','MYYNTIPROSESSIN',0),(96569,2683,'no','SALGSPROSESSEN',0),(96570,2683,'da','SALGSPROCES',0),(96571,2683,'ko','ì˜ì—… í”„ë¡œì„¸ìŠ¤',0),(96572,2683,'he','×ª×”×œ×™×š ×ž×›×™×¨×•×ª',0),(96573,2683,'el','Î”Î™Î‘Î”Î™ÎšÎ‘Î£ÎŠÎ‘ Î Î©Î›Î‰Î£Î•Î©Î',0),(96574,2683,'zh','é”€å”®è¿‡ç¨‹\r\n',0),(96575,2683,'sv','FÃ–RSÃ„LJNINGSPROCESSEN',0),(96576,2683,'it','PROCESSO DI VENDITA',0),(96577,2683,'tl','',0),(96578,2683,'th','&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(96579,2683,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾',0),(96580,2683,'ms','PROSES JUALAN',0),(96581,2683,'ar','Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96582,2683,'fr','PROCESSUS DE VENTE',0),(96583,2683,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒ—ãƒ­ã‚»ã‚¹',0),(96584,2683,'pt','PROCESSO DE VENDAS',0),(96585,2683,'ru','ÐŸÐ ÐžÐ¦Ð•Ð¡Ð¡ ÐŸÐ ÐžÐ”ÐÐ–Ð˜',0),(96586,2683,'es','PROCESO DE VENTAS',0),(96587,2683,'de','VERKAUFSPROZESS',0),(96588,2683,'en','SALES PROCESS',0),(96589,2684,'is','',0),(96590,2684,'dr','Ø§Ù†ØªØ®Ø§Ø¨  ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ Ø¬Ù‡Øª ÙˆÙŠØ±Ø§ÙŠØ´',0),(96591,2684,'pr','Ø§Ù†ØªØ®Ø§Ø¨  ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ Ø¬Ù‡Øª ÙˆÙŠØ±Ø§ÙŠØ´',0),(96592,2684,'tr','SatÄ±ÅŸ iÅŸlemi dÃ¼zenlemek iÃ§in seÃ§in',0),(96593,2684,'pl','Wybierz procesu sprzedaÅ¼y do edycji',0),(96594,2684,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(96595,2684,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ„Ø² Ø¹Ù…Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(96596,2684,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(96597,2684,'vi','Chá»n QuÃ¡ TrÃ¬nh BÃ¡n HÃ ng Äá»ƒ Chá»‰nh Sá»­a',0),(96598,2684,'af','Kies verkope proses om te redigeer',0),(96599,2684,'ro','SelectaÅ£i procesul de vÃ¢nzare pentru a edita',0),(96600,2684,'et','Valige redigeerimiseks mÃ¼Ã¼giprotsessi',0),(96601,2684,'si','Izberite prodajni proces za urejanje',0),(96602,2684,'ba','Pilih proses penjualan untuk mengedit',0),(96603,2684,'nl','Selecteer verkoopproces bewerken',0),(96604,2684,'fi','Valitse muokattava myyntiprosessin',0),(96605,2684,'no','Velg salgsprosessen redigere',0),(96606,2684,'da','VÃ¦lg salgsproces redigere',0),(96607,2684,'ko','íŽ¸ì§‘ í•˜ë ¤ë©´ ì˜ì—… í”„ë¡œì„¸ìŠ¤ ì„ íƒ',0),(96608,2684,'he','×‘×—×¨ ×ª×”×œ×™×š ×ž×›×™×¨×•×ª ×œ×¢×¨×™×›×”',0),(96609,2684,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½, Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(96610,2684,'zh','é€‰æ‹©é”€å”®æµç¨‹ç¼–è¾‘\r\n',0),(96611,2684,'sv','VÃ¤lj fÃ¶rsÃ¤ljning Process fÃ¶r att redigera',0),(96612,2684,'it','Selezionare il processo di vendita per modificare',0),(96613,2684,'tl','',0),(96614,2684,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(96615,2684,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(96616,2684,'ms','Pilih proses jualan untuk mengedit',0),(96617,2684,'ar','Ø­Ø¯Ø¯ Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ØªØ­Ø±ÙŠØ±',0),(96618,2684,'fr','SÃ©lectionnez le processus de vente pour modifier',0),(96619,2684,'jp','ç·¨é›†ã?™ã‚‹ã‚»ãƒ¼ãƒ«ã‚¹ãƒ—ãƒ­ã‚»ã‚¹ã?®é?¸æŠž',0),(96620,2684,'pt','Selecione o processo de vendas para editar',0),(96621,2684,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÑ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(96622,2684,'es','Seleccionar Proceso de Ventas para Editar',0),(96623,2684,'de','WÃ¤hlen Sie Vertriebsprozess bearbeiten',0),(96624,2684,'en','Select Sales Process to Edit',0),(96625,2685,'is','',0),(96626,2685,'dr','ÙˆØ¶Ø¹ÙŠØª ÙØ±ÙˆØ´ ',0),(96627,2685,'pr','ÙˆØ¶Ø¹ÙŠØª ÙØ±ÙˆØ´ ',0),(96628,2685,'tr','SatÄ±ÅŸ durumu',0),(96629,2685,'pl','Stan sprzedaÅ¼y',0),(96630,2685,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(96631,2685,'ur','Ø³ÛŒÙ„Ø² Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(96632,2685,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(96633,2685,'vi','TÃ¬nh tráº¡ng bÃ¡n hÃ ng',0),(96634,2685,'af','Verkoopsstatus',0),(96635,2685,'ro','Statutul de vÃ¢nzÄƒri',0),(96636,2685,'et','MÃ¼Ã¼gi olek',0),(96637,2685,'si','Prodaje Status',0),(96638,2685,'ba','Status penjualan',0),(96639,2685,'nl','Verkoop Status',0),(96640,2685,'fi','Tila',0),(96641,2685,'no','Salg Status',0),(96642,2685,'da','Salg Status',0),(96643,2685,'ko','íŒë§¤ ìƒíƒœ',0),(96644,2685,'he','×ž×¦×‘ ×ž×›×™×¨×”',0),(96645,2685,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96646,2685,'zh','é”€å”®çŠ¶å†µ\r\n',0),(96647,2685,'sv','FÃ¶rsÃ¤ljning Status',0),(96648,2685,'it','Stato vendito',0),(96649,2685,'tl','',0),(96650,2685,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(96651,2685,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(96652,2685,'ms','Status jualan',0),(96653,2685,'ar','Ù…Ø±ÙƒØ² Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96654,2685,'fr','Statut de vente',0),(96655,2685,'jp','ã‚»ãƒ¼ãƒ«ã‚¹çŠ¶æ³?',0),(96656,2685,'pt','Status de vendas',0),(96657,2685,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(96658,2685,'es','Status de Ventas',0),(96659,2685,'de','Vertrieb-Status',0),(96660,2685,'en','Sales Status',0),(96661,2686,'is','',0),(96662,2686,'dr','Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(96663,2686,'pr','Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(96664,2686,'tr','SatÄ±ÅŸ vergisi',0),(96665,2686,'pl','Podatek od sprzedaÅ¼y',0),(96666,2686,'bg','Ð”Ð°Ð½ÑŠÐº Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(96667,2686,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³',0),(96668,2686,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(96669,2686,'vi','Thuáº¿ bÃ¡n hÃ ng',0),(96670,2686,'af','Verkoopsbelasting',0),(96671,2686,'ro','Impozit pe vÃ¢nzÄƒri',0),(96672,2686,'et','KÃ¤ibemaks',0),(96673,2686,'si','Prodajni davek',0),(96674,2686,'ba','Pajak penjualan',0),(96675,2686,'nl','Sales Tax',0),(96676,2686,'fi','ArvonlisÃ¤vero',0),(96677,2686,'no','Merverdiavgift',0),(96678,2686,'da','Moms',0),(96679,2686,'ko','íŒë§¤ ì„¸ê¸ˆ',0),(96680,2686,'he','×ž×¡ ×ž×›×™×¨×•×ª',0),(96681,2686,'el','Î¦ÏŒÏÎ¿Ï‚ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96682,2686,'zh','é”€å”®ç¨Ž\r\n',0),(96683,2686,'sv','Moms',0),(96684,2686,'it','Imposta sulle vendite',0),(96685,2686,'tl','',0),(96686,2686,'th','&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(96687,2686,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°',0),(96688,2686,'ms','Cukai jualan',0),(96689,2686,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96690,2686,'fr','Taxe de vente',0),(96691,2686,'jp','å£²ä¸Šç¨Ž',0),(96692,2686,'pt','Imposto sobre vendas',0),(96693,2686,'ru','ÐÐ°Ð»Ð¾Ð³ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(96694,2686,'es','IVA',0),(96695,2686,'de','Umsatzsteuer',0),(96696,2686,'en','Sales Tax',0),(96697,2687,'is','',0),(96698,2687,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(96699,2687,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(96700,2687,'tr','Yeni satÄ±ÅŸ vergisi',0),(96701,2687,'pl','Nowy podatek',0),(96702,2687,'bg','ÐÐ¾Ð² Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(96703,2687,'ur','Ù†Ø¦Û’ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³',0),(96704,2687,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(96705,2687,'vi','ThÃªm Thuáº¿ bÃ¡n hÃ ng',0),(96706,2687,'af','Verkoopsbelasting Byvoeg',0),(96707,2687,'ro','Noua taxÄƒ de vÃ¢nzÄƒri',0),(96708,2687,'et','Uue kÃ¤ibemaksu',0),(96709,2687,'si','Nov prometni davek',0),(96710,2687,'ba','Pajak penjualan baru',0),(96711,2687,'nl','Nieuwe Sales Tax',0),(96712,2687,'fi','Uusi arvonlisÃ¤vero',0),(96713,2687,'no','Nye mva',0),(96714,2687,'da','Nye moms',0),(96715,2687,'ko','ìƒˆë¡œìš´ íŒë§¤ ì„¸ê¸ˆ',0),(96716,2687,'he','×”×ž×¢ ×ž ×”×—×“×©',0),(96717,2687,'el','ÎÎ­Î¿ Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96718,2687,'zh','æ–°å¢žè¥ä¸šç¨Ž\r\n',0),(96719,2687,'sv','Ny moms',0),(96720,2687,'it','Nuova imposta sulle vendite',0),(96721,2687,'tl','',0),(96722,2687,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(96723,2687,'hi','à¤¨à¤ˆ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°',0),(96724,2687,'ms','Baru cukai jualan',0),(96725,2687,'ar','Ø¥Ø¶Ø§ÙØ© Ø¶Ø±ÙŠØ¨Ø© Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96726,2687,'fr','Nouvelle taxe de vente',0),(96727,2687,'jp','å£²ä¸Šç¨Žã?®è¿½åŠ ',0),(96728,2687,'pt','Novo imposto sobre vendas',0),(96729,2687,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ°Ð»Ð¾Ð³ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(96730,2687,'es','IVA Agregar',0),(96731,2687,'de','Neue Mehrwertsteuer',0),(96732,2687,'en','New Sales Tax',0),(96733,2688,'is','',0),(96734,2688,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(96735,2688,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(96736,2688,'tr','SatÄ±ÅŸ vergisi eklendi',0),(96737,2688,'pl','Podatek dodany pomyÅ›lnie',0),(96738,2688,'bg','Ð”Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(96739,2688,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(96740,2688,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ ÐºÐ¾Ñ˜Ð¸ ÑÑƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(96741,2688,'vi','ThÃªm Thuáº¿ bÃ¡n hÃ ng thÃ nh cÃ´ng',0),(96742,2688,'af','Verkoopsbelasting suksesvol Byvoeg',0),(96743,2688,'ro','Impozit pe vÃ¢nzÄƒri adÄƒugat cu succes',0),(96744,2688,'et','KÃ¤ibemaks lisati edukalt',0),(96745,2688,'si','Prometni davek, uspeÅ¡no dodani',0),(96746,2688,'ba','Pajak penjualan ditambahkan berhasil',0),(96747,2688,'nl','Sales Tax wordt toegevoegd',0),(96748,2688,'fi','ArvonlisÃ¤veron lisÃ¤Ã¤minen onnistui',0),(96749,2688,'no','Mva lagt',0),(96750,2688,'da','Moms tilfÃ¸jet',0),(96751,2688,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ íŒë§¤ì„¸',0),(96752,2688,'he','×ž×¡ ×ž×›×™×¨×•×ª × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(96753,2688,'el','Î¦ÏŒÏÎ¿Ï‚ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(96754,2688,'zh','é”€å”®ç¨Žæ·»åŠ æˆåŠŸ\r\n',0),(96755,2688,'sv','Moms som lagts',0),(96756,2688,'it','IVA aggiunto con successo',0),(96757,2688,'tl','',0),(96758,2688,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(96759,2688,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(96760,2688,'ms','Cukai jualan yang berjaya menambah',0),(96761,2688,'ar','Ø£Ø¶ÙŠÙØª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(96762,2688,'fr','Taxe de vente ajoutÃ©e avec succÃ¨s',0),(96763,2688,'jp','å£²ä¸Šç¨Žã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(96764,2688,'pt','Imposto sobre vendas adicionado com sucesso',0),(96765,2688,'ru','ÐÐ°Ð»Ð¾Ð³ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(96766,2688,'es','IVA agregado exitosamente',0),(96767,2688,'de','Umsatzsteuer erfolgreich hinzugefÃ¼gt',0),(96768,2688,'en','Sales Tax added successfully',0),(96769,2689,'is','',0),(96770,2689,'dr','Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(96771,2689,'pr','Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(96772,2689,'tr','SatÄ±ÅŸ vergisi baÅŸarÄ±yla silindi',0),(96773,2689,'pl','Podatek od sprzedaÅ¼y przesâ”‚anie',0),(96774,2689,'bg','Ð”Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(96775,2689,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(96776,2689,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ ÐºÐ¾Ñ˜Ð¸ ÑÑƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(96777,2689,'vi','XÃ³a Thuáº¿ bÃ¡n hÃ ng thÃ nh cÃ´ng',0),(96778,2689,'af','Verkoopsbelasting suksesvol GEskrap',0),(96779,2689,'ro','Impozit pe vÃ¢nzÄƒri eliminÄƒ cu succes',0),(96780,2689,'et','KÃ¤ibemaks kustutati edukalt',0),(96781,2689,'si','Prometni davek, uspeÅ¡no izbrisana',0),(96782,2689,'ba','Pajak penjualan yang berhasil dihapus',0),(96783,2689,'nl','Sales Tax wordt verwijderd',0),(96784,2689,'fi','ArvonlisÃ¤veron poistettu',0),(96785,2689,'no','Mva slettet',0),(96786,2689,'da','Sales Tax slettet',0),(96787,2689,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” íŒë§¤ì„¸',0),(96788,2689,'he','×ž×¢ ×ž × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(96789,2689,'el','Î¦ÏŒÏÎ¿Ï‚ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(96790,2689,'zh','è¥ä¸šç¨Žå·²æˆåŠŸåˆ é™¤\r\n',0),(96791,2689,'sv','Moms raderades',0),(96792,2689,'it','IVA eliminato con successo',0),(96793,2689,'tl','',0),(96794,2689,'th','&#3621;&#3610;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(96795,2689,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(96796,2689,'ms','Cukai jualan dihapuskan dengan jayanya',0),(96797,2689,'ar','Ø­Ø°ÙØª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(96798,2689,'fr','Taxe de vente supprimÃ©e avec succÃ¨s',0),(96799,2689,'jp','å£²ä¸Šç¨Žã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(96800,2689,'pt','Imposto sobre vendas apagado com sucesso',0),(96801,2689,'ru','ÐÐ°Ð»Ð¾Ð³ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(96802,2689,'es','IVA Agregar eliminado exitosamente',0),(96803,2689,'de','Umsatzsteuer erfolgreich gelÃ¶scht',0),(96804,2689,'en','Sales Tax deleted successfully',0),(96805,2690,'is','',0),(96806,2690,'dr','Ø¨Ø®Ø´ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(96807,2690,'pr','Ø¨Ø®Ø´ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(96808,2690,'tr','SatÄ±ÅŸ vergisi Ä°lÃ§e',0),(96809,2690,'pl','Powiat podatek od sprzedaÅ¼y',0),(96810,2690,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(96811,2690,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø¶Ù„Ø¹',0),(96812,2690,'sr','ÐžÐºÑ€ÑƒÐ³ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(96813,2690,'vi','Quáº­n thuáº¿ bÃ¡n hÃ ng',0),(96814,2690,'af','Verkoopsbelasting Distrik',0),(96815,2690,'ro','Districtul de taxa de vÃ¢nzÄƒri',0),(96816,2690,'et','MÃ¼Ã¼gi maksu rajoon',0),(96817,2690,'si','Prodaja davÄni okraj',0),(96818,2690,'ba','Distrik pajak penjualan',0),(96819,2690,'nl','Verkoopregio belasting',0),(96820,2690,'fi','Vero Myyntialue',0),(96821,2690,'no','Salg skatt distriktet',0),(96822,2690,'da','Salg skat distrikt',0),(96823,2690,'ko','íŒë§¤ ì„¸ê¸ˆ ì§€êµ¬',0),(96824,2690,'he','×ž×—×•×– ×ž×¡ ×ž×›×™×¨×•×ª',0),(96825,2690,'el','Î ÎµÏÎ¹Î¿Ï‡Î® Ï†ÏŒÏÎ¿Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96826,2690,'zh','è¥ä¸šç¨ŽåŒº\r\n',0),(96827,2690,'sv','SÃ¤ljdistrikt skatt',0),(96828,2690,'it','Distretto di Sales Tax',0),(96829,2690,'tl','',0),(96830,2690,'th','&#3648;&#3586;&#3605;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(96831,2690,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤œà¤¿à¤²à¤¾',0),(96832,2690,'ms','Daerah cukai jualan',0),(96833,2690,'ar','Ù…Ù†Ø·Ù‚Ø© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96834,2690,'fr','District de taxe de vente',0),(96835,2690,'jp','å£²ä¸Šç¨ŽåŒºåŸŸ',0),(96836,2690,'pt','Distrito de imposto sobre vendas',0),(96837,2690,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ñ€Ð°Ð¹Ð¾Ð½',0),(96838,2690,'es','Distrito de IVA ',0),(96839,2690,'de','Sales Tax District',0),(96840,2690,'en','Sales Tax District',0),(96841,2691,'is','',0),(96842,2691,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(96843,2691,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(96844,2691,'tr','SatÄ±ÅŸ vergisi kodu',0),(96845,2691,'pl','Nr identyfikacji podatkowej',0),(96846,2691,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´Ð°Ð½ÑŠÑ‡ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(96847,2691,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(96848,2691,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ ÐŸÐ˜Ð‘',0),(96849,2691,'vi','ID thuáº¿ bÃ¡n hÃ ng',0),(96850,2691,'af','Verkoopsbelasting ID',0),(96851,2691,'ro','VÃ¢nzÄƒri taxa ID',0),(96852,2691,'et','KÃ¤ibemaksukohuslase nr.',0),(96853,2691,'si','Prodajni davek ID',0),(96854,2691,'ba','ID pajak penjualan',0),(96855,2691,'nl','Verkoop Belastingnummer',0),(96856,2691,'fi','Vero tunnus',0),(96857,2691,'no','Sales Tax-ID',0),(96858,2691,'da','Sales Tax ID',0),(96859,2691,'ko','íŒë§¤ ì„¸ê¸ˆ ID',0),(96860,2691,'he','×ž×–×”×” ×ž×¡ ×ž×›×™×¨×•×ª',0),(96861,2691,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î‘Î¦Îœ',0),(96862,2691,'zh','é”€å”®ç¨Žå·\r\n',0),(96863,2691,'sv','Sales Tax ID',0),(96864,2691,'it','Sales Tax ID',0),(96865,2691,'tl','',0),(96866,2691,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(96867,2691,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤†à¤ˆà¤¡à¥€',0),(96868,2691,'ms','ID cukai jualan',0),(96869,2691,'ar','Ù…Ø¹Ø±Ù‘Ù Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96870,2691,'fr','Sales Tax ID',0),(96871,2691,'jp','å£²ä¸Šç¨ŽID',0),(96872,2691,'pt','ID de imposto sobre vendas',0),(96873,2691,'ru','ÐÐ°Ð»Ð¾Ð³ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð° ID',0),(96874,2691,'es','ID de IVA',0),(96875,2691,'de','USt-ID',0),(96876,2691,'en','Sales Tax ID',0),(96877,2692,'is','',0),(96878,2692,'dr','Ù†Ø§Ù… Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(96879,2692,'pr','Ù†Ø§Ù… Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(96880,2692,'tr','SatÄ±ÅŸ vergisi adÄ± zaten var',0),(96881,2692,'pl','Podatek od sprzedaÅ¼y nazwy juÅ¼ istnieje',0),(96882,2692,'bg','Ð”Ð°Ð½ÑŠÐº Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¸Ð¼Ðµ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(96883,2692,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©Ø§ Ù†Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(96884,2692,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¸Ð¼Ðµ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(96885,2692,'vi','TÃªn thuáº¿ bÃ¡n hÃ ng Ä‘Ã£ cÃ³',0),(96886,2692,'af','Verkoopsbelasting Naam Bestaan Alreeds',0),(96887,2692,'ro','Impozit pe vÃ¢nzÄƒri nume existÄƒ deja',0),(96888,2692,'et','KÃ¤ibemaksu nimi on juba olemas',0),(96889,2692,'si','Prometni davek ime Å¾e obstaja',0),(96890,2692,'ba','Nama pajak penjualan sudah ada',0),(96891,2692,'nl','Sales Tax naam bestaat al',0),(96892,2692,'fi','ArvonlisÃ¤veron nimi on jo olemassa',0),(96893,2692,'no','Mva-navnet finnes allerede',0),(96894,2692,'da','Sales Tax navn findes allerede',0),(96895,2692,'ko','íŒë§¤ì„¸ ì´ë¦„ì´ ì´ë¯¸',0),(96896,2692,'he','×ž×¢ ×ž ×©× ×›×‘×¨ ×§×™×™×',0),(96897,2692,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96898,2692,'zh','è¥ä¸šç¨Žåç§°å·²ç»å­˜åœ¨\r\n',0),(96899,2692,'sv','Moms namnet finns redan',0),(96900,2692,'it','IVA nome esiste giÃ ',0),(96901,2692,'tl','',0),(96902,2692,'th','&#3594;&#3639;&#3656;&#3629;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(96903,2692,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤•à¤¾ à¤¨à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(96904,2692,'ms','Cukai jualan nama sudah wujud',0),(96905,2692,'ar','Ø¥Ø³Ù… Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(96906,2692,'fr','Taxe de vente nom existe dÃ©jÃ ',0),(96907,2692,'jp','å£²ä¸Šç¨Žå??ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(96908,2692,'pt','Imposto sobre vendas nome jÃ¡ existe.',0),(96909,2692,'ru','ÐÐ°Ð»Ð¾Ð³ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¸Ð¼Ñ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(96910,2692,'es','Nombre de IVA Ya Existe',0),(96911,2692,'de','Umsatzsteuer-Namen ist bereits vorhanden.',0),(96912,2692,'en','Sales Tax Name Already Exists',0),(96913,2693,'is','',0),(96914,2693,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(96915,2693,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(96916,2693,'tr','SatÄ±ÅŸ vergisi DÃ¼zenle',0),(96917,2693,'pl','Edytuj podatku',0),(96918,2693,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(96919,2693,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(96920,2693,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(96921,2693,'vi','Cáº­p Nháº­t Thuáº¿ BÃ¡n HÃ ng',0),(96922,2693,'af','Verkoopsbelasting Opdateer',0),(96923,2693,'ro','Editare impozit pe vÃ¢nzÄƒri',0),(96924,2693,'et','Redigeeri kÃ¤ibemaksu',0),(96925,2693,'si','Urejanje prometnega davka',0),(96926,2693,'ba','Mengedit pajak penjualan',0),(96927,2693,'nl','Sales Tax bewerken',0),(96928,2693,'fi','Muokkaa ALV',0),(96929,2693,'no','Redigere mva',0),(96930,2693,'da','Redigere moms',0),(96931,2693,'ko','íŒë§¤ì„¸ë¥¼ íŽ¸ì§‘',0),(96932,2693,'he','×¢×¨×™×›×ª ×ž×¢ ×ž',0),(96933,2693,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96934,2693,'zh','è¥ä¸šç¨Žæ›´æ–°\r\n',0),(96935,2693,'sv','Redigera moms',0),(96936,2693,'it','Modifica IVA',0),(96937,2693,'tl','',0),(96938,2693,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(96939,2693,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(96940,2693,'ms','Edit cukai jualan',0),(96941,2693,'ar','ØªØ­Ø¯ÙŠØ« Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(96942,2693,'fr','Modifier la taxe de vente',0),(96943,2693,'jp','å£²ä¸Šç¨Žã?®æ›´æ–°',0),(96944,2693,'pt','Editar o imposto sobre vendas',0),(96945,2693,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐÐ°Ð»Ð¾Ð³ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(96946,2693,'es','IVA Actualizar',0),(96947,2693,'de','Bearbeiten von Umsatzsteuer',0),(96948,2693,'en','Edit Sales Tax',0),(96949,2694,'is','',0),(96950,2694,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(96951,2694,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(96952,2694,'tr','SatÄ±ÅŸ vergisi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(96953,2694,'pl','Podatek od sprzedaÅ¼y pomyÅ›lnie zaktualizowana',0),(96954,2694,'bg','Ð”Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(96955,2694,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(96956,2694,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(96957,2694,'vi','Cáº­p Nháº­t Thuáº¿ BÃ¡n HÃ ng thÃ nh cÃ´ng',0),(96958,2694,'af','Verkoopsbelasting suksesvol opdateer',0),(96959,2694,'ro','Impozit pe vÃ¢nzÄƒri actualizat cu succes',0),(96960,2694,'et','VÃ¤rskendatud kÃ¤ibemaksu',0),(96961,2694,'si','Prometni davek, ki je uspeÅ¡no posodobljena',0),(96962,2694,'ba','Pajak penjualan yang berhasil',0),(96963,2694,'nl','Sales Tax wordt bijgewerkt',0),(96964,2694,'fi','ArvonlisÃ¤veron pÃ¤ivitetty',0),(96965,2694,'no','Mva oppdatert',0),(96966,2694,'da','Sales Tax opdateret',0),(96967,2694,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” íŒë§¤ì„¸',0),(96968,2694,'he','×ž×¢ ×ž ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(96969,2694,'el','Î•Î½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Î¿ Ï†ÏŒÏÎ¿Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(96970,2694,'zh','è¥ä¸šç¨Žå·²æˆåŠŸæ›´æ–°\r\n',0),(96971,2694,'sv','Moms uppdaterats',0),(96972,2694,'it','IVA aggiornato con successo',0),(96973,2694,'tl','',0),(96974,2694,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3657;&#3592;',0),(96975,2694,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(96976,2694,'ms','Cukai jualan yang berjaya dikemas kini',0),(96977,2694,'ar','Ø­Ø¯Ù‘Ø«Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(96978,2694,'fr','Taxe de vente mis Ã  jour avec succÃ¨s',0),(96979,2694,'jp','å£²ä¸Šç¨Žã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(96980,2694,'pt','Imposto sobre vendas atualizado com sucesso',0),(96981,2694,'ru','ÐÐ°Ð»Ð¾Ð³ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(96982,2694,'es','IVA actualizado exitosamente',0),(96983,2694,'de','Umsatzsteuer, die erfolgreich aktualisiert',0),(96984,2694,'en','Sales Tax updated successfully',0),(96985,2695,'is','',0),(96986,2695,'dr','(Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ) ÙØ±ÙˆØ´',0),(96987,2695,'pr','Ø¯Ù†Ø¨Ø§Ù„ ÙƒÙ†Ù†Ø¯Ù‡ (Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ) ÙØ±ÙˆØ´',0),(96988,2695,'tr','SATIÅž Ä°ZCÄ°',0),(96989,2695,'pl','SPRZEDAÅ»Y HOLOWNIK',0),(96990,2695,'bg','ÐŸÐ ÐžÐ”ÐÐ–Ð‘Ð˜ TRACKER',0),(96991,2695,'ur','Ø³ÛŒÙ„Ø² Ù¹Ø±ÛŒÚ©Ø±',0),(96992,2695,'sr','ÐŸÐ ÐžÐ”ÐÐˆÐ• Ð¢Ð ÐÐ“ÐÐ§',0),(96993,2695,'vi','Theo dÃµi bÃ¡n hÃ ng',0),(96994,2695,'af','VERKOPE TRACKER',0),(96995,2695,'ro','VÃ‚NZÄ‚RI TRACKER',0),(96996,2695,'et','MÃœÃœGI TRACKER',0),(96997,2695,'si','PRODAJE TRACKER',0),(96998,2695,'ba','PENJUALAN TRACKER',0),(96999,2695,'nl','VERKOOP TRACKER',0),(97000,2695,'fi','MYYNNIN TRACKER',0),(97001,2695,'no','SALG BANE',0),(97002,2695,'da','SALG TRACKER',0),(97003,2695,'ko','íŒë§¤ ì¶”ì ê¸°',0),(97004,2695,'he','×ž×¢×§×‘ ×ž×›×™×¨×•×ª',0),(97005,2695,'el','Î Î©Î›Î‰Î£Î•Î©Î TRACKER',0),(97006,2695,'zh','é”€å”®è·Ÿè¸ªå™¨\r\n',0),(97007,2695,'sv','FÃ–RSÃ„LJNING TRACKER',0),(97008,2695,'it','SALES TRACKER',0),(97009,2695,'tl','',0),(97010,2695,'th','&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(97011,2695,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤Ÿà¥à¤°à¥ˆà¤•à¤°',0),(97012,2695,'ms','TRACKER JUALAN',0),(97013,2695,'ar','ØªØ¹Ù‚Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(97014,2695,'fr','SALES TRACKER',0),(97015,2695,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒˆãƒ©ãƒƒã‚«ãƒ¼',0),(97016,2695,'pt','VENDAS TRACKER',0),(97017,2695,'ru','ÐŸÐ ÐžÐ”ÐÐ– Ð¢Ð Ð•ÐšÐ•Ð ',0),(97018,2695,'es','RASTREADOR DE VENTAS',0),(97019,2695,'de','SALES TRACKER',0),(97020,2695,'en','SALES TRACKER',0),(97021,2696,'is','',0),(97022,2696,'dr','/ Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(97023,2696,'pr','ÙØ±ÙˆØ´ / Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(97024,2696,'tr','SatÄ±ÅŸ/fiyat birimi adÄ±',0),(97025,2696,'pl','Nazwa jednostki sprzedaÅ¼y/Cennik',0),(97026,2696,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸/Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð¸Ð¼Ðµ Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(97027,2696,'ur','Ø³ÛŒÙ„Ø²/Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù…',0),(97028,2696,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° /Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ð¸Ð¼Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(97029,2696,'vi','TÃªn dÆ¡n vá»‹ giÃ¡/bÃ¡n hÃ ng',0),(97030,2696,'af','Verkope/pryse eenheid naam',0),(97031,2696,'ro','Nume de unitatea de vÃ¢nzÄƒri/preturi',0),(97032,2696,'et','MÃ¼Ã¼gi/hind Ã¼hiku nimi',0),(97033,2696,'si','Prodaja/cene enote ime',0),(97034,2696,'ba','Nama Unit penjualan/harga',0),(97035,2696,'nl','Naam van de eenheid van de verkoop/prijzen',0),(97036,2696,'fi','Myynti/hinnoittelu yksikÃ¶n nimi',0),(97037,2696,'no','Navn pÃ¥ salg/priser',0),(97038,2696,'da','Salg/prissÃ¦tning enhed navn',0),(97039,2696,'ko','íŒë§¤/ê°€ê²© ë‹¨ìœ„ ì´ë¦„',0),(97040,2696,'he','×©× ×™×—×™×“×ª ×ž×›×™×¨×•×ª/×ª×ž×—×•×¨',0),(97041,2696,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚/Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÏŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(97042,2696,'zh','é”€å”®/è®¡ä»·å•ä½åç§°\r\n',0),(97043,2696,'sv','FÃ¶rsÃ¤ljning/prissÃ¤ttning enhet namn',0),(97044,2696,'it','Nome dell\'unitÃ  vendite/prezzi',0),(97045,2696,'tl','',0),(97046,2696,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;/&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(97047,2696,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¾à¤® à¤¬à¤¿à¤•à¥à¤°à¥€/à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(97048,2696,'ms','Nama Unit jualan/harga',0),(97049,2696,'ar','Ø¥Ø³Ù… ÙˆØ­Ø¯Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª/Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(97050,2696,'fr','Nom de l\'unitÃ© ventes/tarification',0),(97051,2696,'jp','è²©å£²/å€¤ä»˜ã?‘ã€€å?˜ä½?å??',0),(97052,2696,'pt','Nome da unidade de vendas/preÃ§os',0),(97053,2696,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¸ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(97054,2696,'es','Ventas/Precios Nombre de Unidad',0),(97055,2696,'de','Name der Organisationseinheit Sales/Preise',0),(97056,2696,'en','Sales/Pricing Unit Name',0),(97057,2697,'is','',0),(97058,2697,'dr','ÙØ±ÙˆØ´ Ø³Ø§Ù„ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(97059,2697,'pr','ÙØ±ÙˆØ´ Ø³Ø§Ù„ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(97060,2697,'tr','SatÄ±ÅŸ yÄ±l Tarih',0),(97061,2697,'pl','SprzedaÅ¼ od poczÄ…tku roku',0),(97062,2697,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð³Ð¾Ð´Ð¸Ð½Ð° ÐºÑŠÐ¼ Ð´Ð°Ñ‚Ð°',0),(97063,2697,'ur','Ø³ÛŒÙ„Ø² Ø³Ø§Ù„-ØªØ§Ø±ÛŒØ®',0),(97064,2697,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(97065,2697,'vi','Doanh sá»‘ tá»« Ä‘áº§u nÄƒm Ä‘áº¿n nay',0),(97066,2697,'af','Verkoopsjaar-Tot-Op-Datum',0),(97067,2697,'ro','VÃ¢nzÄƒri an la data',0),(97068,2697,'et','MÃ¼Ã¼gi aasta kuupÃ¤evani',0),(97069,2697,'si','Prodaja leto do datuma',0),(97070,2697,'ba','Penjualan tahun-To-Date',0),(97071,2697,'nl','Verkoop jaar-To-Date',0),(97072,2697,'fi','Myynti vuoden alusta',0),(97073,2697,'no','Salg hittil i Ã¥r',0),(97074,2697,'da','Salg Ã¥r-til-dato',0),(97075,2697,'ko','íŒë§¤ ë…„ ë‚ ì§œ',0),(97076,2697,'he','×ž×›×™×¨×•×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(97077,2697,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î­Ï„Î¿Ï‚-Ï€ÏÎ¿Ï‚-Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(97078,2697,'zh','é”€å”®å¹´æœ€æ–°\r\n',0),(97079,2697,'sv','FÃ¶rsÃ¤ljning Ã¥r-To-Date',0),(97080,2697,'it','Vendite anno-To-Date',0),(97081,2697,'tl','',0),(97082,2697,'th','&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3592;&#3634;&#3585;&#3611;&#3637;&#3626;&#3641;&#3656;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(97083,2697,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¤¾à¤² à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(97084,2697,'ms','Jualan tahun sehingga kini',0),(97085,2697,'ar','Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø³Ù†Ø© Ø¥Ù„Ù‰ ØªØ§Ø±ÙŠØ®',0),(97086,2697,'fr','Ventes annÃ©e Ã  ce jour',0),(97087,2697,'jp','ä¼šè¨ˆå¹´åº¦å§‹ã‚?ã?‹ã‚‰ç?¾åœ¨ã?¾ã?§ã?®è²©å£²',0),(97088,2697,'pt','Vendas ano-To-Date',0),(97089,2697,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸ Ð³Ð¾Ð´ Ðº Ð”Ð°Ñ‚Ð°,',0),(97090,2697,'es','Ventas AÃ±o a la Fecha',0),(97091,2697,'de','Umsatz Jahr-To-Date',0),(97092,2697,'en','Sales Year-To-Date',0),(97093,2698,'is','',0),(97094,2698,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(97095,2698,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(97096,2698,'tr','SatÄ±ÅŸ elemanÄ±',0),(97097,2698,'pl','Sprzedawca',0),(97098,2698,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ‡',0),(97099,2698,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û',0),(97100,2698,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(97101,2698,'vi','NhÃ¢n viÃªn kinh doanh',0),(97102,2698,'af','Verkoopspersoon',0),(97103,2698,'ro','Vanzator',0),(97104,2698,'et','MÃ¼Ã¼gimees',0),(97105,2698,'si','Prodajalec',0),(97106,2698,'ba','Penjual',0),(97107,2698,'nl','Verkoper',0),(97108,2698,'fi','MyyjÃ¤',0),(97109,2698,'no','Selger',0),(97110,2698,'da','SÃ¦lger',0),(97111,2698,'ko','ì„¸ì¼ì¦ˆ ë§¨',0),(97112,2698,'he','××™×© ×ž×›×™×¨×•×ª',0),(97113,2698,'el','Î Ï‰Î»Î·Ï„Î®Ï‚',0),(97114,2698,'zh','æŽ¨é”€å‘˜\r\n',0),(97115,2698,'sv','SÃ¤ljare',0),(97116,2698,'it','Venditore',0),(97117,2698,'tl','',0),(97118,2698,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(97119,2698,'hi','à¤¸à¥‡à¤²à¥à¤¸à¤®à¥‡à¤¨',0),(97120,2698,'ms','Jurujual',0),(97121,2698,'ar','Ù…ÙˆØ¸Ù Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(97122,2698,'fr','Vendeur',0),(97123,2698,'jp','ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…',0),(97124,2698,'pt','Vendedor',0),(97125,2698,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(97126,2698,'es','Vendedor',0),(97127,2698,'de','VerkÃ¤ufer',0),(97128,2698,'en','Salesman',0),(97129,2699,'is','',0),(97130,2699,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø§Ø³Øª â€“ Ù„Ø·ÙØ§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(97131,2699,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø§Ø³Øª â€“ Ù„Ø·ÙØ§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(97132,2699,'tr','SatÄ±cÄ± veritabanÄ±nda zaten, lÃ¼tfen tekrar deneyin',0),(97133,2699,'pl','Sprzedawca juÅ¼ w bazie danych, sprÃ³buj ponownie',0),(97134,2699,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ‡ Ð²ÐµÑ‡Ðµ Ð² Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸, Ð¼Ð¾Ð»Ñ Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(97135,2699,'ur','Ø¨Ù†Ø§Ú©Ø± Ú©ÙˆØ§Ø¦ÙÛŒÛØŒ Ù…ÛŒÚº Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ú©Ø±Ù†Û’ Ú©ÛŒ Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº Ù¾Ú¾Ø±',0),(97136,2699,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ† Ð²ÐµÑ› Ñƒ Ð±Ð°Ð·Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°, Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(97137,2699,'vi','NhÃ¢n viÃªn kinh doanh Ä‘Ã£ cÃ³ trong dá»¯ liá»‡u, vui lÃ²ng thá»­ láº¡i',0),(97138,2699,'af','Verkoopspersoon reeds in databasis, probeer asseblief weer',0),(97139,2699,'ro','Vanzator deja Ã®n baza de date, vÄƒ rugÄƒm sÄƒ Ã®ncercaÅ£i din nou',0),(97140,2699,'et','MÃ¼Ã¼gimees juba andmebaasis, Palun proovige uuesti',0),(97141,2699,'si','Prodajalec Å¾e v bazi, poskusite znova',0),(97142,2699,'ba','Salesman sudah dalam database, silakan coba lagi',0),(97143,2699,'nl','Verkoper al in database, probeer het a.u.b. opnieuw',0),(97144,2699,'fi','Myyntimies jo tietokanta, yritÃ¤ uudelleen',0),(97145,2699,'no','Selger allerede i databasen, prÃ¸v igjen',0),(97146,2699,'da','SÃ¦lger allerede i databasen, skal du prÃ¸ve igen',0),(97147,2699,'ko','ë°ì´í„°ë² ì´ìŠ¤ì— ì´ë¯¸ ì„¸ì¼ì¦ˆ ë§¨ ë‹¤ì‹œ ì‹œë„ í•˜ì‹­ì‹œì˜¤',0),(97148,2699,'he','××™×© ×ž×›×™×¨×•×ª ×›×‘×¨ ×‘×ž×¡×“ × ×ª×•× ×™×, ×× × × ×¡×” ×©×•×‘',0),(97149,2699,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ Î®Î´Î· ÏƒÏ„Î· Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½, Ï€Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(97150,2699,'zh','æŽ¨é”€å‘˜å·²ç»å­˜åœ¨äºŽæ•°æ®åº“ä¸­çš„ï¼Œè¯·å†è¯•ä¸€æ¬¡\r\n',0),(97151,2699,'sv','SÃ¤ljare redan i databasen, vÃ¤nligen fÃ¶rsÃ¶k igen',0),(97152,2699,'it','Venditore giÃ  nel database, riprovare',0),(97153,2699,'tl','',0),(97154,2699,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3649;&#3621;&#3657;&#3623;, &#3585;&#3619;&#3640;&#3603;&#3634;&',0),(97155,2699,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸, à¤®à¥‡à¤‚ à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚',0),(97156,2699,'ms','Jurujual sudah ada dalam pangkalan data, sila cuba lagi',0),(97157,2699,'ar','Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹ ÙÙŠ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§ØªØŒ ÙØ¶Ù„Ø§Ù‹ Ø­Ø§ÙˆÙ„ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(97158,2699,'fr','Vendeur dÃ©jÃ  dans la base de donnÃ©es, veuillez recommencer',0),(97159,2699,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?«ã?™ã?§ã?«ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…ã?Œã?„ã?¾ã?™ã€‚ã‚‚ã?†ä¸€åº¦ãƒˆãƒ©ã‚¤ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(97160,2699,'pt','Vendedor jÃ¡ no banco de dados, por favor tente novamente',0),(97161,2699,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ† ÑƒÐ¶Ðµ Ð² Ð±Ð°Ð·Ðµ Ð´Ð°Ð½Ð½Ñ‹Ñ…, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÑÐ½Ð¾Ð²Ð°',0),(97162,2699,'es','Vendedor ya esta en la base de datos, por favor intenta otra vez',0),(97163,2699,'de','VerkÃ¤ufer bereits in Datenbank, bitte versuchen Sie es erneut',0),(97164,2699,'en','Salesman already in database, please try again',0),(97165,2700,'is','',0),(97166,2700,'dr','Ú©Ø§Ø±Ø´Ù†Ø§Ø³ ÙØ±ÙˆØ´',0),(97167,2700,'pr','Ú©Ø§Ø±Ø´Ù†Ø§Ø³ ÙØ±ÙˆØ´',0),(97168,2700,'tr','SatÄ±ÅŸ temsilcisi',0),(97169,2700,'pl','Sprzedawca',0),(97170,2700,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(97171,2700,'ur','Ù¾Ø±Ø³Ù†',0),(97172,2700,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(97173,2700,'vi','NhÃ¢n viÃªn kinh doanh',0),(97174,2700,'af','Verkoopspersoon',0),(97175,2700,'ro','Agent de vÃ¢nzÄƒri',0),(97176,2700,'et','MÃ¼Ã¼gimees',0),(97177,2700,'si','Prodajalec',0),(97178,2700,'ba','Penjual',0),(97179,2700,'nl','Verkoper',0),(97180,2700,'fi','MyyjÃ¤',0),(97181,2700,'no','Selger',0),(97182,2700,'da','SÃ¦lger',0),(97183,2700,'ko','ì˜ì—… ì‚¬ì›',0),(97184,2700,'he','× ×¦×™×’ ×ž×›×™×¨×•×ª',0),(97185,2700,'el','Î Ï‰Î»Î·Ï„Î®',0),(97186,2700,'zh','å”®è´§å‘˜\r\n',0),(97187,2700,'sv','SÃ¤ljare',0),(97188,2700,'it','Venditore',0),(97189,2700,'tl','',0),(97190,2700,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(97191,2700,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿',0),(97192,2700,'ms','Jurujual',0),(97193,2700,'ar','Ù…Ù†Ø¯ÙˆØ¨ Ù…Ø¨ÙŠØ¹Ø§Øª',0),(97194,2700,'fr','Vendeur',0),(97195,2700,'jp','ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…',0),(97196,2700,'pt','Vendedor',0),(97197,2700,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(97198,2700,'es','Vendedor',0),(97199,2700,'de','Verkaufsberater',0),(97200,2700,'en','Salesperson',0),(97201,2701,'is','',0),(97202,2701,'dr','ÙˆØ§Ø­Ø¯ ÙØ±ÙˆØ´',0),(97203,2701,'pr','ÙˆØ§Ø­Ø¯ ÙØ±ÙˆØ´',0),(97204,2701,'tr','SatÄ±ÅŸ birimi',0),(97205,2701,'pl','Jednostki sprzedaÅ¼y',0),(97206,2701,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(97207,2701,'ur','Ø³ÛŒÙ„Ø² ÛŒÙˆÙ†Ù¹',0),(97208,2701,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(97209,2701,'vi','ÄÆ¡n vá»‹ bÃ¡n hÃ ng',0),(97210,2701,'af','Verkope eenheid',0),(97211,2701,'ro','Unitate de vÃ¢nzare',0),(97212,2701,'et','MÃ¼Ã¼giÃ¼ksuse',0),(97213,2701,'si','Prodajne enote',0),(97214,2701,'ba','Unit penjualan',0),(97215,2701,'nl','Verkoopeenheid',0),(97216,2701,'fi','MyyntiyksikkÃ¶',0),(97217,2701,'no','Salgsenheten',0),(97218,2701,'da','Salgsenheden',0),(97219,2701,'ko','íŒë§¤ ë‹¨ìœ„',0),(97220,2701,'he','×¦×•×•×ª ×ž×›×™×¨×•×ª',0),(97221,2701,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î±',0),(97222,2701,'zh','é”€å”®å•ä½\r\n',0),(97223,2701,'sv','FÃ¶rsÃ¤ljningsenhet',0),(97224,2701,'it','UnitÃ  di vendita',0),(97225,2701,'tl','',0),(97226,2701,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3634;&#3618;',0),(97227,2701,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤‡à¤•à¤¾à¤ˆ',0),(97228,2701,'ms','Unit jualan',0),(97229,2701,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(97230,2701,'fr','UnitÃ© de vente',0),(97231,2701,'jp','è²©å£²å?˜ä½?',0),(97232,2701,'pt','Unidade de vendas',0),(97233,2701,'ru','ÐžÑ‚Ð´ÐµÐ» Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(97234,2701,'es','Unidad de Ventas',0),(97235,2701,'de','Verkaufseinheit',0),(97236,2701,'en','Sales Unit',0),(97237,2702,'is','',0),(97238,2702,'dr','Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† ',0),(97239,2702,'pr','Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† ',0),(97240,2702,'tr','Kaydet',0),(97241,2702,'pl','Zapisz',0),(97242,2702,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸',0),(97243,2702,'ur','Ù…Ø­ÙÙˆØ¸',0),(97244,2702,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜',0),(97245,2702,'vi','Save',0),(97246,2702,'af','Stoor',0),(97247,2702,'ro','Salveaza',0),(97248,2702,'et','Salvesta',0),(97249,2702,'si','Shrani',0),(97250,2702,'ba','Simpan',0),(97251,2702,'nl','Opslaan',0),(97252,2702,'fi','Tallenna',0),(97253,2702,'no','Lagre',0),(97254,2702,'da','Gem',0),(97255,2702,'ko','ì €ìž¥',0),(97256,2702,'he','×©×ž×•×¨',0),(97257,2702,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·',0),(97258,2702,'zh','ä¿å­˜\r\n',0),(97259,2702,'sv','Spara',0),(97260,2702,'it','Salvare',0),(97261,2702,'tl','',0),(97262,2702,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;',0),(97263,2702,'hi','à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(97264,2702,'ms','Simpan',0),(97265,2702,'ar','Ø§Ù„Ø­ÙØ¸',0),(97266,2702,'fr','Enregistrer',0),(97267,2702,'jp','ä¿?å­˜',0),(97268,2702,'pt','Salvar',0),(97269,2702,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ',0),(97270,2702,'es','Guardar',0),(97271,2702,'de','Speichern',0),(97272,2702,'en','Save',0),(97273,2703,'is','',0),(97274,2703,'dr','Ø°Ø®ÙŠØ±Ù‡  Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡ ÙØ¹Ø§Ù„ÙŠØª ',0),(97275,2703,'pr','Ø°Ø®ÙŠØ±Ù‡  Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡ ÙØ¹Ø§Ù„ÙŠØª ',0),(97276,2703,'tr','Ekle eylem kaydetme',0),(97277,2703,'pl','Zapisz Dodaj dziaÅ‚ania',0),(97278,2703,'bg','ÐžÑÐ²ÐµÐ½ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(97279,2703,'ur','Ø¹Ù…Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97280,2703,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(97281,2703,'vi','Sao lÆ°u ThÃªm hÃ nh Ä‘á»™ng',0),(97282,2703,'af','Stoor Aksie Byvoeging',0),(97283,2703,'ro','SalvaÅ£i AdÄƒugare acÅ£iuni',0),(97284,2703,'et','Salvestada toimingu lisamine',0),(97285,2703,'si','Shranjevanje Add delovanja',0),(97286,2703,'ba','Simpan Tambah tindakan',0),(97287,2703,'nl','Toevoegen van de actie Opslaan',0),(97288,2703,'fi','Tallenna lisÃ¤Ã¤ toiminnan',0),(97289,2703,'no','Lagre Legg til handling',0),(97290,2703,'da','Gemme TilfÃ¸j handling',0),(97291,2703,'ko','ì•¡ì…˜ì˜ ì¶”ê°€ ì €ìž¥',0),(97292,2703,'he','×œ×”×¦×™×œ ××ª ×”×•×¡×¤×” ×©×œ ×¤×¢×•×œ×”',0),(97293,2703,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î·Ï‚ Î´ÏÎ¬ÏƒÎ·Ï‚',0),(97294,2703,'zh','ä¿å­˜æ–°å¢žè¡ŒåŠ¨\r\n',0),(97295,2703,'sv','Spara LÃ¤gg till Ã¥tgÃ¤rd',0),(97296,2703,'it','Salvare aggiuntivo di azione',0),(97297,2703,'tl','',0),(97298,2703,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(97299,2703,'hi','à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤¾',0),(97300,2703,'ms','Simpan Tambah tindakan',0),(97301,2703,'ar','Ø­ÙØ¸ Ø¥Ø¶Ø§ÙØ© Ù„Ù„Ø¹Ù…Ù„',0),(97302,2703,'fr','Enregistrer le complÃ©ment de l\'Action',0),(97303,2703,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã?®è¿½åŠ ã‚’ä¿?å­˜',0),(97304,2703,'pt','Salvar adicionar de aÃ§Ã£o',0),(97305,2703,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(97306,2703,'es','Guardar Agregar AcciÃ³n',0),(97307,2703,'de','HinzufÃ¼gen von Action zu speichern',0),(97308,2703,'en','Save Add of Action',0),(97309,2704,'is','',0),(97310,2704,'dr','Ø°Ø®ÙŠØ±Ù‡  Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø² Ú¯Ø±ÙˆÙ‡',0),(97311,2704,'pr','Ø°Ø®ÙŠØ±Ù‡  Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø² Ú¯Ø±ÙˆÙ‡',0),(97312,2704,'tr','Kategori Ekle Kaydet',0),(97313,2704,'pl','Zapisz Dodaj kategoriÄ™',0),(97314,2704,'bg','ÐžÑÐ²ÐµÐ½ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(97315,2704,'ur','Ø²Ù…Ø±Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97316,2704,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(97317,2704,'vi','Sao lÆ°u thá»ƒ loáº¡i thÃªm ',0),(97318,2704,'af','Stoor Kategorie Byvoeging',0),(97319,2704,'ro','SalvaÅ£i AdÄƒugare din categoria',0),(97320,2704,'et','Lisa kategooria salvestamine',0),(97321,2704,'si','Shranjevanje Add kategorije',0),(97322,2704,'ba','Simpan Tambahkan Kategori',0),(97323,2704,'nl','Toevoegen van categorie opslaan',0),(97324,2704,'fi','Tallenna LisÃ¤Ã¤ luokka',0),(97325,2704,'no','Lagre legge av kategori',0),(97326,2704,'da','Gemme TilfÃ¸j kategori',0),(97327,2704,'ko','ì¹´í…Œê³ ë¦¬ì˜ ì¶”ê°€ ì €ìž¥',0),(97328,2704,'he','×©×ž×•×¨ ×”×•×¡×£ ×§×˜×’×•×¨×™×”',0),(97329,2704,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î·Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚',0),(97330,2704,'zh','ç±»åˆ«æ·»åŠ ä¿å­˜\r\n',0),(97331,2704,'sv','Spara LÃ¤gg till kategori',0),(97332,2704,'it','Salvare aggiuntivo di categoria',0),(97333,2704,'tl','',0),(97334,2704,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3621;&#3635;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;',0),(97335,2704,'hi','à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤à¤¡',0),(97336,2704,'ms','Simpan Tambah Kategori',0),(97337,2704,'ar','Ø­ÙØ¸ Ø¥Ø¶Ø§ÙØ© Ù„Ù„ÙØ¦Ø©',0),(97338,2704,'fr','Sauver l\'ajout de la catÃ©gorie',0),(97339,2704,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼è¿½åŠ ã‚’ä¿?å­˜',0),(97340,2704,'pt','Salvar adicionar da categoria',0),(97341,2704,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(97342,2704,'es','Guardar Agregar CategorÃ­a',0),(97343,2704,'de','HinzufÃ¼gen der Kategorie speichern',0),(97344,2704,'en','Save Add of Category',0),(97345,2705,'is','',0),(97346,2705,'dr','Ø°Ø®ÙŠØ±Ù‡   Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø² ÙØ±Ø¢ÙŠÙ†Ø¯',0),(97347,2705,'pr','Ø°Ø®ÙŠØ±Ù‡   Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø² ÙØ±Ø¢ÙŠÙ†Ø¯',0),(97348,2705,'tr','Ekleme iÅŸlemi kaydetme',0),(97349,2705,'pl','Zapisz Dodaj procesu',0),(97350,2705,'bg','Ð—Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(97351,2705,'ur','Ø¹Ù…Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97352,2705,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼ÑÐºÐ¾Ð³ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ°',0),(97353,2705,'vi','Sao lÆ°u ThÃªm quy trÃ¬nh',0),(97354,2705,'af','Stoor Proses Byvoeging',0),(97355,2705,'ro','AdÄƒugare de procesul de a salva',0),(97356,2705,'et','Salvesta protsessi lisamine',0),(97357,2705,'si','Shranjevanje Add procesa',0),(97358,2705,'ba','Simpan Tambah proses',0),(97359,2705,'nl','Toevoegen van proces opslaan',0),(97360,2705,'fi','Tallenna lisÃ¤Ã¤ prosessin',0),(97361,2705,'no','Lagre legge av prosessen',0),(97362,2705,'da','Gemme TilfÃ¸j proces',0),(97363,2705,'ko','ì €ìž¥ í”„ë¡œì„¸ìŠ¤ì˜ ì¶”ê°€',0),(97364,2705,'he','×œ×”×¦×™×œ ××ª ×”×•×¡×¤×” ×©×œ ×ª×”×œ×™×š',0),(97365,2705,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±Ï‚',0),(97366,2705,'zh','è¿‡ç¨‹æ·»åŠ ä¿å­˜\r\n',0),(97367,2705,'sv','Spara LÃ¤gg till processen',0),(97368,2705,'it','Salvare aggiuntivo del processo',0),(97369,2705,'tl','',0),(97370,2705,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;',0),(97371,2705,'hi','à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤•à¥€ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(97372,2705,'ms','Simpan Tambah proses',0),(97373,2705,'ar','Ø¥Ø¶Ø§ÙØ© Ù„Ø¹Ù…Ù„ÙŠØ© Ø­ÙØ¸',0),(97374,2705,'fr','Ã‰conomisez ajouter des processus',0),(97375,2705,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã?®è¿½åŠ ã‚’ä¿?å­˜',0),(97376,2705,'pt','Salvar adicionar de processo',0),(97377,2705,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ°',0),(97378,2705,'es','Guardar Agregar Proceso',0),(97379,2705,'de','HinzufÃ¼gen des Prozesses zu speichern',0),(97380,2705,'en','Save Add of Process',0),(97381,2706,'is','',0),(97382,2706,'dr','Ø°Ø®ÙŠØ±Ù‡ Ùˆ  Ù¾Ø³Øª  Ù…Ù‚Ø§Ø¯ÙŠØ± Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(97383,2706,'pr','Ø°Ø®ÙŠØ±Ù‡ Ùˆ  Ù¾Ø³Øª  Ù…Ù‚Ø§Ø¯ÙŠØ± Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(97384,2706,'tr','Kaydetmek ve girilen sayÄ±larÄ± sonrasÄ±',0),(97385,2706,'pl','ZapisaÄ‡ i wysÅ‚aÄ‡ pocztÄ… liczy wprowadzone',0),(97386,2706,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¸ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ Ð±Ñ€Ð¾Ð¹ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸',0),(97387,2706,'ur','Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø¯Ø§Ø®Ù„ Ø´Ù…Ø§Ø± Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº',0),(97388,2706,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð¸ ÐŸÐ ÐžÐšÐŠÐ˜Ð–Ð˜Ð¢Ð• Ñ‚Ð°Ñ‡Ð°ÐºÐ° ÑƒÑˆÐ°Ð¾',0),(97389,2706,'vi','Sao lÆ°u & Nháº­p Ä‘áº¿m ',0),(97390,2706,'af','Stoor en POS Tellings Ingevoer',0),(97391,2706,'ro','SalvaÅ£i ÅŸi POST conteazÄƒ intrat',0),(97392,2706,'et','Salvesta ja POST loeb sisestatud',0),(97393,2706,'si','Shranite in POST Å¡teje, vstopil',0),(97394,2706,'ba','Simpan dan posting hitungan masuk',0),(97395,2706,'nl','Opslaan en POST telt ingevoerd',0),(97396,2706,'fi','Tallentaa ja lÃ¤hettÃ¤Ã¤ laskee tuli',0),(97397,2706,'no','Lagre og legge teller angitt',0),(97398,2706,'da','Gemme og sende tÃ¦ller indtastet',0),(97399,2706,'ko','ì €ìž¥ í•˜ ê³  ìž…ë ¥ í•œ ê±´ì˜ ê²Œì‹œë¬¼',0),(97400,2706,'he','×œ×©×ž×•×¨ ×•×œ×¤×¨×¡× ×¡×¤×™×¨×•×ª × ×›× ×¡×•',0),(97401,2706,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ ÎºÎ±Î¹ Î¼ÎµÏ„Î¬ Î¼ÎµÏ„ÏÎ¬ÎµÎ¹ Ï„Î­Î¸Î·ÎºÎµ',0),(97402,2706,'zh','ä¿å­˜å’Œé‚®æ”¿è®¡æ•°è¾“å…¥\r\n',0),(97403,2706,'sv','Spara och skicka rÃ¤knas in',0),(97404,2706,'it','Salvare e conta entrato POST',0),(97405,2706,'tl','',0),(97406,2706,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3649;&#3621;&#3632;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3656;&#3634;&#3609;&#3605;&#3633;&#3623;&#3609;&#3633;&#3610;',0),(97407,2706,'hi','à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤”à¤° à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¥€ à¤—à¤¿à¤¨à¤¤à¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(97408,2706,'ms','Simpan dan menyiarkan tuduhan yang memasuki',0),(97409,2706,'ar','Ø­ÙØ¸ ÙˆÙ†Ø´Ø± Ø§Ù„ØªÙ‡Ù… Ø§Ù„ØªÙŠ Ø¯Ø®Ù„Øª',0),(97410,2706,'fr','Enregistrer et poster des comtes entrÃ©s',0),(97411,2706,'jp','å…¥åŠ›ã?—ã?Ÿã‚«ã‚¦ãƒ³ãƒˆã‚’ä¿?å­˜ã?—ã?¦è¨ˆä¸Š',0),(97412,2706,'pt','Salvar e contagens entradas posto',0),(97413,2706,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¸ Ð¿Ð¾ÑÐ»Ðµ Ð³Ñ€Ð°Ñ„Ð¾Ð² Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»',0),(97414,2706,'es','Guardar y ASENTAR Conteos Entradas',0),(97415,2706,'de','Sparen Sie und nach Grafen eingegeben',0),(97416,2706,'en','Save and POST Counts Entered',0),(97417,2707,'is','',0),(97418,2707,'dr','Ø°Ø®ÙŠØ±Ù‡  Ùˆ  Ù†Ù…Ø§ÙŠØ´ Ù…Ø¬Ø¯Ø¯',0),(97419,2707,'pr','Ø°Ø®ÙŠØ±Ù‡  Ùˆ  Ù†Ù…Ø§ÙŠØ´ Ù…Ø¬Ø¯Ø¯',0),(97420,2707,'tr','Kaydet & yeniden',0),(97421,2707,'pl','Zapisz & umoÅ¼liwiÄ‡ jego prezentacjÄ™',0),(97422,2707,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ & Ð¿Ð¾ÐºÐ°Ð¶ÐµÑ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(97423,2707,'ur','Ù…Ø­ÙÙˆØ¸ & Ø±Ø§Ø¯Ø§Ø³Ù¾Ù„ÛŒ',0),(97424,2707,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ & ÑÐºÐ¸Ñ€Ð²ÐµÐ½Ð¾Ð³',0),(97425,2707,'vi','Sao lÆ°u & hiá»ƒn thá»‹ láº¡i',0),(97426,2707,'af','Stoor en Hervertoon',0),(97427,2707,'ro','Salvare & reafiÅŸa',0),(97428,2707,'et','Salvesta ja kuva uuesti',0),(97429,2707,'si','Shrani & ponovno prikazovanje',0),(97430,2707,'ba','Simpan & Redisplay',0),(97431,2707,'nl','Opslaan & weergeven',0),(97432,2707,'fi','Tallenna & uudelleen nÃ¤kyviin',0),(97433,2707,'no','Lagre & vise',0),(97434,2707,'da','Gem & visningen',0),(97435,2707,'ko','Save & ë‹¤ì‹œ í‘œì‹œ',0),(97436,2707,'he','×©×ž×•×¨ & ×”×”×¦×’×” ×”×—×•×–×¨×ª',0),(97437,2707,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· & ÎµÏ€Î±Î½ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ·',0),(97438,2707,'zh','ä¿å­˜å¹¶é‡æ–°æ˜¾ç¤º\r\n',0),(97439,2707,'sv','Spara & visningen',0),(97440,2707,'it','Rivisualizzazione & Salva',0),(97441,2707,'tl','',0),(97442,2707,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3649;&#3621;&#3632;&#3649;&#3626;&#3604;&#3591;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(97443,2707,'hi','& à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(97444,2707,'ms','Simpan & Redisplay',0),(97445,2707,'ar','Ø­ÙØ¸ Ø¢Ù†Ø¯ Ø¥Ø¹Ø§Ø¯Ø© Ø¹Ø±Ø¶',0),(97446,2707,'fr','Enregistrer & sur Actualiser',0),(97447,2707,'jp','ä¿?å­˜ï¼†å†?è¡¨ç¤º',0),(97448,2707,'pt','Salvar & reexibiÃ§Ã£o',0),(97449,2707,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ & Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð·Ð¸Ñ‚ÑŒ',0),(97450,2707,'es','Guardar y Redesplegar',0),(97451,2707,'de','& \"Redisplay\" Speichern',0),(97452,2707,'en','Save & Redisplay',0),(97453,2708,'is','',0),(97454,2708,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÙˆØ¯Ø¬Ù‡',0),(97455,2708,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÙˆØ¯Ø¬Ù‡',0),(97456,2708,'tr','BÃ¼tÃ§e bilgilerini kaydet',0),(97457,2708,'pl','Zapisywanie informacji na temat budÅ¼etu',0),(97458,2708,'bg','Ð—Ð°Ð¿Ð¸ÑÐ²Ð°Ð¹ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(97459,2708,'ur','Ø¨Ø¬Ù¹ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97460,2708,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð±ÑƒÑŸÐµÑ‚Ð°',0),(97461,2708,'vi','Sao lÆ°u ThÃ´ng Tin ngÃ¢n sÃ¡ch',0),(97462,2708,'af','Stoor Begrotings Inligting',0),(97463,2708,'ro','SalvaÅ£i bugetul Info',0),(97464,2708,'et','Salvesta eelarve Info',0),(97465,2708,'si','Shranite proraÄuna Info',0),(97466,2708,'ba','Menghemat anggaran Info',0),(97467,2708,'nl','Begroting Info opslaan',0),(97468,2708,'fi','Tallenna talousarvion',0),(97469,2708,'no','Lagre budsjett Info',0),(97470,2708,'da','Gemme Budget Info',0),(97471,2708,'ko','ì˜ˆì‚° ì •ë³´ ì €ìž¥',0),(97472,2708,'he','×©×ž×•×¨ ×ž×™×“×¢ ×ª×§×¦×™×‘',0),(97473,2708,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ Ï„Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(97474,2708,'zh','ä¿å­˜é¢„ç®—ä¿¡æ¯\r\n',0),(97475,2708,'sv','Spara Budget information',0),(97476,2708,'it','Salvare le informazioni di bilancio',0),(97477,2708,'tl','',0),(97478,2708,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(97479,2708,'hi','à¤¬à¤œà¤Ÿ à¤¸à¥‚à¤šà¤¨à¤¾ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(97480,2708,'ms','Simpan maklumat belanjawan',0),(97481,2708,'ar','ØªØ®Ø²ÙŠÙ† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(97482,2708,'fr','Enregistrer les Info budgÃ©taire',0),(97483,2708,'jp','äºˆç®—æƒ…å ±ã‚’ä¿?å­˜',0),(97484,2708,'pt','Salvar informaÃ§Ãµes de orÃ§amento',0),(97485,2708,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð˜Ð½Ñ„Ð¾ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(97486,2708,'es','Guardar Info de Presupuesto',0),(97487,2708,'de','Budget-Info speichern',0),(97488,2708,'en','Save Budget Info',0),(97489,2709,'is','',0),(97490,2709,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(97491,2709,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(97492,2709,'tr','YapÄ± sipariÅŸi kaydetmek',0),(97493,2709,'pl','Zapisz Build Order',0),(97494,2709,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ ÑÑ‚Ñ€Ð¾Ñ Ñ€ÐµÐ´',0),(97495,2709,'ur','ØªØ¹Ù…ÛŒØ± ØªØ±ØªÛŒØ¨ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97496,2709,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð‘ÑƒÐ¸Ð»Ð´ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´',0),(97497,2709,'vi','Sao lÆ°u ÄÆ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(97498,2709,'af','Stoor Geboude Bestelling',0),(97499,2709,'ro','SalvaÅ£i construi ordine',0),(97500,2709,'et','Salvesta ehitada jÃ¤rjestus',0),(97501,2709,'si','Shranite izgradnje',0),(97502,2709,'ba','Simpan membangun Order',0),(97503,2709,'nl','Opbouwvolgorde opslaan',0),(97504,2709,'fi','Tallentaa tilauksen mukaan',0),(97505,2709,'no','Lagre bygge rekkefÃ¸lge',0),(97506,2709,'da','Gemme bygge rÃ¦kkefÃ¸lge',0),(97507,2709,'ko','ë¹Œë“œ ìˆœì„œ ì €ìž¥',0),(97508,2709,'he','×©×ž×•×¨ ×”×–×ž× ×ª ×‘× ×™×”',0),(97509,2709,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÎ¹ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(97510,2709,'zh','ä¿å­˜æž„å»ºé¡ºåº\r\n',0),(97511,2709,'sv','Spara bygga Order',0),(97512,2709,'it','Salvare l\'ordine di compilazione',0),(97513,2709,'tl','',0),(97514,2709,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(97515,2709,'hi','à¤¬à¤¿à¤²à¥à¤¡ à¤•à¥à¤°à¤® à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(97516,2709,'ms','Simpan perintah membina',0),(97517,2709,'ar','Ø­ÙØ¸ ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(97518,2709,'fr','Enregistrer l\'ordre de compilation',0),(97519,2709,'jp','çµ„ç«‹æ³¨æ–‡ã?®ä¿?å­˜',0),(97520,2709,'pt','Salvar a ordem de compilaÃ§Ã£o',0),(97521,2709,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(97522,2709,'es','Guardar Orden de ConstrucciÃ³n',0),(97523,2709,'de','Build-Auftrag speichern',0),(97524,2709,'en','Save Build Order',0),(97525,2710,'is','',0),(97526,2710,'dr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª ',0),(97527,2710,'pr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª ',0),(97528,2710,'tr','DeÄŸiÅŸiklikleri Kaydet',0),(97529,2710,'pl','Zapisz zmiany',0),(97530,2710,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ',0),(97531,2710,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97532,2710,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(97533,2710,'vi','Sao lÆ°u thay Ä‘á»•i',0),(97534,2710,'af','Stoor Veranderinge',0),(97535,2710,'ro','SalvaÅ£i modificÄƒrile',0),(97536,2710,'et','Salvesta muudatused',0),(97537,2710,'si','Shrani spremembe',0),(97538,2710,'ba','Simpan perubahan',0),(97539,2710,'nl','Wijzigingen opslaan',0),(97540,2710,'fi','Tallenna muutokset',0),(97541,2710,'no','Lagre endringer',0),(97542,2710,'da','Gemme Ã¦ndringer',0),(97543,2710,'ko','ë³€ê²½ ì‚¬í•­ì„ ì €ìž¥í•©ë‹ˆë‹¤',0),(97544,2710,'he','×©×ž×•×¨ ×©×™× ×•×™×™×',0),(97545,2710,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÏ„Îµ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚',0),(97546,2710,'zh','ä¿å­˜æ›´æ”¹\r\n',0),(97547,2710,'sv','Spara Ã¤ndringar',0),(97548,2710,'it','Salvare le modifiche',0),(97549,2710,'tl','',0),(97550,2710,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(97551,2710,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(97552,2710,'ms','Menyimpan perubahan',0),(97553,2710,'ar','Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(97554,2710,'fr','Enregistrer les modifications',0),(97555,2710,'jp','å¤‰æ›´ã‚’ä¿?å­˜',0),(97556,2710,'pt','Salvar ModificaÃ§Ãµes',0),(97557,2710,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(97558,2710,'es','Guardar Cambios',0),(97559,2710,'de','Speichern Sie die Ã„nderungen',0),(97560,2710,'en','Save Changes',0),(97561,2711,'is','',0),(97562,2711,'dr','/ Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¶Ø§ÙÙŠ',0),(97563,2711,'pr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª / Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¶Ø§ÙÙŠ',0),(97564,2711,'tr','DeÄŸiÅŸiklikleri Kaydet / Addl Ekle',0),(97565,2711,'pl','ZapisaÄ‡ zmiany / Dodaj Addl',0),(97566,2711,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ / Ð´Ð¾Ð±Ð°Ð²Ð¸ Addl',0),(97567,2711,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº / Ø§Ø¯Ø¯Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(97568,2711,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð° / ÐÐ´Ð´ ÐÐ´Ð´Ð»',0),(97569,2711,'vi','Sao lÆ°u thay Ä‘á»•i / ThÃªm',0),(97570,2711,'af','Stoor Veranderinge / Skep Add.',0),(97571,2711,'ro','SalvaÅ£i modificÄƒrile / Add Addl',0),(97572,2711,'et','Salvesta muudatused / lisa Addl',0),(97573,2711,'si','Shranite spremembe / Dodaj pokvariti se',0),(97574,2711,'ba','Simpan perubahan / Add Addl',0),(97575,2711,'nl','Wijzigingen opslaan / Add Addl',0),(97576,2711,'fi','Tallenna muutokset / lisÃ¤Ã¤ Addl',0),(97577,2711,'no','Lagre endringer / legge Addl',0),(97578,2711,'da','Gemme Ã¦ndringer / tilfÃ¸je Addl',0),(97579,2711,'ko','ë³€ê²½ ë‚´ìš©ì„ ì €ìž¥/Addl ì¶”ê°€',0),(97580,2711,'he','×œ×©×ž×•×¨ ×©×™× ×•×™×™× / ×”×•×¡×£ Addl',0),(97581,2711,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÏ„Îµ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚ / Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Addl',0),(97582,2711,'zh','ä¿å­˜æ›´æ”¹/æ·»åŠ é¢å¤–\r\n',0),(97583,2711,'sv','Spara Ã¤ndringar / LÃ¤gg till Addl',0),(97584,2711,'it','Salvare le modifiche / Aggiungi Addl',0),(97585,2711,'tl','',0),(97586,2711,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;/&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(97587,2711,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ / à¤…à¤ªà¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(97588,2711,'ms','Menyimpan perubahan / Add Addl',0),(97589,2711,'ar','Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª/Ø¥Ø¶Ø§ÙØ© Ø£',0),(97590,2711,'fr','Enregistrer les modifications / ajouter Addl',0),(97591,2711,'jp','å¤‰æ›´ã‚’ä¿?å­˜/è¿½åŠ ',0),(97592,2711,'pt','Salvar alteraÃ§Ãµes / adicionar Addl',0),(97593,2711,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ / Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÐŸÑ€Ð¸ÑÑ‚Ð°Ð²Ð½Ð¾Ð¹',0),(97594,2711,'es','Guardar Cambios / Agregar Addl.',0),(97595,2711,'de','Speichern Sie die Ã„nderungen / Add Addl',0),(97596,2711,'en','Save Changes / Add Addl',0),(97597,2712,'is','',0),(97598,2712,'dr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª ØªØ¹ÙŠÙŠÙ† Ù…ÙƒØ§Ù† Ø¨Ø±Ø§ÙŠ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨ÙŠØ´ØªØ±',0),(97599,2712,'pr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª ØªØ¹ÙŠÙŠÙ† Ù…ÙƒØ§Ù† Ø¨Ø±Ø§ÙŠ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨ÙŠØ´ØªØ±',0),(97600,2712,'tr','DeÄŸiÅŸiklikler/yapmak oda iÃ§in daha fazla malzeme kaydetmek',0),(97601,2712,'pl','Zapisz zmiany/Make pokÃ³j dla materiaÅ‚Ã³w wiÄ™cej',0),(97602,2712,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ/Ð¿Ñ€Ð°Ð²ÑÑ‚ Ð¼ÑÑÑ‚Ð¾ Ð·Ð° Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸',0),(97603,2712,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº/Ø¨Ù†Ø§Ù†Û’ Ú©Ø§ Ú©Ù…Ø±Û Ø²ÛŒØ§Ø¯Û Ù…ÙˆØ§Ø¯ Ú©Û’ Ù„Ø¦Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97604,2712,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°/Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ Ð¼ÐµÑÑ‚Ð° Ð·Ð° Ð²Ð¸ÑˆÐµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð°',0),(97605,2712,'vi','Sao lÆ°u thay Ä‘á»•i/DÃ nh chá»— cho nguyÃªn váº­t liá»‡u',0),(97606,2712,'af','Stoor veranderinge/maak ruimte vir meer materiaal',0),(97607,2712,'ro','SalvaÅ£i modificÄƒrile/a face loc pentru mai multe materiale',0),(97608,2712,'et','Salvesta muutused/tee ruumi rohkem materjale',0),(97609,2712,'si','Shranite spremembe/narediti prostor za veÄ materialov',0),(97610,2712,'ba','Simpan perubahan membuat ruang untuk lebih banyak bahan',0),(97611,2712,'nl','Opslaan van veranderingen/maken ruimte voor meer materiaal',0),(97612,2712,'fi','Muutokset/tehdÃ¤ tilaa enemmÃ¤n materiaalia',0),(97613,2712,'no','Endringer/lage plass til flere materialer',0),(97614,2712,'da','Gemme Ã¦ndringer/gÃ¸re plads til flere materialer',0),(97615,2712,'ko','ë” ë§Žì€ ìžë£Œì— ëŒ€ í•œ ë³€ê²½/í™•ì¸ ê³µê°„ì„ ì €ìž¥',0),(97616,2712,'he','×œ×©×ž×•×¨ ×©×™× ×•×™×™×/×œ×”×¤×•×š ×ž×§×•× ×œ×—×•×ž×¨×™× × ×•×¡×¤×™×',0),(97617,2712,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚/ÎºÎ¬Î½Î¿Ï…Î½ Ï‡ÏŽÏÎ¿ Î³Î¹Î± Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Ï…Î»Î¹ÎºÎ¬',0),(97618,2712,'zh','ä¿å­˜æ›´æ”¹/ç•™ç©ºé—´ç»™æ›´å¤šææ–™\r\n',0),(97619,2712,'sv','Spara Ã¤ndringar/gÃ¶ra rum fÃ¶r fler material',0),(97620,2712,'it','Salvare le modifiche/fare stanza per materiali piÃ¹',0),(97621,2712,'tl','',0),(97622,2712,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;/',0),(97623,2712,'hi','à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤”à¤° à¤…à¤§à¤¿à¤• à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨/à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤•à¤®à¤°à¥‡',0),(97624,2712,'ms','Simpan perubahan/membuat bilik untuk bahan-bahan yang lebih banyak',0),(97625,2712,'ar','Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª/Ø¬Ø¹Ù„ Ø§Ù„ØºØ±ÙØ© Ù„Ù…Ø²ÙŠØ¯ Ù…Ù† Ø§Ù„Ù…ÙˆØ§Ø¯',0),(97626,2712,'fr','Gagner de la place de changements/faire pour les matÃ©riaux plus',0),(97627,2712,'jp','å¤‰æ›´ã‚’ä¿?å­˜/ä»–ã?®æ??æ–™ã?®ã?Ÿã‚?ã?®ã‚¹ãƒšãƒ¼ã‚¹ã‚’ä½œã‚‹',0),(97628,2712,'pt','Salvar alteraÃ§Ãµes/fazer sala para materiais mais',0),(97629,2712,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ/ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð´Ð»Ñ Ð±Ð¾Ð»ÑŒÑˆÐµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð²',0),(97630,2712,'es','Guardar Cambios/Hacer Espacio para MÃ¡s Materiales',0),(97631,2712,'de','Speichern von Ã„nderungen/Make Room for weitere Materialien',0),(97632,2712,'en','Save Changes/Make Room for More Materials',0),(97633,2713,'is','',0),(97634,2713,'dr','Ø°Ø®ÙŠØ±Ù‡  Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(97635,2713,'pr','Ø°Ø®ÙŠØ±Ù‡  Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(97636,2713,'tr','Verileri kaydetme',0),(97637,2713,'pl','Zapisywanie danych',0),(97638,2713,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ',0),(97639,2713,'ur','Ú©ÙˆØ§Ø¦Ù Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97640,2713,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(97641,2713,'vi','Sao lÆ°u dá»¯ liá»‡u',0),(97642,2713,'af','Stoor Data',0),(97643,2713,'ro','Salvarea datelor',0),(97644,2713,'et','Salvesta andmed',0),(97645,2713,'si','Shranjevanje podatkov',0),(97646,2713,'ba','Menyimpan Data',0),(97647,2713,'nl','Gegevens opslaan',0),(97648,2713,'fi','Tallenna tiedot',0),(97649,2713,'no','Lagre Data',0),(97650,2713,'da','Gemme Data',0),(97651,2713,'ko','ë°ì´í„° ì €ìž¥',0),(97652,2713,'he','×©×ž×•×¨ × ×ª×•× ×™×',0),(97653,2713,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(97654,2713,'zh','ä¿å­˜æ•°æ®\r\n',0),(97655,2713,'sv','Spara Data',0),(97656,2713,'it','Salvare dati',0),(97657,2713,'tl','',0),(97658,2713,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(97659,2713,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(97660,2713,'ms','Menyimpan Data',0),(97661,2713,'ar','Ø­ÙØ¸ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(97662,2713,'fr','Enregistrer les donnÃ©es',0),(97663,2713,'jp','ãƒ‡ãƒ¼ã‚¿ã‚’ä¿?å­˜',0),(97664,2713,'pt','Salvar dados',0),(97665,2713,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ðµ',0),(97666,2713,'es','Guardar Datos',0),(97667,2713,'de','Speichern von Daten',0),(97668,2713,'en','Save Data',0),(97669,2714,'is','',0),(97670,2714,'dr','Ø°Ø®ÙŠØ±Ù‡  Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(97671,2714,'pr','Ø°Ø®ÙŠØ±Ù‡  Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(97672,2714,'tr','AyrÄ±ntÄ±larÄ± kaydetmek',0),(97673,2714,'pl','ZapisaÄ‡ szczegÃ³Å‚y',0),(97674,2714,'bg','Ð—Ð°Ð¿Ð°Ð¼ÐµÑ‚ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸',0),(97675,2714,'ur','ØªÙØµÛŒÙ„Ø§Øª Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97676,2714,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð´ÐµÑ‚Ð°Ñ™Ð°',0),(97677,2714,'vi','Sao lÆ°u chi tiáº¿t',0),(97678,2714,'af','Stoor Besonderhede',0),(97679,2714,'ro','Salvare detalii',0),(97680,2714,'et','Salvesta andmed',0),(97681,2714,'si','Shranite podrobnosti',0),(97682,2714,'ba','Simpan rincian',0),(97683,2714,'nl','Details opslaan',0),(97684,2714,'fi','Tallenna tiedot',0),(97685,2714,'no','Lagre detaljer',0),(97686,2714,'da','Gemme oplysninger',0),(97687,2714,'ko','ì„¸ë¶€ ì •ë³´ë¥¼ ì €ìž¥',0),(97688,2714,'he','×©×ž×•×¨ ×¤×¨×˜×™×',0),(97689,2714,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(97690,2714,'zh','ä¿å­˜è¯¦æƒ…\r\n',0),(97691,2714,'sv','Spara Detaljer',0),(97692,2714,'it','Salvare dettagli',0),(97693,2714,'tl','',0),(97694,2714,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(97695,2714,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(97696,2714,'ms','Simpan maklumat',0),(97697,2714,'ar','Ø­ÙØ¸ Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(97698,2714,'fr','Sauvegarder les dÃ©tails',0),(97699,2714,'jp','è©³ç´°ã‚’ä¿?å­˜',0),(97700,2714,'pt','Salvar detalhes',0),(97701,2714,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð”ÐµÑ‚Ð°Ð»Ð¸',0),(97702,2714,'es','Guardar Detalles',0),(97703,2714,'de','Speichern Details',0),(97704,2714,'en','Save Details',0),(97705,2715,'is','',0),(97706,2715,'dr','Ø°Ø®ÙŠØ±Ù‡  ÙˆÙŠØ±Ø§ÙŠØ´  ÙØ¹Ø§Ù„ÙŠØª ',0),(97707,2715,'pr','Ø°Ø®ÙŠØ±Ù‡  ÙˆÙŠØ±Ø§ÙŠØ´  ÙØ¹Ø§Ù„ÙŠØª ',0),(97708,2715,'tr','Kaydet eylemi DÃ¼zenle',0),(97709,2715,'pl','Zapisz edycja akcji',0),(97710,2715,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(97711,2715,'ur','Ø¹Ù…Ù„ ØªØ¯ÙˆÛŒÙ† Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97712,2715,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(97713,2715,'vi','Sao LÆ°u HÃ nh Äá»™ng Chá»‰nh Sá»­a',0),(97714,2715,'af','Stoor Redigering van Aksie',0),(97715,2715,'ro','Salveaza editarea actiunii',0),(97716,2715,'et','Salvestada toimingu redigeerimine',0),(97717,2715,'si','Shranite urejanje ukrepov',0),(97718,2715,'ba','Simpan Edit aksi',0),(97719,2715,'nl','Bewerken van de actie Opslaan',0),(97720,2715,'fi','Tallenna tehtÃ¤vÃ¤n muutokset',0),(97721,2715,'no','Lagre Rediger handling',0),(97722,2715,'da','Gemme redigering af handling',0),(97723,2715,'ko','ì €ìž¥ ìž‘ì—…ì˜ íŽ¸ì§‘',0),(97724,2715,'he','×©×ž×•×¨ ××ª ×¢×¨×™×›×ª ×”×¤×¢×•×œ×”',0),(97725,2715,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„Î·Ï‚ Î´ÏÎ¬ÏƒÎ·Ï‚',0),(97726,2715,'zh','ä¿å­˜ç¼–è¾‘çš„åŠ¨ä½œ\r\n',0),(97727,2715,'sv','Spara redigera Ã¥tgÃ¤rder',0),(97728,2715,'it','Salvare la modifica dell\'azione',0),(97729,2715,'tl','',0),(97730,2715,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(97731,2715,'hi','à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(97732,2715,'ms','Simpan Edit tindakan',0),(97733,2715,'ar','Ø­ÙØ¸ Ø§Ù„ØªØ¹Ø¯ÙŠÙ„ ÙÙŠ Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(97734,2715,'fr','Enregistrer Edit d\'Action',0),(97735,2715,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã?®ç·¨é›†ã‚’ä¿?å­˜',0),(97736,2715,'pt','Salvar Editar de aÃ§Ã£o',0),(97737,2715,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¿Ð¾ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸ÑŽ',0),(97738,2715,'es','Guardar Editar AcciÃ³n',0),(97739,2715,'de','Bearbeiten des Handelns zu speichern',0),(97740,2715,'en','Save Edit of Action',0),(97741,2716,'is','',0),(97742,2716,'dr','Ø°Ø®ÙŠØ±Ù‡  ÙˆÙŠØ±Ø§ÙŠØ´ Ú¯Ø±ÙˆÙ‡',0),(97743,2716,'pr','Ø°Ø®ÙŠØ±Ù‡  ÙˆÙŠØ±Ø§ÙŠØ´ Ú¯Ø±ÙˆÙ‡',0),(97744,2716,'tr','Kategori DÃ¼zenle Kaydet',0),(97745,2716,'pl','Zapisz edycja kategorii',0),(97746,2716,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(97747,2716,'ur','Ø²Ù…Ø±Û Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97748,2716,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(97749,2716,'vi','Sao LÆ°u Thá»ƒ Loáº¡i Chá»‰nh Sá»­a',0),(97750,2716,'af','Stoor Redigering van Kategorie',0),(97751,2716,'ro','Salva Edit din categoria',0),(97752,2716,'et','Salvestada Muuda kategooria',0),(97753,2716,'si','Shranite urejanje kategorije',0),(97754,2716,'ba','Simpan mengedit Kategori',0),(97755,2716,'nl','Bewerken van categorie opslaan',0),(97756,2716,'fi','Tallenna Muokkaa luokka',0),(97757,2716,'no','Lagre redigere kategori',0),(97758,2716,'da','Gemme redigering af kategori',0),(97759,2716,'ko','ì¹´í…Œê³ ë¦¬ì˜ íŽ¸ì§‘ ì €ìž¥',0),(97760,2716,'he','×©×ž×•×¨ ×¢×¨×™×›×ª ×§×˜×’×•×¨×™×™×”',0),(97761,2716,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„Î·Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚',0),(97762,2716,'zh','ä¿å­˜ç¼–è¾‘çš„åˆ†ç±»\r\n',0),(97763,2716,'sv','Spara redigera kategori',0),(97764,2716,'it','Salvare la modifica della categoria',0),(97765,2716,'tl','',0),(97766,2716,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(97767,2716,'hi','à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(97768,2716,'ms','Simpan Edit kategori',0),(97769,2716,'ar','Ø­ÙØ¸ ØªØ­Ø±ÙŠØ± ÙØ¦Ø©',0),(97770,2716,'fr','Enregistrer Edit de catÃ©gorie',0),(97771,2716,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®ç·¨é›†ã‚’ä¿?å­˜',0),(97772,2716,'pt','Salvar Editar Categoria',0),(97773,2716,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(97774,2716,'es','Guardar Editar CategorÃ­a',0),(97775,2716,'de','Bearbeiten der Kategorie speichern',0),(97776,2716,'en','Save Edit of Category',0),(97777,2717,'is','',0),(97778,2717,'dr','Ø°Ø®ÙŠØ±Ù‡  ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±Ø¢ÙŠÙ†Ø¯ ',0),(97779,2717,'pr','Ø°Ø®ÙŠØ±Ù‡  ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±Ø¢ÙŠÙ†Ø¯ ',0),(97780,2717,'tr','DÃ¼zenleme iÅŸlemi kaydetme',0),(97781,2717,'pl','Zapisz edycja procesu',0),(97782,2717,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(97783,2717,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ø¹Ù…Ù„ Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97784,2717,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ°',0),(97785,2717,'vi','Sao LÆ°u QuÃ¡ TrÃ¬nh Chá»‰nh Sá»­a',0),(97786,2717,'af','Stoor Redigering van Proses',0),(97787,2717,'ro','Salva Edit procesului de',0),(97788,2717,'et','Salvestada Muuda protsessi',0),(97789,2717,'si','Shranite urejanje procesa',0),(97790,2717,'ba','Simpan Edit proses',0),(97791,2717,'nl','Opslaan van bewerken van proces',0),(97792,2717,'fi','Tallenna muokkaus prosessi',0),(97793,2717,'no','Lagre redigere av prosessen',0),(97794,2717,'da','Gemme redigering af processen',0),(97795,2717,'ko','ì €ìž¥ í”„ë¡œì„¸ìŠ¤ì˜ íŽ¸ì§‘',0),(97796,2717,'he','×©×ž×•×¨ ×¢×¨×™×›×ª ×ª×”×œ×™×š',0),(97797,2717,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„Î·Ï‚ Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±Ï‚',0),(97798,2717,'zh','ä¿å­˜ç¼–è¾‘è¿‡ç¨‹\r\n',0),(97799,2717,'sv','Spara redigera av processen',0),(97800,2717,'it','Salvare la modifica del processo',0),(97801,2717,'tl','',0),(97802,2717,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;',0),(97803,2717,'hi','à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤•à¥€ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾',0),(97804,2717,'ms','Simpan Edit proses',0),(97805,2717,'ar','ØªØ­Ø±ÙŠØ± Ø¹Ù…Ù„ÙŠØ© Ø­ÙØ¸',0),(97806,2717,'fr','Enregistrer Edit du processus',0),(97807,2717,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã?®ç·¨é›†ã‚’ä¿?å­˜',0),(97808,2717,'pt','Salvar editar do processo',0),(97809,2717,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ°',0),(97810,2717,'es','Guardar Editar Proceso',0),(97811,2717,'de','Bearbeiten des Prozesses zu speichern',0),(97812,2717,'en','Save Edit of Process',0),(97813,2718,'is','',0),(97814,2718,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø«Ø¨Øª ',0),(97815,2718,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø«Ø¨Øª ',0),(97816,2718,'tr','Girdiyi kaydetmek',0),(97817,2718,'pl','Zapisz wpis',0),(97818,2718,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð·Ð°Ð¿Ð¸Ñ',0),(97819,2718,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97820,2718,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(97821,2718,'vi','Sao LÆ°u Entry',0),(97822,2718,'af','Stoor Inskrywing',0),(97823,2718,'ro','SalvaÅ£i intrare',0),(97824,2718,'et','Salvesta',0),(97825,2718,'si','Shranite vnos',0),(97826,2718,'ba','Menyimpan entri',0),(97827,2718,'nl','Vermelding opslaan',0),(97828,2718,'fi','Tallenna merkintÃ¤',0),(97829,2718,'no','Lagre oppfÃ¸ringen',0),(97830,2718,'da','Gem post',0),(97831,2718,'ko','í•­ëª© ì €ìž¥',0),(97832,2718,'he','×©×ž×•×¨ ×¨×©×•×ž×”',0),(97833,2718,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î·Î½ ÎµÎ³Î³ÏÎ±Ï†Î®',0),(97834,2718,'zh','ä¿å­˜æ¡ç›®\r\n',0),(97835,2718,'sv','Spara posten',0),(97836,2718,'it','Salvare la voce',0),(97837,2718,'tl','',0),(97838,2718,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(97839,2718,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¬à¤šà¤¾à¤¨à¥‡',0),(97840,2718,'ms','Simpan entri',0),(97841,2718,'ar','Ø­ÙØ¸ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(97842,2718,'fr','Enregistrer l\'entrÃ©e',0),(97843,2718,'jp','ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?®ä¿?å­˜',0),(97844,2718,'pt','Salvar a entrada',0),(97845,2718,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(97846,2718,'es','Guardar Entrada',0),(97847,2718,'de','Eintrag speichern',0),(97848,2718,'en','Save Entry',0),(97849,2719,'is','',0),(97850,2719,'dr','Ø°Ø®ÙŠØ±Ù‡ ÙØ§ÙƒØªÙˆØ±',0),(97851,2719,'pr','Ø°Ø®ÙŠØ±Ù‡ ÙØ§ÙƒØªÙˆØ±',0),(97852,2719,'tr','Fatura kaydetme',0),(97853,2719,'pl','ZapisaÄ‡ faktury',0),(97854,2719,'bg','Ð—Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(97855,2719,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97856,2719,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(97857,2719,'vi','Sao lÆ°u hÃ³a Ä‘Æ¡n',0),(97858,2719,'af','Stoor Faktuur',0),(97859,2719,'ro','Salva factura',0),(97860,2719,'et','Salvesta arve',0),(97861,2719,'si','Shranite raÄun',0),(97862,2719,'ba','Simpan faktur',0),(97863,2719,'nl','Factuur opslaan',0),(97864,2719,'fi','Tallenna lasku',0),(97865,2719,'no','Lagre fakturaen',0),(97866,2719,'da','Gemme fakturaen',0),(97867,2719,'ko','ì†¡ìž¥ ì €ìž¥',0),(97868,2719,'he','×©×ž×•×¨ ×—×©×‘×•× ×™×ª',0),(97869,2719,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(97870,2719,'zh','ä¿å­˜å‘ç¥¨\r\n',0),(97871,2719,'sv','Spara fakturan',0),(97872,2719,'it','Salvare la fattura',0),(97873,2719,'tl','',0),(97874,2719,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(97875,2719,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(97876,2719,'ms','Menyimpan invois',0),(97877,2719,'ar','Ø­ÙØ¸ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(97878,2719,'fr','Enregistrer la facture',0),(97879,2719,'jp','è«‹æ±‚æ›¸ã‚’ä¿?å­˜',0),(97880,2719,'pt','Salvar a factura',0),(97881,2719,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚',0),(97882,2719,'es','Guardar Factura',0),(97883,2719,'de','Rechnung speichern',0),(97884,2719,'en','Save Invoice',0),(97885,2720,'is','',0),(97886,2720,'dr','Ø°Ø®ÙŠØ±Ù‡ Ù…Ø­Ù„',0),(97887,2720,'pr','Ø°Ø®ÙŠØ±Ù‡ Ù…Ø­Ù„',0),(97888,2720,'tr','Kaydetme konumu',0),(97889,2720,'pl','Zapisz poÅ‚oÅ¼enie',0),(97890,2720,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(97891,2720,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…Ø­ÙÙˆØ¸',0),(97892,2720,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ñ‡ÑƒÐ²Ð°ÑšÐµ',0),(97893,2720,'vi','Sao lÆ°u vá»‹ trÃ­',0),(97894,2720,'af','Stoor Ligging',0),(97895,2720,'ro','SalvaÅ£i locaÅ£ie',0),(97896,2720,'et','Salvesta asukohta',0),(97897,2720,'si','Mesto shranjevanja',0),(97898,2720,'ba','Menyimpan lokasi',0),(97899,2720,'nl','Locatie opslaan',0),(97900,2720,'fi','Tallenna sijainti',0),(97901,2720,'no','Lagre sted',0),(97902,2720,'da','Gem placering',0),(97903,2720,'ko','ì €ìž¥ ìœ„ì¹˜',0),(97904,2720,'he','×©×ž×•×¨ ×ž×™×§×•×',0),(97905,2720,'el','ÎÎ± Î±Ï€Î¿Î¸Î·ÎºÎµÏÎµÏ„Î±Î¹ Î· Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(97906,2720,'zh','ä¿å­˜ä½ç½®\r\n',0),(97907,2720,'sv','Spara plats',0),(97908,2720,'it','Salva posizione',0),(97909,2720,'tl','',0),(97910,2720,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(97911,2720,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(97912,2720,'ms','Simpan lokasi',0),(97913,2720,'ar','Ø­ÙØ¸ Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(97914,2720,'fr','Emplacement d\'enregistrement',0),(97915,2720,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®ä¿?å­˜',0),(97916,2720,'pt','Salvar a localizaÃ§Ã£o',0),(97917,2720,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(97918,2720,'es','UbicaciÃ³n de Guardar',0),(97919,2720,'de','Speicherort speichern',0),(97920,2720,'en','Save Location',0),(97921,2721,'is','',0),(97922,2721,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª Ø¬Ø¯ÙŠØ¯ ',0),(97923,2721,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª Ø¬Ø¯ÙŠØ¯ ',0),(97924,2721,'tr','Yeni ayrÄ±ntÄ± Kaydet',0),(97925,2721,'pl','Zapisz nowe szczegÃ³Å‚y',0),(97926,2721,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(97927,2721,'ur','Ù†Ø¦ÛŒ ØªÙØµÛŒÙ„ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97928,2721,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð´ÐµÑ‚Ð°Ñ™',0),(97929,2721,'vi','Sao lÆ°u chi tiáº¿t má»›i',0),(97930,2721,'af','Stoor Nuwe Detail',0),(97931,2721,'ro','SalvaÅ£i nou detaliu',0),(97932,2721,'et','Salvesta uus info',0),(97933,2721,'si','Shranite nove podrobnosti',0),(97934,2721,'ba','Menyimpan Detail baru',0),(97935,2721,'nl','Nieuwe Detail opslaan',0),(97936,2721,'fi','Tallenna uusi yksityiskohta',0),(97937,2721,'no','Lagre nye detaljer',0),(97938,2721,'da','Gem nye detaljer',0),(97939,2721,'ko','ìƒˆë¡œìš´ ì„¸ë¶€ ì‚¬í•­ ì €ìž¥',0),(97940,2721,'he','×©×ž×•×¨ ×¤×¨×˜ ×—×“×©',0),(97941,2721,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Î½Î­Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(97942,2721,'zh','ä¿å­˜æ–°çš„ç»†èŠ‚\r\n',0),(97943,2721,'sv','Spara nya detalj',0),(97944,2721,'it','Salvare il nuovo dettaglio',0),(97945,2721,'tl','',0),(97946,2721,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3651;&#3627;&#3617;&#3656;',0),(97947,2721,'hi','à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(97948,2721,'ms','Simpan butiran baru',0),(97949,2721,'ar','Ø­ÙØ¸ ØªÙØ§ØµÙŠÙ„ Ø¬Ø¯ÙŠØ¯Ø©',0),(97950,2721,'fr','Enregistrez le nouveau dÃ©tail',0),(97951,2721,'jp','æ–°è¦?è©³ç´°ã?®ä¿?å­˜',0),(97952,2721,'pt','Salvar novo detalhe',0),(97953,2721,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð´ÐµÑ‚Ð°Ð»ÑŒ',0),(97954,2721,'es','Guardar Nuevo Detalle',0),(97955,2721,'de','Neue Details zu speichern',0),(97956,2721,'en','Save New Detail',0),(97957,2722,'is','',0),(97958,2722,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø´Ù…Ø§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ ÙØ§ÙƒØªÙˆØ±',0),(97959,2722,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø´Ù…Ø§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ ÙØ§ÙƒØªÙˆØ±',0),(97960,2722,'tr','Yeni Stok sayÄ±mÄ± Kaydet',0),(97961,2722,'pl','Zapisz nowe inwentaryzacji',0),(97962,2722,'bg','Ð—Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(97963,2722,'ur','Ù†Ø¦Û’ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ø§ Ø´Ù…Ø§Ø± Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(97964,2722,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð½Ð¾Ð²Ð¾Ð³ Ð¿Ð¾Ð¿Ð¸ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(97965,2722,'vi','Sao LÆ°u Sá»‘ LÆ°á»£ng hÃ ng trong kho má»›i',0),(97966,2722,'af','Stoor Nuwe Voorraad Telling',0),(97967,2722,'ro','SalvaÅ£i nou inventar conta',0),(97968,2722,'et','Salvesta uus inventuuri lugemine',0),(97969,2722,'si','Shranite nove inventura',0),(97970,2722,'ba','Simpan baru menghitung persediaan',0),(97971,2722,'nl','Nieuwe inventaris tellen opslaan',0),(97972,2722,'fi','Tallenna uusi varaston inventointi',0),(97973,2722,'no','Lagre nye Lageropptelling',0),(97974,2722,'da','Gem nye lageroptÃ¦lling',0),(97975,2722,'ko','ìƒˆë¡œìš´ ìž¬ê³  ì¹´ìš´íŠ¸ë¥¼ ì €ìž¥',0),(97976,2722,'he','×œ×”×¦×™×œ ××ª ×¡×¤×™×¨×ª ×”×ž×œ××™ ×”×—×“×©',0),(97977,2722,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Î½Î­Î± ÎºÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ· Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(97978,2722,'zh','ä¿å­˜æ–°çš„åº“å­˜ç›˜ç‚¹\r\n',0),(97979,2722,'sv','Spara ny lagerinventering',0),(97980,2722,'it','Salvare il nuovo conte di inventario',0),(97981,2722,'tl','',0),(97982,2722,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3609;&#3633;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(97983,2722,'hi','à¤¨à¤ˆ à¤¸à¥‚à¤šà¥€ à¤—à¤¿à¤¨à¤¤à¥€ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(97984,2722,'ms','Simpan pengiraan inventori baru',0),(97985,2722,'ar','Ø­ÙØ¸ Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(97986,2722,'fr','Enregistrer le nouveau comte de l\'inventaire',0),(97987,2722,'jp','æ–°è¦?æ£šå?¸ã‚’ä¿?å­˜',0),(97988,2722,'pt','Salvar a nova contagem de inventÃ¡rio',0),(97989,2722,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(97990,2722,'es','Guardar Nuevo Conteo de Inventario',0),(97991,2722,'de','Speichern neue InventurzÃ¤hlung',0),(97992,2722,'en','Save New Inventory Count',0),(97993,2723,'is','',0),(97994,2723,'dr','Ø°Ø®ÙŠØ±Ù‡ Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ',0),(97995,2723,'pr','Ø°Ø®ÙŠØ±Ù‡ Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ',0),(97996,2723,'tr','Pasta Kaydet',0),(97997,2723,'pl','Zapisz Pie',0),(97998,2723,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð¿Ð°Ð¹',0),(97999,2723,'ur','Ù¾Ø§Ø¦ÛŒ Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(98000,2723,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¿Ð¸Ñ‚Ñƒ',0),(98001,2723,'vi','Sao lÆ°u á»‘ng ',0),(98002,2723,'af','Stoor Pie',0),(98003,2723,'ro','SalvaÅ£i Pie',0),(98004,2723,'et','Salvesta pirukas',0),(98005,2723,'si','Shranite Pie',0),(98006,2723,'ba','Simpan Pie',0),(98007,2723,'nl','Opslaan van Pie',0),(98008,2723,'fi','Tallenna Pie',0),(98009,2723,'no','Lagre Pie',0),(98010,2723,'da','Gemme Pie',0),(98011,2723,'ko','íŒŒì´ ì €ìž¥',0),(98012,2723,'he','×œ×”×¦×™×œ ××ª ×¤××™',0),(98013,2723,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï€Î¯Ï„Î±',0),(98014,2723,'zh','ä¿å­˜æ´¾\r\n',0),(98015,2723,'sv','Spara paj',0),(98016,2723,'it','Salvare Pie',0),(98017,2723,'tl','',0),(98018,2723,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3594;&#3636;&#3657;&#3609;&#3626;&#3656;&#3623;&#3609;&#3649;&#3612;&#3609;&#3616;&#3641;&#3617;&#3636;&#3623;&#3591;&#3585;&#3621;&#3617;',0),(98019,2723,'hi','à¤¬à¤šà¤¾ à¤ªà¤¾à¤ˆ',0),(98020,2723,'ms','Simpan pai',0),(98021,2723,'ar','Ø­ÙØ¸ Ø§Ù„Ù…Ø®Ø·Ø· Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠ',0),(98022,2723,'fr','Ã‰conomisez Pie',0),(98023,2723,'jp','ãƒ‘ã‚¤ã?®ä¿?å­˜',0),(98024,2723,'pt','Salvar torta',0),(98025,2723,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¿Ð¸Ñ€Ð¾Ð³',0),(98026,2723,'es','Guardar Pie',0),(98027,2723,'de','Pie zu speichern',0),(98028,2723,'en','Save Pie',0),(98029,2724,'is','',0),(98030,2724,'dr','Ø°Ø®ÙŠØ±Ù‡ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(98031,2724,'pr','Ø°Ø®ÙŠØ±Ù‡ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(98032,2724,'tr','Teklif Kaydet',0),(98033,2724,'pl','Zapisz cytat',0),(98034,2724,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(98035,2724,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(98036,2724,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(98037,2724,'vi','Sao lÆ°u bÃ¡o giÃ¡',0),(98038,2724,'af','Stoor Kwotasie',0),(98039,2724,'ro','SalvaÅ£i citat',0),(98040,2724,'et','Salvesta Quote',0),(98041,2724,'si','Shranite citat',0),(98042,2724,'ba','Simpan kutipan',0),(98043,2724,'nl','Prijsopgave opslaan',0),(98044,2724,'fi','Tallenna tarjous',0),(98045,2724,'no','Lagre sitat',0),(98046,2724,'da','Spar tilbud',0),(98047,2724,'ko','ê²¬ì  ì €ìž¥',0),(98048,2724,'he','×©×ž×•×¨ ×”×¦×¢×ª ×ž×—×™×¨',0),(98049,2724,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÏ„Îµ Ï„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(98050,2724,'zh','ä¿å­˜æŠ¥ä»·\r\n',0),(98051,2724,'sv','Spara citat',0),(98052,2724,'it','Salvare il preventivo',0),(98053,2724,'tl','',0),(98054,2724,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(98055,2724,'hi','à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(98056,2724,'ms','Simpan Quote',0),(98057,2724,'ar','Ø­ÙØ¸ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(98058,2724,'fr','Enregistrez Devis',0),(98059,2724,'jp','è¦‹ç©?ã‚‚ã‚Šã?®ä¿?å­˜',0),(98060,2724,'pt','Salvar a citaÃ§Ã£o',0),(98061,2724,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(98062,2724,'es','Guardar CotizaciÃ³n',0),(98063,2724,'de','Zitat speichern',0),(98064,2724,'en','Save Quote',0),(98065,2725,'is','',0),(98066,2725,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„',0),(98067,2725,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„',0),(98068,2725,'tr','Nakliye bilgileri kaydetmek',0),(98069,2725,'pl','Zapisywanie, wysyÅ‚anie informacji',0),(98070,2725,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(98071,2725,'ur','Ø´Ù¾Ù†Ú¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(98072,2725,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ Ð˜Ð½Ñ„Ð¾',0),(98073,2725,'vi','Sao lÆ°u ThÃ´ng Tin váº­n chuyá»ƒn',0),(98074,2725,'af','Stoor Versendings Inligting',0),(98075,2725,'ro','Salva informaÅ£ii de transport maritim',0),(98076,2725,'et','Salvesta tarneinfo',0),(98077,2725,'si','Shranite Shipping Info',0),(98078,2725,'ba','Menyimpan Info pengiriman',0),(98079,2725,'nl','Verzending Info opslaan',0),(98080,2725,'fi','Tallenna toimitustiedot',0),(98081,2725,'no','Lagre Shipping Info',0),(98082,2725,'da','Spar Shipping Info',0),(98083,2725,'ko','ë°°ì†¡ ì •ë³´ ì €ìž¥',0),(98084,2725,'he','×©×ž×•×¨ ×ž×™×“×¢ ×ž×©×œ×•×—',0),(98085,2725,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Î½Î±Ï…Ï„Î¹Î»Î¹Î±ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(98086,2725,'zh','ä¿å­˜è£…è¿ä¿¡æ¯\r\n',0),(98087,2725,'sv','Spara Leveransinfo',0),(98088,2725,'it','Salvare le informazioni di spedizione',0),(98089,2725,'tl','',0),(98090,2725,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(98091,2725,'hi','à¤ªà¥‹à¤¤ à¤ªà¤°à¤¿à¤µà¤¹à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(98092,2725,'ms','Simpan Info penghantaran',0),(98093,2725,'ar','Ø­ÙØ¸ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø­Ù†',0),(98094,2725,'fr','Enregistrer les infos d\'expÃ©dition',0),(98095,2725,'jp','é…?é€?æƒ…å ±ã?®ä¿?å­˜',0),(98096,2725,'pt','Salvar informaÃ§Ã£o de envio',0),(98097,2725,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ, Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¿Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐµ',0),(98098,2725,'es','Guardar Info de EnvÃ­o',0),(98099,2725,'de','Sparen Sie Versandkosten',0),(98100,2725,'en','Save Shipping Info',0),(98101,2726,'is','',0),(98102,2726,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù…Ø­Ù„',0),(98103,2726,'pr','Ø°Ø®ÙŠØ±Ù‡ / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„',0),(98104,2726,'tr','Kaydet/konumunu gÃ¼ncelleÅŸtirme',0),(98105,2726,'pl','Zapisz/zaktualizuj lokalizacji',0),(98106,2726,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸/ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð¹ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(98107,2726,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(98108,2726,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(98109,2726,'vi','Sao LÆ°u/Cáº­p Nháº­t Äá»‹a Äiá»ƒm',0),(98110,2726,'af','Stoor/Opdateer Ligging',0),(98111,2726,'ro','Salvare/actualizare locaÅ£ie',0),(98112,2726,'et','Salvesta/Uuenda asukoht',0),(98113,2726,'si','Shrani/posodobi lokacijo',0),(98114,2726,'ba','Simpan/Perbarui lokasi',0),(98115,2726,'nl','Locatie opslaan/bijwerken',0),(98116,2726,'fi','Tallenna/PÃ¤ivitÃ¤ sijainti',0),(98117,2726,'no','Lagre/Oppdater plassering',0),(98118,2726,'da','Gem/Opdater placering',0),(98119,2726,'ko','ì €ìž¥/ì—…ë°ì´íŠ¸ ìœ„ì¹˜',0),(98120,2726,'he','×©×ž×•×¨/×¢×“×›×Ÿ ×ž×™×§×•×',0),(98121,2726,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(98122,2726,'zh','ä¿å­˜/æ›´æ–°ä½ç½®\r\n',0),(98123,2726,'sv','Spara/uppdatera lÃ¤ge',0),(98124,2726,'it','Salva/aggiornamento posizione',0),(98125,2726,'tl','',0),(98126,2726,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(98127,2726,'hi','à¤¸à¤¹à¥‡à¤œà¥‡à¤‚/à¤¸à¥à¤¥à¤¾à¤¨ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(98128,2726,'ms','Simpan/Kemaskini lokasi',0),(98129,2726,'ar','Ø­ÙØ¸/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(98130,2726,'fr','Enregistrer/mettre Ã  jour emplacement',0),(98131,2726,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®ä¿?å­˜/æ›´æ–°',0),(98132,2726,'pt','Salvar/atualizar localizaÃ§Ã£o',0),(98133,2726,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(98134,2726,'es','Guardar/Actualizar UbicaciÃ³n',0),(98135,2726,'de','Aktualisieren Sie speichern/Lage',0),(98136,2726,'en','Save/Update Location',0),(98137,2727,'is','',0),(98138,2727,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø´Ø±ÙƒØª Ù…Ø­Ø¯ÙˆØ¯ Ø§Ø³Øª â€“ Ø´Ø±ÙƒØª Ø§Ø¶Ø§ÙÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(98139,2727,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø´Ø±ÙƒØª Ù…Ø­Ø¯ÙˆØ¯ Ø§Ø³Øª â€“ Ø´Ø±ÙƒØª Ø§Ø¶Ø§ÙÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(98140,2727,'tr','Ek ÅŸirket eklenemez.',0),(98141,2727,'pl','Nie moÅ¼na dodaÄ‡ dodatkowe firmy.',0),(98142,2727,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð´Ð¾Ð±Ð°Ð²ÑÑ‚ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ.',0),(98143,2727,'ur','Ø§Ø¶Ø§ÙÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ Û”',0),(98144,2727,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°.',0),(98145,2727,'vi','KhÃ´ng thÃªm Ä‘Æ°á»£c cty',0),(98146,2727,'af','Addisionele Onderneming kan nie bygevoeg word nie.',0),(98147,2727,'ro','Imposibil de adÄƒugat suplimentare companiei.',0),(98148,2727,'et','TÃ¤iendav firma ei saa lisada.',0),(98149,2727,'si','Dodatna podjetja ni mogoÄe dodati.',0),(98150,2727,'ba','Tambahan perusahaan tidak dapat ditambahkan.',0),(98151,2727,'nl','Aanvullende bedrijf kan niet worden toegevoegd.',0),(98152,2727,'fi','LisÃ¤ksi yritys ei voi lisÃ¤tÃ¤.',0),(98153,2727,'no','Kan ikke legge ytterligere selskapet.',0),(98154,2727,'da','Ekstra selskab kan ikke tilfÃ¸jes.',0),(98155,2727,'ko','ì¶”ê°€ì ì¸ íšŒì‚¬ë¥¼ ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(98156,2727,'he','.×œ× × ×™×ª×Ÿ ×œ×”×•×¡×™×£ ×—×‘×¨×” × ×•×¡×¤×ª',0),(98157,2727,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î´ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸Î¿ÏÎ½.',0),(98158,2727,'zh','å…¶ä»–å…¬å¸ä¸èƒ½æ·»åŠ ã€‚\r\n',0),(98159,2727,'sv','Ytterligare fÃ¶retag kan inte lÃ¤ggas till.',0),(98160,2727,'it','Non Ã¨ possibile aggiungere ulteriori societÃ .',0),(98161,2727,'tl','',0),(98162,2727,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3607;&#3635;&#3652;&#3604;&#3657;',0),(98163,2727,'hi','à¤…à¤ªà¤° à¤•à¤‚à¤ªà¤¨à¥€ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾à¥¤',0),(98164,2727,'ms','Tambahan Syarikat tidak boleh ditambah.',0),(98165,2727,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙƒØ© Ø¥Ø¶Ø§ÙÙŠØ©.',0),(98166,2727,'fr','Compagnie complÃ©mentaire ne peut Ãªtre ajoutÃ©e.',0),(98167,2727,'jp','è¿½åŠ ä¼šç¤¾ã?Œè¿½åŠ ã?§ã??ã?¾ã?›ã‚“',0),(98168,2727,'pt','Empresa adicionais nÃ£o podem ser adicionada.',0),(98169,2727,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°.',0),(98170,2727,'es','Empresa Adicional no se puede agregar',0),(98171,2727,'de','ZusÃ¤tzliche Unternehmen kann nicht hinzugefÃ¼gt werden.',0),(98172,2727,'en','Additional Company cannot be added.',0),(98173,2728,'is','',0),(98174,2728,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø®Ø±ÙŠØ¯Ø§Ø± Ù…Ø­Ø¯ÙˆØ¯ Ø§Ø³Øª â€“ Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ø¶Ø§ÙÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(98175,2728,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø®Ø±ÙŠØ¯Ø§Ø± Ù…Ø­Ø¯ÙˆØ¯ Ø§Ø³Øª â€“ Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ø¶Ø§ÙÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(98176,2728,'tr','MÃ¼ÅŸteri eklenemez.',0),(98177,2728,'pl','Nie moÅ¼na dodaÄ‡ klienta.',0),(98178,2728,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½.',0),(98179,2728,'ur','Ú¯Ø§ÛÚ© Ú©Ùˆ Ø´Ø§Ù…Ù„ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§Ø³Ú©ØªØ§ Û”',0),(98180,2728,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ ÐºÑƒÐ¿Ñ†Ð°.',0),(98181,2728,'vi','KhÃ´ng thÃªm Ä‘Æ°á»£c khÃ¡ch hÃ ng',0),(98182,2728,'af','KliÃ«nt kan nie bygevoeg word nie.',0),(98183,2728,'ro','Imposibil de adÄƒugat clientului.',0),(98184,2728,'et','Klient ei saa lisada.',0),(98185,2728,'si','Kupca ni mogoÄe dodati.',0),(98186,2728,'ba','Pelanggan tidak dapat ditambahkan.',0),(98187,2728,'nl','Klant kan niet worden toegevoegd.',0),(98188,2728,'fi','Asiakas ei voi lisÃ¤tÃ¤.',0),(98189,2728,'no','Kunden kan ikke legges til.',0),(98190,2728,'da','Kunden kan ikke tilfÃ¸jes.',0),(98191,2728,'ko','ê³ ê°ì€ ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(98192,2728,'he','.×œ× × ×™×ª×Ÿ ×œ×”×•×¡×™×£ ×œ×§×•×—',0),(98193,2728,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸Î¿ÏÎ½.',0),(98194,2728,'zh','å®¢æˆ·ä¸èƒ½æ·»åŠ ã€‚\r\n',0),(98195,2728,'sv','Kunden kan inte lÃ¤ggas till.',0),(98196,2728,'it','Cliente non puÃ² essere aggiunto.',0),(98197,2728,'tl','',0),(98198,2728,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3614;&#3636;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3652;&#3604;&#3657;',0),(98199,2728,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾à¥¤',0),(98200,2728,'ms','Pelanggan tidak boleh ditambah.',0),(98201,2728,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(98202,2728,'fr','Client ne peut pas Ãªtre ajoutÃ©.',0),(98203,2728,'jp','é¡§å®¢ã?Œè¿½åŠ ã?§ã??ã?¾ã?›ã‚“',0),(98204,2728,'pt','Cliente nÃ£o pode ser adicionado.',0),(98205,2728,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹.',0),(98206,2728,'es','Cliente no se puede agregar',0),(98207,2728,'de','Kunde kann nicht hinzugefÃ¼gt werden.',0),(98208,2728,'en','Customer cannot be added.',0),(98209,2729,'is','',0),(98210,2729,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù…Ø­Ø¯ÙˆØ¯ Ø§Ø³Øª â€“ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø§Ø¶Ø§ÙÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(98211,2729,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù…Ø­Ø¯ÙˆØ¯ Ø§Ø³Øª â€“ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø§Ø¶Ø§ÙÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(98212,2729,'tr','Ã‡alÄ±ÅŸan eklenemez.',0),(98213,2729,'pl','Nie moÅ¼na dodaÄ‡ pracownika.',0),(98214,2729,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½.',0),(98215,2729,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ Û”',0),(98216,2729,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³.',0),(98217,2729,'vi','KhÃ´ng thÃªm Ä‘Æ°á»£c nhÃ¢n viÃªn',0),(98218,2729,'af','Werknemer kan nie bygevoeg word nie.',0),(98219,2729,'ro','Imposibil de adÄƒugat angajat.',0),(98220,2729,'et','TÃ¶Ã¶taja ei saa lisada.',0),(98221,2729,'si','Delavca ni mogoÄe dodati.',0),(98222,2729,'ba','Karyawan tidak dapat ditambahkan.',0),(98223,2729,'nl','Werknemer kan niet worden toegevoegd.',0),(98224,2729,'fi','TyÃ¶ntekijÃ¤ ei voi lisÃ¤tÃ¤.',0),(98225,2729,'no','Ansatte kan ikke legges til.',0),(98226,2729,'da','Medarbejderen kan ikke tilfÃ¸jes.',0),(98227,2729,'ko','ì§ì›ì„ ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(98228,2729,'he','.×œ× × ×™×ª×Ÿ ×œ×”×•×¡×™×£ ×¢×•×‘×“',0),(98229,2729,'el','Î•ÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸Î¿ÏÎ½.',0),(98230,2729,'zh','å‘˜å·¥ä¸èƒ½æ·»åŠ ã€‚\r\n',0),(98231,2729,'sv','Medarbetare kan inte lÃ¤ggas till.',0),(98232,2729,'it','Dipendente non puÃ² essere aggiunto.',0),(98233,2729,'tl','',0),(98234,2729,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3652;&#3604;&#3657;',0),(98235,2729,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾à¥¤',0),(98236,2729,'ms','Pekerja tidak boleh ditambah.',0),(98237,2729,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…ÙˆØ¸Ù.',0),(98238,2729,'fr','EmployÃ© ne peut pas Ãªtre ajoutÃ©.',0),(98239,2729,'jp','å¾“æ¥­å“¡ã?Œè¿½åŠ ã?§ã??ã?¾ã?›ã‚“',0),(98240,2729,'pt','Empregado nÃ£o pode ser adicionado.',0),(98241,2729,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹.',0),(98242,2729,'es','Empleado no se puede agregar',0),(98243,2729,'de','Mitarbeiter kann nicht hinzugefÃ¼gt werden.',0),(98244,2729,'en','Employee cannot be added.',0),(98245,2730,'is','',0),(98246,2730,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù…Ø­Ø¯ÙˆØ¯ Ø§Ø³Øª â€“ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(98247,2730,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù…Ø­Ø¯ÙˆØ¯ Ø§Ø³Øª â€“ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(98248,2730,'tr','Envanter Ã¶ÄŸe eklenemiyor.',0),(98249,2730,'pl','Nie moÅ¼na dodaÄ‡ elementu zapasÃ³w.',0),(98250,2730,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð² Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½.',0),(98251,2730,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ ÛÛ’ Û”',0),(98252,2730,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°.',0),(98253,2730,'vi','HÃ ng trong kho khÃ´ng xÃ³a Ä‘Æ°á»£c',0),(98254,2730,'af','Inventaris Item kan bygevoeg word.',0),(98255,2730,'ro','Imposibil de adÄƒugat element de inventar.',0),(98256,2730,'et','Laokauba ei saa lisada.',0),(98257,2730,'si','Zaloge elementa ni mogoÄe dodati.',0),(98258,2730,'ba','Persediaan barang tidak dapat ditambahkan.',0),(98259,2730,'nl','Inventaris object kan niet worden toegevoegd.',0),(98260,2730,'fi','NimikettÃ¤ ei voi lisÃ¤tÃ¤.',0),(98261,2730,'no','Kan ikke legge lagervare.',0),(98262,2730,'da','Lagervare kan ikke tilfÃ¸jes.',0),(98263,2730,'ko','ìž¬ê³  í•­ëª©ì„ ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(98264,2730,'he','.××™×Ÿ ××¤×©×¨×•×ª ×œ×”×•×¡×™×£ ×¤×¨×™×˜ ×ž×œ××™',0),(98265,2730,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸Î¿ÏÎ½.',0),(98266,2730,'zh','åº“å­˜ç‰©å“ä¸èƒ½æ·»åŠ ã€‚\r\n',0),(98267,2730,'sv','Lagerartikel kan inte lÃ¤ggas.',0),(98268,2730,'it','Articolo di magazzino non puÃ² essere aggiunto.',0),(98269,2730,'tl','',0),(98270,2730,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3652;&#3604;&#3657;',0),(98271,2730,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾à¥¤',0),(98272,2730,'ms','Inventori tidak boleh ditambah.',0),(98273,2730,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø¹Ù†ØµØ± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ø±Ø¯.',0),(98274,2730,'fr','Article en stock ne peuvent pas Ãªtre ajoutÃ©.',0),(98275,2730,'jp','åœ¨åº«å“?ç›®ã?Œè¿½åŠ ã?§ã??ã?¾ã?›ã‚“',0),(98276,2730,'pt','Item de estoque nÃ£o pode ser adicionado.',0),(98277,2730,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(98278,2730,'es','Item de Inventario no se puede agregar',0),(98279,2730,'de','Lagerartikel kann hinzugefÃ¼gt werden.',0),(98280,2730,'en','Inventory Item cannot be added.',0),(98281,2731,'is','',0),(98282,2731,'dr','1 â€“ Ø´Ù…Ø§ Ø§Ø² Ù…Ø­Ø¯ÙˆØ¯ÙŠØª ÛŒÙˆØ²Ø± ØªØ¬Ø§Ø±ØªÛŒ ÙØ±Ø§ØªØ± Ø±ÙØªÙ‡ Ø§ÙŠØ¯ ',0),(98283,2731,'pr','Ù…Ø­Ø¯ÙˆØ¯ÙŠØª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ 1 â€“ Ø´Ù…Ø§ Ø§Ø² Ù…Ø­Ø¯ÙˆØ¯ÙŠØª ÙƒØ§Ø±Ø¨Ø± ØªØ¬Ø§Ø±ÙŠ ÙØ±Ø§ØªØ± Ø±ÙØªÙ‡ Ø§ÙŠØ¯ ',0),(98284,2731,'tr','Ä°ÅŸ kullanÄ±cÄ±larÄ± iÃ§in sÄ±nÄ±rÄ± aÅŸtÄ±nÄ±z',0),(98285,2731,'pl','PrzekroczyÅ‚eÅ› limit dla uÅ¼ytkownikÃ³w biznesowych',0),(98286,2731,'bg','ÐÐ°Ð´Ð²Ð¸ÑˆÐ¸Ð»Ð¸ ÑÑ‚Ðµ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð·Ð° Ð±Ð¸Ð·Ð½ÐµÑ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(98287,2731,'ur','Ø¢Ù¾ Ú©Ø§Ø±ÙˆØ¨Ø§Ø±ÛŒ ØµØ§Ø±ÙÛŒÙ† Ú©Û’ Ù„Ø¦Û’ Ø­Ø¯ Ø³Û’ ØªØ¬Ø§ÙˆØ² Ú©Ø± Ú†Ú©Ø§ ÛÛ’',0),(98288,2731,'sr','ÐŸÑ€ÐµÐºÐ¾Ñ€Ð°Ñ‡Ð¸Ð»Ð¸ ÑÑ‚Ðµ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÑšÐµ Ð·Ð° Ð¿Ð¾ÑÐ»Ð¾Ð²Ð½Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐµ',0),(98289,2731,'vi','NgÆ°á»i sá»­ dá»¥ng dáº¡ng kinh doanh Ä‘Ã£ quÃ¡ háº¡n má»©c',0),(98290,2731,'af','Jy het die limiet vir besigheid gebruikers oorskry',0),(98291,2731,'ro','A fost depÄƒÈ™itÄƒ limita pentru utilizatorii de afaceri',0),(98292,2731,'et','Olete Ã¼letanud piirangu Ã¤rikasutajatele',0),(98293,2731,'si','Presegli ste omejitev za poslovne uporabnike',0),(98294,2731,'ba','Anda telah melebihi batas untuk pengguna bisnis',0),(98295,2731,'nl','U hebt de overschreden voor zakelijke gebruikers',0),(98296,2731,'fi','Olet ylittÃ¤nyt rajan yrityskÃ¤yttÃ¤jille',0),(98297,2731,'no','Du har overskredet grensen for forretningsbrukere',0),(98298,2731,'da','Du har overskredet grÃ¦nsen for Business-brugere',0),(98299,2731,'ko','ë¹„ì¦ˆë‹ˆìŠ¤ ì‚¬ìš©ìžë¥¼ ìœ„í•œ í•œê³„ë¥¼ ì´ˆê³¼ í–ˆìŠµë‹ˆë‹¤.',0),(98300,2731,'he','×—×¨×’×ª ×ž×ž×’×‘×œ×ª ×œ×ž×©×ª×ž×©×™× ×¢×¡×§×™×™×',0),(98301,2731,'el','ÎˆÏ‡ÎµÏ„Îµ Ï…Ï€ÎµÏÎ²ÎµÎ¯ Ï„Î¿ ÏŒÏÎ¹Î¿ Î³Î¹Î± Ï„Î¿Ï…Ï‚ ÎµÏ€Î¹Ï‡ÎµÎ¹ÏÎ·Î¼Î±Ï„Î¹ÎºÎ¿ÏÏ‚ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(98302,2731,'zh','æ‚¨å·²ç»è¶…è¿‡äº†å•†ä¸šç”¨æˆ·é™åˆ¶\r\n',0),(98303,2731,'sv','Du har Ã¶verskridit grÃ¤nsen fÃ¶r fÃ¶retagsanvÃ¤ndare',0),(98304,2731,'it','Hai superato il limite per gli utenti Business',0),(98305,2731,'tl','',0),(98306,2731,'th','&#3588;&#3640;&#3603;&#3617;&#3637;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3626;&#3641;&#3591;&#3585;&#3623;&#3656;&#3634;&#3586;&#3637;&#3604;&#3592;&#3635;&#3585;&#3633;&#3604;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(98307,2731,'hi','à¤†à¤ª à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤° à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥€à¤®à¤¾ à¤ªà¤¾à¤° à¤•à¤° à¤šà¥à¤•à¥‡ à¤¹à¥ˆà¤‚',0),(98308,2731,'ms','Anda telah melebihi had untuk pengguna perniagaan',0),(98309,2731,'ar','Ù„Ù‚Ø¯ ØªØ¬Ø§ÙˆØ²Øª Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† ÙÙŠ Ù‚Ø·Ø§Ø¹ Ø§Ù„Ø£Ø¹Ù…Ø§Ù„',0),(98310,2731,'fr','Vous avez dÃ©passÃ© la limite pour les utilisateurs professionnels',0),(98311,2731,'jp','ãƒ“ã‚¸ãƒ?ã‚¹ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®åˆ¶é™?ã‚’è¶…ã?ˆã?¾ã?—ã?Ÿ',0),(98312,2731,'pt','VocÃª excedeu o limite para usuÃ¡rios de negÃ³cios',0),(98313,2731,'ru','Ð’Ñ‹ Ð¿Ñ€ÐµÐ²Ñ‹ÑÐ¸Ð»Ð¸ Ð»Ð¸Ð¼Ð¸Ñ‚ Ð´Ð»Ñ Ð±Ð¸Ð·Ð½ÐµÑ-Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(98314,2731,'es','Se excediÃ³ el limite para usuarios de Negocios',0),(98315,2731,'de','Sie haben das Limit fÃ¼r GeschÃ¤ftsanwender Ã¼berschritten.',0),(98316,2731,'en','You have exceeded the limit for Business users',0),(98317,2732,'is','',0),(98318,2732,'dr','2-  Ù„Ø·ÙØ§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ / Ø«Ø¨Øª Ù‡Ø§ÙŠ(ÙˆØ±ÙˆØ¯ÙŠ) Ø¯ÙŠÚ¯Ø± Ø±Ø§ ØºÙŠØ± ÙØ¹Ø§Ù„ ÙƒÙ†ÙŠØ¯ ',0),(98319,2732,'pr','Ù…Ø­Ø¯ÙˆØ¯ÙŠØª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ 2-  Ù„Ø·ÙØ§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ / Ø«Ø¨Øª Ù‡Ø§ÙŠ(ÙˆØ±ÙˆØ¯ÙŠ) Ø¯ÙŠÚ¯Ø± Ø±Ø§ ØºÙŠØ± ÙØ¹Ø§Ù„ ÙƒÙ†ÙŠØ¯ ',0),(98320,2732,'tr','LÃ¼tfen Sil/diÄŸer giriÅŸleri veya aramayÄ± devre dÄ±ÅŸÄ± bÄ±rakma',0),(98321,2732,'pl','ProszÄ™ usunÄ…Ä‡/Dezaktywuj inne wpisy lub zadzwoÅ„',0),(98322,2732,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ/Ð¸Ð½Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ‚ Ð´Ñ€ÑƒÐ³Ð¸ Ð²Ð¿Ð¸ÑÐ²Ð°Ð½Ð¸Ñ Ð¸Ð»Ð¸ Ð¿Ð¾Ð²Ð¸ÐºÐ²Ð°Ð½Ðµ',0),(98323,2732,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø­Ø°Ù/Ø¯ÛŒÚ¯Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª ÛŒØ§ Ú©Ø§Ù„ Ø§Ù†ÛŒÚ©Ù¹Ø§ÙˆØ§Ù¹ÛŒ',0),(98324,2732,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸/Ð¸ÑÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¸Ð»Ð¸ Ð¿Ð¾Ð·Ð¸Ð²',0),(98325,2732,'vi','Vui lÃ²ng xÃ³a/khÃ´ng kÃ­ch hoáº¡t cÃ¡c bÃºt toÃ¡n hay cuá»™c gá»i khÃ¡c',0),(98326,2732,'af','Asseblief skrap/deaktiveer ander inskrywings of oproep',0),(98327,2732,'ro','VÄƒ rugÄƒm sÄƒ ÅŸtergeÅ£i/inactiva alte intrÄƒri sau apel',0),(98328,2732,'et','Palun Kustuta/inaktiveerimiseks muid kirjeid vÃµi kÃµne',0),(98329,2732,'si','Prosim izbrisati/Deaktiviraj druge postavke ali klic',0),(98330,2732,'ba','Harap menghapus/menonaktifkan entri lain atau panggilan',0),(98331,2732,'nl','Gelieve te verwijderen/inactivering van andere posten of bel',0),(98332,2732,'fi','Ota Poista tai poista kÃ¤ytÃ¶stÃ¤ muut merkinnÃ¤t tai soita',0),(98333,2732,'no','Vennligst slette/deaktivere andre oppfÃ¸ringer eller samtale',0),(98334,2732,'da','Venligst slette/inaktivere andre poster eller ring',0),(98335,2732,'ko','ì œë°œ ì‚­ì œ/ë¹„í™œì„±í™” ë‹¤ë¥¸ í•­ëª© ë˜ëŠ” ì „í™”',0),(98336,2732,'he','× × ×ž×—×§/×ž×©×‘×™×ª×™× ×¢×¨×›×™× ××—×¨×™× ××• ×œ×”×ª×§×©×¨',0),(98337,2732,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Î”Î¹Î±Î³ÏÎ±Ï†Î®/Î±Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î¬Î»Î»ÎµÏ‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î® ÎºÎ»Î®ÏƒÎ·',0),(98338,2732,'zh','è¯·åˆ é™¤/ç­æ´»å…¶ä»–æ¡ç›®æˆ–è‡´ç”µ\r\n',0),(98339,2732,'sv','SnÃ¤lla ta bort/inaktivera andra transaktioner eller ring',0),(98340,2732,'it','Per favore Cancella/inattivare altre voci o chiamata',0),(98341,2732,'tl','',0),(98342,2732,'th','&#3650;&#3611;&#3619;&#3604;&#3621;&#3610;/&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657; &#3611;&#3657;&#3629;&#3609;&#3627;&#3619;&#3639;&#3629;&#3648;&#3619;&#3637;&#3618;&#3585;&#3629;&#3639;&#3656;&#3609;&#3654;',0),(98343,2732,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ delete/à¤…à¤¨à¥à¤¯ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤¯à¤¾ à¤•à¥‰à¤² inactivate',0),(98344,2732,'ms','Sila delete/inactivate penyertaan atau panggilan lain',0),(98345,2732,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø­Ø°Ù/ØªØ¹Ø·ÙŠÙ„ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø£Ùˆ Ù…ÙƒØ§Ù„Ù…Ø© Ø£Ø®Ø±Ù‰',0),(98346,2732,'fr','S\'il vous plaÃ®t supprimer/dÃ©sactiver autres entrÃ©es ou appel',0),(98347,2732,'jp','ä»–ã?®è¨˜å¸³ã‚’æ¶ˆåŽ»/å?œæ­¢ã?—ã?¦ã??ã? ã?•ã?„ã€‚å?ˆã?¯é€£çµ¡',0),(98348,2732,'pt','Por favor apagar/inativar outras entradas ou chamada',0),(98349,2732,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ/Ð¾Ñ‚ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¸Ð»Ð¸ Ð¿Ð¾ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ñƒ',0),(98350,2732,'es','Por favor eliminar/inactivar otras entradas o llamar',0),(98351,2732,'de','Bitte deaktivieren Sie lÃ¶schen/andere EintrÃ¤ge oder Anruf',0),(98352,2732,'en','Please delete/inactivate other entries or call',0),(98353,2733,'is','',0),(98354,2733,'dr','3- Ø¨Ø±Ø§ÙŠ Ø¨Ù‡Ø¨ÙˆØ¯ Ø§ÙŠÙ† Ø³Ø§ÙØª ÙˆÛŒØ±',0),(98355,2733,'pr','Ù…Ø­Ø¯ÙˆØ¯ÙŠØª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ 3- Ø¨Ø±Ø§ÙŠ Ø¨Ù‡Ø¨ÙˆØ¯ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±\r\n1-800-NOGUSKA</b> to upgrade NOLA PRO',0),(98356,2733,'tr','NOLA PRO yÃ¼kseltmek iÃ§in <b>1-800-NOGUSKA</b>',0),(98357,2733,'pl','<b>1-800-NOGUSKA</b> uaktualniÄ‡ NOLA PRO',0),(98358,2733,'bg','<b>1-800-NOGUSKA</b> Ð´Ð° Ð½Ð°Ð´ÑÑ‚Ñ€Ð¾Ð¸Ñ‚Ðµ ÐÐ¾Ð»Ð° Ð¿Ñ€Ð¾',0),(98359,2733,'ur','Ù†Ø§ÙˆÙ„Û Ù¾Ø±Ùˆ Ú©Ùˆ Ø§Ù¾ Ú¯Ø±ÛŒÚˆ Ú©Ø±Ù†Û’ <b>1-800-Ù†ÙˆÚ¯ÙˆØ³Ú©</b>',0),(98360,2733,'sr','<b>1-800-ÐÐžÐ“Ð£Ð¡ÐšÐ</b> Ð·Ð° Ð½Ð°Ð´Ð¾Ð³Ñ€Ð°Ð´ÑšÑƒ ÐÐžÐ›Ð ÐŸÐ Ðž',0),(98361,2733,'vi','<b>1-800-NOGUSKA</b> Ä‘á»ƒ nÃ¢ng cáº¥p NOLA PRO',0),(98362,2733,'af','<b>1-800-NOGUSKA</b> om op te gradeer NOLA PRO',0),(98363,2733,'ro','<b>1-800-NOGUSKA</b> pentru a face upgrade NOLA PRO',0),(98364,2733,'et','<b>1-800-NOGUSKA</b> uuendada NOLA PRO',0),(98365,2733,'si','<b>1-800-NOGUSKA</b> za nadgradnjo NOLA PRO',0),(98366,2733,'ba','<b>1-800-NOGUSKA</b> untuk meng-upgrade NOLA PRO',0),(98367,2733,'nl','<b>1-800-NOGUSKA</b> om te upgraden van NOLA PRO',0),(98368,2733,'fi','<b>1-800-NOGUSKA</b> pÃ¤ivittÃ¤Ã¤ NOLA PRO',0),(98369,2733,'no','<b>1-800-NOGUSKA</b> oppgradere NOLA PRO',0),(98370,2733,'da','<b>1-800-NOGUSKA</b> at opgradere NOLA PRO',0),(98371,2733,'ko','<b>1-800-NOGUSKA</b> ë…¸ë¼ í”„ë¡œ ì—…ê·¸ë ˆì´ë“œ',0),(98372,2733,'he','<b>1-800-NOGUSKA</b> ×œ×©×“×¨×’ ××ª × ×•×œ×” PRO',0),(98373,2733,'el','<b>1-800-NOGUSKA</b> Î³Î¹Î± Ï„Î·Î½ Î±Î½Î±Î²Î¬Î¸Î¼Î¹ÏƒÎ· Ï„Î¿Ï… NOLA PRO',0),(98374,2733,'zh','<b>1-800-NOGUSKAå‡çº§NOLA PRO\r\n',0),(98375,2733,'sv','<b>1-800-NOGUSKA</b> att uppgradera NOLA PRO',0),(98376,2733,'it','<b>1-800-NOGUSKA</b> per aggiornare NOLA PRO',0),(98377,2733,'tl','',0),(98378,2733,'th','<b>1-800-NOGUSKA</b> to upgrade NOLA PRO',0),(98379,2733,'hi','NOLA à¤ªà¥à¤°à¥‹ à¤®à¥‡à¤‚ à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ <b>1-800-NOGUSKA</b>',0),(98380,2733,'ms','<b>1-800-NOGUSKA</b> untuk menaik taraf NOLA PRO',0),(98381,2733,'ar','<b>1-800-Ù†ÙˆØ¬ÙˆØ³ÙƒØ§</b> Ù„Ø±ÙØ¹ Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ù…Ø­ØªØ±ÙÙŠÙ† Ù†ÙˆÙ„Ø§',0),(98382,2733,'fr','<b>1-800-NOGUSKA</b> pour mettre Ã  niveau de NOLA PRO',0),(98383,2733,'jp','NOLA PROã‚’ã‚¢ãƒƒãƒ—ã‚°ãƒ¬ãƒ¼ãƒ‰ã?™ã‚‹ã?«ã?¯ã€€1-800-NOGUSKA',0),(98384,2733,'pt','<b>1-800-NOGUSKA</b> para atualizar a NOLA PRO',0),(98385,2733,'ru','<b>1-800-NOGUSKA</b> Ð´Ð»Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÐÐ¾Ð»Ð° PRO',0),(98386,2733,'es','<b>1-800-NOGUSKA</b> para actualizar a la nueva versiÃ³n de NolaPro',0),(98387,2733,'de','<b>1-800-NOGUSKA</b> NOLA PRO Upgrade',0),(98388,2733,'en','<b>1-800-NOGUSKA</b> to upgrade NOLA PRO',0),(98389,2734,'is','',0),(98390,2734,'dr','4-   Ù†Ø³Ø®Ù‡ ÙˆØ§Ø­Ø¯ ØªØ¬Ø§Ø±ØªÛŒ',0),(98391,2734,'pr','Ù…Ø­Ø¯ÙˆØ¯ÙŠØª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ 4-   Ù†Ø³Ø®Ù‡ ÙˆØ§Ø­Ø¯ ØªØ¬Ø§Ø±ÙŠ\r\nEnterprise</u> version',0),(98392,2734,'tr','<u>Kurumsal</u> sÃ¼rÃ¼m',0),(98393,2734,'pl','do wersji <u>Enterprise</u>',0),(98394,2734,'bg','Ð½Ð° <u>Ð¿Ñ€ÐµÐ´Ð¿Ñ€Ð¸ÑÑ‚Ð¸ÐµÑ‚Ð¾</u> Ð²ÐµÑ€ÑÐ¸Ñ',0),(98395,2734,'ur','<u>Ø§Ù†Ù¹Ø±Ù¾Ø±Ø§Ø¦Ø²</u> Ú©Û’ ÙˆØ±Ú˜Ù† Ú©Û’ Ù„ÛŒÛ’',0),(98396,2734,'sr','Ð´Ð° Ñ˜Ðµ <u>Ð•Ð½Ñ‚ÐµÑ€Ð¿Ñ€Ð¸ÑÐµ</u> Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð°',0),(98397,2734,'vi','tá»›i phiÃªn báº£n Enterprise ',0),(98398,2734,'af','om die <u>onderneming se</u> weergawe',0),(98399,2734,'ro','versiunea <u>Enterprise</u>',0),(98400,2734,'et','<u>Enterprise</u> versiooni',0),(98401,2734,'si','<u>lotitev</u> prevod',0),(98402,2734,'ba','untuk versi <u>Enterprise</u>',0),(98403,2734,'nl','naar de <u>Enterprise</u> -versie',0),(98404,2734,'fi','<u>Enterprise</u> -versio',0),(98405,2734,'no','med <u>Enterprise</u> -versjonen',0),(98406,2734,'da','at <u>initiativ</u> gengivelse',0),(98407,2734,'ko','<u>ì—”í„°í”„ë¼ì´ì¦ˆ</u> ë²„ì „',0),(98408,2734,'he','×¢×œ ×’×™×¨×¡×ª <u>Enterprise</u>',0),(98409,2734,'el','ÏƒÏ„Î·Î½ <u>ÎµÏ€Î¹Ï‡ÎµÎ¯ÏÎ·ÏƒÎ·</u> Î­ÎºÎ´Î¿ÏƒÎ·',0),(98410,2734,'zh','å¯¹ä¼ä¸šçš„ç‰ˆæœ¬\r\n',0),(98411,2734,'sv','till <u>Enterprise</u> -versionen',0),(98412,2734,'it','per la versione <u>Enterprise</u>',0),(98413,2734,'tl','',0),(98414,2734,'th','to the <u>Enterprise</u> version',0),(98415,2734,'hi','<u>à¤à¤‚à¤Ÿà¤°à¤ªà¥à¤°à¤¾à¤‡à¤œà¤¼</u> à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤',0),(98416,2734,'ms','untuk versi <u>Enterprise</u>',0),(98417,2734,'ar','Ù„Ø¥ØµØ¯Ø§Ø± <u>Ø§Ù„Ù…Ø¤Ø³Ø³Ø©</u>',0),(98418,2734,'fr','la version <u>Enterprise</u>',0),(98419,2734,'jp','ä¼?æ¥­ãƒ?ãƒ¼ã‚¸ãƒ§ãƒ³ã?¸',0),(98420,2734,'pt','para a versÃ£o <u>Enterprise</u>',0),(98421,2734,'ru','Ð² Ð²ÐµÑ€ÑÐ¸Ð¸ <u>Enterprise</u>',0),(98422,2734,'es','hasta la <u>Enterprise</u> versiÃ³n',0),(98423,2734,'de','auf die <u>Enterprise</u> -version',0),(98424,2734,'en','to the <u>Enterprise</u> version',0),(98425,2735,'is','',0),(98426,2735,'dr','-  ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(98427,2735,'pr','Ù…Ø­Ø¯ÙˆØ¯ÙŠØª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ -  ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(98428,2735,'tr','SatÄ±cÄ± eklenemez.',0),(98429,2735,'pl','Nie moÅ¼na dodaÄ‡ dostawcy.',0),(98430,2735,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½.',0),(98431,2735,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û Ú©Ùˆ Ø´Ø§Ù…Ù„ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§Ø³Ú©ØªØ§ Û”',0),(98432,2735,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡.',0),(98433,2735,'vi','NgÆ°á»i bÃ¡n khÃ´ng thá»ƒ thÃªm Ä‘Æ°á»£c',0),(98434,2735,'af','Ondernemer kan bygevoeg word.',0),(98435,2735,'ro','Imposibil de adÄƒugat furnizor.',0),(98436,2735,'et','Hankija ei saa lisada.',0),(98437,2735,'si','Prodajalec ni mogoÄe dodati.',0),(98438,2735,'ba','Penjual tidak dapat ditambahkan.',0),(98439,2735,'nl','Leverancier kan niet worden toegevoegd.',0),(98440,2735,'fi','Toimittaja ei voi lisÃ¤tÃ¤.',0),(98441,2735,'no','LeverandÃ¸ren kan ikke legges til.',0),(98442,2735,'da','Kreditor kan ikke tilfÃ¸jes.',0),(98443,2735,'ko','ê³µê¸‰ ì—…ì²´ë¥¼ ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(98444,2735,'he','.×œ× × ×™×ª×Ÿ ×œ×”×•×¡×™×£ ×¡×¤×§',0),(98445,2735,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸Î¿ÏÎ½.',0),(98446,2735,'zh','ä¸èƒ½æ·»åŠ å–æ–¹ã€‚\r\n',0),(98447,2735,'sv','LeverantÃ¶ren kan inte lÃ¤ggas till.',0),(98448,2735,'it','Fornitore non puÃ² essere aggiunto.',0),(98449,2735,'tl','',0),(98450,2735,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(98451,2735,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾à¥¤',0),(98452,2735,'ms','Penjual tidak boleh ditambah.',0),(98453,2735,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…ÙˆØ±Ø¯.',0),(98454,2735,'fr','Fournisseur ne peut pas Ãªtre ajoutÃ©.',0),(98455,2735,'jp','æ¥­è€…ã?®è¿½åŠ ã?Œã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(98456,2735,'pt','Fornecedor nÃ£o pode ser adicionado.',0),(98457,2735,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°.',0),(98458,2735,'es','Proveedor no se puede agregar',0),(98459,2735,'de','Anbieter kann nicht hinzugefÃ¼gt werden.',0),(98460,2735,'en','Vendor cannot be added.',0),(98461,2736,'is','',0),(98462,2736,'dr','Ø¶Ø§ÙŠØ¹Ø§Øª',0),(98463,2736,'pr','Ø¶Ø§ÙŠØ¹Ø§Øª',0),(98464,2736,'tr','Hurda',0),(98465,2736,'pl','ZÅ‚om',0),(98466,2736,'bg','Ð¡ÐºÑ€Ð°Ð¿',0),(98467,2736,'ur','Ù¹Ú©Ú‘Ø§',0),(98468,2736,'sr','Ð¨ÐºÐ°Ñ€Ñ‚Ð°',0),(98469,2736,'vi','Pháº¿ liá»‡u',0),(98470,2736,'af','Knipsel',0),(98471,2736,'ro','Resturi',0),(98472,2736,'et','JÃ¤Ã¤gid',0),(98473,2736,'si','Ostanki',0),(98474,2736,'ba','Scrap',0),(98475,2736,'nl','Schroot',0),(98476,2736,'fi','Romu',0),(98477,2736,'no','Skrap',0),(98478,2736,'da','Skrot',0),(98479,2736,'ko','ìŠ¤í¬ëž©',0),(98480,2736,'he','×’×¨×•×˜××•×ª',0),(98481,2736,'el','Î˜ÏÎ±ÏÏƒÎ¼Î±Ï„Î±',0),(98482,2736,'zh','åºŸæ–™\r\n',0),(98483,2736,'sv','Skrot',0),(98484,2736,'it','Rottami',0),(98485,2736,'tl','',0),(98486,2736,'th','&#3648;&#3624;&#3625;&#3648;&#3621;&#3655;&#3585; &#3654;',0),(98487,2736,'hi','à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª',0),(98488,2736,'ms','Sekerap',0),(98489,2736,'ar','Ø®Ø±Ø¯Ø©',0),(98490,2736,'fr','Ferraille',0),(98491,2736,'jp','ã‚¹ã‚¯ãƒ©ãƒƒãƒ—',0),(98492,2736,'pt','Sucata',0),(98493,2736,'ru','Ð›Ð¾Ð¼',0),(98494,2736,'es','Desechas',0),(98495,2736,'de','Schrott',0),(98496,2736,'en','Scrap',0),(98497,2737,'is','',0),(98498,2737,'dr','ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´',0),(98499,2737,'pr','ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´',0),(98500,2737,'tr','Ekran',0),(98501,2737,'pl','Ekran',0),(98502,2737,'bg','Ð•ÐºÑ€Ð°Ð½',0),(98503,2737,'ur','Ø³Ú©Ø±ÛŒÙ†',0),(98504,2737,'sr','Ð•ÐºÑ€Ð°Ð½',0),(98505,2737,'vi','MÃ n hÃ¬nh',0),(98506,2737,'af','Keur',0),(98507,2737,'ro','Ecran',0),(98508,2737,'et','Ekraani',0),(98509,2737,'si','Zaslon',0),(98510,2737,'ba','Layar',0),(98511,2737,'nl','Scherm',0),(98512,2737,'fi','NÃ¤ytÃ¶n',0),(98513,2737,'no','Skjermen',0),(98514,2737,'da','SkÃ¦rm',0),(98515,2737,'ko','í™”ë©´',0),(98516,2737,'he','×ž×¡×š',0),(98517,2737,'el','ÎŸÎ¸ÏŒÎ½Î·',0),(98518,2737,'zh','ç­›é€‰\r\n',0),(98519,2737,'sv','SkÃ¤rmen',0),(98520,2737,'it','Schermo',0),(98521,2737,'tl','',0),(98522,2737,'th','&#3627;&#3609;&#3657;&#3634;&#3592;&#3629;',0),(98523,2737,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨',0),(98524,2737,'ms','Skrin',0),(98525,2737,'ar','Ø§Ù„Ø´Ø§Ø´Ø©',0),(98526,2737,'fr','Ã‰cran',0),(98527,2737,'jp','ç”»é?¢',0),(98528,2737,'pt','Tela',0),(98529,2737,'ru','Ð­ÐºÑ€Ð°Ð½',0),(98530,2737,'es','Pantalla',0),(98531,2737,'de','Bildschirm',0),(98532,2737,'en','Screen',0),(98533,2738,'is','',0),(98534,2738,'dr','Ø¬Ø³ØªØ¬Ùˆ',0),(98535,2738,'pr','Ø¬Ø³ØªØ¬Ùˆ',0),(98536,2738,'tr','Arama',0),(98537,2738,'pl','Szukaj',0),(98538,2738,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ',0),(98539,2738,'ur','ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(98540,2738,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð³Ð°',0),(98541,2738,'vi','TÃ¬m kiáº¿m',0),(98542,2738,'af','Soek',0),(98543,2738,'ro','CÄƒutare',0),(98544,2738,'et','Otsing',0),(98545,2738,'si','IÅ¡Äi',0),(98546,2738,'ba','Cari',0),(98547,2738,'nl','Zoeken',0),(98548,2738,'fi','Etsi',0),(98549,2738,'no','SÃ¸k',0),(98550,2738,'da','SÃ¸g',0),(98551,2738,'ko','ê²€ìƒ‰',0),(98552,2738,'he','×—×¤×©',0),(98553,2738,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(98554,2738,'zh','æœç´¢\r\n',0),(98555,2738,'sv','SÃ¶k',0),(98556,2738,'it','Ricerca',0),(98557,2738,'tl','',0),(98558,2738,'th','&#3588;&#3657;&#3609;&#3627;&#3634;',0),(98559,2738,'hi','à¤–à¥‹à¤œ',0),(98560,2738,'ms','Cari',0),(98561,2738,'ar','Ø§Ù„Ø¨Ø­Ø«',0),(98562,2738,'fr','Rechercher',0),(98563,2738,'jp','æ¤œç´¢',0),(98564,2738,'pt','Pesquisa',0),(98565,2738,'ru','ÐŸÐ¾Ð¸ÑÐº',0),(98566,2738,'es','Buscar',0),(98567,2738,'de','Suche',0),(98568,2738,'en','Search',0),(98569,2739,'is','',0),(98570,2739,'dr','Ø¬Ø³ØªØ¬Ùˆ Ù…Ø¬Ø¯Ø¯',0),(98571,2739,'pr','Ø¬Ø³ØªØ¬Ùˆ Ù…Ø¬Ø¯Ø¯',0),(98572,2739,'tr','Yeniden arama',0),(98573,2739,'pl','Szukaj ponownie',0),(98574,2739,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(98575,2739,'ur','Ø¯ÙˆØ¨Ø§Ø±Û ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(98576,2739,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(98577,2739,'vi','TÃ¬m kiáº¿m láº¡i',0),(98578,2739,'af','Soek Weer',0),(98579,2739,'ro','CÄƒutaÅ£i din nou',0),(98580,2739,'et','Otsi uuesti',0),(98581,2739,'si','IÅ¡Äi ponovno',0),(98582,2739,'ba','Telusuri lagi',0),(98583,2739,'nl','Opnieuw zoeken',0),(98584,2739,'fi','Etsi uudelleen',0),(98585,2739,'no','SÃ¸k pÃ¥ nytt',0),(98586,2739,'da','SÃ¸g igen',0),(98587,2739,'ko','ë‹¤ì‹œ ê²€ìƒ‰',0),(98588,2739,'he','×—×¤×© ×©×•×‘',0),(98589,2739,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎºÎ±Î¹ Ï€Î¬Î»Î¹',0),(98590,2739,'zh','é‡æ–°æœç´¢\r\n',0),(98591,2739,'sv','SÃ¶k igen',0),(98592,2739,'it','Ulteriore ricerca',0),(98593,2739,'tl','',0),(98594,2739,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(98595,2739,'hi','à¤«à¤¿à¤° à¤¸à¥‡ à¤–à¥‹à¤œ',0),(98596,2739,'ms','Gelintar lagi',0),(98597,2739,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø§Ù„Ø¨Ø­Ø«',0),(98598,2739,'fr','Recherche supplÃ©mentaire',0),(98599,2739,'jp','å†?åº¦æ¤œç´¢ã?—ã?¦ä¸‹ã?•ã?„',0),(98600,2739,'pt','Pesquisar novamente',0),(98601,2739,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¡Ð½Ð¾Ð²Ð°',0),(98602,2739,'es','Buscar Otra Vez',0),(98603,2739,'de','Weitere Suche',0),(98604,2739,'en','Search Again',0),(98605,2740,'is','',0),(98606,2740,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ú¯Ø±ÙˆÙ‡ ',0),(98607,2740,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ú¯Ø±ÙˆÙ‡ ',0),(98608,2740,'tr','Arama kategorisi',0),(98609,2740,'pl','Wyszukiwanie kategorii',0),(98610,2740,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(98611,2740,'ur','Ø²Ù…Ø±Û ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(98612,2740,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(98613,2740,'vi','TÃ¬m thá»ƒ loáº¡i',0),(98614,2740,'af','Soek Katergorie',0),(98615,2740,'ro','Categoria de cÄƒutare',0),(98616,2740,'et','Otsingukategooria',0),(98617,2740,'si','Kategorija iskanja',0),(98618,2740,'ba','Cari Kategori',0),(98619,2740,'nl','Zoekcategorie',0),(98620,2740,'fi','Etsi luokka',0),(98621,2740,'no','SÃ¸k etter kategori',0),(98622,2740,'da','SÃ¸g efter kategori',0),(98623,2740,'ko','ê²€ìƒ‰ ì¹´í…Œê³ ë¦¬',0),(98624,2740,'he','×—×¤×© ×§×˜×’×•×¨×™×”',0),(98625,2740,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(98626,2740,'zh','æœç´¢ç±»åˆ«\r\n',0),(98627,2740,'sv','SÃ¶kkategori',0),(98628,2740,'it','Categoria di ricerca',0),(98629,2740,'tl','',0),(98630,2740,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(98631,2740,'hi','à¤–à¥‹à¤œ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(98632,2740,'ms','Kategori carian',0),(98633,2740,'ar','ØªØµÙ†ÙŠÙ Ø§Ù„Ø¨Ø­Ø«',0),(98634,2740,'fr','CatÃ©gorie de recherche',0),(98635,2740,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®æ¤œç´¢',0),(98636,2740,'pt','Categoria pesquisa',0),(98637,2740,'ru','ÐŸÐ¾Ð¸ÑÐº ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(98638,2740,'es','CategorÃ­a de Busqueda',0),(98639,2740,'de','Suchkategorie',0),(98640,2740,'en','Search Category',0),(98641,2741,'is','',0),(98642,2741,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø´Ø±Ø­ ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(98643,2741,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø´Ø±Ø­ ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(98644,2741,'tr','Madde tanÄ±mÄ± iÃ§in arama',0),(98645,2741,'pl','Szukaj opis przedmiotu',0),(98646,2741,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð·Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(98647,2741,'ur','Ø´Û’ Ú©ÛŒ ØªÙØµÛŒÙ„ Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(98648,2741,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð³Ð° Ð·Ð° Ð¾Ð¿Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(98649,2741,'vi','TÃ¬m mÃ´ táº£ hÃ ng',0),(98650,2741,'af','Soek vir Itembeskrywing',0),(98651,2741,'ro','CÄƒutare pentru Descriere element',0),(98652,2741,'et','Otsi tootekirjeldust',0),(98653,2741,'si','PoiÅ¡Äite opis elementa',0),(98654,2741,'ba','Pencarian untuk Deskripsi Item',0),(98655,2741,'nl','Zoeken voor objectbeschrijving',0),(98656,2741,'fi','Etsi nimikkeen kuvaus',0),(98657,2741,'no','SÃ¸k etter varebeskrivelsen',0),(98658,2741,'da','SÃ¸g efter emnebeskrivelse',0),(98659,2741,'ko','í•­ëª© ì„¤ëª…ì— ëŒ€ í•œ ê²€ìƒ‰',0),(98660,2741,'he','×—×¤×© ×ª××•×¨ ×ž×•×¦×¨',0),(98661,2741,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(98662,2741,'zh','æœç´¢é¡¹ç›®è¯´æ˜Ž\r\n',0),(98663,2741,'sv','SÃ¶k efter objektbeskrivning',0),(98664,2741,'it','Ricerca per Descrizione articolo',0),(98665,2741,'tl','',0),(98666,2741,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(98667,2741,'hi','à¤®à¤¦ à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ',0),(98668,2741,'ms','Mencari keterangan Item',0),(98669,2741,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† ÙˆØµÙ Ø§Ù„ØµÙ†Ù',0),(98670,2741,'fr','Recherche pour la Description de l\'objet',0),(98671,2741,'jp','å“?ç›®å??ã?®æ¤œç´¢',0),(98672,2741,'pt','Busca por Item DescriÃ§Ã£o',0),(98673,2741,'ru','ÐŸÐ¾Ð¸ÑÐº ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(98674,2741,'es','Buscar Nombre del Item',0),(98675,2741,'de','Suche nach Artikelbeschreibung',0),(98676,2741,'en','Search for Item Description',0),(98677,2742,'is','',0),(98678,2742,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø´Ø±Ø­ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ø¨Ø®Ø´ÙŠ Ø§Ø² Ø´Ø±Ø­ ',0),(98679,2742,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø´Ø±Ø­ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ø¨Ø®Ø´ÙŠ Ø§Ø² Ø´Ø±Ø­ ',0),(98680,2742,'tr','Madde tanÄ±mÄ± (kÄ±smi tarife) ile ara',0),(98681,2742,'pl','Szukaj opis przedmiotu (czÄ™Å›ciowy opis)',0),(98682,2742,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð·Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ñ (Ñ‡Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ)',0),(98683,2742,'ur','(Ø¬Ø²ÙˆÛŒ ØªØµØ±ÛŒØ­ Ù†ÛÛŒÚº) Ú©Û’ Ø³Ø§ØªÚ¾ Ø´Û’ Ú©ÛŒ ØªÙØµÛŒÙ„ Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(98684,2742,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð³Ð° Ð·Ð° Ð¾Ð¿Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° (Ð´ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð° Ð¾Ð¿Ð¸ÑÐ°)',0),(98685,2742,'vi','TÃ¬m mÃ´ táº£ hÃ ng vá»›i (mÃ´ táº£ 1 pháº§n)',0),(98686,2742,'af','Soek vir Itembeskrywing Met (Gedeeltelike Beskrywing)',0),(98687,2742,'ro','CÄƒutare pentru Descriere element cu (Descrierea parÅ£ialÄƒ)',0),(98688,2742,'et','Otsi tootekirjeldust (Osalise kirjeldusega)',0),(98689,2742,'si','PoiÅ¡Äite opis artikla z (delni opis)',0),(98690,2742,'ba','Pencarian untuk Item Description dengan (parsial Deskripsi)',0),(98691,2742,'nl','Zoeken voor objectbeschrijving met (gedeeltelijke beschrijving)',0),(98692,2742,'fi','Etsi nimikkeen kuvaus (osittainen kuvaus)',0),(98693,2742,'no','SÃ¸k etter varebeskrivelse (delvis beskrivelse)',0),(98694,2742,'da','SÃ¸g efter emnebeskrivelse med (delvis beskrivelse)',0),(98695,2742,'ko','(ë¶€ë¶„ì  ì„¤ëª…) í•­ëª© ì„¤ëª…ì— ëŒ€ í•œ ê²€ìƒ‰',0),(98696,2742,'he','×—×™×¤×•×© ×©×œ ×ª×™××•×¨ ×¤×¨×™×˜ ×¢× (×ª×™××•×¨ ×—×œ×§×™)',0),(98697,2742,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± Ï„Î·Î½ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎµÎ¯Î´Î¿Ï…Ï‚ Î¼Îµ Ï„Î· (Î¼ÎµÏÎ¹ÎºÎ® Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®)',0),(98698,2742,'zh','æœç´¢å¸¦æœ‰ï¼ˆéƒ¨åˆ†æè¿°ï¼‰é¡¹ç›®è¯´æ˜Ž\r\n',0),(98699,2742,'sv','SÃ¶k efter objektbeskrivning med (partiell beskrivning)',0),(98700,2742,'it','Ricerca per Descrizione articolo con (descrizione parziale)',0),(98701,2742,'tl','',0),(98702,2742,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3604;&#3657;&#3623;&#3618;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;&#3',0),(98703,2742,'hi','à¤®à¤¦ à¤µà¤¿à¤µà¤°à¤£ (à¤†à¤‚à¤¶à¤¿à¤• à¤µà¤¿à¤µà¤°à¤£) à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ',0),(98704,2742,'ms','Mencari keterangan Item dengan (sebahagian penerangan)',0),(98705,2742,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† ÙˆØµÙ Ø§Ù„Ø¨Ù†Ø¯ Ù…Ø¹ (ÙˆØµÙ Ø¬Ø²Ø¦ÙŠ)',0),(98706,2742,'fr','Recherche pour la Description de l\'objet (Description partielle)',0),(98707,2742,'jp','ï¼ˆå??å‰?ã?®ä¸€éƒ¨ï¼‰ã?§å“?ç›®å??ã‚’æ¤œç´¢',0),(98708,2742,'pt','Busca por descriÃ§Ã£o de Item com (descriÃ§Ã£o parcial)',0),(98709,2742,'ru','ÐŸÐ¾Ð¸ÑÐº ÐŸÐ¾ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸ÑŽ Ð¢Ð¾Ð²Ð°Ñ€Ð°(Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾Ðµ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ)',0),(98710,2742,'es','Buscar Nombres de Items Con (Nombrs Parciales)',0),(98711,2742,'de','Suche nach Artikelbeschreibung mit (teilweise Beschreibung)',0),(98712,2742,'en','Search For Item Description With (Partial Description)',0),(98713,2743,'is','',0),(98714,2743,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ù„Ø§',0),(98715,2743,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ù„Ø§',0),(98716,2743,'tr','Madde numarasÄ± iÃ§in arama',0),(98717,2743,'pl','Wyszukiwanie towaru',0),(98718,2743,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(98719,2743,'ur','Ø¢Ø¦Ù¹Ù… Ù†Ù…Ø¨Ø± Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(98720,2743,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð³Ð° Ð·Ð° Ð±Ñ€Ð¾Ñ˜ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(98721,2743,'vi','TÃ¬m sá»‘ hÃ ng',0),(98722,2743,'af','Soek vir Itemnommer',0),(98723,2743,'ro','CÄƒutare pentru numÄƒrul de articol',0),(98724,2743,'et','Otsi toote numbrit',0),(98725,2743,'si','Iskanje artikla',0),(98726,2743,'ba','Pencarian untuk Item nomor',0),(98727,2743,'nl','Zoeken naar objectnummer',0),(98728,2743,'fi','Etsi nimikkeen numero',0),(98729,2743,'no','SÃ¸k etter varenummer',0),(98730,2743,'da','SÃ¸g efter varenummer',0),(98731,2743,'ko','í•­ëª© ë²ˆí˜¸ì— ëŒ€ í•œ ê²€ìƒ‰',0),(98732,2743,'he','×—×¤×© ×ž×¡×¤×¨ ×¤×¨×™×˜',0),(98733,2743,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± ÎºÏ‰Î´Î¹ÎºÏŒ ÎµÎ¯Î´Î¿Ï…Ï‚',0),(98734,2743,'zh','æœç´¢äº§å“ç¼–å·\r\n',0),(98735,2743,'sv','SÃ¶k efter artikelnummer',0),(98736,2743,'it','Ricerca per numero di articolo',0),(98737,2743,'tl','',0),(98738,2743,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(98739,2743,'hi','à¤†à¤‡à¤Ÿà¤® à¤¨à¤‚à¤¬à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ',0),(98740,2743,'ms','Gelintar untuk Item nombor',0),(98741,2743,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø±Ù‚Ù… Ø§Ù„ØµÙ†Ù',0),(98742,2743,'fr','Recherche de numÃ©ro d\'article',0),(98743,2743,'jp','å“?ç›®ç•ªå?·ã?®æ¤œç´¢',0),(98744,2743,'pt','Pesquisar pelo nÃºmero do Item',0),(98745,2743,'ru','Ð˜ÑÐºÐ°Ñ‚ÑŒ ÐÐ¾Ð¼ÐµÑ€ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(98746,2743,'es','Buscar NÃºmero de Item',0),(98747,2743,'de','Suche nach Artikelnummer',0),(98748,2743,'en','Search for Item Number',0),(98749,2744,'is','',0),(98750,2744,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ¯Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ø¨Ø®Ø´ÙŠ Ø§Ø² ÙƒØ¯',0),(98751,2744,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ¯Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ø¨Ø®Ø´ÙŠ Ø§Ø² ÙƒØ¯',0),(98752,2744,'tr','Madde kodu (kÄ±smi kodlarÄ±) iÃ§in arama',0),(98753,2744,'pl','Wyszukaj kody zapasÃ³w (czÄ™Å›ciowe kody)',0),(98754,2744,'bg','Ð¢ÑŠÑ€ÑÐµÐ½ÐµÑ‚Ð¾ Ð·Ð° ÐºÐ¾Ð´Ð¾Ð²Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ñ (Ñ‡Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ ÐºÐ¾Ð´Ð¾Ð²Ðµ)',0),(98755,2744,'ur','(Ø¬Ø²ÙˆÛŒ Ø±Ù…ÙˆØ²) Ú©Û’ Ø³Ø§ØªÚ¾ Ø´Û’ Ø±Ù…ÙˆØ² Ú©ÛŒ ØªÙ„Ø§Ø´',0),(98756,2744,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð³Ð° Ð·Ð° ÑˆÐ¸Ñ„Ñ€Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° ÑÐ° (Ð´ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð° ÐºÐ¾Ð´Ð¾Ð²Ð¸)',0),(98757,2744,'vi','TÃ¬m mÃ£ hÃ ng vá»›i (mÃ£ 1 pháº§n)',0),(98758,2744,'af','Soek Vir Item Kodes Met (Gedeeltelike Kodes)',0),(98759,2744,'ro','CÄƒutare pentru element coduri cu (coduri de parÅ£ialÄƒ)',0),(98760,2744,'et','Otsi toote koodi (osalise koodiga)',0),(98761,2744,'si','PoiÅ¡Äite Å¡ifre artiklov z (delno kode)',0),(98762,2744,'ba','Pencarian untuk Item kode dengan (parsial kode)',0),(98763,2744,'nl','Zoeken naar Item Codes met (gedeeltelijke Codes)',0),(98764,2744,'fi','Etsi nimikkeen kÃ¤ytÃ¤nnesÃ¤Ã¤nnÃ¶t (osittainen koodit)',0),(98765,2744,'no','SÃ¸k etter varekoder med (delvis koder)',0),(98766,2744,'da','SÃ¸g efter varekoder med (delvis koder)',0),(98767,2744,'ko','(ì¼ë¶€ ì½”ë“œ) í•­ëª© ì½”ë“œì— ëŒ€ í•œ ê²€ìƒ‰',0),(98768,2744,'he','×—×™×¤×•×© ×©×œ ×§×•×“×™ ×¤×¨×™×˜ ×¢× (×§×•×“×™ ×—×œ×§×™×ª)',0),(98769,2744,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚ ÎµÎ¹Î´ÏŽÎ½ Î¼Îµ Ï„Î· (Î¼ÎµÏÎ¹ÎºÎ® ÎºÏ‰Î´Î¹ÎºÎ¿Î¯)',0),(98770,2744,'zh','æœç´¢å¸¦æœ‰ï¼ˆéƒ¨åˆ†ä»£ç ï¼‰é¡¹ç›®ä»£ç \r\n',0),(98771,2744,'sv','SÃ¶k efter artikelkoder med (partiell koder)',0),(98772,2744,'it','Ricerca per codici articolo con (parziale codici)',0),(98773,2744,'tl','',0),(98774,2744,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3604;&#3657;&#3623;&#3618;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3619;&#3627;&#3633;&#3626;',0),(98775,2744,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ (à¤†à¤‚à¤¶à¤¿à¤• à¤•à¥‹à¤¡) à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ',0),(98776,2744,'ms','Cari kod Item dengan (separa Kod)',0),(98777,2744,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø±Ù…ÙˆØ² Ø§Ù„Ø¨Ù†Ø¯ Ù…Ø¹ (Ø±Ù…ÙˆØ² Ø¬Ø²Ø¦ÙŠØ©)',0),(98778,2744,'fr','Recherche pour les Codes (codes partielle)',0),(98779,2744,'jp','ï¼ˆã‚³ãƒ¼ãƒ‰ã?®ä¸€éƒ¨ï¼‰ã?§å“?ç›®ã‚³ãƒ¼ãƒ‰ã‚’æ¤œç´¢',0),(98780,2744,'pt','Busca por cÃ³digos de Item com (cÃ³digos parciais)',0),(98781,2744,'ru','ÐŸÐ¾Ð¸ÑÐº ÐŸÐ¾ ÐšÐ¾Ð´Ð°Ð¼ Ð¢Ð¾Ð²Ð°Ñ€Ð° (Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ñ‹Ðµ ÐšÐ¾Ð´Ñ‹)',0),(98782,2744,'es','Buscar CÃ³digos de Items Con (CÃ³digos Parciales)',0),(98783,2744,'de','Suche nach Leistungsnummern mit (teilweise Codes)',0),(98784,2744,'en','Search For Item Codes With (Partial Codes)',0),(98785,2745,'is','',0),(98786,2745,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ø¬Ù‡Øª Ø­Ù…Ù„ ',0),(98787,2745,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ø¬Ù‡Øª Ø­Ù…Ù„ ',0),(98788,2745,'tr','SipariÅŸ sevk etmek iÃ§in arama',0),(98789,2745,'pl','Szukaj dla zamÃ³wienia do wysyÅ‚ki',0),(98790,2745,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(98791,2745,'ur','Ø¬ÛØ§Ø² ØªÚ© Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(98792,2745,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð³Ð° Ð·Ð° Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(98793,2745,'vi','TÃ¬m Ä‘Æ¡n hÃ ng Ä‘á»ƒ chuyá»ƒn Ä‘i',0),(98794,2745,'af','Soek vir bestelling om te versend',0),(98795,2745,'ro','CÄƒutare pentru pentru a navei',0),(98796,2745,'et','Otsi tellimusi tarnimiseks',0),(98797,2745,'si','PoiÅ¡Äite naroÄilo za dobavo',0),(98798,2745,'ba','Mencari agar kapal',0),(98799,2745,'nl','Zoek om te verzenden',0),(98800,2745,'fi','Etsi tilauksen aluksen',0),(98801,2745,'no','SÃ¸k etter for Ã¥ levere',0),(98802,2745,'da','SÃ¸g efter ordre til skibet',0),(98803,2745,'ko','ë°°ì†¡ ì£¼ë¬¸ì— ëŒ€ í•œ ê²€ìƒ‰',0),(98804,2745,'he','×—×™×¤×•×© ×¢×‘×•×¨ ×”×–×ž× ×” ×œ×ž×©×œ×•×—',0),(98805,2745,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÎµ Ï€Î»Î¿Î¯Î¿',0),(98806,2745,'zh','ä¸ºäº†èˆ¹èˆ¶æœå¯»\r\n',0),(98807,2745,'sv','SÃ¶k efter att fartyget',0),(98808,2745,'it','Ricerca per ordine di spedire',0),(98809,2745,'tl','',0),(98810,2745,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3652;&#3611;&#3618;&#3633;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(98811,2745,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ',0),(98812,2745,'ms','Carian untuk kapal',0),(98813,2745,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† ØªØ±ØªÙŠØ¨ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(98814,2745,'fr','Recherche de l\'ordre d\'expÃ©dier',0),(98815,2745,'jp','ç™ºé€?ã?™ã‚‹æ³¨æ–‡ã‚’æ¤œç´¢',0),(98816,2745,'pt','Busca por ordem de navio',0),(98817,2745,'ru','ÐŸÐ¾Ð¸ÑÐº Ð´Ð»Ñ Ñ‚Ð¾Ð³Ð¾ Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(98818,2745,'es','Buscar orden para enviar',0),(98819,2745,'de','Suche nach Bestellung versenden',0),(98820,2745,'en','Search for order to ship',0),(98821,2746,'is','',0),(98822,2746,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(98823,2746,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(98824,2746,'tr','Sevk emri iÃ§in gÃ¶rÃ¼nÃ¼mde ara',0),(98825,2746,'pl','Szukaj wysÅ‚ane celu wyÅ›wietlenia',0),(98826,2746,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸ Ð·Ð° Ð´Ð° ÑÐµ Ð²Ð¸Ð¶Ð´Ð°Ñ‚',0),(98827,2746,'ur','ØªÙ„Ø§Ø´ Ø¨Ø±Ø§Ø¦Û’ Ø¢Ø±ÚˆØ± Ø¨Ù†Ø§Ù… Ù…Ù†Ø¸Ø± Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(98828,2746,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð³Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ð»Ð¸',0),(98829,2746,'vi','TÃ¬m Ä‘Æ¡n hÃ ng Ä‘Ã£ chuyá»ƒn',0),(98830,2746,'af','Soek vir versende bestelling om te besigtig',0),(98831,2746,'ro','CÄƒutare pentru livrat pentru a vizualiza',0),(98832,2746,'et','Otsi tarnitud tellimusi vaatamiseks',0),(98833,2746,'si','Iskanje poÅ¡iljajo da si ogledate',0),(98834,2746,'ba','Cari untuk dikirim untuk melihat',0),(98835,2746,'nl','Zoeken naar verzonden bestelling te bekijken',0),(98836,2746,'fi','Etsi toimitetaan tarkasteleminen',0),(98837,2746,'no','SÃ¸k etter sendt for Ã¥ vise',0),(98838,2746,'da','SÃ¸g efter afsendt for at se',0),(98839,2746,'ko','ë°°ì†¡ ìˆœì„œë¥¼ ë³´ë ¤ë©´ ê²€ìƒ‰',0),(98840,2746,'he','×œ×—×™×¤×•×© ×©× ×©×œ×—×” ×›×“×™ ×œ×”×¦×™×’',0),(98841,2746,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± Î¼ÎµÏ„Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹ Ï€ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± Î±Î½Ï„Î¹Î¼ÎµÏ„Ï‰Ï€Î¹ÏƒÎ¸ÎµÎ¯',0),(98842,2746,'zh','ä¸ºè¿é€è®¢å•æŸ¥è¯¢ï¼Œä»¥æŸ¥çœ‹\r\n',0),(98843,2746,'sv','SÃ¶k efter levereras fÃ¶r att Visa',0),(98844,2746,'it','Ricerca per spedito per poter visualizzare',0),(98845,2746,'tl','',0),(98846,2746,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;',0),(98847,2746,'hi','à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¥ƒà¤¶à¥à¤¯ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ',0),(98848,2746,'ms','Cari untuk pesanan dihantar kepada paparan',0),(98849,2746,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† ØªØ±ØªÙŠØ¨ Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ù„Ø¹Ø±Ø¶',0),(98850,2746,'fr','Recherche d\'embarquÃ©e pour afficher',0),(98851,2746,'jp','è¡¨ç¤ºã?™ã‚‹ç™ºé€?æ¸ˆæ³¨æ–‡ã?®æ¤œç´¢',0),(98852,2746,'pt','Pesquisa para enviado a ordem para exibiÃ§Ã£o',0),(98853,2746,'ru','ÐŸÐ¾Ð¸ÑÐº Ð´Ð»Ñ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð°',0),(98854,2746,'es','Buscar orden enviado para visionar',0),(98855,2746,'de','Suche nach gelieferten zur Anzeige',0),(98856,2746,'en','Search for shipped order to view',0),(98857,2747,'is','',0),(98858,2747,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(98859,2747,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(98860,2747,'tr','Arama tÄ±rnak',0),(98861,2747,'pl','Szukaj oferty',0),(98862,2747,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(98863,2747,'ur','ØªÙ„Ø§Ø´ Ù‚ÛŒÙ…Øª',0),(98864,2747,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð³Ð° Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(98865,2747,'vi','TÃ¬m kiáº¿m bÃ¡o giÃ¡',0),(98866,2747,'af','Soek Kwotasies',0),(98867,2747,'ro','Citate de cÄƒutare',0),(98868,2747,'et','Otsi hinnapakkumisi',0),(98869,2747,'si','Iskanje ponudbe',0),(98870,2747,'ba','Cari tanda kutip',0),(98871,2747,'nl','Zoek Quotes',0),(98872,2747,'fi','Etsi Quotes',0),(98873,2747,'no','SÃ¸k etter tilbud',0),(98874,2747,'da','SÃ¸g efter citater',0),(98875,2747,'ko','ê²€ìƒ‰ ë”°ì˜´í‘œ',0),(98876,2747,'he','×—×¤×© ×‘×”×¦×¢×•×ª ×ž×—×™×¨',0),(98877,2747,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(98878,2747,'zh','æœç´¢æŠ¥ä»·\r\n',0),(98879,2747,'sv','SÃ¶k citat',0),(98880,2747,'it','Ricerca citazioni',0),(98881,2747,'tl','',0),(98882,2747,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(98883,2747,'hi','à¤–à¥‹à¤œ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(98884,2747,'ms','Cari sebut harga',0),(98885,2747,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(98886,2747,'fr','Recherche de citations',0),(98887,2747,'jp','è¦‹ç©?ã‚‚ã‚Šã?®æ¤œç´¢',0),(98888,2747,'pt','Pesquisar CotaÃ§Ãµes',0),(98889,2747,'ru','ÐŸÐ¾Ð¸ÑÐº ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(98890,2747,'es','Buscar Cotizaciones',0),(98891,2747,'de','Suche Zitate',0),(98892,2747,'en','Search Quotes',0),(98893,2748,'is','',0),(98894,2748,'dr','(Ø²Ù…Ø§Ù†-Ø¬Ù…Ù„Ù‡',0),(98895,2748,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù…Ø¯Øª (Ø²Ù…Ø§Ù†-Ø¬Ù…Ù„Ù‡',0),(98896,2748,'tr','Arama terimi',0),(98897,2748,'pl','Wyszukiwane hasÅ‚o',0),(98898,2748,'bg','Ð”ÑƒÐ¼Ð° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(98899,2748,'ur','ØªÙ„Ø§Ø´ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­',0),(98900,2748,'sr','Ð¢ÐµÑ€Ð¼Ð¸Ð½ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(98901,2748,'vi','TÃ¬m kiáº¿m Ä‘iá»u khoáº£n',0),(98902,2748,'af','Soekterm',0),(98903,2748,'ro','Termen de cÄƒutare',0),(98904,2748,'et','OtsingusÃµna',0),(98905,2748,'si','Iskalni izraz',0),(98906,2748,'ba','Istilah pencarian',0),(98907,2748,'nl','Zoekterm',0),(98908,2748,'fi','Hakusana',0),(98909,2748,'no','SÃ¸keord',0),(98910,2748,'da','SÃ¸geord',0),(98911,2748,'ko','ê²€ìƒ‰ ìš©ì–´',0),(98912,2748,'he','×—×¤×© ×ª× ××™',0),(98913,2748,'el','ÎŒÏÎ¿Ï‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(98914,2748,'zh','æ£€ç´¢æ¡æ¬¾\r\n',0),(98915,2748,'sv','SÃ¶kterm',0),(98916,2748,'it','Termine di ricerca',0),(98917,2748,'tl','',0),(98918,2748,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;',0),(98919,2748,'hi','à¤–à¥‹à¤œ à¤ªà¤¦',0),(98920,2748,'ms','Istilah carian',0),(98921,2748,'ar','Ù…ØµØ·Ù„Ø­ Ø§Ù„Ø¨Ø­Ø«',0),(98922,2748,'fr','Terme de recherche',0),(98923,2748,'jp','æ¤œç´¢å“?ç›®',0),(98924,2748,'pt','Termo de pesquisa',0),(98925,2748,'ru','ÐŸÐ¾Ð¸ÑÐº Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð°',0),(98926,2748,'es','Buscar TÃ©rmino',0),(98927,2748,'de','Suchbegriff',0),(98928,2748,'en','Search term',0),(98929,2749,'is','',0),(98930,2749,'dr','ÙØµÙ„',0),(98931,2749,'pr','ÙØµÙ„',0),(98932,2749,'tr','Sezon',0),(98933,2749,'pl','Sezon',0),(98934,2749,'bg','Ð¡ÐµÐ·Ð¾Ð½',0),(98935,2749,'ur','Ù…ÙˆØ³Ù…',0),(98936,2749,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð°',0),(98937,2749,'vi','MÃ¹a',0),(98938,2749,'af','Seisoen',0),(98939,2749,'ro','Sezon',0),(98940,2749,'et','Hooaja',0),(98941,2749,'si','Sezona',0),(98942,2749,'ba','Musim',0),(98943,2749,'nl','Seizoen',0),(98944,2749,'fi','Kausi',0),(98945,2749,'no','Sesong',0),(98946,2749,'da','SÃ¦son',0),(98947,2749,'ko','ì‹œì¦Œ',0),(98948,2749,'he','×¢×•× ×”',0),(98949,2749,'el','Î£ÎµÎ¶ÏŒÎ½',0),(98950,2749,'zh','å­£èŠ‚\r\n',0),(98951,2749,'sv','SÃ¤song',0),(98952,2749,'it','Stagione',0),(98953,2749,'tl','',0),(98954,2749,'th','&#3620;&#3604;&#3641;&#3585;&#3634;&#3621;',0),(98955,2749,'hi','à¤®à¥Œà¤¸à¤®',0),(98956,2749,'ms','Musim',0),(98957,2749,'ar','Ø§Ù„Ù…ÙˆØ³Ù…',0),(98958,2749,'fr','Saison',0),(98959,2749,'jp','å­£ç¯€',0),(98960,2749,'pt','Temporada',0),(98961,2749,'ru','Ð¡ÐµÐ·Ð¾Ð½',0),(98962,2749,'es','Temporada',0),(98963,2749,'de','Saison',0),(98964,2749,'en','Season',0),(98965,2750,'is','',0),(98966,2750,'dr','Ø¯ÙˆÙ…ÙŠÙ†',0),(98967,2750,'pr','Ø¯ÙˆÙ…ÙŠÙ†',0),(98968,2750,'tr','Ä°kinci',0),(98969,2750,'pl','Drugi',0),(98970,2750,'bg','Ð¡ÐµÐºÑƒÐ½Ð´Ð°',0),(98971,2750,'ur','Ø¯ÙˆØ³Ø±ÛŒ',0),(98972,2750,'sr','Ð”Ñ€ÑƒÐ³Ð¸',0),(98973,2750,'vi','Thá»© hai',0),(98974,2750,'af','Sekonde',0),(98975,2750,'ro','Al doilea',0),(98976,2750,'et','Teine',0),(98977,2750,'si','Drugi',0),(98978,2750,'ba','Kedua',0),(98979,2750,'nl','Tweede',0),(98980,2750,'fi','Toinen',0),(98981,2750,'no','Andre',0),(98982,2750,'da','Anden',0),(98983,2750,'ko','ë‘ ë²ˆì§¸',0),(98984,2750,'he','×©× ×™×™×”',0),(98985,2750,'el','Î”ÎµÏÏ„ÎµÏÎ¿',0),(98986,2750,'zh','ç¬¬äºŒ\r\n',0),(98987,2750,'sv','Andra',0),(98988,2750,'it','Secondo',0),(98989,2750,'tl','',0),(98990,2750,'th','&#3621;&#3635;&#3604;&#3633;&#3610;&#3607;&#3637;&#3656; 2',0),(98991,2750,'hi','à¤¦à¥‚à¤¸à¤°à¤¾',0),(98992,2750,'ms','Kedua',0),(98993,2750,'ar','Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(98994,2750,'fr','Seconde',0),(98995,2750,'jp','2ã?¤ç›®',0),(98996,2750,'pt','Segundo',0),(98997,2750,'ru','Ð’Ñ‚Ð¾Ñ€Ð¾Ð¹',0),(98998,2750,'es','Segundo',0),(98999,2750,'de','Sekunde',0),(99000,2750,'en','Second',0),(99001,2751,'is','',0),(99002,2751,'dr','Ø§Ù†ØªØ®Ø§Ø¨',0),(99003,2751,'pr','Ø§Ù†ØªØ®Ø§Ø¨',0),(99004,2751,'tr','SeÃ§in',0),(99005,2751,'pl','Wybierz',0),(99006,2751,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ',0),(99007,2751,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99008,2751,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ',0),(99009,2751,'vi','Chá»n',0),(99010,2751,'af','Kies',0),(99011,2751,'ro','SelectaÅ£i',0),(99012,2751,'et','Valige',0),(99013,2751,'si','Izberite',0),(99014,2751,'ba','Pilih',0),(99015,2751,'nl','Selecteer',0),(99016,2751,'fi','Valitse',0),(99017,2751,'no','Velg',0),(99018,2751,'da','VÃ¦lg',0),(99019,2751,'ko','ì„ íƒ',0),(99020,2751,'he','×‘×—×¨',0),(99021,2751,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ',0),(99022,2751,'zh','é€‰æ‹©\r\n',0),(99023,2751,'sv','VÃ¤lj',0),(99024,2751,'it','Selezionare',0),(99025,2751,'tl','',0),(99026,2751,'th','&#3648;&#3621;&#3639;&#3629;&#3585;',0),(99027,2751,'hi','à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99028,2751,'ms','Pilih',0),(99029,2751,'ar','Ø¥Ø®ØªØ±',0),(99030,2751,'fr','SÃ©lectionnez',0),(99031,2751,'jp','é?¸æŠž',0),(99032,2751,'pt','Selecione',0),(99033,2751,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ',0),(99034,2751,'es','Seleccionar',0),(99035,2751,'de','WÃ¤hlen Sie',0),(99036,2751,'en','Select',0),(99037,2752,'is','',0),(99038,2752,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´',0),(99039,2752,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´',0),(99040,2752,'tr','SeÃ§in eylem dÃ¼zenlemek iÃ§in',0),(99041,2752,'pl','Wybierz akcjÄ™, aby edytowaÄ‡',0),(99042,2752,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(99043,2752,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø¹Ù…Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99044,2752,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ€Ð°Ð´ÑšÑƒ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(99045,2752,'vi','Chá»n HÃ nh Äá»™ng Äá»ƒ Chá»‰nh Sá»­a',0),(99046,2752,'af','Kies \'n aksie om te redigeer',0),(99047,2752,'ro','Selectare acÅ£iune pentru a edita',0),(99048,2752,'et','Valige toimingu redigeerimine',0),(99049,2752,'si','Izberite dejanje za urejanje',0),(99050,2752,'ba','Memilih tindakan untuk mengedit',0),(99051,2752,'nl','Selecteer actie om te bewerken',0),(99052,2752,'fi','Valitse toiminto Muokkaa',0),(99053,2752,'no','Velg handling Ã¥ redigere',0),(99054,2752,'da','VÃ¦lg handling at redigere',0),(99055,2752,'ko','íŽ¸ì§‘ ìž‘ì—…ì„ ì„ íƒ',0),(99056,2752,'he','×‘×—×¨ ×¤×¢×•×œ×” ×œ×¢×¨×™×›×”',0),(99057,2752,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎµÎ½Î­ÏÎ³ÎµÎ¹Î± Î³Î¹Î± Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(99058,2752,'zh','é€‰æ‹©æ“ä½œç¼–è¾‘\r\n',0),(99059,2752,'sv','VÃ¤lj Ã¥tgÃ¤rd att redigera',0),(99060,2752,'it','Selezionare l\'azione da modificare',0),(99061,2752,'tl','',0),(99062,2752,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(99063,2752,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99064,2752,'ms','Memilih tindakan untuk mengedit',0),(99065,2752,'ar','Ø­Ø¯Ø¯ Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ù„ØªØ­Ø±ÙŠØ±',0),(99066,2752,'fr','SÃ©lectionnez l\'Action Ã  modifier',0),(99067,2752,'jp','ç·¨é›†ã?™ã‚‹ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã?®é?¸æŠž',0),(99068,2752,'pt','Selecionar aÃ§Ã£o de editar',0),(99069,2752,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð´Ð»Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(99070,2752,'es','Seleccionar AcciÃ³n para Editar',0),(99071,2752,'de','WÃ¤hlen Sie Aktion Bearbeiten',0),(99072,2752,'en','Select Action to Edit',0),(99073,2753,'is','',0),(99074,2753,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø¬Ø¯Ø¯ Ø¨Ø±Ø§ÙŠ Ø­Ø°Ù Ø§Ø² Ù„ÙŠØ³Øª ',0),(99075,2753,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø¬Ø¯Ø¯ Ø¨Ø±Ø§ÙŠ Ø­Ø°Ù Ø§Ø² Ù„ÙŠØ³Øª ',0),(99076,2753,'tr','listeden kaldÄ±rmak iÃ§in yeniden seÃ§in.',0),(99077,2753,'pl','Wybierz ponownie, aby usunÄ…Ä‡ z listy',0),(99078,2753,'bg','Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾, Ð·Ð° Ð´Ð° Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½ÐµÑ‚Ðµ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐºÐ°',0),(99079,2753,'ur','ÙÛØ±Ø³Øª Ø³Û’ ÛÙ¹Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¯ÙˆØ¨Ø§Ø±Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Û”',0),(99080,2753,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð´Ð° ÑƒÐºÐ»Ð¾Ð½Ð¸ ÑÐ° Ð»Ð¸ÑÑ‚Ðµ',0),(99081,2753,'vi','Lá»±a chá»n láº¡i Ä‘á»ƒ bá» khá»i danh sÃ¡ch',0),(99082,2753,'af','Kies weer te verwyder uit lys',0),(99083,2753,'ro','SelectaÅ£i din nou pentru a elimina din listÄƒ',0),(99084,2753,'et','Valige uuesti loendist eemaldada',0),(99085,2753,'si','Izberite znova odstraniti s seznama',0),(99086,2753,'ba','Pilih lagi untuk menghapus dari daftar',0),(99087,2753,'nl','opnieuw selecteren om te verwijderen uit lijst',0),(99088,2753,'fi','Valitse uudelleen Poista luettelosta',0),(99089,2753,'no','Velg nytt fjerne fra listen',0),(99090,2753,'da','VÃ¦lg igen for at fjerne fra listen',0),(99091,2753,'ko','ëª©ë¡ì—ì„œ ì œê±°ë¥¼ ë‹¤ì‹œ ì„ íƒ',0),(99092,2753,'he','×‘×—×¨ ×©×•×‘ ×›×“×™ ×œ×”×¡×™×¨ ×ž×”×¨×©×™×ž×”',0),(99093,2753,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎºÎ±Î¹ Ï€Î¬Î»Î¹ Î³Î¹Î± Î½Î± ÎºÎ±Ï„Î±ÏÎ³Î®ÏƒÎµÏ„Îµ Î±Ï€ÏŒ Ï„Î· Î»Î¯ÏƒÏ„Î±',0),(99094,2753,'zh','é‡æ–°é€‰æ‹©ä»Žåˆ—è¡¨ä¸­ç§»é™¤\r\n',0),(99095,2753,'sv','VÃ¤lj Ã¥terigen ta bort frÃ¥n lista',0),(99096,2753,'it','Selezionare nuovamente per rimuovere dall\'elenco',0),(99097,2753,'tl','',0),(99098,2753,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3618;&#3657;&#3634;&#3618;&#3592;&#3634;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(99099,2753,'hi','à¤«à¤¿à¤° à¤¸à¥‡ à¤¸à¥‚à¤šà¥€ à¤¸à¥‡ à¤¨à¤¿à¤•à¤¾à¤²à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99100,2753,'ms','Pilih sekali lagi untuk alih keluar dari senarai',0),(99101,2753,'ar','Ø­Ø¯Ø¯ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ Ø¥Ø²Ø§Ù„Ø© Ù…Ù† Ù‚Ø§Ø¦Ù…Ø©',0),(99102,2753,'fr','SÃ©lectionnez Ã  nouveau Ã  supprimer de la liste',0),(99103,2753,'jp','ãƒªã‚¹ãƒˆã?‹ã‚‰æ¶ˆåŽ»ã?™ã‚‹ã?«ã?¯ã‚‚ã?†ä¸€åº¦é?¸æŠžã?—ã?¦ã??ã? ã?•ã?„',0),(99104,2753,'pt','selecione novamente para remover da lista',0),(99105,2753,'ru','Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ½Ð¾Ð²Ð° Ð´Ð»Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð¸Ð· ÑÐ¿Ð¸ÑÐºÐ°',0),(99106,2753,'es','seleccionar otra vez para eliminar de la lista',0),(99107,2753,'de','WÃ¤hlen Sie erneut aus Liste entfernen',0),(99108,2753,'en','select again to remove from list',0),(99109,2754,'is','',0),(99110,2754,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ¹Ø§Ù„ÙŠØª Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(99111,2754,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ¹Ø§Ù„ÙŠØª Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(99112,2754,'tr','DÃ¼zenlemek iÃ§in baÅŸka bir eylem seÃ§in',0),(99113,2754,'pl','Wybierz innÄ… akcjÄ™ do edycji',0),(99114,2754,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(99115,2754,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø¯ÙˆØ³Ø±Ø§ Ø¹Ù…Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99116,2754,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ñƒ Ñ€Ð°Ð´ÑšÑƒ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(99117,2754,'vi','Chá»n HÃ nh Äá»™ng KhÃ¡c Äá»ƒ Chá»‰nh Sá»­a',0),(99118,2754,'af','Kies \'n Ander Aksie om te Redigeer',0),(99119,2754,'ro','SelectaÅ£i o altÄƒ acÅ£iune pentru a edita',0),(99120,2754,'et','Saate valida mÃµne muu toimingu redigeerimine',0),(99121,2754,'si','Izberite drugo dejanje urediti',0),(99122,2754,'ba','Memilih tindakan lain untuk mengedit',0),(99123,2754,'nl','Selecteer een andere actie om te bewerken',0),(99124,2754,'fi','Valitse toinen toiminto Muokkaa',0),(99125,2754,'no','Velg en annen handling Ã¥ redigere',0),(99126,2754,'da','VÃ¦lge en anden handling til at redigere',0),(99127,2754,'ko','íŽ¸ì§‘ í•˜ë ¤ë©´ ë‹¤ë¥¸ ìž‘ì—…ì„ ì„ íƒ',0),(99128,2754,'he','×‘×—×¨ ×¤×¢×•×œ×” × ×•×¡×¤×ª ×œ×¢×¨×™×›×”',0),(99129,2754,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î¬Î»Î»Î· ÎµÎ½Î­ÏÎ³ÎµÎ¹Î±, Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(99130,2754,'zh','é€‰æ‹©å¦ä¸€ä¸ªåŠ¨ä½œç¼–è¾‘\r\n',0),(99131,2754,'sv','VÃ¤lj en annan Ã¥tgÃ¤rd att redigera',0),(99132,2754,'it','Selezionare un\'altra azione per modificare',0),(99133,2754,'tl','',0),(99134,2754,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3629;&#3633;&#3609;&#3629;&#3639;&#3656;&#3609;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(99135,2754,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99136,2754,'ms','Pilih tindakan yang lain untuk mengedit',0),(99137,2754,'ar','Ø­Ø¯Ø¯ Ø¥Ø¬Ø±Ø§Ø¡ Ø¢Ø®Ø± ØªØ­Ø±ÙŠØ±',0),(99138,2754,'fr','SÃ©lectionnez une autre Action Ã  modifier',0),(99139,2754,'jp','ç·¨é›†ã?™ã‚‹ä»–ã?®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã?®é?¸æŠž',0),(99140,2754,'pt','Selecione outra aÃ§Ã£o para editar',0),(99141,2754,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð´Ð»Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(99142,2754,'es','Seleccionar Otra AcciÃ³n para Editar',0),(99143,2754,'de','WÃ¤hlen Sie eine andere Aktion zu bearbeiten',0),(99144,2754,'en','Select Another Action to Edit',0),(99145,2755,'is','',0),(99146,2755,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(99147,2755,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(99148,2755,'tr','DÃ¼zenlemek iÃ§in bir kategori seÃ§in',0),(99149,2755,'pl','Wybierz innÄ… kategoriÄ™ do edycji',0),(99150,2755,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ñ€ÑƒÐ³Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ, Ð·Ð° Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ',0),(99151,2755,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ø³ÛŒ Ø¯ÙˆØ³Ø±Û’ Ø²Ù…Ø±Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99152,2755,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÑ€ÐµÐ´Ð¸Ð»Ð¸',0),(99153,2755,'vi','Chá»n Thá»ƒ Loáº¡i KhÃ¡c Äá»ƒ Chá»‰nh Sá»­a',0),(99154,2755,'af','Kies \'n Ander Kategorie om te Redigeer',0),(99155,2755,'ro','SelectaÅ£i o altÄƒ categorie pentru a edita',0),(99156,2755,'et','Valige mÃµni muu kategooria redigeerimiseks',0),(99157,2755,'si','Izberite drugo kategorijo urediti',0),(99158,2755,'ba','Pilih kategori yang lain untuk mengedit',0),(99159,2755,'nl','Selecteer een andere categorie te bewerken',0),(99160,2755,'fi','Valitse jokin toinen luokka muokkaaminen',0),(99161,2755,'no','Velg en kategori for Ã¥ redigere',0),(99162,2755,'da','VÃ¦lg en anden kategori for at redigere',0),(99163,2755,'ko','ë‹¤ë¥¸ ë²”ì£¼ íŽ¸ì§‘ë¥¼ ì„ íƒí•©ë‹ˆë‹¤',0),(99164,2755,'he','×‘×—×¨ ×§×˜×’×•×¨×™×” × ×•×¡×¤×ª ×œ×¢×¨×™×›×”',0),(99165,2755,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î¬Î»Î»Î· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î³Î¹Î± Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(99166,2755,'zh','é€‰æ‹©å…¶ä»–ç±»åˆ«ç¼–è¾‘\r\n',0),(99167,2755,'sv','VÃ¤lj en annan kategori att redigera',0),(99168,2755,'it','Selezionare un\'altra categoria di modificare',0),(99169,2755,'tl','',0),(99170,2755,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3629;&#3639;&#3656;&#3609;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(99171,2755,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤”à¤° à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99172,2755,'ms','Pilih satu lagi kategori untuk mengedit',0),(99173,2755,'ar','Ø¥Ø®ØªÙŠØ§Ø± ØªØµÙ†ÙŠÙ Ø¢Ø®Ø± ',0),(99174,2755,'fr','SÃ©lectionner une autre catÃ©gorie Ã  modifier',0),(99175,2755,'jp','ç·¨é›†ã?™ã‚‹ä»–ã?®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®é?¸æŠž',0),(99176,2755,'pt','Selecione outra categoria para editar',0),(99177,2755,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³ÑƒÑŽ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ Ð´Ð»Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(99178,2755,'es','Seleccionar Otra CategorÃ­a para Editar',0),(99179,2755,'de','WÃ¤hlen Sie eine andere Kategorie bearbeiten',0),(99180,2755,'en','Select Another Category to Edit',0),(99181,2756,'is','',0),(99182,2756,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø±ÙƒØª Ø¯ÙŠÚ¯Ø± ',0),(99183,2756,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø±ÙƒØª Ø¯ÙŠÚ¯Ø± ',0),(99184,2756,'tr','BaÅŸka bir ÅŸirket seÃ§in',0),(99185,2756,'pl','Wybierz innÄ… firmÄ™',0),(99186,2756,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ñ€ÑƒÐ³Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(99187,2756,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± Ú©Ù…Ù¾Ù†ÛŒ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99188,2756,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(99189,2756,'vi','Chá»n cty khÃ¡c',0),(99190,2756,'af','Kies \'n Ander Onderneming',0),(99191,2756,'ro','SelectaÅ£i o altÄƒ companie',0),(99192,2756,'et','Vali muu ettevÃµte',0),(99193,2756,'si','Izberite drugo druÅ¾bo',0),(99194,2756,'ba','Pilih perusahaan lain',0),(99195,2756,'nl','Selecteer een ander bedrijf',0),(99196,2756,'fi','Valitse toinen yritys',0),(99197,2756,'no','Velg et annet firma',0),(99198,2756,'da','VÃ¦lg et andet selskab',0),(99199,2756,'ko','ë‹¤ë¥¸ íšŒì‚¬ë¥¼ ì„ íƒ',0),(99200,2756,'he','×‘×—×¨ ×—×‘×¨×” × ×•×¡×¤×ª',0),(99201,2756,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î¬Î»Î»Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(99202,2756,'zh','é€‰æ‹©å¦ä¸€å®¶å…¬å¸\r\n',0),(99203,2756,'sv','VÃ¤lj ett annat fÃ¶retag',0),(99204,2756,'it','Selezionare un\'altra societÃ ',0),(99205,2756,'tl','',0),(99206,2756,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3629;&#3639;&#3656;&#3609;',0),(99207,2756,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤šà¤¯à¤¨',0),(99208,2756,'ms','Pilih Syarikat lain',0),(99209,2756,'ar','Ø§Ø®ØªØ± Ø´Ø±ÙƒØ© Ø£Ø®Ø±Ù‰',0),(99210,2756,'fr','SÃ©lectionnez une autre sociÃ©tÃ©',0),(99211,2756,'jp','ä»–ã?®ä¼šç¤¾ã‚’é?¸æŠž',0),(99212,2756,'pt','Selecione outra empresa',0),(99213,2756,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³ÑƒÑŽ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ',0),(99214,2756,'es','Seleccionar Otra Empresa',0),(99215,2756,'de','WÃ¤hlen Sie ein anderes Unternehmen',0),(99216,2756,'en','Select Another Company',0),(99217,2757,'is','',0),(99218,2757,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§ÙŠ  Ø¯ÙŠÚ¯Ø± ',0),(99219,2757,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§ÙŠ  Ø¯ÙŠÚ¯Ø± ',0),(99220,2757,'tr','BaÅŸka bir Ã¶ÄŸe seÃ§in',0),(99221,2757,'pl','Wybierz inny element',0),(99222,2757,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ñ€ÑƒÐ³ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(99223,2757,'ur','Ø§ÛŒÚ© Ø´Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99224,2757,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½ÐµÐºÑƒ Ð´Ñ€ÑƒÐ³Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(99225,2757,'vi','Chá»n hÃ ng khÃ¡c',0),(99226,2757,'af','Kies \'n Ander Item',0),(99227,2757,'ro','SelectaÅ£i un alt element',0),(99228,2757,'et','Valige mÃµni muu Ã¼ksus',0),(99229,2757,'si','Izberite drug element',0),(99230,2757,'ba','Pilih Item lain',0),(99231,2757,'nl','Een ander Item selecteren',0),(99232,2757,'fi','Valitse toinen kohde',0),(99233,2757,'no','Velg et annet element',0),(99234,2757,'da','VÃ¦lg et andet element',0),(99235,2757,'ko','ë‹¤ë¥¸ í•­ëª©ì„ ì„ íƒ',0),(99236,2757,'he','×‘×—×¨ ×¤×¨×™×˜ × ×•×¡×£',0),(99237,2757,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Î¬Î»Î»Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(99238,2757,'zh','é€‰æ‹©å¦ä¸€ä¸ªé¡¹ç›®\r\n',0),(99239,2757,'sv','Markera ett annat objekt',0),(99240,2757,'it','Selezionare un altro elemento',0),(99241,2757,'tl','',0),(99242,2757,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3629;&#3639;&#3656;&#3609;',0),(99243,2757,'hi','à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤†à¤‡à¤Ÿà¤® à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99244,2757,'ms','Pilih butiran yang lain',0),(99245,2757,'ar','Ø§Ø®ØªØ± ØµÙ†Ù Ø¢Ø®Ø±',0),(99246,2757,'fr','SÃ©lectionnez un autre Ã©lÃ©ment',0),(99247,2757,'jp','ä»–ã?®å“?ç›®ã‚’é?¸æŠž',0),(99248,2757,'pt','Selecione outro Item',0),(99249,2757,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð¹ Ð¢Ð¾Ð²Ð°Ñ€',0),(99250,2757,'es','Seleccionar Otro Item',0),(99251,2757,'de','WÃ¤hlen Sie ein anderes Element',0),(99252,2757,'en','Select Another Item',0),(99253,2758,'is','',0),(99254,2758,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ±Ø¢ÙŠÙ†Ø¯ Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(99255,2758,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ±Ø¢ÙŠÙ†Ø¯ Ø¯ÙŠÚ¯Ø± Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(99256,2758,'tr','DÃ¼zenlemek iÃ§in baÅŸka bir iÅŸlem seÃ§in',0),(99257,2758,'pl','Wybierz inny proces edycji',0),(99258,2758,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ñ€ÑƒÐ³ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(99259,2758,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø¯ÙˆØ³Ø±Ø§ Ø¹Ù…Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99260,2758,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÑ€ÐµÐ´Ð¸Ð»Ð¸',0),(99261,2758,'vi','Chá»n QuÃ¡ TrÃ¬nh KhÃ¡c Äá»ƒ Chá»‰nh Sá»­a',0),(99262,2758,'af','Kies \'n Ander Proses om te Redigeer',0),(99263,2758,'ro','SelectaÅ£i un alt proces pentru a edita',0),(99264,2758,'et','Valige teine protsess redigeerimiseks',0),(99265,2758,'si','Izberite drug proces in ga uredite',0),(99266,2758,'ba','Pilih proses lain untuk mengedit',0),(99267,2758,'nl','Selecteer een ander proces om te bewerken',0),(99268,2758,'fi','Valitse toinen prosessi muokkaaminen',0),(99269,2758,'no','Velg en annen prosess Ã¥ redigere',0),(99270,2758,'da','VÃ¦lg en anden proces til at redigere',0),(99271,2758,'ko','íŽ¸ì§‘ í•˜ë ¤ë©´ ë‹¤ë¥¸ í”„ë¡œì„¸ìŠ¤ë¥¼ ì„ íƒ',0),(99272,2758,'he','×‘×—×¨ ×ª×”×œ×™×š × ×•×¡×£ ×œ×¢×¨×™×›×”',0),(99273,2758,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î¬Î»Î»Î· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±, Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(99274,2758,'zh','é€‰æ‹©å¦ä¸€ä¸ªè¿›ç¨‹ç¼–è¾‘\r\n',0),(99275,2758,'sv','VÃ¤lj en annan Process fÃ¶r att redigera',0),(99276,2758,'it','Selezionare un altro processo per modificare',0),(99277,2758,'tl','',0),(99278,2758,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3629;&#3639;&#3656;&#3609;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(99279,2758,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99280,2758,'ms','Pilih proses yang lain untuk mengedit',0),(99281,2758,'ar','Ø­Ø¯Ø¯ Ø¹Ù…Ù„ÙŠØ© Ø£Ø®Ø±Ù‰ ØªØ­Ø±ÙŠØ±',0),(99282,2758,'fr','SÃ©lectionnez un autre processus pour modifier',0),(99283,2758,'jp','ç·¨é›†ã?™ã‚‹ä»–ã?®ãƒ—ãƒ­ã‚»ã‚¹ã‚’é?¸æŠž',0),(99284,2758,'pt','Selecione outro processo para editar',0),(99285,2758,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð¹ ÐŸÑ€Ð¾Ñ†ÐµÑÑ Ð´Ð»Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(99286,2758,'es','Seleccionar Otro Proceso para Editar',0),(99287,2758,'de','WÃ¤hlen Sie einen anderen Prozess zu bearbeiten',0),(99288,2758,'en','Select Another Process to Edit',0),(99289,2759,'is','',0),(99290,2759,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø­Ù…Ù„ Ø¨Ù‡ Ù…Ø­Ù„ Ø¯ÙŠÚ¯Ø± ',0),(99291,2759,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø­Ù…Ù„ Ø¨Ù‡ Ù…Ø­Ù„ Ø¯ÙŠÚ¯Ø± ',0),(99292,2759,'tr','BaÅŸka bir gemiye konumu seÃ§in',0),(99293,2759,'pl','Wybierz inny statek do lokalizacji',0),(99294,2759,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ñ€ÑƒÐ³ ÐºÐ¾Ñ€Ð°Ð± Ð·Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(99295,2759,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± Ú©Ø´ØªÛŒ Ú©Ùˆ Ø¬Ú¯Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99296,2759,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¸ Ð±Ñ€Ð¾Ð´ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(99297,2759,'vi','Chá»n chuyáº¿n hÃ ng khÃ¡c tá»›i vá»‹ trÃ­',0),(99298,2759,'af','Kies \'n Ander Versend Na Plek',0),(99299,2759,'ro','SelectaÅ£i o altÄƒ navÄƒ la locaÅ£ia',0),(99300,2759,'et','Saate valida teise laeva asukohta',0),(99301,2759,'si','Izberite drugo ladjo, ki mesto',0),(99302,2759,'ba','Pilih kapal lainnya ke lokasi',0),(99303,2759,'nl','Selecteer een ander schip naar locatie',0),(99304,2759,'fi','Valitse toisen aluksen sijaintiin',0),(99305,2759,'no','Velg et annet skip til plassering',0),(99306,2759,'da','VÃ¦lg et andet skib til placering',0),(99307,2759,'ko','ìœ„ì¹˜ì— ë‹¤ë¥¸ ë°°ë¥¼ ì„ íƒ',0),(99308,2759,'he','×‘×—×¨ ×¡×¤×™× ×” × ×•×¡×¤×ª ×œ×ž×™×§×•×',0),(99309,2759,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Î¬Î»Î»Î¿ Ï€Î»Î¿Î¯Î¿ ÏƒÎµ Î¸Î­ÏƒÎ·',0),(99310,2759,'zh','é€‰æ‹©å…¶ä»–æ”¶è´§åœ°ç‚¹\r\n',0),(99311,2759,'sv','VÃ¤lj ett annat fartyg till plats',0),(99312,2759,'it','Selezionare un\'altra nave in posizione',0),(99313,2759,'tl','',0),(99314,2759,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3629;&#3639;&#3656;&#3609;&#3652;&#3611;&#3626;&#3641;&#3656;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(99315,2759,'hi','à¤à¤• à¤”à¤° à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99316,2759,'ms','Pilih satu lagi kapal ke lokasi',0),(99317,2759,'ar','Ø¥Ø®ØªÙŠØ§Ø± Ù…ÙˆÙ‚Ø¹ (Ø´Ø­Ù† Ø¥Ù„Ù‰) Ø¢Ø®Ø±',0),(99318,2759,'fr','SÃ©lectionnez un autre navire Ã  l\'emplacement',0),(99319,2759,'jp','ä»–ã?®é…?é€?å…ˆãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã‚’é?¸æŠž',0),(99320,2759,'pt','Selecione outra nave para localizaÃ§Ã£o',0),(99321,2759,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð½Ð° Ð¼ÐµÑÑ‚Ðµ',0),(99322,2759,'es','Seleccionar Otra UbicaciÃ³n para Enviar a',0),(99323,2759,'de','WÃ¤hlen Sie ein anderes Schiff zu Lage',0),(99324,2759,'en','Select Another Ship To Location',0),(99325,2760,'is','',0),(99326,2760,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ø±Ø¨Ø± Ø¯ÙŠÚ¯Ø± ',0),(99327,2760,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ø±Ø¨Ø± Ø¯ÙŠÚ¯Ø± ',0),(99328,2760,'tr','BaÅŸka bir kullanÄ±cÄ± seÃ§in',0),(99329,2760,'pl','Wybierz innego uÅ¼ytkownika',0),(99330,2760,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ñ€ÑƒÐ³ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(99331,2760,'ur','Ú©Ø³ÛŒ Ø¯ÙˆØ³Ø±Û’ ØµØ§Ø±Ù Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99332,2760,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½ÐµÐºÐ¾Ð³ Ð´Ñ€ÑƒÐ³Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(99333,2760,'vi','Chá»n NgÆ°á»i Sá»­ Dá»¥ng khÃ¡c',0),(99334,2760,'af','Kies \'n Ander Gebruiker',0),(99335,2760,'ro','Alegeti alt utilizator',0),(99336,2760,'et','Valige suvand teine kasutaja',0),(99337,2760,'si','Izberite drugega uporabnika',0),(99338,2760,'ba','Pilih pengguna lain',0),(99339,2760,'nl','Selecteer andere gebruiker',0),(99340,2760,'fi','Toinen kÃ¤yttÃ¤jÃ¤',0),(99341,2760,'no','Velg en annen bruker',0),(99342,2760,'da','VÃ¦lg en anden bruger',0),(99343,2760,'ko','ë‹¤ë¥¸ ì‚¬ìš©ìžë¥¼ ì„ íƒ',0),(99344,2760,'he','×‘×—×¨ ×ž×©×ª×ž×© × ×•×¡×£',0),(99345,2760,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Î¬Î»Î»Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(99346,2760,'zh','é€‰æ‹©å¦ä¸€ä¸ªç”¨æˆ·\r\n',0),(99347,2760,'sv','VÃ¤lj en annan anvÃ¤ndare',0),(99348,2760,'it','Selezionare un altro utente',0),(99349,2760,'tl','',0),(99350,2760,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3629;&#3639;&#3656;&#3609;',0),(99351,2760,'hi','à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99352,2760,'ms','Pilih pengguna lain',0),(99353,2760,'ar','Ø§Ø®ØªØ± Ù…Ø³ØªØ®Ø¯Ù… Ø¢Ø®Ø±',0),(99354,2760,'fr','SÃ©lectionner un autre utilisateur',0),(99355,2760,'jp','ä»–ã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’é?¸æŠž',0),(99356,2760,'pt','Selecione outro usuÃ¡rio',0),(99357,2760,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð³Ð¾ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(99358,2760,'es','Seleccionar Otro Usuario',0),(99359,2760,'de','WÃ¤hlen Sie einen anderen Benutzer',0),(99360,2760,'en','Select Another User',0),(99361,2761,'is','',0),(99362,2761,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨ÙˆØ¯Ø¬Ù‡ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(99363,2761,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨ÙˆØ¯Ø¬Ù‡ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(99364,2761,'tr','BÃ¼tÃ§e kullanÄ±m seÃ§in',0),(99365,2761,'pl','Wybierz budÅ¼etu do wykorzystania',0),(99366,2761,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(99367,2761,'ur','Ø¨Ø¬Ù¹ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99368,2761,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð±ÑƒÑŸÐµÑ‚ Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ',0),(99369,2761,'vi','Lá»±a chá»n ngÃ¢n sÃ¡ch Ä‘á»ƒ dÃ¹ng',0),(99370,2761,'af','Kies Begroting om te Gebruik',0),(99371,2761,'ro','SelectaÅ£i bugetul pentru utilizarea',0),(99372,2761,'et','Saate valida eelarve kasutamine',0),(99373,2761,'si','Izberite proraÄuna za uporabo',0),(99374,2761,'ba','Pilih anggaran untuk penggunaan',0),(99375,2761,'nl','Selecteer Budget voor gebruik',0),(99376,2761,'fi','Valitse kÃ¤ytettÃ¤vÃ¤',0),(99377,2761,'no','Velg budsjettet til bruk',0),(99378,2761,'da','VÃ¦lg Budget til brug',0),(99379,2761,'ko','ì˜ˆì‚° ì‚¬ìš© ì„ íƒ',0),(99380,2761,'he','×‘×—×¨ ×ª×§×¦×™×‘ ×œ×©×™×ž×•×©',0),(99381,2761,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î³Î¹Î± Ï‡ÏÎ®ÏƒÎ·',0),(99382,2761,'zh','é€‰æ‹©ä½¿ç”¨çš„è´¢æ”¿é¢„ç®—æ¡ˆ\r\n',0),(99383,2761,'sv','VÃ¤lj Budget till anvÃ¤ndning',0),(99384,2761,'it','Seleziona il Budget per uso',0),(99385,2761,'tl','',0),(99386,2761,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3648;&#3614;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;',0),(99387,2761,'hi','à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤œà¤Ÿ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99388,2761,'ms','Pilih bajet untuk kegunaan',0),(99389,2761,'ar','Ø¥Ø®ØªØ± Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù„Ù„Ø¥Ø³ØªØ¹Ù…Ø§Ù„',0),(99390,2761,'fr','SÃ©lectionnez Budget d\'utilisation',0),(99391,2761,'jp','ä½¿ç”¨ã?™ã‚‹äºˆç®—ã‚’é?¸æŠž',0),(99392,2761,'pt','Selecione o orÃ§amento para uso',0),(99393,2761,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð´Ð»Ñ Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(99394,2761,'es','Seleccionar Presupuesto para Usar',0),(99395,2761,'de','WÃ¤hlen Sie zur Verwendung',0),(99396,2761,'en','Select Budget to Use',0),(99397,2762,'is','',0),(99398,2762,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(99399,2762,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(99400,2762,'tr','MÃ¼ÅŸteriyi seÃ§in',0),(99401,2762,'pl','Wybierz klienta',0),(99402,2762,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(99403,2762,'ur','Ú¯Ø§ÛÚ© Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99404,2762,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(99405,2762,'vi','Lá»±a chá»n khÃ¡ch hÃ ng',0),(99406,2762,'af','Selekteer KliÃ«nt/Klant',0),(99407,2762,'ro','SelectaÅ£i clientul',0),(99408,2762,'et','Vali klient',0),(99409,2762,'si','Izberite kupca',0),(99410,2762,'ba','Pilih pelanggan',0),(99411,2762,'nl','Selecteer klant',0),(99412,2762,'fi','Valitse asiakas',0),(99413,2762,'no','Velg kunde',0),(99414,2762,'da','VÃ¦lg debitor',0),(99415,2762,'ko','ê³ ê° ì„ íƒ',0),(99416,2762,'he','×‘×—×¨ ×œ×§×•×—',0),(99417,2762,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€ÎµÎ»Î¬Ï„Î·Ï‚',0),(99418,2762,'zh','é€‰æ‹©å®¢æˆ·\r\n',0),(99419,2762,'sv','VÃ¤lj kund',0),(99420,2762,'it','Selezionare il cliente',0),(99421,2762,'tl','',0),(99422,2762,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(99423,2762,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99424,2762,'ms','Pilih pelanggan',0),(99425,2762,'ar','Ø§Ø®ØªØ± Ø²Ø¨ÙˆÙ†',0),(99426,2762,'fr','SÃ©lectionnez client',0),(99427,2762,'jp','ä»–ã?®é¡§å®¢ã‚’é?¸æŠž',0),(99428,2762,'pt','Selecione o cliente',0),(99429,2762,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(99430,2762,'es','Seleccionar Cliente',0),(99431,2762,'de','Kunden auswÃ¤hlen',0),(99432,2762,'en','Select Customer',0),(99433,2763,'is','',0),(99434,2763,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(99435,2763,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(99436,2763,'tr','MÃ¼ÅŸteri dosyayÄ± seÃ§in',0),(99437,2763,'pl','Wybierz plik klienta',0),(99438,2763,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð» Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(99439,2763,'ur','Ú©Ø³Ù¹Ù…Ø± Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99440,2763,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(99441,2763,'vi','Lá»±a chá»n há»“ sÆ¡ khÃ¡ch hÃ ng',0),(99442,2763,'af','Selekteer KliÃ«nt/Klant LÃªer',0),(99443,2763,'ro','SelectaÅ£i fiÅŸierul clientului',0),(99444,2763,'et','Vali kliendi fail',0),(99445,2763,'si','Izberite datoteko kupca',0),(99446,2763,'ba','Pilih File pelanggan',0),(99447,2763,'nl','Selecteer klantenbestand',0),(99448,2763,'fi','Valitse asiakas-tiedosto',0),(99449,2763,'no','Velg kunden fil',0),(99450,2763,'da','VÃ¦lg kundefil',0),(99451,2763,'ko','ê³ ê° íŒŒì¼ ì„ íƒ',0),(99452,2763,'he','×‘×—×¨ ×§×•×‘×¥ ×œ×§×•×—',0),(99453,2763,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î‘ÏÏ‡ÎµÎ¯Î¿ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(99454,2763,'zh','é€‰æ‹©å®¢æˆ·æ¡£æ¡ˆ\r\n',0),(99455,2763,'sv','VÃ¤lj kundregister',0),(99456,2763,'it','Selezionare il File del cliente',0),(99457,2763,'tl','',0),(99458,2763,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3615;&#3621;&#3660;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(99459,2763,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99460,2763,'ms','Pilih fail pelanggan',0),(99461,2763,'ar','Ø¥Ø®ØªÙŠØ§Ø± Ù…Ù„Ù Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(99462,2763,'fr','SÃ©lectionnez le fichier client',0),(99463,2763,'jp','ä»–ã?®é¡§å®¢ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é?¸æŠž',0),(99464,2763,'pt','Selecione o arquivo do cliente',0),(99465,2763,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¤Ð°Ð¹Ð» ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(99466,2763,'es','Seleccionar File de Cliente',0),(99467,2763,'de','WÃ¤hlen Sie Kundendatei',0),(99468,2763,'en','Select Customer File',0),(99469,2764,'is','',0),(99470,2764,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ù…ÙˆØ¬ÙˆØ¯ ',0),(99471,2764,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ù…ÙˆØ¬ÙˆØ¯ ',0),(99472,2764,'tr','Varolan bir kullanÄ±cÄ± seÃ§in',0),(99473,2764,'pl','Wybierz istniejÄ…cego uÅ¼ytkownika',0),(99474,2764,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(99475,2764,'ur','Ú©Ø³ÛŒ Ù…ÙˆØ¬ÙˆØ¯Û ØµØ§Ø±Ù Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99476,2764,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›ÐµÐ³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(99477,2764,'vi','Chá»n NgÆ°á»i Sá»­ Dá»¥ng d9amg tá»“n táº¡i',0),(99478,2764,'af','Kies \'n bestaande gebruiker',0),(99479,2764,'ro','Alegeti un utilizator existent',0),(99480,2764,'et','Valige olemasolev kasutaja',0),(99481,2764,'si','Izberite obstojeÄega uporabnika',0),(99482,2764,'ba','Pilih pengguna yang ada',0),(99483,2764,'nl','Selecteer een bestaande gebruiker',0),(99484,2764,'fi','Valitse olemassa oleva kÃ¤yttÃ¤jÃ¤',0),(99485,2764,'no','Velg en eksisterende bruker',0),(99486,2764,'da','VÃ¦lg en eksisterende bruger',0),(99487,2764,'ko','ê¸°ì¡´ ì‚¬ìš©ìžë¥¼ ì„ íƒ',0),(99488,2764,'he','×‘×—×¨ ×ž×©×ª×ž×© ×§×™×™×',0),(99489,2764,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î±Î½ Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Ï‡ÏÎ®ÏƒÏ„Î·',0),(99490,2764,'zh','é€‰æ‹©ä¸€ä¸ªçŽ°æœ‰çš„ç”¨æˆ·\r\n',0),(99491,2764,'sv','VÃ¤lj en befintlig anvÃ¤ndare',0),(99492,2764,'it','Selezionare un utente esistente',0),(99493,2764,'tl','',0),(99494,2764,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;',0),(99495,2764,'hi','à¤•à¤¿à¤¸à¥€ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99496,2764,'ms','Pilih pengguna sedia ada',0),(99497,2764,'ar','Ø­Ø¯Ø¯ Ù…Ø³ØªØ®Ø¯Ù… Ù…ÙˆØ¬ÙˆØ¯',0),(99498,2764,'fr','SÃ©lectionnez un utilisateur existant',0),(99499,2764,'jp','æ—¢å­˜ã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’é?¸æŠž',0),(99500,2764,'pt','Selecione um usuÃ¡rio existente',0),(99501,2764,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÐµÐ³Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(99502,2764,'es','Seleccionar un usuario existente',0),(99503,2764,'de','WÃ¤hlen Sie einen vorhandenen Benutzer',0),(99504,2764,'en','Select an existing user',0),(99505,2765,'is','',0),(99506,2765,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„',0),(99507,2765,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„',0),(99508,2765,'tr','Dosya',0),(99509,2765,'pl','Plik',0),(99510,2765,'bg','Ð¤Ð°Ð¹Ð»',0),(99511,2765,'ur','Ù…Ø³Ù„',0),(99512,2765,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(99513,2765,'vi','Há»“ sÆ¡',0),(99514,2765,'af','LÃªer',0),(99515,2765,'ro','FiÅŸier',0),(99516,2765,'et','Vali fail',0),(99517,2765,'si','Datoteke',0),(99518,2765,'ba','File',0),(99519,2765,'nl','Bestand',0),(99520,2765,'fi','Tiedosto',0),(99521,2765,'no','Filen',0),(99522,2765,'da','Fil',0),(99523,2765,'ko','íŒŒì¼',0),(99524,2765,'he','×§×•×‘×¥',0),(99525,2765,'el','Î‘ÏÏ‡ÎµÎ¯Î¿',0),(99526,2765,'zh','æ–‡ä»¶\r\n',0),(99527,2765,'sv','Fil',0),(99528,2765,'it','File',0),(99529,2765,'tl','',0),(99530,2765,'th','&#3652;&#3615;&#3621;&#3660;',0),(99531,2765,'hi','à¤«à¤¼à¤¾à¤‡à¤²',0),(99532,2765,'ms','Fail',0),(99533,2765,'ar','Ø¥Ø®ØªÙŠØ§Ø± Ø§Ù„Ù…Ù„ÙÙ‘',0),(99534,2765,'fr','Fichier',0),(99535,2765,'jp','ãƒ•ã‚¡ã‚¤ãƒ«',0),(99536,2765,'pt','Arquivo',0),(99537,2765,'ru','Ð¤Ð°Ð¹Ð»',0),(99538,2765,'es','File',0),(99539,2765,'de','Datei',0),(99540,2765,'en','File',0),(99541,2766,'is','',0),(99542,2766,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ Ø¬Ù‡Øª Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙƒØªÙˆØ± ',0),(99543,2766,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ Ø¬Ù‡Øª Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙƒØªÙˆØ± ',0),(99544,2766,'tr','Fatura oluÅŸturmak iÃ§in Grup SeÃ§',0),(99545,2766,'pl','Wybierz grupÄ™, aby utworzyÄ‡ faktury',0),(99546,2766,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð³Ñ€ÑƒÐ¿Ð° Ð·Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(99547,2766,'ur','Ú¯Ø±ÙˆÙ¾ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ ØªØ®Ù„ÛŒÙ‚ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99548,2766,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸ Ð³Ñ€ÑƒÐ¿Ñƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(99549,2766,'vi','Chá»n nhÃ³m Ä‘á»ƒ ra hÃ³a Ä‘Æ¡n',0),(99550,2766,'af','Selekteer Groep om Faktuur te Skep',0),(99551,2766,'ro','SelectaÅ£i grupul pentru a crea facturi',0),(99552,2766,'et','Vali arve koostamiseks grupp',0),(99553,2766,'si','Izberi skupino tvoriti raÄun',0),(99554,2766,'ba','Pilih grup untuk membuat faktur',0),(99555,2766,'nl','Selecteer groep om factuur te maken',0),(99556,2766,'fi','Valitse ryhmÃ¤ luo lasku',0),(99557,2766,'no','Velg Group opprette faktura',0),(99558,2766,'da','VÃ¦lg gruppen oprette faktura',0),(99559,2766,'ko','ì†¡ìž¥ ë§Œë“¤ë ¤ë©´ ê·¸ë£¹ ì„ íƒ',0),(99560,2766,'he','×‘×—×¨ ×§×‘×•×¦×ª ×›×“×™ ×œ×™×¦×•×¨ ×—×©×‘×•× ×™×ª',0),(99561,2766,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¿Î¼Î¬Î´Î± Î³Î¹Î± Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(99562,2766,'zh','é€‰æ‹©ç»„ä»¥åˆ›å»ºå‘ç¥¨\r\n',0),(99563,2766,'sv','VÃ¤lj grupp skapa faktura',0),(99564,2766,'it','Seleziona il gruppo a creare fattura',0),(99565,2766,'tl','',0),(99566,2766,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3621;&#3640;&#3656;&#3617;&#3648;&#3614;&#3639;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(99567,2766,'hi','à¤¸à¤®à¥‚à¤¹ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¬à¤¨à¤¾à¤à¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99568,2766,'ms','Pilih Kumpulan untuk mencipta invois',0),(99569,2766,'ar','Ø­Ø¯Ø¯ Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¥Ù†Ø´Ø§Ø¡ ÙØ§ØªÙˆØ±Ø©',0),(99570,2766,'fr','SÃ©lectionner un groupe pour crÃ©er la facture',0),(99571,2766,'jp','è«‹æ±‚æ›¸ã‚’ä½œæˆ?ã?™ã‚‹ã‚°ãƒ«ãƒ¼ãƒ—ã‚’é?¸æŠž',0),(99572,2766,'pt','Selecionar grupo criar fatura',0),(99573,2766,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñƒ Ð´Ð»Ñ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°',0),(99574,2766,'es','Seleccionar Grupo para Crear Factura',0),(99575,2766,'de','WÃ¤hlen Sie Gruppe zum Rechnung erstellen',0),(99576,2766,'en','Select Group to Create Invoice',0),(99577,2767,'is','',0),(99578,2767,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§',0),(99579,2767,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§',0),(99580,2767,'tr','Ã–ÄŸeyi seÃ§in',0),(99581,2767,'pl','Wybierz element',0),(99582,2767,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(99583,2767,'ur','Ø´Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99584,2767,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(99585,2767,'vi','Chá»n hÃ ng',0),(99586,2767,'af','Kies Item',0),(99587,2767,'ro','SelectaÅ£i elementul',0),(99588,2767,'et','Ãœksuse valimine',0),(99589,2767,'si','Izberite element',0),(99590,2767,'ba','Pilih Item',0),(99591,2767,'nl','Selecteer Item',0),(99592,2767,'fi','Valitse kohde',0),(99593,2767,'no','Velg vare',0),(99594,2767,'da','VÃ¦lg vare',0),(99595,2767,'ko','í•­ëª© ì„ íƒ',0),(99596,2767,'he','×‘×—×¨ ×¤×¨×™×˜',0),(99597,2767,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(99598,2767,'zh','é€‰æ‹©é¡¹ç›®\r\n',0),(99599,2767,'sv','Markera objekt',0),(99600,2767,'it','Selezionare la voce',0),(99601,2767,'tl','',0),(99602,2767,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(99603,2767,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99604,2767,'ms','Pilih Item',0),(99605,2767,'ar','Ø§Ø®ØªØ± ØµÙ†Ù',0),(99606,2767,'fr','SÃ©lectionnez l\'Ã©lÃ©ment',0),(99607,2767,'jp','å“?ç›®ã?®é?¸æŠž',0),(99608,2767,'pt','Selecione o Item',0),(99609,2767,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€',0),(99610,2767,'es','Seleccionar Item',0),(99611,2767,'de','WÃ¤hlen Sie Element',0),(99612,2767,'en','Select Item',0),(99613,2768,'is','',0),(99614,2768,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§ Ùˆ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® Ø¬Ù‡Øª Ù¾Ø§ÙƒØ³Ø§Ø²ÙŠ',0),(99615,2768,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§ Ùˆ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® Ø¬Ù‡Øª Ù¾Ø§ÙƒØ³Ø§Ø²ÙŠ',0),(99616,2768,'tr','Ã–ÄŸe SeÃ§ veya tarih aralÄ±ÄŸÄ±nÄ± temizlemek iÃ§in',0),(99617,2768,'pl','Wybierz element lub zakres dat do usuniÄ™cia',0),(99618,2768,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð¸Ð»Ð¸ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ð´ÑƒÑ…Ð²Ð°Ð½Ðµ',0),(99619,2768,'ur','Ù¾Ø§Ú© Ú©Û’ Ù„ÛŒÛ’ Ø´Û’ ÛŒØ§ ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99620,2768,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÑƒ Ð¸Ð»Ð¸ Ñ€Ð°ÑÐ¿Ð¾Ð½ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð´Ð° Ð¾Ñ‡Ð¸ÑÑ‚Ð¸',0),(99621,2768,'vi','Chá»n hÃ ng hay pháº¡m vi ngÃ y Ä‘á»ƒ trá»¥c xuáº¥t',0),(99622,2768,'af','Kies Item of Datumreeks om te Verwyder (\"Purge\")',0),(99623,2768,'ro','SelectaÅ£i elementul sau intervalul de Date pentru a curÄƒÅ£a',0),(99624,2768,'et','Valige Ã¼ksus vÃµi kuupÃ¤evavahemik Purge',0),(99625,2768,'si','Izberite element ali datumski obseg za prezraÄevanje',0),(99626,2768,'ba','Pilih Item atau rentang tanggal untuk membersihkan',0),(99627,2768,'nl','Selecteer Item of datumbereik voor het zuiveren van',0),(99628,2768,'fi','Valitse nimike tai tietyn pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤vÃ¤lin sisÃ¤llÃ¤ puhdistaa',0),(99629,2768,'no','Velg varen eller datointervall for Ã¥ rense',0),(99630,2768,'da','VÃ¦lg vare eller datointerval for at rense',0),(99631,2768,'ko','ì†Œê±° í•­ëª© ë˜ëŠ” ë‚ ì§œ ë²”ìœ„ë¥¼ ì„ íƒ',0),(99632,2768,'he','×‘×—×¨ ×¤×¨×™×˜ ××• ×˜×•×•×— ×ª××¨×™×›×™× ×œ×˜×”×¨',0),(99633,2768,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î® ÎµÏÏÎ¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½ Î³Î¹Î± Î½Î± ÎµÎ¾Î±Î³Î½Î¯ÏƒÎµÎ¹',0),(99634,2768,'zh','é€‰æ‹©é¡¹ç›®æˆ–æ—¥æœŸèŒƒå›´æ¥æ¸…é™¤\r\n',0),(99635,2768,'sv','Markera objektet eller datumintervall fÃ¶r att rensa',0),(99636,2768,'it','Selezionare la voce o intervallo di Date per eliminare',0),(99637,2768,'tl','',0),(99638,2768,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3619;&#3639;&#3629;&#3649;&#3606;&#3623;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3635;&#3592;&#3633;&#3604;',0),(99639,2768,'hi','à¤¶à¥à¤¦à¥à¤§ à¤•à¤°à¤¨à¥‡ à¤†à¤‡à¤Ÿà¤® à¤¯à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99640,2768,'ms','Memilih Item tarikh tertentu untuk Singkir',0),(99641,2768,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø¹Ù†ØµØ± Ø£Ùˆ Ù†Ø·Ø§Ù‚ Ø§Ù„ØªØ§Ø±ÙŠØ® ØªØ·Ù‡ÙŠØ±',0),(99642,2768,'fr','SÃ©lectionnez l\'Ã©lÃ©ment ou la plage de dates pour purger',0),(99643,2768,'jp','å“?ç›®ã?®é?¸æŠžã‚‚ã?—ã??ã?¯æ¶ˆåŽ»ã?™ã‚‹æ—¥ç¨‹ç¯„å›²',0),(99644,2768,'pt','Selecione o Item ou o intervalo de datas para limpar',0),(99645,2768,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾Ñ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ',0),(99646,2768,'es','Seleccionar Item o Rango de Fechas para Purgar',0),(99647,2768,'de','WÃ¤hlen Sie oder Datumsbereich lÃ¶schen',0),(99648,2768,'en','Select Item or Date Range to Purge',0),(99649,2769,'is','',0),(99650,2769,'dr','(Ø³Ø±ÙŠ) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(99651,2769,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ØªÙ†Ø¸ÙŠÙ… (Ø³Ø±ÙŠ) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(99652,2769,'tr','BiÃ§imlendirme seÃ§eneÄŸini belirleyin',0),(99653,2769,'pl','Wybierz zestaw znacznikÃ³w',0),(99654,2769,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(99655,2769,'ur','Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99656,2769,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð·Ð½Ð°ÐºÐµ ÑÐºÑƒÐ¿',0),(99657,2769,'vi','Chá»n pháº§n cá»™ng thÃªm',0),(99658,2769,'af','Selekteer Prysverhoging',0),(99659,2769,'ro','SelectaÅ£i marcare Set',0),(99660,2769,'et','Valige mÃ¤rgistus',0),(99661,2769,'si','Izberite nabor oznak',0),(99662,2769,'ba','Pilih Markup Set',0),(99663,2769,'nl','Selecteer Markup Set',0),(99664,2769,'fi','Valitse merkinnÃ¤t',0),(99665,2769,'no','Velg markering',0),(99666,2769,'da','VÃ¦lg Markup sÃ¦t',0),(99667,2769,'ko','íƒœê·¸ ì„¸íŠ¸ë¥¼ ì„ íƒ',0),(99668,2769,'he','×‘×—×¨ ×¢×¨×›×ª ×¡×™×ž×•×Ÿ',0),(99669,2769,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÏƒÏÎ½Î¿Î»Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(99670,2769,'zh','é€‰æ‹©æ ‡è®°é›†\r\n',0),(99671,2769,'sv','VÃ¤lj markering',0),(99672,2769,'it','Selezionare Set di Markup',0),(99673,2769,'tl','',0),(99674,2769,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;',0),(99675,2769,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99676,2769,'ms','Pilih Set penanda',0),(99677,2769,'ar','Ø­Ø¯Ø¯ Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª',0),(99678,2769,'fr','SÃ©lectionnez le jeu d\'annotations',0),(99679,2769,'jp','å€¤ä¸Šã?’è¨­å®šã‚’é?¸æŠž',0),(99680,2769,'pt','Selecione o conjunto de marcaÃ§Ã£o',0),(99681,2769,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð±Ð¾Ñ€ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(99682,2769,'es','Seleccionar Juego de Encarecer',0),(99683,2769,'de','WÃ¤hlen Sie Markup festlegen',0),(99684,2769,'en','Select Markup Set',0),(99685,2770,'is','',0),(99686,2770,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(99687,2770,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(99688,2770,'tr','Yeni bir maliyet merkezi seÃ§in',0),(99689,2770,'pl','Wybierz nowe centrum kosztÃ³w',0),(99690,2770,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð² Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(99691,2770,'ur','Ø§ÛŒÚ© Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ù…Ø±Ú©Ø² Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99692,2770,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(99693,2770,'vi','Chá»n Cost Center má»›i',0),(99694,2770,'af','Kies \'n nuwe koste Sentrum',0),(99695,2770,'ro','SelectaÅ£i un nou centru de Cost',0),(99696,2770,'et','Valige uus Kulukeskus',0),(99697,2770,'si','Izberite novo stroÅ¡kovno srediÅ¡Äe',0),(99698,2770,'ba','Pilih pusat biaya baru',0),(99699,2770,'nl','Een nieuwe kostenplaats selecteren',0),(99700,2770,'fi','Valitse uusi kustannuspaikka',0),(99701,2770,'no','Velg en ny kostsenter',0),(99702,2770,'da','VÃ¦lg en ny bÃ¦rer',0),(99703,2770,'ko','ìƒˆë¡œìš´ ë¹„ìš© ì„¼í„°ë¥¼ ì„ íƒ',0),(99704,2770,'he','×‘×—×¨ ×ž×¨×›×– ×¢×œ×•×ª ×—×“×©',0),(99705,2770,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Î½Î­Î¿ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(99706,2770,'zh','é€‰æ‹©ä¸€ä¸ªæ–°çš„æˆæœ¬ä¸­å¿ƒ\r\n',0),(99707,2770,'sv','VÃ¤lj en ny kostnadsstÃ¤lle',0),(99708,2770,'it','Selezionare un nuovo centro di costo',0),(99709,2770,'tl','',0),(99710,2770,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3624;&#3641;&#3609;&#3618;&#3660;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3651;&#3627;&#3617;&#3656;',0),(99711,2770,'hi','à¤à¤• à¤¨à¤ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤¨à¥à¤¦à¥à¤° à¤•à¤¾ à¤šà¤¯à¤¨',0),(99712,2770,'ms','Pilih Pusat kos baru',0),(99713,2770,'ar','Ø­Ø¯Ø¯ Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© Ø¬Ø¯ÙŠØ¯',0),(99714,2770,'fr','SÃ©lectionnez un nouveau centre de coÃ»t',0),(99715,2770,'jp','æ–°è¦?ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?®é?¸æŠž',0),(99716,2770,'pt','Selecione um novo centro de custo',0),(99717,2770,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ†ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(99718,2770,'es','Seleccionar un nuevo Centro de Costos',0),(99719,2770,'de','WÃ¤hlen Sie eine neue Kostenstelle',0),(99720,2770,'en','Select a new Cost Center',0),(99721,2771,'is','',0),(99722,2771,'dr','/ Ù†Ù‡Ø§ÙŠÙŠ ÙƒØ±Ø¯Ù† ',0),(99723,2771,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø¨Ø§Ø² Ø¬Ù‡Øª ÙˆÙŠØ±Ø§ÙŠØ´  / Ù†Ù‡Ø§ÙŠÙŠ ÙƒØ±Ø¯Ù† ',0),(99724,2771,'tr','AÃ§Ä±k yapÄ± dÃ¼zeni seÃ§in<br>EDIT/sonlandÄ±rma',0),(99725,2771,'pl','Wybierz opcjÄ™ otwarte Build Order<br>Edycja/sfinalizowania',0),(99726,2771,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½ Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°<br>Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ñ„Ð¸Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(99727,2771,'ur','Ú©Ú¾Ù„ÛŒ ØªØ¹Ù…ÛŒØ± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº<br>ØªØ¯ÙˆÛŒÙ†/Ø­ØªÙ…ÛŒ Ø´Ú©Ù„ Ø¯ÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’',0),(99728,2771,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¾Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ð‘ÑƒÐ¸Ð»Ð´<br>Ð´Ð° Ð£Ñ€ÐµÐ´Ð¸/Ñ„Ð¸Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚Ð¸',0),(99729,2771,'vi','Chá»n Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng Ä‘á»ƒ Sá»­a/Káº¿t ThÃºc',0),(99730,2771,'af','Kies oop bou orde<br>Redigeer/POMA',0),(99731,2771,'ro','SelectaÅ£i ordinea de Open construi<br>pentru a edita/finaliza',0),(99732,2771,'et','Valige avatud ehitada tellimus<br>Edit/lÃµpule',0),(99733,2771,'si','Izberite Odpri izgradnje<br>Uredi/dokonÄana',0),(99734,2771,'ba','Pilih Buka membangun Order<br>untuk mengedit/menyelesaikan',0),(99735,2771,'nl','Selecteer Open opbouwvolgorde<br>om te bewerken/ronden',0),(99736,2771,'fi','Valitse avoimen tilauksen mukaan<br>Muokkaa/viimeistelemÃ¤Ã¤n',0),(99737,2771,'no','Velg Ã…pne bygge<br>Rediger/fullfÃ¸re',0),(99738,2771,'da','VÃ¦lg Ã¥ben Byg efter ordre<br>Rediger/fÃ¦rdiggÃ¸re',0),(99739,2771,'ko','ì˜¤í”ˆ ë¹Œë“œ ìˆœì„œë¥¼ ì„ íƒ í•©ë‹ˆë‹¤<br>íŽ¸ì§‘/ë§ˆë¬´ë¦¬',0),(99740,2771,'he','×‘×—×¨ ×‘× ×™×” ×¤×ª×•×— ×”×–×ž× ×”<br>×›×“×™ ×œ×¡×’×•×¨/×¢×¨×™×›×”',0),(99741,2771,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÏƒÎµÎ¹ÏÎ¬ Î¿Î¹ÎºÎ¿Î´Î¿Î¼Î¿ÏÎ½ Î±Î½Î¿Î¹ÎºÏ„Î­Ï‚<br>Î³Î¹Î± Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±/Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ·',0),(99742,2771,'zh','é€‰æ‹©å…¬å¼€æž„å»ºé¡ºåºä»¥ç¼–è¾‘/ç¡®å®š\r\n',0),(99743,2771,'sv','VÃ¤lj Ã–ppna bygga Order<br>att redigera/fÃ¤rdigstÃ¤lla',0),(99744,2771,'it','Selezionare l\'ordine di compilazione aperta<br>Edit/finalizzare',0),(99745,2771,'tl','',0),(99746,2771,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3626;&#3619;&#3657;&#3634;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629; &#3649;&#3585;&#3657;&#3652;&#',0),(99747,2771,'hi','à¤“à¤ªà¤¨ à¤¬à¤¿à¤²à¥à¤¡ à¤•à¥à¤°à¤® à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚<br>à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚/à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¥‡à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(99748,2771,'ms','Pilih pesanan terbuka membina<br>untuk mengedit/mengesahkan',0),(99749,2771,'ar','Ø­Ø¯Ø¯ ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙØªÙˆØ­Ø©<br>Ù„ÙˆØ¶Ø¹ Ø§Ù„Ù„Ù…Ø³Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø© Ø¹Ù„Ù‰/ØªØ­Ø±ÙŠØ±',0),(99750,2771,'fr','SÃ©lectionnez l\'ordre de construction ouverte<br>Edit/finaliser',0),(99751,2771,'jp','ç·¨é›†/å®Œäº†ã?™ã‚‹ã‚ªãƒ¼ãƒ—ãƒ³çµ„ç«‹æ³¨æ–‡ã?®é?¸æŠž',0),(99752,2771,'pt','Selecione a ordem de compilaÃ§Ã£o aberta<br>para editar/finalizar',0),(99753,2771,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ…<br>Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ/Ð·Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ',0),(99754,2771,'es','Seleccionar Orden de ConstrucciÃ³n para Editar/Finalizar',0),(99755,2771,'de','WÃ¤hlen Sie offene Buildreihenfolge<br>Bearbeiten/abschlieÃŸen',0),(99756,2771,'en','Select Open Build Order<br>to Edit/Finalize',0),(99757,2772,'is','',0),(99758,2772,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ØµÙØ­Ù‡',0),(99759,2772,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ØµÙØ­Ù‡',0),(99760,2772,'tr','Sayfa SeÃ§',0),(99761,2772,'pl','Wybierz stronÄ™',0),(99762,2772,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(99763,2772,'ur','ØµÙØ­Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99764,2772,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(99765,2772,'vi','Chá»n trang',0),(99766,2772,'af','Kies bladsy',0),(99767,2772,'ro','SelectaÅ£i pagina',0),(99768,2772,'et','Vali lehekÃ¼lg',0),(99769,2772,'si','Izberite stran',0),(99770,2772,'ba','Pilih Halaman',0),(99771,2772,'nl','Selecteer pagina',0),(99772,2772,'fi','Valitse sivu',0),(99773,2772,'no','Velg side',0),(99774,2772,'da','VÃ¦lg side',0),(99775,2772,'ko','íŽ˜ì´ì§€ ì„ íƒ',0),(99776,2772,'he','×‘×—×¨ ×“×£',0),(99777,2772,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÏƒÎµÎ»Î¯Î´Î±',0),(99778,2772,'zh','é€‰æ‹©é¡µ\r\n',0),(99779,2772,'sv','VÃ¤lj sida',0),(99780,2772,'it','Selezionare la pagina',0),(99781,2772,'tl','',0),(99782,2772,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3627;&#3609;&#3657;&#3634;',0),(99783,2772,'hi','à¤ªà¥ƒà¤·à¥à¤  à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99784,2772,'ms','Pilih Laman',0),(99785,2772,'ar','Ø­Ø¯Ø¯ Ø§Ù„ØµÙØ­Ø©',0),(99786,2772,'fr','SÃ©lectionnez la Page',0),(99787,2772,'jp','ãƒšãƒ¼ã‚¸ã?®é?¸æŠž',0),(99788,2772,'pt','Selecione a pÃ¡gina',0),(99789,2772,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(99790,2772,'es','Seleccionar PÃ¡gina',0),(99791,2772,'de','WÃ¤hlen Sie die Seite',0),(99792,2772,'en','Select Page',0),(99793,2773,'is','',0),(99794,2773,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø­Ù‚ÙˆÙ‚',0),(99795,2773,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø­Ù‚ÙˆÙ‚',0),(99796,2773,'tr','Ã–deme dÃ¶nemi seÃ§in',0),(99797,2773,'pl','Wybierz okresu rozliczeniowego',0),(99798,2773,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(99799,2773,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¯Øª Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99800,2773,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐŸÐµÑ€Ð¸Ð¾Ð´ Ð¿Ð»Ð°Ñ‚Ðµ',0),(99801,2773,'vi','Chá»n ká»³ thanh toÃ¡n',0),(99802,2773,'af','Kies Stoor Besoldigingsperiode',0),(99803,2773,'ro','SelectaÅ£i perioadÄƒ de platÄƒ',0),(99804,2773,'et','Saate valida tasuperioodi',0),(99805,2773,'si','Izberite plaÄilno obdobje',0),(99806,2773,'ba','Pilih bayar periode',0),(99807,2773,'nl','Selecteer betalen periode',0),(99808,2773,'fi','Valitse maksukausi',0),(99809,2773,'no','Velg lÃ¸nnsperioden',0),(99810,2773,'da','VÃ¦lg lÃ¸nperiode',0),(99811,2773,'ko','ì§€ë¶ˆ ê¸°ê°„ ì„ íƒ',0),(99812,2773,'he','×‘×—×¨ ×¤×¨×§ ×©×œ×',0),(99813,2773,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿Ï„Î¹ÎºÎ®Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(99814,2773,'zh','é€‰æ‹©æ”¯ä»˜æœŸé™\r\n',0),(99815,2773,'sv','VÃ¤lj betalningsperiod',0),(99816,2773,'it','Selezionare il periodo di paga',0),(99817,2773,'tl','',0),(99818,2773,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(99819,2773,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99820,2773,'ms','Pilih tempoh pembayaran gaji',0),(99821,2773,'ar','Ø­Ø¯Ø¯ ÙØªØ±Ø© Ø§Ù„Ø¯ÙØ¹',0),(99822,2773,'fr','SÃ©lectionnez la pÃ©riode de paie',0),(99823,2773,'jp','çµ¦ä¸ŽæœŸé–“ã?®é?¸æŠž',0),(99824,2773,'pt','Selecione o perÃ­odo de pagamento',0),(99825,2773,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(99826,2773,'es','Seleccionar PerÃ­odo de Pago',0),(99827,2773,'de','WÃ¤hlen Sie Arbeitsentgelt',0),(99828,2773,'en','Select Pay Period',0),(99829,2774,'is','',0),(99830,2774,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø­Ù‚ÙˆÙ‚',0),(99831,2774,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø­Ù‚ÙˆÙ‚',0),(99832,2774,'tr','Ã–deme dÃ¶nem tarihleri seÃ§in',0),(99833,2774,'pl','Wybierz daty pÅ‚atnoÅ›ci',0),(99834,2774,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð¸Ñ‚Ðµ Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð½Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(99835,2774,'ur','ØªÙ†Ø®ÙˆØ§Û Ø¯ÙˆØ± ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99836,2774,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð¿Ð»Ð°Ñ‚Ðµ',0),(99837,2774,'vi','Chá»n ngÃ y cá»§a ká»³ thanh toÃ¡n',0),(99838,2774,'af','Kies Besoldigingsperiode Datums',0),(99839,2774,'ro','SelectaÅ£i datele perioadei de plata',0),(99840,2774,'et','Valige maksmise perioodi kuupÃ¤evad',0),(99841,2774,'si','Izberite obdobje datumi plaÄila',0),(99842,2774,'ba','Pilihan jangka waktu bayar',0),(99843,2774,'nl','Selecteer betalen periode datums',0),(99844,2774,'fi','Valitse maksu ajanjakson pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(99845,2774,'no','Velg betale periodedatoene',0),(99846,2774,'da','VÃ¦lg betalings periode datoer',0),(99847,2774,'ko','ì§€ë¶ˆ ê¸°ê°„ ë‚ ì§œ ì„ íƒ',0),(99848,2774,'he','×‘×—×¨ ×ª××¨×™×›×™ ×ª×§×•×¤×ª ×”×ª×©×œ×•×',0),(99849,2774,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€ÎµÏÎ¯Î¿Î´Î¿ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(99850,2774,'zh','é€‰æ‹©æ”¯ä»˜æœŸé™æ—¥æœŸ\r\n',0),(99851,2774,'sv','VÃ¤lj betala periodens datum',0),(99852,2774,'it','Seleziona le date di periodo di paga',0),(99853,2774,'tl','',0),(99854,2774,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3594;&#3656;&#3623;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(99855,2774,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99856,2774,'ms','Pilih tarikh tempoh gaji',0),(99857,2774,'ar','Ø­Ø¯Ø¯ ØªÙˆØ§Ø±ÙŠØ® Ø§Ù„ÙØªØ±Ø© Ø§Ù„Ø£Ø¬Ø±',0),(99858,2774,'fr','SÃ©lectionnez les Dates de pÃ©riode de paie',0),(99859,2774,'jp','çµ¦ä¸ŽæœŸé–“æ—¥ä»˜ã?®é?¸æŠž',0),(99860,2774,'pt','Seleccione as datas de perÃ­odo de pagamento',0),(99861,2774,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”Ð°Ñ‚Ñƒ Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ð¾Ð³Ð¾ ÐŸÐµÑ€Ð¸Ð¾Ð´Ð°',0),(99862,2774,'es','Seleccionar las Fechas de PerÃ­odo de Pago',0),(99863,2774,'de','WÃ¤hlen Sie zahlen Periodendaten',0),(99864,2774,'en','Select Pay Period Dates',0),(99865,2775,'is','',0),(99866,2775,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø·Ø±Ø­ ',0),(99867,2775,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø·Ø±Ø­ ',0),(99868,2775,'tr','PlanÄ± seÃ§in',0),(99869,2775,'pl','Wybierz Plan',0),(99870,2775,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð»Ð°Ð½',0),(99871,2775,'ur','Ù…Ù†ØµÙˆØ¨Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99872,2775,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐŸÐ»Ð°Ð½',0),(99873,2775,'vi','Chá»n káº¿ hoáº¡ch',0),(99874,2775,'af','Kies Plan',0),(99875,2775,'ro','SelectaÅ£i planul',0),(99876,2775,'et','Valige reÅ¾iim',0),(99877,2775,'si','Izberite naÄrt',0),(99878,2775,'ba','Pilih rencana',0),(99879,2775,'nl','Selecteer Plan',0),(99880,2775,'fi','Valitse suunnitelma',0),(99881,2775,'no','Velg planen',0),(99882,2775,'da','VÃ¦lg Plan',0),(99883,2775,'ko','ê³„íšì„ ì„ íƒ',0),(99884,2775,'he','×‘×—×¨ ×ª×›× ×™×ª',0),(99885,2775,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ ÏƒÏ‡Î­Î´Î¹Î¿',0),(99886,2775,'zh','é€‰æ‹©è®¡åˆ’\r\n',0),(99887,2775,'sv','VÃ¤lj Plan',0),(99888,2775,'it','Selezionare il piano',0),(99889,2775,'tl','',0),(99890,2775,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3649;&#3612;&#3609;',0),(99891,2775,'hi','à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99892,2775,'ms','Pilih pelan',0),(99893,2775,'ar','Ø¥Ø®ØªÙŠØ§Ø± Ø®Ø·Ù‘Ø©',0),(99894,2775,'fr','SÃ©lectionnez Plan',0),(99895,2775,'jp','è¨ˆç”»ã?®é?¸æŠž',0),(99896,2775,'pt','Selecione o plano',0),(99897,2775,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐŸÐ»Ð°Ð½',0),(99898,2775,'es','Seleccionar Plan',0),(99899,2775,'de','WÃ¤hlen Sie Plan',0),(99900,2775,'en','Select Plan',0),(99901,2776,'is','',0),(99902,2776,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ Ø¬Ù‡Øª ÙˆÙŠØ±Ø§ÙŠØ´',0),(99903,2776,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ Ø¬Ù‡Øª ÙˆÙŠØ±Ø§ÙŠØ´',0),(99904,2776,'tr','SatÄ±ÅŸ iÅŸlemi dÃ¼zenlemek iÃ§in seÃ§in',0),(99905,2776,'pl','Wybierz procesu sprzedaÅ¼y do edycji',0),(99906,2776,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(99907,2776,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ„Ø² Ø¹Ù…Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99908,2776,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(99909,2776,'vi','Chá»n QuÃ¡ TrÃ¬nh BÃ¡n HÃ ng Äá»ƒ Chá»‰nh Sá»­a',0),(99910,2776,'af','Kies verkope proses om te redigeer',0),(99911,2776,'ro','SelectaÅ£i procesul de vÃ¢nzare pentru a edita',0),(99912,2776,'et','Valige redigeerimiseks mÃ¼Ã¼giprotsessi',0),(99913,2776,'si','Izberite prodajni proces za urejanje',0),(99914,2776,'ba','Pilih proses penjualan untuk mengedit',0),(99915,2776,'nl','Selecteer verkoopproces bewerken',0),(99916,2776,'fi','Valitse muokattava myyntiprosessin',0),(99917,2776,'no','Velg salgsprosessen redigere',0),(99918,2776,'da','VÃ¦lg salgsproces redigere',0),(99919,2776,'ko','íŽ¸ì§‘ í•˜ë ¤ë©´ ì˜ì—… í”„ë¡œì„¸ìŠ¤ ì„ íƒ',0),(99920,2776,'he','×‘×—×¨ ×ª×”×œ×™×š ×ž×›×™×¨×•×ª ×œ×¢×¨×™×›×”',0),(99921,2776,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½, Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(99922,2776,'zh','é€‰æ‹©é”€å”®æµç¨‹ç¼–è¾‘\r\n',0),(99923,2776,'sv','VÃ¤lj fÃ¶rsÃ¤ljning Process fÃ¶r att redigera',0),(99924,2776,'it','Selezionare il processo di vendita per modificare',0),(99925,2776,'tl','',0),(99926,2776,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(99927,2776,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(99928,2776,'ms','Pilih proses jualan untuk mengedit',0),(99929,2776,'ar','Ø­Ø¯Ø¯ Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ØªØ­Ø±ÙŠØ±',0),(99930,2776,'fr','SÃ©lectionnez le processus de vente pour modifier',0),(99931,2776,'jp','ç·¨é›†ã?™ã‚‹ã‚»ãƒ¼ãƒ«ã‚¹ãƒ—ãƒ­ã‚»ã‚¹ã?®é?¸æŠž',0),(99932,2776,'pt','Selecione o processo de vendas para editar',0),(99933,2776,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÑ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(99934,2776,'es','Seleccionar Proceso de Ventas para Editar',0),(99935,2776,'de','WÃ¤hlen Sie Vertriebsprozess bearbeiten',0),(99936,2776,'en','Select Sales Process to Edit',0),(99937,2777,'is','',0),(99938,2777,'dr','(Ø¨Ø¯ÙˆÙ† Ø§Ù†ØªØ®Ø§Ø¨ ØªÙ…Ø§Ù… Ø±Ù†Ú¯ Ù‡Ø§',0),(99939,2777,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø±Ù†Ú¯ Ù‡Ø§ÙŠ Ø®Ø§Øµ (Ø¨Ø¯ÙˆÙ† Ø§Ù†ØªØ®Ø§Ø¨ ØªÙ…Ø§Ù… Ø±Ù†Ú¯ Ù‡Ø§',0),(99940,2777,'tr','Belirli renkleri seÃ§me (seÃ§im tÃ¼m renkler =)',0),(99941,2777,'pl','Wybierz okreÅ›lone kolory (nie ma wyboru = wszystkie kolory)',0),(99942,2777,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ð¸ Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ (Ð½ÑÐ¼Ð° ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ = Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ)',0),(99943,2777,'ur','Ù…Ø®ØµÙˆØµ Ø±Ù†Ú¯ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº (Ú©ÙˆØ¦ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ = ØªÙ…Ø§Ù… Ø±Ù†Ú¯)',0),(99944,2777,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ñƒ Ð±Ð¾Ñ˜Ñƒ (Ð±ÐµÐ· ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ðµ = ÑÐ²Ðµ Ð±Ð¾Ñ˜Ðµ)',0),(99945,2777,'vi','Chá»n mÃ u cá»¥ thá»ƒ',0),(99946,2777,'af','Kies spesifieke kleure (geen seleksie = alle kleure)',0),(99947,2777,'ro','SelectaÅ£i culorile specifice (nicio selecÅ£ie = toate culorile)',0),(99948,2777,'et','Saate valida kindlad vÃ¤rvid (no valik = kÃµik vÃ¤rvid)',0),(99949,2777,'si','Izberite barve (ni izbor = vse barve)',0),(99950,2777,'ba','Pilih warna tertentu (pilihan tidak = semua warna)',0),(99951,2777,'nl','Selecteer specifieke kleuren (geen selectie = alle kleuren)',0),(99952,2777,'fi','Valitse tiettyjÃ¤ vÃ¤rejÃ¤ (ei valintaa = kaikki vÃ¤rit)',0),(99953,2777,'no','Velge spesifikke farger (ingen valg = alle farger)',0),(99954,2777,'da','VÃ¦lg bestemte farver (ingen markering = alle farver)',0),(99955,2777,'ko','íŠ¹ì • ìƒ‰ìƒì„ ì„ íƒ í•©ë‹ˆë‹¤ (ì„ íƒ í•˜ì§€ ëª¨ë“  ìƒ‰ìƒì„ =)',0),(99956,2777,'he','×œ×‘×—×™×¨×ª ×¦×‘×¢×™× ×ž×¡×•×™×ž×™× (×œ× × ×¢×©×ª×” ×‘×—×™×¨×” = ×›×œ ×”×¦×‘×¢×™×)',0),(99957,2777,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î± Ï‡ÏÏŽÎ¼Î±Ï„Î± (ÎµÏ€Î¹Î»Î¿Î³Î® Î´ÎµÎ½ = ÏŒÎ»Î± Ï„Î± Ï‡ÏÏŽÎ¼Î±Ï„Î±)',0),(99958,2777,'zh','é€‰æ‹©ç‰¹å®šçš„é¢œè‰²ï¼ˆä¸é€‰æ‹©=æ‰€æœ‰é¢œè‰²ï¼‰\r\n',0),(99959,2777,'sv','Markera specifika fÃ¤rger (inget val = alla fÃ¤rger)',0),(99960,2777,'it','Selezionare colori specifici (nessuna selezione = tutti i colori)',0),(99961,2777,'tl','',0),(99962,2777,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3637;&#3607;&#3637;&#3656;&#3619;&#3632;&#3610;&#3640;(&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;=&#3607;&#3640;&#3585;&#3626;&#3637;)',0),(99963,2777,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤°à¤‚à¤— à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ (à¤•à¥‹à¤ˆ à¤šà¤¯à¤¨ à¤¸à¤­à¥€ à¤°à¤‚à¤— =)',0),(99964,2777,'ms','Pilih warna-warna tertentu (tiada pilihan = semua warna)',0),(99965,2777,'ar','Ø­Ø¯Ø¯ \"Ø£Ù„ÙˆØ§Ù† Ù…Ø­Ø¯Ø¯Ø©\" (Ø£ÙŠ Ø§Ù„ØªØ­Ø¯ÙŠØ¯ = Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø£Ù„ÙˆØ§Ù†)',0),(99966,2777,'fr','SÃ©lectionnez les couleurs spÃ©cifiques (pas de sÃ©lection = toutes les couleurs)',0),(99967,2777,'jp','ç‰¹å®šã?®è‰²ã?®é?¸æŠžï¼ˆé?¸æŠžã?ªã?—ï¼?å…¨ã?¦ã?®è‰²ï¼‰',0),(99968,2777,'pt','Selecione cores especÃ­ficas (nenhuma seleÃ§Ã£o = todas as cores)',0),(99969,2777,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ñ‹Ðµ Ð¦Ð²ÐµÑ‚Ð° (Ð½ÐµÑ‚ Ð²Ñ‹Ð±Ð¾Ñ€Ð°=Ð²ÑÐµ Ñ†Ð²ÐµÑ‚Ð°)',0),(99970,2777,'es','Seleccionar Colores EspecÃ­ficos (no selecciÃ³n=todos los colores)',0),(99971,2777,'de','WÃ¤hlen Sie bestimmte Farben (keine Auswahl = alle Farben)',0),(99972,2777,'en','Select Specific Colors (no selection=all colors)',0),(99973,2778,'is','',0),(99974,2778,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§',0),(99975,2778,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§',0),(99976,2778,'tr','Bu Ã¶ÄŸe iÃ§in seÃ§in',0),(99977,2778,'pl','Wybierz opcjÄ™ dostawcy dla tego przedmiotu',0),(99978,2778,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(99979,2778,'ur','Ø§Ø³ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ ÙˆÛŒÙ†ÚˆØ± Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(99980,2778,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(99981,2778,'vi','Chá»n ngÆ°á»i bÃ¡n cho hÃ ng nÃ y',0),(99982,2778,'af','Kies handelaar vir hierdie Item',0),(99983,2778,'ro','SelectaÅ£i furnizor pentru acest element',0),(99984,2778,'et','Valige hankija selle kauba kohta',0),(99985,2778,'si','Izberite dobavitelja za ta element',0),(99986,2778,'ba','Pilih Vendor untuk Item ini',0),(99987,2778,'nl','Leverancier voor dit object selecteren',0),(99988,2778,'fi','Valitse toimittaja tÃ¤lle kohteelle',0),(99989,2778,'no','Velg leverandÃ¸r for denne varen',0),(99990,2778,'da','VÃ¦lg kreditor for dette element',0),(99991,2778,'ko','ì´ í•­ëª©ì— ëŒ€ í•œ ê³µê¸‰ ì—…ì²´ ì„ íƒ',0),(99992,2778,'he','×‘×—×¨ ×¡×¤×§ ×¢×‘×•×¨ ×¤×¨×™×˜ ×–×”',0),(99993,2778,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(99994,2778,'zh','é€‰æ‹©æ­¤é¡¹ç›®ä¾›åº”å•†\r\n',0),(99995,2778,'sv','VÃ¤lj leverantÃ¶r fÃ¶r objektet',0),(99996,2778,'it','Selezionare il fornitore per questo elemento',0),(99997,2778,'tl','',0),(99998,2778,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3627;&#3634;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;',0),(99999,2778,'hi','à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(100000,2778,'ms','Pilih pembekal untuk Item ini',0),(100001,2778,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ù…ÙˆØ±Ø¯ Ù„Ù‡Ø°Ø§ Ø§Ù„ØµÙ†Ù',0),(100002,2778,'fr','SÃ©lectionnez fournisseur pour cet article',0),(100003,2778,'jp','ã?“ã?®å“?ç›®ã?®æ¥­è€…ã‚’é?¸æŠž',0),(100004,2778,'pt','Selecionar fornecedores para este Item',0),(100005,2778,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(100006,2778,'es','Seleccionar EspecÃ­ficos Proveedor para este Item',0),(100007,2778,'de','WÃ¤hlen Sie Hersteller fÃ¼r diesen Artikel',0),(100008,2778,'en','Select Vendor for this Item',0),(100009,2779,'is','',0),(100010,2779,'dr','Ø¯Ø± Ù‚Ø³Ù…Øª Ø²ÙŠØ± Ø´Ø±ÙƒØª Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(100011,2779,'pr','Ø¯Ø± Ù‚Ø³Ù…Øª Ø²ÙŠØ± Ø´Ø±ÙƒØª Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(100012,2779,'tr','AÅŸaÄŸÄ±da ÅŸirket seÃ§in,',0),(100013,2779,'pl','Wybierz firmÄ™ poniÅ¼ej,',0),(100014,2779,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ, ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð°',0),(100015,2779,'ur','Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚºØŒ',0),(100016,2779,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ðµ Ð¸ÑÐ¿Ð¾Ð´,',0),(100017,2779,'vi','Chá»n cty dÆ°á»›i Ä‘Ã¢y',0),(100018,2779,'af','Kies die Onderneming hieronder,',0),(100019,2779,'ro','SelectaÅ£i companie de mai jos,',0),(100020,2779,'et','Vali ettevÃµte',0),(100021,2779,'si','Izberite podjetje, ki je spodaj,',0),(100022,2779,'ba','Pilih perusahaan di bawah ini,',0),(100023,2779,'nl','Selecteer het bedrijf hieronder,',0),(100024,2779,'fi','Valitse yrityksen alla,',0),(100025,2779,'no','Velg firmaet nedenfor,',0),(100026,2779,'da','VÃ¦lg det regnskab, der er nedenfor,',0),(100027,2779,'ko','ì•„ëž˜ì˜ íšŒì‚¬ ì„ íƒ',0),(100028,2779,'he',',×‘×—×¨ ××ª ×”×—×‘×¨×” ×œ×”×œ×Ÿ',0),(100029,2779,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰,',0),(100030,2779,'zh','é€‰æ‹©ä¸‹é¢çš„å…¬å¸ï¼Œ\r\n',0),(100031,2779,'sv','VÃ¤lj fÃ¶retaget som nedan,',0),(100032,2779,'it','Selezionare la societÃ  sottostante,',0),(100033,2779,'tl','',0),(100034,2779,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3586;&#3657;&#3634;&#3591;&#3621;&#3656;&#3634;&#3591;',0),(100035,2779,'hi','à¤¨à¥€à¤šà¥‡ à¤¦à¥€ à¤—à¤ˆ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤šà¤¯à¤¨,',0),(100036,2779,'ms','Pilih Syarikat yang di bawah ini,',0),(100037,2779,'ar','Ø¥Ø®ØªÙŠØ§Ø± Ø§Ù„Ø´Ø±ÙƒØ© Ø£Ø¯Ù†Ø§Ù‡',0),(100038,2779,'fr','SÃ©lectionnez la sociÃ©tÃ© ci-dessous,',0),(100039,2779,'jp','ä¸‹è¨˜ã?®ä¼šç¤¾ã‚’é?¸æŠž',0),(100040,2779,'pt','Selecione abaixo, a empresa',0),(100041,2779,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ Ð½Ð¸Ð¶Ðµ,',0),(100042,2779,'es','Seleccionar abajo la Empresa',0),(100043,2779,'de','WÃ¤hlen Sie die Firma unten,',0),(100044,2779,'en','Select the Company below,',0),(100045,2780,'is','',0),(100046,2780,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø§Ø¨Ø²Ø§Ø± Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´',0),(100047,2780,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø§Ø¨Ø²Ø§Ø± Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´',0),(100048,2780,'tr','DÃ¼zenleme aracÄ±nÄ± seÃ§in',0),(100049,2780,'pl','Wybierz narzÄ™dzie do edycji',0),(100050,2780,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(100051,2780,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ù¹ÙˆÙ„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(100052,2780,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð°Ð»Ð°Ñ‚ÐºÑƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÑ€ÐµÐ´Ð¸Ð»Ð¸',0),(100053,2780,'vi','Chá»n CÃ´ng Cá»¥ Äá»ƒ Chá»‰nh Sá»­a',0),(100054,2780,'af','Kies instrument om te redigeer',0),(100055,2780,'ro','SelectaÅ£i instrumentul pentru a edita',0),(100056,2780,'et','Valige abil muuta',0),(100057,2780,'si','Izberite orodje za urejanje',0),(100058,2780,'ba','Pilih alat untuk mengedit',0),(100059,2780,'nl','Selecteer gereedschap om te bewerken',0),(100060,2780,'fi','Valitse tyÃ¶kalu muokata',0),(100061,2780,'no','Velg for Ã¥ redigere',0),(100062,2780,'da','VÃ¦lg vÃ¦rktÃ¸j til at redigere',0),(100063,2780,'ko','íŽ¸ì§‘ ë„êµ¬ë¥¼ ì„ íƒ',0),(100064,2780,'he','×‘×—×¨ ×›×œ×™ ×œ×¢×¨×™×›×”',0),(100065,2780,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ Î³Î¹Î± Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(100066,2780,'zh','é€‰æ‹©å·¥å…·æ¥ç¼–è¾‘\r\n',0),(100067,2780,'sv','VÃ¤lj verktyg fÃ¶r att redigera',0),(100068,2780,'it','Seleziona strumento per modificare',0),(100069,2780,'tl','',0),(100070,2780,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(100071,2780,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(100072,2780,'ms','Pilih alat untuk mengedit',0),(100073,2780,'ar','Ø­Ø¯Ø¯ Ø£Ø¯Ø§Ø© ØªØ­Ø±ÙŠØ±',0),(100074,2780,'fr','SÃ©lectionnez l\'outil d\'Ã©dition',0),(100075,2780,'jp','ç·¨é›†ã?™ã‚‹ãƒ„ãƒ¼ãƒ«ã?®é?¸æŠž',0),(100076,2780,'pt','Selecione a ferramenta editar',0),(100077,2780,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ð´Ð»Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(100078,2780,'es','Seleccionar Herramienta para Editar',0),(100079,2780,'de','WÃ¤hlen Sie Bearbeiten-Werkzeug',0),(100080,2780,'en','Select Tool to Edit',0),(100081,2781,'is','',0),(100082,2781,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(100083,2781,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(100084,2781,'tr','SatÄ±cÄ±yÄ± seÃ§in',0),(100085,2781,'pl','Wybierz dostawcÄ™',0),(100086,2781,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(100087,2781,'ur','ÙˆÛŒÙ†ÚˆØ± Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(100088,2781,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(100089,2781,'vi','Chá»n ngÆ°á»i bÃ¡n ',0),(100090,2781,'af','Kies handelaar',0),(100091,2781,'ro','SelecteazÄƒ furnizor',0),(100092,2781,'et','Vali tarnija',0),(100093,2781,'si','Izberite prodajalca',0),(100094,2781,'ba','Pilih Vendor',0),(100095,2781,'nl','Leverancier selecteren',0),(100096,2781,'fi','Valitse toimittaja',0),(100097,2781,'no','Velg leverandÃ¸r',0),(100098,2781,'da','VÃ¦lg kreditor',0),(100099,2781,'ko','ê³µê¸‰ ì—…ì²´ ì„ íƒ',0),(100100,2781,'he','×‘×—×¨ ×¡×¤×§',0),(100101,2781,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(100102,2781,'zh','é€‰æ‹©ä¾›åº”å•†\r\n',0),(100103,2781,'sv','VÃ¤lj leverantÃ¶r',0),(100104,2781,'it','Selezionare fornitore',0),(100105,2781,'tl','',0),(100106,2781,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(100107,2781,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(100108,2781,'ms','Pilih Vendor',0),(100109,2781,'ar','Ø§Ø®ØªØ± Ù…ÙˆØ±Ø¯',0),(100110,2781,'fr','SÃ©lectionnez fournisseur',0),(100111,2781,'jp','æ¥­è€…ã?®é?¸æŠž',0),(100112,2781,'pt','Selecione o fornecedor',0),(100113,2781,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(100114,2781,'es','Seleccionar Proveedor',0),(100115,2781,'de','WÃ¤hlen Sie Kreditor',0),(100116,2781,'en','Select Vendor',0),(100117,2782,'is','',0),(100118,2782,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(100119,2782,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(100120,2782,'tr','SeÃ§ili',0),(100121,2782,'pl','Wybrane',0),(100122,2782,'bg','Ð˜Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(100123,2782,'ur','Ù…Ù†ØªØ®Ø¨',0),(100124,2782,'sr','Ð˜Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(100125,2782,'vi','ÄÃ£ chá»n',0),(100126,2782,'af','Gekies',0),(100127,2782,'ro','Selectate',0),(100128,2782,'et','Valitud',0),(100129,2782,'si','Izbrani',0),(100130,2782,'ba','Dipilih',0),(100131,2782,'nl','Geselecteerd',0),(100132,2782,'fi','Valittu',0),(100133,2782,'no','Valgt',0),(100134,2782,'da','Valgt',0),(100135,2782,'ko','ì„ ì •',0),(100136,2782,'he','× ×‘×—×¨',0),(100137,2782,'el','Î•Ï€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿',0),(100138,2782,'zh','é€‰æ‹©\r\n',0),(100139,2782,'sv','Valt',0),(100140,2782,'it','Selezionato',0),(100141,2782,'tl','',0),(100142,2782,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3649;&#3621;&#3657;&#3623;',0),(100143,2782,'hi','à¤šà¤¯à¤¨à¤¿à¤¤',0),(100144,2782,'ms','Dipilih',0),(100145,2782,'ar','ØªØ­Ø¯ÙŠØ¯',0),(100146,2782,'fr','SÃ©lectionnÃ©',0),(100147,2782,'jp','é?¸æŠž',0),(100148,2782,'pt','Selecionado',0),(100149,2782,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð¾',0),(100150,2782,'es','Seleccionado',0),(100151,2782,'de','AusgewÃ¤hlt',0),(100152,2782,'en','Selected',0),(100153,2783,'is','',0),(100154,2783,'dr','Ø¯ÙˆØ±Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(100155,2783,'pr','Ø¯ÙˆØ±Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(100156,2783,'tr','SEÃ‡Ä°LÄ° DÃ–NEM',0),(100157,2783,'pl','WYBRANY OKRES',0),(100158,2783,'bg','Ð˜Ð—Ð‘Ð ÐÐ ÐŸÐ•Ð Ð˜ÐžÐ”',0),(100159,2783,'ur','Ù…Ù†ØªØ®Ø¨ Ø¯ÙˆØ±',0),(100160,2783,'sr','Ð˜Ð—ÐÐ‘Ð ÐÐÐ˜ ÐŸÐ•Ð Ð˜ÐžÐ”',0),(100161,2783,'vi','Thá»i ká»³ ÄÃ£ chá»n',0),(100162,2783,'af','VERKOSE PERIODE',0),(100163,2783,'ro','PERIOADE SELECTATE',0),(100164,2783,'et','VALITUD PERIOODI',0),(100165,2783,'si','IZBRANO OBDOBJE',0),(100166,2783,'ba','DIPILIH PERIODE',0),(100167,2783,'nl','GESELECTEERDE PERIODE',0),(100168,2783,'fi','VALITUN KAUDEN',0),(100169,2783,'no','VALGT PERIODE',0),(100170,2783,'da','VALGTE PERIODE',0),(100171,2783,'ko','ì„ íƒ ëœ ê¸°ê°„',0),(100172,2783,'he','×”×ª×§×•×¤×” ×©× ×‘×—×¨×”',0),(100173,2783,'el','Î•Î Î™Î›Î•Î“ÎœÎˆÎÎ—Î£ Î Î•Î¡Î™ÎŒÎ”ÎŸÎ¥',0),(100174,2783,'zh','æ‰€é€‰æ—¶é—´æ®µå†…\r\n',0),(100175,2783,'sv','VALD PERIOD',0),(100176,2783,'it','PERIODO SELEZIONATO',0),(100177,2783,'tl','',0),(100178,2783,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(100179,2783,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤…à¤µà¤§à¤¿',0),(100180,2783,'ms','TEMPOH TERPILIH',0),(100181,2783,'ar','Ø§Ù„ÙØªØ±Ø© Ø§Ù„Ù…Ø®ØªØ§Ø±Ø©',0),(100182,2783,'fr','PÃ‰RIODE CHOISIE',0),(100183,2783,'jp','é?¸æŠžã?•ã‚Œã?ŸæœŸé–“',0),(100184,2783,'pt','PERÃODO SELECIONADO',0),(100185,2783,'ru','Ð’Ð«Ð‘Ð ÐÐÐÐ«Ð™ ÐŸÐ•Ð Ð˜ÐžÐ”',0),(100186,2783,'es','PERÃODO SELECCIONADO',0),(100187,2783,'de','AUSGEWÃ„HLTEN ZEITRAUM',0),(100188,2783,'en','SELECTED PERIOD',0),(100189,2784,'is','',0),(100190,2784,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ',0),(100191,2784,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ',0),(100192,2784,'tr','SeÃ§imi',0),(100193,2784,'pl','WybÃ³r',0),(100194,2784,'bg','Ð¡ÐµÐ»ÐµÐºÑ†Ð¸ÑÑ‚Ð°',0),(100195,2784,'ur','Ø§Ù†ØªØ®Ø§Ø¨',0),(100196,2784,'sr','Ð¡ÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ð°',0),(100197,2784,'vi','Chá»n lá»±a',0),(100198,2784,'af','Seleksie',0),(100199,2784,'ro','SelecÅ£ie',0),(100200,2784,'et','Valik',0),(100201,2784,'si','Izbor',0),(100202,2784,'ba','Seleksi',0),(100203,2784,'nl','Selectie',0),(100204,2784,'fi','Valinta',0),(100205,2784,'no','Utvalg',0),(100206,2784,'da','Udvalg',0),(100207,2784,'ko','ì„ íƒ',0),(100208,2784,'he','×‘×—×™×¨×”',0),(100209,2784,'el','Î•Ï€Î¹Î»Î¿Î³Î®',0),(100210,2784,'zh','é€‰æ‹©\r\n',0),(100211,2784,'sv','Urval',0),(100212,2784,'it','Selezione',0),(100213,2784,'tl','',0),(100214,2784,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(100215,2784,'hi','à¤šà¤¯à¤¨',0),(100216,2784,'ms','Pemilihan',0),(100217,2784,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ¯',0),(100218,2784,'fr','SÃ©lection',0),(100219,2784,'jp','é?¸æŠžè‚¢',0),(100220,2784,'pt','SeleÃ§Ã£o',0),(100221,2784,'ru','Ð’Ñ‹Ð±Ð¾Ñ€',0),(100222,2784,'es','SelecciÃ³n',0),(100223,2784,'de','Auswahl',0),(100224,2784,'en','Selection',0),(100225,2785,'is','',0),(100226,2785,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ø¯ÙŠÚ¯Ø± ',0),(100227,2785,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ø¯ÙŠÚ¯Ø± ',0),(100228,2785,'tr','SeÃ§imi ve diÄŸer',0),(100229,2785,'pl','WybÃ³r oraz inne',0),(100230,2785,'bg','Ð˜Ð·Ð±Ð¾Ñ€, Ð¿Ð»ÑŽÑ Ð´Ñ€ÑƒÐ³Ð¸',0),(100231,2785,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ø¹Ù„Ø§ÙˆÛ Ø¯ÙˆØ³Ø±Û’',0),(100232,2785,'sr','Ð˜Ð·Ð±Ð¾Ñ€ ÐŸÐ›Ð£Ð¡ Ð´Ñ€ÑƒÐ³Ð¸Ð¼Ð°',0),(100233,2785,'vi','Lá»±a chá»n ThÃªm khÃ¡c ',0),(100234,2785,'af','Seleksie PLUS Ander',0),(100235,2785,'ro','SelecÅ£ie PLUS alte',0),(100236,2785,'et','Valik pluss muud',0),(100237,2785,'si','Izbor, PLUS drugi',0),(100238,2785,'ba','Seleksi ditambah lain',0),(100239,2785,'nl','Selectie PLUS andere',0),(100240,2785,'fi','Valinta sekÃ¤ muut',0),(100241,2785,'no','Utvalg samt andre',0),(100242,2785,'da','Udvalg PLUS andre',0),(100243,2785,'ko','ì„ íƒ í”ŒëŸ¬ìŠ¤ ë‹¤ë¥¸',0),(100244,2785,'he','×‘×—×™×¨×” ×‘×ª×•×¡×¤×ª ×”×©× ×™×™×”',0),(100245,2785,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÏƒÏ…Î½ Î¬Î»Î»Î¿',0),(100246,2785,'zh','é€‰æ‹©åŠ ä¸Šå…¶ä»–\r\n',0),(100247,2785,'sv','Urval PLUS andra',0),(100248,2785,'it','Selezione, piÃ¹ altri',0),(100249,2785,'tl','',0),(100250,2785,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3623;&#3585;&#3629;&#3639;&#3656;&#3609; &#3654;',0),(100251,2785,'hi','à¤šà¤¯à¤¨ à¤•à¥‡ à¤…à¤²à¤¾à¤µà¤¾ à¤…à¤¨à¥à¤¯',0),(100252,2785,'ms','Pemilihan serta lain-lain',0),(100253,2785,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ¯ Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø£Ø®Ø±Ù‰',0),(100254,2785,'fr','SÃ©lection ainsi que d\'autres',0),(100255,2785,'jp','é?¸æŠžè‚¢ã?¨ã??ã?®ä»–',0),(100256,2785,'pt','SeleÃ§Ã£o e outros',0),(100257,2785,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ ÐŸÐ›Ð®Ð¡ Ð”Ñ€ÑƒÐ³Ð¾Ðµ',0),(100258,2785,'es','SelecciÃ³n MAS Otro',0),(100259,2785,'de','Auswahl sowie andere',0),(100260,2785,'en','Selection PLUS Other',0),(100261,2786,'is','',0),(100262,2786,'dr','..../  Ø¬Ø¹Ø¨Ù‡ ÙˆØ±ÙˆØ¯ w ',0),(100263,2786,'pr','Ø§Ù†ØªØ®Ø§Ø¨  ..../  Ø¬Ø¹Ø¨Ù‡ ÙˆØ±ÙˆØ¯ w ',0),(100264,2786,'tr','W / giriÅŸ kutusu seÃ§imi',0),(100265,2786,'pl','WybÃ³r / pole wprowadzania',0),(100266,2786,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð±ÐµÐ· Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ ÐºÑƒÑ‚Ð¸Ñ',0),(100267,2786,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø®Ø§Ù†Û w / Ø§Ù†ØªØ®Ø§Ø¨',0),(100268,2786,'sr','Ð¡ÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ð° w/ Ð¿Ð¾Ñ™Ðµ Ð·Ð° ÑƒÐ½Ð¾Ñ',0),(100269,2786,'vi','Lá»±a Chá»n vá»›i Há»™p Entry',0),(100270,2786,'af','Seleksie w / inskrywing boks',0),(100271,2786,'ro','SelecÅ£ie w / caseta de intrare',0),(100272,2786,'et','Valik w / kanne vÃ¤ljale',0),(100273,2786,'si','Izbor w / vnosno polje',0),(100274,2786,'ba','Seleksi w / kotak entri',0),(100275,2786,'nl','Selectie w / invoervak',0),(100276,2786,'fi','Valinta w / tekstiruutu',0),(100277,2786,'no','Utvalg med inntastingsfeltet',0),(100278,2786,'da','Udvalg med indtastningsfeltet',0),(100279,2786,'ko','í•­ëª© ìƒìž / ì„ íƒ',0),(100280,2786,'he','×‘×—×™×¨×” ×¢× ×ª×™×‘×ª ×”×–× ×ª',0),(100281,2786,'el','Î•Ï€Î¹Î»Î¿Î³Î® w / Ï€Î»Î±Î¯ÏƒÎ¹Î¿',0),(100282,2786,'zh','é€‰æ‹©w/è¾“å…¥æ¡†\r\n',0),(100283,2786,'sv','Urval med skrivfÃ¤ltet',0),(100284,2786,'it','Selezione w / casella di immissione',0),(100285,2786,'tl','',0),(100286,2786,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585; w/ &#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(100287,2786,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¬à¥‰à¤•à¥à¤¸ w / à¤šà¤¯à¤¨',0),(100288,2786,'ms','Pemilihan dengan Peti Masuk',0),(100289,2786,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø«/Ù…Ø±Ø¨Ø¹ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(100290,2786,'fr','SÃ©lection w / boÃ®te d\'entrÃ©e',0),(100291,2786,'jp','ã‚¨ãƒ³ãƒˆãƒªãƒ¼ãƒœãƒƒã‚¯ã‚¹ã?®ã?‚ã‚‹é?¸æŠžè‚¢',0),(100292,2786,'pt','SeleÃ§Ã£o w / caixa de entrada',0),(100293,2786,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ Ð¶ / Ð¿Ð¾Ð»Ðµ',0),(100294,2786,'es','SelecciÃ³n w/ Caja de Entrada',0),(100295,2786,'de','Auswahl w / Eingabefeld',0),(100296,2786,'en','Selection w/ Entry Box',0),(100297,2787,'is','',0),(100298,2787,'dr','Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(100299,2787,'pr','Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(100300,2787,'tr','SatÄ±ÅŸ FiyatÄ±',0),(100301,2787,'pl','Cena sprzedaÅ¼y',0),(100302,2787,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð° Ñ†ÐµÐ½Ð°',0),(100303,2787,'ur','Ù‚ÛŒÙ…Øª ÙØ±ÙˆØ®Øª',0),(100304,2787,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ð° Ñ†ÐµÐ½Ð°',0),(100305,2787,'vi','GiÃ¡ bÃ¡n',0),(100306,2787,'af','Verkoopsprys',0),(100307,2787,'ro','Vindem Pret',0),(100308,2787,'et','MÃ¼Ã¼a hinda',0),(100309,2787,'si','Prodajna cena',0),(100310,2787,'ba','Jual harga',0),(100311,2787,'nl','Verkoopprijs',0),(100312,2787,'fi','MyyntipÃ¤ivÃ¤',0),(100313,2787,'no','Salgspris',0),(100314,2787,'da','SÃ¦lge pris',0),(100315,2787,'ko','íŒë§¤ ê°€ê²©',0),(100316,2787,'he','×ž×—×™×¨ ×ž×—×™×¨×•×Ÿ',0),(100317,2787,'el','Î Ï‰Î»Î¿ÏÎ½ Ï„Î¹Î¼Î®',0),(100318,2787,'zh','å–å‡ºä»·\r\n',0),(100319,2787,'sv','SÃ¤ljkurs',0),(100320,2787,'it','Prezzo di vendita',0),(100321,2787,'tl','',0),(100322,2787,'th','&#3619;&#3634;&#3588;&#3634;&#3586;&#3634;&#3618;',0),(100323,2787,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¬à¥‡à¤š',0),(100324,2787,'ms','Menjual harga',0),(100325,2787,'ar','Ø³Ø¹Ø± Ø§Ù„Ø¨ÙŠØ¹',0),(100326,2787,'fr','Prix de vente',0),(100327,2787,'jp','è²©å£²ä¾¡æ ¼',0),(100328,2787,'pt','PreÃ§o de venda',0),(100329,2787,'ru','Ð¦ÐµÐ½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(100330,2787,'es','Precio de Venta',0),(100331,2787,'de','Preis zu verkaufen',0),(100332,2787,'en','Sell Price',0),(100333,2788,'is','',0),(100334,2788,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ ',0),(100335,2788,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ ',0),(100336,2788,'tr','E-posta gÃ¶nder',0),(100337,2788,'pl','WyÅ›lij E-mail',0),(100338,2788,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¸Ð¼ÐµÐ¹Ð»',0),(100339,2788,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(100340,2788,'sr','Ð¡Ð»Ð°ÑšÐµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(100341,2788,'vi','Gá»­i Email',0),(100342,2788,'af','Stuur E-pos',0),(100343,2788,'ro','Trimite E-mail',0),(100344,2788,'et','Saada e-kiri',0),(100345,2788,'si','PoÅ¡lji Email',0),(100346,2788,'ba','Kirim Email',0),(100347,2788,'nl','Stuur E-mail',0),(100348,2788,'fi','LÃ¤hetÃ¤ sÃ¤hkÃ¶postia',0),(100349,2788,'no','Send e-post',0),(100350,2788,'da','Send E-mail',0),(100351,2788,'ko','ì´ë©”ì¼ ë³´ë‚´ê¸°',0),(100352,2788,'he','×©×œ×— ×“×•×\"×œ',0),(100353,2788,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(100354,2788,'zh','å‘é€ç”µå­é‚®ä»¶\r\n',0),(100355,2788,'sv','Skicka e-post',0),(100356,2788,'it','Inviare Email',0),(100357,2788,'tl','',0),(100358,2788,'th','&#3626;&#3656;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(100359,2788,'hi','à¤ˆà¤®à¥‡à¤² à¤­à¥‡à¤œà¥‡à¤‚',0),(100360,2788,'ms','Menghantar e-mel',0),(100361,2788,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(100362,2788,'fr','Envoyer Email',0),(100363,2788,'jp','ï¼¥ãƒ¡ãƒ¼ãƒ«é€?ä¿¡',0),(100364,2788,'pt','Enviar E-mail',0),(100365,2788,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¸ÑÑŒÐ¼Ð¾',0),(100366,2788,'es','Enviar Email',0),(100367,2788,'de','Senden Sie E-Mail',0),(100368,2788,'en','Send Email',0),(100369,2789,'is','',0),(100370,2789,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù¾ÙŠØºØ§Ù…',0),(100371,2789,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù¾ÙŠØºØ§Ù…',0),(100372,2789,'tr','Mesaj GÃ¶nder',0),(100373,2789,'pl','WyÅ›lij wiadomoÅ›Ä‡',0),(100374,2789,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(100375,2789,'ur','Ù¾ÛŒØºØ§Ù… Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(100376,2789,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð¿Ð¾Ñ€ÑƒÐºÑƒ',0),(100377,2789,'vi','Gá»­i tin nháº¯n',0),(100378,2789,'af','Stuur Boodskap',0),(100379,2789,'ro','Trimite mesaj',0),(100380,2789,'et','Saada sÃµnum',0),(100381,2789,'si','PoÅ¡lji sporoÄilo',0),(100382,2789,'ba','Kirim pesan',0),(100383,2789,'nl','Stuur bericht',0),(100384,2789,'fi','LÃ¤hetÃ¤ viesti',0),(100385,2789,'no','Send melding',0),(100386,2789,'da','Send besked',0),(100387,2789,'ko','ë©”ì‹œì§€ ë³´ë‚´ê¸°',0),(100388,2789,'he','×©×œ×— ×”×•×“×¢×”',0),(100389,2789,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Î¼Î®Î½Ï…Î¼Î±',0),(100390,2789,'zh','å‘é€æ¶ˆæ¯\r\n',0),(100391,2789,'sv','Skicka meddelande',0),(100392,2789,'it','Invia messaggio',0),(100393,2789,'tl','',0),(100394,2789,'th','&#3626;&#3656;&#3591;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(100395,2789,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤­à¥‡à¤œà¥‡à¤‚',0),(100396,2789,'ms','Menghantar mesej',0),(100397,2789,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø±Ø³Ø§Ù„Ø©',0),(100398,2789,'fr','Envoyer Message',0),(100399,2789,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸é€?ä¿¡',0),(100400,2789,'pt','Enviar mensagem',0),(100401,2789,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(100402,2789,'es','Enviar Mensaje',0),(100403,2789,'de','Nachricht senden',0),(100404,2789,'en','Send Message',0),(100405,2790,'is','',0),(100406,2790,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù¾ÙŠØºØ§Ù… Ø¬Ø¯ÙŠØ¯ ',0),(100407,2790,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù¾ÙŠØºØ§Ù… Ø¬Ø¯ÙŠØ¯ ',0),(100408,2790,'tr','Yeni mesaj',0),(100409,2790,'pl','WyÅ›lij nowÄ… wiadomoÅ›Ä‡',0),(100410,2790,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð½Ð¾Ð²Ð¾ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(100411,2790,'ur','Ù†Ø¦Û’ Ù¾ÛŒØºØ§Ù… Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(100412,2790,'sr','Ð¡Ð»Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(100413,2790,'vi','Gá»­i tin nháº¯n má»›i',0),(100414,2790,'af','Stuur \'n nuwe boodskap',0),(100415,2790,'ro','Trimite mesaj nou',0),(100416,2790,'et','Saada uus sÃµnum',0),(100417,2790,'si','PoÅ¡lji novo sporoÄilo',0),(100418,2790,'ba','Kirim pesan baru',0),(100419,2790,'nl','Nieuw bericht verzenden',0),(100420,2790,'fi','LÃ¤hetÃ¤ uusi viesti',0),(100421,2790,'no','Sende nye melding',0),(100422,2790,'da','Send ny besked',0),(100423,2790,'ko','ìƒˆ ë©”ì‹œì§€ ë³´ë‚´ê¸°',0),(100424,2790,'he','×©×œ×— ×”×•×“×¢×” ×—×“×©×”',0),(100425,2790,'el','ÎÎ­Î¿ Î¼Î®Î½Ï…Î¼Î±',0),(100426,2790,'zh','å‘é€æ–°é‚®ä»¶\r\n',0),(100427,2790,'sv','Skicka nytt meddelande',0),(100428,2790,'it','Invia nuovo messaggio',0),(100429,2790,'tl','',0),(100430,2790,'th','&#3626;&#3656;&#3591;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3651;&#3627;&#3617;&#3656;',0),(100431,2790,'hi','à¤¨à¤ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤­à¥‡à¤œà¥‡à¤‚',0),(100432,2790,'ms','Menghantar mesej baru',0),(100433,2790,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø±Ø³Ø§Ù„Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(100434,2790,'fr','Envoyer le nouveau message',0),(100435,2790,'jp','æ–°è¦?ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’é€?ä¿¡',0),(100436,2790,'pt','Enviar nova mensagem',0),(100437,2790,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ð¾Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(100438,2790,'es','Enviar nuevo mensaje',0),(100439,2790,'de','Neue Nachricht senden',0),(100440,2790,'en','Send new message',0),(100441,2791,'is','',0),(100442,2791,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù† ',0),(100443,2791,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù† ',0),(100444,2791,'tr','Faturalanacak sipariÅŸleri gÃ¶nderme',0),(100445,2791,'pl','WysyÅ‚anie zamÃ³wieÅ„ do zafakturowania',0),(100446,2791,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸Ñ‚Ðµ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(100447,2791,'ur','Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ø¬Ø§ Ù„ÛŒÛ’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(100448,2791,'sr','Ð¡Ð»Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(100449,2791,'vi','Gá»­i Ä‘Æ¡n hÃ ng sang hÃ³a Ä‘Æ¡n',0),(100450,2791,'af','Stuur Bestellings om te Faktureer',0),(100451,2791,'ro','Trimite comenzi sÄƒ fie facturate',0),(100452,2791,'et','Saada tellimused arvete koostamisele',0),(100453,2791,'si','PoÅ¡iljanje naroÄil za fakturiranje',0),(100454,2791,'ba','Mengirim pesanan untuk dikenakan tagihan',0),(100455,2791,'nl','Verzenden Orders worden gefactureerd',0),(100456,2791,'fi','LÃ¤hetÃ¤ laskutettavia tilauksia',0),(100457,2791,'no','Sende bestillinger som skal faktureres',0),(100458,2791,'da','Sende ordrer skal faktureres',0),(100459,2791,'ko','ë³´ë‚´ê¸° ëª…ë ¹ ì²­êµ¬',0),(100460,2791,'he','×©×œ×— ×”×–×ž× ×•×ª ×œ×”× ×¤×§×ª ×—×©×‘×•× ×™×ª',0),(100461,2791,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î¸Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î·Î¸Î¿ÏÎ½',0),(100462,2791,'zh','å‘é€è¦å¼€å‘ç¥¨çš„è®¢å•\r\n',0),(100463,2791,'sv','Skicka order som ska faktureras',0),(100464,2791,'it','Inviare ordini da fatturare',0),(100465,2791,'tl','',0),(100466,2791,'th','&#3626;&#3656;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3611;&#3655;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(100467,2791,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œà¤¨à¥‡',0),(100468,2791,'ms','Menghantar pesanan untuk dapat invois',0),(100469,2791,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø£ÙˆØ§Ù…Ø± Ù„Ù„ÙÙˆØªØ±Ø©',0),(100470,2791,'fr','Envoyez les commandes Ã  facturer',0),(100471,2791,'jp','è«‹æ±‚ã?•ã‚Œã‚‹æ³¨æ–‡ã?®é€?ä¿¡',0),(100472,2791,'pt','Enviar ordens para ser faturado',0),(100473,2791,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²ÐºÐ° Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ðº Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐµ',0),(100474,2791,'es','Enviar Ordenes para ser Facturados',0),(100475,2791,'de','Senden Sie Bestellungen zu fakturierende',0),(100476,2791,'en','Send Orders to be Invoiced',0),(100477,2792,'is','',0),(100478,2792,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(100479,2792,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(100480,2792,'tr','Teklifi gÃ¶nder',0),(100481,2792,'pl','WyÅ›lij ofertÄ™',0),(100482,2792,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(100483,2792,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(100484,2792,'sr','Ð¡Ð»Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(100485,2792,'vi','Gá»­i bÃ¡o giÃ¡',0),(100486,2792,'af','Gestuurde Kwotasie',0),(100487,2792,'ro','Trimite oferta',0),(100488,2792,'et','Saada pakkumine',0),(100489,2792,'si','PoÅ¡ljite ponudbo',0),(100490,2792,'ba','Kirim Penawaran',0),(100491,2792,'nl','Verzending van offerte',0),(100492,2792,'fi','LÃ¤hetÃ¤ tarjous',0),(100493,2792,'no','Sende tilbud',0),(100494,2792,'da','Send tilbud',0),(100495,2792,'ko','ê²¬ì ì„ ë³´ë‚´',0),(100496,2792,'he','×©×œ×— ×”×¦×¢×ª ×ž×—×™×¨',0),(100497,2792,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(100498,2792,'zh','å‘é€æŠ¥ä»·\r\n',0),(100499,2792,'sv','Skicka offert',0),(100500,2792,'it','Inviare il preventivo',0),(100501,2792,'tl','',0),(100502,2792,'th','&#3626;&#3656;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(100503,2792,'hi','à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤­à¥‡à¤œà¥‡à¤‚',0),(100504,2792,'ms','Hantar sebut harga',0),(100505,2792,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(100506,2792,'fr','Envoyer Devis',0),(100507,2792,'jp','è¦‹ç©?ã?®é€?ä¿¡',0),(100508,2792,'pt','Enviar cotaÃ§Ã£o',0),(100509,2792,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(100510,2792,'es','Enviar CotizaciÃ³n',0),(100511,2792,'de','Senden Sie Angebot',0),(100512,2792,'en','Send Quote',0),(100513,2793,'is','',0),(100514,2793,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø¬ÙˆØ§Ø¨',0),(100515,2793,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø¬ÙˆØ§Ø¨',0),(100516,2793,'tr','Cevap gÃ¶nder',0),(100517,2793,'pl','WyÅ›lij odpowiedÅº',0),(100518,2793,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(100519,2793,'ur','Ø¬ÙˆØ§Ø¨ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(100520,2793,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€',0),(100521,2793,'vi','Gá»­i tráº£ lá»i',0),(100522,2793,'af','Stuur Antwoord',0),(100523,2793,'ro','Trimite rÄƒspunsul',0),(100524,2793,'et','Saada vastus',0),(100525,2793,'si','PoÅ¡lji odgovori',0),(100526,2793,'ba','Kirim Balasan',0),(100527,2793,'nl','Antwoord verzenden',0),(100528,2793,'fi','LÃ¤hetÃ¤ vastaus',0),(100529,2793,'no','Send svar',0),(100530,2793,'da','Send svar',0),(100531,2793,'ko','ì‘ë‹µì„ ë³´ë‚´ê¸°',0),(100532,2793,'he','×©×œ×— ×ž×¢× ×”',0),(100533,2793,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Î±Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(100534,2793,'zh','å‘é€å›žå¤\r\n',0),(100535,2793,'sv','Skicka svar',0),(100536,2793,'it','Inviare la risposta',0),(100537,2793,'tl','',0),(100538,2793,'th','&#3626;&#3656;&#3591;&#3585;&#3634;&#3619;&#3605;&#3629;&#3610;&#3585;&#3621;&#3633;&#3610;',0),(100539,2793,'hi','à¤‰à¤¤à¥à¤¤à¤° à¤­à¥‡à¤œà¥‡à¤‚',0),(100540,2793,'ms','Menghantar maklum balas',0),(100541,2793,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø±Ø¯',0),(100542,2793,'fr','Envoyer la rÃ©ponse',0),(100543,2793,'jp','è¿”ä¿¡',0),(100544,2793,'pt','Enviar resposta',0),(100545,2793,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ñ‚Ð²ÐµÑ‚',0),(100546,2793,'es','Enviar Respuesta',0),(100547,2793,'de','Antwort senden',0),(100548,2793,'en','Send Reply',0),(100549,2794,'is','',0),(100550,2794,'dr','ÙØ±Ø³ØªÙ†Ø¯Ù‡ ',0),(100551,2794,'pr','ÙØ±Ø³ØªÙ†Ø¯Ù‡ ',0),(100552,2794,'tr','gÃ¶nderen',0),(100553,2794,'pl','nadawcy',0),(100554,2794,'bg','Ð¿Ð¾Ð´Ð°Ñ‚ÐµÐ»',0),(100555,2794,'ur','Ù…Ø±Ø³Ù„',0),(100556,2794,'sr','Ð¿Ð¾ÑˆÐ¸Ñ™Ð°Ð¾Ñ†Ð°',0),(100557,2794,'vi','ngÆ°á»i gá»­i',0),(100558,2794,'af','afsender',0),(100559,2794,'ro','expeditor',0),(100560,2794,'et','saatja',0),(100561,2794,'si','PoÅ¡iljatelj',0),(100562,2794,'ba','pengirim',0),(100563,2794,'nl','afzender',0),(100564,2794,'fi','LÃ¤hettÃ¤jÃ¤',0),(100565,2794,'no','avsenderen',0),(100566,2794,'da','afsender',0),(100567,2794,'ko','ë³´ë‚¸ ì‚¬ëžŒ',0),(100568,2794,'he','×©×•×œ×—',0),(100569,2794,'el','Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Î±',0),(100570,2794,'zh','å¯„ä»¶äºº\r\n',0),(100571,2794,'sv','avsÃ¤ndaren',0),(100572,2794,'it','mittente',0),(100573,2794,'tl','',0),(100574,2794,'th','&#3612;&#3641;&#3657;&#3626;&#3656;&#3591;',0),(100575,2794,'hi','à¤ªà¥à¤°à¥‡à¤·à¤•',0),(100576,2794,'ms','penghantar',0),(100577,2794,'ar','Ø§Ù„Ù…Ø±Ø³Ù„',0),(100578,2794,'fr','expÃ©diteur',0),(100579,2794,'jp','é€?ä¿¡è€…',0),(100580,2794,'pt','remetente',0),(100581,2794,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÐµÐ»ÑŒ',0),(100582,2794,'es','Remitente',0),(100583,2794,'de','Absender',0),(100584,2794,'en','sender',0),(100585,2795,'is','',0),(100586,2795,'dr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ',0),(100587,2795,'pr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ',0),(100588,2795,'tr','GÃ¶nderilen',0),(100589,2795,'pl','wysÅ‚ane',0),(100590,2795,'bg','Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(100591,2795,'ur','Ø¨Ú¾ÛŒØ¬Ø§',0),(100592,2795,'sr','Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(100593,2795,'vi','Ä‘Ã£ gá»­i',0),(100594,2795,'af','gestuur',0),(100595,2795,'ro','trimis',0),(100596,2795,'et','saadetud',0),(100597,2795,'si','poslal',0),(100598,2795,'ba','Dikirim',0),(100599,2795,'nl','verzonden',0),(100600,2795,'fi','lÃ¤hetti',0),(100601,2795,'no','sendt',0),(100602,2795,'da','sendt',0),(100603,2795,'ko','ì „ì†¡',0),(100604,2795,'he','× ×©×œ×—',0),(100605,2795,'el','Î­ÏƒÏ„ÎµÎ¹Î»Îµ',0),(100606,2795,'zh','å‘é€\r\n',0),(100607,2795,'sv','skickas',0),(100608,2795,'it','Inviato',0),(100609,2795,'tl','',0),(100610,2795,'th','&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(100611,2795,'hi','à¤­à¥‡à¤œà¥‡ à¤—à¤',0),(100612,2795,'ms','dihantar',0),(100613,2795,'ar','Ø£Ø±Ø³Ù„Øª',0),(100614,2795,'fr','envoyÃ©',0),(100615,2795,'jp','é€?ä¿¡æ¸ˆ',0),(100616,2795,'pt','enviado',0),(100617,2795,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(100618,2795,'es','Enviado',0),(100619,2795,'de','gesendet',0),(100620,2795,'en','sent',0),(100621,2796,'is','',0),(100622,2796,'dr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ',0),(100623,2796,'pr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ',0),(100624,2796,'tr','gÃ¶nderilen iletileri',0),(100625,2796,'pl','wysÅ‚ane wiadomoÅ›ci',0),(100626,2796,'bg','Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(100627,2796,'ur','Ù…Ø±Ø³Ù„Û Ù¾ÛŒØºØ§Ù…Ø§Øª',0),(100628,2796,'sr','Ð¿Ð¾ÑÐ»Ð°Ñ‚Ðµ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(100629,2796,'vi','gá»­i tin nháº¯n',0),(100630,2796,'af','boodskap(pe) gestuur',0),(100631,2796,'ro','mesaje trimise',0),(100632,2796,'et','saadetud sÃµnumid',0),(100633,2796,'si','poslanih sporoÄil',0),(100634,2796,'ba','pesan terkirim',0),(100635,2796,'nl','verzonden berichten',0),(100636,2796,'fi','lÃ¤hetetyt viestit',0),(100637,2796,'no','sendte melding(er)',0),(100638,2796,'da','sendte beskeder',0),(100639,2796,'ko','ë³´ë‚¸ëœ ë©”ì‹œì§€',0),(100640,2796,'he','×”×•×“×¢×•×ª ×©× ×©×œ×—×•',0),(100641,2796,'el','Î‘Ï€ÎµÏƒÏ„Î±Î»Î¼Î­Î½Î± Î¼Î·Î½ÏÎ¼Î±Ï„Î±',0),(100642,2796,'zh','å‘é€æ¶ˆæ¯ï¼ˆsï¼‰\r\n',0),(100643,2796,'sv','skickade meddelanden',0),(100644,2796,'it','messaggi inviati',0),(100645,2796,'tl','',0),(100646,2796,'th','&#3626;&#3656;&#3591;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(100647,2796,'hi','à¤­à¥‡à¤œà¥‡ à¤—à¤ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(100648,2796,'ms','mesej yang dihantar',0),(100649,2796,'ar','Ø§Ù„Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ù…Ø±Ø³Ù„Ø©',0),(100650,2796,'fr','messages envoyÃ©s',0),(100651,2796,'jp','é€?ä¿¡æ¸ˆãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(100652,2796,'pt','mensagens enviadas',0),(100653,2796,'ru','Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ(Ñ)',0),(100654,2796,'es','mensaje(s) enviado(s)',0),(100655,2796,'de','gesendete Nachrichten',0),(100656,2796,'en','sent message(s)',0),(100657,2797,'is','',0),(100658,2797,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø·Ø¨Ù‚ ',0),(100659,2797,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø·Ø¨Ù‚ ',0),(100660,2797,'tr','GÃ¶nderdi',0),(100661,2797,'pl','WysÅ‚ana',0),(100662,2797,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾ Ð½Ð°',0),(100663,2797,'ur','Ù…Ø±Ø³Ù„Û',0),(100664,2797,'sr','ÐŸÐ¾ÑÐ»Ð°Ñ‚Ð¸',0),(100665,2797,'vi','Gá»­i vÃ o ',0),(100666,2797,'af','Gestuur Op',0),(100667,2797,'ro','Trimis',0),(100668,2797,'et','Saadetud',0),(100669,2797,'si','Poslal',0),(100670,2797,'ba','Dikirim pada',0),(100671,2797,'nl','Verzonden op',0),(100672,2797,'fi','LÃ¤hetti',0),(100673,2797,'no','Sendt pÃ¥',0),(100674,2797,'da','Sendt',0),(100675,2797,'ko','ì „ì†¡',0),(100676,2797,'he','× ×©×œ×— ×‘',0),(100677,2797,'el','ÎˆÏƒÏ„ÎµÎ¹Î»Îµ ÏƒÎµ',0),(100678,2797,'zh','å‘é€\r\n',0),(100679,2797,'sv','Skickas pÃ¥',0),(100680,2797,'it','Inviato',0),(100681,2797,'tl','',0),(100682,2797,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;',0),(100683,2797,'hi','à¤­à¥‡à¤œà¥‡ à¤—à¤',0),(100684,2797,'ms','Dihantar pada',0),(100685,2797,'ar','Ø£Ø±Ø³Ù„Øª',0),(100686,2797,'fr','EnvoyÃ©',0),(100687,2797,'jp','é€?ä¿¡æ—¥',0),(100688,2797,'pt','Enviada',0),(100689,2797,'ru','ÐŸÐ¾ÑÐ»Ð°Ð» Ð½Ð°',0),(100690,2797,'es','Enviado',0),(100691,2797,'de','Gesendet am',0),(100692,2797,'en','Sent On',0),(100693,2798,'is','',0),(100694,2798,'dr','Ø³Ù¾ØªØ§Ù…Ø¨Ø±',0),(100695,2798,'pr','Ø³Ù¾ØªØ§Ù…Ø¨Ø±',0),(100696,2798,'tr','EylÃ¼l',0),(100697,2798,'pl','WrzeÅ›nia',0),(100698,2798,'bg','Ð¡ÐµÐ¿Ñ‚ÐµÐ¼Ð²Ñ€Ð¸',0),(100699,2798,'ur','Ø³ØªÙ…Ø¨Ø±',0),(100700,2798,'sr','Ð¡ÐµÐ¿Ñ‚ÐµÐ¼Ð±Ñ€Ð°',0),(100701,2798,'vi','ThÃ¡ng chÃ­n',0),(100702,2798,'af','September',0),(100703,2798,'ro','Septembrie',0),(100704,2798,'et','September',0),(100705,2798,'si','Septembra',0),(100706,2798,'ba','September',0),(100707,2798,'nl','September',0),(100708,2798,'fi','Syyskuuta',0),(100709,2798,'no','September',0),(100710,2798,'da','September',0),(100711,2798,'ko','9 ì›”',0),(100712,2798,'he','×¡×¤×˜×ž×‘×¨',0),(100713,2798,'el','Î£ÎµÏ€Ï„ÎµÎ¼Î²ÏÎ¯Î¿Ï…',0),(100714,2798,'zh','ä¹æœˆ\r\n',0),(100715,2798,'sv','September',0),(100716,2798,'it','Settembre',0),(100717,2798,'tl','',0),(100718,2798,'th','&#3585;&#3633;&#3609;&#3618;&#3634;&#3618;&#3609;',0),(100719,2798,'hi','à¤¸à¤¿à¤¤à¤®à¥à¤¬à¤°',0),(100720,2798,'ms','September',0),(100721,2798,'ar','Ø³Ø¨ØªÙ…Ø¨Ø±',0),(100722,2798,'fr','Septembre',0),(100723,2798,'jp','9æœˆ',0),(100724,2798,'pt','Setembro',0),(100725,2798,'ru','Ð¡ÐµÐ½Ñ‚ÑÐ±Ñ€ÑŒ',0),(100726,2798,'es','Septiembre',0),(100727,2798,'de','September',0),(100728,2798,'en','September',0),(100729,2799,'is','',0),(100730,2799,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(100731,2799,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(100732,2799,'tr','Server Kurulumu',0),(100733,2799,'pl','Ustawienia serwera',0),(100734,2799,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÑÑŠÑ€Ð²ÑŠÑ€Ð°',0),(100735,2799,'ur','Ù¾ÛŒØ´ Ú©Ø§Ø± Ø³ÛŒÙ¹ Ø§Ù¾',0),(100736,2799,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÑÐµÑ€Ð²ÐµÑ€Ð°',0),(100737,2799,'vi','Setup MÃ¡y chá»§',0),(100738,2799,'af','Bediener Opstelling',0),(100739,2799,'ro','Setare server',0),(100740,2799,'et','Serveri seadistamine',0),(100741,2799,'si','Nastavitev streÅ¾nika',0),(100742,2799,'ba','Server Setup',0),(100743,2799,'nl','Server Setup',0),(100744,2799,'fi','Palvelimen asennus',0),(100745,2799,'no','Serverinstallasjonen',0),(100746,2799,'da','Server installation',0),(100747,2799,'ko','ì„œë²„ ì„¤ì¹˜',0),(100748,2799,'he','×”×’×“×¨×ª ×©×¨×ª',0),(100749,2799,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· server',0),(100750,2799,'zh','æœåŠ¡å™¨å®‰è£…\r\n',0),(100751,2799,'sv','Server Setup',0),(100752,2799,'it','Installazione server',0),(100753,2799,'tl','',0),(100754,2799,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3648;&#3595;&#3636;&#3615;&#3648;&#3623;&#3629;&#3619;&#3660;',0),(100755,2799,'hi','à¤¸à¤°à¥à¤µà¤° à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(100756,2799,'ms','Persediaan pelayan',0),(100757,2799,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ù…Ù„Ù‚Ù…',0),(100758,2799,'fr','Installation du serveur',0),(100759,2799,'jp','ã‚µãƒ¼ãƒ?ãƒ¼ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(100760,2799,'pt','ConfiguraÃ§Ã£o do servidor',0),(100761,2799,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð¡ÐµÑ€Ð²ÐµÑ€Ð°',0),(100762,2799,'es','ConfiguraciÃ³n de Servidor',0),(100763,2799,'de','Server-Setup',0),(100764,2799,'en','Server Setup',0),(100765,2800,'is','',0),(100766,2800,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ØµØ­ÙŠØ­ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡',0),(100767,2800,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ØµØ­ÙŠØ­ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡',0),(100768,2800,'tr','Server Kurulumu doÄŸru veritabanÄ±',0),(100769,2800,'pl','Konfiguracja serwera bazy danych poprawnie',0),(100770,2800,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÑÑŠÑ€Ð²ÑŠÑ€ Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¾',0),(100771,2800,'ur','Ù¾ÛŒØ´ Ú©Ø§Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Ùˆ ØµØ­ÛŒØ­ Ø·ÙˆØ± Ù¾Ø± Ú©ÙˆØ§Ø¦ÙÛŒÛ',0),(100772,2800,'sr','Ð‘Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ðµ Ð¡ÐµÑ€Ð²ÐµÑ€ Ð¸ÑÐ¿Ñ€Ð°Ð²Ð½Ð¾',0),(100773,2800,'vi','Setup dá»¯ liá»‡u MÃ¡y chá»§ chÃ­nh xÃ¡c',0),(100774,2800,'af','Databasis Bediener het Korrek Opgestel',0),(100775,2800,'ro','Instalarea serverului de baze de date corect',0),(100776,2800,'et','Andmebaasi Server Setup Ãµigesti',0),(100777,2800,'si','ÄŒasovno doloÄljiv pomoÄnik Setup pravilno',0),(100778,2800,'ba','Database Server Setup dengan benar',0),(100779,2800,'nl','Database Server Setup correct',0),(100780,2800,'fi','Tietokannan asetukset oikein',0),(100781,2800,'no','Database Server Setup riktig',0),(100782,2800,'da','Database Server Setup korrekt',0),(100783,2800,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì„œë²„ ì„¤ì¹˜ë¥¼ ì˜¬ë°”ë¥´ê²Œ',0),(100784,2800,'he','×ž×¡×“ ×”× ×ª×•× ×™× ×©×œ ×”×©×¨×ª ×‘×¦×•×¨×” × ×›×•× ×”',0),(100785,2800,'el','Î’Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Server ÏƒÏ‰ÏƒÏ„Î¬',0),(100786,2800,'zh','æ•°æ®åº“æœåŠ¡å™¨è®¾ç½®æ­£ç¡®\r\n',0),(100787,2800,'sv','Databas Server Setup korrekt',0),(100788,2800,'it','Installazione di Server di database correttamente',0),(100789,2800,'tl','',0),(100790,2800,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3595;&#3636;&#3615;&#3648;&#3623;&#3629;&#3619;&#3660;&#3629;&#3618;&#3656;&#3634;&#3591;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3',0),(100791,2800,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤°à¥à¤µà¤° à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¸à¤¹à¥€ à¤¢à¤‚à¤— à¤¸à¥‡',0),(100792,2800,'ms','Pangkalan data pelayan persediaan dengan betul',0),(100793,2800,'ar','ØªÙ… Ø¥Ø¹Ø¯Ø§Ø¯ Ø®Ø§Ø¯Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø¨Ø´ÙƒÙ„ ØµØ­ÙŠØ­',0),(100794,2800,'fr','Base de donnÃ©es de configuration de serveur correctement',0),(100795,2800,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?Œã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(100796,2800,'pt','ConfiguraÃ§Ã£o do servidor de banco de dados corretamente',0),(100797,2800,'ru','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ… ÑÐµÑ€Ð²ÐµÑ€Ð° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð¿Ñ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ð¾',0),(100798,2800,'es','Servidor de Base de Datos Configurado Correctamente',0),(100799,2800,'de','Datenbank-Server-Setup korrekt',0),(100800,2800,'en','Database Server Setup Correctly',0),(100801,2801,'is','',0),(100802,2801,'dr','Ø®Ø¯Ù…Ø§Øª',0),(100803,2801,'pr','Ø®Ø¯Ù…Ø§Øª',0),(100804,2801,'tr','Hizmet',0),(100805,2801,'pl','UsÅ‚ugi',0),(100806,2801,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð·',0),(100807,2801,'ur','Ø®Ø¯Ù…Øª',0),(100808,2801,'sr','Ð¡ÐµÑ€Ð²Ð¸Ñ',0),(100809,2801,'vi','Dá»‹ch vá»¥',0),(100810,2801,'af','Diens',0),(100811,2801,'ro','Serviciu',0),(100812,2801,'et','Teenuste Tellimusi',0),(100813,2801,'si','Storitev',0),(100814,2801,'ba','Layanan',0),(100815,2801,'nl','Service',0),(100816,2801,'fi','Palvelu',0),(100817,2801,'no','Service',0),(100818,2801,'da','Service',0),(100819,2801,'ko','ì„œë¹„ìŠ¤',0),(100820,2801,'he','×©×¨×•×ª',0),(100821,2801,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î±',0),(100822,2801,'zh','æœåŠ¡\r\n',0),(100823,2801,'sv','Service',0),(100824,2801,'it','Servizio',0),(100825,2801,'tl','',0),(100826,2801,'th','&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(100827,2801,'hi','à¤¸à¥‡à¤µà¤¾',0),(100828,2801,'ms','Perkhidmatan',0),(100829,2801,'ar','Ø®Ø¯Ù…Ø©',0),(100830,2801,'fr','Service',0),(100831,2801,'jp','ã‚µãƒ¼ãƒ“ã‚¹',0),(100832,2801,'pt','ServiÃ§o',0),(100833,2801,'ru','Ð£ÑÐ»ÑƒÐ³Ð¸',0),(100834,2801,'es','Servicio',0),(100835,2801,'de','Service',0),(100836,2801,'en','Service',0),(100837,2802,'is','',0),(100838,2802,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø¯Ù…Ø§Øª',0),(100839,2802,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø¯Ù…Ø§Øª',0),(100840,2802,'tr','Servis Ã¼creti',0),(100841,2802,'pl','OpÅ‚ata za usÅ‚ugÄ™',0),(100842,2802,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° ÑƒÑÐ»ÑƒÐ³Ð°',0),(100843,2802,'ur','Ø³Ø±ÙˆØ³ Ú†Ø§Ø±Ø¬',0),(100844,2802,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(100845,2802,'vi','PhÃ­ Dá»‹ch vá»¥',0),(100846,2802,'af','Diensfooie',0),(100847,2802,'ro','Taxa de serviciu',0),(100848,2802,'et','Teenustasu',0),(100849,2802,'si','Servisni stroÅ¡ek',0),(100850,2802,'ba','Biaya layanan',0),(100851,2802,'nl','Servicekosten',0),(100852,2802,'fi','Palvelumaksu',0),(100853,2802,'no','Gebyr',0),(100854,2802,'da','Serviceafgift pÃ¥',0),(100855,2802,'ko','ì„œë¹„ìŠ¤ ìš”ê¸ˆ',0),(100856,2802,'he','×—×™×•×‘ ×©×¨×•×ª',0),(100857,2802,'el','Î§ÏÎ­Ï‰ÏƒÎ· Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½',0),(100858,2802,'zh','æœåŠ¡è´¹\r\n',0),(100859,2802,'sv','Serviceavgift',0),(100860,2802,'it','Costo del servizio',0),(100861,2802,'tl','',0),(100862,2802,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(100863,2802,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(100864,2802,'ms','Caj Perkhidmatan',0),(100865,2802,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø®Ø¯Ù…Ø©',0),(100866,2802,'fr','Frais de service',0),(100867,2802,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ–™',0),(100868,2802,'pt','Taxa de serviÃ§o',0),(100869,2802,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(100870,2802,'es','Cargo de Servicio',0),(100871,2802,'de','ServicegebÃ¼hr',0),(100872,2802,'en','Service Charge',0),(100873,2803,'is','',0),(100874,2803,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(100875,2803,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(100876,2803,'tr','Hizmet Rep',0),(100877,2803,'pl','UsÅ‚ugi Rep',0),(100878,2803,'bg','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»',0),(100879,2803,'ur','Ø®Ø¯Ù…Øª Ø¬Ù…ÛÙˆØ±ÛŒÛ',0),(100880,2803,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ‚ÐµÑ€Ð°',0),(100881,2803,'vi','NhÃ¢n viÃªn Dá»‹ch vá»¥',0),(100882,2803,'af','Diens Verteenwoordiger',0),(100883,2803,'ro','Service Rep',0),(100884,2803,'et','Teenuse Rep',0),(100885,2803,'si','Service Rep',0),(100886,2803,'ba','Service Rep',0),(100887,2803,'nl','Service Rep',0),(100888,2803,'fi','Asepalvelus ripsi',0),(100889,2803,'no','Service Rep',0),(100890,2803,'da','Service Rep',0),(100891,2803,'ko','ì„œë¹„ìŠ¤ ë‹´ë‹¹ìž',0),(100892,2803,'he','× ×¦×™×’ ×©×™×¨×•×ª',0),(100893,2803,'el','Î¥Ï†Î¬ÏƒÎ¼Î±Ï„ÏŒÏ‚ ÏƒÎ±Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±',0),(100894,2803,'zh','æœåŠ¡ä»£è¡¨\r\n',0),(100895,2803,'sv','TjÃ¤nst Rep',0),(100896,2803,'it','Servizio Rep',0),(100897,2803,'tl','',0),(100898,2803,'th','&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3586;&#3634;&#3618;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(100899,2803,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿',0),(100900,2803,'ms','Wakil Perkhidmatan',0),(100901,2803,'ar','Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ø®Ø¯Ù…Ø§Øª',0),(100902,2803,'fr','Service Rep',0),(100903,2803,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ‹…å½“è€…',0),(100904,2803,'pt','Representante de serviÃ§o',0),(100905,2803,'ru','Rep Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(100906,2803,'es','Rep. de Servicio',0),(100907,2803,'de','Service Rep',0),(100908,2803,'en','Service Rep',0),(100909,2804,'is','',0),(100910,2804,'dr','(Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ù†) Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§',0),(100911,2804,'pr','ØªÙ†Ø¸ÙŠÙ…(Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ù†) Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§',0),(100912,2804,'tr','VarsayÄ±lanlarÄ±nÄ± ayarlama',0),(100913,2804,'pl','Ustaw domyÅ›lne',0),(100914,2804,'bg','Ð—Ð°Ð´Ð°Ð¹ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(100915,2804,'ur','Ø³ÛŒÙ¹ Ø·Û’ Ø´Ø¯Û',0),(100916,2804,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸Ñ… Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(100917,2804,'vi','Äáº·t máº·c Ä‘á»‹nh',0),(100918,2804,'af','Stel verstek',0),(100919,2804,'ro','Set Defaults',0),(100920,2804,'et','VaikesÃ¤tete seadmine',0),(100921,2804,'si','Privzeto',0),(100922,2804,'ba','Menetapkan default',0),(100923,2804,'nl','Standaardwaarden instellen',0),(100924,2804,'fi','Valitse oletusasetukset',0),(100925,2804,'no','Angi standardinnstillinger',0),(100926,2804,'da','Angive standarder',0),(100927,2804,'ko','ì„¤ì •ëœ ê¸°ë³¸ê°’',0),(100928,2804,'he','×”×’×“×¨×ª ×‘×¨×™×¨×•×ª ×ž×—×“×œ',0),(100929,2804,'el','ÎŸÎ¡Î™Î£ÎœÎŸÎ£ Î Î¡ÎŸÎ•Î Î™Î›ÎŸÎ“Î©Î',0),(100930,2804,'zh','è®¾ç½®é»˜è®¤å€¼\r\n',0),(100931,2804,'sv','StÃ¤ll in standardvÃ¤rden',0),(100932,2804,'it','Impostare valori predefiniti',0),(100933,2804,'tl','',0),(100934,2804,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(100935,2804,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(100936,2804,'ms','Set lalai',0),(100937,2804,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø§ÙØªØ±Ø§Ø¶Ø§Øª',0),(100938,2804,'fr','Ensemble de valeurs par dÃ©faut',0),(100939,2804,'jp','æ—¢å®šã?®è¨­å®š',0),(100940,2804,'pt','Definidos padrÃµes',0),(100941,2804,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(100942,2804,'es','Configurar Predeterminados',0),(100943,2804,'de','Festlegen von Standardwerten',0),(100944,2804,'en','Set Defaults',0),(100945,2805,'is','',0),(100946,2805,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ',0),(100947,2805,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ',0),(100948,2805,'tr','Kurulum',0),(100949,2805,'pl','Instalator',0),(100950,2805,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(100951,2805,'ur','Ø³ÛŒÙ¹ Ø§Ù¾',0),(100952,2805,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(100953,2805,'vi','Setup',0),(100954,2805,'af','Opstelling',0),(100955,2805,'ro','Setare',0),(100956,2805,'et','Seadistamine',0),(100957,2805,'si','Nastavitev',0),(100958,2805,'ba','Setup',0),(100959,2805,'nl','Setup',0),(100960,2805,'fi','Asetukset',0),(100961,2805,'no','Installasjonsprogrammet',0),(100962,2805,'da','OpsÃ¦tning',0),(100963,2805,'ko','ì„¤ì¹˜',0),(100964,2805,'he','×”×ª×§× ×”',0),(100965,2805,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(100966,2805,'zh','è®¾ç½®\r\n',0),(100967,2805,'sv','Setup',0),(100968,2805,'it','Installazione',0),(100969,2805,'tl','',0),(100970,2805,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;',0),(100971,2805,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(100972,2805,'ms','Persediaan',0),(100973,2805,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª',0),(100974,2805,'fr','Programme d\'installation',0),(100975,2805,'jp','è¨­å®š',0),(100976,2805,'pt','InstalaÃ§Ã£o',0),(100977,2805,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(100978,2805,'es','Configurar',0),(100979,2805,'de','Setup',0),(100980,2805,'en','Setup',0),(100981,2806,'is','',0),(100982,2806,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(100983,2806,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(100984,2806,'tr','Kur farkÄ±',0),(100985,2806,'pl','Ustawienie bezpÅ‚atnie',0),(100986,2806,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ñ‚Ð°ÐºÑÐ°',0),(100987,2806,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ú†Ø§Ø±Ø¬',0),(100988,2806,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(100989,2806,'vi','Setup phÃ­',0),(100990,2806,'af','Aanklag opstel',0),(100991,2806,'ro','Taxa de instalare',0),(100992,2806,'et','Setup tasu',0),(100993,2806,'si','Setup pristojbine',0),(100994,2806,'ba','Biaya setup',0),(100995,2806,'nl','Setup kosten',0),(100996,2806,'fi','Asetukset maksu',0),(100997,2806,'no','Setup kostnad',0),(100998,2806,'da','Setup gebyr',0),(100999,2806,'ko','ì„¤ì¹˜ ìš”ê¸ˆ',0),(101000,2806,'he','×ª×©×œ×•× ×”×”×ª×§× ×”',0),(101001,2806,'el','Î§ÏÎ­Ï‰ÏƒÎ· ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(101002,2806,'zh','å®‰è£…è´¹\r\n',0),(101003,2806,'sv','Setup avgift',0),(101004,2806,'it','Installazione carica',0),(101005,2806,'tl','',0),(101006,2806,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(101007,2806,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¶à¥à¤²à¥à¤•',0),(101008,2806,'ms','Bayaran persediaan',0),(101009,2806,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(101010,2806,'fr','Charge d\'installation',0),(101011,2806,'jp','è¨­å®šæ–™é‡‘',0),(101012,2806,'pt','Custo de instalaÃ§Ã£o',0),(101013,2806,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° ÑÐ¾ÐµÐ´Ð¸Ð½ÐµÐ½Ð¸Ðµ',0),(101014,2806,'es','Carga de Configurar',0),(101015,2806,'de','Setup-GebÃ¼hr',0),(101016,2806,'en','Setup Charge',0),(101017,2807,'is','',0),(101018,2807,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙƒØ§Ù…Ù„ Ø§Ø³Øª ',0),(101019,2807,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙƒØ§Ù…Ù„ Ø§Ø³Øª ',0),(101020,2807,'tr','Kurulum tamamlandÄ±ktan',0),(101021,2807,'pl','ZakoÅ„czeniu instalacji',0),(101022,2807,'bg','Ð˜Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ðµ Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð¸Ð»Ð¾',0),(101023,2807,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ù…Ú©Ù…Ù„ ÛÙˆ Ú¯ÛŒØ§ ÛÛ’',0),(101024,2807,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð°',0),(101025,2807,'vi','HoÃ n táº¥t Setup',0),(101026,2807,'af','Opstelling is voltooi',0),(101027,2807,'ro','Setarea este completata',0),(101028,2807,'et','Install on lÃµpule viidud',0),(101029,2807,'si','Setup je celoten',0),(101030,2807,'ba','Setup lengkap',0),(101031,2807,'nl','Setup is voltooid',0),(101032,2807,'fi','Asennus on valmis',0),(101033,2807,'no','Installasjonen er fullfÃ¸rt',0),(101034,2807,'da','Installationen er fuldfÃ¸rt',0),(101035,2807,'ko','ì„¤ì¹˜ê°€ ì™„ë£Œ ë˜ ë©´',0),(101036,2807,'he','×”×©×œ×ž×ª ×”×”×ª×§× ×”',0),(101037,2807,'el','Î— Î¿ÏÎ³Î¬Î½Ï‰ÏƒÎ· ÎµÎ¯Î½Î±Î¹ Ï€Î»Î®ÏÎ·Ï‚',0),(101038,2807,'zh','å®‰è£…å®Œæˆ\r\n',0),(101039,2807,'sv','Installationen Ã¤r klar',0),(101040,2807,'it','Installazione Ã¨ completa',0),(101041,2807,'tl','',0),(101042,2807,'th','&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(101043,2807,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤ªà¥‚à¤°à¥à¤£ à¤¹à¥ˆ',0),(101044,2807,'ms','Persediaan yang lengkap',0),(101045,2807,'ar','Ø§ÙƒØªÙ…Ø§Ù„ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(101046,2807,'fr','L\'installation est terminÃ©e',0),(101047,2807,'jp','è¨­å®šã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(101048,2807,'pt','A instalaÃ§Ã£o estÃ¡ completa',0),(101049,2807,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°',0),(101050,2807,'es','ConfiguraciÃ³n es Completa',0),(101051,2807,'de','Die Installation ist abgeschlossen',0),(101052,2807,'en','Setup is complete',0),(101053,2808,'is','',0),(101054,2808,'dr','7',0),(101055,2808,'pr','Ù‡ÙØª  7',0),(101056,2808,'tr','yedi',0),(101057,2808,'pl','siedem',0),(101058,2808,'bg','ÑÐµÐ´ÐµÐ¼',0),(101059,2808,'ur','Ø³Ø§Øª',0),(101060,2808,'sr','ÑÐµÐ´Ð°Ð¼',0),(101061,2808,'vi','báº£y',0),(101062,2808,'af','sewe',0),(101063,2808,'ro','ÅŸapte',0),(101064,2808,'et','seitse',0),(101065,2808,'si','sedem',0),(101066,2808,'ba','tujuh',0),(101067,2808,'nl','zeven',0),(101068,2808,'fi','seitsemÃ¤n',0),(101069,2808,'no','syv',0),(101070,2808,'da','syv',0),(101071,2808,'ko','7',0),(101072,2808,'he','×©×‘×¢',0),(101073,2808,'el','ÎµÏ€Ï„Î¬',0),(101074,2808,'zh','ä¸ƒ\r\n',0),(101075,2808,'sv','sju',0),(101076,2808,'it','sette',0),(101077,2808,'tl','',0),(101078,2808,'th','&#3648;&#3592;&#3655;&#3604;',0),(101079,2808,'hi','à¤¸à¤¾à¤¤',0),(101080,2808,'ms','tujuh',0),(101081,2808,'ar','Ø³Ø¨Ø¹Ø©',0),(101082,2808,'fr','sept',0),(101083,2808,'jp','7',0),(101084,2808,'pt','sete',0),(101085,2808,'ru','ÑÐµÐ¼ÑŒ',0),(101086,2808,'es','siete',0),(101087,2808,'de','sieben',0),(101088,2808,'en','seven',0),(101089,2809,'is','',0),(101090,2809,'dr','17',0),(101091,2809,'pr','Ù‡ÙØ¯Ù‡  17',0),(101092,2809,'tr','on yedi',0),(101093,2809,'pl','siedemnaÅ›cie',0),(101094,2809,'bg','ÑÐµÐ´ÐµÐ¼Ð½Ð°Ð´ÐµÑÐµÑ‚',0),(101095,2809,'ur','Ø³ØªØ±Û',0),(101096,2809,'sr','Ð¡ÐµÐ´Ð°Ð¼Ð½Ð°ÐµÑÑ‚',0),(101097,2809,'vi','mÆ°á»i báº£y',0),(101098,2809,'af','sewentien',0),(101099,2809,'ro','ÅŸaptesprezece ani',0),(101100,2809,'et','seitseteist',0),(101101,2809,'si','sedemnajst',0),(101102,2809,'ba','tujuh belas',0),(101103,2809,'nl','zeventien',0),(101104,2809,'fi','seitsemÃ¤ntoista',0),(101105,2809,'no','sytten',0),(101106,2809,'da','sytten',0),(101107,2809,'ko','17',0),(101108,2809,'he','×©×‘×¢ ×¢×©×¨×”',0),(101109,2809,'el','Î´ÎµÎºÎ±ÎµÏ€Ï„Î¬',0),(101110,2809,'zh','åä¸ƒ\r\n',0),(101111,2809,'sv','sjutton',0),(101112,2809,'it','diciassette anni',0),(101113,2809,'tl','',0),(101114,2809,'th','&#3626;&#3636;&#3610;&#3648;&#3592;&#3655;&#3604;',0),(101115,2809,'hi','à¤¸à¤¤à¥à¤°à¤¹',0),(101116,2809,'ms','tujuh belas',0),(101117,2809,'ar','Ø³Ø¨Ø¹Ø© Ø¹Ø´Ø±',0),(101118,2809,'fr','dix-sept ans',0),(101119,2809,'jp','17',0),(101120,2809,'pt','dezessete anos',0),(101121,2809,'ru','ÑÐµÐ¼Ð½Ð°Ð´Ñ†Ð°Ñ‚ÑŒ',0),(101122,2809,'es','diecisiete',0),(101123,2809,'de','siebzehn',0),(101124,2809,'en','seventeen',0),(101125,2810,'is','',0),(101126,2810,'dr','70 ',0),(101127,2810,'pr','Ù‡ÙØªØ§Ø¯  70 ',0),(101128,2810,'tr','YetmiÅŸ',0),(101129,2810,'pl','siedemdziesiÄ…t',0),(101130,2810,'bg','ÑÐµÐ´ÐµÐ¼Ð´ÐµÑÐµÑ‚',0),(101131,2810,'ur','Ø³ØªØ±',0),(101132,2810,'sr','Ð¡ÐµÐ´Ð°Ð¼Ð´ÐµÑÐµÑ‚',0),(101133,2810,'vi','báº£y mÆ°Æ¡i',0),(101134,2810,'af','sewentig',0),(101135,2810,'ro','ÅŸaptezeci',0),(101136,2810,'et','seitsekÃ¼mmend',0),(101137,2810,'si','sedemdeset',0),(101138,2810,'ba','tujuh puluh',0),(101139,2810,'nl','zeventig',0),(101140,2810,'fi','seitsemÃ¤nkymmentÃ¤',0),(101141,2810,'no','sytti',0),(101142,2810,'da','Halvfjerds',0),(101143,2810,'ko','70',0),(101144,2810,'he','×©×‘×¢×™×',0),(101145,2810,'el','ÎµÎ²Î´Î¿Î¼Î®Î½Ï„Î±',0),(101146,2810,'zh','ä¸ƒå\r\n',0),(101147,2810,'sv','sjuttio',0),(101148,2810,'it','Settanta',0),(101149,2810,'tl','',0),(101150,2810,'th','&#3648;&#3592;&#3655;&#3604;&#3626;&#3636;&#3610;',0),(101151,2810,'hi','à¤¸à¤¤à¥à¤¤à¤°',0),(101152,2810,'ms','tujuh puluh',0),(101153,2810,'ar','Ø³Ø¨Ø¹ÙˆÙ†',0),(101154,2810,'fr','soixante-dix',0),(101155,2810,'jp','70',0),(101156,2810,'pt','setenta',0),(101157,2810,'ru','ÑÐµÐ¼Ð´ÐµÑÑÑ‚',0),(101158,2810,'es','setenta',0),(101159,2810,'de','siebzig',0),(101160,2810,'en','seventy',0),(101161,2811,'is','',0),(101162,2811,'dr','(ÙˆØ±Ù‚',0),(101163,2811,'pr','Ø¨Ø±Ú¯Ù‡ (ÙˆØ±Ù‚',0),(101164,2811,'tr','Levha',0),(101165,2811,'pl','Arkusz',0),(101166,2811,'bg','Ð›Ð¸ÑÑ‚',0),(101167,2811,'ur','ÙˆØ±Ù‚',0),(101168,2811,'sr','Ð›Ð¸ÑÑ‚',0),(101169,2811,'vi','Trang',0),(101170,2811,'af','Vel',0),(101171,2811,'ro','Foaie',0),(101172,2811,'et','Leht',0),(101173,2811,'si','List',0),(101174,2811,'ba','Lembar',0),(101175,2811,'nl','Blad',0),(101176,2811,'fi','Arkki',0),(101177,2811,'no','Ark',0),(101178,2811,'da','Ark',0),(101179,2811,'ko','ì‹œíŠ¸',0),(101180,2811,'he','×’×™×œ×™×•×Ÿ',0),(101181,2811,'el','Î¦ÏÎ»Î»Î¿',0),(101182,2811,'zh','å¼ \r\n',0),(101183,2811,'sv','Blad',0),(101184,2811,'it','Foglio',0),(101185,2811,'tl','',0),(101186,2811,'th','&#3649;&#3612;&#3656;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(101187,2811,'hi','à¤¶à¥€à¤Ÿ',0),(101188,2811,'ms','Kira-kira',0),(101189,2811,'ar','ÙˆØ±Ù‚Ø©',0),(101190,2811,'fr','Feuille',0),(101191,2811,'jp','ã‚·ãƒ¼ãƒˆ',0),(101192,2811,'pt','Folha',0),(101193,2811,'ru','Ð›Ð¸ÑÑ‚',0),(101194,2811,'es','Hoja',0),(101195,2811,'de','Blatt',0),(101196,2811,'en','Sheet',0),(101197,2812,'is','',0),(101198,2812,'dr','(Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ',0),(101199,2812,'pr','Ù†ÙˆØ¨ØªÚ©Ø§Ø±Ù‰ (Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ',0),(101200,2812,'tr','Shift',0),(101201,2812,'pl','Zmiany',0),(101202,2812,'bg','Ð¡Ð¼ÑÐ½Ð°',0),(101203,2812,'ur','Ù…Ù†ØªÙ‚Ù„ Ú©Ø±ÛŒÚº',0),(101204,2812,'sr','Ð¡Ð¥Ð˜Ð¤Ð¢',0),(101205,2812,'vi','Ca lÃ m viá»‡c',0),(101206,2812,'af','Skof',0),(101207,2812,'ro','Shift',0),(101208,2812,'et','SHIFT',0),(101209,2812,'si','SHIFT',0),(101210,2812,'ba','Pergeseran',0),(101211,2812,'nl','Shift',0),(101212,2812,'fi','Vaihto',0),(101213,2812,'no','Skift',0),(101214,2812,'da','Skift',0),(101215,2812,'ko','ì‹œí”„íŠ¸',0),(101216,2812,'he','×ž×©×ž×¨×ª',0),(101217,2812,'el','ÎœÎµÏ„Î±Ï„ÏŒÏ€Î¹ÏƒÎ·',0),(101218,2812,'zh','ç§»\r\n',0),(101219,2812,'sv','Skift',0),(101220,2812,'it','MAIUSC',0),(101221,2812,'tl','',0),(101222,2812,'th','&#3648;&#3621;&#3639;&#3656;&#3629;&#3609;',0),(101223,2812,'hi','à¤¶à¤¿à¤«à¥à¤Ÿ',0),(101224,2812,'ms','Anjakan',0),(101225,2812,'ar','Ø§Ù„ØªØ­ÙˆÙ„',0),(101226,2812,'fr','Maj',0),(101227,2812,'jp','ã‚·ãƒ•ãƒˆ',0),(101228,2812,'pt','Turno',0),(101229,2812,'ru','Ð¡Ð´Ð²Ð¸Ð³',0),(101230,2812,'es','Turno',0),(101231,2812,'de','Verschiebung',0),(101232,2812,'en','Shift',0),(101233,2813,'is','',0),(101234,2813,'dr','Ø­Ù…Ù„ ÙƒØ±Ø¯Ù†',0),(101235,2813,'pr','Ø­Ù…Ù„ ÙƒØ±Ø¯Ù†',0),(101236,2813,'tr','Gemi',0),(101237,2813,'pl','Statek',0),(101238,2813,'bg','ÐšÐ¾Ñ€Ð°Ð±',0),(101239,2813,'ur','Ø¬ÛØ§Ø²',0),(101240,2813,'sr','Ð‘Ñ€Ð¾Ð´',0),(101241,2813,'vi','Chuyá»ƒn',0),(101242,2813,'af','Versend',0),(101243,2813,'ro','NavÄƒ',0),(101244,2813,'et','Laeva',0),(101245,2813,'si','Ladja',0),(101246,2813,'ba','Kapal',0),(101247,2813,'nl','Schip',0),(101248,2813,'fi','Aluksen',0),(101249,2813,'no','Skipet',0),(101250,2813,'da','Skib',0),(101251,2813,'ko','ì„ ë°•',0),(101252,2813,'he','×”×¡×¤×™× ×”',0),(101253,2813,'el','Î Î»Î¿Î¯Î¿',0),(101254,2813,'zh','è£…è¿\r\n',0),(101255,2813,'sv','Fartyget',0),(101256,2813,'it','Nave',0),(101257,2813,'tl','',0),(101258,2813,'th','&#3586;&#3609;&#3626;&#3656;&#3591;',0),(101259,2813,'hi','à¤œà¤¹à¤¾à¤œ',0),(101260,2813,'ms','Kapal',0),(101261,2813,'ar','Ø³ÙÙŠÙ†Ø©',0),(101262,2813,'fr','Navire',0),(101263,2813,'jp','ç™ºé€?',0),(101264,2813,'pt','Navio',0),(101265,2813,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(101266,2813,'es','Enviar',0),(101267,2813,'de','Schiff',0),(101268,2813,'en','Ship',0),(101269,2814,'is','',0),(101270,2814,'dr','/ Ø±ÙˆØ´',0),(101271,2814,'pr','Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ / Ø±ÙˆØ´',0),(101272,2814,'tr','Nakliye gemisi/yÃ¶ntemleri',0),(101273,2814,'pl','PrzewoÅºnik/metody wysyÅ‚ki',0),(101274,2814,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡/Ð¼ÐµÑ‚Ð¾Ð´Ð¸ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(101275,2814,'ur','Ú©ÛŒØ±ÛŒØ¦Ø±/Ø·Ø±ÛŒÙ‚Û Ú©ÛŒ ØªØ±Ø³ÛŒÙ„',0),(101276,2814,'sr','ÐÐ¾ÑÐ°Ñ‡ /ÐÐ°Ñ‡Ð¸Ð½Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(101277,2814,'vi','HÃ£ng váº­n chuyá»ƒn/phÆ°Æ¡ng thá»©c',0),(101278,2814,'af','Versendings Karweier/Metodes',0),(101279,2814,'ro','Operatorul de transport/metoda de transport',0),(101280,2814,'et','Laevanduse vedaja/meetodid',0),(101281,2814,'si','Storim prevoznik',0),(101282,2814,'ba','Pembawa metode pengiriman',0),(101283,2814,'nl','Vervoerder/verzendmethoden',0),(101284,2814,'fi','Postikulut harjoittaja',0),(101285,2814,'no','Leveringsmetoder Carrier',0),(101286,2814,'da','Forsendelsesmetoder luftfartsselskab',0),(101287,2814,'ko','ë°°ì†¡ ìºë¦¬ì–´/ë°©ë²•',0),(101288,2814,'he','×ž× ×©×/×©×™×˜×•×ª ×ž×©×œ×•×—',0),(101289,2814,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Î±Ï‚/ÎœÎµÎ¸Î¿Î´Î¿Î¹ Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î·Ï‚',0),(101290,2814,'zh','èˆªè¿æ‰¿è¿äºº/æ–¹æ³•\r\n',0),(101291,2814,'sv','Leveransmetoder bÃ¤rare',0),(101292,2814,'it','Metodi di spedizione vettore',0),(101293,2814,'tl','',0),(101294,2814,'th','&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;/&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;',0),(101295,2814,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¾à¤¹à¤•/à¤¤à¤°à¥€à¤•à¥‹à¤‚',0),(101296,2814,'ms','Kapal pengangkut/kaedah',0),(101297,2814,'ar','Ø§Ù„Ù†Ø§Ù‚Ù„/Ø·Ø±Ù‚ Ø§Ù„Ø´Ø­Ù†',0),(101298,2814,'fr','Transporteur/mÃ©thodes d\'expÃ©dition',0),(101299,2814,'jp','ç™ºé€?æ¥­è€…/æ–¹æ³•',0),(101300,2814,'pt','Transportadora/mÃ©todos de envio',0),(101301,2814,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº/Ð¼ÐµÑ‚Ð¾Ð´Ñ‹ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(101302,2814,'es','Transportador de EnvÃ­o /MÃ©todos',0),(101303,2814,'de','Carrier/Versandarten',0),(101304,2814,'en','Shipping Carrier/Methods',0),(101305,2815,'is','',0),(101306,2815,'dr','/ Ø±ÙˆØ´ Ù‡Ø§',0),(101307,2815,'pr','Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ / Ø±ÙˆØ´ Ù‡Ø§',0),(101308,2815,'tr','Nakliye gemisi/yÃ¶ntemleri',0),(101309,2815,'pl','PrzewoÅºnik/metody wysyÅ‚ki',0),(101310,2815,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡/Ð¼ÐµÑ‚Ð¾Ð´Ð¸ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(101311,2815,'ur','Ú©ÛŒØ±ÛŒØ¦Ø±/Ø·Ø±ÛŒÙ‚Û Ú©ÛŒ ØªØ±Ø³ÛŒÙ„',0),(101312,2815,'sr','ÐÐ¾ÑÐ°Ñ‡ /ÐÐ°Ñ‡Ð¸Ð½Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(101313,2815,'vi','HÃ£ng váº­n chuyá»ƒn/phÆ°Æ¡ng thá»©c',0),(101314,2815,'af','Versendings Karweier/Metodes',0),(101315,2815,'ro','Operatorul de transport/metoda de transport',0),(101316,2815,'et','Laevanduse vedaja/meetodid',0),(101317,2815,'si','Storim prevoznik',0),(101318,2815,'ba','Pembawa metode pengiriman',0),(101319,2815,'nl','Vervoerder/verzendmethoden',0),(101320,2815,'fi','Postikulut harjoittaja',0),(101321,2815,'no','Leveringsmetoder Carrier',0),(101322,2815,'da','Forsendelsesmetoder luftfartsselskab',0),(101323,2815,'ko','ë°°ì†¡ ìºë¦¬ì–´/ë°©ë²•',0),(101324,2815,'he','×ž× ×©×/×©×™×˜×•×ª ×ž×©×œ×•×—',0),(101325,2815,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Î±Ï‚/ÎœÎµÎ¸Î¿Î´Î¿Î¹ Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î·Ï‚',0),(101326,2815,'zh','èˆªè¿æ‰¿è¿äºº/æ–¹æ³•\r\n',0),(101327,2815,'sv','Leveransmetoder bÃ¤rare',0),(101328,2815,'it','Metodi di spedizione vettore',0),(101329,2815,'tl','',0),(101330,2815,'th','&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;/&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;',0),(101331,2815,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¾à¤¹à¤•/à¤¤à¤°à¥€à¤•à¥‹à¤‚',0),(101332,2815,'ms','Kapal pengangkut/kaedah',0),(101333,2815,'ar','Ø§Ù„Ù†Ø§Ù‚Ù„/Ø·Ø±Ù‚ Ø§Ù„Ø´Ø­Ù†',0),(101334,2815,'fr','Transporteur/mÃ©thodes d\'expÃ©dition',0),(101335,2815,'jp','ç™ºé€?æ¥­è€…/æ–¹æ³•',0),(101336,2815,'pt','Transportadora/mÃ©todos de envio',0),(101337,2815,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº/Ð¼ÐµÑ‚Ð¾Ð´Ñ‹ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(101338,2815,'es','Transportador de EnvÃ­o /MÃ©todos',0),(101339,2815,'de','Carrier/Versandarten',0),(101340,2815,'en','Shipping Carrier/Methods',0),(101341,2816,'is','',0),(101342,2816,'dr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ ',0),(101343,2816,'pr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ ',0),(101344,2816,'tr','Sevk tarihi',0),(101345,2816,'pl','Data wysyÅ‚ki',0),(101346,2816,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(101347,2816,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(101348,2816,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ðµ',0),(101349,2816,'vi','NgÃ y váº­n chuyá»ƒn',0),(101350,2816,'af','Versendingsdatum',0),(101351,2816,'ro','Data navei',0),(101352,2816,'et','Tarne kuupÃ¤ev',0),(101353,2816,'si','Datum poÅ¡iljanja',0),(101354,2816,'ba','Kapal tanggal',0),(101355,2816,'nl','Verzenddatum',0),(101356,2816,'fi','LÃ¤hetyspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(101357,2816,'no','Forsendelsesdato',0),(101358,2816,'da','Afsendelsesdatoen',0),(101359,2816,'ko','ë°°ì†¡ì¼',0),(101360,2816,'he','×ª××¨×™×š ×ž×©×œ×•×—',0),(101361,2816,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(101362,2816,'zh','äº¤è´§æ—¥æœŸ\r\n',0),(101363,2816,'sv','Transportdatum',0),(101364,2816,'it','Data di spedizione',0),(101365,2816,'tl','',0),(101366,2816,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(101367,2816,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(101368,2816,'ms','Tarikh kapal',0),(101369,2816,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø´Ø­Ù†',0),(101370,2816,'fr','Date d\'expÃ©dition',0),(101371,2816,'jp','ç™ºé€?æ—¥',0),(101372,2816,'pt','Data de envio',0),(101373,2816,'ru','Ð”Ð°Ñ‚Ð° ÐžÑ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(101374,2816,'es','Fecha de EnvÃ­o',0),(101375,2816,'de','Lieferdatum',0),(101376,2816,'en','Ship Date',0),(101377,2817,'is','',0),(101378,2817,'dr','Ø­Ù…Ù„ Ø§Ø² ',0),(101379,2817,'pr','Ø­Ù…Ù„ Ø§Ø² ',0),(101380,2817,'tr','Gelen gemi',0),(101381,2817,'pl','Statek z',0),(101382,2817,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð¾Ñ‚',0),(101383,2817,'ur','Ø¬ÛØ§Ø² Ø³Û’',0),(101384,2817,'sr','Ð‘Ñ€Ð¾Ð´ Ð¸Ð·',0),(101385,2817,'vi','Chuyá»ƒn tá»«',0),(101386,2817,'af','Versending Vanaf',0),(101387,2817,'ro','Nava de la',0),(101388,2817,'et','Kust saadetud',0),(101389,2817,'si','Ladja iz',0),(101390,2817,'ba','Kapal dari',0),(101391,2817,'nl','Verzenden via',0),(101392,2817,'fi','Aluksen',0),(101393,2817,'no','Skip fra',0),(101394,2817,'da','Skib fra',0),(101395,2817,'ko','ë°°',0),(101396,2817,'he','×©×œ×™×—×” ×ž',0),(101397,2817,'el','Î Î»Î¿Î¯Î¿ Î±Ï€ÏŒ',0),(101398,2817,'zh','å‘è´§åœ°\r\n',0),(101399,2817,'sv','Fartyg frÃ¥n',0),(101400,2817,'it','Nave da',0),(101401,2817,'tl','',0),(101402,2817,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3592;&#3634;&#3585;',0),(101403,2817,'hi','à¤¸à¥‡ à¤œà¤¹à¤¾à¤œ',0),(101404,2817,'ms','Kapal dari',0),(101405,2817,'ar','Ø§Ù„Ø´Ø­Ù† Ù…Ù†',0),(101406,2817,'fr','ExpÃ©dier de',0),(101407,2817,'jp','ç™ºé€?å…ƒ',0),(101408,2817,'pt','O navio de',0),(101409,2817,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¸Ð·',0),(101410,2817,'es','Enviar De',0),(101411,2817,'de','Schiff aus',0),(101412,2817,'en','Ship From',0),(101413,2818,'is','',0),(101414,2818,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„',0),(101415,2818,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„',0),(101416,2818,'tr','Gemi Mkt.',0),(101417,2818,'pl','IloÅ›Ä‡ statkÃ³w',0),(101418,2818,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(101419,2818,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ Ù‚ÛŒ',0),(101420,2818,'sr','Ð‘Ñ€Ð¾Ð´ ÐšÐ¾Ð».',0),(101421,2818,'vi','Sá»‘ lÆ°á»£ng váº­n chuyá»ƒn',0),(101422,2818,'af','Versende Hoev.',0),(101423,2818,'ro','Nava cantit',0),(101424,2818,'et','Laeva kogus',0),(101425,2818,'si','Ladja kol.',0),(101426,2818,'ba','Kapal Qty',0),(101427,2818,'nl','Schip Qty',0),(101428,2818,'fi','Aluksen mÃ¤Ã¤rÃ¤',0),(101429,2818,'no','Skipet Ant',0),(101430,2818,'da','Skibet Qty',0),(101431,2818,'ko','ë°° ìˆ˜ëŸ‰',0),(101432,2818,'he','×›×ž×•×ª ×©×œ ×”×¡×¤×™× ×”',0),(101433,2818,'el','Î Î»Î¿Î¯Î¿ Qty',0),(101434,2818,'zh','è¿é€æ•°é‡\r\n',0),(101435,2818,'sv','Fartyget Kvt',0),(101436,2818,'it','Nave Qty',0),(101437,2818,'tl','',0),(101438,2818,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(101439,2818,'hi','à¤œà¤¹à¤¾à¤œ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(101440,2818,'ms','Qty kapal',0),(101441,2818,'ar','Ø´Ø­Ù† Ø§Ù„ÙƒÙ…ÙŠØ©',0),(101442,2818,'fr','QtÃ© de navire',0),(101443,2818,'jp','ç™ºé€?æ•°é‡?',0),(101444,2818,'pt','Qtde de navio',0),(101445,2818,'ru','ÐšÐ¾Ð»-Ð²Ð¾ ÐºÐ¾Ñ€Ð°Ð±Ð»ÐµÐ¹',0),(101446,2818,'es','Enviar Cant.',0),(101447,2818,'de','Schiff Qty',0),(101448,2818,'en','Ship Qty',0),(101449,2819,'is','',0),(101450,2819,'dr','Ø­Ù…Ù„ Ø¨Ù‡ ',0),(101451,2819,'pr','Ø­Ù…Ù„ Ø¨Ù‡ ',0),(101452,2819,'tr','O gemi',0),(101453,2819,'pl','Statek do',0),(101454,2819,'bg','Ð—Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(101455,2819,'ur','Ø¬ÛØ§Ø² Ú©Ùˆ',0),(101456,2819,'sr','Ð—Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(101457,2819,'vi','Chuyá»ƒn Ä‘áº¿n',0),(101458,2819,'af','Versend Na',0),(101459,2819,'ro','NavÄƒ la',0),(101460,2819,'et','Tarne aadress',0),(101461,2819,'si','Dostava',0),(101462,2819,'ba','Kapal ke',0),(101463,2819,'nl','Verzenden naar',0),(101464,2819,'fi','Aluksen',0),(101465,2819,'no','Leveringsgate',0),(101466,2819,'da','Skib til',0),(101467,2819,'ko','ìš´ì†¡ì§€',0),(101468,2819,'he','×ž×©×œ×•×— ××œ',0),(101469,2819,'el','Î Î»Î¿Î¯Î¿',0),(101470,2819,'zh','æ”¶è´§\r\n',0),(101471,2819,'sv','Fartyget till',0),(101472,2819,'it','Spedire a',0),(101473,2819,'tl','',0),(101474,2819,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;',0),(101475,2819,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(101476,2819,'ms','Kapal',0),(101477,2819,'ar','Ø§Ù„Ø´Ø­Ù† Ø¥Ù„Ù‰',0),(101478,2819,'fr','ExpÃ©dier Ã ',0),(101479,2819,'jp','ç™ºé€?å…ˆ',0),(101480,2819,'pt','Navio para',0),(101481,2819,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(101482,2819,'es','Enviar A',0),(101483,2819,'de','Ship To',0),(101484,2819,'en','Ship To',0),(101485,2820,'is','',0),(101486,2820,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ Ø¨Ù‡ ',0),(101487,2820,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ Ø¨Ù‡ ',0),(101488,2820,'tr','Gemi eklemek iÃ§in',0),(101489,2820,'pl','Statek dodac',0),(101490,2820,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(101491,2820,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ø´ØªÛŒ',0),(101492,2820,'sr','Ð‘Ñ€Ð¾Ð´ Ð·Ð° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐµ',0),(101493,2820,'vi','ThÃªm Chuyá»ƒn Ä‘áº¿n',0),(101494,2820,'af','Versend Na Byvoeging',0),(101495,2820,'ro','Navei pentru a adÄƒuga',0),(101496,2820,'et','Laeva lisamine',0),(101497,2820,'si','Ladja dodati',0),(101498,2820,'ba','Kapal untuk menambahkan',0),(101499,2820,'nl','Schip om toe te voegen',0),(101500,2820,'fi','Aluksen lisÃ¤Ã¤',0),(101501,2820,'no','Skipet til',0),(101502,2820,'da','Skib til at tilfÃ¸je',0),(101503,2820,'ko','ë°° ì¶”ê°€ë¥¼',0),(101504,2820,'he','×”×•×¡×¤×ª ×©×œ×— ××œ',0),(101505,2820,'el','Î Î»Î¿Î¯Î¿ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(101506,2820,'zh','æ”¶è´§åœ°å€\r\n',0),(101507,2820,'sv','Fartyget fÃ¶r att lÃ¤gga till',0),(101508,2820,'it','Nave da aggiungere',0),(101509,2820,'tl','',0),(101510,2820,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(101511,2820,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(101512,2820,'ms','Kapal untuk menambah',0),(101513,2820,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ø¶Ø§ÙØ©',0),(101514,2820,'fr','Navire Ã  ajouter',0),(101515,2820,'jp','ç™ºé€?å…ˆã?®è¿½åŠ ',0),(101516,2820,'pt','Navio para adicionar',0),(101517,2820,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(101518,2820,'es','Agregar Enviar-A',0),(101519,2820,'de','Schiff hinzufÃ¼gen',0),(101520,2820,'en','Ship To Add',0),(101521,2821,'is','',0),(101522,2821,'dr','Ø¢Ø¯Ø±Ø³ Ø­Ù…Ù„ Ø¨Ù‡ ',0),(101523,2821,'pr','Ø¢Ø¯Ø±Ø³ Ø­Ù…Ù„ Ø¨Ù‡ ',0),(101524,2821,'tr','Adrese sevk',0),(101525,2821,'pl','Statek na adres',0),(101526,2821,'bg','ÐÐ´Ñ€ÐµÑ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(101527,2821,'ur','Ù¾ØªÛ Ú©Û’ Ù„Ø¦Û’ Ø¬ÛØ§Ø²',0),(101528,2821,'sr','ÐÐ´Ñ€ÐµÑÐ° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(101529,2821,'vi','Chuyá»ƒn Ä‘áº¿n Ä‘á»‹a chá»‰',0),(101530,2821,'af','Versend Na Adres',0),(101531,2821,'ro','NavÄƒ la adresa',0),(101532,2821,'et','Tarneaadress',0),(101533,2821,'si','Dostava â€“ naslov',0),(101534,2821,'ba','Kapal ke alamat',0),(101535,2821,'nl','Verzenden naar adres',0),(101536,2821,'fi','Vastaanottajan nimi',0),(101537,2821,'no','Skipet til adressen',0),(101538,2821,'da','Skib til adresse',0),(101539,2821,'ko','ìš´ì†¡ì§€ ì£¼ì†Œ',0),(101540,2821,'he','×›×ª×•×‘×ª ×©×œ×— ××œ',0),(101541,2821,'el','Î Î»Î¿Î¯Î¿ ÏƒÏ„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(101542,2821,'zh','æ”¶è´§åœ°å€\r\n',0),(101543,2821,'sv','Leverans till adress',0),(101544,2821,'it','Spedire all\'indirizzo',0),(101545,2821,'tl','',0),(101546,2821,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(101547,2821,'hi','à¤ªà¤¤à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(101548,2821,'ms','Kapal ke alamat',0),(101549,2821,'ar','Ø´Ø­Ù† Ù„Ø¹Ù†ÙˆØ§Ù†',0),(101550,2821,'fr','ExpÃ©dier Ã  l\'adresse',0),(101551,2821,'jp','ç™ºé€?å…ˆä½?æ‰€',0),(101552,2821,'pt','Enviar para o endereÃ§o',0),(101553,2821,'ru','ÐÐ´Ñ€ÐµÑ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(101554,2821,'es','DirecciÃ³n de Enviar-A',0),(101555,2821,'de','Ship To Address',0),(101556,2821,'en','Ship To Address',0),(101557,2822,'is','',0),(101558,2822,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø¢Ø¯Ø±Ø³ Ø­Ù…Ù„ Ø¨Ù‡ ',0),(101559,2822,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø¢Ø¯Ø±Ø³ Ø­Ù…Ù„ Ø¨Ù‡ ',0),(101560,2822,'tr','Arama adrese sevk',0),(101561,2822,'pl','Statek na adres odnoÅ›nika',0),(101562,2822,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð¾ Ð°Ð´Ñ€ÐµÑ Ð·Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(101563,2822,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº Ø³Û’ Ù†Ù…Ù¹Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(101564,2822,'sr','Ð‘Ñ€Ð¾Ð´ Ð´Ð° ÑÐµ Ð¾Ð±Ñ€Ð°Ñ‚Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(101565,2822,'vi','TÃ¬m Ä‘á»‹a chá»‰ chuyá»ƒn Ä‘áº¿n',0),(101566,2822,'af','Skip te spreek opsoek',0),(101567,2822,'ro','Nava a adresa cÄƒutare',0),(101568,2822,'et','Saaja-aadressi otsing',0),(101569,2822,'si','Ladjo in naslov za iskanje',0),(101570,2822,'ba','Kapal ke alamat Lookup',0),(101571,2822,'nl','Schip aan te pakken Lookup',0),(101572,2822,'fi','Aluksen Etsi osoite',0),(101573,2822,'no','Lever til-adresse-oppslag',0),(101574,2822,'da','Skib til adresse opslag',0),(101575,2822,'ko','ì¡°íšŒë¥¼ í•´ê²° í•˜ê¸° ìœ„í•´ ë°°',0),(101576,2822,'he','×”×¡×¤×™× ×” ×›×“×™ ×œ×˜×¤×œ ×‘×“×™×§×ª ×ž×™×“×¢',0),(101577,2822,'el','Î Î»Î¿Î¯Î¿ Î³Î¹Î± Ï„Î·Î½ Î±Î½Ï„Î¹Î¼ÎµÏ„ÏŽÏ€Î¹ÏƒÎ· Ï„Î·Ï‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(101578,2822,'zh','æ”¶è´§åœ°å€æŸ¥è¯¢\r\n',0),(101579,2822,'sv','Fartyget till adress Lookup',0),(101580,2822,'it','Nave per affrontare la ricerca',0),(101581,2822,'tl','',0),(101582,2822,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3607;&#3637;&#3656;&#3588;&#3657;&#3609;&#3627;&#3634;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(101583,2822,'hi','à¤²à¥à¤•à¤…à¤ª à¤•à¥‹ à¤¸à¤‚à¤¬à¥‹à¤§à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(101584,2822,'ms','Kapal untuk menangani Lookup',0),(101585,2822,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„ØªØµØ¯ÙŠ Ù„Ù„Ø¨Ø­Ø«',0),(101586,2822,'fr','Navire d\'aborder la recherche',0),(101587,2822,'jp','é…?é€?å…ˆä½?æ‰€å?‚ç…§',0),(101588,2822,'pt','Navio para pesquisa de endereÃ§o',0),(101589,2822,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð¿Ð¾Ð¸ÑÐºÐ°',0),(101590,2822,'es','DirecciÃ³n de Enviar-A Buscar',0),(101591,2822,'de','Schiff auf Lookup',0),(101592,2822,'en','Ship To Address Lookup',0),(101593,2823,'is','',0),(101594,2823,'dr','( Ø§Ø±Ø³Ø§Ù„ ) Ø¨Ù‡ Ø´Ù‡Ø±',0),(101595,2823,'pr','Ø­Ù…Ù„( Ø§Ø±Ø³Ø§Ù„ ) Ø¨Ù‡ Ø´Ù‡Ø±',0),(101596,2823,'tr','Åžehre gemi',0),(101597,2823,'pl','Statek do miasta',0),(101598,2823,'bg','Ð“Ñ€Ð°Ð´ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(101599,2823,'ur','Ø´ÛØ± Ù…ÛŒÚº Ø¬ÛØ§Ø²',0),(101600,2823,'sr','Ð“Ñ€Ð°Ð´ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(101601,2823,'vi','Chuyá»ƒn Ä‘áº¿n thÃ nh phá»‘',0),(101602,2823,'af','Versend Na Stad/Dorp',0),(101603,2823,'ro','Nava-la City',0),(101604,2823,'et','Tarnida linna',0),(101605,2823,'si','Dostava â€“ mesto',0),(101606,2823,'ba','Kapal ke kota',0),(101607,2823,'nl','Verzenden naar stad',0),(101608,2823,'fi','Toimitusosoitteen postitoimipaikka',0),(101609,2823,'no','Skipet til byen',0),(101610,2823,'da','Skib til byen',0),(101611,2823,'ko','ë„ì‹œì— ë°°',0),(101612,2823,'he','×œ×ž×©×œ×•×— ×”×¢×™×¨',0),(101613,2823,'el','Î Î»Î¿Î¯Î¿ ÏƒÏ„Î·Î½ Ï€ÏŒÎ»Î·',0),(101614,2823,'zh','æ”¶è´§å¸‚\r\n',0),(101615,2823,'sv','Fartyget till staden',0),(101616,2823,'it','Spedisci in cittÃ ',0),(101617,2823,'tl','',0),(101618,2823,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3648;&#3617;&#3639;&#3629;&#3591;',0),(101619,2823,'hi','à¤—à¤‚à¤¤à¤µà¥à¤¯ à¤¶à¤¹à¤°',0),(101620,2823,'ms','Kapal ke bandar',0),(101621,2823,'ar','Ø´Ø­Ù† Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(101622,2823,'fr','ExpÃ©dier Ã  la ville',0),(101623,2823,'jp','ç™ºé€?å…ˆå¸‚ç”ºæ?‘',0),(101624,2823,'pt','Navio para a cidade',0),(101625,2823,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð² Ð³Ð¾Ñ€Ð¾Ð´',0),(101626,2823,'es','Enviar-A Ciudad',0),(101627,2823,'de','Ship To City',0),(101628,2823,'en','Ship To City',0),(101629,2824,'is','',0),(101630,2824,'dr','( Ø§Ø±Ø³Ø§Ù„ ) Ø¨Ù‡ Ø´Ø±ÙƒØª',0),(101631,2824,'pr','Ø­Ù…Ù„( Ø§Ø±Ø³Ø§Ù„ ) Ø¨Ù‡ Ø´Ø±ÙƒØª',0),(101632,2824,'tr','Åžirketin iÃ§in sevk',0),(101633,2824,'pl','Statek do firmy',0),(101634,2824,'bg','ÐšÐ¾Ñ€Ð°Ð± ÐºÑŠÐ¼ Ñ„Ð¸Ñ€Ð¼Ð°',0),(101635,2824,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø¬ÛØ§Ø²',0),(101636,2824,'sr','Ð‘Ñ€Ð¾Ð´ Ð·Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(101637,2824,'vi','Chuyá»ƒn Ä‘áº¿n Cty',0),(101638,2824,'af','Versend Na Onderneming',0),(101639,2824,'ro','NavÄƒ la compania',0),(101640,2824,'et','Tarnida ettevÃµttele',0),(101641,2824,'si','Dostava â€“ podjetje',0),(101642,2824,'ba','Kapal ke perusahaan',0),(101643,2824,'nl','Verzenden naar bedrijf',0),(101644,2824,'fi','Aluksen yritys',0),(101645,2824,'no','Skipet til selskapet',0),(101646,2824,'da','Skib til virksomheden',0),(101647,2824,'ko','íšŒì‚¬ì— ë°œì†¡',0),(101648,2824,'he','×œ×ž×©×œ×•×— ×”×—×‘×¨×”',0),(101649,2824,'el','Î Î»Î¿Î¯Î¿ ÏƒÎµ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(101650,2824,'zh','æ”¶è´§å…¬å¸\r\n',0),(101651,2824,'sv','Levererar till fÃ¶retag',0),(101652,2824,'it','Spedire in azienda',0),(101653,2824,'tl','',0),(101654,2824,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(101655,2824,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(101656,2824,'ms','Kapal kepada Syarikat',0),(101657,2824,'ar','Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø´Ø­Ù†',0),(101658,2824,'fr','ExpÃ©dier Ã  la sociÃ©tÃ©',0),(101659,2824,'jp','ç™ºé€?å…ˆä¼šç¤¾',0),(101660,2824,'pt','Navio para empresa',0),(101661,2824,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(101662,2824,'es','Enviar-A Empresa',0),(101663,2824,'de','Ship To Unternehmen',0),(101664,2824,'en','Ship To Company',0),(101665,2825,'is','',0),(101666,2825,'dr','( Ø§Ø±Ø³Ø§Ù„ ) Ø¨Ù‡ ÙˆÙ„Ø§ÛŒØª',0),(101667,2825,'pr','Ø­Ù…Ù„( Ø§Ø±Ø³Ø§Ù„ ) Ø¨Ù‡ Ø§Ø³ØªØ§Ù† ',0),(101668,2825,'tr','Devlet iÃ§in gemi',0),(101669,2825,'pl','Statek do stanu',0),(101670,2825,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð² ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(101671,2825,'ur','Ø±ÛŒØ§Ø³Øª Ù…ÛŒÚº Ø¬ÛØ§Ø²',0),(101672,2825,'sr','Ð‘Ñ€Ð¾Ð´ Ñƒ ÑÑ‚Ð°ÑšÐµ',0),(101673,2825,'vi','Chuyá»ƒn Ä‘áº¿n bang',0),(101674,2825,'af','Versend Na Staat (Landsgebied)',0),(101675,2825,'ro','NavÄƒ la stat',0),(101676,2825,'et','Kauba saaja riik',0),(101677,2825,'si','Dostava â€“ drÅ¾ava',0),(101678,2825,'ba','Kapal ke negara',0),(101679,2825,'nl','Schip aan staat',0),(101680,2825,'fi','Aluksen tilaan',0),(101681,2825,'no','Leveringsgate /-tilstand',0),(101682,2825,'da','Skib til staten',0),(101683,2825,'ko','ìƒíƒœë¡œ ë°°ì†¡',0),(101684,2825,'he','×”×¡×¤×™× ×” ×œ×ž×¦×‘',0),(101685,2825,'el','Î Î»Î¿Î¯Î¿ ÏƒÎµ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(101686,2825,'zh','æ”¶è´§å›½å®¶\r\n',0),(101687,2825,'sv','Fartyget till staten',0),(101688,2825,'it','Nave allo stato',0),(101689,2825,'tl','',0),(101690,2825,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(101691,2825,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(101692,2825,'ms','Kapal ke Negeri',0),(101693,2825,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(101694,2825,'fr','ExpÃ©dier Ã  l\'Ã‰tat',0),(101695,2825,'jp','ç™ºé€?å…ˆå·ž',0),(101696,2825,'pt','Navio para o estado',0),(101697,2825,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð² ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(101698,2825,'es','Enviar-A Estado',0),(101699,2825,'de','Ship To State',0),(101700,2825,'en','Ship To State',0),(101701,2826,'is','',0),(101702,2826,'dr','( Ø§Ø±Ø³Ø§Ù„ ) Ø¨Ù‡ Ú©ÙˆØ¯ Ù¾Ø³ØªÙŠ',0),(101703,2826,'pr','Ø­Ù…Ù„( Ø§Ø±Ø³Ø§Ù„ ) Ø¨Ù‡ ÙƒØ¯ Ù¾Ø³ØªÙŠ',0),(101704,2826,'tr','Gemi kodu Zip',0),(101705,2826,'pl','Statek do kod pocztowy',0),(101706,2826,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð·Ð° Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(101707,2826,'ur','Ø²Ù¾ Ú©ÙˆÚˆ Ú©Û’ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²',0),(101708,2826,'sr','Ð‘Ñ€Ð¾Ð´ Ð·Ð° Ð—Ð¸Ð¿ ÐºÐ¾Ð´Ð°',0),(101709,2826,'vi','Chuyá»ƒn Ä‘áº¿n mÃ£ Zip',0),(101710,2826,'af','Versend Na Zip Kode',0),(101711,2826,'ro','Nava sÄƒ Zip Code',0),(101712,2826,'et','Laeva Zip Code',0),(101713,2826,'si','Ladji Zip kode',0),(101714,2826,'ba','Kapal untuk kode pos',0),(101715,2826,'nl','Schip aan Zip Code',0),(101716,2826,'fi','Aluksen postinumero',0),(101717,2826,'no','Skipet til postnummer',0),(101718,2826,'da','Skib til Zip-kode',0),(101719,2826,'ko','Zip ì½”ë“œë¥¼ ë°°',0),(101720,2826,'he','×”×¡×¤×™× ×” ×›×“×™ ×ž×™×§×•×“',0),(101721,2826,'el','Î Î»Î¿Î¯Î¿ Î½Î± Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(101722,2826,'zh','æ”¶è´§é‚®ç¼–\r\n',0),(101723,2826,'sv','Fartyget postnummer',0),(101724,2826,'it','Nave di Zip codice',0),(101725,2826,'tl','',0),(101726,2826,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;',0),(101727,2826,'hi','à¤œà¤¼à¤¿à¤ª à¤•à¥‹à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(101728,2826,'ms','Kapal untuk Zip kod',0),(101729,2826,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(101730,2826,'fr','Ship To Code postal',0),(101731,2826,'jp','ç™ºé€?å…ˆéƒµä¾¿ç•ªå?·',0),(101732,2826,'pt','Navio de CEP',0),(101733,2826,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð² Zip ÐºÐ¾Ð´',0),(101734,2826,'es','Enviar-A CÃ³digo Postal',0),(101735,2826,'de','Schiff ZIP-Code',0),(101736,2826,'en','Ship To Zip Code',0),(101737,2827,'is','',0),(101738,2827,'dr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(101739,2827,'pr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(101740,2827,'tr','Sevk',0),(101741,2827,'pl','WysÅ‚ane',0),(101742,2827,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¾',0),(101743,2827,'ur','Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(101744,2827,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¾',0),(101745,2827,'vi','ÄÃ£ chuyá»ƒn',0),(101746,2827,'af','Versending',0),(101747,2827,'ro','Expediate',0),(101748,2827,'et','Tarnitud',0),(101749,2827,'si','Staja',0),(101750,2827,'ba','Dikirim',0),(101751,2827,'nl','Verzonden',0),(101752,2827,'fi','LÃ¤hetetty',0),(101753,2827,'no','Sendt',0),(101754,2827,'da','Afsendt',0),(101755,2827,'ko','ë°°ì†¡',0),(101756,2827,'he','× ×©×œ×—',0),(101757,2827,'el','Î‘Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯',0),(101758,2827,'zh','å‘è´§\r\n',0),(101759,2827,'sv','Levereras',0),(101760,2827,'it','Spedito',0),(101761,2827,'tl','',0),(101762,2827,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(101763,2827,'hi','à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(101764,2827,'ms','Dihantar',0),(101765,2827,'ar','ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(101766,2827,'fr','ExpÃ©diÃ©',0),(101767,2827,'jp','ç™ºé€?æ¸ˆ',0),(101768,2827,'pt','Enviados',0),(101769,2827,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½',0),(101770,2827,'es','Enviado',0),(101771,2827,'de','Ausgeliefert',0),(101772,2827,'en','Shipped',0),(101773,2828,'is','',0),(101774,2828,'dr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø²',0),(101775,2828,'pr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø²',0),(101776,2828,'tr','Sevk:',0),(101777,2828,'pl','WysÅ‚any od:',0),(101778,2828,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸ Ð¾Ñ‚:',0),(101779,2828,'ur','Ø³Û’ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§:',0),(101780,2828,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÑƒÑ˜Ðµ ÑÐµ Ð¾Ð´:',0),(101781,2828,'vi','Chuyá»ƒn tá»«:',0),(101782,2828,'af','Versending Vanaf:',0),(101783,2828,'ro','Expediat din:',0),(101784,2828,'et','Veetakse:',0),(101785,2828,'si','Dobavljen iz:',0),(101786,2828,'ba','Dikirim dari:',0),(101787,2828,'nl','Verzonden vanuit:',0),(101788,2828,'fi','LÃ¤hetetty:',0),(101789,2828,'no','Levert av:',0),(101790,2828,'da','Afsendt fra:',0),(101791,2828,'ko','ì œê³µ:',0),(101792,2828,'he','× ×©×œ×— ×ž:',0),(101793,2828,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î±Ï€ÏŒ:',0),(101794,2828,'zh','å‘è´§åœ°ï¼š\r\n',0),(101795,2828,'sv','Levereras frÃ¥n:',0),(101796,2828,'it','Spedito da:',0),(101797,2828,'tl','',0),(101798,2828,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3592;&#3634;&#3585;:',0),(101799,2828,'hi','à¤¸à¥‡ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾:',0),(101800,2828,'ms','Dihantar dari:',0),(101801,2828,'ar','Ø´Ø­Ù† Ù…Ù†:',0),(101802,2828,'fr','ExpÃ©diÃ© de :',0),(101803,2828,'jp','ç™ºé€?å…ƒ',0),(101804,2828,'pt','Enviado de:',0),(101805,2828,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð»ÑÐµÑ‚ÑÑ Ñ:',0),(101806,2828,'es','Enviado De:',0),(101807,2828,'de','Geliefert von:',0),(101808,2828,'en','Shipped From',0),(101809,2829,'is','',0),(101810,2829,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(101811,2829,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(101812,2829,'tr','Ä°Ã§in sevk edilen madde listesi',0),(101813,2829,'pl','Listy wysÅ‚ane element',0),(101814,2829,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð°',0),(101815,2829,'ur','Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ø´Û’ ÙÛØ±Ø³Øª',0),(101816,2829,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸Ñ… Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð·Ð°',0),(101817,2829,'vi','Danh sÃ¡ch chuyáº¿n hÃ ng cho',0),(101818,2829,'af','Versende Itemlys vir',0),(101819,2829,'ro','Lista livrat pentru',0),(101820,2829,'et','LÃ¤hetatava kauba loend',0),(101821,2829,'si','Seznam ob dobavi artiklov za',0),(101822,2829,'ba','Daftar Item dikirim untuk',0),(101823,2829,'nl','Verzonden itemlijst voor',0),(101824,2829,'fi','LÃ¤hetetty Nimikeluettelo',0),(101825,2829,'no','Leveres liste over',0),(101826,2829,'da','Afsendte elementlisten for',0),(101827,2829,'ko','ë°°ì†¡ëœ í•­ëª© ëª©ë¡',0),(101828,2829,'he','×¨×©×™×ž×ª ×¤×¨×™×˜×™× ×©× ×©×œ×—×” ×¢×‘×•×¨',0),(101829,2829,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î¼ÎµÏ„Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹ ÎµÎ¹Î´ÏŽÎ½ Î³Î¹Î±',0),(101830,2829,'zh','è¿é¡¹ç›®ç›®å½•\r\n',0),(101831,2829,'sv','Levererade artikellistan fÃ¶r',0),(101832,2829,'it','Elenco di elementi spedito per',0),(101833,2829,'tl','',0),(101834,2829,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(101835,2829,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(101836,2829,'ms','Senarai barangan yang dihantar untuk',0),(101837,2829,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(101838,2829,'fr','Liste d\'Ã©lÃ©ments expÃ©diÃ©s pour',0),(101839,2829,'jp','ç™ºé€?æ¸ˆå“?ç›®ãƒªã‚¹ãƒˆ',0),(101840,2829,'pt','Lista de itens enviados para',0),(101841,2829,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶Ð°ÐµÐ¼Ð¾Ð³Ð¾ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð´Ð»Ñ',0),(101842,2829,'es','Lista de Items Enviados para',0),(101843,2829,'de','Verschickt Elementliste fÃ¼r',0),(101844,2829,'en','Shipped Item List for',0),(101845,2830,'is','',0),(101846,2830,'dr','ÙÙ‚Ø· Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(101847,2830,'pr','ÙÙ‚Ø· Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(101848,2830,'tr','YalnÄ±zca sevk',0),(101849,2830,'pl','WysÅ‚ane tylko',0),(101850,2830,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÑÑ‚ ÑÐ°Ð¼Ð¾',0),(101851,2830,'ur','ØµØ±Ù Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(101852,2830,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð° ÑÐ°Ð¼Ð¾',0),(101853,2830,'vi','Chá»‰ chuyá»ƒn',0),(101854,2830,'af','Slegs Versend',0),(101855,2830,'ro','Transportate numai',0),(101856,2830,'et','Ainult tarnitud',0),(101857,2830,'si','Staja samo',0),(101858,2830,'ba','Dikirim hanya',0),(101859,2830,'nl','Alleen verzonden',0),(101860,2830,'fi','Toimitetaan vain',0),(101861,2830,'no','Leveres bare',0),(101862,2830,'da','Leveres kun',0),(101863,2830,'ko','ë§Œ ë°°ì†¡',0),(101864,2830,'he','× ×©×œ×— ×¨×§',0),(101865,2830,'el','Î‘Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯ Î¼ÏŒÎ½Î¿',0),(101866,2830,'zh','åªæœ‰å‘è´§\r\n',0),(101867,2830,'sv','Levereras endast',0),(101868,2830,'it','Spedito solo',0),(101869,2830,'tl','',0),(101870,2830,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(101871,2830,'hi','à¤•à¥‡à¤µà¤² à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(101872,2830,'ms','Dihantar hanya',0),(101873,2830,'ar','ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§ ÙÙ‚Ø·',0),(101874,2830,'fr','ExpÃ©diÃ© uniquement',0),(101875,2830,'jp','ç™ºé€?æ¸ˆã?®ã?¿',0),(101876,2830,'pt','Enviado por apenas',0),(101877,2830,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð»ÑÑŽÑ‚ÑÑ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(101878,2830,'es','Enviado Solamente',0),(101879,2830,'de','Nur geliefert',0),(101880,2830,'en','Shipped Only',0),(101881,2831,'is','',0),(101882,2831,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(101883,2831,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(101884,2831,'tr','SEVK emri listesi',0),(101885,2831,'pl','WYSÅANE zamÃ³wienie listy do',0),(101886,2831,'bg','Ð•ÐšÐ¡ÐŸÐ•Ð”Ð˜Ð ÐÐÐ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð°',0),(101887,2831,'ur','Ø¢Ø±ÚˆØ± ÙÛØ±Ø³Øª Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(101888,2831,'sr','Ð˜Ð¡ÐŸÐžÐ Ð£Ð§Ð•ÐÐ Ð»Ð¸ÑÑ‚Ð° ÐÐÐ›ÐžÐ“Ð Ð·Ð°',0),(101889,2831,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng Ä‘Ã£ váº­n chuyá»ƒn cho',0),(101890,2831,'af','VERSENDE BESTELLYS vir',0),(101891,2831,'ro','LISTÄ‚ de comandÄƒ livrat pentru',0),(101892,2831,'et','TARNITAKSE hooldustellimuste loend jaoks',0),(101893,2831,'si','STAJA seznam NALOGOV za',0),(101894,2831,'ba','DIKIRIM pesanan daftar untuk',0),(101895,2831,'nl','ORDERLIJST voor verzonden',0),(101896,2831,'fi','TOIMITETTU tilaus luettelo',0),(101897,2831,'no','SENDT listen for',0),(101898,2831,'da','AFSENDT ORDREN liste for',0),(101899,2831,'ko','ë°°ì†¡ ìˆœì„œ ëª©ë¡ì— ëŒ€ í•œ',0),(101900,2831,'he','×©×œ×— ×¨×©×™×ž×ª ×¡×“×¨ ×¢×‘×•×¨',0),(101901,2831,'el','Î‘Î ÎŸÎ£Î¤Î‘Î›Î•ÎŠ ÎšÎ‘Î¤Î‘Î›ÎŒÎ“ÎŸÎ¥ Î”Î™Î‘Î¤Î‘Î“Î‰Î£ Î³Î¹Î± Ï„Î·Î½',0),(101902,2831,'zh','è¿ä»¤ç›®å½•\r\n',0),(101903,2831,'sv','LEVERERAS BESTÃ„LLNINGSLISTA fÃ¶r',0),(101904,2831,'it','LISTA di ordini spediti per',0),(101905,2831,'tl','',0),(101906,2831,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(101907,2831,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(101908,2831,'ms','Senarai pesanan yang dihantar untuk',0),(101909,2831,'ar','Ù‚Ø§Ø¦Ù…Ø© ØªØ±ØªÙŠØ¨ Ø´Ø­Ù†',0),(101910,2831,'fr','Liste des commandes expÃ©diÃ©es pour',0),(101911,2831,'jp','ç™ºé€?æ¸ˆæ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(101912,2831,'pt','LISTA de encomendas enviadas para',0),(101913,2831,'ru','ÐžÐ¢ÐŸÐ ÐÐ’Ð›Ð•Ð ÑÐ¿Ð¸ÑÐ¾Ðº Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð´Ð»Ñ',0),(101914,2831,'es','LISTA DE ORDENES ENVIADOS para',0),(101915,2831,'de','Lieferumfang Bestell-Liste fÃ¼r',0),(101916,2831,'en','SHIPPED ORDER LIST for',0),(101917,2832,'is','',0),(101918,2832,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(101919,2832,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(101920,2832,'tr','Sevk edilen toplamlarÄ±',0),(101921,2832,'pl','Wydane sumy',0),(101922,2832,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸ ÑÑƒÐ¼Ð¸',0),(101923,2832,'ur','Ù…ÛŒØ²Ø§Ù† Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(101924,2832,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(101925,2832,'vi','Tá»•ng cá»™ng chuyá»ƒn',0),(101926,2832,'af','Versende Totale',0),(101927,2832,'ro','Livrat totaluri',0),(101928,2832,'et','LÃ¤hetanud kogusummad',0),(101929,2832,'si','Ob dobavi vsote',0),(101930,2832,'ba','Total dikirim',0),(101931,2832,'nl','Verzonden totalen',0),(101932,2832,'fi','LÃ¤hetetty yhteensÃ¤',0),(101933,2832,'no','Leveres totaler',0),(101934,2832,'da','Afsendte totaler',0),(101935,2832,'ko','ë°°ì†¡ëœ ìš”ì•½',0),(101936,2832,'he','×¡×™×›×•×ž×™× ×©× ×©×œ×—×”',0),(101937,2832,'el','Î‘Ï€Î¿ÏƒÏ„Î­Î»Î»ÎµÏ„Î±Î¹ ÏƒÏÎ½Î¿Î»Î±',0),(101938,2832,'zh','å‘è´§æ±‡æ€»\r\n',0),(101939,2832,'sv','Levererade summor',0),(101940,2832,'it','Totali spediti',0),(101941,2832,'tl','',0),(101942,2832,'th','&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(101943,2832,'hi','à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤¯à¥‹à¤—',0),(101944,2832,'ms','Jumlah yang dihantar',0),(101945,2832,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹ Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(101946,2832,'fr','Totaux embarquÃ©es',0),(101947,2832,'jp','ç™ºé€?æ¸ˆå?ˆè¨ˆ',0),(101948,2832,'pt','Totais enviados',0),(101949,2832,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð»ÑÐµÑ‚ÑÑ Ð¸Ñ‚Ð¾Ð³Ð¸',0),(101950,2832,'es','Totales de Enviados ',0),(101951,2832,'de','Gelieferten Summen',0),(101952,2832,'en','Shipped Totals',0),(101953,2833,'is','',0),(101954,2833,'dr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(101955,2833,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(101956,2833,'tr','Nakliye',0),(101957,2833,'pl','WysyÅ‚ka',0),(101958,2833,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(101959,2833,'ur','Ø¬ÛØ§Ø² Ø±Ø§Ù†ÛŒ',0),(101960,2833,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(101961,2833,'vi','Chuyá»ƒn hÃ ng',0),(101962,2833,'af','Versending',0),(101963,2833,'ro','De transport maritim',0),(101964,2833,'et','Laevandus',0),(101965,2833,'si','Dostava',0),(101966,2833,'ba','Pengiriman',0),(101967,2833,'nl','Verzending',0),(101968,2833,'fi','Toimitus',0),(101969,2833,'no','Norge',0),(101970,2833,'da','Forsendelse',0),(101971,2833,'ko','ë°°ì†¡',0),(101972,2833,'he','×ž×©×œ×•×—',0),(101973,2833,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î±',0),(101974,2833,'zh','èˆªè¿\r\n',0),(101975,2833,'sv','Frakt',0),(101976,2833,'it','Spedizione gratuita',0),(101977,2833,'tl','',0),(101978,2833,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(101979,2833,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(101980,2833,'ms','Penghantaran',0),(101981,2833,'ar','Ø§Ù„Ø´Ø­Ù†',0),(101982,2833,'fr','ExpÃ©dition',0),(101983,2833,'jp','ç™ºé€?',0),(101984,2833,'pt','Frete',0),(101985,2833,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(101986,2833,'es','EnvÃ­o',0),(101987,2833,'de','Versand',0),(101988,2833,'en','Shipping',0),(101989,2834,'is','',0),(101990,2834,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(101991,2834,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(101992,2834,'tr','Yeni kargo taÅŸÄ±yÄ±cÄ±',0),(101993,2834,'pl','Nowy przewoÅºnik',0),(101994,2834,'bg','ÐÐ¾Ð²Ð¸ Ð¼Ð¾Ñ€ÑÐºÐ¸ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(101995,2834,'ur','Ù†Ø¦Û’ Ø´Ù¾Ù†Ú¯ Ú©ÛŒØ±ÛŒØ¦Ø±',0),(101996,2834,'sr','ÐÐ¾Ð²Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð½Ð¾ÑÐ°Ñ‡',0),(101997,2834,'vi','ThÃªm hÃ£ng váº­n chuyá»ƒn',0),(101998,2834,'af','Versendingskarweier Byvoeg',0),(101999,2834,'ro','Noi de transport maritim',0),(102000,2834,'et','Uute laevade vedaja',0),(102001,2834,'si','Nov ladijskega prevoznika',0),(102002,2834,'ba','Baru pengiriman Carrier',0),(102003,2834,'nl','Nieuwe verzendkosten vervoerder',0),(102004,2834,'fi','Uusi rahdinkuljettaja',0),(102005,2834,'no','Nye transportÃ¸ren',0),(102006,2834,'da','Nye fragtmanden',0),(102007,2834,'ko','ìƒˆë¡œìš´ ìš´ì†¡ í•­ê³µì‚¬',0),(102008,2834,'he','×”×ž×•×‘×™×œ ×”×ž×©×œ×•×— ×”×—×“×©',0),(102009,2834,'el','ÎÎ­Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(102010,2834,'zh','èˆªè¿æ‰¿è¿äººæ·»åŠ \r\n',0),(102011,2834,'sv','Nya transportfÃ¶retaget',0),(102012,2834,'it','Nuovo vettore di spedizione',0),(102013,2834,'tl','',0),(102014,2834,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(102015,2834,'hi','à¤¨à¤ˆ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¾à¤¹à¤•',0),(102016,2834,'ms','Baru kapal pengangkut',0),(102017,2834,'ar','Ø´Ø±ÙƒØ© Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(102018,2834,'fr','Nouveau transporteur',0),(102019,2834,'jp','ç™ºé€?æ¥­è€…ã?®è¿½åŠ ',0),(102020,2834,'pt','Nova operadora de transporte',0),(102021,2834,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº',0),(102022,2834,'es','Transportador de EnvÃ­os Agregar',0),(102023,2834,'de','Neu Versand',0),(102024,2834,'en','New Shipping Carrier',0),(102025,2835,'is','',0),(102026,2835,'dr','Ù‚ÙŠÙ…Øª Ø­Ù…Ù„',0),(102027,2835,'pr','Ù‚ÙŠÙ…Øª Ø­Ù…Ù„',0),(102028,2835,'tr','Nakliye maliyeti',0),(102029,2835,'pl','Koszt wysyÅ‚ki',0),(102030,2835,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(102031,2835,'ur','Ù„Ø§Ú¯Øª Ø´Ù¾Ù†Ú¯',0),(102032,2835,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(102033,2835,'vi','Chi phÃ­ váº­n chuyá»ƒn',0),(102034,2835,'af','Versendingskoste',0),(102035,2835,'ro','Costul de transport maritim',0),(102036,2835,'et','Transpordi maksumus',0),(102037,2835,'si','Prevozni stroÅ¡ki',0),(102038,2835,'ba','Biaya pengiriman',0),(102039,2835,'nl','Verzendkosten',0),(102040,2835,'fi','Toimituskulut',0),(102041,2835,'no','Frakt kostnader',0),(102042,2835,'da','Shipping Cost',0),(102043,2835,'ko','ìš´ì†¡ ë¹„ìš©',0),(102044,2835,'he','×¢×œ×•×ª ×ž×©×œ×•×—',0),(102045,2835,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(102046,2835,'zh','è¿è´¹\r\n',0),(102047,2835,'sv','Fraktkostnad',0),(102048,2835,'it','Costo di spedizione',0),(102049,2835,'tl','',0),(102050,2835,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(102051,2835,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤²à¤¾à¤—à¤¤',0),(102052,2835,'ms','Kos penghantaran',0),(102053,2835,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ø´Ø­Ù†',0),(102054,2835,'fr','Frais de port',0),(102055,2835,'jp','ç™ºé€?è²»ç”¨',0),(102056,2835,'pt','Custo de transporte',0),(102057,2835,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(102058,2835,'es','Costo de Transporte',0),(102059,2835,'de','Versandkosten',0),(102060,2835,'en','Shipping Cost',0),(102061,2836,'is','',0),(102062,2836,'dr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ ',0),(102063,2836,'pr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ ',0),(102064,2836,'tr','Sevkiyat tarihi',0),(102065,2836,'pl','Data wysyÅ‚ki',0),(102066,2836,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(102067,2836,'ur','Ø¬ÛØ§Ø² Ø±Ø§Ù†ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(102068,2836,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(102069,2836,'vi','NgÃ y váº­n chuyá»ƒn',0),(102070,2836,'af','Versendingsdatum',0),(102071,2836,'ro','Data de livrare',0),(102072,2836,'et','Tarneaeg',0),(102073,2836,'si','Datum poÅ¡iljke',0),(102074,2836,'ba','Tanggal pengiriman',0),(102075,2836,'nl','Verzenddatum',0),(102076,2836,'fi','LÃ¤hetyspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(102077,2836,'no','Forsendelsesdato',0),(102078,2836,'da','Afsendelsesdatoen',0),(102079,2836,'ko','ë°°ì†¡ ë‚ ì§œ',0),(102080,2836,'he','×ª××¨×™×š ×”×ž×©×œ×•×—',0),(102081,2836,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î½Î±Ï…Ï„Î¹Î»Î¯Î±Ï‚',0),(102082,2836,'zh','é€è´§æ—¥æœŸ\r\n',0),(102083,2836,'sv','Leveransdatum',0),(102084,2836,'it','Data di spedizione',0),(102085,2836,'tl','',0),(102086,2836,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(102087,2836,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤¤à¤¿à¤¥à¤¿',0),(102088,2836,'ms','Tarikh penghantaran',0),(102089,2836,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø´Ø­Ù†',0),(102090,2836,'fr','Date d\'expÃ©dition',0),(102091,2836,'jp','ç™ºé€?æ—¥',0),(102092,2836,'pt','Data de envio',0),(102093,2836,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(102094,2836,'es','Fecha de Transporte',0),(102095,2836,'de','Versanddatum',0),(102096,2836,'en','Shipping Date',0),(102097,2837,'is','',0),(102098,2837,'dr','Ù…Ø³Ø¦ÙˆÙ„ÙŠØª Ø­Ù…Ù„ ',0),(102099,2837,'pr','Ù…Ø³Ø¦ÙˆÙ„ÙŠØª Ø­Ù…Ù„ ',0),(102100,2837,'tr','Sevkiyat sorumluluÄŸu',0),(102101,2837,'pl','WysyÅ‚ka odpowiedzialnoÅ›ci',0),(102102,2837,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ°Ñ‚Ð° Ð¿Ð°ÑÐ¸Ð²',0),(102103,2837,'ur','Ø¬ÛØ§Ø² Ø±Ø§Ù†ÛŒ Ú©ÛŒ Ø°Ù…Û Ø¯Ø§Ø±ÛŒ',0),(102104,2837,'sr','ÐžÐ´Ð³Ð¾Ð²Ð¾Ñ€Ð½Ð¾ÑÑ‚ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(102105,2837,'vi','TrÃ¡ch nhiá»‡m váº­n chuyá»ƒn',0),(102106,2837,'af','Versending Las',0),(102107,2837,'ro','Transport pasiv',0),(102108,2837,'et','Toimetaja vastutus',0),(102109,2837,'si','Dostava odgovornosti',0),(102110,2837,'ba','Pengiriman kewajiban',0),(102111,2837,'nl','Verzending van aansprakelijkheid',0),(102112,2837,'fi','Merenkulun vastuu',0),(102113,2837,'no','Frakt ansvar',0),(102114,2837,'da','Shipping ansvar',0),(102115,2837,'ko','ë°°ì†¡ ì±…ìž„',0),(102116,2837,'he','×ž×©×œ×•×— ××—×¨×™×•×ª',0),(102117,2837,'el','Î•Ï…Î¸ÏÎ½Î· Ï„Î·Ï‚ Î½Î±Ï…Ï„Î¹Î»Î¯Î±Ï‚',0),(102118,2837,'zh','èˆªè¿æ³•å¾‹è´£ä»»\r\n',0),(102119,2837,'sv','Frakt ansvar',0),(102120,2837,'it','ResponsabilitÃ  di spedizione',0),(102121,2837,'tl','',0),(102122,2837,'th','&#3627;&#3609;&#3637;&#3657;&#3626;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(102123,2837,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤¦à¤¾à¤¯à¤¿à¤¤à¥à¤µ',0),(102124,2837,'ms','Penghantaran liabiliti',0),(102125,2837,'ar','Ù…Ø³Ø¤ÙˆÙ„ÙŠØ© Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ',0),(102126,2837,'fr','ResponsabilitÃ© de l\'expÃ©dition',0),(102127,2837,'jp','ç™ºé€?è² æ‹…',0),(102128,2837,'pt','Responsabilidade de frete',0),(102129,2837,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(102130,2837,'es','Transporte Responsabilidad Legal',0),(102131,2837,'de','Versand-Haftung',0),(102132,2837,'en','Shipping Liability',0),(102133,2838,'is','',0),(102134,2838,'dr','Ø±ÙˆØ´ Ø­Ù…Ù„',0),(102135,2838,'pr','Ø±ÙˆØ´ Ø­Ù…Ù„',0),(102136,2838,'tr','Sevkiyat yÃ¶ntemi',0),(102137,2838,'pl','Metoda wysyÅ‚ki',0),(102138,2838,'bg','ÐÐ°Ñ‡Ð¸Ð½ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(102139,2838,'ur','Ø·Ø±ÛŒÙ‚Û Ø´Ù¾Ù†Ú¯',0),(102140,2838,'sr','ÐÐ°Ñ‡Ð¸Ð½ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(102141,2838,'vi','PhÆ°Æ¡ng thá»©c váº­n chuyá»ƒn',0),(102142,2838,'af','Versendingsmetode',0),(102143,2838,'ro','Metoda de transport',0),(102144,2838,'et','Tarneviis',0),(102145,2838,'si','NaÄin poÅ¡iljanja',0),(102146,2838,'ba','Metode pengiriman',0),(102147,2838,'nl','Verzendmethode',0),(102148,2838,'fi','Toimitustapa',0),(102149,2838,'no','ForsendelsesmÃ¥te',0),(102150,2838,'da','Shipping metode',0),(102151,2838,'ko','ë°°ì†¡ ë°©ë²•',0),(102152,2838,'he','×©×™×˜×ª ×ž×©×œ×•×—',0),(102153,2838,'el','Î¤ÏÎ¿Ï€Î¿Î¹ Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î·Ï‚',0),(102154,2838,'zh','é€è´§æ–¹å¼\r\n',0),(102155,2838,'sv','LeveranssÃ¤tt',0),(102156,2838,'it','Metodo di spedizione',0),(102157,2838,'tl','',0),(102158,2838,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(102159,2838,'hi','à¤¨à¥Œà¤ªà¤°à¤¿à¤µà¤¹à¤¨ à¤µà¤¿à¤§à¤¿',0),(102160,2838,'ms','Kaedah penghantaran',0),(102161,2838,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø´Ø­Ù†',0),(102162,2838,'fr','Mode de livraison',0),(102163,2838,'jp','éƒµé€?æ–¹æ³•',0),(102164,2838,'pt','MÃ©todo de envio',0),(102165,2838,'ru','Ð¡Ð¿Ð¾ÑÐ¾Ð± Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(102166,2838,'es','MÃ©todo de Transporte',0),(102167,2838,'de','Versandart',0),(102168,2838,'en','Shipping Method',0),(102169,2839,'is','',0),(102170,2839,'dr','Ø±ÙˆØ´ Ø­Ù…Ù„',0),(102171,2839,'pr','Ø±ÙˆØ´ Ø­Ù…Ù„',0),(102172,2839,'tr','Sevkiyat yÃ¶ntemi baÅŸarÄ±yla eklendi',0),(102173,2839,'pl','Metody wysyÅ‚ki dodany pomyÅ›lnie',0),(102174,2839,'bg','ÐÐ°Ñ‡Ð¸Ð½ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(102175,2839,'ur','Ú©Ø´ØªÛŒ Ø±Ø§Ù†ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(102176,2839,'sr','ÐÐ°Ñ‡Ð¸Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(102177,2839,'vi','ThÃªm phÆ°Æ¡ng thá»©c váº­n chuyá»ƒn thÃ nh cÃ´ng',0),(102178,2839,'af','Versendingsmetode Suksesvol Bygevoeg',0),(102179,2839,'ro','Metoda de transport maritim adÄƒugat cu succes',0),(102180,2839,'et','Tarneviisi lisamine Ãµnnestus',0),(102181,2839,'si','NaÄin poÅ¡iljanja uspeÅ¡no dodani',0),(102182,2839,'ba','Metode pengiriman yang ditambahkan berhasil',0),(102183,2839,'nl','Verzendmethode toegevoegd',0),(102184,2839,'fi','Toimitustapa lisÃ¤Ã¤minen onnistui',0),(102185,2839,'no','Fraktmetode lagt',0),(102186,2839,'da','Shipping metode tilfÃ¸jet',0),(102187,2839,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ë°°ì†¡ ë°©ë²•',0),(102188,2839,'he','×©×™×˜×ª ×”×ž×©×œ×•×— × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(102189,2839,'el','Î¤ÏÎ¿Ï€Î¿Î¹ Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î·Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(102190,2839,'zh','é€è´§æ–¹å¼æ·»åŠ æˆåŠŸ\r\n',0),(102191,2839,'sv','LeveranssÃ¤tt som lagts',0),(102192,2839,'it','Metodo di spedizione aggiunto con successo',0),(102193,2839,'tl','',0),(102194,2839,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(102195,2839,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤ªà¤¦à¥à¤§à¤¤à¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(102196,2839,'ms','Kaedah penghantaran yang berjaya menambah',0),(102197,2839,'ar','Ø£Ø¶ÙŠÙØª Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø´Ø­Ù† Ø¨Ù†Ø¬Ø§Ø­',0),(102198,2839,'fr','Mode de livraison ajoutÃ© avec succÃ¨s',0),(102199,2839,'jp','ç™ºé€?æ–¹æ³•ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(102200,2839,'pt','MÃ©todo de envio adicionado com sucesso',0),(102201,2839,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹ ÑÐ¿Ð¾ÑÐ¾Ð±Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(102202,2839,'es','MÃ©todo de Transporte agregado exitosamente',0),(102203,2839,'de','Versandart erfolgreich hinzugefÃ¼gt',0),(102204,2839,'en','Shipping Method added successfully',0),(102205,2840,'is','',0),(102206,2840,'dr','Ø­Ø°Ù Ø±ÙˆØ´ Ø­Ù…Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(102207,2840,'pr','Ø­Ø°Ù Ø±ÙˆØ´ Ø­Ù…Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(102208,2840,'tr','Sevkiyat yÃ¶ntemi baÅŸarÄ±yla silindi',0),(102209,2840,'pl','Metody wysyÅ‚ki przesâ”‚anie',0),(102210,2840,'bg','ÐÐ°Ñ‡Ð¸Ð½ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(102211,2840,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø´Ù¾Ù†Ú¯ Ø·Ø±ÛŒÙ‚Û',0),(102212,2840,'sr','ÐÐ°Ñ‡Ð¸Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(102213,2840,'vi','XÃ³a phÆ°Æ¡ng thá»©c váº­n chuyá»ƒn thÃ nh cÃ´ng',0),(102214,2840,'af','Versendingsmetode Suksesvol Geskrap',0),(102215,2840,'ro','Metoda de transport maritim eliminÄƒ cu succes',0),(102216,2840,'et','Tarneviisi kustutamine Ãµnnestus',0),(102217,2840,'si','NaÄin poÅ¡iljanja uspeÅ¡no izbrisana',0),(102218,2840,'ba','Metode pengiriman yang berhasil dihapus',0),(102219,2840,'nl','Verzendmethode met succes verwijderd',0),(102220,2840,'fi','Toimitustapa poistettu',0),(102221,2840,'no','Fraktmetode slettet',0),(102222,2840,'da','Shipping metode slettet',0),(102223,2840,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ë°°ì†¡ ë°©ë²•',0),(102224,2840,'he','×©×™×˜×ª ×”×ž×©×œ×•×— × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(102225,2840,'el','Î¤ÏÎ¿Ï€Î¿Î¹ Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î·Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(102226,2840,'zh','é€è´§æ–¹å¼æˆåŠŸåˆ é™¤\r\n',0),(102227,2840,'sv','LeveranssÃ¤tt raderades',0),(102228,2840,'it','Metodo di spedizione eliminato con successo',0),(102229,2840,'tl','',0),(102230,2840,'th','&#3621;&#3610;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(102231,2840,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤ªà¤¦à¥à¤§à¤¤à¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(102232,2840,'ms','Kaedah penghantaran yang dihapuskan dengan jayanya',0),(102233,2840,'ar','Ø­Ø°ÙØª Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø´Ø­Ù† Ø¨Ù†Ø¬Ø§Ø­',0),(102234,2840,'fr','Mode de livraison supprimÃ© avec succÃ¨s',0),(102235,2840,'jp','ç™ºé€?æ–¹æ³•ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(102236,2840,'pt','MÃ©todo de envio apagado com sucesso',0),(102237,2840,'ru','Ð¡Ð¿Ð¾ÑÐ¾Ð± Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(102238,2840,'es','MÃ©todo de Transporte eliminado exitosamente',0),(102239,2840,'de','Versandart erfolgreich gelÃ¶scht',0),(102240,2840,'en','Shipping Method deleted successfully',0),(102241,2841,'is','',0),(102242,2841,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø±ÙˆØ´ Ø­Ù…Ù„',0),(102243,2841,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø±ÙˆØ´ Ø­Ù…Ù„',0),(102244,2841,'tr','Sevkiyat yÃ¶ntemi DÃ¼zenle',0),(102245,2841,'pl','Edytuj metoda wysyÅ‚ki',0),(102246,2841,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð°Ñ‡Ð¸Ð½ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(102247,2841,'ur','Ø·Ø±ÛŒÙ‚Û Ø´Ù¾Ù†Ú¯ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(102248,2841,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð½Ð°Ñ‡Ð¸Ð½ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(102249,2841,'vi','Cáº­p nháº­t phÆ°Æ¡ng thá»©c váº­n chuyá»ƒn',0),(102250,2841,'af','Versendingsmetode Suksesvol Opdateer',0),(102251,2841,'ro','Edita metoda de transport',0),(102252,2841,'et','Tarneviisi uuendamine',0),(102253,2841,'si','Urejanje prevozov metoda',0),(102254,2841,'ba','Mengedit pengiriman metode',0),(102255,2841,'nl','Verzendmethode bewerken',0),(102256,2841,'fi','Muokkaa toimitustapa',0),(102257,2841,'no','Redigere forsendelsesmÃ¥te',0),(102258,2841,'da','Redigere leveringsmetoden',0),(102259,2841,'ko','ì„ ë°• ë°©ë²• íŽ¸ì§‘',0),(102260,2841,'he','×¢×¨×™×›×ª ×©×™×˜×ª ×ž×©×œ×•×—',0),(102261,2841,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î¼Î­Î¸Î¿Î´Î¿Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(102262,2841,'zh','é€è´§æ–¹å¼æ›´æ–°\r\n',0),(102263,2841,'sv','Redigera fraktsÃ¤tt',0),(102264,2841,'it','Modificare il metodo di spedizione',0),(102265,2841,'tl','',0),(102266,2841,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(102267,2841,'hi','à¤¨à¥Œà¤ªà¤°à¤¿à¤µà¤¹à¤¨ à¤µà¤¿à¤§à¤¿ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(102268,2841,'ms','Edit penghantaran kaedah',0),(102269,2841,'ar','ØªØ­Ø¯ÙŠØ« Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø´Ø­Ù†',0),(102270,2841,'fr','Modifier le mode de livraison',0),(102271,2841,'jp','ç™ºé€?æ–¹æ³•ã?®æ›´æ–°',0),(102272,2841,'pt','Edite o mÃ©todo de envio',0),(102273,2841,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¼ÐµÑ‚Ð¾Ð´ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(102274,2841,'es','MÃ©todo de Transporte Actualizar',0),(102275,2841,'de','Bearbeiten, Versandart',0),(102276,2841,'en','Edit Shipping Method',0),(102277,2842,'is','',0),(102278,2842,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø±ÙˆØ´ Ø­Ù…Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(102279,2842,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø±ÙˆØ´ Ø­Ù…Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(102280,2842,'tr','Sevkiyat yÃ¶ntemi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(102281,2842,'pl','Metoda pomyÅ›lnie zaktualizowana wysyÅ‚ki',0),(102282,2842,'bg','ÐÐ°Ñ‡Ð¸Ð½ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(102283,2842,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø·Ø±ÛŒÙ‚Û Ø´Ù¾Ù†Ú¯',0),(102284,2842,'sr','ÐÐ°Ñ‡Ð¸Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(102285,2842,'vi','Cáº­p nháº­t phÆ°Æ¡ng thá»©c váº­n chuyá»ƒn thÃ nh cÃ´ng',0),(102286,2842,'af','Versendingsmetode Suksesvol Opdateer',0),(102287,2842,'ro','Metoda de transport maritim actualizat cu succes',0),(102288,2842,'et','rneviisi uuendamine Ãµnnestus',0),(102289,2842,'si','NaÄin poÅ¡iljanja uspeÅ¡no posodobljena',0),(102290,2842,'ba','Metode pengiriman yang berhasil',0),(102291,2842,'nl','Verzendmethode bijgewerkt',0),(102292,2842,'fi','PÃ¤ivitetty toimitustapa',0),(102293,2842,'no','Fraktmetode oppdatert',0),(102294,2842,'da','Shipping metode opdateret',0),(102295,2842,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ë°°ì†¡ ë°©ë²•',0),(102296,2842,'he','×©×™×˜×ª ×”×ž×©×œ×•×— ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(102297,2842,'el','Î¤ÏÎ¿Ï€Î¿Î¹ Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î·Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(102298,2842,'zh','é€è´§æ–¹å¼æˆåŠŸæ›´æ–°\r\n',0),(102299,2842,'sv','LeveranssÃ¤tt uppdaterats',0),(102300,2842,'it','Metodo di spedizione aggiornato con successo',0),(102301,2842,'tl','',0),(102302,2842,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(102303,2842,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤ªà¤¦à¥à¤§à¤¤à¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(102304,2842,'ms','Kaedah penghantaran yang berjaya dikemas kini',0),(102305,2842,'ar','Ø­Ø¯Ù‘Ø«Øª Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø´Ø­Ù† Ø¨Ù†Ø¬Ø§Ø­',0),(102306,2842,'fr','Mode de livraison mis Ã  jour avec succÃ¨s',0),(102307,2842,'jp','ç™ºé€?æ–¹æ³•ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(102308,2842,'pt','MÃ©todo de envio atualizado com sucesso',0),(102309,2842,'ru','Ð¡Ð¿Ð¾ÑÐ¾Ð± Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(102310,2842,'es','MÃ©todo de Transporte actualizado exitosamente',0),(102311,2842,'de','Versandart erfolgreich aktualisiert',0),(102312,2842,'en','Shipping Method updated successfully',0),(102313,2843,'is','',0),(102314,2843,'dr','Ù†ÙˆØ¹ Ø­Ù…Ù„',0),(102315,2843,'pr','Ù†ÙˆØ¹ Ø­Ù…Ù„',0),(102316,2843,'tr','Aktarma tÃ¼rÃ¼',0),(102317,2843,'pl','WysyÅ‚ka typu',0),(102318,2843,'bg','Ð¢Ð¸Ð¿ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(102319,2843,'ur','Ø¬ÛØ§Ø² Ø±Ø§Ù†ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(102320,2843,'sr','Ð¢Ð¸Ð¿ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(102321,2843,'vi','Loáº¡i váº­n chuyá»ƒn ',0),(102322,2843,'af','Versendingstipe',0),(102323,2843,'ro','Tipul de expediere',0),(102324,2843,'et','Laevanduse tÃ¼Ã¼p',0),(102325,2843,'si','Vrste prevozov',0),(102326,2843,'ba','Jenis pengiriman',0),(102327,2843,'nl','Verzending Type',0),(102328,2843,'fi','Merenkulkua',0),(102329,2843,'no','Frakt Type',0),(102330,2843,'da','Fragt Type',0),(102331,2843,'ko','ë°°ì†¡ ìœ í˜•',0),(102332,2843,'he','×¡×•×’ ×ž×©×œ×•×—',0),(102333,2843,'el','Î¤ÏÏ€Î¿ Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(102334,2843,'zh','èˆªè¿ç±»åž‹\r\n',0),(102335,2843,'sv','Frakt typ',0),(102336,2843,'it','Tipo di spedizione',0),(102337,2843,'tl','',0),(102338,2843,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(102339,2843,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(102340,2843,'ms','Jenis penghantaran',0),(102341,2843,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø´Ø­Ù†',0),(102342,2843,'fr','Type d\'expÃ©dition',0),(102343,2843,'jp','ç™ºé€?ç¨®é¡ž',0),(102344,2843,'pt','Tipo de envio',0),(102345,2843,'ru','Ð¢Ð¸Ð¿ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(102346,2843,'es','Tipo de Transporte',0),(102347,2843,'de','Versandart',0),(102348,2843,'en','Shipping Type',0),(102349,2844,'is','',0),(102350,2844,'dr','Ø­Ù…Ù„ Ø¨Ù‡  Ù…Ø­Ù„',0),(102351,2844,'pr','Ø­Ù…Ù„ Ø¨Ù‡  Ù…Ø­Ù„',0),(102352,2844,'tr','Konum iÃ§in sevk',0),(102353,2844,'pl','Statek do lokalizacji',0),(102354,2844,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð·Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(102355,2844,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø± Ø¬ÛØ§Ø²',0),(102356,2844,'sr','Ð‘Ñ€Ð¾Ð´ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(102357,2844,'vi','Gá»­i Ä‘áº¿n: vá»‹ trÃ­',0),(102358,2844,'af','Versend Na Plek',0),(102359,2844,'ro','NavÄƒ la locaÅ£ia',0),(102360,2844,'et','Laeva asukohta',0);
INSERT INTO `langdef` VALUES (102361,2844,'si','Dostava â€“ mesto',0),(102362,2844,'ba','Kapal ke lokasi',0),(102363,2844,'nl','Schip naar locatie',0),(102364,2844,'fi','Aluksen sijaintiin',0),(102365,2844,'no','Leveringsgate /-plassering',0),(102366,2844,'da','Skib til placering',0),(102367,2844,'ko','ìœ„ì¹˜ì— ë°°',0),(102368,2844,'he','×”×¡×¤×™× ×” ×œ×ž×™×§×•×',0),(102369,2844,'el','Î Î»Î¿Î¯Î¿ ÏƒÎµ Î¸Î­ÏƒÎ·',0),(102370,2844,'zh','æ”¶è´§åœ°ç‚¹\r\n',0),(102371,2844,'sv','Skickar till den',0),(102372,2844,'it','Spedisci in posizione',0),(102373,2844,'tl','',0),(102374,2844,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(102375,2844,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(102376,2844,'ms','Menghantar ke lokasi',0),(102377,2844,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ù…ÙƒØ§Ù†',0),(102378,2844,'fr','ExpÃ©dier Ã  l\'emplacement',0),(102379,2844,'jp','ç™ºé€?å…ˆãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(102380,2844,'pt','A localizaÃ§Ã£o do navio',0),(102381,2844,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð½Ð° Ð¼ÐµÑÑ‚Ðµ',0),(102382,2844,'es','UbicaciÃ³n de Enviar a',0),(102383,2844,'de','Ship To Location',0),(102384,2844,'en','Ship To Location',0),(102385,2845,'is','',0),(102386,2845,'dr','_ Ù…Ø­Ù„',0),(102387,2845,'pr','Ø­Ù…Ù„ Ø¨Ù‡  _ Ù…Ø­Ù„',0),(102388,2845,'tr','GÃ¶nderilecek yerleri',0),(102389,2845,'pl','Miejsca dostaw',0),(102390,2845,'bg','ÐœÐµÑÑ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(102391,2845,'ur','Ø¬ÛØ§Ø² Ú©Û’ Ù…Ù‚Ø§Ù…Ø§Øª',0),(102392,2845,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(102393,2845,'vi','Gá»­i Ä‘áº¿n: vá»‹ trÃ­',0),(102394,2845,'af','Versend-Na Plekke',0),(102395,2845,'ro','Livrare-la locaÅ£ii',0),(102396,2845,'et','Asukohad',0),(102397,2845,'si','Za dobavo lokacijah',0),(102398,2845,'ba','Kapal ke lokasi',0),(102399,2845,'nl','Verzendlocaties',0),(102400,2845,'fi','Toimitusasiakkaan sijainnit',0),(102401,2845,'no','Lever til-steder',0),(102402,2845,'da','Skib-til placeringer',0),(102403,2845,'ko','ë°°ì†¡ ìœ„ì¹˜',0),(102404,2845,'he','×œ×ž×©×œ×•×— ×ž×™×§×•×ž×™×',0),(102405,2845,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚',0),(102406,2845,'zh','èˆ°å¯¹åœ°ç‚¹\r\n',0),(102407,2845,'sv','Leveransadress platser',0),(102408,2845,'it','Spedire a posizioni',0),(102409,2845,'tl','',0),(102410,2845,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(102411,2845,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(102412,2845,'ms','Kapal ke lokasi',0),(102413,2845,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù„Ù„Ù…ÙˆØ§Ù‚Ø¹',0),(102414,2845,'fr','Lieux de livraison',0),(102415,2845,'jp','ç™ºé€?å…ˆãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(102416,2845,'pt','Nave-para locais',0),(102417,2845,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð² Ð¼ÐµÑÑ‚Ð°',0),(102418,2845,'es','Ubicaciones de Enviar a',0),(102419,2845,'de','Lieferadresse Locations',0),(102420,2845,'en','Ship-to Locations',0),(102421,2846,'is','',0),(102422,2846,'dr','Ø®Ø±ÙŠØ¯ ',0),(102423,2846,'pr','Ø®Ø±ÙŠØ¯ ',0),(102424,2846,'tr','AlÄ±ÅŸveriÅŸ',0),(102425,2846,'pl','Zakupy',0),(102426,2846,'bg','ÐŸÐ°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ',0),(102427,2846,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(102428,2846,'sr','Ð£ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ñƒ',0),(102429,2846,'vi','Mua Sáº¯m',0),(102430,2846,'af','Aankope',0),(102431,2846,'ro','Mag. Online',0),(102432,2846,'et','Uudised',0),(102433,2846,'si','Nakupi',0),(102434,2846,'ba','Belanja',0),(102435,2846,'nl','Winkelen',0),(102436,2846,'fi','Ostokset',0),(102437,2846,'no','Shopping',0),(102438,2846,'da','Shopping',0),(102439,2846,'ko','ì‡¼í•‘',0),(102440,2846,'he','×§× ×™×•×ª',0),(102441,2846,'el','Î¨ÏŽÎ½Î¹Î±',0),(102442,2846,'zh','è´­ç‰©\r\n',0),(102443,2846,'sv','Shopping',0),(102444,2846,'it','Lo shopping',0),(102445,2846,'tl','',0),(102446,2846,'th','&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;(PO)',0),(102447,2846,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€',0),(102448,2846,'ms','Membeli-belah',0),(102449,2846,'ar','Ø§Ù„ØªØ³ÙˆÙ‚',0),(102450,2846,'fr','Shopping',0),(102451,2846,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°',0),(102452,2846,'pt','Fazer compras',0),(102453,2846,'ru','Ð¨Ð¾Ð¿Ð¿Ð¸Ð½Ð³',0),(102454,2846,'es','Ir a Compras',0),(102455,2846,'de','Einkaufen',0),(102456,2846,'en','Shopping',0),(102457,2847,'is','',0),(102458,2847,'dr','ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(102459,2847,'pr','ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(102460,2847,'tr','AlÄ±ÅŸveriÅŸ sepeti',0),(102461,2847,'pl','Koszyk na zakupy',0),(102462,2847,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐºÐ° Ð·Ð° Ð¿Ð°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ',0),(102463,2847,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ',0),(102464,2847,'sr','Ð¡Ñ…Ð¾Ð¿Ð¿Ð¸Ð½Ð³ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(102465,2847,'vi','Giá» HÃ ng',0),(102466,2847,'af','Winkeltrollie',0),(102467,2847,'ro','Cosul de cumparaturi',0),(102468,2847,'et','Ostukorv',0),(102469,2847,'si','Nakupovalni voziÄek',0),(102470,2847,'ba','Keranjang belanja',0),(102471,2847,'nl','Uw winkelwagen',0),(102472,2847,'fi','Ostoskori',0),(102473,2847,'no','Handlekurv',0),(102474,2847,'da','IndkÃ¸bskurv',0),(102475,2847,'ko','ì‡¼í•‘ ì¹´íŠ¸',0),(102476,2847,'he','×¢×’×œ×ª ×§× ×™×•×ª',0),(102477,2847,'el','ÎšÎ±Î»Î¬Î¸Î¹ Î±Î³Î¿ÏÏŽÎ½',0),(102478,2847,'zh','è´­ç‰©è½¦\r\n',0),(102479,2847,'sv','Kundvagn',0),(102480,2847,'it','Carrello',0),(102481,2847,'tl','',0),(102482,2847,'th','&#3619;&#3606;&#3648;&#3586;&#3655;&#3609;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(102483,2847,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€',0),(102484,2847,'ms','Troli membeli-belah',0),(102485,2847,'ar','Ø¹Ø±Ø¨Ø© Ø§Ù„ØªØ³ÙˆÙ‘Ù‚',0),(102486,2847,'fr','Panier d\'achat',0),(102487,2847,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°ã‚«ãƒ¼ãƒˆ',0),(102488,2847,'pt','Carrinho de compras',0),(102489,2847,'ru','ÐšÐ¾Ñ€Ð·Ð¸Ð½Ð°',0),(102490,2847,'es','Carrito de Compras',0),(102491,2847,'de','Warenkorb',0),(102492,2847,'en','Shopping Cart',0),(102493,2848,'is','',0),(102494,2848,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(102495,2848,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(102496,2848,'tr','AlÄ±ÅŸveriÅŸ sepeti arama gÃ¶rÃ¼ntÃ¼leme',0),(102497,2848,'pl','Zakupy koszyka Szukaj wyÅ›wietlacz',0),(102498,2848,'bg','ÐŸÐ°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ ÐºÐ¾ÑˆÐ½Ð¸Ñ†Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð´Ð¸ÑÐ¿Ð»ÐµÐ¹',0),(102499,2848,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ ØªÙ„Ø§Ø´ Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(102500,2848,'sr','ÐšÑƒÐ¿Ð¾Ð²Ð¸Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ†Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°',0),(102501,2848,'vi','Hiá»ƒn Thá»‹ Giá» HÃ ng',0),(102502,2848,'af','Shopping Cart soek vertoon',0),(102503,2848,'ro','AfiÅŸat de CÄƒutaÅ£i coÅŸ de cumpÄƒrÄƒturi',0),(102504,2848,'et','Shopping ostukorvi Otsing ekraani',0),(102505,2848,'si','Nakupovalni voziÄek iskanje prikaz',0),(102506,2848,'ba','Shopping Cart pencarian tampilan',0),(102507,2848,'nl','Shopping Cart Zoek Display',0),(102508,2848,'fi','Shopping Cart Etsi nÃ¤yttÃ¶',0),(102509,2848,'no','Shopping Cart sÃ¸kevisningen',0),(102510,2848,'da','Shopping Cart SÃ¸g Display',0),(102511,2848,'ko','ì‡¼í•‘ ì¹´íŠ¸ ê²€ìƒ‰ í‘œì‹œ',0),(102512,2848,'he','×ª×¦×•×’×ª ×—×™×¤×•×© ×¢×’×œ×ª ×§× ×™×•×ª',0),(102513,2848,'el','Î¨ÏŽÎ½Î¹Î± ÎºÎ±Î»Î¬Î¸Î¹ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î¿Î¸ÏŒÎ½Î·',0),(102514,2848,'zh','æœç´¢æ˜¾ç¤ºè´­ç‰©è½¦\r\n',0),(102515,2848,'sv','Shopping Cart SÃ¶k Display',0),(102516,2848,'it','Visualizzazione di ricerca dello Shopping Cart',0),(102517,2848,'tl','',0),(102518,2848,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;&#3619;&#3606;&#3648;&#3586;&#3655;&#3609;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(102519,2848,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤–à¥‹à¤œ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨',0),(102520,2848,'ms','Paparan carian troli membeli-belah',0),(102521,2848,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø¹Ø±Ø¨Ø© Ø§Ù„ØªØ³ÙˆÙ‚',0),(102522,2848,'fr','Ã‰cran de recherche Shopping Cart',0),(102523,2848,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°ã‚«ãƒ¼ãƒˆæ¤œç´¢è¡¨ç¤º',0),(102524,2848,'pt','ExibiÃ§Ã£o de pesquisa carrinho de compras',0),(102525,2848,'ru','Ð”Ð¸ÑÐ¿Ð»ÐµÐ¹ ÐŸÐ¾Ð¸ÑÐº ÐºÐ¾Ñ€Ð·Ð¸Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº',0),(102526,2848,'es','Carrito de Compras Pantalla de Busqueda',0),(102527,2848,'de','Shopping Cart-Such-Display',0),(102528,2848,'en','Shopping Cart Search Display',0),(102529,2849,'is','',0),(102530,2849,'dr','Ù†Ù…Ø§ÙŠØ´ ',0),(102531,2849,'pr','Ù†Ù…Ø§ÙŠØ´ ',0),(102532,2849,'tr','GÃ¶ster',0),(102533,2849,'pl','PokaÅ¼',0),(102534,2849,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸',0),(102535,2849,'ur','Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102536,2849,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸',0),(102537,2849,'vi','Hiá»ƒn thá»‹',0),(102538,2849,'af','Wys ',0),(102539,2849,'ro','AratÄƒ',0),(102540,2849,'et','NÃ¤ita',0),(102541,2849,'si','PrikaÅ¾i',0),(102542,2849,'ba','Tampilkan',0),(102543,2849,'nl','Toon',0),(102544,2849,'fi','NÃ¤ytÃ¤',0),(102545,2849,'no','Vis',0),(102546,2849,'da','Vis',0),(102547,2849,'ko','ë³´ê¸°',0),(102548,2849,'he','×”×¦×’',0),(102549,2849,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·',0),(102550,2849,'zh','æ˜¾ç¤º\r\n',0),(102551,2849,'sv','Visa',0),(102552,2849,'it','Visualizza',0),(102553,2849,'tl','',0),(102554,2849,'th','&#3649;&#3626;&#3604;&#3591;',0),(102555,2849,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102556,2849,'ms','Papar',0),(102557,2849,'ar','Ø¥Ø¸Ù‡Ø§Ø±',0),(102558,2849,'fr','Voir l\'Ã©tablissement',0),(102559,2849,'jp','è¡¨ç¤º',0),(102560,2849,'pt','Mostrar',0),(102561,2849,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ',0),(102562,2849,'es','Mostrar',0),(102563,2849,'de','Karte',0),(102564,2849,'en','Show',0),(102565,2850,'is','',0),(102566,2850,'dr','Ù†Ù…Ø§ÙŠØ´ ØªÙ…Ø§Ù… Ø«Ø¨Øª Ù‡Ø§',0),(102567,2850,'pr','Ù†Ù…Ø§ÙŠØ´ ØªÙ…Ø§Ù… Ø«Ø¨Øª Ù‡Ø§',0),(102568,2850,'tr','TÃœM giriÅŸleri gÃ¶ster',0),(102569,2850,'pl','PokaÅ¼ wszystkie wpisy',0),(102570,2850,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(102571,2850,'ur','ØªÙ…Ø§Ù… Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102572,2850,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(102573,2850,'vi','Hiá»ƒn thá»‹ táº¥t cáº£ cÃ¡c bÃºt toÃ¡n',0),(102574,2850,'af','Wys ALLE Inskrywings',0),(102575,2850,'ro','AratÄƒ toate intrÄƒrile',0),(102576,2850,'et','Vaata kÃµiki kirjeid',0),(102577,2850,'si','PrikaÅ¾i vse navedbe',0),(102578,2850,'ba','Tampilkan semua entri',0),(102579,2850,'nl','Laat alle reacties zien',0),(102580,2850,'fi','NÃ¤ytÃ¤ kaikki merkinnÃ¤t',0),(102581,2850,'no','Vis alle',0),(102582,2850,'da','Vis alle indgange',0),(102583,2850,'ko','ëª¨ë“  í•­ëª© í‘œì‹œ',0),(102584,2850,'he','×”×¦×’ ××ª ×›×œ ×”×¢×¨×›×™×',0),(102585,2850,'el','Î”ÎµÎ¯Ï„Îµ ÎŒÎ›Î•Î£ Ï„Î¹Ï‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(102586,2850,'zh','æ˜¾ç¤ºæ‰€æœ‰æ¡ç›®\r\n',0),(102587,2850,'sv','Visa alla poster',0),(102588,2850,'it','Visualizza tutte le voci',0),(102589,2850,'tl','',0),(102590,2850,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(102591,2850,'hi','à¤¸à¤­à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102592,2850,'ms','Tunjukkan semua catatan',0),(102593,2850,'ar','ØªØ¸Ù‡Ø± ÙƒØ§ÙØ© Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª',0),(102594,2850,'fr','Afficher toutes les entrÃ©es',0),(102595,2850,'jp','å…¨ã?¦ã?®è¨˜å¸³ã‚’è¡¨ç¤º',0),(102596,2850,'pt','Mostrar todas as entradas',0),(102597,2850,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð’Ð¡Ð• Ð—Ð°Ð¿Ð¸ÑÐ¸',0),(102598,2850,'es','Mostrar TODAS Entradas',0),(102599,2850,'de','ALLE EintrÃ¤ge anzeigen',0),(102600,2850,'en','Show ALL Entries',0),(102601,2851,'is','',0),(102602,2851,'dr','Ù†Ù…Ø§ÙŠØ´ ØªÙ…Ø§Ù… Ø«Ø¨Øª Ù‡Ø§',0),(102603,2851,'pr','Ù†Ù…Ø§ÙŠØ´ ØªÙ…Ø§Ù… Ø«Ø¨Øª Ù‡Ø§',0),(102604,2851,'tr','TÃ¼m giriÅŸleri gÃ¶ster',0),(102605,2851,'pl','PokaÅ¼ wszystkie wpisy',0),(102606,2851,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(102607,2851,'ur','ØªÙ…Ø§Ù… Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102608,2851,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(102609,2851,'vi','Hiá»ƒn thá»‹ táº¥t cáº£ cÃ¡c bÃºt toÃ¡n',0),(102610,2851,'af','Wys Alle Inskrywings',0),(102611,2851,'ro','AratÄƒ toate intrÄƒrile',0),(102612,2851,'et','Vaata kÃµiki kirjeid',0),(102613,2851,'si','PrikaÅ¾i vse navedbe',0),(102614,2851,'ba','Tampilkan semua entri',0),(102615,2851,'nl','Laat alle reacties zien',0),(102616,2851,'fi','NÃ¤ytÃ¤ kaikki merkinnÃ¤t',0),(102617,2851,'no','Vis alle',0),(102618,2851,'da','Vis alle indgange',0),(102619,2851,'ko','ëª¨ë“  í•­ëª© í‘œì‹œ',0),(102620,2851,'he','×”×¦×’ ××ª ×›×œ ×”×¢×¨×›×™×',0),(102621,2851,'el','Î”ÎµÎ¯Ï„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(102622,2851,'zh','æ˜¾ç¤ºæ‰€æœ‰æ¡ç›®\r\n',0),(102623,2851,'sv','Visa alla poster',0),(102624,2851,'it','Visualizza tutte le voci',0),(102625,2851,'tl','',0),(102626,2851,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(102627,2851,'hi','à¤¸à¤­à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102628,2851,'ms','Tunjukkan semua catatan',0),(102629,2851,'ar','ØªØ¸Ù‡Ø± ÙƒØ§ÙØ© Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª',0),(102630,2851,'fr','Afficher toutes les entrÃ©es',0),(102631,2851,'jp','å…¨ã?¦ã?®è¨˜å¸³ã‚’è¡¨ç¤º',0),(102632,2851,'pt','Mostrar todas as entradas',0),(102633,2851,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð’ÑÐµÑ… Ð—Ð°Ð¿Ð¸ÑÐµÐ¹',0),(102634,2851,'es','Mostrar TODAS Entradas',0),(102635,2851,'de','Alle EintrÃ¤ge anzeigen',0),(102636,2851,'en','Show All Entries',0),(102637,2852,'is','',0),(102638,2852,'dr','Ù†Ù…Ø§ÙŠØ´ Ø·Ø¨Ù‚ Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ',0),(102639,2852,'pr','Ù†Ù…Ø§ÙŠØ´ Ø·Ø¨Ù‚ Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ',0),(102640,2852,'tr','GeÃ§erli aya gÃ¶re gÃ¶stermek',0),(102641,2852,'pl','PokaÅ¼ przez bieÅ¼Ä…cy miesiÄ…c',0),(102642,2852,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ð¾ Ñ‚ÐµÐºÑƒÑ‰Ð¸Ñ Ð¼ÐµÑÐµÑ†',0),(102643,2852,'ur','Ø±ÙˆØ§Úº Ù…Ø§Û Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102644,2852,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ð¼ÐµÑÐµÑ†',0),(102645,2852,'vi','Hiá»ƒn thá»‹ theo thÃ¡ng hiá»‡n thá»i',0),(102646,2852,'af','Wys per Huidige Maand',0),(102647,2852,'ro','AratÄƒ de luna curentÄƒ',0),(102648,2852,'et','NÃ¤ita praeguse kuu',0),(102649,2852,'si','Prikazati trenutni mesec',0),(102650,2852,'ba','Menunjukkan dengan bulan ini',0),(102651,2852,'nl','Toon door huidige maand',0),(102652,2852,'fi','NÃ¤ytÃ¤ nykyinen kuukausittain',0),(102653,2852,'no','Vis etter gjeldende mÃ¥ned',0),(102654,2852,'da','Vis af indevÃ¦rende mÃ¥ned',0),(102655,2852,'ko','í˜„ìž¬ ë‹¬ ë³´ê¸°',0),(102656,2852,'he','×”×¦×’ ×œ×¤×™ ×”×—×•×“×© ×”× ×•×›×—×™',0),(102657,2852,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î±Ï€ÏŒ Ï„Î¿Î½ Ï„ÏÎ­Ï‡Î¿Î½Ï„Î± Î¼Î®Î½Î±',0),(102658,2852,'zh','å±•è§ˆç”±æœ¬æœˆ\r\n',0),(102659,2852,'sv','Visa av innevarande mÃ¥nad',0),(102660,2852,'it','Visualizza il mese corrente',0),(102661,2852,'tl','',0),(102662,2852,'th','&#3649;&#3626;&#3604;&#3591;&#3650;&#3604;&#3618;&#3648;&#3604;&#3639;&#3629;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(102663,2852,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102664,2852,'ms','Menunjukkan dengan bulan semasa',0),(102665,2852,'ar','ÙˆØªØ¨ÙŠÙ† Ø®Ù„Ø§Ù„ Ø§Ù„Ø´Ù‡Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(102666,2852,'fr','Afficher par mois en cours',0),(102667,2852,'jp','ç?¾åœ¨ã?®æœˆã?§è¡¨ç¤º',0),(102668,2852,'pt','Visualizar mÃªs atual',0),(102669,2852,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ð¾ Ð¢ÐµÐºÑƒÑ‰ÐµÐ¼Ñƒ ÐœÐµÑÑÑ†Ñƒ',0),(102670,2852,'es','Mostrar por Mes Actual',0),(102671,2852,'de','Bis zum aktuellen Monat anzeigen',0),(102672,2852,'en','Show by Current Month',0),(102673,2853,'is','',0),(102674,2853,'dr','Ù†Ù…Ø§ÙŠØ´ Ø·Ø¨Ù‚ Ø³Ù‡ Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(102675,2853,'pr','Ù†Ù…Ø§ÙŠØ´ Ø·Ø¨Ù‚ Ø³Ù‡ Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(102676,2853,'tr','GeÃ§erli Ã¼Ã§ aylÄ±k dÃ¶nemlere gÃ¶re gÃ¶ster:',0),(102677,2853,'pl','PokaÅ¼ przez bieÅ¼Ä…cy kwartaÅ‚',0),(102678,2853,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¾Ñ‚ Ñ‚ÐµÐºÑƒÑ‰Ð¾Ñ‚Ð¾ Ñ‚Ñ€Ð¸Ð¼ÐµÑÐµÑ‡Ð¸Ðµ',0),(102679,2853,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø­Ø§Ù„ÛŒÛ Ø³Û Ù…Ø§ÛÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102680,2853,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾ Ð¾Ð²Ð¾Ð¼ ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ñƒ',0),(102681,2853,'vi','Hiá»ƒn thá»‹ theo quÃ½ hiá»‡n thá»i',0),(102682,2853,'af','Wys per Huidige Kwartaal ',0),(102683,2853,'ro','AratÄƒ de trimestru curent',0),(102684,2853,'et','Saate kuvada praeguse kvartali',0),(102685,2853,'si','Pokazati trenutni Äetrtino',0),(102686,2853,'ba','Tampilkan sekarang kuartal',0),(102687,2853,'nl','Tonen door het huidige kwartaal',0),(102688,2853,'fi','NÃ¤ytÃ¤ nykyisen neljÃ¤nneksen',0),(102689,2853,'no','Vis gjeldende kvartal',0),(102690,2853,'da','Vis af indevÃ¦rende kvartal',0),(102691,2853,'ko','í˜„ìž¬ ë¶„ê¸°ë³„ë¡œ í‘œì‹œ',0),(102692,2853,'he','×”×¦×’ ×œ×¤×™ ×‘×¨×‘×¢×•×Ÿ ×”× ×•×›×—×™',0),(102693,2853,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î±Ï€ÏŒ Ï„Î¿ Ï„ÏÎ­Ï‡Î¿Î½ Ï„ÏÎ¯Î¼Î·Î½Î¿',0),(102694,2853,'zh','æ˜¾ç¤ºäº†å½“å‰å­£åº¦\r\n',0),(102695,2853,'sv','Visa aktuella kvartalsvis',0),(102696,2853,'it','Visualizza trimestre corrente',0),(102697,2853,'tl','',0),(102698,2853,'th','&#3649;&#3626;&#3604;&#3591;&#3650;&#3604;&#3618;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(102699,2853,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¤à¤¿à¤®à¤¾à¤¹à¥€ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102700,2853,'ms','Menunjukkan suku semasa',0),(102701,2853,'ar','ÙˆØªØ¨ÙŠÙ† Ø®Ù„Ø§Ù„ Ø§Ù„Ø±Ø¨Ø¹ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(102702,2853,'fr','Afficher par trimestre en cours',0),(102703,2853,'jp','ç?¾åœ¨ã?®å››å?ŠæœŸã?§è¡¨ç¤º',0),(102704,2853,'pt','Mostrar por trimestre atual',0),(102705,2853,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ð¾ Ð¢ÐµÐºÑƒÑ‰ÐµÐ¼Ñƒ ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»Ñƒ',0),(102706,2853,'es','Mostrar por Trimestre Actual',0),(102707,2853,'de','Durch laufende Quartal zeigen',0),(102708,2853,'en','Show by Current Quarter',0),(102709,2854,'is','',0),(102710,2854,'dr','Ù†Ù…Ø§ÙŠØ´ ØªÙÙƒÙŠÙƒ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(102711,2854,'pr','Ù†Ù…Ø§ÙŠØ´ ØªÙÙƒÙŠÙƒ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(102712,2854,'tr','Costcenter arÄ±za show',0),(102713,2854,'pl','PokaÅ¼ funkcja rozkÅ‚adu',0),(102714,2854,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Costcenter Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(102715,2854,'ur','Ú©ÙˆØ³Ù¹Ú©Ø§Ù†Ù¹ÛŒØ± Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102716,2854,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¦Ð¾ÑÑ‚Ñ†ÐµÐ½Ñ‚ÐµÑ€ ÑÐ»Ð¾Ð¼',0),(102717,2854,'vi','Hiá»ƒn thá»‹ chi tiáº¿t cost center',0),(102718,2854,'af','Wys Kostessentrum Verdeling',0),(102719,2854,'ro','AratÄƒ Costcenter defalcare',0),(102720,2854,'et','NÃ¤ita Costcenter jaotus',0),(102721,2854,'si','PrikaÅ¾i Costcenter razÄlenitev',0),(102722,2854,'ba','Tampilkan Costcenter rincian',0),(102723,2854,'nl','Toon Costcenter verdeling',0),(102724,2854,'fi','NÃ¤ytÃ¤ Costcenter erittely',0),(102725,2854,'no','Vis Costcenter sammenbrudd',0),(102726,2854,'da','Vis Costcenter opdeling',0),(102727,2854,'ko','Costcenter ì‹ ê²½ ì‡  ì•½ ì¦ì„¸ë¥¼ ë³´ì—¬',0),(102728,2854,'he','×”×¦×’ ×¤×™×¨×•×˜ Costcenter',0),(102729,2854,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Costcenter ÎºÎ±Ï„Î±Î½Î¿Î¼Î®',0),(102730,2854,'zh','æˆæœ¬ä¸­å¿ƒçš„åˆ†é¡¹æ•°å­—æ˜¾ç¤º\r\n',0),(102731,2854,'sv','Visa Costcenter fÃ¶rdelning',0),(102732,2854,'it','Visualizza centro ripartizione',0),(102733,2854,'tl','',0),(102734,2854,'th','&#3649;&#3626;&#3604;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3648;&#3610;&#3619;&#3588;&#3604;&#3634;&#3623;&#3609;&#3660;',0),(102735,2854,'hi','Costcenter à¤Ÿà¥‚à¤Ÿà¤¨à¥‡ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102736,2854,'ms','Menunjukkan pecahan Costcenter',0),(102737,2854,'ar','Ø¥Ø¸Ù‡Ø§Ø± ØªÙØ§ØµÙŠÙ„ ÙƒÙˆØ³ØªØ³ÙŠÙ†ØªÙŠØ±',0),(102738,2854,'fr','Voir la Costcenter ventilation',0),(102739,2854,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼å†…è¨³ã?®è¡¨ç¤º',0),(102740,2854,'pt','Mostrar Costcenter avaria',0),(102741,2854,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Costcenter Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(102742,2854,'es','Mostrar Detalle de Centro de Costos',0),(102743,2854,'de','Karte Costcenter AufschlÃ¼sselung',0),(102744,2854,'en','Show Costcenter Breakdown',0),(102745,2855,'is','',0),(102746,2855,'dr','Ù†Ù…Ø§ÙŠØ´ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(102747,2855,'pr','Ù†Ù…Ø§ÙŠØ´ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(102748,2855,'tr','Ãœcretleri gÃ¶ster',0),(102749,2855,'pl','PokaÅ¼ koszty',0),(102750,2855,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(102751,2855,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102752,2855,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(102753,2855,'vi','Hiá»ƒn thá»‹ giÃ¡ thÃ nh',0),(102754,2855,'af','Wys Kostes',0),(102755,2855,'ro','AratÄƒ costurile',0),(102756,2855,'et','Kuva kulud',0),(102757,2855,'si','Razstava stroÅ¡ke',0),(102758,2855,'ba','Biaya Tampilkan',0),(102759,2855,'nl','Bekijk Kosten',0),(102760,2855,'fi','NÃ¤ytÃ¤ kustannukset',0),(102761,2855,'no','Vis kostnader',0),(102762,2855,'da','Vis omkostninger',0),(102763,2855,'ko','ë¹„ìš© ë³´ê¸°',0),(102764,2855,'he','×”×¦×’ ×¢×œ×•×™×•×ª',0),(102765,2855,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(102766,2855,'zh','æ˜¾ç¤ºæˆæœ¬\r\n',0),(102767,2855,'sv','Visa kostnader',0),(102768,2855,'it','Visualizza costi',0),(102769,2855,'tl','',0),(102770,2855,'th','&#3649;&#3626;&#3604;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(102771,2855,'hi','à¤²à¤¾à¤—à¤¤ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102772,2855,'ms','Menunjukkan kos',0),(102773,2855,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(102774,2855,'fr','Voir l\'Ã©tablissement des coÃ»ts',0),(102775,2855,'jp','è²»ç”¨ã?®è¡¨ç¤º',0),(102776,2855,'pt','Mostrar os custos',0),(102777,2855,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(102778,2855,'es','Mostrar Costos',0),(102779,2855,'de','Kosten',0),(102780,2855,'en','Show Costs',0),(102781,2856,'is','',0),(102782,2856,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¬Ø§Ø±ÙŠ',0),(102783,2856,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¬Ø§Ø±ÙŠ',0),(102784,2856,'tr','GeÃ§erli gÃ¶stermek',0),(102785,2856,'pl','WyÅ›wietlanie bieÅ¼Ä…cego',0),(102786,2856,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð°',0),(102787,2856,'ur','Ø­Ø§Ù„ÛŒÛ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102788,2856,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ñƒ',0),(102789,2856,'vi','Hiá»ƒn thá»‹ hiá»‡n táº¡i',0),(102790,2856,'af','Wys Huidige',0),(102791,2856,'ro','AratÄƒ curent',0),(102792,2856,'et','Kuva praegune',0),(102793,2856,'si','Prikazati trenutni',0),(102794,2856,'ba','Menunjukkan saat ini',0),(102795,2856,'nl','Toon huidige',0),(102796,2856,'fi','NÃ¤ytÃ¤ nykyinen',0),(102797,2856,'no','Vis gjeldende',0),(102798,2856,'da','Vis nuvÃ¦rende',0),(102799,2856,'ko','í˜„ìž¬ ë³´ê¸°',0),(102800,2856,'he','×”×¦×’ ×”× ×•×›×—×™',0),(102801,2856,'el','Î”ÎµÎ¯Ï‡Î½Î¿Ï…Î½ Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ±',0),(102802,2856,'zh','æ˜¾ç¤ºå½“å‰\r\n',0),(102803,2856,'sv','Visa aktuella',0),(102804,2856,'it','Visualizza attuale',0),(102805,2856,'tl','',0),(102806,2856,'th','&#3649;&#3626;&#3604;&#3591;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(102807,2856,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102808,2856,'ms','Menunjukkan semasa',0),(102809,2856,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(102810,2856,'fr','Voir l\'Ã©tablissement actuel',0),(102811,2856,'jp','ç?¾çŠ¶ã?®è¡¨ç¤º',0),(102812,2856,'pt','Visualizar atual',0),(102813,2856,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¢ÐµÐºÑƒÑ‰ÐµÐµ',0),(102814,2856,'es','Mostrar Actual',0),(102815,2856,'de','Das Umlauf-',0),(102816,2856,'en','Show Current',0),(102817,2857,'is','',0),(102818,2857,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(102819,2857,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(102820,2857,'tr','GeÃ§erli ayÄ± gÃ¶ster',0),(102821,2857,'pl','PokaÅ¼ bieÅ¼Ä…cy miesiÄ…c',0),(102822,2857,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐºÑƒÑ‰Ð¸Ñ Ð¼ÐµÑÐµÑ†',0),(102823,2857,'ur','Ø±ÙˆØ§Úº Ù…Ø§Û Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102824,2857,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ð¼ÐµÑÐµÑ†',0),(102825,2857,'vi','Hiá»ƒn thá»‹ thÃ¡ng hiá»‡n táº¡i',0),(102826,2857,'af','Wys Huidige Maand',0),(102827,2857,'ro','AratÄƒ luna curentÄƒ',0),(102828,2857,'et','Kuva praeguse kuu',0),(102829,2857,'si','Prikazati trenutni mesec',0),(102830,2857,'ba','Menunjukkan bulan ini',0),(102831,2857,'nl','Toon huidige maand',0),(102832,2857,'fi','NÃ¤ytÃ¤ nykyinen kuukausi',0),(102833,2857,'no','Vis gjeldende mÃ¥ned',0),(102834,2857,'da','Vis nuvÃ¦rende mÃ¥ned',0),(102835,2857,'ko','í˜„ìž¬ ì›”ì„ í‘œì‹œ',0),(102836,2857,'he','×”×¦×’ ××ª ×”×—×•×“×© ×”× ×•×›×—×™',0),(102837,2857,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„ÏÎ­Ï‡Î¿Î½Ï„Î± Î¼Î®Î½Î±',0),(102838,2857,'zh','æ˜¾ç¤ºå½“å‰æœˆä»½\r\n',0),(102839,2857,'sv','Visa aktuell mÃ¥nad',0),(102840,2857,'it','Visualizza il mese corrente',0),(102841,2857,'tl','',0),(102842,2857,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3604;&#3639;&#3629;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(102843,2857,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¤¹à¥€à¤¨à¥‡ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102844,2857,'ms','Menunjukkan bulan semasa',0),(102845,2857,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø´Ù‡Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(102846,2857,'fr','Afficher le mois en cours',0),(102847,2857,'jp','ä»Šæœˆã?®è¡¨ç¤º',0),(102848,2857,'pt','Visualizar mÃªs atual',0),(102849,2857,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ ÐœÐµÑÑÑ†',0),(102850,2857,'es','Mostrar Mes Actual',0),(102851,2857,'de','Aktuellen Monat anzeigen',0),(102852,2857,'en','Show Current Month',0),(102853,2858,'is','',0),(102854,2858,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(102855,2858,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(102856,2858,'tr','AyrÄ±ntÄ±larÄ± gÃ¶ster',0),(102857,2858,'pl','PokaÅ¼ szczegÃ³Å‚y',0),(102858,2858,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(102859,2858,'ur','ØªÙØ§ØµÛŒÙ„ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102860,2858,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(102861,2858,'vi','Hiá»ƒn thá»‹ chi tiáº¿t',0),(102862,2858,'af','Wys Details',0),(102863,2858,'ro','AfiÈ™are detalii',0),(102864,2858,'et','Kuva Ã¼ksikasjad',0),(102865,2858,'si','PokaÅ¾i podrobnosti',0),(102866,2858,'ba','Menampilkan rincian',0),(102867,2858,'nl','Details weergeven',0),(102868,2858,'fi','NÃ¤ytÃ¤ tiedot',0),(102869,2858,'no','Vis detaljer',0),(102870,2858,'da','Vis detaljer',0),(102871,2858,'ko','ì„¸ë¶€ ì •ë³´ ë³´ê¸°',0),(102872,2858,'he','×”×¦×’ ×¤×¨×˜×™×',0),(102873,2858,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½',0),(102874,2858,'zh','æ˜¾ç¤ºè¯¦ç»†ä¿¡æ¯\r\n',0),(102875,2858,'sv','Visa Detaljer',0),(102876,2858,'it','Visualizza dettagli',0),(102877,2858,'tl','',0),(102878,2858,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(102879,2858,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102880,2858,'ms','Menunjukkan butir-butir',0),(102881,2858,'ar','Ø£Ø¸Ù‡Ø± Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(102882,2858,'fr','Afficher les caractÃ¨res invisibles',0),(102883,2858,'jp','è©³ç´°ã‚’è¡¨ç¤º',0),(102884,2858,'pt','Mostrar detalhes',0),(102885,2858,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð”ÐµÑ‚Ð°Ð»Ð¸',0),(102886,2858,'es','Mostrar Detalles',0),(102887,2858,'de','Details anzeigen',0),(102888,2858,'en','Show Details',0),(102889,2859,'is','',0),(102890,2859,'dr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø· Ø§ÙˆÙ„',0),(102891,2859,'pr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø· Ø§ÙˆÙ„',0),(102892,2859,'tr','Ä°lk satÄ±rÄ± gÃ¶ster',0),(102893,2859,'pl','PokaÅ¼ pierwszy wiersz',0),(102894,2859,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿ÑŠÑ€Ð²Ð¸Ñ Ñ€ÐµÐ´',0),(102895,2859,'ur','Ù¾ÛÙ„ÛŒ Ù„Ø§Ø¦Ù† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102896,2859,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð¿Ñ€Ð²Ð¾Ð³ Ñ€ÐµÐ´Ð°',0),(102897,2859,'vi','Hiá»ƒn thá»‹ dÃ²ng thá»© nháº¥t',0),(102898,2859,'af','Wys Eerste Lyn',0),(102899,2859,'ro','AratÄƒ prima linie',0),(102900,2859,'et','Kuva esimene rida',0),(102901,2859,'si','PokaÅ¾i prvo vrstico',0),(102902,2859,'ba','Baris pertama Tampilkan',0),(102903,2859,'nl','Eerste regel weergeven',0),(102904,2859,'fi','NÃ¤ytÃ¤ ensimmÃ¤inen rivi',0),(102905,2859,'no','Vis fÃ¸rste linje',0),(102906,2859,'da','Vis fÃ¸rste linje',0),(102907,2859,'ko','ì²« ë²ˆì§¸ ë¼ì¸ í‘œì‹œ',0),(102908,2859,'he','×”×¦×’ ×©×•×¨×” ×¨××©×•× ×”',0),(102909,2859,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€ÏÏŽÏ„Î·Ï‚ Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(102910,2859,'zh','æ˜¾ç¤ºç¬¬ä¸€è¡Œ\r\n',0),(102911,2859,'sv','Visa fÃ¶rsta raden',0),(102912,2859,'it','Visualizza la prima riga',0),(102913,2859,'tl','',0),(102914,2859,'th','&#3649;&#3626;&#3604;&#3591;&#3607;&#3637;&#3656;&#3626;&#3635;&#3588;&#3633;&#3597;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;',0),(102915,2859,'hi','à¤ªà¤¹à¤²à¥€ à¤°à¥‡à¤–à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102916,2859,'ms','Baris pertama menunjukkan',0),(102917,2859,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø³Ø·Ø± Ø§Ù„Ø£ÙˆÙ„',0),(102918,2859,'fr','Voir la premiÃ¨re ligne',0),(102919,2859,'jp','ä¸€è¡Œç›®ã?®è¡¨ç¤º',0),(102920,2859,'pt','Show de primeira linha',0),(102921,2859,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐŸÐµÑ€Ð²ÑƒÑŽ Ð¡Ñ‚Ñ€Ð¾ÐºÑƒ',0),(102922,2859,'es','Mostrar Primera Linea',0),(102923,2859,'de','Erste Zeile anzeigen',0),(102924,2859,'en','Show First Line',0),(102925,2860,'is','',0),(102926,2860,'dr','Ù†Ù…Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(102927,2860,'pr','Ù†Ù…Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(102928,2860,'tr','Faturalar gÃ¶ster',0),(102929,2860,'pl','PokaÅ¼ faktury',0),(102930,2860,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(102931,2860,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102932,2860,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(102933,2860,'vi','Hiá»ƒn thá»‹ hÃ³a Ä‘Æ¡n',0),(102934,2860,'af','Wys Fakture',0),(102935,2860,'ro','AratÄƒ facturi',0),(102936,2860,'et','NÃ¤ita arveid',0),(102937,2860,'si','Show raÄuni',0),(102938,2860,'ba','Faktur Tampilkan',0),(102939,2860,'nl','Facturen weergeven',0),(102940,2860,'fi','NÃ¤ytÃ¤ laskut',0),(102941,2860,'no','Vis fakturaer',0),(102942,2860,'da','Vis fakturaer',0),(102943,2860,'ko','ì²­êµ¬ì„œë¥¼ í‘œì‹œ',0),(102944,2860,'he','×”×¦×’ ×—×©×‘×•× ×™×•×ª',0),(102945,2860,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(102946,2860,'zh','æ˜¾ç¤ºå‘ç¥¨\r\n',0),(102947,2860,'sv','Visa fakturor',0),(102948,2860,'it','Visualizza fatture',0),(102949,2860,'tl','',0),(102950,2860,'th','&#3649;&#3626;&#3604;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(102951,2860,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¶à¥‹',0),(102952,2860,'ms','Menunjukkan invois',0),(102953,2860,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(102954,2860,'fr','Voir l\'Ã©tablissement de factures',0),(102955,2860,'jp','è«‹æ±‚æ›¸ã?®è¡¨ç¤º',0),(102956,2860,'pt','Visualizar faturas',0),(102957,2860,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚Ð°',0),(102958,2860,'es','Mostrar Facturas',0),(102959,2860,'de','Rechnungen anzeigen',0),(102960,2860,'en','Show Invoices',0),(102961,2861,'is','',0),(102962,2861,'dr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª',0),(102963,2861,'pr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª',0),(102964,2861,'tr','Listeyi gÃ¶ster',0),(102965,2861,'pl','PokaÅ¼ listÄ™',0),(102966,2861,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ¿Ð¸ÑÑŠÐºÐ°',0),(102967,2861,'ur','ÙÛØ±Ø³Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(102968,2861,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð»Ð¸ÑÑ‚Ñƒ',0),(102969,2861,'vi','Hiá»ƒn thá»‹ danh sÃ¡ch',0),(102970,2861,'af','Wys Lys',0),(102971,2861,'ro','AratÄƒ Lista',0),(102972,2861,'et','Kuva loend',0),(102973,2861,'si','PrikaÅ¾i seznam',0),(102974,2861,'ba','Tunjukan daftar',0),(102975,2861,'nl','Lijst weergeven',0),(102976,2861,'fi','NÃ¤ytÃ¤ luettelo',0),(102977,2861,'no','Vis-listen',0),(102978,2861,'da','Vis liste',0),(102979,2861,'ko','í‘œì‹œ ëª©ë¡',0),(102980,2861,'he','×”×¦×’ ×¨×©×™×ž×”',0),(102981,2861,'el','Î›Î¯ÏƒÏ„Î± \"Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·\"',0),(102982,2861,'zh','æ˜¾ç¤ºåˆ—è¡¨\r\n',0),(102983,2861,'sv','Visa lista',0),(102984,2861,'it','Visualizza elenco',0),(102985,2861,'tl','',0),(102986,2861,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(102987,2861,'hi','à¤¸à¥‚à¤šà¥€ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(102988,2861,'ms','Tunjukkan senarai',0),(102989,2861,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù‚Ø§Ø¦Ù…Ø©',0),(102990,2861,'fr','Voir la liste',0),(102991,2861,'jp','ãƒªã‚¹ãƒˆã‚’è¡¨ç¤º',0),(102992,2861,'pt','Visualizar lista',0),(102993,2861,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¡Ð¿Ð¸ÑÐ¾Ðº',0),(102994,2861,'es','Mostrar Lista',0),(102995,2861,'de','Liste anzeigen',0),(102996,2861,'en','Show List',0),(102997,2862,'is','',0),(102998,2862,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ÙˆÙ‚ØªÙŠ ÙƒÙ‡ ',0),(102999,2862,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ÙˆÙ‚ØªÙŠ ÙƒÙ‡ ',0),(103000,2862,'tr','GÃ¶stermek Ã¼stÃ¼nde ne zaman alÄ±ntÄ±',0),(103001,2862,'pl','PokaÅ¼ na cytat gdy',0),(103002,2862,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° ÐºÐ¾Ð³Ð°Ñ‚Ð¾',0),(103003,2862,'ur','Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº Ù¾Ø± Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Ø¨',0),(103004,2862,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð° Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ñ‚Ð¸ ÐºÐ°Ð´',0),(103005,2862,'vi','Chá»‰ Hiá»ƒn thá»‹ bÃ¡o giÃ¡ khi',0),(103006,2862,'af','Wys op kwotasie wanneer',0),(103007,2862,'ro','AratÄƒ pe citat atunci cÃ¢nd',0),(103008,2862,'et','Kuva tsiteerida, kui',0),(103009,2862,'si','KaÅ¾ejo na ponudba pri',0),(103010,2862,'ba','Tampilkan di mengutip ketika',0),(103011,2862,'nl','Toon op citeer wanneer',0),(103012,2862,'fi','NÃ¤ytÃ¤ hotelli edelleen lainata kun',0),(103013,2862,'no','Vis pÃ¥ tilbud nÃ¥r',0),(103014,2862,'da','Vis pÃ¥ citerer nÃ¥r',0),(103015,2862,'ko','ì‡¼ì— ì–¸ì œ ì¸ìš©',0),(103016,2862,'he','×œ×”×¨××•×ª ×¢×œ ×¦×™×˜×•×˜ ×ž×ª×™',0),(103017,2862,'el','Î”ÎµÎ¯Î¾ÎµÎ¹ Î½Î± Ï€Î±ÏÎ±Î¸Î­ÏƒÏ‰ Î±Ï€ÏŒ ÏŒÏ„Î±Î½',0),(103018,2862,'zh','æ˜¾ç¤ºæŠ¥ä»·å½“\r\n',0),(103019,2862,'sv','Visa Ã¥ citera nÃ¤r',0),(103020,2862,'it','Mostrare a citare quando',0),(103021,2862,'tl','',0),(103022,2862,'th','&#3649;&#3626;&#3604;&#3591;&#3610;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3648;&#3617;&#3639;&#3656;&#3629;',0),(103023,2862,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤ à¤ªà¤° à¤•à¤¬ à¤¬à¥‹à¤²à¥€',0),(103024,2862,'ms','Tunjukkan pada quote apabila',0),(103025,2862,'ar','ÙˆØªØ¸Ù‡Ø± Ø¹Ù„Ù‰ Ø­Ø¯ ØªØ¹Ø¨ÙŠØ± Ø¹Ù†Ø¯Ù…Ø§',0),(103026,2862,'fr','Voir la suite cite quand',0),(103027,2862,'jp','ï½žã?®æ™‚ã?«è¦‹ç©?ã‚Šã?«è¡¨ç¤º',0),(103028,2862,'pt','Mostrar por citar quando',0),(103029,2862,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð¾Ð¹ ÐºÐ¾Ð³Ð´Ð°',0),(103030,2862,'es','Mostrar en cotizaciÃ³n cuando',0),(103031,2862,'de','Zeigen auf zitieren wenn',0),(103032,2862,'en','Show on quote when',0),(103033,2863,'is','',0),(103034,2863,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ù†Ù‚Ø¯ÙŠÙ†Ú¯ÙŠ',0),(103035,2863,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ù†Ù‚Ø¯ÙŠÙ†Ú¯ÙŠ',0),(103036,2863,'tr','Sadece para Ã¶dÃ¼lÃ¼ gÃ¶ster',0),(103037,2863,'pl','PokaÅ¼ tylko zrealizowane',0),(103038,2863,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¾ÑÑ€ÐµÐ±Ñ€ÑÑ‚',0),(103039,2863,'ur','ØµØ±Ù Ø¨Ø¸Ø§ÛØ±Ø§Ù† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(103040,2863,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÑƒÐ½Ð¾Ð²Ñ‡Ð¸Ð¾',0),(103041,2863,'vi','Chá»‰ Hiá»ƒn thá»‹ Ä‘Ã£ Ä‘á»•i tiá»n máº·t',0),(103042,2863,'af','Wys slegs gewisseldes',0),(103043,2863,'ro','AratÄƒ numai incasate',0),(103044,2863,'et','NÃ¤ita ainult sularahaks',0),(103045,2863,'si','PrikaÅ¾i samo unovÄiti',0),(103046,2863,'ba','Tampilkan hanya menguangkan',0),(103047,2863,'nl','Toon alleen geÃ¯ncasseerd',0),(103048,2863,'fi','NÃ¤ytÃ¤ vain lunastettu',0),(103049,2863,'no','Vis bare heves',0),(103050,2863,'da','Vis kun indlÃ¸ses',0),(103051,2863,'ko','í‘œì‹œë§Œ í˜„ê¸ˆìœ¼ë¡œ',0),(103052,2863,'he','×”×¦×’ ×¨×§ ×¤×“×”',0),(103053,2863,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ ÎµÎ¾Î±ÏÎ³Ï…ÏÏŽÏƒÎµÎ¹',0),(103054,2863,'zh','åªæ˜¾ç¤ºå…‘çŽ°\r\n',0),(103055,2863,'sv','Visa endast inkasserades',0),(103056,2863,'it','Visualizza solo incassato',0),(103057,2863,'tl','',0),(103058,2863,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(103059,2863,'hi','à¤¶à¥‹ à¤¹à¥€ à¤­à¥à¤¨à¤¾à¤¯à¤¾',0),(103060,2863,'ms','Papar hanya ditunaikan',0),(103061,2863,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙÙ‚Ø· ØµØ±ÙØ©',0),(103062,2863,'fr','Spectacle seulement encaissÃ©',0),(103063,2863,'jp','æ?›é‡‘æ¸ˆã?®ã?¿è¡¨ç¤º',0),(103064,2863,'pt','Mostrar apenas descontado',0),(103065,2863,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ðµ',0),(103066,2863,'es','Mostrar solo cambiados',0),(103067,2863,'de','Karte nur eingelÃ¶st',0),(103068,2863,'en','Show only cashed',0),(103069,2864,'is','',0),(103070,2864,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ù†Ù‚Ø¯ Ù†Ø´Ø¯Ù‡ ',0),(103071,2864,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ù†Ù‚Ø¯ Ù†Ø´Ø¯Ù‡ ',0),(103072,2864,'tr','Sadece paraya gÃ¶sterisi',0),(103073,2864,'pl','PokaÅ¼ tylko nie zrealizowane',0),(103074,2864,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð·Ð° Ñ‚ÐµÐ³Ð»ÐµÐ½Ð¸',0),(103075,2864,'ur','ØµØ±Ù ØºÛŒØ± Ø¨Ø¸Ø§ÛØ±Ø§Ù† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(103076,2864,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÐºÐ¾Ñ˜Ð¸ Ð½Ð¸Ñ˜Ðµ ÑƒÐ½Ð¾Ð²Ñ‡Ð¸Ð¾',0),(103077,2864,'vi','Chá»‰ Hiá»ƒn thá»‹ chÆ°a Ä‘á»•i tiá»n máº·t',0),(103078,2864,'af','Wys slegs nie-gewisseldes',0),(103079,2864,'ro','AratÄƒ numai non-incasate',0),(103080,2864,'et','NÃ¤ita ainult-sularahaks',0),(103081,2864,'si','PokaÅ¾i samo non unovÄiti',0),(103082,2864,'ba','Tampilkan hanya menguangkan bebas',0),(103083,2864,'nl','Toon alleen niet-geÃ¯ncasseerd',0),(103084,2864,'fi','NÃ¤ytÃ¤ vain ei lunastettu',0),(103085,2864,'no','Vis bare ikke innlÃ¸ses',0),(103086,2864,'da','Vis kun ikke-indlÃ¸st',0),(103087,2864,'ko','ë¹„ í˜„ê¸ˆë§Œ í‘œì‹œ',0),(103088,2864,'he','×”×¦×’ ×¨×§ ×©××™× ×• × ×¤×“×”',0),(103089,2864,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ Î¼Î·-ÎµÎ¾Î±ÏÎ³Ï…ÏÏŽÏƒÎµÎ¹',0),(103090,2864,'zh','ä»…æ˜¾ç¤ºéžå…‘çŽ°\r\n',0),(103091,2864,'sv','Visa endast icke-inkasserades',0),(103092,2864,'it','Visualizza solo non incassato',0),(103093,2864,'tl','',0),(103094,2864,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(103095,2864,'hi','à¤•à¥‡à¤µà¤² à¤—à¥ˆà¤°-à¤­à¥à¤¨à¤¾à¤¯à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(103096,2864,'ms','Menunjukkan hanya bebas ditunaikan',0),(103097,2864,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙÙ‚Ø· ØºÙŠØ± ØµØ±ÙØ©',0),(103098,2864,'fr','N\'afficher que non encaissÃ©',0),(103099,2864,'jp','æœªæ?›é‡‘ã?®ã?¿è¡¨ç¤º',0),(103100,2864,'pt','Mostrar somente nÃ£o-creditadas',0),(103101,2864,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð±ÐµÐ·Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ðµ',0),(103102,2864,'es','Mostrar solo no-cambiados',0),(103103,2864,'de','Karte nur nicht eingelÃ¶st',0),(103104,2864,'en','Show only non-cashed',0),(103105,2865,'is','',0),(103106,2865,'dr','Ù†Ù…Ø§ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± Ø·ÙŠ Ø¢Ø®Ø±ÙŠÙ† â€“ ØªØ¹Ø¯Ø§ Ø±ÙˆØ²Ù‡Ø§ Ù¾ÙŠØ´ Ø§Ø² Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(103107,2865,'pr','Ù†Ù…Ø§ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± Ø·ÙŠ Ø¢Ø®Ø±ÙŠÙ† â€“ ØªØ¹Ø¯Ø§ Ø±ÙˆØ²Ù‡Ø§ Ù¾ÙŠØ´ Ø§Ø² Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(103108,2865,'tr','GÃ¼n Ã¶ncesinde Ã¶demeleri dahil',0),(103109,2865,'pl','Liczba dni przed obejmujÄ… pÅ‚atnoÅ›ci',0),(103110,2865,'bg','Ð‘Ñ€Ð¾Ð¹ Ð½Ð° Ð´Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(103111,2865,'ur','Ø³Û’ Ù¾ÛÙ„Û’ Ú©Û’ Ø¯Ù†ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”',0),(103112,2865,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð´Ð°Ð½Ð° Ð¿Ñ€Ðµ ÑƒÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(103113,2865,'vi','Sá»‘ ngÃ y trÆ°á»›c trong thanh toÃ¡n',0),(103114,2865,'af','Aantal Dae om In te Sluit voor Betalings',0),(103115,2865,'ro','NumÄƒrul de zile Ã®nainte de a Include plÄƒÅ£i',0),(103116,2865,'et','PÃ¤evi enne sisaldavad maksed',0),(103117,2865,'si','Å tevilo dni pred vkljuÄujejo plaÄila',0),(103118,2865,'ba','Jumlah hari sebelum memasukkan pembayaran',0),(103119,2865,'nl','Aantal dagen voorafgaand aan betalingen omvatten',0),(103120,2865,'fi','PÃ¤ivinÃ¤ ennen sisÃ¤llyttÃ¤Ã¤ maksut',0),(103121,2865,'no','Antall dager fÃ¸r inkludere betalinger',0),(103122,2865,'da','Antal dage fÃ¸r inkludere betalinger',0),(103123,2865,'ko','ì´ì „ì— ì¼ ìˆ˜ ìˆ˜ë‹¹ í¬í•¨',0),(103124,2865,'he','×ž×¡×¤×¨ ×”×™×ž×™× ×œ×¤× ×™ ×›×•×œ×œ×™× ×ª×©×œ×•×ž×™×',0),(103125,2865,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î·Î¼ÎµÏÏŽÎ½ Ï€ÏÎ¹Î½ Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(103126,2865,'zh','åœ¨æ­¤ä¹‹å‰çš„å¤©æ•°åŒ…æ‹¬ä»˜æ¬¾\r\n',0),(103127,2865,'sv','Antal dagar fÃ¶re innefattar betalningar',0),(103128,2865,'it','Numero di giorni prima di includere i pagamenti',0),(103129,2865,'tl','',0),(103130,2865,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3586;&#3629;&#3591;&#3623;&#3633;&#3609;&#3585;&#3656;&#3629;&#3609;&#3648;&#3614;&#3639;&#3656;&#3629;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(103131,2865,'hi','à¤ªà¤¹à¤²à¥‡ à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(103132,2865,'ms','Bilangan hari sebelum termasuk bayaran',0),(103133,2865,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø£ÙŠØ§Ù… Ù‚Ø¨Ù„ Ø£Ù† ØªØ´Ù…Ù„ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(103134,2865,'fr','Nombre de jours avant d\'inclure les paiements',0),(103135,2865,'jp','æ”¯æ‰•ã‚’å?«ã‚€å‰?ã?®æ—¥æ•°',0),(103136,2865,'pt','NÃºmero de dias antes de incluir pagamentos',0),(103137,2865,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð½ÐµÐ¹ Ð´Ð¾ Ð²ÐºÐ»ÑŽÑ‡Ð°ÑŽÑ‚ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(103138,2865,'es','NÃºmero de DÃ­as Antes para Incluir Pagos',0),(103139,2865,'de','Anzahl der Tage vor dem gehÃ¶ren Zahlungen',0),(103140,2865,'en','Number of Days Prior to Include Payments',0),(103141,2866,'is','',0),(103142,2866,'dr','(Ù…Ù†ØªØ¸Ø±',0),(103143,2866,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø¹ÙˆÙ‚(Ù…Ù†ØªØ¸Ø±',0),(103144,2866,'tr','Bekleyen gÃ¶ster',0),(103145,2866,'pl','PokaÅ¼ oczekujÄ…ce',0),(103146,2866,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð§Ð°ÐºÐ°Ñ‰Ð¾',0),(103147,2866,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(103148,2866,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(103149,2866,'vi','Chá»‰ Hiá»ƒn thá»‹ Ä‘ang treo',0),(103150,2866,'af','Wys Afwagtend',0),(103151,2866,'ro','AratÄƒ Ã®n aÅŸteptare',0),(103152,2866,'et','Kuva ootel',0),(103153,2866,'si','PokaÅ¾i ÄakajoÄe',0),(103154,2866,'ba','Tampilkan tertunda',0),(103155,2866,'nl','Toon in behandeling',0),(103156,2866,'fi','NÃ¤ytÃ¤ odottavat',0),(103157,2866,'no','Vis ventende',0),(103158,2866,'da','Vis afventende',0),(103159,2866,'ko','ë³´ë¥˜ ì¤‘ì¸ í‘œì‹œ',0),(103160,2866,'he','×”×¦×’ ×ž×ž×ª×™× ×”',0),(103161,2866,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î±',0),(103162,2866,'zh','æ˜¾ç¤ºå¾…å®š\r\n',0),(103163,2866,'sv','Visa vÃ¤ntande',0),(103164,2866,'it','Visualizza in sospeso',0),(103165,2866,'tl','',0),(103166,2866,'th','&#3649;&#3626;&#3604;&#3591;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(103167,2866,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(103168,2866,'ms','Menunjukkan belum selesai',0),(103169,2866,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù…Ø¹Ù„Ù‚Ø©',0),(103170,2866,'fr','Montrer en attente',0),(103171,2866,'jp','ãƒšãƒ³ãƒ‡ã‚£ãƒ³ã‚°ã?®è¡¨ç¤º',0),(103172,2866,'pt','Mostrar pendente',0),(103173,2866,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(103174,2866,'es','Mostrar Pendiente',0),(103175,2866,'de','Ausstehende anzeigen',0),(103176,2866,'en','Show Pending',0),(103177,2867,'is','',0),(103178,2867,'dr','Ù†Ù…Ø§ÙŠØ´ ØªØµØ§ÙˆÙŠØ± ',0),(103179,2867,'pr','Ù†Ù…Ø§ÙŠØ´ ØªØµØ§ÙˆÙŠØ± ',0),(103180,2867,'tr','Resimleri gÃ¶ster',0),(103181,2867,'pl','PokaÅ¼ zdjÄ™cia',0),(103182,2867,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð¹ ÐºÐ°Ñ€Ñ‚Ð¸Ð½Ð¸Ñ‚Ðµ',0),(103183,2867,'ur','ØªØµØ§ÙˆÛŒØ± Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(103184,2867,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ»Ð¸ÐºÐµ',0),(103185,2867,'vi','Hiá»ƒn thá»‹ hÃ¬nh áº£nh',0),(103186,2867,'af','Wys Prente',0),(103187,2867,'ro','AratÄƒ fotografii',0),(103188,2867,'et','Piltide kuvamine',0),(103189,2867,'si','Slike prikazujejo',0),(103190,2867,'ba','Menampilkan gambar',0),(103191,2867,'nl','Afbeeldingen weergeven',0),(103192,2867,'fi','NÃ¤ytÃ¤ kuvat',0),(103193,2867,'no','Vise bilder',0),(103194,2867,'da','Vis billeder',0),(103195,2867,'ko','ì‚¬ì§„ í‘œì‹œ',0),(103196,2867,'he','×”×¦×’ ×ª×ž×•× ×•×ª',0),(103197,2867,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎµÎ¹ÎºÏŒÎ½ÎµÏ‚',0),(103198,2867,'zh','æ˜¾ç¤ºå›¾ç‰‡\r\n',0),(103199,2867,'sv','Visa bilder',0),(103200,2867,'it','Visualizza immagini',0),(103201,2867,'tl','',0),(103202,2867,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3641;&#3611;&#3616;&#3634;&#3614;',0),(103203,2867,'hi','à¤šà¤¿à¤¤à¥à¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(103204,2867,'ms','Menunjukkan gambar',0),(103205,2867,'ar','Ø¹Ø±Ø¶ Ø§Ù„ØµÙˆØ±',0),(103206,2867,'fr','Afficher l\'image',0),(103207,2867,'jp','å†™çœŸã‚’è¡¨ç¤º',0),(103208,2867,'pt','Mostrar fotos',0),(103209,2867,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐšÐ°Ñ€Ñ‚Ð¸Ð½ÐºÐ¸',0),(103210,2867,'es','Mostrar Fotos',0),(103211,2867,'de','Bilder anzeigen',0),(103212,2867,'en','Show Pictures',0),(103213,2868,'is','',0),(103214,2868,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ ',0),(103215,2868,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ ',0),(103216,2868,'tr','YalnÄ±zca deftere nakledilen giriÅŸleri gÃ¶ster',0),(103217,2868,'pl','PokaÅ¼ tylko zaksiÄ™gowane zapisy',0),(103218,2868,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÐ°Ð¼Ð¾',0),(103219,2868,'ur','Ø§Ø´ØªÛØ§Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(103220,2868,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ.',0),(103221,2868,'vi','Chá»‰ Hiá»ƒn thá»‹ bÃºt toÃ¡n Ä‘Ã£ káº¿t chuyá»ƒn',0),(103222,2868,'af','Wys Geposde Inskrywings Alleenlik',0),(103223,2868,'ro','AratÄƒ numai intrÄƒrile Ã®nregistrate',0),(103224,2868,'et','NÃ¤ita konteeritud kanded ainult',0),(103225,2868,'si','PokaÅ¾i samo knjiÅ¾ene postavke',0),(103226,2868,'ba','Tampilkan hanya diposting entri',0),(103227,2868,'nl','Toon alleen geboekte posten',0),(103228,2868,'fi','NÃ¤ytÃ¤ vain kirjatut tapahtumat',0),(103229,2868,'no','Vise bokfÃ¸rte poster bare',0),(103230,2868,'da','Vis bogfÃ¸rte poster kun',0),(103231,2868,'ko','ê²Œì‹œ í•­ëª©ì„ í‘œì‹œ',0),(103232,2868,'he','×”×¦×’ ×¤×•×¨×¡× ×¢×¨×›×™× ×‘×œ×‘×“',0),(103233,2868,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î¼ÏŒÎ½Î¿',0),(103234,2868,'zh','ä»…æ˜¾ç¤ºå‘å¸ƒçš„æ¡ç›®\r\n',0),(103235,2868,'sv','Visa bokfÃ¶rda transaktioner endast',0),(103236,2868,'it','Visualizza movimenti registrati solo',0),(103237,2868,'tl','',0),(103238,2868,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(103239,2868,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¹à¥€ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(103240,2868,'ms','Menunjukkan hantar penyertaan sahaja',0),(103241,2868,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù‚ÙŠÙˆØ¯ Ø§Ù„Ù…Ø±Ø­Ù‘Ù„Ø© ÙÙ‚Ø·',0),(103242,2868,'fr','Afficher uniquement des Ã©critures validÃ©es',0),(103243,2868,'jp','è¨ˆä¸Šæ¸ˆã?¿ã?®è¨˜å¸³ã?®ã?¿è¡¨ç¤º',0),(103244,2868,'pt','Mostrar movimentos registados apenas',0),(103245,2868,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ… Ð—Ð°Ð¿Ð¸ÑÐµÐ¹',0),(103246,2868,'es','Mostrar Entradas Asentadas Solamente',0),(103247,2868,'de','Gebuchte Posten nur zeigen',0),(103248,2868,'en','Show Posted Entries Only',0),(103249,2869,'is','',0),(103250,2869,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(103251,2869,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(103252,2869,'tr','YalnÄ±zca deftere nakledilen giriÅŸleri gÃ¶ster',0),(103253,2869,'pl','PokaÅ¼ tylko zaksiÄ™gowane zapisy',0),(103254,2869,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÐ°Ð¼Ð¾',0),(103255,2869,'ur','Ø§Ø´ØªÛØ§Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(103256,2869,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ.',0),(103257,2869,'vi','Chá»‰ Hiá»ƒn thá»‹ bÃºt toÃ¡n Ä‘Ã£ káº¿t chuyá»ƒn',0),(103258,2869,'af','Wys Geposde Inskrywings Alleenlik',0),(103259,2869,'ro','AratÄƒ numai intrÄƒrile Ã®nregistrate',0),(103260,2869,'et','NÃ¤ita konteeritud kanded ainult',0),(103261,2869,'si','PokaÅ¾i samo knjiÅ¾ene postavke',0),(103262,2869,'ba','Tampilkan hanya diposting entri',0),(103263,2869,'nl','Toon alleen geboekte posten',0),(103264,2869,'fi','NÃ¤ytÃ¤ vain kirjatut tapahtumat',0),(103265,2869,'no','Vise bokfÃ¸rte poster bare',0),(103266,2869,'da','Vis bogfÃ¸rte poster kun',0),(103267,2869,'ko','ê²Œì‹œ í•­ëª©ì„ í‘œì‹œ',0),(103268,2869,'he','×”×¦×’ ×¤×•×¨×¡× ×¢×¨×›×™× ×‘×œ×‘×“',0),(103269,2869,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î¼ÏŒÎ½Î¿',0),(103270,2869,'zh','ä»…æ˜¾ç¤ºå‘å¸ƒçš„æ¡ç›®\r\n',0),(103271,2869,'sv','Visa bokfÃ¶rda transaktioner endast',0),(103272,2869,'it','Visualizza movimenti registrati solo',0),(103273,2869,'tl','',0),(103274,2869,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(103275,2869,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¹à¥€ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(103276,2869,'ms','Menunjukkan hantar penyertaan sahaja',0),(103277,2869,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù‚ÙŠÙˆØ¯ Ø§Ù„Ù…Ø±Ø­Ù‘Ù„Ø© ÙÙ‚Ø·',0),(103278,2869,'fr','Afficher uniquement des Ã©critures validÃ©es',0),(103279,2869,'jp','è¨ˆä¸Šæ¸ˆã?¿ã?®è¨˜å¸³ã?®ã?¿ã‚’è¡¨ç¤º',0),(103280,2869,'pt','Mostrar movimentos registados apenas',0),(103281,2869,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ… Ð—Ð°Ð¿Ð¸ÑÐµÐ¹',0),(103282,2869,'es','Mostrar Entradas Asentadas Solamente',0),(103283,2869,'de','Gebuchte Posten nur zeigen',0),(103284,2869,'en','Show Posted Entries Only',0),(103285,2870,'is','',0),(103286,2870,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(103287,2870,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(103288,2870,'tr','HaritayÄ± aldÄ±',0),(103289,2870,'pl','PokaÅ¼ otrzymane',0),(103290,2870,'bg','Ð¨Ð¾ÑƒÑ‚Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°',0),(103291,2870,'ur','Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº Ù…ÙˆØµÙˆÙ„Û',0),(103292,2870,'sr','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð° Ñ˜Ðµ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð°',0),(103293,2870,'vi','Hiá»ƒn thá»‹ Ä‘Ã£ nháº­n',0),(103294,2870,'af','Wys ontvang',0),(103295,2870,'ro','AratÄƒ primite',0),(103296,2870,'et','NÃ¤ita saabunud',0),(103297,2870,'si','PrikaÅ¾i prejel',0),(103298,2870,'ba','Tampilkan yang diterima',0),(103299,2870,'nl','Toon ontvangen',0),(103300,2870,'fi','NÃ¤ytÃ¤ sai',0),(103301,2870,'no','Vis mottatt',0),(103302,2870,'da','Vis modtaget',0),(103303,2870,'ko','ë°›ì€ í‘œì‹œ',0),(103304,2870,'he','×”×¦×’ ×”×ª×§×‘×œ',0),(103305,2870,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î­Î»Î±Î²Îµ',0),(103306,2870,'zh','æ˜¾ç¤ºæŽ¥æ”¶\r\n',0),(103307,2870,'sv','Visa fick',0),(103308,2870,'it','Visualizza ricevuta',0),(103309,2870,'tl','',0),(103310,2870,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;',0),(103311,2870,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¶à¥‹',0),(103312,2870,'ms','Papar yang diterima',0),(103313,2870,'ar','Ø¥Ø¸Ù‡Ø§Ø± ØªÙ„Ù‚ÙŠ',0),(103314,2870,'fr','Spectacle a reÃ§u',0),(103315,2870,'jp','Show Received',0),(103316,2870,'pt','Show recebida',0),(103317,2870,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ð¾Ðµ',0),(103318,2870,'es','Mostrar Recibido',0),(103319,2870,'de','Karte empfangen',0),(103320,2870,'en','Show Received',0),(103321,2871,'is','',0),(103322,2871,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡ ',0),(103323,2871,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡ ',0),(103324,2871,'tr','YalnÄ±zca deftere nakledilmemiÅŸ giriÅŸlerini gÃ¶ster',0),(103325,2871,'pl','PokaÅ¼ tylko niezaksiÄ™gowanych zapisÃ³w',0),(103326,2871,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(103327,2871,'ur','Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(103328,2871,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð½ÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(103329,2871,'vi','Chá»‰ Hiá»ƒn thá»‹ bÃºt toÃ¡n chÆ°a káº¿t chuyá»ƒn',0),(103330,2871,'af','Wys Ongeposde Inskrywings Alleenlik',0),(103331,2871,'ro','AratÄƒ neÃ®nregistratÄƒ Ã®nregistrÄƒrile doar',0),(103332,2871,'et','NÃ¤ita ainult sisestamata kanded',0),(103333,2871,'si','PrikaÅ¾i samo neknjiÅ¾enih navedbe',0),(103334,2871,'ba','Tampilkan hanya Unposted entri',0),(103335,2871,'nl','Alleen niet-doorgevoerde vermeldingen',0),(103336,2871,'fi','NÃ¤ytÃ¤ kirjaamattomat tapahtumat',0),(103337,2871,'no','Vis ikke-bokfÃ¸rte poster bare',0),(103338,2871,'da','Vis ikke-bogfÃ¸rte poster kun',0),(103339,2871,'ko','ê²Œì‹œ ë˜ì§€ ì•Šì€ í•­ëª© í‘œì‹œ',0),(103340,2871,'he','×”×¦×’ ×¢×¨×›×™× ×©×œ× × ×¨×©×ž×• ×¨×§',0),(103341,2871,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼Î· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î¼ÏŒÎ½Î¿',0),(103342,2871,'zh','ä»…æ˜¾ç¤ºæœªå‘å¸ƒçš„ä½œå“\r\n',0),(103343,2871,'sv','Visa bokfÃ¶rda transaktioner endast',0),(103344,2871,'it','Visualizza le voci registrate solo',0),(103345,2871,'tl','',0),(103346,2871,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3585;&#3619;&#3629;&#3585;&#3585;&#3634;&#3619;&#3612;&#3656;&#3',0),(103347,2871,'hi','Unposted à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¹à¥€ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(103348,2871,'ms','Menunjukkan Unposted penyertaan sahaja',0),(103349,2871,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù‚ÙŠÙˆØ¯ Ø§Ù„ØºÙŠØ± Ù…Ø±Ø­Ù‘Ù„Ø© ÙÙ‚Ø·',0),(103350,2871,'fr','Afficher les entrÃ©es non validÃ©es uniquement',0),(103351,2871,'jp','æœªè¨ˆä¸Šè¨˜å¸³ã?®ã?¿è¡¨ç¤º',0),(103352,2871,'pt','Mostrar apenas as entradas de nÃ£o lanÃ§adas',0),(103353,2871,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐÐµÐ¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ… Ð—Ð°Ð¿Ð¸ÑÐµÐ¹',0),(103354,2871,'es','Mostrar Entradas No Asentadas Solamente',0),(103355,2871,'de','Nur ungebuchte EintrÃ¤ge anzeigen',0),(103356,2871,'en','Show Unposted Entries Only',0),(103357,2872,'is','',0),(103358,2872,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡',0),(103359,2872,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡',0),(103360,2872,'tr','YalnÄ±zca deftere nakledilmemiÅŸ giriÅŸlerini gÃ¶ster',0),(103361,2872,'pl','PokaÅ¼ tylko niezaksiÄ™gowanych zapisÃ³w',0),(103362,2872,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(103363,2872,'ur','Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(103364,2872,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð½ÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(103365,2872,'vi','Chá»‰ Hiá»ƒn thá»‹ bÃºt toÃ¡n chÆ°a káº¿t chuyá»ƒn',0),(103366,2872,'af','Wys Ongeposde Inskrywings Alleenlik',0),(103367,2872,'ro','AratÄƒ neÃ®nregistratÄƒ Ã®nregistrÄƒrile doar',0),(103368,2872,'et','NÃ¤ita ainult sisestamata kanded',0),(103369,2872,'si','PrikaÅ¾i samo neknjiÅ¾enih navedbe',0),(103370,2872,'ba','Tampilkan hanya Unposted entri',0),(103371,2872,'nl','Alleen niet-doorgevoerde vermeldingen',0),(103372,2872,'fi','NÃ¤ytÃ¤ kirjaamattomat tapahtumat',0),(103373,2872,'no','Vis ikke-bokfÃ¸rte poster bare',0),(103374,2872,'da','Vis ikke-bogfÃ¸rte poster kun',0),(103375,2872,'ko','ê²Œì‹œ ë˜ì§€ ì•Šì€ í•­ëª© í‘œì‹œ',0),(103376,2872,'he','×”×¦×’ ×¢×¨×›×™× ×©×œ× × ×¨×©×ž×• ×¨×§',0),(103377,2872,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼Î· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î¼ÏŒÎ½Î¿',0),(103378,2872,'zh','ä»…æ˜¾ç¤ºæœªå‘å¸ƒçš„ä½œå“\r\n',0),(103379,2872,'sv','Visa bokfÃ¶rda transaktioner endast',0),(103380,2872,'it','Visualizza le voci registrate solo',0),(103381,2872,'tl','',0),(103382,2872,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3585;&#3619;&#3629;&#3585;&#3585;&#3634;&#3619;&#3612;&#3656;&#3',0),(103383,2872,'hi','Unposted à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¹à¥€ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(103384,2872,'ms','Menunjukkan Unposted penyertaan sahaja',0),(103385,2872,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù‚ÙŠÙˆØ¯ Ø§Ù„ØºÙŠØ± Ù…Ø±Ø­Ù‘Ù„Ø© ÙÙ‚Ø·',0),(103386,2872,'fr','Afficher les entrÃ©es non validÃ©es uniquement',0),(103387,2872,'jp','æœªè¨ˆä¸Šè¨˜å¸³ã?®ã?¿è¡¨ç¤º',0),(103388,2872,'pt','Mostrar apenas as entradas de nÃ£o lanÃ§adas',0),(103389,2872,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐÐµÐ¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ… Ð—Ð°Ð¿Ð¸ÑÐµÐ¹',0),(103390,2872,'es','Mostrar Entradas No Asentadas Solamente',0),(103391,2872,'de','Nur ungebuchte EintrÃ¤ge anzeigen',0),(103392,2872,'en','Show Unposted Entries Only',0),(103393,2873,'is','',0),(103394,2873,'dr','  Ù„ÙŠØ³Øª  Ù†Ù…Ø§ÙŠØ´',0),(103395,2873,'pr','  Ù„ÙŠØ³Øª  Ù†Ù…Ø§ÙŠØ´',0),(103396,2873,'tr','GÃ¶ster',0),(103397,2873,'pl','PokaÅ¼',0),(103398,2873,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸',0),(103399,2873,'ur','Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(103400,2873,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸',0),(103401,2873,'vi','Hiá»ƒn thá»‹',0),(103402,2873,'af','Wys Lysing',0),(103403,2873,'ro','AratÄƒ',0),(103404,2873,'et','NÃ¤ita',0),(103405,2873,'si','PrikaÅ¾i',0),(103406,2873,'ba','Tampilkan',0),(103407,2873,'nl','Toon',0),(103408,2873,'fi','NÃ¤ytÃ¤',0),(103409,2873,'no','Vis',0),(103410,2873,'da','Vis',0),(103411,2873,'ko','ë³´ê¸°',0),(103412,2873,'he','×”×¦×’',0),(103413,2873,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·',0),(103414,2873,'zh','æ˜¾ç¤º\r\n',0),(103415,2873,'sv','Visa',0),(103416,2873,'it','Visualizza',0),(103417,2873,'tl','',0),(103418,2873,'th','&#3649;&#3626;&#3604;&#3591;',0),(103419,2873,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤',0),(103420,2873,'ms','Papar',0),(103421,2873,'ar','Ø¥Ø¸Ù‡Ø§Ø±',0),(103422,2873,'fr','Voir l\'Ã©tablissement',0),(103423,2873,'jp','è¡¨ç¤º',0),(103424,2873,'pt','Mostrar',0),(103425,2873,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ',0),(103426,2873,'es','Mostrar',0),(103427,2873,'de','Karte',0),(103428,2873,'en','Show',0),(103429,2874,'is','',0),(103430,2874,'dr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(103431,2874,'pr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(103432,2874,'tr','gÃ¶sterilen',0),(103433,2874,'pl','siÄ™',0),(103434,2874,'bg','Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½Ð¸',0),(103435,2874,'ur','Ø¯Ú©Ú¾Ø§ÛŒØ§ Ú¯ÛŒØ§',0),(103436,2874,'sr','ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½Ð¾',0),(103437,2874,'vi','ÄÃ£ Hiá»ƒn thá»‹',0),(103438,2874,'af','Gewys',0),(103439,2874,'ro','indicat',0),(103440,2874,'et','programmi',0),(103441,2874,'si','prikazano',0),(103442,2874,'ba','ditampilkan',0),(103443,2874,'nl','weergegeven',0),(103444,2874,'fi','JavaScript',0),(103445,2874,'no','vist',0),(103446,2874,'da','vist',0),(103447,2874,'ko','í‘œì‹œ',0),(103448,2874,'he','×”×ž×•×¦×’',0),(103449,2874,'el','Î´ÎµÎ¯Î¾ÎµÎ¹',0),(103450,2874,'zh','æ˜¾ç¤º\r\n',0),(103451,2874,'sv','visas',0),(103452,2874,'it','mostrato',0),(103453,2874,'tl','',0),(103454,2874,'th','&#3649;&#3626;&#3604;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(103455,2874,'hi','à¤¦à¤¿à¤–à¤¾à¤ à¤—à¤',0),(103456,2874,'ms','ditunjukkan',0),(103457,2874,'ar','Ø³ÙŠØ¸Ù‡Ø±',0),(103458,2874,'fr','montrÃ©',0),(103459,2874,'jp','è¡¨ç¤º',0),(103460,2874,'pt','mostrado',0),(103461,2874,'ru','Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½Ð¾',0),(103462,2874,'es','Mostrado',0),(103463,2874,'de','gezeigt',0),(103464,2874,'en','shown',0),(103465,2875,'is','',0),(103466,2875,'dr','Ø¨ÙŠÙ…Ø§Ø±',0),(103467,2875,'pr','Ø¨ÙŠÙ…Ø§Ø±',0),(103468,2875,'tr','Hasta',0),(103469,2875,'pl','Chory',0),(103470,2875,'bg','Ð‘Ð¾Ð»Ð½Ð¸',0),(103471,2875,'ur','Ø¨ÛŒÙ…Ø§Ø±',0),(103472,2875,'sr','Ð‘Ð¾Ð»ÐµÑÐ½Ð¸',0),(103473,2875,'vi','Bá»‡nh',0),(103474,2875,'af','Siek',0),(103475,2875,'ro','Bolnav',0),(103476,2875,'et','Haige',0),(103477,2875,'si','Bolan',0),(103478,2875,'ba','Sakit',0),(103479,2875,'nl','Ziek',0),(103480,2875,'fi','Sairas',0),(103481,2875,'no','Syk',0),(103482,2875,'da','Syg',0),(103483,2875,'ko','ì•„í”ˆ',0),(103484,2875,'he','×—×•×œ×”',0),(103485,2875,'el','Î†ÏÏÏ‰ÏƒÏ„Î¿Ï‚',0),(103486,2875,'zh','ç”Ÿç—…\r\n',0),(103487,2875,'sv','Sjukt',0),(103488,2875,'it','Malato',0),(103489,2875,'tl','',0),(103490,2875,'th','&#3611;&#3656;&#3623;&#3618;',0),(103491,2875,'hi','à¤¬à¥€à¤®à¤¾à¤°',0),(103492,2875,'ms','Sakit',0),(103493,2875,'ar','Ø§Ù„Ù…Ø±Ø¶Ù‰',0),(103494,2875,'fr','Malade',0),(103495,2875,'jp','ç—…æ°—',0),(103496,2875,'pt','Doente',0),(103497,2875,'ru','Ð‘Ð¾Ð»ÑŒÐ½Ñ‹Ðµ',0),(103498,2875,'es','Enfermo',0),(103499,2875,'de','SICK',0),(103500,2875,'en','Sick',0),(103501,2876,'is','',0),(103502,2876,'dr','Ø³Ø§Ø¹Ø§Øª Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰ Ø¬Ù…Ø¹ Ø´Ø¯Ù‡ ',0),(103503,2876,'pr','Ø³Ø§Ø¹Ø§Øª Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰ Ø¬Ù…Ø¹ Ø´Ø¯Ù‡ ',0),(103504,2876,'tr','Hasta saatler tahakkuk',0),(103505,2876,'pl','Chore godziny naliczone',0),(103506,2876,'bg','Ð‘Ð¾Ð»Ð½Ð¸Ñ‚Ðµ Ñ‡Ð°ÑÐ¾Ð²Ðµ Ð½Ð°Ñ‚Ñ€ÑƒÐ¿Ð°Ð½Ð¸',0),(103507,2876,'ur','Ø§ÙˆÙ‚Ø§Øª ØªÙ…Ø§Ù… ÛÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ø¨ÛŒÙ…Ø§Ø±',0),(103508,2876,'sr','ÐœÑƒÐºÐ° Ð¼Ð¸ Ñ˜Ðµ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ ÑÐ°Ñ‚Ð¸ Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°Ð½Ð¸Ñ…',0),(103509,2876,'vi','Cá»™ng dá»“n giá» nghá»‰ bá»‡nh',0),(103510,2876,'af','Opgeloopte Siekverlof Ure',0),(103511,2876,'ro','Bolnav ore acumulate',0),(103512,2876,'et','Haiguspuhkuse tunde kogunenud',0),(103513,2876,'si','Bolne, ure, obraÄunane',0),(103514,2876,'ba','Sakit jam Diperoleh',0),(103515,2876,'nl','Zieken uren opgebouwde',0),(103516,2876,'fi','Sairas tunteja kertynyt',0),(103517,2876,'no','Syk timer pÃ¥lÃ¸pt',0),(103518,2876,'da','Syge timer periodiseret',0),(103519,2876,'ko','ì•„í”ˆ ì‹œê°„ ë°œìƒ',0),(103520,2876,'he','×—×•×œ×” ×œ×¦×‘×•×¨ ×©×¢×•×ª',0),(103521,2876,'el','Î‘Î½Î±ÏÏÏ‰Ï„Î¹ÎºÎ® Ï„Ï‰Î½ Î´ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Ï‰Î½ Ï‰ÏÏŽÎ½',0),(103522,2876,'zh','ç—…å‡æ—¶é—´ç´¯è®¡\r\n',0),(103523,2876,'sv','Sjuka timmar upplupna',0),(103524,2876,'it','Malati ore maturati',0),(103525,2876,'tl','',0),(103526,2876,'th','&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3621;&#3634;&#3611;&#3656;&#3623;&#3618;',0),(103527,2876,'hi','à¤¬à¥€à¤®à¤¾à¤° à¤¸à¤®à¤¯ à¤¤à¤• à¤…à¤°à¥à¤œà¤¿à¤¤',0),(103528,2876,'ms','Sakit waktu terakru',0),(103529,2876,'ar','Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¥Ø¬Ø§Ø²Ø© Ø§Ù„Ù…Ø±Ø¶ÙŠØ© Ø§Ù„Ù…ØªØ±Ø§ÙƒÙ…Ø©',0),(103530,2876,'fr','Malades heures accumulÃ©es',0),(103531,2876,'jp','ç´¯ç©?ç—…æ°—ä¼‘æš‡æ™‚é–“',0),(103532,2876,'pt','Doente horas acumuladas',0),(103533,2876,'ru','Ð‘Ð¾Ð»ÑŒÐ½Ñ‹Ñ… Ñ‡Ð°ÑÑ‹ Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÑŽÑ‚ÑÑ',0),(103534,2876,'es','Horas enfermo de descanso acumuladaa',0),(103535,2876,'de','Kranken Stunden angefallen',0),(103536,2876,'en','Sick Hours Accrued',0),(103537,2877,'is','',0),(103538,2877,'dr','Ø³Ø§Ø¹Ø§Øª Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰ Ù…Ø¬Ø§Ø² Ø³Ø§Ù„Ø§Ù†Ù‡',0),(103539,2877,'pr','Ø³Ø§Ø¹Ø§Øª Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰ Ù…Ø¬Ø§Ø² Ø³Ø§Ù„Ø§Ù†Ù‡',0),(103540,2877,'tr','YÄ±l baÅŸÄ±na izin verilen hastalÄ±k saatleri',0),(103541,2877,'pl','Godzin urlop chorobowy dozwolone rocznie',0),(103542,2877,'bg','ÐžÑ‚Ð¿ÑƒÑÐº Ñ‡Ð°ÑÐ° Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸ Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¾',0),(103543,2877,'ur','Ø¨ÛŒÙ…Ø§Ø± Ú†Ú¾ÙˆÚ‘ÛŒÚº Ú¯Ú¾Ù†Ù¹Û’ ÙÛŒ Ø³Ø§Ù„ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(103544,2877,'sr','Ð‘Ð¾Ð»Ð¾Ð²Ð°ÑšÐµ ÑÐ°Ñ‚Ð¸ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾ Ð³Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(103545,2877,'vi','Giá» nghá»‰ bá»‡nh cho phÃ©p 1 nÄƒm',0),(103546,2877,'af','Siekverlof ure toegelaat per jaar',0),(103547,2877,'ro','Ore de concediu medical pe an a permis',0),(103548,2877,'et','Haiguspuhkuse tundi aastas lubatud',0),(103549,2877,'si','Ur bolniÅ¡kega dopusta, dovoljene na leto',0),(103550,2877,'ba','Jam cuti sakit yang diperbolehkan per tahun',0),(103551,2877,'nl','Zieken verlofuren per jaar toegestaan',0),(103552,2877,'fi','Sairausloma vÃ¤himmÃ¤istuntimÃ¤Ã¤rÃ¤ vuodessa',0),(103553,2877,'no','SykefravÃ¦r timer per Ã¥r',0),(103554,2877,'da','Sygeorlov timer om Ã¥ret',0),(103555,2877,'ko','ë³‘ê°€ ì‹œê°„ ë…„ ë‹¹ í—ˆìš©',0),(103556,2877,'he','×©×¢×•×ª ×ž×—×œ×” ×”×ž×•×ª×¨ ×¢×‘×•×¨ ×›×œ ×©× ×”',0),(103557,2877,'el','ÎÏÎµÏ‚ Î±Î½Î±ÏÏÏ‰Ï„Î¹ÎºÎ® Î¬Î´ÎµÎ¹Î± ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î±Î½Î¬ Î­Ï„Î¿Ï‚',0),(103558,2877,'zh','ç—…å‡æ¯å¹´å…è®¸å°æ—¶\r\n',0),(103559,2877,'sv','SjukfrÃ¥nvaro timmar per Ã¥r tillÃ¥tet',0),(103560,2877,'it','Ore di congedo ammessi ogni anno',0),(103561,2877,'tl','',0),(103562,2877,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3621;&#3634;&#3611;&#3656;&#3623;&#3618;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3605;&#3656;&#3629;&#3611;&#3637;',0),(103563,2877,'hi','à¤¬à¥€à¤®à¤¾à¤° à¤›à¥‹à¤¡à¤¼ à¤˜à¤‚à¤Ÿà¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤· à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(103564,2877,'ms','Jam cuti sakit yang dibenarkan setahun',0),(103565,2877,'ar','Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¥Ø¬Ø§Ø²Ø© Ø§Ù„Ù…Ø±Ø¶ÙŠØ© Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡Ø§ Ø³Ù†ÙˆÙŠØ§Ù‹',0),(103566,2877,'fr','Heures de congÃ© de maladie autorisÃ©s par an',0),(103567,2877,'jp','å¹´é–“è¨±å®¹ç—…æ¬ å‹¤å‹™æ™‚é–“',0),(103568,2877,'pt','Horas de dispensa mÃ©dica permitidas por ano',0),(103569,2877,'ru','Ð§Ð°ÑÐ¾Ð² Ð¾Ñ‚Ð¿ÑƒÑÐºÐ° Ð¿Ð¾ Ð±Ð¾Ð»ÐµÐ·Ð½Ð¸, Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾ Ð² Ð³Ð¾Ð´',0),(103570,2877,'es','Horas enfermo de descanso permitidos por aÃ±o',0),(103571,2877,'de','Krankheitstage Stunden pro Jahr',0),(103572,2877,'en','Sick Leave hours allowed per year',0),(103573,2878,'is','',0),(103574,2878,'dr','1',0),(103575,2878,'pr','Ø¬Ù‡Øª   1',0),(103576,2878,'tr','YÃ¼zÃ¼ 1',0),(103577,2878,'pl','Strona 1',0),(103578,2878,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð° 1',0),(103579,2878,'ur','1 Ú©ÛŒ Ø·Ø±Ù',0),(103580,2878,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð° 1',0),(103581,2878,'vi','Máº·t 1',0),(103582,2878,'af','Kant 1',0),(103583,2878,'ro','Partea 1',0),(103584,2878,'et','1. kÃ¼lje',0),(103585,2878,'si','Stran 1',0),(103586,2878,'ba','Sisi 1',0),(103587,2878,'nl','Kant 1',0),(103588,2878,'fi','Side 1',0),(103589,2878,'no','Side 1',0),(103590,2878,'da','Side 1',0),(103591,2878,'ko','ì¸¡ë©´ 1',0),(103592,2878,'he','×¦×“ 1',0),(103593,2878,'el','Î Î»ÎµÏ…ÏÎ¬ 1',0),(103594,2878,'zh','ä¾§1\r\n',0),(103595,2878,'sv','Sida 1',0),(103596,2878,'it','Lato 1',0),(103597,2878,'tl','',0),(103598,2878,'th','&#3604;&#3657;&#3634;&#3609; 1',0),(103599,2878,'hi','1 à¤•à¥€ à¤“à¤°',0),(103600,2878,'ms','Bahagian 1',0),(103601,2878,'ar','Ø§Ù„Ø¬Ø§Ù†Ø¨ 1',0),(103602,2878,'fr','CÃ´tÃ© 1',0),(103603,2878,'jp','ã‚µã‚¤ãƒ‰ï¼‘',0),(103604,2878,'pt','Lado 1',0),(103605,2878,'ru','Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð° 1',0),(103606,2878,'es','Lado 1',0),(103607,2878,'de','Seite 1',0),(103608,2878,'en','Side 1',0),(103609,2879,'is','',0),(103610,2879,'dr','2',0),(103611,2879,'pr','Ø¬Ù‡Øª   2',0),(103612,2879,'tr','YÃ¼z 2',0),(103613,2879,'pl','Strona 2',0),(103614,2879,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð° 2',0),(103615,2879,'ur','2 Ú©ÛŒ Ø·Ø±Ù',0),(103616,2879,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð° 2',0),(103617,2879,'vi','Máº·t 2',0),(103618,2879,'af','Kant 2',0),(103619,2879,'ro','Partea 2',0),(103620,2879,'et','Pool 2',0),(103621,2879,'si','Stran 2',0),(103622,2879,'ba','Sisi 2',0),(103623,2879,'nl','Kant 2',0),(103624,2879,'fi','2-puoli',0),(103625,2879,'no','Side 2',0),(103626,2879,'da','Side 2',0),(103627,2879,'ko','ì¸¡ë©´ 2',0),(103628,2879,'he','×¦×“ 2',0),(103629,2879,'el','Î Î»ÎµÏ…ÏÎ¬ 2',0),(103630,2879,'zh','ä¾§é¢2\r\n',0),(103631,2879,'sv','Sida 2',0),(103632,2879,'it','Lato 2',0),(103633,2879,'tl','',0),(103634,2879,'th','&#3604;&#3657;&#3634;&#3609; 2',0),(103635,2879,'hi','à¤•à¤¿à¤¨à¤¾à¤°à¤¾ 2',0),(103636,2879,'ms','Bahagian 2',0),(103637,2879,'ar','Ø§Ù„Ø¬Ø§Ù†Ø¨ 2',0),(103638,2879,'fr','CÃ´tÃ© 2',0),(103639,2879,'jp','ã‚µã‚¤ãƒ‰ï¼’',0),(103640,2879,'pt','Lado 2',0),(103641,2879,'ru','Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð° 2',0),(103642,2879,'es','Lado 2',0),(103643,2879,'de','Seite 2',0),(103644,2879,'en','Side 2',0),(103645,2880,'is','',0),(103646,2880,'dr','1  ',0),(103647,2880,'pr','Ø¬Ù‡Øª  1  ',0),(103648,2880,'tr','Bir yan',0),(103649,2880,'pl','Po jednej stronie',0),(103650,2880,'bg','ÐžÑ‚ ÐµÐ´Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð°',0),(103651,2880,'ur','Ø§ÛŒÚ© Ø·Ø±Ù Ø¯Ø§Ø±ÛŒ',0),(103652,2880,'sr','ÐˆÐµÐ´Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð°',0),(103653,2880,'vi','Máº·t Má»™t',0),(103654,2880,'af','Kant Een',0),(103655,2880,'ro','Partea una',0),(103656,2880,'et','Ãœks kÃ¼lg',0),(103657,2880,'si','Ena stran',0),(103658,2880,'ba','Sisi satu',0),(103659,2880,'nl','Kant 1',0),(103660,2880,'fi','Puoli 1',0),(103661,2880,'no','Siden en',0),(103662,2880,'da','Side en',0),(103663,2880,'ko','ì¸¡ë©´ 1',0),(103664,2880,'he','×¦×“ ××—×“',0),(103665,2880,'el','ÎœÎ¯Î± Ï€Î»ÎµÏ…ÏÎ¬',0),(103666,2880,'zh','ä¾§1\r\n',0),(103667,2880,'sv','Sidan en',0),(103668,2880,'it','Lato uno',0),(103669,2880,'tl','',0),(103670,2880,'th','&#3604;&#3657;&#3634;&#3609;&#3627;&#3609;&#3638;&#3656;&#3591;',0),(103671,2880,'hi','à¤à¤• à¤“à¤°',0),(103672,2880,'ms','Tepi satu',0),(103673,2880,'ar','Ø¬Ø§Ù†Ø¨ ÙˆØ§Ø­Ø¯',0),(103674,2880,'fr','Un cÃ´tÃ©',0),(103675,2880,'jp','ã‚µã‚¤ãƒ‰ï¼‘',0),(103676,2880,'pt','Lado um',0),(103677,2880,'ru','ÐžÐ´Ð½Ð° ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð°',0),(103678,2880,'es','Lado Uno',0),(103679,2880,'de','Seite 1',0),(103680,2880,'en','Side One',0),(103681,2881,'is','',0),(103682,2881,'dr','2',0),(103683,2881,'pr','Ø¬Ù‡Øª   2',0),(103684,2881,'tr','Ä°ki yan',0),(103685,2881,'pl','Dwa boczne',0),(103686,2881,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð°, Ð´Ð²Ðµ',0),(103687,2881,'ur','Ø¯Ùˆ Ú©ÛŒ Ø·Ø±Ù Ø¯Ø§Ø±ÛŒ',0),(103688,2881,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð° Ð´Ð²Ð°',0),(103689,2881,'vi','Máº·t Hai',0),(103690,2881,'af','Kant Twee',0),(103691,2881,'ro','DouÄƒ laterale',0),(103692,2881,'et','Side kaks',0),(103693,2881,'si','Dve strani',0),(103694,2881,'ba','Sisi dua',0),(103695,2881,'nl','Kant twee',0),(103696,2881,'fi','Puoli 2',0),(103697,2881,'no','Side to',0),(103698,2881,'da','Side to',0),(103699,2881,'ko','ì¸¡ë©´ 2',0),(103700,2881,'he','×¦×“ ×©× ×™',0),(103701,2881,'el','Î”ÏÎ¿ Ï€Î»ÎµÏ…ÏÎ¬',0),(103702,2881,'zh','ä¾§2\r\n',0),(103703,2881,'sv','Sidan tvÃ¥',0),(103704,2881,'it','Due laterali',0),(103705,2881,'tl','',0),(103706,2881,'th','&#3604;&#3657;&#3634;&#3609;&#3626;&#3629;&#3591;',0),(103707,2881,'hi','à¤¦à¥‹ à¤ªà¤•à¥à¤·',0),(103708,2881,'ms','Tepi dua',0),(103709,2881,'ar','Ø§Ù„Ø¬Ø§Ù†Ø¨ Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(103710,2881,'fr','Deux latÃ©raux',0),(103711,2881,'jp','ã‚µã‚¤ãƒ‰ï¼’',0),(103712,2881,'pt','Lado dois',0),(103713,2881,'ru','Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð° Ð”Ð²Ð°',0),(103714,2881,'es','Lado Dos',0),(103715,2881,'de','Seite 2',0),(103716,2881,'en','Side Two',0),(103717,2882,'is','',0),(103718,2882,'dr','Ù…Ø¬Ø±Ø¯',0),(103719,2882,'pr','Ù…Ø¬Ø±Ø¯',0),(103720,2882,'tr','Tek',0),(103721,2882,'pl','Pojedynczy',0),(103722,2882,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ‡Ð½Ð°',0),(103723,2882,'ur','ÙˆØ§Ø­Ø¯',0),(103724,2882,'sr','ÐˆÐµÐ´Ð°Ð½',0),(103725,2882,'vi','Äá»™c thÃ¢n',0),(103726,2882,'af','Enkelopend',0),(103727,2882,'ro','Singur',0),(103728,2882,'et','Ãœhtse',0),(103729,2882,'si','Enotnega',0),(103730,2882,'ba','Tunggal',0),(103731,2882,'nl','Enkele',0),(103732,2882,'fi','Yhden',0),(103733,2882,'no','Enkelt',0),(103734,2882,'da','Enkelt',0),(103735,2882,'ko','ë‹¨ì¼',0),(103736,2882,'he','×™×—×™×“',0),(103737,2882,'el','Î•Î½Î¹Î±Î¯Î±',0),(103738,2882,'zh','å•\r\n',0),(103739,2882,'sv','Enda',0),(103740,2882,'it','Singolo',0),(103741,2882,'tl','',0),(103742,2882,'th','&#3650;&#3626;&#3604;',0),(103743,2882,'hi','à¤à¤•à¤²',0),(103744,2882,'ms','Tunggal',0),(103745,2882,'ar','Ø£Ø¹Ø²Ø¨/Ø¹Ø²Ø¨Ø§Ø¡',0),(103746,2882,'fr','Unique',0),(103747,2882,'jp','ã‚·ãƒ³ã‚°ãƒ«',0),(103748,2882,'pt','Ãšnico',0),(103749,2882,'ru','ÐžÐ´Ð¸Ð½Ð¾ÐºÐ¸Ð¹',0),(103750,2882,'es','Sencillo',0),(103751,2882,'de','Einzelne',0),(103752,2882,'en','Single',0),(103753,2883,'is','',0),(103754,2883,'dr','6',0),(103755,2883,'pr','Ø´Ø´  6',0),(103756,2883,'tr','altÄ±',0),(103757,2883,'pl','szeÅ›Ä‡',0),(103758,2883,'bg','ÑˆÐµÑÑ‚',0),(103759,2883,'ur','Ú†Ú¾',0),(103760,2883,'sr','6',0),(103761,2883,'vi','sÃ¡u',0),(103762,2883,'af','ses',0),(103763,2883,'ro','ÅŸase',0),(103764,2883,'et','kuus',0),(103765,2883,'si','Å¡est',0),(103766,2883,'ba','enam',0),(103767,2883,'nl','zes',0),(103768,2883,'fi','kuusi',0),(103769,2883,'no','seks',0),(103770,2883,'da','seks',0),(103771,2883,'ko','6',0),(103772,2883,'he','×©×©',0),(103773,2883,'el','Î­Î¾Î¹',0),(103774,2883,'zh','å…­\r\n',0),(103775,2883,'sv','sex',0),(103776,2883,'it','Sei',0),(103777,2883,'tl','',0),(103778,2883,'th','&#3627;&#3585;',0),(103779,2883,'hi','à¤›à¤¹',0),(103780,2883,'ms','enam',0),(103781,2883,'ar','Ø³ØªØ©',0),(103782,2883,'fr','six',0),(103783,2883,'jp','6',0),(103784,2883,'pt','seis',0),(103785,2883,'ru','ÑˆÐµÑÑ‚ÑŒ',0),(103786,2883,'es','seis',0),(103787,2883,'de','sechs',0),(103788,2883,'en','six',0),(103789,2884,'is','',0),(103790,2884,'dr','16',0),(103791,2884,'pr','Ø´Ø§Ù†Ø²Ø¯Ù‡  16',0),(103792,2884,'tr','on altÄ±',0),(103793,2884,'pl','szesnaÅ›cie',0),(103794,2884,'bg','ÑˆÐµÑÑ‚Ð½Ð°Ð´ÐµÑÐµÑ‚',0),(103795,2884,'ur','Ø³ÙˆÙ„Û',0),(103796,2884,'sr','Ð¨ÐµÑÐ½Ð°ÐµÑÑ‚',0),(103797,2884,'vi','mÆ°á»i sÃ¡u',0),(103798,2884,'af','sestien',0),(103799,2884,'ro','ÅŸaisprezece',0),(103800,2884,'et','kuusteist',0),(103801,2884,'si','Å¡estnajst',0),(103802,2884,'ba','enam belas',0),(103803,2884,'nl','zestien',0),(103804,2884,'fi','kuusitoista',0),(103805,2884,'no','seksten',0),(103806,2884,'da','seksten',0),(103807,2884,'ko','16',0),(103808,2884,'he','×©×© ×¢×©×¨×”',0),(103809,2884,'el','Î´ÎµÎºÎ±Î­Î¾Î¹',0),(103810,2884,'zh','åå…­\r\n',0),(103811,2884,'sv','sexton',0),(103812,2884,'it','sedici',0),(103813,2884,'tl','',0),(103814,2884,'th','&#3626;&#3636;&#3610;&#3627;&#3585;',0),(103815,2884,'hi','à¤¸à¥‹à¤²à¤¹',0),(103816,2884,'ms','enam belas',0),(103817,2884,'ar','Ø³ØªØ© Ø¹Ø´Ø±Ø©',0),(103818,2884,'fr','seize',0),(103819,2884,'jp','16',0),(103820,2884,'pt','dezesseis',0),(103821,2884,'ru','Ð¨ÐµÑÑ‚Ð½Ð°Ð´Ñ†Ð°Ñ‚ÑŒ',0),(103822,2884,'es','dieciseis',0),(103823,2884,'de','sechzehn',0),(103824,2884,'en','sixteen',0),(103825,2885,'is','',0),(103826,2885,'dr','60',0),(103827,2885,'pr','Ø´ØµØª  60',0),(103828,2885,'tr','altmÄ±ÅŸ',0),(103829,2885,'pl','szeÅ›Ä‡dziesiÄ…t',0),(103830,2885,'bg','ÑˆÐµÑÑ‚Ð´ÐµÑÐµÑ‚',0),(103831,2885,'ur','Ø³Ø§Ù¹Ú¾',0),(103832,2885,'sr','60',0),(103833,2885,'vi','sÃ¡u mÆ°Æ¡i',0),(103834,2885,'af','sestig',0),(103835,2885,'ro','ÅŸaizeci',0),(103836,2885,'et','kuuskÃ¼mmend',0),(103837,2885,'si','Å¡estdeset',0),(103838,2885,'ba','enam puluh',0),(103839,2885,'nl','zestig',0),(103840,2885,'fi','kuusikymmentÃ¤',0),(103841,2885,'no','seksti',0),(103842,2885,'da','Tres',0),(103843,2885,'ko','60',0),(103844,2885,'he','×©×™×©×™×',0),(103845,2885,'el','ÎµÎ¾Î®Î½Ï„Î±',0),(103846,2885,'zh','å…­å\r\n',0),(103847,2885,'sv','sextio',0),(103848,2885,'it','sessanta',0),(103849,2885,'tl','',0),(103850,2885,'th','&#3627;&#3585;&#3626;&#3636;&#3610;',0),(103851,2885,'hi','à¤¸à¤¾à¤ ',0),(103852,2885,'ms','enam puluh',0),(103853,2885,'ar','Ø³ØªÙˆÙ†',0),(103854,2885,'fr','soixante',0),(103855,2885,'jp','60',0),(103856,2885,'pt','sessenta',0),(103857,2885,'ru','ÑˆÐµÑÑ‚ÑŒÐ´ÐµÑÑÑ‚',0),(103858,2885,'es','sesenta',0),(103859,2885,'de','sechzig',0),(103860,2885,'en','sixty',0),(103861,2886,'is','',0),(103862,2886,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ',0),(103863,2886,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ',0),(103864,2886,'tr','Boyutu',0),(103865,2886,'pl','Rozmiar',0),(103866,2886,'bg','Ð Ð°Ð·Ð¼ÐµÑ€',0),(103867,2886,'ur','Ø³Ø§Ø¦Ø²',0),(103868,2886,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð°',0),(103869,2886,'vi','Cá»¡',0),(103870,2886,'af','Grootte',0),(103871,2886,'ro','Dimensiune',0),(103872,2886,'et','Suurus',0),(103873,2886,'si','Velikost',0),(103874,2886,'ba','Ukuran',0),(103875,2886,'nl','Grootte',0),(103876,2886,'fi','Kokoa',0),(103877,2886,'no','StÃ¸rrelse',0),(103878,2886,'da','StÃ¸rrelse',0),(103879,2886,'ko','í¬ê¸°',0),(103880,2886,'he','×’×•×“×œ',0),(103881,2886,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚',0),(103882,2886,'zh','å°ºå¯¸\r\n',0),(103883,2886,'sv','Storlek',0),(103884,2886,'it','Dimensione',0),(103885,2886,'tl','',0),(103886,2886,'th','&#3586;&#3609;&#3634;&#3604;',0),(103887,2886,'hi','à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(103888,2886,'ms','Saiz',0),(103889,2886,'ar','Ø§Ù„Ø­Ø¬Ù…',0),(103890,2886,'fr','Taille',0),(103891,2886,'jp','ã‚µã‚¤ã‚º',0),(103892,2886,'pt','Tamanho',0),(103893,2886,'ru','Ð Ð°Ð·Ð¼ÐµÑ€',0),(103894,2886,'es','TamaÃ±o',0),(103895,2886,'de','GrÃ¶ÃŸe',0),(103896,2886,'en','Size',0),(103897,2887,'is','',0),(103898,2887,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(103899,2887,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(103900,2887,'tr','Boyut bulunamadÄ±.',0),(103901,2887,'pl','Rozmiar nie znaleziono.',0),(103902,2887,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(103903,2887,'ur','Ø³Ø§Ø¦Ø² Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(103904,2887,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(103905,2887,'vi','Cá»¡ khÃ´ng tháº¥y',0),(103906,2887,'af','Grootte nie gevind.',0),(103907,2887,'ro','Dimensiune nu a fost gÄƒsit.',0),(103908,2887,'et','Suurus ei leitud.',0),(103909,2887,'si','Velikost ni mogoÄe najti.',0),(103910,2887,'ba','Ukuran tidak ditemukan.',0),(103911,2887,'nl','Grootte niet gevonden.',0),(103912,2887,'fi','Kokoa ei lÃ¶ydy.',0),(103913,2887,'no','StÃ¸rrelsen ikke funnet.',0),(103914,2887,'da','StÃ¸rrelse ikke fundet.',0),(103915,2887,'ko','í¬ê¸°ëŠ” ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(103916,2887,'he','.×’×•×“×œ ×œ× × ×ž×¦×',0),(103917,2887,'el','Î¤Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(103918,2887,'zh','å°ºå¯¸æ²¡æœ‰æ‰¾åˆ°ã€‚\r\n',0),(103919,2887,'sv','Storlek hittades inte.',0),(103920,2887,'it','Dimensione non trovato.',0),(103921,2887,'tl','',0),(103922,2887,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3586;&#3609;&#3634;&#3604;',0),(103923,2887,'hi','à¤†à¤•à¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(103924,2887,'ms','Saiz tidak dijumpai.',0),(103925,2887,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø­Ø¬Ù….',0),(103926,2887,'fr','Taille non trouvÃ©e.',0),(103927,2887,'jp','ã‚µã‚¤ã‚ºã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(103928,2887,'pt','Tamanho nÃ£o encontrado.',0),(103929,2887,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(103930,2887,'es','TamaÃ±o no se encontrÃ³',0),(103931,2887,'de','GrÃ¶ÃŸe nicht gefunden.',0),(103932,2887,'en','Size not found.',0),(103933,2888,'is','',0),(103934,2888,'dr','Ø¨Ø±Ø´ ',0),(103935,2888,'pr','Ø¨Ø±Ø´ ',0),(103936,2888,'tr','Dilim',0),(103937,2888,'pl','Plasterek',0),(103938,2888,'bg','Ð¤Ð¸Ð»Ð¸Ñ',0),(103939,2888,'ur','Ù‚Ø§Ø´',0),(103940,2888,'sr','Ð˜ÑÐµÑ‡Ð°Ðº',0),(103941,2888,'vi','LÃ¡t cáº¯t',0),(103942,2888,'af','Skyf',0),(103943,2888,'ro','Felie',0),(103944,2888,'et','Viil',0),(103945,2888,'si','Rezina',0),(103946,2888,'ba','Slice',0),(103947,2888,'nl','Segment',0),(103948,2888,'fi','Slice',0),(103949,2888,'no','Skive',0),(103950,2888,'da','Skive',0),(103951,2888,'ko','ìŠ¬ë¼ì´ìŠ¤',0),(103952,2888,'he','×¤×¨×•×¡×”',0),(103953,2888,'el','Î¦Î­Ï„Î±',0),(103954,2888,'zh','åˆ‡ç‰‡\r\n',0),(103955,2888,'sv','Skiva',0),(103956,2888,'it','Fetta',0),(103957,2888,'tl','',0),(103958,2888,'th','&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3656;&#3591;',0),(103959,2888,'hi','à¤¸à¥à¤²à¤¾à¤‡à¤¸',0),(103960,2888,'ms','Hirisan',0),(103961,2888,'ar','Ø´Ø±ÙŠØ­Ø©',0),(103962,2888,'fr','Tranche',0),(103963,2888,'jp','ã‚¹ãƒ©ã‚¤ã‚¹',0),(103964,2888,'pt','Fatia',0),(103965,2888,'ru','Ð¡Ñ€ÐµÐ·',0),(103966,2888,'es','Rebanada',0),(103967,2888,'de','Scheibe',0),(103968,2888,'en','Slice',0),(103969,2889,'is','',0),(103970,2889,'dr','Ø¨Ø±Ø´  ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹',0),(103971,2889,'pr','Ø¨Ø±Ø´  ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹',0),(103972,2889,'tr','Dilim baÅŸlangÄ±Ã§ tarihi',0),(103973,2889,'pl','KawaÅ‚ek Data rozp.',0),(103974,2889,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(103975,2889,'ur','Ù‚Ø§Ø´ Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(103976,2889,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¸ÑÐµÑ‡Ð°Ðº',0),(103977,2889,'vi','NgÃ y báº¯t Ä‘áº§u LÃ¡t cáº¯t',0),(103978,2889,'af','Skyf Begin Datum',0),(103979,2889,'ro','Data de inceput de felie',0),(103980,2889,'et','Viil alguskuupÃ¤ev',0),(103981,2889,'si','Rezina zaÄetni datum',0),(103982,2889,'ba','Slice dimulai tanggal',0),(103983,2889,'nl','Segment begindatum',0),(103984,2889,'fi','Siivu aloituspÃ¤ivÃ¤',0),(103985,2889,'no','Skive Start dato',0),(103986,2889,'da','Skive Start dato',0),(103987,2889,'ko','ìŠ¬ë¼ì´ìŠ¤ ì‹œìž‘ ë‚ ì§œ',0),(103988,2889,'he','×ª××¨×™×š ×”×”×ª×—×œ×” ×¤×¨×•×¡×”',0),(103989,2889,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Ï†Î­Ï„Î±',0),(103990,2889,'zh','åˆ‡ç‰‡å¼€å§‹æ—¥æœŸ\r\n',0),(103991,2889,'sv','Skiva bÃ¶rja datum',0),(103992,2889,'it','Data Begin fetta',0),(103993,2889,'tl','',0),(103994,2889,'th','&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3656;&#3591;&#3623;&#3633;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(103995,2889,'hi','à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(103996,2889,'ms','Hirisan Mulakan tarikh',0),(103997,2889,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø´Ø±ÙŠØ­Ø©',0),(103998,2889,'fr','Date de dÃ©but de tranche',0),(103999,2889,'jp','ã‚¹ãƒ©ã‚¤ã‚¹é–‹å§‹æ—¥',0),(104000,2889,'pt','Data de inÃ­cio de fatia',0),(104001,2889,'ru','Ð¤Ñ€Ð°Ð³Ð¼ÐµÐ½Ñ‚ Begin Ð”Ð°Ñ‚Ð°',0),(104002,2889,'es','Rebanada de GrÃ¡fica Fecha de Comienza',0),(104003,2889,'de','Anfangsdatum der Scheibe',0),(104004,2889,'en','Slice Begin Date',0),(104005,2890,'is','',0),(104006,2890,'dr','Ø´Ø±Ø­ Ø¨Ø±Ø´',0),(104007,2890,'pr','Ø´Ø±Ø­ Ø¨Ø±Ø´',0),(104008,2890,'tr','Dilim aÃ§Ä±klamasÄ±',0),(104009,2890,'pl','Opis kawaÅ‚ek',0),(104010,2890,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(104011,2890,'ur','Ù‚Ø§Ø´ ØªØµØ±ÛŒØ­',0),(104012,2890,'sr','Ð˜ÑÐµÑ‡Ð°Ðº Ð¾Ð¿Ð¸Ñ',0),(104013,2890,'vi','MÃ´ táº£ lÃ¡t cáº¯t ',0),(104014,2890,'af','Skyf Beskrywing',0),(104015,2890,'ro','Felie Descriere',0),(104016,2890,'et','Viil kirjeldus',0),(104017,2890,'si','Opis rezina',0),(104018,2890,'ba','Irisan Deskripsi',0),(104019,2890,'nl','Beschrijving van het segment',0),(104020,2890,'fi','Siivu kuvaus',0),(104021,2890,'no','Skive beskrivelse',0),(104022,2890,'da','Skive beskrivelse',0),(104023,2890,'ko','ì¡°ê° ì„¤ëª…',0),(104024,2890,'he','×ª×™××•×¨ ×¤×¨×•×¡×”',0),(104025,2890,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï†Î­Ï„Î±',0),(104026,2890,'zh','åˆ‡ç‰‡æè¿°\r\n',0),(104027,2890,'sv','Segment Beskrivning',0),(104028,2890,'it','Fetta Descrizione',0),(104029,2890,'tl','',0),(104030,2890,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3656;&#3591;',0),(104031,2890,'hi','à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤µà¤¿à¤µà¤°à¤£',0),(104032,2890,'ms','Description/kawalan Slice',0),(104033,2890,'ar','ÙˆØµÙ Ø´Ø±ÙŠØ­Ø©',0),(104034,2890,'fr','Description de la tranche',0),(104035,2890,'jp','ã‚¹ãƒ©ã‚¤ã‚¹èª¬æ˜Ž',0),(104036,2890,'pt','DescriÃ§Ã£o de fatia',0),(104037,2890,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ñ„Ñ€Ð°Ð³Ð¼ÐµÐ½Ñ‚Ð°',0),(104038,2890,'es','Rebanada de GrÃ¡fica DescripciÃ³n',0),(104039,2890,'de','Scheibe Beschreibung',0),(104040,2890,'en','Slice Description',0),(104041,2891,'is','',0),(104042,2891,'dr','Ø¨Ø±Ø´ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(104043,2891,'pr','Ø¨Ø±Ø´ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(104044,2891,'tr','Dilim bitiÅŸ tarihi',0),(104045,2891,'pl','Data koÅ„cowa czÄ™Å›Ä‡',0),(104046,2891,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ñ€Ñ‡Ðµ',0),(104047,2891,'ur','Ù‚Ø§Ø´ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(104048,2891,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð¸ÑÐµÑ‡Ð°Ðº',0),(104049,2891,'vi','NgÃ y káº¿t thÃºc LÃ¡t cáº¯t',0),(104050,2891,'af','Skyf End Datum',0),(104051,2891,'ro','Data de sfÃ¢rÅŸit felie',0),(104052,2891,'et','Viil lÃµppkuupÃ¤ev',0),(104053,2891,'si','Rezina konÄni datum',0),(104054,2891,'ba','Tanggal akhir slice',0),(104055,2891,'nl','Segment einddatum',0),(104056,2891,'fi','Siivu pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(104057,2891,'no','Skive sluttdatoen',0),(104058,2891,'da','Skive slutdato',0),(104059,2891,'ko','ìŠ¬ë¼ì´ìŠ¤ ì¢…ë£Œ ë‚ ì§œ',0),(104060,2891,'he','×ª××¨×™×š ×¡×™×•× ×¤×¨×•×¡×”',0),(104061,2891,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï†Î­Ï„Î±',0),(104062,2891,'zh','åˆ‡ç‰‡ç»“æŸæ—¥æœŸ\r\n',0),(104063,2891,'sv','Skiva slutdatum',0),(104064,2891,'it','Data fine fetta',0),(104065,2891,'tl','',0),(104066,2891,'th','&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3656;&#3591;&#3623;&#3633;&#3609;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(104067,2891,'hi','à¤Ÿà¥à¤•à¤¡à¤¼à¤¾ à¤…à¤‚à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(104068,2891,'ms','Tarikh akhir Slice',0),(104069,2891,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø´Ø±ÙŠØ­Ø©',0),(104070,2891,'fr','Date de fin de tranche',0),(104071,2891,'jp','ã‚¹ãƒ©ã‚¤ã‚¹çµ‚äº†æ—¥',0),(104072,2891,'pt','Data de tÃ©rmino da fatia',0),(104073,2891,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ñ„Ñ€Ð°Ð³Ð¼ÐµÐ½Ñ‚Ð°',0),(104074,2891,'es','Rebanada de GrÃ¡fica Fecha de TerminaciÃ³n',0),(104075,2891,'de','Slice-Enddatum',0),(104076,2891,'en','Slice End Date',0),(104077,2892,'is','',0),(104078,2892,'dr','Ø¨Ø± Ø´ Ù†Ø§Ù… ',0),(104079,2892,'pr','Ø¨Ø± Ø´ Ù†Ø§Ù… ',0),(104080,2892,'tr','Dilim adÄ±',0),(104081,2892,'pl','Nazwa kawaÅ‚ek',0),(104082,2892,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¿Ð°Ñ€Ñ‡Ðµ',0),(104083,2892,'ur','Ù‚Ø§Ø´ Ù†Ø§Ù…',0),(104084,2892,'sr','Ð˜ÑÐµÑ‡Ð°Ðº Ð¸Ð¼Ðµ',0),(104085,2892,'vi','TÃªn LÃ¡t cáº¯t',0),(104086,2892,'af','Skyfnaam',0),(104087,2892,'ro','Numele de felie',0),(104088,2892,'et','Viil nimi',0),(104089,2892,'si','Rezina ime',0),(104090,2892,'ba','Nama slice',0),(104091,2892,'nl','Segmentnaam',0),(104092,2892,'fi','Sektorin nimi',0),(104093,2892,'no','Skive navn',0),(104094,2892,'da','Skive navn',0),(104095,2892,'ko','ì¡°ê° ì´ë¦„',0),(104096,2892,'he','×¤×¨×•×¡×” ×©×',0),(104097,2892,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î¿Ï… slice',0),(104098,2892,'zh','ç‰‡åç§°\r\n',0),(104099,2892,'sv','Segmentnamn',0),(104100,2892,'it','Nome fetta',0),(104101,2892,'tl','',0),(104102,2892,'th','&#3594;&#3639;&#3656;&#3629;&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3656;&#3591;',0),(104103,2892,'hi','à¤¸à¥à¤²à¤¾à¤‡à¤¸ à¤•à¤¾ à¤¨à¤¾à¤®',0),(104104,2892,'ms','Nama Slice',0),(104105,2892,'ar','Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙŠØ­Ø©',0),(104106,2892,'fr','Nom de la tranche',0),(104107,2892,'jp','ã‚¹ãƒ©ã‚¤ã‚¹å??',0),(104108,2892,'pt','Nome de fatia',0),(104109,2892,'ru','Ð˜Ð¼Ñ Ñ€Ð°Ð·Ð´ÐµÐ»Ð°',0),(104110,2892,'es','Rebanada de GrÃ¡fica Nombre',0),(104111,2892,'de','Segmentname',0),(104112,2892,'en','Slice Name',0),(104113,2893,'is','',0),(104114,2893,'dr','Ø¨Ø±Ø´ Ø¬Ù‡Øª ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(104115,2893,'pr','Ø¨Ø±Ø´ Ø¬Ù‡Øª ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(104116,2893,'tr','Dilim DÃ¼zenle',0),(104117,2893,'pl','KawaÅ‚ek do edycji',0),(104118,2893,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ð½Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(104119,2893,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ù‚Ø§Ø´',0),(104120,2893,'sr','Ð˜ÑÐµÑ‡Ð°Ðº Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(104121,2893,'vi','LÃ¡t Cáº¯t Äá»ƒ Sá»­a',0),(104122,2893,'af','Skyf om te Redigeer',0),(104123,2893,'ro','Felie la Edit',0),(104124,2893,'et','Viil redigeerimine',0),(104125,2893,'si','Rezina za urejanje',0),(104126,2893,'ba','Mengiris ke Edit',0),(104127,2893,'nl','Segment wilt bewerken',0),(104128,2893,'fi','Siivu Muokkaa',0),(104129,2893,'no','Skive Ã¥ redigere',0),(104130,2893,'da','Skive til Rediger',0),(104131,2893,'ko','ìŠ¬ë¼ì´ìŠ¤ íŽ¸ì§‘',0),(104132,2893,'he','×¤×¨×•×¡×” ×¢×œ ×¢×¨×•×š',0),(104133,2893,'el','Î¦Î­Ï„Î± ÏƒÏ„Î¿ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(104134,2893,'zh','ç¼–è¾‘åˆ‡ç‰‡\r\n',0),(104135,2893,'sv','Segment fÃ¶r att redigera',0),(104136,2893,'it','Fetta di modifica',0),(104137,2893,'tl','',0),(104138,2893,'th','&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3656;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(104139,2893,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¸à¥à¤²à¤¾à¤‡à¤¸',0),(104140,2893,'ms','Slice untuk Edit',0),(104141,2893,'ar','Ø´Ø±ÙŠØ­Ø© Ù„ØªØ­Ø±ÙŠØ±',0),(104142,2893,'fr','Tranche Ã  modifier',0),(104143,2893,'jp','ç·¨é›†ã?™ã‚‹ã‚¹ãƒ©ã‚¤ã‚¹',0),(104144,2893,'pt','Fatia para editar',0),(104145,2893,'ru','Ð¡Ñ€ÐµÐ· Ð´Ð»Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(104146,2893,'es','Rebanada de GrÃ¡fica  para Editar',0),(104147,2893,'de','Segment bearbeiten',0),(104148,2893,'en','Slice to Edit',0),(104149,2894,'is','',0),(104150,2894,'dr','Ø¨Ø±Ø´ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(104151,2894,'pr','Ø¨Ø±Ø´ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(104152,2894,'tr','Makas',0),(104153,2894,'pl','Slitter-creaser',0),(104154,2894,'bg','Ð¢Ñ€ÑŠÐ±Ð¾ÑÐ³ÑŠÐ²Ð°Ñ‰Ð¸',0),(104155,2894,'ur','Ø³Ù„Ø§Ù¹Ø±',0),(104156,2894,'sr','Ð¡Ð»Ð¸Ñ‚Ñ‚ÐµÑ€',0),(104157,2894,'vi','ÄÆ°á»ng ná»©t',0),(104158,2894,'af','Slitter',0),(104159,2894,'ro','Zigzag',0),(104160,2894,'et','Slitter',0),(104161,2894,'si','Slitter',0),(104162,2894,'ba','Slitter',0),(104163,2894,'nl','Slitter',0),(104164,2894,'fi','Pituusleikkuri',0),(104165,2894,'no','Bruk',0),(104166,2894,'da','Slitter',0),(104167,2894,'ko','ìŠ¬ ë¦¬í„°',0),(104168,2894,'he','Slitter',0),(104169,2894,'el','Î£Ï‡Î¹ÏƒÏ„Î¹ÎºÏŒ',0),(104170,2894,'zh','åˆ†åˆ‡æœº\r\n',0),(104171,2894,'sv','Slitter',0),(104172,2894,'it','Taglierina',0),(104173,2894,'tl','',0),(104174,2894,'th','&#3605;&#3633;&#3604;&#3648;&#3611;&#3655;&#3609;&#3607;&#3634;&#3591;&#3618;&#3634;&#3623;',0),(104175,2894,'hi','à¤•à¤¾à¤Ÿà¤¨à¥‡ à¤•à¥€ à¤®à¤¶à¥€à¤¨',0),(104176,2894,'ms','Slitter',0),(104177,2894,'ar','Ø§Ù„Ù…Ø´Ù‚Ù‚',0),(104178,2894,'fr','DÃ©coupeuse',0),(104179,2894,'jp','ã‚¹ãƒªãƒƒã‚¿ãƒ¼',0),(104180,2894,'pt','Talhadeira',0),(104181,2894,'ru','Ð‘Ð¾Ð±Ð¸Ð½Ð¾Ñ€ÐµÐ·ÐºÐ¸',0),(104182,2894,'es','Partidor',0),(104183,2894,'de','LÃ¤ngsschneider',0),(104184,2894,'en','Slitter',0),(104185,2895,'is','',0),(104186,2895,'dr','Slsm',0),(104187,2895,'pr','Slsm',0),(104188,2895,'tr','Slsm',0),(104189,2895,'pl','Slsm',0),(104190,2895,'bg','Slsm',0),(104191,2895,'ur','Ø³Ù„Ø³Ù…',0),(104192,2895,'sr','Ð¡Ð»ÑÐ¼',0),(104193,2895,'vi','Slsm',0),(104194,2895,'af','Slsm',0),(104195,2895,'ro','Slsm',0),(104196,2895,'et','Slsm',0),(104197,2895,'si','Slsm',0),(104198,2895,'ba','Slsm',0),(104199,2895,'nl','Slsm',0),(104200,2895,'fi','Slsm',0),(104201,2895,'no','Slsm',0),(104202,2895,'da','Slsm',0),(104203,2895,'ko','Slsm',0),(104204,2895,'he','Slsm',0),(104205,2895,'el','Slsm',0),(104206,2895,'zh','Slsm\r\n',0),(104207,2895,'sv','Slsm',0),(104208,2895,'it','Slsm',0),(104209,2895,'tl','',0),(104210,2895,'th','Slsm',0),(104211,2895,'hi','Slsm',0),(104212,2895,'ms','Slsm',0),(104213,2895,'ar','Ø³Ù„Ø³Ù…',0),(104214,2895,'fr','Slsm',0),(104215,2895,'jp','Slsm',0),(104216,2895,'pt','Slsm',0),(104217,2895,'ru','Slsm',0),(104218,2895,'es','SLSM',0),(104219,2895,'de','Slsm',0),(104220,2895,'en','Slsm',0),(104221,2896,'is','',0),(104222,2896,'dr','ØªØ¬Ø§Ø±Øª Ø¬Ø²Ø¦ÙŠ',0),(104223,2896,'pr','ØªØ¬Ø§Ø±Øª Ø¬Ø²Ø¦ÙŠ',0),(104224,2896,'tr','Ä°ÅŸ',0),(104225,2896,'pl','Biznes',0),(104226,2896,'bg','Ð‘Ð¸Ð·Ð½ÐµÑ',0),(104227,2896,'ur','Ú©Ø§Ø±ÙˆØ¨Ø§Ø±',0),(104228,2896,'sr','ÐŸÐ¾ÑÐ°Ð¾',0),(104229,2896,'vi','Kinh doanh',0),(104230,2896,'af','Besigheid',0),(104231,2896,'ro','Afaceri',0),(104232,2896,'et','Ã„ri',0),(104233,2896,'si','Poslovni',0),(104234,2896,'ba','Bisnis',0),(104235,2896,'nl','Business',0),(104236,2896,'fi','Liiketoiminnan',0),(104237,2896,'no','Business',0),(104238,2896,'da','Business',0),(104239,2896,'ko','ë¹„ì¦ˆë‹ˆìŠ¤',0),(104240,2896,'he','×¢×¡×§',0),(104241,2896,'el','Î•Ï€Î¹Ï‡ÎµÎ¹ÏÎ®ÏƒÎµÏ‰Î½',0),(104242,2896,'zh','å•†åŠ¡\r\n',0),(104243,2896,'sv','Business',0),(104244,2896,'it','Affari',0),(104245,2896,'tl','',0),(104246,2896,'th','&#3608;&#3640;&#3619;&#3585;&#3636;&#3592;&#3586;&#3609;&#3634;&#3604;&#3648;&#3621;&#3655;&#3585;',0),(104247,2896,'hi','à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤°',0),(104248,2896,'ms','Perniagaan',0),(104249,2896,'ar','Ø§Ù„Ø£Ø¹Ù…Ø§Ù„ Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ©',0),(104250,2896,'fr','Entreprise',0),(104251,2896,'jp','ãƒ“ã‚¸ãƒ?ã‚¹',0),(104252,2896,'pt','NegÃ³cios',0),(104253,2896,'ru','Ð‘Ð¸Ð·Ð½ÐµÑ',0),(104254,2896,'es','Negocio',0),(104255,2896,'de','GeschÃ¤ft',0),(104256,2896,'en','Business',0),(104257,2897,'is','',0),(104258,2897,'dr','9 ÙƒØ§Ø±Ø§ÙƒØªØ± Ø¨Ø§Ø´Ø¯',0),(104259,2897,'pr','Ø´Ù…Ø§Ø±Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹Ù‰ Ø¨Ø§ÙŠØ¯ 9 ÙƒØ§Ø±Ø§ÙƒØªØ± Ø¨Ø§Ø´Ø¯',0),(104260,2897,'tr','Sosyal GÃ¼venlik numarasÄ± 9 basamak olmalÄ±!',0),(104261,2897,'pl','Social Security Number musi byÄ‡ 9 cyfr!',0),(104262,2897,'bg','ÐÐ¾Ð¼ÐµÑ€Ð° Ð½Ð° ÑÐ¾Ñ†Ð¸Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÐ¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ 9 Ñ†Ð¸Ñ„Ñ€Ð¸!',0),(104263,2897,'ur','Ø³ÙˆØ´Ù„ Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ Ù†Ù…Ø¨Ø± 9 Ø§Ø¹Ø¯Ø§Ø¯ ÛÙˆÙ†Ø§!',0),(104264,2897,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑÐ¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾Ð³ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ 9 Ñ†Ð¸Ñ„Ð°Ñ€Ð°!',0),(104265,2897,'vi','Sá»‘ an sinh xÃ£ há»™i pháº£i cÃ³ 9 sá»‘!',0),(104266,2897,'af','Sosiale sekerheid nommer moet word 9 syfers!',0),(104267,2897,'ro','NumÄƒrul de securitate socialÄƒ trebuie sÄƒ fie 9 cifre!',0),(104268,2897,'et','Isikukood peab olema 9-kohaline!',0),(104269,2897,'si','9 Å¡tevilk EMÅ O morajo biti!',0),(104270,2897,'ba','Nomor jaminan sosial harus menjadi 9 digit!',0),(104271,2897,'nl','Sofi-nummer moet 9 cijfers bestaan!',0),(104272,2897,'fi','HenkilÃ¶tunnus on oltava 9 numeroa!',0),(104273,2897,'no','Personnummer mÃ¥ vÃ¦re 9 siffer!',0),(104274,2897,'da','CPR-nummeret skal bestÃ¥ af 9 cifre!',0),(104275,2897,'ko','ì‚¬íšŒ ë³´ìž¥ ë²ˆí˜¸ 9 ìžë¦¬ ì—¬ì•¼ í•©ë‹ˆë‹¤!',0),(104276,2897,'he','×ž×¡×¤×¨ ×‘×™×˜×•×— ×œ××•×ž×™ 9 ×¡×¤×¨×•×ª ×‘×˜×—!',0),(104277,2897,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÎºÎ®Ï‚ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± 9 ÏˆÎ·Ï†Î¯Î±!',0),(104278,2897,'zh','ç¤¾ä¼šå®‰å…¨å·ç å¿…é¡»æ˜¯9ä½æ•°å­—ï¼\r\n',0),(104279,2897,'sv','Personnummer mÃ¥ste vara 9 siffror!',0),(104280,2897,'it','Numero di sicurezza sociale deve essere 9 cifre!',0),(104281,2897,'tl','',0),(104282,2897,'th','&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3585;&#3629;&#3591;&#3607;&#3640;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;&#3605;&#3657;&#3629;&#3591;&#3617;&#3637; 9 &#3627;&#3621;&#3633;&#3585;',0),(104283,2897,'hi','à¤¸à¤¾à¤®à¤¾à¤œà¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤•à¥à¤°à¤®à¤¾à¤‚à¤• à¤šà¤¾à¤¹à¤¿à¤ 9 à¤…à¤‚à¤• à¤¹à¥‹!',0),(104284,2897,'ms','Nombor jaminan sosial mesti 9 digit!',0),(104285,2897,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† 9 Ø£Ø±Ù‚Ø§Ù…!',0),(104286,2897,'fr','NumÃ©ro de sÃ©curitÃ© sociale doit Ãªtre 9 chiffres !',0),(104287,2897,'jp','ç¤¾ä¼šä¿?éšœç•ªå?·ã?¯9æ¡?ã?§ã?ªã?‘ã‚Œã?°ã?„ã?‘ã?¾ã?›ã‚“ï¼?',0),(104288,2897,'pt','NÃºmero de seguranÃ§a social deve ser 9 dÃ­gitos!',0),(104289,2897,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÐ¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ñ Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ 9 Ñ†Ð¸Ñ„Ñ€!',0),(104290,2897,'es','El NÃºmero de Seguro Social Debe ser de 9 dÃ­gitos',0),(104291,2897,'de','Social Security Number muÃŸ 9 Ziffern!',0),(104292,2897,'en','Social Security Number Must be 9 digits!',0),(104293,2898,'is','',0),(104294,2898,'dr','ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹Ù‰',0),(104295,2898,'pr','ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹Ù‰',0),(104296,2898,'tr','Sosyal GÃ¼venlik',0),(104297,2898,'pl','Zabezpieczenia spoÅ‚ecznego',0),(104298,2898,'bg','Ð¡Ð¾Ñ†Ð¸Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€ÑÐ²Ð°Ð½Ðµ',0),(104299,2898,'ur','Ø³ÙˆØ´Ù„ Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ',0),(104300,2898,'sr','Ð¡Ð¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐµ',0),(104301,2898,'vi','An sinh xÃ£ há»™i',0),(104302,2898,'af','Sosiale sekuriteit',0),(104303,2898,'ro','De securitate socialÄƒ',0),(104304,2898,'et','Sotsiaalkindlustus',0),(104305,2898,'si','Socialne varnosti',0),(104306,2898,'ba','Jaminan sosial',0),(104307,2898,'nl','Sociale zekerheid',0),(104308,2898,'fi','Sosiaaliturva',0),(104309,2898,'no','Trygd',0),(104310,2898,'da','Social sikring',0),(104311,2898,'ko','ì‚¬íšŒ ë³´ìž¥',0),(104312,2898,'he','×‘×™×˜×•×— ×œ××•×ž×™',0),(104313,2898,'el','ÎšÎ¿Î¹Î½Ï‰Î½Î¹ÎºÎ®Ï‚ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚',0),(104314,2898,'zh','ç¤¾ä¼šä¿éšœ\r\n',0),(104315,2898,'sv','Social trygghet',0),(104316,2898,'it','Sicurezza sociale',0),(104317,2898,'tl','',0),(104318,2898,'th','&#3585;&#3629;&#3591;&#3607;&#3640;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;',0),(104319,2898,'hi','à¤¸à¤¾à¤®à¤¾à¤œà¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¾',0),(104320,2898,'ms','Keselamatan Sosial',0),(104321,2898,'ar','Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø¥Ø¬ØªÙ…Ø§Ø¹ÙŠ',0),(104322,2898,'fr','SÃ©curitÃ© sociale',0),(104323,2898,'jp','ç¤¾ä¼šä¿?éšœ',0),(104324,2898,'pt','SeguranÃ§a social',0),(104325,2898,'ru','Ð¡Ð¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ðµ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ðµ',0),(104326,2898,'es','Seguro Social',0),(104327,2898,'de','Soziale Sicherheit',0),(104328,2898,'en','Social Security',0),(104329,2899,'is','',0),(104330,2899,'dr','ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(104331,2899,'pr','ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(104332,2899,'tr','SatÄ±lan',0),(104333,2899,'pl','Sprzedany',0),(104334,2899,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°',0),(104335,2899,'ur','ÙØ±ÙˆØ®Øª',0),(104336,2899,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð¾',0),(104337,2899,'vi','ÄÃ£ bÃ¡n',0),(104338,2899,'af','Verkoop',0),(104339,2899,'ro','VÃ¢ndute',0),(104340,2899,'et','MÃ¼Ã¼dud',0),(104341,2899,'si','Prodaja',0),(104342,2899,'ba','Dijual',0),(104343,2899,'nl','Verkocht',0),(104344,2899,'fi','MyydÃ¤Ã¤n',0),(104345,2899,'no','Solgt',0),(104346,2899,'da','SÃ¦lges',0),(104347,2899,'ko','íŒë§¤',0),(104348,2899,'he','× ×ž×›×¨',0),(104349,2899,'el','Î Ï‰Î»Î¿ÏÎ½Ï„Î±Î¹',0),(104350,2899,'zh','å‡ºå”®\r\n',0),(104351,2899,'sv','SÃ¤ljs',0),(104352,2899,'it','Venduto',0),(104353,2899,'tl','',0),(104354,2899,'th','&#3586;&#3634;&#3618;&#3629;&#3629;&#3585;',0),(104355,2899,'hi','à¤¬à¥‡à¤šà¤¾',0),(104356,2899,'ms','Dijual',0),(104357,2899,'ar','ØªØ¨Ø§Ø¹',0),(104358,2899,'fr','Vendu',0),(104359,2899,'jp','è²©å£²æ¸ˆ',0),(104360,2899,'pt','Vendida',0),(104361,2899,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð½Ð¾',0),(104362,2899,'es','Vendido',0),(104363,2899,'de','Verkauft',0),(104364,2899,'en','Sold',0),(104365,2900,'is','',0),(104366,2900,'dr','. Ù„Ø·ÙØ§ Ø¨Ø±Ú¯Ø±Ø¯ÙŠØ¯ Ùˆ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(104367,2900,'pr','Ù…ØªØ§Ø³ÙØ§Ù†Ù‡ ØµÙØ­Ù‡ Ù‚Ø¨Ù„ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ú†ÙƒÙŠ Ø±Ø§ ÙƒÙ‡ Ø´Ù…Ø§ Ù…ÙŠ Ø®ÙˆØ§Ø³ØªÙŠØ¯ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ†ÙŠØ¯ Ø±Ø§ Ù†Ù¾Ø°ÙŠØ±ÙØª . Ù„Ø·ÙØ§ Ø¨Ø±Ú¯Ø±Ø¯ÙŠØ¯ Ùˆ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(104368,2900,'tr','ÃœzgÃ¼nÃ¼z, Ã¶nceki sayfa dÃ¼zenlemek istediÄŸiniz onay numarasÄ± geÃ§emedi.  LÃ¼tfen dÃ¶nÃ¼n ve yeniden deneyin.',0),(104369,2900,'pl','Przepraszamy poprzedniej strony zrobiÅ‚ nie wydaÄ‡ numer czeku, ktÃ³ry chcesz edytowaÄ‡.  WrÃ³Ä‡ i sprÃ³buj ponownie.',0),(104370,2900,'bg','Ð—Ð° ÑÑŠÐ¶Ð°Ð»ÐµÐ½Ð¸Ðµ, Ð¿Ñ€ÐµÐ´Ð¸ÑˆÐ½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð½Ðµ Ð¼Ð¸Ð½Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ñ‡ÐµÐºÐ°, ÐºÐ¾Ð¹Ñ‚Ð¾ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ.  Ð’ÑŠÑ€Ð½ÐµÑ‚Ðµ ÑÐµ Ð¸ Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾.',0),(104371,2900,'ur','Ù…Ø¹Ø§Ù Ú©ÛŒØ¬Ø¦Û’ Ú¯Ø§ØŒ Ù¾Ú†Ú¾Ù„Û’ ØµÙØ­Û Ø¢Ù¾ ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº Ù¾Ú‘ØªØ§Ù„ ØªØ¹Ø¯Ø§Ø¯ Ù†Û Ú¯Ø²Ø±Ù†Û’ Û”  ÙˆØ§Ù¾Ø³ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù¾Ú¾Ø± Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº Û”',0),(104372,2900,'sr','Ð˜Ð·Ð²Ð¸Ð½Ð¸ , Ð½Ð° Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾ÑˆÐ»Ð° Ð±Ñ€Ð¾Ñ˜ Ñ‡ÐµÐºÐ° ÐºÐ¾Ñ˜Ð¸ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° ÑƒÑ€ÐµÐ´Ð¸Ñ‚Ðµ.  ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ, Ð²Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ð¸ Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾.',0),(104373,2900,'vi','Xin lá»—i, trang trÆ°á»›c khÃ´ng chuyá»ƒn sá»‘ sÃ©c báº¡n muá»‘n sá»­a. Vui lÃ²ng quay láº¡i & thá»­ láº¡i',0),(104374,2900,'af','Jammer, die vorige bladsy het nie slaag die tjek nommer wat jy wil redigeer.  Asseblief terug en probeer weer.',0),(104375,2900,'ro','Ne pare rau, pagina anterioarÄƒ nu se trece numÄƒrul cecului doriÅ£i sÄƒ editaÅ£i.  ReveniÈ›i È™i Ã®ncercaÈ›i din nou.',0),(104376,2900,'et','Vabandust, eelmine leht ei liigu tÅ¡eki number, mida soovite muuta.  Naaske ja proovige uuesti.',0),(104377,2900,'si','Å½al, prejÅ¡nja stran did ne prelaz potrditveno Å¡tevilko, ki jo Å¾elite urediti.  Vrnite se in poskusite znova.',0),(104378,2900,'ba','Maaf, halaman sebelumnya tidak lulus nomor check yang akan diedit.  Silakan kembali dan coba lagi.',0),(104379,2900,'nl','Sorry, dat de vorige pagina is niet geslaagd voor de nummer van de cheque die u wilt bewerken.  Ga terug en probeer het opnieuw.',0),(104380,2900,'fi','Valitettavasti Edellinen sivu ei antaa sekin numeron, jota haluat muokata.  Palauta ja yritÃ¤ uudelleen.',0),(104381,2900,'no','Beklager, forrige side ikke bestod sjekknummeret du vil redigere.  GÃ¥ tilbake og prÃ¸v pÃ¥ nytt.',0),(104382,2900,'da','DesvÃ¦rre, gjorde forrige side ikke pass checknummeret du â”œâ••nsker at redigere.  GÃ¥ tilbage og prÃ¸ve igen.',0),(104383,2900,'ko','ì£„ì†¡ í•©ë‹ˆë‹¤, ì´ì „ íŽ˜ì´ì§€ ìˆ˜ì •í•  í™•ì¸ ë²ˆí˜¸ë¥¼ í†µê³¼ í•˜ì§€ ì•Šì•˜ë‹¤.  ë°˜í™˜ í•˜ ê³  ë‹¤ì‹œ ì‹œë„ í•˜ì‹­ì‹œì˜¤.',0),(104384,2900,'he','. ×ž×¦×˜×¢×¨, ×”×¢×ž×•×“ ×”×§×•×“× ×œ× ×¢×‘×¨ ×ž×¡×¤×¨ ×”×©×™×§ ×©×‘×¨×¦×•× ×š ×œ×¢×¨×•×š.  ×× × ×—×–×•×¨ ×•× ×¡×” ×©×•×‘.',0),(104385,2900,'el','Î£Ï…Î³Î³Î½ÏŽÎ¼Î·, Î´ÎµÎ½ Ï€Î­ÏÎ±ÏƒÎµ ÏƒÏ„Î·Î½ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· ÏƒÎµÎ»Î¯Î´Î± Î¿ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Ï€Î¿Ï… Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ.  Î•Ï€Î¹ÏƒÏ„ÏÎ­ÏˆÏ„Îµ ÎºÎ±Î¹ Î´Î¿ÎºÎ¹Î¼Î¬ÏƒÏ„Îµ Î¾Î±Î½Î¬.',0),(104386,2900,'zh','å¯¹ä¸èµ·ï¼Œä¸Šä¸€é¡µæ²¡æœ‰é€šè¿‡æ‚¨è¦ç¼–è¾‘çš„æ”¯ç¥¨å·ç ï¼Œè¯·è¿”å›žå¹¶å†è¯•ä¸€æ¬¡ã€‚',0),(104387,2900,'sv','TyvÃ¤rr, fÃ¶regÃ¥ende sida inte klarade checknumret du vill redigera.  GÃ¥ tillbaka och fÃ¶rsÃ¶ka igen.',0),(104388,2900,'it','Siamo spiacenti, la pagina precedente non ha superato il numero di controllo da modificare.  Si prega di tornare e riprovare.',0),(104389,2900,'tl','',0),(104390,2900,'th','Sorry, the previous page did not pass the check number you wish to edit.  Please return and try again.',0),(104391,2900,'hi','à¤®à¤¾à¤« à¤•à¤°à¤¨à¤¾, à¤ªà¤¿à¤›à¤²à¥‡ à¤ªà¥ƒà¤·à¥à¤  à¤†à¤ª à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤šà¥‡à¤• à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤¾à¤°à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤¥à¤¾à¥¤  à¤•à¥ƒà¤ªà¤¯à¤¾ à¤µà¤¾à¤ªà¤¸ à¤œà¤¾à¤à¤ à¤”à¤° ',0),(104392,2900,'ms','Maaf, halaman sebelumnya tidak lulus nombor cek yang hendak diedit.  Sila kembali dan cuba lagi.',0),(104393,2900,'ar','Ø¹Ø°Ø±Ø§Ù‹ØŒ Ù„Ù… ÙŠÙ…Ø± Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø³Ø§Ø¨Ù‚Ø© Ø±Ù‚Ù… Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø°ÙŠ ØªØ±ÙŠØ¯ ØªØ­Ø±ÙŠØ±Ù‡.  ÙŠØ±Ø¬Ù‰ Ø§Ù„Ø¹ÙˆØ¯Ø© ÙˆØ§Ù„Ù…Ø­Ø§ÙˆÙ„Ø© Ù…Ø±Ø© Ø£Ø®Ø±Ù‰.',0),(104394,2900,'fr','DÃ©solÃ©, que la page prÃ©cÃ©dente n\'a pas rÃ©ussi Ã  modifier le numÃ©ro de chÃ¨que.  S\'il vous plaÃ®t, revenez et rÃ©essayez.',0),(104395,2900,'jp','ã?‚ã?„ã?«ã??ç·¨é›†ã?—ã‚ˆã?†ã?¨ã?—ã?Ÿå°?åˆ‡æ‰‹ç•ªå?·ã?Œå‰?ã?®ãƒšãƒ¼ã‚¸ã‚’é€šé?Žã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿã€‚ã‚‚ã?†ä¸€åº¦æˆ»ã?£ã?¦ãƒˆãƒ©ã‚¤ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(104396,2900,'pt','Desculpe, que a pÃ¡gina anterior nÃ£o passou o nÃºmero do cheque que deseja editar.  Por favor volte e tente novamente.',0),(104397,2900,'ru','Ðš ÑÐ¾Ð¶Ð°Ð»ÐµÐ½Ð¸ÑŽ, ÐŸÑ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð½Ðµ Ð¿Ñ€Ð¾Ð¹Ñ‚Ð¸ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ð¹ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ.  Ð’ÐµÑ€Ð½Ð¸Ñ‚ÐµÑÑŒ Ð¸ Ð¿Ð¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÐµÑ‰Ðµ Ñ€Ð°Ð·.',0),(104398,2900,'es','Perdon, la pÃ¡gina previa no pasÃ³ el nÃºmero de cheque que desea editar. Por favor regresar y intentar otra vez',0),(104399,2900,'de','Tut mir leid, die vorherige Seite die Schecknummer nicht bestanden haben, die Sie bearbeiten mÃ¶chten.  Bitte zurÃ¼ck und versuchen Sie es erneut.',0),(104400,2900,'en','Sorry, the previous page did not pass the check number you wish to edit.  Please return and try again.',0),(104401,2901,'is','',0),(104402,2901,'dr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø·Ø¨Ù‚',0),(104403,2901,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø·Ø¨Ù‚',0),(104404,2901,'tr','SÄ±ralama Ã¶lÃ§Ã¼tÃ¼',0),(104405,2901,'pl','Sortuj wedÅ‚ug',0),(104406,2901,'bg','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾',0),(104407,2901,'ur','Ú†Ú¾Ø§Ù†Ù¹ÛŒÚº Ø¨Ù…Ø·Ø§Ø¨Ù‚',0),(104408,2901,'sr','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾',0),(104409,2901,'vi','Sáº¯p xáº¿p theo',0),(104410,2901,'af','Sorteer Volgens',0),(104411,2901,'ro','Sortare dupÄƒ',0),(104412,2901,'et','Sorteeri',0),(104413,2901,'si','Razvrsti po',0),(104414,2901,'ba','Urutkan',0),(104415,2901,'nl','Sorteren op',0),(104416,2901,'fi','Lajittele',0),(104417,2901,'no','Sorter etter',0),(104418,2901,'da','Sorter efter',0),(104419,2901,'ko','ì •ë ¬ ê¸°ì¤€',0),(104420,2901,'he','×ž×™×™×Ÿ ×œ×¤×™',0),(104421,2901,'el','Î¤Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ· ÎºÎ±Ï„Î¬',0),(104422,2901,'zh','åˆ†ç±»æ–¹å¼\r\n',0),(104423,2901,'sv','Sortera efter',0),(104424,2901,'it','Ordina per',0),(104425,2901,'tl','',0),(104426,2901,'th','&#3592;&#3633;&#3604;&#3648;&#3619;&#3637;&#3618;&#3591;&#3650;&#3604;&#3618;',0),(104427,2901,'hi','à¤‡à¤¸à¤¸à¥‡ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(104428,2901,'ms','Susun mengikut',0),(104429,2901,'ar','ÙØ±Ø² Ø­Ø³Ø¨',0),(104430,2901,'fr','Trier par',0),(104431,2901,'jp','åˆ†é¡ž',0),(104432,2901,'pt','Ordenar por',0),(104433,2901,'ru','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐŸÐ¾',0),(104434,2901,'es','Clasificar Por',0),(104435,2901,'de','Sortieren nach',0),(104436,2901,'en','Sort By',0),(104437,2902,'is','',0),(104438,2902,'dr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³ÙØ§Ø±Ø´',0),(104439,2902,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³ÙØ§Ø±Ø´',0),(104440,2902,'tr','SÄ±ralama dÃ¼zeni',0),(104441,2902,'pl','KolejnoÅ›Ä‡ sortowania',0),(104442,2902,'bg','Ð ÐµÐ´ Ð½Ð° ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(104443,2902,'ur','Ú†Ú¾Ø§Ù†Ù¹ ØªØ±ØªÛŒØ¨',0),(104444,2902,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°ÑšÐ°',0),(104445,2902,'vi','Sáº¯p xáº¿p Ä‘Æ¡n hÃ ng',0),(104446,2902,'af','Sorteer Bestelling',0),(104447,2902,'ro','Ordinea de sortare',0),(104448,2902,'et','SortimisjÃ¤rjestus',0),(104449,2902,'si','Vrstni red',0),(104450,2902,'ba','Urutan',0),(104451,2902,'nl','Sorteervolgorde',0),(104452,2902,'fi','LajittelujÃ¤rjestys',0),(104453,2902,'no','SorteringsrekkefÃ¸lge',0),(104454,2902,'da','SorteringsrÃ¦kkefÃ¸lge',0),(104455,2902,'ko','ì •ë ¬ ìˆœì„œ',0),(104456,2902,'he','×¡×“×¨ ×ž×™×•×Ÿ',0),(104457,2902,'el','Î£ÎµÎ¹ÏÎ¬ Ï„Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ·Ï‚',0),(104458,2902,'zh','æŽ’åºæŽ’åº\r\n',0),(104459,2902,'sv','Sorteringsordning',0),(104460,2902,'it','Ordinamento',0),(104461,2902,'tl','',0),(104462,2902,'th','&#3592;&#3633;&#3604;&#3648;&#3619;&#3637;&#3618;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(104463,2902,'hi','à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¥à¤°à¤®',0),(104464,2902,'ms','Susun mengikut',0),(104465,2902,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„ÙØ±Ø²',0),(104466,2902,'fr','Ordre de tri',0),(104467,2902,'jp','åˆ†é¡žæ³¨æ–‡',0),(104468,2902,'pt','Ordem de classificaÃ§Ã£o',0),(104469,2902,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(104470,2902,'es','Orden de ClasificaciÃ³n',0),(104471,2902,'de','Sortierreihenfolge',0),(104472,2902,'en','Sort Order',0),(104473,2903,'is','',0),(104474,2903,'dr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´',0),(104475,2903,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´',0),(104476,2903,'tr','SÄ±ralama dÃ¼zenini gÃ¶rÃ¼ntÃ¼lemek iÃ§in',0),(104477,2903,'pl','PorzÄ…dek wyÅ›wietlania',0),(104478,2903,'bg','Ð ÐµÐ´ Ð½Ð° ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ',0),(104479,2903,'ur','Ø¯Ú©Ú¾Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú†Ú¾Ø§Ù†Ù¹ ØªØ±ØªÛŒØ¨',0),(104480,2903,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°ÑšÐ° Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·',0),(104481,2903,'vi','Sáº¯p xáº¿p Ä‘Æ¡n hÃ ng Ä‘á»‡ hiá»ƒn thá»‹',0),(104482,2903,'af','Sorteer Bestelling vir Vertoning',0),(104483,2903,'ro','Ordinea de sortare pentru afiÅŸare',0),(104484,2903,'et','Kuva sortimisjÃ¤rjestus',0),(104485,2903,'si','Vrstni red za prikaz',0),(104486,2903,'ba','Urutan tampilan',0),(104487,2903,'nl','Sorteervolgorde voor weergave',0),(104488,2903,'fi','OletuslajittelujÃ¤rjestys jotta nÃ¤yttÃ¶',0),(104489,2903,'no','SorteringsrekkefÃ¸lgen for visning',0),(104490,2903,'da','SorteringsrÃ¦kkefÃ¸lge til visning',0),(104491,2903,'ko','ë””ìŠ¤í”Œë ˆì´ ëŒ€ í•œ ì •ë ¬ ìˆœì„œ',0),(104492,2903,'he','×¡×“×¨ ×ž×™×•×Ÿ ×¢×‘×•×¨ ×”×ª×¦×•×’×”',0),(104493,2903,'el','Î£ÎµÎ¹ÏÎ¬ Ï„Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î·Î½ Î¿Î¸ÏŒÎ½Î·',0),(104494,2903,'zh','æŽ’åºé¡ºåºæ˜¾ç¤º\r\n',0),(104495,2903,'sv','Sorteringsordningen fÃ¶r visning',0),(104496,2903,'it','Ordinamento per Display',0),(104497,2903,'tl','',0),(104498,2903,'th','&#3592;&#3633;&#3604;&#3648;&#3619;&#3637;&#3618;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3649;&#3626;&#3604;&#3591;',0),(104499,2903,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶',0),(104500,2903,'ms','Susun mengikut paparan',0),(104501,2903,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„ÙØ±Ø² Ù„Ù„Ø¹Ø±Ø¶',0),(104502,2903,'fr','Ordre de tri pour l\'affichage',0),(104503,2903,'jp','ãƒ‡ã‚£ã‚¹ãƒ—ãƒ¬ã‚¤ã?®åˆ†é¡žæ³¨æ–‡',0),(104504,2903,'pt','Ordem de classificaÃ§Ã£o para a exposiÃ§Ã£o',0),(104505,2903,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð´Ð»Ñ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(104506,2903,'es','Orden de ClasificaciÃ³n para Desplegar',0),(104507,2903,'de','Sortierreihenfolge fÃ¼r die Anzeige',0),(104508,2903,'en','Sort Order for Display',0),(104509,2904,'is','',0),(104510,2904,'dr','Ø§ÙˆÙ„ÙˆÙŠØª Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ ',0),(104511,2904,'pr','Ø§ÙˆÙ„ÙˆÙŠØª Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ ',0),(104512,2904,'tr','SÄ±ralama Ã¶nceliÄŸini',0),(104513,2904,'pl','Priorytet sortowania',0),(104514,2904,'bg','ÐÐµÑ‰Ð¾ ÐºÐ°Ñ‚Ð¾ Ð¿Ñ€Ð¸Ð¾Ñ€Ð¸Ñ‚ÐµÑ‚',0),(104515,2904,'ur','Ú†Ú¾Ø§Ù†Ù¹ÛŒÚº ØªØ±Ø¬ÛŒØ­',0),(104516,2904,'sr','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ˜ Ð¿Ñ€Ð¸Ð¾Ñ€Ð¸Ñ‚ÐµÑ‚',0),(104517,2904,'vi','Æ¯u tiÃªn Sáº¯p xáº¿p',0),(104518,2904,'af','Soort prioriteit',0),(104519,2904,'ro','Sortare prioritate',0),(104520,2904,'et','Sortimise prioriteedi',0),(104521,2904,'si','Prednostno razvrÅ¡Äanje',0),(104522,2904,'ba','Urutkan prioritas',0),(104523,2904,'nl','Sorteerprioriteit',0),(104524,2904,'fi','LajittelujÃ¤rjestys',0),(104525,2904,'no','Sorteringsprioriteten',0),(104526,2904,'da','Form prioritet',0),(104527,2904,'ko','ì •ë ¬ ìš°ì„  ìˆœìœ„',0),(104528,2904,'he','×ž×™×•×Ÿ ×¢×“×™×¤×•×ª',0),(104529,2904,'el','Î•Î¯Î´Î¿Ï‚ Ï€ÏÎ¿Ï„ÎµÏÎ±Î¹ÏŒÏ„Î·Ï„Î±Ï‚',0),(104530,2904,'zh','åˆ†ç±»ä¼˜å…ˆ\r\n',0),(104531,2904,'sv','Sortera prioritet',0),(104532,2904,'it','PrioritÃ  di ordinamento',0),(104533,2904,'tl','',0),(104534,2904,'th','&#3592;&#3633;&#3604;&#3648;&#3619;&#3637;&#3618;&#3591;&#3626;&#3636;&#3607;&#3608;&#3636;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(104535,2904,'hi','à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚ à¤ªà¥à¤°à¤¾à¤¥à¤®à¤¿à¤•à¤¤à¤¾',0),(104536,2904,'ms','Susun keutamaan',0),(104537,2904,'ar','Ø£ÙˆÙ„ÙˆÙŠØ© Ø§Ù„ÙØ±Ø²',0),(104538,2904,'fr','PrioritÃ© de tri',0),(104539,2904,'jp','å„ªå…ˆé †ä½?ã?®åˆ†é¡ž',0),(104540,2904,'pt','Prioridade de classificaÃ§Ã£o',0),(104541,2904,'ru','ÐŸÑ€Ð¸Ð¾Ñ€Ð¸Ñ‚ÐµÑ‚ ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(104542,2904,'es','Prioridad de Clasificar',0),(104543,2904,'de','SortierprioritÃ¤t',0),(104544,2904,'en','Sort Priority',0),(104545,2905,'is','',0),(104546,2905,'dr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(104547,2905,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(104548,2905,'tr','SÄ±ralama dÃ¼zeni',0),(104549,2905,'pl','KolejnoÅ›Ä‡ sortowania',0),(104550,2905,'bg','Ð ÐµÐ´ Ð½Ð° ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(104551,2905,'ur','Ú†Ú¾Ø§Ù†Ù¹ ØªØ±ØªÛŒØ¨',0),(104552,2905,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°ÑšÐ°',0),(104553,2905,'vi','Sáº¯p xáº¿p Ä‘Æ¡n hÃ ng',0),(104554,2905,'af','Sorteer Bestelling',0),(104555,2905,'ro','Ordinea de sortare',0),(104556,2905,'et','SortimisjÃ¤rjestus',0),(104557,2905,'si','Vrstni red',0),(104558,2905,'ba','Urutan',0),(104559,2905,'nl','Sorteerorde',0),(104560,2905,'fi','LajittelujÃ¤rjestys',0),(104561,2905,'no','SorteringsrekkefÃ¸lge',0),(104562,2905,'da','SorteringsrÃ¦kkefÃ¸lge',0),(104563,2905,'ko','ì •ë ¬ ìˆœì„œ',0),(104564,2905,'he','×¡×“×¨ ×ž×™×•×Ÿ',0),(104565,2905,'el','Î£ÎµÎ¹ÏÎ¬ Ï„Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ·Ï‚',0),(104566,2905,'zh','åˆ†ç±»æŽ’åº\r\n',0),(104567,2905,'sv','Sorteringsordning',0),(104568,2905,'it','Ordinamento',0),(104569,2905,'tl','',0),(104570,2905,'th','&#3649;&#3610;&#3656;&#3591;&#3594;&#3609;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(104571,2905,'hi','à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¥à¤°à¤®',0),(104572,2905,'ms','Susun mengikut',0),(104573,2905,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„ÙØ±Ø²',0),(104574,2905,'fr','Ordre de tri',0),(104575,2905,'jp','æ³¨æ–‡ã?®åˆ†é¡ž',0),(104576,2905,'pt','Ordem de classificaÃ§Ã£o',0),(104577,2905,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(104578,2905,'es','Orden de Clasificar',0),(104579,2905,'de','Sortierreihenfolge',0),(104580,2905,'en','Sort Order',0),(104581,2906,'is','',0),(104582,2906,'dr','Ø´Ø±Ø­ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ â€“ Ø¯Ùˆ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ù…Ø´Ø§Ø¨Ù‡  Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯',0),(104583,2906,'pr','Ø´Ø±Ø­ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ â€“ Ø¯Ùˆ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ù…Ø´Ø§Ø¨Ù‡  Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯',0),(104584,2906,'tr','Yok iki workareas atanabilir<br>aynÄ± SÄ±ralamaDÃ¼zeni numarasÄ±',0),(104585,2906,'pl','Nie ma dwÃ³ch odseparowanych miej mogÄ… byÄ‡ przypisane<br>aby ten sam numer parametru KolejnoÅ›Ä‡_sortowania',0),(104586,2906,'bg','ÐÑÐ¼Ð° Ð´Ð²Ðµ workareas Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½<br>ÐºÑŠÐ¼ ÑÑŠÑ‰Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Sortorder',0),(104587,2906,'ur','Ú©ÙˆØ¦ÛŒ Ø¯Ùˆ ÙˆÙˆØ±Ú©Ø§Ø±ÛŒØ³ ØªÙÙˆÛŒØ¶ Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ ÛÛ’<br>Ø§Ø³ÛŒ Ø³ÙˆØ±Ù¹ÙˆØ±Ø¯Ø± Ù†Ù…Ø¨Ø± Ù¾Ø±',0),(104588,2906,'sr','ÐÐµÐ¼Ð° Ð´Ð²Ð° wÐ¾Ñ€ÐºÐ°Ñ€ÐµÐ°Ñ Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð´Ð¾Ð´ÐµÑ™ÐµÐ½Ð°.<br>Ð½Ð° Ð¸ÑÑ‚Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð¡Ð¾Ñ€Ñ‚Ð¾Ñ€Ð´ÐµÑ€',0),(104589,2906,'vi','KhÃ´ng thá»ƒ chá»‰ Ä‘á»‹nh hai Ä‘á»‹a Ä‘iá»ƒm cho cÃ¹ng má»™t sá»‘ sáº¯p xáº¿p',0),(104590,2906,'af','Geen TWEE werkarea\'s kan nie toegeken<br> aan dieselfde Sorteer Bestellingsnommer',0),(104591,2906,'ro','Nici un workareas douÄƒ pot fi atribuite<br>la acelaÅŸi numÄƒr Sortorder',0),(104592,2906,'et','KAHE workareas saab mÃ¤Ã¤rata<br>Ã¼he Sortorder numbri',0),(104593,2906,'si','Ni dveh workareas se lahko dodeli<br>za isto Å¡tevilko Vrstni_red_razvrÅ¡Äanja',0),(104594,2906,'ba','Workareas dua tidak dapat ditetapkan<br>untuk jumlah yang sama Sortorder',0),(104595,2906,'nl','Geen twee workareas kunnen worden toegewezen<br>naar hetzelfde SortOrder (sorteervolgorde) nummer',0),(104596,2906,'fi','KAKSI workareas voidaan mÃ¤Ã¤rittÃ¤Ã¤<br>samaan lajittelujÃ¤rjestys numeroon',0),(104597,2906,'no','Ingen to workareas kan tildeles<br>samme sorteringsrekkefÃ¸lge nummeret',0),(104598,2906,'da','Ikke to workareas kan tildeles<br>til samme Sortorder antallet',0),(104599,2906,'ko','ì•„ë¬´ 2 ê°œì˜ workareasëŠ” í• ë‹¹í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<br>ë™ì¼í•œ Sortorder ìˆ˜',0),(104600,2906,'he','× ×™×ª×Ÿ ×œ×”×§×¦×•×ª ××™×Ÿ workareas ×©× ×™<br>Sortorder ×œ××•×ª×• ×ž×¡×¤×¨',0),(104601,2906,'el','Î”ÎµÎ½ Î´ÏÎ¿ ÎµÏ€Î¹Ï†Î¬Î½ÎµÎ¹ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÏƒÏ„Î¿ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î½Î±Ï„ÎµÎ¸ÎµÎ¯<br>ÏƒÏ„Î¿Î½ Î¯Î´Î¹Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ ÏƒÎµÎ¹ÏÎ¬ Ï„Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ·Ï‚',0),(104602,2906,'zh','åˆ†ç±»æŽ’åºè§£é‡Šï¼šä¸¤ä¸ªå·¥ä½œåŒºä¸å¯åˆ†é…åˆ°ç›¸åŒçš„åˆ†ç±»æŽ’åºå·ç \r\n',0),(104603,2906,'sv','Ingen tvÃ¥ workareas kan tilldelas<br>att samma sorteringsordning nummer',0),(104604,2906,'it','No due workareas possono essere assegnati<br>per lo stesso numero di Sortorder',0),(104605,2906,'tl','',0),(104606,2906,'th','No TWO workareas can be assigned<br> to the same Sortorder number',0),(104607,2906,'hi','à¤•à¥‹à¤ˆ à¤¦à¥‹ workareas à¤•à¥‹ à¤¸à¥Œà¤‚à¤ªà¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾<br>à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤¹à¥€ Sortorder à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(104608,2906,'ms','Workareas dua tidak boleh diberikan<br>ke nombor Sortorder yang sama',0),(104609,2906,'ar','ÙŠÙ…ÙƒÙ† ØªØ¹ÙŠÙŠÙ† Ù„Ø§ ÙˆÙˆØ±ÙƒØ§Ø±ÙŠØ³ Ø§Ø«Ù†ÙŠÙ†<br>Ù„Ù†ÙØ³ Ø§Ù„Ø±Ù‚Ù… Ø§Ø®ØªÙŠØ§Ø±ÙŠØ©',0),(104610,2906,'fr','Vous ne pouvez assigner aucun deux workareas<br>pour le mÃªme nombre de Sortorder',0),(104611,2906,'jp','å?Œã?˜æ³¨æ–‡åˆ†é¡žç•ªå?·ã?«<br>äºŒã?¤ã?®ä½œæ¥­åŒºåŸŸã‚’å‰²å½“ã?¦ã‚‹äº‹ã?Œã?§ã??ã?¾ã?›ã‚“',0),(104612,2906,'pt','NÃ£o hÃ¡ dois workareas pode ser atribuÃ­dos<br>para o mesmo nÃºmero de Sortorder',0),(104613,2906,'ru','ÐÐµÑ‚ Ð´Ð²ÑƒÑ… workareas Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½<br>Ð² Ð¾Ð´Ð¸Ð½ Ð¸ Ñ‚Ð¾Ñ‚ Ð¶Ðµ Ð½Ð¾Ð¼ÐµÑ€ Sortorder',0),(104614,2906,'es','No hay DOS Ã¡reas de trabajo que se puede asignar<br>al mismonÃºmero de orden de clasificar',0),(104615,2906,'de','Keine zwei Workareas kÃ¶nnen zugewiesen werden<br>an die selbe Nummer Sortorder',0),(104616,2906,'en','No TWO workareas can be assigned<br> to the same Sortorder number',0),(104617,2907,'is','',0),(104618,2907,'dr','Ù…Ù†Ø¨Ø¹',0),(104619,2907,'pr','Ù…Ù†Ø¨Ø¹',0),(104620,2907,'tr','Kaynak',0),(104621,2907,'pl','Å¹rÃ³dÅ‚a',0),(104622,2907,'bg','Ð˜Ð·Ñ‚Ð¾Ñ‡Ð½Ð¸Ðº',0),(104623,2907,'ur','Ù…Ø§Ø®Ø°',0),(104624,2907,'sr','Ð˜Ð·Ð²Ð¾Ñ€',0),(104625,2907,'vi','Nguá»“n',0),(104626,2907,'af','Bron',0),(104627,2907,'ro','Sursa',0),(104628,2907,'et','Allikas',0),(104629,2907,'si','Vir',0),(104630,2907,'ba','Sumber',0),(104631,2907,'nl','Bron',0),(104632,2907,'fi','LÃ¤hde',0),(104633,2907,'no','Kilde',0),(104634,2907,'da','Kilde',0),(104635,2907,'ko','ì†ŒìŠ¤',0),(104636,2907,'he','×ž×§×•×¨',0),(104637,2907,'el','Î Î·Î³Î®',0),(104638,2907,'zh','æ¥æº\r\n',0),(104639,2907,'sv','KÃ¤lla',0),(104640,2907,'it','Fonte',0),(104641,2907,'tl','',0),(104642,2907,'th','&#3649;&#3627;&#3621;&#3656;&#3591;&#3607;&#3637;&#3656;&#3617;&#3634;',0),(104643,2907,'hi','à¤¸à¥à¤°à¥‹à¤¤',0),(104644,2907,'ms','Sumber',0),(104645,2907,'ar','Ø§Ù„Ù…ØµØ¯Ø±',0),(104646,2907,'fr','Source',0),(104647,2907,'jp','æº?æ³‰',0),(104648,2907,'pt','Fonte',0),(104649,2907,'ru','Ð˜ÑÑ‚Ð¾Ñ‡Ð½Ð¸Ðº',0),(104650,2907,'es','Fuente',0),(104651,2907,'de','Quelle',0),(104652,2907,'en','Source',0),(104653,2908,'is','',0),(104654,2908,'dr','Ø§Ø³Ù¾Ø§Ù†ÙŠØ§ÙŠÙŠ',0),(104655,2908,'pr','Ø§Ø³Ù¾Ø§Ù†ÙŠØ§ÙŠÙŠ',0),(104656,2908,'tr','Ä°spanyolca',0),(104657,2908,'pl','HiszpaÅ„ski',0),(104658,2908,'bg','Ð˜ÑÐ¿Ð°Ð½ÑÐºÐ¸',0),(104659,2908,'ur','Ø³Ù¾ÙŠÙ†Ø´',0),(104660,2908,'sr','ÑˆÐ¿Ð°Ð½ÑÐºÐ¸',0),(104661,2908,'vi','TÃ¢y ban nha',0),(104662,2908,'af','Spaans',0),(104663,2908,'ro','SpaniolÄƒ',0),(104664,2908,'et','Hispaania',0),(104665,2908,'si','Å¡panÅ¡Äina',0),(104666,2908,'ba','Spanyol',0),(104667,2908,'nl','Spaans',0),(104668,2908,'fi','espanja',0),(104669,2908,'no','Spansk',0),(104670,2908,'da','spansk',0),(104671,2908,'ko','ìŠ¤íŽ˜ì¸ì–´',0),(104672,2908,'he','×¡×¤×¨×“×™×ª',0),(104673,2908,'el','Î™ÏƒÏ€Î±Î½Î¹ÎºÎ¬',0),(104674,2908,'zh','è¥¿ç­ç‰™è¯­\r\n',0),(104675,2908,'sv','Spanska',0),(104676,2908,'it','Spagnolo',0),(104677,2908,'tl','',0),(104678,2908,'th','&#3616;&#3634;&#3625;&#3634;&#3626;&#3648;&#3611;&#3609;',0),(104679,2908,'hi','à¤¸à¥à¤ªà¥ˆà¤¨à¤¿à¤¶',0),(104680,2908,'ms','Sepanyol',0),(104681,2908,'ar','Ø§Ù„Ø£Ø³Ø¨Ø§Ù†ÙŠØ©',0),(104682,2908,'fr','Espagnol',0),(104683,2908,'jp','ã‚¹ãƒšã‚¤ãƒ³èªž',0),(104684,2908,'pt','Espanhol',0),(104685,2908,'ru','Ð¸ÑÐ¿Ð°Ð½ÑÐºÐ¸Ð¹',0),(104686,2908,'es','EspaÃ±ol',0),(104687,2908,'de','Spanisch',0),(104688,2908,'en','Spanish',0),(104689,2909,'is','',0),(104690,2909,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙˆÙŠÚ˜Ù‡',0),(104691,2909,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙˆÙŠÚ˜Ù‡',0),(104692,2909,'tr','Ã–zel notlar',0),(104693,2909,'pl','Uwagi specjalne',0),(104694,2909,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(104695,2909,'ur','Ø®ØµÙˆØµÛŒ Ù†ÙˆÙ¹',0),(104696,2909,'sr','ÐŸÐ¾ÑÐµÐ±Ð½Ðµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(104697,2909,'vi','Ghi chÃº Ä‘áº·c biá»‡t',0),(104698,2909,'af','Spesiale Notas',0),(104699,2909,'ro','Note speciale',0),(104700,2909,'et','Erilist mÃ¤rkused',0),(104701,2909,'si','Poseben opombe',0),(104702,2909,'ba','Catatan Khusus',0),(104703,2909,'nl','Speciale notities',0),(104704,2909,'fi','ErityisiÃ¤ huomautuksia',0),(104705,2909,'no','Spesiell notater',0),(104706,2909,'da','SÃ¦rlige bemÃ¦rkninger',0),(104707,2909,'ko','íŠ¹ë³„ í•œ ë…¸íŠ¸',0),(104708,2909,'he','×”×¢×¨×•×ª ×ž×™×•×—×“×•×ª',0),(104709,2909,'el','Î•Î¹Î´Î¹ÎºÎ­Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(104710,2909,'zh','ç‰¹åˆ«æ³¨æ„äº‹é¡¹\r\n',0),(104711,2909,'sv','SÃ¤rskilda anmÃ¤rkningar',0),(104712,2909,'it','Note particolari',0),(104713,2909,'tl','',0),(104714,2909,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(104715,2909,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤¨à¥‹à¤Ÿà¥à¤¸',0),(104716,2909,'ms','Nota-Nota Khas',0),(104717,2909,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø®Ø§ØµØ©',0),(104718,2909,'fr','Notes spÃ©ciales',0),(104719,2909,'jp','ã‚¹ãƒšã‚·ãƒ£ãƒ«ãƒ¡ãƒ¢',0),(104720,2909,'pt','Notas especiais',0),(104721,2909,'ru','ÐžÑÐ¾Ð±Ñ‹Ðµ Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(104722,2909,'es','Notas Especiales',0),(104723,2909,'de','Besondere Hinweise',0),(104724,2909,'en','Special Notes',0),(104725,2910,'is','',0),(104726,2910,'dr','(ÙˆÙŠÚ˜Ù‡',0),(104727,2910,'pr','Ø´Ø±ÙƒØª Ø«Ø§Ø¨Øª(ÙˆÙŠÚ˜Ù‡',0),(104728,2910,'tr','Ã–zel ÅŸirket',0),(104729,2910,'pl','Firma poszczegÃ³lnych',0),(104730,2910,'bg','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(104731,2910,'ur','Ù…Ø®ØµÙˆØµ Ú©Ù…Ù¾Ù†ÛŒ',0),(104732,2910,'sr','ÐžÐ´Ñ€ÐµÑ’ÐµÐ½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(104733,2910,'vi','Cty cá»¥ thá»ƒ',0),(104734,2910,'af','Spesifieke Onderneming',0),(104735,2910,'ro','Specifice companiei',0),(104736,2910,'et','Kindlate ettevÃµtetega',0),(104737,2910,'si','DoloÄeno podjetje',0),(104738,2910,'ba','Khusus perusahaan',0),(104739,2910,'nl','Specifieke bedrijf',0),(104740,2910,'fi','Tiettyyn yritykseen',0),(104741,2910,'no','Bestemt selskap',0),(104742,2910,'da','Specifik virksomhed',0),(104743,2910,'ko','ê´€ë ¨ íšŒì‚¬',0),(104744,2910,'he','×™×™×—×•×“×™×•×ª ×”×—×‘×¨×”',0),(104745,2910,'el','Î£Ï…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(104746,2910,'zh','å…·ä½“çš„å…¬å¸\r\n',0),(104747,2910,'sv','Specifika fÃ¶retag',0),(104748,2910,'it','Specifica azienda',0),(104749,2910,'tl','',0),(104750,2910,'th','&#3619;&#3632;&#3610;&#3640;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(104751,2910,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤•à¤‚à¤ªà¤¨à¥€',0),(104752,2910,'ms','Syarikat khusus',0),(104753,2910,'ar','Ø§Ù„Ø®Ø§ØµØ© Ø¨Ø§Ù„Ø´Ø±ÙƒØ©',0),(104754,2910,'fr','SociÃ©tÃ© spÃ©cifique',0),(104755,2910,'jp','ç‰¹å®šã?®ä¼šç¤¾',0),(104756,2910,'pt','Empresa especÃ­fica',0),(104757,2910,'ru','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ð°Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(104758,2910,'es','Empresa EspecÃ­fica',0),(104759,2910,'de','Spezifische Unternehmen',0),(104760,2910,'en','Specific Company',0),(104761,2911,'is','',0),(104762,2911,'dr','(ÙˆÙŠÚ˜Ù‡) Ù„ÛŒØ¬Ø±',0),(104763,2911,'pr','Ø­Ø³Ø§Ø¨ Ø«Ø§Ø¨Øª(ÙˆÙŠÚ˜Ù‡) Ø¯ÙØªØ± ÙƒÙ„',0),(104764,2911,'tr','Ã–zel genel muhasebe hesabÄ±',0),(104765,2911,'pl','Konto ksiÄ™gowe dotyczÄ…ce ogÃ³lnego',0),(104766,2911,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ð¸ Ð¾Ð±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(104767,2911,'ur','Ù…Ø®ØµÙˆØµ Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(104768,2911,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ðµ ÐºÑšÐ¸Ð³Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(104769,2911,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Cá»¥ Thá»ƒ',0),(104770,2911,'af','Spesifieke Algemene Grootboekrekening',0),(104771,2911,'ro','Specifice General Ledger cont',0),(104772,2911,'et','Spetsiifiline Ã¼ldine pearaamatukonto',0),(104773,2911,'si','SpecifiÄne General Ledger raÄun',0),(104774,2911,'ba','Khusus General Ledger Account',0),(104775,2911,'nl','Specifieke algemene grootboekrekening',0),(104776,2911,'fi','Erityisen yleistÃ¤ kirjanpitotili',0),(104777,2911,'no','Spesifikke generelt finanskonto',0),(104778,2911,'da','Specifikke General finanskonto',0),(104779,2911,'ko','íŠ¹ì • ì¼ë°˜ ì›ìž¥ ê³„ì •',0),(104780,2911,'he','×—×©×‘×•×Ÿ ×¡×¤×¨ ×¨××©×™ ×¡×¤×¦×™×¤×™ ×›×œ×œ×™',0),(104781,2911,'el','Î£Ï…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Î³ÎµÎ½Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î³/Î»',0),(104782,2911,'zh','å…·ä½“çš„æ€»å¸è´¦ç›®\r\n',0),(104783,2911,'sv','SÃ¤rskilda allmÃ¤nna redovisningskonto',0),(104784,2911,'it','Conto di contabilitÃ  generale di specifici',0),(104785,2911,'tl','',0),(104786,2911,'th','&#3619;&#3632;&#3610;&#3640;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(104787,2911,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¤¾',0),(104788,2911,'ms','Akaun Lejar Am tertentu',0),(104789,2911,'ar','Ø­Ø³Ø§Ø¨ Ù…Ø­Ø¯Ù‘Ø¯ Ù…Ù† Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(104790,2911,'fr','Compte du grand livre gÃ©nÃ©ral spÃ©cifique',0),(104791,2911,'jp','ã??ã?Ÿã?„ã?¦ã??ã?ªç·?å‹˜å®šå…ƒå¸³å‹˜å®š',0),(104792,2911,'pt','EspecÃ­ficas do General Ledger conta',0),(104793,2911,'ru','ÐšÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ñ‹Ðµ Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹ Ð±ÑƒÑ…Ð³.',0),(104794,2911,'es','Cuenta de Libro Mayor EspecÃ­fica',0),(104795,2911,'de','Spezifischen allgemeinen Sachkonto',0),(104796,2911,'en','Specific General Ledger Account',0),(104797,2912,'is','',0),(104798,2912,'dr','ØªØ¹ÙŠÙŠÙ† Ù‚ÙŠÙ…Øª  ÙˆØ²Ù† Ø¯Ø± Ù‡Ø± Ø¨Ø³ØªÙ‡ ',0),(104799,2912,'pr','ØªØ¹ÙŠÙŠÙ† Ù‚ÙŠÙ…Øª  ÙˆØ²Ù† Ø¯Ø± Ù‡Ø± Ø¨Ø³ØªÙ‡ ',0),(104800,2912,'tr','Paket maliyet/aÄŸÄ±rlÄ±k belirtin',0),(104801,2912,'pl','OkreÅ›liÄ‡ koszt/waga za pakiet',0),(104802,2912,'bg','ÐŸÐ¾ÑÐ¾Ñ‡ÐµÑ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ/Ñ‚ÐµÐ³Ð»Ð¾ Ð½Ð° Ð¿Ð°ÐºÐµÑ‚',0),(104803,2912,'ur','ÙÛŒ Ù¾ÛŒÚ©Ø¬ Ú©ÛŒ Ù‚ÛŒÙ…Øª/ÙˆØ²Ù† Ú©Ø§ Ø§Ø®ØªØµØ§Øµ Ú©Ø±ÛŒÚº',0),(104804,2912,'sr','ÐžÐ´Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°/Ñ‚ÐµÐ¶Ð¸Ð½Ð° Ð¿Ð¾ Ð¿Ð°ÐºÐµÑ‚Ñƒ',0),(104805,2912,'vi','Chá»‰ di85nh giÃ¡ thÃ nh/trá»ng lÆ°á»£ng tá»«ng bao',0),(104806,2912,'af','Spesifiseer koste/gewig per pakket',0),(104807,2912,'ro','SpecificaÅ£i Cost/greutate per pachet',0),(104808,2912,'et','MÃ¤Ã¤rake kulu/kaal pakendi kohta',0),(104809,2912,'si','Navedite stroÅ¡ek/teÅ¾e na paket',0),(104810,2912,'ba','Menentukan biaya berat per paket',0),(104811,2912,'nl','Kosten/gewicht per pakket opgeven',0),(104812,2912,'fi','MÃ¤Ã¤ritÃ¤ hinta/paino / Paketti',0),(104813,2912,'no','Angi pris/vekt per pakke',0),(104814,2912,'da','Angive omkostninger/vÃ¦gt pr. pakke',0),(104815,2912,'ko','íŒ¨í‚¤ì§€ ë‹¹ ë¹„ìš©/ì¤‘ëŸ‰ ì§€ì •',0),(104816,2912,'he','×œ×¦×™×™×Ÿ ×¢×œ×•×ª/×ž×©×§×œ ×œ××¨×™×–×”',0),(104817,2912,'el','ÎšÎ±Î¸Î¿ÏÎ¯ÏƒÏ„Îµ Ï„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚/Î²Î¬ÏÎ¿Ï‚ Î±Î½Î¬ Ï€Î±ÎºÎ­Ï„Î¿',0),(104818,2912,'zh','æŒ‡å®šæ¯åŒ…çš„æˆæœ¬/é‡é‡\r\n',0),(104819,2912,'sv','Ange kostnaden/vikt per kolli',0),(104820,2912,'it','Specificare il costo/peso per collo',0),(104821,2912,'tl','',0),(104822,2912,'th','&#3619;&#3632;&#3610;&#3640; &#3605;&#3657;&#3609;&#3607;&#3640;&#3609;/&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585; &#3605;&#3656;&#3629;&#3649;&#3614;&#3655;&#3605;&#3648;&#3585;&#3655;&#3592;',0),(104823,2912,'hi','à¤²à¤¾à¤—à¤¤/à¤µà¤œà¤¨ à¤ªà¥ˆà¤•à¥‡à¤œ à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(104824,2912,'ms','Menentukan kos/berat setiap pakej',0),(104825,2912,'ar','ØªØ­Ø¯ÙŠØ¯ ØªÙƒÙ„ÙØ©/Ø§Ù„ÙˆØ²Ù† ÙÙŠ Ø§Ù„Ø¹Ø¨ÙˆØ© Ø§Ù„ÙˆØ§Ø­Ø¯Ø©',0),(104826,2912,'fr','SpÃ©cifier le coÃ»t/poids par colis',0),(104827,2912,'jp','ç‰¹å®šè²»ç”¨/ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸ã?”ã?¨ã?®é‡?ã?•',0),(104828,2912,'pt','Especificar custo/peso por pacote',0),(104829,2912,'ru','Ð£ÐºÐ°Ð¶Ð¸Ñ‚Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ/Ð²ÐµÑ Ð² ÑƒÐ¿Ð°ÐºÐ¾Ð²ÐºÐµ',0),(104830,2912,'es','Especificar Costo/Peso por paquete',0),(104831,2912,'de','Kosten/Gewicht pro Paket angeben',0),(104832,2912,'en','Specify Cost/Weight per&nbsp;package',0),(104833,2913,'is','',0),(104834,2913,'dr','ÙÙˆØª Ù…Ø±Ø¨Ø¹ Ø¯Ø± Ù¾ÙˆØ´Ø´ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ ',0),(104835,2913,'pr','ÙÙˆØª Ù…Ø±Ø¨Ø¹ Ø¯Ø± Ù¾ÙˆØ´Ø´ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ ',0),(104836,2913,'tr','Birim baÅŸÄ±na sq. in kapsamÄ±',0),(104837,2913,'pl','Sq. In. zapotrzebowania na jednostkÄ™',0),(104838,2913,'bg','Sq. Ð¸Ð½Ñ‡Ð° Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(104839,2913,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù…Ø±Ø¨Ø¹ Ú©Ù¹ Ú©ÙˆØ±ÛŒØ¬',0),(104840,2913,'sr','ÐŸÐ¾ÐºÑ€Ð¸Ð²ÐµÐ½Ð¾ÑÑ‚ Ð˜Ð½. ÐºÐ²Ð°Ð´Ñ€Ð°Ñ‚Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(104841,2913,'vi','Sq. Trong pháº¡m vi má»—i Ä‘Æ¡n vá»‹',0),(104842,2913,'af','Sq. in. dekking per eenheid',0),(104843,2913,'ro','Sq. In. Coverage pe unitate',0),(104844,2913,'et','Sq. In. laovarude Ã¼hiku kohta',0),(104845,2913,'si','Sq. noter kritje na enoto',0),(104846,2913,'ba','Sq. In. cakupan per unit',0),(104847,2913,'nl','Sq. In. Coverage per eenheid',0),(104848,2913,'fi','Sq. In. kattavuutta per yksikkÃ¶',0),(104849,2913,'no','Sq. In. Coverage per enhet',0),(104850,2913,'da','Sq. In. Coverage pr. enhed',0),(104851,2913,'ko','ë‹¨ìœ„ ë‹¹ í‰ë°© ì¸ì¹˜ ì ìš©',0),(104852,2913,'he','×›×™×¡×•×™ in. ×ž ×¨ ×œ×›×œ ×™×—×™×“×”',0),(104853,2913,'el','ÎšÎ¬Î»Ï…ÏˆÎ· In. Ï€Î». Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î±',0),(104854,2913,'zh','å¹³æ–¹è‹±å¯¸ã€‚è¦†ç›–çŽ‡æ¯å•ä½\r\n',0),(104855,2913,'sv','Sq. In. Coverage per enhet',0),(104856,2913,'it','Sq. In. Coverage per unitÃ ',0),(104857,2913,'tl','',0),(104858,2913,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3609;&#3636;&#3657;&#3623; &#3611;&#3585;&#3588;&#3621;&#3640;&#3617;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(104859,2913,'hi','à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤— à¤‡à¤‚à¤š à¤•à¤µà¤°à¥‡à¤œ',0),(104860,2913,'ms','Liputan In. meter persegi seunit',0),(104861,2913,'ar','Ù…ÙŠØ¯Ø§Ù† ØªÙ„Ø¨ÙŠØªÙ‡Ø§ØŒ ØªØºØ·ÙŠØ© ÙƒÙ„ ÙˆØ­Ø¯Ø©',0),(104862,2913,'fr','Sq. In. Coverage unitaire',0),(104863,2913,'jp','Sq. In. Coverage per unit',0),(104864,2913,'pt','Sq. In. Coverage por unidade',0),(104865,2913,'ru','ÐŸÐ»Ð¾Ñ‰Ð°Ð´ÑŒ Ð¿Ð¾ÐºÑ€Ñ‹Ñ‚Ð¸Ñ Ð´ÑŽÐ¹Ð¼Ð° Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(104866,2913,'es','Pulgadas Cuadradas Cobertura por Unidad',0),(104867,2913,'de','SQ. In. Coverage pro Einheit',0),(104868,2913,'en','Sq. In. Coverage per unit',0),(104869,2914,'is','',0),(104870,2914,'dr',' Ø´Ù…Ø§Ø±Ù‡ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ ',0),(104871,2914,'pr',' Ø´Ù…Ø§Ø±Ù‡ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ ',0),(104872,2914,'tr','SSN:',0),(104873,2914,'pl','SSN:',0),(104874,2914,'bg','SSN:',0),(104875,2914,'ur','Ø§ÛŒØ³Ø§ÛŒØ³ÛŒÙ†:',0),(104876,2914,'sr','Ð¡Ð¡Ð:',0),(104877,2914,'vi','SSN:',0),(104878,2914,'af','SSN:',0),(104879,2914,'ro','SSN:',0),(104880,2914,'et','SSN:',0),(104881,2914,'si','SSN:',0),(104882,2914,'ba','SSN:',0),(104883,2914,'nl','SSN:',0),(104884,2914,'fi','SSN:',0),(104885,2914,'no','SSN:',0),(104886,2914,'da','SSN:',0),(104887,2914,'ko','SSN:',0),(104888,2914,'he','×ž×¡×¤×¨ ×ª×¢×•×“×ª ×–×”×•×ª:',0),(104889,2914,'el','SSN:',0),(104890,2914,'zh','ç¤¾ä¼šä¿éšœå·ç ',0),(104891,2914,'sv','SSN:',0),(104892,2914,'it','SSN:',0),(104893,2914,'tl','',0),(104894,2914,'th','SSN:',0),(104895,2914,'hi','à¤à¤¸à¤à¤¸à¤à¤¨:',0),(104896,2914,'ms','SSN:',0),(104897,2914,'ar','Ø§Ù„Ø±Ù‚Ù… Ø§Ù„ÙˆØ·Ù†ÙŠ :',0),(104898,2914,'fr','SSN :',0),(104899,2914,'jp','SSN:',0),(104900,2914,'pt','SSN:',0),(104901,2914,'ru','SSN:',0),(104902,2914,'es','SSN:',0),(104903,2914,'de','SSN:',0),(104904,2914,'en','SSN:',0),(104905,2915,'is','',0),(104906,2915,'dr','Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„',0),(104907,2915,'pr','Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„',0),(104908,2915,'tr','Standart GL hesabÄ±',0),(104909,2915,'pl','Konto standardowe GL',0),(104910,2915,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(104911,2915,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(104912,2915,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(104913,2915,'vi','TK sá»• cÃ¡i chuáº©n',0),(104914,2915,'af','Standaard AG Rekening',0),(104915,2915,'ro','Contul standard GL',0),(104916,2915,'et','Standard pearaamatukontole',0),(104917,2915,'si','Standard GL raÄun',0),(104918,2915,'ba','GL standar Account',0),(104919,2915,'nl','Standaard GL Account',0),(104920,2915,'fi','Standard Kirjanpitotilin pÃ¤Ã¤tilin',0),(104921,2915,'no','Standard gi-konto',0),(104922,2915,'da','Standard GL konto',0),(104923,2915,'ko','í‘œì¤€ GL ê³„ì •',0),(104924,2915,'he','×—×©×‘×•×Ÿ ×¨×’×™×œ GL',0),(104925,2915,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Standard Î³/Î»',0),(104926,2915,'zh','æ ‡å‡†æ€»å¸å¸æˆ·\r\n',0),(104927,2915,'sv','Standard GL konto',0),(104928,2915,'it','Conto standard GL',0),(104929,2915,'tl','',0),(104930,2915,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(104931,2915,'hi','à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‡',0),(104932,2915,'ms','Akaun standard GL',0),(104933,2915,'ar','Ø­Ø³Ø§Ø¨ Ù‚ÙŠØ§Ø³ÙŠ Ù…Ù† Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(104934,2915,'fr','Compte GL standard',0),(104935,2915,'jp','æ¨™æº–ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(104936,2915,'pt','Conta padrÃ£o GL',0),(104937,2915,'ru','Ð¡Ñ‡ÐµÑ‚ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ GL',0),(104938,2915,'es','Cuenta LM EstÃ¡ndar',0),(104939,2915,'de','Standard Sako',0),(104940,2915,'en','Standard GL Account',0),(104941,2916,'is','',0),(104942,2916,'dr','S.T. Ø³Ø§Ø¹Ø§Øª ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯ ',0),(104943,2916,'pr','S.T. Ø³Ø§Ø¹Ø§Øª Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(104944,2916,'tr','AltyazÄ±lÄ± saat',0),(104945,2916,'pl','Godziny S.T.',0),(104946,2916,'bg','S.T. Ñ‡Ð°ÑÐ°',0),(104947,2916,'ur','S.T. Ú©Û’ Ø§ÙˆÙ‚Ø§Øª',0),(104948,2916,'sr','Ð Ð°Ð´Ð¸Ð¾ ÑÐ°Ñ‚Ð¸',0),(104949,2916,'vi','Giá» S.T',0),(104950,2916,'af','S.T. Ure',0),(104951,2916,'ro','Serghei ore',0),(104952,2916,'et','S.T. tundi',0),(104953,2916,'si','S.T. ur',0),(104954,2916,'ba','S.T. jam',0),(104955,2916,'nl','S.T. uur',0),(104956,2916,'fi','St tuntia',0),(104957,2916,'no','St timer',0),(104958,2916,'da','St timer',0),(104959,2916,'ko','ìŠ¤ ì‹œê°„',0),(104960,2916,'he','×¢×œ×™×” ×©×¢×•×ª',0),(104961,2916,'el','S.T. ÏŽÏÎµÏ‚',0),(104962,2916,'zh','æ ‡å‡†æ—¶é—´\r\n',0),(104963,2916,'sv','St timmar',0),(104964,2916,'it','S.T. ore',0),(104965,2916,'tl','',0),(104966,2916,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(104967,2916,'hi','à¤ªà¤‚à¤šà¤®à¤¹à¤¾à¤² à¤˜à¤‚à¤Ÿà¥‡',0),(104968,2916,'ms','Jam S.T.',0),(104969,2916,'ar','Ø´Ø§Ø±Ø¹ Ø³Ø§Ø¹Ø©',0),(104970,2916,'fr','S.T. heures',0),(104971,2916,'jp','S.T. Hours',0),(104972,2916,'pt','Horas S.T.',0),(104973,2916,'ru','Ð¡.Ð¢. Ñ‡Ð°ÑÐ¾Ð²',0),(104974,2916,'es','Horas de S.T.',0),(104975,2916,'de','S.T. Stunden',0),(104976,2916,'en','S.T. Hours',0),(104977,2917,'is','',0),(104978,2917,'dr','S.T. Ù…Ø¹Ø§Ø´  ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯ ',0),(104979,2917,'pr','S.T. Ø­Ù‚ÙˆÙ‚  Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(104980,2917,'tr','AltyazÄ±lÄ± Ã¶deme',0),(104981,2917,'pl','S.T. Pay',0),(104982,2917,'bg','S.T. Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(104983,2917,'ur','S.T. ØªÙ†Ø®ÙˆØ§Û',0),(104984,2917,'sr','Ð Ð°Ð´Ð¸Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ',0),(104985,2917,'vi','Tráº£ S.T',0),(104986,2917,'af','S.T. Besoldiging',0),(104987,2917,'ro','Serghei Pay',0),(104988,2917,'et','S.T. tasu',0),(104989,2917,'si','S.T. plaÄati',0),(104990,2917,'ba','Membayar S.T.',0),(104991,2917,'nl','S.T. Pay',0),(104992,2917,'fi','St maksu',0),(104993,2917,'no','St Pay',0),(104994,2917,'da','St lÃ¸n',0),(104995,2917,'ko','ìŠ¤ íŽ˜ì´',0),(104996,2917,'he','×œ×©×œ× ×¢×œ×™×”',0),(104997,2917,'el','S.T. Pay',0),(104998,2917,'zh','æ ‡å‡†æ”¯ä»˜\r\n',0),(104999,2917,'sv','St lÃ¶n',0),(105000,2917,'it','S.T. Pay',0),(105001,2917,'tl','',0),(105002,2917,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(105003,2917,'hi','à¤ªà¤‚à¤šà¤®à¤¹à¤¾à¤² à¤ªà¥‡',0),(105004,2917,'ms','Gaji S.T.',0),(105005,2917,'ar','Ø´Ø§Ø±Ø¹ Ø§Ù„Ø£Ø¬Ø±',0),(105006,2917,'fr','S.T. Pay',0),(105007,2917,'jp','S.T. Pay',0),(105008,2917,'pt','S.T. Pay',0),(105009,2917,'ru','Ð¡.Ð¢. ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ðµ',0),(105010,2917,'es','Pago de S.T.',0),(105011,2917,'de','S.T. Pay',0),(105012,2917,'en','S.T. Pay',0),(105013,2918,'is','',0),(105014,2918,'dr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(105015,2918,'pr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(105016,2918,'tr','Standart biÃ§imlendirme',0),(105017,2918,'pl','Standardowych znacznikÃ³w',0),(105018,2918,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð°',0),(105019,2918,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­',0),(105020,2918,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð·Ð½Ð°ÐºÐµ',0),(105021,2918,'vi','GiÃ¡ cá»™ng thÃªm chuáº©n',0),(105022,2918,'af','Standaard Prysverhogings',0),(105023,2918,'ro','Marcare standard',0),(105024,2918,'et','Standardne mÃ¤rgistuskeel',0),(105025,2918,'si','Standardni oznaÄevalni',0),(105026,2918,'ba','Markup standar',0),(105027,2918,'nl','Standaardcoderingstaal',0),(105028,2918,'fi','Standardi merkintÃ¤kieli',0),(105029,2918,'no','Standard kode',0),(105030,2918,'da','Standard Markup',0),(105031,2918,'ko','í‘œì¤€ íƒœê·¸',0),(105032,2918,'he','×”×¡×™×ž×•×Ÿ ×”×¡×˜× ×“×¨×˜×™×ª',0),(105033,2918,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(105034,2918,'zh','æ ‡å‡†æ ‡è®°\r\n',0),(105035,2918,'sv','Standard Markup',0),(105036,2918,'it','Markup standard',0),(105037,2918,'tl','',0),(105038,2918,'th','&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3585;&#3634;&#3619;&#3586;&#3638;&#3657;&#3609;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(105039,2918,'hi','à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤°à¥à¤•à¤…à¤ª',0),(105040,2918,'ms','Standard penanda',0),(105041,2918,'ar','Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(105042,2918,'fr','Balisage standard',0),(105043,2918,'jp','æ¨™æº–å€¤ä¸Šã?’',0),(105044,2918,'pt','MarcaÃ§Ã£o padrÃ£o',0),(105045,2918,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð°Ñ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ°',0),(105046,2918,'es','Encarecemiento EstÃ¡ndar',0),(105047,2918,'de','Standard-Markup',0),(105048,2918,'en','Standard Markup',0),(105049,2919,'is','',0),(105050,2919,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨ Ø­Ù‚ÙˆÙ‚ ÙˆØ¯Ø³ØªÙ…Ø²Ø¯ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(105051,2919,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨ Ø­Ù‚ÙˆÙ‚ ÙˆØ¯Ø³ØªÙ…Ø²Ø¯ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(105052,2919,'tr','Kurulum standart GL hesaplarÄ± iÃ§in bordro deÄŸil',0),(105053,2919,'pl','GL standardowych kont nie instalacji na liÅ›cie pÅ‚ac',0),(105054,2919,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ GL ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð½Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð° Ð¢Ð Ð—',0),(105055,2919,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ù¾Û’ Ø±ÙˆÙ„ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ø§Ù¾ Ù†ÛÛŒÚº',0),(105056,2919,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð“Ð› Ð½Ð°Ð»Ð¾Ð·Ð¸ Ð½Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº',0),(105057,2919,'vi','ChÆ°a Táº¡o TK Sá»• CÃ¡i Tá»•ng Há»£p Chuáº©n  Cho LÆ°Æ¡ng',0),(105058,2919,'af','Standaard AG Rekeninge Nie Opgestel vir Loonrol',0),(105059,2919,'ro','Standard GL conturi nu instalare pentru salarizare',0),(105060,2919,'et','Standard GL kontosid ei saa Setup palgaarvestuseks',0),(105061,2919,'si','Standard GL raÄunov ne Setup za izplaÄane plaÄe',0),(105062,2919,'ba','GL standar account tidak Setup untuk penggajian',0),(105063,2919,'nl','Standaard GL Accounts Setup niet voor Payroll',0),(105064,2919,'fi','Standard GL tilit Setup Palkanlaskenta',0),(105065,2919,'no','Standard GL kontoer oppsett ikke For lÃ¸nn',0),(105066,2919,'da','Standard GL konti Setup ikke For lÃ¸n',0),(105067,2919,'ko','í‘œì¤€ GL ê³„ì • ê¸‰ì—¬ì— ëŒ€ í•œ ì„¤ì¹˜ í•˜ì§€',0),(105068,2919,'he','×—×©×‘×•× ×•×ª GL ×¨×’×™×œ ×œ× ×”×ª×§× ×” ×¢×‘×•×¨ ×©×›×¨',0),(105069,2919,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ ÏŒÏ‡Î¹ Î¿ÏÎ³Î¬Î½Ï‰ÏƒÎ· Î³Î¹Î± Ï„Î· Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±',0),(105070,2919,'zh','å°šæœªä¸ºè–ªé‡‘è®¾ç½®æ ‡å‡†æ€»å¸å¸æˆ·\r\n',0),(105071,2919,'sv','Standard GL konton Setup inte fÃ¶r lÃ¶ner',0),(105072,2919,'it','GL standard account Setup non per paghe',0),(105073,2919,'tl','',0),(105074,2919,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;&#3610;&#3633;&#3',0),(105075,2919,'hi','à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤ªà¥‡à¤°à¥‹à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¨à¤¹à¥€à¤‚',0),(105076,2919,'ms','Akaun standard GL tidak sediakan bagi gaji',0),(105077,2919,'ar','Ø¹Ø¯Ù… Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª GL Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ù„ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(105078,2919,'fr','Comptes GL standard pas de configuration pour les paie',0),(105079,2919,'jp','çµ¦ä¸Žã?®ã?Ÿã‚?ã?®æ¨™æº–ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?Œè¨­å®šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(105080,2919,'pt','Contas padrÃ£o GL nÃ£o Setup para folha de pagamento',0),(105081,2919,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ GL ÑÑ‡ÐµÑ‚Ð¾Ð² Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð´Ð»Ñ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(105082,2919,'es','Cuentas LM EstÃ¡ndares No Configuradas Para la NÃ³mina',0),(105083,2919,'de','Standard GL Accounts Setup nicht zur Abrechnung',0),(105084,2919,'en','Standard GL Accounts Not Setup For Payroll',0),(105085,2920,'is','',0),(105086,2920,'dr','(Ø³Ø±ÙŠ) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯',0),(105087,2920,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªÙ†Ø¸ÙŠÙ…(Ø³Ø±ÙŠ) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(105088,2920,'tr','Yeni standart biÃ§imlendirme kÃ¼mesi',0),(105089,2920,'pl','Nowy zestaw standardowych znacznikÃ³w',0),(105090,2920,'bg','ÐÐ¾Ð² ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ Ð·Ð° Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ Ð½Ð°Ð±Ð¾Ñ€',0),(105091,2920,'ur','Ù†Ø¦ÛŒ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹',0),(105092,2920,'sr','ÐÐ¾Ð²Ð¸ ÑÐºÑƒÐ¿ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸Ñ… Ð½Ð°Ð·Ð½Ð°ÐºÐµ',0),(105093,2920,'vi','ThÃªm GiÃ¡ cÃ´ng thÃªm chuáº©n',0),(105094,2920,'af','Standaard Prysverhogings Stel Geskep',0),(105095,2920,'ro','Noul Set de marcare Standard',0),(105096,2920,'et','Uus Standard mÃ¤rgistuskeel komplekt',0),(105097,2920,'si','Nov standardni oznaÄevalni nabor',0),(105098,2920,'ba','Set Markup standar baru',0),(105099,2920,'nl','Nieuwe standaardcoderingstaal Set',0),(105100,2920,'fi','Uusi standardi merkintÃ¤kieli joukko',0),(105101,2920,'no','Nytt Standard kode sett',0),(105102,2920,'da','Ny Standard Markup sÃ¦t',0),(105103,2920,'ko','ìƒˆë¡œìš´ í‘œì¤€ íƒœê·¸ ì§‘í•©',0),(105104,2920,'he','×ž×¢×¨×›×ª ×”×¡×™×ž×•×Ÿ ×”×¡×˜× ×“×¨×˜×™×ª ×—×“×©×”',0),(105105,2920,'el','ÎÎ­Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ ÏƒÏÎ½Î¿Î»Î¿',0),(105106,2920,'zh','æ–°å¢žæ ‡å‡†æ ‡è®°é›†\r\n',0),(105107,2920,'sv','Ny Standard Markup uppsÃ¤ttning',0),(105108,2920,'it','Nuovo Set di Markup Standard',0),(105109,2920,'tl','',0),(105110,2920,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3586;&#3638;&#3657;&#3609;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3',0),(105111,2920,'hi','à¤¨à¤ à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ',0),(105112,2920,'ms','Set Standard penanda yang baru',0),(105113,2920,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(105114,2920,'fr','Nouveau balisage Standard Set',0),(105115,2920,'jp','æ¨™æº–å€¤ä¸Šã?’è¨­å®šã?®è¿½åŠ ',0),(105116,2920,'pt','Novo conjunto de marcaÃ§Ã£o padrÃ£o',0),(105117,2920,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð½Ð°Ð±Ð¾Ñ€ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(105118,2920,'es','Agregar Juego EstÃ¡ndar de Encarecimiento',0),(105119,2920,'de','Neue Standard-Markup-Set',0),(105120,2920,'en','New Standard Markup Set',0),(105121,2921,'is','',0),(105122,2921,'dr','(Ø³Ø±ÙŠ) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯ Ø¨Ø§ Ø§ÙŠÙ† ØªÙØµÛŒÙ„  Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(105123,2921,'pr','ØªÙ†Ø¸ÙŠÙ…(Ø³Ø±ÙŠ) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø§ Ø§ÙŠÙ† Ø´Ø±Ø­ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(105124,2921,'tr','Standart biÃ§imlendirme kÃ¼me bu tarife ile zaten',0),(105125,2921,'pl','Standardowy zestaw znacznikÃ³w juÅ¼ z tego opisu',0),(105126,2921,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸Ñ‚Ðµ Markup Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ñ Ñ‚Ð¾Ð²Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(105127,2921,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ù¾ÛÙ„Û’ ÛÛŒ Ø§Ø³ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(105128,2921,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½ Ñ˜Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð·Ð½Ð°ÐºÐµ ÑÐ° Ñ‚Ð¾Ð¼ Ð¾Ð¿Ð¸ÑÑƒ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(105129,2921,'vi','GiÃ¡ cÃ´ng thÃªm chuáº©n Ä‘Ã£ cÃ³ vá»›i mÃ´ táº£ nÃ y',0),(105130,2921,'af','Standaard Prysverhogings Stel bestaan alreeds met daardie beskrywing',0),(105131,2921,'ro','Set standard de marcare existÄƒ deja cu aceastÄƒ descriere',0),(105132,2921,'et','Standardne mÃ¤rgistuskeel seada juba olemas et kirjeldus',0),(105133,2921,'si','Standard oznaÄevalni Set Å¾e obstaja s tem opisom',0),(105134,2921,'ba','Standard Markup Set sudah ada dengan deskripsi',0),(105135,2921,'nl','Standard Markup Set bestaat al met deze beschrijving',0),(105136,2921,'fi','Standard Markup Set on jo ettÃ¤ kuvaus',0),(105137,2921,'no','Standard Markup satt finnes allerede med denne beskrivelsen',0),(105138,2921,'da','Standard Markup sÃ¦t findes allerede med denne beskrivelse',0),(105139,2921,'ko','ê·¸ ì„¤ëª…ê³¼ í•¨ê»˜ ì´ë¯¸ í‘œì¤€ íƒœê·¸ ì„¤ì •',0),(105140,2921,'he','×”×’×“×¨ ×¡×™×ž×•×Ÿ ×¨×’×™×œ ×›×‘×¨ ×§×™×™× ×¢× ×”×ª×™××•×¨ ×”×–×”',0),(105141,2921,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ Ï€Î¿Ï… Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Îµ ÏŒÏ„Î¹ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(105142,2921,'zh','æœ‰è¿™ç§æçš„è¿°æ ‡å‡†æ ‡è®°é›†å·²ç»å­˜åœ¨\r\n',0),(105143,2921,'sv','Standard Markup ange finns redan med denna beskrivning',0),(105144,2921,'it','Set standard di Markup esiste giÃ  con tale descrizione',0),(105145,2921,'tl','',0),(105146,2921,'th','&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623; &#3614;&#3619;&#3657;&#',0),(105147,2921,'hi','à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‰à¤¸ à¤µà¤°à¥à¤£à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(105148,2921,'ms','Set penanda Standard telah wujud dengan huraian yang',0),(105149,2921,'ar','ØªØ¹ÙŠÙŠÙ† ØªØ±Ù…ÙŠØ² Ù‚ÙŠØ§Ø³ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„ Ù…Ø¹ Ù‡Ø°Ø§ Ø§Ù„ÙˆØµÙ',0),(105150,2921,'fr','La valeur standard de balisage existe dÃ©jÃ  avec cette description',0),(105151,2921,'jp','ã??ã?®è§£èª¬ã?®æ¨™æº–å€¤ä¸Šã?’è¨­å®šã?¯ã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(105152,2921,'pt','Conjunto padrÃ£o de marcaÃ§Ã£o jÃ¡ existe com essa descriÃ§Ã£o',0),(105153,2921,'ru','Ð¡ Ñ‡Ñ‚Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… Ð½Ð°Ð±Ð¾Ñ€Ð¾Ð² Ð¿Ð¾Ð¼ÐµÑ‚Ð¾Ðº ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(105154,2921,'es','Juego EstÃ¡ndar de Encarecimiento ya existe con esta descripciÃ³n',0),(105155,2921,'de','Standard Markup festgelegt mit dieser Beschreibung ist bereits vorhanden',0),(105156,2921,'en','Standard Markup Set already exists with that description',0),(105157,2922,'is','',0),(105158,2922,'dr','(Ø³Ø±ÙŠ) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯',0),(105159,2922,'pr','Ù„ÙŠØ³Øª ØªÙ†Ø¸ÙŠÙ…(Ø³Ø±ÙŠ) Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(105160,2922,'tr','Standart biÃ§imlendirme listesi',0),(105161,2922,'pl','Lista standardowych znacznikÃ³w',0),(105162,2922,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº',0),(105163,2922,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº ÙÛØ±Ø³Øª',0),(105164,2922,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð° Ð½Ð°ÑÑ‚ÑƒÐ¿ Ð¾Ð´ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸Ñ… Ð½Ð°Ð·Ð½Ð°ÐºÐµ',0),(105165,2922,'vi','Danh sÃ¡ch GiÃ¡ cÃ´ng thÃªm chuáº©n',0),(105166,2922,'af','Standaard Prysverhoging Stel Lyste',0),(105167,2922,'ro','Lista Set marcare standard',0),(105168,2922,'et','Standardne mÃ¤rgistuskeel loendil',0),(105169,2922,'si','Standardni oznaÄevalni seznam',0),(105170,2922,'ba','Daftar Markup standar',0),(105171,2922,'nl','Standaardcoderingstaal setlist',0),(105172,2922,'fi','Standardi merkintÃ¤kieli settilista',0),(105173,2922,'no','Angi standard markeringslisten',0),(105174,2922,'da','Standard Markup sÃ¦tliste',0),(105175,2922,'ko','í‘œì¤€ íƒœê·¸ ì„¸íŠ¸ ë¦¬ìŠ¤íŠ¸',0),(105176,2922,'he','×¨×©×™×ž×ª ×”×©×™×¨×™× ×”×¡×™×ž×•×Ÿ ×”×¡×˜× ×“×¨×˜×™×ª',0),(105177,2922,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(105178,2922,'zh','æ ‡å‡†æ ‡è®°é›†åˆ—è¡¨\r\n',0),(105179,2922,'sv','StÃ¤ll in standard markeringslistan',0),(105180,2922,'it','Elenco Set di Markup standard',0),(105181,2922,'tl','',0),(105182,2922,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(105183,2922,'hi','à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(105184,2922,'ms','Senarai Set Standard penanda',0),(105185,2922,'ar','ØªØ¹ÙŠÙŠÙ† Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(105186,2922,'fr','Liste standard de balisage',0),(105187,2922,'jp','æ¨™æº–å€¤ä¸Šã?’è¨­å®šãƒªã‚¹ãƒˆ',0),(105188,2922,'pt','MarcaÃ§Ã£o padrÃ£o Set List',0),(105189,2922,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(105190,2922,'es','Lista de Juego EstÃ¡ndar de Encarecimiento',0),(105191,2922,'de','Standard-Markup-Set-Liste',0),(105192,2922,'en','Standard Markup Set List',0),(105193,2923,'is','',0),(105194,2923,'dr','(Ø³Ø±ÙŠ)Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯',0),(105195,2923,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙ†Ø¸ÙŠÙ…(Ø³Ø±ÙŠ)Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(105196,2923,'tr','Standart biÃ§imlendirme kÃ¼mesini DÃ¼zenle',0),(105197,2923,'pl','Edycja znacznikÃ³w standardowy zestaw',0),(105198,2923,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð°Ð±Ð¾Ñ€ Ð¾Ñ‚ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸',0),(105199,2923,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(105200,2923,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÑÐºÑƒÐ¿ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸Ñ… Ð½Ð°Ð·Ð½Ð°ÐºÐµ',0),(105201,2923,'vi','Cáº­p Nháº­t Má»©c Cá»™ng ThÃªm Chuáº©n',0),(105202,2923,'af','Standaard Prysverhogings Stel Opdateer',0),(105203,2923,'ro','Editare Set de marcare Standard',0),(105204,2923,'et','Muuta Standard mÃ¤rgistuskeel komplekt',0),(105205,2923,'si','Urejanje Standardni oznaÄevalni Set',0),(105206,2923,'ba','Mengedit Markup standar Set',0),(105207,2923,'nl','Bewerken standaardcoderingstaal Set',0),(105208,2923,'fi','Standardi merkintÃ¤kieli joukon muokkaaminen',0),(105209,2923,'no','Rediger Standard kode sett',0),(105210,2923,'da','Redigere Standard Markup sÃ¦t',0),(105211,2923,'ko','í‘œì¤€ íƒœê·¸ ì§‘í•© íŽ¸ì§‘',0),(105212,2923,'he','×¢×¨×™×›×ª ×¢×¨×›×ª ×”×¡×™×ž×•×Ÿ ×”×¡×˜× ×“×¨×˜×™×ª',0),(105213,2923,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ…Î½ÏŒÎ»Î¿Ï… Ï€ÏÏŒÏ„Ï…Ï€Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(105214,2923,'zh','æ ‡å‡†æ ‡è®°é›†æ›´æ–°\r\n',0),(105215,2923,'sv','Redigera Standard Markup Set',0),(105216,2923,'it','Modificare il Markup Standard Set',0),(105217,2923,'tl','',0),(105218,2923,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(105219,2923,'hi','à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(105220,2923,'ms','Mengedit Set Standard penanda',0),(105221,2923,'ar','ØªØ­Ø±ÙŠØ± Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(105222,2923,'fr','Modifier le balisage Standard Set',0),(105223,2923,'jp','æ¨™æº–å€¤ä¸Šã?’è¨­å®šã?®æ›´æ–°',0),(105224,2923,'pt','Editar conjunto de marcaÃ§Ã£o padrÃ£o',0),(105225,2923,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ð°Ð±Ð¾Ñ€ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(105226,2923,'es','Juego EstÃ¡ndar de Encarecimiento Agregar',0),(105227,2923,'de','Bearbeiten von Standard-Markup-Set',0),(105228,2923,'en','Edit Standard Markup Set',0),(105229,2924,'is','',0),(105230,2924,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(105231,2924,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(105232,2924,'tr','Standart boyut ekleme',0),(105233,2924,'pl','DodaÄ‡ standardowy rozmiar',0),(105234,2924,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(105235,2924,'ur','Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ø³Ø§Ø¦Ø² Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(105236,2924,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ðµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(105237,2924,'vi','ThÃªm Cá»¡ chuáº©n',0),(105238,2924,'af','Skep Standaard Grootte',0),(105239,2924,'ro','Adauga dimensiune standard',0),(105240,2924,'et','Standardformaadiga lisamine',0),(105241,2924,'si','Standardne velikosti dodamo',0),(105242,2924,'ba','Tambahkan ukuran standar',0),(105243,2924,'nl','Standaard grootte toevoegen',0),(105244,2924,'fi','Vakiokoko lisÃ¤Ã¤',0),(105245,2924,'no','Standard stÃ¸rrelse legge',0),(105246,2924,'da','Standard stÃ¸rrelse tilfÃ¸je',0),(105247,2924,'ko','í‘œì¤€ í¬ê¸° ì¶”ê°€',0),(105248,2924,'he','×œ×”×•×¡×™×£ ×‘×’×•×“×œ ×¡×˜× ×“×¨×˜×™',0),(105249,2924,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÎ±Î½Î¿Î½Î¹ÎºÎ¿Ï Î¼ÎµÎ³Î­Î¸Î¿Ï…Ï‚',0),(105250,2924,'zh','æ–°å¢žæ ‡å‡†å°ºå¯¸\r\n',0),(105251,2924,'sv','Standard storlek lÃ¤gga till',0),(105252,2924,'it','Aggiungi dimensione standard',0),(105253,2924,'tl','',0),(105254,2924,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3609;&#3634;&#3604;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(105255,2924,'hi','à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(105256,2924,'ms','Menambah saiz standard',0),(105257,2924,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø¬Ù… Ù‚ÙŠØ§Ø³ÙŠ',0),(105258,2924,'fr','Ajouter taille standard',0),(105259,2924,'jp','æ¨™æº–ã‚µã‚¤ã‚ºã?®è¿½åŠ ',0),(105260,2924,'pt','Adicionar o tamanho padrÃ£o',0),(105261,2924,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð Ð°Ð·Ð¼ÐµÑ€',0),(105262,2924,'es','Agregar TamaÃ±o EstÃ¡ndar',0),(105263,2924,'de','StandardgrÃ¶ÃŸe hinzufÃ¼gen',0),(105264,2924,'en','Standard Size Add',0),(105265,2925,'is','',0),(105266,2925,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(105267,2925,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(105268,2925,'tr','Standart Ã¶lÃ§Ã¼ baÅŸarÄ±yla eklendi.',0),(105269,2925,'pl','Standardowy rozmiar dodane pomyÅ›lnie.',0),(105270,2925,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(105271,2925,'ur','Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ø³Ø§Ø¦Ø² Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(105272,2925,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(105273,2925,'vi','ThÃªm Cá»¡ chuáº©n thÃ nh cÃ´ng',0),(105274,2925,'af','Standaard Grootte suksesvol geskep.',0),(105275,2925,'ro','Dimensiuni standard adÄƒugat cu succes.',0),(105276,2925,'et','Standardformaadiga edukalt lisatud.',0),(105277,2925,'si','Standardne velikosti uspeÅ¡no dodana.',0),(105278,2925,'ba','Ukuran standar ditambahkan berhasil.',0),(105279,2925,'nl','Standaard grootte toegevoegd.',0),(105280,2925,'fi','Vakiokoko lisÃ¤Ã¤minen onnistui.',0),(105281,2925,'no','Standard stÃ¸rrelse lagt.',0),(105282,2925,'da','Standard stÃ¸rrelse tilfÃ¸jet.',0),(105283,2925,'ko','í‘œì¤€ í¬ê¸°ëŠ” ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(105284,2925,'he','×’×•×“×œ ×¡×˜× ×“×¨×˜×™ × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(105285,2925,'el','Î¤Ï…Ï€Î¹ÎºÏŒ Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(105286,2925,'zh','æ ‡å‡†å°ºå¯¸æ·»åŠ æˆåŠŸã€‚\r\n',0),(105287,2925,'sv','Standard storlek lagts.',0),(105288,2925,'it','Dimensioni standard aggiunto con successo.',0),(105289,2925,'tl','',0),(105290,2925,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3609;&#3634;&#3604;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(105291,2925,'hi','à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(105292,2925,'ms','Saiz standard yang berjaya menambah.',0),(105293,2925,'ar','Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(105294,2925,'fr','Taille standard ajoutÃ©e avec succÃ¨s.',0),(105295,2925,'jp','æ¨™æº–ã‚µã‚¤ã‚ºã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(105296,2925,'pt','Tamanho padrÃ£o adicionado com Ãªxito.',0),(105297,2925,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð Ð°Ð·Ð¼ÐµÑ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(105298,2925,'es','TamaÃ±o EstÃ¡ndar agregado exitosamente',0),(105299,2925,'de','Standard-GrÃ¶ÃŸe wurde erfolgreich hinzugefÃ¼gt.',0),(105300,2925,'en','Standard Size added successfully.',0),(105301,2926,'is','',0),(105302,2926,'dr','Ø­Ø°Ù Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(105303,2926,'pr','Ø­Ø°Ù Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(105304,2926,'tr','Standart Ã¶lÃ§Ã¼ baÅŸarÄ±yla silindi.',0),(105305,2926,'pl','Standardowy rozmiar usuniÄ™te pomyÅ›lnie.',0),(105306,2926,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(105307,2926,'ur','Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ø³Ø§Ø¦Ø² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(105308,2926,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(105309,2926,'vi','XÃ³a Cá»¡ chuáº©n thÃ nh cÃ´ng',0),(105310,2926,'af','Standaard Grootte suksesvol geskrap.',0),(105311,2926,'ro','Dimensiuni standard ÅŸters cu succes.',0),(105312,2926,'et','Standardformaadiga edukalt kustutatud.',0),(105313,2926,'si','Standardne velikosti uspeÅ¡no izbrisana.',0),(105314,2926,'ba','Ukuran standar yang berhasil dihapus.',0),(105315,2926,'nl','Standaard grootte met succes verwijderd.',0),(105316,2926,'fi','Vakiokoko poistettu.',0),(105317,2926,'no','Standard stÃ¸rrelse slettet.',0),(105318,2926,'da','Standard stÃ¸rrelse slettet.',0),(105319,2926,'ko','í‘œì¤€ í¬ê¸°ëŠ” ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(105320,2926,'he','×’×•×“×œ ×¡×˜× ×“×¨×˜×™ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(105321,2926,'el','Î¤Ï…Ï€Î¹ÎºÏŒ Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(105322,2926,'zh','æ ‡å‡†å°ºå¯¸å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(105323,2926,'sv','Standard storlek raderades.',0),(105324,2926,'it','Dimensioni standard cancellato con successo.',0),(105325,2926,'tl','',0),(105326,2926,'th','&#3621;&#3610;&#3586;&#3609;&#3634;&#3604;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(105327,2926,'hi','à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(105328,2926,'ms','Saiz standard dihapuskan dengan jayanya.',0),(105329,2926,'ar','Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(105330,2926,'fr','Taille standard supprimÃ©e avec succÃ¨s.',0),(105331,2926,'jp','æ¨™æº–ã‚µã‚¤ã‚ºã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(105332,2926,'pt','Tamanho padrÃ£o excluÃ­do com sucesso.',0),(105333,2926,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð Ð°Ð·Ð¼ÐµÑ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½.',0),(105334,2926,'es','TamaÃ±o EstÃ¡ndar eliminado exitosamente',0),(105335,2926,'de','Standard-GrÃ¶ÃŸe erfolgreich gelÃ¶scht.',0),(105336,2926,'en','Standard Size deleted successfully.',0),(105337,2927,'is','',0),(105338,2927,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(105339,2927,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(105340,2927,'tr','Standart Ã¶lÃ§Ã¼ gÃ¼ncelleÅŸtirme',0),(105341,2927,'pl','Standardowy rozmiar aktualizacji',0),(105342,2927,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ€Ð¸',0),(105343,2927,'ur','Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ø³Ø§Ø¦Ø² Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(105344,2927,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸Ñ… Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð°',0),(105345,2927,'vi','Cáº­p Nháº­t KÃ­ch Cá»¡ Chuáº©n',0),(105346,2927,'af','Standaard Grootte Opdateer',0),(105347,2927,'ro','Dimensiune standard de actualizare',0),(105348,2927,'et','Standardformaadiga Update',0),(105349,2927,'si','Standardne velikosti posodobitev',0),(105350,2927,'ba','Ukuran standar Update',0),(105351,2927,'nl','Standaard grootte Update',0),(105352,2927,'fi','Vakiokoko pÃ¤ivitys',0),(105353,2927,'no','Standard stÃ¸rrelse oppdatering',0),(105354,2927,'da','Standard stÃ¸rrelse opdatering',0),(105355,2927,'ko','í‘œì¤€ í¬ê¸° ì—…ë°ì´íŠ¸',0),(105356,2927,'he','×¢×“×›×•×Ÿ ×‘×’×•×“×œ ×¡×˜× ×“×¨×˜×™',0),(105357,2927,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… ÎºÎ±Î½Î¿Î½Î¹ÎºÎ¿Ï Î¼ÎµÎ³Î­Î¸Î¿Ï…Ï‚',0),(105358,2927,'zh','æ ‡å‡†å°ºå¯¸çš„æ›´æ–°\r\n',0),(105359,2927,'sv','Standard storlek uppdatering',0),(105360,2927,'it','Aggiornamento di dimensioni standard',0),(105361,2927,'tl','',0),(105362,2927,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3609;&#3634;&#3604;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(105363,2927,'hi','à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(105364,2927,'ms','Update saiz standard',0),(105365,2927,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ',0),(105366,2927,'fr','Mise Ã  jour de taille standard',0),(105367,2927,'jp','æ¨™æº–ã‚µã‚¤ã‚ºã?®æ›´æ–°',0),(105368,2927,'pt','AtualizaÃ§Ã£o de tamanho padrÃ£o',0),(105369,2927,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð Ð°Ð·Ð¼ÐµÑ€',0),(105370,2927,'es','TamaÃ±o EstÃ¡ndar Actualizar',0),(105371,2927,'de','StandardgrÃ¶ÃŸe Update',0),(105372,2927,'en','Standard Size Update',0),(105373,2928,'is','',0),(105374,2928,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(105375,2928,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(105376,2928,'tr','Standart Ã¶lÃ§Ã¼ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(105377,2928,'pl','Standardowy rozmiar pomyÅ›lnie zaktualizowana.',0),(105378,2928,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(105379,2928,'ur','Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ø³Ø§Ø¦Ø² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(105380,2928,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(105381,2928,'vi','Cáº­p Nháº­t KÃ­ch Cá»¡ Chuáº©n thÃ nh cÃ´ng',0),(105382,2928,'af','Standaard Grootte suksesvol opdateer.',0),(105383,2928,'ro','Dimensiuni standard actualizat cu succes.',0),(105384,2928,'et','Standardformaadiga vÃ¤rskendamine Ãµnnestus.',0),(105385,2928,'si','Standardne velikosti uspeÅ¡no posodobljena.',0),(105386,2928,'ba','Ukuran standar yang berhasil.',0),(105387,2928,'nl','Standaard grootte bijgewerkt.',0),(105388,2928,'fi','Vakiokoko pÃ¤ivitettiin onnistuneesti.',0),(105389,2928,'no','Standard stÃ¸rrelse oppdatert.',0),(105390,2928,'da','Standard stÃ¸rrelse opdateret.',0),(105391,2928,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” í‘œì¤€ í¬ê¸°.',0),(105392,2928,'he','×’×•×“×œ ×¡×˜× ×“×¨×˜×™ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(105393,2928,'el','Î¤Ï…Ï€Î¹ÎºÏŒ Î¼Î­Î³ÎµÎ¸Î¿Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(105394,2928,'zh','æ ‡å‡†å°ºå¯¸æ›´æ–°æˆåŠŸã€‚\r\n',0),(105395,2928,'sv','Standard storlek uppdaterats.',0),(105396,2928,'it','Dimensioni standard aggiornato con successo.',0),(105397,2928,'tl','',0),(105398,2928,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3609;&#3634;&#3604;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(105399,2928,'hi','à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(105400,2928,'ms','Saiz standard yang berjaya dikemas kini.',0),(105401,2928,'ar','Ø­Ø¬Ù… Ù‚ÙŠØ§Ø³ÙŠ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(105402,2928,'fr','Taille standard mis Ã  jour avec succÃ¨s.',0),(105403,2928,'jp','æ¨™æº–ã‚µã‚¤ã‚ºã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(105404,2928,'pt','Tamanho padrÃ£o atualizado com Ãªxito.',0),(105405,2928,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð Ð°Ð·Ð¼ÐµÑ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½.',0),(105406,2928,'es','TamaÃ±o EstÃ¡ndar actualizado exitosamente',0),(105407,2928,'de','Standard-GrÃ¶ÃŸe erfolgreich aktualisiert.',0),(105408,2928,'en','Standard Size updated successfully.',0),(105409,2929,'is','',0),(105410,2929,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯  Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  Ø¯ÙØªØ± ÙƒÙ„ ',0),(105411,2929,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯  Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  Ø¯ÙØªØ± ÙƒÙ„ ',0),(105412,2929,'tr','<font size=\"4\">Bordro standart GL hesaplarÄ± gÃ¼ncelleÅŸtirmek</font>',0),(105413,2929,'pl','<font size=\"4\">PÅ‚ac standardowych kont GL aktualizowane</font>',0),(105414,2929,'bg','<font size=\"4\">Ð¢Ð Ð— ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½</font>',0),(105415,2929,'ur','<font size=\"4\">Ù¾Û’ Ø±ÙˆÙ„ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ù¾ ÚˆÛŒÙ¹ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³</font>',0),(105416,2929,'sr','<font size=\"4\">ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð“Ð› Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½</font>',0),(105417,2929,'vi','Cáº­p nháº­t TK LÆ°Æ¡ng Chuáº©n Trong Sá»• CÃ¡i Tá»•ng Há»£p',0),(105418,2929,'af','Loonrol Standaard AG Rekeninge opdateer',0),(105419,2929,'ro','<font size=\"4\">Salarizare Standard GL conturi actualizat</font>',0),(105420,2929,'et','<font size=\"4\">Palgaarvestuse GL tavakasutajakontod uuendatud</font>',0),(105421,2929,'si','<font size=\"4\">IzplaÄane plaÄe standardni raÄuni GL posodobljen</font>',0),(105422,2929,'ba','<font size=\"4\">Gaji account GL standar Diperbarui</font>',0),(105423,2929,'nl','<font size=\"4\">Payroll standaard GL Accounts bijgewerkt</font>',0),(105424,2929,'fi','<font size=\"4\">Standard GL palkanlaskentatileillÃ¤ pÃ¤ivitetty</font>',0),(105425,2929,'no','<font size=\"4\">Standard GL lÃ¸nnskontoer oppdatert</font>',0),(105426,2929,'da','<font size=\"4\">Standard GL lÃ¸nkonti opdateret</font>',0),(105427,2929,'ko','<font size=\"4\">ê¸‰ì—¬ í‘œì¤€ GL ê³„ì • ì—…ë°ì´íŠ¸</font>',0),(105428,2929,'he','<font size=\"4\">×—×©×‘×•× ×•×ª GL ×¨×’×™×œ×™× ×”×©×›×¨ ×ž×ª×¢×“×›×Ÿ</font>',0),(105429,2929,'el','<font size=\"4\">Î ÏÏŒÏ„Ï…Ï€Î¿ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·</font>',0),(105430,2929,'zh','å·¥èµ„æ ‡å‡†æ€»å¸å¸æˆ·æ›´æ–°\r\n',0),(105431,2929,'sv','<font size=\"4\">LÃ¶nekonton Standard GL uppdaterad</font>',0),(105432,2929,'it','<font size=\"4\">Libro paga conti GL Standard aggiornato</font>',0),(105433,2929,'tl','',0),(105434,2929,'th','<font size=4>&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#36',0),(105435,2929,'hi','<font size=\"4\">à¤ªà¥‡à¤°à¥‹à¤² à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨</font>',0),(105436,2929,'ms','<font size=\"4\">Akaun GL Standard gaji yang dikemaskini</font>',0),(105437,2929,'ar','<font size=\"4\">ØªØ­Ø¯ÙŠØ« \"Ø­Ø³Ø§Ø¨Ø§Øª\" Ø§Ù„Ø±ÙˆØ§ØªØ¨ GL Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©</font>',0),(105438,2929,'fr','<font size=\"4\">Mise Ã  jour des comptes GL Standard de salaires</font>',0),(105439,2929,'jp','<font size=4>çµ¦ä¸Žæ¨™æº–ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(105440,2929,'pt','<font size=\"4\">Folha de pagamento, contas padrÃ£o GL atualizado</font>',0),(105441,2929,'ru','<font size=\"4\">Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ GL ÑÑ‡ÐµÑ‚Ð¾Ð² Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ</font>',0),(105442,2929,'es','<font size=4>NÃ³mina Cuentas de LM EstÃ¡ndar actualizadas',0),(105443,2929,'de','<font size=\"4\">Standard GL Lohnkonten aktualisiert</font>',0),(105444,2929,'en','<font size=4>Payroll Standard GL Accounts updated',0),(105445,2930,'is','',0),(105446,2930,'dr','.Ø¢Ù†Ù‡Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯ÙƒØ§Ø± Ù¾Ø± Ù…ÙŠ Ø´ÙˆÙ†Ø¯',0),(105447,2930,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø³ØªØ§Ø±Ù‡ Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù„Ø§Ø²Ù… Ù†ÙŠØ³ØªÙ†Ø¯ .Ø¢Ù†Ù‡Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯ÙƒØ§Ø± Ù¾Ø± Ù…ÙŠ Ø´ÙˆÙ†Ø¯',0),(105448,2930,'tr','* YÄ±ldÄ±z eklediÄŸiniz girdileri (otomatik doldurma iÃ§inde olacak) stok maddeleri iÃ§in gerekli deÄŸildir.',0),(105449,2930,'pl','* GwiazdkÄ… wpisy nie sÄ… potrzebne dla zapasÃ³w (bÄ™dÄ… one w auto-fill).',0),(105450,2930,'bg','* Ð¤Ñ€Ð°Ð³Ð¼ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ ÑÐ° Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´ (Ñ‚Ðµ Ñ‰Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¿Ð¾Ð¿ÑŠÐ»Ð²Ð°Ð½Ðµ Ð²).',0),(105451,2930,'ur','* Ú©Ø§Ù… Ú©ÛŒØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª (ÙˆÛ Ù…ÛŒÚº Ø®ÙˆØ¯ Ø¨Ú¾Ø±ÛŒÚº Ú¯Û’) Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ù„Ø¦Û’ Ø¶Ø±ÙˆØ±Øª Ù†ÛÛŒÚº ÛÛ’ Û”',0),(105452,2930,'sr','* Ð¡Ð»Ð°Ð²Ð½Ð¸Ð¼ ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð¸ÑÑƒ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ñƒ Ð—ÐÐ›Ð˜Ð¥ÐÐœÐ (Ð¾Ð½Ð¸ Ñ›Ðµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ñƒ).',0),(105453,2930,'vi','* Nháº­p cÃ³ Ä‘Ã¡nh dáº¥u sao khÃ´ng cáº§n cho HÃ ng kho (HÃ ng sáº½ tá»± Ä‘iá»n vÃ o)',0),(105454,2930,'af','* Gesterde inskrywings word Nie benodig vir INVENTARIS items (hul sal outomaties invul).',0),(105455,2930,'ro','* A jucat intrÄƒri nu sunt necesare pentru obiecte de inventar (se va auto-umplere Ã®n).',0),(105456,2930,'et','* TÃ¤rniga kanded on vaja (need on auto-tÃ¤itke) laokaupade puhul.',0),(105457,2930,'si','* Zvezdico postavke niso potrebni za artikle v zalogi (bodo auto-fill v).',0),(105458,2930,'ba','* Bintangnya entri tidak diperlukan untuk barang-barang INVENTARIS yang (mereka akan otomatis mengisi di).',0),(105459,2930,'nl','* Ster posten zijn niet nodig voor voorraadartikelen (ze zal auto-invullen).',0),(105460,2930,'fi','* TÃ¤hdellÃ¤ merkityt tapahtumat ei tarvita varastonimikkeille (he jÃ¤lkisÃ¤Ã¤dÃ¶s Automaattinen tÃ¤yttÃ¶).',0),(105461,2930,'no','* Stjernemerkede oppfÃ¸ringer er ikke nÃ¸dvendig for varer pÃ¥ lager (de vil automatisk fylle i).',0),(105462,2930,'da','* Stjernemarkerede poster er ikke nÃ¸dvendig for lagervarer (de vil auto-fyld i).',0),(105463,2930,'ko','* ë³„í‘œ í•­ëª© (ê·¸ë“¤ì€ ê²ƒì—ì„œ ìžë™ ì±„ìš°ê¸°) ìž¬ê³  í•­ëª©ì— ëŒ€ í•œ í•„ìš” í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(105464,2930,'he','* ×¢×¨×›×™ ×”×ž×¡×•×ž× ×™× ×‘×›×•×›×‘×™×ª ××™×Ÿ ×¦×•×¨×š ×¢×‘×•×¨ ×¤×¨×™×˜×™× ×”×ž×œ××™ (×©×›×Ÿ ×œ×ž×œ× ××•×˜×•×ž×˜×™×ª ×‘).',0),(105465,2930,'el','* Î‘ÏƒÏ„Î­ÏÎ¹ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î´ÎµÎ½ Î±Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î·Ï‚ Î‘Î ÎŸÎ“Î¡Î‘Î¦Î‰Î£ (Î¸Î± auto-ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÏƒÏ„Îµ).',0),(105466,2930,'zh','*æ˜Ÿå·æ ‡è®°çš„é¡¹ç›®æ˜¯ä¸éœ€è¦çš„åº“å­˜ç‰©å“ï¼ˆä»–ä»¬ä¼šè‡ªåŠ¨å¡«å†™ï¼‰ã€‚\r\n',0),(105467,2930,'sv','* StjÃ¤rnmÃ¤rkt poster krÃ¤vs inte fÃ¶r lagerartiklar (de kommer fylla i).',0),(105468,2930,'it','* Un ruolo da protagonista le voci non sono necessari per gli oggetti dell\'inventario (che si auto-fill in).',0),(105469,2930,'tl','',0),(105470,2930,'th','* Starred entries are Not needed for INVENTORY items (they will auto-fill in).',0),(105471,2930,'hi','* à¤¤à¤¾à¤°à¤¾à¤‚à¤•à¤¿à¤¤ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® (à¤µà¥‡ à¤‘à¤Ÿà¥‹-à¤­à¤°à¤£ à¤®à¥‡à¤‚ à¤•à¤°à¥‡à¤—à¤¾) à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(105472,2930,'ms','* Berbintang penyertaan tidak diperlukan untuk item inventori (mereka akan mengisi dalam).',0),(105473,2930,'ar','* Ù†Ø¬Ù…Ø© Ø¥Ø¯Ø®Ø§Ù„Ø§Øª ØºÙŠØ± Ù…Ø·Ù„ÙˆØ¨Ø© Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ† (Ø£Ù†Ù‡Ù… Ø³ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª-Ø§Ù„ØªØ¹Ø¨Ø¦Ø© ÙÙŠ).',0),(105474,2930,'fr','* EntrÃ©es favoris ne sont pas nÃ©cessaires pour les articles en stock (ils vont remplir automatiquement dans).',0),(105475,2930,'jp','*æ˜Ÿå?°ã?®å…¥åŠ›ã?¯åœ¨åº«å“?ç›®ã?«å¿…è¦?ã?‚ã‚Šã?¾ã?›ã‚“ï¼ˆè‡ªå‹•çš„ã?«è¨˜å…¥ã?•ã‚Œã?¾ã?™ï¼‰',0),(105476,2930,'pt','* Starred entradas nÃ£o sÃ£o necessÃ¡rios para itens de estoque (eles vÃ£o em preenchimento automÃ¡tico).',0),(105477,2930,'ru','* ÐŸÐ¾Ð¼ÐµÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ Ñ‚Ñ€ÐµÐ±ÑƒÑŽÑ‚ÑÑ Ð´Ð»Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð½Ð¾-ÐœÐÐ¢Ð•Ð Ð˜ÐÐ›Ð¬ÐÐ«Ð¥ Ñ†ÐµÐ½Ð½Ð¾ÑÑ‚ÐµÐ¹ (Ð¾Ð½Ð¸ Ð±ÑƒÐ´ÑƒÑ‚ Ð°Ð²Ñ‚Ð¾ Ð·Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ).',0),(105478,2930,'es','* Entradas estrelladas No se necesita para items de INVENTARIO (ellas se llenan automaticamente)',0),(105479,2930,'de','* Markierte EintrÃ¤ge sind nicht fÃ¼r Lagerartikel erforderlich (sie werden Auto-Fill in).',0),(105480,2930,'en','* Starred entries are Not needed for INVENTORY items (they will auto-fill in).',0),(105481,2931,'is','',0),(105482,2931,'dr','Ø´Ø±ÙˆØ¹ Ù¾Ø±ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ ',0),(105483,2931,'pr','Ø´Ø±ÙˆØ¹ Ù¾Ø±ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ ',0),(105484,2931,'tr','SipariÅŸ doldurma baÅŸlamak',0),(105485,2931,'pl','RozpoczÄ™cie wypeÅ‚niania zamÃ³wienia',0),(105486,2931,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð´Ð° Ð¿Ð¾Ð¿ÑŠÐ»Ð²Ð°Ñ‚Ðµ Ñ€ÐµÐ´',0),(105487,2931,'ur','ØªØ±ØªÛŒØ¨ Ø¨Ú¾Ø±Ù†Û’ Ø´Ø±ÙˆØ¹ Ú©Ø±ÛŒÚº',0),(105488,2931,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(105489,2931,'vi','Báº¯t Ä‘áº©u Ä‘iá»n Ä‘Æ¡n hÃ ng',0),(105490,2931,'af','Begin vul orde',0),(105491,2931,'ro','ÃŽncepe completarea Ordinului',0),(105492,2931,'et','Tellimuse tÃ¤itmisega alustada',0),(105493,2931,'si','ZaÄetek izpolnjevanja nalog',0),(105494,2931,'ba','Mulai mengisi Order',0),(105495,2931,'nl','Beginnen met het vullen van de bestelling',0),(105496,2931,'fi','Alkaa tÃ¤yttÃ¤Ã¤ tilauksen',0),(105497,2931,'no','Begynne Ã¥ fylle ordren',0),(105498,2931,'da','Start fylde rÃ¦kkefÃ¸lge',0),(105499,2931,'ko','ì£¼ë¬¸ ìž‘ì„± ì‹œìž‘',0),(105500,2931,'he','×œ×”×ª×—×™×œ ×œ×ž×œ× ×”×–×ž× ×”',0),(105501,2931,'el','ÎžÎµÎºÎ¹Î½Î®ÏƒÏ„Îµ ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÎ½Î¿Î½Ï„Î±Ï‚ Ï€ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï…',0),(105502,2931,'zh','å¼€å§‹å¡«å……é¡ºåº\r\n',0),(105503,2931,'sv','BÃ¶rja fylla Order',0),(105504,2931,'it','Iniziare il riempimento ordine',0),(105505,2931,'tl','',0),(105506,2931,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(105507,2931,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤­à¤°à¤¨à¥‡ à¤¶à¥à¤°à¥‚',0),(105508,2931,'ms','Mula mengisi perintah',0),(105509,2931,'ar','Ø¨Ø¯Ø¡ Ù…Ù„Ø¡ Ø£Ù…Ø±',0),(105510,2931,'fr','Commencez Ã  remplir l\'ordre',0),(105511,2931,'jp','æ³¨æ–‡è¨˜å…¥ã?®é–‹å§‹',0),(105512,2931,'pt','ComeÃ§ar a encher a ordem',0),(105513,2931,'ru','ÐÐ°Ñ‡Ð°Ñ‚ÑŒ Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ð°',0),(105514,2931,'es','Comenzar Llenar el Orden',0),(105515,2931,'de','FÃ¼llt bestellen',0),(105516,2931,'en','Start Filling Order',0),(105517,2932,'is','',0),(105518,2932,'dr','Ø´Ø±ÙˆØ¹ Ù¾Ø±ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(105519,2932,'pr','Ø´Ø±ÙˆØ¹ Ù¾Ø±ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(105520,2932,'tr','SipariÅŸ numarasÄ± doldurma baÅŸlamak',0),(105521,2932,'pl','RozpoczÄ…Ä‡ numer zamÃ³wienia',0),(105522,2932,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð´Ð° Ð¿Ð¾Ð¿ÑŠÐ»Ð²Ð°Ñ‚Ðµ Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(105523,2932,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ø¨Ú¾Ø±Ù†Û’ Ø´Ø±ÙˆØ¹ Ú©Ø±ÛŒÚº',0),(105524,2932,'sr','Ð‘Ð¸Ñ€Ð¾ .Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµÐ¼ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(105525,2932,'vi','Báº¯t Ä‘áº©u Ä‘iá»n Ä‘Æ¡n hÃ ng sá»‘',0),(105526,2932,'af','Begin vul orde nommer',0),(105527,2932,'ro','ÃŽncepe completarea Ordinului numÄƒrul',0),(105528,2932,'et','Alusta tÃ¤ites tellimuse kood',0),(105529,2932,'si','ZaÄetek toÄenje zaporedno Å¡tevilko',0),(105530,2932,'ba','Mulai mengisi nomor pesanan',0),(105531,2932,'nl','Start vullen ordernummer',0),(105532,2932,'fi','Alkaa tÃ¤yttÃ¤Ã¤ tilauksen numero',0),(105533,2932,'no','Begynne Ã¥ fylle nummer',0),(105534,2932,'da','Start fylde ordrenummer',0),(105535,2932,'ko','ì£¼ë¬¸ ë²ˆí˜¸ë¥¼ ìž‘ì„±ì„ ì‹œìž‘í•©ë‹ˆë‹¤',0),(105536,2932,'he','×œ×”×ª×—×™×œ ×œ×ž×œ× ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(105537,2932,'el','Î‘ÏÏ‡Î¯Î¶Î¿Ï…Î½ Î½Î± Î³ÎµÎ¼Î¯Î¶Î¿Ï…Î½ Ï„Î¿Î½ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(105538,2932,'zh','å¼€å§‹å¡«å……é¡ºåºç¼–å·\r\n',0),(105539,2932,'sv','BÃ¶rja fylla ordernummer',0),(105540,2932,'it','Iniziare a riempire il numero d\'ordine',0),(105541,2932,'tl','',0),(105542,2932,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3619;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(105543,2932,'hi','à¤‘à¤°à¥à¤¡à¤° à¤¨à¤‚à¤¬à¤° à¤­à¤°à¤¨à¤¾ à¤†à¤°à¤‚à¤­',0),(105544,2932,'ms','Mula mengisi nombor pesanan',0),(105545,2932,'ar','Ø¨Ø¯Ø¡ Ù…Ù„Ø¡ Ø¹Ø¯Ø¯ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(105546,2932,'fr','Commencez Ã  remplir le numÃ©ro de commande',0),(105547,2932,'jp','æ³¨æ–‡ç•ªå?·è¨˜å…¥ã?®é–‹å§‹',0),(105548,2932,'pt','ComeÃ§ar a encher o nÃºmero de ordem',0),(105549,2932,'ru','ÐÐ°Ñ‡Ð°Ñ‚ÑŒ Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ð° ÐÐ¾Ð¼ÐµÑ€',0),(105550,2932,'es','NÃºmero de Comenzar Llenar el Orden',0),(105551,2932,'de','FÃ¼llt Bestellnummer',0),(105552,2932,'en','Start Filling Order Number',0),(105553,2933,'is','',0),(105554,2933,'dr','Ù¾Ø± ÙƒØ±Ø¯Ù† Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡ ',0),(105555,2933,'pr','Ù¾Ø± ÙƒØ±Ø¯Ù† Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡ ',0),(105556,2933,'tr','BaÅŸlatan dolgu',0),(105557,2933,'pl','RozpoczÄ™to wypeÅ‚nienie',0),(105558,2933,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð° Ð·Ð°Ð¿ÑŠÐ»Ð²Ð°Ð½Ðµ',0),(105559,2933,'ur','Ø¢ØºØ§Ø² Ø¨Ú¾Ø±ÛŒÚº',0),(105560,2933,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½ÑƒÑ‚Ð° Ð¿Ð¾Ð¿ÑƒÐ½Ðµ',0),(105561,2933,'vi','Báº¯t Äáº§u Ä‘iá»n',0),(105562,2933,'af','Begin vul',0),(105563,2933,'ro','A Ã®nceput sÄƒ umple',0),(105564,2933,'et','Alustatud tÃ¤ide',0),(105565,2933,'si','ZaÄel polnila',0),(105566,2933,'ba','Mengisi dimulai',0),(105567,2933,'nl','Gestarte opvulling',0),(105568,2933,'fi','Alkoi tÃ¤yttÃ¤Ã¤',0),(105569,2933,'no','Startet fyll',0),(105570,2933,'da','Startede fyld',0),(105571,2933,'ko','ì±„ìš°ê¸° ì‹œìž‘ëœ',0),(105572,2933,'he','×ž×™×œ×•×™ ×”×ª×—×™×œ',0),(105573,2933,'el','ÎžÎµÎºÎ¯Î½Î·ÏƒÎµ Î³ÎµÎ¼Î¯ÏƒÎ¼Î±Ï„Î¿Ï‚',0),(105574,2933,'zh','å¼€å§‹å¡«å†™\r\n',0),(105575,2933,'sv','BÃ¶rjade fylla',0),(105576,2933,'it','Riempimento iniziato',0),(105577,2933,'tl','',0),(105578,2933,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3648;&#3605;&#3636;&#3617;',0),(105579,2933,'hi','à¤¶à¥à¤°à¥‚ à¤•à¤° à¤­à¤°à¥‡à¤‚',0),(105580,2933,'ms','Mula mengisi',0),(105581,2933,'ar','Ø¨Ø¯Ø£Øª Ø§Ù„ØªØ¹Ø¨Ø¦Ø©',0),(105582,2933,'fr','Remplissage a commencÃ©',0),(105583,2933,'jp','è¨˜å…¥ã‚’é–‹å§‹ã?—ã?¾ã?—ã?Ÿ',0),(105584,2933,'pt','Comecei a preencher',0),(105585,2933,'ru','ÐÐ°Ñ‡Ð°Ñ‚Ð¾Ðµ Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ',0),(105586,2933,'es','Llenar Comenzado',0),(105587,2933,'de','Running FÃ¼llung',0),(105588,2933,'en','Started Fill',0),(105589,2934,'is','',0),(105590,2934,'dr','(Ø´Ø±ÙˆØ¹',0),(105591,2934,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²Ù‰(Ø´Ø±ÙˆØ¹',0),(105592,2934,'tr','BaÅŸlangÄ±Ã§ miktarÄ±',0),(105593,2934,'pl','PoczÄ…wszy od iloÅ›ci',0),(105594,2934,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(105595,2934,'ur','Ù…Ù‚Ø¯Ø§Ø± Ø´Ø±ÙˆØ¹ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(105596,2934,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(105597,2934,'vi','Sá»‘ lÆ°á»£ng báº¯t Ä‘áº§u',0),(105598,2934,'af','Hoeveelheid begin',0),(105599,2934,'ro','ÃŽncepÃ¢nd cu cantitatea',0),(105600,2934,'et','Alates kogusest',0),(105601,2934,'si','ZaÄetna koliÄina',0),(105602,2934,'ba','Mulai kuantitas',0),(105603,2934,'nl','Hoeveelheid starten',0),(105604,2934,'fi','Alkaen mÃ¤Ã¤rÃ¤',0),(105605,2934,'no','Starter antall',0),(105606,2934,'da','Start mÃ¦ngde',0),(105607,2934,'ko','ì‹œìž‘ ìˆ˜ëŸ‰',0),(105608,2934,'he','×”×—×œ ×›×ž×•×ª',0),(105609,2934,'el','Î‘ÏÏ‡Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(105610,2934,'zh','å¼€å§‹æ•°é‡\r\n',0),(105611,2934,'sv','Start kvantitet',0),(105612,2934,'it','QuantitÃ  di partenza',0),(105613,2934,'tl','',0),(105614,2934,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(105615,2934,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¶à¥à¤°à¥‚',0),(105616,2934,'ms','Bermula dari kuantiti',0),(105617,2934,'ar','Ø§Ø¨ØªØ¯Ø§Ø¡ Ù…Ù† Ø§Ù„ÙƒÙ…ÙŠØ©',0),(105618,2934,'fr','QuantitÃ© de dÃ©part',0),(105619,2934,'jp','é–‹å§‹æ•°é‡?',0),(105620,2934,'pt','Quantidade inicial',0),(105621,2934,'ru','ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(105622,2934,'es','Cantidad de Inicio',0),(105623,2934,'de','Ab Menge',0),(105624,2934,'en','Starting Quantity',0),(105625,2935,'is','',0),(105626,2935,'dr','Ø§Ø³ØªØ§Ù† ',0),(105627,2935,'pr','Ø§Ø³ØªØ§Ù† ',0),(105628,2935,'tr','Stat',0),(105629,2935,'pl','Statystyka',0),(105630,2935,'bg','Stat',0),(105631,2935,'ur','Ø³Ù¹Ø¢Ù¹',0),(105632,2935,'sr','Ð¡Ñ‚Ð°Ñ‚',0),(105633,2935,'vi','Thá»‘ng kÃª',0),(105634,2935,'af','ROM',0),(105635,2935,'ro','Stat',0),(105636,2935,'et','Stat',0),(105637,2935,'si','Stat',0),(105638,2935,'ba','Stat',0),(105639,2935,'nl','Stat',0),(105640,2935,'fi','Stat',0),(105641,2935,'no','Stat',0),(105642,2935,'da','Stat',0),(105643,2935,'ko','í•©ê³„',0),(105644,2935,'he','×¡×˜×˜×™×¡×˜×™×§×”',0),(105645,2935,'el','Stat',0),(105646,2935,'zh','ç»Ÿè®¡\r\n',0),(105647,2935,'sv','Stat',0),(105648,2935,'it','Stat',0),(105649,2935,'tl','',0),(105650,2935,'th','&#3626;&#3606;&#3636;&#3605;&#3636;',0),(105651,2935,'hi','à¤¸à¥à¤Ÿà¥‡à¤Ÿ',0),(105652,2935,'ms','Stat',0),(105653,2935,'ar','Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ø§Ù„Ø£Ø³Ø§Ø³ÙŠ',0),(105654,2935,'fr','Stat',0),(105655,2935,'jp','Stat',0),(105656,2935,'pt','Stat',0),(105657,2935,'ru','Ð¡Ð¢ÐÐ¢',0),(105658,2935,'es','EstadÃ­stica',0),(105659,2935,'de','Stat',0),(105660,2935,'en','Stat',0),(105661,2936,'is','',0),(105662,2936,'dr','Ø§Ø³ØªØ§Ù† ',0),(105663,2936,'pr','Ø§Ø³ØªØ§Ù† ',0),(105664,2936,'tr','Devlet',0),(105665,2936,'pl','PaÅ„stwa',0),(105666,2936,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²Ð°',0),(105667,2936,'ur','Ø­Ø§Ù„Øª',0),(105668,2936,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð°',0),(105669,2936,'vi','Tiá»ƒu bang',0),(105670,2936,'af','Staat (Landsgebied)',0),(105671,2936,'ro','Stat',0),(105672,2936,'et','Maakond',0),(105673,2936,'si','DrÅ¾ava',0),(105674,2936,'ba','Negara',0),(105675,2936,'nl','Staat',0),(105676,2936,'fi','Valtion',0),(105677,2936,'no','Tilstand',0),(105678,2936,'da','Staten',0),(105679,2936,'ko','ìƒíƒœ',0),(105680,2936,'he','×ž×“×™× ×”',0),(105681,2936,'el','ÎšÏÎ¬Ï„Î¿Ï‚',0),(105682,2936,'zh','å›½å·ž\r\n',0),(105683,2936,'sv','Staten',0),(105684,2936,'it','Stato',0),(105685,2936,'tl','',0),(105686,2936,'th','&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(105687,2936,'hi','à¤°à¤¾à¤œà¥à¤¯',0),(105688,2936,'ms','Negeri',0),(105689,2936,'ar','Ø§Ù„ÙˆÙ„Ø§ÙŠØ©',0),(105690,2936,'fr','Ã‰tat',0),(105691,2936,'jp','éƒ½é?“åºœçœŒ',0),(105692,2936,'pt','Estado',0),(105693,2936,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð¾',0),(105694,2936,'es','Estado',0),(105695,2936,'de','Zustand',0),(105696,2936,'en','State',0),(105697,2937,'is','',0),(105698,2937,'dr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†',0),(105699,2937,'pr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†',0),(105700,2937,'tr','Devlet muafiyetler',0),(105701,2937,'pl','Stan wyÅ‚Ä…czenia',0),(105702,2937,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð½Ð¸',0),(105703,2937,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ø§Ø³ØªØ«Ù†Ø§Ø¦ÛŒÚº',0),(105704,2937,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(105705,2937,'vi','Miá»…n trá»« tiá»ƒu bang',0),(105706,2937,'af','Staat (Landsgebied) Vrystellings',0),(105707,2937,'ro','Scutirile de stat',0),(105708,2937,'et','Riiklik vabastused',0),(105709,2937,'si','Stanje izjeme',0),(105710,2937,'ba','Pengecualian negara',0),(105711,2937,'nl','Staat vrijstellingen',0),(105712,2937,'fi','Valtion vapautukset',0),(105713,2937,'no','Statlige unntak',0),(105714,2937,'da','Statslige undtagelser',0),(105715,2937,'ko','ì£¼ ë©´ì œ',0),(105716,2937,'he','×¤×˜×•×¨×™× ×”×ž×“×™× ×”',0),(105717,2937,'el','ÎšÏÎ±Ï„Î¹ÎºÎ­Ï‚ ÎµÎ¾Î±Î¹ÏÎ­ÏƒÎµÎ¹Ï‚',0),(105718,2937,'zh','å›½å®¶è±å…\r\n',0),(105719,2937,'sv','Statliga undantag',0),(105720,2937,'it','Esenzioni statali',0),(105721,2937,'tl','',0),(105722,2937,'th','&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;&#3586;&#3629;&#3591;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(105723,2937,'hi','à¤°à¤¾à¤œà¥ à¤¯ à¤®à¥‡à¤‚ à¤›à¥‚à¤Ÿ',0),(105724,2937,'ms','Pengecualian-pengecualian yang Negeri',0),(105725,2937,'ar','Ø¥Ø¹ÙØ§Ø¡Ø§Øª Ø§Ù„ÙˆÙ„Ø§ÙŠØ©',0),(105726,2937,'fr','Exemptions Ã‰tats',0),(105727,2937,'jp','å·žæŽ§é™¤',0),(105728,2937,'pt','IsenÃ§Ãµes estaduais',0),(105729,2937,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ðµ Ð»ÑŒÐ³Ð¾Ñ‚Ñ‹',0),(105730,2937,'es','Exenciones de Estado',0),(105731,2937,'de','Staatliche Ausnahmen',0),(105732,2937,'en','State Exemptions',0),(105733,2938,'is','',0),(105734,2938,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø§Ø³ØªØ§Ù† ',0),(105735,2938,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø§Ø³ØªØ§Ù† ',0),(105736,2938,'tr','Devlet gelir vergisi',0),(105737,2938,'pl','PaÅ„stwa podatku dochodowego',0),(105738,2938,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð´Ð¾Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(105739,2938,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ø§Ù†Ú©Ù… Ù¹ÛŒÚ©Ø³',0),(105740,2938,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð´Ð¾Ñ…Ð¾Ð´Ð°Ðº',0),(105741,2938,'vi','Thuáº¿ thu nháº­p tiá»ƒu bang',0),(105742,2938,'af','Staat (Landsgebied) Inkomstebelasting',0),(105743,2938,'ro','Stat impozitul pe venit',0),(105744,2938,'et','Tulumaks',0),(105745,2938,'si','Stanje davka na dohodek',0),(105746,2938,'ba','Pajak pendapatan negara',0),(105747,2938,'nl','Staat inkomstenbelasting',0),(105748,2938,'fi','Valtion tulovero',0),(105749,2938,'no','Statlig inntektsskatt',0),(105750,2938,'da','Statslig indkomstskat',0),(105751,2938,'ko','ì£¼ ì†Œë“ì„¸',0),(105752,2938,'he','×ž×¡ ×”×›× ×¡×” ×ž×“×™× ×ª×™',0),(105753,2938,'el','ÎšÏÎ±Ï„Î¹ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï… ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(105754,2938,'zh','å›½å®¶æ‰€å¾—ç¨Ž\r\n',0),(105755,2938,'sv','Statens inkomstskatt',0),(105756,2938,'it','Statali sul reddito',0),(105757,2938,'tl','',0),(105758,2938,'th','&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;&#3586;&#3629;&#3591;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(105759,2938,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤†à¤¯à¤•à¤°',0),(105760,2938,'ms','Cukai pendapatan Negeri',0),(105761,2938,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø© Ù…Ù† Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯Ø®Ù„',0),(105762,2938,'fr','Etat impÃ´t sur le revenu',0),(105763,2938,'jp','å·žæ‰€å¾—ç¨Ž',0),(105764,2938,'pt','Imposto de renda estadual',0),(105765,2938,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ Ð¿Ð¾Ð´Ð¾Ñ…Ð¾Ð´Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(105766,2938,'es','Impuesto Sobre la Renta del Estado',0),(105767,2938,'de','Arbeitslosenversicherung',0),(105768,2938,'en','State Income Tax',0),(105769,2939,'is','',0),(105770,2939,'dr','State Tax',0),(105771,2939,'pr','State Tax',0),(105772,2939,'tr','Devlet vergi',0),(105773,2939,'pl','Podatkowej',0),(105774,2939,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð´Ð°Ð½ÑŠÐº',0),(105775,2939,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ù¹ÛŒÚ©Ø³',0),(105776,2939,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(105777,2939,'vi','Thuáº¿ tiá»ƒu bang',0),(105778,2939,'af','Staat belasting',0),(105779,2939,'ro','Fiscal de stat',0),(105780,2939,'et','Riigi maksu',0),(105781,2939,'si','Stanje davka',0),(105782,2939,'ba','Pajak negara',0),(105783,2939,'nl','Staat belasting',0),(105784,2939,'fi','Osavaltion verotunnuksen',0),(105785,2939,'no','Skattepenger',0),(105786,2939,'da','Statslige skat',0),(105787,2939,'ko','ì£¼ ì„¸',0),(105788,2939,'he','. ×ž×¡ ×”×›× ×¡×”',0),(105789,2939,'el','ÎšÏÎ±Ï„Î¹ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï…',0),(105790,2939,'zh','å›½å®¶ç¨ŽåŠ¡\r\n',0),(105791,2939,'sv','Statlig skatt',0),(105792,2939,'it','Imposte statali',0),(105793,2939,'tl','',0),(105794,2939,'th','&#3616;&#3634;&#3625;&#3637;&#3586;&#3629;&#3591;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(105795,2939,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤•à¤°',0),(105796,2939,'ms','Cukai Negeri',0),(105797,2939,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(105798,2939,'fr','ImpÃ´t provincial',0),(105799,2939,'jp','å·žç¨Ž',0),(105800,2939,'pt','Imposto estadual',0),(105801,2939,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ð°Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð°Ñ',0),(105802,2939,'es','Impuesto Estatal',0),(105803,2939,'de','Staatliche Steuern',0),(105804,2939,'en','State Tax',0),(105805,2940,'is','',0),(105806,2940,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø³ØªØ§Ù† ',0),(105807,2940,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø³ØªØ§Ù† ',0),(105808,2940,'tr','Devlet vergi',0),(105809,2940,'pl','Podatkowej',0),(105810,2940,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð´Ð°Ð½ÑŠÐº',0),(105811,2940,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ù¹ÛŒÚ©Ø³',0),(105812,2940,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(105813,2940,'vi','Thuáº¿ tiá»ƒu bang',0),(105814,2940,'af','Staat belasting',0),(105815,2940,'ro','Fiscal de stat',0),(105816,2940,'et','Riigi maksu',0),(105817,2940,'si','Stanje davka',0),(105818,2940,'ba','Pajak negara',0),(105819,2940,'nl','Staat belasting',0),(105820,2940,'fi','Osavaltion verotunnuksen',0),(105821,2940,'no','Skattepenger',0),(105822,2940,'da','Statslige skat',0),(105823,2940,'ko','ì£¼ ì„¸',0),(105824,2940,'he','. ×ž×¡ ×”×›× ×¡×”',0),(105825,2940,'el','ÎšÏÎ±Ï„Î¹ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï…',0),(105826,2940,'zh','å›½å®¶ç¨ŽåŠ¡\r\n',0),(105827,2940,'sv','Statlig skatt',0),(105828,2940,'it','Imposte statali',0),(105829,2940,'tl','',0),(105830,2940,'th','&#3616;&#3634;&#3625;&#3637;&#3586;&#3629;&#3591;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(105831,2940,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤•à¤°',0),(105832,2940,'ms','Cukai Negeri',0),(105833,2940,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(105834,2940,'fr','ImpÃ´t provincial',0),(105835,2940,'jp','å·žç¨Ž',0),(105836,2940,'pt','Imposto estadual',0),(105837,2940,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ð°Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð°Ñ',0),(105838,2940,'es','Impuesto Estatal',0),(105839,2940,'de','Staatliche Steuern',0),(105840,2940,'en','State Tax',0),(105841,2941,'is','',0),(105842,2941,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§Ø³ØªØ§Ù† ',0),(105843,2941,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§Ø³ØªØ§Ù† ',0),(105844,2941,'tr','Devlet iÅŸsizlik kimliÄŸi',0),(105845,2941,'pl','Stan bezrobocia ID',0),(105846,2941,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ð˜Ð”',0),(105847,2941,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ø´Ù†Ø§Ø®Øª',0),(105848,2941,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚ Ð˜Ð”',0),(105849,2941,'vi','ID tháº¥t nghiá»‡p tiá»ƒu bang',0),(105850,2941,'af','Staat werkloosheid ID',0),(105851,2941,'ro','Stat ÅŸomajului ID',0),(105852,2941,'et','Riigi tÃ¶Ã¶tuse ID',0),(105853,2941,'si','Stanje brezposelnosti ID',0),(105854,2941,'ba','Negara pengangguran ID',0),(105855,2941,'nl','Staat werkloosheid ID',0),(105856,2941,'fi','Valtion tyÃ¶ttÃ¶myyden tunnus',0),(105857,2941,'no','Statlig arbeidsledighet ID',0),(105858,2941,'da','Statslige arbejdslÃ¸shed ID',0),(105859,2941,'ko','ì£¼ ì‹¤ì—… ID',0),(105860,2941,'he','×”×ž×“×™× ×” ×ž×–×”×” ×”××‘×˜×œ×”',0),(105861,2941,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Î½ÎµÏÎ³Î¯Î±Ï‚ ID',0),(105862,2941,'zh','å›½å®¶å¤±ä¸šç¼–å·\r\n\r\n',0),(105863,2941,'sv','Statlig arbetslÃ¶shet-ID',0),(105864,2941,'it','ID dello stato di disoccupazione',0),(105865,2941,'tl','',0),(105866,2941,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3626;&#3616;&#3634;&#3614;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3585;&#3634;&#3619;&#3592;&#3657;&#3634;&#3591;&#3591;&#3634;&#3609;',0),(105867,2941,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ ID',0),(105868,2941,'ms','Negeri ID pengangguran',0),(105869,2941,'ar','Ø­Ø§Ù„Ø© Ø§Ù„Ø¨Ø·Ø§Ù„Ø© Ù…Ø¹Ø±Ù',0),(105870,2941,'fr','Ã‰tat ID de chÃ´mage',0),(105871,2941,'jp','å·žã?®å¤±æ¥­è€…ID',0),(105872,2941,'pt','Estado desemprego ID',0),(105873,2941,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ ID',0),(105874,2941,'es','ID de Desempleo del Estado',0),(105875,2941,'de','Staatliche Arbeitslosigkeit-ID',0),(105876,2941,'en','State Unemployment ID',0),(105877,2942,'is','',0),(105878,2942,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§Ø³ØªØ§Ù† ',0),(105879,2942,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§Ø³ØªØ§Ù† ',0),(105880,2942,'tr','Devlet iÅŸsizlik vergi',0),(105881,2942,'pl','Stan bezrobocia podatku',0),(105882,2942,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ð´Ð°Ð½ÑŠÐº',0),(105883,2942,'ur','ØµÙˆØ¨Ø§Ø¦ÛŒ Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ú©ÛŒ Ø´Ø±Ø­ Ù¹ÛŒÚ©Ø³',0),(105884,2942,'sr','ÐÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚Ð¸ Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(105885,2942,'vi','Thuáº¿ tháº¥t nghiá»‡p tiá»ƒu bang',0),(105886,2942,'af','Staat werkloosheid belasting',0),(105887,2942,'ro','Taxa de stat de ÅŸomaj',0),(105888,2942,'et','TÃ¶Ã¶tuskindlustusmaks ???',0),(105889,2942,'si','Stanje brezposelnosti davka',0),(105890,2942,'ba','Pajak negara pengangguran',0),(105891,2942,'nl','Staat werkloosheid belasting',0),(105892,2942,'fi','Valtion tyÃ¶ttÃ¶myys vero',0),(105893,2942,'no','Statlig arbeidsledighet skatt',0),(105894,2942,'da','Statslige arbejdslÃ¸shed skat',0),(105895,2942,'ko','êµ­ê°€ ì‹¤ì§ ì„¸ê¸ˆ',0),(105896,2942,'he','×”××‘×˜×œ×” ×”×ž×“×™× ×” ×ž×¡',0),(105897,2942,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Î½ÎµÏÎ³Î¯Î±Ï‚',0),(105898,2942,'zh','å›½å®¶å¤±ä¸šç¨Ž\r\n',0),(105899,2942,'sv','Statlig arbetslÃ¶shet skatt',0),(105900,2942,'it','Fiscale dello stato di disoccupazione',0),(105901,2942,'tl','',0),(105902,2942,'th','&#3616;&#3634;&#3625;&#3637;&#3626;&#3616;&#3634;&#3614;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3585;&#3634;&#3619;&#3592;&#3657;&#3634;&#3591;&#3591;&#3634;&#3609;',0),(105903,2942,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(105904,2942,'ms','Pengangguran Negeri cukai',0),(105905,2942,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¨Ø·Ø§Ù„Ø© Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(105906,2942,'fr','Cotisation d\'Ã‰tat',0),(105907,2942,'jp','å·žå¤±æ¥­ä¿?é™ºç¨Ž',0),(105908,2942,'pt','Imposto de desemprego do estado',0),(105909,2942,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ Ð½Ð°Ð»Ð¾Ð³',0),(105910,2942,'es','Impuesto de Desempleo del Estado',0),(105911,2942,'de','Staatliche Arbeitslosigkeit Steuern',0),(105912,2942,'en','State Unemployment Tax',0),(105913,2943,'is','',0),(105914,2943,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§Ø³ØªØ§Ù†',0),(105915,2943,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§Ø³ØªØ§Ù†',0),(105916,2943,'tr','Devlet iÅŸsizlik vergi gideri',0),(105917,2943,'pl','Stan bezrobocia podatku dochodowego',0),(105918,2943,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð½Ð° Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°Ñ‚Ð° Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð°',0),(105919,2943,'ur','Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ú©Û’ Ø±ÛŒØ§Ø³ØªÛŒ Ù¹ÛŒÚ©Ø³ Ø®Ø±Ú†Û’',0),(105920,2943,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚Ð¸ Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(105921,2943,'vi','Chi phÃ­ Thuáº¿ tháº¥t nghiá»‡p tiá»ƒu bang',0),(105922,2943,'af','Staat werkloosheid belasting uitgawe',0),(105923,2943,'ro','Stat ÅŸomajului fiscale cheltuieli',0),(105924,2943,'et','Riigi tÃ¶Ã¶tuse maksukulu',0),(105925,2943,'si','Stanje brezposelnosti odhodek za davek',0),(105926,2943,'ba','Biaya pajak negara pengangguran',0),(105927,2943,'nl','Staat werkloosheid belastinglasten',0),(105928,2943,'fi','Valtion tyÃ¶ttÃ¶myyden ALV-menot',0),(105929,2943,'no','Statlig arbeidsledighet skattekostnad',0),(105930,2943,'da','Statslige arbejdslÃ¸shed skatteudgifter',0),(105931,2943,'ko','êµ­ê°€ ì‹¤ì§ ì„¸ê¸ˆ ë¹„ìš©',0),(105932,2943,'he','×”××‘×˜×œ×” ×”×ž×“×™× ×” ×ž×¡ ×”×•×¦××•×ª',0),(105933,2943,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Î½ÎµÏÎ³Î¯Î±Ï‚ Ï„Î¿ Î­Î¾Î¿Î´Î¿ Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï…',0),(105934,2943,'zh','å›½å®¶å¤±ä¸šæ‰€å¾—ç¨Žè´¹ç”¨\r\n',0),(105935,2943,'sv','Statlig arbetslÃ¶shet skattekostnad',0),(105936,2943,'it','Spese fiscali dello stato di disoccupazione',0),(105937,2943,'tl','',0),(105938,2943,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3616;&#3634;&#3625;&#3637;&#3626;&#3616;&#3634;&#3614;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3585;&#3634;&#3619;&#3592;&#3657;&#3634;&#3591;&#3591;&#3634;&#3',0),(105939,2943,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤µà¥à¤¯à¤¯',0),(105940,2943,'ms','Perbelanjaan cukai pengangguran Negeri',0),(105941,2943,'ar','Ø­Ø³Ø§Ø¨ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¨Ø·Ø§Ù„Ø© Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(105942,2943,'fr','Charge d\'impÃ´t de chÃ´mage Etat',0),(105943,2943,'jp','å·žå¤±æ¥­ä¿?é™ºç¨Žè²»ç”¨',0),(105944,2943,'pt','Despesa de imposto de desemprego do estado',0),(105945,2943,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ Ð¿Ð¾ Ð¿Ð¾Ð´Ð¾Ñ…Ð¾Ð´Ð½Ð¾Ð¼Ñƒ Ð½Ð°Ð»Ð¾Ð³Ñƒ',0),(105946,2943,'es','Gastos del Impuesto de Desempleo del Estado',0),(105947,2943,'de','Staatliche Arbeitslosigkeit Steueraufwand',0),(105948,2943,'en','State Unemployment Tax Expense',0),(105949,2944,'is','',0),(105950,2944,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  Ø§Ø³ØªØ§Ù†',0),(105951,2944,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙƒØ§Ø±ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  Ø§Ø³ØªØ§Ù†',0),(105952,2944,'tr','Devlet iÅŸsizlik vergisi Ã¶denecek',0),(105953,2944,'pl','Stan bezrobocia podatku naleÅ¼nego',0),(105954,2944,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸Ñ Ð´Ð°Ð½ÑŠÐº',0),(105955,2944,'ur','Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ú©Û’ Ø±ÛŒØ§Ø³ØªÛŒ Ù¹ÛŒÚ©Ø³ Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(105956,2944,'sr','ÐŸÐ»Ð°Ñ›Ð°Ñˆ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚Ð¸',0),(105957,2944,'vi','Thuáº¿ Tháº¥t Nghiá»‡p Cá»§a Tiá»ƒu Bang Pháº£i Tráº£',0),(105958,2944,'af','Werkloosheidversekering Betaalbaar',0),(105959,2944,'ro','Stat ÅŸomajului impozitului datorat',0),(105960,2944,'et','Riikliku tÃ¶Ã¶tuskindlustuse maksu tasuma',0),(105961,2944,'si','Stanje brezposelnosti davÄne obveznosti',0),(105962,2944,'ba','Pengangguran negara pajak yang dibayar',0),(105963,2944,'nl','Staat werkloosheid belasting te betalen',0),(105964,2944,'fi','Valtion tyÃ¶ttÃ¶myyden maksettava vero',0),(105965,2944,'no','Betalbar skatt statlig arbeidsledighet',0),(105966,2944,'da','Statslige arbejdslÃ¸shed skat',0),(105967,2944,'ko','êµ­ê°€ ì‹¤ì§ ì„¸ê¸ˆ ì§€ê¸‰',0),(105968,2944,'he','×”××‘×˜×œ×” ×”×ž×“×™× ×” ×ž×¡ ×œ×ª×©×œ×•×',0),(105969,2944,'el','ÎšÎ±Ï„Î±Î²Î»Î·Ï„Î­Î¿Ï‚ Ï†ÏŒÏÎ¿Ï‚ ÎºÏÎ±Ï„Î¹ÎºÏŽÎ½ Î±Î½ÎµÏÎ³Î¯Î±Ï‚',0),(105970,2944,'zh','å›½å®¶åº”ä»˜å¤±ä¸šç¨Ž\r\n',0),(105971,2944,'sv','Statlig arbetslÃ¶shet skatt som skall betalas',0),(105972,2944,'it','Stato di disoccupazione imposta da pagare',0),(105973,2944,'tl','',0),(105974,2944,'th','&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3616;&#3634;&#3625;&#3637;&#3626;&#3616;&#3634;&#3614;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3585;&#3634;&#3619;&#3592;&#3657;&#3634;&#3591;&#3591;&#3634;&#3609;',0),(105975,2944,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¦à¥‡à¤¯',0),(105976,2944,'ms','Pengangguran Negeri cukai yang kena dibayar',0),(105977,2944,'ar','Ø§Ù„Ø¨Ø·Ø§Ù„Ø© Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(105978,2944,'fr','ChÃ´mage Ã‰tat impÃ´t Payable',0),(105979,2944,'jp','å·žå¤±æ¥­ä¿?é™ºç¨Žè²·æŽ›é‡‘',0),(105980,2944,'pt','Desemprego estado imposto a pagar',0),(105981,2944,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(105982,2944,'es','Impuesto de Desempleo del Estado Pagable',0),(105983,2944,'de','Staatliche Arbeitslosigkeit Zahllast',0),(105984,2944,'en','State Unemployment Tax Payable',0),(105985,2945,'is','',0),(105986,2945,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§Ø³ØªØ§Ù† ',0),(105987,2945,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§Ø³ØªØ§Ù† ',0),(105988,2945,'tr','Devlet Ã¼cretler',0),(105989,2945,'pl','PaÅ„stwa wynagrodzenia',0),(105990,2945,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(105991,2945,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ø§Ø¬Ø±Øª',0),(105992,2945,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ðµ Ð¿Ð»Ð°Ñ‚Ðµ',0),(105993,2945,'vi','LÆ°Æ¡ng tiá»ƒu bang',0),(105994,2945,'af','Staat (Landsgebied) Besoldiging',0),(105995,2945,'ro','Stat salarii',0),(105996,2945,'et','Riigi palgad',0),(105997,2945,'si','DrÅ¾avne plaÄe',0),(105998,2945,'ba','Negara upah',0),(105999,2945,'nl','Staat lonen',0),(106000,2945,'fi','Valtion palkat',0),(106001,2945,'no','Statlige lÃ¸nn',0),(106002,2945,'da','Statslige lÃ¸nninger',0),(106003,2945,'ko','ì£¼ ìž„ê¸ˆ',0),(106004,2945,'he','×—×•×‘×•×ª ×”×ž×“×™× ×”',0),(106005,2945,'el','ÎšÏÎ±Ï„Î¹ÎºÎ­Ï‚ Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(106006,2945,'zh','å›½å®¶å·¥èµ„\r\n',0),(106007,2945,'sv','Statliga lÃ¶ner',0),(106008,2945,'it','Stipendi statali',0),(106009,2945,'tl','',0),(106010,2945,'th','&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(106011,2945,'hi','à¤°à¤¾à¤œà¥ à¤¯ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(106012,2945,'ms','Gaji Negeri',0),(106013,2945,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø© Ù„Ù„Ø£Ø¬ÙˆØ±',0),(106014,2945,'fr','Salaires Ã‰tats',0),(106015,2945,'jp','å·žè³ƒé‡‘',0),(106016,2945,'pt','SalÃ¡rio estadual',0),(106017,2945,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ð°Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(106018,2945,'es','Sueldos Estatales',0),(106019,2945,'de','Staatliche LÃ¶hne',0),(106020,2945,'en','State Wages',0),(106021,2946,'is','',0),(106022,2946,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø§Ø²',0),(106023,2946,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø§Ø²',0),(106024,2946,'tr','Deyim',0),(106025,2946,'pl','OÅ›wiadczenie',0),(106026,2946,'bg','Ð”ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ Ð¾Ñ‚',0),(106027,2946,'ur','Ø¨ÛŒØ§Ù† Ø³Û’',0),(106028,2946,'sr','Ð˜Ð·Ð²Ð¾Ð´ Ð¸Ð·',0),(106029,2946,'vi','Sao kÃª tá»«',0),(106030,2946,'af','Staat Vanaf',0),(106031,2946,'ro','DeclaraÅ£ia de la',0),(106032,2946,'et','Avaldus',0),(106033,2946,'si','Izjava iz',0),(106034,2946,'ba','Pernyataan dari',0),(106035,2946,'nl','Verklaring van',0),(106036,2946,'fi','Lausunto',0),(106037,2946,'no','Uttalelse fra',0),(106038,2946,'da','ErklÃ¦ring fra',0),(106039,2946,'ko','ì„±ëª…ì—ì„œ',0),(106040,2946,'he','×”×¦×”×¨×ª',0),(106041,2946,'el','Î”Î®Î»Ï‰ÏƒÎ· Î±Ï€ÏŒ',0),(106042,2946,'zh','å£°æ˜Žæ¥è‡ª\r\n',0),(106043,2946,'sv','Uttalande frÃ¥n',0),(106044,2946,'it','Dichiarazione da',0),(106045,2946,'tl','',0),(106046,2946,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3592;&#3634;&#3585;',0),(106047,2946,'hi','à¤¬à¤¯à¤¾à¤¨ à¤¸à¥‡',0),(106048,2946,'ms','Kenyataan daripada',0),(106049,2946,'ar','Ø¨ÙŠØ§Ù† Ù…Ù†',0),(106050,2946,'fr','DÃ©claration de',0),(106051,2946,'jp','ï½žã?®æ˜Žç´°',0),(106052,2946,'pt','DeclaraÃ§Ã£o de',0),(106053,2946,'ru','Ð’Ñ‹Ð¿Ð¸ÑÐºÐ° Ð˜Ð·',0),(106054,2946,'es','DeclaraciÃ³n De',0),(106055,2946,'de','ErklÃ¤rung von',0),(106056,2946,'en','Statement From',0),(106057,2947,'is','',0),(106058,2947,'dr','Ø¢Ù…Ø§Ø±',0),(106059,2947,'pr','Ø¢Ù…Ø§Ø±',0),(106060,2947,'tr','Ä°statistik',0),(106061,2947,'pl','Statystyki',0),(106062,2947,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(106063,2947,'ur','Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±',0),(106064,2947,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸',0),(106065,2947,'vi','Thá»‘ng kÃª',0),(106066,2947,'af','Statistieke',0),(106067,2947,'ro','Statistici',0),(106068,2947,'et','Statistika',0),(106069,2947,'si','Statistika',0),(106070,2947,'ba','Statistik',0),(106071,2947,'nl','Statistieken',0),(106072,2947,'fi','Tilastot',0),(106073,2947,'no','Statistikk',0),(106074,2947,'da','Statistik',0),(106075,2947,'ko','í†µê³„',0),(106076,2947,'he','×¡×˜×˜×™×¡×˜×™×§×”',0),(106077,2947,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(106078,2947,'zh','ç»Ÿè®¡\r\n',0),(106079,2947,'sv','Statistik',0),(106080,2947,'it','Statistiche',0),(106081,2947,'tl','',0),(106082,2947,'th','&#3626;&#3606;&#3636;&#3605;&#3636;',0),(106083,2947,'hi','à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤•à¥€',0),(106084,2947,'ms','Statistik',0),(106085,2947,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª',0),(106086,2947,'fr','Statistiques',0),(106087,2947,'jp','çµ±è¨ˆ',0),(106088,2947,'pt','EstatÃ­sticas',0),(106089,2947,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(106090,2947,'es','EstadÃ­sticas',0),(106091,2947,'de','Statistik',0),(106092,2947,'en','Statistics',0),(106093,2948,'is','',0),(106094,2948,'dr','ÙˆØ¶Ø¹ÙŠØª ',0),(106095,2948,'pr','ÙˆØ¶Ø¹ÙŠØª ',0),(106096,2948,'tr','Durumu',0),(106097,2948,'pl','Stan',0),(106098,2948,'bg','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(106099,2948,'ur','Ø­Ø§Ù„Øª',0),(106100,2948,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(106101,2948,'vi','TÃ¬nh tráº¡ng',0),(106102,2948,'af','Status',0),(106103,2948,'ro','Statutul',0),(106104,2948,'et','Staatus',0),(106105,2948,'si','Status',0),(106106,2948,'ba','Status',0),(106107,2948,'nl','Status',0),(106108,2948,'fi','Tila',0),(106109,2948,'no','Status',0),(106110,2948,'da','Status',0),(106111,2948,'ko','ìƒíƒœ',0),(106112,2948,'he','×ž×¦×‘',0),(106113,2948,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(106114,2948,'zh','çŠ¶æ€\r\n',0),(106115,2948,'sv','Status',0),(106116,2948,'it','Stato',0),(106117,2948,'tl','',0),(106118,2948,'th','&#3626;&#3606;&#3634;&#3609;&#3632;',0),(106119,2948,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(106120,2948,'ms','Status',0),(106121,2948,'ar','Ø§Ù„Ø­Ø§Ù„Ø©',0),(106122,2948,'fr','Statut',0),(106123,2948,'jp','çŠ¶æ³?',0),(106124,2948,'pt','Status',0),(106125,2948,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(106126,2948,'es','Status',0),(106127,2948,'de','Status',0),(106128,2948,'en','Status',0),(106129,2949,'is','',0),(106130,2949,'dr','Std.Ø±Ù†Ú¯',0),(106131,2949,'pr','Std.Ø±Ù†Ú¯',0),(106132,2949,'tr','Std.Color',0),(106133,2949,'pl','Std.Color',0),(106134,2949,'bg','Std.Color',0),(106135,2949,'ur','Std.Color',0),(106136,2949,'sr','Ð¡Ñ‚Ð´.Ð¦Ð¾Ð»Ð¾Ñ€',0),(106137,2949,'vi','Máº§u chuáº©n',0),(106138,2949,'af','Std. Kleur',0),(106139,2949,'ro','Std.Color',0),(106140,2949,'et','Std.Color',0),(106141,2949,'si','Std.Color',0),(106142,2949,'ba','Std.Color',0),(106143,2949,'nl','Std.Color',0),(106144,2949,'fi','Std.Color',0),(106145,2949,'no','Std.Color',0),(106146,2949,'da','Std.Color',0),(106147,2949,'ko','Std.Color',0),(106148,2949,'he','Std.Color',0),(106149,2949,'el','Std.Color',0),(106150,2949,'zh','æ ‡å‡†è‰²\r\n',0),(106151,2949,'sv','Std.Color',0),(106152,2949,'it','Std.Color',0),(106153,2949,'tl','',0),(106154,2949,'th','&#3626;&#3637;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(106155,2949,'hi','Std.Color',0),(106156,2949,'ms','Std.Color',0),(106157,2949,'ar','Std.Color',0),(106158,2949,'fr','Std.Color',0),(106159,2949,'jp','æ¨™æº–è‰²',0),(106160,2949,'pt','Std.Color',0),(106161,2949,'ru','Std.Color',0),(106162,2949,'es','Color EstÃ¡ndar',0),(106163,2949,'de','Std.Color',0),(106164,2949,'en','Std.Color',0),(106165,2950,'is','',0),(106166,2950,'dr','(Ø³Ù‡Ø§Ù…',0),(106167,2950,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± (Ø³Ù‡Ø§Ù…',0),(106168,2950,'tr','Hisse senedi',0),(106169,2950,'pl','Czas',0),(106170,2950,'bg','Ð¡ÑŠÑÑ‚Ð°Ð²',0),(106171,2950,'ur','Ø§Ø³Ù¹Ø§Ú©',0),(106172,2950,'sr','ÐÐºÑ†Ð¸Ñ˜Ðµ',0),(106173,2950,'vi','HÃ ng tá»“n',0),(106174,2950,'af','Voorraad',0),(106175,2950,'ro','Stoc',0),(106176,2950,'et','Stock',0),(106177,2950,'si','Zalog',0),(106178,2950,'ba','Saham',0),(106179,2950,'nl','Voorraad',0),(106180,2950,'fi','Varastossa',0),(106181,2950,'no','Lager',0),(106182,2950,'da','Stock',0),(106183,2950,'ko','ì£¼ì‹',0),(106184,2950,'he','×ž×œ××™',0),(106185,2950,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(106186,2950,'zh','åº“å­˜\r\n',0),(106187,2950,'sv','Lager',0),(106188,2950,'it','Magazzino',0),(106189,2950,'tl','',0),(106190,2950,'th','&#3626;&#3605;&#3658;&#3629;&#3588;',0),(106191,2950,'hi','à¤¶à¥‡à¤¯à¤°',0),(106192,2950,'ms','Saham',0),(106193,2950,'ar','Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(106194,2950,'fr','Stock',0),(106195,2950,'jp','åœ¨åº«',0),(106196,2950,'pt','Estoque',0),(106197,2950,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ð°Ñ',0),(106198,2950,'es','Stock',0),(106199,2950,'de','Lager',0),(106200,2950,'en','Stock',0),(106201,2951,'is','',0),(106202,2951,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(106203,2951,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(106204,2951,'tr','Stok Ekle',0),(106205,2951,'pl','Czas dodaÄ‡',0),(106206,2951,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(106207,2951,'ur','Ø§Ø³Ù¹Ø§Ú© Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(106208,2951,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(106209,2951,'vi','ThÃªm HÃ ng tá»“n',0),(106210,2951,'af','Voorraad Byvoeg',0),(106211,2951,'ro','AdÄƒugaÅ£i stoc',0),(106212,2951,'et','Stock lisamine',0),(106213,2951,'si','Dodaj parka',0),(106214,2951,'ba','Tambahkan saham',0),(106215,2951,'nl','Voorraad toevoegen',0),(106216,2951,'fi','Varastossa lisÃ¤Ã¤',0),(106217,2951,'no','Lager legge',0),(106218,2951,'da','Stock tilfÃ¸je',0),(106219,2951,'ko','ì‚¬ì§„ ì¶”ê°€',0),(106220,2951,'he','×”×•×¡×£ ×ž×œ××™',0),(106221,2951,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(106222,2951,'zh','åº“å­˜å¢žåŠ \r\n',0),(106223,2951,'sv','LÃ¤gga till lager',0),(106224,2951,'it','Aggiungere brodo',0),(106225,2951,'tl','',0),(106226,2951,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(106227,2951,'hi','à¤¶à¥‡à¤¯à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(106228,2951,'ms','Tambah stok',0),(106229,2951,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø£Ø³Ù‡Ù…',0),(106230,2951,'fr','Stock Ajouter',0),(106231,2951,'jp','åœ¨åº«å“?ã?®è¿½åŠ ',0),(106232,2951,'pt','Adicionar o estoque',0),(106233,2951,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹',0),(106234,2951,'es','Agregar Stock',0),(106235,2951,'de','Aktie hinzufÃ¼gen',0),(106236,2951,'en','Stock Add',0),(106237,2952,'is','',0),(106238,2952,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(106239,2952,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(106240,2952,'tr','Stok baÅŸarÄ±yla eklendi.',0),(106241,2952,'pl','Czas dodanej pomyÅ›lnie.',0),(106242,2952,'bg','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(106243,2952,'ur','Ø§Ø³Ù¹Ø§Ú© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(106244,2952,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(106245,2952,'vi','ThÃªm HÃ ng tá»“n thÃ nh cÃ´ng',0),(106246,2952,'af','Voorraad Suksesvol Bygevoeg',0),(106247,2952,'ro','Stoc adÄƒugat cu succes.',0),(106248,2952,'et','Stock edukalt lisatud.',0),(106249,2952,'si','Stock uspeÅ¡no dodana.',0),(106250,2952,'ba','Saham ditambahkan berhasil.',0),(106251,2952,'nl','Voorraad toegevoegd.',0),(106252,2952,'fi','Kalusto lisÃ¤Ã¤minen onnistui.',0),(106253,2952,'no','Lager lagt.',0),(106254,2952,'da','Stock tilfÃ¸jet.',0),(106255,2952,'ko','ì£¼ì‹ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(106256,2952,'he','×ž× ×™×•×ª × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(106257,2952,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(106258,2952,'zh','åº“å­˜æ·»åŠ æˆåŠŸã€‚\r\n',0),(106259,2952,'sv','Lager lagts.',0),(106260,2952,'it','Brodo aggiunto con successo.',0),(106261,2952,'tl','',0),(106262,2952,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3605;&#3658;&#3629;&#3588;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(106263,2952,'hi','à¤¶à¥‡à¤¯à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(106264,2952,'ms','Saham berjaya menambah.',0),(106265,2952,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­.',0),(106266,2952,'fr','Stock ajoutÃ© avec succÃ¨s.',0),(106267,2952,'jp','åœ¨åº«å“?ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(106268,2952,'pt','Estoque adicionado com Ãªxito.',0),(106269,2952,'ru','Ð—Ð°Ð¿Ð°Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(106270,2952,'es','Stock agregado exitosamente',0),(106271,2952,'de','Lager wurde erfolgreich hinzugefÃ¼gt.',0),(106272,2952,'en','Stock added successfully.',0),(106273,2953,'is','',0),(106274,2953,'dr','Ù„ÙŠØ³Øª Ø±Ù†Ú¯ Ø°Ø®ÙŠØ±Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106275,2953,'pr','Ù„ÙŠØ³Øª Ø±Ù†Ú¯ Ø°Ø®ÙŠØ±Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106276,2953,'tr','Renk stok listesi',0),(106277,2953,'pl','PieÅ„ kolor liÅ›cie',0),(106278,2953,'bg','ÐžÑÐ½Ð¾Ð²ÐµÐ½ Ñ†Ð²ÑÑ‚ ÑÐ¿Ð¸ÑÑŠÐº',0),(106279,2953,'ur','Ø§Ø³Ù¹Ø§Ú© Ø±Ù†Ú¯ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(106280,2953,'sr','Ð›Ð¸ÑÑ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð±Ð¾Ñ˜Ð°',0),(106281,2953,'vi','Danh sÃ¡ch máº§u HÃ ng tá»“n',0),(106282,2953,'af','Voorraad Kleurlys',0),(106283,2953,'ro','Lista stoc Color',0),(106284,2953,'et','Varude loendis',0),(106285,2953,'si','Osnovna barva seznam',0),(106286,2953,'ba','Daftar saham warna',0),(106287,2953,'nl','Lijst voorraad kleur',0),(106288,2953,'fi','Varastossa vÃ¤ri-luettelosta',0),(106289,2953,'no','Lager-listen',0),(106290,2953,'da','Stock farvelisten',0),(106291,2953,'ko','ìž¬ê³  ìƒ‰ìƒ ëª©ë¡',0),(106292,2953,'he','×¨×©×™×ž×ª ×ž×œ××™ ×¦×‘×¢',0),(106293,2953,'el','Î›Î¯ÏƒÏ„Î± Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÏŽÎ¼Î±',0),(106294,2953,'zh','åº“å­˜é¢œè‰²åˆ—è¡¨\r\n',0),(106295,2953,'sv','Lager fÃ¤rg i listan',0),(106296,2953,'it','Elenco dei colori stock',0),(106297,2953,'tl','',0),(106298,2953,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3637;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(106299,2953,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤°à¤‚à¤— à¤¸à¥‚à¤šà¥€',0),(106300,2953,'ms','Senarai stok warna',0),(106301,2953,'ar','Ù‚Ø§Ø¦Ù…Ø© Ù„ÙˆÙ† Ø§Ù„Ø£Ø³Ù‡Ù…',0),(106302,2953,'fr','Liste de stock de couleur',0),(106303,2953,'jp','åœ¨åº«è‰²ãƒªã‚¹ãƒˆ',0),(106304,2953,'pt','Lista de estoque cor',0),(106305,2953,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… Ñ†Ð²ÐµÑ‚Ð¾Ð²',0),(106306,2953,'es','Lista de Colores de Stock',0),(106307,2953,'de','Lager Farbliste',0),(106308,2953,'en','Stock Color List',0),(106309,2954,'is','',0),(106310,2954,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø±Ù†Ú¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(106311,2954,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø±Ù†Ú¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(106312,2954,'tr','Renkler gÃ¼ncelleme baÅŸarÄ±yla stok',0),(106313,2954,'pl','PieÅ„ kolory zaktualizowany pomyÅ›lnie',0),(106314,2954,'bg','Ð¡ÐºÐ»Ð°Ð´ Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(106315,2954,'ur','Ø±Ù†Ú¯ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø³Ù¹Ø§Ú©',0),(106316,2954,'sr','Ð£ÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð¸Ñ‚Ðµ Ð±Ð¾Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(106317,2954,'vi','Cáº­p nháº­t thÃ nh cÃ´ng máº§u tá»“n kho',0),(106318,2954,'af','Voorraad Kleure suksesvol Opdateer',0),(106319,2954,'ro','Stoc culori actualizat cu succes',0),(106320,2954,'et','Stock vÃ¤rvid uuendatud edukalt',0),(106321,2954,'si','UspeÅ¡no Stock barve posodobljen',0),(106322,2954,'ba','Stok warna diperbarui berhasil',0),(106323,2954,'nl','Voorraad kleuren bijgewerkt met succes',0),(106324,2954,'fi','Varastossa vÃ¤rit pÃ¤ivitetty onnistuneesti',0),(106325,2954,'no','Lager farger oppdatert vellykket',0),(106326,2954,'da','Stock farver opdateret med succes',0),(106327,2954,'ko','ì„±ê³µì ìœ¼ë¡œ ìž¬ê³  ìƒ‰ìƒ ì—…ë°ì´íŠ¸',0),(106328,2954,'he','×‘×ž×œ××™ ×‘×¦×‘×¢×™× ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(106329,2954,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Ï‡ÏÏŽÎ¼Î±Ï„Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(106330,2954,'zh','åº“å­˜é¢œè‰²æ›´æ–°æˆåŠŸ\r\n',0),(106331,2954,'sv','Lager fÃ¤rger uppdaterad framgÃ¥ngsrikt',0),(106332,2954,'it','Dipinga colori aggiornato con successo',0),(106333,2954,'tl','',0),(106334,2954,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3637;&#3626;&#3605;&#3658;&#3629;&#3588;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(106335,2954,'hi','à¤°à¤‚à¤— à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¶à¥‡à¤¯à¤°',0),(106336,2954,'ms','Stok warna dikemaskini berjaya',0),(106337,2954,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… \"ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£Ù„ÙˆØ§Ù†\" Ø¨Ù†Ø¬Ø§Ø­',0),(106338,2954,'fr','Stock de couleurs mis Ã  jour avec succÃ¨s',0),(106339,2954,'jp','åœ¨åº«è‰²ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(106340,2954,'pt','Estoque de cores atualizado com sucesso',0),(106341,2954,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ð¹ Ñ†Ð²ÐµÑ‚Ð° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(106342,2954,'es','Colores de Stock Agregado exitosamente',0),(106343,2954,'de','Farben aktualisiert hat erfolgreich',0),(106344,2954,'en','Stock Colors Updated successfully',0),(106345,2955,'is','',0),(106346,2955,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106347,2955,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106348,2955,'tr','Hisse senedi fiyat gÃ¼ncelleÅŸtirme',0),(106349,2955,'pl','PieÅ„ koszt aktualizacji',0),(106350,2955,'bg','Ð‘Ð¾Ñ€ÑÐ¾Ð²Ð° Ñ†ÐµÐ½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(106351,2955,'ur','Ø³Ù¹Ø§Ú© Ù‚ÛŒÙ…Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(106352,2955,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(106353,2955,'vi','Cáº­p nháº­t giÃ¡ thÃ nh hÃ ng tá»“n kho',0),(106354,2955,'af','Voorraad Koste Opdateer',0),(106355,2955,'ro','Update Costa stoc',0),(106356,2955,'et','Varude maksumuse Update',0),(106357,2955,'si','Zalog stroÅ¡kovno posodobitev',0),(106358,2955,'ba','Informasi biaya saham',0),(106359,2955,'nl','Voorraad kosten Update',0),(106360,2955,'fi','Varaston kustannusten pÃ¤ivitys',0),(106361,2955,'no','Lager pris oppdatering',0),(106362,2955,'da','Omkostninger aktieopdatering',0),(106363,2955,'ko','ìž¬ê³  ë¹„ìš©ëœ ì—…ë°ì´íŠ¸',0),(106364,2955,'he','×¢×“×›×•×Ÿ ×¢×œ×•×ª ×ž×œ××™',0),(106365,2955,'el','Î›Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(106366,2955,'zh','åº“å­˜æˆæœ¬æ›´æ–°\r\n',0),(106367,2955,'sv','Lager kostnad uppdatering',0),(106368,2955,'it','Aggiornamento costo magazzino',0),(106369,2955,'tl','',0),(106370,2955,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(106371,2955,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤²à¤¾à¤—à¤¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(106372,2955,'ms','Kemaskini kos stok',0),(106373,2955,'ar','ØªØ­Ø¯ÙŠØ« ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(106374,2955,'fr','Mise Ã  jour de stock coÃ»t',0),(106375,2955,'jp','åœ¨åº«è²»ç”¨ã?®æ›´æ–°',0),(106376,2955,'pt','AtualizaÃ§Ã£o de custo de estoque',0),(106377,2955,'ru','ÐÐºÑ†Ð¸Ð¸ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(106378,2955,'es','Costo de Stock Actualizar',0),(106379,2955,'de','Kosten Bestandsfortschreibung',0),(106380,2955,'en','Stock Cost Update',0),(106381,2956,'is','',0),(106382,2956,'dr','Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106383,2956,'pr','Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106384,2956,'tr','Stok listesi',0),(106385,2956,'pl','Lista magazynowa',0),(106386,2956,'bg','Ð¡Ð¿Ð¸ÑÑŠÐºÑŠÑ‚ Ð·Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚',0),(106387,2956,'ur','Ø³Ù¹Ø§Ú© Ú©ÛŒ ÙÛØ±Ø³Øª',0),(106388,2956,'sr','Ð›Ð°Ð³ÐµÑ€ Ð»Ð¸ÑÑ‚Ð°',0),(106389,2956,'vi','Danh sÃ¡ch HÃ ng tá»“n',0),(106390,2956,'af','Voorraadlys',0),(106391,2956,'ro','Stoc listÄƒ',0),(106392,2956,'et','Nimestik',0),(106393,2956,'si','Seznam izdelkov na zalogi',0),(106394,2956,'ba','Daftar saham',0),(106395,2956,'nl','Voorraad lijst',0),(106396,2956,'fi','Osakeluettelo',0),(106397,2956,'no','Lager liste',0),(106398,2956,'da','Bestanden listen',0),(106399,2956,'ko','ìž¬ê³  ëª©ë¡',0),(106400,2956,'he','×¨×©×™×ž×ª ×ž×œ××™',0),(106401,2956,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿ Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(106402,2956,'zh','åº“å­˜åˆ—è¡¨\r\n',0),(106403,2956,'sv','Lagerlista',0),(106404,2956,'it','Stock List',0),(106405,2956,'tl','',0),(106406,2956,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(106407,2956,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥‚à¤šà¥€',0),(106408,2956,'ms','Senarai stok',0),(106409,2956,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ù‡Ù…',0),(106410,2956,'fr','Liste de stock',0),(106411,2956,'jp','åœ¨åº«å“?ãƒªã‚¹ãƒˆ',0),(106412,2956,'pt','Lista de estoque',0),(106413,2956,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(106414,2956,'es','Lista de Stock',0),(106415,2956,'de','Lagerliste',0),(106416,2956,'en','Stock List',0),(106417,2957,'is','',0),(106418,2957,'dr','Ù†Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106419,2957,'pr','Ù†Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106420,2957,'tr','Stok Ismi',0),(106421,2957,'pl','Nazwa pieÅ„',0),(106422,2957,'bg','ÐžÑÐ½Ð¾Ð²ÐµÐ½ Ð¸Ð¼Ðµ',0),(106423,2957,'ur','Ø§Ø³Ù¹Ø§Ú© Ù†Ø§Ù…',0),(106424,2957,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð¸Ð¼Ðµ',0),(106425,2957,'vi','TÃªn HÃ ng tá»“n',0),(106426,2957,'af','Voorraadnaam',0),(106427,2957,'ro','Numele de stoc',0),(106428,2957,'et','Varude nimi',0),(106429,2957,'si','Zalog ime',0),(106430,2957,'ba','Nama saham',0),(106431,2957,'nl','Voorraad naam',0),(106432,2957,'fi','Varastossa nimi',0),(106433,2957,'no','Lager navn',0),(106434,2957,'da','Stock navn',0),(106435,2957,'ko','ì‚¬ì§„ ì´ë¦„',0),(106436,2957,'he','×©× ×ž× ×™×•×ª',0),(106437,2957,'el','ÎŒÎ½Î¿Î¼Î± Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(106438,2957,'zh','åº“å­˜åç§°\r\n',0),(106439,2957,'sv','Lager namn',0),(106440,2957,'it','Nome magazzino',0),(106441,2957,'tl','',0),(106442,2957,'th','&#3594;&#3639;&#3656;&#3629;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(106443,2957,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤¨à¤¾à¤®',0),(106444,2957,'ms','Kod stok nama',0),(106445,2957,'ar','Ø§Ø³Ù… Ø§Ù„Ø£Ø³Ù‡Ù…',0),(106446,2957,'fr','Nom de stock',0),(106447,2957,'jp','åœ¨åº«å“?å??',0),(106448,2957,'pt','Nome de estoque',0),(106449,2957,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ð¹ Ð¸Ð¼Ñ',0),(106450,2957,'es','Nombre de Stock',0),(106451,2957,'de','Hat Namen',0),(106452,2957,'en','Stock Name',0),(106453,2958,'is','',0),(106454,2958,'dr','Ù…ÙØ§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106455,2958,'pr','Ù…ÙØ§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106456,2958,'tr','Hisse senedi amaÃ§',0),(106457,2958,'pl','PieÅ„ celem',0),(106458,2958,'bg','Ð‘Ð¾Ñ€ÑÐ¾Ð²Ð° Ñ†ÐµÐ»',0),(106459,2958,'ur','Ø§Ø³Ù¹Ø§Ú© Ù…Ù‚ØµØ¯',0),(106460,2958,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ ÑÐ²Ñ€Ñ…Ñƒ',0),(106461,2958,'vi','Má»¥c Ä‘Ã­ch HÃ ng tá»“n',0),(106462,2958,'af','Voorraad doel',0),(106463,2958,'ro','Stoc scop',0),(106464,2958,'et','Varude eesmÃ¤rk',0),(106465,2958,'si','Namen parka',0),(106466,2958,'ba','Tujuan saham',0),(106467,2958,'nl','Voorraad doel',0),(106468,2958,'fi','Varastossa tarkoitus',0),(106469,2958,'no','Lager formÃ¥l',0),(106470,2958,'da','Stock formÃ¥l',0),(106471,2958,'ko','ìž¬ê³  ëª©ì ',0),(106472,2958,'he','×ª×›×œ×™×ª ×ž× ×™×•×ª',0),(106473,2958,'el','Î‘Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÏƒÎºÎ¿Ï€ÏŒ',0),(106474,2958,'zh','åº“å­˜çš„ç›®çš„\r\n',0),(106475,2958,'sv','Stock syfte',0),(106476,2958,'it','Scopo di magazzino',0),(106477,2958,'tl','',0),(106478,2958,'th','&#3623;&#3633;&#3605;&#3606;&#3640;&#3611;&#3619;&#3632;&#3626;&#3591;&#3588;&#3660;&#3586;&#3629;&#3591;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(106479,2958,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤ªà¥à¤°à¤¯à¥‹à¤œà¤¨',0),(106480,2958,'ms','Maksud saham',0),(106481,2958,'ar','Ø§Ù„ØºØ±Ø¶ Ø§Ù„Ø£Ø³Ù‡Ù…',0),(106482,2958,'fr','Fin de stock',0),(106483,2958,'jp','åœ¨åº«ç›®çš„',0),(106484,2958,'pt','Finalidade das aÃ§Ãµes',0),(106485,2958,'ru','Ð¦ÐµÐ»ÑŒ Ñ„Ð¾Ð½Ð´Ð°',0),(106486,2958,'es','PropÃ³sito de Stock',0),(106487,2958,'de','Hat Zweck',0),(106488,2958,'en','Stock Purpose',0),(106489,2959,'is','',0),(106490,2959,'dr','Ù†ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106491,2959,'pr','Ù†ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106492,2959,'tr','Stok tipi',0),(106493,2959,'pl','Typ',0),(106494,2959,'bg','Ð‘Ð¾Ñ€ÑÐ¾Ð² Ñ‚Ð¸Ð¿',0),(106495,2959,'ur','Ø³Ù¹Ø§Ú© Ú©ÛŒ Ù‚Ø³Ù…',0),(106496,2959,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ñ‚Ð¸Ð¿',0),(106497,2959,'vi','Loáº¡i HÃ ng tá»“n',0),(106498,2959,'af','Voorraadtipe',0),(106499,2959,'ro','Tipul de stoc',0),(106500,2959,'et','Lao tÃ¼Ã¼p',0),(106501,2959,'si','Osnovna vrsta',0),(106502,2959,'ba','Stock jenis',0),(106503,2959,'nl','Voorraad Type',0),(106504,2959,'fi','Varaston laji',0),(106505,2959,'no','Lager Type',0),(106506,2959,'da','Stock Type',0),(106507,2959,'ko','ìŠ¤í†¡ ìœ í˜•',0),(106508,2959,'he','×¡×•×’ ×ž×œ××™',0),(106509,2959,'el','ÎœÎµÏ„Î¿Ï‡ÏŽÎ½ Ï„ÏÏ€Î¿Ï…',0),(106510,2959,'zh','åº“å­˜ç±»åž‹\r\n',0),(106511,2959,'sv','Lager typ',0),(106512,2959,'it','Tipo di magazzino',0),(106513,2959,'tl','',0),(106514,2959,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(106515,2959,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤ªà¥à¤°à¤•à¤¾à¤°',0),(106516,2959,'ms','Jenis saham',0),(106517,2959,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(106518,2959,'fr','Type de stock',0),(106519,2959,'jp','åœ¨åº«å“?ã‚¿ã‚¤ãƒ—',0),(106520,2959,'pt','Tipo de estoque',0),(106521,2959,'ru','Ð¢Ð¸Ð¿ Ð°ÐºÑ†Ð¸Ð¹',0),(106522,2959,'es','Tipo de Stock',0),(106523,2959,'de','Bestandsart',0),(106524,2959,'en','Stock Type',0),(106525,2960,'is','',0),(106526,2960,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106527,2960,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(106528,2960,'tr','Stok birimleri',0),(106529,2960,'pl','PieÅ„ jednostek',0),(106530,2960,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð²Ð¸Ñ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(106531,2960,'ur','Ø§Ø³Ù¹Ø§Ú© ÛŒÙˆÙ†Ù¹Ø³',0),(106532,2960,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(106533,2960,'vi','ÄÆ¡n vá»‹ HÃ ng tá»“n',0),(106534,2960,'af','Voorraadeenhede',0),(106535,2960,'ro','UnitÄƒÅ£ile de stoc',0),(106536,2960,'et','Varude Ã¼hikut',0),(106537,2960,'si','Stock enote',0),(106538,2960,'ba','Unit saham',0),(106539,2960,'nl','Voorraad eenheden',0),(106540,2960,'fi','Varastossa yksikkÃ¶Ã¤',0),(106541,2960,'no','Lager enheter',0),(106542,2960,'da','Lager enheder',0),(106543,2960,'ko','ìž¬ê³  ë‹¨ìœ„',0),(106544,2960,'he','×™×—×™×“×•×ª ×ž×œ××™',0),(106545,2960,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(106546,2960,'zh','åº“å­˜å•ä½ï¼š\r\n',0),(106547,2960,'sv','Aktier',0),(106548,2960,'it','UnitÃ  di magazzino',0),(106549,2960,'tl','',0),(106550,2960,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(106551,2960,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(106552,2960,'ms','Unit-unit saham',0),(106553,2960,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(106554,2960,'fr','UnitÃ©s de stockage',0),(106555,2960,'jp','åœ¨åº«å?˜ä½?',0),(106556,2960,'pt','Unidades de estoque',0),(106557,2960,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ñ‹ Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(106558,2960,'es','Unidades de Stock',0),(106559,2960,'de','Stock Units',0),(106560,2960,'en','Stock Units',0),(106561,2961,'is','',0),(106562,2961,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù… ',0),(106563,2961,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(106564,2961,'tr','Stok gÃ¼ncelleÅŸtirme / alt gruplarÄ± Ekle',0),(106565,2961,'pl','PieÅ„ aktualizacji / Dodawanie podgrup',0),(106566,2961,'bg','Ð¡ÐºÐ»Ð°Ð´ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ / Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð¸',0),(106567,2961,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø§Ø³Ù¹Ø§Ú© / Ø³Ø¨Ú¯Ø±Ø§ÛŒÙ¾Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(106568,2961,'sr','Ð—Ð°Ð»Ð¸Ñ…Ðµ Ð£Ð¿Ð´Ð°Ñ‚Ðµ / ÐÐ´Ð´ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð°',0),(106569,2961,'vi','ThÃªm/Cáº­p Nháº­t NhÃ³m HÃ ng Tá»“n Kho Phá»¥',0),(106570,2961,'af','Voorraad Opdateer /Skep Subgroepe',0),(106571,2961,'ro','Bursa de valori Update / Adauga subgrupe',0),(106572,2961,'et','Varude uuendamine / Add alarÃ¼hmad',0),(106573,2961,'si','StaleÅ¾ modernizirati / Add podskupine',0),(106574,2961,'ba','Saham Update / Add subkumpulan',0),(106575,2961,'nl','Voorraad Update / Add subgroepen',0),(106576,2961,'fi','Varastossa pÃ¤ivitys / lisÃ¤Ã¤ alaryhmÃ¤t',0),(106577,2961,'no','Lager oppdatering / legge undergrupper',0),(106578,2961,'da','Stock opdatering / Add undergrupper',0),(106579,2961,'ko','ìž¬ê³  ì—…ë°ì´íŠ¸/í•˜ìœ„ ê·¸ë£¹ ì¶”ê°€',0),(106580,2961,'he','×‘×ž× ×™×” ×¢×“×›×•×Ÿ / ×”×•×¡×£ ×ª×ª-×§×‘×•×¦×•×ª',0),(106581,2961,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· / Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï…Ï€Î¿Î¿Î¼Î¬Î´ÎµÏ‚',0),(106582,2961,'zh','åº“å­˜æ›´æ–°/æ·»åŠ å­ç¾¤\r\n',0),(106583,2961,'sv','Lager uppdatering / LÃ¤gg till undergrupper',0),(106584,2961,'it','Dipinga aggiornamento / Aggiungi sottogruppi',0),(106585,2961,'tl','',0),(106586,2961,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;/&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3626;&#3605;&#3658;&#3629;&#3588;&#3618;&#3656;&#3629;&#3618;',0),(106587,2961,'hi','à¤¶à¥‡à¤¯à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ / à¤‰à¤ªà¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(106588,2961,'ms','Stok Update / Add subkumpulan',0),(106589,2961,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… ØªØ­Ø¯ÙŠØ«/Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø§Øª ÙØ±Ø¹ÙŠØ©',0),(106590,2961,'fr','Mise Ã  jour de stock / ajouter des sous-groupes',0),(106591,2961,'jp','åœ¨åº«ã?®æ›´æ–°/ã‚µãƒ–ã‚°ãƒ«ãƒ¼ãƒ—ã?®è¿½åŠ ',0),(106592,2961,'pt','AtualizaÃ§Ã£o de estoque / adicionar subgrupos',0),(106593,2961,'ru','Ð¡ÐºÐ»Ð°Ð´ÑÐºÐ¸Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ / Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð¿',0),(106594,2961,'es','Stock Actualizar /Agregar Subgrupos',0),(106595,2961,'de','Stock Update / Add Untergruppen',0),(106596,2961,'en','Stock Update /Add Subgroups',0),(106597,2962,'is','',0),(106598,2962,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(106599,2962,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(106600,2962,'tr','Stok baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(106601,2962,'pl','Czas pomyÅ›lnie zaktualizowana.',0),(106602,2962,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(106603,2962,'ur','Ø§Ø³Ù¹Ø§Ú© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(106604,2962,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(106605,2962,'vi','Cáº­p nháº­t hÃ ng tá»“n kho thÃ nh cÃ´ng',0),(106606,2962,'af','Voorraad suksesvol opdateer',0),(106607,2962,'ro','Stoc actualizat cu succes.',0),(106608,2962,'et','Stock vÃ¤rskendamine Ãµnnestus.',0),(106609,2962,'si','Stock uspeÅ¡no posodobljena.',0),(106610,2962,'ba','Saham diperbarui berhasil.',0),(106611,2962,'nl','Voorraad bijgewerkt.',0),(106612,2962,'fi','Kalusto pÃ¤ivitetty.',0),(106613,2962,'no','Lager oppdatert.',0),(106614,2962,'da','Lager opdateret.',0),(106615,2962,'ko','ìž¬ê³  ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(106616,2962,'he','×”×ž× ×™×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(106617,2962,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(106618,2962,'zh','åº“å­˜æ›´æ–°æˆåŠŸã€‚\r\n',0),(106619,2962,'sv','Lager uppdaterats.',0),(106620,2962,'it','Magazzino aggiornato con successo.',0),(106621,2962,'tl','',0),(106622,2962,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3605;&#3658;&#3629;&#3588;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(106623,2962,'hi','à¤¶à¥‡à¤¯à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(106624,2962,'ms','Saham berjaya dikemas kini.',0),(106625,2962,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¨Ù†Ø¬Ø§Ø­',0),(106626,2962,'fr','Stock mis Ã  jour avec succÃ¨s.',0),(106627,2962,'jp','åœ¨åº«å“?ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(106628,2962,'pt','Estoque atualizado com Ãªxito.',0),(106629,2962,'ru','Ð¡Ñ‚Ð¾Ðº, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(106630,2962,'es','Stock actualizado exitosamente',0),(106631,2962,'de','Lager erfolgreich aktualisiert.',0),(106632,2962,'en','Stock updated successfully.',0),(106633,2963,'is','',0),(106634,2963,'dr','(Ø³Ù‡Ø§Ù…',0),(106635,2963,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± (Ø³Ù‡Ø§Ù…',0),(106636,2963,'tr','Hisse senedi bilgileri',0),(106637,2963,'pl','PieÅ„ szczegÃ³Å‚y',0),(106638,2963,'bg','Ð‘Ð¾Ñ€ÑÐ¾Ð²Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(106639,2963,'ur','Ø³Ù¹Ø§Ú© Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(106640,2963,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(106641,2963,'vi','Chi tiáº¿t HÃ ng tá»“n',0),(106642,2963,'af','Voorraad Details',0),(106643,2963,'ro','Detalii stoc',0),(106644,2963,'et','Varude andmetel',0),(106645,2963,'si','Zalog podrobnosti',0),(106646,2963,'ba','Informasi stok',0),(106647,2963,'nl','Voorraad Details',0),(106648,2963,'fi','Kaluston',0),(106649,2963,'no','Lager detaljer',0),(106650,2963,'da','Stock detaljer',0),(106651,2963,'ko','ì£¼ì‹ ì •ë³´',0),(106652,2963,'he','×ž×œ××™ ×¤×¨×˜×™×',0),(106653,2963,'el','Î‘Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(106654,2963,'zh','åº“å­˜è¯¦ç»†\r\n',0),(106655,2963,'sv','Lager Detaljer',0),(106656,2963,'it','Dettagli magazzino',0),(106657,2963,'tl','',0),(106658,2963,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(106659,2963,'hi','à¤¶à¥‡à¤¯à¤° à¤µà¤¿à¤µà¤°à¤£',0),(106660,2963,'ms','Stok butir-butir',0),(106661,2963,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø£Ø³Ù‡Ù…',0),(106662,2963,'fr','DÃ©tails de stock',0),(106663,2963,'jp','åœ¨åº«å“?',0),(106664,2963,'pt','Detalhes das aÃ§Ãµes',0),(106665,2963,'ru','Ð‘Ð¸Ñ€Ð¶ÐµÐ²Ñ‹Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(106666,2963,'es','Detalles de Stock',0),(106667,2963,'de','Hat Informationen',0),(106668,2963,'en','Stock Details',0),(106669,2964,'is','',0),(106670,2964,'dr','(Ø³Ù‡Ø§Ù…) Ø¯Ø±',0),(106671,2964,'pr','Ø³Ø·Ø­ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± (Ø³Ù‡Ø§Ù…) Ø¯Ø±',0),(106672,2964,'tr','Ã‡orap dÃ¼zeyleri',0),(106673,2964,'pl','Poziomy zapasÃ³w w',0),(106674,2964,'bg','ÐžÑ‚Ð³Ð»ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð¸Ð²Ð° Ð²',0),(106675,2964,'ur','Ø°Ø®ÛŒØ±Û Ú©Ø±Ù†Û’ Ú©ÛŒ Ø³Ø·Ø­ Ù…ÛŒÚº',0),(106676,2964,'sr','ÐŸÑ€Ð¸Ð¿Ñ€ÐµÐ¼Ð¸Ð»Ðµ Ð½Ð¸Ð²Ð¾Ð° Ñƒ',0),(106677,2964,'vi','Má»©c HÃ ng tá»“n trong',0),(106678,2964,'af','Kous vlakke in',0),(106679,2964,'ro','Nivelurile de stocare Ã®n',0),(106680,2964,'et','Loomkoormuse taset',0),(106681,2964,'si','Obremenitve ravni v',0),(106682,2964,'ba','Tingkat stok',0),(106683,2964,'nl','Niveaus in tricotst',0),(106684,2964,'fi','SileÃ¤Ã¤ tasoilla',0),(106685,2964,'no','StrÃ¸mpe nivÃ¥er i',0),(106686,2964,'da','StrÃ¸mpe niveauer i',0),(106687,2964,'ko','ìŠ¤íƒ€í‚¹ ìˆ˜ì¤€',0),(106688,2964,'he','×¨×ž×•×ª ×’×¨×‘',0),(106689,2964,'el','Î•Ï€Î¯Ï€ÎµÎ´Î± Ï„Î¿Ï… Î¶Ï‰Î¹ÎºÎ¿Ï ÎºÎµÏ†Î±Î»Î±Î¯Î¿Ï… ÏƒÏ„Î·Î½',0),(106690,2964,'zh','åº“å­˜æ°´å¹³\r\n',0),(106691,2964,'sv','Strumpa nivÃ¥er i',0),(106692,2964,'it','Livelli di stoccaggio in',0),(106693,2964,'tl','',0),(106694,2964,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3626;&#3605;&#3658;&#3629;&#3588;&#3648;&#3611;&#3655;&#3609;',0),(106695,2964,'hi','à¤®à¥‹à¤œà¤¾ à¤¸à¥à¤¤à¤°à¥‹à¤‚ à¤®à¥‡à¤‚',0),(106696,2964,'ms','Paras stok di',0),(106697,2964,'ar','Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ÙÙŠ',0),(106698,2964,'fr','Bas niveaux dans',0),(106699,2964,'jp','åœ¨åº«ãƒ¬ãƒ™ãƒ«ã?¯',0),(106700,2964,'pt','NÃ­veis de meia em',0),(106701,2964,'ru','Ð Ñ‹Ð½Ð¾Ñ‡Ð½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð²',0),(106702,2964,'es','Niveles de Stock en',0),(106703,2964,'de','Ebenen in glatt',0),(106704,2964,'en','Stocking Levels in',0),(106705,2965,'is','',0),(106706,2965,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†ÙŠØ³Øª ',0),(106707,2965,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†ÙŠØ³Øª ',0),(106708,2965,'tr','stockusageid geÃ§ti',0),(106709,2965,'pl','stockusageid nie przeszÅ‚y',0),(106710,2965,'bg','stockusageid Ð½Ðµ Ðµ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ»',0),(106711,2965,'ur','Ø³Ù¹ÙˆÚ©ÙˆØ³Ú¯ÛŒØ¯ Ù†ÛÛŒÚº Ú¯Ø²Ø±Ø§',0),(106712,2965,'sr','ÑÑ‚Ð¾Ñ†ÐºÑƒÑÐ°Ð³ÐµÐ¸Ð´ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾ÑˆÐ°Ð¾',0),(106713,2965,'vi','ID dÃ¹ng HÃ ng tá»“n chÆ°a qua',0),(106714,2965,'af','vooraadgebruik id nie geslaag',0),(106715,2965,'ro','stockusageid nu a trecut',0),(106716,2965,'et','stockusageid sooritamata',0),(106717,2965,'si','stockusageid ni opravil',0),(106718,2965,'ba','stockusageid tidak lolos',0),(106719,2965,'nl','stockusageid niet worden doorgegeven',0),(106720,2965,'fi','stockusageid ei siirretÃ¤',0),(106721,2965,'no','stockusageid ikke bestÃ¥tt',0),(106722,2965,'da','stockusageid ikke bestÃ¥et',0),(106723,2965,'ko','stockusageid ì „ë‹¬ ë˜ì§€',0),(106724,2965,'he','stockusageid ×œ× ×—×œ×¤×•',0),(106725,2965,'el','stockusageid Ï€Î¿Ï… Î´ÎµÎ½ Ï€Î­ÏÎ±ÏƒÎµ',0),(106726,2965,'zh','åº“å­˜ä½¿ç”¨ç æœªé€šè¿‡\r\n',0),(106727,2965,'sv','stockusageid inte gÃ¥tt',0),(106728,2965,'it','stockusageid non superato',0),(106729,2965,'tl','',0),(106730,2965,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3626;&#3605;&#3658;&#3629;&#3588;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;',0),(106731,2965,'hi','à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤°à¤¿à¤¤ stockusageid',0),(106732,2965,'ms','stockusageid yang tidak diluluskan',0),(106733,2965,'ar','Ø³ØªÙˆÙƒÙˆØ³Ø§Ø¬ÙŠØ¯ Ø¹Ø¯Ù… ØªÙ…Ø±ÙŠØ±',0),(106734,2965,'fr','stockusageid ne pas passÃ©',0),(106735,2965,'jp','stockusageid not passed',0),(106736,2965,'pt','stockusageid nÃ£o passada',0),(106737,2965,'ru','stockusageid Ð½Ðµ Ð¿Ñ€Ð¾ÑˆÐ»Ð¾',0),(106738,2965,'es','ID del uso de stock no pasÃ³',0),(106739,2965,'de','Stockusageid nicht bestanden',0),(106740,2965,'en','stockusageid not passed',0),(106741,2966,'is','',0),(106742,2966,'dr','(Ù¾Ø± ÙƒØ±Ø¯Ù†) ÙØ±Ù…Ø§ÛŒØ´',0),(106743,2966,'pr','ØªÙˆÙ‚Ù Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ(Ù¾Ø± ÙƒØ±Ø¯Ù†) Ø³ÙØ§Ø±Ø´',0),(106744,2966,'tr','SipariÅŸ doldurma durdur',0),(106745,2966,'pl','Przystanek wypeÅ‚nienie zamÃ³wienia',0),(106746,2966,'bg','Ð¡Ð¿Ñ€Ð°Ñ‚ Ñ€ÐµÐ´',0),(106747,2966,'ur','ØªØ±ØªÛŒØ¨ Ø¨Ú¾Ø±Ù†Û’ Ø³Û’ Ø±ÙˆÚ©ÛŒÚº',0),(106748,2966,'sr','ÐŸÑ€ÐµÑÑ‚Ð°Ð½Ð¸ Ð´Ð° ÑÐµ Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(106749,2966,'vi','Ngá»«ng Ä‘iá»n Ä‘Æ¡n hÃ ng',0),(106750,2966,'af','Stop bestelling te vul',0),(106751,2966,'ro','Opri completarea Ordinului',0),(106752,2966,'et','LÃµpetage tellimuse tÃ¤itmine',0),(106753,2966,'si','Stop polnjenje nalog',0),(106754,2966,'ba','Berhenti mengisi Order',0),(106755,2966,'nl','Stop Order vullen',0),(106756,2966,'fi','PysÃ¤hdy tÃ¤yttÃ¶ jÃ¤rjestyksessÃ¤',0),(106757,2966,'no','Stoppe fylle orden',0),(106758,2966,'da','Stoppe fylde rÃ¦kkefÃ¸lge',0),(106759,2966,'ko','ì£¼ë¬¸ ìž‘ì„± ì¤‘ì§€',0),(106760,2966,'he','×ª×¤×¡×™×§ ×œ×ž×œ× ×”×–×ž× ×”',0),(106761,2966,'el','Î£Ï„Î±Î¼Î±Ï„Î®ÏƒÎµÎ¹ Ï„Î·Î½ Ï€Î»Î®ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ Ï„Î¬Î¾Î·Ï‚',0),(106762,2966,'zh','åœæ­¢å¡«å……é¡ºåº\r\n',0),(106763,2966,'sv','Sluta fylla Order',0),(106764,2966,'it','Smettere di riempire l\'ordine',0),(106765,2966,'tl','',0),(106766,2966,'th','&#3627;&#3618;&#3640;&#3604;&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(106767,2966,'hi','à¤¬à¤‚à¤¦ à¤•à¤°à¥‹ à¤†à¤¦à¥‡à¤¶ à¤­à¤°à¤¨à¥‡',0),(106768,2966,'ms','Berhenti mengisi perintah',0),(106769,2966,'ar','Ø§Ù„ØªÙˆÙ‚Ù Ø¹Ù† ØªØ¹Ø¨Ø¦Ø© Ø§Ù„Ù†Ø¸Ø§Ù…',0),(106770,2966,'fr','ArrÃªter l\'ordre de remplissage',0),(106771,2966,'jp','æ³¨æ–‡ã?®è¨˜å…¥ã‚’ã‚„ã‚?ã‚‹',0),(106772,2966,'pt','Pare de encher a ordem',0),(106773,2966,'ru','ÐžÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ð°',0),(106774,2966,'es','Suspender Llenar el Orden',0),(106775,2966,'de','Stop Order ausfÃ¼llen',0),(106776,2966,'en','Stop Filling Order',0),(106777,2967,'is','',0),(106778,2967,'dr','(Ù¾Ø± ÙƒØ±Ø¯Ù†)   Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù…Ø§ÛŒØ´',0),(106779,2967,'pr','ØªÙˆÙ‚Ù Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ(Ù¾Ø± ÙƒØ±Ø¯Ù†)   Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(106780,2967,'tr','SipariÅŸ numarasÄ± doldurmayÄ± durdurmak',0),(106781,2967,'pl','Przystanek napeÅ‚niania numer zamÃ³wienia',0),(106782,2967,'bg','Ð¡Ð¿Ñ€Ð°Ñ‚ Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(106783,2967,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ø¨Ú¾Ø±Ù†Û’ Ø³Û’ Ø±ÙˆÚ©ÛŒÚº',0),(106784,2967,'sr','ÐŸÑ€ÐµÑÑ‚Ð°Ð½Ð¸ Ð´Ð° Ð¿ÑƒÐ½Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(106785,2967,'vi','Ngá»«ng Ä‘iá»n Ä‘Æ¡n hÃ ng sá»‘',0),(106786,2967,'af','Stop vul orde nommer',0),(106787,2967,'ro','Opri completarea Ordinului numÄƒrul',0),(106788,2967,'et','Peatada tÃ¤ites tellimuse kood',0),(106789,2967,'si','Stop polnjenje zaporedno Å¡tevilko',0),(106790,2967,'ba','Berhenti mengisi nomor pesanan',0),(106791,2967,'nl','Stoppen vullen ordernummer',0),(106792,2967,'fi','PysÃ¤hdy tÃ¤yttÃ¶ tilausnumero',0),(106793,2967,'no','Stoppe fylle nummer',0),(106794,2967,'da','Stoppe fylde ordrenummer',0),(106795,2967,'ko','ì£¼ë¬¸ ë²ˆí˜¸ë¥¼ ìž‘ì„± ì¤‘ì§€',0),(106796,2967,'he','×ª×¤×¡×™×§ ×œ×ž×œ× ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(106797,2967,'el','Î£Ï„Î±Î¼Î±Ï„Î®ÏƒÎµÎ¹ Ï„Î·Î½ Ï€Î»Î®ÏÏ‰ÏƒÎ· Î±ÏÎ¾Ï‰Î½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(106798,2967,'zh','åœæ­¢å¡«å……é¡ºåºç¼–å·\r\n',0),(106799,2967,'sv','Sluta fylla ordernummer',0),(106800,2967,'it','Smettere di riempire il numero d\'ordine',0),(106801,2967,'tl','',0),(106802,2967,'th','&#3627;&#3618;&#3640;&#3604;&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(106803,2967,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤­à¤° à¤¬à¤‚à¤¦ à¤•à¤°à¥‹',0),(106804,2967,'ms','Berhenti mengisi nombor pesanan',0),(106805,2967,'ar','ÙˆÙ‚Ù Ù…Ù„Ø¡ Ø¹Ø¯Ø¯ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(106806,2967,'fr','ArrÃªter le numÃ©ro d\'ordre de remplissage',0),(106807,2967,'jp','æ³¨æ–‡ç•ªå?·ã?®è¨˜å…¥ã‚’ã‚„ã‚?ã‚‹',0),(106808,2967,'pt','Pare de encher o nÃºmero de ordem',0),(106809,2967,'ru','ÐžÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ð° ÐÐ¾Ð¼ÐµÑ€',0),(106810,2967,'es','NÃºmero de Suspender Llenar el Orden',0),(106811,2967,'de','FÃ¼llung Bestellnummer zu stoppen',0),(106812,2967,'en','Stop Filling Order Number',0),(106813,2968,'is','',0),(106814,2968,'dr','Ø§Ø¨Ø²Ø§Ø±',0),(106815,2968,'pr','Ø§Ø¨Ø²Ø§Ø±',0),(106816,2968,'tr','AraÃ§lar',0),(106817,2968,'pl','NarzÄ™dzia',0),(106818,2968,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(106819,2968,'ur','ÙÙˆØ±Ù… Ú©Û’ Ø§ÙˆØ²Ø§Ø±',0),(106820,2968,'sr','ÐÐ»Ð°Ñ‚ÐºÐµ',0),(106821,2968,'vi','CÃ´ng cá»¥',0),(106822,2968,'af','Gereedskap',0),(106823,2968,'ro','Instrumente',0),(106824,2968,'et','TÃ¶Ã¶riistad',0),(106825,2968,'si','Orodja',0),(106826,2968,'ba','Alat',0),(106827,2968,'nl','Hulpprogramma \'s',0),(106828,2968,'fi','TyÃ¶kalut',0),(106829,2968,'no','VerktÃ¸y',0),(106830,2968,'da','VÃ¦rktÃ¸jer',0),(106831,2968,'ko','ë„êµ¬',0),(106832,2968,'he','×›×œ×™×',0),(106833,2968,'el','Î•ÏÎ³Î±Î»ÎµÎ¯Î±',0),(106834,2968,'zh','å·¥å…·\r\n',0),(106835,2968,'sv','Verktyg',0),(106836,2968,'it','Strumenti',0),(106837,2968,'tl','',0),(106838,2968,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;',0),(106839,2968,'hi','à¤‰à¤ªà¤•à¤°à¤£',0),(106840,2968,'ms','Alat-alat',0),(106841,2968,'ar','Ø£Ø¯ÙˆØ§Øª',0),(106842,2968,'fr','Outils',0),(106843,2968,'jp','ãƒ„ãƒ¼ãƒ«',0),(106844,2968,'pt','Ferramentas',0),(106845,2968,'ru','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(106846,2968,'es','Herramientas',0),(106847,2968,'de','Werkzeuge',0),(106848,2968,'en','Tools',0),(106849,2969,'is','',0),(106850,2969,'dr','Ø®ÙŠØ§Ø¨Ø§Ù† ',0),(106851,2969,'pr','Ø®ÙŠØ§Ø¨Ø§Ù† ',0),(106852,2969,'tr','Sokak',0),(106853,2969,'pl','Ulica',0),(106854,2969,'bg','Ð£Ð»Ð¸Ñ†Ð°',0),(106855,2969,'ur','Ú¯Ù„ÛŒ',0),(106856,2969,'sr','Ð£Ð»Ð¸Ñ†Ð°',0),(106857,2969,'vi','Phá»‘',0),(106858,2969,'af','Straat',0),(106859,2969,'ro','Strada',0),(106860,2969,'et','Street',0),(106861,2969,'si','Street',0),(106862,2969,'ba','Street',0),(106863,2969,'nl','Straat',0),(106864,2969,'fi','Street',0),(106865,2969,'no','Street',0),(106866,2969,'da','Street',0),(106867,2969,'ko','ìŠ¤íŠ¸ë¦¬íŠ¸',0),(106868,2969,'he','×¨×—×•×‘',0),(106869,2969,'el','ÎŸÎ´ÏŒÏ‚',0),(106870,2969,'zh','è¡—\r\n',0),(106871,2969,'sv','Street',0),(106872,2969,'it','Via',0),(106873,2969,'tl','',0),(106874,2969,'th','&#3606;&#3609;&#3609;',0),(106875,2969,'hi','à¤¸à¥à¤Ÿà¥à¤°à¥€à¤Ÿ',0),(106876,2969,'ms','Jalan',0),(106877,2969,'ar','Ø´Ø§Ø±Ø¹',0),(106878,2969,'fr','Rue',0),(106879,2969,'jp','é€šã‚Š',0),(106880,2969,'pt','Rua',0),(106881,2969,'ru','Ð£Ð»Ð¸Ñ†Ð°',0),(106882,2969,'es','Calle',0),(106883,2969,'de','StraÃŸe',0),(106884,2969,'en','Street',0),(106885,2970,'is','',0),(106886,2970,'dr','Ø±ÙˆØ´ ',0),(106887,2970,'pr','Ø±ÙˆØ´ ',0),(106888,2970,'tr','Stil',0),(106889,2970,'pl','Styl',0),(106890,2970,'bg','Ð¡Ñ‚Ð¸Ð»',0),(106891,2970,'ur','Ø·Ø±Ø²',0),(106892,2970,'sr','Ð¡Ñ‚Ð¸Ð»',0),(106893,2970,'vi','Kiá»ƒu DÃ¡ng',0),(106894,2970,'af','Styl',0),(106895,2970,'ro','Stil',0),(106896,2970,'et','Stiil',0),(106897,2970,'si','Slog',0),(106898,2970,'ba','Gaya',0),(106899,2970,'nl','Stijl',0),(106900,2970,'fi','Tyyli',0),(106901,2970,'no','Stil',0),(106902,2970,'da','Stil',0),(106903,2970,'ko','ìŠ¤íƒ€ì¼',0),(106904,2970,'he','×¡×’× ×•×Ÿ',0),(106905,2970,'el','Î£Ï„Ï…Î»',0),(106906,2970,'zh','é£Žæ ¼\r\n',0),(106907,2970,'sv','Stil',0),(106908,2970,'it','Stile',0),(106909,2970,'tl','',0),(106910,2970,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;',0),(106911,2970,'hi','à¤¶à¥ˆà¤²à¥€',0),(106912,2970,'ms','Gaya',0),(106913,2970,'ar','Ù†Ù…Ø·',0),(106914,2970,'fr','Style',0),(106915,2970,'jp','ã‚¹ã‚¿ã‚¤ãƒ«',0),(106916,2970,'pt','Estilo',0),(106917,2970,'ru','Ð¡Ñ‚Ð¸Ð»ÑŒ',0),(106918,2970,'es','Estilo',0),(106919,2970,'de','Stil',0),(106920,2970,'en','Style',0),(106921,2971,'is','',0),(106922,2971,'dr','Ø²ÙŠØ± ',0),(106923,2971,'pr','Ø²ÙŠØ± ',0),(106924,2971,'tr','Sub',0),(106925,2971,'pl','Sub',0),(106926,2971,'bg','ÐŸÐ¾Ð´',0),(106927,2971,'ur','Ø°ÛŒÙ„ÛŒ',0),(106928,2971,'sr','ÐŸÐ¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð°',0),(106929,2971,'vi','Phá»¥',0),(106930,2971,'af','Sub',0),(106931,2971,'ro','Sub',0),(106932,2971,'et','Sub',0),(106933,2971,'si','Sub',0),(106934,2971,'ba','Sub',0),(106935,2971,'nl','Sub',0),(106936,2971,'fi','Sub',0),(106937,2971,'no','Sub',0),(106938,2971,'da','Sub',0),(106939,2971,'ko','í•˜ìœ„',0),(106940,2971,'he','×”×¦×•×œ×œ×ª',0),(106941,2971,'el','Î¥Ï€Î¿',0),(106942,2971,'zh','å­\r\n',0),(106943,2971,'sv','Sub',0),(106944,2971,'it','Sub',0),(106945,2971,'tl','',0),(106946,2971,'th','&#3618;&#3656;&#3629;&#3618;',0),(106947,2971,'hi','à¤‰à¤ª',0),(106948,2971,'ms','Sub',0),(106949,2971,'ar','Sub',0),(106950,2971,'fr','Void',0),(106951,2971,'jp','ã‚µãƒ–',0),(106952,2971,'pt','Sub',0),(106953,2971,'ru','Sub',0),(106954,2971,'es','Sub',0),(106955,2971,'de','Sub',0),(106956,2971,'en','Sub',0),(106957,2972,'is','',0),(106958,2972,'dr','Ù†Ø§Ù… Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(106959,2972,'pr','Ù†Ø§Ù… Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(106960,2972,'tr','Alt grup adÄ±',0),(106961,2972,'pl','Sub-nazwa grupy',0),(106962,2972,'bg','ÐŸÐ¾Ð´ Ð¸Ð¼Ðµ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(106963,2972,'ur','Ø°ÛŒÙ„ÛŒ Ú¯Ø±ÙˆÙ¾ Ù†Ø§Ù…',0),(106964,2972,'sr','Ð¡ÑƒÐ± -Ð³Ñ€ÑƒÐ¿Ð° Ð¸Ð¼Ðµ',0),(106965,2972,'vi','TÃªn nhÃ³m phá»¥',0),(106966,2972,'af','Sub-groep Naam',0),(106967,2972,'ro','Numele sub-grupului',0),(106968,2972,'et','AlltÃ¶Ã¶rÃ¼hma nimi',0),(106969,2972,'si','Ime podskupine',0),(106970,2972,'ba','Subkumpulan nama',0),(106971,2972,'nl','Subgroep naam',0),(106972,2972,'fi','AlaryhmÃ¤n nimi',0),(106973,2972,'no','Undergruppe navn',0),(106974,2972,'da','Undergruppen navn',0),(106975,2972,'ko','í•˜ìœ„ ê·¸ë£¹ ì´ë¦„',0),(106976,2972,'he','×‘×§×‘×•×¦×ª ×¢×‘×•×“×” ×©×',0),(106977,2972,'el','Î¥Ï€Î¿Î¿Î¼Î¬Î´Î±Ï‚ ÏŒÎ½Î¿Î¼Î±',0),(106978,2972,'zh','å°ç»„åç§°\r\n',0),(106979,2972,'sv','Undergrupp namn',0),(106980,2972,'it','Sottogruppo nome',0),(106981,2972,'tl','',0),(106982,2972,'th','&#3594;&#3639;&#3656;&#3629;&#3585;&#3621;&#3640;&#3656;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(106983,2972,'hi','à¤‰à¤ª à¤¸à¤®à¥‚à¤¹ à¤¨à¤¾à¤®',0),(106984,2972,'ms','Nama sub Kumpulan',0),(106985,2972,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„ÙØ±Ø¹ÙŠØ©',0),(106986,2972,'fr','Nom du sous-groupe',0),(106987,2972,'jp','ã‚µãƒ–ã‚°ãƒ«ãƒ¼ãƒ—å??',0),(106988,2972,'pt','Nome do subgrupo',0),(106989,2972,'ru','ÐŸÐ¾Ð´Ð³Ñ€ÑƒÐ¿Ð¿Ð° Ð¸Ð¼Ñ',0),(106990,2972,'es','Nombre de Sub-grupo',0),(106991,2972,'de','Sub-Gruppe Name',0),(106992,2972,'en','Sub-group Name',0),(106993,2973,'is','',0),(106994,2973,'dr','Ø§Ù†Ø¨Ø§Ø± ÙØ±Ø¹ÙŠ',0),(106995,2973,'pr','Ø§Ù†Ø¨Ø§Ø± ÙØ±Ø¹ÙŠ',0),(106996,2973,'tr','Alt stok',0),(106997,2973,'pl','Sub akcji',0),(106998,2973,'bg','ÐŸÐ¾Ð´ ÑÑŠÑÑ‚Ð°Ð²',0),(106999,2973,'ur','Ø°ÛŒÙ„ÛŒ Ø§Ø³Ù¹Ø§Ú©',0),(107000,2973,'sr','ÐŸÐ¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð° Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(107001,2973,'vi','HÃ ng tá»“n phá»¥',0),(107002,2973,'af','Sub-Voorraad',0),(107003,2973,'ro','Sub stoc',0),(107004,2973,'et','Sub Stock',0),(107005,2973,'si','Sub zalog',0),(107006,2973,'ba','Sub saham',0),(107007,2973,'nl','Sub voorraad',0),(107008,2973,'fi','Osa varastossa',0),(107009,2973,'no','Sub lager',0),(107010,2973,'da','Sub lager',0),(107011,2973,'ko','í•˜ìœ„ ì‚¬ì§„',0),(107012,2973,'he','×”×ž× ×™×” ×¦×•×œ×œ×ª',0),(107013,2973,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Ï…Ï€Î¿',0),(107014,2973,'zh','è‡ªåº“å­˜\r\n',0),(107015,2973,'sv','Sub lager',0),(107016,2973,'it','Stock di sub',0),(107017,2973,'tl','',0),(107018,2973,'th','&#3626;&#3605;&#3658;&#3629;&#3588;&#3618;&#3656;&#3629;&#3618;',0),(107019,2973,'hi','à¤‰à¤ª à¤¶à¥‡à¤¯à¤°',0),(107020,2973,'ms','Saham sub',0),(107021,2973,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… sub',0),(107022,2973,'fr','Void Stock',0),(107023,2973,'jp','ã‚µãƒ–ã‚¹ãƒˆãƒƒã‚¯',0),(107024,2973,'pt','Estoque de sub',0),(107025,2973,'ru','Sub Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹',0),(107026,2973,'es','Sub Stock',0),(107027,2973,'de','Sub-Lager',0),(107028,2973,'en','Sub Stock',0),(107029,2974,'is','',0),(107030,2974,'dr','Ù†Ø§Ù… Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(107031,2974,'pr','Ù†Ø§Ù… Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(107032,2974,'tr','Alt grup adÄ±',0),(107033,2974,'pl','Nazwa podgrupy',0),(107034,2974,'bg','ÐŸÐ¾Ð´Ð³Ñ€ÑƒÐ¿Ð° Ð¸Ð¼Ðµ',0),(107035,2974,'ur','Ø³Ø¨Ú¯Ø±ÙˆÙ¾ Ú©Û’ Ù†Ø§Ù…',0),(107036,2974,'sr','ÐŸÐ¾Ð´Ð³Ñ€ÑƒÐ¿Ñƒ Ð¸Ð¼Ðµ',0),(107037,2974,'vi','TÃªn nhÃ³m phá»¥',0),(107038,2974,'af','Sub-groep Naam',0),(107039,2974,'ro','Subgrupul numele',0),(107040,2974,'et','AlarÃ¼hma nimi',0),(107041,2974,'si','Podskupini ime',0),(107042,2974,'ba','Nama grup',0),(107043,2974,'nl','Subgroep naam',0),(107044,2974,'fi','AliryhmÃ¤n nimi',0),(107045,2974,'no','Undergruppen navn',0),(107046,2974,'da','Undergruppe navn',0),(107047,2974,'ko','í•˜ìœ„ ê·¸ë£¹ ì´ë¦„',0),(107048,2974,'he','×©× ×§×‘×•×¦×ª ×ž×©× ×”',0),(107049,2974,'el','Î¥Ï€Î¿Î¿Î¼Î¬Î´Î± ÏŒÎ½Î¿Î¼Î±',0),(107050,2974,'zh','å­å°ç»„åç§°\r\n',0),(107051,2974,'sv','Undergrupp namn',0),(107052,2974,'it','Nome del sottogruppo',0),(107053,2974,'tl','',0),(107054,2974,'th','&#3594;&#3639;&#3656;&#3629;&#3585;&#3621;&#3640;&#3656;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(107055,2974,'hi','à¤‰à¤ªà¤¸à¤®à¥‚à¤¹ à¤¨à¤¾à¤®',0),(107056,2974,'ms','Nama subkumpulan',0),(107057,2974,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„ÙØ±Ø¹ÙŠØ©',0),(107058,2974,'fr','Nom du sous-groupe',0),(107059,2974,'jp','ã‚µãƒ–ã‚°ãƒ«ãƒ¼ãƒ—å??',0),(107060,2974,'pt','Nome do subgrupo',0),(107061,2974,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(107062,2974,'es','Nombre de Subgrupo',0),(107063,2974,'de','Untergruppe Name',0),(107064,2974,'en','Subgroup Name',0),(107065,2975,'is','',0),(107066,2975,'dr','Ø§Ø±Ø³Ø§Ù„',0),(107067,2975,'pr','Ø§Ø±Ø³Ø§Ù„',0),(107068,2975,'tr','GÃ¶nder',0),(107069,2975,'pl','PrzeÅ›lij',0),(107070,2975,'bg','ÐŸÐ¾Ð´Ð°Ð²Ð°Ð½Ðµ',0),(107071,2975,'ur','Ø§Ø±Ø³Ø§Ù„ Ú©Ø±ÛŒÚº',0),(107072,2975,'sr','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´Ð¸Ñ‚Ðµ',0),(107073,2975,'vi','Ná»™p',0),(107074,2975,'af','Inteken',0),(107075,2975,'ro','Prezinte',0),(107076,2975,'et','Sisene',0),(107077,2975,'si','PredloÅ¾i',0),(107078,2975,'ba','Kirim',0),(107079,2975,'nl','Opslaan',0),(107080,2975,'fi','LÃ¤hetÃ¤',0),(107081,2975,'no','Sende',0),(107082,2975,'da','Indsende',0),(107083,2975,'ko','ì „ì†¡',0),(107084,2975,'he','×©×œ×—',0),(107085,2975,'el','Î¥Ï€Î¿Î²Î¬Î»Î¿Ï…Î½',0),(107086,2975,'zh','æäº¤\r\n',0),(107087,2975,'sv','LÃ¤mna in',0),(107088,2975,'it','Invia',0),(107089,2975,'tl','',0),(107090,2975,'th','Submit',0),(107091,2975,'hi','à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(107092,2975,'ms','Mengemukakan',0),(107093,2975,'ar','Ø¥Ø±Ø³Ø§Ù„',0),(107094,2975,'fr','Envoyer',0),(107095,2975,'jp','æ??å‡º',0),(107096,2975,'pt','Enviar',0),(107097,2975,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ',0),(107098,2975,'es','Presentar',0),(107099,2975,'de','Senden',0),(107100,2975,'en','Submit',0),(107101,2976,'is','',0),(107102,2976,'dr','Ø§Ø±Ø³Ø§Ù„ ØªØºÙŠÙŠØ±Ø§Øª ',0),(107103,2976,'pr','Ø§Ø±Ø³Ø§Ù„ ØªØºÙŠÙŠØ±Ø§Øª ',0),(107104,2976,'tr','DeÄŸiÅŸiklikleri GÃ¶nder',0),(107105,2976,'pl','PrzesÅ‚aÄ‡ zmiany',0),(107106,2976,'bg','ÐŸÐ¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ',0),(107107,2976,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ø¬Ù…Ø¹ Ú©Ø±Ø§Ø¦ÛŒÚº',0),(107108,2976,'sr','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(107109,2976,'vi','Ná»™p thay Ä‘á»•i',0),(107110,2976,'af','Inhandigingsveranderinge',0),(107111,2976,'ro','PrezintÄƒ modificÄƒri',0),(107112,2976,'et','Muudatused esitada',0),(107113,2976,'si','PredloÅ¾i spremembe',0),(107114,2976,'ba','Mengirimkan perubahan',0),(107115,2976,'nl','Wijzigingen verzenden',0),(107116,2976,'fi','LÃ¤hetÃ¤ muutokset',0),(107117,2976,'no','Send endringer',0),(107118,2976,'da','Sende Ã¦ndringer',0),(107119,2976,'ko','ë³€ê²½ ë‚´ìš©ì„ ì œì¶œí•©ë‹ˆë‹¤',0),(107120,2976,'he','×œ×©×œ×•×— ×©×™× ×•×™×™×',0),(107121,2976,'el','Î¥Ï€Î¿Î²Î¬Î»ÎµÏ„Îµ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚',0),(107122,2976,'zh','æäº¤æ›´æ”¹\r\n',0),(107123,2976,'sv','Skicka in Ã¤ndringar',0),(107124,2976,'it','Inviare le modifiche',0),(107125,2976,'tl','',0),(107126,2976,'th','&#3648;&#3626;&#3609;&#3629;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(107127,2976,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(107128,2976,'ms','Borang perubahan',0),(107129,2976,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(107130,2976,'fr','Soumettre les modifications',0),(107131,2976,'jp','å¤‰æ›´ã‚’æ??å‡º',0),(107132,2976,'pt','Enviar alteraÃ§Ãµes',0),(107133,2976,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(107134,2976,'es','Presentar Cambios',0),(107135,2976,'de','Ã„nderungen Ã¼bermitteln',0),(107136,2976,'en','Submit Changes',0),(107137,2977,'is','',0),(107138,2977,'dr','Ø¬Ù…Ø¹ Ø¬Ø²Ø¡',0),(107139,2977,'pr','Ø¬Ù…Ø¹ Ø¬Ø²Ø¡',0),(107140,2977,'tr','Alt toplam',0),(107141,2977,'pl','Suma czÄ…stkowa',0),(107142,2977,'bg','ÐœÐµÐ¶Ð´Ð¸Ð½Ð½Ð° ÑÑƒÐ¼Ð°',0),(107143,2977,'ur','Ø°ÛŒÙ„ÛŒ Ù…ÛŒØ²Ø§Ù†',0),(107144,2977,'sr','ÐŸÐ¾Ð´Ð·Ð±Ð¸Ñ€',0),(107145,2977,'vi','Tá»•ng cá»™ng phá»¥',0),(107146,2977,'af','Subtotaal',0),(107147,2977,'ro','Subtotalul',0),(107148,2977,'et','Summa',0),(107149,2977,'si','Delna vsota',0),(107150,2977,'ba','Subtotal',0),(107151,2977,'nl','Subtotaal',0),(107152,2977,'fi','YhteensÃ¤',0),(107153,2977,'no','Delsum',0),(107154,2977,'da','Subtotal',0),(107155,2977,'ko','ë¶€ë¶„í•©',0),(107156,2977,'he','×¡×›×•× ×‘×™× ×™×™×',0),(107157,2977,'el','ÎœÎµÏÎ¹ÎºÏŒ Î¬Î¸ÏÎ¿Î¹ÏƒÎ¼Î±',0),(107158,2977,'zh','å°è®¡\r\n',0),(107159,2977,'sv','Delsumma',0),(107160,2977,'it','Subtotale',0),(107161,2977,'tl','',0),(107162,2977,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(107163,2977,'hi','à¤‰à¤ª-à¤¯à¥‹à¤— à¤•à¤°à¤¨à¤¾',0),(107164,2977,'ms','Jumlah kecil',0),(107165,2977,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹',0),(107166,2977,'fr','Total partiel',0),(107167,2977,'jp','å°?è¨ˆ',0),(107168,2977,'pt','Subtotal',0),(107169,2977,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾',0),(107170,2977,'es','Subtotal',0),(107171,2977,'de','Zwischensumme',0),(107172,2977,'en','Subtotal',0),(107173,2978,'is','',0),(107174,2978,'dr','Ø¬Ù…Ø¹ Ø¬Ø²Ø¡',0),(107175,2978,'pr','Ø¬Ù…Ø¹ Ø¬Ø²Ø¡',0),(107176,2978,'tr','Alt toplamlar',0),(107177,2978,'pl','Sub sumy',0),(107178,2978,'bg','ÐŸÐ¾Ð´ Ð¾Ð±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸',0),(107179,2978,'ur','Ø°ÛŒÙ„ÛŒ Ù…ÛŒØ²Ø§Ù†',0),(107180,2978,'sr','ÐŸÐ¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð° Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(107181,2978,'vi','Tá»•ng cá»™ng phá»¥',0),(107182,2978,'af','Sub-Totale',0),(107183,2978,'ro','Sub totaluri',0),(107184,2978,'et','Sub kokku',0),(107185,2978,'si','Sub vsote',0),(107186,2978,'ba','Total sub',0),(107187,2978,'nl','Sub-totalen',0),(107188,2978,'fi','VÃ¤lisummia',0),(107189,2978,'no','Sub totaler',0),(107190,2978,'da','Sub totaler',0),(107191,2978,'ko','í•˜ìœ„ í•©ê³„',0),(107192,2978,'he','×¡×™×›×•×ž×™× sub',0),(107193,2978,'el','Î¥Ï€Î¿ ÏƒÏÎ½Î¿Î»Î±',0),(107194,2978,'zh','å°ç»„æ±‡æ€»\r\n',0),(107195,2978,'sv','Sub summor',0),(107196,2978,'it','Sub totali',0),(107197,2978,'tl','',0),(107198,2978,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(107199,2978,'hi','à¤‰à¤ª à¤¯à¥‹à¤—',0),(107200,2978,'ms','Jumlah kecil',0),(107201,2978,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹ Ø§Ù„ÙØ±Ø¹ÙŠØ©',0),(107202,2978,'fr','Sous totaux',0),(107203,2978,'jp','å°?è¨ˆ',0),(107204,2978,'pt','Sub totais',0),(107205,2978,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ Sub',0),(107206,2978,'es','Subtotales',0),(107207,2978,'de','Sub-Summen',0),(107208,2978,'en','Sub Totals',0),(107209,2979,'is','',0),(107210,2979,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ',0),(107211,2979,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ',0),(107212,2979,'tr','baÅŸarÄ±lÄ± bir ÅŸekilde.',0),(107213,2979,'pl','pomyÅ›lnie.',0),(107214,2979,'bg','ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(107215,2979,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Û”',0),(107216,2979,'sr','ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾.',0),(107217,2979,'vi','ThÃ nh cÃ´ng',0),(107218,2979,'af','suksesvol.',0),(107219,2979,'ro','cu succes.',0),(107220,2979,'et','Edukas',0),(107221,2979,'si','uspeÅ¡no.',0),(107222,2979,'ba','berhasil.',0),(107223,2979,'nl','en met succes.',0),(107224,2979,'fi','onnistuneesti.',0),(107225,2979,'no','vellykket.',0),(107226,2979,'da','med succes.',0),(107227,2979,'ko','ì„±ê³µì ìœ¼ë¡œ.',0),(107228,2979,'he','. ×‘×”×¦×œ×—×”.',0),(107229,2979,'el','Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(107230,2979,'zh','æˆåŠŸã€‚\r\n',0),(107231,2979,'sv','framgÃ¥ngsrikt.',0),(107232,2979,'it','con successo.',0),(107233,2979,'tl','',0),(107234,2979,'th','&#3629;&#3618;&#3656;&#3634;&#3591;&#3611;&#3619;&#3632;&#3626;&#3610;&#3612;&#3621;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(107235,2979,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤•à¥¤',0),(107236,2979,'ms','berjaya.',0),(107237,2979,'ar','Ø¨Ù†Ø¬Ø§Ø­',0),(107238,2979,'fr','avec succÃ¨s.',0),(107239,2979,'jp','æˆ?åŠŸ',0),(107240,2979,'pt','com Ãªxito.',0),(107241,2979,'ru','ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(107242,2979,'es','exitosamente',0),(107243,2979,'de','erfolgreich.',0),(107244,2979,'en','successfully.',0),(107245,2980,'is','',0),(107246,2980,'dr','SUI Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§ÙŠØ§Ù„ØªÙŠ',0),(107247,2980,'pr','SUI Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§ÙŠØ§Ù„ØªÙŠ',0),(107248,2980,'tr','SUI',0),(107249,2980,'pl','SUI',0),(107250,2980,'bg','SUI',0),(107251,2980,'ur','Ø³ÙˆØ¦ÛŒ',0),(107252,2980,'sr','Ð¡Ð£Ð˜',0),(107253,2980,'vi','SUI',0),(107254,2980,'af','SUI',0),(107255,2980,'ro','SUI',0),(107256,2980,'et','SUI',0),(107257,2980,'si','SUI',0),(107258,2980,'ba','SUI',0),(107259,2980,'nl','SUI',0),(107260,2980,'fi','SUI',0),(107261,2980,'no','SUI',0),(107262,2980,'da','SUI',0),(107263,2980,'ko','ìˆ˜ì´',0),(107264,2980,'he','×¡×•×•×™',0),(107265,2980,'el','SUI',0),(107266,2980,'zh','SUI\r\n',0),(107267,2980,'sv','SUI',0),(107268,2980,'it','SUI',0),(107269,2980,'tl','',0),(107270,2980,'th','&#3610;&#3640;&#3588;&#3588;&#3621;',0),(107271,2980,'hi','à¤¸à¥à¤ˆ',0),(107272,2980,'ms','SUI',0),(107273,2980,'ar','ÙØ±ÙŠØ¯ Ù…Ù† Ù†ÙˆØ¹Ù‡',0),(107274,2980,'fr','SUI',0),(107275,2980,'jp','SUI',0),(107276,2980,'pt','SUI',0),(107277,2980,'ru','Ð¡Ð£Ð™',0),(107278,2980,'es','SUI',0),(107279,2980,'de','SUI',0),(107280,2980,'en','SUI',0),(107281,2981,'is','',0),(107282,2981,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§ÙŠØ§Ù„ØªÙŠ',0),(107283,2981,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§ÙŠØ§Ù„ØªÙŠ',0),(107284,2981,'tr','SUI vergi',0),(107285,2981,'pl','SUI podatku',0),(107286,2981,'bg','SUI Ð´Ð°Ð½ÑŠÐº',0),(107287,2981,'ur','Ø³ÙˆØ¦ÛŒ Ù¹ÛŒÚ©Ø³',0),(107288,2981,'sr','Ð¡Ð£Ð˜ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(107289,2981,'vi','Thuáº¿ SUI',0),(107290,2981,'af','SUI belasting',0),(107291,2981,'ro','SUI fiscale',0),(107292,2981,'et','SUI maksu',0),(107293,2981,'si','SUI davka',0),(107294,2981,'ba','Pajak SUI',0),(107295,2981,'nl','SUI belasting',0),(107296,2981,'fi','SUI vero',0),(107297,2981,'no','SUI skatt',0),(107298,2981,'da','SUI skat',0),(107299,2981,'ko','ìˆ˜ì´ ì„¸',0),(107300,2981,'he','×œ×¡×•×™ ×ž×¡',0),(107301,2981,'el','SUI Ï†ÏŒÏÎ¿Ï…',0),(107302,2981,'zh','SUIç¨Ž\r\n',0),(107303,2981,'sv','SUI skatt',0),(107304,2981,'it','Tassa SUI',0),(107305,2981,'tl','',0),(107306,2981,'th','&#3616;&#3634;&#3625;&#3637;&#3610;&#3640;&#3588;&#3588;&#3621;',0),(107307,2981,'hi','à¤¸à¥à¤‡ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(107308,2981,'ms','Cukai SUI',0),(107309,2981,'ar','Ø¶Ø±ÙŠØ¨Ø© ÙØ±ÙŠØ¯ Ù…Ù† Ù†ÙˆØ¹Ù‡',0),(107310,2981,'fr','ImpÃ´t SUI',0),(107311,2981,'jp','SUIç¨Ž',0),(107312,2981,'pt','Imposto SUI',0),(107313,2981,'ru','Ð¡ÑƒÐ¹ Ð½Ð°Ð»Ð¾Ð³',0),(107314,2981,'es','SUI Impuesto',0),(107315,2981,'de','SUI-Steuer',0),(107316,2981,'en','SUI Tax',0),(107317,2982,'is','',0),(107318,2982,'dr','Ø¬Ù…Ø¹',0),(107319,2982,'pr','Ø¬Ù…Ø¹',0),(107320,2982,'tr','ToplamÄ±',0),(107321,2982,'pl','Suma',0),(107322,2982,'bg','Ð¡ÑƒÐ¼Ð°',0),(107323,2982,'ur','Ú©Ù„ Ù…ÛŒØ²Ø§Ù†',0),(107324,2982,'sr','Ð—Ð±Ð¸Ñ€',0),(107325,2982,'vi','Tá»•ng',0),(107326,2982,'af','Som',0),(107327,2982,'ro','Suma',0),(107328,2982,'et','Summa',0),(107329,2982,'si','Vsota',0),(107330,2982,'ba','Jumlah',0),(107331,2982,'nl','Som',0),(107332,2982,'fi','Summa',0),(107333,2982,'no','Sum',0),(107334,2982,'da','Sum',0),(107335,2982,'ko','í•©ê³„',0),(107336,2982,'he','×¡×›×•×',0),(107337,2982,'el','Î†Î¸ÏÎ¿Î¹ÏƒÎ¼Î±',0),(107338,2982,'zh','æ€»å’Œ\r\n',0),(107339,2982,'sv','Summa',0),(107340,2982,'it','Somma',0),(107341,2982,'tl','',0),(107342,2982,'th','&#3619;&#3623;&#3617;',0),(107343,2982,'hi','à¤¯à¥‹à¤—',0),(107344,2982,'ms','Jumlah',0),(107345,2982,'ar','Ù…Ø¬Ù…ÙˆØ¹',0),(107346,2982,'fr','Somme',0),(107347,2982,'jp','å?ˆè¨ˆ',0),(107348,2982,'pt','Soma',0),(107349,2982,'ru','Ð¡ÑƒÐ¼Ð¼Ð°',0),(107350,2982,'es','Suma',0),(107351,2982,'de','Summe',0),(107352,2982,'en','Sum',0),(107353,2983,'is','',0),(107354,2983,'dr','Ø®Ù„Ø§ØµÙ‡ ÙƒØ±Ø¯Ù† Ø¨Ù‡ Ø­Ø³Ø§Ø¨ ',0),(107355,2983,'pr','Ø®Ù„Ø§ØµÙ‡ ÙƒØ±Ø¯Ù† Ø¨Ù‡ Ø­Ø³Ø§Ø¨ ',0),(107356,2983,'tr','Hesap iÃ§in Ã¶zetlemek',0),(107357,2983,'pl','Podsumowanie konta',0),(107358,2983,'bg','ÐžÐ±Ð¾Ð±Ñ‰Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(107359,2983,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(107360,2983,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°ÑšÐµ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(107361,2983,'vi','Tá»•ng Há»£p Cho TK',0),(107362,2983,'af','Som op rekening',0),(107363,2983,'ro','Rezuma la cont',0),(107364,2983,'et','Konto KokkuvÃµte',0),(107365,2983,'si','Povzeti raÄun',0),(107366,2983,'ba','Meringkas ke akun',0),(107367,2983,'nl','Samenvatten naar Account',0),(107368,2983,'fi','Tilin Yhteenveto',0),(107369,2983,'no','Oppsummere konto',0),(107370,2983,'da','Opsummere til konto',0),(107371,2983,'ko','ê³„ì • ìš”ì•½',0),(107372,2983,'he','×œ×¡×›× ×œ×—×©×‘×•×Ÿ',0),(107373,2983,'el','Î£Ï…Î½Î¿ÏˆÎ¯ÏƒÏ„Îµ ÏƒÏ„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(107374,2983,'zh','æ±‡æ€»åˆ°å¸æˆ·\r\n',0),(107375,2983,'sv','Sammanfatta till konto',0),(107376,2983,'it','Riassumere per conto',0),(107377,2983,'tl','',0),(107378,2983,'th','&#3626;&#3619;&#3640;&#3611;&#3652;&#3611;&#3618;&#3633;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(107379,2983,'hi','à¤¸à¤‚à¤•à¥à¤·à¥‡à¤ª à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¤¾à¤¤à¤¾',0),(107380,2983,'ms','Meringkaskan ke akaun',0),(107381,2983,'ar','ØªÙ„Ø®ÙŠØµ Ø¥Ù„Ù‰ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(107382,2983,'fr','RÃ©sumer au compte',0),(107383,2983,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?«é›†ç´„ã?™ã‚‹',0),(107384,2983,'pt','Resumir a conta',0),(107385,2983,'ru','Ð¡ÑƒÐ¼Ð¼Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚',0),(107386,2983,'es','Sumarizar A Cuenta',0),(107387,2983,'de','Konto zusammenfassen',0),(107388,2983,'en','Summarize To Account',0),(107389,2984,'is','',0),(107390,2984,'dr','Ø®Ù„Ø§ØµÙ‡ Ø´Ø¯Ù‡ ',0),(107391,2984,'pr','Ø®Ù„Ø§ØµÙ‡ Ø´Ø¯Ù‡ ',0),(107392,2984,'tr','Ã–zetlenen',0),(107393,2984,'pl','Podsumowane',0),(107394,2984,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½Ð¸',0),(107395,2984,'ur','ØªØ®Ù„ÛŒØµ',0),(107396,2984,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°Ñ‚Ð¸',0),(107397,2984,'vi','Tá»•ng káº¿t',0),(107398,2984,'af','Opgesom',0),(107399,2984,'ro','Rezumate',0),(107400,2984,'et','Kokku',0),(107401,2984,'si','Povzeti',0),(107402,2984,'ba','Diringkas',0),(107403,2984,'nl','Samengevat',0),(107404,2984,'fi','Yhteenveto',0),(107405,2984,'no','Oppsummert',0),(107406,2984,'da','Opsummeret',0),(107407,2984,'ko','ìš”ì•½',0),(107408,2984,'he','×¡×™×›×',0),(107409,2984,'el','Î£Ï…Î½Î¿ÏˆÎ¯Î¶Î¿Î½Ï„Î±Î¹',0),(107410,2984,'zh','æ±‡æ€»\r\n',0),(107411,2984,'sv','Sammanfattas',0),(107412,2984,'it','Riassunti',0),(107413,2984,'tl','',0),(107414,2984,'th','&#3626;&#3619;&#3640;&#3611;',0),(107415,2984,'hi','à¤¸à¤‚à¤•à¥à¤·à¥‡à¤ª à¤®à¥‡à¤‚',0),(107416,2984,'ms','Diringkaskan',0),(107417,2984,'ar','Ù…Ù„Ø®Ù‘Øµ',0),(107418,2984,'fr','RÃ©sumÃ©s',0),(107419,2984,'jp','é›†è¨ˆæ¸ˆã?¿',0),(107420,2984,'pt','Resumido',0),(107421,2984,'ru','ÐšÑ€Ð°Ñ‚ÐºÐ¾',0),(107422,2984,'es','Sumarizado',0),(107423,2984,'de','Zusammengefasst',0),(107424,2984,'en','Summarized',0),(107425,2985,'is','',0),(107426,2985,'dr','Ø®Ù„Ø§ØµÙ‡ ',0),(107427,2985,'pr','Ø®Ù„Ø§ØµÙ‡ ',0),(107428,2985,'tr','Ã–zet',0),(107429,2985,'pl','KrÃ³tki opis',0),(107430,2985,'bg','Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(107431,2985,'ur','Ø®Ù„Ø§ØµÛ',0),(107432,2985,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ',0),(107433,2985,'vi','Tá»•ng káº¿t',0),(107434,2985,'af','Opsomming',0),(107435,2985,'ro','Sumar',0),(107436,2985,'et','KokkuvÃµte',0),(107437,2985,'si','Povzetek',0),(107438,2985,'ba','Ringkasan',0),(107439,2985,'nl','Samenvatting',0),(107440,2985,'fi','Yhteenveto',0),(107441,2985,'no','Sammendrag',0),(107442,2985,'da','ResumÃ©',0),(107443,2985,'ko','ìš”ì•½',0),(107444,2985,'he','×¡×™×›×•×',0),(107445,2985,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(107446,2985,'zh','ç»¼è¿°\r\n',0),(107447,2985,'sv','Sammanfattning',0),(107448,2985,'it','Riassunto',0),(107449,2985,'tl','',0),(107450,2985,'th','&#3650;&#3604;&#3618;&#3626;&#3619;&#3640;&#3611;',0),(107451,2985,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(107452,2985,'ms','Ringkasan',0),(107453,2985,'ar','Ù…Ù„Ø®Ù‘Øµ',0),(107454,2985,'fr','RÃ©sumÃ©',0),(107455,2985,'jp','é›†è¨ˆ',0),(107456,2985,'pt','Resumo',0),(107457,2985,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(107458,2985,'es','Resumen',0),(107459,2985,'de','Zusammenfassung',0),(107460,2985,'en','Summary',0),(107461,2986,'is','',0),(107462,2986,'dr','Ø®Ù„Ø§ØµÙ‡ Ø¬Ù…Ø¹â€Œ ÙƒÙ„ Ø·Ø¨Ù‚ ÙØ§ÙƒØªÙˆØ±',0),(107463,2986,'pr','Ø®Ù„Ø§ØµÙ‡ Ø¬Ù…Ø¹â€Œ ÙƒÙ„ Ø·Ø¨Ù‚ ÙØ§ÙƒØªÙˆØ±',0),(107464,2986,'tr','Fatura Ã–zet toplamlarÄ±',0),(107465,2986,'pl','PodsumowaÅ„ faktura',0),(107466,2986,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½Ð¸ ÑÑƒÐ¼Ð¸ Ð¾Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(107467,2986,'ur','Ø®Ù„Ø§ØµÛ Ú©Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(107468,2986,'sr','Ð—Ð±Ð¸Ñ€Ð¾Ð²Ðµ Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ° Ð¿Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(107469,2986,'vi','Tá»•ng há»£p theo hÃ³a Ä‘Æ¡n ',0),(107470,2986,'af','Opsommingstotale Per Faktuur',0),(107471,2986,'ro','Totaluri rezumative de facturÄƒ',0),(107472,2986,'et','Kaubaarve kokkuvÃµtted',0),(107473,2986,'si','Povzetek vsote z raÄuna',0),(107474,2986,'ba','Ringkasan Totals oleh faktur',0),(107475,2986,'nl','Samenvattingstotalen door factuur',0),(107476,2986,'fi','Yhteenveto summa laskulla',0),(107477,2986,'no','Sammendrag totaler etter faktura',0),(107478,2986,'da','Sammenfattende totaler af faktura',0),(107479,2986,'ko','ì†¡ìž¥ìœ¼ë¡œ ìš”ì•½ í•©ê³„',0),(107480,2986,'he','×¡×›×•×ž×™× ×¢×œ ×™×“×™ ×—×©×‘×•× ×™×ª',0),(107481,2986,'el','Î‘Î¸ÏÎ¿Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏÎ½Î¿Î»Î± Î±Ï€ÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(107482,2986,'zh','æŒ‰å‘ç¥¨æ‘˜è¦æ±‡æ€»\r\n',0),(107483,2986,'sv','Sammanfattning summor av faktura',0),(107484,2986,'it','Riepilogo totali di fattura',0),(107485,2986,'tl','',0),(107486,2986,'th','&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(107487,2986,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤•à¥‡ à¤¯à¥‹à¤— à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(107488,2986,'ms','Ringkasan jumlah oleh invois',0),(107489,2986,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹ Ù…ÙˆØ¬Ø² Ø¨Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(107490,2986,'fr','Totaux rÃ©capitulatifs par facture',0),(107491,2986,'jp','è«‹æ±‚æ›¸ã?”ã?¨ã?®å…¨æ¦‚è¦?',0),(107492,2986,'pt','Totais resumidos por fatura',0),(107493,2986,'ru','Ð¡Ð²Ð¾Ð´Ð½Ñ‹Ðµ Ð¸Ñ‚Ð¾Ð³Ð¸ Ð¿Ð¾ ÑÑ‡ÐµÑ‚Ñƒ',0),(107494,2986,'es','Totales de ResÃºmen Por Factura',0),(107495,2986,'de','Zusammenfassung Summen per Rechnung',0),(107496,2986,'en','Summary Totals By Invoice',0),(107497,2987,'is','',0),(107498,2987,'dr','Ù†Ø§Ø¸Ø±',0),(107499,2987,'pr','Ù†Ø§Ø¸Ø±',0),(107500,2987,'tr','GÃ¶zetmen',0),(107501,2987,'pl','Inspektor',0),(107502,2987,'bg','ÐÐ°Ð´Ð·Ð¾Ñ€ÐµÐ½ Ð¾Ñ€Ð³Ð°Ð½',0),(107503,2987,'ur','Ù†Ú¯Ø±Ø§Ù†',0),(107504,2987,'sr','ÐÐ°Ð´Ð·Ð¾Ñ€Ð½Ð¸Ðº',0),(107505,2987,'vi','GiÃ¡m sÃ¡t',0),(107506,2987,'af','Toesighouer',0),(107507,2987,'ro','Supervizor',0),(107508,2987,'et','Juhendaja',0),(107509,2987,'si','Nadzornik',0),(107510,2987,'ba','Pengawas',0),(107511,2987,'nl','Toezichthouder',0),(107512,2987,'fi','Ohjaaja',0),(107513,2987,'no','Veileder',0),(107514,2987,'da','Vejleder',0),(107515,2987,'ko','ê°ë…ìž',0),(107516,2987,'he','×”×ž×¤×§×—',0),(107517,2987,'el','Î•Ï€ÏŒÏ€Ï„Î·Ï‚',0),(107518,2987,'zh','ç›‘ç£äºº\r\n',0),(107519,2987,'sv','Handledare',0),(107520,2987,'it','Supervisore',0),(107521,2987,'tl','',0),(107522,2987,'th','&#3612;&#3641;&#3657;&#3588;&#3623;&#3610;&#3588;&#3640;&#3617;&#3604;&#3641;&#3649;&#3621;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(107523,2987,'hi','à¤ªà¤°à¥à¤¯à¤µà¥‡à¤•à¥à¤·à¤•',0),(107524,2987,'ms','Penyelia',0),(107525,2987,'ar','Ø§Ù„Ù…Ø´Ø±Ù',0),(107526,2987,'fr','Superviseur',0),(107527,2987,'jp','ã‚¹ãƒ¼ãƒ‘ãƒ¼ãƒ?ã‚¤ã‚¶ãƒ¼',0),(107528,2987,'pt','Supervisor',0),(107529,2987,'ru','Ð ÑƒÐºÐ¾Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒ',0),(107530,2987,'es','Supervisor',0),(107531,2987,'de','Supervisor',0),(107532,2987,'en','Supervisor',0),(107533,2988,'is','',0),(107534,2988,'dr','Ø¬Ø¯ÙˆÙ„ â€“ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(107535,2988,'pr','Ø¬Ø¯ÙˆÙ„ â€“ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(107536,2988,'tr','OluÅŸturulan tablo <B>mod_help_categories</B>',0),(107537,2988,'pl','Tabela <B>mod_help_categories</B> stworzony',0),(107538,2988,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° <B>mod_help_categories</B> ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½',0),(107539,2988,'ur','ØªØ®Ù„ÛŒÙ‚ Ø¬Ø¯ÙˆÙ„ <B>mod_help_categories</B>',0),(107540,2988,'sr','Ð¡Ñ‚Ð²Ð¾Ñ€Ð¸Ð¾ Ñ˜Ðµ ÑÑ‚Ð¾ <B>Ð¼Ð¾Ð´_Ñ…ÐµÐ»Ð¿_Ñ†Ð°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÐµÑ</B>',0),(107541,2988,'vi','ÄÃ£ táº¡o báº£ng <B>mod_help_categories</B>.',0),(107542,2988,'af','Tabel <B>mod_help_categories</B> geskep',0),(107543,2988,'ro','Tabel <B>mod_help_categories</B> creat',0),(107544,2988,'et','Tabelis <B>mod_help_categories</B> loodud',0),(107545,2988,'si','Tabela <B>mod_help_categories</B> ustvaril',0),(107546,2988,'ba','Tabel <B>mod_help_categories</B> telah terbentuk',0),(107547,2988,'nl','Tabel <B>mod_help_categories</B> gemaakt',0),(107548,2988,'fi','Taulukon <B>mod_help_categories</B> luotu',0),(107549,2988,'no','Tabell <B>mod_help_categories</B> opprettet',0),(107550,2988,'da','Tabel <B>mod_help_categories</B> lavet',0),(107551,2988,'ko','ë§Œë“  í…Œì´ë¸” <B>mod_help_categories</B>',0),(107552,2988,'he','×”×˜×‘×œ×” <B>mod_help_categories</B> × ×•×¦×¨',0),(107553,2988,'el','Î Î¯Î½Î±ÎºÎ± <B>mod_help_categories</B> , Ï„Î¿ Î¿Ï€Î¿Î¯Î¿ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ',0),(107554,2988,'zh','è¡¨çš„<b>å›½é˜²éƒ¨å¸®åŠ©ç±»åˆ«åˆ›å»º\r\n',0),(107555,2988,'sv','Tabell <B>mod_help_categories</B> skapad',0),(107556,2988,'it','Tabella <B>mod_help_categories</B> creata',0),(107557,2988,'tl','',0),(107558,2988,'th','&#3605;&#3634;&#3619;&#3634;&#3591; <B>mod_help_categories</B> &#3606;&#3641;&#3585;&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(107559,2988,'hi','à¤¬à¤¨à¤¾à¤ˆ à¤—à¤ˆ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ <B>mod_help_categories</B>',0),(107560,2988,'ms','Jadual <B>mod_help_categories</B> dicipta',0),(107561,2988,'ar','Ø§Ù„Ø¬Ø¯ÙˆÙ„ <B>mod_help_categories</B> Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§',0),(107562,2988,'fr','Table de <B>mod_help_categories</B> crÃ©Ã©',0),(107563,2988,'jp','è¡¨ <B>mod_help_categories</B> ä½œæˆ?ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(107564,2988,'pt','Tabela <B>mod_help_categories</B> criado',0),(107565,2988,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° <B>mod_help_categories</B> ÑÐ¾Ð·Ð´Ð°Ð½Ð°',0),(107566,2988,'es','Tabla <B>mod_ayuda_categorÃ­as</B> creado',0),(107567,2988,'de','Tabelle <B>Mod_help_categories</B> erstellt',0),(107568,2988,'en','Table <B>mod_help_categories</B> created',0),(107569,2989,'is','',0),(107570,2989,'dr','Ø¬Ø¯ÙˆÙ„ â€“ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù…Ø·Ø§Ù„Ø¨ Ù…Ø±ØªØ¨Ø·',0),(107571,2989,'pr','Ø¬Ø¯ÙˆÙ„ â€“ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù…Ø·Ø§Ù„Ø¨ Ù…Ø±ØªØ¨Ø·',0),(107572,2989,'tr','OluÅŸturulan tablo <B>mod_help_related_topics</B>',0),(107573,2989,'pl','Tabela <B>mod_help_related_topics</B> stworzony',0),(107574,2989,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° <B>mod_help_related_topics</B> ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½',0),(107575,2989,'ur','ØªØ®Ù„ÛŒÙ‚ Ø¬Ø¯ÙˆÙ„ <B>mod_help_related_topics</B>',0),(107576,2989,'sr','Ð¡Ñ‚Ð²Ð¾Ñ€Ð¸Ð¾ Ñ˜Ðµ ÑÑ‚Ð¾ <B>Ð¼Ð¾Ð´_Ñ…ÐµÐ»Ð¿_Ñ€ÐµÐ»Ð°Ñ‚ÐµÐ´_Ñ‚Ð¾Ð¿Ð¸Ñ†Ñ</B>',0),(107577,2989,'vi','ÄÃ£ táº¡o báº£ng <B>mod_help_related_topics</B>',0),(107578,2989,'af','Tabel <B>mod_help_related_topics</B> geskep',0),(107579,2989,'ro','Tabel <B>mod_help_related_topics</B> creat',0),(107580,2989,'et','Tabelis <B>mod_help_related_topics</B> loodud',0),(107581,2989,'si','Tabela <B>mod_help_related_topics</B> ustvaril',0),(107582,2989,'ba','Tabel <B>mod_help_related_topics</B> dibuat',0),(107583,2989,'nl','Tabel <B>mod_help_related_topics</B> gemaakt',0),(107584,2989,'fi','Taulukon <B>mod_help_related_topics</B> luotu',0),(107585,2989,'no','Tabell <B>mod_help_related_topics</B> opprettet',0),(107586,2989,'da','Tabel <B>mod_help_related_topics</B> lavet',0),(107587,2989,'ko','ë§Œë“  í…Œì´ë¸” <B>mod_help_related_topics</B>',0),(107588,2989,'he','×”×˜×‘×œ×” <B>mod_help_related_topics</B> × ×•×¦×¨',0),(107589,2989,'el','Î Î¯Î½Î±ÎºÎ± <B>mod_help_related_topics</B> , Ï„Î¿ Î¿Ï€Î¿Î¯Î¿ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ',0),(107590,2989,'zh','è¡¨çš„<b>å›½é˜²éƒ¨ååŠ©ç›¸å…³ä¸»é¢˜åˆ›å»º\r\n',0),(107591,2989,'sv','Tabell <B>mod_help_related_topics</B> skapad',0),(107592,2989,'it','Tabella <B>mod_help_related_topics</B> creata',0),(107593,2989,'tl','',0),(107594,2989,'th','&#3605;&#3634;&#3619;&#3634;&#3591; <B>mod_help_related_topics</B> &#3606;&#3641;&#3585;&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(107595,2989,'hi','à¤¬à¤¨à¤¾à¤ˆ à¤—à¤ˆ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ <B>mod_help_related_topics</B>',0),(107596,2989,'ms','Jadual <B>mod_help_related_topics</B> dicipta',0),(107597,2989,'ar','Ø§Ù„Ø¬Ø¯ÙˆÙ„ <B>mod_help_related_topics</B> Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§',0),(107598,2989,'fr','Table de <B>mod_help_related_topics</B> crÃ©Ã©',0),(107599,2989,'jp','è¡¨ <B>mod_help_related_topics</B> ä½œæˆ?ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(107600,2989,'pt','Tabela <B>mod_help_related_topics</B> criado',0),(107601,2989,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° <B>mod_help_related_topics</B> ÑÐ¾Ð·Ð´Ð°Ð½Ð°',0),(107602,2989,'es','Tabla <B>mod_ayuda_tÃ³picos_relacionados</B> creado',0),(107603,2989,'de','Tabelle <B>Mod_help_related_topics</B> erstellt',0),(107604,2989,'en','Table <B>mod_help_related_topics</B> created',0),(107605,2990,'is','',0),(107606,2990,'dr','Ø¬Ø¯ÙˆÙ„ â€“ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù…Ø·Ø§Ù„Ø¨  Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(107607,2990,'pr','Ø¬Ø¯ÙˆÙ„ â€“ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù…Ø·Ø§Ù„Ø¨  Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(107608,2990,'tr','OluÅŸturulan tablo <B>mod_help_topics</B>',0),(107609,2990,'pl','Tabela <B>mod_help_topics</B> stworzony',0),(107610,2990,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° <B>mod_help_topics</B> ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½',0),(107611,2990,'ur','ØªØ®Ù„ÛŒÙ‚ Ø¬Ø¯ÙˆÙ„ <B>mod_help_topics</B>',0),(107612,2990,'sr','Ð¡Ñ‚Ð²Ð¾Ñ€Ð¸Ð¾ Ñ˜Ðµ ÑÑ‚Ð¾ <B>Ð¼Ð¾Ð´_Ñ…ÐµÐ»Ð¿_Ñ‚Ð¾Ð¿Ð¸Ñ†Ñ</B>',0),(107613,2990,'vi','ÄÃ£ táº¡o báº£ng <B>mod_help_topics</B>',0),(107614,2990,'af','Tabel <B>mod_help_topics</B> geskep',0),(107615,2990,'ro','Tabel <B>mod_help_topics</B> creat',0),(107616,2990,'et','Tabelis <B>mod_help_topics</B> loodud',0),(107617,2990,'si','Tabela <B>mod_help_topics</B> ustvaril',0),(107618,2990,'ba','Tabel <B>mod_help_topics</B> dibuat',0),(107619,2990,'nl','Tabel <B>mod_help_topics</B> gemaakt',0),(107620,2990,'fi','Taulukon <B>mod_help_topics</B> luotu',0),(107621,2990,'no','Tabell <B>mod_help_topics</B> opprettet',0),(107622,2990,'da','Tabel <B>mod_help_topics</B> lavet',0),(107623,2990,'ko','ë§Œë“  í…Œì´ë¸” <B>mod_help_topics</B>',0),(107624,2990,'he','×”×˜×‘×œ×” <B>mod_help_topics</B> × ×•×¦×¨',0),(107625,2990,'el','Î Î¯Î½Î±ÎºÎ± <B>mod_help_topics</B> , Ï„Î¿ Î¿Ï€Î¿Î¯Î¿ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ',0),(107626,2990,'zh','è¡¨çš„<b>å›½é˜²éƒ¨å¸®åŠ©ä¸»é¢˜åˆ›å»º\r\n',0),(107627,2990,'sv','Tabell <B>mod_help_topics</B> skapad',0),(107628,2990,'it','Tabella <B>mod_help_topics</B> creata',0),(107629,2990,'tl','',0),(107630,2990,'th','&#3605;&#3634;&#3619;&#3634;&#3591; <B>mod_help_topics</B> &#3606;&#3641;&#3585;&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(107631,2990,'hi','à¤¬à¤¨à¤¾à¤ˆ à¤—à¤ˆ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ <B>mod_help_topics</B>',0),(107632,2990,'ms','Jadual <B>mod_help_topics</B> dicipta',0),(107633,2990,'ar','Ø§Ù„Ø¬Ø¯ÙˆÙ„ <B>mod_help_topics</B> Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§',0),(107634,2990,'fr','Table de <B>mod_help_topics</B> crÃ©Ã©',0),(107635,2990,'jp','è¡¨ <B>mod_help_topics</B> ä½œæˆ?ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(107636,2990,'pt','Tabela <B>mod_help_topics</B> criado',0),(107637,2990,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° <B>mod_help_topics</B> ÑÐ¾Ð·Ð´Ð°Ð½Ð°',0),(107638,2990,'es','Tabla <B>mod_ayuda_tÃ³picos</B> creado',0),(107639,2990,'de','Tabelle <B>Mod_help_topics</B> erstellt',0),(107640,2990,'en','Table <B>mod_help_topics</B> created',0),(107641,2991,'is','',0),(107642,2991,'dr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107643,2991,'pr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107644,2991,'tr','Tablo mod_webshop_categories kaldÄ±rÄ±ldÄ±',0),(107645,2991,'pl','Tabela mod_webshop_categories usuniÄ™ty',0),(107646,2991,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_categories Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸',0),(107647,2991,'ur','Ø¬Ø¯ÙˆÙ„ mod_webshop_categories ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(107648,2991,'sr','ÐœÐ¾Ð´_wÐµÐ±ÑÑ…Ð¾Ð¿_Ñ†Ð°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÐµÑ ÑÑ‚Ð¾ Ñ˜Ðµ ÑƒÐºÐ»Ð¾ÑšÐµÐ½',0),(107649,2991,'vi','Bá» báº£ng thá»ƒ loáº¡i webshop ',0),(107650,2991,'af','Tabel mod_webshop_categories geskrap',0),(107651,2991,'ro','Tabel mod_webshop_categories eliminat',0),(107652,2991,'et','Tabel mod_webshop_categories eemaldatud',0),(107653,2991,'si','Tabela mod_webshop_categories odstrani',0),(107654,2991,'ba','Tabel mod_webshop_categories telah terhapus',0),(107655,2991,'nl','Tabel mod_webshop_categories verwijderd',0),(107656,2991,'fi','Taulukon mod_webshop_categories poistettu',0),(107657,2991,'no','Tabell mod_webshop_categories fjernet',0),(107658,2991,'da','Tabel mod_webshop_categories fjernet',0),(107659,2991,'ko','ì œê±° í…Œì´ë¸” mod_webshop_categories',0),(107660,2991,'he','Mod_webshop_categories ×©×•×œ×—×Ÿ ×”×•×¡×¨',0),(107661,2991,'el','Î Î¯Î½Î±ÎºÎ±Ï‚ mod_webshop_categories Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯',0),(107662,2991,'zh','æŒ‰ä»˜æ¬¾å½“æ—¥ç½‘ä¸Šå•†åº—ç±»åˆ«è¡¨ä¸­åˆ é™¤\r\n',0),(107663,2991,'sv','Tabell mod_webshop_categories bort',0),(107664,2991,'it','Tabella mod_webshop_categories rimosso',0),(107665,2991,'tl','',0),(107666,2991,'th','&#3605;&#3634;&#3619;&#3634;&#3591; mod_webshop_categories &#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(107667,2991,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ mod_webshop_categories à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(107668,2991,'ms','Mod_webshop_categories jadual yang dikeluarkan',0),(107669,2991,'ar','Mod_webshop_categories Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø¥Ø²Ø§Ù„Ø©',0),(107670,2991,'fr','Table mod_webshop_categories supprimÃ©',0),(107671,2991,'jp','è¡¨ mod_webshop_categories æ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(107672,2991,'pt','Tabela mod_webshop_categories removido',0),(107673,2991,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_categories ÑƒÐ´Ð°Ð»ÐµÐ½',0),(107674,2991,'es','Tabla mod_webshop_categorias eliminadas',0),(107675,2991,'de','Tabelle Mod_webshop_categories entfernt',0),(107676,2991,'en','Table mod_webshop_categories removed',0),(107677,2992,'is','',0),(107678,2992,'dr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ø¨Ù‡ Ø±ÙˆØ² Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107679,2992,'pr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ø¨Ù‡ Ø±ÙˆØ² Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107680,2992,'tr','Tablo mod_webshop_customers kaldÄ±rÄ±ldÄ±',0),(107681,2992,'pl','Tabela mod_webshop_customers usuniÄ™ty',0),(107682,2992,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_customers Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸',0),(107683,2992,'ur','Ø¬Ø¯ÙˆÙ„ mod_webshop_customers ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(107684,2992,'sr','ÐœÐ¾Ð´_wÐµÐ±ÑÑ…Ð¾Ð¿_Ñ†ÑƒÑÑ‚Ð¾Ð¼ÐµÑ€Ñ ÑÑ‚Ð¾ Ñ˜Ðµ ÑƒÐºÐ»Ð¾ÑšÐµÐ½',0),(107685,2992,'vi','Bá» báº£ng khÃ¡ch hÃ ng webshop ',0),(107686,2992,'af','Tabel mod_webshop_customers verwyder',0),(107687,2992,'ro','Tabel mod_webshop_customers eliminat',0),(107688,2992,'et','Tabel mod_webshop_customers eemaldatud',0),(107689,2992,'si','Tabela mod_webshop_customers odstrani',0),(107690,2992,'ba','Tabel mod_webshop_customers dihapus',0),(107691,2992,'nl','Tabel mod_webshop_customers verwijderd',0),(107692,2992,'fi','Taulukon mod_webshop_customers poistettu',0),(107693,2992,'no','Tabell mod_webshop_customers fjernet',0),(107694,2992,'da','Tabel mod_webshop_customers fjernet',0),(107695,2992,'ko','ì œê±° í…Œì´ë¸” mod_webshop_customers',0),(107696,2992,'he','Mod_webshop_customers ×©×•×œ×—×Ÿ ×”×•×¡×¨',0),(107697,2992,'el','Î Î¯Î½Î±ÎºÎ±Ï‚ mod_webshop_customers Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯',0),(107698,2992,'zh','æŒ‰ä»˜æ¬¾å½“æ—¥ç½‘ä¸Šå•†åº—çš„å®¢æˆ·è¡¨ä¸­åˆ é™¤\r\n',0),(107699,2992,'sv','Tabell mod_webshop_customers bort',0),(107700,2992,'it','Tabella mod_webshop_customers rimosso',0),(107701,2992,'tl','',0),(107702,2992,'th','&#3605;&#3634;&#3619;&#3634;&#3591; mod_webshop_customers &#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(107703,2992,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ mod_webshop_customers à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(107704,2992,'ms','Mod_webshop_customers jadual yang dikeluarkan',0),(107705,2992,'ar','Mod_webshop_customers Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø¥Ø²Ø§Ù„Ø©',0),(107706,2992,'fr','Table mod_webshop_customers supprimÃ©',0),(107707,2992,'jp','è¡¨ mod_webshop_customers æ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(107708,2992,'pt','Tabela mod_webshop_customers removido',0),(107709,2992,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_customers ÑƒÐ´Ð°Ð»ÐµÐ½',0),(107710,2992,'es','Tabla mod_webshop_clientes eliminados',0),(107711,2992,'de','Tabelle Mod_webshop_customers entfernt',0),(107712,2992,'en','Table mod_webshop_customers removed',0),(107713,2993,'is','',0),(107714,2993,'dr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ø¨Ù‡ Ø±ÙˆØ² ÙƒØ§Ù„Ø§Ù‡Ø§ ÙŠ Ø³ÙØ§Ø±Ø´  ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107715,2993,'pr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ø¨Ù‡ Ø±ÙˆØ² ÙƒØ§Ù„Ø§Ù‡Ø§ ÙŠ Ø³ÙØ§Ø±Ø´  ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107716,2993,'tr','Tablo mod_webshop_order_items kaldÄ±rÄ±ldÄ±',0),(107717,2993,'pl','Tabela mod_webshop_order_items usuniÄ™ty',0),(107718,2993,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_order_items Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸',0),(107719,2993,'ur','Ø¬Ø¯ÙˆÙ„ mod_webshop_order_items ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(107720,2993,'sr','ÐœÐ¾Ð´_wÐµÐ±ÑÑ…Ð¾Ð¿_Ð¾Ñ€Ð´ÐµÑ€_Ð¸Ñ‚ÐµÐ¼Ñ ÑÑ‚Ð¾ Ñ˜Ðµ ÑƒÐºÐ»Ð¾ÑšÐµÐ½',0),(107721,2993,'vi','Bá» báº£ng mod_webshop_orders',0),(107722,2993,'af','Tabel mod_webshop_order_items verwyder',0),(107723,2993,'ro','Tabel mod_webshop_order_items eliminat',0),(107724,2993,'et','Tabel mod_webshop_order_items eemaldatud',0),(107725,2993,'si','Tabela mod_webshop_order_items odstrani',0),(107726,2993,'ba','Tabel mod_webshop_order_items dihapus',0),(107727,2993,'nl','Tabel mod_webshop_order_items verwijderd',0),(107728,2993,'fi','Taulukon mod_webshop_order_items poistettu',0),(107729,2993,'no','Tabell mod_webshop_order_items fjernet',0),(107730,2993,'da','Tabel mod_webshop_order_items fjernet',0),(107731,2993,'ko','ì œê±° í…Œì´ë¸” mod_webshop_order_items',0),(107732,2993,'he','Mod_webshop_order_items ×©×•×œ×—×Ÿ ×”×•×¡×¨',0),(107733,2993,'el','Î Î¯Î½Î±ÎºÎ±Ï‚ mod_webshop_order_items Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯',0),(107734,2993,'zh','å›½é˜²éƒ¨çš„ç½‘ä¸Šå•†åº—è®¢è´­ç‰©å“è¡¨ä¸­åˆ é™¤\r\n',0),(107735,2993,'sv','Tabell mod_webshop_order_items bort',0),(107736,2993,'it','Tabella mod_webshop_order_items rimosso',0),(107737,2993,'tl','',0),(107738,2993,'th','&#3605;&#3634;&#3619;&#3634;&#3591; mod_webshop_order_items &#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(107739,2993,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ mod_webshop_order_items à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(107740,2993,'ms','Mod_webshop_order_items jadual yang dikeluarkan',0),(107741,2993,'ar','Mod_webshop_order_items Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø¥Ø²Ø§Ù„Ø©',0),(107742,2993,'fr','Table mod_webshop_order_items supprimÃ©',0),(107743,2993,'jp','è¡¨ mod_webshop_order_items æ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(107744,2993,'pt','Tabela mod_webshop_order_items removido',0),(107745,2993,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_order_items ÑƒÐ´Ð°Ð»ÐµÐ½',0),(107746,2993,'es','Tabla mod_webshop_orden_items eliminados',0),(107747,2993,'de','Tabelle Mod_webshop_order_items entfernt',0),(107748,2993,'en','Table mod_webshop_order_items removed',0),(107749,2994,'is','',0),(107750,2994,'dr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ø¨Ù‡ Ø±ÙˆØ² Ø³ÙØ§Ø±Ø´Ø§Øª  ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107751,2994,'pr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ø¨Ù‡ Ø±ÙˆØ² Ø³ÙØ§Ø±Ø´Ø§Øª  ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107752,2994,'tr','Tablo mod_webshop_orders kaldÄ±rÄ±ldÄ±',0),(107753,2994,'pl','Tabela mod_webshop_orders usuniÄ™ty',0),(107754,2994,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_orders Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸',0),(107755,2994,'ur','Ø¬Ø¯ÙˆÙ„ mod_webshop_orders ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(107756,2994,'sr','ÐœÐ¾Ð´_wÐµÐ±ÑÑ…Ð¾Ð¿_Ð¾Ñ€Ð´ÐµÑ€Ñ ÑÑ‚Ð¾ Ñ˜Ðµ ÑƒÐºÐ»Ð¾ÑšÐµÐ½',0),(107757,2994,'vi','Bá» báº£ng mod_webshop_orders',0),(107758,2994,'af','Table mod_webshop_orders verwyder',0),(107759,2994,'ro','Tabel mod_webshop_orders eliminat',0),(107760,2994,'et','Tabel mod_webshop_orders eemaldatud',0),(107761,2994,'si','Tabela mod_webshop_orders odstrani',0),(107762,2994,'ba','Tabel mod_webshop_orders dihapus',0),(107763,2994,'nl','Tabel mod_webshop_orders verwijderd',0),(107764,2994,'fi','Taulukon mod_webshop_orders poistettu',0),(107765,2994,'no','Tabell mod_webshop_orders fjernet',0),(107766,2994,'da','Tabel mod_webshop_orders fjernet',0),(107767,2994,'ko','ì œê±° í…Œì´ë¸” mod_webshop_orders',0),(107768,2994,'he','Mod_webshop_orders ×©×•×œ×—×Ÿ ×”×•×¡×¨',0),(107769,2994,'el','Î Î¯Î½Î±ÎºÎ±Ï‚ mod_webshop_orders Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯',0),(107770,2994,'zh','æŒ‰ä»˜æ¬¾å½“æ—¥ç½‘ä¸Šå•†åº—çš„è®¢å•è¡¨ä¸­åˆ é™¤\r\n',0),(107771,2994,'sv','Tabell mod_webshop_orders bort',0),(107772,2994,'it','Tabella mod_webshop_orders rimosso',0),(107773,2994,'tl','',0),(107774,2994,'th','&#3605;&#3634;&#3619;&#3634;&#3591; mod_webshop_orders &#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(107775,2994,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ mod_webshop_orders à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(107776,2994,'ms','Mod_webshop_orders jadual yang dikeluarkan',0),(107777,2994,'ar','Mod_webshop_orders Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø¥Ø²Ø§Ù„Ø©',0),(107778,2994,'fr','Table mod_webshop_orders supprimÃ©',0),(107779,2994,'jp','è¡¨ mod_webshop_orders æ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(107780,2994,'pt','Tabela mod_webshop_orders removido',0),(107781,2994,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_orders ÑƒÐ´Ð°Ð»ÐµÐ½',0),(107782,2994,'es','Tabla mod_webshop_ordenes eliminados',0),(107783,2994,'de','Tabelle Mod_webshop_orders entfernt',0),(107784,2994,'en','Table mod_webshop_orders removed',0),(107785,2995,'is','',0),(107786,2995,'dr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ø¨Ù‡ Ø±ÙˆØ² Ù…Ø­ØµÙˆÙ„Ø§Øª  ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107787,2995,'pr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ø¨Ù‡ Ø±ÙˆØ² Ù…Ø­ØµÙˆÙ„Ø§Øª  ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107788,2995,'tr','Tablo mod_webshop_products kaldÄ±rÄ±ldÄ±',0),(107789,2995,'pl','Tabela mod_webshop_products usuniÄ™ty',0),(107790,2995,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_products Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸',0),(107791,2995,'ur','Ø¬Ø¯ÙˆÙ„ mod_webshop_products ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(107792,2995,'sr','ÐœÐ¾Ð´_wÐµÐ±ÑÑ…Ð¾Ð¿_Ð¿Ñ€Ð¾Ð´ÑƒÑ†Ñ‚Ñ ÑÑ‚Ð¾ Ñ˜Ðµ ÑƒÐºÐ»Ð¾ÑšÐµÐ½',0),(107793,2995,'vi','Bá» báº£ng sáº£n pháº©m webshop ',0),(107794,2995,'af','Tabel mod_webshop_products verwyder',0),(107795,2995,'ro','Tabel mod_webshop_products eliminat',0),(107796,2995,'et','Tabel mod_webshop_products eemaldatud',0),(107797,2995,'si','Tabela mod_webshop_products odstrani',0),(107798,2995,'ba','Tabel mod_webshop_products dihapus',0),(107799,2995,'nl','Tabel mod_webshop_products verwijderd',0),(107800,2995,'fi','Taulukon mod_webshop_products poistettu',0),(107801,2995,'no','Tabell mod_webshop_products fjernet',0),(107802,2995,'da','Tabel mod_webshop_products fjernet',0),(107803,2995,'ko','ì œê±° í…Œì´ë¸” mod_webshop_products',0),(107804,2995,'he','Mod_webshop_products ×©×•×œ×—×Ÿ ×”×•×¡×¨',0),(107805,2995,'el','Î Î¯Î½Î±ÎºÎ±Ï‚ mod_webshop_products Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯',0),(107806,2995,'zh','ç½‘ä¸Šå•†åº—çš„äº§å“ä¸­åˆ é™¤è¡¨æ¨¡\r\n',0),(107807,2995,'sv','Tabell mod_webshop_products bort',0),(107808,2995,'it','Tabella mod_webshop_products rimosso',0),(107809,2995,'tl','',0),(107810,2995,'th','&#3605;&#3634;&#3619;&#3634;&#3591; mod_webshop_products &#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(107811,2995,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ mod_webshop_products à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(107812,2995,'ms','Mod_webshop_products jadual yang dikeluarkan',0),(107813,2995,'ar','Mod_webshop_products Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø¥Ø²Ø§Ù„Ø©',0),(107814,2995,'fr','Table mod_webshop_products supprimÃ©',0),(107815,2995,'jp','è¡¨ mod_webshop_products æ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(107816,2995,'pt','Tabela mod_webshop_products removido',0),(107817,2995,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_products ÑƒÐ´Ð°Ð»ÐµÐ½',0),(107818,2995,'es','Tabla mod_webshop_productos eliminados',0),(107819,2995,'de','Tabelle Mod_webshop_products entfernt',0),(107820,2995,'en','Table mod_webshop_products removed',0),(107821,2996,'is','',0),(107822,2996,'dr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ø¨Ù‡ Ø±ÙˆØ² Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107823,2996,'pr','Ø¬Ø¯ÙˆÙ„ Ù…Ø¯Ù„ Ø¨Ù‡ Ø±ÙˆØ² Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø­Ø°Ù Ø´Ø¯',0),(107824,2996,'tr','Tablo mod_webshop_sub_categories kaldÄ±rÄ±ldÄ±',0),(107825,2996,'pl','Tabela mod_webshop_sub_categories usuniÄ™ty',0),(107826,2996,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_sub_categories Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸',0),(107827,2996,'ur','Ø¬Ø¯ÙˆÙ„ mod_webshop_sub_categories ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(107828,2996,'sr','ÐœÐ¾Ð´_wÐµÐ±ÑÑ…Ð¾Ð¿_ÑÑƒÐ±_Ñ†Ð°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÐµÑ ÑÑ‚Ð¾ Ñ˜Ðµ ÑƒÐºÐ»Ð¾ÑšÐµÐ½',0),(107829,2996,'vi','Bá» báº£ng thá»ƒ loáº¡i phá»¥ webshop ',0),(107830,2996,'af','Tabel mod_webshop_sub_categories verwyder',0),(107831,2996,'ro','Tabel mod_webshop_sub_categories eliminat',0),(107832,2996,'et','Tabel mod_webshop_sub_categories eemaldatud',0),(107833,2996,'si','Tabela mod_webshop_sub_categories odstrani',0),(107834,2996,'ba','Tabel mod_webshop_sub_categories telah terhapus',0),(107835,2996,'nl','Tabel mod_webshop_sub_categories verwijderd',0),(107836,2996,'fi','Taulukon mod_webshop_sub_categories poistettu',0),(107837,2996,'no','Tabell mod_webshop_sub_categories fjernet',0),(107838,2996,'da','Tabel mod_webshop_sub_categories fjernet',0),(107839,2996,'ko','ì œê±° í…Œì´ë¸” mod_webshop_sub_categories',0),(107840,2996,'he','Mod_webshop_sub_categories ×©×•×œ×—×Ÿ ×”×•×¡×¨',0),(107841,2996,'el','Î Î¯Î½Î±ÎºÎ±Ï‚ mod_webshop_sub_categories Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯',0),(107842,2996,'zh','å°ç±»è¡¨ä¸­åˆ é™¤å›½é˜²éƒ¨çš„ç½‘ä¸Šå•†åº—\r\n',0),(107843,2996,'sv','Tabell mod_webshop_sub_categories bort',0),(107844,2996,'it','Tabella mod_webshop_sub_categories rimosso',0),(107845,2996,'tl','',0),(107846,2996,'th','&#3605;&#3634;&#3619;&#3634;&#3591; mod_webshop_sub_categories &#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(107847,2996,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ mod_webshop_sub_categories à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(107848,2996,'ms','Mod_webshop_sub_categories jadual yang dikeluarkan',0),(107849,2996,'ar','Mod_webshop_sub_categories Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø¥Ø²Ø§Ù„Ø©',0),(107850,2996,'fr','Table mod_webshop_sub_categories supprimÃ©',0),(107851,2996,'jp','è¡¨ mod_webshop_sub_categories æ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(107852,2996,'pt','Tabela mod_webshop_sub_categories removido',0),(107853,2996,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° mod_webshop_sub_categories ÑƒÐ´Ð°Ð»ÐµÐ½',0),(107854,2996,'es','Tabla mod_webshop_sub_categorias eliminadas',0),(107855,2996,'de','Tabelle Mod_webshop_sub_categories entfernt',0),(107856,2996,'en','Table mod_webshop_sub_categories removed',0),(107857,2997,'is','',0),(107858,2997,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ±Ø¯ Ù†Ø¸Ø± ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø¬Ù‡Øª ØªÙˆÙ„ÙŠØ¯ ',0),(107859,2997,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ±Ø¯ Ù†Ø¸Ø± ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø¬Ù‡Øª ØªÙˆÙ„ÙŠØ¯ ',0),(107860,2997,'tr','Hedef miktarÄ± Ã¼retmek iÃ§in ana Ã¶ÄŸe',0),(107861,2997,'pl','Cel iloÅ›Ä‡ elementÃ³w wzorca do produkcji',0),(107862,2997,'bg','Ð¦ÐµÐ»ÐµÐ²Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° ÐºÐ°Ð¿Ð¸Ñ‚Ð°Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ†Ð¸ÑÑ‚Ð°',0),(107863,2997,'ur','Ù…Ø§Ø³Ù¹Ø± Ø§Ø´ÛŒØ§Ø¡ Ù¾ÛŒØ¯Ø§ÙˆØ§Ø± Ú©Ø§ ÛØ¯Ù Qty.',0),(107864,2997,'sr','ÐœÐµÑ‚Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð³Ð¾ÑÐ¿Ð¾Ð´Ð°Ñ€ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ðµ',0),(107865,2997,'vi','Sá»‘ lÆ°á»£ng má»¥c tiÃªu cá»§a hÃ ng chÃ­nh Ä‘á»ƒ sáº£n xuáº¥t',0),(107866,2997,'af','Teiken Qty. van Meester Items om produkte',0),(107867,2997,'ro','Cant. Å£intÄƒ de elemente de Master pentru a Produce',0),(107868,2997,'et','Target Master kaupu toota kogus',0),(107869,2997,'si','Kol cilj Master elementov za proizvodnjo',0),(107870,2997,'ba','Target Qty. Master item untuk menghasilkan',0),(107871,2997,'nl','Doelgroep veld van stramienitems producten',0),(107872,2997,'fi','Kohde mÃ¤Ã¤rÃ¤ Master tuotteet maksoi',0),(107873,2997,'no','MÃ¥let antall malobjekter til Ã¥ produsere',0),(107874,2997,'da','Target antal af masterelementer til at producere',0),(107875,2997,'ko','ìƒì‚° ë§ˆìŠ¤í„° í•­ëª© ëŒ€ìƒ ìˆ˜ëŸ‰',0),(107876,2997,'he','×™×¢×“ ×›×ž×•×ª ×¤×¨×™×˜×™ ×ž××¡×˜×¨, ×›×“×™ ×œ×™×™×¦×¨',0),(107877,2997,'el','Î£Ï„ÏŒÏ‡Î¿Ï‚ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï„Ï‰Î½ Î±Î½Ï„Î¹ÎºÎµÎ¹Î¼Î­Î½Ï‰Î½ Ï€ÏÏŒÏ„Ï…Ï€Î·Ï‚ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Ï‰Î³Î®',0),(107878,2997,'zh','è¦äº§ç”Ÿçš„ç®¡ç†é¡¹ç›®ç›®æ ‡æ•°é‡\r\n',0),(107879,2997,'sv','MÃ¥let Ant. av mallobjekt att producera',0),(107880,2997,'it','QtÃ  di destinazione degli articoli Master per produrre',0),(107881,2997,'tl','',0),(107882,2997,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3621;&#3633;&#3585;&#3586;&#3629;&#3591;&#3612;&#3621;&#3636;&#3605;&#3612;&#3621;',0),(107883,2997,'hi','à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤µà¤¸à¥à¤¤à¥à¤“à¤‚ à¤•à¤¾ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¤¾ à¤²à¤•à¥à¤·à¥à¤¯ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(107884,2997,'ms','Sasaran Qty. item induk untuk mengemukakan',0),(107885,2997,'ar','Qty. Ø§Ù„Ù‡Ø¯Ù Ù…Ù† Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ù„Ù„Ù…Ù†ØªØ¬Ø§Øª',0),(107886,2997,'fr','QtÃ© de cible d\'Ã©lÃ©ments de maÃ®tre Ã  produire',0),(107887,2997,'jp','è£½é€ ã?™ã‚‹ä¸»è¦?å“?ç›®ã?®ç›®æ¨™æ•°é‡?',0),(107888,2997,'pt','Alvo Qtd. de itens-mestre de produÃ§Ã£o',0),(107889,2997,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ñ†ÐµÐ»ÐµÐ²Ð¾Ð¹ Ð¼Ð°ÑÑ‚ÐµÑ€ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð°',0),(107890,2997,'es','Cant. Objetivo de Items Maestros para Producir',0),(107891,2997,'de','Ziel-Anzahl der Musterseitenobjekte zu produzieren',0),(107892,2997,'en','Target Qty. of Master Items to Produce',0),(107893,2998,'is','',0),(107894,2998,'dr','Ù…Ø§Ù„ÙŠØ§Øª ',0),(107895,2998,'pr','Ù…Ø§Ù„ÙŠØ§Øª ',0),(107896,2998,'tr','Vergi',0),(107897,2998,'pl','Podatku',0),(107898,2998,'bg','Ð”Ð°Ð½ÑŠÐº',0),(107899,2998,'ur','Ù¹ÛŒÚ©Ø³',0),(107900,2998,'sr','ÐŸÐ¾Ñ€ÐµÐ·',0),(107901,2998,'vi','Thuáº¿',0),(107902,2998,'af','Belasting',0),(107903,2998,'ro','Fiscale',0),(107904,2998,'et','Maksud',0),(107905,2998,'si','DavÄne',0),(107906,2998,'ba','Pajak',0),(107907,2998,'nl','Belasting',0),(107908,2998,'fi','Vero',0),(107909,2998,'no','Skatt',0),(107910,2998,'da','Skat',0),(107911,2998,'ko','ì„¸ê¸ˆ',0),(107912,2998,'he','×ž×¡',0),(107913,2998,'el','Î¦ÏŒÏÎ¿Ï…',0),(107914,2998,'zh','ç¨Ž\r\n',0),(107915,2998,'sv','Skatt',0),(107916,2998,'it','Fiscale',0),(107917,2998,'tl','',0),(107918,2998,'th','&#3616;&#3634;&#3625;&#3637;',0),(107919,2998,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸',0),(107920,2998,'ms','Cukai',0),(107921,2998,'ar','Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(107922,2998,'fr','ImpÃ´t',0),(107923,2998,'jp','ç¨Ž',0),(107924,2998,'pt','Fiscal',0),(107925,2998,'ru','ÐÐ°Ð»Ð¾Ð³',0),(107926,2998,'es','Impuesto',0),(107927,2998,'de','Steuer',0),(107928,2998,'en','Tax',0),(107929,2999,'is','',0),(107930,2999,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(107931,2999,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(107932,2999,'tr','Vergi baÅŸarÄ±yla eklendi',0),(107933,2999,'pl','Podatek dodany pomyÅ›lnie',0),(107934,2999,'bg','Ð”Ð°Ð½ÑŠÐº Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(107935,2999,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ù¹ÛŒÚ©Ø³',0),(107936,2999,'sr','ÐŸÐ¾Ñ€ÐµÐ· ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ñ‚ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(107937,2999,'vi','ThÃªm thuáº¿ thÃ nh cÃ´ng',0),(107938,2999,'af','Belasting Suksesvol Geskep',0),(107939,2999,'ro','Taxa adÄƒugat cu succes',0),(107940,2999,'et','Maks lisati edukalt',0),(107941,2999,'si','Davek dodan uspeÅ¡no',0),(107942,2999,'ba','Pajak ditambahkan berhasil',0),(107943,2999,'nl','Belasting met succes toegevoegd',0),(107944,2999,'fi','Verotuksen lisÃ¤Ã¤minen onnistui',0),(107945,2999,'no','Skatt lagt',0),(107946,2999,'da','Moms tilfÃ¸jet',0),(107947,2999,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì„¸ê¸ˆ',0),(107948,2999,'he','×ž×¡ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(107949,2999,'el','Î¦ÏŒÏÎ¿ Ï€ÏÎ¿ÏƒÏ„Î¹Î¸Î­Î¼ÎµÎ½Î·Ï‚ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(107950,2999,'zh','ç¨ŽåŠ¡æ·»åŠ æˆåŠŸ\r\n',0),(107951,2999,'sv','Skatt som lagts',0),(107952,2999,'it','Fiscale aggiunto con successo',0),(107953,2999,'tl','',0),(107954,2999,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(107955,2999,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(107956,2999,'ms','Cukai yang berjaya menambah',0),(107957,2999,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(107958,2999,'fr','Taxe ajoutÃ©e avec succÃ¨s',0),(107959,2999,'jp','ç¨Žã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(107960,2999,'pt','Imposto adicionado com sucesso',0),(107961,2999,'ru','ÐÐ°Ð»Ð¾Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(107962,2999,'es','Impuesto Agregado Exitosamente',0),(107963,2999,'de','Steuern erfolgreich hinzugefÃ¼gt',0),(107964,2999,'en','Tax Added Successfully',0),(107965,3000,'is','',0),(107966,3000,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø§Ù„ÙŠØ§Øª',0),(107967,3000,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø§Ù„ÙŠØ§Øª',0),(107968,3000,'tr','Vergi tutarÄ±',0),(107969,3000,'pl','Kwota podatku',0),(107970,3000,'bg','Ð¡ÑƒÐ¼Ð° Ð”Ð”Ð¡',0),(107971,3000,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø±Ù‚Ù…',0),(107972,3000,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(107973,3000,'vi','Sá»‘ tiá»n thuáº¿',0),(107974,3000,'af','Belastingbedrag',0),(107975,3000,'ro','Suma impozitului',0),(107976,3000,'et','Maksude kogusumma',0),(107977,3000,'si','Znesek davka',0),(107978,3000,'ba','Jumlah pajak',0),(107979,3000,'nl','BTW-bedrag',0),(107980,3000,'fi','ALV-summa',0),(107981,3000,'no','-BelÃ¸p',0),(107982,3000,'da','SkattebelÃ¸b',0),(107983,3000,'ko','ì„¸ ì•¡',0),(107984,3000,'he','×¡×›×•× ×ž×¡',0),(107985,3000,'el','Î¤Î¿ Ï€Î¿ÏƒÏŒ Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï…',0),(107986,3000,'zh','ç¨Žé¢\r\n',0),(107987,3000,'sv','Skattebeloppet',0),(107988,3000,'it','Importo imposta',0),(107989,3000,'tl','',0),(107990,3000,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(107991,3000,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤°à¤¾à¤¶à¤¿',0),(107992,3000,'ms','Amaun cukai',0),(107993,3000,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(107994,3000,'fr','Montant de la taxe',0),(107995,3000,'jp','ç¨Žé¡?',0),(107996,3000,'pt','Valor do imposto',0),(107997,3000,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(107998,3000,'es','Monto de impuesto',0),(107999,3000,'de','Steuerbetrag',0),(108000,3000,'en','Tax amount',0),(108001,3001,'is','',0),(108002,3001,'dr','Ù…Ø¨Ù†Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª',0),(108003,3001,'pr','Ù…Ø¨Ù†Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª',0),(108004,3001,'tr','Vergi iÃ§in temel',0),(108005,3001,'pl','Podstawa do podatku',0),(108006,3001,'bg','ÐžÑÐ½Ð¾Ð²Ð° Ð·Ð° Ð´Ð°Ð½ÑŠÐºÐ°',0),(108007,3001,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯',0),(108008,3001,'sr','ÐžÑÐ½Ð¾Ð²Ð° Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ·',0),(108009,3001,'vi','CÆ¡ sá»Ÿ cho thuáº¿',0),(108010,3001,'af','Basis vir Belasting',0),(108011,3001,'ro','Baza de impozitare',0),(108012,3001,'et','Maksu alus',0),(108013,3001,'si','Osnova za davek',0),(108014,3001,'ba','Dasar untuk pajak',0),(108015,3001,'nl','Basis voor belasting',0),(108016,3001,'fi','Perusta vero',0),(108017,3001,'no','Grunnlag for mva',0),(108018,3001,'da','Grundlag for skat',0),(108019,3001,'ko','ì„¸ê¸ˆì„ ìœ„í•œ ê¸°ì´ˆ',0),(108020,3001,'he','×‘×¡×™×¡ ×”×ž×¡',0),(108021,3001,'el','Î’Î¬ÏƒÎ· Î³Î¹Î± Ï„Î¿Î½ Ï†ÏŒÏÎ¿',0),(108022,3001,'zh','ç¨Žæ”¶åŸºç¡€\r\n',0),(108023,3001,'sv','Grund fÃ¶r skatt',0),(108024,3001,'it','Base per tassa',0),(108025,3001,'tl','',0),(108026,3001,'th','&#3627;&#3621;&#3633;&#3585;&#3648;&#3585;&#3603;&#3601;&#3660;&#3586;&#3629;&#3591;&#3616;&#3634;&#3625;&#3637;',0),(108027,3001,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤§à¤¾à¤°',0),(108028,3001,'ms','Asas cukai',0),(108029,3001,'ar','Ø§Ù„Ø£Ø³Ø§Ø³ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(108030,3001,'fr','Base de l\'impÃ´t',0),(108031,3001,'jp','èª²ç¨ŽåŸºæº–',0),(108032,3001,'pt','Base para imposto',0),(108033,3001,'ru','ÐžÑÐ½Ð¾Ð²Ð° Ð´Ð»Ñ ÐÐ°Ð»Ð¾Ð³Ð°',0),(108034,3001,'es','Base para Impuesto',0),(108035,3001,'de','Grundlage fÃ¼r die steuerliche',0),(108036,3001,'en','Basis for Tax',0),(108037,3002,'is','',0),(108038,3002,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ú†Ùƒ Ù…Ø§Ù„ÙŠØ§Øª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(108039,3002,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ú†Ùƒ Ù…Ø§Ù„ÙŠØ§Øª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(108040,3002,'tr','Vergi onay ekleme baÅŸarÄ±sÄ±z oldu.',0),(108041,3002,'pl','Podatek od wyboru Wstaw nie powiodÅ‚o siÄ™.',0),(108042,3002,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð½Ðµ ÑƒÑÐ¿Ñ.',0),(108043,3002,'ur','Ù¹ÛŒÚ©Ø³ Ú†ÛŒÚ© Ø¯Ø§Ø®Ù„ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§ Û”',0),(108044,3002,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(108045,3002,'vi','ChÃ¨n SÃ©c thuáº¿ tháº¥t báº¡i',0),(108046,3002,'af','Belasting kontroleer insetsel het misluk.',0),(108047,3002,'ro','Inserare de control fiscal nu a reuÅŸit.',0),(108048,3002,'et','Maksu sisse lisamine nurjus.',0),(108049,3002,'si','Vstavi potrditveno davka ni uspela.',0),(108050,3002,'ba','Pajak Check Masukkan gagal.',0),(108051,3002,'nl','Fiscale selectievakje invoegen mislukt.',0),(108052,3002,'fi','Vero uloskirjautuminen lisÃ¤ys epÃ¤onnistui.',0),(108053,3002,'no','Skatt av sett inn mislyktes.',0),(108054,3002,'da','Skat Check IndsÃ¦t mislykkedes.',0),(108055,3002,'ko','ì„¸ê¸ˆ í‘œ ì‚½ìž… í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(108056,3002,'he','×ž×¡ ×”×¡×™×ž×•×Ÿ ×”×•×¡×£ × ×›×©×œ.',0),(108057,3002,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ¿Ï ÎµÎ»Î­Î³Ï‡Î¿Ï… Ï„Î¿Ï€Î¿Î¸ÎµÏ„Î®ÏƒÏ„Îµ Î±Ï€Î­Ï„Ï…Ï‡Îµ.',0),(108058,3002,'zh','ç¨ŽåŠ¡ç¨½æŸ¥æ’å…¥å¤±è´¥ã€‚\r\n',0),(108059,3002,'sv','Skatt kryssrutan Infoga misslyckades.',0),(108060,3002,'it','Inserimento di controllo fiscale non riuscito.',0),(108061,3002,'tl','',0),(108062,3002,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3616;&#3634;&#3625;&#3637;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(108063,3002,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤šà¥‡à¤• à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾à¥¤',0),(108064,3002,'ms','Masukkan semak cukai gagal.',0),(108065,3002,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ÙØ´Ù„.',0),(108066,3002,'fr','ImpÃ´t cocher Ã©chouÃ©e de l\'insertion.',0),(108067,3002,'jp','ç¨Žå°?åˆ‡æ‰‹ã?®æŒ¿å…¥ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(108068,3002,'pt','InserÃ§Ã£o de seleÃ§Ã£o imposto falhada.',0),(108069,3002,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð²ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ðµ ÑƒÐ´Ð°Ð»Ð°ÑÑŒ.',0),(108070,3002,'es','InserciÃ³n de Cheque de Impuestos fallÃ³',0),(108071,3002,'de','Steuer Check einfÃ¼gen ist fehlgeschlagen.',0),(108072,3002,'en','Tax Check insert failed.',0),(108073,3003,'is','',0),(108074,3003,'dr','ÙƒÙ… ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ù…Ø§Ù„ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¨Ø¹Ø¯ Ø§Ø² Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø§Ù„ÙŠØ§Øª',0),(108075,3003,'pr','ÙƒÙ… ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ù…Ø§Ù„ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¨Ø¹Ø¯ Ø§Ø² Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø§Ù„ÙŠØ§Øª',0),(108076,3003,'tr','Sonra vergisinin vergi kredisi',0),(108077,3003,'pl','Ulg podatkowych po podatku obliczonego',0),(108078,3003,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸ ÑÐ»ÐµÐ´ Ð´Ð°Ð½ÑŠÐº, Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½',0),(108079,3003,'ur','Ù¹ÛŒÚ©Ø³ Ú©Ø±ÛŒÚˆÙ¹Ø³ Ù…Ø­Ø³ÙˆØ¨ Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø¨Ø¹Ø¯',0),(108080,3003,'sr','ÐŸÐ¾Ñ€ÐµÑÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸ Ð½Ð°ÐºÐ¾Ð½ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð»Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(108081,3003,'vi','Tiá»n DÆ° Sau Khi TÃ­nh ToÃ¡n Thuáº¿',0),(108082,3003,'af','Belastingkrediete nadat belasting bereken is',0),(108083,3003,'ro','Creditele fiscale nete calculate',0),(108084,3003,'et','Maksusoodustuste pÃ¤rast arvutatud kÃ¤ibemaks',0),(108085,3003,'si','DavÄne olajÅ¡ave po izraÄunani davek',0),(108086,3003,'ba','Kredit pajak setelah pajak dihitung',0),(108087,3003,'nl','Fiscaal verrekenbare tegoeden na belasting berekend',0),(108088,3003,'fi','Verohyvitykset jÃ¤lkeen laskettu',0),(108089,3003,'no','Skatt kreditt etter skatt beregnes',0),(108090,3003,'da','Skattefradrag efter skat beregnes',0),(108091,3003,'ko','ì„¸ê¸ˆ ê³„ì‚° í›„ ì„¸ ì•¡ ê³µì œ',0),(108092,3003,'he','×–×™×›×•×™×™ ×ž×¡ ×œ××—×¨ ×”×ž×¡ ×ž×—×•×©×‘',0),(108093,3003,'el','Î¦ÏŒÏÎ¿Ï… Î¼ÎµÏ„Î¬ Ï„Î¿Ï…Ï‚ Ï†ÏŒÏÎ¿Ï…Ï‚ Ï€Î¿Ï… Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶Î¿Î½Ï„Î±Î¹',0),(108094,3003,'zh','ç¨ŽåŽè®¡ç®—ç¨Žæ”¶æŠµå…\r\n',0),(108095,3003,'sv','SkattelÃ¤ttnader efter skatt berÃ¤knas',0),(108096,3003,'it','Crediti d\'imposta dopo imposta calcolata',0),(108097,3003,'tl','',0),(108098,3003,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3616;&#3634;&#3625;&#3637;&#3627;&#3621;&#3633;&#3591;&#3588;&#3635;&#3609;&#3623;&#3603;&#3616;&#3634;&#3625;&#3637;',0),(108099,3003,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(108100,3003,'ms','Kredit cukai selepas cukai dikira',0),(108101,3003,'ar','Ø§Ù„Ø¥Ø¹ÙØ§Ø¡Ø§Øª Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ© Ø¨Ø¹Ø¯ Ø§Ø­ØªØ³Ø§Ø¨ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(108102,3003,'fr','CrÃ©dits d\'impÃ´t aprÃ¨s impÃ´t calculÃ©',0),(108103,3003,'jp','ç¨Žè¨ˆç®—å¾Œã?®ç¨ŽæŽ§é™¤',0),(108104,3003,'pt','CrÃ©ditos fiscais apÃ³s imposto calculado',0),(108105,3003,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ñ‹ Ð¿Ð¾ÑÐ»Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°, Ð¸ÑÑ‡Ð¸ÑÐ»ÑÐµÐ¼Ð¾Ð³Ð¾',0),(108106,3003,'es','Creditos de Impuestos despuÃ©s de Calcular los Impuestos',0),(108107,3003,'de','Steuergutschriften nach Steuern berechnet',0),(108108,3003,'en','Tax credits after tax calculated',0),(108109,3004,'is','',0),(108110,3004,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(108111,3004,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(108112,3004,'tr','Vergi baÅŸarÄ±yla silindi',0),(108113,3004,'pl','Podatek przesâ”‚anie',0),(108114,3004,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(108115,3004,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù¹ÛŒÚ©Ø³',0),(108116,3004,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(108117,3004,'vi','XÃ³a thuáº¿ thÃ nh cÃ´ng',0),(108118,3004,'af','Belasting Suksesvol Geskrap',0),(108119,3004,'ro','Taxa eliminÄƒ cu succes',0),(108120,3004,'et','Maks kustutati edukalt',0),(108121,3004,'si','Davek, ki se uspeÅ¡no izbrisana',0),(108122,3004,'ba','Pajak dihapus berhasil',0),(108123,3004,'nl','Belasting met succes verwijderd',0),(108124,3004,'fi','Vero poistettu',0),(108125,3004,'no','Skatt slettet',0),(108126,3004,'da','Skat slettet',0),(108127,3004,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì„¸ê¸ˆ',0),(108128,3004,'he','×ž×¡ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(108129,3004,'el','Î¦ÏŒÏÎ¿Ï… Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(108130,3004,'zh','ç¨ŽåŠ¡æˆåŠŸåˆ é™¤\r\n',0),(108131,3004,'sv','Skatt raderades',0),(108132,3004,'it','Fiscale eliminato con successo',0),(108133,3004,'tl','',0),(108134,3004,'th','&#3621;&#3610;&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(108135,3004,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(108136,3004,'ms','Cukai dihapuskan dengan jayanya',0),(108137,3004,'ar','Ø­Ø°ÙØª Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(108138,3004,'fr','ImpÃ´t supprimÃ© avec succÃ¨s',0),(108139,3004,'jp','ç¨Žã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(108140,3004,'pt','Imposto excluÃ­do com sucesso',0),(108141,3004,'ru','ÐÐ°Ð»Ð¾Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(108142,3004,'es','Impuesto Eliminado Exitosamente',0),(108143,3004,'de','Steuern erfolgreich gelÃ¶scht',0),(108144,3004,'en','Tax Deleted Successfully',0),(108145,3005,'is','',0),(108146,3005,'dr','Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§Øª',0),(108147,3005,'pr','Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§Øª',0),(108148,3005,'tr','Vergi muafiyeti',0),(108149,3005,'pl','Zwolnienie z podatku',0),(108150,3005,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº',0),(108151,3005,'ur','Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(108152,3005,'sr','Ð˜Ð·ÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð¾Ð´ Ð¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð°ÑšÐ°',0),(108153,3005,'vi','Miá»…n thuáº¿',0),(108154,3005,'af','Belasting Vrystelling',0),(108155,3005,'ro','Scutirea de impozit',0),(108156,3005,'et','Maksuvabastus',0),(108157,3005,'si','Oprostitve davka',0),(108158,3005,'ba','Pembebasan pajak',0),(108159,3005,'nl','Belastingvrijstelling',0),(108160,3005,'fi','Verovapaus',0),(108161,3005,'no','Skattefritak',0),(108162,3005,'da','Skattefrihed',0),(108163,3005,'ko','ì„¸ê¸ˆ ë©´ì œ',0),(108164,3005,'he','. ×¤×˜×•×¨ ×ž×ž×¡',0),(108165,3005,'el','Î‘Ï€Î±Î»Î»Î±Î³Î® Î±Ï€ÏŒ Ï„Î¿ Ï†ÏŒÏÎ¿',0),(108166,3005,'zh','å…ç¨Ž\r\n',0),(108167,3005,'sv','Skattebefrielse',0),(108168,3005,'it','Esenzione fiscale',0),(108169,3005,'tl','',0),(108170,3005,'th','&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(108171,3005,'hi','à¤•à¤° à¤›à¥‚à¤Ÿ',0),(108172,3005,'ms','Pengecualian cukai',0),(108173,3005,'ar','Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ',0),(108174,3005,'fr','ExonÃ©ration fiscale',0),(108175,3005,'jp','ç¨ŽæŽ§é™¤',0),(108176,3005,'pt','IsenÃ§Ã£o fiscal',0),(108177,3005,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ ÐžÑ‚ ÐÐ°Ð»Ð¾Ð³Ð°',0),(108178,3005,'es','ExenciÃ³n de Impuesto',0),(108179,3005,'de','Steuerbefreiung',0),(108180,3005,'en','Tax Exemption',0),(108181,3006,'is','',0),(108182,3006,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(108183,3006,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(108184,3006,'tr','Yeni vergi muafiyeti',0),(108185,3006,'pl','Nowe zwolnienie z podatku',0),(108186,3006,'bg','ÐÐ¾Ð²Ð¸ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº',0),(108187,3006,'ur','Ù†Ø¦Û’ Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(108188,3006,'sr','ÐÐ¾Ð²Ð¸ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½Ð¾Ð³ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(108189,3006,'vi','ThÃªm Miá»…n thuáº¿',0),(108190,3006,'af','Belasting Vrystelling Skep',0),(108191,3006,'ro','Scutirea de impozit nou',0),(108192,3006,'et','Uus maksuvabastus',0),(108193,3006,'si','Nove davÄne oprostitve',0),(108194,3006,'ba','Pembebasan pajak baru',0),(108195,3006,'nl','Nieuwe fiscale vrijstelling',0),(108196,3006,'fi','Uusi verovapautus',0),(108197,3006,'no','Nye skattefritak',0),(108198,3006,'da','Nye skattefrihed',0),(108199,3006,'ko','ìƒˆë¡œìš´ ì„¸ê¸ˆ ë©´ì œ',0),(108200,3006,'he','×¤×˜×•×¨ ×ž×ž×¡ ×—×“×©',0),(108201,3006,'el','ÎÎ­Î± Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Î±Ï€Î±Î»Î»Î±Î³Î®',0),(108202,3006,'zh','æ–°å¢žå…ç¨Ž\r\n',0),(108203,3006,'sv','Nya skattebefrielse',0),(108204,3006,'it','Nuova esenzione fiscale',0),(108205,3006,'tl','',0),(108206,3006,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(108207,3006,'hi','à¤¨à¤¯à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤›à¥‚à¤Ÿ',0),(108208,3006,'ms','Pengecualian cukai baru',0),(108209,3006,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø¹ÙØ§Ø¡ Ø¶Ø±ÙŠØ¨ÙŠ',0),(108210,3006,'fr','Nouvelle dÃ©fiscalisation',0),(108211,3006,'jp','ç¨ŽæŽ§é™¤ã?®è¿½åŠ ',0),(108212,3006,'pt','Nova isenÃ§Ã£o de imposto',0),(108213,3006,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ ÐžÑ‚ ÐÐ°Ð»Ð¾Ð³Ð°',0),(108214,3006,'es','ExenciÃ³n de Impuesto Agregar',0),(108215,3006,'de','Neue Steuerbefreiung',0),(108216,3006,'en','New Tax Exemption',0),(108217,3007,'is','',0),(108218,3007,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(108219,3007,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(108220,3007,'tr','Vergi muafiyeti baÅŸarÄ±yla eklendi',0),(108221,3007,'pl','PomyÅ›lnie dodano zwolnienia z podatku',0),(108222,3007,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(108223,3007,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(108224,3007,'sr','Ð˜Ð·ÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð¾Ð´ Ð¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð°ÑšÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(108225,3007,'vi','ThÃªm Miá»…n thuáº¿ thÃ nh cÃ´ng',0),(108226,3007,'af','Belasting Vrystelling suksesvol geskep',0),(108227,3007,'ro','Scutirea de impozit adÄƒugat cu succes',0),(108228,3007,'et','Lisatud maksuvabastus',0),(108229,3007,'si','Oprostitev davka, ki se uspeÅ¡no dodani',0),(108230,3007,'ba','Pembebasan pajak ditambahkan berhasil',0),(108231,3007,'nl','Belastingvrijstelling toegevoegd',0),(108232,3007,'fi','Verovapautus lisÃ¤Ã¤minen onnistui',0),(108233,3007,'no','Skattefritak lagt',0),(108234,3007,'da','Skattefritagelse tilfÃ¸jet',0),(108235,3007,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì„¸ê¸ˆ ë©´ì œ',0),(108236,3007,'he','×¤×˜×•×¨ ×ž×ž×¡ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(108237,3007,'el','Î¦Î¿ÏÎ¿Î±Ï€Î±Î»Î»Î±Î³Î® Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(108238,3007,'zh','å…ç¨Žæ·»åŠ æˆåŠŸ\r\n',0),(108239,3007,'sv','Skattebefrielse som lagts',0),(108240,3007,'it','Esenzione fiscale aggiunto con successo',0),(108241,3007,'tl','',0),(108242,3007,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(108243,3007,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤›à¥‚à¤Ÿ',0),(108244,3007,'ms','Pengecualian cukai yang berjaya menambah',0),(108245,3007,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(108246,3007,'fr','DÃ©fiscalisation ajoutÃ©e avec succÃ¨s',0),(108247,3007,'jp','ç¨ŽæŽ§é™¤ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(108248,3007,'pt','IsenÃ§Ã£o de imposto adicionada com sucesso',0),(108249,3007,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ ÐžÑ‚ ÐÐ°Ð»Ð¾Ð³Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾',0),(108250,3007,'es','ExenciÃ³n de Impuesto agregado exitosamente',0),(108251,3007,'de','Steuerbefreiung erfolgreich hinzugefÃ¼gt',0),(108252,3007,'en','Tax Exemption added successfully',0),(108253,3008,'is','',0),(108254,3008,'dr','Ø­Ø°Ù Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(108255,3008,'pr','Ø­Ø°Ù Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(108256,3008,'tr','Vergi muafiyeti baÅŸarÄ±yla silindi',0),(108257,3008,'pl','Zwolnienie z podatku przesâ”‚anie',0),(108258,3008,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(108259,3008,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(108260,3008,'sr','Ð˜Ð·ÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð¾Ð´ Ð¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð°ÑšÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(108261,3008,'vi','XÃ³a Miá»…n thuáº¿ thÃ nh cÃ´ng',0),(108262,3008,'af','Belasting Vrystelling suksesvol geskrap',0),(108263,3008,'ro','Scutirea de impozit eliminÄƒ cu succes',0),(108264,3008,'et','Edukalt kustutatud maksuvabastus',0),(108265,3008,'si','Oprostitev davka, ki se uspeÅ¡no izbrisana',0),(108266,3008,'ba','Pembebasan pajak dihapus berhasil',0),(108267,3008,'nl','Belastingvrijstelling succesvol verwijderd',0),(108268,3008,'fi','Verovapautus poistettu',0),(108269,3008,'no','Skattefritak slettet',0),(108270,3008,'da','Skattefritagelse slettet',0),(108271,3008,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì„¸ê¸ˆ ë©´ì œ',0),(108272,3008,'he','×¤×˜×•×¨ ×ž×ž×¡ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(108273,3008,'el','Î¦Î¿ÏÎ¿Î±Ï€Î±Î»Î»Î±Î³Î® Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(108274,3008,'zh','å…ç¨Žåˆ é™¤æˆåŠŸ\r\n',0),(108275,3008,'sv','Skattebefrielsen raderades',0),(108276,3008,'it','Esenzione fiscale eliminato con successo',0),(108277,3008,'tl','',0),(108278,3008,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(108279,3008,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤›à¥‚à¤Ÿ',0),(108280,3008,'ms','Pengecualian cukai dihapuskan dengan jayanya',0),(108281,3008,'ar','Ø­Ø°Ù Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(108282,3008,'fr','ExonÃ©ration de l\'impÃ´t supprimÃ©e avec succÃ¨s',0),(108283,3008,'jp','ç¨ŽæŽ§é™¤ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(108284,3008,'pt','IsenÃ§Ã£o de imposto excluÃ­da com sucesso',0),(108285,3008,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ ÐžÑ‚ ÐÐ°Ð»Ð¾Ð³Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾',0),(108286,3008,'es','ExenciÃ³n de Impuesto eliminado exitosamente',0),(108287,3008,'de','Steuerbefreiung erfolgreich gelÃ¶scht',0),(108288,3008,'en','Tax Exemption deleted successfully',0),(108289,3009,'is','',0),(108290,3009,'dr','Ù†Ø§Ù… Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(108291,3009,'pr','Ù†Ø§Ù… Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(108292,3009,'tr','Vergi muafiyeti adÄ± zaten var',0),(108293,3009,'pl','Podatek od zwolnienia nazwy juÅ¼ istnieje',0),(108294,3009,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¸Ð¼Ðµ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(108295,3009,'ur','Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ù†Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(108296,3009,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¾ÑÐ»Ð¾Ð±Ð¾Ñ’ÐµÑšÐµ Ð¸Ð¼Ðµ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(108297,3009,'vi','TÃªn Miá»…n thuáº¿ Ä‘Ã£ cÃ³',0),(108298,3009,'af','Belasting Vrystellingnaam bestaan alreeds',0),(108299,3009,'ro','Numele de scutire impozit existÄƒ deja',0),(108300,3009,'et','Tulumaksu vabastus nimi on juba olemas',0),(108301,3009,'si','DavÄne oprostitve ime Å¾e obstaja',0),(108302,3009,'ba','Nama Pembebasan pajak sudah ada',0),(108303,3009,'nl','Fiscale vrijstelling naam bestaat al',0),(108304,3009,'fi','Veron vapautusta nimi on jo olemassa',0),(108305,3009,'no','Skatt fritak navnet finnes allerede',0),(108306,3009,'da','Skat fritagelse navn findes allerede',0),(108307,3009,'ko','ì„¸ê¸ˆ ë©´ì œ ì´ë¦„ì´ ì´ë¯¸',0),(108308,3009,'he','×©×›×‘×¨ ×§×™×™× ×©× ×¤×˜×•×¨ ×ž×ž×¡',0),(108309,3009,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Î±Ï€Î±Î»Î»Î±Î³Î® ÏŒÎ½Î¿Î¼Î± Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(108310,3009,'zh','å…ç¨Žåç§°å·²ç»å­˜åœ¨\r\n',0),(108311,3009,'sv','Skatte befrielse namnet finns redan',0),(108312,3009,'it','Nome di esenzione fiscale esiste giÃ ',0),(108313,3009,'tl','',0),(108314,3009,'th','&#3594;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(108315,3009,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤›à¥‚à¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(108316,3009,'ms','Nama pengecualian cukai telah wujud',0),(108317,3009,'ar','Ø¥Ø³Ù… Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(108318,3009,'fr','Nom d\'Exemption de taxe existe dÃ©jÃ ',0),(108319,3009,'jp','ç¨ŽæŽ§é™¤å??ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(108320,3009,'pt','Nome de isenÃ§Ã£o fiscal jÃ¡ existe',0),(108321,3009,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ ÐžÑ‚ ÐÐ°Ð»Ð¾Ð³Ð° ÑƒÐ¶Ðµ ÑÐ¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ÑÑ',0),(108322,3009,'es','Nombre de ExenciÃ³n de Impuesto ya existe',0),(108323,3009,'de','MwSt.-Befreiung-Namen ist bereits vorhanden.',0),(108324,3009,'en','Tax Exemption Name already exists',0),(108325,3010,'is','',0),(108326,3010,'dr','Ø¯Ù„ÙŠÙ„ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(108327,3010,'pr','Ø¯Ù„ÙŠÙ„ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(108328,3010,'tr','Vergi muafiyet sebebi',0),(108329,3010,'pl','PowÃ³d zwolnienia podatkowe',0),(108330,3010,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(108331,3010,'ur','Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ú©ÛŒ ÙˆØ¬Û',0),(108332,3010,'sr','Ð Ð°Ð·Ð»Ð¾Ð³ Ð·Ð° Ð¸Ð·ÑƒÐ·ÐµÑ›Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(108333,3010,'vi','LÃ½ do Miá»…n thuáº¿',0),(108334,3010,'af','Rede vir Belasting Vrystelling',0),(108335,3010,'ro','Motivul pentru scutirea de impozit',0),(108336,3010,'et','Maksudest vabastamise pÃµhjus',0),(108337,3010,'si','Razlog za oprostitev davka',0),(108338,3010,'ba','Alasan Pembebasan pajak',0),(108339,3010,'nl','Fiscale vrijstelling reden',0),(108340,3010,'fi','Vero poikkeuksen syy',0),(108341,3010,'no','Skatt fritak grunn',0),(108342,3010,'da','Skat fritagelse grund',0),(108343,3010,'ko','ì„¸ê¸ˆ ë©´ì œ ì´ìœ ',0),(108344,3010,'he','×¡×™×‘×ª ×¤×˜×•×¨ ×ž×ž×¡',0),(108345,3010,'el','Î›ÏŒÎ³Î¿Ï‚ ÎµÎ¾Î±Î¯ÏÎµÏƒÎ·Ï‚ Ï†ÏŒÏÎ¿Ï…',0),(108346,3010,'zh','å…ç¨ŽåŽŸå› \r\n',0),(108347,3010,'sv','Skattebefrielse anledning',0),(108348,3010,'it','Motivo di esenzione fiscale',0),(108349,3010,'tl','',0),(108350,3010,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3651;&#3609;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(108351,3010,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤›à¥‚à¤Ÿ à¤•à¤¾à¤°à¤£',0),(108352,3010,'ms','Sebab pengecualian cukai',0),(108353,3010,'ar','Ø³Ø¨Ø¨ Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ',0),(108354,3010,'fr','Motif d\'Exemption fiscale',0),(108355,3010,'jp','ç¨ŽæŽ§é™¤ç?†ç”±',0),(108356,3010,'pt','Motivo de isenÃ§Ã£o de imposto',0),(108357,3010,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ ÐžÑ‚ ÐÐ°Ð»Ð¾Ð³Ð°',0),(108358,3010,'es','RazÃ³n para ExenciÃ³n de Impuesto',0),(108359,3010,'de','MwSt.-Befreiung-Grund',0),(108360,3010,'en','Tax Exemption Reason',0),(108361,3011,'is','',0),(108362,3011,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(108363,3011,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(108364,3011,'tr','Vergi muafiyeti DÃ¼zenle',0),(108365,3011,'pl','Edytuj zwolnienia z podatku',0),(108366,3011,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº',0),(108367,3011,'ur','Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(108368,3011,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½Ð¾Ð³ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(108369,3011,'vi','Cáº­p Nháº­t Miá»…n Thuáº¿',0),(108370,3011,'af','Belasting Vrystelling Opdateer',0),(108371,3011,'ro','Editare scutire de impozit',0),(108372,3011,'et','Redigeeri maksuvabastus',0),(108373,3011,'si','Urejanje davÄne oprostitve',0),(108374,3011,'ba','Mengedit Pembebasan pajak',0),(108375,3011,'nl','Belastingvrijstelling bewerken',0),(108376,3011,'fi','Muokkaa verovapautus',0),(108377,3011,'no','Redigere skattefritak',0),(108378,3011,'da','Redigere skattefrihed',0),(108379,3011,'ko','ì„¸ê¸ˆ ë©´ì œë¥¼ íŽ¸ì§‘',0),(108380,3011,'he','×œ×¢×¨×•×š. ×¤×˜×•×¨ ×ž×ž×¡',0),(108381,3011,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Î±Ï€Î±Î»Î»Î±Î³Î® Î±Ï€ÏŒ Ï„Î¿ Ï†ÏŒÏÎ¿',0),(108382,3011,'zh','å…ç¨Žæ›´æ–°\r\n',0),(108383,3011,'sv','Redigera skattebefrielse',0),(108384,3011,'it','Modificare l\'esenzione fiscale',0),(108385,3011,'tl','',0),(108386,3011,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(108387,3011,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤›à¥‚à¤Ÿ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(108388,3011,'ms','Edit pengecualian cukai',0),(108389,3011,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ',0),(108390,3011,'fr','Modifier la dÃ©fiscalisation',0),(108391,3011,'jp','ç¨ŽæŽ§é™¤ã?®æ›´æ–°',0),(108392,3011,'pt','Editar a isenÃ§Ã£o fiscal',0),(108393,3011,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ ÐžÑ‚ ÐÐ°Ð»Ð¾Ð³Ð°',0),(108394,3011,'es','Actualizar ExenciÃ³n de Impuesto',0),(108395,3011,'de','Steuerbefreiung zu bearbeiten',0),(108396,3011,'en','Edit Tax Exemption',0),(108397,3012,'is','',0),(108398,3012,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(108399,3012,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(108400,3012,'tr','Vergi muafiyeti baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(108401,3012,'pl','Zwolnienie z podatku pomyÅ›lnie zaktualizowana',0),(108402,3012,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(108403,3012,'ur','Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(108404,3012,'sr','ÐžÐ´Ð±Ð¸Ñ˜ÐµÐ½Ð¾Ð³ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(108405,3012,'vi','Cáº­p Nháº­t Miá»…n Thuáº¿ thÃ nh cÃ´ng',0),(108406,3012,'af','Belasting Vrystelling suksesvol opdateer',0),(108407,3012,'ro','Scutirea de impozit actualizat cu succes',0),(108408,3012,'et','VÃ¤rskendatud maksuvabastus',0),(108409,3012,'si','Oprostitev davka, ki se uspeÅ¡no posodobljena',0),(108410,3012,'ba','Pembebasan pajak yang berhasil',0),(108411,3012,'nl','Belastingvrijstelling bijgewerkt',0),(108412,3012,'fi','PÃ¤ivitetty verovapautus',0),(108413,3012,'no','Skattefritak oppdatert',0),(108414,3012,'da','Skattefritagelse opdateret',0),(108415,3012,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì„¸ê¸ˆ ë©´ì œ',0),(108416,3012,'he','×¤×˜×•×¨ ×ž×ž×¡ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(108417,3012,'el','Î¦Î¿ÏÎ¿Î±Ï€Î±Î»Î»Î±Î³Î® ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(108418,3012,'zh','å…ç¨ŽæˆåŠŸæ›´æ–°\r\n',0),(108419,3012,'sv','Skattebefrielsen uppdaterats',0),(108420,3012,'it','Esenzione fiscale aggiornato con successo',0),(108421,3012,'tl','',0),(108422,3012,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(108423,3012,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤° à¤›à¥‚à¤Ÿ',0),(108424,3012,'ms','Pengecualian cukai yang berjaya dikemas kini',0),(108425,3012,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(108426,3012,'fr','ExonÃ©ration de l\'impÃ´t mis Ã  jour avec succÃ¨s',0),(108427,3012,'jp','ç¨ŽæŽ§é™¤ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(108428,3012,'pt','IsenÃ§Ã£o de imposto atualizada com sucesso',0),(108429,3012,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ ÐžÑ‚ ÐÐ°Ð»Ð¾Ð³Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾',0),(108430,3012,'es','ExenciÃ³n de Impuesto actualizado exitosamente',0),(108431,3012,'de','Steuerbefreiung, die erfolgreich aktualisiert',0),(108432,3012,'en','Tax Exemption updated successfully',0),(108433,3013,'is','',0),(108434,3013,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø±Ø§ÙŠ Ø¯Ø±Ø§Ù…Ø¯ Ø³Ø§Ù„Ø§Ù†Ù‡ Ø¨ÙŠØ´ Ø§Ø² ',0),(108435,3013,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø±Ø§ÙŠ Ø¯Ø±Ø§Ù…Ø¯ Ø³Ø§Ù„Ø§Ù†Ù‡ Ø¨ÙŠØ´ Ø§Ø² ',0),(108436,3013,'tr','YÄ±llÄ±k kazanÃ§larÄ± vergi',0),(108437,3013,'pl','Podatku rocznego zysku ponad',0),(108438,3013,'bg','Ð”Ð°Ð½ÑŠÐº Ð·Ð° Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¸ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸ Ð½Ð°Ð´',0),(108439,3013,'ur','Ú©ÛŒ Ø³Ø§Ù„Ø§Ù†Û Ø¢Ù…Ø¯Ù†ÛŒ Ù¾Ø± Ù¹ÛŒÚ©Ø³',0),(108440,3013,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð·Ð° Ð³Ð¾Ð´Ð¸ÑˆÑšÐ° Ð·Ð°Ñ€Ð°Ð´Ð° Ð¿Ñ€ÐµÐºÐ¾',0),(108441,3013,'vi','Thuáº¿ cho thu nháº­p hÃ ng nÄƒm nhiá»u hÆ¡n',0),(108442,3013,'af','Belasting vir jaarlikse verdienste oor',0),(108443,3013,'ro','Fiscal pentru venitul anual peste',0),(108444,3013,'et','KÃ¤ibemaksu aastane kasum Ã¼le',0),(108445,3013,'si','Davek za letne plaÄe nad',0),(108446,3013,'ba','Pajak pendapatan tahunan lebih dari',0),(108447,3013,'nl','Belasting voor jaarlijkse winst over',0),(108448,3013,'fi','Vero vuosiansioista',0),(108449,3013,'no','Avgiften for Ã¥rlige inntekter over',0),(108450,3013,'da','Skat for Ã¥rlige indtjening over',0),(108451,3013,'ko','ì— ì—°ê°„ ìˆ˜ìž…ì— ëŒ€ í•œ ì„¸ê¸ˆ',0),(108452,3013,'he','×ž×¡ ×¢×œ ×¨×•×•×— ×©× ×ª×™ ×ž×¢×œ',0),(108453,3013,'el','Î¦ÏŒÏÎ¿Ï… Î³Î¹Î± ÎµÏ„Î®ÏƒÎ¹ÎµÏ‚ Î±Ï€Î¿Î´Î¿Ï‡Î­Ï‚ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ',0),(108454,3013,'zh','å…¨å¹´ç¨Žæ”¶æ”¶å…¥è¶…è¿‡\r\n',0),(108455,3013,'sv','Skatt fÃ¶r Ã¥rslÃ¶n Ã¶ver',0),(108456,3013,'it','Fiscale per i guadagni annuali sopra',0),(108457,3013,'tl','',0),(108458,3013,'th','&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3635;&#3652;&#3619;&#3626;&#3640;&#3607;&#3608;&#3636;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3637;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3617;&#3634;',0),(108459,3013,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤µà¤¾à¤°à¥à¤·à¤¿à¤• à¤†à¤¯ à¤•à¥‡ à¤²à¤¿à¤ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(108460,3013,'ms','Cukai pendapatan tahunan ke atas',0),(108461,3013,'ar','Ø¶Ø±ÙŠØ¨Ø© Ù„Ù„Ø¯Ø®Ù„ Ø§Ù„Ø³Ù†ÙˆÙŠ Ø¹Ù„Ù‰ Ù…Ø¯Ù‰',0),(108462,3013,'fr','Taxe pour les revenus annuels au-dessus',0),(108463,3013,'jp','ï½žä»¥ä¸Šã?®å¹´å?Žã?®ç¨Žé‡‘',0),(108464,3013,'pt','Imposto para ganhos anuais sobre',0),(108465,3013,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð³Ð¾Ð´Ð¾Ð²Ð¾Ð¹ Ð´Ð¾Ñ…Ð¾Ð´ Ð·Ð°',0),(108466,3013,'es','Impuesto para rentas anuales mÃ¡s que',0),(108467,3013,'de','Steuer fÃ¼r Jahresverdienst Ã¼ber',0),(108468,3013,'en','Tax for annual earnings over',0),(108469,3014,'is','',0),(108470,3014,'dr','(Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ) Ù…Ø§Ù„ÙŠØ§Øª ',0),(108471,3014,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª(Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ) Ù…Ø§Ù„ÙŠØ§Øª ',0),(108472,3014,'tr','Vergi bilgisi',0),(108473,3014,'pl','Informacji podatkowych',0),(108474,3014,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(108475,3014,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(108476,3014,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð˜Ð½Ñ„Ð¾',0),(108477,3014,'vi','ThÃ´ng Tin thuáº¿',0),(108478,3014,'af','Belasting Inligting',0),(108479,3014,'ro','Info taxe',0),(108480,3014,'et','KÃ¤ibemaksu Info',0),(108481,3014,'si','Davek Info',0),(108482,3014,'ba','Info pajak',0),(108483,3014,'nl','Fiscale Info',0),(108484,3014,'fi','Vero Info',0),(108485,3014,'no','Skatt informasjon',0),(108486,3014,'da','Skat Info',0),(108487,3014,'ko','ì„¸ê¸ˆ ì •ë³´',0),(108488,3014,'he','×¤×¨×˜×™ ×ž×¡',0),(108489,3014,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(108490,3014,'zh','ç¨Žæ”¶ä¿¡æ¯\r\n',0),(108491,3014,'sv','Skatt information',0),(108492,3014,'it','Info fiscali',0),(108493,3014,'tl','',0),(108494,3014,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3616;&#3634;&#3625;&#3637;',0),(108495,3014,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(108496,3014,'ms','Maklumat cukai',0),(108497,3014,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(108498,3014,'fr','Infos fiscales',0),(108499,3014,'jp','ç¨Žæƒ…å ±',0),(108500,3014,'pt','InformaÃ§Ã£o fiscal',0),(108501,3014,'ru','Ð˜Ð½Ñ„Ð¾ ÐÐ°Ð»Ð¾Ð³Ð°',0),(108502,3014,'es','Info de Impuestos',0),(108503,3014,'de','Steuer-Info',0),(108504,3014,'en','Tax Info',0),(108505,3015,'is','',0),(108506,3015,'dr','Ù…Ø§Ù„ÙŠØ§Øª  ÙƒÙ…ØªØ± Ø§Ø² ',0),(108507,3015,'pr','Ù…Ø§Ù„ÙŠØ§Øª  ÙƒÙ…ØªØ± Ø§Ø² ',0),(108508,3015,'tr','Daha az vergi',0),(108509,3015,'pl','Podatku, mniej',0),(108510,3015,'bg','Ð”Ð°Ð½ÑŠÐº, Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾',0),(108511,3015,'ur','Ù¹ÛŒÚ©Ø³ØŒ Ú©Ù…',0),(108512,3015,'sr','ÐŸÐ¾Ñ€ÐµÐ·Ð° , Ð¼Ð°ÑšÐµ',0),(108513,3015,'vi','Thuáº¿, trá»«',0),(108514,3015,'af','Belasting, minus',0),(108515,3015,'ro','Impozitare, mai puÅ£in',0),(108516,3015,'et','Maksu vÃ¤hem',0),(108517,3015,'si','Davka, manj',0),(108518,3015,'ba','Pajak, kurang',0),(108519,3015,'nl','Belastingen, minder',0),(108520,3015,'fi','Veroja, vÃ¤hemmÃ¤n',0),(108521,3015,'no','Skatt, mindre',0),(108522,3015,'da','Skat, mindre',0),(108523,3015,'ko','ì„¸ê¸ˆ, ë” ì ì€',0),(108524,3015,'he','×ž×¡, ×¤×—×•×ª',0),(108525,3015,'el','Î¦ÏŒÏÎ¿Ï…, Î»Î¹Î³ÏŒÏ„ÎµÏÎ¿',0),(108526,3015,'zh','ç¨Žï¼Œå°‘äºŽ\r\n',0),(108527,3015,'sv','Skatt, mindre',0),(108528,3015,'it','Fiscale, a meno',0),(108529,3015,'tl','',0),(108530,3015,'th','&#3616;&#3634;&#3625;&#3637; &#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;',0),(108531,3015,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸, à¤•à¤®',0),(108532,3015,'ms','Cukai, kurang',0),(108533,3015,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ØŒ Ø£Ù‚Ù„',0),(108534,3015,'fr','ImpÃ´t, Ã  moins',0),(108535,3015,'jp','Tax, less',0),(108536,3015,'pt','Impostos, menos',0),(108537,3015,'ru','ÐÐ°Ð»Ð¾Ð³,',0),(108538,3015,'es','Impuesto, menos',0),(108539,3015,'de','Steuer, weniger',0),(108540,3015,'en','Tax, less',0),(108541,3016,'is','',0),(108542,3016,'dr','Ù†Ø§Ù… Ù†Ø§Ø­ÙŠÙ‡ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(108543,3016,'pr','Ù†Ø§Ù… Ù†Ø§Ø­ÙŠÙ‡ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(108544,3016,'tr','Vergi bÃ¶lge adÄ±',0),(108545,3016,'pl','Nazwa okrÄ™gu podatkowego',0),(108546,3016,'bg','Ð˜Ð¼Ðµ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(108547,3016,'ur','Ù¹ÛŒÚ©Ø³ Ø¶Ù„Ø¹ Ú©Ø§ Ù†Ø§Ù…',0),(108548,3016,'sr','ÐžÐºÑ€ÑƒÐ³ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ðµ',0),(108549,3016,'vi','TÃªn quáº­n thuáº¿',0),(108550,3016,'af','Belasting Kantoornaam',0),(108551,3016,'ro','Fiscal din numele',0),(108552,3016,'et','Maksu linnaosa nimi',0),(108553,3016,'si','DavÄna okroÅ¾ja ime',0),(108554,3016,'ba','Nama Distrik pajak',0),(108555,3016,'nl','Fiscale District naam',0),(108556,3016,'fi','Veropiiri nimi',0),(108557,3016,'no','Skatt distriktet navn',0),(108558,3016,'da','Skat distrikt navn',0),(108559,3016,'ko','ì„¸ê¸ˆ ì§€êµ¬ ì´ë¦„',0),(108560,3016,'he','×©× ×ž×—×•×– ×ž×¡',0),(108561,3016,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ­Ï‚ Ï€ÎµÏÎ¹Î¿Ï‡Î® ÏŒÎ½Î¿Î¼Î±',0),(108562,3016,'zh','ç¨ŽåŒºåç§°\r\n',0),(108563,3016,'sv','Skatt distriktet namn',0),(108564,3016,'it','Nome distretto fiscale',0),(108565,3016,'tl','',0),(108566,3016,'th','&#3594;&#3639;&#3656;&#3629;&#3616;&#3634;&#3625;&#3637;&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;',0),(108567,3016,'hi','à¤•à¤° à¤œà¤¿à¤²à¥‡ à¤•à¤¾ à¤¨à¤¾à¤®',0),(108568,3016,'ms','Nama Daerah cukai',0),(108569,3016,'ar','Ø§Ø³Ù… Ø§Ù„Ø­ÙŠ Ø¶Ø±ÙŠØ¨Ø©',0),(108570,3016,'fr','Nom de la circonscription de taxe',0),(108571,3016,'jp','ç¨ŽåŒºåˆ†å??',0),(108572,3016,'pt','Nome de distrito de imposto',0),(108573,3016,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ€Ð°Ð¹Ð¾Ð½Ð°',0),(108574,3016,'es','Nombre de Distrito de Impuesto',0),(108575,3016,'de','Name des Steuer-Kreises',0),(108576,3016,'en','Tax District Name',0),(108577,3017,'is','',0),(108578,3017,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(108579,3017,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(108580,3017,'tr','Vergi bulunamadÄ±',0),(108581,3017,'pl','Podatku nie znaleziono',0),(108582,3017,'bg','Ð”Ð°Ð½ÑŠÐº Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(108583,3017,'ur','Ù¹ÛŒÚ©Ø³ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(108584,3017,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(108585,3017,'vi','KhÃ´ng tháº¥y thuáº¿',0),(108586,3017,'af','Belasting nie gevind',0),(108587,3017,'ro','Taxa nu a fost gÄƒsit',0),(108588,3017,'et','Maksu ei leitud',0),(108589,3017,'si','Davka ni bilo mogoÄe najti',0),(108590,3017,'ba','Pajak tidak ditemukan',0),(108591,3017,'nl','Belasting niet gevonden',0),(108592,3017,'fi','Vero ei lÃ¶ydy',0),(108593,3017,'no','Skatt ikke funnet',0),(108594,3017,'da','Skat ikke fundet',0),(108595,3017,'ko','ì„¸ê¸ˆì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(108596,3017,'he','×”×ž×¡ ×œ× × ×ž×¦×',0),(108597,3017,'el','Î¦ÏŒÏÎ¿Ï… Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(108598,3017,'zh','ç¨Žæ”¶æ²¡æœ‰æ‰¾åˆ°\r\n',0),(108599,3017,'sv','Skatten hittades inte',0),(108600,3017,'it','Fiscale non trovato',0),(108601,3017,'tl','',0),(108602,3017,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3616;&#3634;&#3625;&#3637;',0),(108603,3017,'hi','à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(108604,3017,'ms','Cukai yang tidak dijumpai',0),(108605,3017,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(108606,3017,'fr','Taxe introuvable',0),(108607,3017,'jp','ç¨Žã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(108608,3017,'pt','Imposto nÃ£o encontrado',0),(108609,3017,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(108610,3017,'es','Impuesto no se encontrÃ³',0),(108611,3017,'de','Steuer nicht gefunden',0),(108612,3017,'en','Tax not found',0),(108613,3018,'is','',0),(108614,3018,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø±Ø§ÙŠ \r\n W-2',0),(108615,3018,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø±Ø§ÙŠ \r\n W-2',0),(108616,3018,'tr','Vergi numarasÄ± W-2',0),(108617,3018,'pl','Numer identyfikacji podatkowej dla W-2',0),(108618,3018,'bg','Ð”Ð°Ð½ÑŠÑ‡ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð° W-2',0),(108619,3018,'ur','W-2 Ú©Û’ Ù„ÛŒÛ’ Ù¹ÛŒÚ©Ø³ Ù†Ù…Ø¨Ø±',0),(108620,3018,'sr','ÐŸÐ¾Ñ€ÐµÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜ Ð·Ð° W-2',0),(108621,3018,'vi','Sá»‘ thuáº¿ cho W-2',0),(108622,3018,'af','Belasting nommer vir W-2',0),(108623,3018,'ro','Fiscal pentru W-2',0),(108624,3018,'et','Maksu kood W-2',0),(108625,3018,'si','DavÄno Å¡tevilko za W-2',0),(108626,3018,'ba','Nomor pajak untuk W-2',0),(108627,3018,'nl','BTW nummer voor W-2',0),(108628,3018,'fi','Veronumero W-2',0),(108629,3018,'no','Mva-nummer for W-2',0),(108630,3018,'da','Nummeret for W-2',0),(108631,3018,'ko','W-2ì— ëŒ€ í•œ ì„¸ê¸ˆ ë²ˆí˜¸',0),(108632,3018,'he','×ž×¡×¤×¨ ×ž×ž×¡ ×¢×‘×•×¨ W-2',0),(108633,3018,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ¿Ï Î¼Î·Ï„ÏÏŽÎ¿Ï… Î¦Î Î‘ Î³Î¹Î± W-2',0),(108634,3018,'zh','ç¨Žå·W- 2\r\n',0),(108635,3018,'sv','Momsnummer fÃ¶r W-2',0),(108636,3018,'it','Numero fiscale per W-2',0),(108637,3018,'tl','',0),(108638,3018,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3626;&#3637;&#3618;&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610; W-2',0),(108639,3018,'hi','W-2 à¤•à¥‡ à¤²à¤¿à¤ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¨à¤‚à¤¬à¤°',0),(108640,3018,'ms','Cukai nombor untuk W-2',0),(108641,3018,'ar','Ø§Ù„Ø±Ù‚Ù… Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ Ø«-2',0),(108642,3018,'fr','NumÃ©ro de TVA pour W-2',0),(108643,3018,'jp','W-2ã?®ç¨Žç•ªå?·',0),(108644,3018,'pt','NÃºmero de contribuinte para W-2',0),(108645,3018,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ Ð´Ð»Ñ W-2',0),(108646,3018,'es','NÃºmero de impuesto para el W-2',0),(108647,3018,'de','Steuernummer fÃ¼r W-2',0),(108648,3018,'en','Tax number for W-2',0),(108649,3019,'is','',0),(108650,3019,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø§Ù„ÙŠØ§Øª',0),(108651,3019,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø§Ù„ÙŠØ§Øª',0),(108652,3019,'tr','Vergi gideri Ã¶denmiÅŸ',0),(108653,3019,'pl','Podatku od wydatkÃ³w',0),(108654,3019,'bg','Ð”Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(108655,3019,'ur','Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(108656,3019,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ð»Ð°Ñ‚Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(108657,3019,'vi','Chi phÃ­ ÄÃ£ tráº£ thuáº¿',0),(108658,3019,'af','Belasting Betaal Uitgawe',0),(108659,3019,'ro','Impozitului plÄƒtit cheltuieli',0),(108660,3019,'et','Tasutud kulude',0),(108661,3019,'si','Davek plaÄa stroÅ¡ke',0),(108662,3019,'ba','Pajak dibayar biaya',0),(108663,3019,'nl','Belasting betaald kosten',0),(108664,3019,'fi','Maksetut verot',0),(108665,3019,'no','Betalt bekostning',0),(108666,3019,'da','Skat betales udgiften',0),(108667,3019,'ko','ë¹„ìš©ì„ ì§€ë¶ˆ í•˜ëŠ” ì„¸ê¸ˆ',0),(108668,3019,'he','×ž×¡ ×œ×©×œ× ×”×•×¦××•×ª',0),(108669,3019,'el','Î¦ÏŒÏÎ¿Ï… Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹ Î´Î±Ï€Î¬Î½Î·',0),(108670,3019,'zh','æ”¯ä»˜ç¨Žè´¹ç”¨\r\n',0),(108671,3019,'sv','Betald skattekostnad',0),(108672,3019,'it','Tasse pagate spese',0),(108673,3019,'tl','',0),(108674,3019,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3592;&#3656;&#3634;&#3618;&#3616;&#3634;&#3625;&#3637;',0),(108675,3019,'hi','à¤µà¥à¤¯à¤¯ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°',0),(108676,3019,'ms','Cukai dibayar perbelanjaan',0),(108677,3019,'ar','Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø³Ø¯Ø¯Ø©',0),(108678,3019,'fr','Taxe payÃ©e les frais',0),(108679,3019,'jp','èª²ç¨Žæ”¯æ‰•ã?„è²»ç”¨',0),(108680,3019,'pt','Imposto pago a despesa',0),(108681,3019,'ru','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° ÑÑ‡ÐµÑ‚',0),(108682,3019,'es','Gastos de Impuesto Pagado',0),(108683,3019,'de','Bezahlte Steueraufwand',0),(108684,3019,'en','Tax Paid Expense',0),(108685,3020,'is','',0),(108686,3020,'dr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙŠØ§Øª ',0),(108687,3020,'pr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙŠØ§Øª ',0),(108688,3020,'tr','Vergi yÃ¼zde',0),(108689,3020,'pl','Procent podatku',0),(108690,3020,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° Ð½Ð° Ð´Ð°Ð½ÑŠÐºÐ°',0),(108691,3020,'ur','Ù¹ÛŒÚ©Ø³ Ú©Ø§ ÙÛŒØµØ¯',0),(108692,3020,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ð¾Ð´ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(108693,3020,'vi','% cá»§a thuáº¿',0),(108694,3020,'af','Persentasie van Belasting',0),(108695,3020,'ro','La sutÄƒ din impozit',0),(108696,3020,'et','Maksu protsent',0),(108697,3020,'si','Odstotkov davka',0),(108698,3020,'ba','Persen dari pajak',0),(108699,3020,'nl','Procent van de belasting',0),(108700,3020,'fi','Prosenttia veron',0),(108701,3020,'no','Prosent av merverdiavgift',0),(108702,3020,'da','Procent af skat',0),(108703,3020,'ko','ì„¸ê¸ˆì˜ %',0),(108704,3020,'he','××—×•×– ×”×ž×¡',0),(108705,3020,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï…',0),(108706,3020,'zh','ç¨Žæ”¶çš„ç™¾åˆ†æ¯”\r\n',0),(108707,3020,'sv','Procent av skatt',0),(108708,3020,'it','Per cento dell\'imposta',0),(108709,3020,'tl','',0),(108710,3020,'th','&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3586;&#3629;&#3591;&#3616;&#3634;&#3625;&#3637;',0),(108711,3020,'hi','à¤•à¤° à¤•à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(108712,3020,'ms','Peratus cukai',0),(108713,3020,'ar','ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ù…Ù† Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(108714,3020,'fr','Pour cent de la taxe',0),(108715,3020,'jp','ç¨ŽçŽ‡',0),(108716,3020,'pt','Por cento de imposto',0),(108717,3020,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐÐ°Ð»Ð¾Ð³Ð°',0),(108718,3020,'es','Porcentaje de Impuesto',0),(108719,3020,'de','Prozent der Steuern',0),(108720,3020,'en','Percent of Tax',0),(108721,3021,'is','',0),(108722,3021,'dr','Ø³ÙˆØ§Ù„ Ù…Ø§Ù„ÙŠØ§Øª ØŸ',0),(108723,3021,'pr','Ø³ÙˆØ§Ù„ Ù…Ø§Ù„ÙŠØ§Øª ØŸ',0),(108724,3021,'tr','Vergi mi?',0),(108725,3021,'pl','Podatek?',0),(108726,3021,'bg','Ð”Ð°Ð½ÑŠÐº?',0),(108727,3021,'ur','Ù¹ÛŒÚ©Ø³ØŸ',0),(108728,3021,'sr','ÐŸÐ¾Ñ€ÐµÐ·?',0),(108729,3021,'vi','Thuáº¿?',0),(108730,3021,'af','Belasting?',0),(108731,3021,'ro','Fiscal?',0),(108732,3021,'et','Maks?',0),(108733,3021,'si','Davka?',0),(108734,3021,'ba','Pajak?',0),(108735,3021,'nl','Belasting?',0),(108736,3021,'fi','Vero?',0),(108737,3021,'no','Skatt?',0),(108738,3021,'da','Skat?',0),(108739,3021,'ko','ì„¸ê¸ˆ?',0),(108740,3021,'he','×ž×¡?',0),(108741,3021,'el','Î¦ÏŒÏÎ¿Ï‚;',0),(108742,3021,'zh','ç¨Žï¼Ÿ\r\n',0),(108743,3021,'sv','Skatt?',0),(108744,3021,'it','Fiscale?',0),(108745,3021,'tl','',0),(108746,3021,'th','&#3588;&#3635;&#3606;&#3634;&#3617;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3616;&#3634;&#3625;&#3637;',0),(108747,3021,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸?',0),(108748,3021,'ms','Cukai?',0),(108749,3021,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ØŸ',0),(108750,3021,'fr','ImpÃ´t ?',0),(108751,3021,'jp','èª²ç¨Žã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(108752,3021,'pt','Imposto?',0),(108753,3021,'ru','ÐÐ°Ð»Ð¾Ð³?',0),(108754,3021,'es','Â¿Impuesto?',0),(108755,3021,'de','Steuer?',0),(108756,3021,'en','Tax?',0),(108757,3022,'is','',0),(108758,3022,'dr','Ù†Ø±Ø® Ù…Ø§Ù„ÙŠØ§Øª ',0),(108759,3022,'pr','Ù†Ø±Ø® Ù…Ø§Ù„ÙŠØ§Øª ',0),(108760,3022,'tr','Vergi oranÄ±',0),(108761,3022,'pl','Stawka podatku',0),(108762,3022,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(108763,3022,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø´Ø±Ø­ Ù…ÛŒÚº',0),(108764,3022,'sr','ÐŸÐ¾Ñ€ÐµÑÐºÐ° ÑÑ‚Ð¾Ð¿Ð°',0),(108765,3022,'vi','GiÃ¡ thuáº¿',0),(108766,3022,'af','Belasting Koers',0),(108767,3022,'ro','Rata de impozitare',0),(108768,3022,'et','TulumaksumÃ¤Ã¤r',0),(108769,3022,'si','DavÄna stopnja',0),(108770,3022,'ba','Tarif pajak',0),(108771,3022,'nl','Belastingtarief',0),(108772,3022,'fi','Veroprosentti',0),(108773,3022,'no','Skattesatsen',0),(108774,3022,'da','Skatteprocenten',0),(108775,3022,'ko','ì„¸ìœ¨',0),(108776,3022,'he','×©×™×¢×•×¨ ×”×ž×¡',0),(108777,3022,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŒÏ‚ ÏƒÏ…Î½Ï„ÎµÎ»ÎµÏƒÏ„Î®Ï‚',0),(108778,3022,'zh','ç¨ŽçŽ‡\r\n',0),(108779,3022,'sv','Skattesatsen',0),(108780,3022,'it','Aliquota fiscale',0),(108781,3022,'tl','',0),(108782,3022,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3616;&#3634;&#3625;&#3637;',0),(108783,3022,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¦à¤°',0),(108784,3022,'ms','Kadar cukai',0),(108785,3022,'ar','Ù…Ø¹Ø¯Ù„ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(108786,3022,'fr','Taux d\'imposition',0),(108787,3022,'jp','ç¨ŽçŽ‡',0),(108788,3022,'pt','Taxa de imposto',0),(108789,3022,'ru','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(108790,3022,'es','Tasa de Impuesto',0),(108791,3022,'de','Steuersatz',0),(108792,3022,'en','Tax Rate',0),(108793,3023,'is','',0),(108794,3023,'dr','Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(108795,3023,'pr','Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(108796,3023,'tr','Vergi tablolar baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(108797,3023,'pl','Tabele podatkowe pomyÅ›lnie zaktualizowana',0),(108798,3023,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð¸ Ð·Ð° Ð´Ð°Ð½ÑŠÐº, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(108799,3023,'ur','Ù¹ÛŒÚ©Ø³ Ø¬Ø¯Ø§ÙˆÙ„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(108800,3023,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(108801,3023,'vi','Báº£ng Thuáº¿ Cáº­p Nháº­t thÃ nh cÃ´ng',0),(108802,3023,'af','Belastingtabelle suksesvol opdateer',0),(108803,3023,'ro','Tabele fiscal actualizat cu succes',0),(108804,3023,'et','Maksu tabelite vÃ¤rskendamine Ãµnnestus',0),(108805,3023,'si','Davek tabele uspeÅ¡no posodobljena',0),(108806,3023,'ba','Tabel pajak yang berhasil',0),(108807,3023,'nl','Fiscale tabellen bijgewerkt',0),(108808,3023,'fi','PÃ¤ivitetty verotaulut',0),(108809,3023,'no','Skattetabeller oppdatert',0),(108810,3023,'da','Momstabeller opdateret',0),(108811,3023,'ko','ì„¸ê¸ˆ í…Œì´ë¸” ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(108812,3023,'he','×˜×‘×œ××•×ª ×ž×¡ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(108813,3023,'el','Î Î¯Î½Î±ÎºÎµÏ‚ Ï†ÏŒÏÎ¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(108814,3023,'zh','ç¨Žè¡¨çš„æ›´æ–°æˆåŠŸ\r\n',0),(108815,3023,'sv','Skatt tabeller uppdaterats',0),(108816,3023,'it','Tabelle fiscali aggiornati con successo',0),(108817,3023,'tl','',0),(108818,3023,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(108819,3023,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤Ÿà¥‡à¤¬à¤² à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾',0),(108820,3023,'ms','Jadual cukai yang berjaya dikemas kini',0),(108821,3023,'ar','Ø­Ø¯Ù‘Ø«Øª Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(108822,3023,'fr','Tables d\'impÃ´t mis Ã  jour avec succÃ¨s',0),(108823,3023,'jp','ç¨Žé¡?è¡¨ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(108824,3023,'pt','Tabelas de imposto atualizadas com sucesso',0),(108825,3023,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(108826,3023,'es','Tablas de impuestos actualizadas exitosamente',0),(108827,3023,'de','Steuertabellen erfolgreich aktualisiert',0),(108828,3023,'en','Tax tables updated successfully',0),(108829,3024,'is','',0),(108830,3024,'dr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(108831,3024,'pr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(108832,3024,'tr','Vergi tÃ¼rÃ¼',0),(108833,3024,'pl','Typ podatku',0),(108834,3024,'bg','Ð’Ð¸Ð´ Ð½Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸Ñ‚Ðµ',0),(108835,3024,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù…',0),(108836,3024,'sr','Ð’Ñ€ÑÑ‚Ð° ÐŸÐ”Ð’-Ð°',0),(108837,3024,'vi','Loáº¡i thuáº¿',0),(108838,3024,'af','Belastingtipe',0),(108839,3024,'ro','Tipul de impozit',0),(108840,3024,'et','Maksu tÃ¼Ã¼p',0),(108841,3024,'si','Vrsta davka',0),(108842,3024,'ba','Jenis pajak',0),(108843,3024,'nl','Fiscale Type',0),(108844,3024,'fi','ALV-tyyppi',0),(108845,3024,'no','Mva-Type',0),(108846,3024,'da','Afgiftstype.',0),(108847,3024,'ko','ì„¸ê¸ˆ ìœ í˜•',0),(108848,3024,'he','×¡×•×’ ×ž×¡',0),(108849,3024,'el','Î¤ÏÏ€Î¿Ï‚ Î¦Î Î‘',0),(108850,3024,'zh','ç¨Žé¡¹ç§ç±»\r\n',0),(108851,3024,'sv','Typ av skatte',0),(108852,3024,'it','Tipo di tassa',0),(108853,3024,'tl','',0),(108854,3024,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;',0),(108855,3024,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(108856,3024,'ms','Jenis cukai',0),(108857,3024,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(108858,3024,'fr','Type de taxe',0),(108859,3024,'jp','ç¨Žã‚¿ã‚¤ãƒ—',0),(108860,3024,'pt','Tipo de imposto',0),(108861,3024,'ru','Ð¢Ð¸Ð¿ ÐÐ°Ð»Ð¾Ð³Ð°',0),(108862,3024,'es','Tipo de Impuesto',0),(108863,3024,'de','Steuerart',0),(108864,3024,'en','Tax Type',0),(108865,3025,'is','',0),(108866,3025,'dr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(108867,3025,'pr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(108868,3025,'tr','Vergi tÃ¼rÃ¼ baÅŸarÄ±yla silindi',0),(108869,3025,'pl','Typ podatku przesâ”‚anie',0),(108870,3025,'bg','Ð’Ð¸Ð´ Ð½Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸Ñ‚Ðµ, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(108871,3025,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù…',0),(108872,3025,'sr','Ð’Ñ€ÑÑ‚Ð° ÐŸÐ”Ð’ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(108873,3025,'vi','XÃ³a Loáº¡i thuáº¿ thÃ nh cÃ´ng',0),(108874,3025,'af','Belasting Vrystelling suksesvol geskrap',0),(108875,3025,'ro','Tipul de impozit eliminÄƒ cu succes',0),(108876,3025,'et','Maksu tÃ¼Ã¼p edukalt kustutatud',0),(108877,3025,'si','Izstavljenih uspeÅ¡no izbrisana',0),(108878,3025,'ba','Jenis pajak yang berhasil dihapus',0),(108879,3025,'nl','Fiscale Type met succes verwijderd',0),(108880,3025,'fi','ALV-tyyppi poistettu',0),(108881,3025,'no','Skatt Type slettet',0),(108882,3025,'da','Skat Type slettet',0),(108883,3025,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì„¸ê¸ˆ ì¢…ë¥˜',0),(108884,3025,'he','×¡×•×’ ×”×ž×¡ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(108885,3025,'el','Î¤ÏÏ€Î¿Ï‚ Î¦Î Î‘ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(108886,3025,'zh','ç¨Žç§åˆ é™¤æˆåŠŸ\r\n',0),(108887,3025,'sv','Typ av skatte raderades',0),(108888,3025,'it','Tipo fiscale eliminato con successo',0),(108889,3025,'tl','',0),(108890,3025,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(108891,3025,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(108892,3025,'ms','Jenis cukai yang dihapuskan dengan jayanya',0),(108893,3025,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(108894,3025,'fr','Type d\'impÃ´t supprimÃ© avec succÃ¨s',0),(108895,3025,'jp','ç¨Žã‚¿ã‚¤ãƒ—ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(108896,3025,'pt','Tipo de imposto excluÃ­do com sucesso',0),(108897,3025,'ru','Ð¢Ð¸Ð¿ ÐÐ°Ð»Ð¾Ð³Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(108898,3025,'es','Tipo de Impuesto eliminado exitosamente',0),(108899,3025,'de','Steuerart erfolgreich gelÃ¶scht',0),(108900,3025,'en','Tax Type deleted successfully',0),(108901,3026,'is','',0),(108902,3026,'dr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(108903,3026,'pr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(108904,3026,'tr','Vergi tÃ¼rÃ¼ bulunamadÄ±',0),(108905,3026,'pl','Typ podatku nie znaleziono',0),(108906,3026,'bg','Ð’Ð¸Ð´ Ð½Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸Ñ‚Ðµ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(108907,3026,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù… Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(108908,3026,'sr','Ð’Ñ€ÑÑ‚Ð° ÐŸÐ”Ð’-Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(108909,3026,'vi','KhÃ´ng tháº¥y Loáº¡i thuáº¿',0),(108910,3026,'af','Belastingtipe nie gevind',0),(108911,3026,'ro','Tipul de impozit nu a fost gÄƒsit',0),(108912,3026,'et','Maksu tÃ¼Ã¼p ei leitud',0),(108913,3026,'si','Vrsta davka ni bilo mogoÄe najti',0),(108914,3026,'ba','Jenis pajak yang tidak ditemukan',0),(108915,3026,'nl','Fiscale Type niet gevonden',0),(108916,3026,'fi','ALV-tyyppi ei lÃ¶ydy',0),(108917,3026,'no','Finner ikke mva-typen',0),(108918,3026,'da','Skat Type blev ikke fundet',0),(108919,3026,'ko','ì„¸ê¸ˆ í˜•ì‹ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(108920,3026,'he','×¡×•×’ ×”×ž×¡ ×œ× × ×ž×¦×',0),(108921,3026,'el','Î¤ÏÏ€Î¿Ï‚ Î¦Î Î‘ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(108922,3026,'zh','ç¨ŽåŠ¡ç±»åž‹æœªæ‰¾åˆ°\r\n',0),(108923,3026,'sv','Typ av skatte hittades inte',0),(108924,3026,'it','Tipo fiscale non trovato',0),(108925,3026,'tl','',0),(108926,3026,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;',0),(108927,3026,'hi','à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(108928,3026,'ms','Jenis cukai yang tidak dijumpai',0),(108929,3026,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(108930,3026,'fr','Type de taxe introuvable',0),(108931,3026,'jp','ç¨Žã‚¿ã‚¤ãƒ—ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(108932,3026,'pt','Tipo de imposto nÃ£o encontrado',0),(108933,3026,'ru','Ð¢Ð¸Ð¿ ÐÐ°Ð»Ð¾Ð³Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(108934,3026,'es','Tipo de Impuesto no se encontrÃ³',0),(108935,3026,'de','Steuerart nicht gefunden',0),(108936,3026,'en','Tax Type not found',0),(108937,3027,'is','',0),(108938,3027,'dr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(108939,3027,'pr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(108940,3027,'tr','Vergi tÃ¼rÃ¼ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(108941,3027,'pl','Typ podatku pomyÅ›lnie zaktualizowana',0),(108942,3027,'bg','Ð’Ð¸Ð´ Ð½Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸Ñ‚Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(108943,3027,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(108944,3027,'sr','Ð’Ñ€ÑÑ‚Ð° ÐŸÐ”Ð’ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(108945,3027,'vi','Cáº­p nháº­t Loáº¡i thuáº¿ thÃ nh cÃ´ng',0),(108946,3027,'af','Belastingtipe suksesvol opdateer',0),(108947,3027,'ro','Tip fiscal actualizat cu succes',0),(108948,3027,'et','Maksu tÃ¼Ã¼p vÃ¤rskendamine Ãµnnestus',0),(108949,3027,'si','Izstavljenih uspeÅ¡no posodobljena',0),(108950,3027,'ba','Jenis pajak yang berhasil',0),(108951,3027,'nl','Fiscale Type bijgewerkt',0),(108952,3027,'fi','ALV-tyyppi pÃ¤ivitetty',0),(108953,3027,'no','Skatt Type oppdatert',0),(108954,3027,'da','Skat Type opdateret',0),(108955,3027,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì„¸ê¸ˆ ì¢…ë¥˜',0),(108956,3027,'he','×¡×•×’ ×”×ž×¡ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(108957,3027,'el','Î¤ÏÏ€Î¿Ï‚ Î¦Î Î‘ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(108958,3027,'zh','ç¨ŽåŠ¡ç±»åž‹æ›´æ–°æˆåŠŸ\r\n',0),(108959,3027,'sv','Typ av skatte uppdaterats',0),(108960,3027,'it','Tipo fiscale aggiornato con successo',0),(108961,3027,'tl','',0),(108962,3027,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(108963,3027,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(108964,3027,'ms','Jenis cukai yang berjaya dikemas kini',0),(108965,3027,'ar','Ø­Ø¯Ù‘Ø« Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(108966,3027,'fr','Type de taxe, mis Ã  jour avec succÃ¨s',0),(108967,3027,'jp','ç¨Žã‚¿ã‚¤ãƒ—ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(108968,3027,'pt','Tipo de imposto atualizado com sucesso',0),(108969,3027,'ru','Ð¢Ð¸Ð¿ ÐÐ°Ð»Ð¾Ð³Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(108970,3027,'es','Tipo de Impuesto actualizado exitosamente',0),(108971,3027,'de','Steuerart, die erfolgreich aktualisiert',0),(108972,3027,'en','Tax Type updated successfully',0),(108973,3028,'is','',0),(108974,3028,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(108975,3028,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(108976,3028,'tr','Vergi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(108977,3028,'pl','Podatek pomyÅ›lnie zaktualizowana',0),(108978,3028,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(108979,3028,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(108980,3028,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(108981,3028,'vi','Thuáº¿ Cáº­p Nháº­t thÃ nh cÃ´ng',0),(108982,3028,'af','Belasting suksesvol opdateer',0),(108983,3028,'ro','Fiscal actualizat cu succes',0),(108984,3028,'et','VÃ¤rskendatud maksu',0),(108985,3028,'si','Davka, ki je uspeÅ¡no posodobljena',0),(108986,3028,'ba','Pajak yang berhasil',0),(108987,3028,'nl','Belasting met succes bijgewerkt',0),(108988,3028,'fi','Vero pÃ¤ivitetty',0),(108989,3028,'no','Skatt oppdatert',0),(108990,3028,'da','Skat opdateret',0),(108991,3028,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì„¸ê¸ˆ',0),(108992,3028,'he','×ž×¡ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(108993,3028,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(108994,3028,'zh','ç¨ŽåŠ¡æˆåŠŸæ›´æ–°\r\n',0),(108995,3028,'sv','Skatt uppdaterats',0),(108996,3028,'it','Fiscale aggiornato con successo',0),(108997,3028,'tl','',0),(108998,3028,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(108999,3028,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(109000,3028,'ms','Cukai yang berjaya dikemas kini',0),(109001,3028,'ar','Ø­Ø¯Ù‘Ø«Øª Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(109002,3028,'fr','Fiscaux mis Ã  jour avec succÃ¨s',0),(109003,3028,'jp','ç¨Žã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(109004,3028,'pt','Imposto atualizado com sucesso',0),(109005,3028,'ru','ÐÐ°Ð»Ð¾Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(109006,3028,'es','Impuesto actualizado exitosamente',0),(109007,3028,'de','Steuer, die erfolgreich aktualisiert',0),(109008,3028,'en','Tax updated successfully',0),(109009,3029,'is','',0),(109010,3029,'dr','(ØªÙˆÙ‚ÙŠÙ',0),(109011,3029,'pr','Ù…Ø§Ù„ÙŠØ§Øª ÙƒØ³Ø± Ø´Ø¯Ù‡ (ØªÙˆÙ‚ÙŠÙ',0),(109012,3029,'tr','Vergi tevkif',0),(109013,3029,'pl','Podatek dochodowy',0),(109014,3029,'bg','Ð£Ð´ÑŠÑ€Ð¶Ð°Ð½Ð¸Ñ Ð´Ð°Ð½ÑŠÐº',0),(109015,3029,'ur','Ù¹ÛŒÚ©Ø³ Ú†Ø§ÛØªÛŒ ØªÚ¾ÛŒÚº',0),(109016,3029,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ñ˜Ðµ ÑÐºÑ€Ð¸Ð²Ð°Ð¾',0),(109017,3029,'vi','Thuáº¿ giá»¯ láº¡i',0),(109018,3029,'af','Belasting weerhou',0),(109019,3029,'ro','Taxa reÅ£ine',0),(109020,3029,'et','Tulumaks',0),(109021,3029,'si','DavÄnega odtegljaja',0),(109022,3029,'ba','Pajak penghasilan yang dipotong',0),(109023,3029,'nl','Belasting ingehouden',0),(109024,3029,'fi','Veron',0),(109025,3029,'no','Kildeskatt',0),(109026,3029,'da','Tilbageholdte skat',0),(109027,3029,'ko','ì„¸ê¸ˆ ë³´ë¥˜',0),(109028,3029,'he','×ž×¡ ×©× ×•×›×” ×‘×ž×§×•×¨',0),(109029,3029,'el','Î¤Î¿Ï… Ï†ÏŒÏÎ¿Ï… Ï€Î¿Ï… Ï€Î±ÏÎ±ÎºÏÎ±Ï„Î®Î¸Î·ÎºÎµ',0),(109030,3029,'zh','æ‰£ç¼´ç¨Žæ¬¾\r\n',0),(109031,3029,'sv','Skattebeloppet',0),(109032,3029,'it','Imposta trattenuta',0),(109033,3029,'tl','',0),(109034,3029,'th','&#3616;&#3634;&#3625;&#3637;&#3627;&#3633;&#3585; &#3603; &#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;',0),(109035,3029,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¤° à¤°à¥‹à¤• à¤²à¤—à¤¾à¤ˆ',0),(109036,3029,'ms','Cukai yang dipungut',0),(109037,3029,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø­ØªØ¬Ø²Ø©',0),(109038,3029,'fr','ImpÃ´t retenu',0),(109039,3029,'jp','æº?æ³‰å¾´å?Ž',0),(109040,3029,'pt','Imposto retido',0),(109041,3029,'ru','ÐÐ°Ð»Ð¾Ð³, ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð½Ñ‹Ð¹',0),(109042,3029,'es','Impuesto Retenido',0),(109043,3029,'de','Einbehaltenen Steuer',0),(109044,3029,'en','Tax Withheld',0),(109045,3030,'is','',0),(109046,3030,'dr','Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(109047,3030,'pr','Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(109048,3030,'tr','Vergiye tabi',0),(109049,3030,'pl','Opodatkowaniu',0),(109050,3030,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¾',0),(109051,3030,'ur','Ø¹Ø§Ø¦Ø¯',0),(109052,3030,'sr','ÐŸÐ»Ð°Ð¶Ð°',0),(109053,3030,'vi','Chá»‹u thuáº¿',0),(109054,3030,'af','Belasbaar',0),(109055,3030,'ro','Impozabile',0),(109056,3030,'et','Maksustatav',0),(109057,3030,'si','DavÄni zavezanec',0),(109058,3030,'ba','Pajak',0),(109059,3030,'nl','Belastbare',0),(109060,3030,'fi','Verovelvollinen',0),(109061,3030,'no','Skattepliktig',0),(109062,3030,'da','Afgiftspligtige',0),(109063,3030,'ko','ê³¼ì„¸',0),(109064,3030,'he','×—×™×™×‘ ×‘×ž×¡',0),(109065,3030,'el','Î¥Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿',0),(109066,3030,'zh','åº”çº³ç¨Ž\r\n',0),(109067,3030,'sv','Beskattningsbara',0),(109068,3030,'it','Soggetti passivi',0),(109069,3030,'tl','',0),(109070,3030,'th','&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;',0),(109071,3030,'hi','à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯',0),(109072,3030,'ms','Dikenakan cukai',0),(109073,3030,'ar','Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(109074,3030,'fr','Imposable',0),(109075,3030,'jp','èª²ç¨Žå¯¾è±¡',0),(109076,3030,'pt','TributÃ¡veis',0),(109077,3030,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ',0),(109078,3030,'es','Imponible',0),(109079,3030,'de','Steuerpflichtige',0),(109080,3030,'en','Taxable',0),(109081,3031,'is','',0),(109082,3031,'dr','Ø­Ù‚ÙˆÙ‚  Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(109083,3031,'pr','Ø­Ù‚ÙˆÙ‚  Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(109084,3031,'tr','Vergiye tabi Ã¶deme',0),(109085,3031,'pl','Opodatkowania wynagrodzenia',0),(109086,3031,'bg','ÐžÐ±Ð»Ð°Ð³Ð°ÐµÐ¼Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(109087,3031,'ur','Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ ØªÙ†Ø®ÙˆØ§Û',0),(109088,3031,'sr','ÐžÐ¿Ð¾Ñ€ÐµÐ·Ð¸Ð² Ð¿Ð»Ð°Ñ‚Ðµ',0),(109089,3031,'vi','LÆ°Æ¡ng chá»‹u thuáº¿',0),(109090,3031,'af','Belasbare Besoldiging',0),(109091,3031,'ro','ImpozabilÄƒ plata',0),(109092,3031,'et','Maksustatav tÃ¶Ã¶tasu',0),(109093,3031,'si','PlaÄilo davÄnega',0),(109094,3031,'ba','Membayar pajak',0),(109095,3031,'nl','Belastbare loon',0),(109096,3031,'fi','Veron maksu',0),(109097,3031,'no','Skattepliktig lÃ¸nn',0),(109098,3031,'da','Skattepligtig lÃ¸n',0),(109099,3031,'ko','ê³¼ì„¸ ê¸‰ì—¬',0),(109100,3031,'he','×—×™×™×‘ ×‘×ž×¡ ×©×›×¨',0),(109101,3031,'el','Î¥Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½',0),(109102,3031,'zh','åº”çº³ç¨Žç²®\r\n',0),(109103,3031,'sv','Skattepliktig lÃ¶n',0),(109104,3031,'it','Retribuzione imponibile',0),(109105,3031,'tl','',0),(109106,3031,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;',0),(109107,3031,'hi','à¤•à¤°à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨',0),(109108,3031,'ms','Membayar cukai',0),(109109,3031,'ar','Ø§Ù„Ù…Ø±ØªØ¨ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(109110,3031,'fr','RÃ©munÃ©ration imposable',0),(109111,3031,'jp','èª²ç¨Žè³ƒé‡‘',0),(109112,3031,'pt','SalÃ¡rio tributÃ¡vel',0),(109113,3031,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð¾Ð³Ð¾ Ð²Ð¾Ð·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(109114,3031,'es','Pago Imponible',0),(109115,3031,'de','Steuerpflichtiger Lohn',0),(109116,3031,'en','Taxable Pay',0),(109117,3032,'is','',0),(109118,3032,'dr','Ø­Ù‚ÙˆÙ‚  Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ…ØªØ± Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª ',0),(109119,3032,'pr','Ø­Ù‚ÙˆÙ‚  Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ…ØªØ± Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª ',0),(109120,3032,'tr','Vergiye tabi daha az vergi Ã¶demek',0),(109121,3032,'pl','Opodatkowaniu zapÅ‚aciÄ‡ mniej podatku',0),(109122,3032,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð´Ð°Ð½ÑŠÐº',0),(109123,3032,'ur','Ú©Ù… Ù¹ÛŒÚ©Ø³ Ø¹Ø§Ø¦Ø¯ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(109124,3032,'sr','ÐžÐ¿Ð¾Ñ€ÐµÐ·Ð¸Ð² Ð¿Ð»Ð°Ñ‚Ðµ Ð¼Ð°ÑšÐµ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(109125,3032,'vi','LÆ°Æ¡ng chá»‹u thuáº¿ trá»« thuáº¿',0),(109126,3032,'af','Belasbare Besoldiging Minus Belasting',0),(109127,3032,'ro','Impozabile plÄƒti impozit mai puÅ£in',0),(109128,3032,'et','Maksustatav maksta vÃ¤hem maksu',0),(109129,3032,'si','DavÄni zavezanec plaÄati manj davka',0),(109130,3032,'ba','Pajak membayar pajak lebih sedikit',0),(109131,3032,'nl','Belastbare minder belasting betalen',0),(109132,3032,'fi','Veron maksavat vÃ¤hemmÃ¤n veroja',0),(109133,3032,'no','Skattepliktig betale mindre skatt',0),(109134,3032,'da','Afgiftspligtige betale mindre i skat',0),(109135,3032,'ko','ë” ì ì€ ì„¸ê¸ˆì„ ë‚©ë¶€ í•˜ëŠ” ê³¼ì„¸',0),(109136,3032,'he','×—×™×™×‘ ×‘×ž×¡ ×œ×©×œ× ×¤×—×•×ª ×ž×¡',0),(109137,3032,'el','Î¥Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Ï…Î½ Î»Î¹Î³ÏŒÏ„ÎµÏÎ¿ Ï†ÏŒÏÎ¿',0),(109138,3032,'zh','åº”çº³ç¨Žå°‘äºŽç¨Žæ¬¾\r\n',0),(109139,3032,'sv','Skattskyldig betalar mindre skatt',0),(109140,3032,'it','Soggetti passivi pagare meno tasse',0),(109141,3032,'tl','',0),(109142,3032,'th','&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;&#3616;&#3634;&#3625;&#3637;',0),(109143,3032,'hi','à¤•à¤°à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨ à¤•à¤® à¤•à¤°',0),(109144,3032,'ms','Gaji yang kena cukai ditolak cukai',0),(109145,3032,'ar','Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© ØªØ¯ÙØ¹ Ø¶Ø±Ø§Ø¦Ø¨ Ø£Ù‚Ù„',0),(109146,3032,'fr','Taxables payer moins d\'impÃ´ts',0),(109147,3032,'jp','ç¨Žå¼•ã??èª²ç¨Žè³ƒé‡‘',0),(109148,3032,'pt','Sujeito passivo pagar menos impostos',0),(109149,3032,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼ÑƒÑŽ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð¼ÐµÐ½ÑŒÑˆÐµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(109150,3032,'es','Pago Imponible Menos Impuesto',0),(109151,3032,'de','Steuerpflichtige zahlen weniger Steuern',0),(109152,3032,'en','Taxable Pay Less Tax',0),(109153,3033,'is','',0),(109154,3033,'dr','10 ',0),(109155,3033,'pr','Ø¯Ù‡   10 ',0),(109156,3033,'tr','on',0),(109157,3033,'pl','dziesiÄ™Ä‡',0),(109158,3033,'bg','Ð´ÐµÑÐµÑ‚',0),(109159,3033,'ur','Ø¯Ø³',0),(109160,3033,'sr','Ð´ÐµÑÐµÑ‚',0),(109161,3033,'vi','mÆ°á»i',0),(109162,3033,'af','tien',0),(109163,3033,'ro','zece',0),(109164,3033,'et','kÃ¼mme',0),(109165,3033,'si','deset',0),(109166,3033,'ba','sepuluh',0),(109167,3033,'nl','tien',0),(109168,3033,'fi','kymmenen',0),(109169,3033,'no','ti',0),(109170,3033,'da','ti',0),(109171,3033,'ko','10',0),(109172,3033,'he','×¢×©×¨',0),(109173,3033,'el','Î´Î­ÎºÎ±',0),(109174,3033,'zh','å\r\n',0),(109175,3033,'sv','tio',0),(109176,3033,'it','dieci',0),(109177,3033,'tl','',0),(109178,3033,'th','&#3626;&#3636;&#3610;',0),(109179,3033,'hi','à¤¦à¤¸',0),(109180,3033,'ms','sepuluh',0),(109181,3033,'ar','Ø¹Ø´Ø±Ø©',0),(109182,3033,'fr','dix',0),(109183,3033,'jp','10',0),(109184,3033,'pt','dez',0),(109185,3033,'ru','Ð´ÐµÑÑÑ‚ÑŒ',0),(109186,3033,'es','diez',0),(109187,3033,'de','zehn',0),(109188,3033,'en','ten',0),(109189,3034,'is','',0),(109190,3034,'dr','Ù¾Ø§ÙŠØ§Ù† Ø¯Ø§Ø¯Ù† ',0),(109191,3034,'pr','Ù¾Ø§ÙŠØ§Ù† Ø¯Ø§Ø¯Ù† ',0),(109192,3034,'tr','SonlandÄ±rma',0),(109193,3034,'pl','ZakoÅ„czyÄ‡',0),(109194,3034,'bg','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‚Ð¸',0),(109195,3034,'ur','Ø®ØªÙ…',0),(109196,3034,'sr','ÐŸÑ€ÐµÐºÐ¸Ð½Ð¸Ñ‚Ðµ',0),(109197,3034,'vi','Cháº¥m dá»©t',0),(109198,3034,'af','BeeÃ«indig',0),(109199,3034,'ro','Rezilia',0),(109200,3034,'et','LÃµpetada',0),(109201,3034,'si','Prekine',0),(109202,3034,'ba','Mengakhiri',0),(109203,3034,'nl','BeÃ«indigen',0),(109204,3034,'fi','Lopettaa',0),(109205,3034,'no','Avslutte',0),(109206,3034,'da','Opsige',0),(109207,3034,'ko','ì¢…ë£Œ',0),(109208,3034,'he','×œ×¡×™×™×',0),(109209,3034,'el','Î¤ÎµÏÎ¼Î±Ï„Î¯ÏƒÎµÎ¹',0),(109210,3034,'zh','ç»ˆæ­¢\r\n',0),(109211,3034,'sv','Avsluta',0),(109212,3034,'it','Terminare',0),(109213,3034,'tl','',0),(109214,3034,'th','&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(109215,3034,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤•à¤°',0),(109216,3034,'ms','Menamatkan',0),(109217,3034,'ar','Ø¥Ù†Ù‡Ø§Ø¡',0),(109218,3034,'fr','RÃ©silier',0),(109219,3034,'jp','çµ‚çµ?',0),(109220,3034,'pt','Encerrar',0),(109221,3034,'ru','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‚Ð¸Ñ‚ÑŒ',0),(109222,3034,'es','Terminar',0),(109223,3034,'de','KÃ¼ndigen',0),(109224,3034,'en','Terminate',0),(109225,3035,'is','',0),(109226,3035,'dr','(Ø¹Ø¨Ø§Ø±Øª Ù‡Ø§',0),(109227,3035,'pr','Ø´Ø±Ø§ÙŠØ·(Ø¹Ø¨Ø§Ø±Øª Ù‡Ø§',0),(109228,3035,'tr','Åžartlar',0),(109229,3035,'pl','Warunki',0),(109230,3035,'bg','Ð¢ÐµÑ€Ð¼Ð¸Ð½Ð¸',0),(109231,3035,'ur','Ø´Ø±Ø§Ø¦Ø·',0),(109232,3035,'sr','Ð£ÑÐ»Ð¾Ð²Ð¸',0),(109233,3035,'vi','Äiá»u khoáº£n',0),(109234,3035,'af','Terme',0),(109235,3035,'ro','Termeni',0),(109236,3035,'et','Tingimused',0),(109237,3035,'si','Pogoji',0),(109238,3035,'ba','Persyaratan',0),(109239,3035,'nl','Voorwaarden',0),(109240,3035,'fi','Ehdot',0),(109241,3035,'no','VilkÃ¥r',0),(109242,3035,'da','VilkÃ¥r',0),(109243,3035,'ko','ì´ìš© ì•½ê´€',0),(109244,3035,'he','×ª× ××™×',0),(109245,3035,'el','ÎŒÏÎ¿Î¹',0),(109246,3035,'zh','æ¡æ¬¾\r\n',0),(109247,3035,'sv','Villkor',0),(109248,3035,'it','Termini',0),(109249,3035,'tl','',0),(109250,3035,'th','&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;',0),(109251,3035,'hi','à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(109252,3035,'ms','Terma-terma',0),(109253,3035,'ar','Ø´Ø±ÙˆØ· Ø§Ù„Ø³Ø¯Ø§Ø¯',0),(109254,3035,'fr','Termes',0),(109255,3035,'jp','æ?¡ä»¶',0),(109256,3035,'pt','Termos',0),(109257,3035,'ru','Ð¢ÐµÑ€Ð¼Ð¸Ð½Ñ‹',0),(109258,3035,'es','TÃ©rminos',0),(109259,3035,'de','Begriffe',0),(109260,3035,'en','Terms',0),(109261,3036,'is','',0),(109262,3036,'dr','Ù‚Ø³Ù…Øª Ù†ÙƒØªÙ‡ Ù…ØªÙ† ',0),(109263,3036,'pr','Ù‚Ø³Ù…Øª Ù†ÙƒØªÙ‡ Ù…ØªÙ† ',0),(109264,3036,'tr','Not metin bÃ¶lÃ¼mÃ¼nÃ¼',0),(109265,3036,'pl','CzÄ™Å›Ä‡ tekstu Uwaga',0),(109266,3036,'bg','Ð¢ÐµÐºÑÑ‚Ð¾Ð²Ð°Ñ‚Ð° Ñ‡Ð°ÑÑ‚ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(109267,3036,'ur','Ù†ÙˆÙ¹ Ú©ÛŒ Ù…ØªÙ† Ú©Ø§ Ø­ØµÛ',0),(109268,3036,'sr','Ð”ÐµÐ¾ Ñ‚ÐµÐºÑÑ‚ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(109269,3036,'vi','Pháº§n VÄƒn báº£n trong ghi chÃº',0),(109270,3036,'af','Teksposissie van Nota',0),(109271,3036,'ro','PorÅ£iune de text de nota',0),(109272,3036,'et','MÃ¤rkuse teksti osa',0),(109273,3036,'si','Del besedila opombe',0),(109274,3036,'ba','Sebagian teks catatan',0),(109275,3036,'nl','Tekstgedeelte van notitie',0),(109276,3036,'fi','Tekstiosuuden Huomautus',0),(109277,3036,'no','Tekstdelen av notatet',0),(109278,3036,'da','Tekstdelen af Note',0),(109279,3036,'ko','ë©”ëª¨ì˜ í…ìŠ¤íŠ¸ ë¶€ë¶„',0),(109280,3036,'he','×—×œ×§ ×”×˜×§×¡×˜ ×©×œ ×”×¢×¨×”',0),(109281,3036,'el','Î¤Î¼Î®Î¼Î± ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Ï„Î·Ï‚ ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·Ï‚',0),(109282,3036,'zh','æ³¨é‡Šçš„æ–‡æœ¬éƒ¨åˆ†\r\n',0),(109283,3036,'sv','Textdelen av Obs',0),(109284,3036,'it','Parte del testo della nota',0),(109285,3036,'tl','',0),(109286,3036,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(109287,3036,'hi','à¤¨à¥‹à¤Ÿ à¤•à¤¾ à¤ªà¤¾à¤  à¤­à¤¾à¤—',0),(109288,3036,'ms','Bahagian teks Nota',0),(109289,3036,'ar','Ø¬Ø²Ø¡ Ø§Ù„Ù†Øµ Ù…Ù† Ù…Ù„Ø§Ø­Ø¸Ø©',0),(109290,3036,'fr','Partie de texte de la Note',0),(109291,3036,'jp','ãƒ¡ãƒ¢ã?®æ–‡ç« éƒ¨åˆ†',0),(109292,3036,'pt','Parte do texto da nota',0),(109293,3036,'ru','Ð¢ÐµÐºÑÑ‚Ð¾Ð²Ð°Ñ Ñ‡Ð°ÑÑ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÐºÐ¸',0),(109294,3036,'es','PorciÃ³n Texto de Nota',0),(109295,3036,'de','Textteil der Hinweis',0),(109296,3036,'en','Text Portion of Note',0),(109297,3037,'is','',0),(109298,3037,'dr','!',0),(109299,3037,'pr','Ù…ØªØ´ÙƒØ±ÙŠÙ… !',0),(109300,3037,'tr','TeÅŸekkÃ¼r ederiz!',0),(109301,3037,'pl','DziÄ™kujemy!',0),(109302,3037,'bg','Ð‘Ð»Ð°Ð³Ð¾Ð´Ð°Ñ€Ñ!',0),(109303,3037,'ur','Ø´Ú©Ø±ÙŠØ§!',0),(109304,3037,'sr','Ð¥Ð²Ð°Ð»Ð° Ñ‚Ð¸!',0),(109305,3037,'vi','CÃ¡m Æ n!',0),(109306,3037,'af','Dankie!',0),(109307,3037,'ro','vÄƒ mulÅ£umesc!',0),(109308,3037,'et','AitÃ¤h!',0),(109309,3037,'si','hvala!',0),(109310,3037,'ba','Terima kasih!',0),(109311,3037,'nl','Bedankt!',0),(109312,3037,'fi','Kiitos!',0),(109313,3037,'no','takk!',0),(109314,3037,'da','Tak!',0),(109315,3037,'ko','ê°ì‚¬í•©ë‹ˆë‹¤!',0),(109316,3037,'he','!×ª×•×“×” ×¨×‘×”',0),(109317,3037,'el','Î•Ï…Ï‡Î±ÏÎ¹ÏƒÏ„Î¿ÏÎ¼Îµ!',0),(109318,3037,'zh','è°¢è°¢ï¼\r\n',0),(109319,3037,'sv','Tack!',0),(109320,3037,'it','Grazie!',0),(109321,3037,'tl','',0),(109322,3037,'th','&#3586;&#3629;&#3610;&#3588;&#3640;&#3603;!',0),(109323,3037,'hi','à¤§à¤¨à¥à¤¯à¤µà¤¾à¤¦!',0),(109324,3037,'ms','terima kasih!',0),(109325,3037,'ar','Ø´ÙƒØ±Ø§!',0),(109326,3037,'fr','Merci!',0),(109327,3037,'jp','ã?‚ã‚Šã?Œã?¨ã?†ã?”ã?–ã?„ã?¾ã?™ï¼?',0),(109328,3037,'pt','Obrigado!',0),(109329,3037,'ru','Ð¡Ð¿Ð°ÑÐ¸Ð±Ð¾!',0),(109330,3037,'es','Gracias!',0),(109331,3037,'de','Vielen Dank!',0),(109332,3037,'en','Thank you!',0),(109333,3038,'is','',0),(109334,3038,'dr','Ù…ØªØ´ÙƒØ±ÙŠÙ… Ø¨Ø§Ø¨Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙŠÙƒ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ú†Ø§Ù¾ÙŠ',0),(109335,3038,'pr','Ù…ØªØ´ÙƒØ±ÙŠÙ… Ø¨Ø§Ø¨Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙŠÙƒ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ú†Ø§Ù¾ÙŠ',0),(109336,3038,'tr','BaskÄ± teklif istemek iÃ§in teÅŸekkÃ¼r ederim',0),(109337,3038,'pl','DziÄ™kujÄ™ za proÅ›bÄ… o wycenÄ™ druku',0),(109338,3038,'bg','Ð‘Ð»Ð°Ð³Ð¾Ð´Ð°Ñ€Ñ Ñ‚Ð¸ Ð·Ð° Ð¼Ð¾Ð»Ð±Ð° Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(109339,3038,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Û’ Ù„Ø¦Û’ Ø¢Ù¾ Ú©Ø§ Ø´Ú©Ø±ÛŒÛ',0),(109340,3038,'sr','Ð¥Ð²Ð°Ð»Ð° Ñ‚Ð¸ Ð·Ð° Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¸Ð·Ñ€Ð°Ð´Ñƒ Ñ„Ð¾Ñ‚Ð¾Ð³Ñ€Ð°Ñ„Ð¸Ñ˜Ð°',0),(109341,3038,'vi','CÃ¡m Æ¡n báº¡n Ä‘Ã£ yÃªu cáº§u bÃ¡o giÃ¡ in',0),(109342,3038,'af','Dankie dat u \'n gedrukte kwotasie versoek het.',0),(109343,3038,'ro','VÄƒ mulÅ£umim pentru a solicita un citat de imprimare',0),(109344,3038,'et','TÃ¤name taotleva trÃ¼ki hinnapakkumine',0),(109345,3038,'si','The same zakaj proÅ¡nja tiskanje citat',0),(109346,3038,'ba','Terima kasih untuk meminta sebuah kutipan Percetakan',0),(109347,3038,'nl','Dank u voor het aanvragen van een offerte afdrukken',0),(109348,3038,'fi','Kiitos kysymÃ¤stÃ¤ tulostus lainaus',0),(109349,3038,'no','Takk for Ã¥ be om en utskrift tilbud',0),(109350,3038,'da','Tak for at anmode om en udskrivning citat',0),(109351,3038,'ko','ì¸ì‡„ ê²¬ì  ìš”ì²­ í•´ ì£¼ì…”ì„œ ê°ì‚¬ í•©ë‹ˆë‹¤',0),(109352,3038,'he','×ª×•×“×” ×œ×š ×©××ª×” ×ž×‘×§×© ×”×¦×¢×ª ×ž×—×™×¨ ×”×”×“×¤×¡×”',0),(109353,3038,'el','Î£Î±Ï‚ ÎµÏ…Ï‡Î±ÏÎ¹ÏƒÏ„ÏŽ Î³Î¹Î± Î¶Î·Ï„ÏŽÎ½Ï„Î±Ï‚ Î¼Î¹Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Ï„Î·Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(109354,3038,'zh','æ„Ÿè°¢æ‚¨è¦æ±‚å°åˆ·æŠ¥ä»·\r\n',0),(109355,3038,'sv','Tack fÃ¶r att begÃ¤ra en utskrift offert',0),(109356,3038,'it','Grazie per la richiesta di un preventivo di stampa',0),(109357,3038,'tl','',0),(109358,3038,'th','&#3586;&#3629;&#3610;&#3588;&#3640;&#3603;&#3607;&#3637;&#3656;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3',0),(109359,3038,'hi','à¤à¤• à¤®à¥à¤¦à¥à¤°à¤£ à¤¬à¥‹à¤²à¥€ à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤•à¥‡ à¤²à¤¿à¤ à¤§à¤¨à¥à¤¯à¤µà¤¾à¤¦',0),(109360,3038,'ms','Terima kasih kerana meminta sebut harga percetakan',0),(109361,3038,'ar','Ø´ÙƒØ±Ø§ Ù„Ùƒ Ù„Ø·Ù„Ø¨ Ø¹Ø±Ø¶ Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(109362,3038,'fr','Merci de demander un devis d\'impression',0),(109363,3038,'jp','è¦‹ç©?å?°åˆ·ã?®ãƒªã‚¯ã‚¨ã‚¹ãƒˆã?‚ã‚Šã?Œã?¨ã?†ã?”ã?–ã?„ã?¾ã?™',0),(109364,3038,'pt','Obrigado por solicitar uma cotaÃ§Ã£o de impressÃ£o',0),(109365,3038,'ru','Ð‘Ð»Ð°Ð³Ð¾Ð´Ð°Ñ€Ð¸Ð¼ Ð²Ð°Ñ Ð·Ð° Ð¿Ñ€Ð¾ÑÑŒÐ±Ð¾Ð¹ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(109366,3038,'es','Gracias a usted para pedir una cotizaciÃ³n de ImpresiÃ³n',0),(109367,3038,'de','Vielen Dank fÃ¼r ein Druck-Angebot anfordern',0),(109368,3038,'en','Thank you for requesting a printing quote',0),(109369,3039,'is','',0),(109370,3039,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù†Ø¯ ',0),(109371,3039,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù†Ø¯ ',0),(109372,3039,'tr','Hesap baÅŸarÄ±yla eklendi.',0),(109373,3039,'pl','Rachunki zostaÅ‚y dodane pomyÅ›lnie.',0),(109374,3039,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ Ð±ÑÑ…Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(109375,3039,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(109376,3039,'sr','ÐšÐ¾Ð½Ñ‚Ð° ÑÑƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ðµ.',0),(109377,3039,'vi','TK thÃªm vÃ o thÃ nh cÃ´ng',0),(109378,3039,'af','Die rekeninge was suksesvol bygevoeg.',0),(109379,3039,'ro','Conturile au fost adÄƒugate cu succes.',0),(109380,3039,'et','Raamatupidamise lisati edukalt.',0),(109381,3039,'si','RaÄuni so bili uspeÅ¡no dodani.',0),(109382,3039,'ba','Rekening ditambahkan berhasil.',0),(109383,3039,'nl','De rekeningen werden met succes toegevoegd.',0),(109384,3039,'fi','Tilien lisÃ¤Ã¤minen onnistui.',0),(109385,3039,'no','Kontoene ble lagt.',0),(109386,3039,'da','Regnskabet blev tilfÃ¸jet med succes.',0),(109387,3039,'ko','ê³„ì •ì„ì€ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(109388,3039,'he','.×”×—×©×‘×•× ×•×ª × ×•×¡×¤×• ×‘×”×¦×œ×—×”',0),(109389,3039,'el','ÎŸÎ¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎ±Î½ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(109390,3039,'zh','è¯¥å¸æˆ·æ·»åŠ æˆåŠŸã€‚\r\n',0),(109391,3039,'sv','RÃ¤kenskaperna har lagts till.',0),(109392,3039,'it','I conti sono stati aggiunti correttamente.',0),(109393,3039,'tl','',0),(109394,3039,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(109395,3039,'hi','à¤–à¤¾à¤¤à¥‹à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤¥à¤¾à¥¤',0),(109396,3039,'ms','Akaun-akaun telah berjaya menambah.',0),(109397,3039,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(109398,3039,'fr','Les comptes ont Ã©tÃ© ajoutÃ©s avec succÃ¨s.',0),(109399,3039,'jp','ã??ã?®å?£åº§ã?¯è¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(109400,3039,'pt','As contas foram adicionadas com Ãªxito.',0),(109401,3039,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹.',0),(109402,3039,'es','La cuentas se agregaron exitosamente',0),(109403,3039,'de','Die Konten wurden erfolgreich hinzugefÃ¼gt.',0),(109404,3039,'en','The accounts were added successfully.',0),(109405,3040,'is','',0),(109406,3040,'dr','(Ù…Ø¯ÙŠØ±ÙŠØª Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡) Ù†ØµØ¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(109407,3040,'pr','Ú†Ø§Ø±Ú†ÙˆØ¨ (Ù…Ø¯ÙŠØ±ÙŠØª Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡) Ù†ØµØ¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(109408,3040,'tr','\"Ã‡erÃ§eve\" yÃ¼klÃ¼ deÄŸil!',0),(109409,3040,'pl','\"Ram\" nie jest zainstalowany!',0),(109410,3040,'bg','\"Ð Ð°Ð¼ÐºÐ°\" Ð½Ðµ Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½!',0),(109411,3040,'ur','\'ÙØ±ÛŒÙ… ÙˆØ±Ú©\' ØªÙ†ØµÛŒØ¨ Ù†ÛÛŒÚº ÛÛ’!',0),(109412,3040,'sr','\"ÐžÐºÐ²Ð¸Ñ€ \" Ð½Ð¸Ñ˜Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½!',0),(109413,3040,'vi','ChÆ°a láº¯p Ä‘áº·t \"Framework\"',0),(109414,3040,'af','Die \"Raamwerk\" is nie geinstalleer!',0),(109415,3040,'ro','\"Cadrul\" nu este instalat!',0),(109416,3040,'et','\"Raamistik\" pole installitud!',0),(109417,3040,'si','\"Okvir\" je ne umestiti!',0),(109418,3040,'ba','\"Kerangka\" tidak diinstal!',0),(109419,3040,'nl','Het \"kader\" is niet geÃ¯nstalleerd!',0),(109420,3040,'fi','\"Puitteet\" ei ole asennettu.',0),(109421,3040,'no','\"Ramme\" er ikke installert!',0),(109422,3040,'da','\"Ramme\" er ikke installeret!',0),(109423,3040,'ko','\"í”„ë ˆìž„ ì›Œí¬\" ì„¤ì¹˜ ë˜ì–´ ìžˆì§€ ì•ŠìŠµë‹ˆë‹¤!',0),(109424,3040,'he','\"×”×ž×¡×’×¨×ª\" ×œ× ×ž×•×ª×§×Ÿ!',0),(109425,3040,'el','Î¤Î¿ \"Ï€Î»Î±Î¯ÏƒÎ¹Î¿\" Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÎµÎ³ÎºÎ±Ï„ÎµÏƒÏ„Î·Î¼Î­Î½Î¿!',0),(109426,3040,'zh','â€œæ¡†æž¶â€æ˜¯æ²¡æœ‰å®‰è£…ï¼\r\n',0),(109427,3040,'sv','\"Ramen\" Ã¤r inte installerad!',0),(109428,3040,'it','Il \"quadro\" non Ã¨ installato!',0),(109429,3040,'tl','',0),(109430,3040,'th','The \"Framework\" is not installed!',0),(109431,3040,'hi','\"à¤°à¥‚à¤ªà¤°à¥‡à¤–à¤¾\" à¤¸à¥à¤¥à¤¾à¤ªà¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ!',0),(109432,3040,'ms','\"Rangka\" tidak dipasang!',0),(109433,3040,'ar','Ù„Ù… ÙŠØªÙ… ØªØ«Ø¨ÙŠØª \"Ø¥Ø·Ø§Ø±\"!',0),(109434,3040,'fr','Le Â« cadre Â» n\'est pas installÃ© !',0),(109435,3040,'jp','ãƒ•ãƒ¬ãƒ¼ãƒ ãƒ¯ãƒ¼ã‚¯ã?Œã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“ï¼?',0),(109436,3040,'pt','O \"Framework\" nÃ£o estÃ¡ instalado!',0),(109437,3040,'ru','Â«Ð Ð°Ð¼ÐºÐ¸Â» Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½!',0),(109438,3040,'es','El \"Framework\" no esta instlado!',0),(109439,3040,'de','\"Rahmen\" ist nicht installiert!',0),(109440,3040,'en','The \"Framework\" is not installed!',0),(109441,3041,'is','',0),(109442,3041,'dr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¬Ø±Ø§ Ø´ÙˆØ¯',0),(109443,3041,'pr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø¬Ø±Ø§ Ø´ÙˆØ¯',0),(109444,3041,'tr','Ä°ÅŸlem kaydedilemedi.',0),(109445,3041,'pl','Transakcja nie moÅ¼e byÄ‡ popeÅ‚nione.',0),(109446,3041,'bg','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸ÑÑ‚Ð° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¸Ð·Ð²ÑŠÑ€ÑˆÐµÐ½Ð¾.',0),(109447,3041,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ù¾Ø§Ø¨Ù†Ø¯ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©Ø§ Û”',0),(109448,3041,'sr','Ð¢Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð¼Ð¾Ð³Ð°Ð¾ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´Ð°Ð½.',0),(109449,3041,'vi','Giao dá»‹ch khÃ´ng cam káº¿t Ä‘Æ°á»£c',0),(109450,3041,'af','Die transaksie kon verbind word nie.',0),(109451,3041,'ro','TranzacÅ£ia nu a putut fi angajat.',0),(109452,3041,'et','Kannet ei saa toime.',0),(109453,3041,'si','Transakcije ni bilo mogoÄe potrditi.',0),(109454,3041,'ba','Transaksi tidak bisa berkomitmen.',0),(109455,3041,'nl','De transactie zou niet inzetten.',0),(109456,3041,'fi','Tapahtumaa ei voitu vahvistaa.',0),(109457,3041,'no','Transaksjonen kan ikke iverksettes.',0),(109458,3041,'da','Transaktionen kunne ikke vÃ¦re forpligtet.',0),(109459,3041,'ko','íŠ¸ëžœìž­ì…˜ì„ ì»¤ë°‹í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(109460,3041,'he','×”×ª× ×•×¢×” ×œ× ×™×›×•×œ ×œ×”×™×•×ª ×ž×—×•×™×‘.',0),(109461,3041,'el','Î— ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Î´ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î´ÎµÏƒÎ¼ÎµÏ…Ï„ÎµÎ¯.',0),(109462,3041,'zh','è¯¥äº¤æ˜“ä¸èƒ½æäº¤ã€‚\r\n',0),(109463,3041,'sv','Transaktionen kan inte begÃ¥s.',0),(109464,3041,'it','La transazione potrebbe non essere impegnata.',0),(109465,3041,'tl','',0),(109466,3041,'th','&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3607;&#3635;&#3652;&#3604;&#3657;',0),(109467,3041,'hi','à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(109468,3041,'ms','Urus niaga tidak dapat dilakukan.',0),(109469,3041,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø§Ù„ØªØ²Ø§Ù… Ø¨Ø§Ù„Ø­Ø±ÙƒØ©.',0),(109470,3041,'fr','La transaction ne pourra Ãªtre engagÃ©e.',0),(109471,3041,'jp','ã??ã?®å?–å¼•ã?¯å‡¦ç?†ã?•ã‚Œã‚‹ã?“ã?¨ã?Œã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(109472,3041,'pt','A transaÃ§Ã£o nÃ£o pÃ´de ser confirmada.',0),(109473,3041,'ru','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð½Ðµ Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð·Ð°Ñ„Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹.',0),(109474,3041,'es','La transacciÃ³n no se podÃ­a comprometida',0),(109475,3041,'de','Die Transaktion kann nicht Ã¼bernommen werden.',0),(109476,3041,'en','The transaction could not be committed.',0),(109477,3042,'is','',0),(109478,3042,'dr','/ Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø´Ø®Ø§Øµ',0),(109479,3042,'pr','Ø³Ù¾Ø³ Ø¨Ø¹Ø¯ÙŠ â€“ Ø¬Ù‡Øª ÙˆÙŠØ±Ø§ÙŠØ´  / Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø´Ø®Ø§Øµ',0),(109480,3042,'tr','sonra DÃ¼zenle/Ekle kiÅŸiler iÃ§in [ileri]',0),(109481,3042,'pl','wtedy [dalej], aby Edytuj/dodaj osoby',0),(109482,3042,'bg','Ñ‚Ð¾Ð³Ð°Ð²Ð° [Next] Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»Ð¸Ñ†Ð°',0),(109483,3042,'ur','Ù¾Ú¾Ø± [ØªØ¯ÙˆÛŒÙ†/Ø§ÙØ±Ø§Ø¯ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ú¯Ù„Ø§]',0),(109484,3042,'sr','Ð° Ð·Ð°Ñ‚Ð¸Ð¼ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð£Ñ€ÐµÐ´Ð¸/Ð¾ÑÐ¾Ð±Ðµ [Ð´Ð°Ñ™Ðµ]',0),(109485,3042,'vi','sau (tiáº¿p) tá»›i chá»‰nh sá»­a/thÃªm ngÆ°á»i',0),(109486,3042,'af','dan [Volgende] in persone te redigeer/skep',0),(109487,3042,'ro','apoi [Next] pentru a edita/Adauga persoane',0),(109488,3042,'et','siis (Edasi), et muuta/lisada isikuid',0),(109489,3042,'si','potem [naprej] urejanje/dodajanje oseb',0),(109490,3042,'ba','kemudian [berikutnya] untuk Ubah/Tambah orang',0),(109491,3042,'nl','dan [volgende] om te bewerken/toevoegen van personen',0),(109492,3042,'fi','sitten Siirry Muokkaa tai LisÃ¤Ã¤ henkilÃ¶itÃ¤',0),(109493,3042,'no','deretter [neste] Ã¥ redigere/legge til personer',0),(109494,3042,'da','derefter [nÃ¦ste] edit/tilfÃ¸je personer',0),(109495,3042,'ko','ë‹¤ìŒ [ë‹¤ìŒ] íŽ¸ì§‘/ì¶”ê°€í•  ì¸',0),(109496,3042,'he','×•××– [×”×‘×] ×›×“×™ ×¢×¨×•×š/×”×•×¡×£ ×× ×©×™×',0),(109497,3042,'el','ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î±, [Next] Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±/Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÏÎ¿ÏƒÏŽÏ€Ï‰Î½',0),(109498,3042,'zh','ç„¶åŽæŒ‰[ä¸‹ä¸€æ­¥]ç¼–è¾‘/æ·»åŠ äºº\r\n',0),(109499,3042,'sv','dÃ¥ [NÃ¤sta] att redigera/LÃ¤gg till personer',0),(109500,3042,'it','quindi [avanti] per modificare/aggiungere persone',0),(109501,3042,'tl','',0),(109502,3042,'th','&#3605;&#3656;&#3629;&#3592;&#3634;&#3585;&#3609;&#3633;&#3657;&#3609; (&#3605;&#3656;&#3629;&#3652;&#3611;) &#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;/&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3640;&#3588;&#3588;&#3621;',0),(109503,3042,'hi','à¤¤à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤µà¥à¤¯à¤•à¥à¤¤à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ [à¤…à¤—à¤²à¤¾]',0),(109504,3042,'ms','Kemudian [seterusnya] untuk edit/Tambah orang',0),(109505,3042,'ar','Ø«Ù… [Ø§Ù„ØªØ§Ù„ÙŠ] Ù„ØªØ­Ø±ÙŠØ±/Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø£Ø´Ø®Ø§Øµ',0),(109506,3042,'fr','puis [suivant] pour modifier/ajouter des personnes',0),(109507,3042,'jp','æ¬¡ã?« [Next] äººã?®ç·¨é›†/è¿½åŠ ',0),(109508,3042,'pt','em seguida, [seguinte] para editar/adicionar pessoas',0),(109509,3042,'ru','Ð·Ð°Ñ‚ÐµÐ¼ [Ð´Ð°Ð»ÐµÐµ], Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ/Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð»Ð¸Ñ†',0),(109510,3042,'es','entonces [Proximo] para editar/agregar personas',0),(109511,3042,'de','dann [weiter], um Personen bearbeiten/hinzufÃ¼gen',0),(109512,3042,'en','then [Next] to edit/add persons',0),(109513,3043,'is','',0),(109514,3043,'dr','/ Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(109515,3043,'pr','Ø³Ù¾Ø³ Ù„ÙŠØ³Øª Ø±Ø§ Ù†Ø´Ø§Ù† Ø¯Ù‡ÙŠØ¯ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´  / Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(109516,3043,'tr','sonra EDIT/Ã§alÄ±ÅŸanlarÄ± eklemek iÃ§in [listesini gÃ¶ster]',0),(109517,3043,'pl','wtedy [PokaÅ¼ listÄ™], aby edytowaÄ‡/dodawaÄ‡ pracownikÃ³w',0),(109518,3043,'bg','Ñ‚Ð¾Ð³Ð°Ð²Ð° [ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ¿Ð¸ÑÑŠÐº] Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(109519,3043,'ur','Ù¾Ú¾Ø± [Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº ØªØ±Ù…ÛŒÙ…/Ø§Ø¶Ø§ÙÛ Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ ÙÛØ±Ø³Øª]',0),(109520,3043,'sr','Ð° Ð¾Ð½Ð´Ð° [ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð»Ð¸ÑÑ‚Ñƒ] Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð£Ñ€ÐµÐ´Ð¸/Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸',0),(109521,3043,'vi','sau (Hiá»ƒn thá»‹ danh sÃ¡ch) Ä‘á»ƒ chá»‰nh/thÃªm nhÃ¢n viÃªn',0),(109522,3043,'af','dan [wys lys] om te redigeer/voeg werknemers',0),(109523,3043,'ro','apoi [AratÄƒ lista] pentru a edita/Adauga angajaÅ£i',0),(109524,3043,'et','siis [Kuva loend] edit/lisada tÃ¶Ã¶tajate',0),(109525,3043,'si','potem [PokaÅ¾i seznam] edit/add zaposlenih',0),(109526,3043,'ba','kemudian [Tampilkan daftar] untuk Ubah/Tambah karyawan',0),(109527,3043,'nl','dan [weergeven] om te bewerken/toevoegen van werknemers',0),(109528,3043,'fi','sitten [NÃ¤ytÃ¤-luettelosta] Muokkaa tai lisÃ¤Ã¤ tyÃ¶ntekijÃ¶iden',0),(109529,3043,'no','deretter [visningslisten] Ã¥ redigere/legge til ansatte',0),(109530,3043,'da','derefter [Vis listen] edit/tilfÃ¸je medarbejdere',0),(109531,3043,'ko','ë‹¤ìŒ [ëª©ë¡ í‘œì‹œ] íŽ¸ì§‘/ì¶”ê°€ ì§ì›ì„',0),(109532,3043,'he','×•××– [×”×¦×’ ×¨×©×™×ž×”] ×¢×¨×•×š/×”×•×¡×£ ×¢×•×‘×“×™×',0),(109533,3043,'el','Ï„ÏŒÏ„Îµ [Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚] Î³Î¹Î± Î½Î± Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±/Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(109534,3043,'zh','ç„¶åŽé€‰æ‹©[æ˜¾ç¤ºåˆ—è¡¨]ç¼–è¾‘/æ·»åŠ é›‡å‘˜\r\n',0),(109535,3043,'sv','dÃ¥ [Visa lista] att redigera/LÃ¤gg till anstÃ¤llda',0),(109536,3043,'it','poi [Mostra elenco] per modificare/aggiungere dipendenti',0),(109537,3043,'tl','',0),(109538,3043,'th','&#3592;&#3634;&#3585;&#3609;&#3633;&#3657;&#3609;(&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;)&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;/&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3609;&#3633;&#3585;',0),(109539,3043,'hi','à¤¤à¤¬ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ [à¤¸à¥‚à¤šà¥€ à¤¦à¤¿à¤–à¤¾à¤à¤]',0),(109540,3043,'ms','Kemudian [Tunjukkan senarai] untuk edit/Tambah pekerja',0),(109541,3043,'ar','Ø«Ù… [Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©] ØªØ­Ø±ÙŠØ±/Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(109542,3043,'fr','puis [Voir la liste] pour modifier/ajouter des employÃ©s',0),(109543,3043,'jp','æ¬¡ã?«[Show List]å¾“æ¥­å“¡ã?®ç·¨é›†/è¿½åŠ ',0),(109544,3043,'pt','em seguida, [Mostrar lista] para editar/adicionar empregados',0),(109545,3043,'ru','Ñ‚Ð¾Ð³Ð´Ð° [ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¡Ð¿Ð¸ÑÐ¾Ðº] Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ/Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(109546,3043,'es','entonces [Mostrar Lista] para editar/agregar empleados',0),(109547,3043,'de','dann [Liste anzeigen], um Mitarbeiter bearbeiten/hinzufÃ¼gen',0),(109548,3043,'en','then [Show List] to edit/add employees',0),(109549,3044,'is','',0),(109550,3044,'dr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø§Ø² Ù†ÙˆØ¹ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¯Ø± Ø§ÙŠÙ† Ù…Ø­Ù„ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(109551,3044,'pr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø§Ø² Ù†ÙˆØ¹ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¯Ø± Ø§ÙŠÙ† Ù…Ø­Ù„ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(109552,3044,'tr','Bu konumda SeÃ§ili tÃ¼rde hiÃ§bir ana Ã¶ÄŸeler vardÄ±r.',0),(109553,3044,'pl','Nie ma Å¼adnych towarÃ³w Master typ wybrany w tym miejscu.',0),(109554,3044,'bg','ÐÑÐ¼Ð° Ð¾Ð±Ñ€Ð°Ð·ÐµÑ† ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ Ñ‚Ð¸Ð¿ Ð½Ð° Ñ‚Ð¾Ð²Ð° Ð¼ÑÑÑ‚Ð¾.',0),(109555,3044,'ur','Ø§Ø³ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø± Ù…Ù†ØªØ®Ø¨ Ù‚Ø³Ù… Ú©Û’ Ú©ÙˆØ¦ÛŒ Ù…Ø§Ø³Ù¹Ø± Ø§Ø´ÛŒØ§Ø¡ ÛÛŒÚº Û”',0),(109556,3044,'sr','ÐÐµÐ¼Ð° Ð³Ð¾ÑÐ¿Ð¾Ð´Ð°Ñ€Ð° ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾Ð³ Ñ‚Ð¸Ð¿Ð° Ð½Ð° Ð¾Ð²Ð¾Ñ˜ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸.',0),(109557,3044,'vi','KhÃ´ng cÃ³ hÃ ng chá»§ trong loáº¡i Ä‘Ã£ chá»n á»Ÿ vá»‹ trÃ­ nÃ y',0),(109558,3044,'af','Daar is geen Meesteritems van die geselekteerde tipe by hierdie plek',0),(109559,3044,'ro','Nu existÄƒ elemente Master de tipul selectat Ã®n aceastÄƒ locaÈ›ie.',0),(109560,3044,'et','Pole Master Ã¼ksusi selles asukohas valitud tÃ¼Ã¼biga.',0),(109561,3044,'si','Ni nobenih elementov Master izbrane vrste na tej lokaciji.',0),(109562,3044,'ba','Ada tidak ada Master item dari jenis yang dipilih di lokasi ini.',0),(109563,3044,'nl','Er zijn geen stramienitems van het geselecteerde type op deze locatie.',0),(109564,3044,'fi','NÃ¤ytettÃ¤viÃ¤ kohteita ei ole Master valittua tyyppiÃ¤ tÃ¤ssÃ¤ sijainnissa.',0),(109565,3044,'no','Det finnes ingen Master elementer av valgt type pÃ¥ denne plasseringen.',0),(109566,3044,'da','Der er ingen Master elementer af den valgte type pÃ¥ denne placering.',0),(109567,3044,'ko','ì—ì´ ìœ„ì¹˜ì— ì„ íƒ ëœ í˜•ì‹ì˜ ë§ˆìŠ¤í„° í•­ëª©ì´ ì—†ìŠµë‹ˆë‹¤.',0),(109568,3044,'he','×™×©× × ××™×Ÿ ×¤×¨×™×˜×™ ×ž××¡×˜×¨ ×©×œ ×”×¡×•×’ ×”× ×‘×—×¨ ×‘×ž×™×§×•× ×–×”.',0),(109569,3044,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÎºÏÏÎ¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î¿Ï… ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï… Ï„ÏÏ€Î¿Ï… ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· Î¸Î­ÏƒÎ·.',0),(109570,3044,'zh','åœ¨æ­¤ä½ç½®æ²¡æœ‰é€‰å®šç±»åž‹çš„ç®¡ç†é¡¹ç›®ã€‚\r\n',0),(109571,3044,'sv','Det finns inga Master objekt fÃ¶r den valda typen pÃ¥ den hÃ¤r platsen.',0),(109572,3044,'it','Esistono elementi Master del tipo selezionato in questa posizione.',0),(109573,3044,'tl','',0),(109574,3044,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3621;&#3633;&#3585;&#3586;&#3629;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3607;&#3637;&#3656;&#3614;&#3',0),(109575,3044,'hi','à¤•à¥‹à¤ˆ à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤° à¤šà¤¯à¤¨à¤¿à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(109576,3044,'ms','Terdapat item induk dari jenis yang terpilih di lokasi ini.',0),(109577,3044,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙŠ Ø¹Ù†Ø§ØµØ± Ø±Ø¦ÙŠØ³ÙŠØ© Ù…Ù† Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„Ù…Ø­Ø¯Ø¯ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹.',0),(109578,3044,'fr','Il n\'y a aucun Ã©lÃ©ment maÃ®tre du type sÃ©lectionnÃ© Ã  cet endroit.',0),(109579,3044,'jp','ã?“ã?®ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?«é?¸æŠžã?•ã‚Œã?Ÿã‚¿ã‚¤ãƒ—ã?®ä¸»è¦?å“?ç›®ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(109580,3044,'pt','NÃ£o hÃ¡ nenhum item de mestre do tipo selecionado neste local.',0),(109581,3044,'ru','ÐÐµÑ‚ ÐœÐ°ÑÑ‚ÐµÑ€ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾ Ñ‚Ð¸Ð¿Ð° Ð² ÑÑ‚Ð¾Ð¼ Ð¼ÐµÑÑ‚Ðµ.',0),(109582,3044,'es','No hay Items Mastros del tipo de selecciÃ³n en esta colocaciÃ³n',0),(109583,3044,'de','Es gibt keine Master-Elemente des ausgewÃ¤hlten Typs an dieser Stelle.',0),(109584,3044,'en','There are no Master Items of the selected type at this location.',0),(109585,3045,'is','',0),(109586,3045,'dr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠ Ù…Ù†Ø§Ø³Ø¨ÙŠ Ø¨Ø±Ø§ ÙŠ Ù†ÙˆØ¹ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ù…Ø§ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(109587,3045,'pr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠ Ù…Ù†Ø§Ø³Ø¨ÙŠ Ø¨Ø±Ø§ ÙŠ Ù†ÙˆØ¹ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ù…Ø§ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(109588,3045,'tr','Talep ettiÄŸiniz bir eÅŸleÅŸen hiÃ§bir Ã¶ÄŸe',0),(109589,3045,'pl','Brak pasujÄ…cych elementÃ³w do tego, Å¼e wymagane jest',0),(109590,3045,'bg','ÐÑÐ¼Ð° Ð½ÑÐ¼Ð° ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð°Ñ‰ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ð° Ñ‚Ð°Ð·Ð¸, ÐºÐ¾ÑÑ‚Ð¾ ÑÑ‚Ðµ Ð·Ð°ÑÐ²Ð¸Ð»Ð¸',0),(109591,3045,'ur','Ú©Û Ø¢Ù¾ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø´Û’ ÛÛ’ Û”',0),(109592,3045,'sr','ÐÐµÐ¼Ð° Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð°Ñ˜ÑƒÑ›Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ Ñƒ Ð¾Ð½Ñƒ ÐºÐ¾Ñ˜Ñƒ ÑÑ‚Ðµ Ñ‚Ñ€Ð°Ð¶Ð¸Ð»Ð¸',0),(109593,3045,'vi','KhÃ´ng cÃ³ hÃ ng phÃ¹ há»£p vá»›i yÃªu cáº§u cá»§a báº¡n',0),(109594,3045,'af','Daar is geen passende item vir die een wat u versoek het',0),(109595,3045,'ro','Nu existÄƒ nici un element potrivire cu cea pe care aÅ£i solicitat',0),(109596,3045,'et','Seal on seda, mida sa soovisid vastavaid Ã¼ksusi pole',0),(109597,3045,'si','Ni nobenega ujemajoÄega se elementa tisti, ki ste ga zahtevali',0),(109598,3045,'ba','Ada barang tidak cocok dengan salah satu yang Anda minta',0),(109599,3045,'nl','Er is geen overeenkomende item met de sjabloon die u hebt aangevraagd',0),(109600,3045,'fi','Ei ole vastaavaa kohdetta kuin ettÃ¤ pyysit',0),(109601,3045,'no','Det er ingen samsvarende elementer til den forespurte',0),(109602,3045,'da','Der er ingen tilsvarende element til en, der Ã¸nskede',0),(109603,3045,'ko','ì‚¬ìš©ìžê°€ ìš”ì²­í•œ ê²ƒ ì—†ìŒ ì¼ì¹˜ í•˜ëŠ” í•­ëª©ì€',0),(109604,3045,'he','×–×” ×œ× ×¤×¨×™×˜ ×ª×•×× ×œ- one ×©×‘×™×§×©×ª',0),(109605,3045,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÎºÎ±Î½Î­Î½Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Î½Î± Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Î¼Îµ Î±Ï…Ï„ÏŒ Ï€Î¿Ï… Î¶Î·Ï„Î®ÏƒÎ±Ï„Îµ',0),(109606,3045,'zh','æ²¡æœ‰æ‚¨è¦æ±‚çš„åŒ¹é…çš„é¡¹ç›®\r\n',0),(109607,3045,'sv','Det finns ingen matchande post till den som du begÃ¤rt',0),(109608,3045,'it','Non non c\'Ã¨ nessun elemento corrispondente a quello che avete richiesto',0),(109609,3045,'tl','',0),(109610,3045,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3605;&#3619;&#3591;&#3585;&#3633;&#3610;&#3607;&#3637;&#3656;&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(109611,3045,'hi','à¤µà¤¹à¤¾à¤ à¤à¤• à¤¹à¥ˆ à¤•à¤¿ à¤†à¤ª à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤†à¤‡à¤Ÿà¤® à¤¹à¥ˆ',0),(109612,3045,'ms','Terdapat tiada perkara yang hampir sama dengan yang yang anda minta',0),(109613,3045,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø£ÙŠ Ø¨Ù†Ø¯ Ù…Ø·Ø§Ø¨Ù‚Ø© Ù„ØªÙ„Ùƒ Ø§Ù„ØªÙŠ Ø·Ù„Ø¨ØªÙ‡Ø§',0),(109614,3045,'fr','Il n\'y a aucun Ã©lÃ©ment correspondant Ã  celui que vous avez demandÃ©',0),(109615,3045,'jp','ãƒªã‚¯ã‚¨ã‚¹ãƒˆã?—ã?Ÿã‚‚ã?®ã?«ä¸€è‡´ã?™ã‚‹å“?ç›®ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(109616,3045,'pt','NÃ£o hÃ¡ nenhum item correspondente ao que vocÃª pediu.',0),(109617,3045,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð² Ñ‚Ð¾, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ð¿Ñ€Ð¾ÑÐ¸Ð»Ð¸',0),(109618,3045,'es','No hay item emparejado a lo que pidiÃ³',0),(109619,3045,'de','Es gibt kein entsprechendes Element, die Sie angefordert',0),(109620,3045,'en','There is no matching item to the one that you requested',0),(109621,3046,'is','',0),(109622,3046,'dr','. Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù†ÙŠØ³Øª',0),(109623,3046,'pr','ÙŠÙƒ Ø®Ø·Ø§ Ø¯Ø± Ø¬Ø¯ÙˆÙ„ Ø¬Ø³ØªØ¬Ùˆ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ . Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù†ÙŠØ³Øª',0),(109624,3046,'tr','Tablo sorguda bir hata oluÅŸtu.  Ä°ÅŸleyemiyor.',0),(109625,3046,'pl','WystÄ…piÅ‚ bÅ‚Ä…d w tabeli kwerendy.  Nie moÅ¼e przetworzyÄ‡.',0),(109626,3046,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð° Ð³Ñ€ÐµÑˆÐºÐ° Ð² Ð·Ð°ÑÐ²ÐºÐ° Ð·Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°.  ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð¸.',0),(109627,3046,'ur','Ø·Ù„Ø¨ Ø¬Ø¯ÙˆÙ„ Ù…ÛŒÚº Ø§ÛŒÚ© Ù†Ù‚Øµ ØªÚ¾Ø§ Û”  Ø¹Ù…Ù„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(109628,3046,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð³Ñ€ÐµÑˆÐºÐµ Ñƒ ÑƒÐ¿Ð¸Ñ‚Ñƒ Ð·Ð° ÑÑ‚Ð¾Ð»Ð¾Ð¼.  ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¾Ð±Ñ€Ð°Ð´Ð¸Ñ‚Ð¸.',0),(109629,3046,'vi','CÃ³ lá»—i trong báº£ng truy váº¥n. KhÃ´ng tiáº¿p tá»¥c Ä‘Æ°á»£c',0),(109630,3046,'af','Daar was \'n fout in die tafel navraag.  Kon verwerk nie.',0),(109631,3046,'ro','A existat o eroare Ã®n interogare tabel.  Nu a procesat.',0),(109632,3046,'et','Tabeli pÃ¤ring tehti viga.  Ei saa tÃ¶Ã¶delda.',0),(109633,3046,'si','V tabeli poizvedbe je priÅ¡lo do napake.  Ni bilo mogoÄe obdelati.',0),(109634,3046,'ba','Ada kesalahan dalam query tabel.  Tidak dapat memproses.',0),(109635,3046,'nl','Er is een fout opgetreden in de tabelmaakquery.  Konden niet verwerken.',0),(109636,3046,'fi','Taulukon luovan kyselyn tapahtui virhe.  Ei voi kÃ¤sitellÃ¤.',0),(109637,3046,'no','Det oppstod en feil i tabell-spÃ¸rring.  Kan ikke behandle.',0),(109638,3046,'da','Der opstod en fejl i tabeloprettelsesforespÃ¸rgsel.  Kunne ikke behandle.',0),(109639,3046,'ko','í…Œì´ë¸” ì¿¼ë¦¬ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.  ì²˜ë¦¬ í•˜ì§€ ì•Šì„ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(109640,3046,'he','××™×¨×¢×” ×©×’×™××” ×‘×©××™×œ×ª×” ×‘×˜×‘×œ×”.  ×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×¢×‘×“.',0),(109641,3046,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î± ÏƒÏ„Î¿ ÎµÏÏŽÏ„Î·Î¼Î± Ï€Î¯Î½Î±ÎºÎ±.  Î”ÎµÎ½ Î®Ï„Î±Î½ Î´Ï…Î½Î±Ï„ÏŒ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯.',0),(109642,3046,'zh','è¡¨æŸ¥è¯¢ä¸­æœ‰ä¸€ä¸ªé”™è¯¯ã€‚æ— æ³•å¤„ç†',0),(109643,3046,'sv','Ett fel uppstod i tabellfrÃ¥gan.  Kunde inte behandla.',0),(109644,3046,'it','C\'era un errore nella tabella query.  Impossibile elaborare.',0),(109645,3046,'tl','',0),(109646,3046,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3626;&#3629;&#3610;&#3606;&#3634;&#3617;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(109647,3046,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤•à¥à¤µà¥‡à¤°à¥€ à¤®à¥‡à¤‚ à¤•à¥‹à¤ˆ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¥à¥€à¥¤  à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¾à¥¤',0),(109648,3046,'ms','Ini satu ralat dalam Jadual pertanyaan.  Dapat memproses.',0),(109649,3046,'ar','ÙƒØ§Ù† Ù‡Ù†Ø§Ùƒ Ø®Ø·Ø£ ÙÙŠ Ø§Ø³ØªØ¹Ù„Ø§Ù… ØªÙƒÙˆÙŠÙ† Ø¬Ø¯ÙˆÙ„.  ØªØ¹Ø°Ø± Ù…Ø¹Ø§Ù„Ø¬Ø©.',0),(109650,3046,'fr','Il y avait une erreur dans la requÃªte de la table.  N\'a pas pu traiter.',0),(109651,3046,'jp','è¡¨æ¤œç´¢ã?§ã‚¨ãƒ©ãƒ¼ã?Œã?‚ã‚Šã?¾ã?—ã?Ÿã€‚å‡¦ç?†ã?§ã??ã?¾ã?›ã‚“ã€‚',0),(109652,3046,'pt','Houve um erro na consulta de tabela.  NÃ£o pÃ´de processar.',0),(109653,3046,'ru','Ð’ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ð¿Ñ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð° Ð¾ÑˆÐ¸Ð±ÐºÐ°.  ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚ÑŒ.',0),(109654,3046,'es','HabÃ­a un error en la busqueda de la tabla. No se podÃ­a procesar',0),(109655,3046,'de','In der Tabellenerstellungsabfrage ein Fehler aufgetreten.  Konnte nicht verarbeiten.',0),(109656,3046,'en','There was an error in the table query.  Could not process.',0),(109657,3047,'is','',0),(109658,3047,'dr','Ù‡ÙŠÚ† Ø§Ø³Ù†Ø§Ø¯ÙŠ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(109659,3047,'pr','Ù‡ÙŠÚ† Ø§Ø³Ù†Ø§Ø¯ÙŠ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(109660,3047,'tr','Eklenen kayÄ±t edildi.',0),(109661,3047,'pl','Nie byÅ‚o Å¼adnych rekordÃ³w wstawionych',0),(109662,3047,'bg','Ð˜Ð¼Ð°ÑˆÐµ Ð½ÑÐ¼Ð° Ð²Ð¼ÑŠÐºÐ½Ð°Ñ‚Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(109663,3047,'ur','Ú©ÙˆØ¦ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø¯Ø§Ø®Ù„ Ú©ÛŒ Ú¯Ø¦ÛŒ ØªÚ¾ÛŒÚº Û”',0),(109664,3047,'sr','ÐÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑƒÐ¼ÐµÑ‚Ð½ÑƒÑ‚',0),(109665,3047,'vi','KhÃ´ng cÃ³ há»“ sÆ¡ chÃ¨n vÃ o',0),(109666,3047,'af','Daar was geen rekords ingevoeg',0),(109667,3047,'ro','Nu au nici o Ã®nregistrare inserate',0),(109668,3047,'et','Puudusid lisatud dokumendid',0),(109669,3047,'si','Ni bilo nobenih zapisov vstavi',0),(109670,3047,'ba','Ada tidak ada catatan yang dimasukkan',0),(109671,3047,'nl','Er waren geen records ingevoegd',0),(109672,3047,'fi','Ei ollut yhtÃ¤Ã¤n tietuetta lisÃ¤tÃ¤Ã¤n',0),(109673,3047,'no','Det var ingen poster settes inn',0),(109674,3047,'da','Der var ingen poster, der er indsat',0),(109675,3047,'ko','ì•„ë¬´ ë ˆì½”ë“œ ì‚½ìž… í–ˆë‹¤',0),(109676,3047,'he','×œ× ×”×™×• ×¨×©×•×ž×•×ª ×©× ×•×¡×¤×•',0),(109677,3047,'el','Î¥Ï€Î®ÏÏ‡Îµ ÎºÎ±Î¼Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î® Î½Î± ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯',0),(109678,3047,'zh','æ²¡æœ‰è®°å½•æ’å…¥\r\n',0),(109679,3047,'sv','Det fanns ingen infogade poster',0),(109680,3047,'it','Non ci erano nessun record inseriti',0),(109681,3047,'tl','',0),(109682,3047,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(109683,3047,'hi','à¤µà¤¹à¤¾à¤ à¤•à¥‹à¤ˆ à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤¿à¤ à¤—à¤ à¤¥à¥‡',0),(109684,3047,'ms','Terdapat tiada rekod yang dimasukkan',0),(109685,3047,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙŠ Ø³Ø¬Ù„Ø§Øª Ø¥Ø¯Ø±Ø§Ø¬Ù‡Ø§',0),(109686,3047,'fr','Il n\'y a aucun enregistrement insÃ©rÃ©',0),(109687,3047,'jp','æŒ¿å…¥ã?•ã‚Œã?Ÿè¨˜éŒ²ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(109688,3047,'pt','NÃ£o havia nenhum registro inserido',0),(109689,3047,'ru','Ð¢Ð°Ð¼ Ð±Ñ‹Ð»Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ Ð²ÑÑ‚Ð°Ð²Ð»ÐµÐ½',0),(109690,3047,'es','No habÃ­an records insertados',0),(109691,3047,'de','Es wurden keine DatensÃ¤tze eingefÃ¼gt',0),(109692,3047,'en','There were no records inserted',0),(109693,3048,'is','',0),(109694,3048,'dr','(ÙŠÙƒ Ø³ÙˆÙ…',0),(109695,3048,'pr','Ø³ÙˆÙ…ÙŠ(ÙŠÙƒ Ø³ÙˆÙ…',0),(109696,3048,'tr','ÃœÃ§Ã¼ncÃ¼',0),(109697,3048,'pl','Trzeci',0),(109698,3048,'bg','Ð¢Ñ€ÐµÑ‚Ð°',0),(109699,3048,'ur','ØªÛŒØ³Ø±Ø§',0),(109700,3048,'sr','Ð¢Ñ€ÐµÑ›Ð¸',0),(109701,3048,'vi','Thá»© ba',0),(109702,3048,'af','Derde',0),(109703,3048,'ro','Al treilea',0),(109704,3048,'et','Kolmanda',0),(109705,3048,'si','Tretje',0),(109706,3048,'ba','Ketiga',0),(109707,3048,'nl','Derde',0),(109708,3048,'fi','Kolmannen',0),(109709,3048,'no','Tredje',0),(109710,3048,'da','Tredje',0),(109711,3048,'ko','ì œ 3',0),(109712,3048,'he','×©×œ×™×©×™',0),(109713,3048,'el','Î¤ÏÎ¯Ï„Î¿',0),(109714,3048,'zh','ç¬¬ä¸‰\r\n',0),(109715,3048,'sv','Tredje',0),(109716,3048,'it','Terzo',0),(109717,3048,'tl','',0),(109718,3048,'th','&#3621;&#3635;&#3604;&#3633;&#3610;&#3607;&#3637;&#3656; 3',0),(109719,3048,'hi','à¤¤à¥ƒà¤¤à¥€à¤¯',0),(109720,3048,'ms','Ketiga',0),(109721,3048,'ar','Ø§Ù„Ø«Ø§Ù„Ø«',0),(109722,3048,'fr','TroisiÃ¨me',0),(109723,3048,'jp','ä¸‰ã?¤ç›®',0),(109724,3048,'pt','Terceiro',0),(109725,3048,'ru','Ð¢Ñ€ÐµÑ‚Ð¸Ð¹',0),(109726,3048,'es','Tercer',0),(109727,3048,'de','Dritte',0),(109728,3048,'en','Third',0),(109729,3049,'is','',0),(109730,3049,'dr','13',0),(109731,3049,'pr','Ø³ÙŠØ²Ø¯Ù‡ 13',0),(109732,3049,'tr','On Ã¼Ã§',0),(109733,3049,'pl','trzynaÅ›cie',0),(109734,3049,'bg','Ñ‚Ñ€Ð¸Ð½Ð°Ð´ÐµÑÐµÑ‚',0),(109735,3049,'ur','ØªÛŒØ±Û',0),(109736,3049,'sr','-13',0),(109737,3049,'vi','mÆ°á»i ba',0),(109738,3049,'af','dertien',0),(109739,3049,'ro','treisprezece',0),(109740,3049,'et','kolmteist',0),(109741,3049,'si','trinajst',0),(109742,3049,'ba','tiga belas',0),(109743,3049,'nl','dertien',0),(109744,3049,'fi','kolmetoista',0),(109745,3049,'no','tretten',0),(109746,3049,'da','tretten',0),(109747,3049,'ko','13',0),(109748,3049,'he','×©×œ×•×© ×¢×©×¨×”',0),(109749,3049,'el','Î´ÎµÎºÎ±Ï„ÏÎµÎ¯Ï‚',0),(109750,3049,'zh','åä¸‰\r\n',0),(109751,3049,'sv','tretton',0),(109752,3049,'it','tredici',0),(109753,3049,'tl','',0),(109754,3049,'th','13',0),(109755,3049,'hi','à¤¤à¥‡à¤°à¤¹',0),(109756,3049,'ms','tiga belas',0),(109757,3049,'ar','Ø«Ù„Ø§Ø«Ø© Ø¹Ø´Ø±Ø©',0),(109758,3049,'fr','treize',0),(109759,3049,'jp','13',0),(109760,3049,'pt','Treze',0),(109761,3049,'ru','Ð¢Ñ€Ð¸Ð½Ð°Ð´Ñ†Ð°Ñ‚ÑŒ',0),(109762,3049,'es','trece',0),(109763,3049,'de','dreizehn',0),(109764,3049,'en','thirteen',0),(109765,3050,'is','',0),(109766,3050,'dr','30 ',0),(109767,3050,'pr','Ø³ÙŠ 30 ',0),(109768,3050,'tr','Otuz',0),(109769,3050,'pl','trzydzieÅ›ci',0),(109770,3050,'bg','Ñ‚Ñ€Ð¸Ð´ÐµÑÐµÑ‚',0),(109771,3050,'ur','ØªÛŒØ³',0),(109772,3050,'sr','Ð¢Ñ€Ð¸Ð´ÐµÑÐµÑ‚',0),(109773,3050,'vi','ba mÆ°Æ¡i',0),(109774,3050,'af','dertig',0),(109775,3050,'ro','treizeci',0),(109776,3050,'et','kolmkÃ¼mmend',0),(109777,3050,'si','trideset',0),(109778,3050,'ba','tiga puluh',0),(109779,3050,'nl','dertig',0),(109780,3050,'fi','kolmekymmentÃ¤',0),(109781,3050,'no','tretti',0),(109782,3050,'da','tredive',0),(109783,3050,'ko','30',0),(109784,3050,'he','×©×œ×•×©×™×',0),(109785,3050,'el','Ï„ÏÎ¹Î¬Î½Ï„Î±',0),(109786,3050,'zh','ä¸‰å\r\n',0),(109787,3050,'sv','trettio',0),(109788,3050,'it','trenta',0),(109789,3050,'tl','',0),(109790,3050,'th','30',0),(109791,3050,'hi','à¤¤à¥€à¤¸',0),(109792,3050,'ms','tiga puluh',0),(109793,3050,'ar','Ø«Ù„Ø§Ø«ÙˆÙ†',0),(109794,3050,'fr','trente',0),(109795,3050,'jp','30',0),(109796,3050,'pt','Trinta',0),(109797,3050,'ru','Ñ‚Ñ€Ð¸Ð´Ñ†Ð°Ñ‚ÑŒ',0),(109798,3050,'es','treinta',0),(109799,3050,'de','dreiÃŸig',0),(109800,3050,'en','thirty',0),(109801,3051,'is','',0),(109802,3051,'dr','Ø§ÙŠÙ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(109803,3051,'pr','Ø§ÙŠÙ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(109804,3051,'tr','Bu ekonomik zaten silindi.',0),(109805,3051,'pl','BudÅ¼et ten zostaÅ‚o juÅ¼ usuniÄ™te.',0),(109806,3051,'bg','Ð¢Ð¾Ð·Ð¸ Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð²ÐµÑ‡Ðµ Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚.',0),(109807,3051,'ur','ÛŒÛ Ø¨Ø¬Ù¹ Ù¾ÛÙ„Û’ ÛÛŒ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ Ú¯Ø¦ÛŒ ÛÛ’ Û”',0),(109808,3051,'sr','ÐžÐ²Ð°Ñ˜ Ð±ÑƒÑŸÐµÑ‚ Ð²ÐµÑ› Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(109809,3051,'vi','NgÃ¢n sÃ¡ch nÃ y Ä‘Ã£ xÃ³a',0),(109810,3051,'af','Hierdie begroting is alreeds geskrap.',0),(109811,3051,'ro','Acest buget a fost deja È™ters.',0),(109812,3051,'et','See eelarve on juba kustutatud.',0),(109813,3051,'si','Ta proraÄun je Å¾e izbrisan.',0),(109814,3051,'ba','Anggaran ini telah dihapus.',0),(109815,3051,'nl','Deze begroting is al verwijderd.',0),(109816,3051,'fi','TÃ¤mÃ¤ talousarvio on jo poistettu.',0),(109817,3051,'no','Dette budsjettet er allerede slettet.',0),(109818,3051,'da','Dette budget er allerede blevet slettet.',0),(109819,3051,'ko','ì´ ì˜ˆì‚°ì€ ì´ë¯¸ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(109820,3051,'he','×ª×§×¦×™×‘ ×–×” ×›×‘×¨ × ×ž×—×§×”.',0),(109821,3051,'el','Î‘Ï…Ï„ÏŒÏ‚ Î¿ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Î­Ï‡ÎµÎ¹ Î®Î´Î· Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯.',0),(109822,3051,'zh','è¿™ä»½é¢„ç®—æ¡ˆå·²è¢«åˆ é™¤\r\n',0),(109823,3051,'sv','Denna budget har redan tagits bort.',0),(109824,3051,'it','Questo bilancio Ã¨ giÃ  stato eliminato.',0),(109825,3051,'tl','',0),(109826,3051,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3609;&#3637;&#3657;&#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(109827,3051,'hi','à¤‡à¤¸ à¤¬à¤œà¤Ÿ à¤•à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(109828,3051,'ms','Bajet ini telah dihapuskan.',0),(109829,3051,'ar','Ù‡Ø°Ù‡ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù…Ø­Ø°ÙˆÙØ© Ù…Ø³Ø¨Ù‚Ø§',0),(109830,3051,'fr','Ce budget a dÃ©jÃ  Ã©tÃ© supprimÃ©.',0),(109831,3051,'jp','ã?“ã?®äºˆç®—ã?¯ã?™ã?§ã?«æ¶ˆåŽ»ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(109832,3051,'pt','Este orÃ§amento jÃ¡ foi excluÃ­do.',0),(109833,3051,'ru','Ð”Ð°Ð½Ð½Ñ‹Ð¹ Ð±ÑŽÐ´Ð¶ÐµÑ‚ ÑƒÐ¶Ðµ Ð±Ñ‹Ð» ÑƒÐ´Ð°Ð»ÐµÐ½. ',0),(109834,3051,'es','Este presupuesto ya se eliminÃ³',0),(109835,3051,'de','Dieses Budget wurde bereits gelÃ¶scht.',0),(109836,3051,'en','This budget has already been deleted.',0),(109837,3052,'is','',0),(109838,3052,'dr','Ø§ÙŠÙ† Ø³Ù†Ø¯ Ù†Ù‡Ø§ÙŠÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(109839,3052,'pr','Ø§ÙŠÙ† Ø³Ù†Ø¯ Ù†Ù‡Ø§ÙŠÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(109840,3052,'tr','Bu belge sonlandÄ±rÄ±lmÄ±ÅŸ.',0),(109841,3052,'pl','Dokument ten zostaÅ‚ zakoÅ„czony.',0),(109842,3052,'bg','Ð¢Ð¾Ð·Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ðµ Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¾.',0),(109843,3052,'ur','Ø§Ø³ Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ Ø±Ø§Ø¬Ø¯Ú¾Ø§Ù†ÛŒ Ú©ÛŒ Ú¯Ø¦ÛŒ ÛÛ’ Û”',0),(109844,3052,'sr','ÐžÐ²Ð°Ñ˜ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½.',0),(109845,3052,'vi','TÃ i liá»‡u nÃ y Ä‘Ã£ káº¿t thÃºc',0),(109846,3052,'af','Hierdie dokument is gefinaliseer.',0),(109847,3052,'ro','Acest document a fost finalizat.',0),(109848,3052,'et','See dokument on lÃµpetatud.',0),(109849,3052,'si','Ta dokument je bil dokonÄan.',0),(109850,3052,'ba','Dokumen ini telah diselesaikan.',0),(109851,3052,'nl','Dit document is voltooid.',0),(109852,3052,'fi','TÃ¤mÃ¤ asiakirja on saatu pÃ¤Ã¤tÃ¶kseen.',0),(109853,3052,'no','Dette dokumentet er fullfÃ¸rt.',0),(109854,3052,'da','Dette dokument er blevet afsluttet.',0),(109855,3052,'ko','ì´ ë¬¸ì„œ ë§ˆë¬´ë¦¬ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(109856,3052,'he','×ž×¡×ž×š ×–×” ×›×‘×¨ ×”×•×©×œ×ž×•.',0),(109857,3052,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Î­Î³Î³ÏÎ±Ï†Î¿ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„Î¹ÎºÎ¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯.',0),(109858,3052,'zh','è¿™ä»½æ–‡ä»¶å·²ç»å®šç¨¿\r\n',0),(109859,3052,'sv','Detta dokument har slutfÃ¶rts.',0),(109860,3052,'it','Questo documento Ã¨ stato finalizzato.',0),(109861,3052,'tl','',0),(109862,3052,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3609;&#3637;&#3657;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(109863,3052,'hi','à¤‡à¤¸ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(109864,3052,'ms','Dokumen ini telah dimuktamadkan.',0),(109865,3052,'ar','Ù‚Ø¯ ØªÙ… ÙˆØ¶Ø¹ Ø§Ù„ØµÙŠØºØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© Ù„Ù‡Ø°Ù‡ Ø§Ù„ÙˆØ«ÙŠÙ‚Ø©.',0),(109866,3052,'fr','Ce document a Ã©tÃ© finalisÃ©.',0),(109867,3052,'jp','ã?“ã?®æ–‡æ›¸ã?¯å®Œäº†ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(109868,3052,'pt','Este documento foi finalizado.',0),(109869,3052,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð±Ñ‹Ð» Ð´Ð¾Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½.',0),(109870,3052,'es','Este documento se finalizÃ³',0),(109871,3052,'de','Dieses Dokument wurde fertiggestellt.',0),(109872,3052,'en','This document has been finalized.',0),(109873,3053,'is','',0),(109874,3053,'dr','Ø§ÙŠÙ† Ø³Ù†Ø¯ Ø¨Ø±Ø§ÙŠ ØªØµÙÙŠÙ‡ Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª',0),(109875,3053,'pr','Ø§ÙŠÙ† Ø³Ù†Ø¯ Ø¨Ø±Ø§ÙŠ ØªØµÙÙŠÙ‡ Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª',0),(109876,3053,'tr','Bu belgenin kullanÄ±ma alÄ±nmasÄ±nÄ± temin',0),(109877,3053,'pl','Ten dokument jest dostÄ™pny do sprawdzenia siÄ™',0),(109878,3053,'bg','Ð¢Ð¾Ð·Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ðµ Ð´Ð¾ÑÑ‚ÑŠÐ¿ÐµÐ½ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(109879,3053,'ur','ÛŒÛ Ø¯Ø³ØªØ§ÙˆÛŒØ² Ø®Ø§Ø±Ø¬ ÛÙˆ Ø¬Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø³ØªÛŒØ§Ø¨ ÛÛ’ Û”',0),(109880,3053,'sr','ÐžÐ²Ð°Ñ˜ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½ Ð´Ð° Ð±ÑƒÐ´Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¾',0),(109881,3053,'vi','TÃ i liá»‡u nÃ y sáºµn sÃ ng Ä‘á»ƒ Ä‘Æ°a ra',0),(109882,3053,'af','Hierdie dokument is beskikbaar om gekontroleer te word',0),(109883,3053,'ro','Acest document este disponibil pentru a fi verificat',0),(109884,3053,'et','See dokument on kÃ¤ttesaadav vÃ¤lja mÃ¶llitud',0),(109885,3053,'si','Ta dokument je na voljo za rezervacijo',0),(109886,3053,'ba','Dokumen ini tersedia untuk diperiksa',0),(109887,3053,'nl','Dit document is beschikbaar om te worden uitgecheckt',0),(109888,3053,'fi','TÃ¤mÃ¤ asiakirja on saatavana kuittaamista ulos',0),(109889,3053,'no','Dette dokumentet er tilgjengelig for utsjekking',0),(109890,3053,'da','Dette dokument er tilgÃ¦ngeligt til at blive tjekket ud',0),(109891,3053,'ko','ì´ ë¬¸ì„œëŠ” ì²´í¬ ì•„ì›ƒì„ ì‚¬ìš©í•  ìˆ˜',0),(109892,3053,'he','×”×ž×¡×ž×š ×–×” × ×™×ª×Ÿ ×œ×‘×“×•×§ ××ª ×–×”',0),(109893,3053,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Î­Î³Î³ÏÎ±Ï†Î¿ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î¿ Î³Î¹Î± Ï„Î·Î½ Î±Î½Î¬Î»Î·ÏˆÎ·',0),(109894,3053,'zh','è¯¥æ–‡ä»¶å¯è¢«ç™»å‡º\r\n',0),(109895,3053,'sv','Detta dokument finns att checkas ut',0),(109896,3053,'it','Questo documento Ã¨ disponibile per essere verificato',0),(109897,3053,'tl','',0),(109898,3053,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3609;&#3637;&#3657;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3652;&#3604;&#3657;',0),(109899,3053,'hi','à¤‡à¤¸ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤•à¥‹ à¤šà¥‡à¤•à¥à¤¡ à¤†à¤‰à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¹à¥ˆ',0),(109900,3053,'ms','Dokumen ini boleh didapati untuk diperiksa',0),(109901,3053,'ar','ÙŠØªÙˆÙØ± Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø¥Ù„Ù‰ Ø£Ù† Ø³Ø­Ø¨Ù‡',0),(109902,3053,'fr','Ce document est disponible Ã  Ãªtre vÃ©rifiÃ©',0),(109903,3053,'jp','ã?“ã?®æ–‡æ›¸ã?¯ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?§ã??ã?¾ã?†ï½“',0),(109904,3053,'pt','Este documento estÃ¡ disponÃ­vel para fazer check-out',0),(109905,3053,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð´Ð¾ÑÑ‚ÑƒÐ¿ÐµÐ½ Ð´Ð»Ñ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ñ',0),(109906,3053,'es','Este documento es disponible para sacar en prÃ©stamo',0),(109907,3053,'de','Dieses Dokument ist verfÃ¼bar ausgecheckt werden',0),(109908,3053,'en','This document is available to be checked out',0),(109909,3054,'is','',0),(109910,3054,'dr','( Ø¨Ø±Ø±Ø³ÙŠ ) Ø´Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(109911,3054,'pr','Ø§ÙŠÙ† Ø³Ù†Ø¯ Ø§Ø®ÙŠØ±Ø§ ØªØµÙÙŠÙ‡ Ø­Ø³Ø§Ø¨ ( Ø¨Ø±Ø±Ø³ÙŠ ) Ø´Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(109912,3054,'tr','Bu belge iÃ§in ÅŸu anda kullanÄ±ma',0),(109913,3054,'pl','Dokument ten jest obecnie wyewidencjonowana do',0),(109914,3054,'bg','Ð¢Ð¾Ð·Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ðµ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ð´Ð°',0),(109915,3054,'ur','ÛŒÛ Ø¯Ø³ØªØ§ÙˆÛŒØ² Ø§Ø³ ÙˆÙ‚Øª Ø³Û’ Ø®Ø§Ø±Ø¬ ÛÛ’',0),(109916,3054,'sr','ÐžÐ²Ð°Ñ˜ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð¾Ð´Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð° Ð½Ð°',0),(109917,3054,'vi','TÃ i liá»‡u nÃ y Ä‘Ã£ chuyá»ƒn ra tá»›i',0),(109918,3054,'af','Hierdie dokument is tans nagegaan het om te',0),(109919,3054,'ro','Acest document este extrasÄƒ Ã®n prezent la',0),(109920,3054,'et','See dokument on praegu vÃ¤lja mÃ¶llitud',0),(109921,3054,'si','Ta dokument je trenutno rezerviran za',0),(109922,3054,'ba','Dokumen ini sedang memeriksa untuk',0),(109923,3054,'nl','Dit document is momenteel uitgecheckt om te',0),(109924,3054,'fi','TÃ¤mÃ¤ asiakirja on tÃ¤llÃ¤ hetkellÃ¤ kuitannut ulos',0),(109925,3054,'no','Dette dokumentet er sjekket til',0),(109926,3054,'da','Dette dokument er i Ã¸jeblikket tjekket ud til',0),(109927,3054,'ko','ì´ ë¬¸ì„œëŠ” í˜„ìž¬ ì²´í¬ ì•„ì›ƒ',0),(109928,3054,'he','×ž×¡×ž×š ×–×” ×›×¢×ª ×ž××—×¡×•×Ÿ',0),(109929,3054,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Î­Î³Î³ÏÎ±Ï†Î¿ ÎµÎ¯Î½Î±Î¹ ÎµÏ€Î¯ Ï„Î¿Ï… Ï€Î±ÏÏŒÎ½Ï„Î¿Ï‚ Î±Ï€Î¿ÏƒÏ…ÏÎ¼Î­Î½Î± ÏƒÎµ',0),(109930,3054,'zh','è¿™ä¸ªæ–‡ä»¶ç›®å‰ç­¾å‡º\r\n',0),(109931,3054,'sv','Detta dokument har checkats ut till',0),(109932,3054,'it','Questo documento Ã¨ attualmente estratti a',0),(109933,3054,'tl','',0),(109934,3054,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3609;&#3637;&#3657;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3606;&#3641;&#3585; Check Out',0),(109935,3054,'hi','à¤¯à¤¹ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¥€ à¤¹à¥ˆ',0),(109936,3054,'ms','Dokumen ini sedang keluar ke',0),(109937,3054,'ar','Ø­Ø§Ù„ÙŠØ§ ØªÙ… Ø³Ø­Ø¨ Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø¥Ù„Ù‰',0),(109938,3054,'fr','Ce document est actuellement extrait Ã ',0),(109939,3054,'jp','ã?“ã?®æ–‡æ›¸ã?¯ç?¾åœ¨ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(109940,3054,'pt','Este documento atualmente check-out para',0),(109941,3054,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½ Ð² Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð´Ð»Ñ',0),(109942,3054,'es','Este documento se sacÃ³ en prÃ©stamo a ',0),(109943,3054,'de','Dieses Dokument wird fÃ¼r derzeit ausgecheckt.',0),(109944,3054,'en','This document is currently checked out to',0),(109945,3055,'is','',0),(109946,3055,'dr','Ø§ÙŠÙ† ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(109947,3055,'pr','Ø§ÙŠÙ† ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(109948,3055,'tr','Bu Ã§alÄ±ÅŸan',0),(109949,3055,'pl','Pracownik',0),(109950,3055,'bg','Ð¢Ð¾Ð·Ð¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(109951,3055,'ur','Ø§Ø³ Ú©Û’ Ù…Ù„Ø§Ø²Ù…',0),(109952,3055,'sr','ÐžÐ²Ð°Ñ˜ Ñ€Ð°Ð´Ð½Ð¸Ðº',0),(109953,3055,'vi','NhÃ¢n viÃªn nÃ y',0),(109954,3055,'af','Hierdie Werknemer',0),(109955,3055,'ro','Acest angajat',0),(109956,3055,'et','See tÃ¶Ã¶taja',0),(109957,3055,'si','Ta delavec',0),(109958,3055,'ba','Karyawan ini',0),(109959,3055,'nl','Deze werknemer',0),(109960,3055,'fi','TÃ¤mÃ¤n tyÃ¶ntekijÃ¤n',0),(109961,3055,'no','Denne ansatte',0),(109962,3055,'da','Denne medarbejder',0),(109963,3055,'ko','ì´ ì§ì›',0),(109964,3055,'he','×¢×•×‘×“ ×–×”',0),(109965,3055,'el','Î‘Ï…Ï„ÏŒ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(109966,3055,'zh','è¿™åé›‡å‘˜\r\n',0),(109967,3055,'sv','Denna medarbetare',0),(109968,3055,'it','Questo dipendente',0),(109969,3055,'tl','',0),(109970,3055,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3588;&#3609;&#3609;&#3637;&#3657;',0),(109971,3055,'hi','à¤‡à¤¸ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(109972,3055,'ms','Pekerja ini',0),(109973,3055,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ¸Ù',0),(109974,3055,'fr','Cet employÃ©',0),(109975,3055,'jp','ã?“ã?®å¾“æ¥­å“¡',0),(109976,3055,'pt','Este empregado',0),(109977,3055,'ru','Ð”Ð°Ð½Ð½Ñ‹Ð¹ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº',0),(109978,3055,'es','Este Empleado',0),(109979,3055,'de','Dieser Mitarbeiter',0),(109980,3055,'en','This Employee',0),(109981,3056,'is','',0),(109982,3056,'dr','Ø§ÙŠÙ† Ù†ÙˆØ¹ ÙØ§ÙŠÙ„ Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ù†Ù…ÙŠ Ø´ÙˆØ¯',0),(109983,3056,'pr','Ø§ÙŠÙ† Ù†ÙˆØ¹ ÙØ§ÙŠÙ„ Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ù†Ù…ÙŠ Ø´ÙˆØ¯',0),(109984,3056,'tr','Bu dosya tÃ¼rÃ¼ desteklenmiyor.',0),(109985,3056,'pl','Tego typu pliku nie jest obsÅ‚ugiwany.',0),(109986,3056,'bg','Ð¢Ð¾Ð·Ð¸ Ñ‚Ð¸Ð¿ Ñ„Ð°Ð¹Ð» Ð½Ðµ ÑÐµ Ð¿Ð¾Ð´Ð´ÑŠÑ€Ð¶Ð°.',0),(109987,3056,'ur','Ø§Ø³ Ù‚Ø³Ù… Ù…Ø³Ù„ Ù…Ø¹Ø§ÙˆÙ† Ù†ÛÛŒÚº Û”',0),(109988,3056,'sr','ÐžÐ²Ð°Ñ˜ Ñ‚Ð¸Ð¿ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾Ð´Ñ€Ð¶Ð°Ð½.',0),(109989,3056,'vi','Loáº¡i há»“ sÆ¡ nÃ y khÃ´ng há»— trá»£',0),(109990,3056,'af','Hierdie LÃªertipe kan nie ondersteun word nie.',0),(109991,3056,'ro','Acest tip de fiÈ™ier nu este acceptat.',0),(109992,3056,'et','See failitÃ¼Ã¼p pole toetatud.',0),(109993,3056,'si','Ta vrsta datoteke ni podprta.',0),(109994,3056,'ba','Jenis file ini tidak didukung.',0),(109995,3056,'nl','Dit bestandstype wordt niet ondersteund.',0),(109996,3056,'fi','TÃ¤tÃ¤ tiedostotyyppiÃ¤ ei tueta.',0),(109997,3056,'no','Denne filtypen stÃ¸ttes ikke.',0),(109998,3056,'da','Denne filtype understÃ¸ttes ikke.',0),(109999,3056,'ko','ì´ íŒŒì¼ í˜•ì‹ì´ ì§€ì› ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(110000,3056,'he','.×¡×•×’ ×§×•×‘×¥ ×–×” ××™× ×• × ×ª×ž×š',0),(110001,3056,'el','Î‘Ï…Ï„ÏŒÏ‚ Î¿ Ï„ÏÏ€Î¿Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿Ï… Î´ÎµÎ½ Ï…Ï€Î¿ÏƒÏ„Î·ÏÎ¯Î¶ÎµÏ„Î±Î¹.',0),(110002,3056,'zh','æ­¤æ–‡ä»¶ç±»åž‹ä¸æ”¯æŒã€‚\r\n',0),(110003,3056,'sv','Den hÃ¤r filtypen stÃ¶ds inte.',0),(110004,3056,'it','Questo tipo di file non Ã¨ supportato.',0),(110005,3056,'tl','',0),(110006,3056,'th','&#3652;&#3617;&#3656;&#3626;&#3609;&#3633;&#3610;&#3626;&#3609;&#3640;&#3609;&#3652;&#3615;&#3621;&#3660;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3609;&#3637;&#3657;',0),(110007,3056,'hi','à¤¯à¤¹ à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤®à¤°à¥à¤¥à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(110008,3056,'ms','Fail jenis ini tidak disokong.',0),(110009,3056,'ar','Ù†ÙˆØ¹ Ù‡Ø°Ø§ Ø§Ù„Ù…Ù„Ù ØºÙŠØ± Ù…Ø¯Ø¹ÙˆÙ…',0),(110010,3056,'fr','Ce type de fichier n\'est pas pris en charge.',0),(110011,3056,'jp','ã?“ã?®ãƒ•ã‚¡ã‚¤ãƒ«å½¢å¼?ã?¯ä½¿ç”¨ã?§ã??ã?¾ã?›ã‚“',0),(110012,3056,'pt','Este tipo de arquivo nÃ£o Ã© suportado.',0),(110013,3056,'ru','Ð­Ñ‚Ð¾Ñ‚ Ñ‚Ð¸Ð¿ Ñ„Ð°Ð¹Ð»Ð° Ð½Ðµ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶Ð¸Ð²Ð°ÐµÑ‚ÑÑ.',0),(110014,3056,'es','Este tipo de file no se soporta',0),(110015,3056,'de','Dieser Dateityp wird nicht unterstÃ¼tzt.',0),(110016,3056,'en','This file type is not supported.',0),(110017,3057,'is','',0),(110018,3057,'dr','. Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†Ø¬Ø§Ù… ØªØºÙŠÙŠØ±Ø§Øª Ù¾Ø³Øª Ù†Ø´ÙˆØ¯ ',0),(110019,3057,'pr','Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ± Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø§Ø³Øª . Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†Ø¬Ø§Ù… ØªØºÙŠÙŠØ±Ø§Øª Ù¾Ø³Øª Ù†Ø´ÙˆØ¯ ',0),(110020,3057,'tr','Bu faturayÄ± deftere nakledilmiÅŸ. DeÄŸiÅŸiklik yapmadan Ã¶nce UNPOST gerekir.',0),(110021,3057,'pl','Ta faktura zostaÅ‚a zaksiÄ™gowana. NaleÅ¼y UNPOST przed wprowadzeniem zmian.',0),(110022,3057,'bg','Ð¢Ð°Ð·Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ðµ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½. Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° UNPOST Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸.',0),(110023,3057,'ur','Ø§Ø³ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù¾ÙˆØ³Ù¹ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û” ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ú©Ø±Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ø§Ù†Ù¾ÙˆØ³Ù¹ Ø¶Ø±ÙˆØ±ÛŒ ÛÛ’ Û”',0),(110024,3057,'sr','ÐžÐ²Ð¾ Ñ˜Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð°. ÐœÐ¾Ñ€Ð° Ð´Ð° ÑÐµ ÐŸÐžÐ’Ð£Ð˜Ð• Ð¿Ñ€Ðµ Ð²Ñ€ÑˆÐµÑšÐ° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°.',0),(110025,3057,'vi','HÃ³a Ä‘Æ¡n nÃ y Ä‘Ã£ káº¿t chuyá»ƒn. Pháº£i chÆ°a káº¿t chuyá»ƒn láº¡i trÆ°á»› khi thay Ä‘á»•i',0),(110026,3057,'af','Hierdie faktuur is gepos.  Moet ONPOS voordat veranderinge gemaak word.',0),(110027,3057,'ro','AceastÄƒ facturÄƒ a fost postat. Trebuie sÄƒ UNPOST Ã®nainte de a face modificÄƒri.',0),(110028,3057,'et','Selle arve on juba konteeritud. Tuleb UNPOST enne muudatuste tegemist.',0),(110029,3057,'si','Ta raÄun Å¾e knjiÅ¾ili. Mora UNPOST pred spremembami.',0),(110030,3057,'ba','Faktur ini telah diposting. Harus UNPOST sebelum membuat perubahan.',0),(110031,3057,'nl','Deze factuur is geboekt. UNPOST moet voordat u wijzigingen aanbrengt.',0),(110032,3057,'fi','TÃ¤mÃ¤ lasku on kirjattu. On UNPOST ennen kuin teet muutoksia.',0),(110033,3057,'no','Fakturaen er postert. MÃ¥ UNPOST fÃ¸r du gjÃ¸r endringer.',0),(110034,3057,'da','Fakturaen er blevet bogfÃ¸rt. Skal UNPOST fÃ¸r du foretager Ã¦ndringer.',0),(110035,3057,'ko','ì´ ì²­êµ¬ì„œ ê²Œì‹œ ë˜ì—ˆìŠµë‹ˆë‹¤. ë³€ê²½ í•˜ê¸° ì „ì— UNPOST í•´ì•¼ í•©ë‹ˆë‹¤.',0),(110036,3057,'he','×—×©×‘×•× ×™×ª ×–×• × ×¨×©×. ×‘×˜×— UNPOST ×œ×¤× ×™ ×‘×™×¦×•×¢ ×©×™× ×•×™×™×.',0),(110037,3057,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î­Ï‡ÎµÎ¹ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¸ÎµÎ¯. Î ÏÎ­Ï€ÎµÎ¹ Î½Î± UNPOST Ï€ÏÎ¹Î½ ÎºÎ¬Î½ÎµÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚.',0),(110038,3057,'zh','è¿™å¼ å‘ç¥¨å·²å‘å¸ƒã€‚ å¿…é¡»åœ¨å˜æ›´åŽå‘å¸ƒã€‚\r\n',0),(110039,3057,'sv','Denna faktura har bokfÃ¶rts. MÃ¥ste UNPOST innan du gÃ¶r Ã¤ndringar.',0),(110040,3057,'it','Questa fattura Ã¨ stata registrata. Deve UNPOST prima di apportare modifiche.',0),(110041,3057,'tl','',0),(110042,3057,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3609;&#3637;&#3657;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3621;&#3657;&#3623;. &#3605;&#3657;&#3629;&#3591;&#3607;&#3635;&#3585;&#3634;&#3619;&',0),(110043,3057,'hi','à¤‡à¤¸ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤¿à¤¯à¥à¤•à¥à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤ UNPOST à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(110044,3057,'ms','Invois ini telah dipaparkan. Mesti UNPOST sebelum membuat perubahan.',0),(110045,3057,'ar','ÙˆÙ‚Ø¯ Ø­Ù‚Ù‚Øª Ù‡Ø°Ù‡ Ø§Ù„ÙØ§ØªÙˆØ±Ø©. ÙŠØ¬Ø¨ Ø£Ù† Ø£ÙˆÙ†Ø¨ÙˆØ³Øª Ù‚Ø¨Ù„ Ø¥Ø¬Ø±Ø§Ø¡ Ø£ÙŠØ© ØªØºÙŠÙŠØ±Ø§Øª.',0),(110046,3057,'fr','Cette facture a Ã©tÃ© validÃ©e. Doit UNPOST avant d\'effectuer des modifications.',0),(110047,3057,'jp','ã?“ã?®è«‹æ±‚æ›¸ã?¯è¨ˆä¸Šã?•ã‚Œã?¦ã?„ã?¾ã?™ã€‚å¤‰æ›´ã?™ã‚‹å‰?ã?«æœªè¨ˆä¸Šã?¸æˆ»ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(110048,3057,'pt','Esta fatura foi postada. Deve UNPOST antes de fazer alteraÃ§Ãµes.',0),(110049,3057,'ru','Ð­Ñ‚Ð¾Ñ‚ ÑÑ‡ÐµÑ‚ Ð±Ñ‹Ð» ÑƒÑ‡Ñ‚ÐµÐ½. ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ UNPOST Ð´Ð¾ Ð²Ð½ÐµÑÐµÐ½Ð¸Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹.',0),(110050,3057,'es','Esta factura habÃ­a asentado. Debe DESASENTAR antes que hacer cambios',0),(110051,3057,'de','Diese Rechnung gebucht wurde. Muss UNPOST, bevor Sie Ã„nderungen vornehmen.',0),(110052,3057,'en','This invoice has been posted. Must UNPOST before making changes.',0),(110053,3058,'is','',0),(110054,3058,'dr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ØªÙƒÙ…ÙŠÙ„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(110055,3058,'pr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ØªÙƒÙ…ÙŠÙ„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(110056,3058,'tr','Bu emri yerine getirdi.',0),(110057,3058,'pl','To zamÃ³wienie zostaÅ‚o speÅ‚nione.',0),(110058,3058,'bg','Ð¢Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ðµ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¾.',0),(110059,3058,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ù¾ÙˆØ±ÛŒ ÛÙˆ Ú†Ú©ÛŒ ÛÛ’ Û”',0),(110060,3058,'sr','ÐžÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ð° ÑÐµ Ð¾ÑÑ‚Ð²Ð°Ñ€Ð¸Ð»Ð¾.',0),(110061,3058,'vi','ÄÆ¡n hÃ ng nÃ y Ä‘Ã£ hoÃ n táº¥t',0),(110062,3058,'af','Hierdie orde het vervul is.',0),(110063,3058,'ro','Acest ordin a fost Ã®ndeplinitÄƒ.',0),(110064,3058,'et','Tellimus on tÃ¤idetud.',0),(110065,3058,'si','Ta naloga je bila izpolnjena.',0),(110066,3058,'ba','Urutan ini telah digenapi.',0),(110067,3058,'nl','Deze bestelling is voldaan.',0),(110068,3058,'fi','TÃ¤mÃ¤ tilaus on tÃ¤ytetty.',0),(110069,3058,'no','Denne rekkefÃ¸lgen er oppfylt.',0),(110070,3058,'da','Denne ordre er blevet opfyldt.',0),(110071,3058,'ko','ì´ ìˆœì„œ ëŒ€ë¡œ ì„±ì·¨ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(110072,3058,'he','×”×–×ž× ×” ×–×• ×”×ª×’×©×ž×”',0),(110073,3058,'el','ÎˆÏ‡ÎµÎ¹ ÎµÎºÏ€Î»Î·ÏÏ‰Î¸ÎµÎ¯ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬.',0),(110074,3058,'zh','æ­¤è®¢å•å·²ç»å®Œæˆã€‚\r\n',0),(110075,3058,'sv','Denna ordning har uppfyllts.',0),(110076,3058,'it','Questo ordine Ã¨ stato adempiuto.',0),(110077,3058,'tl','',0),(110078,3058,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3636;&#3657;&#3629;&#3609;&#3637;&#3657;&#3610;&#3619;&#3619;&#3621;&#3640;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(110079,3058,'hi','à¤‡à¤¸ à¤‘à¤°à¥à¤¡à¤° à¤ªà¥‚à¤°à¤¾ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(110080,3058,'ms','Perintah ini telah dipenuhi.',0),(110081,3058,'ar','Ù‡Ø°Ø§ Ø§Ù„Ø£Ù…Ø± Ù‚Ø¯ Ø§Ø³ØªÙˆÙÙŠØª.',0),(110082,3058,'fr','Cette commande a Ã©tÃ© exÃ©cutÃ©e.',0),(110083,3058,'jp','ã?“ã?®æ³¨æ–‡ã?¯å®Œäº†ã?—ã?¦ã?„ã?¾ã?™',0),(110084,3058,'pt','Esta ordem foi cumprida.',0),(110085,3058,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¾.',0),(110086,3058,'es','Este Orden se CumpliÃ³',0),(110087,3058,'de','Diese Reihenfolge hat sich erfÃ¼llt.',0),(110088,3058,'en','This order has been fulfilled.',0),(110089,3059,'is','',0),(110090,3059,'dr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ù‚Ø¨Ù„Ø§  Ø¨Ù‡ Ø·ÙˆØ± ÙƒØ§Ù…Ù„ Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(110091,3059,'pr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ù‚Ø¨Ù„Ø§  Ø¨Ù‡ Ø·ÙˆØ± ÙƒØ§Ù…Ù„ Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(110092,3059,'tr','Bu sÄ±rada zaten tamamen sevk edilmiÅŸ.',0),(110093,3059,'pl','To zamÃ³wienie ma juÅ¼ peÅ‚ni wysÅ‚ane.',0),(110094,3059,'bg','Ð¢Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð²ÐµÑ‡Ðµ Ðµ Ð½Ð°Ð¿ÑŠÐ»Ð½Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½.',0),(110095,3059,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ù¾ÛÙ„Û’ ÛÛŒ Ù…Ú©Ù…Ù„ Ø·ÙˆØ± Ù¾Ø± Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(110096,3059,'sr','ÐžÐ²Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³ Ð²ÐµÑ› Ñƒ Ð¿Ð¾Ñ‚Ð¿ÑƒÐ½Ð¾ÑÑ‚Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½.',0),(110097,3059,'vi','ÄÆ¡n hÃ ng nÃ y Ä‘Ã£ chuyá»ƒn Ä‘á»§',0),(110098,3059,'af','Hierdie bestelling is alreeds ten volle versend.',0),(110099,3059,'ro','Acest ordin a fost deja expediat complet.',0),(110100,3059,'et','Tellimus on juba tÃ¤ielikult lÃ¤hetatud.',0),(110101,3059,'si','Ta naloga je Å¾e v celoti dobavljen.',0),(110102,3059,'ba','Urutan ini sudah dikirim dengan sepenuhnya.',0),(110103,3059,'nl','Deze bestelling is al volledig verzonden.',0),(110104,3059,'fi','TÃ¤mÃ¤ jÃ¤rjestys on jo kokonaan toimitettu.',0),(110105,3059,'no','Denne rekkefÃ¸lgen har allerede levert.',0),(110106,3059,'da','Denne ordre har allerede vÃ¦ret fuldt leveret.',0),(110107,3059,'ko','ì´ ìˆœì„œ ëŒ€ë¡œ ì´ë¯¸ ì™„ë²½ í•˜ ê²Œ ë°°ì†¡ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(110108,3059,'he','×¦×• ×–×” ×›×‘×¨ × ×©×œ×—×” ×‘××•×¤×Ÿ ×ž×œ×.',0),(110109,3059,'el','Î‘Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Î®Î´Î· Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯ Ï€Î»Î®ÏÏ‰Ï‚.',0),(110110,3059,'zh','æ­¤è®¢å•å·²è¢«å®Œå…¨å‡ºè´§ã€‚\r\n',0),(110111,3059,'sv','Denna ordning har redan skeppats helt.',0),(110112,3059,'it','Questo ordine Ã¨ stato giÃ  spedito completamente.',0),(110113,3059,'tl','',0),(110114,3059,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3636;&#3657;&#3629;&#3609;&#3637;&#3657;&#3614;&#3619;&#3657;&#3629;&#3617;&#3586;&#3609;&#3626;&#3656;&#3591;&#3629;&#3618;&#3656;&#3634;&#3591;&#3648;&#3605;&#3655;&#3617;&#3607;&#3637;&#3656;',0),(110115,3059,'hi','à¤¯à¤¹ à¤†à¤¦à¥‡à¤¶ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤ªà¥‚à¤°à¥€ à¤¤à¤°à¤¹ à¤¸à¥‡ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(110116,3059,'ms','Perintah ini sudah sepenuhnya dikirimkan.',0),(110117,3059,'ar','ÙØ¹Ù„Ø§ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ù‡Ø°Ø§ Ø§Ù„Ø£Ù…Ø± ØªÙ…Ø§Ù…Ø§.',0),(110118,3059,'fr','Cette commande a dÃ©jÃ  Ã©tÃ© entiÃ¨rement expÃ©diÃ©e.',0),(110119,3059,'jp','ã?“ã?®æ³¨æ–‡ã?¯æ—¢ã?«ç™ºé€?ã‚’å®Œäº†ã?—ã?¦ã?„ã?¾ã?™',0),(110120,3059,'pt','Esta ordem jÃ¡ foi totalmente enviada.',0),(110121,3059,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ñ€Ð¸ÐºÐ°Ð· ÑƒÐ¶Ðµ Ð±Ñ‹Ð» Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½ Ð¿Ð¾Ð»Ð½Ð¾ÑÑ‚ÑŒÑŽ.',0),(110122,3059,'es','Este Orden ya se enviÃ³ completamente',0),(110123,3059,'de','Dieser Auftrag hat bereits vollstÃ¤ndig geliefert wurde.',0),(110124,3059,'en','This order has already been fully shipped.',0),(110125,3060,'is','',0),(110126,3060,'dr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠ Ø²ÙŠØ± Ø±Ø§ Ø¯Ø§Ø±Ø¯ ',0),(110127,3060,'pr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠ Ø²ÙŠØ± Ø±Ø§ Ø¯Ø§Ø±Ø¯ ',0),(110128,3060,'tr','Bu sÄ±rada aÅŸaÄŸÄ±daki sevk irsaliyeleri vardÄ±r',0),(110129,3060,'pl','Ten ma nastÄ™pujÄ…ce przesyÅ‚ek',0),(110130,3060,'bg','Ð¢Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¸Ð¼Ð° ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ñ‚ÐºÐ¸',0),(110131,3060,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ù…ÛŒÚº Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ù„ÛŒØªÛŒ ÛÛ’',0),(110132,3060,'sr','ÐžÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ð° Ð¸Ð¼Ð° ÑÐ»ÐµÐ´ÐµÑ›Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(110133,3060,'vi','ÄÆ¡n hÃ ng nÃ y cÃ³ chuyáº¿n hÃ ng sau',0),(110134,3060,'af','Hierdie bestelling het die volgende besendings',0),(110135,3060,'ro','AceastÄƒ comandÄƒ are urmÄƒtoarele livrÄƒri',0),(110136,3060,'et','Selle tellimusega on jÃ¤rgmised saadetised',0),(110137,3060,'si','Ta vrstni red je naslednje poÅ¡iljke',0),(110138,3060,'ba','Urutan ini memiliki pengiriman berikut',0),(110139,3060,'nl','Deze volgorde heeft de volgende zendingen',0),(110140,3060,'fi','TÃ¤mÃ¤ jÃ¤rjestys on seuraavien lÃ¤hetysten',0),(110141,3060,'no','Denne bestillingen er fÃ¸lgende forsendelser',0),(110142,3060,'da','Denne ordre har de fÃ¸lgende leverancer',0),(110143,3060,'ko','ì´ ìˆœì„œëŠ” ë‹¤ìŒ ì¶œí•˜',0),(110144,3060,'he','×¦×• ×–×” ×™×© ××ª ×”×ž×©×œ×•×—×™× ×”×‘××™×',0),(110145,3060,'el','Î‘Ï…Ï„Î® Î· ÏƒÎµÎ¹ÏÎ¬ Î­Ï‡ÎµÎ¹ Ï„Î¹Ï‚ Î±ÎºÏŒÎ»Î¿Ï…Î¸ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(110146,3060,'zh','æœ¬è®¢å•æœ‰ä»¥ä¸‹å‡ºè´§\r\n',0),(110147,3060,'sv','Denna ordning har de fÃ¶ljande transporterna',0),(110148,3060,'it','Questo ordine ha le seguenti spedizioni',0),(110149,3060,'tl','',0),(110150,3060,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3636;&#3657;&#3629;&#3609;&#3637;&#3657;&#3617;&#3637;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(110151,3060,'hi','à¤‡à¤¸ à¤†à¤°à¥à¤¡à¤° à¤¹à¥ˆ à¤¨à¤¿à¤®à¥à¤¨ à¤²à¤¦à¤¾à¤¨',0),(110152,3060,'ms','Perintah ini telah penghantaran berikut',0),(110153,3060,'ar','Ù‡Ø°Ø§ Ø§Ù„Ø£Ù…Ø± Ù‚Ø¯ Ø§Ù„Ø´Ø­Ù†Ø§Øª Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(110154,3060,'fr','Cette commande a les expÃ©ditions suivantes',0),(110155,3060,'jp','ã?“ã?®æ³¨æ–‡ã?«ã?¯æ¬¡ã?®ç™ºé€?å“?ã?Œã?‚ã‚Šã?¾ã?™',0),(110156,3060,'pt','Esta ordem tem os seguintes carregamentos',0),(110157,3060,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¸Ð¼ÐµÐµÑ‚ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(110158,3060,'es','Este Orden tiene los siguentes envÃ­os',0),(110159,3060,'de','Dieser Auftrag hat die folgenden Sendungen',0),(110160,3060,'en','This order has the following shipments',0),(110161,3061,'is','',0),(110162,3061,'dr','Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡ ',0),(110163,3061,'pr','Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡ ',0),(110164,3061,'tr','Bu dÃ¶nem',0),(110165,3061,'pl','Ten okres',0),(110166,3061,'bg','Ð¢Ð¾Ð·Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(110167,3061,'ur','ÛŒÛ Ø¯ÙˆØ±',0),(110168,3061,'sr','ÐžÐ²Ð°Ñ˜ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(110169,3061,'vi','Thá»i ká»³ nÃ y',0),(110170,3061,'af','Hierdie Periode',0),(110171,3061,'ro','AceastÄƒ perioadÄƒ',0),(110172,3061,'et','Selle aja',0),(110173,3061,'si','To obdobje',0),(110174,3061,'ba','Periode ini',0),(110175,3061,'nl','Deze periode',0),(110176,3061,'fi','TÃ¤nÃ¤ aikana',0),(110177,3061,'no','Denne perioden',0),(110178,3061,'da','Denne periode',0),(110179,3061,'ko','ì´ ê¸°ê°„',0),(110180,3061,'he','×ª×§×•×¤×” ×–×•',0),(110181,3061,'el','Î‘Ï…Ï„Î® Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(110182,3061,'zh','è¿™ä¸€æ—¶æœŸ\r\n',0),(110183,3061,'sv','Denna Period',0),(110184,3061,'it','Questo periodo',0),(110185,3061,'tl','',0),(110186,3061,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3609;&#3637;&#3657;',0),(110187,3061,'hi','à¤‡à¤¸ à¤…à¤µà¤§à¤¿ à¤•à¥‡',0),(110188,3061,'ms','Tempoh ini',0),(110189,3061,'ar','Ù‡Ø°Ù‡ Ø§Ù„ÙØªØ±Ø©',0),(110190,3061,'fr','Cette pÃ©riode',0),(110191,3061,'jp','ã?“ã?®æœŸé–“',0),(110192,3061,'pt','Este perÃ­odo',0),(110193,3061,'ru','Ð”Ð°Ð½Ð½Ñ‹Ð¹ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(110194,3061,'es','Este PerÃ­odo',0),(110195,3061,'de','Dieser Zeit',0),(110196,3061,'en','This Period',0),(110197,3062,'is','',0),(110198,3062,'dr','Ù‡Ø²Ø§Ø± ',0),(110199,3062,'pr','Ù‡Ø²Ø§Ø± ',0),(110200,3062,'tr','bin',0),(110201,3062,'pl','tysiÄ™cy',0),(110202,3062,'bg','Ñ…Ð¸Ð»ÑÐ´Ð¸',0),(110203,3062,'ur','ÛØ²Ø§Ø±',0),(110204,3062,'sr','Ñ…Ð¸Ñ™Ð°Ð´Ñƒ',0),(110205,3062,'vi','ngÃ n',0),(110206,3062,'af','duisend',0),(110207,3062,'ro','mie',0),(110208,3062,'et','tuhat',0),(110209,3062,'si','tisoÄ',0),(110210,3062,'ba','seribu',0),(110211,3062,'nl','duizend',0),(110212,3062,'fi','tuhatta',0),(110213,3062,'no','tusen',0),(110214,3062,'da','tusinde',0),(110215,3062,'ko','ì²œ',0),(110216,3062,'he','××œ×£',0),(110217,3062,'el','Ï‡Î¹Î»Î¹Î¬Î´ÎµÏ‚',0),(110218,3062,'zh','åƒ\r\n',0),(110219,3062,'sv','tusen',0),(110220,3062,'it','mille',0),(110221,3062,'tl','',0),(110222,3062,'th','&#3627;&#3609;&#3638;&#3656;&#3591;&#3614;&#3633;&#3609;',0),(110223,3062,'hi','à¤¹à¤œà¤¾à¤°',0),(110224,3062,'ms','seribu',0),(110225,3062,'ar','Ø£Ù„Ù',0),(110226,3062,'fr','mille',0),(110227,3062,'jp','1000',0),(110228,3062,'pt','mil',0),(110229,3062,'ru','Ñ‚Ñ‹ÑÑÑ‡Ð°',0),(110230,3062,'es','mil',0),(110231,3062,'de','Tausend',0),(110232,3062,'en','thousand',0),(110233,3063,'is','',0),(110234,3063,'dr','3',0),(110235,3063,'pr','Ø³Ù‡   3',0),(110236,3063,'tr','ÃœÃ§',0),(110237,3063,'pl','Trzy',0),(110238,3063,'bg','Ð¢Ñ€Ð¸',0),(110239,3063,'ur','ØªÛŒÙ†',0),(110240,3063,'sr','Ð¢Ñ€Ð¸',0),(110241,3063,'vi','Ba',0),(110242,3063,'af','Drie',0),(110243,3063,'ro','Trei',0),(110244,3063,'et','Kolm',0),(110245,3063,'si','Tri',0),(110246,3063,'ba','Tiga',0),(110247,3063,'nl','Drie',0),(110248,3063,'fi','Kolme',0),(110249,3063,'no','Tre',0),(110250,3063,'da','Tre',0),(110251,3063,'ko','3',0),(110252,3063,'he','×©×œ×•×©',0),(110253,3063,'el','Î¤ÏÎµÎ¹Ï‚',0),(110254,3063,'zh','ä¸‰\r\n',0),(110255,3063,'sv','Tre',0),(110256,3063,'it','Tre',0),(110257,3063,'tl','',0),(110258,3063,'th','&#3626;&#3634;&#3617;',0),(110259,3063,'hi','à¤¤à¥€à¤¨',0),(110260,3063,'ms','Tiga',0),(110261,3063,'ar','Ø«Ù„Ø§Ø«Ø©',0),(110262,3063,'fr','Trois',0),(110263,3063,'jp','3',0),(110264,3063,'pt','TrÃªs',0),(110265,3063,'ru','Ð¢Ñ€Ð¸',0),(110266,3063,'es','tres',0),(110267,3063,'de','Drei',0),(110268,3063,'en','Three',0),(110269,3064,'is','',0),(110270,3064,'dr','Ø«Ø¨Øª Ù†Ø§Ù… Ø¬Ø¯ÙŠ',0),(110271,3064,'pr','Ø«Ø¨Øª Ù†Ø§Ù… Ø¬Ø¯ÙŠ',0),(110272,3064,'tr','SÄ±kÄ± kayÄ±t',0),(110273,3064,'pl','Mocno rejestracji',0),(110274,3064,'bg','Ð—Ð´Ñ€Ð°Ð²Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(110275,3064,'ur','ØªÙ†Ú¯ Ø±Ø¬Ø³Ù¹Ø±ÛŒØ´Ù†',0),(110276,3064,'sr','Ð¦Ð²Ñ€ÑÑ‚Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ð°',0),(110277,3064,'vi','ÄÄƒng kÃ½ cháº·t',0),(110278,3064,'af','Stywe registrasie',0),(110279,3064,'ro','Strans de Ã®nregistrare',0),(110280,3064,'et','Tihe registreerimine',0),(110281,3064,'si','Stroga registracija',0),(110282,3064,'ba','Pendaftaran ketat',0),(110283,3064,'nl','Strakke registratie',0),(110284,3064,'fi','Tiukka rekisterÃ¶inti',0),(110285,3064,'no','Stramme registrering',0),(110286,3064,'da','Stram registrering',0),(110287,3064,'ko','ê½‰ ë“±ë¡',0),(110288,3064,'he','×¨×™×©×•× ×—×–×§',0),(110289,3064,'el','Î£Ï†Î¹Ï‡Ï„ÏŒ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(110290,3064,'zh','ç´§ç™»è®°\r\n',0),(110291,3064,'sv','SnÃ¤va registrering',0),(110292,3064,'it','Registrazione stretto',0),(110293,3064,'tl','',0),(110294,3064,'th','&#3585;&#3634;&#3619;&#3621;&#3591;&#3607;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;&#3649;&#3629;&#3629;&#3633;&#3604;',0),(110295,3064,'hi','à¤¤à¤‚à¤— à¤ªà¤‚à¤œà¥€à¤•à¤°à¤£',0),(110296,3064,'ms','Pendaftaran yang ketat',0),(110297,3064,'ar','ØªØ³Ø¬ÙŠÙ„ Ø¶ÙŠÙ‚',0),(110298,3064,'fr','Enregistrement serrÃ©',0),(110299,3064,'jp','Tight Registration',0),(110300,3064,'pt','Registo apertado',0),(110301,3064,'ru','Ð¢ÑƒÐ³Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(110302,3064,'es','Registro Apretada',0),(110303,3064,'de','Enge Registrierung',0),(110304,3064,'en','Tight Registration',0),(110305,3065,'is','',0),(110306,3065,'dr','Ø«Ø¨Øª Ù†Ø§Ù… Ø¬Ø¯ÙŠ Ø¯Ø± Ø¬Ù‡Øª ',0),(110307,3065,'pr','Ø«Ø¨Øª Ù†Ø§Ù… Ø¬Ø¯ÙŠ Ø¯Ø± Ø¬Ù‡Øª ',0),(110308,3065,'tr','TarafÄ±nda sÄ±kÄ± kayÄ±t',0),(110309,3065,'pl','Mocno rejestracji na stronie',0),(110310,3065,'bg','Ð—Ð´Ñ€Ð°Ð²Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ Ð¾Ñ‚ ÑÑ‚Ñ€Ð°Ð½Ð°',0),(110311,3065,'ur','ØªÙ†Ú¯ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ Ø·Ø±Ù',0),(110312,3065,'sr','Ð¦Ð²Ñ€ÑÑ‚Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ðµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸',0),(110313,3065,'vi','ÄÄƒng kÃ½ cháº·t máº·t bÃªn',0),(110314,3065,'af','Stywe registrasie aan kant',0),(110315,3065,'ro','ÃŽnregistrare strans pe partea',0),(110316,3065,'et','Tihe registreerimine kÃ¼ljel',0),(110317,3065,'si','Stroga registracija na strani',0),(110318,3065,'ba','Ketat pendaftaran di sisi',0),(110319,3065,'nl','Strakke registratie aan kant',0),(110320,3065,'fi','Tiukka rekisterÃ¶inti puolella',0),(110321,3065,'no','Stramme registrering pÃ¥ side',0),(110322,3065,'da','Stram registrering side',0),(110323,3065,'ko','ì¸¡ë©´ì— ê½‰ ë“±ë¡',0),(110324,3065,'he','×¨×™×©×•× ×—×–×§ ×‘×¦×“',0),(110325,3065,'el','Î£Ï†Î¹Ï‡Ï„ÏŒ ÎµÎ³Î³ÏÎ±Ï†Î® ÏƒÏ„Î·Î½ Ï€Î»ÎµÏ…ÏÎ¬',0),(110326,3065,'zh','ä¾§ç´§ç™»è®°\r\n',0),(110327,3065,'sv','SnÃ¤va registrering pÃ¥ sidan',0),(110328,3065,'it','Registrazione stretta sul lato',0),(110329,3065,'tl','',0),(110330,3065,'th','&#3604;&#3657;&#3634;&#3609;&#3585;&#3634;&#3619;&#3621;&#3591;&#3607;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;&#3649;&#3629;&#3629;&#3633;&#3604;',0),(110331,3065,'hi','à¤ªà¤•à¥à¤· à¤ªà¤° à¤¤à¤‚à¤— à¤ªà¤‚à¤œà¥€à¤•à¤°à¤£',0),(110332,3065,'ms','Pendaftaran yang ketat pada bahagian',0),(110333,3065,'ar','ØªØ³Ø¬ÙŠÙ„ Ø¶ÙŠÙ‚ Ø¹Ù„Ù‰ Ø§Ù„Ø¬Ø§Ù†Ø¨',0),(110334,3065,'fr','Enregistrement serrÃ© sur le cÃ´tÃ©',0),(110335,3065,'jp','Tight registration on side',0),(110336,3065,'pt','Registo apertado do lado',0),(110337,3065,'ru','Ð¢ÑƒÐ³Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ Ð½Ð° ÑÑ‚Ð¾Ñ€Ð¾Ð½Ðµ',0),(110338,3065,'es','Registro Apretada en el lado',0),(110339,3065,'de','Enge Registrierung auf Seite',0),(110340,3065,'en','Tight registration on side',0),(110341,3066,'is','',0),(110342,3066,'dr','Ø²Ù…Ø§Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(110343,3066,'pr','Ø²Ù…Ø§Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(110344,3066,'tr','KullanÄ±lan kere',0),(110345,3066,'pl','Czasy',0),(110346,3066,'bg','ÐŸÑŠÑ‚Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð°',0),(110347,3066,'ur','Ù…Ø±ØªØ¨Û Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§',0),(110348,3066,'sr','ÐŸÑƒÑ‚Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ð¾',0),(110349,3066,'vi','Thá»i gian Ä‘Ã£ dÃ¹ng',0),(110350,3066,'af','Kere Gebruik',0),(110351,3066,'ro','Ori utilizate',0),(110352,3066,'et','Korda kasutatud',0),(110353,3066,'si','Krat uporabljena',0),(110354,3066,'ba','Kali digunakan',0),(110355,3066,'nl','Keer gebruikt',0),(110356,3066,'fi','KÃ¤yttÃ¶kertojen mÃ¤Ã¤rÃ¤',0),(110357,3066,'no','Tid brukt',0),(110358,3066,'da','Gange bruges',0),(110359,3066,'ko','ì‚¬ìš© ì‹œê°„',0),(110360,3066,'he','×‘×™×ž×™×',0),(110361,3066,'el','Î¦Î¿ÏÎ­Ï‚ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹',0),(110362,3066,'zh','æ—¶é—´ä½¿ç”¨\r\n',0),(110363,3066,'sv','GÃ¥nger anvÃ¤nds',0),(110364,3066,'it','Volte usati',0),(110365,3066,'tl','',0),(110366,3066,'th','&#3648;&#3623;&#3621;&#3634;&#3651;&#3594;&#3657;',0),(110367,3066,'hi','à¤¬à¤¾à¤° à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(110368,3066,'ms','Times yang digunakan',0),(110369,3066,'ar','Ø§Ù„Ø£ÙˆÙ‚Ø§Øª Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(110370,3066,'fr','Temps utilisÃ©s',0),(110371,3066,'jp','åˆ©ç”¨å›žæ•°',0),(110372,3066,'pt','Vezes usados',0),(110373,3066,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð½Ð¾Ðµ Ð’Ñ€ÐµÐ¼Ñ',0),(110374,3066,'es','Tiempos Usados',0),(110375,3066,'de','Mal verwendet',0),(110376,3066,'en','Times Used',0),(110377,3067,'is','',0),(110378,3067,'dr','(Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯Ø§Øª',0),(110379,3067,'pr','Ø§Ù†Ø¹Ø§Ù… Ù‡Ø§(Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯Ø§Øª',0),(110380,3067,'tr','Ä°puÃ§larÄ±',0),(110381,3067,'pl','Porady',0),(110382,3067,'bg','Ð¡ÑŠÐ²ÐµÑ‚Ð¸',0),(110383,3067,'ur','ØªØ¬Ø§ÙˆÛŒØ²',0),(110384,3067,'sr','Ð¡Ð°Ð²ÐµÑ‚Ð¸',0),(110385,3067,'vi','Tiá»n boa',0),(110386,3067,'af','Wenke',0),(110387,3067,'ro','Sfaturi',0),(110388,3067,'et','NÃµuanded',0),(110389,3067,'si','Nasveti',0),(110390,3067,'ba','Tips',0),(110391,3067,'nl','Tips',0),(110392,3067,'fi','VinkkejÃ¤',0),(110393,3067,'no','Tips',0),(110394,3067,'da','Tips',0),(110395,3067,'ko','íŒ',0),(110396,3067,'he','×˜×™×¤×™×',0),(110397,3067,'el','Î£Ï…Î¼Î²Î¿Ï…Î»Î­Ï‚',0),(110398,3067,'zh','å°è´¹\r\n',0),(110399,3067,'sv','Tips',0),(110400,3067,'it','Consigli',0),(110401,3067,'tl','',0),(110402,3067,'th','&#3607;&#3636;&#3611;',0),(110403,3067,'hi','à¤¯à¥à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤',0),(110404,3067,'ms','Tips',0),(110405,3067,'ar','Ù†ØµØ§Ø¦Ø­',0),(110406,3067,'fr','Conseils',0),(110407,3067,'jp','ãƒ?ãƒƒãƒ—',0),(110408,3067,'pt','Dicas',0),(110409,3067,'ru','Ð¡Ð¾Ð²ÐµÑ‚Ñ‹',0),(110410,3067,'es','Propinas',0),(110411,3067,'de','Tipps',0),(110412,3067,'en','Tips',0),(110413,3068,'is','',0),(110414,3068,'dr','Ø§Ù†Ø¹Ø§Ù… Ù‡Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¯Ø³ØªÙ…Ø²Ø¯',0),(110415,3068,'pr','Ø§Ù†Ø¹Ø§Ù… Ù‡Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¯Ø³ØªÙ…Ø²Ø¯',0),(110416,3068,'tr','Ãœcret olarak ipuÃ§larÄ±',0),(110417,3068,'pl','Porady jak pÅ‚ace',0),(110418,3068,'bg','Ð¡ÑŠÐ²ÐµÑ‚Ð¸ ÐºÐ°Ñ‚Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(110419,3068,'ur','Ù…Ø²Ø¯ÙˆØ±ÛŒ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ú©ÛŒ Ø³ÙØ§Ø±Ø´',0),(110420,3068,'sr','Ð¡Ð°Ð²Ñ˜ÐµÑ‚Ð¸ ÐºÐ°Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ',0),(110421,3068,'vi','Tiá»n boa tÃ­nh vÃ o lÆ°Æ¡ng',0),(110422,3068,'af','Fooitjies as Besoldiging',0),(110423,3068,'ro','Sfaturi ca salariile',0),(110424,3068,'et','NÃµuandeid nagu palk',0),(110425,3068,'si','Nasveti kot plaÄe',0),(110426,3068,'ba','Tips sebagai upah',0),(110427,3068,'nl','Tips als loon',0),(110428,3068,'fi','VinkkejÃ¤ palkat',0),(110429,3068,'no','Tips som lÃ¸nn',0),(110430,3068,'da','Tips som lÃ¸n',0),(110431,3068,'ko','ìž„ê¸ˆìœ¼ë¡œ íŒ',0),(110432,3068,'he','×˜×™×¤×™× ×›×ž×• ×©×›×¨',0),(110433,3068,'el','Î£Ï…Î¼Î²Î¿Ï…Î»Î­Ï‚ Ï‰Ï‚ Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(110434,3068,'zh','å°è´¹ä½œä¸ºå·¥èµ„\r\n',0),(110435,3068,'sv','Tips som lÃ¶ner',0),(110436,3068,'it','Consigli come stipendi',0),(110437,3068,'tl','',0),(110438,3068,'th','&#3607;&#3636;&#3611;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;',0),(110439,3068,'hi','à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¯à¥à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤',0),(110440,3068,'ms','Tip-Tip sebagai upah',0),(110441,3068,'ar','Ù†ØµØ§Ø¦Ø­ Ø§Ù„Ø£Ø¬ÙˆØ±',0),(110442,3068,'fr','Conseils salaire',0),(110443,3068,'jp','çµ¦ä¸Žã?¨ã?—ã?¦ã?®ãƒ?ãƒƒãƒ—',0),(110444,3068,'pt','Dicas como salÃ¡rios',0),(110445,3068,'ru','Ð¡Ð¾Ð²ÐµÑ‚Ñ‹, ÐºÐ°Ðº Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(110446,3068,'es','Propinas como Sueldos',0),(110447,3068,'de','Tipps, wie LÃ¶hne',0),(110448,3068,'en','Tips as wages',0),(110449,3069,'is','',0),(110450,3069,'dr','Ø§Ù†Ø¹Ø§Ù… Ù‡Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¯Ø³ØªÙ…Ø²Ø¯',0),(110451,3069,'pr','Ø§Ù†Ø¹Ø§Ù… Ù‡Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¯Ø³ØªÙ…Ø²Ø¯',0),(110452,3069,'tr','Ãœcret olarak ipuÃ§larÄ±',0),(110453,3069,'pl','Porady jak pÅ‚ace',0),(110454,3069,'bg','Ð¡ÑŠÐ²ÐµÑ‚Ð¸ ÐºÐ°Ñ‚Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(110455,3069,'ur','Ù…Ø²Ø¯ÙˆØ±ÛŒ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ú©ÛŒ Ø³ÙØ§Ø±Ø´',0),(110456,3069,'sr','Ð¡Ð°Ð²Ñ˜ÐµÑ‚Ð¸ ÐºÐ°Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ',0),(110457,3069,'vi','Tiá»n boa tÃ­nh vÃ o lÆ°Æ¡ng',0),(110458,3069,'af','Fooitjies as Besoldiging',0),(110459,3069,'ro','Sfaturi ca salariile',0),(110460,3069,'et','NÃµuandeid nagu palk',0),(110461,3069,'si','Nasveti kot plaÄe',0),(110462,3069,'ba','Tips sebagai upah',0),(110463,3069,'nl','Tips als loon',0),(110464,3069,'fi','VinkkejÃ¤ palkat',0),(110465,3069,'no','Tips som lÃ¸nn',0),(110466,3069,'da','Tips som lÃ¸n',0),(110467,3069,'ko','ìž„ê¸ˆìœ¼ë¡œ íŒ',0),(110468,3069,'he','×˜×™×¤×™× ×›×ž×• ×©×›×¨',0),(110469,3069,'el','Î£Ï…Î¼Î²Î¿Ï…Î»Î­Ï‚ Ï‰Ï‚ Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(110470,3069,'zh','å°è´¹ä½œä¸ºå·¥èµ„\r\n',0),(110471,3069,'sv','Tips som lÃ¶ner',0),(110472,3069,'it','Consigli come stipendi',0),(110473,3069,'tl','',0),(110474,3069,'th','&#3607;&#3636;&#3611;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;',0),(110475,3069,'hi','à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¯à¥à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤',0),(110476,3069,'ms','Tip-Tip sebagai upah',0),(110477,3069,'ar','Ù†ØµØ§Ø¦Ø­ Ø§Ù„Ø£Ø¬ÙˆØ±',0),(110478,3069,'fr','Conseils salaire',0),(110479,3069,'jp','çµ¦ä¸Žã?¨ã?—ã?¦ã?®ãƒ?ãƒƒãƒ—',0),(110480,3069,'pt','Dicas como salÃ¡rios',0),(110481,3069,'ru','Ð¡Ð¾Ð²ÐµÑ‚Ñ‹, ÐºÐ°Ðº Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(110482,3069,'es','Propinas como Sueldos',0),(110483,3069,'de','Tipps, wie LÃ¶hne',0),(110484,3069,'en','Tips as wages',0),(110485,3070,'is','',0),(110486,3070,'dr','Ø¹Ù†ÙˆØ§Ù† ',0),(110487,3070,'pr','Ø¹Ù†ÙˆØ§Ù† ',0),(110488,3070,'tr','BaÅŸlÄ±k',0),(110489,3070,'pl','TytuÅ‚',0),(110490,3070,'bg','Ð—Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ',0),(110491,3070,'ur','Ø¹Ù†ÙˆØ§Ù†',0),(110492,3070,'sr','ÐÐ°ÑÐ»Ð¾Ð²',0),(110493,3070,'vi','Chá»©c danh',0),(110494,3070,'af','Titel',0),(110495,3070,'ro','Titlu',0),(110496,3070,'et','Pealkiri',0),(110497,3070,'si','Naslov',0),(110498,3070,'ba','Judul',0),(110499,3070,'nl','Titel',0),(110500,3070,'fi','Otsikko',0),(110501,3070,'no','Tittel',0),(110502,3070,'da','Titel',0),(110503,3070,'ko','ì œëª©',0),(110504,3070,'he','×›×•×ª×¨×ª',0),(110505,3070,'el','Î¤Î¯Ï„Î»Î¿Ï‚',0),(110506,3070,'zh','æ ‡é¢˜\r\n',0),(110507,3070,'sv','Titel',0),(110508,3070,'it','Titolo',0),(110509,3070,'tl','',0),(110510,3070,'th','&#3605;&#3657;&#3609;&#3648;&#3619;&#3639;&#3656;&#3629;&#3591;',0),(110511,3070,'hi','à¤¶à¥€à¤°à¥à¤·à¤•',0),(110512,3070,'ms','Tajuk',0),(110513,3070,'ar','Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(110514,3070,'fr','Titre',0),(110515,3070,'jp','ã‚¿ã‚¤ãƒˆãƒ«',0),(110516,3070,'pt','TÃ­tulo',0),(110517,3070,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ',0),(110518,3070,'es','TÃ­tulo',0),(110519,3070,'de','Titel',0),(110520,3070,'en','Title',0),(110521,3071,'is','',0),(110522,3071,'dr',': Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø³Ù…Øª / ØªÙØµÛŒÙ„  ',0),(110523,3071,'pr','Ø¹Ù†ÙˆØ§Ù† Ø¯Ø±Ø®ÙˆØ§Ø³Øª : Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø³Ù…Øª / Ø´Ø±Ø­ ',0),(110524,3071,'tr','BÃ¶lÃ¼m sayÄ±sÄ± / aÃ§Ä±klama',0),(110525,3071,'pl','CzÄ™Å›Ä‡ numer / opis',0),(110526,3071,'bg','Ð§Ð°ÑÑ‚ Ð½Ð¾Ð¼ÐµÑ€ / Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(110527,3071,'ur','Ø­ØµÛ Ù†Ù…Ø¨Ø± / Ø¨ÛŒØ§Ù†',0),(110528,3071,'sr','Ð Ð°ÑÑ‚Ð°Ð²Ð¸ Ð±Ñ€Ð¾Ñ˜ / Ð¾Ð¿Ð¸Ñ',0),(110529,3071,'vi','Sá»‘ phá»¥ tÃ¹ng / MÃ´ táº£',0),(110530,3071,'af','Deel nommer / Beskrywing',0),(110531,3071,'ro','Partea numÄƒrul / Descriere',0),(110532,3071,'et','Osa Number / kirjeldus',0),(110533,3071,'si','Del Å¡tevilka / opis',0),(110534,3071,'ba','Bagian nomor / Keterangan',0),(110535,3071,'nl','Onderdeelnummer / beschrijving',0),(110536,3071,'fi','Osa numero / kuvaus',0),(110537,3071,'no','Del antall / beskrivelse',0),(110538,3071,'da','Del nummer / beskrivelse',0),(110539,3071,'ko','ë¶€í’ˆ ë²ˆí˜¸ / ì„¤ëª…',0),(110540,3071,'he','×—×œ×§ ×ž×¡×¤×¨ / ×ª×™××•×¨',0),(110541,3071,'el','ÎœÎ­ÏÎ¿Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ / Î ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(110542,3071,'zh','ä¸è§ç¼–å·/æè¿°\r\n',0),(110543,3071,'sv','Del nummer / Beskrivning',0),(110544,3071,'it','Numero di parte / Descrizione',0),(110545,3071,'tl','',0),(110546,3071,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586; Part/&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(110547,3071,'hi','à¤­à¤¾à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾ / à¤µà¤¿à¤µà¤°à¤£',0),(110548,3071,'ms','Bahagian bilangan / keterangan',0),(110549,3071,'ar','Ø§Ù„Ø¬Ø²Ø¡ Ø±Ù‚Ù…/Ø§Ù„ÙˆØµÙ',0),(110550,3071,'fr','Part Number / Description',0),(110551,3071,'jp','éƒ¨å“?ç•ªå?·/è§£èª¬',0),(110552,3071,'pt','PeÃ§a nÃºmero / descriÃ§Ã£o',0),(110553,3071,'ru','Ð§Ð°ÑÑ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ / ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(110554,3071,'es','Parte NÃºmero / DescripciÃ³n',0),(110555,3071,'de','Bestellnummer / Beschreibung',0),(110556,3071,'en','Part Number / Description',0),(110557,3072,'is','',0),(110558,3072,'dr','Ø¨Ù‡ ',0),(110559,3072,'pr','Ø¨Ù‡ ',0),(110560,3072,'tr','Hedef',0),(110561,3072,'pl','do',0),(110562,3072,'bg','Ð´Ð°',0),(110563,3072,'ur','Ú©Ø±Ù†Ø§',0),(110564,3072,'sr','Ð´Ð°',0),(110565,3072,'vi','tá»›i',0),(110566,3072,'af','tot',0),(110567,3072,'ro','pentru a',0),(110568,3072,'et','Kellele',0),(110569,3072,'si','za',0),(110570,3072,'ba','untuk',0),(110571,3072,'nl','Aan',0),(110572,3072,'fi','jotta',0),(110573,3072,'no','til',0),(110574,3072,'da','til',0),(110575,3072,'ko','ë°›ëŠ” ì‚¬ëžŒ',0),(110576,3072,'he','××œ',0),(110577,3072,'el','Î½Î±',0),(110578,3072,'zh','åˆ°\r\n',0),(110579,3072,'sv','till',0),(110580,3072,'it','A',0),(110581,3072,'tl','',0),(110582,3072,'th','&#3606;&#3638;&#3591;',0),(110583,3072,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(110584,3072,'ms','untuk',0),(110585,3072,'ar','Ø¥Ù„Ù‰',0),(110586,3072,'fr','Ã€',0),(110587,3072,'jp','ã?¸',0),(110588,3072,'pt','Para',0),(110589,3072,'ru','ÐšÐ¾Ð¼Ñƒ',0),(110590,3072,'es','A',0),(110591,3072,'de','An',0),(110592,3072,'en','to',0),(110593,3073,'is','',0),(110594,3073,'dr','Ø¨Ø±Ø§ÙŠ Ø´Ø±ÙˆØ¹ Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø³Ù†Ø¯ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¯Ø± Ø³ÙŠØ³ØªÙ… ÙƒØ§Ù…Ù¾ÙˆØªØ±ÙŠ Ø®ÙˆØ¯ ',0),(110595,3073,'pr','Ø¨Ø±Ø§ÙŠ Ø´Ø±ÙˆØ¹ Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø³Ù†Ø¯ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¯Ø± Ø³ÙŠØ³ØªÙ… ÙƒØ§Ù…Ù¾ÙˆØªØ±ÙŠ Ø®ÙˆØ¯ ',0),(110596,3073,'tr','SeÃ§ili belgenin yerel istasyonunuza karÅŸÄ±dan yÃ¼klemeye baÅŸlamak iÃ§in.',0),(110597,3073,'pl','Aby rozpoczÄ…Ä‡ pobieranie wybranego dokumentu do lokalnej stacji roboczej.',0),(110598,3073,'bg','Ð·Ð° Ð´Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð¸Ð·Ñ‚ÐµÐ³Ð»ÑÐ½ÐµÑ‚Ð¾ Ð½Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÐºÑŠÐ¼ Ð»Ð¾ÐºÐ°Ð»Ð½Ð¸Ñ Ð²Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾ Ð¼ÑÑÑ‚Ð¾.',0),(110599,3073,'ur','Ø¢Ù¾ Ú©Ø§ Ù…Ù‚Ø§Ù…ÛŒ Ú©Ø§Ù… Ø³Ù¹ÛŒØ´Ù† Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ùˆ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Ø±Ù†Û’ Ø´Ø±ÙˆØ¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Û”',0),(110600,3073,'sr','Ð¿Ð¾Ñ‡Ð¸ÑšÐµ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾Ð³ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð´Ð° ÑÐ²Ð¾Ñ˜Ðµ Ð»Ð¾ÐºÐ°Ð»Ð½Ðµ Ñ€Ð°Ð´Ð½Ðµ ÑÑ‚Ð°Ð½Ð¸Ñ†Ðµ.',0),(110601,3073,'vi','báº¯t Ä‘áº§u táº£i tÃ i liá»‡u lá»±a chá»n tá»›i mÃ¡y cá»§a báº¡n',0),(110602,3073,'af','begin die geselekteerde dokument aflaai om jou plaaslike werkstasie.',0),(110603,3073,'ro','pentru a Ã®ncepe descÄƒrcarea documentul selectat de dumneavoastrÄƒ workstation locale.',0),(110604,3073,'et','et alustada allalaadimist valitud dokumendi kohaliku tÃ¶Ã¶jaama.',0),(110605,3073,'si','zaÄeti downloading izbranega dokumenta na vaÅ¡o lokalno delovno postajo.',0),(110606,3073,'ba','untuk mulai men-download dokumen dipilih ke workstation lokal Anda.',0),(110607,3073,'nl','om te beginnen met het downloaden van het geselecteerde document op uw lokale werkstation.',0),(110608,3073,'fi','Voit aloittaa lataamisen valitun tiedoston paikallisen tyÃ¶asemasi.',0),(110609,3073,'no','Ã¥ laste ned dokumentet pÃ¥ lokale arbeidsstasjonen.',0),(110610,3073,'da','at begynde at downloade det valgte dokument til din lokale arbejdsstation.',0),(110611,3073,'ko','ë¡œì»¬ ì›Œí¬ìŠ¤í…Œì´ì…˜ì— ì„ íƒ ëœ ë¬¸ì„œë¥¼ ë‹¤ìš´ë¡œë“œ í•˜ë ¤ë©´.',0),(110612,3073,'he','×›×“×™ ×œ×”×ª×—×™×œ ×œ×”×•×¨×™×“ ××ª ×”×ž×¡×ž×š ×”× ×‘×—×¨ ×œ×ª×—× ×ª ×”×¢×‘×•×“×” ×”×ž×§×•×ž×™ ×©×œ×š.',0),(110613,3073,'el','Î½Î± Î¾ÎµÎºÎ¹Î½Î·ÏƒÎµÎ¹ Î· Î›Î—Î¨Î— Ï„Î¿Ï… ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï… ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï… ÏƒÎ±Ï‚ Ï„Î¿Ï€Î¹ÎºÎ¿Ï ÏƒÏ„Î±Î¸Î¼Î¿Ï ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚.',0),(110614,3073,'zh','å¼€å§‹ä¸‹è½½é€‰å®šçš„æ–‡ä»¶åˆ°æœ¬åœ°å·¥ä½œç«™ã€‚\r\n',0),(110615,3073,'sv','att bÃ¶rja ladda ner det markerade dokumentet till din lokala arbetsstation.',0),(110616,3073,'it','per iniziare il download del documento selezionato per la workstation locale.',0),(110617,3073,'tl','',0),(110618,3073,'th','to begin downloading the selected document to your local workstation.',0),(110619,3073,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤•à¥‹ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤ªà¤¨à¥‡ à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤¶à¥à¤°à¥‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤à¥¤',0),(110620,3073,'ms','untuk mula memuat turun dokumen yang telah dipilih ke komputer tempatan anda.',0),(110621,3073,'ar','Ù„Ø¨Ø¯Ø¡ ØªÙ†Ø²ÙŠÙ„ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø§Ù„Ù…Ø­Ø¯Ø¯ Ø¥Ù„Ù‰ Ù…Ø­Ø·Ø© Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ù…Ø­Ù„ÙŠØ© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(110622,3073,'fr','pour commencer Ã  tÃ©lÃ©charger le document sÃ©lectionnÃ© Ã  votre station de travail locale.',0),(110623,3073,'jp','ãƒ­ãƒ¼ã‚«ãƒ«ãƒ¯ãƒ¼ã‚¯ã‚¹ãƒ†ãƒ¼ã‚·ãƒ§ãƒ³ã?«é?¸æŠžã?•ã‚Œã?Ÿæ–‡æ›¸ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã?—å§‹ã‚?ã‚‹',0),(110624,3073,'pt','para comeÃ§ar a baixar o documento selecionado para sua estaÃ§Ã£o de trabalho local.',0),(110625,3073,'ru','Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð½Ð°Ñ‡Ð°Ñ‚ÑŒ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÑƒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ðº Ð»Ð¾ÐºÐ°Ð»ÑŒÐ½Ð¾Ð¹ Ñ€Ð°Ð±Ð¾Ñ‡ÐµÐ¹ ÑÑ‚Ð°Ð½Ñ†Ð¸Ð¸.',0),(110626,3073,'es','para empezar descargar el documento seleccionado a su estaciÃ³n de trabajo local',0),(110627,3073,'de','zu Beginn das ausgewÃ¤hlte Dokument auf der lokalen Arbeitsstation herunterzuladen.',0),(110628,3073,'en','to begin downloading the selected document to your local workstation.',0),(110629,3074,'is','',0),(110630,3074,'dr','Ø¬Ù‡Øª ØªØµÙÙŠÙ‡ Ø­Ø³Ø§Ø¨ Ú©Ø±Ø¯Ù† Ø³Ù†Ø¯ Ù…Ù†ØªØ®Ø¨ Ùˆ Ø´Ø±ÙˆØ¹ Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø¢Ù† Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ÙƒØ§Ù…Ù¾ÙŠÙˆØªØ±ÙŠ Ø®ÙˆØ¯',0),(110631,3074,'pr','Ø¬Ù‡Øª ØªØµÙÙŠÙ‡ Ø­Ø³Ø§Ø¨ Ú©Ø±Ø¯Ù† Ø³Ù†Ø¯ Ù…Ù†ØªØ®Ø¨ Ùˆ Ø´Ø±ÙˆØ¹ Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø¢Ù† Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ÙƒØ§Ù…Ù¾ÙŠÙˆØªØ±ÙŠ Ø®ÙˆØ¯',0),(110632,3074,'tr','SeÃ§ili belgeyi kullanÄ±ma alma ve yerel istasyonunuza karÅŸÄ±dan yÃ¼klemeye baÅŸlamak iÃ§in.',0),(110633,3074,'pl','Aby sprawdziÄ‡ wybrany dokument i rozpoczÄ…Ä‡ pobieranie go do lokalnej stacji roboczej.',0),(110634,3074,'bg','Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¸ Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð´Ð° Ð³Ð¾ Ð¸Ð·Ñ‚ÐµÐ³Ð»Ð¸Ñ‚Ðµ Ð½Ð° Ð»Ð¾ÐºÐ°Ð»Ð½Ð¸Ñ Ð²Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾ Ð¼ÑÑÑ‚Ð¾.',0),(110635,3074,'ur','Ù…Ù†ØªØ®Ø¨ Ø¯Ø³ØªØ§ÙˆÛŒØ² Ø®Ø§Ø¯Ø¬ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø§Ø³ Ú©Û’ Ù„ÛŒÛ’ Ø§Ù¾Ù†Û’ Ù…Ù‚Ø§Ù…ÛŒ Ú©Ø§Ù… Ø³Ù¹ÛŒØ´Ù† ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Ø±Ù†Û’ Ø´Ø±ÙˆØ¹ Ú©Ø±Ù†Ø§ Û”',0),(110636,3074,'sr','Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¸ Ð¿Ð¾Ñ‡ÐµÑ‚Ð¸ Ð´Ð° Ð³Ð° Ð¿Ñ€ÐµÑƒÐ·Ð¼ÐµÑ‚Ðµ Ð½Ð° ÑÐ²Ð¾Ñ˜Ðµ Ð»Ð¾ÐºÐ°Ð»Ð½Ðµ Ñ€Ð°Ð´Ð½Ðµ ÑÑ‚Ð°Ð½Ð¸Ñ†Ðµ.',0),(110637,3074,'vi','Ä‘á»ƒ Ä‘Æ°a tÃ i liá»‡u Ä‘Ã£ chá»n ra & báº¯t Ä‘áº§u táº£i vá» mÃ¡y cá»§a báº¡n',0),(110638,3074,'af','check die geselekteerde dokument en begin dit aflaai om jou plaaslike werkstasie.',0),(110639,3074,'ro','pentru a verifica documentul selectat ÅŸi Ã®ncepe descÄƒrcarea acesteia de la dumneavoastrÄƒ de lucru locale.',0),(110640,3074,'et','valitud dokumendi vÃ¤ljamÃ¶llimiseks ja alustada allalaadimist teie kohaliku tÃ¶Ã¶jaama.',0),(110641,3074,'si','Oglejte si izbranega dokumenta in zaÄeti downloading vaÅ¡ lokalni postaji.',0),(110642,3074,'ba','untuk memeriksa dokumen dipilih dan mulai men-download ke komputer lokal Anda.',0),(110643,3074,'nl','het geselecteerde document uitchecken en beginnen met het downloaden het op uw lokale werkstation.',0),(110644,3074,'fi','tarkistaa valitun asiakirjan ja aloittaa lataamisen paikallisen tyÃ¶asemasi.',0),(110645,3074,'no','Sjekk ut det valgte dokumentet og begynne Ã¥ laste den ned til din lokale arbeidsstasjon.',0),(110646,3074,'da','Tjek det valgte dokument og begynde at downloade den til din lokale arbejdsstation.',0),(110647,3074,'ko','ì„ íƒí•œ ë¬¸ì„œë¥¼ í™•ì¸ í•˜ ê³  ë¡œì»¬ ì›Œí¬ìŠ¤í…Œì´ì…˜ì— ë‹¤ìš´ë¡œë“œ ë˜ê¸° ì‹œìž‘ í•©ë‹ˆë‹¤.',0),(110648,3074,'he','×‘×“×•×§ ××ª ×”×ž×¡×ž×š ×”× ×‘×—×¨ ×•×œ×”×ª×—×™×œ ×œ×”×•×¨×™×“ ××•×ª×• ×œ×ª×—× ×ª ×”×¢×‘×•×“×” ×”×ž×§×•×ž×™ ×©×œ×š.',0),(110649,3074,'el','Î½Î± ÎµÎ»Î­Î³Î¾ÎµÏ„Îµ Î­Î¾Ï‰ Ï„Î¿Ï… ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï… ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï… ÎºÎ±Î¹ Î½Î± Î±ÏÏ‡Î¯ÏƒÎµÎ¹ Î½Î± ÎºÎ±Ï„ÎµÎ²Î±ÏƒÏ„ÎµÎ¯ Î½Î± ÏƒÎ±Ï‚ Ï„Î¿Ï€Î¹ÎºÎ¿Ï ÏƒÏ„Î±Î¸Î¼Î¿Ï ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚.',0),(110650,3074,'zh','ç™»å‡ºæ‰€é€‰çš„æ–‡æ¡£å¹¶å¼€å§‹ä¸‹è½½åˆ°æœ¬åœ°å·¥ä½œç«™ã€‚\r\n',0),(110651,3074,'sv','Kolla in det valda dokumentet och bÃ¶rja ladda ner den till din lokala arbetsstation.',0),(110652,3074,'it','di controllare il documento selezionato e iniziare a scaricarlo su workstation locale.',0),(110653,3074,'tl','',0),(110654,3074,'th','to check out the selected document and begin downloading it to your local workstation.',0),(110655,3074,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤‡à¤¸à¥‡ à¤…à¤ªà¤¨à¥‡ à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤•à¥‹ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¤¨à¤¾ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤•à¤°à¤¨à¥‡ à',0),(110656,3074,'ms','menyemak dokumen yang telah dipilih dan mula memuat turunnya ke komputer tempatan anda.',0),(110657,3074,'ar','Ù„Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø§Ù„Ù…Ø­Ø¯Ø¯ ÙˆØ§Ù„Ø¨Ø¯Ø¡ Ø¨ØªØ­Ù…ÙŠÙ„Ù‡ Ø¹Ù„Ù‰ Ù…Ø­Ø·Ø© Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ù…Ø­Ù„ÙŠØ© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(110658,3074,'fr','Ã  consulter le document sÃ©lectionnÃ© et commencer Ã  tÃ©lÃ©charger sur votre poste de travail local.',0),(110659,3074,'jp','é?¸æŠžã?•ã‚Œã?Ÿæ–‡æ›¸ã‚’ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?—ã€?ãƒ­ãƒ¼ã‚«ãƒ«ãƒ¯ãƒ¼ã‚¯ã‚¹ãƒ†ãƒ¼ã‚·ãƒ§ãƒ³ã?«ã??ã‚Œã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã?—å§‹ã‚?ã‚‹',0),(110660,3074,'pt','Confira o documento selecionado e comeÃ§ar o download para sua estaÃ§Ã£o de trabalho local.',0),(110661,3074,'ru','Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð¸ Ð½Ð°Ñ‡Ð°Ð»Ð° ÐµÐ³Ð¾ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð² Ð²Ð°ÑˆÑƒ Ð»Ð¾ÐºÐ°Ð»ÑŒÐ½ÑƒÑŽ Ñ€Ð°Ð±Ð¾Ñ‡ÑƒÑŽ ÑÑ‚Ð°Ð½Ñ†Ð¸ÑŽ.',0),(110662,3074,'es','Para investigar el documento seleccionado y empezar descargarlo a su estaciÃ³n de Trabajo.',0),(110663,3074,'de','das ausgewÃ¤hlte Dokument auschecken und per Download auf der lokalen Arbeitsstation zu beginnen.',0),(110664,3074,'en','to check out the selected document and begin downloading it to your local workstation.',0),(110665,3075,'is','',0),(110666,3075,'dr','Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø§Ø¯Ù†',0),(110667,3075,'pr','Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø§Ø¯Ù†',0),(110668,3075,'tr','devam etmek iÃ§in',0),(110669,3075,'pl','Aby kontynuowaÄ‡',0),(110670,3075,'bg','Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸Ñ‚Ðµ',0),(110671,3075,'ur','Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(110672,3075,'sr','Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸',0),(110673,3075,'vi','tiáº¿p tá»¥c',0),(110674,3075,'af','vervolg',0),(110675,3075,'ro','pentru a continua',0),(110676,3075,'et','jÃ¤tkamiseks',0),(110677,3075,'si','za nadaljevanje',0),(110678,3075,'ba','untuk melanjutkan',0),(110679,3075,'nl','om door te gaan',0),(110680,3075,'fi','Jatka',0),(110681,3075,'no','Ã¥ fortsette',0),(110682,3075,'da','at fortsÃ¦tte',0),(110683,3075,'ko','ê³„ì† í•˜ë ¤ë©´',0),(110684,3075,'he','×›×“×™ ×œ×”×ž×©×™×š',0),(110685,3075,'el','Î½Î± ÏƒÏ…Î½ÎµÏ‡Î¯ÏƒÎµÎ¹',0),(110686,3075,'zh','ç»§ç»­\r\n',0),(110687,3075,'sv','att fortsÃ¤tta',0),(110688,3075,'it','per continuare',0),(110689,3075,'tl','',0),(110690,3075,'th','&#3652;&#3611;&#3605;&#3656;&#3629;',0),(110691,3075,'hi','à¤œà¤¾à¤°à¥€ à¤°à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(110692,3075,'ms','untuk meneruskan',0),(110693,3075,'ar','Ù„Ù„Ø¥Ø³ØªÙ…Ø±Ø§Ø±',0),(110694,3075,'fr','pour continuer',0),(110695,3075,'jp','ç¶šã?‘ã‚‹',0),(110696,3075,'pt','para continuar',0),(110697,3075,'ru','Ðº Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸ÑŽ',0),(110698,3075,'es','para continuar',0),(110699,3075,'de','weiterhin',0),(110700,3075,'en','to continue',0),(110701,3076,'is','',0),(110702,3076,'dr','ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(110703,3076,'pr','ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(110704,3076,'tr','BugÃ¼ne kadar',0),(110705,3076,'pl','Do tej pory',0),(110706,3076,'bg','ÐšÑŠÐ¼ Ð´Ð½ÐµÑˆÐ½Ð° Ð´Ð°Ñ‚Ð°',0),(110707,3076,'ur','ØªØ§Ø±ÛŒØ® Ú©Ø§',0),(110708,3076,'sr','Ð”Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(110709,3076,'vi','Tá»›i ngÃ y',0),(110710,3076,'af','Tot Datum',0),(110711,3076,'ro','La data de',0),(110712,3076,'et','Praeguseks',0),(110713,3076,'si','Do danes',0),(110714,3076,'ba','Sampai saat ini',0),(110715,3076,'nl','Tot op heden',0),(110716,3076,'fi','TÃ¤hÃ¤n mennessÃ¤',0),(110717,3076,'no','Hittil',0),(110718,3076,'da','Til dato',0),(110719,3076,'ko','ë‚ ì§œ',0),(110720,3076,'he','×¢×“ ×›×”',0),(110721,3076,'el','ÎœÎ­Ï‡ÏÎ¹ ÏƒÎ®Î¼ÎµÏÎ±',0),(110722,3076,'zh','æ—¥æœŸ\r\n',0),(110723,3076,'sv','Hittills',0),(110724,3076,'it','Fino ad oggi',0),(110725,3076,'tl','',0),(110726,3076,'th','&#3606;&#3638;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(110727,3076,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(110728,3076,'ms','Setakat ini',0),(110729,3076,'ar','Ø¥Ù„Ù‰ ',0),(110730,3076,'fr','Ã€ ce jour',0),(110731,3076,'jp','ï½žã?®æ—¥ä»˜',0),(110732,3076,'pt','AtÃ© Ã  data',0),(110733,3076,'ru','Ð”Ð¾ Ð”Ð°Ñ‚Ñ‹',0),(110734,3076,'es','A la Fecha',0),(110735,3076,'de','Bis heute',0),(110736,3076,'en','To Date',0),(110737,3077,'is','',0),(110738,3077,'dr','=   ØµÙØ± 0 Ø±Ø§ ØªÙ†Ø¸ÙŠÙ… ÙƒÙ†ÙŠØ¯ ',0),(110739,3077,'pr','Ø¬Ù‡Øª Ø­Ø°Ù Ù…Ù‚Ø¯Ø§Ø± =   ØµÙØ± 0 Ø±Ø§ ØªÙ†Ø¸ÙŠÙ… ÙƒÙ†ÙŠØ¯ ',0),(110740,3077,'tr','set miktar silmek iÃ§in 0 =',0),(110741,3077,'pl','Aby usunÄ…Ä‡ zestaw iloÅ›Ä‡ = 0',0),(110742,3077,'bg','Ð·Ð° Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ ÐºÐ¾Ð» = 0',0),(110743,3077,'ur','Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ù‚ÛŒ Ø­Ø°Ù Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ = 0',0),(110744,3077,'sr','Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð»Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸ ÐšÐ¾Ð» = 0',0),(110745,3077,'vi','Ä‘á»ƒ xÃ³a sá»‘ lÆ°á»£ng=0',0),(110746,3077,'af','om stel hoev. te skrap=0',0),(110747,3077,'ro','pentru a ÅŸterge setarea cantit = 0',0),(110748,3077,'et','kustutamiseks mÃ¤Ã¤ratud kogus = 0',0),(110749,3077,'si','brisanje nastavitev koliÄina = 0',0),(110750,3077,'ba','untuk menghapus set qty = 0',0),(110751,3077,'nl','instellen aantal verwijderen = 0',0),(110752,3077,'fi','Poista MÃ¤Ã¤ritÃ¤ mÃ¤Ã¤rÃ¤ = 0',0),(110753,3077,'no','slette angi antall = 0',0),(110754,3077,'da','slette sÃ¦t qty = 0',0),(110755,3077,'ko','ì„¸íŠ¸ qtyë¥¼ ì‚­ì œ í•˜ë ¤ë©´ = 0',0),(110756,3077,'he','×›×“×™ ×œ×ž×—×•×§ ×”×’×“×¨×ª ×›×ž×•×ª = 0',0),(110757,3077,'el','Î³Î¹Î± Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ ÏƒÏÎ½Î¿Î»Î¿ qty = 0',0),(110758,3077,'zh','åˆ é™¤è®¾ç½®æ•°é‡=0\r\n',0),(110759,3077,'sv','ta bort ange antal = 0',0),(110760,3077,'it','per eliminare il set qty = 0',0),(110761,3077,'tl','',0),(110762,3077,'th','&#3621;&#3610; &#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3652;&#3623;&#3657;&#3648;&#3607;&#3656;&#3634;&#3585;&#3633;&#3610; 0',0),(110763,3077,'hi','à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤¿à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‹ à¤¨à¤·à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ = 0',0),(110764,3077,'ms','untuk menghapuskan set qty = 0',0),(110765,3077,'ar','Ù„Ø­Ø°Ù Ù…Ø¬Ù…ÙˆØ¹Ø© qty = 0',0),(110766,3077,'fr','pour supprimer la quantitÃ© rÃ©glÃ©e = 0',0),(110767,3077,'jp','è¨­å®šæ•°é‡?ï¼?ï¼?ã‚’æ¶ˆåŽ»ã?™ã‚‹',0),(110768,3077,'pt','para excluir o conjunto Qtde = 0',0),(110769,3077,'ru','Ð´Ð»Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ ÐºÐ¾Ð»-Ð²Ð¾=0',0),(110770,3077,'es','para eliminar, cofigurar cant.=0',0),(110771,3077,'de','Set Qty lÃ¶schen = 0',0),(110772,3077,'en','to delete set qty=0',0),(110773,3078,'is','',0),(110774,3078,'dr','Ø¨Ø±Ø§ÙŠ Ø´ØºÙ„',0),(110775,3078,'pr','Ø¨Ø±Ø§ÙŠ Ø´ØºÙ„',0),(110776,3078,'tr','iÅŸ ile',0),(110777,3078,'pl','do pracy',0),(110778,3078,'bg','Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(110779,3078,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Ø±Ù†Ø§',0),(110780,3078,'sr','Ð½Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(110781,3078,'vi','tá»›i Job',0),(110782,3078,'af','na kontruksiewerk',0),(110783,3078,'ro','la locuri de muncÄƒ',0),(110784,3078,'et','et tÃ¶Ã¶',0),(110785,3078,'si','za delo',0),(110786,3078,'ba','untuk pekerjaan',0),(110787,3078,'nl','naar baan',0),(110788,3078,'fi','Jobille',0),(110789,3078,'no','jobb',0),(110790,3078,'da','til job',0),(110791,3078,'ko','ì§ì—…ì„',0),(110792,3078,'he','×›×“×™ ×¢×‘×•×“×”',0),(110793,3078,'el','Î³Î¹Î± Ï„Î· Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(110794,3078,'zh','å·¥ä½œ\r\n',0),(110795,3078,'sv','till jobb',0),(110796,3078,'it','fare,',0),(110797,3078,'tl','',0),(110798,3078,'th','&#3606;&#3638;&#3591;&#3591;&#3634;&#3609;',0),(110799,3078,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(110800,3078,'ms','untuk kerja',0),(110801,3078,'ar','Ù„Ù„ÙˆØ¸ÙŠÙØ©',0),(110802,3078,'fr','Ã  l\'emploi',0),(110803,3078,'jp','ä½œæ¥­ã?«',0),(110804,3078,'pt','para trabalho',0),(110805,3078,'ru','Ð² Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(110806,3078,'es','al trabajo',0),(110807,3078,'de','an den Auftrag',0),(110808,3078,'en','to job',0),(110809,3079,'is','',0),(110810,3079,'dr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø­Ø³Ø§Ø¨ Ø¨ÙˆØ¯Ø¬Ù‡ Ù…Ø´Ø§Ø¨Ù‡ Ø¯ÙØªØ± ÙƒÙ„ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø´Ù…Ø§ Ù…Ø´ØºÙˆÙ„ ÙƒØ§Ø± ÙƒØ±Ø¯Ù† Ø±ÙˆÙŠ ØªØºÙŠÙŠØ±Ø§Øª Ø¨ÙˆØ¯ÙŠØ¯ ',0),(110811,3079,'pr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø­Ø³Ø§Ø¨ Ø¨ÙˆØ¯Ø¬Ù‡ Ù…Ø´Ø§Ø¨Ù‡ Ø¯ÙØªØ± ÙƒÙ„ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø´Ù…Ø§ Ù…Ø´ØºÙˆÙ„ ÙƒØ§Ø± ÙƒØ±Ø¯Ù† Ø±ÙˆÙŠ ØªØºÙŠÙŠØ±Ø§Øª Ø¨ÙˆØ¯ÙŠØ¯ ',0),(110812,3079,'tr','Bu aynÄ± GL bÃ¼tÃ§e deÄŸiÅŸiklikleri Ã¼zerinde Ã§alÄ±ÅŸtÄ±ÄŸÄ±nÄ±z sÄ±rada hesabÄ±na',0),(110813,3079,'pl','na to samo konto budÅ¼etu GL podczas pracy na zmiany',0),(110814,3079,'bg','Ñ‚Ð¾Ð·Ð¸ ÑÑŠÑ‰Ð¸Ñ GL Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð°ÐºÐ°ÑƒÐ½Ñ‚, Ð´Ð¾ÐºÐ°Ñ‚Ð¾ ÑÑ‚Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ð»Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ',0),(110815,3079,'ur','ÛŒÛ ÙˆÛÛŒ Ø¬ÛŒØ¬Û’ Ø¨Ø¬Ù¹ Ø¢Ù¾ Ø§Ù¾Ù†ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ù¾Ø± Ú©Ø§Ù… Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³Û’',0),(110816,3079,'sr','ÐžÐ²Ð°Ñ˜ Ð¸ÑÑ‚Ð¸ Ð“Ð› Ð±ÑƒÑŸÐµÑ‚Ð° Ñ€Ð°Ñ‡ÑƒÐ½ Ð´Ð¾Ðº ÑÑ‚Ðµ Ñ€Ð°Ð´Ð¸Ð»Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(110817,3079,'vi','tá»›i TK ngÃ¢n sÃ¡ch sá»• cÃ¡i nÃ y trong khi báº¡n tiáº¿p tá»¥c thay Ä‘á»•i',0),(110818,3079,'af','om hierdie dieselfde GL begrotingsrekening terwyl jy op jou veranderinge was werk',0),(110819,3079,'ro','Ã®n acest fel GL buget contul Ã®n timp ce au fost de lucru pe modificÄƒrile',0),(110820,3079,'et','sama GL eelarve kontole kui sa tÃ¶Ã¶tasid oma muudatused',0),(110821,3079,'si','Ta isti raÄun GL proraÄun, medtem, ko ste delali na spremembe',0),(110822,3079,'ba','ini sama GL anggaran akun sementara Anda sedang bekerja pada perubahan Anda',0),(110823,3079,'nl','naar deze dezelfde GL begroting rekening terwijl u uw wijzigingen hebt gewerkt',0),(110824,3079,'fi','TÃ¤mÃ¤ sama GL budjettitilille tekemiesi muutosten kÃ¤yttÃ¤essÃ¤si',0),(110825,3079,'no','denne samme GL budsjett kontoen mens du arbeidet pÃ¥ endringene',0),(110826,3079,'da','denne samme GL Budget konto, mens du arbejder pÃ¥ dine Ã¦ndringer',0),(110827,3079,'ko','ì´ ê°™ì€ GL ì˜ˆì‚° ê³„ì • ë³€ê²½ ë‚´ìš©ì„ì— í•˜ëŠ” ë™ì•ˆì—',0),(110828,3079,'he','×œ×—×©×‘×•×Ÿ ×–×” ×–×”×” GL ×”×ª×§×¦×™×‘ ×‘×–×ž×Ÿ ×©×¢×‘×“×ª ×¢×œ ×”×©×™× ×•×™×™× ×©×œ×š',0),(110829,3079,'el','ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¯Î´Î¹Î¿ GL Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎµÎ½ÏŽ ÎµÏÎ³Î±Î¶ÏŒÏƒÎ±ÏƒÏ„Î±Î½ Î±Î»Î»Î±Î³Î­Ï‚ ÏƒÎ±Ï‚',0),(110830,3079,'zh','å½“æ‚¨æ­£åœ¨å¤„ç†æ‚¨çš„å˜æ›´æ­¤ç›¸åŒçš„æ€»å¸é¢„ç®—å¸æˆ·ï¼Œ',0),(110831,3079,'sv','till denna samma GL budgetkonto medan du arbetade pÃ¥ dina Ã¤ndringar',0),(110832,3079,'it','a questo stesso conto bilancio GL mentre lavoravi sulle modifiche',0),(110833,3079,'tl','',0),(110834,3079,'th','to this same GL Budget Account while you were working on your changes',0),(110835,3079,'hi','à¤‡à¤¸ à¤à¤• à¤¹à¥€ GL à¤¬à¤œà¤Ÿ à¤†à¤ª à¤…à¤ªà¤¨à¥‡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤ªà¤° à¤•à¤¾à¤® à¤•à¤° à¤°à¤¹à¥‡ à¤¥à¥‡, à¤œà¤¬à¤•à¤¿ à¤–à¤¾à¤¤à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(110836,3079,'ms','ke sama GL bajet akaun ini semasa anda sedang usahakan perubahan anda',0),(110837,3079,'ar','Ù„Ù‡Ø°Ø§ GL Ù†ÙØ³ \"Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©\" Ø¨ÙŠÙ†Ù…Ø§ ÙƒÙ†Øª ØªØ¹Ù…Ù„ Ø¹Ù„Ù‰ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(110838,3079,'fr','Ã  ce compte de Budget GL mÃªme tandis que vous travaillez sur vos modifications',0),(110839,3079,'jp','to this same GL Budget Account while you were working on your changes',0),(110840,3079,'pt','para esta mesma GL orÃ§amento conta enquanto vocÃª estava trabalhando em suas alteraÃ§Ãµes',0),(110841,3079,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¶Ðµ ÑÑ‡ÐµÑ‚ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° GL, Ð² Ñ‚Ð¾ Ð²Ñ€ÐµÐ¼Ñ ÐºÐ°Ðº Ð²Ñ‹ Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð»Ð¸ Ð½Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(110842,3079,'es','al mismo cuenta presupuestal de LM mientras que se trabajÃ³ en sus cambios',0),(110843,3079,'de','zu dieser gleichen GL Budgetkonto wÃ¤hrend Sie Ihre Ã„nderungen gearbeitet haben',0),(110844,3079,'en','to this same GL Budget Account while you were working on your changes',0),(110845,3080,'is','',0),(110846,3080,'dr','Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø§Ø±Ø³Ø§Ù„',0),(110847,3080,'pr','Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø§Ø±Ø³Ø§Ù„',0),(110848,3080,'tr','Unpost iÃ§in',0),(110849,3080,'pl','do Unpost',0),(110850,3080,'bg','ÐºÑŠÐ¼ Unpost',0),(110851,3080,'ur','Ø§Ù†Ù¾ÙˆØ³Ù¹ Ú©Ø±Ù†Ø§',0),(110852,3080,'sr','Ð´Ð° Ð£Ð½Ð¿Ð¾ÑÑ‚',0),(110853,3080,'vi','tá»›i ChÆ°a gá»­i',0),(110854,3080,'af','na Ongepos',0),(110855,3080,'ro','la Unpost',0),(110856,3080,'et','kuni Unpost',0),(110857,3080,'si','za Unpost',0),(110858,3080,'ba','untuk Unpost',0),(110859,3080,'nl','naar Unpost',0),(110860,3080,'fi','jotta Unpost',0),(110861,3080,'no','til Unpost',0),(110862,3080,'da','til Unpost',0),(110863,3080,'ko','Unpostë¥¼',0),(110864,3080,'he','×œ Unpost',0),(110865,3080,'el','Î½Î± Unpost',0),(110866,3080,'zh','å‘å¸ƒ\r\n',0),(110867,3080,'sv','till Unpost',0),(110868,3080,'it','a Unpost',0),(110869,3080,'tl','',0),(110870,3080,'th','&#3648;&#3614;&#3639;&#3656;&#3629;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(110871,3080,'hi','Unpost à¤•à¤°à¤¨à¤¾',0),(110872,3080,'ms','untuk Unpost',0),(110873,3080,'ar','Ø¥Ù„Ù‰ Ø£ÙˆÙ†Ø¨ÙˆØ³Øª',0),(110874,3080,'fr','Ã  Unpost',0),(110875,3080,'jp','è¨ˆä¸Šã‚’å?–ã‚Šæ¶ˆã?™',0),(110876,3080,'pt','para Unpost',0),(110877,3080,'ru','Ð´Ð»Ñ Unpost',0),(110878,3080,'es','para Desasentar',0),(110879,3080,'de','zu Unpost',0),(110880,3080,'en','to Unpost',0),(110881,3081,'is','',0),(110882,3081,'dr','Ù†Ø§Ù… Ø§Ø¨Ø²Ø§Ø± ',0),(110883,3081,'pr','Ù†Ø§Ù… Ø§Ø¨Ø²Ø§Ø± ',0),(110884,3081,'tr','AraÃ§ adÄ±',0),(110885,3081,'pl','Nazwa narzÄ™dzia',0),(110886,3081,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(110887,3081,'ur','Ø¢Ù„Û Ù†Ø§Ù…',0),(110888,3081,'sr','Ð˜Ð¼Ðµ Ð°Ð»Ð°Ñ‚ÐºÐµ',0),(110889,3081,'vi','TÃªn CÃ´ng cá»¥',0),(110890,3081,'af','Gereedskapnaam',0),(110891,3081,'ro','Nume instrument',0),(110892,3081,'et','TÃ¶Ã¶riista nimi',0),(110893,3081,'si','Ime orodja',0),(110894,3081,'ba','Nama alat',0),(110895,3081,'nl','Naam van gereedschap',0),(110896,3081,'fi','TyÃ¶kalun nimi',0),(110897,3081,'no','VerktÃ¸ynavn',0),(110898,3081,'da','VÃ¦rktÃ¸jsnavn',0),(110899,3081,'ko','ë„êµ¬ ì´ë¦„',0),(110900,3081,'he','×©× ×”×›×œ×™',0),(110901,3081,'el','Î•ÏÎ³Î±Î»ÎµÎ¯Î¿ ÏŒÎ½Î¿Î¼Î±',0),(110902,3081,'zh','å·¥å…·åç§°\r\n',0),(110903,3081,'sv','Verktygsnamn',0),(110904,3081,'it','Nome strumento',0),(110905,3081,'tl','',0),(110906,3081,'th','&#3594;&#3639;&#3656;&#3629;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;',0),(110907,3081,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤•à¤¾ à¤¨à¤¾à¤®',0),(110908,3081,'ms','Nama alatan',0),(110909,3081,'ar','Ø§Ø³Ù… Ø§Ù„Ø£Ø¯Ø§Ø©',0),(110910,3081,'fr','Nom de l\'outil',0),(110911,3081,'jp','ãƒ„ãƒ¼ãƒ«å??',0),(110912,3081,'pt','Nome da ferramenta',0),(110913,3081,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(110914,3081,'es','Nombre de Herramienta',0),(110915,3081,'de','Name des Tools',0),(110916,3081,'en','Tool Name',0),(110917,3082,'is','',0),(110918,3082,'dr','(ØªØ¬Ù‡ÙŠØ²Ø§Øª ) Ø§Ø¨Ø²Ø§Ø± ',0),(110919,3082,'pr','Ù…Ø­Ù„ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡ (ØªØ¬Ù‡ÙŠØ²Ø§Øª ) Ø§Ø¨Ø²Ø§Ø± ',0),(110920,3082,'tr','AracÄ± fabrikasÄ± konumu',0),(110921,3082,'pl','NarzÄ™dzie poÅ‚oÅ¼enie zakÅ‚adu',0),(110922,3082,'bg','ÐœÑÑÑ‚Ð¾ Ð½Ð° Ð·Ð°Ð²Ð¾Ð´Ð° Ð½Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚',0),(110923,3082,'ur','Ù¹ÙˆÙ„ Ù¾Ù„Ø§Ù†Ù¹ Ú©Ø§ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(110924,3082,'sr','ÐÐ»Ð°Ñ‚ÐºÐ° Ð·Ð° Ð±Ð¸Ñ™ÐºÑƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(110925,3082,'vi','Vá»‹ trÃ­ nhÃ  mÃ¡y cÃ´ng cá»¥',0),(110926,3082,'af','Instrument Plant ligging',0),(110927,3082,'ro','LocaÅ£ie de plante instrument',0),(110928,3082,'et','TÃ¶Ã¶riista tehase asukoht',0),(110929,3082,'si','Kraj orodje proizvodnega obrata',0),(110930,3082,'ba','Alat pabrik lokasi',0),(110931,3082,'nl','Hulpprogramma Plant locatie',0),(110932,3082,'fi','TyÃ¶kalu tuotantolaitoksen sijainti',0),(110933,3082,'no','VerktÃ¸yet anlegget beliggenheten',0),(110934,3082,'da','VÃ¦rktÃ¸j produktionsanlÃ¦ggets beliggenhed',0),(110935,3082,'ko','ë„êµ¬ ê³µìž¥ ìœ„ì¹˜',0),(110936,3082,'he','×”×›×œ×™ ×ž×™×§×•× ×”×ž×¤×¢×œ',0),(110937,3082,'el','Î•ÏÎ³Î±Î»ÎµÎ¯Î¿ ÎµÏÎ³Î¿ÏƒÏ„Î¬ÏƒÎ¹Î¿ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(110938,3082,'zh','å·¥å…·åŽ‚çš„ä½ç½®\r\n',0),(110939,3082,'sv','Verktyget tillverkningsanlÃ¤ggningens belÃ¤genhet',0),(110940,3082,'it','Ubicazione dello stabilimento strumento',0),(110941,3082,'tl','',0),(110942,3082,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;&#3586;&#3629;&#3591;&#3650;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(110943,3082,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤¸à¤‚à¤¯à¤‚à¤¤à¥à¤° à¤¸à¥à¤¥à¤¾à¤¨',0),(110944,3082,'ms','Lokasi loji alat',0),(110945,3082,'ar','Ù…ÙˆÙ‚Ø¹ Ù…ØµÙ†Ø¹ Ø£Ø¯Ø§Ø©',0),(110946,3082,'fr','Emplacement de l\'usine outil',0),(110947,3082,'jp','ãƒ„ãƒ¼ãƒ«å·¥å ´æ‰€åœ¨åœ°',0),(110948,3082,'pt','Ferramenta planta localizaÃ§Ã£o',0),(110949,3082,'ru','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð·Ð°Ð²Ð¾Ð´Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(110950,3082,'es','UbicaciÃ³n de FÃ¡brica de Herramientas',0),(110951,3082,'de','Werkzeug-BetriebsstÃ¤tte',0),(110952,3082,'en','Tool Plant Location',0),(110953,3083,'is','',0),(110954,3083,'dr','Ù†ÙˆØ¹ Ø§Ø¨Ø²Ø§Ø± ',0),(110955,3083,'pr','Ù†ÙˆØ¹ Ø§Ø¨Ø²Ø§Ø± ',0),(110956,3083,'tr','AraÃ§ tÃ¼rÃ¼',0),(110957,3083,'pl','NarzÄ™dzia typu',0),(110958,3083,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ñ‚Ð¸Ð¿',0),(110959,3083,'ur','Ø¢Ù„Û Ú©ÛŒ Ù‚Ø³Ù…',0),(110960,3083,'sr','ÐÐ»Ð°Ñ‚ÐºÐ° Ð·Ð° Ñ‚Ð¸Ð¿',0),(110961,3083,'vi','Loáº¡i cÃ´ng cá»¥',0),(110962,3083,'af','Gereedskap tipe',0),(110963,3083,'ro','Tip unealtÄƒ',0),(110964,3083,'et','TÃ¶Ã¶riista tÃ¼Ã¼p',0),(110965,3083,'si','Vrsto orodja',0),(110966,3083,'ba','Jenis alat',0),(110967,3083,'nl','Type tool',0),(110968,3083,'fi','TyÃ¶kalun tyyppi',0),(110969,3083,'no','VerktÃ¸y type',0),(110970,3083,'da','VÃ¦rktÃ¸j type',0),(110971,3083,'ko','ë„êµ¬ ì¢…ë¥˜',0),(110972,3083,'he','×¡×•×’ ×›×œ×™',0),(110973,3083,'el','Î•ÏÎ³Î±Î»ÎµÎ¯Î¿ Ï„ÏÏ€Î¿Ï…',0),(110974,3083,'zh','å·¥å…·ç±»åž‹\r\n',0),(110975,3083,'sv','Verktyg typ',0),(110976,3083,'it','Tipo di strumento',0),(110977,3083,'tl','',0),(110978,3083,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;',0),(110979,3083,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(110980,3083,'ms','Jenis alat',0),(110981,3083,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø£Ø¯Ø§Ø©',0),(110982,3083,'fr','Type d\'outil',0),(110983,3083,'jp','ãƒ„ãƒ¼ãƒ«ã‚¿ã‚¤ãƒ—',0),(110984,3083,'pt','Tipo de ferramenta',0),(110985,3083,'ru','Ð¢Ð¸Ð¿ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(110986,3083,'es','Tipo de herramienta',0),(110987,3083,'de','Werkzeugtyp',0),(110988,3083,'en','Tool type',0),(110989,3084,'is','',0),(110990,3084,'dr','Tooltip ØªÙˆØ¶ÙŠØ­Ø§ØªÙŠ Ú©Ù‡ Ø¨Ø§ Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ† Ù…Ø§ÙˆØ³ Ø±ÙˆÙŠ Ø´ÙŠØ¡ Ù†Ù…Ø§ÙŠØ§Ù† Ù…ÙŠ Ø´ÙˆØ¯',0),(110991,3084,'pr','Tooltip ØªÙˆØ¶ÙŠØ­Ø§ØªÙŠ Ú©Ù‡ Ø¨Ø§ Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ† Ù…Ø§ÙˆØ³ Ø±ÙˆÙŠ Ø´ÙŠØ¡ Ù†Ù…Ø§ÙŠØ§Ù† Ù…ÙŠ Ø´ÙˆØ¯',0),(110992,3084,'tr','AraÃ§ ipucu',0),(110993,3084,'pl','Tooltip',0),(110994,3084,'bg','ÐŸÐ¾ÑÑÐ½ÐµÐ½Ð¸Ðµ',0),(110995,3084,'ur','Ù¹ÙˆÙ„ Ù¹ÙˆÙ¹Ú©Û’',0),(110996,3084,'sr','ÐžÐ¿Ð¸Ñ Ð°Ð»Ð°Ñ‚ÐºÐµ',0),(110997,3084,'vi','CÃ´ng cá»¥ tÃ­nh tiá»n boa',0),(110998,3084,'af','Nutswenk',0),(110999,3084,'ro','Tooltip',0),(111000,3084,'et','Kohtspikker',0),(111001,3084,'si','Namig',0),(111002,3084,'ba','Tooltip',0),(111003,3084,'nl','Tooltip',0),(111004,3084,'fi','Tooltip',0),(111005,3084,'no','VerktÃ¸ytips',0),(111006,3084,'da','Tooltip',0),(111007,3084,'ko','ë„êµ¬ ì„¤ëª…',0),(111008,3084,'he','×ª×™××•×¨ ×›×œ×™',0),(111009,3084,'el','Tooltip',0),(111010,3084,'zh','å·¥å…·æç¤º\r\n',0),(111011,3084,'sv','Tooltip',0),(111012,3084,'it','ToolTip',0),(111013,3084,'tl','',0),(111014,3084,'th','&#3649;&#3609;&#3632;&#3609;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;',0),(111015,3084,'hi','à¤Ÿà¥‚à¤² à¤Ÿà¤¿à¤ª',0),(111016,3084,'ms','Tooltip',0),(111017,3084,'ar','ØªÙ„Ù…ÙŠØ­ Ø£Ø¯Ø§Ø©',0),(111018,3084,'fr','Info-bulle',0),(111019,3084,'jp','ã‚³ãƒ¡ãƒ³ãƒˆ',0),(111020,3084,'pt','Dica de ferramenta',0),(111021,3084,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ°',0),(111022,3084,'es','Consejo de Herramienta',0),(111023,3084,'de','ToolTip',0),(111024,3084,'en','Tooltip',0),(111025,3085,'is','',0),(111026,3085,'dr','Ù…ÙˆØ¶ÙˆØ¹ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯ ',0),(111027,3085,'pr','Ù…ÙˆØ¶ÙˆØ¹ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯ ',0),(111028,3085,'tr','Konu taÅŸÄ±ndÄ±',0),(111029,3085,'pl','Temat przeniesiony',0),(111030,3085,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚ÐµÐ½Ð° Ñ‚ÐµÐ¼Ð°',0),(111031,3085,'ur','Ù…ÙˆØ¶ÙˆØ¹ Ù…ÛŒÚº Ù…Ù†ØªÙ‚Ù„',0),(111032,3085,'sr','Ð¢Ð¾Ð¿Ð¸Ñ› ÑÐµ Ð¿Ñ€ÐµÑÐµÐ»Ð¸Ð¾',0),(111033,3085,'vi','Chá»§ Ä‘á» thay Ä‘á»•i',0),(111034,3085,'af','Onderwerp geskuif',0),(111035,3085,'ro','Subiect mutat',0),(111036,3085,'et','Teema kolis',0),(111037,3085,'si','Tema prestavljena',0),(111038,3085,'ba','Topik pindah',0),(111039,3085,'nl','Verplaatst onderwerp',0),(111040,3085,'fi','Aihe siirretty',0),(111041,3085,'no','Emnet flyttet',0),(111042,3085,'da','Emne flyttet',0),(111043,3085,'ko','í•­ëª© ì´ë™',0),(111044,3085,'he','×”× ×•×©× ×¢×‘×¨',0),(111045,3085,'el','Î¤Î¿ Î¸Î­Î¼Î± Î¼ÎµÏ„Î±Ï†Î­ÏÎ¸Î·ÎºÎµ',0),(111046,3085,'zh','ä¸»é¢˜åŠ¨è®®',0),(111047,3085,'sv','Ã„mne flyttade',0),(111048,3085,'it','Topic spostato',0),(111049,3085,'tl','',0),(111050,3085,'th','&#3618;&#3657;&#3634;&#3618;&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;&#3618;&#3656;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(111051,3085,'hi','à¤šà¤²à¥‡ à¤—à¤ à¤µà¤¿à¤·à¤¯',0),(111052,3085,'ms','Topik yang berpindah',0),(111053,3085,'ar','Ù…ÙˆØ¶ÙˆØ¹ Ù†Ù‚Ù„',0),(111054,3085,'fr','Sujet dÃ©placÃ©',0),(111055,3085,'jp','ç§»å‹•æ¸ˆãƒˆãƒ”ãƒƒã‚¯',0),(111056,3085,'pt','TÃ³pico movido',0),(111057,3085,'ru','Ð¢ÐµÐ¼Ð° Ð¿ÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð°',0),(111058,3085,'es','TÃ³pico Movido',0),(111059,3085,'de','Thema verschoben',0),(111060,3085,'en','Topic moved',0),(111061,3086,'is','',0),(111062,3086,'dr','Ù…ÙˆØ¶ÙˆØ¹ Ø­Ø°Ù Ø´Ø¯ ',0),(111063,3086,'pr','Ù…ÙˆØ¶ÙˆØ¹ Ø­Ø°Ù Ø´Ø¯ ',0),(111064,3086,'tr','Konu Ã§Ä±karmak',0),(111065,3086,'pl','Temat usuniÄ™ty',0),(111066,3086,'bg','Ð¢ÐµÐ¼Ð° Ð¾Ñ‚ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸',0),(111067,3086,'ur','Ù…ÙˆØ¶ÙˆØ¹ ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(111068,3086,'sr','Ð¢ÐµÐ¼Ð° Ñ˜Ðµ ÑƒÐºÐ»Ð¾ÑšÐµÐ½',0),(111069,3086,'vi','Bá» Chá»§ Ä‘á» ',0),(111070,3086,'af','Onderwerp verwyder',0),(111071,3086,'ro','Subiect eliminat',0),(111072,3086,'et','Teema eemaldada',0),(111073,3086,'si','Tema odstranjena',0),(111074,3086,'ba','Topik dihapus',0),(111075,3086,'nl','Onderwerp verwijderd',0),(111076,3086,'fi','Aihe poistettu',0),(111077,3086,'no','Emnet fjernet',0),(111078,3086,'da','Emnet fjernes',0),(111079,3086,'ko','í•­ëª© ì œê±°',0),(111080,3086,'he','×”× ×•×©× ×”×•×¡×¨',0),(111081,3086,'el','Î˜Î­Î¼Î± Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯',0),(111082,3086,'zh','åˆ é™¤ä¸»é¢˜\r\n',0),(111083,3086,'sv','Ã„mnet tas bort',0),(111084,3086,'it','Argomento rimosso',0),(111085,3086,'tl','',0),(111086,3086,'th','&#3621;&#3610;&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;&#3618;&#3656;&#3629;&#3618;&#3629;&#3629;&#3585;&#3649;&#3621;&#3657;&#3623;',0),(111087,3086,'hi','à¤µà¤¿à¤·à¤¯ à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(111088,3086,'ms','Topik yang dikeluarkan',0),(111089,3086,'ar','Ù…ÙˆØ¶ÙˆØ¹ Ø¥Ø²Ø§Ù„Ø©',0),(111090,3086,'fr','Rubrique supprimÃ©e',0),(111091,3086,'jp','å‰Šé™¤æ¸ˆãƒˆãƒ”ãƒƒã‚¯',0),(111092,3086,'pt','TÃ³pico removido',0),(111093,3086,'ru','Ð¢ÐµÐ¼Ð° ÑƒÐ´Ð°Ð»ÐµÐ½Ð°',0),(111094,3086,'es','TÃ³pico eliminado',0),(111095,3086,'de','Thema entfernt',0),(111096,3086,'en','Topic removed',0),(111097,3087,'is','',0),(111098,3087,'dr','Ù…ÙˆØ¶ÙˆØ¹ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(111099,3087,'pr','Ù…ÙˆØ¶ÙˆØ¹ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(111100,3087,'tr','GÃ¼ncel konu',0),(111101,3087,'pl','Aktualizacja tematu',0),(111102,3087,'bg','Ð¢ÐµÐ¼Ð° Ð¾ÑÑŠÐ²Ñ€ÐµÐ¼ÐµÐ½ÑÐ²Ð°Ð½Ðµ',0),(111103,3087,'ur','Ù…ÙˆØ¶ÙˆØ¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(111104,3087,'sr','Ð¢ÐµÐ¼Ð° Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(111105,3087,'vi','Cáº­p nháº­t chá»§ Ä‘á»',0),(111106,3087,'af','Onderwerp opdateer',0),(111107,3087,'ro','Subiect actualizat',0),(111108,3087,'et','Uuendatud teema',0),(111109,3087,'si','Temo posodobljen',0),(111110,3087,'ba','Topik yang diperbarui',0),(111111,3087,'nl','Onderwerp bijgewerkt',0),(111112,3087,'fi','Aihe pÃ¤ivitetty',0),(111113,3087,'no','Emnet oppdatert',0),(111114,3087,'da','Emnet opdateret',0),(111115,3087,'ko','í•­ëª© ì—…ë°ì´íŠ¸',0),(111116,3087,'he','×”× ×•×©× ×¢×•×“×›×Ÿ',0),(111117,3087,'el','Î˜Î­Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(111118,3087,'zh','ä¸»é¢˜æ›´æ–°\r\n',0),(111119,3087,'sv','Ã„mnet uppdaterad',0),(111120,3087,'it','Argomento aggiornato',0),(111121,3087,'tl','',0),(111122,3087,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;&#3618;&#3656;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(111123,3087,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¿à¤¤ à¤µà¤¿à¤·à¤¯',0),(111124,3087,'ms','Topik yang dikemaskini',0),(111125,3087,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆØ¶ÙˆØ¹',0),(111126,3087,'fr','Rubrique mise Ã  jour',0),(111127,3087,'jp','æ›´æ–°æ¸ˆãƒˆãƒ”ãƒƒã‚¯',0),(111128,3087,'pt','TÃ³pico atualizado',0),(111129,3087,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°Ð·Ð´ÐµÐ»Ð°',0),(111130,3087,'es','TÃ³pico actualizado',0),(111131,3087,'de','Aktualisierung des Themas',0),(111132,3087,'en','Topic updated',0),(111133,3088,'is','',0),(111134,3088,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯ÙØªØ± ÙƒÙ„',0),(111135,3088,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯ÙØªØ± ÙƒÙ„',0),(111136,3088,'tr','-',0),(111137,3088,'pl','-',0),(111138,3088,'bg','-',0),(111139,3088,'ur','-',0),(111140,3088,'sr','-',0),(111141,3088,'vi','-',0),(111142,3088,'af','-',0),(111143,3088,'ro','-',0),(111144,3088,'et','-',0),(111145,3088,'si','-',0),(111146,3088,'ba','-',0),(111147,3088,'nl','-',0),(111148,3088,'fi','-',0),(111149,3088,'no','-',0),(111150,3088,'da','-',0),(111151,3088,'ko','-',0),(111152,3088,'he','-',0),(111153,3088,'el','-',0),(111154,3088,'zh','çš„GL -é“è¾¾å°”\r\n',0),(111155,3088,'sv','-',0),(111156,3088,'it','-',0),(111157,3088,'tl','',0),(111158,3088,'th','-',0),(111159,3088,'hi','-',0),(111160,3088,'ms','-',0),(111161,3088,'ar','-',0),(111162,3088,'fr','-',0),(111163,3088,'jp','-',0),(111164,3088,'pt','-',0),(111165,3088,'ru','-',0),(111166,3088,'es','-',0),(111167,3088,'de','-',0),(111168,3088,'en','-',0),(111169,3089,'is','',0),(111170,3089,'dr','ÙƒÙ„ Ú†Ù†Ø¯ Ø´Ø±ÙƒØª',0),(111171,3089,'pr','ÙƒÙ„ Ú†Ù†Ø¯ Ø´Ø±ÙƒØª',0),(111172,3089,'tr','-',0),(111173,3089,'pl','-',0),(111174,3089,'bg','-',0),(111175,3089,'ur','-',0),(111176,3089,'sr','-',0),(111177,3089,'vi','-',0),(111178,3089,'af','-',0),(111179,3089,'ro','-',0),(111180,3089,'et','-',0),(111181,3089,'si','-',0),(111182,3089,'ba','-',0),(111183,3089,'nl','-',0),(111184,3089,'fi','-',0),(111185,3089,'no','-',0),(111186,3089,'da','-',0),(111187,3089,'ko','-',0),(111188,3089,'he','-',0),(111189,3089,'el','-',0),(111190,3089,'zh','é“è¾¾å°”å¤šå…¬å¸\r\n',0),(111191,3089,'sv','-',0),(111192,3089,'it','-',0),(111193,3089,'tl','',0),(111194,3089,'th','-',0),(111195,3089,'hi','-',0),(111196,3089,'ms','-',0),(111197,3089,'ar','-',0),(111198,3089,'fr','-',0),(111199,3089,'jp','-',0),(111200,3089,'pt','-',0),(111201,3089,'ru','-',0),(111202,3089,'es','-',0),(111203,3089,'de','-',0),(111204,3089,'en','-',0),(111205,3090,'is','',0),(111206,3090,'dr','Ø¬Ù…Ø¹ ÙƒÙ„',0),(111207,3090,'pr','Ø¬Ù…Ø¹ ÙƒÙ„',0),(111208,3090,'tr','Toplam',0),(111209,3090,'pl','OgÃ³Å‚em',0),(111210,3090,'bg','ÐžÐ±Ñ‰Ð¾',0),(111211,3090,'ur','Ú©Ù„ ØªØ¹Ø¯Ø§Ø¯',0),(111212,3090,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾',0),(111213,3090,'vi','Tá»•ng cá»™ng',0),(111214,3090,'af','Totaal',0),(111215,3090,'ro','Total',0),(111216,3090,'et','Kokku',0),(111217,3090,'si','Skupaj',0),(111218,3090,'ba','Total',0),(111219,3090,'nl','Totaal',0),(111220,3090,'fi','YhteensÃ¤',0),(111221,3090,'no','Totalt',0),(111222,3090,'da','I alt',0),(111223,3090,'ko','ì´',0),(111224,3090,'he','×¡×”\"×›',0),(111225,3090,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬',0),(111226,3090,'zh','æ€»è®¡\r\n',0),(111227,3090,'sv','Totalt',0),(111228,3090,'it','Totale',0),(111229,3090,'tl','',0),(111230,3090,'th','&#3619;&#3623;&#3617;',0),(111231,3090,'hi','à¤•à¥à¤²',0),(111232,3090,'ms','Jumlah keseluruhan',0),(111233,3090,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(111234,3090,'fr','Total',0),(111235,3090,'jp','å?ˆè¨ˆ',0),(111236,3090,'pt','Total',0),(111237,3090,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾',0),(111238,3090,'es','Total',0),(111239,3090,'de','Gesamt',0),(111240,3090,'en','Total',0),(111241,3091,'is','',0),(111242,3091,'dr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§ÙŠ Ù†Ù‚Ø¯ Ø´Ø¯Ù‡ ',0),(111243,3091,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§ÙŠ Ù†Ù‚Ø¯ Ø´Ø¯Ù‡ ',0),(111244,3091,'tr','TÃœM PARAYA KONTROL TOPLAM',0),(111245,3091,'pl','OGÃ“ÅEM WSZYSTKIE ZREALIZOWANE KONTROLI',0),(111246,3091,'bg','ÐžÐ‘Ð©Ðž Ð’Ð¡Ð˜Ð§ÐšÐ˜ ÐžÐ¡Ð Ð•Ð‘Ð Ð•ÐÐžÐ¢Ðž ÐŸÐ ÐžÐ’Ð•Ð ÐšÐ˜',0),(111247,3091,'ur','ØªÙ…Ø§Ù… Ú©Ø§Ø´Ø§Ø¯ Ú†ÛŒÚ© Ú©Ù„',0),(111248,3091,'sr','Ð£ÐšÐ£ÐŸÐÐž Ð¡Ð’Ð• Ð£ÐÐžÐ’Ð˜Ð•ÐÐ˜ Ð§Ð•ÐšÐžÐ’Ð•',0),(111249,3091,'vi','Táº¥t cáº£ cÃ¡c SÃ©c Ä‘Ã£ Ä‘á»•i thÃ nh tiá»n máº·t',0),(111250,3091,'af','BEREKEN ALLE GEWISSELDE TJEKS',0),(111251,3091,'ro','TOTALA INCASATA TOATE CONTROALELE',0),(111252,3091,'et','KOKKU KÃ•IK RAAMES LAEKUNUD KONTROLLI',0),(111253,3091,'si','SKUPAJ VSE VNOVÄŒIL PREGLEDI',0),(111254,3091,'ba','JUMLAH CEK SEMUA CASHED',0),(111255,3091,'nl','TOTAL ALLE GEÃNCASSEERD CONTROLES',0),(111256,3091,'fi','YHTEENSÃ„ KAIKKI NE VOI TARKISTAA',0),(111257,3091,'no','SUM ALLE INNLÃ˜ST SJEKKER',0),(111258,3091,'da','SAMLET ALLE INDLÃ˜SES KONTROL',0),(111259,3091,'ko','ëª¨ë“  CASHED ê²€ì‚¬ ì´',0),(111260,3091,'he','×¡×š ×›×œ CASHED ×¦\'×§×™×',0),(111261,3091,'el','Î£ÎŽÎÎŸÎ›ÎŸ ÎŒÎ›Î‘ Î•ÎžÎ‘Î¡Î“ÎŽÎ¡Î©Î£Î• Î•Î›ÎˆÎ“Î§ÎŸÎ¥Î£',0),(111262,3091,'zh','æ€»è®¡æ‰€æœ‰å…‘çŽ°çš„æ”¯ç¥¨\r\n',0),(111263,3091,'sv','TOTALT ALLA INKASSERADE KONTROLLER',0),(111264,3091,'it','TOTALE ASSEGNI INCASSATI TUTTI',0),(111265,3091,'tl','',0),(111266,3091,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3648;&#3594;&#3655;&#3588;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(111267,3091,'hi','à¤¸à¤¬ CASHED à¤œà¤¾à¤à¤šà¥‹à¤‚ à¤•à¥à¤²',0),(111268,3091,'ms','JUMLAH SEMUA CASHED PEMERIKSAAN',0),(111269,3091,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ ØµØ±Ù Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´ÙŠÙƒØ§Øª',0),(111270,3091,'fr','TOTAL DES CHÃˆQUES ENCAISSÃ‰S TOUT',0),(111271,3091,'jp','æ?›é‡‘ã?—ã?Ÿå°?åˆ‡æ‰‹ã?®ç·?é¡?',0),(111272,3091,'pt','TOTAL TUDO DESCONTADOS CHEQUES',0),(111273,3091,'ru','Ð’Ð¡Ð•Ð“Ðž Ð’Ð¡Ð•Ð“Ðž ÐžÐ‘ÐÐÐ›Ð˜Ð§Ð˜Ð’ÐÐ¢Ð¬ Ð§Ð•ÐšÐ˜',0),(111274,3091,'es','TOTAL DE TODOS LOS CHEQUES CAMBIADOS',0),(111275,3091,'de','INSGESAMT ALLES SCHECKRÃœCKLAUF',0),(111276,3091,'en','TOTAL ALL CASHED CHECKS',0),(111277,3092,'is','',0),(111278,3092,'dr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§',0),(111279,3092,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§',0),(111280,3092,'tr','BÃœTÃœN KONTROLLERÄ° TOPLAM',0),(111281,3092,'pl','SUMA WSZYSTKICH KONTROLI',0),(111282,3092,'bg','ÐžÐ‘Ð©Ðž Ð’Ð¡Ð˜Ð§ÐšÐ˜ Ð§Ð•ÐšÐžÐ’Ð•',0),(111283,3092,'ur','Ú©Ù„ Ø³Ø¨ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’',0),(111284,3092,'sr','Ð£ÐšÐ£ÐŸÐÐž Ð¡Ð’Ð• Ð§Ð•ÐšÐžÐ’Ð•',0),(111285,3092,'vi','Táº¥t cáº£ SÃ©c',0),(111286,3092,'af','BEREKEN ALLE TJEKS',0),(111287,3092,'ro','TOTALUL TUTUROR CONTROALELOR',0),(111288,3092,'et','KOKKU KÃ•IK KONTROLLID',0),(111289,3092,'si','SKUPAJ VSI PREGLEDI',0),(111290,3092,'ba','JUMLAH CEK SEMUA',0),(111291,3092,'nl','TOTAL ALLE CONTROLES',0),(111292,3092,'fi','YHTEENSÃ„ KAIKKI TARKASTUKSET',0),(111293,3092,'no','SUM ALLE SJEKKER',0),(111294,3092,'da','SAMLET ALLE KONTROL',0),(111295,3092,'ko','ëª¨ë“  ê²€ì‚¬ë¥¼ ì´',0),(111296,3092,'he','×¡×š ×›×œ ×”×¦\'×§×™×',0),(111297,3092,'el','Î£Î¥ÎÎŸÎ›Î™ÎšÎ† ÎŒÎ›ÎŸÎ¥Î£ Î¤ÎŸÎ¥Î£ Î•Î›ÎˆÎ“Î§ÎŸÎ¥Î£',0),(111298,3092,'zh','æ€»è®¡æ‰€æœ‰æ”¯ç¥¨\r\n',0),(111299,3092,'sv','TOTALT ALLA KONTROLLER',0),(111300,3092,'it','TOTALE DI TUTTI I CONTROLLI',0),(111301,3092,'tl','',0),(111302,3092,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3648;&#3594;&#3655;&#3588;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(111303,3092,'hi','à¤¸à¤­à¥€ à¤šà¥‡à¤• à¤•à¥à¤²',0),(111304,3092,'ms','JUMLAH SEMUA CEK',0),(111305,3092,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ ÙƒÙ„Ù‘ Ø§Ù„ØµÙƒÙˆÙƒ',0),(111306,3092,'fr','TOTAL DE TOUS LES CONTRÃ”LES',0),(111307,3092,'jp','å°?åˆ‡æ‰‹ã?®ç·?é¡?',0),(111308,3092,'pt','TOTAL DE TODAS AS VERIFICAÃ‡Ã•ES',0),(111309,3092,'ru','Ð’Ð¡Ð•Ð“Ðž Ð’Ð¡Ð• ÐŸÐ ÐžÐ’Ð•Ð ÐšÐ˜',0),(111310,3092,'es','TOTAL TODOS LOS CHEQUES',0),(111311,3092,'de','INSGESAMT ALLE PRÃœFUNGEN',0),(111312,3092,'en','TOTAL ALL CHECKS',0),(111313,3093,'is','',0),(111314,3093,'dr','(Ù…Ù†ØªØ¸Ø±) ØªØ¹ÙˆÛŒÙ‚',0),(111315,3093,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§ÙŠ(Ù…Ù†ØªØ¸Ø±) Ù…Ø¹ÙˆÙ‚',0),(111316,3093,'tr','TÃœM BEKLEYEN KONTROL TOPLAM',0),(111317,3093,'pl','SUMA WSZYSTKICH KONTROLI CZASU',0),(111318,3093,'bg','ÐžÐ‘Ð©Ðž Ð’Ð¡Ð˜Ð§ÐšÐ˜ Ð§ÐÐšÐÐ©Ð˜ ÐšÐžÐÐ¢Ð ÐžÐ›',0),(111319,3093,'ur','ØªÙ…Ø§Ù… Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ù¾Ú‘ØªØ§Ù„ Ú©Ù„',0),(111320,3093,'sr','Ð£ÐšÐ£ÐŸÐÐž Ð¡Ð’Ð• ÐÐ•ÐžÐ‘Ð ÐÐ‚Ð•ÐÐ• Ð§Ð•ÐšÐžÐ’Ð•',0),(111321,3093,'vi','Táº¥t cáº£ SÃ©c Ä‘ang treo',0),(111322,3093,'af','BEREKEN ALLE AFWAGTENDE TJEKS',0),(111323,3093,'ro','TOTAL, TOATE ÃŽN AÅžTEPTAREA CONTROALELOR',0),(111324,3093,'et','KOKKU KÃ•IK KONTROLLI LÃ„BIVIIMIST OODATES',0),(111325,3093,'si','SKUPAJ VSE ÄŒAKAJOÄŒE PREGLEDI',0),(111326,3093,'ba','JUMLAH SEMUA TERTUNDA CEK',0),(111327,3093,'nl','TOTALE ALL IN AFWACHTING VAN CONTROLES',0),(111328,3093,'fi','YHTEENSÃ„ KAIKKI ODOTTAVAT SEKIT',0),(111329,3093,'no','SUM ALLE VENTENDE KONTROLLER',0),(111330,3093,'da','SAMLET ALLE VENTENDE KONTROL',0),(111331,3093,'ko','ëª¨ë“  ë³´ë¥˜ ì¤‘ì¸ ê²€ì‚¬ ì´',0),(111332,3093,'he','×¡×š ×›×œ ×”×¦\'×§×™× ×ž×ž×ª×™× ×”',0),(111333,3093,'el','Î£Î¥ÎÎŸÎ›Î™ÎšÎ† ÎŒÎ›ÎŸÎ¥Î£ Î¤ÎŸÎ¥Î£ Î•Î›ÎˆÎ“Î§ÎŸÎ¥Î£ Î£Î• Î•ÎšÎšÎ¡Î•ÎœÎŒÎ¤Î—Î¤Î‘',0),(111334,3093,'zh','åˆè®¡æ‰€æœ‰å¾…åŠžæ”¯ç¥¨\r\n',0),(111335,3093,'sv','TOTALT ALLA VÃ„NTANDE KONTROLLER',0),(111336,3093,'it','TOTALE DI TUTTI GLI ASSEGNI IN SOSPESO',0),(111337,3093,'tl','',0),(111338,3093,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3648;&#3594;&#3655;&#3588;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(111339,3093,'hi','à¤•à¥à¤² à¤¸à¤­à¥€ à¤²à¤‚à¤¬à¤¿à¤¤ à¤šà¥‡à¤•',0),(111340,3093,'ms','JUMLAH SEMUA CEK YANG BELUM SELESAI',0),(111341,3093,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(111342,3093,'fr','TOTAL DE TOUS LES CHÃˆQUES EN ATTENTE',0),(111343,3093,'jp','æœªå®Œäº†å°?åˆ‡æ‰‹ã?®ç·?é¡?',0),(111344,3093,'pt','TOTAL DE TODOS OS CHEQUES PENDENTES',0),(111345,3093,'ru','Ð’Ð¡Ð•Ð“Ðž Ð’Ð¡Ð• ÐžÐ–Ð˜Ð”ÐÐ®Ð©Ð˜Ð• ÐŸÐ ÐžÐ’Ð•Ð ÐšÐ˜',0),(111346,3093,'es','TOTAL TODOS LOS CHEQUES PENDIENTES',0),(111347,3093,'de','INSGESAMT ALLE AUSSTEHENDE PRÃœFUNGEN',0),(111348,3093,'en','TOTAL ALL PENDING CHECKS',0),(111349,3094,'is','',0),(111350,3094,'dr','(Ù†Ù‚Ø¯ Ø´Ø¯Ù‡ Ùˆ ØªØ¹ÙˆÛŒÙ‚ ',0),(111351,3094,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§ÙŠ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ (Ù†Ù‚Ø¯ Ø´Ø¯Ù‡ Ùˆ Ù…Ø¹ÙˆÙ‚ ',0),(111352,3094,'tr','Toplam tÃ¼m geÃ§erli DENETLER (paraya ve bekleyen)',0),(111353,3094,'pl','OGÃ“ÅEM wszystkie waÅ¼ne czeki (zrealizowane i czasu)',0),(111354,3094,'bg','ÐžÐ‘Ð©Ðž Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð’ÐÐ›Ð˜Ð”ÐÐ˜ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ (Ð¾ÑÑ€ÐµÐ±Ñ€ÐµÐ½Ð¾Ñ‚Ð¾ Ð¸ Ð²Ð¸ÑÑÑ‰Ð¸)',0),(111355,3094,'ur','Ú©Ù„ Ø³Ø¨ Ø¬Ø§Ø¦Ø² Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’ (Ø¨Ø¸Ø§ÛØ±Ø§Ù† Ø§ÙˆØ± Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§)',0),(111356,3094,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÑÐ²Ðµ Ð’ÐÐ–Ð•Ð‹Ð• Ð§Ð•ÐšÐžÐ’Ð• (ÑƒÐ½Ð¾Ð²Ð¸ÐµÐ½Ð¸ Ð¸ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ)',0),(111357,3094,'vi','Táº¥t cáº£ SÃ©c cÃ³ hiá»‡u lá»±c (Ä‘Ã£ Ä‘á»•i thÃ nh tiá»n máº·t & Ä‘ang treo)',0),(111358,3094,'af','BEREKEN ALLE GELDIGE TJEKS (gewissel en ongewissel)',0),(111359,3094,'ro','VERIFICÄ‚ toate TOTAL valabil (cash ÅŸi Ã®n aÅŸteptare)',0),(111360,3094,'et','Kokku kÃµigile kehtiva KONTROLLIB (raames laekunud ja ootel)',0),(111361,3094,'si','SKUPNO vse veljavne ÄŒEKE (vnovÄil in ÄakajoÄe)',0),(111362,3094,'ba','TOTAL semua berlaku cek (menguangkan dan tertunda)',0),(111363,3094,'nl','TOTALE alle geldige cheques (geÃ¯ncasseerd en in behandeling)',0),(111364,3094,'fi','YhteensÃ¤ kaikki voimassa SEKIT (pÃ¤Ã¤si ja vireillÃ¤)',0),(111365,3094,'no','Totalt alle gyldige SJEKKER (innlÃ¸st og ventende)',0),(111366,3094,'da','SAMLEDE alle GYLDIGE check (indlÃ¸ses og ventende)',0),(111367,3094,'ko','ì´ ëª¨ë“  ìœ íš¨í•œ í™•ì¸ (í˜„ê¸ˆ ë° ë³´ë¥˜)',0),(111368,3094,'he','×¡×š ×›×œ ×—×•×§×™ ×‘×•×“×§ (×¤×“×”, ×ž×ž×ª×™× ×”)',0),(111369,3094,'el','Î£ÎŽÎÎŸÎ›ÎŸ ÏŒÎ»Ï‰Î½ Î™Î£Î§ÎŽÎ•Î™ Ï„Ï‰Î½ Î•Î Î™Î¤Î‘Î“ÎÎ (Î•Î¾Î±ÏÎ³ÏÏÏ‰ÏƒÎµ ÎºÎ±Î¹ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î±)',0),(111370,3094,'zh','åˆè®¡æ‰€æœ‰æœ‰æ•ˆæ”¯ç¥¨ï¼ˆå…‘çŽ°å’Œå¾…å®šï¼‰\r\n',0),(111371,3094,'sv','TOTALT alla giltiga checkar (inkasserade och vÃ¤ntande)',0),(111372,3094,'it','TOTALE controlla tutti validi (incassati e in sospeso)',0),(111373,3094,'tl','',0),(111374,3094,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3648;&#3594;&#3655;&#3588;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(111375,3094,'hi','à¤•à¥à¤² à¤¸à¤­à¥€ à¤®à¤¾à¤¨à¥à¤¯ à¤šà¥‡à¤• (à¤­à¥à¤¨à¤¾à¤¯à¤¾ à¤”à¤° à¤²à¤‚à¤¬à¤¿à¤¤)',0),(111376,3094,'ms','Jumlah semua sah menyemak (ditunaikan dan belum selesai)',0),(111377,3094,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù…Ù† ÙƒØ§ÙØ© Ø§Ù„Ø§Ø®ØªØ¨Ø§Ø±Ø§Øª ØµØ§Ù„Ø­Ø© (cashed ÙˆÙ…Ø¹Ù„Ù‚Ø©)',0),(111378,3094,'fr','TOTAL vÃ©rifie tous les valides (encaissÃ©s et en attente)',0),(111379,3094,'jp','æœ‰åŠ¹ã?ªå°?åˆ‡æ‰‹ï¼ˆæ?›é‡‘æ¸ˆã?¨ä¿?ç•™ä¸­ï¼‰ã?®ç·?é¡?',0),(111380,3094,'pt','TOTAL todos os cheques vÃ¡lido (descontado e pendentes)',0),(111381,3094,'ru','Ð’Ð¡Ð•Ð“Ðž Ð²ÑÐµ Ð´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚ (Ð¾Ð±Ð½Ð°Ð»Ð¸Ñ‡Ð¸Ð²Ð°Ñ‚ÑŒ Ð¸ Ð¾Ð¶Ð¸Ð´Ð°Ð½Ð¸Ðµ)',0),(111382,3094,'es','TODOS LOS CHEQUES VÃLIDOS (cambiados y pendientes)',0),(111383,3094,'de','TOTAL alle gÃ¼ltigen Ã¼berprÃ¼ft (eingelÃ¶ste und ausstehende)',0),(111384,3094,'en','TOTAL ALL VALID CHECKS (cashed and pending)',0),(111385,3095,'is','',0),(111386,3095,'dr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§ÙŠ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡',0),(111387,3095,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§ÙŠ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡',0),(111388,3095,'tr','TÃœM GEÃ‡ERSÄ°Z KILINMIÅž DENETÄ°MLER TOPLAM',0),(111389,3095,'pl','CAÅKOWITEJ KONTROLI WSZYSTKICH UNIEWAÅ»NIONE',0),(111390,3095,'bg','ÐžÐ‘Ð©Ðž Ð’Ð¡Ð˜Ð§ÐšÐ˜ ÐÐÐ£Ð›Ð˜Ð ÐÐÐ˜Ð¯ ÐŸÐ ÐžÐ’Ð•Ð ÐšÐ˜',0),(111391,3095,'ur','ØªÙ…Ø§Ù… ÙˆÙˆØ§ÚˆÛŒØ¯ Ú†ÛŒÚ© Ú©Ù„',0),(111392,3095,'sr','Ð£ÐšÐ£ÐŸÐÐž Ð¡Ð’Ð˜ Ð¡Ð¢ÐžÐ ÐÐ˜Ð ÐÐÐ˜ Ð§Ð•ÐšÐžÐ’Ð•',0),(111393,3095,'vi','Táº¥t cáº£ SÃ©c Ä‘Ã£ xÃ³a',0),(111394,3095,'af','TOTALE ALLE VOIDED ONDERSOEKE',0),(111395,3095,'ro','TOTAL TOATE ANULAT CONTROALE',0),(111396,3095,'et','KOKKU KÃ•IK TÃœHISTATUD KONTROLLI',0),(111397,3095,'si','SKUPAJ VSI RAZVELJAVLJENI PREGLEDI',0),(111398,3095,'ba','JUMLAH SEMUA VOIDED CEK',0),(111399,3095,'nl','ALLE VERNIETIGDE CONTROLES TOTAL',0),(111400,3095,'fi','YHTEENSÃ„ KAIKKI MITÃ„TÃ–IDYT TARKASTUKSET',0),(111401,3095,'no','SUM ALLE ANNULLERTE SJEKKER',0),(111402,3095,'da','SAMLET ALLE NEDLAGTE KONTROL',0),(111403,3095,'ko','ì´ ëª¨ë‘ ëª©í‘œë¡œ í™•ì¸',0),(111404,3095,'he','×¡×” ×› ×‘×“×™×§×•×ª ×›×œ ×©×ª×•×§×¤×Ÿ ×‘×•×˜×œ',0),(111405,3095,'el','Î£ÎŽÎÎŸÎ›ÎŸ ÎŒÎ›Î‘ Î‘ÎšÎ¥Î¡Î©ÎœÎˆÎÎ—Î£ Î•Î›ÎˆÎ“Î§ÎŸÎ¥Î£',0),(111406,3095,'zh','æ€»è®¡æ‰€æœ‰æ— æ•ˆçš„æ”¯ç¥¨\r\n',0),(111407,3095,'sv','TOTALT ALLA ANNULLERADE KONTROLLER',0),(111408,3095,'it','TOTALE CONTROLLI TUTTO ESCRETA',0),(111409,3095,'tl','',0),(111410,3095,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3648;&#3594;&#3655;&#3588;&#3610;&#3633;&#3605;&#3619;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(111411,3095,'hi','à¤¸à¤¬ VOIDED à¤œà¤¾à¤à¤šà¥‹à¤‚ à¤•à¥à¤²',0),(111412,3095,'ms','JUMLAH CEK SEMUA VOIDED',0),(111413,3095,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ù…Ù„ØºØ§Ø© Ø¬Ù…ÙŠØ¹',0),(111414,3095,'fr','TOTAL DES CONTRÃ”LES TOUT ANNULÃ‰S',0),(111415,3095,'jp','ç„¡åŠ¹å°?åˆ‡æ‰‹ã?®ç·?é¡?',0),(111416,3095,'pt','TOTAL DE CHEQUES TODAS ANULADAS',0),(111417,3095,'ru','Ð’Ð¡Ð•Ð“Ðž Ð’Ð¡Ð• ÐÐÐÐ£Ð›Ð˜Ð ÐžÐ’ÐÐÐÐ«Ð• Ð§Ð•ÐšÐ˜',0),(111418,3095,'es','TOTAL TODOS LOS CHEQUES ANULADOS',0),(111419,3095,'de','INSGESAMT ALLES STORNIERTE SCHECKS',0),(111420,3095,'en','TOTAL ALL VOIDED CHECKS',0),(111421,3096,'is','',0),(111422,3096,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠÙ‡Ø§',0),(111423,3096,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠÙ‡Ø§',0),(111424,3096,'tr','TOPLAM AKTÄ°F',0),(111425,3096,'pl','AKTYWA OGÃ“ÅEM',0),(111426,3096,'bg','ÐžÐ‘Ð©Ðž ÐÐšÐ¢Ð˜Ð’Ð˜',0),(111427,3096,'ur','Ú©Ù„ Ø§Ø«Ø§Ø«Û’',0),(111428,3096,'sr','Ð£ÐšÐ£ÐŸÐÐ ÐÐšÐ¢Ð˜Ð’Ð',0),(111429,3096,'vi','Tá»•ng cá»™ng tÃ i sáº£n',0),(111430,3096,'af','TOTALE BATES',0),(111431,3096,'ro','ACTIVELE TOTALE',0),(111432,3096,'et','VARAD KOKKU',0),(111433,3096,'si','BILANÄŒNE VSOTE',0),(111434,3096,'ba','TOTAL ASET',0),(111435,3096,'nl','TOTAAL ACTIVA',0),(111436,3096,'fi','TASEEN LOPPUSUMMA',0),(111437,3096,'no','EIENDELER',0),(111438,3096,'da','SAMLEDE AKTIVER',0),(111439,3096,'ko','ì´ ìžì‚°',0),(111440,3096,'he','×¡×š ×”× ×›×¡×™×',0),(111441,3096,'el','Î“Î•ÎÎ™ÎšÎŸ Î£Î¥ÎÎŸÎ›ÎŸ Î•ÎÎ•Î¡Î“Î—Î¤Î™ÎšÎŸÎ¥',0),(111442,3096,'zh','æ€»èµ„äº§\r\n',0),(111443,3096,'sv','TOTALA TILLGÃ…NGAR',0),(111444,3096,'it','TOTALE ATTIVITÃ€',0),(111445,3096,'tl','',0),(111446,3096,'th','&#3626;&#3636;&#3609;&#3607;&#3619;&#3633;&#3614;&#3618;&#3660;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(111447,3096,'hi','à¤•à¥à¤² à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿',0),(111448,3096,'ms','JUMLAH ASET',0),(111449,3096,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø£ØµÙˆÙ„',0),(111450,3096,'fr','TOTAL DE L\'ACTIF',0),(111451,3096,'jp','è³‡ç”£å?ˆè¨ˆ',0),(111452,3096,'pt','TOTAL DE ATIVOS',0),(111453,3096,'ru','Ð˜Ð¢ÐžÐ“Ðž ÐÐšÐ¢Ð˜Ð’Ð«',0),(111454,3096,'es','TOTAL DE ACTIVOS',0),(111455,3096,'de','BILANZSUMME',0),(111456,3096,'en','TOTAL ASSETS',0),(111457,3097,'is','',0),(111458,3097,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ú©Ù„',0),(111459,3097,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ú©Ù„',0),(111460,3097,'tr','Toplam maliyet',0),(111461,3097,'pl','CaÅ‚kowity koszt',0),(111462,3097,'bg','ÐžÐ±Ñ‰Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(111463,3097,'ur','Ú©Ù„ Ù„Ø§Ú¯Øª',0),(111464,3097,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(111465,3097,'vi','Tá»•ng cá»™ng giÃ¡ thÃ nh',0),(111466,3097,'af','Totale Koste',0),(111467,3097,'ro','Costul total',0),(111468,3097,'et','Kulu kokku',0),(111469,3097,'si','Skupni stroÅ¡ki',0),(111470,3097,'ba','Total biaya',0),(111471,3097,'nl','Totale kosten',0),(111472,3097,'fi','Kokonaiskustannukset',0),(111473,3097,'no','Totale kostnader',0),(111474,3097,'da','Samlede omkostninger',0),(111475,3097,'ko','ì´ ë¹„ìš©',0),(111476,3097,'he','×¢×œ×•×ª ×›×•×œ×œ×ª',0),(111477,3097,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(111478,3097,'zh','æ€»æˆæœ¬\r\n',0),(111479,3097,'sv','Total kostnad',0),(111480,3097,'it','Costo totale',0),(111481,3097,'tl','',0),(111482,3097,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(111483,3097,'hi','à¤•à¥à¤² à¤²à¤¾à¤—à¤¤',0),(111484,3097,'ms','Jumlah kos',0),(111485,3097,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ©',0),(111486,3097,'fr','CoÃ»t total',0),(111487,3097,'jp','ç·?é¡?',0),(111488,3097,'pt','Custo total',0),(111489,3097,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(111490,3097,'es','Costo Total',0),(111491,3097,'de','Gesamtkosten',0),(111492,3097,'en','Total Cost',0),(111493,3098,'is','',0),(111494,3098,'dr','Ù…Ø¬Ù…ÙˆØ¹\r\nÙƒØ³ÙˆØ±Ø§Øª',0),(111495,3098,'pr','Ù…Ø¬Ù…ÙˆØ¹\r\nÙƒØ³ÙˆØ±Ø§Øª',0),(111496,3098,'tr','Toplam Ded',0),(111497,3098,'pl','CaÅ‚kowita Ded',0),(111498,3098,'bg','ÐžÐ±Ñ‰Ð¾ Ded',0),(111499,3098,'ur','Ú©Ù„ Ø¯Ø¯',0),(111500,3098,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð”ÐµÐ´',0),(111501,3098,'vi','Tá»•ng cá»™ng giáº£m trá»«',0),(111502,3098,'af','Totale Aftrekk.',0),(111503,3098,'ro','Total Ded',0),(111504,3098,'et','Kokku Ded',0),(111505,3098,'si','Skupno zmletimi',0),(111506,3098,'ba','Total Ded',0),(111507,3098,'nl','Totale Ded',0),(111508,3098,'fi','YhteensÃ¤ Ded',0),(111509,3098,'no','Totalt Ded',0),(111510,3098,'da','Samlede Ded',0),(111511,3098,'ko','ì´ ê³µê²© í•œ',0),(111512,3098,'he','Ded ×¡×”',0),(111513,3098,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Ded',0),(111514,3098,'zh','æ€»è®¡æ‰£é™¤\r\n',0),(111515,3098,'sv','Totala Ded',0),(111516,3098,'it','Totale Ded',0),(111517,3098,'tl','',0),(111518,3098,'th','Total Ded',0),(111519,3098,'hi','à¤•à¥à¤² Ded',0),(111520,3098,'ms','Jumlah Anugerah',0),(111521,3098,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø¯Ø§Ø¦Ø±Ø© Ø§Ù„Ø§Ù‚ØªØµØ§Ø¯ÙŠØ©',0),(111522,3098,'fr','Total Ded',0),(111523,3098,'jp','Total Ded',0),(111524,3098,'pt','Total Ded',0),(111525,3098,'ru','Ð’ÑÐµÐ³Ð¾ Ð”ÐµÐ´',0),(111526,3098,'es','Ded. Totales',0),(111527,3098,'de','Total Ded',0),(111528,3098,'en','Total Ded',0),(111529,3099,'is','',0),(111530,3099,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(111531,3099,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(111532,3099,'tr','Toplam mevduat',0),(111533,3099,'pl','Depozyty ogÃ³Å‚em',0),(111534,3099,'bg','ÐžÐ±Ñ‰Ð¾ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(111535,3099,'ur','Ú©Ù„ ÚˆÙ¾Ø§Ø²Ù¹Ø³',0),(111536,3099,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾Ð³ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(111537,3099,'vi','Tá»•ng cá»™ng kÃ½ quá»¹',0),(111538,3099,'af','Totale Deposito\'s',0),(111539,3099,'ro','Total depozite',0),(111540,3099,'et','Hoiused kokku',0),(111541,3099,'si','Vse vloge',0),(111542,3099,'ba','Total deposito',0),(111543,3099,'nl','De totale stortingen',0),(111544,3099,'fi','Talletukset yhteensÃ¤',0),(111545,3099,'no','Totale innskudd',0),(111546,3099,'da','Samlede indbetalinger',0),(111547,3099,'ko','ì´ ì˜ˆê¸ˆ',0),(111548,3099,'he','×¡×š ×”×¤×§×“×•×ª',0),(111549,3099,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ­Ï‚ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚',0),(111550,3099,'zh','æ€»å­˜æ¬¾\r\n',0),(111551,3099,'sv','Totala insÃ¤ttningar',0),(111552,3099,'it','Totale dei depositi',0),(111553,3099,'tl','',0),(111554,3099,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;',0),(111555,3099,'hi','à¤•à¥à¤² à¤œà¤®à¤¾',0),(111556,3099,'ms','Jumlah Deposit',0),(111557,3099,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹Ø§Øª',0),(111558,3099,'fr','Total des dÃ©pÃ´ts',0),(111559,3099,'jp','é ?é‡‘ç·?é¡?',0),(111560,3099,'pt','DepÃ³sitos totais',0),(111561,3099,'ru','Ð’ÑÐµÐ³Ð¾ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¾Ð²',0),(111562,3099,'es','Total DepÃ³sitos',0),(111563,3099,'de','Gesamten Einlagen',0),(111564,3099,'en','Total Deposits',0),(111565,3100,'is','',0),(111566,3100,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø­Ù‚ Ù…Ø§Ù„ÙŠ',0),(111567,3100,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø­Ù‚ Ù…Ø§Ù„ÙŠ',0),(111568,3100,'tr','TOPLAM Ã–Z SERMAYE',0),(111569,3100,'pl','CAÅKOWITEGO KAPITAÅU',0),(111570,3100,'bg','ÐžÐ‘Ð©Ðž Ð¡ÐžÐ‘Ð¡Ð¢Ð’Ð•Ð ÐšÐÐŸÐ˜Ð¢ÐÐ›',0),(111571,3100,'ur','Ú©Ù„ Ø¹Ø¯Ù„',0),(111572,3100,'sr','Ð£ÐšÐ£ÐŸÐÐ ÐšÐÐŸÐ˜Ð¢ÐÐ›',0),(111573,3100,'vi','Tá»•ng cá»™ng giÃ¡ trá»‹ chá»§ sá»¡ há»¯u',0),(111574,3100,'af','TOTALE EKWITEIT',0),(111575,3100,'ro','TOTAL CAPITALURI PROPRII',0),(111576,3100,'et','OMAKAPITAL KOKKU',0),(111577,3100,'si','CELOTNEGA KAPITALA',0),(111578,3100,'ba','JUMLAH EKUITAS',0),(111579,3100,'nl','TOTAAL EIGEN VERMOGEN',0),(111580,3100,'fi','OMA PÃ„Ã„OMA YHTEENSÃ„',0),(111581,3100,'no','SUM EGENKAPITAL',0),(111582,3100,'da','SAMLEDE EGENKAPITAL',0),(111583,3100,'ko','ìžë³¸ ì´ê³„',0),(111584,3100,'he','×¡×” ×› ×”×•×Ÿ ×¢×¦×ž×™',0),(111585,3100,'el','Î£Î¥ÎÎŸÎ›ÎŸ Î™âˆ†Î™Î©Î',0),(111586,3100,'zh','æ€»èµ„äº§å‡€å€¼\r\n',0),(111587,3100,'sv','SUMMA EGET KAPITAL',0),(111588,3100,'it','PATRIMONIO NETTO TOTALE',0),(111589,3100,'tl','',0),(111590,3100,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3648;&#3607;&#3656;&#3634;&#3585;&#3633;&#3610;',0),(111591,3100,'hi','à¤•à¥à¤² à¤‡à¤•à¥à¤µà¤¿à¤Ÿà¥€',0),(111592,3100,'ms','JUMLAH EKUITI',0),(111593,3100,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³Ø§Ù‡Ù…ÙŠÙ†',0),(111594,3100,'fr','TOTAL DES CAPITAUX PROPRES',0),(111595,3100,'jp','æ ªå?ˆè¨ˆ',0),(111596,3100,'pt','TOTAL PATRIMÃ”NIO LÃQUIDO',0),(111597,3100,'ru','Ð˜Ð¢ÐžÐ“Ðž ÐšÐÐŸÐ˜Ð¢ÐÐ›',0),(111598,3100,'es','TOTAL DE PLUSVALIA',0),(111599,3100,'de','TOTAL EIGENKAPITAL',0),(111600,3100,'en','TOTAL EQUITY',0),(111601,3101,'is','',0),(111602,3101,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ',0),(111603,3101,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ',0),(111604,3101,'tr','Ä°Ã§in toplam',0),(111605,3101,'pl','OgÃ³Å‚em',0),(111606,3101,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð°',0),(111607,3101,'ur','Ú©Ù„ Ú©Û’ Ù„ÛŒÛ’',0),(111608,3101,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð°',0),(111609,3101,'vi','Tá»•ng cá»™ng cho',0),(111610,3101,'af','Totaal vir',0),(111611,3101,'ro','Total pentru',0),(111612,3101,'et','Kogusumma',0),(111613,3101,'si','Skupaj za',0),(111614,3101,'ba','Total untuk',0),(111615,3101,'nl','Totaal voor',0),(111616,3101,'fi','YhteensÃ¤',0),(111617,3101,'no','Totalen for',0),(111618,3101,'da','Alt for',0),(111619,3101,'ko','ì— ëŒ€ í•œ ì´',0),(111620,3101,'he','×¡×” ×¢×‘×•×¨',0),(111621,3101,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î³Î¹Î±',0),(111622,3101,'zh','æ€»è®¡\r\n',0),(111623,3101,'sv','Totalt fÃ¶r',0),(111624,3101,'it','Totale per',0),(111625,3101,'tl','',0),(111626,3101,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(111627,3101,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²',0),(111628,3101,'ms','Jumlah keseluruhan bagi',0),(111629,3101,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(111630,3101,'fr','Total pour',0),(111631,3101,'jp','ã?®å?ˆè¨ˆ',0),(111632,3101,'pt','Total para',0),(111633,3101,'ru','Ð’ÑÐµÐ³Ð¾ Ð·Ð°',0),(111634,3101,'es','Total para',0),(111635,3101,'de','Insgesamt fÃ¼r',0),(111636,3101,'en','Total for',0),(111637,3102,'is','',0),(111638,3102,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… ',0),(111639,3102,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… ',0),(111640,3102,'tr','TÃ¼m toplam',0),(111641,3102,'pl','ÅÄ…cznie dla wszystkich',0),(111642,3102,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸',0),(111643,3102,'ur','Ú©Ù„ Ø³Ø¨ Ú©Û’ Ù„ÛŒÛ’',0),(111644,3102,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð° ÑÐ²Ðµ',0),(111645,3102,'vi','Tá»•ng cá»™ng cho táº¥t cáº£',0),(111646,3102,'af','Totaal vir alles',0),(111647,3102,'ro','Total pentru toate',0),(111648,3102,'et','Kokku kÃµik',0),(111649,3102,'si','Skupno za vse',0),(111650,3102,'ba','Total untuk semua',0),(111651,3102,'nl','Totaal voor alle',0),(111652,3102,'fi','YhteensÃ¤ kaikki',0),(111653,3102,'no','Totalen for alle',0),(111654,3102,'da','Det samlede belÃ¸b for alle',0),(111655,3102,'ko','ëª¨ë‘ì— ëŒ€ í•œ ì´',0),(111656,3102,'he','×¡×” ×¢×‘×•×¨ ×›×œ',0),(111657,3102,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î³Î¹Î± ÏŒÎ»Î¿Ï…Ï‚',0),(111658,3102,'zh','æ€»è®¡æ‰€æœ‰\r\n',0),(111659,3102,'sv','Totalt fÃ¶r alla',0),(111660,3102,'it','Totale per tutti',0),(111661,3102,'tl','',0),(111662,3102,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(111663,3102,'hi','à¤¸à¤­à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²',0),(111664,3102,'ms','Jumlah keseluruhan bagi Semua',0),(111665,3102,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ù„ÙƒÙ„',0),(111666,3102,'fr','Total pour l\'ensemble',0),(111667,3102,'jp','å…¨ã?¦ã?®ç·?é¡?',0),(111668,3102,'pt','Total para todos',0),(111669,3102,'ru','ÐžÐ±Ñ‰ÐµÐµ Ð´Ð»Ñ Ð²ÑÐµÑ…',0),(111670,3102,'es','Total para todo',0),(111671,3102,'de','Insgesamt fÃ¼r alle',0),(111672,3102,'en','Total for all',0),(111673,3103,'is','',0),(111674,3103,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ù‡ ØµÙˆØ±Øª  Ú¯Ø±ÙˆÙ‡ÙŠ ',0),(111675,3103,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ù‡ ØµÙˆØ±Øª  Ú¯Ø±ÙˆÙ‡ÙŠ ',0),(111676,3103,'tr','Toplam grup',0),(111677,3103,'pl','W grupie',0),(111678,3103,'bg','ÐžÐ±Ñ‰Ð¾ Ð² Ð³Ñ€ÑƒÐ¿Ð°',0),(111679,3103,'ur','Ú¯Ø±ÙˆÙ¾ Ù…ÛŒÚº Ú©Ù„',0),(111680,3103,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ñƒ',0),(111681,3103,'vi','Tá»•ng cá»™ng trong nhÃ³m',0),(111682,3103,'af','Totaal in Groep',0),(111683,3103,'ro','Total Ã®n grup',0),(111684,3103,'et','Kokku rÃ¼hma',0),(111685,3103,'si','Skupaj v skupini',0),(111686,3103,'ba','Total dalam kelompok',0),(111687,3103,'nl','Totale in groep',0),(111688,3103,'fi','YhteensÃ¤ ryhmÃ¤n',0),(111689,3103,'no','Total i gruppe',0),(111690,3103,'da','Samlede gruppe',0),(111691,3103,'ko','ê·¸ë£¹ì—ì„œ ì´',0),(111692,3103,'he','×¡×”\"×› ×‘×§×‘×•×¦×”',0),(111693,3103,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ ÏƒÏ„Î·Î½ Î¿Î¼Î¬Î´Î±',0),(111694,3103,'zh','ç»„å†…æ€»è®¡\r\n',0),(111695,3103,'sv','Totalt i gruppen',0),(111696,3103,'it','Totale nel gruppo',0),(111697,3103,'tl','',0),(111698,3103,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3651;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(111699,3103,'hi','à¤•à¥à¤² à¤¸à¤®à¥‚à¤¹',0),(111700,3103,'ms','Jumlah dalam Kumpulan',0),(111701,3103,'ar','Ù…Ø¬Ù…ÙˆØ¹ ÙÙŠ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(111702,3103,'fr','Total Groupe',0),(111703,3103,'jp','ã‚°ãƒ«ãƒ¼ãƒ—å†…ã?®ç·?é¡?',0),(111704,3103,'pt','Total no grupo',0),(111705,3103,'ru','Ð’ÑÐµÐ³Ð¾ Ð² Ð³Ñ€ÑƒÐ¿Ð¿Ðµ',0),(111706,3103,'es','Total en Grupo',0),(111707,3103,'de','Total Gruppe',0),(111708,3103,'en','Total in Group',0),(111709,3104,'is','',0),(111710,3104,'dr','(Ø¨Ù‡Ø±Ù‡',0),(111711,3104,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙˆØ¯ (Ø¨Ù‡Ø±Ù‡',0),(111712,3104,'tr','Toplam faiz',0),(111713,3104,'pl','CaÅ‚kowity odsetek',0),(111714,3104,'bg','ÐžÐ±Ñ‰ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(111715,3104,'ur','Ú©Ù„ Ø¯Ù„Ú†Ø³Ù¾ÛŒ',0),(111716,3104,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(111717,3104,'vi','Tá»•ng cá»™ng lÃ£i xuáº¥t',0),(111718,3104,'af','Totale Rente',0),(111719,3104,'ro','DobÃ¢ndÄƒ totalÄƒ',0),(111720,3104,'et','Intressid kokku',0),(111721,3104,'si','Skupaj obresti',0),(111722,3104,'ba','Bunga Total',0),(111723,3104,'nl','Totale rente',0),(111724,3104,'fi','Korko yhteensÃ¤',0),(111725,3104,'no','Totale renten',0),(111726,3104,'da','Samlede interesse',0),(111727,3104,'ko','ì´ ì´ìž',0),(111728,3104,'he','×¡×” ×› ×¨×™×‘×™×ª',0),(111729,3104,'el','Î£Î¥ÎÎŸÎ›ÎŸ Î¤ÎŸÎšÎ©Î',0),(111730,3104,'zh','æ€»åˆ©æ¯\r\n',0),(111731,3104,'sv','Totala intresse',0),(111732,3104,'it','Totale degli interessi',0),(111733,3104,'tl','',0),(111734,3104,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;',0),(111735,3104,'hi','à¤•à¥à¤² à¤¬à¥à¤¯à¤¾à¤œ',0),(111736,3104,'ms','Jumlah faedah',0),(111737,3104,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(111738,3104,'fr','Total des intÃ©rÃªts',0),(111739,3104,'jp','åˆ©å­?ç·?é¡?',0),(111740,3104,'pt','Total de juros',0),(111741,3104,'ru','ÐžÐ±Ñ‰Ð¸Ð¹ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(111742,3104,'es','InterÃ©s Total',0),(111743,3104,'de','Gesamtzinsen',0),(111744,3104,'en','Total Interest',0),(111745,3105,'is','',0),(111746,3105,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø¯Ù‡ÙŠ Ù‡Ø§',0),(111747,3105,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø¯Ù‡ÙŠ Ù‡Ø§',0),(111748,3105,'tr','TOPLAM BORÃ‡',0),(111749,3105,'pl','SUMA ZOBOWIÄ„ZAÅƒ',0),(111750,3105,'bg','ÐžÐ‘Ð©Ðž ÐŸÐÐ¡Ð˜Ð’Ð˜',0),(111751,3105,'ur','Ú©Ù„ Ø¯Ø§Ø±ÛŒÙˆÚº',0),(111752,3105,'sr','Ð£ÐšÐ£ÐŸÐÐ• ÐžÐ‘ÐÐ’Ð•Ð—Ð•',0),(111753,3105,'vi','Tá»•ng cá»™ng ná»£',0),(111754,3105,'af','TOTALE LASTE',0),(111755,3105,'ro','TOTAL PASIV',0),(111756,3105,'et','KOHUSTUSED KOKKU',0),(111757,3105,'si','SKUPAJ OBVEZNOSTI',0),(111758,3105,'ba','JUMLAH KEWAJIBAN',0),(111759,3105,'nl','TOTAAL PASSIVA',0),(111760,3105,'fi','VELAT YHTEENSÃ„',0),(111761,3105,'no','SUM FORPLIKTELSER',0),(111762,3105,'da','PASSIVER I ALT',0),(111763,3105,'ko','ì´ ë¶€ì±„',0),(111764,3105,'he','×”×”×¤×¨×©×” ×œ×—×•×ž ×¡',0),(111765,3105,'el','Î“Î•ÎÎ™ÎšÎŸ Î£Î¥ÎÎŸÎ›ÎŸ Î Î‘Î˜Î—Î¤Î™ÎšÎŸÎ¥',0),(111766,3105,'zh','æ€»è´Ÿå€º\r\n',0),(111767,3105,'sv','SUMMA SKULDER',0),(111768,3105,'it','TOTALE PASSIVITÃ€',0),(111769,3105,'tl','',0),(111770,3105,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3627;&#3609;&#3637;&#3657;&#3626;&#3636;&#3609;',0),(111771,3105,'hi','à¤•à¥à¤² à¤¦à¥‡à¤¯à¤¤à¤¾à¤à¤‚',0),(111772,3105,'ms','JUMLAH LIABILITI',0),(111773,3105,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø®ØµÙˆÙ…',0),(111774,3105,'fr','TOTAL DU PASSIF',0),(111775,3105,'jp','å‚µå‹™å?ˆè¨ˆ',0),(111776,3105,'pt','TOTAL DO PASSIVO',0),(111777,3105,'ru','ÐžÐ‘Ð©ÐÐ¯ Ð¡Ð£ÐœÐœÐ ÐŸÐÐ¡Ð¡Ð˜Ð’ÐžÐ’',0),(111778,3105,'es','TOTAL PASIVOS',0),(111779,3105,'de','SUMME DER PASSIVA',0),(111780,3105,'en','TOTAL LIABILITIES',0),(111781,3106,'is','',0),(111782,3106,'dr','Ù…Ø¬Ù…ÙˆØ¹ ØªØ®ÙÙŠÙØ§Øª Ù…Ø®ØªÙ„Ù ',0),(111783,3106,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªØ®ÙÙŠÙØ§Øª Ù…Ø®ØªÙ„Ù ',0),(111784,3106,'tr','Toplam Misc kesintiler',0),(111785,3106,'pl','CaÅ‚kowita rÃ³Å¼ne potrÄ…cenia',0),(111786,3106,'bg','ÐžÐ±Ñ‰Ð¾ Ð Ð°Ð·Ð½Ð¸ ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸',0),(111787,3106,'ur','Ú©Ù„ Ù…ØªÙØ±Ù‚ Ú©Ù¹ÙˆØªÛŒ',0),(111788,3106,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÐœÐ¸ÑÑ† Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ',0),(111789,3106,'vi','Tá»•ng cá»™ng giáº£m trá»« linh tinh',0),(111790,3106,'af','Totale Misc aftrekkings',0),(111791,3106,'ro','Total Misc deduceri',0),(111792,3106,'et','Kokku Varia mahaarvamised',0),(111793,3106,'si','Skupno Misc odbitki',0),(111794,3106,'ba','Pengurangan Total Misc',0),(111795,3106,'nl','Totale Misc inhoudingen',0),(111796,3106,'fi','YhteensÃ¤ Muut vÃ¤hennykset',0),(111797,3106,'no','Totalt diverse fradrag',0),(111798,3106,'da','Samlede Misc fradrag',0),(111799,3106,'ko','ì´ ê¸°íƒ€ ê³µì œ',0),(111800,3106,'he','Misc ×¡×š × ×™×›×•×™×™×',0),(111801,3106,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Misc ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½',0),(111802,3106,'zh','æ‚é¡¹æ‰£é™¤é¢åˆè®¡\r\n',0),(111803,3106,'sv','Totala Misc avdrag',0),(111804,3106,'it','Misc totale deduzioni',0),(111805,3106,'tl','',0),(111806,3106,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3627;&#3633;&#3585;&#3588;&#3656;&#3634;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;',0),(111807,3106,'hi','à¤•à¥à¤² à¤µà¤¿à¤µà¤¿à¤§ à¤•à¤Ÿà¥Œà¤¤à¤¿à¤¯à¤¾à¤‚',0),(111808,3106,'ms','Misc jumlah potongan',0),(111809,3106,'ar','Ù…ØªÙØ±Ù‚Ø§Øª Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø§Ø³ØªÙ‚Ø·Ø§Ø¹Ø§Øª',0),(111810,3106,'fr','DÃ©ductions totales Misc',0),(111811,3106,'jp','ã??ã?®ä»–æŽ§é™¤ã?®ç·?é¡?',0),(111812,3106,'pt','Misc total deduÃ§Ãµes',0),(111813,3106,'ru','Ð’ÑÐµÐ³Ð¾ ÐŸÑ€Ð¾Ñ‡Ð¸Ðµ Ð²Ñ‹Ñ‡ÐµÑ‚Ñ‹',0),(111814,3106,'es','Total Deducciones Misc.',0),(111815,3106,'de','Total Misc AbzÃ¼ge',0),(111816,3106,'en','Total Misc Deductions',0),(111817,3107,'is','',0),(111818,3107,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(111819,3107,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(111820,3107,'tr','Toplam fatura',0),(111821,3107,'pl','CaÅ‚kowita # faktur',0),(111822,3107,'bg','ÐžÐ±Ñ‰Ð¾ # Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(111823,3107,'ur','Ú©Ù„ # ÙˆØ¨Ø¬Ù„ÛŒ',0),(111824,3107,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° # Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(111825,3107,'vi','Tá»•ng cá»™ng sá»‘ hÃ³a Ä‘Æ¡n',0),(111826,3107,'af','Totaal # Fakture',0),(111827,3107,'ro','Total # facturi',0),(111828,3107,'et','Arvete # Kogusumma',0),(111829,3107,'si','Skupno # raÄunov',0),(111830,3107,'ba','Total # faktur',0),(111831,3107,'nl','Totaal aantal facturen',0),(111832,3107,'fi','YhteensÃ¤ # laskut',0),(111833,3107,'no','Totalt # fakturaer',0),(111834,3107,'da','Samlede # fakturaer',0),(111835,3107,'ko','ì´ # ì¸ë³´ì´ìŠ¤',0),(111836,3107,'he','# ×”×›×•×œ×œ ×—×©×‘×•× ×™×•×ª',0),(111837,3107,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ # Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(111838,3107,'zh','å…±æœ‰ï¼ƒå‘ç¥¨\r\n',0),(111839,3107,'sv','Totala # fakturor',0),(111840,3107,'it','# Totale fatture',0),(111841,3107,'tl','',0),(111842,3107,'th','&#3612;&#3621;&#3619;&#3623;&#3617; # &#3651;&#3610;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;',0),(111843,3107,'hi','à¤•à¥à¤² # à¤šà¤¾à¤²à¤¾à¤¨',0),(111844,3107,'ms','# Jumlah invois',0),(111845,3107,'ar','# Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(111846,3107,'fr','NB. total de factures',0),(111847,3107,'jp','è«‹æ±‚æ›¸ã?®ç·?æ•°',0),(111848,3107,'pt','N Âº total de faturas',0),(111849,3107,'ru','Ð’ÑÐµÐ³Ð¾ # Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(111850,3107,'es','Total # Facturas',0),(111851,3107,'de','Gesamtzahl Rechnungen',0),(111852,3107,'en','Total # Invoices',0),(111853,3108,'is','',0),(111854,3108,'dr','ÙƒÙ„ ØµÙØ­Ø§Øª ',0),(111855,3108,'pr','ÙƒÙ„ ØµÙØ­Ø§Øª ',0),(111856,3108,'tr','Toplam sayfa sayÄ±sÄ±',0),(111857,3108,'pl','CaÅ‚kowita liczba stron',0),(111858,3108,'bg','ÐžÐ±Ñ‰Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(111859,3108,'ur','Ú©Ù„ ØµÙØ­Ø§Øª',0),(111860,3108,'sr','Ð£ÐºÑƒÐ¿Ð°Ð½ Ð±Ñ€Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(111861,3108,'vi','Tá»•ng cá»™ng trang',0),(111862,3108,'af','Totale Bladsye',0),(111863,3108,'ro','Total pagini',0),(111864,3108,'et','LehekÃ¼lgede koguarv',0),(111865,3108,'si','Å tevilo strani',0),(111866,3108,'ba','Total Halaman',0),(111867,3108,'nl','Totaal aantal pagina \'s',0),(111868,3108,'fi','Sivuja yhteensÃ¤',0),(111869,3108,'no','Totalt sideantall',0),(111870,3108,'da','Samlede sider',0),(111871,3108,'ko','ì´ íŽ˜ì´ì§€',0),(111872,3108,'he','×¡×” ×› ×“×¤×™×',0),(111873,3108,'el','Î£ÏÎ½Î¿Î»Î¿ ÏƒÎµÎ»Î¯Î´Ï‰Î½',0),(111874,3108,'zh','æ€»é¡µæ•°\r\n',0),(111875,3108,'sv','Totalt sidor',0),(111876,3108,'it','Totale pagine',0),(111877,3108,'tl','',0),(111878,3108,'th','&#3627;&#3609;&#3657;&#3634;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(111879,3108,'hi','à¤•à¥à¤² à¤ªà¥ƒà¤·à¥à¤ ',0),(111880,3108,'ms','Jumlah muka surat',0),(111881,3108,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ØµÙØ­Ø§Øª',0),(111882,3108,'fr','Nombre total de Pages',0),(111883,3108,'jp','ç·?ãƒšãƒ¼ã‚¸',0),(111884,3108,'pt','Total de pÃ¡ginas',0),(111885,3108,'ru','Ð’ÑÐµÐ³Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†',0),(111886,3108,'es','Total PÃ¡ginas',0),(111887,3108,'de','Gesamtseiten',0),(111888,3108,'en','Total Pages',0),(111889,3109,'is','',0),(111890,3109,'dr','- Ø­Ø¯Ø§ÙƒØ«Ø± Ù…Ø¹Ø§Ø´ Ù†Ø§Ø®Ø§Ù„Øµ ÙØ±Ø§ØªØ± Ø§Ø³Øª ',0),(111891,3109,'pr','ÙƒÙ„ Ø­Ù‚ÙˆÙ‚ Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø­Ø¯Ø§ÙƒØ«Ø±- Ø­Ø¯Ø§ÙƒØ«Ø± Ø­Ù‚ÙˆÙ‚ Ù†Ø§Ø®Ø§Ù„Øµ ÙØ±Ø§ØªØ± Ø§Ø³Øª ',0),(111892,3109,'tr','Maksimum brÃ¼t maaÅŸ aÅŸÄ±ldÄ±',0),(111893,3109,'pl','Maksymalne wynagrodzenia brutto przekroczyÅ‚a',0),(111894,3109,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¾ Ð±Ñ€ÑƒÑ‚Ð½Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ²Ð¸ÑˆÐµÐ½Ð°',0),(111895,3109,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù…Ø¬Ù…ÙˆØ¹ÛŒ ØªÙ†Ø®ÙˆØ§Û Ø³Û’ Ù…ØªØ¬Ø§ÙˆØ²',0),(111896,3109,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð±Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ñ€ÐµÐ¼Ð°ÑˆÐ¸Ð¾',0),(111897,3109,'vi','VÆ°á»£t quÃ¡ má»©c thanh toÃ¡n gá»™p tá»‘i Ä‘a',0),(111898,3109,'af','Maksimum Bruto Besoldiging Oorskry',0),(111899,3109,'ro','Maxime Pay brut a depÄƒÅŸit',0),(111900,3109,'et','Ãœletanud maksimaalse brutopalk',0),(111901,3109,'si','NajviÅ¡je bruto plaÄe, preseÅ¾ene',0),(111902,3109,'ba','Gaji Bruto maksimum melebihi',0),(111903,3109,'nl','Maximale brutoloon overschreden',0),(111904,3109,'fi','Suurin bruttopalkasta ylitti',0),(111905,3109,'no','Maksimal bruttolÃ¸nn overskredet',0),(111906,3109,'da','Maksimale brutto lÃ¸n overskredet',0),(111907,3109,'ko','ìµœëŒ€ ì´ ì§€ë¶ˆ ì´ˆê³¼',0),(111908,3109,'he','×©×›×¨ ×‘×¨×•×˜×• ×ž×¨×‘×™ ×—×¨×™×’×”',0),(111909,3109,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Î±ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î· Î±Î¼Î¿Î¹Î²Î® Ï…Ï€Î­ÏÎ²Î±ÏƒÎ·',0),(111910,3109,'zh','è¶…å‡ºæœ€å¤§æ€»è–ªé…¬\r\n',0),(111911,3109,'sv','Maximal bruttolÃ¶n Ã¶verskrids',0),(111912,3109,'it','Paga lorda massima superata',0),(111913,3109,'tl','',0),(111914,3109,'th','&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3648;&#3585;&#3636;&#3609;&#3626;&#3641;&#3591;&#3585;&#3623;&#3656;&#3634;&#3607;&#3637;&#3656;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(111915,3109,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¤•à¤² à¤µà¥‡à¤¤à¤¨ à¤ªà¤¾à¤° à¤¹à¥‹ à¤—à¤ˆ',0),(111916,3109,'ms','Maksimum gaji kasar yang melebihi',0),(111917,3109,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø£Ù‚ØµÙ‰ ØªØ¬Ø§ÙˆØ²Øª',0),(111918,3109,'fr','RÃ©munÃ©ration brute maximale dÃ©passÃ©e',0),(111919,3109,'jp','æœ€å¤§çµ¦ä¸Žç·?é¡?ã‚’è¶…é?Žã?—ã?¾ã?—ã?Ÿ',0),(111920,3109,'pt','SalÃ¡rio bruto mÃ¡ximo excedido',0),(111921,3109,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð²Ð°Ð»Ð¾Ð²Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ñ€ÐµÐ²Ñ‹ÑÐ¸Ð»',0),(111922,3109,'es','Se ExcediÃ³ el Pago Bruto MÃ¡ximo',0),(111923,3109,'de','Maximale Bruttogehalt Ã¼berschritten',0),(111924,3109,'en','Maximum Gross Pay Exceeded',0),(111925,3110,'is','',0),(111926,3110,'dr','ÙƒÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(111927,3110,'pr','ÙƒÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(111928,3110,'tr','Toplam POs onayladÄ±',0),(111929,3110,'pl','CaÅ‚kowita POs zatwierdzone',0),(111930,3110,'bg','ÐžÐ±Ñ‰Ð¾ POs Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸',0),(111931,3110,'ur','Ú©Ù„ Ù¾ÙˆØ²ÛŒØ´Ù† Ù…ØªØ­Ø¯Û Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(111932,3110,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÐŸÐžÑ Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ð¾',0),(111933,3110,'vi','Tá»•ng cá»™ng Ä‘Æ¡n mua hÃ ng cháº¥p thuáº­n',0),(111934,3110,'af','Totale ANs Goedgekeur',0),(111935,3110,'ro','Total POs aprobat',0),(111936,3110,'et','Kokku POs heaks',0),(111937,3110,'si','Skupaj POs odobren',0),(111938,3110,'ba','Total POs yang disetujui',0),(111939,3110,'nl','Totale POs goedgekeurd',0),(111940,3110,'fi','YhteensÃ¤ POs hyvÃ¤ksytty',0),(111941,3110,'no','Totalt POs godkjent',0),(111942,3110,'da','Samlede POs godkendt',0),(111943,3110,'ko','ì´ ìˆœìœ„ ìŠ¹ì¸',0),(111944,3110,'he','×—×’ ×ž××•×©×¨',0),(111945,3110,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Î Î©Î£ ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯',0),(111946,3110,'zh','æ€»è®¡å·²å®¡æ‰¹çš„é‡‡è´­è®¢å•\r\n',0),(111947,3110,'sv','Totala POs godkÃ¤nd',0),(111948,3110,'it','Totale POs approvato',0),(111949,3110,'tl','',0),(111950,3110,'th','&#3592;&#3640;&#3604;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;&#3649;&#3621;&#3657;&#3623;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(111951,3110,'hi','à¤•à¥à¤² POs à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥€',0),(111952,3110,'ms','Jumlah POs yang diluluskan',0),(111953,3110,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ù…Ø¹ØªÙ…Ø¯Ø©',0),(111954,3110,'fr','Totales POs approuvÃ©s',0),(111955,3110,'jp','POå?ˆè¨ˆã‚’å?—é ˜',0),(111956,3110,'pt','POs totais aprovados',0),(111957,3110,'ru','Ð’ÑÐµÐ³Ð¾ POs Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ð»',0),(111958,3110,'es','Total OCs Aprobados',0),(111959,3110,'de','Insgesamt POs genehmigt',0),(111960,3110,'en','Total POs Approved',0),(111961,3111,'is','',0),(111962,3111,'dr','Ù‚ÙŠÙ…Øª ÙƒÙ„',0),(111963,3111,'pr','Ù‚ÙŠÙ…Øª ÙƒÙ„',0),(111964,3111,'tr','Toplam fiyat',0),(111965,3111,'pl','CaÅ‚kowita cena',0),(111966,3111,'bg','ÐžÐ±Ñ‰Ð° Ñ†ÐµÐ½Ð°',0),(111967,3111,'ur','Ú©Ù„ Ù‚ÛŒÙ…Øª',0),(111968,3111,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ñ†ÐµÐ½Ð°',0),(111969,3111,'vi','Tá»•ng cá»™ng giÃ¡',0),(111970,3111,'af','Totale Prys',0),(111971,3111,'ro','PreÅ£ total',0),(111972,3111,'et','Hind kokku',0),(111973,3111,'si','Skupna cena',0),(111974,3111,'ba','Total harga',0),(111975,3111,'nl','Totaalprijs',0),(111976,3111,'fi','Kokonaishinta',0),(111977,3111,'no','SalgsbelÃ¸p',0),(111978,3111,'da','Samlet pris',0),(111979,3111,'ko','ì´ ê°€ê²©',0),(111980,3111,'he','×¡×”',0),(111981,3111,'el','Î£Ï…Î½.Ï„Î¹Î¼Î®',0),(111982,3111,'zh','æ€»ä»·æ ¼\r\n',0),(111983,3111,'sv','Totalpris',0),(111984,3111,'it','Prezzo totale',0),(111985,3111,'tl','',0),(111986,3111,'th','&#3619;&#3634;&#3588;&#3634;&#3619;&#3623;&#3617;',0),(111987,3111,'hi','à¤•à¥à¤² à¤®à¥‚à¤²à¥à¤¯',0),(111988,3111,'ms','Jumlah harga',0),(111989,3111,'ar','Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(111990,3111,'fr','Prix total',0),(111991,3111,'jp','ç·?é¡?',0),(111992,3111,'pt','PreÃ§o total',0),(111993,3111,'ru','ÐžÐ±Ñ‰Ð°Ñ Ñ†ÐµÐ½Ð°',0),(111994,3111,'es','Total Precio',0),(111995,3111,'de','Gesamtpreis',0),(111996,3111,'en','Total Price',0),(111997,3112,'is','',0),(111998,3112,'dr',': Ø¨ÛŒÙ„Ø§Ù†Ø³ Ø¨ÛŒØ¬Ú© Ù…ÙˆØ¬ÙˆØ¯ Ø®Ø±ÙŠØ¯Ø§Ø± Ø§ÙƒÙ†ÙˆÙ† Ø¨ÙŠØ´ Ø§Ø² Ø­Ø¯ Ø§Ø¹ØªØ¨Ø§Ø± Ø¢Ù†Ù‡Ø§ Ø§Ø³Øª ',0),(111999,3112,'pr','Ù‚ÙŠÙ…Øª ÙƒÙ„ Ø§Ø² Ø­Ø¯ Ø§Ø¹ØªØ¨Ø§Ø± Ø®Ø±ÙŠØ¯Ø§Ø± ÙØ±Ø§ØªØ± Ø§Ø³Øª â€“ Ø§Ø®Ø·Ø§Ø±: Ù…Ø§Ù†Ø¯Ù‡ ÙØ§ÙƒØªÙˆØ± Ù…ÙˆØ¬ÙˆØ¯ Ø®Ø±ÙŠØ¯Ø§Ø± Ø§ÙƒÙ†ÙˆÙ† Ø¨ÙŠØ´ Ø§Ø² Ø­Ø¯ Ø§Ø¹ØªØ¨Ø§Ø± Ø¢Ù†Ù‡Ø§ Ø§Ø³Øª ',0),(112000,3112,'tr','UyarÄ±: MÃ¼ÅŸterinin mevcut fatura Balance(s)<br>Åžimdi, kredi sÄ±nÄ±rlarÄ±nÄ± aÅŸan',0),(112001,3112,'pl','OstrzeÅ¼enie: Klienta istniejÄ…cych faktury saldo systemu<br>Teraz przekroczyli Limit kredytu z',0),(112002,3112,'bg','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ: ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Balance(s)<br>Ð¡ÐµÐ³Ð° Ð½Ð°Ð´Ð²Ð¸ÑˆÐ°Ð²Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸Ñ Ð»Ð¸Ð¼Ð¸Ñ‚ Ð½Ð°',0),(112003,3112,'ur','ØªÙ†Ø¨ÛŒÛ: Ú¯Ø§ÛÚ© Ú©Û’ Ù…ÙˆØ¬ÙˆØ¯Û Ø§Ù†ÙˆØ§Ø¦Ø³ Balance(s)<br>Ø§Ø¨ Ø§Ù† Ú©ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ø­Ø¯ Ø³Û’ ØªØ¬Ø§ÙˆØ²',0),(112004,3112,'sr','Ð£Ð¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ : Ð‘Ð°Ð»Ð°Ð½Ñ†Ðµ(Ñ) Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÑƒÐ¿Ñ†Ð° Ð·Ð° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ<br>Ð¡Ð°Ð´Ð° Ð¿Ñ€ÐµÐ¼Ð°ÑˆÑƒÑ˜Ñƒ ÑšÐ¸Ñ…Ð¾Ð² ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð›Ð¸Ð¼Ð¸Ñ‚ Ð¾Ð´',0),(112005,3112,'vi','Cáº£nh bÃ¡o: HÃ³a ÄÆ¡n Cá»§a KhÃ¡ch HÃ ng (s)hiá»‡n táº¡i cao hÆ¡n háº¡n má»©c tÃ­n dá»¥ng cá»§a há» lÃ  ',0),(112006,3112,'af','Waarskuwing: Klant / KliÃ«nt se Bestaande Faktuurbalans(e)<br>Oorskry Nou Hul Kredietlimiet van',0),(112007,3112,'ro','Avertisment: Client existente facturÄƒ Balance(s)<br>Acum sÄƒ depÄƒÅŸeascÄƒ limita de Credit de a lor',0),(112008,3112,'et','Hoiatus: Kliendi olemasolevad arve Balance(s)<br>NÃ¼Ã¼d Ã¼letaks oma krediidilimiiti',0),(112009,3112,'si','Opozorilo: Kupca obstojeÄi raÄun Balance(s)<br>Zdaj preseÅ¾e svoj kreditni Limit za',0),(112010,3112,'ba','Peringatan: Pelanggan yang sudah ada faktur Balance(s)<br>Sekarang melebihi batas kredit mereka',0),(112011,3112,'nl','Waarschuwing: Klant bestaande factuur Balance(s)<br>Nu groter zijn dan hun kredietlimiet van',0),(112012,3112,'fi','Varoitus: Asiakkaan olemassa laskun Balance(s)<br>Nyt yli niiden luottoraja',0),(112013,3112,'no','Advarsel: Kundens eksisterende faktura Balance(s)<br>NÃ¥ overstige sin kredittgrense av',0),(112014,3112,'da','Advarsel: Kundens eksisterende faktura Balance(s)<br>Nu, der overskride deres kredit',0),(112015,3112,'ko','ê²½ê³ : ê³ ê°ì˜ ê¸°ì¡´ ì†¡ìž¥ Balance(s)<br>ì§€ê¸ˆì˜ ê·¸ë“¤ì˜ ì‹ ìš© í•œë„ ì´ˆê³¼',0),(112016,3112,'he','××–×”×¨×”: ×”×§×™×™×ž×™× ×—×©×‘×•× ×™×ª Balance(s) ×”×œ×§×•×—<br>×¢×›×©×™×• ×—×•×¨×’ ×ž×ž×’×‘×œ×ª ×”××©×¨××™ ×©×œ',0),(112017,3112,'el','Î ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·: Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· Balance(s)<br>Î¤ÏŽÏÎ± Ï…Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ Ï„Î¿Ï…Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ ÏŒÏÎ¹Î¿ Ï„Î·Ï‚',0),(112018,3112,'zh','è­¦å‘Šï¼šå®¢æˆ·çŽ°æœ‰çš„å‘ç¥¨ä½™é¢ï¼ˆsï¼‰çŽ°åœ¨è¶…è¿‡å…¶ä¿¡ç”¨æžé™\r\n',0),(112019,3112,'sv','Varning: Kundens befintliga faktura Balance(s)<br>Nu Ã¶verstiger deras kreditgrÃ¤ns pÃ¥',0),(112020,3112,'it','Attenzione: Esistente fattura Balance(s) cliente<br>Ora superare il loro limite di credito del',0),(112021,3112,'tl','',0),(112022,3112,'th','Warning: Customer\'s Existing Invoice Balance(s)<br>Now Exceed Their Credit Limit of',0),(112023,3112,'hi','à¤šà¥‡à¤¤à¤¾à¤µà¤¨à¥€: à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ Balance(s)<br>à¤…à¤¬ à¤…à¤ªà¤¨à¥€ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¸à¥€à¤®à¤¾ à¤•à¥‡ à¤ªà¤¾à¤°',0),(112024,3112,'ms','Amaran: Pelanggan sedia ada invois hadapan<br>Kini melebihi had kredit mereka',0),(112025,3112,'ar','ØªØ­Ø°ÙŠØ±: Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø© Balance(s) Ø§Ù„Ø²Ø¨ÙˆÙ†<br>Ø§Ù„Ø¢Ù† ØªØ¬Ø§ÙˆØ² Ø­Ø¯ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù…Ù†',0),(112026,3112,'fr','AVERTISSEMENT : Existant facture solde du client<br>Maintenant dÃ©passer leur limite de crÃ©dit de',0),(112027,3112,'jp','è­¦å‘Šï¼šé¡§å®¢ã?®å­˜åœ¨ã?™ã‚‹è«‹æ±‚æ›¸ã?®é‡‘é¡?ã?Œè²¸ä»˜é‡‘é¡?ã?®é™?åº¦ã‚’è¶…ã?ˆã?¾ã?—ã?Ÿ',0),(112028,3112,'pt','Aviso: Existentes fatura Balance(s) do cliente<br>Agora exceder seu limite de crÃ©dito de',0),(112029,3112,'ru','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ: ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° Ð±Ð°Ð»Ð°Ð½Ñ(Ñ‹)<br>Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð¿Ñ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ Ð¸Ñ… ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¹ Ð»Ð¸Ð¼Ð¸Ñ‚',0),(112030,3112,'es','Aviso: Balance(s) Existentes de Facturas de Cliente(s)<br>Ahora Excede Su Limite de CrÃ©dito de',0),(112031,3112,'de','Achtung: Kunden bestehenden Rechnung Balance(s)<br>Jetzt ihr Kreditlimit Ã¼berschreiten',0),(112032,3112,'en','Warning: Customer\'s Existing Invoice Balance(s)<br>Now Exceed Their Credit Limit of',0),(112033,3113,'is','',0),(112034,3113,'dr','(Ø¹Ø¯Ù… Ù¾Ø±Ø¯Ø§Ø®Øª',0),(112035,3113,'pr','Ù¾Ø´ ÙØ±Ø¶ ÙƒÙ„ Ø­Ù‚ÙˆÙ‚ (Ø¹Ø¯Ù… Ù¾Ø±Ø¯Ø§Ø®Øª',0),(112036,3113,'tr','Toplam varsayÄ±lan<br>(Salaried iÃ§in)',0),(112037,3113,'pl','CaÅ‚kowita domyÅ›lne<br>(dla Salaried)',0),(112038,3113,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ<br>(Ð·Ð° Salaried)',0),(112039,3113,'ur','Ú©Ù„ Ø·Û’ Ø´Ø¯Û<br>(Ø³Ø§Ù„Ø¢Ø±ÛŒØ¯ Ú©Û’ Ù„Ø¦Û’)',0),(112040,3113,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸<br>(Ð·Ð° Ð¡Ð°Ð»Ð°Ñ€Ð¸ÐµÐ´)',0),(112041,3113,'vi','Tá»•ng cá»™ng máº·c Ä‘á»‹nh(cho lÆ°Æ¡ng)',0),(112042,3113,'af','Totaal Verstek<br>(vir Gesalarieerde)',0),(112043,3113,'ro','Total implicit<br>(pentru Salaried)',0),(112044,3113,'et','Kokku vaikimisi<br>(for Salaried)',0),(112045,3113,'si','Skupno privzeto<br>(za Salaried)',0),(112046,3113,'ba','Total Default<br>(untuk Salaried)',0),(112047,3113,'nl','Totale standaard<br>(voor Salaried)',0),(112048,3113,'fi','YhteensÃ¤ oletus<br>(ja Salaried)',0),(112049,3113,'no','Totalt standard<br>(for lÃ¸nnsbasert)',0),(112050,3113,'da','Samlede standard<br>(for Salaried)',0),(112051,3113,'ko','ì´ ê¸°ë³¸<br>(Salaried)ì— ëŒ€ í•œ',0),(112052,3113,'he','×¡×” ×› ×‘×¨×™×¨×ª ×ž×—×“×œ<br>(×¢×‘×•×¨ Salaried)',0),(112053,3113,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î®<br>(Î³Î¹Î± Salaried)',0),(112054,3113,'zh','æ€»è®¡é»˜è®¤å€¼ï¼ˆå—è–ªï¼‰\r\n',0),(112055,3113,'sv','Totala standard<br>(fÃ¶r Salaried)',0),(112056,3113,'it','Totale predefinita<br>(per stipendiato)',0),(112057,3113,'tl','',0),(112058,3113,'th','&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;<br>(&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;)',0),(112059,3113,'hi','à¤•à¥à¤² à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ<br>(Salaried à¤•à¥‡ à¤²à¤¿à¤)',0),(112060,3113,'ms','Jumlah lalai<br>(untuk Salaried)',0),(112061,3113,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ<br>(Ù„Ø£Ø¬ÙŠØ±)',0),(112062,3113,'fr','Total par dÃ©faut<br>(pour les salariÃ©s)',0),(112063,3113,'jp','Total Default<br>(for Salaried)',0),(112064,3113,'pt','PadrÃ£o total<br>(para assalariado)',0),(112065,3113,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ<br>(Ð´Ð»Ñ Ð½Ð°ÐµÐ¼Ð½Ñ‹Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¸)',0),(112066,3113,'es','Total Predeerminado<br>(para Salariados)',0),(112067,3113,'de','Gesamt Standard<br>(fÃ¼r Angestellte)',0),(112068,3113,'en','Total Default<br>(for Salaried)',0),(112069,3114,'is','',0),(112070,3114,'dr','ÙƒÙ„ ÙØ±ÙˆØ´',0),(112071,3114,'pr','ÙƒÙ„ ÙØ±ÙˆØ´',0),(112072,3114,'tr','Toplam satÄ±ÅŸ',0),(112073,3114,'pl','Wielka wyprzedaÅ¼',0),(112074,3114,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(112075,3114,'ur','Ú©Ù„ ÙØ±ÙˆØ®Øª',0),(112076,3114,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð°',0),(112077,3114,'vi','Tá»•ng cá»™ng doanh sá»‘',0),(112078,3114,'af','Verkope Totaal',0),(112079,3114,'ro','VÃ¢nzarea totalÄƒ',0),(112080,3114,'et','MÃ¼Ã¼gile kokku',0),(112081,3114,'si','Totalna Razprodaja',0),(112082,3114,'ba','Total penjualan',0),(112083,3114,'nl','Totale verkoop',0),(112084,3114,'fi','Kokonaismyynti',0),(112085,3114,'no','Totalt salg',0),(112086,3114,'da','Samlede salg',0),(112087,3114,'ko','ì´ íŒë§¤',0),(112088,3114,'he','×œ×ž×›×™×¨×” ×¡×”',0),(112089,3114,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® Ï€ÏŽÎ»Î·ÏƒÎ·',0),(112090,3114,'zh','æ€»é”€å”®\r\n',0),(112091,3114,'sv','Totala fÃ¶rsÃ¤ljning',0),(112092,3114,'it','Vendita totale',0),(112093,3114,'tl','',0),(112094,3114,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(112095,3114,'hi','à¤•à¥à¤² à¤¬à¤¿à¤•à¥à¤°à¥€',0),(112096,3114,'ms','Jumlah jualan',0),(112097,3114,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(112098,3114,'fr','Total de la vente',0),(112099,3114,'jp','å£²ä¸Šå?ˆè¨ˆ',0),(112100,3114,'pt','Venda total',0),(112101,3114,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(112102,3114,'es','Venta Total',0),(112103,3114,'de','Total Verkauf',0),(112104,3114,'en','Total Sale',0),(112105,3115,'is','',0),(112106,3115,'dr','(Ø­Ø±Ø§Ø¬ Ù‡Ø§',0),(112107,3115,'pr','ÙƒÙ„ ÙØ±ÙˆØ´ Ù‡Ø§(Ø­Ø±Ø§Ø¬ Ù‡Ø§',0),(112108,3115,'tr','Toplam satÄ±ÅŸ',0),(112109,3115,'pl','CaÅ‚kowita sprzedaÅ¼',0),(112110,3115,'bg','ÐžÐ±Ñ‰Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(112111,3115,'ur','Ú©Ù„ ÙØ±ÙˆØ®Øª',0),(112112,3115,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð°',0),(112113,3115,'vi','Tá»•ng cá»™ng doanh sá»‘',0),(112114,3115,'af','Totale Verkope ',0),(112115,3115,'ro','VÃ¢nzÄƒrile totale',0),(112116,3115,'et','KÃµik mÃ¼Ã¼gid',0),(112117,3115,'si','Celotne prodaje',0),(112118,3115,'ba','Total penjualan',0),(112119,3115,'nl','Totale verkoop',0),(112120,3115,'fi','Kokonaismyynti',0),(112121,3115,'no','Totalt salg',0),(112122,3115,'da','Samlede salg',0),(112123,3115,'ko','ì´ ë§¤ì¶œ',0),(112124,3115,'he','×¡×š ×›×œ ×”×ž×›×™×¨×•×ª',0),(112125,3115,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ­Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(112126,3115,'zh','é”€å”®æ€»é¢\r\n',0),(112127,3115,'sv','Total fÃ¶rsÃ¤ljning',0),(112128,3115,'it','Vendite totali',0),(112129,3115,'tl','',0),(112130,3115,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(112131,3115,'hi','à¤•à¥à¤² à¤¬à¤¿à¤•à¥à¤°à¥€',0),(112132,3115,'ms','Jumlah jualan',0),(112133,3115,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(112134,3115,'fr','Total des ventes',0),(112135,3115,'jp','å£²ã‚Šä¸Šã?’å?ˆè¨ˆ',0),(112136,3115,'pt','Vendas totais',0),(112137,3115,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(112138,3115,'es','Ventas Totales',0),(112139,3115,'de','Gesamtumsatz',0),(112140,3115,'en','Total Sales',0),(112141,3116,'is','',0),(112142,3116,'dr','ÙƒÙ„ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(112143,3116,'pr','ÙƒÙ„ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(112144,3116,'tr','Toplam Ã¼cretler',0),(112145,3116,'pl','ÅÄ…cznej wartoÅ›ci wynagrodzeÅ„',0),(112146,3116,'bg','ÐžÐ±Ñ‰Ð¾ Ð½Ð°Ð´Ð½Ð¸Ñ†Ð¸',0),(112147,3116,'ur','Ú©Ù„ Ù…Ø²Ø¯ÙˆØ±ÛŒ',0),(112148,3116,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð·Ð°Ñ€Ð°Ð´Ð°',0),(112149,3116,'vi','Tá»•ng cá»™ng lÆ°Æ¡ng',0),(112150,3116,'af','Totale Besoldiging',0),(112151,3116,'ro','Total salarii',0),(112152,3116,'et','TÃ¶Ã¶tasude kogusumma',0),(112153,3116,'si','Celotne plaÄe',0),(112154,3116,'ba','Total upah',0),(112155,3116,'nl','Totaal lonen',0),(112156,3116,'fi','Palkkojen kokonaismÃ¤Ã¤rÃ¤',0),(112157,3116,'no','Samlet lÃ¸nn',0),(112158,3116,'da','Samlede lÃ¸n',0),(112159,3116,'ko','ì´ ìž„ê¸ˆ',0),(112160,3116,'he','×©×›×¨ ×”×›×•×œ×œ',0),(112161,3116,'el','Î£ÏÎ½Î¿Î»Î¿ Ï„Ï‰Î½ Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(112162,3116,'zh','å·¥èµ„æ€»é¢\r\n',0),(112163,3116,'sv','Totala lÃ¶ner',0),(112164,3116,'it','Totali salari',0),(112165,3116,'tl','',0),(112166,3116,'th','&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(112167,3116,'hi','à¤•à¥à¤² à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(112168,3116,'ms','Jumlah upah',0),(112169,3116,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø£Ø¬ÙˆØ±',0),(112170,3116,'fr','Total des salaires',0),(112171,3116,'jp','è³ƒé‡‘å?ˆè¨ˆ',0),(112172,3116,'pt','Total de salÃ¡rios',0),(112173,3116,'ru','Ð’ÑÐµÐ³Ð¾ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(112174,3116,'es','Sueldos Totales',0),(112175,3116,'de','Lohnsumme',0),(112176,3116,'en','Total Wages',0),(112177,3117,'is','',0),(112178,3117,'dr','Ø¬Ù…Ø¹ ÙƒØ±Ø¯Ù†',0),(112179,3117,'pr','Ø¬Ù…Ø¹ ÙƒØ±Ø¯Ù†',0),(112180,3117,'tr','Toplam alma',0),(112181,3117,'pl','Sumowanie',0),(112182,3117,'bg','Ð¡ÑƒÐ¼Ð¸Ñ€Ð°Ð½Ðµ',0),(112183,3117,'ur','Ú©Û’ ÙØ§ØµÙ„Û’',0),(112184,3117,'sr','Ð¡Ð°Ð±Ð¸Ñ€Ð°ÑšÐµ',0),(112185,3117,'vi','tá»•ng cá»™ng',0),(112186,3117,'af','in totaal',0),(112187,3117,'ro','valoare totalÄƒ de',0),(112188,3117,'et','summeerimine',0),(112189,3117,'si','seÅ¡tevanje',0),(112190,3117,'ba','senilai',0),(112191,3117,'nl','totaal',0),(112192,3117,'fi','yhteensÃ¤',0),(112193,3117,'no','Totalt',0),(112194,3117,'da','sammentÃ¦lling',0),(112195,3117,'ko','ì´',0),(112196,3117,'he','×‘×”×™×§×£',0),(112197,3117,'el','ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¿Ï ÏÏˆÎ¿Ï…Ï‚',0),(112198,3117,'zh','å…±è®¡\r\n',0),(112199,3117,'sv','totalt',0),(112200,3117,'it','per un totale di',0),(112201,3117,'tl','',0),(112202,3117,'th','&#3619;&#3623;&#3617;',0),(112203,3117,'hi','totaling',0),(112204,3117,'ms','berjumlah',0),(112205,3117,'ar','Ø¨Ù„Øº Ù…Ø¬Ù…ÙˆØ¹Ù‡Ø§',0),(112206,3117,'fr','pour un total de',0),(112207,3117,'jp','ç·?è¨ˆ',0),(112208,3117,'pt','totalizando',0),(112209,3117,'ru','Ð½Ð° Ð¾Ð±Ñ‰ÑƒÑŽ ÑÑƒÐ¼Ð¼Ñƒ',0),(112210,3117,'es','totalizando',0),(112211,3117,'de','in HÃ¶he von',0),(112212,3117,'en','totaling',0),(112213,3118,'is','',0),(112214,3118,'dr','Ù…Ø¬Ù…ÙˆØ¹ ',0),(112215,3118,'pr','Ù…Ø¬Ù…ÙˆØ¹ ',0),(112216,3118,'tr','ToplamlarÄ±',0),(112217,3118,'pl','Sumy',0),(112218,3118,'bg','ÐžÐ±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸',0),(112219,3118,'ur','Ù…ÛŒØ²Ø§Ù†',0),(112220,3118,'sr','Ð¡Ð°Ð±Ð¸Ñ€Ð°ÑšÐµ',0),(112221,3118,'vi','Tá»•ng cá»™ng',0),(112222,3118,'af','Totale',0),(112223,3118,'ro','Totaluri',0),(112224,3118,'et','KokkuvÃµtted',0),(112225,3118,'si','Vsote',0),(112226,3118,'ba','Total',0),(112227,3118,'nl','Totalen',0),(112228,3118,'fi','YhteensÃ¤',0),(112229,3118,'no','Totaler',0),(112230,3118,'da','Totaler',0),(112231,3118,'ko','í•©ê³„',0),(112232,3118,'he','×¡×”\"×›',0),(112233,3118,'el','Î£ÏÎ½Î¿Î»Î±',0),(112234,3118,'zh','æ€»è®¡\r\n',0),(112235,3118,'sv','Summor',0),(112236,3118,'it','Totali',0),(112237,3118,'tl','',0),(112238,3118,'th','&#3619;&#3623;&#3617;',0),(112239,3118,'hi','à¤¯à¥‹à¤—',0),(112240,3118,'ms','Jumlah',0),(112241,3118,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹',0),(112242,3118,'fr','Totaux',0),(112243,3118,'jp','å?ˆè¨ˆ',0),(112244,3118,'pt','Totais',0),(112245,3118,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸',0),(112246,3118,'es','Totales',0),(112247,3118,'de','Summen',0),(112248,3118,'en','Totals',0),(112249,3119,'is','',0),(112250,3119,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ',0),(112251,3119,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ',0),(112252,3119,'tr','ToplamlarÄ±',0),(112253,3119,'pl','Sumy',0),(112254,3119,'bg','ÐžÐ±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸ Ð·Ð°',0),(112255,3119,'ur','Ù…ÛŒØ²Ø§Ù† Ú©Û’ Ù„Ø¦Û’',0),(112256,3119,'sr','Ð—Ð±Ð¸Ñ€Ð¾Ð²Ð¸ Ð·Ð°',0),(112257,3119,'vi','Tá»•ng cá»™ng cho',0),(112258,3119,'af','Totale vir',0),(112259,3119,'ro','Totaluri pentru',0),(112260,3119,'et','Kogusummad',0),(112261,3119,'si','Vsote za',0),(112262,3119,'ba','Total untuk',0),(112263,3119,'nl','Totalen voor',0),(112264,3119,'fi','Kokonaissummat',0),(112265,3119,'no','Totalene for',0),(112266,3119,'da','Totaler for',0),(112267,3119,'ko','ì— ëŒ€ í•œ',0),(112268,3119,'he','×¡×”\"×› ×¢×‘×•×¨',0),(112269,3119,'el','Î£ÏÎ½Î¿Î»Î± Î³Î¹Î±',0),(112270,3119,'zh','æ€»è®¡\r\n',0),(112271,3119,'sv','Summor fÃ¶r',0),(112272,3119,'it','Totali per',0),(112273,3119,'tl','',0),(112274,3119,'th','&#3619;&#3623;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(112275,3119,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‹à¤—',0),(112276,3119,'ms','Jumlah bagi',0),(112277,3119,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª',0),(112278,3119,'fr','Totaux pour',0),(112279,3119,'jp','ï½žã?®å?ˆè¨ˆ',0),(112280,3119,'pt','Totais de',0),(112281,3119,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ Ð´Ð»Ñ',0),(112282,3119,'es','Totales para',0),(112283,3119,'de','Summen fÃ¼r',0),(112284,3119,'en','Totals for',0),(112285,3120,'is','',0),(112286,3120,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨ ',0),(112287,3120,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨ ',0),(112288,3120,'tr','Hesap iÃ§in toplamlarÄ±',0),(112289,3120,'pl','Sumy na konto',0),(112290,3120,'bg','Ð¡ÑƒÐ¼Ð¸ Ð¿Ð¾ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(112291,3120,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù„Ø¦Û’ Ù…ÛŒØ²Ø§Ù†',0),(112292,3120,'sr','Ð—Ð±Ð¸Ñ€Ð¾Ð²Ð¸ Ð·Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(112293,3120,'vi','Tá»•ng sá»‘ cho TK',0),(112294,3120,'af','Totale vir rekening',0),(112295,3120,'ro','Totaluri pentru cont',0),(112296,3120,'et','Konto kogusummade',0),(112297,3120,'si','Vsote raÄuna',0),(112298,3120,'ba','Total untuk account',0),(112299,3120,'nl','Totalen voor account',0),(112300,3120,'fi','Tilin summat',0),(112301,3120,'no','Totalene for konto',0),(112302,3120,'da','Totaler for konto',0),(112303,3120,'ko','ê³„ì •ì— ëŒ€ í•œ í•©ê³„',0),(112304,3120,'he','×¡×›×•×ž×™× ×¢×‘×•×¨ ×—×©×‘×•×Ÿ',0),(112305,3120,'el','Î£ÏÎ½Î¿Î»Î± Î³Î¹Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(112306,3120,'zh','æ€»è®¡å¸æˆ·\r\n',0),(112307,3120,'sv','Summor fÃ¶r konto',0),(112308,3120,'it','Totali per conto',0),(112309,3120,'tl','',0),(112310,3120,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(112311,3120,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‹à¤—',0),(112312,3120,'ms','Jumlah akaun',0),(112313,3120,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ù„Ø­Ø³Ø§Ø¨',0),(112314,3120,'fr','Totaux pour le compte',0),(112315,3120,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®å?ˆè¨ˆ',0),(112316,3120,'pt','Totais por conta',0),(112317,3120,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ Ð´Ð»Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(112318,3120,'es','Totales para cuenta',0),(112319,3120,'de','Summen fÃ¼r Konto',0),(112320,3120,'en','Totals for account',0),(112321,3121,'is','',0),(112322,3121,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ØªØ§Ø±ÙŠØ® ',0),(112323,3121,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ØªØ§Ø±ÙŠØ® ',0),(112324,3121,'tr','Tarih toplamlarÄ±',0),(112325,3121,'pl','Sumy dla daty',0),(112326,3121,'bg','ÐžÐ±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸ Ð·Ð° Ð´Ð°Ñ‚Ð°',0),(112327,3121,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ù…ÛŒØ²Ø§Ù†',0),(112328,3121,'sr','Ð£ÐºÑƒÐ¿Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð´Ð°Ñ‚ÑƒÐ¼',0),(112329,3121,'vi','Tá»•ng cá»™ng cho ngÃ y',0),(112330,3121,'af','Totale vir datum',0),(112331,3121,'ro','Totaluri pentru data',0),(112332,3121,'et','KuupÃ¤eva summad',0),(112333,3121,'si','Vsote za datum',0),(112334,3121,'ba','Total untuk tanggal',0),(112335,3121,'nl','Totalen voor datum',0),(112336,3121,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n summat',0),(112337,3121,'no','Totalene for dato',0),(112338,3121,'da','Totaler for dato',0),(112339,3121,'ko','ë‚ ì§œì— ëŒ€ í•œ',0),(112340,3121,'he','×¡×›×•×ž×™× ×¢×‘×•×¨ ×ª××¨×™×š',0),(112341,3121,'el','Î£ÏÎ½Î¿Î»Î± Î³Î¹Î± Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(112342,3121,'zh','æ±‡æ€»çš„æ—¥æœŸ\r\n',0),(112343,3121,'sv','Summor fÃ¶r datum',0),(112344,3121,'it','Totali per data',0),(112345,3121,'tl','',0),(112346,3121,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(112347,3121,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‹à¤—',0),(112348,3121,'ms','Jumlah untuk tarikh',0),(112349,3121,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ù„Ù„ØªØ§Ø±ÙŠØ®',0),(112350,3121,'fr','Totaux pour la date',0),(112351,3121,'jp','ã?“ã?®æ—¥ä»˜ã?®å?ˆè¨ˆ',0),(112352,3121,'pt','Totais por data',0),(112353,3121,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ Ð´Ð»Ñ Ð´Ð°Ñ‚Ñ‹',0),(112354,3121,'es','Totales para la Fecha',0),(112355,3121,'de','Summen fÃ¼r Datum',0),(112356,3121,'en','Totals for date',0),(112357,3122,'is','',0),(112358,3122,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ø§Ø² ',0),(112359,3122,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ø§Ø² ',0),(112360,3122,'tr','Tarih toplamlarÄ±',0),(112361,3122,'pl','Sumy dla daty',0),(112362,3122,'bg','ÐžÐ±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸ Ð·Ð° Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð°',0),(112363,3122,'ur','Ù…ÛŒØ²Ø§Ù† Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Û’ Ù„Ø¦Û’',0),(112364,3122,'sr','Ð£ÐºÑƒÐ¿Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð´Ð°Ñ‚ÑƒÐ¼ Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐ°',0),(112365,3122,'vi','Tá»•ng cá»™ng cho ngÃ y cá»§a',0),(112366,3122,'af','Totale vir die datum van',0),(112367,3122,'ro','Totaluri pentru data',0),(112368,3122,'et','KuupÃ¤eva summad',0),(112369,3122,'si','Vsote za datum',0),(112370,3122,'ba','Total untuk tanggal',0),(112371,3122,'nl','Totalen voor de datum van',0),(112372,3122,'fi','Kokonaissummat pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(112373,3122,'no','Totalene for datoen for',0),(112374,3122,'da','Totaler for datoen for',0),(112375,3122,'ko','ë‚ ì§œì— ëŒ€ í•œ',0),(112376,3122,'he','×¡×›×•×ž×™× ×¢×‘×•×¨ ×ª××¨×™×š',0),(112377,3122,'el','Î£ÏÎ½Î¿Î»Î± Î³Î¹Î± Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(112378,3122,'zh','æ±‡æ€»çš„æ—¥æœŸ\r\n',0),(112379,3122,'sv','Summor fÃ¶r dagen fÃ¶r',0),(112380,3122,'it','Totali per la data di',0),(112381,3122,'tl','',0),(112382,3122,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3586;&#3629;&#3591;',0),(112383,3122,'hi','à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‹à¤—',0),(112384,3122,'ms','Jumlah bagi tarikh',0),(112385,3122,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ù„ØªØ§Ø±ÙŠØ®',0),(112386,3122,'fr','Totaux pour la date de',0),(112387,3122,'jp','ï½žæ—¥ä»˜ç·?è¨ˆ',0),(112388,3122,'pt','Totais para a data de',0),(112389,3122,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ Ð´Ð»Ñ Ð´Ð°Ñ‚Ñ‹',0),(112390,3122,'es','Totales para la fecha de',0),(112391,3122,'de','Summen fÃ¼r das Datum der',0),(112392,3122,'en','Totals for the date of',0),(112393,3123,'is','',0),(112394,3123,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(112395,3123,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(112396,3123,'tr','ToplamlarÄ± fiÅŸe ait',0),(112397,3123,'pl','Sumy dla zaÅ‚Ä…cznika',0),(112398,3123,'bg','Ð¡ÑƒÐ¼Ð¸ Ð¿Ð¾ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(112399,3123,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©Û’ Ù„Ø¦Û’ Ù…ÛŒØ²Ø§Ù†',0),(112400,3123,'sr','Ð—Ð±Ð¸Ñ€Ð¾Ð²Ð¸ Ð·Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(112401,3123,'vi','Tá»•ng cá»™ng cho phiáº¿u',0),(112402,3123,'af','Totale vir bewysstuk',0),(112403,3123,'ro','Totaluri pentru voucher',0),(112404,3123,'et','Kande kogusumma',0),(112405,3123,'si','Vsote za kupon',0),(112406,3123,'ba','Total voucher',0),(112407,3123,'nl','Totalen voor voucher',0),(112408,3123,'fi','Kokonaissummat tosite',0),(112409,3123,'no','Totalene for bilaget',0),(112410,3123,'da','Totaler for voucher',0),(112411,3123,'ko','ë°”ìš°ì²˜ì— ëŒ€ í•œ',0),(112412,3123,'he','×¡×›×•×ž×™× ×¢×‘×•×¨ ×©×•×‘×¨',0),(112413,3123,'el','Î£ÏÎ½Î¿Î»Î± Î³Î¹Î± ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(112414,3123,'zh','æ€»è®¡å‡­å•\r\n',0),(112415,3123,'sv','Summor fÃ¶r verifikation',0),(112416,3123,'it','Totali per voucher',0),(112417,3123,'tl','',0),(112418,3123,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(112419,3123,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‹à¤—',0),(112420,3123,'ms','Jumlah bagi baucer',0),(112421,3123,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ù„Ù„Ø¥ÙŠØµØ§Ù„',0),(112422,3123,'fr','Totaux pour le bon',0),(112423,3123,'jp','ä¼?ç¥¨ã?®å?ˆè¨ˆ',0),(112424,3123,'pt','Totais de voucher',0),(112425,3123,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ Ð´Ð»Ñ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(112426,3123,'es','Totales para Voucher',0),(112427,3123,'de','Summen fÃ¼r Gutschein',0),(112428,3123,'en','Totals for voucher',0),(112429,3124,'is','',0),(112430,3124,'dr','Ù…Ø¬Ù…ÙˆØ¹ ',0),(112431,3124,'pr','Ù…Ø¬Ù…ÙˆØ¹ ',0),(112432,3124,'tr','TOPLAMLARI',0),(112433,3124,'pl','SUMY',0),(112434,3124,'bg','ÐžÐ‘Ð©Ð˜ Ð¡Ð£ÐœÐ˜',0),(112435,3124,'ur','Ù…ÛŒØ²Ø§Ù†',0),(112436,3124,'sr','Ð¡ÐÐ‘Ð˜Ð ÐÐŠÐ•',0),(112437,3124,'vi','Tá»•ng cá»™ng',0),(112438,3124,'af','TOTALE',0),(112439,3124,'ro','TOTALURI',0),(112440,3124,'et','KOKKUVÃ•TTED',0),(112441,3124,'si','VSOTE',0),(112442,3124,'ba','TOTAL',0),(112443,3124,'nl','TOTALEN',0),(112444,3124,'fi','YHTEENSÃ„',0),(112445,3124,'no','TOTALER',0),(112446,3124,'da','TOTALER',0),(112447,3124,'ko','í•©ê³„',0),(112448,3124,'he','×¡×™×›×•×ž×™×',0),(112449,3124,'el','Î£ÎŽÎÎŸÎ›Î‘',0),(112450,3124,'zh','æ€»è®¡\r\n',0),(112451,3124,'sv','SUMMOR',0),(112452,3124,'it','TOTALI',0),(112453,3124,'tl','',0),(112454,3124,'th','&#3619;&#3623;&#3617;',0),(112455,3124,'hi','à¤¯à¥‹à¤—',0),(112456,3124,'ms','JUMLAH',0),(112457,3124,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹',0),(112458,3124,'fr','TOTAUX',0),(112459,3124,'jp','ç·?è¨ˆ',0),(112460,3124,'pt','TOTAIS',0),(112461,3124,'ru','Ð˜Ð¢ÐžÐ“Ð˜',0),(112462,3124,'es','TOTALES',0),(112463,3124,'de','SUMMEN',0),(112464,3124,'en','TOTALS',0),(112465,3125,'is','',0),(112466,3125,'dr','Ø¹Ù…Ù„ÙŠØ§Øª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø«Ø¨Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(112467,3125,'pr','Ø¹Ù…Ù„ÙŠØ§Øª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø«Ø¨Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(112468,3125,'tr','Eylem izleme giriÅŸi baÅŸarÄ±yla eklendi',0),(112469,3125,'pl','Akcja Å›ledzenia wpis dodany pomyÅ›lnie',0),(112470,3125,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(112471,3125,'ur','Ø¹Ù…Ù„ Ù¹Ø±ÛŒÚ©Ù†Ú¯ Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(112472,3125,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð¿Ñ€Ð°Ñ›ÐµÑšÐ° Ð°ÐºÑ†Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(112473,3125,'vi','Theo DÃµi cÃ¡c hoáº¡t Ä‘á»™ng Ä‘Ã£ thÃªm vÃ o thÃ nh cÃ´ng',0),(112474,3125,'af','Aksie dop inskrywing suksesvol bygevoeg',0),(112475,3125,'ro','AcÅ£iunea de urmÄƒrire intrare adÄƒugat cu succes',0),(112476,3125,'et','Lisatud meetme jÃ¤lgimiskanne',0),(112477,3125,'si','Dejanje sledenje doda uspeÅ¡no',0),(112478,3125,'ba','Tindakan pelacakan entri ditambahkan berhasil',0),(112479,3125,'nl','Actie bijhouden vermelding toegevoegd',0),(112480,3125,'fi','Seurantatapahtuma lisÃ¤Ã¤minen onnistui',0),(112481,3125,'no','Handlingen sporing oppfÃ¸ring lagt',0),(112482,3125,'da','Handling tracking Post tilfÃ¸jet',0),(112483,3125,'ko','ë™ìž‘ ì¶”ì  í•­ëª©ì´ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(112484,3125,'he','×¢×¨×š ×ž×¢×§×‘ ××—×¨ ×¤×¢×•×œ×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(112485,3125,'el','Î•Î³Î³ÏÎ±Ï†Î® Î™Ï‡Î½Î·Î»Î±ÏƒÎ·Î¼ÏŒÏ„Î·Ï„Î±Ï‚ Î´ÏÎ¬ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(112486,3125,'zh','è¡ŒåŠ¨è·Ÿè¸ªæ¡ç›®æˆåŠŸæ·»åŠ \r\n',0),(112487,3125,'sv','Ã…tgÃ¤rd spÃ¥rning post lagts',0),(112488,3125,'it','Voce di rilevamento azione aggiunta con successo',0),(112489,3125,'tl','',0),(112490,3125,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3607;&#3635;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(112491,3125,'hi','à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(112492,3125,'ms','Tindakan pengesanan kemasukan berjaya menambah',0),(112493,3125,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­ Ø¥Ø¯Ø®Ø§Ù„ ØªØ¹Ù‚Ø¨ Ø§Ù„Ø¹Ù…Ù„',0),(112494,3125,'fr','Suivi des actions d\'entrÃ©e ajoutÃ©e avec succÃ¨s',0),(112495,3125,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã‚’è¿½åŠ ã?—ã?¾ã?—ã?Ÿ',0),(112496,3125,'pt','Entrada de controle de aÃ§Ã£o adicionada com sucesso',0),(112497,3125,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(112498,3125,'es','Entrada de acciÃ³n rastreo agregado exitosamente',0),(112499,3125,'de','Aktion-Tracking-Eintrag erfolgreich hinzugefÃ¼gt',0),(112500,3125,'en','Action tracking entry added successfully',0),(112501,3126,'is','',0),(112502,3126,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(112503,3126,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(112504,3126,'tr','Ä°zleme #',0),(112505,3126,'pl','Åšledzenia #',0),(112506,3126,'bg','# Ð—Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(112507,3126,'ur','Ø³Ø±Ø§Øº Ú©Ø§Ø±ÛŒ #',0),(112508,3126,'sr','ÐŸÑ€Ð°Ñ›ÐµÑšÐµ #',0),(112509,3126,'vi','DÃ² tÃ¬m sá»‘',0),(112510,3126,'af','Spoor #',0),(112511,3126,'ro','UrmÄƒrire #',0),(112512,3126,'et','JÃ¤lgimise #',0),(112513,3126,'si','Sledenje #',0),(112514,3126,'ba','Pelacakan #',0),(112515,3126,'nl','Trackingnummer',0),(112516,3126,'fi','Seuranta #',0),(112517,3126,'no','Sporing #',0),(112518,3126,'da','Sporing #',0),(112519,3126,'ko','# ì¶”ì ',0),(112520,3126,'he','×ž×¢×§×‘ ××—×¨ #',0),(112521,3126,'el','Î Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ· #',0),(112522,3126,'zh','è·Ÿè¸ªï¼ƒ\r\n',0),(112523,3126,'sv','Tracking #',0),(112524,3126,'it','Tracking #',0),(112525,3126,'tl','',0),(112526,3126,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(112527,3126,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— #',0),(112528,3126,'ms','Menjejaki #',0),(112529,3126,'ar','ØªØªØ¨Ø¹ #',0),(112530,3126,'fr','Suivi de #',0),(112531,3126,'jp','ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°ç•ªå?·',0),(112532,3126,'pt','Rastreamento #',0),(112533,3126,'ru','ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ #',0),(112534,3126,'es','Rastreo #',0),(112535,3126,'de','Tracking #',0),(112536,3126,'en','Tracking #',0),(112537,3127,'is','',0),(112538,3127,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ù…ØªØºÙŠÙŠØ± ',0),(112539,3127,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ù…ØªØºÙŠÙŠØ± ',0),(112540,3127,'tr','# DeÄŸiÅŸkeni izleme',0),(112541,3127,'pl','Åšledzenia # zmiennej',0),(112542,3127,'bg','# ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð»Ð¸Ð²Ð° Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(112543,3127,'ur','# Ù…ØªØºÛŒØ± Ú©Ø§ Ú©Ú¾ÙˆØ¬ Ù„Ú¯Ø§Ù†Ø§',0),(112544,3127,'sr','ÐŸÑ€Ð°Ñ›ÐµÑšÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñ™Ð¸Ð²Ñƒ #',0),(112545,3127,'vi','DÃ² tÃ¬m chÃªnh lá»‡ch sá»‘',0),(112546,3127,'af','# Veranderlike dop',0),(112547,3127,'ro','UrmÄƒrirea variabilÄƒ #',0),(112548,3127,'et','# Muutujale jÃ¤lgimine',0),(112549,3127,'si','Sledenje # spremenljivka',0),(112550,3127,'ba','Pelacakan # variabel',0),(112551,3127,'nl','# Variabele bijhouden',0),(112552,3127,'fi','Seuranta # muuttuja',0),(112553,3127,'no','Sporing # variabel',0),(112554,3127,'da','Sporing # variabel',0),(112555,3127,'ko','# ë³€ìˆ˜ë¥¼ ì¶”ì ',0),(112556,3127,'he','×ž×¢×§×‘ ××—×¨ ×ž×©×ª× ×” #',0),(112557,3127,'el','Î Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ· # Î¼ÎµÏ„Î±Î²Î»Î·Ï„Î®',0),(112558,3127,'zh','è·Ÿè¸ªï¼ƒå˜é‡\r\n',0),(112559,3127,'sv','Tracking # variabel',0),(112560,3127,'it','# Variabile di rilevamento',0),(112561,3127,'tl','',0),(112562,3127,'th','&#3605;&#3633;&#3623;&#3649;&#3611;&#3619;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(112563,3127,'hi','# à¤šà¤° à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤—',0),(112564,3127,'ms','Mengesan pemboleh ubah #',0),(112565,3127,'ar','ØªØªØ¨Ø¹ Ù…ØªØºÙŠØ± #',0),(112566,3127,'fr','# Variable de suivi',0),(112567,3127,'jp','å?¯å¤‰ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°ç•ªå?·',0),(112568,3127,'pt','# VariÃ¡vel de controle',0),(112569,3127,'ru','ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ Ð¿ÐµÑ€ÐµÐ¼ÐµÐ½Ð½Ð¾Ð¹ #',0),(112570,3127,'es','Rastreo 3 Variable',0),(112571,3127,'de','Tracking # Variable',0),(112572,3127,'en','Tracking # Variable',0),(112573,3128,'is','',0),(112574,3128,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ÙØ§ÙŠÙ„ \r\n URL',0),(112575,3128,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ÙØ§ÙŠÙ„ \r\n URL',0),(112576,3128,'tr','Ä°zleme URL',0),(112577,3128,'pl','Åšledzenie adresu URL',0),(112578,3128,'bg','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° URL Ð°Ð´Ñ€ÐµÑ',0),(112579,3128,'ur','ÛŒÙˆ Ø¢Ø± Ø§ÛŒÙ„ Ú©Ø§ Ú©Ú¾ÙˆØ¬ Ù„Ú¯Ø§Ù†Ø§',0),(112580,3128,'sr','Ð£Ð Ð› Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ',0),(112581,3128,'vi','DÃ² tÃ¬m Ä‘Æ°á»ng dáº«n',0),(112582,3128,'af','Spoor BA (\"URL\")',0),(112583,3128,'ro','URL-ul de urmÄƒrire',0),(112584,3128,'et','JÃ¤lgimise URL',0),(112585,3128,'si','Sledenje URL',0),(112586,3128,'ba','URL pelacakan',0),(112587,3128,'nl','Tracking URL',0),(112588,3128,'fi','Seuranta-URL',0),(112589,3128,'no','Sporingswebadressen',0),(112590,3128,'da','Sporing af URL',0),(112591,3128,'ko','ì¶”ì  URL',0),(112592,3128,'he','×ž×¢×§×‘ ××—×¨ ×›×ª×•×‘×ª URL',0),(112593,3128,'el','Î Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ· URL',0),(112594,3128,'zh','è·Ÿè¸ªç½‘å€\r\n',0),(112595,3128,'sv','Tracking-URL',0),(112596,3128,'it','Tracking URL',0),(112597,3128,'tl','',0),(112598,3128,'th','&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617; URL',0),(112599,3128,'hi','à¤¯à¥‚à¤†à¤°à¤à¤² à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤—',0),(112600,3128,'ms','URL pelacakan',0),(112601,3128,'ar','ØªØªØ¨Ø¹ Ø¹Ù†ÙˆØ§Ù† URL',0),(112602,3128,'fr','URL de suivi',0),(112603,3128,'jp','ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°URL',0),(112604,3128,'pt','URL de acompanhamento',0),(112605,3128,'ru','ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ URL-Ð°Ð´Ñ€ÐµÑ',0),(112606,3128,'es','Rastreo URL',0),(112607,3128,'de','Tracking-URL',0),(112608,3128,'en','Tracking URL',0),(112609,3129,'is','',0),(112610,3129,'dr','ØªØ§Ø±ÙŠØ® Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(112611,3129,'pr','ØªØ§Ø±ÙŠØ® Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(112612,3129,'tr','Hareket tarihi',0),(112613,3129,'pl','Data transakcji',0),(112614,3129,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÑÐ´ÐµÐ»ÐºÐ°Ñ‚Ð°',0),(112615,3129,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(112616,3129,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(112617,3129,'vi','NgÃ y Giao dá»‹ch ',0),(112618,3129,'af','Transaksiedatum',0),(112619,3129,'ro','Data tranzacÅ£iei',0),(112620,3129,'et','Kande kuupÃ¤ev',0),(112621,3129,'si','Datum transakcije',0),(112622,3129,'ba','Tanggal transaksi',0),(112623,3129,'nl','Transactiedatum',0),(112624,3129,'fi','TapahtumapÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(112625,3129,'no','Transaksjonsdato',0),(112626,3129,'da','Posteringsdato',0),(112627,3129,'ko','íŠ¸ëžœìž­ì…˜ ë‚ ì§œ',0),(112628,3129,'he','×ª××¨×™×š ×ª× ×•×¢×”',0),(112629,3129,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(112630,3129,'zh','äº¤æ˜“æ—¥æœŸ\r\n',0),(112631,3129,'sv','Transaktionsdatum',0),(112632,3129,'it','Data di transazione',0),(112633,3129,'tl','',0),(112634,3129,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(112635,3129,'hi','à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(112636,3129,'ms','Tarikh urus niaga',0),(112637,3129,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(112638,3129,'fr','Date de la transaction',0),(112639,3129,'jp','å?–å¼•æ—¥',0),(112640,3129,'pt','Data da transaÃ§Ã£o',0),(112641,3129,'ru','Ð”Ð°Ñ‚Ð° ÑÐ´ÐµÐ»ÐºÐ¸',0),(112642,3129,'es','Fecha de TransacciÃ³n',0),(112643,3129,'de','Buchungsdatum',0),(112644,3129,'en','Transaction Date',0),(112645,3130,'is','',0),(112646,3130,'dr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø§Ø²Ù…Ø§ÙŠØ´Ù‰',0),(112647,3130,'pr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø§Ø²Ù…Ø§ÙŠØ´Ù‰',0),(112648,3130,'tr','Mizan',0),(112649,3130,'pl','Bilans prÃ³bny',0),(112650,3130,'bg','ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð½Ð° Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚',0),(112651,3130,'ur','Ù…Ù‚Ø¯Ù…Û Ù…ÛŒØ²Ø§Ù†',0),(112652,3130,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð±Ð¸Ð»Ð°Ð½Ñ',0),(112653,3130,'vi','Sá»‘ dÆ° thá»­',0),(112654,3130,'af','Proefbalans',0),(112655,3130,'ro','Balanta de verificare',0),(112656,3130,'et','Proovibilanss',0),(112657,3130,'si','Bilanca',0),(112658,3130,'ba','Trial Balance',0),(112659,3130,'nl','Proefbalans',0),(112660,3130,'fi','Alustava saldo',0),(112661,3130,'no','RÃ¥balanse',0),(112662,3130,'da','RÃ¥balance',0),(112663,3130,'ko','ì‹œì‚°í‘œ',0),(112664,3130,'he','×ž××–×Ÿ × ×¡×™×•×Ÿ',0),(112665,3130,'el','Î™ÏƒÎ¿Î¶ÏÎ³Î¹Î¿',0),(112666,3130,'zh','è¯•ç®—è¡¨\r\n',0),(112667,3130,'sv','RÃ¥balans',0),(112668,3130,'it','Equilibrio di prova',0),(112669,3130,'tl','',0),(112670,3130,'th','&#3591;&#3610;&#3607;&#3604;&#3621;&#3629;&#3591;',0),(112671,3130,'hi','à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤¸à¤‚à¤¤à¥à¤²à¤¨',0),(112672,3130,'ms','Imbangan duga',0),(112673,3130,'ar','Ù…ÙŠØ²Ø§Ù† Ø§Ù„Ù…Ø±Ø§Ø¬Ø¹Ø©',0),(112674,3130,'fr','Balance de vÃ©rification',0),(112675,3130,'jp','è©¦ç®—è¡¨',0),(112676,3130,'pt','Balancete',0),(112677,3130,'ru','ÐŸÑ€Ð¾Ð±Ð½Ñ‹Ð¹ Ð±Ð°Ð»Ð°Ð½Ñ',0),(112678,3130,'es','Balance de ComprobaciÃ³n',0),(112679,3130,'de','Rohbilanz',0),(112680,3130,'en','Trial Balance',0),(112681,3131,'is','',0),(112682,3131,'dr','/ Ø­Ø¯Ø§Ù‚Ù„/ ØªØ®ÙÙŠÙ ',0),(112683,3131,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ / Ø­Ø¯Ø§Ù‚Ù„/ ØªØ®ÙÙŠÙ ',0),(112684,3131,'tr','Åžarj/M/kesim kesim',0),(112685,3131,'pl','WykoÅ„czenia M/bezpÅ‚atnie/ciÄ™cie',0),(112686,3131,'bg','ÐžÑ‚Ñ€ÐµÐ¶ÐµÑ‚Ðµ Ñ‚Ð°ÐºÑÐ°/M/Ñ€ÑÐ·Ð°Ð½Ð¸',0),(112687,3131,'ur','Ú†Ø§Ø±Ø¬/M/Ú©Ù¹ ØªØ±Ø§Ø´ÛŒÚº',0),(112688,3131,'sr','Ð¢Ñ€Ð¸Ð¼ Ð¿ÑƒÑšÐµÑšÐµ/Ðœ/Ñ€ÐµÐ·',0),(112689,3131,'vi','Cáº¯t phÃ­/M/cáº¯t',0),(112690,3131,'af','Snoei beheer/M/sny',0),(112691,3131,'ro','TÄƒiaÅ£i taxa/M/cut',0),(112692,3131,'et','KÃ¤rbi tasu/M/lÃµigatud',0),(112693,3131,'si','Trim M/brezplaÄno/cut',0),(112694,3131,'ba','Memangkas biaya/M/memotong',0),(112695,3131,'nl','Trim gratis/M/knippen',0),(112696,3131,'fi','Trim ilmaiseksi/M/leikkaus',0),(112697,3131,'no','Trimme kostnad/M/kutt',0),(112698,3131,'da','Trim afgift/M/klip',0),(112699,3131,'ko','ì¶©ì „/M/ì»· íŠ¸ë¦¼',0),(112700,3131,'he','×œ×§×¦×¥ ×ª×©×œ×•×/M/×’×–×•×¨',0),(112701,3131,'el','Î¤ÎµÎ»ÎµÎ¹ÏŽÎ¼Î±Ï„Î± Ï‡ÏÎ­Ï‰ÏƒÎ·/M/Ï€ÎµÏÎ¹ÎºÎ¿Ï€Î®',0),(112702,3131,'zh','å‰Šå‡è´¹/æœˆ/åˆ‡å‰²\r\n',0),(112703,3131,'sv','Trimma avgift/M/klippa',0),(112704,3131,'it','Tagliare carica/M/taglio',0),(112705,3131,'tl','',0),(112706,3131,'th','Trim Charge/M/cut',0),(112707,3131,'hi','à¤ªà¥à¤°à¤­à¤¾à¤°à¥€/à¤à¤®/à¤•à¤Ÿ à¤Ÿà¥à¤°à¤¿à¤® à¤•à¤° à¤¦à¥€à¤œà¤¿à¤',0),(112708,3131,'ms','Mengurangkan caj/M/potong',0),(112709,3131,'ar','ØªÙ‚Ù„ÙŠÙ… ØªÙ‡Ù…Ø©/M/Ù‚Øµ',0),(112710,3131,'fr','Garniture M/Charge/coupe',0),(112711,3131,'jp','Trim Charge/M/cut',0),(112712,3131,'pt','Aparar a carga/M/corte',0),(112713,3131,'ru','ÐžÐ±Ñ€ÐµÐ·Ð°Ñ‚ÑŒ Ð·Ð°Ñ€ÑÐ´Ð°/M/cut',0),(112714,3131,'es','Cargo de Adorno/M/corte',0),(112715,3131,'de','Trimmen Sie kostenlos/M/Schnitt',0),(112716,3131,'en','Trim Charge/M/cut',0),(112717,3132,'is','',0),(112718,3132,'dr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(112719,3132,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(112720,3132,'tr','Giderleri en dÃ¼ÅŸÃ¼k dÃ¶ÅŸeme',0),(112721,3132,'pl','WykoÅ„czenia za Minimum',0),(112722,3132,'bg','ÐžÑ‚Ñ€ÐµÐ¶ÐµÑ‚Ðµ Ñ‚Ð°ÐºÑÐ° Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼',0),(112723,3132,'ur','Ú†Ø§Ø±Ø¬ Ú©ÛŒ Ú©Ù… Ø§Ø² Ú©Ù… ØªØ±Ø§Ø´ÛŒÚº',0),(112724,3132,'sr','Ð¢Ñ€Ð¸Ð¼ ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(112725,3132,'vi','Cáº¯t phÃ­ tá»‘i thiá»ƒu',0),(112726,3132,'af','Aanklag Minimum snoei',0),(112727,3132,'ro','TÄƒiaÅ£i taxa minimÄƒ',0),(112728,3132,'et','KÃ¤rbi maksu alammÃ¤Ã¤ra',0),(112729,3132,'si','Trim dajatev najmanj',0),(112730,3132,'ba','Memangkas biaya Minimum',0),(112731,3132,'nl','Trim gratis Minimum',0),(112732,3132,'fi','Trim ilmaiseksi vÃ¤hintÃ¤Ã¤n',0),(112733,3132,'no','Trimme kostnad Minimum',0),(112734,3132,'da','Trim afgift Minimum',0),(112735,3132,'ko','ì¶©ì „ ìµœì†Œ íŠ¸ë¦¼',0),(112736,3132,'he','×œ×§×¦×¥ ×ž×™× ×™×ž×•× ×”×˜×¢×™× ×”',0),(112737,3132,'el','Î¤ÎµÎ»ÎµÎ¹ÏŽÎ¼Î±Ï„Î± ÎµÎ»Î¬Ï‡Î¹ÏƒÏ„Î· Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(112738,3132,'zh','å‰Šå‡è´¹æœ€ä½Ž\r\n',0),(112739,3132,'sv','Trimma kostnadsfritt Minimum',0),(112740,3132,'it','Tagliare la carica minima',0),(112741,3132,'tl','',0),(112742,3132,'th','&#3605;&#3633;&#3604;&#3618;&#3629;&#3604;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(112743,3132,'hi','à¤¶à¥à¤²à¥à¤• à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤Ÿà¥à¤°à¤¿à¤® à¤•à¤° à¤¦à¥€à¤œà¤¿à¤',0),(112744,3132,'ms','Mengurangkan bayaran minima',0),(112745,3132,'ar','Ø®ÙØ¶ Ø±Ø³ÙˆÙ… Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰',0),(112746,3132,'fr','Garniture de Charge Minimum',0),(112747,3132,'jp','Trim Charge Minimum',0),(112748,3132,'pt','GuarniÃ§Ã£o mÃ­nima de carga',0),(112749,3132,'ru','ÐžÐ±Ñ€ÐµÐ·ÐºÐ° Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(112750,3132,'es','Cargo MÃ­nimo de Adorno',0),(112751,3132,'de','Trimmen kostenlos Minimum',0),(112752,3132,'en','Trim Charge Minimum',0),(112753,3133,'is','',0),(112754,3133,'dr','/ ØªØ®ÙÙŠÙ',0),(112755,3133,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡  Ø­Ø¯Ø§Ù‚Ù„/ ØªØ®ÙÙŠÙ',0),(112756,3133,'tr','Giderleri en dÃ¼ÅŸÃ¼k/kesim kesim',0),(112757,3133,'pl','WykoÅ„czenia za Minimum/ciÄ™cie',0),(112758,3133,'bg','ÐžÑ‚Ñ€ÐµÐ¶ÐµÑ‚Ðµ Ñ‚Ð°ÐºÑÐ° Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼/Ñ€ÑÐ·Ð°Ð½Ð¸',0),(112759,3133,'ur','Ú©Ù… Ø§Ø² Ú©Ù…/Ú©Ù¹ Ú†Ø§Ø±Ø¬ ØªØ±Ø§Ø´ÛŒÚº',0),(112760,3133,'sr','Ð¢Ñ€Ð¸Ð¼ Ð¿ÑƒÑšÐµÑšÐµ ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼/Ñ€ÐµÐ·.',0),(112761,3133,'vi','Cáº¯t phÃ­ tá»‘i thiá»ƒu/cáº¯t',0),(112762,3133,'af','Snoei beheer Minimum/sny',0),(112763,3133,'ro','TÄƒiaÅ£i taxa minimÄƒ/cut',0),(112764,3133,'et','KÃ¤rbi maksu alammÃ¤Ã¤ra/lÃµigatud',0),(112765,3133,'si','Trim dajatev Minimum/cut',0),(112766,3133,'ba','Memangkas biaya Minimum/memotong',0),(112767,3133,'nl','Trim gratis Minimum/knippen',0),(112768,3133,'fi','Trim ilmaiseksi vÃ¤hintÃ¤Ã¤n/leikkaus',0),(112769,3133,'no','Trimme kostnad Minimum/kutt',0),(112770,3133,'da','Trim afgift Minimum/cut',0),(112771,3133,'ko','ì¶©ì „ ìµœì†Œ/ì»· íŠ¸ë¦¼',0),(112772,3133,'he','×œ×§×¦×¥ ×ž×™× ×™×ž×•× ×”×˜×¢×™× ×”/×’×–×•×¨',0),(112773,3133,'el','Î ÎµÏÎ¹Ï€Î¿Î¯Î·ÏƒÎ· ÎµÎ»Î¬Ï‡Î¹ÏƒÏ„Î¿/Î±Ï€Î¿ÎºÎ¿Ï€Î® Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(112774,3133,'zh','å‰Šå‡è´¹æœ€å°/åˆ‡å‰²\r\n',0),(112775,3133,'sv','Trimma kostnadsfritt Minimum/klippa',0),(112776,3133,'it','Tagliare carica minimo/taglio',0),(112777,3133,'tl','',0),(112778,3133,'th','&#3605;&#3633;&#3604;&#3618;&#3629;&#3604;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;/&#3605;&#3633;&#3604;',0),(112779,3133,'hi','à¤¶à¥à¤²à¥à¤• à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤®/à¤•à¤Ÿ à¤Ÿà¥à¤°à¤¿à¤® à¤•à¤° à¤¦à¥€à¤œà¤¿à¤',0),(112780,3133,'ms','Mengurangkan bayaran minima/potong',0),(112781,3133,'ar','Ø®ÙØ¶ Ø±Ø³ÙˆÙ… Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰/Ù‚Øµ',0),(112782,3133,'fr','Garniture de Charge Minimum/coupe',0),(112783,3133,'jp','Trim Charge Minimum/cut',0),(112784,3133,'pt','GuarniÃ§Ã£o de carga mÃ­nimo/corte',0),(112785,3133,'ru','ÐžÐ±Ñ€ÐµÐ·Ð°Ñ‚ÑŒ Ð·Ð°Ñ€ÑÐ´ Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼/cut',0),(112786,3133,'es','Cargo MÃ­nimo de Adorno/corte',0),(112787,3133,'de','Trimmen Sie kostenlos Minimum/Schnitt',0),(112788,3133,'en','Trim Charge Minimum/cut',0),(112789,3134,'is','',0),(112790,3134,'dr','Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(112791,3134,'pr','Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(112792,3134,'tr','Yeniden Deneyin',0),(112793,3134,'pl','PrÃ³buj ponownie',0),(112794,3134,'bg','ÐžÐ¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(112795,3134,'ur','Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ Ú©Ø±Ùˆ',0),(112796,3134,'sr','Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(112797,3134,'vi','Thá»­ láº¡i',0),(112798,3134,'af','Probeer Weer',0),(112799,3134,'ro','Ã®ncearcÄƒ din nou',0),(112800,3134,'et','Proovi uuesti',0),(112801,3134,'si','poskusi znova',0),(112802,3134,'ba','Coba lagi',0),(112803,3134,'nl','&Opnieuw',0),(112804,3134,'fi','YritÃ¤ uudestaan',0),(112805,3134,'no','prÃ¸v igjen',0),(112806,3134,'da','PrÃ¸v igen',0),(112807,3134,'ko','ë‹¤ì‹œ ì‹œë„',0),(112808,3134,'he','× ×¡×” ×©×•×‘',0),(112809,3134,'el','Î”Î¿ÎºÎ¯Î¼Î±ÏƒÎµ Î¾Î±Î½Î¬',0),(112810,3134,'zh','å†è¯•ä¸€æ¬¡\r\n',0),(112811,3134,'sv','FÃ¶rsÃ¶k igen',0),(112812,3134,'it','Riprova',0),(112813,3134,'tl','',0),(112814,3134,'th','&#3614;&#3618;&#3634;&#3618;&#3634;&#3617;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(112815,3134,'hi','à¤«à¤¿à¤° à¤•à¥‹à¤¶à¤¿à¤¶ à¤•à¤°à¥‹',0),(112816,3134,'ms','cuba lagi',0),(112817,3134,'ar','Ø­Ø§ÙˆÙ„ Ù…Ø¬Ø¯Ø¯Ø§Ù‹',0),(112818,3134,'fr','RÃ©essayez',0),(112819,3134,'jp','å†?åº¦è¡Œã?£ã?¦ä¸‹ã?•ã?„',0),(112820,3134,'pt','Tentar novamente',0),(112821,3134,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð¸Ñ‚ÑŒ',0),(112822,3134,'es','Intentar Otra Vez',0),(112823,3134,'de','Wiederholen',0),(112824,3134,'en','Try Again',0),(112825,3135,'is','',0),(112826,3135,'dr','. Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¯Ø± Ù…Ø±ÙˆØ±Ú¯Ø± Ø´Ù…Ø§ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ Ø§Ú¯Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø§ÙƒØ³Ù„ ÙŠØ§ ØªØ§Ø¨Ø¹ Ø¨Ù‡ Ú©Ø§Ø± Ú¯ÙŠØ±Ù†Ø¯Ù‡ Ù†ØµØ¨ Ø´Ø¯Ù‡ Ø§Ø³Øª . ',0),(112827,3135,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ÙƒØ§Ù…Ø§ÙŠ Ø¬Ø¯Ø§ÙƒÙ†Ù†Ø¯Ù‡ Ø¨Ø§ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† . Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¯Ø± Ù…Ø±ÙˆØ±Ú¯Ø± Ø´Ù…Ø§ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ Ø§Ú¯Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø§ÙƒØ³Ù„ ÙŠØ§ ØªØ§Ø¨Ø¹ Ø¨Ù‡ Ú©Ø§Ø± Ú¯ÙŠØ±Ù†Ø¯Ù‡ Ù†ØµØ¨ Ø´Ø¯Ù‡ Ø§Ø³Øª . Ø',0),(112828,3135,'tr','MÃ¼ÅŸterilerin listesini virgÃ¼lle ayrÄ±lmÄ±ÅŸ (CSV) oluÅŸturur.  Microsoft Excel veya baÅŸka bir iÅŸleyici, aksi takdirde istenir dosyayÄ± kaydetmek iÃ§in yÃ¼klÃ¼yse, tarayÄ±cÄ±da gÃ¶rÃ¼ntÃ¼lenebilir.',0),(112829,3135,'pl','Generuje listÄ™ rozdzielany przecinkami (CSV) klientÃ³w.  MogÄ… byÄ‡ wyÅ›wietlane w przeglÄ…darce, jeÅ›li Microsoft Excel lub inny program obsÅ‚ugi jest zainstalowany, w przeciwnym wypadku zostanie wyÅ›wietlony monit o zapisanie pliku.',0),(112830,3135,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð° Ð·Ð°Ð¿ÐµÑ‚Ð°Ñ (CSV) ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸.  ÐœÐ¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½Ð¸ Ð²ÑŠÐ² Ð²Ð°ÑˆÐ¸Ñ Ð±Ñ€Ð°ÑƒÐ·ÑŠÑ€, Ð°ÐºÐ¾ Microsoft Excel Ð¸Ð»Ð¸ Ð´Ñ€ÑƒÐ³ ÐœÐ°Ð½Ð¸Ð¿ÑƒÐ»Ð°Ñ‚Ð¾Ñ€ÑŠÑ‚ Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½, Ð² Ð¿Ñ€Ð¾Ñ‚Ð¸',0),(112831,3135,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©ÛŒ Ú©Ø§Ù…Ø§ (CSV) ØªØ­Ø¯ÛŒØ¯ÛŒ ÙÛØ±Ø³Øª Ù¾ÛŒØ¯Ø§ Ú©Ø±ØªØ§ ÛÛ’ Û”  Microsoft Excel ÛŒØ§ Ú©Ø³ÛŒ Ø¯ÙˆØ³Ø±Û’ Ø¨Ø±ØªÙ†Û’ ÙˆØ§Ù„Û’ØŒ ÙˆØ±Ù†Û Ø¢Ù¾ Ù…Ù„ Ø¬Ø§Ø¦Û’ Ú¯ÛŒ Ù…Ø³Ù„ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ØªÙ†ØµÛŒØ¨ ÛÛ’ ØªÙˆ Ø¢Ù¾ Ú©Û’ Ø¨Ø±Ø§Ø',0),(112832,3135,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑˆÐµ Ð·Ð°Ñ€ÐµÐ·Ð¾Ð¼ (Ð¦Ð¡Ð’) Ð»Ð¸ÑÑ‚Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°.  ÐœÐ¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½ Ñƒ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‡Ñƒ Ð°ÐºÐ¾ ÐœÐ¸Ñ†Ñ€Ð¾ÑÐ¾Ñ„Ñ‚ Ð•xÑ†ÐµÐ» Ð¸Ð»Ð¸ Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ñ€ÐµÐ³ÑƒÐ»Ð°Ñ‚Ð¾Ñ€Ð° Ñ˜Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½, Ñƒ ÑÑƒÐ¿Ñ€Ð¾Ñ‚Ð½Ð¾Ð¼ Ð²Ð',0),(112833,3135,'vi','Táº¡o dáº¥u pháº©y phÃ¢n cÃ¡ch (CSV) danh sÃ¡ch khÃ¡ch hÃ ng. CÃ³ thá»ƒ hiá»ƒn thá»‹ trÃªn trÃ¬nh duyá»‡t cá»§a báº¡n náº¿u cÃ³ Microsoft Excel hay pháº§n má»m khÃ¡c, náº¿u khÃ´ng há»‡ thá»‘ng sáº½ nháº¯c báº¡n sao lÆ°u há»“ sÆ¡',0),(112834,3135,'af','Genereer \'n komma afgebaken (CSV) lys van kliÃ«nte.  Mag vertoon word in jou blaaier as Microsoft Excel of \'n ander hanteerder geÃ¯nstalleer is, anders sal jy gevra word om die lÃªer te stoor.',0),(112835,3135,'ro','GenereazÄƒ o listÄƒ de virgulÄƒ (CSV) de clienÅ£ii.  Pot fi afiÅŸate Ã®n browser-ul Ã®n cazul Ã®n care Microsoft Excel sau alt handler este instalat, Ã®n caz contrar vi se va salva fiÈ™ierul.',0),(112836,3135,'et','Loob komaeraldusega (CSV) klientide loetelu.  VÃµidakse kuvada brauseris kui Microsoft Exceli vÃµi teisele kÃ¤itlejale paigaldatakse, muidu teil palutakse faili salvestada.',0),(112837,3135,'si','Ustvari seznam z vejico (CSV) stranke.  Lahko se prikaÅ¾e v brskalniku, Äe Microsoft Excel ali drug trener je nameÅ¡Äen, drugaÄe boste pozvani, da shranite datoteko.',0),(112838,3135,'ba','Menghasilkan daftar pelanggan comma delimited (CSV).  Dapat ditampilkan dalam browser Anda jika Microsoft Excel atau lain handler terinstal, jika tidak Anda akan diminta untuk menyimpan file.',0),(112839,3135,'nl','Genereert een door komma\'s gescheiden (CSV) lijst van klanten.  Kan worden weergegeven in uw browser als Microsoft Excel of een andere handler is geÃ¯nstalleerd, anders wordt u gevraagd het bestand op te slaan.',0),(112840,3135,'fi','Luo pilkulla (CSV) luettelo asiakkaista.  Voi nÃ¤kyÃ¤ selaimen, jos Microsoft Excel tai toinen kÃ¤sittelytoiminto on asennettu, muuten sinua pyydetÃ¤Ã¤n tallentamaan tiedoston.',0),(112841,3135,'no','Genererer en kommadelt (CSV) liste over kunder.  Kan vises i leseren hvis Microsoft Excel eller et annet hÃ¥nd er installert, ellers vil du bli bedt om Ã¥ lagre filen.',0),(112842,3135,'da','Genererer en kommasepareret (CSV) liste af kunder.  Kan blive vist i din browser, hvis Microsoft Excel eller et andet handleren er installeret, ellers vil du blive bedt om at gemme filen.',0),(112843,3135,'ko','ê³ ê° ëª©ë¡ì´ ì‰¼í‘œë¡œ êµ¬ë¶„ ëœ (CSV) ìƒì„±í•©ë‹ˆë‹¤.  Microsoft Excel ì´ë‚˜ ë‹¤ë¥¸ ì²˜ë¦¬ê¸°ê°€ ì„¤ì¹˜ ëœ ê²½ìš°, ê·¸ë ‡ì§€ ì•Šìœ¼ë©´ ë©”ì‹œì§€ê°€ í‘œì‹œ ë©ë‹ˆë‹¤ íŒŒì¼ì„ ì €ìž¥ í•˜ë„ë¡ ê·€í•˜ì˜ ë¸Œë¼ìš°ì €ì— í‘œì‹œ ë  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(112844,3135,'he','×™×•×¦×¨ ×¨×©×™×ž×” ×ž×•×¤×¨×“×ª ×‘××ž×¦×¢×•×ª ×¤×¡×™×§ (CSV) ×©×œ ×”×œ×§×•×—×•×ª.  ×¢×©×•×™×™× ×œ×”×™×•×ª ×ž×•×¦×’×™× ×‘×“×¤×“×¤×Ÿ ×©×œ×š ×× Microsoft Excel ××• ×‘×ž×˜×¤×œ ××—×¨ ×ž×•×ª×§×Ÿ, ××—×¨×ª ××ª×” ×ª×ª×‘×§×© ×œ×©×ž×•×¨ ××ª ×”×§×•×‘×¥.',0),(112845,3135,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯ Î¼Î¹Î± Î»Î¯ÏƒÏ„Î± Î¿ÏÎ¹Î¿Î¸ÎµÏ„Î·Î¼Î­Î½Î¿ Î¼Îµ ÎºÏŒÎ¼Î¼Î±Ï„Î± (CSV) Î¼Îµ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚.  Î•Î½Î´Î­Ï‡ÎµÏ„Î±Î¹ Î½Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ ÏƒÏ„Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Ï€ÎµÏÎ¹Î®Î³Î·ÏƒÎ·Ï‚, ÎµÎ¬Î½ Ï„Î¿ Microsoft Excel Î® Î­Î½Î± Î¬Î',0),(112846,3135,'zh','ç”Ÿæˆä¸€ä¸ªé€—å·åˆ†éš”ï¼ˆCSVï¼‰çš„å®¢æˆ·åå•ã€‚å¦‚æžœMicrosoft Excelæˆ–å…¶ä»–å¤„ç†ç¨‹åºè¢«å®‰è£…ï¼Œå¯èƒ½ä¼šæ˜¾ç¤ºåœ¨æ‚¨çš„æµè§ˆå™¨ï¼Œå¦åˆ™å°†æç¤ºæ‚¨ä¿å­˜æ–‡ä»¶ã€‚\r\n',0),(112847,3135,'sv','Genererar en kommaavgrÃ¤nsad (CSV) lista Ã¶ver kunder.  Kan visas i din webblÃ¤sare om Microsoft Excel eller en annan hanterare Ã¤r installerat, annars uppmanas du fÃ¶r att spara filen.',0),(112848,3135,'it','Genera un elenco di valori delimitati da virgole (CSV) di clienti.  PuÃ² essere visualizzato nel browser se Microsoft Excel o un altro gestore Ã¨ installato, altrimenti verrÃ  richiesto di salvare il file.',0),(112849,3135,'tl','',0),(112850,3135,'th','Generates a comma delimited (CSV) list of customers.  May be displayed in your browser if Microsoft Excel or another handler is installed, otherwise you will be prompted to save the file.',0),(112851,3135,'hi','à¤à¤• à¤…à¤²à¥à¤ªà¤µà¤¿à¤°à¤¾à¤® (CSV) à¤¸à¥€à¤®à¤¾à¤‚à¤•à¤¿à¤¤ à¤¸à¥‚à¤šà¥€ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆà¥¤  à¤¯à¤¦à¤¿ Microsoft Excel à¤¯à¤¾ à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤¹à¥‡à¤¨à¥à¤¡à¤²à¤°, à¤…à¤¨à¥à¤¯à¤¥à',0),(112852,3135,'ms','Menjana senarai pelanggan oleh delimited koma (CSV).  Mungkin dipaparkan di pelayar web anda jika Microsoft Excel atau pengendali lain dipasang, jika tidak anda akan diprom untuk menyimpan fail.',0),(112853,3135,'ar','ÙŠÙ†Ø´Ø¦ Ù‚Ø§Ø¦Ù…Ø© Ù…Ø­Ø¯Ø¯ Ø¨ÙØ§ØµÙ„Ø© (CSV) Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡.  Ù‚Ø¯ ÙŠØªÙ… Ø¹Ø±Ø¶ ÙÙŠ Ø§Ù„Ù…Ø³ØªØ¹Ø±Ø¶ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø¥Ø°Ø§ ÙƒØ§Ù† Microsoft Excel Ø£Ùˆ Ù…Ø¹Ø§Ù„Ø¬ Ø¢Ø®Ø± Ù…Ø«Ø¨ØªØŒ ÙˆØ¥Ù„Ø§ Ø³ØªØªÙ… Ù…Ø·Ø§Ù„Ø¨ØªÙƒ Ø¨Ø­ÙØ¸ Ø§Ù„Ù…Ù„Ù.',0),(112854,3135,'fr','GÃ©nÃ¨re une liste par des virgules (CSV) des clients.  Peut s\'afficher dans votre navigateur, si Microsoft Excel ou un autre gestionnaire est installÃ©, sinon vous serez invitÃ© Ã  enregistrer le fichier.',0),(112855,3135,'jp','ã‚³ãƒ³ãƒžåŒºåˆ‡ã‚Šï¼ˆï¼£ï¼³ï¼¶ï¼‰ã?®é¡§å®¢ãƒªã‚¹ãƒˆã‚’ä½œæˆ?ã?™ã‚‹ã€‚ãƒžã‚¤ã‚¯ãƒ­ã‚½ãƒ•ãƒˆã‚¨ã‚¯ã‚»ãƒ«ã?‹ä»–ã?®å?Œæ§˜ã‚½ãƒ•ãƒˆã?Œã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«ã?•ã‚Œã?¦ã?„ã‚Œã?°ã€?ãƒ–ãƒ©ã‚¦ã‚¶ã?«è¡¨ç¤ºã?•ã‚Œã?¾ã?™ã?Œã€?ã?ªã?‘ã‚Œã?°ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ä¿?å­˜ã?™ã‚‹ã‚ˆã?†ã?«',0),(112856,3135,'pt','Gera uma lista delimitada por vÃ­rgulas (CSV) dos clientes.  Pode ser exibido em seu navegador, se o Microsoft Excel ou outro manipulador Ã© instalado, caso contrÃ¡rio vocÃª serÃ¡ solicitado para salvar o arquivo.',0),(112857,3135,'ru','Ð¡Ð¾Ð·Ð´Ð°ÐµÑ‚ ÑÐ¿Ð¸ÑÐ¾Ðº ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð·Ð°Ð¿ÑÑ‚Ñ‹Ð¼Ð¸ (CSV).  ÐœÐ¾Ð¶ÐµÑ‚ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒÑÑ Ð² Ð²Ð°ÑˆÐµÐ¼ Ð±Ñ€Ð°ÑƒÐ·ÐµÑ€Ðµ, ÐµÑÐ»Ð¸ Microsoft Excel Ð¸Ð»Ð¸ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ñ‡Ð¸Ðº ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½, Ð² Ð¿Ñ€Ð¾Ñ‚Ð¸Ð²Ð½Ð¾Ð¼ ÑÐ»ÑƒÑ',0),(112858,3135,'es','Se Genera una lista de clientes delimitada por coma (CSV). Se puede desplegar en su browser si Microsoft Excel u otro manipulador esta instalado, de otra manera se pedirÃ¡ que guarda su file.',0),(112859,3135,'de','Erzeugt eine kommagetrennte (CSV)-Liste der Kunden.  KÃ¶nnen in Ihrem Browser angezeigt werden, wenn Microsoft Excel oder ein anderer Handler sonst werden Sie aufgefordert installiert ist, um die Datei zu speichern.',0),(112860,3135,'en','Generates a comma delimited (CSV) list of customers.  May be displayed in your browser if Microsoft Excel or another handler is installed, otherwise you will be prompted to save the file.',0),(112861,3136,'is','',0),(112862,3136,'dr','. Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¯Ø± Ù…Ø±ÙˆØ±Ú¯Ø± Ø´Ù…Ø§ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ Ø§Ú¯Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø§ÙƒØ³Ù„ ÙŠØ§ ØªØ§Ø¨Ø¹ Ø¨Ù‡ Ú©Ø§Ø± Ú¯ÙŠØ±Ù†Ø¯Ù‡ Ù†ØµØ¨ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(112863,3136,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ÙƒØ§Ù…Ø§ÙŠ Ø¬Ø¯Ø§ÙƒÙ†Ù†Ø¯Ù‡ Ø¨Ø§ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ  Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† . Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¯Ø± Ù…Ø±ÙˆØ±Ú¯Ø± Ø´Ù…Ø§ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ Ø§Ú¯Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø§ÙƒØ³Ù„ ÙŠØ§ ØªØ§Ø¨Ø¹ Ø¨Ù‡ Ú©Ø§Ø± Ú¯ÙŠØ±Ù†Ø¯Ù‡ Ù†ØµØ¨ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(112864,3136,'tr','SatÄ±cÄ±larÄ±n listesini virgÃ¼lle ayrÄ±lmÄ±ÅŸ (CSV) oluÅŸturur.  Microsoft Excel veya baÅŸka bir iÅŸleyici, aksi takdirde istenir dosyayÄ± kaydetmek iÃ§in yÃ¼klÃ¼yse, tarayÄ±cÄ±nÄ±zda gÃ¶rÃ¼ntÃ¼lenebilir.',0),(112865,3136,'pl','Generuje listÄ™ dostawcÃ³w rozdzielany przecinkami (CSV).  MogÄ… byÄ‡ wyÅ›wietlane w przeglÄ…darce, jeÅ›li program Microsoft Excel lub inny program obsÅ‚ugi jest zainstalowany, w przeciwnym razie pojawi siÄ™ monit do zapisania pliku.',0),(112866,3136,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð° Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½ ÑÑŠÑ Ð·Ð°Ð¿ÐµÑ‚Ð°Ð¸ (CSV) ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸.  ÐœÐ¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½Ð¸ Ð²ÑŠÐ² Ð²Ð°ÑˆÐ¸Ñ Ð±Ñ€Ð°ÑƒÐ·ÑŠÑ€, Ð°ÐºÐ¾ Microsoft Excel Ð¸Ð»Ð¸ Ð´Ñ€ÑƒÐ³ ÐœÐ°Ð½Ð¸Ð¿ÑƒÐ»Ð°Ñ‚Ð¾Ñ€ÑŠÑ‚ Ðµ Ð¸Ð½Ñ',0),(112867,3136,'ur','Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§Ù…Ø§ (CSV) Ø¯Ù„ÛŒÙ…Ø§Ù¹ÛŒØ¯ Ù¾ÛŒØ¯Ø§ Ú©Ø±ØªØ§ ÛÛ’ Û”  Ù…Ø§Ø¦ÛŒÚ©Ø±ÙˆØ³Ø§ÙÙ¹ Ø§ÛŒÚ©Ø³Ù„ ÛŒØ§ Ú©Ø³ÛŒ Ø¯ÙˆØ³Ø±Û’ Ù†Ø¨Ù¹ Ú©Ø§Ø±ØŒ Ø¨ØµÙˆØ±ØªÙ Ø¯ÛŒÚ¯Ø± Ø¢Ù¾ Ú©ÛØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§ Ù…Ø³Ù„ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø',0),(112868,3136,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑˆÐµ Ð·Ð°Ñ€ÐµÐ·Ð¾Ð¼ (Ð¦Ð¡Ð’) Ð»Ð¸ÑÑ‚Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°.  ÐœÐ¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½ Ñƒ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‡Ñƒ Ð°ÐºÐ¾ ÐœÐ¸Ñ†Ñ€Ð¾ÑÐ¾Ñ„Ñ‚ Ð•xÑ†ÐµÐ» Ð¸Ð»Ð¸ Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ñ€ÐµÐ³ÑƒÐ»Ð°Ñ‚Ð¾Ñ€Ð° Ñ˜Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½, Ñƒ ÑÑƒÐ¿Ñ€Ð¾Ñ‚Ð½Ð¾',0),(112869,3136,'vi','Táº¡o dáº¥u pháº©y ngÄƒn cÃ¡ch (CSV) danh sÃ¡ch cá»§a ngÆ°á»i bÃ¡n. CÃ³ thá»ƒ hiá»ƒn thá»‹ trÃªn trÃ¬nh duyá»‡t cá»§a báº¡n náº¿u cÃ³ Microsoft Excel hay pháº§n má»m khÃ¡c. Náº¿u khÃ´ng há»‡ thá»‘ng sáº½ nháº¯c báº¡n sao lÆ°u há»“ sÆ¡',0),(112870,3136,'af','Genereer \'n komma afgebaken (CSV) lys van verskaffers.  Mag vertoon word nie in jou blaaier as Microsoft Excel of \'n ander hanteerder geÃ¯nstalleer is, anders sal jy gevra word om die lÃªer te stoor.',0),(112871,3136,'ro','GenereazÄƒ o listÄƒ de virgulÄƒ (CSV) de furnizori.  Pot fi afiÅŸate Ã®n browser-ul Ã®n cazul Ã®n care Microsoft Excel sau alt handler este instalat, Ã®n caz contrar vi se va pentru a salva fiÅŸierul.',0),(112872,3136,'et','Loob komaeraldusega (CSV) tarnijate loend.  VÃµidakse kuvada brauseris Microsoft Exceli vÃµi teisele kÃ¤itlejale on installitud, muidu kÃ¼sitakse faili salvestada.',0),(112873,3136,'si','Ustvari loÄeno z vejicami (CSV) seznam prodajalcev.  Lahko se prikaÅ¾e v brskalniku, Äe Microsoft Excel ali drug trener je nameÅ¡Äen, drugaÄe boÅ¡ sufler reÅ¡iti pila.',0),(112874,3136,'ba','Menghasilkan daftar vendor comma delimited (CSV).  Dapat ditampilkan dalam browser Anda jika Microsoft Excel atau lain handler terinstal, jika tidak Anda akan diminta untuk menyimpan file.',0),(112875,3136,'nl','Genereert een door komma\'s gescheiden (CSV) lijst van leveranciers.  Kan worden weergegeven in uw browser als Microsoft Excel of een andere handler is geÃ¯nstalleerd, anders wordt u gevraagd het bestand op te slaan.',0),(112876,3136,'fi','Luo pilkulla (CSV) luettelo toimittajista.  Voi nÃ¤kyÃ¤ selaimen, jos Microsoft Excel- tai toinen kÃ¤sittelytoiminto on asennettu, muuten sinua pyydetÃ¤Ã¤n tallentamaan tiedoston.',0),(112877,3136,'no','Genererer en kommadelt (CSV) liste over leverandÃ¸rer.  Kan vises i leseren hvis Microsoft Excel eller et annet hÃ¥nd er installert, ellers vil du bli bedt om Ã¥ lagre filen.',0),(112878,3136,'da','Genererer en kommasepareret (CSV) liste over kreditorer.  Kan ses i browseren, hvis Microsoft Excel eller et andet handleren er installeret, ellers vil du blive bedt om at gemme filen.',0),(112879,3136,'ko','ê³µê¸‰ ì—…ì²´ì˜ ì‰¼í‘œë¡œ êµ¬ë¶„ ëœ (CSV) ëª©ë¡ì„ ìƒì„±í•©ë‹ˆë‹¤.  Microsoft Excel ë˜ëŠ” ë‹¤ë¥¸ ì²˜ë¦¬ê¸°ê°€ ì„¤ì¹˜ ëœ ê²½ìš°, ê·¸ë ‡ì§€ ì•Šìœ¼ë©´ ë©”ì‹œì§€ê°€ í‘œì‹œ ë©ë‹ˆë‹¤ íŒŒì¼ì„ ì €ìž¥í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤ ê·€í•˜ì˜ ë¸Œë¼ìš°ì €ì— í‘œì‹œ ë',0),(112880,3136,'he','×™×•×¦×¨ ×¨×©×™×ž×” ×ž×•×¤×¨×“×ª ×‘××ž×¦×¢×•×ª ×¤×¡×™×§ (CSV) ×©×œ ×¡×¤×§×™×.  ×¢×©×•×™×™× ×œ×”×™×•×ª ×ž×•×¦×’×™× ×‘×“×¤×“×¤×Ÿ ×©×œ×š ×× Microsoft Excel ××• ×‘×ž×˜×¤×œ ××—×¨ ×ž×•×ª×§×Ÿ, ××—×¨×ª ××ª×” ×ª×ª×‘×§×© ×œ×©×ž×•×¨ ××ª ×”×§×•×‘×¥.',0),(112881,3136,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯ Î¼Î¹Î± Î»Î¯ÏƒÏ„Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½ Î¿ÏÎ¹Î¿Î¸ÎµÏ„Î·Î¼Î­Î½Î¿ Î¼Îµ ÎºÏŒÎ¼Î¼Î±Ï„Î± (CSV).  Î•Î½Î´Î­Ï‡ÎµÏ„Î±Î¹ Î½Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ ÏƒÏ„Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Ï€ÎµÏÎ¹Î®Î³Î·ÏƒÎ·Ï‚, ÎµÎ¬Î½ Ï„Î¿ Microsoft Excel Î® Î­Î½Î± Î¬Î»Î»Î¿ ',0),(112882,3136,'zh','ç”Ÿæˆä¸€ä¸ªé€—å·åˆ†éš”ï¼ˆCSVï¼‰çš„ä¾›åº”å•†åå•ã€‚å¦‚æžœMicrosoft Excelæˆ–å…¶ä»–å¤„ç†ç¨‹åºè¢«å®‰è£…ï¼Œå¯èƒ½ä¼šæ˜¾ç¤ºåœ¨æ‚¨çš„æµè§ˆå™¨ï¼Œå¦åˆ™å°†æç¤ºæ‚¨ä¿å­˜æ–‡ä»¶ã€‚\r\n',0),(112883,3136,'sv','Genererar en kommaavgrÃ¤nsad (CSV) lista Ã¶ver leverantÃ¶rer.  Kan visas i din webblÃ¤sare om Microsoft Excel eller en annan hanterare Ã¤r installerat, annars blir du ombedd fÃ¶r att spara filen.',0),(112884,3136,'it','Genera un elenco delimitato da virgole (CSV) di fornitori.  Potrebbe essere visualizzato nel browser se Microsoft Excel o un altro gestore Ã¨ installato, in caso contrario verrÃ  chiesto di salvare il file.',0),(112885,3136,'tl','',0),(112886,3136,'th','Generates a comma delimited (CSV) list of vendors.  May be displayed in your browser if Microsoft Excel or another handler is installed, otherwise you will be prompted to save the file.',0),(112887,3136,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥€ à¤à¤• à¤¸à¥€à¤®à¤¾à¤‚à¤•à¤¿à¤¤ à¤…à¤²à¥à¤ªà¤µà¤¿à¤°à¤¾à¤® (CSV) à¤¸à¥‚à¤šà¥€ à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆà¥¤  Microsoft Excel à¤¯à¤¾ à¤…à¤¨à¥à¤¯ à¤¹à¥ˆà¤‚à¤¡à¤²à¤°, à¤…à¤¨à¥à¤¯à¤¥à¤¾ à¤†à¤ªà¤•à¥‹ à¤¸à¤‚à¤•à',0),(112888,3136,'ms','Menjana senarai vendor oleh delimited koma (CSV).  Mungkin dipaparkan di pelayar web anda jika Microsoft Excel atau pengendali lain dipasang, jika tidak anda akan dipromkan untuk menyimpan fail.',0),(112889,3136,'ar','ÙŠÙ†Ø´Ø¦ Ù‚Ø§Ø¦Ù…Ø© Ù…Ø­Ø¯Ø¯ Ø¨ÙØ§ØµÙ„Ø© (CSV) Ù…Ù† Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ†.  Ù‚Ø¯ ÙŠØªÙ… Ø¹Ø±Ø¶ ÙÙŠ Ø§Ù„Ù…Ø³ØªØ¹Ø±Ø¶ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø¥Ø°Ø§ ÙƒØ§Ù† Microsoft Excel Ø£Ùˆ Ù…Ø¹Ø§Ù„Ø¬ Ø¢Ø®Ø± Ù…Ø«Ø¨ØªØŒ ÙˆØ¥Ù„Ø§ Ø³ØªØªÙ… Ù…Ø·Ø§Ù„Ø¨ØªÙƒ Ø¨Ø­ÙØ¸ Ø§Ù„Ù…Ù„Ù.',0),(112890,3136,'fr','GÃ©nÃ¨re une liste par des virgules (CSV) des fournisseurs.  Peut sâ€™afficher dans votre navigateur si Microsoft Excel ou un autre gestionnaire est installÃ©, sinon vous serez invitÃ© Ã  enregistrer le fichier.',0),(112891,3136,'jp','ã‚³ãƒ³ãƒžåŒºåˆ‡ã‚Šï¼ˆï¼£ï¼³ï¼¶ï¼‰ã?®æ¥­è€…ãƒªã‚¹ãƒˆã‚’ä½œæˆ?ã?™ã‚‹ã€‚ãƒžã‚¤ã‚¯ãƒ­ã‚½ãƒ•ãƒˆã‚¨ã‚¯ã‚»ãƒ«ã?‹ä»–ã?®å?Œæ§˜ã‚½ãƒ•ãƒˆã?Œã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«ã?•ã‚Œã?¦ã?„ã‚Œã?°ã€?ãƒ–ãƒ©ã‚¦ã‚¶ã?«è¡¨ç¤ºã?•ã‚Œã?¾ã?™ã?Œã€?ã?ªã?‘ã‚Œã?°ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ä¿?å­˜ã?™ã‚‹ã‚ˆã?†ã?«',0),(112892,3136,'pt','Gera uma lista delimitado por vÃ­rgula (CSV) de fornecedores.  Pode ser exibido no seu navegador, se o Microsoft Excel ou outro manipulador Ã© instalado, caso contrÃ¡rio vocÃª serÃ¡ solicitado para salvar o arquivo.',0),(112893,3136,'ru','Ð¡Ð¾Ð·Ð´Ð°ÐµÑ‚ ÑÐ¿Ð¸ÑÐ¾Ðº Ñ Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑÐ¼Ð¸ Ð·Ð°Ð¿ÑÑ‚Ñ‹Ð¼Ð¸ (CSV) Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð².  Ð•ÑÐ»Ð¸ Microsoft Excel Ð¸Ð»Ð¸ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ñ‡Ð¸Ðº ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½, Ð² Ð¿Ñ€Ð¾Ñ‚Ð¸Ð²Ð½Ð¾Ð¼ ÑÐ»ÑƒÑ‡Ð°Ðµ Ð²Ð°Ð¼ Ð±ÑƒÐ´ÐµÑ‚ Ð¿Ñ€ÐµÐ´',0),(112894,3136,'es','Se Genera una lista de Proveedores delimitada por coma (CSV). Se puede desplegar en su browser si Microsoft Excel u otro manipulador esta instalado, de otra manera se pedirÃ¡ que guarda su file.',0),(112895,3136,'de','Erzeugt eine Komma getrennt (CSV) Liste der Anbieter.  Kann in Ihrem Browser angezeigt werden, wenn Microsoft Excel oder einem anderen Handler sonst werden Sie aufgefordert installiert ist, um die Datei zu speichern,',0),(112896,3136,'en','Generates a comma delimited (CSV) list of vendors.  May be displayed in your browser if Microsoft Excel or another handler is installed, otherwise you will be prompted to save the file.',0),(112897,3137,'is','',0),(112898,3137,'dr','Ø±ÙˆÙŠ ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³ØªÙŠ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§ØµÙ„ÙŠ Ù…Ø­Ù„ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø´Ù…Ø§ ',0),(112899,3137,'pr','Ø±ÙˆÙŠ ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³ØªÙŠ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§ØµÙ„ÙŠ Ù…Ø­Ù„ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø´Ù…Ø§ ',0),(112900,3137,'tr','MÃ¼ÅŸterileriniz iÃ§in ana konum bilgisi ekran listesi Ã¼zerinde.',0),(112901,3137,'pl','Na ekranie Lista informacji gÅ‚Ã³wnej lokalizacji dla swoich klientÃ³w.',0),(112902,3137,'bg','ÐÐ° ÐµÐºÑ€Ð°Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ð½Ð¸Ñ‚Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑÑ‚Ð° Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸.',0),(112903,3137,'ur','Ø³Ú©Ø±ÛŒÙ† Ú©ÛŒ ÙÛØ±Ø³Øª Ø¢Ù¾ Ú©Û’ Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ù„ÛŒÛ’ Ø§ØµÙ„ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù¾Ø± Û”',0),(112904,3137,'sr','ÐÐ° ÐµÐºÑ€Ð°Ð½Ñƒ Ð»Ð¸ÑÑ‚Ð° Ð³Ð»Ð°Ð²Ð½Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð·Ð° ÐºÑƒÐ¿Ñ†Ðµ.',0),(112905,3137,'vi','Danh sÃ¡ch trÃªn mÃ n hÃ¬nh thÃ´ng tin vá»‹ trÃ­ chÃ­nh dÃ nh cho khÃ¡ch hÃ ng cá»§a báº¡n.',0),(112906,3137,'af','Op die skerm lys van die belangrikste ligging-inligting vir jou kliÃ«nte.',0),(112907,3137,'ro','Pe ecran lista informaÅ£iilor locaÅ£ia principalÄƒ pentru clienÅ£ii dumneavoastrÄƒ.',0),(112908,3137,'et','Ekraani nimekirja peamine asukoht teabe oma klientidele.',0),(112909,3137,'si','Na zaslonu seznam glavnih podatkov o lokaciji za vaÅ¡e stranke.',0),(112910,3137,'ba','Di layar daftar informasi lokasi utama untuk pelanggan Anda.',0),(112911,3137,'nl','Op het scherm lijst van de belangrijkste locatie-informatie voor uw klanten.',0),(112912,3137,'fi','NÃ¤ytÃ¶n luettelossa Main sijaintitietojen asiakkaillesi.',0),(112913,3137,'no','PÃ¥ skjermen liste over Main stedsinformasjonen for kundene.',0),(112914,3137,'da','PÃ¥ skÃ¦rmen liste over de vigtigste geografiske oplysninger til dine kunder.',0),(112915,3137,'ko','ê³ ê°ì— ëŒ€ í•œ ì£¼ìš” ìœ„ì¹˜ ì •ë³´ í™”ë©´ ëª©ë¡.',0),(112916,3137,'he','×¢×œ ×ž×¡×š ×¨×©×™×ž×ª ×œ×ž×™×“×¢ ×”×ž×™×§×•× ×”×ž×¨×›×–×™ ×¢×‘×•×¨ ×”×œ×§×•×—×•×ª ×©×œ×š.',0),(112917,3137,'el','Î£Ï„Î· Î»Î¯ÏƒÏ„Î± Î¿Î¸ÏŒÎ½Î·Ï‚ Î³Î¹Î± Ï„Î·Î½ ÎºÏÏÎ¹Î± Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÏƒÎ±Ï‚.',0),(112918,3137,'zh','åœ¨å±å¹•ä¸Šæœ‰æ‚¨çš„å®¢æˆ·ä¿¡æ¯åˆ—è¡¨ã€‚',0),(112919,3137,'sv','PÃ¥ skÃ¤rmen lista Ã¶ver Main platsinformationen fÃ¶r dina kunder.',0),(112920,3137,'it','Lista di schermo dell\'informazione principale Location per i vostri clienti.',0),(112921,3137,'tl','',0),(112922,3137,'th','On screen list of the Main Location information for your customers.',0),(112923,3137,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤ªà¤° à¤®à¥à¤–à¥à¤¯ à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤ªà¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€à¥¤',0),(112924,3137,'ms','Pada skrin senarai maklumat lokasi utama bagi pelanggan-pelanggan anda.',0),(112925,3137,'ar','Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø§Ø´Ø© Ù‚Ø§Ø¦Ù…Ø© Ø¨Ù…Ø¹Ù„ÙˆÙ…Ø§Øª \"Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ\" Ù„Ø¹Ù…Ù„Ø§Ø¦Ùƒ.',0),(112926,3137,'fr','Sur la liste d\'Ã©cran les Main des informations de localisation pour vos clients.',0),(112927,3137,'jp','é¡§å®¢ç”¨ä¸»è¦?ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³æƒ…å ±ã?®ç”»é?¢ä¸Šãƒªã‚¹ãƒˆ',0),(112928,3137,'pt','Na lista da tela da informaÃ§Ã£o principal local para seus clientes.',0),(112929,3137,'ru','ÐÐ° ÑÐºÑ€Ð°Ð½Ðµ ÑÐ¿Ð¸ÑÐ¾Ðº Ð³Ð»Ð°Ð²Ð½Ñ‹Ñ… Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð´Ð»Ñ Ð²Ð°ÑˆÐ¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð².',0),(112930,3137,'es','Lista en pantalla de la informaciÃ³n de ColocaciÃ³n Principal de sus clientes',0),(112931,3137,'de','Auf Bildschirm-Liste der Main Standortinformationen fÃ¼r Ihre Kunden.',0),(112932,3137,'en','On screen list of the Main Location information for your customers.',0),(112933,3138,'is','',0),(112934,3138,'dr','Ø±ÙˆÙŠ ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³ØªÙŠ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­Ù„ Ø­Ù…Ù„ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø´Ù…Ø§',0),(112935,3138,'pr','Ø±ÙˆÙŠ ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³ØªÙŠ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­Ù„ Ø­Ù…Ù„ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø´Ù…Ø§',0),(112936,3138,'tr','MÃ¼ÅŸterileriniz iÃ§in nakliye konum bilgisi ekran listesi Ã¼zerinde.',0),(112937,3138,'pl','Na ekranie Lista lokalizacji wysyÅ‚ka informacji dla klientÃ³w.',0),(112938,3138,'bg','ÐÐ° ÐµÐºÑ€Ð°Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑÑ‚Ð° Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸.',0),(112939,3138,'ur','Ø³Ú©Ø±ÛŒÙ† Ú©ÛŒ ÙÛØ±Ø³Øª Ø¢Ù¾ Ú©Û’ Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ù„ÛŒÛ’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø´Ù¾Ù†Ú¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù¾Ø± Û”',0),(112940,3138,'sr','ÐÐ° ÐµÐºÑ€Ð°Ð½Ñƒ Ð»Ð¸ÑÑ‚Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð·Ð° ÐºÑƒÐ¿Ñ†Ðµ.',0),(112941,3138,'vi','MÃ n hÃ¬nh liá»‡t kÃª thÃ´ng tin Ä‘á»‹a chá»‰ chuyá»ƒn hÃ ng cho khÃ¡ch hÃ ng cá»§a báº¡n',0),(112942,3138,'af','Op die skerm lys van die gestuur ligginginligting vir jou kliÃ«nte.',0),(112943,3138,'ro','Pe ecran lista de informaÅ£ii de transport maritim locaÅ£ie pentru clienÅ£ii dumneavoastrÄƒ.',0),(112944,3138,'et','Ekraani loendis laevanduse asukohateavet oma klientidele.',0),(112945,3138,'si','Na zaslonu seznam dostava podatkov o lokaciji za vaÅ¡e stranke.',0),(112946,3138,'ba','Di layar daftar informasi lokasi pengiriman untuk pelanggan Anda.',0),(112947,3138,'nl','Op de lijst van het scherm van de scheepvaart locatie-informatie voor uw klanten.',0),(112948,3138,'fi','NÃ¤ytÃ¶n luettelossa Shipping sijaintitietojen asiakkaillesi.',0),(112949,3138,'no','PÃ¥ skjermen liste over Shipping stedsinformasjonen for kundene.',0),(112950,3138,'da','PÃ¥ skÃ¦rmen liste den Shipping positionsoplysninger for dine kunder.',0),(112951,3138,'ko','ê³ ê°ì— ëŒ€ í•œ ë°°ì†¡ ìœ„ì¹˜ ì •ë³´ í™”ë©´ ëª©ë¡.',0),(112952,3138,'he','×¢×œ ×ž×¡×š ×¨×©×™×ž×ª ×œ×ž×™×“×¢ ×”×ž×™×§×•× ×ž×©×œ×•×— ×¢×‘×•×¨ ×”×œ×§×•×—×•×ª ×©×œ×š.',0),(112953,3138,'el','Î£Ï„Î·Î½ Î»Î¯ÏƒÏ„Î± Ï„Î·Ï‚ Î¿Î¸ÏŒÎ½Î·Ï‚ Ï„Ï‰Î½ Î½Î±Ï…Ï„Î¹Î»Î¯Î± Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÏƒÎ±Ï‚.',0),(112954,3138,'zh','åœ¨å±å¹•ä¸Šæ‚¨çš„å®¢æˆ·æœ‰å‘è´§ä½ç½®ä¿¡æ¯åå•ã€‚\r\n',0),(112955,3138,'sv','PÃ¥ skÃ¤rmen lista Ã¶ver frakt platsinformationen fÃ¶r dina kunder.',0),(112956,3138,'it','Lista di schermo delle informazioni di spedizione posizione per i vostri clienti.',0),(112957,3138,'tl','',0),(112958,3138,'th','On screen list of the Shipping Location information for your customers.',0),(112959,3138,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤ªà¤° à¤…à¤ªà¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥€ à¤¸à¥‚à¤šà¥€à¥¤',0),(112960,3138,'ms','Pada skrin senarai maklumat lokasi penghantaran untuk pelanggan anda.',0),(112961,3138,'ar','Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø§Ø´Ø© Ù‚Ø§Ø¦Ù…Ø© Ù…Ù† Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª \"Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø´Ø­Ù†\" Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡.',0),(112962,3138,'fr','Sur la liste d\'Ã©cran l\'expÃ©dition des informations de localisation pour vos clients.',0),(112963,3138,'jp','é¡§å®¢ç”¨é…?é€?ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³æƒ…å ±ã?®ç”»é?¢ä¸Šãƒªã‚¹ãƒˆ',0),(112964,3138,'pt','Na lista de tela as envio de informaÃ§Ãµes de localizaÃ§Ã£o para os seus clientes.',0),(112965,3138,'ru','ÐÐ° ÑÐºÑ€Ð°Ð½Ðµ ÑÐ¿Ð¸ÑÐ¾Ðº Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð´Ð»Ñ Ð²Ð°ÑˆÐ¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð².',0),(112966,3138,'es','Lista en pantalla de la informaciÃ³n de EnvÃ­o de sus clientes',0),(112967,3138,'de','Auf Bildschirm-Liste der Versand Standortinformationen fÃ¼r Ihre Kunden.',0),(112968,3138,'en','On screen list of the Shipping Location information for your customers.',0),(112969,3139,'is','',0),(112970,3139,'dr','(Ex. LocalHost)',0),(112971,3139,'pr','Ù…ÙƒØ§Ù† Ø¯Ø§Ø®Ù„ÙŠ Ø³Ø±ÙˆØ± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ (Ex. LocalHost)',0),(112972,3139,'tr','Yerel veritabanÄ± sunucusu (Ex. LocalHost) konumunu',0),(112973,3139,'pl','Lokalizacja lokalna baza danych serwera (Ex. LocalHost)',0),(112974,3139,'bg','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° ÑÑŠÑ€Ð²ÑŠÑ€Ð° Ð·Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ (Ð½Ð°Ð¿Ñ€. LocalHost)',0),(112975,3139,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù¾ÛŒØ´ Ú©Ø§Ø± (Ø¢Ø±Ú© Ù…Ù‚Ø§Ù…ÛŒ Ù…ÛŒØ²Ø¨Ø§Ù† Ú©Ø§) Ú©Û’ Ù…Ù‚Ø§Ù…ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(112976,3139,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¸ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ ÑÐµÑ€Ð²ÐµÑ€Ð° Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° (Ð½Ð¿Ñ€. Ð›Ð¾Ñ†Ð°Ð»Ð¥Ð¾ÑÑ‚)',0),(112977,3139,'vi','Vá»‹ trÃ­ Ä‘á»‹a phÆ°Æ¡ng cá»§a mÃ¡y chá»§ dá»¯ liá»‡u (Ex.LocalHost)',0),(112978,3139,'af','Plaaslike ligging van databasisbediener (Ex. LocalHost)',0),(112979,3139,'ro','Locale locaÅ£ia server de baze de date (de Ex. LocalHost)',0),(112980,3139,'et','Andmebaasi serveri (2Ms LocalHost) kohaliku asukohta',0),(112981,3139,'si','Lokalni mesto zbirke podatkov streÅ¾nika (Ex. LocalHost)',0),(112982,3139,'ba','Lokasi lokal server database (Ex. LocalHost)',0),(112983,3139,'nl','Lokale locatie van de databaseserver (Ex. LocalHost)',0),(112984,3139,'fi','Paikallisesti tietokantapalvelimen (Ex. LocalHost)',0),(112985,3139,'no','Lokale plasseringen til databaseserveren (Ex. LocalHost)',0),(112986,3139,'da','Lokale placering af database-server (Ex. LocalHost)',0),(112987,3139,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì„œë²„ (ì˜ˆ: LocalHost)ì˜ í˜„ì§€ ìœ„ì¹˜',0),(112988,3139,'he','×ž×™×§×•× ×ž×§×•×ž×™ ×©×œ ×©×¨×ª ×ž×¡×“ ×”× ×ª×•× ×™× (××§×¡ LocalHost)',0),(112989,3139,'el','Î¤Î¿Ï€Î¹ÎºÎ® Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Ï„Î¿Ï… Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î® (LocalHost Ï€.Ï‡.)',0),(112990,3139,'zh','æœ¬åœ°æ•°æ®åº“æœåŠ¡å™¨çš„ä½ç½®ï¼ˆä¾‹å¦‚ï¼šæœ¬åœ°ä¸»æœºï¼‰\r\n',0),(112991,3139,'sv','Lokal plats pÃ¥ databasservern (Ex. LocalHost)',0),(112992,3139,'it','Percorso locale del server di database (es. LocalHost)',0),(112993,3139,'tl','',0),(112994,3139,'th','Local location of database server (Ex. LocalHost)',0),(112995,3139,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤°à¥à¤µà¤° (à¤‰à¤¦à¤¾. LocalHost) à¤•à¥‡ à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤¸à¥à¤¥à¤¾à¤¨',0),(112996,3139,'ms','Lokasi pelayan pangkalan data (cth LocalHost)',0),(112997,3139,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø­Ù„ÙŠ Ù„Ø®Ø§Ø¯Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª (Ù…Ø«Ø§Ù„: LocalHost)',0),(112998,3139,'fr','Emplacement local du serveur de base de donnÃ©es (Ex. LocalHost)',0),(112999,3139,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚µãƒ¼ãƒ?ãƒ¼ã?®ãƒ­ãƒ¼ã‚«ãƒ«ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ï¼ˆä¾‹ï¼šãƒ­ãƒ¼ã‚«ãƒ«ãƒ›ã‚¹ãƒˆï¼‰',0),(113000,3139,'pt','LocalizaÃ§Ã£o local do servidor de banco de dados (ex.: LocalHost)',0),(113001,3139,'ru','Ð›Ð¾ÐºÐ°Ð»ÑŒÐ½Ð¾Ðµ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ ÑÐµÑ€Ð²ÐµÑ€Ð° Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… (Ex. LocalHost)',0),(113002,3139,'es','ColocaciÃ³n local del servido de base de datos (Ej. LocalHost)',0),(113003,3139,'de','Lokalen Speicherort des Datenbank-Servers (Z.B. LocalHost)',0),(113004,3139,'en','Local location of database server (Ex. LocalHost)',0),(113005,3140,'is','',0),(113006,3140,'dr','. Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¨Ù‡ ØµÙˆØ±Øª ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¯Ø± Ù¾Ù†Ø¬Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ .Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ ØµØ­ÙŠØ­ Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø¢ÙƒØ±',0),(113007,3140,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ØµÙØ­Ù‡ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ù†Ø§Ù…Ù‡ Ù†Ú¯Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø´Ù…Ø§. Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¨Ù‡ ØµÙˆØ±Øª ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¯Ø± Ù¾Ù†Ø¬Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ .Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ ØµØ­ÙŠØ­ Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø¢ÙƒØ±',0),(113008,3140,'tr','Posta etiketleri SatÄ±cÄ±lar (<nobr>1 x 2,63 inÃ§</nobr> iÃ§in bir sayfa oluÅŸturur -her sayfada 30 - Avery 5160). Yeni bir pencerede bir PDF belgesi olarak gÃ¶rÃ¼ntÃ¼lenebilir.  Adobe Acrobat Reader veya kendisi doÄŸru olarak gÃ¶rÃ¼ntÃ¼lemek iÃ§in baÅŸka',0),(113009,3140,'pl','Generuje stronÄ™ etykiet adresowych dla dostawcÃ³w (<nobr>1 x 2,63 cale</nobr> -30 za stronÄ™ - Avery 5160). MogÄ… byÄ‡ wyÅ›wietlane jako dokument PDF w nowym oknie.  Wymaga programu Adobe Acrobat Reader lub innej przeglÄ…darki PDF do wyÅ›wietlania samego',0),(113010,3140,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð½Ð° Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸ Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ (<nobr>1 x 2.63 Ð¸Ð½Ñ‡Ð°</nobr> -30 Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° - Ð•Ð¹Ð²ÑŠÑ€Ð¸ 5160). ÐœÐ¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð¶Ðµ ÐºÐ°Ñ‚Ð¾ PDF Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð² ',0),(113011,3140,'ur','ØªØ±Ø³ÛŒÙ„ÛŒ Ù„ÛŒØ¨Ù„ Ø¢Ù¾ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©Û’ Ù„Ø¦Û’ (<nobr>1 x 2.63 Ú©Ù¹</nobr> Ú©Û’ Ø§ÛŒÚ© ØµÙØ­Û Ù¾ÛŒØ¯Ø§ Ú©Ø±ØªØ§ ÛÛ’ -30 ÙÛŒ ØµÙØ­Û - Ø§ÛŒÙˆØ±ÛŒ 5160) Û” Ø§ÛŒÚ© Ù†Ø¦ÛŒ ÙˆÙ†ÚˆÙˆ Ù…ÛŒÚº Ø§ÛŒÚ© PDF Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†ÛÛŒÚº Ø¯Ú',0),(113012,3140,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑˆÐµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÑÐ° Ð½Ð°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ðµ ÑÐ° Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ (<nobr>1 x 2.63 Ð¸Ð½Ñ‡Ð°</nobr> -30 Ð¿Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ - ÐÐ²ÐµÑ€y 5160). ÐœÐ¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½ ÐºÐ°Ð¾ ÐŸÐ”Ð¤ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñƒ Ð½Ð¾Ð²Ð',0),(113013,3140,'vi','Táº¡o má»™t trang nhÃ£n bao thÆ° cho ngÆ°á»i bÃ¡n cá»§a báº¡n (1 x 2.63 in. - 30 per page - Avery 5160). CÃ³ thá»ƒ hiá»‡n thá»‹ dáº¡ng PDF trong cá»­a sá»• má»›i. Cáº§n cÃ³ Adobe Acrobat hay PDF viewer Ä‘á»ƒ hiá»ƒn thá»‹ Ä‘Ãºng.',0),(113014,3140,'af','Genereer \'n bladsy van versending etikette vir jou verskaffers (<nobr>1 x 2.63 in.</nobr> -30 per bladsy - Avery 5160). Kan as \'n PDF dokument in \'n nuwe venster vertoon word.  Dit vereis Adobe Acrobat Reader of nog \'n PDF leser self om korrek te vertoon.',0),(113015,3140,'ro','GenereazÄƒ o paginÄƒ de etichete poÅŸtale pentru furnizorii dumneavoastrÄƒ (<nobr>in. 1 x 2.63</nobr> -30 pe filme - Avery 5160). Pot fi afiÅŸate Ã®n format PDF Ã®ntr-o fereastrÄƒ nouÄƒ.  Este nevoie de Adobe Acrobat Reader sau alt PDF viewer pentru a se ',0),(113016,3140,'et','Loob oma hankijatele (<nobr>1 x 2,63 sisse</nobr> aadressisiltide lehe -30 Lk - Avery 5160). Kui PDF-dokument uues aknas kuvada.  Selleks on vaja Adobe Acrobat Readeri vÃµi mÃµne muu PDF vaataja ise Ãµigesti kuvada.',0),(113017,3140,'si','Ustvari stran nalepke za dobavitelje (<nobr>1 x 2,63 noter</nobr> -30 na strani - Avery 5160). Lahko se prikaÅ¾e kot PDF dokument v novem oknu.  To zahteva Adobe Acrobat Reader ali drug pregledovalnik PDF sama pravilno prikazati.',0),(113018,3140,'ba','Menghasilkan halaman label surat untuk vendor Anda (<nobr>1 x 2,63 in.</nobr> -30 per halaman - Avery 5160). Dapat ditampilkan sebagai dokumen PDF di jendela baru.  Hal ini membutuhkan Adobe Acrobat Reader atau lain PDF viewer untuk menampilkan dirinya se',0),(113019,3140,'nl','Genereert een pagina met adresetiketten voor uw leveranciers (<nobr>1 x 2,63 in.</nobr> -30 per pagina - Avery 5160). Kan worden weergegeven als een PDF-document in een nieuw venster.  Het vereist Adobe Acrobat Reader of een andere PDF viewer zelf correct',0),(113020,3140,'fi','Luo sivun osoitetarrojen toimittajille (<nobr>1 x 2,63 in.</nobr> -30 per sivu - Avery 5160). Voi nÃ¤kyÃ¤ uuteen ikkunaan PDF-dokumenttina.  Se vaatii Adobe Acrobat Reader tai toinen PDF-katseluohjelma nÃ¤yttÃ¤Ã¤ itse oikein.',0),(113021,3140,'no','Genererer en side med adresseetiketter for leverandÃ¸rer (<nobr>1 x 2.63 tommer</nobr> -30 per side - Avery 5160). Kan vises som et PDF-dokument i et nytt vindu.  Det krever Adobe Acrobat Reader eller et annet PDF seer Ã¥ vise seg riktig.',0),(113022,3140,'da','Genererer en side af adresseetiketter til dine kreditorer (<nobr>1 x 2,63 in.</nobr> -30 pr. side - Avery 5160). Kan vises som et PDF-dokument i et nyt vindue.  Det krÃ¦ver Adobe Acrobat Reader eller en anden PDF-fremviser til at vise sig selv korrekt.',0),(113023,3140,'ko','ê³µê¸‰ ì—…ì²´ (<nobr>1 x 2.63 ì¸ì¹˜</nobr> ì— ëŒ€ í•œ ìš°íŽ¸ë¬¼ ë ˆì´ë¸” íŽ˜ì´ì§€ë¥¼ ìƒì„± -íŽ˜ì´ì§€ ë‹¹ 30-Avery 5160). ìƒˆ ì°½ì—ì„œ PDF ë¬¸ì„œë¡œ í‘œì‹œ ë  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.  Adobe Acrobat Reader ë˜ëŠ” ë‹¤ë¥¸ PDF ë·°ì–´ë¥¼ ì˜¬ë°”ë¥´ê²Œ í‘œì‹œ í',0),(113024,3140,'he','×™×•×¦×¨ ×¢×ž×•×“ ×©×œ ×ª×•×•×™×•×ª ×ž×¢×Ÿ ×©×œ×š ×œ×¡×¤×§×™× (<nobr>1 x 2.63 in...</nobr> -30 ×‘×›×œ ×¢×ž×•×“ - ××™×™×‘×¨×™ 5160). ×¢×©×•×™ ×œ×”×™×•×ª ×ž×•×¦×’ ×ž×¡×ž×š PDF ×‘×—×œ×•×Ÿ ×—×“×©.  ×–×” ×“×•×¨×© Adobe Acrobat Reader ××• ×”×¦×•×¤×” PDF ××—',0),(113025,3140,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯ Î¼Î¹Î± ÏƒÎµÎ»Î¯Î´Î± ÎµÏ„Î¹ÎºÎµÏ„ÏŽÎ½ Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ ÏƒÎ±Ï‚ (<nobr>1 x 2,63 in.</nobr> -30 Î±Î½Î¬ ÏƒÎµÎ»Î¯Î´Î± - Avery 5160). Î•Î½Î´Î­Ï‡ÎµÏ„Î±Î¹ Î½Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ Ï‰Ï‚ Î­Î½Î± Î',0),(113026,3140,'zh','ä¸ºæ‚¨çš„ä¾›åº”å•†ç”Ÿæˆä¸€ä¸ªé‚®ä»¶æ ‡ç­¾ç½‘é¡µï¼ˆ1Ã—2.63è‹±å¯¸-æ¯é¡µ30 -è‰¾å¼—é‡Œ5160ï¼‰ã€‚å¯èƒ½ä¼šæ˜¾ç¤ºä¸ºåœ¨æ–°è§†çª—PDFæ–‡æ¡£ã€‚å®ƒéœ€è¦Adobe Acrobat Readeræˆ–å…¶ä»–PDFæŸ¥çœ‹å™¨æ˜¾ç¤º\r\n',0),(113027,3140,'sv','Genererar en sida av adressetiketter fÃ¶r leverantÃ¶rer (<nobr>1 x 2,63 in.</nobr> -30 per sida - Avery 5160). Kan visas som ett PDF-dokument i ett nytt fÃ¶nster.  Det krÃ¤vs Adobe Acrobat Reader eller annan PDF-lÃ¤sare att visa sig korrekt.',0),(113028,3140,'it','Genera una pagina di etichette di indirizzi per i fornitori (<nobr>1 x 2.63 pollici</nobr> -30 per pagina - Avery 5160). PuÃ² essere visualizzato come un documento PDF in una nuova finestra.  Richiede Adobe Acrobat Reader o un altro visualizzatore di PDF ',0),(113029,3140,'tl','',0),(113030,3140,'th','Generates a page of mailing labels for your vendors (<nobr>1 x 2.63 in. </nobr>- 30 per page - Avery 5160). May be displayed as a PDF document in a new window.  It requires Adobe Acrobat Reader or another PDF viewer to display itself correctly.',0),(113031,3140,'hi','à¤…à¤ªà¤¨à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ (<nobr>1 x 2, 63 à¤‡à¤‚à¤š</nobr> à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‡à¤²à¤¿à¤‚à¤— à¤²à¥‡à¤¬à¤²à¥à¤¸ à¤•à¤¾ à¤à¤• à¤ªà¥ƒà¤·à¥à¤  à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ -à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¥ƒà¤·à¥à¤  30 - à¤à¤µà¤°à¥€ 5160)',0),(113032,3140,'ms','Menjana satu halaman surat menyurat label untuk vendor anda (<nobr>1 x 2,63 in.</nobr> -30 setiap muka - Avery 5160). Mungkin dipaparkan sebagai dokumen PDF dalam tetingkap baru.  Ia memerlukan Adobe Acrobat Reader atau pelihat PDF lain untuk mempamerkan ',0),(113033,3140,'ar','ÙŠÙ‚ÙˆÙ… Ø¨Ø¥Ù†Ø´Ø§Ø¡ ØµÙØ­Ø© Ù…Ù† Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø¹Ù†ÙˆÙ†Ø© Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠØ© Ù„Ù„Ù…ÙˆØ±Ø¯ÙŠÙ† (<nobr>1 Ã— 2.63 ØªÙ„Ø¨ÙŠØªÙ‡Ø§ØŒ</nobr> -30 Ù„ÙƒÙ„ ØµÙØ­Ø©-Avery 5160). Ù‚Ø¯ ÙŠØªÙ… Ø¹Ø±Ø¶ ÙƒÙˆØ«ÙŠÙ‚Ø© PDF ÙÙŠ Ù†Ø§ÙØ°Ø© Ø¬Ø¯ÙŠØ¯Ø©.  ÙˆÙ‡ÙŠ ØªØªØ·Ù„Ø¨ ',0),(113034,3140,'fr','GÃ©nÃ¨re une page dâ€™Ã©tiquettes de publipostage pour vos fournisseurs (<nobr>1 x 2,63 po</nobr> -30 par page - Avery 5160). Peut sâ€™afficher comme un document PDF dans une nouvelle fenÃªtre.  Il nÃ©cessite Adobe Acrobat Reader ou un autre lecteur PDF p',0),(113035,3140,'jp','æ¥­è€…ã?®å®›å??ãƒªã‚¹ãƒˆãƒšãƒ¼ã‚¸ã‚’ä½œæˆ?ã?™ã‚‹ã€‚(<nobr>1 x 2.63 in. </nobr>- 30 per page - Avery 5160)æ–°ã?—ã?„ã‚¦ã‚¤ãƒ³ãƒ‰ã‚¦ã?«ï¼°ï¼¤ï¼¦ã?§è¡¨ç¤ºã?•ã‚Œã‚‹ã‚‚ã?®ã?¨ã?™ã‚‹ã€‚æ­£ã?—ã??è¡¨ç¤ºã?•ã?›ã‚‹ã?«ã?¯ã‚¢ãƒ‰ãƒ“ã‚¢ã‚¯ãƒ­ãƒ?ãƒƒãƒˆãƒªãƒ¼ãƒ€ãƒ¼ã?‹ä»–ã?®',0),(113036,3140,'pt','Gera uma pÃ¡gina de etiquetas de endereÃ§amento para seus fornecedores (<nobr>2,63 x 1 pol.</nobr> -30 por pÃ¡gina - Avery 5160). Pode ser exibido como um documento PDF em uma nova janela.  Requer Adobe Acrobat Reader ou outro visualizador PDF para exibir',0),(113037,3140,'ru','Ð¡Ð¾Ð·Ð´Ð°ÐµÑ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð¿Ð¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ñ… Ð½Ð°ÐºÐ»ÐµÐµÐº Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² (<nobr>1 x 2,63 Ð´ÑŽÐ¹Ð¼Ð°</nobr> -30 Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ - Avery 5160). ÐœÐ¾Ð¶ÐµÑ‚ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒÑÑ Ð² Ð²Ð¸Ð´Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° PDF Ð² Ð½Ð¾Ð²Ð¾Ð¼ Ð',0),(113038,3140,'es','Se genera una pÃ¡gina de etiquetas de correo para sus Proveedores (1 x 2.63 en. - 30 por Hoja - Avery 5160. Se puede desplegar como documento PDF en una nueva ventana. Se requiere Adobe Acrobat Reader u otro visualizador para desplegar correc',0),(113039,3140,'de','Erzeugt eine Seite von Adressetiketten fÃ¼r Ihre Kreditoren (<nobr>1 x 2,63 Zoll</nobr> -30 pro Seite - Avery 5160). Kann als PDF-Dokument in einem neuen Fenster angezeigt werden.  Es erfordert Adobe Acrobat Reader oder einem anderen PDF-Viewer selbst kor',0),(113040,3140,'en','Generates a page of mailing labels for your vendors (<nobr>1 x 2.63 in. </nobr>- 30 per page - Avery 5160). May be displayed as a PDF document in a new window.  It requires Adobe Acrobat Reader or another PDF viewer to display itself correctly.',0),(113041,3141,'is','',0),(113042,3141,'dr','. Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¨Ù‡ ØµÙˆØ±Øª ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¯Ø± Ù¾Ù†Ø¬Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ .Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ ØµØ­ÙŠØ­ Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø¢ÙƒØ±',0),(113043,3141,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ØµÙØ­Ù‡ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ù†Ø§Ù…Ù‡ Ù†Ú¯Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø´Ù…Ø§. Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¨Ù‡ ØµÙˆØ±Øª ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¯Ø± Ù¾Ù†Ø¬Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ .Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ ØµØ­ÙŠØ­ Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø¢ÙƒØ±',0),(113044,3141,'tr','Posta etiketleri SatÄ±cÄ±lar (<nobr>1 x 2,63 inÃ§</nobr> iÃ§in bir sayfa oluÅŸturur -her sayfada 30 - Avery 5160). Yeni bir pencerede bir PDF belgesi olarak gÃ¶rÃ¼ntÃ¼lenebilir.  Adobe Acrobat Reader veya kendisi doÄŸru olarak gÃ¶rÃ¼ntÃ¼lemek iÃ§in baÅŸka',0),(113045,3141,'pl','Generuje stronÄ™ etykiet adresowych dla dostawcÃ³w (<nobr>1 x 2,63 cale</nobr> -30 za stronÄ™ - Avery 5160). MogÄ… byÄ‡ wyÅ›wietlane jako dokument PDF w nowym oknie.  Wymaga programu Adobe Acrobat Reader lub innej przeglÄ…darki PDF do wyÅ›wietlania samego',0),(113046,3141,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð½Ð° Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸ Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ (<nobr>1 x 2.63 Ð¸Ð½Ñ‡Ð°</nobr> -30 Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° - Ð•Ð¹Ð²ÑŠÑ€Ð¸ 5160). ÐœÐ¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð¶Ðµ ÐºÐ°Ñ‚Ð¾ PDF Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð² ',0),(113047,3141,'ur','ØªØ±Ø³ÛŒÙ„ÛŒ Ù„ÛŒØ¨Ù„ Ø¢Ù¾ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©Û’ Ù„Ø¦Û’ (<nobr>1 x 2.63 Ú©Ù¹</nobr> Ú©Û’ Ø§ÛŒÚ© ØµÙØ­Û Ù¾ÛŒØ¯Ø§ Ú©Ø±ØªØ§ ÛÛ’ -30 ÙÛŒ ØµÙØ­Û - Ø§ÛŒÙˆØ±ÛŒ 5160) Û” Ø§ÛŒÚ© Ù†Ø¦ÛŒ ÙˆÙ†ÚˆÙˆ Ù…ÛŒÚº Ø§ÛŒÚ© PDF Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†ÛÛŒÚº Ø¯Ú',0),(113048,3141,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑˆÐµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÑÐ° Ð½Ð°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ðµ ÑÐ° Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ (<nobr>1 x 2.63 Ð¸Ð½Ñ‡Ð°</nobr> -30 Ð¿Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ - ÐÐ²ÐµÑ€y 5160). ÐœÐ¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½ ÐºÐ°Ð¾ ÐŸÐ”Ð¤ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñƒ Ð½Ð¾Ð²Ð',0),(113049,3141,'vi','Táº¡o trang nhÃ£n bao thÆ° cho ngÆ°á»i bÃ¡n cá»§a báº¡n (1 x 2.63 in. - 30 má»—i trang - trung bÃ¬nh 5160). CÃ³ thá»ƒ hiá»ƒn thá»‹ dáº¡ng PDF á»Ÿ cá»­a sá»• má»›i. Cáº§n pháº£i cÃ³ Adobe Acrobat Reader hay má»™t pháº§n má»m Ä‘á»c PDF khÃ¡c',0),(113050,3141,'af','Genereer \'n bladsy van posetikette vir u verskaffers 91 x 2.63\" - 30 per bladsy - Avery 5160). Mag vertoon word as \'n PDF dokument in \'n nuwe venster.  Dit benodig Adobe Acrobat Reader of \'n ander PDF leeser to dit korrek te vertoon.',0),(113051,3141,'ro','GenereazÄƒ o paginÄƒ de etichete poÅŸtale pentru furnizorii dumneavoastrÄƒ (<nobr>in. 1 x 2.63</nobr> -30 pe filme - Avery 5160). Pot fi afiÅŸate Ã®n format PDF Ã®ntr-o fereastrÄƒ nouÄƒ.  Este nevoie de Adobe Acrobat Reader sau alt PDF viewer pentru a se ',0),(113052,3141,'et','Loob oma hankijatele (<nobr>1 x 2,63 sisse</nobr> aadressisiltide lehe -30 Lk - Avery 5160). Kui PDF-dokument uues aknas kuvada.  Selleks on vaja Adobe Acrobat Readeri vÃµi mÃµne muu PDF vaataja ise Ãµigesti kuvada.',0),(113053,3141,'si','Ustvari stran nalepke za dobavitelje (<nobr>1 x 2,63 noter</nobr> -30 na strani - Avery 5160). Lahko se prikaÅ¾e kot PDF dokument v novem oknu.  To zahteva Adobe Acrobat Reader ali drug pregledovalnik PDF sama pravilno prikazati.',0),(113054,3141,'ba','Menghasilkan halaman label surat untuk vendor Anda (<nobr>1 x 2,63 in.</nobr> -30 per halaman - Avery 5160). Dapat ditampilkan sebagai dokumen PDF di jendela baru.  Hal ini membutuhkan Adobe Acrobat Reader atau lain PDF viewer untuk menampilkan dirinya se',0),(113055,3141,'nl','Genereert een pagina met adresetiketten voor uw leveranciers (<nobr>1 x 2,63 in.</nobr> -30 per pagina - Avery 5160). Kan worden weergegeven als een PDF-document in een nieuw venster.  Het vereist Adobe Acrobat Reader of een andere PDF viewer zelf correct',0),(113056,3141,'fi','Luo sivun osoitetarrojen toimittajille (<nobr>1 x 2,63 in.</nobr> -30 per sivu - Avery 5160). Voi nÃ¤kyÃ¤ uuteen ikkunaan PDF-dokumenttina.  Se vaatii Adobe Acrobat Reader tai toinen PDF-katseluohjelma nÃ¤yttÃ¤Ã¤ itse oikein.',0),(113057,3141,'no','Genererer en side med adresseetiketter for leverandÃ¸rer (<nobr>1 x 2.63 tommer</nobr> -30 per side - Avery 5160). Kan vises som et PDF-dokument i et nytt vindu.  Det krever Adobe Acrobat Reader eller et annet PDF seer Ã¥ vise seg riktig.',0),(113058,3141,'da','Genererer en side af adresseetiketter til dine kreditorer (<nobr>1 x 2,63 in.</nobr> -30 pr. side - Avery 5160). Kan vises som et PDF-dokument i et nyt vindue.  Det krÃ¦ver Adobe Acrobat Reader eller en anden PDF-fremviser til at vise sig selv korrekt.',0),(113059,3141,'ko','ê³µê¸‰ ì—…ì²´ (<nobr>1 x 2.63 ì¸ì¹˜</nobr> ì— ëŒ€ í•œ ìš°íŽ¸ë¬¼ ë ˆì´ë¸” íŽ˜ì´ì§€ë¥¼ ìƒì„± -íŽ˜ì´ì§€ ë‹¹ 30-Avery 5160). ìƒˆ ì°½ì—ì„œ PDF ë¬¸ì„œë¡œ í‘œì‹œ ë  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.  Adobe Acrobat Reader ë˜ëŠ” ë‹¤ë¥¸ PDF ë·°ì–´ë¥¼ ì˜¬ë°”ë¥´ê²Œ í‘œì‹œ í',0),(113060,3141,'he','×™×•×¦×¨ ×¢×ž×•×“ ×©×œ ×ª×•×•×™×•×ª ×ž×¢×Ÿ ×©×œ×š ×œ×¡×¤×§×™× (<nobr>1 x 2.63 in...</nobr> -30 ×‘×›×œ ×¢×ž×•×“ - ××™×™×‘×¨×™ 5160). ×¢×©×•×™ ×œ×”×™×•×ª ×ž×•×¦×’ ×ž×¡×ž×š PDF ×‘×—×œ×•×Ÿ ×—×“×©.  ×–×” ×“×•×¨×© Adobe Acrobat Reader ××• ×”×¦×•×¤×” PDF ××—',0),(113061,3141,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯ Î¼Î¹Î± ÏƒÎµÎ»Î¯Î´Î± ÎµÏ„Î¹ÎºÎµÏ„ÏŽÎ½ Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ ÏƒÎ±Ï‚ (<nobr>1 x 2,63 in.</nobr> -30 Î±Î½Î¬ ÏƒÎµÎ»Î¯Î´Î± - Avery 5160). Î•Î½Î´Î­Ï‡ÎµÏ„Î±Î¹ Î½Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ Ï‰Ï‚ Î­Î½Î± Î',0),(113062,3141,'zh','ä¸ºæ‚¨çš„ä¾›åº”å•†ç”Ÿæˆä¸€ä¸ªé‚®ä»¶æ ‡ç­¾ç½‘é¡µï¼ˆ1Ã—2.63è‹±å¯¸-æ¯é¡µ30 -è‰¾å¼—é‡Œ5160ï¼‰ã€‚å¯èƒ½ä¼šæ˜¾ç¤ºä¸ºåœ¨æ–°è§†çª—PDFæ–‡æ¡£ã€‚å®ƒéœ€è¦Adobe Acrobat Readeræˆ–å…¶ä»–PDFæŸ¥çœ‹å™¨æ¥æ˜¾ç¤ºè‡ªå·±æ­£ç¡®ã€‚\r\n',0),(113063,3141,'sv','Genererar en sida av adressetiketter fÃ¶r leverantÃ¶rer (<nobr>1 x 2,63 in.</nobr> -30 per sida - Avery 5160). Kan visas som ett PDF-dokument i ett nytt fÃ¶nster.  Det krÃ¤vs Adobe Acrobat Reader eller annan PDF-lÃ¤sare att visa sig korrekt.',0),(113064,3141,'it','Genera una pagina di etichette di indirizzi per i fornitori (<nobr>1 x 2.63 pollici</nobr> -30 per pagina - Avery 5160). PuÃ² essere visualizzato come un documento PDF in una nuova finestra.  Richiede Adobe Acrobat Reader o un altro visualizzatore di PDF ',0),(113065,3141,'tl','',0),(113066,3141,'th','Generates a page of mailing labels for your vendors (<nobr>1 x 2.63 in. </nobr>- 30 per page - Avery 5160). May be displayed as a PDF document in a new window.  It requires Adobe Acrobat Reader or another PDF viewer to display itself correctly.',0),(113067,3141,'hi','à¤…à¤ªà¤¨à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ (<nobr>1 x 2, 63 à¤‡à¤‚à¤š</nobr> à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‡à¤²à¤¿à¤‚à¤— à¤²à¥‡à¤¬à¤²à¥à¤¸ à¤•à¤¾ à¤à¤• à¤ªà¥ƒà¤·à¥à¤  à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ -à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¥ƒà¤·à¥à¤  30 - à¤à¤µà¤°à¥€ 5160)',0),(113068,3141,'ms','Menjana satu halaman surat menyurat label untuk vendor anda (<nobr>1 x 2,63 in.</nobr> -30 setiap muka - Avery 5160). Mungkin dipaparkan sebagai dokumen PDF dalam tetingkap baru.  Ia memerlukan Adobe Acrobat Reader atau pelihat PDF lain untuk mempamerkan ',0),(113069,3141,'ar','ÙŠÙ‚ÙˆÙ… Ø¨Ø¥Ù†Ø´Ø§Ø¡ ØµÙØ­Ø© Ù…Ù† Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø¹Ù†ÙˆÙ†Ø© Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠØ© Ù„Ù„Ù…ÙˆØ±Ø¯ÙŠÙ† (<nobr>1 Ã— 2.63 ØªÙ„Ø¨ÙŠØªÙ‡Ø§ØŒ</nobr> -30 Ù„ÙƒÙ„ ØµÙØ­Ø©-Avery 5160). Ù‚Ø¯ ÙŠØªÙ… Ø¹Ø±Ø¶ ÙƒÙˆØ«ÙŠÙ‚Ø© PDF ÙÙŠ Ù†Ø§ÙØ°Ø© Ø¬Ø¯ÙŠØ¯Ø©.  ÙˆÙ‡ÙŠ ØªØªØ·Ù„Ø¨ ',0),(113070,3141,'fr','GÃ©nÃ¨re une page dâ€™Ã©tiquettes de publipostage pour vos fournisseurs (<nobr>1 x 2,63 po</nobr> -30 par page - Avery 5160). Peut sâ€™afficher comme un document PDF dans une nouvelle fenÃªtre.  Il nÃ©cessite Adobe Acrobat Reader ou un autre lecteur PDF p',0),(113071,3141,'jp','æ¥­è€…ã?®å®›å??ãƒªã‚¹ãƒˆãƒšãƒ¼ã‚¸ã‚’ä½œæˆ?ã?™ã‚‹ã€‚(<nobr>1 x 2.63 in. </nobr>- 30 per page - Avery 5160)æ–°ã?—ã?„ã‚¦ã‚¤ãƒ³ãƒ‰ã‚¦ã?«ï¼°ï¼¤ï¼¦ã?§è¡¨ç¤ºã?•ã‚Œã‚‹ã‚‚ã?®ã?¨ã?™ã‚‹ã€‚æ­£ã?—ã??è¡¨ç¤ºã?•ã?›ã‚‹ã?«ã?¯ã‚¢ãƒ‰ãƒ“ã‚¢ã‚¯ãƒ­ãƒ?ãƒƒãƒˆãƒªãƒ¼ãƒ€ãƒ¼ã?‹ä»–ã?®',0),(113072,3141,'pt','Gera uma pÃ¡gina de etiquetas de endereÃ§amento para seus fornecedores (<nobr>2,63 x 1 pol.</nobr> -30 por pÃ¡gina - Avery 5160). Pode ser exibido como um documento PDF em uma nova janela.  Requer Adobe Acrobat Reader ou outro visualizador PDF para exibir',0),(113073,3141,'ru','Ð¡Ð¾Ð·Ð´Ð°ÐµÑ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð¿Ð¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ñ… Ð½Ð°ÐºÐ»ÐµÐµÐº Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² (<nobr>1 x 2,63 Ð´ÑŽÐ¹Ð¼Ð°</nobr> -30 Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ - Avery 5160). ÐœÐ¾Ð¶ÐµÑ‚ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒÑÑ Ð² Ð²Ð¸Ð´Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° PDF Ð² Ð½Ð¾Ð²Ð¾Ð¼ Ð',0),(113074,3141,'es','Se genera una pÃ¡gina de etiquetas de correo para sus Proveedores (1 x 2.63 en. - 30 por Hoja - Avery 5160. Se puede desplegar como documento PDF en una nueva ventana. Se requiere Adobe Acrobat Reader u otro visualizador para desplegar correc',0),(113075,3141,'de','Erzeugt eine Seite von Adressetiketten fÃ¼r Ihre Kreditoren (<nobr>1 x 2,63 Zoll</nobr> -30 pro Seite - Avery 5160). Kann als PDF-Dokument in einem neuen Fenster angezeigt werden.  Es erfordert Adobe Acrobat Reader oder einem anderen PDF-Viewer selbst kor',0),(113076,3141,'en','Generates a page of mailing labels for your vendors (<nobr>1 x 2.63 in. </nobr>- 30 per page - Avery 5160). May be displayed as a PDF document in a new window.  It requires Adobe Acrobat Reader or another PDF viewer to display itself correctly.',0),(113077,3142,'is','',0),(113078,3142,'dr','. Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¨Ù‡ ØµÙˆØ±Øª ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¯Ø± Ù¾Ù†Ø¬Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ .Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ ØµØ­ÙŠØ­ Ù†ÙŠ',0),(113079,3142,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ù†Ø§Ù…Ù‡ Ù†Ú¯Ø§Ø±ÙŠ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¢Ø¯Ø±Ø³ Ù…Ø­Ù„ Ø§ØµÙ„ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± . Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¨Ù‡ ØµÙˆØ±Øª ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¯Ø± Ù¾Ù†Ø¬Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ .Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ ØµØ­ÙŠØ­ Ù†ÙŠØ',0),(113080,3142,'tr','MÃ¼ÅŸteri ana konum adresini kullanarak posta etiketleri oluÅŸturur.  Yeni bir pencerede PDF belgesi olarak gÃ¶rÃ¼ntÃ¼lenebilir.  DoÄŸru ÅŸekilde gÃ¶rÃ¼ntÃ¼lemek iÃ§in Adobe Acrobat Reader ya da diÄŸer PDF gÃ¶rÃ¼ntÃ¼leyici gerektirir.',0),(113081,3142,'pl','Generuje etykiet adresowych za pomocÄ… klienta adres gÅ‚Ã³wnego miejsca.  MogÄ… byÄ‡ wyÅ›wietlane jako dokument PDF w nowym oknie.  Wymaga Adobe Acrobat Reader lub inne PDF viewer wyÅ›wietliÄ‡ poprawnie.',0),(113082,3142,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð° Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹ÐºÐ¸ Ð³Ð»Ð°Ð²ÐµÐ½ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð°Ð´Ñ€ÐµÑÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°.  ÐœÐ¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð¶Ðµ ÐºÐ°Ñ‚Ð¾ PDF Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð² Ð½Ð¾Ð² Ð¿Ñ€Ð¾Ð·Ð¾Ñ€ÐµÑ†.  Ð˜Ð·Ð¸ÑÐºÐ²Ð°',0),(113083,3142,'ur','ØªØ±Ø³ÛŒÙ„ÛŒ Ù„ÛŒØ¨Ù„ Ú©Ø³Ù¹Ù…Ø± Ù…ÛŒÙ† Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾ØªÛ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù¾ÛŒØ¯Ø§ Ú©Ø±ØªØ§ ÛÛ’ Û”  Ø§ÛŒÚ© Ù†ÛŒØ§ ÙˆÙ†ÚˆÙˆ Ù…ÛŒÚº Ø§ÛŒÚ© PDF Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø¯Ú©Ú¾Ø§ÛŒØ§ Ù†ÛÛŒÚº Ø¬Ø§ Ø³Ú©ØªØ§ Û”  Ø§ÛŒÚˆÙˆØ¨ Ø§ÛŒÚ©Ø±',0),(113084,3142,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑˆÐµ Ð½Ð°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ð° Ð¿Ð¾Ð¼Ð¾Ñ›Ñƒ Ð³Ð»Ð°Ð²Ð½Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð°Ð´Ñ€ÐµÑÐ° ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°.  ÐœÐ¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½ ÐºÐ°Ð¾ ÐŸÐ”Ð¤ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñƒ Ð½Ð¾Ð²Ð¾Ð¼ Ð¿Ñ€Ð¾Ð·Ð¾Ñ€Ñƒ.  Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð° ÐÐ´Ð¾Ð±Ðµ ÐÑ†Ñ€Ð¾Ð±Ð°Ñ‚ Ð ÐµÐ°',0),(113085,3142,'vi','Táº¡o nhÃ£n bao thÆ° sá»­ dá»¥ng Ä‘á»‹a chá»‰ chÃ­nh cá»§a khÃ¡ch hÃ ng. ',0),(113086,3142,'af','Genereer mailing etikette gebruik hoof Liggingsadres kliÃ«nt.  Kan as \'n PDF dokument in \'n nuwe venster vertoon word.  Vereis Adobe Acrobat Reader of ander PDF leser om korrek te vertoon.',0),(113087,3142,'ro','GenereazÄƒ etichete poÅŸtale utilizÃ¢nd adresa de Main locatia clientului.  Pot fi afiÅŸate ca un document PDF Ã®ntr-o fereastrÄƒ nouÄƒ.  Nevoie de Adobe Acrobat Reader sau alte PDF viewer pentru a afiÅŸa corect.',0),(113088,3142,'et','Tekitab aadressisiltide kliendi Main asukoha aadressi.  VÃµidakse kuvada uues aknas PDF dokumendina.  On vaja Adobe Acrobat Readeri vÃµi muu PDF vaataja Ãµigesti kuvada.',0),(113089,3142,'si','Ustvari nalepke z naslovi z glavno mesto naslov stranke.  So lahko prikazani kot PDF dokument v novem oknu.  Zahteva Adobe Acrobat Reader ali drug pregledovalnik PDF prikazani pravilno.',0),(113090,3142,'ba','Menghasilkan label Surat menggunakan alamat utama lokasi pelanggan.  Dapat ditampilkan sebagai dokumen PDF di jendela baru.  Memerlukan Adobe Acrobat Reader atau lainnya PDF viewer untuk menampilkan dengan benar.',0),(113091,3142,'nl','Adresetiketten met de klant Main vestigingsadres genereert.  Kan worden weergegeven als een PDF-document in een nieuw venster.  Vereist Adobe Acrobat Reader of andere PDF viewer correct kan weergeven.',0),(113092,3142,'fi','Luo asiakkaan Main sijainnin osoitteen osoitetarroja.  Voi nÃ¤kyÃ¤ uuteen ikkunaan PDF-dokumenttina.  Vaatii Adobe Acrobat Reader tai muu PDF-katseluohjelma nÃ¤yttÃ¤Ã¤ oikein.',0),(113093,3142,'no','Genererer etiketter med hovedlokasjon kundeadressen.  Kan vises som et PDF-dokument i et nytt vindu.  Krever Adobe Acrobat Reader eller annen PDF-leser Ã¥ vise riktig.',0),(113094,3142,'da','Opretter adresseetiketter ved hjÃ¦lp af Main placering kundeadressen.  Kan vises som et PDF-dokument i et nyt vindue.  KrÃ¦ver Adobe Acrobat Reader eller andet PDF viewer vises korrekt.',0),(113095,3142,'ko','ê³ ê° ì£¼ìš” ìœ„ì¹˜ ì£¼ì†Œë¥¼ ì‚¬ìš© í•˜ ì—¬ ìš°íŽ¸ë¬¼ ë ˆì´ë¸”ì„ ìƒì„± í•©ë‹ˆë‹¤.  ìƒˆ ì°½ì—ì„œ PDF ë¬¸ì„œë¡œ í‘œì‹œ ë  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.  ì–´ë„ë¹„ ì•„í¬ë¡œ ë±ƒ ë¦¬ë” ë˜ëŠ” ë‹¤ë¥¸ PDF ë·°ì–´ë¥¼ ì˜¬ë°”ë¥´ê²Œ í‘œì‹œ í•˜ë ¤ë©´ í•„ìš” í•©ë‹ˆë‹¤.',0),(113096,3142,'he','×™×•×¦×¨ ×ª×•×•×™×•×ª ×“×™×•×•×¨ ×‘××ž×¦×¢×•×ª ×”×›×ª×•×‘×ª ×”×¨××©×™×ª ×ž×™×§×•× ×”×œ×§×•×—.  ×¢×©×•×™ ×œ×”×™×•×ª ×ž×•×¦×’ ×ž×¡×ž×š PDF ×‘×—×œ×•×Ÿ ×—×“×©.  ×“×•×¨×© Adobe Acrobat Reader ××• ××—×¨×™× ×‘×ž×¦×™×’ PDF ×œ×ª×¦×•×’×” × ×›×•× ×”.',0),(113097,3142,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯ ÎµÏ„Î¹ÎºÎ­Ï„ÎµÏ‚ Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚, Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· ÎºÏÏÎ¹Î± Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·.  Î•Î½Î´Î­Ï‡ÎµÏ„Î±Î¹ Î½Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ Ï‰Ï‚ Î­Î½Î± Î­Î³Î³ÏÎ±Ï†Î¿ PDF ÏƒÎµ Î',0),(113098,3142,'zh','ä½¿ç”¨å®¢æˆ·ä¸»è¦ä½ç½®çš„åœ°å€ç”Ÿæˆé‚®ä»¶æ ‡ç­¾ã€‚å¯èƒ½ä¼šæ˜¾ç¤ºä¸ºåœ¨æ–°è§†çª—ä¸­çš„PDFæ–‡æ¡£ã€‚éœ€è¦ä½¿ç”¨Adobe Acrobat Readeræˆ–å…¶ä»–PDFæµè§ˆå™¨æ­£ç¡®æŸ¥çœ‹ã€‚\r\n',0),(113099,3142,'sv','Genererar adressetiketter med hjÃ¤lp kunden Main BelÃ¤genhetsadress.  Kan visas som ett PDF-dokument i ett nytt fÃ¶nster.  KrÃ¤ver Adobe Acrobat Reader eller annan PDF-viewer fÃ¶r att visa korrekt.',0),(113100,3142,'it','Genera etichette postali, utilizzando l\'indirizzo principale posizione di cliente.  PuÃ² essere visualizzato come un documento PDF in una nuova finestra.  Richiede Adobe Acrobat Reader o altro visualizzatore PDF visualizzare correttamente.',0),(113101,3142,'tl','',0),(113102,3142,'th','Generates mailing labels using customer Main Location address.  May be displayed as a PDF document in a new window.  Requires Adobe Acrobat Reader or other PDF viewer to display correctly.',0),(113103,3142,'hi','à¤®à¥‡à¤²à¤¿à¤‚à¤— à¤²à¥‡à¤¬à¤²à¥à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¥à¤–à¥à¤¯ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤¤à¥‡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤•à¥‡ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆà¥¤  à¤à¤• à¤¨à¤ˆ à¤µà¤¿à¤‚à¤¡à¥‹ à¤®à¥‡à¤‚ à¤à¤• à¤ªà¥€à¤¡à¥€à¤à¤« à¤¦à¤¸à¥',0),(113104,3142,'ms','Menjana label mel menggunakan alamat lokasi utama pelanggan.  Mungkin dipaparkan sebagai dokumen PDF dalam tetingkap baru.  Memerlukan Adobe Acrobat Reader atau lain-lain penonton PDF untuk dipaparkan dengan betul.',0),(113105,3142,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø§Øª Ø¹Ù†ÙˆÙ†Ø© Ø¨Ø±ÙŠØ¯ÙŠØ© Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¹Ù†ÙˆØ§Ù† \"Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ\" Ø§Ù„Ø¹Ù…ÙŠÙ„.  Ù‚Ø¯ ÙŠØªÙ… Ø¹Ø±Ø¶ ÙƒÙ…Ø³ØªÙ†Ø¯ PDF ÙÙŠ Ù†Ø§ÙØ°Ø© Ø¬Ø¯ÙŠØ¯Ø©.  ÙŠØªØ·Ù„Ø¨ Ø¨Ø±Ù†Ø§Ù…Ø¬ Adobe Acrobat Reader Ø£Ùˆ Ø¹Ø§Ø±Ø¶ PDF Ø§Ù„Ø£',0),(113106,3142,'fr','GÃ©nÃ¨re des Ã©tiquettes de publipostage Ã  l\'aide d\'adresse client principal.  Peut s\'afficher comme un document PDF dans une nouvelle fenÃªtre.  NÃ©cessite Adobe Acrobat Reader ou autre visionneuse PDF s\'affiche correctement.',0),(113107,3142,'jp','é¡§å®¢ä½?æ‰€ã‚’ä½¿ç”¨ã?—ã?¦å®›å??ãƒ©ãƒ™ãƒ«ã‚’ä½œæˆ?ã?™ã‚‹ã€‚æ–°ã?—ã?„ã‚¦ã‚¤ãƒ³ãƒ‰ã‚¦ã?«ï¼°ï¼¤ï¼¦ã?§è¡¨ç¤ºã?•ã‚Œã‚‹ã‚‚ã?®ã?¨ã?™ã‚‹ã€‚æ­£ã?—ã??è¡¨ç¤ºã?•ã?›ã‚‹ã?«ã?¯ã‚¢ãƒ‰ãƒ“ã‚¢ã‚¯ãƒ­ãƒ?ãƒƒãƒˆãƒªãƒ¼ãƒ€ãƒ¼ã?‹ä»–ã?®ï¼°ï¼¤ï¼¦ãƒ“ãƒ¥ãƒ¼ã‚¢ãƒ¼ã?Œå¿…è¦?ã?§ã?™ã€‚',0),(113108,3142,'pt','Gera etiquetas de endereÃ§amento usando o endereÃ§o de localizaÃ§Ã£o principal do cliente.  Pode ser exibido como um documento PDF em uma nova janela.  Requer Adobe Acrobat Reader ou outro visualizador PDF para exibir corretamente.',0),(113109,3142,'ru','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€ÑƒÐµÑ‚ Ð¿Ð¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ñ… Ð½Ð°ÐºÐ»ÐµÐµÐº Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð°Ð´Ñ€ÐµÑ.  ÐœÐ¾Ð¶ÐµÑ‚ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒÑÑ Ð² Ð²Ð¸Ð´Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° PDF Ð² Ð½Ð¾Ð²Ð¾Ð¼ Ð¾ÐºÐ½Ðµ.  Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ Adobe Acrobat Reader Ð¸Ð»Ð¸ ',0),(113110,3142,'es','Se genera etiquetas de correo usando la direcciÃ³n de Colocaciones Principales de clientes. Se puede desplegar como documento PDF en una nueva ventana. Se requiere Adobe Acrobat Reader u otro visualizador para desplegar correctamente.',0),(113111,3142,'de','Adressetiketten mit Kundenadresse Hauptspeicherort generiert.  Kann als PDF-Dokument in einem neuen Fenster angezeigt werden.  Erfordert Adobe Acrobat Reader oder anderen PDF-Viewer ordnungsgemÃ¤ÃŸ angezeigt.',0),(113112,3142,'en','Generates mailing labels using customer Main Location address.  May be displayed as a PDF document in a new window.  Requires Adobe Acrobat Reader or other PDF viewer to display correctly.',0),(113113,3143,'is','',0),(113114,3143,'dr','. Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¨Ù‡ ØµÙˆØ±Øª ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¯Ø± Ù¾Ù†Ø¬Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ .Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ ØµØ­ÙŠØ­ Ù†ÙŠØ§',0),(113115,3143,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ù†Ø§Ù…Ù‡ Ù†Ú¯Ø§Ø±ÙŠ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¢Ø¯Ø±Ø³ Ù…Ø­Ù„ Ø­Ù…Ù„ Ø®Ø±ÙŠØ¯Ø§Ø± . Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¨Ù‡ ØµÙˆØ±Øª ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¯Ø± Ù¾Ù†Ø¬Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ .Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ ØµØ­ÙŠØ­ Ù†ÙŠØ§Ø',0),(113116,3143,'tr','MÃ¼ÅŸteri sevk yeri adresini kullanarak posta etiketleri oluÅŸturur.  Yeni bir pencerede PDF belgesi olarak gÃ¶rÃ¼ntÃ¼lenebilir.  DoÄŸru ÅŸekilde gÃ¶rÃ¼ntÃ¼lemek iÃ§in Adobe Acrobat Reader ya da diÄŸer PDF gÃ¶rÃ¼ntÃ¼leyici gerektirir.',0),(113117,3143,'pl','Generuje etykiet adresowych za pomocÄ… adresu wysyÅ‚ki lokalizacji klienta.  MogÄ… byÄ‡ wyÅ›wietlane jako dokument PDF w nowym oknie.  Wymaga Adobe Acrobat Reader lub inne PDF viewer wyÅ›wietliÄ‡ poprawnie.',0),(113118,3143,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð° Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹ÐºÐ¸ ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð°Ð´Ñ€ÐµÑÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°.  ÐœÐ¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð¶Ðµ ÐºÐ°Ñ‚Ð¾ PDF Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð² Ð½Ð¾Ð² Ð¿Ñ€Ð¾Ð·Ð¾Ñ€ÐµÑ',0),(113119,3143,'ur','ØªØ±Ø³ÛŒÙ„ÛŒ Ù„ÛŒØ¨Ù„ Ú©Ø³Ù¹Ù…Ø± Ø´Ù¾Ù†Ú¯ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾ØªÛ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù¾ÛŒØ¯Ø§ Ú©Ø±ØªØ§ ÛÛ’ Û”  Ø§ÛŒÚ© Ù†ÛŒØ§ ÙˆÙ†ÚˆÙˆ Ù…ÛŒÚº Ø§ÛŒÚ© PDF Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø¯Ú©Ú¾Ø§ÛŒØ§ Ù†ÛÛŒÚº Ø¬Ø§ Ø³Ú©ØªØ§ Û”  Ø§ÛŒÚˆÙˆØ¨ Ø§ÛŒÚ©',0),(113120,3143,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑˆÐµ Ð½Ð°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ð° Ð¿Ð¾Ð¼Ð¾Ñ›Ñƒ Ð°Ð´Ñ€ÐµÑÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ ÐºÑƒÐ¿Ñ†Ñƒ.  ÐœÐ¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½ ÐºÐ°Ð¾ ÐŸÐ”Ð¤ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñƒ Ð½Ð¾Ð²Ð¾Ð¼ Ð¿Ñ€Ð¾Ð·Ð¾Ñ€Ñƒ.  Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð° ÐÐ´Ð¾Ð±Ðµ ÐÑ†Ñ€Ð¾Ð±Ð°Ñ‚ Ð Ð',0),(113121,3143,'vi','Táº¡o nhÃ£n bao thÆ° sá»­ dá»¥ng Ä‘á»‹a chá»‰ chuyá»ƒn hÃ ng cho khÃ¡ch hÃ ng. CÃ³ thá»ƒ hiá»ƒn thá»‹ báº±ng PDF á»Ÿ cá»­a sá»• má»›i. Pháº£i cÃ³ Adobe Acrobat Reader hay xem PDF Ä‘á»ƒ hiá»ƒn thá»‹ Ä‘Ãºng',0),(113122,3143,'af','Genereer poslysetikette deur die gebruik van klant / klient Versendingsplekadres. Mag vertoon word as \'n PDF dokument in \'n nuwe venster.  Benodig Adobe Acrobat Reader of \'n ander PDF besigtiger om reg te vertoon.',0),(113123,3143,'ro','GenereazÄƒ etichete poÅŸtale utilizÃ¢nd adresa de transport maritim locaÅ£ie clientului.  Pot fi afiÅŸate ca un document PDF Ã®ntr-o fereastrÄƒ nouÄƒ.  Nevoie de Adobe Acrobat Reader sau alte PDF viewer pentru a afiÅŸa corect.',0),(113124,3143,'et','Tekitab aadressisiltide kliendi saatmise asukoha aadressi.  VÃµidakse kuvada uues aknas PDF dokumendina.  On vaja Adobe Acrobat Readeri vÃµi muu PDF vaataja Ãµigesti kuvada.',0),(113125,3143,'si','Ustvari nalepke z naslovi using Shipping mesto naslov stranke.  So lahko prikazani kot PDF dokument v novem oknu.  Zahteva Adobe Acrobat Reader ali drug pregledovalnik PDF prikazani pravilno.',0),(113126,3143,'ba','Menghasilkan label Surat menggunakan alamat pengiriman lokasi pelanggan.  Dapat ditampilkan sebagai dokumen PDF di jendela baru.  Memerlukan Adobe Acrobat Reader atau lainnya PDF viewer untuk menampilkan dengan benar.',0),(113127,3143,'nl','Genereert adresetiketten met de scheepvaart locatie adres van de klant.  Kan worden weergegeven als een PDF-document in een nieuw venster.  Vereist Adobe Acrobat Reader of andere PDF viewer correct kan weergeven.',0),(113128,3143,'fi','Luo asiakkaan Shipping sijainti osoitteen osoitetarroja.  Voi nÃ¤kyÃ¤ uuteen ikkunaan PDF-dokumenttina.  Vaatii Adobe Acrobat Reader tai muu PDF-katseluohjelma nÃ¤yttÃ¤Ã¤ oikein.',0),(113129,3143,'no','Genererer adresseetiketter ved hjelp av Shipping beliggenhet kundeadressen.  Kan vises som et PDF-dokument i et nytt vindu.  Krever Adobe Acrobat Reader eller annen PDF-leser Ã¥ vise riktig.',0),(113130,3143,'da','Opretter adresseetiketter ved hjÃ¦lp af Shipping beliggenhed kundeadressen.  Kan vises som et PDF-dokument i et nyt vindue.  KrÃ¦ver Adobe Acrobat Reader eller andet PDF viewer vises korrekt.',0),(113131,3143,'ko','ê³ ê° ë°°ì†¡ ìœ„ì¹˜ ì£¼ì†Œë¥¼ ì‚¬ìš© í•˜ ì—¬ ìš°íŽ¸ë¬¼ ë ˆì´ë¸”ì„ ìƒì„± í•©ë‹ˆë‹¤.  ìƒˆ ì°½ì—ì„œ PDF ë¬¸ì„œë¡œ í‘œì‹œ ë  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.  ì–´ë„ë¹„ ì•„í¬ë¡œ ë±ƒ ë¦¬ë” ë˜ëŠ” ë‹¤ë¥¸ PDF ë·°ì–´ë¥¼ ì˜¬ë°”ë¥´ê²Œ í‘œì‹œ í•˜ë ¤ë©´ í•„ìš” í•©ë‹ˆë‹¤.',0),(113132,3143,'he','×™×•×¦×¨ ×ª×•×•×™×•×ª ×“×™×•×•×¨ ×‘××ž×¦×¢×•×ª ×›×ª×•×‘×ª ×ž×©×œ×•×— ×ž×™×§×•× ×”×œ×§×•×—.  ×¢×©×•×™ ×œ×”×™×•×ª ×ž×•×¦×’ ×ž×¡×ž×š PDF ×‘×—×œ×•×Ÿ ×—×“×©.  ×“×•×¨×© Adobe Acrobat Reader ××• ××—×¨×™× ×‘×ž×¦×™×’ PDF ×œ×ª×¦×•×’×” × ×›×•× ×”.',0),(113133,3143,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯ ÎµÏ„Î¹ÎºÎ­Ï„ÎµÏ‚ Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚, Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·.  Î•Î½Î´Î­Ï‡ÎµÏ„Î±Î¹ Î½Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ Ï‰Ï‚ Î­Î½Î± Î­Î³Î³ÏÎ±Ï†Î¿ PD',0),(113134,3143,'zh','ä½¿ç”¨å®¢æˆ·é€è´§åœ°ç‚¹çš„åœ°å€ç”Ÿæˆé‚®ä»¶æ ‡ç­¾ã€‚å¯èƒ½ä¼šæ˜¾ç¤ºä¸ºåœ¨æ–°è§†çª—PDFæ–‡æ¡£ã€‚éœ€è¦ä½¿ç”¨Adobe Acrobat Readeræˆ–å…¶ä»–PDFæµè§ˆå™¨æ­£ç¡®æ˜¾ç¤ºã€‚\r\n',0),(113135,3143,'sv','Genererar adressetiketter med hjÃ¤lp kunden frakt BelÃ¤genhetsadress.  Kan visas som ett PDF-dokument i ett nytt fÃ¶nster.  KrÃ¤ver Adobe Acrobat Reader eller annan PDF-viewer fÃ¶r att visa korrekt.',0),(113136,3143,'it','Genera etichette postali, utilizzando l\'indirizzo di spedizione posizione del cliente.  PuÃ² essere visualizzato come un documento PDF in una nuova finestra.  Richiede Adobe Acrobat Reader o altro visualizzatore PDF visualizzare correttamente.',0),(113137,3143,'tl','',0),(113138,3143,'th','Generates mailing labels using customer Shipping Location address.  May be displayed as a PDF document in a new window.  Requires Adobe Acrobat Reader or other PDF viewer to display correctly.',0),(113139,3143,'hi','à¤®à¥‡à¤²à¤¿à¤‚à¤— à¤²à¥‡à¤¬à¤²à¥à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥à¤¥à¤¾à¤¨ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤ªà¤¤à¥‡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤•à¥‡ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆà¥¤  à¤à¤• à¤¨à¤ˆ à¤µà¤¿à¤‚à¤¡à¥‹ à¤®à¥‡à¤‚ à¤à¤• à¤ªà¥€à¤¡à¥€à¤à¤« à¤¦à¤',0),(113140,3143,'ms','Menjana label mel menggunakan alamat lokasi penghantaran pelanggan.  Mungkin dipaparkan sebagai dokumen PDF dalam tetingkap baru.  Memerlukan Adobe Acrobat Reader atau lain-lain penonton PDF untuk dipaparkan dengan betul.',0),(113141,3143,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø§Øª Ø¹Ù†ÙˆÙ†Ø© Ø¨Ø±ÙŠØ¯ÙŠØ© Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¹Ù†ÙˆØ§Ù† \"Ø§Ù„Ø´Ø­Ù† Ù…ÙˆÙ‚Ø¹\" Ø§Ù„Ø¹Ù…ÙŠÙ„.  Ù‚Ø¯ ÙŠØªÙ… Ø¹Ø±Ø¶ ÙƒÙ…Ø³ØªÙ†Ø¯ PDF ÙÙŠ Ù†Ø§ÙØ°Ø© Ø¬Ø¯ÙŠØ¯Ø©.  ÙŠØªØ·Ù„Ø¨ Ø¨Ø±Ù†Ø§Ù…Ø¬ Adobe Acrobat Reader Ø£Ùˆ Ø¹Ø§Ø±Ø¶ PDF Ø§Ù„Ø£Ø®Ø±Ù‰ Ù',0),(113142,3143,'fr','GÃ©nÃ¨re des Ã©tiquettes de publipostage Ã  l\'aide d\'adresse du lieu de livraison client.  Peut s\'afficher comme un document PDF dans une nouvelle fenÃªtre.  NÃ©cessite Adobe Acrobat Reader ou autre visionneuse PDF s\'affiche correctement.',0),(113143,3143,'jp','é¡§å®¢ç™ºé€?å…ˆä½?æ‰€ã‚’ä½¿ç”¨ã?—ã?¦å®›å??ãƒ©ãƒ™ãƒ«ã‚’ä½œæˆ?ã?™ã‚‹ã€‚æ–°ã?—ã?„ã‚¦ã‚¤ãƒ³ãƒ‰ã‚¦ã?«ï¼°ï¼¤ï¼¦ã?§è¡¨ç¤ºã?•ã‚Œã‚‹ã‚‚ã?®ã?¨ã?™ã‚‹ã€‚æ­£ã?—ã??è¡¨ç¤ºã?•ã?›ã‚‹ã?«ã?¯ã‚¢ãƒ‰ãƒ“ã‚¢ã‚¯ãƒ­ãƒ?ãƒƒãƒˆãƒªãƒ¼ãƒ€ãƒ¼ã?‹ä»–ã?®ï¼°ï¼¤ï¼¦ãƒ“ãƒ¥ãƒ¼ã‚¢ãƒ¼ã?Œå¿…è¦?ã?§',0),(113144,3143,'pt','Gera etiquetas de endereÃ§amento usando o endereÃ§o do local de envio do cliente.  Pode ser exibido como um documento PDF em uma nova janela.  Requer Adobe Acrobat Reader ou outro visualizador PDF para exibir corretamente.',0),(113145,3143,'ru','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€ÑƒÐµÑ‚ Ð»ÐµÐ¹Ð±Ð»Ñ‹ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ Ð¿Ð¾ Ð¿Ð¾Ñ‡Ñ‚Ðµ, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑ Ð°Ð´Ñ€ÐµÑ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°.  ÐœÐ¾Ð¶ÐµÑ‚ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒÑÑ Ð² Ð²Ð¸Ð´Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° PDF Ð² Ð½Ð¾Ð²Ð¾Ð¼ Ð¾ÐºÐ½Ðµ.  Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ Adobe Acroba',0),(113146,3143,'es','Se genera etiquetas de correo usando la direcciÃ³n de Colocaciones de EnvÃ­os de clientes. Se puede desplegar como documento PDF en una nueva ventana. Se requiere Adobe Acrobat Reader u otro visualizador para desplegar correctamente.',0),(113147,3143,'de','Adressetiketten mit Kunden Versand Adresse generiert.  Kann als PDF-Dokument in einem neuen Fenster angezeigt werden.  Erfordert Adobe Acrobat Reader oder anderen PDF-Viewer ordnungsgemÃ¤ÃŸ angezeigt.',0),(113148,3143,'en','Generates mailing labels using customer Shipping Location address.  May be displayed as a PDF document in a new window.  Requires Adobe Acrobat Reader or other PDF viewer to display correctly.',0),(113149,3144,'is','',0),(113150,3144,'dr','Ø±Ù…Ø²Ø¹Ø¨ÙˆØ± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø³Ø±ÙˆØ± ',0),(113151,3144,'pr','Ø±Ù…Ø²Ø¹Ø¨ÙˆØ± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø³Ø±ÙˆØ± ',0),(113152,3144,'tr','VeritabanÄ± sunucusuna eriÅŸmek iÃ§in kullanÄ±lan parola',0),(113153,3144,'pl','HasÅ‚o umoÅ¼liwiajÄ…ce dostÄ™p do serwera bazy danych',0),(113154,3144,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð° Ð·Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ ÑÑŠÑ€Ð²ÑŠÑ€ Ð·Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(113155,3144,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù¾ÛŒØ´ Ú©Ø§Ø± Ú©ÛŒ Ø±Ø³Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(113156,3144,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÑƒ ÐºÐ¾Ñ˜Ð° ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð·Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ ÑÐµÑ€Ð²ÐµÑ€Ñƒ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(113157,3144,'vi','Máº­t kháº©u dÃ¹ng Ä‘á»ƒ truy cáº­p mÃ¡y chá»§ dá»¯ liá»‡u',0),(113158,3144,'af','Wagwoord gebruik om toegang tot die databasis bediener',0),(113159,3144,'ro','Parola folosite pentru a accesa server bazÄƒ de date',0),(113160,3144,'et','Kasutada juurdepÃ¤Ã¤suks andmebaasi serveri parool',0),(113161,3144,'si','Geslo za dostop do streÅ¾nika zbirke podatkov',0),(113162,3144,'ba','Sandi yang digunakan untuk mengakses database server',0),(113163,3144,'nl','Wachtwoord dat wordt gebruikt voor toegang tot databaseserver',0),(113164,3144,'fi','Salasana tietokantapalvelin',0),(113165,3144,'no','Passord for tilgang til database-serveren',0),(113166,3144,'da','Adgangskode, der bruges til at fÃ¥ adgang til databaseserveren',0),(113167,3144,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì„œë²„ì— ì•¡ì„¸ìŠ¤ í•˜ëŠ” ë° ì‚¬ìš© í•˜ëŠ” ì•”í˜¸',0),(113168,3144,'he','×”×¡×™×¡×ž×” ×”×ž×©×ž×©×ª ×œ×’×™×©×” ×œ×©×¨×ª ×ž×¡×“ × ×ª×•× ×™×',0),(113169,3144,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î® Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(113170,3144,'zh','å¯†ç ç”¨äºŽè®¿é—®æ•°æ®åº“æœåŠ¡å™¨\r\n',0),(113171,3144,'sv','LÃ¶senord som anvÃ¤nds fÃ¶r Ã¥tkomst till databasservern',0),(113172,3144,'it','Password utilizzata per accedere ai server di database',0),(113173,3144,'tl','',0),(113174,3144,'th','&#3651;&#3594;&#3657; Password &#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591; database server',0),(113175,3144,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤°à¥à¤µà¤° à¤¤à¤• à¤ªà¤¹à¥à¤à¤šà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡',0),(113176,3144,'ms','Kata laluan yang digunakan untuk mencapai pelayan pangkalan data',0),(113177,3144,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„Ù„ÙˆØµÙˆÙ„ Ù„Ø®Ø§Ø¯Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(113178,3144,'fr','Mot de passe utilisÃ© pour accÃ©der au serveur de base de donnÃ©es',0),(113179,3144,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚µãƒ¼ãƒ?ãƒ¼ã‚¢ã‚¯ã‚»ã‚¹ç”¨ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰',0),(113180,3144,'pt','Senha usada para acessar o servidor de banco de dados',0),(113181,3144,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ð¹ Ð´Ð»Ñ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ðº ÑÐµÑ€Ð²ÐµÑ€Ñƒ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(113182,3144,'es','ContraseÃ±a usada para accesar servidor de base de datos',0),(113183,3144,'de','Passwort Zugriff auf Datenbankserver verwendet',0),(113184,3144,'en','Password used to access database server',0),(113185,3145,'is','',0),(113186,3145,'dr','Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ Ù…Ø­Ù„ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡ Ø¨Ø§ÙŠØ¯ Ø¨Ø§Ø´Ø¯',0),(113187,3145,'pr','Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ Ù…Ø­Ù„ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡ Ø¨Ø§ÙŠØ¯ Ø¨Ø§Ø´Ø¯',0),(113188,3145,'tr','En az bir (1) bitki yeri olmasÄ± gerekir',0),(113189,3145,'pl','Musi mieÄ‡ co najmniej jeden (1) roÅ›lina lokalizacji',0),(113190,3145,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½Ð°Ð¹-Ð¼Ð°Ð»ÐºÐ¾ ÐµÐ´Ð¸Ð½ (1) Ñ€Ð°ÑÑ‚Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(113191,3145,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø§ÛŒÚ© (1) Ù¾Ù„Ø§Ù†Ù¹ Ù…Ù‚Ø§Ù… ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(113192,3145,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½Ð°Ñ˜Ð¼Ð°ÑšÐµ Ñ˜ÐµÐ´Ð°Ð½ (1) Ð±Ð¸Ñ™ÐºÐ° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(113193,3145,'vi','Pháº£i cÃ³ Ã­t nháº¥t 1 vá»‹ trÃ­ nhÃ  mÃ¡y',0),(113194,3145,'af','Moet ten minste een (1) plant ligging het',0),(113195,3145,'ro','Trebuie sÄƒ aibÄƒ cel puÅ£in un (1) plantÄƒ locaÅ£ia',0),(113196,3145,'et','Peab olema vÃ¤hemalt Ã¼ks (1) tehase asukoht',0),(113197,3145,'si','Mora imeti vsaj en (1) rastlin mesto',0),(113198,3145,'ba','Harus memiliki setidaknya satu (1) tanaman lokasi',0),(113199,3145,'nl','Moet ten minste Ã©Ã©n (1) plant locatie',0),(113200,3145,'fi','On oltava vÃ¤hintÃ¤Ã¤n yksi (1) tuotantolaitoksen sijainti',0),(113201,3145,'no','MÃ¥ ha minst Ã©n (1) anlegget beliggenheten',0),(113202,3145,'da','Skal have mindst Ã©n (1) produktionsanlÃ¦ggets beliggenhed',0),(113203,3145,'ko','ì ì–´ë„ í•˜ë‚˜ì˜ (1) ê³µìž¥ ìœ„ì¹˜ë¥¼ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(113204,3145,'he','×—×™×™×‘ ×œ×”×™×•×ª ×œ×¤×—×•×ª ××—×“ (1) ×ž×¦×™×™×Ÿ',0),(113205,3145,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î­Î½Î± (1) ÎµÏÎ³Î¿ÏƒÏ„Î¬ÏƒÎ¹Î¿',0),(113206,3145,'zh','å¿…é¡»æœ‰è¿‡è‡³å°‘ä¸€ï¼ˆ1ï¼‰å·¥åŽ‚\r\n',0),(113207,3145,'sv','MÃ¥ste ha minst en (1) tillverkningsanlÃ¤ggningens belÃ¤genhet',0),(113208,3145,'it','Deve avere luogo almeno un 1 pianta',0),(113209,3145,'tl','',0),(113210,3145,'th','&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3629;&#3618;&#3656;&#3634;&#3591;&#3609;&#3657;&#3629;&#3618; 1 &#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(113211,3145,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• (1) à¤¸à¤‚à¤¯à¤‚à¤¤à¥à¤° à¤¸à¥à¤¥à¤¾à¤¨ à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤•',0),(113212,3145,'ms','Mesti mempunyai sekurang-kurangnya satu (1) loji lokasi',0),(113213,3145,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…ØµÙ†Ø¹ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„ ÙˆØ§Ø­Ø¯ 1',0),(113214,3145,'fr','Doit avoir lieu au moins une 1 plante',0),(113215,3145,'jp','å°‘ã?ªã??ã?¦ã‚‚ä¸€ã?¤ä»¥ä¸Šã?®å·¥å ´æ‰€åœ¨åœ°ã?Œã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(113216,3145,'pt','Deve ter pelo menos um 1 planta localizaÃ§Ã£o',0),(113217,3145,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð¼ÐµÑ‚ÑŒ Ð¼ÐµÑÑ‚Ð¾ Ð¿Ð¾ ÐºÑ€Ð°Ð¹Ð½ÐµÐ¹ Ð¼ÐµÑ€Ðµ 1 (Ð¾Ð´Ð¸Ð½) Ð·Ð°Ð²Ð¾Ð´',0),(113218,3145,'es','Debe tener mÃ¡s de (1) ColocaiÃ³n de InstalaciÃ³n',0),(113219,3145,'de','Muss mindestens ein 1-BetriebsstÃ¤tte',0),(113220,3145,'en','Must have at least one (1) plant location',0),(113221,3146,'is','',0),(113222,3146,'dr','Ø±Ù…Ø²Ø¹Ø¨ÙˆØ± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡',0),(113223,3146,'pr','Ø±Ù…Ø²Ø¹Ø¨ÙˆØ± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡',0),(113224,3146,'tr','VeritabanÄ± sunucusu eriÅŸmek iÃ§in kullanÄ±lan kullanÄ±cÄ± adÄ±',0),(113225,3146,'pl','Nazwa uÅ¼ytkownika uÅ¼ywana do dostÄ™pu do bazy danych serwera',0),(113226,3146,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ Ð·Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ ÑÑŠÑ€Ð²ÑŠÑ€ Ð·Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(113227,3146,'ur','Ù†Ø§Ù… ØµØ§Ø±Ù Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù¾ÛŒØ´ Ú©Ø§Ø± ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§',0),(113228,3146,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð·Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ ÑÐµÑ€Ð²ÐµÑ€Ñƒ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(113229,3146,'vi','TÃªn NgÆ°á»i Sá»­ Dá»¥ng dÃ¹ng Ä‘á»ƒ truy cáº­p vÃ o mÃ¡y chá»§ dá»¯ liá»‡u',0),(113230,3146,'af','Gebruikernaam wat gebruik word om toegang tot die databasis Bediener te verkry ',0),(113231,3146,'ro','Nume utilizat pentru a accesa serverul bazei de date',0),(113232,3146,'et','Kasutajanimi kasutatakse juurdepÃ¤Ã¤su andmebaasi server',0),(113233,3146,'si','UporabniÅ¡ko ime za dostop do streÅ¾nika zbirke podatkov',0),(113234,3146,'ba','Username yang digunakan untuk mengakses database server',0),(113235,3146,'nl','Gebruikersnaam gebruikt voor toegang tot de databaseserver',0),(113236,3146,'fi','KÃ¤yttÃ¤jÃ¤tunnus kÃ¤yttÃ¤Ã¤ tietokantapalvelimen',0),(113237,3146,'no','Brukernavn for tilgang til database-serveren',0),(113238,3146,'da','Brugernavnet anvendes til at fÃ¥ adgang til databaseserveren',0),(113239,3146,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì„œë²„ì— ì•¡ì„¸ìŠ¤ í•˜ëŠ” ë° ì‚¬ìš© í•˜ëŠ” ì‚¬ìš©ìž ì´ë¦„',0),(113240,3146,'he','×©× ×”×ž×©×ª×ž×© ×•×”×¡×™×¡×ž×” ×”×ž×©×ž×©×™× ×œ×’×™×©×” ×œ×©×¨×ª ×ž×¡×“ × ×ª×•× ×™×',0),(113241,3146,'el','ÎŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î® Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(113242,3146,'zh','ç”¨æˆ·åç”¨äºŽè®¿é—®æ•°æ®åº“æœåŠ¡å™¨\r\n',0),(113243,3146,'sv','AnvÃ¤ndarnamn anvÃ¤nds fÃ¶r Ã¥tkomst till databasservern',0),(113244,3146,'it','Nome utente utilizzato per accedere ai server di database',0),(113245,3146,'tl','',0),(113246,3146,'th','&#3651;&#3594;&#3657; Username &#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591; database server',0),(113247,3146,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤°à¥à¤µà¤° à¤¤à¤• à¤ªà¤¹à¥à¤à¤šà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤¿à¤¯à¤¾',0),(113248,3146,'ms','Nama pengguna yang digunakan untuk mencapai pelayan pangkalan data',0),(113249,3146,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù„Ù„ÙˆØµÙˆÙ„ Ù„Ø®Ø§Ø¯Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(113250,3146,'fr','Nom d\'utilisateur utilisÃ© pour accÃ©der au serveur de base de donnÃ©es',0),(113251,3146,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚µãƒ¼ãƒ?ãƒ¼ã‚¢ã‚¯ã‚»ã‚¹ç”¨ãƒ¦ãƒ¼ã‚¶ãƒ¼å??',0),(113252,3146,'pt','Nome de usuÃ¡rio usado para acessar o servidor de banco de dados',0),(113253,3146,'ru','Ð˜Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ð¾Ðµ Ð´Ð»Ñ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ðº ÑÐµÑ€Ð²ÐµÑ€Ñƒ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(113254,3146,'es','Nombe de usuario usado para accesar servidor de base de datos',0),(113255,3146,'de','Benutzername, Datenbankserver zugreifen',0),(113256,3146,'en','Username used to access database server',0),(113257,3147,'is','',0),(113258,3147,'dr','Ø§ÙŠÙ† Ù„ÙŠÙ†Ùƒ ÙŠÙƒ Ù„ÙŠØ³Øª Ø§Ø²Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø´Ù…Ø§ Ø±Ø§ Ø±ÙˆÙŠ ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†Ø¯',0),(113259,3147,'pr','Ø§ÙŠÙ† Ù„ÙŠÙ†Ùƒ ÙŠÙƒ Ù„ÙŠØ³Øª Ø§Ø²Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø´Ù…Ø§ Ø±Ø§ Ø±ÙˆÙŠ ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†Ø¯',0),(113260,3147,'tr','Bu baÄŸlantÄ±yÄ± oluÅŸturur bir ekran, satÄ±cÄ±larÄ±nÄ±n listesi.',0),(113261,3147,'pl','Generuje ten link na ekranie listÄ™ dostawcÃ³w.',0),(113262,3147,'bg','Ð¢Ð°Ð·Ð¸ Ð²Ñ€ÑŠÐ·ÐºÐ° ÑÑŠÐ·Ð´Ð°Ð²Ð° ÐµÐºÑ€Ð°Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸.',0),(113263,3147,'ur','Ø§Ø³ Ø±Ø¨Ø· Ù¾ÛŒØ¯Ø§ Ú©Ø±ØªØ§ ÛÛ’ Ø§ÛŒÚ© Ø¢Ù† Ø³Ú©Ø±ÛŒÙ† Ø¢Ù¾ Ú©Û’ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©ÛŒ ÙÛØ±Ø³Øª Û”',0),(113264,3147,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑˆÐµ Ð¾Ð²Ð°Ñ˜ Ð»Ð¸Ð½Ðº Ñ˜Ðµ Ð½Ð° ÐµÐºÑ€Ð°Ð½Ñƒ Ð»Ð¸ÑÑ‚Ñƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°.',0),(113265,3147,'vi','ÄÆ°á»ng dáº«n táº¡o trÃªn danh sÃ¡ch mÃ n hÃ¬nh cá»§a ngÆ°á»i bÃ¡n cá»§a báº¡n',0),(113266,3147,'af','Hierdie skakel genereer \'n skermsleutelbord lys van jou handelaars.',0),(113267,3147,'ro','Acest link genereazÄƒ un ecran listÄƒ de furnizorii dumneavoastrÄƒ.',0),(113268,3147,'et','See link genereerib on ekraanil oma tarnijate loend.',0),(113269,3147,'si','Ta povezava ustvarja je na zaslonu seznam vaÅ¡ih dobaviteljev.',0),(113270,3147,'ba','Link ini menghasilkan layar Daftar vendor Anda.',0),(113271,3147,'nl','Deze link genereert een op het scherm lijst van uw leveranciers.',0),(113272,3147,'fi','TÃ¤mÃ¤ linkki tuottaa nÃ¤ytÃ¶n luettelo toimittajista.',0),(113273,3147,'no','Denne koblingen genererer en skjermen liste over leverandÃ¸rer.',0),(113274,3147,'da','Dette link genererer en on-screen liste af dine leverandÃ¸rer.',0),(113275,3147,'ko','ì´ ë§í¬ë¥¼ ìƒì„± í•œ í™”ë©´ ê³µê¸‰ ì—…ì²´ ëª©ë¡.',0),(113276,3147,'he','×§×™×©×•×¨ ×–×” ×™×•×¦×¨ ×”×ž×¡×š ×¨×©×™×ž×ª ×”×¡×¤×§×™× ×©×œ×š.',0),(113277,3147,'el','Î‘Ï…Ï„Î® Î· ÏƒÏÎ½Î´ÎµÏƒÎ· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯ Î¼Î¹Î± Î¿Î¸ÏŒÎ½Î· Î»Î¯ÏƒÏ„Î± Î±Ï€ÏŒ Ï„Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ ÏƒÎ±Ï‚.',0),(113278,3147,'zh','æ­¤é“¾æŽ¥ç”Ÿæˆä¸€ä¸ªé¡µé¢ä¸Šçš„æ‚¨çš„ä¾›åº”å•†åå•ã€‚\r\n',0),(113279,3147,'sv','Denna lÃ¤nk genererar en pÃ¥ skÃ¤rmen lista Ã¶ver dina leverantÃ¶rer.',0),(113280,3147,'it','Questo link genera sullo schermo l\'elenco dei fornitori.',0),(113281,3147,'tl','',0),(113282,3147,'th','&#3649;&#3626;&#3604;&#3591;&#3621;&#3636;&#3591;&#3588;&#3660;&#3610;&#3609;&#3592;&#3629;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3649;&#3607;&#3609;&#3586;&#3634;&#3618;',0),(113283,3147,'hi','à¤‡à¤¸ à¤²à¤¿à¤‚à¤• à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤à¤• à¤‘à¤¨-à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤…à¤ªà¤¨à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€à¥¤',0),(113284,3147,'ms','Pautan ini menjana satu skrin Senarai vendor anda.',0),(113285,3147,'ar','ÙŠÙˆÙ„Ø¯ Ù‡Ø°Ø§ Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø· Ø§Ù„Ø´Ø§Ø´Ø© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ† Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(113286,3147,'fr','Ce lien gÃ©nÃ¨re lâ€™un Ã  lâ€™Ã©cran la liste de vos fournisseurs.',0),(113287,3147,'jp','ã?“ã?®ãƒªãƒ³ã‚¯ã?¯æ¥­è€…ç”»é?¢ä¸Šãƒªã‚¹ãƒˆã‚’ä½œã‚Šå‡ºã?—ã?¾ã?™',0),(113288,3147,'pt','Este link gera na tela lista de seus fornecedores.',0),(113289,3147,'ru','Ð­Ñ‚Ð° ÑÑÑ‹Ð»ÐºÐ° ÑÐ¾Ð·Ð´Ð°ÐµÑ‚ Ð½Ð° ÑÐºÑ€Ð°Ð½Ðµ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð².',0),(113290,3147,'es','Este enlace genera una lista en pantalla de sus Proveedores',0),(113291,3147,'de','Diesen Link erzeugt ein on-Screen-Liste Ihrer Lieferanten.',0),(113292,3147,'en','This link generates an on-screen list of your vendors.',0),(113293,3148,'is','',0),(113294,3148,'dr','Turnaround Days Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª Ø¬Ù†Ø³ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ù…Ø¬Ø¯Ø¯ Ø¢Ù†Ù‡Ø§ (Ø¨Ø±Ú¯Ø´Øª',0),(113295,3148,'pr','Turnaround Days Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ù…Ø¬Ø¯Ø¯ Ø¢Ù†Ù‡Ø§ (Ø¨Ø±Ú¯Ø´Øª',0),(113296,3148,'tr','DÃ¶nÃ¼ÅŸ gÃ¼nleri',0),(113297,3148,'pl','Dni realizacji',0),(113298,3148,'bg','ÐžÐ±Ñ€Ð°Ñ‚ Ð´Ð½Ð¸',0),(113299,3148,'ur','Ù¾ÛŒØ´ Ø¯Ù†',0),(113300,3148,'sr','ÐŸÑ€ÐµÐ¾ÐºÑ€ÐµÑ‚ Ð´Ð°Ð½Ð°',0),(113301,3148,'vi','NgÃ y quay vÃ²ng',0),(113302,3148,'af','Rugbymanne dae',0),(113303,3148,'ro','RÄƒspuns de zile',0),(113304,3148,'et','PÃ¶Ã¶re pÃ¤eva',0),(113305,3148,'si','Preobrat dni',0),(113306,3148,'ba','Perputaran hari',0),(113307,3148,'nl','Ommekeer dagen',0),(113308,3148,'fi','LÃ¤pimenoaika pÃ¤ivinÃ¤',0),(113309,3148,'no','Behandlingstid dager',0),(113310,3148,'da','Turnaround dage',0),(113311,3148,'ko','ì²˜ë¦¬ ì¼',0),(113312,3148,'he','×¡×‘×‘ ×™×ž×™×',0),(113313,3148,'el','ÎœÎµÏ„Î±ÏƒÏ„ÏÎ¿Ï†Î® Î·Î¼Î­ÏÎµÏ‚',0),(113314,3148,'zh','å‘¨è½¬å¤©æ•°\r\n',0),(113315,3148,'sv','VÃ¤ndningen dagar',0),(113316,3148,'it','Giorni di turnaround',0),(113317,3148,'tl','',0),(113318,3148,'th','&#3619;&#3629;&#3610;&#3623;&#3633;&#3609;',0),(113319,3148,'hi','à¤¬à¤¦à¤²à¤¾à¤µ à¤¦à¤¿à¤¨à¥‹à¤‚',0),(113320,3148,'ms','Hari pemulihan',0),(113321,3148,'ar','Ø£ÙŠØ§Ù… Ø§Ù„ØªØ­ÙˆÙ„',0),(113322,3148,'fr','Jours de dÃ©lai d\'exÃ©cution',0),(113323,3148,'jp','Turnaround Days',0),(113324,3148,'pt','Reviravolta dias',0),(113325,3148,'ru','ÐŸÐ¾Ð²Ð¾Ñ€Ð¾Ñ‚ Ð´Ð½ÐµÐ¹',0),(113326,3148,'es','DÃ­as de Servicio de Respuesta',0),(113327,3148,'de','Wende-Tage',0),(113328,3148,'en','Turnaround Days',0),(113329,3149,'is','',0),(113330,3149,'dr','(Ø¨Ø±Ú¯Ø´Øª) Ø±ÙˆÙŠ Ù…Ù‚Ø¯Ø§Ø± ',0),(113331,3149,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ù…Ø¬Ø¯Ø¯ Ø¢Ù†Ù‡Ø§ (Ø¨Ø±Ú¯Ø´Øª) Ø±ÙˆÙŠ Ù…Ù‚Ø¯Ø§Ø± ',0),(113332,3149,'tr','DÃ¶nÃ¼ÅŸ gÃ¼n iÃ§inde miktar',0),(113333,3149,'pl','Dni realizacji ponad iloÅ›Ä‡',0),(113334,3149,'bg','ÐžÐ±Ñ€Ð°Ñ‚ Ð´Ð½Ð¸ Ð½Ð°Ð´ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(113335,3149,'ur','Ù¾ÛŒØ´ Ú©Û’ Ø¯Ù†ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø±',0),(113336,3149,'sr','ÐŸÑ€ÐµÐ¾ÐºÑ€ÐµÑ‚ Ð´Ð°Ð½Ð° Ð¿Ñ€ÐµÐºÐ¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(113337,3149,'vi','NgÃ y quay vÃ²ng trÃªn sá»‘ lÆ°á»£ng',0),(113338,3149,'af','Rugbymanne dae oor hoeveelheid',0),(113339,3149,'ro','RÄƒspuns de zile peste cantitatea',0),(113340,3149,'et','PÃ¶Ã¶re pÃ¤eva Ã¼le kogus',0),(113341,3149,'si','Preobrat dni nad koliÄino',0),(113342,3149,'ba','Perputaran hari daripada kuantitas',0),(113343,3149,'nl','Ommekeer dagen boven kwantiteit',0),(113344,3149,'fi','LÃ¤pimenoaika pÃ¤ivinÃ¤ mÃ¤Ã¤rÃ¤n',0),(113345,3149,'no','Behandlingstid dager over antall',0),(113346,3149,'da','Turnaround dage frem for kvantitet',0),(113347,3149,'ko','ìˆ˜ëŸ‰ ì´ìƒì˜ ì²˜ë¦¬ ì¼',0),(113348,3149,'he','×¡×‘×‘ ×™×ž×™× ×ž×¢×œ ×”×›×ž×•×ª',0),(113349,3149,'el','ÎœÎµÏ„Î±ÏƒÏ„ÏÎ¿Ï†Î® Î·Î¼Î­ÏÎµÏ‚ Î­Î½Î±Î½Ï„Î¹ Ï„Î·Ï‚ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±Ï‚',0),(113350,3149,'zh','è¶…è¿‡æ•°é‡å‘¨è½¬å¤©æ•°\r\n',0),(113351,3149,'sv','VÃ¤ndningen dagar Ã¶ver kvantitet',0),(113352,3149,'it','Giorni di inversione di tendenza rispetto alla quantitÃ ',0),(113353,3149,'tl','',0),(113354,3149,'th','&#3619;&#3629;&#3610;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(113355,3149,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¬à¤¦à¤²à¤¾à¤µ à¤¦à¤¿à¤¨à¥‹à¤‚',0),(113356,3149,'ms','Hari pemulihan ke atas kuantiti',0),(113357,3149,'ar','Ø£ÙŠØ§Ù… ØªØ­ÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(113358,3149,'fr','Jours de dÃ©lai d\'exÃ©cution sur la quantitÃ©',0),(113359,3149,'jp','Turnaround days over quantity',0),(113360,3149,'pt','Dias de rotaÃ§Ã£o sobre a quantidade',0),(113361,3149,'ru','ÐŸÐ¾Ð²Ð¾Ñ€Ð¾Ñ‚ Ð´Ð½ÐµÐ¹ Ð½Ð°Ð´ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ð¼',0),(113362,3149,'es','DÃ­as de Servicio de Respuesta sobre cantidad',0),(113363,3149,'de','Wende Tage vor QuantitÃ¤t',0),(113364,3149,'en','Turnaround days over quantity',0),(113365,3150,'is','',0),(113366,3150,'dr','(Ø¨Ø±Ú¯Ø´Øª)  Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù†  Ù…Ù‚Ø¯Ø§Ø±',0),(113367,3150,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ù…Ø¬Ø¯Ø¯ Ø¢Ù†Ù‡Ø§ (Ø¨Ø±Ú¯Ø´Øª)  Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù†  Ù…Ù‚Ø¯Ø§Ø±',0),(113368,3150,'tr','DÃ¶nÃ¼ÅŸ gÃ¼n miktarÄ± kadar',0),(113369,3150,'pl','Dni realizacji do iloÅ›ci',0),(113370,3150,'bg','ÐžÐ±Ñ€Ð°Ñ‚ Ð´Ð½Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(113371,3150,'ur','Ù¾ÛŒØ´ Ø¯Ù†ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(113372,3150,'sr','ÐŸÑ€ÐµÐ¾ÐºÑ€ÐµÑ‚ Ð´Ð°Ð½Ð° Ð·Ð°Ð²Ð¸ÑÐ¸ Ð¾Ð´ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(113373,3150,'vi','NgÃ y quay vÃ²ng tá»›i sá»‘ lÆ°á»£ng',0),(113374,3150,'af','Rugbymanne dae tot die hoeveelheid',0),(113375,3150,'ro','RÄƒspuns de zile pÃ¢nÄƒ la cantitatea',0),(113376,3150,'et','PÃ¶Ã¶re pÃ¤eva koguse piires',0),(113377,3150,'si','Preobrat dni do koliÄine',0),(113378,3150,'ba','Perputaran hari sampai dengan kuantitas',0),(113379,3150,'nl','Ommekeer dagen tot hoeveelheid',0),(113380,3150,'fi','LÃ¤pimenoaika pÃ¤ivinÃ¤ mÃ¤Ã¤rien',0),(113381,3150,'no','Behandlingstid dager til antall',0),(113382,3150,'da','Turnaround dage mÃ¦ngde',0),(113383,3150,'ko','ì–‘ê¹Œì§€ ì²˜ë¦¬ ì¼',0),(113384,3150,'he','×¡×‘×‘ ×™×ž×™× ×¢×“ ×›×ž×•×ª',0),(113385,3150,'el','ÎœÎµÏ„Î±ÏƒÏ„ÏÎ¿Ï†Î® Î·Î¼Î­ÏÎµÏ‚ Î¼Î­Ï‡ÏÎ¹ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(113386,3150,'zh','å‘¨è½¬å¤©æ•°åˆ°æ•°é‡\r\n',0),(113387,3150,'sv','VÃ¤ndningen dagar kvantitet',0),(113388,3150,'it','Giorni di consegna fino alla quantitÃ ',0),(113389,3150,'tl','',0),(113390,3150,'th','&#3619;&#3629;&#3610;&#3623;&#3633;&#3609;&#3648;&#3614;&#3636;&#3656;&#3617;&#3606;&#3638;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(113391,3150,'hi','à¤¬à¤¦à¤²à¤¾à¤µ à¤¦à¤¿à¤¨à¥‹à¤‚ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¤à¤•',0),(113392,3150,'ms','Pemulihan hari kuantiti',0),(113393,3150,'ar','Ø£ÙŠØ§Ù… ØªØ­ÙˆÙ„ Ù…Ø§ ÙŠØµÙ„ Ø¥Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(113394,3150,'fr','Jours de dÃ©lai d\'exÃ©cution jusqu\'Ã  la quantitÃ©',0),(113395,3150,'jp','Turnaround days up to quantity',0),(113396,3150,'pt','Dias de rotaÃ§Ã£o atÃ© quantidade',0),(113397,3150,'ru','ÐŸÐ¾Ð²Ð¾Ñ€Ð¾Ñ‚ Ð´Ð½ÐµÐ¹ Ð´Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(113398,3150,'es','DÃ­as de Servicio de Respuesta hasta la cantidad',0),(113399,3150,'de','Wende Tage Menge',0),(113400,3150,'en','Turnaround days up to quantity',0),(113401,3151,'is','',0),(113402,3151,'dr','Turnaround  Ø²Ù…Ø§Ù† Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª Ø¬Ù†Ø³ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ù…Ø¬Ø¯Ø¯ Ø¢Ù†Ù‡Ø§ (Ø¨Ø±Ú¯Ø´Øª',0),(113403,3151,'pr','Turnaround  Ø²Ù…Ø§Ù† Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ù…Ø¬Ø¯Ø¯ Ø¢Ù†Ù‡Ø§ (Ø¨Ø±Ú¯Ø´Øª',0),(113404,3151,'tr','Geri dÃ¶nÃ¼ÅŸ',0),(113405,3151,'pl','Realizacji',0),(113406,3151,'bg','Ð¡Ñ€Ð¾Ðº Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(113407,3151,'ur','Ù¾ÛŒØ´',0),(113408,3151,'sr','ÐŸÑ€ÐµÐ¾ÐºÑ€ÐµÑ‚',0),(113409,3151,'vi','VÃ²ng quay',0),(113410,3151,'af','Rugbymanne',0),(113411,3151,'ro','RÄƒspuns',0),(113412,3151,'et','PÃ¶Ã¶re',0),(113413,3151,'si','Preobrat',0),(113414,3151,'ba','Perputaran',0),(113415,3151,'nl','Turnaround',0),(113416,3151,'fi','KÃ¤Ã¤nne',0),(113417,3151,'no','Omslaget',0),(113418,3151,'da','Ekspeditionstid',0),(113419,3151,'ko','ì²˜ë¦¬',0),(113420,3151,'he','×¡×‘×‘',0),(113421,3151,'el','ÎœÎµÏ„Î±ÏƒÏ„ÏÎ¿Ï†Î®',0),(113422,3151,'zh','è½¬æœº\r\n',0),(113423,3151,'sv','VÃ¤ndningen',0),(113424,3151,'it','Inversione di tendenza',0),(113425,3151,'tl','',0),(113426,3151,'th','&#3585;&#3634;&#3619;&#3627;&#3617;&#3640;&#3609;&#3619;&#3629;&#3610;',0),(113427,3151,'hi','à¤¬à¤¦à¤²à¤¾à¤µ',0),(113428,3151,'ms','Pemulihan',0),(113429,3151,'ar','ØªØ­ÙˆÙ„',0),(113430,3151,'fr','DÃ©lai d\'exÃ©cution',0),(113431,3151,'jp','è»¢æ?›',0),(113432,3151,'pt','Reviravolta',0),(113433,3151,'ru','ÐŸÐ¾Ð²Ð¾Ñ€Ð¾Ñ‚',0),(113434,3151,'es','Servicio de Respuesta',0),(113435,3151,'de','Wende',0),(113436,3151,'en','Turnaround',0),(113437,3152,'is','',0),(113438,3152,'dr','12',0),(113439,3152,'pr','Ø¯ÙˆØ§Ø²Ø¯Ù‡  12',0),(113440,3152,'tr','on iki',0),(113441,3152,'pl','dwanaÅ›cie',0),(113442,3152,'bg','Ð´Ð²Ð°Ð½Ð°Ð´ÐµÑÐµÑ‚',0),(113443,3152,'ur','Ø¨Ø§Ø±Û',0),(113444,3152,'sr','Ð”Ð²Ð°Ð½Ð°ÐµÑÑ‚',0),(113445,3152,'vi','mÆ°á»i hai',0),(113446,3152,'af','twaalf',0),(113447,3152,'ro','doisprezece',0),(113448,3152,'et','kaksteist',0),(113449,3152,'si','dvanajst',0),(113450,3152,'ba','dua belas',0),(113451,3152,'nl','twaalf',0),(113452,3152,'fi','kaksitoista',0),(113453,3152,'no','tolv',0),(113454,3152,'da','tolv',0),(113455,3152,'ko','12',0),(113456,3152,'he','12',0),(113457,3152,'el','Î´ÏŽÎ´ÎµÎºÎ±',0),(113458,3152,'zh','åäºŒ\r\n',0),(113459,3152,'sv','tolv',0),(113460,3152,'it','dodici',0),(113461,3152,'tl','',0),(113462,3152,'th','12',0),(113463,3152,'hi','à¤¬à¤¾à¤°à¤¹',0),(113464,3152,'ms','dua belas',0),(113465,3152,'ar','Ø¥Ø«Ù†Ù‰ Ø¹Ø´Ø±Ø©',0),(113466,3152,'fr','douze',0),(113467,3152,'jp','12',0),(113468,3152,'pt','doze',0),(113469,3152,'ru','Ð”Ð²ÐµÐ½Ð°Ð´Ñ†Ð°Ñ‚ÑŒ',0),(113470,3152,'es','doce',0),(113471,3152,'de','zwÃ¶lf',0),(113472,3152,'en','twelve',0),(113473,3153,'is','',0),(113474,3153,'dr','20',0),(113475,3153,'pr','Ø¨ÙŠØ³Øª  20',0),(113476,3153,'tr','Yirmi',0),(113477,3153,'pl','dwadzieÅ›cia',0),(113478,3153,'bg','Ð´Ð²Ð°Ð´ÐµÑÐµÑ‚',0),(113479,3153,'ur','Ø¨ÛŒØ³',0),(113480,3153,'sr','Ð”Ð²Ð°Ð´ÐµÑÐµÑ‚',0),(113481,3153,'vi','hai mÆ°Æ¡i',0),(113482,3153,'af','twintig',0),(113483,3153,'ro','douÄƒzeci',0),(113484,3153,'et','kakskÃ¼mmend',0),(113485,3153,'si','dvajset',0),(113486,3153,'ba','dua puluh',0),(113487,3153,'nl','twintig',0),(113488,3153,'fi','kaksikymmentÃ¤',0),(113489,3153,'no','tjue',0),(113490,3153,'da','tyve',0),(113491,3153,'ko','20',0),(113492,3153,'he','×¢×©×¨×™×',0),(113493,3153,'el','ÎµÎ¯ÎºÎ¿ÏƒÎ¹',0),(113494,3153,'zh','äºŒå\r\n\r\n',0),(113495,3153,'sv','tjugo',0),(113496,3153,'it','venti',0),(113497,3153,'tl','',0),(113498,3153,'th','20',0),(113499,3153,'hi','à¤¬à¥€à¤¸',0),(113500,3153,'ms','dua puluh',0),(113501,3153,'ar','Ø¹Ø´Ø±ÙˆÙ†',0),(113502,3153,'fr','vingt',0),(113503,3153,'jp','20',0),(113504,3153,'pt','vinte',0),(113505,3153,'ru','Ð´Ð²Ð°Ð´Ñ†Ð°Ñ‚ÑŒ',0),(113506,3153,'es','veinte',0),(113507,3153,'de','zwanzig',0),(113508,3153,'en','twenty',0),(113509,3154,'is','',0),(113510,3154,'dr','2',0),(113511,3154,'pr','Ø¯Ùˆ 2',0),(113512,3154,'tr','Ä°ki',0),(113513,3154,'pl','Dwa',0),(113514,3154,'bg','Ð”Ð²Ðµ',0),(113515,3154,'ur','Ø¯Ùˆ',0),(113516,3154,'sr','Ð”Ð²Ð°',0),(113517,3154,'vi','Hai',0),(113518,3154,'af','Twee',0),(113519,3154,'ro','DouÄƒ',0),(113520,3154,'et','Kaks',0),(113521,3154,'si','Dve',0),(113522,3154,'ba','Dua',0),(113523,3154,'nl','Twee',0),(113524,3154,'fi','Kaksi',0),(113525,3154,'no','To',0),(113526,3154,'da','To',0),(113527,3154,'ko','2',0),(113528,3154,'he','×©× ×™',0),(113529,3154,'el','Î”ÏÎ¿',0),(113530,3154,'zh','ä¸¤\r\n',0),(113531,3154,'sv','TvÃ¥',0),(113532,3154,'it','Due',0),(113533,3154,'tl','',0),(113534,3154,'th','2',0),(113535,3154,'hi','à¤¦à¥‹',0),(113536,3154,'ms','Dua',0),(113537,3154,'ar','Ø¥Ø«Ù†Ø§Ù†',0),(113538,3154,'fr','Deux',0),(113539,3154,'jp','2',0),(113540,3154,'pt','Dois',0),(113541,3154,'ru','Ð”Ð²Ð°',0),(113542,3154,'es','Dos',0),(113543,3154,'de','Zwei',0),(113544,3154,'en','Two',0),(113545,3155,'is','',0),(113546,3155,'dr','Ø¯Ùˆ Ù…Ø±ØªØ¨ Ø³Ø§Ø²ÙŠ',0),(113547,3155,'pr','Ø¯Ùˆ Ù…Ø±ØªØ¨ Ø³Ø§Ø²ÙŠ',0),(113548,3155,'tr','Ä°ki sÃ¼sler',0),(113549,3155,'pl','Dwa wzory',0),(113550,3155,'bg','Ð”Ð²Ðµ Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(113551,3155,'ur','Ø¯Ùˆ Ù¹Ø±ÛŒÙ…Ø³',0),(113552,3155,'sr','Ð”Ð²Ð° Ð²ÐµÑ™Ñ‚Ð¸Ñ†Ð°',0),(113553,3155,'vi','Hai cáº¯t xÃ©n',0),(113554,3155,'af','Twee Trims',0),(113555,3155,'ro','DouÄƒ ornamente',0),(113556,3155,'et','Kaks trimmib',0),(113557,3155,'si','Dve okraskov',0),(113558,3155,'ba','Dua Trims',0),(113559,3155,'nl','Twee Trims',0),(113560,3155,'fi','Kaksi koristeita',0),(113561,3155,'no','To Trims',0),(113562,3155,'da','To trim',0),(113563,3155,'ko','2 ê°œì˜ ì†ì§ˆ',0),(113564,3155,'he','Trims ×©× ×™',0),(113565,3155,'el','Î”ÏÎ¿ Ï€ÎµÏÎ¹Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚',0),(113566,3155,'zh','ä¸¤ä¸ªè¾…æ–™\r\n',0),(113567,3155,'sv','TvÃ¥ klippningar',0),(113568,3155,'it','Due finiture',0),(113569,3155,'tl','',0),(113570,3155,'th','2 Trims',0),(113571,3155,'hi','à¤¦à¥‹ à¤›à¤¾à¤à¤Ÿà¥‹',0),(113572,3155,'ms','Memotong dua',0),(113573,3155,'ar','Ø§Ø«Ù†ÙŠÙ† Ù…Ù† Ø§Ù„Ø¯ÙŠÙƒÙˆØ±Ø§Øª',0),(113574,3155,'fr','Deux garnitures',0),(113575,3155,'jp','Two Trims',0),(113576,3155,'pt','Duas guarniÃ§Ãµes',0),(113577,3155,'ru','Ð”Ð²Ðµ Ð¿Ð»Ð°Ð½ÐºÐ¸',0),(113578,3155,'es','Dos Adornos',0),(113579,3155,'de','Zwei Trims',0),(113580,3155,'en','Two Trims',0),(113581,3156,'is','',0),(113582,3156,'dr','Ù†ÙˆØ¹ ',0),(113583,3156,'pr','Ù†ÙˆØ¹ ',0),(113584,3156,'tr','TÃ¼rÃ¼',0),(113585,3156,'pl','Typ',0),(113586,3156,'bg','Ð¢Ð¸Ð¿',0),(113587,3156,'ur','Ù‚Ø³Ù…',0),(113588,3156,'sr','Ð¢Ð¸Ð¿',0),(113589,3156,'vi','Loáº¡i',0),(113590,3156,'af','Tipe',0),(113591,3156,'ro','Tip',0),(113592,3156,'et','TÃ¼Ã¼p',0),(113593,3156,'si','Vrsta',0),(113594,3156,'ba','Jenis',0),(113595,3156,'nl','Type',0),(113596,3156,'fi','Tyyppi',0),(113597,3156,'no','Type',0),(113598,3156,'da','Type',0),(113599,3156,'ko','ìœ í˜•',0),(113600,3156,'he','×¡×•×’',0),(113601,3156,'el','Î¤ÏÏ€Î¿Ï‚',0),(113602,3156,'zh','ç±»åž‹\r\n',0),(113603,3156,'sv','Typ',0),(113604,3156,'it','Tipo',0),(113605,3156,'tl','',0),(113606,3156,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(113607,3156,'hi','à¤ªà¥à¤°à¤•à¤¾à¤°',0),(113608,3156,'ms','Jenis',0),(113609,3156,'ar','Ø§Ù„Ù†ÙˆØ¹',0),(113610,3156,'fr','Type',0),(113611,3156,'jp','ã‚¿ã‚¤ãƒ—',0),(113612,3156,'pt','Tipo',0),(113613,3156,'ru','Ð¢Ð¸Ð¿',0),(113614,3156,'es','Tipo ',0),(113615,3156,'de','Typ',0),(113616,3156,'en','Type',0),(113617,3157,'is','',0),(113618,3157,'dr','Ù†ÙˆØ¹ ÙØ¹Ø§Ù„ÙŠØª ',0),(113619,3157,'pr','Ù†ÙˆØ¹ ÙØ¹Ø§Ù„ÙŠØª ',0),(113620,3157,'tr','Hesap tÃ¼rÃ¼',0),(113621,3157,'pl','Typ konta',0),(113622,3157,'bg','Ð¢Ð¸Ð¿ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(113623,3157,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(113624,3157,'sr','Ð¢Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(113625,3157,'vi','Loáº¡i TK',0),(113626,3157,'af','Tipe Rekening',0),(113627,3157,'ro','Tip de cont',0),(113628,3157,'et','Konto tÃ¼Ã¼p',0),(113629,3157,'si','Vrsto raÄuna',0),(113630,3157,'ba','Jenis account',0),(113631,3157,'nl','Type account',0),(113632,3157,'fi','Tilin tyyppi',0),(113633,3157,'no','Kontotype',0),(113634,3157,'da','Kontotype',0),(113635,3157,'ko','ê³„ì • ìœ í˜•',0),(113636,3157,'he','×¡×•×’ ×”×—×©×‘×•×Ÿ',0),(113637,3157,'el','Î¤ÏÏ€Î¿Ï‚ Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(113638,3157,'zh','å¸æˆ·ç±»åž‹\r\n',0),(113639,3157,'sv','Typ av konto',0),(113640,3157,'it','Tipo di account',0),(113641,3157,'tl','',0),(113642,3157,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(113643,3157,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(113644,3157,'ms','Jenis akaun',0),(113645,3157,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(113646,3157,'fr','Type de compte',0),(113647,3157,'jp','é ?é‡‘ã‚¿ã‚¤ãƒ—',0),(113648,3157,'pt','Tipo de conta',0),(113649,3157,'ru','Ð¢Ð¸Ð¿ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(113650,3157,'es','Tipo de Cuenta',0),(113651,3157,'de','Art des Kontos',0),(113652,3157,'en','Type of account',0),(113653,3158,'is','',0),(113654,3158,'dr','Ø§Ù†ÙˆØ§Ø¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(113655,3158,'pr','Ø§Ù†ÙˆØ§Ø¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(113656,3158,'tr','Vergi tÃ¼rleri',0),(113657,3158,'pl','Rodzaje podatkÃ³w',0),(113658,3158,'bg','Ð’Ð¸Ð´Ð¾Ð²Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(113659,3158,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(113660,3158,'sr','Ð¢Ð¸Ð¿Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(113661,3158,'vi','Loáº¡i thuáº¿',0),(113662,3158,'af','Belastingtipes',0),(113663,3158,'ro','Tipuri de impozitare',0),(113664,3158,'et','Maksude liigid',0),(113665,3158,'si','StroÅ¡kovni nosilci',0),(113666,3158,'ba','Jenis pajak',0),(113667,3158,'nl','Fiscale typen',0),(113668,3158,'fi','Verolajit',0),(113669,3158,'no','Mva-typer',0),(113670,3158,'da','Skat typer',0),(113671,3158,'ko','ì„¸ê¸ˆ ì¢…ë¥˜',0),(113672,3158,'he','×¡×•×’×™ ×”×ž×¡',0),(113673,3158,'el','ÎœÎ¿ÏÏ†Î­Ï‚ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¯Î±Ï‚',0),(113674,3158,'zh','ç¨Žç§\r\n',0),(113675,3158,'sv','Momstyper',0),(113676,3158,'it','Tipi di imposte',0),(113677,3158,'tl','',0),(113678,3158,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;',0),(113679,3158,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(113680,3158,'ms','Jenis-jenis cukai',0),(113681,3158,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(113682,3158,'fr','Types d\'impÃ´t',0),(113683,3158,'jp','ç¨Žã‚¿ã‚¤ãƒ—',0),(113684,3158,'pt','Tipos de imposto',0),(113685,3158,'ru','Ð¢Ð¸Ð¿Ñ‹ ÐÐ°Ð»Ð¾Ð³Ð¾Ð²',0),(113686,3158,'es','Tipo de Impuesto',0),(113687,3158,'de','Steuerarten',0),(113688,3158,'en','Tax Types',0),(113689,3159,'is','',0),(113690,3159,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ù„ÙŠØ³Øª Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ Ù†ÙŠØ³Øª ',0),(113691,3159,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ù„ÙŠØ³Øª Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ Ù†ÙŠØ³Øª ',0),(113692,3159,'tr','BÃ¼tÃ§elerin listesi alÄ±namÄ±yor',0),(113693,3159,'pl','Nie moÅ¼na uzyskaÄ‡ listy budÅ¼etÃ³w.',0),(113694,3159,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸',0),(113695,3159,'ur','ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) Ú©ÛŒ ÙÛØ±Ø³Øª Ø¨Ø§Ø²ÛŒØ§ÙØª Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(113696,3159,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ Ð»Ð¸ÑÑ‚Ñƒ Ð±ÑƒÑŸÐµÑ‚Ðµ',0),(113697,3159,'vi','KhÃ´ng truy váº¥n Ä‘Æ°á»£c danh sÃ¡ch ngÃ¢n sÃ¡ch',0),(113698,3159,'af','Nie instaat om die lys van begrotings te herwin',0),(113699,3159,'ro','Imposibil de regÄƒsit lista bugetelor',0),(113700,3159,'et','Eelarvete loendit ei saa tuua',0),(113701,3159,'si','Ni mogoÄe pridobiti seznam proraÄunov',0),(113702,3159,'ba','Mampu mengambil daftar anggaran',0),(113703,3159,'nl','Niet in staat om op te halen van de lijst van budgetten',0),(113704,3159,'fi','Ei voi noutaa budjettiluettelo.',0),(113705,3159,'no','Kan ikke hente liste over budsjetter',0),(113706,3159,'da','Stand til at hente listen over budgetter',0),(113707,3159,'ko','ì˜ˆì‚°ì˜ ëª©ë¡ì„ ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(113708,3159,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ××—×–×¨ ×¨×©×™×ž×ª ×ª×§×¦×™×‘×™×',0),(113709,3159,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚ Ï„Ï‰Î½ Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŽÎ½',0),(113710,3159,'zh','æ— æ³•æ£€ç´¢é¢„ç®—æ¸…å•\r\n',0),(113711,3159,'sv','Det gick inte att hÃ¤mta listan Ã¶ver budgetar',0),(113712,3159,'it','Impossibile recuperare l\'elenco dei bilanci',0),(113713,3159,'tl','',0),(113714,3159,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3585;&#3641;&#3657;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3621;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3652;&#3604;&#3657;',0),(113715,3159,'hi','à¤¬à¤œà¤Ÿ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(113716,3159,'ms','Tidak dapat mendapatkan semula senarai belanjawan',0),(113717,3159,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¥Ø³ØªØ±Ø¯Ø§Ø¯ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª',0),(113718,3159,'fr','Impossible de rÃ©cupÃ©rer la liste des budgets',0),(113719,3159,'jp','äºˆç®—ã?®ãƒªã‚¹ãƒˆã‚’å?–ã‚Šè¾¼ã‚?ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(113720,3159,'pt','NÃ£o Ã© possÃ­vel recuperar a lista de orÃ§amentos',0),(113721,3159,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð²Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¾Ð²',0),(113722,3159,'es','No se Puede recuperar lista de presupuestos',0),(113723,3159,'de','Keine Liste der Haushalte abrufen',0),(113724,3159,'en','Unable to retrieve list of budgets',0),(113725,3160,'is','',0),(113726,3160,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù…Ø¹Ú©ÙˆØ³ Ú©Ø±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù†ÙŠØ³Øª ',0),(113727,3160,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù…Ø¹Ú©ÙˆØ³ Ú©Ø±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù†ÙŠØ³Øª ',0),(113728,3160,'tr','FiÅŸler geri yÃ¼klenemiyor.',0),(113729,3160,'pl','Nie moÅ¼na odwrÃ³ciÄ‡ bony.',0),(113730,3160,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¾Ð±ÑŠÑ€Ð½Ðµ Ð½Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸.',0),(113731,3160,'ur','ÙˆØ§Ø¤Ú†Ø± Ù…Ø¹Ú©ÙˆØ³ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(113732,3160,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‚Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ.',0),(113733,3160,'vi','KhÃ´ng tÃ¬m tháº¥y phiáº¿u viáº¿t ngÆ°á»£c',0),(113734,3160,'af','Kon nie die omgekeerde van bewyse.',0),(113735,3160,'ro','Imposibilitatea de a inversa vouchere.',0),(113736,3160,'et','Ei saa tÃ¼histada kandeid.',0),(113737,3160,'si','Ni mogoÄe obrniti bonov.',0),(113738,3160,'ba','Tidak dapat membalikkan voucher.',0),(113739,3160,'nl','Niet in staat om te keren bonnen.',0),(113740,3160,'fi','Ei pysty kÃ¤Ã¤ntÃ¤mÃ¤Ã¤n tositteet.',0),(113741,3160,'no','Kan ikke reversere bilag.',0),(113742,3160,'da','Stand til at vende vÃ¦rdikuponer.',0),(113743,3160,'ko','ì¦ì¸ì„ ë°˜ëŒ€ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(113744,3160,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×¤×•×š ××ª ×”×©×•×‘×¨×™×.',0),(113745,3160,'el','Î”Ï…Î½Î±Ï„ÏŒ Î½Î± Î±Î½Ï„Î¹ÏƒÏ„ÏÎ­ÏˆÎµÎ¹ Ï„Î± ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î±.',0),(113746,3160,'zh','æ— æ³•æ‰­è½¬å‡­å•\r\n',0),(113747,3160,'sv','Det gÃ¥r inte att vÃ¤nda kuponger.',0),(113748,3160,'it','Impossibile invertire il voucher.',0),(113749,3160,'tl','',0),(113750,3160,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3585;&#3621;&#3633;&#3610;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3652;&#3604;&#3657;',0),(113751,3160,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤•à¥‹ à¤‰à¤²à¤Ÿà¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥à¥¤',0),(113752,3160,'ms','Tidak dapat mengundurkan baucar.',0),(113753,3160,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¹ÙƒØ³ Ø§Ù„Ù‚Ø³Ø§Ø¦Ù….',0),(113754,3160,'fr','Impossible d\'inverser les piÃ¨ces justificatives.',0),(113755,3160,'jp','ä¼?ç¥¨ã‚’å?–ã‚Šæ¶ˆã?›ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(113756,3160,'pt','NÃ£o Ã© possÃ­vel reverter os vouchers.',0),(113757,3160,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ‚Ð°Ð»Ð¾Ð½Ñ‹.',0),(113758,3160,'es','No se Puede reversar vouchers',0),(113759,3160,'de','Nicht in der Lage, Gutscheine umzukehren.',0),(113760,3160,'en','Unable to reverse vouchers.',0),(113761,3161,'is','',0),(113762,3161,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù†ÙŠØ³Øª ',0),(113763,3161,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù†ÙŠØ³Øª ',0),(113764,3161,'tr','VeritabanÄ±nÄ± seÃ§mek iÃ§in',0),(113765,3161,'pl','Nie moÅ¼na wybraÄ‡ bazy danych',0),(113766,3161,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(113767,3161,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(113768,3161,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ñ‚Ð¸ Ð±Ð°Ð·Ñƒ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(113769,3161,'vi','KhÃ´ng chá»n Ä‘Æ°á»£c dá»¯ liá»‡u',0),(113770,3161,'af','Nie Instaat om databasis te kies nie',0),(113771,3161,'ro','Imposibilitatea de a selecta baza de date',0),(113772,3161,'et','Ei saa valida andmebaasi',0),(113773,3161,'si','Ni mogoÄe izbrati, baze podatkov',0),(113774,3161,'ba','Mampu memilih database',0),(113775,3161,'nl','Kan geen database te selecteren',0),(113776,3161,'fi','Voi valita tietokannan',0),(113777,3161,'no','Kunne ikke velge database',0),(113778,3161,'da','Kunne ikke vÃ¦lge databasen',0),(113779,3161,'ko','ë°ì´í„°ë² ì´ìŠ¤ë¥¼ ì„ íƒí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(113780,3161,'he','× ×™×ª×Ÿ ×œ×‘×—×•×¨ ×ž×¡×“ × ×ª×•× ×™×',0),(113781,3161,'el','Î‘Î½Î¯ÎºÎ±Î½Î¿Ï‚ ÏƒÎµ Î´Î¹Î±Î»Î­Î³Ï‰ Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(113782,3161,'zh','æ— æ³•é€‰æ‹©æ•°æ®åº“\r\n',0),(113783,3161,'sv','Det gÃ¥r inte att vÃ¤lja databas',0),(113784,3161,'it','Impossibile selezionare il database',0),(113785,3161,'tl','',0),(113786,3161,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3621;&#3639;&#3629;&#3585;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3652;&#3604;&#3657;',0),(113787,3161,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(113788,3161,'ms','Tidak boleh memilih pangkalan data',0),(113789,3161,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ ØªØ­Ø¯ÙŠØ¯ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(113790,3161,'fr','Impossible de sÃ©lectionner la base de donnÃ©es',0),(113791,3161,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?®é?¸æŠžã?Œã?§ã??ã?¾ã?›ã‚“',0),(113792,3161,'pt','NÃ£o Ã© possÃ­vel selecionar o banco de dados',0),(113793,3161,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð±Ð°Ð·Ñƒ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(113794,3161,'es','No se Puede seleccionar base de datos',0),(113795,3161,'de','Keine Datenbank auswÃ¤hlen',0),(113796,3161,'en','Unable to select database',0),(113797,3162,'is','',0),(113798,3162,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ ',0),(113799,3162,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ ',0),(113800,3162,'tr','FaturalandÄ±rÄ±lmamÄ±ÅŸ sipariÅŸler',0),(113801,3162,'pl','ZleceÅ„ nieopÅ‚aconych',0),(113802,3162,'bg','Unbilled Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(113803,3162,'ur','ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(113804,3162,'sr','Ð£Ð½Ð±Ð¸Ð»Ð»ÐµÐ´ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(113805,3162,'vi','ÄÆ¡n HÃ ng ChÆ°a Ra HÃ³a ÄÆ¡n',0),(113806,3162,'af','Ongefaktureerde Bestellings',0),(113807,3162,'ro','Comenzi de unbilled',0),(113808,3162,'et','Ilma arveta tellimused',0),(113809,3162,'si','Unbilled naroÄila',0),(113810,3162,'ba','Tertagih pesanan',0),(113811,3162,'nl','Nog niet gefactureerde Orders',0),(113812,3162,'fi','Unbilled tilaukset',0),(113813,3162,'no','Fakturert ordre',0),(113814,3162,'da','Faktureret ordrer',0),(113815,3162,'ko','ë° ì£¼ë¬¸',0),(113816,3162,'he','×”×–×ž× ×•×ª unbilled',0),(113817,3162,'el','Î‘Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(113818,3162,'zh','æœªå¼€å•è®¢å•\r\n',0),(113819,3162,'sv','Relaterade order',0),(113820,3162,'it','AttivitÃ  non ancora fatturati ordini',0),(113821,3162,'tl','',0),(113822,3162,'th','&#3652;&#3617;&#3656;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(113823,3162,'hi','Unbilled à¤†à¤¦à¥‡à¤¶',0),(113824,3162,'ms','Perintah-perintah lepas',0),(113825,3162,'ar','Ø£ÙˆØ§Ù…Ø± ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(113826,3162,'fr','Commandes non-facture',0),(113827,3162,'jp','æœªè«‹æ±‚æ³¨æ–‡',0),(113828,3162,'pt','Ordens nÃ£o faturadas',0),(113829,3162,'ru','ÐÐµ Ð¾Ð¿Ð»Ð°Ñ‚Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(113830,3162,'es','Ordenes No Facturados',0),(113831,3162,'de','Noch nicht fakturierte AuftrÃ¤ge',0),(113832,3162,'en','Unbilled Orders',0),(113833,3163,'is','',0),(113834,3163,'dr','(Ø¯Ø±Ø¯Ø³Øª',0),(113835,3163,'pr','Ø²ÙŠØ±  (Ø¯Ø±Ø¯Ø³Øª',0),(113836,3163,'tr','altÄ±nda',0),(113837,3163,'pl','pod',0),(113838,3163,'bg','Ð¿Ð¾Ð´',0),(113839,3163,'ur','Ú©Û’ ØªØ­Øª',0),(113840,3163,'sr','Ñƒ Ð¾ÐºÐ²Ð¸Ñ€Ñƒ',0),(113841,3163,'vi','dÆ°á»›i',0),(113842,3163,'af','onder',0),(113843,3163,'ro','sub',0),(113844,3163,'et','alusel',0),(113845,3163,'si','pod',0),(113846,3163,'ba','di bawah',0),(113847,3163,'nl','onder',0),(113848,3163,'fi','mukaisesti',0),(113849,3163,'no','under',0),(113850,3163,'da','under',0),(113851,3163,'ko','ì•„ëž˜',0),(113852,3163,'he','×ª×—×ª',0),(113853,3163,'el','ÎºÎ¬Ï„Ï‰ Î±Ï€ÏŒ',0),(113854,3163,'zh','ä¸‹\r\n',0),(113855,3163,'sv','under',0),(113856,3163,'it','sotto',0),(113857,3163,'tl','',0),(113858,3163,'th','&#3651;&#3605;&#3657;',0),(113859,3163,'hi','à¤•à¥‡ à¤…à¤‚à¤¤à¤°à¥à¤—à¤¤',0),(113860,3163,'ms','di bawah',0),(113861,3163,'ar','ØªØ­Øª',0),(113862,3163,'fr','en vertu de',0),(113863,3163,'jp','ä¸‹',0),(113864,3163,'pt','sob',0),(113865,3163,'ru','Ð¿Ð¾Ð´',0),(113866,3163,'es','Bajo',0),(113867,3163,'de','unter',0),(113868,3163,'en','under',0),(113869,3164,'is','',0),(113870,3164,'dr','Ù†Ø§ Ù…Ø¹ÙŠÙ† ',0),(113871,3164,'pr','Ù†Ø§ Ù…Ø¹ÙŠÙ† ',0),(113872,3164,'tr','Belirsiz',0),(113873,3164,'pl','NieokreÅ›lony',0),(113874,3164,'bg','ÐÐµÐ¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½',0),(113875,3164,'ur','Ù…Ø°Ø¨Ø°Ø¨',0),(113876,3164,'sr','ÐÐµÐ¾Ð´Ñ€ÐµÑ’ÐµÐ½Ðµ',0),(113877,3164,'vi','ChÆ°a xÃ¡c Ä‘á»‹nh',0),(113878,3164,'af','Ongedetermineerd',0),(113879,3164,'ro','Nedeterminata',0),(113880,3164,'et','MÃ¤Ã¤ratlemata',0),(113881,3164,'si','NedoloÄeno',0),(113882,3164,'ba','Belum ditentukan',0),(113883,3164,'nl','Onbepaald',0),(113884,3164,'fi','MÃ¤Ã¤rittelemÃ¤tÃ¶n',0),(113885,3164,'no','Ukjent',0),(113886,3164,'da','Ubestemt',0),(113887,3164,'ko','ì•Œ ìˆ˜ ì—†ëŠ”',0),(113888,3164,'he','×œ× × ×§×‘×¢',0),(113889,3164,'el','Î‘Ï€ÏÎ¿ÏƒÎ´Î¹ÏŒÏÎ¹ÏƒÏ„Î¿',0),(113890,3164,'zh','å¾…å®š\r\n',0),(113891,3164,'sv','ObestÃ¤md',0),(113892,3164,'it','Indeterminato',0),(113893,3164,'tl','',0),(113894,3164,'th','&#3652;&#3617;&#3656;&#3605;&#3633;&#3657;&#3591;&#3651;&#3592;',0),(113895,3164,'hi','à¤…à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤¿à¤¤',0),(113896,3164,'ms','Undetermined',0),(113897,3164,'ar','ØºÙŠØ± Ù…Ø­Ø¯Ø¯',0),(113898,3164,'fr','IndÃ©terminÃ©',0),(113899,3164,'jp','ä¸?ç¢ºå®šã?®',0),(113900,3164,'pt','Indeterminado',0),(113901,3164,'ru','ÐÐµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¾',0),(113902,3164,'es','No Determinado',0),(113903,3164,'de','Unbestimmten',0),(113904,3164,'en','Undetermined',0),(113905,3165,'is','',0),(113906,3165,'dr','ÙˆØ§Ø­Ø¯ ',0),(113907,3165,'pr','ÙˆØ§Ø­Ø¯ ',0),(113908,3165,'tr','Birim',0),(113909,3165,'pl','Jednostki',0),(113910,3165,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð°',0),(113911,3165,'ur','ÛŒÙˆÙ†Ù¹',0),(113912,3165,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(113913,3165,'vi','ÄÆ¡n vá»‹',0),(113914,3165,'af','Eenheid',0),(113915,3165,'ro','Unitate',0),(113916,3165,'et','Ãœhik',0),(113917,3165,'si','Enota',0),(113918,3165,'ba','Unit',0),(113919,3165,'nl','Eenheid',0),(113920,3165,'fi','YksikkÃ¶',0),(113921,3165,'no','Enhet',0),(113922,3165,'da','Enhed',0),(113923,3165,'ko','ë‹¨ìœ„',0),(113924,3165,'he','×™×—×™×“×”',0),(113925,3165,'el','ÎœÎ¿Î½Î¬Î´Î±',0),(113926,3165,'zh','å•ä½\r\n',0),(113927,3165,'sv','Enhet',0),(113928,3165,'it','UnitÃ ',0),(113929,3165,'tl','',0),(113930,3165,'th','&#3627;&#3609;&#3656;&#3623;&#3618;',0),(113931,3165,'hi','à¤‡à¤•à¤¾à¤ˆ',0),(113932,3165,'ms','Unit',0),(113933,3165,'ar','Ø§Ù„ÙˆØ­Ø¯Ø©',0),(113934,3165,'fr','UnitÃ©',0),(113935,3165,'jp','å?˜ä½?',0),(113936,3165,'pt','Unidade',0),(113937,3165,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð°',0),(113938,3165,'es','Unidad',0),(113939,3165,'de','Einheit',0),(113940,3165,'en','Unit',0),(113941,3166,'is','',0),(113942,3166,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ ',0),(113943,3166,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ ',0),(113944,3166,'tr','Birim adÄ± Ekle',0),(113945,3166,'pl','Dodaj nazwÄ™ jednostki',0),(113946,3166,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð¼Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(113947,3166,'ur','ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ù†Ø§Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(113948,3166,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð¸Ð¼Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(113949,3166,'vi','ThÃªm tÃªn ÄÆ¡n vá»‹',0),(113950,3166,'af','Eenheidsnaam Skep',0),(113951,3166,'ro','Adauga nume de unitatea de',0),(113952,3166,'et','Ãœksuse nime lisamine',0),(113953,3166,'si','Dodaj ime enote',0),(113954,3166,'ba','Tambahkan nama unit',0),(113955,3166,'nl','Naam van de eenheid toevoegen',0),(113956,3166,'fi','YksikÃ¶n nimi LisÃ¤Ã¤',0),(113957,3166,'no','Navn legge',0),(113958,3166,'da','Enhed navn tilfÃ¸je',0),(113959,3166,'ko','ë‹¨ìœ„ ì´ë¦„ ì¶”ê°€',0),(113960,3166,'he','×™×—×™×“×ª ×©× ×œ×”×•×¡×™×£',0),(113961,3166,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(113962,3166,'zh','å•ä½åç§°åœ°å€\r\n',0),(113963,3166,'sv','LÃ¤gg till enhet namn',0),(113964,3166,'it','Aggiungi nome unitÃ ',0),(113965,3166,'tl','',0),(113966,3166,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(113967,3166,'hi','à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤¨à¤¾à¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(113968,3166,'ms','Tambah nama unit',0),(113969,3166,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø©',0),(113970,3166,'fr','Nom de l\'unitÃ© ajouter',0),(113971,3166,'jp','å?˜ä½?å??è¿½åŠ ',0),(113972,3166,'pt','Adicionar o nome da unidade',0),(113973,3166,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ',0),(113974,3166,'es','Agregar Nombre de Unidad ',0),(113975,3166,'de','Name Organisationseinheit hinzufÃ¼gen',0),(113976,3166,'en','Unit Name Add',0),(113977,3167,'is','',0),(113978,3167,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(113979,3167,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(113980,3167,'tr','Birim adÄ± baÅŸarÄ±yla eklendi',0),(113981,3167,'pl','Nazwa jednostki dodaje siÄ™ pomyÅ›lnie',0),(113982,3167,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(113983,3167,'ur','ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù… Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(113984,3167,'sr','Ð˜Ð¼Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(113985,3167,'vi','ThÃªm tÃªn ÄÆ¡n vá»‹ thÃ nh cÃ´ng',0),(113986,3167,'af','Eenheidsnaam suksesvol geskep',0),(113987,3167,'ro','Nume de unitatea adÄƒugat cu succes',0),(113988,3167,'et','Ãœksuse nime lisamine Ãµnnestus',0),(113989,3167,'si','Ime enote, ki so dodani',0),(113990,3167,'ba','Nama unit ditambahkan berhasil',0),(113991,3167,'nl','Eenheid naam toegevoegd',0),(113992,3167,'fi','YksikÃ¶n nimi lisÃ¤Ã¤minen onnistui',0),(113993,3167,'no','Navn lagt',0),(113994,3167,'da','Enhed navn tilfÃ¸jet',0),(113995,3167,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ëœ ìž¥ì¹˜ ì´ë¦„',0),(113996,3167,'he','×‘×©× ×™×—×™×“×ª × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(113997,3167,'el','ÎŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(113998,3167,'zh','å•ä½åç§°æ·»åŠ æˆåŠŸ\r\n',0),(113999,3167,'sv','Enhetens namn lagts',0),(114000,3167,'it','UnitÃ  nome aggiunto con successo',0),(114001,3167,'tl','',0),(114002,3167,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(114003,3167,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¾à¤® à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(114004,3167,'ms','Nama unit yang berjaya menambah',0),(114005,3167,'ar','Ø£Ø¶ÙŠÙ Ø¥Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(114006,3167,'fr','Nom de l\'unitÃ© ajoutÃ©e avec succÃ¨s',0),(114007,3167,'jp','å?˜ä½?å??ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(114008,3167,'pt','Nome da unidade adicionada com sucesso',0),(114009,3167,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(114010,3167,'es','Nombre de Unidad agregado exitosamente',0),(114011,3167,'de','Der Name der Organisationseinheit erfolgreich hinzugefÃ¼gt',0),(114012,3167,'en','Unit Name added successfully',0),(114013,3168,'is','',0),(114014,3168,'dr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯Ø¯Ø§Ø±Ø¯',0),(114015,3168,'pr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯Ø¯Ø§Ø±Ø¯',0),(114016,3168,'tr','Birim adÄ± zaten var',0),(114017,3168,'pl','Nazwa jednostki juÅ¼ istnieje',0),(114018,3168,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð¼Ðµ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(114019,3168,'ur','ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ù†Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(114020,3168,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð¼Ðµ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(114021,3168,'vi','TÃªn ÄÆ¡n vá»‹ Ä‘Ã£ cÃ³',0),(114022,3168,'af','Eenheidsnaam bestaan alreeds',0),(114023,3168,'ro','Nume de unitatea existÄƒ deja',0),(114024,3168,'et','Ãœksuse nimi on juba olemas',0),(114025,3168,'si','Enota ime Å¾e obstaja',0),(114026,3168,'ba','Nama unit sudah ada',0),(114027,3168,'nl','Eenheid naam bestaat al',0),(114028,3168,'fi','YksikÃ¶n nimi on jo olemassa',0),(114029,3168,'no','Navn finnes allerede',0),(114030,3168,'da','Enhed navn findes allerede',0),(114031,3168,'ko','ìž¥ì¹˜ ì´ë¦„ì´ ì´ë¯¸',0),(114032,3168,'he','×™×—×™×“×ª ×©× ×›×‘×¨ ×§×™×™×',0),(114033,3168,'el','ÎœÎ¿Î½Î¬Î´Î± ÏŒÎ½Î¿Î¼Î± Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(114034,3168,'zh','å•ä½åç§°å·²å­˜åœ¨\r\n',0),(114035,3168,'sv','Enhetens namn finns redan',0),(114036,3168,'it','Nome dell\'unitÃ  esiste giÃ ',0),(114037,3168,'tl','',0),(114038,3168,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3591;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(114039,3168,'hi','à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤¨à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(114040,3168,'ms','Nama unit sudah wujud',0),(114041,3168,'ar','Ø¥Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø© Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(114042,3168,'fr','Nom de l\'unitÃ© existe dÃ©jÃ ',0),(114043,3168,'jp','å?˜ä½?å??ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(114044,3168,'pt','Unidade nome jÃ¡ existe.',0),(114045,3168,'ru','Ð˜Ð¼Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(114046,3168,'es','Nombre de Unidad ya existe',0),(114047,3168,'de','GerÃ¤tename ist bereits vorhanden.',0),(114048,3168,'en','Unit Name already exists',0),(114049,3169,'is','',0),(114050,3169,'dr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(114051,3169,'pr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(114052,3169,'tr','Birim adÄ± baÅŸarÄ±yla silindi',0),(114053,3169,'pl','Nazwa jednostki przesâ”‚anie',0),(114054,3169,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(114055,3169,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù…',0),(114056,3169,'sr','Ð˜Ð¼Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(114057,3169,'vi','XÃ³a TÃªn ÄÆ¡n vá»‹ thÃ nh cÃ´ng',0),(114058,3169,'af','Eenheidsnaam suksesvol geskrap',0),(114059,3169,'ro','Nume de unitatea eliminÄƒ cu succes',0),(114060,3169,'et','Ãœksuse nime kustutamine Ãµnnestus',0),(114061,3169,'si','Ime enote uspeÅ¡no izbrisana',0),(114062,3169,'ba','Nama unit dihapus berhasil',0),(114063,3169,'nl','Naam van de eenheid met succes verwijderd',0),(114064,3169,'fi','YksikÃ¶n nimi poistettu',0),(114065,3169,'no','Navn pÃ¥ slettet',0),(114066,3169,'da','Enhed navn slettet',0),(114067,3169,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ë‹¨ìœ„ ì´ë¦„',0),(114068,3169,'he','×‘×©× ×™×—×™×“×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(114069,3169,'el','ÎŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(114070,3169,'zh','å•ä½åç§°åˆ é™¤æˆåŠŸ\r\n',0),(114071,3169,'sv','Enhetens namn raderades',0),(114072,3169,'it','UnitÃ  nome eliminato con successo',0),(114073,3169,'tl','',0),(114074,3169,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3606;&#3641;&#3585;&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(114075,3169,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¾à¤® à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(114076,3169,'ms','Nama unit dihapuskan dengan jayanya',0),(114077,3169,'ar','Ø­Ø°Ù Ø¥Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(114078,3169,'fr','Nom de l\'unitÃ© supprimÃ©e avec succÃ¨s',0),(114079,3169,'jp','å?˜ä½?å??ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(114080,3169,'pt','Unidade nome apagado com sucesso',0),(114081,3169,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(114082,3169,'es','Nombre de Unidad eliminado exitosamente',0),(114083,3169,'de','Der Name der Organisationseinheit erfolgreich gelÃ¶scht',0),(114084,3169,'en','Unit Name deleted successfully',0),(114085,3170,'is','',0),(114086,3170,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ù… ÙˆØ§Ø­Ø¯',0),(114087,3170,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ù… ÙˆØ§Ø­Ø¯',0),(114088,3170,'tr','Birim adÄ± gÃ¼ncelleÅŸtirme',0),(114089,3170,'pl','Jednostka nazwa aktualizacji',0),(114090,3170,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð¼Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(114091,3170,'ur','ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ù†Ø§Ù… ØªØ¬Ø¯ÛŒØ¯',0),(114092,3170,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¸Ð¼Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(114093,3170,'vi','Cáº­p nháº­t tÃªn Ä‘Æ¡n vá»‹',0),(114094,3170,'af','Eenheidsnaam Opdateer',0),(114095,3170,'ro','Update de nume de unitatea de',0),(114096,3170,'et','Ãœhiku nimi Update',0),(114097,3170,'si','Enota ime posodobitev',0),(114098,3170,'ba','Unit nama Update',0),(114099,3170,'nl','Eenheid naam Update',0),(114100,3170,'fi','YksikÃ¶n nimi pÃ¤ivitys',0),(114101,3170,'no','Enheten navnet oppdatering',0),(114102,3170,'da','Enhed navn opdatering',0),(114103,3170,'ko','ìž¥ì¹˜ ì´ë¦„ ì—…ë°ì´íŠ¸',0),(114104,3170,'he','×¢×“×›×•×Ÿ ×©× ×™×—×™×“×”',0),(114105,3170,'el','ÎœÎ¿Î½Î¬Î´Î± ÏŒÎ½Î¿Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(114106,3170,'zh','å•ä½åç§°æ›´æ–°\r\n',0),(114107,3170,'sv','Enhet namn uppdatering',0),(114108,3170,'it','Aggiornamento nome unitÃ ',0),(114109,3170,'tl','',0),(114110,3170,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(114111,3170,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¾à¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(114112,3170,'ms','Kemaskini nama unit',0),(114113,3170,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ø³Ù… ÙˆØ­Ø¯Ø©',0),(114114,3170,'fr','Mise Ã  jour du nom d\'unitÃ©',0),(114115,3170,'jp','å?˜ä½?å??ã?®æ›´æ–°',0),(114116,3170,'pt','AtualizaÃ§Ã£o do nome de unidade',0),(114117,3170,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¸Ð¼ÐµÐ½Ð¸ Ð±Ð»Ð¾ÐºÐ°',0),(114118,3170,'es','Nombre de Unidad Actualizar',0),(114119,3170,'de','Update Unit/Name',0),(114120,3170,'en','Unit Name Update',0),(114121,3171,'is','',0),(114122,3171,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(114123,3171,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(114124,3171,'tr','Birim adÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(114125,3171,'pl','Nazwa jednostki pomyÅ›lnie zaktualizowana',0),(114126,3171,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(114127,3171,'ur','ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù… Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(114128,3171,'sr','Ð˜Ð¼Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(114129,3171,'vi','Cáº­p nháº­t tÃªn Ä‘Æ¡n vá»‹ thÃ nh cÃ´ng',0),(114130,3171,'af','Eenheidsnaam susesvol Opdateer',0),(114131,3171,'ro','Nume de unitatea actualizat cu succes',0),(114132,3171,'et','Ãœksuse nime vÃ¤rskendamine Ãµnnestus',0),(114133,3171,'si','Ime enote uspeÅ¡no posodobljena',0),(114134,3171,'ba','Nama unit yang berhasil',0),(114135,3171,'nl','Naam van de eenheid bijgewerkt',0),(114136,3171,'fi','YksikÃ¶n nimi pÃ¤ivitetty',0),(114137,3171,'no','Navn oppdatert',0),(114138,3171,'da','Enhed navn opdateret',0),(114139,3171,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ë‹¨ìœ„ ì´ë¦„',0),(114140,3171,'he','×‘×©× ×™×—×™×“×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(114141,3171,'el','ÎŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î±Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(114142,3171,'zh','å•ä½åç§°æ›´æ–°æˆåŠŸ\r\n',0),(114143,3171,'sv','Enhetens namn uppdaterats',0),(114144,3171,'it','Nome dell\'unitÃ  aggiornato con successo',0),(114145,3171,'tl','',0),(114146,3171,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(114147,3171,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¾à¤® à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(114148,3171,'ms','Nama unit berjaya dikemas kini',0),(114149,3171,'ar','Ø­Ø¯Ù‘Ø« Ø¥Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(114150,3171,'fr','Nom de l\'unitÃ© correctement mis Ã  jour',0),(114151,3171,'jp','å?˜ä½?å??ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(114152,3171,'pt','Nome da unidade atualizado com sucesso',0),(114153,3171,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(114154,3171,'es','Nombre de Unidad actualizado exitosamente',0),(114155,3171,'de','Der Name der Organisationseinheit erfolgreich aktualisiert',0),(114156,3171,'en','Unit Name updated successfully',0),(114157,3172,'is','',0),(114158,3172,'dr','Ù‚ÙŠÙ…Øª ÙˆØ§Ø­Ø¯ ',0),(114159,3172,'pr','Ù‚ÙŠÙ…Øª ÙˆØ§Ø­Ø¯ ',0),(114160,3172,'tr','Birim fiyatÄ±',0),(114161,3172,'pl','Cena jednostkowa',0),(114162,3172,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð°',0),(114163,3172,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(114164,3172,'sr','Ð¦ÐµÐ½Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(114165,3172,'vi','ÄÆ¡n vá»‹ giÃ¡',0),(114166,3172,'af','Eenheidsprys',0),(114167,3172,'ro','PreÅ£ unitar',0),(114168,3172,'et','Ãœhiku hind',0),(114169,3172,'si','Cena na enoto',0),(114170,3172,'ba','Harga satuan',0),(114171,3172,'nl','Prijs per eenheid',0),(114172,3172,'fi','YksikkÃ¶hinta',0),(114173,3172,'no','Salgspris',0),(114174,3172,'da','Salgspris',0),(114175,3172,'ko','ë‹¨ìœ„ ê°€ê²©',0),(114176,3172,'he','×ž×—×™×¨ ×™×—×™×“×”',0),(114177,3172,'el','Î¤Î¹Î¼Î® Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(114178,3172,'zh','å•ä»·\r\n',0),(114179,3172,'sv','Pris per enhet',0),(114180,3172,'it','Prezzo unitario',0),(114181,3172,'tl','',0),(114182,3172,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3629;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(114183,3172,'hi','à¤‡à¤•à¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯',0),(114184,3172,'ms','Harga seunit',0),(114185,3172,'ar','Ø³Ø¹Ø± Ø§Ù„ÙˆØ­Ø¯Ø©',0),(114186,3172,'fr','Prix unitaire',0),(114187,3172,'jp','å?˜ä¾¡',0),(114188,3172,'pt','PreÃ§o unitÃ¡rio',0),(114189,3172,'ru','Ð¦ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(114190,3172,'es','Precio de Unidad',0),(114191,3172,'de','VK-Preis',0),(114192,3172,'en','Unit Price',0),(114193,3173,'is','',0),(114194,3173,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙˆØ§Ø­Ø¯',0),(114195,3173,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙˆØ§Ø­Ø¯',0),(114196,3173,'tr','Birim boyutu',0),(114197,3173,'pl','Rozmiar jednostki',0),(114198,3173,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(114199,3173,'ur','ÛŒÙˆÙ†Ù¹ Ø³Ø§Ø¦Ø²',0),(114200,3173,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(114201,3173,'vi','Cá»¡ Ä‘Æ¡n vá»‹',0),(114202,3173,'af','Eenheidsgrootte',0),(114203,3173,'ro','Dimensiunea unitÄƒÈ›ii de',0),(114204,3173,'et','Ãœhiku maht',0),(114205,3173,'si','Velikost enote',0),(114206,3173,'ba','Ukuran unit',0),(114207,3173,'nl','Grootte van de eenheid',0),(114208,3173,'fi','Kokoa',0),(114209,3173,'no','StÃ¸rrelse',0),(114210,3173,'da','Enhed stÃ¸rrelse',0),(114211,3173,'ko','ë‹¨ìœ„ í¬ê¸°',0),(114212,3173,'he','×’×•×“×œ ×™×—×™×“×”',0),(114213,3173,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(114214,3173,'zh','å•ä½å°ºå¯¸\r\n',0),(114215,3173,'sv','Storlek',0),(114216,3173,'it','Dimensioni dell\'unitÃ ',0),(114217,3173,'tl','',0),(114218,3173,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3629;&#3591;&#3586;&#3609;&#3634;&#3604;',0),(114219,3173,'hi','à¤‡à¤•à¤¾à¤ˆ à¤†à¤•à¤¾à¤°',0),(114220,3173,'ms','Saiz unit',0),(114221,3173,'ar','Ø­Ø¬Ù… Ø§Ù„ÙˆØ­Ø¯Ø©',0),(114222,3173,'fr','Dimensions de l\'appareil',0),(114223,3173,'jp','å?˜ä½?ã‚µã‚¤ã‚º',0),(114224,3173,'pt','Tamanho da unidade',0),(114225,3173,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(114226,3173,'es','TamaÃ±o de Unidad',0),(114227,3173,'de','EinheitsgrÃ¶ÃŸe',0),(114228,3173,'en','Unit Size',0),(114229,3174,'is','',0),(114230,3174,'dr','ÙØ¹Ø§Ù„ÙŠØª Ù†Ø§ Ù…Ø¹Ù„ÙˆÙ…',0),(114231,3174,'pr','ÙØ¹Ø§Ù„ÙŠØª Ù†Ø§ Ù…Ø¹Ù„ÙˆÙ…',0),(114232,3174,'tr','Bilinmeyen eylem',0),(114233,3174,'pl','Nieznane dziaÅ‚ania',0),(114234,3174,'bg','ÐÐµÐ¸Ð·Ð²ÐµÑÑ‚ÐµÐ½ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(114235,3174,'ur','Ù†Ø§Ù…Ø¹Ù„ÙˆÙ… Ø¹Ù…Ù„',0),(114236,3174,'sr','ÐÐµÐ¿Ð¾Ð·Ð½Ð°Ñ‚Ð° Ð°ÐºÑ†Ð¸Ñ˜Ð°',0),(114237,3174,'vi','HÃ nh Ä‘á»™ng KhÃ´ng biáº¿t',0),(114238,3174,'af','Onbekende Aksie',0),(114239,3174,'ro','AcÅ£iune necunoscutÄƒ',0),(114240,3174,'et','Tundmatu toiming',0),(114241,3174,'si','Neznano dejanje',0),(114242,3174,'ba','Aksi yang tidak diketahui',0),(114243,3174,'nl','Onbekende actie',0),(114244,3174,'fi','Tuntematon toiminto',0),(114245,3174,'no','Ukjent handling',0),(114246,3174,'da','Ukendt handling',0),(114247,3174,'ko','ì•Œ ìˆ˜ ì—†ëŠ” ìž‘ì—…',0),(114248,3174,'he','×¤×¢×•×œ×” ×œ× ×™×“×•×¢',0),(114249,3174,'el','Î†Î³Î½Ï‰ÏƒÏ„Î· Î´ÏÎ¬ÏƒÎ·Ï‚',0),(114250,3174,'zh','æœªçŸ¥åŠ¨ä½œ\r\n',0),(114251,3174,'sv','OkÃ¤nd Ã¥tgÃ¤rd',0),(114252,3174,'it','Azione sconosciuta',0),(114253,3174,'tl','',0),(114254,3174,'th','&#3652;&#3617;&#3656;&#3619;&#3641;&#3657;&#3592;&#3633;&#3585;&#3585;&#3634;&#3619;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(114255,3174,'hi','à¤…à¤œà¥à¤žà¤¾à¤¤ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(114256,3174,'ms','Tindakan yang tidak diketahui',0),(114257,3174,'ar','Ø¹Ù…Ù„ ØºÙŠØ± Ù…Ø¹Ø±ÙˆÙ',0),(114258,3174,'fr','Action inconnue',0),(114259,3174,'jp','ä¸?æ˜Žã?ªã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(114260,3174,'pt','AÃ§Ã£o desconhecida',0),(114261,3174,'ru','ÐÐµÐ¸Ð·Ð²ÐµÑÑ‚Ð½Ð¾Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(114262,3174,'es','AcciÃ³n Desconocido',0),(114263,3174,'de','Unbekannte Aktion',0),(114264,3174,'en','Unknown action',0),(114265,3175,'is','',0),(114266,3175,'dr','(Ù†Ø§Ù…Ø¹ÙŠÙ†',0),(114267,3175,'pr','Ù†Ø§Ù…Ø­Ø¯ÙˆØ¯ (Ù†Ø§Ù…Ø¹ÙŠÙ†',0),(114268,3175,'tr','SÄ±nÄ±rsÄ±z',0),(114269,3175,'pl','Nieograniczony',0),(114270,3175,'bg','ÐÐµÐ¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½',0),(114271,3175,'ur','Ù„Ø§Ù…Ø­Ø¯ÙˆØ¯',0),(114272,3175,'sr','ÐÐµÐ¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½',0),(114273,3175,'vi','KhÃ´ng giá»›i háº¡n',0),(114274,3175,'af','Onbeperk',0),(114275,3175,'ro','Nelimitat',0),(114276,3175,'et','Piiramatu',0),(114277,3175,'si','Neomejeno',0),(114278,3175,'ba','Tak terbatas',0),(114279,3175,'nl','Onbeperkt',0),(114280,3175,'fi','Rajoittamaton',0),(114281,3175,'no','Ubegrenset',0),(114282,3175,'da','UbegrÃ¦nset',0),(114283,3175,'ko','ë¬´ì œí•œ',0),(114284,3175,'he','×œ×œ× ×”×’×‘×œ×”',0),(114285,3175,'el','Î‘Ï€ÎµÏÎ¹ÏŒÏÎ¹ÏƒÏ„Î·',0),(114286,3175,'zh','æ— é™\r\n',0),(114287,3175,'sv','ObegrÃ¤nsad',0),(114288,3175,'it','Illimitato',0),(114289,3175,'tl','',0),(114290,3175,'th','&#3652;&#3617;&#3656;&#3592;&#3635;&#3585;&#3633;&#3604;',0),(114291,3175,'hi','à¤…à¤¸à¥€à¤®à¤¿à¤¤',0),(114292,3175,'ms','Tanpa had',0),(114293,3175,'ar','ØºÙŠØ± Ù…Ø­Ø¯ÙˆØ¯',0),(114294,3175,'fr','IllimitÃ©',0),(114295,3175,'jp','ç„¡åˆ¶é™?ã?®',0),(114296,3175,'pt','Ilimitado',0),(114297,3175,'ru','ÐÐµÐ¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(114298,3175,'es','Sin Limite',0),(114299,3175,'de','Unbegrenzte',0),(114300,3175,'en','Unlimited',0),(114301,3176,'is','',0),(114302,3176,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ ',0),(114303,3176,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ ',0),(114304,3176,'tr','Ã–denmemiÅŸ',0),(114305,3176,'pl','NiezapÅ‚acone',0),(114306,3176,'bg','ÐÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(114307,3176,'ur','Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û',0),(114308,3176,'sr','ÐÐµÐ¿Ð»Ð°Ñ›ÐµÐ½Ð¸Ñ…',0),(114309,3176,'vi','ChÆ°a tráº£',0),(114310,3176,'af','Onbetaald',0),(114311,3176,'ro','NeplÄƒtite',0),(114312,3176,'et','Tasumata',0),(114313,3176,'si','NeplaÄana',0),(114314,3176,'ba','Belum dibayar',0),(114315,3176,'nl','Onbetaalde',0),(114316,3176,'fi','Maksamattomat',0),(114317,3176,'no','Ubetalte',0),(114318,3176,'da','UlÃ¸nnet',0),(114319,3176,'ko','ë¬´ ê¸‰',0),(114320,3176,'he','×©×œ× ×©×•×œ×ž×•',0),(114321,3176,'el','Î ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎºÎ±Ï„Î±Î²Î¿Î»Î®',0),(114322,3176,'zh','æœªä»˜\r\n',0),(114323,3176,'sv','Obetalda',0),(114324,3176,'it','Non pagati',0),(114325,3176,'tl','',0),(114326,3176,'th','&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(114327,3176,'hi','à¤…à¤µà¥ˆà¤¤à¤¨à¤¿à¤•',0),(114328,3176,'ms','Tidak dibayar',0),(114329,3176,'ar','ØºÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(114330,3176,'fr','Non rÃ©munÃ©rÃ©',0),(114331,3176,'jp','æœªæ‰•ã?„',0),(114332,3176,'pt','NÃ£o remunerado',0),(114333,3176,'ru','ÐÐµÐ¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ð¹',0),(114334,3176,'es','No Pagado',0),(114335,3176,'de','Unbezahlte',0),(114336,3176,'en','Unpaid',0),(114337,3177,'is','',0),(114338,3177,'dr','Ù¾Ø³Øª Ù†ÙƒØ±Ø¯Ù†',0),(114339,3177,'pr','Ù¾Ø³Øª Ù†ÙƒØ±Ø¯Ù†',0),(114340,3177,'tr','Unpost',0),(114341,3177,'pl','Unpost',0),(114342,3177,'bg','Unpost',0),(114343,3177,'ur','Ø§Ù†Ù¾ÙˆØ³Ù¹',0),(114344,3177,'sr','ÐŸÐ¾Ð²ÑƒÐ¸Ðµ',0),(114345,3177,'vi','KhÃ´ng káº¿t chuyá»ƒn',0),(114346,3177,'af','Onpos',0),(114347,3177,'ro','Unpost',0),(114348,3177,'et','Unpost',0),(114349,3177,'si','Unpost',0),(114350,3177,'ba','Unpost',0),(114351,3177,'nl','Unpost',0),(114352,3177,'fi','Unpost',0),(114353,3177,'no','Unpost',0),(114354,3177,'da','Unpost',0),(114355,3177,'ko','Unpost',0),(114356,3177,'he','Unpost',0),(114357,3177,'el','Unpost',0),(114358,3177,'zh','æœªå‘å¸ƒ\r\n',0),(114359,3177,'sv','Unpost',0),(114360,3177,'it','Unpost',0),(114361,3177,'tl','',0),(114362,3177,'th','&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(114363,3177,'hi','Unpost',0),(114364,3177,'ms','Unpost',0),(114365,3177,'ar','Ø£ÙˆÙ†Ø¨ÙˆØ³Øª',0),(114366,3177,'fr','Unpost',0),(114367,3177,'jp','æœªè¨ˆä¸Š',0),(114368,3177,'pt','Unpost',0),(114369,3177,'ru','Unpost',0),(114370,3177,'es','No Asentar',0),(114371,3177,'de','Unpost',0),(114372,3177,'en','Unpost',0),(114373,3178,'is','',0),(114374,3178,'dr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ ',0),(114375,3178,'pr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ ',0),(114376,3178,'tr','Fatura unpost',0),(114377,3178,'pl','Unpost faktury',0),(114378,3178,'bg','Unpost Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(114379,3178,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ù†Ù¾ÙˆØ³Ù¹',0),(114380,3178,'sr','ÐŸÐ¾Ð²ÑƒÐ¸Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(114381,3178,'vi','HÃ³a Ä‘Æ¡n KhÃ´ng káº¿t chuyá»ƒn',0),(114382,3178,'af','Onposde Faktuur',0),(114383,3178,'ro','Unpost facturÄƒ',0),(114384,3178,'et','Unpost arve',0),(114385,3178,'si','Unpost raÄun',0),(114386,3178,'ba','Unpost faktur',0),(114387,3178,'nl','Unpost factuur',0),(114388,3178,'fi','Unpost lasku',0),(114389,3178,'no','Unpost faktura',0),(114390,3178,'da','Unpost faktura',0),(114391,3178,'ko','Unpost ì†¡ìž¥',0),(114392,3178,'he','Unpost ×—×©×‘×•× ×™×ª',0),(114393,3178,'el','Unpost Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(114394,3178,'zh','ä¸å‘å¸ƒå‘ç¥¨\r\n',0),(114395,3178,'sv','Unpost faktura',0),(114396,3178,'it','Unpost fattura',0),(114397,3178,'tl','',0),(114398,3178,'th','&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(114399,3178,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ unpost',0),(114400,3178,'ms','Unpost invois',0),(114401,3178,'ar','Ø£ÙˆÙ†Ø¨ÙˆØ³Øª Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(114402,3178,'fr','Unpost facture',0),(114403,3178,'jp','æœªè¨ˆä¸Šè«‹æ±‚æ›¸',0),(114404,3178,'pt','Unpost fatura',0),(114405,3178,'ru','Unpost ÑÑ‡ÐµÑ‚Ð°',0),(114406,3178,'es','No Asentar Factura',0),(114407,3178,'de','Unpost Rechnung',0),(114408,3178,'en','Unpost Invoice',0),(114409,3179,'is','',0),(114410,3179,'dr','Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ ',0),(114411,3179,'pr','Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ ',0),(114412,3179,'tr','Deftere nakledilmemiÅŸ',0),(114413,3179,'pl','NiezaksiÄ™gowana',0),(114414,3179,'bg','ÐÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸',0),(114415,3179,'ur','Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯',0),(114416,3179,'sr','ÐÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸',0),(114417,3179,'vi','ÄÃ£ KhÃ´ng káº¿t chuyá»ƒn',0),(114418,3179,'af','Ongepos',0),(114419,3179,'ro','NeÃ®nregistrate',0),(114420,3179,'et','Sisestamata',0),(114421,3179,'si','Neobjavljene',0),(114422,3179,'ba','Unposted',0),(114423,3179,'nl','Niet-doorgevoerde',0),(114424,3179,'fi','Kirjaamattomat',0),(114425,3179,'no','Ikke',0),(114426,3179,'da','Ikke bogfÃ¸rte',0),(114427,3179,'ko','ê²Œì‹œ',0),(114428,3179,'he','×©×œ× × ×¨×©×ž×•',0),(114429,3179,'el','ÎœÎ· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚',0),(114430,3179,'zh','æœªå‘å¸ƒ\r\n',0),(114431,3179,'sv','Ej bokfÃ¶rd',0),(114432,3179,'it','Non registrata',0),(114433,3179,'tl','',0),(114434,3179,'th','&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(114435,3179,'hi','Unposted',0),(114436,3179,'ms','Unposted',0),(114437,3179,'ar','ØºÙŠØ± Ù…Ø±Ø­Ù‘Ù„Ø©',0),(114438,3179,'fr','Non comptabilisÃ©s',0),(114439,3179,'jp','æœªè¨ˆä¸Šã?®',0),(114440,3179,'pt','NÃ£o lanÃ§adas',0),(114441,3179,'ru','ÐÐµÐ¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ',0),(114442,3179,'es','No Asentado',0),(114443,3179,'de','Ungebuchte',0),(114444,3179,'en','Unposted',0),(114445,3180,'is','',0),(114446,3180,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(114447,3180,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(114448,3180,'tr','baÅŸarÄ±lÄ± bir ÅŸekilde yÃ¼klenmemiÅŸ',0),(114449,3180,'pl','niezaksiÄ™gowane pomyÅ›lnie',0),(114450,3180,'bg','Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(114451,3180,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯',0),(114452,3180,'sr','ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð½ÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ',0),(114453,3180,'vi','KhÃ´ng káº¿t chuyá»ƒn thÃ nh cÃ´ng',0),(114454,3180,'af','suksesvol Onpos',0),(114455,3180,'ro','cu succes de neÃ®nregistrate',0),(114456,3180,'et','Postituse eemaldamine Ãµnnestus',0),(114457,3180,'si','neobjavljene uspeÅ¡no',0),(114458,3180,'ba','unposted berhasil',0),(114459,3180,'nl','niet-geboekte met succes',0),(114460,3180,'fi','Kirjaamattomat onnistuneesti',0),(114461,3180,'no','vellykket',0),(114462,3180,'da','ikke-bogfÃ¸rte med succes',0),(114463,3180,'ko','ì„±ê³µì ìœ¼ë¡œ ê²Œì‹œ',0),(114464,3180,'he','×©×œ× × ×¨×©×ž×• ×‘×”×¦×œ×—×”',0),(114465,3180,'el','Î¼Î· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(114466,3180,'zh','ä¸å‘å¸ƒæˆåŠŸ\r\n',0),(114467,3180,'sv','ej bokfÃ¶rda framgÃ¥ngsrikt',0),(114468,3180,'it','non registrate con successo',0),(114469,3180,'tl','',0),(114470,3180,'th','&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(114471,3180,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• unposted',0),(114472,3180,'ms','unposted berjaya',0),(114473,3180,'ar','Ù„Ù… ÙŠØªÙ… ØªØ±Ø­ÙŠÙ„Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(114474,3180,'fr','non validÃ© avec succÃ¨s',0),(114475,3180,'jp','æœªè¨ˆä¸Šã?«ã?—ã?¾ã?—ã?Ÿ',0),(114476,3180,'pt','nÃ£o lanÃ§adas com sucesso',0),(114477,3180,'ru','Ð½ÐµÐ¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(114478,3180,'es','No Asentado exitosamente',0),(114479,3180,'de','ungebuchte erfolgreich',0),(114480,3180,'en','unposted successfully',0),(114481,3181,'is','',0),(114482,3181,'dr','Ø¯Ø±ÙŠØ§ÙØª Ù†Ø´Ø¯Ù‡ ÙƒØ§Ù…Ù„ Ø§Ø³Øª ',0),(114483,3181,'pr','Ø¯Ø±ÙŠØ§ÙØª Ù†Ø´Ø¯Ù‡ ÙƒØ§Ù…Ù„ Ø§Ø³Øª ',0),(114484,3181,'tr','Tam unreceive.',0),(114485,3181,'pl','Unreceive kompletne.',0),(114486,3181,'bg','Unreceive Ð¿ÑŠÐ»Ð½Ð°.',0),(114487,3181,'ur','Ù…Ú©Ù…Ù„ Ø§Ù†Ø±ÛŒØ³ÛŒÙˆÛŒ Û”',0),(114488,3181,'sr','Ð£Ð½Ñ€ÐµÑ†ÐµÐ¸Ð²Ðµ ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½.',0),(114489,3181,'vi','HoÃ n táº¥t chÆ°a nháº­n',0),(114490,3181,'af','Unreceive voltooi.',0),(114491,3181,'ro','Unreceive complet.',0),(114492,3181,'et','Unreceive tÃ¤ielik.',0),(114493,3181,'si','Unreceive popolna.',0),(114494,3181,'ba','Unreceive lengkap.',0),(114495,3181,'nl','Unreceive voltooid.',0),(114496,3181,'fi','Unreceive tÃ¤ydellinen.',0),(114497,3181,'no','Unreceive fullfÃ¸rt.',0),(114498,3181,'da','Unreceive komplet.',0),(114499,3181,'ko','ì™„ì „ í•œ unreceive.',0),(114500,3181,'he','Unreceive ×ž×œ××”.',0),(114501,3181,'el','Unreceive Ï€Î»Î®ÏÎ·.',0),(114502,3181,'zh','æœªæ”¶åˆ°å®Œæ•´çš„ã€‚\r\n',0),(114503,3181,'sv','Unreceive komplett.',0),(114504,3181,'it','Impervie completa.',0),(114505,3181,'tl','',0),(114506,3181,'th','&#3652;&#3617;&#3656;&#3619;&#3633;&#3610;&#3588;&#3623;&#3634;&#3617;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(114507,3181,'hi','à¤ªà¥‚à¤°à¥à¤£ unreceive.',0),(114508,3181,'ms','Unreceive lengkap.',0),(114509,3181,'ar','Ø£ÙˆÙ†Ø±ÙŠØ³ÙŠÙÙŠ ÙƒØ§Ù…Ù„Ø©.',0),(114510,3181,'fr','Unreceive complet.',0),(114511,3181,'jp','æœªå?—é ˜å®Œäº†',0),(114512,3181,'pt','Unreceive completa.',0),(114513,3181,'ru','Unreceive Ð¿Ð¾Ð»Ð½Ñ‹Ð¹.',0),(114514,3181,'es','No Recibir completo',0),(114515,3181,'de','Unreceive abgeschlossen.',0),(114516,3181,'en','Unreceive complete.',0),(114517,3182,'is','',0),(114518,3182,'dr','Ø§ÙŠÙ† ÙƒØ§Ù„Ø§Ø±Ø§ Ø¯Ø±ÙŠØ§ÙØª Ù†ÙƒÙ†ÙŠØ¯ ',0),(114519,3182,'pr','Ø§ÙŠÙ† ÙƒØ§Ù„Ø§Ø±Ø§ Ø¯Ø±ÙŠØ§ÙØª Ù†ÙƒÙ†ÙŠØ¯ ',0),(114520,3182,'tr','Bu madde unreceive',0),(114521,3182,'pl','Unreceive ten przedmiot',0),(114522,3182,'bg','Unreceive Ñ‚Ð¾Ð·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(114523,3182,'ur','Ø§Ø³ Ø´Û’ Ú©Ùˆ Ø§Ù†Ø±ÛŒØ³ÛŒÙˆÛŒ',0),(114524,3182,'sr','Ð£Ð½Ñ€ÐµÑ†ÐµÐ¸Ð²Ðµ Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(114525,3182,'vi','KhÃ´ng nháº­n Ä‘Æ°á»£c hÃ ng nÃ y',0),(114526,3182,'af','Ontvang nie hierdie Item',0),(114527,3182,'ro','Unreceive acest element',0),(114528,3182,'et','Unreceive seda Ã¼ksust',0),(114529,3182,'si','Unreceive element',0),(114530,3182,'ba','Unreceive Item ini',0),(114531,3182,'nl','Unreceive van dit Item',0),(114532,3182,'fi','Unreceive tÃ¤mÃ¤ kohde',0),(114533,3182,'no','Unreceive dette elementet',0),(114534,3182,'da','Unreceive dette element',0),(114535,3182,'ko','ì´ í•­ëª©ì„ unreceive',0),(114536,3182,'he','Unreceive ×¤×¨×™×˜ ×–×”',0),(114537,3182,'el','Unreceive Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(114538,3182,'zh','æœªæ”¶åˆ°æ­¤é¡¹ç›®\r\n',0),(114539,3182,'sv','Unreceive denna punkt',0),(114540,3182,'it','Impervie questo elemento',0),(114541,3182,'tl','',0),(114542,3182,'th','&#3652;&#3617;&#3656;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;',0),(114543,3182,'hi','à¤‡à¤¸ à¤®à¤¦ unreceive',0),(114544,3182,'ms','Unreceive perkara ini',0),(114545,3182,'ar','Ø£ÙˆÙ†Ø±ÙŠØ³ÙŠÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ø¨Ù†Ø¯',0),(114546,3182,'fr','Unreceive ques',0),(114547,3182,'jp','ã?“ã?®å“?ç›®ã?¯æœªå?—é ˜ã?§ã?™',0),(114548,3182,'pt','Unreceive este Item',0),(114549,3182,'ru','Unreceive ÑÑ‚Ð¾Ñ‚ Ð¿ÑƒÐ½ÐºÑ‚',0),(114550,3182,'es','No Recibir este item',0),(114551,3182,'de','Unreceive Unterpunkt',0),(114552,3182,'en','Unreceive this Item',0),(114553,3183,'is','',0),(114554,3183,'dr','(ØªØ§ Ø­Ø¯ÙˆØ¯',0),(114555,3183,'pr','Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù† (ØªØ§ Ø­Ø¯ÙˆØ¯',0),(114556,3183,'tr','e kadar',0),(114557,3183,'pl','do',0),(114558,3183,'bg','Ð´Ð¾',0),(114559,3183,'ur','Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(114560,3183,'sr','Ð´Ð¾',0),(114561,3183,'vi','lÃªn tá»›i',0),(114562,3183,'af','tot',0),(114563,3183,'ro','pÃ¢nÄƒ la',0),(114564,3183,'et','kuni',0),(114565,3183,'si','do',0),(114566,3183,'ba','hingga',0),(114567,3183,'nl','tot',0),(114568,3183,'fi','jopa',0),(114569,3183,'no','opptil',0),(114570,3183,'da','op til',0),(114571,3183,'ko','ìµœëŒ€',0),(114572,3183,'he','×¢×“',0),(114573,3183,'el','Î­Ï‰Ï‚',0),(114574,3183,'zh','åˆ°\r\n',0),(114575,3183,'sv','upp till',0),(114576,3183,'it','fino a',0),(114577,3183,'tl','',0),(114578,3183,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;',0),(114579,3183,'hi','à¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(114580,3183,'ms','sehingga',0),(114581,3183,'ar','ØªØµÙ„ Ø¥Ù„Ù‰',0),(114582,3183,'fr','jusqu\'Ã ',0),(114583,3183,'jp','æœ€å¤§è¶…é?Žçµ¦ä¸Žç·?é¡?',0),(114584,3183,'pt','atÃ©',0),(114585,3183,'ru','Ð´Ð¾',0),(114586,3183,'es','hasta ',0),(114587,3183,'de','bis zu',0),(114588,3183,'en','up to',0),(114589,3184,'is','',0),(114590,3184,'dr','Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù† Ù…Ù‚Ø¯Ø§Ø±',0),(114591,3184,'pr','Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù† Ù…Ù‚Ø¯Ø§Ø±',0),(114592,3184,'tr','miktar kadar',0),(114593,3184,'pl','do iloÅ›Ä‡',0),(114594,3184,'bg','Ð´Ð¾ ÐºÐ¾Ð»',0),(114595,3184,'ur','Ù‚ÛŒ ØªÚ©',0),(114596,3184,'sr','Ð´Ð¾ ÐšÐ¾Ð».',0),(114597,3184,'vi','lÃªn tá»›i sá»‘ lÆ°á»£ng',0),(114598,3184,'af','tot qty',0),(114599,3184,'ro','pÃ¢nÄƒ la cantitate',0),(114600,3184,'et','kuni kogus',0),(114601,3184,'si','do kol.',0),(114602,3184,'ba','hingga qty',0),(114603,3184,'nl','maximaal aantal',0),(114604,3184,'fi','jopa mÃ¤Ã¤rÃ¤',0),(114605,3184,'no','opp antall',0),(114606,3184,'da','op til antal',0),(114607,3184,'ko','ìˆ˜ëŸ‰ê¹Œì§€',0),(114608,3184,'he','×¢×“ ×›×ž×•×ª ×©×œ',0),(114609,3184,'el','Î¼Î­Ï‡ÏÎ¹ qty',0),(114610,3184,'zh','å¤šè¾¾æ•°é‡\r\n',0),(114611,3184,'sv','upp till Kvt',0),(114612,3184,'it','fino a q. tÃ ',0),(114613,3184,'tl','',0),(114614,3184,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;',0),(114615,3184,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¤à¤•',0),(114616,3184,'ms','sehingga qty',0),(114617,3184,'ar','Ù…Ø§ ÙŠØµÙ„ Ø¥Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(114618,3184,'fr','jusqu\'Ã  QtÃ©',0),(114619,3184,'jp','æœ€å¤§æ•°é‡?',0),(114620,3184,'pt','atÃ© qty',0),(114621,3184,'ru','Ð´Ð¾ ÑˆÑ‚.',0),(114622,3184,'es','Hasta cant.',0),(114623,3184,'de','bis zu der Menge:',0),(114624,3184,'en','up to qty',0),(114625,3185,'is','',0),(114626,3185,'dr','Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù† Ø§ÙŠÙ†  Ù…Ù‚Ø¯Ø§Ø± ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯ ',0),(114627,3185,'pr','Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù† Ø§ÙŠÙ†  Ù…Ù‚Ø¯Ø§Ø± ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯ ',0),(114628,3185,'tr','Bu satÄ±nalma birimlerinin miktarÄ± kadar',0),(114629,3185,'pl','Do tej iloÅ›ci zakupu jednostek',0),(114630,3185,'bg','Ð¢Ð¾Ð²Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(114631,3185,'ur','Ø§Ø³ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ ÛŒÙˆÙ†Ù¹Ø³ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± ØªÚ©',0),(114632,3185,'sr','ÐÐ° Ð¾Ð²Ñƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(114633,3185,'vi','lÃªn tá»›i sá»‘ lÆ°á»£ng nÃ y cá»§a Ä‘Æ¡n vá»‹ mua',0),(114634,3185,'af','Tot hierdie hoeveelheid aangekoopte eenhede',0),(114635,3185,'ro','PÃ¢nÄƒ la aceastÄƒ cantitate de unitÄƒÅ£i de cumpÄƒrare',0),(114636,3185,'et','Kuni selle ostutellimuse Ã¼hikute kogus',0),(114637,3185,'si','Do te koliÄine nakupa enot',0),(114638,3185,'ba','Sampai dengan jumlah pembelian unit',0),(114639,3185,'nl','Tot deze hoeveelheid aankoop Units',0),(114640,3185,'fi','Jopa tÃ¤mÃ¤ mÃ¤Ã¤rÃ¤ ostoyksikkÃ¶inÃ¤ ilmaistu',0),(114641,3185,'no','Opptil dette antall innkjÃ¸psenheter',0),(114642,3185,'da','Op til dette antal i kÃ¸bsenheder',0),(114643,3185,'ko','êµ¬ë§¤ ë‹¨ìœ„ì´ ì–‘ê¹Œì§€',0),(114644,3185,'he','×¢×“ ×–×” ×›×ž×•×ª ×™×—×™×“×•×ª ×¨×›×©',0),(114645,3185,'el','ÎœÎ­Ï‡ÏÎ¹ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Ï…Ï„Î® Î±Î³Î¿ÏÎ¬ Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(114646,3185,'zh','å¤šè¾¾æ­¤è´­ä¹°å•ä½æ•°é‡\r\n',0),(114647,3185,'sv','Denna kvantitet inkÃ¶psenheter',0),(114648,3185,'it','Fino a questa quantitÃ  di unitÃ  di acquisto',0),(114649,3185,'tl','',0),(114650,3185,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;',0),(114651,3185,'hi','à¤‡à¤¸ à¤–à¤°à¥€à¤¦ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤•à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(114652,3185,'ms','Sehingga ini jumlah unit-unit',0),(114653,3185,'ar','Ø­ØªÙ‘Ù‰ Ù‡Ø°Ù‡ Ø§Ù„ÙƒÙ…ÙŠÙ‘Ø© Ù…Ù† ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ø´Ø±Ø§Ø¡',0),(114654,3185,'fr','Jusqu\'Ã  cette quantitÃ© d\'unitÃ©s d\'achat',0),(114655,3185,'jp','è³¼å…¥å?˜ä¾¡ã?¯ã?“ã?®æ•°é‡?ã?¾ã?§',0),(114656,3185,'pt','AtÃ© essa quantidade de unidades de compra',0),(114657,3185,'ru','Ð”Ð¾ ÑÑ‚Ð¾Ð³Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐµÐ´Ð¸Ð½Ð¸Ñ† Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(114658,3185,'es','Hasta Esta Cantidad de Unidades de Compra',0),(114659,3185,'de','Bis zu dieser Menge Bestelleinheiten',0),(114660,3185,'en','Up To This Quantity of Purchase&nbsp;Units',0),(114661,3186,'is','',0),(114662,3186,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ',0),(114663,3186,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ',0),(114664,3186,'tr','GÃ¼ncelleÅŸtirme',0),(114665,3186,'pl','Aktualizacja',0),(114666,3186,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(114667,3186,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(114668,3186,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(114669,3186,'vi','Cáº­p nháº­t',0),(114670,3186,'af','Opdateer',0),(114671,3186,'ro','Actualizare',0),(114672,3186,'et','Uuendus',0),(114673,3186,'si','Posodobitev',0),(114674,3186,'ba','Update',0),(114675,3186,'nl','Update',0),(114676,3186,'fi','PÃ¤ivitys',0),(114677,3186,'no','Oppdatering',0),(114678,3186,'da','Opdatering',0),(114679,3186,'ko','ì—…ë°ì´íŠ¸',0),(114680,3186,'he','×¢×“×›×Ÿ',0),(114681,3186,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(114682,3186,'zh','æ›´æ–°\r\n',0),(114683,3186,'sv','Uppdatering',0),(114684,3186,'it','Aggiornamento',0),(114685,3186,'tl','',0),(114686,3186,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(114687,3186,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(114688,3186,'ms','Kemaskini',0),(114689,3186,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(114690,3186,'fr','Mise Ã  jour',0),(114691,3186,'jp','æ›´æ–°',0),(114692,3186,'pt','AtualizaÃ§Ã£o',0),(114693,3186,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(114694,3186,'es','Actualizar',0),(114695,3186,'de','Update',0),(114696,3186,'en','Update',0),(114697,3187,'is','',0),(114698,3187,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø± Ù…ØªÙØ§ÙˆØª',0),(114699,3187,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø± Ù…ØªÙØ§ÙˆØª',0),(114700,3187,'tr','FarklÄ± bir mÃ¼ÅŸteri gÃ¼ncelleyin',0),(114701,3187,'pl','Aktualizacja klienta rÃ³Å¼ne',0),(114702,3187,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚, Ñ€Ð°Ð·Ð»Ð¸Ñ‡ÐµÐ½',0),(114703,3187,'ur','Ø§ÛŒÚ© Ù…Ø®ØªÙ„Ù Ú¯Ø§ÛÚ© Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(114704,3187,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÑƒÐ¿Ñ†Ð° Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð¸Ñ‚Ð¾Ð³',0),(114705,3187,'vi','Cáº­p Nháº­t 1 KhÃ¡ch hÃ ng khÃ¡c',0),(114706,3187,'af','Opdateer \'n ander Klant / KliÃ«nt',0),(114707,3187,'ro','Actualizare client diferite',0),(114708,3187,'et','Uuenda teist klienti',0),(114709,3187,'si','Posodobitev drugemu kupcu',0),(114710,3187,'ba','Memperbarui Pelanggan yang berbeda',0),(114711,3187,'nl','Een andere klant bijwerken',0),(114712,3187,'fi','PÃ¤ivitÃ¤ asiakkaalle',0),(114713,3187,'no','Oppdatere en annen kunde',0),(114714,3187,'da','Opdatere en anden kunde',0),(114715,3187,'ko','ë‹¤ë¥¸ ê³ ê° ì—…ë°ì´íŠ¸',0),(114716,3187,'he','×¢×“×›×•×Ÿ ×œ×§×•×— ××—×¨',0),(114717,3187,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î­Î½Î± Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(114718,3187,'zh','ä¸åŒçš„å®¢æˆ·æ›´æ–°\r\n',0),(114719,3187,'sv','Uppdatera en annan kund',0),(114720,3187,'it','Aggiornare un cliente diverso',0),(114721,3187,'tl','',0),(114722,3187,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3623;&#3634;&#3617;&#3649;&#3605;&#3585;&#3605;&#3656;&#3634;&#3591;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(114723,3187,'hi','à¤à¤• à¤…à¤²à¤— à¤—à¥à¤°à¤¾à¤¹à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(114724,3187,'ms','Kemaskini Terakhir pelanggan yang berbeza',0),(114725,3187,'ar','ØªØ­Ø¯ÙŠØ« Ø¹Ù…ÙŠÙ„ Ù…Ø®ØªÙ„ÙØ©',0),(114726,3187,'fr','Mise Ã  jour d\'un autre client',0),(114727,3187,'jp','ä»–ã?®é¡§å®¢ã‚’æ›´æ–°',0),(114728,3187,'pt','Atualizar um cliente diferente',0),(114729,3187,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¾Ð³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(114730,3187,'es','Actualizar un cliente diferente',0),(114731,3187,'de','Einen anderen Kunden zu aktualisieren',0),(114732,3187,'en','Update a different customer',0),(114733,3188,'is','',0),(114734,3188,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ù…Ø­Ù„',0),(114735,3188,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ù…Ø­Ù„',0),(114736,3188,'tr','GÃ¼ncelleÅŸtirme konumu',0),(114737,3188,'pl','Aktualizacja lokalizacji',0),(114738,3188,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(114739,3188,'ur','Ø§ÛŒÚ© Ø¬Ú¯Û Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(114740,3188,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(114741,3188,'vi','Cáº­p Nháº­t 1 Äá»‹a Äiá»ƒm',0),(114742,3188,'af','Opdateer \'n Ligging',0),(114743,3188,'ro','Update o locaÅ£ie',0),(114744,3188,'et','VÃ¤rskenduse asukoht',0),(114745,3188,'si','Update na lokaciji',0),(114746,3188,'ba','Memperbarui lokasi',0),(114747,3188,'nl','Een locatie bijwerken',0),(114748,3188,'fi','PÃ¤ivityksen sijainti',0),(114749,3188,'no','Oppdatere en',0),(114750,3188,'da','Opdatere en placering',0),(114751,3188,'ko','ì—…ë°ì´íŠ¸ ìœ„ì¹˜',0),(114752,3188,'he','×¢×“×›×Ÿ ×ž×™×§×•×',0),(114753,3188,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Î¼Î¹Î± Î¸Î­ÏƒÎ·',0),(114754,3188,'zh','ä½ç½®æ›´æ–°\r\n',0),(114755,3188,'sv','Uppdatera en plats',0),(114756,3188,'it','Un percorso di aggiornamento',0),(114757,3188,'tl','',0),(114758,3188,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(114759,3188,'hi','à¤à¤• à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(114760,3188,'ms','Kemaskini terakhir di lokasi',0),(114761,3188,'ar','ØªØ­Ø¯ÙŠØ« Ù…ÙˆÙ‚Ø¹',0),(114762,3188,'fr','Mettre Ã  jour un emplacement',0),(114763,3188,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã‚’æ›´æ–°',0),(114764,3188,'pt','Atualizar um local',0),(114765,3188,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(114766,3188,'es','Actualizar una UbicaciÃ³n',0),(114767,3188,'de','Update ein Urlaubsziel',0),(114768,3188,'en','Update a location',0),(114769,3189,'is','',0),(114770,3189,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø¨ÙˆØ¯Ø¬Ù‡',0),(114771,3189,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø¨ÙˆØ¯Ø¬Ù‡',0),(114772,3189,'tr','Hesap bÃ¼tÃ§esini gÃ¼ncelleÅŸtir',0),(114773,3189,'pl','Aktualizacja budÅ¼etu konta',0),(114774,3189,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(114775,3189,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ø¬Ù¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(114776,3189,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ñ€Ð°Ñ‡ÑƒÐ½ Ð±ÑƒÑŸÐµÑ‚Ð°',0),(114777,3189,'vi','Cáº­p Nháº­t TK NgÃ¢n SÃ¡ch',0),(114778,3189,'af','Opdateer Rekening Begroting',0),(114779,3189,'ro','Actualizare cont buget',0),(114780,3189,'et','Update arvesse eelarve',0),(114781,3189,'si','Posodobite raÄun proraÄuna',0),(114782,3189,'ba','Memperbarui Account anggaran',0),(114783,3189,'nl','Update Account begroting',0),(114784,3189,'fi','PÃ¤ivitÃ¤ tilin budjetti',0),(114785,3189,'no','Oppdatere kontobudsjettet',0),(114786,3189,'da','Opdatere konto Budget',0),(114787,3189,'ko','ì—…ë°ì´íŠ¸ ê³„ì • ì˜ˆì‚°',0),(114788,3189,'he','×¢×“×›×•×Ÿ ×ª×§×¦×™×‘ ×—×©×‘×•×Ÿ',0),(114789,3189,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ¬',0),(114790,3189,'zh','æ›´æ–°å¸æˆ·é¢„ç®—\r\n',0),(114791,3189,'sv','Uppdatera konto Budget',0),(114792,3189,'it','Aggiornamento conto bilancio',0),(114793,3189,'tl','',0),(114794,3189,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(114795,3189,'hi','à¤–à¤¾à¤¤à¤¾ à¤¬à¤œà¤Ÿ à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(114796,3189,'ms','Kemaskini akaun bajet',0),(114797,3189,'ar','ØªØ­Ø¯ÙŠØ« Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(114798,3189,'fr','Mise Ã  jour compte Budget',0),(114799,3189,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆäºˆç®—ã‚’æ›´æ–°',0),(114800,3189,'pt','Atualizar conta orÃ§amento',0),(114801,3189,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° ÑÑ‡ÐµÑ‚Ð°',0),(114802,3189,'es','Actualizar Presupuesto de Cuenta',0),(114803,3189,'de','Update Konto Budget',0),(114804,3189,'en','Update Account Budget',0),(114805,3190,'is','',0),(114806,3190,'dr','/ Ø§ÙØ²ÙˆØ¯Ù†  Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ø´ÙŠÙ† ',0),(114807,3190,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ / Ø§ÙØ²ÙˆØ¯Ù†  Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ø´ÙŠÙ† ',0),(114808,3190,'tr','GÃ¼ncelleÅŸtirme Ekle/makine aileler',0),(114809,3190,'pl','Aktualizacja/dodaÄ‡ maszyna rodzin',0),(114810,3190,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ/Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð°',0),(114811,3190,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº/Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù†ÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(114812,3190,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ /Ð”Ð¾Ð´Ð°Ñ˜ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ˜Ðµ',0),(114813,3190,'vi','Cáº­p Nháº­t/ThÃªm DÃ²ng MÃ¡y Gia ÄÃ¬nh',0),(114814,3190,'af','Opdateer/Skep Masjien Families',0),(114815,3190,'ro','Actualizare/Add maÅŸinÄƒ de familii',0),(114816,3190,'et','Update/lisada kohapeal peredele',0),(114817,3190,'si','Posodobitev/Add stroj druÅ¾ine',0),(114818,3190,'ba','Update/menambahkan mesin keluarga',0),(114819,3190,'nl','Update/voegt Machine gezinnen',0),(114820,3190,'fi','PÃ¤ivitÃ¤ tai lisÃ¤Ã¤ koneen Perheet',0),(114821,3190,'no','Oppdatering/legge Machine familier',0),(114822,3190,'da','Opdatering/Add maskine familier',0),(114823,3190,'ko','ì—…ë°ì´íŠ¸/ì¶”ê°€ ê¸°ê³„ ê°€ì¡±',0),(114824,3190,'he','×¢×“×›×•×Ÿ/×”×•×¡×£ ×ž×›×•× ×ª ×ž×©×¤×—×•×ª',0),(114825,3190,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ·/Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼Î·Ï‡Î±Î½Î® Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹ÎµÏ‚',0),(114826,3190,'zh','æ›´æ–°/æ·»åŠ æœºç³»åˆ—\r\n',0),(114827,3190,'sv','Uppdatering/LÃ¤gg till maskin familjer',0),(114828,3190,'it','Aggiornamento/aggiungere macchina famiglie',0),(114829,3190,'tl','',0),(114830,3190,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;/&#3648;&#3614;&#3636;&#3656;&#3617; &#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(114831,3190,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤°à¥‹à¤‚',0),(114832,3190,'ms','Kemaskini/Tambah Mesin keluarga',0),(114833,3190,'ar','ØªØ­Ø¯ÙŠØ«/Ø¥Ø¶Ø§ÙØ© Ø¢Ù„Ø© Ø§Ù„Ø£Ø³Ø±',0),(114834,3190,'fr','Mise Ã  jour ou ajouter des familles de la Machine',0),(114835,3190,'jp','æ©Ÿæ¢°ç³»çµ±ã?®æ›´æ–°/è¿½åŠ ',0),(114836,3190,'pt','AtualizaÃ§Ã£o/adicionar mÃ¡quina famÃ­lias',0),(114837,3190,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ/Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹',0),(114838,3190,'es','Actualizar/Agregar Familias de MÃ¡quinas',0),(114839,3190,'de','Update/Add Maschine Familien',0),(114840,3190,'en','Update/Add Machine Families',0),(114841,3191,'is','',0),(114842,3191,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(114843,3191,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(114844,3191,'tr','Bir hesap bÃ¼tÃ§esini gÃ¼ncelleÅŸtir',0),(114845,3191,'pl','Aktualizacja budÅ¼etu konta',0),(114846,3191,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(114847,3191,'ur','Ø§ÛŒÚ© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ø¬Ù¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(114848,3191,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½ Ð±ÑƒÑŸÐµÑ‚Ð°',0),(114849,3191,'vi','Cáº­p Nháº­t 1 TK NgÃ¢n SÃ¡ch',0),(114850,3191,'af','Opdateer \'n Rekening Begroting',0),(114851,3191,'ro','ActualizaÅ£i un cont buget',0),(114852,3191,'et','Update arvesse eelarve',0),(114853,3191,'si','Posodobite raÄun proraÄuna',0),(114854,3191,'ba','Memperbarui Account anggaran',0),(114855,3191,'nl','Een begroting Account bijwerken',0),(114856,3191,'fi','PÃ¤ivitÃ¤ tilin budjetti',0),(114857,3191,'no','Oppdatere en kontobudsjettet',0),(114858,3191,'da','Opdatere en konto Budget',0),(114859,3191,'ko','ì—…ë°ì´íŠ¸ ê³„ì • ì˜ˆì‚°',0),(114860,3191,'he','×¢×“×›×•×Ÿ ×ª×§×¦×™×‘ ×—×©×‘×•×Ÿ',0),(114861,3191,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÎ½ÏŒÏ‚ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(114862,3191,'zh','æ›´æ–°å¸æˆ·é¢„ç®—\r\n',0),(114863,3191,'sv','Uppdatera ett konto',0),(114864,3191,'it','Aggiornare un bilancio conto',0),(114865,3191,'tl','',0),(114866,3191,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(114867,3191,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤à¤• à¤–à¤¾à¤¤à¤¾ à¤¬à¤œà¤Ÿ',0),(114868,3191,'ms','Kemaskini Terakhir belanjawan akaun untuk',0),(114869,3191,'ar','ØªØ­Ø¯ÙŠØ« Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø­Ø³Ø§Ø¨',0),(114870,3191,'fr','Mise Ã  jour d\'un Budget de compte',0),(114871,3191,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆäºˆç®—ã‚’æ›´æ–°',0),(114872,3191,'pt','Atualizar um conta orÃ§amento',0),(114873,3191,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° ÑÑ‡ÐµÑ‚Ð°',0),(114874,3191,'es','Actualizar un Cuenta Presupuestaria',0),(114875,3191,'de','Update ein Konto-Budget',0),(114876,3191,'en','Update an Account Budget',0),(114877,3192,'is','',0),(114878,3192,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙŠÚ¯Ø± ',0),(114879,3192,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙŠÚ¯Ø± ',0),(114880,3192,'tr','BaÅŸka bir Ã¶ÄŸeyi GÃ¼ncelleÅŸtir',0),(114881,3192,'pl','Aktualizacja innego elementu',0),(114882,3192,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(114883,3192,'ur','Ú©Ø³ÛŒ Ø§ÙˆØ± Ø´Û’ ØªØ§Ø²Û Ú©Ø±ÛŒÚº',0),(114884,3192,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ñ€ÑƒÐ³Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(114885,3192,'vi','Cáº­p Nháº­t Má»¥c KhÃ¡c',0),(114886,3192,'af','Opdateer \'n ander Item',0),(114887,3192,'ro','Un alt element de actualizare',0),(114888,3192,'et','Teise Ã¼ksuse vÃ¤rskendamine',0),(114889,3192,'si','Posodobite drug element',0),(114890,3192,'ba','Memperbarui Item lain',0),(114891,3192,'nl','Een ander Item bijwerken',0),(114892,3192,'fi','PÃ¤ivitÃ¤ toiseen kohteeseen',0),(114893,3192,'no','Oppdatere et element',0),(114894,3192,'da','Opdatere en anden vare',0),(114895,3192,'ko','ë‹¤ë¥¸ í•­ëª©ì„ ì—…ë°ì´íŠ¸',0),(114896,3192,'he','×¢×“×›×Ÿ ×¤×¨×™×˜ × ×•×¡×£',0),(114897,3192,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Î­Î½Î± Î¬Î»Î»Î¿ ÎµÎ¯Î´Î¿Ï‚',0),(114898,3192,'zh','æ›´æ–°å…¶ä»–ç‰©å“\r\n',0),(114899,3192,'sv','Uppdatera ett annat objekt',0),(114900,3192,'it','Aggiornare un altro elemento',0),(114901,3192,'tl','',0),(114902,3192,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3629;&#3639;&#3656;&#3609;',0),(114903,3192,'hi','à¤à¤• à¤”à¤° à¤†à¤‡à¤Ÿà¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(114904,3192,'ms','Kemaskini Terakhir Item lain',0),(114905,3192,'ar','ØªØ­Ø¯ÙŠØ« ØµÙ†Ù Ø¢Ø®Ø±',0),(114906,3192,'fr','Mettre Ã  jour un autre Ã©lÃ©ment',0),(114907,3192,'jp','ä»–ã?®å“?ç›®ã?®æ›´æ–°',0),(114908,3192,'pt','Atualizar Item outro',0),(114909,3192,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ð¢Ð¾Ð²Ð°Ñ€',0),(114910,3192,'es','Actualizar otro item',0),(114911,3192,'de','Ein weiteres Element aktualisieren',0),(114912,3192,'en','Update another Item',0),(114913,3193,'is','',0),(114914,3193,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙˆØ§Ø¨Ø¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù†ÙˆØ¹',0),(114915,3193,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙˆØ§Ø¨Ø¹ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ Ù†Øª Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù†ÙˆØ¹',0),(114916,3193,'tr','Bu tÃ¼r iÃ§in gÃ¼ncelleÅŸtirme baÄŸlayÄ±cÄ± iÅŸlevleri',0),(114917,3193,'pl','Aktualizacja bazy danych Bindery funkcje dla tego typu',0),(114918,3193,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ñ‚Ð¸Ð¿',0),(114919,3193,'ur','Ø§Ø³ Ù‚Ø³Ù… Ú©Û’ Ù„Ø¦Û’ Ø¨Ø§Ù†ÚˆØ±ÛŒ Ø§ÙØ¹Ø§Ù„ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(114920,3193,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ñ‚Ð¸Ð¿',0),(114921,3193,'vi','Cáº­p Nháº­t Chá»©c NÄƒng ÄÃ³ng SÃ¡ch cho loáº¡i nÃ y',0),(114922,3193,'af','Bindery funksies vir hierdie tipe werk',0),(114923,3193,'ro','Actualizare legatorie funcÅ£ii pentru acest tip de',0),(114924,3193,'et','Update Kirjansitomo funktsioonid selline',0),(114925,3193,'si','Posodobitev Knjigoveznica funkcije za to vrsto',0),(114926,3193,'ba','Fungsi Bindery update untuk tipe ini',0),(114927,3193,'nl','Bijwerken van Bindery functies voor dit type',0),(114928,3193,'fi','PÃ¤ivitÃ¤ Bindery tehtÃ¤viÃ¤ tÃ¤llaisen',0),(114929,3193,'no','Oppdatere Bindery funksjoner for denne type',0),(114930,3193,'da','Opdatere Bindery funktioner for denne type',0),(114931,3193,'ko','ì´ í˜•ì‹ì— ëŒ€ í•œ ì—…ë°ì´íŠ¸ ë°”ì¸ë”ë¦¬ ê¸°ëŠ¥',0),(114932,3193,'he','×¢×“×›×•×Ÿ Bindery ×¤×•× ×§×¦×™×•×ª ×¢×‘×•×¨ ×¡×•×’ ×–×”',0),(114933,3193,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚ Ï„Î¿Ï… Bindery Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚ Î³Î¹Î± Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï„ÏÏ€Î¿',0),(114934,3193,'zh','æ›´æ–°æ­¤ç±»åž‹çš„è£…è®¢åŠŸèƒ½\r\n',0),(114935,3193,'sv','Uppdatera Bindery funktioner fÃ¶r denna typ',0),(114936,3193,'it','Aggiornamento della legatoria funzioni per questo tipo',0),(114937,3193,'tl','',0),(114938,3193,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3585;&#3627;&#3609;&#3657;&#3634;&#3607;&#3637;&#3656;&#3586;&#3629;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3609;&#3637;&#3657;',0),(114939,3193,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤•à¤¾à¤°à¥à¤¯ à¤‡à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(114940,3193,'ms','Kemaskini Terakhir Bindery fungsi untuk jenis ini',0),(114941,3193,'ar','ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ù‡Ø§Ù… Ù„Ù‡Ø°Ø§ Ø§Ù„Ù†ÙˆØ¹',0),(114942,3193,'fr','Mise Ã  jour des fonctions de faÃ§onnage pour ce type',0),(114943,3193,'jp','ã?“ã?®ã‚¿ã‚¤ãƒ—ã?®ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ©Ÿèƒ½ã‚’æ›´æ–°',0),(114944,3193,'pt','FunÃ§Ãµes de Bindery atualizaÃ§Ã£o para este tipo',0),(114945,3193,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð” Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð´Ð»Ñ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ Ñ‚Ð¸Ð¿Ð°',0),(114946,3193,'es','Actualizar funciones de EncuadernaciÃ³n para este tipo',0),(114947,3193,'de','Buchbinderei Aktualisierungsfunktionen fÃ¼r diese Art',0),(114948,3193,'en','Update Bindery functions for this type',0),(114949,3194,'is','',0),(114950,3194,'dr','/ Ø§ÙØ²ÙˆØ¯Ù† Ø±ÙˆØ´Ù‡Ø§ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(114951,3194,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ / Ø§ÙØ²ÙˆØ¯Ù† Ø±ÙˆØ´Ù‡Ø§ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(114952,3194,'tr','Yeni/DÃ¼zenle taÅŸÄ±yÄ±cÄ± yÃ¶ntemleri',0),(114953,3194,'pl','Nowy edycja przewoÅºnika metody',0),(114954,3194,'bg','ÐÐ¾Ð²Ð¸/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ Ð¼ÐµÑ‚Ð¾Ð´Ð¸',0),(114955,3194,'ur','Ù†Ø¦ÛŒ/ØªØ±Ù…ÛŒÙ… Ú©ÛŒØ±ÛŒØ¦Ø± Ø·Ø±ÛŒÙ‚Û’',0),(114956,3194,'sr','ÐÐ¾Ð²Ð¸ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð¾ÑÐ°Ñ‡ Ð¼ÐµÑ‚Ð¾Ð´Ðµ',0),(114957,3194,'vi','ThÃªm/Cáº­p Nháº­t PhÆ°Æ¡ng Thá»©c ChuyÃªn Chá»Ÿ',0),(114958,3194,'af','Opdateer/Skep Karweier Metodes',0),(114959,3194,'ro','Metode de transport noi/editare',0),(114960,3194,'et','Uus/Muuda vedaja meetodid',0),(114961,3194,'si','Nove izdajati/prevoznik metode',0),(114962,3194,'ba','Baru/Edit pembawa metode',0),(114963,3194,'nl','Nieuwe/bewerken vervoerder methoden',0),(114964,3194,'fi','Uusi tai Muokkaa harjoittaja menetelmien',0),(114965,3194,'no','Ny/Rediger Carrier metoder',0),(114966,3194,'da','Nyt/Rediger Carrier metoder',0),(114967,3194,'ko','ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘ ìºë¦¬ì–´ ë°©ë²•',0),(114968,3194,'he','×©×™×˜×•×ª ×ž× ×©× ×—×“×©/×¢×¨×™×›×”',0),(114969,3194,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼ÎµÎ¸ÏŒÎ´Ï‰Î½ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(114970,3194,'zh','æ›´æ–°/æ–°å¢žæ‰¿è¿å•†æ–¹æ³•\r\n',0),(114971,3194,'sv','Ny/redigera bÃ¤rare metoder',0),(114972,3194,'it','Metodi Carrier nuovo/modifica',0),(114973,3194,'tl','',0),(114974,3194,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;/&#3648;&#3614;&#3636;&#3656;&#3617; &#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3610;&#3619;&#3619;&#3607;&#3640;&#3585;',0),(114975,3194,'hi','à¤¨à¤ˆ/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤µà¤¾à¤¹à¤• à¤µà¤¿à¤§à¤¿à¤¯à¤¾à¤',0),(114976,3194,'ms','Kaedah-kaedah pengangkutan baru/Edit',0),(114977,3194,'ar','Ø£Ø³Ø§Ù„ÙŠØ¨ Ø¬Ø¯ÙŠØ¯Ø©/ØªØ­Ø±ÙŠØ± Ø§Ù„Ù†Ø§Ù‚Ù„',0),(114978,3194,'fr','Edit/nouveau transporteur mÃ©thodes',0),(114979,3194,'jp','é…?é€?æ–¹æ³•ã?®æ›´æ–°/è¿½åŠ ',0),(114980,3194,'pt','MÃ©todos de transportadora novo/editar',0),(114981,3194,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ/Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡Ð¿Ð¾ÑÐ¾Ð± ÐšÑƒÑ€ÑŒÐµÑ€ÑÐºÐ¾Ð¹ Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(114982,3194,'es','Actualizar/Agregar MÃ©todos de Transporte',0),(114983,3194,'de','Neu/bearbeiten-Carrier-Methoden',0),(114984,3194,'en','New/Edit Carrier Methods',0),(114985,3195,'is','',0),(114986,3195,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø±Ù†Ú¯ ',0),(114987,3195,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø±Ù†Ú¯ ',0),(114988,3195,'tr','Renk listesini GÃ¼ncelleÅŸtir',0),(114989,3195,'pl','ZaktualizowaÄ‡ listÄ™ kolorÃ³w',0),(114990,3195,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð½Ð° Ñ†Ð²ÑÑ‚',0),(114991,3195,'ur','Ø±Ù†Ú¯ ÙÛØ±Ø³Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(114992,3195,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð±Ð¾Ñ˜Ð°',0),(114993,3195,'vi','Cáº­p Nháº­t Danh SÃ¡ch Máº§u',0),(114994,3195,'af','Opdateer Kleurlys',0),(114995,3195,'ro','ActualizeazÄƒ lista de culoare',0),(114996,3195,'et','VÃ¤rvi loendi uuendamine',0),(114997,3195,'si','Posodobite seznam barv',0),(114998,3195,'ba','Memperbarui daftar warna',0),(114999,3195,'nl','Kleur updatelijst',0),(115000,3195,'fi','PÃ¤ivitÃ¤ vÃ¤riluettelo',0),(115001,3195,'no','Oppdatere listen',0),(115002,3195,'da','Opdatere farvelisten',0),(115003,3195,'ko','ìƒ‰ ëª©ë¡ ì—…ë°ì´íŠ¸',0),(115004,3195,'he','×¢×“×›×•×Ÿ ×¨×©×™×ž×ª ×¦×‘×¢×™',0),(115005,3195,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚ Ï‡ÏÏŽÎ¼Î±',0),(115006,3195,'zh','æ›´æ–°é¢œè‰²åˆ—è¡¨\r\n',0),(115007,3195,'sv','Uppdatera listan',0),(115008,3195,'it','Aggiornare l\'elenco dei colori',0),(115009,3195,'tl','',0),(115010,3195,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(115011,3195,'hi','à¤°à¤‚à¤— à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115012,3195,'ms','Mengemaskini senarai warna',0),(115013,3195,'ar','ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ù„ÙˆØ§Ù†',0),(115014,3195,'fr','Mise Ã  jour de la liste des couleurs',0),(115015,3195,'jp','ã‚«ãƒ©ãƒ¼ãƒªã‚¹ãƒˆã?®æ›´æ–°',0),(115016,3195,'pt','Atualizar a lista de cores',0),(115017,3195,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ð¦Ð²ÐµÑ‚',0),(115018,3195,'es','Actualizar Lista de Colores',0),(115019,3195,'de','Liste der Update-Farbe',0),(115020,3195,'en','Update Color List',0),(115021,3196,'is','',0),(115022,3196,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(115023,3196,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(115024,3196,'tr','Maliyetleri gÃ¼ncelleÅŸtirme',0),(115025,3196,'pl','Koszty aktualizacji',0),(115026,3196,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(115027,3196,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115028,3196,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(115029,3196,'vi','Cáº­p Nháº­t GiÃ¡ ThÃ nh',0),(115030,3196,'af','Opdateer Kostes',0),(115031,3196,'ro','Costurile de actualizare',0),(115032,3196,'et','Uuenda kulude',0),(115033,3196,'si','Posodobitev stroÅ¡kov',0),(115034,3196,'ba','Biaya update',0),(115035,3196,'nl','Bijwerken Kosten',0),(115036,3196,'fi','Kustannusten pÃ¤ivittÃ¤minen',0),(115037,3196,'no','Oppdatere kostnader',0),(115038,3196,'da','Opdatere omkostningerne',0),(115039,3196,'ko','ë¹„ìš© ì—…ë°ì´íŠ¸',0),(115040,3196,'he','×¢×“×›×Ÿ ×¢×œ×•×™×•×ª',0),(115041,3196,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(115042,3196,'zh','æ›´æ–°è´¹ç”¨\r\n',0),(115043,3196,'sv','Uppdatera kostnader',0),(115044,3196,'it','Costi di aggiornamento',0),(115045,3196,'tl','',0),(115046,3196,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(115047,3196,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤²à¤¾à¤—à¤¤',0),(115048,3196,'ms','Kos Kemaskini',0),(115049,3196,'ar','ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(115050,3196,'fr','CoÃ»ts de mise Ã  jour',0),(115051,3196,'jp','è²»ç”¨ã?®æ›´æ–°',0),(115052,3196,'pt','Custos de atualizaÃ§Ã£o',0),(115053,3196,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(115054,3196,'es','Actualizar Costos',0),(115055,3196,'de','Update-Kosten',0),(115056,3196,'en','Update Costs',0),(115057,3197,'is','',0),(115058,3197,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ùˆ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(115059,3197,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ùˆ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(115060,3197,'tr','GÃ¼ncelleÅŸtirme maliyeti ve fiyatlandÄ±rma',0),(115061,3197,'pl','Aktualizacja kosztÃ³w i cen',0),(115062,3197,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¸ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(115063,3197,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø§ÙˆØ± Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(115064,3197,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¸ Ñ†ÐµÐ½Ðµ',0),(115065,3197,'vi','Cáº­p Nháº­t GiÃ¡ ThÃ nh & GiÃ¡ BÃ¡n',0),(115066,3197,'af','Opdateer Kostes en \"Pricing\"',0),(115067,3197,'ro','Costurile de actualizare ÅŸi de stabilire a preÅ£urilor',0),(115068,3197,'et','Update kulud ja hinnakujundus',0),(115069,3197,'si','Posodobitev stroÅ¡kov in cen',0),(115070,3197,'ba','Pembaruan biaya dan harga',0),(115071,3197,'nl','Bijwerken Kosten en Prijzen',0),(115072,3197,'fi','PÃ¤ivityksen kustannukset ja hinnoittelu',0),(115073,3197,'no','Oppdateringskostnader og priser',0),(115074,3197,'da','Opdatering omkostninger og prissÃ¦tning',0),(115075,3197,'ko','ì—…ë°ì´íŠ¸ ë¹„ìš© ë° ê°€ê²©',0),(115076,3197,'he','×¢×“×›×•×Ÿ ×¢×œ×•×™×•×ª ×•×ª×ž×—×•×¨',0),(115077,3197,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÎ±Î¹ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(115078,3197,'zh','æ›´æ–°æˆæœ¬å’Œä»·æ ¼\r\n',0),(115079,3197,'sv','Uppdatera kostnader och prissÃ¤ttning',0),(115080,3197,'it','Aggiornamento costi e prezzi',0),(115081,3197,'tl','',0),(115082,3197,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(115083,3197,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤²à¤¾à¤—à¤¤ à¤”à¤° à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(115084,3197,'ms','Update kos dan harga',0),(115085,3197,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ ÙˆØ§Ù„ØªØ³Ø¹ÙŠØ±',0),(115086,3197,'fr','Mise Ã  jour des coÃ»ts et tarification',0),(115087,3197,'jp','è²»ç”¨ã?¨ä¾¡æ ¼ã?®æ›´æ–°',0),(115088,3197,'pt','AtualizaÃ§Ã£o de custos e preÃ§os',0),(115089,3197,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð¸ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(115090,3197,'es','Actualizar Costos y Precios',0),(115091,3197,'de','Update-Kosten und Preise',0),(115092,3197,'en','Update Costs and Pricing',0),(115093,3198,'is','',0),(115094,3198,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(115095,3198,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(115096,3198,'tr','Fiyat gÃ¼ncelleÅŸtirme mÃ¼ÅŸteri',0),(115097,3198,'pl','Aktualizacja klienta ceny',0),(115098,3198,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(115099,3198,'ur','Ú¯Ø§ÛÚ© Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115100,3198,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÑƒÐ¿Ñ†Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(115101,3198,'vi','Cáº­p Nháº­t GiÃ¡ KhÃ¡ch HÃ ng',0),(115102,3198,'af','Opdateer Klant / KliÃ«nt Prys',0),(115103,3198,'ro','Actualizare clientului preturi',0),(115104,3198,'et','Update klient hinnakujundus',0),(115105,3198,'si','Posodobite cenitev stranka',0),(115106,3198,'ba','Memperbarui pelanggan harga',0),(115107,3198,'nl','Klant prijzen bijwerken',0),(115108,3198,'fi','PÃ¤ivitÃ¤ asiakas hinnoittelu',0),(115109,3198,'no','Oppdatere kunden priser',0),(115110,3198,'da','Opdatere kunden prissÃ¦tning',0),(115111,3198,'ko','ê³ ê° ê°€ê²© ì—…ë°ì´íŠ¸',0),(115112,3198,'he','×¢×“×›×•×Ÿ ×”×œ×§×•×— ×ª×ž×—×•×¨',0),(115113,3198,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÎµÎ»Î¬Ï„Î· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(115114,3198,'zh','æ›´æ–°å®¢æˆ·å®šä»·\r\n',0),(115115,3198,'sv','Uppdatera kund prissÃ¤ttning',0),(115116,3198,'it','Cliente di aggiornamento prezzi',0),(115117,3198,'tl','',0),(115118,3198,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(115119,3198,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115120,3198,'ms','Baca Update harga',0),(115121,3198,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(115122,3198,'fr','Mise Ã  jour client tarification',0),(115123,3198,'jp','é¡§å®¢å€¤ä»˜ã?‘ã?®æ›´æ–°',0),(115124,3198,'pt','Cliente de atualizaÃ§Ã£o de preÃ§os',0),(115125,3198,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ñ†ÐµÐ½Ñ‹',0),(115126,3198,'es','Actualizar Precios de Clientes',0),(115127,3198,'de','Kunden, die Preise zu aktualisieren',0),(115128,3198,'en','Update Customer Pricing',0),(115129,3199,'is','',0),(115130,3199,'dr','ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(115131,3199,'pr','ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(115132,3199,'tr','KullanÄ±cÄ± baÅŸarÄ±yla silindi.',0),(115133,3199,'pl','UÅ¼ytkownik pomyÅ›lnie usuniÄ™ty.',0),(115134,3199,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(115135,3199,'ur','ØµØ§Ø±Ù Ù†Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø±Ø¯ÛŒØ§ Û”',0),(115136,3199,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(115137,3199,'vi','XÃ³a NgÆ°á»i Sá»­ Dá»¥ng ThÃ nh CÃ´ng',0),(115138,3199,'af','Gebruiker suksesvol geskrap',0),(115139,3199,'ro','Utilizator ÅŸters cu succes.',0),(115140,3199,'et','VÃ¤rskendus edukalt kustutatud',0),(115141,3199,'si','Uporabnik uspeÅ¡no izbrisana.',0),(115142,3199,'ba','User berhasil dihapus.',0),(115143,3199,'nl','Gebruiker verwijderd.',0),(115144,3199,'fi','KÃ¤yttÃ¤jÃ¤ on poistettu.',0),(115145,3199,'no','Brukeren ble slettet.',0),(115146,3199,'da','Brugeren slettet.',0),(115147,3199,'ko','ì‚¬ìš©ìžê°€ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í–ˆìŠµë‹ˆë‹¤.',0),(115148,3199,'he','×”×ž×©×ª×ž×© × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(115149,3199,'el','Î§ÏÎ®ÏƒÏ„Î· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(115150,3199,'zh','ç”¨æˆ·å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(115151,3199,'sv','AnvÃ¤ndaren raderades.',0),(115152,3199,'it','Utente cancellato con successo.',0),(115153,3199,'tl','',0),(115154,3199,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3606;&#3641;&#3585;&#3621;&#3610;&#3626;&#3635;&#3648;&#3655;&#3619;&#3655;&#3592;&#3649;&#3621;&#3657;&#3623;',0),(115155,3199,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(115156,3199,'ms','Pengguna yang dihapuskan dengan jayanya.',0),(115157,3199,'ar','Ù…Ø³ØªØ®Ø¯Ù… Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­.',0),(115158,3199,'fr','Utilisateur supprimÃ© avec succÃ¨s.',0),(115159,3199,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(115160,3199,'pt','UsuÃ¡rio excluÃ­do com sucesso.',0),(115161,3199,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½.',0),(115162,3199,'es','Usuario eliminado exitosamente',0),(115163,3199,'de','Benutzer erfolgreich gelÃ¶scht.',0),(115164,3199,'en','User deleted successfully.',0),(115165,3200,'is','',0),(115166,3200,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± â€“ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¹Ù…ÙˆÙ…ÙŠ ',0),(115167,3200,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†ÙˆØ¹ ÙƒØ§Ø± â€“ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¹Ù…ÙˆÙ…ÙŠ ',0),(115168,3200,'tr','AyrÄ±ntÄ±lÄ± Ã§alÄ±ÅŸma tÃ¼rÃ¼ bilgilerini gÃ¼ncelleme<br>Genel iÅŸ tÃ¼rÃ¼ =',0),(115169,3200,'pl','Aktualizacja szczegÃ³Å‚Ã³w pracy typu informacji<br>OgÃ³lne pracy typu =',0),(115170,3200,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ<br>ÐžÐ±Ñ‰ Ð²Ð¸Ð´ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚Ð° =',0),(115171,3200,'ur','ØªÙØµÛŒÙ„ Ú©Ø§Ù… Ù‚Ø³Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº<br>Ø¬Ù†Ø±Ù„ Ú©Ø§Ù… Ù‚Ø³Ù… =',0),(115172,3200,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð¿Ð¾ÑÐ»Ð° Ñ‚Ð¸Ð¿Ð° Ð˜Ð½Ñ„Ð¾<br>Ð’Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð» =',0),(115173,3200,'vi','Cáº­p Nháº­t ThÃ´ng Tin Chi Tiáº¿t Loáº¡i CÃ´ng viá»‡c<br>Loáº¡i CÃ´ng Viá»‡c Chung =',0),(115174,3200,'af','Opdateer van Gedetailleerde Werkstipe Info<br>General Work Type =',0),(115175,3200,'ro','Actualizare informaÅ£ii de tip detaliu locul de muncÄƒ<br>Tip de muncÄƒ general =',0),(115176,3200,'et','Detail tÃ¶Ã¶d tÃ¼Ã¼pi teabe vÃ¤rskendamine<br>Ãœldine tÃ¶Ã¶ tÃ¼Ã¼p =',0),(115177,3200,'si','Posodobite podrobnosti dela vrsta Info<br>Vrsta dela sploÅ¡ne =',0),(115178,3200,'ba','Memperbarui informasi jenis pekerjaan Detail<br>Jenis pekerjaan umum =',0),(115179,3200,'nl','Detail werk Type Info bijwerken<br>Generaal werksoort =',0),(115180,3200,'fi','PÃ¤ivitÃ¤ tiedot tyÃ¶n tyyppi<br>Yleinen tyÃ¶n tyyppi =',0),(115181,3200,'no','Oppdatere detaljert arbeid Type informasjon<br>Generelt arbeid Type =',0),(115182,3200,'da','Opdatere detaljer arbejde Type Info<br>General arbejde Type =',0),(115183,3200,'ko','ì„¸ë¶€ ìž‘ì—… ìœ í˜• ì •ë³´ ì—…ë°ì´íŠ¸<br>ì¼ë°˜ ìž‘ì—… ìœ í˜• =',0),(115184,3200,'he','×¢×“×›×Ÿ ××ª ×¤×™×¨×•×˜ ×”×¢×‘×•×“×” ×¡×•×’ ×¤×¨×˜×™<br>×¡×•×’ ×¢×‘×•×“×” ×›×œ×œ×™ =',0),(115185,3200,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï… Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚<br>Î“ÎµÎ½Î¹ÎºÏŒÏ‚ Î¤ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ =',0),(115186,3200,'zh','æ›´æ–°ç»†èŠ‚å·¥ä½œç±»åž‹ä¿¡æ¯<br>ç‰©ç†åŒ–å­¦æ€»ä½“å·¥ä½œç±»åž‹=\r\n',0),(115187,3200,'sv','Uppdatera detalj arbete typ information<br>AllmÃ¤nna arbete typ =',0),(115188,3200,'it','Aggiornare le informazioni di dettaglio lavoro tipo<br>Tipo di lavoro generale =',0),(115189,3200,'tl','',0),(115190,3200,'th','Update Detail Work Type Info<br>General Work Type =',0),(115191,3200,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚<br>à¤œà¤¨à¤°à¤² à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤° =',0),(115192,3200,'ms','Kemaskinikan butiran kerja jenis maklumat<br>Jenis kerja am =',0),(115193,3200,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„ØªÙØµÙŠÙ„<br>Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù…Ø© =',0),(115194,3200,'fr','Mettre Ã  jour les informations de Type de travail dÃ©tail<br>Type de travail gÃ©nÃ©rale =',0),(115195,3200,'jp','ä½œæ¥­ã‚¿ã‚¤ãƒ—æƒ…å ±è©³ç´°ã?®æ›´æ–°<br>ä¸€èˆ¬ä½œæ¥­ã‚¿ã‚¤ãƒ—ï¼?',0),(115196,3200,'pt','Atualizar informaÃ§Ãµes de tipo de trabalho de detalhe<br>Tipo de trabalho geral =',0),(115197,3200,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾<br>Ð¢Ð¸Ð¿ Ð¾Ð±Ñ‰ÐµÐ³Ð¾ Ñ€Ð°Ð±Ð¾Ñ‡ÐµÐ³Ð¾ =',0),(115198,3200,'es','Actualizar Info de Detalle de Tipo de Trabajo<br>Tipo de Trabajo General =',0),(115199,3200,'de','Detail-Arbeit-Typinformationen zu aktualisieren<br>General Arbeitstyp =',0),(115200,3200,'en','Update Detail Work Type Info<br>General Work Type =',0),(115201,3201,'is','',0),(115202,3201,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ù†Ø¯ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§',0),(115203,3201,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ù†Ø¯ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§',0),(115204,3201,'tr','Belge Ã¶zelliklerini GÃ¼ncelleÅŸtir',0),(115205,3201,'pl','Aktualizacja wÅ‚aÅ›ciwoÅ›ci dokumentu',0),(115206,3201,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(115207,3201,'ur','Ø®ÙˆØ§Øµ Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115208,3201,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð°Ð²Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(115209,3201,'vi','Cáº­p nháº­t tÃ­nh cháº¥t tÃ i liá»‡u',0),(115210,3201,'af','Opdateer Dokument \"Properties\"',0),(115211,3201,'ro','Actualizare proprietÄƒÅ£i Document',0),(115212,3201,'et','Dokumendi atribuutide vÃ¤rskendamine',0),(115213,3201,'si','Posodobite lastnosti dokumenta',0),(115214,3201,'ba','Memperbarui properti dokumen',0),(115215,3201,'nl','Documenteigenschappen bijwerken',0),(115216,3201,'fi','Asiakirjaominaisuuksien pÃ¤ivittÃ¤minen',0),(115217,3201,'no','Oppdatere dokumentegenskapene',0),(115218,3201,'da','Opdatere dokumentegenskaber',0),(115219,3201,'ko','ë¬¸ì„œ ì†ì„± ì—…ë°ì´íŠ¸',0),(115220,3201,'he','×ž××¤×™×™× ×™ ×ž×¡×ž×š ×¢×“×›×•×Ÿ',0),(115221,3201,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¹Î´Î¹Î¿Ï„Î®Ï„Ï‰Î½ ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(115222,3201,'zh','æ›´æ–°æ–‡æ¡£å±žæ€§\r\n',0),(115223,3201,'sv','Uppdatera dokumentegenskaper',0),(115224,3201,'it','Aggiornare le proprietÃ  del documento',0),(115225,3201,'tl','',0),(115226,3201,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;&#3586;&#3629;&#3591;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(115227,3201,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤—à¥à¤£ à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(115228,3201,'ms','Kemaskini dokumen hartanah',0),(115229,3201,'ar','ØªØ­Ø¯ÙŠØ« Ø®ØµØ§Ø¦Øµ Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(115230,3201,'fr','Mise Ã  jour des propriÃ©tÃ©s de Document',0),(115231,3201,'jp','æ–‡æ›¸ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã?®æ›´æ–°',0),(115232,3201,'pt','Atualizar as propriedades do documento',0),(115233,3201,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ²Ð¾Ð¹ÑÑ‚Ð² Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(115234,3201,'es','Actualizar Propiedades del Documento',0),(115235,3201,'de','Update-Dokumenteigenschaften',0),(115236,3201,'en','Update Document Properties',0),(115237,3202,'is','',0),(115238,3202,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(115239,3202,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(115240,3202,'tr','GÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu!',0),(115241,3202,'pl','Aktualizacja nie powiodÅ‚a siÄ™!',0),(115242,3202,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ!',0),(115243,3202,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù…!',0),(115244,3202,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾!',0),(115245,3202,'vi','Cáº­p nháº­t tháº¥t báº¡i!',0),(115246,3202,'af','Opdatering het Gefaal!',0),(115247,3202,'ro','Actualizarea nu a reuÈ™it!',0),(115248,3202,'et','VÃ¤rskendamine nurjus!',0),(115249,3202,'si','Posodobitev ni uspela!',0),(115250,3202,'ba','Gagal update!',0),(115251,3202,'nl','Update is mislukt!',0),(115252,3202,'fi','PÃ¤ivitys epÃ¤onnistui!',0),(115253,3202,'no','Oppdateringen mislyktes!',0),(115254,3202,'da','Opdateringen mislykkedes!',0),(115255,3202,'ko','ì—…ë°ì´íŠ¸ ì‹¤íŒ¨!',0),(115256,3202,'he','×¢×“×›×•×Ÿ × ×›×©×œ!',0),(115257,3202,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·!',0),(115258,3202,'zh','æ›´æ–°å¤±è´¥ï¼\r\n',0),(115259,3202,'sv','Det gick inte att uppdatera!',0),(115260,3202,'it','Aggiornamento non riuscito!',0),(115261,3202,'tl','',0),(115262,3202,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;!',0),(115263,3202,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾!',0),(115264,3202,'ms','Kemas kini yang gagal!',0),(115265,3202,'ar','ÙØ´Ù„ Ø§Ù„ØªØ­Ø¯ÙŠØ« !',0),(115266,3202,'fr','Mise Ã  jour a Ã©chouÃ© !',0),(115267,3202,'jp','æ›´æ–°ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿï¼?',0),(115268,3202,'pt','AtualizaÃ§Ã£o falhou!',0),(115269,3202,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ!',0),(115270,3202,'es','ActualizaciÃ³n FallÃ³!',0),(115271,3202,'de','Update fehlgeschlagen!',0),(115272,3202,'en','Update Failed!',0),(115273,3203,'is','',0),(115274,3203,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙƒÙ„ÙŠ ',0),(115275,3203,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙƒÙ„ÙŠ ',0),(115276,3203,'tr','Genel PO gÃ¼ncelleme #',0),(115277,3203,'pl','Aktualizacja ogÃ³lne PO #',0),(115278,3203,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ð±Ñ‰Ð° PO #',0),(115279,3203,'ur','Ø¬Ù†Ø±Ù„ Ù¾ÙˆØ³Ù¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº #',0),(115280,3203,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð³Ð»Ð°Ð²Ð½Ðµ ÐŸÐž #',0),(115281,3203,'vi','Cáº­p nháº­t sá»‘ ÄÆ¡n Mua HÃ ng chung',0),(115282,3203,'af','Opdateer Algemene AB #',0),(115283,3203,'ro','Actualizare generale PO #',0),(115284,3203,'et','Muudetud Ã¼ldise PO #',0),(115285,3203,'si','Posodobite sploÅ¡na PO #',0),(115286,3203,'ba','Memperbarui umum PO #',0),(115287,3203,'nl','Bijwerken van algemene PO #',0),(115288,3203,'fi','PÃ¤ivittÃ¤Ã¤ yleisen PO #',0),(115289,3203,'no','Oppdatere generell PO #',0),(115290,3203,'da','Opdatere generelle PO #',0),(115291,3203,'ko','ì¼ë°˜ í¬ ì—…ë°ì´íŠ¸ #',0),(115292,3203,'he','×¢×“×›×•×Ÿ ×›×œ×œ×™ ×¤×• #',0),(115293,3203,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³ÎµÎ½Î¹ÎºÎ® PO #',0),(115294,3203,'zh','æ›´æ–°çš„æ™®é€šè®¢å•ï¼ƒ\r\n',0),(115295,3203,'sv','Uppdatera allmÃ¤nna PO #',0),(115296,3203,'it','Aggiornamento generale PO #',0),(115297,3203,'tl','',0),(115298,3203,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(115299,3203,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤ªà¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ #',0),(115300,3203,'ms','Kemaskini Terakhir PO am #',0),(115301,3203,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¹Ø§Ù… Øµ. Ø¨ #',0),(115302,3203,'fr','Mise Ã  jour gÃ©nÃ©rale PO #',0),(115303,3203,'jp','ä¸€èˆ¬POï¼ƒã‚’æ›´æ–°',0),(115304,3203,'pt','AtualizaÃ§Ã£o geral PO #',0),(115305,3203,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð±Ñ‰Ð¸Ñ… PO #',0),(115306,3203,'es','Actualizar OC General #',0),(115307,3203,'de','Aktualisieren Sie allgemeine PO #',0),(115308,3203,'en','Update General PO #',0),(115309,3204,'is','',0),(115310,3204,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ÙƒÙ„ÙŠ ',0),(115311,3204,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ÙƒÙ„ÙŠ ',0),(115312,3204,'tr','GENEL FÄ°Åž BÄ°LGÄ°LERÄ°NÄ° GÃœNCELLEÅžTÄ°RME',0),(115313,3204,'pl','AKTUALIZACJA INFORMACJI OGÃ“LNYCH ZAÅÄ„CZNIKA',0),(115314,3204,'bg','ÐÐšÐ¢Ð£ÐÐ›Ð˜Ð—Ð˜Ð ÐÐÐ• ÐÐ Ð’ÐÐ£Ð§Ð•Ð  Ð—Ð ÐžÐ‘Ð©Ð Ð˜ÐÐ¤ÐžÐ ÐœÐÐ¦Ð˜Ð¯',0),(115315,3204,'ur','Ø¬Ù†Ø±Ù„ ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115316,3204,'sr','Ð’ÐÐ£Ð§Ð•Ð  Ð—Ð ÐžÐŸÐ¨Ð¢Ð• Ð˜ÐÐ¤ÐžÐ ÐœÐÐ¦Ð˜ÐˆÐ• Ðž Ð˜Ð¡ÐŸÐ ÐÐ’Ð¦Ð˜',0),(115317,3204,'vi','Cáº­p nháº­t thÃ´ng tin phiáº¿u mua hÃ ng chung',0),(115318,3204,'af','OPDATERING VAN ALGEMENE BEWYSSTUK INLIGTING',0),(115319,3204,'ro','ACTUALIZAÅ¢I INFORMAÅ¢IILE GENERALE VOUCHER',0),(115320,3204,'et','ÃœLDISE KANDE TEABE VÃ„RSKENDAMINE',0),(115321,3204,'si','POSODOBITE INFORMACIJE O SPLOÅ NI KUPON',0),(115322,3204,'ba','MEMPERBARUI INFORMASI UMUM VOUCHER',0),(115323,3204,'nl','ALGEMENE VOUCHER INFORMATIE BIJWERKEN',0),(115324,3204,'fi','PÃ„IVITTÃ„Ã„ YLEISEN TOSITTEEN TIEDOT',0),(115325,3204,'no','OPPDATERE GENERELL BILAGSINFORMASJON',0),(115326,3204,'da','OPDATERE GENERELLE BILAGSOPLYSNINGER',0),(115327,3204,'ko','ì¼ë°˜ ì¿ í° ì •ë³´ ì—…ë°ì´íŠ¸',0),(115328,3204,'he','×œ×¢×“×›×Ÿ ××ª ×¤×¨×˜×™ ×”×©×•×‘×¨ ×›×œ×œ×™',0),(115329,3204,'el','Î•ÎÎ—ÎœÎˆÎ¡Î©Î£Î— ÎšÎŸÎ¥Î ÎŒÎÎ™ Î“Î•ÎÎ™ÎšÎˆÎ£ Î Î›Î—Î¡ÎŸÎ¦ÎŸÎ¡ÎŠÎ•Î£',0),(115330,3204,'zh','æ›´æ–°æ™®é€šå‡­å•ä¿¡æ¯\r\n',0),(115331,3204,'sv','UPPDATERA INFORMATION OM ALLMÃ„N VOUCHER',0),(115332,3204,'it','AGGIORNARE LE INFORMAZIONI GENERALI DI VOUCHER',0),(115333,3204,'tl','',0),(115334,3204,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3623;&#3652;&#3611;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(115335,3204,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤µà¤¾à¤‰à¤šà¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115336,3204,'ms','KEMAS KINI MAKLUMAT UMUM BAUCER',0),(115337,3204,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø© Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(115338,3204,'fr','METTRE Ã€ JOUR LES INFORMATIONS DE DOCUMENT GÃ‰NÃ‰RAL',0),(115339,3204,'jp','æ¨™æº–ä¼?ç¥¨æƒ…å ±ã‚’æ›´æ–°',0),(115340,3204,'pt','ATUALIZAR INFORMAÃ‡Ã•ES GERAIS VOUCHER',0),(115341,3204,'ru','ÐžÐ‘ÐÐžÐ’Ð›Ð•ÐÐ˜Ð• Ð˜ÐÐ¤ÐžÐ ÐœÐÐ¦Ð˜Ð˜ ÐžÐ‘Ð©Ð˜Ð• Ð’ÐÐ£Ð§Ð•Ð ',0),(115342,3204,'es','ACTUALIZAR INFORMACIÃ“N GENERAL DE VOUCHERS',0),(115343,3204,'de','ALLGEMEINE BELEGDATEN ZU AKTUALISIEREN',0),(115344,3204,'en','UPDATE GENERAL VOUCHER INFORMATION',0),(115345,3205,'is','',0),(115346,3205,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(115347,3205,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(115348,3205,'tr','GÃ¼ncelleÅŸtirme PO',0),(115349,3205,'pl','PO aktualizacji',0),(115350,3205,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° PO',0),(115351,3205,'ur','Ù¾Ùˆ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115352,3205,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐŸÐž',0),(115353,3205,'vi','Cáº­p Nháº­t ÄÆ¡n Mua HÃ ng',0),(115354,3205,'af','Opdateer AB',0),(115355,3205,'ro','Actualizare PO',0),(115356,3205,'et','Update PO',0),(115357,3205,'si','PO posodobitvi',0),(115358,3205,'ba','Memperbarui PO',0),(115359,3205,'nl','Update PO',0),(115360,3205,'fi','PÃ¤ivitÃ¤ PO',0),(115361,3205,'no','Oppdatere PO',0),(115362,3205,'da','Opdatering PO',0),(115363,3205,'ko','ì—…ë°ì´íŠ¸ í¬',0),(115364,3205,'he','×¢×“×›×•×Ÿ ×¤×•',0),(115365,3205,'el','PO ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(115366,3205,'zh','æ›´æ–°é‡‡è´­è®¢å•\r\n',0),(115367,3205,'sv','Uppdatera PO',0),(115368,3205,'it','Aggiornamento PO',0),(115369,3205,'tl','',0),(115370,3205,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;',0),(115371,3205,'hi','PO à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(115372,3205,'ms','Kemaskini Terakhir PO',0),(115373,3205,'ar','Øµ. Ø¨ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(115374,3205,'fr','Mise Ã  jour PO',0),(115375,3205,'jp','POã‚’æ›´æ–°',0),(115376,3205,'pt','PO de atualizaÃ§Ã£o',0),(115377,3205,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ PO',0),(115378,3205,'es','Actualizar OC',0),(115379,3205,'de','Update PO',0),(115380,3205,'en','Update PO',0),(115381,3206,'is','',0),(115382,3206,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‚Ø³Ù…Øª Ù‡Ø§ÙŠ Ø´ØºÙ„ Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(115383,3206,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‚Ø³Ù…Øª Ù‡Ø§ÙŠ Ø´ØºÙ„ Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(115384,3206,'tr','Ä°ÅŸ parÃ§alarÄ± iÃ§in fiyat listesi gÃ¼ncelleme',0),(115385,3206,'pl','Aktualizacja czÄ™Å›ci pracy z cennikiem',0),(115386,3206,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‡Ð°ÑÑ‚Ð¸ Ð·Ð° Ñ†ÐµÐ½Ð¾Ð²Ð°Ñ‚Ð° Ð»Ð¸ÑÑ‚Ð°',0),(115387,3206,'ur','Ø¬Ø§Ø¨ Ø­ØµÙˆÚº Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115388,3206,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾ÑÐ°Ð¾ ÑÐµÐ³Ð¼ÐµÐ½Ð°Ñ‚Ð° Ð·Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(115389,3206,'vi','Cáº­p Nháº­t Pháº§n Job Cho Biá»ƒu GiÃ¡',0),(115390,3206,'af','Bywerking werk dele vir die prys lys',0),(115391,3206,'ro','Actualizare Job piese pentru lista de preturi',0),(115392,3206,'et','Update tÃ¶Ã¶ osade hinnakiri',0),(115393,3206,'si','Posodobitev delo deli za cenik',0),(115394,3206,'ba','Bagian pekerjaan update untuk daftar harga',0),(115395,3206,'nl','Update baan delen voor de prijslijst',0),(115396,3206,'fi','PÃ¤ivitÃ¤ projektin osat hinnaston',0),(115397,3206,'no','Oppdatere jobb webdeler for prislisten',0),(115398,3206,'da','Opdatere Job dele til prislisten',0),(115399,3206,'ko','ê°€ê²© ë¦¬ìŠ¤íŠ¸ì— ëŒ€ í•œ ì—…ë°ì´íŠ¸ ìž‘ì—… ë¶€ë¶„',0),(115400,3206,'he','×¢×“×›×•×Ÿ ×—×œ×§×™ ×”×¢×‘×•×“×” ×¢×‘×•×¨ ×”×ž×—×™×¨×•×Ÿ',0),(115401,3206,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎµÎ¾Î±ÏÏ„Î®Î¼Î±Ï„Î± Î³Î¹Î± Ï„Î¿Î½ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(115402,3206,'zh','æ›´æ–°å·¥ä½œéƒ¨ä»¶ä»·ç›®è¡¨\r\n',0),(115403,3206,'sv','Uppdatera jobb delar fÃ¶r prislistan',0),(115404,3206,'it','Parti di lavoro di aggiornamento per il listino prezzi',0),(115405,3206,'tl','',0),(115406,3206,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3594;&#3636;&#3657;&#3609;&#3626;&#3656;&#3623;&#3609;&#3591;&#3634;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(115407,3206,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤­à¤¾à¤—à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115408,3206,'ms','Bahagian-bahagian kerja Kemaskini bagi senarai harga',0),(115409,3206,'ar','ØªØ­Ø¯ÙŠØ« Ø£Ø¬Ø²Ø§Ø¡ Ù…Ù‡Ù…Ø© Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(115410,3206,'fr','PiÃ¨ces de travail mise Ã  jour pour la liste de prix',0),(115411,3206,'jp','ä¾¡æ ¼è¡¨ã?®ä»•äº‹éƒ¨åˆ†ã?®æ›´æ–°',0),(115412,3206,'pt','PeÃ§as de trabalho de atualizaÃ§Ã£o para a lista de preÃ§o',0),(115413,3206,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ñ… Ñ‡Ð°ÑÑ‚ÐµÐ¹ Ð´Ð»Ñ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(115414,3206,'es','Actualizar Partes de Trabajo para la Lista de Precios',0),(115415,3206,'de','Update-Job-Teile fÃ¼r die Preisliste',0),(115416,3206,'en','Update Job Parts for the Price List',0),(115417,3207,'is','',0),(115418,3207,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„',0),(115419,3207,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„',0),(115420,3207,'tr','GÃ¼ncelleÅŸtirme konumu',0),(115421,3207,'pl','ZaktualizowaÄ‡ lokalizacjÄ™',0),(115422,3207,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(115423,3207,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115424,3207,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(115425,3207,'vi','Cáº­p Nháº­t Äá»‹a Äiá»ƒm',0),(115426,3207,'af','Opdateer Ligging',0),(115427,3207,'ro','Actualiza locaÅ£ia',0),(115428,3207,'et','VÃ¤rskenduse asukoht',0),(115429,3207,'si','Posodobitev mesta',0),(115430,3207,'ba','Memperbarui lokasi',0),(115431,3207,'nl','Locatie bijwerken',0),(115432,3207,'fi','PÃ¤ivityssijainti',0),(115433,3207,'no','Oppdatere',0),(115434,3207,'da','Opdater placering',0),(115435,3207,'ko','ì—…ë°ì´íŠ¸ ìœ„ì¹˜',0),(115436,3207,'he','×¢×“×›×Ÿ ×ž×™×§×•×',0),(115437,3207,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎ¿Ï…Î½ Ï„Î· Î¸Î­ÏƒÎ·',0),(115438,3207,'zh','æ›´æ–°ä½ç½®\r\n',0),(115439,3207,'sv','Uppdatera lÃ¤ge',0),(115440,3207,'it','Percorso di aggiornamento',0),(115441,3207,'tl','',0),(115442,3207,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(115443,3207,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥à¤¥à¤¾à¤¨',0),(115444,3207,'ms','Mengemaskini lokasi',0),(115445,3207,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(115446,3207,'fr','Emplacement de mise Ã  jour',0),(115447,3207,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(115448,3207,'pt','LocalizaÃ§Ã£o de atualizaÃ§Ã£o',0),(115449,3207,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(115450,3207,'es','Actualizar UbicaciÃ³n',0),(115451,3207,'de','Update-Speicherort',0),(115452,3207,'en','Update Location',0),(115453,3208,'is','',0),(115454,3208,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¹Ù…Ù„ÙŠØ§Øª',0),(115455,3208,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¹Ù…Ù„ÙŠØ§Øª',0),(115456,3208,'tr','GÃ¼ncelleÅŸtirme iÅŸlemi',0),(115457,3208,'pl','Aktualizowanie operacji',0),(115458,3208,'bg','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸ÑÑ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(115459,3208,'ur','Ø¹Ù…Ù„ÛŒÛ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115460,3208,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(115461,3208,'vi','Cáº­p nháº­t hoáº¡t Ä‘á»™ng',0),(115462,3208,'af','Bewerkbewerking',0),(115463,3208,'ro','OperaÅ£ia actualizare',0),(115464,3208,'et','VÃ¤rskendamistoiming',0),(115465,3208,'si','Postopka posodobitev',0),(115466,3208,'ba','Memperbarui operasi',0),(115467,3208,'nl','Updatebewerking',0),(115468,3208,'fi','PÃ¤ivitystoiminto',0),(115469,3208,'no','Oppdateringsoperasjonen',0),(115470,3208,'da','Update-handlingen',0),(115471,3208,'ko','ì—…ë°ì´íŠ¸ ìž‘ì—…',0),(115472,3208,'he','×¤×¢×•×œ×ª ×”×¢×“×›×•×Ÿ',0),(115473,3208,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚',0),(115474,3208,'zh','æ›´æ–°æ“ä½œ\r\n',0),(115475,3208,'sv','UppdateringsÃ¥tgÃ¤rd',0),(115476,3208,'it','Operazione di aggiornamento',0),(115477,3208,'tl','',0),(115478,3208,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(115479,3208,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(115480,3208,'ms','Operasi Kemaskini',0),(115481,3208,'ar','Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(115482,3208,'fr','Mise Ã  jour',0),(115483,3208,'jp','ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(115484,3208,'pt','OperaÃ§Ã£o de atualizaÃ§Ã£o',0),(115485,3208,'ru','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(115486,3208,'es','Actualizar OperaciÃ³n',0),(115487,3208,'de','Update-Operation',0),(115488,3208,'en','Update Operation',0),(115489,3209,'is','',0),(115490,3209,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¹Ù…Ù„ÙŠØ§Øª Ù‡Ø§',0),(115491,3209,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¹Ù…Ù„ÙŠØ§Øª Ù‡Ø§',0),(115492,3209,'tr','GÃ¼ncelleÅŸtirme iÅŸlemleri',0),(115493,3209,'pl','Aktualizowanie operacji',0),(115494,3209,'bg','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(115495,3209,'ur','Ú©Ø§Ø±Ø±ÙˆØ§Ø¦ÛŒÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115496,3209,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(115497,3209,'vi','Cáº­p nháº­t hoáº¡t Ä‘á»™ng',0),(115498,3209,'af','Bywerking bedrywighede',0),(115499,3209,'ro','OperaÅ£iunile de actualizare',0),(115500,3209,'et','Update operatsioonid',0),(115501,3209,'si','Operacij posodabljanja',0),(115502,3209,'ba','Memperbarui operasi',0),(115503,3209,'nl','Updatebewerkingen',0),(115504,3209,'fi','PÃ¤ivitÃ¤ toiminnot',0),(115505,3209,'no','Oppdateringsoperasjoner',0),(115506,3209,'da','Opdater operationer',0),(115507,3209,'ko','ì—…ë°ì´íŠ¸ ìž‘ì—…',0),(115508,3209,'he','×¤×¢×•×œ×•×ª ×¢×“×›×•×Ÿ',0),(115509,3209,'el','Î•Î½Î­ÏÎ³ÎµÎ¹ÎµÏ‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚',0),(115510,3209,'zh','æ›´æ–°æ“ä½œ\r\n',0),(115511,3209,'sv','Uppdatera operationer',0),(115512,3209,'it','Operazioni di aggiornamento',0),(115513,3209,'tl','',0),(115514,3209,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(115515,3209,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(115516,3209,'ms','Operasi Kemaskini',0),(115517,3209,'ar','Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(115518,3209,'fr','OpÃ©rations de mise Ã  jour',0),(115519,3209,'jp','ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(115520,3209,'pt','OperaÃ§Ãµes de atualizaÃ§Ã£o',0),(115521,3209,'ru','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(115522,3209,'es','Actualizar Operaciones',0),(115523,3209,'de','Update-Operationen',0),(115524,3209,'en','Update Operations',0),(115525,3210,'is','',0),(115526,3210,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(115527,3210,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(115528,3210,'tr','SipariÅŸini GÃ¼ncelleÅŸtir',0),(115529,3210,'pl','Aktualizacja zamÃ³wienia',0),(115530,3210,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(115531,3210,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115532,3210,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(115533,3210,'vi','Cáº­p Nháº­t ÄÆ¡n HÃ ng',0),(115534,3210,'af','Bestelling Opdateer',0),(115535,3210,'ro','Comanda de actualizare',0),(115536,3210,'et','Tootmistellimuse vÃ¤rskendamine',0),(115537,3210,'si','Modernizirati naloga',0),(115538,3210,'ba','Ubah urutan',0),(115539,3210,'nl','Bijwerken van volgorde',0),(115540,3210,'fi','PÃ¤ivitetÃ¤Ã¤n',0),(115541,3210,'no','Oppdatere rekkefÃ¸lge',0),(115542,3210,'da','Opdatere rÃ¦kkefÃ¸lge',0),(115543,3210,'ko','ì—…ë°ì´íŠ¸ ìˆœì„œ',0),(115544,3210,'he','×¢×“×›×•×Ÿ ×”×–×ž× ×”',0),(115545,3210,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(115546,3210,'zh','æ›´æ–°è®¢å•\r\n',0),(115547,3210,'sv','Uppdatera ordning',0),(115548,3210,'it','Ordine di aggiornamento',0),(115549,3210,'tl','',0),(115550,3210,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(115551,3210,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤†à¤¦à¥‡à¤¶',0),(115552,3210,'ms','Mengemaskini arahan',0),(115553,3210,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(115554,3210,'fr','Ordre de mise Ã  jour',0),(115555,3210,'jp','æ³¨æ–‡ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(115556,3210,'pt','Ordem de atualizaÃ§Ã£o',0),(115557,3210,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·',0),(115558,3210,'es','Actualizar Orden',0),(115559,3210,'de','Update-Bestellung',0),(115560,3210,'en','Update Order',0),(115561,3211,'is','',0),(115562,3211,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(115563,3211,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(115564,3211,'tr','GÃ¼ncelleÅŸtirme PO',0),(115565,3211,'pl','PO aktualizacji',0),(115566,3211,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° PO',0),(115567,3211,'ur','Ù¾Ùˆ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115568,3211,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐŸÐž',0),(115569,3211,'vi','Cáº­p Nháº­t ÄÆ¡n Mua HÃ ng',0),(115570,3211,'af','Opdateer AB',0),(115571,3211,'ro','Actualizare PO',0),(115572,3211,'et','Update PO',0),(115573,3211,'si','PO posodobitvi',0),(115574,3211,'ba','Memperbarui PO',0),(115575,3211,'nl','Update PO',0),(115576,3211,'fi','PÃ¤ivitÃ¤ PO',0),(115577,3211,'no','Oppdatere PO',0),(115578,3211,'da','Opdatering PO',0),(115579,3211,'ko','ì—…ë°ì´íŠ¸ í¬',0),(115580,3211,'he','×¢×“×›×•×Ÿ ×¤×•',0),(115581,3211,'el','PO ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(115582,3211,'zh','æ›´æ–°é‡‡è´­è®¢å•\r\n',0),(115583,3211,'sv','Uppdatera PO',0),(115584,3211,'it','Aggiornamento PO',0),(115585,3211,'tl','',0),(115586,3211,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;',0),(115587,3211,'hi','PO à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(115588,3211,'ms','Kemaskini Terakhir PO',0),(115589,3211,'ar','Øµ. Ø¨ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(115590,3211,'fr','Mise Ã  jour PO',0),(115591,3211,'jp','POã‚’æ›´æ–°',0),(115592,3211,'pt','PO de atualizaÃ§Ã£o',0),(115593,3211,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ PO',0),(115594,3211,'es','Actualizar OC',0),(115595,3211,'de','Update PO',0),(115596,3211,'en','Update PO',0),(115597,3212,'is','',0),(115598,3212,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(115599,3212,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(115600,3212,'tr','P0 ayrÄ±ntÄ±larÄ±nÄ± gÃ¼ncelleÅŸtirmek',0),(115601,3212,'pl','Informacje na temat aktualizacji P0',0),(115602,3212,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ P0 Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(115603,3212,'ur','P0 Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115604,3212,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð´ÐµÑ‚Ð°Ñ™Ðµ ÐŸ0',0),(115605,3212,'vi','Cáº­p Nháº­t Chi Tiáº¿t ÄÆ¡n Mua HÃ ng',0),(115606,3212,'af','Opdateer AB Besonderhede',0),(115607,3212,'ro','Actualizare P0 detalii',0),(115608,3212,'et','P0 VÃ¤rskendusteave',0),(115609,3212,'si','Posodobitev P0 podrobnosti',0),(115610,3212,'ba','Memperbarui rincian P0',0),(115611,3212,'nl','Update P0 Details',0),(115612,3212,'fi','P0 tiedot',0),(115613,3212,'no','P0 detaljer',0),(115614,3212,'da','Opdatere P0 detaljer',0),(115615,3212,'ko','P0 ì •ë³´ ì—…ë°ì´íŠ¸',0),(115616,3212,'he','×¢×“×›×•×Ÿ ×¤×¨×˜×™× P0',0),(115617,3212,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ P0',0),(115618,3212,'zh','æ›´æ–°é‡‡è´­è®¢å•è¯¦æƒ…\r\n',0),(115619,3212,'sv','Uppdatera P0 Detaljer',0),(115620,3212,'it','Aggiornamento dettagli P0',0),(115621,3212,'tl','',0),(115622,3212,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;',0),(115623,3212,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ P0 à¤µà¤¿à¤µà¤°à¤£',0),(115624,3212,'ms','Butir-butir P0 Kemaskini',0),(115625,3212,'ar','ØªØ­Ø¯ÙŠØ« ØªÙØ§ØµÙŠÙ„ P0',0),(115626,3212,'fr','Mise Ã  jour P0 dÃ©tails',0),(115627,3212,'jp','POè©³ç´°ã‚’æ›´æ–°',0),(115628,3212,'pt','Detalhes de atualizaÃ§Ã£o P0',0),(115629,3212,'ru','Ð¡Ð²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾Ð± Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ P0',0),(115630,3212,'es','Actualizar Deatlles de OC',0),(115631,3212,'de','Update-P0-Details',0),(115632,3212,'en','Update P0 Details',0),(115633,3213,'is','',0),(115634,3213,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø¯ÙˆÙ„ Ù‚ÙŠÙ…Øª Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(115635,3213,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø¯ÙˆÙ„ Ù‚ÙŠÙ…Øª Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(115636,3213,'tr','FiyatÄ± tablosunu gÃ¼ncelleÅŸtirmek iÃ§in fiyat listesi',0),(115637,3213,'pl','Aktualizacja tabeli cena Cennik',0),(115638,3213,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð° \"Ñ†ÐµÐ½Ð°\" Ð·Ð° Ñ†ÐµÐ½Ð¾Ð²Ð°Ñ‚Ð° Ð»Ð¸ÑÑ‚Ð°',0),(115639,3213,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„Ø¦Û’ Ù‚ÛŒÙ…Øª Ø¬Ø¯ÙˆÙ„ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115640,3213,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ†ÐµÐ½Ð° Ñ‚Ð°Ð±ÐµÐ»Ðµ Ð·Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(115641,3213,'vi','Cáº­p Nháº­t Biá»ƒu GiÃ¡ Cho Báº£ng giÃ¡',0),(115642,3213,'af','Opdateer Prystabel vir die Pryslys',0),(115643,3213,'ro','Actualizare Pret masa pentru lista de preturi',0),(115644,3213,'et','Hinnakirja hind tabelist',0),(115645,3213,'si','Posodobitev cenik za cenik',0),(115646,3213,'ba','Memperbarui tabel harga untuk daftar harga',0),(115647,3213,'nl','Update Prijstabel voor de prijslijst',0),(115648,3213,'fi','PÃ¤ivitys taulukossa hinnasto',0),(115649,3213,'no','Oppdatere pris for prislisten',0),(115650,3213,'da','Opdatere pris tabel for prislisten',0),(115651,3213,'ko','ê°€ê²© ë¦¬ìŠ¤íŠ¸ì— ëŒ€ í•œ ì—…ë°ì´íŠ¸ ê°€ê²© í…Œì´ë¸”',0),(115652,3213,'he','×¢×“×›×•×Ÿ ×ž×—×™×¨ ×˜×‘×œ×” ×¢×‘×•×¨ ×”×ž×—×™×¨×•×Ÿ',0),(115653,3213,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î¯Î½Î±ÎºÎ± Ï„Î¹Î¼ÏŽÎ½ Î³Î¹Î± Ï„Î¿Î½ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(115654,3213,'zh','æ›´æ–°ä»·æ ¼è¡¨çš„ä»·æ ¼åˆ—è¡¨\r\n',0),(115655,3213,'sv','Uppdatera pris bordet fÃ¶r prislistan',0),(115656,3213,'it','Aggiornare la tabella dei prezzi per il listino prezzi',0),(115657,3213,'tl','',0),(115658,3213,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(115659,3213,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115660,3213,'ms','Kemaskini Jadual harga untuk senarai harga',0),(115661,3213,'ar','ØªØ­Ø¯ÙŠØ« Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(115662,3213,'fr','Tableau des prix mise Ã  jour pour la liste de prix',0),(115663,3213,'jp','ä¾¡æ ¼ãƒªã‚¹ãƒˆã?®ä¾¡æ ¼è¡¨ã‚’æ›´æ–°',0),(115664,3213,'pt','Tabela de preÃ§o de atualizaÃ§Ã£o para a lista de preÃ§o',0),(115665,3213,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ñ†ÐµÐ½ Ð½Ð° Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(115666,3213,'es','Actualizar Tabla de Precios para la lista de Precios',0),(115667,3213,'de','Update-Preis-Tabelle fÃ¼r die Preisliste',0),(115668,3213,'en','Update Price Table for the Price List',0),(115669,3214,'is','',0),(115670,3214,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§ØµÙ„Ø§Ø­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(115671,3214,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§ØµÙ„Ø§Ø­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(115672,3214,'tr','Teklif gÃ¶zden geÃ§irme gÃ¼ncelleÅŸtirme',0),(115673,3214,'pl','Aktualizacja oferty zmiany',0),(115674,3214,'bg','Update Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ',0),(115675,3214,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115676,3214,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ñƒ',0),(115677,3214,'vi','Cáº­p Nháº­t Chá»‰nh Sá»­a BÃ¡o GiÃ¡',0),(115678,3214,'af','Bywerking aanhaling hersiening',0),(115679,3214,'ro','Actualizare citat revizuire',0),(115680,3214,'et','Update tsiteerida redaktsioon',0),(115681,3214,'si','Revizija posodobitve ponudbe',0),(115682,3214,'ba','Memperbarui kutipan revisi',0),(115683,3214,'nl','Bijwerken offerte herziening',0),(115684,3214,'fi','PÃ¤ivitÃ¤ tarjouspyynnÃ¶n tarkistaminen',0),(115685,3214,'no','Oppdatere tilbud revisjon',0),(115686,3214,'da','Opdatere tilbud revision',0),(115687,3214,'ko','ê²¬ì  ìˆ˜ì • ì—…ë°ì´íŠ¸',0),(115688,3214,'he','×¢×“×›×•×Ÿ ×”×¦×¢×ª ×ª×™×§×•×Ÿ',0),(115689,3214,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(115690,3214,'zh','æ›´æ–°æŠ¥ä»·ä¿®è®¢\r\n',0),(115691,3214,'sv','Uppdatera citat Ã¶versyn',0),(115692,3214,'it','Revisione di aggiornamento preventivo',0),(115693,3214,'tl','',0),(115694,3214,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3610;&#3623;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(115695,3214,'hi','à¤¬à¥‹à¤²à¥€ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115696,3214,'ms','Kemaskini Terakhir semakan tarif',0),(115697,3214,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³',0),(115698,3214,'fr','Mise Ã  jour de la rÃ©vision de la citation',0),(115699,3214,'jp','è¦‹ç©?ã?®ä¿®æ­£ã‚’æ›´æ–°',0),(115700,3214,'pt','RevisÃ£o de citaÃ§Ã£o de atualizaÃ§Ã£o',0),(115701,3214,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° Ñ€ÐµÐ´Ð°ÐºÑ†Ð¸Ñ',0),(115702,3214,'es','Actualizar revisiÃ³n de cotizaciÃ³n',0),(115703,3214,'de','Aktualisierte Angebot revision',0),(115704,3214,'en','Update quote revision',0),(115705,3215,'is','',0),(115706,3215,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(115707,3215,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(115708,3215,'tr','GÃ¼ncelleÅŸtirme seÃ§imleri',0),(115709,3215,'pl','Opcje aktualizacji',0),(115710,3215,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐµÐ»ÐµÐºÑ†Ð¸ÑÑ‚Ð°',0),(115711,3215,'ur','Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115712,3215,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(115713,3215,'vi','Cáº­p Nháº­t lá»±a chá»n',0),(115714,3215,'af','Opdateer Seleksies',0),(115715,3215,'ro','SelecÅ£iile de actualizare',0),(115716,3215,'et','Uuenda valituid',0),(115717,3215,'si','Posodobitev izbire',0),(115718,3215,'ba','Memperbarui pilihan',0),(115719,3215,'nl','Update selecties',0),(115720,3215,'fi','PÃ¤ivitys valinnat',0),(115721,3215,'no','Oppdatere valg',0),(115722,3215,'da','Opdatere valg',0),(115723,3215,'ko','ì—…ë°ì´íŠ¸ ì„ íƒ',0),(115724,3215,'he','×¢×“×›×Ÿ ×‘×—×™×¨×•×ª',0),(115725,3215,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(115726,3215,'zh','æ›´æ–°é€‰é¡¹\r\n',0),(115727,3215,'sv','Uppdatera markering',0),(115728,3215,'it','Aggiornamento selezioni',0),(115729,3215,'tl','',0),(115730,3215,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(115731,3215,'hi','à¤šà¤¯à¤¨ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115732,3215,'ms','Pengemaskinian pilihan',0),(115733,3215,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ØªØ­Ø¯ÙŠØ¯Ø§Øª',0),(115734,3215,'fr','Mise Ã  jour de sÃ©lections',0),(115735,3215,'jp','ã‚»ãƒ¬ã‚¯ã‚·ãƒ§ãƒ³ã?®æ›´æ–°',0),(115736,3215,'pt','AtualizaÃ§Ã£o seleÃ§Ãµes',0),(115737,3215,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð±Ð¾Ñ€',0),(115738,3215,'es','Actualizar selecciones',0),(115739,3215,'de','Update-Auswahl',0),(115740,3215,'en','Update selections',0),(115741,3216,'is','',0),(115742,3216,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù…Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ ',0),(115743,3216,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù…Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ ',0),(115744,3216,'tr','GÃ¼ncelleÅŸtirme sevk adresleri',0),(115745,3216,'pl','Statek aktualizacja adresÃ³w',0),(115746,3216,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð± Ð·Ð° Ð°Ð´Ñ€ÐµÑÐ¸',0),(115747,3216,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ù„Ø¦Û’ Ù¾ØªÛ’ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115748,3216,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð±Ñ€Ð¾Ð´ Ð½Ð° Ð°Ð´Ñ€ÐµÑÐµ',0),(115749,3216,'vi','Cáº­p Nháº­t Äá»‹a Chá»‰ Nháº­n HÃ ng',0),(115750,3216,'af','Versend Aan Adresse Opdateer',0),(115751,3216,'ro','Actualizare navei la adrese',0),(115752,3216,'et','VÃ¤rskenda tarneaadressi',0),(115753,3216,'si','Posodobitev ladje za naslove',0),(115754,3216,'ba','Update kapal ke alamat',0),(115755,3216,'nl','Update verzenden naar adressen',0),(115756,3216,'fi','PÃ¤ivittÃ¤Ã¤ aluksen osoitteet',0),(115757,3216,'no','Oppdater lever til-adresser',0),(115758,3216,'da','Opdatere skib til adresser',0),(115759,3216,'ko','ì£¼ì†Œë¥¼ ì—…ë°ì´íŠ¸ í•¨',0),(115760,3216,'he','×¢×“×›×•×Ÿ ×œ×ž×©×œ×•×—',0),(115761,3216,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î»Î¿Î¯Î¿ ÏƒÎµ Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚',0),(115762,3216,'zh','æ›´æ–°æ”¶è´§åœ°å€\r\n',0),(115763,3216,'sv','Uppdatera fartyget till adresser',0),(115764,3216,'it','Aggiornamento nave agli indirizzi',0),(115765,3216,'tl','',0),(115766,3216,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(115767,3216,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¤à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115768,3216,'ms','Kapal Kemaskini alamat',0),(115769,3216,'ar','ØªØ­Ø¯Ø¨Ø« Ø¹Ù†Ø§ÙˆÙŠÙ† Ø§Ù„Ø´Ø­Ù†',0),(115770,3216,'fr','Navire de mise Ã  jour d\'adresses',0),(115771,3216,'jp','é…?é€?å…ˆä½?æ‰€ã?®æ›´æ–°',0),(115772,3216,'pt','Navio de atualizaÃ§Ã£o de endereÃ§os',0),(115773,3216,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿Ð¾ Ð°Ð´Ñ€ÐµÑÐ°Ð¼',0),(115774,3216,'es','Actualizar Dirreciones de Enviar A',0),(115775,3216,'de','Schiff-Adressen aktualisieren',0),(115776,3216,'en','Update Ship To Addresses',0),(115777,3217,'is','',0),(115778,3217,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø±Ù†Ú¯Ù‡Ø§',0),(115779,3217,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø±Ù†Ú¯Ù‡Ø§',0),(115780,3217,'tr','GÃ¼ncelleÅŸtirme stok renkler',0),(115781,3217,'pl','Aktualizacja pieÅ„ kolory',0),(115782,3217,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(115783,3217,'ur','Ø§Ø³Ù¹Ø§Ú© Ø±Ù†Ú¯ÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115784,3217,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð±Ð¾Ñ˜Ðµ',0),(115785,3217,'vi','Cáº­p Nháº­t máº§u tá»“n kho',0),(115786,3217,'af','Opdateer Voorraad Kleure',0),(115787,3217,'ro','Actualizare stoc culori',0),(115788,3217,'et','VÃ¤rskenda vÃ¤rve',0),(115789,3217,'si','Posodobitve osnovne barve',0),(115790,3217,'ba','Memperbarui stok warna',0),(115791,3217,'nl','Update voorraad kleuren',0),(115792,3217,'fi','PÃ¤ivitÃ¤ varastossa vÃ¤rit',0),(115793,3217,'no','Oppdateringen lager farger',0),(115794,3217,'da','Opdatere Stock farver',0),(115795,3217,'ko','ìž¬ê³  ìƒ‰ìƒ ì—…ë°ì´íŠ¸',0),(115796,3217,'he','×¢×“×›×•×Ÿ ×ž×œ××™ ×¦×‘×¢×™×',0),(115797,3217,'el','Î‘Î½Î±Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÏŽÎ¼Î±Ï„Î±',0),(115798,3217,'zh','æ›´æ–°åº“å­˜é¢œè‰²\r\n',0),(115799,3217,'sv','Uppdatera lager fÃ¤rger',0),(115800,3217,'it','Aggiornamento magazzino colori',0),(115801,3217,'tl','',0),(115802,3217,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3637;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(115803,3217,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤°à¤‚à¤— à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(115804,3217,'ms','Kemaskini stok warna',0),(115805,3217,'ar','ØªØ­Ø¯ÙŠØ« Ø£Ù„ÙˆØ§Ù† Ø§Ù„Ø£Ø³Ù‡Ù…',0),(115806,3217,'fr','Mise Ã  jour Stock couleurs',0),(115807,3217,'jp','åœ¨åº«è‰²ã?®æ›´æ–°',0),(115808,3217,'pt','Atualizar estoque cores',0),(115809,3217,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ñ†Ð²ÐµÑ‚Ð¾Ð²',0),(115810,3217,'es','Actualizar Colores de Stock',0),(115811,3217,'de','Update hat Farben',0),(115812,3217,'en','Update Stock Colors',0),(115813,3218,'is','',0),(115814,3218,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù‚Ø³Ù…Øª',0),(115815,3218,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù‚Ø³Ù…Øª',0),(115816,3218,'tr','Bu bÃ¶lÃ¼mÃ¼ iÃ§in gÃ¼ncelleÅŸtirme stok listesi',0),(115817,3218,'pl','Aktualizacja listy czas dla tej czÄ™Å›ci',0),(115818,3218,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð½Ð° ÑÐºÐ»Ð°Ð´ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ‡Ð°ÑÑ‚',0),(115819,3218,'ur','Ø§Ø³ Ø­ØµÛ’ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³Ù¹Ø§Ú© Ú©ÛŒ ÙÛØ±Ø³Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115820,3218,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð»Ð°Ð³ÐµÑ€ Ð»Ð¸ÑÑ‚Ð° Ð·Ð° Ð¾Ð²Ñƒ ÑƒÐ»Ð¾Ð³Ñƒ',0),(115821,3218,'vi','Cáº­p Nháº­t Danh SÃ¡ch HÃ ng Tá»“n Kho Cho Pháº§n NÃ y',0),(115822,3218,'af','Opdateer Voorraadlys vir hierdie Onderdeel',0),(115823,3218,'ro','ActualizeazÄƒ lista de stoc pentru aceastÄƒ parte',0),(115824,3218,'et','Update varude nimekirja selles osas',0),(115825,3218,'si','Posodobi seznam zalog za ta del',0),(115826,3218,'ba','Memperbarui daftar saham untuk bagian ini',0),(115827,3218,'nl','Stock lijst bijwerken voor dit deel',0),(115828,3218,'fi','PÃ¤ivitÃ¤ kalusto luettelon tÃ¤mÃ¤n osan',0),(115829,3218,'no','Lager oppdateringslisten for denne delen',0),(115830,3218,'da','Opdatere bestand liste for denne del',0),(115831,3218,'ko','ì´ ë¶€ë¶„ì— ëŒ€ í•œ ìž¬ê³  ëª©ë¡ ì—…ë°ì´íŠ¸',0),(115832,3218,'he','×¢×“×›×Ÿ ×¨×©×™×ž×ª ×”×ž× ×™×•×ª ×œ×—×œ×§ ×”×–×”',0),(115833,3218,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î­ÏÎ¿Ï‚',0),(115834,3218,'zh','æ›´æ–°æœ¬éƒ¨çš„åº“å­˜åˆ—è¡¨\r\n',0),(115835,3218,'sv','Uppdatera aktielista fÃ¶r denna del',0),(115836,3218,'it','Aggiornamento lista dello Stock per questa parte',0),(115837,3218,'tl','',0),(115838,3218,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;&#3586;&#3629;&#3591;&#3626;&#3656;&#3623;&#3609;&#3609;&#3637;&#3657;',0),(115839,3218,'hi','à¤‡à¤¸ à¤­à¤¾à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115840,3218,'ms','Mengemaskini senarai saham untuk bahagian ini',0),(115841,3218,'ar','ØªØ­Ø¯ÙŠØ« \"Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ù‡Ù…\" Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¬Ø²Ø¡',0),(115842,3218,'fr','Liste mise Ã  jour du Stock pour cette partie',0),(115843,3218,'jp','ã?“ã?®éƒ¨å“?ã?®åœ¨åº«ãƒªã‚¹ãƒˆã‚’æ›´æ–°',0),(115844,3218,'pt','Atualizar a lista de aÃ§Ãµes para esta parte',0),(115845,3218,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ñ‡Ð°ÑÑ‚Ð¸',0),(115846,3218,'es','Actualizar Lista de Stock para esta Parte',0),(115847,3218,'de','Lagerliste fÃ¼r diesen Teil zu aktualisieren',0),(115848,3218,'en','Update Stock List for this Part',0),(115849,3219,'is','',0),(115850,3219,'dr','/ Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù‚Ø³Ù…Øª',0),(115851,3219,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± / Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù‚Ø³Ù…Øª',0),(115852,3219,'tr','Bu bÃ¶lÃ¼mÃ¼ iÃ§in stok/baskÄ± listesini gÃ¼ncelleÅŸtirme',0),(115853,3219,'pl','Aktualizacja listy drukowania fotografii w tej czÄ™Å›ci',0),(115854,3219,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð½Ð° ÑÐºÐ»Ð°Ð´/Ð¿ÐµÑ‡Ð°Ñ‚ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ‡Ð°ÑÑ‚',0),(115855,3219,'ur','Ø§Ø³ Ø­ØµÛ’ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³Ù¹Ø§Ú©/Ú†Ú¾Ø§Ù¾ÛŒÚº ÙÛØ±Ø³Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115856,3219,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°/Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð·Ð° Ð¾Ð²Ñƒ ÑƒÐ»Ð¾Ð³Ñƒ',0),(115857,3219,'vi','Cáº­p Nháº­t HÃ ng Tá»“n Kho/Danh SÃ¡ch In Cho Pháº§n NÃ y',0),(115858,3219,'af','Opdateer Voorraad/Druk Lys vir hierdie Onderdeel',0),(115859,3219,'ro','Actualizare stoc/imprimare listÄƒ pentru aceastÄƒ parte',0),(115860,3219,'et','Aktsia/Prindi nimekirja ajakohastamise selles osas',0),(115861,3219,'si','Stock/Natisni seznam posodobitev za ta del',0),(115862,3219,'ba','Memperbarui daftar saham cetak untuk bagian ini',0),(115863,3219,'nl','Lijst van de voorraad/afdrukken van de update voor dit deel',0),(115864,3219,'fi','PÃ¤ivitÃ¤ kalusto/Tulosta luettelo tÃ¤mÃ¤n osan',0),(115865,3219,'no','Oppdateringen lager/Skriv ut-listen for denne delen',0),(115866,3219,'da','Opdatere materiel/Udskriv liste for denne del',0),(115867,3219,'ko','ì´ ë¶€ë¶„ì— ëŒ€ í•œ ìž¬ê³ /ì¸ì‡„ ëª©ë¡ ì—…ë°ì´íŠ¸',0),(115868,3219,'he','×¢×“×›×Ÿ ×¨×©×™×ž×ª ×ž×œ××™/×”×“×¤×¡×” ×œ×ª×¤×§×™×“ ×”×–×”',0),(115869,3219,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€ÏŒÎ¸ÎµÎ¼Î±/ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î­ÏÎ¿Ï‚',0),(115870,3219,'zh','æ›´æ–°åº“å­˜/æ‰“å°æœ¬éƒ¨ç›®å½•\r\n',0),(115871,3219,'sv','Uppdatera lager/Skriv ut lista fÃ¶r denna del',0),(115872,3219,'it','Aggiornamento magazzino/stampa elenco per questa parte',0),(115873,3219,'tl','',0),(115874,3219,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3605;&#3655;&#3629;&#3585;/&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3609;&#3637;&#3657;',0),(115875,3219,'hi','à¤‡à¤¸ à¤­à¤¾à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤Ÿà¥‰à¤•/à¤®à¥à¤¦à¥à¤°à¤£ à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115876,3219,'ms','Mengemaskini stok/cetakan senarai bagi bahagian ini',0),(115877,3219,'ar','ØªØ­Ø¯ÙŠØ« \"Ù‚Ø§Ø¦Ù…Ø©\" Ø§Ù„Ø£Ø³Ù‡Ù…/Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¬Ø²Ø¡',0),(115878,3219,'fr','Mise Ã  jour Stock/imprimer la liste pour cette partie',0),(115879,3219,'jp','åœ¨åº«ã?®æ›´æ–°/ã?“ã?®éƒ¨å“?ã?®ãƒªã‚¹ãƒˆã‚’å?°åˆ·',0),(115880,3219,'pt','Atualizar lista de Stock/impressÃ£o para esta parte',0),(115881,3219,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ñ‡Ð°ÑÑ‚Ð¸',0),(115882,3219,'es','Actualizar Lista de Stock/Imprimir para esta Parte',0),(115883,3219,'de','Lager, Druck-Updateliste fÃ¼r diesen Teil',0),(115884,3219,'en','Update Stock/Print List for this Part',0),(115885,3220,'is','',0),(115886,3220,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†Ø¨Ø§Ø±Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(115887,3220,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†Ø¨Ø§Ø±Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(115888,3220,'tr','Hisse senetleri iÃ§in fiyat listesi gÃ¼ncelleme',0),(115889,3220,'pl','Aktualizacja zasobÃ³w z cennikiem',0),(115890,3220,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ Ð·Ð° Ñ†ÐµÐ½Ð¾Ð²Ð°Ñ‚Ð° Ð»Ð¸ÑÑ‚Ð°',0),(115891,3220,'ur','Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ù„Ø¦Û’ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115892,3220,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð´Ð¸Ð¾Ð½Ð¸Ñ†Ðµ Ð·Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(115893,3220,'vi','Cáº­p Nháº­t HÃ ng Tá»“n Kho Cho Báº£ng GiÃ¡',0),(115894,3220,'af','Opdateer Voorraad vir die Pryslys',0),(115895,3220,'ro','Actualizare stocuri pentru lista de preturi',0),(115896,3220,'et','Muudetud kalavarude hinnakirja',0),(115897,3220,'si','Posodobitev zalog za cenik',0),(115898,3220,'ba','Pembaruan saham untuk daftar harga',0),(115899,3220,'nl','Update voorraden voor de prijslijst',0),(115900,3220,'fi','PÃ¤ivitÃ¤ varastot hinnaston',0),(115901,3220,'no','Oppdatere aksjer for prislisten',0),(115902,3220,'da','Opdatere bestande til prislisten',0),(115903,3220,'ko','ì£¼ì‹ ê°€ê²© ë¦¬ìŠ¤íŠ¸ì— ëŒ€ í•œ ì—…ë°ì´íŠ¸',0),(115904,3220,'he','×¢×“×›×•×Ÿ ×”×ž×œ××™ ×¢×‘×•×¨ ×”×ž×—×™×¨×•×Ÿ',0),(115905,3220,'el','Î‘Ï€Î¿Î¸Î­Î¼Î±Ï„Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³Î¹Î± Ï„Î¿Î½ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(115906,3220,'zh','æ›´æ–°ä»·æ ¼åˆ—è¡¨çš„åº“å­˜\r\n',0),(115907,3220,'sv','Uppdatera bestÃ¥nd fÃ¶r prislistan',0),(115908,3220,'it','Aggiornare le scorte per il listino prezzi',0),(115909,3220,'tl','',0),(115910,3220,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(115911,3220,'hi','à¤¶à¥‡à¤¯à¤°à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115912,3220,'ms','Kemaskini stok untuk senarai harga',0),(115913,3220,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£Ø±ØµØ¯Ø© Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(115914,3220,'fr','Mise Ã  jour des Stocks pour la liste de prix',0),(115915,3220,'jp','ã?“ã?®ä¾¡æ ¼ãƒªã‚¹ãƒˆã?®åœ¨åº«ã‚’æ›´æ–°',0),(115916,3220,'pt','AÃ§Ãµes de atualizaÃ§Ã£o para a lista de preÃ§o',0),(115917,3220,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð´Ð»Ñ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(115918,3220,'es','Actualizar Stocks para la Lista de Precios',0),(115919,3220,'de','BestÃ¤nde fÃ¼r die Preisliste aktualisieren',0),(115920,3220,'en','Update Stocks for the Price List',0),(115921,3221,'is','',0),(115922,3221,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(115923,3221,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(115924,3221,'tr','GÃ¼ncelleÅŸtirme baÅŸarÄ±lÄ±',0),(115925,3221,'pl','Aktualizacja sukces',0),(115926,3221,'bg','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(115927,3221,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨',0),(115928,3221,'sr','Ð˜ÑÐ¿Ñ€Ð°Ð²ÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(115929,3221,'vi','Cáº­p Nháº­t thÃ nh cÃ´ng',0),(115930,3221,'af','Opdatering suksesvol',0),(115931,3221,'ro','Actualizare de succes',0),(115932,3221,'et','Uuendamine Ãµnnestus',0),(115933,3221,'si','Posodobitev uspeÅ¡no',0),(115934,3221,'ba','Update berhasil',0),(115935,3221,'nl','Update succesvol',0),(115936,3221,'fi','PÃ¤ivitys onnistui',0),(115937,3221,'no','Vellykket oppdatering',0),(115938,3221,'da','Update vellykket',0),(115939,3221,'ko','ì„±ê³µì ì¸ ì—…ë°ì´íŠ¸',0),(115940,3221,'he','×¢×“×›×•×Ÿ ×ž×•×¦×œ×—',0),(115941,3221,'el','Î•Ï€Î¹Ï„Ï…Ï‡Î®Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(115942,3221,'zh','æ›´æ–°æˆåŠŸ\r\n',0),(115943,3221,'sv','Uppdatera framgÃ¥ngsrik',0),(115944,3221,'it','Aggiornamento riuscito',0),(115945,3221,'tl','',0),(115946,3221,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(115947,3221,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤«à¤²',0),(115948,3221,'ms','Kemaskini',0),(115949,3221,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ« Ù†Ø§Ø¬Ø­',0),(115950,3221,'fr','Mise Ã  jour rÃ©ussie',0),(115951,3221,'jp','æ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(115952,3221,'pt','ActualizaÃ§Ã£o bem sucedida',0),(115953,3221,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾',0),(115954,3221,'es','ActualizaciÃ³n exitosa',0),(115955,3221,'de','Update erfolgreich',0),(115956,3221,'en','Update successful',0),(115957,3222,'is','',0),(115958,3222,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø¯ÙˆÙ„',0),(115959,3222,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø¯ÙˆÙ„',0),(115960,3222,'tr','Tabloyu gÃ¼ncelleÅŸtir',0),(115961,3222,'pl','Aktualizacja tabeli',0),(115962,3222,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(115963,3222,'ur','Ø¬Ø¯ÙˆÙ„ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(115964,3222,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ð¸ Ñ‚Ð°Ð±ÐµÐ»Ñƒ',0),(115965,3222,'vi','Báº£ng Cáº­p Nháº­t',0),(115966,3222,'af','Opdateer Tabel',0),(115967,3222,'ro','Tabelul de actualizare',0),(115968,3222,'et','VÃ¤rskenda tabelit',0),(115969,3222,'si','Posodobi kazalo',0),(115970,3222,'ba','Memperbarui tabel',0),(115971,3222,'nl','Tabel bijwerken',0),(115972,3222,'fi','PÃ¤ivitystaulu',0),(115973,3222,'no','Oppdater tabell',0),(115974,3222,'da','Opdater tabel',0),(115975,3222,'ko','í…Œì´ë¸” ì—…ë°ì´íŠ¸',0),(115976,3222,'he','×¢×“×›×Ÿ ×˜×‘×œ×”',0),(115977,3222,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î¯Î½Î±ÎºÎ±',0),(115978,3222,'zh','æ›´æ–°è¡¨\r\n',0),(115979,3222,'sv','Uppdateringsregister',0),(115980,3222,'it','Aggiornamento tabella',0),(115981,3222,'tl','',0),(115982,3222,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;',0),(115983,3222,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(115984,3222,'ms','Kemaskini Jadual',0),(115985,3222,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(115986,3222,'fr','Mise Ã  jour de Table',0),(115987,3222,'jp','è¡¨ã?®æ›´æ–°',0),(115988,3222,'pt','AtualizaÃ§Ã£o da tabela',0),(115989,3222,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñƒ',0),(115990,3222,'es','Actualizar Tabla',0),(115991,3222,'de','Aktualisierungstabelle',0),(115992,3222,'en','Update Table',0),(115993,3223,'is','',0),(115994,3223,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ',0),(115995,3223,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ',0),(115996,3223,'tr','Vergi tablolarÄ± gÃ¼ncelleÅŸtirmek',0),(115997,3223,'pl','Aktualizowanie tabel podatku',0),(115998,3223,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð¸ Ð·Ð° Ð´Ð°Ð½ÑŠÐº Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(115999,3223,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù…ÛŒØ²ÛŒÚº Ú©Ùˆ Ø§Ù¾ ÚˆÛŒÙ¹',0),(116000,3223,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ð°Ð±ÐµÐ»Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð°',0),(116001,3223,'vi','Cáº­p Nháº­t Báº£ng Thuáº¿',0),(116002,3223,'af','Opdateer belastingtabelle',0),(116003,3223,'ro','Tabele de impozit actualizare',0),(116004,3223,'et','VÃ¤rskenduse maksudest tabelid',0),(116005,3223,'si','Posodobitev davka tabel',0),(116006,3223,'ba','Memperbarui tabel pajak',0),(116007,3223,'nl','Fiscale tabellen bijwerken',0),(116008,3223,'fi','PÃ¤ivitÃ¤ vero',0),(116009,3223,'no','Oppdatere skattetabeller',0),(116010,3223,'da','Opdatere tax-tabeller',0),(116011,3223,'ko','ì„¸ê¸ˆ í…Œì´ë¸” ì—…ë°ì´íŠ¸',0),(116012,3223,'he','×¢×“×›×•×Ÿ ×˜×‘×œ××•×ª ×ž×¡',0),(116013,3223,'el','Î Î¯Î½Î±ÎºÎµÏ‚ Ï†ÏŒÏÎ¿Ï… ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(116014,3223,'zh','ç¨Žè¡¨çš„æ›´æ–°\r\n',0),(116015,3223,'sv','Uppdatera skatt tabeller',0),(116016,3223,'it','Aggiornare le tabelle fiscali',0),(116017,3223,'tl','',0),(116018,3223,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;&#3616;&#3634;&#3625;&#3637;',0),(116019,3223,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¤à¤¾à¤²à¤¿à¤•à¤¾à¤“à¤‚ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(116020,3223,'ms','Kemaskini Terakhir Jadual cukai',0),(116021,3223,'ar','ØªØ­Ø¯ÙŠØ« Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(116022,3223,'fr','Mettre Ã  jour les tables d\'impÃ´t',0),(116023,3223,'jp','ç¨Žé¡?è¡¨ã?®æ›´æ–°',0),(116024,3223,'pt','Atualizar tabelas de impostos',0),(116025,3223,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(116026,3223,'es','Actualizar tablas de impuestos',0),(116027,3223,'de','Update-Steuertabellen',0),(116028,3223,'en','Update tax tables',0),(116029,3224,'is','',0),(116030,3224,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ø¨Ø± Ø¯Ø± Ù…Ø¯Ù„ Ù†Ù…Ø§ÙŠØ´ÙŠ Ø§Ø² ÙƒØ§Ø± Ø§ÙØªØ§Ø¯Ù‡ Ø§Ø³Øª ',0),(116031,3224,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ø¨Ø± Ø¯Ø± Ù…Ø¯Ù„ Ù†Ù…Ø§ÙŠØ´ÙŠ Ø§Ø² ÙƒØ§Ø± Ø§ÙØªØ§Ø¯Ù‡ Ø§Ø³Øª ',0),(116032,3224,'tr','Demo modunda devre dÄ±ÅŸÄ± kullanÄ±cÄ±yÄ± gÃ¼ncelleÅŸtirin',0),(116033,3224,'pl','Aktualizacja uÅ¼ytkownika wyÅ‚Ä…czone w trybie demo',0),(116034,3224,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ», Ð·Ð°Ð±Ñ€Ð°Ð½ÐµÐ½Ð¸ Ð² Ð´ÐµÐ¼Ð¾ Ñ€ÐµÐ¶Ð¸Ð¼',0),(116035,3224,'ur','ÚˆÛŒÙ…Ùˆ Ù…ÙˆÚˆ Ù…ÛŒÚº Ù†Ø§Ø§ÛÙ„ ØµØ§Ø±Ù Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(116036,3224,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¾Ð½ÐµÐ¼Ð¾Ð³ÑƒÑ›ÐµÐ½Ðµ Ñƒ Ð´ÐµÐ¼Ð¾ ÐœÐ¾Ð´',0),(116037,3224,'vi','Cáº­p nháº­t ngÆ°á»i sá»­ dá»¥ng vÃ´ hiá»‡u trong tráº¡ng thÃ¡i demo',0),(116038,3224,'af','Opdatering van gebruiker is gedeaktiveer in demo modus',0),(116039,3224,'ro','Actualizare utilizator dezactivat Ã®n modul demo',0),(116040,3224,'et','Muudetud kasutaja keelatud demoreÅ¾iimis',0),(116041,3224,'si','Modernizirati uporabnik onemogoÄen v demo naÄinu',0),(116042,3224,'ba','Pembaruan pengguna dinonaktifkan dalam demo mode',0),(116043,3224,'nl','Gebruiker uitgeschakeld in de demo mode bijwerken',0),(116044,3224,'fi','Ajantasaistaa kÃ¤yttÃ¤jÃ¤ liikuntaesteinen kotona mielenosoitus moodi',0),(116045,3224,'no','Oppdatere bruker deaktivert i demo-modus',0),(116046,3224,'da','Opdatering bruger deaktiveret i demo-tilstand',0),(116047,3224,'ko','ì—…ë°ì´íŠ¸ ì‚¬ìš©ìž ë°ëª¨ ëª¨ë“œì—ì„œ ì‚¬ìš©í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(116048,3224,'he','×¢×“×›×•×Ÿ ×ž×©×ª×ž×© ×œ× ×¤×¢×™×œ ×‘×ž×¦×‘ ×“×ž×•',0),(116049,3224,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½ Î¼Îµ ÎµÎ¹Î´Î¹ÎºÎ­Ï‚ Î±Î½Î¬Î³ÎºÎµÏ‚ ÏƒÎµ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± ÎµÏ€Î¯Î´ÎµÎ¹Î¾Î·Ï‚',0),(116050,3224,'zh','æ›´æ–°æ¼”ç¤ºæ¨¡å¼ä¸‹è¢«ç¦ç”¨çš„ç”¨æˆ·\r\n',0),(116051,3224,'sv','Uppdatera anvÃ¤ndare inaktiveras i demo-lÃ¤ge',0),(116052,3224,'it','Aggiornamento utente disattivato in modalitÃ  demo',0),(116053,3224,'tl','',0),(116054,3224,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3626;&#3636;&#3607;&#3608;&#3636;&#3650;&#3627;&#3617;&#3604;&#3626;&#3634;&#3608;&#3636;&#3605;',0),(116055,3224,'hi','à¤¡à¥‡à¤®à¥‹ à¤®à¥‹à¤¡ à¤®à¥‡à¤‚ à¤…à¤•à¥à¤·à¤® à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(116056,3224,'ms','Kemaskini Terakhir pengguna Kurang Upaya dalam mod demo',0),(116057,3224,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… ØºÙŠØ± Ù…ØªØ§Ø­ ÙÙŠ ÙˆØ¶Ø¹ Ø§Ù„Ø§Ø³ØªØ¹Ø±Ø§Ø¶',0),(116058,3224,'fr','Mise Ã  jour utilisateur dÃ©sactivÃ© en mode dÃ©mo',0),(116059,3224,'jp','ãƒ‡ãƒ¢ãƒ¢ãƒ¼ãƒ‰ã?§ç„¡åŠ¹ã?«ã?ªã?£ã?Ÿãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’æ›´æ–°',0),(116060,3224,'pt','Atualizar usuÃ¡rio desabilitado em modo de demonstraÃ§Ã£o',0),(116061,3224,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð¾Ñ‚ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ Ð² Ð´ÐµÐ¼Ð¾-Ñ€ÐµÐ¶Ð¸Ð¼Ðµ',0),(116062,3224,'es','Actualizar usuario deshabilitado en modo de demo',0),(116063,3224,'de','Update-Benutzer im Demo-Modus deaktiviert',0),(116064,3224,'en','Update user disabled in demo mode',0),(116065,3225,'is','',0),(116066,3225,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(116067,3225,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(116068,3225,'tr','BaÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(116069,3225,'pl','PomyÅ›lnie zaktualizowana!',0),(116070,3225,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾!',0),(116071,3225,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹!',0),(116072,3225,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½!',0),(116073,3225,'vi','Cáº­p nháº­t thÃ nh cÃ´ng!',0),(116074,3225,'af','Suksesvol Opdateer!',0),(116075,3225,'ro','Actualizat cu succes!',0),(116076,3225,'et','Edukalt vÃ¤rskendatud',0),(116077,3225,'si','UspeÅ¡no posodobljen!',0),(116078,3225,'ba','Diperbarui berhasil!',0),(116079,3225,'nl','Succesvol bijgewerkt!',0),(116080,3225,'fi','PÃ¤ivitetty!',0),(116081,3225,'no','Oppdatert!',0),(116082,3225,'da','Opdateret!',0),(116083,3225,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸!',0),(116084,3225,'he','×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”!',0),(116085,3225,'el','Î•Î½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±!',0),(116086,3225,'zh','æ›´æ–°æˆåŠŸï¼\r\n',0),(116087,3225,'sv','Uppdaterats!',0),(116088,3225,'it','Aggiornato con successo!',0),(116089,3225,'tl','',0),(116090,3225,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(116091,3225,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾!',0),(116092,3225,'ms','Dikemaskini berjaya!',0),(116093,3225,'ar','ØªÙ… Ø§Ù„ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­!',0),(116094,3225,'fr','Mis Ã  jour avec succÃ¨s !',0),(116095,3225,'jp','æ›´æ–°ã?—ã?¾ã?—ã?Ÿï¼?ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ç¢ºèª?ã?™ã‚‹ã?«ã?¯BACKã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ã??ã? ã?•ã?„',0),(116096,3225,'pt','Atualizado com sucesso!',0),(116097,3225,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾!',0),(116098,3225,'es','Actualizado Exitosamente',0),(116099,3225,'de','Erfolgreich aktualisiert!',0),(116100,3225,'en','Updated Successfully!',0),(116101,3226,'is','',0),(116102,3226,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ§ÙŠÙ„ ',0),(116103,3226,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ§ÙŠÙ„ ',0),(116104,3226,'tr','GÃœNCELLEÅžTÄ°RME DOSYASI',0),(116105,3226,'pl','AKTUALIZACJA PLIKU',0),(116106,3226,'bg','ÐÐšÐ¢Ð£ÐÐ›Ð˜Ð—Ð˜Ð ÐÐÐ• ÐÐ Ð¤ÐÐ™Ð›',0),(116107,3226,'ur','Ù…Ø³Ù„ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(116108,3226,'sr','ÐÐ–Ð£Ð Ð˜Ð ÐÐŠÐ• Ð”ÐÐ¢ÐžÐ¢Ð•ÐšÐ',0),(116109,3226,'vi','Cáº­p nháº­t há»“ sÆ¡',0),(116110,3226,'af','OPDATERING VAN LÃªER',0),(116111,3226,'ro','ACTUALIZAREA FIÅžIERULUI',0),(116112,3226,'et','UUENDAN FAILI',0),(116113,3226,'si','MODERNIZIRATI PILA',0),(116114,3226,'ba','MEMPERBARUI FILE',0),(116115,3226,'nl','BESTAND BIJWERKEN',0),(116116,3226,'fi','PÃ„IVITETÃ„Ã„N TIEDOSTO',0),(116117,3226,'no','OPPDATERE FILEN',0),(116118,3226,'da','OPDATERE FIL',0),(116119,3226,'ko','íŒŒì¼ ì—…ë°ì´íŠ¸',0),(116120,3226,'he','×¢×“×›×•×Ÿ ×§×•×‘×¥',0),(116121,3226,'el','Î•ÎÎ—ÎœÎˆÎ¡Î©Î£Î— Î‘Î¡Î§Î•ÎŠÎŸÎ¥',0),(116122,3226,'zh','æ›´æ–°æ–‡ä»¶\r\n',0),(116123,3226,'sv','UPPDATERA FIL',0),(116124,3226,'it','AGGIORNAMENTO FILE',0),(116125,3226,'tl','',0),(116126,3226,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3652;&#3615;&#3621;&#3660;',0),(116127,3226,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¤¾',0),(116128,3226,'ms','PENGEMASKINIAN FAIL',0),(116129,3226,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ù„Ù',0),(116130,3226,'fr','MISE Ã€ JOUR DU FICHIER',0),(116131,3226,'jp','ãƒ•ã‚¡ã‚¤ãƒ«æ›´æ–°ä¸­',0),(116132,3226,'pt','ARQUIVO DE ATUALIZAÃ‡ÃƒO',0),(116133,3226,'ru','ÐžÐ‘ÐÐžÐ’Ð›Ð•ÐÐ˜Ð• Ð¤ÐÐ™Ð›Ð',0),(116134,3226,'es','ACTUALIZANDO EL FILE',0),(116135,3226,'de','UPDATE DATEI',0),(116136,3226,'en','UPDATING FILE',0),(116137,3227,'is','',0),(116138,3227,'dr','ÙØ§ÙŠÙ„ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(116139,3227,'pr','ÙØ§ÙŠÙ„ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(116140,3227,'tr','YÃ¼klenen dosya boÅŸ olamaz.',0),(116141,3227,'pl','ZaÅ‚adowany plik nie moÅ¼e byÄ‡ pusta.',0),(116142,3227,'bg','ÐšÐ°Ñ‡ÐµÐ½Ð¸ÑÑ‚ Ñ„Ð°Ð¹Ð» Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾.',0),(116143,3227,'ur','Ø§Ù¾ Ù„ÙˆÚˆ Ù…Ø³Ù„ Ø®Ø§Ù„ÛŒ Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©ØªØ§ Û”',0),(116144,3227,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð°Ð·Ð½Ð°.',0),(116145,3227,'vi','Há»“ sÆ¡ táº£i lÃªn khÃ´ng thá»ƒ trá»‘ng',0),(116146,3227,'af','Opgelaaide lÃªer kan nie leeg wees nie',0),(116147,3227,'ro','FiÅŸierul Ã®ncÄƒrcat nu poate fi gol.',0),(116148,3227,'et','Ãœleslaaditud fail ei tohi olla tÃ¼hi.',0),(116149,3227,'si','NaloÅ¾ena datoteka ne sme biti prazno.',0),(116150,3227,'ba','File upload tidak boleh kosong.',0),(116151,3227,'nl','Ge-uploade bestand mag niet leeg.',0),(116152,3227,'fi','Ladattu tiedosto ei voi olla tyhjÃ¤.',0),(116153,3227,'no','Opplastede filen kan ikke vÃ¦re tomt.',0),(116154,3227,'da','Uploadede filen mÃ¥ ikke vÃ¦re tom.',0),(116155,3227,'ko','ì—…ë¡œë“œ ëœ íŒŒì¼ì€ ë¹„ì›Œë‘˜ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(116156,3227,'he','×”×§×•×‘×¥ ×©×”×•×¢×œ×” ××™× ×• ×™×›×•×œ ×œ×”×™×•×ª ×¨×™×§.',0),(116157,3227,'el','Î¦Î¿ÏÏ„ÏŽÎ½Ï‰ Î±ÏÏ‡ÎµÎ¯Î¿ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ½ÏŒ.',0),(116158,3227,'zh','ä¸Šä¼ æ–‡ä»¶ä¸èƒ½ä¸ºç©ºã€‚\r\n',0),(116159,3227,'sv','Uppladdad fil fÃ¥r inte vara tomt.',0),(116160,3227,'it','File caricato non puÃ² essere vuoto.',0),(116161,3227,'tl','',0),(116162,3227,'th','&#3629;&#3633;&#3614;&#3650;&#3627;&#3621;&#3604;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3592;&#3634;&#3585;&#3652;&#3615;&#3621;&#3660;&#3623;&#3656;&#3634;&#3591;',0),(116163,3227,'hi','à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¥€ à¤—à¤ˆ à¤«à¤¼à¤¾à¤‡à¤² à¤°à¤¿à¤•à¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾à¥¤',0),(116164,3227,'ms','Di-upload fail tidak boleh kosong.',0),(116165,3227,'ar','Ø§Ù„Ù…Ù„Ù Ø§Ù„Ø°ÙŠ ØªÙ… ØªØ­Ù…ÙŠÙ„Ù‡ Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ÙŠÙƒÙˆÙ† ÙØ§Ø±ØºØ§Ù‹.',0),(116166,3227,'fr','Fichier tÃ©lÃ©chargÃ© ne peut pas Ãªtre vide.',0),(116167,3227,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã?•ã‚Œã?Ÿãƒ•ã‚¡ã‚¤ãƒ«ã?¯ç©ºã?§ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(116168,3227,'pt','Arquivo enviado nÃ£o pode ser vazio.',0),(116169,3227,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ðµ Ñ„Ð°Ð¹Ð»Ñ‹ Ð½Ðµ Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¿ÑƒÑÑ‚Ñ‹Ð¼Ð¸.',0),(116170,3227,'es','File subido no puede ser vacÃ­o',0),(116171,3227,'de','Hochgeladene Datei darf nicht leer sein.',0),(116172,3227,'en','Uploaded file cannot be empty.',0),(116173,3228,'is','',0),(116174,3228,'dr','UPSØ§Ø³Ø§Ø³ Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ',0),(116175,3228,'pr','UPSØ§Ø³Ø§Ø³ Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ',0),(116176,3228,'tr','UPS Ground',0),(116177,3228,'pl','UPS ziemi',0),(116178,3228,'bg','UPS Ñ‚ÐµÑ€ÐµÐ½',0),(116179,3228,'ur','UPS Ú¯Ø±Ø§Ø¤Ù†Úˆ',0),(116180,3228,'sr','Ð£ÐŸÐ¡ Ð·ÐµÐ¼Ñ™Ñƒ',0),(116181,3228,'vi','Ná»n UPS',0),(116182,3228,'af','Onderbrekinglose Kragtoevoer grond',0),(116183,3228,'ro','UPS solului',0),(116184,3228,'et','UPS Ground',0),(116185,3228,'si','UPS terenu',0),(116186,3228,'ba','UPS Ground',0),(116187,3228,'nl','UPS Ground',0),(116188,3228,'fi','UPS Ground',0),(116189,3228,'no','UPS bakken',0),(116190,3228,'da','UPS Ground',0),(116191,3228,'ko','UPS ì ‘ì§€',0),(116192,3228,'he','UPS ×”×§×¨×§×¢',0),(116193,3228,'el','UPS Î­Î´Î±Ï†Î¿Ï‚',0),(116194,3228,'zh','UPSç¾Žå›½è”åˆåŒ…è£¹åœ°é¢æœåŠ¡\r\n',0),(116195,3228,'sv','UPS Ground',0),(116196,3228,'it','UPS Ground',0),(116197,3228,'tl','',0),(116198,3228,'th','UPS Ground',0),(116199,3228,'hi','à¤¯à¥‚à¤ªà¥€à¤à¤¸ à¤—à¥à¤°à¤¾à¤‰à¤‚à¤¡',0),(116200,3228,'ms','UPS Ground',0),(116201,3228,'ar','Ø§Ù„Ø£Ø±Ø¶ UPS',0),(116202,3228,'fr','UPS Ground',0),(116203,3228,'jp','UPS é™¸é?‹',0),(116204,3228,'pt','UPS Ground',0),(116205,3228,'ru','UPS Ground',0),(116206,3228,'es','UPS por Tierra',0),(116207,3228,'de','UPS Boden',0),(116208,3228,'en','UPS Ground',0),(116209,3229,'is','',0),(116210,3229,'dr','(Ù‚Ø±Ù…Ø²',0),(116211,3229,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø±ÙˆØ² Ø¢ÙŠÙ†Ø¯Ù‡ (Ù‚Ø±Ù…Ø²',0),(116212,3229,'tr','UPS sonraki gÃ¼nÃ¼ (kÄ±rmÄ±zÄ±)',0),(116213,3229,'pl','UPS nastÄ™pnego dnia (czerwony)',0),(116214,3229,'bg','UPS ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ Ð´ÐµÐ½ (Ñ‡ÐµÑ€Ð²ÐµÐ½)',0),(116215,3229,'ur','UPS Ø§Ú¯Ù„Ø§ Ø¯Ù† (Ø³Ø±Ø®)',0),(116216,3229,'sr','Ð£ÐŸÐ¡ ÑÐ»ÐµÐ´ÐµÑ›Ð¸ Ð´Ð°Ð½ (Ñ†Ñ€Ð²ÐµÐ½Ð°)',0),(116217,3229,'vi','UPS ngÃ y hÃ´m sau (Äá»)',0),(116218,3229,'af','Onderbrekinglose Kragtoevoer volgende dag (rooi)',0),(116219,3229,'ro','UPS urmÄƒtoarea zi (rosu)',0),(116220,3229,'et','UPS jÃ¤rgmisel pÃ¤eval (punane)',0),(116221,3229,'si','UPS naslednji dan (Red)',0),(116222,3229,'ba','Next Up hari (merah)',0),(116223,3229,'nl','UPS Next Day (rood)',0),(116224,3229,'fi','UPS Next Day (punainen)',0),(116225,3229,'no','UPS neste dag (rÃ¸d)',0),(116226,3229,'da','UPS nÃ¦ste dag (rÃ¸d)',0),(116227,3229,'ko','UPS ìµì¼ (ë ˆë“œ)',0),(116228,3229,'he','×‘×™×•× ×”×‘× UPS (××“×•×)',0),(116229,3229,'el','UPS ÎµÏ€ÏŒÎ¼ÎµÎ½Î· Î·Î¼Î­ÏÎ± (ÎºÏŒÎºÎºÎ¹Î½Î¿)',0),(116230,3229,'zh','UPSç¬¬äºŒå¤©ï¼ˆçº¢è‰²ï¼‰\r\n',0),(116231,3229,'sv','UPS Next Day (rÃ¶d)',0),(116232,3229,'it','UPS Next Day (rosso)',0),(116233,3229,'tl','',0),(116234,3229,'th','&#3610;&#3619;&#3636;&#3636;&#3585;&#3634;&#3619;&#3627;&#3656;&#3629;&#3623;&#3633;&#3626;&#3604;&#3640;&#3623;&#3633;&#3609;&#3606;&#3633;&#3604;&#3652;&#3611;(&#3649;&#3604;&#3591;)',0),(116235,3229,'hi','UPS à¤…à¤—à¤²à¤¾ à¤¦à¤¿à¤¨ (à¤²à¤¾à¤²)',0),(116236,3229,'ms','Hari seterusnya up (merah)',0),(116237,3229,'ar','Ø§Ù„ÙŠÙˆÙ… Ø§Ù„ØªØ§Ù„ÙŠ UPS (Ø£Ø­Ù…Ø±)',0),(116238,3229,'fr','UPS Next Day (rouge)',0),(116239,3229,'jp','UPS ç¿Œæ—¥é…?é€? (èµ¤)',0),(116240,3229,'pt','UPS no prÃ³ximo dia (vermelho)',0),(116241,3229,'ru','UPS ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð´ÐµÐ½ÑŒ (ÐºÑ€Ð°ÑÐ½Ñ‹Ð¹)',0),(116242,3229,'es','UPS Proximo DÃ­a (Rojo)',0),(116243,3229,'de','UPS Next Day (rot)',0),(116244,3229,'en','UPS Next Day (Red)',0),(116245,3230,'is','',0),(116246,3230,'dr','(Ø¢Ø¨ÙŠ',0),(116247,3230,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø±ÙˆØ² Ø¯ÙˆÙ…(Ø¢Ø¨ÙŠ',0),(116248,3230,'tr','UPS 2. gÃ¼n (mavi)',0),(116249,3230,'pl','UPS 2nd Day (niebieski)',0),(116250,3230,'bg','ÐŸÐ ÐžÐ—ÐžÐ Ð¦Ð˜, 2-Ñ€Ð¸ Ð´ÐµÐ½ (ÑÐ¸Ð½ÑŒÐ¾)',0),(116251,3230,'ur','UPS Ø¯ÙˆØ³Ø±Ø§ Ø¯Ù† (Ù†ÛŒÙ„Ø§)',0),(116252,3230,'sr','ÐÐ¿Ñ 2 Ð´Ð°Ð½Ð° (Ð¿Ð»Ð°Ð²Ð°)',0),(116253,3230,'vi','NgÃ y thá»© 2 UPS (Xanh)',0),(116254,3230,'af','Onderbrekinglose KRAGTOEVOER 2de dag (blou)',0),(116255,3230,'ro','UPS a doua zi (albastru)',0),(116256,3230,'et','UPS 2. pÃ¤ev (sinine)',0),(116257,3230,'si','UPS, 2. dan (modra)',0),(116258,3230,'ba','UPS 2 hari (biru)',0),(116259,3230,'nl','UPS 2nd Day (blauw)',0),(116260,3230,'fi','UPS toinen pÃ¤ivÃ¤ (sininen)',0),(116261,3230,'no','UPS andre dag (blÃ¥)',0),(116262,3230,'da','UPS 2nd Day (blÃ¥)',0),(116263,3230,'ko','UPSëŠ” ë‘˜ì§¸ ë‚  (ë¸”ë£¨)',0),(116264,3230,'he','×¢×œ×™×•×ª ×œ×™×•× ×©× ×™ (×›×—×•×œ)',0),(116265,3230,'el','UPS 2Î· Î·Î¼Î­ÏÎ± (Î¼Ï€Î»Îµ)',0),(116266,3230,'zh','UPSçš„ç¬¬äºŒæ—¥ï¼ˆè“è‰²ï¼‰\r\n',0),(116267,3230,'sv','UPS-dag 2 (blÃ¥)',0),(116268,3230,'it','UPS 2 Â° giorno (blu)',0),(116269,3230,'tl','',0),(116270,3230,'th','&#3610;&#3619;&#3636;&#3636;&#3585;&#3634;&#3619;&#3627;&#3656;&#3629;&#3623;&#3633;&#3626;&#3604;&#3640; 2 &#3623;&#3633;&#3609;(&#3648;&#3586;&#3637;&#3618;&#3623;)',0),(116271,3230,'hi','à¤‰à¤¤à¤¾à¤° à¤•à¥‡ 2 à¤¦à¤¿à¤¨ (à¤¨à¥€à¤²à¤¾)',0),(116272,3230,'ms','UPS hari ke-2 (biru)',0),(116273,3230,'ar','Ø´ÙƒØ§ Ø§Ù„ÙŠÙˆÙ… Ø§Ù„Ø«Ø§Ù†ÙŠ (Ø§Ù„Ø£Ø²Ø±Ù‚)',0),(116274,3230,'fr','UPS 2nd Day (bleu)',0),(116275,3230,'jp','UPS ç¿Œã€…æ—¥é…?é€? (é?’)',0),(116276,3230,'pt','2Âº dia (azul)-UPS',0),(116277,3230,'ru','UPS 2-Ð¹ Ð´ÐµÐ½ÑŒ (ÑÐ¸Ð½Ð¸Ð¹)',0),(116278,3230,'es','UPS 2do DÃ­a (Azul)',0),(116279,3230,'de','UPS 2. Tag (blau)',0),(116280,3230,'en','UPS 2nd Day (Blue)',0),(116281,3231,'is','',0),(116282,3231,'dr','(Ù†Ø§Ø±Ù†Ø¬ÙŠ',0),(116283,3231,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø±ÙˆØ² Ø³ÙˆÙ… (Ù†Ø§Ø±Ù†Ø¬ÙŠ',0),(116284,3231,'tr','UPS Ã¼Ã§Ã¼ncÃ¼ gÃ¼n (turuncu)',0),(116285,3231,'pl','UPS trzeci dzieÅ„ (pomaraÅ„czowy)',0),(116286,3231,'bg','UPS Ñ‚Ñ€ÐµÑ‚Ð¸ÑÑ‚ Ð´ÐµÐ½ (Ð¾Ñ€Ð°Ð½Ð¶ÐµÐ²Ð¾)',0),(116287,3231,'ur','UPS ØªÛŒØ³Ø±Ø§ Ø¯Ù† (Ø§ÙˆØ±Ù†Ø¬)',0),(116288,3231,'sr','ÐÐ¿Ñ Ñ‚Ñ€ÐµÑ›Ð¸ Ð´Ð°Ð½ (ÐžÑ€Ð°Ð½Ð³Ðµ)',0),(116289,3231,'vi','UPS ngÃ y thá»© 3 (Cam)',0),(116290,3231,'af','Onderbrekinglose KRAGTOEVOER derde dag (oranje)',0),(116291,3231,'ro','Up treia zi (portocaliu)',0),(116292,3231,'et','UPS kolmas pÃ¤ev (oranÅ¾)',0),(116293,3231,'si','UPS tretji dan (oranÅ¾na)',0),(116294,3231,'ba','UPS ketiga hari (oranye)',0),(116295,3231,'nl','UPS derde dag (oranje)',0),(116296,3231,'fi','UPS kolmas pÃ¤ivÃ¤ (oranssi)',0),(116297,3231,'no','UPS tredje dag (oransje)',0),(116298,3231,'da','UPS tredje dag (Orange)',0),(116299,3231,'ko','UPSëŠ” ì…‹ì§¸ ë‚  (ì˜¤ë Œì§€)',0),(116300,3231,'he','×¢×œ×™×•×ª ×”×©×œ×™×©×™×ª ×™×•× (×›×ª×•×)',0),(116301,3231,'el','UPS Ï„ÏÎ¯Ï„Î· Î·Î¼Î­ÏÎ± (Ï€Î¿ÏÏ„Î¿ÎºÎ±Î»Î¯)',0),(116302,3231,'zh','UPSçš„ç¬¬ä¸‰å¤©ï¼ˆæ©™è‰²ï¼‰\r\n',0),(116303,3231,'sv','UPS-tredje dagen (Orange)',0),(116304,3231,'it','UPS terzo giorno (arancione)',0),(116305,3231,'tl','',0),(116306,3231,'th','&#3610;&#3619;&#3636;&#3636;&#3585;&#3634;&#3619;&#3627;&#3656;&#3629;&#3623;&#3633;&#3626;&#3604;&#3640; 3 &#3623;&#3633;&#3609;(&#3626;&#3657;&#3617;)',0),(116307,3231,'hi','à¤‰à¤¤à¤¾à¤° à¤•à¥‡ à¤¤à¥€à¤¸à¤°à¥‡ à¤¦à¤¿à¤¨ (à¤¨à¤¾à¤°à¤‚à¤—à¥€)',0),(116308,3231,'ms','UPS ketiga hari (oren)',0),(116309,3231,'ar','Ø´ÙƒØ§ Ù…Ù† Ø«Ø§Ù„Ø« ÙŠÙˆÙ… (Ø¨Ø±ØªÙ‚Ø§Ù„ÙŠ)',0),(116310,3231,'fr','UPS troisiÃ¨me jour (Orange)',0),(116311,3231,'jp','UPS ï¼“æ—¥ç›®é…?é€? (ã‚ªãƒ¬ãƒ³ã‚¸)',0),(116312,3231,'pt','UPS terceiro dia (laranja)',0),(116313,3231,'ru','UPS Ñ‚Ñ€ÐµÑ‚Ð¸Ð¹ Ð´ÐµÐ½ÑŒ (Ð¾Ñ€Ð°Ð½Ð¶ÐµÐ²Ñ‹Ð¹)',0),(116314,3231,'es','UPS Tercer DÃ­a (Naranja)',0),(116315,3231,'de','USV-Dritter Tag (Orange)',0),(116316,3231,'en','UPS Third Day (Orange)',0),(116317,3232,'is','',0),(116318,3232,'dr','Ø²Ø¨Ø§Ù† Ø§Ø±Ø¯Ùˆ',0),(116319,3232,'pr','Ø²Ø¨Ø§Ù† Ø§Ø±Ø¯Ùˆ',0),(116320,3232,'tr','Urduca',0),(116321,3232,'pl','Urdu',0),(116322,3232,'bg','Ð£Ñ€Ð´Ñƒ',0),(116323,3232,'ur','Ø§Ø±Ø¯Ùˆ',0),(116324,3232,'sr','ÑƒÑ€Ð´Ñƒ',0),(116325,3232,'vi','Urdu',0),(116326,3232,'af','Urdu',0),(116327,3232,'ro','Urdu',0),(116328,3232,'et','Urdu',0),(116329,3232,'si','urdu',0),(116330,3232,'ba','Urdu',0),(116331,3232,'nl','Urdu',0),(116332,3232,'fi','urdu',0),(116333,3232,'no','Urdu',0),(116334,3232,'da','urdu',0),(116335,3232,'ko','ìš°ë¥´ë‘ì–´',0),(116336,3232,'he','××•×¨×“×•',0),(116337,3232,'el','ÎŸÏ…ÏÎ½Ï„Î¿Ï',0),(116338,3232,'zh','ä¹Œå°”éƒ½è¯­\r\n',0),(116339,3232,'sv','Urdu',0),(116340,3232,'it','Urdu',0),(116341,3232,'tl','',0),(116342,3232,'th','Urdu',0),(116343,3232,'hi','à¤‰à¤°à¥à¤¦à¥‚',0),(116344,3232,'ms','Urdu',0),(116345,3232,'ar','Ø§Ù„Ø£Ø±Ø¯ÙŠÙ‘Ø©',0),(116346,3232,'fr','Urdu',0),(116347,3232,'jp','ã‚¦ãƒ«ãƒ‰ã‚¥èªž',0),(116348,3232,'pt','Urdu',0),(116349,3232,'ru','ÑƒÑ€Ð´Ñƒ',0),(116350,3232,'es','Urdu',0),(116351,3232,'de','Urdu',0),(116352,3232,'en','Urdu',0),(116353,3233,'is','',0),(116354,3233,'dr',' ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ  ÙØ§ÙŠÙ„ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(116355,3233,'pr',' ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ  ÙØ§ÙŠÙ„ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(116356,3233,'tr','URL/dosya CSV biÃ§imi mÃ¼ÅŸteri dosyasÄ±',0),(116357,3233,'pl','Plik/URL do pliku CSV Format klienta',0),(116358,3233,'bg','URL Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° Ð·Ð° Ñ„Ð°Ð¹Ð» CSV Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(116359,3233,'ur','URL/ÙØ§Ø¦Ù„ CSV ÙˆØ¶Ø¹ Ú©Ø³Ù¹Ù…Ø± Ù…Ø³Ù„ Ú©Û’ Ù„ÛŒÛ’',0),(116360,3233,'sr','Ð£Ð Ð› /Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸ Ð·Ð° Ð¦Ð¡Ð’ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(116361,3233,'vi','ÄÆ°á»ng dáº«n/Há»“ sÆ¡ cho Há»“ sÆ¡ khÃ¡ch hÃ ng dáº¡ng CSV',0),(116362,3233,'af','BA (\"URL\") vir CSV Formaat Klant LÃªer',0),(116363,3233,'ro','URL-ul/fiÅŸier pentru fiÅŸierul CSV Format client',0),(116364,3233,'et','URL/Faili asukoht CSV formaadis kliendifaili jaoks',0),(116365,3233,'si','URL/datoteke za kupca datoteki v obliki CSV',0),(116366,3233,'ba','URL/File untuk File CSV Format pelanggan',0),(116367,3233,'nl','Bestand/URL voor CSV-formaat klantenbestand',0),(116368,3233,'fi','URL-osoitteen tai tiedoston CSV-tiedostossa on asiakkaan',0),(116369,3233,'no','URL/fil for CSV-Format kunden-fil',0),(116370,3233,'da','URL/fil i CSV-Format kundefil',0),(116371,3233,'ko','CSV í˜•ì‹ ê³ ê° íŒŒì¼ì— ëŒ€ í•œ URL ë˜ëŠ” íŒŒì¼',0),(116372,3233,'he','×›×ª×•×‘×ª URL/×§×•×‘×¥ ×¢×‘×•×¨ ×§×•×‘×¥ ×”-CSV ×¢×™×¦×•×‘ ×”×œ×§×•×—',0),(116373,3233,'el','Î‘ÏÏ‡ÎµÎ¯Î¿/URL Î³Î¹Î± Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ ÏƒÎµ CSV Î¼Î¿ÏÏ†Î® Ï€ÎµÎ»Î¬Ï„Î·',0),(116374,3233,'zh','ç½‘å€/å®¢æˆ·æ¡£æ¡ˆé€—å·åˆ†éš”å€¼æ ¼å¼æ–‡ä»¶\r\n',0),(116375,3233,'sv','URL/fil fÃ¶r CSV-Format kundregister',0),(116376,3233,'it','URL/File per File in formato CSV cliente',0),(116377,3233,'tl','',0),(116378,3233,'th','URL/File for CSV Format Customer File',0),(116379,3233,'hi','CSV à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª à¤—à¥à¤°à¤¾à¤¹à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‡ à¤²à¤¿à¤ URL/à¤«à¤¼à¤¾à¤‡à¤²',0),(116380,3233,'ms','URL/fail untuk fail baca Format CSV',0),(116381,3233,'ar','Ù…Ù„Ù/Ø¹Ù†ÙˆØ§Ù† URL Ù„Ù…Ù„Ù Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø¨ØªÙ†Ø³ÙŠÙ‚ CSV',0),(116382,3233,'fr','Fichier/URL pour le fichier client au Format CSV',0),(116383,3233,'jp','CSVãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆã?®é¡§å®¢ãƒ•ã‚¡ã‚¤ãƒ«ã?®URL/ãƒ•ã‚¡ã‚¤ãƒ«',0),(116384,3233,'pt','Arquivo/URL para o arquivo de cliente de formato CSV',0),(116385,3233,'ru','Ð¤Ð°Ð¹Ð»/URL Ð´Ð»Ñ CSV Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ñ„Ð°Ð¹Ð»Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(116386,3233,'es','URL/File para Formato CSV de File de Cliente',0),(116387,3233,'de','URL/Datei fÃ¼r Datei im CSV Format Kunden',0),(116388,3233,'en','URL/File for CSV Format Customer File',0),(116389,3234,'is','',0),(116390,3234,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ù†Ù…ÙˆØ¯Ø§Ø±  Ù…Ø­ØµÙˆÙ„ ',0),(116391,3234,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ù†Ù…ÙˆØ¯Ø§Ø±  Ù…Ø­ØµÙˆÙ„ ',0),(116392,3234,'tr','URL/dosya Ã¼rÃ¼n grafik iÃ§in',0),(116393,3234,'pl','Plik/URL dla produktu grafika',0),(116394,3234,'bg','URL Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(116395,3234,'ur','Ù…ØµÙ†ÙˆØ¹Û Ú¯Ø±Ø§ÙÛŒ Ú©Û’ Ù„ÛŒÛ’ URL/ÙØ§Ø¦Ù„',0),(116396,3234,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ð³Ñ€Ð°Ñ„Ð¸ÐºÑƒ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(116397,3234,'vi','ÄÆ°á»ng dáº«n/káº¿t ná»‘i cho sáº£n pháº©m Ä‘á»“ há»a',0),(116398,3234,'af','BA (\"URL\")/LÃªer vir Produk Grafika',0),(116399,3234,'ro','URL-ul/fiÅŸier pentru produsul grafic',0),(116400,3234,'et','URL/faili toote pilt',0),(116401,3234,'si','URL/datoteke za grafiÄni izdelek',0),(116402,3234,'ba','URL/File untuk produk grafis',0),(116403,3234,'nl','Bestand/URL voor Product afbeelding',0),(116404,3234,'fi','URL-osoitteen tai tiedoston tuotteen kuva',0),(116405,3234,'no','URL/filen for produktet grafikk',0),(116406,3234,'da','URL/fil for produkt grafik',0),(116407,3234,'ko','URL/ì œí’ˆ ê·¸ëž˜í”½ íŒŒì¼',0),(116408,3234,'he','×›×ª×•×‘×ª ××ª×¨/×§×•×‘×¥ ×¢×‘×•×¨ ××™×•×¨ ×”×ž×•×¦×¨',0),(116409,3234,'el','Î‘ÏÏ‡ÎµÎ¯Î¿/URL Î³Î¹Î± Ï€ÏÎ¿ÏŠÏŒÎ½ Î³ÏÎ±Ï†Î¹ÎºÏŒ',0),(116410,3234,'zh','ç½‘å€/äº§å“çš„å›¾å½¢æ–‡ä»¶\r\n',0),(116411,3234,'sv','URL/fil fÃ¶r produkten grafik',0),(116412,3234,'it','File/URL per prodotto grafico',0),(116413,3234,'tl','',0),(116414,3234,'th','URL/&#3652;&#3615;&#3621;&#3660; &#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(116415,3234,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‚à¤†à¤°à¤à¤²/à¤«à¤¼à¤¾à¤‡à¤²',0),(116416,3234,'ms','URL/fail untuk produk grafik',0),(116417,3234,'ar','URL/Ù…Ù„Ù Ù„Ù„Ø±Ø³Ù… Ø§Ù„Ù…Ù†ØªØ¬',0),(116418,3234,'fr','Fichier/URL produit graphique',0),(116419,3234,'jp','URL/è£½å“?ã‚°ãƒ©ãƒ•ãƒ•ã‚¡ã‚¤ãƒ«',0),(116420,3234,'pt','Arquivo/URL para produto grÃ¡fico',0),(116421,3234,'ru','Ð¤Ð°Ð¹Ð»/URL Ð´Ð»Ñ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¾Ð³Ð¾ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(116422,3234,'es','URL/File para GrÃ¡fica de Producto',0),(116423,3234,'de','URL/Datei fÃ¼r Produkt-Grafik',0),(116424,3234,'en','URL/File for Product Graphic',0),(116425,3235,'is','',0),(116426,3235,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ØµÙØ­Ù‡ Ù…Ø­ØµÙˆÙ„ ',0),(116427,3235,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ØµÙØ­Ù‡ Ù…Ø­ØµÙˆÙ„ ',0),(116428,3235,'tr','URL/dosya iÃ§in Ã¼rÃ¼n sayfasÄ±',0),(116429,3235,'pl','Plik/URL arkusza produktu',0),(116430,3235,'bg','URL Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° Ð·Ð° Ð»Ð¸ÑÑ‚ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚',0),(116431,3235,'ur','Ù…ØµÙ†ÙˆØ¹Û ÙˆØ±Ù‚ Ú©Û’ Ù„ÛŒÛ’ URL/ÙØ§Ø¦Ù„',0),(116432,3235,'sr','Ð£Ð Ð› /Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸ Ð·Ð° Ð»Ð¸ÑÑ‚ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(116433,3235,'vi','ÄÆ°á»ng dáº«n/Há»“ sÆ¡ cho trang sáº£n pháº©m',0),(116434,3235,'af','BA (\"URL\")/LÃªer vir Produk Blad',0),(116435,3235,'ro','URL-ul/fiÅŸier pentru produs foaie',0),(116436,3235,'et','URL/faili tooteleht',0),(116437,3235,'si','URL/datoteke za Product list',0),(116438,3235,'ba','URL/File untuk produk Sheet',0),(116439,3235,'nl','Bestand/URL voor productsheet',0),(116440,3235,'fi','URL-osoitteen tai tiedoston tuote-esite',0),(116441,3235,'no','URL/fil for produktark',0),(116442,3235,'da','URL/fil til produktblad',0),(116443,3235,'ko','ì œí’ˆ ì‹œíŠ¸ì— ëŒ€ í•œ URL ë˜ëŠ” íŒŒì¼',0),(116444,3235,'he','×›×ª×•×‘×ª URL/×§×•×‘×¥ ×¢×‘×•×¨ ×”×ž×•×¦×¨ ×”×’×™×œ×™×•×Ÿ',0),(116445,3235,'el','Î‘ÏÏ‡ÎµÎ¯Î¿/URL Î³Î¹Î± Ï„Î¿ Ï†Ï…Î»Î»Î¬Î´Î¹Î¿ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚',0),(116446,3235,'zh','ç½‘å€/äº§å“å•æ–‡ä»¶\r\n',0),(116447,3235,'sv','URL/fil fÃ¶r produktblad',0),(116448,3235,'it','File/URL per scheda prodotto',0),(116449,3235,'tl','',0),(116450,3235,'th','URL/&#3652;&#3615;&#3621;&#3660; &#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(116451,3235,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤ªà¤¤à¥à¤°à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‚à¤†à¤°à¤à¤²/à¤«à¤¼à¤¾à¤‡à¤²',0),(116452,3235,'ms','URL/fail untuk kira-kira produk',0),(116453,3235,'ar','Ù…Ù„Ù/URL Ù„ØµÙØ­Ø© Ø§Ù„Ù…Ù†ØªØ¬',0),(116454,3235,'fr','Fichier/URL de la fiche produit',0),(116455,3235,'jp','URL/è£½å“?ã‚·ãƒ¼ãƒˆãƒ•ã‚¡ã‚¤ãƒ«',0),(116456,3235,'pt','URL/arquivo de folha de produto',0),(116457,3235,'ru','Ð¤Ð°Ð¹Ð»/URL Ð´Ð»Ñ Ð»Ð¸ÑÑ‚Ð¾Ð²Ð¾Ð¹ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ†Ð¸Ð¸',0),(116458,3235,'es','URL/File para Hoja de Producto',0),(116459,3235,'de','URL/Datei fÃ¼r Produkt-Datenblatt',0),(116460,3235,'en','URL/File for Product Sheet',0),(116461,3236,'is','',0),(116462,3236,'dr','Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙŠØ§ ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø¶Ù…ÙŠÙ…Ù‡ ÙƒØ±Ø¯Ù†',0),(116463,3236,'pr','Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙŠØ§ ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø¶Ù…ÙŠÙ…Ù‡ ÙƒØ±Ø¯Ù†',0),(116464,3236,'tr','URL/dosya iliÅŸtirmek iÃ§in',0),(116465,3236,'pl','Adres URL/plik, aby doÅ‚Ä…czyÄ‡',0),(116466,3236,'bg','URL Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ñ‡Ð²Ð°Ð½Ðµ',0),(116467,3236,'ur','URL/ÙØ§Ø¦Ù„ Ù…Ù†Ø³Ù„Ú© Ú©Ø±Ù†Ø§',0),(116468,3236,'sr','Ð£Ð Ð› /Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸Ð»Ð¸',0),(116469,3236,'vi','ÄÆ°á»ng dáº«n Há»“ sÆ¡ tá»›i há»“ sÆ¡ gá»­i kÃ¨m',0),(116470,3236,'af','BA (\"URL\")/LÃªer vir Aanhegging',0),(116471,3236,'ro','URL-ul/fiÅŸier pentru a ataÅŸa',0),(116472,3236,'et','URL/faili manustamiseks',0),(116473,3236,'si','URL/datoteko priloÅ¾ite',0),(116474,3236,'ba','URL/File untuk melampirkan',0),(116475,3236,'nl','URL/bestand koppelen',0),(116476,3236,'fi','LiitettÃ¤vÃ¤ URL/tiedosto',0),(116477,3236,'no','URL/filen legge',0),(116478,3236,'da','URL/fil vedhÃ¦ftes',0),(116479,3236,'ko','URL ë˜ëŠ” íŒŒì¼ ì²¨ë¶€',0),(116480,3236,'he','×›×ª×•×‘×ª ××ª×¨/×§×•×‘×¥ ×œ×¦×™×¨×•×£',0),(116481,3236,'el','URL/Î±ÏÏ‡ÎµÎ¯Î¿ Ï€ÏÎ¿Ï‚ ÎµÏ€Î¹ÏƒÏÎ½Î±ÏˆÎ·',0),(116482,3236,'zh','ç½‘å€/é™„åŠ çš„æ¡£æ¡ˆ\r\n',0),(116483,3236,'sv','URL/fil att fÃ¤sta',0),(116484,3236,'it','URL/File da allegare',0),(116485,3236,'tl','',0),(116486,3236,'th','URL/&#3652;&#3615;&#3621;&#3660; &#3607;&#3637;&#3656;&#3649;&#3609;&#3610;',0),(116487,3236,'hi','à¤¯à¥‚à¤†à¤°à¤à¤²/à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤¨à¥à¤²à¤—à¥à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(116488,3236,'ms','URL/fail untuk melampirkan',0),(116489,3236,'ar','URL/Ù…Ù„Ù Ø¥Ø±ÙØ§Ù‚',0),(116490,3236,'fr','URL/fichier Ã  joindre',0),(116491,3236,'jp','URL/æ·»ä»˜ãƒ•ã‚¡ã‚¤ãƒ«',0),(116492,3236,'pt','URL/arquivo para anexar',0),(116493,3236,'ru','URL/Ñ„Ð°Ð¹Ð»',0),(116494,3236,'es','URL/File para Anexar',0),(116495,3236,'de','URL/Datei anhÃ¤ngen',0),(116496,3236,'en','URL/File to Attach',0),(116497,3237,'is','',0),(116498,3237,'dr','US Ø¢Ù…Ø±ÙŠÙƒØ§',0),(116499,3237,'pr','US Ø¢Ù…Ø±ÙŠÙƒØ§',0),(116500,3237,'tr','BÄ°ZÄ°',0),(116501,3237,'pl','NAS',0),(116502,3237,'bg','ÐÐ˜',0),(116503,3237,'ur','ÛÙ…ÛŒÚº',0),(116504,3237,'sr','ÐÐÐ¡',0),(116505,3237,'vi','US',0),(116506,3237,'af','VSA',0),(116507,3237,'ro','NE',0),(116508,3237,'et','MEILE',0),(116509,3237,'si','NAS',0),(116510,3237,'ba','KAMI',0),(116511,3237,'nl','ONS',0),(116512,3237,'fi','MEILLE',0),(116513,3237,'no','OSS',0),(116514,3237,'da','OS',0),(116515,3237,'ko','ìš°ë¦¬ì— ê²Œ',0),(116516,3237,'he','××•×ª× ×•',0),(116517,3237,'el','ÎœÎ‘Î£',0),(116518,3237,'zh','ç¾Žå›½\r\n',0),(116519,3237,'sv','OSS',0),(116520,3237,'it','NOI',0),(116521,3237,'tl','',0),(116522,3237,'th','&#3626;&#3627;&#3619;&#3633;&#3600;&#3629;&#3648;&#3617;&#3619;&#3636;&#3585;&#3634;',0),(116523,3237,'hi','à¤¹à¤®à¥‡à¤‚',0),(116524,3237,'ms','KAMI',0),(116525,3237,'ar','Ù„Ù†Ø§',0),(116526,3237,'fr','NOUS',0),(116527,3237,'jp','US',0),(116528,3237,'pt','NOS',0),(116529,3237,'ru','ÐÐÐ¡',0),(116530,3237,'es','US',0),(116531,3237,'de','UNS',0),(116532,3237,'en','US',0),(116533,3238,'is','',0),(116534,3238,'dr','(ÛŒÙˆØ²Ø±Ø¯',0),(116535,3238,'pr','Ù…ØµØ±Ù(ÙƒØ§Ø±Ø¨Ø±Ø¯',0),(116536,3238,'tr','KullanÄ±m',0),(116537,3238,'pl','UÅ¼ycie',0),(116538,3238,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ',0),(116539,3238,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(116540,3238,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(116541,3238,'vi','DÃ¹ng',0),(116542,3238,'af','Gebruik',0),(116543,3238,'ro','Utilizare',0),(116544,3238,'et','Kasutus',0),(116545,3238,'si','Uporaba',0),(116546,3238,'ba','Penggunaan',0),(116547,3238,'nl','Gebruik',0),(116548,3238,'fi','KÃ¤yttÃ¶',0),(116549,3238,'no','Bruk',0),(116550,3238,'da','Brug',0),(116551,3238,'ko','ì‚¬ìš©',0),(116552,3238,'he','×”×©×™×ž×•×©',0),(116553,3238,'el','Î§ÏÎ®ÏƒÎ·',0),(116554,3238,'zh','ç”¨æ³•\r\n',0),(116555,3238,'sv','AnvÃ¤ndning',0),(116556,3238,'it','Utilizzo',0),(116557,3238,'tl','',0),(116558,3238,'th','&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(116559,3238,'hi','à¤‰à¤ªà¤¯à¥‹à¤—',0),(116560,3238,'ms','Penggunaan',0),(116561,3238,'ar','Ø§Ù„Ø¥Ø³ØªØ¹Ù…Ø§Ù„',0),(116562,3238,'fr','Utilisation',0),(116563,3238,'jp','ä½¿ç”¨',0),(116564,3238,'pt','Uso',0),(116565,3238,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(116566,3238,'es','Uso',0),(116567,3238,'de','Verwendung',0),(116568,3238,'en','Usage',0),(116569,3239,'is','',0),(116570,3239,'dr','ÙˆØ§Ø­Ø¯ Ù…ØµØ±ÙÙŠ ',0),(116571,3239,'pr','ÙˆØ§Ø­Ø¯ Ù…ØµØ±ÙÙŠ ',0),(116572,3239,'tr','KullanÄ±m birimi',0),(116573,3239,'pl','UÅ¼ycie jednostki',0),(116574,3239,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(116575,3239,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ ÛŒÙˆÙ†Ù¹',0),(116576,3239,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(116577,3239,'vi','ÄÆ¡n vá»‹ dÃ¹ng',0),(116578,3239,'af','Gebruikseenheid(hede)',0),(116579,3239,'ro','Utilizare unitate',0),(116580,3239,'et','Kasutus Ã¼ksus',0),(116581,3239,'si','Uporabe enote',0),(116582,3239,'ba','Penggunaan Unit',0),(116583,3239,'nl','Gebruik eenheid',0),(116584,3239,'fi','KÃ¤yttÃ¶ yksikkÃ¶',0),(116585,3239,'no','Bruk enhet',0),(116586,3239,'da','Brug enhed',0),(116587,3239,'ko','ì‚¬ìš© ë‹¨ìœ„',0),(116588,3239,'he','×™×—×™×“×ª ×”×©×™×ž×•×©',0),(116589,3239,'el','Î§ÏÎ®ÏƒÎ· Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(116590,3239,'zh','ç”¨æ³•å•ä½\r\n',0),(116591,3239,'sv','AnvÃ¤ndning enhet',0),(116592,3239,'it','UnitÃ  di utilizzo',0),(116593,3239,'tl','',0),(116594,3239,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(116595,3239,'hi','à¤‰à¤ªà¤¯à¥‹à¤— à¤‡à¤•à¤¾à¤ˆ',0),(116596,3239,'ms','Penggunaan Unit',0),(116597,3239,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„Ø¥Ø³ØªØ¹Ù…Ø§Ù„',0),(116598,3239,'fr','UnitÃ© d\'utilisation',0),(116599,3239,'jp','ä½¿ç”¨å?˜ä½?',0),(116600,3239,'pt','Unidade de uso',0),(116601,3239,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð±Ð»Ð¾Ðº',0),(116602,3239,'es','Unidad de Uso',0),(116603,3239,'de','Nutzung-Einheit',0),(116604,3239,'en','Usage Unit',0),(116605,3240,'is','',0),(116606,3240,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ØµØ±ÙÙŠ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª',0),(116607,3240,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ØµØ±ÙÙŠ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª',0),(116608,3240,'tr','Fiyat birimi baÅŸÄ±na kullanÄ±m tutarlarÄ±nÄ±',0),(116609,3240,'pl','UÅ¼ycie przyokienny(e) jednostkowa cena',0),(116610,3240,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÑƒÑ‡Ð°ÑÑ‚ÑŠÐºÐ° Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð°',0),(116611,3240,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù‚ÛŒÙ…Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„ Unit(s)',0),(116612,3240,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ñ†ÐµÐ½Ð°',0),(116613,3240,'vi','ÄÆ¡n vá»‹ dÃ¹ng má»—i Ä‘Æ¡n vá»‹ giÃ¡',0),(116614,3240,'af','Gebruikte Eenheid(hede) per Pryseenheid',0),(116615,3240,'ro','UnitÄƒÅ£ile de utilizare per unitate de pret',0),(116616,3240,'et','Kasutus Ã¼hik(UT) hinnaÃ¼hiku kohta',0),(116617,3240,'si','Uporaba enot na enoto cena',0),(116618,3240,'ba','Penggunaan nasabah per Unit harga',0),(116619,3240,'nl','Per prijs eenheid/eenheden in gebruik',0),(116620,3240,'fi','KÃ¤yttÃ¶ infrastruktuurilaitteiden hintayksikkÃ¶Ã¤ kohti',0),(116621,3240,'no','Bruk Unit(s) per prisenhet',0),(116622,3240,'da','Brug enhed pr. prisenhed',0),(116623,3240,'ko','ê°€ê²© ë‹¨ìœ„ ë‹¹ ì‚¬ìš© ìž¥ì¹˜',0),(116624,3240,'he','×”×©×™×ž×•×© Unit(s) ×œ×›×œ ×™×—×™×“×ª ×ž×—×™×¨',0),(116625,3240,'el','Î§ÏÎ®ÏƒÎ· Î¼Î¿Î½Î¬Î´Î±Ï‚(-Ï‰Î½) Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Ï„Î¹Î¼Î®',0),(116626,3240,'zh','ç”¨æ³•å•ä½ï¼ˆä»¬ï¼‰æ¯å•ä½ä»·æ ¼\r\n',0),(116627,3240,'sv','AnvÃ¤ndning enheter per prisenhet',0),(116628,3240,'it','UnitÃ  di utilizzo prezzo unitario',0),(116629,3240,'tl','',0),(116630,3240,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(116631,3240,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤•à¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤‰à¤ªà¤¯à¥‹à¤— à¤°à¤¾à¤¯',0),(116632,3240,'ms','Penggunaan Unit(s) seunit harga',0),(116633,3240,'ar','ÙˆØ­Ø¯Ø©(Ø§Øª) Ø§Ù„Ø¥Ø³ØªØ¹Ù…Ø§Ù„ Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø© Ø³Ø¹Ø±',0),(116634,3240,'fr','UnitÃ©(s)d\'usage par prix d\'unitÃ©',0),(116635,3240,'jp','ä¾¡æ ¼å?˜ä½?ã?”ã?¨ã?®ä½¿ç”¨å?˜ä½?',0),(116636,3240,'pt','Unidade (s) de uso preÃ§o unitÃ¡rio',0),(116637,3240,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑˆÑ‚. Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ Ñ†ÐµÐ½Ñ‹',0),(116638,3240,'es','Unidad (es) de Uso(s) por unidad de precios',0),(116639,3240,'de','Verwendung Stck pro Preiseinheit',0),(116640,3240,'en','Usage Unit(s) per Price&nbsp;Unit',0),(116641,3241,'is','',0),(116642,3241,'dr','( Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ Ø¨Ø±Ø±Ø³ÙŠ Ù†Ø´Ø¯Ù‡ ',0),(116643,3241,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²  ØªØ§Ø±ÙŠØ® Ø¯Ø±ÙŠØ§ÙØª Ø³ÙØ§Ø±Ø´ ( Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ Ø¨Ø±Ø±Ø³ÙŠ Ù†Ø´Ø¯Ù‡ ',0),(116644,3241,'tr','SipariÅŸ alma tarihi <small>(denetlenmeyen kullanÄ±r sevk tarihi)</small> kullanmak',0),(116645,3241,'pl','UÅ¼yj daty otrzymania zamÃ³wienia <small>(uÅ¼ywa niezaznaczone Data wysyÅ‚ki)</small>',0),(116646,3241,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð´Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° <small>(Ð½ÐµÑ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°Ñ‚Ð°)</small>',0),(116647,3241,'ur','Ø¢Ø±ÚˆØ± ÙˆØµÙˆÙ„ Ú©ÛŒ ØªØ§Ø±ÛŒØ® <small>(ØºÛŒØ± Ù¾Ú‘ØªØ§Ù„ Ø´Ø¯Û Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø¬ÛØ§Ø² ØªØ§Ø±ÛŒØ®)</small> Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(116648,3241,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼ Ð½Ð°Ð»Ð¾Ð³Ð° <small>(ÐÐµÐ¿Ñ€Ð¾Ð²Ñ˜ÐµÑ€ÐµÐ½Ð¸ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ðµ)</small>',0),(116649,3241,'vi','Sá»­ dá»¥ng ngÃ y nháº­n Ä‘Æ°á»£c Ä‘Æ¡n hÃ ng(un-checked uses ship date)',0),(116650,3241,'af','Gebruik bestelling ontvang datum <small>(ongemerk gebruike skip datum)</small>',0),(116651,3241,'ro','UtilizaÅ£i primi data comenzii <small>(debifat utilizÄƒri nava data)</small>',0),(116652,3241,'et','Tellimuse saate kuupÃ¤eva <small>(mÃ¤rkimata kasutab lÃ¤hetuskuupÃ¤ev)</small>',0),(116653,3241,'si','PrikaÅ¾e datum naloga <small>(nepreverjene uporabe ladja datum)</small>',0),(116654,3241,'ba','Menggunakan tanggal menerima Order <small>(dicentang menggunakan kapal tanggal)</small>',0),(116655,3241,'nl','Orderdatum ontvangen <small>(niet-gecontroleerde toepassingen verzenddatum)</small> gebruiken',0),(116656,3241,'fi','KÃ¤ytetÃ¤Ã¤n tilauspÃ¤ivÃ¤n saavat <small>(tarkistamaton kÃ¤yttÃ¤Ã¤ lÃ¤hetyspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤)</small>',0),(116657,3241,'no','Bruke motta ordredatoen <small>(ukontrollert bruker forsendelsesdato)</small>',0),(116658,3241,'da','Bruge modtage ordredatoen <small>(ukontrolleret bruger skib dato)</small>',0),(116659,3241,'ko','ì£¼ë¬¸ ë°›ì„ ë‚ ì§œ <small>(í™•ì¸ ë˜ì§€ ì•Šì€ ì‚¬ìš© ë°°ì†¡ì¼)</small> ì‚¬ìš©',0),(116660,3241,'he','×œ×”×©×ª×ž×© ×ª××¨×™×š ×§×‘×œ×ª ×”×–×ž× ×” <small>(×ª××¨×™×š ×ž×©×œ×•×— ×©×™×ž×•×©×™× ×œ× ×ž×¡×•×ž×Ÿ)</small>',0);
INSERT INTO `langdef` VALUES (116661,3241,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Î»Î¬Î²ÎµÎ¹ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ <small>(Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Î±Î½ÎµÎ¾Î­Î»ÎµÎ³ÎºÏ„Î· Ï‡ÏÎ®ÏƒÎµÎ¹Ï‚)</small>',0),(116662,3241,'zh','ä½¿ç”¨è®¢å•æŽ¥æ”¶æ—¥æœŸï¼ˆå‹¾é™¤ä½¿ç”¨å‘è´§æ—¥æœŸï¼‰',0),(116663,3241,'sv','AnvÃ¤nda fÃ¥ Orderdatum <small>(oskyddad anvÃ¤nder transportdatum)</small>',0),(116664,3241,'it','Utilizzare Data ricezione dell\'ordine <small>(usi unchecked data di spedizione)</small>',0),(116665,3241,'tl','',0),(116666,3241,'th','&#3651;&#3594;&#3657;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;<br>(un-checked uses ship date)',0),(116667,3241,'hi','à¤‘à¤°à¥à¤¡à¤° à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¤à¤¿à¤¥à¤¿ <small>(à¤…à¤¨à¤¿à¤¯à¤‚à¤¤à¥à¤°à¤¿à¤¤ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¤à¤¾ à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–)</small> à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(116668,3241,'ms','Gunakan tarikh menerima perintah <small>(berdaftar menggunakan kapal tarikh)</small>',0),(116669,3241,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… \"ØªØ§Ø±ÙŠØ® ØªÙ„Ù‚ÙŠ Ø£Ù…Ø±\" <small>(ØªØ§Ø±ÙŠØ® Ø´Ø­Ù† Ø§Ù„Ø£ØºØ±Ø§Ø¶ Ø¯ÙˆÙ† Ø±Ø§Ø¯Ø¹)</small>',0),(116670,3241,'fr','Utiliser la Date de rÃ©ception de commande <small>(date d\'expÃ©dition des utilisations non contrÃ´lÃ©)</small>',0),(116671,3241,'jp','æ³¨æ–‡å?—é ˜æ—¥ã?®ä½¿ç”¨<br>ï¼ˆæœªãƒ?ã‚§ãƒƒã‚¯ã?®ã‚‚ã?®ã?¯ç™ºé€?æ—¥ã‚’ä½¿ç”¨ï¼‰',0),(116672,3241,'pt','Usar ordem receber data <small>(data de envio usa desmarcada)</small>',0),(116673,3241,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð° <small>(Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð½ÐµÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð¸Ñ€ÑƒÐµÐ¼Ð¾Ð³Ð¾ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ)</small>',0),(116674,3241,'es','Usar Fecha de RecepciÃ³n de Orden<br>(no-marcados usan fecha de envÃ­o',0),(116675,3241,'de','Verwenden Sie erhalten Bestelldatum <small>(ungeprÃ¼ften Verwendung Lieferdatum)</small>',0),(116676,3241,'en','Use Order Receive Date&nbsp;&nbsp;<small>(unchecked uses ship date)</small>',0),(116677,3242,'is','',0),(116678,3242,'dr','/ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù…Ù‡Ø§ Ø§Ø² Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¯ÙŠÚ¯Ø±',0),(116679,3242,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‚ÙŠÙ…Øª Ù‡Ø§ / Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±Ù‡Ø§ Ø§Ø² Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø¯ÙŠÚ¯Ø±',0),(116680,3242,'tr','Fiyatlar/stoklar gelen diÄŸer fiyat listesi kullanma',0),(116681,3242,'pl','Stosowanie cen/zasobÃ³w z innych Cennik',0),(116682,3242,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ†ÐµÐ½Ð¸/Ð·Ð°Ð¿Ð°ÑÐ¸ Ð¾Ñ‚ Ð´Ñ€ÑƒÐ³Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(116683,3242,'ur','Ù‚ÛŒÙ…ØªÛŒÚº/Ø§Ø³Ù¹Ø§Ú© Ø³Û’ Ø¯ÛŒÚ¯Ø± Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(116684,3242,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð¸Ð· Ð´Ñ€ÑƒÐ³Ð¸Ñ… Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(116685,3242,'vi','DÃ¹ng giÃ¡/hÃ ng tá»“n tá»« báº£ng giÃ¡ khÃ¡c ',0),(116686,3242,'af','Gebruike Pryse/Voorade vanaf ander Pryslys',0),(116687,3242,'ro','Utilizarea preÈ›urilor/stocuri la alte lista de preturi',0),(116688,3242,'et','Kasutamise hinnad/varud: muud hinnakiri',0),(116689,3242,'si','Uporaba cen/zaloge iz drugih cenik',0),(116690,3242,'ba','Menggunakan harga/saham dari daftar harga lainnya',0),(116691,3242,'nl','Gebruik prijzen/voorraden uit andere prijslijst',0),(116692,3242,'fi','KÃ¤ytÃ¤ hinnat/varastot muut hinnasto',0),(116693,3242,'no','Bruke priser/aksjer fra andre prisliste',0),(116694,3242,'da','Brug priser/aktier fra andre prisliste',0),(116695,3242,'ko','ì‚¬ìš© í•˜ ê³  ë‹¤ë¥¸ ê°€ê²© ë¦¬ìŠ¤íŠ¸ì—ì„œ ê°€ê²©/ì£¼ì‹',0),(116696,3242,'he','×”×©×ª×ž×© ×ž×—×™×¨×™×/×ž× ×™×•×ª ×©×œ ××—×¨×™× ×ž×—×™×¨×•×Ÿ',0),(116697,3242,'el','Î¤Î¹Î¼Î­Ï‚/Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î± Ï‡ÏÎ®ÏƒÎ· Î±Ï€ÏŒ Î¬Î»Î»Î± Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(116698,3242,'zh','ä½¿ç”¨æ¥è‡ªå…¶ä»–ä»·æ ¼è¡¨çš„ä»·æ ¼/åº“å­˜\r\n',0),(116699,3242,'sv','AnvÃ¤nda priser/lager frÃ¥n andra prislista',0),(116700,3242,'it','Utilizzare da altri Listino prezzi/scorte',0),(116701,3242,'tl','',0),(116702,3242,'th','&#3651;&#3594;&#3657; &#3619;&#3634;&#3588;&#3634;/&#3626;&#3605;&#3655;&#3629;&#3585; &#3592;&#3634;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3629;&#3639;&#3656;&#3609;',0),(116703,3242,'hi','à¤•à¥€à¤®à¤¤à¥‡à¤‚/à¤¸à¥à¤Ÿà¥‰à¤• à¤…à¤¨à¥à¤¯ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥‡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(116704,3242,'ms','Menggunakan harga/stok dari senarai harga lain',0),(116705,3242,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø£Ø³Ø¹Ø§Ø±/Ø§Ù„Ø£Ø±ØµØ¯Ø© Ù…Ù† \"Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\" Ø§Ù„Ø£Ø®Ø±Ù‰',0),(116706,3242,'fr','Utilisation des prix/Stocks d\'autres liste de prix',0),(116707,3242,'jp','ä»–ã?®ä¾¡æ ¼è¡¨ã?‹ã‚‰å€¤æ®µã?¨åœ¨åº«ã‚’ä½¿ç”¨',0),(116708,3242,'pt','Use os preÃ§os/Stocks de outra lista de preÃ§o',0),(116709,3242,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‹/Ð°ÐºÑ†Ð¸Ð¸ Ð¸Ð· Ð´Ñ€ÑƒÐ³Ð¸Ñ… Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(116710,3242,'es','Usar Precios/Stocks de otra lista de precios',0),(116711,3242,'de','Preise/BestÃ¤nde aus anderen Preisliste verwenden',0),(116712,3242,'en','Use Prices/Stocks from other Price List',0),(116713,3243,'is','',0),(116714,3243,'dr','/ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù…Ù‡Ø§ Ø§Ø² Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(116715,3243,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‚ÙŠÙ…Øª Ù‡Ø§ / Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±Ù‡Ø§ Ø§Ø² Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(116716,3243,'tr','Fiyatlar/hisse fiyat listesi Ã¼zerinden kullanmak',0),(116717,3243,'pl','Stosowanie cen/zapasy z cennika',0),(116718,3243,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ†ÐµÐ½Ð¸/Ð·Ð°Ð¿Ð°ÑÐ¸ Ð¾Ñ‚ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(116719,3243,'ur','Ù‚ÛŒÙ…ØªÛŒÚº/Ø§Ø³Ù¹Ø§Ú© Ø³Û’ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(116720,3243,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð¸Ð· Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°',0),(116721,3243,'vi','DÃ¹ng giÃ¡/hÃ ng tá»“n tá»« báº£ng giÃ¡ ',0),(116722,3243,'af','Gebruik Pryse/Voorrade vanaf Pryslys',0),(116723,3243,'ro','Utilizarea preÈ›urilor/stocuri din lista de preturi',0),(116724,3243,'et','Kasutamise hinnad/varud: hinnakiri',0),(116725,3243,'si','Uporaba cen/zaloge iz cenika',0),(116726,3243,'ba','Menggunakan harga/saham dari daftar harga',0),(116727,3243,'nl','Gebruik prijzen/voorraden in prijslijst',0),(116728,3243,'fi','KÃ¤ytÃ¤ hinnat/varastot hinnasto',0),(116729,3243,'no','Bruke priser/aksjer fra prisliste',0),(116730,3243,'da','Brug priser/aktier fra prisliste',0),(116731,3243,'ko','ê°€ê²©/ì£¼ì‹ ê°€ê²© ëª©ë¡ì—ì„œ ì‚¬ìš©',0),(116732,3243,'he','×”×©×ª×ž×© ×ž×—×™×¨×™×/×ž× ×™×•×ª ×ž×ª×•×š ×ž×—×™×¨×•×Ÿ',0),(116733,3243,'el','Î§ÏÎ®ÏƒÎ· Ï„Î¹Î¼ÏŽÎ½/Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î± Î±Ï€ÏŒ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(116734,3243,'zh','ä½¿ç”¨æ¥è‡ªä»·æ ¼åˆ—è¡¨çš„ä»·æ ¼/åº“å­˜\r\n',0),(116735,3243,'sv','AnvÃ¤nda priser/lager frÃ¥n prislista',0),(116736,3243,'it','Utilizzare prezzi/stock dal prezzo di listino',0),(116737,3243,'tl','',0),(116738,3243,'th','&#3651;&#3594;&#3657; &#3619;&#3634;&#3588;&#3634;/&#3626;&#3605;&#3655;&#3629;&#3585; &#3592;&#3634;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(116739,3243,'hi','à¤•à¥€à¤®à¤¤à¥‡à¤‚/à¤¸à¥à¤Ÿà¥‰à¤• à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥‡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(116740,3243,'ms','Menggunakan harga/stok dari senarai harga',0),(116741,3243,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø£Ø³Ø¹Ø§Ø±/Ø§Ù„Ø£Ø±ØµØ¯Ø© Ù…Ù† Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(116742,3243,'fr','Utilisation des prix/Stocks de liste de prix',0),(116743,3243,'jp','ä¾¡æ ¼è¡¨ã?‹ã‚‰å€¤æ®µã?¨åœ¨åº«ã‚’ä½¿ç”¨',0),(116744,3243,'pt','PreÃ§os/Stocks de uso da lista de preÃ§os',0),(116745,3243,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‹/Ð·Ð°Ð¿Ð°ÑÑ‹ Ð¸Ð· Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚Ð°',0),(116746,3243,'es','Usar Precios/Stocks de lista de precios',0),(116747,3243,'de','Preise/BestÃ¤nde aus Preisliste verwenden',0),(116748,3243,'en','Use Prices/Stocks from Price List',0),(116749,3244,'is','',0),(116750,3244,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø± Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ ',0),(116751,3244,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø± Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ ',0),(116752,3244,'tr','KullanÄ±m saÄŸ tÄ±kla-> download dosyasÄ± olarak kaydet',0),(116753,3244,'pl','Kliknij prawym przyciskiem myszy UÅ¼ycie-> Zapisz jako, aby pobraÄ‡ plik',0),(116754,3244,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð´ÐµÑÐ½Ð¸Ñ Ð±ÑƒÑ‚Ð¾Ð½-> Ð¾ÑÐ²ÐµÐ½ Ð·Ð° Ð¸Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(116755,3244,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº ØµØ­ÛŒØ­ Ú©Ø±ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº-> Ù…Ø­ÙÙˆØ¸ ÙØ§Ø¦Ù„ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Û’ Ø·ÙˆØ±',0),(116756,3244,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð´ÐµÑÐ½Ð¸ ÐºÐ»Ð¸Ðº Ð¼Ð¸ Ñ˜Ðµ Ñ‡ÑƒÐ²Ð°ÑšÐµ Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(116757,3244,'vi','DÃ¹ng nháº¥p chuá»™t pháº£i->sao lÆ°u Ä‘á»ƒ táº£i há»“ sÆ¡',0),(116758,3244,'af','Gebruik regte klik Stoor-> oor die lÃªer aflaai',0),(116759,3244,'ro','Utilizarea faceÅ£i clic dreapta-> Save as pentru a descarca fisierul',0),(116760,3244,'et','Kasuta parem klÃµps-> pÃ¤Ã¤sta mis faili alla laadida',0),(116761,3244,'si','Uporabo desni klik-> shrani, da prenesete datoteko',0),(116762,3244,'ba','Klik kanan digunakan-> menyimpan untuk men-download file',0),(116763,3244,'nl','Gebruik Klik met de rechtermuisknop-> opslaan over downloaden naar de vijl',0),(116764,3244,'fi','Apu aivan click on-> Tallenna nimellÃ¤ ladata tiedoston',0),(116765,3244,'no','Bruk HÃ¸yreklikk-> lagre som Ã¥ laste ned filen',0),(116766,3244,'da','Brug lige falde i hak-> Gem, Hent filen',0),(116767,3244,'ko','ì‚¬ìš© í•˜ ì—¬ ë§ˆìš°ìŠ¤ ì˜¤ë¥¸ìª½ ë‹¨ì¶”ë¡œ íŒŒì¼ì„ ë‹¤ìš´ë¡œë“œì— ê´€í•´ì„œëŠ” ì €ìž¥->',0),(116768,3244,'he','×”×©×™×ž×•×© ×œ×—×¦×Ÿ ×™×ž× ×™-> ×©×ž×•×¨ ×›×“×™ ×œ×”×•×¨×™×“ ××ª ×”×§×•×‘×¥',0),(116769,3244,'el','Î§ÏÎ®ÏƒÎ· ÎºÎ¬Î½Ï„Îµ Î´ÎµÎ¾Î¯ ÎºÎ»Î¹Îº ÏƒÏ„Î¿-> Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· ÏŽÏƒÏ„Îµ Î½Î± ÎºÎ±Ï„ÎµÎ²Î¬ÏƒÎµÏ„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(116770,3244,'zh','ä½¿ç”¨æƒé™ï¼Œç‚¹å‡»>â€œå¦å­˜ä¸ºä¸‹è½½æ–‡ä»¶\r\n',0),(116771,3244,'sv','AnvÃ¤nd rÃ¤tt klick-> spara att ladda ner filen',0),(116772,3244,'it','Uso click destro-> salva per scaricare il file.',0),(116773,3244,'tl','',0),(116774,3244,'th','&#3651;&#3594;&#3657;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3588;&#3621;&#3636;&#3658;&#3585;->&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;&#3652;&#3615;&#3621;&#3660;',0),(116775,3244,'hi','à¤‰à¤ªà¤¯à¥‹à¤— à¤¦à¤¾à¤¯à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚ à¤•à¥‹ à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤«à¤¼à¤¾à¤‡à¤² à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚->',0),(116776,3244,'ms','Klik kanan menggunakan-> Simpan untuk muat turun fail',0),(116777,3244,'ar','-> Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ù‚ Ø§Ù†Ù‚Ø± Ø­ÙØ¸ ÙÙŠÙ…Ø§ ÙŠØªØ¹Ù„Ù‚ Ø¨ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ù…Ù„Ù',0),(116778,3244,'fr','Utilisation clic droit-> enregistrer quant Ã  tÃ©lÃ©charger le fichier',0),(116779,3244,'jp','ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã?™ã‚‹ã?«ã?¯ã€€å?³ã‚¯ãƒªãƒƒã‚¯ãƒ¼ï¼žåˆ¥å??ã?§ä¿?å­˜ã‚’ã?—ã?¦ä¸‹ã?•ã?„',0),(116780,3244,'pt','Clique direito uso-> salvar como para baixar o arquivo.',0),(116781,3244,'ru','-> Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€Ð°Ð²Ð¾Ð¹ ÐºÐ½Ð¾Ð¿ÐºÐ¾Ð¹ Ð¼Ñ‹ÑˆÐ¸ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ ÐºÐ°Ðº ÑÐºÐ°Ñ‡Ð°Ñ‚ÑŒ Ñ„Ð°Ð¹Ð»',0),(116782,3244,'es','Usar click Derecho->Guardar para descargar el file ',0),(116783,3244,'de','Verwendung Rechtsklick-> speichern, die Datei herunterzuladen',0),(116784,3244,'en','Use Right click->Save as to download the file',0),(116785,3245,'is','',0),(116786,3245,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø§Ø² Ø±ÙˆÙŠ Ø«Ø¨Øª Ù…ØµØ§Ø±Ù Ø¯ÙŠÚ¯Ø±',0),(116787,3245,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø§Ø² Ø±ÙˆÙŠ Ø«Ø¨Øª Ù…ØµØ§Ø±Ù Ø¯ÙŠÚ¯Ø±',0),(116788,3245,'tr','Hisse senedi bilgileri diÄŸer kullanÄ±m giriÅŸi kullanÄ±n',0),(116789,3245,'pl','KorzystaÄ‡ z zasobÃ³w informacji z innych pozycji uÅ¼ytkowania',0),(116790,3245,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÑÑŠÑÑ‚Ð°Ð² Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ñ‚ Ð´Ñ€ÑƒÐ³Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°ÐµÐ¼Ð¾ÑÑ‚',0),(116791,3245,'ur','Ø¯ÛŒÚ¯Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø³Û’ Ø§Ø³Ù¹Ø§Ú© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(116792,3245,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð˜Ð½Ñ„Ð¾ Ð¸Ð· Ð´Ñ€ÑƒÐ³Ðµ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(116793,3245,'vi','Sá»­ dá»¥ng thÃ´ng tin hÃ ng tá»“n kho tá»« má»™t entry khÃ¡c',0),(116794,3245,'af','Gebruik Voorraadinligting vanaf ander gebruiksinskrywing',0),(116795,3245,'ro','UtilizaÅ£i Info stoc de la alte intrare de utilizare',0),(116796,3245,'et','Kasutamine laos infot teiste kasutus kanne',0),(116797,3245,'si','Uporaba Stock Info iz druge uporabe vstop',0),(116798,3245,'ba','Menggunakan Info saham dari catatan penggunaan lainnya',0),(116799,3245,'nl','Gebruik voorraad Info van andere gebruikspost',0),(116800,3245,'fi','KÃ¤yttÃ¤Ã¤ varastossa Info pÃ¶ydissÃ¤Ã¤n kÃ¤yttÃ¶',0),(116801,3245,'no','Bruk lager Info fra andre forbrukspost',0),(116802,3245,'da','Brug Stock Info fra andre forbrugspost',0),(116803,3245,'ko','ì£¼ì‹ ì •ë³´ë¥¼ ì‚¬ìš© í•˜ ì—¬ ë‹¤ë¥¸ ì‚¬ìš© í•­ëª©ì—ì„œ',0),(116804,3245,'he','×©×™×ž×•×© ×¤×¨×˜×™ ×ž×œ××™ ×©×œ ×¢×¨×š ×©×™×ž×•×© ××—×¨',0),(116805,3245,'el','Î§ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î±Ï€ÏŒ Î¬Î»Î»Î· ÎµÎ¯ÏƒÎ¿Î´Î¿ Ï‡ÏÎ®ÏƒÎ·',0),(116806,3245,'zh','ä½¿ç”¨æ¥è‡ªå…¶ä»–ç”¨æ³•æ¡ç›®çš„åº“å­˜ä¿¡æ¯\r\n',0),(116807,3245,'sv','AnvÃ¤nda lager information frÃ¥n andra anvÃ¤ndning posten',0),(116808,3245,'it','Uso magazzino Info da altre voce utilizzo',0),(116809,3245,'tl','',0),(116810,3245,'th','&#3651;&#3594;&#3657;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3605;&#3655;&#3629;&#3585;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(116811,3245,'hi','à¤…à¤¨à¥à¤¯ à¤‰à¤ªà¤¯à¥‹à¤— à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¥‡ à¤¶à¥‡à¤¯à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(116812,3245,'ms','Gunakan maklumat saham daripada kemasukan penggunaan lain-lain',0),(116813,3245,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… \"Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†\" Ù…Ù† Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø®Ø±Ù‰',0),(116814,3245,'fr','Info Stock utilisation d\'autre entrÃ©e d\'utilisation',0),(116815,3245,'jp','ä»–ã?®ä½¿ç”¨ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?‹ã‚‰åœ¨åº«æƒ…å ±ã‚’ä½¿ç”¨',0),(116816,3245,'pt','Usar informaÃ§Ã£o de estoque de outra entrada de uso',0),(116817,3245,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ñ‚ Ð´Ñ€ÑƒÐ³Ð¸Ñ… Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(116818,3245,'es','Usar Info de Stock de otra entrada de uso',0),(116819,3245,'de','Lager-Info aus anderen Nutzung-Eintrag verwenden',0),(116820,3245,'en','Use Stock Info from other usage entry',0),(116821,3246,'is','',0),(116822,3246,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(116823,3246,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(116824,3246,'tr','Hareket tarihini kullan',0),(116825,3246,'pl','UÅ¼yj daty transakcji',0),(116826,3246,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð´Ð°Ñ‚Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(116827,3246,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(116828,3246,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(116829,3246,'vi','DÃ¹ng ngÃ y giao dá»‹ch',0),(116830,3246,'af','Gebruik Transaksiedatum',0),(116831,3246,'ro','UtilizaÅ£i data tranzactiei',0),(116832,3246,'et','Kasutage tehingu kuupÃ¤ev',0),(116833,3246,'si','Uporabite datum transakcije',0),(116834,3246,'ba','Menggunakan tanggal transaksi',0),(116835,3246,'nl','Gebruik de datum van de transactie',0),(116836,3246,'fi','KÃ¤ytÃ¤ tapahtumapÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(116837,3246,'no','Bruk transaksjonsdato',0),(116838,3246,'da','Bruge posteringsdato',0),(116839,3246,'ko','íŠ¸ëžœìž­ì…˜ ë‚ ì§œ ì‚¬ìš©',0),(116840,3246,'he','×”×©×ª×ž×© ×ª××¨×™×š ×ª× ×•×¢×”',0),(116841,3246,'el','Î§ÏÎ®ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(116842,3246,'zh','ä½¿ç”¨äº¤æ˜“æ—¥æœŸ\r\n',0),(116843,3246,'sv','AnvÃ¤nda transaktionsdatum',0),(116844,3246,'it','Utilizzare Data transazione',0),(116845,3246,'tl','',0),(116846,3246,'th','&#3651;&#3594;&#3657;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(116847,3246,'hi','à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(116848,3246,'ms','Gunakan tarikh urus niaga',0),(116849,3246,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø±ÙƒØ©',0),(116850,3246,'fr','Utiliser la Date de Transaction',0),(116851,3246,'jp','å‡¦ç?†æ—¥ã?®ä½¿ç”¨',0),(116852,3246,'pt','Usar data de transaÃ§Ã£o',0),(116853,3246,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ð°Ñ‚Ñƒ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(116854,3246,'es','Usar Fecha De La TransacciÃ³n',0),(116855,3246,'de','Buchungsdatum verwenden',0),(116856,3246,'en','Use Transaction Date',0),(116857,3247,'is','',0),(116858,3247,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø§ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(116859,3247,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø§ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(116860,3247,'tr','Ã‡alÄ±ÅŸma tÃ¼rÃ¼ ile kullanma',0),(116861,3247,'pl','Za pomocÄ… pracy typu',0),(116862,3247,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(116863,3247,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(116864,3247,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÐ° Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(116865,3247,'vi','DÃ¹ng vá»›i loáº¡i cÃ´ng viá»‡c nÃ o',0),(116866,3247,'af','Werk tipe gebruik',0),(116867,3247,'ro','UtilizaÅ£i cu tipul de munca',0),(116868,3247,'et','Kasutage tÃ¶Ã¶ tÃ¼Ã¼p',0),(116869,3247,'si','Uporabite z vrsto dela',0),(116870,3247,'ba','Gunakan dengan jenis pekerjaan',0),(116871,3247,'nl','Gebruiken met werksoort',0),(116872,3247,'fi','KÃ¤ytÃ¤ tyÃ¶n tyyppi',0),(116873,3247,'no','Bruke med arbeidstype',0),(116874,3247,'da','Brug med arbejdstype',0),(116875,3247,'ko','ìž‘ì—… ì¢…ë¥˜ ì‚¬ìš©',0),(116876,3247,'he','×”×©×ª×ž×© ×‘×¡×•×’ ×¢×‘×•×“×” ×–×•',0),(116877,3247,'el','Î§ÏÎ®ÏƒÎ· Î¼Îµ Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(116878,3247,'zh','ä½¿ç”¨ä¸Žå·¥ä½œç±»åž‹\r\n',0),(116879,3247,'sv','AnvÃ¤nda med arbetstyp',0),(116880,3247,'it','Utilizzare con il tipo di lavoro',0),(116881,3247,'tl','',0),(116882,3247,'th','&#3651;&#3594;&#3657;&#3585;&#3633;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(116883,3247,'hi','à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤¸à¤¾à¤¥ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(116884,3247,'ms','Gunakan dengan jenis kerja',0),(116885,3247,'ar','ØªØ³ØªØ®Ø¯Ù… Ù…Ø¹ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(116886,3247,'fr','Utiliser avec le type de travail',0),(116887,3247,'jp','ä½œæ¥­ã‚¿ã‚¤ãƒ—ã?¨ä½¿ç”¨',0),(116888,3247,'pt','Usar com o tipo de trabalho',0),(116889,3247,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÐ°ÐºÐ¾Ð¹ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(116890,3247,'es','Usar Hoy Como Fecha De La TransacciÃ³n',0),(116891,3247,'de','Verwenden Sie mit Arbeitstyp',0),(116892,3247,'en','Use with work type',0),(116893,3248,'is','',0),(116894,3248,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(116895,3248,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(116896,3248,'tr','KullanÄ±lan',0),(116897,3248,'pl','UÅ¼ywane',0),(116898,3248,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°',0),(116899,3248,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(116900,3248,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(116901,3248,'vi','ÄÃ£ Sá»­ dá»¥ng',0),(116902,3248,'af','Gebruik',0),(116903,3248,'ro','Folosit',0),(116904,3248,'et','Kasutatud',0),(116905,3248,'si','Uporablja',0),(116906,3248,'ba','Digunakan',0),(116907,3248,'nl','Gebruikt',0),(116908,3248,'fi','KÃ¤yttÃ¤Ã¤',0),(116909,3248,'no','Brukt',0),(116910,3248,'da','Brugt',0),(116911,3248,'ko','ì‚¬ìš©',0),(116912,3248,'he','×ž×©×•×ž×©',0),(116913,3248,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹',0),(116914,3248,'zh','ç”¨äºŽ\r\n',0),(116915,3248,'sv','AnvÃ¤nds',0),(116916,3248,'it','Usato',0),(116917,3248,'tl','',0),(116918,3248,'th','&#3651;&#3594;&#3657;&#3649;&#3621;&#3657;&#3623;',0),(116919,3248,'hi','à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(116920,3248,'ms','Digunakan',0),(116921,3248,'ar','ÙŠØ³ØªØ®Ø¯Ù…',0),(116922,3248,'fr','UtilisÃ©',0),(116923,3248,'jp','ä½¿ç”¨æ¸ˆ',0),(116924,3248,'pt','Usado',0),(116925,3248,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ',0),(116926,3248,'es','Usado',0),(116927,3248,'de','Verwendet',0),(116928,3248,'en','Used',0),(116929,3249,'is','',0),(116930,3249,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¯Ø± Ù‡Ø±',0),(116931,3249,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¯Ø± Ù‡Ø±',0),(116932,3249,'tr','BaÅŸÄ±na kullanÄ±lan',0),(116933,3249,'pl','Na',0),(116934,3249,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð·Ð°',0),(116935,3249,'ur','ÙÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§',0),(116936,3249,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¿Ð¾',0),(116937,3249,'vi','DÃ¹ng má»—i',0),(116938,3249,'af','Gebruik Per',0),(116939,3249,'ro','Pentru fiecare',0),(116940,3249,'et','On kasutatud',0),(116941,3249,'si','Uporabljajo na',0),(116942,3249,'ba','Digunakan Per',0),(116943,3249,'nl','Gebruikt Per',0),(116944,3249,'fi','Kohti',0),(116945,3249,'no','Brukes Per',0),(116946,3249,'da','Brugt pr',0),(116947,3249,'ko','ë‹¹ ì‚¬ìš©',0),(116948,3249,'he','×©×™×ž×•×© ×œ×›×œ',0),(116949,3249,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ ÏƒÎµ ÎºÎ¬Î¸Îµ',0),(116950,3249,'zh','ç”¨äºŽæ¯\r\n',0),(116951,3249,'sv','AnvÃ¤nds Per',0),(116952,3249,'it','Utilizzato per ogni',0),(116953,3249,'tl','',0),(116954,3249,'th','&#3651;&#3594;&#3657;&#3605;&#3656;&#3629;',0),(116955,3249,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(116956,3249,'ms','Digunakan setiap',0),(116957,3249,'ar','ØªØ³ØªØ®Ø¯Ù… ÙƒÙ„',0),(116958,3249,'fr','UtilisÃ© par',0),(116959,3249,'jp','ï½žã?”ã?¨ã?®ä½¿ç”¨',0),(116960,3249,'pt','Usado por',0),(116961,3249,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð²',0),(116962,3249,'es','Usado Por',0),(116963,3249,'de','Pro',0),(116964,3249,'en','Used Per',0),(116965,3250,'is','',0),(116966,3250,'dr','Ù…Ù‚Ø¯Ø§Ø±  Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(116967,3250,'pr','Ù…Ù‚Ø¯Ø§Ø±  Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(116968,3250,'tr','KullanÄ±lan miktar',0),(116969,3250,'pl','IloÅ›Ä‡ uÅ¼ywanych',0),(116970,3250,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(116971,3250,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø´Ø¯Û ØªØ¹Ø¯Ø§Ø¯',0),(116972,3250,'sr','ÐšÐ¾Ñ€Ð¸ÑˆÑ›ÐµÐ½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(116973,3250,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ sá»­ dá»¥ng',0),(116974,3250,'af','Gebruikte Hoeveelheid',0),(116975,3250,'ro','Cantitatea folosita',0),(116976,3250,'et','Kasutatud kogus',0),(116977,3250,'si','Porabljeno koliÄino',0),(116978,3250,'ba','Kuantitas yang digunakan',0),(116979,3250,'nl','Gebruikte hoeveelheid',0),(116980,3250,'fi','KÃ¤ytetty mÃ¤Ã¤rÃ¤',0),(116981,3250,'no','Brukt antall',0),(116982,3250,'da','Anvendte mÃ¦ngde',0),(116983,3250,'ko','ì‚¬ìš©ëœ ìˆ˜ëŸ‰',0),(116984,3250,'he','×›×ž×•×ª ×‘×©×™×ž×•×©',0),(116985,3250,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(116986,3250,'zh','ä½¿ç”¨é‡\r\n',0),(116987,3250,'sv','AnvÃ¤nda kvantiteten',0),(116988,3250,'it','QuantitÃ  usate',0),(116989,3250,'tl','',0),(116990,3250,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3649;&#3621;&#3657;&#3623;',0),(116991,3250,'hi','à¤ªà¥à¤°à¤¯à¥à¤•à¥à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(116992,3250,'ms','Kuantiti digunakan',0),(116993,3250,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(116994,3250,'fr','QuantitÃ© utilisÃ©e',0),(116995,3250,'jp','ä½¿ç”¨æ¸ˆæ•°é‡?',0),(116996,3250,'pt','Quantidade utilizada',0),(116997,3250,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð½Ð¾Ðµ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(116998,3250,'es','Cantidad Usada',0),(116999,3250,'de','Verwendete Menge',0),(117000,3250,'en','Used Quantity',0),(117001,3251,'is','',0),(117002,3251,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(117003,3251,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(117004,3251,'tr','KullanÄ±lan toplamlarÄ±',0),(117005,3251,'pl','Sumy uÅ¼ywane',0),(117006,3251,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸Ñ‚Ðµ ÑÑƒÐ¼Ð¸',0),(117007,3251,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø´Ø¯Û Ù…ÛŒØ²Ø§Ù†',0),(117008,3251,'sr','ÐŸÐ¾Ð»Ð¾Ð²Ð½Ð° Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(117009,3251,'vi','Tá»•ng cá»™ng sá»­ dá»¥ng',0),(117010,3251,'af','Gebruikte Totale',0),(117011,3251,'ro','Folosit totaluri',0),(117012,3251,'et','Kasutatud kogusummad',0),(117013,3251,'si','Uporabljene vsote',0),(117014,3251,'ba','Total digunakan',0),(117015,3251,'nl','Gebruikte totalen',0),(117016,3251,'fi','KÃ¤ytetyt summat',0),(117017,3251,'no','Brukte totaler',0),(117018,3251,'da','Brugte totaler',0),(117019,3251,'ko','ì‚¬ìš©ëœ í•©ê³„',0),(117020,3251,'he','×¡×™×›×•×ž×™× ×ž×©×•×ž×©',0),(117021,3251,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ ÏƒÏÎ½Î¿Î»Î±',0),(117022,3251,'zh','äºŒæ‰‹æ±‡æ€»\r\n',0),(117023,3251,'sv','Begagnade summor',0),(117024,3251,'it','Totali usati',0),(117025,3251,'tl','',0),(117026,3251,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;',0),(117027,3251,'hi','à¤ªà¥à¤°à¤¯à¥à¤•à¥à¤¤ à¤¯à¥‹à¤—à¥‹à¤‚',0),(117028,3251,'ms','Jumlah yang digunakan',0),(117029,3251,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(117030,3251,'fr','Totaux utilisÃ©s',0),(117031,3251,'jp','ä½¿ç”¨æ¸ˆç·?è¨ˆ',0),(117032,3251,'pt','Totais de usados',0),(117033,3251,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑŽÑ‚ÑÑ Ð¸Ñ‚Ð¾Ð³Ð¸',0),(117034,3251,'es','Totales Usados',0),(117035,3251,'de','Verwendeten Summen',0),(117036,3251,'en','Used Totals',0),(117037,3252,'is','',0),(117038,3252,'dr','ÙƒØ§Ø±Ø¨Ø±',0),(117039,3252,'pr','ÙƒØ§Ø±Ø¨Ø±',0),(117040,3252,'tr','KullanÄ±cÄ±',0),(117041,3252,'pl','UÅ¼ytkownik',0),(117042,3252,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(117043,3252,'ur','ØµØ§Ø±Ù',0),(117044,3252,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº',0),(117045,3252,'vi','NgÆ°á»i Sá»­ Dá»¥ng',0),(117046,3252,'af','Gebruiker',0),(117047,3252,'ro','Utilizator',0),(117048,3252,'et','Kasutaja',0),(117049,3252,'si','Uporabnik',0),(117050,3252,'ba','Pengguna',0),(117051,3252,'nl','Gebruiker',0),(117052,3252,'fi','KÃ¤yttÃ¤jÃ¤',0),(117053,3252,'no','Bruker',0),(117054,3252,'da','Bruger',0),(117055,3252,'ko','ì‚¬ìš©ìž',0),(117056,3252,'he','×ž×©×ª×ž×©',0),(117057,3252,'el','Î§ÏÎ®ÏƒÏ„Î·',0),(117058,3252,'zh','ç”¨æˆ·\r\n',0),(117059,3252,'sv','AnvÃ¤ndaren',0),(117060,3252,'it','Utente',0),(117061,3252,'tl','',0),(117062,3252,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(117063,3252,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(117064,3252,'ms','Pengguna',0),(117065,3252,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(117066,3252,'fr','Utilisateur',0),(117067,3252,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(117068,3252,'pt','UsuÃ¡rio',0),(117069,3252,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ',0),(117070,3252,'es','Usuario',0),(117071,3252,'de','Benutzer',0),(117072,3252,'en','User',0),(117073,3253,'is','',0),(117074,3253,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø±',0),(117075,3253,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø±',0),(117076,3253,'tr','KullanÄ±cÄ± Ekle',0),(117077,3253,'pl','Dodaj uÅ¼ytkownika',0),(117078,3253,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(117079,3253,'ur','ØµØ§Ø±Ù Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(117080,3253,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(117081,3253,'vi','ThÃªm NgÆ°á»i Sá»­ Dá»¥ng',0),(117082,3253,'af','Gebruiker Skep',0),(117083,3253,'ro','Adauga Utilizator',0),(117084,3253,'et','Kasutaja Lisamine',0),(117085,3253,'si','Uporabnik doda',0),(117086,3253,'ba','Tambahkan pengguna',0),(117087,3253,'nl','Gebruiker toevoegen',0),(117088,3253,'fi','KÃ¤yttÃ¤jÃ¤n lisÃ¤Ã¤misen',0),(117089,3253,'no','Brukeren legge til',0),(117090,3253,'da','Brugeren tilfÃ¸je',0),(117091,3253,'ko','ì‚¬ìš©ìž ì¶”ê°€',0),(117092,3253,'he','×”×•×¡×¤×ª ×ž×©×ª×ž×©',0),(117093,3253,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(117094,3253,'zh','ç”¨æˆ·æ·»åŠ \r\n',0),(117095,3253,'sv','AnvÃ¤ndaren lÃ¤gger till',0),(117096,3253,'it','Aggiungi utente',0),(117097,3253,'tl','',0),(117098,3253,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(117099,3253,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(117100,3253,'ms','Tambah pengguna',0),(117101,3253,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø³ØªØ®Ø¯Ù…',0),(117102,3253,'fr','Ajouter utilisateur',0),(117103,3253,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®è¿½åŠ ',0),(117104,3253,'pt','Adicionar usuÃ¡rio',0),(117105,3253,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(117106,3253,'es','Usuario Agregar',0),(117107,3253,'de','Benutzer hinzufÃ¼gen',0),(117108,3253,'en','User Add',0),(117109,3254,'is','',0),(117110,3254,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(117111,3254,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(117112,3254,'tr','KullanÄ±cÄ± baÅŸarÄ±yla eklendi.',0),(117113,3254,'pl','UÅ¼ytkownik pomyÅ›lnie dodana.',0),(117114,3254,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(117115,3254,'ur','ØµØ§Ø±Ù Ù†Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(117116,3254,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(117117,3254,'vi','ThÃªm NgÆ°á»i Sá»­ Dá»¥ng thÃ nh cÃ´ng',0),(117118,3254,'af','Gebruiker suksesvol geskep.',0),(117119,3254,'ro','Utilizator adaugat cu succes',0),(117120,3254,'et','Kasutaja lisati edukalt',0),(117121,3254,'si','Uporabnik uspeÅ¡no dodana.',0),(117122,3254,'ba','Pengguna yang ditambahkan berhasil.',0),(117123,3254,'nl','Gebruiker successvol toegevoegd',0),(117124,3254,'fi','KÃ¤yttÃ¤jÃ¤n lisÃ¤Ã¤minen onnistui.',0),(117125,3254,'no','Brukeren ble lagt til.',0),(117126,3254,'da','Brugeren tilfÃ¸jet.',0),(117127,3254,'ko','ì‚¬ìš©ìžê°€ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í–ˆìŠµë‹ˆë‹¤.',0),(117128,3254,'he','×ž×©×ª×ž×© × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(117129,3254,'el','Î§ÏÎ®ÏƒÏ„Î· Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(117130,3254,'zh','ç”¨æˆ·æ·»åŠ æˆåŠŸã€‚\r\n',0),(117131,3254,'sv','AnvÃ¤ndaren lagts till.',0),(117132,3254,'it','Utente aggiunto con successo.',0),(117133,3254,'tl','',0),(117134,3254,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(117135,3254,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¥‡ à¤—à¤à¥¤',0),(117136,3254,'ms','Pengguna berjaya menambah.',0),(117137,3254,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¨Ù†Ø¬Ø§Ø­',0),(117138,3254,'fr','Utilisateur ajoutÃ© avec succÃ¨s.',0),(117139,3254,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(117140,3254,'pt','UsuÃ¡rio adicionado com Ãªxito.',0),(117141,3254,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(117142,3254,'es','Usuario agregado exitosamente',0),(117143,3254,'de','Benutzer wurde erfolgreich hinzugefÃ¼gt.',0),(117144,3254,'en','User added successfully.',0),(117145,3255,'is','',0),(117146,3255,'dr','ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(117147,3255,'pr','ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(117148,3255,'tr','KullanÄ±cÄ± baÅŸarÄ±yla silindi.',0),(117149,3255,'pl','UÅ¼ytkownik pomyÅ›lnie usuniÄ™ty.',0),(117150,3255,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(117151,3255,'ur','ØµØ§Ø±Ù Ù†Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø±Ø¯ÛŒØ§ Û”',0),(117152,3255,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(117153,3255,'vi','XÃ³a NgÆ°á»i Sá»­ Dá»¥ng thÃ nh cÃ´ng',0),(117154,3255,'af','Gebruiker suksesvol geskrap.',0),(117155,3255,'ro','Utilizator sters cu succes',0),(117156,3255,'et','Kasutaja kustutati edukalt',0),(117157,3255,'si','Uporabnik uspeÅ¡no izbrisana.',0),(117158,3255,'ba','User berhasil dihapus.',0),(117159,3255,'nl','Gebruiker verwijderd.',0),(117160,3255,'fi','KÃ¤yttÃ¤jÃ¤ on poistettu.',0),(117161,3255,'no','Brukeren ble slettet.',0),(117162,3255,'da','Brugeren slettet.',0),(117163,3255,'ko','ì‚¬ìš©ìžê°€ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í–ˆìŠµë‹ˆë‹¤.',0),(117164,3255,'he','×ž×©×ª×ž×© × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(117165,3255,'el','Î§ÏÎ®ÏƒÏ„Î· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(117166,3255,'zh','ç”¨æˆ·å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(117167,3255,'sv','AnvÃ¤ndaren raderades.',0),(117168,3255,'it','Utente cancellato con successo.',0),(117169,3255,'tl','',0),(117170,3255,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3606;&#3641;&#3585;&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;&#3649;&#3621;&#3657;&#3623;',0),(117171,3255,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(117172,3255,'ms','Pengguna yang dihapuskan dengan jayanya.',0),(117173,3255,'ar','Ø­Ø°Ù Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¨Ù†Ø¬Ø§Ø­',0),(117174,3255,'fr','Utilisateur supprimÃ© avec succÃ¨s.',0),(117175,3255,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(117176,3255,'pt','UsuÃ¡rio excluÃ­do com sucesso.',0),(117177,3255,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½.',0),(117178,3255,'es','Usuario eliminado exitosamente',0),(117179,3255,'de','Benutzer erfolgreich gelÃ¶scht.',0),(117180,3255,'en','User deleted successfully.',0),(117181,3256,'is','',0),(117182,3256,'dr','Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±',0),(117183,3256,'pr','Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±',0),(117184,3256,'tr','KullanÄ±cÄ± adÄ±',0),(117185,3256,'pl','Nazwa uÅ¼ytkownika',0),(117186,3256,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ',0),(117187,3256,'ur','ØµØ§Ø±Ù Ú©Ø§ Ù†Ø§Ù…',0),(117188,3256,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ',0),(117189,3256,'vi','TÃªn NgÆ°á»i Sá»­ Dá»¥ng',0),(117190,3256,'af','Gebruikernaam',0),(117191,3256,'ro','Nume Utilizator',0),(117192,3256,'et','Kasutajanimi',0),(117193,3256,'si','UporabniÅ¡ko ime',0),(117194,3256,'ba','Nama pengguna',0),(117195,3256,'nl','Gebruikersnaam',0),(117196,3256,'fi','KÃ¤yttÃ¤jÃ¤nimi',0),(117197,3256,'no','Brukernavn',0),(117198,3256,'da','Brugernavn',0),(117199,3256,'ko','ì‚¬ìš©ìž ì´ë¦„',0),(117200,3256,'he','×©× ×ž×©×ª×ž×©',0),(117201,3256,'el','ÎŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î·',0),(117202,3256,'zh','ç”¨æˆ·å\r\n',0),(117203,3256,'sv','AnvÃ¤ndarnamn',0),(117204,3256,'it','Nome utente',0),(117205,3256,'tl','',0),(117206,3256,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(117207,3256,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤®',0),(117208,3256,'ms','Nama pengguna',0),(117209,3256,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(117210,3256,'fr','Nom d\'utilisateur',0),(117211,3256,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼å??',0),(117212,3256,'pt','Nome de usuÃ¡rio',0),(117213,3256,'ru','Ð˜Ð¼Ñ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(117214,3256,'es','Nombre de Usuario',0),(117215,3256,'de','Benutzername',0),(117216,3256,'en','User Name',0),(117217,3257,'is','',0),(117218,3257,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(117219,3257,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(117220,3257,'tr','KullanÄ±cÄ± adÄ± baÅŸarÄ±yla eklendi',0),(117221,3257,'pl','Nazwa uÅ¼ytkownika dodane pomyÅ›lnie',0),(117222,3257,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(117223,3257,'ur','ØµØ§Ø±Ù Ù†Ø§Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(117224,3257,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(117225,3257,'vi','ThÃªm TÃªn NgÆ°á»i Sá»­ Dá»¥ng thÃ nh cÃ´ng',0),(117226,3257,'af','Gebruikernaam suksesvol geskep',0),(117227,3257,'ro','Numele de utilizator adÄƒugat cu succes',0),(117228,3257,'et','Kasutajatunnus lisamine Ãµnnestus',0),(117229,3257,'si','UporabniÅ¡ko ime dodano uspeÅ¡no',0),(117230,3257,'ba','Nama pengguna ditambahkan berhasil',0),(117231,3257,'nl','De naam van de gebruiker toegevoegd',0),(117232,3257,'fi','KÃ¤yttÃ¤jÃ¤nimen lisÃ¤Ã¤minen onnistui',0),(117233,3257,'no','Brukernavnet ble lagt til',0),(117234,3257,'da','Brugernavn tilfÃ¸jet',0),(117235,3257,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ëœ ì‚¬ìš©ìž ì´ë¦„',0),(117236,3257,'he','×©× ×ž×©×ª×ž×© × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(117237,3257,'el','ÎŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(117238,3257,'zh','ç”¨æˆ·åæ·»åŠ æˆåŠŸ\r\n',0),(117239,3257,'sv','AnvÃ¤ndarnamn som lagts',0),(117240,3257,'it','Nome utente aggiunto con successo',0),(117241,3257,'tl','',0),(117242,3257,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3626;&#3635;&#3648;&#3655;&#3619;&#3655;&#3592;',0),(117243,3257,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤®',0),(117244,3257,'ms','Nama pengguna yang berjaya menambah',0),(117245,3257,'ar','Ø£Ø¶ÙŠÙ Ø¥Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¨Ù†Ø¬Ø§Ø­',0),(117246,3257,'fr','Nom d\'utilisateur ajoutÃ© avec succÃ¨s',0),(117247,3257,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼å??ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(117248,3257,'pt','Nome de usuÃ¡rio adicionado com sucesso',0),(117249,3257,'ru','Ð˜Ð¼Ñ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾',0),(117250,3257,'es','Nombre de Usuario agregado exitosamente',0),(117251,3257,'de','Benutzernamen, die erfolgreich hinzugefÃ¼gt',0),(117252,3257,'en','User Name added successfully',0),(117253,3258,'is','',0),(117254,3258,'dr','Ø­Ø°Ù Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(117255,3258,'pr','Ø­Ø°Ù Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(117256,3258,'tr','KullanÄ±cÄ± adÄ± baÅŸarÄ±yla silindi',0),(117257,3258,'pl','Nazwa uÅ¼ytkownika, usuniÄ™te pomyÅ›lnie',0),(117258,3258,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(117259,3258,'ur','ØµØ§Ø±Ù Ù†Ø§Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(117260,3258,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(117261,3258,'vi','XÃ³a TÃªn NgÆ°á»i Sá»­ Dá»¥ng thÃ nh cÃ´ng',0),(117262,3258,'af','Gebruikernaam suksesvol geskrap',0),(117263,3258,'ro','Nume de utilizator ÅŸters cu succes',0),(117264,3258,'et','Kasutajatunnuse kustutamine Ãµnnestus',0),(117265,3258,'si','UporabniÅ¡ko ime uspeÅ¡no izbrisana',0),(117266,3258,'ba','Nama pengguna dihapus berhasil',0),(117267,3258,'nl','De naam van de gebruiker verwijderd',0),(117268,3258,'fi','KÃ¤yttÃ¤jÃ¤nimi poistettu',0),(117269,3258,'no','Brukernavn slettet',0),(117270,3258,'da','Brugernavnet slettet',0),(117271,3258,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì‚¬ìš©ìž ì´ë¦„',0),(117272,3258,'he','×©× ×ž×©×ª×ž×© × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(117273,3258,'el','ÎŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(117274,3258,'zh','ç”¨æˆ·ååˆ é™¤æˆåŠŸ\r\n',0),(117275,3258,'sv','AnvÃ¤ndarnamn raderades',0),(117276,3258,'it','Nome utente eliminato con successo',0),(117277,3258,'tl','',0),(117278,3258,'th','&#3621;&#3610;&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3626;&#3635;&#3648;&#3655;&#3619;&#3655;&#3592;',0),(117279,3258,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(117280,3258,'ms','Nama pengguna yang dihapuskan dengan jayanya',0),(117281,3258,'ar','Ø­Ø°Ù Ø¥Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¨Ù†Ø¬Ø§Ø­',0),(117282,3258,'fr','Nom d\'utilisateur supprimÃ© avec succÃ¨s',0),(117283,3258,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼å??ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(117284,3258,'pt','Nome de usuÃ¡rio excluÃ­do com sucesso',0),(117285,3258,'ru','Ð˜Ð¼Ñ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾',0),(117286,3258,'es','Nombre e Usuario eliminado exitosamente',0),(117287,3258,'de','Benutzernamen, die erfolgreich gelÃ¶scht',0),(117288,3258,'en','User Name deleted successfully',0),(117289,3259,'is','',0),(117290,3259,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(117291,3259,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(117292,3259,'tr','KullanÄ±cÄ± adÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(117293,3259,'pl','Nazwa uÅ¼ytkownika pomyÅ›lnie zaktualizowana',0),(117294,3259,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(117295,3259,'ur','ØµØ§Ø±Ù Ù†Ø§Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(117296,3259,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(117297,3259,'vi','Cáº­p Nháº­t TÃªn NgÆ°á»i Sá»­ Dá»¥ng thÃ nh cÃ´ng',0),(117298,3259,'af','Gebruikernaam suksesvol opdateer',0),(117299,3259,'ro','Numele de utilizator actualizat cu succes',0),(117300,3259,'et','Kasutajanime uuendamine Ãµnnestus',0),(117301,3259,'si','UporabniÅ¡ko ime, ki je uspeÅ¡no posodobljena',0),(117302,3259,'ba','Nama pengguna yang berhasil',0),(117303,3259,'nl','De naam van de gebruiker bijgewerkt',0),(117304,3259,'fi','PÃ¤ivitetty kÃ¤yttÃ¤jÃ¤nimi',0),(117305,3259,'no','Brukernavn oppdatert',0),(117306,3259,'da','Brugernavnet opdateret',0),(117307,3259,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì‚¬ìš©ìž ì´ë¦„',0),(117308,3259,'he','×©× ×ž×©×ª×ž×© ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(117309,3259,'el','ÎŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(117310,3259,'zh','ç”¨æˆ·åæˆåŠŸæ›´æ–°\r\n',0),(117311,3259,'sv','AnvÃ¤ndarnamn uppdaterats',0),(117312,3259,'it','Nome utente aggiornato con successo',0),(117313,3259,'tl','',0),(117314,3259,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3626;&#3635;&#3648;&#3655;&#3619;&#3655;&#3592;',0),(117315,3259,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(117316,3259,'ms','Nama pengguna yang berjaya dikemas kini',0),(117317,3259,'ar','Ø­Ø¯Ù‘Ø« Ø¥Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¨Ù†Ø¬Ø§Ø­',0),(117318,3259,'fr','Nom de l\'utilisateur mis Ã  jour avec succÃ¨s',0),(117319,3259,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼å??ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(117320,3259,'pt','Nome de usuÃ¡rio atualizado com sucesso',0),(117321,3259,'ru','Ð˜Ð¼Ñ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾',0),(117322,3259,'es','Nombre e Usuario actualizado exitosamente',0),(117323,3259,'de','Benutzernamen, die erfolgreich aktualisiert',0),(117324,3259,'en','User Name updated successfully',0),(117325,3260,'is','',0),(117326,3260,'dr','(Ø³Ø±ÙŠØ¹) ÛŒÙˆØ²Ø±',0),(117327,3260,'pr','Ø¹ÙƒØ³ Ø§Ù„Ø¹Ù…Ù„(Ø³Ø±ÙŠØ¹) ÙƒØ§Ø±Ø¨Ø±',0),(117328,3260,'tr','KullanÄ±cÄ± istemi',0),(117329,3260,'pl','Monit uÅ¼ytkownika',0),(117330,3260,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ñ€ÐµÐ´',0),(117331,3260,'ur','ØµØ§Ø±Ù Ù„Ù‚Ù…ÛŒØ§',0),(117332,3260,'sr','Ð£Ð¿Ð¸Ñ‚ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(117333,3260,'vi','Nháº¯c Nhá»Ÿ NgÆ°á»i Sá»­ Dá»¥ng',0),(117334,3260,'af','Gebruiker Aanhits',0),(117335,3260,'ro','Prompt de utilizator',0),(117336,3260,'et','Kasutaja viip',0),(117337,3260,'si','Poziv uporabniku',0),(117338,3260,'ba','Pengguna Prompt',0),(117339,3260,'nl','User Prompt',0),(117340,3260,'fi','KÃ¤yttÃ¤jÃ¤n kuiskata',0),(117341,3260,'no','Bruker spÃ¸rsmÃ¥l',0),(117342,3260,'da','Brugeren lynhurtig',0),(117343,3260,'ko','ì‚¬ìš©ìž í”„ë¡¬í”„íŠ¸',0),(117344,3260,'he','×¤×§×•×“×” ×œ×ž×©×ª×ž×©',0),(117345,3260,'el','Î•ÏÏŽÏ„Î·ÏƒÎ· Ï„Î¿Ï… Ï‡ÏÎ®ÏƒÏ„Î·.',0),(117346,3260,'zh','ç”¨æˆ·æç¤º\r\n',0),(117347,3260,'sv','AnvÃ¤ndaren snabb',0),(117348,3260,'it','Prompt utente',0),(117349,3260,'tl','',0),(117350,3260,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3650;&#3604;&#3618;&#3607;&#3633;&#3609;&#3607;&#3637;',0),(117351,3260,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤ªà¥à¤°à¥‰à¤®à¥à¤ªà¥à¤Ÿ',0),(117352,3260,'ms','Gesaan pengguna',0),(117353,3260,'ar','Ù…Ø·Ø§Ù„Ø¨Ø© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(117354,3260,'fr','Invite de l\'utilisateur',0),(117355,3260,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ãƒ—ãƒ­ãƒ³ãƒ—ãƒˆ',0),(117356,3260,'pt','Prompt de usuÃ¡rio',0),(117357,3260,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(117358,3260,'es','Indicador de Usuario ',0),(117359,3260,'de','Eingabeaufforderung',0),(117360,3260,'en','User Prompt',0),(117361,3261,'is','',0),(117362,3261,'dr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(117363,3261,'pr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(117364,3261,'tr','KullanÄ±cÄ± haklarÄ± baÅŸarÄ±yla eklendi',0),(117365,3261,'pl','Prawa uÅ¼ytkownika dodane pomyÅ›lnie',0),(117366,3261,'bg','ÐŸÑ€Ð°Ð²Ð° Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(117367,3261,'ur','ØµØ§Ø±Ù Ú©Û’ Ø­Ù‚ÙˆÙ‚ Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(117368,3261,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ° Ð¿Ñ€Ð°Ð²Ð°, Ð´Ð¾Ð´Ð°Ð¾ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(117369,3261,'vi','ThÃªm Quyá»n Cá»§a NgÆ°á»i Sá»­ Dá»¥ng thÃ nh cÃ´ng',0),(117370,3261,'af','Gebruikerregte suksesvol byvoeg.',0),(117371,3261,'ro','Drepturile de utilizator adÄƒugat cu succes',0),(117372,3261,'et','KasutajaÃµiguste lisamine Ãµnnestus',0),(117373,3261,'si','UporabniÅ¡ke pravice uspeÅ¡no dodani',0),(117374,3261,'ba','Hak-hak pengguna yang ditambahkan berhasil',0),(117375,3261,'nl','Gebruikersrechten met succes toegevoegd',0),(117376,3261,'fi','KÃ¤yttÃ¤jien oikeuksien lisÃ¤Ã¤minen onnistui',0),(117377,3261,'no','Brukerrettigheter lagt',0),(117378,3261,'da','Brugerrettigheder tilfÃ¸jet',0),(117379,3261,'ko','ì‚¬ìš©ìž ê¶Œí•œì„ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(117380,3261,'he','×”×¨×©××•×ª ×ž×©×ª×ž×© × ×•×¡×¤×• ×‘×”×¦×œ×—×”',0),(117381,3261,'el','Î”Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï‡ÏÎ®ÏƒÏ„Î· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(117382,3261,'zh','ç”¨æˆ·æƒé™æ·»åŠ æˆåŠŸ\r\n',0),(117383,3261,'sv','AnvÃ¤ndarrÃ¤ttigheter som lagts',0),(117384,3261,'it','Diritti utente aggiunti con successo',0),(117385,3261,'tl','',0),(117386,3261,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(117387,3261,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(117388,3261,'ms','Hak-hak pengguna yang berjaya menambah',0),(117389,3261,'ar','Ø£Ø¶ÙŠÙØª Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¨Ù†Ø¬Ø§Ø­',0),(117390,3261,'fr','Droits d\'utilisateur ajoutÃ©s avec succÃ¨s',0),(117391,3261,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©é™?ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(117392,3261,'pt','Direitos de usuÃ¡rio adicionados com sucesso',0),(117393,3261,'ru','ÐŸÑ€Ð°Ð²Ð° Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(117394,3261,'es','Derechos del Usuario agregados exitosamente',0),(117395,3261,'de','Benutzerrechte, die erfolgreich hinzugefÃ¼gt',0),(117396,3261,'en','User rights added successfully',0),(117397,3262,'is','',0),(117398,3262,'dr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(117399,3262,'pr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(117400,3262,'tr','KullanÄ±cÄ± haklarÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(117401,3262,'pl','Prawa uÅ¼ytkownika pomyÅ›lnie zaktualizowana',0),(117402,3262,'bg','ÐŸÑ€Ð°Ð²Ð° Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(117403,3262,'ur','ØµØ§Ø±Ù Ú©Û’ Ø­Ù‚ÙˆÙ‚ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(117404,3262,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ° Ð¿Ñ€Ð°Ð²Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(117405,3262,'vi','Cáº­p nháº­t phÃ¢n quyá»n ngÆ°á»i sá»­ dá»¥ng thÃ nh cÃ´ng',0),(117406,3262,'af','Gebruikerregte suksesvol opdateer',0),(117407,3262,'ro','Succes actualizare drepturi utilizator',0),(117408,3262,'et','KasutajaÃµiguste uuendamine Ãµnnestus',0),(117409,3262,'si','UporabniÅ¡ke pravice uspeÅ¡no posodobljena',0),(117410,3262,'ba','Hak-hak pengguna yang berhasil',0),(117411,3262,'nl','Gebruikersrechten bijgewerkt',0),(117412,3262,'fi','PÃ¤ivitetty kÃ¤yttÃ¶oikeudet',0),(117413,3262,'no','Brukerrettigheter oppdatert',0),(117414,3262,'da','Brugerrettigheder opdateret',0),(117415,3262,'ko','ì‚¬ìš©ìž ê¶Œí•œì„ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(117416,3262,'he','×–×›×•×™×•×ª ×ž×©×ª×ž×© ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(117417,3262,'el','Î”Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï‡ÏÎ®ÏƒÏ„Î· ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(117418,3262,'zh','ç”¨æˆ·æƒé™å·²æˆåŠŸæ›´æ–°\r\n',0),(117419,3262,'sv','AnvÃ¤ndarrÃ¤ttigheter som uppdaterats',0),(117420,3262,'it','Diritti utente aggiornati con successo',0),(117421,3262,'tl','',0),(117422,3262,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(117423,3262,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(117424,3262,'ms','Hak-hak pengguna yang berjaya dikemas kini',0),(117425,3262,'ar','Ø­Ø¯Ù‘Ø«Øª Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¨Ù†Ø¬Ø§Ø­',0),(117426,3262,'fr','Droits de l\'utilisateur mis Ã  jour avec succÃ¨s',0),(117427,3262,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©é™?ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(117428,3262,'pt','Direitos de usuÃ¡rio atualizados com sucesso',0),(117429,3262,'ru','ÐŸÑ€Ð°Ð²Ð° Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(117430,3262,'es','Derechos del Usuario actualizados exitosamente',0),(117431,3262,'de','Benutzerrechte, die erfolgreich aktualisiert',0),(117432,3262,'en','User rights updated successfully',0),(117433,3263,'is','',0),(117434,3263,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ø¨Ø±',0),(117435,3263,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ø¨Ø±',0),(117436,3263,'tr','KullanÄ±cÄ± gÃ¼ncelleÅŸtirme',0),(117437,3263,'pl','UÅ¼ytkownik aktualizacji',0),(117438,3263,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(117439,3263,'ur','ØµØ§Ø±Ù Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(117440,3263,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(117441,3263,'vi','Cáº­p Nháº­t NgÆ°á»i Sá»­ Dá»¥ng',0),(117442,3263,'af','Gebruiker Opdateer',0),(117443,3263,'ro','Actualizare Utilizator',0),(117444,3263,'et','Kasutaja Update',0),(117445,3263,'si','Uporabnik modernizirati',0),(117446,3263,'ba','Pengguna Update',0),(117447,3263,'nl','Gebruiker bijwerken',0),(117448,3263,'fi','User-pÃ¤ivitys',0),(117449,3263,'no','Bruker oppdateringen',0),(117450,3263,'da','Bruger Update',0),(117451,3263,'ko','ì‚¬ìš©ìž ì—…ë°ì´íŠ¸',0),(117452,3263,'he','×¢×“×›×•×Ÿ ×ž×©×ª×ž×©',0),(117453,3263,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Ï‡ÏÎ®ÏƒÏ„Î·',0),(117454,3263,'zh','ç”¨æˆ·æ›´æ–°\r\n',0),(117455,3263,'sv','Uppdatering fÃ¶r anvÃ¤ndaren',0),(117456,3263,'it','Aggiornamento utente',0),(117457,3263,'tl','',0),(117458,3263,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(117459,3263,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(117460,3263,'ms','Kemaskini pengguna',0),(117461,3263,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(117462,3263,'fr','Mise Ã  jour utilisateur',0),(117463,3263,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ›´æ–°',0),(117464,3263,'pt','AtualizaÃ§Ã£o para o usuÃ¡rio',0),(117465,3263,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(117466,3263,'es','Usuario Actualizar',0),(117467,3263,'de','Benutzer Update',0),(117468,3263,'en','User Update',0),(117469,3264,'is','',0),(117470,3264,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(117471,3264,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(117472,3264,'tr','KullanÄ±cÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(117473,3264,'pl','UÅ¼ytkownik pomyÅ›lnie zaktualizowana.',0),(117474,3264,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(117475,3264,'ur','ØµØ§Ø±Ù Ù†Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ Û”',0),(117476,3264,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(117477,3264,'vi','Cáº­p Nháº­t NgÆ°á»i Sá»­ Dá»¥ng thÃ nh cÃ´ng',0),(117478,3264,'af','Gebruiker suksesvol opdateer',0),(117479,3264,'ro','Utilizatorul actualizat cu succes.',0),(117480,3264,'et','Profiil uuendati edukalt',0),(117481,3264,'si','Uporabnik uspeÅ¡no posodobljena.',0),(117482,3264,'ba','Pengguna diperbarui berhasil.',0),(117483,3264,'nl','Gebruiker bijgewerkt.',0),(117484,3264,'fi','KÃ¤yttÃ¤jÃ¤ pÃ¤ivitettiin onnistuneesti.',0),(117485,3264,'no','Bruker ble oppdatert.',0),(117486,3264,'da','Bruger opdateret korrekt.',0),(117487,3264,'ko','ì‚¬ìš©ìžê°€ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í–ˆìŠµë‹ˆë‹¤.',0),(117488,3264,'he','×”×ž×©×ª×ž×© ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(117489,3264,'el','Î§ÏÎ®ÏƒÏ„Î·Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(117490,3264,'zh','ç”¨æˆ·æ›´æ–°æˆåŠŸ',0),(117491,3264,'sv','AnvÃ¤ndaren uppdaterats.',0),(117492,3264,'it','Utente aggiornato con successo.',0),(117493,3264,'tl','',0),(117494,3264,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(117495,3264,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(117496,3264,'ms','Pengguna berjaya dikemas kini.',0),(117497,3264,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¨Ù†Ø¬Ø§Ø­',0),(117498,3264,'fr','Utilisateur mis Ã  jour avec succÃ¨s.',0),(117499,3264,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(117500,3264,'pt','UsuÃ¡rio atualizado com sucesso.',0),(117501,3264,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½.',0),(117502,3264,'es','Usuario actualizado exitosamente',0),(117503,3264,'de','Benutzer erfolgreich aktualisiert.',0),(117504,3264,'en','User updated successfully.',0),(117505,3265,'is','',0),(117506,3265,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(117507,3265,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(117508,3265,'tr','KullanÄ±cÄ± KimliÄŸi bulunamadÄ±.',0),(117509,3265,'pl','Nazwa uÅ¼ytkownika nie znaleziono.',0),(117510,3265,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(117511,3265,'ur','ÛŒÙˆØ²Ø± Ù†ÛŒÙ… Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(117512,3265,'sr','Ð˜Ð” ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°.',0),(117513,3265,'vi','KhÃ´ng tÃ¬m tháº¥y ID NgÆ°á»i Sá»­ Dá»¥ng',0),(117514,3265,'af','Gebruiker ID nie gevind.',0),(117515,3265,'ro','ID utilizator nu exista',0),(117516,3265,'et','Kasutaja ID ei leitud',0),(117517,3265,'si','ID uporabnika ni mogoÄe najti.',0),(117518,3265,'ba','UserID tidak ditemukan.',0),(117519,3265,'nl','Gebruiker ID niet gevonden',0),(117520,3265,'fi','KÃ¤yttÃ¤jÃ¤tunnus ei lÃ¶ydy.',0),(117521,3265,'no','Bruker-ID ikke funnet.',0),(117522,3265,'da','Bruger-id blev ikke fundet.',0),(117523,3265,'ko','ì‚¬ìš©ìž Id ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(117524,3265,'he','×ž×–×”×” ×ž×©×ª×ž×© ×œ× × ×ž×¦×.',0),(117525,3265,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï‡ÏÎ®ÏƒÏ„Î· Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(117526,3265,'zh','ç”¨æˆ·åæ²¡æœ‰æ‰¾åˆ°ã€‚\r\n',0),(117527,3265,'sv','UserID hittades inte.',0),(117528,3265,'it','ID utente non trovato.',0),(117529,3265,'tl','',0),(117530,3265,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3627;&#3633;&#3626;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(117531,3265,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ Id à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(117532,3265,'ms','Administrative tidak dijumpai.',0),(117533,3265,'ar','Ù…Ø¹Ø±Ù‘Ù Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(117534,3265,'fr','Nom d\'utilisateur non trouvÃ©.',0),(117535,3265,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼IDã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(117536,3265,'pt','ID de usuÃ¡rio nÃ£o encontrado.',0),(117537,3265,'ru','ID ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(117538,3265,'es','Usuario ID no se encontrÃ³',0),(117539,3265,'de','Benutzer-ID nicht gefunden.',0),(117540,3265,'en','UserID not found.',0),(117541,3266,'is','',0),(117542,3266,'dr','Ù…Ø±Ø®ØµÙŠ',0),(117543,3266,'pr','Ù…Ø±Ø®ØµÙŠ',0),(117544,3266,'tr','Tatil',0),(117545,3266,'pl','Wakacje',0),(117546,3266,'bg','Ð’Ð°ÐºÐ°Ð½Ñ†Ð¸Ñ',0),(117547,3266,'ur','Ú†Ú¾Ù¹ÛŒ',0),(117548,3266,'sr','ÐžÐ´Ð¼Ð¾Ñ€',0),(117549,3266,'vi','Ká»³ nghá»‰',0),(117550,3266,'af','Vakansie',0),(117551,3266,'ro','Vacanta',0),(117552,3266,'et','Puhkus',0),(117553,3266,'si','PoÄitnice',0),(117554,3266,'ba','Liburan',0),(117555,3266,'nl','Vakantie',0),(117556,3266,'fi','Loma',0),(117557,3266,'no','Ferie',0),(117558,3266,'da','Ferie',0),(117559,3266,'ko','íœ´ê°€',0),(117560,3266,'he','×—×•×¤×©×”',0),(117561,3266,'el','Î”Î¹Î±ÎºÎ¿Ï€Î­Ï‚',0),(117562,3266,'zh','å‡æœŸ\r\n',0),(117563,3266,'sv','Semester',0),(117564,3266,'it','Vacanze',0),(117565,3266,'tl','',0),(117566,3266,'th','&#3585;&#3634;&#3619;&#3627;&#3618;&#3640;&#3604;&#3591;&#3634;&#3609;',0),(117567,3266,'hi','à¤›à¥à¤Ÿà¥à¤Ÿà¥€',0),(117568,3266,'ms','Percutian',0),(117569,3266,'ar','Ø¹Ø·Ù„Ø©',0),(117570,3266,'fr','Vacances',0),(117571,3266,'jp','ä¼‘æš‡',0),(117572,3266,'pt','FÃ©rias',0),(117573,3266,'ru','ÐžÑ‚Ð¿ÑƒÑÐº',0),(117574,3266,'es','VacaciÃ³n',0),(117575,3266,'de','Urlaub',0),(117576,3266,'en','Vacation',0),(117577,3267,'is','',0),(117578,3267,'dr','Ø³Ø§Ø¹Ø§Øª Ø¬Ù…Ø¹ Ø´Ø¯Ù‡ Ù…Ø±Ø®ØµÙŠ ',0),(117579,3267,'pr','Ø³Ø§Ø¹Ø§Øª Ø¬Ù…Ø¹ Ø´Ø¯Ù‡ Ù…Ø±Ø®ØµÙŠ ',0),(117580,3267,'tr','Tatil saatleri tahakkuk',0),(117581,3267,'pl','Wakacje naliczone godziny',0),(117582,3267,'bg','Ð’Ð°ÐºÐ°Ð½Ñ†Ð¸Ð¾Ð½ÐµÐ½ Ñ‡Ð°ÑÐ¾Ð²Ðµ Ð½Ð°Ñ‚Ñ€ÑƒÐ¿Ð°Ð½Ð¸',0),(117583,3267,'ur','Ú†Ú¾Ù¹ÛŒ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª ØªÙ…Ø§Ù… ÛÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§',0),(117584,3267,'sr','ÐžÐ´Ð¼Ð¾Ñ€ Ð¿Ð°Ñ€ ÑÐ°Ñ‚Ð¸ Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°Ð½Ð¸Ñ…',0),(117585,3267,'vi','Cá»™ng dá»“n giá» ká»³ nghá»‰',0),(117586,3267,'af','Opgeloopte Vakansie Ure',0),(117587,3267,'ro','Vacanta de ore acumulate',0),(117588,3267,'et','Tunde kogunenud puhkus',0),(117589,3267,'si','Dopust, ure, obraÄunane',0),(117590,3267,'ba','Liburan di jam masih harus dibayar',0),(117591,3267,'nl','Vakantie uren opgebouwde',0),(117592,3267,'fi','Loma tuntia kertyneet',0),(117593,3267,'no','Ferie timer pÃ¥lÃ¸pt',0),(117594,3267,'da','Ferie timer periodiseret',0),(117595,3267,'ko','íœ´ê°€ ì‹œê°„ ë°œìƒ',0),(117596,3267,'he','× ×•×¤×© ×œ×¦×‘×•×¨ ×©×¢×•×ª',0),(117597,3267,'el','Î”Î¹Î±ÎºÎ¿Ï€Î­Ï‚ Î´ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½ÎµÏ‚ ÏŽÏÎµÏ‚',0),(117598,3267,'zh','ç´¯è®¡ä¼‘å‡æ—¶é—´\r\n',0),(117599,3267,'sv','Semester timmar upplupna',0),(117600,3267,'it','Vacanze ore maturate',0),(117601,3267,'tl','',0),(117602,3267,'th','&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3623;&#3633;&#3609;&#3627;&#3618;&#3640;&#3604;&#3626;&#3632;&#3626;&#3617;',0),(117603,3267,'hi','à¤›à¥à¤Ÿà¥à¤Ÿà¥€ à¤•à¥‡ à¤¸à¤®à¤¯ à¤¤à¤• à¤…à¤°à¥à¤œà¤¿à¤¤',0),(117604,3267,'ms','Percutian yang jam terakru',0),(117605,3267,'ar','Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¥Ø¬Ø§Ø²Ø© Ø§Ù„Ù…ØªØ±Ø§ÙƒÙ…Ø©',0),(117606,3267,'fr','Vacances heures accumulÃ©es',0),(117607,3267,'jp','ç´¯ç©?æœ‰çµ¦ä¼‘æš‡æ™‚é–“',0),(117608,3267,'pt','FÃ©rias horas acumuladas',0),(117609,3267,'ru','Ð§Ð°ÑÐ¾Ð² Ð½Ð°ÐºÐ¾Ð¿Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð¾Ñ‚Ð¿ÑƒÑÐºÐ°',0),(117610,3267,'es','Horas de Vacaciones Acumuladas',0),(117611,3267,'de','Urlaub Stunden angefallen',0),(117612,3267,'en','Vacation Hours Accrued',0),(117613,3268,'is','',0),(117614,3268,'dr','Ø¬ÙˆØ§Ø¨ ØµØ­ÙŠØ­ ',0),(117615,3268,'pr','Ø¬ÙˆØ§Ø¨ ØµØ­ÙŠØ­ ',0),(117616,3268,'tr','GeÃ§erli yanÄ±t',0),(117617,3268,'pl','PrawidÅ‚owe odpowiedzi',0),(117618,3268,'bg','Ð’Ð°Ð»Ð¸Ð´ÐµÐ½ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(117619,3268,'ur','Ø¯Ø±Ø³Øª Ø¬ÙˆØ§Ø¨ Ø¯ÛŒÚº',0),(117620,3268,'sr','Ð˜ÑÐ¿Ñ€Ð°Ð²Ð°Ð½ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€',0),(117621,3268,'vi','Tráº£ lá»i cÃ³ hiá»‡u lá»±c',0),(117622,3268,'af','Geldige Antwoord',0),(117623,3268,'ro','Raspuns valabil',0),(117624,3268,'et','Sobiv vastus',0),(117625,3268,'si','Veljaven odgovor',0),(117626,3268,'ba','Berlaku Balasan',0),(117627,3268,'nl','Geldig antwoord',0),(117628,3268,'fi','Kelvollinen vastaus',0),(117629,3268,'no','Ugyldig svar',0),(117630,3268,'da','Gyldige svar',0),(117631,3268,'ko','ìœ íš¨ ì‘ë‹µ',0),(117632,3268,'he','×ª×’×•×‘×” ×ª×§×¤×”',0),(117633,3268,'el','ÎˆÎ³ÎºÏ…ÏÎ· Î±Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(117634,3268,'zh','æœ‰æ•ˆçš„å›žè¦†\r\n',0),(117635,3268,'sv','Giltigt svar',0),(117636,3268,'it','Risposta valida',0),(117637,3268,'tl','',0),(117638,3268,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3585;&#3634;&#3619;&#3605;&#3629;&#3610;',0),(117639,3268,'hi','à¤®à¤¾à¤¨à¥à¤¯ à¤‰à¤¤à¥à¤¤à¤° à¤¦à¥‡à¤‚',0),(117640,3268,'ms','Balasan yang sah',0),(117641,3268,'ar','Ø±Ø¯ ØµØ§Ù„Ø­',0),(117642,3268,'fr','RÃ©ponse valide',0),(117643,3268,'jp','æœ‰åŠ¹å›žç­”',0),(117644,3268,'pt','Resposta vÃ¡lida',0),(117645,3268,'ru','Ð”Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ Ð¾Ñ‚Ð²ÐµÑ‚',0),(117646,3268,'es','Respuesta VÃ¡lida',0),(117647,3268,'de','GÃ¼ltige Antwort',0),(117648,3268,'en','Valid Reply',0),(117649,3269,'is','',0),(117650,3269,'dr','(Ø¨Ù‡Ø§Ø¡',0),(117651,3269,'pr','Ø§Ø±Ø²Ø´ (Ø¨Ù‡Ø§Ø¡',0),(117652,3269,'tr','DeÄŸer',0),(117653,3269,'pl','WartoÅ›Ä‡',0),(117654,3269,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(117655,3269,'ur','Ù‚Ø¯Ø±',0),(117656,3269,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(117657,3269,'vi','GiÃ¡ trá»‹',0),(117658,3269,'af','Waarde',0),(117659,3269,'ro','Valoarea',0),(117660,3269,'et','VÃ¤Ã¤rtus',0),(117661,3269,'si','Vrednost',0),(117662,3269,'ba','Nilai',0),(117663,3269,'nl','Waarde',0),(117664,3269,'fi','Arvo',0),(117665,3269,'no','Verdi',0),(117666,3269,'da','VÃ¦rdi',0),(117667,3269,'ko','ê°’',0),(117668,3269,'he','×¢×¨×š',0),(117669,3269,'el','Î‘Î¾Î¯Î±',0),(117670,3269,'zh','ä»·å€¼\r\n',0),(117671,3269,'sv','VÃ¤rde',0),(117672,3269,'it','Valore',0),(117673,3269,'tl','',0),(117674,3269,'th','&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;',0),(117675,3269,'hi','à¤®à¤¾à¤¨',0),(117676,3269,'ms','Nilai',0),(117677,3269,'ar','Ø§Ù„Ù‚ÙŠÙ…Ø©',0),(117678,3269,'fr','Valeur',0),(117679,3269,'jp','è©•ä¾¡',0),(117680,3269,'pt','Valor',0),(117681,3269,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(117682,3269,'es','Valor',0),(117683,3269,'de','Wert',0),(117684,3269,'en','Value',0),(117685,3270,'is','',0),(117686,3270,'dr','Ø§Ø±Ø²Ø´ Ø¯Ø± Ø®Ø±Ø¯Ù‡ ÙØ±ÙˆØ´ÙŠ ',0),(117687,3270,'pr','Ø§Ø±Ø²Ø´ Ø¯Ø± Ø®Ø±Ø¯Ù‡ ÙØ±ÙˆØ´ÙŠ ',0),(117688,3270,'tr','DeÄŸer',0),(117689,3270,'pl','WartoÅ›Ä‡ w',0),(117690,3270,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(117691,3270,'ur','Ù…ÛŒÚº Ù‚Ø¯Ø±',0),(117692,3270,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ Ð·Ð°',0),(117693,3270,'vi','GiÃ¡ trá»‹ tá»›i',0),(117694,3270,'af','Waarde by',0),(117695,3270,'ro','Valoarea la',0),(117696,3270,'et','VÃ¤Ã¤rtus',0),(117697,3270,'si','Vrednost na',0),(117698,3270,'ba','Nilai di',0),(117699,3270,'nl','De waarde van',0),(117700,3270,'fi','Arvo',0),(117701,3270,'no','Verdien i',0),(117702,3270,'da','VÃ¦rdi pÃ¥',0),(117703,3270,'ko','ê°’',0),(117704,3270,'he','×¢×¨×š ×‘× ×§×•×“×ª',0),(117705,3270,'el','Î¤Î¹Î¼Î® Ï€Î¿Ï… Î²ÏÎ¯ÏƒÎºÎµÏ„Î±Î¹',0),(117706,3270,'zh','å€¼\r\n',0),(117707,3270,'sv','VÃ¤rde pÃ¥',0),(117708,3270,'it','Valore al',0),(117709,3270,'tl','',0),(117710,3270,'th','&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3607;&#3637;&#3656;',0),(117711,3270,'hi','à¤ªà¤° à¤®à¥‚à¤²à¥à¤¯',0),(117712,3270,'ms','Nilai pada',0),(117713,3270,'ar','Ù‚ÙŠÙ…Ø© ÙÙŠ',0),(117714,3270,'fr','La valeur Ã ',0),(117715,3270,'jp','è©•ä¾¡',0),(117716,3270,'pt','Valor em',0),(117717,3270,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(117718,3270,'es','Valor a',0),(117719,3270,'de','Wert am',0),(117720,3270,'en','Value at',0),(117721,3271,'is','',0),(117722,3271,'dr','Ù…ØºØ§ÙŠØ±Øª ',0),(117723,3271,'pr','Ù…ØºØ§ÙŠØ±Øª ',0),(117724,3271,'tr','Varyans',0),(117725,3271,'pl','Odchylenie',0),(117726,3271,'bg','Ð”Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ñ',0),(117727,3271,'ur','ØªØºÛŒØ±',0),(117728,3271,'sr','ÐžÐ´ÑÑ‚ÑƒÐ¿Ð°ÑšÐµ',0),(117729,3271,'vi','ChÃªnh lá»‡ch',0),(117730,3271,'af','Afwyking',0),(117731,3271,'ro','VarianÅ£a',0),(117732,3271,'et','Dispersiooni',0),(117733,3271,'si','Varianca',0),(117734,3271,'ba','Varians',0),(117735,3271,'nl','Variantie',0),(117736,3271,'fi','Varianssi',0),(117737,3271,'no','Avvik',0),(117738,3271,'da','Varians',0),(117739,3271,'ko','ë¶„ì‚°',0),(117740,3271,'he','×¡×˜×™×”',0),(117741,3271,'el','Î”Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ·',0),(117742,3271,'zh','å·®å¼‚\r\n',0),(117743,3271,'sv','Varians',0),(117744,3271,'it','Varianza',0),(117745,3271,'tl','',0),(117746,3271,'th','&#3585;&#3634;&#3619;&#3612;&#3633;&#3609;&#3649;&#3611;&#3619;',0),(117747,3271,'hi','à¤µà¤¿à¤šà¤°à¤£',0),(117748,3271,'ms','Varians',0),(117749,3271,'ar','Ø§Ù„Ø¥Ø®ØªÙ„Ø§Ù',0),(117750,3271,'fr','Variance',0),(117751,3271,'jp','å·®é¡?',0),(117752,3271,'pt','VariÃ¢ncia',0),(117753,3271,'ru','Ð”Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ñ',0),(117754,3271,'es','Diferencia',0),(117755,3271,'de','Varianz',0),(117756,3271,'en','Variance',0),(117757,3272,'is','',0),(117758,3272,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø´Ø±ÙƒØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(117759,3272,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø´Ø±ÙƒØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(117760,3272,'tr','Vendcompanyid geÃ§ersiz.',0),(117761,3272,'pl','Vendcompanyid nieprawidÅ‚owe.',0),(117762,3272,'bg','Vendcompanyid Ð½ÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½.',0),(117763,3272,'ur','ÙˆØ§Ù†Ø¯Ú©ÙˆÙ…Ù¾Ù†ÛŒØ§Ø¯ Ù†Ø§Ø¬Ø§Ø¦Ø² ÛÛ’ Û”',0),(117764,3272,'sr','Ð’ÐµÐ½Ð´Ñ†Ð¾Ð¼Ð¿Ð°Ð½yÐ¸Ð´ Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð°.',0),(117765,3272,'vi','VÃ´ hiá»‡u',0),(117766,3272,'af','Vendcompanyid ongeldig.',0),(117767,3272,'ro','Vendcompanyid nevalid.',0),(117768,3272,'et','Vendcompanyid ei sobi.',0),(117769,3272,'si','Neveljaven Vendcompanyid.',0),(117770,3272,'ba','Vendcompanyid tidak valid.',0),(117771,3272,'nl','Ongeldige Vendcompanyid.',0),(117772,3272,'fi','Vendcompanyid ei kelpaa.',0),(117773,3272,'no','Vendcompanyid er ugyldig.',0),(117774,3272,'da','Vendcompanyid ugyldig.',0),(117775,3272,'ko','ìž˜ëª» ëœ Vendcompanyidìž…ë‹ˆë‹¤.',0),(117776,3272,'he','Vendcompanyid ×œ× ×—×•×§×™×ª.',0),(117777,3272,'el','Vendcompanyid Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ·.',0),(117778,3272,'zh','å–æˆ¿å…¬å¸å¸å·æ— æ•ˆã€‚\r\n',0),(117779,3272,'sv','Vendcompanyid ogiltigt.',0),(117780,3272,'it','Vendcompanyid non valido.',0),(117781,3272,'tl','',0),(117782,3272,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(117783,3272,'hi','Vendcompanyid à¤…à¤®à¤¾à¤¨à¥à¤¯à¥¤',0),(117784,3272,'ms','Vendcompanyid tidak sah.',0),(117785,3272,'ar','ÙÙŠÙ†Ø¯ÙƒÙˆÙ…Ø¨Ø§Ù†ÙŠÙŠØ¯ ØºÙŠØ± ØµØ§Ù„Ø­.',0),(117786,3272,'fr','Vendcompanyid non valide.',0),(117787,3272,'jp','Vendcompanyid invalid.',0),(117788,3272,'pt','Vendcompanyid invÃ¡lido.',0),(117789,3272,'ru','Vendcompanyid Ð½ÐµÐ²ÐµÑ€Ð½Ñ‹Ð¹.',0),(117790,3272,'es','vendidempresa invÃ¡lido',0),(117791,3272,'de','Vendcompanyid ungÃ¼ltig.',0),(117792,3272,'en','Vendcompanyid invalid.',0),(117793,3273,'is','',0),(117794,3273,'dr','ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡',0),(117795,3273,'pr','ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡',0),(117796,3273,'tr','Vended',0),(117797,3273,'pl','Nabyci przez opiekuna nr',0),(117798,3273,'bg','Vended',0),(117799,3273,'ur','ÙˆØ§Ù†ÚˆÛŒØ¯',0),(117800,3273,'sr','ÐÐ°Ñ†Ñ€Ñ‚Ð°Ð½Ð¾',0),(117801,3273,'vi','ÄÃ£ bÃ¡n',0),(117802,3273,'af','Vended',0),(117803,3273,'ro','Vended',0),(117804,3273,'et','Vended',0),(117805,3273,'si','Vended',0),(117806,3273,'ba','Vended',0),(117807,3273,'nl','Vended',0),(117808,3273,'fi','Vended',0),(117809,3273,'no','Vended',0),(117810,3273,'da','Vended',0),(117811,3273,'ko','Vended',0),(117812,3273,'he','Vended',0),(117813,3273,'el','Vended',0),(117814,3273,'zh','å‡ºå”®\r\n\r\nVended\r\n',0),(117815,3273,'sv','Vended',0),(117816,3273,'it','Vended',0),(117817,3273,'tl','',0),(117818,3273,'th','&#3606;&#3641;&#3585;&#3586;&#3634;&#3618;',0),(117819,3273,'hi','Vended',0),(117820,3273,'ms','Vended',0),(117821,3273,'ar','ÙÙŠÙ†Ø¯ÙŠØ¯',0),(117822,3273,'fr','Vendue',0),(117823,3273,'jp','è²©å£²æ¸ˆ',0),(117824,3273,'pt','Vended',0),(117825,3273,'ru','Vended',0),(117826,3273,'es','Vendido',0),(117827,3273,'de','Vended',0),(117828,3273,'en','Vended',0),(117829,3274,'is','',0),(117830,3274,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(117831,3274,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(117832,3274,'tr','SatÄ±cÄ±',0),(117833,3274,'pl','Dostawcy',0),(117834,3274,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(117835,3274,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û',0),(117836,3274,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(117837,3274,'vi','NgÆ°á»i bÃ¡n',0),(117838,3274,'af','Verskaffer',0),(117839,3274,'ro','Furnizor',0),(117840,3274,'et','Tarnija',0),(117841,3274,'si','Dobavitelja',0),(117842,3274,'ba','Penjual',0),(117843,3274,'nl','Leverancier',0),(117844,3274,'fi','Toimittajan',0),(117845,3274,'no','LeverandÃ¸r',0),(117846,3274,'da','Kreditor',0),(117847,3274,'ko','ê³µê¸‰ ì—…ì²´',0),(117848,3274,'he','×¡×¤×§',0),(117849,3274,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(117850,3274,'zh','ä¾›åº”å•†\r\n',0),(117851,3274,'sv','LeverantÃ¶r',0),(117852,3274,'it','Fornitore',0),(117853,3274,'tl','',0),(117854,3274,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(117855,3274,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(117856,3274,'ms','Penjual',0),(117857,3274,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(117858,3274,'fr','Nom du vendeur',0),(117859,3274,'jp','æ¥­è€…',0),(117860,3274,'pt','Fornecedor',0),(117861,3274,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº',0),(117862,3274,'es','Proveedor',0),(117863,3274,'de','Kreditor',0),(117864,3274,'en','Vendor',0),(117865,3275,'is','',0),(117866,3275,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(117867,3275,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(117868,3275,'tr','SatÄ±cÄ± Ekle',0),(117869,3275,'pl','Dodawanie dostawcy',0),(117870,3275,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(117871,3275,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(117872,3275,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(117873,3275,'vi','ThÃªm NgÆ°á»i bÃ¡n',0),(117874,3275,'af','Verskaffer Skep',0),(117875,3275,'ro','Adauga furnizor',0),(117876,3275,'et','Hankija lisada',0),(117877,3275,'si','Prodajalec dodati',0),(117878,3275,'ba','Penjual menambahkan',0),(117879,3275,'nl','Leverancier toevoegen',0),(117880,3275,'fi','Toimittajan lisÃ¤ys',0),(117881,3275,'no','LeverandÃ¸ren legge',0),(117882,3275,'da','LeverandÃ¸ren tilfÃ¸jer',0),(117883,3275,'ko','ê³µê¸‰ ì—…ì²´ ì¶”ê°€',0),(117884,3275,'he','×”×•×¡×¤×ª ×¡×¤×§',0),(117885,3275,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(117886,3275,'zh','ä¾›åº”å•†åŠ å…¥\r\n',0),(117887,3275,'sv','LeverantÃ¶ren lÃ¤gger till',0),(117888,3275,'it','Aggiungere fornitore',0),(117889,3275,'tl','',0),(117890,3275,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(117891,3275,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(117892,3275,'ms','Tambah pembekal',0),(117893,3275,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ±Ù‘Ø¯',0),(117894,3275,'fr','Ajouter des fournisseurs',0),(117895,3275,'jp','æ¥­è€…è¿½åŠ ',0),(117896,3275,'pt','Adicionar o fornecedor',0),(117897,3275,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(117898,3275,'es','Proveedor Agregar',0),(117899,3275,'de','Kreditor hinzufÃ¼gen',0),(117900,3275,'en','Vendor Add',0),(117901,3276,'is','',0),(117902,3276,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(117903,3276,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(117904,3276,'tr','SatÄ±cÄ± baÅŸarÄ±yla eklendi',0),(117905,3276,'pl','Dostawcy dodany pomyÅ›lnie',0),(117906,3276,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(117907,3276,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(117908,3276,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð´Ð¾Ð´Ð°Ð¾ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(117909,3276,'vi','ThÃªm NgÆ°á»i bÃ¡n thÃ nh cÃ´ng',0),(117910,3276,'af','Verskaffer suksesvol geskep',0),(117911,3276,'ro','Furnizor adÄƒugat cu succes',0),(117912,3276,'et','Tarnija lisamine Ãµnnestus',0),(117913,3276,'si','Dobavitelja, ki so dodani',0),(117914,3276,'ba','Penjual menambahkan berhasil',0),(117915,3276,'nl','Leverancier toegevoegd',0),(117916,3276,'fi','Toimittajan lisÃ¤Ã¤minen onnistui',0),(117917,3276,'no','LeverandÃ¸ren ble lagt til',0),(117918,3276,'da','Kreditor tilfÃ¸jet',0),(117919,3276,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ê³µê¸‰ ì—…ì²´',0),(117920,3276,'he','×¡×¤×§ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(117921,3276,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(117922,3276,'zh','é”€å”®å•†æ·»åŠ æˆåŠŸ\r\n',0),(117923,3276,'sv','LeverantÃ¶r som lagts',0),(117924,3276,'it','Fornitore aggiunto con successo',0),(117925,3276,'tl','',0),(117926,3276,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(117927,3276,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(117928,3276,'ms','Penjual yang berjaya menambah',0),(117929,3276,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(117930,3276,'fr','Fournisseur ajoutÃ© avec succÃ¨s',0),(117931,3276,'jp','æ¥­è€…ã?®è¿½åŠ ã?—ã?¾ã?—ã?Ÿ',0),(117932,3276,'pt','Fornecedor adicionado com sucesso',0),(117933,3276,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(117934,3276,'es','Proveedor agregado exitosamente',0),(117935,3276,'de','Hersteller erfolgreich hinzugefÃ¼gt',0),(117936,3276,'en','Vendor added successfully',0),(117937,3277,'is','',0),(117938,3277,'dr','- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(117939,3277,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(117940,3277,'tr','SatÄ±cÄ± zaten var',0),(117941,3277,'pl','Sprzedawca juÅ¼ istnieje',0),(117942,3277,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ‡ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(117943,3277,'ur','ÙˆÛŒÙ†ÚˆØ± Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(117944,3277,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(117945,3277,'vi','NgÆ°á»i bÃ¡n Ä‘Ã£ cÃ³',0),(117946,3277,'af','Handelaar bestaan reeds',0),(117947,3277,'ro','Furnizor existÄƒ deja',0),(117948,3277,'et','Hankija on juba olemas',0),(117949,3277,'si','Prodajalec Å¾e obstaja',0),(117950,3277,'ba','Sudah ada vendor',0),(117951,3277,'nl','Leverancier bestaat al',0),(117952,3277,'fi','Toimittaja on jo olemassa',0),(117953,3277,'no','LeverandÃ¸r eksisterer allerede',0),(117954,3277,'da','Kreditor findes allerede',0),(117955,3277,'ko','ì´ë¯¸ ì¡´ìž¬ í•˜ëŠ” ê³µê¸‰ ì—…ì²´',0),(117956,3277,'he','×¡×¤×§ ×›×‘×¨ ×§×™×™×',0),(117957,3277,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(117958,3277,'zh','é”€å”®å•†å·²å­˜åœ¨\r\n',0),(117959,3277,'sv','LeverantÃ¶ren finns redan',0),(117960,3277,'it','Fornitore esiste giÃ ',0),(117961,3277,'tl','',0),(117962,3277,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;',0),(117963,3277,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(117964,3277,'ms','Penjual sudah wujud',0),(117965,3277,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(117966,3277,'fr','Fournisseur existe dÃ©jÃ ',0),(117967,3277,'jp','ã?™ã?§ã?«å­˜åœ¨ã?™ã‚‹æ¥­è€…',0),(117968,3277,'pt','Fornecedor, jÃ¡ existe',0),(117969,3277,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº ÑƒÐ¶Ðµ ÑÐ¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ÑÑ',0),(117970,3277,'es','Proveedor ya existe',0),(117971,3277,'de','VerkÃ¤ufer ist bereits vorhanden.',0),(117972,3277,'en','Vendor already exists',0),(117973,3278,'is','',0),(117974,3278,'dr','Ù†Ø§Ù… Ø´Ø±ÙƒØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(117975,3278,'pr','Ù†Ø§Ù… Ø´Ø±ÙƒØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(117976,3278,'tr','SatÄ±cÄ± Firma adÄ±',0),(117977,3278,'pl','Nazwa dostawcy firmy',0),(117978,3278,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°',0),(117979,3278,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù…',0),(117980,3278,'sr','Ð˜Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(117981,3278,'vi','TÃªn cty ngÆ°á»i bÃ¡n',0),(117982,3278,'af','Verskaffer Ondernemingnaam',0),(117983,3278,'ro','Denumire furnizor',0),(117984,3278,'et','Tarnija ettevÃµtte nimi',0),(117985,3278,'si','Ime dobavitelja podjetja',0),(117986,3278,'ba','Nama perusahaan Penjual',0),(117987,3278,'nl','De naam van de leverancier',0),(117988,3278,'fi','Toimittajan yrityksen nimi',0),(117989,3278,'no','LeverandÃ¸ren firmanavn',0),(117990,3278,'da','Kreditorens firma navn',0),(117991,3278,'ko','ê³µê¸‰ ì—…ì²´ íšŒì‚¬ ì´ë¦„',0),(117992,3278,'he','×©× ×—×‘×¨×ª ×¡×¤×§',0),(117993,3278,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Ï€Ï‰Î»Î·Ï„Î®',0),(117994,3278,'zh','é”€å”®å•†å…¬å¸åç§°\r\n',0),(117995,3278,'sv','LeverantÃ¶rens namn',0),(117996,3278,'it','Nome della societÃ  fornitrice',0),(117997,3278,'tl','',0),(117998,3278,'th','&#3594;&#3639;&#3656;&#3629;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(117999,3278,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤®',0),(118000,3278,'ms','Nama Syarikat pembekal',0),(118001,3278,'ar','Ø¥Ø³Ù… Ø´Ø±ÙƒØ© Ø§Ù„Ù…ÙˆØ±Ø¯',0),(118002,3278,'fr','Nom de lâ€™entreprise du vendeur',0),(118003,3278,'jp','æ¥­è€…å??',0),(118004,3278,'pt','Nome da empresa do fornecedor',0),(118005,3278,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¤Ð¸Ñ€Ð¼Ñ‹-ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(118006,3278,'es','Proveedor Nombre de Empresa',0),(118007,3278,'de','Kreditor Firmenname',0),(118008,3278,'en','Vendor Company Name',0),(118009,3279,'is','',0),(118010,3279,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(118011,3279,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(118012,3279,'tr','SatÄ±cÄ± veri bulunamadÄ±',0),(118013,3279,'pl','Dostawcy danych nie znaleziono',0),(118014,3279,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(118015,3279,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÙˆØ§Ø¦Ù Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(118016,3279,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(118017,3279,'vi','Dá»¯ liá»‡u ngÆ°á»i bÃ¡n khÃ´ng tháº¥y',0),(118018,3279,'af','Handelaar data nie gevind nie',0),(118019,3279,'ro','Furnizor de date nu a fost gÄƒsit',0),(118020,3279,'et','Tarnija andmeid ei leitud',0),(118021,3279,'si','Dobavitelja podatkov ni bilo mogoÄe najti',0),(118022,3279,'ba','Vendor data tidak ditemukan',0),(118023,3279,'nl','Gegevens van de leverancier niet gevonden',0),(118024,3279,'fi','Toimittajatietojen ei lÃ¶ydy',0),(118025,3279,'no','LeverandÃ¸rdata ikke funnet',0),(118026,3279,'da','Kreditordata ikke fundet',0),(118027,3279,'ko','ê³µê¸‰ ì—…ì²´ ë°ì´í„°ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(118028,3279,'he','×œ× × ×ž×¦××• × ×ª×•× ×™ ×¡×¤×§',0),(118029,3279,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(118030,3279,'zh','ä¾›åº”å•†çš„æ•°æ®æœªæ‰¾åˆ°\r\n',0),(118031,3279,'sv','LeverantÃ¶rsdata hittades inte',0),(118032,3279,'it','Dati del fornitore non trovati',0),(118033,3279,'tl','',0),(118034,3279,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118035,3279,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(118036,3279,'ms','Pembekal data tidak ditemui',0),(118037,3279,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(118038,3279,'fr','DonnÃ©es du vendeur introuvables',0),(118039,3279,'jp','æ¥­è€…ãƒ‡ãƒ¼ã‚¿ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(118040,3279,'pt','Dados do fornecedor nÃ£o encontrados',0),(118041,3279,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(118042,3279,'es','Datos de Proveedor no se encontraron',0),(118043,3279,'de','Lieferantendaten nicht gefunden',0),(118044,3279,'en','Vendor data not found',0),(118045,3280,'is','',0),(118046,3280,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ ØªØ§Ø±ÙŠØ® â€“ Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ ',0),(118047,3280,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ ØªØ§Ø±ÙŠØ® â€“ Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ ',0),(118048,3280,'tr','SatÄ±cÄ±, tarihi, kontrol #',0),(118049,3280,'pl','Dostawcy, Data, sprawdziÄ‡ nr',0),(118050,3280,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, Ð´Ð°Ñ‚Ð°, Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ #',0),(118051,3280,'ur','ÙˆÛŒÙ†ÚˆØ±ØŒ ØªØ§Ø±ÛŒØ®ØŒ # Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(118052,3280,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ , Ð´Ð°Ñ‚ÑƒÐ¼, Ð²Ð¸Ð´Ð¸ #',0),(118053,3280,'vi','NgÆ°á»i bÃ¡n, ngÃ y, SÃ©c sá»‘',0),(118054,3280,'af','Verskaffer, Datum, Tjek #',0),(118055,3280,'ro','Furnizor, data, verifica #',0),(118056,3280,'et','Tarnija, pÃ¤ev, tsekk #',0),(118057,3280,'si','Prodajalec, datum, preverite #',0),(118058,3280,'ba','Penjual, tanggal, memeriksa #',0),(118059,3280,'nl','Leverancier, datum, Check #',0),(118060,3280,'fi','Toimittaja, pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤, tarkista #',0),(118061,3280,'no','LeverandÃ¸r, dato, sjekk #',0),(118062,3280,'da','Kreditor, dato, tjekke #',0),(118063,3280,'ko','ê³µê¸‰ ì—…ì²´, ë‚ ì§œ, í™•ì¸ #',0),(118064,3280,'he','×”×¡×¤×§, ×ª××¨×™×š, ×‘×“×•×§ #',0),(118065,3280,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®, Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±, ÎµÎ»Î­Î³Î¾Ï„Îµ #',0),(118066,3280,'zh','ä¾›åº”å•†ï¼Œæ—¥æœŸï¼Œæ”¯ç¥¨ï¼ƒ\r\n',0),(118067,3280,'sv','LeverantÃ¶r, datum, kontrollera #',0),(118068,3280,'it','Fornitore, data, verifica n.',0),(118069,3280,'tl','',0),(118070,3280,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;,&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;,&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&#3588;',0),(118071,3280,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾, à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ #',0),(118072,3280,'ms','Penjual, tarikh, semak #',0),(118073,3280,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ , Ø§Ù„ØªØ§Ø±ÙŠØ® , Ø±Ù‚Ù… Ø§Ù„ØµÙƒÙ‘',0),(118074,3280,'fr','Fournisseur, Date, vÃ©rifiez #',0),(118075,3280,'jp','æ¥­è€…ã€?æ—¥ä»˜ã€?å°?åˆ‡æ‰‹ç•ªå?·',0),(118076,3280,'pt','Fornecedor, data, verifique #',0),(118077,3280,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº, Ð”Ð°Ñ‚Ð°, Ð§ÐµÐº #',0),(118078,3280,'es','Proveedor, Fecha, Cheque #',0),(118079,3280,'de','Hersteller, Datum, prÃ¼fen #',0),(118080,3280,'en','Vendor, Date, Check #',0),(118081,3281,'is','',0),(118082,3281,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(118083,3281,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(118084,3281,'tr','SatÄ±cÄ± baÅŸarÄ±yla silindi',0),(118085,3281,'pl','Vendor usuniÄ™ty',0),(118086,3281,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(118087,3281,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(118088,3281,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(118089,3281,'vi','XÃ³a NgÆ°á»i bÃ¡n thÃ nh cÃ´ng',0),(118090,3281,'af','Verskaffer suksesvol geskrap',0),(118091,3281,'ro','Furnizor eliminÄƒ cu succes',0),(118092,3281,'et','Tarnija kustutamine Ãµnnestus',0),(118093,3281,'si','Dobavitelja, uspeÅ¡no izbrisana',0),(118094,3281,'ba','Penjual dihapus berhasil',0),(118095,3281,'nl','Leverancier met succes verwijderd',0),(118096,3281,'fi','Toimittajan poistettu',0),(118097,3281,'no','LeverandÃ¸ren slettet',0),(118098,3281,'da','Kreditor slettet',0),(118099,3281,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ê³µê¸‰ ì—…ì²´',0),(118100,3281,'he','×”×¡×¤×§ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(118101,3281,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(118102,3281,'zh','ä¾›åº”å•†å·²æˆåŠŸåˆ é™¤\r\n',0),(118103,3281,'sv','LeverantÃ¶r som raderades',0),(118104,3281,'it','Fornitore eliminato con successo',0),(118105,3281,'tl','',0),(118106,3281,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(118107,3281,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾',0),(118108,3281,'ms','Penjual dihapuskan dengan jayanya',0),(118109,3281,'ar','Ø­Ø°Ù Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(118110,3281,'fr','Fournisseur supprimÃ© avec succÃ¨s',0),(118111,3281,'jp','æ¥­è€…ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(118112,3281,'pt','Vendedor deletado com sucesso',0),(118113,3281,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(118114,3281,'es','Proveedor eliminado exitosamente',0),(118115,3281,'de','Anbieter wurde erfolgreich gelÃ¶scht',0),(118116,3281,'en','Vendor deleted successfully',0),(118117,3282,'is','',0),(118118,3282,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ø¨Ø± Ø®Ø§Ø±Ø¬ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(118119,3282,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ø¨Ø± Ø®Ø§Ø±Ø¬ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(118120,3282,'tr','SatÄ±cÄ± dÄ±ÅŸ kullanÄ±cÄ± gÃ¼ncelleÅŸtirme',0),(118121,3282,'pl','Aktualizacja uÅ¼ytkownika zewnÄ™trznego dostawcy',0),(118122,3282,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð²ÑŠÐ½ÑˆÐµÐ½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(118123,3282,'ur','ÙˆÛŒÙ†ÚˆØ± Ø®Ø§Ø±Ø¬ÛŒ ØµØ§Ø±Ù ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(118124,3282,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÐµÐºÑÑ‚ÐµÑ€Ð½Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(118125,3282,'vi','Cáº­p Nháº­t NgÆ°á»i Sá»­ Dá»¥ng BÃªn NgoÃ i Cá»§a NgÆ°á»i BÃ¡n',0),(118126,3282,'af','Verskaffer Ekterne Gebruiker Opdateer',0),(118127,3282,'ro','Furnizor extern utilizator actualizare',0),(118128,3282,'et','Hankija vÃ¤lise kasutaja vÃ¤rskendus',0),(118129,3282,'si','Prodajalec zunanjo uporabnik modernizirati',0),(118130,3282,'ba','Penjual pengguna eksternal Update',0),(118131,3282,'nl','Leverancier externe gebruiker Update',0),(118132,3282,'fi','Toimittajan ulkoinen kÃ¤yttÃ¤jÃ¤ pÃ¤ivitys',0),(118133,3282,'no','LeverandÃ¸ren ekstern bruker oppdateringen',0),(118134,3282,'da','Kreditor ekstern bruger Update',0),(118135,3282,'ko','ê³µê¸‰ ì—…ì²´ ì™¸ë¶€ ì‚¬ìš©ìž ì—…ë°ì´íŠ¸',0),(118136,3282,'he','×”×¡×¤×§ ×ž×©×ª×ž×© ×—×™×¦×•× ×™ ×¢×“×›×•×Ÿ',0),(118137,3282,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÎ¿Ï Ï‡ÏÎ®ÏƒÏ„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(118138,3282,'zh','ä¾›åº”å•†å¤–éƒ¨ç”¨æˆ·æ›´æ–°\r\n',0),(118139,3282,'sv','LeverantÃ¶r-uppdatering fÃ¶r externa anvÃ¤ndare',0),(118140,3282,'it','Aggiornamento utente esterno del fornitore',0),(118141,3282,'tl','',0),(118142,3282,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3641;&#3611;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118143,3282,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¾à¤¹à¤°à¥€ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(118144,3282,'ms','Kemaskini pengguna luaran Penjual',0),(118145,3282,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ø®Ø§Ø±Ø¬ÙŠ',0),(118146,3282,'fr','Mise Ã  jour utilisateur externe du vendeur',0),(118147,3282,'jp','æ¥­è€…å¤–éƒ¨ãƒ¦ãƒ¼ã‚¶ãƒ¼æ›´æ–°',0),(118148,3282,'pt','Vendedor externo usuÃ¡rio atualizaÃ§Ã£o',0),(118149,3282,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð²Ð½ÐµÑˆÐ½ÐµÐ³Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(118150,3282,'es','Proveedor Actualizar Usuario External',0),(118151,3282,'de','Anbieter externer Benutzer Update',0),(118152,3282,'en','Vendor External User Update',0),(118153,3283,'is','',0),(118154,3283,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª  Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(118155,3283,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª  Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(118156,3283,'tr','SatÄ±cÄ± iÃ§in bordro mevduat',0),(118157,3283,'pl','Dostawcy dla depozytu listy pÅ‚ac',0),(118158,3283,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(118159,3283,'ur','ÙˆÛŒÙ†ÚˆØ± Ù¾Û’ Ø±ÙˆÙ„ Ø¬Ù…Ø¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(118160,3283,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‚Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(118161,3283,'vi','NgÆ°á»i bÃ¡n cho SÃ©c lÆ°Æ¡ng',0),(118162,3283,'af','Verskaffer vir Loonrol Deposito',0),(118163,3283,'ro','Furnizor pentru depozit de salarizare',0),(118164,3283,'et','Hankija palgaarvestuse hoiuse',0),(118165,3283,'si','Dobavitelja za depozit na izplaÄane plaÄe',0),(118166,3283,'ba','Vendor untuk penggajian Deposit',0),(118167,3283,'nl','Leverancier voor Payroll storting',0),(118168,3283,'fi','Toimittajan palkanlaskennan talletus',0),(118169,3283,'no','LeverandÃ¸r for lÃ¸nn innskudd',0),(118170,3283,'da','LeverandÃ¸r til lÃ¸nningslisten depositum',0),(118171,3283,'ko','ê¸‰ì—¬ ìž…ê¸ˆì— ëŒ€ í•œ ê³µê¸‰ ì—…ì²´',0),(118172,3283,'he','×”×¡×¤×§ ×¢×‘×•×¨ ×ž×©×›×•×¨×•×ª ×¤×™×§×“×•×Ÿ',0),(118173,3283,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î³Î¹Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(118174,3283,'zh','ä¾›åº”å•†çš„å·¥èµ„å­˜æ¬¾\r\n',0),(118175,3283,'sv','LeverantÃ¶r fÃ¶r lÃ¶n insÃ¤ttning',0),(118176,3283,'it','Fornitore per il deposito delle retribuzioni',0),(118177,3283,'tl','',0),(118178,3283,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118179,3283,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤‚à¤¬à¤§à¥€ à¤œà¤®à¤¾ à¤•à¥‡ à¤²à¤¿à¤',0),(118180,3283,'ms','Penjual bagi Deposit pembayaran gaji',0),(118181,3283,'ar','Ø¨Ø§Ø¦Ø¹ Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(118182,3283,'fr','Fournisseur pour les virements de fonds',0),(118183,3283,'jp','Vendor for payroll deposit',0),(118184,3283,'pt','Vendedor para depÃ³sito de folha de pagamento',0),(118185,3283,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð´Ð»Ñ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(118186,3283,'es','Proveedor para DepÃ³sitos de NÃ³mina',0),(118187,3283,'de','Anbieter fÃ¼r Lohn-und Gehaltsabrechnung Einzahlung',0),(118188,3283,'en','Vendor for Payroll Deposit',0),(118189,3284,'is','',0),(118190,3284,'dr','Ø§Ø·Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(118191,3284,'pr','Ø§Ø·Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(118192,3284,'tr','SatÄ±cÄ± bilgisi iÃ§in',0),(118193,3284,'pl','Dostawcy informacji dla',0),(118194,3284,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð·Ð°',0),(118195,3284,'ur','ÙˆÛŒÙ†ÚˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ù„ÛŒÛ’',0),(118196,3284,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ñƒ Ð·Ð°',0),(118197,3284,'vi','ThÃ´ng Tin ngÆ°á»i bÃ¡n cho',0),(118198,3284,'af','Verskaffer Inligting vir',0),(118199,3284,'ro','Furnizor de informaÅ£ii pentru',0),(118200,3284,'et','MÃ¼Ã¼ja Info',0),(118201,3284,'si','Dobavitelj informacij za',0),(118202,3284,'ba','Penjual Info untuk',0),(118203,3284,'nl','Info van de leverancier voor',0),(118204,3284,'fi','Toimittajan tiedot',0),(118205,3284,'no','LeverandÃ¸ren Info for',0),(118206,3284,'da','LeverandÃ¸r Info for',0),(118207,3284,'ko','ê³µê¸‰ ì—…ì²´ ì •ë³´',0),(118208,3284,'he','×ž×™×“×¢ ×¡×¤×§ ×¢×‘×•×¨',0),(118209,3284,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î³Î¹Î±',0),(118210,3284,'zh','ä¾›åº”å•†ä¿¡æ¯\r\n',0),(118211,3284,'sv','LeverantÃ¶r information fÃ¶r',0),(118212,3284,'it','Vendor Info per',0),(118213,3284,'tl','',0),(118214,3284,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(118215,3284,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(118216,3284,'ms','Maklumat penjual untuk',0),(118217,3284,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ±Ø¯',0),(118218,3284,'fr','Info du vendeur pour',0),(118219,3284,'jp','æ¥­è€…æƒ…å ±',0),(118220,3284,'pt','Fornecedor de informaÃ§Ã£o para',0),(118221,3284,'ru','Ð˜Ð½Ñ„Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð´Ð»Ñ',0),(118222,3284,'es','Proveedor Info para',0),(118223,3284,'de','Hersteller Info fÃ¼r',0),(118224,3284,'en','Vendor Info for',0),(118225,3285,'is','',0),(118226,3285,'dr','ÙƒØ§Ù„Ø§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø­Ø°Ù Ø´Ø¯ ',0),(118227,3285,'pr','ÙƒØ§Ù„Ø§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø­Ø°Ù Ø´Ø¯ ',0),(118228,3285,'tr','MADDE SATICISI SÄ°LÄ°NDÄ°',0),(118229,3285,'pl','DOSTAWCA ZAPASU USUNIÄ˜TE',0),(118230,3285,'bg','Ð”ÐžÐ¡Ð¢ÐÐ’Ð§Ð˜Ðš ÐÐ ÐÐ Ð¢Ð˜ÐšÐ£Ð› Ð˜Ð—Ð¢Ð Ð˜Ð¢Ð˜',0),(118231,3285,'ur','Ø­Ø°Ù Ø´Ø¯Û Ø¢Ø¦Ù¹Ù… ÙØ±ÙˆØ´Ù†Ø¯Û',0),(118232,3285,'sr','Ð”ÐžÐ‘ÐÐ’Ð‰ÐÐ§ ÐÐ Ð¢Ð˜ÐšÐ›Ð Ð˜Ð—Ð‘Ð Ð˜Ð¡ÐÐÐ•',0),(118233,3285,'vi','XÃ³a ngÆ°á»i bÃ¡n hÃ ng',0),(118234,3285,'af','ITEM VERSKAFFER GESKRAP',0),(118235,3285,'ro','FURNIZOR DE ELEMENT ÅžTERS',0),(118236,3285,'et','KAUBA HANKIJA KUSTUTATUD',0),(118237,3285,'si','ARTIKEL DOBAVITELJ ÄŒRTA',0),(118238,3285,'ba','VENDOR ITEM YANG DIHAPUS',0),(118239,3285,'nl','ARTIKELLEVERANCIER VERWIJDERD',0),(118240,3285,'fi','NIMIKKEEN TOIMITTAJA POISTETTU',0),(118241,3285,'no','VARELEVERANDÃ˜R SLETTET',0),(118242,3285,'da','VARE/LEVERANDÃ˜R SLETTET',0),(118243,3285,'ko','ì‚­ì œ ëœ í•­ëª© ê³µê¸‰ ì—…ì²´',0),(118244,3285,'he','×¤×¨×™×˜ ×¡×¤×§ ×©× ×ž×—×§×•',0),(118245,3285,'el','Î Î¡ÎŸÎœÎ—Î˜Î•Î¥Î¤Î‰Î£ Î•ÎŠÎ”ÎŸÎ¥Î£ Î”Î™Î‘Î“Î¡Î‘Î¦Î•ÎŠ',0),(118246,3285,'zh','å–æ–¹é¡¹ç›®åˆ é™¤\r\n',0),(118247,3285,'sv','ARTIKELNS LEVERANTÃ–R TAS BORT',0),(118248,3285,'it','ARTICOLO FORNITORE ELIMINATO',0),(118249,3285,'tl','',0),(118250,3285,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3612;&#3621;&#3636;&#3605;&#3649;&#3621;&#3657;&#3623;',0),(118251,3285,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(118252,3285,'ms','PENJUAL ITEM YANG DIHAPUSKAN',0),(118253,3285,'ar','Ø­Ø°Ù Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ù„Ù„ØµÙ†Ù',0),(118254,3285,'fr','FOURNISSEUR ARTICLE SUPPRIMÃ‰',0),(118255,3285,'jp','å“?ç›®æ¥­è€…ã?®æ¶ˆåŽ»',0),(118256,3285,'pt','FORNECEDOR DE ITEM EXCLUÃDO',0),(118257,3285,'ru','ÐŸÐžÐ¡Ð¢ÐÐ’Ð©Ð˜Ðš Ð¢ÐžÐ’ÐÐ Ð Ð£Ð”ÐÐ›Ð•Ð',0),(118258,3285,'es','PROVEEDOR DE ITEM ELIMINADO',0),(118259,3285,'de','ARTIKELLIEFERANT GELÃ–SCHT',0),(118260,3285,'en','ITEM VENDOR DELETED',0),(118261,3286,'is','',0),(118262,3286,'dr','/ ÙØ±ÙˆØ´Ù†Ø¯Ù‡  Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(118263,3286,'pr','ÙƒØ§Ù„Ø§ / ÙØ±ÙˆØ´Ù†Ø¯Ù‡  Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(118264,3286,'tr','Madde/tedarikÃ§i gÃ¼ncellendi',0),(118265,3286,'pl','Towar/dostawca zostaÅ‚ zaktualizowany',0),(118266,3286,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸Ñ‚Ðµ/Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸Ñ‚Ðµ Ðµ Ð±Ð¸Ð» Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½',0),(118267,3286,'ur','Ø´Û’/ÙˆÛŒÙ†ÚˆØ± Ø§Ù¾ ÚˆÛŒÙ¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(118268,3286,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð»Ð° /Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð°.',0),(118269,3286,'vi','Danh Má»¥c/NgÆ°á»i bÃ¡n Ä‘Ã£ cáº­p nháº­t',0),(118270,3286,'af','Item/Verskaffer is opdateer',0),(118271,3286,'ro','Furnizor/articol a fost actualizat',0),(118272,3286,'et','Kauba/hankija uuendatud',0),(118273,3286,'si','Posodobljen dobavitelj artikla /',0),(118274,3286,'ba','Item Vendor telah diperbarui',0),(118275,3286,'nl','Artikelleverancier/is bijgewerkt',0),(118276,3286,'fi','Nimike/toimittaja on pÃ¤ivitetty',0),(118277,3286,'no','Vare/leverandÃ¸r er oppdatert',0),(118278,3286,'da','Vare/leverandÃ¸r er blevet opdateret',0),(118279,3286,'ko','í•­ëª©/ê³µê¸‰ ì—…ì²´ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(118280,3286,'he','×”×¤×¨×™×˜/×¡×¤×§ ×¢×•×“×›×Ÿ',0),(118281,3286,'el','ÎˆÏ‡ÎµÎ¹ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¸ÎµÎ¯ ÎµÎ¹Î´ÏŽÎ½/Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½',0),(118282,3286,'zh','é¡¹ç›®/ä¾›åº”å•†å·²æ›´æ–°\r\n',0),(118283,3286,'sv','Artikel/leverantÃ¶r har uppdaterats',0),(118284,3286,'it','Ãˆ stato aggiornato l\'articolo/fornitore',0),(118285,3286,'tl','',0),(118286,3286,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;/&#3612;&#3641;&#3657;&#3612;&#3621;&#3636;&#3605;&#3617;&#3637;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(118287,3286,'hi','à¤®à¤¦/à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(118288,3286,'ms','Butiran/penjual telah dikemaskini',0),(118289,3286,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„ØµÙ†Ù/Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(118290,3286,'fr','Article/fournisseur a Ã©tÃ© mis Ã  jour',0),(118291,3286,'jp','å“?ç›®/æ¥­è€…ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(118292,3286,'pt','Itens/fornecedores foi atualizado',0),(118293,3286,'ru','Ð¢Ð¾Ð²Ð°Ñ€/ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð±Ñ‹Ð» Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(118294,3286,'es','Item/Proveedor se actualizan',0),(118295,3286,'de','Artikel/Kreditor wurde aktualisiert',0),(118296,3286,'en','Item/Vendor has been updated',0),(118297,3287,'is','',0),(118298,3287,'dr','Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118299,3287,'pr','Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118300,3287,'tr','SatÄ±cÄ± listesi',0),(118301,3287,'pl','Lista dostawcÃ³w',0),(118302,3287,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(118303,3287,'ur','ÙˆÛŒÙ†ÚˆØ± ÙÛØ±Ø³Øª',0),(118304,3287,'sr','Ð›Ð¸ÑÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(118305,3287,'vi','Danh sÃ¡ch NgÆ°á»i bÃ¡n',0),(118306,3287,'af','Verkoper lys',0),(118307,3287,'ro','Lista furnizori',0),(118308,3287,'et','Hankijate loend',0),(118309,3287,'si','Seznam dobaviteljev',0),(118310,3287,'ba','Daftar vendor',0),(118311,3287,'nl','Leveranciersoverzicht',0),(118312,3287,'fi','Toimittajien luettelo',0),(118313,3287,'no','LeverandÃ¸roversikt',0),(118314,3287,'da','Vendor List',0),(118315,3287,'ko','ê³µê¸‰ ì—…ì²´ ëª©ë¡',0),(118316,3287,'he','×¨×©×™×ž×ª ×¡×¤×§',0),(118317,3287,'el','Î›Î¯ÏƒÏ„Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½',0),(118318,3287,'zh','ä¾›åº”å•†åå•\r\n',0),(118319,3287,'sv','LeverantÃ¶rslista',0),(118320,3287,'it','Vendor List',0),(118321,3287,'tl','',0),(118322,3287,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118323,3287,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥‚à¤šà¥€',0),(118324,3287,'ms','Senarai vendor',0),(118325,3287,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(118326,3287,'fr','Liste des fournisseurs',0),(118327,3287,'jp','æ¥­è€…ãƒªã‚¹ãƒˆ',0),(118328,3287,'pt','Lista de fornecedores',0),(118329,3287,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(118330,3287,'es','Lista de Proveedores',0),(118331,3287,'de','Lieferantenliste',0),(118332,3287,'en','Vendor List',0),(118333,3288,'is','',0),(118334,3288,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ Ùˆ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118335,3288,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ Ùˆ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118336,3288,'tr','SatÄ±cÄ± liste ve etiketleri',0),(118337,3288,'pl','Dostawca list i etykiety',0),(118338,3288,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ Ð¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(118339,3288,'ur','ÙˆÛŒÙ†ÚˆØ± ÙÛØ±Ø³ØªÙˆÚº Ø§ÙˆØ± Ù„ÛŒØ¨Ù„',0),(118340,3288,'sr','Ð›Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸ Ð¾Ð·Ð½Ð°ÐºÐµ',0),(118341,3288,'vi','Danh sÃ¡ch NgÆ°á»i bÃ¡n & NhÃ£n',0),(118342,3288,'af','Verskaffer Lyste en Ettikette',0),(118343,3288,'ro','Liste de furnizori ÅŸi etichete',0),(118344,3288,'et','Hankija nimekirjad ja sildid',0),(118345,3288,'si','Prodajalec Seznami in oznake',0),(118346,3288,'ba','Daftar Penjual dan label',0),(118347,3288,'nl','Verkoper lijsten en etiketten',0),(118348,3288,'fi','Toimittajan luettelot ja tarrat',0),(118349,3288,'no','LeverandÃ¸rer lister og etiketter',0),(118350,3288,'da','Kreditor lister og etiketter',0),(118351,3288,'ko','ê³µê¸‰ ì—…ì²´ ëª©ë¡ ë° ë ˆì´ë¸”',0),(118352,3288,'he','×ª×•×•×™×•×ª ×•×¨×©×™×ž×•×ª ×¡×¤×§',0),(118353,3288,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î»Î¯ÏƒÏ„ÎµÏ‚ ÎºÎ±Î¹ ÎµÏ„Î¹ÎºÎ­Ï„ÎµÏ‚',0),(118354,3288,'zh','ä¾›åº”å•†åå•å’Œæ ‡ç­¾\r\n',0),(118355,3288,'sv','FÃ¶rsÃ¤ljare listor och etiketter',0),(118356,3288,'it','Fornitore elenchi ed etichette',0),(118357,3288,'tl','',0),(118358,3288,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3649;&#3621;&#3632;&#3611;&#3657;&#3634;&#3618;&#3585;&#3635;&#3585;&#3633;&#3610;',0),(118359,3288,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥‚à¤šà¥€ à¤”à¤° à¤²à¥‡à¤¬à¤²',0),(118360,3288,'ms','Senarai penjual dan label',0),(118361,3288,'ar','Ù‚ÙˆØ§Ø¦Ù… Ùˆ Ù…Ù„ØµÙ‚Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(118362,3288,'fr','Listes de fournisseurs et Ã©tiquettes',0),(118363,3288,'jp','æ¥­è€…ãƒªã‚¹ãƒˆã?¨ãƒ©ãƒ™ãƒ«',0),(118364,3288,'pt','Fornecedores de listas e etiquetas',0),(118365,3288,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¸ ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸',0),(118366,3288,'es','Listas y Etiquetas de Proveedores',0),(118367,3288,'de','Hersteller-Listen und Etiketten',0),(118368,3288,'en','Vendor Lists and Labels',0),(118369,3289,'is','',0),(118370,3289,'dr','ÙƒØ§Ø±Ø¨Ø± ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118371,3289,'pr','ÙƒØ§Ø±Ø¨Ø± ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118372,3289,'tr','SatÄ±cÄ± oturum aÃ§ma kullanÄ±cÄ±',0),(118373,3289,'pl','Dostawcy logowania uÅ¼ytkownika',0),(118374,3289,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Login Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(118375,3289,'ur','ÙˆÛŒÙ†ÚˆØ± Ù„Ø§Ú¯ Ø§Ù† ØµØ§Ø±Ù',0),(118376,3289,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(118377,3289,'vi','TÃªn ÄÄƒng Nháº­p NgÆ°á»i BÃ¡n B2B',0),(118378,3289,'af','Verskaffer Gebruiker Aantekening',0),(118379,3289,'ro','Furnizor Autentificare utilizator',0),(118380,3289,'et','MÃ¼Ã¼k sisselogimise kasutaja',0),(118381,3289,'si','Prodajalec prijavo uporabnika',0),(118382,3289,'ba','Penjual Login pengguna',0),(118383,3289,'nl','Leverancier Login gebruiker',0),(118384,3289,'fi','Toimittajan kÃ¤yttÃ¤jÃ¤tunnusten',0),(118385,3289,'no','LeverandÃ¸ren pÃ¥logget bruker',0),(118386,3289,'da','LeverandÃ¸r Login bruger',0),(118387,3289,'ko','ê³µê¸‰ ì—…ì²´ ë¡œê·¸ì¸ ì‚¬ìš©ìž',0),(118388,3289,'he','×”×¡×¤×§ ×›× ×™×¡×” ×ž×©×ª×ž×©',0),(118389,3289,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î•Î¯ÏƒÎ¿Î´Î¿Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·',0),(118390,3289,'zh','ä¾›åº”å•†ç™»å½•ç”¨æˆ·\r\n',0),(118391,3289,'sv','Inloggning leverantÃ¶rsanvÃ¤ndare',0),(118392,3289,'it','Utente Login Fornitore',0),(118393,3289,'tl','',0),(118394,3289,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118395,3289,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤²à¥‰à¤—à¤¿à¤¨ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(118396,3289,'ms','Penjual Login pengguna',0),(118397,3289,'ar','Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(118398,3289,'fr','Utilisateur de la connexion du vendeur',0),(118399,3289,'jp','æ¥­è€…ãƒ­ã‚°ã‚¤ãƒ³ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(118400,3289,'pt','UsuÃ¡rio de Login do fornecedor',0),(118401,3289,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð›Ð¾Ð³Ð¸Ð½ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(118402,3289,'es','Proveedor Usuario Login',0),(118403,3289,'de','HÃ¤ndler Login Benutzer',0),(118404,3289,'en','Vendor Login User',0),(118405,3290,'is','',0),(118406,3290,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118407,3290,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118408,3290,'tr','SatÄ±cÄ± arama',0),(118409,3290,'pl','Dostawcy wyszukiwania',0),(118410,3290,'bg','Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(118411,3290,'ur','ÙˆÛŒÙ†ÚˆØ± Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(118412,3290,'sr','Ð—Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(118413,3290,'vi','TÃ¬m NgÆ°á»i bÃ¡n',0),(118414,3290,'af','Verskaffer Opsoek',0),(118415,3290,'ro','CÄƒutare distribuitor',0),(118416,3290,'et','Tarnija otsing',0),(118417,3290,'si','Iskanje dobavitelja',0),(118418,3290,'ba','Penjual Lookup',0),(118419,3290,'nl','Leverancier zoeken',0),(118420,3290,'fi','Toimittajan valinta',0),(118421,3290,'no','LeverandÃ¸ren oppslag',0),(118422,3290,'da','Kreditor opslag',0),(118423,3290,'ko','ê³µê¸‰ ì—…ì²´ ì¡°íšŒ',0),(118424,3290,'he','×—×™×¤×•×© ×¡×¤×§',0),(118425,3290,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½',0),(118426,3290,'zh','ä¾›åº”å•†æŸ¥æ‰¾\r\n',0),(118427,3290,'sv','LeverantÃ¶r-sÃ¶kning',0),(118428,3290,'it','Ricerca fornitore',0),(118429,3290,'tl','',0),(118430,3290,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118431,3290,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤²à¥à¤•à¤…à¤ª',0),(118432,3290,'ms','Penjual Lookup',0),(118433,3290,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(118434,3290,'fr','Recherche de fournisseur',0),(118435,3290,'jp','æ¥­è€…èª¿ã?¹',0),(118436,3290,'pt','Pesquisa de fornecedores',0),(118437,3290,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(118438,3290,'es','Proveedor Buscar',0),(118439,3290,'de','Kreditor-Lookup',0),(118440,3290,'en','Vendor Lookup',0),(118441,3291,'is','',0),(118442,3291,'dr','/ Ø¢Ù¾Ø¯ÛŒØª  ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118443,3291,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118444,3291,'tr','SatÄ±cÄ± Ekle/GÃ¼ncelle',0),(118445,3291,'pl','Dodawanie dostawcy/aktualizacja',0),(118446,3291,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(118447,3291,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(118448,3291,'sr','/ ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(118449,3291,'vi','ThÃªm/cáº­p nháº­t NgÆ°á»i bÃ¡n',0),(118450,3291,'af','Handelaar byvoeg/opdatering',0),(118451,3291,'ro','Adauga furnizor/Update',0),(118452,3291,'et','Hankija andmete lisamine/uuendamine',0),(118453,3291,'si','Prodajalec Dodaj/posodobi',0),(118454,3291,'ba','Penjual Tambahkan/Perbarui',0),(118455,3291,'nl','Leverancier toevoegen/bijwerken',0),(118456,3291,'fi','Toimittajan lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(118457,3291,'no','LeverandÃ¸r/Oppdater',0),(118458,3291,'da','LeverandÃ¸ren tilfÃ¸jer/opdatering',0),(118459,3291,'ko','ê³µê¸‰ ì—…ì²´ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(118460,3291,'he','×”×•×¡×¤×ª/×¢×“×›×•×Ÿ ×¡×¤×§',0),(118461,3291,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(118462,3291,'zh','ä¾›åº”å•†æ–°å¢ž/æ›´æ–°\r\n',0),(118463,3291,'sv','LeverantÃ¶ren lÃ¤gger till/uppdatera',0),(118464,3291,'it','Aggiungere/aggiornamento del fornitore',0),(118465,3291,'tl','',0),(118466,3291,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3629;&#3633;&#3614;&#3648;&#3604;&#3605;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118467,3291,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(118468,3291,'ms','Penjual Tambah/Kemaskini',0),(118469,3291,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù…ÙˆØ±Ø¯',0),(118470,3291,'fr','Vendeur ajouter/mettre Ã  jour',0),(118471,3291,'jp','æ¥­è€…ã?®è¿½åŠ /æ›´æ–°',0),(118472,3291,'pt','Adicionar/atualizar do fornecedor',0),(118473,3291,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(118474,3291,'es','Proveedor Agregar/Actualizar',0),(118475,3291,'de','Anbieter hinzufÃ¼gen/aktualisieren',0),(118476,3291,'en','Vendor Add/Update',0),(118477,3292,'is','',0),(118478,3292,'dr','Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118479,3292,'pr','Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118480,3292,'tr','SatÄ±cÄ± adÄ±',0),(118481,3292,'pl','Nazwa dostawcy',0),(118482,3292,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(118483,3292,'ur','ÙˆÛŒÙ†ÚˆØ± Ù†Ø§Ù…',0),(118484,3292,'sr','Ð˜Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(118485,3292,'vi','TÃªn NgÆ°á»i bÃ¡n',0),(118486,3292,'af','Verskaffer Naam',0),(118487,3292,'ro','Nume furnizor',0),(118488,3292,'et','Tarnija nimi',0),(118489,3292,'si','Ime dobavitelja',0),(118490,3292,'ba','Nama Penjual',0),(118491,3292,'nl','De naam van de leverancier',0),(118492,3292,'fi','Toimittajan nimi',0),(118493,3292,'no','LeverandÃ¸rnavn',0),(118494,3292,'da','Kreditornavnet',0),(118495,3292,'ko','ê³µê¸‰ ì—…ì²´ ì´ë¦„',0),(118496,3292,'he','×©× ×¡×¤×§',0),(118497,3292,'el','ÎŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(118498,3292,'zh','ä¾›åº”å•†åç§°\r\n',0),(118499,3292,'sv','LeverantÃ¶rens namn',0),(118500,3292,'it','Nome del fornitore',0),(118501,3292,'tl','',0),(118502,3292,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118503,3292,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¾à¤®',0),(118504,3292,'ms','Nama penjual.',0),(118505,3292,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…ÙˆØ±Ø¯',0),(118506,3292,'fr','Nom du vendeur',0),(118507,3292,'jp','æ¥­è€…å??',0),(118508,3292,'pt','Nome do fornecedor',0),(118509,3292,'ru','Ð˜Ð¼Ñ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(118510,3292,'es','Nombre de Proveedor',0),(118511,3292,'de','Name des Kreditors',0),(118512,3292,'en','Vendor Name',0),(118513,3293,'is','',0),(118514,3293,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯ ',0),(118515,3293,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯ ',0),(118516,3293,'tr','SatÄ±cÄ± ekledi.',0),(118517,3293,'pl','Sprzedawca nie dodaÅ‚.',0),(118518,3293,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ.',0),(118519,3293,'ur','ÙˆÛŒÙ†ÚˆØ± Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©ÛŒØ§ Û”',0),(118520,3293,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð½Ðµ Ð´Ð¾Ð´Ð°Ñ˜Ñƒ.',0),(118521,3293,'vi','ChÆ°a thÃªm NgÆ°á»i bÃ¡n',0),(118522,3293,'af','Handelaar nie bygevoeg.',0),(118523,3293,'ro','VÃ¢nzÄƒtorul nu adÄƒugat.',0),(118524,3293,'et','Tarnijat ei lisatud',0),(118525,3293,'si','Prodajalec ne doda.',0),(118526,3293,'ba','Penjual tidak ditambahkan.',0),(118527,3293,'nl','Leverancier niet toegevoegd.',0),(118528,3293,'fi','Toimittaja ei lisÃ¤tÃ¤.',0),(118529,3293,'no','LeverandÃ¸r ikke lagt.',0),(118530,3293,'da','Kreditor ikke tilfÃ¸jet.',0),(118531,3293,'ko','ê³µê¸‰ ì—…ì²´ ì¶”ê°€ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(118532,3293,'he','×”×¡×¤×§ ×œ× ×”×•×¡×™×£.',0),(118533,3293,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´ÎµÎ½ Ï€ÏÎ¿ÏƒÏ„Î¯Î¸ÎµÏ„Î±Î¹.',0),(118534,3293,'zh','ä¾›åº”å•†æœªæ·»åŠ ã€‚\r\n',0),(118535,3293,'sv','LeverantÃ¶ren inte lagt till.',0),(118536,3293,'it','Fornitore non aggiunto.',0),(118537,3293,'tl','',0),(118538,3293,'th','&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118539,3293,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾à¥¤',0),(118540,3293,'ms','Penjual tidak ditambah.',0),(118541,3293,'ar','Ù„Ù… ÙŠØ¶Ù Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(118542,3293,'fr','Vendeur ne pas ajoutÃ©.',0),(118543,3293,'jp','æ¥­è€…ã?Œè¿½åŠ ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(118544,3293,'pt','Fornecedor nÃ£o adicionado.',0),(118545,3293,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(118546,3293,'es','Proveedor no agregado',0),(118547,3293,'de','VerkÃ¤ufer nicht hinzugefÃ¼gt.',0),(118548,3293,'en','Vendor not added.',0),(118549,3294,'is','',0),(118550,3294,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(118551,3294,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(118552,3294,'tr','SatÄ±cÄ± bulunamadÄ±.',0),(118553,3294,'pl','Dostawcy nie znaleziono.',0),(118554,3294,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(118555,3294,'ur','ÙˆÛŒÙ†ÚˆØ± Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(118556,3294,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(118557,3294,'vi','KhÃ´ng tháº¥y NgÆ°á»i bÃ¡n',0),(118558,3294,'af','Handelaar nie gevind nie.',0),(118559,3294,'ro','Furnizor negÄƒsit.',0),(118560,3294,'et','Hankija ei leitud.',0),(118561,3294,'si','Prodajalec ni mogoÄe najti.',0),(118562,3294,'ba','Penjual tidak ditemukan.',0),(118563,3294,'nl','Leverancier niet gevonden.',0),(118564,3294,'fi','Toimittajaa ei lÃ¶ydy.',0),(118565,3294,'no','LeverandÃ¸r ikke funnet.',0),(118566,3294,'da','Kreditor blev ikke fundet.',0),(118567,3294,'ko','ê³µê¸‰ ì—…ì²´ëŠ” ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(118568,3294,'he','×¡×¤×§ ×œ× × ×ž×¦×',0),(118569,3294,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(118570,3294,'zh','ä¾›åº”å•†æœªæ‰¾åˆ°ã€‚\r\n',0),(118571,3294,'sv','LeverantÃ¶ren inte hittas.',0),(118572,3294,'it','Fornitore non trovato.',0),(118573,3294,'tl','',0),(118574,3294,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118575,3294,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾à¥¤',0),(118576,3294,'ms','Penjual tidak dijumpai.',0),(118577,3294,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(118578,3294,'fr','Fournisseur non trouvÃ©.',0),(118579,3294,'jp','æ¥­è€…ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(118580,3294,'pt','Vendedor nÃ£o foi encontrado.',0),(118581,3294,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(118582,3294,'es','Proveedor no se encontrÃ³',0),(118583,3294,'de','Anbieter nicht gefunden.',0),(118584,3294,'en','Vendor not found.',0),(118585,3295,'is','',0),(118586,3295,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118587,3295,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118588,3295,'tr','SatÄ±cÄ± #',0),(118589,3295,'pl','Sprzedawca nr',0),(118590,3295,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº #',0),(118591,3295,'ur','ÙˆÛŒÙ†ÚˆØ± #',0),(118592,3295,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° #',0),(118593,3295,'vi','NgÆ°á»i bÃ¡n sá»‘',0),(118594,3295,'af','Verskaffer #',0),(118595,3295,'ro','Furnizor #',0),(118596,3295,'et','Tarnija #',0),(118597,3295,'si','Prodajalec #',0),(118598,3295,'ba','Penjual #',0),(118599,3295,'nl','Leverancier #',0),(118600,3295,'fi','Toimittajan #',0),(118601,3295,'no','LeverandÃ¸ren #',0),(118602,3295,'da','LeverandÃ¸r #',0),(118603,3295,'ko','ê³µê¸‰ ì—…ì²´ #',0),(118604,3295,'he','# ×¡×¤×§',0),(118605,3295,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® #',0),(118606,3295,'zh','ä¾›åº”å•†ï¼ƒ\r\n',0),(118607,3295,'sv','LeverantÃ¶r nr',0),(118608,3295,'it','Fornitore n.',0),(118609,3295,'tl','',0),(118610,3295,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118611,3295,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ #',0),(118612,3295,'ms','Penjual #',0),(118613,3295,'ar','Ø±Ù‚Ù… Ø§Ù„Ù…ÙˆØ±Ø¯',0),(118614,3295,'fr','Fournisseur #',0),(118615,3295,'jp','æ¥­è€…ï¼ƒ',0),(118616,3295,'pt','Fornecedor #',0),(118617,3295,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº #',0),(118618,3295,'es','Proveedor #',0),(118619,3295,'de','Kreditor #',0),(118620,3295,'en','Vendor #',0),(118621,3296,'is','',0),(118622,3296,'dr','(Ø¹Ø±Ø¶Ù‡ ÙƒÙ†Ù†Ø¯Ù‡',0),(118623,3296,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ (Ø¹Ø±Ø¶Ù‡ ÙƒÙ†Ù†Ø¯Ù‡',0),(118624,3296,'tr','SatÄ±cÄ± #',0),(118625,3296,'pl','Sprzedawca nr',0),(118626,3296,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº #',0),(118627,3296,'ur','ÙˆÛŒÙ†ÚˆØ± #',0),(118628,3296,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° #',0),(118629,3296,'vi','NgÆ°á»i bÃ¡n sá»‘',0),(118630,3296,'af','Verskaffer # ',0),(118631,3296,'ro','Furnizor #',0),(118632,3296,'et','Tarnija #',0),(118633,3296,'si','Prodajalec #',0),(118634,3296,'ba','Penjual #',0),(118635,3296,'nl','Leverancier #',0),(118636,3296,'fi','Toimittajan #',0),(118637,3296,'no','LeverandÃ¸ren #',0),(118638,3296,'da','LeverandÃ¸r #',0),(118639,3296,'ko','ê³µê¸‰ ì—…ì²´ #',0),(118640,3296,'he','# ×¡×¤×§',0),(118641,3296,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® #',0),(118642,3296,'zh','é”€å”®å•†ï¼ƒ\r\n',0),(118643,3296,'sv','LeverantÃ¶r nr',0),(118644,3296,'it','Fornitore n.',0),(118645,3296,'tl','',0),(118646,3296,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118647,3296,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ #',0),(118648,3296,'ms','Penjual #',0),(118649,3296,'ar','Ø±Ù‚Ù… Ø§Ù„Ù…ÙˆØ±Ø¯',0),(118650,3296,'fr','Fournisseur #',0),(118651,3296,'jp','ä»•å…¥å…ˆç•ªå?·',0),(118652,3296,'pt','Fornecedor #',0),(118653,3296,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº #',0),(118654,3296,'es','Proveedor #',0),(118655,3296,'de','Kreditor #',0),(118656,3296,'en','Vendor #',0),(118657,3297,'is','',0),(118658,3297,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(118659,3297,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(118660,3297,'tr','SatÄ±cÄ± SipariÅŸ No',0),(118661,3297,'pl','Nr zamÃ³wienia dostawcy',0),(118662,3297,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° #',0),(118663,3297,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¢Ø±ÚˆØ± #',0),(118664,3297,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð½Ð°Ñ€ÐµÐ´Ð¸ #',0),(118665,3297,'vi','ÄÆ¡n hÃ ng ngÆ°á»i bÃ¡n sá»‘',0),(118666,3297,'af','Verskaffer Bestelling #',0),(118667,3297,'ro','Furnizor comanda #',0),(118668,3297,'et','Ostutellimus #',0),(118669,3297,'si','Dobavitelja, naroÄilo #',0),(118670,3297,'ba','Penjual memesan #',0),(118671,3297,'nl','Leverancier bestellen #',0),(118672,3297,'fi','Toimittajan tilausnumero',0),(118673,3297,'no','LeverandÃ¸rens bestillingsnummer',0),(118674,3297,'da','Kreditor bestille #',0),(118675,3297,'ko','ê³µê¸‰ ì—…ì²´ ì£¼ë¬¸ #',0),(118676,3297,'he','# ×”×–×ž× ×ª ×¡×¤×§',0),(118677,3297,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± #',0),(118678,3297,'zh','ä¾›åº”å•†è®¢å•ï¼ƒ\r\n',0),(118679,3297,'sv','LeverantÃ¶rens Ordernr',0),(118680,3297,'it','Fornitore di ordine n.',0),(118681,3297,'tl','',0),(118682,3297,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118683,3297,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤†à¤¦à¥‡à¤¶ #',0),(118684,3297,'ms','Penjual Order #',0),(118685,3297,'ar','Ø¨Ø§Ø¦Ø¹ Ø§Ù„Ù†Ø¸Ø§Ù… #',0),(118686,3297,'fr','No de commande fournisseur',0),(118687,3297,'jp','æ¥­è€…æ³¨æ–‡ï¼ƒ',0),(118688,3297,'pt','Vendedor de ordem #',0),(118689,3297,'ru','Ð—Ð°ÐºÐ°Ð· # ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(118690,3297,'es','Proveedor Orden #',0),(118691,3297,'de','Kreditor bestellen #',0),(118692,3297,'en','Vendor Order #',0),(118693,3298,'is','',0),(118694,3298,'dr','ÙƒØ¯ Ù…Ø­ØµÙˆÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118695,3298,'pr','ÙƒØ¯ Ù…Ø­ØµÙˆÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118696,3298,'tr','SatÄ±cÄ± Ã¼rÃ¼n kodu',0),(118697,3298,'pl','Kod produktu dostawcy',0),(118698,3298,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(118699,3298,'ur','ÙˆÛŒÙ†ÚˆØ± Ù¾Ø±ÙˆÚˆÚ©Ù¹ Ú©ÙˆÚˆ',0),(118700,3298,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(118701,3298,'vi','MÃ£ sáº£n pháº©m NgÆ°á»i bÃ¡n',0),(118702,3298,'af','Verskaffer Produkkode',0),(118703,3298,'ro','Cod de produs furnizor',0),(118704,3298,'et','Tarnija tootekood',0),(118705,3298,'si','Koda artikla dobavitelja',0),(118706,3298,'ba','Kode produk vendor',0),(118707,3298,'nl','Leverancier productcode',0),(118708,3298,'fi','Toimittajan Tuotekoodi',0),(118709,3298,'no','Produktkoden for leverandÃ¸r',0),(118710,3298,'da','Kreditorkoden produkt',0),(118711,3298,'ko','ê³µê¸‰ ì—…ì²´ ì œí’ˆ ì½”ë“œ',0),(118712,3298,'he','×§×•×“ ×ž×•×¦×¨ ×©×œ ×¡×¤×§',0),(118713,3298,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚',0),(118714,3298,'zh','ä¾›åº”å•†äº§å“ç¼–å·\r\n',0),(118715,3298,'sv','LeverantÃ¶rens produktkod',0),(118716,3298,'it','Codice prodotto Fornitore',0),(118717,3298,'tl','',0),(118718,3298,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3621;&#3636;&#3605;&#3616;&#3633;&#3603;&#3601;&#3660;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118719,3298,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤•à¥‹à¤¡',0),(118720,3298,'ms','Kod produk pembekal',0),(118721,3298,'ar','Ø±Ù…Ø² Ù…Ù†ØªØ¬ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(118722,3298,'fr','Code de produit du vendeur',0),(118723,3298,'jp','æ¥­è€…è£½å“?ã‚³ãƒ¼ãƒ‰',0),(118724,3298,'pt','CÃ³digo de produto do fornecedor',0),(118725,3298,'ru','ÐšÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(118726,3298,'es','Proveedor CÃ³digo de Producto',0),(118727,3298,'de','Hersteller-Produkt-Code',0),(118728,3298,'en','Vendor Product Code',0),(118729,3299,'is','',0),(118730,3299,'dr','Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118731,3299,'pr','Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118732,3299,'tr','SatÄ±cÄ± ÅŸartlarÄ±',0),(118733,3299,'pl','WarunkÃ³w dostawcy',0),(118734,3299,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(118735,3299,'ur','ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø·',0),(118736,3299,'sr','Ð£ÑÐ»Ð¾Ð²Ð¸ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(118737,3299,'vi','Äiá»u khoáº£n NgÆ°á»i bÃ¡n',0),(118738,3299,'af','Verskaffer Terme',0),(118739,3299,'ro','Termeni Furnizor',0),(118740,3299,'et','Hankija tingimused',0),(118741,3299,'si','Pogoji dobavitelja',0),(118742,3299,'ba','Vendor persyaratan',0),(118743,3299,'nl','Leverancier voorwaarden',0),(118744,3299,'fi','Toimittajan',0),(118745,3299,'no','LeverandÃ¸ren vilkÃ¥r',0),(118746,3299,'da','Kreditor vilkÃ¥r',0),(118747,3299,'ko','ê³µê¸‰ ì—…ì²´ ì¡°ê±´',0),(118748,3299,'he','×ª× ××™ ×¡×¤×§',0),(118749,3299,'el','Î¤Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(118750,3299,'zh','ä¾›åº”å•†æ¡æ¬¾\r\n',0),(118751,3299,'sv','Villkor fÃ¶r leverantÃ¶r',0),(118752,3299,'it','Termini di fornitore',0),(118753,3299,'tl','',0),(118754,3299,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118755,3299,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(118756,3299,'ms','Syarat-syarat Penjual',0),(118757,3299,'ar','Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(118758,3299,'fr','Conditions du vendeur',0),(118759,3299,'jp','æ¥­è€…æ?¡ä»¶',0),(118760,3299,'pt','Termos de fornecedor',0),(118761,3299,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(118762,3299,'es','Proveedor TÃ©rminos',0),(118763,3299,'de','VerkÃ¤ufer-AGB',0),(118764,3299,'en','Vendor Terms',0),(118765,3300,'is','',0),(118766,3300,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118767,3300,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118768,3300,'tr','Yeni satÄ±cÄ± aÃ§Ä±sÄ±ndan',0),(118769,3300,'pl','Nowych warunkÃ³w dostawcy',0),(118770,3300,'bg','ÐÐ¾Ð²Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(118771,3300,'ur','Ù†Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø·',0),(118772,3300,'sr','ÐÐ¾Ð²Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(118773,3300,'vi','ThÃªm Äiá»u khoáº£n NgÆ°á»i bÃ¡n',0),(118774,3300,'af','Verskaffer Terme Byvoeg',0),(118775,3300,'ro','Noul furnizor de termeni',0),(118776,3300,'et','Uue hankija tingimused',0),(118777,3300,'si','Novi pogoji dobavitelja',0),(118778,3300,'ba','Istilah Vendor baru',0),(118779,3300,'nl','Nieuwe leverancier voorwaarden',0),(118780,3300,'fi','Uudet toimittajan ehdot',0),(118781,3300,'no','Ny leverandÃ¸r-vilkÃ¥r',0),(118782,3300,'da','Ny leverandÃ¸r vilkÃ¥r',0),(118783,3300,'ko','ìƒˆë¡œìš´ ê³µê¸‰ ì—…ì²´ ì¡°ê±´',0),(118784,3300,'he','×ª× ××™ ×”×¡×¤×§ ×”×—×“×©',0),(118785,3300,'el','ÎÎ­Î¿Î¹ ÏŒÏÎ¿Î¹ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(118786,3300,'zh','ä¾›åº”å•†æ–°å¢žæ¡æ¬¾\r\n',0),(118787,3300,'sv','Nya villkor fÃ¶r leverantÃ¶r',0),(118788,3300,'it','Nuovi termini di fornitore',0),(118789,3300,'tl','',0),(118790,3300,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118791,3300,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤°à¥à¤¤à¥‹à¤‚',0),(118792,3300,'ms','Terma-terma penjual yang baru',0),(118793,3300,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(118794,3300,'fr','Nouvelles conditions de paiement du fournisseur',0),(118795,3300,'jp','æ¥­è€…å?–å¼•æ?¡ä»¶ã?®è¿½åŠ ',0),(118796,3300,'pt','Novos termos de fornecedor',0),(118797,3300,'ru','ÐÐ¾Ð²Ñ‹Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(118798,3300,'es','Proveedor Agregar TÃ©rminos',0),(118799,3300,'de','Neuer Lieferant-Begriffe',0),(118800,3300,'en','New Vendor Terms',0),(118801,3301,'is','',0),(118802,3301,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(118803,3301,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(118804,3301,'tr','SatÄ±cÄ± aÃ§Ä±sÄ±ndan baÅŸarÄ±yla eklendi',0),(118805,3301,'pl','Warunki dostawcy dodany pomyÅ›lnie',0),(118806,3301,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(118807,3301,'ur','ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø· Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(118808,3301,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÑƒÑÐ»Ð¾Ð²Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(118809,3301,'vi','ThÃªm Äiá»u khoáº£n NgÆ°á»i bÃ¡n thÃ nh cÃ´ng',0),(118810,3301,'af','Verskafferterme Suksesvol Bygevoeg',0),(118811,3301,'ro','Termeni de furnizor adÄƒugat cu succes',0),(118812,3301,'et','Hankija tingimused on edukalt',0),(118813,3301,'si','Prodajalec pogoji dodal uspeÅ¡no',0),(118814,3301,'ba','Penjual ketentuan ditambahkan berhasil',0),(118815,3301,'nl','Leverancier termen toegevoegd',0),(118816,3301,'fi','Toimittajan ehtojen lisÃ¤Ã¤minen onnistui',0),(118817,3301,'no','LeverandÃ¸ren vilkÃ¥rene lagt',0),(118818,3301,'da','Kreditor vilkÃ¥r tilfÃ¸jet',0),(118819,3301,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ê³µê¸‰ ì—…ì²´ ì¡°ê±´',0),(118820,3301,'he','×ª× ××™ ×¡×¤×§ × ×•×¡×¤×• ×‘×”×¦×œ×—×”',0),(118821,3301,'el','Î¤Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î¼Îµ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(118822,3301,'zh','ä¾›åº”å•†æ¡æ¬¾æ–°å¢žæˆåŠŸ\r\n',0),(118823,3301,'sv','Villkor fÃ¶r leverantÃ¶ren som lagts',0),(118824,3301,'it','Termini di fornitore aggiunti con successo',0),(118825,3301,'tl','',0),(118826,3301,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(118827,3301,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(118828,3301,'ms','Syarat-syarat penjual yang berjaya menambah',0),(118829,3301,'ar','Ø£Ø¶ÙŠÙØª Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(118830,3301,'fr','Conditions de paiement du fournisseur ajoutÃ©es avec succÃ¨s',0),(118831,3301,'jp','æ¥­è€…å?–å¼•æ?¡ä»¶ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(118832,3301,'pt','Termos de fornecedor adicionados com sucesso',0),(118833,3301,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð², ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(118834,3301,'es','Proveedor TÃ©rminos Agregados Exitosamente',0),(118835,3301,'de','Hersteller-Bedingungen erfolgreich hinzugefÃ¼gt',0),(118836,3301,'en','Vendor Terms added successfully',0),(118837,3302,'is','',0),(118838,3302,'dr','Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(118839,3302,'pr','Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(118840,3302,'tr','SatÄ±cÄ± aÃ§Ä±sÄ±ndan zaten var',0),(118841,3302,'pl','Warunki sprzedawcy juÅ¼ istnieÄ‡',0),(118842,3302,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(118843,3302,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(118844,3302,'sr','Ð¢ÐµÑ€Ð¼Ð¸Ð½Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(118845,3302,'vi','Äiá»u khoáº£n NgÆ°á»i bÃ¡n Ä‘Ã£ cÃ³',0),(118846,3302,'af','Verskaffer Terme Bestaan Alreeds',0),(118847,3302,'ro','Furnizor termeni deja exista',0),(118848,3302,'et','Hankija juba olemas',0),(118849,3302,'si','Prodajalec izrazi Å¾e obstaja',0),(118850,3302,'ba','Vendor persyaratan sudah ada',0),(118851,3302,'nl','Leverancier voorwaarden al bestaan',0),(118852,3302,'fi','Toimittajan ehdot jo olemassa',0),(118853,3302,'no','LeverandÃ¸ren vilkÃ¥r allerede finnes',0),(118854,3302,'da','Kreditor vilkÃ¥r allerede findes',0),(118855,3302,'ko','ê³µê¸‰ ì—…ì²´ ì¡°ê±´ ì´ë¯¸ ì¡´ìž¬',0),(118856,3302,'he','×ª× ××™ ×¡×¤×§ ×›×‘×¨ ×§×™×™×ž×™×',0),(118857,3302,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏŒÏÎ¿Ï…Ï‚ Î®Î´Î· Ï…Ï€Î¬ÏÏ‡ÎµÎ¹',0),(118858,3302,'zh','ä¾›åº”å•†æ¡æ¬¾å·²ç»å­˜åœ¨\r\n',0),(118859,3302,'sv','LeverantÃ¶rens villkor redan finns',0),(118860,3302,'it','Termini di fornitore giÃ  esiste',0),(118861,3302,'tl','',0),(118862,3302,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(118863,3302,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¿à¤¯à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦',0),(118864,3302,'ms','Syarat-syarat penjual sudah wujud',0),(118865,3302,'ar','Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ù…ÙˆØ¬ÙˆØ¯Ø© Ù…Ø³Ø¨Ù‚Ø§',0),(118866,3302,'fr','Conditions de paiement du fournisseur dÃ©jÃ  exister',0),(118867,3302,'jp','æ¥­è€…å?–å¼•æ?¡ä»¶ã?¯ã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(118868,3302,'pt','Termos de fornecedor jÃ¡ existe',0),(118869,3302,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ñ‹ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‚',0),(118870,3302,'es','Proveedor TÃ©rminos Ya Existen',0),(118871,3302,'de','Kreditor Begriffe bereits vorhanden',0),(118872,3302,'en','Vendor Terms Already Exist',0),(118873,3303,'is','',0),(118874,3303,'dr','Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(118875,3303,'pr','Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(118876,3303,'tr','SatÄ±cÄ± aÃ§Ä±sÄ±ndan baÅŸarÄ±yla silindi',0),(118877,3303,'pl','Warunki Vendor usuniÄ™ty',0),(118878,3303,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(118879,3303,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø·',0),(118880,3303,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÑƒÑÐ»Ð¾Ð²Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(118881,3303,'vi','XÃ³a Äiá»u khoáº£n NgÆ°á»i bÃ¡n thÃ nh cÃ´ng',0),(118882,3303,'af','Verskafferterme Suksesvol Geskrap',0),(118883,3303,'ro','Termeni de furnizor eliminÄƒ cu succes',0),(118884,3303,'et','Hankija tingimusi edukalt kustutatud',0),(118885,3303,'si','Prodajalec izrazi uspeÅ¡no izbrisana',0),(118886,3303,'ba','Vendor persyaratan dihapus berhasil',0),(118887,3303,'nl','Voorwaarden van de leverancier met succes verwijderd',0),(118888,3303,'fi','Toimittajan ehdot poistettu',0),(118889,3303,'no','LeverandÃ¸ren vilkÃ¥rene slettet',0),(118890,3303,'da','Kreditor vilkÃ¥r slettet',0),(118891,3303,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ê³µê¸‰ ì—…ì²´ ì¡°ê±´',0),(118892,3303,'he','×ª× ××™ ×”×¡×¤×§ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(118893,3303,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏŒÏÎ¿Ï…Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(118894,3303,'zh','ä¾›åº”å•†æ¡æ¬¾æˆåŠŸåˆ é™¤\r\n',0),(118895,3303,'sv','Villkor fÃ¶r leverantÃ¶ren raderades',0),(118896,3303,'it','Termini di fornitore eliminati con successo',0),(118897,3303,'tl','',0),(118898,3303,'th','&#3621;&#3610;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(118899,3303,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾',0),(118900,3303,'ms','Syarat-syarat penjual dihapuskan dengan jayanya',0),(118901,3303,'ar','Ø­Ø°ÙØª Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(118902,3303,'fr','Conditions de paiement du fournisseur supprimÃ©es avec succÃ¨s',0),(118903,3303,'jp','æ¥­è€…æ?¡ä»¶ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(118904,3303,'pt','Fornecedor de termos apagados com sucesso',0),(118905,3303,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð², ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(118906,3303,'es','Proveedor TÃ©rminos Eliminados Exitosamente',0),(118907,3303,'de','Hersteller-Bedingungen erfolgreich gelÃ¶scht',0),(118908,3303,'en','Vendor Terms deleted successfully',0),(118909,3304,'is','',0),(118910,3304,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· Ø¬Ø¯ÙŠØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118911,3304,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· Ø¬Ø¯ÙŠØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(118912,3304,'tr','Yeni ekle',0),(118913,3304,'pl','Dodaj nowe',0),(118914,3304,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²',0),(118915,3304,'ur','Ù†ÛŒØ§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(118916,3304,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³',0),(118917,3304,'vi','ThÃªm má»›i',0),(118918,3304,'af','Voeg nuwe',0),(118919,3304,'ro','AdÄƒuga noi',0),(118920,3304,'et','Lisa uus',0),(118921,3304,'si','Dodati novo',0),(118922,3304,'ba','Tambah baru',0),(118923,3304,'nl','Nieuwe toevoegen',0),(118924,3304,'fi','LisÃ¤Ã¤ uusi',0),(118925,3304,'no','Legge til nye',0),(118926,3304,'da','TilfÃ¸j ny',0),(118927,3304,'ko','ìƒˆë¡œ ì¶”ê°€',0),(118928,3304,'he','×”×•×¡×£ ×›×ª×•×‘×ª ×—×“×©×”',0),(118929,3304,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Ï‰Î½',0),(118930,3304,'zh','æ·»åŠ æ–°\r\n',0),(118931,3304,'sv','LÃ¤gga till nya',0),(118932,3304,'it','Aggiungere nuovi',0),(118933,3304,'tl','',0),(118934,3304,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3627;&#3617;&#3656;',0),(118935,3304,'hi','à¤¨à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(118936,3304,'ms','Tambah baru',0),(118937,3304,'ar','Ø¥Ø¶Ø§ÙØ© Ø¬Ø¯ÙŠØ¯',0),(118938,3304,'fr','Ajouter un nouveau',0),(118939,3304,'jp','æ–°è¦?è¿½åŠ ',0),(118940,3304,'pt','Adicionar Novo',0),(118941,3304,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ðµ',0),(118942,3304,'es','Agrgar Nuevo',0),(118943,3304,'de','FÃ¼gen neuer hinzu',0),(118944,3304,'en','Add New',0),(118945,3305,'is','',0),(118946,3305,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(118947,3305,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(118948,3305,'tr','SatÄ±cÄ± aÃ§Ä±sÄ±ndan DÃ¼zenle',0),(118949,3305,'pl','Edycja warunkÃ³w dostawcy',0),(118950,3305,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑƒÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(118951,3305,'ur','ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø· ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(118952,3305,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑƒÑÐ»Ð¾Ð²Ð¸',0),(118953,3305,'vi','Cáº­p Nháº­t Äiá»u Khoáº£n NgÆ°á»i BÃ¡n',0),(118954,3305,'af','Verskaffer Terme Opdateer',0),(118955,3305,'ro','Editare furnizor de termeni',0),(118956,3305,'et','Muuta hankija tingimused',0),(118957,3305,'si','Urejanje pogojev dobavitelja',0),(118958,3305,'ba','Mengedit Vendor persyaratan',0),(118959,3305,'nl','Voorwaarden van de verkoper bewerken',0),(118960,3305,'fi','Muokkaa toimittajan',0),(118961,3305,'no','Redigere leverandÃ¸r termer',0),(118962,3305,'da','Rediger leverandÃ¸r vilkÃ¥r',0),(118963,3305,'ko','ê³µê¸‰ ì—…ì²´ ì¡°ê±´ íŽ¸ì§‘',0),(118964,3305,'he','×¢×¨×•×š ×œ×¡×¤×§ ×ª× ××™',0),(118965,3305,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(118966,3305,'zh','ä¾›åº”å•†æ¡æ¬¾æ›´æ–°\r\n',0),(118967,3305,'sv','Redigera leverantÃ¶rens villkor',0),(118968,3305,'it','Modificare le condizioni del fornitore',0),(118969,3305,'tl','',0),(118970,3305,'th','&#3629;&#3633;&#3614;&#3648;&#3604;&#3607;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(118971,3305,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¿à¤¯à¤® à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(118972,3305,'ms','Edit penjual terma',0),(118973,3305,'ar','ØªØ­Ø¯ÙŠØ« Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(118974,3305,'fr','Modifier les conditions du vendeur',0),(118975,3305,'jp','æ¥­è€…æ?¡ä»¶æ›´æ–°',0),(118976,3305,'pt','Editar os termos do fornecedor',0),(118977,3305,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(118978,3305,'es','Proveedor TÃ©rminos Actualizar',0),(118979,3305,'de','Kreditor Begriffe bearbeiten',0),(118980,3305,'en','Edit Vendor Terms',0),(118981,3306,'is','',0),(118982,3306,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(118983,3306,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(118984,3306,'tr','SatÄ±cÄ± aÃ§Ä±sÄ±ndan baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(118985,3306,'pl','Warunki dostawcy pomyÅ›lnie zaktualizowana',0),(118986,3306,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(118987,3306,'ur','ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø· Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(118988,3306,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÑƒÑÐ»Ð¾Ð²Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(118989,3306,'vi','Cáº­p Nháº­t Äiá»u Khoáº£n NgÆ°á»i BÃ¡n thÃ nh cÃ´ng',0),(118990,3306,'af','Verskaffer Terme Suksesvol Opdateer',0),(118991,3306,'ro','Termeni de furnizor actualizat cu succes',0),(118992,3306,'et','Hankija edukalt uuendatud tingimused',0),(118993,3306,'si','Prodajalec izrazi uspeÅ¡no posodobljena',0),(118994,3306,'ba','Syarat-syarat Penjual yang berhasil',0),(118995,3306,'nl','Leverancier voorwaarden bijgewerkt',0),(118996,3306,'fi','Toimittajan ehdot pÃ¤ivitetty',0),(118997,3306,'no','LeverandÃ¸ren vilkÃ¥rene oppdatert',0),(118998,3306,'da','Kreditor vilkÃ¥r opdateret',0),(118999,3306,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ê³µê¸‰ ì—…ì²´ ì¡°ê±´',0),(119000,3306,'he','×ª× ××™ ×¡×¤×§ ×¢×•×“×›× ×• ×‘×”×¦×œ×—×”',0),(119001,3306,'el','ÎŒÏÎ¿Î¹ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®, ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(119002,3306,'zh','æˆåŠŸæ›´æ–°ä¾›åº”å•†æ¡æ¬¾\r\n',0),(119003,3306,'sv','LeverantÃ¶rens villkor uppdaterats',0),(119004,3306,'it','Termini di fornitore aggiornati con successo',0),(119005,3306,'tl','',0),(119006,3306,'th','&#3629;&#3633;&#3614;&#3648;&#3604;&#3607;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(119007,3306,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(119008,3306,'ms','Syarat-syarat penjual yang berjaya dikemas kini',0),(119009,3306,'ar','Ø­Ø¯Ù‘Ø«Øª Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(119010,3306,'fr','Conditions de paiement du fournisseur mis Ã  jour avec succÃ¨s',0),(119011,3306,'jp','æ¥­è€…å?–å¼•æ?¡ä»¶ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(119012,3306,'pt','Termos de fornecedor atualizados com sucesso',0),(119013,3306,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð², ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(119014,3306,'es','Proveedor TÃ©rminos Actualizados Exitosamente',0),(119015,3306,'de','Hersteller-Bedingungen erfolgreich aktualisiert',0),(119016,3306,'en','Vendor Terms updated successfully',0),(119017,3307,'is','',0),(119018,3307,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(119019,3307,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(119020,3307,'tr','SatÄ±cÄ± GÃ¼ncelleÅŸtirmesi',0),(119021,3307,'pl','Dostawca aktualizacji',0),(119022,3307,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(119023,3307,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(119024,3307,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(119025,3307,'vi','Cáº­p Nháº­t NgÆ°á»i BÃ¡n',0),(119026,3307,'af','Verskaffer Opdateer',0),(119027,3307,'ro','Furnizor de actualizare',0),(119028,3307,'et','Tarnija uuendamine',0),(119029,3307,'si','Prodajalec posodobitev',0),(119030,3307,'ba','Penjual Update',0),(119031,3307,'nl','Leverancier Update',0),(119032,3307,'fi','Toimittajan pÃ¤ivitys',0),(119033,3307,'no','LeverandÃ¸ren Update',0),(119034,3307,'da','Kreditor opdatering',0),(119035,3307,'ko','ê³µê¸‰ ì—…ì²´ ì—…ë°ì´íŠ¸',0),(119036,3307,'he','×¢×“×›×•×Ÿ ×”×¡×¤×§',0),(119037,3307,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(119038,3307,'zh','å–æ–¹æ›´æ–°\r\n',0),(119039,3307,'sv','LeverantÃ¶r uppdatering',0),(119040,3307,'it','Aggiornamento del fornitore',0),(119041,3307,'tl','',0),(119042,3307,'th','&#3629;&#3633;&#3614;&#3648;&#3604;&#3607;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(119043,3307,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(119044,3307,'ms','Kemaskini Penjual',0),(119045,3307,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆØ±Ø¯',0),(119046,3307,'fr','Mise Ã  jour du vendeur',0),(119047,3307,'jp','æ¥­è€…æ›´æ–°',0),(119048,3307,'pt','AtualizaÃ§Ã£o de fornecedor',0),(119049,3307,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(119050,3307,'es','Proveedor Actualizar',0),(119051,3307,'de','Kreditor Update',0),(119052,3307,'en','Vendor Update',0),(119053,3308,'is','',0),(119054,3308,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(119055,3308,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(119056,3308,'tr','SatÄ±cÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(119057,3308,'pl','Dostawcy pomyÅ›lnie zaktualizowana',0),(119058,3308,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(119059,3308,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(119060,3308,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(119061,3308,'vi','Cáº­p Nháº­t NgÆ°á»i BÃ¡n thÃ nh cÃ´ng',0),(119062,3308,'af','Verskaffer Suksesvol Opdateer',0),(119063,3308,'ro','Furnizor actualizat cu succes',0),(119064,3308,'et','Tarnija uuendamine Ãµnnestus',0),(119065,3308,'si','UspeÅ¡no posodobljen dobavitelj',0),(119066,3308,'ba','Penjual yang berhasil',0),(119067,3308,'nl','Leverancier bijgewerkt',0),(119068,3308,'fi','Toimittajan pÃ¤ivitetty',0),(119069,3308,'no','LeverandÃ¸ren oppdatert',0),(119070,3308,'da','Kreditor opdateret',0),(119071,3308,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ê³µê¸‰ ì—…ì²´',0),(119072,3308,'he','×¡×¤×§ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(119073,3308,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®, ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(119074,3308,'zh','ä¾›åº”å•†å·²æˆåŠŸæ›´æ–°\r\n',0),(119075,3308,'sv','LeverantÃ¶r som uppdaterats',0),(119076,3308,'it','Fornitore aggiornato con successo',0),(119077,3308,'tl','',0),(119078,3308,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(119079,3308,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(119080,3308,'ms','Penjual yang berjaya dikemas kini',0),(119081,3308,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(119082,3308,'fr','Fournisseur de mise Ã  jour rÃ©ussie',0),(119083,3308,'jp','æ¥­è€…ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(119084,3308,'pt','Vandedor Atualizado com Sucesso',0),(119085,3308,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(119086,3308,'es','Proveedor Actualizar Exitosamente',0),(119087,3308,'de','Anbieter wurde erfolgreich aktualisiert',0),(119088,3308,'en','Vendor Updated Successfully',0),(119089,3309,'is','',0),(119090,3309,'dr','Ø´ÙØ§Ù‡Ù‰',0),(119091,3309,'pr','Ø´ÙØ§Ù‡Ù‰',0),(119092,3309,'tr','SÃ¶zlÃ¼',0),(119093,3309,'pl','SÅ‚owne',0),(119094,3309,'bg','Ð£ÑÑ‚Ð½Ð¸',0),(119095,3309,'ur','Ø²Ø¨Ø§Ù†ÛŒ',0),(119096,3309,'sr','Ð’ÐµÑ€Ð±Ð°Ð»Ð½Ð°',0),(119097,3309,'vi','Báº±ng Miá»‡ng',0),(119098,3309,'af','Mondelings',0),(119099,3309,'ro','Verbale',0),(119100,3309,'et','Verbaalne',0),(119101,3309,'si','Verbalne',0),(119102,3309,'ba','Verbal',0),(119103,3309,'nl','Verbale',0),(119104,3309,'fi','Sanallinen',0),(119105,3309,'no','Verbale',0),(119106,3309,'da','Verbal',0),(119107,3309,'ko','êµ¬ë‘',0),(119108,3309,'he','×ž×™×œ×•×œ×™',0),(119109,3309,'el','Î›ÎµÎºÏ„Î¹ÎºÎ®',0),(119110,3309,'zh','å£å¤´\r\n',0),(119111,3309,'sv','Verbala',0),(119112,3309,'it','Verbale',0),(119113,3309,'tl','',0),(119114,3309,'th','&#3604;&#3657;&#3623;&#3618;&#3611;&#3634;&#3585;&#3648;&#3611;&#3621;&#3656;&#3634;',0),(119115,3309,'hi','à¤®à¥Œà¤–à¤¿à¤•',0),(119116,3309,'ms','Lisan',0),(119117,3309,'ar','Ø§Ù„Ù„ÙØ¸ÙŠ',0),(119118,3309,'fr','Verbal',0),(119119,3309,'jp','å?£é ­',0),(119120,3309,'pt','Verbal',0),(119121,3309,'ru','Ð¡Ð»Ð¾Ð²ÐµÑÐ½Ñ‹Ðµ',0),(119122,3309,'es','Verbal',0),(119123,3309,'de','Verbale',0),(119124,3309,'en','Verbal',0),(119125,3310,'is','',0),(119126,3310,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ø§Ø«Ø¨Ø§Øª â€Œ ÙƒØ±Ø¯Ù†â€Œ',0),(119127,3310,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ø§Ø«Ø¨Ø§Øª â€Œ ÙƒØ±Ø¯Ù†â€Œ',0),(119128,3310,'tr','DoÄŸrulayÄ±n',0),(119129,3310,'pl','SprawdÅº, czy',0),(119130,3310,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ',0),(119131,3310,'ur','Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚',0),(119132,3310,'sr','ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ',0),(119133,3310,'vi','XÃ¡c nháº­n',0),(119134,3310,'af','Verifeer',0),(119135,3310,'ro','VerificaÅ£i dacÄƒ',0),(119136,3310,'et','Kinnita',0),(119137,3310,'si','Preverite, ali',0),(119138,3310,'ba','Memverifikasi',0),(119139,3310,'nl','Controleer of',0),(119140,3310,'fi','Tarkista',0),(119141,3310,'no','Kontroller',0),(119142,3310,'da','Kontroller',0),(119143,3310,'ko','í™•ì¸',0),(119144,3310,'he','×•×“×',0),(119145,3310,'el','Î•Ï€Î±Î»Î®Î¸ÎµÏ…ÏƒÎ·',0),(119146,3310,'zh','éªŒè¯\r\n',0),(119147,3310,'sv','Kontrollera',0),(119148,3310,'it','Verificare',0),(119149,3310,'tl','',0),(119150,3310,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;',0),(119151,3310,'hi','à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(119152,3310,'ms','Mengesahkan',0),(119153,3310,'ar','Ø§Ù„ØªØ£ÙƒÙŠØ¯',0),(119154,3310,'fr','VÃ©rifier',0),(119155,3310,'jp','ç¢ºèª?',0),(119156,3310,'pt','Verifique se',0),(119157,3310,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ',0),(119158,3310,'es','Verificar',0),(119159,3310,'de','ÃœberprÃ¼fen Sie',0),(119160,3310,'en','Verify',0),(119161,3311,'is','',0),(119162,3311,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ø§Ø«Ø¨Ø§Øª â€Œ ÙƒØ±Ø¯Ù†',0),(119163,3311,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ø§Ø«Ø¨Ø§Øª â€Œ ÙƒØ±Ø¯Ù†',0),(119164,3311,'tr','(DoÄŸrulama)',0),(119165,3311,'pl','(SprawdÅº)',0),(119166,3311,'bg','(ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸)',0),(119167,3311,'ur','(ØªØµØ¯ÛŒÙ‚)',0),(119168,3311,'sr','(ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ)',0),(119169,3311,'vi','(XÃ¡c nháº­n)',0),(119170,3311,'af','(Verifeer)',0),(119171,3311,'ro','(Verifica)',0),(119172,3311,'et','(Kinnita)',0),(119173,3311,'si','(Preveri)',0),(119174,3311,'ba','(Verifikasi)',0),(119175,3311,'nl','(Controleren)',0),(119176,3311,'fi','(Tarkista)',0),(119177,3311,'no','(Bekrefte)',0),(119178,3311,'da','(Kontroller)',0),(119179,3311,'ko','(í™•ì¸)',0),(119180,3311,'he','(×‘×“×•×§)',0),(119181,3311,'el','(Î•Ï€Î±Î»Î®Î¸ÎµÏ…ÏƒÎ·)',0),(119182,3311,'zh','ï¼ˆéªŒè¯ï¼‰\r\n',0),(119183,3311,'sv','(Verifiera)',0),(119184,3311,'it','(Verificare)',0),(119185,3311,'tl','',0),(119186,3311,'th','(&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;)',0),(119187,3311,'hi','(à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¿à¤¤)',0),(119188,3311,'ms','(Sahkan)',0),(119189,3311,'ar','(Ø§Ù„ØªØ£ÙƒÙŠØ¯)',0),(119190,3311,'fr','(VÃ©rifier)',0),(119191,3311,'jp','ï¼ˆç¢ºèª?ã?™ã‚‹ï¼‰',0),(119192,3311,'pt','(Verificar)',0),(119193,3311,'ru','(ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ)',0),(119194,3311,'es','(Verificar)',0),(119195,3311,'de','(ÃœberprÃ¼fen)',0),(119196,3311,'en','(Verify)',0),(119197,3312,'is','',0),(119198,3312,'dr','Ù†Ø³Ø®Ù‡ ',0),(119199,3312,'pr','Ù†Ø³Ø®Ù‡ ',0),(119200,3312,'tr','SÃ¼rÃ¼m',0),(119201,3312,'pl','Wersja',0),(119202,3312,'bg','Ð’ÐµÑ€ÑÐ¸Ñ',0),(119203,3312,'ur','ÙˆØ±Ú˜Ù†',0),(119204,3312,'sr','Ð’ÐµÑ€Ð·Ð¸Ñ˜Ð°',0),(119205,3312,'vi','PhiÃªn báº£n',0),(119206,3312,'af','Weergawe',0),(119207,3312,'ro','Versiunea',0),(119208,3312,'et','Versioon',0),(119209,3312,'si','RazliÄica',0),(119210,3312,'ba','Versi',0),(119211,3312,'nl','Versie',0),(119212,3312,'fi','Versio',0),(119213,3312,'no','Versjon',0),(119214,3312,'da','Version',0),(119215,3312,'ko','ë²„ì „',0),(119216,3312,'he','×’×¨×¡×”',0),(119217,3312,'el','ÎˆÎºÎ´Î¿ÏƒÎ·',0),(119218,3312,'zh','ç‰ˆæœ¬\r\n',0),(119219,3312,'sv','Version',0),(119220,3312,'it','Versione',0),(119221,3312,'tl','',0),(119222,3312,'th','Version',0),(119223,3312,'hi','à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(119224,3312,'ms','Versi',0),(119225,3312,'ar','Ø§Ù„Ø¥ØµØ¯Ø§Ø±',0),(119226,3312,'fr','Version',0),(119227,3312,'jp','ãƒ?ãƒ¼ã‚¸ãƒ§ãƒ³',0),(119228,3312,'pt','VersÃ£o',0),(119229,3312,'ru','Ð’ÐµÑ€ÑÐ¸Ñ',0),(119230,3312,'es','VersiÃ³n',0),(119231,3312,'de','Version',0),(119232,3312,'en','Version',0),(119233,3313,'is','',0),(119234,3313,'dr','Ù†Ø³Ø®Ù‡ ÙƒØ§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ ',0),(119235,3313,'pr','Ù†Ø³Ø®Ù‡ ÙƒØ§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ ',0),(119236,3313,'tr','Ä°ÅŸ tam sÃ¼rÃ¼m',0),(119237,3313,'pl','PeÅ‚na wersja dla firm',0),(119238,3313,'bg','Ð‘Ð¸Ð·Ð½ÐµÑ Ð¿ÑŠÐ»Ð½Ð° Ð²ÐµÑ€ÑÐ¸Ñ',0),(119239,3313,'ur','Ú©Ø§Ø±ÙˆØ¨Ø§Ø± Ù…Ú©Ù…Ù„ ÙˆØ±Ú˜Ù†',0),(119240,3313,'sr','ÐŸÑƒÐ½Ð° Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð° Ð¿Ð¾ÑÐ»Ð¾Ð²Ð½Ðµ',0),(119241,3313,'vi','PhiÃªn báº£n kinh doanh Ä‘áº§y Ä‘á»§',0),(119242,3313,'af','Volledige Besigheid Demo',0),(119243,3313,'ro','Afaceri plin traducere',0),(119244,3313,'et','Ã„ri tÃ¤isversioon',0),(119245,3313,'si','Poln prevod poslovnih',0),(119246,3313,'ba','Versi penuh bisnis',0),(119247,3313,'nl','Business Full Version',0),(119248,3313,'fi','Business tÃ¤ysversio',0),(119249,3313,'no','Business fullversjonen',0),(119250,3313,'da','Business fulde Version',0),(119251,3313,'ko','ë¹„ì¦ˆë‹ˆìŠ¤ í’€ ë²„ì „',0),(119252,3313,'he','×”×’×™×¨×¡×” ×”×ž×œ××” ×©×œ ×¢×¡×§×™×',0),(119253,3313,'el','Î•Ï€Î¹Ï‡ÎµÎ¹ÏÎ®ÏƒÎµÏ‰Î½ ÏƒÏ„Î¿ Forum',0),(119254,3313,'zh','å•†ä¸šå®Œæ•´ç‰ˆ\r\n',0),(119255,3313,'sv','Business Full Version',0),(119256,3313,'it','Versione completa di affari',0),(119257,3313,'tl','',0),(119258,3313,'th','&#3648;&#3623;&#3629;&#3619;&#3660;&#3594;&#3633;&#3656;&#3609;&#3648;&#3605;&#3655;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3608;&#3640;&#3619;&#3585;&#3636;&#3592;',0),(119259,3313,'hi','à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤° à¤ªà¥‚à¤°à¥à¤£ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(119260,3313,'ms','Versi penuh perniagaan',0),(119261,3313,'ar','Ø¥ØµØ¯Ø§Ø± Ø§Ù„Ø£Ø¹Ù…Ø§Ù„ Ø§Ù„ÙƒØ§Ù…Ù„Ø©',0),(119262,3313,'fr','Entreprise Version complÃ¨te',0),(119263,3313,'jp','ãƒ“ã‚¸ãƒ?ã‚¹å®Œå…¨ç‰ˆ',0),(119264,3313,'pt','VersÃ£o completa do negÃ³cio',0),(119265,3313,'ru','Ð‘Ð¸Ð·Ð½ÐµÑ-Ð¿Ð¾Ð»Ð½Ð°Ñ Ð²ÐµÑ€ÑÐ¸Ñ',0),(119266,3313,'es','Negocio VersiÃ³n Completa',0),(119267,3313,'de','Business Vollversion',0),(119268,3313,'en','Business Full Version',0),(119269,3314,'is','',0),(119270,3314,'dr','Ù†Ù…ÙˆÙ†Ù‡ Ù†Ù…Ø§ÙŠØ´Ù‰ ØªØ¬Ø§Ø±ÙŠ ',0),(119271,3314,'pr','Ù†Ù…ÙˆÙ†Ù‡ Ù†Ù…Ø§ÙŠØ´Ù‰ ØªØ¬Ø§Ø±ÙŠ ',0),(119272,3314,'tr','Ä°ÅŸ Demo',0),(119273,3314,'pl','Biznes Demo',0),(119274,3314,'bg','Ð‘Ð¸Ð·Ð½ÐµÑ Ð´ÐµÐ¼Ð¾',0),(119275,3314,'ur','Ú©Ø§Ø±ÙˆØ¨Ø§Ø±ÛŒ ÚˆÛŒÙ…Ùˆ',0),(119276,3314,'sr','ÐŸÐ¾ÑÐ»Ð¾Ð²Ð½Ð¸ Ð”ÐµÐ¼Ð¾',0),(119277,3314,'vi','Demo kinh doanh',0),(119278,3314,'af','Besigheid Demo',0),(119279,3314,'ro','Business Demo',0),(119280,3314,'et','Ã„ri Demo',0),(119281,3314,'si','Poslovni Demo',0),(119282,3314,'ba','Bisnis Demo',0),(119283,3314,'nl','Zakelijke Demo',0),(119284,3314,'fi','Funny Videos',0),(119285,3314,'no','Business Demo',0),(119286,3314,'da','Business Demo',0),(119287,3314,'ko','ë¹„ì¦ˆë‹ˆìŠ¤ ë°ëª¨',0),(119288,3314,'he','×¢×¡×§×™× ×”×“×’×ž×”',0),(119289,3314,'el','Demo ÎµÏ€Î¹Ï‡ÎµÎ¹ÏÎ®ÏƒÎµÏ‰Î½',0),(119290,3314,'zh','ä¸šåŠ¡æ¼”ç¤º\r\n',0),(119291,3314,'sv','Business Demo',0),(119292,3314,'it','Demo di affari',0),(119293,3314,'tl','',0),(119294,3314,'th','&#3607;&#3604;&#3621;&#3629;&#3591;&#3651;&#3594;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3608;&#3640;&#3619;&#3585;&#3636;&#3592;',0),(119295,3314,'hi','à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤° à¤¡à¥‡à¤®à¥‹',0),(119296,3314,'ms','Demo perniagaan',0),(119297,3314,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø¹Ù…Ø§Ù„',0),(119298,3314,'fr','DÃ©mo de l\'entreprise',0),(119299,3314,'jp','ãƒ“ã‚¸ãƒ?ã‚¹ãƒ‡ãƒ¢ç‰ˆ',0),(119300,3314,'pt','Demo de negÃ³cios',0),(119301,3314,'ru','Ð‘Ð¸Ð·Ð½ÐµÑ-Ð´ÐµÐ¼Ð¾',0),(119302,3314,'es','Demo de Negocio',0),(119303,3314,'de','Business-Demo',0),(119304,3314,'en','Business Demo',0),(119305,3315,'is','',0),(119306,3315,'dr','Ù†Ù…ÙˆÙ†Ù‡ Ù†Ù…Ø§ÙŠØ´Ù‰ Ù…ÙˆØ³Ø³Ù‡ Ø§Ù‚ØªØµØ§Ø¯Ù‰',0),(119307,3315,'pr','Ù†Ù…ÙˆÙ†Ù‡ Ù†Ù…Ø§ÙŠØ´Ù‰ Ù…ÙˆØ³Ø³Ù‡ Ø§Ù‚ØªØµØ§Ø¯Ù‰',0),(119308,3315,'tr','Kurumsal Demo',0),(119309,3315,'pl','PrzedsiÄ™biorstwo Demo',0),(119310,3315,'bg','ÐŸÑ€ÐµÐ´Ð¿Ñ€Ð¸ÑÑ‚Ð¸ÐµÑ‚Ð¾ Ð´ÐµÐ¼Ð¾Ð½ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(119311,3315,'ur','Ø§Ù†Ù¹Ø±Ù¾Ø±Ø§Ø¦Ø² ÚˆÛŒÙ…Ùˆ',0),(119312,3315,'sr','Ð•Ð½Ñ‚ÐµÑ€Ð¿Ñ€Ð¸ÑÐµ Ð”ÐµÐ¼Ð¾',0),(119313,3315,'vi','Demo doanh nghiá»‡p',0),(119314,3315,'af','Onderneming Demo',0),(119315,3315,'ro','Intreprindere Demo',0),(119316,3315,'et','EttevÃµtte Demo',0),(119317,3315,'si','Demo podjetju',0),(119318,3315,'ba','Enterprise Demo',0),(119319,3315,'nl','Enterprise Demo',0),(119320,3315,'fi','Yrityksen esittely',0),(119321,3315,'no','Enterprise Demo',0),(119322,3315,'da','Enterprise Demo',0),(119323,3315,'ko','ê¸°ì—… ë°ëª¨',0),(119324,3315,'he','×”×“×’×ž×” ×©×œ ×”××¨×’×•×Ÿ',0),(119325,3315,'el','Î•Ï€Î¹Ï‡ÎµÎ¯ÏÎ·ÏƒÎ· Demo',0),(119326,3315,'zh','ä¼ä¸šæ¼”ç¤º\r\n',0),(119327,3315,'sv','Enterprise Demo',0),(119328,3315,'it','Demo impresa',0),(119329,3315,'tl','',0),(119330,3315,'th','&#3607;&#3604;&#3621;&#3629;&#3591;&#3651;&#3594;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(119331,3315,'hi','à¤à¤‚à¤Ÿà¤°à¤ªà¥à¤°à¤¾à¤‡à¤œà¤¼ à¤¡à¥‡à¤®à¥‹',0),(119332,3315,'ms','Enterprise Demo',0),(119333,3315,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø´Ø§Ø±ÙŠØ¹',0),(119334,3315,'fr','DÃ©mo de l\'entreprise',0),(119335,3315,'jp','ã‚¨ãƒ³ã‚¿ãƒ¼ãƒ—ãƒ©ã‚¤ã‚ºå®Œå…¨ç‰ˆ',0),(119336,3315,'pt','Empresa Demo',0),(119337,3315,'ru','Enterprise Ð´ÐµÐ¼Ð¾Ð½ÑÑ‚Ñ€Ð°Ñ†Ð¸ÑŽ',0),(119338,3315,'es','Demo de Impresa',0),(119339,3315,'de','Enterprise Demo',0),(119340,3315,'en','Enterprise Demo',0),(119341,3316,'is','',0),(119342,3316,'dr','(Ù…ÙˆØ³Ø³Ù‡ Ø§Ù‚ØªØµØ§Ø¯Ù‰',0),(119343,3316,'pr','Ù†Ø³Ø®Ù‡ ÙƒØ§Ù…Ù„ Ø³Ø±Ù…Ø§ÙŠÙ‡ Ú¯Ø°Ø§Ø±ÙŠ(Ù…ÙˆØ³Ø³Ù‡ Ø§Ù‚ØªØµØ§Ø¯Ù‰',0),(119344,3316,'tr','Kurumsal tam sÃ¼rÃ¼m',0),(119345,3316,'pl','PeÅ‚na wersja Enterprise',0),(119346,3316,'bg','ÐŸÑ€ÐµÐ´Ð¿Ñ€Ð¸ÑÑ‚Ð¸ÐµÑ‚Ð¾ Ð¿ÑŠÐ»Ð½Ð°Ñ‚Ð° Ð²ÐµÑ€ÑÐ¸Ñ',0),(119347,3316,'ur','Ø§Ù†Ù¹Ø±Ù¾Ø±Ø§Ø¦Ø² Ù…Ú©Ù…Ù„ ÙˆØ±Ú˜Ù†',0),(119348,3316,'sr','ÐšÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ðµ Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ Ð•Ð½Ñ‚ÐµÑ€Ð¿Ñ€Ð¸ÑÐµ',0),(119349,3316,'vi','PhiÃªn báº£n doanh nghiá»‡p Ä‘áº§y Ä‘á»§',0),(119350,3316,'af','Volledige Onderneming Demo',0),(119351,3316,'ro','ÃŽntreprinderi versiunea completÄƒ',0),(119352,3316,'et','EttevÃµtte tÃ¤isversioon',0),(119353,3316,'si','Podjetje polno razliÄico',0),(119354,3316,'ba','Versi penuh Enterprise',0),(119355,3316,'nl','Volledige versie van de Enterprise',0),(119356,3316,'fi','Yrityksen tÃ¤ysversio',0),(119357,3316,'no','Enterprise fullversjonen',0),(119358,3316,'da','Enterprise fulde Version',0),(119359,3316,'ko','ì—”í„°í”„ë¼ì´ì¦ˆ í’€ ë²„ì „',0),(119360,3316,'he','×”×’×™×¨×¡×” ×”×ž×œ××” ×©×œ ×”××¨×’×•×Ÿ',0),(119361,3316,'el','Î Î»Î®ÏÎ· Î­ÎºÎ´Î¿ÏƒÎ· Enterprise',0),(119362,3316,'zh','ä¼ä¸šå®Œå…¨ç‰ˆ\r\n',0),(119363,3316,'sv','FÃ¶retagets fullstÃ¤ndiga versionen',0),(119364,3316,'it','Enterprise versione completa',0),(119365,3316,'tl','',0),(119366,3316,'th','&#3648;&#3623;&#3629;&#3619;&#3660;&#3594;&#3633;&#3656;&#3609;&#3648;&#3605;&#3655;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(119367,3316,'hi','à¤à¤‚à¤Ÿà¤°à¤ªà¥à¤°à¤¾à¤‡à¤œà¤¼ à¤ªà¥‚à¤°à¥à¤£ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(119368,3316,'ms','Versi penuh Enterprise',0),(119369,3316,'ar','Ø§Ù„Ù†Ø³Ø®Ø© Ø§Ù„ÙƒØ§Ù…Ù„Ø© Ù…Ù† Ø§Ù„Ù…Ø¤Ø³Ø³Ø©',0),(119370,3316,'fr','Enterprise Version complÃ¨te',0),(119371,3316,'jp','ã‚¨ãƒ³ã‚¿ãƒ¼ãƒ—ãƒ©ã‚¤ã‚ºãƒ‡ãƒ¢ç‰ˆ',0),(119372,3316,'pt','Enterprise versÃ£o completa',0),(119373,3316,'ru','ÐŸÐ¾Ð»Ð½Ð°Ñ Ð²ÐµÑ€ÑÐ¸Ñ Enterprise',0),(119374,3316,'es','Empresa VersiÃ³n Completa',0),(119375,3316,'de','Enterprise Vollversion',0),(119376,3316,'en','Enterprise Full Version',0),(119377,3317,'is','',0),(119378,3317,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ø³Ø®Ù‡',0),(119379,3317,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ø³Ø®Ù‡',0),(119380,3317,'tr','SÃ¼rÃ¼m bilgisi',0),(119381,3317,'pl','Informacje o wersji',0),(119382,3317,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð²ÐµÑ€ÑÐ¸ÑÑ‚Ð°',0),(119383,3317,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ÙˆØ±Ú˜Ù† Ù†ÛÛŒÚº',0),(119384,3317,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð¸',0),(119385,3317,'vi','ThÃ´ng Tin Vá» PhiÃªn Báº£n',0),(119386,3317,'af','Weergawe Inligting',0),(119387,3317,'ro','Informatii despre versiune',0),(119388,3317,'et','Versiooni info',0),(119389,3317,'si','Informacije o razliÄici',0),(119390,3317,'ba','Informasi versi',0),(119391,3317,'nl','Versie-informatie',0),(119392,3317,'fi','Versiotiedot',0),(119393,3317,'no','Versjonsinformasjon',0),(119394,3317,'da','Versionsoplysninger',0),(119395,3317,'ko','ë²„ì „ ì •ë³´',0),(119396,3317,'he','×ž×™×“×¢ ×’×¨×¡×”',0),(119397,3317,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î­ÎºÎ´Î¿ÏƒÎ·Ï‚',0),(119398,3317,'zh','ç‰ˆæœ¬ä¿¡æ¯\r\n',0),(119399,3317,'sv','Versionsinformation',0),(119400,3317,'it','Informazioni sulla versione',0),(119401,3317,'tl','',0),(119402,3317,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3623;&#3629;&#3619;&#3660;&#3594;&#3633;&#3656;&#3609;',0),(119403,3317,'hi','à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(119404,3317,'ms','Maklumat versi',0),(119405,3317,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¥ØµØ¯Ø§Ø±',0),(119406,3317,'fr','Informations de version',0),(119407,3317,'jp','ãƒ?ãƒ¼ã‚¸ãƒ§ãƒ³æƒ…å ±',0),(119408,3317,'pt','InformaÃ§Ãµes de versÃ£o',0),(119409,3317,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð²ÐµÑ€ÑÐ¸Ð¸',0),(119410,3317,'es','InformaciÃ³n de VersiÃ³n ',0),(119411,3317,'de','Versionsinformationen',0),(119412,3317,'en','Version Information',0),(119413,3318,'is','',0),(119414,3318,'dr','- Ù†Ù…Ø§ÙŠØ´ Ø³Ø·Ø­ Ùˆ Ø§Ø­ØµØ§Ø¦ÛŒÙ‡  Ù†Ø³Ø®Ù‡ Ø§Ø®ÙŠØ± Ø®ÙˆØ¯ ',0),(119415,3318,'pr','Ù…ØªÙ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ø³Ø®Ù‡- Ù†Ù…Ø§ÙŠØ´ Ø³Ø·Ø­ Ùˆ Ø¢Ù…Ø§Ø± Ù†Ø³Ø®Ù‡ Ø§Ø®ÙŠØ± Ø®ÙˆØ¯ ',0),(119416,3318,'tr','DÃ¼zeyi ve geÃ§erli sÃ¼rÃ¼mÃ¼nÃ¼z istatistikleri gÃ¶sterir',0),(119417,3318,'pl','Pokazuje poziom i statystyk bieÅ¼Ä…cej wersji',0),(119418,3318,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð° Ð½Ð¸Ð²Ð¾Ñ‚Ð¾ Ð¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°Ñ‚Ð° Ð¾Ñ‚ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð²Ð¸ Ð²ÐµÑ€ÑÐ¸Ñ',0),(119419,3318,'ur','Ø³Ø·Ø­ Ø§ÙˆØ± Ø¢Ù¾ Ú©Û’ Ø­Ø§Ù„ÛŒÛ ÙˆØ±Ú˜Ù† Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± Ø¸Ø§ÛØ± Ú©Ø±ØªØ§ ÛÛ’',0),(119420,3318,'sr','ÐŸÐ¾ÐºÐ°Ð·ÑƒÑ˜Ðµ Ð½Ð¸Ð²Ð¾ Ð¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐµ Ð·Ð° Ñ‚ÐµÐºÑƒÑ›Ñƒ Ð²ÐµÑ€Ð·Ð¸Ñ˜Ñƒ',0),(119421,3318,'vi','Hiá»ƒn thá»‹ cáº­p Ä‘á»™ & thá»‘ng kÃª phiÃªn báº£n hiá»‡n thá»i cá»§a báº¡n',0),(119422,3318,'af','Wys Vlakke en Statistieke van U Huidige Weergawe',0),(119423,3318,'ro','Nivel de spectacole ÅŸi statistici de versiunea curentÄƒ',0),(119424,3318,'et','NÃ¤itab taset ja praegune versioon statistika',0),(119425,3318,'si','KaÅ¾e raven in statistika trenutno razliÄico',0),(119426,3318,'ba','Menunjukkan tingkat dan statistik dari versi Anda saat ini',0),(119427,3318,'nl','Toont niveau en statistieken van uw huidige versie',0),(119428,3318,'fi','NÃ¤yttÃ¤Ã¤ tason ja tilastot nykyinen versio',0),(119429,3318,'no','Viser nivÃ¥et og statistikken for gjeldende versjon',0),(119430,3318,'da','Viser niveau og statistikker for din aktuelle Version',0),(119431,3318,'ko','ìˆ˜ì¤€ ë° í˜„ìž¬ ë²„ì „ì˜ í†µê³„ë¥¼ ë³´ì—¬ì¤ë‹ˆë‹¤.',0),(119432,3318,'he','×ž×¨××” ×•×‘×¨×ž×ª ×”×¡×˜×˜×™×¡×˜×™×§×” ×©×œ ×”×’×™×¨×¡×” ×”× ×•×›×—×™×ª ×©×œ×š',0),(119433,3318,'el','Î”ÎµÎ¯Ï‡Î½ÎµÎ¹ Ï„Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ ÎºÎ±Î¹ ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Ï€ÏŒ Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î­ÎºÎ´Î¿ÏƒÎ·',0),(119434,3318,'zh','æ˜¾ç¤ºæ°´å¹³ä¸Žç›®å‰çš„ç‰ˆæœ¬ç»Ÿè®¡\r\n',0),(119435,3318,'sv','Visar statistik Ã¶ver din nuvarande Version och nivÃ¥',0),(119436,3318,'it','Mostra livello e statistiche della versione corrente',0),(119437,3318,'tl','',0),(119438,3318,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3632;&#3604;&#3633;&#3610;&#3649;&#3621;&#3632;&#3626;&#3606;&#3636;&#3605;&#3636;&#3648;&#3623;&#3629;&#3619;&#3660;&#3594;&#3633;&#3656;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(119439,3318,'hi','à¤¸à¥à¤¤à¤° à¤”à¤° à¤…à¤ªà¤¨à¥‡ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥‡ à¤†à¤à¤•à¤¡à¤¼à¥‡ à¤¦à¤¿à¤–à¤¾à¤¤à¤¾ à¤¹à¥ˆ',0),(119440,3318,'ms','Menunjukkan tahap dan statistik versi semasa',0),(119441,3318,'ar','ÙˆÙŠØ¨ÙŠÙ† Ù…Ø³ØªÙˆÙ‰ ÙˆØ§Ù„Ø¥Ø­ØµØ§Ø¡Ø§Øª Ù„Ù„Ø¥ØµØ¯Ø§Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(119442,3318,'fr','Affiche les statistiques de votre Version actuelle et le niveau',0),(119443,3318,'jp','ç?¾åœ¨ã?®ãƒ?ãƒ¼ã‚¸ãƒ§ãƒ³ã?®ãƒ¬ãƒ™ãƒ«ã?¨çŠ¶æ³?ã‚’è¡¨ç¤ºã?™ã‚‹',0),(119444,3318,'pt','Mostra o nÃ­vel e as estatÃ­sticas de sua versÃ£o atual',0),(119445,3318,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°ÐµÑ‚ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð¾ Ñ‚ÐµÐºÑƒÑ‰ÐµÐ¹ Ð²ÐµÑ€ÑÐ¸Ð¸',0),(119446,3318,'es','Muestra Nivel y EstadÃ­sticas de Su VersiÃ³n Actual',0),(119447,3318,'de','Ebene und Statistiken Ihrer aktuellen Version zeigt',0),(119448,3318,'en','Shows Level and Statistics of Your Current Version',0),(119449,3319,'is','',0),(119450,3319,'dr','Ù†Ù…Ø§ÙŠØ´ ',0),(119451,3319,'pr','Ù†Ù…Ø§ÙŠØ´ ',0),(119452,3319,'tr','GÃ¶rÃ¼nÃ¼m',0),(119453,3319,'pl','Widok',0),(119454,3319,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´',0),(119455,3319,'ur','Ù…Ù†Ø¸Ø±',0),(119456,3319,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·',0),(119457,3319,'vi','Xem',0),(119458,3319,'af','Besigtig',0),(119459,3319,'ro','Vezi',0),(119460,3319,'et','Vaade',0),(119461,3319,'si','Pogled',0),(119462,3319,'ba','Pemandangan',0),(119463,3319,'nl','Weergave',0),(119464,3319,'fi','NÃ¤kymÃ¤',0),(119465,3319,'no','Vis',0),(119466,3319,'da','Se',0),(119467,3319,'ko','ë³´ê¸°',0),(119468,3319,'he','×”×¦×’',0),(119469,3319,'el','Î˜Î­Î±',0),(119470,3319,'zh','æŸ¥çœ‹\r\n',0),(119471,3319,'sv','Visa',0),(119472,3319,'it','Vista',0),(119473,3319,'tl','',0),(119474,3319,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(119475,3319,'hi','à¤¦à¥ƒà¤¶à¥à¤¯',0),(119476,3319,'ms','Pandangan',0),(119477,3319,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¹Ø±Ø¶',0),(119478,3319,'fr','Vue',0),(119479,3319,'jp','ä¸€è¦§',0),(119480,3319,'pt','Vista',0),(119481,3319,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€',0),(119482,3319,'es','Visionar',0),(119483,3319,'de','Ansicht',0),(119484,3319,'en','View',0),(119485,3320,'is','',0),(119486,3320,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³Ù†Ø¯ ',0),(119487,3320,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³Ù†Ø¯ ',0),(119488,3320,'tr','Belgeyi GÃ¶rÃ¼ntÃ¼le',0),(119489,3320,'pl','Zobacz dokument',0),(119490,3320,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(119491,3320,'ur','Ù…Ù†Ø¸Ø± Ø¯Ø³ØªØ§ÙˆÛŒØ²',0),(119492,3320,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(119493,3320,'vi','Xem tÃ i liá»‡u ',0),(119494,3320,'af','Besigtig Dokument',0),(119495,3320,'ro','Vezi Document',0),(119496,3320,'et','Vaata dokumenti',0),(119497,3320,'si','Pogled dokumenta',0),(119498,3320,'ba','Lihat dokumen',0),(119499,3320,'nl','Document weergeven',0),(119500,3320,'fi','NÃ¤ytÃ¤ asiakirja',0),(119501,3320,'no','Vis dokument',0),(119502,3320,'da','Se dokument',0),(119503,3320,'ko','ë¬¸ì„œ ë³´ê¸°',0),(119504,3320,'he','×”×¦×’×ª ×”×ž×¡×ž×š',0),(119505,3320,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(119506,3320,'zh','æŸ¥çœ‹æ–‡æ¡£\r\n',0),(119507,3320,'sv','Visa dokument',0),(119508,3320,'it','Visualizza documento',0),(119509,3320,'tl','',0),(119510,3320,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(119511,3320,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¦à¥‡à¤–à¥‡à¤‚',0),(119512,3320,'ms','Lihat dokumen',0),(119513,3320,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(119514,3320,'fr','Affichage du Document',0),(119515,3320,'jp','æ–‡æ›¸ä¸€è¦§',0),(119516,3320,'pt','Documento de exibiÃ§Ã£o',0),(119517,3320,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(119518,3320,'es','Visionar Documento',0),(119519,3320,'de','Dokument anzeigen',0),(119520,3320,'en','View Document',0),(119521,3321,'is','',0),(119522,3321,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª Ù†Ù‡Ø§ÙŠÙŠ Ø´Ø¯Ù‡ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø¨ÙŠÙ† ',0),(119523,3321,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª Ù†Ù‡Ø§ÙŠÙŠ Ø´Ø¯Ù‡ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø¨ÙŠÙ† ',0),(119524,3321,'tr','ArasÄ±nda oluÅŸturulan kesinleÅŸmiÅŸ inÅŸa sipariÅŸlerini gÃ¶rÃ¼ntÃ¼leyin',0),(119525,3321,'pl','Zobacz zakoÅ„czone budowy zamÃ³wienia utworzone miÄ™dzy',0),(119526,3321,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½ Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð¸ Ð¼ÐµÐ¶Ð´Ñƒ',0),(119527,3321,'ur','Ù†Ù‚Ø·Û Ù†Ø¸Ø± Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† Ù¾ÛŒØ¯Ø§ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…Ù†Ù¹Ø³',0),(119528,3321,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ˜Ðµ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½ Ð‘ÑƒÐ¸Ð»Ð´ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ðµ Ð¸Ð·Ð¼ÐµÑ’Ñƒ',0),(119529,3321,'vi','Xem Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng táº¡o ra giá»¯a',0),(119530,3321,'af','Besigtig Klant/KliÃ«nt Rekening',0),(119531,3321,'ro','Vezi comenzi finalizate construi creat Ã®ntre',0),(119532,3321,'et','Vaade valmis ehitada tellimuste vahel',0),(119533,3321,'si','Pogled dokonÄno izoblikovati graditi nalogov je ustvarjenih med',0),(119534,3321,'ba','Lihat selesai membangun pesanan dibuat antara',0),(119535,3321,'nl','Bekijk gefinaliseerde Build bestellingen gemaakt tussen',0),(119536,3321,'fi','Katso valmiiksi rakentaa tilauksiin vÃ¤lillÃ¤',0),(119537,3321,'no','Se endelige bygge bestillinger opprettes mellom',0),(119538,3321,'da','Se fÃ¦rdiggjort bygge ordrer lavet mellem',0),(119539,3321,'ko','ìµœì¢…ëœ ë¹Œë“œ ìˆœì„œ ì‚¬ì´ ë³´ê¸°',0),(119540,3321,'he','×”×¦×’ ×”×–×ž× ×•×ª ×œ×‘× ×•×ª ×’×™×‘×•×© ×©× ×•×¦×¨×• ×‘×™×Ÿ',0),(119541,3321,'el','Î ÏÎ¿Î²Î¿Î»Î® Î¿ÏÎ¹ÏƒÏ„Î¹ÎºÎ¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ Ï‡Ï„Î¯Î¶ÎµÎ¹ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎ±Î½ Î¼ÎµÏ„Î±Î¾Ï',0),(119542,3321,'zh','æŸ¥çœ‹è®¢å•ä¹‹é—´å»ºç«‹å®šç¨¿å»ºè®¾\r\n',0),(119543,3321,'sv','Visa slutbehandlad bygga order skapas mellan',0),(119544,3321,'it','Gli ordini di costruire finalizzato creati tra',0),(119545,3321,'tl','',0),(119546,3321,'th','&#3604;&#3641;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3635;&#3651;&#3627;&#3657;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3636;&#3657;&#3609;',0),(119547,3321,'hi','à¤¬à¤¿à¤²à¥à¤¡ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤¬à¥€à¤š à¤¬à¤¨à¤¾à¤ à¤—à¤ à¤¦à¥ƒà¤¶à¥à¤¯ à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤¦à¤¿à¤¯à¤¾',0),(119548,3321,'ms','Lihat pesanan dimuktamadkan membina yang wujud antara',0),(119549,3321,'ar','Ø¹Ø±Ø¶ Ø£ÙˆØ§Ù…Ø± Ø¨Ù†Ø§Ø¡ Ø§Ù„ØµÙŠØºØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨ÙŠÙ†',0),(119550,3321,'fr','Vue finalisÃ© Build Orders crÃ©Ã©s entre',0),(119551,3321,'jp','ï½žã?®é–“ã?«ä½œæˆ?ã?•ã‚Œã?Ÿå®Œäº†æ¸ˆçµ„ç«‹æ³¨æ–‡ã?®ä¸€è¦§',0),(119552,3321,'pt','Vista finalizado ordens de construÃ§Ã£o criadas entre',0),(119553,3321,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ð¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ, ÑÐ¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð¼ÐµÐ¶Ð´Ñƒ',0),(119554,3321,'es','Visionar Ordenes de ConstrucciÃ³n Finalizados Creados Entre',0),(119555,3321,'de','Ansicht finalisiert Build Bestellungen, die zwischen',0),(119556,3321,'en','View Finalized Build Orders Created Between',0),(119557,3322,'is','',0),(119558,3322,'dr','Ù†Ù…Ø§ÙŠØ´ ØªØ§Ø±ÙŠØ®Ú†Ù‡',0),(119559,3322,'pr','Ù†Ù…Ø§ÙŠØ´ ØªØ§Ø±ÙŠØ®Ú†Ù‡',0),(119560,3322,'tr','GeÃ§miÅŸi gÃ¶rÃ¼ntÃ¼le',0),(119561,3322,'pl','WyÅ›wietl historiÄ™',0),(119562,3322,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ñ…Ñ€Ð¾Ð½Ð¾Ð»Ð¾Ð³Ð¸ÑÑ‚Ð°',0),(119563,3322,'ur','Ø¯ÛŒÚ©Ú¾ÛŒÛ“ ØªØ§Ø±ÛŒØ®',0),(119564,3322,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(119565,3322,'vi','Xem lá»‹ch sá»­',0),(119566,3322,'af','Besigtig Geskiedenis',0),(119567,3322,'ro','Vezi istorie',0),(119568,3322,'et','Vaata ajalugu',0),(119569,3322,'si','Ogled zgodovine',0),(119570,3322,'ba','Versi terdahulu',0),(119571,3322,'nl','Geschiedenis weergeven',0),(119572,3322,'fi','NÃ¤ytÃ¤ historia',0),(119573,3322,'no','Vis logg',0),(119574,3322,'da','Se historie',0),(119575,3322,'ko','ê¸°ë¡ ë³´ê¸°',0),(119576,3322,'he','×”×¦×’ ×”×™×¡×˜×•×¨×™×™×ª',0),(119577,3322,'el','Î ÏÎ¿Î²Î¿Î»Î® Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÎ¿Ï',0),(119578,3322,'zh','æŸ¥çœ‹åŽ†å²è®°å½•\r\n',0),(119579,3322,'sv','Visa historik',0),(119580,3322,'it','Visualizza cronologia',0),(119581,3322,'tl','',0),(119582,3322,'th','&#3604;&#3641;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;',0),(119583,3322,'hi','à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤¦à¥‡à¤–à¥‡à¤‚',0),(119584,3322,'ms','Lihat sejarah',0),(119585,3322,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø­Ø±ÙƒØ©',0),(119586,3322,'fr','Afficher l\'historique',0),(119587,3322,'jp','å±¥æ­´ä¸€è¦§',0),(119588,3322,'pt','Ver HistÃ³rico',0),(119589,3322,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ð¸',0),(119590,3322,'es','Visionar Historia',0),(119591,3322,'de','Geschichte Ansehen',0),(119592,3322,'en','View History',0),(119593,3323,'is','',0),(119594,3323,'dr','Ù†Ù…Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(119595,3323,'pr','Ù†Ù…Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(119596,3323,'tr','GÃ¶rÃ¼nÃ¼m fiyatlandÄ±rma',0),(119597,3323,'pl','Zobacz Cennik',0),(119598,3323,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ñ†ÐµÐ½Ð¸',0),(119599,3323,'ur','Ù…Ù†Ø¸Ø± Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(119600,3323,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°',0),(119601,3323,'vi','Xem giÃ¡',0),(119602,3323,'af','Besigtig Pryse',0),(119603,3323,'ro','Vezi preturi',0),(119604,3323,'et','Vaata hinnakujundus',0),(119605,3323,'si','Pogled oblikovanja cen',0),(119606,3323,'ba','Lihat harga',0),(119607,3323,'nl','Weergave prijzen',0),(119608,3323,'fi','Katso hinnoittelu',0),(119609,3323,'no','Vis priser',0),(119610,3323,'da','Se prisfastsÃ¦ttelse',0),(119611,3323,'ko','ë³´ê¸° ê°€ê²©',0),(119612,3323,'he','×”×¦×’ ×ž×—×™×¨×™×',0),(119613,3323,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï„Î¹Î¼ÏŽÎ½',0),(119614,3323,'zh','æŸ¥çœ‹ä»·æ ¼\r\n',0),(119615,3323,'sv','Visa priser',0),(119616,3323,'it','Visualizzazione dei prezzi',0),(119617,3323,'tl','',0),(119618,3323,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(119619,3323,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤¦à¥‡à¤–à¥‡à¤‚',0),(119620,3323,'ms','Paparan harga',0),(119621,3323,'ar','Ø¹Ø±Ø¶ Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(119622,3323,'fr','Affichage prix',0),(119623,3323,'jp','ä¾¡æ ¼è¨­å®šä¸€è¦§',0),(119624,3323,'pt','Ver preÃ§os',0),(119625,3323,'ru','Ð’Ð¸Ð´ Ñ†ÐµÐ½Ñ‹',0),(119626,3323,'es','Visionar Precios',0),(119627,3323,'de','Preise anzeigen',0),(119628,3323,'en','View Pricing',0),(119629,3324,'is','',0),(119630,3324,'dr','Ø¢ÙŠØ§ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ØŸ',0),(119631,3324,'pr','Ø¢ÙŠØ§ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ØŸ',0),(119632,3324,'tr','Void',0),(119633,3324,'pl','NiewaÅ¼ne',0),(119634,3324,'bg','Void',0),(119635,3324,'ur','Ø®Ù„Ø§',0),(119636,3324,'sr','ÐŸÑ€Ð°Ð·Ð½Ð¸Ð½Ð°',0),(119637,3324,'vi','Há»§y?',0),(119638,3324,'af','Leemte',0),(119639,3324,'ro','Gol',0),(119640,3324,'et','Annuleeri?',0),(119641,3324,'si','NiÄna',0),(119642,3324,'ba','Kekosongan',0),(119643,3324,'nl','Leegte',0),(119644,3324,'fi','Void',0),(119645,3324,'no','Ugyldig',0),(119646,3324,'da','Void',0),(119647,3324,'ko','ë¬´íš¨',0),(119648,3324,'he','×”×—×œ×œ ×”×¨×™×§',0),(119649,3324,'el','ÎšÎµÎ½ÏŒ',0),(119650,3324,'zh','æ— æ•ˆï¼Ÿ\r\n',0),(119651,3324,'sv','Void',0),(119652,3324,'it','Void',0),(119653,3324,'tl','',0),(119654,3324,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(119655,3324,'hi','à¤¶à¥‚à¤¨à¥à¤¯',0),(119656,3324,'ms','Kekosongan jawatan',0),(119657,3324,'ar','Ø§Ù„ÙØ±Ø§Øº',0),(119658,3324,'fr','Vide',0),(119659,3324,'jp','ç ´æ£„ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(119660,3324,'pt','Vazio',0),(119661,3324,'ru','Void',0),(119662,3324,'es','Â¿Anular?',0),(119663,3324,'de','Void',0),(119664,3324,'en','Void',0),(119665,3325,'is','',0),(119666,3325,'dr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(119667,3325,'pr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(119668,3325,'tr','Void hesaplamalarÄ±',0),(119669,3325,'pl','NiewaÅ¼ne obliczeÅ„',0),(119670,3325,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(119671,3325,'ur','Ø¨Ø§Ø·Ù„ Ú©Û’ Ø­Ø³Ø§Ø¨',0),(119672,3325,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ°',0),(119673,3325,'vi','Há»§y tÃ­nh toÃ¡n ',0),(119674,3325,'af','Leemte berekeninge',0),(119675,3325,'ro','Calculele nule',0),(119676,3325,'et','Annulleeri kalkulatsioonid',0),(119677,3325,'si','Neveljavne izraÄuni',0),(119678,3325,'ba','Membatalkan perhitungan',0),(119679,3325,'nl','VOID berekeningen',0),(119680,3325,'fi','MitÃ¤tÃ¶n laskelmat',0),(119681,3325,'no','Ugyldig beregninger',0),(119682,3325,'da','Ugyldig beregninger',0),(119683,3325,'ko','Void ê³„ì‚°',0),(119684,3325,'he','×—×™×©×•×‘×™× void',0),(119685,3325,'el','Î†ÎºÏ…ÏÎ· Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(119686,3325,'zh','è™šç©ºè®¡ç®—\r\n',0),(119687,3325,'sv','Void berÃ¤kningar',0),(119688,3325,'it','Void calcoli',0),(119689,3325,'tl','',0),(119690,3325,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(119691,3325,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(119692,3325,'ms','Pengiraan tidak sah',0),(119693,3325,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø¨Ø§Ø·Ù„Ø©',0),(119694,3325,'fr','Calculs Sub',0),(119695,3325,'jp','ç„¡åŠ¹ã?ªè¨ˆç®—',0),(119696,3325,'pt','Void cÃ¡lculos',0),(119697,3325,'ru','Void Ñ€Ð°ÑÑ‡ÐµÑ‚Ñ‹',0),(119698,3325,'es','Anular CÃ¡lculos',0),(119699,3325,'de','Void Berechnungen',0),(119700,3325,'en','Void Calculations',0),(119701,3326,'is','',0),(119702,3326,'dr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ùˆ ØªÙ…Ø§Ù… Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(119703,3326,'pr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ùˆ ØªÙ…Ø§Ù… Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(119704,3326,'tr','Hesaplamalar ve tÃ¼m Ã¶deme veri geÃ§ersiz',0),(119705,3326,'pl','NiewaÅ¼ne, obliczenia i wszystkie dane pÅ‚atnoÅ›ci',0),(119706,3326,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(119707,3326,'ur','Ø­Ø³Ø§Ø¨ Ø§ÙˆØ± ØªÙ†Ø®ÙˆØ§Û Ú©Û’ ØªÙ…Ø§Ù… Ú©ÙˆØ§Ø¦Ù ØµÙØ±',0),(119708,3326,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ° Ð¸ ÑÐ²Ð¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ',0),(119709,3326,'vi','Há»§y tÃ­nh toÃ¡n & Táº¥t Cáº£ dá»¯ liá»‡u thanh toÃ¡n ',0),(119710,3326,'af','Ongeldige Berekeninge EN Alle Besoldiging Data',0),(119711,3326,'ro','Anula calcule ÅŸi toate datele de plata',0),(119712,3326,'et','Annulleri kviitung, kalkulatsioonid ja makseandmed',0),(119713,3326,'si','Neveljavne izraÄune in vse plaÄati podatkov',0),(119714,3326,'ba','Membatalkan perhitungan dan semua Data membayar',0),(119715,3326,'nl','VOID berekeningen en alle gegevens van de beloning',0),(119716,3326,'fi','MitÃ¤tÃ¶idÃ¤ laskutoimitusten ja kaikkien maksu tietojen',0),(119717,3326,'no','Ugyldig beregninger og alle betale Data',0),(119718,3326,'da','Ugyldig beregninger og alle betale Data',0),(119719,3326,'ko','ê³„ì‚° ë° ëª¨ë“  ì§€ë¶ˆ ë°ì´í„° ë¬´íš¨',0),(119720,3326,'he','×ª×•×§×£ ×›×œ × ×ª×•× ×™ ×©×›×¨ ×•×—×™×©×•×‘×™×',0),(119721,3326,'el','Î†ÎºÏ…ÏÎ· Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ ÎºÎ±Î¹ ÏŒÎ»Î± Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Î¼Î¿Î¹Î²ÏŽÎ½',0),(119722,3326,'zh','è™šç©ºè®¡ç®—å’Œæ‰€æœ‰è–ªé…¬æ•°æ®\r\n',0),(119723,3326,'sv','Void berÃ¤kningar och alla betala Data',0),(119724,3326,'it','Annullare i calcoli e tutti i dati di pagamento',0),(119725,3326,'tl','',0),(119726,3326,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3588;&#3635;&#3609;&#3623;&#3603;&#3649;&#3621;&#3632;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(119727,3326,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤”à¤° à¤¸à¤­à¥€ à¤¡à¥‡à¤Ÿà¤¾ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(119728,3326,'ms','Membatalkan semua gaji Data dan pengiraan',0),(119729,3326,'ar','Ø¥ÙØ±Ø§Øº ÙƒØ§ÙØ© Ø§Ù„Ø£Ø¬ÙˆØ± Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ÙˆØ§Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ÙŠØ©',0),(119730,3326,'fr','Annuler les calculs et toutes les donnÃ©es de paye',0),(119731,3326,'jp','ç„¡åŠ¹ã?ªè¨ˆç®—ã?¨å…¨ã?¦ã?®æ”¯æ‰•ãƒ‡ãƒ¼ã‚¿',0),(119732,3326,'pt','Void cÃ¡lculos e todos os dados de pagamento',0),(119733,3326,'ru','Void Ñ€Ð°ÑÑ‡ÐµÑ‚Ñ‹ Ð¸ Ð²ÑÐµ Ð¿Ð»Ð°Ñ‚ÑÑ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(119734,3326,'es','Anular CÃ¡lculos Y Todos los Datos de Pagos',0),(119735,3326,'de','Void Berechnungen und alle Pay-Daten',0),(119736,3326,'en','Void Calculations AND All Pay Data',0),(119737,3327,'is','',0),(119738,3327,'dr','Ø§Ø¨Ø·Ø§Ù„ Ú†Ùƒ',0),(119739,3327,'pr','Ø§Ø¨Ø·Ø§Ù„ Ú†Ùƒ',0),(119740,3327,'tr','Ã‡eki',0),(119741,3327,'pl','UniewaÅ¼nij czek',0),(119742,3327,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ñ‚Ðµ Ñ‡ÐµÐº',0),(119743,3327,'ur','Ú©Ø§Ù„Ø¹Ø¯Ù… Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(119744,3327,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ñ‡ÐµÐº',0),(119745,3327,'vi','SÃ©c há»§y',0),(119746,3327,'af','Tjek leemte',0),(119747,3327,'ro','AnulaÅ£i CEC',0),(119748,3327,'et','Annulleeri kviitung',0),(119749,3327,'si','Razveljavi Äek',0),(119750,3327,'ba','Membatalkan Check',0),(119751,3327,'nl','Cheque',0),(119752,3327,'fi','MitÃ¤tÃ¶i sekki',0),(119753,3327,'no','Kansellere sjekk',0),(119754,3327,'da','Annullere Check',0),(119755,3327,'ko','ë¬´íš¨ í™•ì¸',0),(119756,3327,'he','×”×¡×™×ž×•×Ÿ ×‘×˜×œ ×•×ž×‘×•×˜×œ',0),(119757,3327,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· Î•Ï€Î¹Ï„Î±Î³Î®Ï‚',0),(119758,3327,'zh','ä½œåºŸæ£€æŸ¥\r\n',0),(119759,3327,'sv','Makulera Check',0),(119760,3327,'it','Void Check',0),(119761,3327,'tl','',0),(119762,3327,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3594;&#3655;&#3588;',0),(119763,3327,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤šà¥‡à¤•',0),(119764,3327,'ms','Cek terbatal',0),(119765,3327,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø¨Ø§Ø·Ù„Ø©',0),(119766,3327,'fr','Cocher Sub',0),(119767,3327,'jp','ç„¡åŠ¹ã?ªå°?åˆ‡æ‰‹',0),(119768,3327,'pt','Anular seleÃ§Ã£o',0),(119769,3327,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ‡ÐµÐº',0),(119770,3327,'es','Anular Cheque',0),(119771,3327,'de','Void Check',0),(119772,3327,'en','Void Check',0),(119773,3328,'is','',0),(119774,3328,'dr','Ø§Ø¨Ø·Ø§Ù„ Ú†Ùƒ Ùˆ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(119775,3328,'pr','Ø§Ø¨Ø·Ø§Ù„ Ú†Ùƒ Ùˆ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(119776,3328,'tr','Ã‡eki ve hesaplamalar',0),(119777,3328,'pl','UniewaÅ¼nij czek i obliczenia',0),(119778,3328,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð¼ Ñ‡ÐµÐº Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(119779,3328,'ur','Ú©Ø§Ù„Ø¹Ø¯Ù… Ú†ÛŒÚ© Ø§ÙˆØ± Ø­Ø³Ø§Ø¨',0),(119780,3328,'sr','ÐŸÑ€Ð°Ð·Ð½Ð¸Ð½Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ð°ÑšÐ°',0),(119781,3328,'vi','XÃ³a SÃ©c & tÃ­nh toÃ¡n',0),(119782,3328,'af','Tjek leemte en berekeninge',0),(119783,3328,'ro','Selectare nule ÅŸi calcule',0),(119784,3328,'et','Annulleeri kviitung ja kalkulatsioonid',0),(119785,3328,'si','Razveljavi Äek in izraÄuni',0),(119786,3328,'ba','Cek kosong dan perhitungan',0),(119787,3328,'nl','Cheque en berekeningen',0),(119788,3328,'fi','MitÃ¤tÃ¶i sekki ja laskelmat',0),(119789,3328,'no','Kanseller sjekk og beregninger',0),(119790,3328,'da','Ugyldig Check og beregninger',0),(119791,3328,'ko','ë¬´íš¨ í™•ì¸ ë° ê³„ì‚°',0),(119792,3328,'he','×”×¡×™×ž×•×Ÿ ×‘×˜×œ ×•×ž×‘×•×˜×œ ×•×—×™×©×•×‘×™×',0),(119793,3328,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· Î•Ï€Î¹Ï„Î±Î³Î®Ï‚ ÎºÎ±Î¹ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(119794,3328,'zh','ä½œåºŸæ£€æŸ¥å’Œè®¡ç®—\r\n',0),(119795,3328,'sv','Void Check och berÃ¤kningar',0),(119796,3328,'it','Calcoli e void Check',0),(119797,3328,'tl','',0),(119798,3328,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3594;&#3655;&#3588;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(119799,3328,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤šà¥‡à¤• à¤”à¤° à¤—à¤£à¤¨à¤¾',0),(119800,3328,'ms','Cek terbatal dan pengiraan',0),(119801,3328,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø¨Ø§Ø·Ù„Ø§ ÙˆØ§Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ÙŠØ©',0),(119802,3328,'fr','Calculs et cocher Sub',0),(119803,3328,'jp','ç„¡åŠ¹ã?ªå°?åˆ‡æ‰‹ã?¨è¨ˆç®—',0),(119804,3328,'pt','CÃ¡lculos e seleÃ§Ã£o void',0),(119805,3328,'ru','Void Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¸ Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(119806,3328,'es','Anular Cheque y CÃ¡lculos',0),(119807,3328,'de','Void Check und Berechnungen',0),(119808,3328,'en','Void Check and Calculations',0),(119809,3329,'is','',0),(119810,3329,'dr','(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(119811,3329,'pr','Ø§Ø¨Ø·Ø§Ù„ Ú†Ùƒ Ùˆ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ùˆ ØªÙ…Ø§Ù… Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(119812,3329,'tr','Ã‡eki, hesaplamalar ve tÃ¼m veri Ã¶deme',0),(119813,3329,'pl','UniewaÅ¼nij czek, obliczenia i wszystko zapÅ‚aciÄ‡ danych',0),(119814,3329,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð¼ Ñ‡ÐµÐº, Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(119815,3329,'ur','Ú†ÛŒÚ©ØŒ Ø­Ø³Ø§Ø¨ Ø§ÙˆØ± ØªÙ†Ø®ÙˆØ§Û Ú©Û’ ØªÙ…Ø§Ù… Ú©ÙˆØ§Ø¦Ù ØµÙØ±',0),(119816,3329,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ, Ð¿Ñ€Ð¾Ñ€Ð°Ñ‡ÑƒÐ½Ð¸Ð¼Ð° Ð¸ ÑÐ²Ð¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ',0),(119817,3329,'vi','XÃ³a SÃ©c, tÃ­nh toÃ¡n & Táº¥t cáº£ dá»¯ liá»‡u thanh toÃ¡n',0),(119818,3329,'af','Ongeldige Tjek, Berekenings EN Alle Besoldiging Data',0),(119819,3329,'ro','Anula Check, calcule ÅŸi toate datele de plata',0),(119820,3329,'et','Annulleri kviitung, kalkulatsioonid ja KÃ•IK makseandmed',0),(119821,3329,'si','Razveljavi Äek, izraÄuni in vse plaÄati podatkov',0),(119822,3329,'ba','Membatalkan cek, perhitungan, dan semua Data membayar',0),(119823,3329,'nl','Cheque, berekeningen en alle betalen gegevens',0),(119824,3329,'fi','MitÃ¤tÃ¶i sekki, laskelmat ja kaikki maksaa tiedot',0),(119825,3329,'no','Kanseller sjekk, beregninger og alle betale Data',0),(119826,3329,'da','Annullere Check, beregninger og alle lÃ¸n Data',0),(119827,3329,'ko','ë¬´íš¨ í™•ì¸, ê³„ì‚° ë° ì§€ë¶ˆì˜ ëª¨ë“  ë°ì´í„°',0),(119828,3329,'he','×œ×‘×˜×œ ××ª ×”×¡×™×ž×•×Ÿ, ×›×œ × ×ª×•× ×™ ×©×›×¨ ×•×—×™×©×•×‘×™×',0),(119829,3329,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· Î•Ï€Î¹Ï„Î±Î³Î®Ï‚, Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ ÎºÎ±Î¹ ÏŒÎ»Î¿Î¹ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(119830,3329,'zh','ä½œåºŸæ£€æŸ¥ï¼Œè®¡ç®—å’Œæ‰€æœ‰è–ªé…¬æ•°æ®\r\n',0),(119831,3329,'sv','Makulera Check, berÃ¤kningar och alla betala Data',0),(119832,3329,'it','Void Check, calcoli e tutti i dati di pagamento',0),(119833,3329,'tl','',0),(119834,3329,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3594;&#3655;&#3588;,&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3649;&#3621;&#3632;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#',0),(119835,3329,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤šà¥‡à¤•, à¤—à¤£à¤¨à¤¾ à¤”à¤° à¤¸à¤­à¥€ à¤¡à¥‡à¤Ÿà¤¾ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(119836,3329,'ms','Cek terbatal, pengiraan dan semua membayar Data',0),(119837,3329,'ar','Ø¯ÙØ¹ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø¨Ø§Ø·Ù„Ø©ØŒ ÙˆØ§Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ÙŠØ© ÙˆØ¬Ù…ÙŠØ¹ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(119838,3329,'fr','Void Check, calculs et toutes les donnÃ©es de paye',0),(119839,3329,'jp','ç„¡åŠ¹ã?ªå°?åˆ‡æ‰‹ã€?è¨ˆç®—ã?¨å…¨ã?¦ã?®æ”¯æ‰•ãƒ‡ãƒ¼ã‚¿',0),(119840,3329,'pt','Cancelar a seleÃ§Ã£o, cÃ¡lculos e todos os dados de pagamento',0),(119841,3329,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ‡ÐµÐº, Ñ€Ð°ÑÑ‡ÐµÑ‚Ñ‹ Ð¸ Ð²ÑÐµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(119842,3329,'es','Anular Cheque, CÃ¡lculos Y Todos los Datos de Pagos',0),(119843,3329,'de','Void Check, Berechnungen und alle Pay-Daten',0),(119844,3329,'en','Void Check, Calculations AND All Pay Data',0),(119845,3330,'is','',0),(119846,3330,'dr','Ù‡Ø± Ú†Ùƒ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ Ø§ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø´Ø¯ ',0),(119847,3330,'pr','Ù‡Ø± Ú†Ùƒ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ Ø§ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø´Ø¯ ',0),(119848,3330,'tr','Herhangi baÅŸarÄ±lÄ± bir ÅŸekilde iÅŸaretlenmiÅŸ Ã§ekleri geÃ§ersiz kÄ±lÄ±ndÄ±.',0),(119849,3330,'pl','Wszelkie uniewaÅ¼niÄ‡ czeki oznaczony jako powodzeniem.',0),(119850,3330,'bg','Ð’ÑÐµÐºÐ¸ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½ Ñ‡ÐµÐº(Ð¾Ð²Ðµ), Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(119851,3330,'ur','Ú©Ø³ÛŒ Ø¨Ú¾ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù†Ø´Ø§Ù† Ø²Ø¯ check(s) ÙˆÙˆØ§ÚˆÛŒØ¯ Û”',0),(119852,3330,'sr','ÐÐµÐºÐ¸ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾.',0),(119853,3330,'vi','Táº¥t cáº£ sÃ©c há»§y Ä‘Ã£ Ä‘Ã¡nh dáº¥u thÃ nh cÃ´ng',0),(119854,3330,'af','Enige ontlaste check(s) suksesvol gemerk.',0),(119855,3330,'ro','Orice anulate cecul/cecurile marcate cu succes.',0),(119856,3330,'et','Annulleeritud kviitungi(te) mÃ¤rkimine Ãµnnestus',0),(119857,3330,'si','Koli razveljavi Äeke oznaÄena uspeÅ¡no.',0),(119858,3330,'ba','Setiap voided check(s) ditandai berhasil.',0),(119859,3330,'nl','Een ongeldig cheques gemarkeerd met succes.',0),(119860,3330,'fi','MitÃ¤Ã¤n mitÃ¤tÃ¶ity sekki merkitty onnistuneesti.',0),(119861,3330,'no','Noen strÃ¸ket sjekken(e) merket vellykket.',0),(119862,3330,'da','Nogen nedlagte checken(e) markeret med succes.',0),(119863,3330,'ko','ì–´ë–¤ ì·¨ì†Œ ë“  ì„±ê³µì ìœ¼ë¡œ í‘œì‹œ.',0),(119864,3330,'he','×™×© ×œ×‘×˜×œ ××ª ×ª×•×§×£ check(s) ×ž×¡×•×ž×Ÿ ×‘×”×¦×œ×—×”.',0),(119865,3330,'el','ÎŸÏ€Î¿Î¹Î±Î´Î®Ï€Î¿Ï„Îµ Î¬ÎºÏ…ÏÎ· ÎµÏ€Î¹Ï„Î±Î³Î® Î® ÎµÏ€Î¹Ï„Î±Î³Î­Ï‚ Ï€Î¿Ï… ÏƒÎ·Î¼ÎµÎ¹ÏŽÎ½Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(119866,3330,'zh','ä»»ä½•ä½œåºŸæ”¯ç¥¨æ ‡è®°æˆåŠŸã€‚\r\n',0),(119867,3330,'sv','NÃ¥gon annullerade checken/checkarna markeras framgÃ¥ngsrikt.',0),(119868,3330,'it','Qualsiasi annullate assegni contrassegnato con successo.',0),(119869,3330,'tl','',0),(119870,3330,'th','&#3607;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3594;&#3655;&#3588;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(119871,3330,'hi','à¤•à¤¿à¤¸à¥€ à¤­à¥€ check(s) à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤ voided.',0),(119872,3330,'ms','Mana-mana voided check(s) yang menandakan berjaya.',0),(119873,3330,'ar','Ø£ÙŠ Ù…Ù„ØºØ§Ø© check(s) ØªÙ…ÙŠØ² Ø¨Ù†Ø¬Ø§Ø­.',0),(119874,3330,'fr','Tout annulÃ© chÃ¨ques marquÃ©s avec succÃ¨s.',0),(119875,3330,'jp','ã?©ã?®ç„¡åŠ¹ã?ªå°?åˆ‡æ‰‹ã‚‚',0),(119876,3330,'pt','Qualquer anuladas verificaÃ§Ãµes marcadas com Ãªxito.',0),(119877,3330,'ru','Ð›ÑŽÐ±Ñ‹Ðµ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ñ, Ð¾Ñ‚Ð¼ÐµÑ‡ÐµÐ½Ð½Ñ‹Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(119878,3330,'es','Cualquier cheque(s) anulado(s) marcados exitosamente',0),(119879,3330,'de','Eine stornierte Schecks erfolgreich markiert.',0),(119880,3330,'en','Any voided check(s) marked successfully.',0),(119881,3331,'is','',0),(119882,3331,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ø§Ø·Ù„ Ø´Ø¯ ',0),(119883,3331,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ø§Ø·Ù„ Ø´Ø¯ ',0),(119884,3331,'tr','baÅŸarÄ±lÄ± bir ÅŸekilde hÃ¼kÃ¼msÃ¼z.',0),(119885,3331,'pl','uniewaÅ¼nione pomyÅ›lnie.',0),(119886,3331,'bg','Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(119887,3331,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ ÙˆÙˆØ§ÚˆÛŒØ¯ Û”',0),(119888,3331,'sr','ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ñ˜Ðµ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½.',0),(119889,3331,'vi','há»§y thÃ nh cÃ´ng',0),(119890,3331,'af','suksesvol uitgewis.',0),(119891,3331,'ro','anulat cu succes.',0),(119892,3331,'et','Annulleerimine Ãµnnestus',0),(119893,3331,'si','razveljavljena uspeÅ¡no.',0),(119894,3331,'ba','voided berhasil.',0),(119895,3331,'nl','ongeldig met succes.',0),(119896,3331,'fi','pÃ¤tevÃ¤ onnistuneesti.',0),(119897,3331,'no','strÃ¸ket vellykket.',0),(119898,3331,'da','annulleret med succes.',0),(119899,3331,'ko','ì„±ê³µì ìœ¼ë¡œ ë¬´íš¨í™”.',0),(119900,3331,'he','×‘×•×˜×œ ×‘×”×¦×œ×—×”.',0),(119901,3331,'el','Î±ÎºÏ…ÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(119902,3331,'zh','ä½œåºŸæˆåŠŸã€‚\r\n',0),(119903,3331,'sv','annullerade framgÃ¥ngsrikt.',0),(119904,3331,'it','annullate con successo.',0),(119905,3331,'tl','',0),(119906,3331,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(119907,3331,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• voided.',0),(119908,3331,'ms','voided berjaya.',0),(119909,3331,'ar','Ù…Ù„ØºØ§Ø© Ø¨Ù†Ø¬Ø§Ø­.',0),(119910,3331,'fr','annulÃ©e avec succÃ¨s.',0),(119911,3331,'jp','ç ´æ£„ã?—ã?¾ã?—ã?Ÿ',0),(119912,3331,'pt','anulada com Ãªxito.',0),(119913,3331,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(119914,3331,'es','anulado exitosamente',0),(119915,3331,'de','erfolgreich storniert.',0),(119916,3331,'en','voided successfully.',0),(119917,3332,'is','',0),(119918,3332,'dr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(119919,3332,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(119920,3332,'tr','FiÅŸ baÅŸarÄ±yla eklendi!',0),(119921,3332,'pl','PomyÅ›lnie dodano zaÅ‚Ä…cznik!',0),(119922,3332,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾!',0),(119923,3332,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§!',0),(119924,3332,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸!',0),(119925,3332,'vi','ThÃªm phiáº¿u thÃ nh cÃ´ng',0),(119926,3332,'af','Bewys suksesvol bygevoeg!',0),(119927,3332,'ro','Voucher adÄƒugat cu succes!',0),(119928,3332,'et','VautÅ¡eri lisamine Ãµnnestus!',0),(119929,3332,'si','Voucher uspeÅ¡no dodan!',0),(119930,3332,'ba','Voucher ditambahkan berhasil!',0),(119931,3332,'nl','Waardebon toegevoegd!',0),(119932,3332,'fi','Tositteen lisÃ¤Ã¤minen onnistui!',0),(119933,3332,'no','Bilag lagt!',0),(119934,3332,'da','Voucher tilfÃ¸jet!',0),(119935,3332,'ko','ë°”ìš°ì²˜ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€!',0),(119936,3332,'he','×©×•×‘×¨ × ×•×¡×£ ×‘×”×¦×œ×—×”!',0),(119937,3332,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±!',0),(119938,3332,'zh','å‡­å•æ·»åŠ æˆåŠŸï¼\r\n',0),(119939,3332,'sv','Verifikationen lagts till!',0),(119940,3332,'it','Buono aggiunto con successo!',0),(119941,3332,'tl','',0),(119942,3332,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(119943,3332,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾!',0),(119944,3332,'ms','Baucar yang berjaya menambah!',0),(119945,3332,'ar','Ø§Ù„Ø¥ÙŠØµØ§Ù„ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­!',0),(119946,3332,'fr','Bon ajoutÃ© avec succÃ¨s !',0),(119947,3332,'jp','ä¼?ç¥¨ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(119948,3332,'pt','Voucher adicionado com sucesso!',0),(119949,3332,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½!',0),(119950,3332,'es','Voucher Agregado Exitosamente',0),(119951,3332,'de','Gutschein wurde erfolgreich hinzugefÃ¼gt!',0),(119952,3332,'en','Voucher Added Successfully!',0),(119953,3333,'is','',0),(119954,3333,'dr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(119955,3333,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(119956,3333,'tr','FiÅŸ',0),(119957,3333,'pl','Kupon',0),(119958,3333,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€',0),(119959,3333,'ur','ÙˆØ§Ø¤Ú†Ø±',0),(119960,3333,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€',0),(119961,3333,'vi','Phiáº¿u',0),(119962,3333,'af','Bewysstuk',0),(119963,3333,'ro','Voucher',0),(119964,3333,'et','VautÅ¡eri',0),(119965,3333,'si','Kupon',0),(119966,3333,'ba','Voucher',0),(119967,3333,'nl','Waardebon',0),(119968,3333,'fi','Tosite',0),(119969,3333,'no','Bilag',0),(119970,3333,'da','Voucher',0),(119971,3333,'ko','ë°”ìš°ì²˜',0),(119972,3333,'he','×©×•×‘×¨',0),(119973,3333,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(119974,3333,'zh','å‡­å•\r\n',0),(119975,3333,'sv','Kupongen',0),(119976,3333,'it','Buono',0),(119977,3333,'tl','',0),(119978,3333,'th','&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(119979,3333,'hi','à¤µà¤¾à¤‰à¤šà¤°',0),(119980,3333,'ms','Baucer',0),(119981,3333,'ar','Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(119982,3333,'fr','Bon',0),(119983,3333,'jp','ä¼?ç¥¨',0),(119984,3333,'pt','Voucher',0),(119985,3333,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€',0),(119986,3333,'es','Recibo (Voucher)',0),(119987,3333,'de','Gutschein',0),(119988,3333,'en','Voucher',0),(119989,3334,'is','',0),(119990,3334,'dr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(119991,3334,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(119992,3334,'tr','FiÅŸ baÅŸarÄ±yla eklendi',0),(119993,3334,'pl','PomyÅ›lnie dodano zaÅ‚Ä…cznik',0),(119994,3334,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(119995,3334,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(119996,3334,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(119997,3334,'vi','ThÃªm phiáº¿u thÃ nh cÃ´ng',0),(119998,3334,'af','Bewysstukke suksesvol bygevoeg.',0),(119999,3334,'ro','Voucher adÄƒugat cu succes',0),(120000,3334,'et','VautÅ¡eri lisamine Ãµnnestus',0),(120001,3334,'si','Voucher uspeÅ¡no dodani',0),(120002,3334,'ba','Voucher yang ditambahkan berhasil',0),(120003,3334,'nl','Waardebon toegevoegd',0),(120004,3334,'fi','Tositteen lisÃ¤Ã¤minen onnistui',0),(120005,3334,'no','Bilag lagt',0),(120006,3334,'da','Voucher tilfÃ¸jet',0),(120007,3334,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì¿ í°',0),(120008,3334,'he','×©×•×‘×¨ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(120009,3334,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(120010,3334,'zh','å‡­å•æ·»åŠ æˆåŠŸ\r\n',0),(120011,3334,'sv','Verifikationen som lagts',0),(120012,3334,'it','Voucher aggiunto con successo',0),(120013,3334,'tl','',0),(120014,3334,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(120015,3334,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(120016,3334,'ms','Baucar yang berjaya menambah',0),(120017,3334,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(120018,3334,'fr','Bon ajoutÃ© avec succÃ¨s',0),(120019,3334,'jp','ä¼?ç¥¨ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(120020,3334,'pt','Voucher adicionado com sucesso',0),(120021,3334,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(120022,3334,'es','Voucher Agregado Exitosamente',0),(120023,3334,'de','Gutschein wurde erfolgreich hinzugefÃ¼gt',0),(120024,3334,'en','Voucher Added Successfully',0),(120025,3335,'is','',0),(120026,3335,'dr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(120027,3335,'pr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(120028,3335,'tr','Tam fiÅŸi',0),(120029,3335,'pl','WypeÅ‚niÄ‡ kupon',0),(120030,3335,'bg','ÐŸÑŠÐ»Ð½Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(120031,3335,'ur','Ù…Ú©Ù…Ù„ ÙˆØ§Ø¤Ú†Ø±',0),(120032,3335,'sr','ÐŸÐ¾Ñ‚Ð¿ÑƒÐ½ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(120033,3335,'vi','HoÃ nn táº¥t phiáº¿u',0),(120034,3335,'af','Voltooi Bewysstuk',0),(120035,3335,'ro','Voucher complet',0),(120036,3335,'et','LÃµplik vautÅ¡er',0),(120037,3335,'si','Izpolnite kupon',0),(120038,3335,'ba','Voucher lengkap',0),(120039,3335,'nl','Volledige Voucher',0),(120040,3335,'fi','TÃ¤ydellinen tosite',0),(120041,3335,'no','Komplett bilag',0),(120042,3335,'da','Komplet Voucher',0),(120043,3335,'ko','ì™„ì „ í•œ ë°”ìš°ì²˜',0),(120044,3335,'he','×œ×”×©×œ×™× ××ª ×”×©×•×‘×¨',0),(120045,3335,'el','Î Î»Î®ÏÎµÏ‚ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(120046,3335,'zh','å®Œæ•´å‡­å•\r\n',0),(120047,3335,'sv','FullstÃ¤ndig verifikation',0),(120048,3335,'it','Voucher completa',0),(120049,3335,'tl','',0),(120050,3335,'th','&#3588;&#3623;&#3634;&#3617;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3586;&#3629;&#3591;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(120051,3335,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤•à¥‹ à¤ªà¥‚à¤°à¤¾',0),(120052,3335,'ms','Baucer yang lengkap',0),(120053,3335,'ar','Ù‚Ø³ÙŠÙ…Ø© ÙƒØ§Ù…Ù„Ø©',0),(120054,3335,'fr','Remplir le coupon',0),(120055,3335,'jp','ä¼?ç¥¨ã‚’å®Œäº†',0),(120056,3335,'pt','Voucher completa',0),(120057,3335,'ru','ÐŸÐ¾Ð»Ð½Ð°Ñ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(120058,3335,'es','Completar Voucher',0),(120059,3335,'de','Komplette Gutschein',0),(120060,3335,'en','Complete Voucher',0),(120061,3336,'is','',0),(120062,3336,'dr','ØªØ§Ø±ÙŠØ® Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(120063,3336,'pr','ØªØ§Ø±ÙŠØ® Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(120064,3336,'tr','FiÅŸ tarihi',0),(120065,3336,'pl','DatÄ™ zaÅ‚Ä…cznika',0),(120066,3336,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð·Ð° Ð´Ð°Ñ‚Ð°',0),(120067,3336,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(120068,3336,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð´Ð°Ñ‚ÑƒÐ¼',0),(120069,3336,'vi','NgÃ y phiáº¿u',0),(120070,3336,'af','Bewysstuk Datum',0),(120071,3336,'ro','Data voucher',0),(120072,3336,'et','VautÅ¡eri kuupÃ¤ev',0),(120073,3336,'si','Datum kupona',0),(120074,3336,'ba','Voucher tanggal',0),(120075,3336,'nl','Waardebon datum',0),(120076,3336,'fi','Tositteen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(120077,3336,'no','Bilagsdatoen',0),(120078,3336,'da','Bilagsdatoen',0),(120079,3336,'ko','ì¿ í° ë‚ ì§œ',0),(120080,3336,'he','×ª××¨×™×š ×©×•×‘×¨',0),(120081,3336,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(120082,3336,'zh','å‡­å•æ—¥æœŸ\r\n',0),(120083,3336,'sv','Verifikationsdatum',0),(120084,3336,'it','Buono data',0),(120085,3336,'tl','',0),(120086,3336,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(120087,3336,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(120088,3336,'ms','Tarikh baucer',0),(120089,3336,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(120090,3336,'fr','Date de coupon',0),(120091,3336,'jp','ä¼?ç¥¨æ—¥ä»˜',0),(120092,3336,'pt','Data do voucher',0),(120093,3336,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(120094,3336,'es','Fecha de Voucher',0),(120095,3336,'de','Belegdatum',0),(120096,3336,'en','Voucher Date',0),(120097,3337,'is','',0),(120098,3337,'dr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(120099,3337,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(120100,3337,'tr','FiÅŸ baÅŸarÄ±yla silindi.',0),(120101,3337,'pl','ZaÅ‚Ä…cznik usuniÄ™ty pomyÅ›lnie.',0),(120102,3337,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(120103,3337,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(120104,3337,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(120105,3337,'vi','XÃ³a phiáº¿u thÃ nh cÃ´ng',0),(120106,3337,'af','Bewysstuk suksesvol geskrap.',0),(120107,3337,'ro','Voucher ÅŸters cu succes.',0),(120108,3337,'et','VautÅ¡eri kustutamine Ãµnnestus',0),(120109,3337,'si','Voucher uspeÅ¡no izbrisana.',0),(120110,3337,'ba','Voucher berhasil dihapus.',0),(120111,3337,'nl','Bon met succes verwijderd.',0),(120112,3337,'fi','Tosite poistettu.',0),(120113,3337,'no','Bilaget slettet.',0),(120114,3337,'da','Voucher slettet.',0),(120115,3337,'ko','ë°”ìš°ì²˜ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(120116,3337,'he','×©×•×‘×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(120117,3337,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(120118,3337,'zh','å‡­å•å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(120119,3337,'sv','Verifikationen raderades.',0),(120120,3337,'it','Voucher eliminato con successo.',0),(120121,3337,'tl','',0),(120122,3337,'th','&#3621;&#3610;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(120123,3337,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(120124,3337,'ms','Baucer dihapuskan dengan jayanya.',0),(120125,3337,'ar','Ø­Ø°Ù Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(120126,3337,'fr','Bon supprimÃ© avec succÃ¨s.',0),(120127,3337,'jp','ä¼?ç¥¨ã‚’æ¶ˆåŽ»ã?—ã?¾ã?—ã?Ÿ',0),(120128,3337,'pt','Voucher excluÃ­do com sucesso.',0),(120129,3337,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(120130,3337,'es','Voucher eliminado exitosamente',0),(120131,3337,'de','Gutschein wurde erfolgreich gelÃ¶scht.',0),(120132,3337,'en','Voucher deleted successfully.',0),(120133,3338,'is','',0),(120134,3338,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(120135,3338,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(120136,3338,'tr','FiÅŸ detay baÅŸarÄ±yla eklendi',0),(120137,3338,'pl','ZaÅ‚Ä…cznik szczegÃ³Å‚y dodane pomyÅ›lnie',0),(120138,3338,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(120139,3338,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ ØªÙØµÛŒÙ„ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(120140,3338,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð´ÐµÑ‚Ð°Ñ™ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(120141,3338,'vi','ThÃªm chi tiáº¿t phiáº¿u thÃ nh cÃ´ng',0),(120142,3338,'af','Bewysstuk Detail suksesvol geskep',0),(120143,3338,'ro','Voucher detaliu adÄƒugat cu succes',0),(120144,3338,'et','VautÅ¡erile andmed lisatut',0),(120145,3338,'si','Voucher podrobno uspeÅ¡no dodani',0),(120146,3338,'ba','Voucher Detail ditambahkan berhasil',0),(120147,3338,'nl','Detail van de waardebon toegevoegd',0),(120148,3338,'fi','Tositteen tiedot lisÃ¤ttiin',0),(120149,3338,'no','Bilag detaljer lagt',0),(120150,3338,'da','Voucher detaljer tilfÃ¸jet',0),(120151,3338,'ko','ë°”ìš°ì²˜ ì„¸ë¶€ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(120152,3338,'he','×¤×™×¨×•×˜ ×©×•×‘×¨ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(120153,3338,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(120154,3338,'zh','å‡­å•è¯¦ç»†æ·»åŠ æˆåŠŸ\r\n',0),(120155,3338,'sv','Verifikationen detalj lagts',0),(120156,3338,'it','Voucher dettaglio aggiunto con successo',0),(120157,3338,'tl','',0),(120158,3338,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(120159,3338,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(120160,3338,'ms','Butiran baucar yang berjaya menambah',0),(120161,3338,'ar','Ø£Ø¶ÙŠÙØª ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(120162,3338,'fr','Bon dÃ©tail ajoutÃ© avec succÃ¨s',0),(120163,3338,'jp','ä¼?ç¥¨è©³ç´°ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(120164,3338,'pt','Voucher detalhe adicionado com sucesso',0),(120165,3338,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð´ÐµÑ‚Ð°Ð»ÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(120166,3338,'es','Detalle de Voucher Agregado Exitosamente',0),(120167,3338,'de','Gutschein Details erfolgreich hinzugefÃ¼gt',0),(120168,3338,'en','Voucher Detail Added Successfully',0),(120169,3339,'is','',0),(120170,3339,'dr','. Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ù‡ Ø±ÙˆØ² Ù†ÙŠØ³Øª',0),(120171,3339,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ØªØ±Ø§Ø² Ù†ÙŠØ³Øª . Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ù‡ Ø±ÙˆØ² Ù†ÙŠØ³Øª',0),(120172,3339,'tr','FiÅŸ bakiyesi deÄŸil. FiÅŸi gÃ¼ncelleme deÄŸil.',0),(120173,3339,'pl','Kupon nie bilans. Kupon nie aktualizowane.',0),(120174,3339,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ÑŠÑ‚ Ð½Ðµ Ð±Ð°Ð»Ð°Ð½Ñ. Ð’Ð°ÑƒÑ‡ÐµÑ€ÑŠÑ‚ Ð½Ðµ ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°.',0),(120175,3339,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† ØªÙˆØ§Ø²Ù† Ù†ÛÛŒÚº Ú©ÛŒØ§ ØªÚ¾Ø§ Û” ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†ÛÛŒÚº Ú©ÛŒ ÛÛ’ Û”',0),(120176,3339,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð´Ð° Ð»Ð¸ Ð½Ð¸ÑÑƒ Ñ˜ÐµÐ´Ð½Ð°ÐºÐ¸. Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð½Ð¸Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(120177,3339,'vi','Phiáº¿u khÃ´ng cÃ¢n Ä‘á»‘i. Phiáº¿u chÆ°a cáº­p nháº­t',0),(120178,3339,'af','Bewysstuk het nie balanseer.  Bewysstuk nie opdateer.',0),(120179,3339,'ro','Voucherul nu echilibru. Voucherul nu actualizat.',0),(120180,3339,'et','*Voucher did not balance. Voucher not updated.',0),(120181,3339,'si','Kupona ni storil ravnovesje. Kupona ni posodobljen.',0),(120182,3339,'ba','Voucher tidak seimbang. Voucher tidak diperbarui.',0),(120183,3339,'nl','Waardebon deed niet in evenwicht brengen. Waardebon niet bijgewerkt.',0),(120184,3339,'fi','Tositetta ei tasapainottanut. Tosite ei pÃ¤ivitetÃ¤.',0),(120185,3339,'no','Bilag ikke balanse. Bilaget er ikke oppdatert.',0),(120186,3339,'da','Voucher ikke balance. Bilaget opdateres ikke.',0),(120187,3339,'ko','ë°”ìš°ì²˜ ê· í˜•ì„ ì¡°ì • í•˜ì§€ ì•Šì•˜ë‹¤. ë°”ìš°ì²˜ ì—…ë°ì´íŠ¸ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(120188,3339,'he','×œ× ×œ××–×Ÿ ××ª ×”×©×•×‘×¨. ×”×©×•×‘×¨ ××™× ×• ×ž×¢×•×“×›×Ÿ.',0),(120189,3339,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Î´ÎµÎ½ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±. Î¤Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Î´ÎµÎ½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹.',0),(120190,3339,'zh','å‡­å•æœªç»“ä½™ã€‚å‡­å•æœªæ›´æ–°ã€‚\r\n',0),(120191,3339,'sv','Inte att balansera verifikationen. Verifikationen inte uppdateras.',0),(120192,3339,'it','Buono non equilibrio. Voucher non aggiornato.',0),(120193,3339,'tl','',0),(120194,3339,'th','&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3652;&#3617;&#3656;&#3604;&#3640;&#3621; &#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3629;&#3633;&#3614;&#3648;&#3604;&#3607;',0),(120195,3339,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤¥à¤¾à¥¤ à¤µà¤¾à¤‰à¤šà¤° à¤¨à¤¹à¥€à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(120196,3339,'ms','Baucar tidak baki. Baucer yang tidak dikemaskini.',0),(120197,3339,'ar','Ø¹Ø¯Ù… Ø§Ù„ØªÙˆØ§Ø²Ù† Ø¨ÙŠÙ† Ø§Ù„Ø¥ÙŠØµØ§Ù„. Ù„Ù… ÙŠØªÙ… ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¥ÙŠØµØ§Ù„.',0),(120198,3339,'fr','Bon sans soupeser. Bon ne pas mis Ã  jour.',0),(120199,3339,'jp','ä¼?ç¥¨ã?Œãƒ?ãƒ©ãƒ³ã‚¹ã?—ã?¾ã?›ã‚“ã€‚ä¼?ç¥¨ã?Œæ›´æ–°ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(120200,3339,'pt','Voucher nÃ£o equilibrar. Voucher nÃ£o atualizado.',0),(120201,3339,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð½Ðµ ÑÐ´ÐµÐ»Ð°Ð» Ð±Ð°Ð»Ð°Ð½Ñ. Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð½Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÑÐµÑ‚ÑÑ.',0),(120202,3339,'es','Voucher no se BalanceÃ³. Voucher no se actualizÃ³',0),(120203,3339,'de','Gutschein nicht ausgeglichen. Gutschein nicht aktualisiert.',0),(120204,3339,'en','Voucher did not balance. Voucher not updated.',0),(120205,3340,'is','',0),(120206,3340,'dr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ  ØªØ±Ø§Ø² Ù†ÙŠØ³Øª ',0),(120207,3340,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ  ØªØ±Ø§Ø² Ù†ÙŠØ³Øª ',0),(120208,3340,'tr','Dengede deÄŸil fiÅŸ',0),(120209,3340,'pl','Kupon nie w rÃ³wnowadze',0),(120210,3340,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð½Ðµ Ð² Ð±Ð°Ð»Ð°Ð½Ñ',0),(120211,3340,'ur','Ù†Û Ù…ÛŒÚº ØªÙˆØ§Ø²Ù† ÙˆØ§Ø¤Ú†Ø±',0),(120212,3340,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð½Ð¸Ñ˜Ðµ Ñƒ Ñ€Ð°Ð²Ð½Ð¾Ñ‚ÐµÐ¶Ñƒ',0),(120213,3340,'vi','Phiáº¿u khÃ´ng cÃ¢n Ä‘á»‘i.',0),(120214,3340,'af','Bewysstuk balanseer nie ',0),(120215,3340,'ro','Bonul nu Ã®n echilibru',0),(120216,3340,'et','VautÅ¡er not in balance',0),(120217,3340,'si','Kupon ni v ravnovesju',0),(120218,3340,'ba','Voucher tidak dalam keseimbangan',0),(120219,3340,'nl','Bon niet in evenwicht',0),(120220,3340,'fi','Tositenumero muussa kuin tasapaino',0),(120221,3340,'no','Bilag ikke i balanse',0),(120222,3340,'da','Voucher ikke i balance',0),(120223,3340,'ko','ê· í˜•ì— ë°”ìš°ì²˜',0),(120224,3340,'he','×”×©×•×‘×¨ ×œ× ×‘××™×–×•×Ÿ',0),(120225,3340,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Î´ÎµÎ½ Î¹ÏƒÎ¿ÏƒÎºÎµÎ»Î¯Î¶Î¿Î½Ï„Î±Î¹',0),(120226,3340,'zh','å‡­å•æœªç»“ä½™',0),(120227,3340,'sv','Kupongen inte i balans',0),(120228,3340,'it','Voucher non in equilibrio',0),(120229,3340,'tl','',0),(120230,3340,'th','&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3652;&#3617;&#3656;&#3604;&#3640;&#3621;',0),(120231,3340,'hi','à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤µà¤¾à¤‰à¤šà¤°',0),(120232,3340,'ms','Baucar tidak dalam kira-kira',0),(120233,3340,'ar','Ø§Ù„Ù‚Ø³ÙŠÙ…Ø© Ù„Ø§ ÙÙŠ Ø§Ù„ØªÙˆØ§Ø²Ù†',0),(120234,3340,'fr','Bon pas dans la balance',0),(120235,3340,'jp','ä¼?ç¥¨ã?Œä¸?å?‡è¡¡ã?§ã?™',0),(120236,3340,'pt','Voucher nÃ£o em equilÃ­brio',0),(120237,3340,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð½Ðµ Ð² Ð±Ð°Ð»Ð°Ð½ÑÐµ',0),(120238,3340,'es','Voucher no se BalanceÃ³',0),(120239,3340,'de','Gutschein nicht im Gleichgewicht',0),(120240,3340,'en','Voucher not in balance',0),(120241,3341,'is','',0),(120242,3341,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(120243,3341,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(120244,3341,'tr','FiÅŸ #',0),(120245,3341,'pl','ZaÅ‚Ä…cznik #',0),(120246,3341,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð¸Ñ‚ÐµÐ» #',0),(120247,3341,'ur','ÙˆØ§Ø¤Ú†Ø± #',0),(120248,3341,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ #',0),(120249,3341,'vi','Phiáº¿u sá»‘',0),(120250,3341,'af','Bewysstuk #',0),(120251,3341,'ro','Voucher #',0),(120252,3341,'et','Dokumendi #',0),(120253,3341,'si','Voucher #',0),(120254,3341,'ba','Voucher #',0),(120255,3341,'nl','Voucher #',0),(120256,3341,'fi','Tosite #',0),(120257,3341,'no','Bilag #',0),(120258,3341,'da','Voucher #',0),(120259,3341,'ko','# ë°”ìš°ì²˜',0),(120260,3341,'he','×©×•×‘×¨ #',0),(120261,3341,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ #',0),(120262,3341,'zh','å‡­å•ï¼ƒ\r\n',0),(120263,3341,'sv','Kupongen #',0),(120264,3341,'it','Giustificativo #',0),(120265,3341,'tl','',0),(120266,3341,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(120267,3341,'hi','à¤µà¤¾à¤‰à¤šà¤° #',0),(120268,3341,'ms','Baucer #',0),(120269,3341,'ar','Ø±Ù‚Ù… Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(120270,3341,'fr','# En chÃ¨ques-cadeaux',0),(120271,3341,'jp','ä¼?ç¥¨ç•ªå?·',0),(120272,3341,'pt','Voucher #',0),(120273,3341,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ #',0),(120274,3341,'es','Voucher #',0),(120275,3341,'de','# Gutschein',0),(120276,3341,'en','Voucher #',0),(120277,3342,'is','',0),(120278,3342,'dr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(120279,3342,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(120280,3342,'tr','FiÅŸ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(120281,3342,'pl','Voucher pomyÅ›lnie zaktualizowana.',0),(120282,3342,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(120283,3342,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Û”',0),(120284,3342,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(120285,3342,'vi','Cáº­p Nháº­t Phiáº¿u thÃ nh cÃ´ng',0),(120286,3342,'af','Bewysstuk suksesvol opdateer.',0),(120287,3342,'ro','Voucher actualizat cu succes.',0),(120288,3342,'et','VautÅ¡eri uuendamine Ãµnnestus!',0),(120289,3342,'si','Kupon je uspeÅ¡no posodobljena.',0),(120290,3342,'ba','Voucher yang berhasil.',0),(120291,3342,'nl','Waardebon bijgewerkt.',0),(120292,3342,'fi','Tosite pÃ¤ivitettiin onnistuneesti.',0),(120293,3342,'no','Bilaget oppdatert.',0),(120294,3342,'da','Voucher opdateret.',0),(120295,3342,'ko','ë°”ìš°ì²˜ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(120296,3342,'he','×©×•×‘×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(120297,3342,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(120298,3342,'zh','å‡­å•å·²æˆåŠŸæ›´æ–°ã€‚\r\n',0),(120299,3342,'sv','Verifikationen uppdaterats.',0),(120300,3342,'it','Voucher Ã¨ aggiornato correttamente.',0),(120301,3342,'tl','',0),(120302,3342,'th','&#3629;&#3633;&#3614;&#3648;&#3604;&#3607;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(120303,3342,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾à¥¤',0),(120304,3342,'ms','Baucar yang berjaya dikemas kini.',0),(120305,3342,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(120306,3342,'fr','Bon, mis Ã  jour avec succÃ¨s.',0),(120307,3342,'jp','ä¼?ç¥¨ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(120308,3342,'pt','Comprovante atualizado com Ãªxito.',0),(120309,3342,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(120310,3342,'es','Voucher actualizado exitosamente',0),(120311,3342,'de','Gutschein wurde erfolgreich aktualisiert.',0),(120312,3342,'en','Voucher updated successfully.',0),(120313,3343,'is','',0),(120314,3343,'dr','Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(120315,3343,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(120316,3343,'tr','FiÅŸler',0),(120317,3343,'pl','Bony',0),(120318,3343,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€Ð¸',0),(120319,3343,'ur','ÙˆØ§Ø¤Ú†Ø±',0),(120320,3343,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€Ð¸',0),(120321,3343,'vi','Phiáº¿u',0),(120322,3343,'af','Bewysstukke',0),(120323,3343,'ro','Vouchere',0),(120324,3343,'et','VautÅ¡erid',0),(120325,3343,'si','Bonov',0),(120326,3343,'ba','Voucher',0),(120327,3343,'nl','Bonnen',0),(120328,3343,'fi','Tositteet',0),(120329,3343,'no','Bilag',0),(120330,3343,'da','Gavekort',0),(120331,3343,'ko','ìƒí’ˆê¶Œ',0),(120332,3343,'he','×©×•×‘×¨×™×',0),(120333,3343,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹Î±',0),(120334,3343,'zh','å‡­å•\r\n',0),(120335,3343,'sv','Kuponger',0),(120336,3343,'it','Voucher',0),(120337,3343,'tl','',0),(120338,3343,'th','&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(120339,3343,'hi','à¤µà¤¾à¤‰à¤šà¤°',0),(120340,3343,'ms','Baucar',0),(120341,3343,'ar','Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª',0),(120342,3343,'fr','PiÃ¨ces justificatives',0),(120343,3343,'jp','ä¼?ç¥¨',0),(120344,3343,'pt','Vouchers',0),(120345,3343,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€Ñ‹',0),(120346,3343,'es','Recibos (Vouchers)',0),(120347,3343,'de','Gutscheine',0),(120348,3343,'en','Vouchers',0),(120349,3344,'is','',0),(120350,3344,'dr','. Ø¨Ù„Ù‡ ',0),(120351,3344,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù¾Ø³Øª Ø´Ø¯Ù‡ . Ø¨Ù„Ù‡ ',0),(120352,3344,'tr','deftere nakledilen fiÅŸleri, tamam.',0),(120353,3344,'pl','bony wysÅ‚any OK.',0),(120354,3344,'bg','Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸ ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾ OK.',0),(120355,3344,'ur','ÙˆØ§Ø¤Ú†Ø± Ù¹Ú¾ÛŒÚ© ÛÛ’ Ù…ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(120356,3344,'sr','Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ Ñƒ Ñ€ÐµÐ´Ñƒ.',0),(120357,3344,'vi','Káº¿t chuyá»ƒn Phiáº¿u OK',0),(120358,3344,'af','bewysstukke gepos OK.',0),(120359,3344,'ro','vouchere postat OK.',0),(120360,3344,'et','VautÅ¡eri postitamine Ãµnnestus.',0),(120361,3344,'si','Bone Objavljeno OK.',0),(120362,3344,'ba','voucher diposting OK.',0),(120363,3344,'nl','bonnen Gepost OK.',0),(120364,3344,'fi','tositteet kirjata OK.',0),(120365,3344,'no','bilag postet OK.',0),(120366,3344,'da','gavekort sendt OK.',0),(120367,3344,'ko','ìƒí’ˆê¶Œ í™•ì¸ ê²Œì‹œ.',0),(120368,3344,'he','×©×•×‘×¨×™× ×¤×•×¨×¡× ××™×©×•×¨.',0),(120369,3344,'el','ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î± Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏ„Î·ÎºÎµ OK.',0),(120370,3344,'zh','ç¡®å®šå‘è¡¨å‡­å•ã€‚\r\n',0),(120371,3344,'sv','kuponger postat OK.',0),(120372,3344,'it','voucher inviato OK.',0),(120373,3344,'tl','',0),(120374,3344,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597; OK',0),(120375,3344,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤ à¥€à¤• à¤ªà¥à¤°à¤•à¤¾à¤¶à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¥à¤¾à¥¤',0),(120376,3344,'ms','baucar posted OK.',0),(120377,3344,'ar','Ù‚Ø³Ø§Ø¦Ù… Ù†Ø´Ø±Øª Ù…ÙˆØ§ÙÙ‚.',0),(120378,3344,'fr','bons PostÃ© OK.',0),(120379,3344,'jp','ä¼?ç¥¨è¨ˆä¸ŠOK',0),(120380,3344,'pt','os vouchers postado OK.',0),(120381,3344,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€Ñ‹ Ð½Ð°Ð¿Ð¸ÑÐ°Ð» ÐžÐš.',0),(120382,3344,'es','recibo asentado OK.',0),(120383,3344,'de','Gutscheine geschrieben OK.',0),(120384,3344,'en','vouchers posted OK.',0),(120385,3345,'is','',0),(120386,3345,'dr','. Ø¨Ù„Ù‡  ',0),(120387,3345,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù…Ø¹ÙƒÙˆØ³ Ø´Ø¯Ù‡ . Ø¨Ù„Ù‡  ',0),(120388,3345,'tr','FiÅŸler OK ters.',0),(120389,3345,'pl','bony odwrÃ³cone OK.',0),(120390,3345,'bg','Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð° ÐžÐš.',0),(120391,3345,'ur','ÙˆØ§Ø¤Ú†Ø± Ù¹Ú¾ÛŒÚ© Ø§Ù„Ù¹ ÛÛ’ Û”',0),(120392,3345,'sr','Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸ Ð¾Ð±Ñ€Ð½ÑƒÑ‚ ÐžÐš.',0),(120393,3345,'vi','Viáº¿t ngÆ°á»£c Phiáº¿u OK',0),(120394,3345,'af','bewyse omgekeer OK.',0),(120395,3345,'ro','vouchere inversat OK.',0),(120396,3345,'et','vouchers reversed OK.',0),(120397,3345,'si','bonov obrnil OK.',0),(120398,3345,'ba','voucher terbalik OK.',0),(120399,3345,'nl','bonnen omgekeerd OK.',0),(120400,3345,'fi','tositteet kÃ¤Ã¤ntÃ¤Ã¤ OK.',0),(120401,3345,'no','bilag reversert OK.',0),(120402,3345,'da','gavekort vendes OK.',0),(120403,3345,'ko','ìƒí’ˆê¶Œ í™•ì¸ ë°˜ì „.',0),(120404,3345,'he','×©×•×‘×¨×™× ×ž×ª×”×¤×š. ×‘×¡×“×¨.',0),(120405,3345,'el','ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î± Î±Î½Ï„Î¹ÏƒÏ„ÏÎ±Ï†ÎµÎ¯ ÎµÎ½Ï„Î¬Î¾ÎµÎ¹.',0),(120406,3345,'zh','ç¡®å®šæ‰­è½¬å‡­å•ã€‚\r\n',0),(120407,3345,'sv','kuponger omvÃ¤nda OK.',0),(120408,3345,'it','voucher invertito OK.',0),(120409,3345,'tl','',0),(120410,3345,'th','&#3606;&#3629;&#3618;&#3585;&#3621;&#3633;&#3610;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597; OK',0),(120411,3345,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤ à¥€à¤• à¤‰à¤²à¤Ÿà¥¤',0),(120412,3345,'ms','baucar diterbalikkan OK.',0),(120413,3345,'ar','Ù‚Ø³Ø§Ø¦Ù… Ø¹ÙƒØ³ Ø·ÙŠØ¨.',0),(120414,3345,'fr','bons inversÃ© OK.',0),(120415,3345,'jp','ä¼?ç¥¨ã‚’å?–ã‚Šæ¶ˆã?—ã?¾ã?—ã?Ÿ',0),(120416,3345,'pt','os vouchers invertida OK.',0),(120417,3345,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€Ñ‹ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ñ‹ ÐžÐš.',0),(120418,3345,'es','vouchers reversados OK',0),(120419,3345,'de','Gutscheine umgekehrt OK.',0),(120420,3345,'en','vouchers reversed OK.',0),(120421,3346,'is','',0),(120422,3346,'dr','W-2',0),(120423,3346,'pr','W-2',0),(120424,3346,'tr','W-2',0),(120425,3346,'pl','W-2',0),(120426,3346,'bg','W-2',0),(120427,3346,'ur','W-2',0),(120428,3346,'sr','W-2',0),(120429,3346,'vi','W-2',0),(120430,3346,'af','W-2',0),(120431,3346,'ro','W-2',0),(120432,3346,'et','*W-2',0),(120433,3346,'si','W-2',0),(120434,3346,'ba','W-2',0),(120435,3346,'nl','W-2',0),(120436,3346,'fi','W-2',0),(120437,3346,'no','W-2',0),(120438,3346,'da','W-2',0),(120439,3346,'ko','W-2',0),(120440,3346,'he','W-2',0),(120441,3346,'el','W-2',0),(120442,3346,'zh','çš„W - 2\r\n',0),(120443,3346,'sv','W-2',0),(120444,3346,'it','W-2',0),(120445,3346,'tl','',0),(120446,3346,'th','W-2',0),(120447,3346,'hi','W-2',0),(120448,3346,'ms','W-2',0),(120449,3346,'ar','Ø«-2',0),(120450,3346,'fr','W-2',0),(120451,3346,'jp','W-2',0),(120452,3346,'pt','W-2',0),(120453,3346,'ru','W-2',0),(120454,3346,'es','W-2',0),(120455,3346,'de','W-2',0),(120456,3346,'en','W-2',0),(120457,3347,'is','',0),(120458,3347,'dr','W-2 Ø¢Ø¯Ø±Ø³ 1 ',0),(120459,3347,'pr','W-2 Ø¢Ø¯Ø±Ø³ 1 ',0),(120460,3347,'tr','W-2 adresi 1',0),(120461,3347,'pl','Adres W 2 1',0),(120462,3347,'bg','W-2 Ð°Ð´Ñ€ÐµÑ 1',0),(120463,3347,'ur','W-2 Ù¾ØªØ§ 1',0),(120464,3347,'sr','W -2 Ð°Ð´Ñ€ÐµÑÐ° 1',0),(120465,3347,'vi','W-2 Ä‘á»‹a chá»‰ 1',0),(120466,3347,'af','W-2 adres 1',0),(120467,3347,'ro','W-2 adresa 1',0),(120468,3347,'et','W-2 Aadress 1',0),(120469,3347,'si','W-2 naslov 1',0),(120470,3347,'ba','Alamat W-2 1',0),(120471,3347,'nl','W-2 adres 1',0),(120472,3347,'fi','W-2 osoite 1',0),(120473,3347,'no','W-2 adresse 1',0),(120474,3347,'da','W-2 adresse 1',0),(120475,3347,'ko','W-2 ì£¼ì†Œ 1',0),(120476,3347,'he','W-2 ×›×ª×•×‘×ª 1',0),(120477,3347,'el','W-2 Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· 1',0),(120478,3347,'zh','W - 2åœ°å€1\r\n',0),(120479,3347,'sv','Adress: W-2 1',0),(120480,3347,'it','W-2 indirizzo 1',0),(120481,3347,'tl','',0),(120482,3347,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656; 1 W-2 ',0),(120483,3347,'hi','W-2 à¤ªà¤¤à¤¾ 1',0),(120484,3347,'ms','W-2 alamat 1',0),(120485,3347,'ar','Ø«-2 Ø§Ù„Ø¹Ù†ÙˆØ§Ù† 1',0),(120486,3347,'fr','W-2 adresse 1',0),(120487,3347,'jp','W-2ã€€ä½?æ‰€ï¼‘',0),(120488,3347,'pt','W-2 endereÃ§o 1',0),(120489,3347,'ru','W-2 Ð°Ð´Ñ€ÐµÑ 1',0),(120490,3347,'es','W-2 DirecciÃ³n 1',0),(120491,3347,'de','W-2 Adresse 1',0),(120492,3347,'en','W-2 Address 1',0),(120493,3348,'is','',0),(120494,3348,'dr','W-2 Ø¢Ø¯Ø±Ø³ 2 ',0),(120495,3348,'pr','W-2 Ø¢Ø¯Ø±Ø³ 2 ',0),(120496,3348,'tr','W-2 adresi 2',0),(120497,3348,'pl','Adres W-2 2',0),(120498,3348,'bg','W-2 Ð°Ð´Ñ€ÐµÑ 2',0),(120499,3348,'ur','W-2 Ù¾ØªÛ’ 2',0),(120500,3348,'sr','W -2 Ð°Ð´Ñ€ÐµÑÐ° 2',0),(120501,3348,'vi','W-2 Ä‘á»‹a chá»‰ 2',0),(120502,3348,'af','W-2 adres 2',0),(120503,3348,'ro','W-2 adresa 2',0),(120504,3348,'et','W-2 Aadress 2',0),(120505,3348,'si','W-2 naslov 2',0),(120506,3348,'ba','Alamat W-2 2',0),(120507,3348,'nl','W-2 adres 2',0),(120508,3348,'fi','W-2 osoite 2',0),(120509,3348,'no','W-2 adresse 2',0),(120510,3348,'da','W-2 adresse 2',0),(120511,3348,'ko','W-2 ì£¼ì†Œ 2',0),(120512,3348,'he','W-2 ×›×ª×•×‘×ª 2',0),(120513,3348,'el','W-2 Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· 2',0),(120514,3348,'zh','W - 2åœ°å€2\r\n',0),(120515,3348,'sv','Adress: W-2 2',0),(120516,3348,'it','W-2 indirizzo 2',0),(120517,3348,'tl','',0),(120518,3348,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656; 2 W-2 ',0),(120519,3348,'hi','W-2 à¤ªà¤¤à¤¾ 2',0),(120520,3348,'ms','W-2 alamat 2',0),(120521,3348,'ar','Ø«-2 Ø§Ù„Ø¹Ù†ÙˆØ§Ù† 2',0),(120522,3348,'fr','W-2 adresse 2',0),(120523,3348,'jp','W-2ã€€ä½?æ‰€ï¼’',0),(120524,3348,'pt','W-2 endereÃ§o 2',0),(120525,3348,'ru','W-2 Ð°Ð´Ñ€ÐµÑ 2',0),(120526,3348,'es','W-2 DirecciÃ³n 2',0),(120527,3348,'de','W-2-Adresse 2',0),(120528,3348,'en','W-2 Address 2',0),(120529,3349,'is','',0),(120530,3349,'dr','W-2 Ø´Ù‡Ø± â€“ÙˆÙ„Ø§ÛŒØª - Ú©ÙˆØ¯ Ù¾Ø³ØªÙŠ',0),(120531,3349,'pr','W-2 Ø´Ù‡Ø± â€“Ø§Ø³ØªØ§Ù†- ÙƒØ¯ Ù¾Ø³ØªÙŠ',0),(120532,3349,'tr','W-2 ÅŸehir, eyalet & ZIP',0),(120533,3349,'pl','Miasta W-2, stan & Zip',0),(120534,3349,'bg','W-2 Ð³Ñ€Ð°Ð´, Ð´ÑŠÑ€Ð¶Ð°Ð²Ð° & Zip',0),(120535,3349,'ur','W-2 Ø´ÛØ±ØŒ Ø±ÛŒØ§Ø³Øª & Ø²Ù¾',0),(120536,3349,'sr','W -2 Ð³Ñ€Ð°Ð´Ð°, Ð´Ñ€Ð¶Ð°Ð²Ðµ & Ð—Ð¸Ð¿',0),(120537,3349,'vi','W-2 thÃ nh phá»‘, bang & Zip',0),(120538,3349,'af','W-2 Stad, staat & ritssluiter',0),(120539,3349,'ro','W-2 oraÅŸ, stat & Zip',0),(120540,3349,'et','W-2 Linn, Maakond & Zip',0),(120541,3349,'si','W-2 mesto, drÅ¾ava & Zip',0),(120542,3349,'ba','W-2 kota, negara & Zip',0),(120543,3349,'nl','W-2 stad, staat & Zip',0),(120544,3349,'fi','W-2 kaupungin, valtion & Zip',0),(120545,3349,'no','W-2 byen, staten & Zip',0),(120546,3349,'da','W-2 City, staten & Zip',0),(120547,3349,'ko','W-2 ì‹œ, êµ­ê°€ & Zip',0),(120548,3349,'he','W-2 ×¢×™×¨, ×ž×“×™× ×” & Zip',0),(120549,3349,'el','W-2 Ï€ÏŒÎ»Î·, ÎºÏÎ¬Ï„Î¿Ï‚ & Zip',0),(120550,3349,'zh','W -2å¸‚ï¼Œå›½å®¶å’Œé‚®æ”¿ç¼–ç \r\n',0),(120551,3349,'sv','W-2 staden, staten & Zip',0),(120552,3349,'it','W-2 cittÃ , stato & Zip',0),(120553,3349,'tl','',0),(120554,3349,'th','&#3648;&#3617;&#3639;&#3629;&#3591; W-2,&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604; &#3649;&#3621;&#3632;&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;',0),(120555,3349,'hi','W-2 à¤¶à¤¹à¤°, à¤°à¤¾à¤œà¥à¤¯ & à¤œà¤¼à¤¿à¤ª',0),(120556,3349,'ms','W-2 bandar, Negeri & Zip',0),(120557,3349,'ar','Ø«-2 Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©ØŒ ÙˆØ§Ù„Ø¯ÙˆÙ„Ø© Ø¢Ù†Ø¯ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(120558,3349,'fr','W-2 ville, Ã©tat & Zip',0),(120559,3349,'jp','W-2ã€€å¸‚ç”ºæ?‘ã€?éƒ½é?“åºœçœŒã€?éƒµä¾¿ç•ªå?·',0),(120560,3349,'pt','W-2, cidade, estado & Zip',0),(120561,3349,'ru','W-2 Ð³Ð¾Ñ€Ð¾Ð´Ð°, Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð° & Zip',0),(120562,3349,'es','W-2 Ciudad, Estado & CÃ³digo Postal',0),(120563,3349,'de','W-2-City, State & Zip',0),(120564,3349,'en','W-2 City, State & Zip',0),(120565,3350,'is','',0),(120566,3350,'dr','W-2 Ù†Ø§Ù… Ø´Ø±ÙƒØª ',0),(120567,3350,'pr','W-2 Ù†Ø§Ù… Ø´Ø±ÙƒØª ',0),(120568,3350,'tr','W-2 ÅŸirket adÄ±',0),(120569,3350,'pl','Nazwa firmy W-2',0),(120570,3350,'bg','W-2 Ñ„Ð¸Ñ€Ð¼Ð°',0),(120571,3350,'ur','W-2 Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù…',0),(120572,3350,'sr','Ð˜Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ W-2',0),(120573,3350,'vi','W-2 TÃªn Cty',0),(120574,3350,'af','W-2 Ondernemingnaam',0),(120575,3350,'ro','Numele companiei W-2',0),(120576,3350,'et','W-2 EttevÃµtte nimi',0),(120577,3350,'si','Ime podjetja W-2',0),(120578,3350,'ba','Nama perusahaan W-2',0),(120579,3350,'nl','W-2 bedrijfsnaam',0),(120580,3350,'fi','W-2 yrityksen nimi',0),(120581,3350,'no','W-2 firmanavn',0),(120582,3350,'da','W-2 firmanavn',0),(120583,3350,'ko','W-2 ì‚¬ëª…',0),(120584,3350,'he','×©× ×”×—×‘×¨×” W-2',0),(120585,3350,'el','Î•Ï€Ï‰Î½Ï…Î¼Î¯Î± W-2',0),(120586,3350,'zh','W - 2å…¬å¸åç§°\r\n',0),(120587,3350,'sv','W-2 fÃ¶retagets namn',0),(120588,3350,'it','Nome azienda W-2',0),(120589,3350,'tl','',0),(120590,3350,'th','&#3594;&#3639;&#3656;&#3629;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607; W-2',0),(120591,3350,'hi','W-2 à¤•à¤‚à¤ªà¤¨à¥€ à¤¨à¤¾à¤®',0),(120592,3350,'ms','Nama Syarikat W-2',0),(120593,3350,'ar','Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© 2 Ø«',0),(120594,3350,'fr','Nom de la sociÃ©tÃ© W-2',0),(120595,3350,'jp','W-2ã€€ä¼šç¤¾å??',0),(120596,3350,'pt','Nome da empresa W-2',0),(120597,3350,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ W-2',0),(120598,3350,'es','W-2 Nombre de Empresa',0),(120599,3350,'de','W-2-Firmennamen',0),(120600,3350,'en','W-2 Company Name',0),(120601,3351,'is','',0),(120602,3351,'dr','W-2 Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú†Ù‡ Ø¬Ø¹Ø¨Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø·Ø±Ø­ØŸ',0),(120603,3351,'pr','W-2 Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú†Ù‡ Ø¬Ø¹Ø¨Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø·Ø±Ø­ØŸ',0),(120604,3351,'tr','W-2 kullanmak iÃ§in plan iletiÅŸim kutusuna?',0),(120605,3351,'pl','W-2 UÅ¼yj polu planu?',0),(120606,3351,'bg','W-2 Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ Ð¿Ð¾Ð»ÐµÑ‚Ð¾ Ð·Ð° Ð¿Ð»Ð°Ð½?',0),(120607,3351,'ur','W-2 Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ø®Ø§Ù†ÛØŸ',0),(120608,3351,'sr','W -2 ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ ÐºÐ°ÐºÐ¾ Ñƒ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ Ð·Ð° Ð¿Ð»Ð°Ð½?',0),(120609,3351,'vi','W2 chá»‰nh sá»­a há»™p nÃ o Ä‘á»ƒ Ä‘áº·t káº¿ hoáº¡ch',0),(120610,3351,'af','W-2 gebruik wat box vir plan?',0),(120611,3351,'ro','W-2 utilizaÅ£i ceea ce caseta pentru planul?',0),(120612,3351,'et','*W-2 use what box for plan?',0),(120613,3351,'si','W-2 uporabite polju za naÄrt?',0),(120614,3351,'ba','W-2 menggunakan apa box untuk rencana?',0),(120615,3351,'nl','W-2 gebruiken vak voor plan?',0),(120616,3351,'fi','W-2 kÃ¤yttÃ¤Ã¤ ruudussa suunnitelma?',0),(120617,3351,'no','W-2 bruke gjenkjent for planen?',0),(120618,3351,'da','W-2 bruge boksen til planen?',0),(120619,3351,'ko','W-2 ë‚´ìš© ê³„íšì— ëŒ€ í•œ ìƒìžë¥¼ ì‚¬ìš© í•˜ ì—¬?',0),(120620,3351,'he','W-2 ×œ×”×©×ª×ž×© ×ž×” ×”×ª×™×‘×” ×¢×‘×•×¨ ×ª×•×›× ×™×ª?',0),(120621,3351,'el','W-2 Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ Î³Î¹Î± Ï„Î¿ ÏƒÏ‡Î­Î´Î¹Î¿;',0),(120622,3351,'zh','W - 2è®¡åˆ’ä½¿ç”¨å“ªä¸ªæ¡†ï¼Ÿ\r\n',0),(120623,3351,'sv','W-2 anvÃ¤nda rutan fÃ¶r plan?',0),(120624,3351,'it','W-2 utilizzare cosa box per piano?',0),(120625,3351,'tl','',0),(120626,3351,'th','&#3651;&#3594;&#3657;&#3585;&#3621;&#3656;&#3629;&#3591; W-2 &#3629;&#3632;&#3652;&#3619;&#3648;&#3614;&#3639;&#3656;&#3629;&#3623;&#3634;&#3591;&#3649;&#3612;&#3609;?',0),(120627,3351,'hi','W-2 à¤•à¥à¤¯à¤¾ à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥‰à¤•à¥à¤¸ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚?',0),(120628,3351,'ms','W-2 menggunakan apa kotak pelan?',0),(120629,3351,'ar','Ø«-2 Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…Ø±Ø¨Ø¹ Ù„Ù„Ø®Ø·Ø©ØŸ',0),(120630,3351,'fr','W-2 utiliser la zone de plan ?',0),(120631,3351,'jp','ã?“ã?®ãƒ—ãƒ©ãƒ³ã?«ã?¯ï¼·-ï¼’ã?®ã?©ã?®ãƒœãƒƒã‚¯ã‚¹ã‚’ä½¿ç”¨ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(120632,3351,'pt','W-2 usar o caixa para o plano?',0),(120633,3351,'ru','W-2 Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð¾Ð»Ðµ Ð´Ð»Ñ Ð¿Ð»Ð°Ð½Ð°?',0),(120634,3351,'es','W-2 usar esa caja para el plan',0),(120635,3351,'de','Verwenden W-2, was fÃ¼r Plan-box?',0),(120636,3351,'en','W-2 use what box for plan?',0),(120637,3352,'is','',0),(120638,3352,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯',0),(120639,3352,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯',0),(120640,3352,'tr','Ãœcretler',0),(120641,3352,'pl','PÅ‚ace',0),(120642,3352,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(120643,3352,'ur','Ø§Ø¬Ø±Øª',0),(120644,3352,'sr','ÐŸÐ»Ð°Ñ‚Ðµ',0),(120645,3352,'vi','LÆ°Æ¡ng',0),(120646,3352,'af','Besoldigings',0),(120647,3352,'ro','Salarii',0),(120648,3352,'et','Palgad',0),(120649,3352,'si','PlaÄe',0),(120650,3352,'ba','Upah',0),(120651,3352,'nl','Lonen',0),(120652,3352,'fi','Palkat',0),(120653,3352,'no','LÃ¸nn',0),(120654,3352,'da','LÃ¸n',0),(120655,3352,'ko','ìž„ê¸ˆ',0),(120656,3352,'he','×©×›×¨',0),(120657,3352,'el','ÎœÎ¹ÏƒÎ¸Î¿Î¯',0),(120658,3352,'zh','å·¥èµ„\r\n',0),(120659,3352,'sv','LÃ¶ner',0),(120660,3352,'it','Salari',0),(120661,3352,'tl','',0),(120662,3352,'th','&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;',0),(120663,3352,'hi','à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(120664,3352,'ms','Upah',0),(120665,3352,'ar','Ø§Ù„Ø£Ø¬ÙˆØ±',0),(120666,3352,'fr','Salaires',0),(120667,3352,'jp','è³ƒé‡‘',0),(120668,3352,'pt','SalÃ¡rios',0),(120669,3352,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(120670,3352,'es','Sueldos',0),(120671,3352,'de','LÃ¶hne',0),(120672,3352,'en','Wages',0),(120673,3353,'is','',0),(120674,3353,'dr','Ø§Ù†ØªØ¸Ø§Ø± ',0),(120675,3353,'pr','Ø§Ù†ØªØ¸Ø§Ø± ',0),(120676,3353,'tr','Bekleyen',0),(120677,3353,'pl','Czekam',0),(120678,3353,'bg','Ð˜Ð·Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ',0),(120679,3353,'ur','Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ø±',0),(120680,3353,'sr','Ð§ÐµÐºÐ°',0),(120681,3353,'vi','Chá»',0),(120682,3353,'af','Wagtend',0),(120683,3353,'ro','ÃŽn aÅŸteptare',0),(120684,3353,'et','Ootel',0),(120685,3353,'si','ÄŒaka',0),(120686,3353,'ba','Menunggu',0),(120687,3353,'nl','Wachten',0),(120688,3353,'fi','Odottaa',0),(120689,3353,'no','Venter',0),(120690,3353,'da','Venter',0),(120691,3353,'ko','ëŒ€ê¸°',0),(120692,3353,'he','×ž×—×›×”',0),(120693,3353,'el','Î‘Î½Î±Î¼Î¿Î½Î®',0),(120694,3353,'zh','ç­‰å¾…\r\n',0),(120695,3353,'sv','VÃ¤ntar pÃ¥',0),(120696,3353,'it','In attesa',0),(120697,3353,'tl','',0),(120698,3353,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3619;&#3629;&#3626;&#3633;&#3585;&#3588;&#3619;&#3641;&#3656;',0),(120699,3353,'hi','à¤‡à¤‚à¤¤à¤œà¤¼à¤¾à¤° à¤•à¤° à¤°à¤¹à¤¾',0),(120700,3353,'ms','Menunggu',0),(120701,3353,'ar','ÙÙŠ Ø§Ù†ØªØ¸Ø§Ø±',0),(120702,3353,'fr','En attente',0),(120703,3353,'jp','å¾…æ©Ÿ',0),(120704,3353,'pt','Ã€ espera',0),(120705,3353,'ru','ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ðµ',0),(120706,3353,'es','Esperando',0),(120707,3353,'de','Warten',0),(120708,3353,'en','Waiting',0),(120709,3354,'is','',0),(120710,3354,'dr','Ø¢Ø¯Ø±Ø³ ÙˆØ¨ ',0),(120711,3354,'pr','Ø¢Ø¯Ø±Ø³ ÙˆØ¨ ',0),(120712,3354,'tr','Web adresi',0),(120713,3354,'pl','Adres sieci Web',0),(120714,3354,'bg','Ð£ÐµÐ± Ð°Ð´Ñ€ÐµÑ',0),(120715,3354,'ur','ÙˆÛŒØ¨ Ù¾ØªÛ',0),(120716,3354,'sr','WÐµÐ± Ð°Ð´Ñ€ÐµÑÐ°',0),(120717,3354,'vi','Äá»‹a chá»‰ Web',0),(120718,3354,'af','Web Adres',0),(120719,3354,'ro','Adresa de web',0),(120720,3354,'et','Veebiaadress',0),(120721,3354,'si','Spletni naslov',0),(120722,3354,'ba','Alamat web',0),(120723,3354,'nl','Webadres',0),(120724,3354,'fi','Www-osoite',0),(120725,3354,'no','Web-adresse',0),(120726,3354,'da','Web-adresse',0),(120727,3354,'ko','ì›¹ ì£¼ì†Œ',0),(120728,3354,'he','×›×ª×•×‘×ª ××™× ×˜×¨× ×˜',0),(120729,3354,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Web',0),(120730,3354,'zh','ç½‘å€\r\n',0),(120731,3354,'sv','Webbadress',0),(120732,3354,'it','Indirizzo Web',0),(120733,3354,'tl','',0),(120734,3354,'th','URL',0),(120735,3354,'hi','à¤µà¥‡à¤¬ à¤ªà¤¤à¥‡',0),(120736,3354,'ms','Alamat web',0),(120737,3354,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø¨ÙƒØ© Ø§Ù„Ø¹Ù†ÙƒØ¨ÙˆØªÙŠØ©',0),(120738,3354,'fr','Adresse Web',0),(120739,3354,'jp','ã‚¦ã‚§ãƒ–ã‚¢ãƒ‰ãƒ¬ã‚¹',0),(120740,3354,'pt','EndereÃ§o Web',0),(120741,3354,'ru','Ð’ÑÐ± ÐÐ´Ñ€ÐµÑ',0),(120742,3354,'es','DirecciÃ³n Web',0),(120743,3354,'de','Web-Adresse',0),(120744,3354,'en','Web Address',0),(120745,3355,'is','',0),(120746,3355,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª',0),(120747,3355,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª',0),(120748,3355,'tr','Web sitesi',0),(120749,3355,'pl','Witryna sieci Web',0),(120750,3355,'bg','Ð£ÐµÐ± ÑÐ°Ð¹Ñ‚',0),(120751,3355,'ur','ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹',0),(120752,3355,'sr','WÐµÐ± Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(120753,3355,'vi','Trang Web',0),(120754,3355,'af','Webwerf',0),(120755,3355,'ro','Site-ul web',0),(120756,3355,'et','Veebileht',0),(120757,3355,'si','Spletno mesto',0),(120758,3355,'ba','Situs web',0),(120759,3355,'nl','Web Site',0),(120760,3355,'fi','Web-sivusto',0),(120761,3355,'no','WebomrÃ¥de',0),(120762,3355,'da','Web Site',0),(120763,3355,'ko','ì›¹ ì‚¬ì´íŠ¸',0),(120764,3355,'he','××ª×¨ ××™× ×˜×¨× ×˜',0),(120765,3355,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Web',0),(120766,3355,'zh','ç½‘ç«™\r\n',0),(120767,3355,'sv','Webbplats',0),(120768,3355,'it','Sito Web',0),(120769,3355,'tl','',0),(120770,3355,'th','&#3648;&#3623;&#3655;&#3611;&#3652;&#3595;&#3604;&#3660;',0),(120771,3355,'hi','à¤µà¥‡à¤¬ à¤¸à¤¾à¤‡à¤Ÿ',0),(120772,3355,'ms','Laman web',0),(120773,3355,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø¨ÙƒØ© Ø§Ù„Ø¹Ù†ÙƒØ¨ÙˆØªÙŠØ©',0),(120774,3355,'fr','Site Web',0),(120775,3355,'jp','ã‚¦ã‚§ãƒ–ã‚µã‚¤ãƒˆ',0),(120776,3355,'pt','Web Site',0),(120777,3355,'ru','Ð’ÐµÐ±-ÑÐ°Ð¹Ñ‚',0),(120778,3355,'es','Sitio Web',0),(120779,3355,'de','Website',0),(120780,3355,'en','Web Site',0),(120781,3356,'is','',0),(120782,3356,'dr','ÙØ±ÙˆØ´Ú¯Ø§Ù‡ ÙˆØ¨ Ø§Ø² Ø¬Ø¯ÙˆÙ„ Ø­Ø°Ù Ø´Ø¯',0),(120783,3356,'pr','ÙØ±ÙˆØ´Ú¯Ø§Ù‡ ÙˆØ¨ Ø§Ø² Ø¬Ø¯ÙˆÙ„ Ø­Ø°Ù Ø´Ø¯',0),(120784,3356,'tr','Webshop tablo <B>modÃ¼lleri</B> kaldÄ±rÄ±ldÄ±',0),(120785,3356,'pl','Sklep internetowy usuniÄ™te z tabela <B>moduÅ‚Ã³w</B>',0),(120786,3356,'bg','ÐžÐ½Ð»Ð°Ð¹Ð½ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½, Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸ Ð¾Ñ‚ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð° <B>Ð¼Ð¾Ð´ÑƒÐ»Ð¸</B>',0),(120787,3356,'ur','ÙˆÛŒØ¨Ø´ÙˆÙ¾ Ù¹ÛŒØ¨Ù„ <B>Ù…Ø§ÚˆÛŒÙˆÙ„</B> Ø³Û’ ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(120788,3356,'sr','ÐžÐ½Ð»Ð¸Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð½Ð¸Ñ†Ð° Ñ˜Ðµ ÑƒÐºÐ»Ð¾ÑšÐµÐ½ Ð¸Ð· Ñ‚Ð°Ð±ÐµÐ»Ðµ <B>Ð¼Ð¾Ð´ÑƒÐ»Ð¸</B>',0),(120789,3356,'vi','Bá» webshop tá»« báº£ng <B>modules</B>',0),(120790,3356,'af','Webwinkel verwyder vanuit tabel<B>modules</B>',0),(120791,3356,'ro','Webshop eliminate din tabelul <B>module</B>',0),(120792,3356,'et','Veebipood on eemaldatud tabelist<B>modules</B>',0),(120793,3356,'si','Webshop odstranjena iz tabele <B>modulov</B>',0),(120794,3356,'ba','Webshop dihapus dari tabel <B>modul</B>',0),(120795,3356,'nl','Webshop verwijderd uit de tabel <B>modules</B>',0),(120796,3356,'fi','WebShop poistaa taulukon <B>moduulit</B>',0),(120797,3356,'no','Nettbutikk fjernet fra tabellen <B>moduler</B>',0),(120798,3356,'da','Webshop fjernet fra bordet <B>moduler</B>',0),(120799,3356,'ko','Webshopì—ì„œ í…Œì´ë¸” <B>ëª¨ë“ˆ</B> ì œê±°',0),(120800,3356,'he','Webshop ×œ×”×¡×™×¨ ×˜×‘×œ×” <B>×ž×•×“×•×œ×™×</B>',0),(120801,3356,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯ Î±Ï€ÏŒ Ï€Î¯Î½Î±ÎºÎ±Ï‚ <B>ÎµÎ½ÏŒÏ„Î·Ï„ÎµÏ‚</B>',0),(120802,3356,'zh','ä»Žè¡¨ä¸­åˆ é™¤ç½‘ä¸Šå•†åº—çš„<b>æ¨¡å—\r\n',0),(120803,3356,'sv','Webshop bort frÃ¥n tabellen <B>moduler</B>',0),(120804,3356,'it','Webshop rimosso dalla tabella <B>moduli</B>',0),(120805,3356,'tl','',0),(120806,3356,'th','&#3619;&#3657;&#3634;&#3609;&#3588;&#3657;&#3634;&#3607;&#3634;&#3591;&#3648;&#3623;&#3655;&#3611;&#3652;&#3595;&#3604;&#3660;&#3606;&#3641;&#3585;&#3621;&#3610;&#3592;&#3634;&#3585;&#3605;&#3634;&#3619;&#3634;&#3591; <B>&#3650;&#3617;&#3604;&#3641;&#3621',0),(120807,3356,'hi','Webshop à¤¤à¤¾à¤²à¤¿à¤•à¤¾ <B>à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤²</B> à¤¸à¥‡ à¤¨à¤¿à¤•à¤¾à¤² à¤¦à¤¿à¤¯à¤¾',0),(120808,3356,'ms','Webshop dikeluarkan dari jadual <B>modul</B>',0),(120809,3356,'ar','Webshop Ø¥Ø²Ø§Ù„ØªÙ‡Ø§ Ù…Ù† Ø§Ù„Ø¬Ø¯ÙˆÙ„ <B>Ø§Ù„ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù†Ù…Ø·ÙŠØ©</B>',0),(120810,3356,'fr','Boutique en ligne supprimÃ©e de <B>modules</B> de la table',0),(120811,3356,'jp','è¡¨ <B>ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«</B>ã?‹ã‚‰ã‚¦ã‚§ãƒ–ã‚·ãƒ§ãƒƒãƒ—ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(120812,3356,'pt','Webshop removido da tabela <B>mÃ³dulos</B>',0),(120813,3356,'ru','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚-Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹ Ð¸Ð· Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ <B>Ð¼Ð¾Ð´ÑƒÐ»ÐµÐ¹</B>',0),(120814,3356,'es','Tienda de Web se quitÃ³ de la tabla<B>mÃ³dulos</B>',0),(120815,3356,'de','Webshop entfernt aus Tabelle <B>Module</B>',0),(120816,3356,'en','Webshop removed from table <B>modules</B>',0),(120817,3357,'is','',0),(120818,3357,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ±ÙˆØ´Ú¯Ø§Ù‡ ÙˆØ¨',0),(120819,3357,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ±ÙˆØ´Ú¯Ø§Ù‡ ÙˆØ¨',0),(120820,3357,'tr','Webshop Kur',0),(120821,3357,'pl','Ustawienia sklepu internetowego',0),(120822,3357,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¾Ð½Ð»Ð°Ð¹Ð½ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½',0),(120823,3357,'ur','ÙˆÛŒØ¨Ø´ÙˆÙ¾ Ø³ÛŒÙ¹ Ø§Ù¾',0),(120824,3357,'sr','ÐžÐ½Ð»Ð¸Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð½Ð¸Ñ†Ð° ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(120825,3357,'vi','Setup Webshop',0),(120826,3357,'af','Webwinkel Opstelling',0),(120827,3357,'ro','Webshop Setup',0),(120828,3357,'et','Veebipoe seadistamine',0),(120829,3357,'si','Internetna trgovina Setup',0),(120830,3357,'ba','Webshop Setup',0),(120831,3357,'nl','Webshop installatie',0),(120832,3357,'fi','Verkkokaupan asennus',0),(120833,3357,'no','WebShop-oppsett',0),(120834,3357,'da','OpsÃ¦tning af webshop',0),(120835,3357,'ko','Webshop ì„¤ì¹˜',0),(120836,3357,'he','×”×’×“×¨×ª Webshop',0),(120837,3357,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(120838,3357,'zh','ç½‘ä¸Šå•†åº—è®¾ç½®\r\n',0),(120839,3357,'sv','Webshop Setup',0),(120840,3357,'it','Webshop Setup',0),(120841,3357,'tl','',0),(120842,3357,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3619;&#3657;&#3634;&#3609;&#3588;&#3657;&#3634;&#3607;&#3634;&#3591;&#3648;&#3623;&#3655;&#3611;&#3652;&#3595;&#3604;&#3660;',0),(120843,3357,'hi','Webshop à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(120844,3357,'ms','Persediaan Webshop',0),(120845,3357,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Webshop',0),(120846,3357,'fr','Configuration de la boutique en ligne',0),(120847,3357,'jp','ã‚¦ã‚§ãƒ–ã‚·ãƒ§ãƒƒãƒ—ã?®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(120848,3357,'pt','InstalaÃ§Ã£o de loja virtual',0),(120849,3357,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Web ÐœÐ°Ð³Ð°Ð·Ð¸Ð½Ð°',0),(120850,3357,'es','ConfiguraciÃ³n de Tienda de Web',0),(120851,3357,'de','Webshop-Setup',0),(120852,3357,'en','Webshop Setup',0),(120853,3358,'is','',0),(120854,3358,'dr','Ù‡ÙØªÙ‡ ',0),(120855,3358,'pr','Ù‡ÙØªÙ‡ ',0),(120856,3358,'tr','Hafta',0),(120857,3358,'pl','TydzieÅ„',0),(120858,3358,'bg','Ð¡ÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(120859,3358,'ur','ÛÙØªÛ',0),(120860,3358,'sr','ÐÐµÐ´ÐµÑ™Ñƒ Ð´Ð°Ð½Ð°',0),(120861,3358,'vi','Tuáº§n',0),(120862,3358,'af','Week',0),(120863,3358,'ro','SÄƒptÄƒmÃ¢na',0),(120864,3358,'et','NÃ¤dal',0),(120865,3358,'si','Teden',0),(120866,3358,'ba','Minggu',0),(120867,3358,'nl','Week',0),(120868,3358,'fi','Viikko',0),(120869,3358,'no','Uke',0),(120870,3358,'da','Uge',0),(120871,3358,'ko','ì£¼',0),(120872,3358,'he','×©×‘×•×¢',0),(120873,3358,'el','Î•Î²Î´Î¿Î¼Î¬Î´Î±',0),(120874,3358,'zh','å‘¨\r\n',0),(120875,3358,'sv','Vecka',0),(120876,3358,'it','Settimana',0),(120877,3358,'tl','',0),(120878,3358,'th','&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(120879,3358,'hi','à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(120880,3358,'ms','Minggu',0),(120881,3358,'ar','Ø£Ø³Ø¨ÙˆØ¹',0),(120882,3358,'fr','Semaine',0),(120883,3358,'jp','é€±',0),(120884,3358,'pt','Semana',0),(120885,3358,'ru','ÐÐµÐ´ÐµÐ»Ñ',0),(120886,3358,'es','Semana',0),(120887,3358,'de','Woche',0),(120888,3358,'en','Week',0),(120889,3359,'is','',0),(120890,3359,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù‡ÙØªÚ¯ÙŠ',0),(120891,3359,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù‡ÙØªÚ¯ÙŠ',0),(120892,3359,'tr','HaftalÄ±k Amt',0),(120893,3359,'pl','Cotygodniowe Amt',0),(120894,3359,'bg','Ð¡ÐµÐ´Ð¼Ð¸Ñ‡ÐµÐ½ Amt',0),(120895,3359,'ur','ÛÙØªÛ ÙˆØ§Ø± Ø§Ù…Ù¹',0),(120896,3359,'sr','Ð¡ÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð¸ Ð Ð•Ð¤. Ð’Ð°Ð».',0),(120897,3359,'vi','Sá»‘ tiá»n tuáº§n',0),(120898,3359,'af','Weeklikse Bedr.',0),(120899,3359,'ro','SÄƒptÄƒmÃ¢nal Amt',0),(120900,3359,'et','nÃ¤dalane kogus',0),(120901,3359,'si','Tedenski Amt',0),(120902,3359,'ba','Mingguan Amt',0),(120903,3359,'nl','Per Amt',0),(120904,3359,'fi','Weekly Amt',0),(120905,3359,'no','Ukentlig Amt',0),(120906,3359,'da','Ugentlige Amt',0),(120907,3359,'ko','ì£¼ê°„ Amt',0),(120908,3359,'he','Amt ×©×‘×•×¢×™',0),(120909,3359,'el','Î•Î²Î´Î¿Î¼Î±Î´Î¹Î±Î¯Î± Amt',0),(120910,3359,'zh','æ¯å‘¨é‡‘é¢\r\n\r\n',0),(120911,3359,'sv','Veckovisa Amt',0),(120912,3359,'it','Download Amt',0),(120913,3359,'tl','',0),(120914,3359,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3619;&#3634;&#3618;&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(120915,3359,'hi','à¤¸à¤¾à¤ªà¥à¤¤à¤¾à¤¹à¤¿à¤• Amt',0),(120916,3359,'ms','Amt mingguan',0),(120917,3359,'ar','Ø§Ù„Ù‚Ø¶Ø§Ø© Ø§Ù„ØªÙˆÙ†Ø³ÙŠÙŠÙ† Ø§Ù„ØªÙ†Ø²ÙŠÙ„Ø§Øª',0),(120918,3359,'fr','Amt hebdomadaire',0),(120919,3359,'jp','é€±é–“ç·?é¡?',0),(120920,3359,'pt','Amt semanal',0),(120921,3359,'ru','Ð—Ð° Amt',0),(120922,3359,'es','Cant. Semanalmente',0),(120923,3359,'de','WÃ¶chentliche Amt',0),(120924,3359,'en','Weekly Amt',0),(120925,3360,'is','',0),(120926,3360,'dr','ÙˆØ²Ù† ',0),(120927,3360,'pr','ÙˆØ²Ù† ',0),(120928,3360,'tr','AÄŸÄ±rlÄ±k',0),(120929,3360,'pl','Waga',0),(120930,3360,'bg','Ð¢ÐµÐ³Ð»Ð¾',0),(120931,3360,'ur','ÙˆØ²Ù†',0),(120932,3360,'sr','Ð¢ÐµÐ¶Ð¸Ð½Ð°',0),(120933,3360,'vi','Trá»ng lÆ°á»£ng',0),(120934,3360,'af','Gewig',0),(120935,3360,'ro','Greutate',0),(120936,3360,'et','Kaal',0),(120937,3360,'si','TeÅ¾a',0),(120938,3360,'ba','Berat badan',0),(120939,3360,'nl','Gewicht',0),(120940,3360,'fi','Paino',0),(120941,3360,'no','Vekt',0),(120942,3360,'da','VÃ¦gt',0),(120943,3360,'ko','ë¬´ê²Œ',0),(120944,3360,'he','×ž×©×§×œ',0),(120945,3360,'el','Î’Î¬ÏÎ¿Ï‚',0),(120946,3360,'zh','é‡é‡\r\n',0),(120947,3360,'sv','Vikt',0),(120948,3360,'it','Peso',0),(120949,3360,'tl','',0),(120950,3360,'th','&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;',0),(120951,3360,'hi','à¤µà¤œà¤¨',0),(120952,3360,'ms','Berat badan',0),(120953,3360,'ar','Ø§Ù„ÙˆØ²Ù†',0),(120954,3360,'fr','Poids',0),(120955,3360,'jp','é‡?é‡?',0),(120956,3360,'pt','Peso',0),(120957,3360,'ru','Ð’ÐµÑ',0),(120958,3360,'es','Peso',0),(120959,3360,'de','Gewicht',0),(120960,3360,'en','Weight',0),(120961,3361,'is','',0),(120962,3361,'dr','/ ÙˆØ²Ù† ØµÙØ­Ø§Øª 8.5 * 11M',0),(120963,3361,'pr',' / ÙˆØ²Ù† ØµÙØ­Ø§Øª 8.5 * 11M',0),(120964,3361,'tr','AÄŸÄ±rlÄ±k/M 8.5x11 levhalar',0),(120965,3361,'pl','Waga/M 8.5x11 arkuszy',0),(120966,3361,'bg','Ð¢ÐµÐ³Ð»Ð¾/M 8.5x11 Ð»Ð¸ÑÑ‚Ð¾Ð²Ðµ',0),(120967,3361,'ur','ÙˆØ²Ù†/M 8.5x11 Ø§ÙˆØ±Ø§Ù‚',0),(120968,3361,'sr','Ð¢ÐµÐ¶Ð¸Ð½Ð° /Ðœ 8.5 x11 Ð»Ð¸ÑÑ‚Ð¾Ð²Ðµ',0),(120969,3361,'vi','Trá»ng lÆ°á»£ng/M trang 8.5x11 ',0),(120970,3361,'af','Gewig/M 8.5x11 blaaie',0),(120971,3361,'ro','Greutate/M 8.5x11 foi',0),(120972,3361,'et','Kaal/M 8.5x11 lehtedes',0),(120973,3361,'si','TeÅ¾a/M 8.5x11 listov',0),(120974,3361,'ba','Berat/M 8.5x11 lembar',0),(120975,3361,'nl','Gewicht/M 8.5x11 bladen',0),(120976,3361,'fi','Paino/M 8.5x11 levyt',0),(120977,3361,'no','Vekt/M 8.5x11 ark',0),(120978,3361,'da','VÃ¦gt/M 8.5x11 ark',0),(120979,3361,'ko','ë¬´ê²Œ/M 8.5 x 11 ì‹œíŠ¸',0),(120980,3361,'he','×ž×©×§×œ/M 8.5 x11 ×’×œ×™×•× ×•×ª',0),(120981,3361,'el','Î’Î¬ÏÎ¿Ï‚/M 8.5x11 Ï†ÏÎ»Î»Î±',0),(120982,3361,'zh','é‡é‡/ MæœŸ8.5x11è¡¨\r\n',0),(120983,3361,'sv','Vikt/M 8.5x11 ark',0),(120984,3361,'it','Peso/M 5x11 fogli',0),(120985,3361,'tl','',0),(120986,3361,'th','&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;/&#3648;&#3617;&#3605;&#3619; 8.5x11 &#3627;&#3609;&#3657;&#3634;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(120987,3361,'hi','à¤µà¤œà¤¨/M 8.5 x11 à¤¶à¥€à¤Ÿà¥à¤¸',0),(120988,3361,'ms','Cadar-cadar 8.5x11 berat badan/M',0),(120989,3361,'ar','Ø§Ù„ÙˆØ²Ù† Ù„Ù„Ù…ØªØ± Ø§Ù„Ù…Ø±Ø¨Ø¹ 8.5 x11 Ø£ÙˆØ±Ø§Ù‚',0),(120990,3361,'fr','Feuilles de 8,5 x 11 poids/M',0),(120991,3361,'jp','é‡?é‡?/M 8.5x11 ã‚·ãƒ¼ãƒˆ',0),(120992,3361,'pt','Peso/M 8.5 X11 folhas',0),(120993,3361,'ru','Ð’ÐµÑ/Ðœ 8.5x11 Ð»Ð¸ÑÑ‚Ñ‹',0),(120994,3361,'es','Peso/M hojas de 8.5x11',0),(120995,3361,'de','Gewicht/M 8.5 x 11 Blatt',0),(120996,3361,'en','Weight/M 8.5x11 sheets',0),(120997,3362,'is','',0),(120998,3362,'dr','ÙˆØ²Ù† Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(120999,3362,'pr','ÙˆØ²Ù† Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(121000,3362,'tr','Fiyat birimi baÅŸÄ±na aÄŸÄ±rlÄ±k',0),(121001,3362,'pl','Waga jednostkowa cena',0),(121002,3362,'bg','Ð¢ÐµÐ³Ð»Ð¾ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð°',0),(121003,3362,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù‚ÛŒÙ…Øª ÙˆØ²Ù†',0),(121004,3362,'sr','Ð¢ÐµÐ¶Ð¸Ð½Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ñ†ÐµÐ½Ð°',0),(121005,3362,'vi','Trá»ng lÆ°á»£ng má»—i Ä‘Æ¡n vá»‹ giÃ¡',0),(121006,3362,'af','Gewig per Pryseenheid',0),(121007,3362,'ro','Greutate/ pret unitar',0),(121008,3362,'et','Kaal hinnaÃ¼hiku kohta',0),(121009,3362,'si','TeÅ¾a na enoto cena',0),(121010,3362,'ba','Berat per satuan harga',0),(121011,3362,'nl','Gewicht per prijs eenheid',0),(121012,3362,'fi','Paino hintayksikkÃ¶Ã¤ kohti',0),(121013,3362,'no','Vekt per prisenhet',0),(121014,3362,'da','VÃ¦gt pr. prisenhed',0),(121015,3362,'ko','ê°€ê²© ë‹¨ìœ„ ë‹¹ ë¬´ê²Œ',0),(121016,3362,'he','×ž×©×§×œ ×œ×™×—×™×“×” ×ž×—×™×¨',0),(121017,3362,'el','Î’Î¬ÏÎ¿Ï‚ Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Ï„Î¹Î¼Î®',0),(121018,3362,'zh','æ¯å•ä»·é‡é‡\r\n',0),(121019,3362,'sv','Vikt per prisenhet',0),(121020,3362,'it','Peso prezzo unitario',0),(121021,3362,'tl','',0),(121022,3362,'th','&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(121023,3362,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤•à¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤µà¤œà¤¨',0),(121024,3362,'ms','Berat per Unit harga',0),(121025,3362,'ar','Ø§Ù„ÙˆØ²Ù† Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø© Ø³Ø¹Ø±',0),(121026,3362,'fr','Poids prix unitaire',0),(121027,3362,'jp','ä¾¡æ ¼å?˜ä¾¡ã?”ã?¨ã?®é‡?é‡?',0),(121028,3362,'pt','Peso por unidade de preÃ§o',0),(121029,3362,'ru','Ð’ÐµÑ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ Ñ†ÐµÐ½Ñ‹',0),(121030,3362,'es','Peso por Unidad de Precio',0),(121031,3362,'de','Gewicht pro Preiseinheit',0),(121032,3362,'en','Weight per Price Unit',0),(121033,3363,'is','',0),(121034,3363,'dr','Ø®ÙˆØ´ Ø¢Ù…Ø¯ÙŠØ¯',0),(121035,3363,'pr','Ø®ÙˆØ´ Ø¢Ù…Ø¯ÙŠØ¯',0),(121036,3363,'tr','HoÅŸ geldiniz',0),(121037,3363,'pl','Witaj',0),(121038,3363,'bg','Ð”Ð¾Ð±Ñ€Ðµ Ð´Ð¾ÑˆÐ»Ð¸',0),(121039,3363,'ur','Ù…ÛŒÚº Ø®ÙˆØ´ Ø¢Ù…Ø¯ÛŒØ¯',0),(121040,3363,'sr','Ð”Ð¾Ð±Ñ€Ð¾ Ð´Ð¾ÑˆÐ»Ð¸',0),(121041,3363,'vi','ChÃ o má»«ng',0),(121042,3363,'af','Welkom',0),(121043,3363,'ro','Bine ati veit',0),(121044,3363,'et','Teretulemast',0),(121045,3363,'si','dobrodoÅ¡li',0),(121046,3363,'ba','Selamat datang',0),(121047,3363,'nl','Welkom',0),(121048,3363,'fi','Tervetuloa',0),(121049,3363,'no','velkommen',0),(121050,3363,'da','Velkommen',0),(121051,3363,'ko','í™˜ì˜ í•©ë‹ˆë‹¤',0),(121052,3363,'he','×‘×¨×•×š ×”×‘×',0),(121053,3363,'el','ÎšÎ±Î»ÏŽÏ‚ ÏŒÏÎ¹ÏƒÎµÏ‚',0),(121054,3363,'zh','æ¬¢è¿Ž\r\n',0),(121055,3363,'sv','VÃ¤lkommen',0),(121056,3363,'it','Benvenuti',0),(121057,3363,'tl','',0),(121058,3363,'th','&#3618;&#3636;&#3609;&#3604;&#3637;&#3605;&#3657;&#3629;&#3609;&#3619;&#3633;&#3610;',0),(121059,3363,'hi','à¤¸à¥à¤µà¤¾à¤—à¤¤ à¤¹à¥ˆ',0),(121060,3363,'ms','Selamat datang',0),(121061,3363,'ar','Ù…Ø±Ø­Ø¨Ø§Ù‹',0),(121062,3363,'fr','Bienvenue',0),(121063,3363,'jp','ã‚ˆã?†ã?“ã??',0),(121064,3363,'pt','Bem-vindo',0),(121065,3363,'ru','Ð”Ð¾Ð±Ñ€Ð¾ Ð¿Ð¾Ð¶Ð°Ð»Ð¾Ð²Ð°Ñ‚ÑŒ',0),(121066,3363,'es','Bienvenido',0),(121067,3363,'de','Willkommen',0),(121068,3363,'en','Welcome',0),(121069,3364,'is','',0),(121070,3364,'dr','Ø§ÙƒÙ†ÙˆÙ† ÙƒØ¯Ø§Ù… ',0),(121071,3364,'pr','Ø§ÙƒÙ†ÙˆÙ† ÙƒØ¯Ø§Ù… ',0),(121072,3364,'tr','Åžimdi ne olacak',0),(121073,3364,'pl','Co teraz',0),(121074,3364,'bg','ÐšÐ°ÐºÐ²Ð¾ ÑÐµÐ³Ð°',0),(121075,3364,'ur','Ú©ÛŒØ§ Ø§Ø¨',0),(121076,3364,'sr','Ð¨Ñ‚Ð° ÑÐ°Ð´',0),(121077,3364,'vi','CÃ¡i gÃ¬ bÃ¢y giá»',0),(121078,3364,'af','Wat Nou',0),(121079,3364,'ro','Ceea ce acum',0),(121080,3364,'et','Mis nÃ¼Ã¼d',0),(121081,3364,'si','Kaj zdaj',0),(121082,3364,'ba','Apa sekarang',0),(121083,3364,'nl','Wat nu',0),(121084,3364,'fi','MitÃ¤ nyt',0),(121085,3364,'no','Hva nÃ¥',0),(121086,3364,'da','Hvad nu',0),(121087,3364,'ko','ì§€ê¸ˆ ë¬´ì—‡',0),(121088,3364,'he','? ×ž×” ×¢×›×©×™×•-',0),(121089,3364,'el','Î¤Î¹ Ï„ÏŽÏÎ±',0),(121090,3364,'zh','çŽ°åœ¨åšä»€ä¹ˆ\r\n',0),(121091,3364,'sv','Vad nu',0),(121092,3364,'it','CiÃ² che ora',0),(121093,3364,'tl','',0),(121094,3364,'th','&#3629;&#3632;&#3652;&#3619;&#3651;&#3609;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(121095,3364,'hi','à¤•à¥à¤¯à¤¾ à¤…à¤¬',0),(121096,3364,'ms','Apa sekarang',0),(121097,3364,'ar','Ù…Ø§Ø°Ø§ Ø§Ù„Ø¢Ù†',0),(121098,3364,'fr','Maintenant, ce qui',0),(121099,3364,'jp','æ¬¡ã?¯ä½•',0),(121100,3364,'pt','O que agora',0),(121101,3364,'ru','Ð§Ñ‚Ð¾ Ð¡ÐµÐ¹Ñ‡Ð°Ñ',0),(121102,3364,'es','Â¿Ahora Que?',0),(121103,3364,'de','Was nun',0),(121104,3364,'en','What Now',0),(121105,3365,'is','',0),(121106,3365,'dr','ÙˆÙ‚ØªÙŠ ØºÙŠØ± ÙØ¹Ø§Ù„ Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† Ù…ÙŠ Ø´ÙˆØ¯ Ø¨Ø§ ',0),(121107,3365,'pr','ÙˆÙ‚ØªÙŠ ØºÙŠØ± ÙØ¹Ø§Ù„ Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† Ù…ÙŠ Ø´ÙˆØ¯ Ø¨Ø§ ',0),(121108,3365,'tr','Etkin olmadÄ±ÄŸÄ±nda DeÄŸiÅŸtir',0),(121109,3365,'pl','Gdy nieaktywne zastÄ…piÄ‡',0),(121110,3365,'bg','ÐšÐ¾Ð³Ð°Ñ‚Ð¾ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð·Ð°Ð¼ÐµÐ½Ð¸ Ñ',0),(121111,3365,'ur','Ø¬Ø¨ ØºÛŒØ± ÙØ¹Ø§Ù„ ÛÙˆ Ú©Û’ Ø³Ø§ØªÚ¾ Ø¨Ø¯Ù„ Ø¯ÛŒÚº',0),(121112,3365,'sr','ÐšÐ°Ð´Ð° Ñ˜Ðµ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð° Ð·Ð°Ð¼ÐµÐ½Ð¸Ñ‚Ðµ',0),(121113,3365,'vi','Khi khÃ´ng hoáº¡t Ä‘á»™ng thay vá»›i',0),(121114,3365,'af','Wanneer Onaktief Vervang Met',0),(121115,3365,'ro','Atunci cÃ¢nd inactiv Ã®nlocuiÅ£i cu',0),(121116,3365,'et','Kui on passiivne siis asenda',0),(121117,3365,'si','Ko neaktivni nadomestiti z',0),(121118,3365,'ba','Ketika tidak aktif ganti dengan',0),(121119,3365,'nl','Indien niet actief vervangen door',0),(121120,3365,'fi','Kun ei ole aktiivinen korvaaminen',0),(121121,3365,'no','NÃ¥r inaktiv Erstatt med',0),(121122,3365,'da','NÃ¥r inaktive erstatte med',0),(121123,3365,'ko','ë•Œ ë¹„í™œì„± ë°”ê¿‰ë‹ˆë‹¤',0),(121124,3365,'he','×›××©×¨ ×œ× ×¤×¢×™×œ ×”×—×œ×£ ×¢×',0),(121125,3365,'el','ÎŒÏ„Î±Î½ Î±Î½ÎµÎ½ÎµÏÎ³ÏŒÏ‚ Î±Î½Ï„Î¹ÎºÎ±Ï„Î±ÏƒÏ„Î®ÏƒÎµÎ¹ Î¼Îµ',0),(121126,3365,'zh','å½“æ— æ•ˆæ›¿æ¢ä¸º\r\n',0),(121127,3365,'sv','Vid inaktivitet ersÃ¤tta med',0),(121128,3365,'it','Quando inattivo sostituire con',0),(121129,3365,'tl','',0),(121130,3365,'th','&#3648;&#3617;&#3639;&#3656;&#3629;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3605;&#3629;&#3610;&#3626;&#3609;&#3629;&#3591;&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3604;&#3657;&#3623;&#3618;',0),(121131,3365,'hi','à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯ à¤¹à¥‹à¤¨à¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¬à¤¦à¤²à¥‡à¤‚',0),(121132,3365,'ms','Semasa tidak aktif menggantikan dengan',0),(121133,3365,'ar','Ø§Ù„Ø¨Ø¯ÙŠÙ„ Ø¹Ù†Ø¯Ù…Ø§ ÙŠÙƒÙˆÙ† Ø§Ù„ØµÙ†Ù Ø®Ø§Ù…Ù„Ø§',0),(121134,3365,'fr','Lorsqu\'il est inactif remplacer par',0),(121135,3365,'jp','ä¼‘æ­¢ä¸­ã?®æ™‚ï½žã?¨äº¤æ?›ã?™ã‚‹',0),(121136,3365,'pt','Quando inativo substitua',0),(121137,3365,'ru','ÐšÐ¾Ð³Ð´Ð° ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ð¹ Ð—Ð°Ð¼ÐµÐ½Ð¸Ñ‚Ðµ',0),(121138,3365,'es','Cuando Inactivo Reemplazar Con',0),(121139,3365,'de','Wenn inaktiv ersetzen durch',0),(121140,3365,'en','When Inactive Replace&nbsp;With',0),(121141,3366,'is','',0),(121142,3366,'dr','Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ø¬ÙˆØ§Ø¨ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³Øª Ø¨ÙŠÙ†',0),(121143,3366,'pr','Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ø¬ÙˆØ§Ø¨ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³Øª Ø¨ÙŠÙ†',0),(121144,3366,'tr','Burada cevap arasÄ±nda bir sayÄ±dÄ±r',0),(121145,3366,'pl','JeÅ¼eli odpowiedÅº jest liczbÄ… z przedziaÅ‚u',0),(121146,3366,'bg','ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ÑŠÑ‚ Ðµ Ñ‡Ð¸ÑÐ»Ð¾ Ð¼ÐµÐ¶Ð´Ñƒ',0),(121147,3366,'ur','Ø¬ÛØ§Úº Ø¬ÙˆØ§Ø¨ Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† Ú©Ø§ Ø§ÛŒÚ© Ù†Ù…Ø¨Ø± ÛÛ’ Û”',0),(121148,3366,'sr','Ð“Ð´Ðµ Ñ˜Ðµ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€ Ñ˜Ðµ Ð±Ñ€Ð¾Ñ˜ Ð¸Ð·Ð¼ÐµÑ’Ñƒ',0),(121149,3366,'vi','khi tráº£ lá»i lÃ  sá»‘ giá»¯a',0),(121150,3366,'af','waar die antwoord \'n syfer is tussen',0),(121151,3366,'ro','Ã®n cazul Ã®n care rÄƒspunsul este un numÄƒr Ã®ntre',0),(121152,3366,'et','Kus vastus on numver vahemikus',0),(121153,3366,'si','kjer je odgovor Å¡tevilka med',0),(121154,3366,'ba','mana jawabannya adalah angka antara',0),(121155,3366,'nl','waar antwoord is een getal tussen',0),(121156,3366,'fi','Jos vastaus on vÃ¤liltÃ¤',0),(121157,3366,'no','hvor svaret er et tall mellom',0),(121158,3366,'da','hvor svaret er et tal mellem',0),(121159,3366,'ko','ëŒ€ë‹µì€ ì‚¬ì´ì˜ ìˆ«ìž',0),(121160,3366,'he','××™×¤×” ×”×ª×©×•×‘×” ×ž×¡×¤×¨ ×‘×™×Ÿ',0),(121161,3366,'el','ÏŒÏ€Î¿Ï… Î· Î±Ï€Î¬Î½Ï„Î·ÏƒÎ· ÎµÎ¯Î½Î±Î¹ Î­Î½Î±Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î¼ÎµÏ„Î±Î¾Ï',0),(121162,3366,'zh','å¦‚æžœç­”æ¡ˆæ˜¯ä¸€ä¸ªæ•°å­—ä¹‹é—´\r\n',0),(121163,3366,'sv','dÃ¤r svaret Ã¤r ett nummer mellan',0),(121164,3366,'it','dove la risposta Ã¨ un numero compreso tra',0),(121165,3366,'tl','',0),(121166,3366,'th','&#3607;&#3637;&#3656;&#3595;&#3638;&#3656;&#3591;&#3588;&#3635;&#3605;&#3629;&#3610;&#3648;&#3611;&#3655;&#3609;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;',0),(121167,3366,'hi','à¤œà¤¹à¤¾à¤‚ à¤‰à¤¤à¥à¤¤à¤° à¤•à¥‡ à¤¬à¥€à¤š à¤•à¥€ à¤à¤• à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¹à¥ˆ',0),(121168,3366,'ms','di mana jawapan adalah nombor di antara',0),(121169,3366,'ar','Ø­ÙŠØ« Ø£Ù† Ø§Ù„Ø¬ÙˆØ§Ø¨ Ø¹Ø¯Ø¯ Ø¨ÙŠÙ†',0),(121170,3366,'fr','oÃ¹ la rÃ©ponse est un nombre compris entre',0),(121171,3366,'jp','ç­”ã?ˆã?®æ•°å­—ã?Œã?“ã?®é–“ã?®å ´æ‰€',0),(121172,3366,'pt','onde a resposta Ã© um nÃºmero entre',0),(121173,3366,'ru','Ð³Ð´Ðµ Ð¾Ñ‚Ð²ÐµÑ‚ ÑÑ‚Ð¾ Ð½Ð¾Ð¼ÐµÑ€ Ð¼ÐµÐ¶Ð´Ñƒ',0),(121174,3366,'es','En Donde la respuesta es un nÃºmero entre',0),(121175,3366,'de','Wo ist die Antwort eine Zahl zwischen',0),(121176,3366,'en','where answer is a number between',0),(121177,3367,'is','',0),(121178,3367,'dr','Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ø¬ÙˆØ§Ø¨ Ù…ØªÙ† Ø§Ø³Øª ',0),(121179,3367,'pr','Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ø¬ÙˆØ§Ø¨ Ù…ØªÙ† Ø§Ø³Øª ',0),(121180,3367,'tr','YanÄ±t metin nerede',0),(121181,3367,'pl','JeÅ¼eli odpowiedÅº jest tekst',0),(121182,3367,'bg','ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ÑŠÑ‚ Ðµ Ñ‚ÐµÐºÑÑ‚',0),(121183,3367,'ur','Ø¬ÛØ§Úº Ú©Ø§ Ø¬ÙˆØ§Ø¨ Ù…ØªÙ† ÛÛ’',0),(121184,3367,'sr','Ð“Ð´Ðµ Ñ˜Ðµ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€ Ñ˜Ðµ Ñ‚ÐµÐºÑÑ‚',0),(121185,3367,'vi','khi tráº£ lá»i lÃ  vÄƒn báº£n',0),(121186,3367,'af','waar die antwoord teks is',0),(121187,3367,'ro','Ã®n cazul Ã®n care rÄƒspunsul este text',0),(121188,3367,'et','Kus vastus on tekstiline',0),(121189,3367,'si','kateri odgovor je besedilo',0),(121190,3367,'ba','mana jawabannya adalah teks',0),(121191,3367,'nl','waar antwoord is tekst',0),(121192,3367,'fi','Jos vastaus on teksti',0),(121193,3367,'no','hvor svaret er tekst',0),(121194,3367,'da','hvor svaret er tekst',0),(121195,3367,'ko','ëŒ€ë‹µì€ í…ìŠ¤íŠ¸',0),(121196,3367,'he','××™×¤×” ×”×ª×©×•×‘×” ×˜×§×¡×˜',0),(121197,3367,'el','ÏŒÏ€Î¿Ï… Î· Î±Ï€Î¬Î½Ï„Î·ÏƒÎ· ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ¯Î¼ÎµÎ½Î¿',0),(121198,3367,'zh','è¿™é‡Œçš„ç­”æ¡ˆæ˜¯æ–‡æœ¬\r\n',0),(121199,3367,'sv','dÃ¤r svaret Ã¤r text',0),(121200,3367,'it','dove la risposta Ã¨ testo',0),(121201,3367,'tl','',0),(121202,3367,'th','&#3607;&#3637;&#3656;&#3595;&#3638;&#3656;&#3591;&#3588;&#3635;&#3605;&#3629;&#3610;&#3648;&#3611;&#3655;&#3609;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(121203,3367,'hi','à¤œà¤¹à¤¾à¤ à¤‰à¤¤à¥à¤¤à¤° à¤ªà¤¾à¤  à¤¹à¥ˆ',0),(121204,3367,'ms','di mana jawapannya ialah teks',0),(121205,3367,'ar','Ø­ÙŠØ« Ø£Ù† Ø§Ù„Ø¬ÙˆØ§Ø¨ Ø§Ù„Ù†Øµ',0),(121206,3367,'fr','oÃ¹ la rÃ©ponse est text',0),(121207,3367,'jp','ç­”ã?ˆã?Œæ–‡ç« ã?®å ´æ‰€',0),(121208,3367,'pt','onde a resposta for texto',0),(121209,3367,'ru','Ð³Ð´Ðµ Ð¾Ñ‚Ð²ÐµÑ‚ ÑÑ‚Ð¾ Ñ‚ÐµÐºÑÑ‚',0),(121210,3367,'es','En Donde la respuesta es Texto',0),(121211,3367,'de','Wo ist Antwort text',0),(121212,3367,'en','where answer is text',0),(121213,3368,'is','',0),(121214,3368,'dr','Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ø¬ÙˆØ§Ø¨ Ø¨Ù„Ù‡ ÙŠØ§ Ø®ÙŠØ± Ø§Ø³Øª ',0),(121215,3368,'pr','Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ø¬ÙˆØ§Ø¨ Ø¨Ù„Ù‡ ÙŠØ§ Ø®ÙŠØ± Ø§Ø³Øª ',0),(121216,3368,'tr','nerede cevabÄ±m evet ya da HayÄ±r',0),(121217,3368,'pl','gdzie jest odpowiedÅº tak lub nie',0),(121218,3368,'bg','ÐºÑŠÐ´ÐµÑ‚Ð¾ Ðµ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ Ð´Ð° Ð¸Ð»Ð¸ Ð½Ðµ',0),(121219,3368,'ur','Ø¬ÛØ§Úº Ø¬ÙˆØ§Ø¨ ÛÛ’ ÛØ§Úº ÛŒØ§ Ù†ÛÛŒÚº',0),(121220,3368,'sr','Ð“Ð´Ðµ Ñ˜Ðµ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€ Ð´Ð° Ð¸Ð»Ð¸ Ð½Ðµ',0),(121221,3368,'vi','khi tráº£ lá»i lÃ  CÃ³ hay KhÃ´ng',0),(121222,3368,'af','waar die antwoord Ja of Nee is',0),(121223,3368,'ro','Ã®n cazul Ã®n care rÄƒspunsul este da sau nu',0),(121224,3368,'et','Kus vastus on Jah vÃµi Ei',0),(121225,3368,'si','ÄŒe je odgovor da ali ne',0),(121226,3368,'ba','mana jawaban adalah ya atau tidak',0),(121227,3368,'nl','waar antwoord is ja of Nee',0),(121228,3368,'fi','Jos vastaus on kyllÃ¤ tai ei',0),(121229,3368,'no','hvor svaret er Ja eller nei',0),(121230,3368,'da','Hvis svaret er ja eller nej',0),(121231,3368,'ko','ëŒ€ë‹µì€ ì˜ˆ, ì•„ë‹ˆì˜¤',0),(121232,3368,'he','××™×¤×” ×”×ª×©×•×‘×” ×”×™× ×›×Ÿ ××• ×œ×',0),(121233,3368,'el','ÏŒÏ€Î¿Ï… Î· Î±Ï€Î¬Î½Ï„Î·ÏƒÎ· ÎµÎ¯Î½Î±Î¹ Î½Î±Î¹ Î® ÏŒÏ‡Î¹',0),(121234,3368,'zh','è¿™é‡Œçš„ç­”æ¡ˆæ˜¯æ˜¯æˆ–å¦\r\n',0),(121235,3368,'sv','dÃ¤r svaret Ã¤r ja eller nej',0),(121236,3368,'it','dove la risposta Ã¨ sÃ¬ o No',0),(121237,3368,'tl','',0),(121238,3368,'th','&#3607;&#3637;&#3656;&#3595;&#3638;&#3656;&#3591;&#3588;&#3635;&#3605;&#3629;&#3610;&#3648;&#3611;&#3655;&#3609;&#3651;&#3594;&#3656;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;',0),(121239,3368,'hi','à¤œà¤¹à¤¾à¤ à¤‰à¤¤à¥à¤¤à¤° à¤¹à¥ˆ à¤¹à¤¾à¤ à¤¯à¤¾ à¤¨à¤¹à¥€à¤‚',0),(121240,3368,'ms','di mana jawapan adalah ya atau tidak',0),(121241,3368,'ar','Ø­ÙŠØ« Ø£Ù† Ø§Ù„Ø¬ÙˆØ§Ø¨ \"Ù†Ø¹Ù…\" Ø£Ùˆ \"Ù„Ø§\"',0),(121242,3368,'fr','oÃ¹ la rÃ©ponse est oui ou non',0),(121243,3368,'jp','ç­”ã?ˆã?Œã?¯ã?„ã?‹ã?„ã?„ã?ˆã?®å ´æ‰€',0),(121244,3368,'pt','onde a resposta Ã© sim ou nÃ£o',0),(121245,3368,'ru','Ð³Ð´Ðµ Ð¾Ñ‚Ð²ÐµÑ‚ Ð”Ð° Ð¸Ð»Ð¸ ÐÐµÑ‚',0),(121246,3368,'es','En Donde la respuesta es Si o No',0),(121247,3368,'de','Wo ist Antwort Ja oder Nein',0),(121248,3368,'en','where answer is Yes or No',0),(121249,3369,'is','',0),(121250,3369,'dr','(Ù†Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(121251,3369,'pr','Ø§Ø² Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ÙƒØ§Ù„Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ (Ù†Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(121252,3369,'tr','Madde satÄ±ÅŸ hesabÄ± kullanma<br>(DeÄŸil mÃ¼ÅŸteri)',0),(121253,3369,'pl','PRZEDMIOT sprzedaÅ¼y konta<br>(Nie klienta)',0),(121254,3369,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÑÐ¼ÐµÑ‚ÐºÐ°<br>(ÐÐµ ÐºÐ»Ð¸ÐµÐ½Ñ‚)',0),(121255,3369,'ur','Ø´Û’ Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº<br>(Ù†ÛÛŒÚº ØµØ§Ø±ÙÛŒÙ†)',0),(121256,3369,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÐÐ Ð¢Ð˜ÐšÐÐ›Ð<br>(ÐÐµ ÐºÑƒÐ¿Ñ†Ð°)',0),(121257,3369,'vi','DÃ¹ng HÃ ng trong TK BÃ¡n hÃ ng(KhÃ´ng pháº£i khÃ¡ch hÃ ng)',0),(121258,3369,'af','Gebruik ITEM Verkoperekening<br> (Nie KliÃ«nt/Klant)',0),(121259,3369,'ro','UtilizaÅ£i element de vÃ¢nzÄƒri cont<br>(Nu client)',0),(121260,3369,'et','*Kasuta ITEM mÃ¼Ã¼gi kontot<br>(Mitte kliendi)',0),(121261,3369,'si','Uporabite element prodajni raÄun<br>(Ne strank)',0),(121262,3369,'ba','Menggunakan ITEM penjualan Account<br>(Tidak nasabah)',0),(121263,3369,'nl','OBJECT verkoop-Account gebruiken<br>(Geen klant)',0),(121264,3369,'fi','KÃ¤yttÃ¤Ã¤ tuotteen myynnin tili<br>(Ei asiakas)',0),(121265,3369,'no','Bruke ELEMENTET salgskontoen<br>(Ikke kunden)',0),(121266,3369,'da','Brug vare salgskontoen<br>(Ikke kunde)',0),(121267,3369,'ko','ì•„ì´í…œ íŒë§¤ ê³„ì • ì‚¬ìš©<br>(ê³ ê°)',0),(121268,3369,'he','×”×©×ª×ž×© ×‘×—×©×‘×•×Ÿ ×¤×¨×™×˜ ×ž×›×™×¨×•×ª<br>(×œ× ×œ×§×•×—)',0),(121269,3369,'el','Î§ÏÎ®ÏƒÎ· Î»Î®ÏƒÎµÎ¹Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï<br>(Î”ÎµÎ½ Ï€ÎµÎ»Î¬Ï„Î·Ï‚)',0),(121270,3369,'zh','ä½¿ç”¨é¡¹ç›®é”€å”®å¸æˆ·ï¼ˆéžé¡¾å®¢ï¼‰\r\n',0),(121271,3369,'sv','AnvÃ¤nda objekt fÃ¶rsÃ¤ljning konto<br>(Inte kund)',0),(121272,3369,'it','Utilizzare l\'elemento Sales Account<br>(Non cliente)',0),(121273,3369,'tl','',0),(121274,3369,'th','&#3651;&#3594;&#3657;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3586;&#3634;&#3618; (&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;)',0),(121275,3369,'hi','à¤†à¤‡à¤Ÿà¤® à¤¬à¤¿à¤•à¥à¤°à¥€ à¤–à¤¾à¤¤à¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚<br>(à¤¨à¤¹à¥€à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤•)',0),(121276,3369,'ms','Menggunakan akaun ITEM jualan<br>(Tidak Baca)',0),(121277,3369,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¯ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª<br>(Ù„Ø§ Ù…Ù† Ø§Ù„Ø¹Ù…ÙŠÙ„)',0),(121278,3369,'fr','Utiliser le compte de point de vente<br>(Pas de client)',0),(121279,3369,'jp','å“?ç›®è²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®ä½¿ç”¨<br>(é¡§å®¢ã?§ã?¯ã?ªã?„ï¼‰',0),(121280,3369,'pt','Use o ITEM venda conta<br>(NÃ£o cliente)',0),(121281,3369,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿ÑƒÐ½ÐºÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶<br>(ÐÐµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°)',0),(121282,3369,'es','Usar Cuenta de Ventas ITEM<br>(No el Cliente)',0),(121283,3369,'de','ITEM Sales Account verwenden<br>(Nicht Kunde)',0),(121284,3369,'en','Use ITEM Sales Account (Not Customer)',0),(121285,3370,'is','',0),(121286,3370,'dr','ÙƒØ¯Ø§Ù… Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ Ø¯Ø± Ø¯Ø³ØªÙ…Ø²Ø¯Ù‡Ø§ÙŠÙŠ ÙƒÙ‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ù…Ù‚Ø§Ø¯ÙŠØ±  Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯Ù‰ ÙƒÙ… Ø´Ø¯Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…ÙŠ Ø´ÙˆÙ†Ø¯',0),(121287,3370,'pr','ÙƒØ¯Ø§Ù… Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ Ø¯Ø± Ø¯Ø³ØªÙ…Ø²Ø¯Ù‡Ø§ÙŠÙŠ ÙƒÙ‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ù…Ù‚Ø§Ø¯ÙŠØ±  Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯Ù‰ ÙƒÙ… Ø´Ø¯Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…ÙŠ Ø´ÙˆÙ†Ø¯',0),(121288,3370,'tr','Hangi vergiler emeklilik tutarlarÄ± ile indirimli Ã¼cret alÄ±narak hesaplanÄ±r',0),(121289,3370,'pl','KtÃ³re podatki sÄ… obliczane na wynagrodzenia pomniejszona o kwoty emerytury',0),(121290,3370,'bg','ÐšÐ¾Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸ ÑÐµ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ñ‚ Ð²ÑŠÑ€Ñ…Ñƒ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ Ð½Ð°Ð¼Ð°Ð»ÑÐ²Ð°Ñ‚ Ñ Ð¿ÐµÐ½ÑÐ¸Ð¾Ð½Ð½Ð¸ ÑÑƒÐ¼Ð¸',0),(121291,3370,'ur','Ø¬Ùˆ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾Ù†Ø´Ù† Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©Ùˆ Ú©Ù… Ø§Ø¬Ø±Øª Ù¾Ø± Ø­Ø³Ø§Ø¨ Ú©Ø± Ø±ÛÛ’ ÛÛŒÚº',0),(121292,3370,'sr','ÐšÐ¾Ñ˜Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ðµ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð° Ð¿Ð»Ð°Ñ‚Ð° ÑƒÐ¼Ð°ÑšÐµÐ½Ð° Ð·Ð° Ð¸Ð·Ð½Ð¾ÑÐµ Ð¿ÐµÐ½Ð·Ð¸Ñ˜Ð°',0),(121293,3370,'vi','TÃ­nh thuáº¿ nÃ o cho lÆ°Æ¡ng Ä‘Ã£ trá»« giáº£m lÆ°Æ¡ng hÆ°u',0),(121294,3370,'af','Watter belasting is bereken op Besoldiging wat verminder is deur pensioenbedrae',0),(121295,3370,'ro','Care taxele sunt calculate pe salariile reduse de pensii sumele',0),(121296,3370,'et','*Which taxes are calculated on wages reduced by pension amounts',0),(121297,3370,'si','Katere davke izraÄunajo zmanjÅ¡a za zneske pokojnine, plaÄe',0),(121298,3370,'ba','Pajak yang dihitung pada upah yang dikurangi jumlah pensiun',0),(121299,3370,'nl','Welke belastingen worden berekend op de lonen verlaagd met pensioen bedragen',0),(121300,3370,'fi','MitkÃ¤ verot lasketaan veron palkasta vÃ¤hennetÃ¤Ã¤n elÃ¤ke',0),(121301,3370,'no','Hvilke skatt beregnes av lÃ¸nn redusert med pensjon belÃ¸p',0),(121302,3370,'da','Hvilke skatter er beregnet pÃ¥ lÃ¸n reduceret med pension belÃ¸b',0),(121303,3370,'ko','ì–´ë–¤ ì„¸ê¸ˆ ì—°ê¸ˆ ê¸ˆì•¡ ê°ì†Œ ìž„ê¸ˆ ê³„ì‚°',0),(121304,3370,'he','××™×œ×• ×ž×¡×™× ×ž×—×•×©×‘×™× ×¢×œ ×©×›×¨ ×ž×•×¤×—×ª ×¢×œ ×™×“×™ ×¡×›×•×ž×™ ×”×¤× ×¡×™×”',0),(121305,3370,'el','Î¤Î± Ï„Î­Î»Î· Ï€Î¿Ï… Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶Î¿Î½Ï„Î±Î¹ Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¹Ï‚ Î±Ï€Î¿Î´Î¿Ï‡Î­Ï‚ Î¼Î¹ÎºÏÏŒÏ„ÎµÏÎµÏ‚ Î±Ï€ÏŒ Ï„Î¿ ÏÏˆÎ¿Ï‚ Ï„Ï‰Î½ ÏƒÏ…Î½Ï„Î¬Î¾ÎµÏ‰Î½',0),(121306,3370,'zh','å“ªäº›ç¨Žæ˜¯æ ¹æ®å…»è€ä¿é™©é‡‘é¢å‡å°‘çš„å·¥èµ„è®¡ç®—\r\n',0),(121307,3370,'sv','Vilka skatter berÃ¤knas pÃ¥ lÃ¶nen minskas med belopp som pension',0),(121308,3370,'it','Quali tasse sono calcolate sui salari ridotti importi pensione',0),(121309,3370,'tl','',0),(121310,3370,'th','&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3588;&#3635;&#3609;&#3623;&#3603;&#3586;&#3629;&#3591;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3621;&#3604;&#3621;&#3591;&#3592;&#3',0),(121311,3370,'hi','à¤œà¥‹ à¤•à¤°à¥‹à¤‚ à¤•à¥€ à¤ªà¥‡à¤‚à¤¶à¤¨ à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡ à¤•à¤® à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤ªà¤° à¤—à¤£à¤¨à¤¾ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚',0),(121312,3370,'ms','Cukai yang dikira pada gaji dikurangkan oleh amaun pencen',0),(121313,3370,'ar','ÙˆØªØ­Ø³Ø¨ ÙÙŠÙ‡Ø§ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ø¬ÙˆØ± Ø¨Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø¹Ø§Ø´Ø§Øª Ø§Ù„ØªÙ‚Ø§Ø¹Ø¯ÙŠØ©',0),(121314,3370,'fr','Quelles taxes sont calculÃ©es sur les salaires, diminuÃ©s du montant des pensions',0),(121315,3370,'jp','å¹´é‡‘é¡?ã‚’æŽ§é™¤ã?—ã?Ÿè³ƒé‡‘ã?«è¨ˆç®—ã?•ã‚Œã?Ÿç¨Žé‡‘',0),(121316,3370,'pt','Quais os impostos sÃ£o calculados sobre os salÃ¡rios reduzidos por montantes de pensÃµes',0),(121317,3370,'ru','ÐšÐ°ÐºÐ¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¸ Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ñ‹Ð²Ð°ÑŽÑ‚ÑÑ Ð¿Ð¾ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ðµ, ÑƒÐ¼ÐµÐ½ÑŒÑˆÐµÐ½Ñ‹ Ð¿ÐµÐ½ÑÐ¸Ð¸',0),(121318,3370,'es','Cuales Impuestos se Calcularon sobre Sueldos reducido por montos de pensiones',0),(121319,3370,'de','Welche Steuern werden auf die LÃ¶hne gesenkt Rente BetrÃ¤ge berechnet.',0),(121320,3370,'en','Which taxes are calculated on wages reduced by pension amounts',0),(121321,3371,'is','',0),(121322,3371,'dr','Ø¯Ø± Ø­Ø§Ù„ÙŠ ÙƒÙ‡ Ø³ÙØ§Ø±Ø´ Ø§Ø¶Ø§ÙÙ‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(121323,3371,'pr','Ø¯Ø± Ø­Ø§Ù„ÙŠ ÙƒÙ‡ Ø³ÙØ§Ø±Ø´ Ø§Ø¶Ø§ÙÙ‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(121324,3371,'tr',' sipariÅŸi eklerken.',0),(121325,3371,'pl',' podczas dodawania zlecenia.',0),(121326,3371,'bg',' Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€ÐµÐ´.',0),(121327,3371,'ur',' ØªØ±ØªÛŒØ¨ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Û”',0),(121328,3371,'sr',' Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° Ð½Ð°Ð»Ð¾Ð³Ð°.',0),(121329,3371,'vi','trong khi thÃªm Ä‘Æ¡n hÃ ng',0),(121330,3371,'af','  terwyl bestelling geskep word.',0),(121331,3371,'ro','Adaugand in acelasi timp comanda',0),(121332,3371,'et','Kuni lisab tellimust.',0),(121333,3371,'si',' pri dodajanju naloga.',0),(121334,3371,'ba',' sambil menambahkan perintah.',0),(121335,3371,'nl',' terwijl het toevoegen van orde.',0),(121336,3371,'fi',' lisÃ¤ttÃ¤essÃ¤ jÃ¤rjestyksessÃ¤.',0),(121337,3371,'no',' mens du legger ordren.',0),(121338,3371,'da',' samtidig med at tilfÃ¸je rÃ¦kkefÃ¸lge.',0),(121339,3371,'ko',' ìˆœì„œë¥¼ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(121340,3371,'he',' ×‘×¢×ª ×”×•×¡×¤×ª ×¡×“×¨.',0),(121341,3371,'el',' Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±.',0),(121342,3371,'zh','åŒæ—¶æ·»åŠ é¡ºåº',0),(121343,3371,'sv',' samtidigt som du lÃ¤gger order.',0),(121344,3371,'it',' mentre l\'aggiunta di ordine.',0),(121345,3371,'tl','',0),(121346,3371,'th','&#3586;&#3603;&#3632;&#3607;&#3637;&#3656;&#3585;&#3635;&#3621;&#3633;&#3591;&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(121347,3371,'hi',' à¤œà¤¬à¤•à¤¿ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡à¥¤',0),(121348,3371,'ms',' sambil menambah perintah.',0),(121349,3371,'ar','Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(121350,3371,'fr',' lors de l\'ajout de commande.',0),(121351,3371,'jp','æ³¨æ–‡ã‚’è¿½åŠ ã?—ã?¦ã‚‹é–“',0),(121352,3371,'pt',' ao adicionar a ordem.',0),(121353,3371,'ru',' ÐŸÑ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð°ÐºÐ°Ð·Ð°.',0),(121354,3371,'es',' mientras que agregar ordne',0),(121355,3371,'de',' beim HinzufÃ¼gen von Reihenfolge.',0),(121356,3371,'en',' while adding order.',0),(121357,3372,'is','',0),(121358,3372,'dr','Ú†Ù‡ ÙƒØ³ÙŠ Ø¨Ø§ÙŠØ¯ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯',0),(121359,3372,'pr','Ú†Ù‡ ÙƒØ³ÙŠ Ø¨Ø§ÙŠØ¯ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯',0),(121360,3372,'tr','Kim verilmelidir',0),(121361,3372,'pl','Kto powinien otrzymaÄ‡',0),(121362,3372,'bg','ÐºÐ¾Ð¸Ñ‚Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð´Ð°Ð´Ðµ',0),(121363,3372,'ur','Ø¬Ùˆ Ø¯ÛŒØ§ Ø¬Ø§Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(121364,3372,'sr','ÐšÐ¾ Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð°Ñ‚Ð¸',0),(121365,3372,'vi','ai Ä‘Æ°á»£c cho',0),(121366,3372,'af','wat gegee moet word',0),(121367,3372,'ro','Cine ar trebui sÄƒ fie dat',0),(121368,3372,'et','who should be given',0),(121369,3372,'si','kdo je treba',0),(121370,3372,'ba','yang harus diberi',0),(121371,3372,'nl','die moet worden gegeven',0),(121372,3372,'fi','joille olisi tarjottava',0),(121373,3372,'no','som bÃ¸r gis',0),(121374,3372,'da','der bÃ¸r gives',0),(121375,3372,'ko','ëˆ„ê°€ ì£¼ì–´ì ¸ì•¼ í•œë‹¤',0),(121376,3372,'he','×ž×™ ×¦×¨×™×š ×œ×”×™× ×ª×Ÿ',0),(121377,3372,'el','Ï€Î¿Ï… Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î´Î¿Î¸ÎµÎ¯',0),(121378,3372,'zh','è°åº”è¢«ç»™äºˆ\r\n',0),(121379,3372,'sv','som bÃ¶r ges',0),(121380,3372,'it','che dovrebbe essere data',0),(121381,3372,'tl','',0),(121382,3372,'th','&#3588;&#3640;&#3603;&#3588;&#3623;&#3619;&#3592;&#3632;&#3651;&#3627;&#3657;',0),(121383,3372,'hi','à¤œà¥‹ à¤¦à¥€ à¤œà¤¾à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(121384,3372,'ms','yang patut diberi',0),(121385,3372,'ar','Ø§Ù„Ø°ÙŠÙ† ÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ØªÙƒÙˆÙ†',0),(121386,3372,'fr','qui devrait Ãªtre donnÃ©',0),(121387,3372,'jp','ä¸Žã?ˆã‚‰ã‚Œã‚‹ã?¹ã??äºº',0),(121388,3372,'pt','Quem deve ser dada',0),(121389,3372,'ru','ÐºÑ‚Ð¾ ÑÐ»ÐµÐ´ÑƒÐµÑ‚ Ð´Ð°Ñ‚ÑŒ',0),(121390,3372,'es','A quien se darÃ­a',0),(121391,3372,'de','Wer sollte gegeben werden',0),(121392,3372,'en','who should be given',0),(121393,3373,'is','',0),(121394,3373,'dr','Ø¹Ø±Ø¶ ',0),(121395,3373,'pr','Ø¹Ø±Ø¶ ',0),(121396,3373,'tr','GeniÅŸlik',0),(121397,3373,'pl','SzerokoÅ›Ä‡',0),(121398,3373,'bg','Ð¨Ð¸Ñ€Ð¸Ð½Ð°',0),(121399,3373,'ur','Ú†ÙˆÚ‘Ø§Ø¦ÛŒ',0),(121400,3373,'sr','Ð¨Ð¸Ñ€Ð¸Ð½Ð°',0),(121401,3373,'vi','Chiá»u rá»™ng',0),(121402,3373,'af','Wydte',0),(121403,3373,'ro','Latime',0),(121404,3373,'et','Laius',0),(121405,3373,'si','Å irina',0),(121406,3373,'ba','Lebar',0),(121407,3373,'nl','Breedte',0),(121408,3373,'fi','Leveys',0),(121409,3373,'no','Bredde',0),(121410,3373,'da','Bredde',0),(121411,3373,'ko','ë„ˆë¹„',0),(121412,3373,'he','×¨×•×—×‘',0),(121413,3373,'el','Î Î»Î¬Ï„Î¿Ï‚',0),(121414,3373,'zh','å®½åº¦\r\n',0),(121415,3373,'sv','Bredd',0),(121416,3373,'it','Larghezza',0),(121417,3373,'tl','',0),(121418,3373,'th','&#3588;&#3623;&#3634;&#3617;&#3585;&#3623;&#3657;&#3634;&#3591;',0),(121419,3373,'hi','à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ',0),(121420,3373,'ms','Lebar',0),(121421,3373,'ar','Ø§Ù„Ø¹Ø±Ø¶',0),(121422,3373,'fr','Largeur',0),(121423,3373,'jp','å¹…',0),(121424,3373,'pt','Largura',0),(121425,3373,'ru','Ð¨Ð¸Ñ€Ð¸Ð½Ð°',0),(121426,3373,'es','Anchura',0),(121427,3373,'de','Breite',0),(121428,3373,'en','Width',0),(121429,3374,'is','',0),(121430,3374,'dr','/ Ø·ÙˆÙ„',0),(121431,3374,'pr','Ø¹Ø±Ø¶ / Ø·ÙˆÙ„',0),(121432,3374,'tr','GeniÅŸliÄŸi ve uzunluÄŸu',0),(121433,3374,'pl','SzerokoÅ›Ä‡/dÅ‚ugoÅ›Ä‡',0),(121434,3374,'bg','Ð¨Ð¸Ñ€Ð¸Ð½Ð°/Ð´ÑŠÐ»Ð¶Ð¸Ð½Ð°',0),(121435,3374,'ur','Ú†ÙˆÚ‘Ø§Ø¦ÛŒ/Ù„Ù…Ø¨Ø§Ø¦ÛŒ',0),(121436,3374,'sr','Ð¨Ð¸Ñ€Ð¸Ð½Ð°/Ð´ÑƒÐ¶Ð¸Ð½Ð°',0),(121437,3374,'vi','Chiá»u rá»™ng/Chiá»u dÃ i',0),(121438,3374,'af','Wydte/Lengte',0),(121439,3374,'ro','Latime/lungime',0),(121440,3374,'et','Laius/Pikkus',0),(121441,3374,'si','Å irina/dolÅ¾ina',0),(121442,3374,'ba','Lebar panjang',0),(121443,3374,'nl','Breedte/lengte',0),(121444,3374,'fi','Leveys/pituus',0),(121445,3374,'no','Bredde/lengde',0),(121446,3374,'da','Bredde/lÃ¦ngde',0),(121447,3374,'ko','í­/ê¸¸ì´',0),(121448,3374,'he','×¨×•×—×‘/××•×¨×š',0),(121449,3374,'el','Î Î»Î¬Ï„Î¿Ï‚/ÎœÎ®ÎºÎ¿Ï‚',0),(121450,3374,'zh','å®½åº¦/é•¿åº¦\r\n',0),(121451,3374,'sv','Bredd/lÃ¤ngd',0),(121452,3374,'it','Larghezza/lunghezza',0),(121453,3374,'tl','',0),(121454,3374,'th','&#3588;&#3623;&#3634;&#3617;&#3585;&#3623;&#3657;&#3634;&#3591;/&#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623;',0),(121455,3374,'hi','à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ/à¤²à¤‚à¤¬à¤¾à¤ˆ',0),(121456,3374,'ms','Lebar/panjang',0),(121457,3374,'ar','Ø¹Ø±Ø¶/Ø·ÙˆÙ„',0),(121458,3374,'fr','Largeur/longueur',0),(121459,3374,'jp','å¹…/é•·ã?•',0),(121460,3374,'pt','Largura/comprimento',0),(121461,3374,'ru','Ð¨Ð¸Ñ€Ð¸Ð½Ð°/Ð´Ð»Ð¸Ð½Ð°',0),(121462,3374,'es','Anchura/Largo',0),(121463,3374,'de','Breite/LÃ¤nge',0),(121464,3374,'en','Width/Length',0),(121465,3375,'is','',0),(121466,3375,'dr','* Ø·ÙˆÙ„',0),(121467,3375,'pr','Ø¹Ø±Ø¶  * Ø·ÙˆÙ„',0),(121468,3375,'tr','GeniÅŸlik x uzunluk',0),(121469,3375,'pl','SzerokoÅ›Ä‡ x dÅ‚ugoÅ›Ä‡',0),(121470,3375,'bg','Ð¨Ð¸Ñ€Ð¸Ð½Ð° x Ð´ÑŠÐ»Ð¶Ð¸Ð½Ð°',0),(121471,3375,'ur','Ú†ÙˆÚ‘Ø§Ø¦ÛŒ Ù„Ù…Ø¨Ø§Ø¦ÛŒ x',0),(121472,3375,'sr','Ð¨Ð¸Ñ€Ð¸Ð½Ð° x Ð´ÑƒÐ¶Ð¸Ð½Ð°',0),(121473,3375,'vi','Chiá»u rá»™ng x Chiá»u dÃ i',0),(121474,3375,'af','Wydte x Lengte',0),(121475,3375,'ro','Latime x Lungime',0),(121476,3375,'et','Laius x Pikkus',0),(121477,3375,'si','Å irina x dolÅ¾ina',0),(121478,3375,'ba','Lebar x panjang',0),(121479,3375,'nl','Breedte x lengte',0),(121480,3375,'fi','Leveys x pituus',0),(121481,3375,'no','Bredde x lengde',0),(121482,3375,'da','Bredde x lÃ¦ngde',0),(121483,3375,'ko','í­ x ê¸¸ì´',0),(121484,3375,'he','××•×¨×š x ×¨×•×—×‘',0),(121485,3375,'el','Î Î»Î¬Ï„Î¿Ï‚ x Î¼Î®ÎºÎ¿Ï‚',0),(121486,3375,'zh','å®½xé•¿\r\n',0),(121487,3375,'sv','Bredd x lÃ¤ngd',0),(121488,3375,'it','Larghezza x lunghezza',0),(121489,3375,'tl','',0),(121490,3375,'th','&#3588;&#3623;&#3634;&#3617;&#3585;&#3623;&#3657;&#3634;&#3591; x &#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623;',0),(121491,3375,'hi','à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ à¤²à¤‚à¤¬à¤¾à¤ˆ x',0),(121492,3375,'ms','Lebar x panjang',0),(121493,3375,'ar','Ø¹Ø±Ø¶ x Ø·ÙˆÙ„',0),(121494,3375,'fr','Largeur x longueur',0),(121495,3375,'jp','å¹…Ã—é•·ã?•',0),(121496,3375,'pt','Largura x comprimento',0),(121497,3375,'ru','Ð¨Ð¸Ñ€Ð¸Ð½Ð° x Ð´Ð»Ð¸Ð½Ð°',0),(121498,3375,'es','Anchura x Largo',0),(121499,3375,'de','Breite x LÃ¤nge',0),(121500,3375,'en','Width x Length',0),(121501,3376,'is','',0),(121502,3376,'dr','ÙÙ‚Ø· Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ø§Ú¯Ø± Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù‡Ø± Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ø´Ø¯',0),(121503,3376,'pr','ÙÙ‚Ø· Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ø§Ú¯Ø± Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù‡Ø± Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ø´Ø¯',0),(121504,3376,'tr','Varolan herhangi bir fatura numarasÄ± daha yÃ¼ksek ise sadece kullanÄ±lacak',0),(121505,3376,'pl','BÄ™dÄ… wykorzystywane wyÅ‚Ä…cznie jeÅ›li wyÅ¼szy niÅ¼ wszelki istniejÄ…cy numer faktury',0),(121506,3376,'bg','Ð©Ðµ Ð±ÑŠÐ´Ðµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¿Ð¾-Ð²Ð¸ÑÐ¾ÐºÐ° Ð¾Ñ‚ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(121507,3376,'ur','ØµØ±Ù Ø§Ø¹Ù„ÛŒ Ø§Ú¯Ø± Ú©Ø³ÛŒ Ù…ÙˆØ¬ÙˆØ¯Û Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(121508,3376,'sr','Ð‹Ðµ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ñ˜Ðµ Ñ‚Ð¾ Ð²Ð¸ÑˆÐµ Ð½ÐµÐ³Ð¾ Ð±Ð¸Ð»Ð¾ ÐºÐ¾Ñ˜Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(121509,3376,'vi','Sáº½ dÃ¹ng khi cao hÆ¡n sá»‘ hÃ³a Ä‘Æ¡n hiá»‡n cÃ³',0),(121510,3376,'af','Sal slegs gebruik word as hoÃ«r as enige bestaande faktuur nommer',0),(121511,3376,'ro','Vor fi folosite doar pentru',0),(121512,3376,'et','On kasutuses ainult siis kui on suurem kui olemasoleva tellimuse number',0),(121513,3376,'si','Bo uporabiti samo, Äe je viÅ¡ji od vseh obstojeÄih Å¡tevilko raÄuna',0),(121514,3376,'ba','Hanya dapat digunakan jika lebih tinggi dari nomor faktur yang ada',0),(121515,3376,'nl','Zal alleen worden gebruikt als hoger zijn dan enige bestaande factuurnummer',0),(121516,3376,'fi','SitÃ¤ kÃ¤ytetÃ¤Ã¤n vain, jos se on korkeampi kuin nykyisen laskunumero',0),(121517,3376,'no','Bare brukes hvis det er hÃ¸yere enn alle eksisterende fakturanummer',0),(121518,3376,'da','Bruges kun, hvis hÃ¸jere end nogen eksisterende fakturanummer',0),(121519,3376,'ko','ëª¨ë“  ê¸°ì¡´ ì†¡ìž¥ ë²ˆí˜¸ ë³´ë‹¤ ë†’ì€ ê²½ìš°ì— ì‚¬ìš© ë©ë‹ˆë‹¤.',0),(121520,3376,'he','××š ×•×¨×§ ×× ×’×‘×•×” ×™×•×ª×¨ ×ž××©×¨ ×›×œ ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª ×”×§×™×™×',0),(121521,3376,'el','Î˜Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ Î¼ÏŒÎ½Î¿ ÎµÏ†ÏŒÏƒÎ¿Î½ ÎµÎ¯Î½Î±Î¹ Ï…ÏˆÎ·Î»ÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ ÏŒ, Ï„Î¹ Î¿Ï€Î¿Î¹Î±Î´Î®Ï€Î¿Ï„Îµ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎ± Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(121522,3376,'zh','åªæœ‰å½“æ¯”ä»»ä½•çŽ°æœ‰çš„å‘ç¥¨å·æ—¶ä¼šè¢«ä½¿ç”¨\r\n',0),(121523,3376,'sv','Kommer endast att anvÃ¤ndas om hÃ¶gre Ã¤n alla befintliga fakturanummer',0),(121524,3376,'it','Saranno utilizzati solo se superiore a qualsiasi numero di fattura esistente',0),(121525,3376,'tl','',0),(121526,3376,'th','&#3592;&#3632;&#3651;&#3594;&#3657;&#3648;&#3617;&#3639;&#3656;&#3629;&#3626;&#3641;&#3591;&#3585;&#3623;&#3656;&#3634;&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3',0),(121527,3376,'hi','à¤•à¥‡à¤µà¤² à¤¯à¤¦à¤¿ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾ à¤‰à¤šà¥à¤š à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾',0),(121528,3376,'ms','Hanya boleh digunakan jika lebih tinggi daripada mana-mana nombor invois yang sedia ada',0),(121529,3376,'ar','Ø³ÙˆÙ ØªØ³ØªØ®Ø¯Ù… ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† Ø£Ø¹Ù„Ù‰ Ù…Ù† Ø£ÙŠ Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(121530,3376,'fr','Serviront uniquement si supÃ©rieur Ã  n\'importe quel nombre de facture existante',0),(121531,3376,'jp','ã?©ã‚Œã?‹å­˜åœ¨ã?™ã‚‹è«‹æ±‚æ›¸ç•ªå?·ã‚ˆã‚Šã‚‚å¤§ã??ã?„å ´å?ˆã?®ã?¿ä½¿ç”¨ã?™ã‚‹',0),(121532,3376,'pt','SÃ³ serÃ¡ usado se maior do que qualquer nÃºmero de factura existentes',0),(121533,3376,'ru','Ð‘ÑƒÐ´ÐµÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒÑÑ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð²Ñ‹ÑˆÐµ, Ñ‡ÐµÐ¼ Ð»ÑŽÐ±Ð¾Ð¹ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(121534,3376,'es','Solo se usarÃ¡ si el nÃºmero es mÃ¡s alto que el nÃºmero existente de la Factura',0),(121535,3376,'de','Wenn hÃ¶her als jede bestehende Rechnungsnummer dienen ausschlieÃŸlich',0),(121536,3376,'en','Will only be used if higher than any existing invoice number',0),(121537,3377,'is','',0),(121538,3377,'dr','Ø¨Ø§ Ø³Ø± ØµÙØ­Ù‡',0),(121539,3377,'pr','Ø¨Ø§ Ø³Ø± ØµÙØ­Ù‡',0),(121540,3377,'tr','BAÅžLIKLARI Ä°LE',0),(121541,3377,'pl','Z NAGÅÃ“WKÃ“W',0),(121542,3377,'bg','Ð¡ Ð“ÐžÐ ÐÐ˜ ÐšÐžÐ›ÐžÐÐ¢Ð˜Ð¢Ð£Ð›Ð˜',0),(121543,3377,'ur','Ø³Ø±ØªØ­Ø±ÛŒØ± Ú©Û’ Ø³Ø§ØªÚ¾',0),(121544,3377,'sr','Ð¡Ð Ð—ÐÐ“Ð›ÐÐ’Ð‰Ð˜ÐœÐ',0),(121545,3377,'vi','Vá»šI TIÃŠU Äá»€',0),(121546,3377,'af','MET HOOFDE',0),(121547,3377,'ro','CU ANTETURI',0),(121548,3377,'et','KOOS PÃ„ISEGA',0),(121549,3377,'si','Z GLAVE',0),(121550,3377,'ba','DENGAN HEADER',0),(121551,3377,'nl','MET HEADERS',0),(121552,3377,'fi','OTSIKOT',0),(121553,3377,'no','HEADINGER',0),(121554,3377,'da','MED OVERSKRIFTER',0),(121555,3377,'ko','í—¤ë”ì™€ í•¨ê»˜',0),(121556,3377,'he','×¢× ×›×•×ª×¨×•×ª',0),(121557,3377,'el','ÎœÎ• ÎšÎ•Î¦Î‘Î›ÎŠÎ”Î•Î£',0),(121558,3377,'zh','é¡µçœ‰\r\n',0),(121559,3377,'sv','MED HUVUDEN',0),(121560,3377,'it','CON INTESTAZIONI',0),(121561,3377,'tl','',0),(121562,3377,'th','&#3604;&#3657;&#3623;&#3618;&#3627;&#3633;&#3623;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(121563,3377,'hi','à¤¹à¥‡à¤¡à¤° à¤•à¥‡ à¤¸à¤¾à¤¥',0),(121564,3377,'ms','DENGAN TAJUK',0),(121565,3377,'ar','Ù…Ø¹ Ø±Ø¤ÙˆØ³',0),(121566,3377,'fr','AVEC DES EN-TÃŠTES',0),(121567,3377,'jp','ãƒ˜ãƒƒãƒ€ãƒ¼ä»˜',0),(121568,3377,'pt','COM CABEÃ‡ALHOS',0),(121569,3377,'ru','Ð¡ Ð—ÐÐ“ÐžÐ›ÐžÐ’ÐšÐÐœÐ˜',0),(121570,3377,'es','CON ENCABEZADO',0),(121571,3377,'de','MIT HEADER',0),(121572,3377,'en','WITH HEADERS',0),(121573,3378,'is','',0),(121574,3378,'dr','(Ø²Ù…Ø§Ù† Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª Ø¬Ù†Ø³ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ø¢Ù†',0),(121575,3378,'pr','Ø¨Ø§ ÙŠÙƒ Ø¨Ø±Ú¯Ø´Øª Ø§Ø²(Ø²Ù…Ø§Ù† Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ø¢Ù†',0),(121576,3378,'tr','bir dÃ¶nÃ¼ÅŸ ile',0),(121577,3378,'pl','z realizacji z',0),(121578,3378,'bg','Ñ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð½Ð°',0),(121579,3378,'ur','Ú©Û’ Ø§ÛŒÚ© Ù¾ÛŒØ´ Ú©Û’ Ø³Ø§ØªÚ¾',0),(121580,3378,'sr','ÑÐ° Ñ˜Ðµ Ð¿Ñ€ÐµÐ¾ÐºÑ€ÐµÑ‚ Ð¾Ð´',0),(121581,3378,'vi','vá»›i 1 vÃ²ng quay cá»§a',0),(121582,3378,'af','met \'n ommeswaai van',0),(121583,3378,'ro','cu un rÄƒspuns de',0),(121584,3378,'et','*with a turnaround of',0),(121585,3378,'si','z preobrat od',0),(121586,3378,'ba','dengan waktu penyelesaian',0),(121587,3378,'nl','met een ommekeer van',0),(121588,3378,'fi','jossa lÃ¤pimenoaika',0),(121589,3378,'no','med en behandlingstid pÃ¥',0),(121590,3378,'da','med en turnaround af',0),(121591,3378,'ko','ì²˜ë¦¬ì™€',0),(121592,3378,'he','×¢× ×”×—×•×–×¨×ª ×©×œ',0),(121593,3378,'el','Î¼Îµ Î¼Î¹Î± Î¼ÎµÏ„Î±ÏƒÏ„ÏÎ¿Ï†Î® Ï„Î¿Ï…',0),(121594,3378,'zh','ä¸Žå‘¨è½¬\r\n',0),(121595,3378,'sv','med en vÃ¤ndning av',0),(121596,3378,'it','con un\'inversione di tendenza del',0),(121597,3378,'tl','',0),(121598,3378,'th','&#3604;&#3657;&#3623;&#3618;&#3585;&#3634;&#3619;&#3627;&#3617;&#3640;&#3609;&#3652;&#3611;&#3619;&#3629;&#3610; &#3654; &#3586;&#3629;&#3591;',0),(121599,3378,'hi','à¤à¤• à¤¬à¤¦à¤²à¤¾à¤µ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(121600,3378,'ms','dengan pemulihan',0),(121601,3378,'ar','Ù…Ø¹ ØªØ­ÙˆÙ„ Ù…Ù†',0),(121602,3378,'fr','avec un revirement de',0),(121603,3378,'jp','ï½žã?®å¿…è¦?æ—¥æ•°ã?¯',0),(121604,3378,'pt','com uma reviravolta de',0),(121605,3378,'ru','Ñ Ñ€Ð°Ð·Ð²Ð¾Ñ€Ð¾Ñ‚Ð°',0),(121606,3378,'es','con un cambio de',0),(121607,3378,'de','mit eine Kehrtwende',0),(121608,3378,'en','with a turnaround of',0),(121609,3379,'is','',0),(121610,3379,'dr','Ø¯Ø± Ø¯ÙˆØ±Ù‡ ØªØ®ÙÙŠÙ',0),(121611,3379,'pr','Ø¯Ø± Ø¯ÙˆØ±Ù‡ ØªØ®ÙÙŠÙ',0),(121612,3379,'tr','Ä°Ã§inde<br>DÃ¶nem indirim',0),(121613,3379,'pl','W ramach<br>ZniÅ¼ki okres',0),(121614,3379,'bg','Ð’ Ñ€Ð°Ð¼ÐºÐ¸Ñ‚Ðµ Ð½Ð°<br>ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(121615,3379,'ur','Ú©Û’ Ø§Ù†Ø¯Ø±<br>Ø¯ÙˆØ± ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(121616,3379,'sr','Ð£ Ñ€Ð¾ÐºÑƒ Ð¾Ð´<br>ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(121617,3379,'vi','Trongthá»i ká»³ chiáº¿t kháº¥u',0),(121618,3379,'af','Binne<br>Kortings Periode',0),(121619,3379,'ro','Discount in perioada',0),(121620,3379,'et','Koos<br>Allahindulse perioodiga',0),(121621,3379,'si','Znotraj<br>Popust obdobje',0),(121622,3379,'ba','Dalam<br>DISKON TERBAIK untuk periode',0),(121623,3379,'nl','Binnen<br>Goedkope periode',0),(121624,3379,'fi','SisÃ¤llÃ¤<br>Alennuskauden',0),(121625,3379,'no','Innen<br>Rabatt perioden',0),(121626,3379,'da','Inden for<br>Discount periode',0),(121627,3379,'ko','ë‚´ì—ì„œ<br>ê¸°ê°„ í• ì¸',0),(121628,3379,'he','×‘×ª×•×š<br>×”× ×—×” ×œ×ª×§×•×¤×”',0),(121629,3379,'el','Î•Î½Ï„ÏŒÏ‚<br>Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(121630,3379,'zh','åœ¨ä¼˜æƒ æœŸå†…\r\n',0),(121631,3379,'sv','Inom<br>Rabatt Period',0),(121632,3379,'it','All\'interno di<br>Periodo di sconto',0),(121633,3379,'tl','',0),(121634,3379,'th','&#3616;&#3634;&#3618;&#3651;&#3609;&#3619;&#3629;&#3610;&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(121635,3379,'hi','à¤•à¥‡ à¤­à¥€à¤¤à¤°<br>à¤›à¥‚à¤Ÿ à¤•à¥€ à¤…à¤µà¤§à¤¿',0),(121636,3379,'ms','Dalam tempoh<br>Diskaun tempoh',0),(121637,3379,'ar','Ø¶Ù…Ù†<br>Ø®ØµÙ… Ø§Ù„ÙØªØ±Ø©',0),(121638,3379,'fr','Au sein de<br>PÃ©riode de remise',0),(121639,3379,'jp','ãƒ‡ã‚£ã‚¹ã‚«ã‚¦ãƒ³ãƒˆæœŸé–“å†…',0),(121640,3379,'pt','No prazo de<br>PerÃ­odo de desconto',0),(121641,3379,'ru','Ð’ Ñ€Ð°Ð¼ÐºÐ°Ñ…<br>Ð›ÑŒÐ³Ð¾Ñ‚Ð½Ñ‹Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(121642,3379,'es','Dentro de<br>Periodo de descuento',0),(121643,3379,'de','Innerhalb<br>Rabatt-Zeitraum',0),(121644,3379,'en','Within<br>Discount Period',0),(121645,3380,'is','',0),(121646,3380,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ ÙƒØ§Ø±ÙŠ ',0),(121647,3380,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ ÙƒØ§Ø±ÙŠ ',0),(121648,3380,'tr','iÅŸ gÃ¼nleri',0),(121649,3380,'pl','dni pracy',0),(121650,3380,'bg','Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð´Ð½Ð¸',0),(121651,3380,'ur','Ú©Ø§Ù… Ø¯Ù†',0),(121652,3380,'sr','Ð Ð°Ð´Ð½Ð¸ Ð´Ð°Ð½Ð¸',0),(121653,3380,'vi','ngÃ y lÃ m viá»‡c',0),(121654,3380,'af','werksdae',0),(121655,3380,'ro','luni-vineri',0),(121656,3380,'et','TÃ¶Ã¶pÃ¤evi',0),(121657,3380,'si','delovnih dni',0),(121658,3380,'ba','hari kerja',0),(121659,3380,'nl','werkdagen',0),(121660,3380,'fi','tyÃ¶pÃ¤ivien',0),(121661,3380,'no','arbeidsdager',0),(121662,3380,'da','arbejdsdage',0),(121663,3380,'ko','ìž‘ì—… ì¼',0),(121664,3380,'he','×™×ž×™ ×¢×‘×•×“×”',0),(121665,3380,'el','Î·Î¼Î­ÏÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(121666,3380,'zh','å·¥ä½œæ—¥å†…\r\n',0),(121667,3380,'sv','arbetsdagar',0),(121668,3380,'it','giorni di lavoro',0),(121669,3380,'tl','',0),(121670,3380,'th','&#3623;&#3633;&#3609;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(121671,3380,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¦à¤¿à¤¨',0),(121672,3380,'ms','hari kerja',0),(121673,3380,'ar','Ø£ÙŠØ§Ù… Ø§Ù„Ø¹Ù…Ù„',0),(121674,3380,'fr','jours de travail',0),(121675,3380,'jp','å‹¤å‹™æ—¥æ•°',0),(121676,3380,'pt','dias de trabalho',0),(121677,3380,'ru','Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ðµ Ð´Ð½Ð¸',0),(121678,3380,'es','DÃ­as de Trabajo',0),(121679,3380,'de','Arbeitstage',0),(121680,3380,'en','work days',0),(121681,3381,'is','',0),(121682,3381,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(121683,3381,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(121684,3381,'tr','Ä°ÅŸ tÃ¼rÃ¼',0),(121685,3381,'pl','Typ pracy',0),(121686,3381,'bg','Ð’Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(121687,3381,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù…',0),(121688,3381,'sr','Ð’Ñ€ÑÑ‚Ðµ Ñ€Ð°Ð´Ð°',0),(121689,3381,'vi','Loáº¡i cÃ´ng viá»‡c',0),(121690,3381,'af','Werktipe',0),(121691,3381,'ro','Tipul de lucru',0),(121692,3381,'et','TÃ¶Ã¶ liik',0),(121693,3381,'si','Vrsta dela',0),(121694,3381,'ba','Jenis pekerjaan',0),(121695,3381,'nl','Werksoort',0),(121696,3381,'fi','TyÃ¶n tyyppi',0),(121697,3381,'no','Arbeidstype',0),(121698,3381,'da','Arbejdstype',0),(121699,3381,'ko','ìž‘ì—… í˜•ì‹',0),(121700,3381,'he','×¡×•×’ ×¢×‘×•×“×”',0),(121701,3381,'el','Î¤ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(121702,3381,'zh','å·¥ä½œç±»åž‹\r\n',0),(121703,3381,'sv','Arbetstyp',0),(121704,3381,'it','Tipo di lavoro',0),(121705,3381,'tl','',0),(121706,3381,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(121707,3381,'hi','à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(121708,3381,'ms','Jenis kerja',0),(121709,3381,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(121710,3381,'fr','Type de travail',0),(121711,3381,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—',0),(121712,3381,'pt','Tipo de trabalho',0),(121713,3381,'ru','Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(121714,3381,'es','Tipo de Trabajo',0),(121715,3381,'de','Arbeitstyp',0),(121716,3381,'en','Work Type',0),(121717,3382,'is','',0),(121718,3382,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(121719,3382,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(121720,3382,'tr','Ã‡alÄ±ÅŸma tÃ¼rÃ¼ Ekle',0),(121721,3382,'pl','DodaÄ‡ typ pracy',0),(121722,3382,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(121723,3382,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(121724,3382,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð°',0),(121725,3382,'vi','ThÃªm Loáº¡i cÃ´ng viá»‡c',0),(121726,3382,'af','Werktipes Byvoeg',0),(121727,3382,'ro','Adauga tip de munca',0),(121728,3382,'et','TÃ¶Ã¶ liigi lisamine',0),(121729,3382,'si','Vrsta dela dodati',0),(121730,3382,'ba','Menambahkan jenis pekerjaan',0),(121731,3382,'nl','Werksoort toevoegen',0),(121732,3382,'fi','TyÃ¶tyyppi lisÃ¤Ã¤',0),(121733,3382,'no','Arbeidstype legge',0),(121734,3382,'da','Arbejdstype tilfÃ¸je',0),(121735,3382,'ko','ìž‘ì—… ìœ í˜• ì¶”ê°€',0),(121736,3382,'he','×”×•×¡×£ ×¡×•×’ ×¢×‘×•×“×”',0),(121737,3382,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(121738,3382,'zh','å·¥ä½œç±»åž‹æ·»åŠ \r\n',0),(121739,3382,'sv','Arbetstyp lÃ¤gga till',0),(121740,3382,'it','Aggiungi tipo di lavoro',0),(121741,3382,'tl','',0),(121742,3382,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(121743,3382,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(121744,3382,'ms','Tambah jenis kerja',0),(121745,3382,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(121746,3382,'fr','Type de travail ajouter',0),(121747,3382,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—ã?®è¿½åŠ ',0),(121748,3382,'pt','Adicionar o tipo de trabalho',0),(121749,3382,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(121750,3382,'es','Agregar Tipo de Trabajo',0),(121751,3382,'de','Arbeitstyp hinzufÃ¼gen',0),(121752,3382,'en','Work Type Add',0),(121753,3383,'is','',0),(121754,3383,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(121755,3383,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(121756,3383,'tr','Ä°ÅŸ tÃ¼rÃ¼ baÅŸarÄ±yla eklendi.',0),(121757,3383,'pl','Praca typu dodane pomyÅ›lnie.',0),(121758,3383,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(121759,3383,'ur','Ù‚Ø³Ù… Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Ú©Ø§Ù… Ú©Ø±ØªÛ’ ÛÛŒÚº Û”',0),(121760,3383,'sr','Ð’Ñ€ÑÑ‚Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð·Ð° Ñ€Ð°Ð´Ð°.',0),(121761,3383,'vi','ThÃªm Loáº¡i cÃ´ng viá»‡c thÃ nh cÃ´ng',0),(121762,3383,'af','Werktipe suksesvol bygevoeg.',0),(121763,3383,'ro','Tip de munca adaugat cu succes',0),(121764,3383,'et','TÃ¶Ã¶ liigi lisamine Ãµnnestus',0),(121765,3383,'si','Delo uspeÅ¡no dodana vrsta.',0),(121766,3383,'ba','Bekerja jenis ditambahkan berhasil.',0),(121767,3383,'nl','Werksoort met succes toegevoegd.',0),(121768,3383,'fi','TyÃ¶tyypin lisÃ¤Ã¤minen onnistui.',0),(121769,3383,'no','Arbeidstype lagt.',0),(121770,3383,'da','Arbejde type tilfÃ¸jet.',0),(121771,3383,'ko','ìž‘ì—…ì„ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” í˜•ì‹.',0),(121772,3383,'he','×¢×•×‘×“×™× ×¡×•×’ × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(121773,3383,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(121774,3383,'zh','å·¥ä½œç±»åž‹æ·»åŠ æˆåŠŸã€‚\r\n',0),(121775,3383,'sv','Arbetstyp lagts.',0),(121776,3383,'it','Lavoro tipo aggiunto con successo.',0),(121777,3383,'tl','',0),(121778,3383,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(121779,3383,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾à¤® à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(121780,3383,'ms','Kerja jenis berjaya menambah.',0),(121781,3383,'ar','Ø£Ø¶ÙŠÙ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(121782,3383,'fr','Travail type ajoutÃ© avec succÃ¨s.',0),(121783,3383,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(121784,3383,'pt','Trabalho tipo adicionado com Ãªxito.',0),(121785,3383,'ru','Ð¢Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(121786,3383,'es','Tipo de Trabajo Agregado satisfactoriamente.',0),(121787,3383,'de','Arbeiten Sie Typ erfolgreich hinzugefÃ¼gt.',0),(121788,3383,'en','Work type added successfully.',0),(121789,3384,'is','',0),(121790,3384,'dr','Ø­Ø°Ù Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(121791,3384,'pr','Ø­Ø°Ù Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(121792,3384,'tr','Ä°ÅŸ tÃ¼rÃ¼ baÅŸarÄ±yla silindi.',0),(121793,3384,'pl','Praca typu usuniÄ™te pomyÅ›lnie.',0),(121794,3384,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(121795,3384,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù‚Ø³Ù… Ú©Ø§ Ú©Ø§Ù… ÛÛ’ Û”',0),(121796,3384,'sr','Ð Ð°Ð´Ð¸ Ñ‚Ð¸Ð¿ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ.',0),(121797,3384,'vi','XÃ³a Loáº¡i cÃ´ng viá»‡c thÃ nh cÃ´ng',0),(121798,3384,'af','Werktipe suksesvol geskrap.',0),(121799,3384,'ro','Tip de munca sters cu cucces',0),(121800,3384,'et','TÃ¶Ã¶ liigi kustutamine Ãµnnestus',0),(121801,3384,'si','Delo vrsta uspeÅ¡no izbrisana.',0),(121802,3384,'ba','Bekerja jenis berhasil dihapus.',0),(121803,3384,'nl','Werksoort verwijderd.',0),(121804,3384,'fi','TyÃ¶tyypin poistettu.',0),(121805,3384,'no','Arbeidstype slettet.',0),(121806,3384,'da','Arbejde type slettet.',0),(121807,3384,'ko','ìž‘ì—… ìœ í˜•ì„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(121808,3384,'he','×¢×•×‘×“×™× ×¡×•×’ × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(121809,3384,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(121810,3384,'zh','å·¥ä½œç±»åž‹å·²æˆåŠŸåˆ é™¤',0),(121811,3384,'sv','Arbetstyp raderades.',0),(121812,3384,'it','Lavoro tipo eliminato con successo.',0),(121813,3384,'tl','',0),(121814,3384,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(121815,3384,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾à¤® à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(121816,3384,'ms','Kerja jenis dihapuskan dengan jayanya.',0),(121817,3384,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(121818,3384,'fr','Travail type supprimÃ© avec succÃ¨s.',0),(121819,3384,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(121820,3384,'pt','Trabalho tipo excluÃ­do com sucesso.',0),(121821,3384,'ru','Ð¢Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½.',0),(121822,3384,'es','Tipo de trabajo eliminado satisfactoriamente.',0),(121823,3384,'de','Arbeiten Sie Typ erfolgreich gelÃ¶scht.',0),(121824,3384,'en','Work type deleted successfully.',0),(121825,3385,'is','',0),(121826,3385,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(121827,3385,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(121828,3385,'tr','Ä°ÅŸ tÃ¼rÃ¼ bulunamadÄ±.',0),(121829,3385,'pl','Praca typu nie znaleziono.',0),(121830,3385,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(121831,3385,'ur','Ù‚Ø³Ù… Ù†ÛÛŒÚº Ù…Ù„ Ú©Ø§Ù… Ú©Ø±ØªÛ’ ÛÛŒÚº Û”',0),(121832,3385,'sr','Ð Ð°Ð´Ð¸ Ñ‚Ð¸Ð¿ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(121833,3385,'vi','KhÃ´ng tháº¥y Loáº¡i cÃ´ng viá»‡c ',0),(121834,3385,'af','Werktipe nie gevind.',0),(121835,3385,'ro','Tip de munca negasit',0),(121836,3385,'et','TÃ¶Ã¶ liiki ei leitud',0),(121837,3385,'si','Delo tipa ni mogoÄe najti.',0),(121838,3385,'ba','Bekerja jenis tidak ditemukan.',0),(121839,3385,'nl','Werksoort niet gevonden.',0),(121840,3385,'fi','Toimi tyyppiÃ¤ ei lÃ¶ydy.',0),(121841,3385,'no','Arbeidstype ikke funnet.',0),(121842,3385,'da','Arbejde type blev ikke fundet.',0),(121843,3385,'ko','ìž‘ì—… ìœ í˜•ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(121844,3385,'he','×¢×•×‘×“×™× ×¡×•×’ ×œ× × ×ž×¦×.',0),(121845,3385,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï‚ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(121846,3385,'zh','å·¥ä½œç±»åž‹æœªæ‰¾åˆ°\r\n',0),(121847,3385,'sv','Fungerar typ inte hittas.',0),(121848,3385,'it','Tipo non trovato lavoro.',0),(121849,3385,'tl','',0),(121850,3385,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(121851,3385,'hi','à¤ªà¥à¤°à¤•à¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤•à¤¾à¤® à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(121852,3385,'ms','Kerja jenis tidak dijumpai.',0),(121853,3385,'ar','Ù†ÙˆØ¹ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¹Ù…Ù„.',0),(121854,3385,'fr','Type ne pas trouvÃ© de travail.',0),(121855,3385,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(121856,3385,'pt','Trabalho tipo nÃ£o encontrado.',0),(121857,3385,'ru','Ð¢Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(121858,3385,'es','Tipo de Trabajo no encontrado.',0),(121859,3385,'de','Arbeiten Sie Typ nicht gefunden.',0),(121860,3385,'en','Work type not found.',0),(121861,3386,'is','',0),(121862,3386,'dr','Ø³ÙˆØ§Ù„ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(121863,3386,'pr','Ø³ÙˆØ§Ù„ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(121864,3386,'tr','Ä°ÅŸ tÃ¼rÃ¼ soru',0),(121865,3386,'pl','Praca typu pytanie',0),(121866,3386,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð²ÑŠÐ¿Ñ€Ð¾Ñ',0),(121867,3386,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø³ÙˆØ§Ù„',0),(121868,3386,'sr','Ð Ð°Ð´ Ð¾Ñ‚ÐºÑƒÑ†Ð°Ñ˜Ñ‚Ðµ Ð¿Ð¸Ñ‚Ð°ÑšÐµ',0),(121869,3386,'vi','Loáº¡i cÃ¢u há»i',0),(121870,3386,'af','Werktipe Vraag',0),(121871,3386,'ro','Intrebare tip de munca',0),(121872,3386,'et','TÃ¶Ã¶ liigi kÃ¼simus',0),(121873,3386,'si','Delo vrsta vpraÅ¡anje',0),(121874,3386,'ba','Pekerjaan jenis pertanyaan',0),(121875,3386,'nl','Werk Type vraag',0),(121876,3386,'fi','WC ongelma',0),(121877,3386,'no','Arbeid Type spÃ¸rsmÃ¥l',0),(121878,3386,'da','Arbejdet Type spÃ¸rgsmÃ¥l',0),(121879,3386,'ko','ìž‘ì—… ìœ í˜• ì§ˆë¬¸',0),(121880,3386,'he','×©××œ×ª ×¡×•×’ ×¢×‘×•×“×”',0),(121881,3386,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï… ÎµÏÏŽÏ„Î·ÏƒÎ·',0),(121882,3386,'zh','å·¥ä½œç±»åž‹çš„é—®é¢˜\r\n',0),(121883,3386,'sv','Arbete typ frÃ¥ga',0),(121884,3386,'it','Domanda di lavoro tipo',0),(121885,3386,'tl','',0),(121886,3386,'th','&#3588;&#3635;&#3606;&#3634;&#3617;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(121887,3386,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¥à¤°à¤¶à¥à¤¨',0),(121888,3386,'ms','Soalan jenis kerja',0),(121889,3386,'ar','Ù…Ø³Ø£Ù„Ø© Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(121890,3386,'fr','Question de Type de travail',0),(121891,3386,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—è³ªå•?',0),(121892,3386,'pt','Pergunta de tipo de trabalho',0),(121893,3386,'ru','Ð’Ð¾Ð¿Ñ€Ð¾Ñ Ð¿Ð¾ Ð¢Ð¸Ð¿Ñƒ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(121894,3386,'es','Pregunta de Tipo de Trabajo',0),(121895,3386,'de','Arbeit-Typ-Frage',0),(121896,3386,'en','Work Type Question',0),(121897,3387,'is','',0),(121898,3387,'dr','Ø³ÙˆØ§Ù„ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(121899,3387,'pr','Ø³ÙˆØ§Ù„ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(121900,3387,'tr','Ä°ÅŸ tÃ¼rÃ¼ soru baÅŸarÄ±yla eklendi.',0),(121901,3387,'pl','Praca typu pytanie dodane pomyÅ›lnie.',0),(121902,3387,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð²ÑŠÐ¿Ñ€Ð¾Ñ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(121903,3387,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø³ÙˆØ§Ù„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Û”',0),(121904,3387,'sr','Ð Ð°Ð´ Ð¾Ñ‚ÐºÑƒÑ†Ð°Ñ˜Ñ‚Ðµ Ð¿Ð¸Ñ‚Ð°ÑšÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸.',0),(121905,3387,'vi','ThÃªm loáº¡i cÃ¢u há»i thÃ nh cÃ´ng',0),(121906,3387,'af','Werktipe vraag suksesvol bygevoeg.',0),(121907,3387,'ro','Intrebare tip de munca adaugata cu succes',0),(121908,3387,'et','TÃ¶Ã¶ liigi kÃ¼simuse lisamine Ã¼nnestus',0),(121909,3387,'si','Delo vrsta vpraÅ¡anje uspeÅ¡no dodana.',0),(121910,3387,'ba','Pekerjaan jenis pertanyaan ditambahkan berhasil.',0),(121911,3387,'nl','Werk type vraag met succes toegevoegd.',0),(121912,3387,'fi','TyÃ¶n tyyppi kysymys lisÃ¤Ã¤minen onnistui.',0),(121913,3387,'no','Arbeid type spÃ¸rsmÃ¥l lagt.',0),(121914,3387,'da','Arbejdet type spÃ¸rgsmÃ¥l tilfÃ¸jet.',0),(121915,3387,'ko','ìž‘ì—… ìœ í˜• ì§ˆë¬¸ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(121916,3387,'he','×©××œ×ª ×¡×•×’ ×¢×‘×•×“×” × ×•×¡×£ ×‘×”×¦×œ×—×”.',0),(121917,3387,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï… ÎµÏÏŽÏ„Î·ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(121918,3387,'zh','å·¥ä½œç±»åž‹çš„é—®é¢˜æ·»åŠ æˆåŠŸ\r\n',0),(121919,3387,'sv','Arbete typ frÃ¥ga lagts.',0),(121920,3387,'it','Domanda di lavoro tipo aggiunto con successo.',0),(121921,3387,'tl','',0),(121922,3387,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3606;&#3634;&#3617;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(121923,3387,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤µà¤¾à¤² à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(121924,3387,'ms','Soalan jenis kerja berjaya menambah.',0),(121925,3387,'ar','Ø£Ø¶ÙŠÙ Ø³Ø¤Ø§Ù„ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(121926,3387,'fr','Question de type de travail ajoutÃ©e avec succÃ¨s.',0),(121927,3387,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—è³ªå•?ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(121928,3387,'pt','Pergunta de tipo de trabalho adicionada com Ãªxito.',0),(121929,3387,'ru','Ð’Ð¾Ð¿Ñ€Ð¾Ñ Ð¿Ð¾ Ñ‚Ð¸Ð¿Ñƒ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(121930,3387,'es','Pregunta de trabajo agregada satisfactoriamente.',0),(121931,3387,'de','Arbeit-Typ-Frage erfolgreich hinzugefÃ¼gt.',0),(121932,3387,'en','Work type question added successfully.',0),(121933,3388,'is','',0),(121934,3388,'dr','Ø³ÙˆØ§Ù„ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(121935,3388,'pr','Ø³ÙˆØ§Ù„ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(121936,3388,'tr','Ä°ÅŸ tÃ¼rÃ¼ soru baÅŸarÄ±yla silindi.',0),(121937,3388,'pl','Praca typu pytanie usuniÄ™te pomyÅ›lnie.',0),(121938,3388,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð²ÑŠÐ¿Ñ€Ð¾Ñ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(121939,3388,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø³ÙˆØ§Ù„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(121940,3388,'sr','Ð Ð°Ð´ Ð¾Ñ‚ÐºÑƒÑ†Ð°Ñ˜Ñ‚Ðµ Ð¿Ð¸Ñ‚Ð°ÑšÐµ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(121941,3388,'vi','XÃ³a loáº¡i cÃ¢u há»i thÃ nh cÃ´ng',0),(121942,3388,'af','Werktipe vraag suksesvol geskrap.',0),(121943,3388,'ro','Intrebare tip de munca stearsa cu succes',0),(121944,3388,'et','TÃ¶Ã¶ liigi kÃ¼simuse kustutamine Ãµnnestus',0),(121945,3388,'si','Delo vrsta vpraÅ¡anje uspeÅ¡no izbrisana.',0),(121946,3388,'ba','Pekerjaan jenis pertanyaan berhasil dihapus.',0),(121947,3388,'nl','Werk type vraag verwijderd.',0),(121948,3388,'fi','TyÃ¶n tyyppi kysymys poistettu.',0),(121949,3388,'no','Arbeid type spÃ¸rsmÃ¥l slettet.',0),(121950,3388,'da','Arbejdet type spÃ¸rgsmÃ¥l slettet.',0),(121951,3388,'ko','ìž‘ì—… ìœ í˜• ì§ˆë¬¸ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(121952,3388,'he','×©××œ×ª ×¡×•×’ ×¢×‘×•×“×” × ×ž×—×§ ×‘×”×¦×œ×—×”.',0),(121953,3388,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï… ÎµÏÏŽÏ„Î·ÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(121954,3388,'zh','å·¥ä½œç±»åž‹çš„é—®é¢˜å·²æˆåŠŸåˆ é™¤ã€‚\r\n',0),(121955,3388,'sv','Arbete typ frÃ¥ga raderades.',0),(121956,3388,'it','Domanda di lavoro tipo eliminato con successo.',0),(121957,3388,'tl','',0),(121958,3388,'th','&#3621;&#3610;&#3588;&#3635;&#3606;&#3634;&#3617;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(121959,3388,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¥à¤°à¤¶à¥à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(121960,3388,'ms','Soalan jenis kerja dihapuskan dengan jayanya.',0),(121961,3388,'ar','Ø­Ø°Ù Ø³Ø¤Ø§Ù„ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(121962,3388,'fr','Question de type travail supprimÃ©e avec succÃ¨s.',0),(121963,3388,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—è³ªå•?ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(121964,3388,'pt','Pergunta de tipo trabalho excluÃ­da com sucesso.',0),(121965,3388,'ru','Ð’Ð¾Ð¿Ñ€Ð¾Ñ Ð¿Ð¾ Ñ‚Ð¸Ð¿Ñƒ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½.',0),(121966,3388,'es','Tipo de pregunta de trabajo eliminada satisfactoriamente.',0),(121967,3388,'de','Arbeit-Typ-Frage erfolgreich gelÃ¶scht.',0),(121968,3388,'en','Work type question deleted successfully.',0),(121969,3389,'is','',0),(121970,3389,'dr','Ø³ÙˆØ§Ù„ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(121971,3389,'pr','Ø³ÙˆØ§Ù„ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(121972,3389,'tr','Ä°ÅŸ tÃ¼rÃ¼ soru baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(121973,3389,'pl','Praca typu pytanie pomyÅ›lnie zaktualizowana.',0),(121974,3389,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð²ÑŠÐ¿Ñ€Ð¾Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(121975,3389,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø³ÙˆØ§Ù„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Û”',0),(121976,3389,'sr','Ð Ð°Ð´ Ð¾Ñ‚ÐºÑƒÑ†Ð°Ñ˜Ñ‚Ðµ Ð¿Ð¸Ñ‚Ð°ÑšÐµ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(121977,3389,'vi','Cáº­p Nháº­t CÃ¢u Há»i CÃ´ng Viá»‡c thÃ nh cÃ´ng',0),(121978,3389,'af','Werktipe vraag suksesvol opdateer.',0),(121979,3389,'ro','Intrebare tip de munca actualizata cu succes',0),(121980,3389,'et','TÃ¶Ã¶ liigi kÃ¼simuse uuendamine Ãµnnestus',0),(121981,3389,'si','Delo vrsta vpraÅ¡anje uspeÅ¡no posodobljena.',0),(121982,3389,'ba','Pekerjaan jenis pertanyaan diperbarui berhasil.',0),(121983,3389,'nl','Werk type vraag bijgewerkt.',0),(121984,3389,'fi','TyÃ¶n tyyppi kysymys pÃ¤ivittÃ¤minen onnistui.',0),(121985,3389,'no','Arbeid type spÃ¸rsmÃ¥l oppdatert.',0),(121986,3389,'da','Arbejdet type spÃ¸rgsmÃ¥l opdateret.',0),(121987,3389,'ko','ìž‘ì—… ìœ í˜• ì§ˆë¬¸ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(121988,3389,'he','×©××œ×ª ×¡×•×’ ×¢×‘×•×“×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(121989,3389,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï… ÎµÏÏŽÏ„Î·ÏƒÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(121990,3389,'zh','å·¥ä½œç±»åž‹çš„é—®é¢˜æ›´æ–°æˆåŠŸã€‚\r\n',0),(121991,3389,'sv','Arbete typ frÃ¥ga uppdaterats.',0),(121992,3389,'it','Domanda di lavoro tipo aggiornato con successo.',0),(121993,3389,'tl','',0),(121994,3389,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3606;&#3634;&#3617;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3',0),(121995,3389,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¥à¤°à¤¶à¥à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(121996,3389,'ms','Soalan jenis kerja berjaya dikemas kini.',0),(121997,3389,'ar','Ø­Ø¯Ù‘Ø« Ø³Ø¤Ø§Ù„ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(121998,3389,'fr','Question de type de travail mis Ã  jour avec succÃ¨s.',0),(121999,3389,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—è³ªå•?ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(122000,3389,'pt','Pergunta de tipo de trabalho atualizada com Ãªxito.',0),(122001,3389,'ru','Ð’Ð¾Ð¿Ñ€Ð¾Ñ Ð¿Ð¾ Ñ‚Ð¸Ð¿Ñƒ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½.',0),(122002,3389,'es','Tipo de pregunta de trabajo actualizada satisfactoriamente.',0),(122003,3389,'de','Arbeit-Typ-Frage erfolgreich aktualisiert.',0),(122004,3389,'en','Work type question updated successfully.',0),(122005,3390,'is','',0),(122006,3390,'dr','Ù„ÙŠØ³Øª Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(122007,3390,'pr','Ù„ÙŠØ³Øª Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(122008,3390,'tr','Ã‡alÄ±ÅŸma tipi standart boyut listesi',0),(122009,3390,'pl','ListÄ™ rozmiar standardowy typ pracy',0),(122010,3390,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€ ÑÐ¿Ð¸ÑÑŠÐº',0),(122011,3390,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ø³Ø§Ø¦Ø² Ú©ÛŒ ÙÛØ±Ø³Øª',0),(122012,3390,'sr','Ð Ð°Ð´ Ñ‚Ð¸Ð¿ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð»Ð¸ÑÑ‚Ð°',0),(122013,3390,'vi','Danh sÃ¡ch cá»¡ chuáº©n cá»§a Loáº¡i cÃ´ng viá»‡c',0),(122014,3390,'af','Werktipe Standaard Grootte Lys',0),(122015,3390,'ro','Lista de dimensiuni Standard de lucru tip',0),(122016,3390,'et','TÃ¶Ã¶ liigi standardmahu nimekiri',0),(122017,3390,'si','Delo vrsta standardne velikosti seznam',0),(122018,3390,'ba','Daftar ukuran standar jenis pekerjaan',0),(122019,3390,'nl','Werk Type standaard formaat lijst',0),(122020,3390,'fi','TyÃ¶n vakiokoko luettelosta',0),(122021,3390,'no','Arbeid Type Standard stÃ¸rrelse-listen',0),(122022,3390,'da','Arbejdet Type Standard stÃ¸rrelse liste',0),(122023,3390,'ko','ìž‘ì—… ìœ í˜• í‘œì¤€ í¬ê¸° ëª©ë¡',0),(122024,3390,'he','×”×¨×©×™×ž×” ×’×•×“×œ ×¡×˜× ×“×¨×˜×™ ×¡×•×’ ×¢×‘×•×“×”',0),(122025,3390,'el','Î¤Î¿ Ï„Ï…Ï€Î¹ÎºÏŒ Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î»Î¯ÏƒÏ„Î± ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï‚',0),(122026,3390,'zh','å·¥ä½œç±»åž‹æ ‡å‡†å°ºå¯¸è¡¨\r\n',0),(122027,3390,'sv','Typ Standard storlek arbetslista',0),(122028,3390,'it','Elenco di dimensioni Standard tipo di lavoro',0),(122029,3390,'tl','',0),(122030,3390,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3609;&#3634;&#3604;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(122031,3390,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤° à¤¸à¥‚à¤šà¥€',0),(122032,3390,'ms','Senarai Standard saiz jenis kerja',0),(122033,3390,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(122034,3390,'fr','Liste de taille Standard pour le Type de travail',0),(122035,3390,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—æ¨™æº–ã‚µã‚¤ã‚ºãƒªã‚¹ãƒˆ',0),(122036,3390,'pt','Lista de tamanho padrÃ£o do tipo de trabalho',0),(122037,3390,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð³Ð¾ Ñ€Ð°Ð·Ð¼ÐµÑ€Ð° ÑÐ¿Ð¸ÑÐºÐ°',0),(122038,3390,'es','Lista de  Tipo de Trabajo tamaÃ±o estandar ',0),(122039,3390,'de','Arbeit StandardgrÃ¶ÃŸe Typenliste',0),(122040,3390,'en','Work Type Standard Size List',0),(122041,3391,'is','',0),(122042,3391,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(122043,3391,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(122044,3391,'tr','Ä°ÅŸ tÃ¼rÃ¼ gÃ¼ncelleÅŸtirme',0),(122045,3391,'pl','Praca typu Update',0),(122046,3391,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(122047,3391,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(122048,3391,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ð¸Ð¿ Ð¿Ð¾ÑÐ»Ð°',0),(122049,3391,'vi','Cáº­p Nháº­t Loáº¡i CÃ´ng Viá»‡c',0),(122050,3391,'af','Werk Tipe Opdateer',0),(122051,3391,'ro','Actualizare tip de munca',0),(122052,3391,'et','TÃ¶Ã¶ liigi uuendus',0),(122053,3391,'si','Delo vrsta posodobitev',0),(122054,3391,'ba','Pekerjaan jenis Update',0),(122055,3391,'nl','Werk Type Update',0),(122056,3391,'fi','TyÃ¶n tyypin pÃ¤ivitys',0),(122057,3391,'no','Arbeid Type oppdatering',0),(122058,3391,'da','Arbejdet Type opdatering',0),(122059,3391,'ko','ìž‘ì—… í˜•ì‹ ì—…ë°ì´íŠ¸',0),(122060,3391,'he','×¢×“×›×•×Ÿ ×¡×•×’ ×¢×‘×•×“×”',0),(122061,3391,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(122062,3391,'zh','å·¥ä½œç±»åž‹æ›´æ–°\r\n',0),(122063,3391,'sv','Arbete typ uppdatering',0),(122064,3391,'it','Lavoro tipo aggiornamento',0),(122065,3391,'tl','',0),(122066,3391,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(122067,3391,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(122068,3391,'ms','Kemaskini jenis kerja',0),(122069,3391,'ar','ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(122070,3391,'fr','Mise Ã  jour du Type de travail',0),(122071,3391,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—ã?®æ›´æ–°',0),(122072,3391,'pt','ActualizaÃ§Ã£o do tipo de trabalho',0),(122073,3391,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(122074,3391,'es','Tipo de Trabajo Actualizado',0),(122075,3391,'de','Arbeit Typ Update',0),(122076,3391,'en','Work Type Update',0),(122077,3392,'is','',0),(122078,3392,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(122079,3392,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(122080,3392,'tr','Ä°ÅŸ tÃ¼rÃ¼ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(122081,3392,'pl','Praca typu pomyÅ›lnie zaktualizowana.',0),(122082,3392,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(122083,3392,'ur','Ù‚Ø³Ù… Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø§Ù… Ú©Ø±ØªÛ’ ÛÛŒÚº Û”',0),(122084,3392,'sr','Ð Ð°Ð´Ð¸ Ñ‚Ð¸Ð¿ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(122085,3392,'vi','Cáº­p Nháº­t Loáº¡i CÃ´ng Viá»‡c thÃ nh cÃ´ng',0),(122086,3392,'af','Werk tipe suksesvol opdateer.',0),(122087,3392,'ro','Tip de munca actualizat cu succes',0),(122088,3392,'et','TÃ¶Ã¶ liigi uuendamine Ãµnnestus',0),(122089,3392,'si','Delo vrsta uspeÅ¡no posodobljena.',0),(122090,3392,'ba','Bekerja jenis diperbarui berhasil.',0),(122091,3392,'nl','Werksoort bijgewerkt.',0),(122092,3392,'fi','TyÃ¶tyypin pÃ¤ivitettiin onnistuneesti.',0),(122093,3392,'no','Arbeidstype oppdatert.',0),(122094,3392,'da','Arbejde type opdateret.',0),(122095,3392,'ko','ìž‘ì—…ì„ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” í˜•ì‹.',0),(122096,3392,'he','×¢×•×‘×“×™× ×¡×•×’ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(122097,3392,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(122098,3392,'zh','å·¥ä½œç±»åž‹æ›´æ–°æˆåŠŸã€‚\r\n',0),(122099,3392,'sv','Arbetstyp uppdaterats.',0),(122100,3392,'it','Lavoro tipo aggiornato con successo.',0),(122101,3392,'tl','',0),(122102,3392,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(122103,3392,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾à¤® à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(122104,3392,'ms','Kerja jenis berjaya dikemas kini.',0),(122105,3392,'ar','Ø­Ø¯Ù‘Ø« Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(122106,3392,'fr','Travail type mis Ã  jour avec succÃ¨s.',0),(122107,3392,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(122108,3392,'pt','Trabalho tipo atualizado com Ãªxito.',0),(122109,3392,'ru','Ð¢Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½.',0),(122110,3392,'es','Tipo de Trabajo Actualizado satisfactoriamente.',0),(122111,3392,'de','Arbeiten Sie Typ erfolgreich aktualisiert.',0),(122112,3392,'en','Work type updated successfully.',0),(122113,3393,'is','',0),(122114,3393,'dr','Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± ',0),(122115,3393,'pr','Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± ',0),(122116,3393,'tr','Ä°ÅŸ tÃ¼rleri',0),(122117,3393,'pl','Rodzaj pracy',0),(122118,3393,'bg','Ð’Ð¸Ð´Ð¾Ð²Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(122119,3393,'ur','Ú©Ø§Ù… Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(122120,3393,'sr','Ð’Ñ€ÑÑ‚Ðµ Ñ€Ð°Ð´Ð°',0),(122121,3393,'vi','Loáº¡i cÃ´ng viá»‡c',0),(122122,3393,'af','Werktipes',0),(122123,3393,'ro','Tipuri de lucru',0),(122124,3393,'et','TÃ¶Ã¶ liik',0),(122125,3393,'si','Vrste dela',0),(122126,3393,'ba','Jenis pekerjaan',0),(122127,3393,'nl','Werksoorten',0),(122128,3393,'fi','TyÃ¶tyypit',0),(122129,3393,'no','Arbeidstyper',0),(122130,3393,'da','Arbejdstyper',0),(122131,3393,'ko','ìž‘ì—… í˜•ì‹',0),(122132,3393,'he','×¡×•×’×™ ×”×¢×‘×•×“×”',0),(122133,3393,'el','Î¤Î¿Ï…Ï‚ Ï„ÏÏ€Î¿Ï…Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(122134,3393,'zh','å·¥ä½œç±»åž‹\r\n',0),(122135,3393,'sv','Arbetstyper',0),(122136,3393,'it','Tipi di lavoro',0),(122137,3393,'tl','',0),(122138,3393,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(122139,3393,'hi','à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤°',0),(122140,3393,'ms','Jenis-jenis kerja yang',0),(122141,3393,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¹Ù…Ù„',0),(122142,3393,'fr','Types de travail',0),(122143,3393,'jp','å‹¤å‹™ã‚¿ã‚¤ãƒ—',0),(122144,3393,'pt','Tipos de trabalho',0),(122145,3393,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(122146,3393,'es','Tipos de Trabajo',0),(122147,3393,'de','Arbeitstypen',0),(122148,3393,'en','Work Types',0),(122149,3394,'is','',0),(122150,3394,'dr','Ù†Ø§Ù… Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(122151,3394,'pr','Ù†Ø§Ù… Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(122152,3394,'tr','Ã‡alÄ±ÅŸma alanÄ± adÄ±',0),(122153,3394,'pl','Nazwa obszaru pracy',0),(122154,3394,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(122155,3394,'ur','Ú©Ø§Ù… Ø¬Ú¯Û Ú©Ø§ Ù†Ø§Ù…',0),(122156,3394,'sr','Ð˜Ð¼Ðµ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ Ñ€Ð°Ð´Ð°',0),(122157,3394,'vi','TÃªn khu vá»±c lÃ m viá»‡c',0),(122158,3394,'af','Werk Area Naam',0),(122159,3394,'ro','Numele de domeniu munca',0),(122160,3394,'et','TÃ¶Ã¶ala nimi',0),(122161,3394,'si','Ime obmoÄja dela',0),(122162,3394,'ba','Nama daerah kerja',0),(122163,3394,'nl','Werk gebied naam',0),(122164,3394,'fi','TyÃ¶tÃ¤ Alueen_nimi',0),(122165,3394,'no','Arbeid omrÃ¥denavn',0),(122166,3394,'da','Arbejde omrÃ¥de navn',0),(122167,3394,'ko','ìž‘ì—… ì˜ì—­ ì´ë¦„',0),(122168,3394,'he','×©× ××–×•×¨ ×¢×‘×•×“×”',0),(122169,3394,'el','ÎŒÎ½Î¿Î¼Î± Ï‡ÏŽÏÎ¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(122170,3394,'zh','å·¥ä½œåŒºåç§°\r\n',0),(122171,3394,'sv','Arbete omrÃ¥det namn',0),(122172,3394,'it','Nome dell\'Area di lavoro',0),(122173,3394,'tl','',0),(122174,3394,'th','&#3594;&#3639;&#3656;&#3629;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(122175,3394,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤•à¤¾ à¤¨à¤¾à¤®',0),(122176,3394,'ms','Nama kawasan kerja',0),(122177,3394,'ar','Ø§Ø³Ù… Ù…Ø³Ø§Ø­Ø© Ø§Ù„Ø¹Ù…Ù„',0),(122178,3394,'fr','Nom de zone de travail',0),(122179,3394,'jp','å‹¤å‹™åœ°åŸŸå??',0),(122180,3394,'pt','Nome da Ã¡rea de trabalho',0),(122181,3394,'ru','Ð˜Ð¼Ñ Ñ€Ð°Ð±Ð¾Ñ‡ÐµÐ¹ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(122182,3394,'es','Nombre de Area de Trabajo',0),(122183,3394,'de','Arbeit Bereichsname',0),(122184,3394,'en','Work Area Name',0),(122185,3395,'is','',0),(122186,3395,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(122187,3395,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(122188,3395,'tr','Yeni Ã§alÄ±ÅŸma alanÄ± ekleme',0),(122189,3395,'pl','Dodaj nowe miejsca pracy',0),(122190,3395,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(122191,3395,'ur','Ù†ÛŒØ§ Ú©Ø§Ù… Ø¹Ù„Ø§Ù‚Û Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(122192,3395,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð¿Ñ€Ð¾ÑÑ‚Ð¾Ñ€Ð°',0),(122193,3395,'vi','ThÃªm khu vá»±c lÃ m viá»‡c má»›i',0),(122194,3395,'af','Nuwe Werk Area Byvoeg',0),(122195,3395,'ro','Adauga noi zona de lucru',0),(122196,3395,'et','Lisa uus tÃ¶Ã¶aala',0),(122197,3395,'si','Dodaj nov delovni prostor',0),(122198,3395,'ba','Menambahkan baru Area kerja',0),(122199,3395,'nl','Toevoegen van nieuwe werkgebied',0),(122200,3395,'fi','LisÃ¤Ã¤ uusi tyÃ¶alue',0),(122201,3395,'no','Legge til nye arbeidsomrÃ¥det',0),(122202,3395,'da','TilfÃ¸je nye arbejdsomrÃ¥de',0),(122203,3395,'ko','ìƒˆ ìž‘ì—… ì˜ì—­ì„ ì¶”ê°€',0),(122204,3395,'he','×”×•×¡×£ ××–×•×¨ ×¢×‘×•×“×” ×—×“×©×”',0),(122205,3395,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï‡ÏŽÏÎ¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(122206,3395,'zh','æ·»åŠ æ–°å·¥ä½œé¢†åŸŸ\r\n',0),(122207,3395,'sv','LÃ¤gg till ny arbetsplats',0),(122208,3395,'it','Aggiungere la nuova Area di lavoro',0),(122209,3395,'tl','',0),(122210,3395,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;&#3651;&#3627;&#3617;&#3656;',0),(122211,3395,'hi','à¤¨à¤ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(122212,3395,'ms','Menambah kawasan kerja baru',0),(122213,3395,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø³Ø§Ø­Ø© Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(122214,3395,'fr','Ajouter la nouvelle zone de travail',0),(122215,3395,'jp','å‹¤å‹™åœ°åŸŸã?®è¿½åŠ ',0),(122216,3395,'pt','Adicionar a nova Ã¡rea de trabalho',0),(122217,3395,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(122218,3395,'es','Agregar Nueva Area de Trabajo',0),(122219,3395,'de','FÃ¼gen neuer Arbeitsbereich hinzu',0),(122220,3395,'en','Add New Work Area',0),(122221,3396,'is','',0),(122222,3396,'dr','ÙŠÙƒ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù… Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(122223,3396,'pr','ÙŠÙƒ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù… Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(122224,3396,'tr','Bu adda bir Workarea zaten',0),(122225,3396,'pl','JuÅ¼ z tej nazwy pola pracy',0),(122226,3396,'bg','Workarea Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ñ Ñ‚Ð¾Ð²Ð° Ð¸Ð¼Ðµ',0),(122227,3396,'ur','Ø§ÛŒÚ© ÙˆÙˆØ±Ú©Ø¢Ø±ÛŒØ§ Ú©Û’ Ø³Ø§ØªÚ¾ ÛŒÛ Ù†Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(122228,3396,'sr','Ð¡Ð° Ð¾Ð²Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð½Ð° WÐ¾Ñ€ÐºÐ°Ñ€ÐµÐ°',0),(122229,3396,'vi','1 khu vá»±c lÃ m viá»‡c Ä‘Ã£ tá»“n táº¡i vá»›i tÃªn nÃ y',0),(122230,3396,'af','\'n Werkarea met Hierdie Naam Bestaan Alreeds',0),(122231,3396,'ro','O Workarea existÄƒ deja cu acest nume',0),(122232,3396,'et','Selle nimega tÃ¶Ã¶ala juba eksisteerib',0),(122233,3396,'si','A Workarea s tem imenom Å¾e obstaja',0),(122234,3396,'ba','Workarea sudah ada dengan nama ini',0),(122235,3396,'nl','Een Workarea bestaat met deze naam',0),(122236,3396,'fi','Workarea jo olemassa',0),(122237,3396,'no','Et Workarea finnes allerede med dette navnet',0),(122238,3396,'da','Der findes allerede en Workarea med dette navn',0),(122239,3396,'ko','ì´ ì´ë¦„ìœ¼ë¡œ ì´ë¯¸ ì¡´ìž¬ í•˜ëŠ” Workarea',0),(122240,3396,'he','Workarea ×›×‘×¨ ×§×™×™× ×‘×©× ×–×”',0),(122241,3396,'el','ÎˆÎ½Î± Workarea Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(122242,3396,'zh','å·¥ä½œåŒºåç§°å·²ç»å­˜åœ¨\r\n',0),(122243,3396,'sv','Det finns redan ett arbetsfÃ¤lt med detta namn',0),(122244,3396,'it','Un Workarea esiste giÃ  con questo nome',0),(122245,3396,'tl','',0),(122246,3396,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;&#3604;&#3657;&#3623;&#3618;&#3594;&#3639;&#3656;&#3629;&#3609;&#3637;&#3657;',0),(122247,3396,'hi','à¤à¤• Workarea à¤‡à¤¸ à¤¨à¤¾à¤® à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(122248,3396,'ms','Workarea yang telah sedia wujud dengan nama ini',0),(122249,3396,'ar','ÙˆÙˆØ±ÙƒØ§Ø±ÙŠØ§ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹ Ø¨Ù‡Ø°Ø§ Ø§Ù„Ø§Ø³Ù…',0),(122250,3396,'fr','Un Workarea existe dÃ©jÃ  avec ce nom',0),(122251,3396,'jp','ã?“ã?®å??å‰?ã?§ã?™ã?§ã?«å‹¤å‹™åœ°åŸŸã?Œå­˜åœ¨ã?—ã?¾ã?™',0),(122252,3396,'pt','Uma Workarea jÃ¡ existe com este nome',0),(122253,3396,'ru','ÐžÐ±Ð»Ð°ÑÑ‚Ð¸ Ñ Ñ‚Ð°ÐºÐ¸Ð¼ Ð¸Ð¼ÐµÐ½ÐµÐ¼ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(122254,3396,'es','Area de Trabajo ya existe con este Nombre',0),(122255,3396,'de','Eine Workarea mit diesem Namen ist bereits vorhanden.',0),(122256,3396,'en','A Workarea Already Exists with This Name',0),(122257,3397,'is','',0),(122258,3397,'dr','ØªØ¹ÙŠÙŠÙ† Ø³ÙØ§Ø±Ø´ Ùˆ Ù†ÙˆØ¹ Ø¨Ù‡ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(122259,3397,'pr','ØªØ¹ÙŠÙŠÙ† Ø³ÙØ§Ø±Ø´ Ùˆ Ù†ÙˆØ¹ Ø¨Ù‡ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(122260,3397,'tr','SipariÅŸ ve tip workareas iÃ§in atama',0),(122261,3397,'pl','PrzypisaÄ‡ kolejnoÅ›Ä‡ i rodzaj odseparowanych miej',0),(122262,3397,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´ Ð¸ Ð²Ð¸Ð´ Ð½Ð° workareas',0),(122263,3397,'ur','Ø¢Ø±ÚˆØ± Ø§ÙˆØ± Ù‚Ø³Ù… ÙˆÙˆØ±Ú©Ø§Ø±ÛŒØ³ Ú©Ùˆ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(122264,3397,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ñ€ÐµÐ´ Ð¸ Ñ‚Ð¸Ð¿ wÐ¾Ñ€ÐºÐ°Ñ€ÐµÐ°Ñ',0),(122265,3397,'vi','Chá»‰ Ä‘á»‹nh Ä‘Æ¡n hÃ ng & loáº¡i tá»›i khu vá»±c lÃ m viá»‡c',0),(122266,3397,'af','Orde en tipe wys vir workareas',0),(122267,3397,'ro','Atribui ordine si tip workareas',0),(122268,3397,'et','Lisa tellimus ja sisesta tÃ¶Ã¶ala',0),(122269,3397,'si','Dodeljevanje nalog in vrsto workareas',0),(122270,3397,'ba','Menetapkan urutan dan ketik workareas',0),(122271,3397,'nl','Volgorde en type toewijzen aan workareas',0),(122272,3397,'fi','MÃ¤Ã¤ritÃ¤ tilauksen ja tyyppi workareas',0),(122273,3397,'no','Tilordne rekkefÃ¸lgen og typen til workareas',0),(122274,3397,'da','Tildele workareas rÃ¦kkefÃ¸lge og type',0),(122275,3397,'ko','Workareasì— ìˆœì„œ ë° ìœ í˜• í• ë‹¹',0),(122276,3397,'he','×œ×”×§×¦×•×ª ×¡×“×¨ ×•×¡×•×’ workareas',0),(122277,3397,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ Ï„Î¬Î¾Î·Ï‚ ÎºÎ±Î¹ Ï„ÏÏ€Î¿Ï… ÏƒÎµ ÎµÏ€Î¹Ï†Î¬Î½ÎµÎ¹ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÏƒÏ„Î¿',0),(122278,3397,'zh','åˆ†é…é¡ºåºå’Œç±»åž‹åˆ°å·¥ä½œé¢†åŸŸ\r\n',0),(122279,3397,'sv','Tilldela workareas ordning och typ',0),(122280,3397,'it','Assegnare l\'ordine e tipo di workareas',0),(122281,3397,'tl','',0),(122282,3397,'th','&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3649;&#3621;&#3632;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3652;&#3611;&#3626;&#3641;&#3656;&#3614;&#3639;&#3657;&#3609;&#3607;&#3',0),(122283,3397,'hi','à¤•à¥à¤°à¤® à¤”à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ workareas',0),(122284,3397,'ms','Peruntukkan perintah dan jenis workareas',0),(122285,3397,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„ØªØ±ØªÙŠØ¨ ÙˆÙ†ÙˆØ¹ ÙˆÙˆØ±ÙƒØ§Ø±ÙŠØ³',0),(122286,3397,'fr','Attribuer l\'ordre et le type de workareas',0),(122287,3397,'jp','å‹¤å‹™åœ°åŸŸã?®æ³¨æ–‡ã?¨ã‚¿ã‚¤ãƒ—ã?®å‰²ã‚Šå½“ã?¦',0),(122288,3397,'pt','Atribuir ordem e tipo para workareas',0),(122289,3397,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¸ Ñ‚Ð¸Ð¿ workareas',0),(122290,3397,'es','Asignar pedido y tipo de Ã¡reas de trabajo',0),(122291,3397,'de','Workareas Ordnung und Typ zuweisen',0),(122292,3397,'en','Assign order and type to workareas',0),(122293,3398,'is','',0),(122294,3398,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(122295,3398,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(122296,3398,'tr','Ã‡alÄ±ÅŸma AlanÄ± GÃ¼ncelleÅŸtir',0),(122297,3398,'pl','Obszar roboczy aktualizacji',0),(122298,3398,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(122299,3398,'ur','Ú©Ø§Ù… Ø¬Ú¯Û Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(122300,3398,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð¿Ñ€Ð¾ÑÑ‚Ð¾Ñ€Ð°',0),(122301,3398,'vi','Cáº­p Nháº­t Khu Vá»±c LÃ m Viá»‡c',0),(122302,3398,'af','Opdateer Werk Area',0),(122303,3398,'ro','Zona de lucru actualizare',0),(122304,3398,'et','TÃ¶Ã¶ala uuendamine',0),(122305,3398,'si','Posodobite delovno obmoÄje',0),(122306,3398,'ba','Memperbarui Area kerja',0),(122307,3398,'nl','Werkgebied bijgewerkt',0),(122308,3398,'fi','PÃ¤ivitÃ¤ tyÃ¶alue',0),(122309,3398,'no','Oppdatere arbeidsomrÃ¥det',0),(122310,3398,'da','Opdatere arbejdsomrÃ¥de',0),(122311,3398,'ko','ìž‘ì—… ì˜ì—­ ì—…ë°ì´íŠ¸',0),(122312,3398,'he','×¢×“×›×•×Ÿ ×¤×™× ×ª ×¢×‘×•×“×”',0),(122313,3398,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÎµÏÎ¹Î¿Ï‡Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(122314,3398,'zh','æ›´æ–°å·¥ä½œåŒº\r\n',0),(122315,3398,'sv','Uppdatera arbetsomrÃ¥det',0),(122316,3398,'it','Area di lavoro di aggiornamento',0),(122317,3398,'tl','',0),(122318,3398,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(122319,3398,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(122320,3398,'ms','Kawasan kerja Kemaskini',0),(122321,3398,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø³Ø§Ø­Ø© Ø§Ù„Ø¹Ù…Ù„',0),(122322,3398,'fr','Mettre Ã  jour la zone de travail',0),(122323,3398,'jp','å‹¤å‹™åœ°åŸŸã?®æ›´æ–°',0),(122324,3398,'pt','Ãrea de trabalho de atualizaÃ§Ã£o',0),(122325,3398,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°Ð±Ð¾Ñ‡ÐµÐ¹ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(122326,3398,'es','Actualizar Area de Trabajo',0),(122327,3398,'de','Update-Arbeitsbereich',0),(122328,3398,'en','Update Work Area',0),(122329,3399,'is','',0),(122330,3399,'dr',': Ú¯Ø±Ø§Ù Ù‡Ø§- Ù¾ÙŠØ´ Ú†Ø§Ù¾ â€“ Ú†Ø§Ù¾ â€“Ù¾Ø§ÙŠØ§Ù† â€“ ÙØ±Ø³ØªØ§Ø¯Ù†',0),(122331,3399,'pr','Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ: Ù†Ù…ÙˆØ¯Ø§Ø± Ù‡Ø§- Ù¾ÙŠØ´ Ú†Ø§Ù¾ â€“ Ú†Ø§Ù¾ â€“Ù¾Ø§ÙŠØ§Ù† â€“ ÙØ±Ø³ØªØ§Ø¯Ù†',0),(122332,3399,'tr','Grafik, baskÄ± Ã¶ncesi, baskÄ±, bitiÅŸ, gemi',0),(122333,3399,'pl','Grafika, Przygotowalnia, druk, wykoÅ„czenie, statek',0),(122334,3399,'bg','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ°, Ð¿Ñ€ÐµÐ´Ð¿ÐµÑ‡Ð°Ñ‚, Ð¿ÐµÑ‡Ð°Ñ‚, Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ, ÐºÐ¾Ñ€Ð°Ð±',0),(122335,3399,'ur','Ú¯Ø±Ø§ÙÚ©Ø³ØŒ Ù‚Ø¨Ù„ Ø·Ø¨Ø§Ø¹Øª, Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº, Ø®ØªÙ…, Ø¬ÛØ§Ø²',0),(122336,3399,'sr','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° , Ð¿Ñ€Ð¸Ð¿Ñ€ÐµÐ¼Ð° Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ñƒ, ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ, Ð·Ð°Ð²Ñ€ÑˆÐ¸, Ð±Ñ€Ð¾Ð´',0),(122337,3399,'vi','Äá»“ há»a, In, Káº¿t thÃºc, Chuyá»ƒn',0),(122338,3399,'af','Grafika, Prepress, druk, afwerking, skip',0),(122339,3399,'ro','Grafica, Prepress, imprimare, finisare, nava',0),(122340,3399,'et','Graafiline, eeltrÃ¼kk, trÃ¼kk, lÃµpeta, lÃ¤heta',0),(122341,3399,'si','GrafiÄna priprava za tisk, tisk, zakljuÄek, ladje',0),(122342,3399,'ba','Grafis, Prepress, cetak, selesai, kapal',0),(122343,3399,'nl','Graphics, Prepress, Print, afwerking, schip',0),(122344,3399,'fi','Grafiikka, Prepress, tulosta, viimeistely, aluksen',0),(122345,3399,'no','Grafikk, fÃ¸rtrykk, Print, Finish, skip',0),(122346,3399,'da','Grafik, Prepress, Print, Finish, skib',0),(122347,3399,'ko','ê·¸ëž˜í”½, í”„ë¦¬ í”„ë ˆìŠ¤, ì¸ì‡„, ë§ˆë¬´ë¦¬, ë°°',0),(122348,3399,'he','×’×¨×¤×™×§×”, ×§×“× ×“×¤×•×¡, ×”×“×¤×¡×”, ×¡×™×•×, ×”×¡×¤×™× ×”',0),(122349,3399,'el','Î“ÏÎ±Ï†Î¹ÎºÎ¬, Ï€ÏÎ¿ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·, ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·, Ï†Î¹Î½Î¯ÏÎ¹ÏƒÎ¼Î±, Ï€Î»Î¿Î¯Î¿',0),(122350,3399,'zh','å›¾å½¢ï¼Œå°å‰ï¼Œå°åˆ·ï¼Œç»“æŸï¼Œè´§è¿\r\n',0),(122351,3399,'sv','Grafik, Prepress, tryck, Finish, fartyg',0),(122352,3399,'it','Grafica, prestampa, stampa, finitura, nave',0),(122353,3399,'tl','',0),(122354,3399,'th','&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;,&#3585;&#3656;&#3629;&#3609;&#3585;&#3604;,&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;,&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;,&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591',0),(122355,3399,'hi','à¤—à¥à¤°à¤¾à¤«à¤¿à¤•à¥à¤¸, Prepress, à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ, à¤–à¤¤à¥à¤®, à¤œà¤¹à¤¾à¤œ',0),(122356,3399,'ms','Grafik, Prepress cetak, selesai, kapal',0),(122357,3399,'ar','Ø§Ù„Ø±Ø³ÙˆÙ…Ø§ØªØŒ Ù…Ø§ Ù‚Ø¨Ù„ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©ØŒ ÙˆØ§Ù„Ø·Ø¨Ø§Ø¹Ø©ØŒ ÙˆØ¥Ù†Ù‡Ø§Ø¡ØŒ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(122358,3399,'fr','Graphique, prÃ©presse, impression, finition, navire',0),(122359,3399,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã€?è£½ç‰ˆã€?å?°åˆ·ã€?ä»•ä¸Šã?’ã€?ç™ºé€?',0),(122360,3399,'pt','GrÃ¡fica, prÃ©-impressÃ£o, impressÃ£o, acabamento, navio',0),(122361,3399,'ru','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ°, Ð”Ð¾Ð¿ÐµÑ‡Ð°Ñ‚Ð½Ð°Ñ Ð¿Ð¾Ð´Ð³Ð¾Ñ‚Ð¾Ð²ÐºÐ°, Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ, Ð¾Ñ‚Ð´ÐµÐ»ÐºÐ°, ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(122362,3399,'es','GrÃ¡ficos, preimpresiÃ³n, impresiÃ³n, Terminado, EnvÃ­o',0),(122363,3399,'de','Grafik, Prepress, Print, Finish, Schiff',0),(122364,3399,'en','Graphics,Prepress,Print,Finish,Ship',0),(122365,3400,'is','',0),(122366,3400,'dr',': 1- 2-  3-  4 - 5',0),(122367,3400,'pr','Ø´Ø§Ø®Øµ Ù‡Ø§ÙŠ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ : 1- 2-  3-  4 - 5',0),(122368,3400,'tr','1,2,3,4,5',0),(122369,3400,'pl','1,2,3,4,5',0),(122370,3400,'bg','1,2,3,4,5',0),(122371,3400,'ur','1,2,3,4,5',0),(122372,3400,'sr','1,2,3,4,5',0),(122373,3400,'vi','1,2,3,4,5',0),(122374,3400,'af','1,2,3,4,5',0),(122375,3400,'ro','1,2,3,4,5',0),(122376,3400,'et','1,2,3,4,5',0),(122377,3400,'si','1,2,3,4,5',0),(122378,3400,'ba','1,2,3,4,5',0),(122379,3400,'nl','1,2,3,4,5',0),(122380,3400,'fi','1,2,3,4,5',0),(122381,3400,'no','1,2,3,4,5',0),(122382,3400,'da','1,2,3,4,5',0),(122383,3400,'ko','1,2,3,4,5',0),(122384,3400,'he','1,2,3,4,5',0),(122385,3400,'el','1,2,3,4,5',0),(122386,3400,'zh','å·¥ä½œé¢†åŸŸä»·å€¼ï¼š1ï¼Œ2ï¼Œ3ï¼Œ4ï¼Œ5\r\n',0),(122387,3400,'sv','1,2,3,4,5',0),(122388,3400,'it','1,2,3,4,5',0),(122389,3400,'tl','',0),(122390,3400,'th','1,2,3,4,5',0),(122391,3400,'hi','1,2,3,4,5',0),(122392,3400,'ms','1,2,3,4,5',0),(122393,3400,'ar','1,2,3,4,5',0),(122394,3400,'fr','1,2,3,4,5',0),(122395,3400,'jp','1,2,3,4,5',0),(122396,3400,'pt','1,2,3,4,5',0),(122397,3400,'ru','1,2,3,4,5',0),(122398,3400,'es','1,2,3,4,5',0),(122399,3400,'de','1,2,3,4,5',0),(122400,3400,'en','1,2,3,4,5',0),(122401,3401,'is','',0),(122402,3401,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ ÙƒØ§Ø±ÙŠ ',0),(122403,3401,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ ÙƒØ§Ø±ÙŠ ',0),(122404,3401,'tr','Ä°ÅŸ gÃ¼nleri',0),(122405,3401,'pl','Dni pracy',0),(122406,3401,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð´Ð½Ð¸',0),(122407,3401,'ur','Ú©Ø§Ù… Ø¯Ù†',0),(122408,3401,'sr','Ð Ð°Ð´Ð½Ð¸ Ð´Ð°Ð½Ð¸',0),(122409,3401,'vi','NgÃ y LÃ m viá»‡c',0),(122410,3401,'af','Werksdae',0),(122411,3401,'ro','Luni-vineri',0),(122412,3401,'et','TÃ¶Ã¶pÃ¤evi',0),(122413,3401,'si','Delovnih dni',0),(122414,3401,'ba','Hari kerja',0),(122415,3401,'nl','Werkdagen',0),(122416,3401,'fi','TyÃ¶pÃ¤ivien',0),(122417,3401,'no','Arbeidsdager',0),(122418,3401,'da','Arbejdsdage',0),(122419,3401,'ko','ìž‘ì—… ì¼',0),(122420,3401,'he','×™×ž×™ ×¢×‘×•×“×”',0),(122421,3401,'el','Î—Î¼Î­ÏÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(122422,3401,'zh','å·¥ä½œæ—¥å†…\r\n',0),(122423,3401,'sv','Arbetsdagar',0),(122424,3401,'it','Giorni di lavoro',0),(122425,3401,'tl','',0),(122426,3401,'th','&#3623;&#3633;&#3609;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(122427,3401,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¦à¤¿à¤¨',0),(122428,3401,'ms','Hari kerja',0),(122429,3401,'ar','Ø£ÙŠØ§Ù… Ø§Ù„Ø¹Ù…Ù„',0),(122430,3401,'fr','Jours de travail',0),(122431,3401,'jp','å‹¤å‹™æ—¥æ•°',0),(122432,3401,'pt','Dias de trabalho',0),(122433,3401,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ðµ Ð´Ð½Ð¸',0),(122434,3401,'es','DÃ­as de trabajo',0),(122435,3401,'de','Arbeitstage',0),(122436,3401,'en','Work days',0),(122437,3402,'is','',0),(122438,3402,'dr','ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª\r\n Comp',0),(122439,3402,'pr','ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª\r\n Comp',0),(122440,3402,'tr','Workmans Comp',0),(122441,3402,'pl','Workmans zÅ‚',0),(122442,3402,'bg','Workmans Comp',0),(122443,3402,'ur','ÙˆÙˆØ±Ú©Ù…Ø¢Ù†Ø³ Ú©Ø¹Ù…Ù¾',0),(122444,3402,'sr','WÐ¾Ñ€ÐºÐ¼Ð°Ð½Ñ Ð¦Ð¾Ð¼Ð¿',0),(122445,3402,'vi','CÃ´ng nhÃ¢n Comp',0),(122446,3402,'af','Vergoedingskommisaris',0),(122447,3402,'ro','Workmans Comp',0),(122448,3402,'et','TÃ¶Ã¶taja kompensatsioon',0),(122449,3402,'si','Workmans Comp',0),(122450,3402,'ba','Workmans Comp',0),(122451,3402,'nl','Workmans Comp',0),(122452,3402,'fi','Workmans Comp',0),(122453,3402,'no','Workmans Comp',0),(122454,3402,'da','Workmans Comp',0),(122455,3402,'ko','Workmans ê´‘ê³ ',0),(122456,3402,'he','Workmans ×§×•×ž×¤',0),(122457,3402,'el','Workmans Comp',0),(122458,3402,'zh','å·¥äººèµ”å¿\r\n',0),(122459,3402,'sv','Workmans Comp',0),(122460,3402,'it','Comp workmans',0),(122461,3402,'tl','',0),(122462,3402,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;&#3594;&#3604;&#3648;&#3594;&#3618;',0),(122463,3402,'hi','Workmans à¤•à¤‚à¤ª',0),(122464,3402,'ms','Workmans Comp',0),(122465,3402,'ar','Ø´Ø±ÙƒØ§Øª ÙˆÙˆØ±ÙƒÙ…Ø§Ù†Ø³',0),(122466,3402,'fr','AccidentÃ©s Comp',0),(122467,3402,'jp','åŠ´åƒ?è€…ç?½å®³è£œå„Ÿ',0),(122468,3402,'pt','Direitoa Comp',0),(122469,3402,'ru','Comp Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð²',0),(122470,3402,'es','CompensaciÃ³n al Trabajador ',0),(122471,3402,'de','Workmans Comp',0),(122472,3402,'en','Workmans Comp',0),(122473,3403,'is','',0),(122474,3403,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(122475,3403,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(122476,3403,'tr','Ä°ÅŸÃ§i Comp gider',0),(122477,3403,'pl','Koszt komp pracownikÃ³w',0),(122478,3403,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ†Ð¸ Comp Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(122479,3403,'ur','Ú©Ø§Ø±Ú©Ù†ÙˆÚº Ú©Ø¹Ù…Ù¾ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(122480,3403,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ñ€Ð°Ð´Ð½Ð¸ÐºÐ° Ð¦Ð¾Ð¼Ð¿',0),(122481,3403,'vi','Chi phÃ­ CÃ´ng nhÃ¢n Comp',0),(122482,3403,'af','Vergoedingskommisaris Uitgawe',0),(122483,3403,'ro','LucrÄƒtorilor Comp cheltuieli',0),(122484,3403,'et','*Workers Comp Expense',0),(122485,3403,'si','Delavcev Comp stroÅ¡ke',0),(122486,3403,'ba','Pekerja Comp biaya',0),(122487,3403,'nl','Werknemers Comp kosten',0),(122488,3403,'fi','TyÃ¶ntekijÃ¶iden Comp kustannuksella',0),(122489,3403,'no','Arbeidere Comp bekostning',0),(122490,3403,'da','Arbejdstagernes Comp udgift',0),(122491,3403,'ko','ë…¸ë™ìž ë³´ìƒ ë¹„ìš©',0),(122492,3403,'he','×”×•×¦××•×ª ×”×¤×™×¦×•×™×™× ×œ×¢×•×‘×“×™×',0),(122493,3403,'el','Î•ÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Comp Î´Î±Ï€Î¬Î½Î·',0),(122494,3403,'zh','å·¥äººèµ”å¿è´¹ç”¨\r\n',0),(122495,3403,'sv','Arbetstagare Comp bekostnad',0),(122496,3403,'it','Lavoratori Comp spese',0),(122497,3403,'tl','',0),(122498,3403,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;&#3594;&#3604;&#3648;&#3594;&#3618;',0),(122499,3403,'hi','à¤¶à¥à¤°à¤®à¤¿à¤•à¥‹à¤‚ Comp à¤µà¥à¤¯à¤¯',0),(122500,3403,'ms','Pekerja Comp perbelanjaan',0),(122501,3403,'ar','Ø­Ø³Ø§Ø¨ Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø¹Ù…Ø§Ù„',0),(122502,3403,'fr','Travailleurs Comp frais',0),(122503,3403,'jp','åŠ´åƒ?è€…ç?½å®³è£œå„Ÿè²»ç”¨',0),(122504,3403,'pt','Trabalhadores Comp despesa',0),(122505,3403,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ðµ Comp Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(122506,3403,'es','Comp. Gasto trabajadores ',0),(122507,3403,'de','Arbeiter Comp Kosten',0),(122508,3403,'en','Workers Comp Expense',0),(122509,3404,'is','',0),(122510,3404,'dr','Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¨Ù‡ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(122511,3404,'pr','Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¨Ù‡ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(122512,3404,'tr','Ä°ÅŸÃ§ilere Ã¶denecek Comp',0),(122513,3404,'pl','PracownikÃ³w komp pÅ‚atne',0),(122514,3404,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ†Ð¸ Comp Ð¿Ð»Ð°Ñ‚Ð¸Ð¼Ð¸',0),(122515,3404,'ur','Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø§Ø±Ú©Ù†ÙˆÚº Ú©Ø¹Ù…Ù¾',0),(122516,3404,'sr','Ð Ð°Ð´Ð½Ð¸Ñ†Ð¸ Ð¦Ð¾Ð¼Ð¿ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(122517,3404,'vi','Pháº£i Tráº£ CÃ´ng NhÃ¢n COMP',0),(122518,3404,'af','Vergoedingskommisaris Betaalbaar',0),(122519,3404,'ro','LucrÄƒtorilor Comp de plÄƒtit',0),(122520,3404,'et','*Workers Comp Payable',0),(122521,3404,'si','Delavcev Comp plaÄljive',0),(122522,3404,'ba','Pekerja Comp hutang',0),(122523,3404,'nl','Werknemers Comp te betalen',0),(122524,3404,'fi','TyÃ¶ntekijÃ¶iden Comp maksettava',0),(122525,3404,'no','Arbeidere Comp betales',0),(122526,3404,'da','Arbejdstagernes Comp betales',0),(122527,3404,'ko','ë…¸ë™ìž Comp ì§€ë¶ˆ',0),(122528,3404,'he','×¢×•×‘×“×™× ×ž×‘× ×” ×©×›×‘×•×ª ×–×›××™×',0),(122529,3404,'el','Î•ÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Comp Ï€Î»Î·ÏÏ‰Ï„Î­Î¿Î¹',0),(122530,3404,'zh','åº”ä»˜å·¥äººèµ”å¿\r\n',0),(122531,3404,'sv','Arbetstagare Comp betalas',0),(122532,3404,'it','Lavoratori Comp pagabile',0),(122533,3404,'tl','',0),(122534,3404,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;&#3594;&#3604;&#3648;&#3594;&#3618;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;',0),(122535,3404,'hi','à¤¶à¥à¤°à¤®à¤¿à¤•à¥‹à¤‚ Comp à¤¦à¥‡à¤¯',0),(122536,3404,'ms','Pekerja Comp yang perlu dibayar',0),(122537,3404,'ar','Ø¹Ù…Ø§Ù„ Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø¯ÙØ¹',0),(122538,3404,'fr','Travailleurs Comp Ã  payer',0),(122539,3404,'jp','åŠ´åƒ?è€…ç?½å®³è£œå„Ÿè²·æŽ›é‡‘',0),(122540,3404,'pt','Trabalhadores Comp a pagar',0),(122541,3404,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ðµ Comp Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ',0),(122542,3404,'es','Comp. por pagar trabajadores',0),(122543,3404,'de','Arbeiter Comp zahlbar',0),(122544,3404,'en','Workers Comp Payable',0),(122545,3405,'is','',0),(122546,3405,'dr','Ù†Ø±Ø® Ø¬Ø¨Ø±Ø§Ù† Ø®Ø³Ø§Ø±Øª ÙƒØ§Ø±Ú¯Ø±Ø§Ù† ',0),(122547,3405,'pr','Ù†Ø±Ø® Ø¬Ø¨Ø±Ø§Ù† Ø®Ø³Ø§Ø±Øª ÙƒØ§Ø±Ú¯Ø±Ø§Ù† ',0),(122548,3405,'tr','Ä°ÅŸÃ§i Comp oranÄ±',0),(122549,3405,'pl','Kurs komp pracownikÃ³w',0),(122550,3405,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ†Ð¸ Comp ÐºÑƒÑ€Ñ',0),(122551,3405,'ur','Ú©Ø§Ø±Ú©Ù†ÙˆÚº Ú©ÛŒ Ø´Ø±Ø­ Ú©Ø¹Ù…Ù¾',0),(122552,3405,'sr','Ð Ð°Ð´Ð½Ð¸Ñ†Ð¸ Ð¦Ð¾Ð¼Ð¿ ÑÑ‚Ð¾Ð¿Ð°',0),(122553,3405,'vi','GiÃ¡ lÆ°Æ¡ng CÃ´ng nhÃ¢n ',0),(122554,3405,'af','Vergoedingskommisaris Koers',0),(122555,3405,'ro','LucrÄƒtorilor Comp rata',0),(122556,3405,'et','TÃ¶Ã¶lise kompensatasiooni mÃ¤Ã¤r',0),(122557,3405,'si','Delavcev Comp stopnja',0),(122558,3405,'ba','Pekerja Comp tingkat',0),(122559,3405,'nl','Werknemers Comp tarief',0),(122560,3405,'fi','TyÃ¶ntekijÃ¶iden Comp mÃ¤Ã¤rÃ¤',0),(122561,3405,'no','Arbeidere Comp Rate',0),(122562,3405,'da','Arbejdstagernes Comp sats',0),(122563,3405,'ko','ë…¸ë™ìž ë³´ìƒ ìœ¨',0),(122564,3405,'he','×©×™×¢×•×¨ ×”×¤×™×¦×•×™×™× ×œ×¢×•×‘×“×™×',0),(122565,3405,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Comp ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(122566,3405,'zh','å·¥äººè¡¥å¿æ ‡å‡†\r\n',0),(122567,3405,'sv','Arbetstagare Comp kurs',0),(122568,3405,'it','Tasso di lavoratori Comp',0),(122569,3405,'tl','',0),(122570,3405,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;&#3594;&#3604;&#3648;&#3594;&#3618;',0),(122571,3405,'hi','à¤¶à¥à¤°à¤®à¤¿à¤•à¥‹à¤‚ Comp à¤¦à¤°',0),(122572,3405,'ms','Pekerja Comp kadar',0),(122573,3405,'ar','Ù…Ø¹Ø¯Ù„ Ø§Ù„Ø¹Ø§Ù…Ù„ÙŠÙ† ÙÙŠ Ø´Ø±ÙƒØ§Øª',0),(122574,3405,'fr','Taux de travailleurs Comp',0),(122575,3405,'jp','åŠ´åƒ?è€…ç?½å®³è£œå„Ÿåˆ©çŽ‡',0),(122576,3405,'pt','Taxa de trabalhadores Comp',0),(122577,3405,'ru','ÐšÑƒÑ€Ñ Comp Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð²',0),(122578,3405,'es','Nivel de Comp. a trabajadores',0),(122579,3405,'de','Arbeiter Comp Rate',0),(122580,3405,'en','Workers Comp Rate',0),(122581,3406,'is','',0),(122582,3406,'dr','Ù‡Ù…Ù‡ ÙØ±ÙˆØ´ ÙƒØ§Ø±Ù‡Ø§ÙŠ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(122583,3406,'pr','Ù‡Ù…Ù‡ ÙØ±ÙˆØ´ ÙƒØ§Ø±Ù‡Ø§ÙŠ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(122584,3406,'tr','TÃ¼m',0),(122585,3406,'pl','Wszystkie',0),(122586,3406,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸',0),(122587,3406,'ur','ØªÙ…Ø§Ù…',0),(122588,3406,'sr','Ð¡Ð²Ðµ',0),(122589,3406,'vi','Táº¥t cáº£',0),(122590,3406,'af','Alle',0),(122591,3406,'ro','Toate',0),(122592,3406,'et','KÃµik',0),(122593,3406,'si','Vse',0),(122594,3406,'ba','Semua',0),(122595,3406,'nl','Alle',0),(122596,3406,'fi','Kaikki',0),(122597,3406,'no','Alle',0),(122598,3406,'da','Alle',0),(122599,3406,'ko','ëª¨ë“ ',0),(122600,3406,'he','×›×œ',0),(122601,3406,'el','ÎŒÎ»Î±',0),(122602,3406,'zh','æ‰€æœ‰\r\n',0),(122603,3406,'sv','Alla',0),(122604,3406,'it','Tutti',0),(122605,3406,'tl','',0),(122606,3406,'th','&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(122607,3406,'hi','à¤¸à¤­à¥€',0),(122608,3406,'ms','Semua',0),(122609,3406,'ar','Ø¬Ù…ÙŠØ¹',0),(122610,3406,'fr','Tous les',0),(122611,3406,'jp','ã?™ã?¹ã?¦',0),(122612,3406,'pt','Todos os',0),(122613,3406,'ru','Ð’ÑÐµ',0),(122614,3406,'es','Todo',0),(122615,3406,'de','Alle',0),(122616,3406,'en','All',0),(122617,3407,'is','',0),(122618,3407,'dr','ÙØ±ÙˆØ´ Ù‡ÙŠÚ† ÙŠÙƒ Ø§Ø² ÙƒØ§Ø±Ù‡Ø§ÙŠ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(122619,3407,'pr','ÙØ±ÙˆØ´ Ù‡ÙŠÚ† ÙŠÙƒ Ø§Ø² ÙƒØ§Ø±Ù‡Ø§ÙŠ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(122620,3407,'tr','HiÃ§biri',0),(122621,3407,'pl','Brak',0),(122622,3407,'bg','ÐÑÐ¼Ð°',0),(122623,3407,'ur','Ú©ÙˆØ¦ÛŒ Ù†ÛÛŒÚº',0),(122624,3407,'sr','ÐÐ¸ÐºÐ¾ Ð½Ð¸Ñ˜Ðµ',0),(122625,3407,'vi','KhÃ´ng',0),(122626,3407,'af','Geen',0),(122627,3407,'ro','Nici unul',0),(122628,3407,'et','Puudub',0),(122629,3407,'si','Nobena',0),(122630,3407,'ba','Tidak ada',0),(122631,3407,'nl','Geen',0),(122632,3407,'fi','Ei mitÃ¤Ã¤n',0),(122633,3407,'no','Ingen',0),(122634,3407,'da','Ingen',0),(122635,3407,'ko','ì—†ìŒ',0),(122636,3407,'he','××£ ××—×“',0),(122637,3407,'el','ÎšÎ±Î½Î­Î½Î±Ï‚',0),(122638,3407,'zh','æ— \r\n',0),(122639,3407,'sv','Ingen',0),(122640,3407,'it','Nessuno',0),(122641,3407,'tl','',0),(122642,3407,'th','&#3652;&#3617;&#3656;&#3648;&#3621;&#3618;',0),(122643,3407,'hi','à¤•à¥‹à¤ˆ à¤¨à¤¹à¥€à¤‚',0),(122644,3407,'ms','Tiada seorang pun',0),(122645,3407,'ar','Ù„Ø§ Ø´ÙŠØ¡',0),(122646,3407,'fr','Aucun',0),(122647,3407,'jp','ä¸€ã?¤ã‚‚ã?ªã?„',0),(122648,3407,'pt','Nenhum',0),(122649,3407,'ru','ÐÐ¸ Ð¾Ð´Ð¸Ð½',0),(122650,3407,'es','Nada',0),(122651,3407,'de','Keine',0),(122652,3407,'en','None',0),(122653,3408,'is','',0),(122654,3408,'dr','ÙØ±ÙˆØ´ Ø§Ù†ØªØ®Ø§Ø¨ÙŠ ÙƒØ§Ø±Ù‡Ø§ÙŠ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(122655,3408,'pr','ÙØ±ÙˆØ´ Ø§Ù†ØªØ®Ø§Ø¨ÙŠ ÙƒØ§Ø±Ù‡Ø§ÙŠ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(122656,3408,'tr','Ä°steÄŸe baÄŸlÄ±',0),(122657,3408,'pl','Opcjonalne',0),(122658,3408,'bg','ÐŸÐ¾ Ð¸Ð·Ð±Ð¾Ñ€',0),(122659,3408,'ur','Ø§Ø®ØªÛŒØ§Ø±ÛŒ',0),(122660,3408,'sr','ÐžÐ¿Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð¸',0),(122661,3408,'vi','Lá»±a chá»n',0),(122662,3408,'af','Optimale',0),(122663,3408,'ro','OpÅ£ional',0),(122664,3408,'et','Valikuline',0),(122665,3408,'si','Neobvezno',0),(122666,3408,'ba','Opsional',0),(122667,3408,'nl','Optioneel',0),(122668,3408,'fi','Valinnainen',0),(122669,3408,'no','Valgfritt',0),(122670,3408,'da','Valgfri',0),(122671,3408,'ko','(ì„ íƒ ì‚¬í•­)',0),(122672,3408,'he','××•×¤×¦×™×•× ×œ×™',0),(122673,3408,'el','Î ÏÎ¿Î±Î¹ÏÎµÏ„Î¹ÎºÏŒ',0),(122674,3408,'zh','å¯é€‰\r\n',0),(122675,3408,'sv','Tillval',0),(122676,3408,'it','Opzionale',0),(122677,3408,'tl','',0),(122678,3408,'th','&#3595;&#3638;&#3656;&#3591;&#3648;&#3611;&#3655;&#3609;&#3607;&#3634;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(122679,3408,'hi','à¤µà¥ˆà¤•à¤²à¥à¤ªà¤¿à¤•',0),(122680,3408,'ms','Pilihan',0),(122681,3408,'ar','Ø¥Ø®ØªÙŠØ§Ø±ÙŠ',0),(122682,3408,'fr','En option',0),(122683,3408,'jp','ä»»æ„?ã?®',0),(122684,3408,'pt','Opcional',0),(122685,3408,'ru','ÐžÐ¿Ñ†Ð¸Ð¾Ð½Ð°Ð»ÑŒÐ½Ñ‹Ðµ',0),(122686,3408,'es','Opcional',0),(122687,3408,'de','Optional',0),(122688,3408,'en','Optional',0),(122689,3409,'is','',0),(122690,3409,'dr','ÙØ±ÙˆØ´ Ù‚Ø³Ù…ØªÙŠ Ø§Ø² ÙƒØ§Ø±Ù‡Ø§ÙŠ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(122691,3409,'pr','ÙØ±ÙˆØ´ Ù‚Ø³Ù…ØªÙŠ Ø§Ø² ÙƒØ§Ø±Ù‡Ø§ÙŠ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(122692,3409,'tr','KÄ±smi',0),(122693,3409,'pl','CzÄ™Å›ciowe',0),(122694,3409,'bg','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð°',0),(122695,3409,'ur','Ø¬Ø²ÙˆÛŒ',0),(122696,3409,'sr','Ð”ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð°',0),(122697,3409,'vi','1 Pháº§n',0),(122698,3409,'af','Gedeeltelik',0),(122699,3409,'ro','ParÅ£ialÄƒ',0),(122700,3409,'et','Osaline',0),(122701,3409,'si','Delno',0),(122702,3409,'ba','Parsial',0),(122703,3409,'nl','Gedeeltelijke',0),(122704,3409,'fi','Osittainen',0),(122705,3409,'no','Delvis',0),(122706,3409,'da','Delvis',0),(122707,3409,'ko','ë¶€ë¶„',0),(122708,3409,'he','×—×œ×§×™',0),(122709,3409,'el','ÎœÎµÏÎ¹ÎºÎ®',0),(122710,3409,'zh','éƒ¨åˆ†\r\n',0),(122711,3409,'sv','Partiell',0),(122712,3409,'it','Parziale',0),(122713,3409,'tl','',0),(122714,3409,'th','&#3648;&#3611;&#3655;&#3609;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;',0),(122715,3409,'hi','à¤†à¤‚à¤¶à¤¿à¤•',0),(122716,3409,'ms','Separa',0),(122717,3409,'ar','Ø¬Ø²Ø¦ÙŠØ©',0),(122718,3409,'fr','Partielle',0),(122719,3409,'jp','ä¸€éƒ¨ã?®',0),(122720,3409,'pt','Parcial',0),(122721,3409,'ru','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ñ‹Ðµ',0),(122722,3409,'es','Parcial',0),(122723,3409,'de','Teilweise',0),(122724,3409,'en','Partial',0),(122725,3410,'is','',0),(122726,3410,'dr','Ù†ÙˆØ´ØªÙ† ',0),(122727,3410,'pr','Ù†ÙˆØ´ØªÙ† ',0),(122728,3410,'tr','Yazmak',0),(122729,3410,'pl','Napisz',0),(122730,3410,'bg','ÐŸÐ¸ÑˆÐ°',0),(122731,3410,'ur','Ù„Ú©Ú¾Ù†Ø§',0),(122732,3410,'sr','ÐŸÐ¸ÑÐ°ÑšÐµ',0),(122733,3410,'vi','Viáº¿t',0),(122734,3410,'af','Skryf',0),(122735,3410,'ro','Scrie',0),(122736,3410,'et','Kirjuta',0),(122737,3410,'si','Napisati',0),(122738,3410,'ba','Menulis',0),(122739,3410,'nl','Schrijven',0),(122740,3410,'fi','Kirjoittaa',0),(122741,3410,'no','Skrive',0),(122742,3410,'da','Skrive',0),(122743,3410,'ko','ì“°ê¸°',0),(122744,3410,'he','×›×ª×™×‘×”',0),(122745,3410,'el','Î“ÏÎ¬ÏˆÏ„Îµ',0),(122746,3410,'zh','å†™\r\n',0),(122747,3410,'sv','Skriva',0),(122748,3410,'it','Scrivere',0),(122749,3410,'tl','',0),(122750,3410,'th','&#3648;&#3586;&#3637;&#3618;&#3609;',0),(122751,3410,'hi','à¤²à¤¿à¤–à¤¨à¤¾',0),(122752,3410,'ms','Menulis',0),(122753,3410,'ar','Ø§Ù„ÙƒØªØ§Ø¨Ø©',0),(122754,3410,'fr','Ã‰crire',0),(122755,3410,'jp','æ›¸ã??è¾¼ã‚€',0),(122756,3410,'pt','Escrever',0),(122757,3410,'ru','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚ÑŒ',0),(122758,3410,'es','Escribir',0),(122759,3410,'de','Schreiben',0),(122760,3410,'en','Write',0),(122761,3411,'is','',0),(122762,3411,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(122763,3411,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ (Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(122764,3411,'tr','Para Ã§ek',0),(122765,3411,'pl','Napisz SprawdÅº depozyt',0),(122766,3411,'bg','ÐÐ°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ‡ÐµÐº',0),(122767,3411,'ur','Ø¬Ù…Ø¹ Ú†ÛŒÚ© Ù„Ú©Ú¾',0),(122768,3411,'sr','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(122769,3411,'vi','Viáº¿t SÃ©c Ghi Ná»£',0),(122770,3411,'af','Skryf Tjek Deposito',0),(122771,3411,'ro','Scrie depozit CEC',0),(122772,3411,'et','Write Deposit Check',0),(122773,3411,'si','Napisati vloga Äek',0),(122774,3411,'ba','Menulis Deposit Check',0),(122775,3411,'nl','Schrijven storting Check',0),(122776,3411,'fi','Kirjoita talletus tarkistaa',0),(122777,3411,'no','Skrive innskudd sjekk',0),(122778,3411,'da','Skrive depositum Check',0),(122779,3411,'ko','ìž…ê¸ˆ í‘œ ìž‘ì„±',0),(122780,3411,'he','×œ×¨×©×•× ×¦\'×§ ×¤×™×§×“×•×Ÿ',0),(122781,3411,'el','Î“ÏÎ¬ÏˆÏ„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Ï‡Ï‰',0),(122782,3411,'zh','å†™å­˜æ¬¾æ”¯ç¥¨\r\n',0),(122783,3411,'sv','Skriv insÃ¤ttning Check',0),(122784,3411,'it','Deposito assegno',0),(122785,3411,'tl','',0),(122786,3411,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3613;&#3634;&#3585;',0),(122787,3411,'hi','à¤œà¤®à¤¾ à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡',0),(122788,3411,'ms','Menulis cek Deposit',0),(122789,3411,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(122790,3411,'fr','Faire chÃ¨que de dÃ©pÃ´t',0),(122791,3411,'jp','é ?ã?‹ã‚Šå°?åˆ‡æ‰‹ã?®æ›¸ã??è¾¼ã?¿',0),(122792,3411,'pt','DepÃ³sito de cheque',0),(122793,3411,'ru','Ð’Ñ‹Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ñ‡ÐµÐº Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(122794,3411,'es','Escribir depÃ³sito',0),(122795,3411,'de','Einzahlung Scheck',0),(122796,3411,'en','Write Deposit Check',0),(122797,3412,'is','',0),(122798,3412,'dr','x',0),(122799,3412,'pr','x',0),(122800,3412,'tr','x',0),(122801,3412,'pl','x',0),(122802,3412,'bg','x',0),(122803,3412,'ur','x',0),(122804,3412,'sr','x',0),(122805,3412,'vi','x',0),(122806,3412,'af','x',0),(122807,3412,'ro','X',0),(122808,3412,'et','x',0),(122809,3412,'si','x',0),(122810,3412,'ba','x',0),(122811,3412,'nl','x',0),(122812,3412,'fi','x',0),(122813,3412,'no','x',0),(122814,3412,'da','x',0),(122815,3412,'ko','x',0),(122816,3412,'he','x',0),(122817,3412,'el','x',0),(122818,3412,'zh','x',0),(122819,3412,'sv','x',0),(122820,3412,'it','x',0),(122821,3412,'tl','',0),(122822,3412,'th','x',0),(122823,3412,'hi','à¤à¤•à¥à¤¸',0),(122824,3412,'ms','x',0),(122825,3412,'ar','x',0),(122826,3412,'fr','x',0),(122827,3412,'jp','x',0),(122828,3412,'pt','x',0),(122829,3412,'ru','x',0),(122830,3412,'es','x',0),(122831,3412,'de','x',0),(122832,3412,'en','x',0),(122833,3413,'is','',0),(122834,3413,'dr','X',0),(122835,3413,'pr','Ø¬ÙˆØ§Ø¨  Ø¨Ù‡ Ø´ØºÙ„ X',0),(122836,3413,'tr','Ä°ÅŸ iÃ§in cevap x',0),(122837,3413,'pl','X odpowiedÅº na zadanie',0),(122838,3413,'bg','X Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(122839,3413,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Ø§ Ø¬ÙˆØ§Ø¨ x',0),(122840,3413,'sr','X Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€ Ð½Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(122841,3413,'vi','X tráº£ lá»i cho Job',0),(122842,3413,'af','X Antwoord tot Werkstuk',0),(122843,3413,'ro','X rÄƒspunsul la job',0),(122844,3413,'et','X Vastus tÃ¶Ã¶le',0),(122845,3413,'si','X odgovor na delo',0),(122846,3413,'ba','X jawaban pekerjaan',0),(122847,3413,'nl','X antwoord op baan',0),(122848,3413,'fi','X vastaus tyÃ¶',0),(122849,3413,'no','X svaret pÃ¥ jobben',0),(122850,3413,'da','X svar pÃ¥ job',0),(122851,3413,'ko','X ìž‘ì—…ì— ì‘ë‹µ',0),(122852,3413,'he','X ×ª×©×•×‘×” ×œ×¢×‘×•×“×”',0),(122853,3413,'el','X Î±Ï€Î¬Î½Ï„Î·ÏƒÎ· ÏƒÏ„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(122854,3413,'zh','Xå¯¹å·¥ä½œå›žç­”\r\n',0),(122855,3413,'sv','X svar till jobb',0),(122856,3413,'it','X risposta a lavoro',0),(122857,3413,'tl','',0),(122858,3413,'th','X &#3588;&#3635;&#3605;&#3629;&#3610;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3591;&#3634;&#3609;',0),(122859,3413,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¤¾ à¤œà¤µà¤¾à¤¬ x',0),(122860,3413,'ms','X jawapan untuk kerja',0),(122861,3413,'ar','Ã— Ø¬ÙˆØ§Ø¨ Ù„Ù„ÙˆØ¸ÙŠÙØ©',0),(122862,3413,'fr','X rÃ©ponse Ã  job',0),(122863,3413,'jp','X Answer to job',0),(122864,3413,'pt','X resposta ao trabalho',0),(122865,3413,'ru','X Ð¾Ñ‚Ð²ÐµÑ‚ Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(122866,3413,'es','Respuesta X a trabajo',0),(122867,3413,'de','X Antwort auf Auftrag',0),(122868,3413,'en','X Answer to job',0),(122869,3414,'is','',0),(122870,3414,'dr','Y',0),(122871,3414,'pr','Y',0),(122872,3414,'tr','Y',0),(122873,3414,'pl','Y',0),(122874,3414,'bg','Y',0),(122875,3414,'ur','Y',0),(122876,3414,'sr','Y',0),(122877,3414,'vi','Y',0),(122878,3414,'af','J',0),(122879,3414,'ro','Y',0),(122880,3414,'et','Y',0),(122881,3414,'si','Y',0),(122882,3414,'ba','Y',0),(122883,3414,'nl','Y',0),(122884,3414,'fi','Y',0),(122885,3414,'no','Y',0),(122886,3414,'da','Y',0),(122887,3414,'ko','Y',0),(122888,3414,'he','Y',0),(122889,3414,'el','Y',0),(122890,3414,'zh','Y\r\n',0),(122891,3414,'sv','Y',0),(122892,3414,'it','Y',0),(122893,3414,'tl','',0),(122894,3414,'th','Y',0),(122895,3414,'hi','Y',0),(122896,3414,'ms','Y',0),(122897,3414,'ar','Y',0),(122898,3414,'fr','Y',0),(122899,3414,'jp','Y',0),(122900,3414,'pt','Y',0),(122901,3414,'ru','Y',0),(122902,3414,'es','Y',0),(122903,3414,'de','Y',0),(122904,3414,'en','Y',0),(122905,3415,'is','',0),(122906,3415,'dr','Ø³Ø§Ù„ ',0),(122907,3415,'pr','Ø³Ø§Ù„ ',0),(122908,3415,'tr','YÄ±l',0),(122909,3415,'pl','Roku',0),(122910,3415,'bg','Ð“Ð¾Ð´Ð¸Ð½Ð°',0),(122911,3415,'ur','Ø³Ø§Ù„',0),(122912,3415,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ',0),(122913,3415,'vi','NÄƒm',0),(122914,3415,'af','Jaar',0),(122915,3415,'ro','An',0),(122916,3415,'et','Aasta',0),(122917,3415,'si','Leto',0),(122918,3415,'ba','Tahun',0),(122919,3415,'nl','Jaar',0),(122920,3415,'fi','Vuoden',0),(122921,3415,'no','Ã…r',0),(122922,3415,'da','Ã…r',0),(122923,3415,'ko','1 ë…„',0),(122924,3415,'he','×©× ×”',0),(122925,3415,'el','ÎˆÏ„Î¿Ï‚',0),(122926,3415,'zh','å¹´\r\n',0),(122927,3415,'sv','Ã…r',0),(122928,3415,'it','Anno',0),(122929,3415,'tl','',0),(122930,3415,'th','&#3611;&#3637;',0),(122931,3415,'hi','à¤µà¤°à¥à¤·',0),(122932,3415,'ms','Tahun',0),(122933,3415,'ar','Ø§Ù„Ø³Ù†Ø©',0),(122934,3415,'fr','AnnÃ©e',0),(122935,3415,'jp','å¹´',0),(122936,3415,'pt','Ano',0),(122937,3415,'ru','Ð“Ð¾Ð´',0),(122938,3415,'es','AÃ±o',0),(122939,3415,'de','Jahr',0),(122940,3415,'en','Year',0),(122941,3416,'is','',0),(122942,3416,'dr','/ Ù…Ø§Ù‡ ',0),(122943,3416,'pr','Ø³Ø§Ù„ / Ù…Ø§Ù‡ ',0),(122944,3416,'tr','YÄ±l/ay',0),(122945,3416,'pl','MiesiÄ…c i rok',0),(122946,3416,'bg','Ð“Ð¾Ð´Ð¸Ð½Ð°/Ð¼ÐµÑÐµÑ†',0),(122947,3416,'ur','Ø³Ø§Ù„ Ù…ÛŒÚº Ø§ÛŒÚ© Ù…ÛÛŒÙ†Û',0),(122948,3416,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ/Ð¼ÐµÑÐµÑ†',0),(122949,3416,'vi','NÄƒm/thÃ¡ng',0),(122950,3416,'af','Jaar/Maand',0),(122951,3416,'ro','An/ Luna',0),(122952,3416,'et','Aasta/Kuu',0),(122953,3416,'si','Leto/mesec',0),(122954,3416,'ba','Tahun/bulan',0),(122955,3416,'nl','Jaar/maand',0),(122956,3416,'fi','Vuosi/kuukausi',0),(122957,3416,'no','Ã…r/mÃ¥ned',0),(122958,3416,'da','Ã…r/mÃ¥ned',0),(122959,3416,'ko','ë…„/ì›”',0),(122960,3416,'he','×©× ×”/×—×•×“×©',0),(122961,3416,'el','ÎˆÏ„Î¿Ï‚/Î¼Î®Î½Î±Ï‚',0),(122962,3416,'zh','å¹´/æœˆ\r\n',0),(122963,3416,'sv','Ã…r/mÃ¥nad',0),(122964,3416,'it','Anno/mese',0),(122965,3416,'tl','',0),(122966,3416,'th','&#3611;&#3637;/&#3648;&#3604;&#3639;&#3629;&#3609;',0),(122967,3416,'hi','à¤µà¤°à¥à¤·/à¤®à¤¾à¤¹',0),(122968,3416,'ms','Tahun/bulan',0),(122969,3416,'ar','Ø§Ù„Ø³Ù†Ø©/Ø§Ù„Ø´Ù‡Ø±',0),(122970,3416,'fr','AnnÃ©e/mois',0),(122971,3416,'jp','å¹´/æœˆ',0),(122972,3416,'pt','Ano/mÃªs',0),(122973,3416,'ru','Ð“Ð¾Ð´/ÐœÐµÑÑÑ†',0),(122974,3416,'es','AÃ±o/Mes',0),(122975,3416,'de','Jahr/Monat',0),(122976,3416,'en','Year/Month',0),(122977,3417,'is','',0),(122978,3417,'dr','/ Ù…Ø§Ù‡  Ù¾Ø³Øª Ø¯Ø± ',0),(122979,3417,'pr','Ø³Ø§Ù„  / Ù…Ø§Ù‡  Ù¾Ø³Øª Ø¯Ø± ',0),(122980,3417,'tr','YÄ±l/ay sonrasÄ±',0),(122981,3417,'pl','MiesiÄ…c i rok Post do',0),(122982,3417,'bg','Ð“Ð¾Ð´Ð¸Ð½Ð°/Ð¼ÐµÑÐµÑ† Ð¿Ð¾ÑÑ‚ Ð²',0),(122983,3417,'ur','Ø³Ø§Ù„ Ù…ÛŒÚº Ø§ÛŒÚ© Ù…ÛÛŒÙ†Û Ù¾ÙˆØ³Ù¹ Ù…ÛŒÚº',0),(122984,3417,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ /Ð¼ÐµÑÐµÑ† Ð¿Ð¾ÑÑ‚Ð° Ñƒ',0),(122985,3417,'vi','Káº¿t chuyá»ƒn NÄƒm/thÃ¡ng vÃ o',0),(122986,3417,'af','Jaar/Maand GEPOS BINNE',0),(122987,3417,'ro','Anul/luna Post Ã®n',0),(122988,3417,'et','Year/Month Post Into',0),(122989,3417,'si','Objava leto/mesec v',0),(122990,3417,'ba','Tahun/bulan pos ke',0),(122991,3417,'nl','Jaar/maand Post in',0),(122992,3417,'fi','Vuosi/kuukausi virkaan',0),(122993,3417,'no','Ã…r/mÃ¥ned innlegget pÃ¥',0),(122994,3417,'da','Ã…r/mÃ¥ned indlÃ¦g i',0),(122995,3417,'ko','ë…„/ì›” ê²Œì‹œë¬¼ì—',0),(122996,3417,'he','×©× ×”/×—×•×“×© ×¤×•×¡×˜ ×œ×ª×•×š',0),(122997,3417,'el','ÎˆÏ„Î¿Ï‚/Î¼Î®Î½Î±Ï‚ Î¸Î­ÏƒÎ· ÏƒÎµ',0),(122998,3417,'zh','å¹´/æœˆåŽè¿›å…¥\r\n',0),(122999,3417,'sv','Ã…r/mÃ¥nad inlÃ¤gg i',0),(123000,3417,'it','Post del mese/anno in',0),(123001,3417,'tl','',0),(123002,3417,'th','&#3611;&#3637;/&#3648;&#3604;&#3639;&#3629;&#3609;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3611;&#3618;&#3633;&#3591;',0),(123003,3417,'hi','à¤µà¤°à¥à¤·/à¤®à¤¾à¤¹ à¤®à¥‡à¤‚ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(123004,3417,'ms','Tahun/bulan pos ke',0),(123005,3417,'ar','Ø§Ù„ØªØ±Ø­ÙŠÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ø´Ù‡Ø±/Ø§Ù„Ø³Ù†Ø©',0),(123006,3417,'fr','AnnÃ©e/mois Post dans',0),(123007,3417,'jp','å¹´/æœˆã€€ã?«è¨ˆä¸Š',0),(123008,3417,'pt','Post do ano/mÃªs em',0),(123009,3417,'ru','Ð“Ð¾Ð´/Ð¼ÐµÑÑÑ† Ð¿Ð¾ÑÑ‚Ð° Ð²',0),(123010,3417,'es','AÃ±o/Mes puesto en',0),(123011,3417,'de','Jahr/Monat Post in',0),(123012,3417,'en','Year/Month Post Into',0),(123013,3418,'is','',0),(123014,3418,'dr','/ Ù…Ø¯Øª Ø³Ù‡ Ù…Ø§Ù‡',0),(123015,3418,'pr','Ø³Ø§Ù„ / Ù…Ø¯Øª Ø³Ù‡ Ù…Ø§Ù‡',0),(123016,3418,'tr','YÄ±l/Ã¼Ã§ ay',0),(123017,3418,'pl','Rok/kwartaÅ‚',0),(123018,3418,'bg','Ð“Ð¾Ð´Ð¸Ð½Ð°/Ñ‚Ñ€Ð¸Ð¼ÐµÑÐµÑ‡Ð¸Ðµ',0),(123019,3418,'ur','Ø³Ø§Ù„/Ø³Û Ù…Ø§ÛÛŒ',0),(123020,3418,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð°/ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(123021,3418,'vi','NÄƒm/QuÃ½',0),(123022,3418,'af','Jaar/Kwartaal',0),(123023,3418,'ro','Trimestru',0),(123024,3418,'et','Aasta/Kvartal',0),(123025,3418,'si','Leto/Äetrtletje',0),(123026,3418,'ba','Kuartal/tahun',0),(123027,3418,'nl','Jaar/kwartaal',0),(123028,3418,'fi','Vuosi per vuosineljÃ¤nnes',0),(123029,3418,'no','Ã…r/kvartal',0),(123030,3418,'da','Ã…r/kvartal',0),(123031,3418,'ko','1 ë…„/ë¶„ê¸°',0),(123032,3418,'he','×©× ×”/×¨×‘×¢×•×Ÿ',0),(123033,3418,'el','ÎˆÏ„Î¿Ï‚/Ï„ÏÎ¯Î¼Î·Î½Î¿',0),(123034,3418,'zh','å¹´/å­£\r\n',0),(123035,3418,'sv','Ã…r/kvartal',0),(123036,3418,'it','Anno/trimestre',0),(123037,3418,'tl','',0),(123038,3418,'th','&#3611;&#3637;/&#3648;&#3604;&#3639;&#3629;&#3609;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3611;&#3618;&#3633;&#3591;',0),(123039,3418,'hi','à¤µà¤°à¥à¤·/à¤¤à¤¿à¤®à¤¾à¤¹à¥€',0),(123040,3418,'ms','Tahun/suku',0),(123041,3418,'ar','Ø±Ø¨Ø¹ Ø§Ù„Ø³Ù†Ø©/',0),(123042,3418,'fr','Trimestre/annÃ©e',0),(123043,3418,'jp','å¹´/å››å?ŠæœŸ',0),(123044,3418,'pt','Ano/trimestre',0),(123045,3418,'ru','Ð“Ð¾Ð´/ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(123046,3418,'es','AÃ±o/Trimestre',0),(123047,3418,'de','Jahr/Quartal',0),(123048,3418,'en','Year/Quarter',0),(123049,3419,'is','',0),(123050,3419,'dr','Ø³Ù‚Ù Ø³Ø§Ù„Ø§Ù†Ù‡',0),(123051,3419,'pr','Ø³Ù‚Ù Ø³Ø§Ù„Ø§Ù†Ù‡',0),(123052,3419,'tr','YÄ±llÄ±k tavan',0),(123053,3419,'pl','Roczny puÅ‚ap',0),(123054,3419,'bg','Ð“Ð¾Ð´Ð¸ÑˆÐµÐ½ Ñ‚Ð°Ð²Ð°Ð½',0),(123055,3419,'ur','Ø³Ø§Ù„Ø§Ù†Û Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø­Ø¯',0),(123056,3419,'sr','Ð“Ð¾Ð´Ð¸ÑˆÑšÐ¸ Ð¿Ð»Ð°Ñ„Ð¾Ð½',0),(123057,3419,'vi','Tráº§n NÄƒm',0),(123058,3419,'af','Jaarlikse Hoogtegrens',0),(123059,3419,'ro','Plafonul anuale',0),(123060,3419,'et','Iga-aastane Ã¼lemmÃ¤Ã¤r',0),(123061,3419,'si','Letno zgornjo mejo',0),(123062,3419,'ba','Langit-langit tahunan',0),(123063,3419,'nl','Jaarlijkse plafond',0),(123064,3419,'fi','Vuosittainen enimmÃ¤ismÃ¤Ã¤rÃ¤',0),(123065,3419,'no','Ã…rlig tak',0),(123066,3419,'da','Ã…rligt loft',0),(123067,3419,'ko','í•´ë§ˆë‹¤ ì²œìž¥',0),(123068,3419,'he','×”×ª×§×¨×” ×©× ×ª×™',0),(123069,3419,'el','Î‘Î½ÏŽÏ„Î±Ï„Î¿ ÎµÏ„Î®ÏƒÎ¹Î¿ ÏŒÏÎ¹Î¿',0),(123070,3419,'zh','å¹´åº¦ä¸Šé™\r\n',0),(123071,3419,'sv','Ã…rliga tak',0),(123072,3419,'it','Massimale annuale',0),(123073,3419,'tl','',0),(123074,3419,'th','&#3619;&#3634;&#3588;&#3634;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3586;&#3629;&#3591;&#3611;&#3637;',0),(123075,3419,'hi','à¤µà¤¾à¤°à¥à¤·à¤¿à¤• à¤›à¤¤',0),(123076,3419,'ms','Siling Tahunan',0),(123077,3419,'ar','Ø§Ù„Ø³Ù‚Ù Ø§Ù„Ø³Ù†ÙˆÙŠ',0),(123078,3419,'fr','Plafond annuel',0),(123079,3419,'jp','å¹´é–“æœ€å¤§æ•°',0),(123080,3419,'pt','Teto anual',0),(123081,3419,'ru','Ð•Ð¶ÐµÐ³Ð¾Ð´Ð½Ñ‹Ð¹ Ð¿Ð¾Ñ‚Ð¾Ð»Ð¾Ðº',0),(123082,3419,'es','Techo anual',0),(123083,3419,'de','JÃ¤hrliche Obergrenze',0),(123084,3419,'en','Yearly Ceiling',0),(123085,3420,'is','',0),(123086,3420,'dr','Ø³Ø§Ù„ Ù‡Ø§ Ù‚Ø¨Ù„ ',0),(123087,3420,'pr','Ø³Ø§Ù„ Ù‡Ø§ Ù‚Ø¨Ù„ ',0),(123088,3420,'tr','YÄ±llar Ã¶nce',0),(123089,3420,'pl','Lat przed',0),(123090,3420,'bg','Ð“Ð¾Ð´Ð¸Ð½Ð¸ Ð¿Ñ€ÐµÐ´Ð¸',0),(123091,3420,'ur','Ø³Ø§Ù„ Ù¾ÛÙ„Û’',0),(123092,3420,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð° Ñ€Ð°Ð½Ð¸Ñ˜Ðµ',0),(123093,3420,'vi','NÄƒm trÆ°á»›c',0),(123094,3420,'af','Jare Vantevore',0),(123095,3420,'ro','Ani inainte',0),(123096,3420,'et','Aastat ennem',0),(123097,3420,'si','Letih pred',0),(123098,3420,'ba','Tahun sebelum',0),(123099,3420,'nl','Jaar vÃ³Ã³r',0),(123100,3420,'fi','Vuotta ennen',0),(123101,3420,'no','Ã…r fÃ¸r',0),(123102,3420,'da','Ã…r fÃ¸r',0),(123103,3420,'ko','ë…„ ì „ì—',0),(123104,3420,'he','×©× ×™× ×œ×¤× ×™',0),(123105,3420,'el','Î§ÏÏŒÎ½Î¹Î± Ï€ÏÎ¹Î½',0),(123106,3420,'zh','å‡ å¹´å‰\r\n',0),(123107,3420,'sv','Ã…r innan',0),(123108,3420,'it','Anni prima',0),(123109,3420,'tl','',0),(123110,3420,'th','&#3611;&#3637;&#3585;&#3656;&#3629;&#3609;',0),(123111,3420,'hi','à¤µà¤°à¥à¤·à¥‹à¤‚ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡',0),(123112,3420,'ms','Tahun sebelum',0),(123113,3420,'ar','Ù‚Ø¨Ù„ Ø³Ù†ÙˆØ§Øª',0),(123114,3420,'fr','Ans avant',0),(123115,3420,'jp','æ•°å¹´å‰?',0),(123116,3420,'pt','Anos antes',0),(123117,3420,'ru','Ð“Ð¾Ð´Ñ‹ Ð”Ð¾ Ð­Ñ‚Ð¾Ð³Ð¾',0),(123118,3420,'es','AÃ±os anters',0),(123119,3420,'de','Jahre vor',0),(123120,3420,'en','Years Before',0),(123121,3421,'is','',0),(123122,3421,'dr','Ø¨Ù„Ù‡ ',0),(123123,3421,'pr','Ø¨Ù„Ù‡ ',0),(123124,3421,'tr','Evet',0),(123125,3421,'pl','Tak',0),(123126,3421,'bg','Ð”Ð°',0),(123127,3421,'ur','Ø¬ÛŒ ÛØ§Úº',0),(123128,3421,'sr','Ð”Ð°',0),(123129,3421,'vi','CÃ³',0),(123130,3421,'af','Ja',0),(123131,3421,'ro','Da',0),(123132,3421,'et','Jah',0),(123133,3421,'si','da',0),(123134,3421,'ba','Ya',0),(123135,3421,'nl','Ja',0),(123136,3421,'fi','KyllÃ¤',0),(123137,3421,'no','ja',0),(123138,3421,'da','Ja',0),(123139,3421,'ko','ì˜ˆ',0),(123140,3421,'he','×›×Ÿ',0),(123141,3421,'el','ÎÎ±Î¹',0),(123142,3421,'zh','æ˜¯çš„\r\n',0),(123143,3421,'sv','Ja',0),(123144,3421,'it','SÃ¬',0),(123145,3421,'tl','',0),(123146,3421,'th','&#3651;&#3594;&#3656;',0),(123147,3421,'hi','à¤¹à¤¾à¤',0),(123148,3421,'ms','Ya',0),(123149,3421,'ar','Ù†Ø¹Ù…',0),(123150,3421,'fr','Oui',0),(123151,3421,'jp','ã?¯ã?„',0),(123152,3421,'pt','Sim',0),(123153,3421,'ru','Ð”Ð°',0),(123154,3421,'es','Si',0),(123155,3421,'de','Ja',0),(123156,3421,'en','Yes',0),(123157,3422,'is','',0),(123158,3422,'dr','/ Ø®ÙŠØ±',0),(123159,3422,'pr','Ø¨Ù„Ù‡ / Ø®ÙŠØ±',0),(123160,3422,'tr','Evet/HayÄ±r',0),(123161,3422,'pl','Tak/nie',0),(123162,3422,'bg','Ð”Ð°/Ð½Ðµ',0),(123163,3422,'ur','ÛØ§Úº/Ù†ÛÛŒÚº',0),(123164,3422,'sr','Ð”Ð°/Ð½Ðµ',0),(123165,3422,'vi','CÃ³/KhÃ´ng',0),(123166,3422,'af','Ja/Nee',0),(123167,3422,'ro','Da nu',0),(123168,3422,'et','Jah/Ei',0),(123169,3422,'si','Da/ne',0),(123170,3422,'ba','Ya tidak',0),(123171,3422,'nl','Ja/Nee',0),(123172,3422,'fi','KyllÃ¤/ei',0),(123173,3422,'no','Ja/nei',0),(123174,3422,'da','Ja/Nej',0),(123175,3422,'ko','ì˜ˆ/ì•„ë‹ˆìš”',0),(123176,3422,'he','×›×Ÿ/×œ×',0),(123177,3422,'el','ÎÎ±Î¹/ÏŒÏ‡Î¹',0),(123178,3422,'zh','æ˜¯/å¦\r\n',0),(123179,3422,'sv','Ja/Nej',0),(123180,3422,'it','SÃ¬/No',0),(123181,3422,'tl','',0),(123182,3422,'th','&#3651;&#3594;&#3656;/&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;',0),(123183,3422,'hi','à¤¹à¤¾à¤/à¤¨à¤¹à¥€à¤‚',0),(123184,3422,'ms','Ya/tidak',0),(123185,3422,'ar','Ù†Ø¹Ù…/Ù„Ø§',0),(123186,3422,'fr','Oui/non',0),(123187,3422,'jp','ã?¯ã?„/ã?„ã?„ã?ˆ',0),(123188,3422,'pt','Sim/nÃ£o',0),(123189,3422,'ru','Ð”Ð°/ÐÐµÑ‚',0),(123190,3422,'es','Si/No',0),(123191,3422,'de','Ja/Nein',0),(123192,3422,'en','Yes/No',0),(123193,3423,'is','',0),(123194,3423,'dr','(ØªØ§ Ø²Ù…Ø§Ù†)  Ø¯Ø±Ø®ÙˆØ§Ø³Øª (ÛŒÙˆØ²Ø±Ø¯',0),(123195,3423,'pr','Ù‡Ù†ÙˆØ² (ØªØ§ Ø²Ù…Ø§Ù†)  Ø¯Ø±Ø®ÙˆØ§Ø³Øª (ÙƒØ§Ø±Ø¨Ø±Ø¯',0),(123196,3423,'tr','HenÃ¼z uygulamak iÃ§in',0),(123197,3423,'pl','Jeszcze do zastosowania',0),(123198,3423,'bg','Ð’ÑÐµ Ð¾Ñ‰Ðµ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð¾Ð¸ Ð´Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°Ñ‚',0),(123199,3423,'ur','Ø§Ø¨Ú¾ÛŒ ØªÚ© Ù„Ú¯Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(123200,3423,'sr','Ð¢ÐµÐº Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚Ðµ',0),(123201,3423,'vi','ChÆ°a Ã¡p dá»¥ng',0),(123202,3423,'af','Moet nog BYVOEG.',0),(123203,3423,'ro','Nu aplica inca',0),(123204,3423,'et','JÃ¤Ã¤b veel kinnitada',0),(123205,3423,'si','Å e prijaviti',0),(123206,3423,'ba','Namun untuk menerapkan',0),(123207,3423,'nl','Nog toe te passen',0),(123208,3423,'fi','VielÃ¤ soveltamaan',0),(123209,3423,'no','Men Ã¥ bruke',0),(123210,3423,'da','Endnu at anvende',0),(123211,3423,'ko','ì•„ì§ ì ìš© í•˜',0),(123212,3423,'he','×¢×“×™×™×Ÿ ×›×“×™ ×œ×”×—×™×œ',0),(123213,3423,'el','Î‘ÎºÏŒÎ¼Î± Î³Î¹Î± Î½Î± ÎµÏ†Î±ÏÎ¼ÏŒÏƒÎµÎ¹',0),(123214,3423,'zh','å°šæœªåŠžç†\r\n',0),(123215,3423,'sv','Ã„nnu gÃ¤lla',0),(123216,3423,'it','Ancora da applicare',0),(123217,3423,'tl','',0),(123218,3423,'th','&#3618;&#3633;&#3591;&#3588;&#3591;&#3609;&#3635;&#3652;&#3611;&#3611;&#3619;&#3632;&#3618;&#3640;&#3585;&#3605;&#3660;&#3651;&#3594;&#3657;',0),(123219,3423,'hi','à¤…à¤­à¥€ à¤¤à¤• à¤²à¤¾à¤—à¥‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(123220,3423,'ms','Lagi untuk memohon',0),(123221,3423,'ar','Ø­ØªÙ‰ Ø§Ù„Ø¢Ù† Ù„ØªØ·Ø¨ÙŠÙ‚',0),(123222,3423,'fr','Reste Ã  appliquer',0),(123223,3423,'jp','é?©ç”¨å‰?',0),(123224,3423,'pt','Ainda para aplicar',0),(123225,3423,'ru','Ð¢ÐµÐ¼ Ð½Ðµ Ð¼ÐµÐ½ÐµÐµ Ð´Ð»Ñ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(123226,3423,'es','Lo Que Falta para aplicar',0),(123227,3423,'de','Noch zu gelten',0),(123228,3423,'en','Yet to Apply',0),(123229,3424,'is','',0),(123230,3424,'dr','Ø´Ù…Ø§ Ø­Ù‚ ØªØºÙŠÙŠØ± Ø§ÙŠÙ† ÙØ§ÙŠÙ„ Ø±Ø§ Ù†Ø¯Ø§Ø±ÙŠØ¯ ',0),(123231,3424,'pr','Ø´Ù…Ø§ Ø­Ù‚ ØªØºÙŠÙŠØ± Ø§ÙŠÙ† ÙØ§ÙŠÙ„ Ø±Ø§ Ù†Ø¯Ø§Ø±ÙŠØ¯ ',0),(123232,3424,'tr','Var deÄŸiÅŸtirmemeniz haklarÄ± bu dosyaya.',0),(123233,3424,'pl','Nie ma zmodyfikowaÄ‡ uprawnienia do tego pliku.',0),(123234,3424,'bg','ÐÐµ ÑÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÑÑ‚ Ð¿Ñ€Ð°Ð²Ð°Ñ‚Ð° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ñ„Ð°Ð¹Ð».',0),(123235,3424,'ur','Ø¢Ù¾ Ù†ÛÛŒÚº ÛÛŒÚº Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ… Ø­Ù‚ÙˆÙ‚ Ø§Ø³ Ù…Ø³Ù„ Ú©Û’ Ù„ÛŒÛ’ Û”',0),(123236,3424,'sr','ÐÐµ Ð´Ð° Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð¾Ð²Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ.',0),(123237,3424,'vi','Báº¡n khÃ´ng Ä‘Æ°á»£c cáº¥p quyá»n chá»‰nh sá»­a há»“ sÆ¡ nÃ y',0),(123238,3424,'af','U het nie modifiseringsregte tot hierdie lÃªer nie.',0),(123239,3424,'ro','Nu',0),(123240,3424,'et','Teil ei ole',0),(123241,3424,'si','Ne spremeni pravice do te datoteke.',0),(123242,3424,'ba','Anda tidak mengubah hak untuk file ini.',0),(123243,3424,'nl','U doen geen rechten om dit bestand te wijzigen.',0),(123244,3424,'fi','Voit Ã„lÃ¤ muokkaa oikeudet tÃ¤hÃ¤n tiedostoon.',0),(123245,3424,'no','Du mÃ¥ ikke ha endre rettigheter til denne filen.',0),(123246,3424,'da','Du mÃ¥ ikke have Ã¦ndre rettigheder til denne fil.',0),(123247,3424,'ko','ìˆ˜ì • í•˜ì§€ ì•ŠëŠ”ì´ íŒŒì¼ì— ëŒ€ í•œ ê¶Œë¦¬.',0),(123248,3424,'he','×œ× ×™×© ×©×™× ×•×™ ×–×›×•×™×•×ª ×œ×§×•×‘×¥ ×–×”.',0),(123249,3424,'el','Î”ÎµÎ½ Î­Ï‡Î¿Ï…Î½ Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿.',0),(123250,3424,'zh','æ‚¨æ²¡æœ‰æƒé™ä¿®æ”¹è¿™ä¸ªæ–‡ä»¶',0),(123251,3424,'sv','Du mÃ¥ste Ã¤ndra inte rÃ¤ttigheter till denna fil.',0),(123252,3424,'it','Non deve modificare i diritti a questo file.',0),(123253,3424,'tl','',0),(123254,3424,'th','&#3588;&#3640;&#3603;&#3652;&#3617;&#3656;&#3617;&#3637;&#3626;&#3636;&#3607;&#3608;&#3636;&#3651;&#3609;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3652;&#3615;&#3621;&#3660;&#3609;&#3637;&#3657;',0),(123255,3424,'hi','à¤†à¤ª à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤§à¤¿à¤•à¤¾à¤°à¥¤',0),(123256,3424,'ms','Anda tidak mempunyai mengubah suai hak untuk fail ini.',0),(123257,3424,'ar','Ø¹Ø¯Ù… ØªØ¹Ø¯ÙŠÙ„ Ø­Ù‚ÙˆÙ‚ Ù„Ù‡Ø°Ø§ Ø§Ù„Ù…Ù„Ù.',0),(123258,3424,'fr','Vous ne pas modifier les droits Ã  ce fichier.',0),(123259,3424,'jp','ã?“ã?®ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ä¿®æ­£ã?™ã‚‹æ¨©åˆ©ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(123260,3424,'pt','VocÃª nÃ£o tem modificar direitos para esse arquivo.',0),(123261,3424,'ru','Ð’Ñ‹ Ð½Ðµ Ð±ÑƒÐ´ÐµÑ‚Ðµ Ð¸Ð·Ð¼ÐµÐ½ÑÑ‚ÑŒ Ð¿Ñ€Ð°Ð²Ð° Ð½Ð° ÑÑ‚Ð¾Ñ‚ Ñ„Ð°Ð¹Ð».',0),(123262,3424,'es','No tiene derechos para modificar este archivo.',0),(123263,3424,'de','Sie haben Ã¤ndern Sie nicht die Rechte an dieser Datei.',0),(123264,3424,'en','You do not have modify rights to this file.',0),(123265,3425,'is','',0),(123266,3425,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¬Ø§Ø²Ù‡ ØªØºÙŠÙŠØ± Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø±Ø§ Ø¨Ø¯Ù‡ÙŠØ¯ ',0),(123267,3425,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¬Ø§Ø²Ù‡ ØªØºÙŠÙŠØ± Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø±Ø§ Ø¨Ø¯Ù‡ÙŠØ¯ ',0),(123268,3425,'tr','Gereken izin deÄŸiÅŸtirmek iÃ§in en az bir kullanÄ±cÄ± eriÅŸim.',0),(123269,3425,'pl','NaleÅ¼y zezwoliÄ‡ na dostÄ™p do co najmniej jednego uÅ¼ytkownika modyfikowaÄ‡.',0),(123270,3425,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ñ€Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ð½Ð°Ð¹-Ð¼Ð°Ð»ÐºÐ¾ ÐµÐ´Ð¸Ð½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ».',0),(123271,3425,'ur','Ø¢Ù¾ ØªØ±Ù…ÛŒÙ… Ú©Ø±ÛŒÚº Ú©Ù… Ø§Ø² Ú©Ù… Ø§ÛŒÚ© ØµØ§Ø±Ù Ú©Ùˆ Ø±Ø³Ø§Ø¦ÛŒ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ú†Ø§ÛÛŒÛ’ Û”',0),(123272,3425,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ð¸Ñ‚Ð¸ Ð¸Ð·Ð¼ÐµÐ½Ñƒ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð½Ð°Ñ˜Ð¼Ð°ÑšÐµ Ñ˜ÐµÐ´Ð°Ð½ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº.',0),(123273,3425,'vi','Báº¡n pháº£i cáº¥p quyá»n chá»‰nh sá»­a cho Ã­t nháº¥t 1 ngÆ°á»i sá»­ dá»¥ng',0),(123274,3425,'af','U moet ten minste aan een gebruiker toegang verleen om veranderinge te maak.',0),(123275,3425,'ro','Trebuie sa permiteti modificarea',0),(123276,3425,'et','Te peate lubama ligipÃ¤Ã¤su muutmiseks vÃ¤hemalt Ã¼hele kasutajale',0),(123277,3425,'si','Morate dovoliti spreminjanje dostop do vsaj enega uporabnika.',0),(123278,3425,'ba','Anda harus membolehkan akses ke setidaknya satu pengguna memodifikasi.',0),(123279,3425,'nl','U mag toegang tot ten minste Ã©Ã©n gebruiker wijzigen.',0),(123280,3425,'fi','Annat muokkausoikeuksia vÃ¤hintÃ¤Ã¤n yksi kÃ¤yttÃ¤jÃ¤.',0),(123281,3425,'no','Du mÃ¥ tillate endre tilgang til minst Ã©n bruker.',0),(123282,3425,'da','Du skal tillade, Ã¦ndre adgang til mindst Ã©n bruger.',0),(123283,3425,'ko','ìˆ˜ì • í•˜ë‚˜ ì´ìƒì˜ ì‚¬ìš©ìžì— ê²Œ ì•¡ì„¸ìŠ¤ë¥¼ í—ˆìš© í•´ì•¼ í•©ë‹ˆë‹¤.',0),(123284,3425,'he','×¢×œ×™×š ×œ××¤×©×¨ ×œ×©× ×•×ª ×’×™×©×” ×œ×¤×—×•×ª ×ž×©×ª×ž×© ××—×“.',0),(123285,3425,'el','Î˜Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Ï„ÏÎ­ÏˆÎµÏ„Îµ Î½Î± Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î­Î½Î±Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚.',0),(123286,3425,'zh','æ‚¨å¿…é¡»å…è®¸ä¿®æ”¹è®¿é—®è‡³å°‘ä¸€ä¸ªç”¨æˆ·ã€‚\r\n',0),(123287,3425,'sv','Du mÃ¥ste tillÃ¥ta Ã¤ndra Ã¥tkomst till minst en anvÃ¤ndare.',0),(123288,3425,'it','Ãˆ necessario consentire l\'accesso ad almeno un utente di modificare.',0),(123289,3425,'tl','',0),(123290,3425,'th','&#3588;&#3640;&#3597;&#3605;&#3657;&#3629;&#3591;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(123291,3425,'hi','à¤†à¤ª à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¹à¥à¤à¤š à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(123292,3425,'ms','Anda perlu membenarkan akses kepada sekurang-kurangnya satu pengguna mengubah suai.',0),(123293,3425,'ar','ÙŠØ¬Ø¨ Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨ØªØ¹Ø¯ÙŠÙ„ Ø¥Ù…ÙƒØ§Ù†ÙŠØ© Ø§Ù„ÙˆØµÙˆÙ„ Ù„Ù…Ø³ØªØ®Ø¯Ù… ÙˆØ§Ø­Ø¯ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„.',0),(123294,3425,'fr','Vous devez autoriser l\'accÃ¨s au moins un utilisateur de modifier.',0),(123295,3425,'jp','å°‘ã?ªã??ã?¦ã‚‚ä¸€äººã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?«ã?¯ä¿®æ­£æ¨©åˆ©ã‚’è¨±å?¯ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(123296,3425,'pt','VocÃª deve permitir o acesso a pelo menos um usuÃ¡rio de modificar.',0),(123297,3425,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ñ€Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÑÑ‚ÑŒ Ð´Ð¾ÑÑ‚ÑƒÐ¿ Ð¿Ð¾ ÐºÑ€Ð°Ð¹Ð½ÐµÐ¹ Ð¼ÐµÑ€Ðµ Ð¾Ð´Ð½Ð¾Ð¼Ñƒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŽ.',0),(123298,3425,'es','Debe permitir acceso de modificar al menos a un usuario.',0),(123299,3425,'de','Sie mÃ¼ssen den Zugriff auf mindestens einen Benutzer Ã¤ndern zulassen.',0),(123300,3425,'en','You must allow modify access to at least one user.',0),(123301,3426,'is','',0),(123302,3426,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¬Ø§Ø²Ù‡ Ù†Ù…Ø§ÙŠØ´  Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø±Ø§ Ø¨Ø¯Ù‡ÙŠØ¯ ',0),(123303,3426,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¬Ø§Ø²Ù‡ Ù†Ù…Ø§ÙŠØ´  Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø±Ø§ Ø¨Ø¯Ù‡ÙŠØ¯ ',0),(123304,3426,'tr','En az bir kullanÄ±cÄ± gÃ¶rÃ¼nÃ¼mÃ¼ eriÅŸmesine izin vermek gerekir.',0),(123305,3426,'pl','NaleÅ¼y zezwoliÄ‡ na widoku dostÄ™p do co najmniej jednego uÅ¼ytkownika.',0),(123306,3426,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ñ€Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚Ðµ Ð¸Ð·Ð³Ð»ÐµÐ´ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ð½Ð°Ð¹-Ð¼Ð°Ð»ÐºÐ¾ ÐµÐ´Ð¸Ð½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ».',0),(123307,3426,'ur','Ø¢Ù¾ Ù…Ù†Ø¸Ø± Ø±Ø³Ø§Ø¦ÛŒ Ú©Ù… Ø§Ø² Ú©Ù… Ø§ÛŒÚ© ØµØ§Ø±Ù Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¶Ø±ÙˆØ±ÛŒ ÛÛ’ Û”',0),(123308,3426,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ñƒ Ð½Ð°Ñ˜Ð¼Ð°ÑšÐµ Ñ˜ÐµÐ´Ð°Ð½ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº.',0),(123309,3426,'vi','Báº¡n pháº£i cáº¥p quyá»n xem cho Ã­t nháº¥t 1 ngÆ°á»i sá»­ dá»¥ng',0),(123310,3426,'af','U moet ten minste aan een gebruiker toegang verleen om inligting te bekyk.',0),(123311,3426,'ro','Trebuie sa permiteti vizualizarea',0),(123312,3426,'et','Te peate vaatajaÃµiguse mÃ¤Ã¤rame vÃ¤hemalt Ã¼hele kasutajale',0),(123313,3426,'si','Dovolite pogled dostop do vsaj enega uporabnika.',0),(123314,3426,'ba','Anda harus membolehkan akses Lihat setidaknya satu pengguna.',0),(123315,3426,'nl','U moet weergave toegang tot ten minste Ã©Ã©n gebruiker toestaan.',0),(123316,3426,'fi','Salli nÃ¤kymÃ¤n pÃ¤Ã¤syÃ¤ vÃ¤hintÃ¤Ã¤n yksi kÃ¤yttÃ¤jÃ¤.',0),(123317,3426,'no','Du mÃ¥ tillate visning tilgang til minst Ã©n bruker.',0),(123318,3426,'da','Du skal give visningsadgang til mindst Ã©n bruger.',0),(123319,3426,'ko','í•˜ë‚˜ ì´ìƒì˜ ì‚¬ìš©ìžì— ëŒ€ í•œ ë³´ê¸° ì•¡ì„¸ìŠ¤ë¥¼ í—ˆìš© í•´ì•¼ í•©ë‹ˆë‹¤.',0),(123320,3426,'he','×¢×œ×™×š ×œ××¤×©×¨ ×’×™×©×” ×ª×¦×•×’×” ×œ×¤×—×•×ª ×ž×©×ª×ž×© ××—×“.',0),(123321,3426,'el','Î˜Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Ï„ÏÎ­ÏˆÎµÏ„Îµ Ï„Î·Î½ Ï€ÏÎ¿Î²Î¿Î»Î® Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î­Î½Î±Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚.',0),(123322,3426,'zh','æ‚¨å¿…é¡»å…è®¸æŸ¥çœ‹è®¿é—®è‡³å°‘ä¸€ä¸ªç”¨æˆ·ã€‚\r\n',0),(123323,3426,'sv','Visa tillgÃ¥ng till minst en anvÃ¤ndare mÃ¥ste du tillÃ¥ta.',0),(123324,3426,'it','Ãˆ necessario consentire l\'accesso ad almeno un utente vista.',0),(123325,3426,'tl','',0),(123326,3426,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3611;&#3619;&#3633;&#3610;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3651;&#3627;&#3657;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3629;&#3618;&#3',0),(123327,3426,'hi','à¤†à¤ª à¤¦à¥ƒà¤¶à¥à¤¯ à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¹à¥à¤à¤š à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(123328,3426,'ms','Anda mesti membenarkan paparan capaian kepada sekurang-kurangnya satu pengguna.',0),(123329,3426,'ar','ÙŠØ¬Ø¨ Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ø¹Ø±Ø¶ Ù„Ù…Ø³ØªØ®Ø¯Ù… ÙˆØ§Ø­Ø¯ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„.',0),(123330,3426,'fr','Vous devez autoriser Voir accÃ¨s au moins un utilisateur.',0),(123331,3426,'jp','å°‘ã?ªã??ã?¦ã‚‚ä¸€äººã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?«ã?¯é–²è¦§æ¨©åˆ©ã‚’è¨±å?¯ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(123332,3426,'pt','VocÃª deve permitir o acesso de exibiÃ§Ã£o pelo menos um usuÃ¡rio.',0),(123333,3426,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ñ€Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð´Ð¾ÑÑ‚ÑƒÐ¿ Ð¿Ð¾ ÐºÑ€Ð°Ð¹Ð½ÐµÐ¹ Ð¼ÐµÑ€Ðµ Ð¾Ð´Ð½Ð¾Ð¼Ñƒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŽ.',0),(123334,3426,'es','Debe permitir acceso de ver al menos a un usuario.',0),(123335,3426,'de','Sie mÃ¼ssen Zugriff auf mindestens einen Benutzer anzeigen zulassen.',0),(123336,3426,'en','You must allow view access to at least one user.',0),(123337,3427,'is','',0),(123338,3427,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ù…Ø§ÙŠØ´Ú¯Ø± ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¨Ø§Ø±ÙŠ Ø®ÙˆØ§Ù†Ø¯Ù† Ø§ÙŠÙ† ÙØ§ÙŠÙ„ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÙŠØ¯',0),(123339,3427,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ù…Ø§ÙŠØ´Ú¯Ø± ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¨Ø§Ø±ÙŠ Ø®ÙˆØ§Ù†Ø¯Ù† Ø§ÙŠÙ† ÙØ§ÙŠÙ„ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÙŠØ¯',0),(123340,3427,'tr','* Bu dosyayÄ± okumak iÃ§in PDF gÃ¶rÃ¼ntÃ¼leyici (Adobe Reader yani) olmasÄ± gerekir.',0),(123341,3427,'pl','* Musisz mieÄ‡ PDF viewer (np Adobe Reader) do odczytu tego pliku.',0),(123342,3427,'bg','* Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð°Ñ‚Ðµ PDF Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ (Ñ‚.Ðµ. Adobe Reader), Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ñ‡ÐµÑ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ñ„Ð°Ð¹Ð».',0),(123343,3427,'ur','* Ø¢Ù¾ Ø§Ø³ Ù…Ø³Ù„ Ú©Ùˆ Ù¾Ú‘Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ Ù†Ø§Ø¸Ø± (ÛŒØ¹Ù†ÛŒ Ø§ÛŒÚˆÙˆØ¨ Ø±ÛŒÚˆØ±) ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ Û”',0),(123344,3427,'sr','* ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð¼Ð°Ñ‚Ð¸ ÐŸÐ”Ð¤ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°Ñ‡ (Ð¾Ð´Ð½Ð¾ÑÐ½Ð¾ ÐÐ´Ð¾Ð±Ðµ Ð ÐµÐ°Ð´ÐµÑ€) Ð·Ð° Ñ‡Ð¸Ñ‚Ð°ÑšÐµ Ð¾Ð²Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ.',0),(123345,3427,'vi','*Báº¡n pháº£i cÃ³ pháº§n má»m PDF (VD Adobe Reader) Ä‘á»ƒ Ä‘á»c há»“ sÆ¡ nÃ y',0),(123346,3427,'af','*U moet oor \'n PDF viewer (bv. Adobe Reader) beskik om hierdie lÃªer te kan lees.',0),(123347,3427,'ro','Trebuie sa aveti',0),(123348,3427,'et','* Teil peab olema PDF vaatamiseks vajalik programm, nÃ¤iteks Adobe Acrobat Reader.',0),(123349,3427,'si','* ÄŒe imate pregledovalnik PDF (t.j. Adobe Reader), ki Å¾elite prebrati to datoteko.',0),(123350,3427,'ba','* Anda harus memiliki viewer PDF (yaitu Adobe Reader) untuk membaca file ini.',0),(123351,3427,'nl','Je hebt een PDF viewer nodig om dit bestand te openen.(bv Adobe Reader)',0),(123352,3427,'fi','* Sinulla on PDF-katseluohjelma (eli Adobe Reader) lukea tÃ¤mÃ¤n tiedoston.',0),(123353,3427,'no','* Du mÃ¥ en PDF seer (dvs. Adobe Reader) Ã¥ lese denne filen.',0),(123354,3427,'da','* Du skal have en PDF viewer (dvs. Adobe Reader) at lÃ¦se denne fil.',0),(123355,3427,'ko','* ë‹¹ì‹ ì´ PDF ë·°ì–´ (ì˜ˆ: Adobe Reader)ì´ì´ íŒŒì¼ì„ ì½ì„ ìˆ˜ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(123356,3427,'he','* ×¢×œ×™×š ×”×¦×•×¤×” PDF (×§×¨×™ Adobe Reader) ×œ×§×¨×•× ×§×•×‘×¥ ×–×”.',0),(123357,3427,'el','* Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î­Î½Î±Î½ Î¸ÎµÎ±Ï„Î® PDF (Ï€.Ï‡. Adobe Reader) Î½Î± Î´Î¹Î±Î²Î¬ÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿.',0),(123358,3427,'zh','*æ‚¨å¿…é¡»æœ‰ä¸€ä¸ªPDFæµè§ˆå™¨ï¼ˆå¦‚Adobe Readerï¼‰ä»¥è¯»å–æ­¤æ–‡ä»¶ã€‚\r\n',0),(123359,3427,'sv','* Du mÃ¥ste ha en PDF-lÃ¤sare (dvs. Adobe LÃ¤saren) att lÃ¤sa filen.',0),(123360,3427,'it','* Ãˆ necessario disporre di un visualizzatore di PDF (ad esempio Adobe Reader) di leggere questo file.',0),(123361,3427,'tl','',0),(123362,3427,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3605;&#3633;&#3623;&#3617;&#3629;&#3591; PDF (Adobe Reader) &#3648;&#3614;&#3639;&#3656;&#3629;&#3629;&#3656;&#3634;&#3609;&#3652;&#3615;&#3621;&#3660;&#3609;&#3637;&#3657;',0),(123363,3427,'hi','* à¤†à¤ª à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤ªà¤¢à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• PDF à¤µà¥à¤¯à¥‚à¤…à¤° (à¤¯à¤¾à¤¨à¥€ à¤à¤¡à¥‹à¤¬ à¤°à¥€à¤¡à¤°) à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(123364,3427,'ms','* Anda mesti mempunyai penonton PDF (iaitu Adobe Reader) untuk membaca fail ini.',0),(123365,3427,'ar','* ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø¹Ø§Ø±Ø¶ PDF (Ø£ÙŠ Adobe Reader) Ù‚Ø±Ø§Ø¡Ø© Ù‡Ø°Ø§ Ø§Ù„Ù…Ù„Ù.',0),(123366,3427,'fr','Vous devez avoir un lecteur de PDF (par exemple Adobe Reader) pour lire ce fichier.',0),(123367,3427,'jp','ã?“ã?®ãƒ•ã‚¡ã‚¤ãƒ«ã‚’èª­ã‚€ã?«ã?¯PDFãƒ“ãƒ¥ãƒ¼ã‚¢ãƒ¼ï¼ˆã‚¢ãƒ‰ãƒ“ãƒªãƒ¼ãƒ€ãƒ¼ã?ªã?©ï¼‰ã?Œã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(123368,3427,'pt','* VocÃª deve ter um visualizador de PDF (ou seja, o Adobe Reader) para ler este arquivo.',0),(123369,3427,'ru','* Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¸Ð¼ÐµÑ‚ÑŒ PDF viewer (Ð½Ð°Ð¿Ñ€Ð¸Ð¼ÐµÑ€, Adobe Reader) Ð´Ð»Ñ Ñ‡Ñ‚ÐµÐ½Ð¸Ñ ÑÑ‚Ð¾Ð³Ð¾ Ñ„Ð°Ð¹Ð»Ð°.',0),(123370,3427,'es','*Debe tener un visor PDF (ejm. Adobe Reader) para leer este archivo.',0),(123371,3427,'de','* Sie mÃ¼ssen einen PDF-Viewer (z.B. Adobe Reader) zum Lesen dieser Datei haben.',0),(123372,3427,'en','*You must have a PDF viewer (i.e. Adobe Reader) to read this file.',0),(123373,3428,'is','',0),(123374,3428,'dr','. Ø§Ú¯Ø± Ø§ÙŠÙ† Ø§ØªÙØ§Ù‚ Ù†ÙŠÙØªØ§Ø¯ ',0),(123375,3428,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø¨Ù‡ Ø·ÙˆØ± Ø§ØªÙˆÙ…Ø§ØªÙŠÙƒ Ø¨Ù‡ Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø± ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´ÙˆÙŠØ¯ ÙˆÙ‚ØªÙŠ ÙƒÙ‡ Ø§ÙŠÙ† Ø¢Ù…Ø§Ø¯Ù‡ Ø§Ø³Øª . Ø§Ú¯Ø± Ø§ÙŠÙ† Ø§ØªÙØ§Ù‚ Ù†ÙŠÙØªØ§Ø¯ ',0),(123376,3428,'tr','HazÄ±r olduÄŸunda otomatik olarak mÃ¼ÅŸteri listesine iletilmesi gereken.<br>EÄŸer bu olmaz,',0),(123377,3428,'pl','Was powinny automatycznie byÄ‡ przekazane do listy odbiorcÃ³w gdy jest gotowy.<br>JeÅ›li tak siÄ™ nie stanie,',0),(123378,3428,'bg','Ð’Ð¸Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ ÑÐµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ñ‚ ÐºÑŠÐ¼ ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ðµ Ð³Ð¾Ñ‚Ð¾Ð²Ð°.<br>ÐÐºÐ¾ Ñ‚Ð¾Ð²Ð° Ð½Ðµ ÑÐµ ÑÐ»ÑƒÑ‡Ð¸,',0),(123379,3428,'ur','Ø¬Ø¨ Ø§Ø³Û’ ØªÛŒØ§Ø± ÛÛ’ Ø¢Ù¾ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú†Ø§ÛØ¦Û’.<br>Ø§Ú¯Ø± Ø§ÛŒØ³Ø§ Ù†ÛÛŒÚº ÛÙˆØªØ§ Ù†ÛÛŒÚºØŒ',0),(123380,3428,'sr','Ð¢Ð¸ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ ÑÐµ Ñ‚Ñ€ÐµÐ±Ð°Ñ˜Ñƒ ÑÐ»Ð°Ñ‚Ð¸ Ð½Ð° Ð»Ð¸ÑÑ‚Ð¸ ÐºÑƒÐ¿Ð°Ñ†Ð° ÐºÐ°Ð´Ð° Ð±ÑƒÐ´Ðµ ÑÐ¿Ñ€ÐµÐ¼Ð½Ð°.<br>ÐÐºÐ¾ ÑÐµ Ñ‚Ð¾ Ð½Ðµ Ð´ÐµÑÐ¸,',0),(123381,3428,'vi','Báº¡n sáº½ Ä‘Æ°á»£c tá»± Ä‘á»™ng thÃªm vÃ o danh sÃ¡ch khÃ¡ch hÃ ng khi sáºµn sÃ ng. Náº¿u khÃ´ng xáº£y ra',0),(123382,3428,'af','U sal outomaties aangestuur word na die KliÃ«ntlys wanneer gereed is. <br> As die nie gebeur,',0),(123383,3428,'ro','Ar trebui in mod automat',0),(123384,3428,'et','Teid suunatakse automaatselt klientide nimekirja, kui see on valmis.<br> Kui seda ei juhtu,',0),(123385,3428,'si','Boste samodejno poÅ¡ljejo seznam kupcev ko je pripravljen.<br>ÄŒe se to zgodi,',0),(123386,3428,'ba','Anda secara otomatis akan diteruskan ke daftar pelanggan saat itu sudah siap.<br>Jika ini tidak terjadi,',0),(123387,3428,'nl','U moet automatisch worden doorgestuurd naar de klantenlijst wanneer het klaar is.<br>Als dit niet gebeurt,',0),(123388,3428,'fi','Voit automaattisesti toimitetaan asiakasluetteloon kun se on valmis.<br>Jos nÃ¤in ei tapahdu,',0),(123389,3428,'no','Du bÃ¸r automatisk bli videresendt til kundelisten nÃ¥r den er klar.<br>Hvis dette ikke skjer,',0),(123390,3428,'da','Du skal automatisk videresendes til debitoroversigten, nÃ¥r den er klar.<br>Sker dette ikke,',0),(123391,3428,'ko','ë‹¹ì‹ ì€ ìžë™ìœ¼ë¡œ ì°©ì‹  ê³ ê° ëª©ë¡ì— ì¤€ë¹„ ë˜ì–´ ìžˆì„ ë•Œ.<br>ì´ ë°œìƒ í•˜ì§€ ì•ŠëŠ” ê²½ìš°',0),(123392,3428,'he','××ª×” ×¦×¨×™×š ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™ ××¤×©×¨×•×ª ×œ×”×¢×‘×™×¨ ×¨×©×™×ž×ª ×œ×§×•×—×•×ª ×›×©×–×” ×™×”×™×” ×ž×•×›×Ÿ.<br>×× ×–×” ×œ× ×§×•×¨×”.',0),(123393,3428,'el','Î£Î±Ï‚ Î¸Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î± Î½Î± Î´Î¹Î±Î²Î¹Î²Î¬Î¶Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î¿Î½ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ ÏŒÏ„Î±Î½ ÎµÎ¯Î½Î±Î¹ Î­Ï„Î¿Î¹Î¼Î¿.<br>Î•Î¬Î½ Î±Ï…Ï„ÏŒ Î´ÎµÎ½ ÏƒÏ…Î¼Î²ÎµÎ¯,',0),(123394,3428,'zh','å½“å…¶å·²å‡†å¤‡å°±ç»ªæ—¶ï¼Œä½ åº”è¯¥è‡ªåŠ¨è¢«è½¬å‘åˆ°å®¢æˆ·åå•ã€‚å¦‚æžœä¸å‘ç”Ÿè¿™ï¼Œ\r\n',0),(123395,3428,'sv','Du bÃ¶r automatiskt vidarebefordras till kundlistan nÃ¤r den Ã¤r klar.<br>Om detta inte sker,',0),(123396,3428,'it','Dovresti essere automaticamente reindirizzato alla lista dei clienti quando l\'azione Ã¨ completata. Se questo non accade, ',0),(123397,3428,'tl','',0),(123398,3428,'th','You should automatically be forwarded to the Customer List when it is ready.<br> If this does not happen,',0),(123399,3428,'hi','à¤œà¤¬ à¤¯à¤¹ à¤¤à¥ˆà¤¯à¤¾à¤° à¤¹à¥ˆ à¤†à¤ª à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‚à¤šà¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤—à¥à¤°à¥‡à¤·à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤<br>à¤¯à¤¦à¤¿ à¤¯à¤¹ à¤¨à¤¹à¥€à¤‚ à¤¹à',0),(123400,3428,'ms','Anda harus secara automatik diserahkan kepada senarai pelanggan apabila ia bersedia.<br>Jika ini tidak berlaku,',0),(123401,3428,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙˆØ¬Ù‡ Ù„Ùƒ ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¥Ù„Ù‰ \"Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡\" Ø¹Ù†Ø¯Ù…Ø§ ÙŠÙƒÙˆÙ† Ø¬Ø§Ù‡Ø²Ø§Ù‹.<br>ÙˆØ¥Ø°Ø§ Ù„Ù… ÙŠØ­Ø¯Ø« Ù‡Ø°Ø§ØŒ',0),(123402,3428,'fr','Vous devriez Ãªtre automatiquement dirigÃ© vers la liste des clients quand c\'est prÃªt. <br> Si cela ne se produit pas',0),(123403,3428,'jp','æº–å‚™å‡ºæ?¥æ¬¡ç¬¬é¡§å®¢ãƒªã‚¹ãƒˆã?¸è»¢é€?ã?•ã‚Œã‚‹ã?¯ã?šã?§ã?™ã€‚<br>ã‚‚ã?—è»¢é€?ã?•ã‚Œã?ªã?‘ã‚Œã?°',0),(123404,3428,'pt','VocÃª automaticamente deve ser encaminhado para a lista de clientes, quando estiver pronto.<br>Se isso nÃ£o acontecer,',0),(123405,3428,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒÑÑ Ðº ÑÐ¿Ð¸ÑÐºÑƒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² ÐºÐ¾Ð³Ð´Ð° Ð¾Ð½ Ð±ÑƒÐ´ÐµÑ‚ Ð³Ð¾Ñ‚Ð¾Ð².<br>Ð•ÑÐ»Ð¸ ÑÑ‚Ð¾Ð³Ð¾ Ð½Ðµ Ð¿Ñ€Ð¾Ð¸Ð·Ð¾Ð¹Ð´ÐµÑ‚,',0),(123406,3428,'es','Debe ser automÃ¡ticamente reenviado a la lista de cliente cuando estÃ© listo.<br> SÃ­ esto no pasa, ',0),(123407,3428,'de','Sie sollten in die Kunden-Liste automatisch Ã¼bermittelt werden, wenn es fertig ist.<br>Wenn dies nicht geschieht,',0),(123408,3428,'en','You should automatically be forwarded to the Customer List when it is ready.<br> If this does not happen,',0),(123409,3429,'is','',0),(123410,3429,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø´Ù…Ø§ Ø¯Ø± Ø­Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´Ø¯Ù† Ø§Ø³Øª ',0),(123411,3429,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø´Ù…Ø§ Ø¯Ø± Ø­Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´Ø¯Ù† Ø§Ø³Øª ',0),(123412,3429,'tr','GÃ¶nderinizin iÅŸleniyor',0),(123413,3429,'pl','PrzesyÅ‚ki sÄ… przetwarzane',0),(123414,3429,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ñ€Ð°Ñ‚ÐºÐ° ÑÐµ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð²Ð°',0),(123415,3429,'ur','Ø¢Ù¾ Ú©ÛŒ Ú©Ú¾ÛŒÙ¾ Ù¾Ø± Ø¹Ù…Ù„Ø¯Ø±Ø¢Ù…Ø¯ Ú©ÛŒØ§ Ø¬Ø§ Ø±ÛØ§ ÛÛ’',0),(123416,3429,'sr','Ð¢Ð²Ð¾Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ ÑÐµ Ð¾Ð±Ñ€Ð°Ñ’ÑƒÑ˜Ðµ.',0),(123417,3429,'vi','Chuyáº¿n hÃ ng cá»§a báº¡n Ä‘ang tiáº¿n hÃ ng',0),(123418,3429,'af','U VERSENDING word verwerk.',0),(123419,3429,'ro','Coletul dumneavoastra este in curs de procesare',0),(123420,3429,'et','Teie tellimus on tÃ¶Ã¶tlemisel',0),(123421,3429,'si','Obdelovanje vaÅ¡e poÅ¡iljke',0),(123422,3429,'ba','Pengiriman Anda sedang diproses',0),(123423,3429,'nl','Uw zending wordt verwerkt',0),(123424,3429,'fi','LÃ¤hetyksen kÃ¤sitellÃ¤Ã¤n',0),(123425,3429,'no','Forsendelsen behandles',0),(123426,3429,'da','Der behandles din forsendelse',0),(123427,3429,'ko','ë°œì†¡ë¬¼ ì²˜ë¦¬ ë˜',0),(123428,3429,'he','×”×ž×©×œ×•×— ×©×œ×š ×ž×¢×•×‘×“×ª',0),(123429,3429,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ ÏƒÎ±Ï‚ ÎµÎ¯Î½Î±Î¹ Ï…Ï€ÏŒ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(123430,3429,'zh','æ­£åœ¨å¤„ç†æ‚¨çš„è´§ä»¶\r\n',0),(123431,3429,'sv','Din fÃ¶rsÃ¤ndelse som behandlas',0),(123432,3429,'it','La spedizione Ã¨ in corso di elaborazione',0),(123433,3429,'tl','',0),(123434,3429,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3585;&#3635;&#3621;&#3633;&#3591;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3629;&#3618;&#3641;&#3656;',0),(123435,3429,'hi','à¤…à¤ªà¤¨à¥‡ à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(123436,3429,'ms','Penghantaran anda sedang diproses',0),(123437,3429,'ar','ÙŠØ¬Ø±ÙŠ ØªØ¬Ù‡ÙŠØ² Ø§Ù„Ø´Ø­Ù†Ø© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(123438,3429,'fr','Votre envoi est en cours de traitement',0),(123439,3429,'jp','ç™ºé€?ã?¯é€²ã‚“ã?§ã?„ã?¾ã?™',0),(123440,3429,'pt','Sua encomenda estÃ¡ sendo processada.',0),(123441,3429,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ Ð²Ð°ÑˆÐµÐ³Ð¾ Ð³Ñ€ÑƒÐ·Ð°',0),(123442,3429,'es','Su envÃ­o estÃ¡ siendo procesado',0),(123443,3429,'de','Ihre Sendung wird verarbeitet',0),(123444,3429,'en','Your shipment is being processed',0),(123445,3430,'is','',0),(123446,3430,'dr','Ø´Ù…Ø§ Ø³Ø¹ÙŠ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ ÙƒÙ‡ ÙŠÙƒ ØµÙØ­Ù‡ Ø¹ÙˆØ¶ ÙƒÙ†ÙŠØ¯ ',0),(123447,3430,'pr','Ø´Ù…Ø§ Ø³Ø¹ÙŠ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ ÙƒÙ‡ ÙŠÙƒ ØµÙØ­Ù‡ Ø¹ÙˆØ¶ ÙƒÙ†ÙŠØ¯ ',0),(123448,3430,'tr','Bir sayfa kendisi ile takas iÃ§in Ã§alÄ±ÅŸÄ±yoruz',0),(123449,3430,'pl','PrÃ³bujesz zamieniÄ‡ stronÄ™ z siebie',0),(123450,3430,'bg','Ð’Ð¸Ðµ ÑÐµ Ð¾Ð¿Ð¸Ñ‚Ð²Ð°Ñ‚Ðµ Ð´Ð° ÑÐ¼ÐµÐ½ÑÑ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÑÑŠÑ ÑÐµÐ±Ðµ ÑÐ¸',0),(123451,3430,'ur','Ø¢Ù¾ Ø®ÙˆØ¯ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© ØµÙØ­Û Ø³ÙˆÛŒÙ¾ Ú©Ø±Ù†Û’ Ú©ÛŒ Ú©ÙˆØ´Ø´ Ú©Ø± Ø±ÛÛ’ ÛÛŒÚº',0),(123452,3430,'sr','ÐŸÐ¾ÐºÑƒÑˆÐ°Ð²Ð°Ñ‚Ðµ Ð´Ð° Ñ€Ð°Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ ÑÐ° ÑÐ°Ð¼Ð¸Ð¼ ÑÐ¾Ð±Ð¾Ð¼',0),(123453,3430,'vi','Báº¡n Ä‘ang giao hoÃ¡n cÃ¹ng 1 trang',0),(123454,3430,'af','U probeer om \'n BLADSY met homself OM TE RUIL.',0),(123455,3430,'ro','ÃŽncercaÅ£i sÄƒ swap o paginÄƒ cu sine',0),(123456,3430,'et','Te proovite lehte vahetada sama lehega',0),(123457,3430,'si','PoskuÅ¡ate swap stran sama s sabo',0),(123458,3430,'ba','Anda mencoba untuk menukar halaman dengan dirinya sendiri',0),(123459,3430,'nl','U probeert te ruilen van een pagina met zichzelf',0),(123460,3430,'fi','YritÃ¤t vaihtaa sivun itse',0),(123461,3430,'no','Du prÃ¸ver Ã¥ bytte en side med seg selv',0),(123462,3430,'da','Du forsÃ¸ger at bytte en side med sig selv',0),(123463,3430,'ko','ìžì²´ì ìœ¼ë¡œ ê°€ì§„ íŽ˜ì´ì§€ë¥¼ ìŠ¤ì™‘ í•˜ë ¤ëŠ”',0),(123464,3430,'he','××ª×” ×ž× ×¡×” ×œ×”×—×œ×™×£ ×¢×ž×•×“ ×¢× ×¢×¦×ž×”',0),(123465,3430,'el','Î ÏÎ¿ÏƒÏ€Î±Î¸ÎµÎ¯Ï„Îµ Î½Î± Î±Î½Ï„Î±Î»Î»Î¬Î¾Î¿Ï…Î½ Î¼Î¹Î± ÏƒÎµÎ»Î¯Î´Î± Î¼Îµ Ï„Î·Î½ Î¯Î´Î¹Î±',0),(123466,3430,'zh','æ‚¨æ­£è¯•å›¾ä¸Žè‡ªå·±äº¤æ¢çš„é¡µé¢\r\n',0),(123467,3430,'sv','Du fÃ¶rsÃ¶ker byta en sida med sig',0),(123468,3430,'it','Si sta cercando di scambiare una pagina con la stessa',0),(123469,3430,'tl','',0),(123470,3430,'th','&#3588;&#3640;&#3603;&#3585;&#3635;&#3621;&#3633;&#3591;&#3614;&#3618;&#3634;&#3618;&#3634;&#3617;&#3607;&#3637;&#3656;&#3592;&#3632;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3627;&#3609;&#3657;&#3634;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(123471,3430,'hi','à¤†à¤ª à¤–à¥à¤¦ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤ªà¥ƒà¤·à¥à¤  à¤¸à¥à¤µà¥ˆà¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚',0),(123472,3430,'ms','Anda cuba untuk menukar Laman dengan sendiri',0),(123473,3430,'ar','Ø£Ù†Øª ØªØ­Ø§ÙˆÙ„ Ù…Ø¨Ø§Ø¯Ù„Ø© ØµÙØ­Ø© Ù…Ø¹ Ù†ÙØ³Ù‡Ø§',0),(123474,3430,'fr','Vous essayez d\'Ã©changer une page avec elle-mÃªme',0),(123475,3430,'jp','ãƒšãƒ¼ã‚¸è‡ªä½“ã‚’äº¤æ?›ã?—ã‚ˆã?†ã?¨ã?—ã?¦ã?„ã?¾ã?™',0),(123476,3430,'pt','VocÃª estÃ¡ tentando trocar uma pÃ¡gina com o prÃ³prio',0),(123477,3430,'ru','Ð’Ñ‹ Ð¿Ñ‹Ñ‚Ð°ÐµÑ‚ÐµÑÑŒ Ð¿Ð¾Ð¼ÐµÐ½ÑÑ‚ÑŒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ñ ÑÐ°Ð¼Ð¸Ð¼ ÑÐ¾Ð±Ð¾Ð¹',0),(123478,3430,'es','EstÃ¡ tratando de intercambiar una pÃ¡gina si misma',0),(123479,3430,'de','Sie versuchen, eine Seite mit sich selbst zu tauschen',0),(123480,3430,'en','You are trying to swap a page with itself',0),(123481,3431,'is','',0),(123482,3431,'dr','ØµÙØ±  0 ',0),(123483,3431,'pr','ØµÙØ±  0 ',0),(123484,3431,'tr','sÄ±fÄ±r',0),(123485,3431,'pl','zero',0),(123486,3431,'bg','Ð½ÑƒÐ»Ð°',0),(123487,3431,'ur','ØµÙØ±',0),(123488,3431,'sr','Ð½ÑƒÐ»Ð°',0),(123489,3431,'vi','KhÃ´ng',0),(123490,3431,'af','nul',0),(123491,3431,'ro','zero',0),(123492,3431,'et','Null',0),(123493,3431,'si','niÄ',0),(123494,3431,'ba','nol',0),(123495,3431,'nl','nul',0),(123496,3431,'fi','nolla',0),(123497,3431,'no','null',0),(123498,3431,'da','nul',0),(123499,3431,'ko','0',0),(123500,3431,'he','××¤×¡',0),(123501,3431,'el','Î¼Î·Î´Î­Î½',0),(123502,3431,'zh','é›¶',0),(123503,3431,'sv','noll',0),(123504,3431,'it','zero',0),(123505,3431,'tl','',0),(123506,3431,'th','&#3624;&#3641;&#3609;&#3618;&#3660;',0),(123507,3431,'hi','à¤¶à¥‚à¤¨à¥à¤¯',0),(123508,3431,'ms','sifar',0),(123509,3431,'ar','ØµÙØ±',0),(123510,3431,'fr','zÃ©ro',0),(123511,3431,'jp','ã‚¼ãƒ­',0),(123512,3431,'pt','zero',0),(123513,3431,'ru','Ð½Ð¾Ð»ÑŒ',0),(123514,3431,'es','Cero',0),(123515,3431,'de','0 (null)',0),(123516,3431,'en','zero',0),(123517,3432,'is','',0),(123518,3432,'dr','ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(123519,3432,'pr','ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(123520,3432,'tr','ZIP',0),(123521,3432,'pl','Zip',0),(123522,3432,'bg','ZIP',0),(123523,3432,'ur','Ø²Ù¾',0),(123524,3432,'sr','Ð—Ð˜ÐŸ',0),(123525,3432,'vi','Zip',0),(123526,3432,'af','Kode',0),(123527,3432,'ro','cod postal',0),(123528,3432,'et','Postikood',0),(123529,3432,'si','Zip',0),(123530,3432,'ba','Zip',0),(123531,3432,'nl','Zip',0),(123532,3432,'fi','Zip',0),(123533,3432,'no','Zip',0),(123534,3432,'da','Zip',0),(123535,3432,'ko','ìš°íŽ¸ ë²ˆí˜¸',0),(123536,3432,'he','×ž×™×§×•×“',0),(123537,3432,'el','Zip',0),(123538,3432,'zh','é‚®ç¼–',0),(123539,3432,'sv','Zip',0),(123540,3432,'it','Zip',0),(123541,3432,'tl','',0),(123542,3432,'th','&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;',0),(123543,3432,'hi','à¤œà¤¼à¤¿à¤ª',0),(123544,3432,'ms','Zip',0),(123545,3432,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(123546,3432,'fr','Zip',0),(123547,3432,'jp','éƒµä¾¿ç•ªå?·',0),(123548,3432,'pt','Zip',0),(123549,3432,'ru','ZIP',0),(123550,3432,'es','Zip',0),(123551,3432,'de','ZIP',0),(123552,3432,'en','Zip',0),(123553,3433,'is','',0),(123554,3433,'dr','ÙØ§ØµÙ„Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ',0),(123555,3433,'pr','ÙØ§ØµÙ„Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ',0),(123556,3433,'tr','Arama aralÄ±ÄŸÄ±',0),(123557,3433,'pl','InterwaÅ‚ dla wyszukiwania',0),(123558,3433,'bg','Ð˜Ð½Ñ‚ÐµÑ€Ð²Ð°Ð» Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(123559,3433,'ur','ØªÙ„Ø§Ø´ Ú©Û’ Ù„Ø¦Û’ ÙˆÙ‚ÙÛ',0),(123560,3433,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð²Ð°Ð» Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(123561,3433,'vi','QuÃ£ng dá»«ng Ä‘á»ƒ tÃ¬m',0),(123562,3433,'af','Interval vir soektog',0),(123563,3433,'ro','Intervalul de cÄƒutare',0),(123564,3433,'et','Otsi intervalliga',0),(123565,3433,'si','Interval za iskanje',0),(123566,3433,'ba','Interval untuk Cari',0),(123567,3433,'nl','Interval voor zoeken',0),(123568,3433,'fi','AikavÃ¤li Etsi',0),(123569,3433,'no','Intervall for sÃ¸k',0),(123570,3433,'da','Interval til sÃ¸gning',0),(123571,3433,'ko','ê²€ìƒ‰ì— ëŒ€ í•œ ê°„ê²©',0),(123572,3433,'he','×ž×¨×•×•×— ×¢×‘×•×¨ ×—×™×¤×•×©',0),(123573,3433,'el','Î”Î¹Î¬ÏƒÏ„Î·Î¼Î± Î³Î¹Î± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(123574,3433,'zh','åŒºé—´æœç´¢\r\n',0),(123575,3433,'sv','Intervall fÃ¶r sÃ¶kning',0),(123576,3433,'it','Intervallo per la ricerca',0),(123577,3433,'tl','',0),(123578,3433,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(123579,3433,'hi','à¤–à¥‹à¤œ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤‚à¤¤à¤°à¤¾à¤²',0),(123580,3433,'ms','Tempoh untuk carian',0),(123581,3433,'ar','Ø§Ù„ÙØ§ØµÙ„ Ø§Ù„Ø²Ù…Ù†ÙŠ Ù„Ù„Ø¨Ø­Ø«',0),(123582,3433,'fr','Intervalle de recherche',0),(123583,3433,'jp','æ¤œç´¢ã?®é–“éš”',0),(123584,3433,'pt','Intervalo para Pesquisar',0),(123585,3433,'ru','Ð˜Ð½Ñ‚ÐµÑ€Ð²Ð°Ð» Ð´Ð»Ñ Ð¿Ð¾Ð¸ÑÐºÐ°',0),(123586,3433,'es','Intervalo para la Busqueda',0),(123587,3433,'de','Intervall fÃ¼r die Suche',0),(123588,3433,'en','Interval for search',0),(123589,3434,'is','',0),(123590,3434,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ',0),(123591,3434,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ',0),(123592,3434,'tr','BaÅŸlangÄ±Ã§ tarihi',0),(123593,3434,'pl','Data rozpoczÄ™cia',0),(123594,3434,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(123595,3434,'ur','ØªØ§Ø±ÛŒØ® Ø¢ØºØ§Ø²',0),(123596,3434,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(123597,3434,'vi','NgÃ y báº¯t Ä‘áº§u',0),(123598,3434,'af','Begin Datum',0),(123599,3434,'ro','Data de Ã®nceput',0),(123600,3434,'et','AlguskuupÃ¤ev',0),(123601,3434,'si','ZaÄetni datum',0),(123602,3434,'ba','Tanggal mulai',0),(123603,3434,'nl','Begindatum',0),(123604,3434,'fi','AlkamispÃ¤ivÃ¤',0),(123605,3434,'no','Startdato',0),(123606,3434,'da','Start dato',0),(123607,3434,'ko','ì‹œìž‘ ë‚ ì§œ',0),(123608,3434,'he','×ª××¨×™×š ×”×ª×—×œ×”',0),(123609,3434,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(123610,3434,'zh','å¼€å§‹æ—¥æœŸ\r\n',0),(123611,3434,'sv','Startdatum',0),(123612,3434,'it','Data di inizio',0),(123613,3434,'tl','',0),(123614,3434,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(123615,3434,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(123616,3434,'ms','Tarikh mula',0),(123617,3434,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(123618,3434,'fr','Date de dÃ©but',0),(123619,3434,'jp','é–‹å§‹æ—¥',0),(123620,3434,'pt','Data de inÃ­cio',0),(123621,3434,'ru','Ð”Ð°Ñ‚Ð° ÐÐ°Ñ‡Ð°Ð»Ð°',0),(123622,3434,'es','Fecha de Inicio',0),(123623,3434,'de','Startdatum',0),(123624,3434,'en','Start Date',0),(123625,3435,'is','',0),(123626,3435,'dr','Ø¯Ø± ',0),(123627,3435,'pr','Ø¯Ø± ',0),(123628,3435,'tr','Ä°Ã§inde',0),(123629,3435,'pl','W',0),(123630,3435,'bg','Ð’',0),(123631,3435,'ur','Ù…ÛŒÚº',0),(123632,3435,'sr','Ð£',0),(123633,3435,'vi','VÃ o',0),(123634,3435,'af','In',0),(123635,3435,'ro','ÃŽn',0),(123636,3435,'et','Aastal',0),(123637,3435,'si','V',0),(123638,3435,'ba','Dalam',0),(123639,3435,'nl','In',0),(123640,3435,'fi','TÃ¤ssÃ¤',0),(123641,3435,'no','I',0),(123642,3435,'da','I',0),(123643,3435,'ko','ì—ì„œ',0),(123644,3435,'he','×‘',0),(123645,3435,'el','Î£Îµ',0),(123646,3435,'zh','åœ¨\r\n',0),(123647,3435,'sv','I',0),(123648,3435,'it','In',0),(123649,3435,'tl','',0),(123650,3435,'th','&#3651;&#3609;',0),(123651,3435,'hi','à¤®à¥‡à¤‚',0),(123652,3435,'ms','Dalam',0),(123653,3435,'ar','ÙÙŠ',0),(123654,3435,'fr','Dans',0),(123655,3435,'jp','ã‚¤ãƒ³',0),(123656,3435,'pt','Em',0),(123657,3435,'ru','Ð’',0),(123658,3435,'es','Dentro',0),(123659,3435,'de','In',0),(123660,3435,'en','In',0),(123661,3436,'is','',0),(123662,3436,'dr','Ø®Ø§Ø±Ø¬ ',0),(123663,3436,'pr','Ø®Ø§Ø±Ø¬ ',0),(123664,3436,'tr','Out',0),(123665,3436,'pl','Obecnie',0),(123666,3436,'bg','Ð’ÑŠÐ½',0),(123667,3436,'ur','Ø¨Ø§ÛØ±',0),(123668,3436,'sr','ÐÐ°Ð¿Ð¾Ñ™Ðµ',0),(123669,3436,'vi','Ra',0),(123670,3436,'af','Uit',0),(123671,3436,'ro','AfarÄƒ',0),(123672,3436,'et','LÃ¤bi',0),(123673,3436,'si','Ven',0),(123674,3436,'ba','Keluar',0),(123675,3436,'nl','Uit',0),(123676,3436,'fi','Ulos',0),(123677,3436,'no','Ut',0),(123678,3436,'da','Ud',0),(123679,3436,'ko','ë°–ìœ¼ë¡œ',0),(123680,3436,'he','.',0),(123681,3436,'el','ÎˆÎ¾Ï‰',0),(123682,3436,'zh','å‡º\r\n',0),(123683,3436,'sv','Ut',0),(123684,3436,'it','Fuori',0),(123685,3436,'tl','',0),(123686,3436,'th','&#3629;&#3629;&#3585;',0),(123687,3436,'hi','à¤¬à¤¾à¤¹à¤°',0),(123688,3436,'ms','Keluar',0),(123689,3436,'ar','Ø§Ù„Ø®Ø±ÙˆØ¬',0),(123690,3436,'fr','Out',0),(123691,3436,'jp','ã‚¢ã‚¦ãƒˆ',0),(123692,3436,'pt','Para fora',0),(123693,3436,'ru','Ð˜Ð·',0),(123694,3436,'es','Fuera',0),(123695,3436,'de','Aus',0),(123696,3436,'en','Out',0),(123697,3437,'is','',0),(123698,3437,'dr','Ú†Ù‡ ÙƒØ³ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙƒØ±Ø¯ ',0),(123699,3437,'pr','Ú†Ù‡ ÙƒØ³ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙƒØ±Ø¯ ',0),(123700,3437,'tr','Kim yarattÄ±',0),(123701,3437,'pl','Kto stworzyÅ‚',0),(123702,3437,'bg','ÐšÐ¾Ð¹ Ðµ ÑÑŠÐ·Ð´Ð°Ð»',0),(123703,3437,'ur','Ø¬Ùˆ Ú©Ùˆ Ø®Ù„Ù‚ Ú©ÛŒØ§',0),(123704,3437,'sr','ÐšÐ¾ Ñ˜Ðµ ÑÑ‚Ð²Ð¾Ñ€Ð¸Ð¾',0),(123705,3437,'vi','Ai táº¡o ra',0),(123706,3437,'af','Wie Het Geskep',0),(123707,3437,'ro','Care a creat',0),(123708,3437,'et','Kelle poolt loodud',0),(123709,3437,'si','Kdo je ustvaril',0),(123710,3437,'ba','Siapa yang menciptakan',0),(123711,3437,'nl','Wie schiep',0),(123712,3437,'fi','Kuka loi',0),(123713,3437,'no','Hvem skapt',0),(123714,3437,'da','Hvem skabte',0),(123715,3437,'ko','ë§Œë“  ì‚¬ëžŒ',0),(123716,3437,'he','×ž×™ ×™×¦×¨',0),(123717,3437,'el','Î Î¿Î¹Î¿Ï‚ Ï„Î¿ Î´Î·Î¼Î¹Î¿ÏÏÎ³Î·ÏƒÎµ',0),(123718,3437,'zh','æ˜¯è°åˆ›é€ \r\n',0),(123719,3437,'sv','Vem skapade',0),(123720,3437,'it','Chi ha creato',0),(123721,3437,'tl','',0),(123722,3437,'th','&#3651;&#3588;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(123723,3437,'hi','à¤•à¥Œà¤¨ à¤¬à¤¨à¤¾à¤',0),(123724,3437,'ms','Yang dicipta',0),(123725,3437,'ar','Ø§Ù„Ø°ÙŠÙ† ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§',0),(123726,3437,'fr','Qui a crÃ©Ã©',0),(123727,3437,'jp','ä½œæˆ?è€…',0),(123728,3437,'pt','Quem o criou',0),(123729,3437,'ru','ÐšÑ‚Ð¾ Ð¡Ð¾Ð·Ð´Ð°Ð»',0),(123730,3437,'es','Quien CreÃ³',0),(123731,3437,'de','Wer erschuf',0),(123732,3437,'en','Who Created',0),(123733,3438,'is','',0),(123734,3438,'dr','Ø®Ø±ÙŠØ¯',0),(123735,3438,'pr','Ø®Ø±ÙŠØ¯',0),(123736,3438,'tr','SatÄ±n alma',0),(123737,3438,'pl','Zakup',0),(123738,3438,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ°',0),(123739,3438,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(123740,3438,'sr','ÐÐ°Ð±Ð°Ð²ÐºÐµ',0),(123741,3438,'vi','Mua',0),(123742,3438,'af','Aankoop',0),(123743,3438,'ro','CumpÄƒrare',0),(123744,3438,'et','Ostu',0),(123745,3438,'si','Nakup',0),(123746,3438,'ba','Pembelian',0),(123747,3438,'nl','Aankoop',0),(123748,3438,'fi','Osto',0),(123749,3438,'no','KjÃ¸p',0),(123750,3438,'da','KÃ¸b',0),(123751,3438,'ko','êµ¬ë§¤',0),(123752,3438,'he','×¨×›×™×©×”',0),(123753,3438,'el','Î‘Î³Î¿ÏÎ¬',0),(123754,3438,'zh','è´­ä¹°\r\n',0),(123755,3438,'sv','KÃ¶p',0),(123756,3438,'it','Acquisto',0),(123757,3438,'tl','',0),(123758,3438,'th','&#3595;&#3639;&#3657;&#3629;',0),(123759,3438,'hi','à¤–à¤°à¥€à¤¦',0),(123760,3438,'ms','Pembelian',0),(123761,3438,'ar','Ø´Ø±Ø§Ø¡',0),(123762,3438,'fr','Achat',0),(123763,3438,'jp','è³¼å…¥',0),(123764,3438,'pt','Compra',0),(123765,3438,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ°',0),(123766,3438,'es','Comprar',0),(123767,3438,'de','Kaufen',0),(123768,3438,'en','Purchase',0),(123769,3439,'is','',0),(123770,3439,'dr','/ Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(123771,3439,'pr','ÙØ±ÙˆØ´  / Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(123772,3439,'tr','SatÄ±ÅŸ/kullanÄ±m',0),(123773,3439,'pl','SprzedaÅ¼y/wykorzystania',0),(123774,3439,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸/ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(123775,3439,'ur','Ø³ÛŒÙ„Ø²/Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Û”',0),(123776,3439,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð°/ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(123777,3439,'vi','BÃ¡n hÃ ng/DÃ¹ng',0),(123778,3439,'af','Verkope/Gebruike',0),(123779,3439,'ro','VÃ¢nzÄƒri/utilizare',0),(123780,3439,'et','MÃ¼Ã¼k/kasutamine',0),(123781,3439,'si','Prodaja/uporabo',0),(123782,3439,'ba','Penjualan dan pemakaian',0),(123783,3439,'nl','Verkoop/gebruik',0),(123784,3439,'fi','Myynti/kÃ¤yttÃ¤Ã¤',0),(123785,3439,'no','Salg/bruk',0),(123786,3439,'da','Salg/brug',0),(123787,3439,'ko','íŒë§¤/ì‚¬ìš©',0),(123788,3439,'he','×ž×›×™×¨×•×ª/×©×™×ž×•×©',0),(123789,3439,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚/Ï‡ÏÎ®ÏƒÎ·',0),(123790,3439,'zh','é”€å”®/ä½¿ç”¨\r\n',0),(123791,3439,'sv','FÃ¶rsÃ¤ljning/anvÃ¤ndning',0),(123792,3439,'it','Vendite/uso',0),(123793,3439,'tl','',0),(123794,3439,'th','&#3586;&#3634;&#3618;/&#3651;&#3594;&#3657;',0),(123795,3439,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€/à¤‰à¤ªà¤¯à¥‹à¤—',0),(123796,3439,'ms','Jualan/menggunakan',0),(123797,3439,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª/Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(123798,3439,'fr','Ventes/utilisation',0),(123799,3439,'jp','è²©å£²/åˆ©ç”¨',0),(123800,3439,'pt','Vendas/uso',0),(123801,3439,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸/Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(123802,3439,'es','Ventas/Uso',0),(123803,3439,'de','Vertrieb/verwenden',0),(123804,3439,'en','Sales/Use',0),(123805,3440,'is','',0),(123806,3440,'dr','Ø´Ø±ÙˆØ¹ ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø±',0),(123807,3440,'pr','Ø´Ø±ÙˆØ¹ ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø±',0),(123808,3440,'tr','Eldeki Begin',0),(123809,3440,'pl','PoczÄ…tek na rÄ™kÄ™',0),(123810,3440,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð½Ð° Ñ€ÑŠÐºÐ°',0),(123811,3440,'ur','ÛØ§ØªÚ¾ Ù¾Ø± Ø´Ø±ÙˆØ¹',0),(123812,3440,'sr','ÐžÐ·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð½Ð° Ñ€ÑƒÐºÑƒ',0),(123813,3440,'vi','Báº¯t Ä‘áº§u CÃ³ sáºµn',0),(123814,3440,'af','Op-Hand Begin',0),(123815,3440,'ro','Inceput de pe-o parte',0),(123816,3440,'et','Vaba algus',0),(123817,3440,'si','ZaÄnite na roko',0),(123818,3440,'ba','Mulailah di tangan',0),(123819,3440,'nl','Begin op de Hand',0),(123820,3440,'fi','KÃ¤si alkaa',0),(123821,3440,'no','Beholdning begynner',0),(123822,3440,'da','Begynd pÃ¥ hÃ¥nd',0),(123823,3440,'ko','ì‹œìž‘ ì†',0),(123824,3440,'he','×‘×’×™×Ÿ ×¢×œ-×™×“',0),(123825,3440,'el','Î£Ï„Î· Î´Î¹Î¬Î¸ÎµÏƒÎ® ÏƒÎ±Ï‚ Î±ÏÏ‡Î¯ÏƒÏ„Îµ',0),(123826,3440,'zh','çŽ°æœ‰å¼€å§‹\r\n ',0),(123827,3440,'sv','BÃ¶rja pÃ¥ Hand',0),(123828,3440,'it','Begin a portata di mano',0),(123829,3440,'tl','',0),(123830,3440,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3607;&#3637;&#3656;&#3606;&#3639;&#3629;&#3629;&#3618;&#3641;&#3656;',0),(123831,3440,'hi','à¤ªà¤° à¤¹à¤¾à¤¥ à¤¶à¥à¤°à¥‚',0),(123832,3440,'ms','Mulakan pada tangan',0),(123833,3440,'ar','Ø§Ù„Ø¨Ø¯Ø¡ ÙÙŠ Ø§Ù„ÙŠØ¯',0),(123834,3440,'fr','Begin Ã  portÃ©e de main',0),(123835,3440,'jp','æ‰‹æŒ?ã?¡é–‹å§‹',0),(123836,3440,'pt','Begin na mÃ£o',0),(123837,3440,'ru','ÐÐ° Ñ€ÑƒÐºÑƒ Begin',0),(123838,3440,'es','Disponble Comenzar',0),(123839,3440,'de','Begin auf die Hand',0),(123840,3440,'en','On-Hand Begin',0),(123841,3441,'is','',0),(123842,3441,'dr','(ØªØ¹Ø¯ÙŠÙ„ Ø´Ø¯Ù‡ ',0),(123843,3441,'pr','Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡ (ØªØ¹Ø¯ÙŠÙ„ Ø´Ø¯Ù‡ ',0),(123844,3441,'tr','Ayarlanabilir',0),(123845,3441,'pl','Dostosowane',0),(123846,3441,'bg','ÐšÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ð¸',0),(123847,3441,'ur','Ø§ÛŒÚˆØ¬Ø³Ù¹',0),(123848,3441,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ð¸Ð¾',0),(123849,3441,'vi','ÄÃ£ Sá»­a Äá»•i',0),(123850,3441,'af','Reggestel',0),(123851,3441,'ro','Ajustate',0),(123852,3441,'et','Korrigeeritud',0),(123853,3441,'si','Prilagojena',0),(123854,3441,'ba','Disesuaikan',0),(123855,3441,'nl','Aangepast',0),(123856,3441,'fi','SÃ¤Ã¤tÃ¤Ã¤',0),(123857,3441,'no','Justert',0),(123858,3441,'da','Justeret',0),(123859,3441,'ko','ì¡°ì •',0),(123860,3441,'he','×ž×•×ª××',0),(123861,3441,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÏ„ÎµÎ¯',0),(123862,3441,'zh','è°ƒæ•´åŽ\r\n',0),(123863,3441,'sv','Justerat',0),(123864,3441,'it','Regolata',0),(123865,3441,'tl','',0),(123866,3441,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(123867,3441,'hi','à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤',0),(123868,3441,'ms','Diselaraskan',0),(123869,3441,'ar','Ø¶Ø¨Ø·',0),(123870,3441,'fr','AjustÃ©',0),(123871,3441,'jp','èª¿æ•´ã?•ã‚Œã‚‹',0),(123872,3441,'pt','Ajustado',0),(123873,3441,'ru','Ð¡ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹',0),(123874,3441,'es','Ajustado',0),(123875,3441,'de','Angepasst',0),(123876,3441,'en','Adjusted',0),(123877,3442,'is','',0),(123878,3442,'dr','Ù¾Ø§ÙŠØ§Ù†  ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø±',0),(123879,3442,'pr','Ù¾Ø§ÙŠØ§Ù†  ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø±',0),(123880,3442,'tr','Eldeki son',0),(123881,3442,'pl','Koniec na rÄ™kÄ™',0),(123882,3442,'bg','ÐšÑ€Ð°Ñ Ð½Ð° Ñ€ÑŠÐºÐ°',0),(123883,3442,'ur','ÛØ§ØªÚ¾ Ù¾Ø± Ø§Ø®ØªØªØ§Ù…',0),(123884,3442,'sr','ÐšÑ€Ð°Ñ˜ Ð½Ð° Ñ€ÑƒÐºÑƒ',0),(123885,3442,'vi','Cuá»‘i CÃ³ sáºµn',0),(123886,3442,'af','Op-Hand einde',0),(123887,3442,'ro','Pe-o parte sfÃ¢rÅŸitul',0),(123888,3442,'et','Vaba ots',0),(123889,3442,'si','Na roko konec',0),(123890,3442,'ba','Di tangan akhir',0),(123891,3442,'nl','Op de Hand einde',0),(123892,3442,'fi','KÃ¤ytettÃ¤vissÃ¤ vuoden',0),(123893,3442,'no','Beholdning slutten',0),(123894,3442,'da','On-side ende',0),(123895,3442,'ko','ì† ë',0),(123896,3442,'he','×§×¦×” ×¢×œ-×™×“',0),(123897,3442,'el','Î¤Î­Î»Î¿Ï‚ ÏƒÏ„Î· Î´Î¹Î¬Î¸ÎµÏƒÎ® ÏƒÎ±Ï‚',0),(123898,3442,'zh','çŽ°æœ‰ç»“æŸ\r\n',0),(123899,3442,'sv','BehÃ¥llning slutet',0),(123900,3442,'it','Fine a portata di mano',0),(123901,3442,'tl','',0),(123902,3442,'th','&#3607;&#3637;&#3656;&#3606;&#3639;&#3629;&#3629;&#3618;&#3641;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(123903,3442,'hi','à¤¹à¤¾à¤¥ à¤ªà¤° à¤…à¤‚à¤¤',0),(123904,3442,'ms','Akhir di tangan',0),(123905,3442,'ar','Ù†Ù‡Ø§ÙŠØ© Ø¹Ù„Ù‰ ÙŠØ¯',0),(123906,3442,'fr','Fin de stock',0),(123907,3442,'jp','æ‰‹æŒ?ã?¡çµ‚äº†',0),(123908,3442,'pt','Na mÃ£o final',0),(123909,3442,'ru','ÐÐ° Ñ€ÑƒÐºÑƒ ÐºÐ¾Ð½ÐµÑ†',0),(123910,3442,'es','Disponble Terminar',0),(123911,3442,'de','Lagerbestand Ende',0),(123912,3442,'en','On-Hand End',0),(123913,3443,'is','',0),(123914,3443,'dr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§ ',0),(123915,3443,'pr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§ ',0),(123916,3443,'tr','Ã–zellikler',0),(123917,3443,'pl','WÅ‚aÅ›ciwoÅ›ci',0),(123918,3443,'bg','Ð˜Ð¼Ð¾Ñ‚Ð¸',0),(123919,3443,'ur','Ø®ÙˆØ§Øµ',0),(123920,3443,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð°',0),(123921,3443,'vi','tÃ i sáº£n',0),(123922,3443,'af','Eiendomme',0),(123923,3443,'ro','ProprietÄƒÅ£i',0),(123924,3443,'et','Atribuudid',0),(123925,3443,'si','Lastnosti',0),(123926,3443,'ba','Properti',0),(123927,3443,'nl','Eigenschappen',0),(123928,3443,'fi','Ominaisuudet',0),(123929,3443,'no','Egenskaper',0),(123930,3443,'da','Egenskaber',0),(123931,3443,'ko','ì†ì„±',0),(123932,3443,'he','×ž××¤×™×™× ×™',0),(123933,3443,'el','Î™Î´Î¹ÏŒÏ„Î·Ï„ÎµÏ‚',0),(123934,3443,'zh','å±žæ€§\r\n',0),(123935,3443,'sv','Egenskaper',0),(123936,3443,'it','ProprietÃ ',0),(123937,3443,'tl','',0),(123938,3443,'th','&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;',0),(123939,3443,'hi','à¤—à¥à¤£',0),(123940,3443,'ms','Sifat-sifat',0),(123941,3443,'ar','Ø®ØµØ§Ø¦Øµ',0),(123942,3443,'fr','PropriÃ©tÃ©s',0),(123943,3443,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ãƒ¼',0),(123944,3443,'pt','Propriedades',0),(123945,3443,'ru','Ð¡Ð²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(123946,3443,'es','CaracterÃ­sticas',0),(123947,3443,'de','Eigenschaften',0),(123948,3443,'en','Properties',0),(123949,3444,'is','',0),(123950,3444,'dr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ',0),(123951,3444,'pr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ',0),(123952,3444,'tr','AralÄ±ÄŸÄ±',0),(123953,3444,'pl','Zakres',0),(123954,3444,'bg','ÐžÐ±Ñ…Ð²Ð°Ñ‚',0),(123955,3444,'ur','Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(123956,3444,'sr','ÐžÐ¿ÑÐµÐ³',0),(123957,3444,'vi','Pháº¡m vi',0),(123958,3444,'af','Reeks',0),(123959,3444,'ro','Gama',0),(123960,3444,'et','Vahemik',0),(123961,3444,'si','Obseg',0),(123962,3444,'ba','Rentang',0),(123963,3444,'nl','Bereik',0),(123964,3444,'fi','Alue',0),(123965,3444,'no','Utvalg',0),(123966,3444,'da','RÃ¦kkevidde',0),(123967,3444,'ko','ë²”ìœ„',0),(123968,3444,'he','×˜×•×•×—',0),(123969,3444,'el','Î¦Î¬ÏƒÎ¼Î±',0),(123970,3444,'zh','èŒƒå›´\r\n',0),(123971,3444,'sv','Utbud',0),(123972,3444,'it','Gamma',0),(123973,3444,'tl','',0),(123974,3444,'th','&#3586;&#3629;&#3610;&#3648;&#3586;&#3605;',0),(123975,3444,'hi','à¤°à¥‡à¤‚à¤œ',0),(123976,3444,'ms','Pelbagai',0),(123977,3444,'ar','Ø§Ù„Ù†Ø·Ø§Ù‚',0),(123978,3444,'fr','Gamme',0),(123979,3444,'jp','ç¯„å›²',0),(123980,3444,'pt','Gama',0),(123981,3444,'ru','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(123982,3444,'es','Rango',0),(123983,3444,'de','Bereich',0),(123984,3444,'en','Range',0),(123985,3445,'is','',0),(123986,3445,'dr','PWO  ÙˆØ²Ù† Ø®Ø±ÙŠØ¯ ÙØ±Ù…Ø§ÛŒØ´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(123987,3445,'pr','PWO  ÙˆØ²Ù† Ø®Ø±ÙŠØ¯ Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(123988,3445,'tr','PWO',0),(123989,3445,'pl','PWO',0),(123990,3445,'bg','PWO',0),(123991,3445,'ur','Ø³ÙˆØŒ',0),(123992,3445,'sr','ÐŸWÐž',0),(123993,3445,'vi','PWO',0),(123994,3445,'af','PWO',0),(123995,3445,'ro','PWO',0),(123996,3445,'et','PWO',0),(123997,3445,'si','PWO',0),(123998,3445,'ba','PWO',0),(123999,3445,'nl','PWO',0),(124000,3445,'fi','PWO',0),(124001,3445,'no','PWO',0),(124002,3445,'da','PWO',0),(124003,3445,'ko','PWO',0),(124004,3445,'he','PWO',0),(124005,3445,'el','PWO',0),(124006,3445,'zh','å…¬å…±å·¥ç¨‹å®˜\r\n',0),(124007,3445,'sv','PWO',0),(124008,3445,'it','PWO',0),(124009,3445,'tl','',0),(124010,3445,'th','&#3629;&#3591;&#3588;&#3660;&#3585;&#3619;&#3588;&#3621;&#3633;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(124011,3445,'hi','PWO',0),(124012,3445,'ms','PWO',0),(124013,3445,'ar','Ø¨Ùˆ',0),(124014,3445,'fr','PWO',0),(124015,3445,'jp','PWO',0),(124016,3445,'pt','PWO',0),(124017,3445,'ru','PWO',0),(124018,3445,'es','PEO',0),(124019,3445,'de','PWO',0),(124020,3445,'en','PWO',0),(124021,3446,'is','',0),(124022,3446,'dr','ÙØ±Ù… Ù‡Ø§ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(124023,3446,'pr','ÙØ±Ù… Ù‡Ø§ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(124024,3446,'tr','Depo formlarÄ±',0),(124025,3446,'pl','Magazyn formy',0),(124026,3446,'bg','ÐšÐ¸Ð»ÐµÑ€ Ñ„Ð¾Ñ€Ð¼Ð¸',0),(124027,3446,'ur','Ø³Ù¹ÙˆØ±ÛŒØ±ÙˆÙ… ÙØ§Ø±Ù…',0),(124028,3446,'sr','Ð¡ÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ðµ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ†Ð°',0),(124029,3446,'vi','Máº«u phÃ²ng kho',0),(124030,3446,'af','Stoorkamer Vorms',0),(124031,3446,'ro','Forme de depozit',0),(124032,3446,'et','Lao vormid',0),(124033,3446,'si','SkladiÅ¡Äni prostor oblike',0),(124034,3446,'ba','Bentuk-bentuk gudang',0),(124035,3446,'nl','Berging formulieren',0),(124036,3446,'fi','Varasto lomakkeet',0),(124037,3446,'no','Bod skjemaer',0),(124038,3446,'da','Pulterrum former',0),(124039,3446,'ko','ì €ìž¥ì‹¤ í˜•íƒœ',0),(124040,3446,'he','×ž×—×¡×Ÿ ×¦×•×¨×•×ª',0),(124041,3446,'el','Î‘Ï€Î¿Î¸Î®ÎºÎ· Î¼Î¿ÏÏ†Î­Ï‚',0),(124042,3446,'zh','åº“æˆ¿å½¢å¼\r\n',0),(124043,3446,'sv','FÃ¶rrÃ¥d former',0),(124044,3446,'it','Forme di magazzino',0),(124045,3446,'tl','',0),(124046,3446,'th','&#3615;&#3629;&#3619;&#3660;&#3617;&#3627;&#3657;&#3629;&#3591;&#3648;&#3626;&#3650;&#3605;&#3619;&#3660;',0),(124047,3446,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤°à¥‚à¤ªà¥‹à¤‚',0),(124048,3446,'ms','Borang-borang stor',0),(124049,3446,'ar','Ø£Ø´ÙƒØ§Ù„ Ù…Ø®Ø²Ù†Ø§Ù‹',0),(124050,3446,'fr','Formes de cellier',0),(124051,3446,'jp','å€‰åº«ãƒ•ã‚©ãƒ¼ãƒ ',0),(124052,3446,'pt','FormulÃ¡rios de arrecadaÃ§Ã£o',0),(124053,3446,'ru','ÐšÐ»Ð°Ð´Ð¾Ð²Ð°Ñ Ñ„Ð¾Ñ€Ð¼Ñ‹',0),(124054,3446,'es','Formularios de Almacen',0),(124055,3446,'de','Lagerraum-Formulare',0),(124056,3446,'en','Storeroom Forms',0),(124057,3447,'is','',0),(124058,3447,'dr','Ù†Ù…Ø§ÙŠØ´ Ø®ØµÙˆØµÙŠØ§Øª ',0),(124059,3447,'pr','Ù†Ù…Ø§ÙŠØ´ Ø®ØµÙˆØµÙŠØ§Øª ',0),(124060,3447,'tr','Ekran Ã¶zellikleri',0),(124061,3447,'pl','WÅ‚aÅ›ciwoÅ›ci wyÅ›wietlania',0),(124062,3447,'bg','Ð¥Ð°Ñ€Ð°ÐºÑ‚ÐµÑ€Ð¸ÑÑ‚Ð¸ÐºÐ¸',0),(124063,3447,'ur','ÚˆØ³Ù¾Ù„Û’ Ú©ÛŒ Ø®ØµÙˆØµÛŒØ§Øª',0),(124064,3447,'sr','ÐšÐ°Ñ€Ð°ÐºÑ‚ÐµÑ€Ð¸ÑÑ‚Ð¸ÐºÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°',0),(124065,3447,'vi','Hiá»ƒn thá»‹ tÃ­nh cháº¥t',0),(124066,3447,'af','Wys Karaktertrekke',0),(124067,3447,'ro','Caracteristici',0),(124068,3447,'et','Tunnused',0),(124069,3447,'si','Prikazati znaÄilnosti',0),(124070,3447,'ba','Karakteristik tampilan',0),(124071,3447,'nl','Weergavekenmerken',0),(124072,3447,'fi','Ominaisuudet',0),(124073,3447,'no','Vise egenskaper',0),(124074,3447,'da','Vise egenskaber',0),(124075,3447,'ko','ë””ìŠ¤í”Œë ˆì´ íŠ¹ì„±',0),(124076,3447,'he','×ž××¤×™×™× ×™ ×ª×¦×•×’×ª',0),(124077,3447,'el','Î•Î¼Ï†Î±Î½Î¯Î¶ÎµÎ¹ Ï‡Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬',0),(124078,3447,'zh','æ˜¾ç¤ºç‰¹å¾\r\n',0),(124079,3447,'sv','Egenskaper',0),(124080,3447,'it','Caratteristiche di visualizzazione',0),(124081,3447,'tl','',0),(124082,3447,'th','&#3649;&#3626;&#3604;&#3591;&#3621;&#3633;&#3585;&#3625;&#3603;&#3632;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(124083,3447,'hi','à¤²à¤•à¥à¤·à¤£ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(124084,3447,'ms','Memaparkan ciri-ciri',0),(124085,3447,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø®ØµØ§Ø¦Øµ',0),(124086,3447,'fr','CaractÃ©ristiques d\'affichage',0),(124087,3447,'jp','ç‰¹å¾´ã?®è¡¨ç¤º',0),(124088,3447,'pt','CaracterÃ­sticas de exibiÃ§Ã£o',0),(124089,3447,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¥Ð°Ñ€Ð°ÐºÑ‚ÐµÑ€Ð¸ÑÑ‚Ð¸ÐºÐ¸',0),(124090,3447,'es','Desplegar CaracterÃ­sticas',0),(124091,3447,'de','Anzeigeeigenschaften',0),(124092,3447,'en','Display Characteristics',0),(124093,3448,'is','',0),(124094,3448,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª  ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(124095,3448,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª  ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(124096,3448,'tr','Stok Ã¶ÄŸesi faaliyet raporu',0),(124097,3448,'pl','Spis pozycji sprawozdania z dziaÅ‚alnoÅ›ci',0),(124098,3448,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° ÑÐºÐ»Ð°Ð´Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(124099,3448,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒÙˆÚº Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(124100,3448,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(124101,3448,'vi','BÃ¡o cÃ¡o hoáº¡t Ä‘á»™ng hÃ ng hÃ³a',0),(124102,3448,'af','Inventaris Item Aktiwiteit Verslag',0),(124103,3448,'ro','Raport de activitate inventar element',0),(124104,3448,'et','Varude Ã¼ksuse tegevuse aruanne',0),(124105,3448,'si','PoroÄilo o dejavnostih zaloge artikla',0),(124106,3448,'ba','Laporan kegiatan persediaan barang',0),(124107,3448,'nl','Inventaris Item activiteitenverslag',0),(124108,3448,'fi','Varaston nimikkeen toimintakertomus',0),(124109,3448,'no','Lageret varen aktivitetsrapport',0),(124110,3448,'da','Lager vare aktivitetsrapport',0),(124111,3448,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© í™œë™ ë³´ê³ ì„œ',0),(124112,3448,'he','×“×•×— ×¤×¢×™×œ×•×ª ×¤×¨×™×˜×™× ×”×ž×œ××™',0),(124113,3448,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï„Î®Ï„Ï‰Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(124114,3448,'zh','åº“å­˜é¡¹ç›®æ´»åŠ¨æŠ¥å‘Š\r\n',0),(124115,3448,'sv','Inventering objektet verksamhetsrapport',0),(124116,3448,'it','Rapporto attivitÃ  elemento di inventario',0),(124117,3448,'tl','',0),(124118,3448,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3648;&#3588;&#3621;&#3639;&#3656;&#3629;&#3609;&#3652;&#3627;&#3623;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3',0),(124119,3448,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(124120,3448,'ms','Laporan aktiviti Item inventori',0),(124121,3448,'ar','ØªÙ‚Ø±ÙŠØ± Ù†Ø´Ø§Ø· Ø¹Ù†ØµØ± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(124122,3448,'fr','Rapport d\'activitÃ© de l\'inventaire du point',0),(124123,3448,'jp','åœ¨åº«å“?ç›®æ´»å‹•ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(124124,3448,'pt','RelatÃ³rio de atividade de Item de inventÃ¡rio',0),(124125,3448,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾Ð± Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð¿ÑƒÐ½ÐºÑ‚Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(124126,3448,'es','Informe de Actividad de Item de Inventario',0),(124127,3448,'de','Inventar Item TÃ¤tigkeitsbericht',0),(124128,3448,'en','Inventory Item Activity Report',0),(124129,3449,'is','',0),(124130,3449,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø³Øª ',0),(124131,3449,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø³Øª ',0),(124132,3449,'tr','BaÅŸlangÄ±Ã§ tarihi bitiÅŸ tarihinden daha sonra daha sonra',0),(124133,3449,'pl','Data startu jest pÃ³Åºniejsza niÅ¼ daty koÅ„cowej nastÄ™pnie',0),(124134,3449,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð° Ðµ ÑÐ»ÐµÐ´ ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð° ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(124135,3449,'ur','Ú©ÛŒ Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ø¨Ø¹Ø¯ Ù…ÛŒÚº Ù¾Ú¾Ø± ØªØ§Ø±ÛŒØ® Ø®ØªÙ… ÛÙˆÙ†Û’ Ø³Û’ Ø²ÛŒØ§Ø¯Û ÛÛ’',0),(124136,3449,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ ÐºÐ°ÑÐ½Ð¸Ñ˜Ð¸ Ð¾Ð´ Ð¾Ð½Ð´Ð° ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(124137,3449,'vi','NgÃ y báº¯t Ä‘áº§u trá»… hÆ¡n ngÃ y káº¿t thÃºc',0),(124138,3449,'af','Die Starting datum later as eindig dan datum is',0),(124139,3449,'ro','La data de start este mai tÃ¢rziu decÃ¢t apoi data de sfÃ¢rÅŸit',0),(124140,3449,'et','Algus kuupÃ¤ev on hilisem kui siis lÃµppkuupÃ¤ev',0),(124141,3449,'si','ZaÄetni datum je poznejÅ¡i od potem konÄni datum',0),(124142,3449,'ba','Tanggal mulai selambat-lambatnya tanggal berakhirnya kemudian',0),(124143,3449,'nl','De begindatum is later dan vervolgens einddatum',0),(124144,3449,'fi','Alkaen-pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ on myÃ¶hempi kuin viimeinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(124145,3449,'no','Start er senere enn deretter sluttdato',0),(124146,3449,'da','Start dato ligger senere end derefter slutdato',0),(124147,3449,'ko','ì‹œìž‘ ë‚ ì§œë¥¼ ë‹¤ìŒ ì¢…ë£Œ ë‚ ì§œ ë³´ë‹¤ ë‚˜ì¤‘',0),(124148,3449,'he','×”×ª××¨×™×š ×”×”×ª×—×œ×ª×™ ×”×•× ×ž××•×—×¨ ×™×•×ª×¨ ×•××– ×ª××¨×™×š ×¡×’×™×¨×”',0),(124149,3449,'el','Î¤Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎºÎºÎ¯Î½Î·ÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹ Î¼ÎµÏ„Î±Î³ÎµÎ½Î­ÏƒÏ„ÎµÏÎ· Ï„Î·Ï‚ Ï„ÏŒÏ„Îµ Î—Î¼/Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(124150,3449,'zh','èµ·å§‹æ—¥æœŸæ™šäºŽç„¶åŽç»“æŸæ—¥æœŸ\r\n',0),(124151,3449,'sv','Startdatum Ã¤r senare Ã¤n slutdatum dÃ¥',0),(124152,3449,'it','La data di partenza Ã¨ successiva a quella data quindi fine',0),(124153,3449,'tl','',0),(124154,3449,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3594;&#3657;&#3634;&#3585;&#3623;&#3656;&#3634;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(124155,3449,'hi','à¤¶à¥à¤°à¥‚ à¤¤à¤¿à¤¥à¤¿ à¤¤à¤¬ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¸à¥‡ à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚ à¤¹à¥ˆ',0),(124156,3449,'ms','Tarikh Start adalah lewat daripada kemudian berakhir pada tarikh',0),(124157,3449,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡ Ø£Ø­Ø¯Ø« Ù…Ù† ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø«Ù…',0),(124158,3449,'fr','La date de dÃ©but est postÃ©rieure Ã  la date de fin puis',0),(124159,3449,'jp','é–‹å§‹æ—¥ã?Œçµ‚äº†æ—¥ã‚ˆã‚Šå¾Œã?§ã?™ã€‚',0),(124160,3449,'pt','A data de partida Ã© posterior a data de encerramento em seguida',0),(124161,3449,'ru','ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ð°Ñ Ð´Ð°Ñ‚Ð° Ð±Ð¾Ð»ÐµÐµ Ð¿Ð¾Ð·Ð´Ð½ÑÑ, Ñ‡ÐµÐ¼ ÐºÐ¾Ð½ÐµÑ‡Ð½Ð°Ñ Ð´Ð°Ñ‚Ð°',0),(124162,3449,'es','La Fecha de comienza es mÃ¡s adelante que la fecha de TÃ©rminaciÃ³n',0),(124163,3449,'de','Das Startdatum ist spÃ¤testens dann Enddatum',0),(124164,3449,'en','The Starting date is later than then Ending date',0),(124165,3450,'is','',0),(124166,3450,'dr','(Ù…Ø¬Ù‡ÙˆÙ„',0),(124167,3450,'pr','Ù†Ø§Ø´Ù†Ø§Ø³(Ù…Ø¬Ù‡ÙˆÙ„',0),(124168,3450,'tr','Bilinmiyor',0),(124169,3450,'pl','Nieznany',0),(124170,3450,'bg','ÐÐµÐ¸Ð·Ð²ÐµÑÑ‚ÐµÐ½',0),(124171,3450,'ur','Ù†Ø§Ù…Ø¹Ù„ÙˆÙ…',0),(124172,3450,'sr','ÐÐµÐ¿Ð¾Ð·Ð½Ð°Ñ‚Ð¾',0),(124173,3450,'vi','KhÃ´ng biáº¿t',0),(124174,3450,'af','Onbekend',0),(124175,3450,'ro','Necunoscut',0),(124176,3450,'et','Teadmata',0),(124177,3450,'si','Neznano',0),(124178,3450,'ba','Unknown',0),(124179,3450,'nl','Onbekend',0),(124180,3450,'fi','Tuntematon',0),(124181,3450,'no','Ukjent',0),(124182,3450,'da','Ukendt',0),(124183,3450,'ko','ì•Œ ìˆ˜ ì—†ëŠ”',0),(124184,3450,'he','×œ× ×™×“×•×¢',0),(124185,3450,'el','Î†Î³Î½Ï‰ÏƒÏ„Î¿',0),(124186,3450,'zh','æœªçŸ¥\r\n',0),(124187,3450,'sv','OkÃ¤nd',0),(124188,3450,'it','Sconosciuto',0),(124189,3450,'tl','',0),(124190,3450,'th','&#3652;&#3617;&#3656;&#3619;&#3641;&#3657;',0),(124191,3450,'hi','à¤…à¤œà¥à¤žà¤¾à¤¤',0),(124192,3450,'ms','Tidak dikenali',0),(124193,3450,'ar','Ø§Ù„Ù…Ø¬Ù‡ÙˆÙ„',0),(124194,3450,'fr','Inconnu',0),(124195,3450,'jp','ä¸?æ˜Žã?®',0),(124196,3450,'pt','Desconhecido',0),(124197,3450,'ru','ÐÐµÐ¸Ð·Ð²ÐµÑÑ‚Ð½Ð¾',0),(124198,3450,'es','Desconocido',0),(124199,3450,'de','Unbekannt',0),(124200,3450,'en','Unknown',0),(124201,3451,'is','',0),(124202,3451,'dr','Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ø§Ø² ',0),(124203,3451,'pr','Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ø§Ø² ',0),(124204,3451,'tr','DÃ¶nemi iÃ§in',0),(124205,3451,'pl','Za okres od',0),(124206,3451,'bg','Ð—Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð¾Ñ‚',0),(124207,3451,'ur','Ø³Û’ Ø¹Ø±ØµÛ’ Ú©Û’ Ù„Ø¦Û’',0),(124208,3451,'sr','Ð—Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´ Ð¾Ð´',0),(124209,3451,'vi','Cho thá»i ká»³ tá»«',0),(124210,3451,'af','Vir Periode vanaf',0),(124211,3451,'ro','Pentru perioada de la',0),(124212,3451,'et','Perioodiks alates',0),(124213,3451,'si','Za obdobje od',0),(124214,3451,'ba','Untuk periode dari',0),(124215,3451,'nl','Voor de periode van',0),(124216,3451,'fi','VÃ¤liseksi ajaksi',0),(124217,3451,'no','For perioden fra',0),(124218,3451,'da','For perioden',0),(124219,3451,'ko','ê¸°ê°„ì— ëŒ€ í•œ',0),(124220,3451,'he','×œ×ª×§×•×¤×” ×©×œ',0),(124221,3451,'el','Î“Î¹Î± Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿ Î±Ï€ÏŒ',0),(124222,3451,'zh','ä»ŽæœŸçš„\r\n',0),(124223,3451,'sv','FÃ¶r perioden',0),(124224,3451,'it','Per il periodo dal',0),(124225,3451,'tl','',0),(124226,3451,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3592;&#3634;&#3585;',0),(124227,3451,'hi','à¤¸à¥‡ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤',0),(124228,3451,'ms','Bagi tempoh dari',0),(124229,3451,'ar','Ù„Ù„ÙØªØ±Ø© Ù…Ù†',0),(124230,3451,'fr','Pour la pÃ©riode allant du',0),(124231,3451,'jp','ï½žã?®æœŸé–“',0),(124232,3451,'pt','Para o perÃ­odo de',0),(124233,3451,'ru','Ð”Ð»Ñ ÐŸÐµÑ€Ð¸Ð¾Ð´Ð° Ð¾Ñ‚',0),(124234,3451,'es','Para PerÃ­odo De',0),(124235,3451,'de','FÃ¼r den Zeitraum vom',0),(124236,3451,'en','For Period from',0),(124237,3452,'is','',0),(124238,3452,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¶Ù…ÙŠÙ…Ù‡ ',0),(124239,3452,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¶Ù…ÙŠÙ…Ù‡ ',0),(124240,3452,'tr','Ek Ekle',0),(124241,3452,'pl','Dodaj zaÅ‚Ä…cznik',0),(124242,3452,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¸ÐºÐ°Ñ‡ÐµÐ½ Ñ„Ð°Ð¹Ð»',0),(124243,3452,'ur','Ù…Ù†Ø³Ù„Ú©Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(124244,3452,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¸Ð»Ð¾Ð³Ð°',0),(124245,3452,'vi','ThÃªm TÃ i Liá»‡u ÄÃ­nh KÃ¨m',0),(124246,3452,'af','Aanhangsel (\"Attachment\")Byvoeg',0),(124247,3452,'ro','Adauga atasament',0),(124248,3452,'et','Lisa manus',0),(124249,3452,'si','Dodajte prilogo',0),(124250,3452,'ba','Menambahkan lampiran',0),(124251,3452,'nl','Bijlage toevoegen',0),(124252,3452,'fi','LisÃ¤Ã¤ liite',0),(124253,3452,'no','Legg til vedlegg',0),(124254,3452,'da','TilfÃ¸j vedhÃ¦ftet fil',0),(124255,3452,'ko','ì²¨ë¶€ íŒŒì¼ ì¶”ê°€',0),(124256,3452,'he','×”×•×¡×£ ×§×•×‘×¥ ×ž×¦×•×¨×£',0),(124257,3452,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ…Î½Î·Î¼Î¼Î­Î½Î¿Ï…',0),(124258,3452,'zh','å¢žåŠ é™„ä»¶\r\n',0),(124259,3452,'sv','Bifoga fil',0),(124260,3452,'it','Aggiungi allegato',0),(124261,3452,'tl','',0),(124262,3452,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3636;&#3656;&#3591;&#3607;&#3637;&#3656;&#3649;&#3609;&#3610;&#3605;&#3636;&#3604;',0),(124263,3452,'hi','à¤…à¤¨à¥à¤²à¤—à¥à¤¨à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(124264,3452,'ms','Menambah lampiran',0),(124265,3452,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø±ÙÙ‚',0),(124266,3452,'fr','Ajouter une piÃ¨ce jointe \r\n',0),(124267,3452,'jp','æ·»ä»˜ã‚’è¿½åŠ ',0),(124268,3452,'pt','Adicionar anexo',0),(124269,3452,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð²Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(124270,3452,'es','Agregar Adjunto',0),(124271,3452,'de','Anhang hinzufÃ¼gen',0),(124272,3452,'en','Add Attachment',0),(124273,3453,'is','',0),(124274,3453,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¢Ø¯Ø±Ø³ Ø¨Ù‡ Ù„ÙŠØ³Øª ',0),(124275,3453,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¢Ø¯Ø±Ø³ Ø¨Ù‡ Ù„ÙŠØ³Øª ',0),(124276,3453,'tr','Adres listesine ekle',0),(124277,3453,'pl','Dodaj adres do listy',0),(124278,3453,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð°Ð´Ñ€ÐµÑÐ¸ ÐºÑŠÐ¼ ÑÐ¿Ð¸ÑÑŠÐºÐ°',0),(124279,3453,'ur','Ù¾ØªÛ’ Ú©ÛŒ ÙÛØ±Ø³Øª Ù…ÛŒÚº Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(124280,3453,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð°Ð´Ñ€ÐµÑÐµ Ñƒ Ð»Ð¸ÑÑ‚Ð¸',0),(124281,3453,'vi','ThÃªm Äá»‹a Chá»‰ cho Danh SÃ¡ch',0),(124282,3453,'af','Voeg Adresse tot Lys',0),(124283,3453,'ro','AdÄƒugarea de adrese la lista',0),(124284,3453,'et','Aadressi lisamiseks loendisse',0),(124285,3453,'si','Dodajanje naslovov na seznam',0),(124286,3453,'ba','Menambahkan alamat ke daftar',0),(124287,3453,'nl','Adressen toevoegen aan lijst',0),(124288,3453,'fi','LisÃ¤Ã¤ osoitteet luetteloon',0),(124289,3453,'no','Legge til adresser i listen',0),(124290,3453,'da','TilfÃ¸je adresser til listen',0),(124291,3453,'ko','ì£¼ì†Œ ëª©ë¡ì— ì¶”ê°€',0),(124292,3453,'he','×”×•×¡×¤×ª ×›×ª×•×‘×•×ª ×œ×¨×©×™×ž×ª',0),(124293,3453,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¹Ï‚ Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚ ÏƒÏ„Î· Î»Î¯ÏƒÏ„Î±',0),(124294,3453,'zh','å¢žåŠ åœ°å€åˆ°åˆ—è¡¨\r\n',0),(124295,3453,'sv','LÃ¤gga till adresser i listan',0),(124296,3453,'it','Aggiungi indirizzi alla lista',0),(124297,3453,'tl','',0),(124298,3453,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(124299,3453,'hi','à¤ªà¤¤à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(124300,3453,'ms','Tambah alamat ke senarai',0),(124301,3453,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¹Ù†Ø§ÙˆÙŠÙ† Ø¥Ù„Ù‰ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(124302,3453,'fr','Ajouter Ã  la liste des adresses',0),(124303,3453,'jp','ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’ãƒªã‚¹ãƒˆã?«è¿½åŠ ',0),(124304,3453,'pt','Adicionar endereÃ§os Ã  lista',0),(124305,3453,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ´Ñ€ÐµÑÐ° Ð’ Ð¡Ð¿Ð¸ÑÐ¾Ðº',0),(124306,3453,'es','Agregar Direcciones a la Lista',0),(124307,3453,'de','Adressen zur Liste hinzufÃ¼gen',0),(124308,3453,'en','Add Addresses to List',0),(124309,3454,'is','',0),(124310,3454,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø¬Ø³ØªØ¬Ùˆ Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯ Ùˆ   Ø¨Ø±Ú¯Ø±Ø¯ÙŠØ¯ØŸ',0),(124311,3454,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø¬Ø³ØªØ¬Ùˆ Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯ Ùˆ   Ø¨Ø±Ú¯Ø±Ø¯ÙŠØ¯ØŸ',0),(124312,3454,'tr','Bu aramayÄ± iptal et ve geri gitmek istediÄŸinizden emin misiniz?',0),(124313,3454,'pl','Czy na pewno chcesz anulowaÄ‡ to wyszukiwanie i wrÃ³ciÄ‡?',0),(124314,3454,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ñ‚Ð¾Ð²Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð¸ Ð´Ð° ÑÐµ Ð²ÑŠÑ€Ð½ÐµÑ‚Ðµ?',0),(124315,3454,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ø³ ØªÙ„Ø§Ø´ Ú©Ùˆ Ù…Ù†Ø³ÙˆØ® Ú©Ø±Ú©Û’ ÙˆØ§Ù¾Ø³ Ø¬Ø§Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(124316,3454,'sr','Ð”Ð° Ð»Ð¸ ÑÑ‚Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ð¾Ð²Ñƒ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ Ð¸ Ð´Ð° ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¼?',0),(124317,3454,'vi','Há»§y bá» tÃ¬m kiáº¿m & quay láº¡i?',0),(124318,3454,'af','Is jy seker jy wil kanselleer hierdie soektog en gaan terug?',0),(124319,3454,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ anulaÅ£i aceastÄƒ cÄƒutare ÅŸi du-te Ã®napoi?',0),(124320,3454,'et','Kas kindlasti tÃ¼histada selle otsingu ja tagasi minna?',0),(124321,3454,'si','Ali ste prepriÄani, da Å¾elite preklicati to iskanje in Å¡el nazaj?',0),(124322,3454,'ba','Apakah Anda yakin mau membatalkan pencarian ini dan kembali?',0),(124323,3454,'nl','Weet u zeker dat u wilt deze zoekopdracht annuleren en teruggaan?',0),(124324,3454,'fi','Haluatko varmasti peruuttaa tÃ¤mÃ¤n haun ja palata?',0),(124325,3454,'no','Er du sikker pÃ¥ at du vil avbryte sÃ¸ket og gÃ¥ tilbake?',0),(124326,3454,'da','Er du sikker pÃ¥ du vil annullere denne sÃ¸gning og gÃ¥ tilbage?',0),(124327,3454,'ko','ë‹¹ì‹ ì€ì´ ê²€ìƒ‰ì„ ì·¨ì†Œ í•˜ ê³  ë‹¤ì‹œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(124328,3454,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×‘×˜×œ ××ª ×”×—×™×¤×•×© ×”×–×” ×•×œ×—×–×•×¨?',0),(124329,3454,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î±ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎºÎ±Î¹ Î½Î± Ï€Î¬ÎµÎ¹ Ï€Î¯ÏƒÏ‰;',0),(124330,3454,'zh','æ‚¨ç¡®å®šè¦å–æ¶ˆæ­¤æœç´¢å¹¶åŽé€€å—ï¼Ÿ\r\n',0),(124331,3454,'sv','Ã„r du sÃ¤ker pÃ¥ att du vill avbryta sÃ¶kningen och gÃ¥ tillbaka?',0),(124332,3454,'it','Sei sicuro di che voler cancellare questa ricerca e tornare indietro?',0),(124333,3454,'tl','',0),(124334,3454,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3588;&#3657;&#3',0),(124335,3454,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤¹à¥ˆà¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ à¤–à¥‹à¤œ à¤•à¥‹ à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤µà¤¾à¤ªà¤¸ à¤œà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(124336,3454,'ms','Adakah anda pasti anda mahu membatalkan carian ini dan kembali?',0),(124337,3454,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¥Ù„ØºØ§Ø¡ Ù‡Ø°Ø§ Ø§Ù„Ø¨Ø­Ø« ÙˆØ§Ù„Ø¹ÙˆØ¯Ø©ØŸ',0),(124338,3454,'fr','ÃŠtes-vous certain de que vouloir annuler cette recherche et revenir en arriÃ¨re ?',0),(124339,3454,'jp','ã?“ã?®æ¤œç´¢ã‚’ä¸­æ­¢ã?—ã?¦æˆ»ã?£ã?¦ã‚ˆã‚?ã?—ã?„ã?§ã?™ã?‹ï¼Ÿ',0),(124340,3454,'pt','Tem certeza que deseja cancelar esta pesquisa e voltar?',0),(124341,3454,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹ Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ð¸ÑÐº Ð¸ Ð²ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ð½Ð°Ð·Ð°Ð´?',0),(124342,3454,'es','Â¿Esta seguro que quiere cancelar este bÃºsqueda y regresar?',0),(124343,3454,'de','Bist du sicher, dass Sie diese Suche abbrechen und zurÃ¼ck gehen?',0),(124344,3454,'en','Are you sure you want to cancel this search and go back?',0),(124345,3455,'is','',0),(124346,3455,'dr','Ù¾ÙŠÙˆØ³Øª Ù‡Ø§',0),(124347,3455,'pr','Ù¾ÙŠÙˆØ³Øª Ù‡Ø§',0),(124348,3455,'tr','Ekleri',0),(124349,3455,'pl','ZaÅ‚Ä…czniki',0),(124350,3455,'bg','ÐŸÑ€Ð¸ÐºÐ°Ñ‡ÐµÐ½Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(124351,3455,'ur','Ù…Ù†Ø³Ù„Ú©Ø§Øª',0),(124352,3455,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð·Ð¸',0),(124353,3455,'vi','TÃ i Liá»‡u KÃ¨m Theo ',0),(124354,3455,'af','Aanhangsels (\"Attachments\")',0),(124355,3455,'ro','AtaÈ™Äƒri',0),(124356,3455,'et','Manused',0),(124357,3455,'si','PrikljuÄki',0),(124358,3455,'ba','Lampiran',0),(124359,3455,'nl','Bijlagen',0),(124360,3455,'fi','Liitteet',0),(124361,3455,'no','Vedlegg',0),(124362,3455,'da','VedhÃ¦ftede filer',0),(124363,3455,'ko','ì²¨ë¶€ íŒŒì¼',0),(124364,3455,'he','×§×‘×¦×™× ×ž×¦×•×¨×¤×™×',0),(124365,3455,'el','Î£Ï…Î½Î·Î¼Î¼Î­Î½Î±',0),(124366,3455,'zh','é™„ä»¶\r\n',0),(124367,3455,'sv','Bilagor',0),(124368,3455,'it','Allegati',0),(124369,3455,'tl','',0),(124370,3455,'th','&#3585;&#3634;&#3619;&#3649;&#3609;&#3610;',0),(124371,3455,'hi','à¤¸à¤‚à¤²à¤—à¥à¤¨à¤•',0),(124372,3455,'ms','Lampiran',0),(124373,3455,'ar','Ø§Ù„Ù…Ø±ÙÙ‚Ø§Øª',0),(124374,3455,'fr','PiÃ¨ce dÃ©tachÃ©e',0),(124375,3455,'jp','æ·»ä»˜',0),(124376,3455,'pt','Anexos',0),(124377,3455,'ru','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(124378,3455,'es','Anexos',0),(124379,3455,'de','Anlagen',0),(124380,3455,'en','Attachments',0),(124381,3456,'is','',0),(124382,3456,'dr','BCC',0),(124383,3456,'pr','BCC',0),(124384,3456,'tr','GÄ°ZLÄ° BÄ°LGÄ°',0),(124385,3456,'pl','BCC',0),(124386,3456,'bg','\"Ð¡Ðš\"',0),(124387,3456,'ur','Ø¨ÛŒ Ø³ÛŒ Ø³ÛŒ',0),(124388,3456,'sr','Ð‘Ð¦Ð¦',0),(124389,3456,'vi','BCC',0),(124390,3456,'af','b.a.a.',0),(124391,3456,'ro','BCC',0),(124392,3456,'et','SALAKOOPIA',0),(124393,3456,'si','SKP',0),(124394,3456,'ba','BCC',0),(124395,3456,'nl','BCC',0),(124396,3456,'fi','PIILOKOPIO',0),(124397,3456,'no','BLINDKOPI',0),(124398,3456,'da','BCC',0),(124399,3456,'ko','ìˆ¨ì€ ì°¸ì¡°',0),(124400,3456,'he','×¢×•×ª×§ ×ž×•×¡×ª×¨',0),(124401,3456,'el','\"Î™Î”Î™Î‘ÎŠÎ¤.\"',0),(124402,3456,'zh','å¯†é€\r\n',0),(124403,3456,'sv','HEMLIG KOPIA',0),(124404,3456,'it','BCC',0),(124405,3456,'tl','',0),(124406,3456,'th','&#3626;&#3635;&#3648;&#3609;&#3634;&#3621;&#3633;&#3610;',0),(124407,3456,'hi','à¤—à¥à¤ªà¥à¤¤ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿',0),(124408,3456,'ms','SKT',0),(124409,3456,'ar','Ù†Ø³Ø®Ø© Ù…Ø®ÙÙŠØ©',0),(124410,3456,'fr','BCC',0),(124411,3456,'jp','BCC',0),(124412,3456,'pt','BCC',0),(124413,3456,'ru','Ð¡Ðš',0),(124414,3456,'es','BCC',0),(124415,3456,'de','BCC',0),(124416,3456,'en','BCC',0),(124417,3457,'is','',0),(124418,3457,'dr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(124419,3457,'pr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(124420,3457,'tr','CC',0),(124421,3457,'pl','CC',0),(124422,3457,'bg','CC',0),(124423,3457,'ur','Ù†Ù‚Ù„ Ø¨Ø±Ø§Û“',0),(124424,3457,'sr','Ð¦Ð¦',0),(124425,3457,'vi','Äá»“ng gá»­i ',0),(124426,3457,'af','a.a.',0),(124427,3457,'ro','CC',0),(124428,3457,'et','CC',0),(124429,3457,'si','CC',0),(124430,3457,'ba','CC',0),(124431,3457,'nl','CC',0),(124432,3457,'fi','CC',0),(124433,3457,'no','CC',0),(124434,3457,'da','CC',0),(124435,3457,'ko','CC',0),(124436,3457,'he','CC',0),(124437,3457,'el','CC',0),(124438,3457,'zh','ä¿¡ç”¨å¡\r\n',0),(124439,3457,'sv','CC',0),(124440,3457,'it','CC',0),(124441,3457,'tl','',0),(124442,3457,'th','&#3626;&#3635;&#3648;&#3609;&#3634;',0),(124443,3457,'hi','à¤¸à¥€à¤¸à¥€',0),(124444,3457,'ms','CC',0),(124445,3457,'ar','CC',0),(124446,3457,'fr','CC',0),(124447,3457,'jp','CC',0),(124448,3457,'pt','CC',0),(124449,3457,'ru','CC',0),(124450,3457,'es','TC',0),(124451,3457,'de','CC',0),(124452,3457,'en','CC',0),(124453,3458,'is','',0),(124454,3458,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(124455,3458,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(124456,3458,'tr','MÃ¼ÅŸteriler',0),(124457,3458,'pl','Klienci',0),(124458,3458,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(124459,3458,'ur','Ú¯Ø§ÛÚ©',0),(124460,3458,'sr','ÐšÑƒÐ¿Ñ†Ð¸',0),(124461,3458,'vi','KhÃ¡ch hÃ ng',0),(124462,3458,'af','Klante/KliÃ«nte',0),(124463,3458,'ro','Clienti',0),(124464,3458,'et','Kliendid',0),(124465,3458,'si','Stranke',0),(124466,3458,'ba','Pelanggan',0),(124467,3458,'nl','Klanten',0),(124468,3458,'fi','Asiakkaat',0),(124469,3458,'no','Kundene',0),(124470,3458,'da','Kunder',0),(124471,3458,'ko','ê³ ê°',0),(124472,3458,'he','×œ×§×•×—×•×ª',0),(124473,3458,'el','Î¤Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(124474,3458,'zh','å®¢æˆ·\r\n',0),(124475,3458,'sv','Kunder',0),(124476,3458,'it','Clienti',0),(124477,3458,'tl','',0),(124478,3458,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(124479,3458,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(124480,3458,'ms','Pelanggan',0),(124481,3458,'ar','Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(124482,3458,'fr','Clients',0),(124483,3458,'jp','é¡§å®¢',0),(124484,3458,'pt','Clientes',0),(124485,3458,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹',0),(124486,3458,'es','Clientes',0),(124487,3458,'de','Kunden',0),(124488,3458,'en','Customers',0),(124489,3459,'is','',0),(124490,3459,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ø¬Ø§Ø±ÙŠ',0),(124491,3459,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ø¬Ø§Ø±ÙŠ',0),(124492,3459,'tr','GeÃ§erli e-posta adresi seÃ§imleri',0),(124493,3459,'pl','BieÅ¼Ä…cy wybÃ³r adresu E-mail',0),(124494,3459,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸Ñ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ ÑÐµÐ»ÐµÐºÑ†Ð¸Ð¸',0),(124495,3459,'ur','Ø­Ø§Ù„ÛŒÛ Ø§ÛŒ Ù…ÛŒÙ„ Ù¾ØªØ§ Ø§Ù†ØªØ®Ø§Ø¨',0),(124496,3459,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ðµ Ð¾Ð´Ð°Ð±Ð¸Ñ€Ðµ Ð°Ð´Ñ€ÐµÑÑƒ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(124497,3459,'vi','Chá»n Ä‘á»‹a chá»‰ Email hiá»‡n thá»i ',0),(124498,3459,'af','Huidige E-pos Adres Seleksies',0),(124499,3459,'ro','Curent E-mail adresa selecÅ£ii',0),(124500,3459,'et','Praegune e-posti aadressi valik',0),(124501,3459,'si','Trenutni e-poÅ¡tni naslov izborov',0),(124502,3459,'ba','Saat pilihan Alamat Email',0),(124503,3459,'nl','Huidige E-mail adres selecties',0),(124504,3459,'fi','Nykyiset sÃ¤hkÃ¶posti osoite valinnat',0),(124505,3459,'no','Gjeldende e-postadresse valg',0),(124506,3459,'da','Aktuelle Email adresse valg',0),(124507,3459,'ko','í˜„ìž¬ ì´ë©”ì¼ ì£¼ì†Œ ì„ íƒ',0),(124508,3459,'he','×”×‘×—×™×¨×•×ª ×”× ×•×›×—×™×•×ª ×©×œ ×›×ª×•×‘×ª ×“×•×',0),(124509,3459,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎµÏ‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(124510,3459,'zh','å½“å‰çš„ç”µå­é‚®ä»¶åœ°å€é€‰æ‹©\r\n',0),(124511,3459,'sv','Nuvarande e-postadress val',0),(124512,3459,'it','Selezioni di indirizzo Email attuale',0),(124513,3459,'tl','',0),(124514,3459,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(124515,3459,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¥‡ à¤šà¤¯à¤¨à¥‹à¤‚',0),(124516,3459,'ms','Pilihan alamat e-mel semasa',0),(124517,3459,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ¯Ø§Øª Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(124518,3459,'fr','SÃ©lection d\'adresse Email actuelle',0),(124519,3459,'jp','ç?¾åœ¨ã?®ï¼¥ãƒ¡ãƒ¼ãƒ«ã‚¢ãƒ‰ãƒ¬ã‚¹é?¸æŠž',0),(124520,3459,'pt','SeleÃ§Ãµes de endereÃ§o de Email atual',0),(124521,3459,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð²Ñ‹Ð±Ð¾Ñ€ Ð°Ð´Ñ€ÐµÑÐ° ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(124522,3459,'es','Selecciones de Direcciones de Email Actuales',0),(124523,3459,'de','Aktuelle E-Mail-Adresse-Kennzeichnungen',0),(124524,3459,'en','Current Email Address Selections',0),(124525,3460,'is','',0),(124526,3460,'dr','ØªØ­ÙˆÙŠÙ„ Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(124527,3460,'pr','ØªØ­ÙˆÙŠÙ„ Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(124528,3460,'tr','VarsayÄ±lan teslim',0),(124529,3460,'pl','DomyÅ›lnie dostawy',0),(124530,3460,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(124531,3460,'ur','Ø·Û’ Ø´Ø¯Û ÚˆÙ„ÛŒÙˆØ±ÛŒ',0),(124532,3460,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ð°',0),(124533,3460,'vi','Giao nháº­n Máº·c Ä‘á»‹nh',0),(124534,3460,'af','Verstek aflewering',0),(124535,3460,'ro','ImplicitÄƒ de livrare',0),(124536,3460,'et','Vaikimisi tarne',0),(124537,3460,'si','Privzeto dostave',0),(124538,3460,'ba','Standar pengiriman',0),(124539,3460,'nl','Standaard levering',0),(124540,3460,'fi','Oletuksena toimitus',0),(124541,3460,'no','Standard levering',0),(124542,3460,'da','Standardadressen for levering',0),(124543,3460,'ko','ê¸°ë³¸ ë°°ë‹¬',0),(124544,3460,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×”×ž×¡×™×¨×”',0),(124545,3460,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÏƒÎ·Î¼ÎµÎ¯Î¿ Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(124546,3460,'zh','é»˜è®¤ä¼ é€’\r\n',0),(124547,3460,'sv','Standardleveransplatsen',0),(124548,3460,'it','Recapito predefinita',0),(124549,3460,'tl','',0),(124550,3460,'th','&#3626;&#3656;&#3591;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(124551,3460,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¡à¤¿à¤²à¥€à¤µà¤°à¥€',0),(124552,3460,'ms','Penghantaran lalai',0),(124553,3460,'ar','Ø§Ù„Ù…Ø³ØªÙ„Ù…ÙˆÙ† Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠÙˆÙ†',0),(124554,3460,'fr','Livraison par dÃ©faut',0),(124555,3460,'jp','æ—¢å®šé…?é?”',0),(124556,3460,'pt','PadrÃ£o de entrega',0),(124557,3460,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(124558,3460,'es','Entrega por Defecto',0),(124559,3460,'de','Standard-Lieferung',0),(124560,3460,'en','Default Delivery',0),(124561,3461,'is','',0),(124562,3461,'dr','Ù…Ø±ÙƒØ² Ø§ÙŠÙ…ÙŠÙ„ ',0),(124563,3461,'pr','Ù…Ø±ÙƒØ² Ø§ÙŠÙ…ÙŠÙ„ ',0),(124564,3461,'tr','E-posta Merkezi',0),(124565,3461,'pl','E centrum',0),(124566,3461,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ñ†ÐµÐ½Ñ‚ÑŠÑ€',0),(124567,3461,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ù…Ø±Ú©Ø²',0),(124568,3461,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ð·Ð° Ðµ-Ð¿Ð¾ÑˆÑ‚Ñƒ',0),(124569,3461,'vi','Trung TÃ¢m Email',0),(124570,3461,'af','E-pos Sentrum',0),(124571,3461,'ro','Centru de email',0),(124572,3461,'et','E-maili keskus',0),(124573,3461,'si','E-poÅ¡tni Center',0),(124574,3461,'ba','Pusat email',0),(124575,3461,'nl','E-mail Center',0),(124576,3461,'fi','SÃ¤hkÃ¶posti Center',0),(124577,3461,'no','E-Center',0),(124578,3461,'da','E-mail Center',0),(124579,3461,'ko','ì´ë©”ì¼ ì„¼í„°',0),(124580,3461,'he','×ž×¨×›×– ×“×•×\"×œ',0),(124581,3461,'el','ÎšÎ­Î½Ï„ÏÎ¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(124582,3461,'zh','ç”µå­é‚®ä»¶ä¸­å¿ƒ\r\n',0),(124583,3461,'sv','E-Center',0),(124584,3461,'it','E-mail Center',0),(124585,3461,'tl','',0),(124586,3461,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3648;&#3595;&#3655;&#3609;&#3648;&#3605;&#3629;&#3619;&#3660;',0),(124587,3461,'hi','à¤ˆà¤®à¥‡à¤² à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(124588,3461,'ms','Pusat e-mel',0),(124589,3461,'ar','Ù…Ø±ÙƒØ² Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(124590,3461,'fr','Email Center',0),(124591,3461,'jp','E-ãƒ¡ãƒ¼ãƒ«ã‚»ãƒ³ã‚¿ãƒ¼',0),(124592,3461,'pt','Centro de e-mail',0),(124593,3461,'ru','Email Ð¦ÐµÐ½Ñ‚Ñ€',0),(124594,3461,'es','Centro de Email',0),(124595,3461,'de','Email-Center',0),(124596,3461,'en','Email Center',0),(124597,3462,'is','',0),(124598,3462,'dr','Ø´Ø±Ø­ Ù…Ø±ÙƒØ² Ø§ÙŠÙ…ÙŠÙ„ â€“ Ø§ÙŠÙ…ÙŠÙ„ Ù‡Ø§ Ø±Ø§ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù†  ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø³ÙŠØ³ØªÙ…  ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨ÙØ±Ø³ØªÙŠØ¯ ',0),(124599,3462,'pr','Ø´Ø±Ø­ Ù…Ø±ÙƒØ² Ø§ÙŠÙ…ÙŠÙ„ â€“ Ø§ÙŠÙ…ÙŠÙ„ Ù‡Ø§ Ø±Ø§ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù†  ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø³ÙŠØ³ØªÙ…  ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨ÙØ±Ø³ØªÙŠØ¯ ',0),(124600,3462,'tr','MÃ¼ÅŸteriler, Ã§alÄ±ÅŸanlar, sistem kullanÄ±cÄ±larÄ±, satÄ±cÄ± ve satÄ±cÄ±lar iÃ§in e-postalar gÃ¶ndermek',0),(124601,3462,'pl','WysyÅ‚anie e-maili do klientÃ³w, pracownikÃ³w, uÅ¼ytkownikÃ³w systemu, sprzedawcÃ³w i dostawcÃ³w',0),(124602,3462,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð»Ð¸ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸, ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸, Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸ Ð½Ð° ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°, Ñ‚ÑŠÑ€Ð³Ð¾Ð²Ñ†Ð¸ Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(124603,3462,'ur','ØµØ§Ø±ÙÛŒÙ†ØŒ Ù…Ù„Ø§Ø²Ù…ÛŒÙ†ØŒ Ù†Ø¸Ø§Ù… Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù†ØŒ Ø³ÛŒÙ„Ø² Ø§ÙˆØ± Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©Ùˆ Ø§ÛŒ Ù…ÛŒÙ„Ø² Ø¨Ú¾ÛŒØ¬Ù†Û’',0),(124604,3462,'sr','Ð¡Ð»Ð°ÑšÐµ Ðµ-Ð¼Ð°Ð¸Ð»Ð¾Ð²Ðµ ÐºÑƒÐ¿Ñ†Ð¸Ð¼Ð°, Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ð¼Ð°, ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° ÑÐ¸ÑÑ‚ÐµÐ¼Ð°, Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð¸ Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(124605,3462,'vi','Gá»­i Email tá»›i KhÃ¡ch HÃ ng, NhÃ¢n ViÃªn, NgÆ°á»i Sá»­ Dá»¥ng Há»‡ Thá»‘ng, NhÃ¢n ViÃªn Kinh Doanh & NgÆ°á»i BÃ¡n',0),(124606,3462,'af','Stuur E-pos aan KliÃ«nte/Klante, Werknemers, Sisteem Gebruikers, Verkoopspersone en Verskaffers',0),(124607,3462,'ro','Trimite Email catre Clienti, Angajati, Utilizatori de Sistem, Agenti de Vanzari si Furnizori ',0),(124608,3462,'et','Saada e-kirju klientidele, tÃ¶Ã¶tajatele, sÃ¼seemi kasutajatele, mÃ¼Ã¼gimeestele ja hankijatele.',0),(124609,3462,'si','PoÅ¡iljanje e-poÅ¡te za stranke, zaposlenih, uporabnikov sistema, prodajalci in dobavitelji',0),(124610,3462,'ba','Mengirim email ke pelanggan, karyawan, pengguna sistem, salesman dan vendor',0),(124611,3462,'nl','E-mails versturen naar klanten, werknemers, systeemgebruikers, verkopers en leveranciers',0),(124612,3462,'fi','LÃ¤hettÃ¤Ã¤ sÃ¤hkÃ¶posteja asiakkaille, tyÃ¶ntekijÃ¶ille, verkonkÃ¤yttÃ¤jille, myyntimiehet ja toimittajat',0),(124613,3462,'no','Send e-post til kunder, ansatte, brukere, selgere og leverandÃ¸rer',0),(124614,3462,'da','Send E-mails til kunder, medarbejdere, brugere, sÃ¦lgere og leverandÃ¸rer',0),(124615,3462,'ko','ê³ ê°, ì§ì›, ì‹œìŠ¤í…œ ì‚¬ìš©ìž, ì ì› ë° ê³µê¸‰ ì´ë©”ì¼ ë³´ë‚´ê¸°',0),(124616,3462,'he','×œ×©×œ×•×— ×ž×™×™×œ×™× ×œ×§×•×—×•×ª, ×¢×•×‘×“×™×, ×ž×¢×¨×›×ª ×ž×©×ª×ž×©×™×, ×× ×©×™ ×ž×›×™×¨×•×ª ×•×¡×¤×§×™×',0),(124617,3462,'el','Î£Ï„ÎµÎ¯Î»ÎµÏ„Îµ Î¼Î·Î½ÏÎ¼Î±Ï„Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… ÏƒÎµ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚, Ï…Ï€Î±Î»Î»Î®Î»Î¿Ï…Ï‚, Î¿Î¹ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚, Ï€Ï‰Î»Î·Ï„Î­Ï‚ ÎºÎ±Î¹ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚',0),(124618,3462,'zh','å‘é€é‚®ä»¶ç»™å®¢æˆ·ï¼Œå‘˜å·¥ï¼Œç³»ç»Ÿç”¨æˆ·ï¼Œé”€å”®äººå‘˜å’Œä¾›åº”å•†\r\n',0),(124619,3462,'sv','Skicka e-postmeddelanden till kunder, medarbetare, systemanvÃ¤ndare, fÃ¶rsÃ¤ljare och leverantÃ¶rer',0),(124620,3462,'it','Inviare E-mail a clienti, dipendenti, utenti del sistema, venditori e fornitori',0),(124621,3462,'tl','',0),(124622,3462,'th','&#3626;&#3656;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3606;&#3638;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;,&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;,&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3619;&#3632;&#3610;&#3610;,&#3648;',0),(124623,3462,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚, à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚, à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚, à¤¸à¥‡à¤²à¥à¤¸à¤®à¥ˆà¤¨ à¤”à¤° à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤ˆà¤®à¥‡à¤² à¤­à¥‡à¤œà¥‡à¤‚',0),(124624,3462,'ms','Menghantar emel kepada pelanggan, pekerja, pengguna sistem, Salesmen dan vendor',0),(124625,3462,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡ ÙˆØ§Ù„Ù…ÙˆØ¸ÙÙŠÙ†ØŒ ÙˆÙ†Ø¸Ø§Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†ØŒ ÙˆØ§Ù„Ø¨Ø§Ø¹Ø© ÙˆØ§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ†',0),(124626,3462,'fr','Envoyer des Emails aux utilisateurs du systÃ¨me, des employÃ©s, des vendeurs, des clients et des fournisseurs',0),(124627,3462,'jp','é¡§å®¢ã€?å¾“æ¥­å“¡ã€?ã‚·ã‚¹ãƒ†ãƒ ãƒ¦ãƒ¼ã‚¶ãƒ¼ã€?ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…ã€?æ¥­è€…ã?«ï¼¥ãƒ¡ãƒ¼ãƒ«ã‚’é€?ä¿¡ã?™ã‚‹',0),(124628,3462,'pt','Enviar E-mails para os clientes, funcionÃ¡rios, usuÃ¡rios do sistema, vendedores e fornecedores',0),(124629,3462,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¸ÑÑŒÐ¼Ð° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð², ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð², Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹, Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð¾Ð² Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(124630,3462,'es','Enviar Emails a Clientes, Empleados, Usuarios del Sistema, Vendedores y Proveedores',0),(124631,3462,'de','Senden Sie E-Mails an Kunden, Mitarbeiter, Systembenutzer, VerkÃ¤ufer und Anbieter',0),(124632,3462,'en','Send Emails to Customers, Employees, System Users, Salesmen and Vendors',0),(124633,3463,'is','',0),(124634,3463,'dr','Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙØ±Ø³ØªØ§Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ Ø®Ø·Ø§ÙŠÙŠ Ø±ÙˆÙŠ Ø¯Ø§Ø¯',0),(124635,3463,'pr','Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙØ±Ø³ØªØ§Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ Ø®Ø·Ø§ÙŠÙŠ Ø±ÙˆÙŠ Ø¯Ø§Ø¯',0),(124636,3463,'tr','E-posta gÃ¶nderirken bir hata oluÅŸtu.',0),(124637,3463,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas wysyÅ‚ania wiadomoÅ›ci e-mail.',0),(124638,3463,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð° Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð».',0),(124639,3463,'ur','ÛŒÛ Ø§ÛŒ Ù…ÛŒÙ„ Ø¨Ú¾ÛŒØ¬Ù†Û’ Ù…ÛŒÚº Ø§ÛŒÚ© Ù†Ù‚Øµ ØªÚ¾Ø§ Û”',0),(124640,3463,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð³Ñ€ÐµÑˆÐºÐµ, ÑÐ»Ð°ÑšÐµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ð¾Ð¼.',0),(124641,3463,'vi','Gá»­i Email bá»‹ lá»—i',0),(124642,3463,'af','Daar was \'n fout met die stuur van die e-pos.',0),(124643,3463,'ro','Eroare la trimiterea de e-mail.',0),(124644,3463,'et','E-kirja saatmisel ilmnes viga',0),(124645,3463,'si','Napaka pri poÅ¡iljanju e-poÅ¡te.',0),(124646,3463,'ba','Ada error mengirim email.',0),(124647,3463,'nl','Er was een fout bij het verzenden van de e-mail.',0),(124648,3463,'fi','Virhe lÃ¤hetettÃ¤essÃ¤ sÃ¤hkÃ¶postia.',0),(124649,3463,'no','En feil oppstod under sending av e-post.',0),(124650,3463,'da','Der opstod en fejl under afsendelse af email.',0),(124651,3463,'ko','ì´ë©”ì¼ ì „ì†¡ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(124652,3463,'he','××™×¨×¢×” ×©×’×™××” ×‘×©×œ×™×—×ª ×”××™×ž×™×™×œ.',0),(124653,3463,'el','Î¥Ï€Î®ÏÎ¾Îµ Î­Î½Î± ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Ï„Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿.',0),(124654,3463,'zh','æœ‰ä¸€ä¸ªå‘é€ç”µå­é‚®ä»¶çš„é”™è¯¯\r\n',0),(124655,3463,'sv','Det gick inte att skicka e-post.',0),(124656,3463,'it','C\'Ã¨ stato un errore durante l\'invio di email.',0),(124657,3463,'tl','',0),(124658,3463,'th','&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3617;&#3637;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(124659,3463,'hi','à¤ˆà¤®à¥‡à¤² à¤­à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¥à¥€à¥¤',0),(124660,3463,'ms','Adalah Ralat menghantar e-mel.',0),(124661,3463,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ.',0),(124662,3463,'fr','Il y avait une erreur d\'envoi de l\'e-mail.',0),(124663,3463,'jp','ï¼¥ãƒ¡ãƒ¼ãƒ«é€?ä¿¡ä¸­ã?«ã‚¨ãƒ©ãƒ¼ã?Œã?‚ã‚Šã?¾ã?—ã?Ÿ',0),(124664,3463,'pt','Houve um erro ao enviar o e-mail.',0),(124665,3463,'ru','Ð‘Ñ‹Ð»Ð° Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐµ email.',0),(124666,3463,'es','HabÃ­a error mandando el Email',0),(124667,3463,'de','Es war ein Fehler beim Senden der e-Mails.',0),(124668,3463,'en','There was an error sending the email.',0),(124669,3464,'is','',0),(124670,3464,'dr','Ø¬Ù…Ø¹ ÙƒÙ†Ù†Ø¯Ù‡ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(124671,3464,'pr','Ø¬Ù…Ø¹ ÙƒÙ†Ù†Ø¯Ù‡ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(124672,3464,'tr','E-posta adres seÃ§ici',0),(124673,3464,'pl','PrÃ³bnik adres e-mail',0),(124674,3464,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ',0),(124675,3464,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÛŒÚˆØ±ÛŒØ³ Ú†Ù†Ù†Ø¯Û',0),(124676,3464,'sr','Ð‘Ð¸Ñ€Ð°Ñ‡ Ð°Ð´Ñ€ÐµÑÐ° Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(124677,3464,'vi','Chá»n Ä‘á»‹a chá»‰ Email',0),(124678,3464,'af','E-pos Adres \"Picker\"',0),(124679,3464,'ro','Selector de adresa de e-mail',0),(124680,3464,'et','E-posti aadressi valija',0),(124681,3464,'si','Email naslov izbirnik',0),(124682,3464,'ba','Email Alamat Picker',0),(124683,3464,'nl','E-mail adres Picker',0),(124684,3464,'fi','SÃ¤hkÃ¶posti osoitteen valinta-ikkuna',0),(124685,3464,'no','E-postadressen Picker',0),(124686,3464,'da','E-mail adresse Picker',0),(124687,3464,'ko','ì´ë©”ì¼ ì£¼ì†Œ ì„ íƒ',0),(124688,3464,'he','×“×•×’× ×›×ª×•×‘×ª ×“×•×',0),(124689,3464,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· ÎµÏ€Î¹Î»Î¿Î³Î­Î±',0),(124690,3464,'zh','ç”µå­é‚®ä»¶åœ°å€é€‰æ‹©å™¨\r\n',0),(124691,3464,'sv','E-postadress Picker',0),(124692,3464,'it','Selezione indirizzo e-mail',0),(124693,3464,'tl','',0),(124694,3464,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3612;&#3641;&#3657;&#3648;&#3585;&#3655;&#3610;',0),(124695,3464,'hi','à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¥‡ à¤ªà¤¿à¤•à¤°',0),(124696,3464,'ms','Picker alamat e-mel',0),(124697,3464,'ar','Ù…Ù†ØªÙ‚ÙŠ Ø¹Ù†Ø§ÙˆÙŠÙ† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(124698,3464,'fr','SÃ©lecteur d\'adresse e-mail',0),(124699,3464,'jp','ï¼¥ãƒ¡ãƒ¼ãƒ«ã‚¢ãƒ‰ãƒ¬ã‚¹é?¸æŠž',0),(124700,3464,'pt','Seletor de endereÃ§o de e-mail',0),(124701,3464,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ Ð°Ð´Ñ€ÐµÑÐ° ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(124702,3464,'es','Email Selecciona un DirecciÃ³n',0),(124703,3464,'de','E-Mail-Adresse-Picker',0),(124704,3464,'en','Email Address Picker',0),(124705,3465,'is','',0),(124706,3465,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ',0),(124707,3465,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ',0),(124708,3465,'tr','E-posta baÅŸarÄ±yla gÃ¶nderildi',0),(124709,3465,'pl','E-mail wysÅ‚any pomyÅ›lnie',0),(124710,3465,'bg','Ð˜Ð¼ÐµÐ¹Ð»ÑŠÑ‚ Ð±ÐµÑˆÐµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(124711,3465,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ú¾ÛŒØ¬Û’ Ú¯Ø¦Û’ Ø§ÛŒ Ù…ÛŒÙ„',0),(124712,3465,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ð¾ÑÐ»Ð°Ñ‚Ð° Ðµ-Ð¿Ð¾Ñ€ÑƒÐºÐ°',0),(124713,3465,'vi','Gá»­i Email thÃ nh cÃ´ng',0),(124714,3465,'af','E-pos Suksesvol Gestuur',0),(124715,3465,'ro','E-mail trimis cu succes',0),(124716,3465,'et','E-kiri saadeti edukalt',0),(124717,3465,'si','Email poslan',0),(124718,3465,'ba','Email yang berhasil dikirim',0),(124719,3465,'nl','E-mail verzonden',0),(124720,3465,'fi','SÃ¤hkÃ¶postiviesti lÃ¤hetettiin onnistuneesti',0),(124721,3465,'no','E-post sendt',0),(124722,3465,'da','E-mail sendt',0),(124723,3465,'ko','ì„±ê³µì ìœ¼ë¡œ ë³´ë‚¸ ì´ë©”ì¼',0),(124724,3465,'he','×“×•××¨ ××œ×§×˜×¨×•× ×™ ×©× ×©×œ×— ×‘×”×¦×œ×—×”',0),(124725,3465,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Ï€Î¿Ï… ÏƒÏ„Î­Î»Î½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(124726,3465,'zh','ç”µå­é‚®ä»¶å‘é€æˆåŠŸ\r\n',0),(124727,3465,'sv','E-post som skickats',0),(124728,3465,'it','Email inviata con successo',0),(124729,3465,'tl','',0),(124730,3465,'th','&#3626;&#3656;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(124731,3465,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤ˆà¤®à¥‡à¤²',0),(124732,3465,'ms','E-mel yang dihantar telah berjaya',0),(124733,3465,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ù…Ø±Ø³Ù„Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(124734,3465,'fr','E-mail envoyÃ© avec succÃ¨s',0),(124735,3465,'jp','ï¼¥ãƒ¡ãƒ¼ãƒ«ã?Œé€?ä¿¡ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(124736,3465,'pt','E-mail enviado com sucesso',0),(124737,3465,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð°Ñ Ð¿Ð¾Ñ‡Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(124738,3465,'es','Email Enviado Exitosamente',0),(124739,3465,'de','E-Mail erfolgreich gesendet',0),(124740,3465,'en','Email Sent Successfully',0),(124741,3466,'is','',0),(124742,3466,'dr','Ø¬Ø¯Ø§ ÙƒØ±Ø¯Ù† Ø¢Ø¯Ø±Ø³ Ø¨Ø§\r\n ;',0),(124743,3466,'pr','Ø¬Ø¯Ø§ ÙƒØ±Ø¯Ù† Ø¢Ø¯Ø±Ø³ Ø¨Ø§\r\n ;',0),(124744,3466,'tr','Adresleri ile ayÄ±rÄ±n;',0),(124745,3466,'pl','Oddzielne adresy',0),(124746,3466,'bg','ÐžÑ‚Ð´ÐµÐ»Ð½Ð¸ Ð°Ð´Ñ€ÐµÑÐ¸ Ñ;',0),(124747,3466,'ur','Ù¾ØªÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾ Ø¹Ù„ÛŒØ­Ø¯Û Ú©Ø±ÛŒÚº Û”',0),(124748,3466,'sr','Ð Ð°Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ Ð°Ð´Ñ€ÐµÑÐµ ÑÐ°;',0),(124749,3466,'vi','PhÃ¢n cÃ¡ch Ä‘á»‹a chá»‰ vá»›i ;',0),(124750,3466,'af','Verdeel Adresse met ;',0),(124751,3466,'ro','Separa adresele',0),(124752,3466,'et','Eralda aadressid mÃ¤rgiga ;',0),(124753,3466,'si','LoÄite naslove s;',0),(124754,3466,'ba','Pisahkan setiap email dengan;',0),(124755,3466,'nl','Afzonderlijke adressen met;',0),(124756,3466,'fi','Erota osoitteet',0),(124757,3466,'no','Skill adressene med;',0),(124758,3466,'da','Adskille adresserne med;',0),(124759,3466,'ko','ë³„ë„ ì£¼ì†Œ;',0),(124760,3466,'he','×œ×”×¤×¨×™×“ ×›×ª×•×‘×•×ª ×¢×;',0),(124761,3466,'el','Î”Î¹Î±Ï‡Ï‰ÏÎ¯ÏƒÏ„Îµ Ï„Î¹Ï‚ Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚ Î¼Îµ?',0),(124762,3466,'zh','ç‹¬ç«‹åœ°å€çš„;\r\n',0),(124763,3466,'sv','Separera adresser med;',0),(124764,3466,'it','Separare gli indirizzi con;',0),(124765,3466,'tl','',0),(124766,3466,'th','&#3649;&#3618;&#3585;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3604;&#3657;&#3623;&#3618;',0),(124767,3466,'hi','à¤¸à¤¾à¤¥ à¤ªà¤¤à¥‹à¤‚ à¤•à¥‹ à¤…à¤²à¤—;',0),(124768,3466,'ms','Asingkan alamat',0),(124769,3466,'ar','ÙØµÙ„ Ø¹Ù†Ø§ÙˆÙŠÙ† Ù…Ø¹Ø›',0),(124770,3466,'fr','SÃ©parez les adresses avec ;',0),(124771,3466,'jp','ï½žã?¨ã?¯åˆ¥ã?®ä½?æ‰€',0),(124772,3466,'pt','Separe os endereÃ§os com;',0),(124773,3466,'ru','ÐžÑ‚Ð´ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð°Ð´Ñ€ÐµÑÐ° Ñ;',0),(124774,3466,'es','Direcciones Separadas con',0),(124775,3466,'de','Trennen Sie die Adressen mit;',0),(124776,3466,'en','Separate Addresses with ;',0),(124777,3467,'is','',0),(124778,3467,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(124779,3467,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(124780,3467,'tr','Ã‡alÄ±ÅŸanlar',0),(124781,3467,'pl','PracownikÃ³w',0),(124782,3467,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(124783,3467,'ur','Ù…Ù„Ø§Ø²Ù…ÛŒÙ†',0),(124784,3467,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸',0),(124785,3467,'vi','NhÃ¢n viÃªn',0),(124786,3467,'af','Werknemers',0),(124787,3467,'ro','AngajaÅ£ii',0),(124788,3467,'et','TÃ¶Ã¶tajad',0),(124789,3467,'si','Zaposlenih',0),(124790,3467,'ba','Karyawan',0),(124791,3467,'nl','Werknemers',0),(124792,3467,'fi','TyÃ¶ntekijÃ¤t',0),(124793,3467,'no','Ansatte',0),(124794,3467,'da','Medarbejdere',0),(124795,3467,'ko','ì§ì›',0),(124796,3467,'he','×¢×•×‘×“×™×',0),(124797,3467,'el','Î•ÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(124798,3467,'zh','å‘˜å·¥',0),(124799,3467,'sv','AnstÃ¤llda',0),(124800,3467,'it','Dipendenti',0),(124801,3467,'tl','',0),(124802,3467,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(124803,3467,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(124804,3467,'ms','Pekerja-pekerja',0),(124805,3467,'ar','Ø§Ù„Ù…ÙˆØ¸ÙÙˆÙ†',0),(124806,3467,'fr','EmployÃ©s',0),(124807,3467,'jp','å¾“æ¥­å“¡',0),(124808,3467,'pt','Empregados',0),(124809,3467,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¸',0),(124810,3467,'es','Empleados',0),(124811,3467,'de','Mitarbeiter',0),(124812,3467,'en','Employees',0),(124813,3468,'is','',0),(124814,3468,'dr','ÙÙ‚Ø· Ø§Ú¯Ø± Ù‚Ø¨ÙˆÙ„ Ø§Ø±ØªÙ‚Ø§Ø¡',0),(124815,3468,'pr','ÙÙ‚Ø· Ø§Ú¯Ø± Ù‚Ø¨ÙˆÙ„ Ø§Ø±ØªÙ‚Ø§Ø¡',0),(124816,3468,'tr','Sadece promosyonlar Tamam',0),(124817,3468,'pl','Tylko wtedy, gdy promocje OK',0),(124818,3468,'bg','Ð¡Ð°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¿Ñ€Ð¾Ð¼Ð¾Ñ†Ð¸Ð¸ OK',0),(124819,3468,'ur','ØµØ±Ù Ø§Ú¯Ø± Ù¾Ø±ÙˆÙ…ÙˆØ´Ù†Ø² Ù¹Ú¾ÛŒÚ© ÛÛ’',0),(124820,3468,'sr','Ð¡Ð°Ð¼Ð¾ Ð°ÐºÐ¾ Ñƒ Ñ€ÐµÐ´Ñƒ Ð¿Ñ€Ð¾Ð¼Ð¾Ñ†Ð¸Ñ˜Ðµ',0),(124821,3468,'vi','Chi khi khuyáº¿n máº¡i lÃ  OK',0),(124822,3468,'af','Slegs indien promosies OK',0),(124823,3468,'ro','Doar Ã®n cazul promoÅ£iilor OK',0),(124824,3468,'et','Kui tutvustusi OK',0),(124825,3468,'si','Samo Äe promocije OK',0),(124826,3468,'ba','Hanya jika OK promosi',0),(124827,3468,'nl','Alleen als promoties OK',0),(124828,3468,'fi','Vain, jos tarjouksia OK',0),(124829,3468,'no','Hvis kampanjer OK',0),(124830,3468,'da','Kun hvis kampagner OK',0),(124831,3468,'ko','ê²½ìš°ì—ë§Œ í”„ë¡œ ëª¨ì…˜ í™•ì¸',0),(124832,3468,'he','×¨×§ ×× ××™×©×•×¨ ×§×™×“×•×ž×™ ×ž×›×™×¨×•×ª',0),(124833,3468,'el','ÎœÏŒÎ½Î¿ Î±Î½ OK Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ­Ï‚',0),(124834,3468,'zh','åªæœ‰å½“ä¿ƒé”€å¯ä»¥\r\n',0),(124835,3468,'sv','Endast om kampanjer OK',0),(124836,3468,'it','Solo se OK promozioni',0),(124837,3468,'tl','',0),(124838,3468,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3606;&#3657;&#3634;&#3650;&#3611;&#3619;&#3650;&#3617;&#3594;&#3633;&#3656;&#3609; OK',0),(124839,3468,'hi','à¤•à¥‡à¤µà¤² à¤…à¤—à¤° à¤ªà¥à¤°à¥‹à¤¨à¥à¤¨à¤¤à¤¿ à¤ à¥€à¤•',0),(124840,3468,'ms','Hanya promosi OK',0),(124841,3468,'ar','ÙŠØ´Ù…Ù„ Ø§Ù„Ù…ÙˆØ§ÙÙ‚ÙŠÙ† Ø¹Ù„Ù‰ Ø¥Ø³ØªÙ„Ø§Ù… Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø¯Ø¹Ø§ÙŠØ© ÙÙ‚Ø·',0),(124842,3468,'fr','Seulement si OK Promotions',0),(124843,3468,'jp','ãƒ—ãƒ­ãƒ¢ãƒ¼ã‚·ãƒ§ãƒ³ã?ŒOKã?®å ´å?ˆã?®ã?¿',0),(124844,3468,'pt','Somente se promoÃ§Ãµes OK',0),(124845,3468,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð°ÐºÑ†Ð¸Ð¸ ÐžÐš',0),(124846,3468,'es','Solo si Promociones OK',0),(124847,3468,'de','Nur dann, wenn Angebote OK',0),(124848,3468,'en','Only if Promotions OK',0),(124849,3469,'is','',0),(124850,3469,'dr','(Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(124851,3469,'pr','Ø´Ø§Ù…Ù„ ØºÙŠØ± ÙØ¹Ø§Ù„ (Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(124852,3469,'tr','Etkin olmayan dahil',0),(124853,3469,'pl','Zawiera nieaktywne',0),(124854,3469,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð¸ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸',0),(124855,3469,'ur','ØºÛŒØ± ÙØ¹Ø§Ù„ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(124856,3469,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ðµ',0),(124857,3469,'vi','Bao gá»“m khÃ´ng hoáº¡t Ä‘á»™ng',0),(124858,3469,'af','Onaktiewes Ingesluit',0),(124859,3469,'ro','Includ inactiv',0),(124860,3469,'et','Lisada mitteaktiivsete',0),(124861,3469,'si','VkljuÄujejo neaktivni',0),(124862,3469,'ba','Termasuk tidak aktif',0),(124863,3469,'nl','Omvatten inactief',0),(124864,3469,'fi','SisÃ¤llytÃ¤ passiiviset',0),(124865,3469,'no','Inkludere inaktive',0),(124866,3469,'da','Medtage inaktive',0),(124867,3469,'ko','ë¹„í™œì„± í¬í•¨',0),(124868,3469,'he','×›×•×œ×œ×™× ×œ× ×¤×¢×™×œ',0),(124869,3469,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î±Î½ÎµÎ½ÎµÏÎ³ÏŒ',0),(124870,3469,'zh','åŒ…æ‹¬æ— æ•ˆ\r\n',0),(124871,3469,'sv','InnehÃ¥lla inaktiva',0),(124872,3469,'it','Sono inattivi',0),(124873,3469,'tl','',0),(124874,3469,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(124875,3469,'hi','à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(124876,3469,'ms','Termasuk tidak aktif',0),(124877,3469,'ar','ÙŠØ´Ù…Ù„ Ø§Ù„Ø®Ø§Ù…Ù„ÙˆÙ†',0),(124878,3469,'fr','Inclure inactif',0),(124879,3469,'jp','ä¸?æ´»å‹•ã‚‚å?«ã‚€',0),(124880,3469,'pt','Incluir inativos',0),(124881,3469,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ñ…',0),(124882,3469,'es','Incluir Inactivo',0),(124883,3469,'de','Sind inaktiv',0),(124884,3469,'en','Include Inactive',0),(124885,3470,'is','',0),(124886,3470,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ',0),(124887,3470,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ',0),(124888,3470,'tr','SipariÅŸ',0),(124889,3470,'pl','ZamÃ³wiÄ‡',0),(124890,3470,'bg','ÐŸÑ€Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚',0),(124891,3470,'ur','Ø³Û’ Ø¢Ø±ÚˆØ±',0),(124892,3470,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð¸Ð·',0),(124893,3470,'vi','Äáº·t hÃ ng tá»«',0),(124894,3470,'af','Bestelling Van',0),(124895,3470,'ro','Comanda de la',0),(124896,3470,'et','Telli',0),(124897,3470,'si','Naloga iz',0),(124898,3470,'ba','Order dari',0),(124899,3470,'nl','Bestellen',0),(124900,3470,'fi','Tilata',0),(124901,3470,'no','Bestille fra',0),(124902,3470,'da','Bestil fra',0),(124903,3470,'ko','ì£¼ë¬¸',0),(124904,3470,'he','×¡×“×¨ ×ž×Ÿ',0),(124905,3470,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î±Ï€ÏŒ',0),(124906,3470,'zh','è®¢è´­æ¥è‡ª\r\n',0),(124907,3470,'sv','BestÃ¤ll frÃ¥n',0),(124908,3470,'it','Ordinare da',0),(124909,3470,'tl','',0),(124910,3470,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;',0),(124911,3470,'hi','à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶',0),(124912,3470,'ms','Pesanan dari',0),(124913,3470,'ar','Ù…Ù† Ø£Ø¬Ù„ Ù…Ù†',0),(124914,3470,'fr','Commander auprÃ¨s de',0),(124915,3470,'jp','ï½žã?‹ã‚‰ã‚ªãƒ¼ãƒ€ãƒ¼',0),(124916,3470,'pt','Ordem de',0),(124917,3470,'ru','Ð—Ð°ÐºÐ°Ð· ÐžÑ‚',0),(124918,3470,'es','Pedido De',0),(124919,3470,'de','Bestellen Sie bei',0),(124920,3470,'en','Order From',0),(124921,3471,'is','',0),(124922,3471,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ ',0),(124923,3471,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ ',0),(124924,3471,'tr','Ä°Ã§in Ã¶deme',0),(124925,3471,'pl','OpÅ‚aca siÄ™',0),(124926,3471,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð°',0),(124927,3471,'ur','Ø§Ø¯Ø§ Ú©Ø±Ù†Ø§',0),(124928,3471,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð°',0),(124929,3471,'vi','Tráº£ cho',0),(124930,3471,'af','Besoldiging Aan',0),(124931,3471,'ro','PlÄƒteascÄƒ',0),(124932,3471,'et','Maksa',0),(124933,3471,'si','PlaÄilo za',0),(124934,3471,'ba','Membayar untuk',0),(124935,3471,'nl','Betalen aan',0),(124936,3471,'fi','Maksaa',0),(124937,3471,'no','Betale',0),(124938,3471,'da','Betale til',0),(124939,3471,'ko','ì§€ë¶ˆ',0),(124940,3471,'he','×©×œ× ×œ',0),(124941,3471,'el','ÎÎ±',0),(124942,3471,'zh','æ”¯ä»˜åˆ°\r\n',0),(124943,3471,'sv','Betala till',0),(124944,3471,'it','Pagare per',0),(124945,3471,'tl','',0),(124946,3471,'th','&#3592;&#3656;&#3634;&#3618;&#3606;&#3638;&#3591;',0),(124947,3471,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(124948,3471,'ms','Membayar kepada',0),(124949,3471,'ar','Ø¯ÙØ¹ Ø¥Ù„Ù‰',0),(124950,3471,'fr','Payer Ã ',0),(124951,3471,'jp','æ”¯æ‰•å…ˆ',0),(124952,3471,'pt','Pagar para',0),(124953,3471,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ',0),(124954,3471,'es','Pagar A',0),(124955,3471,'de','Zollen',0),(124956,3471,'en','Pay To',0),(124957,3472,'is','',0),(124958,3472,'dr','Ù‚Ø¨ÙˆÙ„ Ø§Ø±ØªÙ‚Ø§Ø¡',0),(124959,3472,'pr','Ù‚Ø¨ÙˆÙ„ Ø§Ø±ØªÙ‚Ø§Ø¡',0),(124960,3472,'tr','Promosyonlar Tamam',0),(124961,3472,'pl','Promocje OK',0),(124962,3472,'bg','ÐŸÑ€Ð¾Ð¼Ð¾Ñ†Ð¸Ð¸ OK',0),(124963,3472,'ur','Ù¾Ø±ÙˆÙ…ÙˆØ´Ù†Ø² Ù¹Ú¾ÛŒÚ© ÛÛ’',0),(124964,3472,'sr','ÐŸÑ€Ð¾Ð¼Ð¾Ñ†Ð¸Ñ˜Ðµ Ñƒ Ñ€ÐµÐ´Ñƒ',0),(124965,3472,'vi','Khuyáº¿n máº¡i OK ',0),(124966,3472,'af','Bevorderings OK',0),(124967,3472,'ro','Promotii OK',0),(124968,3472,'et','Tutvustusi OK',0),(124969,3472,'si','Promocije OK',0),(124970,3472,'ba','Promosi OK',0),(124971,3472,'nl','Promoties OK',0),(124972,3472,'fi','Tarjouksia OK',0),(124973,3472,'no','Kampanjer OK',0),(124974,3472,'da','Kampagner OK',0),(124975,3472,'ko','í”„ë¡œ ëª¨ì…˜ í™•ì¸',0),(124976,3472,'he','×ž×‘×¦×¢×™× ×‘×¡×“×¨',0),(124977,3472,'el','Î ÏÎ¿Ï‰Î¸Î®ÏƒÎµÎ¹Ï‚ OK',0),(124978,3472,'zh','åŒæ„ä¿ƒé”€\r\n',0),(124979,3472,'sv','Kampanjer OK',0),(124980,3472,'it','Promozioni OK',0),(124981,3472,'tl','',0),(124982,3472,'th','&#3650;&#3611;&#3619;&#3650;&#3617;&#3594;&#3633;&#3656;&#3609; OK',0),(124983,3472,'hi','à¤ªà¥à¤°à¥‹à¤¨à¥à¤¨à¤¤à¤¿ à¤ à¥€à¤•',0),(124984,3472,'ms','Promosi OK',0),(124985,3472,'ar','ØªØ¶Ù…ÙŠÙ†Ù‡ ÙÙŠ Ø§Ù„Ø­Ù…Ù„Ø§Øª Ø§Ù„Ø¯Ø¹Ø§Ø¦ÙŠØ© ØŸ',0),(124986,3472,'fr','Promotions OK',0),(124987,3472,'jp','ãƒ—ãƒ­ãƒ¢ãƒ¼ã‚·ãƒ§ãƒ³OK',0),(124988,3472,'pt','PromoÃ§Ãµes OK',0),(124989,3472,'ru','ÐÐºÑ†Ð¸Ð¸ ÐžÐš',0),(124990,3472,'es','Promociones OK',0),(124991,3472,'de','Angebote OK',0),(124992,3472,'en','Promotions OK',0),(124993,3473,'is','',0),(124994,3473,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†',0),(124995,3473,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†',0),(124996,3473,'tr','SatÄ±cÄ±lar',0),(124997,3473,'pl','Sprzedawczyni',0),(124998,3473,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²Ñ†Ð¸',0),(124999,3473,'ur','Ø³Ù„ÛŒØ³Ù…Ø§Ù†',0),(125000,3473,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð¸',0),(125001,3473,'vi','NhÃ¢n viÃªn kinh doanh',0),(125002,3473,'af','Verkoopspersone',0),(125003,3473,'ro','AgenÅ£i de vÃ¢nzÄƒri',0),(125004,3473,'et','MÃ¼Ã¼gimehed',0),(125005,3473,'si','Prodajalcev',0),(125006,3473,'ba','Salesman',0),(125007,3473,'nl','Verkopers',0),(125008,3473,'fi','Myyntimiehet',0),(125009,3473,'no','Selgere',0),(125010,3473,'da','SÃ¦lgere',0),(125011,3473,'ko','ì„¸ì¼ì¦ˆ ë§¨',0),(125012,3473,'he','××™×© ×ž×›×™×¨×•×ª',0),(125013,3473,'el','Î Ï‰Î»Î·Ï„Î­Ï‚',0),(125014,3473,'zh','æŽ¨é”€å‘˜\r\n',0),(125015,3473,'sv','FÃ¶rsÃ¤ljare',0),(125016,3473,'it','Venditori',0),(125017,3473,'tl','',0),(125018,3473,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(125019,3473,'hi','à¤¸à¥‡à¤²à¥à¤¸à¤®à¥ˆà¤¨',0),(125020,3473,'ms','Salesmen',0),(125021,3473,'ar','Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙˆÙ†',0),(125022,3473,'fr','Vendeurs',0),(125023,3473,'jp','ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…',0),(125024,3473,'pt','Vendedores',0),(125025,3473,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(125026,3473,'es','Vendedores',0),(125027,3473,'de','VerkÃ¤ufer',0),(125028,3473,'en','Salesmen',0),(125029,3474,'is','',0),(125030,3474,'dr','Ø¬Ø³ØªØ¬Ùˆ Ø·Ø¨Ù‚ Ø§ÙŠÙ…ÙŠÙ„ ÙŠØ§ Ù†Ø§Ù… ',0),(125031,3474,'pr','Ø¬Ø³ØªØ¬Ùˆ Ø·Ø¨Ù‚ Ø§ÙŠÙ…ÙŠÙ„ ÙŠØ§ Ù†Ø§Ù… ',0),(125032,3474,'tr','E-posta veya adÄ±na gÃ¶re arama',0),(125033,3474,'pl','Szukaj przez E-mail lub nazwa',0),(125034,3474,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð¿Ð¾ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ð¿Ð¾Ñ‰Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ',0),(125035,3474,'ur','Ù†Ø§Ù… ÛŒØ§ Ø§ÛŒ Ù…ÛŒÙ„ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(125036,3474,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ð¾Ð¼ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ',0),(125037,3474,'vi','TÃ¬m báº±ng Email hay TÃªn',0),(125038,3474,'af','Soek per E-pos of Naam',0),(125039,3474,'ro','CÄƒutare de Email sau numele',0),(125040,3474,'et','Otsi e-maili vÃµi nime jÃ¤gi',0),(125041,3474,'si','IÅ¡Äi po elektronski poÅ¡ti ali ime',0),(125042,3474,'ba','Cari berdasarkan nama atau Email',0),(125043,3474,'nl','Zoek per E-mail of naam',0),(125044,3474,'fi','Etsi sÃ¤hkÃ¶postitse tai nimi',0),(125045,3474,'no','SÃ¸k etter e-post eller navn',0),(125046,3474,'da','SÃ¸g via E-mail eller navn',0),(125047,3474,'ko','ì´ë©”ì¼ ë˜ëŠ” ì´ë¦„ìœ¼ë¡œ ê²€ìƒ‰',0),(125048,3474,'he','×—×¤×© ×œ×¤×™ ×“×•×\"×œ ××• ×©×',0),(125049,3474,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î® Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(125050,3474,'zh','é€šè¿‡ç”µå­é‚®ä»¶æˆ–åç§°æœç´¢\r\n',0),(125051,3474,'sv','SÃ¶k efter e-post eller namn',0),(125052,3474,'it','Ricerca per nome o Email',0),(125053,3474,'tl','',0),(125054,3474,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3650;&#3604;&#3618;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3627;&#3619;&#3639;&#3629;&#3594;&#3639;&#3656;&#3629;',0),(125055,3474,'hi','à¤ˆà¤®à¥‡à¤² à¤¯à¤¾ à¤¨à¤¾à¤® à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤° à¤–à¥‹à¤œà¥‡à¤‚',0),(125056,3474,'ms','Carian e-mel atau nama',0),(125057,3474,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¨Ø¥Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(125058,3474,'fr','Recherche par nom ou par courriel',0),(125059,3474,'jp','Eãƒ¡ãƒ¼ãƒ«ã?‹å??å‰?ã?§æ¤œç´¢',0),(125060,3474,'pt','Pesquisar por nome ou E-mail',0),(125061,3474,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¿Ð¾ Email Ð¸Ð»Ð¸ ÐÐ°Ð·Ð²Ð°Ð½Ð¸ÑŽ',0),(125062,3474,'es','Buscar por Email o Nombre',0),(125063,3474,'de','Suche per E-Mail oder Name',0),(125064,3474,'en','Search by Email or Name',0),(125065,3475,'is','',0),(125066,3475,'dr','Ø¬Ø³ØªØ¬Ùˆ Ø·Ø¨Ù‚\r\nØ´Ù…Ø§Ø±Ù‡ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ',0),(125067,3475,'pr','Ø¬Ø³ØªØ¬Ùˆ Ø·Ø¨Ù‚\r\nØ´Ù…Ø§Ø±Ù‡ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ',0),(125068,3475,'tr','SSN gÃ¶re ara',0),(125069,3475,'pl','Wg SSN',0),(125070,3475,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð¿Ð¾ SSN',0),(125071,3475,'ur','Ø§ÛŒØ³Ø§ÛŒØ³ÛŒÙ† Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(125072,3475,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð³Ð° Ð¿Ð¾ Ð¡Ð¡Ð',0),(125073,3475,'vi','TÃ¬m kiáº¿m bá»Ÿi SSN',0),(125074,3475,'af','Soek deur SSN',0),(125075,3475,'ro','CÄƒutare de SSN',0),(125076,3475,'et','SSN otsing',0),(125077,3475,'si','Iskanje po SSN',0),(125078,3475,'ba','Cari berdasarkan SSN',0),(125079,3475,'nl','Zoek door SSN',0),(125080,3475,'fi','Etsi SSN',0),(125081,3475,'no','SÃ¸k etter SSN',0),(125082,3475,'da','SÃ¸g efter SSN',0),(125083,3475,'ko','SSNë¡œ ê²€ìƒ‰',0),(125084,3475,'he','×—×™×¤×•×© ×œ×¤×™ ×ž×¡×¤×¨ ×ª×¢×•×“×ª ×–×”×•×ª',0),(125085,3475,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î¼Îµ SSN',0),(125086,3475,'zh','é€šè¿‡ç¤¾ä¼šå®‰å…¨åºå·æœç´¢\r\n',0),(125087,3475,'sv','SÃ¶k av SSN',0),(125088,3475,'it','Ricerca di SSN',0),(125089,3475,'tl','',0),(125090,3475,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3650;&#3604;&#3618; SSN',0),(125091,3475,'hi','à¤à¤¸à¤à¤¸à¤à¤¨ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤–à¥‹à¤œà¥‡à¤‚',0),(125092,3475,'ms','Cari oleh SSN',0),(125093,3475,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¨Ø¥Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø±Ù‚Ù… Ø§Ù„ÙˆØ·Ù†ÙŠ',0),(125094,3475,'fr','Recherche par SSN',0),(125095,3475,'jp','SSNã?§æ¤œç´¢',0),(125096,3475,'pt','Busca por CPF',0),(125097,3475,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¿Ð¾ SSN',0),(125098,3475,'es','Buscar por SSN',0),(125099,3475,'de','Suche nach SSN',0),(125100,3475,'en','Search by SSN',0),(125101,3476,'is','',0),(125102,3476,'dr','Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(125103,3476,'pr','Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(125104,3476,'tr','Geri e-posta adreslerine gÃ¶nder',0),(125105,3476,'pl','WysÅ‚aÄ‡ adresy E-mail powrÃ³t',0),(125106,3476,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑÐ¸',0),(125107,3476,'ur','Ù¾Ú†Ú¾Ù„ÛŒ Ø§ÛŒ Ù…ÛŒÙ„ Ù¾ØªÙˆÚº Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(125108,3476,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð½Ð°Ð·Ð°Ð´ Ð•Ð¼Ð°Ð¸Ð» Ð°Ð´Ñ€ÐµÑÐµ',0),(125109,3476,'vi','Gá»­i láº¡i Email Ä‘á»‹a chá»‰',0),(125110,3476,'af','Stuur E-posadres Terug',0),(125111,3476,'ro','Trimite adrese de E-mail Ã®napoi',0),(125112,3476,'et','Saada tagasi meiliaadressid',0),(125113,3476,'si','PoÅ¡lji nazaj Email naslovi',0),(125114,3476,'ba','Mengirim kembali Email Alamat',0),(125115,3476,'nl','Terug e-mailadressen verzenden',0),(125116,3476,'fi','LÃ¤hetÃ¤ takaisin sÃ¤hkÃ¶postiosoitteet',0),(125117,3476,'no','Sende tilbake e-postadresser',0),(125118,3476,'da','Send tilbage E-mail adresser',0),(125119,3476,'ko','ë‹¤ì‹œ ì´ë©”ì¼ ì£¼ì†Œë¥¼ ë³´ë‚¼',0),(125120,3476,'he','×©×œ×— ×›×ª×•×‘×•×ª ×“×•× ×œ ×’×‘',0),(125121,3476,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Ï€Î¯ÏƒÏ‰ Email Î”Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚',0),(125122,3476,'zh','å‘å›žç”µå­é‚®ä»¶åœ°å€\r\n',0),(125123,3476,'sv','Skicka tillbaka e-postadresser',0),(125124,3476,'it','Inviare indirizzi E-mail posteriore',0),(125125,3476,'tl','',0),(125126,3476,'th','&#3626;&#3656;&#3591;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3585;&#3621;&#3633;&#3610;&#3617;&#3634;',0),(125127,3476,'hi','à¤µà¤¾à¤ªà¤¸ à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¥‡ à¤­à¥‡à¤œ',0),(125128,3476,'ms','Menghantar alamat e-mel kembali',0),(125129,3476,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¹Ù†Ø§ÙˆÙŠÙ† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(125130,3476,'fr','Envoyez les adresses E-mail de retour',0),(125131,3476,'jp','è¿”é€?å…ˆï¼¥ãƒ¡ãƒ¼ãƒ«ã‚¢ãƒ‰ãƒ¬ã‚¹',0),(125132,3476,'pt','Enviar endereÃ§os de E-mail de volta',0),(125133,3476,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾ Email Ð°Ð´Ñ€ÐµÑÐ¾Ð²',0),(125134,3476,'es','Devolver Direcciones de Email',0),(125135,3476,'de','ZurÃ¼ck E-Mail-Adressen senden',0),(125136,3476,'en','Send Back Email Addresses',0),(125137,3477,'is','',0),(125138,3477,'dr','Ù…ÙˆØ¶ÙˆØ¹ ',0),(125139,3477,'pr','Ù…ÙˆØ¶ÙˆØ¹ ',0),(125140,3477,'tr','Konu',0),(125141,3477,'pl','Temat',0),(125142,3477,'bg','Ð¢ÐµÐ¼Ð°',0),(125143,3477,'ur','Ù…ÙˆØ¶ÙˆØ¹',0),(125144,3477,'sr','Ð¢ÐµÐ¼Ð°',0),(125145,3477,'vi','Chá»§ Ä‘á»',0),(125146,3477,'af','Onderwerp',0),(125147,3477,'ro','Subiect',0),(125148,3477,'et','Teema',0),(125149,3477,'si','Predmet',0),(125150,3477,'ba','Subjek',0),(125151,3477,'nl','Onderwerp',0),(125152,3477,'fi','Aihe',0),(125153,3477,'no','Emne',0),(125154,3477,'da','Emne',0),(125155,3477,'ko','ì œëª©',0),(125156,3477,'he','× ×•×©×',0),(125157,3477,'el','Î˜Î­Î¼Î±',0),(125158,3477,'zh','ç§‘ç›®\r\n',0),(125159,3477,'sv','AngÃ¥ende',0),(125160,3477,'it','Oggetto',0),(125161,3477,'tl','',0),(125162,3477,'th','&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;',0),(125163,3477,'hi','à¤µà¤¿à¤·à¤¯',0),(125164,3477,'ms','Subjek',0),(125165,3477,'ar','Ø§Ù„Ù…ÙˆØ¶ÙˆØ¹',0),(125166,3477,'fr','Objet',0),(125167,3477,'jp','é¡Œå??',0),(125168,3477,'pt','Assunto',0),(125169,3477,'ru','ÐŸÑ€ÐµÐ´Ð¼ÐµÑ‚',0),(125170,3477,'es','Sujeto',0),(125171,3477,'de','Betreff',0),(125172,3477,'en','Subject',0),(125173,3478,'is','',0),(125174,3478,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒØ±Ø¯Ù† ',0),(125175,3478,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒØ±Ø¯Ù† ',0),(125176,3478,'tr','KullanÄ±m',0),(125177,3478,'pl','Wykorzystanie',0),(125178,3478,'bg','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(125179,3478,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(125180,3478,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(125181,3478,'vi','Sá»­ dá»¥ng',0),(125182,3478,'af','Gebruik',0),(125183,3478,'ro','Utilizarea',0),(125184,3478,'et','Kasutamine',0),(125185,3478,'si','Uporaba',0),(125186,3478,'ba','Penggunaan',0),(125187,3478,'nl','Gebruik',0),(125188,3478,'fi','KÃ¤yttÃ¶',0),(125189,3478,'no','Bruk',0),(125190,3478,'da','Brug',0),(125191,3478,'ko','ì‚¬ìš©',0),(125192,3478,'he','×©×™×ž×•×©',0),(125193,3478,'el','Î§ÏÎ®ÏƒÎ·',0),(125194,3478,'zh','ä½¿ç”¨\r\n',0),(125195,3478,'sv','AnvÃ¤ndning',0),(125196,3478,'it','Uso',0),(125197,3478,'tl','',0),(125198,3478,'th','&#3651;&#3594;&#3657;',0),(125199,3478,'hi','à¤•à¤¾ à¤ªà¥à¤°à¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(125200,3478,'ms','Penggunaan',0),(125201,3478,'ar','Ø¥Ø³ØªØ®Ø¯Ù…',0),(125202,3478,'fr','Utilisation',0),(125203,3478,'jp','åˆ©ç”¨',0),(125204,3478,'pt','Uso',0),(125205,3478,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(125206,3478,'es','Uso ',0),(125207,3478,'de','Verwendung',0),(125208,3478,'en','Use',0),(125209,3479,'is','',0),(125210,3479,'dr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù†',0),(125211,3479,'pr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù†',0),(125212,3479,'tr','KullanÄ±cÄ±lar',0),(125213,3479,'pl','UÅ¼ytkownicy',0),(125214,3479,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(125215,3479,'ur','ØµØ§Ø±ÙÛŒÙ†',0),(125216,3479,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸',0),(125217,3479,'vi','NgÆ°á»i Sá»­ Dá»¥ng',0),(125218,3479,'af','Gebruikers',0),(125219,3479,'ro','Utilizatori',0),(125220,3479,'et','Kasutajad',0),(125221,3479,'si','Uporabniki',0),(125222,3479,'ba','Pengguna',0),(125223,3479,'nl','Gebruikers',0),(125224,3479,'fi','KÃ¤yttÃ¤jÃ¤t',0),(125225,3479,'no','Brukere',0),(125226,3479,'da','Brugere',0),(125227,3479,'ko','ì‚¬ìš©ìž',0),(125228,3479,'he','×ž×©×ª×ž×©×™×',0),(125229,3479,'el','ÎŸÎ¹ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(125230,3479,'zh','ç”¨æˆ·\r\n',0),(125231,3479,'sv','AnvÃ¤ndare',0),(125232,3479,'it','Utenti',0),(125233,3479,'tl','',0),(125234,3479,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(125235,3479,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹',0),(125236,3479,'ms','Pengguna',0),(125237,3479,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙˆÙ†',0),(125238,3479,'fr','Utilisateurs',0),(125239,3479,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(125240,3479,'pt','UsuÃ¡rios',0),(125241,3479,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸',0),(125242,3479,'es','Usuarios',0),(125243,3479,'de','Benutzer',0),(125244,3479,'en','Users',0),(125245,3480,'is','',0),(125246,3480,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ',0),(125247,3480,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ',0),(125248,3480,'tr','SatÄ±cÄ±lar',0),(125249,3480,'pl','DostawcÃ³w',0),(125250,3480,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(125251,3480,'ur','Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº',0),(125252,3480,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸',0),(125253,3480,'vi','NgÆ°á»i bÃ¡n',0),(125254,3480,'af','Verskaffers',0),(125255,3480,'ro','Furnizori',0),(125256,3480,'et','Tarnijad',0),(125257,3480,'si','Prodajalci',0),(125258,3480,'ba','Vendor',0),(125259,3480,'nl','Leveranciers',0),(125260,3480,'fi','Toimittajat',0),(125261,3480,'no','LeverandÃ¸rer',0),(125262,3480,'da','Kreditorer',0),(125263,3480,'ko','ê³µê¸‰ ì—…ì²´',0),(125264,3480,'he','×¡×¤×§×™×',0),(125265,3480,'el','Î Ï‰Î»Î·Ï„Î­Ï‚',0),(125266,3480,'zh','ä¾›åº”å•†\r\n',0),(125267,3480,'sv','LeverantÃ¶rer',0),(125268,3480,'it','Fornitori',0),(125269,3480,'tl','',0),(125270,3480,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(125271,3480,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(125272,3480,'ms','Vendor',0),(125273,3480,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙˆÙ†',0),(125274,3480,'fr','Vendeurs',0),(125275,3480,'jp','æ¥­è€…',0),(125276,3480,'pt','Fornecedores',0),(125277,3480,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸',0),(125278,3480,'es','Proveedores',0),(125279,3480,'de','Kreditoren',0),(125280,3480,'en','Vendors',0),(125281,3481,'is','',0),(125282,3481,'dr','Ú¯Ø±ÙØªÙ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ  Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(125283,3481,'pr','Ú¯Ø±ÙØªÙ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ  Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(125284,3481,'tr','AlÄ±ntÄ± nakliye almak',0),(125285,3481,'pl','SiÄ™ wysyÅ‚ka cytat',0),(125286,3481,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(125287,3481,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø´Ù¾Ù†Ú¯ Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(125288,3481,'sr','Ð¡Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(125289,3481,'vi','Láº¥y bÃ¡o giÃ¡ váº­n chuyá»ƒn',0),(125290,3481,'af','Verkry Versendingskwotasies',0),(125291,3481,'ro','ObÅ£ine transport citat',0),(125292,3481,'et','Saada Shipping Quote',0),(125293,3481,'si','Dobili prevoz Citiraj',0),(125294,3481,'ba','Mendapatkan pengiriman kutipan',0),(125295,3481,'nl','Krijgen citaat verzending',0),(125296,3481,'fi','Saada Shipping Quote',0),(125297,3481,'no','FÃ¥ Shipping tilbud',0),(125298,3481,'da','FÃ¥ Shipping citat',0),(125299,3481,'ko','ê²¬ì  ë°°ì†¡ ë°›ì„',0),(125300,3481,'he','×œ×§×‘×œ ×œ×”×¦×¢×ª ×ž×—×™×¨ ×ž×©×œ×•×—',0),(125301,3481,'el','Î Î¬ÏÎµÏ„Îµ Ï€Î±ÏÎ¬Î¸ÎµÏƒÎ· Î½Î±Ï…Ï„Î¹Î»Î¯Î±Ï‚',0),(125302,3481,'zh','èŽ·å–èˆªè¿æŠ¥ä»·\r\n',0),(125303,3481,'sv','FÃ¥ frakt Offert',0),(125304,3481,'it','Ottieni spedizione preventivo',0),(125305,3481,'tl','',0),(125306,3481,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3588;&#3656;&#3634;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(125307,3481,'hi','à¤¬à¥‹à¤²à¥€ à¤¨à¥Œà¤µà¤¹à¤¨ à¤œà¤¾à¤“',0),(125308,3481,'ms','Dapatkan penghantaran Quote',0),(125309,3481,'ar','Ø§Ø­ØµÙ„ Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø­Ù† Ø§Ù‚ØªØ¨Ø§Ø³',0),(125310,3481,'fr','Obtenir devis d\'expÃ©dition',0),(125311,3481,'jp','ç™ºé€?è¦‹ç©?ã‚Šã‚’ã?¨ã‚‹',0),(125312,3481,'pt','Obter cotaÃ§Ã£o do transporte',0),(125313,3481,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(125314,3481,'es','Conseguir CotizaciÃ³n de EnvÃ­o',0),(125315,3481,'de','Angebot Versand erhalten',0),(125316,3481,'en','Get Shipping Quote',0),(125317,3482,'is','',0),(125318,3482,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ Ù†Ø§Ù…Ù‡ Ù‡Ø§ ÙˆØ¨Ø³ØªÙ‡ Ù‡Ø§ Ø¯Ø± Ø³Ø±Ø§Ø³Ø± Ø¯Ù†ÙŠØ§ ',0),(125319,3482,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ Ù†Ø§Ù…Ù‡ Ù‡Ø§ ÙˆØ¨Ø³ØªÙ‡ Ù‡Ø§ Ø¯Ø± Ø³Ø±Ø§Ø³Ø± Ø¯Ù†ÙŠØ§ ',0),(125320,3482,'tr','BirleÅŸik parsel Servisi',0),(125321,3482,'pl','United Parcel Service',0),(125322,3482,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÐµÐ½Ð° ÐºÑƒÑ€Ð¸ÐµÑ€ÑÐºÐ° ÑÐ»ÑƒÐ¶Ð±Ð°',0),(125323,3482,'ur','Ù…ØªØ­Ø¯Û Ù¾Ø§Ø±Ø³Ù„ Ø³Ø±ÙˆØ³',0),(125324,3482,'sr','Ð£Ð½Ð¸Ñ‚ÐµÐ´ ÐŸÐ°Ñ€Ñ†ÐµÐ» Ð¡ÐµÑ€Ð²Ð¸Ñ†Ðµ',0),(125325,3482,'vi','HÃ£ng chuyá»ƒn phÃ¡t nhanh UPS',0),(125326,3482,'af','Verenigde Pakketdiens',0),(125327,3482,'ro','United Parcel Service',0),(125328,3482,'et','United Parcel Service',0),(125329,3482,'si','United Parcel Service',0),(125330,3482,'ba','United Parcel Service',0),(125331,3482,'nl','United Parcel Service',0),(125332,3482,'fi','United Parcel Service',0),(125333,3482,'no','United Parcel Service',0),(125334,3482,'da','United Parcel Service',0),(125335,3482,'ko','ë¯¸êµ­ëœ ì†Œí¬ ì„œë¹„ìŠ¤',0),(125336,3482,'he','×—×‘×™×œ×” ×™×•× ×™×™×˜×“ ×©×™×¨×•×ª',0),(125337,3482,'el','Î•Î½Ï‰Î¼Î­Î½Î· Parcel Service',0),(125338,3482,'zh','è”åˆåŒ…è£¹è¿é€æœåŠ¡å…¬å¸\r\n',0),(125339,3482,'sv','United Parcel Service',0),(125340,3482,'it','United Parcel Service',0),(125341,3482,'tl','',0),(125342,3482,'th','&#3610;&#3619;&#3636;&#3636;&#3585;&#3634;&#3619;&#3627;&#3656;&#3629;&#3623;&#3633;&#3626;&#3604;&#3640;',0),(125343,3482,'hi','à¤¯à¥‚à¤¨à¤¾à¤‡à¤Ÿà¥‡à¤¡ à¤ªà¤¾à¤°à¥à¤¸à¤² à¤¸à¥‡à¤µà¤¾',0),(125344,3482,'ms','Buat yang Bersatu',0),(125345,3482,'ar','Ø®Ø¯Ù…Ø© Ø§Ù„Ø·Ø±ÙˆØ¯ Ø§Ù„Ù…ØªØ­Ø¯Ø©',0),(125346,3482,'fr','United Parcel Service',0),(125347,3482,'jp','ãƒ¦ãƒ¼ãƒ”ãƒ¼ã‚¨ã‚¹',0),(125348,3482,'pt','United Parcel Service',0),(125349,3482,'ru','ÐžÐ±ÑŠÐµÐ´Ð¸Ð½ÐµÐ½Ð½Ð°Ñ Ð¿Ð¾ÑÑ‹Ð»Ð¾Ðº',0),(125350,3482,'es','United Parcel Service',0),(125351,3482,'de','United Parcel Service',0),(125352,3482,'en','United Parcel Service',0),(125353,3483,'is','',0),(125354,3483,'dr','UPS Ø§Ø³Ø§Ø³ Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ',0),(125355,3483,'pr','UPS Ø§Ø³Ø§Ø³ Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ',0),(125356,3483,'tr','UPS Ground',0),(125357,3483,'pl','UPS ziemi',0),(125358,3483,'bg','UPS Ñ‚ÐµÑ€ÐµÐ½',0),(125359,3483,'ur','UPS Ú¯Ø±Ø§Ø¤Ù†Úˆ',0),(125360,3483,'sr','Ð£ÐŸÐ¡ Ð·ÐµÐ¼Ñ™Ñƒ',0),(125361,3483,'vi','Ná»n UPS',0),(125362,3483,'af','Onderbrekinglose Kragtoevoer grond',0),(125363,3483,'ro','UPS solului',0),(125364,3483,'et','UPS Ground',0),(125365,3483,'si','UPS terenu',0),(125366,3483,'ba','UPS Ground',0),(125367,3483,'nl','UPS Ground',0),(125368,3483,'fi','UPS Ground',0),(125369,3483,'no','UPS bakken',0),(125370,3483,'da','UPS Ground',0),(125371,3483,'ko','UPS ì ‘ì§€',0),(125372,3483,'he','UPS ×”×§×¨×§×¢',0),(125373,3483,'el','UPS Î­Î´Î±Ï†Î¿Ï‚',0),(125374,3483,'zh','UPSç¾Žå›½è”åˆåŒ…è£¹åœ°é¢æœåŠ¡\r\n',0),(125375,3483,'sv','UPS Ground',0),(125376,3483,'it','UPS Ground',0),(125377,3483,'tl','',0),(125378,3483,'th','UPS Ground',0),(125379,3483,'hi','à¤¯à¥‚à¤ªà¥€à¤à¤¸ à¤—à¥à¤°à¤¾à¤‰à¤‚à¤¡',0),(125380,3483,'ms','UPS Ground',0),(125381,3483,'ar','Ø§Ù„Ø£Ø±Ø¶ UPS',0),(125382,3483,'fr','UPS Ground',0),(125383,3483,'jp','ï¼µï¼°ï¼³é™¸é?‹',0),(125384,3483,'pt','UPS Ground',0),(125385,3483,'ru','UPS Ground',0),(125386,3483,'es','UPS por Tierra',0),(125387,3483,'de','UPS Boden',0),(125388,3483,'en','UPS Ground',0),(125389,3484,'is','',0),(125390,3484,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ù‡ÙˆØ§ÙŠÙŠ Ø§ÙˆØ§ÙŠÙ„ Ø±ÙˆØ² Ø¢ÙŠÙ†Ø¯Ù‡ ',0),(125391,3484,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ù‡ÙˆØ§ÙŠÙŠ Ø§ÙˆØ§ÙŠÙ„ Ø±ÙˆØ² Ø¢ÙŠÙ†Ø¯Ù‡ ',0),(125392,3484,'tr','Sonraki gÃ¼n hava erken GELDÄ°M',0),(125393,3484,'pl','Next Day Air juÅ¼ jestem',0),(125394,3484,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ Ð´ÐµÐ½ Ð²ÑŠÐ·Ð´ÑƒÑ… Ñ€Ð°Ð½Ð¾ ÑÑŠÐ¼',0),(125395,3484,'ur','Ø§Ú¯Ù„Û’ Ø¯Ù† ÛÙˆØ§Ø¦ÛŒ Ø¬Ù„Ø¯ ÛÙˆÚº',0),(125396,3484,'sr','ÐÐ°Ñ€ÐµÐ´Ð½Ð¸Ñ… Ð´Ð°Ð½Ð° Ð°Ð²Ð¸Ð¾Ð½Ð¾Ð¼ Ñ€Ð°Ð½Ð¾ ÑÐ°Ð¼',0),(125397,3484,'vi','Chuyá»ƒn mÃ¡y bay sÃ¡ng sá»›m ngÃ y hÃ´m sau',0),(125398,3484,'af','Volgende dag lug vroeg is',0),(125399,3484,'ro','Doua zi Air sunt la Ã®nceputul',0),(125400,3484,'et','JÃ¤rgmine pÃ¤ev Air varakult olen',0),(125401,3484,'si','Naslednji dan zraku zgodaj sem',0),(125402,3484,'ba','Hari berikutnya udara awal AM',0),(125403,3484,'nl','Lucht van de volgende dag vroeg ben',0),(125404,3484,'fi','Seuraava pÃ¤ivÃ¤ Air AAMUYÃ–',0),(125405,3484,'no','Neste dag Air tidlig er',0),(125406,3484,'da','NÃ¦ste dag Air tidligt AM',0),(125407,3484,'ko','ë‹¤ìŒ ë‚  ì–´ ì¼ì° ì˜¤ì „',0),(125408,3484,'he','×”××•×•×™×¨ ×”×™×•× ×”×‘× ×× ×™ ×ž×•×§×“×',0),(125409,3484,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Î·Î¼Î­ÏÎ± Air Î½Ï‰ÏÎ¯Ï‚ ÎµÎ¯Î¼Î±Î¹',0),(125410,3484,'zh','ä¸‹ä¸€å¤©ä¸Šåˆç©ºè¿æ—¶é—´',0),(125411,3484,'sv','NÃ¤sta dag Air tidigt Ã¤r',0),(125412,3484,'it','Next Day Air presto sto',0),(125413,3484,'tl','',0),(125414,3484,'th','&#3629;&#3634;&#3585;&#3634;&#3624;&#3623;&#3633;&#3609;&#3606;&#3633;&#3604;&#3652;&#3611;&#3594;&#3656;&#3623;&#3591;&#3648;&#3594;&#3657;&#3634;',0),(125415,3484,'hi','à¤…à¤—à¤²à¥‡ à¤¦à¤¿à¤¨ à¤à¤¯à¤° à¤œà¤²à¥à¤¦à¥€ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥‚à¤',0),(125416,3484,'ms','Seterusnya hari udara awal pagi',0),(125417,3484,'ar','Ø§Ù„ÙŠÙˆÙ… Ø§Ù„ØªØ§Ù„ÙŠ Ù„Ù„Ø·ÙŠØ±Ø§Ù† ÙˆØ£Ù†Ø§ Ù…Ø·Ù„Ø¹',0),(125418,3484,'fr','Next Day Air tÃ´t suis',0),(125419,3484,'jp','ç¿Œæ—¥æ—©æœ?é…?é€?',0),(125420,3484,'pt','Next Day Air cedo estou',0),(125421,3484,'ru','Ð’Ð¾Ð·Ð´ÑƒÑ… Ð½Ð° Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ð´ÐµÐ½ÑŒ Ñ€Ð°Ð½Ð¾ AM',0),(125422,3484,'es','Proximo DÃ­a por Correo AÃ©reo Temprano AM',0),(125423,3484,'de','Next Day Air frÃ¼h bin',0),(125424,3484,'en','Next Day Air Early AM',0),(125425,3485,'is','',0),(125426,3485,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ù‡ÙˆØ§ÙŠÙŠ Ø±ÙˆØ² Ø¢ÙŠÙ†Ø¯Ù‡ ',0),(125427,3485,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ù‡ÙˆØ§ÙŠÙŠ Ø±ÙˆØ² Ø¢ÙŠÙ†Ø¯Ù‡ ',0),(125428,3485,'tr','Sonraki gÃ¼n hava',0),(125429,3485,'pl','Next Day Air',0),(125430,3485,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ Ð´ÐµÐ½ Ð²ÑŠÐ·Ð´ÑƒÑ…',0),(125431,3485,'ur','Ø§Ú¯Ù„Û’ Ø¯Ù† ÛÙˆØ§',0),(125432,3485,'sr','ÐÐ°Ñ€ÐµÐ´Ð½Ð¸Ñ… Ð´Ð°Ð½Ð° Ð°Ð²Ð¸Ð¾Ð½Ð¾Ð¼',0),(125433,3485,'vi','Chuyá»ƒn mÃ¡y bay ngÃ y hÃ´m sau',0),(125434,3485,'af','Volgende dag lug',0),(125435,3485,'ro','Doua zi Air',0),(125436,3485,'et','JÃ¤rgmine pÃ¤ev Air',0),(125437,3485,'si','Naslednji dan zraku',0),(125438,3485,'ba','Hari berikutnya udara',0),(125439,3485,'nl','Next Day Air',0),(125440,3485,'fi','Seuraava pÃ¤ivÃ¤ Air',0),(125441,3485,'no','Neste dag Air',0),(125442,3485,'da','NÃ¦ste dag Air',0),(125443,3485,'ko','ë‹¤ìŒ ë‚  ì–´',0),(125444,3485,'he','×”××•×•×™×¨ ×‘×™×•× ×”×‘×',0),(125445,3485,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Î·Î¼Î­ÏÎ± Air',0),(125446,3485,'zh','ä¸‹ä¸€å¤©ç©ºè¿\r\n',0),(125447,3485,'sv','NÃ¤sta dag Air',0),(125448,3485,'it','Next Day Air',0),(125449,3485,'tl','',0),(125450,3485,'th','&#3629;&#3634;&#3585;&#3634;&#3624;&#3623;&#3633;&#3609;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(125451,3485,'hi','à¤…à¤—à¤²à¥‡ à¤¦à¤¿à¤¨ à¤à¤¯à¤°',0),(125452,3485,'ms','Seterusnya hari Penyaman',0),(125453,3485,'ar','Ø§Ù„ÙŠÙˆÙ… Ø§Ù„ØªØ§Ù„ÙŠ Ù„Ù„Ø·ÙŠØ±Ø§Ù†',0),(125454,3485,'fr','Next Day Air',0),(125455,3485,'jp','ç¿Œæ—¥é…?é€?',0),(125456,3485,'pt','Next Day Air',0),(125457,3485,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð´ÐµÐ½ÑŒ Ð²Ð¾Ð·Ð´ÑƒÑ…',0),(125458,3485,'es','Proximo DÃ­a por Correo AÃ©reo',0),(125459,3485,'de','Next Day Air',0),(125460,3485,'en','Next Day Air',0),(125461,3486,'is','',0),(125462,3486,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø°Ø®ÙŠØ±Ù‡ ÙƒÙ†Ù†Ø¯Ù‡ Ù‡ÙˆØ§ÙŠÙŠ Ø±ÙˆØ² Ø¢ÙŠÙ†Ø¯Ù‡ ',0),(125463,3486,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø°Ø®ÙŠØ±Ù‡ ÙƒÙ†Ù†Ø¯Ù‡ Ù‡ÙˆØ§ÙŠÙŠ Ø±ÙˆØ² Ø¢ÙŠÙ†Ø¯Ù‡ ',0),(125464,3486,'tr','Sonraki gÃ¼n hava koruyucu',0),(125465,3486,'pl','NastÄ™pnego dnia powietrze wygaszacz',0),(125466,3486,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ Ð´ÐµÐ½ Ð²ÑŠÐ·Ð´ÑƒÑ… ÑÐºÑ€Ð¸Ð¹Ð½ÑÐµÐ¹Ð²ÑŠÑ€',0),(125467,3486,'ur','Ø§Ú¯Ù„Û’ Ø¯Ù† Ø§ÛŒØ¦Ø± Ù…Ø­Ø§ÙØ¸',0),(125468,3486,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð´Ð°Ð½ Ð²Ð°Ð·Ð´ÑƒÑ… Ñ‡ÑƒÐ²Ð°Ñ€Ð°',0),(125469,3486,'vi','Tiáº¿t kiá»‡m Chuyá»ƒn mÃ¡y bay ngÃ y hÃ´m sau ',0),(125470,3486,'af','Volgende dag lug sluimerskerm',0),(125471,3486,'ro','UrmÄƒtoarea zi aer Saver',0),(125472,3486,'et','JÃ¤rgmine pÃ¤ev Air Saver',0),(125473,3486,'si','Naslednji dan Air ohranjevalnik',0),(125474,3486,'ba','Hari berikutnya udara Saver',0),(125475,3486,'nl','Next Day Air Saver',0),(125476,3486,'fi','Seuraava pÃ¤ivÃ¤ Air Saver',0),(125477,3486,'no','Neste dag Air Saver',0),(125478,3486,'da','NÃ¦ste dag Air Saver',0),(125479,3486,'ko','ë‹¤ìŒ ë‚ ì— ì–´ ë³´í˜¸ê¸°',0),(125480,3486,'he','×©×•×ž×¨ ××•×•×™×¨ ×‘×™×•× ×”×‘×',0),(125481,3486,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Î·Î¼Î­ÏÎ± Ï€ÏÎ¿Ï†ÏÎ»Î±Î¾Î· Î±Î­ÏÎ±',0),(125482,3486,'zh','ä¸‹ä¸€å¤©ç©ºè¿ä¿å­˜å™¨\r\n',0),(125483,3486,'sv','NÃ¤sta dag Air sparare',0),(125484,3486,'it','Prossimo giorno aria Saver',0),(125485,3486,'tl','',0),(125486,3486,'th','&#3612;&#3641;&#3657;&#3604;&#3641;&#3629;&#3634;&#3585;&#3634;&#3624;&#3623;&#3633;&#3609;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(125487,3486,'hi','à¤…à¤—à¤²à¥‡ à¤¦à¤¿à¤¨ à¤à¤¯à¤° à¤¸à¥‡à¤µà¤°',0),(125488,3486,'ms','Seterusnya hari Penyaman pemelihara',0),(125489,3486,'ar','Ø§Ù„ÙŠÙˆÙ… Ø§Ù„ØªØ§Ù„ÙŠ Ø§Ù„Ù‡ÙˆØ§Ø¡ Ø§Ù„ØªÙˆÙ‚Ù',0),(125490,3486,'fr','Prochaine journÃ©e Air Saver',0),(125491,3486,'jp','ç¿Œæ—¥ç¯€ç´„é…?é€?',0),(125492,3486,'pt','Protetor de ar no prÃ³ximo dia',0),(125493,3486,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð´ÐµÐ½ÑŒ Ð²Ð¾Ð·Ð´ÑƒÑ… Ð·Ð°ÑÑ‚Ð°Ð²ÐºÐ°',0),(125494,3486,'es','Proximo DÃ­a por Correo AÃ©reo Ahorrador',0),(125495,3486,'de','NÃ¤chsten Tag-Air-Saver',0),(125496,3486,'en','Next Day Air Saver',0),(125497,3487,'is','',0),(125498,3487,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ù‡ÙˆØ§ÙŠÙŠ Ø§ÙˆØ§ÙŠÙ„ Ø±ÙˆØ² Ø¯ÙˆÙ…',0),(125499,3487,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ù‡ÙˆØ§ÙŠÙŠ Ø§ÙˆØ§ÙŠÙ„ Ø±ÙˆØ² Ø¯ÙˆÙ…',0),(125500,3487,'tr','2 gÃ¼n hava erken GELDÄ°M',0),(125501,3487,'pl','2 dzieÅ„ powietrza juÅ¼ jestem',0),(125502,3487,'bg','2-Ñ€Ð¸ Ð´ÐµÐ½ Ð²ÑŠÐ·Ð´ÑƒÑ… Ñ€Ð°Ð½Ð¾ ÑÑŠÐ¼',0),(125503,3487,'ur','Ø¯ÙˆØ³Ø±Ø§ Ø¯Ù† ÛÙˆØ§Ø¦ÛŒ Ø¬Ù„Ø¯ ÛÙˆÚº',0),(125504,3487,'sr','2 Ð´Ð°Ð½Ð° Ð°Ð²Ð¸Ð¾Ð½Ð¾Ð¼ Ñ€Ð°Ð½Ð¾ ÑÐ°Ð¼',0),(125505,3487,'vi','Chuyá»ƒn mÃ¡y bay sÃ¡ng sá»›m ngÃ y thá»© hai ',0),(125506,3487,'af','2de dag lug vroeg is',0),(125507,3487,'ro','2nd Day Air sunt la Ã®nceputul',0),(125508,3487,'et','2. pÃ¤ev Air varakult olen',0),(125509,3487,'si','2. dan zraka zgodaj sem',0),(125510,3487,'ba','2 hari Air awal AM',0),(125511,3487,'nl','2nd Day Air vroeg ben',0),(125512,3487,'fi','toinen pÃ¤ivÃ¤ Air AAMUYÃ–',0),(125513,3487,'no','andre dag Air tidlig er',0),(125514,3487,'da','2nd Day Air tidligt AM',0),(125515,3487,'ko','2 ì¼ í•­ê³µ ì˜¤ì „ ì¼ì°',0),(125516,3487,'he','2 ×™×•× ××•×•×™×¨ ×ž×•×§×“× ×× ×™',0),(125517,3487,'el','2Î· Î±Î³Ï‰Î½Î¹ÏƒÏ„Î¹ÎºÎ® Air Î½Ï‰ÏÎ¯Ï‚ ÎµÎ¯Î¼Î±Î¹',0),(125518,3487,'zh','ç¬¬2å¤©ä¸Šåˆç©ºè¿æ—¶é—´\r\n',0),(125519,3487,'sv','2 dag Air tidigt Ã¤r',0),(125520,3487,'it','2 Â° giorno aria presto sto',0),(125521,3487,'tl','',0),(125522,3487,'th','&#3629;&#3634;&#3585;&#3634;&#3624; 2 &#3623;&#3633;&#3609;&#3606;&#3633;&#3604;&#3652;&#3611;&#3594;&#3656;&#3623;&#3591;&#3648;&#3594;&#3657;&#3634;',0),(125523,3487,'hi','2 à¤¦à¤¿à¤µà¤¸ à¤¹à¤µà¤¾ à¤œà¤²à¥à¤¦à¥€ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥‚à¤',0),(125524,3487,'ms','2 hari udara awal pagi',0),(125525,3487,'ar','2nd Ø§Ù„ÙŠÙˆÙ… Ø§Ù„Ø¬ÙˆÙŠ Ø§Ù„Ù…Ø¨ÙƒØ± ÙˆØ£Ù†Ø§',0),(125526,3487,'fr','2e journÃ©e de l\'Air au dÃ©but suis',0),(125527,3487,'jp','ç¿Œã€…æ—¥æ—©æœ?é…?é€?',0),(125528,3487,'pt','2Âº ar de dia cedo estou',0),(125529,3487,'ru','2-Ð¹ Ð´ÐµÐ½ÑŒ Ð²Ð¾Ð·Ð´ÑƒÑ… Ñ€Ð°Ð½Ð¾ AM',0),(125530,3487,'es','Segundo DÃ­a por Correo AÃ©reo Temprano AM',0),(125531,3487,'de','2. Tag-Luft frÃ¼h bin',0),(125532,3487,'en','2nd Day Air Early AM',0),(125533,3488,'is','',0),(125534,3488,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ø³Ù‡ Ø±ÙˆØ² ',0),(125535,3488,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ø³Ù‡ Ø±ÙˆØ² ',0),(125536,3488,'tr','3 gÃ¼n SeÃ§',0),(125537,3488,'pl','Wybierz dzieÅ„ 3',0),(125538,3488,'bg','3 Ð´ÐµÐ½ Ð¸Ð·Ð±Ð¾Ñ€',0),(125539,3488,'ur','3 Ø¯Ù† Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(125540,3488,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ 3 Ð´Ð°Ð½Ð°',0),(125541,3488,'vi','Chá»n 3 ngÃ y',0),(125542,3488,'af','3 dag kies',0),(125543,3488,'ro','Ziua 3 SelectaÅ£i',0),(125544,3488,'et','3 pÃ¤ev valimine',0),(125545,3488,'si','Izberite 3 dan',0),(125546,3488,'ba','Pilih 3 hari',0),(125547,3488,'nl','3-daags selecteren',0),(125548,3488,'fi','3 pÃ¤ivÃ¤Ã¤ Valitse',0),(125549,3488,'no','3 dagers Velg',0),(125550,3488,'da','3 dage VÃ¦lg',0),(125551,3488,'ko','3 ì¼ ì„ íƒ',0),(125552,3488,'he','3 ×™×•× ×‘×—×™×¨×”',0),(125553,3488,'el','3Î®Î¼ÎµÏÎ· ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ',0),(125554,3488,'zh','3æ—¥é€‰æ‹©\r\n',0),(125555,3488,'sv','3-dagars VÃ¤lj',0),(125556,3488,'it','Selezionare giorno 3',0),(125557,3488,'tl','',0),(125558,3488,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656; 3',0),(125559,3488,'hi','3 à¤¦à¤¿à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(125560,3488,'ms','Pilih 3 hari',0),(125561,3488,'ar','Ø­Ø¯Ø¯ ÙŠÙˆÙ… 3',0),(125562,3488,'fr','Jour 3 Select',0),(125563,3488,'jp','3æ—¥é?¸æŠž',0),(125564,3488,'pt','Selecione dia 3',0),(125565,3488,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ 3 Ð´Ð½Ñ',0),(125566,3488,'es','3 DÃ­as Seleccionar',0),(125567,3488,'de','3 Tag auswÃ¤hlen',0),(125568,3488,'en','3 Day Select',0),(125569,3489,'is','',0),(125570,3489,'dr','Err:509',0),(125571,3489,'pr','-Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ÙƒØ§Ù†Ø§Ø¯Ø§ \r\nØ´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ ',0),(125572,3489,'tr','Kanada standart',0),(125573,3489,'pl','Kanada Standard',0),(125574,3489,'bg','ÐšÐ°Ð½Ð°Ð´Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚',0),(125575,3489,'ur','Ú©ÛŒÙ†ÛŒÚˆØ§ Ú©Û’ Ù…Ø¹ÛŒØ§Ø±',0),(125576,3489,'sr','ÐšÐ°Ð½Ð°Ð´Ð° Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´',0),(125577,3489,'vi','TiÃªu chuáº©n Canada',0),(125578,3489,'af','Kanada Standaard',0),(125579,3489,'ro','Canada Standard',0),(125580,3489,'et','Kanada standardi',0),(125581,3489,'si','Kanada Standard',0),(125582,3489,'ba','Standar Kanada',0),(125583,3489,'nl','Canada standaard',0),(125584,3489,'fi','Kanada standardi',0),(125585,3489,'no','Canada Standard',0),(125586,3489,'da','Canada Standard',0),(125587,3489,'ko','ìºë‚˜ë‹¤ í‘œì¤€',0),(125588,3489,'he','×ª×§×Ÿ ×§× ×“×”',0),(125589,3489,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ Ï„Î¿Ï… ÎšÎ±Î½Î±Î´Î¬',0),(125590,3489,'zh','åŠ æ‹¿å¤§æ ‡å‡†\r\n',0),(125591,3489,'sv','Kanada Standard',0),(125592,3489,'it','Canada Standard',0),(125593,3489,'tl','',0),(125594,3489,'th','&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3611;&#3619;&#3632;&#3648;&#3607;&#3624;&#3649;&#3588;&#3609;&#3634;&#3604;&#3634;',0),(125595,3489,'hi','à¤•à¤¨à¤¾à¤¡à¤¾ à¤®à¤¾à¤¨à¤•',0),(125596,3489,'ms','Standard Amerika Syarikat',0),(125597,3489,'ar','Ù…Ø¹ÙŠØ§Ø± ÙƒÙ†Ø¯Ø§',0),(125598,3489,'fr','Canada Standard',0),(125599,3489,'jp','ã‚«ãƒŠãƒ€æ¨™æº–',0),(125600,3489,'pt','PadrÃ£o de CanadÃ¡',0),(125601,3489,'ru','ÐšÐ°Ð½Ð°Ð´Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚',0),(125602,3489,'es','CanadÃ¡ EstÃ¡ndar',0),(125603,3489,'de','Kanada Standard',0),(125604,3489,'en','Canada Standard',0),(125605,3490,'is','',0),(125606,3490,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø³Ø±ÙŠØ¹ Ø§Ù„Ø³ÙŠØ±',0),(125607,3490,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø³Ø±ÙŠØ¹ Ø§Ù„Ø³ÙŠØ±',0),(125608,3490,'tr','DÃ¼nya Ã§apÄ±nda hÄ±zlÄ±',0),(125609,3490,'pl','Na caÅ‚ym Å›wiecie Express',0),(125610,3490,'bg','ÐŸÐ¾ ÑÐ²ÐµÑ‚Ð° Ð•ÐºÑÐ¿Ñ€ÐµÑ',0),(125611,3490,'ur','Ø¯Ù†ÛŒØ§ Ø¨Ú¾Ø± Ù…ÛŒÚº Ø§ÛŒÚ©Ø³Ù¾Ø±ÛŒØ³',0),(125612,3490,'sr','Ð¨Ð¸Ñ€Ð¾Ð¼ ÑÐ²ÐµÑ‚Ð° Ð•xÐ¿Ñ€ÐµÑÑ',0),(125613,3490,'vi','PhÃ¡t chuyá»ƒn nhanh toÃ n cáº§u',0),(125614,3490,'af','WÃªreldwyd Express',0),(125615,3490,'ro','Worldwide Express',0),(125616,3490,'et','Kogu maailmas kiire',0),(125617,3490,'si','Worldwide Express',0),(125618,3490,'ba','Express di seluruh dunia',0),(125619,3490,'nl','Worldwide Express',0),(125620,3490,'fi','Maailmanlaajuisesti Nopea',0),(125621,3490,'no','Verdensomspennende Express',0),(125622,3490,'da','Worldwide Express',0),(125623,3490,'ko','ì „ì„¸ê³„ ìµìŠ¤í”„ë ˆìŠ¤',0),(125624,3490,'he','××§×¡×¤×¨×¡ ×‘×¨×—×‘×™ ×”×¢×•×œ×',0),(125625,3490,'el','Î£Îµ Ï€Î±Î³ÎºÏŒÏƒÎ¼Î¹Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Express',0),(125626,3490,'zh','å›½é™…å¿«é€’\r\n',0),(125627,3490,'sv','Worldwide Express',0),(125628,3490,'it','Express in tutto il mondo',0),(125629,3490,'tl','',0),(125630,3490,'th','Worldwide Express',0),(125631,3490,'hi','à¤¦à¥à¤¨à¤¿à¤¯à¤¾ à¤­à¤° à¤®à¥‡à¤‚ à¤à¤•à¥à¤¸à¤ªà¥à¤°à¥‡à¤¸',0),(125632,3490,'ms','Express di seluruh dunia',0),(125633,3490,'ar','Ø¥ÙƒØ³Ø¨Ø±ÙŠØ³ ÙÙŠ Ø¬Ù…ÙŠØ¹ Ø£Ù†Ø­Ø§Ø¡ Ø§Ù„Ø¹Ø§Ù„Ù…',0),(125634,3490,'fr','Express dans le monde entier',0),(125635,3490,'jp','ãƒ¯ãƒ¼ãƒ«ãƒ‰ãƒ¯ã‚¤ãƒ‰ã‚¨ã‚¯ã‚¹ãƒ—ãƒ¬ã‚¹',0),(125636,3490,'pt','Worldwide Express',0),(125637,3490,'ru','Ð’Ð¾ Ð²ÑÐµÐ¼ Ð¼Ð¸Ñ€Ðµ Ð­ÐºÑÐ¿Ñ€ÐµÑÑ',0),(125638,3490,'es','Express Global',0),(125639,3490,'de','Weltweit Express',0),(125640,3490,'en','Worldwide Express',0),(125641,3491,'is','',0),(125642,3491,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù¾Ø³Øª Ø³Ø±ÙŠØ¹ Ø§Ù„Ø³ÙŠØ± Ø¬Ù‡Ø§Ù†ÙŠ',0),(125643,3491,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù¾Ø³Øª Ø³Ø±ÙŠØ¹ Ø§Ù„Ø³ÙŠØ± Ø¬Ù‡Ø§Ù†ÙŠ',0),(125644,3491,'tr','DÃ¼nya Ã§apÄ±nda hÄ±zlÄ± artÄ±',0),(125645,3491,'pl','Na caÅ‚ym Å›wiecie Express Plus',0),(125646,3491,'bg','ÐŸÐ¾ ÑÐ²ÐµÑ‚Ð° Ð¸Ð·Ñ€Ð¸Ñ‡Ð½Ð¾ Ð¿Ð»ÑŽÑ',0),(125647,3491,'ur','Ø¯Ù†ÛŒØ§ Ø¨Ú¾Ø± Ù…ÛŒÚº Ø§ÛŒÚ©Ø³Ù¾Ø±ÛŒØ³ Ù¾Ù„Ø³',0),(125648,3491,'sr','Ð¨Ð¸Ñ€Ð¾Ð¼ ÑÐ²ÐµÑ‚Ð° Ð•ÐºÑÐ¿Ñ€ÐµÑ ÐŸÐ»ÑƒÑ',0),(125649,3491,'vi','PhÃ¡t chuyá»ƒn nhanh toÃ n cáº§u thÃªm',0),(125650,3491,'af','Worldwide Express Plus',0),(125651,3491,'ro','La nivel mondial de Plus expres',0),(125652,3491,'et','Kogu maailmas kiire Plus',0),(125653,3491,'si','Worldwide Express Plus',0),(125654,3491,'ba','Plus Check di seluruh dunia',0),(125655,3491,'nl','Wereldwijde Express Plus',0),(125656,3491,'fi','Maailmanlaajuinen Express Plus',0),(125657,3491,'no','Verdensomspennende Express pluss',0),(125658,3491,'da','Worldwide Express Plus',0),(125659,3491,'ko','ì „ì„¸ê³„ íŠ¹ê¸‰ í”ŒëŸ¬ìŠ¤',0),(125660,3491,'he','×¤×œ×•×¡ ××§×¡×¤×¨×¡ ×‘×¨×—×‘×™ ×”×¢×•×œ×',0),(125661,3491,'el','Î£Îµ Ï€Î±Î³ÎºÏŒÏƒÎ¼Î¹Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ ÏÎ·Ï„Î® ÏƒÏ…Î½',0),(125662,3491,'zh','å…¨çƒç‰¹å¿«åŠ \r\n',0),(125663,3491,'sv','Worldwide Express Plus',0),(125664,3491,'it','Plus espresso in tutto il mondo',0),(125665,3491,'tl','',0),(125666,3491,'th','Worldwide Express Plus',0),(125667,3491,'hi','à¤¦à¥à¤¨à¤¿à¤¯à¤¾ à¤­à¤° à¤®à¥‡à¤‚ à¤µà¥à¤¯à¤•à¥à¤¤ à¤ªà¥à¤²à¤¸',0),(125668,3491,'ms','Plus Daftar di seluruh dunia',0),(125669,3491,'ar','ÙÙŠ Ø¬Ù…ÙŠØ¹ Ø£Ù†Ø­Ø§Ø¡ Ø§Ù„Ø¹Ø§Ù„Ù… Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø§Ù„ØªØ¹Ø¨ÙŠØ± Ø¹Ù†',0),(125670,3491,'fr','Worldwide Express Plus',0),(125671,3491,'jp','ãƒ¯ãƒ¼ãƒ«ãƒ‰ãƒ¯ã‚¤ãƒ‰ã‚¨ã‚¯ã‚¹ãƒ—ãƒ¬ã‚¹ãƒ—ãƒ©ã‚¹',0),(125672,3491,'pt','Worldwide Express Plus',0),(125673,3491,'ru','Ð’Ð¾ Ð²ÑÐµÐ¼ Ð¼Ð¸Ñ€Ðµ Ð­ÐºÑÐ¿Ñ€ÐµÑÑ Ð¿Ð»ÑŽÑ',0),(125674,3491,'es','Express Global Plus',0),(125675,3491,'de','Weltweit Express Plus',0),(125676,3491,'en','Worldwide Express Plus',0),(125677,3492,'is','',0),(125678,3492,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ù¾ÙŠØ´ØªØ§Ø² Ø¯Ø± Ø³Ø·Ø­ Ø¬Ù‡Ø§Ù†ÙŠ',0),(125679,3492,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ù¾ÙŠØ´ØªØ§Ø² Ø¯Ø± Ø³Ø·Ø­ Ø¬Ù‡Ø§Ù†ÙŠ',0),(125680,3492,'tr','DÃ¼nya Ã§apÄ±nda hÄ±zlandÄ±rÄ±lmÄ±ÅŸ',0),(125681,3492,'pl','Na caÅ‚ym Å›wiecie przyspieszone',0),(125682,3492,'bg','ÐŸÐ¾ ÑÐ²ÐµÑ‚Ð° ÑƒÑÐºÐ¾Ñ€ÐµÐ½Ð¾',0),(125683,3492,'ur','Ø¯Ù†ÛŒØ§ Ø¨Ú¾Ø± Ù…ÛŒÚº Ø§Ù†ØªØ®Ø§Ø¨ÛŒ',0),(125684,3492,'sr','Ð£ ÑÐ²ÐµÑ‚Ñƒ ÑƒÐ±Ñ€Ð·Ð°',0),(125685,3492,'vi','Nhanh toÃ n cáº§u',0),(125686,3492,'af','Worldwide Expedited',0),(125687,3492,'ro','ÃŽn Ã®ntreaga lume accelerate',0),(125688,3492,'et','Kogu maailmas kiirendatud',0),(125689,3492,'si','Po vsem svetu pospeÅ¡ene',0),(125690,3492,'ba','Dipercepat di seluruh dunia',0),(125691,3492,'nl','Wereldwijd versnelde',0),(125692,3492,'fi','Maailmanlaajuisesti nopeutetussa',0),(125693,3492,'no','Worldwide rask',0),(125694,3492,'da','PÃ¥ verdensplan fremskyndet',0),(125695,3492,'ko','ì „ì„¸ê³„ ì‹ ì†',0),(125696,3492,'he','×‘×¨×—×‘×™ ×”×¢×•×œ× ×ž×–×•×¨×–',0),(125697,3492,'el','Î¤Î±Ï‡ÎµÎ¯Î± ÏƒÎµ ÏŒÎ»Î¿ Ï„Î¿Î½ ÎºÏŒÏƒÎ¼Î¿',0),(125698,3492,'zh','å…¨çƒå¿«æ·\r\n',0),(125699,3492,'sv','VÃ¤rlden Ã¶ver expedierade',0),(125700,3492,'it','Accelerato in tutto il mondo',0),(125701,3492,'tl','',0),(125702,3492,'th','Worldwide Expedited',0),(125703,3492,'hi','à¤¦à¥à¤¨à¤¿à¤¯à¤¾ à¤­à¤° à¤®à¥‡à¤‚ à¤¶à¥€à¤˜à¥à¤°',0),(125704,3492,'ms','Di seluruh dunia dipercepatkan',0),(125705,3492,'ar','Ø§Ù„Ø¥Ø³Ø±Ø§Ø¹ ÙÙŠ Ø¬Ù…ÙŠØ¹ Ø£Ù†Ø­Ø§Ø¡ Ø§Ù„Ø¹Ø§Ù„Ù…',0),(125706,3492,'fr','AccÃ©lÃ©rÃ© dans le monde entier',0),(125707,3492,'jp','ãƒ¯ãƒ¼ãƒ«ãƒ‰ãƒ¯ã‚¤ãƒ‰é€Ÿé?”',0),(125708,3492,'pt','Acelerada em todo o mundo',0),(125709,3492,'ru','Ð’Ð¾ Ð²ÑÐµÐ¼ Ð¼Ð¸Ñ€Ðµ ÑƒÑÐºÐ¾Ñ€ÐµÐ½Ð½Ñ‹Ñ…',0),(125710,3492,'es','Global Expedito',0),(125711,3492,'de','Weltweit beschleunigt',0),(125712,3492,'en','Worldwide Expedited',0),(125713,3493,'is','',0),(125714,3493,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ Ø±ÙˆØ²Ø§Ù†Ù‡ Ù…Ù†Ø¸Ù… ',0),(125715,3493,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ Ø±ÙˆØ²Ø§Ù†Ù‡ Ù…Ù†Ø¸Ù… ',0),(125716,3493,'tr','Normal gÃ¼nlÃ¼k pikap',0),(125717,3493,'pl','Regularne codzienne Pickup',0),(125718,3493,'bg','Ð ÐµÐ´Ð¾Ð²Ð½Ð¸ ÐµÐ¶ÐµÐ´Ð½ÐµÐ²Ð½Ð¸ Ð¿Ð¸ÐºÐ°Ð¿',0),(125719,3493,'ur','Ø¨Ø§Ù‚Ø§Ø¹Ø¯Û Ø±ÙˆØ²Ø§Ù†Û Ø§Ù¹Ú¾Ø§ Ù„ÛŒÙ†Ø§',0),(125720,3493,'sr','Ð ÐµÐ´Ð¾Ð²Ð½Ðµ Ð´Ð½ÐµÐ²Ð½Ðµ Ð¿Ð¸ÐºÐ°Ð¿',0),(125721,3493,'vi','Äáº¿n nháº­n hÃ ng ngÃ y',0),(125722,3493,'af','Gereelde daaglikse bakkie',0),(125723,3493,'ro','Pickup zilnice regulate',0),(125724,3493,'et','Regulaarne igapÃ¤evane pikap',0),(125725,3493,'si','Redni dnevni Pickup',0),(125726,3493,'ba','Rutin harian Pickup',0),(125727,3493,'nl','Regelmatige dagelijkse Pickup',0),(125728,3493,'fi','SÃ¤Ã¤nnÃ¶llinen pÃ¤ivittÃ¤inen Pickup',0),(125729,3493,'no','Vanlige daglige Pickup',0),(125730,3493,'da','RegelmÃ¦ssig daglig afhentning',0),(125731,3493,'ko','ì •ê¸°ì ìœ¼ë¡œ ë§¤ì¼ í”½ì—…',0),(125732,3493,'he','××™×¡×•×£ ×™×•×ž×™ ×¨×’×™×œ',0),(125733,3493,'el','Î¤Î±ÎºÏ„Î¹ÎºÎ® ÎºÎ±Î¸Î·Î¼ÎµÏÎ¹Î½Î® Ï€Î±ÏÎ±Î»Î±Î²Î®',0),(125734,3493,'zh','æ¯å¤©å®šæ—¶æŽ¥é€\r\n',0),(125735,3493,'sv','Regelbundna dagliga Pickup',0),(125736,3493,'it','Prelievo giornaliero regolare',0),(125737,3493,'tl','',0),(125738,3493,'th','&#3611;&#3585;&#3605;&#3636;&#3610;&#3619;&#3619;&#3607;&#3640;&#3585;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;',0),(125739,3493,'hi','à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ à¤¦à¥ˆà¤¨à¤¿à¤• à¤¬à¤Ÿà¥‹à¤°à¤¨à¤¾',0),(125740,3493,'ms','Pikap harian biasa',0),(125741,3493,'ar','Ø¨ÙŠÙƒ Ø¢Ø¨ Ø§Ù„ÙŠÙˆÙ…ÙŠØ© Ø§Ù„Ø¹Ø§Ø¯ÙŠØ©',0),(125742,3493,'fr','Ramassage quotidien rÃ©gulier',0),(125743,3493,'jp','å®šæœŸæ—¥æ¯Žå?Žé›†',0),(125744,3493,'pt','Coleta diÃ¡ria regular',0),(125745,3493,'ru','Ð ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ñ‹Ðµ ÐµÐ¶ÐµÐ´Ð½ÐµÐ²Ð½Ñ‹Ðµ Ð¿Ð¸ÐºÐ°Ð¿',0),(125746,3493,'es','Recogida Diario Regular',0),(125747,3493,'de','RegelmÃ¤ÃŸige tÃ¤gliche Abholung',0),(125748,3493,'en','Regular Daily Pickup',0),(125749,3494,'is','',0),(125750,3494,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø¨Ù†Ø§ Ø¨Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡ÙˆØ§ÙŠÙŠ',0),(125751,3494,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø¨Ù†Ø§ Ø¨Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡ÙˆØ§ÙŠÙŠ',0),(125752,3494,'tr','Ã‡aÄŸrÄ± canlÄ± yayÄ±nda',0),(125753,3494,'pl','Na wezwanie powietrza',0),(125754,3494,'bg','ÐÐ° Ð¿Ð¾Ð²Ð¸ÐºÐ²Ð°Ð½Ðµ Ð²ÑŠÐ·Ð´ÑƒÑ…',0),(125755,3494,'ur','Ú©Ø§Ù„ ÛÙˆØ§ Ù¾Ø±',0),(125756,3494,'sr','ÐÐ° Ð¿Ð¾Ð·Ð¸Ð² Ð²Ð°Ð·Ð´ÑƒÑ…',0),(125757,3494,'vi','Äá»£i gá»i hÃ ng mÃ¡y bay',0),(125758,3494,'af','Op die oproep lug',0),(125759,3494,'ro','Apel aer',0),(125760,3494,'et','KÃµne eetris',0),(125761,3494,'si','Na klic zraka',0),(125762,3494,'ba','Di udara panggilan',0),(125763,3494,'nl','Op oproep lucht',0),(125764,3494,'fi','Puhelun Air',0),(125765,3494,'no','PÃ¥ samtalen Air',0),(125766,3494,'da','PÃ¥ opfordring luft',0),(125767,3494,'ko','ì „í™” ë°©ì†¡',0),(125768,3494,'he','×¢×œ ×”×©×™×—×” ××•×•×™×¨',0),(125769,3494,'el','Î£Ï„Î¿Î½ Î±Î­ÏÎ± ÎºÎ»Î®ÏƒÎ·',0),(125770,3494,'zh','åœ¨å‘¼å«ç©ºè¿\r\n',0),(125771,3494,'sv','Kalla luften',0),(125772,3494,'it','Su chiamata Air',0),(125773,3494,'tl','',0),(125774,3494,'th','&#3648;&#3619;&#3637;&#3618;&#3585;&#3629;&#3629;&#3585;&#3629;&#3634;&#3585;&#3634;&#3624;',0),(125775,3494,'hi','à¤•à¥‰à¤² à¤¹à¤µà¤¾ à¤ªà¤°',0),(125776,3494,'ms','Panggilan udara',0),(125777,3494,'ar','Ø¹Ù„Ù‰ Ø§Ù„Ù‡ÙˆØ§Ø¡ Ù…ÙƒØ§Ù„Ù…Ø©',0),(125778,3494,'fr','Sur appel Air',0),(125779,3494,'jp','ã‚ªãƒ³ã‚³ãƒ¼ãƒ«é…?é€?',0),(125780,3494,'pt','Na chamada ar',0),(125781,3494,'ru','ÐÐ° Ð²Ð¾Ð·Ð´ÑƒÑ…Ðµ Ð²Ñ‹Ð·Ð¾Ð²Ð°',0),(125782,3494,'es','Correo AÃ©reo en Espera',0),(125783,3494,'de','Aufruf Ministries',0),(125784,3494,'en','On Call Air',0),(125785,3495,'is','',0),(125786,3495,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨Ù‡ Ù…ÙˆÙ‚Ø¹',0),(125787,3495,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨Ù‡ Ù…ÙˆÙ‚Ø¹',0),(125788,3495,'tr','Bir kez kamyonet',0),(125789,3495,'pl','Jeden czas odbioru',0),(125790,3495,'bg','Ð•Ð´Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð¿Ð¸ÐºÐ°Ð¿',0),(125791,3495,'ur','Ø§ÛŒÚ© Ø¨Ø§Ø± Ø§Ù¹Ú¾Ø§ Ù„ÛŒÙ†Ø§',0),(125792,3495,'sr','ÐˆÐµÐ´Ð°Ð½ Ð¿ÑƒÑ‚ Ð¿Ð¸ÐºÐ°Ð¿',0),(125793,3495,'vi','Äáº¿n nháº­n 1 láº§n',0),(125794,3495,'af','Een keer bakkie',0),(125795,3495,'ro','Un timp Pickup',0),(125796,3495,'et','Ãœks kord pikap',0),(125797,3495,'si','En Äas Pickup',0),(125798,3495,'ba','Satu waktu Pickup',0),(125799,3495,'nl','Ã‰Ã©n keer ophalen',0),(125800,3495,'fi','Yksi aika Pickup',0),(125801,3495,'no','Ettall tid Pickup',0),(125802,3495,'da','Ã‰n gang Pickup',0),(125803,3495,'ko','í•œ ì‹œê°„ í”½ì—…',0),(125804,3495,'he','×–×ž×Ÿ ×©×§×˜',0),(125805,3495,'el','ÎˆÎ½Î± Ï‡ÏÏŒÎ½Î¿ Pickup',0),(125806,3495,'zh','ä¸€è¯æ€§æè´§\r\n',0),(125807,3495,'sv','En tid Pickup',0),(125808,3495,'it','Una volta Pickup',0),(125809,3495,'tl','',0),(125810,3495,'th','&#3610;&#3619;&#3619;&#3607;&#3640;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;&#3648;&#3604;&#3637;&#3618;&#3623;',0),(125811,3495,'hi','à¤à¤• à¤¬à¤¾à¤° à¤°à¤‚à¤¡à¥€',0),(125812,3495,'ms','Satu masa pikap',0),(125813,3495,'ar','Ø¨ÙŠÙƒ Ø¢Ø¨ Ù…Ø±Ø© ÙˆØ§Ø­Ø¯Ø©',0),(125814,3495,'fr','Un enclenchement de temps',0),(125815,3495,'jp','ä¸€æ‹¬å?Žé›†',0),(125816,3495,'pt','Um tempo Pickup',0),(125817,3495,'ru','ÐžÐ´Ð¸Ð½ Ñ€Ð°Ð· Ð¿Ð¸ÐºÐ°Ð¿',0),(125818,3495,'es','Recogida de Una Vez',0),(125819,3495,'de','Ein Zeit-Pickup',0),(125820,3495,'en','One Time Pickup',0),(125821,3496,'is','',0),(125822,3496,'dr','Ù…Ø±ÙƒØ² Ù†Ø§Ù…Ù‡ Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ',0),(125823,3496,'pr','Ù…Ø±ÙƒØ² Ù†Ø§Ù…Ù‡ Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ',0),(125824,3496,'tr','Mektup Merkezi',0),(125825,3496,'pl','List centrum',0),(125826,3496,'bg','ÐŸÐ¸ÑÐ¼Ð¾ Ñ†ÐµÐ½Ñ‚ÑŠÑ€',0),(125827,3496,'ur','Ø®Ø· Ù…Ø±Ú©Ø²',0),(125828,3496,'sr','ÐŸÐ¸ÑÐ¼Ð¾ Ñ†ÐµÐ½Ñ‚Ñ€Ð°',0),(125829,3496,'vi','Trung tÃ¢n thÆ°',0),(125830,3496,'af','Brief Sentrum',0),(125831,3496,'ro','Scrisoarea centrului',0),(125832,3496,'et','TÃ¤he keskus',0),(125833,3496,'si','Pismo Center',0),(125834,3496,'ba','Pusat surat',0),(125835,3496,'nl','Brief Center',0),(125836,3496,'fi','Kirjeen Center',0),(125837,3496,'no','Brev Center',0),(125838,3496,'da','Brev Center',0),(125839,3496,'ko','íŽ¸ì§€ ì„¼í„°',0),(125840,3496,'he','×ž×›×ª×‘ ×ž×¨×›×–',0),(125841,3496,'el','Î•Ï€Î¹ÏƒÏ„Î¿Î»Î® ÎºÎ­Î½Ï„ÏÎ¿',0),(125842,3496,'zh','ä¿¡ä»¶ä¸­å¿ƒ\r\n',0),(125843,3496,'sv','Brev Center',0),(125844,3496,'it','Lettera centro',0),(125845,3496,'tl','',0),(125846,3496,'th','&#3624;&#3641;&#3609;&#3618;&#3660;&#3619;&#3623;&#3617;&#3605;&#3633;&#3623;&#3629;&#3633;&#3585;&#3625;&#3619;',0),(125847,3496,'hi','à¤ªà¤¤à¥à¤° à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(125848,3496,'ms','Pusat Surat',0),(125849,3496,'ar','Ù…Ø±ÙƒØ² Ø§Ù„Ø±Ø³Ø§Ù„Ø©',0),(125850,3496,'fr','Lettre Center',0),(125851,3496,'jp','æ‰‹ç´™ã‚»ãƒ³ã‚¿ãƒ¼',0),(125852,3496,'pt','Carta centro',0),(125853,3496,'ru','ÐŸÐ¸ÑÑŒÐ¼Ð¾ Ñ†ÐµÐ½Ñ‚Ñ€',0),(125854,3496,'es','Centro de Cartas',0),(125855,3496,'de','Buchstaben Center',0),(125856,3496,'en','Letter Center',0),(125857,3497,'is','',0),(125858,3497,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø´Ù…Ø§Ø±Ø´Ú¯Ø± Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(125859,3497,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø´Ù…Ø§Ø±Ø´Ú¯Ø± Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(125860,3497,'tr','MÃ¼ÅŸteri sayacÄ±',0),(125861,3497,'pl','Licznik klientÃ³w',0),(125862,3497,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð±Ñ€Ð¾ÑÑ‡',0),(125863,3497,'ur','Ú¯Ø§ÛÚ© Ú©Ø§ Ù…Ù‚Ø§Ø¨Ù„Û',0),(125864,3497,'sr','Ð‘Ñ€Ð¾Ñ˜Ð°Ñ‡ ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(125865,3497,'vi','Quáº§y khÃ¡ch hÃ ng',0),(125866,3497,'af','KliÃ«nt toonbank',0),(125867,3497,'ro','Client Counter',0),(125868,3497,'et','Kliendi loendur',0),(125869,3497,'si','Kupec Counter',0),(125870,3497,'ba','Counter pelanggan',0),(125871,3497,'nl','Klant teller',0),(125872,3497,'fi','Asiakas Counter',0),(125873,3497,'no','Kunden Counter',0),(125874,3497,'da','Kunde Counter',0),(125875,3497,'ko','ê³ ê° ì¹´ìš´í„°',0),(125876,3497,'he','×œ×§×•×— ×ž×•× ×”',0),(125877,3497,'el','ÎœÎµÏ„ÏÎ·Ï„Î® Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(125878,3497,'zh','å®¢æˆ·è®¡æ•°å™¨\r\n',0),(125879,3497,'sv','Kunden Counter',0),(125880,3497,'it','Contatore del cliente',0),(125881,3497,'tl','',0),(125882,3497,'th','&#3612;&#3641;&#3657;&#3609;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(125883,3497,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾à¤‰à¤‚à¤Ÿà¤°',0),(125884,3497,'ms','Kaunter pelanggan',0),(125885,3497,'ar','Ù…ÙˆØ§Ø¬Ù‡Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(125886,3497,'fr','Comptoir Ã  la clientÃ¨le',0),(125887,3497,'jp','é¡§å®¢ã‚«ã‚¦ãƒ³ã‚¿ãƒ¼',0),(125888,3497,'pt','Contador do cliente',0),(125889,3497,'ru','Ð¡Ñ‡ÐµÑ‚Ñ‡Ð¸Ðº Ð·Ð°ÐºÐ°Ð·Ñ‡Ð¸ÐºÐ°',0),(125890,3497,'es','Contador de Cliente',0),(125891,3497,'de','Kunden-Counter',0),(125892,3497,'en','Customer Counter',0),(125893,3498,'is','',0),(125894,3498,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ ØªØ¬Ø§Ø±ÙŠ',0),(125895,3498,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ ØªØ¬Ø§Ø±ÙŠ',0),(125896,3498,'tr','Ticari',0),(125897,3498,'pl','Handlowych',0),(125898,3498,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸',0),(125899,3498,'ur','ØªØ¬Ø§Ø±ØªÛŒ',0),(125900,3498,'sr','ÐšÐ¾Ð¼ÐµÑ€Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸',0),(125901,3498,'vi','ThÆ°Æ¡ng máº¡i',0),(125902,3498,'af','KommersiÃ«el',0),(125903,3498,'ro','Comerciale',0),(125904,3498,'et','Kaubik',0),(125905,3498,'si','Komercialni',0),(125906,3498,'ba','Komersial',0),(125907,3498,'nl','CommerciÃ«le',0),(125908,3498,'fi','Kaupallinen',0),(125909,3498,'no','Kommersielle',0),(125910,3498,'da','Kommercielle',0),(125911,3498,'ko','ìƒì—…',0),(125912,3498,'he','×ž×¡×—×¨×™',0),(125913,3498,'el','Î•Î¼Ï€Î¿ÏÎ¹ÎºÎ®',0),(125914,3498,'zh','å•†ä¸š\r\n',0),(125915,3498,'sv','Kommersiella',0),(125916,3498,'it','Commerciale',0),(125917,3498,'tl','',0),(125918,3498,'th','&#3648;&#3594;&#3636;&#3591;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(125919,3498,'hi','à¤µà¤¾à¤£à¤¿à¤œà¥à¤¯à¤¿à¤•',0),(125920,3498,'ms','Komersil',0),(125921,3498,'ar','Ø§Ù„ØªØ¬Ø§Ø±ÙŠ',0),(125922,3498,'fr','Commercial',0),(125923,3498,'jp','å•†æ¥­ç”¨',0),(125924,3498,'pt','Comercial',0),(125925,3498,'ru','ÐšÐ¾Ð¼Ð¼ÐµÑ€Ñ‡ÐµÑÐºÐ¸Ðµ',0),(125926,3498,'es','Comercial',0),(125927,3498,'de','Kommerzielle',0),(125928,3498,'en','Commercial',0),(125929,3499,'is','',0),(125930,3499,'dr','Ù…Ø³ÙƒÙˆÙ†ÙŠ',0),(125931,3499,'pr','Ù…Ø³ÙƒÙˆÙ†ÙŠ',0),(125932,3499,'tr','Konut',0),(125933,3499,'pl','Mieszkalnych',0),(125934,3499,'bg','Ð–Ð¸Ð»Ð¸Ñ‰Ð½Ð¸',0),(125935,3499,'ur','Ø±ÛØ§Ø¦Ø´ÛŒ',0),(125936,3499,'sr','Ð¡Ñ‚Ð°Ð¼Ð±ÐµÐ½Ð¸',0),(125937,3499,'vi','DÃ¢n cÆ°',0),(125938,3499,'af','ResidensieÃ«l',0),(125939,3499,'ro','Rezidential',0),(125940,3499,'et','Elamu',0),(125941,3499,'si','Stanovanjskih',0),(125942,3499,'ba','Perumahan',0),(125943,3499,'nl','ResidentiÃ«le',0),(125944,3499,'fi','Asuin',0),(125945,3499,'no','Bolig',0),(125946,3499,'da','Bolig',0),(125947,3499,'ko','ì£¼ê±°',0),(125948,3499,'he','×ž×’×•×¨×™×',0),(125949,3499,'el','ÎšÎ±Ï„Î¿Î¹ÎºÎ·Î¼Î­Î½Î·',0),(125950,3499,'zh','ä½å®…\r\n',0),(125951,3499,'sv','BostÃ¤der',0),(125952,3499,'it','Residenziale',0),(125953,3499,'tl','',0),(125954,3499,'th','&#3605;&#3635;&#3610;&#3621;',0),(125955,3499,'hi','à¤†à¤µà¤¾à¤¸à¥€à¤¯',0),(125956,3499,'ms','Kediaman',0),(125957,3499,'ar','Ø§Ù„Ø³ÙƒÙ†ÙŠØ©',0),(125958,3499,'fr','RÃ©sidentiel',0),(125959,3499,'jp','å±…ä½?ã?®',0),(125960,3499,'pt','Residencial',0),(125961,3499,'ru','Ð–Ð¸Ð»Ð¾Ð¹',0),(125962,3499,'es','Residencial',0),(125963,3499,'de','Wohn',0),(125964,3499,'en','Residential',0),(125965,3500,'is','',0),(125966,3500,'dr','Ù‡Ø± ÙƒØ§Ù„Ø§ ',0),(125967,3500,'pr','Ù‡Ø± ÙƒØ§Ù„Ø§ ',0),(125968,3500,'tr','Maddeye gÃ¶re',0),(125969,3500,'pl','Za sztukÄ™',0),(125970,3500,'bg','ÐÐ° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(125971,3500,'ur','Ø´Û’ ÙÛŒ',0),(125972,3500,'sr','ÐŸÐ¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ñƒ',0),(125973,3500,'vi','Má»—i hÃ ng',0),(125974,3500,'af','Per Item',0),(125975,3500,'ro','Fiecare element',0),(125976,3500,'et','Kauba kohta',0),(125977,3500,'si','Po artiklu',0),(125978,3500,'ba','Per Item',0),(125979,3500,'nl','Per Item',0),(125980,3500,'fi','Per nimike',0),(125981,3500,'no','Per vare',0),(125982,3500,'da','Pr. vare',0),(125983,3500,'ko','í•­ëª© ë‹¹',0),(125984,3500,'he','×œ×›×œ ×¤×¨×™×˜',0),(125985,3500,'el','Î‘Î½Î¬ ÎµÎ¯Î´Î¿Ï‚',0),(125986,3500,'zh','æ¯ä»¶\r\n',0),(125987,3500,'sv','Per artikel',0),(125988,3500,'it','Per ogni elemento',0),(125989,3500,'tl','',0),(125990,3500,'th','&#3605;&#3656;&#3629;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(125991,3500,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¤à¤¿',0),(125992,3500,'ms','Setiap perkara',0),(125993,3500,'ar','Ù„ÙƒÙ„ ØµÙ†Ù',0),(125994,3500,'fr','Par article',0),(125995,3500,'jp','å“?ç›®ã?«ã?¤ã??',0),(125996,3500,'pt','Por Item',0),(125997,3500,'ru','Ð—Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(125998,3500,'es','Por Item',0),(125999,3500,'de','Pro StÃ¼ck',0),(126000,3500,'en','Per Item',0),(126001,3501,'is','',0),(126002,3501,'dr','Ù†Ø±Ø® Ø«Ø§Ø¨Øª',0),(126003,3501,'pr','Ù†Ø±Ø® Ø«Ø§Ø¨Øª',0),(126004,3501,'tr','Sabit oran',0),(126005,3501,'pl','Stawka ryczaÅ‚towa',0),(126006,3501,'bg','Ð•Ð´Ð¸Ð½Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(126007,3501,'ur','ÙÙ„ÛŒÙ¹ Ú©ÛŒ Ø´Ø±Ø­',0),(126008,3501,'sr','Ð¤Ð»Ð°Ñ‚ Ð Ð°Ñ‚Ðµ',0),(126009,3501,'vi','1 giÃ¡ ',0),(126010,3501,'af','Vaste Tarief',0),(126011,3501,'ro','ForfetarÄƒ',0),(126012,3501,'et','Kindlasummaline',0),(126013,3501,'si','PavÅ¡alno',0),(126014,3501,'ba','Flat Rate',0),(126015,3501,'nl','Forfaitaire',0),(126016,3501,'fi','KiinteÃ¤',0),(126017,3501,'no','Flat Rate',0),(126018,3501,'da','Faste',0),(126019,3501,'ko','ê³ ì • ìš”ê¸ˆ',0),(126020,3501,'he','×ª×¢×¨×™×£',0),(126021,3501,'el','Î‘Ï€Î¿ÎºÎ¿Ï€Î®',0),(126022,3501,'zh','ç»Ÿä¸€ç¨ŽçŽ‡\r\n',0),(126023,3501,'sv','Schablonbelopp',0),(126024,3501,'it','Forfettario',0),(126025,3501,'tl','',0),(126026,3501,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3649;&#3609;&#3623;&#3619;&#3634;&#3610;',0),(126027,3501,'hi','à¤¸à¤ªà¤¾à¤Ÿ à¤¦à¤°',0),(126028,3501,'ms','Kadar sama rata',0),(126029,3501,'ar','Ø³Ø¹Ø± Ù…ÙˆØ­Ø¯',0),(126030,3501,'fr','Taux fixe',0),(126031,3501,'jp','å?‡ä¸€æ–™é‡‘',0),(126032,3501,'pt','Taxa fixa',0),(126033,3501,'ru','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð°Ñ ÑÑ‚Ð°Ð²ÐºÐ°',0),(126034,3501,'es','Tasa Fija',0),(126035,3501,'de','Pauschale',0),(126036,3501,'en','Flat Rate',0),(126037,3502,'is','',0),(126038,3502,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ ',0),(126039,3502,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ ',0),(126040,3502,'tr','SipariÅŸ ayrÄ±ntÄ±larÄ±',0),(126041,3502,'pl','SzczegÃ³Å‚y zamÃ³wienia',0),(126042,3502,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(126043,3502,'ur','Ø¢Ø±ÚˆØ± ØªÙØ§ØµÛŒÙ„',0),(126044,3502,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(126045,3502,'vi','Chi tiáº¿t Ä‘Æ¡n hÃ ng',0),(126046,3502,'af','Bestelling Besonderhede',0),(126047,3502,'ro','Detalii comanda',0),(126048,3502,'et','Tellimuse Ã¼ksikasjad',0),(126049,3502,'si','Podrobnosti o naroÄilu',0),(126050,3502,'ba','Rincian pesanan',0),(126051,3502,'nl','Orderinformatie',0),(126052,3502,'fi','Tilaustiedot',0),(126053,3502,'no','Ordredetaljer',0),(126054,3502,'da','Ordreoplysninger',0),(126055,3502,'ko','ì£¼ë¬¸ ì •ë³´',0),(126056,3502,'he','×¤×¨×˜×™ ×”×–×ž× ×”',0),(126057,3502,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(126058,3502,'zh','è®¢å•æ˜Žç»†\r\n',0),(126059,3502,'sv','Orderdetaljer',0),(126060,3502,'it','Dettagli dell\'ordine',0),(126061,3502,'tl','',0),(126062,3502,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(126063,3502,'hi','à¤‘à¤°à¥à¤¡à¤° à¤µà¤¿à¤µà¤°à¤£',0),(126064,3502,'ms','Butir-butir pesanan',0),(126065,3502,'ar','ØªÙØ§ØµÙŠÙ„ ØªØ±ØªÙŠØ¨',0),(126066,3502,'fr','DÃ©tails de la commande',0),(126067,3502,'jp','æ³¨æ–‡ã?®è©³ç´°',0),(126068,3502,'pt','Detalhes do pedido',0),(126069,3502,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð—Ð°ÐºÐ°Ð·Ð°',0),(126070,3502,'es','Detalles de Pedido',0),(126071,3502,'de','Bestelldetails',0),(126072,3502,'en','Order Details',0),(126073,3503,'is','',0),(126074,3503,'dr','ØªØ¹Ø¯Ø§Ø¯  ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(126075,3503,'pr','ØªØ¹Ø¯Ø§Ø¯  ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(126076,3503,'tr','Ã–ÄŸe sayÄ±sÄ±',0),(126077,3503,'pl','Liczba elementÃ³w',0),(126078,3503,'bg','Ð‘Ñ€Ð¾Ð¹ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ',0),(126079,3503,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(126080,3503,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(126081,3503,'vi','Sá»‘ cá»§a hÃ ng',0),(126082,3503,'af','Aantal Items',0),(126083,3503,'ro','NumÄƒrul de articole',0),(126084,3503,'et','Ãœksuste arv',0),(126085,3503,'si','Å tevilo elementov',0),(126086,3503,'ba','Jumlah item',0),(126087,3503,'nl','Aantal Items',0),(126088,3503,'fi','Kohteiden mÃ¤Ã¤rÃ¤',0),(126089,3503,'no','Antall elementer',0),(126090,3503,'da','Antal varer',0),(126091,3503,'ko','í•­ëª© ìˆ˜',0),(126092,3503,'he','×ž×¡×¤×¨ ×”×¤×¨×™×˜×™×',0),(126093,3503,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(126094,3503,'zh','é¡¹ç›®æ•°é‡\r\n',0),(126095,3503,'sv','Antal objekt',0),(126096,3503,'it','Numero di elementi',0),(126097,3503,'tl','',0),(126098,3503,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(126099,3503,'hi','à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(126100,3503,'ms','Bilangan item',0),(126101,3503,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(126102,3503,'fr','Nombre d\'Ã©lÃ©ments',0),(126103,3503,'jp','å“?ç›®æ•°',0),(126104,3503,'pt','NÃºmero de itens',0),(126105,3503,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(126106,3503,'es','NÃºmero de items',0),(126107,3503,'de','Anzahl der Elemente',0),(126108,3503,'en','Number of Items',0),(126109,3504,'is','',0),(126110,3504,'dr','ØªØ¹Ø¯Ø§Ø¯  Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§',0),(126111,3504,'pr','ØªØ¹Ø¯Ø§Ø¯  Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§',0),(126112,3504,'tr','KutularÄ±',0),(126113,3504,'pl','Liczba pÃ³l',0),(126114,3504,'bg','Ð‘Ñ€Ð¾Ð¹ ÐºÐ°ÑˆÐ¾Ð½Ð¸',0),(126115,3504,'ur','Ø®Ø§Ù†ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(126116,3504,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¾ÐºÐ²Ð¸Ñ€Ð°',0),(126117,3504,'vi','Sá»‘ há»™p',0),(126118,3504,'af','Aantal Bokse',0),(126119,3504,'ro','NumÄƒrul de cutii',0),(126120,3504,'et','Kastide arv',0),(126121,3504,'si','Å tevilo Å¡katle',0),(126122,3504,'ba','Jumlah kotak',0),(126123,3504,'nl','Aantal dozen',0),(126124,3504,'fi','Laatikoiden lukumÃ¤Ã¤rÃ¤',0),(126125,3504,'no','Antall bokser',0),(126126,3504,'da','Antallet af kasser',0),(126127,3504,'ko','ìƒìžì˜ ìˆ˜',0),(126128,3504,'he','×ž×¡×¤×¨ ×”×ª×™×‘×•×ª',0),(126129,3504,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Ï„Ï‰Î½ Ï‡Î±ÏÏ„Î¿ÎºÎ¹Î²Ï‰Ï„Î¯Ï‰Î½',0),(126130,3504,'zh','ç›’æ•°\r\n',0),(126131,3504,'sv','Antal lÃ¥dor',0),(126132,3504,'it','Numero di scatole',0),(126133,3504,'tl','',0),(126134,3504,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(126135,3504,'hi','à¤¬à¤•à¥à¤¸à¥‡ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(126136,3504,'ms','Bilangan kotak',0),(126137,3504,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ù…Ø±Ø¨Ø¹Ø§Øª',0),(126138,3504,'fr','Nombre de boÃ®tes',0),(126139,3504,'jp','ç®±æ•°',0),(126140,3504,'pt','NÃºmero de caixas',0),(126141,3504,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÐ¾Ñ€Ð¾Ð±Ð¾Ðº',0),(126142,3504,'es','NÃºmero de Cajas',0),(126143,3504,'de','Anzahl der Boxen',0),(126144,3504,'en','Number of Boxes',0),(126145,3505,'is','',0),(126146,3505,'dr','Ø§Ø² ÙƒØ¯Ù¾Ø³ØªÙŠ',0),(126147,3505,'pr','Ø§Ø² ÙƒØ¯Ù¾Ø³ØªÙŠ',0),(126148,3505,'tr','ZIP Kodu',0),(126149,3505,'pl','Z kod pocztowy',0),(126150,3505,'bg','ÐžÑ‚ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(126151,3505,'ur','Ø²Ù¾ Ú©ÙˆÚˆ Ø³Û’',0),(126152,3505,'sr','Ð˜Ð· Ð¿Ð¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¾Ð³ Ð±Ñ€Ð¾Ñ˜Ð°',0),(126153,3505,'vi','Tá»« mÃ£ Zip',0),(126154,3505,'af','Vanaf Poskode',0),(126155,3505,'ro','De cod postal',0),(126156,3505,'et','Zip kood',0),(126157,3505,'si','Iz Zip kode',0),(126158,3505,'ba','Dari kode pos',0),(126159,3505,'nl','Van postcode',0),(126160,3505,'fi','Zip koodi',0),(126161,3505,'no','Fra postnummer',0),(126162,3505,'da','Fra postnummer',0),(126163,3505,'ko','ìš°íŽ¸ ë²ˆí˜¸ì—ì„œ',0),(126164,3505,'he','×ž×ž×™×§×•×“',0),(126165,3505,'el','Î‘Ï€ÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒ ÎºÏŽÎ´Î¹ÎºÎ±',0),(126166,3505,'zh','ä»Žé‚®æ”¿ç¼–ç \r\n',0),(126167,3505,'sv','FrÃ¥n postnummer',0),(126168,3505,'it','Da Cap',0),(126169,3505,'tl','',0),(126170,3505,'th','&#3592;&#3634;&#3585;&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;',0),(126171,3505,'hi','à¤œà¤¼à¤¿à¤ª à¤•à¥‹à¤¡ à¤¸à¥‡',0),(126172,3505,'ms','Dari Kod Zip',0),(126173,3505,'ar','Ù…Ù† Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(126174,3505,'fr','De Code postal',0),(126175,3505,'jp','éƒµä¾¿ç•ªå?·ã?‹ã‚‰',0),(126176,3505,'pt','De CEP',0),(126177,3505,'ru','ÐžÑ‚ Zip ÐºÐ¾Ð´',0),(126178,3505,'es','Del CÃ³digo Postal',0),(126179,3505,'de','Von Postleitzahl',0),(126180,3505,'en','From Zip Code',0),(126181,3506,'is','',0),(126182,3506,'dr','Ø¨Ø±Ø§ÙŠ ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(126183,3506,'pr','Ø¨Ø±Ø§ÙŠ ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(126184,3506,'tr','Kod zip',0),(126185,3506,'pl','Aby kod pocztowy',0),(126186,3506,'bg','Ð—Ð° Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(126187,3506,'ur','Ø²Ù¾ Ú©ÙˆÚˆ Ú©Û’',0),(126188,3506,'sr','Ð”Ð° Ð—Ð¸Ð¿ ÐºÐ¾Ð´Ð°',0),(126189,3506,'vi','MÃ£ Zip',0),(126190,3506,'af','Na Poskode',0),(126191,3506,'ro','SÄƒ Zip Code',0),(126192,3506,'et','ZIP kood',0),(126193,3506,'si','Za Zip kodo',0),(126194,3506,'ba','Untuk kode pos',0),(126195,3506,'nl','Zip Code',0),(126196,3506,'fi','Zip koodi',0),(126197,3506,'no','ZIP-kode',0),(126198,3506,'da','ZIP-koden',0),(126199,3506,'ko','ìš°íŽ¸ ì½”ë“œ',0),(126200,3506,'he','×›×“×™ ×ž×™×§×•×“',0),(126201,3506,'el','ÎÎ± Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(126202,3506,'zh','é‚®ç¼–\r\n',0),(126203,3506,'sv','Till postnummer',0),(126204,3506,'it','Di Zip codice',0),(126205,3506,'tl','',0),(126206,3506,'th','&#3606;&#3638;&#3591;&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;',0),(126207,3506,'hi','à¤œà¤¼à¤¿à¤ª à¤•à¥‹à¤¡ à¤•à¥‡ à¤²à¤¿à¤',0),(126208,3506,'ms','Untuk Zip kod',0),(126209,3506,'ar','Ù„Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(126210,3506,'fr','Pour le Code postal',0),(126211,3506,'jp','éƒµä¾¿ç•ªå?·ã?«',0),(126212,3506,'pt','Para CEP',0),(126213,3506,'ru','Ð”Ð»Ñ Zip ÐºÐ¾Ð´',0),(126214,3506,'es','Al CÃ³digo Postal',0),(126215,3506,'de','ZIP-Code',0),(126216,3506,'en','To Zip Code',0),(126217,3507,'is','',0),(126218,3507,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø­Ù…Ù„',0),(126219,3507,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø­Ù…Ù„',0),(126220,3507,'tr','AlÄ±ntÄ± nakliye',0),(126221,3507,'pl','WysyÅ‚ka cytat',0),(126222,3507,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(126223,3507,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø´Ù¾Ù†Ú¯',0),(126224,3507,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(126225,3507,'vi','BÃ¡o giÃ¡ váº­n chuyá»ƒn ',0),(126226,3507,'af','Versendingskwotasie',0),(126227,3507,'ro','Citat de transport maritim',0),(126228,3507,'et','Shipping Quote',0),(126229,3507,'si','Prevoz Citiraj',0),(126230,3507,'ba','Pengiriman kutipan',0),(126231,3507,'nl','Scheepvaart offerte',0),(126232,3507,'fi','Shipping Quote',0),(126233,3507,'no','Shipping tilbud',0),(126234,3507,'da','Shipping citat',0),(126235,3507,'ko','ë°°ì†¡ ê²¬ì ',0),(126236,3507,'he','×ž×©×œ×•×— ×”×¦×¢×ª ×ž×—×™×¨',0),(126237,3507,'el','Î Î±ÏÎ¬Î¸ÎµÏƒÎ· Î½Î±Ï…Ï„Î¹Î»Î¯Î±Ï‚',0),(126238,3507,'zh','èˆªè¿æŠ¥ä»·\r\n',0),(126239,3507,'sv','Frakt Offert',0),(126240,3507,'it','Preventivo di spedizione',0),(126241,3507,'tl','',0),(126242,3507,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(126243,3507,'hi','à¤¬à¥‹à¤²à¥€ à¤¨à¥Œà¤µà¤¹à¤¨',0),(126244,3507,'ms','Penghantaran Quote',0),(126245,3507,'ar','Ø¹Ø±Ø¶ Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø´Ø­Ù†',0),(126246,3507,'fr','Citation d\'expÃ©dition',0),(126247,3507,'jp','é…?é€?è¦‹ç©?ã‚Š',0),(126248,3507,'pt','CotaÃ§Ã£o de frete',0),(126249,3507,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(126250,3507,'es','CotizaciÃ³n de Transporte',0),(126251,3507,'de','Versand Zitat',0),(126252,3507,'en','Shipping Quote',0),(126253,3508,'is','',0),(126254,3508,'dr','Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø­Ù…Ù„',0),(126255,3508,'pr','Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø­Ù…Ù„',0),(126256,3508,'tr','AlÄ±ntÄ± nakliye geri gÃ¶nder',0),(126257,3508,'pl','WysÅ‚aÄ‡ wysyÅ‚ka cytat z powrotem',0),(126258,3508,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(126259,3508,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø´Ù¾Ù†Ú¯ ÙˆØ§Ù¾Ø³ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(126260,3508,'sr','ÐŸÐ¾ÑÐ»Ð°Ñ‚Ð¸ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(126261,3508,'vi','Gá»­i láº¡i bÃ¡o giÃ¡ váº­n chuyá»ƒn',0),(126262,3508,'af','Stuur Versendingkwotasie Terug',0),(126263,3508,'ro','Trimite Ã®napoi citat de transport maritim',0),(126264,3508,'et','Saada tagasi Shipping Quote',0),(126265,3508,'si','PoÅ¡lji nazaj prevoz Citiraj',0),(126266,3508,'ba','Mengirim kembali pengiriman kutipan',0),(126267,3508,'nl','Terug scheepvaart offerte verzenden',0),(126268,3508,'fi','LÃ¤hettÃ¤Ã¤ takaisin Shipping Quote',0),(126269,3508,'no','Sende tilbake Shipping tilbud',0),(126270,3508,'da','Sende tilbage Shipping citat',0),(126271,3508,'ko','ë‹¤ì‹œ ê²¬ì  ë°°ì†¡ ë³´ë‚¼',0),(126272,3508,'he','×œ×©×œ×•×— ×—×–×¨×” ×ž×©×œ×•×— ×”×¦×¢×ª ×ž×—×™×¨',0),(126273,3508,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Ï€Î¯ÏƒÏ‰ Ï€Î±ÏÎ¬Î¸ÎµÏƒÎ· Î½Î±Ï…Ï„Î¹Î»Î¯Î±Ï‚',0),(126274,3508,'zh','å‘å›žè£…è¿æŠ¥ä»·\r\n',0),(126275,3508,'sv','Skicka tillbaka frakt Offert',0),(126276,3508,'it','Inviare indietro preventivo di spedizione',0),(126277,3508,'tl','',0),(126278,3508,'th','&#3626;&#3656;&#3591;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3607;&#3637;&#3656;&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3617;&#3634;&#3586;&#3609;&#3626;&#3656;&#3591;&#3585;&#3621;&#3633;&#3610;&#3617;&#3634;',0),(126279,3508,'hi','à¤¬à¥‹à¤²à¥€ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¾à¤ªà¤¸ à¤­à¥‡à¤œ',0),(126280,3508,'ms','Menghantar kembali penghantaran Quote',0),(126281,3508,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø®Ù„ÙÙŠ Ø§Ù„Ø´Ø­Ù† Ø§Ù‚ØªØ¨Ø§Ø³',0),(126282,3508,'fr','Renvoyer devis d\'expÃ©dition',0),(126283,3508,'jp','é…?é€?è¦‹ç©?ã‚Šã‚’è¿”ä¿¡',0),(126284,3508,'pt','Enviar cotaÃ§Ã£o de transporte de volta',0),(126285,3508,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾, Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(126286,3508,'es','Devolver CotizaciÃ³n de EnvÃ­o',0),(126287,3508,'de','Senden Sie zurÃ¼ck Versand Zitat',0),(126288,3508,'en','Send Back Shipping Quote',0),(126289,3509,'is','',0),(126290,3509,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§',0),(126291,3509,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§',0),(126292,3509,'tr','KutularÄ± ekleme',0),(126293,3509,'pl','Dodaj pola',0),(126294,3509,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(126295,3509,'ur','Ø®Ø§Ù†ÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(126296,3509,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ™Ð° Ð·Ð°',0),(126297,3509,'vi','ThÃªm CÃ¡c Há»™p',0),(126298,3509,'af','Voeg Bokse by',0),(126299,3509,'ro','Adauga Colete',0),(126300,3509,'et','Lisada lahtrid',0),(126301,3509,'si','Dodajanje polja',0),(126302,3509,'ba','Tambahkan kotak',0),(126303,3509,'nl','Vakken toevoegen',0),(126304,3509,'fi','LisÃ¤Ã¤ laatikot',0),(126305,3509,'no','Legge til bokser',0),(126306,3509,'da','TilfÃ¸je kasser',0),(126307,3509,'ko','ìƒìž ì¶”ê°€',0),(126308,3509,'he','×”×•×¡×£ ×§×•×¤×¡××•×ª',0),(126309,3509,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï€Î»Î±Î¯ÏƒÎ¹Î±',0),(126310,3509,'zh','å¢žåŠ æ¡†\r\n',0),(126311,3509,'sv','LÃ¤gg till lÃ¥dor',0),(126312,3509,'it','Aggiungere caselle',0),(126313,3509,'tl','',0),(126314,3509,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(126315,3509,'hi','à¤¬à¤•à¥à¤¸à¥‡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(126316,3509,'ms','Menambah kotak',0),(126317,3509,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø±Ø¨Ø¹Ø§Øª',0),(126318,3509,'fr','Ajouter Boites',0),(126319,3509,'jp','ãƒœãƒƒã‚¯ã‚¹ã?®è¿½åŠ ',0),(126320,3509,'pt','Adicionar caixas de',0),(126321,3509,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð»Ñ',0),(126322,3509,'es','Agregar Cajas',0),(126323,3509,'de','Felder einfÃ¼gen',0),(126324,3509,'en','Add Boxes',0),(126325,3510,'is','',0),(126326,3510,'dr','ÙˆØ²Ù† Ù‡Ø± Ø¬Ø¹Ø¨Ù‡',0),(126327,3510,'pr','ÙˆØ²Ù† Ù‡Ø± Ø¬Ø¹Ø¨Ù‡',0),(126328,3510,'tr','Kutu aÄŸÄ±rlÄ±ÄŸÄ±',0),(126329,3510,'pl','Waga w opakowaniu',0),(126330,3510,'bg','Ð¢ÐµÐ³Ð»Ð¾ Ð½Ð° ÐºÑƒÑ‚Ð¸Ñ',0),(126331,3510,'ur','ÙˆØ²Ù† Ø®Ø§Ù†Û ÙÛŒ',0),(126332,3510,'sr','Ð¢ÐµÐ¶Ð¸Ð½Ð° Ð¿Ð¾ ÐºÑƒÑ‚Ð¸Ñ˜Ð¸',0),(126333,3510,'vi','Trá»ng lÆ°á»£ng má»—i há»™p',0),(126334,3510,'af','Gewig per Boks',0),(126335,3510,'ro','Greutate per cutie',0),(126336,3510,'et','Kaal kasti kohta',0),(126337,3510,'si','Maso na Å¡katlo',0),(126338,3510,'ba','Berat per kotak',0),(126339,3510,'nl','Gewicht per doos',0),(126340,3510,'fi','Paino per laatikko',0),(126341,3510,'no','Vekt per boks',0),(126342,3510,'da','VÃ¦gt pr. kasse',0),(126343,3510,'ko','ë°•ìŠ¤ ë‹¹ ë¬´ê²Œ',0),(126344,3510,'he','×ž×©×§×œ ×œ×›×œ ×ª×™×‘×ª',0),(126345,3510,'el','Î’Î¬ÏÎ¿Ï‚ Î±Î½Î¬ ÎºÎ¹Î²ÏŽÏ„Î¹Î¿',0),(126346,3510,'zh','æ¯ç›’é‡é‡\r\n',0),(126347,3510,'sv','Vikt per lÃ¥da',0),(126348,3510,'it','Peso per scatola',0),(126349,3510,'tl','',0),(126350,3510,'th','&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;&#3605;&#3656;&#3629;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(126351,3510,'hi','à¤µà¤œà¤¨ à¤ªà¥à¤°à¤¤à¤¿ à¤¬à¥‰à¤•à¥à¤¸',0),(126352,3510,'ms','Berat satu Peti',0),(126353,3510,'ar','ÙˆØ²Ù† Ø§Ù„ØµÙ†Ø¯ÙˆÙ‚',0),(126354,3510,'fr','Poids par boÃ®te',0),(126355,3510,'jp','ç®±ã?”ã?¨ã?®é‡?ã?•',0),(126356,3510,'pt','Peso por caixa',0),(126357,3510,'ru','Ð’ÐµÑ Ð² ÐºÐ¾Ñ€Ð¾Ð±ÐºÐµ',0),(126358,3510,'es','Peso por Caja',0),(126359,3510,'de','Gewicht pro Box',0),(126360,3510,'en','Weight per Box',0),(126361,3511,'is','',0),(126362,3511,'dr','(Ø¯Ùˆ Ù†ÙŠÙ… ÙƒØ±Ø¯Ù†',0),(126363,3511,'pr','ØªÙ‚Ø³ÙŠÙ… ÙƒØ±Ø¯Ù† (Ø¯Ùˆ Ù†ÙŠÙ… ÙƒØ±Ø¯Ù†',0),(126364,3511,'tr','Split',0),(126365,3511,'pl','Split',0),(126366,3511,'bg','Ð¡Ð¿Ð»Ð¸Ñ‚',0),(126367,3511,'ur','Ø§Ù„Ú¯ Ú©Ø±ÛŒÚº',0),(126368,3511,'sr','Ð¡Ð¿Ð»Ð¸Ñ‚',0),(126369,3511,'vi','Chia',0),(126370,3511,'af','Verdeling',0),(126371,3511,'ro','Split',0),(126372,3511,'et','Split',0),(126373,3511,'si','Split',0),(126374,3511,'ba','Split',0),(126375,3511,'nl','Split',0),(126376,3511,'fi','Split',0),(126377,3511,'no','Split',0),(126378,3511,'da','Split',0),(126379,3511,'ko','ë¶„í• ',0),(126380,3511,'he','×¤×™×¦×•×œ',0),(126381,3511,'el','Î£Ï€Î»Î¹Ï„',0),(126382,3511,'zh','åˆ†è£‚\r\n',0),(126383,3511,'sv','Split',0),(126384,3511,'it','Split',0),(126385,3511,'tl','',0),(126386,3511,'th','&#3649;&#3618;&#3585;',0),(126387,3511,'hi','à¤­à¤¾à¤œà¤¿à¤¤',0),(126388,3511,'ms','Split',0),(126389,3511,'ar','Ø³Ø¨Ù„ÙŠØª',0),(126390,3511,'fr','Split',0),(126391,3511,'jp','åˆ†å‰²',0),(126392,3511,'pt','Split',0),(126393,3511,'ru','Ð¡Ð¿Ð»Ð¸Ñ‚',0),(126394,3511,'es','Partido',0),(126395,3511,'de','Split',0),(126396,3511,'en','Split',0),(126397,3512,'is','',0),(126398,3512,'dr','Ú¯Ø±ÙØªÙ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(126399,3512,'pr','Ú¯Ø±ÙØªÙ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(126400,3512,'tr','Teklif alÄ±n',0),(126401,3512,'pl','Pobierz ofertÄ™',0),(126402,3512,'bg','Ð’Ð·ÐµÐ¼Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(126403,3512,'ur','Ú©ÙˆÙ¹ÛŒØ´Ù†',0),(126404,3512,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(126405,3512,'vi','Láº¥y bÃ¡o giÃ¡',0),(126406,3512,'af','Kry Kwotasie',0),(126407,3512,'ro','Da cotatia',0),(126408,3512,'et','Saada pakkumine',0),(126409,3512,'si','Dobili ponudbo',0),(126410,3512,'ba','Dapatkan penawaran',0),(126411,3512,'nl','Vraag offerte aan',0),(126412,3512,'fi','PyydÃ¤ tarjous',0),(126413,3512,'no','FÃ¥ tilbud',0),(126414,3512,'da','FÃ¥ tilbud',0),(126415,3512,'ko','ê²¬ì ',0),(126416,3512,'he','×œ×§×‘×œ ×œ×”×¦×¢×ª ×ž×—×™×¨',0),(126417,3512,'el','Î–Î·Ï„Î®ÏƒÏ„Îµ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(126418,3512,'zh','èŽ·å–æŠ¥ä»·\r\n',0),(126419,3512,'sv','FÃ¥ offert',0),(126420,3512,'it','Richiedi preventivo',0),(126421,3512,'tl','',0),(126422,3512,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(126423,3512,'hi','à¤¬à¥‹à¤²à¥€ à¤œà¤¾à¤“',0),(126424,3512,'ms','Mendapatkan sebut harga',0),(126425,3512,'ar','Ø¬Ù„Ø¨ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(126426,3512,'fr','Demander un devis',0),(126427,3512,'jp','è¦‹ç©?ã‚Šã‚’ã?¨ã‚‹',0),(126428,3512,'pt','Obter cotaÃ§Ã£o',0),(126429,3512,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð¾Ð¹',0),(126430,3512,'es','Conseguir Cotizaciones',0),(126431,3512,'de','Sofortangebot',0),(126432,3512,'en','Get Quote',0),(126433,3513,'is','',0),(126434,3513,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø²ÙŠØ± ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù‡Ø³ØªÙ†Ø¯',0),(126435,3513,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø²ÙŠØ± ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù‡Ø³ØªÙ†Ø¯',0),(126436,3513,'tr','NON-STOK Ä°Ã‡Ä°N SADECE GÄ°RÄ°ÅžLERÄ°NÄ°N ALTINDADIR',0),(126437,3513,'pl','PONIÅ»EJ SÄ„ ZAPISY NA NIE â€“ MAGAZYNOWYCH TYLKO',0),(126438,3513,'bg','ÐŸÐž-Ð”ÐžÐ›Ð£ Ð—ÐÐŸÐ˜Ð¡Ð˜ Ð¡Ð Ð—Ð ÐÐ•-Ð—ÐÐŸÐÐ¡Ð˜ Ð¡ÐÐœÐž',0),(126439,3513,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ-ØºÛŒØ± ØµØ±Ù Ú©Û’ Ù„Ø¦Û’ Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª ÛÛŒÚº',0),(126440,3513,'sr','Ð˜Ð¡ÐŸÐžÐ” Ð¡Ð¢ÐÐ’ÐšÐ• Ð¡Ð£ Ð—Ð ÐÐžÐ-Ð—ÐÐ›Ð˜Ð¥Ð• Ð¡ÐÐœÐž',0),(126441,3513,'vi','BÃºt toÃ¡n nháº­p dÆ°á»›i Ä‘Ã¢y dÃ nh cho hÃ ng khÃ´ng cÃ³ trong kho',0),(126442,3513,'af','ONDERSTAANDE INSKRYWINGS IS ALLEENLIK VIR NIE-INVENTARIS ',0),(126443,3513,'ro','MAI JOS SUNT INTRÄ‚RI PENTRU NON-STOC NUMAI',0),(126444,3513,'et','Allolevad vÃ¤ljad on mitte inventuurikauba jaoks',0),(126445,3513,'si','SPODAJ SO POSTAVKE ZA NON-ZALOGE LE',0),(126446,3513,'ba','DI BAWAH INI ADALAH ENTRI UNTUK BEBAS-PERSEDIAAN HANYA',0),(126447,3513,'nl','ONDER DE POSTEN ZIJN VOOR NIET-VOORRAAD ALLEEN',0),(126448,3513,'fi','TAPAHTUMAT OVAT KUIN VARASTOON VAIN ALLA',0),(126449,3513,'no','UNDER OPPFÃ˜RINGER ER FOR IKKE-LAGER BARE',0),(126450,3513,'da','NEDENSTÃ…ENDE POSTER ER FOR IKKE-BEHOLDNING KUN',0),(126451,3513,'ko','ë¹„-ë§Œ ìž¬ê³ ì— ëŒ€ í•œ í•­ëª©ì€ ì•„ëž˜',0),(126452,3513,'he','×œ×”×œ×Ÿ ×”×¢×¨×›×™× ×”× ×¢×‘×•×¨ ×”×œ×-×”×ž×œ××™ ×‘×œ×‘×“',0),(126453,3513,'el','Î Î‘Î¡Î‘ÎšÎ†Î¤Î© ÎšÎ‘Î¤Î‘Î§Î©Î¡Î‰Î£Î•Î™Î£ Î•ÎŠÎÎ‘Î™ Î“Î™Î‘ ÎœÎ—-Î‘Î ÎŸÎ“Î¡Î‘Î¦Î‰ ÎœÎŒÎÎŸ',0),(126454,3513,'zh','ä¸‹åˆ—æ¡ç›®çš„éžæ¸…å•ä»…\r\n',0),(126455,3513,'sv','UNDER POSTER Ã„R FÃ–R ICKE-LAGER ENDAST',0),(126456,3513,'it','DI SEGUITO SONO LE VOCI PER NON A MAGAZZINO SOLO',0),(126457,3513,'tl','',0),(126458,3513,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3',0),(126459,3513,'hi','à¤—à¥ˆà¤°-à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤•à¥‡à¤µà¤² à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¹à¥ˆà¤‚ à¤¨à¥€à¤šà¥‡',0),(126460,3513,'ms','DI BAWAH ADALAH ENTRI UNTUK BEBAS-INVENTORI HANYA',0),(126461,3513,'ar','Ø§Ù„Ø®Ø§Ù†Ø§Øª Ø£Ø¯Ù†Ø§Ù‡ ØªÙ…Ù„Ø£ Ù„ØºÙŠØ± Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ÙÙ‚Ø·',0),(126462,3513,'fr','CI-DESSOUS SONT DES ENTRÃ‰ES POUR HORS STOCKS SEULEMENT',0),(126463,3513,'jp','ä¸‹è¨˜ã?®ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?¯é?žåœ¨åº«ã?®ã?Ÿã‚?ã?®ã?¿ã?§ã?™',0),(126464,3513,'pt','ABAIXO AS ENTRADAS SÃƒO PARA NÃƒO-INVENTÃRIO SOMENTE',0),(126465,3513,'ru','ÐÐ˜Ð–Ð• Ð—ÐÐŸÐ˜Ð¡Ð˜ Ð”Ð›Ð¯ NON-Ð˜ÐÐ’Ð•ÐÐ¢ÐÐ Ð˜Ð—ÐÐ¦Ð˜Ð¯ Ð¢ÐžÐ›Ð¬ÐšÐž',0),(126466,3513,'es','ENTRADAS ABAJO SOLO SON PARA NO INVENTARIOS',0),(126467,3513,'de','UNTER EINTRÃ„GE SIND FÃœR NICHT-INVENTUR NUR',0),(126468,3513,'en','BELOW ENTRIES ARE FOR NON-INVENTORY ONLY',0),(126469,3514,'is','',0),(126470,3514,'dr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø­Ø³Ø§Ø¨ ',0),(126471,3514,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø­Ø³Ø§Ø¨ ',0),(126472,3514,'tr','Hesap dosyasÄ± sÃ¼tun biÃ§imi',0),(126473,3514,'pl','Format konta pliku kolumna',0),(126474,3514,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(126475,3514,'ur','Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(126476,3514,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(126477,3514,'vi','Há»“ SÆ¡ TK Theo Dáº¡ng Cá»™t',0),(126478,3514,'af','RekeninglÃªer Kolomformaat',0),(126479,3514,'ro','Format coloana cont',0),(126480,3514,'et','Konto faili veeruvormingut',0),(126481,3514,'si','Zapisa stolpec raÄun',0),(126482,3514,'ba','Format File Kolom Akun',0),(126483,3514,'nl','Bestandsindeling kolom rekening',0),(126484,3514,'fi','Huomioon sarakkeen tiedostomuoto',0),(126485,3514,'no','Konto-kolonnen filformat',0),(126486,3514,'da','Konto-kolonne filformat',0),(126487,3514,'ko','ê³„ì • íŒŒì¼ ì—´ í˜•ì‹',0),(126488,3514,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×§×•×‘×¥ ×—×©×‘×•×Ÿ',0),(126489,3514,'el','ÎœÎ¿ÏÏ†Î® ÏƒÏ„Î®Î»Î·Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(126490,3514,'zh','å¸æˆ·æ–‡ä»¶åˆ—æ ¼å¼\r\n',0),(126491,3514,'sv','Konto-kolumn filformatet',0),(126492,3514,'it','Conto formato colonna',0),(126493,3514,'tl','',0),(126494,3514,'th','&#3592;&#3633;&#3604;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3652;&#3615;&#3621;&#3660;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(126495,3514,'hi','à¤–à¤¾à¤¤à¤¾ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(126496,3514,'ms','Format kolum fail akaun',0),(126497,3514,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ ÙÙŠ Ù…Ù„Ù Ø§Ù„Ø­Ø³Ø§Ø¨',0),(126498,3514,'fr','Format de colonne de fichier du compte',0),(126499,3514,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒ•ã‚¡ã‚¤ãƒ«åˆ—ã?®ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(126500,3514,'pt','Formato de coluna do arquivo de conta',0),(126501,3514,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(126502,3514,'es','Cuenta Formato de Archivo de Columna',0),(126503,3514,'de','Konto Spalte Dateiformat',0),(126504,3514,'en','Account File Column Format',0),(126505,3515,'is','',0),(126506,3515,'dr','Ø³ÙˆØ§Ù„Ø§Øª ',0),(126507,3515,'pr','Ø³ÙˆØ§Ù„Ø§Øª ',0),(126508,3515,'tr','Sorular',0),(126509,3515,'pl','Pytania',0),(126510,3515,'bg','Ð’ÑŠÐ¿Ñ€Ð¾ÑÐ¸',0),(126511,3515,'ur','Ø³ÙˆØ§Ù„Ø§Øª',0),(126512,3515,'sr','ÐŸÐ¸Ñ‚Ð°ÑšÐ°',0),(126513,3515,'vi','Há»i',0),(126514,3515,'af','Vrae',0),(126515,3515,'ro','ÃŽntrebÄƒri',0),(126516,3515,'et','KÃ¼simused',0),(126517,3515,'si','VpraÅ¡anja',0),(126518,3515,'ba','Pertanyaan',0),(126519,3515,'nl','Vragen',0),(126520,3515,'fi','KysymyksiÃ¤',0),(126521,3515,'no','SpÃ¸rsmÃ¥l',0),(126522,3515,'da','SpÃ¸rgsmÃ¥l',0),(126523,3515,'ko','ì§ˆë¬¸',0),(126524,3515,'he','×©××œ×•×ª',0),(126525,3515,'el','Î•ÏÏ‰Ï„Î®ÏƒÎµÎ¹Ï‚',0),(126526,3515,'zh','é—®é¢˜\r\n',0),(126527,3515,'sv','FrÃ¥gor',0),(126528,3515,'it','Domande',0),(126529,3515,'tl','',0),(126530,3515,'th','&#3588;&#3635;&#3606;&#3634;&#3617;',0),(126531,3515,'hi','à¤¸à¤µà¤¾à¤²',0),(126532,3515,'ms','Soalan-soalan',0),(126533,3515,'ar','Ø£Ø³Ø¦Ù„Ø©',0),(126534,3515,'fr','Questions',0),(126535,3515,'jp','è³ªå•?',0),(126536,3515,'pt','Perguntas',0),(126537,3515,'ru','Ð’Ð¾Ð¿Ñ€Ð¾ÑÑ‹',0),(126538,3515,'es','Preguntas',0),(126539,3515,'de','Fragen',0),(126540,3515,'en','Questions',0),(126541,3516,'is','',0),(126542,3516,'dr','ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡  Ø¯Ø§Ø®Ù„ÙŠ ',0),(126543,3516,'pr','ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡  Ø¯Ø§Ø®Ù„ÙŠ ',0),(126544,3516,'tr','YalnÄ±zca dahili kullanÄ±m iÃ§in',0),(126545,3516,'pl','Tylko do uÅ¼ytku wewnÄ™trznego',0),(126546,3516,'bg','Ð¡Ð°Ð¼Ð¾ Ð·Ð° Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(126547,3516,'ur','ØµØ±Ù Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Û’ Ù„Ø¦Û’',0),(126548,3516,'sr','Ð¡Ð°Ð¼Ð¾ Ð·Ð° Ð¸Ð½Ñ‚ÐµÑ€Ð½Ñƒ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ',0),(126549,3516,'vi','Chá»‰ dÃ¹ng ná»™i bá»™',0),(126550,3516,'af','Alleenlik Vir Interne Gebruik ',0),(126551,3516,'ro','Numai pentru uz intern',0),(126552,3516,'et','Ainult sÃ¼steemisiseseks kasutuseks',0),(126553,3516,'si','Samo za notranjo uporabo',0),(126554,3516,'ba','Untuk penggunaan Internal saja',0),(126555,3516,'nl','Alleen voor intern gebruik',0),(126556,3516,'fi','Vain sisÃ¤iseen kÃ¤yttÃ¶Ã¶n',0),(126557,3516,'no','Bare for internt bruk',0),(126558,3516,'da','Kun til intern brug',0),(126559,3516,'ko','ë‚´ë¶€ ì „ìš©',0),(126560,3516,'he','×œ×©×™×ž×•×© ×¤× ×™×ž×™ ×‘×œ×‘×“',0),(126561,3516,'el','ÎœÏŒÎ½Î¿ Î³Î¹Î± ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® Ï‡ÏÎ®ÏƒÎ·',0),(126562,3516,'zh','åªä¾›å†…éƒ¨ä½¿ç”¨\r\n',0),(126563,3516,'sv','Endast fÃ¶r intern anvÃ¤ndning',0),(126564,3516,'it','Solo per uso interno',0),(126565,3516,'tl','',0),(126566,3516,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3651;&#3594;&#3657;&#3616;&#3634;&#3618;&#3651;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(126567,3516,'hi','à¤•à¥‡à¤µà¤² à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¥‡ à¤²à¤¿à¤',0),(126568,3516,'ms','Untuk kegunaan dalaman sahaja',0),(126569,3516,'ar','Ù„Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠ ÙÙ‚Ø·',0),(126570,3516,'fr','Pour usage interne seulement',0),(126571,3516,'jp','ç¤¾å†…åˆ©ç”¨é™?å®š',0),(126572,3516,'pt','Somente para uso interno',0),(126573,3516,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ Ð²Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÐµÐ³Ð¾ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(126574,3516,'es','Para Uso Internal Solamente',0),(126575,3516,'de','Nur zur internen Verwendung',0),(126576,3516,'en','For Internal Use Only',0),(126577,3517,'is','',0),(126578,3517,'dr','Ù¾ÙŠØºØ§Ù… Ø§Ø®Ø·Ø§Ø± Ø§Ø±Ø³Ø§Ù„ Ø­Ø³Ø§Ø¨ â€“ Ø§Ø±Ø³Ø§Ù„ Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨ Ù‡Ø± Ø­Ø³Ø§Ø¨ÙŠ Ø±Ø§ ÙƒÙ‡ Ø§Ø®ÙŠØ±Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡  Ø­Ø°Ù Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯ ',0),(126579,3517,'pr','Ù¾ÙŠØºØ§Ù… Ø§Ø®Ø·Ø§Ø± Ø§Ø±Ø³Ø§Ù„ Ø­Ø³Ø§Ø¨ â€“ Ø§Ø±Ø³Ø§Ù„ Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨ Ù‡Ø± Ø­Ø³Ø§Ø¨ÙŠ Ø±Ø§ ÙƒÙ‡ Ø§Ø®ÙŠØ±Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡  Ø­Ø°Ù Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯ ',0),(126580,3517,'tr','UYARI:<br>Liste-ecek Ã§Ä±karmak herhangi bir hesabÄ± alma<br>Åžu anda bu ÅŸirket iÃ§in girilen hesaplarÄ±!',0),(126581,3517,'pl','OSTRZEÅ»ENIE:<br>Importowanie listy bÄ™dzie usuwaÄ‡ konta<br>kont obecnie wprowadzone dla tej firmy!',0),(126582,3517,'bg','ÐŸÐ Ð•Ð”Ð£ÐŸÐ Ð•Ð–Ð”Ð•ÐÐ˜Ð•:<br>Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚, ÑÐ¿Ð¸ÑÑŠÐºÑŠÑ‚ Ñ‰Ðµ Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸<br>ÑÐ¼ÐµÑ‚ÐºÐ¸, Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°!',0),(126583,3517,'ur','ØªÙ†Ø¨ÛŒÛ:<br>ÙÛØ±Ø³Øª Ù…ÛŒÚº Ø³Û’ Ú©Ø³ÛŒ Ú©Ùˆ ÛÙ¹Ø§ Ø¯Û’ Ú¯Ø§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”<br>ÙÛŒ Ø§Ù„Ø­Ø§Ù„ Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø¯Ø§Ø®Ù„ ÛÙˆØ¦Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³!',0),(126584,3517,'sr','Ð£ÐŸÐžÐ—ÐžÐ Ð•ÐŠÐ•:<br>Ð£Ð²Ð¾Ð· Ð½Ð°Ð»Ð¾Ð³Ð° Ð»Ð¸ÑÑ‚Ð° Ñ›Ðµ ÑƒÐºÐ»Ð¾Ð½Ð¸Ñ‚Ð¸ Ð±Ð¸Ð»Ð¾<br>Ð½Ð°Ð»Ð¾Ð·Ð¸ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ ÑƒÐ½ÐµÑÐµÐ½Ð¸ Ð·Ð° Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ!',0),(126585,3517,'vi','Cáº£nh BÃ¡o:Nháº­p danh sÃ¡ch TK sáº½ xÃ³a toÃ n bá»™ nhá»¯ng TK vá»«a cáº­p nháº­t cho cÃ´ng ty nÃ y!',0),(126586,3517,'af','WAARSKUWING:<br>Invoer van rekeninglys sal enige <br>rekening verwyder',0),(126587,3517,'ro','Atentie:<br>Importul listei de conturi va sterge orice<br>conturi utilizate acum pentru aceasta firma!',0),(126588,3517,'et','HOIATUS:<br>Kontode nimekirja importimine kustutab kÃµik<br> kontod, mis on hetkel selle ettevÃµtte jaoks sisestatud!',0),(126589,3517,'si','OPOZORILO:<br>UvaÅ¾anje raÄun, seznam, boste odstranili vse<br>raÄuni trenutno vpisana za to podjetje!',0),(126590,3517,'ba','PERHATIAN:<br>Meng-import daftar akun<br>akan menghapus semua akun yang ada !',0),(126591,3517,'nl','WAARSCHUWING:<br>Importeren van account lijst zal verwijderen<br>rekeningen momenteel ingevoerd voor dit bedrijf!',0),(126592,3517,'fi','VAROITUS:<br>Tuominen arvo luettelosta poistamalla<br>kirjattu yrityksen tilejÃ¤!',0),(126593,3517,'no','ADVARSEL:<br>Importere konto liste fjerner alle<br>kontoer er angitt for dette selskapet!',0),(126594,3517,'da','ADVARSEL:<br>Importere konto liste vil fjerne enhver<br>konti i Ã¸jeblikket angivet for dette selskab!',0),(126595,3517,'ko','ê²½ê³ :<br>ëª©ë¡ ì œê±° ë©ë‹ˆë‹¤ ê³„ì • ê°€ì ¸ì˜¤ê¸°<br>í˜„ìž¬ì´ íšŒì‚¬ì— ëŒ€ í•œ ìž…ë ¥ ëœ ê³„ì •!',0),(126596,3517,'he','××–×”×¨×”:<br>×™×™×‘×•× ×—×©×‘×•×Ÿ ×”×¨×©×™×ž×” ×œ×”×¡×™×¨ ××ª ×›×œ<br>×—×©×‘×•× ×•×ª ×”× ×•×›×—×™×™× ×©×”×•×–× ×• ×¢×‘×•×¨ ×”×—×‘×¨×” ×”×–××ª!',0),(126597,3517,'el','Î Î¡ÎŸÎ•Î™Î”ÎŸÎ ÎŸÎŠÎ—Î£Î—:<br>Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î»Î¯ÏƒÏ„Î±Ï‚ Î¸Î± Î±Ï†Î±Î¹ÏÎ­ÏƒÎµÎ¹ Î¿Ï€Î¿Î¹Î¿Î´Î®Ï€Î¿Ï„Îµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ<br>Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ Ï€Î¿Ï… ÎµÎ³Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹ ÏƒÎ®Î¼ÎµÏÎ± Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î®!',0),(126598,3517,'zh','è®°å¸è¿›å£è­¦å‘Šæ¶ˆæ¯\r\n',0),(126599,3517,'sv','VARNING:<br>Importerar konto lista kommer att ta bort nÃ¥gon<br>konton som fÃ¶r nÃ¤rvarande anges fÃ¶r detta fÃ¶retag!',0),(126600,3517,'it','Attenzione: importando una lista di profili saranno rimossi tutti i profili esistenti per questa azienda!',0),(126601,3517,'tl','',0),(126602,3517,'th','&#3588;&#3635;&#3648;&#3605;&#3639;&#3629;&#3609;:<br>&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3592;&#3632;&#3621;&#3610;<br>&#3610;&#3633;&#3597;&#3594;&#3637;&#3611;&#3633;&',0),(126603,3517,'hi','à¤šà¥‡à¤¤à¤¾à¤µà¤¨à¥€:<br>à¤¸à¥‚à¤šà¥€ à¤¨à¤¿à¤•à¤¾à¤² à¤¦à¥‡à¤—à¤¾ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤–à¤¾à¤¤à¥‡ à¤•à¥‹ à¤†à¤¯à¤¾à¤¤<br>à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤°à¥à¤œ à¤–à¤¾à¤¤à¥‹à¤‚!',0),(126604,3517,'ms','AMARAN:<br>Mengimport senarai akan membuang mana-mana akaun<br>akaun ini dimasukkan untuk Syarikat ini!',0),(126605,3517,'ar','ØªØ­Ø°ÙŠØ±:<br>Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ù‚Ø§Ø¦Ù…Ø© Ø³ÙŠØªÙ… Ø¥Ø²Ø§Ù„Ø© Ø£ÙŠ<br>Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ Ø­Ø§Ù„ÙŠØ§ Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©!',0),(126606,3517,'fr','ATTENTION :<br>Importer la liste des comptes effacera tous<br>les comptes actuellement prÃ©sent de cette compagnie!',0),(126607,3517,'jp','è­¦å‘Šï¼šã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒªã‚¹ãƒˆã?¨ã‚’å?–ã‚Šè¾¼ã‚€ã?¨ç?¾åœ¨è¨˜å¸³ã?•ã‚Œã?Ÿã?„ã‚‹ä¼šç¤¾ã?®ã?‚ã‚‰ã‚†ã‚‹ã‚«ã‚¦ãƒ³ãƒˆã?Œã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?™ï¼?',0),(126608,3517,'pt','AVISO:<br>ImportaÃ§Ã£o conta lista irÃ¡ remover qualquer<br>contas atualmente entradas para esta empresa!',0),(126609,3517,'ru','ÐŸÐ Ð•Ð”Ð£ÐŸÐ Ð•Ð–Ð”Ð•ÐÐ˜Ð•:<br>Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÐ¿Ð¸ÑÐºÐ° Ð±ÑƒÐ´ÐµÑ‚ ÑƒÐ´Ð°Ð»ÑÑ‚ÑŒ Ð»ÑŽÐ±Ñ‹Ðµ<br>ÑÑ‡ÐµÑ‚Ð° Ð² Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð²Ð²Ð¾Ð´Ð¸Ñ‚ÑÑ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸!',0),(126610,3517,'es','AVISO:<br>Importando una lista de cuenta  eliminarÃ¡ cualquiera<br>cuenta actualmente introducida para esta empresa!',0),(126611,3517,'de','WARNUNG:<br>Importieren von Account-Liste entfernen wird<br>Konten, die derzeit fÃ¼r diese Firma eingetragen!',0),(126612,3517,'en','WARNING:<br>Importing account list will remove any<br>accounts currently entered for this company!',0),(126613,3518,'is','',0),(126614,3518,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ù„Ø§ ',0),(126615,3518,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ù„Ø§ ',0),(126616,3518,'tr','YukarÄ±da seÃ§ilen kÃ¼me alma',0),(126617,3518,'pl','Importuj zestaw wybranego powyÅ¼ej',0),(126618,3518,'bg','Ð—Ð° Ð²Ð½Ð¾Ñ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ',0),(126619,3518,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø¨Ø§Ù„Ø§ Ù…Ù†ØªØ®Ø¨ Ø³ÛŒÙ¹ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(126620,3518,'sr','Ð£Ð²Ð¾Ð· Ð¿Ð¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ñƒ Ð¸Ð·Ð½Ð°Ð´',0),(126621,3518,'vi','Nháº­p Nhá»¯ng Pháº§n ÄÃ£ Chá»n á»ž TrÃªn',0),(126622,3518,'af','Invoer van Stel soos Hierbo Gekies',0),(126623,3518,'ro','Import stabilit selectatÄƒ deasupra',0),(126624,3518,'et','Kehtestada valitud eespool',0),(126625,3518,'si','Uvoz iz izbranih zgoraj',0),(126626,3518,'ba','Impor mengatur dipilih di atas',0),(126627,3518,'nl','Import geselecteerde boven instellen',0),(126628,3518,'fi','Tuo valitut edellÃ¤',0),(126629,3518,'no','Importer satt merket ovenfor',0),(126630,3518,'da','Import angivet valgte ovenfor',0),(126631,3518,'ko','ìœ„ì—ì„œ ì„ íƒí•œ ì„¤ì • ê°€ì ¸ì˜¤ê¸°',0),(126632,3518,'he','×™×™×‘×•× × ×‘×—×¨×” ×ž×¢×œ',0),(126633,3518,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³ÎµÏ„Î±Î¹ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ',0),(126634,3518,'zh','å¯¼å…¥ä¸Šé¢æ‰€é€‰è®¾ç½®\r\n',0),(126635,3518,'sv','FaststÃ¤lls valda ovan',0),(126636,3518,'it','Importazione impostare selezionato sopra',0),(126637,3518,'tl','',0),(126638,3518,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3605;&#3633;&#3657;&#3591;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3623;&#3657;&#3586;&#3657;&#3634;&#3591;&#3610;&#3609;',0),(126639,3518,'hi','à¤‡à¤¸à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤šà¤¯à¤¨à¤¿à¤¤ à¤¸à¥‡à¤Ÿ à¤†à¤¯à¤¾à¤¤',0),(126640,3518,'ms','Import Set terpilih di atas',0),(126641,3518,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…Ø­Ø¯Ø¯ Ø£Ø¹Ù„Ø§Ù‡',0),(126642,3518,'fr','Importer la valeur sÃ©lectionnÃ©e ci-dessus',0),(126643,3518,'jp','ä¸Šè¨˜ã?®é?¸æŠžã‚»ãƒƒãƒˆã‚’å?–ã‚Šè¾¼ã‚€',0),(126644,3518,'pt','ImportaÃ§Ã£o conjunto selecionada acima',0),(126645,3518,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð½Ð°Ð±Ð¾Ñ€Ð° Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð²Ñ‹ÑˆÐµ',0),(126646,3518,'es','Importar Juego Seleccionado Arriba',0),(126647,3518,'de','Import Set oben ausgewÃ¤hlten',0),(126648,3518,'en','Import Set Selected Above',0),(126649,3519,'is','',0),(126650,3519,'dr','Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨ Ù‡Ø§',0),(126651,3519,'pr','Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨ Ù‡Ø§',0),(126652,3519,'tr','Hesap planÄ±',0),(126653,3519,'pl','Plan kont',0),(126654,3519,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¾Ð¿Ð»Ð°Ð½',0),(126655,3519,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú©Ø§ Ú†Ø§Ø±Ù¹',0),(126656,3519,'sr','ÐšÐ¾Ð½Ñ‚Ð½Ð¸ Ð¿Ð»Ð°Ð½',0),(126657,3519,'vi','Biá»ƒu Äá»“ TK',0),(126658,3519,'af','Tabel van Rekeninge',0),(126659,3519,'ro','Plan de conturi',0),(126660,3519,'et','Kontoplaan',0),(126661,3519,'si','Kontni naÄrt',0),(126662,3519,'ba','Kode akun',0),(126663,3519,'nl','Rekeningschema',0),(126664,3519,'fi','Tilikartan',0),(126665,3519,'no','Kontoplanen',0),(126666,3519,'da','Kontoplanen',0),(126667,3519,'ko','ê³„ì • ì°¨íŠ¸',0),(126668,3519,'he','×ª×¨×©×™× ×ª×™×§×™ ×œ×§×•×—×•×ª',0),(126669,3519,'el','Î›Î¿Î³Î¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ‡Î­Î´Î¹Î¿',0),(126670,3519,'zh','ä¼šè®¡ç§‘ç›®è¡¨\r\n',0),(126671,3519,'sv','Kontoplanen',0),(126672,3519,'it','Piano dei conti',0),(126673,3519,'tl','',0),(126674,3519,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(126675,3519,'hi','à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¤¾ à¤šà¤¾à¤°à¥à¤Ÿ',0),(126676,3519,'ms','Carta akaun',0),(126677,3519,'ar','Ø¯Ù„ÙŠÙ„ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(126678,3519,'fr','Plan comptable',0),(126679,3519,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒ?ãƒ£ãƒ¼ãƒˆ',0),(126680,3519,'pt','Plano de contas',0),(126681,3519,'ru','ÐŸÐ»Ð°Ð½ Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(126682,3519,'es','CatÃ¡logo de Cuentas',0),(126683,3519,'de','Kontenplan',0),(126684,3519,'en','Chart of Accounts',0),(126685,3520,'is','',0),(126686,3520,'dr','ØªØ§Ø±ÙŠØ® Ù…Ø¹Ø§Ù…Ù„Ù‡ ',0),(126687,3520,'pr','ØªØ§Ø±ÙŠØ® Ù…Ø¹Ø§Ù…Ù„Ù‡ ',0),(126688,3520,'tr','transaction_date',0),(126689,3520,'pl','transaction_date',0),(126690,3520,'bg','transaction_date',0),(126691,3520,'ur','Ú©Ú¾Ø§ØªØ§ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(126692,3520,'sr','Ñ‚Ñ€Ð°Ð½ÑÐ°Ñ†Ñ‚Ð¸Ð¾Ð½_Ð´Ð°Ñ‚Ðµ',0),(126693,3520,'vi','ngÃ y giao dá»‹ch',0),(126694,3520,'af','transaksie_datum',0),(126695,3520,'ro','Data tranzactiei',0),(126696,3520,'et','transaction_date',0),(126697,3520,'si','transaction_date',0),(126698,3520,'ba','tanggal_transaksi',0),(126699,3520,'nl','transactie_datum',0),(126700,3520,'fi','transaction_date',0),(126701,3520,'no','transaksjons_dato',0),(126702,3520,'da','Transaktions dato',0),(126703,3520,'ko','transaction_date',0),(126704,3520,'he','transaction_date',0),(126705,3520,'el','transaction_date',0),(126706,3520,'zh','äº¤æ˜“æ—¥æœŸ',0),(126707,3520,'sv','transaktions_datum',0),(126708,3520,'it','data_transazione',0),(126709,3520,'tl','Petsa_ng_kalakal',0),(126710,3520,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸šà¸±à¸™à¸—à¸¶à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(126711,3520,'hi','transaction_date',0),(126712,3520,'ms','transaction_date',0),(126713,3520,'ar','transaction_date',0),(126714,3520,'fr','transaction_date',0),(126715,3520,'jp','transaction_date',0),(126716,3520,'pt','transaction_date',0),(126717,3520,'ru','transaction_date',0),(126718,3520,'es','fecha_transacciÃ³n',0),(126719,3520,'de','transaction_date',0),(126720,3520,'en','transaction_date',0),(126721,3521,'is','',0),(126722,3521,'dr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± Ø²Ø¨Ø§Ù† ',0),(126723,3521,'pr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± Ø²Ø¨Ø§Ù† ',0),(126724,3521,'tr','Dil editÃ¶rÃ¼',0),(126725,3521,'pl','Edytor jÄ™zyka',0),(126726,3521,'bg','Ð•Ð·Ð¸ÐºÐ¾Ð² Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¾Ñ€',0),(126727,3521,'ur','Ø²Ø¨Ø§Ù† ØªØ¯ÙˆÛŒÙ† Ú©Ø§Ø±',0),(126728,3521,'sr','ÐˆÐµÐ·Ð¸Ðº ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°Ñ‡',0),(126729,3521,'vi','BiÃªn Táº­p NgÃ´n Ngá»¯',0),(126730,3521,'af','Taal Redigeerder',0),(126731,3521,'ro','Editor limba',0),(126732,3521,'et','Keeleredaktor',0),(126733,3521,'si','Jezik urednik',0),(126734,3521,'ba','Bahasa Editor',0),(126735,3521,'nl','Taleneditor',0),(126736,3521,'fi','KielellÃ¤ editori',0),(126737,3521,'no','RedaktÃ¸r',0),(126738,3521,'da','Sprog Editor',0),(126739,3521,'ko','ì–¸ì–´ íŽ¸ì§‘ê¸°',0),(126740,3521,'he','×¢×•×¨×š ×”×©×¤×”',0),(126741,3521,'el','Editor Î³Î»ÏŽÏƒÏƒÎ±',0),(126742,3521,'zh','è¯­è¨€ç¼–è¾‘å™¨\r\n',0),(126743,3521,'sv','SprÃ¥kredigeraren',0),(126744,3521,'it','Editor di lingua',0),(126745,3521,'tl','',0),(126746,3521,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3616;&#3634;&#3625;&#3634;',0),(126747,3521,'hi','à¤­à¤¾à¤·à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤•',0),(126748,3521,'ms','Editor Bahasa',0),(126749,3521,'ar','Ù…Ø­Ø±Ø± Ø§Ù„Ù„ØºØ§Øª',0),(126750,3521,'fr','Ã‰diteur de langue',0),(126751,3521,'jp','è¨€èªžç·¨é›†è€…',0),(126752,3521,'pt','Editor de linguagem',0),(126753,3521,'ru','Ð¯Ð·Ñ‹ÐºÐ¾Ð²Ð¾Ð¹ ÐœÐ¾Ð´ÑƒÐ»ÑŒ',0),(126754,3521,'es','Traductor de Idioma',0),(126755,3521,'de','Der Sprachredakteur',0),(126756,3521,'en','Language Editor',0),(126757,3522,'is','',0),(126758,3522,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(126759,3522,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(126760,3522,'tr','AlÄ±nan miktar',0),(126761,3522,'pl','IloÅ›Ä‡ otrzymanych',0),(126762,3522,'bg','ÐšÐ¾Ð»-Ð²Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¾',0),(126763,3522,'ur','ÙˆØµÙˆÙ„ Ú©ÛŒ Ù‚ÛŒ',0),(126764,3522,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ð° ÐšÐ¾Ð».',0),(126765,3522,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ nháº­n',0),(126766,3522,'af','Hoev. Ontvang',0),(126767,3522,'ro','Cantit primite',0),(126768,3522,'et','Saadud kogus',0),(126769,3522,'si','KoliÄina prejete',0),(126770,3522,'ba','Qty menerima',0),(126771,3522,'nl','Aantal ontvangen',0),(126772,3522,'fi','Vastaanotettu mÃ¤Ã¤rÃ¤',0),(126773,3522,'no','Antall mottatt',0),(126774,3522,'da','Antal modtagne',0),(126775,3522,'ko','ë°›ì€ ìˆ˜ëŸ‰',0),(126776,3522,'he','×›×ž×•×ª ×”×ª×§×‘×œ',0),(126777,3522,'el','Qty Î­Î»Î±Î²Îµ',0),(126778,3522,'zh','æ”¶åˆ°æ•°é‡\r\n',0),(126779,3522,'sv','Antal mottagna',0),(126780,3522,'it','Qty ricevuto',0),(126781,3522,'tl','',0),(126782,3522,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3619;&#3633;&#3610;&#3617;&#3634;',0),(126783,3522,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(126784,3522,'ms','Qty yang diterima',0),(126785,3522,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø³ØªÙ„Ù…Ø©',0),(126786,3522,'fr','QuantitÃ© reÃ§ue',0),(126787,3522,'jp','å?—é ˜æ•°é‡?',0),(126788,3522,'pt','Qty recebido',0),(126789,3522,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ…',0),(126790,3522,'es','Cant. Recibida',0),(126791,3522,'de','Qty empfangen',0),(126792,3522,'en','Qty Received',0),(126793,3523,'is','',0),(126794,3523,'dr','ÙØ¹Ø§Ù„ÙŠØª Ø­Ø³Ø§Ø¨ ',0),(126795,3523,'pr','ÙØ¹Ø§Ù„ÙŠØª Ø­Ø³Ø§Ø¨ ',0),(126796,3523,'tr','Hesap etkinliÄŸi',0),(126797,3523,'pl','AktywnoÅ›Ä‡ na koncie',0),(126798,3523,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(126799,3523,'ur','Ø§Ú©Ø§ÙˆÙ†Ù¹ Ú©ÛŒ Ú©Ø§Ø±ÙˆØ§Ø¡Û’',0),(126800,3523,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(126801,3523,'vi','Hoáº¡t Äá»™ng TK',0),(126802,3523,'af','Rekening Aktiwiteit',0),(126803,3523,'ro','Activitate cont',0),(126804,3523,'et','Konto tegevus',0),(126805,3523,'si','Dejavnost raÄuna',0),(126806,3523,'ba','Aktivitas Akun',0),(126807,3523,'nl','Accountactiviteit',0),(126808,3523,'fi','Huomioon toiminnan',0),(126809,3523,'no','Kontoaktivitet',0),(126810,3523,'da','Kontoaktivitet',0),(126811,3523,'ko','ê³„ì • í™œë™',0),(126812,3523,'he','×¤×¢×™×œ×•×ª ×—×©×‘×•×Ÿ',0),(126813,3523,'el','Î”ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(126814,3523,'zh','å¸æˆ·æ´»åŠ¨\r\n',0),(126815,3523,'sv','Kontoaktivitet',0),(126816,3523,'it','AttivitÃ  del profilo',0),(126817,3523,'tl','',0),(126818,3523,'th','&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(126819,3523,'hi','à¤–à¤¾à¤¤à¤¾ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(126820,3523,'ms','Aktiviti akaun',0),(126821,3523,'ar','Ø­Ø±ÙƒØ© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(126822,3523,'fr','ActivitÃ© du compte',0),(126823,3523,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆæ´»å‹•',0),(126824,3523,'pt','Atividade da conta',0),(126825,3523,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ð°',0),(126826,3523,'es','Actividad de Cuenta',0),(126827,3523,'de','KontenaktivitÃ¤t',0),(126828,3523,'en','Account Activity',0),(126829,3524,'is','',0),(126830,3524,'dr','Ø§Ù†ÙˆØ§Ø¹ Ø­Ø³Ø§Ø¨ ',0),(126831,3524,'pr','Ø§Ù†ÙˆØ§Ø¹ Ø­Ø³Ø§Ø¨ ',0),(126832,3524,'tr','Hesap tÃ¼rleri',0),(126833,3524,'pl','Typy kont',0),(126834,3524,'bg','Ð’Ð¸Ð´Ð¾Ð²Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(126835,3524,'ur','Ø§Ú©Ø§ÙˆÙ†Ù¹ Ú©ÛŒ Û¡Ø³Ù…',0),(126836,3524,'sr','Ð¢Ð¸Ð¿Ð¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(126837,3524,'vi','CÃ¡c Loáº¡i TK',0),(126838,3524,'af','Rekening Tipes',0),(126839,3524,'ro','Tipuri de cont',0),(126840,3524,'et','KontotÃ¼Ã¼bid',0),(126841,3524,'si','Vrste raÄunov',0),(126842,3524,'ba','Tipe-tipe Akun',0),(126843,3524,'nl','Accounttypen',0),(126844,3524,'fi','Tyypit',0),(126845,3524,'no','Kontotyper',0),(126846,3524,'da','Kontotyper',0),(126847,3524,'ko','ê³„ì • ìœ í˜•',0),(126848,3524,'he','×¡×•×’×™ ×—×©×‘×•×Ÿ',0),(126849,3524,'el','Î¤ÏÏ€Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(126850,3524,'zh','å¸æˆ·ç±»åž‹',0),(126851,3524,'sv','Kontotyper',0),(126852,3524,'it','Tipi di conto',0),(126853,3524,'tl','',0),(126854,3524,'th','&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(126855,3524,'hi','à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(126856,3524,'ms','Jenis-jenis akaun',0),(126857,3524,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(126858,3524,'fr','Types de comptes',0),(126859,3524,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç¨®é¡ž',0),(126860,3524,'pt','Tipos de conta',0),(126861,3524,'ru','Ð¢Ð¸Ð¿Ñ‹ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(126862,3524,'es','Tipos de Cuenta',0),(126863,3524,'de','Kontotypen',0),(126864,3524,'en','Account Types',0),(126865,3525,'is','',0),(126866,3525,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø®Ø±ÙŠØ¯Ø§Ø± Ø®Ø§Ø±Ø¬ÙŠ Ø¬Ù‡Øª Ø§Ø¬Ø§Ø²Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ ÙŠØ§ÙØªÙ† Ø¨Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø´ØªØ±ÙŠ Ø¨Ù‡ ØµÙˆØ±Øª  Ø¢Ù† â€“ Ù„Ø§ÙŠÙ†',0),(126867,3525,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø®Ø±ÙŠØ¯Ø§Ø± Ø®Ø§Ø±Ø¬ÙŠ Ø¬Ù‡Øª Ø§Ø¬Ø§Ø²Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ ÙŠØ§ÙØªÙ† Ø¨Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø´ØªØ±ÙŠ Ø¨Ù‡ ØµÙˆØ±Øª  Ø¢Ù† â€“ Ù„Ø§ÙŠÙ†',0),(126868,3525,'tr','Listeler, dÄ±ÅŸ mÃ¼ÅŸteri izin verilen eriÅŸim iÃ§in mÃ¼ÅŸteri veri Ã§evrimiÃ§i kullanÄ±cÄ±larÄ±n eklemek',0),(126869,3525,'pl','Dodawanie listy z klienta uÅ¼ytkownikÃ³w zewnÄ™trznych jest dozwolony dostÄ™p do klienta danych On-Line',0),(126870,3525,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð²ÑŠÐ½ÑˆÐ½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸ Ð´Ð° ÑÐµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐ°Ð²Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ Ð´Ð°Ð½Ð½Ð¸ Ð¾Ð½-Ð»Ð°Ð¹Ð½',0),(126871,3525,'ur','ÙÛØ±Ø³ØªÙˆÚº Ú©Û’ Ø®Ø§Ø±Ø¬ÛŒ Ú©Ø³Ù¹Ù…Ø± Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆØ§Ø¦Ù On-Line ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª ÛÙˆ ØµØ§Ø±ÙÛŒÙ† Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(126872,3525,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð¾Ð´ ÑÐ¿Ð¾Ñ™Ð½Ð¸Ñ… ÐºÑƒÐ¿Ñ†Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð±Ð¸Ñ‚Ð¸ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ ÐºÑƒÐ¿Ñ†Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¼Ñ€ÐµÐ¶Ð½Ð¸',0),(126873,3525,'vi','ThÃªm NgÆ°á»i Sá»­ Dá»¥ng cá»§a KhÃ¡ch HÃ ng BÃªn NgoÃ i ÄÆ°á»£c PhÃ©p truy cáº­p vÃ o Dá»¯ Liá»‡u KhÃ¡ch HÃ ng Trá»±c Tuyáº¿n',0),(126874,3525,'af','Lyste van Eksterne KliÃ«nte Gebruikers aan wie Toegang verleen moet word Byvoeg',0),(126875,3525,'ro','Adauga listele utilizatorilor externi carora li se permite acces la B2B Clienti Data On-line',0),(126876,3525,'et','Loetletud ning vÃ¤liste klientide kasutajate lisamine olema lubatud juurdepÃ¤Ã¤su kliendi andmetele On-Line',0),(126877,3525,'si','Dodajte sezname za zunanje kupca uporabnikom se dovoli dostop do On-Line podatki kupca',0),(126878,3525,'ba','Menambahkan daftar dari pelanggan pengguna eksternal untuk memungkinkan akses ke On-Line Data Pelanggan',0),(126879,3525,'nl','Lijsten van externe klant gebruikers toevoegen om te worden toegelaten toegang tot de klant gegevens On-Line',0),(126880,3525,'fi','LisÃ¤Ã¤ luettelo ulkoisen asiakkaan kÃ¤yttÃ¤jien saatava saa asiakkaan tiedot On-Line',0),(126881,3525,'no','Legge til lister av eksterne kunden brukere skal tillates tilgang til kunden Data On-Line',0),(126882,3525,'da','TilfÃ¸je lister af eksterne kunde brugere for at vÃ¦re tilladt adgang til kundens Data On-Line',0),(126883,3525,'ko','ë‚˜ì—´ì˜ ì™¸ë¶€ ê³ ê° ì‚¬ìš©ìžê°€ ê³ ê° ë°ì´í„°ë¥¼ ì˜¨ë¼ì¸ì— ëŒ€ í•œ í—ˆìš© ì•¡ì„¸ìŠ¤ ì¶”ê°€',0),(126884,3525,'he','×œ×”×•×¡×™×£ ×¨×©×™×ž×•×ª ×©×œ ×œ×§×•×—×•×ª ×ž×©×ª×ž×©×™× ×—×™×¦×•× ×™×™× ×œ×”×™×•×ª ×ž×•×ª×¨×ª ×’×™×©×” ×œ×œ×§×•×— × ×ª×•× ×™× on-line',0),(126885,3525,'el','ÎÎ± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î»Î¯ÏƒÏ„ÎµÏ‚ Ï„Î¿Ï… ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÎ¿Ï Ï€ÎµÎ»Î¬Ï„Î· Î¿Î¹ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Î½Î± ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ On-Line Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(126886,3525,'zh','ç”¨æˆ·å¢žåŠ çš„å¤–éƒ¨å®¢æˆ·åå•ä»¥è®¿é—®å®¢æˆ·çš„åœ¨çº¿æ•°æ®\r\n',0),(126887,3525,'sv','LÃ¤gga till listor av externa kunden anvÃ¤ndare att fÃ¥r Ã¥tkomst till kundens Data On-Line',0),(126888,3525,'it','Aggiungere elenchi di clienti gli utenti esterni per essere permesso di accesso al cliente dati on-line',0),(126889,3525,'tl','',0),(126890,3525,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3594;&#3639;&#3656;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3592;&#3634;&#3585;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585; &#',0),(126891,3525,'hi','à¤¸à¥‚à¤šà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¾à¤¹à¤°à¥€ à¤—à¥à¤°à¤¾à¤¹à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤¡à¥‡à¤Ÿà¤¾ à¤‘à¤¨ à¤²à¤¾à¤‡à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¹à¥à¤à¤š à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥',0),(126892,3525,'ms','Tambah senarai daripada pelanggan pengguna luar supaya dibenarkan akses kepada pelanggan Data On-Line',0),(126893,3525,'ar','Ø¥Ø¶Ø§ÙØ© \"Ù‚ÙˆØ§Ø¦Ù… Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ø®Ø§Ø±Ø¬ÙŠÙŠÙ†\" Ø¨Ø£Ù† \"ÙŠØ³Ù…Ø­ Ø¨Ø§Ù„ÙˆØµÙˆÙ„\" Ø¥Ù„Ù‰ \"Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø¹Ø¨Ø± Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª\"',0),(126894,3525,'fr','Ajouter listes d\'Usagers de Client Externe qui ont l\'Access a leurs Donnees',0),(126895,3525,'jp','ã‚ªãƒ³ãƒ©ã‚¤ãƒ³é¡§å®¢ãƒ‡ãƒ¼ã‚¿ã?¸ã?®ã‚¢ã‚¯ã‚»ã‚¹ã‚’è¨±å?¯ã?•ã‚Œã‚‹å¤–éƒ¨é¡§å®¢ãƒ¦ãƒ¼ã‚¶ãƒ¼ãƒªã‚¹ãƒˆã?®è¿½åŠ ',0),(126896,3525,'pt','Adicionar a lista de clientes usuÃ¡rios externos para ser permitido o acesso a dados de cliente on-line',0),(126897,3525,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐºÐ¸ Ð²Ð½ÐµÑˆÐ½Ð¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ Ñ€Ð°Ð·Ñ€ÐµÑˆÐ°ÐµÑ‚ÑÑ Ð´Ð¾ÑÑ‚ÑƒÐ¿ Ðº ÐºÐ»Ð¸ÐµÐ½Ñ‚Ñƒ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¾Ð½-Ð»Ð°Ð¹Ð½',0),(126898,3525,'es','Agregar Listas de Usuarios que son Clientes Externos para Permitir Acceso a la Data en LÃ­nea de Clientes',0),(126899,3525,'de','FÃ¼gen Sie Listen von externen Kunden Benutzer erlaubt Kunden Daten On-Line zugÃ¤nglich',0),(126900,3525,'en','Add Lists of External Customer Users to be Allowed Access to Customer Data On-Line',0),(126901,3526,'is','',0),(126902,3526,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ ÙˆØ¯Ø³ØªÙ…Ø²Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(126903,3526,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ ÙˆØ¯Ø³ØªÙ…Ø²Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(126904,3526,'tr','Yeni bordro vergi bÃ¶lgesi Ekle',0),(126905,3526,'pl','Dodawanie nowej dzielnicy podatek od wynagrodzeÅ„',0),(126906,3526,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ñ‚Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(126907,3526,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù¹ÛŒÚ©Ø³ Ú©Û’ Ù†Ø¦Û’ Ø¶Ù„Ø¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(126908,3526,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð¾Ð±Ð»Ð°ÑÑ‚ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ',0),(126909,3526,'vi','ThÃªm Vá»‹ TrÃ­ BÃ¡o Thuáº¿ Má»›i Cho Báº£ng LÆ°Æ¡ng',0),(126910,3526,'af','Nuwe Loonrol Belasting Distrik Byvoeg',0),(126911,3526,'ro','Adauga taxa noua de salarizare',0),(126912,3526,'et','Lisa uus palgaarvestuse maksupiirkond',0),(126913,3526,'si','Dodajte novo okroÅ¾je davka na izplaÄane plaÄe',0),(126914,3526,'ba','Tambah Pajak Payroll',0),(126915,3526,'nl','Toevoegen van nieuwe Payroll belastingen District',0),(126916,3526,'fi','LisÃ¤Ã¤ uusi palkanlaskennan veropiiri',0),(126917,3526,'no','Legge til nye lÃ¸nn skatt distrikt',0),(126918,3526,'da','TilfÃ¸je nye Payroll Tax District',0),(126919,3526,'ko','ìƒˆë¡œìš´ ê¸‰ì—¬ ì„¸ê¸ˆ êµ¬ ì¶”ê°€',0),(126920,3526,'he','×œ×”×•×¡×™×£ ×ž×—×•×– ×ž×¡ ×”×©×›×¨ ×”×—×“×©',0),(126921,3526,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Ï€ÎµÏÎ¹Î¿Ï‡Î® Ï†ÏŒÏÎ¿Ï‚ Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½',0),(126922,3526,'zh','å¢žåŠ æ–°çš„å·¥èµ„ç¨ŽåŒº\r\n',0),(126923,3526,'sv','LÃ¤gg till nya lÃ¶n skatt distrikt',0),(126924,3526,'it','Aggiungere il nuovo quartiere di Payroll Tax',0),(126925,3526,'tl','',0),(126926,3526,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3629;&#3633;&#3605;&#3619;&#3634;&#3616;&#3634;&#3625;&#3637;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(126927,3526,'hi','à¤¨à¤ˆ à¤ªà¥‡à¤°à¥‹à¤² à¤Ÿà¥ˆà¤•à¥à¤¸ à¤œà¤¿à¤²à¥‡ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(126928,3526,'ms','Menambah kawasan Cukai gaji baru',0),(126929,3526,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù†Ø·Ù‚Ø© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(126930,3526,'fr','Ajouter le nouveau quartier de taxe sur la paie',0),(126931,3526,'jp','æ–°çµ¦ä¸Žç¨ŽåŒºåŸŸã?®è¿½åŠ ',0),(126932,3526,'pt','Adicionar novo distrito de imposto de folha de pagamento',0),(126933,3526,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ€Ð°Ð¹Ð¾Ð½ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(126934,3526,'es','Agregar Nuevo Impuesto Distrito para NÃ³mina',0),(126935,3526,'de','FÃ¼gen Sie neue Payroll Tax District',0),(126936,3526,'en','Add New Payroll Tax District',0),(126937,3527,'is','',0),(126938,3527,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(126939,3527,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(126940,3527,'tr','Vergi tÃ¼rÃ¼ Ekle',0),(126941,3527,'pl','DodaÄ‡ typ podatku',0),(126942,3527,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð´Ð°Ð½ÑŠÐº',0),(126943,3527,'ur','Ù¹ÛŒÚ©Ø³ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(126944,3527,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÑÑ‚Ð° ÐŸÐ”Ð’-Ð°',0),(126945,3527,'vi','ThÃªm Loáº¡i Thuáº¿ ',0),(126946,3527,'af','Belastingtipe Byvoeg',0),(126947,3527,'ro','Adauga tipuri de taxe ',0),(126948,3527,'et','Lisa maksutÃ¼Ã¼p',0),(126949,3527,'si','Dodaj izstavljenih',0),(126950,3527,'ba','Tambah Tipe Pajak',0),(126951,3527,'nl','Fiscale Type toevoegen',0),(126952,3527,'fi','ALV-tyyppi lisÃ¤Ã¤',0),(126953,3527,'no','Skatt Type legge',0),(126954,3527,'da','Skat Type tilfÃ¸je',0),(126955,3527,'ko','ì„¸ê¸ˆ ìœ í˜• ì¶”ê°€',0),(126956,3527,'he','×”×•×¡×¤×ª ×¡×•×’ ×ž×¡',0),(126957,3527,'el','Î¤ÏÏ€Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ',0),(126958,3527,'zh','å¢žåŠ æ–°ç¨Žç§\r\n',0),(126959,3527,'sv','Skatt typ lÃ¤gga till',0),(126960,3527,'it','Aggiungi tipo di tassa',0),(126961,3527,'tl','',0),(126962,3527,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3616;&#3634;&#3625;&#3637;',0),(126963,3527,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(126964,3527,'ms','Tambah jenis cukai',0),(126965,3527,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø¶Ø±ÙŠØ¨Ø©',0),(126966,3527,'fr','Type de taxe ajouter',0),(126967,3527,'jp','ç¨Žã?®ç¨®é¡žã‚’è¿½åŠ ',0),(126968,3527,'pt','Adicionar o tipo de imposto',0),(126969,3527,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿ ÐÐ°Ð»Ð¾Ð³Ð°',0),(126970,3527,'es','Agregar Tipo de Impuesto',0),(126971,3527,'de','Steuerart hinzufÃ¼gen',0),(126972,3527,'en','Tax Type Add',0),(126973,3528,'is','',0),(126974,3528,'dr','/  Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(126975,3528,'pr','Ø§ÙØ²ÙˆØ¯Ù† /  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(126976,3528,'tr','MÃ¼ÅŸteri Ekle/GÃ¼ncelle',0),(126977,3528,'pl','Dodaj/Aktualizuj klienta',0),(126978,3528,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(126979,3528,'ur','Ú¯Ø§ÛÚ© Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(126980,3528,'sr','ÐšÑƒÐ¿Ñ†Ð°/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(126981,3528,'vi','KhÃ¡ch HÃ ng ThÃªm/Cáº­p Nháº­t',0),(126982,3528,'af','Klant/KliÃ«nt Byvoeg/Opdateer',0),(126983,3528,'ro','Client Adauga/Actualizeaza',0),(126984,3528,'et','Lisa/Uuenda klienti',0),(126985,3528,'si','Kupec Dodaj/posodobi',0),(126986,3528,'ba','Tambah/Ganti Pelanggan',0),(126987,3528,'nl','Klant toevoegen/bijwerken',0),(126988,3528,'fi','Asiakas lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(126989,3528,'no','Kunde/Oppdater',0),(126990,3528,'da','Kunde TilfÃ¸j/opdater',0),(126991,3528,'ko','ê³ ê° ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(126992,3528,'he','×¢×“×›×•×Ÿ/×”×•×¡×¤×ª ×œ×§×•×—',0),(126993,3528,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(126994,3528,'zh','å¢žåŠ /æ›´æ–°å®¢æˆ·ä¿¡æ¯\r\n',0),(126995,3528,'sv','Kunden LÃ¤gg till/uppdatera',0),(126996,3528,'it','Aggiungere/aggiornare un cliente',0),(126997,3528,'tl','',0),(126998,3528,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(126999,3528,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(127000,3528,'ms','Baca Tambah/Kemaskini',0),(127001,3528,'ar','ØªØ­Ø¯ÙŠØ«/Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(127002,3528,'fr','Client ajouter/mettre Ã  jour',0),(127003,3528,'jp','é¡§å®¢ã?®è¿½åŠ /æ›´æ–°',0),(127004,3528,'pt','Cliente adicionar/atualizar',0),(127005,3528,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(127006,3528,'es','Agregar/Actualizar Cliente',0),(127007,3528,'de','Kunden hinzufÃ¼gen/aktualisieren',0),(127008,3528,'en','Customer Add/Update',0),(127009,3529,'is','',0),(127010,3529,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡',0),(127011,3529,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡',0),(127012,3529,'tr','BÃ¼tÃ§e Ekle/GÃ¼ncelle',0),(127013,3529,'pl','Dodaj/Popraw budÅ¼et',0),(127014,3529,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(127015,3529,'ur','Ø¨Ø¬Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(127016,3529,'sr','Ð‘ÑƒÑŸÐµÑ‚/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(127017,3529,'vi','ThÃªm/Cáº­p Nháº­t NgÃ¢n SÃ¡ch',0),(127018,3529,'af','Begroting Byvoeg/Opdateer',0),(127019,3529,'ro','Bugete Adauga/Actualizeaza',0),(127020,3529,'et','Eelarve lisamine/uuendamine',0),(127021,3529,'si','ProraÄun Dodaj/posodobi',0),(127022,3529,'ba','Tambah/Ganti Anggaran',0),(127023,3529,'nl','Begroting toevoegen/bijwerken',0),(127024,3529,'fi','Talousarvion lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(127025,3529,'no','Budsjett/Oppdater',0),(127026,3529,'da','Budget TilfÃ¸j/opdater',0),(127027,3529,'ko','ì˜ˆì‚° ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(127028,3529,'he','×”×•×¡×£/×¢×“×›×Ÿ ×ª×§×¦×™×‘',0),(127029,3529,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(127030,3529,'zh','é¢„ç®—å¢žåŠ /æ›´æ–°\r\n',0),(127031,3529,'sv','Budget LÃ¤gg till/uppdatera',0),(127032,3529,'it','Aggiungere/aggiornare un bilancio',0),(127033,3529,'tl','',0),(127034,3529,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(127035,3529,'hi','à¤¬à¤œà¤Ÿ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(127036,3529,'ms','Bajet Tambah/Kemaskini',0),(127037,3529,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(127038,3529,'fr','Ajouter/mise Ã  jour budgÃ©taire',0),(127039,3529,'jp','äºˆç®—è¿½åŠ /æ›´æ–°',0),(127040,3529,'pt','OrÃ§amento adicionar/atualizar',0),(127041,3529,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(127042,3529,'es','Agregar/Actualizar Presupuesto',0),(127043,3529,'de','Haushalt hinzufÃ¼gen/aktualisieren',0),(127044,3529,'en','Budget Add/Update',0),(127045,3530,'is','',0),(127046,3530,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø±',0),(127047,3530,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(127048,3530,'tr','MÃ¼ÅŸteri Ekle/GÃ¼ncelle',0),(127049,3530,'pl','Dodaj/Aktualizuj klienta',0),(127050,3530,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(127051,3530,'ur','Ú¯Ø§ÛÚ© Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(127052,3530,'sr','ÐšÑƒÐ¿Ñ†Ð°/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(127053,3530,'vi','ThÃªm/Cáº­p Nháº­t KhÃ¡ch HÃ ng',0),(127054,3530,'af','Klant/KliÃ«nt Byvoeg/Opdateer',0),(127055,3530,'ro','Client Adauga/Actualizeaza',0),(127056,3530,'et','Lisa/Uuenda klienti',0),(127057,3530,'si','Kupec Dodaj/posodobi',0),(127058,3530,'ba','Tambah/Ganti Pelanggan',0),(127059,3530,'nl','Klant toevoegen/bijwerken',0),(127060,3530,'fi','Asiakas lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(127061,3530,'no','Kunde/Oppdater',0),(127062,3530,'da','Kunde TilfÃ¸j/opdater',0),(127063,3530,'ko','ê³ ê° ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(127064,3530,'he','×¢×“×›×•×Ÿ/×”×•×¡×¤×ª ×œ×§×•×—',0),(127065,3530,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(127066,3530,'zh','å¢žåŠ /æ›´æ–°å®¢æˆ·\r\n',0),(127067,3530,'sv','Kunden LÃ¤gg till/uppdatera',0),(127068,3530,'it','Aggiungere/aggiornare un cliente',0),(127069,3530,'tl','',0),(127070,3530,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(127071,3530,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(127072,3530,'ms','Baca Tambah/Kemaskini',0),(127073,3530,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø²Ø¨ÙˆÙ†',0),(127074,3530,'fr','Client ajouter/mettre Ã  jour',0),(127075,3530,'jp','é¡§å®¢è¿½åŠ /æ›´æ–°',0),(127076,3530,'pt','Cliente adicionar/atualizar',0),(127077,3530,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(127078,3530,'es','Agregar/Actualizar Cliente',0),(127079,3530,'de','Kunden hinzufÃ¼gen/aktualisieren',0),(127080,3530,'en','Customer Add/Update',0),(127081,3531,'is','',0),(127082,3531,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯',0),(127083,3531,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(127084,3531,'tr','Ã‡alÄ±ÅŸan ekleyin/gÃ¼ncelleyin',0),(127085,3531,'pl','Pracownik Dodaj/Aktualizuj',0),(127086,3531,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(127087,3531,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(127088,3531,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(127089,3531,'vi','ThÃªm/Cáº­p Nháº­t NhÃ¢n ViÃªn',0),(127090,3531,'af','Werknemer Byvoeg/Opdateer ',0),(127091,3531,'ro','Angajat Adauga/Actualizeaza',0),(127092,3531,'et','Lisa/Uuenda tÃ¶Ã¶tajat',0),(127093,3531,'si','Zaposlenih Dodaj/posodobi',0),(127094,3531,'ba','Tambah/Ganti Karyawan',0),(127095,3531,'nl','Werknemer toevoegen/bijwerken',0),(127096,3531,'fi','TyÃ¶ntekijÃ¤n lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(127097,3531,'no','Ansatt/Oppdater',0),(127098,3531,'da','Medarbejder TilfÃ¸j/opdater',0),(127099,3531,'ko','ì§ì› ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(127100,3531,'he','×¢×“×›×•×Ÿ/×”×•×¡×¤×ª ×¢×•×‘×“',0),(127101,3531,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(127102,3531,'zh','é›‡å‘˜æ–°å¢ž/æ›´æ–°\r\n',0),(127103,3531,'sv','AnstÃ¤lld LÃ¤gg till/uppdatera',0),(127104,3531,'it','Aggiungere/aggiornare un dipendente',0),(127105,3531,'tl','',0),(127106,3531,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3649;&#3605;&#3585;&#3605;&#3656;&#3634;&#3591;&#3585;&#3633;&#3609;',0),(127107,3531,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(127108,3531,'ms','Pekerja Tambah/Kemaskini',0),(127109,3531,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù…ÙˆØ¸Ù',0),(127110,3531,'fr','EmployÃ© ajouter/mettre Ã  jour',0),(127111,3531,'jp','å¾“æ¥­å“¡è¿½åŠ /æ›´æ–°',0),(127112,3531,'pt','Empregado adicionar/atualizar',0),(127113,3531,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(127114,3531,'es','Empleado Agregar/Actualizar',0),(127115,3531,'de','Mitarbeiter hinzufÃ¼gen/aktualisieren',0),(127116,3531,'en','Employee Add/Update',0),(127117,3532,'is','',0),(127118,3532,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(127119,3532,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(127120,3532,'tr','Ã‡alÄ±ÅŸan bilgileri Ekle/GÃ¼ncelle',0),(127121,3532,'pl','Pracownik informacji Dodaj lub zaktualizuj',0),(127122,3532,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(127123,3532,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(127124,3532,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð”Ð¾Ð´Ð°Ñ˜/ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜',0),(127125,3532,'vi','ThÃªm/Cáº­p Nháº­t ThÃ´ng Tin Vá» NhÃ¢n ViÃªn',0),(127126,3532,'af','Werknemer Inligting Byvoeg/Opdateer ',0),(127127,3532,'ro','Informatii despre angajat Adauga/Actualizeaza',0),(127128,3532,'et','Lisa/Uuenda tÃ¶Ã¶taja informatsioon',0),(127129,3532,'si','Zaposleni informacije Dodaj/posodobi',0),(127130,3532,'ba','Tambah/Ganti Informasi Karyawan',0),(127131,3532,'nl','Werknemer informatie toevoegen/bijwerken',0),(127132,3532,'fi','TyÃ¶ntekijÃ¤n tiedot lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(127133,3532,'no','Ansatt/Oppdater informasjon',0),(127134,3532,'da','Medarbejder oplysninger TilfÃ¸j/opdater',0),(127135,3532,'ko','ì§ì› ì •ë³´ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(127136,3532,'he','×¢×“×›×•×Ÿ/×”×•×¡×¤×ª ×ž×™×“×¢ ×¢×•×‘×“',0),(127137,3532,'el','Î•ÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(127138,3532,'zh','å¢žåŠ /æ›´æ–°é›‡å‘˜èµ„æ–™\r\n',0),(127139,3532,'sv','LÃ¤gg till anstÃ¤lld-Information/uppdatera',0),(127140,3532,'it','Aggiunta/aggiornamento di informazioni di dipendente',0),(127141,3532,'tl','',0),(127142,3532,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3591;&#3611;&#3619;&#3640;&#3591; &#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(127143,3532,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(127144,3532,'ms','Pekerja maklumat Tambah/Kemaskini',0),(127145,3532,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÙˆØ¸Ù',0),(127146,3532,'fr','EmployÃ© informations ajouter/mettre Ã  jour',0),(127147,3532,'jp','å¾“æ¥­å“¡æƒ…å ±ã?®è¿½åŠ /æ›´æ–°',0),(127148,3532,'pt','FuncionÃ¡rio informaÃ§Ãµes adicionar/atualizar',0),(127149,3532,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ðž Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐµ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(127150,3532,'es','InformaciÃ³n de Empleado  Agregar/Actualizar',0),(127151,3532,'de','Mitarbeiter Informationen hinzufÃ¼gen oder aktualisieren',0),(127152,3532,'en','Employee Information Add/Update',0),(127153,3533,'is','',0),(127154,3533,'dr','Ù…Ø¯ÙŠØ±ÙŠØª',0),(127155,3533,'pr','Ù…Ø¯ÙŠØ±ÙŠØª',0),(127156,3533,'tr','Admin',0),(127157,3533,'pl','Admin',0),(127158,3533,'bg','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€',0),(127159,3533,'ur','Ø§ÛŒÚˆÙ…Ù†',0),(127160,3533,'sr','ÐÐ´Ð¼Ð¸Ð½',0),(127161,3533,'vi','Quáº£n Trá»‹',0),(127162,3533,'af','Admin',0),(127163,3533,'ro','Administrare',0),(127164,3533,'et','Haldamine',0),(127165,3533,'si','Nastavitve',0),(127166,3533,'ba','Admin',0),(127167,3533,'nl','Admin',0),(127168,3533,'fi','Admin',0),(127169,3533,'no','Admin',0),(127170,3533,'da','Admin',0),(127171,3533,'ko','ê´€ë¦¬ìž',0),(127172,3533,'he','× ×™×”×•×œ',0),(127173,3533,'el','Admin',0),(127174,3533,'zh','ç®¡ç†\r\n',0),(127175,3533,'sv','Admin',0),(127176,3533,'it','Admin',0),(127177,3533,'tl','',0),(127178,3533,'th','Admin',0),(127179,3533,'hi','à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤•',0),(127180,3533,'ms','Admin',0),(127181,3533,'ar','Ø§Ù„Ù…Ø´Ø±Ù',0),(127182,3533,'fr','Admin',0),(127183,3533,'jp','ç®¡ç?†',0),(127184,3533,'pt','Admin',0),(127185,3533,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸',0),(127186,3533,'es','Admin',0),(127187,3533,'de','Admin',0),(127188,3533,'en','Admin',0),(127189,3534,'is','',0),(127190,3534,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(127191,3534,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(127192,3534,'tr','VeritabanÄ± bilgileri',0),(127193,3534,'pl','Informacje o bazie danych',0),(127194,3534,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð‘Ð”',0),(127195,3534,'ur','ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(127196,3534,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð±Ð°Ð·Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(127197,3534,'vi','ThÃ´ng Tin Dá»¯ Liá»‡u',0),(127198,3534,'af','Databasis Inligting',0),(127199,3534,'ro','Info baza de date',0),(127200,3534,'et','Andmebaasi informatsioon',0),(127201,3534,'si','Informacije o zbirki podatkov',0),(127202,3534,'ba','Informasi database',0),(127203,3534,'nl','Database-informatie',0),(127204,3534,'fi','Tietokannan tiedot',0),(127205,3534,'no','Databaseinformasjon',0),(127206,3534,'da','Databaseoplysninger',0),(127207,3534,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì •ë³´',0),(127208,3534,'he','×ž×™×“×¢ ××•×“×•×ª ×ž×¡×“ × ×ª×•× ×™×',0),(127209,3534,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(127210,3534,'zh','æ•°æ®åº“ä¿¡æ¯ç®¡ç†\r\n',0),(127211,3534,'sv','Databasinformation',0),(127212,3534,'it','Informazioni del database',0),(127213,3534,'tl','',0),(127214,3534,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(127215,3534,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥‚à¤šà¤¨à¤¾',0),(127216,3534,'ms','Maklumat pangkalan data',0),(127217,3534,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(127218,3534,'fr','Information sur la base de donnÃ©es',0),(127219,3534,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã€?æƒ…å ±',0),(127220,3534,'pt','InformaÃ§Ãµes do banco de dados',0),(127221,3534,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð‘Ð°Ð·Ñ‹ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(127222,3534,'es','InformaciÃ³n de Base de Datos',0),(127223,3534,'de','Datenbankinformationen',0),(127224,3534,'en','Database Information',0),(127225,3535,'is','',0),(127226,3535,'dr','Ø§Ø¨Ø²Ø§Ø± Ù…Ø¯ÙŠØ±ÙŠØª â€“ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø±',0),(127227,3535,'pr','Ø§Ø¨Ø²Ø§Ø± Ù…Ø¯ÙŠØ±ÙŠØª â€“ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø±',0),(127228,3535,'tr','YÃ¶netim AraÃ§larÄ± - kullanÄ±cÄ± haklarÄ±',0),(127229,3535,'pl','NarzÄ™dzia administracyjne - praw uÅ¼ytkownika',0),(127230,3535,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð·Ð° Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½Ðµ - Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ñ€Ð°Ð²Ð°',0),(127231,3535,'ur','Ø§Ù†ØªØ¸Ø§Ù…ÛŒÛ Ù¹ÙˆÙ„Ø² - ØµØ§Ø±Ù Ú©Û’ Ø­Ù‚ÙˆÙ‚',0),(127232,3535,'sr','ÐÐ»Ð°Ñ‚ÐºÐµ Ð·Ð° Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ñƒ - ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ° Ð¿Ñ€Ð°Ð²Ð°',0),(127233,3535,'vi','CÃ´ng Cá»¥ Quáº£n Trá»‹ - Quyá»n NgÆ°á»i Sá»­ Dá»¥ng',0),(127234,3535,'af','Administrasie Gereedskap - Gebruikerregte',0),(127235,3535,'ro','Unelte administrare - Drepturi Utilizator',0),(127236,3535,'et','Administration Tools - kasutaja Ãµigused',0),(127237,3535,'si','SkrbniÅ¡ka orodja - uporabniÅ¡ke pravice',0),(127238,3535,'ba','Alat administrasi - hak pengguna',0),(127239,3535,'nl','Beheerprogramma\'s - gebruikersrechten',0),(127240,3535,'fi','HallintatyÃ¶kalut - kÃ¤yttÃ¶oikeudet',0),(127241,3535,'no','AdministrasjonsverktÃ¸y - brukerrettigheter',0),(127242,3535,'da','AdministrationsvÃ¦rktÃ¸jer - brugerrettigheder',0),(127243,3535,'ko','ê´€ë¦¬ ë„êµ¬-ì‚¬ìš©ìž ê¶Œí•œ',0),(127244,3535,'he','×›×œ×™ ×”× ×™×”×•×œ - ×–×›×•×™×•×ª ×ž×©×ª×ž×©',0),(127245,3535,'el','Î•ÏÎ³Î±Î»ÎµÎ¯Î± Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚ - Î´Î¹ÎºÎ±Î¹Ï‰Î¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÏ„Î·',0),(127246,3535,'zh','ç®¡ç†å·¥å…·-ç”¨æˆ·æƒé™\r\n',0),(127247,3535,'sv','Administration Tools - anvÃ¤ndarrÃ¤ttigheter',0),(127248,3535,'it','Strumenti di amministrazione - diritti utente',0),(127249,3535,'tl','',0),(127250,3535,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;-&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3606;&#3641;&#3585;&#3605;&#3657;&#',0),(127251,3535,'hi','à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤¨ à¤‰à¤ªà¤•à¤°à¤£ - à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(127252,3535,'ms','Alat pentadbiran - hak pengguna',0),(127253,3535,'ar','Ø£Ø¯ÙˆØ§Øª Ø§Ù„Ø¥Ø¯Ø§Ø±Ø©-Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(127254,3535,'fr','Outils d\'administration - droits de l\'utilisateur',0),(127255,3535,'jp','ç®¡ç?†ãƒ„ãƒ¼ãƒ«ã€€-ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©åˆ©',0),(127256,3535,'pt','Ferramentas de administraÃ§Ã£o - direitos de usuÃ¡rio',0),(127257,3535,'ru','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ñ‹Ðµ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ - ÐŸÑ€Ð°Ð²Ð° ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(127258,3535,'es','Herramientas de AdministraciÃ³n - Derechos de Usuarios',0),(127259,3535,'de','Administrations-Tools - Benutzerrechte',0),(127260,3535,'en','Administration Tools - User Rights',0),(127261,3536,'is','',0),(127262,3536,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø²Ø¦ÙŠØ§Øª Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(127263,3536,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø²Ø¦ÙŠØ§Øª Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(127264,3536,'tr','YaÅŸlanma ayrÄ±ntÄ± raporu',0),(127265,3536,'pl','Starzenie siÄ™ szczegÃ³Å‚owy raport',0),(127266,3536,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð°Ñ‚Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(127267,3536,'ur','Ø®Ø³ØªÛ ØªÙØµÛŒÙ„ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(127268,3536,'sr','Ð”Ð¾ÑÐ¿ÐµÐ²Ð°ÑšÐ° ÑÑ‚Ñ€Ð°Ð¶Ð° Ð½ÐµÐºÐ° ÑÐµ Ñ˜Ð°Ð²Ð¸',0),(127269,3536,'vi','BÃ¡o CÃ¡o Chi Tiáº¿t Tuá»•i Ná»£',0),(127270,3536,'af','Ouderdomsgedetaileerde Verslag',0),(127271,3536,'ro','Aging raport de tip detaliu',0),(127272,3536,'et','Aging Ã¼ksikasjalik aruanne',0),(127273,3536,'si','Aging podrobno poroÄilo',0),(127274,3536,'ba','Penuaan laporan rinci',0),(127275,3536,'nl','Veroudering Detail verslag',0),(127276,3536,'fi','IkÃ¤Ã¤ntyminen yksityiskohtainen raportti',0),(127277,3536,'no','Aldring detaljert rapport',0),(127278,3536,'da','Aging detaljeret rapport',0),(127279,3536,'ko','ì—ì´ì§• ì„¸ë¶€ ì •ë³´ ë³´ê³ ì„œ',0),(127280,3536,'he','×“×• ×— ×¤×™×¨×•×˜ ×”×–×“×§× ×•×ª',0),(127281,3536,'el','Î“Î®ÏÎ±Î½ÏƒÎ· ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½',0),(127282,3536,'zh','æ¬ æ•°åˆ†æžè¯¦ç»†æŠ¥è¡¨\r\n',0),(127283,3536,'sv','Ã…ldrande detalj rapport',0),(127284,3536,'it','Report dettagli invecchiamento',0),(127285,3536,'tl','',0),(127286,3536,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(127287,3536,'hi','à¤à¤œà¤¿à¤‚à¤— à¤µà¤¿à¤µà¤°à¤£ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(127288,3536,'ms','Penuaan terperinci Laporan',0),(127289,3536,'ar','ØªÙ‚Ø±ÙŠØ± ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©',0),(127290,3536,'fr','Rapport d\'antÃ©rioritÃ© en dÃ©tail',0),(127291,3536,'jp','ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°è©³ç´°ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(127292,3536,'pt','RelatÃ³rio de detalhe de envelhecimento',0),(127293,3536,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(127294,3536,'es','Informe de Detalles de AntigÃ¼edad',0),(127295,3536,'de','Alternde Detailbericht',0),(127296,3536,'en','Aging Detail Report',0),(127297,3537,'is','',0),(127298,3537,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ  ',0),(127299,3537,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ  ',0),(127300,3537,'tr','YaÅŸlanma - AyrÄ±ntÄ±lar',0),(127301,3537,'pl','Starzenie siÄ™ - szczegÃ³Å‚y',0),(127302,3537,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ - Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(127303,3537,'ur','Ø®Ø³ØªÛ - ØªÙØµÛŒÙ„Ø§Øª',0),(127304,3537,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ - Ð´ÐµÑ‚Ð°Ñ™Ð¸',0),(127305,3537,'vi','Chi Tiáº¿t Tuá»•i Ná»£',0),(127306,3537,'af','Ouderdom Details',0),(127307,3537,'ro','ÃŽmbÄƒtrÃ¢nirea - detalii',0),(127308,3537,'et','Vananemisega - Ã¼ksikasjad',0),(127309,3537,'si','Staranje - podrobnosti',0),(127310,3537,'ba','Penuaan - rincian',0),(127311,3537,'nl','Veroudering - Details',0),(127312,3537,'fi','IkÃ¤Ã¤ntyminen - tiedot',0),(127313,3537,'no','Aldring - detaljer',0),(127314,3537,'da','Aldring - detaljer',0),(127315,3537,'ko','ë…¸í™”-ì„¸ë¶€ ì‚¬í•­',0),(127316,3537,'he','×”×–×“×§× ×•×ª - ×¤×¨×˜×™×',0),(127317,3537,'el','Î“Î®ÏÎ±Î½ÏƒÎ· - Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(127318,3537,'zh','è©³ç´°å¹´åº¦æŽ’åº\r\n',0),(127319,3537,'sv','Ã…ldrande - Detaljer',0),(127320,3537,'it','Invecchiamento - dettagli',0),(127321,3537,'tl','',0),(127322,3537,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(127323,3537,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ - à¤µà¤¿à¤µà¤°à¤£',0),(127324,3537,'ms','Penuaan - butir-butir',0),(127325,3537,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©-Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(127326,3537,'fr','Vieillissement - dÃ©tails',0),(127327,3537,'jp','è€?åŒ–è©³ç´°',0),(127328,3537,'pt','Envelhecimento - detalhes',0),(127329,3537,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ - Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(127330,3537,'es','Deatlles de AntigÃ¼edad',0),(127331,3537,'de','Aging - Details',0),(127332,3537,'en','Aging - Details',0),(127333,3538,'is','',0),(127334,3538,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ  ',0),(127335,3538,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ  ',0),(127336,3538,'tr','Ã–zet raporu',0),(127337,3538,'pl','Podsumowanie raportu chronologicznego',0),(127338,3538,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(127339,3538,'ur','Ø®Ø³ØªÛ Ø®Ù„Ø§ØµÛ Ø±Ù¾ÙˆØ±Ù¹',0),(127340,3538,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÑÐ° Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ¾Ð¼',0),(127341,3538,'vi','BÃ¡o CÃ¡o Tá»•ng Há»£p Tuá»•i Ná»£',0),(127342,3538,'af','Ouderdoms Opsommingsverslag',0),(127343,3538,'ro','Raport de imbatranire',0),(127344,3538,'et','Vananemist KokkuvÃµttev aruanne',0),(127345,3538,'si','Aging zbirno poroÄilo',0),(127346,3538,'ba','Penuaan laporan ringkasan',0),(127347,3538,'nl','Samenvattend verslag veroudering',0),(127348,3538,'fi','IkÃ¤Ã¤ntyminen yhteenvetoraportti',0),(127349,3538,'no','Aldring sammendragsrapport',0),(127350,3538,'da','Aging sammenfattende rapport',0),(127351,3538,'ko','ì—ì´ì§• ìš”ì•½ ë³´ê³ ì„œ',0),(127352,3538,'he','×¡×™×›×•× ×“×•×— ×’×™×•×œ',0),(127353,3538,'el','Î£ÏÎ½Î¿ÏˆÎ· Î•Î½Î·Î»Î¹ÎºÎ¯Ï‰ÏƒÎ·Ï‚ Î¥Ï€Î¿Î».',0),(127354,3538,'zh','æ¬ æ•°åˆ†æžæ€»ç»“æŠ¥å‘Š\r\n',0),(127355,3538,'sv','Ã…ldrande Sammanfattning rapport',0),(127356,3538,'it','Relazione di sintesi di invecchiamento',0),(127357,3538,'tl','',0),(127358,3538,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3626;&#3619;&#3640;&#3611;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(127359,3538,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(127360,3538,'ms','Penuaan ringkasan laporan',0),(127361,3538,'ar','ØªÙ‚Ø±ÙŠØ± Ù…Ù„Ø®Ù‘Øµ Ø§Ù„ØªÙ‚Ø§Ø¯Ù…',0),(127362,3538,'fr','Rapport sommaire d\'antÃ©rioritÃ©',0),(127363,3538,'jp','ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°ã‚µãƒžãƒªãƒ¼ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(127364,3538,'pt','RelatÃ³rio resumido do envelhecimento',0),(127365,3538,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ ÑÐ²Ð¾Ð´Ð½Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(127366,3538,'es','Informe de Resumen de AntigÃ¼edad',0),(127367,3538,'de','Alterung zusammenfassenden Bericht',0),(127368,3538,'en','Aging Summary Report',0),(127369,3539,'is','',0),(127370,3539,'dr','Ù…Ù‚Ø§Ø¯ÙŠØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ÙƒØ§Ø±ÙØ±Ù…Ø§ Ø¨Ù‡ Ù†ÙŠØ§Ø¨Øª Ø§Ø² ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(127371,3539,'pr','Ù…Ù‚Ø§Ø¯ÙŠØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ÙƒØ§Ø±ÙØ±Ù…Ø§ Ø¨Ù‡ Ù†ÙŠØ§Ø¨Øª Ø§Ø² ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(127372,3539,'tr','Ä°ÅŸveren tarafÄ±ndan iÅŸÃ§inin adÄ±na Ã¶denen tutarlar',0),(127373,3539,'pl','Kwoty wypÅ‚acone przez pracodawcÄ™ w imieniu pracownika',0),(127374,3539,'bg','Ð¡ÑƒÐ¼Ð¸, Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸ Ð¾Ñ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»Ñ Ð¾Ñ‚ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ñ',0),(127375,3539,'ur','Ø¢Ø¬Ø± Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ø¬Ø§Ù†Ø¨ Ø³Û’ Ø§Ø¯Ø§ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(127376,3539,'sr','ÐŸÐ»Ð°Ñ›Ð°Ð»Ð¸ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð¿Ð¾ÑÐ»Ð¾Ð´Ð°Ð²Ñ†Ð° Ñƒ Ð¸Ð¼Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(127377,3539,'vi','Sá»‘ Tiá»n CÃ´ng Ty ÄÃ£ Tráº£ Há»™ NhÃ¢n ViÃªn',0),(127378,3539,'af','Bedrae Betaal deur die Werkgewer namens die Werknemer',0),(127379,3539,'ro','Sumele plÄƒtite de angajator pentru angajaÈ›i',0),(127380,3539,'et','TÃ¶Ã¶taja tÃ¶Ã¶andja poolt makstud summad',0),(127381,3539,'si','Zneski, ki jih delodajalec plaÄa v imenu zaposlenega',0),(127382,3539,'ba','Jumlah yang dibayar oleh majikan atas nama karyawan',0),(127383,3539,'nl','Namens de werknemer door de werkgever betaalde bedragen',0),(127384,3539,'fi','TyÃ¶nantajan tyÃ¶ntekijÃ¤n puolesta suorittamat',0),(127385,3539,'no','BelÃ¸pene betales av arbeidsgiver pÃ¥ vegne av ansatt',0),(127386,3539,'da','BelÃ¸b, der betales af arbejdsgiveren for medarbejderen',0),(127387,3539,'ko','ì§ì› ëŒ€ì‹  ê³ ìš©ì£¼ì— ì˜í•´ ì§€ë¶ˆ í•˜ëŠ” ê¸ˆì•¡',0),(127388,3539,'he','×”×¡×›×•×ž×™× ×©×©×•×œ×ž×• ×¢×œ ×™×“×™ ×”×ž×¢×¡×™×§ ×ž×˜×¢× ×”×¢×•×‘×“',0),(127389,3539,'el','Î Î¿ÏƒÎ¬ Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ Ï„Î¿Î½ ÎµÏÎ³Î¿Î´ÏŒÏ„Î· ÎµÎ¾ Î¿Î½ÏŒÎ¼Î±Ï„Î¿Ï‚ Î¿ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚',0),(127390,3539,'zh','ç”±é›‡ä¸»ä»£é›‡å‘˜æ”¯ä»˜é¡¹\r\n',0),(127391,3539,'sv','Belopp som betalats av arbetsgivaren fÃ¶r anstÃ¤llde',0),(127392,3539,'it','Importi versati dal datore di lavoro per conto del dipendente',0),(127393,3539,'tl','',0),(127394,3539,'th','&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3650;&#3604;&#3618;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3648;&#3614;&#3639;&#3656;&#3629;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(127395,3539,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥€ à¤“à¤° à¤¸à¥‡ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(127396,3539,'ms','Jumlah yang dibayar oleh majikan bagi pihak pekerja',0),(127397,3539,'ar','Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„ØªÙŠ ÙŠØ¯ÙØ¹Ù‡Ø§ ØµØ§Ø­Ø¨ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù†ÙŠØ§Ø¨Ø© Ø¹Ù† Ø§Ù„Ù…ÙˆØ¸Ù',0),(127398,3539,'fr','Montants versÃ©s par l\'employeur au nom de l\'employÃ©',0),(127399,3539,'jp','å¾“æ¥­å“¡ã?«ã?‹ã‚?ã?£ã?¦é›‡ç”¨ä¸»ã?Œæ”¯æ‰•ã?£ã?Ÿç·?é¡?',0),(127400,3539,'pt','Montantes pagados pelo empregador em nome do empregado',0),(127401,3539,'ru','Ð¡ÑƒÐ¼Ð¼Ñ‹, Ð²Ñ‹Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»ÐµÐ¼ Ð¾Ñ‚ Ð¸Ð¼ÐµÐ½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(127402,3539,'es','Cantidades Pagados por el PatrÃ³n por Parte del Empleado',0),(127403,3539,'de','Im Namen des Arbeitnehmers vom Arbeitgeber bezahlten BetrÃ¤ge',0),(127404,3539,'en','Amounts Paid by Employer on Behalf of the Employee',0),(127405,3540,'is','',0),(127406,3540,'dr','ØªØ¹ÙŠÙŠÙ† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø§Ø³Ù†Ø§Ø¯ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡',0),(127407,3540,'pr','ØªØ¹ÙŠÙŠÙ† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø§Ø³Ù†Ø§Ø¯ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡',0),(127408,3540,'tr','GruplandÄ±rma yÃ¼klenen belgeler iÃ§in kullanÄ±lacak kategorileri atamak',0),(127409,3540,'pl','Przypisywanie kategorii, ktÃ³re majÄ… byÄ‡ uÅ¼ywane do grupowanie przesÅ‚ane dokumenty',0),(127410,3540,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð·Ð° Ð³Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ñ‡ÐµÐ½Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(127411,3540,'ur','Ú¯Ø±ÙˆÙ¾Ù†Ú¯ Ø§Ù¾ Ù„ÙˆÚˆ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ Ú©Ø±Ù†Û’ Ú©Û’ Ø²Ù…Ø±Û’ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(127412,3540,'sr','Ð”Ð¾Ð´ÐµÑ™Ð¸Ð²Ð°ÑšÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ñ›Ðµ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ð¸ÑÐ°ÑšÐµ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð°',0),(127413,3540,'vi','Chá»‰ Äá»‹nh CÃ¡c PhÃ¢n Loáº¡i sá»­ dá»¥ng cho táº£i cÃ¡c nhÃ³m tÃ i liá»‡u ',0),(127414,3540,'af','Skryf KategoriÃ« toe om gebruik te word vir Groepering van Opgelaaide Dokumente',0),(127415,3540,'ro','Atribui categorii pentru a fi utilizate pentru gruparea Ã®ncÄƒrcat documente',0),(127416,3540,'et','MÃ¤Ã¤ra sisupÃµhised kategooriad kasutatakse eest rÃ¼hmituse Ã¼leslaaditud dokumendid',0),(127417,3540,'si','Dodeli kategorije za zdruÅ¾evanje Uploaded dokumenti',0),(127418,3540,'ba','Kategori yang digunakan untuk Mengelompokkan dokumen ter-upload',0),(127419,3540,'nl','CategorieÃ«n worden gebruikt voor groeperen geÃ¼pload documenten toewijzen',0),(127420,3540,'fi','MÃ¤Ã¤rittÃ¤Ã¤ luokkia kÃ¤ytetÃ¤Ã¤n ryhmittelyÃ¤ Ladatut asiakirjat',0),(127421,3540,'no','Tildele kategorier brukes til gruppering lastet opp dokumenter',0),(127422,3540,'da','Tildele kategorier til gruppering uploadede dokumenter',0),(127423,3540,'ko','ì—…ë¡œë“œ ë¬¸ì„œ ê·¸ë£¹í™”ì— ì‚¬ìš©í•  ë²”ì£¼ë¥¼ ì§€ì •',0),(127424,3540,'he','×œ×”×§×¦×•×ª ×§×˜×’×•×¨×™×•×ª ×›×“×™ ×œ×©×ž×© ×¢×‘×•×¨ ×ž×¡×ž×›×™× ×©× ×˜×¢× ×• ×§×™×‘×•×¥',0),(127425,3540,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ Î¿Î¼Î±Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï†Î¿ÏÏ„ÏŽÎ¸Î·ÎºÎµ Î­Î³Î³ÏÎ±Ï†Î±',0),(127426,3540,'zh','æŒ‡å®šç±»åˆ«ç”¨äºŽåˆ†ç»„ä¸Šè½½çš„æ–‡ä»¶\r\n',0),(127427,3540,'sv','Tilldela kategorier som anvÃ¤nds fÃ¶r gruppering uppladdade dokument',0),(127428,3540,'it','Assegnare categorie da utilizzare per documenti caricati di raggruppamento',0),(127429,3540,'tl','',0),(127430,3540,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3627;&#3617;&#3623;&#3604;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(127431,3540,'hi','à¤¸à¤®à¥‚à¤¹à¥€à¤•à¤°à¤£ à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤¿à¤ à¤—à¤ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(127432,3540,'ms','Menguntukkan kategori untuk digunakan bagi Kumpulan muat naik dokumen',0),(127433,3540,'ar','ØªØ¹ÙŠÙŠÙ† ÙØ¦Ø§Øª Ø§Ø³ØªØ®Ø¯Ø§Ù…Ù‡Ø§ \"ØªØ¬Ù…ÙŠØ¹ Ø§Ù„ÙˆØ«Ø§Ø¦Ù‚ ØªÙ… Ø§Ù„Ø±ÙØ¹\"',0),(127434,3540,'fr','Affecter des catÃ©gories Ã  utiliser pour le regroupement les Documents tÃ©lÃ©chargÃ©s',0),(127435,3540,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰æ¸ˆæ–‡æ›¸åˆ†é¡žã?®ç‚ºã?«ä½¿ç”¨ã?™ã‚‹ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’å‰²ã‚Šå½“ã?¦ã‚‹',0),(127436,3540,'pt','Atribuir categorias a ser usado para documentos enviados de agrupamento',0),(127437,3540,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð±ÑƒÐ´ÑƒÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒÑÑ Ð´Ð»Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð·Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ñ‹',0),(127438,3540,'es','Asignar CategorÃ­as que se usa para Agrupar Documentos Subidos',0),(127439,3540,'de','Zuweisen von Kategorien fÃ¼r Gruppierung hochgeladen Dokumente verwendet werden',0),(127440,3540,'en','Assign Categories to be used for Grouping Uploaded Documents',0),(127441,3541,'is','',0),(127442,3541,'dr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡',0),(127443,3541,'pr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡',0),(127444,3541,'tr','BilanÃ§o',0),(127445,3541,'pl','Bilans',0),(127446,3541,'bg','Ð‘Ð°Ð»Ð°Ð½ÑÐ¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(127447,3541,'ur','Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹',0),(127448,3541,'sr','Ð‘Ð¸Ð»Ð°Ð½Ñ ÑÑ‚Ð°ÑšÐ°',0),(127449,3541,'vi','Báº£ng cÃ¢n Ä‘á»‘i',0),(127450,3541,'af','Balansstaat',0),(127451,3541,'ro','BilanÈ›',0),(127452,3541,'et','Saldoteatis',0),(127453,3541,'si','Bilance stanja',0),(127454,3541,'ba','Neraca',0),(127455,3541,'nl','Balans',0),(127456,3541,'fi','Taseen',0),(127457,3541,'no','Balanse',0),(127458,3541,'da','Balancen',0),(127459,3541,'ko','ëŒ€ì°¨ ëŒ€ì¡°í‘œ',0),(127460,3541,'he','×”×ž××–×Ÿ',0),(127461,3541,'el','Î™ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(127462,3541,'zh','èµ„äº§è´Ÿå€ºè¡¨\r\n',0),(127463,3541,'sv','BalansrÃ¤kningen',0),(127464,3541,'it','Stato patrimoniale',0),(127465,3541,'tl','',0),(127466,3541,'th','&#3651;&#3610;&#3591;&#3610;&#3604;&#3640;&#3621;',0),(127467,3541,'hi','à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ',0),(127468,3541,'ms','Kunci kira-kira',0),(127469,3541,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¹Ù…ÙˆÙ…ÙŠØ©',0),(127470,3541,'fr','Bilan',0),(127471,3541,'jp','ãƒ?ãƒ©ãƒ³ã‚¹ã‚·ãƒ¼ãƒˆ',0),(127472,3541,'pt','Do balanÃ§o',0),(127473,3541,'ru','Ð‘Ð°Ð»Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(127474,3541,'es','Balance General',0),(127475,3541,'de','Bilanz',0),(127476,3541,'en','Balance Sheet',0),(127477,3542,'is','',0),(127478,3542,'dr','Ø¹Ù…Ù„ÙŠØ§Øª Ù†ØµØ¨ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ',0),(127479,3542,'pr','Ø¹Ù…Ù„ÙŠØ§Øª Ù†ØµØ¨ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ',0),(127480,3542,'tr','Fatura iÃ§in temel kurulum iÅŸlevleri',0),(127481,3542,'pl','Funkcji podstawowej konfiguracji dla pÅ‚atnoÅ›ci',0),(127482,3542,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ð½Ð¸Ñ‚Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(127483,3542,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Û’ Ø¨Ù†ÛŒØ§Ø¯ÛŒ Ø§ÙØ¹Ø§Ù„',0),(127484,3542,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð° Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ñƒ',0),(127485,3542,'vi','Chá»©c NÄƒng Setup CÆ¡ Báº£n Cho TK Pháº£i Thu',0),(127486,3542,'af','Basiese opstelling funksies vir fakturering',0),(127487,3542,'ro','FuncÅ£iile de bazÄƒ de configurare pentru facturare',0),(127488,3542,'et','Seadistustoimingute pÃµhi arved',0),(127489,3542,'si','Osnovno nastavitev funkcije za zaraÄunavanje',0),(127490,3542,'ba','Konfigurasi dasar fungsi untuk penagihan',0),(127491,3542,'nl','Basisinstellingen functies voor facturering',0),(127492,3542,'fi','Perusasetukset toiminnot laskutukseen',0),(127493,3542,'no','Grunnoppsett funksjoner for fakturering',0),(127494,3542,'da','GrundlÃ¦ggende opsÃ¦tningsfunktioner for Billing',0),(127495,3542,'ko','ê²°ì œì— ëŒ€ í•œ ê¸°ë³¸ ì„¤ì • ê¸°ëŠ¥',0),(127496,3542,'he','×›×™×•×•× ×•×Ÿ ×‘×¡×™×¡×™ ×¤×•× ×§×¦×™×•×ª ×¢×‘×•×¨ ×—×™×•×‘',0),(127497,3542,'el','Î’Î±ÏƒÎ¹ÎºÎ® ÏÏÎ¸Î¼Î¹ÏƒÎ· Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚ Î³Î¹Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(127498,3542,'zh','åº”æ”¶æ¬¾é¡¹åŸºæœ¬è®¾ç½®åŠŸèƒ½\r\n',0),(127499,3542,'sv','GrundlÃ¤ggande instÃ¤llning funktioner fÃ¶r fakturering',0),(127500,3542,'it','Funzioni di configurazione di base per la fatturazione',0),(127501,3542,'tl','',0),(127502,3542,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3627;&#3609;&#3657;&#3634;&#3607;&#3637;&#3656;&#3614;&#3639;&#3657;&#3609;&#3600;&#3634;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3',0),(127503,3542,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥à¤¨à¤¿à¤¯à¤¾à¤¦à¥€ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¤¾à¤°à¥à¤¯',0),(127504,3542,'ms','Fungsi-fungsi asas persediaan bagi bil',0),(127505,3542,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø£Ø³Ø§Ø³ÙŠØ© Ù„Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(127506,3542,'fr','Fonctions de base de configuration pour la facturation',0),(127507,3542,'jp','å?—å?–å‹˜å®šã?®åŸºæœ¬è¨­å®šæ©Ÿèƒ½',0),(127508,3542,'pt','FunÃ§Ãµes de configuraÃ§Ã£o bÃ¡sica para o faturamento',0),(127509,3542,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð´Ð»Ñ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(127510,3542,'es','Funciones de ConfiguraciÃ³n Basica para Cuentas por Cobrar',0),(127511,3542,'de','Basis-Setup-Funktionen fÃ¼r die Fakturierung',0),(127512,3542,'en','Basic Setup Functions for Billing',0),(127513,3543,'is','',0),(127514,3543,'dr','Ù…Ø²Ø§ÙŠØ§ÙŠ Ø­Ù‚ÙˆÙ‚ Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ø¨Ù‡ Ø¬Ø§ÙŠ Ø´Ø®Øµ Ø®Ø§Øµ',0),(127515,3543,'pr','Ù…Ø²Ø§ÙŠØ§ÙŠ Ø­Ù‚ÙˆÙ‚ Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ø¨Ù‡ Ø¬Ø§ÙŠ Ø´Ø®Øµ Ø®Ø§Øµ',0),(127516,3543,'tr','Birey yerine grup iÃ§in faydalarÄ± (Ã¶deme)',0),(127517,3543,'pl','KorzyÅ›ci (pÅ‚atna) dla grupy, a nie osoby',0),(127518,3543,'bg','ÐžÐ±ÐµÐ·Ñ‰ÐµÑ‚ÐµÐ½Ð¸Ñ (Pay) Ð·Ð° Ð³Ñ€ÑƒÐ¿Ð°, Ð° Ð½Ðµ Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¾ Ð»Ð¸Ñ†Ðµ',0),(127519,3543,'ur','ÙØ±Ø¯ Ú©ÛŒ Ø¨Ø¬Ø§Ø¦Û’ Ú¯Ø±ÙˆÙ¾ Ú©Û’ Ù„Ø¦Û’ ÙˆØ¸Ø§Ø¦Ù (ØªÙ†Ø®ÙˆØ§Û)',0),(127520,3543,'sr','ÐŸÑ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ (Ð¿Ð»Ð°Ñ‚Ð°) Ð·Ð° Ð³Ñ€ÑƒÐ¿Ñƒ, Ð° Ð½Ðµ Ð·Ð° Ð¿Ð¾Ñ˜ÐµÐ´Ð¸Ð½Ñ†Ð°',0),(127521,3543,'vi','Lá»£i Ã­ch (Tráº£) cho nhÃ³m hÆ¡n lÃ  cho cÃ¡ nhÃ¢n',0),(127522,3543,'af','Voordele (betaal) vir die groep, eerder as die individu',0),(127523,3543,'ro','Beneficiile (plata) pentru grup, mai degrabÄƒ decÃ¢t Individual',0),(127524,3543,'et','Kasu (palga) grupp, mitte uksikute',0),(127525,3543,'si','Ugodnosti (plaÄilo) za skupine namesto posameznih',0),(127526,3543,'ba','Manfaat (Pay) untuk grup daripada individu',0),(127527,3543,'nl','Voordelen (Pay) voor de groep in plaats van individuele',0),(127528,3543,'fi','Edut (Pay) ryhmÃ¤ kuin yksilÃ¶n',0),(127529,3543,'no','Fordeler (Pay) for gruppen i stedet for individuelle',0),(127530,3543,'da','Fordele (lÃ¸n) til gruppen frem for individuelle',0),(127531,3543,'ko','ê°œì¸ ë³´ë‹¤ëŠ” ê·¸ë£¹ì— ëŒ€ í•œ í˜œíƒ (ìœ ë£Œ)',0),(127532,3543,'he','×”×˜×‘×•×ª (×ª×©×œ×•×) ×¢×‘×•×¨ ×§×‘×•×¦×” ×•×œ× ×‘×•×“×“×™×',0),(127533,3543,'el','ÎŸÏ†Î­Î»Î· (Pay) Î³Î¹Î± Ï„Î·Î½ Î¿Î¼Î¬Î´Î± ÎºÎ±Î¹ ÏŒÏ‡Î¹ Î¼ÎµÎ¼Î¿Î½Ï‰Î¼Î­Î½ÎµÏ‚',0),(127534,3543,'zh','åˆ©ç›Šï¼ˆæ”¶è´¹ï¼‰çš„æ˜¯é›†å›¢è€Œä¸æ˜¯ä¸ªäºº\r\n',0),(127535,3543,'sv','FÃ¶rdelar (lÃ¶n) fÃ¶r gruppen snarare Ã¤n individen',0),(127536,3543,'it','Benefici (a pagamento) per il gruppo piuttosto che l\'individuo',0),(127537,3543,'tl','',0),(127538,3543,'th','&#3626;&#3636;&#3607;&#3608;&#3636;&#3611;&#3619;&#3632;&#3650;&#3618;&#3594;&#3609;&#3660;(&#3592;&#3656;&#3634;&#3618;)&#3586;&#3629;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3607;&#3637;&#3656;&#3604;&#3637;&#3585;&#3623;&#3656;&#3634;&#3586;&#3629;&',0),(127539,3543,'hi','à¤¸à¤®à¥‚à¤¹ à¤•à¥‡ à¤¬à¤œà¤¾à¤¯ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤­ (à¤­à¥à¤—à¤¤à¤¾à¤¨)',0),(127540,3543,'ms','Manfaat (gaji) untuk Kumpulan dan bukannya individu',0),(127541,3543,'ar','Ø§Ù„ÙÙˆØ§Ø¦Ø¯ (Ø§Ù„Ø£Ø¬Ø±) Ù„Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© ÙˆÙ„ÙŠØ³ Ø§Ù„ÙØ±Ø¯',0),(127542,3543,'fr','Avantages (payante) pour groupe plutÃ´t qu\'individuel',0),(127543,3543,'jp','å€‹äººã?¨ã?„ã?†ã‚ˆã‚Šã‚€ã?—ã‚?ã‚°ãƒ«ãƒ¼ãƒ—ã?®çµ¦ä»˜é‡‘ï¼ˆçµ¦ä¸Žï¼‰',0),(127544,3543,'pt','BenefÃ­cios (pagamento) para o grupo, ao invÃ©s de indivÃ­duo',0),(127545,3543,'ru','ÐŸÑ€ÐµÐ¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð° (Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹) Ð´Ð»Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð²Ð¼ÐµÑÑ‚Ð¾ Ð¸Ð½Ð´Ð¸Ð²Ð¸Ð´ÑƒÐ°Ð»ÑŒÐ½Ñ‹Ñ…',0),(127546,3543,'es','Beneficios (Pagos) para el Grupo en Lugar del Individuo',0),(127547,3543,'de','Vorteile (Pay) fÃ¼r Gruppe eher als Individuum',0),(127548,3543,'en','Benefits (Pay) for Group Rather than Individual',0),(127549,3544,'is','',0),(127550,3544,'dr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(127551,3544,'pr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(127552,3544,'tr','Fatura',0),(127553,3544,'pl','Rozliczenia',0),(127554,3544,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(127555,3544,'ur','Ø­Ø³Ø§Ø¨ Ú©Ø±Ù†Ø§',0),(127556,3544,'sr','ÐÐ°Ð¿Ð»Ð°Ñ‚Ðµ',0),(127557,3544,'vi','Thanh ToÃ¡n',0),(127558,3544,'af','Verekening (RO)',0),(127559,3544,'ro','Venituri',0),(127560,3544,'et','Arvete esitamine',0),(127561,3544,'si','RaÄuni',0),(127562,3544,'ba','Penagihan',0),(127563,3544,'nl','Facturering',0),(127564,3544,'fi','Laskutus',0),(127565,3544,'no','Fakturering',0),(127566,3544,'da','Fakturering',0),(127567,3544,'ko','ê²°ì œ',0),(127568,3544,'he','×—×™×•×‘×™×',0),(127569,3544,'el','Î§ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(127570,3544,'zh','å¸å•\r\n',0),(127571,3544,'sv','Fakturering',0),(127572,3544,'it','Fatturazione',0),(127573,3544,'tl','',0),(127574,3544,'th','&#3623;&#3634;&#3591;&#3610;&#3636;&#3621;(AR)',0),(127575,3544,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤—',0),(127576,3544,'ms','Bil',0),(127577,3544,'ar','Ø§Ù„ÙÙˆØªØ±Ø©',0),(127578,3544,'fr','Facturation',0),(127579,3544,'jp','è«‹æ±‚',0),(127580,3544,'pt','Faturamento',0),(127581,3544,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð°',0),(127582,3544,'es','Clientes',0),(127583,3544,'de','Abrechnung',0),(127584,3544,'en','Billing',0),(127585,3545,'is','',0),(127586,3545,'dr','Ù„ÙŠØ³Øª ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(127587,3545,'pr','Ù„ÙŠØ³Øª ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(127588,3545,'tr','Ã‡alÄ±ÅŸan doÄŸum listesi',0),(127589,3545,'pl','Lista pracownikÃ³w urodziny',0),(127590,3545,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ñ€Ð¾Ð¶Ð´ÐµÐ½ Ð´ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº',0),(127591,3545,'ur','Ù…Ù„Ø§Ø²Ù… Ø³Ø§Ù„Ú¯Ø±Û Ú©ÛŒ ÙÛØ±Ø³Øª',0),(127592,3545,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ñ€Ð¾Ñ’ÐµÐ½Ð´Ð°Ð½',0),(127593,3545,'vi','Danh sÃ¡ch ngÃ y sinh nhÃ¢n viÃªn',0),(127594,3545,'af','Werknemer Verjaarsdaglys',0),(127595,3545,'ro','Lista de ziua de nastere angajat',0),(127596,3545,'et','TÃ¶Ã¶taja sÃ¼nnipÃ¤ev nimekiri',0),(127597,3545,'si','Seznam zaposlenih rojstni dan',0),(127598,3545,'ba','Karyawan ulang daftar',0),(127599,3545,'nl','Lijst van de verjaardag van de werknemer',0),(127600,3545,'fi','SyntymÃ¤pÃ¤ivÃ¤ tyÃ¶ntekijÃ¤luettelo',0),(127601,3545,'no','Bursdag ListeOverAnsatte',0),(127602,3545,'da','Medarbejder fÃ¸dselsdag liste',0),(127603,3545,'ko','ì§ì› ìƒì¼ ëª©ë¡',0),(127604,3545,'he','×¨×©×™×ž×ª ×™×ž×™ ×”×•×œ×“×ª ×©×œ ×”×¢×•×‘×“×™×',0),(127605,3545,'el','Î“ÎµÎ½Î­Î¸Î»Î¹Î± ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Ï‰Î½',0),(127606,3545,'zh','å‘˜å·¥ç”Ÿæ—¥ä¼šåå•\r\n',0),(127607,3545,'sv','Personallista fÃ¶delsedag',0),(127608,3545,'it','Elenco di compleanno dei dipendenti',0),(127609,3545,'tl','',0),(127610,3545,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3623;&#3633;&#3609;&#3648;&#3585;&#3636;&#3604;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(127611,3545,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤œà¤¨à¥à¤®à¤¦à¤¿à¤¨ à¤¸à¥‚à¤šà¥€',0),(127612,3545,'ms','Senarai hari lahir pekerja',0),(127613,3545,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ¸Ù Ø¹ÙŠØ¯ Ù…ÙŠÙ„Ø§Ø¯',0),(127614,3545,'fr','Liste des employÃ©s anniversaire',0),(127615,3545,'jp','å¾“æ¥­å“¡èª•ç”Ÿæ—¥ãƒªã‚¹ãƒˆ',0),(127616,3545,'pt','Lista de aniversÃ¡rio de empregados',0),(127617,3545,'ru','Ð”Ð½Ð¸ Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(127618,3545,'es','Empleados, Lista de CumpleaÃ±os',0),(127619,3545,'de','Geburtstag-Mitarbeiterliste',0),(127620,3545,'en','Employee Birthday List',0),(127621,3546,'is','',0),(127622,3546,'dr','Ù„ÙŠØ³Øª ØµÙˆØ±Øª Ù…ÙˆØ§Ø¯',0),(127623,3546,'pr','Ù„ÙŠØ³Øª ØµÙˆØ±Øª Ù…ÙˆØ§Ø¯',0),(127624,3546,'tr','AÄžACI listesi',0),(127625,3546,'pl','Lista BOM',0),(127626,3546,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÐšÐ˜',0),(127627,3546,'ur','Ø¨Ø§Ù… Ú©ÛŒ ÙÛØ±Ø³Øª',0),(127628,3546,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ð°',0),(127629,3546,'vi','Danhs sÃ¡ch BOM',0),(127630,3546,'af','BOM lys',0),(127631,3546,'ro','Lista BOM',0),(127632,3546,'et','Tootmiskomplektide loend',0),(127633,3546,'si','Seznam Kosovnic',0),(127634,3546,'ba','Daftar BOM',0),(127635,3546,'nl','BOM lijst',0),(127636,3546,'fi','Tuoterak.',0),(127637,3546,'no','Produksjonsstykkliste-oversikt',0),(127638,3546,'da','Styklisten liste',0),(127639,3546,'ko','BOM ëª©ë¡',0),(127640,3546,'he','×¨×©×™×ž×ª BOM',0),(127641,3546,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Ï€ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†ÏŽÎ½',0),(127642,3546,'zh','ç‰©æ–™æ¸…å•\r\n',0),(127643,3546,'sv','BOM lista',0),(127644,3546,'it','Elenco BOM',0),(127645,3546,'tl','',0),(127646,3546,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3656;&#3634;&#3623;&#3633;&#3626;&#3604;&#3640;',0),(127647,3546,'hi','BOM à¤¸à¥‚à¤šà¥€',0),(127648,3546,'ms','Senarai BOM',0),(127649,3546,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø´Ø¬Ø±Ø© Ø§Ù„Ù…ÙˆØ§Ø¯',0),(127650,3546,'fr','Liste de nomenclature',0),(127651,3546,'jp','BOMãƒªã‚¹ãƒˆ',0),(127652,3546,'pt','Lista BOM',0),(127653,3546,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(127654,3546,'es','Lista BOM',0),(127655,3546,'de','BOM-Liste',0),(127656,3546,'en','BOM List',0),(127657,3547,'is','',0),(127658,3547,'dr','Ù„ÙŠØ³Øª Ø¨ÙˆØ¯Ø¬Ù‡',0),(127659,3547,'pr','Ù„ÙŠØ³Øª Ø¨ÙˆØ¯Ø¬Ù‡',0),(127660,3547,'tr','BÃ¼tÃ§e listesi',0),(127661,3547,'pl','Lista budÅ¼etu',0),(127662,3547,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ ÑÐ¿Ð¸ÑÑŠÐº',0),(127663,3547,'ur','Ø¨Ø¬Ù¹ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(127664,3547,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ð»Ð¸ÑÑ‚Ðµ',0),(127665,3547,'vi','Danh sÃ¡ch NgÃ¢n sÃ¡ch',0),(127666,3547,'af','Begrotinglys',0),(127667,3547,'ro','Lista buget',0),(127668,3547,'et','Eelarve loend',0),(127669,3547,'si','ProraÄun seznam',0),(127670,3547,'ba','Daftar anggaran',0),(127671,3547,'nl','Begroting lijst',0),(127672,3547,'fi','Budjetti luetteloon',0),(127673,3547,'no','Budsjett liste',0),(127674,3547,'da','Budget liste',0),(127675,3547,'ko','ì˜ˆì‚° ëª©ë¡',0),(127676,3547,'he','×¨×©×™×ž×ª ×ª×§×¦×™×‘',0),(127677,3547,'el','Î›Î¯ÏƒÏ„Î± Ï„Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(127678,3547,'zh','é¢„ç®—æ¸…å•\r\n',0),(127679,3547,'sv','Budget lista',0),(127680,3547,'it','Elenco di bilancio',0),(127681,3547,'tl','',0),(127682,3547,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(127683,3547,'hi','à¤¬à¤œà¤Ÿ à¤¸à¥‚à¤šà¥€',0),(127684,3547,'ms','Senarai bajet',0),(127685,3547,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª',0),(127686,3547,'fr','Liste de budget',0),(127687,3547,'jp','äºˆç®—ãƒªã‚¹ãƒˆ',0),(127688,3547,'pt','Lista de orÃ§amento',0),(127689,3547,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(127690,3547,'es','Lista de Presupuestos',0),(127691,3547,'de','Budget-Liste',0),(127692,3547,'en','Budget List',0),(127693,3548,'is','',0),(127694,3548,'dr','Ø§Ø®ØªÙ„Ø§Ù Ø¨ÙˆØ¯Ø¬Ù‡',0),(127695,3548,'pr','Ø§Ø®ØªÙ„Ø§Ù Ø¨ÙˆØ¯Ø¬Ù‡',0),(127696,3548,'tr','BÃ¼tÃ§e varyans',0),(127697,3548,'pl','BudÅ¼et wariancji',0),(127698,3548,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð¸ Ð¾Ñ‚ÐºÐ»Ð¾Ð½ÐµÐ½Ð¸Ñ',0),(127699,3548,'ur','Ø¨Ø¬Ù¹ ØªØºÛŒØ±',0),(127700,3548,'sr','ÐžÐ´ÑÑ‚ÑƒÐ¿Ð°ÑšÐµ Ð¾Ð´ Ð±ÑƒÑŸÐµÑ‚Ð°',0),(127701,3548,'vi','ChÃªnh lá»‡ch NgÃ¢n sÃ¡ch',0),(127702,3548,'af','Begroting Afwyking',0),(127703,3548,'ro','Variatii de buget',0),(127704,3548,'et','Eelarve erinevus',0),(127705,3548,'si','Varianca proraÄuna',0),(127706,3548,'ba','Varians anggaran',0),(127707,3548,'nl','Begroting variantie',0),(127708,3548,'fi','Budjetin varianssin',0),(127709,3548,'no','Budsjett avvik',0),(127710,3548,'da','Budget afvigelse',0),(127711,3548,'ko','ì˜ˆì‚° ë¶„ì‚°',0),(127712,3548,'he','×¡×˜×™×™×ª ×ª×§×¦×™×‘',0),(127713,3548,'el','Î”Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ· Ï„Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(127714,3548,'zh','é¢„ç®—å·®å¼‚\r\n',0),(127715,3548,'sv','Budget varians',0),(127716,3548,'it','Variazione di bilancio',0),(127717,3548,'tl','',0),(127718,3548,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3649;&#3611;&#3619;&#3611;&#3619;&#3623;&#3609;',0),(127719,3548,'hi','à¤¬à¤œà¤Ÿ à¤µà¤¿à¤šà¤°à¤£',0),(127720,3548,'ms','Persekitaran variasi bajet',0),(127721,3548,'ar','Ø¥Ø®ØªÙ„Ø§Ù Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(127722,3548,'fr','Ã‰cart budgÃ©taire',0),(127723,3548,'jp','äºˆç®—åˆ†æ•£',0),(127724,3548,'pt','VariaÃ§Ã£o de orÃ§amento',0),(127725,3548,'ru','Ð Ð°Ð·Ð»Ð¸Ñ‡Ð¸Ðµ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(127726,3548,'es','Presupuesto VariaciÃ³n',0),(127727,3548,'de','Budgetabweichung',0),(127728,3548,'en','Budget Variance',0),(127729,3549,'is','',0),(127730,3549,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªÙ…Ø§Ù… Ù…Ø§Ù„ÙŠØ§Øª Ùˆ Ø­Ù‚ÙˆÙ‚ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ ',0),(127731,3549,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªÙ…Ø§Ù… Ù…Ø§Ù„ÙŠØ§Øª Ùˆ Ø­Ù‚ÙˆÙ‚ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ ',0),(127732,3549,'tr','DÃ¶nemin bÃ¼tÃ¼n maaÅŸ ve vergi hesaplamak',0),(127733,3549,'pl','ObliczyÄ‡ wszystkie wynagrodzeÅ„ i podatkÃ³w za okres',0),(127734,3549,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(127735,3549,'ur','Ù…Ø¯Øª Ú©Û’ Ù„ÛŒÛ’ ØªÙ…Ø§Ù… ØªÙ†Ø®ÙˆØ§Û Ø§ÙˆØ± Ù¹ÛŒÚ©Ø³ Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(127736,3549,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ˜ ÑÐ²Ðµ Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð·Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(127737,3549,'vi','TÃ­nh táº¥t cáº£ thanh toÃ¡n & thuáº¿t cho thá»i ká»³',0),(127738,3549,'af','Bereken alle Loon en Belastings vir Periode',0),(127739,3549,'ro','Se calculeazÄƒ toate platÄƒ ÅŸi impozite pentru perioada',0),(127740,3549,'et','Palga ja maksude arvutamiseks ajavahemiku',0),(127741,3549,'si','IzraÄun plaÄe in davkov za obdobje',0),(127742,3549,'ba','Menghitung semua gaji dan pajak untuk periode',0),(127743,3549,'nl','Berekent alle betalen en belastingen voor de periode',0),(127744,3549,'fi','Laskea kaikki maksu ja verot ajanjaksolta',0),(127745,3549,'no','Beregne alle lÃ¸nn og skatt for periode',0),(127746,3549,'da','Beregne alle lÃ¸n og skatter for perioden',0),(127747,3549,'ko','ê¸°ê°„ì— ëŒ€ í•œ ëª¨ë“  ê¸‰ì—¬ ë° ì„¸ê¸ˆ ê³„ì‚°',0),(127748,3549,'he','×œ×—×™×©×•×‘ ×©×›×¨ ×•×ž×™×¡×™× ×›×œ ×ª×§×•×¤×ª',0),(127749,3549,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯ÏƒÏ„Îµ ÏŒÎ»Î± Ï„Î± Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ ÎºÎ±Î¹ Ï†ÏŒÏÎ¿Ï…Ï‚ Î³Î¹Î± Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(127750,3549,'zh','è®¡ç®—æœŸé—´å†…æ‰€æœ‰æ”¶è´¹å’Œç¨Žæ”¶çš„\r\n',0),(127751,3549,'sv','BerÃ¤kna alla lÃ¶ner och skatter fÃ¶r Period',0),(127752,3549,'it','Calcolare tutte le paga e le tasse per il periodo',0),(127753,3549,'tl','',0),(127754,3549,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3632;&#3616;&#3634;&#3625;&#3637;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3586;&#3',0),(127755,3549,'hi','à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤µà¥‡à¤¤à¤¨ à¤”à¤° à¤•à¤°à¥‹à¤‚ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(127756,3549,'ms','Kira semua gaji dan cukai untuk tempoh',0),(127757,3549,'ar','Ø­Ø³Ø§Ø¨ ÙƒØ§ÙØ© Ø§Ù„Ø£Ø¬ÙˆØ± ÙˆØ§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ù„Ù„ÙØªØ±Ø©',0),(127758,3549,'fr','Calculer tous les payants et les Taxes pour la pÃ©riode',0),(127759,3549,'jp','æœŸé–“ä¸­ã?®æ”¯æ‰•ã?¨ç¨Žé‡‘ã‚’è¨ˆç®—',0),(127760,3549,'pt','Calcular todos os salÃ¡rios e impostos por perÃ­odo',0),(127761,3549,'ru','Ð Ð°ÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð²ÑÐµ ÐžÐ¿Ð»Ð°Ñ‚Ñ‹ Ð¸ ÐÐ°Ð»Ð¾Ð³Ð¸ Ð·Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(127762,3549,'es','Calcular Todsos los Pagos y Impuestos por PeriÃ³do',0),(127763,3549,'de','Alle Zahlen und Steuern fÃ¼r Zeitraum berechnen',0),(127764,3549,'en','Calculate all Pay and Taxes for Period',0),(127765,3550,'is','',0),(127766,3550,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø³ÙˆØ¯',0),(127767,3550,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø³ÙˆØ¯',0),(127768,3550,'tr','Faiz hesaplama',0),(127769,3550,'pl','ObliczyÄ‡ odsetki',0),(127770,3550,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ñ‚ Ð»Ð¸Ñ…Ð²Ð¸',0),(127771,3550,'ur','Ø³ÙˆØ¯ Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(127772,3550,'sr','ÐžÐ±Ñ€Ð°Ñ‡ÑƒÐ½ ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(127773,3550,'vi','TÃ­nh lÃ£i suáº¥t',0),(127774,3550,'af','Bereken Rente',0),(127775,3550,'ro','Calcul dobanda',0),(127776,3550,'et','Arvuta viivis',0),(127777,3550,'si','IzraÄun obresti',0),(127778,3550,'ba','Menghitung bunga',0),(127779,3550,'nl','Rente berekenen',0),(127780,3550,'fi','Korko lasketaan',0),(127781,3550,'no','Beregne rente',0),(127782,3550,'da','Renteberegning',0),(127783,3550,'ko','ì´ìžë¥¼ ê³„ì‚°',0),(127784,3550,'he','×—×©×‘ ×¨×™×‘×™×ª',0),(127785,3550,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯ÏƒÎµÎ¹ Ï„Î¿Î½ Ï„ÏŒÎºÎ¿ ÎºÎ±Î¹',0),(127786,3550,'zh','è®¡ç®—åˆ©æ¯\r\n',0),(127787,3550,'sv','BerÃ¤kna rÃ¤nta',0),(127788,3550,'it','Calcolare gli interessi',0),(127789,3550,'tl','',0),(127790,3550,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;',0),(127791,3550,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(127792,3550,'ms','Mengira faedah',0),(127793,3550,'ar','Ø±Ø¨Ø§ - Ø²Ù‚ÙˆÙ…',0),(127794,3550,'fr','Calculer les intÃ©rÃªts',0),(127795,3550,'jp','åˆ©æ?¯è¨ˆç®—',0),(127796,3550,'pt','Calcular juros',0),(127797,3550,'ru','Ð Ð°ÑÑ‡ÐµÑ‚ ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(127798,3550,'es','Calcular InterÃ©ses',0),(127799,3550,'de','Zinsen berechnen',0),(127800,3550,'en','Calculate Interest',0),(127801,3551,'is','',0),(127802,3551,'dr','( ØªØ¹ÙˆÛŒÙ‚',0),(127803,3551,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø³ÙˆØ¯ Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ú¯Ø°Ø´ØªÙ‡( Ù…Ø¹ÙˆÙ‚',0),(127804,3551,'tr','GecikmiÅŸ faturalarÄ±na faiz hesaplama',0),(127805,3551,'pl','ObliczyÄ‡ odsetki od zalegÅ‚ych faktur',0),(127806,3551,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ñ…Ð²Ð¸ Ð¿Ð¾ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(127807,3551,'ur','Ù…ÙˆØ®Ø± ÙˆØ¨Ø¬Ù„ÛŒ Ù¾Ø± Ø³ÙˆØ¯ Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(127808,3551,'sr','ÐžÐ±Ñ€Ð°Ñ‡ÑƒÐ½ ÐºÐ°Ð¼Ð°Ñ‚Ð° Ñƒ Ð´Ð¾ÑÐ¿ÐµÐ»Ð¸Ð¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð°',0),(127809,3551,'vi','TÃ­nh lÃ£i suáº¥t trÃªn hÃ³a Ä‘Æ¡n quÃ¡ háº¡n',0),(127810,3551,'af','Bereken Rente op Agterstallige Fakture',0),(127811,3551,'ro','Calcul dobanda la facturi cu termen depasit',0),(127812,3551,'et','Arvuta tÃ¤htaja Ã¼letanud arvete viivis',0),(127813,3551,'si','IzraÄun obresti za zapadle raÄune',0),(127814,3551,'ba','Menghitung bunga jatuh tempo faktur',0),(127815,3551,'nl','Berekenen van rente op achterstallige facturen',0),(127816,3551,'fi','Lasketaan korko erÃ¤Ã¤ntyneitÃ¤ laskuja',0),(127817,3551,'no','Beregnes rente pÃ¥ forfalte fakturaer',0),(127818,3551,'da','Beregne renter pÃ¥ forfaldne fakturaer',0),(127819,3551,'ko','ê¸°í•œì´ ì§€ë‚œ ì†¡ìž¥ì— ëŒ€ í•œ ì´ìž ê³„ì‚°',0),(127820,3551,'he','×—×™×©×•×‘ ×¨×™×‘×™×ª ×¢×œ ×—×©×‘×•× ×™×•×ª ×©×¤×¨×¢×•× ×Ÿ ×—×œ×£',0),(127821,3551,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Ï„Ï‰Î½ Ï„ÏŒÎºÏ‰Î½ ÏƒÏ„Î± Î»Î·Î¾Î¹Ï€ÏÏŒÎ¸ÎµÏƒÎ¼Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(127822,3551,'zh','è®¡ç®—åˆ©æ¯é€¾æœŸå‘ç¥¨\r\n',0),(127823,3551,'sv','BerÃ¤kna rÃ¤nta pÃ¥ fÃ¶rfallna fakturor',0),(127824,3551,'it','Calcolare interessi su fatture scadute',0),(127825,3551,'tl','',0),(127826,3551,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(127827,3551,'hi','à¤…à¤¤à¤¿à¤¦à¥‡à¤¯ à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¤° à¤¬à¥à¤¯à¤¾à¤œ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(127828,3551,'ms','Mengira faedah ke atas invois-invois yang tertunggak',0),(127829,3551,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(127830,3551,'fr','Calculer les intÃ©rÃªts sur les factures en souffrance',0),(127831,3551,'jp','æœŸé™?çµŒé?Žè«‹æ±‚æ›¸ã?®åˆ©å­?ã‚’è¨ˆç®—',0),(127832,3551,'pt','Calcular juros sobre faturas em atraso',0),(127833,3551,'ru','Ð Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹ Ð·Ð° Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐºÑƒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(127834,3551,'es','Calcular InterÃ©ses sobre Facturas Vencidas',0),(127835,3551,'de','Berechnen Sie Verzugszinsen bei Ã¼berfÃ¤lligen Rechnungen',0),(127836,3551,'en','Calculate Interest on Overdue Invoices',0),(127837,3552,'is','',0),(127838,3552,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø·Ø±Ø­ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø¯Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÙŠØ¯  ØªØºÙŠÙŠØ±Ø§Øª ØªØ§Ø±ÙŠØ® Ù‡Ø§ Ùˆ ØºÙŠØ±Ù‡',0),(127839,3552,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø·Ø±Ø­ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø¯Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÙŠØ¯  ØªØºÙŠÙŠØ±Ø§Øª ØªØ§Ø±ÙŠØ® Ù‡Ø§ Ùˆ ØºÙŠØ±Ù‡',0),(127840,3552,'tr','Yeni sipariÅŸler, deÄŸiÅŸikliklerin tarihleri, vb eklemek iÃ§in yeni program hesaplayÄ±n.',0),(127841,3552,'pl','ObliczyÄ‡ nowy harmonogram, aby uwzglÄ™dniÄ‡ nowe zamÃ³wienia, zmiany daty, itp.',0),(127842,3552,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð³Ñ€Ð°Ñ„Ð¸Ðº Ð´Ð° ÑÐµ Ð²ÐºÐ»ÑŽÑ‡Ð°Ñ‚ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð² Ð´Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¸ Ð´Ñ€.',0),(127843,3552,'ur','Ù†Ø¦Û’ Ø§Ø­Ú©Ø§Ù… Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ØŒ ØªØ§Ø±ÛŒØ®ÙˆÚºØŒ ÙˆØºÛŒØ±Û Ù…ÛŒÚº ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù†Ø¦ÛŒ Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ÛŒ Ú©Ø§ ØªØ®Ù…ÛŒÙ†Û Ù„Ú¯Ø§ØªÛ’ ÛÛŒÚº Û”',0),(127844,3552,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÐºÑ™ÑƒÑ‡Ð¸Ð»Ð¸ Ð½Ð¾Ð²Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ, Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð´Ð°Ñ‚ÑƒÐ¼Ðµ, Ð¸Ñ‚Ð´.',0),(127845,3552,'vi','TÃ­nh lá»‹ch trÃ¬nh má»›i bao gá»“m Ä‘Æ¡n hÃ ng má»›i, thay Ä‘á»•i ngÃ y, vv',0),(127846,3552,'af','Bereken Nuwe Skedule om nuwe bestellings, veranderinge tot op datum, ens.',0),(127847,3552,'ro','Calcula noul program pentru a include comenzi noi, modificÄƒrile dvs., etc.',0),(127848,3552,'et','Arvuta uus graafik, et see hÃµlmaks uusi tellimusi, kuupÃ¤evamuutusi jne',0),(127849,3552,'si','IzraÄuna nov urnik vkljuÄiti nova naroÄila, spremembe datumov, itd.',0),(127850,3552,'ba','Menghitung jadwal baru untuk memasukkan perintah baru, perubahan tanggal, dll.',0),(127851,3552,'nl','Berekenen nieuwe schema op te nemen nieuwe orders, wijzigingen in de datums, enz.',0),(127852,3552,'fi','Laske uusi aikataulu sisÃ¤ltÃ¤Ã¤ uusia tilauksia, muutosten pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t, jne.',0),(127853,3552,'no','Beregne nye planen Ã¥ ta nye ordrer endringer i datoer, etc.',0),(127854,3552,'da','Beregne nye tidsplan til at omfatte nye ordrer, Ã¦ndringer af datoer, osv.',0),(127855,3552,'ko','ìƒˆë¡œìš´ ìˆœì„œ, ë‚ ì§œ, ë“±ë“±ì— ëŒ€ í•œ ë³€ê²½ ë‚´ìš©ì„ í¬í•¨ í•˜ë„ë¡ ìƒˆë¡œìš´ ì¼ì •ì„ ê³„ì‚° í•©ë‹ˆë‹¤.',0),(127856,3552,'he','×œ×—×©×‘ ××ª ×œ×•×— ×”×–×ž× ×™× ×”×—×“×© ×›×“×™ ×œ×›×œ×•×œ ×¤×§×•×“×•×ª ×—×“×©×•×ª, ×©×™× ×•×™×™× ×ª××¨×™×›×™×, ×•×›×• \'.',0),(127857,3552,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÎ¹ Î½Î­ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚, Î±Î»Î»Î±Î³Î­Ï‚ ÏƒÏ„Î¹Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚, ÎºÎ»Ï€.',0),(127858,3552,'zh','è®¡ç®—æ–°çš„é™„è¡¨ï¼ŒåŒ…æ‹¬æ–°è®¢å•ï¼Œå…‘æ¢æ—¥æœŸç­‰',0),(127859,3552,'sv','BerÃ¤kna nytt schema till att omfatta nya bestÃ¤llningar, fÃ¶rÃ¤ndringar av datum, etc.',0),(127860,3552,'it','Calcolare la nuova pianificazione per includere nuovi ordini, cambiamenti di date, ecc.',0),(127861,3552,'tl','',0),(127862,3552,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3588;&#3635;&#3609;&#3623;&#3603;&#3651;&#3627;&#3617;&#3656;&#3607;&#3637;&#3656;&#3619;&#3623;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;,&#3648;&#3611;&#',0),(127863,3552,'hi','à¤¨à¤ à¤†à¤¦à¥‡à¤¶, à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤, à¤†à¤¦à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤ à¤•à¤¾à¤°à¥à¤¯à¤•à¥à¤°à¤® à¤•à¥€ à¤—à¤£à¤¨à¤¾à¥¤',0),(127864,3552,'ms','Pengiraan jadual baru termasuk perintah-perintah yang baru, perubahan dalam tarikh, dan lain-lain.',0),(127865,3552,'ar','Ø­Ø³Ø§Ø¨ \"Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø²Ù…Ù†ÙŠ Ø§Ù„Ø¬Ø¯ÙŠØ¯\" ØªØ´Ù…Ù„ Ø£ÙˆØ§Ù…Ø± Ø¬Ø¯ÙŠØ¯Ø©ØŒ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø¥Ù„Ù‰ Ø§Ù„ØªÙˆØ§Ø±ÙŠØ®ØŒ Ø¥Ù„Ø®.',0),(127866,3552,'fr','Calculer le nouveau barÃ¨me d\'inclure de nouvelles commandes, changements de dates, etc..',0),(127867,3552,'jp','æ–°è¦?æ³¨æ–‡ã€?å¤‰æ›´ã?ªã?©ã‚’å?«ã‚€ã?Ÿã‚?ã?®æ–°ã?—ã?„ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ«ã‚’è¨ˆç”»ã?™ã‚‹',0),(127868,3552,'pt','Calcule a nova rotina para incluir novas encomendas, mudanÃ§as de datas, etc.',0),(127869,3552,'ru','Ð Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ð¾Ðµ Ñ€Ð°ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð´Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ Ð½Ð¾Ð²Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð², Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð´Ð°Ñ‚Ñ‹ Ð¸ Ñ‚.Ð´.',0),(127870,3552,'es','Calcular Nueva Agenda para incluir nuevos pedidos, cambios a las fechas, etc.',0),(127871,3552,'de','Berechnen Sie Neuer Zeitplan fÃ¼r neue Bestellungen, Ã„nderungen an Daten, etc. enthalten.',0),(127872,3552,'en','Calculate New Schedule to include new orders, changes to dates, etc.',0),(127873,3553,'is','',0),(127874,3553,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø­Ù‚ÙˆÙ‚ ',0),(127875,3553,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø­Ù‚ÙˆÙ‚ ',0),(127876,3553,'tr','(Vergi) hesaplamak',0),(127877,3553,'pl','Obliczenia (zapÅ‚aciÄ‡ podatki)',0),(127878,3553,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° (Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð´Ð°Ð½ÑŠÑ†Ð¸)',0),(127879,3553,'ur','(ØªÙ†Ø®ÙˆØ§Û Ù¹ÛŒÚ©Ø³ Ù†ÛÛŒÚº) Ú©Ø§ ØªØ®Ù…ÛŒÙ†Û Ù„Ú¯Ø§ØªÛ’ ÛÛŒÚº',0),(127880,3553,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ˜ (Ð¿Ð»Ð°Ñ›Ð°Ñ˜Ñƒ Ð¿Ð¾Ñ€ÐµÐ·Ðµ)',0),(127881,3553,'vi','TÃ­nh/Tráº£ thuáº¿',0),(127882,3553,'af','Bereken/Betaal Belastings',0),(127883,3553,'ro','Calcula (plata impozitelor)',0),(127884,3553,'et','Arvuta/Maksa makse',0),(127885,3553,'si','IzraÄun (plaÄilo davkov)',0),(127886,3553,'ba','Menghitung (membayar pajak)',0),(127887,3553,'nl','Berekenen (betalen belastingen)',0),(127888,3553,'fi','Laske (maksaa veroja)',0),(127889,3553,'no','Beregne (betale skatt)',0),(127890,3553,'da','Beregn (betale skat)',0),(127891,3553,'ko','ê³„ì‚° (ì„¸ê¸ˆ ì§€ë¶ˆ)',0),(127892,3553,'he','×©×œ×/×—×©×‘ ×ž×™×¡×™×',0),(127893,3553,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ (Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Ï†ÏŒÏÎ¿Ï…Ï‚)',0),(127894,3553,'zh','è®¡ç®—/çº³ç¨Ž\r\n',0),(127895,3553,'sv','BerÃ¤kna (betalar skatt)',0),(127896,3553,'it','Calcolare (paga le tasse)',0),(127897,3553,'tl','',0),(127898,3553,'th','&#3588;&#3635;&#3609;&#3623;&#3603;/&#3592;&#3656;&#3634;&#3618; &#3616;&#3634;&#3625;&#3637;',0),(127899,3553,'hi','(à¤µà¥‡à¤¤à¤¨ à¤•à¤°à¥‹à¤‚) à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(127900,3553,'ms','Mengira (membayar cukai)',0),(127901,3553,'ar','Ø­Ø³Ø§Ø¨ (Ø¯ÙØ¹ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨)',0),(127902,3553,'fr','Calculer (Pay Taxes)',0),(127903,3553,'jp','ç¨Žã€€è¨ˆç®—/æ”¯æ‰•ã?„',0),(127904,3553,'pt','Calcular (pagar impostos)',0),(127905,3553,'ru','Ð Ð°ÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ/Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ ÐÐ°Ð»Ð¾Ð³Ð¸',0),(127906,3553,'es','Calcular/Pagar Impuestos',0),(127907,3553,'de','Berechnung (Steuern zahlen)',0),(127908,3553,'en','Calculate (Pay Taxes)',0),(127909,3554,'is','',0),(127910,3554,'dr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ ',0),(127911,3554,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ ',0),(127912,3554,'tr','ZamanlamayÄ± hesaplamak',0),(127913,3554,'pl','ObliczyÄ‡ harmonogram',0),(127914,3554,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»Ð¸ Ð³Ñ€Ð°Ñ„Ð¸Ðº',0),(127915,3554,'ur','Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ÛŒ Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(127916,3554,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ˜ Ð¿Ð»Ð°Ð½',0),(127917,3554,'vi','TÃ­nh lá»‹ch trÃ¬nh',0),(127918,3554,'af','Bereken Skedule',0),(127919,3554,'ro','Calcula programul',0),(127920,3554,'et','Arvuta ajakava',0),(127921,3554,'si','IzraÄun urnika',0),(127922,3554,'ba','Menghitung jadwal',0),(127923,3554,'nl','Planning berekenen',0),(127924,3554,'fi','Laskee',0),(127925,3554,'no','Beregne tidsplan',0),(127926,3554,'da','Beregne tidsplan',0),(127927,3554,'ko','ì¼ì •ì„ ê³„ì‚°',0),(127928,3554,'he','×—×©×‘ ×œ×•×— ×–×ž× ×™×',0),(127929,3554,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯ÏƒÎµÎ¹ Ï„Î¿ Ï‡ÏÎ¿Î½Î¿Î´Î¹Î¬Î³ÏÎ±Î¼Î¼Î±',0),(127930,3554,'zh','è®¡ç®—è¡¨\r\n',0),(127931,3554,'sv','BerÃ¤kna schema',0),(127932,3554,'it','Calcolare il calendario',0),(127933,3554,'tl','',0),(127934,3554,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3605;&#3634;&#3619;&#3634;&#3591;',0),(127935,3554,'hi','à¤…à¤¨à¥à¤¸à¥‚à¤šà¥€ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(127936,3554,'ms','Mengira Jadual',0),(127937,3554,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø²Ù…Ù†ÙŠ',0),(127938,3554,'fr','Calculer le calendrier',0),(127939,3554,'jp','æ—¥ç¨‹ã?®è¨ˆç®—',0),(127940,3554,'pt','Calcular a agenda',0),(127941,3554,'ru','Ð Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð³Ñ€Ð°Ñ„Ð¸Ðº',0),(127942,3554,'es','Calcular Agenda',0),(127943,3554,'de','Terminplan berechnen',0),(127944,3554,'en','Calculate Schedule',0),(127945,3555,'is','',0),(127946,3555,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ÙŠ Ú¯Ø±ÙˆÙ‡',0),(127947,3555,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ÙŠ Ú¯Ø±ÙˆÙ‡',0),(127948,3555,'tr','Madde Kategori Listesi',0),(127949,3555,'pl','Lista kategorii elementÃ³w',0),(127950,3555,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸Ñ‚Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(127951,3555,'ur','Ø´Û’ Ø²Ù…Ø±Û ÙÛØ±Ø³Øª',0),(127952,3555,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(127953,3555,'vi','Danh sÃ¡ch thá»ƒ loáº¡i hÃ ng',0),(127954,3555,'af','Item Kategorie Lys',0),(127955,3555,'ro','Lista de categorie articol',0),(127956,3555,'et','Ãœksuse kategooria nimekiri',0),(127957,3555,'si','Element seznama zvrsti',0),(127958,3555,'ba','Daftar kategori item',0),(127959,3555,'nl','Categorie itemlijst',0),(127960,3555,'fi','Luokka Nimikeluettelo',0),(127961,3555,'no','Elementet kategorilisten',0),(127962,3555,'da','Kategori elementlisten',0),(127963,3555,'ko','í•­ëª© ë²”ì£¼ ëª©ë¡',0),(127964,3555,'he','×¨×©×™×ž×ª ×”×§×˜×’×•×¨×™×•×ª ×”×¤×¨×™×˜',0),(127965,3555,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ¹Î´ÏŽÎ½',0),(127966,3555,'zh','é¡¹ç›®åˆ†ç±»åˆ—è¡¨\r\n',0),(127967,3555,'sv','Kategori Artikellista',0),(127968,3555,'it','Elenco di elementi di categoria',0),(127969,3555,'tl','',0),(127970,3555,'th','&#3619;&#3634;&#3618;&#3594;&#3639;&#3656;&#3629;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(127971,3555,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¥‚à¤šà¥€',0),(127972,3555,'ms','Senarai kategori barangan',0),(127973,3555,'ar','Ù‚Ø§Ø¦Ù…Ø© ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(127974,3555,'fr','Liste d\'Ã©lÃ©ments de catÃ©gorie',0),(127975,3555,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ãƒªã‚¹ãƒˆ',0),(127976,3555,'pt','Lista de categoria de item',0),(127977,3555,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(127978,3555,'es','Lista de Items de CategorÃ­a',0),(127979,3555,'de','Artikelliste der Kategorie',0),(127980,3555,'en','Item Category List',0),(127981,3556,'is','',0),(127982,3556,'dr','ØªØºÙŠÙŠØ± Ù†Ø§Ù… Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø§Ù†ÙˆØ§Ø¹ Ø­Ø³Ø§Ø¨',0),(127983,3556,'pr','ØªØºÙŠÙŠØ± Ù†Ø§Ù… Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø§Ù†ÙˆØ§Ø¹ Ø­Ø³Ø§Ø¨',0),(127984,3556,'tr','Hesap tÃ¼rleri iÃ§in kullanÄ±lan adlarÄ± deÄŸiÅŸtirme',0),(127985,3556,'pl','Zmiana nazwy stosowane dla typu konta',0),(127986,3556,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð¸Ð¼ÐµÐ½Ð°Ñ‚Ð°, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð·Ð° Ð²Ð¸Ð´Ð¾Ð²Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(127987,3556,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù… Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ù†Ø§Ù… ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(127988,3556,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð¸Ð¼ÐµÐ½Ð° ÐºÐ¾Ñ˜Ð¸ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð·Ð° Ð²Ñ€ÑÑ‚Ðµ ÐºÐ¾Ð½Ñ‚Ð°',0),(127989,3556,'vi','Thay Äá»•i TÃªn Loáº¡i TK',0),(127990,3556,'af','Verander die Name wat Gebruik word vir Rekening Tipes',0),(127991,3556,'ro','Schimba numele folosit pentru tipuri de conturi',0),(127992,3556,'et','Muuda kontotÃ¼Ã¼pi nimed',0),(127993,3556,'si','Sprememba imena, ki se uporabljajo za vrste raÄunov',0),(127994,3556,'ba','Mengubah nama-nama yang digunakan untuk jenis rekening',0),(127995,3556,'nl','Wijzigen van de namen die worden gebruikt voor rekeningsoorten',0),(127996,3556,'fi','Muuta tilin tyypeille kÃ¤ytettÃ¤vÃ¤t nimet',0),(127997,3556,'no','Endre navnene brukes for kontotyper',0),(127998,3556,'da','Ã†ndre de navne, der bruges til kontotyper',0),(127999,3556,'ko','ê³„ì • ìœ í˜•ì— ì‚¬ìš© ë˜ëŠ” ì´ë¦„ ë³€ê²½',0),(128000,3556,'he','×©×™× ×•×™ ×”×©×ž×•×ª ×”×ž×©×ž×©×™× ×¡×•×’×™ ×—×©×‘×•× ×•×ª',0),(128001,3556,'el','Î‘Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î± Î¿Î½ÏŒÎ¼Î±Ï„Î± Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï„ÏÏ€Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(128002,3556,'zh','æ›´æ”¹å¸æˆ·ç±»åž‹ä½¿ç”¨çš„åç§°\r\n',0),(128003,3556,'sv','Ã„ndra de namn som anvÃ¤nds fÃ¶r kontotyper',0),(128004,3556,'it','Cambiare i nomi utilizzati per i tipi di conto',0),(128005,3556,'tl','',0),(128006,3556,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(128007,3556,'hi','à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤¿à¤ à¤—à¤ à¤¨à¤¾à¤® à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(128008,3556,'ms','Perubahan nama-nama yang digunakan untuk jenis-jenis akaun',0),(128009,3556,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø£Ø³Ù…Ø§Ø¡ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„Ø­Ø³Ø§Ø¨ Ø£Ù†ÙˆØ§Ø¹',0),(128010,3556,'fr','Changer les noms utilisÃ©s pour les Types de comptes',0),(128011,3556,'jp','å?£åº§ç¨®é¡žã?®å??å‰?ã‚’å¤‰æ›´',0),(128012,3556,'pt','Alterar os nomes utilizados para os tipos de conta',0),(128013,3556,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¸Ð¼ÐµÐ½Ð°, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ðµ Ð´Ð»Ñ Ñ‚Ð¸Ð¿Ð¾Ð² ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(128014,3556,'es','Cambiar los Nombres Usados para Tipos e Cuenta',0),(128015,3556,'de','Ã„ndern der Namen fÃ¼r das Kontotypen',0),(128016,3556,'en','Change the Names Used for Account Types',0),(128017,3557,'is','',0),(128018,3557,'dr','ØªØºÙŠÙŠØ± Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø´Ø±ÙƒØª',0),(128019,3557,'pr','ØªØºÙŠÙŠØ± Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø´Ø±ÙƒØª',0),(128020,3557,'tr','Åžirket mali yÄ±l baÅŸlangÄ±Ã§ deÄŸiÅŸtirmek',0),(128021,3557,'pl','ZmieÅ„ swÃ³j poczÄ…tek roku obrachunkowego firmy',0),(128022,3557,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° Ñ„Ð¸Ñ€Ð¼Ð° Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð°',0),(128023,3557,'ur','Ø§Ù¾Ù†ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ú©Û’ Ø¢ØºØ§Ø² Ù…ÛŒÚº ØªØ¨Ø¯ÛŒÙ„',0),(128024,3557,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð¾Ð·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ ÑÐ²Ð¾Ñ˜Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(128025,3557,'vi','Thay ngÃ y báº¯t Ä‘áº§u nÄƒm tÃ i chÃ­nh cá»§a cty báº¡n',0),(128026,3557,'af','Verander U Onderneming se Fisiese Jaar Begindatum',0),(128027,3557,'ro','Schimba dumneavoastrÄƒ Ã®ncepe anul Fiscal Firma',0),(128028,3557,'et','Muuda ettevÃµtte majandusaasta algust',0),(128029,3557,'si','Spremenite vaÅ¡ podjetja fiskalnem letu Begin',0),(128030,3557,'ba','Mengubah dimulai tahun fiskal perusahaan Anda',0),(128031,3557,'nl','Wijzigen van uw bedrijf fiscaal jaar Begin',0),(128032,3557,'fi','Muuttaa yhtiÃ¶n tilikausi alkaa',0),(128033,3557,'no','Endre din selskapet regnskapsÃ¥ret begynner',0),(128034,3557,'da','Ã†ndre din virksomhed regnskabsÃ¥r begynder',0),(128035,3557,'ko','íšŒì‚¬ íšŒê³„ ì—°ë„ ì‹œìž‘ ë³€ê²½',0),(128036,3557,'he','×œ×©× ×•×ª ××ª ×‘×’×™×Ÿ ×©× ×ª ×”×›×¡×¤×™× ×©×œ ×”×—×‘×¨×”',0),(128037,3557,'el','Î‘Î»Î»Î±Î³Î® ÏƒÎ±Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î­Î½Î±ÏÎ¾Î· Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÎ¿Ï Î­Ï„Î¿Ï…Ï‚',0),(128038,3557,'zh','ä¿®æ”¹å…¬å¸ä¼šè®¡å¹´åº¦å¼€å§‹\r\n',0),(128039,3557,'sv','Ã„ndra ditt fÃ¶retag rÃ¤kenskapsÃ¥r bÃ¶rjar',0),(128040,3557,'it','Cambiare la vostra azienda anno fiscale Begin',0),(128041,3557,'tl','',0),(128042,3557,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3611;&#3637;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3588;&#3640;&#3603;',0),(128043,3557,'hi','à¤†à¤ªà¤•à¥€ à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¤¿à¤¤à¥à¤¤ à¤µà¤°à¥à¤· à¤¶à¥à¤°à¥‚ à¤¬à¤¦à¤²à¥‡à¤‚',0),(128044,3557,'ms','Menukar mulakan tahun fiskal Syarikat anda',0),(128045,3557,'ar','ØªØºÙŠÙŠØ± Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(128046,3557,'fr','Changer votre sociÃ©tÃ© exercice Begin',0),(128047,3557,'jp','ä¼šç¤¾ã?®å–¶æ¥­å¹´åº¦é–‹å§‹æœˆã‚’å¤‰æ›´',0),(128048,3557,'pt','Mude sua empresa ano Fiscal Begin',0),(128049,3557,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð²Ð°ÑˆÐµÐ¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð½Ð°Ñ‡Ð°Ñ‚ÑŒ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´',0),(128050,3557,'es','Cambiar el Inicio de Ejercicio de su Empresa',0),(128051,3557,'de','Ã„ndern Sie Ihrer Firma GeschÃ¤ftsjahr Begin',0),(128052,3557,'en','Change Your Company Fiscal Year Begin',0),(128053,3558,'is','',0),(128054,3558,'dr','Ù„ÙŠØ³Øª Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨ Ù‡Ø§',0),(128055,3558,'pr','Ù„ÙŠØ³Øª Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨ Ù‡Ø§',0),(128056,3558,'tr','HesaplarÄ± listesinde grafik',0),(128057,3558,'pl','Schemat organizacyjny lista kont',0),(128058,3558,'bg','Ð”Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð° Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(128059,3558,'ur','Ú†Ø§Ø±Ù¹ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(128060,3558,'sr','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ¾Ð½ Ð¾Ð´ Ð»Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(128061,3558,'vi','Biá»ƒu Äá»“ Danh SÃ¡ch TK',0),(128062,3558,'af','Tabel van Rekeninge Lys',0),(128063,3558,'ro','Planul de conturi lista',0),(128064,3558,'et','Kontoplaan nimekirjana',0),(128065,3558,'si','Grafikon seznam raÄunov',0),(128066,3558,'ba','Bagan daftar account',0),(128067,3558,'nl','Grafiek van de lijst met gebruikersaccounts',0),(128068,3558,'fi','Tilikartan tilit-luettelosta',0),(128069,3558,'no','Diagrammet i kontolisten',0),(128070,3558,'da','Diagram af firmaliste',0),(128071,3558,'ko','ì°¨íŠ¸ì˜ ê³„ì • ëª©ë¡',0),(128072,3558,'he','×¨×©×™×ž×ª ×ª×¨×©×™× ×—×©×‘×•× ×•×ª',0),(128073,3558,'el','Î”Î¹Î¬Î³ÏÎ±Î¼Î¼Î± Î±Ï€ÏŒ Ï„Î· Î»Î¯ÏƒÏ„Î± \"Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯\"',0),(128074,3558,'zh','ä¼šè®¡ç§‘ç›®è¡¨æ¸…å•\r\n',0),(128075,3558,'sv','Diagram av kontolistan',0),(128076,3558,'it','Piano dei conti lista',0),(128077,3558,'tl','',0),(128078,3558,'th','&#3619;&#3634;&#3618;&#3594;&#3639;&#3656;&#3629;&#3605;&#3634;&#3619;&#3634;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(128079,3558,'hi','à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‡ à¤¸à¥‚à¤šà¥€ à¤•à¤¾ à¤šà¤¾à¤°à¥à¤Ÿ',0),(128080,3558,'ms','Carta senarai akaun',0),(128081,3558,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¯Ù„ÙŠÙ„ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(128082,3558,'fr','Graphique de la liste des comptes',0),(128083,3558,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒªã‚¹ãƒˆè¡¨',0),(128084,3558,'pt','GrÃ¡fico da lista de contas',0),(128085,3558,'ru','ÐŸÐµÑ€ÐµÑ‡Ð½Ñ Ð¿Ð»Ð°Ð½Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(128086,3558,'es','CatÃ¡logo de Cuentas Lista',0),(128087,3558,'de','Diagramm der Kontenliste',0),(128088,3558,'en','Chart of Accounts List',0),(128089,3559,'is','',0),(128090,3559,'dr','/ ØªØ³ÙˆÙŠÙ‡ ÙƒØ±Ø¯Ù† ÙØ±Ù…Ø§ÛŒØ´Ø§Øª',0),(128091,3559,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙˆØ±ÙˆØ¯ / ØªØ³ÙˆÙŠÙ‡ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª',0),(128092,3559,'tr','Kontrol giriÅŸ/Ã§Ä±kÄ±ÅŸ emirleri',0),(128093,3559,'pl','Zameldowania i wymeldowania zamÃ³wieÅ„',0),(128094,3559,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ/Ð¸Ð·Ñ…Ð¾Ð´ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(128095,3559,'ur','Ù…ÛŒÚº/Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ø§ÛØ± Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(128096,3559,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð° /Ð¾Ð´Ñ˜Ð°Ð²Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(128097,3559,'vi','Kiá»ƒm tra Ä‘Æ¡n Ä‘áº·t hÃ ng vÃ o/ra',0),(128098,3559,'af','Bestellings Aan/Uit Teken',0),(128099,3559,'ro','Check In/Out comenzi',0),(128100,3559,'et','Kontrolli- / tellimused',0),(128101,3559,'si','Check In/Out naroÄila',0),(128102,3559,'ba','Periksa Pesanan Masuk/Keluar',0),(128103,3559,'nl','Check In/Out Orders',0),(128104,3559,'fi','SisÃ¤Ã¤n- / uloskirjautuminen tilaukset',0),(128105,3559,'no','Sjekk inn/ut bestillinger',0),(128106,3559,'da','Tjek ind/ud ordrer',0),(128107,3559,'ko','/ ì£¼ë¬¸ í™•ì¸',0),(128108,3559,'he','×‘×“×•×§/×”×–×ž× ×•×ª',0),(128109,3559,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ In/Out Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(128110,3559,'zh','æ£€æŸ¥è¾“å…¥/è¾“å‡ºè®¢å•\r\n',0),(128111,3559,'sv','Checka In/ut order',0),(128112,3559,'it','Check In/Out ordini',0),(128113,3559,'tl','',0),(128114,3559,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3586;&#3657;&#3634;/&#3629;&#3629;&#3585;',0),(128115,3559,'hi','/ à¤†à¤¦à¥‡à¤¶ à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(128116,3559,'ms','Daftar Masuk/Keluar perintah',0),(128117,3559,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ÙÙŠ/Ø£ÙˆØ§Ù…Ø±',0),(128118,3559,'fr','Check In/Out arrÃªtÃ©s',0),(128119,3559,'jp','ã‚ªãƒ¼ãƒ€ãƒ¼ã?®ãƒ?ã‚§ãƒƒã‚¯ã‚¤ãƒ³/ãƒ?ãƒ£ãƒƒã‚¯ã‚¢ã‚¦ãƒˆ',0),(128120,3559,'pt','Verifique In/ordens',0),(128121,3559,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ / Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(128122,3559,'es','Comprobar Pedidos Dentro/Fuera',0),(128123,3559,'de','Check-In/Bestellungen',0),(128124,3559,'en','Check In/Out Orders',0),(128125,3560,'is','',0),(128126,3560,'dr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ Ú†Ù†Ø¯ÙŠÙ† Ø¯ÙˆØ±Ù‡',0),(128127,3560,'pr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ Ú†Ù†Ø¯ÙŠÙ† Ø¯ÙˆØ±Ù‡',0),(128128,3560,'tr','Ã–zet kontrol edin Ã§ok nokta',0),(128129,3560,'pl','Sprawdzenie podsumowania wiele okresÃ³w',0),(128130,3560,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸',0),(128131,3560,'ur','Ø®Ù„Ø§ØµÛ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø«ÛŒØ± Ø§Ø¯ÙˆØ§Ø±',0),(128132,3560,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ð²Ð¸ÑˆÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(128133,3560,'vi','Tá»•ng há»£p SÃ©c Ä‘a thá»i ká»³',0),(128134,3560,'af','Tjek Opsomming Verskeie Periodes',0),(128135,3560,'ro','Scurta descriere a verifica mai multe perioade',0),(128136,3560,'et','KokkuvÃµtte kontroll mitu perioodid',0),(128137,3560,'si','Preverite Povzetek veÄ obdobij',0),(128138,3560,'ba','Periksa ringkasan beberapa periode',0),(128139,3560,'nl','Controleer samenvatting meerdere perioden',0),(128140,3560,'fi','Tarkista Yhteenveto useita pisteitÃ¤',0),(128141,3560,'no','Sjekk Sammendrag flere perioder',0),(128142,3560,'da','Kontrollere ResumÃ© flere perioder',0),(128143,3560,'ko','ìš”ì•½ í™•ì¸ ì—¬ëŸ¬ ê¸°ê°„',0),(128144,3560,'he','×‘×“×™×§×ª ×¡×™×›×•× ×ª×§×•×¤×•×ª ×ž×¨×•×‘×•×ª',0),(128145,3560,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î·Î½ Ï€ÎµÏÎ¯Î»Î·ÏˆÎ· Ï€Î¿Î»Î»Î±Ï€Î»Î­Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…Ï‚',0),(128146,3560,'zh','æ£€æŸ¥å¤šæœŸç»¼è¿°\r\n',0),(128147,3560,'sv','Kontrollera Sammanfattning flera perioder',0),(128148,3560,'it','Controllare il riepilogo periodi multipli',0),(128149,3560,'tl','',0),(128150,3560,'th','&#3626;&#3619;&#3640;&#3611;&#3648;&#3594;&#3655;&#3588;&#3627;&#3621;&#3634;&#3618;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(128151,3560,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤œà¤¾à¤à¤š à¤à¤•à¤¾à¤§à¤¿à¤• à¤…à¤µà¤§à¤¿à¤¯à¥‹à¤‚',0),(128152,3560,'ms','Menyemak ringkasan tempoh beberapa',0),(128153,3560,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ù…Ù„Ø®Øµ ÙØªØ±Ø§Øª Ù…ØªØ¹Ø¯Ø¯Ø©',0),(128154,3560,'fr','VÃ©rifiez le rÃ©sumÃ© des pÃ©riodes multiples',0),(128155,3560,'jp','è¤‡æ•°æœŸé–“ã?®é›†è¨ˆãƒ?ã‚§ãƒƒã‚¯',0),(128156,3560,'pt','Verifique o resumo vÃ¡rios perÃ­odos',0),(128157,3560,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¾Ð²',0),(128158,3560,'es','Checar ResÃºmen de PerÃ­odos Multiples',0),(128159,3560,'de','ÃœberprÃ¼fen Sie die Zusammenfassung mehrerer Perioden',0),(128160,3560,'en','Check Summary Multiple Periods',0),(128161,3561,'is','',0),(128162,3561,'dr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ ÙŠÙƒ Ø¯ÙˆØ±Ù‡',0),(128163,3561,'pr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ ÙŠÙƒ Ø¯ÙˆØ±Ù‡',0),(128164,3561,'tr','Onay Ã–zeti (bir sÃ¼re)',0),(128165,3561,'pl','Sprawdzenie podsumowania (okresu)',0),(128166,3561,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð ÐµÐ·ÑŽÐ¼Ðµ (ÐµÐ´Ð¸Ð½ Ð¿ÐµÑ€Ð¸Ð¾Ð´)',0),(128167,3561,'ur','Ø®Ù„Ø§ØµÛ (Ø§ÛŒÚ© Ù…Ø¯Øª) Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(128168,3561,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ñ€ÐµÐ·Ð¸Ð¼Ðµ (Ñ˜ÐµÐ´Ð°Ð½ ÐŸÐµÑ€Ð¸Ð¾Ð´)',0),(128169,3561,'vi','Tá»•ng há»£p SÃ©c má»™t thá»i ká»³',0),(128170,3561,'af','Tjek Opsomming Een Period',0),(128171,3561,'ro','Verifica Rezumat (o perioada)',0),(128172,3561,'et','Kontrollige kokkuvÃµte (Ã¼he ajavahemiku kohta)',0),(128173,3561,'si','Preverite Povzetek (eno obdobje)',0),(128174,3561,'ba','Periksa ringkasan (satu periode)',0),(128175,3561,'nl','Selectievakje samenvatting (Ã©Ã©n periode)',0),(128176,3561,'fi','Tarkista Yhteenveto (yksi piste)',0),(128177,3561,'no','Sammendrag (en periode)',0),(128178,3561,'da','Check ResumÃ© (en periode)',0),(128179,3561,'ko','ìš”ì•½ (1 ê¸°ê°„) í™•ì¸',0),(128180,3561,'he','×‘×“×™×§×ª ×¡×™×›×•× (×¤×¨×§ ××—×“)',0),(128181,3561,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î·Î½ Ï€ÎµÏÎ¯Î»Î·ÏˆÎ· (Î¼Î¹Î± Ï€ÎµÏÎ¯Î¿Î´Î¿Ï‚)',0),(128182,3561,'zh','æ£€æŸ¥æ€»ç»“ä¸€ä¸ªæ—¶æœŸ\r\n',0),(128183,3561,'sv','Kontrollera Sammanfattning (en Period)',0),(128184,3561,'it','Riepilogo di controllo (un periodo)',0),(128185,3561,'tl','',0),(128186,3561,'th','&#3626;&#3619;&#3640;&#3611;&#3648;&#3594;&#3655;&#3588;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3648;&#3604;&#3637;&#3618;&#3623;',0),(128187,3561,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ (à¤à¤• à¤…à¤µà¤§à¤¿) à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(128188,3561,'ms','Menyemak ringkasan (satu tempoh)',0),(128189,3561,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ù…Ù„Ø®Øµ (ÙØªØ±Ø© ÙˆØ§Ø­Ø¯Ø©)',0),(128190,3561,'fr','VÃ©rifiez le rÃ©sumÃ© (une pÃ©riode)',0),(128191,3561,'jp','ï¼‘æœŸé–“ã?®é›†è¨ˆãƒ?ã‚§ãƒƒã‚¯',0),(128192,3561,'pt','Verifique o resumo (um ponto)',0),(128193,3561,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ (Ð¾Ð´Ð¸Ð½ Ð¿ÐµÑ€Ð¸Ð¾Ð´)',0),(128194,3561,'es','Checar ResÃºmen Un PerÃ­odo',0),(128195,3561,'de','ÃœberprÃ¼fen Sie die Zusammenfassung (eine Periode)',0),(128196,3561,'en','Check Summary (One Period)',0),(128197,3562,'is','',0),(128198,3562,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰',0),(128199,3562,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø§Ø±Ù‰ Ø¨Ø§Ù†Ú©Ù‰',0),(128200,3562,'tr','Ã‡ek hesaplarÄ±',0),(128201,3562,'pl','Sprawdzanie kont',0),(128202,3562,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(128203,3562,'ur','Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(128204,3562,'sr','Ð§ÐµÐºÐ¾Ð²Ð½Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(128205,3562,'vi','Kiá»ƒm Tra TK',0),(128206,3562,'af','Tjekrekeninge',0),(128207,3562,'ro','Verificarea conturilor',0),(128208,3562,'et','Kontrolli kontosid',0),(128209,3562,'si','Preverjanje raÄunov',0),(128210,3562,'ba','Rekening Giro',0),(128211,3562,'nl','Controle van de rekeningen',0),(128212,3562,'fi','Tarkastaa tilit',0),(128213,3562,'no','Sjekker regnskapet',0),(128214,3562,'da','Kontrol af regnskaber',0),(128215,3562,'ko','ë‹¹ì¢Œ ê³„ì •',0),(128216,3562,'he','×—×©×‘×•× ×•×ª ×‘× ×§',0),(128217,3562,'el','Î¤Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Ï„Ï‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(128218,3562,'zh','æ”¯ç¥¨å¸æˆ·\r\n',0),(128219,3562,'sv','Kontroll konton',0),(128220,3562,'it','Conti correnti',0),(128221,3562,'tl','',0),(128222,3562,'th','&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(128223,3562,'hi','à¤œà¤¾à¤à¤š à¤–à¤¾à¤¤à¥‹à¤‚',0),(128224,3562,'ms','Memeriksa akaun',0),(128225,3562,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¬Ø§Ø±ÙŠØ©',0),(128226,3562,'fr','VÃ©rification des comptes',0),(128227,3562,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒ?ã‚§ãƒƒã‚¯',0),(128228,3562,'pt','Contas',0),(128229,3562,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÑ‡ÐµÑ‚Ð°',0),(128230,3562,'es','Cuentas de Cheques',0),(128231,3562,'de','Girokonten',0),(128232,3562,'en','Checking Accounts',0),(128233,3563,'is','',0),(128234,3563,'dr','(ØªÙˆÙ‚Ù) Ú†Ø§Ù¾ ÙØ±Ù…Ø§ÛŒØ´Ø§Øª',0),(128235,3563,'pr','Ø¨Ø³ØªÙ† (ØªÙˆÙ‚Ù) Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(128236,3563,'tr','KapalÄ± sipariÅŸ YazdÄ±r',0),(128237,3563,'pl','ZamkniÄ™te zlecenia druku',0),(128238,3563,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(128239,3563,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(128240,3563,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð° ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(128241,3563,'vi','ÄÃ³ng ÄÆ¡n Äáº·t HÃ ng In',0),(128242,3563,'af','Afgesluite Uitgedrukte Bestellings',0),(128243,3563,'ro','ÃŽnchis ordine de imprimare',0),(128244,3563,'et','Suletud trÃ¼kitÃ¶Ã¶de tellimused',0),(128245,3563,'si','Zaprta tiskanje nalogov',0),(128246,3563,'ba','Cetak Penanan Tertutup',0),(128247,3563,'nl','Gesloten afdrukken bestellingen',0),(128248,3563,'fi','Suljettu tulosta tilaukset',0),(128249,3563,'no','Lukket bestilling',0),(128250,3563,'da','Lukket aftryksbestillinger',0),(128251,3563,'ko','ì¸ì‡„ ì£¼ë¬¸ ë§ˆê°',0),(128252,3563,'he','×”×“×¤×¡×•×ª ×¡×’×•×¨',0),(128253,3563,'el','ÎšÎ»ÎµÎ¹ÏƒÏ„Î­Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(128254,3563,'zh','å…³é—­æ‰“å°è®¢å•\r\n',0),(128255,3563,'sv','StÃ¤ngda Print Order',0),(128256,3563,'it','Ordini Chiusi Stampati',0),(128257,3563,'tl','',0),(128258,3563,'th','&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(128259,3563,'hi','à¤¬à¤‚à¤¦ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶',0),(128260,3563,'ms','Pesanan cetakan yang tertutup',0),(128261,3563,'ar','Ø¥ØºÙ„Ø§Ù‚ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(128262,3563,'fr','Commandes fermÃ©es',0),(128263,3563,'jp','å®Œäº†ã?—ã?Ÿæ³¨æ–‡',0),(128264,3563,'pt','Ordens de impressÃ£o fechadas',0),(128265,3563,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(128266,3563,'es','Pedidos Cerrrados de ImpresiÃ³n',0),(128267,3563,'de','Abgeschlossene DruckauftrÃ¤ge',0),(128268,3563,'en','Closed Print Orders',0),(128269,3564,'is','',0),(128270,3564,'dr','ØªÙ‚Ø³ÙŠÙ…Ø§Øª Ø´Ø±ÙƒØª',0),(128271,3564,'pr','ØªÙ‚Ø³ÙŠÙ…Ø§Øª Ø´Ø±ÙƒØª',0),(128272,3564,'tr','Åžirket bÃ¶lÃ¼mlerini',0),(128273,3564,'pl','DziaÅ‚Ã³w',0),(128274,3564,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð´Ð¸Ð²Ð¸Ð·Ð¸Ð¸',0),(128275,3564,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ ØªÙ‚Ø³ÛŒÙ…',0),(128276,3564,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¾Ð´ÐµÑ™ÐµÑšÐ°',0),(128277,3564,'vi','PhÃ²ng ban cá»§a Cty',0),(128278,3564,'af','Onderneming Verdelings',0),(128279,3564,'ro','Diviziunile companiei',0),(128280,3564,'et','Ã„riÃ¼hingu jagunemise',0),(128281,3564,'si','Oddelke',0),(128282,3564,'ba','Divisi perusahaan',0),(128283,3564,'nl','Bedrijf divisies',0),(128284,3564,'fi','Yrityksen osastoja',0),(128285,3564,'no','Selskapets divisjoner',0),(128286,3564,'da','Virksomheden divisioner',0),(128287,3564,'ko','íšŒì‚¬ ë¶€ì„œ',0),(128288,3564,'he','×—×˜×™×‘×•×ª ×”×—×‘×¨×”',0),(128289,3564,'el','Î¤Î¼Î®Î¼Î±Ï„Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(128290,3564,'zh','å…¬å¸åˆ†éƒ¨\r\n',0),(128291,3564,'sv','FÃ¶retagsdivisioner',0),(128292,3564,'it','Divisioni aziendali',0),(128293,3564,'tl','',0),(128294,3564,'th','&#3585;&#3634;&#3619;&#3649;&#3610;&#3656;&#3591;&#3649;&#3618;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(128295,3564,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤ªà¥à¤°à¤­à¤¾à¤—à¥‹à¤‚',0),(128296,3564,'ms','Bahagian Syarikat',0),(128297,3564,'ar','Ø£Ù‚Ø³Ø§Ù… Ø§Ù„Ø´Ø±ÙƒØ©',0),(128298,3564,'fr','Divisions de l\'entreprise',0),(128299,3564,'jp','ä¼šç¤¾ã?®éƒ¨ç½²',0),(128300,3564,'pt','DivisÃµes da empresa',0),(128301,3564,'ru','ÐŸÐ¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(128302,3564,'es','Empresas Divisiones',0),(128303,3564,'de','Unternehmensbereiche',0),(128304,3564,'en','Company Divisions',0),(128305,3565,'is','',0),(128306,3565,'dr','-  Ø§Ø³Ù… Ùˆ ØºÙŠØ±Ù‡ ',0),(128307,3565,'pr','Ù„Ùˆ Ú¯Ùˆ Ø´Ø±ÙƒØª -  Ø§Ø³Ù… Ùˆ ØºÙŠØ±Ù‡ ',0),(128308,3565,'tr','Åžirket logosu - adÄ± - vs.',0),(128309,3565,'pl','-Nazwa - Logo firmy itp.',0),(128310,3565,'bg','Ð¤Ð¸Ñ€Ð¼ÐµÐ½Ð¾ Ð»Ð¾Ð³Ð¾ - Ð¸Ð¼Ðµ - Ð¸ Ð´Ñ€.',0),(128311,3565,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ) - Ù†Ø§Ù… - ÙˆØºÛŒØ±Û Û”',0),(128312,3565,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð›Ð¾Ð³Ð¾ - Ð¸Ð¼Ðµ - Ð¸Ñ‚Ð´.',0),(128313,3565,'vi','Logo Cty - TÃªn - vv',0),(128314,3565,'af','Onderneming Embleem - Naam - Ens.',0),(128315,3565,'ro','Compania Logo - nume - Etc.',0),(128316,3565,'et','EttevÃµtte logo, nimi jne',0),(128317,3565,'si','DruÅ¾ba Logo - ime - itd.',0),(128318,3565,'ba','Perusahaan Logo - nama - dll.',0),(128319,3565,'nl','Bedrijf Logo - naam - enz.',0),(128320,3565,'fi','Yrityksen Logo - nimi - jne.',0),(128321,3565,'no','Selskapets Logo - navn - Etc.',0),(128322,3565,'da','Firma Logo - navn - osv.',0),(128323,3565,'ko','ë¡œê³ -ì´ë¦„-íšŒì‚¬ ë“±.',0),(128324,3565,'he','×—×‘×¨×ª ×œ×•×’×• - ×©× - ×•×¢×•×“.',0),(128325,3565,'el','Î›Î¿Î³ÏŒÏ„Ï…Ï€Î¿ - ÏŒÎ½Î¿Î¼Î± - ÎºÎ»Ï€.',0),(128326,3565,'zh','å…¬å¸æ ‡å¿—- åç§°- ç­‰ç­‰\r\n',0),(128327,3565,'sv','FÃ¶retagets logotyp - namn - Etc.',0),(128328,3565,'it','Aziendali Logo - nome - ecc.',0),(128329,3565,'tl','',0),(128330,3565,'th','&#3626;&#3633;&#3597;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607; - &#3594;&#3639;&#3656;&#3629; - &#3629;&#3639;&#3656;&#3609; &#3654;',0),(128331,3565,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤²à¥‹à¤—à¥‹ - à¤¨à¤¾à¤® - à¤†à¤¦à¤¿à¥¤',0),(128332,3565,'ms','-Nama - Logo Syarikat dan sebagainya.',0),(128333,3565,'ar','Ø´Ø±ÙƒØ© Ø§Ù„Ø´Ø¹Ø§Ø±-Ø§Ù„Ø§Ø³Ù…-Ø¥Ù„Ø®.',0),(128334,3565,'fr','Logo - nom - de l\'entreprise Etc.',0),(128335,3565,'jp','ä¼šç¤¾ãƒ­ã‚´ãƒ¼å??å‰?ãƒ¼ã?ªã?©',0),(128336,3565,'pt','Logotipo - nome - da empresa Etc.',0),(128337,3565,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð›Ð¾Ð³Ð¾ - ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ - Ð˜ Ð¢.Ð”.',0),(128338,3565,'es','Empresa Logo - Nombre - Etc.',0),(128339,3565,'de','Logo - Name - Firma etc..',0),(128340,3565,'en','Company Logo - Name - Etc.',0),(128341,3566,'is','',0),(128342,3566,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø´Ø±ÙƒØª ',0),(128343,3566,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø´Ø±ÙƒØª ',0),(128344,3566,'tr','Åžirket seÃ§enekleri',0),(128345,3566,'pl','Firma opcje',0),(128346,3566,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð¾Ð¿Ñ†Ð¸Ð¸',0),(128347,3566,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(128348,3566,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(128349,3566,'vi','Lá»±a chá»n Cty',0),(128350,3566,'af','Onderneming Opsies',0),(128351,3566,'ro','OpÅ£iuni de companie',0),(128352,3566,'et','EttevÃµtte valikud',0),(128353,3566,'si','Podjetje moÅ¾nosti',0),(128354,3566,'ba','Pilihan perusahaan',0),(128355,3566,'nl','Bedrijf opties',0),(128356,3566,'fi','Yrityksen asetukset',0),(128357,3566,'no','Selskapet alternativer',0),(128358,3566,'da','Virksomheden indstillinger',0),(128359,3566,'ko','íšŒì‚¬ ì˜µì…˜',0),(128360,3566,'he','××¤×©×¨×•×™×•×ª ×—×‘×¨×”',0),(128361,3566,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(128362,3566,'zh','å…¬å¸è‚¡æƒ\r\n',0),(128363,3566,'sv','FÃ¶retaget alternativ',0),(128364,3566,'it','Azienda opzioni',0),(128365,3566,'tl','',0),(128366,3566,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(128367,3566,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(128368,3566,'ms','Syarikat pilihan',0),(128369,3566,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ©',0),(128370,3566,'fr','Options de l\'entreprise',0),(128371,3566,'jp','ä¼šç¤¾ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(128372,3566,'pt','OpÃ§Ãµes de empresa',0),(128373,3566,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(128374,3566,'es','Opciones de la Empresa',0),(128375,3566,'de','Unternehmen-Optionen',0),(128376,3566,'en','Company Options',0),(128377,3567,'is','',0),(128378,3567,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡  Ø¬Ù‡Øª ØªØ§ÙŠÙŠØ¯ ',0),(128379,3567,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡  Ø¬Ù‡Øª ØªØ§ÙŠÙŠØ¯ ',0),(128380,3567,'tr','AP iÃ§in tamamlanan PO',0),(128381,3567,'pl','PO zakoÅ„czonych AP',0),(128382,3567,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ PO Ð°Ð¿',0),(128383,3567,'ur','AP Ú©Ùˆ Ù…Ú©Ù…Ù„ Ù¾Ùˆ',0),(128384,3567,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸ ÐŸÐž ÐÐŸ',0),(128385,3567,'vi','ÄÆ¡n mua hÃ ng cho TK pháº£i tráº£ ÄÃ£ hoÃ n thÃ nh',0),(128386,3567,'af','Voltooide AB na RB',0),(128387,3567,'ro','Completat PO pentru a AP',0),(128388,3567,'et','LÃµpuleviidud PO AP',0),(128389,3567,'si','KonÄan PO AP',0),(128390,3567,'ba','Selesai PO AP',0),(128391,3567,'nl','Voltooide PO aan AP',0),(128392,3567,'fi','Valmistunut PO AP',0),(128393,3567,'no','FullfÃ¸rt PO til AP',0),(128394,3567,'da','Udfyldte PO til AP',0),(128395,3567,'ko','APì— ì™„ì„± ëœ í¬',0),(128396,3567,'he','×œ×¤×• ×©×”×•×©×œ×ž×• AP',0),(128397,3567,'el','ÎŸÎ»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½Î· PO Î±Ï€',0),(128398,3567,'zh','å®Œæˆè®¢å•åˆ°åº”ä»˜å¸æ¬¾\r\n\r\n',0),(128399,3567,'sv','Avslutade PO AP',0),(128400,3567,'it','PO completato per AP',0),(128401,3567,'tl','',0),(128402,3567,'th','&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623; &#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3641;&#3656;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#',0),(128403,3567,'hi','à¤à¤ªà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‚à¤°à¥à¤£ à¤•à¤¿à¤ à¤—à¤ à¤ªà¥‹',0),(128404,3567,'ms','Siap PO kepada AP',0),(128405,3567,'ar','Øµ. Ø¨ Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø© Ù„ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(128406,3567,'fr','PO dÃ»ment rempli Ã  l\'AP',0),(128407,3567,'jp','å®Œäº†POã‚’APã?¸',0),(128408,3567,'pt','PO completo para AP',0),(128409,3567,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ PO Ð´Ð»Ñ AP',0),(128410,3567,'es','Completado OC a CC',0),(128411,3567,'de','Abgeschlossene PO mit AP',0),(128412,3567,'en','Completed PO to AP',0),(128413,3568,'is','',0),(128414,3568,'dr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù†  Ù‚Ø¨ÙˆÙ„ ',0),(128415,3568,'pr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù†  Ù‚Ø¨ÙˆÙ„ ',0),(128416,3568,'tr','Tamam olarak sipariÅŸ onaylamak',0),(128417,3568,'pl','Potwierdzenie zamÃ³wienia jako OK',0),(128418,3568,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÐºÐ°Ñ‚Ð¾ ÐžÐš',0),(128419,3568,'ur','Ù¹Ú¾ÛŒÚ© ÛÛ’ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(128420,3568,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð° ÐºÐ°Ð¾ ÐžÐš',0),(128421,3568,'vi','XÃ¡c Nháº­n ÄÆ¡n Äáº·t HÃ ng OK',0),(128422,3568,'af','Bevestig Bestellings as OK',0),(128423,3568,'ro','Confirma comenzile ca OK',0),(128424,3568,'et','Kinnitab korraldusi OK',0),(128425,3568,'si','Potrditev naroÄila kot OK',0),(128426,3568,'ba','Konfirmasi Pesanan OK',0),(128427,3568,'nl','Orders als OK bevestigen',0),(128428,3568,'fi','Vahvista tilausten OK',0),(128429,3568,'no','Bekrefte ordrer som OK',0),(128430,3568,'da','BekrÃ¦fte ordrer som OK',0),(128431,3568,'ko','ì£¼ë¬¸ í™•ì¸ ì„œ í™•ì¸',0),(128432,3568,'he','×œ××©×¨ ×”×•×¨××•×ª ×›×ž×• ×‘×¡×“×¨',0),(128433,3568,'el','OK Î½Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎ¿Ï…Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(128434,3568,'zh','ç¡®è®¤è®¢å•ä¸ºOK\r\n',0),(128435,3568,'sv','BekrÃ¤fta order som OK',0),(128436,3568,'it','Confermare ordini come OK',0),(128437,3568,'tl','',0),(128438,3568,'th','&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3611;&#3655;&#3609;&#3605;&#3585;&#3621;&#3591;',0),(128439,3568,'hi','à¤ à¥€à¤• à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(128440,3568,'ms','Mengesahkan pesanan sebagai OK',0),(128441,3568,'ar','ØªØ£ÙƒÙŠØ¯ Ø£ÙˆØ§Ù…Ø± ÙƒÙ…ÙˆØ§ÙÙ‚',0),(128442,3568,'fr','Confirmer les ordres comme OK',0),(128443,3568,'jp','æ³¨æ–‡ã‚’OKã?¨ç¢ºèª?',0),(128444,3568,'pt','Confirmar ordens como OK',0),(128445,3568,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·Ñ‹ ÐºÐ°Ðº ÐžÐš',0),(128446,3568,'es','Confirmar Pedidos como OK',0),(128447,3568,'de','Bestellungen als OK bestÃ¤tigen',0),(128448,3568,'en','Confirm Orders as OK',0),(128449,3569,'is','',0),(128450,3569,'dr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(128451,3569,'pr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(128452,3569,'tr','SipariÅŸ onaylamak',0),(128453,3569,'pl','Potwierdzenie zamÃ³wienia',0),(128454,3569,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(128455,3569,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(128456,3569,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(128457,3569,'vi','XÃ¡c nháº­n Ä‘Æ¡n hÃ ng',0),(128458,3569,'af','Bevestig Bestellings',0),(128459,3569,'ro','Confirmarea comenzilor',0),(128460,3569,'et','Kinnitage tellimust',0),(128461,3569,'si','Potrditev naroÄila',0),(128462,3569,'ba','Konfirmasi pesanan',0),(128463,3569,'nl','Bevestig bestellingen',0),(128464,3569,'fi','Vahvista tilausten',0),(128465,3569,'no','Bekrefte ordrer',0),(128466,3569,'da','BekrÃ¦fte ordrer',0),(128467,3569,'ko','ì£¼ë¬¸ í™•ì¸',0),(128468,3569,'he','××ž×ª ×”×–×ž× ×•×ª',0),(128469,3569,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· ÎµÎ½Ï„Î¿Î»ÏŽÎ½',0),(128470,3569,'zh','ç¡®è®¤è®¢å•\r\n',0),(128471,3569,'sv','BekrÃ¤fta order',0),(128472,3569,'it','Confermare gli ordini',0),(128473,3569,'tl','',0),(128474,3569,'th','&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(128475,3569,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(128476,3569,'ms','Mengesahkan pesanan',0),(128477,3569,'ar','ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø·Ù„Ø¨ÙŠØ§Øª',0),(128478,3569,'fr','Confirmer les commandes',0),(128479,3569,'jp','æ³¨æ–‡ã?®ç¢ºèª?',0),(128480,3569,'pt','Confirmar ordens',0),(128481,3569,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(128482,3569,'es','Confirmar Pedidos',0),(128483,3569,'de','AuftrÃ¤ge bestÃ¤tigen',0),(128484,3569,'en','Confirm Orders',0),(128485,3570,'is','',0),(128486,3570,'dr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(128487,3570,'pr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(128488,3570,'tr','MÃ¼ÅŸteri sipariÅŸleri girilen onaylama',0),(128489,3570,'pl','PotwierdziÄ‡, Å¼e odbiorcy wprowadzonych zamÃ³wieÅ„',0),(128490,3570,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ð°Ð²Ð»ÐµÐ·Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(128491,3570,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(128492,3570,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸ ÐºÑƒÐ¿Ñ†Ð° ÑƒÐ½ÐµÑ‚ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(128493,3570,'vi','XÃ¡c Nháº­n ÄÆ¡n Äáº·t HÃ ng cá»§a khÃ¡ch hÃ ng',0),(128494,3570,'af','Bevestig Klant/KliÃ«nt Bestellings Ingevoer',0),(128495,3570,'ro','Confirma client intrat comenzi',0),(128496,3570,'et','Kinnitada kliendi sisestatud tellimuste',0),(128497,3570,'si','Potrditi kupec vnesli naroÄila',0),(128498,3570,'ba','Konfirmasi Pelanggan saat Memesan',0),(128499,3570,'nl','Bevestigen klant ingevoerde Orders',0),(128500,3570,'fi','Vahvista asiakkaan yleistietoihin tilaukset',0),(128501,3570,'no','Bekrefte kunden inn ordrer',0),(128502,3570,'da','BekrÃ¦fte kunde indtastede ordrer',0),(128503,3570,'ko','ê³ ê° ì£¼ë¬¸ ìž…ë ¥ í™•ì¸',0),(128504,3570,'he','××™×©×•×¨ ×”×œ×§×•×— ×”×–× ×ª ×”×–×ž× ×•×ª',0),(128505,3570,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎµÎ¹ Ï€ÎµÎ»Î¬Ï„Î·Ï‚ ÎµÎ¹ÏƒÎ­Î»Î¸ÎµÎ¹ ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(128506,3570,'zh','ç¡®è®¤å®¢æˆ·è¾“å…¥çš„è®¢å•\r\n',0),(128507,3570,'sv','BekrÃ¤fta kund in bestÃ¤llningar',0),(128508,3570,'it','Confermare il cliente immesso ordini',0),(128509,3570,'tl','',0),(128510,3570,'th','&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(128511,3570,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¦à¤°à¥à¤œ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(128512,3570,'ms','Mengesahkan pelanggan memasukkan pesanan',0),(128513,3570,'ar','Ø§Ù„ØªØ£ÙƒØ¯ Ù…Ù† Ø¥Ø¯Ø®Ø§Ù„ Ø£ÙˆØ§Ù…Ø± Ù…Ù† Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(128514,3570,'fr','Confirmer le client entrÃ© arrÃªtÃ©s',0),(128515,3570,'jp','é¡§å®¢å…¥åŠ›æ³¨æ–‡ã‚’ç¢ºèª?',0),(128516,3570,'pt','Confirmar o cliente entrou ordens',0),(128517,3570,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð’Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ðµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð¼',0),(128518,3570,'es','Confirmar Ordenes Entrados por el Cliente',0),(128519,3570,'de','BestÃ¤tigen Sie, dass Kunden Bestellungen eingegeben',0),(128520,3570,'en','Confirm Customer Entered Orders',0),(128521,3571,'is','',0),(128522,3571,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ  ØªØ±Ø§Ø² Ù†Ø§Ù…Ù‡  ',0),(128523,3571,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ  ØªØ±Ø§Ø² Ù†Ø§Ù…Ù‡  ',0),(128524,3571,'tr','Bir bilanÃ§o oluÅŸturmak',0),(128525,3571,'pl','Tworzenie bilansu',0),(128526,3571,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ð»Ð°Ð½ÑÐ¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(128527,3571,'ur','Ú©Ø§ Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(128528,3571,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð±Ð¸Ð»Ð°Ð½ÑÐ°',0),(128529,3571,'vi','Táº¡o má»™t báº£ng cÃ¢n Ä‘á»‘i',0),(128530,3571,'af','Skep \'n Balansstaat',0),(128531,3571,'ro','CreaÅ£i un bilanÅ£',0),(128532,3571,'et','Loo bilanss',0),(128533,3571,'si','Ustvarite bilance stanja',0),(128534,3571,'ba','Membuat neraca',0),(128535,3571,'nl','Een balans maken',0),(128536,3571,'fi','Luo tase',0),(128537,3571,'no','Opprette en balanse',0),(128538,3571,'da','Opret en balance',0),(128539,3571,'ko','ëŒ€ì°¨ ëŒ€ì¡°í‘œë¥¼ ë§Œë“¤ê¸°',0),(128540,3571,'he','×¦×•×¨ ×’×œ×™×•×Ÿ ×ž××–×Ÿ',0),(128541,3571,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î­Î½Î± Ï†ÏÎ»Î»Î¿ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±',0),(128542,3571,'zh','å»ºç«‹èµ„äº§è´Ÿå€ºè¡¨\r\n',0),(128543,3571,'sv','Skapa en balansrÃ¤kning',0),(128544,3571,'it','Creare un bilancio',0),(128545,3571,'tl','',0),(128546,3571,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3591;&#3610;&#3604;&#3640;&#3621;',0),(128547,3571,'hi','à¤à¤• à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ à¤¬à¤¨à¤¾',0),(128548,3571,'ms','Membuat kunci kira-kira',0),(128549,3571,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø¹Ù…ÙˆÙ…ÙŠØ©',0),(128550,3571,'fr','CrÃ©er un bilan financier',0),(128551,3571,'jp','ãƒ?ãƒ©ãƒ³ã‚¹ã‚·ãƒ¼ãƒˆã?®ä½œæˆ?',0),(128552,3571,'pt','Criar um balanÃ§o',0),(128553,3571,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð±Ð°Ð»Ð°Ð½Ñ',0),(128554,3571,'es','Crear una Hoja de Balance',0),(128555,3571,'de','Erstellen einer Bilanz',0),(128556,3571,'en','Create a Balance Sheet',0),(128557,3572,'is','',0),(128558,3572,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ÙØ§ÙƒØªÙˆØ± Ø¬Ø¯ÙŠØ¯ ',0),(128559,3572,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ÙØ§ÙƒØªÙˆØ± Ø¬Ø¯ÙŠØ¯ ',0),(128560,3572,'tr','Yeni bir fatura oluÅŸturun',0),(128561,3572,'pl','UtworzyÄ‡ nowÄ… fakturÄ™',0),(128562,3572,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(128563,3572,'ur','Ø§ÛŒÚ© Ù†ÛŒØ§ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(128564,3572,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(128565,3572,'vi','Táº¡o 1 hÃ³a Ä‘Æ¡n má»›i',0),(128566,3572,'af','Skep \'n Nuwe Faktuur',0),(128567,3572,'ro','Creaza o Factura noua',0),(128568,3572,'et','Loo uus arve',0),(128569,3572,'si','Ustvarite nov raÄun',0),(128570,3572,'ba','Membuat faktur baru',0),(128571,3572,'nl','Maak een nieuwe factuur',0),(128572,3572,'fi','Luo uusi lasku',0),(128573,3572,'no','Opprette en ny faktura',0),(128574,3572,'da','Oprette en ny faktura',0),(128575,3572,'ko','ìƒˆ ì†¡ìž¥ ë§Œë“¤ê¸°',0),(128576,3572,'he','×¦×•×¨ ×—×©×‘×•× ×™×ª ×—×“×©×”',0),(128577,3572,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î­Î½Î± Î½Î­Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(128578,3572,'zh','åˆ›å»ºä¸€ä¸ªæ–°çš„å‘ç¥¨\r\n',0),(128579,3572,'sv','Skapa en ny faktura',0),(128580,3572,'it','Creare una nuova fattura',0),(128581,3572,'tl','',0),(128582,3572,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(128583,3572,'hi','à¤à¤• à¤¨à¤¯à¤¾ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¬à¤¨à¤¾à¤à¤',0),(128584,3572,'ms','Mencipta invois baru',0),(128585,3572,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙØ§ØªÙˆØ±Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(128586,3572,'fr','CrÃ©er une facture',0),(128587,3572,'jp','æ–°è¦?è«‹æ±‚æ›¸ã?®ä½œæˆ?',0),(128588,3572,'pt','Criar uma nova fatura',0),(128589,3572,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ Ð¡Ñ‡ÐµÑ‚',0),(128590,3572,'es','Crear una Nueva Factura',0),(128591,3572,'de','Erstellen Sie eine neue Rechnung',0),(128592,3572,'en','Create a New Invoice',0),(128593,3573,'is','',0),(128594,3573,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯',0),(128595,3573,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯',0),(128596,3573,'tr','Yeni satÄ±nalma sipariÅŸi oluÅŸturma',0),(128597,3573,'pl','UtworzyÄ‡ nowe zamÃ³wienie zakupu',0),(128598,3573,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(128599,3573,'ur','Ø§ÛŒÚ© Ù†Ø¦ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(128600,3573,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð¸Ð·Ð»Ð°Ð·Ð½Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(128601,3573,'vi','Táº¡o má»™t Ä‘Æ¡n mua hÃ ng má»›i',0),(128602,3573,'af','Skep \'n Nuwe Aankoopbestelling',0),(128603,3573,'ro','Crea o comandÄƒ de cumpÄƒrare',0),(128604,3573,'et','Loo uus ostutellimus',0),(128605,3573,'si','Ustvari novo naroÄilnico',0),(128606,3573,'ba','Membuat Order Pembelian baru',0),(128607,3573,'nl','Maak een nieuwe inkooporder',0),(128608,3573,'fi','Luo uusi ostotilaus',0),(128609,3573,'no','Opprette en ny bestilling',0),(128610,3573,'da','Opret en ny indkÃ¸bsordre',0),(128611,3573,'ko','ìƒˆë¡œìš´ êµ¬ë§¤ ì£¼ë¬¸ì„ ë§Œë“¤ê¸°',0),(128612,3573,'he','×¦×•×¨ ×”×–×ž× ×ª ×¨×›×™×©×” ×—×“×©×”',0),(128613,3573,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î¼Î¹Î± Î½Î­Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(128614,3573,'zh','åˆ›å»ºä¸€ä¸ªæ–°çš„é‡‡è´­è®¢å•\r\n',0),(128615,3573,'sv','Skapa en ny inkÃ¶psorder',0),(128616,3573,'it','Creare un nuovo ordine di acquisto',0),(128617,3573,'tl','',0),(128618,3573,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(128619,3573,'hi','à¤¬à¤¨à¤¾à¤à¤ à¤à¤• à¤¨à¤ˆ à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(128620,3573,'ms','Mencipta pesanan belian baru',0),(128621,3573,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ø´Ø±Ø§Ø¡ Ø¬Ø¯ÙŠØ¯',0),(128622,3573,'fr','CrÃ©er un nouveau bon de commande',0),(128623,3573,'jp','æ–°è¦?ç™ºæ³¨æ›¸ã?®ä½œæˆ?',0),(128624,3573,'pt','Criar uma nova ordem de compra',0),(128625,3573,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(128626,3573,'es','Crear una Nueva Orden de Compra',0),(128627,3573,'de','Erstellen Sie eine neue Bestellung',0),(128628,3573,'en','Create a New Purchase Order',0),(128629,3574,'is','',0),(128630,3574,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø¯ÙØªØ± ÙƒÙ„  Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(128631,3574,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø¯ÙØªØ± ÙƒÙ„  Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(128632,3574,'tr','Genel muhasebe gÃ¼nlÃ¼k girdileri oluÅŸturmak',0),(128633,3574,'pl','Tworzenie wpisÃ³w w Dzienniku ksiÄ™gi ogÃ³lne',0),(128634,3574,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² ÐºÐ½Ð¸Ð³Ð° Ð·Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(128635,3574,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(128636,3574,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ',0),(128637,3574,'vi','Táº¡o BÃºt ToÃ¡n Trong Sá»• CÃ¡i Tá»•ng Há»£p',0),(128638,3574,'af','Skep Algemene Grootboek Joernaalinskrywings',0),(128639,3574,'ro','Creare intrÄƒri Ã®n jurnal de contabilitate General',0),(128640,3574,'et','Loo Ã¼ldine pearaamatutÃ¶Ã¶lehe kanded',0),(128641,3574,'si','Ustvari vnose v dnevnik glavne knjige General',0),(128642,3574,'ba','Membuat entri General Ledger jurnal',0),(128643,3574,'nl','General Ledger dagboekposten worden gemaakt',0),(128644,3574,'fi','Luo yleinen Kirjanpidon kirjauskansion tapahtumat',0),(128645,3574,'no','Lage General Ledger loggoppfÃ¸ringer',0),(128646,3574,'da','Opret finans finansposter',0),(128647,3574,'ko','ì¼ë°˜ ë ˆì € ì—…ë¬´ ì¼ì§€ í•­ëª© ë§Œë“¤ê¸°',0),(128648,3574,'he','×œ×™×¦×•×¨ ×¢×¨×›×™ ×™×•×ž×Ÿ ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™',0),(128649,3574,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ Î³ÎµÎ½Î¹ÎºÎ®Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚',0),(128650,3574,'zh','å»ºç«‹æ€»å¸æ—¥è®°å¸åˆ†å½•\r\n',0),(128651,3574,'sv','Skapa General Ledger journalposter',0),(128652,3574,'it','Creare le voci del diario di contabilitÃ  generale',0),(128653,3574,'tl','',0),(128654,3574,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;&#3649;&#3618;&#3585;&#3',0),(128655,3574,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾à¤¬à¤¹à¥€ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤¬à¤¨à¤¾à¤à¤',0),(128656,3574,'ms','Membuat catatan jurnal Lejar Am',0),(128657,3574,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(128658,3574,'fr','CrÃ©er des entrÃ©es de Journal grand livre gÃ©nÃ©ral',0),(128659,3574,'jp','ï¼§ï¼¬ã‚¸ãƒ£ãƒ¼ãƒŠãƒ«ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?®ä½œæˆ?',0),(128660,3574,'pt','Criar entradas de diÃ¡rio-razÃ£o geral',0),(128661,3574,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð–ÑƒÑ€Ð½Ð°Ð»Ð° Ð“Ð»Ð°Ð²Ð½Ð¾Ð¹ ÐšÐ½Ð¸Ð³Ð¸',0),(128662,3574,'es','Crear Entrada de Diario',0),(128663,3574,'de','General Ledger Journal-EintrÃ¤ge erstellen',0),(128664,3574,'en','Create General Ledger Journal Entries',0),(128665,3575,'is','',0),(128666,3575,'dr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙƒØªÙˆØ±  Ø§Ø² Ø§Ø±Ø³Ø§Ù„ Ù‡Ø§  ÙŠØ§ Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡',0),(128667,3575,'pr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙƒØªÙˆØ±  Ø§Ø² Ø§Ø±Ø³Ø§Ù„ Ù‡Ø§  ÙŠØ§ Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡',0),(128668,3575,'tr','Faturalar (veya tamamlanmÄ±ÅŸ) sevk emirleri oluÅŸturun',0),(128669,3575,'pl','TwÃ³rz faktury na podstawie zamÃ³wienia wysyÅ‚ane (lub wykonane)',0),(128670,3575,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ (Ð¸Ð»Ð¸ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸) Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(128671,3575,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ (ÛŒØ§ Ù…Ú©Ù…Ù„) Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø³Û’ Ø¨Ù†Ø§Ø¦ÛŒÚº Û”',0),(128672,3575,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¾Ð´ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ (Ð¸Ð»Ð¸ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸Ñ…) Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(128673,3575,'vi','Táº¡o hÃ³a Ä‘Æ¡n cho nhá»¯ng Ä‘Æ¡n Ä‘áº·t hÃ ng Ä‘Ã£ chuyá»ƒn Ä‘i (hay hoÃ n thÃ nh)',0),(128674,3575,'af','Skep Fakture vanaf Versende (of Voltooide) Bestellings',0),(128675,3575,'ro','CreaÅ£i facturi din comenzile expediate (sau finalizate)',0),(128676,3575,'et','Koosta arved tarnitud (vÃµi lÃµpetatud) tellimuste kohta',0),(128677,3575,'si','Ustvarite raÄune za naroÄila poÅ¡iljajo (ali je bilo dokonÄano)',0),(128678,3575,'ba','Buat Faktur dari Pengiriman Pesanan',0),(128679,3575,'nl','Facturen van verzonden (of voltooide) Orders maken',0),(128680,3575,'fi','Luo laskut toimitetaan (tai valmis)',0),(128681,3575,'no','Lage fakturaer fra sendt (eller fullfÃ¸rt)',0),(128682,3575,'da','Oprette fakturaer fra afsendt (eller udfyldte) ordrer',0),(128683,3575,'ko','ë°°ì†¡ (ì™„ë£Œ) ì£¼ë¬¸ì—ì„œ ì†¡ìž¥ ë§Œë“¤ê¸°',0),(128684,3575,'he','×™×¦×™×¨×ª ×—×©×‘×•× ×™×•×ª ×ž×”×–×ž× ×•×ª ×©× ×©×œ×—×” (××• ×©×”×•×©×œ×ž×•)',0),(128685,3575,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î±Ï€ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ (Î® Î­Ï‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯)',0),(128686,3575,'zh','åˆ›å»ºä¸€ä¸ªä»Žå‘è´§å‘ç¥¨ï¼ˆæˆ–å®Œæˆï¼‰ä»¤\r\n',0),(128687,3575,'sv','Skapa fakturor frÃ¥n levererade (eller ifyllda) order',0),(128688,3575,'it','Creare fatture da ordini spediti (o completati)',0),(128689,3575,'tl','',0),(128690,3575,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3592;&#3634;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3586;&#3609;&#3',0),(128691,3575,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤¸à¥‡ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ (à¤¯à¤¾ à¤ªà¥‚à¤°à¥à¤£) à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(128692,3575,'ms','Mencipta invois dari pesanan dihantar (atau lengkap)',0),(128693,3575,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙÙˆØ§ØªÙŠØ± Ù…Ù† Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ (Ø£Ùˆ Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø©)',0),(128694,3575,'fr','CrÃ©er des factures de commandes expÃ©diÃ©es (ou complÃ©tÃ©s)',0),(128695,3575,'jp','ç™ºé€?æ¸ˆï¼ˆå®Œäº†æ¸ˆï¼‰æ³¨æ–‡ã?‹ã‚‰è«‹æ±‚æ›¸ã‚’ä½œæˆ?',0),(128696,3575,'pt','Criar faturas de pedidos enviados (ou concluÃ­dos)',0),(128697,3575,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¸Ð· Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ñ… (Ð¸Ð»Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ð¹) Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(128698,3575,'es','Crear Facturas de Pedidos Enviados (o Completados)',0),(128699,3575,'de','Erstellen von Rechnungen aus gelieferten (oder abgeschlossene) Bestellungen',0),(128700,3575,'en','Create Invoices from Shipped (or Completed) Orders',0),(128701,3576,'is','',0),(128702,3576,'dr','/ Ú†Ø§Ù¾   Ú¯Ø±Ø§Ù  Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ø²  Ø·Ø±Ø§Ø­ÙŠ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù„ÛŒØ¬Ø± Ø®ÙˆØ¯ ',0),(128703,3576,'pr','Ø§ÙŠØ¬Ø§Ø¯   / Ú†Ø§Ù¾   Ù†Ù…ÙˆØ¯Ø§Ø±  Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ø²  Ø·Ø±Ø§Ø­ÙŠ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø®ÙˆØ¯ ',0),(128704,3576,'tr','Pasta grafik tasarÄ±m genel muhasebe verilerinden oluÅŸturma/YazdÄ±r',0),(128705,3576,'pl','Tworzenie drukowania wykresÃ³w koÅ‚owych projektu z General Ledger danych',0),(128706,3576,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ/Ð¿ÐµÑ‡Ð°Ñ‚ ÐºÑ€ÑŠÐ³Ð¾Ð²Ð¸ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¸ Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ Ð´Ð¸Ð·Ð°Ð¹Ð½ Ð¾Ñ‚ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¸ ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(128707,3576,'ur','ØªØ®Ù„ÛŒÙ‚/Ù¾Ø§Ø¦ÛŒ Ú†Ø§Ø±Ù¹ Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ú©ÙˆØ§Ø¦Ù Ø³Û’ Ø§Ù¾Ù†Û’ ÚˆÛŒØ²Ø§Ø¦Ù† Ú©ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ',0),(128708,3576,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ /ÐŸÑ€Ð¸Ð½Ñ‚ ÐºÑ€ÑƒÐ¶Ð½Ð¸ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ¾Ð½Ð¸ ÐºÐ¾Ñ˜Ð¸ ÑÑ‚Ðµ Ð´Ð¸Ð·Ð°Ñ˜Ð½Ð¸Ñ€Ð°Ð»Ð¸ Ð¸Ð· Ð¾Ð¿ÑˆÑ‚Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ ÐºÑšÐ¸Ð³Ðµ',0),(128709,3576,'vi','Táº¡o/In biá»ƒu Ä‘á»“ dáº¡ng á»‘ng tá»« dá»¯ liá»‡u sá»• cÃ¡i theo máº«u cá»§a báº¡n',0),(128710,3576,'af','Skep/Uitdruk van Sirkeldiagram  Grafiek van U Ontwerp vanuit Algemene Grootboek Data',0),(128711,3576,'ro','CreaÅ£i/imprimare diagrame plÄƒcintÄƒ de Design-ul din datele de registru General',0),(128712,3576,'et','Sektordiagrammis saab oma konstruktsiooni Ãœldised pearaamatu andmed loomine/Prindi',0),(128713,3576,'si','Ustvarjanje/Print Tortni grafikoni svojega modela iz sploÅ¡ne podatke v knjigi',0),(128714,3576,'ba','Membuat/cetak diagram lingkaran desain Anda dari General Ledger Data',0),(128715,3576,'nl','Cirkeldiagrammen van uw ontwerp van General Ledger gegevens maken/afdrukken',0),(128716,3576,'fi','Luo tai tulosta piirakkakuvioita suunnittelua General Ledger tiedoista',0),(128717,3576,'no','Opprette/Print sektordiagrammer av designen fra General Ledger Data',0),(128718,3576,'da','Oprette/Print cirkeldiagrammer af dit Design fra General Ledger Data',0),(128719,3576,'ko','ê·€í•˜ì˜ ë””ìžì¸ì˜ ì¼ë°˜ì ì¸ ìž¥ë¶€ ë°ì´í„°ì—ì„œ ì›í˜• ì°¨íŠ¸ ë§Œë“¤ê¸°/ì¸ì‡„',0),(128720,3576,'he','×¦×•×¨/×”×“×¤×¡×” ×ª×¨×©×™×ž×™ ×¢×•×’×” ×©×œ ×”×¢×™×¦×•×‘ ×©×œ×š ×ž× ×ª×•× ×™× ×”×¤× ×§×¡ ×”×›×œ×œ×™',0),(128721,3576,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î³ÏÎ±Ï†Î®Î¼Î±Ï„Î± Ï€Î¯Ï„Î±Ï‚ Ï„Î¿Ï… ÏƒÏ‡ÎµÎ´Î¯Î¿Ï… ÏƒÎ±Ï‚ Î±Ï€ÏŒ Ï„Î± Î³ÎµÎ½Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚',0),(128722,3576,'zh','åˆ›å»ºæ€»å¸æ•°æ®/æ‰“å°æ‚¨çš„è®¾è®¡é¥¼å›¾\r\n',0),(128723,3576,'sv','Skapa/skriva ut cirkeldiagram av din Design frÃ¥n General Ledger Data',0),(128724,3576,'it','Creare/stampa di grafici a torta del vostro disegno dai dati di contabilitÃ  generale',0),(128725,3576,'tl','',0),(128726,3576,'th','&#3626;&#3619;&#3657;&#3634;&#3591;/&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3634;&#3619;&#3634;&#3591;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3588;&#3640;&#3603;&#3629;&#3629;&#3585;&#3649;&#3610;&#3610;&#3592;&#3634;&#',0),(128727,3576,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¥‡ à¤…à¤ªà¤¨à¥‡ à¤¡à¤¿à¤œà¤¾à¤‡à¤¨ à¤•à¥‡ à¤ªà¤¾à¤‡ à¤šà¤¾à¤°à¥à¤Ÿà¥à¤¸ à¤¬à¤¨à¤¾à¤à¤/à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(128728,3576,'ms','Mencipta/Cetak Carta pai anda Reka bentuk dari Data Lejar Am',0),(128729,3576,'ar','Ø¥Ù†Ø´Ø§Ø¡/Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ø¨ÙŠØ§Ù†ÙŠØ© Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠØ© Ù„Ù„ØªØµÙ…ÙŠÙ… Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù…Ù† Ø¨ÙŠØ§Ù†Ø§Øª Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(128730,3576,'fr','CrÃ©er/imprimer des graphiques de votre conception de donnÃ©es du grand livre gÃ©nÃ©ral',0),(128731,3576,'jp','ï¼§ï¼¬ãƒ‡ãƒ¼ã‚¿ã?‹ã‚‰ã?‚ã?ªã?Ÿã?®ãƒ‡ã‚¶ã‚¤ãƒ³ã?®ãƒ‘ã‚¤ãƒ?ãƒ£ãƒ¼ãƒˆã‚’ä½œæˆ?/å?°åˆ·',0),(128732,3576,'pt','Criar/imprimir grÃ¡ficos de pizza de seu projeto do General Ledger dados',0),(128733,3576,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¼Ñ‹ Ð²Ð°ÑˆÐµÐ³Ð¾ Ð´Ð¸Ð·Ð°Ð¹Ð½Ð° Ð¾Ñ‚ Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹ ÐºÐ½Ð¸Ð³Ð¸ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(128734,3576,'es','Crear/Imprimir GrÃ¡ficos Circulares de Su DiseÃ±o de los Datos de Libro Mayor',0),(128735,3576,'de','Drucken Sie Kreisdiagramme Ihres Designs von General Ledger-Daten erstellen /',0),(128736,3576,'en','Create/Print Pie Charts of Your Design from General Ledger Data',0),(128737,3577,'is','',0),(128738,3577,'dr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ',0),(128739,3577,'pr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ',0),(128740,3577,'tr','MÃ¼ÅŸteri oturum aÃ§ma kullanÄ±cÄ±larÄ±',0),(128741,3577,'pl','Klient logowania uÅ¼ytkownikÃ³w',0),(128742,3577,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð’Ñ…Ð¾Ð´ Ð·Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(128743,3577,'ur','Ú©Ø³Ù¹Ù…Ø± Ù„Ø§Ú¯ Ø§Ù† ØµØ§Ø±ÙÛŒÙ†',0),(128744,3577,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(128745,3577,'vi','ÄÄƒng Nháº­p NgÆ°á»i Sá»­ Dá»¥ng Cá»§a KhÃ¡ch hÃ ng',0),(128746,3577,'af','Klant / KliÃ«nt Aantekeningsgebruikers',0),(128747,3577,'ro','Utilizatori client cu logare  ',0),(128748,3577,'et','Kliendi Login kasutajad',0),(128749,3577,'si','Uporabnik prepriÄevalnost kupca',0),(128750,3577,'ba','Login pengguna',0),(128751,3577,'nl','Klant Login gebruikers',0),(128752,3577,'fi','Asiakas Login kÃ¤yttÃ¤jÃ¤',0),(128753,3577,'no','Kunden logikk brukere',0),(128754,3577,'da','Kunde Login brugere',0),(128755,3577,'ko','ê³ ê° ë¡œê·¸ì¸ ì‚¬ìš©ìž',0),(128756,3577,'he','×”×œ×§×•×— ×›× ×™×¡×ª ×ž×©×ª×ž×©×™×',0),(128757,3577,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ· Ï‡ÏÎ®ÏƒÏ„ÏŽÎ½',0),(128758,3577,'zh','å®¢æˆ·ç™»å½•ç”¨æˆ·\r\n',0),(128759,3577,'sv','Kund logga in anvÃ¤ndare',0),(128760,3577,'it','Utenti login cliente',0),(128761,3577,'tl','',0),(128762,3577,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;',0),(128763,3577,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤²à¥‰à¤—à¤¿à¤¨ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(128764,3577,'ms','Pelanggan log masuk pengguna',0),(128765,3577,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ØªØ³Ø¬ÙŠÙ„ Ø¯Ø®ÙˆÙ„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(128766,3577,'fr','Utilisateurs de connexion client',0),(128767,3577,'jp','é¡§å®¢ãƒ­ã‚°ã‚¤ãƒ³ã‚¢ã‚¯ã‚»ã‚¹',0),(128768,3577,'pt','UsuÃ¡rios de Login de cliente',0),(128769,3577,'ru','Ð’Ñ…Ð¾Ð´ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(128770,3577,'es','Cliente Usuarios de Login',0),(128771,3577,'de','Kunden-Login',0),(128772,3577,'en','Customer Login Users',0),(128773,3578,'is','',0),(128774,3578,'dr',' ÙƒØ³Ø±ÙŠ  Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ø¨Ù‡ Ø¬Ø§ÙŠ Ø´Ø®Øµ ',0),(128775,3578,'pr',' ÙƒØ³Ø±ÙŠ  Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ø¨Ù‡ Ø¬Ø§ÙŠ Ø´Ø®Øµ ',0),(128776,3578,'tr','Birey yerine grup indirimleri',0),(128777,3578,'pl','Ulg dla grupy, a nie osoby',0),(128778,3578,'bg','Ð£Ð´Ñ€ÑŠÐ¶ÐºÐ¸ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ð°, Ð° Ð½Ðµ Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¾ Ð»Ð¸Ñ†Ðµ',0),(128779,3578,'ur','ØªÙ„Ø§ÙÛŒ Ú©Û’ ÙØ±Ø¯ Ú©ÛŒ Ø¨Ø¬Ø§Ø¦Û’ Ú¯Ø±ÙˆÙ¾',0),(128780,3578,'sr','Ð£Ð¼Ð°ÑšÐµÑšÐµ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ñƒ, Ð° Ð½Ðµ Ð¿Ð¾Ñ˜ÐµÐ´Ð¸Ð½Ð°Ñ†',0),(128781,3578,'vi','Giáº£m trá»« cá»§a nhÃ³m hÆ¡n lÃ  cá»§a cÃ¡ nhÃ¢n',0),(128782,3578,'af','Aftrekkings vir groep eerder as individu',0),(128783,3578,'ro','Deduceri pentru grup, mai degrabÄƒ decÃ¢t Individual',0),(128784,3578,'et','Mahaarvamiste grupi, mitte uksikute',0),(128785,3578,'si','Odbitki za skupine namesto posameznih',0),(128786,3578,'ba','Pengurangan untuk grup daripada individu',0),(128787,3578,'nl','Aftrek voor de groep in plaats van individuele',0),(128788,3578,'fi','VÃ¤hennykset Group sijaan yksilÃ¶n',0),(128789,3578,'no','Fradrag for gruppen i stedet for individuelle',0),(128790,3578,'da','Fradrag for gruppen frem for individuelle',0),(128791,3578,'ko','ê°œì¸ ë³´ë‹¤ëŠ” ê·¸ë£¹ì— ëŒ€ í•œ ê³µì œ',0),(128792,3578,'he','× ×™×›×•×™×™× ×¢×‘×•×¨ ×§×‘×•×¦×” ×•×œ× ×‘×•×“×“×™×',0),(128793,3578,'el','Î•ÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î·Î½ Î¿Î¼Î¬Î´Î± ÎºÎ±Î¹ ÏŒÏ‡Î¹ Î¼ÎµÎ¼Î¿Î½Ï‰Î¼Î­Î½ÎµÏ‚',0),(128794,3578,'zh','æ‰£é™¤ä¸æ˜¯ä¸ªäººï¼Œè€Œæ˜¯ä¸ºç»„\r\n',0),(128795,3578,'sv','Avdrag fÃ¶r gruppen snarare Ã¤n individen',0),(128796,3578,'it','Deduzioni per gruppo piuttosto che l\'individuo',0),(128797,3578,'tl','',0),(128798,3578,'th','&#3627;&#3633;&#3585;&#3648;&#3611;&#3655;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3592;&#3632;&#3627;&#3633;&#3585;&#3648;&#3611;&#3655;&#3609;&#3588;&#3609;',0),(128799,3578,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤•à¥‡ à¤¸à¤®à¥‚à¤¹ à¤•à¥‡ à¤¬à¤œà¤¾à¤¯ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿ à¤•à¥‡ à¤²à¤¿à¤',0),(128800,3578,'ms','Potongan untuk Kumpulan dan bukannya individu',0),(128801,3578,'ar','Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª Ù„Ù„ÙØ±ÙŠÙ‚ Ø¨Ø¯Ù„Ø§Ù‹ Ù…Ù† Ø§Ù„ÙØ±Ø¯',0),(128802,3578,'fr','DÃ©ductions pour groupe plutÃ´t qu\'individuel',0),(128803,3578,'jp','å€‹äººã?§ã?¯ã?ªã??ã‚°ãƒ«ãƒ¼ãƒ—ã?®æŽ§é™¤',0),(128804,3578,'pt','DeduÃ§Ãµes para o grupo, ao invÃ©s de indivÃ­duo',0),(128805,3578,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚Ñ‹ Ð´Ð»Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð²Ð¼ÐµÑÑ‚Ð¾ Ð¸Ð½Ð´Ð¸Ð²Ð¸Ð´ÑƒÐ°Ð»ÑŒÐ½Ñ‹Ñ…',0),(128806,3578,'es','Deducciones para el Grupo en lugar del Individuo',0),(128807,3578,'de','AbzÃ¼ge fÃ¼r die Gruppe nicht von Individuen',0),(128808,3578,'en','Deductions for Group Rather than Individual',0),(128809,3579,'is','',0),(128810,3579,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ  ÙƒØ³ÙˆØ±Ø§Øª',0),(128811,3579,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ  ÙƒØ³ÙˆØ±Ø§Øª',0),(128812,3579,'tr','SonuÃ§ gruplarÄ±',0),(128813,3579,'pl','Odliczenie grup',0),(128814,3579,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ð¸',0),(128815,3579,'ur','Ù…Ù†ÛØ§Ø¦ÛŒ Ú¯Ø±ÙˆÙ¾',0),(128816,3579,'sr','Ð—Ð°ÐºÑ™ÑƒÑ‡Ð°Ðº Ñƒ Ð³Ñ€ÑƒÐ¿Ð°Ð¼Ð°',0),(128817,3579,'vi','NhÃ³m Giáº£m trá»«',0),(128818,3579,'af','Aftrekking groepe',0),(128819,3579,'ro','Grupuri de deducere',0),(128820,3579,'et','Mahaarvamise rÃ¼hmad',0),(128821,3579,'si','Odbitek skupine',0),(128822,3579,'ba','Kelompok-kelompok pengurangan',0),(128823,3579,'nl','Aftrek groepen',0),(128824,3579,'fi','VÃ¤hennys ryhmÃ¤t',0),(128825,3579,'no','Fradrag grupper',0),(128826,3579,'da','Fradrag grupper',0),(128827,3579,'ko','ê³µì œ ê·¸ë£¹',0),(128828,3579,'he','×§×‘×•×¦×•×ª × ×™×›×•×™',0),(128829,3579,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ· Î¿Î¼Î¬Î´ÎµÏ‚',0),(128830,3579,'zh','æ‰£é™¤ç»„\r\n',0),(128831,3579,'sv','Avdrag grupper',0),(128832,3579,'it','Gruppi di deduzione',0),(128833,3579,'tl','',0),(128834,3579,'th','&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3611;&#3655;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(128835,3579,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚',0),(128836,3579,'ms','Potongan Kumpulan',0),(128837,3579,'ar','Ø®ØµÙ… Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø§Øª',0),(128838,3579,'fr','Groupes de dÃ©duction',0),(128839,3579,'jp','æŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—',0),(128840,3579,'pt','Grupos de deduÃ§Ã£o',0),(128841,3579,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(128842,3579,'es','Grupos de Deducciones',0),(128843,3579,'de','Abzug-Gruppen',0),(128844,3579,'en','Deduction Groups',0),(128845,3580,'is','',0),(128846,3580,'dr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ â€“ Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(128847,3580,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ â€“ Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(128848,3580,'tr','YaÅŸlanma - AyrÄ±ntÄ±lar',0),(128849,3580,'pl','Starzenie siÄ™ - szczegÃ³Å‚y',0),(128850,3580,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ - Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(128851,3580,'ur','Ø®Ø³ØªÛ - ØªÙØµÛŒÙ„Ø§Øª',0),(128852,3580,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ - Ð´ÐµÑ‚Ð°Ñ™Ð¸',0),(128853,3580,'vi','Tuá»•i Ná»£ - Chi Tiáº¿t',0),(128854,3580,'af','Ouderdom - Detail',0),(128855,3580,'ro','ÃŽmbÄƒtrÃ¢nirea - detalii',0),(128856,3580,'et','Vananemisega - Ã¼ksikasjad',0),(128857,3580,'si','Staranje - podrobnosti',0),(128858,3580,'ba','Penuaan - rincian',0),(128859,3580,'nl','Veroudering - Details',0),(128860,3580,'fi','IkÃ¤Ã¤ntyminen - tiedot',0),(128861,3580,'no','Aldring - detaljer',0),(128862,3580,'da','Aldring - detaljer',0),(128863,3580,'ko','ë…¸í™”-ì„¸ë¶€ ì‚¬í•­',0),(128864,3580,'he','×”×–×“×§× ×•×ª - ×¤×¨×˜×™×',0),(128865,3580,'el','Î“Î®ÏÎ±Î½ÏƒÎ· - Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(128866,3580,'zh','è€é¾„åŒ–- ç»†èŠ‚\r\n',0),(128867,3580,'sv','Ã…ldrande - Detaljer',0),(128868,3580,'it','Invecchiamento - dettagli',0),(128869,3580,'tl','',0),(128870,3580,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;',0),(128871,3580,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ - à¤µà¤¿à¤µà¤°à¤£',0),(128872,3580,'ms','Penuaan - butir-butir',0),(128873,3580,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©-Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(128874,3580,'fr','Vieillissement - dÃ©tails',0),(128875,3580,'jp','è€?åŒ–ãƒ¼è©³ç´°',0),(128876,3580,'pt','Envelhecimento - detalhes',0),(128877,3580,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ - Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(128878,3580,'es','AntigÃ¼edad - Detalle',0),(128879,3580,'de','Aging - Details',0),(128880,3580,'en','Aging - Details',0),(128881,3581,'is','',0),(128882,3581,'dr','- ØªØ®ÙÙŠÙ ',0),(128883,3581,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ- ØªØ®ÙÙŠÙ ',0),(128884,3581,'tr','YaÅŸlanma - indirim',0),(128885,3581,'pl','Starzenie siÄ™ - zniÅ¼ki',0),(128886,3581,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ - Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(128887,3581,'ur','Ø®Ø³ØªÛ - Ø±Ø¹Ø§ÛŒØª',0),(128888,3581,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ - Ð¿Ð¾Ð¿ÑƒÑÑ‚',0),(128889,3581,'vi','Tuá»•i Ná»£ - Chiáº¿t Kháº¥u',0),(128890,3581,'af','Ouderdom - Korting',0),(128891,3581,'ro','ÃŽmbÄƒtrÃ¢nirea - reducere',0),(128892,3581,'et','Vananemine - allahindlus',0),(128893,3581,'si','Staranje - popust',0),(128894,3581,'ba','Penuaan - DISKON',0),(128895,3581,'nl','Veroudering - korting',0),(128896,3581,'fi','IkÃ¤Ã¤ntyminen - alennus',0),(128897,3581,'no','Aldring - rabatt',0),(128898,3581,'da','Aldring - rabat',0),(128899,3581,'ko','ë…¸í™”-í• ì¸',0),(128900,3581,'he','×”×–×“×§× ×•×ª - ×”× ×—×”',0),(128901,3581,'el','Î“Î®ÏÎ±Î½ÏƒÎ· - Î­ÎºÏ€Ï„Ï‰ÏƒÎ·',0),(128902,3581,'zh','è€åŒ–- â€‹â€‹æŠ˜æ‰£\r\n',0),(128903,3581,'sv','Ã…ldrande - rabatt',0),(128904,3581,'it','Invecchiamento - sconto',0),(128905,3581,'tl','',0),(128906,3581,'th','&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(128907,3581,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ - à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ',0),(128908,3581,'ms','Penuaan - diskaun',0),(128909,3581,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©-Ø§Ù„Ø®ØµÙ…',0),(128910,3581,'fr','Vieillissement - Discount',0),(128911,3581,'jp','è€?åŒ–ãƒ¼ãƒ‡ã‚£ã‚¹ã‚«ã‚¦ãƒ³ãƒˆ',0),(128912,3581,'pt','Envelhecimento - desconto',0),(128913,3581,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ - ÑÐºÐ¸Ð´ÐºÐ°',0),(128914,3581,'es','AntigÃ¼edad - Descuento',0),(128915,3581,'de','Aging - Rabatt',0),(128916,3581,'en','Aging - Discount',0),(128917,3582,'is','',0),(128918,3582,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø³Ù†Ø¯',0),(128919,3582,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø³Ù†Ø¯',0),(128920,3582,'tr','Belge kategorileri',0),(128921,3582,'pl','Kategorie dokumentu',0),(128922,3582,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(128923,3582,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(128924,3582,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð°',0),(128925,3582,'vi','Thá»ƒ loáº¡i TÃ i liá»‡u',0),(128926,3582,'af','Dokument KategoriÃ«',0),(128927,3582,'ro','Categorii de documente',0),(128928,3582,'et','Dokumendi kategooria',0),(128929,3582,'si','Dokument kategorije',0),(128930,3582,'ba','Kategori Dokumen',0),(128931,3582,'nl','Document CategorieÃ«n',0),(128932,3582,'fi','Tiedostoluokat',0),(128933,3582,'no','Dokumentkategorier',0),(128934,3582,'da','Dokumentkategorier',0),(128935,3582,'ko','ë¬¸ì„œ ì¹´í…Œê³ ë¦¬',0),(128936,3582,'he','×”×ž×¡×ž×š ×§×˜×’×•×¨×™×•×ª',0),(128937,3582,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(128938,3582,'zh','æ–‡ä»¶åˆ†ç±»\r\n',0),(128939,3582,'sv','Dokumentkategorier',0),(128940,3582,'it','Categorie di documento',0),(128941,3582,'tl','',0),(128942,3582,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3586;&#3629;&#3591;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(128943,3582,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(128944,3582,'ms','Kategori dokumen',0),(128945,3582,'ar','ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª',0),(128946,3582,'fr','CatÃ©gories de documents',0),(128947,3582,'jp','æ–‡æ›¸ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(128948,3582,'pt','Categorias de documento',0),(128949,3582,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(128950,3582,'es','CategorÃ­as de Documentos',0),(128951,3582,'de','Dokumentkategorien',0),(128952,3582,'en','Document Categories',0),(128953,3583,'is','',0),(128954,3583,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ø¯Ø§ÙˆÙ„ Ø­Ø³Ø§Ø¨Ù‡Ø§ ',0),(128955,3583,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ø¯Ø§ÙˆÙ„ Ø­Ø³Ø§Ø¨Ù‡Ø§ ',0),(128956,3583,'tr','Hesap planÄ±nÄ± DÃ¼zenle',0),(128957,3583,'pl','Edycja kont',0),(128958,3583,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¾Ð¿Ð»Ð°Ð½',0),(128959,3583,'ur','Ú†Ø§Ø±Ù¹ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(128960,3583,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÐ¾Ð½Ñ‚Ð½Ð¸ Ð¿Ð»Ð°Ð½',0),(128961,3583,'vi','Sá»­a Biá»ƒu Äá»“ TK',0),(128962,3583,'af','Redigeer Tabel van Rekeninge',0),(128963,3583,'ro','Editare plan de conturi',0),(128964,3583,'et','Kontoplaani muutmine',0),(128965,3583,'si','Urejanje Kontni naÄrt',0),(128966,3583,'ba','Mengedit kode akun',0),(128967,3583,'nl','Rekeningschema bewerken',0),(128968,3583,'fi','KÃ¤sittele tilikarttaa',0),(128969,3583,'no','Rediger kontoplan',0),(128970,3583,'da','Redigere kontoplan',0),(128971,3583,'ko','ê³„ì •ê³¼ ëª©í‘œ íŽ¸ì§‘',0),(128972,3583,'he','×¢×¨×•×š ×ª×¨×©×™× ×—×©×‘×•× ×•×ª',0),(128973,3583,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ‡Î­Î´Î¹Î¿',0),(128974,3583,'zh','ç¼–è¾‘ä¼šè®¡ç§‘ç›®è¡¨\r\n',0),(128975,3583,'sv','Redigera kontoplaner',0),(128976,3583,'it','Modificare il piano dei conti',0),(128977,3583,'tl','',0),(128978,3583,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3649;&#3612;&#3609;&#3612;&#3633;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(128979,3583,'hi','à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥€ à¤šà¤¾à¤°à¥à¤Ÿ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(128980,3583,'ms','Mengedit Carta akaun',0),(128981,3583,'ar','ØªØ­Ø±ÙŠØ± Ø¯Ù„ÙŠÙ„ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(128982,3583,'fr','Ã‰diter le plan comptable',0),(128983,3583,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®è¡¨ã‚’ç·¨é›†',0),(128984,3583,'pt','Editar plano de contas',0),(128985,3583,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð»Ð°Ð½Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(128986,3583,'es','Editar CatÃ¡logo de Cuentas',0),(128987,3583,'de','Kontenplan bearbeiten',0),(128988,3583,'en','Edit Chart of Accounts',0),(128989,3584,'is','',0),(128990,3584,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨Ù‡Ø§ ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(128991,3584,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨Ù‡Ø§ ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(128992,3584,'tr','Genel muhasebe hesaplarÄ± listesinde planÄ±nÄ± DÃ¼zenle',0),(128993,3584,'pl','Edytuj ogÃ³lne ksiÄ™gi wykres z listy kont',0),(128994,3584,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ð±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ ÑÐ¼ÐµÑ‚ÐºÐ¾Ð¿Ð»Ð°Ð½ ÑÐ¼ÐµÑ‚ÐºÐ¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(128995,3584,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ú†Ø§Ø±Ù¹ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ ÙÛØ±Ø³Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(128996,3584,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ ÐºÐ¾Ð½Ñ‚Ð½Ð¸ Ð»Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(128997,3584,'vi','Sá»­a Biá»ƒu Äá»“ Sá»• CÃ¡i Tá»•ng Há»£p Cá»§a Danh SÃ¡ch TÃ i Khoáº£n',0),(128998,3584,'af','Redigeer Algemene Grootboek Grafiek (\"Chart\") van Rekeninglys',0),(128999,3584,'ro','Editare General Ledger diagramÄƒ din lista de conturi',0),(129000,3584,'et','Muuda pearaamatus kontoplaani nimekirja',0),(129001,3584,'si','Urejanje General Ledger kontni seznam raÄunov',0),(129002,3584,'ba','Mengedit General Ledger Chart daftar account',0),(129003,3584,'nl','General Ledger rekeningschema Accountlijst bewerken',0),(129004,3584,'fi','Muokkaa yleiset kirjanpidon tilikartan tilit-luettelosta',0),(129005,3584,'no','Rediger General Ledger Kontoplan kontolisten',0),(129006,3584,'da','Redigere General Ledger diagram af firmaliste',0),(129007,3584,'ko','ì¼ë°˜ ë ˆì € ì°¨íŠ¸ ê³„ì • ëª©ë¡ íŽ¸ì§‘',0),(129008,3584,'he','×¢×¨×™×›×ª ×’× ×¨×œ ×‘×¡×¤×¨ ×¨×©×™×ž×” ×©×œ ××™× ×“×§×¡×™ ×—×©×‘×•× ×•×ª',0),(129009,3584,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ Î³ÎµÎ½Î¹ÎºÏŒ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ‡Î­Î´Î¹Î¿ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î±Ï€ÏŒ Ï„Î· Î»Î¯ÏƒÏ„Î± \"Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯\"',0),(129010,3584,'zh','ç¼–è¾‘å¸æˆ·åˆ—è¡¨æ€»å¸å›¾\r\n',0),(129011,3584,'sv','Redigera General Ledger diagram av kontolistan',0),(129012,3584,'it','Modificare il grafico di contabilitÃ  generale della lista conti',0),(129013,3584,'tl','',0),(129014,3584,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3649;&#3612;&#3609;&#3612;&#3633;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3',0),(129015,3584,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¥‹à¤‚ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤šà¤¾à¤°à¥à¤Ÿ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(129016,3584,'ms','Mengedit Carta Lejar Am senarai akaun',0),(129017,3584,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…Ø®Ø·Ø· Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ù…Ù† Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(129018,3584,'fr','Modifier General Ledger graphique de la liste des comptes',0),(129019,3584,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒªã‚¹ãƒˆã?®ï¼§ï¼¬ãƒ?ãƒ£ãƒ¼ãƒˆã?®ç·¨é›†',0),(129020,3584,'pt','Editar General Ledger grÃ¡fico da lista de contas',0),(129021,3584,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¾Ð±Ñ‰ÐµÐ³Ð¾ Ð“Ðš Ð¿ÐµÑ€ÐµÑ‡Ð½Ñ Ð¿Ð»Ð°Ð½Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(129022,3584,'es','Editar Lista de CatÃ¡logo de Cuentas de Libro Mayor',0),(129023,3584,'de','General Ledger Kontenplan Kontoliste bearbeiten',0),(129024,3584,'en','Edit General Ledger Chart of Accounts List',0),(129025,3585,'is','',0),(129026,3585,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ  Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ø§ÙŠ Ùˆ Ø¯ÙØªØ± ÙƒÙ„ ',0),(129027,3585,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ  Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ø§ÙŠ Ùˆ Ø¯ÙØªØ± ÙƒÙ„ ',0),(129028,3585,'tr','GL gÃ¼nlÃ¼k girdilerini dÃ¼zenlemek',0),(129029,3585,'pl','Edycja wpisÃ³w w Dzienniku GL',0),(129030,3585,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ° GL',0),(129031,3585,'ur','Ø¬ÛŒØ¬Û’ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(129032,3585,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ° Ð“Ð›',0),(129033,3585,'vi','Sá»­a BÃºt ToÃ¡n Trong Sá»• CÃ¡i Tá»•ng Há»£p',0),(129034,3585,'af','Redigeer Algemene Grootboek Joernaalinskrywings',0),(129035,3585,'ro','Edita intrÄƒri Ã®n jurnal GL',0),(129036,3585,'et','Redigeeri GL pÃ¤evikukandeid',0),(129037,3585,'si','Urejanje vnosov v dnevnik GL',0),(129038,3585,'ba','Mengedit entri jurnal GL',0),(129039,3585,'nl','GL logboekitems bewerken',0),(129040,3585,'fi','Muokkaa GL',0),(129041,3585,'no','Redigere GL loggoppfÃ¸ringer',0),(129042,3585,'da','Redigere GL journaloptegnelser',0),(129043,3585,'ko','GL ì €ë„ í•­ëª© íŽ¸ì§‘',0),(129044,3585,'he','×œ×¢×¨×•×š ×¢×¨×›×™× ×‘×™×•×ž×Ÿ GL',0),(129045,3585,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Ï‡ÏÎ¿Î½Î¹ÎºÎ¿Ï GL',0),(129046,3585,'zh','ç¼–è¾‘æ€»å¸æ—¥è®°å¸åˆ†å½•\r\n',0),(129047,3585,'sv','Redigera journalposter fÃ¶r GL',0),(129048,3585,'it','Modificare le voci del diario GL',0),(129049,3585,'tl','',0),(129050,3585,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3',0),(129051,3585,'hi','GL à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(129052,3585,'ms','Edit catatan jurnal GL',0),(129053,3585,'ar','ØªØ­Ø±ÙŠØ± Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(129054,3585,'fr','Modifier les entrÃ©es de Journal GL',0),(129055,3585,'jp','ï¼§ï¼¬ã‚¸ãƒ£ãƒ¼ãƒŠãƒ«ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?®ç·¨é›†',0),(129056,3585,'pt','Editar entradas de diÃ¡rio GL',0),(129057,3585,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð–ÑƒÑ€Ð½Ð°Ð»Ð° Ð“Ð»Ð°Ð²Ð½Ð¾Ð¹ ÐšÐ½Ð¸Ð³Ð¸',0),(129058,3585,'es','Editar Entradas del Diario',0),(129059,3585,'de','GL-Journal-EintrÃ¤ge bearbeiten',0),(129060,3585,'en','Edit GL Journal Entries',0),(129061,3586,'is','',0),(129062,3586,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø«Ø¨ØªÙ‡Ø§ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(129063,3586,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø«Ø¨ØªÙ‡Ø§ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(129064,3586,'tr','GÃ¼nlÃ¼k girdisini DÃ¼zenle',0),(129065,3586,'pl','EdytowaÄ‡ wpis do dziennika',0),(129066,3586,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(129067,3586,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(129068,3586,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÑƒÐ½Ð¾Ñ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸Ðº',0),(129069,3586,'vi','Sá»­a BÃºt ToÃ¡n',0),(129070,3586,'af','Redigeer Joernaal Inskrywings',0),(129071,3586,'ro','Editare intrarea de jurnal',0),(129072,3586,'et','Muuta tÃ¶Ã¶lehe kanne',0),(129073,3586,'si','Uredite vnos v dnevnik',0),(129074,3586,'ba','Mengedit entri jurnal',0),(129075,3586,'nl','Logboekitem bewerken',0),(129076,3586,'fi','PÃ¤ivyrimerkinnÃ¤n muokkaaminen',0),(129077,3586,'no','Redigere journalen',0),(129078,3586,'da','Redigere journaloptegnelse',0),(129079,3586,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª© íŽ¸ì§‘',0),(129080,3586,'he','×¢×¨×™×›×ª ×¢×¨×š ×™×•×ž×Ÿ',0),(129081,3586,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï‡ÏÎ¿Î½Î¹ÎºÎ¿Ï',0),(129082,3586,'zh','æ—¥è®°æ¡ç›®ç¼–è¾‘\r\n',0),(129083,3586,'sv','Redigera journalposten',0),(129084,3586,'it','Modificare la voce del diario',0),(129085,3586,'tl','',0),(129086,3586,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;',0),(129087,3586,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(129088,3586,'ms','Edit kemasukan jurnal',0),(129089,3586,'ar','ØªØ­Ø±ÙŠØ± Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(129090,3586,'fr','Modifier l\'entrÃ©e de Journal',0),(129091,3586,'jp','ä»•è¨³è¨˜å…¥ã?®ç·¨é›†',0),(129092,3586,'pt','Editar a entrada de diÃ¡rio',0),(129093,3586,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ',0),(129094,3586,'es','Editar Entradas de Diario',0),(129095,3586,'de','Journaleintrag bearbeiten',0),(129096,3586,'en','Edit Journal Entry',0),(129097,3587,'is','',0),(129098,3587,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ù…ÙˆØ¬ÙˆØ¯ ',0),(129099,3587,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ù…ÙˆØ¬ÙˆØ¯ ',0),(129100,3587,'tr','Varolan sipariÅŸ YazdÄ±r DÃ¼zenle',0),(129101,3587,'pl','Edytowanie istniejÄ…cych zamÃ³wieÅ„ druku',0),(129102,3587,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(129103,3587,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ù¾Ø±Ù†Ù¹ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(129104,3587,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(129105,3587,'vi','Sá»­a ÄÆ¡n Äáº·t HÃ ng In Hiá»‡n Táº¡i',0),(129106,3587,'af','Redigeer Bestaande Gedrukte Bestellings',0),(129107,3587,'ro','EditaÅ£i comenzile de imprimare existente',0),(129108,3587,'et','Saate redigeerida olemasolevaid trÃ¼kitÃ¶Ã¶de tellimused',0),(129109,3587,'si','Urejanje obstojeÄih tiskanje nalogov',0),(129110,3587,'ba','Ganti Cetakan Pesanan yang ada',0),(129111,3587,'nl','Bewerken van bestaande Orders voor afdrukken',0),(129112,3587,'fi','Muokkaa olemassa olevia tulosta tilaukset',0),(129113,3587,'no','Redigere eksisterende bestilling',0),(129114,3587,'da','Redigere eksisterende aftryksbestillinger',0),(129115,3587,'ko','ê¸°ì¡´ ì¸ì‡„ ì£¼ë¬¸ íŽ¸ì§‘',0),(129116,3587,'he','×¢×¨×™×›×ª ×”×•×¨××•×ª×™×• ×”×“×¤×¡×”',0),(129117,3587,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎµÏ‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(129118,3587,'zh','ç¼–è¾‘çŽ°æœ‰çš„æ‰“å°è®¢å•\r\n',0),(129119,3587,'sv','Redigera befintliga Print Order',0),(129120,3587,'it','Ordini Modifica',0),(129121,3587,'tl','',0),(129122,3587,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(129123,3587,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(129124,3587,'ms','Edit pesanan cetakan yang sedia ada',0),(129125,3587,'ar','ØªØ­Ø±ÙŠØ± Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(129126,3587,'fr','Change Commandes',0),(129127,3587,'jp','å­˜åœ¨ã?™ã‚‹å?°åˆ·æ³¨æ–‡ã?®ç·¨é›†',0),(129128,3587,'pt','Editar ordens de impressÃ£o existentes',0),(129129,3587,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(129130,3587,'es','Editar Ordenes de ImpresiÃ³n Existentes',0),(129131,3587,'de','Bearbeiten von vorhandenen DruckauftrÃ¤ge',0),(129132,3587,'en','Edit Existing Print Orders',0),(129133,3588,'is','',0),(129134,3588,'dr','ÙˆÙŠØ±Ø§ÙŠØ´  Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(129135,3588,'pr','ÙˆÙŠØ±Ø§ÙŠØ´  Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(129136,3588,'tr','SipariÅŸ YazdÄ±r DÃ¼zenle',0),(129137,3588,'pl','Edycja zamÃ³wienia druku',0),(129138,3588,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(129139,3588,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(129140,3588,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(129141,3588,'vi','Sá»­a ÄÆ¡n Ä‘áº·t hÃ ng In',0),(129142,3588,'af','Redigeer Gedrukte Bestellings',0),(129143,3588,'ro','EditaÅ£i comenzile de imprimare',0),(129144,3588,'et','Redigeeri trÃ¼kitÃ¶Ã¶de tellimused',0),(129145,3588,'si','Urejanje naroÄila tiskanja',0),(129146,3588,'ba','Ganti Cetakan Pesanan',0),(129147,3588,'nl','Afdrukken Orders bewerken',0),(129148,3588,'fi','Muokkaa tulosta tilaukset',0),(129149,3588,'no','Redigere bestilling',0),(129150,3588,'da','Redigere aftryksbestillinger',0),(129151,3588,'ko','ì¸ì‡„ ëª…ë ¹ íŽ¸ì§‘',0),(129152,3588,'he','×¢×¨×™×›×ª ×”×“×¤×¡×•×ª',0),(129153,3588,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½',0),(129154,3588,'zh','ç¼–è¾‘æ‰“å°è®¢å•\r\n',0),(129155,3588,'sv','Redigera Print Order',0),(129156,3588,'it','Ordini Stampati Modifica',0),(129157,3588,'tl','',0),(129158,3588,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(129159,3588,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(129160,3588,'ms','Edit pesanan cetakan',0),(129161,3588,'ar','ØªØ­Ø±ÙŠØ± Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(129162,3588,'fr','Modifier des ordres d\'impression',0),(129163,3588,'jp','æ³¨æ–‡ã?®ç·¨é›†',0),(129164,3588,'pt','Editar ordens de impressÃ£o',0),(129165,3588,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(129166,3588,'es','Editar Ordenes de ImpresiÃ³n',0),(129167,3588,'de','DruckauftrÃ¤ge bearbeiten',0),(129168,3588,'en','Edit Print Orders',0),(129169,3589,'is','',0),(129170,3589,'dr','/ Ø¢Ù¾Ø¯ÛŒØª  ÙƒØ§Ø±Ù…Ù†Ø¯ â€“ Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§ â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª',0),(129171,3589,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ â€“ Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§ â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª',0),(129172,3589,'tr','Ã‡alÄ±ÅŸan giriÅŸ/gÃ¼ncelleme - Ã§ek - yazmak raporlarÄ±',0),(129173,3589,'pl','Pracownik wpis/aktualizacja - Napisz kontrole - raporty',0),(129174,3589,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð·Ð°Ð¿Ð¸Ñ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ - Ð¿Ð¸ÑˆÐ° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ - Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(129175,3589,'ur','Ú†ÛŒÚ© - Ù„Ú©Ú¾ Ù…Ù„Ø§Ø²Ù… Ø§Ù†Ø¯Ø±Ø§Ø¬/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº - Ø±Ù¾ÙˆØ±Ù¹',0),(129176,3589,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÑƒÐ½Ð¾Ñ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ - Ð¿Ð¸ÑÐµÐ¼Ð¾ Ñ†ÐµÐºÐ¾Ð²Ðµ - Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™ÑƒÑ˜Ðµ.',0),(129177,3589,'vi','Nháº­p/Cáº­p Nháº­t NhÃ¢n ViÃªn - Viáº¿t SÃ©c - BÃ¡o CÃ¡o',0),(129178,3589,'af','Werknemer Inkskrywings/Opdateer - Skryf Loonrol - Verslae',0),(129179,3589,'ro','Angajat intrare/Update - scrie controalelor - rapoarte',0),(129180,3589,'et','TÃ¶Ã¶taja kanne/Update - kirjutada kontrolli - lahendid',0),(129181,3589,'si','Zaposleni vnos/posodobitev - pisati pregledi - poroÄila',0),(129182,3589,'ba','Karyawan masuk/Update - menulis cek - laporan',0),(129183,3589,'nl','Medewerker post/Update - controles - schrijven meldt',0),(129184,3589,'fi','TyÃ¶ntekijÃ¤n merkintÃ¤/PÃ¤ivitÃ¤ - kirjoittaa tarkastukset - raportit',0),(129185,3589,'no','Medarbeider posten/oppdatere - skrive - rapporter',0),(129186,3589,'da','Medarbejder post/Update - skrive kontrol - rapporter',0),(129187,3589,'ko','ì§ì› í•­ëª©/ì—…ë°ì´íŠ¸-ê²€ì‚¬-ìž‘ì„± ë³´ê³ ',0),(129188,3589,'he','×”×¢×•×‘×“ ×›× ×™×¡×”/×¢×“×›×•×Ÿ - ×œ×›×ª×•×‘ ×¦\'×§×™× - ×“×•×—×•×ª',0),(129189,3589,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ - Î³ÏÎ¬ÏˆÎµÏ„Îµ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ - ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(129190,3589,'zh','å‘˜å·¥ è¾“å…¥/æ›´æ–° - å†™æ”¯ç¥¨ - æŠ¥å‘Š',0),(129191,3589,'sv','AnstÃ¤lld intrÃ¤de/uppdatera - skriva kontroller - rapporterar',0),(129192,3589,'it','Assegni - rapporti dipendente entrata/aggiornamento-',0),(129193,3589,'tl','',0),(129194,3589,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609; &#3648;&#3594;&#3655;&#3588;&#3585;&#3634;&#3619;&#3648;&#3586;&#3637;&#3618;&#3609; &#3619;&#3634;&#3618',0),(129195,3589,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤ªà¥à¤°à¤µà¥‡à¤¶/à¤…à¤¦à¥à¤¯à¤¤à¤¨ - à¤²à¤¿à¤–à¤¨à¥‡ à¤•à¥‡ à¤œà¤¾à¤à¤š - à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(129196,3589,'ms','Pekerja Entry/Update - menulis cek - Laporan',0),(129197,3589,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª-ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„Ù…ÙˆØ¸Ù Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ«-',0),(129198,3589,'fr','EmployÃ© saisie/mise Ã  jour - Ã©crire chÃ¨ques - rapports',0),(129199,3589,'jp','å¾“æ¥­å“¡ã?®ã‚¨ãƒ³ãƒˆãƒªãƒ¼/æ›´æ–°ãƒ¼å°?åˆ‡æ‰‹ã?®æ›¸ã??è¾¼ã?¿ãƒ¼ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(129200,3589,'pt','Entrada de empregado/Update - cheques - relatÃ³rios',0),(129201,3589,'ru','Ð’Ð²Ð¾Ð´/ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° - Ð§ÐµÐºÐ¸ - ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹',0),(129202,3589,'es','Empleados Ingresar/Actualizar - Elaborar Cheques - Informes',0),(129203,3589,'de','Mitarbeiter-Eintrag/Update - schreiben PrÃ¼fungen - Berichte',0),(129204,3589,'en','Employee Entry/Update - Write Checks - Reports',0),(129205,3590,'is','',0),(129206,3590,'dr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯  Ø·Ø¨Ù‚ Ù…Ø§Ù‡  ',0),(129207,3590,'pr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯  Ø·Ø¨Ù‚ Ù…Ø§Ù‡  ',0),(129208,3590,'tr','Ã‡alÄ±ÅŸanÄ±n Ã¶deme aya gÃ¶re',0),(129209,3590,'pl','WynagrodzeÅ„ pracownikÃ³w za miesiÄ…c',0),(129210,3590,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¾Ñ‚ Ð¼ÐµÑÐµÑ†',0),(129211,3590,'ur','Ù…Ø§Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û',0),(129212,3590,'sr','ÐŸÐ»Ð°Ñ‚Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ð¿Ð¾ Ð¼ÐµÑÐµÑ†Ð¸Ð¼Ð°',0),(129213,3590,'vi','Tráº£ lÆ°Æ¡ng NhÃ¢n viÃªn theo thÃ¡ng',0),(129214,3590,'af','Werknemer Besoldiging per Maand',0),(129215,3590,'ro','Angajat plata de luna',0),(129216,3590,'et','TÃ¶Ã¶taja tÃ¶Ã¶tasu kuude lÃµikes',0),(129217,3590,'si','Delavec plaÄa po mesecih',0),(129218,3590,'ba','Gaji karyawan oleh bulan',0),(129219,3590,'nl','Werknemer betalen per maand',0),(129220,3590,'fi','TyÃ¶ntekijÃ¶iden palkkojen kuukausi',0),(129221,3590,'no','Ansattes lÃ¸nn etter mÃ¥ned',0),(129222,3590,'da','Medarbejder lÃ¸n pr. mÃ¥ned',0),(129223,3590,'ko','ì›”ë³„ ì§ì› ì§€ë¶ˆ',0),(129224,3590,'he','×©×›×¨ ×”×¢×•×‘×“ ×œ×¤×™ ×—×•×“×©',0),(129225,3590,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Î±Î½Î¬ Î¼Î®Î½Î±',0),(129226,3590,'zh','å‘˜å·¥å·¥èµ„æŒ‰æœˆ\r\n',0),(129227,3590,'sv','AnstÃ¤llde lÃ¶n per mÃ¥nad',0),(129228,3590,'it','Retribuzione del dipendente per mese',0),(129229,3590,'tl','',0),(129230,3590,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3648;&#3611;&#3655;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(129231,3590,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨',0),(129232,3590,'ms','Gaji pekerja mengikut bulan',0),(129233,3590,'ar','Ø±Ø§ØªØ¨ Ø§Ù„Ù…ÙˆØ¸Ù Ø­Ø³Ø¨ Ø§Ù„Ø´Ù‡Ø±',0),(129234,3590,'fr','Paie de lâ€™employÃ© par mois',0),(129235,3590,'jp','æœˆã?”ã?¨ã?®å¾“æ¥­å“¡çµ¦æ–™',0),(129236,3590,'pt','SalÃ¡rio do empregado por mÃªs',0),(129237,3590,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð² ÐœÐµÑÑÑ†',0),(129238,3590,'es','Sueldo de Empleado por Mes',0),(129239,3590,'de','Mitarbeiter Lohn pro Monat',0),(129240,3590,'en','Employee Pay by Month',0),(129241,3591,'is','',0),(129242,3591,'dr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯  Ø·Ø¨Ù‚ Ù…Ø¯Øª Ø³Ù‡ Ù…Ø§Ù‡',0),(129243,3591,'pr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯  Ø·Ø¨Ù‚ Ù…Ø¯Øª Ø³Ù‡ Ù…Ø§Ù‡',0),(129244,3591,'tr','Ã‡alÄ±ÅŸanÄ±n Ã¶deme Ã¼Ã§ aylÄ±k dÃ¶nemlere gÃ¶re',0),(129245,3591,'pl','WynagrodzeÅ„ pracownikÃ³w wedÅ‚ug kwartaÅ‚Ã³w',0),(129246,3591,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¾Ñ‚ Ñ‡ÐµÑ‚Ð²ÑŠÑ€Ñ‚',0),(129247,3591,'ur','Ø³Û Ù…Ø§ÛÛŒ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û',0),(129248,3591,'sr','ÐŸÐ»Ð°Ñ‚Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ð¿Ð¾ ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð¸Ð¼Ð°',0),(129249,3591,'vi','NhÃ¢n viÃªn tráº£ theo quÃ½',0),(129250,3591,'af','Werknemer Besoldiging per Kwartaal',0),(129251,3591,'ro','Salariu angajat de trimestru',0),(129252,3591,'et','TÃ¶Ã¶tajate tasu kvartalis',0),(129253,3591,'si','Zaposleni plaÄati Äetrtino',0),(129254,3591,'ba','Gaji karyawan kuartal',0),(129255,3591,'nl','Werknemer betalen per kwartaal',0),(129256,3591,'fi','TyÃ¶ntekijÃ¶iden palkkojen vuosineljÃ¤nneksittÃ¤in',0),(129257,3591,'no','Ansattes lÃ¸nn etter kvartal',0),(129258,3591,'da','Medarbejder lÃ¸n efter kvartal',0),(129259,3591,'ko','ë¶„ê¸°ë³„ë¡œ ì§ì› ì§€ë¶ˆ',0),(129260,3591,'he','×©×›×¨ ×”×¢×•×‘×“ ×œ×¤×™ ×¨×‘×¢×•×Ÿ',0),(129261,3591,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î±Î¼Î¿Î¹Î²ÏŽÎ½ Î±Î½Î¬ Ï„ÏÎ¯Î¼Î·Î½Î¿',0),(129262,3591,'zh','å‘˜å·¥å·¥èµ„ç”±å­£\r\n',0),(129263,3591,'sv','Medarbetaren betalar kvartalsvis',0),(129264,3591,'it','Retribuzione del dipendente di quarto',0),(129265,3591,'tl','',0),(129266,3591,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3648;&#3611;&#3655;&#3609;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;',0),(129267,3591,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨ à¤¤à¤¿à¤®à¤¾à¤¹à¥€ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(129268,3591,'ms','Gaji pekerja pada suku',0),(129269,3591,'ar','Ø±Ø§ØªØ¨ Ø§Ù„Ù…ÙˆØ¸Ù Ø­Ø³Ø¨ Ø±Ø¨Ø¹ Ø§Ù„Ø³Ù†Ø©',0),(129270,3591,'fr','Paie de lâ€™employÃ© par trimestre',0),(129271,3591,'jp','å››å?ŠæœŸã?®å¾“æ¥­å“¡çµ¦æ–™',0),(129272,3591,'pt','SalÃ¡rio de empregado por trimestre',0),(129273,3591,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð² ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(129274,3591,'es','Sueldo de Empleado por Trimestre',0),(129275,3591,'de','Mitarbeiter Lohn pro Quartal',0),(129276,3591,'en','Employee Pay by Quarter',0),(129277,3592,'is','',0),(129278,3592,'dr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯  Ø·Ø¨Ù‚ Ù‡ÙØªÙ‡',0),(129279,3592,'pr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯  Ø·Ø¨Ù‚ Ù‡ÙØªÙ‡',0),(129280,3592,'tr','Haftaya gÃ¶re Ã§alÄ±ÅŸan Ã¶deme',0),(129281,3592,'pl','Wynagrodzenia pracownika przez tydzieÅ„',0),(129282,3592,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¾Ñ‚ ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(129283,3592,'ur','ÛÙØªÛ’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û',0),(129284,3592,'sr','ÐŸÐ»Ð°Ñ‚Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ð´Ð¾ ÐºÑ€Ð°Ñ˜Ð° Ð½ÐµÐ´ÐµÑ™Ðµ',0),(129285,3592,'vi','Tráº£ lÆ°Æ¡ng NhÃ¢n viÃªn theo tuáº§n',0),(129286,3592,'af','Werknemer Besoldiging per Week',0),(129287,3592,'ro','Salariu angajat de saptamana',0),(129288,3592,'et','TÃ¶Ã¶tajate tasu nÃ¤dala jÃ¤rgi',0),(129289,3592,'si','Zaposleni plaÄati po tednih',0),(129290,3592,'ba','Gaji karyawan minggu',0),(129291,3592,'nl','Werknemer betalen per Week',0),(129292,3592,'fi','TyÃ¶ntekijÃ¶iden palkkojen viikolta',0),(129293,3592,'no','Ansattes lÃ¸nn etter uke',0),(129294,3592,'da','Medarbejder lÃ¸n ved uge',0),(129295,3592,'ko','ì£¼ ì—¬ ì§ì› ê¸‰ì—¬',0),(129296,3592,'he','×”×¢×•×‘×“ ×ª×©×œ×•× ×¢×“ ×©×‘×•×¢',0),(129297,3592,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î±Î¼Î¿Î¹Î²ÏŽÎ½ Î±Î½Î¬ ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(129298,3592,'zh','å‘˜å·¥å·¥èµ„ç”±å‘¨\r\n',0),(129299,3592,'sv','AnstÃ¤lld betala per vecka',0),(129300,3592,'it','Retribuzione del dipendente entro la settimana',0),(129301,3592,'tl','',0),(129302,3592,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3648;&#3611;&#3655;&#3609;&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(129303,3592,'hi','à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨',0),(129304,3592,'ms','Gaji pekerja oleh minggu',0),(129305,3592,'ar','Ø±Ø§ØªØ¨ Ø§Ù„Ù…ÙˆØ¸Ù Ù‚Ø¨Ù„ Ø£Ø³Ø¨ÙˆØ¹',0),(129306,3592,'fr','Paie de lâ€™employÃ© par semaine',0),(129307,3592,'jp','é€±ã?”ã?¨ã?®å¾“æ¥­å“¡çµ¦æ–™',0),(129308,3592,'pt','SalÃ¡rio de empregado por semana',0),(129309,3592,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð² ÐÐµÐ´ÐµÐ»ÑŽ',0),(129310,3592,'es','Sueldo de Empleado por Semana',0),(129311,3592,'de','Mitarbeiter Lohn pro Woche',0),(129312,3592,'en','Employee Pay by Week',0),(129313,3593,'is','',0),(129314,3593,'dr','Ù„ÙŠØ³Øª ØªÙ„ÙÙ† ÙƒØ§Ø±Ù…Ù†Ø¯',0),(129315,3593,'pr','Ù„ÙŠØ³Øª ØªÙ„ÙÙ† ÙƒØ§Ø±Ù…Ù†Ø¯',0),(129316,3593,'tr','Ã‡alÄ±ÅŸan telefon listesi',0),(129317,3593,'pl','Lista telefonÃ³w pracownikÃ³w',0),(129318,3593,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ñ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð¸ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(129319,3593,'ur','Ù…Ù„Ø§Ø²Ù… ÙÙˆÙ† ÙÛØ±Ø³Øª',0),(129320,3593,'sr','Ð›Ð¸ÑÑ‚Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(129321,3593,'vi','Danh sÃ¡ch phone NhÃ¢n viÃªn ',0),(129322,3593,'af','Werknemer Foongids',0),(129323,3593,'ro','ListÄƒ de telefon angajat',0),(129324,3593,'et','TÃ¶Ã¶taja telefonide nimekiri',0),(129325,3593,'si','Telefonski seznam zaposlenih',0),(129326,3593,'ba','Daftar telepon karyawan',0),(129327,3593,'nl','Werknemer telefoonlijst',0),(129328,3593,'fi','TyÃ¶ntekijÃ¶iden Puhelinluettelo',0),(129329,3593,'no','Telefonliste over ansatte',0),(129330,3593,'da','Medarbejder-telefonliste',0),(129331,3593,'ko','ì§ì› ì „í™” ë²ˆí˜¸ ëª©ë¡',0),(129332,3593,'he','×¨×©×™×ž×ª ×˜×œ×¤×•× ×™× ×©×œ ×”×¢×•×‘×“',0),(129333,3593,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Ï‰Î½',0),(129334,3593,'zh','å‘˜å·¥ç”µè¯åˆ—è¡¨\r\n',0),(129335,3593,'sv','Telefon Personallista',0),(129336,3593,'it','Elenco telefonico dei dipendenti',0),(129337,3593,'tl','',0),(129338,3593,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(129339,3593,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤«à¥‹à¤¨ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(129340,3593,'ms','Senarai telefon pekerja',0),(129341,3593,'ar','Ù‚Ø§Ø¦Ù…Ø© Ù‡ÙˆØ§ØªÙ Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(129342,3593,'fr','Liste de tÃ©lÃ©phone des employÃ©s',0),(129343,3593,'jp','å¾“æ¥­å“¡å??ç°¿',0),(129344,3593,'pt','Lista de telefone de empregados',0),(129345,3593,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐÐ¾Ð¼ÐµÑ€Ð¾Ð² Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð¾Ð² Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(129346,3593,'es','Empleado Lista de TelÃ©fonos',0),(129347,3593,'de','Mitarbeiter-Telefonliste',0),(129348,3593,'en','Employee Phone List',0),(129349,3594,'is','',0),(129350,3594,'dr','Ø«Ø¨Øª ÙŠÙƒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ Ø¯Ø± Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(129351,3594,'pr','Ø«Ø¨Øª ÙŠÙƒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ Ø¯Ø± Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(129352,3594,'tr','Yeni bir Bill BorÃ§lar girin',0),(129353,3594,'pl','WprowadÅº nowy Bill do zobowiÄ…zaÅ„',0),(129354,3594,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð² Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð² Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(129355,3594,'ur','Ø§ÛŒÚ© Ù†ÛŒØ§ Ø¨Ù„ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(129356,3594,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð·Ð°ÐºÐ¾Ð½ Ñƒ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(129357,3594,'vi','Nháº­p HÃ³a ÄÆ¡n Má»›i VÃ o TK Pháº£i Tráº£',0),(129358,3594,'af','\'N nuwe Wetsontwerp aangaan Waardedalingstoetse',0),(129359,3594,'ro','IntroduceÅ£i un nou proiect de lege Ã®n datorii',0),(129360,3594,'et','Sisesta uus arve makstavatesse arvetesse',0),(129361,3594,'si','Vnesite nov zakon v obveznosti',0),(129362,3594,'ba','Tagihan baru memasuki hutang',0),(129363,3594,'nl','Voer een nieuw wetsvoorstel in schulden',0),(129364,3594,'fi','SyÃ¶tÃ¤ uusi lakiehdotus Ostovelat',0),(129365,3594,'no','Angi et nytt lovforslag i leverandÃ¸rgjeld',0),(129366,3594,'da','Angiv et nyt lovforslag til gÃ¦ld',0),(129367,3594,'ko','ìƒˆë¡œìš´ ë¹Œ ë¯¸ì§€ê¸‰ê¸ˆìœ¼ë¡œ ìž…ë ¥',0),(129368,3594,'he','×”×¦×¢×ª ×—×•×§ ×—×“×©×” ×œ×”×™×›× ×¡ ×–×›××™×',0),(129369,3594,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Î½Î­Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ ÏƒÎµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î­Ï‚',0),(129370,3594,'zh','è¾“å…¥ä¸€ä¸ªåº”ä»˜æ–°æ¡ä¾‹è‰æ¡ˆ\r\n',0),(129371,3594,'sv','Ange ett nytt lagfÃ¶rslag i leverantÃ¶rsskulder',0),(129372,3594,'it','Immettere una nuova fattura in contabilitÃ  fornitori',0),(129373,3594,'tl','',0),(129374,3594,'th','&#3611;&#3657;&#3629;&#3609;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3652;&#3611;&#3626;&#3641;&#3656;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(129375,3594,'hi','à¤à¤• à¤¨à¤ à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤®à¥‡à¤‚ Payables à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(129376,3594,'ms','Rang undang-undang baru memasuki pemiutang',0),(129377,3594,'ar','ÙŠØ¯Ø®Ù„ Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ø¬Ø¯ÙŠØ¯ ÙÙŠ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹',0),(129378,3594,'fr','Entrer un nouveau projet de loi dans des comptes fournisseurs',0),(129379,3594,'jp','è²·æŽ›é‡‘ã?®ä¸­ã?¸æ–°è¦?è«‹æ±‚æ›¸ã‚’å…¥åŠ›',0),(129380,3594,'pt','Entra um novo projeto de lei em contas a pagar',0),(129381,3594,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð² ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(129382,3594,'es','Introducir un Nuevo Recibo/Factura a Proveedores',0),(129383,3594,'de','Geben Sie ein neues Gesetz in Verbindlichkeiten',0),(129384,3594,'en','Enter a New Bill into Payables',0),(129385,3595,'is','',0),(129386,3595,'dr','Ø«Ø¨Øª Ø§ÙŠÙ…ÙŠÙ„ â€“ ØªÙ†Ø¸ÙŠÙ… Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(129387,3595,'pr','Ø«Ø¨Øª Ø§ÙŠÙ…ÙŠÙ„ â€“ ØªÙ†Ø¸ÙŠÙ… Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(129388,3595,'tr','Kurulum alÄ±ntÄ±',0),(129389,3595,'pl','Cytat instalacji',0),(129390,3595,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(129391,3595,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ø§Ù‚ØªØ¨Ø§Ø³',0),(129392,3595,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(129393,3595,'vi','Setup BÃ¡o GiÃ¡',0),(129394,3595,'af','Kwotasie Opstelling',0),(129395,3595,'ro','Citat de configurare',0),(129396,3595,'et','Pakkumise seadistus',0),(129397,3595,'si','Citat Setup',0),(129398,3595,'ba','Mengutip Setup',0),(129399,3595,'nl','Citeer Setup',0),(129400,3595,'fi','Tarjouksen asetukset',0),(129401,3595,'no','Sitere oppsett',0),(129402,3595,'da','Citere Setup',0),(129403,3595,'ko','ì„¤ì¹˜ ê²¬ì ',0),(129404,3595,'he','×”×’×“×¨×ª ×”×¦×¢×ª ×ž×—×™×¨',0),(129405,3595,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(129406,3595,'zh','æŠ¥ä»·è®¾ç½®',0),(129407,3595,'sv','Citera Setup',0),(129408,3595,'it','Citare il Setup',0),(129409,3595,'tl','',0),(129410,3595,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(129411,3595,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¥‡ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(129412,3595,'ms','Quote persediaan',0),(129413,3595,'ar','Ø§Ù‚ØªØ¨Ø³ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(129414,3595,'fr','Devis d\'installation',0),(129415,3595,'jp','è¦‹ç©?ã‚Šè¨­å®š',0),(129416,3595,'pt','Citar o Setup',0),(129417,3595,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€ÑƒÑŽ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(129418,3595,'es','CotizaciÃ³n ConfiguraciÃ³n',0),(129419,3595,'de','Zitat von Setup',0),(129420,3595,'en','Quote Setup',0),(129421,3596,'is','',0),(129422,3596,'dr','Ø«Ø¨Øª ÙƒÙ„ÙŠ ØªÙØ§ÙˆØª Ø¨ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ù‚ÙŠÙ…Øª Ú©Ø§Ù„Ø§ ',0),(129423,3596,'pr','Ø«Ø¨Øª ÙƒÙ„ÙŠ ØªÙØ§ÙˆØª Ø¨ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ù‚ÙŠÙ…Øª Ú©Ø§Ù„Ø§ ',0),(129424,3596,'tr','General iÅŸaretlemeleri',0),(129425,3596,'pl','OgÃ³lne znacznikÃ³w',0),(129426,3596,'bg','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸',0),(129427,3596,'ur','Ø¬Ù†Ø±Ù„ Ù…Ø¢Ø±Ú©Ùˆ',0),(129428,3596,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐœÐ°Ñ€ÐºÑƒÐ¿Ñ',0),(129429,3596,'vi','Cá»™ng thÃªm chung',0),(129430,3596,'af','Algemene Prysopdaterings',0),(129431,3596,'ro','General marcaje',0),(129432,3596,'et','Ãœldine mÃµÃµtmismÃ¤rkeid',0),(129433,3596,'si','General oznak',0),(129434,3596,'ba','Umum markup',0),(129435,3596,'nl','Generaal markeringen',0),(129436,3596,'fi','Yleinen katteet',0),(129437,3596,'no','General markeringer',0),(129438,3596,'da','General opmÃ¦rkninger',0),(129439,3596,'ko','ì¼ë°˜ ë§ˆí¬ì—…',0),(129440,3596,'he','×’× ×¨×œ ×¡×™×ž×•× ×™×',0),(129441,3596,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(129442,3596,'zh','æ€»æ ‡è®°',0),(129443,3596,'sv','AllmÃ¤nna markeringar',0),(129444,3596,'it','Revisioni generali',0),(129445,3596,'tl','',0),(129446,3596,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(129447,3596,'hi','à¤œà¤¨à¤°à¤² Markups',0),(129448,3596,'ms','Umum sedia',0),(129449,3596,'ar','Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø©',0),(129450,3596,'fr','GÃ©nÃ©ral annotations',0),(129451,3596,'jp','ä¸€èˆ¬åˆ©å¹…',0),(129452,3596,'pt','MarcaÃ§Ãµes gerais',0),(129453,3596,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ðµ ÐÐ°Ð´Ð±Ð°Ð²ÐºÐ¸',0),(129454,3596,'es','Aumentos de Precios Generales',0),(129455,3596,'de','Allgemeine Markierungen',0),(129456,3596,'en','General Markups',0),(129457,3597,'is','',0),(129458,3597,'dr','/ ÙƒØ³ÙˆØ±Ø§Øª Ù…Ø®ØªÙ„Ù Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(129459,3597,'pr','Ø«Ø¨Øª Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ø´Ø¯Ù‡ Ùˆ Ø­Ù‚ÙˆÙ‚ / ÙƒØ³ÙˆØ±Ø§Øª Ù…Ø®ØªÙ„Ù Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(129460,3597,'tr','Saat Ã§alÄ±ÅŸtÄ± girin ve sair Ã¶deme/kesintiler Ã§alÄ±ÅŸanlar iÃ§in',0),(129461,3597,'pl','WprowadÅº przepracowanych godzin i pozostaÅ‚e wynagrodzenia/odliczeÅ„ dla pracownikÃ³w',0),(129462,3597,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¾Ñ‚Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ Ñ‡Ð°ÑÐ¾Ð²Ðµ Ð¸ Ð Ð°Ð·Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ/ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸ Ð·Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ',0),(129463,3597,'ur','Ú©Ø§Ù… Ú©Ø§Ø¬ Ú©Û’ Ù„ÛŒÛ’Ù„Ù…Ø¨ÛŒ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù…ØªÙØ±Ù‚ ØªÙ†Ø®ÙˆØ§Û/Ú©Ù¹ÙˆØªÛŒÙˆÚº Ú©Û’ Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©Û’ Ù„Ø¦Û’',0),(129464,3597,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ ÑÐ°Ñ‚Ð¸ Ñ€Ð°Ð´Ð¸Ð¾ Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ/Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ Ð·Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ðµ',0),(129465,3597,'vi','Nháº­p sá»‘ giá» lÃ m viá»‡c & tráº£/trá»« chi phÃ­ phá»¥ cho nhÃ¢n viÃªn',0),(129466,3597,'af','Invoer van Werknemers Ure Gewerk en Allerlei Besoldigings/Aftrekkings',0),(129467,3597,'ro','Intre orele lucrate si Misc. plata/deducerile pentru angajaÅ£ii',0),(129468,3597,'et','Sisestada tÃ¶Ã¶tunnid ja muud tÃ¶Ã¶tasu/mahaarvamisi tÃ¶Ã¶tajate',0),(129469,3597,'si','Vnesite ure in raznimi plaÄilo/olajÅ¡ave za zaposlene',0),(129470,3597,'ba','Masukkan jam bekerja dan Misc. membayar/pengurangan karyawan',0),(129471,3597,'nl','Voer het aantal gewerkte uren en Misc. Pay/inhoudingen voor werknemers',0),(129472,3597,'fi','Kirjoita tyÃ¶tunnit ja muut maksu/vÃ¤hennykset tyÃ¶ntekijÃ¤t',0),(129473,3597,'no','Angi arbeidstimer og tillegg betale/fradrag for ansatte',0),(129474,3597,'da','Angiv arbejdstid og div. lÃ¸n/fradrag for medarbejdere',0),(129475,3597,'ko','ê·¼ë¬´ ì‹œê°„ì„ ìž…ë ¥ í•˜ ê³  ê¸°íƒ€ ì§€ë¶ˆ/ì§ì›ì— ëŒ€ í•œ ê³µì œ',0),(129476,3597,'he','×”×–×Ÿ ×©×¢×•×ª ×”×¢×‘×•×“×”, ×—×™×•×‘×™× ×©×•× ×™× ×”×©×›×¨/× ×™×›×•×™×™× ×¢×‘×•×¨ ×”×¢×•×‘×“×™×',0),(129477,3597,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ ÏŽÏÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎºÎ±Î¹ Misc. Pay/ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½ Î³Î¹Î± Ï„Î¿Ï…Ï‚ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï…Ï‚',0),(129478,3597,'zh','è¾“å…¥å·¥æ—¶å’Œæ‚é¡¹ã€‚æ”¯ä»˜/æ‰£é™¤é›‡å‘˜\r\n',0),(129479,3597,'sv','Ange arbetade timmar och Misc. lÃ¶n och avdrag fÃ¶r anstÃ¤llda',0),(129480,3597,'it','Immettere le ore lavorate e Misc. Pay/detrazioni per i dipendenti',0),(129481,3597,'tl','',0),(129482,3597,'th','&#3611;&#3657;&#3629;&#3609;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;&#3649;&#3621;&#3632;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;\n&#3592;&#3656;&#',0),(129483,3597,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤•à¤¾à¤® à¤•à¤¿à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤”à¤° misc. à¤­à¥à¤—à¤¤à¤¾à¤¨/à¤•à¤Ÿà¥Œà¤¤à¥€ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤',0),(129484,3597,'ms','Masukkan waktu bekerja dan Misc. gaji/potongan untuk pekerja',0),(129485,3597,'ar','Ù‚Ù… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„ ÙˆØ§Ù„Ø£Ø¬ÙˆØ±/Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª Ø§Ù„Ù…ØªÙ†ÙˆØ¹Ø© Ù„Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(129486,3597,'fr','Entrez les heures travaillÃ©es et divers paie/retenues pour les employÃ©s',0),(129487,3597,'jp','å¾“æ¥­å“¡ã?®å‹¤å‹™æ™‚é–“ã‚„ã??ã?®ä»–è³ƒé‡‘/æŽ§é™¤ã?®å…¥åŠ›',0),(129488,3597,'pt','Digite horas trabalhadas e Misc. pagamento/deduÃ§Ãµes para funcionÃ¡rios',0),(129489,3597,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¾Ñ‚Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½Ð½Ñ‹Ñ… Ñ‡Ð°ÑÐ¾Ð² Ð¸ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ñ‹Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹/Ð²Ñ‹Ñ‡ÐµÑ‚Ñ‹ Ð´Ð»Ñ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(129490,3597,'es','Introducir Horas Trabajadas y Pagos/Deducciones Misc. para los Empleados',0),(129491,3597,'de','Geben Sie Arbeitsstunden und sonstige Pay/AbzÃ¼ge fÃ¼r Mitarbeiter',0),(129492,3597,'en','Enter Hours Worked and Misc. Pay/Deductions for Employees',0),(129493,3598,'is','',0),(129494,3598,'dr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÙŠØ¯ ',0),(129495,3598,'pr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÙŠØ¯ ',0),(129496,3598,'tr','Yeni sipariÅŸler girin',0),(129497,3598,'pl','WprowadÅº nowe zamÃ³wienia',0),(129498,3598,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(129499,3598,'ur','Ù†Ø¦Û’ Ø§Ø­Ú©Ø§Ù… Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(129500,3598,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð²Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(129501,3598,'vi','Nháº­p Ä‘Æ¡n Ä‘áº·t hÃ ng má»›i',0),(129502,3598,'af','Invoer van Nuwe Bestellings',0),(129503,3598,'ro','IntroduceÅ£i comenzi noi',0),(129504,3598,'et','Sisesta uusi tellimusi',0),(129505,3598,'si','Vnesti nova naroÄila',0),(129506,3598,'ba','Membuat Pesanan Baru',0),(129507,3598,'nl','Nieuwe Orders invoeren',0),(129508,3598,'fi','Kirjoittaa uudet tilaukset',0),(129509,3598,'no','Skrive inn nye ordrer',0),(129510,3598,'da','Angiv nye ordrer',0),(129511,3598,'ko','ìƒˆë¡œìš´ ì£¼ë¬¸ ìž…ë ¥',0),(129512,3598,'he','×”×›× ×¡ ×”×–×ž× ×•×ª ×—×“×©×•×ª',0),(129513,3598,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î½Î­ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(129514,3598,'zh','è¾“å…¥æ–°è®¢å•\r\n',0),(129515,3598,'sv','Ange nya order',0),(129516,3598,'it','Inserire nuovi ordini',0),(129517,3598,'tl','',0),(129518,3598,'th','&#3611;&#3657;&#3629;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(129519,3598,'hi','à¤¨à¤ à¤†à¤¦à¥‡à¤¶ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(129520,3598,'ms','Masukkan perintah baru',0),(129521,3598,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø£ÙˆØ§Ù…Ø± Ø¬Ø¯ÙŠØ¯Ø©',0),(129522,3598,'fr','Entrer commandes nouvelle',0),(129523,3598,'jp','æ–°è¦?æ³¨æ–‡ã?®å…¥åŠ›',0),(129524,3598,'pt','Insira novas ordens',0),(129525,3598,'ru','Ð’Ð²ÐµÑÑ‚Ð¸ ÐÐ¾Ð²Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(129526,3598,'es','Introducir Nuevos Pedidos',0),(129527,3598,'de','Neue AuftrÃ¤ge eingeben',0),(129528,3598,'en','Enter New Orders',0),(129529,3599,'is','',0),(129530,3599,'dr','Ø«Ø¨Øª Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(129531,3599,'pr','Ø«Ø¨Øª Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(129532,3599,'tr','Yeni sevk irsaliyesi girin',0),(129533,3599,'pl','WprowadÅº nowÄ… przesyÅ‚kÄ™',0),(129534,3599,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(129535,3599,'ur','Ù†Ø¦ÛŒ Ú©Ú¾ÛŒÙ¾ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(129536,3599,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(129537,3599,'vi','Nháº­p chuyáº¿n hÃ ng má»›i',0),(129538,3599,'af','Voer Nuwe Versendings In',0),(129539,3599,'ro','IntroduceÅ£i noul transport',0),(129540,3599,'et','Lisa uus tarne',0),(129541,3599,'si','Vnesite novo dobavnico',0),(129542,3599,'ba','Masukkan pengiriman baru',0),(129543,3599,'nl','Invoeren van nieuwe verzending',0),(129544,3599,'fi','Kirjoita uusi lÃ¤hetys',0),(129545,3599,'no','Angi ny forsendelse',0),(129546,3599,'da','Angiv ny leverance',0),(129547,3599,'ko','ìƒˆë¡œìš´ ì„ ì  ìž…ë ¥',0),(129548,3599,'he','×”×›× ×¡ ×ž×©×œ×•×— ×—×“×©',0),(129549,3599,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î·Î½ Î½Î­Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(129550,3599,'zh','è¾“å…¥æ–°è´§',0),(129551,3599,'sv','Ange ny fÃ¶rsÃ¤ndelse',0),(129552,3599,'it','Immettere la nuova spedizione',0),(129553,3599,'tl','',0),(129554,3599,'th','&#3611;&#3657;&#3629;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(129555,3599,'hi','à¤¨à¤ à¤²à¤¦à¤¾à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(129556,3599,'ms','Masukkan penghantaran baru',0),(129557,3599,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø´Ø­Ù†Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(129558,3599,'fr','Entrez le nouvel arrivage',0),(129559,3599,'jp','æ–°ã?Ÿã?ªç™ºé€?ã‚’å…¥åŠ›',0),(129560,3599,'pt','Digite a nova remessa',0),(129561,3599,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð²ÑƒÑŽ Ð¿Ð°Ñ€Ñ‚Ð¸ÑŽ',0),(129562,3599,'es','Introducir Nuevo EnvÃ­o',0),(129563,3599,'de','Geben Sie neue Sendung',0),(129564,3599,'en','Enter New Shipment',0),(129565,3600,'is','',0),(129566,3600,'dr','Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(129567,3600,'pr','Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(129568,3600,'tr','Ã–demeler girin',0),(129569,3600,'pl','WprowadÅº pÅ‚atnoÅ›ci',0),(129570,3600,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(129571,3600,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(129572,3600,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(129573,3600,'vi','Nháº­p thanh toÃ¡n',0),(129574,3600,'af','Voer Betalings In',0),(129575,3600,'ro','IntroduceÅ£i plÄƒÅ£i',0),(129576,3600,'et','Sisesta makseid',0),(129577,3600,'si','Vnesti plaÄila',0),(129578,3600,'ba','Masukkan pembayaran',0),(129579,3600,'nl','Invoeren van betalingen',0),(129580,3600,'fi','Maksut',0),(129581,3600,'no','Angi betalinger',0),(129582,3600,'da','Angive betalinger',0),(129583,3600,'ko','ì§€ë¶ˆ ìž…ë ¥',0),(129584,3600,'he','×”×›× ×¡ ×ª×©×œ×•×ž×™×',0),(129585,3600,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(129586,3600,'zh','è¾“å…¥ä»˜æ¬¾',0),(129587,3600,'sv','Ange betalningar',0),(129588,3600,'it','Registrare i pagamenti',0),(129589,3600,'tl','',0),(129590,3600,'th','&#3611;&#3657;&#3629;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(129591,3600,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(129592,3600,'ms','Masukkan bayaran',0),(129593,3600,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(129594,3600,'fr','Entrer les paiements',0),(129595,3600,'jp','æ”¯æ‰•ã?„ã‚’å…¥åŠ›',0),(129596,3600,'pt','Insira os pagamentos',0),(129597,3600,'ru','Ð’Ð²ÐµÑÑ‚Ð¸ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸',0),(129598,3600,'es','Introducir Pagos',0),(129599,3600,'de','Zahlungen erfassen',0),(129600,3600,'en','Enter Payments',0),(129601,3601,'is','',0),(129602,3601,'dr','( ÙˆØ¬ÙˆÙ‡ ) Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(129603,3601,'pr','Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§ÙŠ ( ÙˆØ¬ÙˆÙ‡ ) Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(129604,3601,'tr','AlÄ±nan Ã¶demeler girin',0),(129605,3601,'pl','WprowadÅº otrzymane pÅ‚atnoÅ›ci',0),(129606,3601,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(129607,3601,'ur','Ù…Ù„Ø§ ÛÛ’ Ø¢Ù…Ø¯Ù†ÛŒ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(129608,3601,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ',0),(129609,3601,'vi','Nháº­p thanh toÃ¡n Ä‘Ã£ nháº­n',0),(129610,3601,'af','Betalings Ontvang Invoer',0),(129611,3601,'ro','IntroduceÅ£i primite',0),(129612,3601,'et','Sisesta saadud makseid',0),(129613,3601,'si','Vnesite prejeta plaÄila',0),(129614,3601,'ba','Masukkan pembayaran yang diterima',0),(129615,3601,'nl','Voer betalingen ontvangen',0),(129616,3601,'fi','Kirjoita saadut maksut',0),(129617,3601,'no','Angi betalinger mottatt',0),(129618,3601,'da','Angive betalinger modtaget',0),(129619,3601,'ko','ì§€ë¶ˆ ë°›ì€ ìž…ë ¥',0),(129620,3601,'he','×”×›× ×¡ ×ª×©×œ×•×ž×™× ×©×”×ª×§×‘×œ×•',0),(129621,3601,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î± Ï€Î¿ÏƒÎ¬ Ï€Î¿Ï… Î­Î»Î±Î²Îµ',0),(129622,3601,'zh','è¾“å…¥æ”¯ä»˜å·²æŽ¥æ”¶',0),(129623,3601,'sv','Ange betalningar',0),(129624,3601,'it','Immettere i pagamenti ricevuti',0),(129625,3601,'tl','',0),(129626,3601,'th','&#3611;&#3657;&#3629;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(129627,3601,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(129628,3601,'ms','Masukkan pembayaran yang diterima',0),(129629,3601,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…ØªÙ„Ù‚Ø§Ø©',0),(129630,3601,'fr','Entrer les paiements reÃ§us',0),(129631,3601,'jp','å?—é ˜æ¸ˆæ”¯æ‰•ã?®å…¥åŠ›',0),(129632,3601,'pt','Insira os pagamentos recebidos',0),(129633,3601,'ru','Ð’Ð²ÐµÑÑ‚Ð¸ ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸',0),(129634,3601,'es','Introducir Pagos Recibidos',0),(129635,3601,'de','Geben Sie Zahlungen',0),(129636,3601,'en','Enter Payments Received',0),(129637,3602,'is','',0),(129638,3602,'dr','Ø«Ø¨Øª Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(129639,3602,'pr','Ø«Ø¨Øª Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(129640,3602,'tr','SipariÅŸlerin sevk irsaliyeleri girmek',0),(129641,3602,'pl','WprowadÅº wysyÅ‚ek zamÃ³wieÅ„',0),(129642,3602,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(129643,3602,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ±Ø³ÛŒÙ„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(129644,3602,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°',0),(129645,3602,'vi','Nháº­p chuyáº¿n hÃ ng cá»§a Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(129646,3602,'af','Invoer van Versendings of Bestellings',0),(129647,3602,'ro','IntroduceÅ£i transporturile de comenzi',0),(129648,3602,'et','Sisesta tellimuste tarneid',0),(129649,3602,'si','Vnesite poÅ¡iljke naroÄil',0),(129650,3602,'ba','Memasukkan Pengiriman Pesanan',0),(129651,3602,'nl','Verzendingen voor bestellingen invoeren',0),(129652,3602,'fi','Tilaukset toimitustietojen antamiseen',0),(129653,3602,'no','Registrere fÃ¸lgesedler for bestillinger',0),(129654,3602,'da','Angive leveringer af ordrer',0),(129655,3602,'ko','ì£¼ë¬¸ ì¶œí•˜ ëŸ‰ì„ ìž…ë ¥',0),(129656,3602,'he','×”×›× ×¡ ×ž×©×œ×•×—×™ ×”×–×ž× ×•×ª',0),(129657,3602,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¹Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(129658,3602,'zh','è¾“å…¥è®¢å•å‡ºè´§',0),(129659,3602,'sv','Ange transporter av order',0),(129660,3602,'it','Immettere le spedizioni degli ordini',0),(129661,3602,'tl','',0),(129662,3602,'th','&#3611;&#3657;&#3629;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(129663,3602,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤²à¤¦à¤¾à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(129664,3602,'ms','Masukkan penghantaran pesanan',0),(129665,3602,'ar','Ù‚Ù… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø´Ø­Ù†Ø§Øª Ø£ÙˆØ§Ù…Ø±',0),(129666,3602,'fr','Entrez les expÃ©ditions des commandes',0),(129667,3602,'jp','æ³¨æ–‡ã?®ç™ºé€?ã‚’å…¥åŠ›',0),(129668,3602,'pt','Insira a envios de encomendas',0),(129669,3602,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(129670,3602,'es','Introducir EnvÃ­os de Pedidos',0),(129671,3602,'de','Geben Sie Sendungen von AuftrÃ¤gen',0),(129672,3602,'en','Enter Shipments of Orders',0),(129673,3603,'is','',0),(129674,3603,'dr','-â€“ Ù…Ø­Ù„ Ù‡Ø§ â€“ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ â€“ Ùˆ ØºÙŠØ±Ù‡  ',0),(129675,3603,'pr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª  ÙˆØ§Ø­Ø¯Ù‡Ø§ -â€“ Ù…Ø­Ù„ Ù‡Ø§ â€“ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ â€“ Ùˆ ØºÙŠØ±Ù‡  ',0),(129676,3603,'tr','Birimleri - Mekanlar - Kategoriler - stok nasÄ±l dÃ¼zenleneceÄŸi hakkÄ±nda vb bilgileri girin.',0),(129677,3603,'pl','WprowadÅº jednostki - lokalizacje - kategorie - informacje itp jak zapasÃ³w jest zorganizowany.',0),(129678,3603,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ - Ð¼ÐµÑÑ‚Ð° - ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ - Ð¸ Ñ‚.Ð½. Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð½Ð°Ñ‡Ð¸Ð½Ð°, Ð¿Ð¾ ÐºÐ¾Ð¹Ñ‚Ð¾ Ðµ Ð¾Ñ€Ð³Ð°Ð½Ð¸Ð·Ð¸Ñ€Ð°Ð½ Ð·Ð°Ð¿Ð°ÑÐ¸.',0),(129679,3603,'ur','ÛŒÙˆÙ†Ù¹ - Ù…Ù‚Ø§Ù…Ø§Øª - Ø²Ù…Ø±Û Ø¬Ø§Øª - ÙˆØºÛŒØ±Û Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ùˆ Ú©Ø³ Ø·Ø±Ø­ Ù…Ù†Ø¸Ù… Ú©ÛŒØ§ ÛÛ’ Ú©Û’ Ø¨Ø§Ø±Û’ Ù…ÛŒÚº Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(129680,3603,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°Ð¼Ð° - Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° - ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ - ÑÐ». Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ñ‚Ð¾Ð¼Ðµ ÐºÐ°ÐºÐ¾ Ñ˜Ðµ Ð¾Ñ€Ð³Ð°Ð½Ð¸Ð·Ð¾Ð²Ð°Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°.',0),(129681,3603,'vi','Nháº­p thÃ´ng tin Ä‘Æ¡n vá»‹ - Vá»‹ trÃ­ - Thá»ƒ loáº¡i - vv vá» viá»‡c sáº¯p xáº¿p hÃ ng trong kho',0),(129682,3603,'af','Invoer van Eenhede - Lokaliteit - KategoriÃ« - ens. inligting omtrent hoe inventarisse georganiseerd is.',0),(129683,3603,'ro','IntroduceÅ£i unitÄƒÅ£i - locatii - categorii - etc. informatii despre cum este organizatÄƒ inventar.',0),(129684,3603,'et','Sisestage Ã¼hikute - asukohad - kategooriad - jne teavet varude korraldamine.',0),(129685,3603,'si','Vnesite enot - lokacije - kategorije - itd informacij o tem, kako je organiziran zaloge.',0),(129686,3603,'ba','Isi Satuan - Lokasi - Kategori - dll. informasi mengenai bagaimana menata inventory.',0),(129687,3603,'nl','Voer eenheden - locaties - categorieÃ«n - etc. informatie over hoe de voorraad wordt georganiseerd.',0),(129688,3603,'fi','Kirjoita yksikÃ¶t - Toimipaikat - luokat - jne tietoja varaston jÃ¤rjestÃ¤minen.',0),(129689,3603,'no','Angi - beliggenhet - enhetskategorier - etc. informasjon om hvordan lageret er organisert.',0),(129690,3603,'da','Angiv enheder - placeringer - kategorier - etc. oplysninger om, hvordan lageret er organiseret.',0),(129691,3603,'ko','ë‹¨ìœ„-ìœ„ì¹˜-ì¹´í…Œê³ ë¦¬-ì¸ë²¤í† ë¦¬ êµ¬ì„± ë°©ì‹ì— ëŒ€ í•œ ë“± ì •ë³´ë¥¼ ìž…ë ¥ í•©ë‹ˆë‹¤.',0),(129692,3603,'he','×”×–×Ÿ ×™×—×™×“×•×ª - ×ž×™×§×•×ž×™× - ×§×˜×’×•×¨×™×•×ª - ×•×›×“×•×ž×” ×ž×™×“×¢ ××•×“×•×ª ×›×™×¦×“ ×ž××•×¨×’×Ÿ ×”×ž×œ××™.',0),(129693,3603,'el','Î“Î¹Î± Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¿Î½Î¬Î´ÎµÏ‚ - Î¸Î­ÏƒÎµÎ¹Ï‚ - ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ - Îº.Î±. Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î¿ Ï€ÏŽÏ‚ ÎµÎ¯Î½Î±Î¹ Î¿ÏÎ³Î±Î½Ï‰Î¼Î­Î½Î· Î· Î±Ï€Î¿Î³ÏÎ±Ï†Î®.',0),(129694,3603,'zh','è¾“å…¥å•ä½ -åœ°ç‚¹ -åˆ†ç±» -åº“å­˜ç­‰æœ‰å…³å¦‚ä½•ç»„ç»‡çš„ä¿¡æ¯ã€‚',0),(129695,3603,'sv','Ange enheter - platser - kategorier - etc. information om hur inventering Ã¤r organiserad.',0),(129696,3603,'it','Inserire unitÃ  - sedi - categorie - ecc informazioni su come Ã¨ organizzato per inventario.',0),(129697,3603,'tl','',0),(129698,3603,'th','&#3611;&#3657;&#3629;&#3609;&#3627;&#3609;&#3656;&#3623;&#3618;-&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;-&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;-&#3629;&#3639;&#3656;&#3609;&#3654; &#3607;&#3637;&#3656;&#3648;&#3585;&#3637;&#3656',0),(129699,3603,'hi','à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ - à¤¸à¥à¤¥à¤¾à¤¨ - à¤µà¤°à¥à¤— - à¤†à¤¦à¤¿ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤•à¥ˆà¤¸à¥‡ à¤†à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¹à¥ˆ à¤•à¥‡ à¤¬à¤¾à¤°à¥‡ à¤®à¥‡à¤‚ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(129700,3603,'ms','Masukkan kategori unit - lokasi - - dan lain-lain maklumat mengenai bagaimana inventori ini diadakan.',0),(129701,3603,'ar','Ø£Ø¯Ø®Ù„ ÙØ¦Ø§Øª ÙˆØ­Ø¯Ø§Øª--Ù…ÙˆØ§Ù‚Ø¹--Ø¥Ù„Ø® Ù…Ù† Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø­ÙˆÙ„ ÙƒÙŠÙ ÙŠØªÙ… ØªÙ†Ø¸ÙŠÙ… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ø±Ø¯.',0),(129702,3603,'fr','Entrez les unitÃ©s - Locations - catÃ©gories - etc. de lâ€™information sur la faÃ§on dont lâ€™inventaire est organisÃ©.',0),(129703,3603,'jp','åœ¨åº«ã?®æ§‹æˆ?çŠ¶æ³?ã?«ã?¤ã?„ã?¦ã?®å?˜ä½?-ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³-ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?ªã?©ã?®æƒ…å ±ã‚’å…¥åŠ›',0),(129704,3603,'pt','Digite unidades - locais - categorias - etc. obter informaÃ§Ãµes sobre como Ã© organizado o inventÃ¡rio.',0),(129705,3603,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹ - Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ - ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ - Ñ‚. Ð´. ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾ Ñ‚Ð¾Ð¼, ÐºÐ°Ðº Ð¾Ñ€Ð³Ð°Ð½Ð¸Ð·Ð¾Ð²Ð°Ð½Ñ‹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸.',0),(129706,3603,'es','Introducir Unidades - Ubicaciones - CategorÃ­as - etc. informaciÃ³n',0),(129707,3603,'de','Geben Sie Einheiten - Standorte - Kategorien - usw. Informationen wie Inventar organisiert ist.',0),(129708,3603,'en','Enter Units - Locations - Categories - etc. information about how inventory is organized.',0),(129709,3604,'is','',0),(129710,3604,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ø¯Ø³ØªØ±Ø³ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†ÙŠ ÙƒÙ‡ Ù…Ø¬Ø§Ø² Ø¨Ù‡ Ø¯Ø³ØªÙŠØ§Ø¨ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø´Ø®Øµ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ù‡Ø³ØªÙ†Ø¯',0),(129711,3604,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø¯Ø³ØªØ±Ø³ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†ÙŠ ÙƒÙ‡ Ù…Ø¬Ø§Ø² Ø¨Ù‡ Ø¯Ø³ØªÙŠØ§Ø¨ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø´Ø®Øµ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ù‡Ø³ØªÙ†Ø¯',0),(129712,3604,'tr','SatÄ±cÄ±ya Ã¶zgÃ¼ bilgilere eriÅŸim izin satÄ±cÄ±lar iÃ§in eriÅŸim bilgileri girin/gÃ¼ncelleme',0),(129713,3604,'pl','WprowadÅº/Zaktualizuj informacje dotyczÄ…ce dostÄ™pu do dostawcÃ³w, aby uzyskaÄ‡ dostÄ™p do informacji specyficznych dla dostawcy',0),(129714,3604,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸, Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ð°Ñ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(129715,3604,'ur','ÙˆÛŒÙ†ÚˆØ±Ø² ÙØ±ÙˆØ´Ù†Ø¯Û-Ø§Ø®ØªØµØ§ØµÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ú©Û’ Ù„ÛŒÛ’ Ø±Ø³Ø§Ø¦ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(129716,3604,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐÑ†Ñ†ÐµÑÑ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ðµ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(129717,3604,'vi','Nháº­p/Cáº­p Nháº­t ThÃ´ng Tin Truy Cáº­p cho NgÆ°á»i BÃ¡n Ä‘á»ƒ NgÆ°á»i BÃ¡n cÃ³ thá»ƒ truy cáº­p vÃ o trang ThÃ´ng tin cá»¥ thá»ƒ vá» ngÆ°á»i bÃ¡n ',0),(129718,3604,'af','Invoer/Opdateer van Toegangsingligting met betrekking tot Verskaffer Spesifieke Inligting, wat tot beskikking van Verskaffers is',0),(129719,3604,'ro','IntroduceÅ£i/actualizare informaÅ£ii de acces pentru vÃ¢nzÄƒtorii sÄƒ aibÄƒ acces la informaÅ£ii de furnizor de-specifice',0),(129720,3604,'et','JuurdepÃ¤Ã¤s teabele juurdepÃ¤Ã¤s hankija teavet hankijate sisestamine/ajakohastamine',0),(129721,3604,'si','Vnos/posodobitev dostop do informacij za dobavitelje, ki dovoli dostop do prodajalca informacij',0),(129722,3604,'ba','Masukkan/Update informasi akses untuk vendor yang memungkinkan akses ke informasi Vendor tertentu',0),(129723,3604,'nl','Toegang tot informatie voor leveranciers toegang hebben tot specifieke fabrikantinformatie invoeren/bijwerken',0),(129724,3604,'fi','PÃ¤ivittÃ¤minen tietoja toimittajille pÃ¤Ã¤sy toimittajakohtaiset tiedot',0),(129725,3604,'no','Angi/Oppdater tilgang til informasjon for leverandÃ¸rer tilgang til leverandÃ¸rspesifikk informasjon',0),(129726,3604,'da','Indtaste/opdatere adgang til oplysninger for sÃ¦lgere adgang til leverandÃ¸r-specifikke oplysninger',0),(129727,3604,'ko','ê³µê¸‰ ì—…ì²´ ê³µê¸‰ ì—…ì²´ íŠ¹ì • ì •ë³´ì— ì•¡ì„¸ìŠ¤í•  ìˆ˜ì— ëŒ€ í•œ ì•¡ì„¸ìŠ¤ ì •ë³´ë¥¼ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(129728,3604,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×œ×’×©×ª ×œ×ž×™×“×¢ ×¢×‘×•×¨ ×¡×¤×§×™ ×’×™×©×” ×œ×ž×™×“×¢ ×¡×¤×¦×™×¤×™×ª ×œ×¡×¤×§',0),(129729,3604,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î· Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(129730,3604,'zh','è¾“å…¥/æ›´æ–°å…è®¸è®¿é—®ç‰¹å®šåŽ‚å•†ä¿¡æ¯ä¾›åº”å•†èŽ·å–ä¿¡æ¯ã€‚',0),(129731,3604,'sv','Ange/uppdatera Ã¥tkomstinformation fÃ¶r leverantÃ¶rer tillgÃ¥ng till leverantÃ¶rsspecifik Information',0),(129732,3604,'it','Inserisci/Aggiorna informazioni di accesso per i fornitori autorizzati ad accedere a informazioni specifiche del fornitore',0),(129733,3604,'tl','',0),(129734,3604,'th','Enter/Update Access Information for Vendors Allowed Access to Vendor-Specific Information',0),(129735,3604,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾-à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¤à¤• à¤ªà¤¹à¥à¤à¤š à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤•à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤',0),(129736,3604,'ms','Masukkan/Kemaskini mengakses maklumat untuk vendor yang membenarkan capaian kepada maklumat pembekal tertentu',0),(129737,3604,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ÙˆØµÙˆÙ„ Ù„Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ† Ø¨Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨Ø§Ù„Ù…ÙˆØ±Ø¯',0),(129738,3604,'fr','Entrez/mise Ã  jour des informations dâ€™accÃ¨s pour les fournisseurs autorisÃ©s Ã  accÃ©der aux informations spÃ©cifiques au fournisseur',0),(129739,3604,'jp','æ¥­è€…ç‰¹å®šæƒ…å ±ã?¸ã?®ã‚¢ã‚¯ã‚»ã‚¹ã‚’è¨±å?¯ã?•ã‚Œã?Ÿãƒ™ãƒ³ãƒ€ãƒ¼ã?®ã‚¢ã‚¯ã‚»ã‚¹æƒ…å ±ã‚’å…¥åŠ›/æ›´æ–°',0),(129740,3604,'pt','Inserir/atualizar informaÃ§Ãµes de acesso para fornecedores permitida o acesso a informaÃ§Ãµes especÃ­ficas do fornecedor',0),(129741,3604,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ðº Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð², Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½ Ð´Ð¾ÑÑ‚ÑƒÐ¿ Ðº Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(129742,3604,'es','Introducir/Actualizar Acceso a InformaciÃ³n para Proveedores que se Permiten Acceso a InformaciÃ³n Especifica-al Vendedor',0),(129743,3604,'de','Geben Sie/Update Zugang zu Informationen fÃ¼r Anbieter erlaubt Zugriff auf Hersteller-spezifische Informationen',0),(129744,3604,'en','Enter/Update Access Information for Vendors Allowed Access to Vendor-Specific Information',0),(129745,3605,'is','',0),(129746,3605,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù…ÙˆØ¬ÙˆØ¯ ',0),(129747,3605,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù…ÙˆØ¬ÙˆØ¯ ',0),(129748,3605,'tr','Varolan bir BorÃ§lar Bill girin/gÃ¼ncelleme',0),(129749,3605,'pl','WprowadÅº/aktualizacja istniejÄ…cej listy zobowiÄ…zaÅ„',0),(129750,3605,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ ÐºÑŠÐ¼ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(129751,3605,'ur','Ø§ÛŒÚ© Ù…ÙˆØ¬ÙˆØ¯Û Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø¨Ù„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(129752,3605,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ Ð·Ð°ÐºÐ¾Ð½ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(129753,3605,'vi','Nháº­p/Cáº­p Nháº­t 1 HÃ³a ÄÆ¡n Pháº£i Tráº£ Hiá»‡n Táº¡i',0),(129754,3605,'af','Invoer/Opdateer \'n Bestaande Betaalbare Rekening',0),(129755,3605,'ro','IntroduceÅ£i/Update o facturÄƒ de datorii existente',0),(129756,3605,'et','Olemasolevad kohustused arve sisestamine/ajakohastamine',0),(129757,3605,'si','Vnos/posodobitev obstojeÄih obveznosti zakona',0),(129758,3605,'ba','Masukkan/Update tagihan hutang yang ada',0),(129759,3605,'nl','Een bestaande schulden Bill invoeren/bijwerken',0),(129760,3605,'fi','PÃ¤ivittÃ¤minen velat-Bill',0),(129761,3605,'no','Angi/Oppdater en eksisterende gjeld Bill',0),(129762,3605,'da','Indtaste/opdatere en eksisterende gÃ¦ld Bill',0),(129763,3605,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ëŠ” ê¸°ì¡´ ì±„ë¬´ ë²•ì•ˆ',0),(129764,3605,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×—×©×‘×•×Ÿ ×–×›××™× ×”×§×™×™×',0),(129765,3605,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î­Î½Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(129766,3605,'zh','è¾“å…¥/æ›´æ–°çŽ°æœ‰çš„æ¡ä¾‹è‰æ¡ˆåº”ä»˜æ¬¾',0),(129767,3605,'sv','Ange/uppdatera en befintlig LeverantÃ¶rsskulder Bill',0),(129768,3605,'it','Inserisci/Aggiorna una bolletta di debiti esistenti',0),(129769,3605,'tl','',0),(129770,3605,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3592;&#3634;&#3585;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&',0),(129771,3605,'hi','à¤à¤• à¤®à¥Œà¤œà¥‚à¤¦à¤¾ Payables à¤¬à¤¿à¤² à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(129772,3605,'ms','Masukkan/kemas kini bil pemiutang',0),(129773,3605,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(129774,3605,'fr','Entrez/mettre Ã  jour un projet de loi existante des comptes fournisseurs',0),(129775,3605,'jp','å­˜åœ¨ã?™ã‚‹è²·æŽ›é‡‘è«‹æ±‚æ›¸ã?®å…¥åŠ›/æ›´æ–°',0),(129776,3605,'pt','Inserir/atualizar uma conta existente do contas a pagar',0),(129777,3605,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ ÑÑ‡ÐµÑ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(129778,3605,'es','Introducir/Actualizar un Recibo de Pagable Existente',0),(129779,3605,'de','Geben Sie/Update einer bestehenden Verbindlichkeiten StÃ¼ckliste',0),(129780,3605,'en','Enter/Update an Existing Payables Bill',0),(129781,3606,'is','',0),(129782,3606,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ù‡Ø§ Ùˆ Ø±ÙˆØ´Ù‡Ø§ÙŠ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(129783,3606,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ù‡Ø§ Ùˆ Ø±ÙˆØ´Ù‡Ø§ÙŠ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(129784,3606,'tr','TaÅŸÄ±yÄ±cÄ±larÄ± ve sevkiyat yÃ¶ntemleri girin/gÃ¼ncelleme',0),(129785,3606,'pl','WprowadÅº/aktualizacja przewoÅºnikÃ³w i metody wysyÅ‚ki',0),(129786,3606,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡Ð¸ Ð¸ Ð½Ð°Ñ‡Ð¸Ð½Ð¸ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(129787,3606,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø¨Ø±Ø¯Ø§Ø± Ø¬ÛØ§Ø² Ø§ÙˆØ± ÛÚ‘Ù¾Û Ú©Û’ Ø·Ø±ÛŒÙ‚Û’',0),(129788,3606,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð½Ð¾ÑÐ¸Ð¾Ñ†Ð¸ Ð¸ Ð½Ð°Ñ‡Ð¸Ð½Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(129789,3606,'vi','Nháº­p/Cáº­p Nháº­t HÃ£ng & PhÆ°Æ¡ng Thá»©c Váº­n Chuyá»ƒn ',0),(129790,3606,'af','Karweiers en Versendingsmetodes Invoer/Opdateer',0),(129791,3606,'ro','IntroduceÅ£i/actualizare transportatorii ÅŸi metode de livrare',0),(129792,3606,'et','Sisestamine/ajakohastamine vedajad ja LÃ¤hetusviisid',0),(129793,3606,'si','Vnesite posodobitev prevozniki in naÄine dobave',0),(129794,3606,'ba','Masukkan Update operator dan metode pengiriman',0),(129795,3606,'nl','Vervoerders en verzendcondities invoeren/bijwerken',0),(129796,3606,'fi','PÃ¤ivittÃ¤minen harjoittajien ja toimitusehdot',0),(129797,3606,'no','Angi/Oppdater bÃ¦rere og leveringsmÃ¥ter',0),(129798,3606,'da','Indtaste/opdatere luftfartsselskaber og leveringsformer',0),(129799,3606,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ ì‚¬ì—…ìž ë° ì„ ì  ë°©ë²•',0),(129800,3606,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ × ×•×©××™ ×•×©×™×˜×•×ª ×”×ž×©×œ×•×—',0),(129801,3606,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼ÎµÏ„Î±Ï†Î¿ÏÎµÎ¯Ï‚ ÎºÎ±Î¹ Ï„ÏÏŒÏ€Î¿Î¹ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(129802,3606,'zh','è¾“å…¥/æ›´æ–°æ‰¿è¿å•†å’Œè£…è¿æ–¹æ³•',0),(129803,3606,'sv','Ange/uppdatera transportÃ¶rer och leveransvillkor',0),(129804,3606,'it','Inserisci/Aggiorna i vettori e i metodi di spedizione',0),(129805,3606,'tl','',0),(129806,3606,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3632;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(129807,3606,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¾à¤¹à¤• à¤”à¤° à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤¤à¤°à¥€à¤•à¥‹à¤‚',0),(129808,3606,'ms','Masukkan/Kemaskini pembawa dan kaedah penghantaran',0),(129809,3606,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù†Ø§Ù‚Ù„Ø§Øª ÙˆØ·Ø±Ù‚ Ø§Ù„Ø´Ø­Ù†',0),(129810,3606,'fr','Inscrire/mettre Ã  jour les transporteurs et mÃ©thodes dâ€™expÃ©dition',0),(129811,3606,'jp','é…?é€?æ¥­è€…ã?¨ç™ºé€?æ–¹æ³•ã?®å…¥åŠ›/æ›´æ–°',0),(129812,3606,'pt','Inserir/atualizar as transportadoras e os mÃ©todos de envio',0),(129813,3606,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÑƒÑ€ÑŒÐµÑ€Ð° Ð¸ Ð¡Ð¿Ð¾ÑÐ¾Ð± Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(129814,3606,'es','Introducir/Actualizar Transportadores y Modos de EnvÃ­o',0),(129815,3606,'de','Geben Sie/Update Carrier und Lieferbedingungen',0),(129816,3606,'en','Enter/Update Carriers and Shipment Methods',0),(129817,3607,'is','',0),(129818,3607,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø¬Ù†Ø³ ',0),(129819,3607,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(129820,3607,'tr','Ã–ÄŸe kategorilerini girin/gÃ¼ncelleme',0),(129821,3607,'pl','WprowadÅº/aktualizacja kategorii elementÃ³w',0),(129822,3607,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ',0),(129823,3607,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù… Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(129824,3607,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(129825,3607,'vi','Nháº­p/Cáº­p Nháº­t Thá»ƒ Loáº¡i Cho Danh Má»¥c',0),(129826,3607,'af','Invoer/Opdateer Kategorie van Items',0),(129827,3607,'ro','IntroduceÅ£i/actualizare categorii de articole',0),(129828,3607,'et','Sisesta/Uuenda tootekategooriaid',0),(129829,3607,'si','Vnos/posodobitev kategorije predmetov',0),(129830,3607,'ba','Isi/Perbarui Kategori Item',0),(129831,3607,'nl','CategorieÃ«n van Items invoeren/bijwerken',0),(129832,3607,'fi','PÃ¤ivittÃ¤minen Luokat erien',0),(129833,3607,'no','Angi/Oppdater kategorier av elementer',0),(129834,3607,'da','Indtaste/opdatere kategorier af varer',0),(129835,3607,'ko','í•­ëª©ì˜ ë²”ì£¼ë¥¼ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(129836,3607,'he','×”×›× ×¡/×¢×“×›×Ÿ ×§×˜×’×•×¨×™×•×ª ×¤×¨×™×˜×™×',0),(129837,3607,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Ï„Î¿Ï…',0),(129838,3607,'zh','è¾“å…¥/æ›´æ–°çš„é¡¹ç›®ç±»åˆ«',0),(129839,3607,'sv','Ange/uppdatera kategorier av objekt',0),(129840,3607,'it','Inserisci/Aggiorna categorie di elementi',0),(129841,3607,'tl','',0),(129842,3607,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(129843,3607,'hi','à¤®à¤¦à¥‹à¤‚ à¤•à¥€ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(129844,3607,'ms','Masukkan/Kemaskini kategori item',0),(129845,3607,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« ÙØ¦Ø§Øª Ø§Ù„Ø¨Ù†ÙˆØ¯',0),(129846,3607,'fr','Inscrire/mettre Ã  jour des catÃ©gories dâ€™Articles',0),(129847,3607,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®å…¥åŠ›/æ›´æ–°',0),(129848,3607,'pt','Inserir/atualizar categorias de itens',0),(129849,3607,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(129850,3607,'es','Introducir/Actualizar CategorÃ­as de Items',0),(129851,3607,'de','Geben Sie/Update-Kategorien von GegenstÃ¤nden',0),(129852,3607,'en','Enter/Update Categories of Items',0),(129853,3608,'is','',0),(129854,3608,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(129855,3608,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(129856,3608,'tr','Girin/gÃ¼ncelleme kontrol BorÃ§lar iÃ§in kullanÄ±lan hesaplarÄ±',0),(129857,3608,'pl','WprowadÅº/aktualizacji sprawdzanie konta uÅ¼ywane dla zobowiÄ…zaÅ„',0),(129858,3608,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(129859,3608,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(129860,3608,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ð¸ ÐºÐ¾Ñ€Ð¸ÑˆÑ‚ÐµÐ½Ð¸ Ð·Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(129861,3608,'vi','Nháº­p/Cáº­p Nháº­t TK Kiá»ƒm Tra Sá»­ Dá»¥ng Cho TK Pháº£i Tráº£',0),(129862,3608,'af','Invoer/Opdateer van Kontrolerekeninge vir Uitgawes (RB)',0),(129863,3608,'ro','IntroduceÅ£i/actualizare verificarea conturilor utilizate pentru datorii',0),(129864,3608,'et','Sisestamine/ajakohastamine kontrolli kontosid kasutatakse vÃµlad',0),(129865,3608,'si','Vnesite posodobitev preverjanje raÄunov, ki se uporablja za obveznosti',0),(129866,3608,'ba','Masukkan Update rekening digunakan untuk hutang',0),(129867,3608,'nl','Voer/Update controle van de rekeningen gebruikt voor schulden',0),(129868,3608,'fi','PÃ¤ivittÃ¤minen tileistÃ¤ kÃ¤ytetÃ¤Ã¤n ostojen',0),(129869,3608,'no','Angi/Oppdater sjekker regnskapet brukes for leverandÃ¸rgjeld',0),(129870,3608,'da','Indtaste/opdatere lÃ¸nkonti bruges til gÃ¦ld',0),(129871,3608,'ko','ë¯¸ì§€ê¸‰ê¸ˆì— ëŒ€ í•œ ì‚¬ìš© í•˜ëŠ” ìž…ë ¥/ì—…ë°ì´íŠ¸ ë‹¹ì¢Œ ê³„ì •',0),(129872,3608,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×—×©×‘×•×Ÿ ×”×ž×©×ž×© ×¢×‘×•×¨ ×–×›××™×',0),(129873,3608,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Ï„Ï‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Î³Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(129874,3608,'zh','è¾“å…¥/æ›´æ–°ç”¨äºŽåº”ä»˜æ£€æŸ¥å¸ç›®',0),(129875,3608,'sv','Ange/uppdatera kontroll konton fÃ¶r leverantÃ¶rsskulder',0),(129876,3608,'it','Inserisci/Aggiorna conti correnti utilizzati per debiti',0),(129877,3608,'tl','',0),(129878,3608,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&',0),(129879,3608,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤œà¤¾à¤à¤š à¤–à¤¾à¤¤à¥‹à¤‚ Payables à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(129880,3608,'ms','Masukkan/Kemaskini akaun memeriksa digunakan untuk pemiutang',0),(129881,3608,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« \"Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª\" Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(129882,3608,'fr','Entrez/mise Ã  jour de vÃ©rification des comptes utilisÃ©s pour des comptes fournisseurs',0),(129883,3608,'jp','è²·æŽ›é‡‘ç”¨å½“åº§é ?é‡‘ã?®å…¥åŠ›/æ›´æ–°',0),(129884,3608,'pt','Inserir/atualizar contas usadas para contas a pagar',0),(129885,3608,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ ÑÑ‡ÐµÑ‚Ð¾Ð², Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ñ… Ð´Ð»Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(129886,3608,'es','Introducir/Actualizar Cuentas de Cheques usadas para Proveedores',0),(129887,3608,'de','Geben Sie/Update Girokonten fÃ¼r Verbindlichkeiten verwendet',0),(129888,3608,'en','Enter/Update Checking Accounts used for Payables',0),(129889,3609,'is','',0),(129890,3609,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡ ',0),(129891,3609,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(129892,3609,'tr','Girin/gÃ¼ncelleme Ã‡ek Bordro iÃ§in kullanÄ±lan hesaplarÄ±',0),(129893,3609,'pl','WprowadÅº/aktualizacji sprawdzanie konta uÅ¼ywane dla listy pÅ‚ac',0),(129894,3609,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(129895,3609,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ù¾Û’ Ø±ÙˆÙ„ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(129896,3609,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ð¸ ÐºÐ¾Ñ€Ð¸ÑˆÑ‚ÐµÐ½Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº',0),(129897,3609,'vi','Nháº­p/Cáº­p Nháº­t TK Kiá»ƒm Tra Sá»­ Dá»¥ng Cho LÆ°Æ¡ng',0),(129898,3609,'af','Invoer/Opdateer Kontrolerekeninge gebruik vir Loonrol',0),(129899,3609,'ro','IntroduceÅ£i/actualizare verificarea conturilor utilizate pentru salarizare',0),(129900,3609,'et','Sisestamine/ajakohastamine kontrolli kontosid kasutatakse palgaarvestuse',0),(129901,3609,'si','Vnesite posodobitev preverjanje raÄunov za izplaÄane plaÄe',0),(129902,3609,'ba','Masukkan Update rekening digunakan untuk penggajian',0),(129903,3609,'nl','Voer/Update controle van de rekeningen gebruikt voor Payroll',0),(129904,3609,'fi','PÃ¤ivittÃ¤minen tileistÃ¤ kÃ¤ytetÃ¤Ã¤n palkanlaskennan',0),(129905,3609,'no','Angi/Oppdater sjekker regnskapet brukes for lÃ¸nn',0),(129906,3609,'da','Indtaste/opdatere lÃ¸nkonti bruges til lÃ¸n',0),(129907,3609,'ko','ê¸‰ì—¬ì— ëŒ€ í•œ ì‚¬ìš© í•˜ëŠ” ìž…ë ¥/ì—…ë°ì´íŠ¸ ë‹¹ì¢Œ ê³„ì •',0),(129908,3609,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×—×©×‘×•×Ÿ ×”×ž×©×ž×© ×¢×‘×•×¨ ×©×›×¨',0),(129909,3609,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Ï„Ï‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î± Ï„Î· Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±',0),(129910,3609,'zh','è¾“å…¥/æ›´æ–°ç”¨äºŽå·¥èµ„å¸ç›®æ£€æŸ¥',0),(129911,3609,'sv','Ange/uppdatera kontroll konton anvÃ¤nds fÃ¶r lÃ¶n',0),(129912,3609,'it','Inserisci/Aggiorna conti correnti utilizzati per il libro paga',0),(129913,3609,'tl','',0),(129914,3609,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&',0),(129915,3609,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤œà¤¾à¤à¤š à¤–à¤¾à¤¤à¥‹à¤‚ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤‚à¤¬à¤§à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(129916,3609,'ms','Masukkan/Kemaskini akaun memeriksa yang digunakan untuk pembayaran gaji',0),(129917,3609,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« \"Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª\" Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(129918,3609,'fr','Inscrire/mettre Ã  jour comptes utilisÃ©s par retenues salariales',0),(129919,3609,'jp','çµ¦ä¸Žç”¨å½“åº§é ?é‡‘ã?®å…¥åŠ›/æ›´æ–°',0),(129920,3609,'pt','Inserir/atualizar contas usadas para folha de pagamento',0),(129921,3609,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ ÑÑ‡ÐµÑ‚Ð¾Ð², Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ñ… Ð´Ð»Ñ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(129922,3609,'es','Introducir/Actualizar Cuentas de Cheques usadas para la NÃ³mina',0),(129923,3609,'de','Geben Sie/Update Girokonten verwendet fÃ¼r die Abrechnung',0),(129924,3609,'en','Enter/Update Checking Accounts used for Payroll',0),(129925,3610,'is','',0),(129926,3610,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø´Ø±ÙƒØªÙ‡Ø§ÙŠ ØªØ­Øª Ù¾ÙˆØ´Ø´ Ø³ÙŠØ³ØªÙ… ',0),(129927,3610,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±ÙƒØªÙ‡Ø§ÙŠ ØªØ­Øª Ù¾ÙˆØ´Ø´ Ø³ÙŠØ³ØªÙ… ',0),(129928,3610,'tr','Girin/gÃ¼ncelleme sistemi tarafÄ±ndan kapalÄ± ÅŸirketler',0),(129929,3610,'pl','WprowadÅº/aktualizacja przedsiÄ™biorstwa objÄ™te systemem',0),(129930,3610,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ¶ÐµÑÑ‚Ð²Ð°Ñ‚Ð°, Ð¾Ð±Ñ…Ð²Ð°Ð½Ð°Ñ‚Ð¸ Ð¾Ñ‚ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(129931,3610,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ú©Û’ Ù†Ø¸Ø§Ù… Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø­Ø§Ø·Û Ú©Ø±ØªØ§ ÛÛ’',0),(129932,3610,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¿Ð¾ÐºÑ€Ð¸Ð²Ð° ÑÐ¸ÑÑ‚ÐµÐ¼',0),(129933,3610,'vi','Nháº­p/Cáº­p Nháº­t Cty Theo Há»‡ Thá»‘ng',0),(129934,3610,'af','Invoer/Opdateer Ondernemings Gedek deur die Sisteem',0),(129935,3610,'ro','IntroduceÅ£i/actualizare companii intrÄƒ sub incidenÈ›a sistemului',0),(129936,3610,'et','Sisestamine/ajakohastamine ettevÃµtete vÃµrgu',0),(129937,3610,'si','Vnesite posodobitev podjetij, zajetih v sistem',0),(129938,3610,'ba','Masukkan Update perusahaan ditutupi oleh sistem',0),(129939,3610,'nl','Invoeren/bijwerken bedrijven systeem vallende',0),(129940,3610,'fi','JÃ¤rjestelmÃ¤n pÃ¤ivittÃ¤minen yritykset',0),(129941,3610,'no','Angi/Oppdater selskaper dekket av systemet',0),(129942,3610,'da','Indtaste/opdatere virksomheder er omfattet af systemet',0),(129943,3610,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ íšŒì‚¬ ì‹œìŠ¤í…œì— ì˜í•´ ë³´í˜¸',0),(129944,3610,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×—×‘×¨×•×ª ×ž×›×•×¡×” ×¢×œ ×™×“×™ ×”×ž×¢×¨×›×ª',0),(129945,3610,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Ï€Î¿Ï… ÎºÎ±Î»ÏÏ€Ï„Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ Ï„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(129946,3610,'zh','è¾“å…¥/æ›´æ–°ç”±åˆ¶åº¦ä¿éšœçš„å…¬å¸',0),(129947,3610,'sv','Ange/uppdatera fÃ¶retag som omfattas av systemet',0),(129948,3610,'it','Inserisci/Aggiorna societÃ  coperte dal sistema',0),(129949,3610,'tl','',0),(129950,3610,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3632;&#3610;&#3610;',0),(129951,3610,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¤µà¤° à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚',0),(129952,3610,'ms','Masukkan/Kemaskini Syarikat dilindungi oleh sistem',0),(129953,3610,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„Ù…Ø´Ù…ÙˆÙ„Ø© Ø¨Ø§Ù„Ù†Ø¸Ø§Ù…',0),(129954,3610,'fr','Inscrire/mettre Ã  jour entreprises couvertes par le systÃ¨me',0),(129955,3610,'jp','ã‚·ã‚¹ãƒ†ãƒ ã?§å¯¾è±¡ã?¨ã?ªã?£ã?¦ã?„ã‚‹ä¼šç¤¾ã?®å…¥åŠ›/æ›´æ–°',0),(129956,3610,'pt','Inserir/atualizar as empresas abrangidas pelo sistema',0),(129957,3610,'ru','Ð’Ð²Ð¾Ð´/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¹, Ð¾Ñ…Ð²Ð°Ñ‚Ñ‹Ð²Ð°ÐµÐ¼Ñ‹Ñ… ÑÐ¸ÑÑ‚ÐµÐ¼Ð¾Ð¹',0),(129958,3610,'es','Introducir/Actualizar Empresas Cubiertas por el Sistema',0),(129959,3610,'de','Fallenden System eingeben/Update-Unternehmen',0),(129960,3610,'en','Enter/Update Companies Covered by System',0),(129961,3611,'is','',0),(129962,3611,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù„ÙŠØ³Øª Ø¹Ù†Ø§ØµØ± Ø¨Ø±Ø§ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡   Ø¬Ù†Ø³Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ù…ÙˆØ§Ø¯ ',0),(129963,3611,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø¹Ù†Ø§ØµØ± Ø¨Ø±Ø§ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡   ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ù…ÙˆØ§Ø¯ ',0),(129964,3611,'tr','BileÅŸen listesi iÃ§in malzeme stok maddelerinin girin/gÃ¼ncelleme',0),(129965,3611,'pl','WprowadÅº/Aktualizacja listy komponentÃ³w BOM zapasÃ³w materiaÅ‚Ã³w',0),(129966,3611,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¸ Ð·Ð° ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑÐ½Ð¾ Ð¸Ð·Ð´ÐµÐ»Ð¸Ðµ ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(129967,3611,'ur','Ù…ÙˆØ§Ø¯ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ø¨Ù„ Ú©Û’ Ù„Ø¦Û’ Ø¬Ø²Ùˆ ÙÛØ±Ø³Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(129968,3611,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð»Ð¸ÑÑ‚Ñƒ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¸ Ð·Ð° Ð‘Ð¸Ð»Ð»Ð° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(129969,3611,'vi','Nháº­p/Cáº­p Nháº­t Danh SÃ¡ch ThÃ nh Pháº§n NguyÃªn Váº­t Liá»‡u cho MÃ£ HÃ ng HÃ³a',0),(129970,3611,'af','Invoer/Opdateer Komponentlys vir Materiaallys van Inventarisitems',0),(129971,3611,'ro','IntroduceÅ£i/actualizaÅ£i lista de componente pentru factura de materiale obiecte de inventar',0),(129972,3611,'et','Materjalide lao kaupu komponentide loendisse sisestamine/ajakohastamine',0),(129973,3611,'si','Vnesite posodobitev komponent za Bill materialov inventarja',0),(129974,3611,'ba','Daftar komponen masukkan Update untuk tagihan bahan persediaan barang',0),(129975,3611,'nl','Component lijst voor Bill van materialen voorraadartikelen invoeren/bijwerken',0),(129976,3611,'fi','PÃ¤ivittÃ¤minen komponenttiluettelo materiaalit varaston nimikkeitÃ¤',0),(129977,3611,'no','Angi/Oppdater komponentoversikten for Bill av materiale lagervarer',0),(129978,3611,'da','Indtaste/opdatere komponentliste for Bill af materiale lagervarer',0),(129979,3611,'ko','ìž¬ë£Œ ìž¬ê³  ëª©ë¡ í’ˆëª©ì˜ ë²•ì•ˆì— ëŒ€ í•œ ìž…ë ¥/ì—…ë°ì´íŠ¸ êµ¬ì„± ìš”ì†Œ ëª©ë¡',0),(129980,3611,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×¨×›×™×‘ ×”×¨×©×™×ž×” ×¢×‘×•×¨ ×”×—×©×‘×•×Ÿ ×©×œ ×¤×¨×™×˜×™ ×ž×œ××™ ×—×•×ž×¨×™×',0),(129981,3611,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï… Ï…Ï€Î¿Ï€Î±Î³Î¯Ï‰Î½ Î³Î¹Î± Ï„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï„Ï‰Î½ Ï…Î»Î¹ÎºÏŽÎ½ Î±Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÎ¹Î´ÏŽÎ½',0),(129982,3611,'zh','è¾“å…¥/æ›´æ–°ææ–™åº“å­˜é¡¹ç›®å¸å•çš„ç»„ä»¶æ¸…å•',0),(129983,3611,'sv','Ange/uppdatera komponentlistan fÃ¶r produktstruktur material lagerartiklar',0),(129984,3611,'it','Inserisci/Aggiorna elenco componenti per la distinta materiali articoli di magazzino',0),(129985,3611,'tl','',0),(129986,3611,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3610;&#3636;&',0),(129987,3611,'hi','à¤¬à¤¿à¤² à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤˜à¤Ÿà¤• à¤¸à¥‚à¤šà¥€',0),(129988,3611,'ms','Masukkan/kemas kini Senarai komponen bil item inventori bahan',0),(129989,3611,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙƒÙˆÙ†Ø§Øª Ù„Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ù…ÙˆØ§Ø¯',0),(129990,3611,'fr','Entrez/mise Ã  jour liste de composants pour la facture des articles en stock matiÃ¨res',0),(129991,3611,'jp','æ??æ–™åœ¨åº«å“?ç›®ã?®è«‹æ±‚æ›¸ã?®æ§‹æˆ?å“?ãƒªã‚¹ãƒˆã?®å…¥åŠ›/æ›´æ–°',0),(129992,3611,'pt','Inserir/atualizar lista de componente para o Bill de itens de estoque de materiais',0),(129993,3611,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¾Ð² Ð´Ð»Ñ Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð² Ñ‚Ð¾Ð²Ð°Ñ€Ð½Ð¾-Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ñ… Ñ†ÐµÐ½Ð½Ð¾ÑÑ‚ÐµÐ¹',0),(129994,3611,'es','Introducir/Actualizar Lista de Componentes para Items de Inventaro de Recibo de Materiales',0),(129995,3611,'de','Geben Sie/Update Komponentenliste fÃ¼r Rechnung von Materialien Lagerartikel',0),(129996,3611,'en','Enter/Update Component List for Bill of Materials Inventory Items',0),(129997,3612,'is','',0),(129998,3612,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ù„ÛŒØ¬Ø± ',0),(129999,3612,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(130000,3612,'tr','Genel muhasebe bÃ¼tÃ§eleri girin/gÃ¼ncelleme',0),(130001,3612,'pl','WprowadÅº/aktualizacja budÅ¼etÃ³w ksiÄ™gi ogÃ³lne',0),(130002,3612,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð» Ð›ÐµÐ´Ð¶ÑŠÑ€ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸',0),(130003,3612,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø¨Ø¬Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(130004,3612,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ Ð±ÑƒÑŸÐµÑ‚Ðµ',0),(130005,3612,'vi','Nháº­p/Cáº­p Nháº­t NgÃ¢n SÃ¡ch Sá»• CÃ¡i Tá»•ng Há»£p',0),(130006,3612,'af','Invoer/opdateer Algemene Grootboek Begrotings',0),(130007,3612,'ro','IntroduceÅ£i/Update General Ledger bugete',0),(130008,3612,'et','Ãœldised pearaamatu eelarvete sisestamine/ajakohastamine',0),(130009,3612,'si','Vnos/posodobitev General Ledger proraÄunov',0),(130010,3612,'ba','Masukkan/Update General Ledger anggaran',0),(130011,3612,'nl','General Ledger begrotingen invoeren/bijwerken',0),(130012,3612,'fi','PÃ¤ivittÃ¤minen yleinen kirjanpitobudjetteihin',0),(130013,3612,'no','Angi/Oppdater generelt finansbudsjetter',0),(130014,3612,'da','Indtaste/opdatere General finansbudgetter',0),(130015,3612,'ko','ì¼ë°˜ ë ˆì € ì˜ˆì‚° ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(130016,3612,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×›×œ×œ×™ ×‘×¡×¤×¨×™ ×”×ª×§×¦×™×‘',0),(130017,3612,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Î³ÎµÎ½Î¹ÎºÎ¿Ï ÎºÎ±Î¸Î¿Î»Î¹ÎºÎ¿Ï Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(130018,3612,'zh','è¾“å…¥/æ›´æ–°æ€»å¸é¢„ç®—',0),(130019,3612,'sv','Ange/uppdatera allmÃ¤nna redovisningsbudgetar',0),(130020,3612,'it','Inserisci/Aggiorna budget di contabilitÃ  generale',0),(130021,3612,'tl','',0),(130022,3612,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(130023,3612,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤²à¥‡à¤œà¤¼à¤° à¤¬à¤œà¤Ÿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(130024,3612,'ms','Masukkan/Kemaskini belanjawan Lejar Am',0),(130025,3612,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ø§Ù„Ø£Ø³ØªØ§Ø°Ø§Ù„Ø¹Ø§Ù…',0),(130026,3612,'fr','Entrez/mise Ã  jour des Budgets de comptabilitÃ© gÃ©nÃ©rale',0),(130027,3612,'jp','ç·?å‹˜å®šå…ƒå¸³äºˆç®—ã?®å…¥åŠ›/æ›´æ–°',0),(130028,3612,'pt','Inserir/atualizar General Ledger orÃ§amentos',0),(130029,3612,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ñ‹ Ð“Ð»Ð°Ð²Ð½Ð¾Ð¹ ÐšÐ½Ð¸Ð³Ð¸',0),(130030,3612,'es','Introducir/Actualizar Presupuestos de Libro Mayor',0),(130031,3612,'de','General Ledger Budgets geben Sie/Update',0),(130032,3612,'en','Enter/Update General Ledger Budgets',0),(130033,3613,'is','',0),(130034,3613,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù„ÛŒØ¬Ø± Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ ',0),(130035,3613,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ ',0),(130036,3613,'tr','Alacaklar iÃ§in kullanÄ±lan GL hesaplarÄ±nÄ± girin/gÃ¼ncelleme',0),(130037,3613,'pl','WprowadÅº/aktualizacja konta uÅ¼ywane do naleÅ¼noÅ›ci',0),(130038,3613,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð·Ð° Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ',0),(130039,3613,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ø±ÛŒÚ©ÛŒÙˆØ§Ø¨Ù„Ø§Ø³ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(130040,3613,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð¸ ÐºÐ¾Ñ€Ð¸ÑˆÑ‚ÐµÐ½Ð¸ Ð·Ð° Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(130041,3613,'vi','Nháº­p/Cáº­p Nháº­t TK Sá»• CÃ¡i Tá»•ng Há»£p Sá»­ Dá»¥ng Cho Pháº£i Thu',0),(130042,3613,'af','Invoer/Opdateer AG Rekeninge Gebruik vir Ontvangstes',0),(130043,3613,'ro','IntroduceÅ£i/actualizare GL conturi utilizate pentru creanÅ£e',0),(130044,3613,'et','Sisestamine/ajakohastamine GL kontosid, arved',0),(130045,3613,'si','Vnos/posodobitev GL raÄune za terjatve',0),(130046,3613,'ba','Masukkan/Update GL account yang digunakan untuk piutang',0),(130047,3613,'nl','Invoeren/bijwerken GL Accounts die worden gebruikt voor vorderingen',0),(130048,3613,'fi','PÃ¤ivittÃ¤minen GL kÃ¤yttÃ¤jÃ¤tileillÃ¤ saamiset',0),(130049,3613,'no','Angi/Oppdater GL konti for kundefordringer',0),(130050,3613,'da','Indtaste/opdatere GL konti bruges til tilgodehavender',0),(130051,3613,'ko','ì±„ê¶Œì— ëŒ€ í•œ ì‚¬ìš© í•˜ëŠ” GL ê³„ì • ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(130052,3613,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×—×©×‘×•× ×•×ª GL ×”×ž×©×ž×© ×¢×‘×•×¨ ×—×©×‘×•× ×•×ª ×—×™×™×‘×™×',0),(130053,3613,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î³/Î» Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± ÎµÎ¹ÏƒÏ€ÏÎ±ÎºÏ„Î­Î±',0),(130054,3613,'zh','è¾“å…¥/æ›´æ–°ç”¨äºŽåº”æ”¶æ¬¾é¡¹çš„æ€»å¸å¸æˆ·',0),(130055,3613,'sv','Ange/uppdatera GL konton som anvÃ¤nds fÃ¶r fordringar',0),(130056,3613,'it','Inserisci/Aggiorna conti di contabilitÃ  generale utilizzati per i crediti commerciali',0),(130057,3613,'tl','',0),(130058,3613,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3585;&#3633;&#3610;&#3621;&',0),(130059,3613,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/GL à¤–à¤¾à¤¤à¥‹à¤‚ Receivables à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(130060,3613,'ms','Masukkan/Kemaskini akaun GL yang digunakan untuk penghutang',0),(130061,3613,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø¯ÙŠÙ†ÙŠÙ† ÙÙŠ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(130062,3613,'fr','Entrez/mise Ã  jour des comptes GL utilisÃ©s pour des comptes clients',0),(130063,3613,'jp','å?—å?–å‹˜å®šç”¨ç·?å‹˜å®šå…ƒå¸³ã?®å…¥åŠ›/æ›´æ–°',0),(130064,3613,'pt','Inserir/atualizar GL contas usadas para recebÃ­veis',0),(130065,3613,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ GL ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ðµ Ð´Ð»Ñ Ð´ÐµÐ±Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(130066,3613,'es','Introducir/Actualizar  Cuentas de Libro Mayor Usados Para Cuentas por Cobrar',0),(130067,3613,'de','Geben Sie/Update GL Konten fÃ¼r Forderungen',0),(130068,3613,'en','Enter/Update GL Accounts Used for Receivables',0),(130069,3614,'is','',0),(130070,3614,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ù…Ø³ØªÙ…Ø±ÙŠ / Ø³Ù„Ø§Ù…Øª / Ø¯ÙŠÚ¯Ø± Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø·Ø±Ø­ ',0),(130071,3614,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù…Ø³ØªÙ…Ø±ÙŠ / Ø³Ù„Ø§Ù…Øª / Ø¯ÙŠÚ¯Ø± Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø·Ø±Ø­ ',0),(130072,3614,'tr','Pension/saÄŸlÄ±k/diÄŸer planÄ± bilgileri girin/gÃ¼ncelleme',0),(130073,3614,'pl','WprowadÅº/aktualizacja planu emerytalnego/zdrowie/inne informacje',0),(130074,3614,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿ÐµÐ½ÑÐ¸ÑÑ‚Ð°/Ð·Ð´Ñ€Ð°Ð²Ðµ/Ð´Ñ€ÑƒÐ³ Ð¿Ð»Ð°Ð½ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(130075,3614,'ur','Ù¾Ù†Ø´Ù†/ØµØ­Øª/Ø¯ÛŒÚ¯Ø± Ù…Ù†ØµÙˆØ¨Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(130076,3614,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¿ÐµÐ½Ð·Ð¸Ñ˜Ð°/Ð·Ð´Ñ€Ð°Ð²ÑÑ‚Ð²Ð¾/Ð´Ñ€ÑƒÐ³Ð¸ ÐŸÐ»Ð°Ð½',0),(130077,3614,'vi','Nháº­p/Cáº­p Nháº­t LÆ°Æ¡ng HÆ°u/Sá»©c Khá»e/CÃ¡c ThÃ´ng Tin Káº¿ Hoáº¡ch KhÃ¡c',0),(130078,3614,'af','Invoer/Opdateer Pensioenplan/Gesondheid/Inligting van Ander Planne',0),(130079,3614,'ro','IntroduceÅ£i/actualizare Plan de pensie/sÄƒnÄƒtate/alte informaÅ£ii',0),(130080,3614,'et','Pensioni/tervisele/muu teave sisestamine/ajakohastamine',0),(130081,3614,'si','Vnos/posodobitev pokojnine/zdravje/druga naÄrt informacije',0),(130082,3614,'ba','Masukkan/Update informasi rencana pensiun/kesehatan/lainnya',0),(130083,3614,'nl','Pensioen/gezondheid/andere Plan informatie invoeren/bijwerken',0),(130084,3614,'fi','PÃ¤ivittÃ¤minen Pension/terveys/muut tietoja',0),(130085,3614,'no','Angi/Oppdater informasjon om pensjon/helse/andre omrÃ¥deplanen',0),(130086,3614,'da','Indtaste/opdatere Pension/sundhed/andre Plan oplysninger',0),(130087,3614,'ko','ì—°ê¸ˆ/ê±´ê°•/ê¸°íƒ€ ê³„íš ì •ë³´ë¥¼ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(130088,3614,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×¤×¨×˜×™ ×ª×•×›× ×™×ª ×¤× ×¡×™×”/×‘×¨×™××•×ª/××—×¨×™×',0),(130089,3614,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÏ‡Î­Î´Î¹Î¿ ÏƒÏÎ½Ï„Î±Î¾Î·Ï‚/Ï…Î³ÎµÎ¯Î±Ï‚/Î¬Î»Î»ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(130090,3614,'zh','è¾“å…¥/æ›´æ–°é€€ä¼‘é‡‘/å¥åº·/å…¶ä»–è§„åˆ’ä¿¡æ¯',0),(130091,3614,'sv','Ange/uppdatera Pension/hÃ¤lsa/andra Plan Information',0),(130092,3614,'it','Inserisci/Aggiorna piano Pension/salute/altre informazioni',0),(130093,3614,'tl','',0),(130094,3614,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3635;&#3648;&#3627;&#3609;&#3655;&#3592;/&#3626;&#3640;&#3586;&#3616;&#3634;&#3614;/&#3649;&#3612;&#3609;&#3629;&#3639',0),(130095,3614,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤ªà¥‡à¤‚à¤¶à¤¨/à¤¸à¥à¤µà¤¾à¤¸à¥à¤¥à¥à¤¯/à¤…à¤¨à¥à¤¯ à¤¯à¥‹à¤œà¤¨à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(130096,3614,'ms','Masukkan/Kemaskini maklumat pelan pencen/kesihatan/lain-lain',0),(130097,3614,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø®Ø·Ø© Ø§Ù„Ù…Ø¹Ø§Ø´Ø§Øª Ø§Ù„ØªÙ‚Ø§Ø¹Ø¯ÙŠØ©/Ø§Ù„ØµØ­Ø©/Ø£Ø®Ø±Ù‰',0),(130098,3614,'fr','Entrez/mise Ã  jour des informations de Plan de retraite/santÃ©/autres',0),(130099,3614,'jp','å¹´é‡‘ã€?å?¥åº·ä¿?é™ºã?ªã?©ã?®æƒ…å ±ã‚’å…¥åŠ›/æ›´æ–°',0),(130100,3614,'pt','Inserir/atualizar informaÃ§Ãµes do plano de pensÃ£o/saÃºde/outros',0),(130101,3614,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿ÐµÐ½ÑÐ¸Ð¸/Ð·Ð´Ð¾Ñ€Ð¾Ð²ÑŒÐµ/Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ð¿Ð»Ð°Ð½ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸',0),(130102,3614,'es','Introducir/Actualizar PensiÃ³n/Salud/Otro Plan InformaciÃ³n',0),(130103,3614,'de','Pension/Gesundheit/andere Informationen eingeben/Update',0),(130104,3614,'en','Enter/Update Pension/Health/Other Plan Information',0),(130105,3615,'is','',0),(130106,3615,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø³Ø·ÙˆØ­ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³ ',0),(130107,3615,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø·ÙˆØ­ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(130108,3615,'tr','Girin/gÃ¼ncelleme dÃ¼zeyleri stok satÄ±ÅŸ iÃ§in fiyatlandÄ±rma',0),(130109,3615,'pl','WprowadÅº/aktualizacji poziomÃ³w cen dla sprzedaÅ¼y zapasÃ³w',0),(130110,3615,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ð½Ð¸Ð²Ð° Ð·Ð° ÑÐºÐ»Ð°Ð´ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(130111,3615,'ur','Ø¯Ø§Ø®Ù„/Ø³Ø·Ø­ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ ÙØ±ÙˆØ®Øª Ú©Û’ Ù„Ø¦Û’ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(130112,3615,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ñ†ÐµÐ½Ðµ Ð½Ð¸Ð²Ð¾Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(130113,3615,'vi','Nháº­p/Cáº­p Nháº­t CÃ¡c Má»©c GiÃ¡ BÃ¡n Cho HÃ ng Trong Kho ',0),(130114,3615,'af','Invoer/Opdateer Prysvlakke vir Inventaris Verkope',0),(130115,3615,'ro','IntroduceÅ£i/actualizare nivelurile de stabilire a preÅ£urilor de vÃ¢nzare inventar',0),(130116,3615,'et','Sisestamine/ajakohastamine hinnatasemele varude mÃ¼Ã¼k',0),(130117,3615,'si','Vnos/posodobitev cenovnih ravneh za zaloge prodajo',0),(130118,3615,'ba','Masukkan/Update harga tingkat untuk penjualan persediaan',0),(130119,3615,'nl','Invoeren/bijwerken prijsniveaus voor inventaris verkoop',0),(130120,3615,'fi','PÃ¤ivittÃ¤minen hintatasoja varaston myynti',0),(130121,3615,'no','Angi/Oppdater priser nivÃ¥er for inventar salgs',0),(130122,3615,'da','Indtaste/opdatere prisniveauet for lager salg',0),(130123,3615,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ ìˆ˜ì¤€ ìž¬ê³  íŒë§¤ ê°€ê²©',0),(130124,3615,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ××™×ž×•×©×™×™×• ×¨×ž×•×ª ×”×ž×œ××™ ×”×ž×›×™×¨×•×ª',0),(130125,3615,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏ€Î¯Ï€ÎµÎ´Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î¹Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(130126,3615,'zh','è¾“å…¥/æ›´æ–°åº“å­˜é”€å”®å®šä»·æ°´å¹³',0),(130127,3615,'sv','Ange/uppdatera prisnivÃ¥er fÃ¶r lagerfÃ¶rsÃ¤ljning',0),(130128,3615,'it','Inserisci/Aggiorna prezzi livelli per le vendite di inventario',0),(130129,3615,'tl','',0),(130130,3615,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3626;&#3636;&#3609;&',0),(130131,3615,'hi','à¤®à¤¾à¤² à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‡ à¤¸à¥à¤¤à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(130132,3615,'ms','Masukkan/Kemaskini harga tahap untuk jualan inventori',0),(130133,3615,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø§Ù„ØªØ³Ø¹ÙŠØ± Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(130134,3615,'fr','Entrez/mise Ã  jour de niveaux de prix pour la vente de lâ€™inventaire',0),(130135,3615,'jp','å“?ç›®ã‚»ãƒ¼ãƒ«ã‚¹ã?®ä¾¡æ ¼æ°´æº–ã?®å…¥åŠ›/æ›´æ–°',0),(130136,3615,'pt','Inserir/atualizar nÃ­veis de preÃ§os para vendas de inventÃ¡rio',0),(130137,3615,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½ ÑƒÑ€Ð¾Ð²Ð½ÐµÐ¹ Ð´Ð»Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(130138,3615,'es','Introducir/Actualizar Niveles de Precios para Ventas de Inventario',0),(130139,3615,'de','Geben Sie/Update Preisniveau fÃ¼r Inventar Verkauf',0),(130140,3615,'en','Enter/Update Pricing Levels for Inventory Sales',0),(130141,3616,'is','',0),(130142,3616,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ( ÙØ±ÙˆØ´',0),(130143,3616,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ( ÙØ±ÙˆØ´',0),(130144,3616,'tr','SatÄ±ÅŸ eylemleri girin/gÃ¼ncelleme',0),(130145,3616,'pl','WprowadÅº/aktualizacja sprzedaÅ¼y akcji',0),(130146,3616,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(130147,3616,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø§Ø¹Ù…Ø§Ù„ Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(130148,3616,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ñ€Ð°Ð´ÑšÐµ',0),(130149,3616,'vi','Nháº­p/Cáº­p Nháº­t Hoáº¡t Äá»™ng BÃ¡n hÃ ng',0),(130150,3616,'af','Invoer/Opdateer Verkoopsaksies',0),(130151,3616,'ro','IntroduceÅ£i/actualizare vanzari actiuni',0),(130152,3616,'et','MÃ¼Ã¼gi toimingute sisestamine/ajakohastamine',0),(130153,3616,'si','Vnos/posodobitev akcijah prodajnega',0),(130154,3616,'ba','Masukkan/Update tindakan penjualan',0),(130155,3616,'nl','Verkoop acties invoeren/bijwerken',0),(130156,3616,'fi','PÃ¤ivittÃ¤minen myynnin toiminnot',0),(130157,3616,'no','Angi/Oppdater salg handlinger',0),(130158,3616,'da','Indtaste/opdatere salg handlinger',0),(130159,3616,'ko','íŒë§¤ ìž‘ì—… ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(130160,3616,'he','×”×›× ×¡/×¢×“×›×Ÿ ×¤×¢×•×œ×•×ª ×ž×›×™×¨×•×ª',0),(130161,3616,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î´ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(130162,3616,'zh','è¾“å…¥/æ›´æ–°é”€å”®è¡ŒåŠ¨',0),(130163,3616,'sv','Ange/uppdatera fÃ¶rsÃ¤ljning Ã¥tgÃ¤rder',0),(130164,3616,'it','Inserisci/Aggiorna azioni commerciali',0),(130165,3616,'tl','',0),(130166,3616,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(130167,3616,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤¾à¤°à¥à¤¯à¥‹à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(130168,3616,'ms','Masukkan/Kemaskini tindakan jualan',0),(130169,3616,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(130170,3616,'fr','Inscrire/mettre Ã  jour ventes Actions',0),(130171,3616,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã?®å…¥åŠ›/æ›´æ–°',0),(130172,3616,'pt','Inserir/atualizar aÃ§Ãµes de vendas',0),(130173,3616,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(130174,3616,'es','Introducir/Actualizar Actividades de Ventas',0),(130175,3616,'de','Geben Sie/Update Verkaufsaktionen',0),(130176,3616,'en','Enter/Update Sales Actions',0),(130177,3617,'is','',0),(130178,3617,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ( ÙØ±ÙˆØ´)',0),(130179,3617,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ( ÙØ±ÙˆØ´)',0),(130180,3617,'tr','SatÄ±ÅŸ Kategoriler girin/gÃ¼ncelleme',0),(130181,3617,'pl','WprowadÅº/aktualizacja sprzedaÅ¼y kategorii',0),(130182,3617,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(130183,3617,'ur','Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û Ø¬Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(130184,3617,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑƒÐ»Ð°Ð·Ð½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(130185,3617,'vi','Nháº­p/Cáº­p Nháº­t Thá»ƒ Loáº¡i BÃ¡n HÃ ng',0),(130186,3617,'af','Invoer/Opdateer VerkoopskategoriÃ« ',0),(130187,3617,'ro','IntroduceÅ£i/actualizare vÃ¢nzÄƒri categorii',0),(130188,3617,'et','Tootekategooria sisestamine/ajakohastamine',0),(130189,3617,'si','Vnos/posodobitev prodaje kategorije',0),(130190,3617,'ba','Isi/Perbarui Kategori Penjualan',0),(130191,3617,'nl','Invoeren/bijwerken verkoopcategorie',0),(130192,3617,'fi','PÃ¤ivittÃ¤minen myynnin Luokat',0),(130193,3617,'no','Angi/Oppdater salg kategorier',0),(130194,3617,'da','Indtaste/opdatere salg kategorier',0),(130195,3617,'ko','íŒë§¤ ì¹´í…Œê³ ë¦¬ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(130196,3617,'he','×”×›× ×¡/×¢×“×›×Ÿ ×§×˜×’×•×¨×™×•×ª ×ž×›×™×¨×•×ª',0),(130197,3617,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(130198,3617,'zh','è¾“å…¥/æ›´æ–°é”€å”®ç±»åˆ«',0),(130199,3617,'sv','Ange/uppdatera fÃ¶rsÃ¤ljning kategorier',0),(130200,3617,'it','Inserisci/Aggiorna categorie di vendita',0),(130201,3617,'tl','',0),(130202,3617,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(130203,3617,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(130204,3617,'ms','Masukkan/Kemaskini kategori jualan',0),(130205,3617,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(130206,3617,'fr','Entrez/mettre Ã  jour les catÃ©gories ventes',0),(130207,3617,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®å…¥åŠ›/æ›´æ–°',0),(130208,3617,'pt','Inserir/atualizar categorias vendas',0),(130209,3617,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(130210,3617,'es','Introducir/Actualizar CategorÃ­as de Ventas',0),(130211,3617,'de','Geben Sie/Update Verkaufskategorien',0),(130212,3617,'en','Enter/Update Sales Categories',0),(130213,3618,'is','',0),(130214,3618,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ù¾Ø±Ø³Ù†Ù„ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ( ÙØ±ÙˆØ´',0),(130215,3618,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù¾Ø±Ø³Ù†Ù„ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ( ÙØ±ÙˆØ´',0),(130216,3618,'tr','SatÄ±ÅŸ personeli girin/gÃ¼ncelleme',0),(130217,3618,'pl','WprowadÅº/aktualizacja sprzedaÅ¼y personelu',0),(130218,3618,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(130219,3618,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(130220,3618,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(130221,3618,'vi','Nháº­p/Cáº­p Nháº­t NhÃ¢n ViÃªn Kinh Doanh',0),(130222,3618,'af','Invoer/Opdateer Verkoopspersoneel',0),(130223,3618,'ro','IntroduceÅ£i/actualizare personal de vÃ¢nzÄƒri',0),(130224,3618,'et','MÃ¼Ã¼gipersonalile sisestamine/ajakohastamine',0),(130225,3618,'si','Vnos/posodobitev prodajno osebje',0),(130226,3618,'ba','Masukkan/Update personil penjualan',0),(130227,3618,'nl','Invoeren/bijwerken verkooppersoneel',0),(130228,3618,'fi','PÃ¤ivittÃ¤minen myyntihenkilÃ¶stÃ¶Ã¤',0),(130229,3618,'no','Angi/Oppdater salgspersonale',0),(130230,3618,'da','Indtaste/opdatere salgspersonale',0),(130231,3618,'ko','íŒë§¤ ì§ì› ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(130232,3618,'he','×”×›× ×¡/×¢×“×›×Ÿ ×¦×•×•×ª ×ž×›×™×¨×•×ª',0),(130233,3618,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ¿Ï Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(130234,3618,'zh','è¾“å…¥/æ›´æ–°é”€å”®äººå‘˜',0),(130235,3618,'sv','Ange/uppdatera fÃ¶rsÃ¤ljningspersonal',0),(130236,3618,'it','Inserire/aggiornare il personale di vendita',0),(130237,3618,'tl','',0),(130238,3618,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(130239,3618,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤¾à¤°à¥à¤®à¤¿à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(130240,3618,'ms','Masukkan/Kemaskini kakitangan jualan',0),(130241,3618,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø£ÙØ±Ø§Ø¯ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(130242,3618,'fr','Entrez/mise Ã  jour du Personnel de vente',0),(130243,3618,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚¹ã‚¿ãƒƒãƒ•ã?®å…¥åŠ›/æ›´æ–°',0),(130244,3618,'pt','Inserir/atualizar o pessoal de vendas',0),(130245,3618,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(130246,3618,'es','Introducir/Actualizar Personal de Ventas',0),(130247,3618,'de','Geben Sie/Update Verkaufspersonal',0),(130248,3618,'en','Enter/Update Sales Personnel',0),(130249,3619,'is','',0),(130250,3619,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯ Ù„ÛŒØ¬Ø± Ø·Ø¨Ù‚ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(130251,3619,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„ Ø·Ø¨Ù‚ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(130252,3619,'tr','Girin/gÃ¼ncelleme standart GL BorÃ§lar tarafÄ±ndan kullanÄ±lan hesaplarÄ±',0),(130253,3619,'pl','WprowadÅº/aktualizacji standardowego GL konta uÅ¼ywane przez zobowiÄ…zania',0),(130254,3619,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð¾Ñ‚ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(130255,3619,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(130256,3619,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð“Ð› Ð½Ð°Ð»Ð¾Ð·Ð¸ ÐºÐ¾Ñ˜Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ðµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(130257,3619,'vi','Nháº­p/Cáº­p Nháº­t TK Sá»• CÃ¡i Tá»•ng Há»£p Chuáº©n Sá»­ Dá»¥ng Cho TK Pháº£i Tráº£',0),(130258,3619,'af','Invoer/Opdateer Standaard AG Rekeninge deur \"Payables\"',0),(130259,3619,'ro','IntroduceÅ£i/actualizare conturi GL Standard folosit de datorii',0),(130260,3619,'et','Sisestamine/ajakohastamine Standard GL kasutatavate kontode vÃµlad',0),(130261,3619,'si','Vnesite posodobitev standardni GL raÄuni uporabljajo obveznosti',0),(130262,3619,'ba','Standar masukkan Update GL account yang digunakan oleh hutang',0),(130263,3619,'nl','Invoeren/bijwerken standaard GL Accounts die worden gebruikt door schulden',0),(130264,3619,'fi','PÃ¤ivittÃ¤minen Standard GL tilit kÃ¤yttÃ¤vÃ¤t Ostovelat',0),(130265,3619,'no','Angi/Oppdater Standard GL-kontoer som brukes av gjeld',0),(130266,3619,'da','Indtaste/opdatere Standard GL konti anvendes af Kreditorstyring',0),(130267,3619,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ í‘œì¤€ GL ê³„ì • ì±„ë¬´ì—ì„œ ì‚¬ìš©',0),(130268,3619,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×—×©×‘×•× ×•×ª GL ×¨×’×™×œ×™× ×”×ž×©×ž×©×™× ×–×›××™×',0),(130269,3619,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î³/Î» Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î±Ï€ÏŒ Ï€Î¹ÏƒÏ„Ï‰Ï„Î­Ï‚',0),(130270,3619,'zh','è¾“å…¥/æ›´æ–°ç”¨ä½œåº”ä»˜æ¬¾é¡¹çš„æ ‡å‡†æ€»å¸å¸æˆ·',0),(130271,3619,'sv','Ange/uppdatera GL standardkonton anvÃ¤nds av leverantÃ¶rsskulder',0),(130272,3619,'it','Inserisci/Aggiorna conti di contabilitÃ  generale Standard utilizzato da debiti',0),(130273,3619,'tl','',0),(130274,3619,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&',0),(130275,3619,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤¸à¥‡ Payables à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(130276,3619,'ms','Masukkan/Kemaskini Standard GL akaun digunakan oleh pemiutang',0),(130277,3619,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯Ø§Ø¦Ù†Ø©/Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø§Øª',0),(130278,3619,'fr','Inscrire/mettre Ã  jour des comptes GL Standard utilisÃ© par des comptes fournisseurs',0),(130279,3619,'jp','è²·æŽ›é‡‘ã?§ä½¿ã‚?ã‚Œã?¦ã?„ã‚‹æ¨™æº–ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®å…¥åŠ›/æ›´æ–°',0),(130280,3619,'pt','Inserir/atualizar contas de GL padrÃ£o usado pelo contas a pagar',0),(130281,3619,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ, ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ GL ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(130282,3619,'es','Introducir/Actualizar Cuentas EstÃ¡ndares de Libro Mayor usadas para Proveedores',0),(130283,3619,'de','Geben Sie/Update-Standard GL-Konten von Verbindlichkeiten verwendet',0),(130284,3619,'en','Enter/Update Standard GL Accounts used by Payables',0),(130285,3620,'is','',0),(130286,3620,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯ Ù„ÛŒØ¬Ø± Ø·Ø¨Ù‚ Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(130287,3620,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¯ÙØªØ± ÙƒÙ„ Ø·Ø¨Ù‚ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(130288,3620,'tr','Girin/gÃ¼ncelleme standart GL bordro tarafÄ±ndan kullanÄ±lan hesaplarÄ±',0),(130289,3620,'pl','WprowadÅº/aktualizacji standardowego GL konta uÅ¼ywane przez listy pÅ‚ac',0),(130290,3620,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð¾Ñ‚ Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ñ‚Ð°',0),(130291,3620,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ù¾Û’ Ø±ÙˆÙ„ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(130292,3620,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð“Ð› Ð½Ð°Ð»Ð¾Ð·Ð¸ ÐºÐ¾Ñ˜Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ðµ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ',0),(130293,3620,'vi','Nháº­p/Cáº­p Nháº­t TK Sá»• CÃ¡i Tá»•ng Há»£p Chuáº©n Sá»­ Dá»¥ng Cho LÆ°Æ¡ng',0),(130294,3620,'af','Invoer/Opdateer Standaard AG Rekeninge deur Loonrol',0),(130295,3620,'ro','IntroduceÅ£i/actualizare conturi GL Standard folosit de salarizare',0),(130296,3620,'et','Sisestamine/ajakohastamine Standard GL kasutatavate kontode palga',0),(130297,3620,'si','Vnesite posodobitev standardnih GL raÄunov uporabljalo na izplaÄane plaÄe',0),(130298,3620,'ba','Standar masukkan Update GL account yang digunakan oleh penggajian',0),(130299,3620,'nl','Invoeren/bijwerken standaard GL Accounts die worden gebruikt door Payroll',0),(130300,3620,'fi','PÃ¤ivittÃ¤minen Standard GL tilit kÃ¤yttÃ¤vÃ¤t palkanlaskennan',0),(130301,3620,'no','Angi/Oppdater Standard GL-kontoer som brukes av lÃ¸nn',0),(130302,3620,'da','Indtaste/opdatere Standard GL konti anvendes af lÃ¸n',0),(130303,3620,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ í‘œì¤€ GL ê³„ì • ê¸‰ì—¬ì—ì„œ ì‚¬ìš©',0),(130304,3620,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×—×©×‘×•× ×•×ª GL ×¨×’×™×œ×™× ×”×ž×©×ž×©×™× ×ž×©×›×•×¨×•×ª',0),(130305,3620,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î³/Î» Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î±Ï€ÏŒ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(130306,3620,'zh','è¾“å…¥/æ›´æ–°ç”¨ä½œè–ªé‡‘çš„æ ‡å‡†æ€»å¸å¸æˆ·',0),(130307,3620,'sv','Ange/uppdatera GL standardkonton anvÃ¤nds av lÃ¶ne',0),(130308,3620,'it','Inserisci/Aggiorna conti di contabilitÃ  generale Standard utilizzato da Payroll',0),(130309,3620,'tl','',0),(130310,3620,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&',0),(130311,3620,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤‚à¤¬à¤§à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤¿à¤¯à¤¾',0),(130312,3620,'ms','Masukkan/Kemaskini Standard GL akaun digunakan oleh gaji',0),(130313,3620,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(130314,3620,'fr','Inscrire/mettre Ã  jour les comptes GL Standard utilisÃ© par paie',0),(130315,3620,'jp','çµ¦ä¸Žã?§ä½¿ã‚?ã‚Œã?¦ã?„ã‚‹æ¨™æº–ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®å…¥åŠ›/æ›´æ–°',0),(130316,3620,'pt','Inserir/atualizar contas de GL padrÃ£o usado pela folha de pagamento',0),(130317,3620,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ, ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ GL ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ðµ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(130318,3620,'es','Introducir/Actualizar Cuentas EstÃ¡ndares de Libro Mayor usadas por la NÃ³mina',0),(130319,3620,'de','Geben Sie/Update Standard GL verwendeten Konten von Lohn-und Gehaltsabrechnung',0),(130320,3620,'en','Enter/Update Standard GL Accounts used by Payroll',0),(130321,3621,'is','',0),(130322,3621,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯ Ø·Ø¨Ù‚ Ø¨ÛŒØ¬Ú©Ù‡Ø§ ',0),(130323,3621,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø·Ø¨Ù‚ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(130324,3621,'tr','Faturalar iÃ§in standart Ã¶deme koÅŸullarÄ±nÄ± girin/gÃ¼ncelleme',0),(130325,3621,'pl','WprowadÅº/aktualizacja warunki standardowe pÅ‚atnoÅ›ci za faktury',0),(130326,3621,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(130327,3621,'ur','Ø¯Ø§Ø®Ù„/Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø· ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ù„ÛŒÛ’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(130328,3621,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÑƒÑÐ»Ð¾Ð²Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(130329,3621,'vi','Nháº­p/Cáº­p Nháº­t Má»¥c Thanh ToÃ¡n Chuáº©n Cho HÃ³a ÄÆ¡n',0),(130330,3621,'af','Invoer/Opdateer Standaard Betalingsterme vir Fakture',0),(130331,3621,'ro','IntroduceÅ£i/Update Standard de plata pentru facturi',0),(130332,3621,'et','Sisestamine/ajakohastamine Standard maksetingimused arvete',0),(130333,3621,'si','Vnos/posodobitev standardnih plaÄilnih pogojev za raÄune',0),(130334,3621,'ba','Masukkan/Update pembayaran standar untuk faktur',0),(130335,3621,'nl','Invoeren/bijwerken standaard betalingsconditie voor facturen',0),(130336,3621,'fi','PÃ¤ivittÃ¤minen Standard maksuehdot laskujen',0),(130337,3621,'no','Angi/Oppdater Standard betalingsbetingelser for fakturaer',0),(130338,3621,'da','Indtaste/opdatere Standard betalingsbetingelser for fakturaer',0),(130339,3621,'ko','ì¸ë³´ì´ìŠ¤ì— ëŒ€ í•œ í‘œì¤€ ì§€ë¶ˆ ìš©ì–´ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(130340,3621,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×ª× ××™ ×ª×©×œ×•× ×¡×˜× ×“×¨×˜×™ ×¢×‘×•×¨ ×—×©×‘×•× ×™×•×ª',0),(130341,3621,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÏŒÏ„Ï…Ï€Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î³Î¹Î± Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(130342,3621,'zh','è¾“å…¥/æ›´æ–°å‘ç¥¨æ ‡å‡†æ”¯ä»˜æ¡æ¬¾',0),(130343,3621,'sv','Ange/uppdatera Standard betalningsvillkor fÃ¶r fakturor',0),(130344,3621,'it','Immettere o aggiornare i termini di pagamento Standard per le fatture',0),(130345,3621,'tl','',0),(130346,3621,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&',0),(130347,3621,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤®à¤¾à¤¨à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(130348,3621,'ms','Masukkan/kemas terma Standard pembayaran bagi invois',0),(130349,3621,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø´Ø±ÙˆØ· Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ù„Ù„ÙÙˆØ§ØªÙŠØ±',0),(130350,3621,'fr','Entrez/mise Ã  jour conditions de paiement Standard pour les factures',0),(130351,3621,'jp','è«‹æ±‚æ›¸ã?«ä½¿ã‚?ã‚Œã?¦ã?„ã‚‹æ¨™æº–æ”¯æ‰•æ?¡ä»¶ã?®å…¥åŠ›/æ›´æ–°',0),(130352,3621,'pt','Inserir/atualizar termos de pagamento padrÃ£o para facturas',0),(130353,3621,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ðµ Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð´Ð»Ñ Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(130354,3621,'es','Introducir/Actualizar TÃ©rminos EstÃ¡ndares de Pago para Facturas',0),(130355,3621,'de','Geben Sie/Update Standard-Zahlungskonditionen fÃ¼r Rechnungen',0),(130356,3621,'en','Enter/Update Standard Payment Terms for Invoices',0),(130357,3622,'is','',0),(130358,3622,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø´Ø±Ø§ÙŠØ· ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯ ØªÙ…Ø¯ÙŠØ¯ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨ÛŒØ¬Ú©Ù‡Ø§',0),(130359,3622,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ØªÙ…Ø¯ÙŠØ¯ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(130360,3622,'tr','FaturalarÄ±n iÃ§in satÄ±cÄ±lar tarafÄ±ndan geniÅŸletilmiÅŸ standart ÅŸartlar girin/gÃ¼ncelleme',0),(130361,3622,'pl','WprowadÅº/Aktualizuj standardowe warunki przedÅ‚uÅ¼ony przez dostawcÃ³w pÅ‚atnoÅ›ci faktur',0),(130362,3622,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸Ñ‚Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ, ÑƒÐ´ÑŠÐ»Ð¶ÐµÐ½ Ñ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸Ñ‚Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(130363,3622,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø´Ø±Ø§Ø¦Ø· Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ÙˆÛŒÙ†ÚˆØ±Ø² ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ ØªÙˆØ³ÛŒØ¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(130364,3622,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸Ñ… Ð¾Ð´Ñ€ÐµÐ´Ð±Ð¸ Ð¿Ñ€Ð¾Ð´ÑƒÐ¶ÐµÐ½ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(130365,3622,'vi','Nháº­p/Cáº­p Nháº­t CÃ¡c Khoáº£n Thanh ToÃ¡n HÃ³a ÄÆ¡n ÄÆ°á»£c NgÆ°á»i BÃ¡n Gia Háº¡n',0),(130366,3622,'af','Invoer/Opdateer van Standaardterme Verleng deur Verskaffers vir Betaling van Fakture',0),(130367,3622,'ro','IntroduceÅ£i/actualizare termenilor Standard de furnizori pentru plata facturilor',0),(130368,3622,'et','Hankijate arvete tasumise teel tÃ¼Ã¼ptingimused sisestamine/ajakohastamine',0),(130369,3622,'si','Vnos/posodobitev standardni pogoji podaljÅ¡a prodajalci za plaÄilo raÄunov',0),(130370,3622,'ba','Masukkan/Update persyaratan standar diperpanjang oleh vendor untuk pembayaran tagihan',0),(130371,3622,'nl','Invoeren/bijwerken standaardvoorwaarden uitgebreid door leveranciers voor de betaling van facturen',0),(130372,3622,'fi','PÃ¤ivittÃ¤minen vakioehdot pidentÃ¤Ã¤ toimittajien laskujen maksaminen',0),(130373,3622,'no','Angi/Oppdater standardvilkÃ¥r utvidet av leverandÃ¸rer for betaling av fakturaer',0),(130374,3622,'da','Indtaste/opdatere standardvilkÃ¥r udvidet af leverandÃ¸rer til betaling af fakturaer',0),(130375,3622,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ ì§€ë¶ˆì— ëŒ€ í•œ í™•ìž¥ í•˜ëŠ” í‘œì¤€ ì•½ê´€ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(130376,3622,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×ª× ××™× ×¡×˜× ×“×¨×˜×™×™× ×ž×•×¨×—×‘×™× ×¢×œ-×™×“×™ ×¡×¤×§×™× ×¢×‘×•×¨ ×ª×©×œ×•× ×©×œ ×—×©×‘×•× ×™×•×ª',0),(130377,3622,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï…Ï€Î¿Ï€Î¿Î¹Î·ÂµÎ­Î½Î¿Î¹ ÏŒÏÎ¿Î¹ Ï€Î¿Ï… ÎµÏ€ÎµÎºÏ„ÎµÎ¯Î½ÎµÏ„Î±Î¹ Î±Ï€ÏŒ Ï„Î¿Ï…Ï‚ Ï€Ï‰Î»Î·Ï„Î­Ï‚ Î³Î¹Î± Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î® Ï„Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(130378,3622,'zh','è¾“å…¥/æ›´æ–°ç”±ä¾›åº”å•†å‘å±•çš„ä»˜æ¬¾å‘ç¥¨æ ‡å‡†æ¡æ¬¾',0),(130379,3622,'sv','Ange/uppdatera standardvillkor som utvidgas av leverantÃ¶rer fÃ¶r betalning av fakturor',0),(130380,3622,'it','Inserisci/Aggiorna termini Standard estesi da fornitori per il pagamento delle fatture',0),(130381,3622,'tl','',0),(130382,3622,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3586;&#3657;&#3629;&#3605;&#3585;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3592;&#3634;&#3585;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3648;&#3614;&',0),(130383,3622,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°à¤¿à¤¤ à¤®à¤¾à¤¨à¤• à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(130384,3622,'ms','Masukkan/Kemaskini terma-terma Standard yang diberikan oleh vendor untuk pembayaran invois',0),(130385,3622,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø´Ø±ÙˆØ· Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ø§Ù„Ù…ÙˆØ³Ø¹Ø© Ù…Ù† Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ† Ù„Ø¯ÙØ¹ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(130386,3622,'fr','Entrez/mise Ã  jour des termes Standard Ã©tendus de fournisseurs pour le paiement des factures',0),(130387,3622,'jp','è«‹æ±‚æ›¸ã?®æ”¯æ‰•ã?„ã?®æ¥­è€…ã?«ã‚ˆã?£ã?¦å¼•ã??ä¼¸ã?°ã?•ã‚Œã?Ÿæ¨™æº–æ?¡ä»¶ã?®å…¥åŠ›/æ›´æ–°',0),(130388,3622,'pt','Inserir/atualizar termos padrÃ£o estendidos por fornecedores para o pagamento de facturas',0),(130389,3622,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹, Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÑÐµÐ¼Ñ‹Ñ… Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°Ð¼Ð¸ Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(130390,3622,'es','Introducir/Actualizar TÃ©rminos EstÃ¡ndares Extendidos por Proveedores para Pago de Facturas',0),(130391,3622,'de','Geben Sie/Update Standardbedingungen verlÃ¤ngert von Anbietern fÃ¼r die Bezahlung der Rechnungen',0),(130392,3622,'en','Enter/Update Standard Terms Extended by Vendors for Payment of Invoices',0),(130393,3623,'is','',0),(130394,3623,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬Ø¯ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(130395,3623,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬Ø¯ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(130396,3623,'tr','Vergi tablo bilgilerini girin/gÃ¼ncelleme',0),(130397,3623,'pl','WprowadÅº/aktualizacja informacji o tabeli podatku',0),(130398,3623,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(130399,3623,'ur','Ù¹ÛŒÚ©Ø³ Ø¬Ø¯ÙˆÙ„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(130400,3623,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ñ‚Ð°Ð±ÐµÐ»Ð¸ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(130401,3623,'vi','Nháº­p/Cáº­p Nháº­t ThÃ´ng Tin Báº£ng Thuáº¿',0),(130402,3623,'af','Invoer/Opdateer van Balasting Tabel Inligting',0),(130403,3623,'ro','IntroduceÅ£i/actualizare informatii de tabel taxe',0),(130404,3623,'et','Sisesta/Uuenda maksutabeli informatsiooni',0),(130405,3623,'si','Vnos/posodobitev davÄnih podatkov tabele',0),(130406,3623,'ba','Masukkan/Update informasi meja pajak',0),(130407,3623,'nl','BTW-tabelgegevens invoeren/bijwerken',0),(130408,3623,'fi','PÃ¤ivittÃ¤minen taulukon verotiedot',0),(130409,3623,'no','Angi/oppdatere tabellinformasjon',0),(130410,3623,'da','Indtast/Opdater tabel skatteoplysninger',0),(130411,3623,'ko','ì„¸ê¸ˆ í…Œì´ë¸” ì •ë³´ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(130412,3623,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×¤×¨×˜×™ ×˜×‘×œ×” ×ž×¡',0),(130413,3623,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ/ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Ï€Î¯Î½Î±ÎºÎ±',0),(130414,3623,'zh','è¾“å…¥/æ›´æ–°ç¨ŽçŽ‡è¡¨ä¿¡æ¯\r\n',0),(130415,3623,'sv','Ange/Uppdatera skatteinformation tabell',0),(130416,3623,'it','Inserisci/Aggiorna informazioni tabella fiscale',0),(130417,3623,'tl','',0),(130418,3623,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3605;&#3634;&#3619;&#3634;&#3591;&#3616;&#3634;&#3625;&#3637;',0),(130419,3623,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(130420,3623,'ms','Masukkan/Kemaskini Maklumat Jadual cukai',0),(130421,3623,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(130422,3623,'fr','Entrez/mise Ã  jour des informations fiscales de la Table',0),(130423,3623,'jp','ç¨Žé¡?è¡¨æƒ…å ±ã?®å…¥åŠ›/æ›´æ–°',0),(130424,3623,'pt','Inserir/atualizar informaÃ§Ãµes da tabela de impostos',0),(130425,3623,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹ ÐÐ°Ð»Ð¾Ð³Ð¾Ð²',0),(130426,3623,'es','Introducir/Actualizar InformaciÃ³n de Tabla de Impuestos',0),(130427,3623,'de','Geben Sie/Update Tabelle Steuerinformationen',0),(130428,3623,'en','Enter/Update Tax Table Information',0),(130429,3624,'is','',0),(130430,3624,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¬Ø¯ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ',0),(130431,3624,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø¯ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ',0),(130432,3624,'tr','Vergi tablo yeni/DÃ¼zenle',0),(130433,3624,'pl','Nowy/Edytuj tabelÄ™ podatku',0),(130434,3624,'bg','ÐÐ¾Ð²Ð¸/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð°Ð½ÑŠÐº Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(130435,3624,'ur','Ù†Ø¦ÛŒ/ØªØ±Ù…ÛŒÙ… Ù¹ÛŒÚ©Ø³ Ø¬Ø¯ÙˆÙ„',0),(130436,3624,'sr','ÐÐ¾Ð²Ð¸ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° ÑÑ‚Ð¾Ð»Ñƒ',0),(130437,3624,'vi','ThÃªm/Cáº­p Nháº­t Báº£ng Thuáº¿',0),(130438,3624,'af','Belastingtabel Byvoeg/Opdateer',0),(130439,3624,'ro','Tabelul de taxe noi/editare',0),(130440,3624,'et','Lisa/Uuenda maksutabeleid',0),(130441,3624,'si','Novo/Uredi tabelo davka',0),(130442,3624,'ba','Baru/Edit pajak tabel',0),(130443,3624,'nl','BTW-tabel van nieuwe/bewerken',0),(130444,3624,'fi','Uusi tai Muokkaa veroasteikon taulukossa',0),(130445,3624,'no','Ny/Rediger Tax-tabellen',0),(130446,3624,'da','Nyt/Rediger skat tabel',0),(130447,3624,'ko','ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘ ì„¸ê¸ˆ í…Œì´ë¸”',0),(130448,3624,'he','×”×•×¡×£/×¢×“×›×Ÿ ×˜×‘×œ×ª ×ž×¡',0),(130449,3624,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î¯Î½Î±ÎºÎ± Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½',0),(130450,3624,'zh','ç¨ŽçŽ‡è¡¨æ–°å¢ž/æ›´æ–°',0),(130451,3624,'sv','Ny/redigera skattetabell',0),(130452,3624,'it','Tabella delle imposte nuovo/modifica',0),(130453,3624,'tl','',0),(130454,3624,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3605;&#3634;&#3619;&#3634;&#3591;&#3616;&#3634;&#3625;&#3637;',0),(130455,3624,'hi','à¤¨à¤ˆ/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤° à¤Ÿà¥‡à¤¬à¤²',0),(130456,3624,'ms','Jadual cukai baru/Edit',0),(130457,3624,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(130458,3624,'fr','Table dâ€™impÃ´t nouveau/modifier',0),(130459,3624,'jp','ç¨Žè¡¨è¿½åŠ /æ›´æ–°',0),(130460,3624,'pt','Tabela de imposto novo/editar',0),(130461,3624,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹ ÐÐ°Ð»Ð¾Ð³Ð¾Ð²',0),(130462,3624,'es','Introducir/Actualizar Tabla de Impuestos',0),(130463,3624,'de','Steuertabelle neu/bearbeiten',0),(130464,3624,'en','New/Edit Tax Table',0),(130465,3625,'is','',0),(130466,3625,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù…Ø§Ù„ÙŠØ§ØªÙ‡Ø§ â€“ ÙƒØ³ÙˆØ±Ø§Øª â€“ Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù…Ø³ØªÙ…Ø±ÙŠ  Ùˆ ØºÙŠØ±Ù‡  ÙƒÙ‡ Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡ Ø¨Ø±Ù¾Ø§ÙŠÙ‡ Ø¢Ù† Ù‚Ø±Ø§Ø± Ú¯Ø±ÙØªÙ‡ Ø§Ø³Øª ',0),(130467,3625,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§ØªÙ‡Ø§ â€“ ÙƒØ³ÙˆØ±Ø§Øª â€“ Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù…Ø³ØªÙ…Ø±ÙŠ  Ùˆ ØºÙŠØ±Ù‡  ÙƒÙ‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø±Ù¾Ø§ÙŠÙ‡ Ø¢Ù† Ù‚Ø±Ø§Ø± Ú¯Ø±ÙØªÙ‡ Ø§Ø³Øª ',0),(130468,3625,'tr','Vergi - indirimleri - emeklilik planlarÄ± girin/gÃ¼ncelleme - vb hangi bordro Ã¼zerinde temel alÄ±r.',0),(130469,3625,'pl','WprowadÅº/aktualizacja podatki - odliczenia - Pension Plans - opiera siÄ™ itp, na ktÃ³rych listy pÅ‚ac.',0),(130470,3625,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸ - Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ñ - Ð¿ÐµÐ½ÑÐ¸Ð¾Ð½Ð½Ð¸ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ - Ð¸ Ñ‚.Ð½. Ð² ÐºÐ¾ÑÑ‚Ð¾ Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸ ÑÐµ Ð¾ÑÐ½Ð¾Ð²Ð°Ð²Ð°.',0),(130471,3625,'ur','Ø¯Ø§Ø®Ù„/Ù¹ÛŒÚ©Ø³ - Ú©Ù¹ÙˆØªÛŒ - Ù¾Ù†Ø´Ù† Ú©Ø§ Ù…Ù†ØµÙˆØ¨Û Ø§Ù¾ ÚˆÛŒÙ¹ - ÙˆØºÛŒØ±Û Ø¬Ø³ Ù¾Û’ Ø±ÙˆÙ„ Ù¾Ø± Ù…Ø¨Ù†ÛŒ ÛÛ’ Û”',0),(130472,3625,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾Ñ€ÐµÐ·Ðµ - Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ - Ð¿ÐµÐ½Ð·Ð¸Ñ˜ÑÐºÐ¸ Ð¿Ð»Ð°Ð½Ð¾Ð²Ð¸ - Ð·Ð°ÑÐ½Ð¸Ð²Ð° ÑÐµ ÑÐ». Ð½Ð° ÐºÐ¾Ñ˜ÐµÐ¼ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ.',0),(130473,3625,'vi','Nháº­p/Cáº­p Nháº­t Thuáº¿ - Giáº£m Trá»« - Káº¿ Hoáº¡ch HÆ°u TrÃ­ - vv Ä‘á»ƒ tÃ­nh lÆ°Æ¡ng',0),(130474,3625,'af','Invoer/Opdateer Belastings - Aftrekkings - Pensioenplanne - Ens. Waarop die Loonrol Gebasseer is.',0),(130475,3625,'ro','IntroduceÅ£i/actualizaÅ£i taxele - deduceri - planuri de pensii - Etc. pe salarii care se bazeazÄƒ.',0),(130476,3625,'et','Sisestamine/ajakohastamine maksud - mahaarvamised - Pension plaanid - mis palgal jne vastavalt.',0),(130477,3625,'si','Vnos/posodobitev davkov - odbitkov - pokojninski naÄrti - itd na izplaÄane plaÄe ki temelji.',0),(130478,3625,'ba','Masukkan/Update pajak - pemotongan - Pension rencana - dll pada gaji yang didasarkan.',0),(130479,3625,'nl','Invoeren/bijwerken belastingen - inhoudingen - pensioen plannen - Etc. op die loonlijst is gebaseerd.',0),(130480,3625,'fi','PÃ¤ivittÃ¤minen veroja - vÃ¤hennykset - Pension suunnitelmat - jne joka palkkalistoilla perustuu.',0),(130481,3625,'no','Angi/Oppdater skatter - fradrag - pensjonsplaner - Etc. pÃ¥ som lÃ¸nn er basert.',0),(130482,3625,'da','Indtaste/opdatere skatter - fradrag - Pension planer - osv pÃ¥ som lÃ¸nningslisten er baseret.',0),(130483,3625,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ ì„¸ê¸ˆ-ê³µì œ-ì—°ê¸ˆ ê³„íš-ëŠ” ê¸‰ì—¬ ë“± ê¸°ë°˜ìœ¼ë¡œ.',0),(130484,3625,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×ž×™×¡×™× - × ×™×›×•×™×™× - ×ª×•×›× ×™×•×ª ×¤× ×¡×™×” - ×•×›×• ×ž×©×›×•×¨×ª ××©×¨ ×ž×‘×•×¡×¡×ª.',0),(130485,3625,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï†ÏŒÏÎ¿Î¹ - ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ - ÏƒÏÎ½Ï„Î±Î¾Î· - ÎºÎ»Ï€ ÏƒÎµ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… Î²Î±ÏƒÎ¯Î¶ÎµÏ„Î±Î¹.',0),(130486,3625,'zh','è¾“å…¥/æ›´æ–°ç¨Ž- æ‰£é™¤é¢- é€€ä¼‘é‡‘è®¡åˆ’ -ç­‰è–ªé‡‘ä»¥æ­¤ä¸ºåŸºç¡€',0),(130487,3625,'sv','Ange/uppdatera skatter - avdrag - Pension planer - Etc. pÃ¥ som lÃ¶nelistan Ã¤r baserad.',0),(130488,3625,'it','Inserisci/Aggiorna imposte - deduzioni - piani pensionistici - ecc sul libro paga che si basa.',0),(130489,3625,'tl','',0),(130490,3625,'th','Enter/Update Taxes - Deductions - Pension Plans - Etc. on Which Payroll is Based.',0),(130491,3625,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤•à¤° - à¤•à¤Ÿà¥Œà¤¤à¥€ - à¤ªà¥‡à¤‚à¤¶à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ - à¤†à¤¦à¤¿ à¤œà¥‹ à¤ªà¥‡à¤°à¥‹à¤² à¤ªà¤° à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤¹à¥ˆà¥¤',0),(130492,3625,'ms','Masukkan/Kemaskini cukai - potongan - pelan pencen - dll pada gaji yang disediakan.',0),(130493,3625,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨-Ø§Ù„Ø§Ø³ØªÙ‚Ø·Ø§Ø¹Ø§Øª-\"Ø®Ø·Ø· Ø§Ù„Ù…Ø¹Ø§Ø´Ø§Øª Ø§Ù„ØªÙ‚Ø§Ø¹Ø¯ÙŠØ©\"--Ø¥Ù„Ø® ÙÙŠ \"Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø§Ù„Ø°ÙŠ\" ÙŠØ³ØªÙ†Ø¯.',0),(130494,3625,'fr','Entrez/mise Ã  jour Taxes - dÃ©ductions - rÃ©gimes de retraite - etc sur qui paie est fondÃ©e.',0),(130495,3625,'jp','äººä»¶è²»ã?«ã?‹ã?‹ã‚?ã‚‹ç¨Žé‡‘ã€?æŽ§é™¤ã€?å¹´é‡‘ã?®å…¥åŠ›/æ›´æ–°',0),(130496,3625,'pt','Inserir/atualizar impostos - deduÃ§Ãµes - PrevidÃªncia - etc. em que folha de pagamento Ã© baseado.',0),(130497,3625,'ru','Ð’Ð²Ð¾Ð´/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² - Ð¾Ñ‚Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ð¹ - Ð¿ÐµÐ½ÑÐ¸Ð¾Ð½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ð½Ñ‹ - Ñ‚. Ð´. Ð½Ð° ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ñ… Ð¾ÑÐ½Ð¾Ð²Ñ‹Ð²Ð°ÐµÑ‚ÑÑ.',0),(130498,3625,'es','Introducir/Actualizar  Impuestos - Deducciones - Planes de Pensiones - Etc. en que se base la NÃ³mina',0),(130499,3625,'de','Geben Sie/Update Steuern - AbzÃ¼ge - Vorsorge - Etc. auf die Gehaltsliste basiert.',0),(130500,3625,'en','Enter/Update Taxes - Deductions - Pension Plans - Etc. on Which Payroll is Based.',0),(130501,3626,'is','',0),(130502,3626,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù„ÙŠØ³Øª ÛŒÙˆØ²Ø± Ùˆ ØªØ¹ÙŠÙŠÙ†  Ù…Ø¹Ø§Ø´ Ø¯Ø³ØªØ±Ø³ÙŠ',0),(130503,3626,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª ÙƒØ§Ø±Ø¨Ø± Ùˆ ØªØ¹ÙŠÙŠÙ†  Ø­Ù‚ÙˆÙ‚ Ø¯Ø³ØªØ±Ø³ÙŠ',0),(130504,3626,'tr','KullanÄ±cÄ± listesini girin/gÃ¼ncelleÅŸtir ve eriÅŸim haklarÄ± atama',0),(130505,3626,'pl','WprowadÅº/Aktualizacja listy uÅ¼ytkownika i przypisz uprawnienia dostÄ™pu',0),(130506,3626,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð¸ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð½Ð° Ð¿Ñ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ',0),(130507,3626,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº ØµØ§Ø±Ù ÙÛØ±Ø³Øª Ø§ÙˆØ± ØªÙÙˆÛŒØ¶ Ú©Û’ Ø­Ù‚ÙˆÙ‚ Ø±Ø³Ø§Ø¦ÛŒ',0),(130508,3626,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð»Ð¸ÑÑ‚Ñƒ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¸ Ð´Ð¾Ð´ÐµÑ™Ð¸Ð²Ð°ÑšÐµ Ð¿Ñ€Ð°Ð²Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð°',0),(130509,3626,'vi','Nháº­p/Cáº­p Nháº­t Danh SÃ¡ch NgÆ°á»i Sá»­ Dá»¥ng & Báº£ng Chá»‰ Äá»‹nh PhÃ¢n Quyá»n Truy Cáº­p',0),(130510,3626,'af','Invoer/Opdateer Gebruikerlys en staan Toegangsregte toe',0),(130511,3626,'ro','IntroduceÅ£i/actualizeazÄƒ lista de utilizator ÅŸi atribui drepturile de acces',0),(130512,3626,'et','Sisestamine/ajakohastamine kasutajate nimekiri ning mÃ¤Ã¤rata pÃ¤Ã¤suÃµigused',0),(130513,3626,'si','Vnesite posodobitev uporabnikov seznam in dodelite pravice dostopa',0),(130514,3626,'ba','Daftar pengguna memasukkan Update dan menetapkan hak akses',0),(130515,3626,'nl','Invoeren/bijwerken gebruikerslijst en toegangsrechten toewijzen',0),(130516,3626,'fi','PÃ¤ivittÃ¤minen KÃ¤yttÃ¤jÃ¤luettelo ja mÃ¤Ã¤ritÃ¤ kÃ¤yttÃ¶oikeudet',0),(130517,3626,'no','Angi/Oppdater brukerlisten og tilordne tilgangsrettigheter',0),(130518,3626,'da','Indtast/Update brugerliste, og Tildel adgangsrettigheder',0),(130519,3626,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ ì‚¬ìš©ìž ëª©ë¡ ë° í• ë‹¹ ì•¡ì„¸ìŠ¤ ê¶Œí•œ',0),(130520,3626,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×”×ž×©×ª×ž×© ×¨×©×™×ž×”, ×”×§×¦××ª ×”×¨×©××•×ª ×’×™×©×”',0),(130521,3626,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï‡ÏÎ®ÏƒÏ„Î· Î»Î¯ÏƒÏ„Î± ÎºÎ±Î¹ ÎµÎºÏ‡Ï‰ÏÎ®ÏƒÏ„Îµ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(130522,3626,'zh','è¾“å…¥/æ›´æ–°ç”¨æˆ·æ¸…å•åŠåˆ†é…è®¿é—®æƒé™',0),(130523,3626,'sv','Ange/uppdatera listan Ã¶ver anvÃ¤ndare och tilldelar Ã¥tkomstbehÃ¶righet',0),(130524,3626,'it','Inserisci/Aggiorna elenco di utenti e assegnare i diritti di accesso',0),(130525,3626,'tl','',0),(130526,3626,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3649;&#3621;&#3632;&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;&#3648;&',0),(130527,3626,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¥‚à¤šà¥€ à¤”à¤° à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚ à¤ªà¤¹à¥à¤à¤š à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(130528,3626,'ms','Masukkan/Kemaskini senarai pengguna dan berikan hak capaian',0),(130529,3626,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† ÙˆØªØ¹ÙŠÙŠÙ† Ø­Ù‚ÙˆÙ‚ Ø§Ù„ÙˆØµÙˆÙ„',0),(130530,3626,'fr','Inscrire/mettre Ã  jour liste dâ€™utilisateurs et attribuer des droits dâ€™accÃ¨s',0),(130531,3626,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ãƒªã‚¹ãƒˆã?®å…¥åŠ›/æ›´æ–°ã‚’ã?—ã?¦ã‚¢ã‚¯ã‚»ã‚¹æ¨©åˆ©ã‚’å‰²ã‚Šå½“ã?¦ã‚‹',0),(130532,3626,'pt','Inserir/atualizar lista de usuÃ¡rio e atribuir direitos de acesso',0),(130533,3626,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ Ð¸ Ð½Ð°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð°Ð²Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°',0),(130534,3626,'es','Introducir/Actualizar lista de Usuarios y Asignar Derechos de Acceso',0),(130535,3626,'de','Geben Sie/Update-Benutzerliste und Zugriffsrechte zuweisen',0),(130536,3626,'en','Enter/Update User List and Assign Access Rights',0),(130537,3627,'is','',0),(130538,3627,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(130539,3627,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0);
INSERT INTO `langdef` VALUES (130540,3627,'tr','SatÄ±cÄ± veri girin/gÃ¼ncelleme',0),(130541,3627,'pl','WprowadÅº/aktualizacja danych dostawcy',0),(130542,3627,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(130543,3627,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÙˆØ§Ø¦Ù Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(130544,3627,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(130545,3627,'vi','Nháº­p/Cáº­p Nháº­t Dá»¯ Liá»‡u Cá»§a NgÆ°á»i BÃ¡n',0),(130546,3627,'af','Invoer/Opdateer Verskaffer Data',0),(130547,3627,'ro','IntroduceÅ£i/actualizare date furnizor',0),(130548,3627,'et','Sisesta/uuenda tarnija andmeid',0),(130549,3627,'si','Vnos/posodobitev podatkov dobavitelja',0),(130550,3627,'ba','Masukkan/Update Vendor Data',0),(130551,3627,'nl','Leverancier gegevens invoeren/bijwerken',0),(130552,3627,'fi','SyÃ¶tÃ¤ tai PÃ¤ivitÃ¤ toimittajan tiedot',0),(130553,3627,'no','Angi/Oppdater leverandÃ¸rdata',0),(130554,3627,'da','Indtaste/opdatere kreditordata',0),(130555,3627,'ko','ê³µê¸‰ ì—…ì²´ ë°ì´í„° ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(130556,3627,'he','×”×›× ×¡/×¢×“×›×Ÿ × ×ª×•× ×™ ×¡×¤×§',0),(130557,3627,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(130558,3627,'zh','è¾“å…¥/æ›´æ–°ä¾›åº”å•†çš„æ•°æ®',0),(130559,3627,'sv','Ange/uppdatera leverantÃ¶rsdata',0),(130560,3627,'it','Inserisci/Aggiorna dati fornitore',0),(130561,3627,'tl','',0),(130562,3627,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3640;&#3657;&#3586;&#3634;&#3618;',0),(130563,3627,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(130564,3627,'ms','Masukkan/kemas kini Data Penjual',0),(130565,3627,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø¨ÙŠØ§Ù†Ø§Øª Ù…ÙˆØ±Ù‘Ø¯',0),(130566,3627,'fr','Entrez/mettre Ã  jour les donnÃ©es du vendeur',0),(130567,3627,'jp','æ¥­è€…ãƒ‡ãƒ¼ã‚¿ã?®å…¥åŠ›/æ›´æ–°',0),(130568,3627,'pt','Inserir/atualizar dados de fornecedor',0),(130569,3627,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ðµ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(130570,3627,'es','Introducir/Actualizar  Datos de Proveedor',0),(130571,3627,'de','Lieferantendaten eingeben/Update',0),(130572,3627,'en','Enter/Update Vendor Data',0),(130573,3628,'is','',0),(130574,3628,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ â€“ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù„ÛŒØ¬Ø± Ø¨Ø±Ø§ÙŠ Ø§Ø±ØªØ¨Ø§Ø· Ø¯Ø§Ø¯Ù†',0),(130575,3628,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ â€“ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø§Ø±ØªØ¨Ø§Ø· Ø¯Ø§Ø¯Ù†',0),(130576,3628,'tr','Girin/satÄ±cÄ± ÅŸartlarÄ± - Ã§ek hesabÄ± bilgileri - GL hesaplarÄ± ins iÃ§in gÃ¼ncelleme.',0),(130577,3628,'pl','WprowadÅº/aktualizacja kont dostawcÃ³w warunki - konto czekowe Info - GL dla Tie-Ins.',0),(130578,3628,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ - Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ - GL Ð·Ð° ÐºÐ»Ð¸Ð¿Ð¾Ð²Ðµ.',0),(130579,3628,'ur','Ø¯Ø§Ø®Ù„/ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø· - Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª - Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Tie-Ins Ú©Û’ Ù„ÛŒÛ’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº Û”',0),(130580,3628,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑƒÑÐ»Ð¾Ð²Ð¸ - Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð˜Ð½Ñ„Ð¾ - Ð“Ð› Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° Ð¿Ñ€Ð°Ð²Ð° Ð½Ð° Ð¼Ð°Ñ˜Ð¸Ñ†Ðµ.',0),(130581,3628,'vi','Nháº­p/Cáº­p Nháº­t Äiá»u Khoáº£n NgÆ°á»i BÃ¡n - ThÃ´ng Tin TK Kiá»ƒm Tra - TK Sá»• CÃ¡i Tá»•ng Há»£p Cho CÃ¢n Äá»‘i',0),(130582,3628,'af','Invoer/Opdateer - Tjekrekening Inligting - AG Rekeninge vir \"Tie-Ins\"',0),(130583,3628,'ro','IntroduceÅ£i/actualizare furnizor termeni - Info cont de verificare - GL conturi pentru cravatÄƒ-inuri.',0),(130584,3628,'et','Sisestamine/ajakohastamine hankija tingimused - pangakonto Info - GL moodustab Tie-Ins.',0),(130585,3628,'si','Vnos/posodobitev konte dobaviteljev pogoji - tekoÄi raÄun Info - GL za Tie-Ins.',0),(130586,3628,'ba','Masukkan/Update Vendor persyaratan - rekening giro Info - GL account untuk Tie-Ins.',0),(130587,3628,'nl','Invoeren/bijwerken leveranciersrekeningen voorwaarden - betaalrekening Info - GL voor Tie-Ins.',0),(130588,3628,'fi','Kirjoita/pÃ¤ivitys ehdot - sekkitilin Info - GL toimittajatilien Tie-Ins.',0),(130589,3628,'no','Angi/oppdatere vilkÃ¥rene - brukskonto Info - GL leverandÃ¸rkontoer for Tie-Ins.',0),(130590,3628,'da','Indtaste/opdatere vilkÃ¥r - checkkonto Info - GL kreditorkonti for Tie-Ins.',0),(130591,3628,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ ê³µê¸‰ ì—…ì²´ ì•½ê´€-ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ ì •ë³´-GL ê³„ì • ë„¥íƒ€ì´ ëŒ€ í•œ.',0),(130592,3628,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×ª× ××™ ×”×¡×¤×§ - ×¤×¨×˜×™ ×—×©×‘×•×Ÿ ×‘× ×§ - GL ×—×©×‘×•× ×•×ª ×¢×‘×•×¨ Tie-Ins.',0),(130593,3628,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏŒÏÎ¿Ï…Ï‚ - Ï„ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ - Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î³/Î» Î³Î¹Î± Tie-Ins.',0),(130594,3628,'zh','è¾“å…¥/æ›´æ–°ä¾›åº”å•†æ¡æ¬¾ -æ”¯ç¥¨å¸æˆ·ä¿¡æ¯ -æ­å”®æ€»å¸å¸æˆ·ã€‚',0),(130595,3628,'sv','Ange/uppdatera villkor - checkkonto Info - GL leverantÃ¶rskonton fÃ¶r Tie-Ins.',0),(130596,3628,'it','Inserisci/Aggiorna fornitore termini - Info conto corrente - conti di contabilitÃ  generale per tie-in.',0),(130597,3628,'tl','',0),(130598,3628,'th','Enter/Update Vendor Terms - Checking Account Info - GL Accounts for Tie-Ins.',0),(130599,3628,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤°à¥à¤¤à¥‹à¤‚ - à¤šà¥‡à¤•à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ - GL à¤–à¤¾à¤¤à¥‡ à¤Ÿà¤¾à¤ˆ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨à¥¤',0),(130600,3628,'ms','Masukkan/kemas kini akaun GL terma - memeriksa akaun Info - penjual bagi Tie-Ins.',0),(130601,3628,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…ÙˆØ±Ø¯ Ù…ØµØ·Ù„Ø­Ø§Øª-Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø­Ø³Ø§Ø¨-GL Ù„ØªÙ„Ø§Ø²Ù….',0),(130602,3628,'fr','Entrez/mise Ã  jour de comptes GL de termes - compte-chÃ¨ques Info - fournisseur pour tie-ins.',0),(130603,3628,'jp','æ¥­è€…æ?¡ä»¶ãƒ¼å½“åº§é ?é‡‘æƒ…å ±ãƒ¼é–¢é€£ã?®ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å…¥åŠ›/æ›´æ–°',0),(130604,3628,'pt','Inserir/atualizar contas de GL termos - informaÃ§Ã£o de conta corrente - fornecedor para tie-ins.',0),(130605,3628,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð¾Ð² - Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ Info - GL Ð´Ð»Ñ Ð²Ñ€ÐµÐ·ÐºÐ¸.',0),(130606,3628,'es','Introducir/Actualizar TÃ©rminos de Proveedor - Info de Cuenta de Cheques - Cuentas de LM para Enlaces',0),(130607,3628,'de','Begriffe - Girokonto Info - GL Kreditorenkonten fÃ¼r Tie-Ins eingeben/Update.',0),(130608,3628,'en','Enter/Update Vendor Terms - Checking Account Info - GL Accounts for Tie-Ins.',0),(130609,3629,'is','',0),(130610,3629,'dr','Ø«Ø¨Øª Ù…Ù†Ø§Ø·Ù‚ ÙƒØ§Ø±ÙŠ',0),(130611,3629,'pr','Ø«Ø¨Øª Ù…Ù†Ø§Ø·Ù‚ ÙƒØ§Ø±ÙŠ',0),(130612,3629,'tr','Ã‡alÄ±ÅŸma alanlarÄ±',0),(130613,3629,'pl','Obszary pracy',0),(130614,3629,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(130615,3629,'ur','Ú©Ø§Ù… Ø¹Ù„Ø§Ù‚ÙˆÚº',0),(130616,3629,'sr','ÐžÐ±Ð»Ð°ÑÑ‚Ð¸ Ñ€Ð°Ð´Ð°',0),(130617,3629,'vi','Khu vá»±c cÃ´ng viá»‡c',0),(130618,3629,'af','Werk Areas',0),(130619,3629,'ro','Zone de lucru',0),(130620,3629,'et','TÃ¶Ã¶valdkonnas',0),(130621,3629,'si','Delovna podroÄja',0),(130622,3629,'ba','Area kerja',0),(130623,3629,'nl','Werkgebieden',0),(130624,3629,'fi','TyÃ¶tilat',0),(130625,3629,'no','ArbeidsomrÃ¥der',0),(130626,3629,'da','ArbejdsomrÃ¥der',0),(130627,3629,'ko','ìž‘ì—… ì˜ì—­',0),(130628,3629,'he','×©×˜×—×™ ×¢×‘×•×“×”',0),(130629,3629,'el','Î ÎµÏÎ¹Î¿Ï‡Î­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(130630,3629,'zh','å·¥ä½œé¢†åŸŸ',0),(130631,3629,'sv','ArbetsomrÃ¥den',0),(130632,3629,'it','Aree di lavoro',0),(130633,3629,'tl','',0),(130634,3629,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(130635,3629,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤°à¥‹à¤‚',0),(130636,3629,'ms','Bekerja yang',0),(130637,3629,'ar','Ù…Ø¬Ø§Ù„Ø§Øª Ø§Ù„Ø¹Ù…Ù„',0),(130638,3629,'fr','Domaines d\'activitÃ©',0),(130639,3629,'jp','å‹¤å‹™åœ°åŸŸ',0),(130640,3629,'pt','Ãreas de trabalho',0),(130641,3629,'ru','ÐžÐ±Ð»Ð°ÑÑ‚Ð¸ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(130642,3629,'es','Ãreas de Trabajo',0),(130643,3629,'de','Arbeitsbereiche',0),(130644,3629,'en','Work Areas',0),(130645,3630,'is','',0),(130646,3630,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø¬Ù†Ø³Ù‡Ø§ÙŠ Ø®Ø§Øµ ',0),(130647,3630,'pr','Ø«Ø¨Øª  / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø®Ø§Øµ ',0),(130648,3630,'tr','SatÄ±cÄ± bilgileri belirli maddeler iÃ§in giriÅŸ/gÃ¼ncelleme',0),(130649,3630,'pl','Wpis/aktualizacja informacji o dostawcy dla okreÅ›lonych elementÃ³w',0),(130650,3630,'bg','Ð’Ð»Ð¸Ð·Ð°Ð½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð·Ð° ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(130651,3630,'ur','ÙˆÛŒÙ†ÚˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø®ØµÙˆØµ Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ù„Ø¦Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(130652,3630,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ñƒ Ð·Ð° Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ',0),(130653,3630,'vi','Nháº­p/Cáº­p Nháº­t ThÃ´ng Tin NgÆ°á»i BÃ¡n Cho 1 Máº·t HÃ ng Cá»¥ Thá»ƒ',0),(130654,3630,'af','Inskrywing/Opdateer van Verskaffer Inligting vir Spesifieke Items',0),(130655,3630,'ro','Intrare/actualizarea informaÅ£iilor furnizor pentru elemente specifice',0),(130656,3630,'et','Kanne vÃµi uuendada hankija teabe konkreetsete',0),(130657,3630,'si','Vnos/posodobitev dobavitelj informacij za posebne elemente',0),(130658,3630,'ba','Catatan/Update Informasi Vendor untuk item tertentu',0),(130659,3630,'nl','Post/Update van leveranciersgegevens voor bepaalde artikelen',0),(130660,3630,'fi','Tapahtuma/PÃ¤ivitÃ¤ toimittajatiedot tietyille nimikkeille',0),(130661,3630,'no','OppfÃ¸ring/oppdatering av leverandÃ¸rinformasjon for bestemte varer',0),(130662,3630,'da','Post/opdatering af leverandÃ¸roplysninger for bestemte varer',0),(130663,3630,'ko','íŠ¹ì • í•­ëª©ì— ëŒ€ í•œ ê³µê¸‰ ì—…ì²´ ì •ë³´ ë“±ë¡/ì—…ë°ì´íŠ¸',0),(130664,3630,'he','×›× ×™×¡×”/×¢×“×›×•×Ÿ ×¤×¨×˜×™ ×”×¡×¤×§ ×¢×‘×•×¨ ×¤×¨×™×˜×™× ×¡×¤×¦×™×¤×™×™×',0),(130665,3630,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ Î³Î¹Î± ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î± ÎµÎ¯Î´Î·',0),(130666,3630,'zh','è¾“å…¥/æ›´æ–°ç‰¹å®šç‰©å“ä¾›åº”å•†ä¿¡æ¯',0),(130667,3630,'sv','IntrÃ¤de/uppdatering av leverantÃ¶rsinformation fÃ¶r specifika artiklar',0),(130668,3630,'it','Voce o aggiornamento delle informazioni sul fornitore per elementi specifici',0),(130669,3630,'tl','',0),(130670,3630,'th','&#3648;&#3586;&#3657;&#3634;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3612;&#3621;&#3636;&#3605;&#3648;&#3593;&#3614;&#3634;&#3632;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(130671,3630,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤†à¤‡à¤Ÿà¤®à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(130672,3630,'ms','Kemasukan/Kemaskini Maklumat pembekal untuk barang-barang tertentu',0),(130673,3630,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ±Ø¯ Ù„Ø¨Ù†ÙˆØ¯ Ù…Ø­Ø¯Ø¯Ø©',0),(130674,3630,'fr','Saisie/mise Ã  jour des informations sur le fournisseur pour des Ã©lÃ©ments spÃ©cifiques',0),(130675,3630,'jp','ç‰¹å®šå“?ç›®ã?®ç´?å…¥æ¥­è€…æƒ…å ±å…¥åŠ›/æ›´æ–°',0),(130676,3630,'pt','Entrada/atualizaÃ§Ã£o de informaÃ§Ãµes do fornecedor para itens especÃ­ficos',0),(130677,3630,'ru','Ð’Ñ…Ð¾Ð´/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð´Ð»Ñ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ñ‹Ñ… ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(130678,3630,'es','Introducir/Actualizar InformaciÃ³n de Proveedor para Items EspecÃ­ficos',0),(130679,3630,'de','Eintrag/Update von Herstellerinformationen fÃ¼r bestimmte Elemente',0),(130680,3630,'en','Entry/Update of Vendor Information for Specific Items',0),(130681,3631,'is','',0),(130682,3631,'dr','Ø§Ø±Ø³Ø§Ù„ Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(130683,3631,'pr','Ø§Ø±Ø³Ø§Ù„ Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(130684,3631,'tr','Genel muhasebe hesaplarÄ±nÄ±n listesini verme',0),(130685,3631,'pl','Eksportowanie listy kont ksiÄ™gowych ogÃ³lne',0),(130686,3631,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¾Ð±Ñ‰Ð¸ ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´Ð½Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(130687,3631,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ ÙÛØ±Ø³Øª Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(130688,3631,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð»Ð¸ÑÑ‚Ðµ ÐºÐ¾Ð½Ñ‚Ð° ÐºÑšÐ¸Ð³Ðµ Ð³ÐµÐ½ÐµÑ€Ð°Ð»Ð°',0),(130689,3631,'vi','Káº¿t Xuáº¥t Danh SÃ¡ch TK Trong Sá»• CÃ¡i Tá»•ng Há»£p',0),(130690,3631,'af','Uitvoer van Algemene Grootboek Rekeninge Lys',0),(130691,3631,'ro','Export listÄƒ General Ledger conturi',0),(130692,3631,'et','Ekspordi Ã¼ldine pearaamatu kontode nimekiri',0),(130693,3631,'si','Izvozite seznam sploÅ¡ne konte glavne knjige',0),(130694,3631,'ba','Ekspor daftar General Ledger account',0),(130695,3631,'nl','Generaal grootboekrekeningen lijst exporteren',0),(130696,3631,'fi','Vieminen yleiset kirjanpitotilit',0),(130697,3631,'no','Eksporter General Ledger kontoer-listen',0),(130698,3631,'da','Eksportere General Ledger regnskaber liste',0),(130699,3631,'ko','ì¼ë°˜ ë ˆì € ê³„ì • ëª©ë¡ ë‚´ë³´ë‚´ê¸°',0),(130700,3631,'he','×™×™×¦×•× ×¨×©×™×ž×ª ×—×©×‘×•× ×•×ª ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™',0),(130701,3631,'el','Î•Î¾Î±Î³Ï‰Î³Î® Î»Î¯ÏƒÏ„Î±Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Ï„Î·Ï‚ Î³ÎµÎ½Î¹ÎºÎ®Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚',0),(130702,3631,'zh','å‡ºå£æ€»å¸å¸æˆ·åˆ—è¡¨\r\n',0),(130703,3631,'sv','Exportera General Ledger konton lista',0),(130704,3631,'it','Esportare l\'elenco dei conti di contabilitÃ  generale',0),(130705,3631,'tl','',0),(130706,3631,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(130707,3631,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤',0),(130708,3631,'ms','Eksport Senarai akaun Lejar Am',0),(130709,3631,'ar','ØªØµØ¯ÙŠØ± Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨Ø§Øª Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(130710,3631,'fr','Exporter la liste des comptes du grand livre gÃ©nÃ©ral',0),(130711,3631,'jp','ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒªã‚¹ãƒˆã?®ã‚¨ã‚¯ã‚¹ãƒ?ãƒ¼ãƒˆ',0),(130712,3631,'pt','Exportar lista de contas de contabilidade geral',0),(130713,3631,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ ÑÐ¿Ð¸ÑÐºÐ° Ð¾Ð±Ñ‰Ð¸Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð² Ð“Ðš',0),(130714,3631,'es','Exportar Lista de Cuentas de Libro Mayor',0),(130715,3631,'de','General Sachkonten Liste exportieren',0),(130716,3631,'en','Export General Ledger Accounts List',0),(130717,3632,'is','',0),(130718,3632,'dr','Ù…Ø²Ø§ÙŠØ§ÙŠ ÙƒÙ„ÙŠ Ø­Ù‚ÙˆÙ‚',0),(130719,3632,'pr','Ù…Ø²Ø§ÙŠØ§ÙŠ ÙƒÙ„ÙŠ Ø­Ù‚ÙˆÙ‚',0),(130720,3632,'tr','Genel yararlarÄ± (Ã¶deme)',0),(130721,3632,'pl','OgÃ³lne korzyÅ›ci (pÅ‚aciÄ‡)',0),(130722,3632,'bg','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð¾Ð±ÐµÐ·Ñ‰ÐµÑ‚ÐµÐ½Ð¸Ñ (Pay)',0),(130723,3632,'ur','Ø¬Ù†Ø±Ù„ ÙÙˆØ§Ø¦Ø¯ (ØªÙ†Ø®ÙˆØ§Û)',0),(130724,3632,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð±ÐµÐ½ÐµÑ„Ð¸Ñ†Ð¸Ñ˜Ðµ (Ð¿Ð»Ð°Ñ‚Ðµ)',0),(130725,3632,'vi','Lá»£i Ã­ch Chung (thanh toÃ¡n)',0),(130726,3632,'af','Algemene Voordele (Verdienste)',0),(130727,3632,'ro','Beneficiile de general (plata)',0),(130728,3632,'et','Ãœldine kasu (tasu)',0),(130729,3632,'si','SploÅ¡ne koristi (plaÄa)',0),(130730,3632,'ba','Manfaat Umum (membayar)',0),(130731,3632,'nl','Algemene voordelen (Pay)',0),(130732,3632,'fi','Yleiset edut (Pay)',0),(130733,3632,'no','Generelt fordeler (Pay)',0),(130734,3632,'da','Generelle fordele (lÃ¸n)',0),(130735,3632,'ko','ì¼ë°˜ í˜œíƒ (ìœ ë£Œ)',0),(130736,3632,'he','×™×ª×¨×•× ×•×ª ×”×›×œ×œ×™ (×©×›×¨)',0),(130737,3632,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î±ÏÎ¿Ï‡Î­Ï‚ (Ï€Î»Î·ÏÏ‰Î¼Î®)',0),(130738,3632,'zh','ä¸€èˆ¬çš„åˆ©ç›Šï¼ˆæ”¶è´¹ï¼‰\r\n',0),(130739,3632,'sv','AllmÃ¤nna fÃ¶rmÃ¥ner (lÃ¶n)',0),(130740,3632,'it','Benefici generali (a pagamento)',0),(130741,3632,'tl','',0),(130742,3632,'th','&#3612;&#3621;&#3611;&#3619;&#3632;&#3650;&#3618;&#3594;&#3609;&#3660;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611; (&#3592;&#3656;&#3634;&#3618;)',0),(130743,3632,'hi','à¤œà¤¨à¤°à¤² à¤²à¤¾à¤­ (à¤­à¥à¤—à¤¤à¤¾à¤¨)',0),(130744,3632,'ms','Faedah am (gaji)',0),(130745,3632,'ar','Ø§Ù„Ù…Ù†Ø§ÙØ¹ Ø§Ù„Ø¹Ø§Ù…Ø© (Ø§Ù„Ø£Ø¬Ø±)',0),(130746,3632,'fr','Avantages gÃ©nÃ©raux (payante)',0),(130747,3632,'jp','ä¸€èˆ¬åˆ©å¾—ï¼ˆæ”¯æ‰•ã?„ï¼‰',0),(130748,3632,'pt','BenefÃ­cios gerais (pago)',0),(130749,3632,'ru','ÐŸÑ€ÐµÐ¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð° Ð¾Ð±Ñ‰ÐµÐ³Ð¾ (Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ðµ)',0),(130750,3632,'es','BenefÃ­cios Generales (NÃ³mina)',0),(130751,3632,'de','Allgemeine Leistungen (gebÃ¼hrenpflichtig)',0),(130752,3632,'en','General Benefits (Pay)',0),(130753,3633,'is','',0),(130754,3633,'dr','ÙƒØ³ÙˆØ±Ø§Øª ÙƒÙ„ÙŠ',0),(130755,3633,'pr','ÙƒØ³ÙˆØ±Ø§Øª ÙƒÙ„ÙŠ',0),(130756,3633,'tr','Genel kesintiler',0),(130757,3633,'pl','OgÃ³lne odliczeÅ„',0),(130758,3633,'bg','ÐžÐ±Ñ‰Ð¾ ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸',0),(130759,3633,'ur','Ø¬Ù†Ø±Ù„ Ú©Ù¹ÙˆØªÛŒ',0),(130760,3633,'sr','ÐžÐ¿ÑˆÑ‚Ðµ Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ',0),(130761,3633,'vi','Giáº£m trá»« Chung',0),(130762,3633,'af','Algemene Aftrekkings',0),(130763,3633,'ro','Deduceri generale',0),(130764,3633,'et','Ãœldine mahaarvamised',0),(130765,3633,'si','SploÅ¡ne olajÅ¡ave',0),(130766,3633,'ba','Pengurangan Umum',0),(130767,3633,'nl','Algemene inhoudingen',0),(130768,3633,'fi','Yleiset vÃ¤hennykset',0),(130769,3633,'no','De generelle fradrag',0),(130770,3633,'da','Generelle fradrag',0),(130771,3633,'ko','ì¼ë°˜ ê³µì œ',0),(130772,3633,'he','× ×™×›×•×™×™× ×›×œ×œ×™',0),(130773,3633,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Î±Ï†Î±Î¹ÏÎ­ÏƒÎµÎ¹Ï‚',0),(130774,3633,'zh','ä¸€èˆ¬æ‰£é™¤é¢\r\n',0),(130775,3633,'sv','AllmÃ¤nna avdrag',0),(130776,3633,'it','Deduzioni generali',0),(130777,3633,'tl','',0),(130778,3633,'th','&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3621;&#3610;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(130779,3633,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤Ÿà¥Œà¤¤à¤¿à¤¯à¤¾à¤‚',0),(130780,3633,'ms','Am potongan',0),(130781,3633,'ar','Ø§Ù„Ø¥Ø³ØªÙ‚Ø·Ø§Ø¹Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø©',0),(130782,3633,'fr','DÃ©ductions gÃ©nÃ©rales',0),(130783,3633,'jp','ä¸€èˆ¬æŽ§é™¤',0),(130784,3633,'pt','DeduÃ§Ãµes gerais',0),(130785,3633,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ðµ Ð£Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ',0),(130786,3633,'es','Deducciones Generales',0),(130787,3633,'de','Allgemeine AbzÃ¼ge',0),(130788,3633,'en','General Deductions',0),(130789,3634,'is','',0),(130790,3634,'dr','Ø¹ÙˆØ§Ù…Ù„ ÙƒÙ„ÙŠ ',0),(130791,3634,'pr','Ø¹ÙˆØ§Ù…Ù„ ÙƒÙ„ÙŠ ',0),(130792,3634,'tr','Genel Etkenler',0),(130793,3634,'pl','OgÃ³lne czynniki',0),(130794,3634,'bg','ÐžÐ±Ñ‰Ð¸ Ñ„Ð°ÐºÑ‚Ð¾Ñ€Ð¸',0),(130795,3634,'ur','Ø¬Ù†Ø±Ù„ Ø¹ÙˆØ§Ù…Ù„',0),(130796,3634,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ñ„Ð°ÐºÑ‚Ð¾Ñ€Ð°',0),(130797,3634,'vi','Há»‡ sá»‘ Chung',0),(130798,3634,'af','Algemene Faktore',0),(130799,3634,'ro','General factori',0),(130800,3634,'et','Ãœldised tegurid',0),(130801,3634,'si','SploÅ¡ni dejavniki',0),(130802,3634,'ba','Faktor-faktor Umum',0),(130803,3634,'nl','Algemene factoren',0),(130804,3634,'fi','Yleiset tekijÃ¤t',0),(130805,3634,'no','Generelle faktorer',0),(130806,3634,'da','Generelle faktorer',0),(130807,3634,'ko','ì¼ë°˜ ìš”ì†Œ',0),(130808,3634,'he','×’× ×¨×œ ×’×•×¨×ž×™×',0),(130809,3634,'el','Î“ÎµÎ½Î¹ÎºÎ® Ï€Î±ÏÎ¬Î³Î¿Î½Ï„ÎµÏ‚',0),(130810,3634,'zh','ä¸€èˆ¬å› ç´ \r\n',0),(130811,3634,'sv','AllmÃ¤nna faktorer',0),(130812,3634,'it','Fattori generali',0),(130813,3634,'tl','',0),(130814,3634,'th','&#3611;&#3633;&#3592;&#3592;&#3633;&#3618;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(130815,3634,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¤•',0),(130816,3634,'ms','Faktor-faktor am',0),(130817,3634,'ar','Ø§Ù„Ø¹ÙˆØ§Ù…Ù„ Ø§Ù„Ø¹Ø§Ù…Ø©',0),(130818,3634,'fr','Facteurs gÃ©nÃ©raux',0),(130819,3634,'jp','ä¸€èˆ¬è¦?å› ',0),(130820,3634,'pt','Fatores gerais',0),(130821,3634,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ðµ Ð¤Ð°ÐºÑ‚Ð¾Ñ€Ñ‹',0),(130822,3634,'es','Factores Generales',0),(130823,3634,'de','Allgemeine Faktoren',0),(130824,3634,'en','General Factors',0),(130825,3635,'is','',0),(130826,3635,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(130827,3635,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(130828,3635,'tr','Ã‡alÄ±ÅŸan genel bilgi',0),(130829,3635,'pl','Informacje ogÃ³lne pracownik',0),(130830,3635,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»-Ð¾Ð±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(130831,3635,'ur','Ù…Ù„Ø§Ø²Ù… Ø¬Ù†Ø±Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(130832,3635,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð˜Ð½Ñ„Ð¾',0),(130833,3635,'vi','ThÃ´ng tin chung vá» nhÃ¢n viÃªn',0),(130834,3635,'af','Werknemer Algemene Inligting',0),(130835,3635,'ro','Angajat General Info',0),(130836,3635,'et','TÃ¶Ã¶taja Ãœldinfo',0),(130837,3635,'si','Zaposlenega sploÅ¡ne informacije',0),(130838,3635,'ba','Info Umum karyawan',0),(130839,3635,'nl','Werknemer Algemene Info',0),(130840,3635,'fi','TyÃ¶ntekijÃ¤n yleiset tiedot',0),(130841,3635,'no','Ansatt General Info',0),(130842,3635,'da','Medarbejder General Info',0),(130843,3635,'ko','ì§ì› ì¼ë°˜ ì •ë³´',0),(130844,3635,'he','×ž×™×“×¢ ×›×œ×œ×™ ×”×¢×•×‘×“',0),(130845,3635,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î³ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(130846,3635,'zh','é›‡å‘˜ä¸€èˆ¬ä¿¡æ¯\r\n',0),(130847,3635,'sv','AnstÃ¤lld allmÃ¤n Info',0),(130848,3635,'it','Dipendente General Info',0),(130849,3635,'tl','',0),(130850,3635,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(130851,3635,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(130852,3635,'ms','Maklumat am pekerja',0),(130853,3635,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ¸Ù Ø§Ù„Ø¹Ø§Ù…Ø©',0),(130854,3635,'fr','Infos gÃ©nÃ©rales de l\'employÃ©',0),(130855,3635,'jp','å¾“æ¥­å“¡ä¸€èˆ¬æƒ…å ±',0),(130856,3635,'pt','InformaÃ§Ã£o geral de empregado',0),(130857,3635,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð°Ñ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ðž Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°Ñ…',0),(130858,3635,'es','Info General de Empleado',0),(130859,3635,'de','Mitarbeiter-allgemeine Infos',0),(130860,3635,'en','Employee General Info',0),(130861,3636,'is','',0),(130862,3636,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(130863,3636,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(130864,3636,'tr','Genel muhasebe hesabÄ±nÄ±n faaliyet raporu',0),(130865,3636,'pl','Konto ksiÄ™gowe ogÃ³lne sprawozdanie z dziaÅ‚alnoÅ›ci',0),(130866,3636,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð» Ð›ÐµÐ´Ð¶ÑŠÑ€ Ð¿Ñ€Ð¾Ñ„Ð¸Ð»',0),(130867,3636,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(130868,3636,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð³ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(130869,3636,'vi','BÃ¡o CÃ¡o Hoáº¡t Äá»™ng TK Sá»• CÃ¡i Tá»•ng Há»£p',0),(130870,3636,'af','Algemene Grootboek Rekening Aktiwiteitverslag',0),(130871,3636,'ro','Raport de activitate general Ledger cont',0),(130872,3636,'et','Pearaamatu kontode aktiivsuse aruanne',0),(130873,3636,'si','Konta GK sploÅ¡no poroÄilo o dejavnostih',0),(130874,3636,'ba','Laporan kegiatan General Ledger Account',0),(130875,3636,'nl','Generaal grootboekrekening activiteitenverslag',0),(130876,3636,'fi','Yleinen kirjanpitotilin toimintakertomus',0),(130877,3636,'no','General finanskontoen aktivitetsrapport',0),(130878,3636,'da','General finanskonto aktivitetsrapport',0),(130879,3636,'ko','ì¼ë°˜ ë ˆì € ê³„ì • í™œë™ ë³´ê³ ì„œ',0),(130880,3636,'he','×“×•×— ×¤×¢×™×œ×•×ª ×—×©×‘×•×Ÿ ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™',0),(130881,3636,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï„Î®Ï„Ï‰Î½ Ï„Î¿Ï… Î³ÎµÎ½Î¹ÎºÎ¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î³/Î»',0),(130882,3636,'zh','æ€»å¸å¸æˆ·æ´»åŠ¨æŠ¥å‘Š\r\n',0),(130883,3636,'sv','AllmÃ¤nna redovisningskonto verksamhetsrapport',0),(130884,3636,'it','Relazione di attivitÃ  del conto di contabilitÃ  generale',0),(130885,3636,'tl','',0),(130886,3636,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(130887,3636,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¤¾ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(130888,3636,'ms','Laporan aktiviti akaun Lejar Am',0),(130889,3636,'ar','ØªÙ‚Ø±ÙŠØ± Ù†Ø´Ø§Ø· Ø§Ù„Ø­Ø³Ø§Ø¨ ÙÙŠ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(130890,3636,'fr','Rapport d\'activitÃ© de comptes au grand livre',0),(130891,3636,'jp','ç·?å‹˜å®šå…ƒå¸³å?£åº§å…¥å‡ºé‡‘ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(130892,3636,'pt','RelatÃ³rio de actividades do General Ledger conta',0),(130893,3636,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹ Ð±ÑƒÑ…Ð³.',0),(130894,3636,'es','Informe de Actividad de Cuenta de Libro Mayor',0),(130895,3636,'de','Allgemeinen Sachkonto-TÃ¤tigkeitsbericht',0),(130896,3636,'en','General Ledger Account Activity Report',0),(130897,3637,'is','',0),(130898,3637,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…ØºØ§ÙŠØ±Øª Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(130899,3637,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…ØºØ§ÙŠØ±Øª Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(130900,3637,'tr','Genel muhasebe bÃ¼tÃ§e varyans raporu',0),(130901,3637,'pl','OgÃ³lnego budÅ¼etu ksiÄ™gi wariancji raportu',0),(130902,3637,'bg','ÐžÐ±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ñ€Ð°Ð·Ð»Ð¸ÐºÐ° Ð´Ð¾ÐºÐ»Ð°Ð´',0),(130903,3637,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø¨Ø¬Ù¹ ØªØºÛŒØ± Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(130904,3637,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð±ÑƒÑŸÐµÑ‚Ñƒ Ð·Ð° ÐºÑšÐ¸Ð³Ðµ Ð³ÐµÐ½ÐµÑ€Ð°Ð» Ð¾Ð´ÑÑ‚ÑƒÐ¿Ð°ÑšÐ°',0),(130905,3637,'vi','BÃ¡o CÃ¡o NgÃ¢n SÃ¡ch ChÃªnh Lá»‡ch Sá»• CÃ¡i Tá»•ng Há»£p',0),(130906,3637,'af','Algemene Grootboek Begroting Afwyking Verslag',0),(130907,3637,'ro','Raport de variaÅ£ie general Ledger buget',0),(130908,3637,'et','Ãœldised pearaamatu eelarvesse dispersiooni aruanne',0),(130909,3637,'si','General Ledger proraÄuna Variance poroÄilo',0),(130910,3637,'ba','Laporan varians General Ledger anggaran',0),(130911,3637,'nl','General Ledger begrotingsrapport variantie',0),(130912,3637,'fi','Yleinen kirjanpitobudjettiin varianssi raportti',0),(130913,3637,'no','General Ledger varians Budsjettrapport',0),(130914,3637,'da','General Ledger Budget afvigelse rapport',0),(130915,3637,'ko','ì¼ë°˜ ë ˆì € ì˜ˆì‚° ì°¨ì´ ë³´ê³ ì„œ',0),(130916,3637,'he','×’× ×¨×œ ×‘×¡×¤×¨ ×”×ª×§×¦×™×‘ ×”×©×•× ×•×ª ×—',0),(130917,3637,'el','Î“ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î´Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ· Î­ÎºÎ¸ÎµÏƒÎ·',0),(130918,3637,'zh','æ€»å¸é¢„ç®—å·®å¼‚æŠ¥å‘Š\r\n',0),(130919,3637,'sv','General Ledger budgetrapport varians',0),(130920,3637,'it','General Ledger Budget Variance Report',0),(130921,3637,'tl','',0),(130922,3637,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3623;&#3634;&#3617;&#3649;&#3605;&#3585;&#3605;&#3656;&#3634;&#3591;&#3592;&#3634;&#3585;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3',0),(130923,3637,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤¬à¤œà¤Ÿ à¤µà¤¿à¤šà¤°à¤£ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(130924,3637,'ms','Laporan varians bajet Lejar Am',0),(130925,3637,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ÙØ±Ù‚ Ù…ÙˆØ§Ø²Ù†Ø© Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(130926,3637,'fr','Rapport de Variance Budget comptable gÃ©nÃ©ral',0),(130927,3637,'jp','ç·?å‹˜å®šå…ƒå¸³äºˆç®—å·®é¡?ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(130928,3637,'pt','General Ledger orÃ§amento relatÃ³rio de variÃ¢ncia',0),(130929,3637,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð“Ðš Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹ Ð´Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(130930,3637,'es','Informe de VariaciÃ³n Presupuestario de Libro Mayor',0),(130931,3637,'de','General Ledger Varianz Budgetbericht',0),(130932,3637,'en','General Ledger Budget Variance Report',0),(130933,3638,'is','',0),(130934,3638,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª  Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡  Ø¯ÙØªØ± ÙƒÙ„',0),(130935,3638,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª  Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡  Ø¯ÙØªØ± ÙƒÙ„',0),(130936,3638,'tr','Genel muhasebe gÃ¼nlÃ¼ÄŸÃ¼ raporlarÄ±',0),(130937,3638,'pl','OgÃ³lne arkusza ksiÄ™gi raportÃ³w',0),(130938,3638,'bg','Ð¡Ñ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´Ð½Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(130939,3638,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø¨ÛÛŒ',0),(130940,3638,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐµ ÐºÑšÐ¸Ð³Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(130941,3638,'vi','Nháº­t KÃ½ BÃºt ToÃ¡n Sá»• CÃ¡i Tá»•ng Há»£p',0),(130942,3638,'af','Algemene Grootboek Joernaalverslae',0),(130943,3638,'ro','Jurnalul de contabilitate general rapoartele',0),(130944,3638,'et','Ãœldised pearaamatu tÃ¶Ã¶lehe aruanded',0),(130945,3638,'si','SploÅ¡na temeljnica Ledger poroÄila',0),(130946,3638,'ba','General Ledger Journal melaporkan',0),(130947,3638,'nl','General Ledger Journal Reports',0),(130948,3638,'fi','Yleinen kirjanpidon kirjauskansioraportit',0),(130949,3638,'no','General Ledger journalrapporter',0),(130950,3638,'da','General Ledger Journal rapporter',0),(130951,3638,'ko','ì¼ë°˜ ë ˆì € ì €ë„ ë³´ê³ ì„œ',0),(130952,3638,'he','×“×•×—×•×ª ×™×•×ž×Ÿ ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™',0),(130953,3638,'el','Î•Î³Î³ÏÎ±Ï†ÏŽÎ½ ÎºÎ±Î¸Î¿Î»Î¹ÎºÎ¿Ï ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(130954,3638,'zh','æ€»å¸æ—¥å¿—æŠ¥å‘Š\r\n',0),(130955,3638,'sv','General Ledger journalrapporter',0),(130956,3638,'it','Rapporti del giornale di contabilitÃ  generale',0),(130957,3638,'tl','',0),(130958,3638,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3610;&#3633;&#3597;&#3594;&#3637;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;',0),(130959,3638,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾à¤¬à¤¹à¥€ à¤œà¤°à¥à¤¨à¤² à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥à¤¸',0),(130960,3638,'ms','Laporan jurnal Lejar Am',0),(130961,3638,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(130962,3638,'fr','Ã‰tats de Journal grand livre gÃ©nÃ©ral',0),(130963,3638,'jp','ç·?å‹˜å®šå…ƒå¸³ã‚¸ãƒ£ãƒ¼ãƒŠãƒ«ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(130964,3638,'pt','RelatÃ³rios de diÃ¡rio-razÃ£o geral',0),(130965,3638,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» ÐžÑ‚Ñ‡ÐµÑ‚Ð¾Ð² Ð“Ð»Ð°Ð²Ð½Ð¾Ð¹ ÐšÐ½Ð¸Ð³Ð¸',0),(130966,3638,'es','Informes de Diario de Libro Mayor',0),(130967,3638,'de','General Ledger Journalberichte',0),(130968,3638,'en','General Ledger Journal Reports',0),(130969,3639,'is','',0),(130970,3639,'dr','-  Ù¾Ø³Øª Ø¯ÙØªØ± Ú˜ÙˆØ±Ù†Ø§Ù„ ( Ø§Ø² Ù‡Ø± Ù…Ù†Ø¨Ø¹ÙŠ ',0),(130971,3639,'pr','Ø¯ÙØªØ± ÙƒÙ„-  Ù¾Ø³Øª Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ( Ø§Ø² Ù‡Ø± Ù…Ù†Ø¨Ø¹ÙŠ ',0),(130972,3639,'tr','Genel muhasebe - Post dergi (herhangi bir kaynaktan)',0),(130973,3639,'pl','KsiÄ™ga - Post czasopism (z dowolnego ÅºrÃ³dÅ‚a)',0),(130974,3639,'bg','Ð¡Ñ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ - Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð½ÐµÐ²Ð½Ð¸Ñ†Ð¸ (Ð¾Ñ‚ Ð²ÑÐµÐºÐ¸ Ð¸Ð·Ñ‚Ð¾Ñ‡Ð½Ð¸Ðº)',0),(130975,3639,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ - Ù¾ÙˆØ³Ù¹ Ø¬Ø±Ù†Ù„ (Ø³Û’ Ú©Ø³ÛŒ Ø¨Ú¾ÛŒ Ù…Ø§Ø®Ø°)',0),(130976,3639,'sr','Ð“Ð»Ð°Ð²Ð½Ð° ÐºÑšÐ¸Ð³Ð° - Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ (Ð¸Ð· Ð±Ð¸Ð»Ð¾ ÐºÐ¾Ð³ Ð¸Ð·Ð²Ð¾Ñ€Ð°)',0),(130977,3639,'vi','Sá»• CÃ¡i Tá»•ng Há»£p - Káº¿t Chuyá»ƒn CÃ¡c BÃºt ToÃ¡n (tá»« báº¥t ká»³ nguá»“n nÃ o)',0),(130978,3639,'af','Algemene Grootboek - Pos Joernale (Vanaf Enige Bron)',0),(130979,3639,'ro','Contabilitate - jurnale de Post (de la orice sursÄƒ)',0),(130980,3639,'et','Pearaamat - Post ajakirjad (mis tahes allikast)',0),(130981,3639,'si','Glavna knjiga - Post revijah (iz katerega koli vira)',0),(130982,3639,'ba','General Ledger - jurnal posting (dari berbagai sumber)',0),(130983,3639,'nl','Grootboek - Post tijdschriften (vanaf een willekeurige bron)',0),(130984,3639,'fi','Kirjanpito - Kirjaa kirjauskansiot (lÃ¤hteestÃ¤)',0),(130985,3639,'no','Finans - Post journaler (fra enhver kilde)',0),(130986,3639,'da','General Ledger - Post tidsskrifter (fra enhver kilde)',0),(130987,3639,'ko','ì¼ë°˜ íšŒê³„ ìž¥ë¶€-í¬ìŠ¤íŠ¸ ì €ë„ (ì†ŒìŠ¤)ì—ì„œ',0),(130988,3639,'he','×”×¡×¤×¨ ×”×¨××©×™ - ×›×ª×‘×™ ×¢×ª ×¤×•×¡×˜ (×ž×ž×§×•×¨ ×›×œ×©×”×•)',0),(130989,3639,'el','Î“ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® - Ï€ÎµÏÎ¹Î¿Î´Î¹ÎºÎ¬ Ï„Î· Î¸Î­ÏƒÎ· (Î±Ï€ÏŒ Î¿Ï€Î¿Î¹Î±Î´Î®Ï€Î¿Ï„Îµ Ï€Î·Î³Î®)',0),(130990,3639,'zh','æ€»å¸-é‚®å¯„æ—¥å¿—ï¼ˆä»Žä»»ä½•æ¥æºï¼‰\r\n',0),(130991,3639,'sv','Redovisning - bokfÃ¶ringsjournaler (frÃ¥n alla kÃ¤llor)',0),(130992,3639,'it','ContabilitÃ  generale - Post riviste (da qualsiasi fonte)',0),(130993,3639,'tl','',0),(130994,3639,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;-&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#',0),(130995,3639,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ - à¤ªà¤¦ à¤ªà¤¤à¥à¤°à¤¿à¤•à¤¾à¤“à¤‚ (à¤¸à¥‡ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤¸à¥à¤°à¥‹à¤¤)',0),(130996,3639,'ms','Lejar Am - Post jurnal (dari mana-mana sumber)',0),(130997,3639,'ar','ØªØ±Ø­ÙŠÙ„ Ø§Ù„Ù‚ÙŠÙˆØ¯ - Ù…Ù† Ø£ÙŠ Ù…ØµØ¯Ø± ÙƒØ§Ù†',0),(130998,3639,'fr','ComptabilitÃ© gÃ©nÃ©rale - validez les feuilles (Ã  partir de n\'importe quelle Source)',0),(130999,3639,'jp','ç·?å‹˜å®šå…ƒå¸³ãƒ¼ã‚¸ãƒ£ãƒ¼ãƒŠãƒ«ã?®è¨ˆä¸Šï¼ˆã?©ã?“ã?‹ã‚‰ã?§ã‚‚ï¼‰',0),(131000,3639,'pt','General Ledger - Post diÃ¡rios (a partir de qualquer fonte)',0),(131001,3639,'ru','Ð“Ðš - Ð¿Ð¾ÑÑ‚ Ð¶ÑƒÑ€Ð½Ð°Ð»Ð¾Ð² (Ð¸Ð· Ð»ÑŽÐ±Ð¾Ð³Ð¾ Ð¸ÑÑ‚Ð¾Ñ‡Ð½Ð¸ÐºÐ°)',0),(131002,3639,'es','Libro Mayor - Asentar Diarios ( De Cualquiera Fuente',0),(131003,3639,'de','Hauptbuch - Post Zeitschriften (von jeder Quelle)',0),(131004,3639,'en','General Ledger - Post Journals (From Any Source)',0),(131005,3640,'is','',0),(131006,3640,'dr','- Ø±Ø®ØµØªÛŒ Ø¹Ø§Ø¬Ù„  - Ø±Ø®ØµØªÛŒ Ø¬Ù…Ø¹ Ø´Ø¯Ù‡ ',0),(131007,3640,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù…Ø«Ù„ Ù†Ø±Ø® Ù‡Ø§ÙŠ Ø­Ø¯Ø§Ù‚Ù„ Ø¯Ø³ØªÙ…Ø²Ø¯ â€“Ù…Ø²Ø§ÙŠØ§ÙŠ Ù†ÙˆØ¨Øª ÙƒØ§Ø±ÙŠ - Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰  - Ù…Ø±Ø®ØµÙŠ Ø¬Ù…Ø¹ Ø´Ø¯Ù‡ ',0),(131008,3640,'tr','Asgari Ã¼cret - Shift primler - hastalÄ±k izni ve tatil tahakkuk hÄ±zlarÄ± gibi genel bordro bilgileri',0),(131009,3640,'pl','OgÃ³lne informacje pÅ‚ace minimalne wynagrodzenie - premie Shift - chorobowe i urlop naliczania cena',0),(131010,3640,'bg','ÐžÐ±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ ÐºÐ°Ñ‚Ð¾ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð° - Shift Ð¿Ñ€ÐµÐ¼Ð¸Ð¸ - Ð¾Ñ‚Ð¿ÑƒÑÐº Ð¿Ð¾ Ð±Ð¾Ð»ÐµÑÑ‚ Ð¸ Ð²Ð°ÐºÐ°Ð½Ñ†Ð¸Ñ Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¸',0),(131011,3640,'ur','Ø¬Ù†Ø±Ù„ Ù¾Û’ Ø±ÙˆÙ„ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¬ÛŒØ³Û’ Ù…Ù†ÛŒ Ù…Ù… ÙˆÛŒØ¬ - Shift Ù¾Ø±ÛŒÙ…ÛŒÙ… - Ø¨ÛŒÙ…Ø§Ø± Ú†Ú¾ÙˆÚ‘ÛŒÚº Ø§ÙˆØ± Ú†Ú¾Ù¹ÛŒ Ú©ÛŒ Ø´Ø±Ø­ Ø§Ú©Ú©Ø±ÙˆØ§Ù„',0),(131012,3640,'sr','ÐžÐ¿ÑˆÑ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ñ˜ Ð»Ð¸ÑÑ‚Ð¸ ÐºÐ°Ð¾ ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð° - Ð¡Ñ…Ð¸Ñ„Ñ‚ Ð¿Ñ€ÐµÐ¼Ð¸Ñ˜Ðµ - Ð±Ð¾Ð»Ð¾Ð²Ð°ÑšÐµ Ð¸ Ð¾Ð´Ð¼Ð¾Ñ€ Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°ÑšÐ° ÑÑ‚Ð¾Ð¿Ðµ',0),(131013,3640,'vi','ThÃ´ng tin báº£ng lÆ°Æ¡ng chung nhÆ° lÆ°Æ¡ng tá»‘i thiá»ƒu - LÆ°Æ¡ng lÃ m ca - nghá»‰ be65ng & GiÃ¡ ká»³ nghá»‰ lÅ©y káº¿',0),(131014,3640,'af','Algemene Loonrol Inligting soos Minimum Loon - Skof\"Premiums\" - Siekverlof en Vakansie Opgehoote Skale',0),(131015,3640,'ro','Informatii generale despre salarizare salariul minim - Shift prime - concediu ÅŸi ratele de angajamente de vacanta',0),(131016,3640,'et','Palgaarvestuse Ã¼ldteavet nagu miinimumpalga - Shift lisatasude - haiguspuhkuste ja puhkus tekkepÃµhise mÃ¤Ã¤rad',0),(131017,3640,'si','SploÅ¡ne informacije na izplaÄane plaÄe kot minimalno plaÄo - Shift premije - bolniÅ¡ki dopust in poÄitnice odmernih stopenj',0),(131018,3640,'ba','Informasi gaji umum seperti upah Minimum - Shift premi - cuti dan liburan akrual harga',0),(131019,3640,'nl','Algemene Payroll informatie zoals minimumloon - Shift premies - ziekteverlof en vakantie kostentoename tarieven',0),(131020,3640,'fi','Palkanlaskennan yleistietoa kuten vÃ¤himmÃ¤ispalkkaa - vaihto palkkiot - Sairausloma ja loma karttumisprosenttien',0),(131021,3640,'no','Generell lÃ¸nnsinformasjon som minstelÃ¸nn - Skift premie - sykefravÃ¦r og ferie belastning priser',0),(131022,3640,'da','Generelle lÃ¸noplysninger som mindstelÃ¸n - Skift prÃ¦mier - sygefravÃ¦r og ferie periodisering priser',0),(131023,3640,'ko','ìµœì € ìž„ê¸ˆ-ì‹œí”„íŠ¸ ë³´í—˜ë£Œ-ë³‘ê°€ íœ´ê°€ ì ë¦½ ìœ¨ ë“± ì¼ë°˜ ê¸‰ì—¬ ì •ë³´',0),(131024,3640,'he','×ž×™×“×¢ ×›×œ×œ×™ ×©×›×¨ ×›×’×•×Ÿ ×©×›×¨ ×ž×™× ×™×ž×•× - Shift ×”×¤×¨×ž×™×•×ª - ×ž×—×œ×” ×•×§×¦×‘×™ ×¦×‘×™×¨×ª ×”×—×•×¤×©×”',0),(131025,3640,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ ÏŒÏ€Ï‰Ï‚ ÎµÎ»Î¬Ï‡Î¹ÏƒÏ„Î¿ Î¼Î¹ÏƒÎ¸ÏŒ - Shift Î±ÏƒÏ†Î¬Î»Î¹ÏƒÏ„ÏÎ± - Î±Î½Î±ÏÏÏ‰Ï„Î¹ÎºÎ® Î¬Î´ÎµÎ¹Î± ÎºÎ±Î¹ Ï€Î¿ÏƒÎ¿ÏƒÏ„Î¬ Ï€ÏÎ¿ÏƒÎ±ÏÎ¾Î·ÏƒÎ· Î´Î¹Î±ÎºÎ¿Ï€Î­Ï‚',0),(131026,3640,'zh','ä¸€èˆ¬å·¥èµ„ä¿¡æ¯ï¼Œå¦‚æœ€ä½Žå·¥èµ„ -ç§»ä¿è´¹-ç—…å‡å’Œå‡æœŸç´¯ç§¯çŽ‡\r\n',0),(131027,3640,'sv','AllmÃ¤n Information om lÃ¶ner som minimilÃ¶n - SKIFT Premier - sjukskrivning och semester periodiserad priser',0),(131028,3640,'it','GeneralitÃ  sui salari come salario minimo - premi Shift - assenze per malattia e vacanze per competenza tariffe',0),(131029,3640,'tl','',0),(131030,3640,'th','General Payroll Information such as Minimum Wage - Shift Premiums - Sick Leave and Vacation Accrual Rates',0),(131031,3640,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤®à¤œà¤¦à¥‚à¤°à¥€ - à¤¬à¤¦à¤²à¤¾à¤µ Premiums - à¤¬à¥€à¤®à¤¾à¤° à¤›à¥à¤Ÿà¥à¤Ÿà¥€ à¤”à¤° à¤›à¥à¤Ÿà¥à¤Ÿà¥€ à¤ªà¥à¤°à¥‹à¤¦à¥à¤­à¤µà¤¨ à¤¦à¤°à¥‹à¤‚ à¤œà¥ˆà¤¸à¥‡ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤ªà¥‡à¤°à¥‹à¤² à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(131032,3640,'ms','Maklumat gaji am seperti gaji Minimum - Shift premium - cuti sakit dan kadar akruan percutian',0),(131033,3640,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø¹Ø§Ù…Ø© Ù…Ø«Ù„ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù„Ù„Ø£Ø¬ÙˆØ±-\"ØªØ­ÙˆÙ„ Ø£Ù‚Ø³Ø§Ø·\"-Ø§Ù„Ø¥Ø¬Ø§Ø²Ø© Ø§Ù„Ù…Ø±Ø¶ÙŠØ© ÙˆØ¥Ø¬Ø§Ø²Ø© Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ù…Ø¹Ø¯Ù„Ø§Øª',0),(131034,3640,'fr','Informations gÃ©nÃ©rales sur la paie : salaire Minimum - primes de poste - congÃ© de maladie et le taux d\'accumulation de vacances',0),(131035,3640,'jp','æœ€ä½Žè³ƒé‡‘ã€?ã‚·ãƒ•ãƒˆå‹¤å‹™å‰²å¢—è³ƒé‡‘ã€?ç—…æ°—ä¼‘æš‡ã€?æœ‰çµ¦ä¼‘æš‡ã?ªã?©ã?®ä¸€èˆ¬çµ¦ä¸Žæƒ…å ±',0),(131036,3640,'pt','InformaÃ§Ãµes gerais de folha de pagamento como salÃ¡rio mÃ­nimo - prÃ©mios de Shift - licenÃ§a e taxas de acumulaÃ§Ã£o de fÃ©rias',0),(131037,3640,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹, ÐºÐ°Ðº Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ - ÑÐ´Ð²Ð¸Ð³Ð° Ð²Ð·Ð½Ð¾ÑÑ‹ - Ð¾Ñ‚Ð¿ÑƒÑÐº Ð¸ ÐºÐ°Ð½Ð¸ÐºÑƒÐ»Ñ‹ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ ÑÑ‚Ð°Ð²Ð¾Ðº',0),(131038,3640,'es','InformaciÃ³n de NÃ³mina General como Salario MÃ­nimo - Premios del Torno - Ausencia por Enfermedad y Tasas de AcumulaciÃ³n de Vacaciones',0),(131039,3640,'de','Allgemeine Gehaltsinformationen wie Mindestlohn - Schichtzulagen - Krankenstand und Urlaub Accrual-Preise',0),(131040,3640,'en','General Payroll Information such as Minimum Wage - Shift Premiums - Sick Leave and Vacation Accrual Rates',0),(131041,3641,'is','',0),(131042,3641,'dr','Ø¨Ø±ÙˆÙŠØ¯ Ø¨Ù‡ Ø³Ø¨Ø¯ Ø®Ø±ÙŠØ¯ ',0),(131043,3641,'pr','Ø¨Ø±ÙˆÙŠØ¯ Ø¨Ù‡ Ø³Ø¨Ø¯ Ø®Ø±ÙŠØ¯ ',0),(131044,3641,'tr','AlÄ±ÅŸveriÅŸ sepeti iÃ§in git',0),(131045,3641,'pl','PrzejdÅº do koszyka',0),(131046,3641,'bg','ÐšÑŠÐ¼ Ð¿Ð°Ð·Ð°Ñ€ÑÐºÐ°Ñ‚Ð° ÐºÐ¾ÑˆÐ½Ð¸Ñ†Ð°',0),(131047,3641,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ú©Ùˆ Ø¬Ø§Ù†Ø§',0),(131048,3641,'sr','Ð˜Ð´Ð¸ Ñƒ ÐºÐ¾Ñ€Ð¿Ñƒ',0),(131049,3641,'vi','Äi Tá»›i Giá» HÃ ng',0),(131050,3641,'af','Gaan Shopping Cart',0),(131051,3641,'ro','Du-te la coÅŸul de cumpÄƒrÄƒturi',0),(131052,3641,'et','Mine ostukorvi',0),(131053,3641,'si','Pojdi na nakupovalni voziÄek',0),(131054,3641,'ba','Pergi ke keranjang belanja',0),(131055,3641,'nl','Ga naar winkelwagen',0),(131056,3641,'fi','Siirry ostoskoriin',0),(131057,3641,'no','GÃ¥ til handlekurven',0),(131058,3641,'da','GÃ¥ til indkÃ¸bskurven',0),(131059,3641,'ko','ì‡¼í•‘ ì¹´íŠ¸ë¡œ ì´ë™',0),(131060,3641,'he','×œ×š ×œ×¢×’×œ×”',0),(131061,3641,'el','Î Î·Î³Î±Î¯Î½ÎµÏ„Îµ ÏƒÏ„Î¿ ÎºÎ±Î»Î¬Î¸Î¹',0),(131062,3641,'zh','åŽ»è´­ç‰©è½¦\r\n',0),(131063,3641,'sv','GÃ¥ till varukorgen',0),(131064,3641,'it','Vai al carrello',0),(131065,3641,'tl','',0),(131066,3641,'th','&#3652;&#3611;&#3607;&#3637;&#3656;&#3605;&#3632;&#3585;&#3619;&#3657;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(131067,3641,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤“',0),(131068,3641,'ms','Pergi ke senarai belanja',0),(131069,3641,'ar','Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰ Ø³Ù„Ø© Ø§Ù„ØªØ³ÙˆÙ‚',0),(131070,3641,'fr','AccÃ©dez Ã  votre panier',0),(131071,3641,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°ã‚«ãƒ¼ãƒˆã?¸è¡Œã??',0),(131072,3641,'pt','Ir ao carrinho de compras',0),(131073,3641,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ð² ÐºÐ¾Ñ€Ð·Ð¸Ð½Ñƒ',0),(131074,3641,'es','Ir a Carrito de Compras',0),(131075,3641,'de','Gehen Sie zum Warenkorb',0),(131076,3641,'en','Go to Shopping Cart',0),(131077,3642,'is','',0),(131078,3642,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø§Ø² Ø±ÙˆÙŠ  ØªØ§Ø±ÙŠØ® ',0),(131079,3642,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø§Ø² Ø±ÙˆÙŠ  ØªØ§Ø±ÙŠØ® ',0),(131080,3642,'tr','Grup Yazma Ã§ekleri tarihine gÃ¶re',0),(131081,3642,'pl','Grupa zapisu kontroli wedÅ‚ug daty',0),(131082,3642,'bg','Ð“Ñ€ÑƒÐ¿Ð° Ð¿Ð¸ÑÐ°Ð½Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¿Ð¾ Ð´Ð°Ñ‚Ð°',0),(131083,3642,'ur','Ú¯Ø±ÙˆÙ¾ ØªØ­Ø±ÛŒØ± Ú†ÛŒÚ© ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(131084,3642,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð¿Ð¸ÑÐ°ÑšÐ° Ñ‡ÐµÐºÐ¾Ð²Ð° Ð¿Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ñƒ',0),(131085,3642,'vi','Viáº¿t nhÃ³m SÃ©c theo ngÃ y',0),(131086,3642,'af','Groepeer Uitgeskryfde Tjeks per Datum',0),(131087,3642,'ro','Grupa scrie controalelor de data',0),(131088,3642,'et','Grupi kirjutamine kontrolli kuupÃ¤eva jÃ¤rgi',0),(131089,3642,'si','Skupina pisanje pregledov po datumu',0),(131090,3642,'ba','Kelompok menulis cek oleh tanggal',0),(131091,3642,'nl','Groep schrijven controles door datum',0),(131092,3642,'fi','RyhmÃ¤ kirjoittaa tarkastukset mennessÃ¤',0),(131093,3642,'no','Gruppe skrive sjekker etter dato',0),(131094,3642,'da','Gruppe skrive kontrol af dato',0),(131095,3642,'ko','ê·¸ë£¹ ì“°ê¸° ê²€ì‚¬ ë‚ ì§œ',0),(131096,3642,'he','×§×‘×•×¦×ª ×‘×“×™×§×•×ª ×›×ª×™×‘×” ×œ×¤×™ ×ª××¨×™×š',0),(131097,3642,'el','ÎŸÎ¼Î¬Î´Î± ÎµÎ»Î­Î³Ï‡Ï‰Î½ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ Î±Ï€ÏŒ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(131098,3642,'zh','æŒ‰æ—¥æœŸç»„å†™æ”¯ç¥¨\r\n',0),(131099,3642,'sv','Grupp skriva kontroller av datum',0),(131100,3642,'it','Gruppo scrittura verifiche di data',0),(131101,3642,'tl','',0),(131102,3642,'th','&#3619;&#3623;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3648;&#3594;&#3655;&#3588;&#3607;&#3637;&#3656;&#3648;&#3586;&#3637;&#3618;&#3609;&#3616;&#3634;&#3618;&#3651;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(131103,3642,'hi','à¤¸à¤®à¥‚à¤¹ à¤²à¤¿à¤–à¥‡à¤‚ à¤šà¥‡à¤• à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(131104,3642,'ms','Kumpulan tulis cek mengikut tarikh',0),(131105,3642,'ar','ÙØ±ÙŠÙ‚ ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø¨ØªØ§Ø±ÙŠØ®',0),(131106,3642,'fr','Groupe Ã©criture contrÃ´les par Date',0),(131107,3642,'jp','æ—¥ã?«ã?¡åˆ¥å°?åˆ‡æ‰‹æ›¸ã??è¾¼ã?¿ã‚°ãƒ«ãƒ¼ãƒ—',0),(131108,3642,'pt','Grupo escrever cheques por data',0),(131109,3642,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ð¾ Ð´Ð°Ñ‚Ðµ',0),(131110,3642,'es','Elaborar Cheques de Grupo por Fecha',0),(131111,3642,'de','Gruppe schreiben PrÃ¼fungen nach Datum',0),(131112,3642,'en','Group Write Checks by Date',0),(131113,3643,'is','',0),(131114,3643,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø± Ø¯Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ',0),(131115,3643,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø± Ø¯Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ',0),(131116,3643,'tr','Sistem iÃ§ine mÃ¼ÅŸteri listesini al',0),(131117,3643,'pl','Lista klientÃ³w importu do systemu',0),(131118,3643,'bg','Ð’Ð½Ð¾Ñ ÑÐ¿Ð¸ÑÑŠÐº Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(131119,3643,'ur','Ù†Ø¸Ø§Ù… Ù…ÛŒÚº Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ÙÛØ±Ø³Øª',0),(131120,3643,'sr','Ð£Ð²Ð¾Ð· Ð»Ð¸ÑÑ‚Ðµ ÐºÑƒÐ¿Ð°Ñ†Ð° Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼',0),(131121,3643,'vi','Nháº­p danh sÃ¡ch khÃ¡ch hÃ ng vÃ o Nolapro ',0),(131122,3643,'af','Invoer van KliÃ«nte/Klante Lys binne-in NolaPro',0),(131123,3643,'ro','Import listÄƒ de client Ã®n sistem',0),(131124,3643,'et','Improdi kliendinimekiri NolaPro-sse',0),(131125,3643,'si','Uvozi seznam kupcev v sistem',0),(131126,3643,'ba','Daftar pelanggan impor ke dalam sistem',0),(131127,3643,'nl','Klantenlijst importeren in systeem',0),(131128,3643,'fi','Tuo asiakkaan luettelo jÃ¤rjestelmÃ¤Ã¤n',0),(131129,3643,'no','Importer kundelisten i System',0),(131130,3643,'da','Importer kundeliste i System',0),(131131,3643,'ko','ì‹œìŠ¤í…œì— ê³ ê° ëª©ë¡ ê°€ì ¸ì˜¤ê¸°',0),(131132,3643,'he','NolaPro ×™×‘× ×¨×©×™×ž×ª ×œ×§×•×—×•×ª ×œ×ª×•×š',0),(131133,3643,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î»Î¯ÏƒÏ„Î±Ï‚ Ï€ÎµÎ»Î¬Ï„Î· ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(131134,3643,'zh','å¯¼å…¥åˆ°ç³»ç»Ÿçš„å®¢æˆ·åå•\r\n',0),(131135,3643,'sv','Importera kundlista i systemet',0),(131136,3643,'it','Lista di clienti di importazione nel sistema',0),(131137,3643,'tl','',0),(131138,3643,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3652;&#3611;&#3626;&#3641;&#3656; Nolapro',0),(131139,3643,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤®à¥‡à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‚à¤šà¥€ à¤†à¤¯à¤¾à¤¤',0),(131140,3643,'ms','Senarai pelanggan import ke dalam sistem',0),(131141,3643,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(131142,3643,'fr','Liste de clients d\'importation dans le systÃ¨me',0),(131143,3643,'jp','Nolaproã?¸é¡§å®¢ãƒªã‚¹ãƒˆã‚’ã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆã?™ã‚‹',0),(131144,3643,'pt','Lista de importaÃ§Ã£o de clientes no sistema',0),(131145,3643,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¡Ð¿Ð¸ÑÐºÐ° ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð² NolaPro',0),(131146,3643,'es','Importar Lista de Clientes a NolPro',0),(131147,3643,'de','Import-Kundenliste in System',0),(131148,3643,'en','Import Customer List into System',0),(131149,3644,'is','',0),(131150,3644,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(131151,3644,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(131152,3644,'tr','MÃ¼ÅŸteriler alma',0),(131153,3644,'pl','Klienci importu',0),(131154,3644,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(131155,3644,'ur','ØµØ§Ø±ÙÛŒÙ† Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(131156,3644,'sr','Ð£Ð²Ð¾Ð· ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(131157,3644,'vi','Nháº­p khÃ¡ch hÃ ng',0),(131158,3644,'af','Invoer van KliÃ«nte/Klante',0),(131159,3644,'ro','ClienÅ£ii de import',0),(131160,3644,'et','Impordi kliendid',0),(131161,3644,'si','Uvoz stranke',0),(131162,3644,'ba','Impor pelanggan',0),(131163,3644,'nl','Importeren van klanten',0),(131164,3644,'fi','Tuo asiakkaat',0),(131165,3644,'no','Importere kunder',0),(131166,3644,'da','Importere kunder',0),(131167,3644,'ko','ê°€ì ¸ì˜¤ê¸° ê³ ê°',0),(131168,3644,'he','×™×‘× ×œ×§×•×—×•×ª',0),(131169,3644,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(131170,3644,'zh','å¯¼å…¥å®¢æˆ·\r\n',0),(131171,3644,'sv','Importera kunder',0),(131172,3644,'it','Importazione clienti',0),(131173,3644,'tl','',0),(131174,3644,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(131175,3644,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤†à¤¯à¤¾à¤¤',0),(131176,3644,'ms','Pelanggan import',0),(131177,3644,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(131178,3644,'fr','Importer des clients',0),(131179,3644,'jp','é¡§å®¢å?–ã‚Šè¾¼ã?¿',0),(131180,3644,'pt','ImportaÃ§Ã£o de clientes',0),(131181,3644,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(131182,3644,'es','Importar Clientes',0),(131183,3644,'de','Import Kunden',0),(131184,3644,'en','Import Customers',0),(131185,3645,'is','',0),(131186,3645,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(131187,3645,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(131188,3645,'tr','Ä°thalat genel muhasebe hesaplarÄ±nÄ±n listesi',0),(131189,3645,'pl','Wykaz kont ksiÄ™gi importu ogÃ³lne',0),(131190,3645,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ð±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ ÑÐ¼ÐµÑ‚ÐºÐ¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(131191,3645,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(131192,3645,'sr','Ð›Ð¸ÑÑ‚Ð° ÑƒÐ²Ð¾Ð· Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(131193,3645,'vi','Káº¿t Chuyá»ƒn TK Sá»• CÃ¡i Tá»•ng Há»£p ',0),(131194,3645,'af','Invoer van Algemene Grootboekrekeninge Lys',0),(131195,3645,'ro','Lista de import General Ledger conturi',0),(131196,3645,'et','Impordi Pearaamatu kontode nimekiri',0),(131197,3645,'si','Seznam sploÅ¡nih uvoznih konte glavne knjige',0),(131198,3645,'ba','Daftar Impor General Ledger account',0),(131199,3645,'nl','Import General Ledger Accountlijst',0),(131200,3645,'fi','Tuo yleinen kirjanpidon tilit-luettelosta',0),(131201,3645,'no','Importer General Ledger kontoer-listen',0),(131202,3645,'da','Import General Ledger regnskaber liste',0),(131203,3645,'ko','ê°€ì ¸ì˜¤ê¸° ì¼ë°˜ì  ì›ìž¥ ê³„ì • ëª©ë¡',0),(131204,3645,'he','×¨×©×™×ž×ª ×—×©×‘×•× ×•×ª ×¡×¤×¨ ×¨××©×™ ×™×™×‘×•× ×›×œ×œ×™',0),(131205,3645,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Î³ÎµÎ½Î¹ÎºÎ®Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚',0),(131206,3645,'zh','å¯¼å…¥æ€»å¸å¸æˆ·åˆ—è¡¨\r\n',0),(131207,3645,'sv','Importera General Ledger kontolistan',0),(131208,3645,'it','Elenco di conti di contabilitÃ  generale di importazione',0),(131209,3645,'tl','',0),(131210,3645,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(131211,3645,'hi','à¤†à¤¯à¤¾à¤¤ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(131212,3645,'ms','Senarai akaun Lejar Am import',0),(131213,3645,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨Ø§Øª Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(131214,3645,'fr','Liste des comptes du grand livre gÃ©nÃ©ral d\'importation',0),(131215,3645,'jp','ç·?å‹˜å®šå…ƒå¸³ãƒªã‚¹ãƒˆã?®ã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆ',0),(131216,3645,'pt','Lista de contas de importaÃ§Ã£o General Ledger',0),(131217,3645,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑÑ‡ÐµÑ‚Ð¾Ð² Ð“Ðš Ð¾Ð±Ñ‰ÐµÐ³Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(131218,3645,'es','Importar Lista de Cuentas de Libro Mayor',0),(131219,3645,'de','Import allgemein Sachkonten-Liste',0),(131220,3645,'en','Import General Ledger Accounts List',0),(131221,3646,'is','',0),(131222,3646,'dr','Ø«Ø¨Øª Ø§ØµÙ„Ø§Ø­Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131223,3646,'pr','Ø«Ø¨Øª Ø§ØµÙ„Ø§Ø­Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131224,3646,'tr','Stok dÃ¼zeltmelerini girin',0),(131225,3646,'pl','WprowadÅº korekty zapasÃ³w',0),(131226,3646,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°',0),(131227,3646,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(131228,3646,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(131229,3646,'vi','Nháº­p Chá»‰nh Sá»­a HÃ ng HÃ³a',0),(131230,3646,'af','Voer Inventaris Aanpassings in',0),(131231,3646,'ro','IntroduceÅ£i ajustÄƒrile de stocuri',0),(131232,3646,'et','Lao korrigeerimised',0),(131233,3646,'si','Vnesite popravke zaloge',0),(131234,3646,'ba','Masukkan penyesuaian persediaan',0),(131235,3646,'nl','Voer voorraadherwaarderingen',0),(131236,3646,'fi','Kirjoita varastomuutokset',0),(131237,3646,'no','Angi lagerjusteringer',0),(131238,3646,'da','Angiv lagerreguleringer',0),(131239,3646,'ko','ìž¬ê³  ì¡°ì • ìž…ë ¥',0),(131240,3646,'he','×”×›× ×¡ ×”×ª××ž×•×ª ×ž×œ××™',0),(131241,3646,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(131242,3646,'zh','è¾“å…¥åº“å­˜è°ƒæ•´',0),(131243,3646,'sv','Ange lagerjusteringar',0),(131244,3646,'it','Immettere le rettifiche di magazzino',0),(131245,3646,'tl','',0),(131246,3646,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(131247,3646,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(131248,3646,'ms','Masukkan Pelarasan Inventori',0),(131249,3646,'ar','Ø£Ø¯Ø®Ù„ ØªØ¹Ø¯ÙŠÙ„Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(131250,3646,'fr','Entrez les redressements dâ€™inventaire',0),(131251,3646,'jp','åœ¨åº«èª¿æ•´ã?®å…¥åŠ›',0),(131252,3646,'pt','Inserir ajustes de inventÃ¡rio',0),(131253,3646,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(131254,3646,'es','Introducir Ajuste de Inventario',0),(131255,3646,'de','Geben Sie Lagerregulierungen',0),(131256,3646,'en','Enter Inventory Adjustments',0),(131257,3647,'is','',0),(131258,3647,'dr','/ Ø¨Ù‡ Ø±ÙˆØ²Ø± Ø³Ø§Ù†ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³- Ú¯Ø²Ø§Ø±Ø´Ø§Øª',0),(131259,3647,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø± Ø³Ø§Ù†ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§- Ú¯Ø²Ø§Ø±Ø´Ø§Øª',0),(131260,3647,'tr','Stok giriÅŸ/gÃ¼ncelleme - raporlar',0),(131261,3647,'pl','Wpis/aktualizacji spisu - raporty',0),(131262,3647,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð·Ð°Ð¿Ð¸Ñ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ - Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(131263,3647,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº - Ø±Ù¾ÙˆØ±Ù¹',0),(131264,3647,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° ÑƒÐ½Ð¾Ñ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ - Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(131265,3647,'vi','Nháº­p/Cáº­p Nháº­t HÃ ng HÃ³a - BÃ¡o CÃ¡o',0),(131266,3647,'af','Voorraad Inskrying/Opdatering - Verslae',0),(131267,3647,'ro','Intrare/actualizarea inventarului - rapoarte',0),(131268,3647,'et','Lao kirje/uuendamine - aruanded',0),(131269,3647,'si','Vnos/posodobitev - poroÄila',0),(131270,3647,'ba','Persediaan catatan/Update - laporan',0),(131271,3647,'nl','Voorraad vermelding/Update - verslagen',0),(131272,3647,'fi','Tapahtuma /-pÃ¤ivitys - raportit',0),(131273,3647,'no','Inventar oppfÃ¸ring/oppdatere - rapporter',0),(131274,3647,'da','Lager posten/Update - rapporter',0),(131275,3647,'ko','ì¸ë²¤í† ë¦¬ í•­ëª©/ì—…ë°ì´íŠ¸-ë³´ê³ ì„œ',0),(131276,3647,'he','×›× ×™×¡×”/×¢×“×›×•×Ÿ ×”×ž×œ××™ - ×“×•×—×•×ª',0),(131277,3647,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ - ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(131278,3647,'zh','åº“å­˜æ¡ç›®/æ›´æ–°- æŠ¥å‘Š\r\n',0),(131279,3647,'sv','IntrÃ¤de/lageruppdateringen - rapporter',0),(131280,3647,'it','Inserimento/aggiornamento - report di inventario',0),(131281,3647,'tl','',0),(131282,3647,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(131283,3647,'hi','à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿/à¤…à¤¦à¥à¤¯à¤¤à¤¨ - à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(131284,3647,'ms','Kemasukan/Kemaskini inventori - Laporan',0),(131285,3647,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø®Ø²ÙˆÙ†-Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ±',0),(131286,3647,'fr','Lâ€™inventaire saisie/mise Ã  jour - rapports',0),(131287,3647,'jp','åœ¨åº«ã?®ã‚¨ãƒ³ãƒˆãƒªãƒ¼/æ›´æ–°ãƒ¼ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(131288,3647,'pt','Entrada/atualizaÃ§Ã£o - relatÃ³rios de inventÃ¡rio',0),(131289,3647,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐºÐ»Ð°Ð´Ð° - Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹',0),(131290,3647,'es','Inventario Introducir/Actualizar - Informes',0),(131291,3647,'de','Inventar-Eintrag/Update - Berichte',0),(131292,3647,'en','Inventory Entry/Update - Reports',0),(131293,3648,'is','',0),(131294,3648,'dr','Ù„ÙŠØ³Øª ØµÙˆØ±Øª Ù…ÙˆØ§Ø¯ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131295,3648,'pr','Ù„ÙŠØ³Øª ØµÙˆØ±Øª Ù…ÙˆØ§Ø¯ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131296,3648,'tr','Stok maddesi Ã¼rÃ¼n malzeme listesi',0),(131297,3648,'pl','Spis pozycji Bill Lista materiaÅ‚Ã³w',0),(131298,3648,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚ Ð½Ð° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸Ñ‚Ðµ ÑÐ¿Ð¸ÑÑŠÐº',0),(131299,3648,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ø¨Ù„ Ú©Û’ Ù…ÙˆØ§Ø¯ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(131300,3648,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð‘Ð¸Ð» Ð»Ð¸ÑÑ‚Ðµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð°',0),(131301,3648,'vi','Danh SÃ¡ch HÃ³a ÄÆ¡n NguyÃªn Váº­t Liá»‡u Cá»§a HÃ ng hÃ³a',0),(131302,3648,'af','Inventaris Item Bill of Materials Lys',0),(131303,3648,'ro','Inventarul Bill element din lista de materiale',0),(131304,3648,'et','BOM-ide nimekiri',0),(131305,3648,'si','Zaloge artikla Bill seznama materialov',0),(131306,3648,'ba','Bill persediaan Item daftar bahan',0),(131307,3648,'nl','Inventaris Item Bill van materialen lijst',0),(131308,3648,'fi','Varaston nimikkeen tuoterakenteen luettelo',0),(131309,3648,'no','Lageret varen Bill av materiale',0),(131310,3648,'da','Lager vare Bill materialer liste',0),(131311,3648,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ë¹Œ ìž¬ë£Œ ëª©ë¡',0),(131312,3648,'he','×ž×œ××™ ×‘×™×œ ×¤×¨×™×˜ ×¨×©×™×ž×”',0),(131313,3648,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Ï„Î¿Ï… ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï… Ï„Ï‰Î½ Ï…Î»Î¹ÎºÏŽÎ½',0),(131314,3648,'zh','åº“å­˜ç‰©å“æ¡ä¾‹è‰æ¡ˆçš„ææ–™æ¸…å•\r\n',0),(131315,3648,'sv','Inventering objektet Bill lista',0),(131316,3648,'it','Inventario voce distinta elenco materiali',0),(131317,3648,'tl','',0),(131318,3648,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3636;&#3621;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3623;&#3633;&#3605;&#3606;&#3640;&#3',0),(131319,3648,'hi','à¤®à¤¾à¤² à¤¸à¥‚à¤šà¥€ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¬à¤¿à¤²',0),(131320,3648,'ms','Bil Item inventori senarai bahan-bahan',0),(131321,3648,'ar','ÙØ§ØªÙˆØ±Ø© Ø¨Ù†Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù…Ù† Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ§Ø¯',0),(131322,3648,'fr','Bill point l\'inventaire de la liste du matÃ©riel',0),(131323,3648,'jp','æ??æ–™ãƒªã‚¹ãƒˆã?®åœ¨åº«å“?ç›®è«‹æ±‚æ›¸',0),(131324,3648,'pt','Bill de inventÃ¡rio Item de lista de materiais',0),(131325,3648,'ru','Ð‘Ð¸Ð»Ð» Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿ÑƒÐ½ÐºÑ‚ Ð¿ÐµÑ€ÐµÑ‡Ð½Ñ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð²',0),(131326,3648,'es','Lista de Recibo de Materiales de Item de Inventario',0),(131327,3648,'de','Inventar Item StÃ¼cklisten StÃ¼ckliste',0),(131328,3648,'en','Inventory Item Bill Of Materials List',0),(131329,3649,'is','',0),(131330,3649,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ§Ø±ÙŠØ®ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131331,3649,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ§Ø±ÙŠØ®ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131332,3649,'tr','Stok Ã¶ÄŸesi ayrÄ±ntÄ±lÄ± geÃ§miÅŸini raporlarÄ±',0),(131333,3649,'pl','Raporty historia detal element zapasÃ³w',0),(131334,3649,'bg','Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ¸ Ð·Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° ÑÐºÐ»Ð°Ð´ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸',0),(131335,3649,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ ØªÙØµÛŒÙ„ ØªØ§Ø±ÛŒØ® Ø±Ù¾ÙˆØ±Ù¹ÛŒÚº',0),(131336,3649,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð´ÐµÑ‚Ð°Ñ™ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(131337,3649,'vi','BÃ¡o CÃ¡o Lá»‹ch Sá»­ Chi Tiáº¿t HÃ ng hÃ³a',0),(131338,3649,'af','Voorraaditem Detail Geskiedkundige Verslae',0),(131339,3649,'ro','Inventarul element detaliu istoria rapoarte',0),(131340,3649,'et','Varude Ã¼ksikasjalik ajalugu Kaubaaruanded',0),(131341,3649,'si','Zaloge artikla podrobno zgodovino poroÄil',0),(131342,3649,'ba','Persediaan Item Detail sejarah laporan',0),(131343,3649,'nl','Voorraadrapporten Item Detail geschiedenis',0),(131344,3649,'fi','Varaston nimikkeen yksityiskohtaisia raportteja',0),(131345,3649,'no','Lageret varen detaljert kjÃ¸pshistorikk',0),(131346,3649,'da','Lagerrapporter vare detaljer historie',0),(131347,3649,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ì„¸ë¶€ ì •ë³´ ë‚´ì—­ ë³´ê³ ì„œ',0),(131348,3649,'he','×ž×œ××™ ×¤×¨×™×˜ ×¤×™×¨×•×˜ ×”×™×¡×˜×•×¨×™×™×ª ×“×•×—×•×ª',0),(131349,3649,'el','Î‘Î½Î±Ï†Î¿ÏÎ­Ï‚ Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÎ¿Ï Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(131350,3649,'zh','åº“å­˜é¡¹ç›®è¯¦ç»†åŽ†å²æŠ¥å‘Š\r\n',0),(131351,3649,'sv','Inventarierapporter objekt detalj historia',0),(131352,3649,'it','Rapporti di inventario elemento dettaglio storia',0),(131353,3649,'tl','',0),(131354,3649,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3588;&#3623;&#3634;&#3617;&#3648;&#3611;&#3655;&#3609;&#3617;&#3634;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3',0),(131355,3649,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(131356,3649,'ms','Inventori butiran terperinci sejarah laporan',0),(131357,3649,'ar','ØªÙ‚Ø§Ø±ÙŠØ± ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙØµÙŠÙ„ Ø¹Ù†ØµØ± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(131358,3649,'fr','Rapports d\'inventaire point dÃ©tail histoire',0),(131359,3649,'jp','åœ¨åº«å“?ç›®è©³ç´°å±¥æ­´ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(131360,3649,'pt','RelatÃ³rios de histÃ³rico de detalhe de Item de inventÃ¡rio',0),(131361,3649,'ru','ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹ Ð¾Ð± Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸',0),(131362,3649,'es','Informe de Historia de Inventario de Detalle de Items ',0),(131363,3649,'de','Element Detail Geschichte Inventurberichte',0),(131364,3649,'en','Inventory Item Detail History Reports',0),(131365,3650,'is','',0),(131366,3650,'dr','Ù„ÙŠØ³Øª ØªÙˆØ²ÙŠØ¹ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131367,3650,'pr','Ù„ÙŠØ³Øª ØªÙˆØ²ÙŠØ¹ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131368,3650,'tr','Envanter madde daÄŸÄ±tÄ±m listesi',0),(131369,3650,'pl','Spis pozycji listy dystrybucyjnej',0),(131370,3650,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð·Ð° Ñ€Ð°Ð·Ð¿Ñ€Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(131371,3650,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ø¨Ø§Ù†Ù¹ ÙÛØ±Ø³Øª',0),(131372,3650,'sr','Ð›Ð¸ÑÑ‚Ð° Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(131373,3650,'vi','Danh SÃ¡ch PhÃ¢n Phá»‘i HÃ ng hÃ³a',0),(131374,3650,'af','Voorraaditem Verspreidingslys',0),(131375,3650,'ro','Inventarul element listÄƒ de distribuire',0),(131376,3650,'et','Lao kirje leviloend',0),(131377,3650,'si','Zaloge artikla distribucijski seznam',0),(131378,3650,'ba','Daftar distribusi persediaan barang',0),(131379,3650,'nl','Object distributie inventarislijst',0),(131380,3650,'fi','Varaston nimikkeen jakeluluettelo',0),(131381,3650,'no','Lageret varen distribusjonsliste',0),(131382,3650,'da','Lager vare distributionsliste',0),(131383,3650,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ë©”ì¼ ê·¸ë£¹',0),(131384,3650,'he','×¨×©×™×ž×ª ×”×ª×¤×•×¦×” ×©×œ ×¤×¨×™×˜ ×ž×œ××™',0),(131385,3650,'el','Î›Î¯ÏƒÏ„Î± Î´Î¹Î±Î½Î¿Î¼Î®Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(131386,3650,'zh','åº“å­˜ç‰©å“åˆ†å‘åˆ—è¡¨\r\n',0),(131387,3650,'sv','Inventering objektet distributionslista',0),(131388,3650,'it','Elenco di distribuzione di elementi di inventario',0),(131389,3650,'tl','',0),(131390,3650,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3649;&#3592;&#3585;&#3592;&#3656;&#3634;&#3618;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(131391,3650,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤¤à¤°à¤£ à¤¸à¥‚à¤šà¥€',0),(131392,3650,'ms','Senarai edaran Item inventori',0),(131393,3650,'ar','Ù‚Ø§Ø¦Ù…Ø© ØªÙˆØ²ÙŠØ¹ Ø¹Ù†ØµØ± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(131394,3650,'fr','Liste Distribution d\'Ã©lÃ©ments de l\'inventaire',0),(131395,3650,'jp','åœ¨åº«å“?ç›®é…?å¸ƒåŒºåˆ†è¡¨',0),(131396,3650,'pt','Lista de distribuiÃ§Ã£o de itens de inventÃ¡rio',0),(131397,3650,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² ÑÐ¿Ð¸ÑÐºÐ° Ñ€Ð°ÑÑÑ‹Ð»ÐºÐ¸',0),(131398,3650,'es','Item de Inventario Lista de DistribuciÃ³n',0),(131399,3650,'de','Inventar Item Verteilerliste',0),(131400,3650,'en','Inventory Item Distribution List',0),(131401,3651,'is','',0),(131402,3651,'dr','/ Ø¢Ù¾Ø¯ÛŒØª  Ø¬Ù†Ø³ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³',0),(131403,3651,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131404,3651,'tr','Envanter madde giriÅŸ/gÃ¼ncelleme',0),(131405,3651,'pl','Wpis/aktualizacja spisu przedmiotÃ³w',0),(131406,3651,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð·Ð°Ð¿Ð¸Ñ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(131407,3651,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(131408,3651,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° /Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(131409,3651,'vi','Nháº­p/Cáº­p Nháº­t HÃ ng HÃ³a',0),(131410,3651,'af','Inventaris Item Inskrying/Opdateer',0),(131411,3651,'ro','Intrare/actualizarea inventarului element',0),(131412,3651,'et','Lao kauba kanne/uuendamine',0),(131413,3651,'si','Element vnos/posodobitev',0),(131414,3651,'ba','Persediaan Item catatan/Update',0),(131415,3651,'nl','Inventaris Item item/Update',0),(131416,3651,'fi','Varaston kohteen merkintÃ¤/pÃ¤ivitys',0),(131417,3651,'no','Lageret varen oppfÃ¸ring/Oppdater',0),(131418,3651,'da','Lageropdateringen vare post /',0),(131419,3651,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© í•­ëª©/ì—…ë°ì´íŠ¸',0),(131420,3651,'he','×¢×¨×š ×¤×¨×™×˜ ×ž×œ××™/×¢×“×›×•×Ÿ',0),(131421,3651,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(131422,3651,'zh','åº“å­˜ç‰©å“è¾“å…¥/æ›´æ–°\r\n',0),(131423,3651,'sv','Inventering objektet post/uppdatera',0),(131424,3651,'it','Elemento voce/aggiornamento',0),(131425,3651,'tl','',0),(131426,3651,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(131427,3651,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(131428,3651,'ms','Kemaskini/Masuk Inventori Item',0),(131429,3651,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« ØµÙ†Ù Ù…Ø®Ø²ÙˆÙ†',0),(131430,3651,'fr','Saisie/mise Ã  jour de lâ€™inventaire point',0),(131431,3651,'jp','åœ¨åº«å“?ç›®ã?®ã‚¨ãƒ³ãƒˆãƒªãƒ¼/æ›´æ–°',0),(131432,3651,'pt','Item de estoque entrada/atualizaÃ§Ã£o',0),(131433,3651,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿ÑƒÐ½ÐºÑ‚ Ð·Ð°Ð¿Ð¸ÑÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(131434,3651,'es','Item de Inventario Introducir/Actualizar',0),(131435,3651,'de','Inventar Element Eintrag/Update',0),(131436,3651,'en','Inventory Item Entry/Update',0),(131437,3652,'is','',0),(131438,3652,'dr','Ø«Ø¨Øª Ù‚ÙŠÙ…Øª ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131439,3652,'pr','Ø«Ø¨Øª Ù‚ÙŠÙ…Øª ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131440,3652,'tr','Envanter madde fiyat giriÅŸi',0),(131441,3652,'pl','Spis pozycji cena wejÅ›cia',0),(131442,3652,'bg','Ð¡ÐºÐ»Ð°Ð´ Ñ†ÐµÐ½Ð° Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(131443,3652,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ù‚ÛŒÙ…Øª Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(131444,3652,'sr','Ð¦ÐµÐ½Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(131445,3652,'vi','Nháº­p ÄÆ¡n GiÃ¡ HÃ ng HÃ³a',0),(131446,3652,'af','Voorraaditem Prysinskrywings',0),(131447,3652,'ro','Inventarul element Pret intrare',0),(131448,3652,'et','Lao kaubakande hind',0),(131449,3652,'si','Vnos cene artikla zaloge',0),(131450,3652,'ba','Persediaan Item harga entri',0),(131451,3652,'nl','Voorraad prijs artikelpost',0),(131452,3652,'fi','Hinta nimiketapahtuman varaston',0),(131453,3652,'no','Lageret varen registrering',0),(131454,3652,'da','Lager pris varepost',0),(131455,3652,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ê°€ê²© í•­ëª©',0),(131456,3652,'he','×ž×¦××™ ×¤×¨×™×˜ ×ž×—×™×¨ ×”×›× ×™×¡×”',0),(131457,3652,'el','Î•Î³Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(131458,3652,'zh','åº“å­˜é¡¹ç›®ä»·æ ¼æ¡ç›®\r\n',0),(131459,3652,'sv','Inventering artikeltransaktionen pris',0),(131460,3652,'it','Inventario prezzo MOV',0),(131461,3652,'tl','',0),(131462,3652,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(131463,3652,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤•à¥€à¤®à¤¤ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(131464,3652,'ms','Kemasukan harga Item inventori',0),(131465,3652,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø³Ø¹Ø± Ø§Ù„Ø¨Ù†Ø¯ ÙÙŠ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(131466,3652,'fr','Prix saisie de l\'inventaire',0),(131467,3652,'jp','åœ¨åº«å“?ç›®ä¾¡æ ¼ã‚¨ãƒ³ãƒˆãƒªãƒ¼',0),(131468,3652,'pt','InventÃ¡rio Item preÃ§o entrada',0),(131469,3652,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ñ†ÐµÐ½Ð° Ð²Ñ…Ð¾Ð´Ð°',0),(131470,3652,'es','Item de Inventario Entrada de Precio',0),(131471,3652,'de','Artikel Preis Lagerposten',0),(131472,3652,'en','Inventory Item Price Entry',0),(131473,3653,'is','',0),(131474,3653,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¶Ø¹ÙŠØª ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131475,3653,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¶Ø¹ÙŠØª ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131476,3653,'tr','Stok Ã¶ÄŸesi durum raporu',0),(131477,3653,'pl','Raport o stanie zapasÃ³w towaru',0),(131478,3653,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(131479,3653,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ø­Ø§Ù„Øª Ø±Ù¾ÙˆØ±Ù¹',0),(131480,3653,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÑÑ‚Ð°Ñ‚ÑƒÑÑƒ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(131481,3653,'vi','BÃ¡o CÃ¡o TÃ¬nh Tráº¡ng HÃ ng HÃ³a',0),(131482,3653,'af','Voorraaditem Status Verslag',0),(131483,3653,'ro','Raport cu element de inventar',0),(131484,3653,'et','Lao kirje oleku aruanne',0),(131485,3653,'si','PoroÄilo o stanju zaloge artikla',0),(131486,3653,'ba','Laporan Status persediaan barang',0),(131487,3653,'nl','Rapport van de Status van de Item inventaris',0),(131488,3653,'fi','Varaston nimikkeen tila-raportti',0),(131489,3653,'no','Lageret varen statusrapport',0),(131490,3653,'da','Lager vare statusrapport',0),(131491,3653,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ìƒíƒœ ë³´ê³ ì„œ',0),(131492,3653,'he','×“×•×— ×ž×¦×‘ ×©×œ ×¤×¨×™×˜ ×ž×œ××™',0),(131493,3653,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(131494,3653,'zh','åº“å­˜é¡¹ç›®çŠ¶æ€æŠ¥å‘Š\r\n',0),(131495,3653,'sv','Inventering objektet statusrapport',0),(131496,3653,'it','Rapporto stato elemento di inventario',0),(131497,3653,'tl','',0),(131498,3653,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3626;&#3606;&#3634;&#3609;&#3632;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(131499,3653,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(131500,3653,'ms','Laporan Status Item inventori',0),(131501,3653,'ar','ØªÙ‚Ø±ÙŠØ± Ø­Ø§Ù„Ø© Ø¹Ù†ØµØ± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(131502,3653,'fr','L\'inventaire Item Status Report',0),(131503,3653,'jp','åœ¨åº«å“?ç›®çŠ¶æ³?ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(131504,3653,'pt','RelatÃ³rio de Status de Item de inventÃ¡rio',0),(131505,3653,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿ÑƒÐ½ÐºÑ‚ ÐžÑ‚Ñ‡ÐµÑ‚',0),(131506,3653,'es','Item de Inventario Informe de Status',0),(131507,3653,'de','Inventar Item-Status-Report',0),(131508,3653,'en','Inventory Item Status Report',0),(131509,3654,'is','',0),(131510,3654,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø®Ù„Ø§ØµÙ‡ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131511,3654,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø®Ù„Ø§ØµÙ‡ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131512,3654,'tr','Stok Ã¶ÄŸesi Ã–zet listeler',0),(131513,3654,'pl','Spis pozycji podsumowanie list',0),(131514,3654,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½Ð¸ ÑÐ¿Ð¸ÑÑŠÑ†Ð¸',0),(131515,3654,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ø®Ù„Ø§ØµÛ ÙÛØ±Ø³ØªÛŒÚº',0),(131516,3654,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ° Ð»Ð¸ÑÑ‚Ð°Ð¼Ð°',0),(131517,3654,'vi','Danh SÃ¡ch Tá»•ng Há»£p HÃ ng HÃ³a',0),(131518,3654,'af','Voorraaditem Opsommingslyste',0),(131519,3654,'ro','Listele de inventar element Rezumat',0),(131520,3654,'et','Varude Ã¼ksuse KokkuvÃµte nimekirjad',0),(131521,3654,'si','Zaloge artikla Povzetek sezname',0),(131522,3654,'ba','Daftar Item ringkasan persediaan',0),(131523,3654,'nl','Object samenvatting inventarislijsten',0),(131524,3654,'fi','Varaston tuotteen Yhteenveto-luettelot',0),(131525,3654,'no','Lageret varen Sammendrag lister',0),(131526,3654,'da','Lager vare sammenfattende lister',0),(131527,3654,'ko','ìž¬ê³  í•­ëª© ìš”ì•½ ëª©ë¡',0),(131528,3654,'he','×¨×©×™×ž×•×ª ×ž×¦××™ ×¤×¨×™×˜ ×¡×™×›×•×',0),(131529,3654,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÏ…Î½Î¿Ï€Ï„Î¹ÎºÎ¿Î¯ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(131530,3654,'zh','åº“å­˜é¡¹ç›®æ‘˜è¦åˆ—è¡¨\r\n',0),(131531,3654,'sv','Inventering objektet Sammanfattning listor',0),(131532,3654,'it','Elenchi voce riepilogo inventario',0),(131533,3654,'tl','',0),(131534,3654,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(131535,3654,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(131536,3654,'ms','Inventori Senarai Item ringkasan',0),(131537,3654,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø¬Ø±Ø¯ Ø§Ù„Ø¨Ù†Ø¯ Ù…ÙˆØ¬Ø²Ø©',0),(131538,3654,'fr','Inventaires sommaires point',0),(131539,3654,'jp','åœ¨åº«å“?ç›®ã‚µãƒžãƒªãƒ¼ãƒªã‚¹ãƒˆ',0),(131540,3654,'pt','Listas de Item Resumo do inventÃ¡rio',0),(131541,3654,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿ÑƒÐ½ÐºÑ‚ ÑÐ²Ð¾Ð´Ð½Ñ‹Ðµ ÑÐ¿Ð¸ÑÐºÐ¸',0),(131542,3654,'es','Item de Inventario Lista de Resumenes',0),(131543,3654,'de','Artikel Zusammenfassung Bestandslisten',0),(131544,3654,'en','Inventory Item Summary Lists',0),(131545,3655,'is','',0),(131546,3655,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù…ØµØ±Ù ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131547,3655,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù…ØµØ±Ù ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131548,3655,'tr','Stok maddesi kullanÄ±m raporlarÄ±',0),(131549,3655,'pl','Raporty uÅ¼ycia zapasÃ³w towaru',0),(131550,3655,'bg','ÐžÑ‚Ñ‡ÐµÑ‚Ð¸ Ð·Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(131551,3655,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(131552,3655,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸ Ð¾ ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÑƒ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(131553,3655,'vi','BÃ¡o CÃ¡o TÃ¬nh HÃ¬nh Sá»­ Dá»¥ng HÃ ng',0),(131554,3655,'af','Voorraaditem Gebruiksverslae',0),(131555,3655,'ro','Inventarul element utilizare rapoarte',0),(131556,3655,'et','Lao kirje kasutusaruanded',0),(131557,3655,'si','Uporaba poroÄila zaloge artiklov',0),(131558,3655,'ba','Persediaan Item penggunaan laporan',0),(131559,3655,'nl','Item Gebruik voorraadrapporten',0),(131560,3655,'fi','Varaston nimikkeen kÃ¤yttÃ¶raportit',0),(131561,3655,'no','Lageret varen bruksrapporter',0),(131562,3655,'da','Lager vare anvendelsesrapporter',0),(131563,3655,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ì‚¬ìš© í˜„í™© ë³´ê³ ì„œ',0),(131564,3655,'he','×“×•×—×•×ª ×©×™×ž×•×© ×¤×¨×™×˜ ×ž×œ××™',0),(131565,3655,'el','Î•ÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ Ï‡ÏÎ®ÏƒÎ·Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(131566,3655,'zh','åº“å­˜ç‰©å“ä½¿ç”¨æƒ…å†µæŠ¥å‘Š\r\n',0),(131567,3655,'sv','Inventering objektet anvÃ¤ndningsrapporter',0),(131568,3655,'it','Report di utilizzo elemento di inventario',0),(131569,3655,'tl','',0),(131570,3655,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(131571,3655,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤‰à¤ªà¤¯à¥‹à¤— à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(131572,3655,'ms','Laporan-laporan penggunaan Item inventori',0),(131573,3655,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ø¥Ø³ØªØ¹Ù…Ø§Ù„ Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(131574,3655,'fr','Rapports d\'utilisation de l\'inventaire du point',0),(131575,3655,'jp','åœ¨åº«å“?ç›®ä½¿ç”¨ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(131576,3655,'pt','RelatÃ³rios de uso do Item de inventÃ¡rio',0),(131577,3655,'ru','ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹ Ð¾Ð± Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(131578,3655,'es','Item de Inventario Informes de Uso',0),(131579,3655,'de','Element Verwendung Inventurberichte',0),(131580,3655,'en','Inventory Item Usage Reports',0),(131581,3656,'is','',0),(131582,3656,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131583,3656,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(131584,3656,'tr','Stok birimi',0),(131585,3656,'pl','Spis jednostek',0),(131586,3656,'bg','Ð ÐµÐºÐ»Ð°Ð¼Ð½Ð¸ Ð¼ÐµÑÑ‚Ð°',0),(131587,3656,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ ÛŒÙˆÙ†Ù¹Ø³',0),(131588,3656,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(131589,3656,'vi','ÄÆ¡n Vá»‹ HÃ ng HÃ³a',0),(131590,3656,'af','Inventaris Eenhede',0),(131591,3656,'ro','UnitÄƒÅ£ile de stoc',0),(131592,3656,'et','LaoÃ¼hikute',0),(131593,3656,'si','Inventar enota',0),(131594,3656,'ba','Unit persediaan',0),(131595,3656,'nl','Eenheden van de inventaris',0),(131596,3656,'fi','VarastoyksikÃ¶issÃ¤',0),(131597,3656,'no','Lagerenheter',0),(131598,3656,'da','Lagerenheder',0),(131599,3656,'ko','ìž¬ê³  ë‹¨ìœ„',0),(131600,3656,'he','×™×—×™×“×•×ª ×ž×œ××™',0),(131601,3656,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(131602,3656,'zh','åº“å­˜å•ä½\r\n',0),(131603,3656,'sv','Lagerenheter',0),(131604,3656,'it','UnitÃ  di inventario',0),(131605,3656,'tl','',0),(131606,3656,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(131607,3656,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(131608,3656,'ms','Unit inventori',0),(131609,3656,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(131610,3656,'fr','UnitÃ©s de stock',0),(131611,3656,'jp','åœ¨åº«å?˜ä½?',0),(131612,3656,'pt','Unidades de estoque',0),(131613,3656,'ru','Ð•Ð´',0),(131614,3656,'es','unidades de Inventario',0),(131615,3656,'de','Lagereinheiten',0),(131616,3656,'en','Inventory Units',0),(131617,3657,'is','',0),(131618,3657,'dr','Ø§Ø±Ø²Ø´ Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù„Ø§ ',0),(131619,3657,'pr','Ø§Ø±Ø²Ø´ Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù„Ø§ ',0),(131620,3657,'tr','Maddenin deÄŸerleme',0),(131621,3657,'pl','Przedmiot wyceny',0),(131622,3657,'bg','ÐžÑ†ÐµÐ½ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(131623,3657,'ur','Ø´Û’ Ú©Ø§ Ù…ÙˆÙ„',0),(131624,3657,'sr','ÐžÐ±Ñ€Ð°Ñ‡ÑƒÐ½ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(131625,3657,'vi','Äá»‹nh GiÃ¡ HÃ ng HÃ³a',0),(131626,3657,'af','Item Waardebepaling',0),(131627,3657,'ro','Elementul evaluare',0),(131628,3657,'et','Ãœksuse hindamine',0),(131629,3657,'si','Element vrednotenja',0),(131630,3657,'ba','Item penilaian',0),(131631,3657,'nl','Item waardering',0),(131632,3657,'fi','Nimikkeen arvostus',0),(131633,3657,'no','Elementet verdivurdering',0),(131634,3657,'da','Vare vÃ¦rdiansÃ¦ttelse',0),(131635,3657,'ko','í•­ëª© í‰ê°€',0),(131636,3657,'he','×”×¢×¨×›×ª ×©×•×•×™ ×”×¤×¨×™×˜',0),(131637,3657,'el','Î‘Ï€Î¿Ï„Î¯Î¼Î·ÏƒÎ·Ï‚',0),(131638,3657,'zh','é¡¹ç›®è¯„ä¼°\r\n',0),(131639,3657,'sv','Objektet vÃ¤rdering',0),(131640,3657,'it','Elemento di valutazione',0),(131641,3657,'tl','',0),(131642,3657,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3619;&#3634;&#3588;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(131643,3657,'hi','à¤®à¤¦ à¤•à¥‡ à¤®à¥‚à¤²à¥à¤¯à¤¾à¤‚à¤•à¤¨',0),(131644,3657,'ms','Item penilaian',0),(131645,3657,'ar','Ø¹Ù†ØµØ± Ø§Ù„ØªÙ‚ÙŠÙŠÙ…',0),(131646,3657,'fr','Ã‰valuation de l\'Ã©lÃ©ment',0),(131647,3657,'jp','å“?ç›®è©•ä¾¡',0),(131648,3657,'pt','Item de avaliaÃ§Ã£o',0),(131649,3657,'ru','ÐžÑ†ÐµÐ½ÐºÐ° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(131650,3657,'es','ValuaciÃ³n de Item',0),(131651,3657,'de','Artikel Bewertung',0),(131652,3657,'en','Item Valuation',0),(131653,3658,'is','',0),(131654,3658,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø§Ø±Ø²Ø´ Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(131655,3658,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø§Ø±Ø²Ø´ Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(131656,3658,'tr','Stok Ã¶ÄŸesi deÄŸerleme raporu',0),(131657,3658,'pl','Raporcie wyceny zapasÃ³w towaru',0),(131658,3658,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð½Ð° Ð¾Ñ†ÐµÐ½ÐºÐ° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(131659,3658,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ù…ÙˆÙ„ Ø±Ù¾ÙˆØ±Ù¹',0),(131660,3658,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð° Ð¾ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ñƒ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(131661,3658,'vi','BÃ¡o CÃ¡o Äá»‹nh GiÃ¡ HÃ ng HÃ³a Theo Danh Má»¥c',0),(131662,3658,'af','Voorraaditem Waardasie Verslag',0),(131663,3658,'ro','Raport de evaluare stocuri element',0),(131664,3658,'et','Lao kirje hindamisakt',0),(131665,3658,'si','PoroÄilu vrednotenje zaloge artikla',0),(131666,3658,'ba','Laporan penilaian persediaan barang',0),(131667,3658,'nl','Inventaris Item schattingsverslag',0),(131668,3658,'fi','Varaston nimikkeen arvostus-raportti',0),(131669,3658,'no','Elementet verdivurdering kontorinnholdsrapport',0),(131670,3658,'da','Lagerrapport vare vÃ¦rdiansÃ¦ttelse',0),(131671,3658,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© í‰ê°€ ë³´ê³ ì„œ',0),(131672,3658,'he','×“×•×— ×©×•×•×™ ×ž×œ××™ ×¤×¨×™×˜×™×',0),(131673,3658,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î±Ï€Î¿Ï„Î¯Î¼Î·ÏƒÎ·Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(131674,3658,'zh','åº“å­˜é¡¹ç›®è¯„ä¼°æŠ¥å‘Š\r\n',0),(131675,3658,'sv','Inventering objektet vÃ¤rderingsrapport',0),(131676,3658,'it','Rapporto di valutazione elemento di inventario',0),(131677,3658,'tl','',0),(131678,3658,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3619;&#3634;&#3588;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3',0),(131679,3658,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤®à¥‚à¤²à¥à¤¯à¤¾à¤‚à¤•à¤¨ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(131680,3658,'ms','Inventori Item penilaian Laporan',0),(131681,3658,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªÙ‚ÙŠÙŠÙ… Ø¹Ù†ØµØ± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(131682,3658,'fr','Rapport d\'Ã©valuation de l\'inventaire du point',0),(131683,3658,'jp','åœ¨åº«å“?ç›®è©•ä¾¡ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(131684,3658,'pt','RelatÃ³rio de avaliaÃ§Ã£o do inventÃ¡rio Item',0),(131685,3658,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð½Ð¾Ð¹ Ð¾Ñ†ÐµÐ½ÐºÐ¸',0),(131686,3658,'es','Item de Inventario Informe de ValuaciÃ³n',0),(131687,3658,'de','Artikel Bewertung Inventarbericht',0),(131688,3658,'en','Inventory Item Valuation Report',0),(131689,3659,'is','',0),(131690,3659,'dr','ØµØ¯ÙˆØ± ÙØ§ÙƒØªÙˆØ± â€“Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(131691,3659,'pr','ØµØ¯ÙˆØ± ÙØ§ÙƒØªÙˆØ± â€“Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(131692,3659,'tr','Faturalama - Ã¶demeler satÄ±ÅŸ vergisi raporlarÄ±nÄ± aldÄ±-',0),(131693,3659,'pl','Fakturowanie - pÅ‚atnoÅ›ci otrzymanych - raporty podatkowe',0),(131694,3659,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ - Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ - Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(131695,3659,'ur','Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯ - Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø±Ù¾ÙˆØ±Ù¹ÛŒÚº Ù…Ù„ÛŒ-',0),(131696,3659,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ - Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾ - Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(131697,3659,'vi','Ra hÃ³a Ä‘Æ¡n - ÄÃ£ nháº­n tiá»n - HÃ³a Ä‘Æ¡n thuáº¿ bÃ¡n hÃ ng',0),(131698,3659,'af','Fakturering - Betalings Ontvang - Verkoopsbelasting Verslae',0),(131699,3659,'ro','Facturare - plÄƒÅ£i primite - rapoarte de impozitul pe vÃ¢nzÄƒri',0),(131700,3659,'et','Arveldamine - laekunud - kÃ¤ibemaksuaruandeid',0),(131701,3659,'si','Fakturiranje - prejeta - plaÄila prometnega davka poroÄila',0),(131702,3659,'ba','Faktur - pembayaran yang diterima - laporan pajak penjualan',0),(131703,3659,'nl','Facturatie - betalingen ontvangen - Sales Tax rapporten',0),(131704,3659,'fi','Laskutus - maksut saatu - alv-raportit',0),(131705,3659,'no','Fakturering - betalinger mottatt - mva-rapporter',0),(131706,3659,'da','Fakturering - betalinger modtaget - momsrapporter',0),(131707,3659,'ko','ì¸ë³´ì´ìŠ¤-ì§€ë¶ˆ ë°›ì€-íŒë§¤ ì„¸ê¸ˆ ë³´ê³ ì„œ',0),(131708,3659,'he','×”×¤×§×ª ×—×©×‘×•× ×™×ª - ×ª×©×œ×•×ž×™× ×©×”×ª×§×‘×œ×• - ×“×•×—×•×ª ×ž×¢ ×ž',0),(131709,3659,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· - Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… Î­Î»Î±Î²Îµ - ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(131710,3659,'zh','è´§å“è®¡ä»·- ä»˜æ¬¾æ”¶åˆ° -é”€å”®ç¨Žçš„æŠ¥å‘Š\r\n',0),(131711,3659,'sv','Fakturering - betalningar - momsrapporter',0),(131712,3659,'it','Fatturazione - pagamenti ricevuti - report IVA',0),(131713,3659,'tl','',0),(131714,3659,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657; - &#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609; - &#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3616;&#3634;&#3625;&#3637;&#35',0),(131715,3659,'hi','à¤šà¤¾à¤²à¤¾à¤¨ - à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ - à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥à¤¸',0),(131716,3659,'ms','Invois - pembayaran yang diterima - laporan cukai jualan',0),(131717,3659,'ar','Ø§Ù„ÙÙˆØªØ±Ø©-Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…ØªÙ„Ù‚Ø§Ø©-ØªÙ‚Ø§Ø±ÙŠØ± Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(131718,3659,'fr','Facturation - paiements reÃ§us - rapports de taxe de vente',0),(131719,3659,'jp','è«‹æ±‚ä¸­ãƒ¼å?—é ˜æ¸ˆæ”¯æ‰•ãƒ¼ã‚»ãƒ¼ãƒ«ã‚¹ç¨Žãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(131720,3659,'pt','FacturaÃ§Ã£o - pagamentos recebidos - relatÃ³rios de imposto sobre vendas',0),(131721,3659,'ru','Ð’Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð² - Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ - Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹',0),(131722,3659,'es','FacturaciÃ³n - Pagos Recibidos - Informes de IVA',0),(131723,3659,'de','Fakturierung - Zahlungen empfangen - MehrwertsteuererklÃ¤rungen',0),(131724,3659,'en','Invoicing - Payments Received - Sales Tax Reports',0),(131725,3660,'is','',0),(131726,3660,'dr','ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ù„Ø§',0),(131727,3660,'pr','ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ù„Ø§',0),(131728,3660,'tr','Madde etkinliÄŸi',0),(131729,3660,'pl','Przedmiot dziaÅ‚alnoÅ›ci',0),(131730,3660,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(131731,3660,'ur','Ø´Û’ Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(131732,3660,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(131733,3660,'vi','Hoáº¡t Ä‘á»™ng hÃ ng',0),(131734,3660,'af','Item Aktiwiteit',0),(131735,3660,'ro','Element activitate',0),(131736,3660,'et','Tootega seotud tegevused',0),(131737,3660,'si','Element dejavnosti',0),(131738,3660,'ba','Aktivitas item',0),(131739,3660,'nl','Item activiteit',0),(131740,3660,'fi','Nimikkeen tehtÃ¤vÃ¤',0),(131741,3660,'no','Vare aktivitet',0),(131742,3660,'da','Vare aktivitet',0),(131743,3660,'ko','í•­ëª© í™œë™',0),(131744,3660,'he','×¤×¢×™×œ×•×ª ×¤×¨×™×˜',0),(131745,3660,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(131746,3660,'zh','é¡¹ç›®æ´»åŠ¨\r\n',0),(131747,3660,'sv','Aktiviteten objekt',0),(131748,3660,'it','Elemento attivitÃ ',0),(131749,3660,'tl','',0),(131750,3660,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3588;&#3621;&#3639;&#3656;&#3629;&#3609;&#3652;&#3627;&#3623;',0),(131751,3660,'hi','à¤†à¤‡à¤Ÿà¤® à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(131752,3660,'ms','Butiran aktiviti',0),(131753,3660,'ar','Ø¨Ù†Ø¯ Ø§Ù„Ù†Ø´Ø§Ø·',0),(131754,3660,'fr','ActivitÃ© de l\'ordre du jour',0),(131755,3660,'jp','å“?ç›®æ´»å‹•',0),(131756,3660,'pt','Item atividade',0),(131757,3660,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(131758,3660,'es','Item actividad',0),(131759,3660,'de','Element-AktivitÃ¤t',0),(131760,3660,'en','Item Activity',0),(131761,3661,'is','',0),(131762,3661,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(131763,3661,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(131764,3661,'tr','Madde kategorileri',0),(131765,3661,'pl','Kategorie towarÃ³w',0),(131766,3661,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(131767,3661,'ur','Ø´Û’ Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(131768,3661,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(131769,3661,'vi','Thá»ƒ loáº¡i hÃ ng',0),(131770,3661,'af','Item KategoriÃ«',0),(131771,3661,'ro','Articolul Categorii',0),(131772,3661,'et','Tootekategooriad',0),(131773,3661,'si','Kategorijah artiklov',0),(131774,3661,'ba','Kategori Item',0),(131775,3661,'nl','ArtikelcategorieÃ«n',0),(131776,3661,'fi','Nimikekategoriat',0),(131777,3661,'no','Kategorier',0),(131778,3661,'da','Varekategorier',0),(131779,3661,'ko','í•­ëª© ë²”ì£¼',0),(131780,3661,'he','×§×˜×’×•×¨×™×•×ª ×¤×¨×™×˜',0),(131781,3661,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ ÎµÎ¹Î´ÏŽÎ½',0),(131782,3661,'zh','é¡¹ç›®ç±»åˆ«\r\n',0),(131783,3661,'sv','Artikelkategorier',0),(131784,3661,'it','Articolo categorie',0),(131785,3661,'tl','',0),(131786,3661,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(131787,3661,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(131788,3661,'ms','Kategori item',0),(131789,3661,'ar','ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„ØµÙ†Ù',0),(131790,3661,'fr','CatÃ©gories d\'articles',0),(131791,3661,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(131792,3661,'pt','Categorias de item',0),(131793,3661,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(131794,3661,'es','Item CategorÃ­as',0),(131795,3661,'de','Positionstypen',0),(131796,3661,'en','Item Categories',0),(131797,3662,'is','',0),(131798,3662,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ§Ø±ÙŠØ®Ú†Ù‡  ÙƒØ§Ù„Ø§',0),(131799,3662,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ§Ø±ÙŠØ®Ú†Ù‡  ÙƒØ§Ù„Ø§',0),(131800,3662,'tr','Ã–ÄŸesi ayrÄ±ntÄ±lÄ± geÃ§miÅŸini',0),(131801,3662,'pl','Element szczegÃ³Å‚y historia',0),(131802,3662,'bg','Ð¥Ñ€Ð¾Ð½Ð¾Ð»Ð¾Ð³Ð¸Ñ Ð½Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(131803,3662,'ur','Ø´Û’ Ú©ÛŒ ØªÙØµÛŒÙ„ ØªØ§Ø±ÛŒØ®',0),(131804,3662,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð´ÐµÑ‚Ð°Ñ™Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(131805,3662,'vi','Lá»‹ch sá»­ chi tiáº¿t hÃ ng',0),(131806,3662,'af','Item Detailgeskiedenis',0),(131807,3662,'ro','Element detaliu istoria',0),(131808,3662,'et','Kauba Ã¼ksikasjalik ajalugu',0),(131809,3662,'si','Element podrobnosti zgodovino',0),(131810,3662,'ba','Item Detail sejarah',0),(131811,3662,'nl','Item Detail geschiedenis',0),(131812,3662,'fi','Kohteen yksityiskohdat historia',0),(131813,3662,'no','Elementhistorikk detaljer',0),(131814,3662,'da','Vare detaljer historie',0),(131815,3662,'ko','í•­ëª© ì„¸ë¶€ ì‚¬í•­ ê¸°ë¡',0),(131816,3662,'he','×¤×¨×™×˜ ×¤×™×¨×•×˜ ×”×™×¡×˜×•×¨×™×”',0),(131817,3662,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(131818,3662,'zh','é¡¹ç›®è¯¦ç»†çš„åŽ†å²\r\n',0),(131819,3662,'sv','Objektet detalj historia',0),(131820,3662,'it','Storia di dettaglio articolo',0),(131821,3662,'tl','',0),(131822,3662,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(131823,3662,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(131824,3662,'ms','Butiran terperinci sejarah',0),(131825,3662,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„ØªÙØ§ØµÙŠÙ„ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(131826,3662,'fr','DÃ©tail historique de l\'Ã©lÃ©ment',0),(131827,3662,'jp','å“?ç›®è©³ç´°å±¥æ­´',0),(131828,3662,'pt','HistÃ³rico de detalhes do item',0),(131829,3662,'ru','Ð”ÐµÑ‚Ð°Ð»ÑŒÐ½Ð°Ñ Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(131830,3662,'es','Detalle de Item Historia ',0),(131831,3662,'de','Detail Versionsgeschichte',0),(131832,3662,'en','Item Detail History',0),(131833,3663,'is','',0),(131834,3663,'dr','ØªÙˆØ²ÙŠØ¹ ÙƒØ§Ù„Ø§',0),(131835,3663,'pr','ØªÙˆØ²ÙŠØ¹ ÙƒØ§Ù„Ø§',0),(131836,3663,'tr','Madde daÄŸÄ±tÄ±m',0),(131837,3663,'pl','Element dystrybucji',0),(131838,3663,'bg','Ð¢Ð¾Ñ‡ÐºÐ° Ñ€Ð°Ð·Ð¿Ñ€Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ',0),(131839,3663,'ur','Ø´Û’ Ú©ÛŒ ØªÙ‚Ø³ÛŒÙ…',0),(131840,3663,'sr','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ†Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(131841,3663,'vi','PhÃ¢n phá»‘i hÃ ng',0),(131842,3663,'af','Item Verspreiding',0),(131843,3663,'ro','Element de distribuÅ£ie',0),(131844,3663,'et','HooldusÃ¼ksuse jaotuse',0),(131845,3663,'si','Element distribucijskega',0),(131846,3663,'ba','Distribusi barang',0),(131847,3663,'nl','Object distributie',0),(131848,3663,'fi','Tuotteen jakelu',0),(131849,3663,'no','Elementet distribusjon',0),(131850,3663,'da','Vare Distribution',0),(131851,3663,'ko','í•­ëª© ë°°í¬',0),(131852,3663,'he','×”×ª×¤×œ×’×•×ª ×¤×¨×™×˜',0),(131853,3663,'el','Î£Î·Î¼ÎµÎ¯Î¿ Î´Î¹Î±Î½Î¿Î¼Î®Ï‚',0),(131854,3663,'zh','é¡¹ç›®åˆ†å¸ƒ\r\n',0),(131855,3663,'sv','Artikel Distribution',0),(131856,3663,'it','Elemento di distribuzione',0),(131857,3663,'tl','',0),(131858,3663,'th','&#3585;&#3634;&#3619;&#3585;&#3619;&#3632;&#3592;&#3634;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(131859,3663,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤¤à¤°à¤£',0),(131860,3663,'ms','Taburan item',0),(131861,3663,'ar','ØªÙˆØ²ÙŠØ¹ Ø§Ù„Ø¨Ù†Ø¯',0),(131862,3663,'fr','Point de Distribution',0),(131863,3663,'jp','å“?ç›®åˆ†é…?',0),(131864,3663,'pt','DistribuiÃ§Ã£o de item',0),(131865,3663,'ru','Ð Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð¿ÑƒÐ½ÐºÑ‚Ð°',0),(131866,3663,'es','Item DistribuciÃ³n',0),(131867,3663,'de','Element-Verteilung',0),(131868,3663,'en','Item Distribution',0),(131869,3664,'is','',0),(131870,3664,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ø¬Ù†Ø³ ',0),(131871,3664,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  ÙƒØ§Ù„Ø§ ',0),(131872,3664,'tr','Ã–ÄŸe Ekle/GÃ¼ncelle',0),(131873,3664,'pl','Pozycji Dodaj/Aktualizuj',0),(131874,3664,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(131875,3664,'ur','Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(131876,3664,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð»/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(131877,3664,'vi','ThÃªm/Cáº­p nháº­t hÃ ng',0),(131878,3664,'af','Item Skep/Opdateer',0),(131879,3664,'ro','Adauga/actualizare',0),(131880,3664,'et','Lisa/Uuenda toodet',0),(131881,3664,'si','Element Dodaj/posodobi',0),(131882,3664,'ba','Item Tambahkan/Perbarui',0),(131883,3664,'nl','Item toevoegen/bijwerken',0),(131884,3664,'fi','Nimikkeen lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(131885,3664,'no','Elementet Legg til/Oppdater',0),(131886,3664,'da','Elementet TilfÃ¸j/opdater',0),(131887,3664,'ko','í•­ëª© ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(131888,3664,'he','×”×•×¡×¤×ª/×¢×“×›×•×Ÿ ×¤×¨×™×˜',0),(131889,3664,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(131890,3664,'zh','é¡¹ç›®æ–°å¢ž/æ›´æ–°\r\n',0),(131891,3664,'sv','Artikel LÃ¤gg till/uppdatera',0),(131892,3664,'it','Aggiungere/aggiornare un elemento',0),(131893,3664,'tl','',0),(131894,3664,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(131895,3664,'hi','à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(131896,3664,'ms','Item Tambah/Kemaskini',0),(131897,3664,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« ØµÙ†Ù',0),(131898,3664,'fr','Ã‰lÃ©ment Ajouter/mettre Ã  jour',0),(131899,3664,'jp','å“?ç›®è¿½åŠ /æ›´æ–°',0),(131900,3664,'pt','Item Adicionar/atualizar',0),(131901,3664,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€',0),(131902,3664,'es','Item Agregar/Actualizar',0),(131903,3664,'de','Element hinzufÃ¼gen/aktualisieren',0),(131904,3664,'en','Item Add/Update',0),(131905,3665,'is','',0),(131906,3665,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(131907,3665,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(131908,3665,'tr','Madde fiyatlarÄ±',0),(131909,3665,'pl','Ceny towaru',0),(131910,3665,'bg','Ð¦ÐµÐ½Ð¸ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(131911,3665,'ur','Ø´Û’ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº',0),(131912,3665,'sr','Ð¦ÐµÐ½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(131913,3665,'vi','GiÃ¡ hÃ ng',0),(131914,3665,'af','Item Pryse',0),(131915,3665,'ro','PreÅ£urile articolelor',0),(131916,3665,'et','Toodete hinnad',0),(131917,3665,'si','Cene artiklov',0),(131918,3665,'ba','Harga barang',0),(131919,3665,'nl','Artikelprijzen',0),(131920,3665,'fi','Nimikehinnat',0),(131921,3665,'no','Varepriser',0),(131922,3665,'da','Varepriserne',0),(131923,3665,'ko','í•­ëª© ê°€ê²©',0),(131924,3665,'he','×ž×—×™×¨×™ ×¤×¨×™×˜',0),(131925,3665,'el','Î¤Î¹Î¼Î­Ï‚ ÎµÎ¹Î´ÏŽÎ½',0),(131926,3665,'zh','é¡¹ç›®ä»·æ ¼\r\n',0),(131927,3665,'sv','Artikelpriser',0),(131928,3665,'it','Prezzi articoli',0),(131929,3665,'tl','',0),(131930,3665,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(131931,3665,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‡à¤‚',0),(131932,3665,'ms','Harga item',0),(131933,3665,'ar','Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(131934,3665,'fr','Prix article',0),(131935,3665,'jp','å“?ç›®å€¤æ®µ',0),(131936,3665,'pt','PreÃ§os do item',0),(131937,3665,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(131938,3665,'es','Item Precios',0),(131939,3665,'de','Artikelpreise',0),(131940,3665,'en','Item Prices',0),(131941,3666,'is','',0),(131942,3666,'dr','Ø®Ù„Ø§ØµÙ‡ ÙƒØ§Ù„Ø§ ',0),(131943,3666,'pr','Ø®Ù„Ø§ØµÙ‡ ÙƒØ§Ù„Ø§ ',0),(131944,3666,'tr','ÃœrÃ¼n Ã¶zetleri',0),(131945,3666,'pl','Element streszczenia',0),(131946,3666,'bg','Ð ÐµÐ·ÑŽÐ¼ÐµÑ‚Ð° Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(131947,3666,'ur','Ø´Û’ Ø®Ù„Ø§ØµÛ',0),(131948,3666,'sr','Ð¡Ð°Ð¶ÐµÑ†Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(131949,3666,'vi','Tá»•ng quÃ¡t hÃ ng',0),(131950,3666,'af','Item Opsommings',0),(131951,3666,'ro','Articol rezumate',0),(131952,3666,'et','Toote kokkuvÃµtted',0),(131953,3666,'si','Element povzetke',0),(131954,3666,'ba','Ringkasan item',0),(131955,3666,'nl','Item samenvattingen',0),(131956,3666,'fi','Nimikkeen yhteenvedot',0),(131957,3666,'no','Elementet Sammendrag',0),(131958,3666,'da','Vare resumÃ©er',0),(131959,3666,'ko','í•­ëª© ìš”ì•½',0),(131960,3666,'he','×¤×¨×™×˜ ×¡×™×›×•×ž×™×',0),(131961,3666,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÎµÏÎ¹Î»Î®ÏˆÎµÎ¹Ï‚',0),(131962,3666,'zh','é¡¹ç›®æ‘˜è¦\r\n',0),(131963,3666,'sv','Objektet sammanfattningar',0),(131964,3666,'it','Elemento riassunti',0),(131965,3666,'tl','',0),(131966,3666,'th','&#3626;&#3619;&#3640;&#3611;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(131967,3666,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(131968,3666,'ms','Ringkasan perkara',0),(131969,3666,'ar','Ù…Ù„Ø®Ù‘ØµØ§Øª Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(131970,3666,'fr','RÃ©sumÃ©s de l\'Ã©lÃ©ment',0),(131971,3666,'jp','å“?ç›®é›†è¨ˆ',0),(131972,3666,'pt','Resumos de item',0),(131973,3666,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(131974,3666,'es','Item Resumenes',0),(131975,3666,'de','Element-Zusammenfassungen',0),(131976,3666,'en','Item Summaries',0),(131977,3667,'is','',0),(131978,3667,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ÙƒØ§Ù„Ø§',0),(131979,3667,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ÙƒØ§Ù„Ø§',0),(131980,3667,'tr','SatÄ±cÄ±ya gÃ¶re Ã¶ÄŸeler',0),(131981,3667,'pl','ZapasÃ³w wg dostawcy',0),(131982,3667,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(131983,3667,'ur','Ø§Ø´ÛŒØ§ Ø¨Ù…Ø·Ø§Ø¨Ù‚ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(131984,3667,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(131985,3667,'vi','NgÆ°á»i cung á»©ng hÃ ng',0),(131986,3667,'af','Item Verskaffers',0),(131987,3667,'ro','Elemente de furnizor',0),(131988,3667,'et','Toote hankijad',0),(131989,3667,'si','Elementi, ki jih prodajalec',0),(131990,3667,'ba','Item oleh Vendor',0),(131991,3667,'nl','Objecten op verkoper',0),(131992,3667,'fi','Kohteiden toimittajittain',0),(131993,3667,'no','Elementer av leverandÃ¸r',0),(131994,3667,'da','Elementer af leverandÃ¸r',0),(131995,3667,'ko','ê³µê¸‰ ì—…ì²´ í•­ëª©',0),(131996,3667,'he','×¡×¤×§×™ ×¤×¨×™×˜',0),(131997,3667,'el','Î‘Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î± Ï€Ï‰Î»Î·Ï„Î®',0),(131998,3667,'zh','ç‰©å“ä¾›åº”å•†\r\n',0),(131999,3667,'sv','Artiklar av leverantÃ¶r',0),(132000,3667,'it','Articoli dal fornitore',0),(132001,3667,'tl','',0),(132002,3667,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(132003,3667,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(132004,3667,'ms','Barang-barang oleh pembekal',0),(132005,3667,'ar','Ù…ÙˆØ±Ù‘Ø¯Ùˆ Ø§Ù„ØµÙ†Ù',0),(132006,3667,'fr','Articles par fournisseur',0),(132007,3667,'jp','å“?ç›®ä»•å…¥å…ˆ',0),(132008,3667,'pt','Itens por fornecedor',0),(132009,3667,'ru','Ð¢Ð¾Ð²Ð°Ñ€Ñ‹ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»Ñ',0),(132010,3667,'es','Item Proveedores',0),(132011,3667,'de','Artikel nach Hersteller',0),(132012,3667,'en','Items by Vendor',0),(132013,3668,'is','',0),(132014,3668,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ù…ØµØ±Ù ÙƒØ§Ù„Ø§ ',0),(132015,3668,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ù…ØµØ±Ù ÙƒØ§Ù„Ø§ ',0),(132016,3668,'tr','Madde kullanÄ±mÄ± geÃ§miÅŸi',0),(132017,3668,'pl','Historia uÅ¼ycia elementu',0),(132018,3668,'bg','Ð¥Ñ€Ð¾Ð½Ð¾Ð»Ð¾Ð³Ð¸Ñ Ð½Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(132019,3668,'ur','Ø´Û’ Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(132020,3668,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð·Ð°ÑƒÐ·ÐµÑ›Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(132021,3668,'vi','Lá»‹ch sá»­ sá»­ dá»¥ng hÃ ng',0),(132022,3668,'af','Item Gebruiksgeskiedenis',0),(132023,3668,'ro','Istoria de utilizare element',0),(132024,3668,'et','Toote kasutamise ajalugu',0),(132025,3668,'si','Zgodovina uporabe artikla',0),(132026,3668,'ba','Sejarah penggunaan item',0),(132027,3668,'nl','Item gebruik geschiedenis',0),(132028,3668,'fi','Nimikkeen kÃ¤yttÃ¶historia',0),(132029,3668,'no','Artikkel Bruk historie',0),(132030,3668,'da','Vare skik historie',0),(132031,3668,'ko','í•­ëª© ì‚¬ìš© ì—­ì‚¬',0),(132032,3668,'he','×”×™×¡×˜×•×¨×™×™×ª ×©×™×ž×•×© ×¤×¨×™×˜',0),(132033,3668,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Ï‡ÏÎ®ÏƒÎ·Ï‚ Ï„Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(132034,3668,'zh','é¡¹ç›®ä½¿ç”¨åŽ†å²\r\n',0),(132035,3668,'sv','Objektet anvÃ¤ndning historia',0),(132036,3668,'it','Elemento di cronologia di utilizzo',0),(132037,3668,'tl','',0),(132038,3668,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(132039,3668,'hi','à¤†à¤‡à¤Ÿà¤® à¤‰à¤ªà¤¯à¥‹à¤— à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(132040,3668,'ms','Sejarah penggunaan item',0),(132041,3668,'ar','Ø­Ø±ÙƒØ© Ø¥Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ù„ØµÙ†Ù',0),(132042,3668,'fr','Historique de l\'utilisation du point',0),(132043,3668,'jp','å“?ç›®ä½¿ç”¨å±¥æ­´',0),(132044,3668,'pt','HistÃ³rico de uso do item',0),(132045,3668,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(132046,3668,'es','Item Historia de Uso',0),(132047,3668,'de','Element Nutzungsverlauf',0),(132048,3668,'en','Item Usage History',0),(132049,3669,'is','',0),(132050,3669,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(132051,3669,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(132052,3669,'tr','GÃ¶nderilen Ã¶ÄŸeler',0),(132053,3669,'pl','Elementy wysÅ‚ane',0),(132054,3669,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(132055,3669,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(132056,3669,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ»Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ðµ',0),(132057,3669,'vi','HÃ ng Ä‘Ã£ chuyá»ƒn',0),(132058,3669,'af','Items Versend',0),(132059,3669,'ro','Articole expediate',0),(132060,3669,'et','LÃ¤hetatud kaupade',0),(132061,3669,'si','Dobavljenih artiklov',0),(132062,3669,'ba','Barang-barang yang dikirimkan',0),(132063,3669,'nl','Objecten die worden verzonden',0),(132064,3669,'fi','Toimitettujen nimikkeiden',0),(132065,3669,'no','Varene skal leveres',0),(132066,3669,'da','Leverede varer',0),(132067,3669,'ko','í•­ëª© ì œê³µ',0),(132068,3669,'he','×¤×¨×™×˜×™× ×©× ×©×œ×—×•',0),(132069,3669,'el','Items Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(132070,3669,'zh','ç‰©å“è¿é€\r\n',0),(132071,3669,'sv','Levererade artiklarna',0),(132072,3669,'it','Oggetti spediti',0),(132073,3669,'tl','',0),(132074,3669,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;',0),(132075,3669,'hi','à¤†à¤‡à¤Ÿà¤® à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(132076,3669,'ms','Barang-barang yang dihantar',0),(132077,3669,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„ØªÙŠ ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(132078,3669,'fr','Articles expÃ©diÃ©s',0),(132079,3669,'jp','ç™ºé€?å“?ç›®',0),(132080,3669,'pt','Itens enviados',0),(132081,3669,'ru','Ð¢Ð¾Ð²Ð°Ñ€Ñ‹ Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ðµ',0),(132082,3669,'es','Items Enviados',0),(132083,3669,'de','Artikel geliefert',0),(132084,3669,'en','Items Shipped',0),(132085,3670,'is','',0),(132086,3670,'dr','- ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ù…ÙØ§Ø¯ ÙˆØ¶Ø±Ø±- Ø­Ø³Ø§Ø¨ Ø¨ÙˆØ¯Ø¬Ù‡ ( Ø¯Ø±Ø§Ù…Ø¯ ÙˆØ®Ø±Ø¬)  ',0),(132087,3670,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª  Ø«Ø¨Øª Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ â€“ ØªØ±Ø§Ø² Ù†Ø§Ù…Ù‡ - ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ ÙˆØ²ÙŠØ§Ù†- Ø­Ø³Ø§Ø¨ Ø¨ÙˆØ¯Ø¬Ù‡ ( Ø¯Ø±Ø§Ù…Ø¯ ÙˆØ®Ø±Ø¬)  ',0),(132088,3670,'tr','GÃ¼nlÃ¼k giriÅŸ - bilanÃ§o - gelir beyanÄ± - bÃ¼tÃ§eler - raporlar',0),(132089,3670,'pl','Dziennik wpis - bilans - dochÃ³d instrukcja - budÅ¼et - raporty',0),(132090,3670,'bg','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ - Ð±Ð°Ð»Ð°Ð½ÑÐ° - Ð´Ð¾Ñ…Ð¾Ð´ Ð¾Ñ‚Ñ‡ÐµÑ‚ - Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸ - Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(132091,3670,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ - Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ - Ø¢Ù…Ø¯Ù†ÛŒ Ø¨ÛŒØ§Ù† - ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) - Ø±Ù¾ÙˆØ±Ù¹',0),(132092,3670,'sr','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº ÑÑ‚Ð°Ð²ÐºÐ° - Ð±Ð¸Ð»Ð°Ð½ÑÐ° ÑÑ‚Ð°ÑšÐ° - Ð¿Ñ€Ð¸Ñ…Ð¾Ð´ Ð¸Ð·Ñ˜Ð°Ð²Ð° - Ð±ÑƒÑŸÐµÑ‚Ðµ - Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(132093,3670,'vi','Nháº­p BÃºt ToÃ¡n - Báº£ng CÃ¢n Äá»‘i Káº¿ ToÃ¡n - BÃ¡o CÃ¡o Doanh Thu - NgÃ¢n SÃ¡ch - BÃ¡o CÃ¡o',0),(132094,3670,'af','Joernaalinskrywing - Balansstaat - Inkomstestaat - Begrotings - Verslae',0),(132095,3670,'ro','Jurnalul intrare - bilanÅ£ul - venituri declaraÅ£ie - bugetele - rapoarte',0),(132096,3670,'et','TÃ¶Ã¶lehe kanne - bilanss - tulu avaldus - eelarved - aruanded',0),(132097,3670,'si','Reviji vstop - bilanca - dohodek izjavo - proraÄun - poroÄila',0),(132098,3670,'ba','Jurnal entri - neraca - pendapatan pernyataan - anggaran - laporan',0),(132099,3670,'nl','Journal item - balans - inkomen verklaring - budgetten - Reports',0),(132100,3670,'fi','Kirjauskansion merkintÃ¤ - tase - tuloslaskelma - talousarviot --raporteissa',0),(132101,3670,'no','Journal oppfÃ¸ring - balanse - inntekt uttalelse - budsjetter - rapporter',0),(132102,3670,'da','Journal Entry - balancen - indkomst erklÃ¦ring - budgetter - rapporter',0),(132103,3670,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª©-ëŒ€ì°¨ ëŒ€ì¡°í‘œ-ì†Œë“ ê³„ì‚° ì„œ-ì˜ˆì‚°-ë³´ê³ ì„œ',0),(132104,3670,'he','×“×•×—×•×ª ×”×”×¦×”×¨×” - ×ª×§×¦×™×‘×™× â€“ ×”×›× ×¡×” ×©×œ ×”×¤×•×¡×˜ - ×ž××–×Ÿ - ×™×•×ž×Ÿ',0),(132105,3670,'el','Î•Ï†Î·Î¼ÎµÏÎ¯Î´Î± ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… - Î¹ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ - ÎµÎ¹ÏƒÏŒÎ´Î·Î¼Î± Î´Î®Î»Ï‰ÏƒÎ· - Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŽÎ½ - ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(132106,3670,'zh','æ—¥å¿—æ¡ç›®- èµ„äº§è´Ÿå€ºè¡¨-æŸç›Šè¡¨ -é¢„ç®— -æŠ¥å‘Š\r\n',0),(132107,3670,'sv','Journalen intrade - balansrÃ¤kning - - budgetar - resultatrÃ¤kningsrapporter',0),(132108,3670,'it','Rapporti del Journal Entry - bilancio - reddito dichiarazione - bilanci-',0),(132109,3670,'tl','',0),(132110,3670,'th','Journal Entry - Balance Sheet - Income Statement - Budgets - Reports',0),(132111,3670,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ - à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ - à¤†à¤¯ à¤¬à¤¯à¤¾à¤¨ - à¤¬à¤œà¤Ÿ - à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(132112,3670,'ms','Jurnal catatan - kunci - pendapatan penyata - belanjawan - Laporan',0),(132113,3670,'ar','Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ© - Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© - Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¯Ø®Ù„ - Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ±',0),(132114,3670,'fr','Journal entrÃ©e - bilan - revenu dÃ©claration - Budgets - rapports',0),(132115,3670,'jp','ã‚¸ãƒ£ãƒ¼ãƒŠãƒ«å…¥åŠ›ãƒ¼ãƒ?ãƒ©ãƒ³ã‚¹ã‚·ãƒ¼ãƒˆãƒ¼å?Žå…¥æ˜Žç´°ãƒ¼äºˆç®—ãƒ¼ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(132116,3670,'pt','RelatÃ³rios de instruÃ§Ã£o - orÃ§amentos - diÃ¡rio entrada - balanÃ§o - renda',0),(132117,3670,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ - Ð±ÑŽÐ´Ð¶ÐµÑ‚Ñ‹ - Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹ Ð¶ÑƒÑ€Ð½Ð°Ð»Ð° Ð·Ð°Ð¿Ð¸ÑÑŒ - Ð±Ð°Ð»Ð°Ð½Ñ - Ð´Ð¾Ñ…Ð¾Ð´',0),(132118,3670,'es','Entrada al Diario - Hoja de Balance - Estado de Resultados - Presupuestos - Informes',0),(132119,3670,'de','Eintrag - Bilanz - Income Statement - Budgets - Journalberichte',0),(132120,3670,'en','Journal Entry - Balance Sheet - Income Statement - Budgets - Reports',0),(132121,3671,'is','',0),(132122,3671,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(132123,3671,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(132124,3671,'tr','GÃ¼nlÃ¼k raporlar',0),(132125,3671,'pl','RaportÃ³w dziennika',0),(132126,3671,'bg','Ð’ÐµÑÑ‚Ð½Ð¸Ðº Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(132127,3671,'ur','Ø¬Ø±Ù†Ù„ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(132128,3671,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(132129,3671,'vi','BÃ¡o cÃ¡o Ä‘á»‹nh ká»³',0),(132130,3671,'af','Joernaalverslae',0),(132131,3671,'ro','Rapoarte de jurnal',0),(132132,3671,'et','TÃ¶Ã¶lehearuannete',0),(132133,3671,'si','Journal poroÄila',0),(132134,3671,'ba','Laporan jurnal',0),(132135,3671,'nl','Journal Reports',0),(132136,3671,'fi','PÃ¤ivyrin raportit',0),(132137,3671,'no','Journalrapporter',0),(132138,3671,'da','Kladderapporter',0),(132139,3671,'ko','ì €ë„ ë³´ê³ ì„œ',0),(132140,3671,'he','×“×•×—×•×ª ×™×•×ž×Ÿ',0),(132141,3671,'el','ÎŸÎ¹ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ ÎµÏ†Î·Î¼ÎµÏÎ¯Î´Î±',0),(132142,3671,'zh','æ—¥å¿—æŠ¥å‘Š\r\n',0),(132143,3671,'sv','Journalrapporter',0),(132144,3671,'it','Rapporti del Journal',0),(132145,3671,'tl','',0),(132146,3671,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;',0),(132147,3671,'hi','à¤œà¤°à¥à¤¨à¤² à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥à¤¸',0),(132148,3671,'ms','Laporan jurnal',0),(132149,3671,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(132150,3671,'fr','Ã‰tats de journal',0),(132151,3671,'jp','ä»•è¨³å¸³ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(132152,3671,'pt','RelatÃ³rios de diÃ¡rio',0),(132153,3671,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» ÐžÑ‚Ñ‡ÐµÑ‚Ð¾Ð²',0),(132154,3671,'es','Informes del Diario',0),(132155,3671,'de','Journalberichte',0),(132156,3671,'en','Journal Reports',0),(132157,3672,'is','',0),(132158,3672,'dr','Ø¯ÙØªØ±Ú©Ù„',0),(132159,3672,'pr','Ø¯ÙØªØ±Ú©Ù„',0),(132160,3672,'tr','Genel muhasebe',0),(132161,3672,'pl','KsiÄ™gi',0),(132162,3672,'bg','ÐšÐ½Ð¸Ð³Ð° Ð·Ð°',0),(132163,3672,'ur','Ú©Ú¾Ø§ØªØ§',0),(132164,3672,'sr','ÐšÑšÐ¸Ð³Ðµ',0),(132165,3672,'vi','Sá»• CÃ¡i',0),(132166,3672,'af','Grootboek',0),(132167,3672,'ro','Contabilitate',0),(132168,3672,'et','Pearaamat',0),(132169,3672,'si','Poslovna knjiga',0),(132170,3672,'ba','Buku besar',0),(132171,3672,'nl','Grootboek',0),(132172,3672,'fi','Kirjanpidon',0),(132173,3672,'no','Finans',0),(132174,3672,'da','Finans',0),(132175,3672,'ko','ë ˆì €',0),(132176,3672,'he','×—×©×‘×•× ××•×ª',0),(132177,3672,'el','Î›Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®',0),(132178,3672,'zh','åˆ†ç±»å¸\r\n',0),(132179,3672,'sv','Redovisningen',0),(132180,3672,'it','ContabilitÃ  generale',0),(132181,3672,'tl','',0),(132182,3672,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(132183,3672,'hi','à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€',0),(132184,3672,'ms','Lejar',0),(132185,3672,'ar','Ø§Ù„Ø£Ø³ØªØ§Ø°',0),(132186,3672,'fr','Grand livre',0),(132187,3672,'jp','å…ƒå¸³',0),(132188,3672,'pt','Livro-razÃ£o',0),(132189,3672,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÐšÐ½Ð¸Ð³Ð°',0),(132190,3672,'es','Libro Mayor',0),(132191,3672,'de','Finanzbuchhaltung',0),(132192,3672,'en','Ledger',0),(132193,3673,'is','',0),(132194,3673,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(132195,3673,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(132196,3673,'tr','SipariÅŸ YazdÄ±r listesinde kapalÄ±',0),(132197,3673,'pl','Lista zamkniÄ™ta druku zamÃ³wienia',0),(132198,3673,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(132199,3673,'ur','ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§ Û”',0),(132200,3673,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð° ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(132201,3673,'vi','Danh SÃ¡ch cÃ¡c Ä‘Æ¡n hÃ ng in Ä‘Ã£ Ä‘Ã³ng',0),(132202,3673,'af','Lys Afgesluite Gedrukte Bestellings',0),(132203,3673,'ro','ListÄƒ Ã®nchisÄƒ ordine de imprimare',0),(132204,3673,'et','Nimekiri suletud trÃ¼kitÃ¶Ã¶de tellimused',0),(132205,3673,'si','Seznam zaprtih tiskanje nalogov',0),(132206,3673,'ba','Daftar jumlahclose order cetak',0),(132207,3673,'nl','Lijst met afgesloten afdrukken bestellingen',0),(132208,3673,'fi','Luettelo suljettu tulosta tilaukset',0),(132209,3673,'no','Listen lukkes bestilling',0),(132210,3673,'da','Lukket aftryksbestillinger',0),(132211,3673,'ko','ëª©ë¡ ì¸ì‡„ ì£¼ë¬¸ ë§ˆê°',0),(132212,3673,'he','×”×¨×©×™×ž×” ×¡×’×•×¨×” ×”×“×¤×¡×•×ª',0),(132213,3673,'el','Î›Î¯ÏƒÏ„Î± ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŽÎ½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(132214,3673,'zh','åˆ—å‡ºå°é—­æ‰“å°è®¢å•\r\n',0),(132215,3673,'sv','StÃ¤ngd Print Order',0),(132216,3673,'it','Elenco chiuso stampa ordini',0),(132217,3673,'tl','',0),(132218,3673,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3611;&#3636;&#3604;',0),(132219,3673,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤¸à¥‚à¤šà¥€ à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(132220,3673,'ms','Senarai pesanan cetakan yang tertutup',0),(132221,3673,'ar','Ø¥ØºÙ„Ø§Ù‚ Ù‚Ø§Ø¦Ù…Ø© Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(132222,3673,'fr','Liste Close arrÃªtÃ©s impression',0),(132223,3673,'jp','å®Œäº†ã?—ã?Ÿå?°åˆ·æ³¨æ–‡ã‚’ä¸€è¦§ã?«ã?™ã‚‹',0),(132224,3673,'pt','Lista fechada ordens de impressÃ£o',0),(132225,3673,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°ÐºÑ€Ñ‹Ñ‚ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(132226,3673,'es','Lista Ordenes de ImpresiÃ³n Cerrados',0),(132227,3673,'de','Liste geschlossen DruckauftrÃ¤ge',0),(132228,3673,'en','List Closed Print Orders',0),(132229,3674,'is','',0),(132230,3674,'dr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(132231,3674,'pr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(132232,3674,'tr','MÃ¼ÅŸteri listesi',0),(132233,3674,'pl','Lista klientÃ³w',0),(132234,3674,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(132235,3674,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ÙÛØ±Ø³Øª',0),(132236,3674,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(132237,3674,'vi','Danh sÃ¡ch khÃ¡ch hÃ ng ',0),(132238,3674,'af','Klant/KliÃ«nt Lys',0),(132239,3674,'ro','Lista clienti',0),(132240,3674,'et','Kliendi nimekiri',0),(132241,3674,'si','Seznam kupcev',0),(132242,3674,'ba','Daftar pelanggan',0),(132243,3674,'nl','Klantenlijst',0),(132244,3674,'fi','Asiakasluettelo',0),(132245,3674,'no','Kundeoversikt',0),(132246,3674,'da','Kundeliste',0),(132247,3674,'ko','ê³ ê° ëª©ë¡',0),(132248,3674,'he','×¨×©×™×ž×ª ×œ×§×•×—×•×ª',0),(132249,3674,'el','Î ÎµÎ»Î±Ï„Î¿Î»ÏŒÎ³Î¹Î¿',0),(132250,3674,'zh','å®¢æˆ·åå•\r\n',0),(132251,3674,'sv','Kundlista',0),(132252,3674,'it','Elenco dei clienti',0),(132253,3674,'tl','',0),(132254,3674,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(132255,3674,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‚à¤šà¥€',0),(132256,3674,'ms','Senarai pelanggan',0),(132257,3674,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(132258,3674,'fr','Liste des clients',0),(132259,3674,'jp','é¡§å®¢ãƒªã‚¹ãƒˆ',0),(132260,3674,'pt','Lista de clientes',0),(132261,3674,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(132262,3674,'es','Lista de Clientes',0),(132263,3674,'de','Kundenliste',0),(132264,3674,'en','Customer List',0),(132265,3675,'is','',0),(132266,3675,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§',0),(132267,3675,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§',0),(132268,3675,'tr','Liste madde kategorileri',0),(132269,3675,'pl','Elementu listy kategorii',0),(132270,3675,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(132271,3675,'ur','ÙÛØ±Ø³Øª Ø´Û’ Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(132272,3675,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(132273,3675,'vi','Thá»ƒ loáº¡i danh sÃ¡ch hÃ ng',0),(132274,3675,'af','Lys Item KategoriÃ«',0),(132275,3675,'ro','Element listÄƒ categorii',0),(132276,3675,'et','LoendiÃ¼ksuse Kategooriad',0),(132277,3675,'si','Elementa seznama kategorij',0),(132278,3675,'ba','Daftar Kategori Item',0),(132279,3675,'nl','Lijst artikelcategorieÃ«n',0),(132280,3675,'fi','Luettelokohteen Luokat',0),(132281,3675,'no','Listen kategorier',0),(132282,3675,'da','Listen varekategorier',0),(132283,3675,'ko','ëª©ë¡ í•­ëª© ë²”ì£¼',0),(132284,3675,'he','×¤×¨×™×˜ ×¨×©×™×ž×” ×§×˜×’×•×¨×™×•×ª',0),(132285,3675,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î»Î¯ÏƒÏ„Î±Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(132286,3675,'zh','é¡¹ç›®ç±»åˆ«åå•\r\n',0),(132287,3675,'sv','Lista artikelkategorier',0),(132288,3675,'it','Voce elenco categorie',0),(132289,3675,'tl','',0),(132290,3675,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(132291,3675,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(132292,3675,'ms','Kategori Item senarai',0),(132293,3675,'ar','Ø¹Ù†ØµØ± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„ÙØ¦Ø§Øª',0),(132294,3675,'fr','CatÃ©gories d\'Ã©lÃ©ments de liste',0),(132295,3675,'jp','é …ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(132296,3675,'pt','Categorias de Item de lista',0),(132297,3675,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(132298,3675,'es','Listar CategorÃ­as de Items',0),(132299,3675,'de','Liste Positionstypen',0),(132300,3675,'en','List Item Categories',0),(132301,3676,'is','',0),(132302,3676,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(132303,3676,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(132304,3676,'tr','AlÄ±nan Ã¶ÄŸeler listesi',0),(132305,3676,'pl','Otrzymane listy elementÃ³w',0),(132306,3676,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ ÑÐ¿Ð¸ÑÑŠÐº',0),(132307,3676,'ur','Ø§Ø´ÛŒØ§ Ú©ÛŒ ÙÛØ±Ø³Øª Ù…ÙˆØµÙˆÙ„',0),(132308,3676,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸',0),(132309,3676,'vi','Danh sÃ¡ch hÃ ng nháº­n Ä‘Æ°á»£c',0),(132310,3676,'af','Lys van Ontvangde Items',0),(132311,3676,'ro','RecepÅ£ionate articole listÄƒ',0),(132312,3676,'et','Kaubad vastu loend',0),(132313,3676,'si','Artikli prevzeti seznam',0),(132314,3676,'ba','Daftar menerima item',0),(132315,3676,'nl','Artikelen ontvangen lijst',0),(132316,3676,'fi','Vastaanotetut erÃ¤t',0),(132317,3676,'no','Liste over mottatte',0),(132318,3676,'da','Varer modtages liste',0),(132319,3676,'ko','í•­ëª© ìˆ˜ì‹ ëœ ëª©ë¡',0),(132320,3676,'he','×¨×©×™×ž×ª ×¤×¨×™×˜×™× ×©× ×ª×§×‘×œ×•',0),(132321,3676,'el','ÎˆÎ»Î±Î²Îµ Î»Î¯ÏƒÏ„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(132322,3676,'zh','æ”¶åˆ°çš„é¡¹ç›®æ¸…å•\r\n',0),(132323,3676,'sv','Lista Ã¶ver mottagna',0),(132324,3676,'it','Gli articoli ricevuti elenco',0),(132325,3676,'tl','',0),(132326,3676,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(132327,3676,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤®à¥ à¤¸ à¤ªà¥à¤°à¤¾à¤ªà¥ à¤¤',0),(132328,3676,'ms','Senarai barang-barang diterima',0),(132329,3676,'ar','Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„ÙˆØ§Ø±Ø¯Ø© ÙÙŠ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(132330,3676,'fr','Liste des articles reÃ§us',0),(132331,3676,'jp','å?—é ˜å“?ç›®ãƒªã‚¹ãƒˆ',0),(132332,3676,'pt','Lista de itens recebidos',0),(132333,3676,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(132334,3676,'es','Lista de Items Recibidos',0),(132335,3676,'de','Empfangene Liste',0),(132336,3676,'en','Items Received List',0),(132337,3677,'is','',0),(132338,3677,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(132339,3677,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(132340,3677,'tr','Stok alÄ±nan liste Ã¶ÄŸeleri',0),(132341,3677,'pl','Pozycje listy do magazynu',0),(132342,3677,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÑ†Ð¸, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð² ÑÐºÐ»Ð°Ð´Ð°',0),(132343,3677,'ur','ÙÛØ±Ø³Øª Ø§Ø´ÛŒØ§ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…ÛŒÚº Ù…ÙˆØµÙˆÙ„',0),(132344,3677,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ ÑÐ° Ð»Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ðµ',0),(132345,3677,'vi','Danh SÃ¡ch Nhá»¯ng Máº·t HÃ ng ÄÆ°a VÃ o Kho',0),(132346,3677,'af','Lys van Ontvangde Items',0),(132347,3677,'ro','Lista de elemente primite Ã®n inventar',0),(132348,3677,'et','LoendiÃ¼ksuste varudesse laekunud',0),(132349,3677,'si','Seznam artiklov v zalogi',0),(132350,3677,'ba','Daftar item yang diterima ke dalam persediaan',0),(132351,3677,'nl','Items in de lijst in de voorraad ontvangen',0),(132352,3677,'fi','Luettelokohteiden vastaanotettu varastoon',0),(132353,3677,'no','Listeelementer som er mottatt pÃ¥ lageret',0),(132354,3677,'da','Liste over varer, der modtages pÃ¥ lageret',0),(132355,3677,'ko','ìž¬ê³ ì— ë°›ì€ ëª©ë¡ í•­ëª©',0),(132356,3677,'he','×¨×©×™×ž×ª ×¤×¨×™×˜×™× ×©×”×ª×§×‘×œ×• ×œ×ª×•×š ×”×ž×œ××™',0),(132357,3677,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î·Ï‚ Î»Î¯ÏƒÏ„Î±Ï‚ Ï€Î¿Ï… Î­Î»Î±Î²Îµ ÏƒÎµ Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(132358,3677,'zh','åˆ—å‡ºæŽ¥æ”¶åˆ°çš„é¡¹ç›®åˆ°åº“å­˜\r\n',0),(132359,3677,'sv','Listobjekt som inlevereras till lagret',0),(132360,3677,'it','Elenco articoli ricevuti in inventario',0),(132361,3677,'tl','',0),(132362,3677,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3633;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3651;&#3609;&#3588;&#3621;&#3633;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(132363,3677,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(132364,3677,'ms','Senarai barang-barang yang diterima ke dalam inventori',0),(132365,3677,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„ÙˆØ§Ø±Ø¯Ø© ÙÙŠ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ø±Ø¯',0),(132366,3677,'fr','Ã‰lÃ©ments de la liste reÃ§ues dans l\'inventaire',0),(132367,3677,'jp','åœ¨åº«ã?®',0),(132368,3677,'pt','Lista de itens recebidas no inventÃ¡rio',0),(132369,3677,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð², Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ… Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€ÑŒ',0),(132370,3677,'es','Lista de Items Recibidos al Inventario',0),(132371,3677,'de','Listenelemente in Inventar aufgenommen',0),(132372,3677,'en','List Items Received into Inventory',0),(132373,3678,'is','',0),(132374,3678,'dr','Ù„ÙŠØ³Øª ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ ØªÙˆÙ„Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(132375,3678,'pr','Ù„ÙŠØ³Øª ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ ØªÙˆÙ„Ø¯ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(132376,3678,'tr','Ã‡alÄ±ÅŸanÄ±n doÄŸum gÃ¼nÃ¼',0),(132377,3678,'pl','Urodziny pracownika',0),(132378,3678,'bg','Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸ Ð´Ð½Ð¸ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(132379,3678,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ø³Ø§Ù„Ú¯Ø±Û',0),(132380,3678,'sr','Ð Ð¾Ñ’ÐµÐ½Ð´Ð°Ð½Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(132381,3678,'vi','Danh sÃ¡ch ngÃ y sinh nhÃ¢n viÃªn ',0),(132382,3678,'af','Lys van Werknemerverjaarsdae',0),(132383,3678,'ro','Angajat aniversari',0),(132384,3678,'et','TÃ¶Ã¶tajate sÃ¼nnipÃ¤evade nimekiri',0),(132385,3678,'si','Rojstni dnevi delavcev',0),(132386,3678,'ba','Ulang tahun karyawan',0),(132387,3678,'nl','Verjaardagen van werknemers',0),(132388,3678,'fi','TyÃ¶ntekijÃ¶iden syntymÃ¤pÃ¤ivÃ¤',0),(132389,3678,'no','FÃ¸dselsdagene for ansatte',0),(132390,3678,'da','MedarbejderfÃ¸dselsdage',0),(132391,3678,'ko','ì§ì› ìƒì¼',0),(132392,3678,'he','×¨×©×™×ž×ª ×™×ž×™ ×”×•×œ×“×ª ×©×œ ×”×¢×•×‘×“×™×',0),(132393,3678,'el','Î“ÎµÎ½Î­Î¸Î»Î¹Î± Ï…Ï€Î±Î»Î»Î®Î»Ï‰Î½',0),(132394,3678,'zh','å‘˜å·¥ç”Ÿæ—¥åå•\r\n',0),(132395,3678,'sv','AnstÃ¤lldas fÃ¶delsedagar',0),(132396,3678,'it','Compleanni dei dipendenti',0),(132397,3678,'tl','',0),(132398,3678,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3623;&#3633;&#3609;&#3648;&#3585;&#3636;&#3604;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(132399,3678,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤œà¤¨à¥à¤®à¤¦à¤¿à¤¨',0),(132400,3678,'ms','Hari lahir pekerja',0),(132401,3678,'ar','Ø£Ø¹ÙŠØ§Ø¯ Ø§Ù„Ù…ÙŠÙ„Ø§Ø¯ Ø§Ù„Ù…ÙˆØ¸Ù',0),(132402,3678,'fr','Anniversaires de l\'employÃ©',0),(132403,3678,'jp','å¾“æ¥­å“¡èª•ç”Ÿæ—¥ãƒªã‚¹ãƒˆ',0),(132404,3678,'pt','AniversÃ¡rios de empregado',0),(132405,3678,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð”Ð½ÐµÐ¹ Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(132406,3678,'es','Lista de CumpleaÃ±os de Empleados',0),(132407,3678,'de','Mitarbeitergeburtstage',0),(132408,3678,'en','Employee Birthdays',0),(132409,3679,'is','',0),(132410,3679,'dr','Ù„ÙŠØ³Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯  ',0),(132411,3679,'pr','Ù„ÙŠØ³Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯  ',0),(132412,3679,'tr','Ã‡alÄ±ÅŸan genel bilgi',0),(132413,3679,'pl','Informacje ogÃ³lne pracownik',0),(132414,3679,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»-Ð¾Ð±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(132415,3679,'ur','Ù…Ù„Ø§Ø²Ù… Ø¬Ù†Ø±Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(132416,3679,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð˜Ð½Ñ„Ð¾',0),(132417,3679,'vi','Danh sÃ¡ch ThÃ´ng Tin nhÃ¢n viÃªn',0),(132418,3679,'af','Lys van Werknemer Algemene Inligting',0),(132419,3679,'ro','Angajat General Info',0),(132420,3679,'et','Nimekiri tÃ¶Ã¶tajate Ã¼ldisest informatsioonist',0),(132421,3679,'si','Zaposlenega sploÅ¡ne informacije',0),(132422,3679,'ba','Info Umum karyawan',0),(132423,3679,'nl','Werknemer Algemene Info',0),(132424,3679,'fi','TyÃ¶ntekijÃ¤n yleiset tiedot',0),(132425,3679,'no','Ansatt General Info',0),(132426,3679,'da','Medarbejder General Info',0),(132427,3679,'ko','ì§ì› ì¼ë°˜ ì •ë³´',0),(132428,3679,'he','×ž×™×“×¢ ×›×œ×œ×™ ×”×¢×•×‘×“',0),(132429,3679,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î³ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(132430,3679,'zh','é›‡å‘˜ä¸€èˆ¬èµ„æ–™åˆ—è¡¨\r\n',0),(132431,3679,'sv','AnstÃ¤lld allmÃ¤n Info',0),(132432,3679,'it','Dipendente General Info',0),(132433,3679,'tl','',0),(132434,3679,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(132435,3679,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(132436,3679,'ms','Maklumat am pekerja',0),(132437,3679,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ¸Ù Ø§Ù„Ø¹Ø§Ù…Ø©',0),(132438,3679,'fr','Infos gÃ©nÃ©rales de l\'employÃ©',0),(132439,3679,'jp','å¾“æ¥­å“¡ä¸€èˆ¬æƒ…å ±ãƒªã‚¹ãƒˆ',0),(132440,3679,'pt','InformaÃ§Ã£o geral de empregado',0),(132441,3679,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(132442,3679,'es','Listas InformaciÃ³n General de los Empleados',0),(132443,3679,'de','Mitarbeiter-allgemeine Infos',0),(132444,3679,'en','Employee General Info',0),(132445,3680,'is','',0),(132446,3680,'dr','Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯Ø± Ù…Ø§Ù‡ ',0),(132447,3680,'pr','Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯Ø± Ù…Ø§Ù‡ ',0),(132448,3680,'tr','Aya gÃ¶re Ã§alÄ±ÅŸanÄ±n Ã¶deme listesi',0),(132449,3680,'pl','Listy wynagrodzeÅ„ pracownikÃ³w za miesiÄ…c',0),(132450,3680,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð¿Ð¾ Ð¼ÐµÑÐµÑ†Ð¸',0),(132451,3680,'ur','Ø¨Ù…Ø·Ø§Ø¨Ù‚ Ù…Ø§Û Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ ÙÛØ±Ø³Øª',0),(132452,3680,'sr','Ð¡Ð¿Ð¸ÑÐ°Ðº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ð¾ Ð¼ÐµÑÐµÑ†Ð¸Ð¼Ð°',0),(132453,3680,'vi','Danh sÃ¡ch nhÃ¢n viÃªn tráº£ lÆ°Æ¡ng theo thÃ¡ng',0),(132454,3680,'af','Lys van Werknemer Besoldiging per Maand',0),(132455,3680,'ro','Lista de plata angajat de luna',0),(132456,3680,'et','Loendis tÃ¶Ã¶taja tÃ¶Ã¶tasu kuude lÃµikes',0),(132457,3680,'si','Seznam zaposlenega plaÄa po mesecih',0),(132458,3680,'ba','Daftar gaji karyawan oleh bulan',0),(132459,3680,'nl','Lijst van werknemer betalen per maand',0),(132460,3680,'fi','Luettelo tyÃ¶ntekijÃ¤n maksu kuukausittain',0),(132461,3680,'no','Liste over ansattes lÃ¸nn etter mÃ¥ned',0),(132462,3680,'da','Liste over medarbejder lÃ¸n pr. mÃ¥ned',0),(132463,3680,'ko','ì›”ë³„ ì§ì› ê¸‰ì—¬ì˜ ëª©ë¡',0),(132464,3680,'he','×¨×©×™×ž×ª ×©×›×¨ ×”×¢×•×‘×“ ×œ×¤×™ ×—×•×“×©',0),(132465,3680,'el','Î›Î¯ÏƒÏ„Î± Ï„Î·Ï‚ Î±Î¼Î¿Î¹Î²Î®Ï‚ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Î±Î½Î¬ Î¼Î®Î½Î±',0),(132466,3680,'zh','æŒ‰æœˆèŒå·¥è–ªé…¬åˆ—è¡¨\r\n',0),(132467,3680,'sv','Lista Ã¶ver anstÃ¤llda lÃ¶n per mÃ¥nad',0),(132468,3680,'it','Elenco di retribuzione dei dipendenti di mese',0),(132469,3680,'tl','',0),(132470,3680,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3648;&#3611;&#3655;&#3609;&#3619;&#3634;&#3618;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(132471,3680,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(132472,3680,'ms','Senarai gaji pekerja mengikut bulan',0),(132473,3680,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø±Ø§ØªØ¨ Ø§Ù„Ù…ÙˆØ¸Ù Ø­Ø³Ø¨ Ø§Ù„Ø´Ù‡Ø±',0),(132474,3680,'fr','Liste de paie de l\'employÃ© par mois',0),(132475,3680,'jp','æœˆåˆ¥å¾“æ¥­å“¡è³ƒé‡‘ã?®ä¸€è¦§',0),(132476,3680,'pt','Lista de pagamento do empregado por mÃªs',0),(132477,3680,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°Ñ€Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð·Ð° ÐœÐµÑÑÑ†',0),(132478,3680,'es','Lista de Sueldos de Empleados por Mes',0),(132479,3680,'de','Liste der Mitarbeiter per Monat bezahlen',0),(132480,3680,'en','List of Employee pay by Month',0),(132481,3681,'is','',0),(132482,3681,'dr','Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯Ø± Ø³Ù‡ Ù…Ø§Ù‡ ',0),(132483,3681,'pr','Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯Ø± Ø³Ù‡ Ù…Ø§Ù‡ ',0),(132484,3681,'tr','Ã‡alÄ±ÅŸan listesi Ã¼Ã§ aylÄ±k dÃ¶nemlere gÃ¶re Ã¶deme',0),(132485,3681,'pl','Lista pÅ‚ac pracownikÃ³w przez kwartaÅ‚',0),(132486,3681,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð¿Ð¾ Ñ‚Ñ€Ð¸Ð¼ÐµÑÐµÑ‡Ð¸Ñ',0),(132487,3681,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ú©ÙˆØ§Ø±Ù¹Ø± Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ÙÛØ±Ø³Øª',0),(132488,3681,'sr','Ð¡Ð¿Ð¸ÑÐ°Ðº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð¿Ð¾ ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð¸Ð¼Ð°',0),(132489,3681,'vi','Danh sÃ¡ch nhÃ¢n viÃªn tráº£ lÆ°Æ¡ng theo QuÃ½',0),(132490,3681,'af','Lys van Werknemer Besoldiging per Kwartaal',0),(132491,3681,'ro','Lista angajaÅ£ilor plÄƒtiÅ£i de trimestru',0),(132492,3681,'et','Loetelu tÃ¶Ã¶tajale maksma kvartali alusel',0),(132493,3681,'si','Seznam zaposlenega plaÄati Äetrtino',0),(132494,3681,'ba','Daftar gaji karyawan kuartal',0),(132495,3681,'nl','Lijst van werknemer betalen per kwartaal',0),(132496,3681,'fi','Luettelo tyÃ¶ntekijÃ¶iden palkkojen vuosineljÃ¤nneksittÃ¤in',0),(132497,3681,'no','Liste over ansattes lÃ¸nn etter kvartal',0),(132498,3681,'da','Liste over medarbejder betaler efter kvartal',0),(132499,3681,'ko','ë¶„ê¸°ë³„ë¡œ ì§ì› ê¸‰ì—¬ì˜ ëª©ë¡',0),(132500,3681,'he','×¨×©×™×ž×” ×©×œ ×”×¢×•×‘×“ ×œ×©×œ× ×œ×¤×™ ×¨×‘×¢×•×Ÿ',0),(132501,3681,'el','Î›Î¯ÏƒÏ„Î± Ï„Î·Ï‚ Î±Î¼Î¿Î¹Î²Î®Ï‚ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Î±Î½Î¬ Ï„ÏÎ¯Î¼Î·Î½Î¿',0),(132502,3681,'zh','æŒ‰å­£èŒå·¥è–ªé…¬åˆ—è¡¨\r\n',0),(132503,3681,'sv','Lista Ã¶ver anstÃ¤llda betala per kvartal',0),(132504,3681,'it','Elenco del dipendente paga di quarto',0),(132505,3681,'tl','',0),(132506,3681,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3648;&#3611;&#3655;&#3609;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;',0),(132507,3681,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¿à¤®à¤¾à¤¹à¥€ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(132508,3681,'ms','Senarai gaji pekerja pada suku',0),(132509,3681,'ar','Ù‚Ø§Ø¦Ù…Ø© Ù…Ù† Ø±Ø§ØªØ¨ Ø§Ù„Ù…ÙˆØ¸Ù Ø¨Ø§Ù„Ø±Ø¨Ø¹',0),(132510,3681,'fr','La liste de paie de l\'employÃ© par trimestre',0),(132511,3681,'jp','å››å?ŠæœŸåˆ¥å¾“æ¥­å“¡è³ƒé‡‘ã?®ä¸€è¦§',0),(132512,3681,'pt','Lista de funcionÃ¡rios paga por trimestre',0),(132513,3681,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°Ñ€Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð·Ð° ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(132514,3681,'es','Lista de Sueldos de Empleados por Trimestre',0),(132515,3681,'de','Liste der Mitarbeiter per Quartal bezahlen',0),(132516,3681,'en','List of Employee pay by Quarter',0),(132517,3682,'is','',0),(132518,3682,'dr','Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯Ø± Ù‡ÙØªÙ‡ ',0),(132519,3682,'pr','Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯Ø± Ù‡ÙØªÙ‡ ',0),(132520,3682,'tr','Haftaya gÃ¶re Ã§alÄ±ÅŸanÄ±n Ã¶deme listesi',0),(132521,3682,'pl','Lista pÅ‚ac pracownikÃ³w przez tydzieÅ„',0),(132522,3682,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¾Ñ‚ ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(132523,3682,'ur','ÛÙØªÛ’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ ÙÛØ±Ø³Øª',0),(132524,3682,'sr','Ð¡Ð¿Ð¸ÑÐ°Ðº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ð¿Ð»Ð°Ñ‚Ðµ Ð´Ð¾ ÐºÑ€Ð°Ñ˜Ð° Ð½ÐµÐ´ÐµÑ™Ðµ',0),(132525,3682,'vi','Danh sÃ¡ch nhÃ¢n viÃªn tráº£ lÆ°Æ¡ng theo tuáº§n',0),(132526,3682,'af','Lys van Werknemer Besoldiging per Week',0),(132527,3682,'ro','Lista de plata angajat de saptamana',0),(132528,3682,'et','Loetelu tÃ¶Ã¶tajate tasu nÃ¤dala jÃ¤rgi',0),(132529,3682,'si','Seznam zaposlenega plaÄa po tednu',0),(132530,3682,'ba','Daftar gaji karyawan minggu',0),(132531,3682,'nl','Lijst van werknemer betalen per Week',0),(132532,3682,'fi','Luettelo tyÃ¶ntekijÃ¶iden palkkojen viikolta',0),(132533,3682,'no','Liste over ansattes lÃ¸nn etter uke',0),(132534,3682,'da','Liste over medarbejder lÃ¸n ved uge',0),(132535,3682,'ko','ì£¼ ì—¬ ì§ì› ê¸‰ì—¬ì˜ ëª©ë¡',0),(132536,3682,'he','×¨×©×™×ž×” ×©×œ ×”×¢×•×‘×“ ×ª×©×œ×•× ×¢×“ ×©×‘×•×¢',0),(132537,3682,'el','Î›Î¯ÏƒÏ„Î± Ï„Î·Ï‚ Î±Î¼Î¿Î¹Î²Î®Ï‚ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(132538,3682,'zh','æŒ‰å‘¨èŒå·¥è–ªé…¬åˆ—è¡¨\r\n',0),(132539,3682,'sv','Lista Ã¶ver anstÃ¤llda betala av veckan',0),(132540,3682,'it','Elenco di retribuzione dei dipendenti di settimana',0),(132541,3682,'tl','',0),(132542,3682,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3648;&#3611;&#3655;&#3609;&#3619;&#3634;&#3618;&#3626;&#3633;&#3611;&#3604;&#3634;&#3',0),(132543,3682,'hi','à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(132544,3682,'ms','Senarai gaji pekerja minggu',0),(132545,3682,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø±Ø§ØªØ¨ Ø§Ù„Ù…ÙˆØ¸Ù Ù‚Ø¨Ù„ Ø£Ø³Ø¨ÙˆØ¹',0),(132546,3682,'fr','Liste de paie de l\'employÃ© par semaine',0),(132547,3682,'jp','é€±åˆ¥å¾“æ¥­å“¡è³ƒé‡‘ã?®ä¸€è¦§',0),(132548,3682,'pt','Lista de pagamento de empregado por semana',0),(132549,3682,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°Ñ€Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð·Ð° ÐÐµÐ´ÐµÐ»ÑŽ',0),(132550,3682,'es','Lista de Sueldos de Empleados por Semana',0),(132551,3682,'de','Liste der Mitarbeiter per Woche bezahlen',0),(132552,3682,'en','List of Employee pay by Week',0),(132553,3683,'is','',0),(132554,3683,'dr','Ù„ÙŠØ³Øª Ø´Ù…Ø§Ø±Ù‡ ØªÙ„ÙÙ† Ù‡Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(132555,3683,'pr','Ù„ÙŠØ³Øª Ø´Ù…Ø§Ø±Ù‡ ØªÙ„ÙÙ† Ù‡Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(132556,3683,'tr','Ã‡alÄ±ÅŸan telefon numaralarÄ± listesi',0),(132557,3683,'pl','Wykaz numerÃ³w telefonÃ³w pracownikÃ³w',0),(132558,3683,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(132559,3683,'ur','Ù…Ù„Ø§Ø²Ù… ÙÙˆÙ† Ù†Ù…Ø¨Ø±ÙˆÚº Ú©ÛŒ ÙÛØ±Ø³Øª',0),(132560,3683,'sr','Ð›Ð¸ÑÑ‚Ñƒ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(132561,3683,'vi','Danh sÃ¡ch phone nhÃ¢n viÃªn',0),(132562,3683,'af','Lys van Werknemer Foonnommers',0),(132563,3683,'ro','ListÄƒ de numere de telefon angajat',0),(132564,3683,'et','TÃ¶Ã¶tajate telefoninumbrite nimekiri',0),(132565,3683,'si','Seznam zaposlenega telefonskih Å¡tevilk',0),(132566,3683,'ba','Daftar nomor telepon karyawan',0),(132567,3683,'nl','Lijst met telefoonnummers van de werknemer',0),(132568,3683,'fi','TyÃ¶ntekijÃ¶iden puhelinnumeroluettelo',0),(132569,3683,'no','Liste over ansattes telefonnumre',0),(132570,3683,'da','Liste over medarbejder telefonnumre',0),(132571,3683,'ko','ì§ì› ì „í™” ë²ˆí˜¸ ëª©ë¡',0),(132572,3683,'he','×¨×©×™×ž×ª ×ž×¡×¤×¨×™ ×”×˜×œ×¤×•×Ÿ ×¢×•×‘×“',0),(132573,3683,'el','Î›Î¯ÏƒÏ„Î± Î±ÏÎ¹Î¸Î¼ÏŽÎ½ Ï„Î·Î»ÎµÏ†ÏŽÎ½Î¿Ï… Ï…Ï€Î±Î»Î»Î®Î»Î¿Ï…',0),(132574,3683,'zh','å‘˜å·¥ç”µè¯å·ç åå•\r\n',0),(132575,3683,'sv','Lista Ã¶ver anstÃ¤lldas telefonnummer',0),(132576,3683,'it','Elenco dei numeri di telefono dei dipendenti',0),(132577,3683,'tl','',0),(132578,3683,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(132579,3683,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤«à¥‹à¤¨ à¤¨à¤‚à¤¬à¤°à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(132580,3683,'ms','Senarai nombor telefon kakitangan',0),(132581,3683,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø£Ø±Ù‚Ø§Ù… Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ù…ÙˆØ¸Ù',0),(132582,3683,'fr','Liste des numÃ©ros de tÃ©lÃ©phone des employÃ©s',0),(132583,3683,'jp','å¾“æ¥­å“¡é›»è©±ç•ªå?·ãƒªã‚¹ãƒˆ',0),(132584,3683,'pt','Lista de nÃºmeros de telefone do funcionÃ¡rio',0),(132585,3683,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ñ… ÐÐ¾Ð¼ÐµÑ€Ð¾Ð² Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(132586,3683,'es','Lista de TelÃ©fonos de Empleados',0),(132587,3683,'de','Liste der Telefonnummern der Mitarbeiter',0),(132588,3683,'en','List of Employee Phone Numbers',0),(132589,3684,'is','',0),(132590,3684,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø¨Ø§ Ù†Ø§Ù… Ùˆ Ø¢Ø¯Ø±Ø³ Ùˆ ØªÙ„ÙÙ† ',0),(132591,3684,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø¨Ø§ Ù†Ø§Ù… Ùˆ Ø¢Ø¯Ø±Ø³ Ùˆ ØªÙ„ÙÙ† ',0),(132592,3684,'tr','Ã‡alÄ±ÅŸan adÄ± ve adresi ve telefon listesi',0),(132593,3684,'pl','Wykaz pracownikÃ³w z nazwy i adresu i telefonu',0),(132594,3684,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ñ Ð¸Ð¼Ðµ Ð¸ Ð°Ð´Ñ€ÐµÑ Ð¸ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(132595,3684,'ur','Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©Ø§ Ù†Ø§Ù… Ø§ÙˆØ± Ù¾ØªÛ Ø§ÙˆØ± ÙÙˆÙ† Ú©Û’ Ø³Ø§ØªÚ¾ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(132596,3684,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…, ÑÐ° Ð¸Ð¼Ðµ Ð¸ Ð°Ð´Ñ€ÐµÑÑƒ Ð¸ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(132597,3684,'vi','Danh sÃ¡ch nhÃ¢n viÃªn vá»›i tÃªn, Ä‘á»‹a chá»‰ & phone',0),(132598,3684,'af','Werknemerlys met Naam, Adres en Foonnommer',0),(132599,3684,'ro','Lista de angajati cu numele, adresa ÅŸi telefonul',0),(132600,3684,'et','Nimekiri tÃ¶Ã¶tajatest (Nimi, aadress, telefon)',0),(132601,3684,'si','Seznam zaposlenih s ime in naslov in telefon',0),(132602,3684,'ba','Daftar karyawan dengan nama dan alamat dan telepon',0),(132603,3684,'nl','Lijst van medewerkers met naam en adres en telefoon',0),(132604,3684,'fi','Luettelo tyÃ¶ntekijÃ¶istÃ¤, jossa nimi ja osoite ja puhelinnumero',0),(132605,3684,'no','Liste over ansatte med navn og adresse og telefonnummer',0),(132606,3684,'da','Liste over medarbejdere med navn og adresse og telefonnummer',0),(132607,3684,'ko','ì§ì› ì´ë¦„ ë° ì£¼ì†Œì™€ ì „í™” ëª©ë¡',0),(132608,3684,'he','×¨×©×™×ž×ª ×¢×•×‘×“×™× ×‘×¢×œ×™ ×©×, ×›×ª×•×‘×ª ×•×ž×¡×¤×¨ ×˜×œ×¤×•×Ÿ',0),(132609,3684,'el','Î›Î¯ÏƒÏ„Î± Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Î¼Îµ ÏŒÎ½Î¿Î¼Î±, Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· ÎºÎ±Î¹ Ï„Î·Î»Î­Ï†Ï‰Î½Î¿',0),(132610,3684,'zh','æœ‰åå­—ã€åœ°å€å’Œç”µè¯çš„å‘˜å·¥åˆ—è¡¨',0),(132611,3684,'sv','Lista med medarbetare med namn och adress och telefonnummer',0),(132612,3684,'it','Elenco dei dipendenti con nome, indirizzo e telefono',0),(132613,3684,'tl','',0),(132614,3684,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3614;&#3619;&#3657;&#3629;&#3617;&#3604;&#3657;&#3623;&#3618;&#3594;&#3639;&#3656;&#3629;&#3649;&#3621;&#3632;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3',0),(132615,3684,'hi','à¤¨à¤¾à¤® à¤”à¤° à¤ªà¤¤à¤¾ à¤”à¤° à¤«à¥‹à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(132616,3684,'ms','Senarai pekerja dengan nama dan alamat dan telefon',0),(132617,3684,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ† Ù…Ø¹ Ø§Ù„Ø§Ø³Ù… ÙˆØ§Ù„Ø¹Ù†ÙˆØ§Ù† ÙˆØ§Ù„Ù‡Ø§ØªÙ',0),(132618,3684,'fr','Liste des employÃ©s avec les nom, adresse et tÃ©lÃ©phone',0),(132619,3684,'jp','å??å‰?ã€?ä½?æ‰€ã€?é›»è©±ä»˜å¾“æ¥­å“¡ãƒªã‚¹ãƒˆ',0),(132620,3684,'pt','Lista de empregados com nome, endereÃ§o e telefone',0),(132621,3684,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² Ñ Ð˜Ð¼ÐµÐ½ÐµÐ¼ ÐÐ´Ñ€ÐµÑÐ¾Ð¼ Ð¸ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð¾Ð¼ ',0),(132622,3684,'es','Lista de Empleados con Nombre, DirecciÃ³n y TelÃ©fono',0),(132623,3684,'de','Liste der Mitarbeiter mit Namen und Adresse und Telefonnummer',0),(132624,3684,'en','List of Employees with Name and Address and Phone',0),(132625,3685,'is','',0),(132626,3685,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(132627,3685,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(132628,3685,'tr','Liste Ã¼zerinde tutun sipariÅŸler',0),(132629,3685,'pl','Lista zamÃ³wieÅ„ wstrzymane',0),(132630,3685,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(132631,3685,'ur','ÙÛØ±Ø³Øª Ù¾Ø± Ù¾Ú©Ú‘ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(132632,3685,'sr','Ð›Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð° Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(132633,3685,'vi','Danh SÃ¡ch cÃ¡c Ä‘Æ¡n hÃ ng táº¡m ngÆ°ng',0),(132634,3685,'af','Lys Gehoude Gedrukte Bestellings',0),(132635,3685,'ro','Comenzi de pe-Hold lista',0),(132636,3685,'et','Nimekiri-Hold tellimused',0),(132637,3685,'si','Seznam nalogov na Äakanju',0),(132638,3685,'ba','Daftar pada memegang perintah',0),(132639,3685,'nl','Lijst On-Hold Orders',0),(132640,3685,'fi','Luettelo pidossa tilaukset',0),(132641,3685,'no','Listen pÃ¥ Hold ordrer',0),(132642,3685,'da','Listen pÃ¥ Hold ordrer',0),(132643,3685,'ko','ëª©ë¡ì— ë³´ë¥˜ ì£¼ë¬¸',0),(132644,3685,'he','×”×–×ž× ×•×ª ×¢×œ-×œ×”×—×–×™×§ ×¨×©×™×ž×”',0),(132645,3685,'el','Î›Î¯ÏƒÏ„Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ On-Hold',0),(132646,3685,'zh','åˆ—å‡ºçŽ°æœ‰è®¢å•\r\n',0),(132647,3685,'sv','Listan SpÃ¤rrade order',0),(132648,3685,'it','Elenco ordini in sospeso',0),(132649,3685,'tl','',0),(132650,3685,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3617;&#3639;&#3629;',0),(132651,3685,'hi','à¤¸à¥‚à¤šà¥€ à¤ªà¤° à¤¹à¥‹à¤²à¥à¤¡ à¤†à¤¦à¥‡à¤¶',0),(132652,3685,'ms','Pesanan pada mengadakan senarai',0),(132653,3685,'ar','Ø£ÙˆØ§Ù…Ø± Ù‚Ø§Ø¦Ù…Ø© ÙÙŠ Ø§Ù„Ø§Ù†ØªØ¸Ø§Ø±',0),(132654,3685,'fr','Liste les commandes en attente',0),(132655,3685,'jp','æ‰‹æŒ?ã?¡æ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(132656,3685,'pt','Lista de espera de ordens',0),(132657,3685,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð° ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ð¸',0),(132658,3685,'es','Lista de Ordenes en Espera',0),(132659,3685,'de','Liste-On-Hold-AuftrÃ¤ge',0),(132660,3685,'en','List On-Hold Orders',0),(132661,3686,'is','',0),(132662,3686,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡',0),(132663,3686,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡',0),(132664,3686,'tr','Vadesi geÃ§miÅŸ (geÃ§) emirleri listesi',0),(132665,3686,'pl','Lista zalegÅ‚e zamÃ³wienia (koniec)',0),(132666,3686,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸ (ÐºÑŠÑÐ½Ð¾) Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(132667,3686,'ur','Ù…ÙˆØ®Ø± (Ù…Ø±Ø­ÙˆÙ…) Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(132668,3686,'sr','Ð›Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð° Ð´Ð¾ÑÐ¿ÐµÐ»Ð¾ (ÐºÐ°ÑÐ½Ð¾)',0),(132669,3686,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng quÃ¡ háº¡n (muá»™n)',0),(132670,3686,'af','Lys Agterstallige Uitgedrukte Bestellings',0),(132671,3686,'ro','Lista comenzi restante (tarziu)',0),(132672,3686,'et','TÃ¤htaja Ã¼letanud (hiline) tellimuste loend',0),(132673,3686,'si','Seznam zaostalih naroÄil (pozno)',0),(132674,3686,'ba','Daftar pesanan tertunda (almarhum)',0),(132675,3686,'nl','Lijst van achterstallige (late) Orders',0),(132676,3686,'fi','Luettelo myÃ¶hÃ¤ssÃ¤ (myÃ¶hÃ¤ssÃ¤) tilaukset',0),(132677,3686,'no','Listen forfalt (sen) ordrer',0),(132678,3686,'da','Liste over forfaldne (sent) ordrer',0),(132679,3686,'ko','ì—°ì²´ (í›„ë°˜) ì£¼ë¬¸ ëª©ë¡',0),(132680,3686,'he','×¨×©×™×ž×ª ×”×–×ž× ×•×ª (×”×ž× ×•×—) ×©×¤×¨×¢×•× ×Ÿ ×—×œ×£',0),(132681,3686,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Î›Î·Î¾Î¹Ï€ÏÏŒÎ¸ (Î±ÏÎ³Î¬)',0),(132682,3686,'zh','é€¾æœŸåå•ï¼ˆæ™šï¼‰ä»¤\r\n',0),(132683,3686,'sv','Listan fÃ¶rfallna (sent) order',0),(132684,3686,'it','Elenco ordini (in ritardo) in ritardo',0),(132685,3686,'tl','',0),(132686,3686,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632; ',0),(132687,3686,'hi','à¤…à¤¤à¤¿à¤¦à¥‡à¤¯ (à¤¸à¥à¤µà¤°à¥à¤—à¥€à¤¯) à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(132688,3686,'ms','Senarai pesanan (Allahyarham) yang lampau tempoh',0),(132689,3686,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…ØªØ£Ø®Ø±Ø© (Ø§Ù„Ø±Ø§Ø­Ù„)',0),(132690,3686,'fr','La liste des commandes (tardives) en retard',0),(132691,3686,'jp','æœŸé™?çµŒé?Žï¼ˆé?…å»¶ï¼‰æ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(132692,3686,'pt','Lista de ordens (tarde) em atraso',0),(132693,3686,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(132694,3686,'es','Lista de Ordenes Vencidos',0),(132695,3686,'de','Liste Ã¼berfÃ¤llig (spÃ¤t) Bestellungen',0),(132696,3686,'en','List Overdue (late) Orders',0),(132697,3687,'is','',0),(132698,3687,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹ÙˆÙ‚',0),(132699,3687,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹ÙˆÙ‚',0),(132700,3687,'tr','Bekleyen sipariÅŸler listesi',0),(132701,3687,'pl','Lista zamÃ³wieÅ„',0),(132702,3687,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð²Ð¸ÑÑÑ‰Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(132703,3687,'ur','ÙÛØ±Ø³Øª Ø§Ø­Ú©Ø§Ù… Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(132704,3687,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸Ñ… Ð½Ð°Ð»Ð¾Ð³Ð°',0),(132705,3687,'vi','Danh SÃ¡ch cÃ¡c Ä‘Æ¡n hÃ ng chÆ°a lÃ m',0),(132706,3687,'af','Lys Afwagtende \"Print\" Bestellings',0),(132707,3687,'ro','Lista Ã®n aÅŸteptarea comenzilor',0),(132708,3687,'et','Loendi ootel tellimused',0),(132709,3687,'si','Seznam ÄakajoÄa naroÄila',0),(132710,3687,'ba','Daftar Pending Order',0),(132711,3687,'nl','Lijst in afwachting van Orders',0),(132712,3687,'fi','Luettelon odottavien toimeksiantojen',0),(132713,3687,'no','Listen ventende bestillinger',0),(132714,3687,'da','Liste over afventende ordrer',0),(132715,3687,'ko','ë³´ë¥˜ ì¤‘ì¸ ì£¼ë¬¸ ëª©ë¡',0),(132716,3687,'he','×¨×©×™×ž×ª ×”×•×¨××•×ª ×ž×ž×ª×™× ×•×ª',0),(132717,3687,'el','Î›Î¯ÏƒÏ„Î± ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(132718,3687,'zh','åˆ—å‡ºå¾…å¤„ç†è®¢å•\r\n',0),(132719,3687,'sv','Lista avvaktande ordrar',0),(132720,3687,'it','Elenco ordini pendenti',0),(132721,3687,'tl','',0),(132722,3687,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(132723,3687,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶ à¤¸à¥‚à¤šà¥€',0),(132724,3687,'ms','Senarai pesanan dagangan tertunda',0),(132725,3687,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(132726,3687,'fr','Liste des commandes en attente',0),(132727,3687,'jp','ä¿?ç•™ä¸­æ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(132728,3687,'pt','Lista de ordens pendentes',0),(132729,3687,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¾Ñ‚Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ñ€Ð´ÐµÑ€Ð¾Ð²',0),(132730,3687,'es','Listar Pedidos Pendientes',0),(132731,3687,'de','Liste noch nicht erledigten AuftrÃ¤ge',0),(132732,3687,'en','List Pending Orders',0),(132733,3688,'is','',0),(132734,3688,'dr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(132735,3688,'pr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(132736,3688,'tr','SipariÅŸ listelerini YazdÄ±r',0),(132737,3688,'pl','KolejnoÅ›Ä‡ drukowania listy',0),(132738,3688,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑÐ¿Ð¸ÑÑŠÑ†Ð¸',0),(132739,3688,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(132740,3688,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(132741,3688,'vi','Danh SÃ¡ch cÃ¡c Ä‘Æ¡n hÃ ng in',0),(132742,3688,'af','Druk Bestellingslyste',0),(132743,3688,'ro','Listele de ordine de imprimare',0),(132744,3688,'et','Prindi tellimusnimekirja',0),(132745,3688,'si','Vrstni red tiskanja sezname',0),(132746,3688,'ba','Mencetak daftar urutan',0),(132747,3688,'nl','Afdrukvolgorde lijsten',0),(132748,3688,'fi','TulostusjÃ¤rjestyksen luettelot',0),(132749,3688,'no','UtskriftsrekkefÃ¸lge lister',0),(132750,3688,'da','Udskrive ordre lister',0),(132751,3688,'ko','ì¸ì‡„ ìˆœì„œ ëª©ë¡',0),(132752,3688,'he','×¡×“×¨ ×”×”×“×¤×¡×” ×¨×©×™×ž×•×ª',0),(132753,3688,'el','ÎŸÎ¹ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Ï„Î·Ï‚ ÏƒÎµÎ¹ÏÎ¬Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(132754,3688,'zh','æ‰“å°è®¢å•åˆ—è¡¨\r\n',0),(132755,3688,'sv','Utskriftsordning listor',0),(132756,3688,'it','Ordine di stampa elenchi',0),(132757,3688,'tl','',0),(132758,3688,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(132759,3688,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(132760,3688,'ms','Cetak senarai',0),(132761,3688,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ù†Ø¸Ø§Ù…',0),(132762,3688,'fr','Listes d\'ordre d\'impression',0),(132763,3688,'jp','æ³¨æ–‡ãƒªã‚¹ãƒˆã?®å?°åˆ·',0),(132764,3688,'pt','Listas de ordem de impressÃ£o',0),(132765,3688,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(132766,3688,'es','Imprimir Listas de Pedidos',0),(132767,3688,'de','Bestelllisten drucken',0),(132768,3688,'en','Print Order Lists',0),(132769,3689,'is','',0),(132770,3689,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ú†Ø§Ù¾  Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡',0),(132771,3689,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ú†Ø§Ù¾  Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡',0),(132772,3689,'tr','YazdÄ±rma tekliflerinin listesi',0),(132773,3689,'pl','Wykaz ofert Drukuj',0),(132774,3689,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð¸Ñ‚Ðµ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(132775,3689,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(132776,3689,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(132777,3689,'vi','Danh sÃ¡ch BÃ¡o giÃ¡ in',0),(132778,3689,'af','Lyste van gedrukte aanhalings',0),(132779,3689,'ro','Liste de imprimare citate',0),(132780,3689,'et','Prindi loetelu Quotes',0),(132781,3689,'si','Seznami tiskanja ponudb',0),(132782,3689,'ba','Daftar kutipan cetak',0),(132783,3689,'nl','Lijsten voor Print Quotes',0),(132784,3689,'fi','Tulosta luettelo Quotes',0),(132785,3689,'no','Lister over Print sitater',0),(132786,3689,'da','Lister over Print citater',0),(132787,3689,'ko','ì¸ì‡„ ë”°ì˜´í‘œì˜ ëª…ë¶€',0),(132788,3689,'he','×¨×©×™×ž×ª ×”×¦×¢×•×ª ×ž×—×™×¨ ×”×”×“×¤×¡×”',0),(132789,3689,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ Ï„Î·Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(132790,3689,'zh','åˆ—å‡ºæ‰“å°æŠ¥ä»·\r\n',0),(132791,3689,'sv','Listor fÃ¶r Print citat',0),(132792,3689,'it','Elenchi di citazioni stampa',0),(132793,3689,'tl','',0),(132794,3689,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(132795,3689,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤•à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(132796,3689,'ms','Senarai sebut harga cetakan',0),(132797,3689,'ar','Ù‚ÙˆØ§Ø¦Ù… Ù„Ø·Ø¨Ø§Ø¹Ø© Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(132798,3689,'fr','Listes de citations impression',0),(132799,3689,'jp','å?°åˆ·è¦‹ç©?ã‚Šã?®ãƒªã‚¹ãƒˆ',0),(132800,3689,'pt','Listas de citaÃ§Ãµes de impressÃ£o',0),(132801,3689,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(132802,3689,'es','Listas de Cotizaciones de ImpresiÃ³n',0),(132803,3689,'de','Listen drucken-Zitate',0),(132804,3689,'en','Lists of Print Quotes',0),(132805,3690,'is','',0),(132806,3690,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(132807,3690,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(132808,3690,'tr','SipariÅŸ sevk listesini yazdÄ±r',0),(132809,3690,'pl','Listy wysÅ‚ane druku zamÃ³wienia',0),(132810,3690,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(132811,3690,'ur','ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº Ø­Ú©Ù… Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Û”',0),(132812,3690,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(132813,3690,'vi','Danh SÃ¡ch cÃ¡c Ä‘Æ¡n hÃ ng in Ä‘Ã£ váº­n chuyá»ƒn',0),(132814,3690,'af','Lys Versende Gedrukte Bestellings',0),(132815,3690,'ro','Lista expediate ordine de imprimare',0),(132816,3690,'et','Loetelu saadetakse trÃ¼kitÃ¶Ã¶de tellimused',0),(132817,3690,'si','Seznam odpremljeno tiskanje nalogov',0),(132818,3690,'ba','Daftar dikirim pesanan cetak',0),(132819,3690,'nl','Lijst afdrukken bestellingen verzonden',0),(132820,3690,'fi','Luettelo toimitetaan tulosta tilaukset',0),(132821,3690,'no','Listen sendt bestilling',0),(132822,3690,'da','Listen sendes aftryksbestillinger',0),(132823,3690,'ko','ì¶œí•˜ ëª©ë¡ ì¸ì‡„ ì£¼ë¬¸',0),(132824,3690,'he','×¨×©×™×ž×ª ×©× ×©×œ×—×• ×”×“×¤×¡×•×ª',0),(132825,3690,'el','Î›Î¯ÏƒÏ„Î± Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½',0),(132826,3690,'zh','åˆ—å‡ºå‘è¿æ‰“å°è®¢å•\r\n',0),(132827,3690,'sv','Lista levereras Print Order',0),(132828,3690,'it','Ordini di stampa elenco spedito',0),(132829,3690,'tl','',0),(132830,3690,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(132831,3690,'hi','à¤¸à¥‚à¤šà¥€ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(132832,3690,'ms','Pesanan cetakan senarai yang dihantar',0),(132833,3690,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø´Ø­Ù† Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(132834,3690,'fr','Commandes expÃ©diÃ©e de liste',0),(132835,3690,'jp','ç™ºé€?æ¸ˆå?°åˆ·æ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(132836,3690,'pt','Lista enviados pedidos de impressÃ£o',0),(132837,3690,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(132838,3690,'es','Listar Ordenes de ImpresiÃ³n Enviados',0),(132839,3690,'de','Liste versandt DruckauftrÃ¤ge',0),(132840,3690,'en','List Shipped Print Orders',0),(132841,3691,'is','',0),(132842,3691,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ ',0),(132843,3691,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ ',0),(132844,3691,'tr','Listeler',0),(132845,3691,'pl','List',0),(132846,3691,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸',0),(132847,3691,'ur','ÙÛØ±Ø³ØªÛŒÚº',0),(132848,3691,'sr','Ð›Ð¸ÑÑ‚Ðµ',0),(132849,3691,'vi','Danh sÃ¡ch',0),(132850,3691,'af','Lyste',0),(132851,3691,'ro','Liste',0),(132852,3691,'et','Nimekirjad',0),(132853,3691,'si','Seznami',0),(132854,3691,'ba','Daftar',0),(132855,3691,'nl','Lijsten',0),(132856,3691,'fi','Luettelot',0),(132857,3691,'no','Lister',0),(132858,3691,'da','Lister',0),(132859,3691,'ko','ëª©ë¡',0),(132860,3691,'he','×¨×©×™×ž×•×ª',0),(132861,3691,'el','Î›Î¯ÏƒÏ„ÎµÏ‚',0),(132862,3691,'zh','åˆ—è¡¨\r\n',0),(132863,3691,'sv','Listor',0),(132864,3691,'it','Elenchi',0),(132865,3691,'tl','',0),(132866,3691,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(132867,3691,'hi','à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(132868,3691,'ms','Senarai',0),(132869,3691,'ar','Ù‚ÙˆØ§Ø¦Ù…',0),(132870,3691,'fr','Listes',0),(132871,3691,'jp','ãƒªã‚¹ãƒˆ',0),(132872,3691,'pt','Listas',0),(132873,3691,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸',0),(132874,3691,'es','Listas',0),(132875,3691,'de','Listen',0),(132876,3691,'en','Lists',0),(132877,3692,'is','',0),(132878,3692,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ Ùˆ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ØµØ§Ø¯Ø±Ø§ØªÙŠ Ø§Ø² Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(132879,3692,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ Ùˆ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ØµØ§Ø¯Ø±Ø§ØªÙŠ Ø§Ø² Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(132880,3692,'tr','Listeleri ve mÃ¼ÅŸteri verilerini ihracatÄ±',0),(132881,3692,'pl','List i wywÃ³z dane klienta',0),(132882,3692,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð¸ Ð¸Ð·Ð½Ð¾Ñ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(132883,3692,'ur','ÙÛØ±Ø³ØªÙˆÚº Ø§ÙˆØ± Ú¯Ø§ÛÚ© Ú©ÙˆØ§Ø¦Ù Ú©ÛŒ Ø¨Ø±Ø¢Ù…Ø¯Ø§Øª',0),(132884,3692,'sr','Ð›Ð¸ÑÑ‚Ðµ Ð¸ Ð¸Ð·Ð²Ð¾Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¾ ÐºÑƒÐ¿Ñ†Ð¸Ð¼Ð°',0),(132885,3692,'vi','Danh sÃ¡ch vÃ  xuáº¥t dá»¯ liá»‡u khÃ¡ch hÃ ng',0),(132886,3692,'af','Lyste en Uitvoere van KliÃ«nt/Klant Data',0),(132887,3692,'ro','Liste È™i exporturile de date client',0),(132888,3692,'et','Nimekirjad ja klientide andmete eksport',0),(132889,3692,'si','Seznami in izvoz podatkov o strankah',0),(132890,3692,'ba','Daftar dan ekspor data pelanggan',0),(132891,3692,'nl','Lijsten en uitvoer van klantgegevens',0),(132892,3692,'fi','Luettelot ja viennin asiakastietoja',0),(132893,3692,'no','Lister og eksport av kundedata',0),(132894,3692,'da','Lister og eksport af kundedata',0),(132895,3692,'ko','ëª©ë¡ ë° ê³ ê° ë°ì´í„°ì˜ ìˆ˜ì¶œ',0),(132896,3692,'he','×™×¦×•× × ×ª×•× ×™ ×œ×§×•×—×•×ª ×•×¨×©×™×ž×•×ª',0),(132897,3692,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ ÎºÎ±Î¹ ÎµÎ¾Î±Î³Ï‰Î³Î­Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(132898,3692,'zh','åˆ—è¡¨å’Œå®¢æˆ·æ•°æ®å¯¼å‡º\r\n',0),(132899,3692,'sv','Listor och export av kunddata',0),(132900,3692,'it','Gli elenchi e le esportazioni di dati cliente',0),(132901,3692,'tl','',0),(132902,3692,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(132903,3692,'hi','à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤ à¤”à¤° à¤—à¥à¤°à¤¾à¤¹à¤• à¤¡à¥‡à¤Ÿà¤¾ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤',0),(132904,3692,'ms','Senarai dan eksport data pelanggan',0),(132905,3692,'ar','Ù‚ÙˆØ§Ø¦Ù… ÙˆØªØµØ¯ÙŠØ± Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(132906,3692,'fr','Listes et exportations des donnÃ©es clients',0),(132907,3692,'jp','ãƒªã‚¹ãƒˆã?¨é¡§å®¢ãƒ‡ãƒ¼ã‚¿ã?®ã‚¨ã‚¯ã‚¹ãƒ?ãƒ¼ãƒˆ',0),(132908,3692,'pt','Listas e exportaÃ§Ã£o de dados do cliente',0),(132909,3692,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¸ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(132910,3692,'es','Listas y Exportaciones de Datos de Clientes',0),(132911,3692,'de','Listen und Export von Kundendaten',0),(132912,3692,'en','Lists and Exports of Customer Data',0),(132913,3693,'is','',0),(132914,3693,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ú†Ùƒ Ù‡Ø§',0),(132915,3693,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ú†Ùƒ Ù‡Ø§',0),(132916,3693,'tr','Denetim listeleri',0),(132917,3693,'pl','Listy kontrole',0),(132918,3693,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸Ñ‚Ðµ',0),(132919,3693,'ur','Ú©ÛŒ Ú†ÛŒÚ© Ù„Ø³Ù¹',0),(132920,3693,'sr','Ð›Ð¸ÑÑ‚Ðµ Ñ‡ÐµÐºÐ¾Ð²Ð°',0),(132921,3693,'vi','Danh sÃ¡ch SÃ©c',0),(132922,3693,'af','Lyste van Tjeks',0),(132923,3693,'ro','Listele de control',0),(132924,3693,'et','Kontrollimiste loendid',0),(132925,3693,'si','Seznami pregledov',0),(132926,3693,'ba','Daftar cek',0),(132927,3693,'nl','Lijsten van controles',0),(132928,3693,'fi','Luettelo tarkastukset',0),(132929,3693,'no','Lister over sjekker',0),(132930,3693,'da','Lister over kontrol',0),(132931,3693,'ko','ê²€ì‚¬ ëª©ë¡',0),(132932,3693,'he','×¨×©×™×ž×•×ª ×¦\'×§×™×',0),(132933,3693,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ ÎµÎ»Î­Î³Ï‡Ï‰Î½',0),(132934,3693,'zh','æ”¯ç¥¨åˆ—è¡¨\r\n',0),(132935,3693,'sv','Listor av kontroller',0),(132936,3693,'it','Liste di controllo',0),(132937,3693,'tl','',0),(132938,3693,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3648;&#3594;&#3655;&#3588;',0),(132939,3693,'hi','à¤œà¤¾à¤à¤šà¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(132940,3693,'ms','Senarai Semakan',0),(132941,3693,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„ØµÙƒÙˆÙƒ',0),(132942,3693,'fr','Listes de vÃ©rifications',0),(132943,3693,'jp','ãƒ?ã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆ',0),(132944,3693,'pt','Listas de verificaÃ§Ãµes',0),(132945,3693,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¾Ðº',0),(132946,3693,'es','Listas de Cheques',0),(132947,3693,'de','Listen der Kontrollen',0),(132948,3693,'en','Lists of Checks',0),(132949,3694,'is','',0),(132950,3694,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ú†ÙƒÙ‡Ø§ÙŠ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ ',0),(132951,3694,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ú†ÙƒÙ‡Ø§ÙŠ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ ',0),(132952,3694,'tr','YazÄ±lÄ± denetim listeleri',0),(132953,3694,'pl','Listy kontrole napisaÅ‚',0),(132954,3694,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¿Ð¸ÑÐ¼ÐµÐ½Ð¾',0),(132955,3694,'ur','Ù„Ú©Ú¾Ø§ Ù¾Ú‘ØªØ§Ù„ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(132956,3694,'sr','Ð›Ð¸ÑÑ‚Ðµ Ñ‡ÐµÐºÐ¾Ð²Ð° Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(132957,3694,'vi','Danh sÃ¡ch SÃ©c Ä‘Ã£ viáº¿t',0),(132958,3694,'af','Lyste van Tjeks Uitgeskryf',0),(132959,3694,'ro','Liste de control scris',0),(132960,3694,'et','Kirjutada kontrollimiste loendid',0),(132961,3694,'si','Seznami pregledov napisal',0),(132962,3694,'ba','Daftar cek ditulis',0),(132963,3694,'nl','Lijsten van controles geschreven',0),(132964,3694,'fi','Luettelo tarkastuksia kirjoitettu',0),(132965,3694,'no','Lister over sjekker skrevet',0),(132966,3694,'da','Lister over kontrol skrevet',0),(132967,3694,'ko','ê²€ì‚¬ ìž‘ì„±ì˜ ëª©ë¡',0),(132968,3694,'he','×¨×©×™×ž×•×ª ×¦\'×§×™× ×©× ×›×ª×‘×•',0),(132969,3694,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ ÎµÎ»Î­Î³Ï‡Ï‰Î½ Î³ÏÎ±Î¼Î¼Î­Î½Î¿',0),(132970,3694,'zh','ä¹¦å†™æ”¯ç¥¨æ¸…å•\r\n',0),(132971,3694,'sv','Listor Ã¶ver kontroller skrivna',0),(132972,3694,'it','Elenchi di controlli scritti',0),(132973,3694,'tl','',0),(132974,3694,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;',0),(132975,3694,'hi','à¤²à¤¿à¤–à¤¾ à¤šà¥‡à¤• à¤•à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(132976,3694,'ms','Senarai Semakan yang ditulis',0),(132977,3694,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø¨Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø®Ø·ÙŠØ©',0),(132978,3694,'fr','Listes des chÃ¨ques Ã©mis',0),(132979,3694,'jp','æ›¸ã??è¾¼ã?¿æ¸ˆå°?åˆ‡æ‰‹ã?®ãƒªã‚¹ãƒˆ',0),(132980,3694,'pt','Listas de verificaÃ§Ãµes escritas',0),(132981,3694,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ñ‡ÐµÐºÐ¾Ð²',0),(132982,3694,'es','Listas de Cheques Elaborados',0),(132983,3694,'de','Listen der Kontrollen geschrieben',0),(132984,3694,'en','Lists of Checks Written',0),(132985,3695,'is','',0),(132986,3695,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(132987,3695,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(132988,3695,'tr','Sevk Ã¶ÄŸe listeleri',0),(132989,3695,'pl','Wykaz Elementy wysÅ‚ane',0),(132990,3695,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(132991,3695,'ur','Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(132992,3695,'sr','Ð›Ð¸ÑÑ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð°',0),(132993,3695,'vi','Danh sÃ¡ch hÃ ng chuyá»ƒn',0),(132994,3695,'af','Lys van Items Versend',0),(132995,3695,'ro','Liste de articole expediate',0),(132996,3695,'et','LÃ¤hetatud kaupade loendid',0),(132997,3695,'si','Seznami dobavljenih artiklov',0),(132998,3695,'ba','Daftar item dikirim',0),(132999,3695,'nl','Lijsten met Items verzonden',0),(133000,3695,'fi','Toimitettujen nimikkeiden luettelo',0),(133001,3695,'no','Lister over elementer sendt',0),(133002,3695,'da','Lister af leverede varer',0),(133003,3695,'ko','ì œê³µ ëœ í•­ëª©ì˜ ëª©ë¡',0),(133004,3695,'he','×¨×©×™×ž×•×ª ×¤×¨×™×˜×™× ×©× ×©×œ×—×•',0),(133005,3695,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(133006,3695,'zh','å‘è´§ç‰©å“æ¸…å•\r\n',0),(133007,3695,'sv','Listor med element levereras',0),(133008,3695,'it','Liste di oggetti spediti',0),(133009,3695,'tl','',0),(133010,3695,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(133011,3695,'hi','à¤†à¤‡à¤Ÿà¤® à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤•à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(133012,3695,'ms','Senarai barang-barang yang dihantar',0),(133013,3695,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø¨Ø§Ù„Ù…ÙˆØ§Ø¯ Ø§Ù„ØªÙŠ ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(133014,3695,'fr','Listes des articles expÃ©diÃ©s',0),(133015,3695,'jp','ç™ºé€?æ¸ˆå“?ç›®ã?®ãƒªã‚¹ãƒˆ',0),(133016,3695,'pt','Listas de itens enviados',0),(133017,3695,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð¾Ð² Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð°, Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ñ…',0),(133018,3695,'es','Listas de Items Enviados',0),(133019,3695,'de','Listen von Elementen ausgeliefert',0),(133020,3695,'en','Lists of Items Shipped',0),(133021,3696,'is','',0),(133022,3696,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¯Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(133023,3696,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¯Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(133024,3696,'tr','SipariÅŸleri aÃ§ Ã¶ÄŸe listeleri',0),(133025,3696,'pl','List otwarty towarÃ³w na zamÃ³wieniach',0),(133026,3696,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(133027,3696,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ú©Ú¾Ù„ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(133028,3696,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ð¾ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÑƒ',0),(133029,3696,'vi','Danh sÃ¡ch máº·t hÃ ng má»Ÿ cá»§a Ä‘Æ¡n hÃ ng',0),(133030,3696,'af','Lyste van Oop Items op Bestellings',0),(133031,3696,'ro','Liste de elemente deschise pe comenzi',0),(133032,3696,'et','Tellimustele avatud Ã¼ksuste loendid',0),(133033,3696,'si','Seznam odprtih elementov na naroÄila',0),(133034,3696,'ba','Daftar Buka item pesanan',0),(133035,3696,'nl','Lijsten van geopende Items op bestellingen',0),(133036,3696,'fi','Luettelo avoimista kohteista tilauksista',0),(133037,3696,'no','Liste over Ã¥pne elementer pÃ¥ ordrer',0),(133038,3696,'da','Lister over Ã¥bne elementer pÃ¥ ordrer',0),(133039,3696,'ko','ì£¼ë¬¸ì— ëŒ€í•´ ì—´ë ¤ ìžˆëŠ” í•­ëª©ì˜ ëª©ë¡',0),(133040,3696,'he','×¨×©×™×ž×•×ª ×¤×¨×™×˜×™× ×¤×ª×•×—×™× ×¢×œ ×”×–×ž× ×•×ª',0),(133041,3696,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Ï„Ï‰Î½ Î±Î½Î¿Î¹Ï‡Ï„ÏŽÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(133042,3696,'zh','è®¢å•å¼€æ”¾é¡¹ç›®åˆ—è¡¨\r\n',0),(133043,3696,'sv','Listor Ã¶ver Ã¶ppna poster pÃ¥ order',0),(133044,3696,'it','Elenchi di elementi aperti gli ordini',0),(133045,3696,'tl','',0),(133046,3696,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(133047,3696,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤–à¥à¤²à¥‡ à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(133048,3696,'ms','Senarai item terbuka pada pesanan',0),(133049,3696,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…ÙØªÙˆØ­Ø© Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø±',0),(133050,3696,'fr','Listes d\'articles ouverts des commandes',0),(133051,3696,'jp','æ³¨æ–‡ã?®ã‚ªãƒ¼ãƒ—ãƒ³å“?ç›®ã?®ãƒªã‚¹ãƒˆ',0),(133052,3696,'pt','Listas de itens abertos por ordem',0),(133053,3696,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¹ Ð¿Ð¾ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ñƒ',0),(133054,3696,'es','Listas de Items Abiertos en Pedidos',0),(133055,3696,'de','Listen der offenen Posten auf Bestellungen',0),(133056,3696,'en','Lists of Open Items on Orders',0),(133057,3697,'is','',0),(133058,3697,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² Ù…Ù†ØªØ¸Ø±',0),(133059,3697,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² Ù…Ù†ØªØ¸Ø±',0),(133060,3697,'tr','Bekleyen sipariÅŸler aÃ§Ä±k listesi',0),(133061,3697,'pl','Wykaz otwartych zamÃ³wieÅ„',0),(133062,3697,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð²Ð¸ÑÑÑ‰Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(133063,3697,'ur','Ú©Ú¾Ù„ÛŒ Ø§Ø´Ø®Ø§Øµ Ú©Û’ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(133064,3697,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸Ñ… ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ°',0),(133065,3697,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng má»Ÿ chÆ°a lÃ m',0),(133066,3697,'af','Lys van Oop Afwagtende Bestellings',0),(133067,3697,'ro','Liste de deschise Ã®n aÅŸteptarea comenzilor',0),(133068,3697,'et','Nimekirjad avatud ootel tellimustest',0),(133069,3697,'si','Seznami Open ÄakajoÄa naroÄila',0),(133070,3697,'ba','Daftar terbuka Pending Order',0),(133071,3697,'nl','Lijsten van Open in afwachting van Orders',0),(133072,3697,'fi','Luettelo avaa odottavien toimeksiantojen',0),(133073,3697,'no','Liste over Ã¥pne ventende bestillinger',0),(133074,3697,'da','Lister over Ã¥ben afventende ordrer',0),(133075,3697,'ko','ì£¼ë¬¸ ë³´ë¥˜ ì¤‘ì¸ ì˜¤í”ˆì˜ ëª©ë¡',0),(133076,3697,'he','×¨×©×™×ž×•×ª ×©×œ ×¤×ª×•×— ×”×•×¨××•×ª ×ž×ž×ª×™× ×•×ª',0),(133077,3697,'el','ÎšÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï…Ï‚ Ï„Î¿Ï… Open ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(133078,3697,'zh','å¼€æ”¾å¾…å¤„ç†è®¢å•åˆ—è¡¨\r\n',0),(133079,3697,'sv','Listor Ã¶ver Ã¶ppna avvaktan order',0),(133080,3697,'it','Elenchi degli Open ordini pendenti',0),(133081,3697,'tl','',0),(133082,3697,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3588;&#3',0),(133083,3697,'hi','à¤–à¥à¤²à¤¾ à¤²à¤‚à¤¬à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(133084,3697,'ms','Senarai terbuka pesanan dagangan tertunda',0),(133085,3697,'ar','Ù‚ÙˆØ§Ø¦Ù… Ù…ÙØªÙˆØ­Ø© Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(133086,3697,'fr','Listes de Open commandes en attente',0),(133087,3697,'jp','ã‚ªãƒ¼ãƒ—ãƒ³ä¿?ç•™ä¸­æ³¨æ–‡ã?®ãƒªã‚¹ãƒˆ',0),(133088,3697,'pt','Listas do Open ordens pendentes',0),(133089,3697,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð² Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(133090,3697,'es','Listas de Pedidos Abiertos Pendientes',0),(133091,3697,'de','Listen der offenen, noch nicht erledigten AuftrÃ¤ge',0),(133092,3697,'en','Lists of Open Pending Orders',0),(133093,3698,'is','',0),(133094,3698,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø­Ø³Ø§Ø¨â€ŒÙ‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(133095,3698,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø­Ø³Ø§Ø¨â€ŒÙ‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(133096,3698,'tr','BorÃ§lar listesi',0),(133097,3698,'pl','Wykaz zobowiÄ…zaÅ„',0),(133098,3698,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(133099,3698,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(133100,3698,'sr','Ð›Ð¸ÑÑ‚Ðµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(133101,3698,'vi','Danh SÃ¡ch Pháº£i Tráº£',0),(133102,3698,'af','Lys van Uitgawes (RB)',0),(133103,3698,'ro','Liste de datorii',0),(133104,3698,'et','Loetelu vÃµlad',0),(133105,3698,'si','Seznam obveznosti',0),(133106,3698,'ba','Daftar hutang',0),(133107,3698,'nl','Lijsten van schulden',0),(133108,3698,'fi','Luettelo Ostovelat',0),(133109,3698,'no','Lister over leverandÃ¸rgjeld',0),(133110,3698,'da','Lister af Kreditorstyring',0),(133111,3698,'ko','ë¯¸ì§€ê¸‰ê¸ˆì˜ ëª©ë¡',0),(133112,3698,'he','×¨×©×™×ž×ª ×–×›××™×',0),(133113,3698,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Ï„Ï‰Î½ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(133114,3698,'zh','åº”ä»˜æ¬¾é¡¹åˆ—è¡¨\r\n',0),(133115,3698,'sv','Listor Ã¶ver LeverantÃ¶rsskulder',0),(133116,3698,'it','Elenchi dei debiti',0),(133117,3698,'tl','',0),(133118,3698,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(133119,3698,'hi','Payables à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(133120,3698,'ms','Senarai pemiutang',0),(133121,3698,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹',0),(133122,3698,'fr','Listes des comptes fournisseurs',0),(133123,3698,'jp','è²·æŽ›é‡‘ãƒªã‚¹ãƒˆ',0),(133124,3698,'pt','Listas de contas a pagar',0),(133125,3698,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(133126,3698,'es','Listas de Cuentas por Pagar',0),(133127,3698,'de','Listen von Verbindlichkeiten',0),(133128,3698,'en','Lists of Payables',0),(133129,3699,'is','',0),(133130,3699,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³Ø·ÙˆØ­ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(133131,3699,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³Ø·ÙˆØ­ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(133132,3699,'tr','DÃ¼zeyleri iÃ§in stok satÄ±ÅŸ fiyat listeleri',0),(133133,3699,'pl','Wykaz cen poziom sprzedaÅ¼y zapasÃ³w',0),(133134,3699,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ð½Ð¸Ð²Ð° Ð·Ð° ÑÐºÐ»Ð°Ð´ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(133135,3699,'ur','Ø³Ø·Ø­ÙˆÚº Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ ÙØ±ÙˆØ®Øª Ú©Û’ Ù„Ø¦Û’ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(133136,3699,'sr','Ð›Ð¸ÑÑ‚Ðµ Ñƒ Ð¾Ð´Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÑƒ Ñ†ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾Ð¸Ð¼Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(133137,3699,'vi','Danh SÃ¡ch CÃ¡c Má»©c GiÃ¡ Ä‘á»ƒ bÃ¡n hÃ ng Trong Kho',0),(133138,3699,'af','Lyste van vlakke vir verkope van voorraad pryse',0),(133139,3699,'ro','Liste de preturi niveluri pentru inventarul de vÃ¢nzÄƒri',0),(133140,3699,'et','Loetelu hinnakujunduse taset varude mÃ¼Ã¼k',0),(133141,3699,'si','Seznami cenovnih ravneh za popis prodaje',0),(133142,3699,'ba','Daftar harga tingkat untuk penjualan persediaan',0),(133143,3699,'nl','Lijsten van prijsniveau voor inventaris verkoop',0),(133144,3699,'fi','Luettelo hintatasoja varaston myynti',0),(133145,3699,'no','Liste over priser nivÃ¥er for inventar salgs',0),(133146,3699,'da','Lister over prisniveauet for lager salg',0),(133147,3699,'ko','ìž¬ê³  íŒë§¤ì— ëŒ€ í•œ ìˆ˜ì¤€ ê°€ê²©ì˜ ëª©ë¡',0),(133148,3699,'he','×¨×©×™×ž×•×ª ×©×œ ×ª×ž×—×•×¨ ×¨×ž×•×ª ×”×ž×œ××™ ×ž×›×™×¨×•×ª',0),(133149,3699,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ ÎµÏ€Î¯Ï€ÎµÎ´Î± Ï„Î¹Î¼ÏŽÎ½ Î³Î¹Î± Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(133150,3699,'zh','å®šä»·æ°´å¹³åˆ—å‡ºäº†åº“å­˜é”€å”®\r\n',0),(133151,3699,'sv','Listor av prisnivÃ¥er fÃ¶r lager fÃ¶rsÃ¤ljning',0),(133152,3699,'it','Elenchi dei prezzi dei livelli per le vendite di inventario',0),(133153,3699,'tl','',0),(133154,3699,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3',0),(133155,3699,'hi','à¤®à¤¾à¤² à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‡ à¤¸à¥à¤¤à¤° à¤•à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(133156,3699,'ms','Senarai Harga tahap untuk jualan inventori',0),(133157,3699,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„ØªØ³Ø¹ÙŠØ± Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(133158,3699,'fr','Listes des niveaux de prix pour la vente de l\'inventaire',0),(133159,3699,'jp','åœ¨åº«ã‚»ãƒ¼ãƒ«ã‚¹ã?®å€¤ä»˜ã?‘æ°´æº–ãƒªã‚¹ãƒˆ',0),(133160,3699,'pt','Listas de nÃ­veis de preÃ§os para vendas de inventÃ¡rio',0),(133161,3699,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑƒÑ€Ð¾Ð²Ð½ÐµÐ¹ Ð´Ð»Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(133162,3699,'es','Listas de Niveles de Precios para Ventas de Inventario',0),(133163,3699,'de','Liste der Preise von Ebenen fÃ¼r Inventar Verkauf',0),(133164,3699,'en','Lists of Pricing Levels for Inventory Sales',0),(133165,3700,'is','',0),(133166,3700,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(133167,3700,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(133168,3700,'tr','Sevk edilen sipariÅŸleri listesi',0),(133169,3700,'pl','Listy wysÅ‚ane zamÃ³wieÅ„',0),(133170,3700,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(133171,3700,'ur','ÙÛØ±Ø³Øª Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(133172,3700,'sr','Ð›Ð¸ÑÑ‚Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸Ñ… Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°',0),(133173,3700,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng Ä‘áº£ chuyá»ƒn Ä‘i',0),(133174,3700,'af','Lyste van Versende Bestellings',0),(133175,3700,'ro','Liste cu ordinele de livrat',0),(133176,3700,'et','Nimekirjad tarnitud tellimustest',0),(133177,3700,'si','Seznami poÅ¡iljajo naroÄil',0),(133178,3700,'ba','Daftar perintah dikapalkan',0),(133179,3700,'nl','Lijsten met verzonden bestellingen',0),(133180,3700,'fi','Luettelo lÃ¤hetetyt tilaukset',0),(133181,3700,'no','Lister over sendte ordrer',0),(133182,3700,'da','Lister over leverede ordrer',0),(133183,3700,'ko','ë°°ì†¡ ì£¼ë¬¸ ëª©ë¡',0),(133184,3700,'he','×¨×©×™×ž×•×ª ×©×œ ×¤×§×•×“×•×ª ×©× ×©×œ×—×”',0),(133185,3700,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(133186,3700,'zh','åˆ—å‡ºå‘è´§çš„è®¢å•\r\n',0),(133187,3700,'sv','Listor Ã¶ver levererade order',0),(133188,3700,'it','Elenchi degli ordini spediti',0),(133189,3700,'tl','',0),(133190,3700,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(133191,3700,'hi','à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(133192,3700,'ms','Senarai pesanan yang dihantar',0),(133193,3700,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø¨Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(133194,3700,'fr','Listes des Commandes envoyee',0),(133195,3700,'jp','ç™ºé€?æ¸ˆæ³¨æ–‡ã?®ãƒªã‚¹ãƒˆ',0),(133196,3700,'pt','Listas de pedidos enviados',0),(133197,3700,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(133198,3700,'es','Listas de Ordenes Enviados',0),(133199,3700,'de','Listen der versandten Bestellungen',0),(133200,3700,'en','Lists of Shipped Orders',0),(133201,3701,'is','',0),(133202,3701,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ ',0),(133203,3701,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ ',0),(133204,3701,'tr','Standart biÃ§imlendirme kÃ¼meleri listesi',0),(133205,3701,'pl','Wykaz zestawÃ³w standardowych znacznikÃ³w',0),(133206,3701,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð° ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¸',0),(133207,3701,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(133208,3701,'sr','Ð›Ð¸ÑÑ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸Ñ… Ð½Ð°Ð·Ð½Ð°ÐºÐµ ÑÐºÑƒÐ¿Ð¾Ð²Ð°',0),(133209,3701,'vi','Danh sÃ¡ch cá»§a bá»™ cá»™ng thÃªm giÃ¡ chuáº©n',0),(133210,3701,'af','Lyste van Standaard Prysverhogingsstelle',0),(133211,3701,'ro','Liste de seturi de marcare Standard',0),(133212,3701,'et','Standardne mÃ¤rgistuskeel komplekti nimekirjad',0),(133213,3701,'si','Seznami Standardni oznaÄevalni sklopov',0),(133214,3701,'ba','Daftar set Markup standar',0),(133215,3701,'nl','Lijsten van standaardcoderingstaal Sets',0),(133216,3701,'fi','Luettelo Standardi merkintÃ¤kieli setit',0),(133217,3701,'no','Lister over Standard kode sett',0),(133218,3701,'da','Lister over Standard Markup sÃ¦t',0),(133219,3701,'ko','í‘œì¤€ íƒœê·¸ ì§‘í•© ëª©ë¡',0),(133220,3701,'he','×¨×©×™×ž×•×ª ×©×œ ×¡×“×¨×•×ª ×”×¡×™×ž×•×Ÿ ×”×¡×˜× ×“×¨×˜×™×ª',0),(133221,3701,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ Ï€ÏÏŒÏ„Ï…Ï€Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ ÏƒÏ…Î½ÏŒÎ»Ï‰Î½',0),(133222,3701,'zh','æ ‡å‡†æ ‡è®°åˆ—è¡¨é›†\r\n',0),(133223,3701,'sv','Listor Ã¶ver Standard Markup uppsÃ¤ttningar',0),(133224,3701,'it','Liste di Markup Standard set',0),(133225,3701,'tl','',0),(133226,3701,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3586;&#3634;&#3618;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;',0),(133227,3701,'hi','à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ à¤•à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(133228,3701,'ms','Senarai set Standard penanda',0),(133229,3701,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø¨Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(133230,3701,'fr','Listes des sÃ©ries Standard de balisage',0),(133231,3701,'jp','æ¨™æº–å€¤ä¸Šã?’è¨­å®šã?®ãƒªã‚¹ãƒˆ',0),(133232,3701,'pt','Listas de marcaÃ§Ã£o padrÃ£o de moda',0),(133233,3701,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð½Ð°Ð±Ð¾Ñ€Ð¾Ð² ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(133234,3701,'es','Listas de Juegos EstÃ¡ndares de Encarecimiento',0),(133235,3701,'de','Listen der Standard-Markup-Sets',0),(133236,3701,'en','Lists of Standard Markup Sets',0),(133237,3702,'is','',0),(133238,3702,'dr','Ù„ÙŠØ³Øª Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(133239,3702,'pr','Ù„ÙŠØ³Øª Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(133240,3702,'tr','Ä°ÅŸaretleyicileri listesi',0),(133241,3702,'pl','Listy znacznikÃ³w',0),(133242,3702,'bg','ÐšÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(133243,3702,'ur','Ù…Ø¢Ø±Ú©Ùˆ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(133244,3702,'sr','ÐœÐ°Ñ€ÐºÑƒÐ¿Ñ Ð»Ð¸ÑÑ‚Ð°',0),(133245,3702,'vi','Danh sÃ¡ch GiÃ¡ cá»™ng thÃªm',0),(133246,3702,'af','Markups lys',0),(133247,3702,'ro','ListÄƒ de marcaje',0),(133248,3702,'et','MÃ¤rgete loendi',0),(133249,3702,'si','Seznam oznak',0),(133250,3702,'ba','Daftar markup',0),(133251,3702,'nl','Lijst met markeringen',0),(133252,3702,'fi','Katteet luettelo',0),(133253,3702,'no','Markeringer liste',0),(133254,3702,'da','OpmÃ¦rkninger liste',0),(133255,3702,'ko','ë§ˆí¬ì—… ëª©ë¡',0),(133256,3702,'he','×¨×©×™×ž×ª ×”×¡×™×ž×•× ×™×',0),(133257,3702,'el','Î›Î¯ÏƒÏ„Î± ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÏ‰Î½',0),(133258,3702,'zh','æ ‡è®°åå•\r\n',0),(133259,3702,'sv','Markeringar lista',0),(133260,3702,'it','Elenco revisioni',0),(133261,3702,'tl','',0),(133262,3702,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(133263,3702,'hi','Markups à¤¸à¥‚à¤šà¥€',0),(133264,3702,'ms','Sedia senarai',0),(133265,3702,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª',0),(133266,3702,'fr','Liste des annotations',0),(133267,3702,'jp','å€¤ä¸Šã?’ãƒªã‚¹ãƒˆ',0),(133268,3702,'pt','Lista de marcaÃ§Ãµes',0),(133269,3702,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð¾Ð¼ÐµÑ‚Ð¾Ðº',0),(133270,3702,'es','Listas de Encarecimiento',0),(133271,3702,'de','Liste der Markierungen',0),(133272,3702,'en','Markups List',0),(133273,3703,'is','',0),(133274,3703,'dr','Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ ',0),(133275,3703,'pr','Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ ',0),(133276,3703,'tr','Pasta grafikler',0),(133277,3703,'pl','Wykresy koÅ‚owe',0),(133278,3703,'bg','ÐšÑ€ÑŠÐ³Ð¾Ð²Ð¸Ñ‚Ðµ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¸',0),(133279,3703,'ur','Ù¾Ø§Ø¦ÛŒ Ú†Ø§Ø±Ù¹',0),(133280,3703,'sr','ÐšÑ€ÑƒÐ¶Ð½Ð¸ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ¾Ð½Ð¸',0),(133281,3703,'vi','Biá»ƒu Ä‘á»“ dáº¡ng á»‘ng',0),(133282,3703,'af','Sirkeldiagram Grafieke',0),(133283,3703,'ro','Diagrame plÄƒcintÄƒ',0),(133284,3703,'et','Sektordiagrammis saab',0),(133285,3703,'si','Tortni grafikoni',0),(133286,3703,'ba','Diagram lingkaran',0),(133287,3703,'nl','Cirkeldiagrammen',0),(133288,3703,'fi','YmpyrÃ¤kaavio',0),(133289,3703,'no','Sektordiagrammer',0),(133290,3703,'da','Cirkeldiagrammer',0),(133291,3703,'ko','ì›í˜• ì°¨íŠ¸',0),(133292,3703,'he','×ª×¨×©×™×ž×™ ×¢×•×’×”',0),(133293,3703,'el','Î“ÏÎ±Ï†Î®Î¼Î±Ï„Î± Ï€Î¯Ï„Î±Ï‚',0),(133294,3703,'zh','é¥¼å›¾\r\n',0),(133295,3703,'sv','Cirkeldiagram',0),(133296,3703,'it','Grafici a torta',0),(133297,3703,'tl','',0),(133298,3703,'th','&#3649;&#3612;&#3609;&#3616;&#3641;&#3617;&#3636;&#3623;&#3591;&#3585;&#3621;&#3617;',0),(133299,3703,'hi','à¤ªà¤¾à¤‡ à¤šà¤¾à¤°à¥à¤Ÿà¥à¤¸',0),(133300,3703,'ms','Carta pai',0),(133301,3703,'ar','Ø§Ù„Ù…Ø®Ø·Ù‘Ø·Ø§Øª Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠØ©',0),(133302,3703,'fr','Camemberts',0),(133303,3703,'jp','åˆ†å††å›³',0),(133304,3703,'pt','GrÃ¡ficos de pizza',0),(133305,3703,'ru','ÐšÑ€ÑƒÐ³Ð¾Ð²Ñ‹Ðµ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¼Ñ‹',0),(133306,3703,'es','GrÃ¡ficos Circulares',0),(133307,3703,'de','Kreisdiagramme',0),(133308,3703,'en','Pie Charts',0),(133309,3704,'is','',0),(133310,3704,'dr','Ù„ÙŠØ³Øª Ù†Ø§Ù…  Ø¢Ø¯Ø±Ø³  ØªÙ„ÙÙ† ÙƒØ§Ø±Ù…Ù†Ø¯',0),(133311,3704,'pr','Ù„ÙŠØ³Øª Ù†Ø§Ù…  Ø¢Ø¯Ø±Ø³  ØªÙ„ÙÙ† ÙƒØ§Ø±Ù…Ù†Ø¯',0),(133312,3704,'tr','Ã‡alÄ±ÅŸan adres/telefon listesi',0),(133313,3704,'pl','Lista pracownikÃ³w adres/telefon',0),(133314,3704,'bg','ÐÐ´Ñ€ÐµÑ/Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº ÑÑŠÑ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(133315,3704,'ur','Ù…Ù„Ø§Ø²Ù… Ù¾ØªÛ’/ÙÙˆÙ† ÙÛØ±Ø³Øª',0),(133316,3704,'sr','Ð›Ð¸ÑÑ‚Ð° Ð°Ð´Ñ€ÐµÑÐ°/Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(133317,3704,'vi','Äá»‹a chá»‰ nhÃ¢n viÃªn/danh sÃ¡ch phone',0),(133318,3704,'af','Werknemer Adres/Foonlys',0),(133319,3704,'ro','ListÄƒ de adresa/telefon angajat',0),(133320,3704,'et','TÃ¶Ã¶tajate Aadressi/Telefoni nimekiri',0),(133321,3704,'si','Seznam zaposlenih naslov, telefon',0),(133322,3704,'ba','Daftar alamat/telepon karyawan',0),(133323,3704,'nl','Adres/telefoon Werknemerslijst',0),(133324,3704,'fi','TyÃ¶ntekijÃ¶iden osoite/Puhelinluettelo',0),(133325,3704,'no','Ansatt adresse/telefon-listen',0),(133326,3704,'da','Medarbejder adresse/telefonliste',0),(133327,3704,'ko','ì§ì› ì£¼ì†Œ/ì „í™” ë²ˆí˜¸ ëª©ë¡',0),(133328,3704,'he','×¨×©×™×ž×ª ×›×ª×•×‘×ª/×˜×œ×¤×•×Ÿ ×¢×•×‘×“×™×',0),(133329,3704,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·/Ï„Î·Î»Î­Ï†Ï‰Î½Î¿ ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Ï‰Î½',0),(133330,3704,'zh','é›‡å‘˜åœ°å€/ç”µè¯åˆ—è¡¨\r\n',0),(133331,3704,'sv','Adress/telefon Personallista',0),(133332,3704,'it','Elenco indirizzo e telefono dei dipendenti',0),(133333,3704,'tl','',0),(133334,3704,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;/&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3592;&#3657;&#3634;&#3591;',0),(133335,3704,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤ªà¤¤à¤¾/à¤«à¥‹à¤¨ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(133336,3704,'ms','Senarai alamat/telefon kakitangan',0),(133337,3704,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ¸Ù Ø¨Ø¹Ù†ÙˆØ§Ù†/Ø§Ù„Ù‡Ø§ØªÙ',0),(133338,3704,'fr','Liste des employÃ©s adresse/tÃ©lÃ©phone',0),(133339,3704,'jp','å¾“æ¥­å“¡ã€€ä½?æ‰€/å??ç°¿',0),(133340,3704,'pt','Lista de endereÃ§o/telefone dos empregados',0),(133341,3704,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº ÐÐ´Ñ€ÐµÑ/ÐÐ¾Ð¼ÐµÑ€Ð° Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð¾Ð²',0),(133342,3704,'es','Empleados Direcciones/Lista de TelÃ©fonos',0),(133343,3704,'de','Adresse/Telefon-Mitarbeiterliste',0),(133344,3704,'en','Employee Address/Phone List',0),(133345,3705,'is','',0),(133346,3705,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯  Ø¯ÙØªØ± Ø±ÙˆØ² Ù†Ø§Ù…Ù‡ ',0),(133347,3705,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯  Ø¯ÙØªØ± Ø±ÙˆØ² Ù†Ø§Ù…Ù‡ ',0),(133348,3705,'tr','Yeni gÃ¼nlÃ¼k girdisi',0),(133349,3705,'pl','Nowa pozycja dziennika',0),(133350,3705,'bg','ÐÐ¾Ð² Ð·Ð°Ð¿Ð¸Ñ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(133351,3705,'ur','Ù†ÛŒØ§ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(133352,3705,'sr','ÐÐ¾Ð²Ð¸ ÑƒÐ½Ð¾Ñ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸Ðº',0),(133353,3705,'vi','Nháº­p HÃ³a Ä‘Æ¡n má»›i',0),(133354,3705,'af','Nuwe Joernaalinskrywings',0),(133355,3705,'ro','Noua intrare Ã®n jurnal',0),(133356,3705,'et','Uus pÃ¤evikukanne',0),(133357,3705,'si','Nov vnos v dnevnik',0),(133358,3705,'ba','Entri jurnal baru',0),(133359,3705,'nl','Nieuw logboekitem',0),(133360,3705,'fi','Uusi pÃ¤ivyrimerkintÃ¤',0),(133361,3705,'no','Ny loggoppfÃ¸ring',0),(133362,3705,'da','Ny journaloptegnelse',0),(133363,3705,'ko','ìƒˆ ì—…ë¬´ ì¼ì§€ í•­ëª©',0),(133364,3705,'he','×¢×¨×š ×™×•×ž×Ÿ ×—×“×©',0),(133365,3705,'el','ÎÎ­Î± ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ¹ÏƒÎ· Ï‡ÏÎ¿Î½Î¹ÎºÎ¿Ï',0),(133366,3705,'zh','æ–°çš„æ—¥å¿—æ¡ç›®\r\n',0),(133367,3705,'sv','Ny journalpost',0),(133368,3705,'it','Nuova voce diario',0),(133369,3705,'tl','',0),(133370,3705,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3626;&#3617;&#3640;&#3604;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;&#3651;&#3627;&#3617;&#3656;',0),(133371,3705,'hi','à¤¨à¤ˆ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(133372,3705,'ms','Entri jurnal baru',0),(133373,3705,'ar','Ù‚ÙŠÙˆØ¯ ÙŠÙˆÙ…ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(133374,3705,'fr','Nouvelle entrÃ©e du Journal',0),(133375,3705,'jp','æ–°è¦?ã‚¸ãƒ£ãƒ¼ãƒŠãƒ«ã‚¨ãƒ³ãƒˆãƒªãƒ¼',0),(133376,3705,'pt','Nova entrada de diÃ¡rio',0),(133377,3705,'ru','ÐÐ¾Ð²Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ',0),(133378,3705,'es','Nuevas Entradas al Diario',0),(133379,3705,'de','Neuer Journaleintrag',0),(133380,3705,'en','New Journal Entries',0),(133381,3706,'is','',0),(133382,3706,'dr','Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ ',0),(133383,3706,'pr','Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ ',0),(133384,3706,'tr','Yeni sipariÅŸ',0),(133385,3706,'pl','Nowe zamÃ³wienia',0),(133386,3706,'bg','ÐÐ¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(133387,3706,'ur','Ù†Ø¦Û’ Ø¢Ø±ÚˆØ±',0),(133388,3706,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(133389,3706,'vi','ÄÆ¡n Ä‘áº·t hÃ ng má»›i',0),(133390,3706,'af','Nuwe Bestelling',0),(133391,3706,'ro','Comanda noua',0),(133392,3706,'et','Uus tellimus',0),(133393,3706,'si','Novi Red',0),(133394,3706,'ba','Orde Baru',0),(133395,3706,'nl','Nieuwe orde',0),(133396,3706,'fi','Uusi tilaus',0),(133397,3706,'no','Ny ordre',0),(133398,3706,'da','Ny ordre',0),(133399,3706,'ko','ìƒˆë¡œìš´ ì§ˆì„œ',0),(133400,3706,'he','×”×–×ž× ×” ×—×“×©×”',0),(133401,3706,'el','ÎÎ­Î± Ï„Î¬Î¾Î· Ï€ÏÎ±Î³Î¼Î¬Ï„Ï‰Î½',0),(133402,3706,'zh','æ–°è®¢å•\r\n',0),(133403,3706,'sv','Ny Order',0),(133404,3706,'it','Nuovo ordine',0),(133405,3706,'tl','',0),(133406,3706,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(133407,3706,'hi','à¤¨à¤ à¤†à¤¦à¥‡à¤¶',0),(133408,3706,'ms','Perintah baru',0),(133409,3706,'ar','Ø·Ù„Ø¨ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(133410,3706,'fr','Nouvel ordre',0),(133411,3706,'jp','æ–°è¦?æ³¨æ–‡',0),(133412,3706,'pt','Nova ordem',0),(133413,3706,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð—Ð°ÐºÐ°Ð·',0),(133414,3706,'es','Nuevo Orden',0),(133415,3706,'de','Neuer Auftrag',0),(133416,3706,'en','New Order',0),(133417,3707,'is','',0),(133418,3707,'dr','Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ø¬Ø¯ÙŠØ¯ ',0),(133419,3707,'pr','Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ø¬Ø¯ÙŠØ¯ ',0),(133420,3707,'tr','Yeni YazdÄ±rma dÃ¼zeni',0),(133421,3707,'pl','Nowe zlecenia druku',0),(133422,3707,'bg','ÐÐ¾Ð² Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(133423,3707,'ur','Ù†Ø¦Û’ Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ',0),(133424,3707,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ°',0),(133425,3707,'vi','ÄÆ¡n Ä‘áº·t hÃ ng in má»›i',0),(133426,3707,'af','Nuwe druk orde',0),(133427,3707,'ro','Noua ordine de imprimare',0),(133428,3707,'et','Uus printimise jÃ¤rjekorras',0),(133429,3707,'si','Nov vrstni red tiskanja',0),(133430,3707,'ba','Orde Baru cetak',0),(133431,3707,'nl','Nieuwe afdrukvolgorde',0),(133432,3707,'fi','Uusi tulostusjÃ¤rjestys',0),(133433,3707,'no','Ny rekkefÃ¸lge',0),(133434,3707,'da','Nye udskriftsrÃ¦kkefÃ¸lgen',0),(133435,3707,'ko','ìƒˆë¡œìš´ ì¸ì‡„ ìˆœì„œ',0),(133436,3707,'he','×¡×“×¨ ×”×“×¤×¡×” ×—×“×©',0),(133437,3707,'el','ÎÎ­Î± ÏƒÎµÎ¹ÏÎ¬ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(133438,3707,'zh','æ–°çš„æ‰“å°å‘½ä»¤\r\n',0),(133439,3707,'sv','Nya utskriftsordning',0),(133440,3707,'it','Nuovo ordine di stampa',0),(133441,3707,'tl','',0),(133442,3707,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(133443,3707,'hi','à¤¨à¤ˆ à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤®',0),(133444,3707,'ms','Cetak yang baru',0),(133445,3707,'ar','Ø£Ù…Ø± Ø·Ø¨Ø§Ø¹Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(133446,3707,'fr','Nouvelle commande d\'impression',0),(133447,3707,'jp','æ–°è¦?å?°åˆ·æ³¨æ–‡',0),(133448,3707,'pt','Nova ordem de impressÃ£o',0),(133449,3707,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(133450,3707,'es','Nuevo Orden de ImpresiÃ³n',0),(133451,3707,'de','Neue Druckreihenfolge',0),(133452,3707,'en','New Print Order',0),(133453,3708,'is','',0),(133454,3708,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(133455,3708,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(133456,3708,'tr','Yeni satÄ±nalma sipariÅŸi',0),(133457,3708,'pl','Nowe zamÃ³wienie zakupu',0),(133458,3708,'bg','ÐÐ¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(133459,3708,'ur','Ù†Ø¦ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ±',0),(133460,3708,'sr','ÐÐ¾Ð²Ðµ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(133461,3708,'vi','ÄÆ¡n mua hÃ ng má»›i',0),(133462,3708,'af','Nuwe Aankoopbestelling',0),(133463,3708,'ro','Noua ordine de cumpÄƒrare',0),(133464,3708,'et','Uus ostutellimus',0),(133465,3708,'si','Novo naroÄilnico',0),(133466,3708,'ba','Baru Order Pembelian',0),(133467,3708,'nl','Nieuwe inkooporder',0),(133468,3708,'fi','Uusi ostotilaus',0),(133469,3708,'no','Bestilling',0),(133470,3708,'da','Ny kÃ¸bsordre',0),(133471,3708,'ko','ìƒˆë¡œìš´ ì£¼ë¬¸ì„œ',0),(133472,3708,'he','×”×–×ž× ×ª ×¨×›×™×©×” ×—×“×©×”',0),(133473,3708,'el','ÎÎ­Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(133474,3708,'zh','æ–°çš„é‡‡è´­è®¢å•\r\n',0),(133475,3708,'sv','Ny inkÃ¶psorder',0),(133476,3708,'it','Nuovo ordine di acquisto',0),(133477,3708,'tl','',0),(133478,3708,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(133479,3708,'hi','à¤¨à¤ˆ à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(133480,3708,'ms','Pesanan pembelian baru',0),(133481,3708,'ar','Ø·Ù„Ø¨ Ø´Ø±Ø§Ø¡ Ø¬Ø¯ÙŠØ¯',0),(133482,3708,'fr','Nouveau bon de commande',0),(133483,3708,'jp','æ–°è¦?ç™ºæ³¨æ›¸',0),(133484,3708,'pt','Nova ordem de compra',0),(133485,3708,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(133486,3708,'es','Nuevo Orden de Compra',0),(133487,3708,'de','Neue Bestellung',0),(133488,3708,'en','New Purchase Order',0),(133489,3709,'is','',0),(133490,3709,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯',0),(133491,3709,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯',0),(133492,3709,'tr','Yeni satÄ±cÄ± faturasÄ±',0),(133493,3709,'pl','Nowy rachunek dostawcy',0),(133494,3709,'bg','ÐÐ¾Ð² Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(133495,3709,'ur','Ù†Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„',0),(133496,3709,'sr','ÐÐ¾Ð²Ð¸ Ð·Ð°ÐºÐ¾Ð½ Ð¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ñƒ',0),(133497,3709,'vi','HÃ³a ÄÆ¡n NgÆ°á»i BÃ¡n Má»›i',0),(133498,3709,'af','Nuwe handelaar Wetsontwerp',0),(133499,3709,'ro','Nou proiect de lege de furnizor',0),(133500,3709,'et','Uus hankija arve',0),(133501,3709,'si','Nov raÄun dobavitelja',0),(133502,3709,'ba','RUU Vendor baru',0),(133503,3709,'nl','Nieuwe leverancier Bill',0),(133504,3709,'fi','Uusi toimittajan lasku',0),(133505,3709,'no','Ny leverandÃ¸r Bill',0),(133506,3709,'da','Ny leverandÃ¸r Bill',0),(133507,3709,'ko','ìƒˆë¡œìš´ ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ',0),(133508,3709,'he','×”×¦×¢×ª ×”×¡×¤×§',0),(133509,3709,'el','ÎÎ­Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Î³Î¹Î± Ï„Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(133510,3709,'zh','æ–°ä¾›åº”å•†çš„å¸å•\r\n',0),(133511,3709,'sv','Ny leverantÃ¶r Bill',0),(133512,3709,'it','Nuovo fornitore',0),(133513,3709,'tl','',0),(133514,3709,'th','&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(133515,3709,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤²',0),(133516,3709,'ms','Bil pembekal baru',0),(133517,3709,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ù…ÙˆØ±Ù‘Ø¯ Ø¬Ø¯ÙŠØ¯Ø©',0),(133518,3709,'fr','Nouveau projet de loi du vendeur',0),(133519,3709,'jp','æ–°è¦?æ¥­è€…è«‹æ±‚æ›¸',0),(133520,3709,'pt','Nova lei de fornecedor',0),(133521,3709,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð‘Ð¸Ð»Ð»',0),(133522,3709,'es','Nuevo Recibo/Factura de Proveedor',0),(133523,3709,'de','Neuen Kreditor-Zahlung',0),(133524,3709,'en','New Vendor Bill',0),(133525,3710,'is','',0),(133526,3710,'dr','Ø·Ø¨Ù‚ Ø¢Ù…Ø§Ø± Ø²Ù…Ø§Ù†ÙŠ',0),(133527,3710,'pr','Ø·Ø¨Ù‚ Ø¢Ù…Ø§Ø± Ø²Ù…Ø§Ù†ÙŠ',0),(133528,3710,'tr','Zaman istatistikleri',0),(133529,3710,'pl','Na czas statystyki',0),(133530,3710,'bg','ÐÐ° Ð²Ñ€ÐµÐ¼ÐµÑ‚Ð¾ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(133531,3710,'ur','ÙˆÙ‚Øª Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± Ù¾Ø±',0),(133532,3710,'sr','ÐÐ° Ð²Ñ€ÐµÐ¼Ðµ Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(133533,3710,'vi','Thá»‘ng kÃª ÄÃºng giá»',0),(133534,3710,'af','Op Tyd Statistieke',0),(133535,3710,'ro','Pe timpul statistici',0),(133536,3710,'et','Aeg statistika',0),(133537,3710,'si','O Äasu statistike',0),(133538,3710,'ba','Pada waktu Statistik',0),(133539,3710,'nl','Op tijd statistieken',0),(133540,3710,'fi','Aika tilastoista',0),(133541,3710,'no','PÃ¥ statistikk',0),(133542,3710,'da','PÃ¥ statistik over',0),(133543,3710,'ko','ì‹œê°„ í†µê³„',0),(133544,3710,'he','×¢×œ ×”×–×ž×Ÿ ×¡×˜×˜×™×¡×˜×™×§×•×ª',0),(133545,3710,'el','Î§ÏÏŒÎ½Î¿ ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÏŽÎ½',0),(133546,3710,'zh','æ—¶é—´ç»Ÿè®¡\r\n',0),(133547,3710,'sv','PÃ¥ tid statistik',0),(133548,3710,'it','Sulle statistiche del tempo',0),(133549,3710,'tl','',0),(133550,3710,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3585;&#3634;&#3619;&#3605;&#3619;&#3591;&#3605;&#3634;&#3617;&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3623;&#3621;&#3634;',0),(133551,3710,'hi','à¤ªà¤° à¤¸à¤®à¤¯ à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤•à¥€',0),(133552,3710,'ms','Statistik masa',0),(133553,3710,'ar','ÙÙŠ Ø¥Ø­ØµØ§Ø¡Ø§Øª ÙˆÙ‚Øª',0),(133554,3710,'fr','Statistiques des temps',0),(133555,3710,'jp','On Time Statistics',0),(133556,3710,'pt','Em estatÃ­sticas de vez',0),(133557,3710,'ru','ÐŸÐ¾ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐµ Ð²Ñ€ÐµÐ¼Ñ',0),(133558,3710,'es','Estadisticas de Puntualidad',0),(133559,3710,'de','Auf Zeitstatistik',0),(133560,3710,'en','On Time Statistics',0),(133561,3711,'is','',0),(133562,3711,'dr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ ',0),(133563,3711,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ ',0),(133564,3711,'tr','Performans istatistikleri',0),(133565,3711,'pl','Statystyki wydajnoÅ›ci',0),(133566,3711,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð° ÐµÑ„ÐµÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ñ‚Ð°',0),(133567,3711,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ÙˆØ´Ù…Ø§Ø±',0),(133568,3711,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐµ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ¸',0),(133569,3711,'vi','Thá»‘ng kÃª nÄƒng lá»±c',0),(133570,3711,'af','Prestasie Stats',0),(133571,3711,'ro','Statistici de performanÅ£Äƒ',0),(133572,3711,'et','Tulemuslikkuse statistika',0),(133573,3711,'si','Predstava statistika',0),(133574,3711,'ba','Statistik performa',0),(133575,3711,'nl','Prestatiestatistieken',0),(133576,3711,'fi','Tehokkuustilastojen',0),(133577,3711,'no','Resultatstatistikk',0),(133578,3711,'da','Effektivitetsstatistikker',0),(133579,3711,'ko','ì„±ëŠ¥ í†µê³„',0),(133580,3711,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×',0),(133581,3711,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½',0),(133582,3711,'zh','æ•ˆæžœç»Ÿè®¡\r\n',0),(133583,3711,'sv','Prestanda statistik',0),(133584,3711,'it','Statistiche di prestazioni',0),(133585,3711,'tl','',0),(133586,3711,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3612;&#3621;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;',0),(133587,3711,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡',0),(133588,3711,'ms','Statistik prestasi',0),(133589,3711,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡',0),(133590,3711,'fr','Statistiques de performances',0),(133591,3711,'jp','æ¥­ç¸¾çŠ¶æ³?',0),(133592,3711,'pt','EstatÃ­sticas de desempenho',0),(133593,3711,'ru','Ð¡Ñ‚Ð°Ñ‚ ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(133594,3711,'es','Estadisticas de DesempeÃ±o',0),(133595,3711,'de','Performance-Statistiken',0),(133596,3711,'en','Performance Stats',0),(133597,3712,'is','',0),(133598,3712,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(133599,3712,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(133600,3712,'tr','Hold on emir',0),(133601,3712,'pl','Wstrzymane zamÃ³wienia',0),(133602,3712,'bg','ÐŸÐ¾ Ð½Ð¸ÑÐºÐ° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(133603,3712,'ur','Ù¾Ø± Ù¾Ú©Ú‘ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(133604,3712,'sr','ÐÐ°Ð»Ð¾Ð³Ðµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(133605,3712,'vi','Táº¡m NgÆ°ng ÄÆ¡n Äáº·t HÃ ng',0),(133606,3712,'af','Uitgestelde Bestellings',0),(133607,3712,'ro','Comenzi de pe-Hold',0),(133608,3712,'et','-Hoia tellimused',0),(133609,3712,'si','Nalogov na Äakanju',0),(133610,3712,'ba','Pada memegang perintah',0),(133611,3712,'nl','On-Hold Orders',0),(133612,3712,'fi','Pidossa tilaukset',0),(133613,3712,'no','PÃ¥ Hold ordrer',0),(133614,3712,'da','PÃ¥ Hold ordrer',0),(133615,3712,'ko','ë³´ë¥˜ ì£¼ë¬¸',0),(133616,3712,'he','×”×–×ž× ×•×ª ×‘×”×ž×ª× ×”',0),(133617,3712,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ on-Hold',0),(133618,3712,'zh','çŽ°æœ‰è®¢å•\r\n',0),(133619,3712,'sv','SpÃ¤rrade order',0),(133620,3712,'it','Ordini in sospeso',0),(133621,3712,'tl','',0),(133622,3712,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3606;&#3639;&#3629;&#3651;&#3609;&#3617;&#3639;&#3629;',0),(133623,3712,'hi','à¤¹à¥‹à¤²à¥à¤¡ à¤ªà¤° à¤†à¤¦à¥‡à¤¶',0),(133624,3712,'ms','Pesanan pada mengadakan',0),(133625,3712,'ar','Ø£ÙˆØ§Ù…Ø± ÙÙŠ Ø§Ù„Ø§Ù†ØªØ¸Ø§Ø±',0),(133626,3712,'fr','Commandes en attente',0),(133627,3712,'jp','æ‰‹æŒ?ã?¡æ³¨æ–‡',0),(133628,3712,'pt','Ordens em espera',0),(133629,3712,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð½Ð° ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ð¸',0),(133630,3712,'es','Ordenes en Espera',0),(133631,3712,'de','On-Hold-AuftrÃ¤ge',0),(133632,3712,'en','On-Hold Orders',0),(133633,3713,'is','',0),(133634,3713,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø±ÙˆÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(133635,3713,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø±ÙˆÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(133636,3713,'tr','SipariÅŸleri aÃ§ Ã¶ÄŸelerini',0),(133637,3713,'pl','OtwÃ³rz elementy zamÃ³wienia',0),(133638,3713,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(133639,3713,'ur','Ú©Ú¾Ù„ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø±',0),(133640,3713,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ð¾ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÑƒ',0),(133641,3713,'vi','Máº·t hÃ ng má»Ÿ trÃªn Ä‘Æ¡n hÃ ng',0),(133642,3713,'af','Oop Items op Bestellings',0),(133643,3713,'ro','Elemente deschise pe comenzi',0),(133644,3713,'et','Avatud Ã¼ksustes tellimusi',0),(133645,3713,'si','Odprte elemente na naroÄila',0),(133646,3713,'ba','Buka item pesanan',0),(133647,3713,'nl','Geopende Items op bestellingen',0),(133648,3713,'fi','Avaa kohteet tilauksista',0),(133649,3713,'no','Ã…pne elementer pÃ¥ ordrer',0),(133650,3713,'da','Ã…bne elementer pÃ¥ ordrer',0),(133651,3713,'ko','ì£¼ë¬¸ì— ëŒ€í•´ ì—´ë¦° í•­ëª©',0),(133652,3713,'he','×¤×ª×— ××ª ×”×¤×¨×™×˜×™× ×©×‘×”×–×ž× ×•×ª',0),(133653,3713,'el','Î‘Î½Î¿Î¹Ï‡Ï„Î¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(133654,3713,'zh','æ‰“å¼€è®¢å•ä¸Šçš„é¡¹ç›®\r\n',0),(133655,3713,'sv','Ã–ppna poster pÃ¥ order',0),(133656,3713,'it','Elementi aperti gli ordini',0),(133657,3713,'tl','',0),(133658,3713,'th','&#3648;&#3611;&#3636;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(133659,3713,'hi','à¤–à¥à¤²à¥‡ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°',0),(133660,3713,'ms','Buka item pada pesanan',0),(133661,3713,'ar','ÙØªØ­ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø±',0),(133662,3713,'fr','Ã‰lÃ©ments ouverts sur commandes',0),(133663,3713,'jp','æ³¨æ–‡ä¸­ã?®å“?ç›®ã‚’é–‹ã??',0),(133664,3713,'pt','Itens abertos em ordens',0),(133665,3713,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¿Ð¾ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ñƒ',0),(133666,3713,'es','Items Abiertos en Pedidos',0),(133667,3713,'de','Offene Posten auf Bestellungen',0),(133668,3713,'en','Open Items on Orders',0),(133669,3714,'is','',0),(133670,3714,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ â€“Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² â€“ Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ â€“Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(133671,3714,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ â€“Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² â€“ Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ â€“Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(133672,3714,'tr','SipariÅŸ listeleri - aÃ§Ä±k arka - sevk edilen sipariÅŸler - emir emir',0),(133673,3714,'pl','ZamÃ³wienie list - otwarty zamÃ³wienia - wysÅ‚ane zamÃ³wieÅ„ - zamÃ³wienia',0),(133674,3714,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ - Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ - ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ - Ð½ÐµÐ¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(133675,3714,'ur','ÙÛØ±Ø³Øª - Ø¢Ø±ÚˆØ± Ú©Ú¾ÙˆÙ„ÛŒÚº - Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ - ÙˆØ§Ù¾Ø³ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ø§ Ø­Ú©Ù…',0),(133676,3714,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð»Ð¸ÑÑ‚Ð°Ð¼Ð° - Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾ Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾ - Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸Ñ… Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° - Ð½Ð°Ð³Ð¾Ð¼Ð¸Ð»Ð°Ð½Ð¾Ð³',0),(133677,3714,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng - ÄÆ¡n hÃ ng má»Ÿ - ÄÆ¡n hÃ ng Ä‘Ã£ chuyá»ƒn - ÄÆ¡n hÃ ng chÆ°a thá»±c hiá»‡n ngay',0),(133678,3714,'af','Bestellingslyste - Oop Bestellings - Versende Bestellings - Teruggehoue Bestellings',0),(133679,3714,'ro','Comanda liste - Open comenzi - livrat ordinele - Back comenzi',0),(133680,3714,'et','Telli nimekirja - avatud tellimuste - lÃ¤hetatud tellimuste - jÃ¤reltellimused',0),(133681,3714,'si','NaroÄite seznami - odprta naroÄila - poÅ¡iljajo nalogov - nalogi',0),(133682,3714,'ba','Memesan daftar - terbuka pesanan - pesanan dikirim - kembali perintah',0),(133683,3714,'nl','De volgorde van lijsten - Open bestellingen - verzonden Orders - nabestellingen',0),(133684,3714,'fi','Tilaa luettelot - Avaa tilaukset - lÃ¤hetetyt tilaukset - jÃ¤lkitoimitukset',0),(133685,3714,'no','Bestille lister - Ã¥pne ordrer - leverte ordrer - restordrer',0),(133686,3714,'da','Bestil lister - Ã¥bne ordrer - afsendt ordrer - restordrer',0),(133687,3714,'ko','ì£¼ë¬¸ ë¦¬ìŠ¤íŠ¸-ì˜¤í”ˆ ì£¼ë¬¸-ë°°ì†¡ëœ ì£¼ë¬¸-ë‹¤ì‹œ ì£¼ë¬¸',0),(133688,3714,'he','×œ×”×–×ž×™×Ÿ ×¨×©×™×ž×•×ª - ×¤×ª×— ×”×–×ž× ×•×ª ×”×–×ž× ×•×ª ×”××—×•×¨×™ - ×©× ×©×œ×—×” ×”×–×ž× ×•×ª-',0),(133689,3714,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï…Ï‚ - Open Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ - Î¼ÎµÏ„Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ - Î±Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(133690,3714,'zh','è®¢è´­åˆ—è¡¨ -æœªç»“è®¢å•-å‘è´§çš„è®¢å•-ç¼ºè´§é€šçŸ¥\r\n',0),(133691,3714,'sv','BestÃ¤ll listor - Ã¶ppna order - levererade order - restorder',0),(133692,3714,'it','Ordinare liste - Open ordini - gli ordini spediti - ordini arretrati',0),(133693,3714,'tl','',0),(133694,3714,'th','Order Lists - Open Orders - Shipped Orders - Backorders',0),(133695,3714,'hi','à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤ - à¤†à¤¦à¥‡à¤¶ à¤“à¤ªà¤¨ - à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶ - à¤ªà¥€à¤  à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(133696,3714,'ms','Perintah senarai - terbuka pesanan - pesanan dihantar - kembali pesanan',0),(133697,3714,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ù‚ÙˆØ§Ø¦Ù…-ÙØªØ­ Ø£ÙˆØ§Ù…Ø± Ø£ÙˆØ§Ù…Ø±-Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§-Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(133698,3714,'fr','Commander des listes - Open commandes - commandes expÃ©diÃ©es - arriÃ¨re',0),(133699,3714,'jp','æ³¨æ–‡ãƒªã‚¹ãƒˆãƒ¼æœªå‡ºè?·æ³¨æ–‡ãƒ¼ç™ºé€?æ¸ˆæ³¨æ–‡ãƒ¼å…¥è?·å¾…ã?¡',0),(133700,3714,'pt','Ordenar listas - Open ordena - pedidos enviados - pedidos',0),(133701,3714,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐºÐ¸ - Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ - Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ - Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(133702,3714,'es','Listas de Pedidos - Pedidos Abiertos - Pedidos Eniados - Pedidos en Espera',0),(133703,3714,'de','Bestell-Listen - Open bestellt - gelieferten Bestellungen - Nachlieferungen',0),(133704,3714,'en','Order Lists - Open Orders - Shipped Orders - Back Orders',0),(133705,3715,'is','',0),(133706,3715,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³ÙØ§Ø±Ø´ â€“ Ù¾Ø±ÙƒØ±Ø¯Ù† â€“ Ø­Ù…Ù„ ÙƒØ±Ø¯Ù† â€“ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒØ±Ø¯Ù† ',0),(133707,3715,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³ÙØ§Ø±Ø´ â€“ Ù¾Ø±ÙƒØ±Ø¯Ù† â€“ Ø­Ù…Ù„ ÙƒØ±Ø¯Ù† â€“ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒØ±Ø¯Ù† ',0),(133708,3715,'tr','-Dolgu - iÅŸleme gemi - parÃ§a sipariÅŸ',0),(133709,3715,'pl','Celu przetwarzania - Fill - statek - Track',0),(133710,3715,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ñ‚Ðµ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° - Ð·Ð°Ð¿ÑŠÐ»Ð²Ð°Ð½Ðµ - ÐºÐ¾Ñ€Ð°Ð± - Ð¿ÐµÑÐµÐ½',0),(133711,3715,'ur','Ù¹Ø±ÛŒÚ© Ú©Ø´ØªÛŒ - - Ø¨Ú¾Ø±ÛŒÚº - Ù¾Ø± Ø¹Ù…Ù„ Ú©Ø§ Ø­Ú©Ù…',0),(133712,3715,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð¾Ð±Ñ€Ð°Ð´Ð° - Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ - Ð±Ñ€Ð¾Ð´ - Ð¿Ð¾Ñ˜Ð°Ð¼',0),(133713,3715,'vi','Xá»­ lÃ½ Ä‘Æ¡n hÃ ng - Äiá»n - Chuyá»ƒn - TÃ¬m',0),(133714,3715,'af','Bestelling Prosessering - \"Fill\" - Versend - Spoor',0),(133715,3715,'ro','Comanda procesare - umple - navÄƒ - Track',0),(133716,3715,'et','Tellimuse tÃ¶Ã¶tlemine - tÃ¤ite - laev - Track',0),(133717,3715,'si','NaroÄilo obdelave - Fill - ladja - Track',0),(133718,3715,'ba','Order pengolahan - mengisi - kapal - Track',0),(133719,3715,'nl','Bestel verwerking - Fill - schip - Track',0),(133720,3715,'fi','Tilaa kÃ¤sittely - tÃ¤ytÃ¤ - laiva - radan',0),(133721,3715,'no','Bestille behandling - fyll - skip - spor',0),(133722,3715,'da','Bestil behandling - Fill - skib - spor',0),(133723,3715,'ko','ì£¼ë¬¸-ì±„ìš°ê¸°-ì²˜ë¦¬ ì„ ë°•-íŠ¸ëž™',0),(133724,3715,'he','×¡×“×¨ ×¢×™×‘×•×“ - ×ž×™×œ×•×™ - ×”×¡×¤×™× ×” - ×ž×¡×œ×•×œ',0),(133725,3715,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± - ÏƒÏ…Î¼Ï€Î»Î®ÏÏ‰ÏƒÎ· - Ï€Î»Î¿Î¯Î¿ - Track',0),(133726,3715,'zh','è®¢å•å¤„ç† -å¡«å……- å‘è´§- è·Ÿè¸ª\r\n',0),(133727,3715,'sv','BestÃ¤ll bearbetning - Fyll - fartyg - spÃ¥r',0),(133728,3715,'it','Ordine di elaborazione - riempimento - nave - pista',0),(133729,3715,'tl','',0),(133730,3715,'th','&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;-&#3648;&#3605;&#3636;&#3617;-&#3586;&#3609;&#3626;&#3656;&#3591;-&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(133731,3715,'hi','à¤œà¤¹à¤¾à¤œ - - à¤­à¤°à¤£ - à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤¿à¤‚à¤— à¤†à¤¦à¥‡à¤¶ à¤Ÿà¥à¤°à¥ˆà¤•',0),(133732,3715,'ms','Menempah kapal pemprosesan - isi - - trek',0),(133733,3715,'ar','ØªØ£Ù…Ø± Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„ØªØ¬Ù‡ÙŠØ²-Ø§Ù„ØªØ¹Ø¨Ø¦Ø©--Ø§Ù„Ù…Ø³Ø§Ø±',0),(133734,3715,'fr','Commander transformation - remplissage - navire - piste',0),(133735,3715,'jp','å‡¦ç?†ä¸­æ³¨æ–‡ãƒ¼è¨˜å…¥ãƒ¼ç™ºé€?ãƒ¼ãƒˆãƒ©ãƒƒã‚¯',0),(133736,3715,'pt','Ordem de processamento - preenchimento - navio - faixa',0),(133737,3715,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ - Fill - ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ - Ñ‚Ñ€ÐµÐº',0),(133738,3715,'es','Procesamiento de Pedidos - Cumplir - Enviar - Trazar',0),(133739,3715,'de','Verarbeitung - FÃ¼llung - Schiff - Track zu bestellen',0),(133740,3715,'en','Order Processing - Fill - Ship - Track',0),(133741,3716,'is','',0),(133742,3716,'dr','ÙˆØ¶Ø¹ÙŠØª Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³ÙØ§Ø±Ø´',0),(133743,3716,'pr','ÙˆØ¶Ø¹ÙŠØª Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³ÙØ§Ø±Ø´',0),(133744,3716,'tr','SipariÅŸ durumu iÅŸleme',0),(133745,3716,'pl','Stan realizacji zamÃ³wienia',0),(133746,3716,'bg','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸Ñ‚Ðµ',0),(133747,3716,'ur','Ø­Ø§Ù„Øª Ú©ÛŒ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ø­Ú©Ù…',0),(133748,3716,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¾Ð±Ñ€Ð°Ð´Ðµ',0),(133749,3716,'vi','TÃ¬nh tráº¡ng xá»­ lÃ½ Ä‘Æ¡n hÃ ng',0),(133750,3716,'af','Bestelling Prosessering Status',0),(133751,3716,'ro','Comanda statutul de prelucrare',0),(133752,3716,'et','Tellimuse tÃ¶Ã¶tlemise staatus',0),(133753,3716,'si','Naloga stanje obdelave',0),(133754,3716,'ba','Pemrosesan Status order',0),(133755,3716,'nl','Orderverwerking Status',0),(133756,3716,'fi','Tilauksen kÃ¤sittelyn tila',0),(133757,3716,'no','Status for ordrebehandling',0),(133758,3716,'da','Ordrebehandling Status',0),(133759,3716,'ko','ì£¼ë¬¸ ì²˜ë¦¬ ìƒíƒœ',0),(133760,3716,'he','×¡×“×¨ ×¢×™×‘×•×“ ×ž×¦×‘',0),(133761,3716,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(133762,3716,'zh','è®¢å•å¤„ç†çŠ¶æ€\r\n',0),(133763,3716,'sv','Order bearbetning Status',0),(133764,3716,'it','Lo stato di elaborazione degli ordini',0),(133765,3716,'tl','',0),(133766,3716,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(133767,3716,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(133768,3716,'ms','Memproses Status pesanan',0),(133769,3716,'ar','ØªØ¬Ù‡ÙŠØ² Ù…Ø±ÙƒØ² Ø§Ù„Ù†Ø¸Ø§Ù…',0),(133770,3716,'fr','Statut de traitement des commandes',0),(133771,3716,'jp','ç™ºæ³¨çŠ¶æ³?',0),(133772,3716,'pt','Status de processamento de pedidos',0),(133773,3716,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°ÐºÐ°Ð·Ð°',0),(133774,3716,'es','Status de Proceso de Orden',0),(133775,3716,'de','Status der Auftragsbearbeitung',0),(133776,3716,'en','Order Processing Status',0),(133777,3717,'is','',0),(133778,3717,'dr','- Ø§Ø­ØµØ§Ø¦ÛŒÙ‡ ',0),(133779,3717,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø³ÙØ§Ø±Ø´ â€“ Ù„ÙŠØ³Øª Ù‡Ø§ â€“ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ù‡Ø§- Ø¢Ù…Ø§Ø±',0),(133780,3717,'tr','SipariÅŸ izleme - listeleri - dolum - istatistik',0),(133781,3717,'pl','ZamÃ³wiÄ‡ holowanie - list - wypeÅ‚nienie - statystyki',0),(133782,3717,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° - ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ - Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð¿ÑŠÐ»Ð½ÐµÐ¶ - ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(133783,3717,'ur','Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± Ø¨Ú¾Ø±Ù†Û’ - - ÙÛØ±Ø³Øª - Ø³Û’ Ø¨Ø§Ø®Ø¨Ø± Ø±Ú©Ú¾Ù†Û’ Ú©Ø§ Ø­Ú©Ù…',0),(133784,3717,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ - Ð»Ð¸ÑÑ‚Ð°Ð¼Ð° - Ð¿ÑƒÑšÐµÑšÐµ - Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(133785,3717,'vi','TÃ¬m Ä‘Æ¡n hÃ ng - danh sÃ¡ch - Ä‘iá»n - thá»‘ng kÃª',0),(133786,3717,'af','Bestelling Sporing - Lyste - Liasering - Statistieke',0),(133787,3717,'ro','Comanda urmÄƒrire - liste - umplere - statistici',0),(133788,3717,'et','Tellimuse jÃ¤lgimine - listid - tÃ¤itmine - statistika',0),(133789,3717,'si','NaroÄite sledenje - seznami - nadev - statistika',0),(133790,3717,'ba','Memesan pelacakan - daftar - mengisi - Statistik',0),(133791,3717,'nl','Bestel bijhouden - lijsten - vulling - statistieken',0),(133792,3717,'fi','Jotta seuranta - luettelot - tÃ¤yttÃ¶ - tilastot',0),(133793,3717,'no','Bestill spore - lister - fylling - statistikk',0),(133794,3717,'da','Bestil Tracking - lister - pÃ¥fyldning - statistik',0),(133795,3717,'ko','ì£¼ë¬¸ ì¶”ì -ë¦¬ìŠ¤íŠ¸-ìž‘ì„±-í†µê³„',0),(133796,3717,'he','×¡×˜×˜×™×¡×˜×™×§×” ×©×œ ×”×–×ž× ×•×ª ×ž×¢×§×‘ - ×¨×©×™×ž×•×ª - ×ž×™×œ×•×™-',0),(133797,3717,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚ - Î»Î¯ÏƒÏ„ÎµÏ‚ - Ï€Î»Î®ÏÏ‰ÏƒÎ·-',0),(133798,3717,'zh','è®¢å•è·Ÿè¸ª -åˆ—è¡¨ -å¡«å†™ -ç»Ÿè®¡\r\n',0),(133799,3717,'sv','BestÃ¤ll Tracking - listor - fyllning - statistik',0),(133800,3717,'it','Ordine di rilevamento - liste - riempimento - statistiche',0),(133801,3717,'tl','',0),(133802,3717,'th','&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;-&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;-&#3585;&#3634;&#3619;&#3648;&#3605;&#3636;&#3617;-&#3626;&#3606;&#3636;&#3605;',0),(133803,3717,'hi','à¤«à¤¼à¤¿à¤²à¤¿à¤‚à¤— - - à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤ - à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤•à¥‡ à¤†à¤à¤•à¤¡à¤¼à¥‡ à¤†à¤¦à¥‡à¤¶',0),(133804,3717,'ms','Perintah mengisi Tracking - senarai - - statistik',0),(133805,3717,'ar','Ø£Ù…Ø± Ø´ØºÙ„ ØªØªØ¨Ø¹-Ù‚ÙˆØ§Ø¦Ù…--Ø§Ù„Ø¥Ø­ØµØ§Ø¡Ø§Øª',0),(133806,3717,'fr','Commander suivi - listes - remplissage - statistiques',0),(133807,3717,'jp','æ³¨æ–‡ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°ãƒ¼ãƒªã‚¹ãƒˆãƒ¼è¨˜å…¥ãƒ¼çµ±è¨ˆ',0),(133808,3717,'pt','Ordem de rastreamento - listas - enchimento - estatÃ­sticas',0),(133809,3717,'ru','Ð—Ð°ÐºÐ°Ð· ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ - Ð»Ð¸ÑÑ‚Ñ‹ - Ð½Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ - ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(133810,3717,'es','Orden de Trazar - Listas - Llenando - Estadisticas',0),(133811,3717,'de','Bestellen Sie Tracking - Listen - FÃ¼llung - Statistik',0),(133812,3717,'en','Order Tracking - Lists - Filling - Statistics',0),(133813,3718,'is','',0),(133814,3718,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª â€“ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(133815,3718,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª â€“ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(133816,3718,'tr','SipariÅŸleri faturalara-->',0),(133817,3718,'pl','ZamÃ³wienia --> Faktury',0),(133818,3718,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸--> Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(133819,3718,'ur','ÙˆØ¨Ø¬Ù„ÛŒ--> Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(133820,3718,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ --> Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(133821,3718,'vi','Äáº·t hÃ ng --> HÃ³a Ä‘Æ¡n',0),(133822,3718,'af','Bestellings --> Fakture',0),(133823,3718,'ro','Comenzi --> Facturi ',0),(133824,3718,'et','Tellimused --> Arved',0),(133825,3718,'si','NaroÄila--> raÄuni',0),(133826,3718,'ba','Perintah--> faktur',0),(133827,3718,'nl','Bestellingen--> facturen',0),(133828,3718,'fi','Tilaukset--> laskut',0),(133829,3718,'no','Bestillinger--> fakturaer',0),(133830,3718,'da','Ordrer--> fakturaer',0),(133831,3718,'ko','ì²­êµ¬ì„œ--> ì£¼ë¬¸',0),(133832,3718,'he','×”×–×ž× ×•×ª --> ×—×©×‘×•× ×™×•×ª',0),(133833,3718,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚--> Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(133834,3718,'zh','è®¢å•- >â€œå‘ç¥¨\r\n',0),(133835,3718,'sv','Order--> fakturor',0),(133836,3718,'it','Ordini--> fatture',0),(133837,3718,'tl','',0),(133838,3718,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; --> &#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(133839,3718,'hi','à¤šà¤¾à¤²à¤¾à¤¨--> à¤†à¤¦à¥‡à¤¶',0),(133840,3718,'ms','Perintah--> invois',0),(133841,3718,'ar','Ø£ÙˆØ§Ù…Ø±--> Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(133842,3718,'fr','Commandes--> factures',0),(133843,3718,'jp','æ³¨æ–‡ãƒ¼ï¼žè«‹æ±‚æ›¸',0),(133844,3718,'pt','Ordens--> facturas',0),(133845,3718,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ --> Ð¡Ñ‡ÐµÑ‚Ð°',0),(133846,3718,'es','Pedidos --> Facturas',0),(133847,3718,'de','Bestellungen--> Rechnungen',0),(133848,3718,'en','Orders --> Invoices',0),(133849,3719,'is','',0),(133850,3719,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡',0),(133851,3719,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡',0),(133852,3719,'tr','Sevk edilen sipariÅŸler',0),(133853,3719,'pl','ZamÃ³wienia wysÅ‚ane',0),(133854,3719,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸, ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸',0),(133855,3719,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(133856,3719,'sr','ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÐºÐ¾Ñ˜Ðµ ÑÐµ ÑˆÐ°Ñ™Ñƒ',0),(133857,3719,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ chuyá»ƒn',0),(133858,3719,'af','Bestellings Reeds Versend',0),(133859,3719,'ro','Comenzile expediate',0),(133860,3719,'et','LÃ¤hetatud tellimuste',0),(133861,3719,'si','NaroÄila, poslana',0),(133862,3719,'ba','Pesanan dikirim',0),(133863,3719,'nl','Orders die zijn verzonden',0),(133864,3719,'fi','Toimitetut tilaukset',0),(133865,3719,'no','Ordrer',0),(133866,3719,'da','Ordrer afsendt',0),(133867,3719,'ko','ì£¼ë¬¸ ì¶œí•˜',0),(133868,3719,'he','×”×–×ž× ×•×ª ×©× ×©×œ×—×•',0),(133869,3719,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… ÏƒÏ„Î¬Î»Î¸Î·ÎºÎ±Î½',0),(133870,3719,'zh','è®¢å•å‡ºè´§\r\n',0),(133871,3719,'sv','BestÃ¤llningar levereras',0),(133872,3719,'it','Ordini spediti',0),(133873,3719,'tl','',0),(133874,3719,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(133875,3719,'hi','à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(133876,3719,'ms','Pesanan yang dihantar',0),(133877,3719,'ar','Ø£ÙˆØ§Ù…Ø± ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(133878,3719,'fr','Commandes expÃ©diÃ©es',0),(133879,3719,'jp','æ³¨æ–‡ã€€ç™ºé€?',0),(133880,3719,'pt','Pedidos enviados',0),(133881,3719,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(133882,3719,'es','Ordenes Enviados',0),(133883,3719,'de','Bestellungen',0),(133884,3719,'en','Orders Shipped',0),(133885,3720,'is','',0),(133886,3720,'dr','(Ø®Ø§Ø±Ø¬ Ø§Ø² Ø¢ÙˆÛŒØ²',0),(133887,3720,'pr','Ø«Ø§Ø¨Øª Ù†Ø´Ø¯Ù‡(Ø®Ø§Ø±Ø¬ Ø§Ø² Ù…Ø¯Ø±Ùƒ',0),(133888,3720,'tr','DÄ±ÅŸarÄ± yazÄ±m denetimi yapmak',0),(133889,3720,'pl','Na dowÃ³d',0),(133890,3720,'bg','ÐšÑŠÐ¼ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(133891,3720,'ur','Ø¨Ø§ÛØ± Ú©Ø±Ù†Û’ Ú©Ø§ Ø«Ø¨ÙˆØª',0),(133892,3720,'sr','Ð”Ð° Ñ˜Ðµ Ð´Ð¾ÐºÐ°Ð·',0),(133893,3720,'vi','NgoÃ i báº£n in thá»­',0),(133894,3720,'af','Uit om te bewys',0),(133895,3720,'ro','AfarÄƒ la dovezi',0),(133896,3720,'et','TÃµendi vÃ¤lja',0),(133897,3720,'si','Ven za dokaz',0),(133898,3720,'ba','Untuk bukti',0),(133899,3720,'nl','Out to bewijs',0),(133900,3720,'fi','Ulos todistaa',0),(133901,3720,'no','Ut bevis',0),(133902,3720,'da','Ud til bevis',0),(133903,3720,'ko','ì¦ê±°ë¥¼',0),(133904,3720,'he','×”×—×•×¦×” ×”×•×›×—×”',0),(133905,3720,'el','ÎˆÎ¾Ï‰ ÏƒÏ„Î·Î½ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î·',0),(133906,3720,'zh','å‡ºè¯æ˜Ž\r\n',0),(133907,3720,'sv','Ut till bevis',0),(133908,3720,'it','A prova di',0),(133909,3720,'tl','',0),(133910,3720,'th','&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(133911,3720,'hi','à¤¬à¤¾à¤¹à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¬à¥‚à¤¤',0),(133912,3720,'ms','Keluar untuk bukti',0),(133913,3720,'ar','Ø¨Ø§Ù„Ø®Ø§Ø±Ø¬ Ù„Ø¥Ø«Ø¨Ø§Øª',0),(133914,3720,'fr','Sortir Ã  la preuve',0),(133915,3720,'jp','Out to Proof',0),(133916,3720,'pt','Para prova',0),(133917,3720,'ru','Ð’ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾',0),(133918,3720,'es','Fuera para Prueba de ImpresiÃ³n',0),(133919,3720,'de','Out to Proof',0),(133920,3720,'en','Out to Proof',0),(133921,3721,'is','',0),(133922,3721,'dr','/ Ú†Ø§Ù¾ ÙØ±Ù… ÙÙƒØ³ ',0),(133923,3721,'pr','Ø®Ø§Ø±Ø¬ Ø¯Ø± Ù…Ø¯Ø±Ùƒ / Ú†Ø§Ù¾ ÙØ±Ù… ÙÙƒØ³ ',0),(133924,3721,'tr','DÄ±ÅŸarÄ± yazÄ±m denetimi yapmak / Faks formu yazdÄ±r',0),(133925,3721,'pl','Na dowÃ³d / Drukuj formularz faksu',0),(133926,3721,'bg','Ð”Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ / Ñ„Ð°ÐºÑ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(133927,3721,'ur','Ø«Ø¨ÙˆØª Ú©Û’ Ù„Ø¦Û’ Ø¨Ø§ÛØ± / ÙÛŒÚ©Ø³ ÙØ§Ø±Ù… Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº',0),(133928,3721,'sr','Ð”Ð° Ñ˜Ðµ Ð´Ð¾ÐºÐ°Ð· / ÐŸÑ€Ð¸Ð½Ñ‚ Ñ„Ð°ÐºÑ Ð¾Ð±Ñ€Ð°ÑÑ†Ð°',0),(133929,3721,'vi','NgoÃ i báº£n in thá»­ / Máº«u in fax',0),(133930,3721,'af','Uit om te bewys / faks vorm druk',0),(133931,3721,'ro','AfarÄƒ la dovada / Fax formularul de imprimare',0),(133932,3721,'et','TÃµendi vÃ¤lja / Prindi Faks vorm',0),(133933,3721,'si','Ven za dokaz / Natisni faks obrazec',0),(133934,3721,'ba','Untuk bukti / Print Faks formulir',0),(133935,3721,'nl','Out to bewijs / faxformulier afdrukken',0),(133936,3721,'fi','Ulos todistaa / tulosta Faksi-malli',0),(133937,3721,'no','Ut bevis / ut faksskjemaet',0),(133938,3721,'da','Ud til bevis / Print faxformularen',0),(133939,3721,'ko','ì¦ê±°ë¥¼ / íŒ©ìŠ¤ ì–‘ì‹ ì¸ì‡„',0),(133940,3721,'he','×”×—×•×¦×” ×”×•×›×—×” / ×”×“×¤×¡ ×˜×•×¤×¡ ×”×¤×§×¡',0),(133941,3721,'el','ÎˆÎ¾Ï‰ ÏƒÏ„Î·Î½ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· / ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î¼Î¿ÏÏ†Î® Ï†Î±Î¾',0),(133942,3721,'zh','å‡ºè¯æ˜Ž/æ‰“å°ä¼ çœŸè¡¨æ ¼\r\n',0),(133943,3721,'sv','Ut till bevis / skriva ut Fax formulÃ¤r',0),(133944,3721,'it','A prova / stampare il modulo Fax',0),(133945,3721,'tl','',0),(133946,3721,'th','&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;/&#3614;&#3636;&#3617;&#3614;&#3660;&#3615;&#3629;&#3619;&#3660;&#3617;&#3650;&#3607;&#3619;&#3626;&#3634;&#3619;',0),(133947,3721,'hi','à¤¬à¤¾à¤¹à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¬à¥‚à¤¤ / à¤«à¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(133948,3721,'ms','Keluar untuk bukti / cetak Borang Perkhidmatan Faks',0),(133949,3721,'ar','Ø¨Ø§Ù„Ø®Ø§Ø±Ø¬ Ù„Ø¥Ø«Ø¨Ø§Øª/Ø·Ø¨Ø§Ø¹Ø© Ù†Ù…ÙˆØ°Ø¬ Ø§Ù„ÙØ§ÙƒØ³',0),(133950,3721,'fr','Ã€ preuve / imprimer le formulaire par tÃ©lÃ©copieur',0),(133951,3721,'jp','Out to Proof / Print Fax Form',0),(133952,3721,'pt','A prova / imprimir o formulÃ¡rio de Fax',0),(133953,3721,'ru','Ð’ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ / Ñ€Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð¤Ð°ÐºÑ Ñ„Ð¾Ñ€Ð¼Ñ‹',0),(133954,3721,'es','Fuera para Prueba de ImpresiÃ³n / Imprimir Formulario de Fax',0),(133955,3721,'de','Out to Proof / Druck-Fax-Formular',0),(133956,3721,'en','Out to Proof / Print Fax Form',0),(133957,3722,'is','',0),(133958,3722,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡',0),(133959,3722,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡',0),(133960,3722,'tr','GecikmiÅŸ sipariÅŸ YazdÄ±r',0),(133961,3722,'pl','ZalegÅ‚e zamÃ³wienia druku',0),(133962,3722,'bg','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(133963,3722,'ur','Ù…ÙˆØ®Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(133964,3722,'sr','Ð”Ð¾ÑÐ¿ÐµÐ»Ð¸Ð¼ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(133965,3722,'vi','ÄÆ¡n hÃ ng in quÃ¡ háº¡n',0),(133966,3722,'af','Agterstallige Gedrukte Bestellings',0),(133967,3722,'ro','Ordine de imprimare restante',0),(133968,3722,'et','TÃ¤htaja Ã¼letanud trÃ¼kitÃ¶Ã¶de tellimused',0),(133969,3722,'si','Zdavnaj tiskanje nalogov',0),(133970,3722,'ba','Jatuh tempo cetak pesanan',0),(133971,3722,'nl','Achterstallige afdrukken bestellingen',0),(133972,3722,'fi','MyÃ¶hÃ¤ssÃ¤ tulosta tilaukset',0),(133973,3722,'no','Forfalte bestilling',0),(133974,3722,'da','Forfaldne aftryksbestillinger',0),(133975,3722,'ko','ì—°ì²´ ì¸ì‡„ ì£¼ë¬¸',0),(133976,3722,'he','×”×“×¤×¡×•×ª ×©×¤×¨×¢×•× ×Ÿ ×—×œ×£',0),(133977,3722,'el','Î•ÎºÏ€ÏÏŒÎ¸ÎµÏƒÎ¼ÎµÏ‚ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½',0),(133978,3722,'zh','é€¾æœŸæ‰“å°è®¢å•\r\n',0),(133979,3722,'sv','FÃ¶rfallna Print Order',0),(133980,3722,'it','Ordini di stampa in ritardo',0),(133981,3722,'tl','',0),(133982,3722,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(133983,3722,'hi','à¤…à¤¤à¤¿à¤¦à¥‡à¤¯ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶',0),(133984,3722,'ms','Pesanan cetakan yang tertunggak',0),(133985,3722,'ar','ØªØ£Ø®Ø± Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(133986,3722,'fr','Commandes en souffrance',0),(133987,3722,'jp','æœŸé™?çµŒé?Žæ¸ˆæ³¨æ–‡',0),(133988,3722,'pt','Ordens de impressÃ£o em atraso',0),(133989,3722,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(133990,3722,'es','Ordenes de ImpresiÃ³n Vencidos',0),(133991,3722,'de','ÃœberfÃ¤llige DruckauftrÃ¤ge',0),(133992,3722,'en','Overdue Print Orders',0),(133993,3723,'is','',0),(133994,3723,'dr','Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ ',0),(133995,3723,'pr','Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ ',0),(133996,3723,'tr','ZamanlamayÄ± geÃ§ersiz kÄ±l',0),(133997,3723,'pl','ZastÄ…piÄ‡ harmonogram',0),(133998,3723,'bg','Ð—Ð°Ð¼ÐµÐ½Ð¸ Ð³Ñ€Ð°Ñ„Ð¸Ðº',0),(133999,3723,'ur','Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ÛŒ Ú©Ùˆ Ø²ÛŒØ± Ú©Ø±ÛŒÚº',0),(134000,3723,'sr','ÐŸÑ€ÐµÐ¼Ð¾ÑÑ‚Ð¸ Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´',0),(134001,3723,'vi','Viáº¿t Ä‘Ã¨ lÃªn lá»‹ch trÃ¬nh',0),(134002,3723,'af','Ignoreer Skedule',0),(134003,3723,'ro','Trece peste program',0),(134004,3723,'et','Alistada ajakava',0),(134005,3723,'si','Preglasi urnik',0),(134006,3723,'ba','Menimpa jadwal',0),(134007,3723,'nl','Schema overschrijven',0),(134008,3723,'fi','Ohittaa aikataulu',0),(134009,3723,'no','Overstyre tidsplan',0),(134010,3723,'da','TilsidesÃ¦tte tidsplan',0),(134011,3723,'ko','ì¼ì • ë¬´ì‹œ',0),(134012,3723,'he','×œ×¢×§×•×£ ××ª ×œ×•×— ×”×–×ž× ×™×',0),(134013,3723,'el','Î Î±ÏÎ¬ÎºÎ±Î¼ÏˆÎ· Ï‡ÏÎ¿Î½Î¿Î´Î¹Î¬Î³ÏÎ±Î¼Î¼Î±',0),(134014,3723,'zh','è¦†ç›–é™„è¡¨\r\n',0),(134015,3723,'sv','Ã…sidosÃ¤tt schema',0),(134016,3723,'it','Eseguire l\'override di pianificazione',0),(134017,3723,'tl','',0),(134018,3723,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;',0),(134019,3723,'hi','à¤…à¤¨à¥à¤¸à¥‚à¤šà¥€ à¤“à¤µà¤°à¤°à¤¾à¤‡à¤¡ à¤•à¤°à¥‡à¤‚',0),(134020,3723,'ms','Mengatasi Jadual',0),(134021,3723,'ar','ØªØ¬Ø§ÙˆØ² Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø²Ù…Ù†ÙŠ',0),(134022,3723,'fr','DÃ©roger Ã  horaire',0),(134023,3723,'jp','ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ«ã‚’ç„¡åŠ¹ã?«ã?™ã‚‹',0),(134024,3723,'pt','Substituir a agenda',0),(134025,3723,'ru','ÐŸÐµÑ€ÐµÐ¾Ð¿Ñ€ÐµÐ´ÐµÐ»Ð¸Ñ‚ÑŒ Ñ€Ð°ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(134026,3723,'es','Sobrecontrolar la Agenda',0),(134027,3723,'de','Zeitplan zu Ã¼berschreiben',0),(134028,3723,'en','Override Schedule',0),(134029,3724,'is','',0),(134030,3724,'dr','ØªØºÙŠÙŠØ± Ù¾Ø§Ø±Ø§Ù…ØªØ±Ù‡Ø§ÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ùˆ Ù‚ÙÙ„ Ø¯Ø± ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ø´Ø±ÙˆØ¹ ',0),(134031,3724,'pr','ØªØºÙŠÙŠØ± Ù¾Ø§Ø±Ø§Ù…ØªØ±Ù‡Ø§ÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ùˆ Ù‚ÙÙ„ Ø¯Ø± ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ø´Ø±ÙˆØ¹ ',0),(134032,3724,'tr','ALTER zamanlama parametreleri deÄŸiÅŸtirerek baÅŸlangÄ±Ã§ tarihleri ve baÅŸlangÄ±Ã§ tarihleri kilitleme',0),(134033,3724,'pl','Zmiany parametrÃ³w harmonogramu zmieniajÄ…c poczÄ…tkowÄ… i blokowania w daty rozpoczÄ™cia',0),(134034,3724,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½ÑÑ‚ Ñ€Ð°Ð·Ð¿Ð¸ÑÐ°Ð½Ð¸ÐµÑ‚Ð¾ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¸ ÐºÐ°Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð¾Ñ‡Ð½Ð°Ñ‚ Ð´Ð°Ñ‚Ð¸ Ð¸ Ð·Ð°ÐºÐ»ÑŽÑ‡Ð²Ð°Ð½Ðµ Ð² Ð½Ð°Ñ‡Ð°Ð»Ð½Ð¸ Ð´Ð°Ñ‚Ð¸',0),(134035,3724,'ur','Ù¾ÛŒØ±Ø§Ù…ÛŒÙ¹Ø± Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø´ÛŒÚˆÙˆÙ„ ØªØ¨Ø¯ÛŒÙ„ ØªØ§Ø±ÛŒØ®ÙˆÚº Ø§ÙˆØ± Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØªØ§Ø±ÛŒØ®ÙˆÚº Ù…ÛŒÚº Ù…Ù‚ÙÙ„ Ú©Ø±Ù†Û’ Ù¾Ø± Ø´Ø±ÙˆØ¹ Ú©Ø±ÛŒÚº',0),(134036,3724,'sr','ÐÐ»Ñ‚ÐµÑ€ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¸ Ð°Ð½Ð°Ð»Ð¸Ð·Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¾Ð¼ Ð´Ð°Ñ‚ÑƒÐ¼Ð¸ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¸ Ð·Ð°ÐºÑ™ÑƒÑ‡Ð°Ð²Ð°ÑšÐµ Ñƒ Ð´Ð°Ñ‚ÑƒÐ¼Ð¸Ð¼Ð° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(134037,3724,'vi','Chá»‰nh sá»­a pháº¡m vi lá»‹ch trÃ¬nh báº±ng cÃ¡ch thay Ä‘á»•i & khÃ³a táº¥t cáº£ cÃ¡c ngÃ y báº¯t Ä‘áº§u',0),(134038,3724,'af','Wysig skedule Parameters deur verandering begin datums en sluit in begin datums',0),(134039,3724,'ro','Alter programul parametrii prin schimbarea Ã®ncepe datele ÅŸi blocare Ã®n datele de pornire',0),(134040,3724,'et','Muuda graafiku parameetreid muutes alustada kuupÃ¤evad ja lukustamine algus',0),(134041,3724,'si','Alter tabela parametar s spreminjanjem zaÄetek datume in blokiranje v zaÄetne datume',0),(134042,3724,'ba','Mengubah jadwal parameter dengan mengubah mulai tanggal dan mengunci di tanggal mulai',0),(134043,3724,'nl','Schema Parameters veranderen door het veranderen van begin- en de vergrendeling in begindatums',0),(134044,3724,'fi','Muuta aikataulu parametri muuttamalla aloituspÃ¤ivÃ¤n ja lukitsemisen alkamis',0),(134045,3724,'no','Endre planleggingsparametere ved Ã¥ endre start- og lÃ¥se startdatoer',0),(134046,3724,'da','Ã†ndre tidsplanen parametre ved at Ã¦ndre start datoer og lÃ¥sning i startdatoer',0),(134047,3724,'ko','ë³€ê²½ í•˜ ì—¬ ì¼ì • ë§¤ê°œ ë³€ìˆ˜ ë³€ê²½ ì‹œìž‘ ë‚ ì§œ ë° ì‹œìž‘ ë‚ ì§œ ìž ê¸ˆ',0),(134048,3724,'he','×œ×©× ×•×ª ×¤×¨×ž×˜×¨×™× ×”×–×ž× ×™× ×¢×œ-×™×“×™ ×©×™× ×•×™ ×ª××¨×™×›×™ ×”×”×ª×—×œ×” × ×¢×™×œ×” ×‘×ª××¨×™×›×™ ×”×”×ª×—×œ×”',0),(134049,3724,'el','Î¤ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï€Î±ÏÎ±Î¼Î­Ï„ÏÏ‰Î½ Ï‡ÏÎ¿Î½Î¿Î´Î¹Î±Î³ÏÎ¬Î¼Î¼Î±Ï„Î¿Ï‚ Î¼Îµ Ï„Î·Î½ Î±Î»Î»Î±Î³Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½ Î­Î½Î±ÏÎ¾Î·Ï‚ ÎºÎ±Î¹ ÎºÎ»ÎµÎ¯Î´Ï‰Î¼Î± ÏƒÎµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚ Î­Î½Î±ÏÎ¾Î·Ï‚',0),(134050,3724,'zh','è®¡åˆ’å‚æ•°é€šè¿‡å¼€å§‹æ—¥æœŸçš„ä¿®æ”¹å’Œé”å®šè¿›è¡Œå˜æ›´\r\n',0),(134051,3724,'sv','Ã„ndra schema parametrar genom att Ã¤ndra start- och lÃ¥sning i startdatum',0),(134052,3724,'it','Alterare i parametri di pianificazione cambiando iniziare date e date di inizio di bloccaggio',0),(134053,3724,'tl','',0),(134054,3724,'th','Alter Schedule Parameters by changing start dates and locking in start dates',0),(134055,3724,'hi','à¤ªà¥ˆà¤°à¤¾à¤®à¥€à¤Ÿà¤°à¥à¤¸ à¤¬à¤¦à¤²à¤¨à¥‡ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤…à¤¨à¥à¤¸à¥‚à¤šà¥€ à¤¬à¤¦à¤² à¤¶à¥à¤°à¥‚ à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤ à¤”à¤° à¤²à¥‰à¤•à¤¿à¤‚à¤— à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(134056,3724,'ms','Mengubah Jadual parameter dengan menukar mula tarikh dan penguncian tarikh mula',0),(134057,3724,'ar','Ø¨Ø¯Ø¡ \"ØªØºÙŠÙŠØ± Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø²Ù…Ù†ÙŠ Ù„Ù„Ù…Ø¹Ù„Ù…Ø§Øª\" Ø¨ØªØºÙŠÙŠØ± Ø§Ù„ØªÙˆØ§Ø±ÙŠØ® ÙˆÙ‚ÙÙ„ ÙÙŠ ØªÙˆØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(134058,3724,'fr','Modifier les paramÃ¨tres de calendrier en changeant start dates et verrouillage dans les dates de dÃ©but',0),(134059,3724,'jp','é–‹å§‹æ—¥ã‚’å¤‰æ›´ã€?å›ºå®šã?™ã‚‹ã?“ã?¨ã?«ã‚ˆã‚Šã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ«ãƒ‘ãƒ©ãƒ¡ãƒ¼ã‚¿ãƒ¼ã‚’å¤‰æ›´ã?™ã‚‹',0),(134060,3724,'pt','ComeÃ§ar a alterar parÃ¢metros de programaÃ§Ã£o, alterando datas e bloqueio nas datas de inÃ­cio',0),(134061,3724,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ñ€Ð°ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ, Ð¸Ð·Ð¼ÐµÐ½Ð¸Ð² Ð´Ð°Ñ‚Ñ‹ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¸ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²ÐºÐ° Ð² Ð´Ð°Ñ‚Ñ‹ Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(134062,3724,'es','Aleterar ParÃ¡metros de Agenda por Cambiar Fechas de Comienza y Fijando Fechas de Comienza',0),(134063,3724,'de','Alter Zeitplanparameter durch Ã„ndern start Termine und Sperren in Startdaten',0),(134064,3724,'en','Alter Schedule Parameters by changing start dates and locking in start dates',0),(134065,3725,'is','',0),(134066,3725,'dr','(Ù…ØªÙ†Ø§Ø³Ø¨ Ø¨Ø§ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(134067,3725,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ(Ù…ØªÙ†Ø§Ø³Ø¨ Ø¨Ø§ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(134068,3725,'tr','Tamamlanan satÄ±nalma sipariÅŸi bilgilerini BorÃ§lar (alÄ±nan faturalarÄ± maÃ§a) iÃ§ine geÃ§mek',0),(134069,3725,'pl','Przekazywania informacji zamÃ³wienia dokonanie zakupu do zobowiÄ…zania (dopasowanie do rachunkÃ³w za otrzymane)',0),(134070,3725,'bg','ÐŸÑ€ÐµÐ´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð²ÑŠÑ€ÑˆÐµÐ½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð² Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ (Ð¼Ð°Ñ‡ Ð·Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸)',0),(134071,3725,'ur','Ù…Ú©Ù…Ù„ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ (Ù…ÛŒÚ† Ø¨Ù„ ÙˆØµÙˆÙ„ Ú©Ø±Ù†Û’) Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(134072,3725,'sr','ÐŸÑ€ÐµÐ½Ð¾ÑÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸Ñ… Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ñƒ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° (Ð¿Ð¾ÐºÐ»Ð°Ð¿Ð° ÑÐ° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ)',0),(134073,3725,'vi','HoÃ n Táº¥t Káº¿t Chuyá»ƒn thÃ´ng tin ÄÆ¡n Mua HÃ ng sang TK Pháº£i Tráº£ (PhÃ¹ há»£p vá»›i hÃ³a Ä‘Æ¡n Ä‘Ã£ nháº­n)',0),(134074,3725,'af','Aanstuur na Voltooide Aankoopbestelling inligting binne Uitgawes (RB) [Vergelyk met Rekening Ontvang]',0),(134075,3725,'ro','Transmite informaÅ£ii de ordin cumpÄƒrare completat Ã®n datorii (meci la facturile primite)',0),(134076,3725,'et','TÃ¤idetud ostutellimuste teabe erituda vÃµlad (vaste saadud arved)',0),(134077,3725,'si','Mimo izpolnjen informacije o naroÄilnici v obveznosti (tekmo prejetih raÄunov)',0),(134078,3725,'ba','Lulus informasi pesanan pembelian selesai ke hutang (cocok untuk tagihan yang diterima)',0),(134079,3725,'nl','Voltooide aankoop Orderinformatie doorgeven in schulden (Match te ontvangen rekeningen)',0),(134080,3725,'fi','Valmistunut ostotilauksen kulkeutua velat (Match laskuja saanut)',0),(134081,3725,'no','Sende ferdige bestillingsinformasjon i leverandÃ¸rgjeld (Match regninger mottatt)',0),(134082,3725,'da','Passere udfyldte indkÃ¸bsordreoplysninger i gÃ¦ld (Match til regninger modtaget)',0),(134083,3725,'ko','ë¯¸ì§€ê¸‰ê¸ˆ (ì¼ì¹˜ ê³„ì‚° ì„œ ë°›ì€) ì™„ë£Œ ëœ êµ¬ë§¤ ì£¼ë¬¸ ì •ë³´ ì „ë‹¬',0),(134084,3725,'he','×ž×¢×‘×™×¨ ×ž×™×“×¢ ××•×“×•×ª ×”×–×ž× ×ª ×¨×›×™×©×” ×©×”×•×©×œ×ž×• ×–×›××™× (×”×ª×× ××ª ×”×—×©×‘×•× ×•×ª ×©×”×ª×§×‘×œ×•)',0),(134085,3725,'el','Î ÎµÏÎ¬ÏƒÎµÎ¹ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÏ„Î¿ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ (Î‘Î³ÏŽÎ½Î±Ï‚ Î­Î»Î±Î²Îµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚)',0),(134086,3725,'zh','å®Œæˆçš„è´­ä¹°è®¢å•ä¿¡æ¯ä¼ é€’åˆ°åº”ä»˜æ¬¾ï¼ˆä¸Žæ”¶åˆ°çš„å¸å•åŒ¹é…ï¼‰\r\n',0),(134087,3725,'sv','Passera Ã¶ver slutfÃ¶rda inkÃ¶psorderinformation i leverantÃ¶rsskulder (Match till rÃ¤kningar fick)',0),(134088,3725,'it','Passare informazioni sull\'ordine di acquisto completato nel debiti (partita a fatture ricevute)',0),(134089,3725,'tl','',0),(134090,3725,'th','Pass Completed Purchase Order Information into Payables (Match to Bills Received)',0),(134091,3725,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¥‡ Payables (à¤¬à¤¿à¤² à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥ˆà¤š) à¤®à¥‡à¤‚ à¤—à¥à¤œà¤¾à¤°à¥‡à¤‚',0),(134092,3725,'ms','Pas maklumat pesanan pembelian yang telah siap ke dalam pemiutang (perlawanan untuk bil-bil yang diterima)',0),(134093,3725,'ar','ØªÙ…Ø±ÙŠØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡ Ø§Ù„Ù…Ù†Ø¬Ø²Ø© ÙÙŠ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹ (Ù…Ø·Ø§Ø¨Ù‚Ø© Ù„Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ÙˆØ§Ø±Ø¯Ø©)',0),(134094,3725,'fr','Passer des informations de commande dâ€™achat dÃ»ment rempli dans des comptes fournisseurs (match de football aux factures reÃ§ues)',0),(134095,3725,'jp','è²·æŽ›é‡‘ï¼ˆå?—é ˜æ¸ˆè«‹æ±‚æ›¸ã?«ä¸€è‡´ã?™ã‚‹ï¼‰ã?¸å®Œäº†æ¸ˆè³¼å…¥æ³¨æ–‡æƒ…å ±ã‚’é€?ã‚‹',0),(134096,3725,'pt','Transmitir informaÃ§Ãµes de ordem de compra concluÃ­do em contas a pagar (correspondÃªncia de contas recebidas)',0),(134097,3725,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ð¹Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð¾ Ð·Ð°ÐºÐ°Ð·Ðµ ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð² ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ (Ð¼Ð°Ñ‚Ñ‡ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°)',0),(134098,3725,'es','Pasar InformaciÃ³n de Ordenes de Compras Completados a Proveedores (Emparejar Recibos Recibidos)',0),(134099,3725,'de','Ãœbergeben Sie abgeschlossene Bestelldaten an Verbindlichkeiten (Ãœbereinstimmung mit Rechnungen erhalten)',0),(134100,3725,'en','Pass Completed Purchase Order Information into Payables (Match to Bills Received)',0),(134101,3726,'is','',0),(134102,3726,'dr','Ø§Ù†ÙˆØ§Ø¹ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(134103,3726,'pr','Ø§Ù†ÙˆØ§Ø¹ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(134104,3726,'tr','Ã–deme tipleri',0),(134105,3726,'pl','Typy pÅ‚atnoÅ›ci',0),(134106,3726,'bg','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(134107,3726,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(134108,3726,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸',0),(134109,3726,'vi','Loáº¡i thanh toÃ¡n',0),(134110,3726,'af','Betaal Tipes',0),(134111,3726,'ro','Tipuri de plati',0),(134112,3726,'et','Tasumise tÃ¼Ã¼bid',0),(134113,3726,'si','PlaÄilo vrste',0),(134114,3726,'ba','Membayar jenis',0),(134115,3726,'nl','Typen betalen',0),(134116,3726,'fi','Maksutyypit',0),(134117,3726,'no','LÃ¸nnstyper',0),(134118,3726,'da','LÃ¸ntyper',0),(134119,3726,'ko','ì§€ë¶ˆ ìœ í˜•',0),(134120,3726,'he','×œ×©×œ× ×¡×•×’×™×',0),(134121,3726,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Ï„ÏÏ€Î¿Ï…Ï‚',0),(134122,3726,'zh','æ”¯ä»˜ç±»åž‹\r\n',0),(134123,3726,'sv','LÃ¶netyper',0),(134124,3726,'it','Tipi di pagamento',0),(134125,3726,'tl','',0),(134126,3726,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(134127,3726,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(134128,3726,'ms','Membayar jenis',0),(134129,3726,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¯ÙØ¹',0),(134130,3726,'fr','Payer des Types',0),(134131,3726,'jp','æ”¯æ‰•ã?„ã‚¿ã‚¤ãƒ—',0),(134132,3726,'pt','Tipos de pagar',0),(134133,3726,'ru','Ð¢Ð¸Ð¿Ñ‹ ÐŸÐ»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(134134,3726,'es','Pagar por Tipos',0),(134135,3726,'de','Zahlungsarten',0),(134136,3726,'en','Pay Types',0),(134137,3727,'is','',0),(134138,3727,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(134139,3727,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(134140,3727,'tr','BorÃ§lar ayrÄ±ntÄ± raporu',0),(134141,3727,'pl','SzczegÃ³Å‚y zobowiÄ…zania Raport Wiekowanie',0),(134142,3727,'bg','Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð½Ð¾ÑÑ‚ ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(134143,3727,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ ØªÙØµÛŒÙ„ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ø®Ø³ØªÛ',0),(134144,3727,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð´ÐµÑ‚Ð°Ñ™ ÑÑ‚Ð°Ñ€ÐµÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(134145,3727,'vi','BÃ¡o CÃ¡o TK Pháº£i Tráº£ Theo Tuá»•i Ná»£',0),(134146,3727,'af','Uitgawes (RB) Gedetailleerde Ouderdomsverslag',0),(134147,3727,'ro','Datorii detaliu raportul de imbatranire',0),(134148,3727,'et','Aegumisaruande vÃµlad Detail',0),(134149,3727,'si','Podrobnosti obveznosti, staranje poroÄilo',0),(134150,3727,'ba','Hutang Detail penuaan laporan',0),(134151,3727,'nl','Schulden Detail Aging verslag',0),(134152,3727,'fi','Ostovelat yksityiskohtaisesti yht.veto-raportin',0),(134153,3727,'no','LeverandÃ¸rgjeld detalj aldersfordelt saldoliste',0),(134154,3727,'da','Kreditorstyring detaljer Aging rapport',0),(134155,3727,'ko','ë¯¸ì§€ê¸‰ê¸ˆ ì„¸ë¶€ ë³´ê³ ì„œë¥¼ ë…¸í™”',0),(134156,3727,'he','×¤×™×¨×•×˜ ×–×›××™× ×“×•×— ×’×™×•×œ',0),(134157,3727,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ Î³Î®ÏÎ±Î½ÏƒÎ· Î­ÎºÎ¸ÎµÏƒÎ·',0),(134158,3727,'zh','åº”ä»˜æ˜Žç»†æ¬ æ•°åˆ†æžæŠ¥è¡¨\r\n',0),(134159,3727,'sv','LeverantÃ¶rsskulder detalj Ã…ldersrapport',0),(134160,3727,'it','Dettaglio debiti Report di invecchiamento',0),(134161,3727,'tl','',0),(134162,3727,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(134163,3727,'hi','Payables à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤¸à¥‡ à¤à¤œà¤¿à¤‚à¤— à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(134164,3727,'ms','Penuaan laporan terperinci pembayaran',0),(134165,3727,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(134166,3727,'fr','DÃ©tail des comptes fournisseurs, rapport dâ€™ANTERIORITE',0),(134167,3727,'jp','æ”¯æ‰•è©³ç´°ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(134168,3727,'pt','Detalhe de contas a pagar, relatÃ³rio de envelhecimento',0),(134169,3727,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ ÑÑ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(134170,3727,'es','Proveedores Informe de Detalle de AntigÃ¼edad',0),(134171,3727,'de','Verbindlichkeiten-Detail Altern Bericht',0),(134172,3727,'en','Payables Detail Aging Report',0),(134173,3728,'is','',0),(134174,3728,'dr','ØªØ®ÙÙŠÙØ§Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(134175,3728,'pr','ØªØ®ÙÙŠÙØ§Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(134176,3728,'tr','YaÅŸlanma - indirim (BorÃ§lar) raporu',0),(134177,3728,'pl','Starzenie siÄ™ - raport zniÅ¼ki (zobowiÄ…zania)',0),(134178,3728,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ - Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ° (Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ) Ð´Ð¾ÐºÐ»Ð°Ð´',0),(134179,3728,'ur','Ø®Ø³ØªÛ - Ø±Ø¹Ø§ÛŒØª (Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³) Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(134180,3728,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ - Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð° (Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°)',0),(134181,3728,'vi','BÃ¡o CÃ¡o TK Chiáº¿t Kháº¥u Pháº£i Tráº£ Theo Tuá»•i Ná»£',0),(134182,3728,'af','Uitgawes (RB) Korting Ouderdomsverslag',0),(134183,3728,'ro','Imbatranirea - raport de reducere (cumpÄƒrÄƒri ÅŸi datorii)',0),(134184,3728,'et','Vananemine - allahindlust (vÃµlad) aruanne',0),(134185,3728,'si','Staranje - poroÄilo popust (obveznosti)',0),(134186,3728,'ba','Penuaan - diskon (kewajiban) laporan',0),(134187,3728,'nl','Veroudering - korting (schulden) verslag',0),(134188,3728,'fi','IkÃ¤Ã¤ntyminen - alennus (velat) raportti',0),(134189,3728,'no','Aldring - rabatt (leverandÃ¸rgjeld) rapport',0),(134190,3728,'da','Aldring - rabat (gÃ¦ld) rapport',0),(134191,3728,'ko','ë…¸í™”-í• ì¸ (ë¯¸ì§€ê¸‰ê¸ˆ) ë³´ê³ ì„œ',0),(134192,3728,'he','×”×–×“×§× ×•×ª - ×“×•×— ×”× ×—×” (×–×›××™×)',0),(134193,3728,'el','Î“Î®ÏÎ±Î½ÏƒÎ· - Î‘Î½Î±Ï†Î¿ÏÎ¬ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚ (Ï€Î»Î·ÏÏ‰Ï„Î­Î±)',0),(134194,3728,'zh','åº”ä»˜æŠ˜æ‰£æ¬ æ•°åˆ†æžæŠ¥è¡¨',0),(134195,3728,'sv','Ã…ldrande - rabatt (LeverantÃ¶rsskulder) rapport',0),(134196,3728,'it','Invecchiamento - Report di sconto (debiti)',0),(134197,3728,'tl','',0),(134198,3728,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(134199,3728,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ - à¤›à¥‚à¤Ÿ (Payables) à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(134200,3728,'ms','Penuaan - laporan diskaun (pemiutang)',0),(134201,3728,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©-ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø®ØµÙ… (Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹)',0),(134202,3728,'fr','Vieillissement - Rapport de rÃ©duction (comptes fournisseurs)',0),(134203,3728,'jp','æ”¯æ‰•å‰²å¼•ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(134204,3728,'pt','Envelhecimento - relatÃ³rio de desconto (contas a pagar)',0),(134205,3728,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ - ÑÐºÐ¸Ð´ÐºÐ° (ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ) Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(134206,3728,'es','Proveedores Informe de Descuentos de AntigÃ¼edad',0),(134207,3728,'de','Altern - Rabatt (Verbindlichkeiten) Bericht',0),(134208,3728,'en','Aging - Discount (Payables) Report',0),(134209,3729,'is','',0),(134210,3729,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† â€“ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù†ÙˆØ´ØªÙ† Ú†Ùƒ â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª ',0),(134211,3729,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  Ø«Ø¨Øª  / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ â€“ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù†ÙˆØ´ØªÙ† Ú†Ùƒ â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª ',0),(134212,3729,'tr','Onay isteklerini - yaz BorÃ§lar giriÅŸ/gÃ¼ncelleme - raporlar',0),(134213,3729,'pl','ZobowiÄ…zaÅ„ wpis/aktualizacja - Napisz proÅ›bÄ™ - raporty',0),(134214,3729,'bg','Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ ÐºÑŠÐ¼ Ð·Ð°Ð¿Ð¸Ñ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ - Ð¿Ð¸ÑˆÐ° Ð¸ÑÐºÐ°Ð½Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° - Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(134215,3729,'ur','Ú†ÛŒÚ© Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº - Ù„Ú©Ú¾ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø§Ù†Ø¯Ø±Ø§Ø¬/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº - Ø±Ù¾ÙˆØ±Ù¹',0),(134216,3729,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°/ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ - Ð½Ð°Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ - Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™ÑƒÑ˜Ðµ.',0),(134217,3729,'vi','Nháº­p/Cáº­p Nháº­t Pháº£i Tráº£ - YÃªu Cáº§u Viáº¿t SÃ©c - BÃ¡o CÃ¡o',0),(134218,3729,'af','Uitgawes (RB) Inskryf/Opdateer - Skryf Tjekversoeke - Verslae',0),(134219,3729,'ro','Datorii intrare/Update - scrie verificare cereri - rapoarte',0),(134220,3729,'et','VÃµlad kanne/Update - kirjutada sisse taotlused - lahendid',0),(134221,3729,'si','Obveznosti vnos/posodobitev - napisati pregled zahtev - poroÄila',0),(134222,3729,'ba','Hutang Entry/Update - menulis permintaan Check - laporan',0),(134223,3729,'nl','Schulden Entry/Update - schrijven selectievakje verzoeken - verslagen',0),(134224,3729,'fi','Ostovelat merkintÃ¤/PÃ¤ivitÃ¤ - kirjoittaa shekki nostopyyntÃ¶jen - raportit',0),(134225,3729,'no','LeverandÃ¸rgjeld oppfÃ¸ring/oppdatere - sjekk skriveforespÃ¸rsler - rapporter',0),(134226,3729,'da','Kreditorstyring post/Update - Check skriveanmodninger - rapporter',0),(134227,3729,'ko','ë¯¸ì§€ê¸‰ê¸ˆ í•­ëª©/ì—…ë°ì´íŠ¸-ë¦¬í¬íŠ¸ ì“°ê¸° í™•ì¸ ìš”ì²­-',0),(134228,3729,'he','×–×›××™× ×›× ×™×¡×”/×¢×“×›×•×Ÿ - ×œ×›×ª×•×‘ ×‘×§×©×•×ª ×¡×™×ž×•×Ÿ - ×“×•×—×•×ª',0),(134229,3729,'el','Î Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ - Î³ÏÎ¬Ï†Î¿Ï…Î½ Ï„Î± Î±Î¹Ï„Î®Î¼Î±Ï„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… - ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(134230,3729,'zh','åº”ä»˜æ¡ç›®/æ›´æ–°- å†™æ”¯ç¥¨ç”³è¯·- æŠ¥å‘Š\r\n',0),(134231,3729,'sv','LeverantÃ¶rsskulder intrÃ¤de/uppdatera - skriva in fÃ¶rfrÃ¥gningar - rapporterar',0),(134232,3729,'it','Scrivere le richieste di Check - rapporti debiti voce/aggiornamento-',0),(134233,3729,'tl','',0),(134234,3729,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;-&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3651;&#3627;&#3657;&#3648;&#3586;&#3637;&#3618;&#3609;',0),(134235,3729,'hi','à¤²à¤¿à¤–à¤¨à¥‡ à¤•à¥‡ à¤šà¥‡à¤• à¤…à¤¨à¥à¤°à¥‹à¤§ - payables à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿/à¤…à¤¦à¥à¤¯à¤¤à¤¨ - à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(134236,3729,'ms','Pemiutang Entry/Update - menulis permintaan semak - Laporan',0),(134237,3729,'ar','ÙƒØªØ§Ø¨Ø© Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±-ØªÙ‚Ø§Ø±ÙŠØ± Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ«-',0),(134238,3729,'fr','Saisie des comptes fournisseurs/mise Ã  jour - Ã©crire des requÃªtes de contrÃ´le - rapports',0),(134239,3729,'jp','æ”¯æ‰•ã?®å…¥åŠ›/æ›´æ–°ãƒ¼å°?åˆ‡æ‰‹æ›¸è¾¼ã?¿ãƒªã‚¯ã‚¨ã‚¹ãƒˆãƒ¼ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(134240,3729,'pt','Entrada de contas a pagar/Update - escrever pedidos de Check - relatÃ³rios',0),(134241,3729,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ Ð’Ñ…Ð¾Ð´/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ - Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð² - Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹',0),(134242,3729,'es','Proveedores Introducir/Actualizar-Solicitaciones de Elaborar Cheques - Informes',0),(134243,3729,'de','Verbindlichkeiten-Eintrag/Update - Check Schreibanforderungen - Berichte',0),(134244,3729,'en','Payables Entry/Update - Write Check Requests - Reports',0),(134245,3730,'is','',0),(134246,3730,'dr','Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(134247,3730,'pr','Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(134248,3730,'tr','BorÃ§lar listesi',0),(134249,3730,'pl','Lista zobowiÄ…zaÅ„',0),(134250,3730,'bg','Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ ÐºÑŠÐ¼ ÑÐ¿Ð¸ÑÑŠÐº',0),(134251,3730,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(134252,3730,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð»Ð¸ÑÑ‚Ð°',0),(134253,3730,'vi','Danh SÃ¡ch Pháº£i Tráº£',0),(134254,3730,'af','Uitgawes (RB) Lyste',0),(134255,3730,'ro','Lista de datorii',0),(134256,3730,'et','Tasumata arved',0),(134257,3730,'si','Seznam obveznosti',0),(134258,3730,'ba','Daftar hutang',0),(134259,3730,'nl','Lijst van de schulden',0),(134260,3730,'fi','Ostojen luettelo',0),(134261,3730,'no','LeverandÃ¸rgjeld liste',0),(134262,3730,'da','Kreditorstyring liste',0),(134263,3730,'ko','ë¯¸ì§€ê¸‰ê¸ˆ ëª©ë¡',0),(134264,3730,'he','×¨×©×™×ž×ª ×–×›××™×',0),(134265,3730,'el','Î›Î¯ÏƒÏ„Î± Ï…Ï€Î¿Ï‡ÏÎµÏŽÏƒÎµÏ‰Î½',0),(134266,3730,'zh','åº”ä»˜åå•\r\n',0),(134267,3730,'sv','LeverantÃ¶rsskulder lista',0),(134268,3730,'it','Elenco di debiti',0),(134269,3730,'tl','',0),(134270,3730,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(134271,3730,'hi','Payables à¤¸à¥‚à¤šà¥€',0),(134272,3730,'ms','Senarai pemiutang',0),(134273,3730,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹',0),(134274,3730,'fr','Liste des comptes fournisseurs',0),(134275,3730,'jp','è²·æŽ›é‡‘ã€€ãƒªã‚¹ãƒˆ',0),(134276,3730,'pt','Lista de contas a pagar',0),(134277,3730,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(134278,3730,'es','Lista de Cuentas por Pagar',0),(134279,3730,'de','Verbindlichkeiten-Liste',0),(134280,3730,'en','Payables List',0),(134281,3731,'is','',0),(134282,3731,'dr','Ø®Ù„Ø§ØµÙ‡ Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(134283,3731,'pr','Ø®Ù„Ø§ØµÙ‡ Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(134284,3731,'tr','BorÃ§lar Ã–zet YaÅŸlandÄ±rma raporunu',0),(134285,3731,'pl','KrÃ³tki opis zobowiÄ…zania Raport Wiekowanie',0),(134286,3731,'bg','Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ Ð ÐµÐ·ÑŽÐ¼Ðµ ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(134287,3731,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø®Ù„Ø§ØµÛ Ø±Ù¾ÙˆØ±Ù¹ Ø®Ø³ØªÛ',0),(134288,3731,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ð´Ð¾ÑÐ¿ÐµÐ²Ð°ÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(134289,3731,'vi','BÃ¡o CÃ¡o Tá»•ng Há»£p TK Pháº£i Tráº£ Theo Tuá»•i Ná»£',0),(134290,3731,'af','Uitgawes (RB) Opsomming Ouderdomsverslag',0),(134291,3731,'ro','Datorii Rezumat raport de imbatranire',0),(134292,3731,'et','VÃµlad Summaarne aegumine aruanne',0),(134293,3731,'si','Zapadlost obveznosti poroÄilo',0),(134294,3731,'ba','Hutang ringkasan penuaan laporan',0),(134295,3731,'nl','Schulden Open posten verslag',0),(134296,3731,'fi','Ostovelat ErÃ¤Ã¤nt. yht.veto-raportissa',0),(134297,3731,'no','LeverandÃ¸rgjeld Sammendrag aldersfordelt saldoliste',0),(134298,3731,'da','Kreditorstyring Forfaldsoversigt rapport',0),(134299,3731,'ko','ë¯¸ì§€ê¸‰ê¸ˆ ìš”ì•½ ì—ì´ì§• ë³´ê³ ì„œ',0),(134300,3731,'he','×–×›××™× ×ª×§×¦×™×¨ ×“×•×— ×’×™×•×œ',0),(134301,3731,'el','Î Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ Î£ÏÎ½Î¿ÏˆÎ· Î•Î½Î·Î»Î¹ÎºÎ¯Ï‰ÏƒÎ·Ï‚ Î­ÎºÎ¸ÎµÏƒÎ·Ï‚',0),(134302,3731,'zh','åº”ä»˜æ‘˜è¦æ¬ æ•°åˆ†æžæŠ¥è¡¨\r\n',0),(134303,3731,'sv','LeverantÃ¶rsskulder Sammanfattning Ã…ldersrapport',0),(134304,3731,'it','Scadenziario debiti e Report',0),(134305,3731,'tl','',0),(134306,3731,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3626;&#3619;&#3640;&#3611;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(134307,3731,'hi','Payables à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤à¤œà¤¿à¤‚à¤—',0),(134308,3731,'ms','Ringkasan pemiutang penuaan Laporan',0),(134309,3731,'ar','Ù…Ù„Ø®Øµ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(134310,3731,'fr','RÃ©sumÃ© des comptes fournisseurs, rapport dâ€™ANTERIORITE',0),(134311,3731,'jp','æ”¯æ‰•ã‚µãƒžãƒªãƒ¼ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(134312,3731,'pt','Resumo de contas a pagar, relatÃ³rio de envelhecimento',0),(134313,3731,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ ÐžÐ±Ñ‰Ð°Ñ Ð—Ð°Ð´Ð¾Ð»Ð¶ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(134314,3731,'es','Cuentas por Pagar Informe de Resumen de AntigÃ¼edad',0),(134315,3731,'de','Verbindlichkeiten-Zusammenfassung Bericht Altern',0),(134316,3731,'en','Payables Summary Aging Report',0),(134317,3732,'is','',0),(134318,3732,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(134319,3732,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(134320,3732,'tr','Ã–deme raporu',0),(134321,3732,'pl','Raport pÅ‚atnoÅ›ci',0),(134322,3732,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(134323,3732,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(134324,3732,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(134325,3732,'vi','BÃ¡o CÃ¡o Thanh ToÃ¡n',0),(134326,3732,'af','Betalingsverslae',0),(134327,3732,'ro','Raport de platÄƒ',0),(134328,3732,'et','Maksete aruanne',0),(134329,3732,'si','PlaÄilo poroÄilo',0),(134330,3732,'ba','Laporan pembayaran',0),(134331,3732,'nl','Betaling verslag',0),(134332,3732,'fi','Maksuraportti',0),(134333,3732,'no','Betaling rapport',0),(134334,3732,'da','Betaling rapport',0),(134335,3732,'ko','ì§€ë¶ˆ ë³´ê³ ì„œ',0),(134336,3732,'he','×“×•×— ×ª×©×œ×•×',0),(134337,3732,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î·Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(134338,3732,'zh','ä»˜æ¬¾æŠ¥å‘Š\r\n',0),(134339,3732,'sv','Betalning rapport',0),(134340,3732,'it','Rapporto di pagamento',0),(134341,3732,'tl','',0),(134342,3732,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(134343,3732,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(134344,3732,'ms','Laporan pembayaran',0),(134345,3732,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø³Ø¯Ø§Ø¯',0),(134346,3732,'fr','Rapport de paiement',0),(134347,3732,'jp','æ”¯æ‰•ã?„ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(134348,3732,'pt','RelatÃ³rio de pagamento',0),(134349,3732,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐžÑ‚Ñ‡ÐµÑ‚',0),(134350,3732,'es','Imforme de Pagos',0),(134351,3732,'de','Zahlung-Bericht',0),(134352,3732,'en','Payment Report',0),(134353,3733,'is','',0),(134354,3733,'dr','(Ø§Ù‚Ø³Ø§Ø·) Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ (ØµÙˆØ±Øª Ø§Ø®ØªÙ„Ø§Ù Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†ÙƒÙŠ',0),(134355,3733,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§(Ø§Ù‚Ø³Ø§Ø·) Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ (ØµÙˆØ±Øª Ù…ØºØ§ÙŠØ±Øª Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†ÙƒÙŠ',0),(134356,3733,'tr','Ã–demeler alÄ±nan raporlar (banka mevduat mutabakatÄ±)',0),(134357,3733,'pl','PÅ‚atnoÅ›ci otrzymane raporty (Bank Deposit pojednania)',0),(134358,3733,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸ (Ð±Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ð¾Ð¼Ð¸Ñ€ÐµÐ½Ð¸Ðµ)',0),(134359,3733,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ø³Û’ Ù…ÙˆØµÙˆÙ„Û Ø§Ø·Ù„Ø§Ø¹Ø§Øª (Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ Ù…ÙØ§ÛÙ…Øª)',0),(134360,3733,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ (Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° ÑÑ€Ð°Ð²ÑšÐµÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸)',0),(134361,3733,'vi','BÃ¡o cÃ¡o thanh toÃ¡n Ä‘Ã£ nháº­n (CÃ¢n Ä‘á»‘i TK ngÃ¢n hÃ ng)',0),(134362,3733,'af','Betalings Ontvang Verslae (Bank Deposito Rekonsiliasie)',0),(134363,3733,'ro','PlÄƒÅ£ile primite rapoarte (reconcilierea bancarÄƒ de depozit)',0),(134364,3733,'et','Maksete saanud teateid (panga hoiuste leppimise)',0),(134365,3733,'si','PlaÄila prejeta poroÄila (banÄnega depozita)',0),(134366,3733,'ba','Pembayaran menerima laporan (Bank Deposit rekonsiliasi)',0),(134367,3733,'nl','Betalingen ontvangen verslagen (de verzoening van de storting van de Bank)',0),(134368,3733,'fi','Maksut saanut raportteja (talletus pankkitÃ¤smÃ¤ytyksen)',0),(134369,3733,'no','Betalinger mottatt rapporter (innskudd bankavstemmingen)',0),(134370,3733,'da','Betalinger modtaget rapporter (Bank depositum forsoning)',0),(134371,3733,'ko','ì§€ê¸‰ ë°›ì€ ë³´ê³ ì„œ (ì€í–‰ ì˜ˆê¸ˆ í™”í•´)',0),(134372,3733,'he','×ª×©×œ×•×ž×™× ×©×”×ª×§×‘×œ×• ×“×•×—×•×ª (×¤×™×§×“×•×Ÿ ×”×ª××ž×ª ×‘× ×§)',0),(134373,3733,'el','Î›Î¬Î²ÎµÏ„Îµ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ (Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ® ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÏ…Î¼Ï†Ï‰Î½Î¯Î±)',0),(134374,3733,'zh','ä»˜æ¬¾æ”¶åˆ°æŠ¥å‘Šï¼ˆé“¶è¡Œå­˜æ¬¾å¯¹è´¦ï¼‰\r\n',0),(134375,3733,'sv','Betalningar emot rapporter (Bank insÃ¤ttning fÃ¶rsoning)',0),(134376,3733,'it','Pagamenti ricevuto segnalazioni (Banca deposito riconciliazione)',0),(134377,3733,'tl','',0),(134378,3733,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;(Bank Deposit Reconciliation)',0),(134379,3733,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ (à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤®à¤¿à¤²à¤¾à¤¨) à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(134380,3733,'ms','Pembayaran menerima laporan (Penyata penyesuaian Bank Deposit)',0),(134381,3733,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…ØªÙ„Ù‚Ø§Ø© (Ø§Ù„Ù…ØµØ§Ù„Ø­Ø© Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©)',0),(134382,3733,'fr','Paiements reÃ§us rapports (rapprochement bancaire de dÃ©pÃ´t)',0),(134383,3733,'jp','æ”¯æ‰•ã?„å?—é ˜ãƒ¬ãƒ?ãƒ¼ãƒˆï¼ˆéŠ€è¡Œé ?é‡‘èª¿æ•´ï¼‰',0),(134384,3733,'pt','RelatÃ³rios de pagamentos recebidos (reconciliaÃ§Ã£o bancÃ¡ria de depÃ³sito)',0),(134385,3733,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ñ‹ Ð´Ð¾ÐºÐ»Ð°Ð´Ñ‹ (Ð±Ð°Ð½Ðº Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ñ€Ð¸Ð¼Ð¸Ñ€ÐµÐ½Ð¸Ñ)',0),(134386,3733,'es','Informes de Pagos Recibidos (ReconciliaciÃ³n de DepÃ³sitos Bancarios)',0),(134387,3733,'de','Zahlungen empfangen Berichte (Bank Deposit VersÃ¶hnung)',0),(134388,3733,'en','Payments Received Reports (Bank Deposit Reconciliation)',0),(134389,3734,'is','',0),(134390,3734,'dr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÙŠ Ù…ØªØ¹Ø¯Ø¯',0),(134391,3734,'pr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÙŠ Ù…ØªØ¹Ø¯Ø¯',0),(134392,3734,'tr','Birden fazla dÃ¶nem iÃ§in bordro onay Ã–zeti',0),(134393,3734,'pl','Podsumowanie kontroli pÅ‚ac dla wielu okresÃ³w',0),(134394,3734,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð ÐµÐ·ÑŽÐ¼Ðµ Ð·Ð° Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸',0),(134395,3734,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù…ÛŒÚº Ø§ÛŒÚ© Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø¹Ø±ØµÛ’ Ú©Û’ Ù„Ø¦Û’ Ú†ÛŒÚ© Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(134396,3734,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ð·Ð° Ð²Ð¸ÑˆÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(134397,3734,'vi','Tá»•ng há»£p SÃ©c Tráº£ LÆ°Æ¡ng cho nhiá»u giai Ä‘oáº¡n',0),(134398,3734,'af','Gaan Loonrolopsomming na vir Meervoudige Periodes',0),(134399,3734,'ro','Salarizare Check rezumat pentru mai multe perioade',0),(134400,3734,'et','Palga sisse KokkuvÃµte mitu aega',0),(134401,3734,'si','IzplaÄane plaÄe potrdite Povzetek za veÄ obdobij',0),(134402,3734,'ba','Penggajian Check ringkasan untuk beberapa periode',0),(134403,3734,'nl','Payroll selectievakje samenvatting voor meerdere punten',0),(134404,3734,'fi','Palkanlaskennan tarkistuksen Yhteenveto useita pisteitÃ¤',0),(134405,3734,'no','LÃ¸nn Sammendrag for flere perioder',0),(134406,3734,'da','LÃ¸n Check ResumÃ© for flere perioder',0),(134407,3734,'ko','ì—¬ëŸ¬ ê¸°ê°„ì— ëŒ€ í•œ ê¸‰ì—¬ ê²€ì‚¬ ìš”ì•½',0),(134408,3734,'he','×¡×™×›×•× ×”×¡×™×ž×•×Ÿ ×©×›×¨ ×¢×‘×•×¨ ×ª×§×•×¤×•×ª ×ž×¨×•×‘×•×ª',0),(134409,3734,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· ÎµÎ»Î­Î³Ï‡Î¿Ï… Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Î³Î¹Î± Ï€Î¿Î»Î»Î±Ï€Î»Î­Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…Ï‚',0),(134410,3734,'zh','è–ªé‡‘æ€»é¢å¤šæœŸæ£€æŸ¥æ€»ç»“\r\n',0),(134411,3734,'sv','LÃ¶nelistan kontrollera Sammanfattning fÃ¶r flera perioder',0),(134412,3734,'it','Paghe controllo Sommario per periodi multipli',0),(134413,3734,'tl','',0),(134414,3734,'th','&#3626;&#3619;&#3640;&#3611;&#3648;&#3594;&#3655;&#3588;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3627;&#3621;&#3634;&#3618;&#3594;&#3656;&#3623;&#3591;&#3',0),(134415,3734,'hi','à¤à¤•à¤¾à¤§à¤¿à¤• à¤…à¤µà¤§à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‡à¤°à¥‹à¤² à¤šà¥‡à¤• à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(134416,3734,'ms','Ringkasan semakan gaji untuk tempoh beberapa',0),(134417,3734,'ar','Ù…Ù„Ø®Øµ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ù„ÙØªØ±Ø§Øª Ù…ØªØ¹Ø¯Ø¯Ø©',0),(134418,3734,'fr','RÃ©sumÃ© de cocher paie pour des pÃ©riodes multiples',0),(134419,3734,'jp','è¤‡æ•°æœŸé–“ã?®çµ¦ä¸Žå°?åˆ‡æ‰‹ã‚µãƒžãƒªãƒ¼',0),(134420,3734,'pt','Resumo de verificaÃ§Ã£o de folha de pagamento para vÃ¡rios perÃ­odos',0),(134421,3734,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð´Ð»Ñ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¸Ñ… Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¾Ð²',0),(134422,3734,'es','ResÃºmen de Cheques de NÃ³mina para PÃ©riodos Multiples',0),(134423,3734,'de','Payroll Check Zusammenfassung fÃ¼r mehrere Perioden',0),(134424,3734,'en','Payroll Check Summary for Multiple Periods',0),(134425,3735,'is','',0),(134426,3735,'dr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø±Ø§ÙŠ ÙŠÙƒ Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(134427,3735,'pr','Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø±Ø§ÙŠ ÙŠÙƒ Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(134428,3735,'tr','Bir Ã¶deme dÃ¶nemi iÃ§in bordro onay Ã–zeti',0),(134429,3735,'pl','PÅ‚ac wyboru podsumowanie okresu rozliczeniowego jeden',0),(134430,3735,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð ÐµÐ·ÑŽÐ¼Ðµ Ð·Ð° ÐµÐ´Ð¸Ð½ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(134431,3735,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú†ÛŒÚ© Ú©Ø§ Ø®Ù„Ø§ØµÛ Ø§ÛŒÚ© Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¯Øª Ú©Û’ Ù„Ø¦Û’',0),(134432,3735,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ð·Ð° Ñ˜ÐµÐ´Ð½Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(134433,3735,'vi','Tá»•ng há»£p SÃ©c Tráº£ LÆ°Æ¡ng cho má»™t ká»³ tráº£ lÆ°Æ¡ng',0),(134434,3735,'af','Loonrol Tjekopsomming vir Een Loonperiode',0),(134435,3735,'ro','Salarizare Check Rezumat perioadÄƒ de o platÄƒ',0),(134436,3735,'et','Palga sisse KokkuvÃµte Ã¼he makseperioodi',0),(134437,3735,'si','IzplaÄane plaÄe potrdite Povzetek za eno plaÄi',0),(134438,3735,'ba','Penggajian Check ringkasan untuk membayar satu periode',0),(134439,3735,'nl','Payroll selectievakje samenvatting voor Ã©Ã©n betalen periode',0),(134440,3735,'fi','Palkanlaskennan tarkistuksen Yhteenveto yksi maksukaudelle',0),(134441,3735,'no','Sammendrag for lÃ¸nn for en lÃ¸nnsperioden',0),(134442,3735,'da','LÃ¸n Check ResumÃ© for en lÃ¸nperiode',0),(134443,3735,'ko','1 ê°œì˜ ì§€ë¶ˆ ê¸°ê°„ ë™ì•ˆ ê¸‰ì—¬ ê²€ì‚¬ ìš”ì•½',0),(134444,3735,'he','×¡×™×›×•× ×¡×™×ž×•×Ÿ ×”×©×›×¨ ×œ×ª×§×•×¤×” ×‘×ª×©×œ×•× ××—×“',0),(134445,3735,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· ÎµÎ»Î­Î³Ï‡Î¿Ï… Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Î³Î¹Î± Î­Î½Î± Î¼Î¹ÏƒÎ¸Î¿Î´Î¿Ï„Î¹ÎºÎ®Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(134446,3735,'zh','ä¸€ä¸ªæ”¯ä»˜æœŸçš„è–ªèµ„æ£€æŸ¥ç»¼è¿°\r\n',0),(134447,3735,'sv','LÃ¶nelistan kontrollera Sammanfattning fÃ¶r en betalningsperiod',0),(134448,3735,'it','Paghe controllo Sommario per uno paga periodo',0),(134449,3735,'tl','',0),(134450,3735,'th','&#3626;&#3619;&#3640;&#3611;&#3648;&#3594;&#3655;&#3588;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3592;&#3656;&#3634;&#3618;&#3605;&#3656;&#3629;&#3594;&#3',0),(134451,3735,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤šà¥‡à¤• à¤à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(134452,3735,'ms','Ringkasan semakan gaji bagi tempoh bayar satu',0),(134453,3735,'ar','Ù…Ù„Ø®Øµ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ù„ÙØªØ±Ø© Ø§Ù„Ø¯ÙØ¹ ÙˆØ§Ø­Ø¯',0),(134454,3735,'fr','RÃ©sumÃ© de cocher paie pour la pÃ©riode d\'un paie',0),(134455,3735,'jp','ä¸€ã?¤ã?®æ”¯æ‰•ã?„æœŸé–“ã?®çµ¦ä¸Žå°?åˆ‡æ‰‹ã‚µãƒžãƒªãƒ¼',0),(134456,3735,'pt','Resumo de verificaÃ§Ã£o de folha de pagamento para um pagar perÃ­odo',0),(134457,3735,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð·Ð° Ð¾Ð´Ð¸Ð½ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(134458,3735,'es','NÃ³mina Resumen de Cheques para un PerÃ­odo de Pagos',0),(134459,3735,'de','Payroll Check-Zusammenfassung fÃ¼r ein Arbeitsentgelt',0),(134460,3735,'en','Payroll Check Summary for One Pay Period',0),(134461,3736,'is','',0),(134462,3736,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙƒØ§Ù‡Ø´ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ â€“ Ø¨Ø±Ø§ÙŠ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ØªØ®ÙÙŠÙØ§Øª Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯Ù‡ Ø¨Ù‡ Ú¯Ø±ÙˆÙ‡ÙŠ Ø§Ø² ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(134463,3736,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙƒØ§Ù‡Ø´ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ â€“ Ø¨Ø±Ø§ÙŠ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ØªØ®ÙÙŠÙØ§Øª Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯Ù‡ Ø¨Ù‡ Ú¯Ø±ÙˆÙ‡ÙŠ Ø§Ø² ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(134464,3736,'tr','Bordro kesintisi gruplarÄ± - bir Ã§alÄ±ÅŸan grubu iÃ§in uygulanan kesintiler belirtmek iÃ§in',0),(134465,3736,'pl','Grupy odliczenia listy pÅ‚ac - sÅ‚uÅ¼Ä…cÄ… do potrÄ…cenia z grupÄ… pracownikÃ³w',0),(134466,3736,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð° Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ð¸ - Ð·Ð° Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÑÐ½Ðµ Ð½Ð° ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸ Ð²ÑŠÑ€Ñ…Ñƒ Ð³Ñ€ÑƒÐ¿Ð° Ð¾Ñ‚ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(134467,3736,'ur','Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©Û’ Ø§ÛŒÚ© Ú¯Ø±ÙˆÙ¾ Ú©Ùˆ Ù„Ú¯Ø§Ø¦ÛŒ Ú¯Ø¦ÛŒ Ú©Ù¹ÙˆØªÛŒ Ú©Ùˆ Ù…ØªØ¹ÛŒÙ† Ú©Ø±Ù†Û’ Ú©ÛŒÙ„Ø¦Û’ Ù¾Û’ Ø±ÙˆÙ„ ÛÙˆÙ†Û’Ùˆ Ú¯Ø±ÙˆÙ¾-',0),(134468,3736,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð³Ñ€ÑƒÐ¿Ðµ - Ð·Ð° Ð½Ð°Ð²Ð¾Ñ’ÐµÑšÐµ Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(134469,3736,'vi','NhÃ³m giáº£m trá»« lÆ°Æ¡ng - Giáº£m trá»« Ã¡p dá»¥ng cho má»™t nhÃ³m nhÃ¢n viÃªn cá»¥ thá»ƒ',0),(134470,3736,'af','Loonrol Aftrekkingsgroep - vir Gespesifiseerde Aftrekkings na \'n Groep van Werknemers',0),(134471,3736,'ro','Salarizare deduceri grupuri - pentru specificarea deduceri aplicat la un grup de angajaÅ£i',0),(134472,3736,'et','Mahaarvamise palgagruppe tÃ¤psustamiseks mahaarvamisi kohaldatakse tÃ¶Ã¶tajate grupi-',0),(134473,3736,'si','IzplaÄane plaÄe odbitek skupine - za doloÄanje odbitkov, ki se uporabljajo za skupine zaposlenih',0),(134474,3736,'ba','Kelompok-kelompok pemotongan gaji - untuk menentukan pengurangan diterapkan kepada sekelompok karyawan',0),(134475,3736,'nl','Payroll aftrek groepen - voor het opgeven van inhoudingen toegepast op een groep van werknemers',0),(134476,3736,'fi','Palkanlaskennan vÃ¤hennys ryhmÃ¤t - argumenteille vÃ¤hennykset sovellettava tyÃ¶ntekijÃ¶iden',0),(134477,3736,'no','LÃ¸nningslisten fradrag grupper - for Ã¥ angi fradrag pÃ¥ en gruppe av ansatte',0),(134478,3736,'da','LÃ¸nningslisten fradrag grupper - for at angive fradrag anvendes til en gruppe af medarbejdere',0),(134479,3736,'ko','ê¸‰ì—¬ ê³µì œ ê·¸ë£¹-ì§ì›ì˜ ê·¸ë£¹ì— ì ìš© ë˜ëŠ” ê³µì œë¥¼ ì§€ì • í•˜ê¸° ìœ„í•œ',0),(134480,3736,'he','×§×‘×•×¦×•×ª × ×™×›×•×™ ×©×›×¨ - ×œ×¦×™×•×Ÿ ×”× ×™×›×•×™×™× ×ž×•×—×œ ×¢×œ ×§×‘×•×¦×” ×©×œ ×¢×•×‘×“×™×',0),(134481,3736,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ· Î¿Î¼Î¬Î´ÎµÏ‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ - Î³Î¹Î± Ï„Î¿Î½ ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼ÏŒ ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½ Ï€Î¿Ï… ÎµÏ†Î±ÏÎ¼ÏŒÎ¶ÎµÏ„Î±Î¹ ÏƒÎµ Î¼Î¹Î± Î¿Î¼Î¬Î´Î± Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(134482,3736,'zh','å·¥èµ„æ‰£é™¤ç»„-ç‰¹å®šæ‰£é™¤åº”ç”¨äºŽä¸€ç»„é›‡å‘˜\r\n',0),(134483,3736,'sv','LÃ¶nelistan avdrag grupper - fÃ¶r att ange avdrag tillÃ¤mpas pÃ¥ en grupp av anstÃ¤llda',0),(134484,3736,'it','Gruppi di deduzione sui salari - per specificando detrazioni applicate ad un gruppo di collaboratori',0),(134485,3736,'tl','',0),(134486,3736,'th','Payroll Deduction Groups - for Specifying Deductions Applied to a Group of Employees',0),(134487,3736,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤•à¤Ÿà¥Œà¤¤à¥€ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¥€ à¤•à¤Ÿà¥Œà¤¤à¥€ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤à¤• à¤¸à¤®à¥‚à¤¹ à¤ªà¤° à¤²à¤¾à¤—à¥‚ à¤¨à¤¹à¥€à¤‚ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤-',0),(134488,3736,'ms','Kumpulan potongan gaji - bagi menentukan potongan yang digunakan kepada Kumpulan pekerja',0),(134489,3736,'ar','ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª Ø®ØµÙ… Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø§Øª-Ù„ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø·Ø¨Ù‚Ø© Ø¹Ù„Ù‰ Ù…Ø¬Ù…ÙˆØ¹Ø© Ù…Ù† Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(134490,3736,'fr','Groupes de dÃ©duction sur la paie - pour spÃ©cifier les dÃ©ductions appliquÃ©es Ã  un groupe d\'employÃ©s',0),(134491,3736,'jp','çµ¦ä¸ŽæŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—ãƒ¼å¾“æ¥­å“¡ã‚°ãƒ«ãƒ¼ãƒ—ã?«é?©ç”¨ã?•ã‚Œã‚‹ç‰¹å®šæŽ§é™¤',0),(134492,3736,'pt','Grupos de deduÃ§Ã£o de folha de pagamento - para especificar deduÃ§Ãµes aplicadas a um grupo de funcionÃ¡rios',0),(134493,3736,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð²Ñ‹Ñ‡ÐµÑ‚Ð° Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ - Ð´Ð»Ñ ÑƒÐºÐ°Ð·Ð°Ð½Ð¸Ñ Ð²Ñ‹Ñ‡ÐµÑ‚Ñ‹ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÑÑŽÑ‚ÑÑ Ðº Ð³Ñ€ÑƒÐ¿Ð¿Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð²',0),(134494,3736,'es','NÃ³minas Grupos de Deducciones - para Especificando Deducciones Aplicadas a un Grupo de Empleados',0),(134495,3736,'de','Lohn Abzug Gruppen - fÃ¼r die Angabe der AbzÃ¼ge auf eine Gruppe von Mitarbeitern angewendet',0),(134496,3736,'en','Payroll Deduction Groups - for Specifying Deductions Applied to a Group of Employees',0),(134497,3737,'is','',0),(134498,3737,'dr','Ø§Ù†ÙˆØ§Ø¹ Ø­Ù‚ÙˆÙ‚ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(134499,3737,'pr','Ø§Ù†ÙˆØ§Ø¹ Ø­Ù‚ÙˆÙ‚ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(134500,3737,'tr','Bordro Ã¶deme tipleri',0),(134501,3737,'pl','Typy pÅ‚ac wynagrodzeÅ„',0),(134502,3737,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(134503,3737,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù¾Û’ Ø§Ù‚Ø³Ø§Ù…',0),(134504,3737,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ñ‚Ð¸Ð¿Ð¾Ð²Ð° Ð¿Ð»Ð°Ñ‚Ðµ',0),(134505,3737,'vi','Loáº¡i báº£ng lÆ°Æ¡ng',0),(134506,3737,'af','Loonrol Besoldiging Tipes',0),(134507,3737,'ro','Tipuri de salarizare de salarizare',0),(134508,3737,'et','Palgaarvestuse tasutÃ¼Ã¼bid',0),(134509,3737,'si','IzplaÄane plaÄe vrste',0),(134510,3737,'ba','Jenis membayar gaji',0),(134511,3737,'nl','Salarisadministratie betalen typen',0),(134512,3737,'fi','Palkanlaskennan maksulajeja',0),(134513,3737,'no','LÃ¸nn lÃ¸nnstyper',0),(134514,3737,'da','LÃ¸nningslisten lÃ¸narter',0),(134515,3737,'ko','ê¸‰ì—¬ ì§€ë¶ˆ ìœ í˜•',0),(134516,3737,'he','×¡×•×’×™ ×©×›×¨ ×ž×©×›×•×¨×•×ª',0),(134517,3737,'el','Î¤ÏÏ€Î¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(134518,3737,'zh','è–ªé‡‘æ”¯ä»˜ç±»åž‹\r\n',0),(134519,3737,'sv','LÃ¶nelistan lÃ¶netyper',0),(134520,3737,'it','Tipi di libro paga paga',0),(134521,3737,'tl','',0),(134522,3737,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(134523,3737,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤ªà¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(134524,3737,'ms','Jenis-jenis membayar gaji',0),(134525,3737,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø¯ÙØ¹ Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(134526,3737,'fr','Types de paie paie',0),(134527,3737,'jp','çµ¦ä¸Žæ”¯æ‰•ã‚¿ã‚¤ãƒ—',0),(134528,3737,'pt','Tipos de pagamento de folha de pagamento',0),(134529,3737,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(134530,3737,'es','NÃ³mina Tipos de Pago',0),(134531,3737,'de','Abrechnung Lohnarten',0),(134532,3737,'en','Payroll Pay Types',0),(134533,3738,'is','',0),(134534,3738,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹ÙˆÙ‚',0),(134535,3738,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹ÙˆÙ‚',0),(134536,3738,'tr','Bekleyen sipariÅŸler',0),(134537,3738,'pl','Zlecenia oczekujÄ…ce',0),(134538,3738,'bg','ÐžÑ‚Ð»Ð¾Ð¶ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(134539,3738,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(134540,3738,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(134541,3738,'vi','ÄÆ¡n hÃ ng chÆ°a lÃ m',0),(134542,3738,'af','Afwagtende Bestelling',0),(134543,3738,'ro','Ordinele Ã®n aÈ™teptare',0),(134544,3738,'et','Ootel tellimused',0),(134545,3738,'si','ÄŒakajoÄa naroÄila',0),(134546,3738,'ba','Pending order',0),(134547,3738,'nl','Onverwerkte bestellingen',0),(134548,3738,'fi','Odottavat toimeksiannot',0),(134549,3738,'no','Ventende bestillinger',0),(134550,3738,'da','Afventende ordrer',0),(134551,3738,'ko','ë³´ë¥˜ ì¤‘ì¸ ì£¼ë¬¸',0),(134552,3738,'he','×”×”×•×¨××•×ª ×”×ž×ž×ª×™× ×•×ª',0),(134553,3738,'el','Î•ÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(134554,3738,'zh','å¾…å¤„ç†è®¢å•\r\n',0),(134555,3738,'sv','Avvaktande ordrar',0),(134556,3738,'it','Ordini pendenti',0),(134557,3738,'tl','',0),(134558,3738,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(134559,3738,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶',0),(134560,3738,'ms','Pesanan-pesanan bergantung',0),(134561,3738,'ar','Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(134562,3738,'fr','Commandes en attente',0),(134563,3738,'jp','ä¿?ç•™ä¸­æ³¨æ–‡',0),(134564,3738,'pt','Ordens pendentes',0),(134565,3738,'ru','ÐžÑ‚Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ðµ Ð¾Ñ€Ð´ÐµÑ€Ð°',0),(134566,3738,'es','Ordenes Pendientes',0),(134567,3738,'de','Offene Bestellungen',0),(134568,3738,'en','Pending Orders',0),(134569,3739,'is','',0),(134570,3739,'dr','Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯Ù‰',0),(134571,3739,'pr','Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯Ù‰',0),(134572,3739,'tr','Emeklilik planlarÄ±',0),(134573,3739,'pl','PlanÃ³w emerytalnych',0),(134574,3739,'bg','ÐŸÐµÐ½ÑÐ¸Ð¾Ð½Ð½Ð¸ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(134575,3739,'ur','Ù¾Ù†Ø´Ù† Ù¾Ù„Ø§Ù†',0),(134576,3739,'sr','ÐŸÐµÐ½Ð·Ð¸Ñ˜ÑÐºÐ¸ Ð¿Ð»Ð°Ð½Ð¾Ð²Ð¸',0),(134577,3739,'vi','Káº¿ hoáº¡ch hÆ°u trÃ­',0),(134578,3739,'af','Pensioenplanne',0),(134579,3739,'ro','Planurile de pensii',0),(134580,3739,'et','Pensioniskeemide',0),(134581,3739,'si','Pokojninskih naÄrtov',0),(134582,3739,'ba','Rencana pensiun',0),(134583,3739,'nl','Pensioenregelingen',0),(134584,3739,'fi','ElÃ¤kejÃ¤rjestelyt',0),(134585,3739,'no','Pensjonsordninger',0),(134586,3739,'da','Pensionsordninger',0),(134587,3739,'ko','ì—°ê¸ˆ ê³„íš',0),(134588,3739,'he','×ª×•×›× ×™×•×ª ×¤× ×¡×™×”',0),(134589,3739,'el','Î£Ï…Î½Ï„Î±Î¾Î¹Î¿Î´Î¿Ï„Î¹ÎºÎ¬ Ï€ÏÎ¿Î³ÏÎ¬Î¼Î¼Î±Ï„Î±',0),(134590,3739,'zh','å…»è€é‡‘è®¡åˆ’\r\n',0),(134591,3739,'sv','Pensionsplaner',0),(134592,3739,'it','Piani pensionistici',0),(134593,3739,'tl','',0),(134594,3739,'th','&#3649;&#3612;&#3609;&#3648;&#3591;&#3636;&#3609;&#3610;&#3635;&#3609;&#3634;&#3597;',0),(134595,3739,'hi','à¤ªà¥‡à¤‚à¤¶à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾à¤à¤‚',0),(134596,3739,'ms','Pelan pencen',0),(134597,3739,'ar','Ø®Ø·Ø· Ù…Ø¹Ø§Ø´Ø§Øª Ø§Ù„ØªÙ‚Ø§Ø¹Ø¯',0),(134598,3739,'fr','RÃ©gimes de retraite',0),(134599,3739,'jp','å¹´é‡‘è¨ˆç”»',0),(134600,3739,'pt','Planos de pensÃ£o',0),(134601,3739,'ru','ÐŸÐµÐ½ÑÐ¸Ð¾Ð½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ð½Ñ‹',0),(134602,3739,'es','Planes de PensiÃ³n',0),(134603,3739,'de','PensionsplÃ¤ne',0),(134604,3739,'en','Pension Plans',0),(134605,3740,'is','',0),(134606,3740,'dr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ ',0),(134607,3740,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ ',0),(134608,3740,'tr','Performans istatistikleri',0),(134609,3740,'pl','Statystyki wydajnoÅ›ci',0),(134610,3740,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð´Ð°Ð½Ð½Ð¸',0),(134611,3740,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±',0),(134612,3740,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð°',0),(134613,3740,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c',0),(134614,3740,'af','Prestasie Statistieke',0),(134615,3740,'ro','Statistici de performanÅ£Äƒ',0),(134616,3740,'et','JÃµudluse statistika',0),(134617,3740,'si','Statistiko uspeÅ¡nosti',0),(134618,3740,'ba','Statistik kinerja',0),(134619,3740,'nl','Prestatiestatistieken',0),(134620,3740,'fi','Tehokkuustilastoja',0),(134621,3740,'no','Resultatstatistikk',0),(134622,3740,'da','Effektivitetsstatistikker',0),(134623,3740,'ko','ì„±ëŠ¥ í†µê³„',0),(134624,3740,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×',0),(134625,3740,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½',0),(134626,3740,'zh','ä¸šç»©ç»Ÿè®¡\r\n',0),(134627,3740,'sv','Prestandastatistik',0),(134628,3740,'it','Statistiche sulle prestazioni',0),(134629,3740,'tl','',0),(134630,3740,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;',0),(134631,3740,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡',0),(134632,3740,'ms','Statistik prestasi',0),(134633,3740,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡',0),(134634,3740,'fr','Statistiques de performances',0),(134635,3740,'jp','å®Ÿç¸¾çµ±è¨ˆ',0),(134636,3740,'pt','EstatÃ­sticas de desempenho',0),(134637,3740,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(134638,3740,'es','Estadisticas de DesempeÃ±o',0),(134639,3740,'de','Performance-Statistiken',0),(134640,3740,'en','Performance Statistics',0),(134641,3741,'is','',0),(134642,3741,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ ',0),(134643,3741,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ ',0),(134644,3741,'tr','Fiziksel envanter',0),(134645,3741,'pl','Inwentaryzacja',0),(134646,3741,'bg','Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(134647,3741,'ur','Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(134648,3741,'sr','ÐŸÐ¾Ð¿Ð¸Ñ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(134649,3741,'vi','Kiá»ƒm Tra HÃ ng Kho Thá»±c táº¿',0),(134650,3741,'af','Fisiese Voorraad',0),(134651,3741,'ro','Inventar fizic',0),(134652,3741,'et','Inventuur',0),(134653,3741,'si','Popisa zaloge',0),(134654,3741,'ba','Persediaan fisik',0),(134655,3741,'nl','Inventarisatie',0),(134656,3741,'fi','Inventointi',0),(134657,3741,'no','Vareopptelling',0),(134658,3741,'da','LageropgÃ¸relse',0),(134659,3741,'ko','ì‹¤ì œ ìž¬ê³ ',0),(134660,3741,'he','×ž×œ××™ ×¤×™×–×™',0),(134661,3741,'el','Î¦Ï…ÏƒÎ¹ÎºÎ®Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(134662,3741,'zh','åº“å­˜ç›˜ç‚¹\r\n',0),(134663,3741,'sv','Inventering',0),(134664,3741,'it','Inventario fisico',0),(134665,3741,'tl','',0),(134666,3741,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(134667,3741,'hi','à¤­à¥Œà¤¤à¤¿à¤• à¤¸à¥‚à¤šà¥€',0),(134668,3741,'ms','Inventori fizikal',0),(134669,3741,'ar','Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(134670,3741,'fr','Inventaire physique',0),(134671,3741,'jp','æœŸæœ«æ£šå?¸ï½›',0),(134672,3741,'pt','InventÃ¡rio fÃ­sico',0),(134673,3741,'ru','Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ°Ñ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(134674,3741,'es','Inventario FÃ­sica',0),(134675,3741,'de','Inventur',0),(134676,3741,'en','Physical Inventory',0),(134677,3742,'is','',0),(134678,3742,'dr','Ø«Ø¨Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ ',0),(134679,3742,'pr','Ø«Ø¨Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ ',0),(134680,3742,'tr','Fiziksel envanter giriÅŸ',0),(134681,3742,'pl','Inwentaryzacja wpisu',0),(134682,3742,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð¾Ñ‚ Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(134683,3742,'ur','Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(134684,3742,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð¿Ð¾Ð¿Ð¸ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(134685,3742,'vi','Nháº­p HÃ ng HÃ³a Thá»±c Kiá»ƒm',0),(134686,3742,'af','Fisiese Voorraadinskrywing',0),(134687,3742,'ro','Inventar fizic de intrare',0),(134688,3742,'et','FÃ¼Ã¼silise lao kirje',0),(134689,3742,'si','Postavka popisa zaloge',0),(134690,3742,'ba','Persediaan fisik entri',0),(134691,3742,'nl','Fysieke voorraadpost',0),(134692,3742,'fi','Fyysisen varaston tapahtuma',0),(134693,3742,'no','Vareopptelling oppfÃ¸ring',0),(134694,3742,'da','Fysisk lager posten',0),(134695,3742,'ko','ì‹¤ì œ ìž¬ê³  í•­ëª©',0),(134696,3742,'he','×¢×¨×š ×ž×œ××™ ×¤×™×–×™',0),(134697,3742,'el','Î•Î³Î³ÏÎ±Ï†Î® Ï†Ï…ÏƒÎ¹ÎºÎ¿Ï Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(134698,3742,'zh','åº“å­˜ç›˜ç‚¹æ¡ç›®\r\n',0),(134699,3742,'sv','Fysiska lagret trÃ¤tt',0),(134700,3742,'it','Voce di inventario fisico',0),(134701,3742,'tl','',0),(134702,3742,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(134703,3742,'hi','à¤­à¥Œà¤¤à¤¿à¤• à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(134704,3742,'ms','Kemasukan Inventori fizikal',0),(134705,3742,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø¬Ø±Ø¯ Ø§Ù„ÙØ¹Ù„ÙŠ',0),(134706,3742,'fr','EntrÃ©e de l\'inventaire physique',0),(134707,3742,'jp','æœŸæœ«æ£šå?¸è¨˜å…¥',0),(134708,3742,'pt','Entrada de inventÃ¡rio fÃ­sico',0),(134709,3742,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¾Ð¹ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(134710,3742,'es','Entrad de Inventario FÃ­sica',0),(134711,3742,'de','Inventur-Eintrag',0),(134712,3742,'en','Physical Inventory Entry',0),(134713,3743,'is','',0),(134714,3743,'dr','Ù…Ø­Ù„ Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡',0),(134715,3743,'pr','Ù…Ø­Ù„ Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡',0),(134716,3743,'tr','Bitki Mekanlar',0),(134717,3743,'pl','Lokalizacje produkcji',0),(134718,3743,'bg','Ð Ð°ÑÑ‚Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¼ÐµÑÑ‚Ð°',0),(134719,3743,'ur','Ù¾Ù„Ø§Ù†Ù¹ Ú©Û’ Ù…Ù‚Ø§Ù…Ø§Øª',0),(134720,3743,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° ÐµÐ»ÐµÐºÑ‚Ñ€Ð°Ð½Ðµ',0),(134721,3743,'vi','Vá»‹ trÃ­ nhÃ  mÃ¡y',0),(134722,3743,'af','Plant liggings',0),(134723,3743,'ro','LocaÅ£ii de plante',0),(134724,3743,'et','Taimede asukohad',0),(134725,3743,'si','Obrat lokacijah',0),(134726,3743,'ba','Lokasi pabrik',0),(134727,3743,'nl','Plant locaties',0),(134728,3743,'fi','Kasvi sijainnit',0),(134729,3743,'no','Anlegget steder',0),(134730,3743,'da','Plante steder',0),(134731,3743,'ko','ê³µìž¥ ìœ„ì¹˜',0),(134732,3743,'he','×¦×ž×— ×ž×™×§×•×ž×™×',0),(134733,3743,'el','Î¦Ï…Ï„ÏŒ Î¸Î­ÏƒÎµÎ¹Ï‚',0),(134734,3743,'zh','å·¥åŽ‚ä½ç½®\r\n',0),(134735,3743,'sv','AnlÃ¤ggningen platser',0),(134736,3743,'it','Pianta posizioni',0),(134737,3743,'tl','',0),(134738,3743,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3650;&#3619;&#3591;&#3591;&#3634;&#3609;&#3629;&#3640;&#3605;&#3626;&#3634;&#3627;&#3585;&#3619;&#3619;&#3617;',0),(134739,3743,'hi','à¤¸à¤‚à¤¯à¤‚à¤¤à¥à¤° à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚',0),(134740,3743,'ms','Lokasi loji',0),(134741,3743,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ù…Ø³ØªÙˆØ¯Ø¹',0),(134742,3743,'fr','Lieux d\'usine',0),(134743,3743,'jp','å·¥å ´ã?®å ´æ‰€',0),(134744,3743,'pt','Locais de planta',0),(134745,3743,'ru','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð·Ð°Ð²Ð¾Ð´Ð°',0),(134746,3743,'es','Ubicaciones de FÃ¡bricas',0),(134747,3743,'de','Pflanze-Standorte',0),(134748,3743,'en','Plant Locations',0),(134749,3744,'is','',0),(134750,3744,'dr','Ù…Ø­Ù„ Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡  Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÙŠ Ù…ÙŠ Ø´ÙˆØ¯',0),(134751,3744,'pr','Ù…Ø­Ù„ Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡  Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÙŠ Ù…ÙŠ Ø´ÙˆØ¯',0),(134752,3744,'tr','Stok sakladÄ±ÄŸÄ± bitki Mekanlar',0),(134753,3744,'pl','Lokalizacje, gdzie trzymany jest spis roÅ›lin',0),(134754,3744,'bg','ÐœÐµÑÑ‚Ð°, ÐºÑŠÐ´ÐµÑ‚Ð¾ ÑÐµ ÑÑŠÑ…Ñ€Ð°Ð½ÑÐ²Ð° Ð¾Ð¿Ð¸Ñ Ð½Ð° Ñ€Ð°ÑÑ‚ÐµÐ½Ð¸ÑÑ‚Ð°',0),(134755,3744,'ur','Ù¾Ù„Ø§Ù†Ù¹ Ú©Û’ Ù…Ù‚Ø§Ù…Ø§Øª Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¬ÛØ§Úº Ø±Ú©Ú¾Ø§ ÛÛ’',0),(134756,3744,'sr','Ð‘Ð¸Ñ™ÐºÐ° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð³Ð´Ðµ Ñ˜Ðµ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(134757,3744,'vi','Vá»‹ TrÃ­ NhÃ  MÃ¡y NÆ¡i Giá»¯ HÃ ng',0),(134758,3744,'af','Plant plekke waar voorraad gehou word',0),(134759,3744,'ro','LocaÅ£ii Ã®n care este Å£inut inventar de plante',0),(134760,3744,'et','Taimede asukohti varude pidavasse',0),(134761,3744,'si','Lokacijah, kjer se vodi popis rastlin',0),(134762,3744,'ba','Lokasi pabrik mana persediaan disimpan',0),(134763,3744,'nl','Plant locaties waar voorraad wordt gehouden',0),(134764,3744,'fi','Kasvien paikat varaston pitÃ¤vÃ¤lle',0),(134765,3744,'no','Anlegget steder der lageret holdes',0),(134766,3744,'da','Plante steder hvor lageret opbevares',0),(134767,3744,'ko','ìž¬ê³  ìœ ì§€ ê³µìž¥ ìœ„ì¹˜',0),(134768,3744,'he','×ž×™×§×•×ž×™× ×‘×ž×¤×¢×œ ×©×‘×• × ×©×ž×¨×ª ×ž×œ××™',0),(134769,3744,'el','Î¦Ï…Ï„ÏŒ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚ ÏŒÏ€Î¿Ï… Ï†Ï…Î»Î¬ÏƒÏƒÎµÏ„Î±Î¹ Î· Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(134770,3744,'zh','å·¥åŽ‚åº“å­˜å­˜æ”¾åœ°ç‚¹\r\n',0),(134771,3744,'sv','Plantera platser dÃ¤r lagret hÃ¥lls',0),(134772,3744,'it','Pianta posizioni cui inventario Ã¨ conservato',0),(134773,3744,'tl','',0),(134774,3744,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3650;&#3619;&#3591;&#3591;&#3634;&#3609;&#3629;&#3640;&#3605;&#3626;&#3634;&#3627;&#3585;&#3619;&#3619;&#3617;&#3607;&#3637;&#3656;&#3595;&#3638;&#3656;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3',0),(134775,3744,'hi','à¤¸à¤‚à¤¯à¤‚à¤¤à¥à¤° à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤œà¤¹à¤¾à¤‚ à¤®à¤¾à¤² à¤°à¤–à¤¾ à¤¹à¥ˆ',0),(134776,3744,'ms','Lokasi kilang di mana inventori disimpan',0),(134777,3744,'ar','Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ù…ØµÙ†Ø¹ Ø­ÙŠØ« ÙŠØªÙ… Ø§Ù„Ø§Ø­ØªÙØ§Ø¸ Ø¨Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(134778,3744,'fr','Plante des endroits oÃ¹ l\'inventaire est tenu',0),(134779,3744,'jp','åœ¨åº«ã?Œä¿?ç®¡ã?•ã‚Œã?¦ã?„ã‚‹å·¥å ´æ‰€åœ¨åœ°',0),(134780,3744,'pt','Locais onde Ã© guardado o inventÃ¡rio de plantas',0),(134781,3744,'ru','Ð—Ð°Ð²Ð¾Ð´ Ð¼ÐµÑÑ‚Ð°, Ð³Ð´Ðµ Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑÑ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(134782,3744,'es','Ubicaciones de FÃ¡bricas en Donde esta Guardado el Inventario',0),(134783,3744,'de','Pflanze Locations wo Bestand gehalten wird',0),(134784,3744,'en','Plant Locations where Inventory is Kept',0),(134785,3745,'is','',0),(134786,3745,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(134787,3745,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(134788,3745,'tr','SatÄ±nalma sipariÅŸ listeleri',0),(134789,3745,'pl','List zamÃ³wienie zakupu',0),(134790,3745,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑÐ¿Ð¸ÑÑŠÑ†Ð¸',0),(134791,3745,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(134792,3745,'sr','Ð›Ð¸ÑÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(134793,3745,'vi','Danh sÃ¡ch Ä‘Æ¡n mua hÃ ng',0),(134794,3745,'af','Aankoop orde lyste',0),(134795,3745,'ro','Liste de comandÄƒ cumpÄƒrare',0),(134796,3745,'et','Ostu tellimusnimekirja',0),(134797,3745,'si','Nabavni nalog sezname',0),(134798,3745,'ba','Daftar Order Pembelian',0),(134799,3745,'nl','Aankoop Order lijsten',0),(134800,3745,'fi','Osto tilaus luettelot',0),(134801,3745,'no','Listene for behandlingsrekkefÃ¸lgen for kjÃ¸p',0),(134802,3745,'da','KÃ¸b Bestil lister',0),(134803,3745,'ko','êµ¬ë§¤ ì£¼ë¬¸ ëª©ë¡',0),(134804,3745,'he','×¨×©×™×ž×•×ª ×”×–×ž× ×ª ×¨×›×™×©×”',0),(134805,3745,'el','ÎŸÎ¹ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Ï„Î·Ï‚ ÏƒÎµÎ¹ÏÎ¬Ï‚ Î±Î³Î¿ÏÎ¬',0),(134806,3745,'zh','é‡‡è´­è®¢å•åˆ—è¡¨\r\n',0),(134807,3745,'sv','KÃ¶p ordning listor',0),(134808,3745,'it','Liste di ordine di acquisto',0),(134809,3745,'tl','',0),(134810,3745,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(134811,3745,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(134812,3745,'ms','Senarai pesanan pembelian',0),(134813,3745,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(134814,3745,'fr','Achat ordre listes',0),(134815,3745,'jp','ç™ºæ³¨ãƒªã‚¹ãƒˆ',0),(134816,3745,'pt','Listas de ordem de compra',0),(134817,3745,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð·Ð°ÐºÐ°Ð· ÑÐ¿Ð¸ÑÐºÐ¸',0),(134818,3745,'es','Listas de Ordenes de Compra',0),(134819,3745,'de','Kauf-Bestelllisten',0),(134820,3745,'en','Purchase Order Lists',0),(134821,3746,'is','',0),(134822,3746,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¯ÙØ§ØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ù‡Ù… Ø§ÙƒÙ†ÙˆÙ†',0),(134823,3746,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¯ÙØ§ØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ù‡Ù… Ø§ÙƒÙ†ÙˆÙ†',0),(134824,3746,'tr','Åžimdi gÃ¼nl.',0),(134825,3746,'pl','Teraz zaksiÄ™gowaÄ‡ dzienniki',0),(134826,3746,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð½ÐµÐ²Ð½Ð¸Ñ†Ð¸ ÑÐµÐ³Ð°',0),(134827,3746,'ur','Ø§Ø¨ Ù¾ÙˆØ³Ù¹ Ú©Û’ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û’',0),(134828,3746,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶Ð¸ Ð½Ð°Ð»Ð¾Ð³Ðµ ÑÐ°Ð´Ð°',0),(134829,3746,'vi','Káº¿t chuyá»ƒn dá»‹nh ká»³ bÃ¢y giá»',0),(134830,3746,'af','Pos Joernale Nou',0),(134831,3746,'ro','ÃŽnregistrare jurnale acum',0),(134832,3746,'et','NÃ¼Ã¼d saate sisestada tÃ¶Ã¶lehed',0),(134833,3746,'si','Zdaj knjiÅ¾iti temeljnice',0),(134834,3746,'ba','Jurnal posting sekarang',0),(134835,3746,'nl','Dagboeken boeken nu',0),(134836,3746,'fi','Kirjaa kirjauskansiot',0),(134837,3746,'no','Postere journaler nÃ¥',0),(134838,3746,'da','BogfÃ¸re kladder nu',0),(134839,3746,'ko','ì§€ê¸ˆ í¬ìŠ¤íŠ¸ ì €ë„',0),(134840,3746,'he','×œ×¨×©×•× ×™×•×ž× ×™ ×¢×›×©×™×•',0),(134841,3746,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÏ„Îµ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Ï„ÏŽÏÎ±',0),(134842,3746,'zh','çŽ°åœ¨å‘å¸ƒæ—¥å¿—\r\n',0),(134843,3746,'sv','BokfÃ¶ra journaler nu',0),(134844,3746,'it','Pubblicare riviste ora',0),(134845,3746,'tl','',0),(134846,3746,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3617;&#3640;&#3604;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;&#3648;&#3604;&#3637;&#3658;&#3618;&#3623;&#3609;&#3637;&#3657;',0),(134847,3746,'hi','à¤…à¤¬ à¤ªà¤¤à¥à¤°à¤¿à¤•à¤¾à¤“à¤‚ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(134848,3746,'ms','Jurnal jawatan sekarang',0),(134849,3746,'ar','ØªØ±Ø­ÙŠÙ„ Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ© Ø§Ù„Ø¢Ù†',0),(134850,3746,'fr','Validez les feuilles maintenant',0),(134851,3746,'jp','ä»•è¨³å¸³ã?«è¨˜å¸³',0),(134852,3746,'pt','Revistas de post agora',0),(134853,3746,'ru','Ð¢ÐµÐ¿ÐµÑ€ÑŒ Ñ€Ð°Ð·Ð¼ÐµÑÑ‚Ð¸Ñ‚ÑŒ Ð¶ÑƒÑ€Ð½Ð°Ð»Ñ‹',0),(134854,3746,'es','Asentar Diarios Ahora',0),(134855,3746,'de','Post Zeitschriften jetzt',0),(134856,3746,'en','Post Journals Now',0),(134857,3747,'is','',0),(134858,3747,'dr','Ø³Ø·ÙˆØ­ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(134859,3747,'pr','Ø³Ø·ÙˆØ­ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(134860,3747,'tr','Fiyat dÃ¼zeyleri',0),(134861,3747,'pl','Poziomy cen',0),(134862,3747,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð¸Ñ‚Ðµ Ð½Ð¸Ð²Ð°',0),(134863,3747,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­',0),(134864,3747,'sr','ÐÐ¸Ð²Ð¾Ð° Ñ†ÐµÐ½Ð°',0),(134865,3747,'vi','Má»©c giÃ¡',0),(134866,3747,'af','Prysvlakke',0),(134867,3747,'ro','Nivelurile de preÅ£',0),(134868,3747,'et','Hinnatase',0),(134869,3747,'si','Ravni cen',0),(134870,3747,'ba','Tingkat harga',0),(134871,3747,'nl','Prijsniveaus',0),(134872,3747,'fi','Hintataso',0),(134873,3747,'no','PrisnivÃ¥',0),(134874,3747,'da','Prisniveau',0),(134875,3747,'ko','ê°€ê²© ìˆ˜ì¤€',0),(134876,3747,'he','×¨×ž×•×ª ×ž×—×™×¨×™×',0),(134877,3747,'el','Î•Ï€Î¯Ï€ÎµÎ´Î± Ï„Î¹Î¼ÏŽÎ½',0),(134878,3747,'zh','ä»·æ ¼æ°´å¹³\r\n',0),(134879,3747,'sv','PrisnivÃ¥er',0),(134880,3747,'it','Livelli di prezzo',0),(134881,3747,'tl','',0),(134882,3747,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(134883,3747,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°',0),(134884,3747,'ms','Paras harga',0),(134885,3747,'ar','Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(134886,3747,'fr','Niveaux de prix',0),(134887,3747,'jp','å€¤æ®µãƒ¬ãƒ™ãƒ«',0),(134888,3747,'pt','NÃ­veis de preÃ§os',0),(134889,3747,'ru','Ð£Ñ€Ð¾Ð²Ð½Ð¸ Ñ†ÐµÐ½',0),(134890,3747,'es','Niveles de Precios',0),(134891,3747,'de','Das Preisniveau',0),(134892,3747,'en','Price Levels',0),(134893,3748,'is','',0),(134894,3748,'dr','941',0),(134895,3748,'pr','Ú†Ø§Ù¾941',0),(134896,3748,'tr','941 YazdÄ±r',0),(134897,3748,'pl','Drukuj 941',0),(134898,3748,'bg','ÐŸÐµÑ‡Ð°Ñ‚ 941',0),(134899,3748,'ur','941 Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(134900,3748,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ 941',0),(134901,3748,'vi','In 941',0),(134902,3748,'af','Druk 941',0),(134903,3748,'ro','Imprimare 941',0),(134904,3748,'et','Prindi 941',0),(134905,3748,'si','Natisni 941',0),(134906,3748,'ba','Cetak 941',0),(134907,3748,'nl','941 afdrukken',0),(134908,3748,'fi','Tulosta 941',0),(134909,3748,'no','Skrive ut 941',0),(134910,3748,'da','Udskrive 941',0),(134911,3748,'ko','ì¸ì‡„ 941',0),(134912,3748,'he','×”×“×¤×¡×” 941',0),(134913,3748,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· 941',0),(134914,3748,'zh','æ‰“å°941\r\n',0),(134915,3748,'sv','Skriva ut 941',0),(134916,3748,'it','Stampa 941',0),(134917,3748,'tl','',0),(134918,3748,'th','&#3614;&#3636;&#3617;&#3614;&#3660; 941',0),(134919,3748,'hi','941 à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(134920,3748,'ms','Cetak 941',0),(134921,3748,'ar','Ø·Ø¨Ø§Ø¹Ø© 941',0),(134922,3748,'fr','Imprimer 941',0),(134923,3748,'jp','ï¼™ï¼”ï¼‘ã‚’å?°åˆ·',0),(134924,3748,'pt','Imprimir 941',0),(134925,3748,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ 941',0),(134926,3748,'es','Imprimir 941',0),(134927,3748,'de','Drucken von 941',0),(134928,3748,'en','Print 941',0),(134929,3749,'is','',0),(134930,3749,'dr','941',0),(134931,3749,'pr','Ú†Ø§Ù¾ Ø§Ø·Ù„Ø§Ø¹Ø§Øª   941',0),(134932,3749,'tr','941 bilgilerini yazdÄ±r',0),(134933,3749,'pl','Drukowanie informacji o 941',0),(134934,3749,'bg','ÐŸÐµÑ‡Ð°Ñ‚ 941 Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(134935,3749,'ur','941 Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(134936,3749,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ 941 Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(134937,3749,'vi','ThÃ´ng tin In 941',0),(134938,3749,'af','Druk 941 Inligting',0),(134939,3749,'ro','Imprimare 941 informaÅ£ii',0),(134940,3749,'et','Prindi 941 teave',0),(134941,3749,'si','Natisni 941 informacije',0),(134942,3749,'ba','Mencetak informasi 941',0),(134943,3749,'nl','941 informatie afdrukken',0),(134944,3749,'fi','Tulostaa 941',0),(134945,3749,'no','Skriv ut 941 informasjon',0),(134946,3749,'da','Udskriv 941 oplysninger',0),(134947,3749,'ko','941 ì •ë³´ ì¸ì‡„',0),(134948,3749,'he','×ž×™×“×¢ ×”×“×¤×¡×” 941',0),(134949,3749,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· 941 Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(134950,3749,'zh','941ä¿¡æ¯æ‰“å°\r\n',0),(134951,3749,'sv','Skriva ut 941 Information',0),(134952,3749,'it','Informazioni stampa 941',0),(134953,3749,'tl','',0),(134954,3749,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621; 941',0),(134955,3749,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ 941 à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(134956,3749,'ms','Cetak maklumat 941',0),(134957,3749,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª 941',0),(134958,3749,'fr','Imprimer les informations 941',0),(134959,3749,'jp','941æƒ…å ±ã?®å?°åˆ·',0),(134960,3749,'pt','Imprimir informaÃ§Ãµes de 941',0),(134961,3749,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÐŸÐµÑ‡Ð°Ñ‚Ð¸ 941',0),(134962,3749,'es','Imprimir InformaciÃ³n de 941',0),(134963,3749,'de','941 Informationen drucken',0),(134964,3749,'en','Print 941 Information',0),(134965,3750,'is','',0),(134966,3750,'dr','Ú†Ø§Ù¾  ÙŠÙƒ ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÙŠØ§Ù†',0),(134967,3750,'pr','Ú†Ø§Ù¾  ÙŠÙƒ ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÙŠØ§Ù†',0),(134968,3750,'tr','Kar & zarar raporu yazdÄ±r',0),(134969,3750,'pl','Drukowanie zysku & strat',0),(134970,3750,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° & Ð·Ð°Ð³ÑƒÐ±Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(134971,3750,'ur','Ø§ÛŒÚ© Ù…Ù†Ø§ÙØ¹ Ø¨Ø®Ø´ & Ù†Ù‚ØµØ§Ù† Ø¨ÛŒØ§Ù† Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(134972,3750,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚ Ð¸ Ð³ÑƒÐ±Ð¸Ñ‚Ð°Ðº Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(134973,3750,'vi','In 1 bÃ¡o cÃ¡o lá»i lá»— ',0),(134974,3750,'af','Druk \'n Wins-en-Verlies Staat',0),(134975,3750,'ro','Imprima un Profit & declaraÅ£ie de pierdere',0),(134976,3750,'et','Prindi kasumi & kahjumivÃ¤ljavÃµte',0),(134977,3750,'si','Tiskanje dobiÄek & uspeha',0),(134978,3750,'ba','Mencetak keuntungan & rugi',0),(134979,3750,'nl','Afdrukken van een winst & verliesrekening',0),(134980,3750,'fi','Tulostaa voittoa & tappio ilmoitus',0),(134981,3750,'no','Skrive ut en profitt & tap uttalelse',0),(134982,3750,'da','Udskrive en Profit & tab erklÃ¦ring',0),(134983,3750,'ko','ì´ìµ & ê³„ì‚° ì„œ ì¸ì‡„',0),(134984,3750,'he','×”×“×¤×¡ ×©×œ ×¨×•×•×— & ×•×”×¤×¡×“',0),(134985,3750,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î­Î½Î± ÎºÎ­ÏÎ´Î¿Ï‚ & ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î±Ï€Î¿Ï„ÎµÎ»ÎµÏƒÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎµÏ‰Ï‚',0),(134986,3750,'zh','æ‰“å°æŸç›Šè¡¨\r\n',0),(134987,3750,'sv','Skriva ut en vinst & resultatrÃ¤kning',0),(134988,3750,'it','Stampare un profitto & economico',0),(134989,3750,'tl','',0),(134990,3750,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3591;&#3610;&#3585;&#3635;&#3652;&#3619;&#3586;&#3634;&#3604;&#3607;&#3640;&#3609;',0),(134991,3750,'hi','à¤à¤• à¤²à¤¾à¤­ & à¤¹à¤¾à¤¨à¤¿ à¤•à¤¥à¤¨ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(134992,3750,'ms','Cetak keuntungan & kenyataan kehilangan',0),(134993,3750,'ar','Ø·Ø¨Ø§Ø¹Ø© ÙƒØ´Ù Ø§Ù„Ø£Ø±Ø¨Ø§Ø­ ÙˆØ§Ù„Ø®Ø³Ø§Ø¦Ø±',0),(134994,3750,'fr','Imprimer un Profit & la dÃ©claration de perte',0),(134995,3750,'jp','æ??ç›Šè¨ˆç®—æ›¸ã?®å?°åˆ·',0),(134996,3750,'pt','Imprimir um lucro & declaraÃ§Ã£o de perda',0),(134997,3750,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸ & ÑƒÐ±Ñ‹Ñ‚ÐºÐ°Ñ…',0),(134998,3750,'es','Imprimir un Estado de Resultados',0),(134999,3750,'de','Drucken Sie einen Gewinn & Verlustrechnung',0),(135000,3750,'en','Print a Profit & Loss Statement',0),(135001,3751,'is','',0),(135002,3751,'dr','Ú†Ø§Ù¾ Ø¬ÙˆØ§Ø¨ Ù‡Ø§ÙŠ Ù¾ÙŠØ´ ÙØ±Ø¶',0),(135003,3751,'pr','Ú†Ø§Ù¾ Ø¬ÙˆØ§Ø¨ Ù‡Ø§ÙŠ Ù¾ÙŠØ´ ÙØ±Ø¶',0),(135004,3751,'tr','VarsayÄ±lan yanÄ±t',0),(135005,3751,'pl','DomyÅ›lnie odpowiedzi',0),(135006,3751,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ',0),(135007,3751,'ur','Ø·Û’ Ø´Ø¯Û Ø¬ÙˆØ§Ø¨ÛŒ Ø¹Ù…Ù„',0),(135008,3751,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€Ðµ',0),(135009,3751,'vi','Tráº£ lá»i máº·c Ä‘á»‹nh',0),(135010,3751,'af','Verstek reaksies',0),(135011,3751,'ro','RÄƒspuns implicit la',0),(135012,3751,'et','Vaikimisi vastuseid',0),(135013,3751,'si','Privzeti odgovor',0),(135014,3751,'ba','Default Responses',0),(135015,3751,'nl','Standaard reacties',0),(135016,3751,'fi','Oletusarvoinen vastaus',0),(135017,3751,'no','Standard svar',0),(135018,3751,'da','Standard svar',0),(135019,3751,'ko','ê¸°ë³¸ ì‘ë‹µ',0),(135020,3751,'he','×ª×’×•×‘×•×ª ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(135021,3751,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Î±Ï€Î±Î½Ï„Î®ÏƒÎµÎ¹Ï‚',0),(135022,3751,'zh','é»˜è®¤å“åº”\r\n',0),(135023,3751,'sv','Standard svar',0),(135024,3751,'it','Risposte predefinite',0),(135025,3751,'tl','',0),(135026,3751,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;',0),(135027,3751,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿à¤•à¥à¤°à¤¿à¤¯à¤¾à¤¯à¥‡à¤‚',0),(135028,3751,'ms','Maklum balas lalai',0),(135029,3751,'ar','Ø§Ù„Ø§Ø³ØªØ¬Ø§Ø¨Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(135030,3751,'fr','RÃ©ponses par dÃ©faut',0),(135031,3751,'jp','æ—¢å®šå›žç­”',0),(135032,3751,'pt','Respostas de padrÃ£o',0),(135033,3751,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¾Ñ‚Ð²ÐµÑ‚Ñ‹',0),(135034,3751,'es','Respuestas por Defecto',0),(135035,3751,'de','Standardreaktionen',0),(135036,3751,'en','Default Responses',0),(135037,3752,'is','',0),(135038,3752,'dr','Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(135039,3752,'pr','Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(135040,3752,'tr','Aile hesaplamalarÄ±',0),(135041,3752,'pl','Rodzina obliczeÅ„',0),(135042,3752,'bg','Ð¡ÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(135043,3752,'ur','Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Û’ Ø­Ø³Ø§Ø¨',0),(135044,3752,'sr','ÐŸÐ¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ°',0),(135045,3752,'vi','TÃ­nh toÃ¡n Gia ÄÃ¬nh ',0),(135046,3752,'af','Familie berekeninge',0),(135047,3752,'ro','Calculele de familie',0),(135048,3752,'et','Pere arvutused',0),(135049,3752,'si','DruÅ¾inski izraÄuni',0),(135050,3752,'ba','Perhitungan keluarga',0),(135051,3752,'nl','Familie berekeningen',0),(135052,3752,'fi','Perheen laskelmat',0),(135053,3752,'no','Familie beregninger',0),(135054,3752,'da','Familie beregninger',0),(135055,3752,'ko','ê°€ì¡± ê³„ì‚°',0),(135056,3752,'he','×—×™×©×•×‘×™× ×ž×©×¤×—×ª×™×™×',0),(135057,3752,'el','ÎŸÎ¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ® Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(135058,3752,'zh','ç³»åˆ—è®¡ç®—\r\n',0),(135059,3752,'sv','Familjen berÃ¤kningar',0),(135060,3752,'it','Famiglia calcoli',0),(135061,3752,'tl','',0),(135062,3752,'th','&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3633;&#3623;',0),(135063,3752,'hi','à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(135064,3752,'ms','Pengiraan keluarga',0),(135065,3752,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³Ø±Ø©',0),(135066,3752,'fr','Calculs de la familles',0),(135067,3752,'jp','ç³»çµ±è¨ˆç®—',0),(135068,3752,'pt','CÃ¡lculos de famÃ­lia',0),(135069,3752,'ru','Ð¡ÐµÐ¼ÐµÐ¹Ð½Ñ‹Ðµ Ñ€Ð°ÑÑ‡ÐµÑ‚Ñ‹',0),(135070,3752,'es','Calculaciones Familiares',0),(135071,3752,'de','Familie Berechnungen',0),(135072,3752,'en','Family Calculations',0),(135073,3753,'is','',0),(135074,3753,'dr','ÙØ±Ù…ÙˆÙ„Ù‡Ø§',0),(135075,3753,'pr','ÙØ±Ù…ÙˆÙ„Ù‡Ø§',0),(135076,3753,'tr','FormÃ¼ller',0),(135077,3753,'pl','FormuÅ‚y',0),(135078,3753,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð¸',0),(135079,3753,'ur','ÙØ§Ø±Ù…ÙˆÙ„Û’',0),(135080,3753,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ðµ',0),(135081,3753,'vi','CÃ´ng thá»©c',0),(135082,3753,'af','Formules',0),(135083,3753,'ro','Formule',0),(135084,3753,'et','Valemid',0),(135085,3753,'si','Formule',0),(135086,3753,'ba','Rumus',0),(135087,3753,'nl','Formules',0),(135088,3753,'fi','Kaavat',0),(135089,3753,'no','Formler',0),(135090,3753,'da','Formler',0),(135091,3753,'ko','ìˆ˜ì‹',0),(135092,3753,'he','× ×•×¡×—××•×ª',0),(135093,3753,'el','Î¤ÏÏ€Î¿Î¹',0),(135094,3753,'zh','å…¬å¼\r\n',0),(135095,3753,'sv','Formler',0),(135096,3753,'it','Formule',0),(135097,3753,'tl','',0),(135098,3753,'th','&#3626;&#3641;&#3605;&#3619;',0),(135099,3753,'hi','à¤¸à¥‚à¤¤à¥à¤°',0),(135100,3753,'ms','Formula',0),(135101,3753,'ar','Ø§Ù„ØµÙŠØº',0),(135102,3753,'fr','Formules',0),(135103,3753,'jp','å¼?',0),(135104,3753,'pt','FÃ³rmulas',0),(135105,3753,'ru','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ñ‹',0),(135106,3753,'es','Formulas',0),(135107,3753,'de','Formeln',0),(135108,3753,'en','Formulas',0),(135109,3754,'is','',0),(135110,3754,'dr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(135111,3754,'pr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(135112,3754,'tr','Genel muhasebe bÃ¼tÃ§e listesini yazdÄ±r',0),(135113,3754,'pl','Drukowanie listy ogÃ³lnego budÅ¼etu ksiÄ™gi',0),(135114,3754,'bg','ÐŸÐµÑ‡Ð°Ñ‚ ÐºÐ½Ð¸Ð³Ð° Ð·Ð° Ð¾Ð±Ñ‰Ð¸Ñ ÑÐ¿Ð¸ÑÑŠÐº',0),(135115,3754,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø¨Ø¬Ù¹ ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(135116,3754,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ Ð±ÑƒÑŸÐµÑ‚Ð°',0),(135117,3754,'vi','In NgÃ¢n SÃ¡ch Sá»• CÃ¡i Tá»•ng Há»£p ',0),(135118,3754,'af','Druk Algemene Grootboek Begrotingslys',0),(135119,3754,'ro','ListÄƒ de buget de registru General de imprimare',0),(135120,3754,'et','Saate printida Ãœldised pearaamatu eelarvesse',0),(135121,3754,'si','Tiskanje seznama postavk sploÅ¡nega proraÄuna',0),(135122,3754,'ba','Mencetak daftar General Ledger anggaran',0),(135123,3754,'nl','Algemene grootboek begroting lijst afdrukken',0),(135124,3754,'fi','Yleinen kirjanpitobudjettiin voit tulostaa',0),(135125,3754,'no','Skrive ut generelle Finansbudsjett',0),(135126,3754,'da','Udskrive almindelige finansbudgettet liste',0),(135127,3754,'ko','ì¼ë°˜ ë ˆì € ì˜ˆì‚° ëª©ë¡ ì¸ì‡„',0),(135128,3754,'he','×”×“×¤×¡ ×¨×©×™×ž×ª ×›×œ×œ×™ ×‘×¡×¤×¨ ×”×ª×§×¦×™×‘',0),(135129,3754,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚ Î³ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(135130,3754,'zh','æ‰“å°æ€»å¸é¢„ç®—åˆ—è¡¨\r\n',0),(135131,3754,'sv','Skriva ut allmÃ¤nna redovisningsbudget lista',0),(135132,3754,'it','Stampa elenco generale Budget contabile',0),(135133,3754,'tl','',0),(135134,3754,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(135135,3754,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤¬à¤œà¤Ÿ à¤¸à¥‚à¤šà¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(135136,3754,'ms','Mencetak senarai bajet Lejar Am',0),(135137,3754,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(135138,3754,'fr','Imprimer la liste de Budget comptable gÃ©nÃ©ral',0),(135139,3754,'jp','ç·?å‹˜å®šå…ƒå¸³äºˆç®—ãƒªã‚¹ãƒˆã?®å?°åˆ·',0),(135140,3754,'pt','Imprimir lista de General Ledger orÃ§amento',0),(135141,3754,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¡Ð¿Ð¸ÑÐºÐ° Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð° Ð“Ð»Ð°Ð²Ð½Ð¾Ð¹ ÐšÐ½Ð¸Ð³Ð¸',0),(135142,3754,'es','Imprimir Lista Presupuestal del Libro Mayor',0),(135143,3754,'de','General Ledger Budget Liste drucken',0),(135144,3754,'en','Print General Ledger Budget List',0),(135145,3755,'is','',0),(135146,3755,'dr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(135147,3755,'pr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(135148,3755,'tr','Genel muhasebe hesap hesaplarÄ±n listesini yazdÄ±r',0),(135149,3755,'pl','WydrukowaÄ‡ ogÃ³lne ksiÄ™gi wykres z listy kont',0),(135150,3755,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¾Ð±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ ÑÐ¼ÐµÑ‚ÐºÐ¾Ð¿Ð»Ð°Ð½ ÑÐ¼ÐµÑ‚ÐºÐ¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(135151,3755,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ ÙÛØ±Ø³Øª Ú©Û’ Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ú†Ø§Ø±Ù¹ Ù†ÛÛŒÚº Ú†Ú¾Ø§Ù¾',0),(135152,3755,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐºÑšÐ¸Ð³Ðµ ÐºÐ¾Ð½Ñ‚Ð½Ð¸ Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð»Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(135153,3755,'vi','In Biá»ƒu Äá»“ Sá»• CÃ¡i Tá»•ng Há»£p',0),(135154,3755,'af','Druk Algemene Grootboek Tabel van Rekeninge Lys',0),(135155,3755,'ro','Imprima General Ledger diagramÄƒ din lista de conturi',0),(135156,3755,'et','TrÃ¼ki pearaamatust kontoplaan',0),(135157,3755,'si','Tiskanje General Ledger kontni seznam raÄunov',0),(135158,3755,'ba','Mencetak General Ledger Chart daftar account',0),(135159,3755,'nl','General Ledger grafiek van lijst met Accounts afdrukken',0),(135160,3755,'fi','Tulosta yleiset kirjanpidon tilikartan tilit-luettelosta',0),(135161,3755,'no','Skrive ut General Ledger diagram i kontolisten',0),(135162,3755,'da','Udskrive General Ledger diagram af firmaliste',0),(135163,3755,'ko','ì¼ë°˜ ë ˆì € ì°¨íŠ¸ ê³„ì • ëª©ë¡ ì¸ì‡„',0),(135164,3755,'he','×”×“×¤×¡ ×’× ×¨×œ ×‘×¡×¤×¨ ×¨×©×™×ž×” ×©×œ ××™× ×“×§×¡×™ ×—×©×‘×•× ×•×ª',0),(135165,3755,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï„Î¿ Î³ÎµÎ½Î¹ÎºÏŒ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ‡Î­Î´Î¹Î¿ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î±Ï€ÏŒ Ï„Î· Î»Î¯ÏƒÏ„Î± \"Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯\"',0),(135166,3755,'zh','æ‰“å°å¸æˆ·åˆ—è¡¨æ€»å¸å›¾ç¤º\r\n',0),(135167,3755,'sv','Skriva ut General Ledger diagram av kontolistan',0),(135168,3755,'it','Stampare il grafico di contabilitÃ  generale della lista conti',0),(135169,3755,'tl','',0),(135170,3755,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3649;&#3612;&#3609;&#3612;&#3633;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3586;&#3629;&#3591;&#3619;&#3634;&#3',0),(135171,3755,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¥‹à¤‚ à¤¸à¥‚à¤šà¥€ à¤•à¤¾ à¤šà¤¾à¤°à¥à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(135172,3755,'ms','Cetak Carta Lejar Am senarai akaun',0),(135173,3755,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚Ø§Ø¦Ù…Ø© Ø¯Ù„ÙŠÙ„ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(135174,3755,'fr','General Ledger graphique de la liste des comptes Ã  imprimer',0),(135175,3755,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒªã‚¹ãƒˆã?®ï¼§ï¼¬ãƒ?ãƒ£ãƒ¼ãƒˆã?®å?°åˆ·',0),(135176,3755,'pt','Imprimir General Ledger grÃ¡fico da lista de contas',0),(135177,3755,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð“Ðš Ð¿ÐµÑ€ÐµÑ‡Ð½Ñ Ð¿Ð»Ð°Ð½Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(135178,3755,'es','Imprimir Lista de CÃ¡talogo de Cuentas del Libro Mayor',0),(135179,3755,'de','General Ledger Diagramm der Account-Liste drucken',0),(135180,3755,'en','Print General Ledger Chart of Accounts List',0),(135181,3756,'is','',0),(135182,3756,'dr','Ú†Ø§Ù¾ Ø¢Ø®Ø±ÙŠÙ† Ø¯Ù„Ø§ÙŠÙ„ ØªØ­ÙˆÙŠÙ„ ',0),(135183,3756,'pr','Ú†Ø§Ù¾ Ø¢Ø®Ø±ÙŠÙ† Ø¯Ù„Ø§ÙŠÙ„ ØªØ­ÙˆÙŠÙ„ ',0),(135184,3756,'tr','GeÃ§ nedenleri',0),(135185,3756,'pl','Koniec powodÃ³w',0),(135186,3756,'bg','ÐšÑŠÑÐ½Ð¾ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð¸',0),(135187,3756,'ur','ØªØ§Ø®ÛŒØ± Ú©ÛŒ ÙˆØ¬ÙˆÛØ§Øª',0),(135188,3756,'sr','ÐŸÐ¾ÐºÐ¾Ñ˜Ð½Ð¸ Ñ€Ð°Ð·Ð»Ð¾Ð³Ðµ',0),(135189,3756,'vi','NguyÃªn nhÃ¢n trá»…',0),(135190,3756,'af','Laat redes',0),(135191,3756,'ro','Motive de Ã®ntÃ¢rziere',0),(135192,3756,'et','Hilinenud pÃµhjustel',0),(135193,3756,'si','Pozno razlogov',0),(135194,3756,'ba','Alasan akhir',0),(135195,3756,'nl','Laat redenen',0),(135196,3756,'fi','MyÃ¶hÃ¤ssÃ¤ syitÃ¤',0),(135197,3756,'no','Sen grunner',0),(135198,3756,'da','Sen grunde',0),(135199,3756,'ko','ëŠ¦ì€ ì´ìœ ',0),(135200,3756,'he','×¡×™×‘×•×ª ×ž××•×—×¨',0),(135201,3756,'el','Î¤Î­Î»Î· Î»ÏŒÎ³Î¿Ï…Ï‚',0),(135202,3756,'zh','é€¾æœŸåŽŸå› \r\n',0),(135203,3756,'sv','Sen skÃ¤l',0),(135204,3756,'it','Motivi tardi',0),(135205,3756,'tl','',0),(135206,3756,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(135207,3756,'hi','à¤•à¤¾à¤°à¤£à¥‹à¤‚ à¤¸à¥‡ à¤¦à¥‡à¤° à¤¹à¥‹ à¤—à¤ˆ',0),(135208,3756,'ms','Sebab-sebab yang lewat',0),(135209,3756,'ar','Ø£Ø³Ø¨Ø§Ø¨ Ø§Ù„ØªØ£Ø®Ø±',0),(135210,3756,'fr','Raisons de la fin',0),(135211,3756,'jp','é?…å»¶ç?†ç”±',0),(135212,3756,'pt','RazÃµes finais',0),(135213,3756,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ñ‹ Ð—Ð°Ð´ÐµÑ€Ð¶ÐºÐ¸',0),(135214,3756,'es','Razones por Tardar',0),(135215,3756,'de','SpÃ¤ten GrÃ¼nde',0),(135216,3756,'en','Late Reasons',0),(135217,3757,'is','',0),(135218,3757,'dr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(135219,3757,'pr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(135220,3757,'tr','SatÄ±nalma sipariÅŸlerinin listesini yazdÄ±rÄ±n',0),(135221,3757,'pl','Drukowanie listy zamÃ³wieÅ„ zakupu',0),(135222,3757,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(135223,3757,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(135224,3757,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð»Ð°Ð·Ð½Ð¸Ñ… Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°',0),(135225,3757,'vi','In danh sÃ¡ch Ä‘Æ¡n mua hÃ ng',0),(135226,3757,'af','Druk Lyste van Aankoopbestellings',0),(135227,3757,'ro','Imprima liste de comenzi de cumpÄƒrare',0),(135228,3757,'et','Ostutellimuste nimekirjade printimiseks',0),(135229,3757,'si','Natisnete sezname nabavnih nalogov',0),(135230,3757,'ba','Mencetak daftar pesanan pembelian',0),(135231,3757,'nl','Afdrukken van lijsten van inkooporders',0),(135232,3757,'fi','Tulostaa luettelon ostotilauksista',0),(135233,3757,'no','Skrive ut lister over bestillinger',0),(135234,3757,'da','Udskrive lister over kÃ¸bsordrer',0),(135235,3757,'ko','êµ¬ë§¤ ì£¼ë¬¸ ëª©ë¡ ì¸ì‡„',0),(135236,3757,'he','×”×“×¤×¡ ×¨×©×™×ž×•×ª ×©×œ ×”×–×ž× ×•×ª ×¨×›×©',0),(135237,3757,'el','ÎšÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï…Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Î±Î³Î¿ÏÏŽÎ½',0),(135238,3757,'zh','æ‰“å°é‡‡è´­è®¢å•æ¸…å•\r\n',0),(135239,3757,'sv','Skriva ut listor Ã¶ver inkÃ¶psorder',0),(135240,3757,'it','Stampare gli elenchi degli ordini di acquisto',0),(135241,3757,'tl','',0),(135242,3757,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(135243,3757,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(135244,3757,'ms','Mencetak senarai pesanan pembelian',0),(135245,3757,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚ÙˆØ§Ø¦Ù… Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(135246,3757,'fr','Listes d\'impression des bons de commande',0),(135247,3757,'jp','ç™ºæ³¨æ›¸ãƒªã‚¹ãƒˆã‚’å?°åˆ·',0),(135248,3757,'pt','Imprimir listas de pedidos de compra',0),(135249,3757,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐºÐ¾Ð² Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(135250,3757,'es','Imprimir Listas de Ordenes de Compra',0),(135251,3757,'de','Drucklisten von Bestellungen',0),(135252,3757,'en','Print Lists of Purchase Orders',0),(135253,3758,'is','',0),(135254,3758,'dr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ù‡Ø§ ÙŠØ§ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ',0),(135255,3758,'pr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ù‡Ø§ ÙŠØ§ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ',0),(135256,3758,'tr','Listeleri veya satÄ±cÄ±larÄ±n etiketleri yazdÄ±rma',0),(135257,3758,'pl','Drukowanie listy lub etykiety dostawcÃ³w',0),(135258,3758,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ Ð¸Ð»Ð¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(135259,3758,'ur','ÙÛØ±Ø³Øª ÛŒØ§ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©Ø§ Ù„ÛŒØ¨Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(135260,3758,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð¸Ð»Ð¸ Ð¾Ð·Ð½Ð°ÐºÐµ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(135261,3758,'vi','Danh sÃ¡ch in hay nhÃ£n ngÆ°á»i bÃ¡n',0),(135262,3758,'af','Pryslyste of Ettikette van Verskaffers',0),(135263,3758,'ro','Liste de imprimare sau etichete de furnizori',0),(135264,3758,'et','Nimekirjade printimiseks vÃµi hankijate Sildid',0),(135265,3758,'si','Tiskanje seznamov ali oznake prodajalcev',0),(135266,3758,'ba','Mencetak daftar atau label dari vendor',0),(135267,3758,'nl','Afdrukken van lijsten of etiketten van leveranciers',0),(135268,3758,'fi','Luettelon tulostamiseen tai otsikoissa toimittajia',0),(135269,3758,'no','Skrive ut lister eller etiketter leverandÃ¸rer',0),(135270,3758,'da','Udskrive lister eller i etiketter til kreditorer',0),(135271,3758,'ko','ëª©ë¡ ë˜ëŠ” ê³µê¸‰ ì—…ì²´ì˜ ë ˆì´ë¸” ì¸ì‡„',0),(135272,3758,'he','×”×“×¤×¡ ×¨×©×™×ž×•×ª ××• ×ª×•×•×™×•×ª ×©×œ ×¡×¤×§×™×',0),(135273,3758,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎºÎ±Ï„Î±Î»ÏŒÎ³Ï‰Î½ Î® ÎµÏ„Î¹ÎºÎ­Ï„ÎµÏ‚ Î±Ï€ÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚',0),(135274,3758,'zh','æ‰“å°æ¸…å•æˆ–ä¾›åº”å•†æ ‡ç­¾\r\n',0),(135275,3758,'sv','Skriva ut listor eller etiketter leverantÃ¶rer',0),(135276,3758,'it','Stampa elenchi o etichette dei fornitori',0),(135277,3758,'tl','',0),(135278,3758,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3619;&#3639;&#3629;&#3593;&#3621;&#3634;&#3585;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(135279,3758,'hi','à¤¸à¥‚à¤šà¤¿à¤¯à¥‹à¤‚ à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¥‡à¤¬à¤²à¥à¤¸ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(135280,3758,'ms','Mencetak senarai atau label vendor',0),(135281,3758,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚ÙˆØ§Ø¦Ù… Ø£Ùˆ Ù…Ù„ØµÙ‚Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(135282,3758,'fr','Imprimer les listes ou les Ã©tiquettes de fournisseurs',0),(135283,3758,'jp','æ¥­è€…ãƒªã‚¹ãƒˆã?‹ãƒ©ãƒ™ãƒ«ã?®å?°åˆ·',0),(135284,3758,'pt','Listas de impressÃ£o ou rÃ³tulos de fornecedores',0),(135285,3758,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐºÐ¾Ð² Ð¸Ð»Ð¸ Ð½Ð°ÐºÐ»ÐµÐµÐº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(135286,3758,'es','Imprimir Listas o Etiquetas de Proveedores',0),(135287,3758,'de','Drucken von Listen oder Etiketten Hersteller',0),(135288,3758,'en','Print Lists or Labels of Vendors',0),(135289,3759,'is','',0),(135290,3759,'dr','Ù…Ø­Ù„ Ù‡Ø§ ',0),(135291,3759,'pr','Ù…Ø­Ù„ Ù‡Ø§ ',0),(135292,3759,'tr','Mekanlar',0),(135293,3759,'pl','Lokalizacje',0),(135294,3759,'bg','ÐœÐµÑÑ‚Ð°',0),(135295,3759,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(135296,3759,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(135297,3759,'vi','Vá»‹ trÃ­',0),(135298,3759,'af','Liggings',0),(135299,3759,'ro','Locatii',0),(135300,3759,'et','Asukohad',0),(135301,3759,'si','Lokacijah',0),(135302,3759,'ba','Lokasi',0),(135303,3759,'nl','Locaties',0),(135304,3759,'fi','Sijainnit',0),(135305,3759,'no','Steder',0),(135306,3759,'da','Steder',0),(135307,3759,'ko','ìœ„ì¹˜',0),(135308,3759,'he','×ž×™×§×•×ž×™×',0),(135309,3759,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚',0),(135310,3759,'zh','ä½ç½®\r\n',0),(135311,3759,'sv','Platser',0),(135312,3759,'it','Posizioni',0),(135313,3759,'tl','',0),(135314,3759,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(135315,3759,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚',0),(135316,3759,'ms','Lokasi-lokasi',0),(135317,3759,'ar','Ø§Ù„Ù…ÙˆØ§Ù‚Ø¹',0),(135318,3759,'fr','Emplacements',0),(135319,3759,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(135320,3759,'pt','Locais',0),(135321,3759,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(135322,3759,'es','Ubicaciones',0),(135323,3759,'de','Standorte',0),(135324,3759,'en','Locations',0),(135325,3760,'is','',0),(135326,3760,'dr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ø´ÙŠÙ† ',0),(135327,3760,'pr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ø´ÙŠÙ† ',0),(135328,3760,'tr','Makine aileler',0),(135329,3760,'pl','Maszyna rodzin',0),(135330,3760,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð°',0),(135331,3760,'ur','Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù†',0),(135332,3760,'sr','Ð¤Ð°Ð¼Ð¸Ð»Ð¸Ñ˜Ðµ',0),(135333,3760,'vi','MÃ¡y gia Ä‘Ã¬nh',0),(135334,3760,'af','Masjien gesinne',0),(135335,3760,'ro','MaÅŸinÄƒ de familii',0),(135336,3760,'et','Kohapeal peredele',0),(135337,3760,'si','Stroj druÅ¾ine',0),(135338,3760,'ba','Mesin keluarga',0),(135339,3760,'nl','Machine gezinnen',0),(135340,3760,'fi','Koneen Perheet',0),(135341,3760,'no','Maskinen familier',0),(135342,3760,'da','Maskine familier',0),(135343,3760,'ko','ê¸°ê³„ ê°€ì¡±',0),(135344,3760,'he','×ž×©×¤×—×•×ª ×ž×›×©×™×¨×™×',0),(135345,3760,'el','ÎœÎ·Ï‡Î±Î½Î® Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹ÎµÏ‚',0),(135346,3760,'zh','æœºç³»åˆ—\r\n',0),(135347,3760,'sv','Maskin familjer',0),(135348,3760,'it','Macchina famiglie',0),(135349,3760,'tl','',0),(135350,3760,'th','&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(135351,3760,'hi','à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤°à¥‹à¤‚',0),(135352,3760,'ms','Keluarga Mesin',0),(135353,3760,'ar','Ø¢Ù„Ø© Ø§Ù„Ø£Ø³Ø±',0),(135354,3760,'fr','Familles de machine',0),(135355,3760,'jp','æ©Ÿæ¢°ç³»çµ±',0),(135356,3760,'pt','FamÃ­lias de mÃ¡quina',0),(135357,3760,'ru','ÐœÐ°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹',0),(135358,3760,'es','Familias de Maquinas',0),(135359,3760,'de','Maschine Familien',0),(135360,3760,'en','Machine Families',0),(135361,3761,'is','',0),(135362,3761,'dr','Ù…Ø§Ø´ÙŠÙ† Ù‡Ø§ ',0),(135363,3761,'pr','Ù…Ø§Ø´ÙŠÙ† Ù‡Ø§ ',0),(135364,3761,'tr','Makineleri',0),(135365,3761,'pl','Maszyny',0),(135366,3761,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð¸',0),(135367,3761,'ur','Ù…Ø´ÛŒÙ†ÛŒÚº',0),(135368,3761,'sr','ÐœÐ°ÑˆÐ¸Ð½Ðµ',0),(135369,3761,'vi','MÃ¡y mÃ³c',0),(135370,3761,'af','Masjiene',0),(135371,3761,'ro','Masini',0),(135372,3761,'et','Masinad',0),(135373,3761,'si','Stroji',0),(135374,3761,'ba','Mesin',0),(135375,3761,'nl','Machines',0),(135376,3761,'fi','Koneet',0),(135377,3761,'no','Maskiner',0),(135378,3761,'da','Maskiner',0),(135379,3761,'ko','ê¸°ê³„',0),(135380,3761,'he','×ž×›×©×™×¨×™×',0),(135381,3761,'el','ÎœÎ·Ï‡Î±Î½Î­Ï‚',0),(135382,3761,'zh','æœº\r\n',0),(135383,3761,'sv','Maskiner',0),(135384,3761,'it','Macchine',0),(135385,3761,'tl','',0),(135386,3761,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(135387,3761,'hi','à¤®à¤¶à¥€à¤¨à¥‡à¤‚',0),(135388,3761,'ms','Mesin',0),(135389,3761,'ar','Ø¢Ù„Ø§Øª',0),(135390,3761,'fr','Machines',0),(135391,3761,'jp','æ©Ÿæ¢°',0),(135392,3761,'pt','MÃ¡quinas',0),(135393,3761,'ru','ÐœÐ°ÑˆÐ¸Ð½Ñ‹',0),(135394,3761,'es','Maquinas',0),(135395,3761,'de','Maschinen',0),(135396,3761,'en','Machines',0),(135397,3762,'is','',0),(135398,3762,'dr','Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(135399,3762,'pr','Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(135400,3762,'tr','SipariÅŸ YazdÄ±r',0),(135401,3762,'pl','Druk zamÃ³wienia',0),(135402,3762,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(135403,3762,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(135404,3762,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(135405,3762,'vi','In Ä‘Æ¡n hÃ ng',0),(135406,3762,'af','Druk Bestellings',0),(135407,3762,'ro','Ordine de imprimare',0),(135408,3762,'et','TrÃ¼kitÃ¶Ã¶de tellimused',0),(135409,3762,'si','Tiskanje nalogov',0),(135410,3762,'ba','Cetak pesanan',0),(135411,3762,'nl','Afdrukken bestellingen',0),(135412,3762,'fi','Tulosta tilaukset',0),(135413,3762,'no','Bestilling',0),(135414,3762,'da','Aftryksbestillinger',0),(135415,3762,'ko','ì¸ì‡„ ì£¼ë¬¸',0),(135416,3762,'he','×”×“×¤×¡ ×”×–×ž× ×•×ª',0),(135417,3762,'el','Î”Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½',0),(135418,3762,'zh','æ‰“å°è®¢å•\r\n',0),(135419,3762,'sv','Skriva ut order',0),(135420,3762,'it','Stampa ordini',0),(135421,3762,'tl','',0),(135422,3762,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(135423,3762,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶',0),(135424,3762,'ms','Pesanan cetakan',0),(135425,3762,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(135426,3762,'fr','Impression des ordres',0),(135427,3762,'jp','å?°åˆ·æ³¨æ–‡',0),(135428,3762,'pt','ImpressÃ£o de ordens',0),(135429,3762,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(135430,3762,'es','Ordenes de ImpresiÃ³n',0),(135431,3762,'de','DruckauftrÃ¤ge',0),(135432,3762,'en','Print Orders',0),(135433,3763,'is','',0),(135434,3763,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ú†Ø§Ù¾ ÙØ±Ù…Ø§ÛŒØ´Ø§Øª â€“ Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ ØªÚ©Øª Ù‡Ø§ÙŠ(Ù…Ø¬ÙˆØ²Ù‡Ø§ÙŠ ) ÙØ±Ù…Ø§ÛŒØ´',0),(135435,3763,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª â€“ Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø¨Ù„ÙŠØ· Ù‡Ø§ÙŠ(Ù…Ø¬ÙˆØ²Ù‡Ø§ÙŠ ) Ø³ÙØ§Ø±Ø´',0),(135436,3763,'tr','SipariÅŸ YazdÄ±r, Reprint sipariÅŸ bilet girin/gÃ¼ncelleme',0),(135437,3763,'pl','WprowadÅº/aktualizacja druku zamÃ³wienia, Reprint zamawiaÄ‡ bilety',0),(135438,3763,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚, Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð·Ð° Ð±Ð¸Ð»ÐµÑ‚Ð¸',0),(135439,3763,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ ØªØ±ØªÛŒØ¨ Ù¹Ú©Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(135440,3763,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ, Ð¿Ð¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ðµ',0),(135441,3763,'vi','Nháº­p/Cáº­p nháº­t In Ä‘Æ¡n hÃ ng in, Phiáº¿u in láº¡i',0),(135442,3763,'af','Invoer/Opdateer Druk Bestellings, Herdruk Bestellingskaartjies',0),(135443,3763,'ro','IntroduceÅ£i/actualizare comenzi de imprimare, imprimaÅ£i din nou comanda bilete',0),(135444,3763,'et','TrÃ¼kitÃ¶Ã¶de tellimused, kordustrÃ¼kk tellida pileteid sisestamine/ajakohastamine',0),(135445,3763,'si','Vnos/posodobitev tiskanje naroÄil, ponatis nakup vozovnic',0),(135446,3763,'ba','Masukkan/Update pesanan cetak, Reprint memesan tiket',0),(135447,3763,'nl','Invoeren/bijwerken Print bestellingen, herdruk bestel Tickets',0),(135448,3763,'fi','PÃ¤ivittÃ¤minen tulosta tilaukset, uusintapainos lippuja',0),(135449,3763,'no','Angi/Oppdater bestilling, opptrykk bestille billetter',0),(135450,3763,'da','Indtaste/opdatere aftryksbestillinger, genoptryk Bestil billetter',0),(135451,3763,'ko','ì¸ì‡„ ì£¼ë¬¸, ê¸°ìž… ìˆœì„œ í‹°ì¼“ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(135452,3763,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×©×œ ×”×“×¤×¡×•×ª, ×”×“×¤×¡×” ×ž×—×“×© ×”×–×ž× ×ª ×›×¨×˜×™×¡×™×',0),(135453,3763,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÎ½Ï„Î¿Î»Î­Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚, Î±Î½Î¬Ï„Ï…Ï€Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÎ¹ÏƒÎ¹Ï„Î·ÏÎ¯Ï‰Î½',0),(135454,3763,'zh','è¾“å…¥/æ›´æ–°æ‰“å°è®¢å•ï¼Œé‡æ‰“è®¢è´­é—¨ç¥¨\r\n',0),(135455,3763,'sv','Ange/uppdatera utskriftsbestÃ¤llningar, Reprint BestÃ¤ll biljetter',0),(135456,3763,'it','Inserire/aggiornare gli ordini di stampa, ristampa ordine biglietti',0),(135457,3763,'tl','',0),(135458,3763,'th','Enter/Update Print Orders, Reprint Order Tickets',0),(135459,3763,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶, à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤Ÿà¤¿à¤•à¤Ÿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(135460,3763,'ms','Masukkan/Kemaskini pesanan cetakan, pencetakan semula perintah Tiket',0),(135461,3763,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©ØŒ Ø·Ø¨Ø¹ ØªØ±ØªÙŠØ¨ ØªØ°Ø§ÙƒØ±',0),(135462,3763,'fr','Entrez/mise Ã  jour des ordres dâ€™impression, rÃ©impression commander des billets',0),(135463,3763,'jp','å?°åˆ·æ³¨æ–‡ã?®å…¥åŠ›/æ›´æ–°ã€?æ³¨æ–‡ãƒ?ã‚±ãƒƒãƒˆã?®å†?å?°åˆ·',0),(135464,3763,'pt','Inserir/atualizar ordens de impressÃ£o, reimpressÃ£o ordem bilhetes',0),(135465,3763,'ru','Ð’Ð²Ð¾Ð´/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð², Ñ€ÐµÐ¿Ñ€Ð¸Ð½Ñ‚ Ð·Ð°ÐºÐ°Ð· Ð±Ð¸Ð»ÐµÑ‚Ð¾Ð²',0),(135466,3763,'es','Introducir/Actualizar ordenes de ImpresiÃ³n, Reimprimir Boletos de Ordenes',0),(135467,3763,'de','Geben Sie/Update DruckauftrÃ¤ge, Reprint Tickets bestellen',0),(135468,3763,'en','Enter/Update Print Orders, Reprint Order Tickets',0),(135469,3764,'is','',0),(135470,3764,'dr','-Ø¨Ø§Ø² ØŒØ§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡ â€“ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… â€“ Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ Ùˆ ØºÙŠØ±Ù‡ ',0),(135471,3764,'pr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´-Ø¨Ø§Ø² ØŒØ§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡ â€“ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… â€“ Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ Ùˆ ØºÙŠØ±Ù‡ ',0),(135472,3764,'tr','AÃ§Ä±k listeleri, gecikmiÅŸ, tutma, kapalÄ±, vb. SipariÅŸ YazdÄ±r',0),(135473,3764,'pl','List otwarty, przeterminowane, zawieszone, zamkniÄ™te, itp. Druk zamÃ³wienia',0),(135474,3764,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½, Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡Ð¸Ñ, Ð¿Ð¾-Ð½Ð¸ÑÐºÐ°, Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½, Ð¸ Ð´Ñ€. ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(135475,3764,'ur','ÙÛØ±Ø³Øª Ú©Ú¾ÙˆÙ„ÛŒÚºØŒ Ø§ÙˆÙˆØ±Ø¯ÛŒØŒ Ù¾Ø± Ù¾Ú©Ú‘ØŒ Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ØŒ ÙˆØºÛŒØ±Û Û” Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(135476,3764,'sr','Ð›Ð¸ÑÑ‚Ðµ Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾Ð¼, Ð´Ð¾ÑÐ¿ÐµÐ»Ð¾, Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ, Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½, Ð¸Ñ‚Ð´. ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(135477,3764,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng má»Ÿ, quÃ¡ háº¡n, táº¡m nhÆ°ng, khÃ³a vv. Ä‘Æ¡n hÃ ng in',0),(135478,3764,'af','Lys van Oop, Agterstallige, \"On-Hold\", Afgesluite, ens. Druk Bestellings',0),(135479,3764,'ro','Listele de Open, restante, On-Hold, Ã®nchis, etc. Ordine de imprimare',0),(135480,3764,'et','Avatud nimekirjad, tÃ¤htajaks tasumata, hoidke kohta, suletud, jne. TrÃ¼kitÃ¶Ã¶de tellimused',0),(135481,3764,'si','Seznami odprtega, zapadlo, na Äakanju, zaprt, itd. Tiskanje nalogov',0),(135482,3764,'ba','Daftar terbuka, tempo, pada terus, tertutup, dll. Cetak pesanan',0),(135483,3764,'nl','Lijsten van Open, achterstallig, On-Hold, gesloten, enz. Afdrukken bestellingen',0),(135484,3764,'fi','Avaa luettelo, erÃ¤Ã¤ntynyt, pidossa, kiinni, jne. Tulosta tilaukset',0),(135485,3764,'no','Liste over Ã¥pne, forfalt, pÃ¥ Hold, lukket, etc. Bestilling',0),(135486,3764,'da','Lister over Ã¥ben, forfaldne, i venteposition, lukket, etc. Aftryksbestillinger',0),(135487,3764,'ko','ì˜¤í”ˆì˜ ëª©ë¡, ì—°ì²´, ëŒ€ê¸°, ë“±. ì¸ì‡„ ì£¼ë¬¸',0),(135488,3764,'he','×¨×©×™×ž×•×ª ×©×œ ×¤×ª×—, Overdue, ×¢×œ ×”×—×–×§, ×¡×’×•×¨, ×•×¢×•×“. ×”×“×¤×¡×•×ª',0),(135489,3764,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ Ï„Ï‰Î½ Î±Î½Î¿Î¹ÎºÏ„ÏŽÎ½, Î›Î·Î¾Î¹Ï€ÏÏŒÎ¸, On-Hold, ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŒ, ÎºÎ»Ï€. Î”Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½',0),(135490,3764,'zh','å¼€æ”¾è¡¨ï¼Œé€¾æœŸè¡¨ï¼ŒçŽ°æœ‰è´§ç‰©è¡¨ï¼Œå°é—­è¡¨ï¼Œç­‰æ‰“å°è®¢å•\r\n',0),(135491,3764,'sv','Listor av Ã¶ppna, fÃ¶rfallna, spÃ¤rrade, stÃ¤ngd, etc. Skriva ut order',0),(135492,3764,'it','Liste di Open, scaduti, in attesa, chiuso, ecc. Stampa ordini',0),(135493,3764,'tl','',0),(135494,3764,'th','Lists of Open, Overdue, On-Hold, Closed, etc. Print Orders',0),(135495,3764,'hi','à¤“à¤ªà¤¨ à¤•à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤, à¤…à¤¤à¤¿à¤¦à¥‡à¤¯, à¤ªà¤° à¤ªà¤•à¤¡à¤¼, à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾, à¤†à¤¦à¤¿à¥¤ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶',0),(135496,3764,'ms','Senarai terbuka, pemulangannya, di pegang, ditutup, dan lain-lain. Pesanan cetakan',0),(135497,3764,'ar','Ù‚ÙˆØ§Ø¦Ù… Ù…ÙØªÙˆØ­Ø©ØŒ OverdueØŒ ÙÙŠ Ø§Ù„Ø§Ù†ØªØ¸Ø§Ø±ØŒ Ø¥ØºÙ„Ø§Ù‚ØŒ Ø¥Ù„Ø®. Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(135498,3764,'fr','Listes d\'ouvrir, en retard, en attente, fermÃ©, etc.. Impression des ordres',0),(135499,3764,'jp','ã‚ªãƒ¼ãƒ—ãƒ³ã€?æœŸé™?è¶…é?Žã€?æ‰‹æŒ?ã?¡ã€?çµ‚äº†æ¸ˆå?°åˆ·æ³¨æ–‡ã?®ãƒªã‚¹ãƒˆ',0),(135500,3764,'pt','Listas de Open, tardia, de espera, fechada, etc. ImpressÃ£o de ordens',0),(135501,3764,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ…, Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ, Ð½Ð° ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ðµ, Ð·Ð°ÐºÑ€Ñ‹Ñ‚, Ð¸ Ñ‚.Ð´. ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(135502,3764,'es','Listas de Ordenes de ImpresiÃ³n Abiertas, Vencidas, Cerradas, Etc.',0),(135503,3764,'de','Listen der offenen, Ã¼berfÃ¤llig, On-Hold, geschlossen, etc.. DruckauftrÃ¤ge',0),(135504,3764,'en','Lists of Open, Overdue, On-Hold, Closed, etc. Print Orders',0),(135505,3765,'is','',0),(135506,3765,'dr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¬Ø¯ÙŠØ¯ ',0),(135507,3765,'pr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¬Ø¯ÙŠØ¯ ',0),(135508,3765,'tr','Yeni sipariÅŸ YazdÄ±r girin',0),(135509,3765,'pl','WprowadÅº nowe zlecenia drukowania',0),(135510,3765,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(135511,3765,'ur','Ù†Ø¦Û’ Ù¾Ø±Ù†Ù¹ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(135512,3765,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(135513,3765,'vi','Nháº­p Ä‘Æ¡n hÃ ng in má»›i',0),(135514,3765,'af','Voer nuwe gedrukte bestellings',0),(135515,3765,'ro','IntroduceÅ£i noi comenzi de imprimare',0),(135516,3765,'et','Prindi tellimuse',0),(135517,3765,'si','Vnesti nova naroÄila tiskanja',0),(135518,3765,'ba','Masukkan pesanan cetak baru',0),(135519,3765,'nl','Nieuwe Print Orders invoeren',0),(135520,3765,'fi','Kirjoita uuden tulosta tilaukset',0),(135521,3765,'no','Angi ny bestilling',0),(135522,3765,'da','Angiv nye aftryksbestillinger',0),(135523,3765,'ko','ìƒˆë¡œìš´ ì¸ì‡„ ì£¼ë¬¸ ìž…ë ¥',0),(135524,3765,'he','×”×–× ×ª ×¤×§×•×“×•×ª ×”×“×¤×¡×” ×—×“×©×•×ª',0),(135525,3765,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î½Î­ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(135526,3765,'zh','è¾“å…¥æ–°çš„æ‰“å°è®¢å•\r\n',0),(135527,3765,'sv','Ange nya Print Order',0),(135528,3765,'it','Inserire nuovi ordini di stampa',0),(135529,3765,'tl','',0),(135530,3765,'th','&#3611;&#3657;&#3629;&#3609;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(135531,3765,'hi','à¤¨à¤ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(135532,3765,'ms','Masukkan pesanan cetakan baru',0),(135533,3765,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(135534,3765,'fr','Entrez les nouvelles commandes dâ€™impression',0),(135535,3765,'jp','æ–°è¦?å?°åˆ·æ³¨æ–‡ã?®å…¥åŠ›',0),(135536,3765,'pt','Insira novas ordens de impressÃ£o',0),(135537,3765,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(135538,3765,'es','Introducir Nuevos Ordenes de ImpresiÃ³n',0),(135539,3765,'de','Geben Sie neue DruckauftrÃ¤ge',0),(135540,3765,'en','Enter New Print Orders',0),(135541,3766,'is','',0),(135542,3766,'dr','/ ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ø´ØºÙ„ Ù‡Ø§ / Ø´ØºÙ„ Ù‡Ø§ÙŠ Ø­Ù…Ù„ / Ø§Ø­ØµØ§Ø¦ÛŒÙ‡  / Ø§Ø³Ù†Ø§Ø¯ Ùˆ Ø¢ÙˆÛŒØ²Ù‡Ø§ÛŒ',0),(135543,3766,'pr','Ø«Ø¨Øª Ø²Ù…Ø§Ù† Ùˆ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ÙˆØ§Ù‚Ø¹ÙŠ / ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ø´ØºÙ„ Ù‡Ø§ / Ø´ØºÙ„ Ù‡Ø§ÙŠ Ø­Ù…Ù„ / Ø¢Ù…Ø§Ø± / Ø§Ø³Ù†Ø§Ø¯ Ùˆ Ù…Ø¯Ø§Ø±Ùƒ',0),(135544,3766,'tr','GerÃ§ek zaman ve malzeme/tamamlamak iÅŸleri/gemi iÅŸleri/istatistikler/deliller girin',0),(135545,3766,'pl','WprowadÅº aktualny czas i materiaÅ‚y/zakoÅ„czyÄ‡ zadania/statek zadania/statystyki/dowody',0),(135546,3766,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ€ÐµÐ°Ð»Ð½Ð¾Ñ‚Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸/Ð¿ÑŠÐ»Ð½Ð° Ð·Ð°ÐµÑ‚Ð¾ÑÑ‚/ÐºÐ¾Ñ€Ð°Ð± Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð¼ÐµÑÑ‚Ð°/ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°/Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð°',0),(135547,3766,'ur','Ø§ØµÙ„ ÙˆÙ‚Øª Ø§ÙˆØ± Ù…ÙˆØ§Ø¯/Ù…Ú©Ù…Ù„ Ø±ÙˆØ²Ú¯Ø§Ø±/Ø¬ÛØ§Ø² Ù†ÙˆÚ©Ø±ÛŒØ§Úº/Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±/Ø¯Ù„Ø§Ø¦Ù„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(135548,3766,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑÑ‚Ð²Ð°Ñ€Ð½Ð¾Ð³ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð°/Ð´Ð¾Ð²Ñ€ÑˆÐ¸Ñ‚Ðµ Ð¿Ð¾ÑÐ»Ð¾Ð²Ðµ/Ð±Ñ€Ð¾Ð´ Ð¿Ð¾ÑÐ»Ð¾Ð²Ðµ/Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°/Ð´Ð¾ÐºÐ°Ð·Ðµ',0),(135549,3766,'vi','Nháº­p thá»i gian nguyÃªn váº­t liá»‡u thá»±c táº¿/Job hoÃ n thÃ nh/Job Ä‘Ã£ chuyá»ƒn/Thá»‘ng kÃª/Báº£n in thá»­',0),(135550,3766,'af','Voer Werklike Tyd en Materiale/Voltooide Werstukke/Versendings Werkstukke/Statistieke/Proewe',0),(135551,3766,'ro','Intre timp real ÅŸi materiale completa navÄƒ de locuri de muncÄƒ/locuri de munca/statistici/dovezile',0),(135552,3766,'et','Sisestada tegelik aeg ja materjalid vÃµi tÃ¤ieliku tÃ¶Ã¶ laeval tÃ¶Ã¶kohti/statistika/tÃµendid',0),(135553,3766,'si','Vnesite dejansko Äas in materialov/celoten delovna mesta/ladja delovnih mest/statistika/dokazila',0),(135554,3766,'ba','Masukkan waktu aktual dan bahan/lengkap pekerjaan kapal pekerjaan/Statistik/bukti',0),(135555,3766,'nl','Invoeren van werkelijke tijd en materialen/voltooien banen/schip banen/statistieken/bewijzen',0),(135556,3766,'fi','Kirjoita todellinen aika ja materiaalit, tÃ¤ydellinen tyÃ¶paikkoja tai alusten tyÃ¶paikkoja/tilastot/todisteita',0),(135557,3766,'no','Angi faktisk tid og materialer/fullfÃ¸re jobber/skip jobber/statistikk/bevis',0),(135558,3766,'da','Angiv faktiske tid og materialer/komplet job/skib Jobs/statistik/beviser',0),(135559,3766,'ko','ì‹¤ì œ ì‹œê°„ ë° ìž¬ë£Œ/ì „ì²´ ìž‘ì—…/ë°° ìž‘ì—…/í†µê³„/êµì • ìž…ë ¥',0),(135560,3766,'he','×”×–×Ÿ ×–×ž×Ÿ ×‘×¤×•×¢×œ, ×—×•×ž×¨×™×/×œ×”×©×œ×™× ×ž×©×™×ž×•×ª/×”×¡×¤×™× ×” ×¢×‘×•×“×•×ª/×¡×˜×˜×™×¡×˜×™×§×”/×”×’×”×•×ª',0),(135561,3766,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ¿Ï Ï‡ÏÏŒÎ½Î¿Ï… ÎºÎ±Î¹ Ï…Î»Î¹ÎºÏŽÎ½/Ï€Î»Î®ÏÎµÏ‚ Î±Ï€Î±ÏƒÏ‡ÏŒÎ»Î·ÏƒÎ·/Ï€Î»Î¿Î¯Î¿ Î¸Î­ÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚/ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±/Î±Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚',0),(135562,3766,'zh','è¾“å…¥å®žé™…æ—¶é—´å’Œææ–™/å®Œæˆä½œä¸š/è£…è¿å·¥ä½œ/ç»Ÿè®¡/è¯æ˜Ž\r\n',0),(135563,3766,'sv','Ange faktiska tid och material eller komplettera jobb/fartyg jobb/statistik/korrektur',0),(135564,3766,'it','Immettere il tempo effettivo e materiali/completare i lavori/nave lavori/statistiche/prove',0),(135565,3766,'tl','',0),(135566,3766,'th','Enter Actual Time and Materials/Complete Jobs/Ship Jobs/Statistics/Proofs',0),(135567,3766,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤¸à¤®à¤¯ à¤”à¤° à¤¸à¤¾à¤®à¤—à¥à¤°à¥€/à¤ªà¥‚à¤°à¤¾ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¤¾à¤‚/à¤œà¤¹à¤¾à¤œ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¤¾à¤‚/à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤•à¥€/à¤¸à¤¬à¥‚à¤¤ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(135568,3766,'ms','Masukkan masa sebenar dan bahan-bahan/menyelesaikan pekerjaan/kapal pekerjaan/statistik/bukti-bukti',0),(135569,3766,'ar','Ø£Ø¯Ø®Ù„ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„ÙØ¹Ù„ÙŠ ÙˆØ§Ù„Ù…ÙˆØ§Ø¯/Ø¥ÙƒÙ…Ø§Ù„ Ø§Ù„Ø³ÙÙŠÙ†Ø© ÙˆØ¸Ø§Ø¦Ù ÙˆØ¸Ø§Ø¦Ù/Ø§Ù„Ø¥Ø­ØµØ§Ø¡Ø§Øª/Ø§Ù„Ø¨Ø±Ø§Ù‡ÙŠÙ†',0),(135570,3766,'fr','Entrez temps rÃ©el et toutes les matiÃ¨res/emplois/navire emplois/statistiques/Ã©preuves',0),(135571,3766,'jp','å®Ÿæ™‚é–“ã?¨æ??æ–™/å®Œäº†ä½œæ¥­/ç™ºé€?ä½œæ¥­/çµ±è¨ˆ/æ ¡æ­£ã?®å…¥åŠ›',0),(135572,3766,'pt','Digite a hora Actual e materiais/completar trabalhos/navio empregos/estatÃ­sticas/provas',0),(135573,3766,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð²Ñ€ÐµÐ¼Ñ Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹/Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹/ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð²Ð°ÐºÐ°Ð½ÑÐ¸Ð¸/ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°/Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(135574,3766,'es','Introducir Tiempo Actual y Materiales/Trabajos Completos/EnvÃ­o de Trabajos/Estadisticas/Pruebas',0),(135575,3766,'de','Geben Sie Uhrzeit und Materialien/komplette ArbeitsplÃ¤tze/Schiff Jobs/Statistik/Nachweise',0),(135576,3766,'en','Enter Actual Time and Materials/Complete Jobs/Ship Jobs/Statistics/Proofs',0),(135577,3767,'is','',0),(135578,3767,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡ ',0),(135579,3767,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡ ',0),(135580,3767,'tr','Matbaa Kur',0),(135581,3767,'pl','Drukarnia instalacji',0),(135582,3767,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½',0),(135583,3767,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ Ø¯Ú©Ø§Ù† Ø³ÛŒÙ¹ Ø§Ù¾',0),(135584,3767,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÐŸÑ€Ð¸Ð½Ñ‚ Ð¡Ñ…Ð¾Ð¿',0),(135585,3767,'vi','Setup tiá»‡m in',0),(135586,3767,'af','Druk Shop opstelling',0),(135587,3767,'ro','Print magazin Setup',0),(135588,3767,'et','TrÃ¼kifirma seadistamine',0),(135589,3767,'si','Print Shop Setup',0),(135590,3767,'ba','Setup toko cetak',0),(135591,3767,'nl','Print Shop Setup',0),(135592,3767,'fi','Tulosta Shop asennus',0),(135593,3767,'no','Installasjonsprogrammet for trykkeri',0),(135594,3767,'da','OpsÃ¦tning af Print Shop',0),(135595,3767,'ko','ì¸ì‡„ ê³µìž¥ ì„¤ì¹˜',0),(135596,3767,'he','×‘×™×ª ×”×“×¤×•×¡ ×”×”×ª×§× ×”',0),(135597,3767,'el','Î¤Ï…Ï€Î¿Î³ÏÎ±Ï†ÎµÎ¯Î¿ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(135598,3767,'zh','æ‰“å°æ‰€è®¾ç½®\r\n',0),(135599,3767,'sv','Print Shop Setup',0),(135600,3767,'it','Print Shop Setup',0),(135601,3767,'tl','',0),(135602,3767,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3619;&#3657;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(135603,3767,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(135604,3767,'ms','Kedai cetak persediaan',0),(135605,3767,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ ÙˆØ±Ø´Ø© Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(135606,3767,'fr','Installation de l\'imprimerie',0),(135607,3767,'jp','ã‚·ãƒ§ãƒƒãƒ—è¨­å®šã?®å?°åˆ·',0),(135608,3767,'pt','InstalaÃ§Ã£o do Print Shop',0),(135609,3767,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½',0),(135610,3767,'es','ConfiguraciÃ³n de Taller de ImpresiÃ³n',0),(135611,3767,'de','Druckerei-Setup',0),(135612,3767,'en','Print Shop Setup',0),(135613,3768,'is','',0),(135614,3768,'dr',': Ù…Ø§Ø´ÙŠÙ† Ù‡Ø§- Ù†Ø±Ø® Ù‡Ø§ Ùˆ ØºÙŠØ±Ù‡ ..',0),(135615,3768,'pr','Ù…Ù†ÙˆÙŠ ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ â€“ Ø¹Ù…Ù„ÙŠØ§Øª Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡: Ù…Ø§Ø´ÙŠÙ† Ù‡Ø§- Ù†Ø±Ø® Ù‡Ø§ Ùˆ ØºÙŠØ±Ù‡ ..',0),(135616,3768,'tr','Matbaa kurulum iÅŸlev: Makineleri, oranlarÄ±, vb.',0),(135617,3768,'pl','Drukarni ustawienie funkcji: Maszyny, stawki, itp.',0),(135618,3768,'bg','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð·Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½: ÐœÐ°ÑˆÐ¸Ð½Ð¸, Ñ‚Ð°Ñ€Ð¸Ñ„Ð¸, Ð¸ Ð´Ñ€.',0),(135619,3768,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ Ø¯Ú©Ø§Ù† Ø³ÛŒÙ¹ Ø§Ù¾ Ø§ÙØ¹Ø§Ù„: Ù…Ø´ÛŒÙ†ÛŒÚºØŒ Ø´Ø±Ø­ØŒ ÙˆØºÛŒØ±Û Û”',0),(135620,3768,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°Ñ€Ð¸Ñ˜Ðµ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ: ÐœÐ°ÑˆÐ¸Ð½Ðµ, ÑÑ‚Ð¾Ð¿Ð° Ð¸Ñ‚Ð´.',0),(135621,3768,'vi','Chá»©c nÄƒng setup tiá»‡m in: mÃ¡y, giÃ¡ vv',0),(135622,3768,'af','Druk Shop opstelling funksies: Masjiene, tariewe, ens.',0),(135623,3768,'ro','Print magazin Setup funcÅ£ii: MaÅŸini, ratele, etc.',0),(135624,3768,'et','TrÃ¼kifirma seadistustoimingute: Masinad, mÃ¤Ã¤rad, jne.',0),(135625,3768,'si','Print Shop nastavitev funkcije: Stroji, mere, itd.',0),(135626,3768,'ba','Toko cetak Setup fungsi: Mesin, harga, dll.',0),(135627,3768,'nl','Print Shop Setup functies: Machines, tarieven, enz.',0),(135628,3768,'fi','Tulosta Shop asennuksen toiminnot: Koneet, hinnat, jne.',0),(135629,3768,'no','Trykkeri oppsettfunksjoner: Maskiner, priser, etc.',0),(135630,3768,'da','Print Shop opsÃ¦tningsfunktioner: Maskiner, priser, osv.',0),(135631,3768,'ko','ì¸ì‡„ì†Œ ì„¤ì • ê¸°ëŠ¥: ê¸°ê³„, ìš”ê¸ˆ, ë“±ë“±.',0),(135632,3768,'he','×‘×™×ª ×”×“×¤×•×¡ ×”×’×“×¨×ª ×¤×•× ×§×¦×™×•×ª: ×ž×›×•× ×•×ª, ×”×ž×—×™×¨×™× ×•×›×“\'.',0),(135633,3768,'el','Î¤Ï…Ï€Î¿Î³ÏÎ±Ï†ÎµÎ¯Î¿ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚: ÎœÎ·Ï‡Î±Î½Î­Ï‚, Ï„Î¹Î¼Î­Ï‚, ÎºÎ»Ï€.',0),(135634,3768,'zh','å°åˆ·è½¦é—´çš„è®¾å®šåŠŸèƒ½ï¼šæœºå™¨ï¼Œä»·æ ¼ç­‰\r\n',0),(135635,3768,'sv','Print Shop Setup funktioner: Maskiner, priser, etc.',0),(135636,3768,'it','Funzioni di Setup Print Shop: Macchine, tariffe, ecc.',0),(135637,3768,'tl','',0),(135638,3768,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660; : Machines, Rates, etc.',0),(135639,3768,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¤¾à¤°à¥à¤¯: à¤®à¤¶à¥€à¤¨à¥‹à¤‚, à¤¦à¤°, à¤†à¤¦à¤¿à¥¤',0),(135640,3768,'ms','Fungsi Setup kedai cetak: Mesin, kadar, dan lain-lain.',0),(135641,3768,'ar','Ù…Ù‡Ø§Ù… Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø·Ø¨Ø¹Ø©: Ø¢Ù„Ø§ØªØŒ Ù…Ø¹Ø¯Ù„Ø§ØªØŒ Ø¥Ù„Ø®.',0),(135642,3768,'fr','Fonctions de configuration Print Shop : Machines, tarifs, etc..',0),(135643,3768,'jp','ã‚·ãƒ§ãƒƒãƒ—è¨­å®šæ©Ÿèƒ½ã?®å?°åˆ·ï¼šæ©Ÿæ¢°ã€?æ–™é‡‘ã?ªã?©',0),(135644,3768,'pt','FunÃ§Ãµes de configuraÃ§Ã£o grÃ¡fica: MÃ¡quinas, taxas, etc.',0),(135645,3768,'ru','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ñ‚Ð¸Ð¿Ð¾Ð³Ñ€Ð°Ñ„Ð¸Ð¸: ÐœÐ°ÑˆÐ¸Ð½Ñ‹, Ñ†ÐµÐ½Ñ‹ Ð¸ Ñ‚.Ð´.',0),(135646,3768,'es','ConfiguraciÃ³n de Funciones de Taller de ImpresiÃ³n, Tasas, Etc.',0),(135647,3768,'de','Druckerei-Setup-Funktionen: Maschinen, Preise, etc.',0),(135648,3768,'en','Print Shop Setup Functions: Machines, Rates, etc.',0),(135649,3769,'is','',0),(135650,3769,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(135651,3769,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(135652,3769,'tr','Ä°ÅŸleme',0),(135653,3769,'pl','Przetwarzanie',0),(135654,3769,'bg','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(135655,3769,'ur','Ø¹Ù…Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(135656,3769,'sr','ÐžÐ±Ñ€Ð°Ð´Ð°',0),(135657,3769,'vi','Xá»­ lÃ½',0),(135658,3769,'af','Prosessering',0),(135659,3769,'ro','Prelucrare',0),(135660,3769,'et','TÃ¶Ã¶tlemine',0),(135661,3769,'si','Obdelava',0),(135662,3769,'ba','Pengolahan',0),(135663,3769,'nl','Verwerking',0),(135664,3769,'fi','KÃ¤sittely',0),(135665,3769,'no','Behandling',0),(135666,3769,'da','Behandling',0),(135667,3769,'ko','ì²˜ë¦¬',0),(135668,3769,'he','×ž×¢×‘×“',0),(135669,3769,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(135670,3769,'zh','å¤„ç†\r\n',0),(135671,3769,'sv','Bearbetning',0),(135672,3769,'it','Elaborazione',0),(135673,3769,'tl','',0),(135674,3769,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(135675,3769,'hi','à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(135676,3769,'ms','Pemprosesan',0),(135677,3769,'ar','ØªØ¬Ù‡ÙŠØ²',0),(135678,3769,'fr','Traitement',0),(135679,3769,'jp','å‡¦ç?†ä¸­',0),(135680,3769,'pt','Processamento',0),(135681,3769,'ru','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(135682,3769,'es','Procesando',0),(135683,3769,'de','Verarbeitung',0),(135684,3769,'en','Processing',0),(135685,3770,'is','',0),(135686,3770,'dr','Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(135687,3770,'pr','Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(135688,3770,'tr','SipariÅŸ iÃ§in reprint alÄ±ntÄ±',0),(135689,3770,'pl','Przedruk oferty dla zamÃ³wienia',0),(135690,3770,'bg','ÐŸÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(135691,3770,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹',0),(135692,3770,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(135693,3770,'vi','BÃ¡o giÃ¡ in cho Ä‘Æ¡n hÃ ng',0),(135694,3770,'af','Herdruk Kwotasie vir Bestelling',0),(135695,3770,'ro','ImprimaÅ£i din nou citat pentru comanda',0),(135696,3770,'et','KordustrÃ¼kk hinnapakkumise tellimuse',0),(135697,3770,'si','Ponatis ponudbo za naroÄilo',0),(135698,3770,'ba','Reprint kutipan untuk Order',0),(135699,3770,'nl','Herdruk offerte voor Order',0),(135700,3770,'fi','Tulosta tarjouspyynnÃ¶n tilauksen',0),(135701,3770,'no','Nytt tilbud for bestilling',0),(135702,3770,'da','Genoptryk tilbud til ordre',0),(135703,3770,'ko','ì£¼ë¬¸ì— ëŒ€ í•œ ë¬´ë‹¨ ì „ìž¬ ì¸ìš©',0),(135704,3770,'he','×”×“×¤×¡ ×©×•×‘ ×”×¦×¢×ª ×ž×—×™×¨ ×¢×‘×•×¨ ×”×”×–×ž× ×”',0),(135705,3770,'el','Î‘Î½Î¬Ï„Ï…Ï€Î¿ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(135706,3770,'zh','é‡å°è®¢å•æŠ¥ä»·\r\n',0),(135707,3770,'sv','Nytryck offert fÃ¶r bestÃ¤llning',0),(135708,3770,'it','Ristampa preventivo per ordine',0),(135709,3770,'tl','',0),(135710,3770,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3637;&#3',0),(135711,3770,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(135712,3770,'ms','Pencetakan semula sebut harga untuk pesanan',0),(135713,3770,'ar','Ø§Ù‚ØªØ¨Ø§Ø³ Ø·Ø¨Ø¹ Ù„Ù„Ù†Ø¸Ø§Ù…',0),(135714,3770,'fr','RÃ©impression devis pour commander',0),(135715,3770,'jp','æ³¨æ–‡ã?®è¦‹ç©?ã‚’å†?å?°åˆ·',0),(135716,3770,'pt','CitaÃ§Ã£o de reimpressÃ£o para ordem',0),(135717,3770,'ru','ÐŸÐµÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚ÐºÐ° Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(135718,3770,'es','Reimprimir CotizaciÃ³n para Pedido',0),(135719,3770,'de','Nachdruck Angebot fÃ¼r Bestellung',0),(135720,3770,'en','Reprint Quote for Order',0),(135721,3771,'is','',0),(135722,3771,'dr','Ú†Ø§Ù¾ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ',0),(135723,3771,'pr','Ú†Ø§Ù¾ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ',0),(135724,3771,'tr','YazdÄ±rma programÄ±',0),(135725,3771,'pl','WydrukowaÄ‡ kalendarz',0),(135726,3771,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸',0),(135727,3771,'ur','Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ÛŒ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(135728,3771,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´Ð°',0),(135729,3771,'vi','Káº¿ hoáº¡ch in',0),(135730,3771,'af','Druk Skedule',0),(135731,3771,'ro','Programul de imprimare',0),(135732,3771,'et','Prindi graafik',0),(135733,3771,'si','Natisniti urnik',0),(135734,3771,'ba','Jadwal cetak',0),(135735,3771,'nl','Afdrukken',0),(135736,3771,'fi','Tulosta aikataulu',0),(135737,3771,'no','Skrive ut timeplanen',0),(135738,3771,'da','Udskrive tidsplan',0),(135739,3771,'ko','ì¼ì • ì¸ì‡„',0),(135740,3771,'he','×”×“×¤×¡ ×œ×•×— ×–×ž× ×™×',0),(135741,3771,'el','Î ÏÏŒÎ³ÏÎ±Î¼Î¼Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(135742,3771,'zh','æ‰“å°æ—¥ç¨‹è¡¨\r\n',0),(135743,3771,'sv','Skriva ut schema',0),(135744,3771,'it','Stampare il calendario',0),(135745,3771,'tl','',0),(135746,3771,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3627;&#3617;&#3634;&#3618;&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;',0),(135747,3771,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤…à¤¨à¥à¤¸à¥‚à¤šà¥€',0),(135748,3771,'ms','Cetak Jadual',0),(135749,3771,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø²Ù…Ù†ÙŠ',0),(135750,3771,'fr','Imprimer calendrier',0),(135751,3771,'jp','ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ«ã?®å?°åˆ·',0),(135752,3771,'pt','Imprimir horÃ¡rio',0),(135753,3771,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ñ€Ð°ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(135754,3771,'es','Agenda de ImpresiÃ³n',0),(135755,3771,'de','Zeitplan drucken',0),(135756,3771,'en','Print Schedule',0),(135757,3772,'is','',0),(135758,3772,'dr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ ',0),(135759,3772,'pr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ ',0),(135760,3772,'tr','Planlama raporlarÄ± yazdÄ±rma',0),(135761,3772,'pl','WydrukowaÄ‡ harmonogram raportÃ³w',0),(135762,3772,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð°ÑÑ€Ð¾Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(135763,3772,'ur','Ø±Ù¾ÙˆØ±Ù¹ÛŒÚº Ø´ÛŒÚˆÙˆÙ„Ù†Ú¯ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(135764,3772,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ð»Ð°Ð½Ð¸Ñ€Ð°ÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(135765,3772,'vi','In bÃ¡o cÃ¡o dá»‹nh ká»³',0),(135766,3772,'af','Druk Skedule Verslae',0),(135767,3772,'ro','Imprima rapoarte de planificare',0),(135768,3772,'et','Prindi, aruannete ajastamise',0),(135769,3772,'si','Tiskanje, razporejanje poroÄila',0),(135770,3772,'ba','Mencetak penjadwalan laporan',0),(135771,3772,'nl','Afdrukken rapporten plannen',0),(135772,3772,'fi','Tulostaa raporttien ajoittaminen',0),(135773,3772,'no','Skrive ut planlegging av rapporter',0),(135774,3772,'da','Udskrive planlÃ¦gning af rapporter',0),(135775,3772,'ko','ë³´ê³ ì„œ ì¼ì • ì¸ì‡„',0),(135776,3772,'he','×”×“×¤×¡ ×ª×–×ž×•×Ÿ ×“×•×—×•×ª',0),(135777,3772,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï€ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÎ¼ÏŒ Î±Î½Î±Ï†Î¿ÏÏŽÎ½',0),(135778,3772,'zh','æ‰“å°è°ƒåº¦æŠ¥å‘Š\r\n',0),(135779,3772,'sv','Skriva ut schemalÃ¤gga rapporter',0),(135780,3772,'it','Stampare report di pianificazione',0),(135781,3772,'tl','',0),(135782,3772,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3627;&#3617;&#3634;&#3618;&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;',0),(135783,3772,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¶à¥‡à¤¡à¥à¤¯à¥‚à¤²à¤¿à¤‚à¤— à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(135784,3772,'ms','Mencetak laporan penjadualan',0),(135785,3772,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¬Ø¯ÙˆÙ„Ø© Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ±',0),(135786,3772,'fr','Imprimer des rapports de planification',0),(135787,3772,'jp','ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ«ãƒ¬ãƒ?ãƒ¼ãƒˆã?®å?°åˆ·',0),(135788,3772,'pt','Imprimir relatÃ³rios de agendamento',0),(135789,3772,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ñ€Ð°ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¾Ð²',0),(135790,3772,'es','Imprimir Informes de Agenda',0),(135791,3772,'de','Planen von Berichten zu drucken',0),(135792,3772,'en','Print Scheduling Reports',0),(135793,3773,'is','',0),(135794,3773,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡   Ú†Ø§Ù¾ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù‡Ø§ ',0),(135795,3773,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡   Ú†Ø§Ù¾ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù‡Ø§ ',0),(135796,3773,'tr','Deyimleri GÃ¶rÃ¼ntÃ¼le/YazdÄ±r',0),(135797,3773,'pl','WyÅ›wietl/drukuj instrukcji',0),(135798,3773,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´/Ð¿ÐµÑ‡Ð°Ñ‚ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(135799,3773,'ur','Ù…Ù†Ø¸Ø±/Ø¨ÛŒØ§Ù†Ø§Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(135800,3773,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· /ÐŸÑ€Ð¸Ð½Ñ‚ Ð¸Ð·Ñ˜Ð°Ð²Ðµ',0),(135801,3773,'vi','Xem/In sao kÃª',0),(135802,3773,'af','Besigtig/Druk State',0),(135803,3773,'ro','Vezi/declaraÅ£ii de imprimare',0),(135804,3773,'et','Vaata/Prindi vÃ¤ljavÃµtteid',0),(135805,3773,'si','Poglej/Natisni izjave',0),(135806,3773,'ba','Lihat/Cetak laporan',0),(135807,3773,'nl','Weergeven/afdrukken verklaringen',0),(135808,3773,'fi','NÃ¤ytÃ¤ tai tulosta lausumat',0),(135809,3773,'no','Vis/Skriv ut uttalelser',0),(135810,3773,'da','Se/Udskriv udtalelser',0),(135811,3773,'ko','ë³´ê¸°/ì¸ì‡„ ë¬¸ì˜',0),(135812,3773,'he','×”×¦×’/×”×“×¤×¡ ×”×¦×”×¨×•×ª',0),(135813,3773,'el','Î ÏÎ¿Î²Î¿Î»Î®/Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î´Î·Î»ÏŽÏƒÎµÎ¹Ï‚',0),(135814,3773,'zh','æŸ¥çœ‹/æ‰“å°å£°æ˜Ž\r\n',0),(135815,3773,'sv','View/Print uttalanden',0),(135816,3773,'it','Visualizza/stampa dichiarazioni',0),(135817,3773,'tl','',0),(135818,3773,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;/&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(135819,3773,'hi','à¤¦à¥ƒà¤¶à¥à¤¯/à¤¬à¤¯à¤¾à¤¨ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(135820,3773,'ms','View/Print penyata',0),(135821,3773,'ar','Ø¹Ø±Ø¶/Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(135822,3773,'fr','Visualiser/imprimer des dÃ©clarations',0),(135823,3773,'jp','æ˜Žç´°ã?®è¡¨ç¤º/å?°åˆ·',0),(135824,3773,'pt','Ver/imprimir instruÃ§Ãµes',0),(135825,3773,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(135826,3773,'es','Ver/Imprimir Declaraciones',0),(135827,3773,'de','Drucken Sie anzeigen/Anweisungen',0),(135828,3773,'en','View/Print Statements',0),(135829,3774,'is','',0),(135830,3774,'dr','(Ù…ÙØ§Ø¯) Ø³Ù‡Ø§Ù…(Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù…',0),(135831,3774,'pr','Ú†Ø§Ù¾ Ù…Ù†Ø¸ÙˆØ±(Ù…ÙØ§Ø¯) Ø³Ù‡Ø§Ù…(Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(135832,3774,'tr','Hisse senedi amaÃ§',0),(135833,3774,'pl','PieÅ„ celem',0),(135834,3774,'bg','Ð‘Ð¾Ñ€ÑÐ¾Ð²Ð° Ñ†ÐµÐ»',0),(135835,3774,'ur','Ø§Ø³Ù¹Ø§Ú© Ù…Ù‚ØµØ¯',0),(135836,3774,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ ÑÐ²Ñ€Ñ…Ñƒ',0),(135837,3774,'vi','Má»¥c Ä‘Ã­ch hÃ ng tá»“n',0),(135838,3774,'af','Voorraad Doeleindes',0),(135839,3774,'ro','Stoc scop',0),(135840,3774,'et','Varude eesmÃ¤rk',0),(135841,3774,'si','Namen parka',0),(135842,3774,'ba','Tujuan saham',0),(135843,3774,'nl','Voorraad doel',0),(135844,3774,'fi','Varastossa tarkoitus',0),(135845,3774,'no','Lager formÃ¥l',0),(135846,3774,'da','Stock formÃ¥l',0),(135847,3774,'ko','ìž¬ê³  ëª©ì ',0),(135848,3774,'he','×ª×›×œ×™×ª ×ž× ×™×•×ª',0),(135849,3774,'el','Î‘Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÏƒÎºÎ¿Ï€ÏŒ',0),(135850,3774,'zh','åº“å­˜çš„ç›®çš„\r\n',0),(135851,3774,'sv','Stock syfte',0),(135852,3774,'it','Scopo di magazzino',0),(135853,3774,'tl','',0),(135854,3774,'th','&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3657;&#3634;&#3609;',0),(135855,3774,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤ªà¥à¤°à¤¯à¥‹à¤œà¤¨',0),(135856,3774,'ms','Maksud saham',0),(135857,3774,'ar','Ø§Ù„ØºØ±Ø¶ Ø§Ù„Ø£Ø³Ù‡Ù…',0),(135858,3774,'fr','Fin de stock',0),(135859,3774,'jp','åœ¨åº«ç›®çš„',0),(135860,3774,'pt','Finalidade das aÃ§Ãµes',0),(135861,3774,'ru','Ð¦ÐµÐ»ÑŒ Ñ„Ð¾Ð½Ð´Ð°',0),(135862,3774,'es','PropÃ³sito de Stoack',0),(135863,3774,'de','Hat Zweck',0),(135864,3774,'en','Stock Purpose',0),(135865,3775,'is','',0),(135866,3775,'dr','W2 ',0),(135867,3775,'pr','Ú†Ø§Ù¾ Ø§Ø·Ù„Ø§Ø¹Ø§Øª  W2 ',0),(135868,3775,'tr','W-2 bilgilerini yazdÄ±r',0),(135869,3775,'pl','Drukowanie informacji o W-2',0),(135870,3775,'bg','ÐŸÐµÑ‡Ð°Ñ‚ W-2 Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(135871,3775,'ur','W-2 Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(135872,3775,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ W-2',0),(135873,3775,'vi','ThÃ´ng Tin In W2',0),(135874,3775,'af','Druk W2 Inligting',0),(135875,3775,'ro','Imprimare W-2 informaÅ£ii',0),(135876,3775,'et','W-2 teabe printimiseks',0),(135877,3775,'si','Tiskanje podatkov W-2',0),(135878,3775,'ba','Mencetak informasi W-2',0),(135879,3775,'nl','W-2 gegevens afdrukken',0),(135880,3775,'fi','W-2 tietojen tulostaminen',0),(135881,3775,'no','Skrive ut W-2 informasjon',0),(135882,3775,'da','Udskrive W-2-oplysninger',0),(135883,3775,'ko','W-2 ì •ë³´ ì¸ì‡„',0),(135884,3775,'he','×”×“×¤×¡ ×ž×™×“×¢ ××•×“×•×ª W-2',0),(135885,3775,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ W-2',0),(135886,3775,'zh','W2ä¿¡æ¯æ‰“å°\r\n',0),(135887,3775,'sv','Skriva ut W-2 Information',0),(135888,3775,'it','Stampa informazioni W-2',0),(135889,3775,'tl','',0),(135890,3775,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621; W2',0),(135891,3775,'hi','W-2 à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(135892,3775,'ms','Cetak maklumat W-2',0),(135893,3775,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø«-2',0),(135894,3775,'fr','Imprimer les informations W-2',0),(135895,3775,'jp','ï¼·ï¼’æƒ…å ±ã?®å?°åˆ·',0),(135896,3775,'pt','Imprimir informaÃ§Ãµes de W-2',0),(135897,3775,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÐŸÐµÑ‡Ð°Ñ‚Ð¸ W2',0),(135898,3775,'es','Imprimir InformaciÃ³n de W2',0),(135899,3775,'de','W-2 Informationen drucken',0),(135900,3775,'en','Print W-2 Information',0),(135901,3776,'is','',0),(135902,3776,'dr','Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± ',0),(135903,3776,'pr','Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± ',0),(135904,3776,'tr','Worktypes',0),(135905,3776,'pl','Worktypes',0),(135906,3776,'bg','Worktypes',0),(135907,3776,'ur','ÙˆÙˆØ±Ú©ØªÛŒÙ¾Ø§Ø³',0),(135908,3776,'sr','WÐ¾Ñ€ÐºÑ‚yÐ¿ÐµÑ',0),(135909,3776,'vi','Loáº¡i cÃ´ng viá»‡c',0),(135910,3776,'af','Werktipes',0),(135911,3776,'ro','Worktypes',0),(135912,3776,'et','Worktypes',0),(135913,3776,'si','Worktypes',0),(135914,3776,'ba','Worktypes',0),(135915,3776,'nl','Worktypes',0),(135916,3776,'fi','Worktypes',0),(135917,3776,'no','Worktypes',0),(135918,3776,'da','Worktypes',0),(135919,3776,'ko','Worktypes',0),(135920,3776,'he','Worktypes',0),(135921,3776,'el','Worktypes',0),(135922,3776,'zh','å·¥ä½œç±»åž‹\r\n',0),(135923,3776,'sv','Worktypes',0),(135924,3776,'it','Worktypes',0),(135925,3776,'tl','',0),(135926,3776,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(135927,3776,'hi','Worktypes',0),(135928,3776,'ms','Worktypes',0),(135929,3776,'ar','ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠØ³',0),(135930,3776,'fr','Worktypes',0),(135931,3776,'jp','ä»•äº‹å†…å®¹',0),(135932,3776,'pt','Worktypes',0),(135933,3776,'ru','Ð¢Ð¸Ð¿Ñ‹ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(135934,3776,'es','Tipos de Trabajo',0),(135935,3776,'de','Worktypes',0),(135936,3776,'en','Worktypes',0),(135937,3777,'is','',0),(135938,3777,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(135939,3777,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(135940,3777,'tr','Ä°ÅŸleme',0),(135941,3777,'pl','Przetwarzanie',0),(135942,3777,'bg','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(135943,3777,'ur','Ø¹Ù…Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(135944,3777,'sr','ÐžÐ±Ñ€Ð°Ð´Ð°',0),(135945,3777,'vi','Äang Xá»­ lÃ½',0),(135946,3777,'af','Prosessering',0),(135947,3777,'ro','Prelucrare',0),(135948,3777,'et','TÃ¶Ã¶tlemine',0),(135949,3777,'si','Obdelava',0),(135950,3777,'ba','Pengolahan',0),(135951,3777,'nl','Verwerking',0),(135952,3777,'fi','KÃ¤sittely',0),(135953,3777,'no','Behandling',0),(135954,3777,'da','Behandling',0),(135955,3777,'ko','ì²˜ë¦¬',0),(135956,3777,'he','×ž×¢×‘×“',0),(135957,3777,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(135958,3777,'zh','å¤„ç†\r\n',0),(135959,3777,'sv','Bearbetning',0),(135960,3777,'it','Elaborazione',0),(135961,3777,'tl','',0),(135962,3777,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;',0),(135963,3777,'hi','à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(135964,3777,'ms','Pemprosesan',0),(135965,3777,'ar','Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª',0),(135966,3777,'fr','Traitement',0),(135967,3777,'jp','å‡¦ç?†ä¸­',0),(135968,3777,'pt','Processamento',0),(135969,3777,'ru','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(135970,3777,'es','Procesando',0),(135971,3777,'de','Verarbeitung',0),(135972,3777,'en','Processing',0),(135973,3778,'is','',0),(135974,3778,'dr','ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÙŠØ§Ù† ',0),(135975,3778,'pr','ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÙŠØ§Ù† ',0),(135976,3778,'tr','Kar & kaybÄ± - deyim',0),(135977,3778,'pl','Zysk & straty - instrukcja',0),(135978,3778,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð° & Ð·Ð°Ð³ÑƒÐ±Ð° - Ð´ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ',0),(135979,3778,'ur','Ù…Ù†Ø§ÙØ¹ & Ù†Ù‚ØµØ§Ù† - Ø¨ÛŒØ§Ù†',0),(135980,3778,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð°Ðº Ð¸ Ð³ÑƒÐ±Ð¸Ñ‚Ð°Ðº - Ð¸Ð·Ñ˜Ð°Ð²Ð°',0),(135981,3778,'vi','BÃ¡o cÃ¡o lá»i lá»—',0),(135982,3778,'af','Wins-en-Verlies Staat',0),(135983,3778,'ro','Profitul & pierdere - declaraÅ£ie',0),(135984,3778,'et','Kasum & kadu - avaldus',0),(135985,3778,'si','DobiÄek & izgubo - izjava',0),(135986,3778,'ba','Keuntungan & kerugian - pernyataan',0),(135987,3778,'nl','Winst & verlies - verklaring',0),(135988,3778,'fi','Voitto & tappio - ilmoitus',0),(135989,3778,'no','Fortjeneste & tap - setning',0),(135990,3778,'da','Profit & tab - erklÃ¦ring',0),(135991,3778,'ko','ì´ìµ & ì†ì‹¤-ë¬¸',0),(135992,3778,'he','×¨×•×•×— & ××•×‘×“×Ÿ - ×”×¦×”×¨×”',0),(135993,3778,'el','ÎšÎ­ÏÎ´Î¿Ï‚ & Î±Ï€ÏŽÎ»ÎµÎ¹Î± - Î´Î®Î»Ï‰ÏƒÎ·',0),(135994,3778,'zh','æŸç›Šè¡¨\r\n',0),(135995,3778,'sv','Vinst & fÃ¶rlust - uttalande',0),(135996,3778,'it','Profitto & perdita - istruzione',0),(135997,3778,'tl','',0),(135998,3778,'th','&#3591;&#3610;&#3585;&#3635;&#3652;&#3619;&#3586;&#3634;&#3604;&#3607;&#3640;&#3609;',0),(135999,3778,'hi','à¤²à¤¾à¤­ & à¤¹à¤¾à¤¨à¤¿ - à¤µà¤•à¥à¤¤à¤µà¥à¤¯',0),(136000,3778,'ms','Keuntungan & kerugian - penyata',0),(136001,3778,'ar','ÙƒØ´Ù Ø§Ù„Ø£Ø±Ø¨Ø§Ø­ ÙˆØ§Ù„Ø®Ø³Ø§Ø¦Ø±',0),(136002,3778,'fr','Profit & perte - dÃ©claration',0),(136003,3778,'jp','æ??ç›Šè¨ˆç®—æ›¸',0),(136004,3778,'pt','Lucro & perda - instruÃ§Ã£o',0),(136005,3778,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ & Ð¿Ð¾Ñ‚ÐµÑ€Ð¸ - Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(136006,3778,'es','Estado de Resultados',0),(136007,3778,'de','Gewinn & Loss - Anweisung',0),(136008,3778,'en','Profit & Loss - Statement',0),(136009,3779,'is','',0),(136010,3779,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³Ù†Ø¯ ',0),(136011,3779,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³Ù†Ø¯ ',0),(136012,3779,'tr','DÃ¼zeltme geÃ§miÅŸi',0),(136013,3779,'pl','DowÃ³d historii',0),(136014,3779,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(136015,3779,'ur','Ø«Ø¨ÙˆØª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(136016,3779,'sr','Ð”Ð¾ÐºÐ°Ð· Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(136017,3779,'vi','Lá»‹ch sá»­ Báº£n in thá»­',0),(136018,3779,'af','Bewys geskiedenis',0),(136019,3779,'ro','Dovada istoriei',0),(136020,3779,'et','TÃµend ajalugu',0),(136021,3779,'si','Dokaz zgodovina',0),(136022,3779,'ba','Bukti sejarah',0),(136023,3779,'nl','Bewijs geschiedenis',0),(136024,3779,'fi','Koe historia',0),(136025,3779,'no','Bevis historie',0),(136026,3779,'da','Bevis historie',0),(136027,3779,'ko','ì¦ê±° ì—­ì‚¬',0),(136028,3779,'he','×”×•×›×—×” ×”×™×¡×˜×•×¨×™×”',0),(136029,3779,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(136030,3779,'zh','è¯æ˜ŽåŽ†å²\r\n',0),(136031,3779,'sv','Bevis historia',0),(136032,3779,'it','Prova di storia',0),(136033,3779,'tl','',0),(136034,3779,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(136035,3779,'hi','à¤¸à¤¬à¥‚à¤¤ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(136036,3779,'ms','Bukti sejarah',0),(136037,3779,'ar','Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(136038,3779,'fr','Histoire de preuve',0),(136039,3779,'jp','æ ¡æ­£å±¥æ­´',0),(136040,3779,'pt','Prova de histÃ³ria',0),(136041,3779,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸',0),(136042,3779,'es','Historia de Pruebas de ImpresiÃ³n',0),(136043,3779,'de','Beweis Geschichte',0),(136044,3779,'en','Proof History',0),(136045,3780,'is','',0),(136046,3780,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¶Ø¹ÙŠØª Ø¨Ø±Ø§ÙŠ Ø§Ø³Ù†Ø§Ø¯ Ø®Ø±ÙˆØ¬ÙŠ',0),(136047,3780,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¶Ø¹ÙŠØª Ø¨Ø±Ø§ÙŠ Ø§Ø³Ù†Ø§Ø¯ Ø®Ø±ÙˆØ¬ÙŠ',0),(136048,3780,'tr','SaÄŸlamalarÄ± iÃ§in durum raporu',0),(136049,3780,'pl','Raport dla dowodÃ³w',0),(136050,3780,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð·Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð°',0),(136051,3780,'ur','Ø­Ø§Ù„Øª Ø±Ù¾ÙˆØ±Ù¹ Ø¨Ø§ÛØ± Ø¯Ù„Ø§Ø¦Ù„ Ú©Û’ Ù„ÛŒÛ’',0),(136052,3780,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÑÑ‚Ð°Ñ‚ÑƒÑÑƒ Ð·Ð° Ð´Ð¾ÐºÐ°Ð·Ðµ.',0),(136053,3780,'vi','BÃ¡o cÃ¡o tÃ¬nh tráº¡ng ra Báº£n in thá»­',0),(136054,3780,'af','Status verslag vir proewe uit',0),(136055,3780,'ro','Raport pentru verificÄƒri afarÄƒ',0),(136056,3780,'et','Seisundi kohta tÃµendid lÃ¤bi',0),(136057,3780,'si','PoroÄilo o stanju za dokazila',0),(136058,3780,'ba','Laporan status untuk bukti keluar',0),(136059,3780,'nl','Statusrapport voor bewijzen uit',0),(136060,3780,'fi','Tilaraportti todisteita',0),(136061,3780,'no','Statusrapport for prÃ¸vetrykk ut',0),(136062,3780,'da','Statusrapport for beviser ud',0),(136063,3780,'ko','ë°–ìœ¼ë¡œ êµì •ì— ëŒ€ í•œ ìƒíƒœ ë³´ê³ ì„œ',0),(136064,3780,'he','×“×• ×— ×ž×¦×‘ ×œ×˜×™×•×˜×•×ª ×”×—×•×¦×”',0),(136065,3780,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î³Î¹Î± Î±Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ Î­Î¾Ï‰',0),(136066,3780,'zh','è¯æ˜Žå‡ºçŠ¶æ€æŠ¥å‘Š\r\n',0),(136067,3780,'sv','Statusrapport fÃ¶r preparerar ut',0),(136068,3780,'it','Rapporto di stato per le prove fuori',0),(136069,3780,'tl','',0),(136070,3780,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3629;&#3629;&#3585;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(136071,3780,'hi','à¤¬à¤¾à¤¹à¤° à¤¸à¤¬à¥‚à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(136072,3780,'ms','Laporan status bagi bukti-bukti Keluar',0),(136073,3780,'ar','ØªÙ‚Ø±ÙŠØ± Ø­Ø§Ù„Ø© Ù„Ù„Ø¨Ø±Ø§Ù‡ÙŠÙ† Ø¹Ù„Ù‰',0),(136074,3780,'fr','Rapport de situation pour les Ã©preuves sur',0),(136075,3780,'jp','Status Report for Proofs Out',0),(136076,3780,'pt','RelatÃ³rio de status para provas para fora',0),(136077,3780,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ð¸ Ð´Ð»Ñ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(136078,3780,'es','Informe de Status de Pruebas de ImpresiÃ³n Afuera',0),(136079,3780,'de','Statusbericht fÃ¼r Proofs',0),(136080,3780,'en','Status Report for Proofs Out',0),(136081,3781,'is','',0),(136082,3781,'dr','Ø³Ù†Ø¯ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(136083,3781,'pr','Ø³Ù†Ø¯ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(136084,3781,'tr','KanÄ±t dÃ¶ndÃ¼rdÃ¼',0),(136085,3781,'pl','Zwracane dowÃ³d',0),(136086,3781,'bg','Ð’Ñ€ÑŠÑ‰Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(136087,3781,'ur','Ø«Ø¨ÙˆØª Ù„ÙˆÙ¹ Ø¢Ø¦Û’',0),(136088,3781,'sr','Ð”Ð¾ÐºÐ°Ð· Ñ˜Ðµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾.',0),(136089,3781,'vi','HoÃ n láº¡i Báº£n in thá»­',0),(136090,3781,'af','Bewys teruggestuur',0),(136091,3781,'ro','Dovada a revenit',0),(136092,3781,'et','Tagastatud tÃµend',0),(136093,3781,'si','Vrnil dokaz',0),(136094,3781,'ba','Kembali bukti',0),(136095,3781,'nl','Geretourneerd bewijs',0),(136096,3781,'fi','Palasi todiste',0),(136097,3781,'no','Returnerte bevis',0),(136098,3781,'da','Returneret bevis',0),(136099,3781,'ko','ì¦ê±° ë°˜í™˜',0),(136100,3781,'he','×—×–×¨ ×”×•×›×—×”',0),(136101,3781,'el','Î•Ï€Î­ÏƒÏ„ÏÎµÏˆÎµ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î·',0),(136102,3781,'zh','è¿”å›žçš„è¯æ˜Ž\r\n',0),(136103,3781,'sv','Ã…tervÃ¤nde bevis',0),(136104,3781,'it','Restituito prova',0),(136105,3781,'tl','',0),(136106,3781,'th','&#3588;&#3639;&#3609;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(136107,3781,'hi','à¤¸à¤¬à¥‚à¤¤ à¤²à¥Œà¤Ÿà¥‡',0),(136108,3781,'ms','Kembali bukti',0),(136109,3781,'ar','Ø¹Ø§Ø¯ Ø¨Ø±Ù‡Ø§Ù†',0),(136110,3781,'fr','RetournÃ© une preuve',0),(136111,3781,'jp','è¿”å?´æ¸ˆæ ¡æ­£',0),(136112,3781,'pt','Retornou Ã  prova',0),(136113,3781,'ru','Ð’ÐµÑ€Ð½ÑƒÐ»ÑÑ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾',0),(136114,3781,'es','Prueba de ImpresiÃ³n Devuelta',0),(136115,3781,'de','Beweis zurÃ¼ckgegeben',0),(136116,3781,'en','Returned Proof',0),(136117,3782,'is','',0),(136118,3782,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø§Ø³Ù†Ø§Ø¯ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ùˆ Ø¨Ø±Ú¯Ø´ØªÙŠ  Ù‚Ø¨ÙˆÙ„  ÙŠØ§ Ø¨Ø§ ØªØºÙŠÙŠØ±Ø§Øª ',0),(136119,3782,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø§Ø³Ù†Ø§Ø¯ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ùˆ Ø¨Ø±Ú¯Ø´ØªÙŠ  Ù‚Ø¨ÙˆÙ„  ÙŠØ§ Ø¨Ø§ ØªØºÙŠÙŠØ±Ø§Øª ',0),(136120,3782,'tr','ParÃ§a saÄŸlamalarÄ± gÃ¶nderdi ve Tamam veya deÄŸiÅŸiklikler ile dÃ¶ner',0),(136121,3782,'pl','Dowody utwÃ³r wysÅ‚aÅ‚a i zwracana jest OK lub zmiany',0),(136122,3782,'bg','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð¸ Ð²Ñ€ÑŠÑ‰Ð° Ð´Ð¾Ð±Ñ€Ðµ Ð¸Ð»Ð¸ Ñ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(136123,3782,'ur','Ø¨Ú¾ÛŒØ¬ÛŒ Ø§ÙˆØ± Ù¹Ú¾ÛŒÚ© ÛÛ’ ÛŒØ§ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾ ÙˆØ§Ù¾Ø³ Ù¹Ø±ÛŒÚ© Ú©Û’ Ø¯Ù„Ø§Ø¦Ù„',0),(136124,3782,'sr','ÐŸÐ¾Ñ˜Ð°Ð¼ Ð´Ð¾ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÐ»Ð°Ð»Ð¸ Ð¸ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾ Ñƒ Ñ€ÐµÐ´Ñƒ Ð¸Ð»Ð¸ ÑÐ° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°Ð¼Ð°',0),(136125,3782,'vi','Theo dÃµi Báº£n in thá»­ Ä‘Ã£ gá»­i & hoÃ n láº¡i OK hay cÃ³ thay Ä‘á»•i',0),(136126,3782,'af','Baan proewe uitgestuur en teruggekeer OK of met veranderinge',0),(136127,3782,'ro','Dovezile piesa trimis ÅŸi Ã®ntors OK sau cu modificÄƒri',0),(136128,3782,'et','Pala tÃµestus saatis ja OK vÃµi muutusi tagasi',0),(136129,3782,'si','Skladbo dokazila poslala in vrnjen redu ali s spremembami',0),(136130,3782,'ba','Melacak bukti-bukti yang dikirim keluar dan kembali OK atau dengan perubahan',0),(136131,3782,'nl','Bewijzen verstuurd en keerde terug OK of met wijzigingen bijhouden',0),(136132,3782,'fi','Seurata todisteita lÃ¤hetti ja OK tai muutoksia',0),(136133,3782,'no','Spore bevis sendt ut og returnerte OK eller med endringer',0),(136134,3782,'da','Spore beviser sendt og returneret OK eller med Ã¦ndringer',0),(136135,3782,'ko','íŠ¸ëž™ êµì • ë°œì†¡ ë° í™•ì¸ ë˜ëŠ” ë³€ê²½ ë°˜í™˜',0),(136136,3782,'he','×ž×¢×§×‘ ××—×¨ ×”×’×”×•×ª ×©×œ×— ×•×—×–×¨ ×˜×•×‘ ××• ×¢× ×©×™× ×•×™×™×',0),(136137,3782,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹ Î´Î¿ÎºÎ¯Î¼Î¹Î± Î­ÏƒÏ„ÎµÎ¹Î»Îµ ÎºÎ±Î¹ ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ ÎµÎ½Ï„Î¬Î¾ÎµÎ¹ Î® Î¼Îµ Î±Î»Î»Î±Î³Î­Ï‚',0),(136138,3782,'zh','è·Ÿè¸ªå‘å‡ºçš„è¯æ˜Žå’Œè¿”å›žç¡®è®¤çš„è¯æ˜Žæˆ–æœ‰æ”¹åŠ¨çš„è¯æ˜Ž\r\n',0),(136139,3782,'sv','SpÃ¥ra preparerar skickas ut och Ã¥tervÃ¤nde OK eller med Ã¤ndringar',0),(136140,3782,'it','Pista prove inviati e restituito OK o con modifiche',0),(136141,3782,'tl','',0),(136142,3782,'th','&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;&#3649;&#3621;&#3632;&#3605;&#3585;&#3621;&#3591;&#3588;&#3639;&#3609;&#3627;&#3619;&#3639;&#3629;&#3',0),(136143,3782,'hi','à¤¬à¤¾à¤¹à¤° à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤”à¤° à¤ à¥€à¤• à¤¯à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤²à¥Œà¤Ÿà¥‡ à¤ªà¤Ÿà¤°à¥€ à¤¸à¤¬à¥‚à¤¤',0),(136144,3782,'ms','Mengesan bukti-bukti yang dihantar dan dikembalikan OK atau dengan perubahan',0),(136145,3782,'ar','ØªØªØ¨Ø¹ Ø§Ù„Ø¨Ø±Ø§Ù‡ÙŠÙ† Ø¨Ø¹Ø«Øª ÙˆØ¥Ø±Ø¬Ø§Ø¹ Ù…ÙˆØ§ÙÙ‚ Ø£Ùˆ Ù…Ø¹ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(136146,3782,'fr','Preuves de piste envoyÃ© et retournÃ© OK ou prÃ©sentant des changements',0),(136147,3782,'jp','ç™ºé€?æ¸ˆæ ¡æ­£ã?®ãƒˆãƒ©ãƒƒã‚¯ã?¨è¿”å?´æ¸ˆã?®å¤‰æ›´æœ‰ç„¡',0),(136148,3782,'pt','Provas de pista enviado e retornado OK ou com alteraÃ§Ãµes',0),(136149,3782,'ru','Ð¢Ñ€ÐµÐº Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð° Ñ€Ð°Ð·Ð¾ÑÐ»Ð°Ð» Ð¸ Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ ÐžÐš Ð¸Ð»Ð¸ Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸ÑÐ¼Ð¸',0),(136150,3782,'es','Pruebas de ImpresiÃ³n Track Enviadas OK o con Cargas',0),(136151,3782,'de','Nachverfolgen Sie Proofs, verschickt und wieder OK oder mit Ã„nderungen',0),(136152,3782,'en','Track Proofs Sent Out and Returned OK or with Changes',0),(136153,3783,'is','',0),(136154,3783,'dr','Ø«Ø¨Øª   Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ â€“ Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ â€“ Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§ â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª ',0),(136155,3783,'pr','Ø«Ø¨Øª   Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ â€“ Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ â€“ Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§ â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª ',0),(136156,3783,'tr','SatÄ±nalma sipariÅŸ giriÅŸ/gÃ¼ncelleÅŸtirme raporlarÄ± Ã¼rÃ¼nler - almak - POs yazdÄ±rma-',0),(136157,3783,'pl','Zakupu zamÃ³wienia wpis/aktualizacja - drukowanie POs - odbieranie towarÃ³w - raporty',0),(136158,3783,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ñ€ÐµÐ´ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ - Ð¿ÐµÑ‡Ð°Ñ‚ POs - Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚ ÑÑ‚Ð¾ÐºÐ¸ - Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(136159,3783,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ ØªØ±ØªÛŒØ¨ Ø§Ù†Ø¯Ø±Ø§Ø¬/Ø§Ù¾ ÚˆÛŒÙ¹ - Ù¾Ø±Ù†Ù¹ Ù¾ÙˆØ²ÛŒØ´Ù† - ÙˆØµÙˆÙ„ Ø³Ø§Ù…Ø§Ù† - Ø±Ù¾ÙˆØ±Ù¹',0),(136160,3783,'sr','Ð£Ð½Ð¾Ñ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ - ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐŸÐžÑ - Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼ Ñ€Ð¾Ð±Ðµ - Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(136161,3783,'vi','Nháº­p/Cáº­p Nháº­t ÄÆ¡n Mua HÃ ng - In  ÄÆ¡n Mua HÃ ng - Nháº­n HÃ ng - BÃ¡o CÃ¡o',0),(136162,3783,'af','Aankoopbestellingsinskrywing/Opdatering - Druk ABs - Ontvang Goedere - Verslae',0),(136163,3783,'ro','CumpÄƒrare ordine intrare/Update - imprimarea POs - primesc mÄƒrfuri - rapoarte',0),(136164,3783,'et','Kirje/uuendamise - printida POs - saab kaupa - aruanded',0),(136165,3783,'si','Nakup da vnos/posodobitev - tiskanje POs - prejema blaga - poroÄila',0),(136166,3783,'ba','Pembelian urutan entri/Update - cetak POs - menerima barang - laporan',0),(136167,3783,'nl','Aankoop Order Entry/Update - afdrukken POs - ontvangen goederen - verslagen',0),(136168,3783,'fi','Ostotilauksen merkintÃ¤/pÃ¤ivitys - tulosta POs - vastaanottaa tavaroita - raportit',0),(136169,3783,'no','KjÃ¸p oppfÃ¸ring/oppdateringen - utskrift POs - motta varer - rapporter',0),(136170,3783,'da','KÃ¸b Bestil post/Update - udskrive POs - modtage varer - rapporter',0),(136171,3783,'ko','êµ¬ë§¤ ì£¼ë¬¸ í•­ëª©/ì—…ë°ì´íŠ¸ ìƒí’ˆ-ë³´ê³ ì„œ ìˆ˜ì‹ -POs ì¸ì‡„-',0),(136172,3783,'he','×”×¨×›×™×©×” ×¡×“×¨ ×›× ×™×¡×”/×¢×“×›×•×Ÿ - ×”×“×¤×¡ POs - ×œ×§×‘×œ ×ž×•×¦×¨×™× - ×“×•×—×•×ª',0),(136173,3783,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· - ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· POs - Ï€Î±ÏÎ±Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ ÎµÎ¼Ï€Î¿ÏÎµÏÎ¼Î±Ï„Î± - ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(136174,3783,'zh','é‡‡è´­è®¢å•è¾“å…¥/æ›´æ–°- æ‰“å°é‡‡è´­è®¢å•-æ”¶è´§- æŠ¥å‘Š\r\n',0),(136175,3783,'sv','InkÃ¶p Order Entry/uppdatera - Skriv POs - fÃ¥ varor - rapporter',0),(136176,3783,'it','Inserimento/aggiornamento di ordine di acquisto - stampa POs - ricevere merci - rapporti',0),(136177,3783,'tl','',0),(136178,3783,'th','Purchase Order Entry/Update - Print POs - Receive Goods - Reports',0),(136179,3783,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤®à¤¾à¤² - à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ - POs à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚-',0),(136180,3783,'ms','Pembelian perintah kemasukan/Update - cetak POs - menerima barangan - Laporan',0),(136181,3783,'ar','Ø´Ø±Ø§Ø¡ Ù†Ø¸Ø§Ù… Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ«-Ø·Ø¨Ø§Ø¹Ø© Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹-Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ø¨Ø¶Ø§Ø¦Ø¹-Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ±',0),(136182,3783,'fr','Achat ordre saisie/mise Ã  jour - impression POs - recevoir des marchandises - rapports',0),(136183,3783,'jp','ç™ºæ³¨æ›¸ã?®ã‚¨ãƒ³ãƒˆãƒªãƒ¼/æ›´æ–°',0),(136184,3783,'pt','Entrada de ordem de compra/atualizaÃ§Ã£o - imprimir POs - receber mercadorias - relatÃ³rios',0),(136185,3783,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð·Ð°ÐºÐ°Ð·Ð° Ð·Ð°Ð¿Ð¸ÑÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ - Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ POs - Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð²Ð°Ñ€Ñ‹ - Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹',0),(136186,3783,'es','Orden de Compra Introducir/Actualizar - Imprimir OC - Recibir Bienes - Informes',0),(136187,3783,'de','Einkauf Bestellung Eintrag/Update - drucken POs - Ware - Berichte erhalten',0),(136188,3783,'en','Purchase Order Entry/Update - Print POs - Receive Goods - Reports',0),(136189,3784,'is','',0),(136190,3784,'dr','Ø®Ø±ÙŠØ¯ ÙƒØ±Ø¯Ù† ',0),(136191,3784,'pr','Ø®Ø±ÙŠØ¯ ÙƒØ±Ø¯Ù† ',0),(136192,3784,'tr','SatÄ±n alma',0),(136193,3784,'pl','Zakup',0),(136194,3784,'bg','Ð—Ð°ÐºÑƒÐ¿ÑƒÐ²Ð°Ð½Ðµ',0),(136195,3784,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(136196,3784,'sr','Ð—Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ',0),(136197,3784,'vi','Mua bÃ¡n ',0),(136198,3784,'af','Aankope',0),(136199,3784,'ro','De cumpÄƒrare',0),(136200,3784,'et','Ostmine',0),(136201,3784,'si','Nakup',0),(136202,3784,'ba','Pembelian',0),(136203,3784,'nl','Aankoop',0),(136204,3784,'fi','Ostaa',0),(136205,3784,'no','KjÃ¸pe',0),(136206,3784,'da','KÃ¸b',0),(136207,3784,'ko','êµ¬ë§¤',0),(136208,3784,'he','×¨×›×™×©×•×ª',0),(136209,3784,'el','Î‘Î³Î¿ÏÎ¬',0),(136210,3784,'zh','é‡‡è´­\r\n',0),(136211,3784,'sv','InkÃ¶p',0),(136212,3784,'it','L\'acquisto di',0),(136213,3784,'tl','',0),(136214,3784,'th','&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;',0),(136215,3784,'hi','à¤•à¥à¤°à¤¯',0),(136216,3784,'ms','Pembelian',0),(136217,3784,'ar','Ø§Ù„Ù…Ø´ØªØ±ÙŠØ§Øª',0),(136218,3784,'fr','Achat',0),(136219,3784,'jp','è³¼å…¥',0),(136220,3784,'pt','Compra',0),(136221,3784,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ°',0),(136222,3784,'es','Compras',0),(136223,3784,'de','Einkauf',0),(136224,3784,'en','Purchasing',0),(136225,3785,'is','',0),(136226,3785,'dr','Ù¾Ø§Ùƒ Ø³Ø§Ø²ÙŠ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù‚Ø¯ÙŠÙ…ÙŠ ',0),(136227,3785,'pr','Ù¾Ø§Ùƒ Ø³Ø§Ø²ÙŠ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù‚Ø¯ÙŠÙ…ÙŠ ',0),(136228,3785,'tr','Eski dosyalarÄ±nÄ± Temizleme',0),(136229,3785,'pl','UsunÄ…Ä‡ stare pliki',0),(136230,3785,'bg','ÐŸÑ€Ð¾Ð´ÑƒÑ…Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ñ€Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(136231,3785,'ur','Ù¾Ø±Ø§Ù†ÛŒ Ù…Ø³Ù„ÛŒÚº ØµØ§Ù Ú©Ø±ÛŒÚº',0),(136232,3785,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ ÑÑ‚Ð°Ñ€Ð¸Ñ… Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(136233,3785,'vi','Trá»¥c xuáº¥t há»“ sÆ¡ cÅ©',0),(136234,3785,'af','Verwyder Ou LÃªers',0),(136235,3785,'ro','CurÄƒÅ£a fiÅŸierele vechi',0),(136236,3785,'et','Puhasta vanad failid',0),(136237,3785,'si','Purge stare datoteke',0),(136238,3785,'ba','Membersihkan file lama',0),(136239,3785,'nl','Oude bestanden verwijderen',0),(136240,3785,'fi','Poista vanhat tiedostot',0),(136241,3785,'no','Slett gamle filer',0),(136242,3785,'da','Rense gamle filer',0),(136243,3785,'ko','ì˜¤ëž˜ ëœ íŒŒì¼ ì œê±°',0),(136244,3785,'he','×ž×—×§ ×œ×¦×ž×™×ª×•×ª ××ª ×”×§×‘×¦×™× ×”×™×©× ×™×',0),(136245,3785,'el','Î•ÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ· Ï€Î±Î»Î¹Î¬ Î±ÏÏ‡ÎµÎ¯Î±',0),(136246,3785,'zh','æ¸…é™¤æ—§æ–‡ä»¶\r\n',0),(136247,3785,'sv','Rensa gamla filer',0),(136248,3785,'it','Eliminare i file obsoleti',0),(136249,3785,'tl','',0),(136250,3785,'th','&#3585;&#3634;&#3619;&#3585;&#3635;&#3592;&#3633;&#3604;&#3652;&#3615;&#3621;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3585;&#3656;&#3634;',0),(136251,3785,'hi','à¤ªà¥à¤°à¤¾à¤¨à¥€ à¤«à¤¼à¤¾à¤‡à¤²à¥‹à¤‚ à¤•à¥‹ à¤ªà¤°à¥à¤œ',0),(136252,3785,'ms','Singkir fail lama',0),(136253,3785,'ar','Ø­Ø°Ù Ø§Ù„Ù…Ù„ÙØ§Øª Ø§Ù„Ù‚Ø¯ÙŠÙ…Ø©',0),(136254,3785,'fr','Purge des anciens fichiers',0),(136255,3785,'jp','å?¤ã?„ãƒ•ã‚¡ã‚¤ãƒ«ã‚’æ¶ˆåŽ»',0),(136256,3785,'pt','Limpar arquivos antigos',0),(136257,3785,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÑ‚Ð°Ñ€Ñ‹Ñ… Ñ„Ð°Ð¹Ð»Ð¾Ð²',0),(136258,3785,'es','Expurgar Archivos Viejos',0),(136259,3785,'de','Alte Dateien lÃ¶schen',0),(136260,3785,'en','Purge Old Files',0),(136261,3786,'is','',0),(136262,3786,'dr','Ù¾Ø§Ùƒ Ø³Ø§Ø²ÙŠ  ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù‚Ø¯ÙŠÙ…ÙŠ Ø¶Ù…ÙŠÙ…Ù‡ ÙƒØ§Ù„Ø§ ',0),(136263,3786,'pr','Ù¾Ø§Ùƒ Ø³Ø§Ø²ÙŠ  ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù‚Ø¯ÙŠÙ…ÙŠ Ø¶Ù…ÙŠÙ…Ù‡ ÙƒØ§Ù„Ø§ ',0),(136264,3786,'tr','GÃ¼ncel Ã¶ÄŸe eki dosyalarÄ±nÄ± Temizleme',0),(136265,3786,'pl','Przeczyszczanie plikÃ³w zaÅ‚Ä…cznikÃ³w element nieaktualne',0),(136266,3786,'bg','Ð§Ð¸ÑÑ‚ÐºÐ° Ð½Ð° Ð¾ÑÑ‚Ð°Ñ€ÐµÐ»Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ñ€Ð¸ÐºÐ°Ñ‡ÐµÐ½Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(136267,3786,'ur','Ù¾Ø±Ø§Ù†ÛŒ Ø´Û’ Ù…Ù†Ø³Ù„Ú©Û Ù…Ø³Ù„ÛŒÚº ØµØ§Ù Ú©Ø±ÛŒÚº',0),(136268,3786,'sr','ÐžÑ‡Ð¸ÑÑ‚Ð¸ Ð·Ð°ÑÑ‚Ð°Ñ€Ñ˜ÐµÐ»Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¿Ñ€Ð¸Ð»Ð¾Ð³ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(136269,3786,'vi','Trá»¥c xuáº¥t nhá»¯ng há»“ sÆ¡ hÃ ng háº¿t háº¡n kÃ¨m theo',0),(136270,3786,'af','Verwyder Buite-Datum Item Aangehegte LÃªers',0),(136271,3786,'ro','Epurare expiratÄƒ element ataÅŸament fiÅŸiere',0),(136272,3786,'et','Kustuta aegunud kirje manusfailid',0),(136273,3786,'si','Odstrani zastarele postavka priponko datotek',0),(136274,3786,'ba','Membersihkan file lampiran Item basi',0),(136275,3786,'nl','Verouderde Item bijlagebestanden verwijderen',0),(136276,3786,'fi','Vanhentunut erÃ¤ Liitetiedostojen poistaminen',0),(136277,3786,'no','Slett foreldet elementet vedleggsfiler',0),(136278,3786,'da','Rense forÃ¦ldet vare vedhÃ¦ftede filer',0),(136279,3786,'ko','ì˜¤ëž˜ ëœ í•­ëª© ì²¨ë¶€ íŒŒì¼ ì œê±°',0),(136280,3786,'he','×œ× ×§×•×ª ×§×‘×¦×™× ×ž×¦×•×¨×¤×™× ×¤×¨×™×˜ ×œ× ×ž×¢×•×“×›× ×ª',0),(136281,3786,'el','Î•ÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ· Î¼Î· ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÏ…Î½Î·Î¼Î¼Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î±',0),(136282,3786,'zh','æ¸…é™¤è¿‡æœŸç‰©å“é™„ä»¶æ–‡ä»¶\r\n',0),(136283,3786,'sv','Rensa inaktuella objekt bifogade filer',0),(136284,3786,'it','Eliminare i file allegati non aggiornate elemento',0),(136285,3786,'tl','',0),(136286,3786,'th','&#3585;&#3635;&#3592;&#3633;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3657;&#3634;&#3626;&#3617;&#3633;&#3618;&#3607;&#3637;&#3656;&#3649;&#3609;&#3610;&#3617;&#3634;&#3585;&#3633;&#3610;&#3652;&#3615;&#3621;&#3660;',0),(136287,3786,'hi','à¤ªà¥à¤°à¤¾à¤¨à¥‡ à¤†à¤‡à¤Ÿà¤® à¤…à¤¨à¥à¤²à¤—à¥à¤¨à¤• à¤«à¤¼à¤¾à¤‡à¤²à¥‹à¤‚ à¤•à¥‹ à¤ªà¤°à¥à¤œ',0),(136288,3786,'ms','Singkir fail lampiran Item telah luput tarikh',0),(136289,3786,'ar','Ø¥Ø²Ø§Ù„Ø© Ù…Ù„ÙØ§Øª Ø§Ù„Ù…Ø±ÙÙ‚Ø§Øª Ø§Ù„Ø¨Ù†Ø¯ Ù‚Ø¯ÙŠÙ…Ø©',0),(136290,3786,'fr','Purge des fichiers de piÃ¨ce jointe d\'Ã©lÃ©ment obsolÃ¨tes',0),(136291,3786,'jp','æœŸé™?åˆ‡ã‚Œå“?ç›®ã?®æ·»ä»˜ãƒ•ã‚¡ã‚¤ãƒ«ã‚’æ¶ˆåŽ»ã?™ã‚‹',0),(136292,3786,'pt','Limpar arquivos desatualizados Item de acessÃ³rio',0),(136293,3786,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ° ÑƒÑÑ‚Ð°Ñ€ÐµÐ²ÑˆÐµÐ³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð²Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ñ„Ð°Ð¹Ð»Ð¾Ð²',0),(136294,3786,'es','Expurgar Archivos Anticuados de Apego de Item',0),(136295,3786,'de','Veraltete Element-Attachment-Dateien lÃ¶schen',0),(136296,3786,'en','Purge Out-of-Date Item Attachment Files',0),(136297,3787,'is','',0),(136298,3787,'dr','Ø¬Ø¯ÙˆÙ„ ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(136299,3787,'pr','Ø¬Ø¯ÙˆÙ„ ØªÙˆØ¶ÙŠØ­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(136300,3787,'tr','AlÄ±ntÄ± yorum tablosu',0),(136301,3787,'pl','Cytat komentarz tabeli',0),(136302,3787,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(136303,3787,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ ØªØ¨ØµØ±Û Ø¬Ø¯ÙˆÙ„',0),(136304,3787,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(136305,3787,'vi','Báº£ng Nháº­n xÃ©t bÃ¡o giÃ¡',0),(136306,3787,'af','Haal Opmerking Tabel Aan',0),(136307,3787,'ro','Tabel de comentariu citat',0),(136308,3787,'et','Quote Comment tabel',0),(136309,3787,'si','Citiram komentar tabele',0),(136310,3787,'ba','Mengutip komentar tabel',0),(136311,3787,'nl','Offerte commentaar tabel',0),(136312,3787,'fi','Lainaus kommenttitaulu',0),(136313,3787,'no','Tilbud Merknad-tabellen',0),(136314,3787,'da','Citat bemÃ¦rkningstabellen',0),(136315,3787,'ko','ì¸ìš© ì½”ë©˜íŠ¸ í…Œì´ë¸”',0),(136316,3787,'he','×¦×™×˜×•×˜ ×ª×’×•×‘×” ×˜×‘×œ×”',0),(136317,3787,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï„Î¿ ÏƒÏ‡ÏŒÎ»Î¹Î¿ Ï„Î¿Ï… Ï€Î¯Î½Î±ÎºÎ±',0),(136318,3787,'zh','æŠ¥ä»·è¯„è®ºè¡¨\r\n',0),(136319,3787,'sv','Citera kommentar tabell',0),(136320,3787,'it','Citazione commento tabella',0),(136321,3787,'tl','',0),(136322,3787,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3649;&#3592;&#3657;&#3591;&#3588;&#3635;&#3605;&#3636;&#3594;&#3617;',0),(136323,3787,'hi','à¤¬à¥‹à¤²à¥€ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(136324,3787,'ms','Quote komen Jadual',0),(136325,3787,'ar','Ø¬Ø¯ÙˆÙ„ ØªØ¹Ù‚ÙŠØ¨Ø§Øª Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(136326,3787,'fr','Citation commentaire Table',0),(136327,3787,'jp','è¦‹ç©?ã‚‚ã‚Šã?«è¨˜è¼‰ã?®ã‚³ãƒ¡ãƒ³ãƒˆãƒªã‚¹ãƒˆ',0),(136328,3787,'pt','Tabela do comentÃ¡rio de citaÃ§Ã£o',0),(136329,3787,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(136330,3787,'es','CotizaciÃ³n Tabla de Comentario',0),(136331,3787,'de','Zitat von Kommentar-Tabelle',0),(136332,3787,'en','Quote Comment Table',0),(136333,3788,'is','',0),(136334,3788,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(136335,3788,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(136336,3788,'tr','TÄ±rnak iÅŸaretleri',0),(136337,3788,'pl','Cytaty',0),(136338,3788,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð¸',0),(136339,3788,'ur','ÙˆØ§ÙˆÛŒÙ†',0),(136340,3788,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ðµ',0),(136341,3788,'vi','BÃ¡o giÃ¡',0),(136342,3788,'af','Kwotasies',0),(136343,3788,'ro','Citate',0),(136344,3788,'et','Tsitaadid',0),(136345,3788,'si','Ponudbe',0),(136346,3788,'ba','Kutipan',0),(136347,3788,'nl','Citaten',0),(136348,3788,'fi','Lainauksia',0),(136349,3788,'no','Sitater',0),(136350,3788,'da','Citater',0),(136351,3788,'ko','ë”°ì˜´í‘œ',0),(136352,3788,'he','×”×¦×¢×•×ª ×ž×—×™×¨',0),(136353,3788,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(136354,3788,'zh','æŠ¥ä»·\r\n',0),(136355,3788,'sv','Citat',0),(136356,3788,'it','Citazioni',0),(136357,3788,'tl','',0),(136358,3788,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;',0),(136359,3788,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£',0),(136360,3788,'ms','Sebut harga',0),(136361,3788,'ar','Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(136362,3788,'fr','Citations',0),(136363,3788,'jp','è¦‹ç©?ã‚‚ã‚Š',0),(136364,3788,'pt','CotaÃ§Ãµes',0),(136365,3788,'ru','ÐšÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(136366,3788,'es','Cotizaciones',0),(136367,3788,'de','Zitate',0),(136368,3788,'en','Quotes',0),(136369,3789,'is','',0),(136370,3789,'dr','Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‡Ø§',0),(136371,3789,'pr','Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‡Ø§',0),(136372,3789,'tr','Derecelendirme Ã¶lÃ§eÄŸi iÃ§in deÄŸerlendirmeleri',0),(136373,3789,'pl','Ocena skali ocen',0),(136374,3789,'bg','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³Ð¾Ð²Ð° ÑÐºÐ°Ð»Ð° Ð·Ð° Ð¾Ñ‚Ð·Ð¸Ð²Ð°',0),(136375,3789,'ur','Ø¬Ø§Ø¦Ø²Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ù¾ÛŒÙ…Ø§Ù†Û',0),(136376,3789,'sr','Ð¡ÐºÐ°Ð»Ð° Ð·Ð° ÐºÑ€Ð¸Ñ‚Ð¸ÐºÐµ',0),(136377,3789,'vi','Thang giÃ¡ Ä‘á»ƒ xem xÃ©t',0),(136378,3789,'af','Gradering skaal vir resensies',0),(136379,3789,'ro','Scala de evaluare pentru clienÅ£i',0),(136380,3789,'et','Hindamisskaala arvustust',0),(136381,3789,'si','Ocenjevalna lestvica za Ocene',0),(136382,3789,'ba','Skala rating untuk ulasan',0),(136383,3789,'nl','Beoordelingsschaal voor beoordelingen',0),(136384,3789,'fi','Arviointiasteikko arvioon',0),(136385,3789,'no','Vurderingsskala for vurderinger',0),(136386,3789,'da','BedÃ¸mmelsesskala for anmeldelser',0),(136387,3789,'ko','ë¦¬ë·°ì— ëŒ€ í•œ í‰ê°€ ì²™ë„',0),(136388,3789,'he','×¡×•×œ× ×“×™×¨×•×’ ×¡×§×™×¨×•×ª',0),(136389,3789,'el','ÎšÎ»Î¯Î¼Î±ÎºÎ± Î´Î¹Î±Î²Î¬Î¸Î¼Î¹ÏƒÎ·Ï‚ Î³Î¹Î± ÏƒÏ‡ÏŒÎ»Î¹Î±',0),(136390,3789,'zh','å¤å®¡çš„è¯„å®šé‡è¡¨\r\n',0),(136391,3789,'sv','Skattningsskala fÃ¶r recensioner',0),(136392,3789,'it','Scala di valutazione per le recensioni',0),(136393,3789,'tl','',0),(136394,3789,'th','&#3626;&#3648;&#3585;&#3621;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3648;&#3614;&#3639;&#3656;&#3629;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;',0),(136395,3789,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥ˆà¤®à¤¾à¤¨à¥‡ à¤ªà¤° à¤°à¥‡à¤Ÿà¤¿à¤‚à¤—',0),(136396,3789,'ms','Skala penilaian untuk Ulasan',0),(136397,3789,'ar','Ù…Ù‚ÙŠØ§Ø³ ØªØµÙ†ÙŠÙ Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(136398,3789,'fr','Ã‰chelle d\'Ã©valuation de clients',0),(136399,3789,'jp','èª¿æŸ»ã?®è©•å®šå°ºåº¦',0),(136400,3789,'pt','Escala de classificaÃ§Ã£o avaliaÃ§Ãµes',0),(136401,3789,'ru','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³Ð¾Ð²Ð°Ñ ÑˆÐºÐ°Ð»Ð° Ð·Ð° Ð¾Ñ‚Ð·Ñ‹Ð²Ñ‹',0),(136402,3789,'es','Escala de ValuaciÃ³n para RevisiÃ³n',0),(136403,3789,'de','Rating-Skala fÃ¼r Bewertungen',0),(136404,3789,'en','Rating Scale for Reviews',0),(136405,3790,'is','',0),(136406,3790,'dr','Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¬Ø§ÙŠÙŠ  ÙƒÙ‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(136407,3790,'pr','Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¬Ø§ÙŠÙŠ  ÙƒÙ‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(136408,3790,'tr','ÃœrÃ¼n stok satÄ±nalma sipariÅŸinin oluÅŸturulduÄŸu almak',0),(136409,3790,'pl','OtrzymujÄ… elementy do magazynu, gdzie utworzyÄ‡ zamÃ³wienia zakupu',0),(136410,3790,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð² ÑÐºÐ»Ð°Ð´Ð°, ÐºÑŠÐ´ÐµÑ‚Ð¾ ÑÑŠÐ·Ð´Ð°Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(136411,3790,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©Ø±ÛŒÚº Ø¬ÛØ§Úº Ø¨Ù†Ø§Ø¦ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…ÛŒÚº Ù…ÙˆØµÙˆÙ„',0),(136412,3790,'sr','ÐŸÑ€Ð¸Ð¼Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°, Ð³Ð´Ðµ Ñ˜Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ',0),(136413,3790,'vi','Nháº­n VÃ o Danh Má»¥c HÃ ng Trong Kho Khi ÄÆ¡n Mua HÃ ng ÄÆ°á»£c Táº¡o Ra',0),(136414,3790,'af','Ontvang Items in Voorraad waar Aankoopbestelling Geskep is',0),(136415,3790,'ro','Primi elemente Ã®n inventar Ã®n cazul Ã®n care comanda de cumpÄƒrare creat',0),(136416,3790,'et','Saada kirjed kus ostutellimuse loonud varudesse',0),(136417,3790,'si','Prevzemati artikle v zalogo, naroÄilnico, kjer ustvari',0),(136418,3790,'ba','Menerima barang-barang dalam persediaan yang mana pesanan pembelian dibuat',0),(136419,3790,'nl','Artikelen in de voorraad waar inkooporder gemaakt ontvangen',0),(136420,3790,'fi','NimikkeitÃ¤ vastaanotetaan varastoon, jossa luo tilauksen',0),(136421,3790,'no','Motta varer pÃ¥ lageret der bestillingen opprettet',0),(136422,3790,'da','Modtage varer pÃ¥ lageret, hvor indkÃ¸bsordren oprettes',0),(136423,3790,'ko','ìž¬ê³  êµ¬ë§¤ ì£¼ë¬¸ì„œ ìž‘ì„±ìœ¼ë¡œ ìƒí’ˆì„ ë°›ê²Œ',0),(136424,3790,'he','×§×‘×œ×ª ×¤×¨×™×˜×™× ×œ×ª×•×š ×”×ž×œ××™ ×©×‘×• × ×•×¦×¨×ª ×”×–×ž× ×ª ×”×¨×›×©',0),(136425,3790,'el','Î›Î¬Î²ÎµÏ„Îµ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏ„Î¿ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ ÏŒÏ€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(136426,3790,'zh','æŽ¥æ”¶é¡¹ç›®åˆ°é‡‡è´­è®¢å•å·²åˆ›å»ºçš„åº“å­˜\r\n',0),(136427,3790,'sv','Ta emot objekt i lagret dÃ¤r inkÃ¶psorder skapas',0),(136428,3790,'it','Ricevere articoli in magazzino dove acquisto ordine creato',0),(136429,3790,'tl','',0),(136430,3790,'th','Receive Items into Inventory where Purchase Order Created',0),(136431,3790,'hi','à¤œà¤¹à¤¾à¤‚ à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(136432,3790,'ms','Menerima barang ke dalam inventori di mana pembelian perintah dicipta',0),(136433,3790,'ar','Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ø£ØµÙ†Ø§Ù ÙÙŠ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø­ÙŠØ« ØªÙ… Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ø´Ø±Ø§Ø¡',0),(136434,3790,'fr','RÃ©ception des articles en stock, oÃ¹ le bon de commande crÃ©Ã©, en',0),(136435,3790,'jp','è³¼å…¥æ³¨æ–‡ã?Œä½œæˆ?ã?•ã‚Œã?Ÿåœ¨åº«ã?¸å“?ç›®ã‚’å?—é ˜',0),(136436,3790,'pt','Receber itens em estoque, onde criou a ordem de compra',0),(136437,3790,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ñ‹ Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€ÑŒ, Ð³Ð´Ðµ ÑÐ¾Ð·Ð´Ð°Ð½ Ð·Ð°ÐºÐ°Ð· Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(136438,3790,'es','Recibir Items en Inventario en donde se Crearon Ordenes de Compra',0),(136439,3790,'de','Erhalten Sie Artikel, ins Lager, wo die Bestellung erzeugt',0),(136440,3790,'en','Receive Items into Inventory where Purchase Order Created',0),(136441,3791,'is','',0),(136442,3791,'dr','Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¬Ø§ÙŠÙŠ  ÙƒÙ‡ Ù‡ÙŠÚ†  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(136443,3791,'pr','Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¬Ø§ÙŠÙŠ  ÙƒÙ‡ Ù‡ÙŠÚ†  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(136444,3791,'tr','HÄ°Ã‡BÄ°R satÄ±n alma sipariÅŸi oluÅŸturuldu nerede Ã¼rÃ¼n stok almak',0),(136445,3791,'pl','OtrzymujÄ… elementy do magazynu, gdzie nie utworzono zamÃ³wienie zakupu',0),(136446,3791,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð² ÑÐºÐ»Ð°Ð´Ð°, ÐºÑŠÐ´ÐµÑ‚Ð¾ Ðµ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(136447,3791,'ur','Ø§Ø´ÛŒØ§Ø¡ Ù†ÛÛŒÚº Ø®Ø±ÛŒØ¯ ØªØ±ØªÛŒØ¨ Ø¨Ù†Ø§Ø¦ÛŒ Ú¯Ø¦ÛŒ Ø¬ÛØ§Úº Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…ÛŒÚº Ù…ÙˆØµÙˆÙ„',0),(136448,3791,'sr','ÐŸÑ€Ð¸Ð¼Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°, Ð³Ð´Ðµ Ð½ÐµÐ¼Ð° Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð¾',0),(136449,3791,'vi','Nháº­n VÃ o Danh Má»¥c HÃ ng Trong Kho Khi KhÃ´ng CÃ³ ÄÆ¡n Mua HÃ ng ÄÆ°á»£c Táº¡o Ra',0),(136450,3791,'af','Ontvang Items in Voorraad waar GEEN Aankoopbestelling Geskep is nie',0),(136451,3791,'ro','Primi elemente Ã®n inventar, Ã®n cazul Ã®n care nu creat de ordine de cumpÄƒrare',0),(136452,3791,'et','Saada kirjed varudesse kui Ã¼htegi ostu tellimus loodud',0),(136453,3791,'si','Prevzemati artikle v zalogo, kjer ni ustvarjeno nabavni nalog',0),(136454,3791,'ba','Menerima item ke inventori mana dibuat tidak ada Order Pembelian',0),(136455,3791,'nl','Artikelen in de voorraad ontvangen indien geen aankoop Order gemaakt',0),(136456,3791,'fi','NimikkeitÃ¤ vastaanotetaan varastoon, jos ei ole osto Tilaus luotu',0),(136457,3791,'no','Motta varer pÃ¥ lageret der ingen KjÃ¸p ordre opprettet',0),(136458,3791,'da','Modtage varer pÃ¥ lageret, hvor ingen KÃ¸b ordre oprettet',0),(136459,3791,'ko','ì–´ë”” ì•„ë‹ˆ êµ¬ë§¤ ì£¼ë¬¸ ìƒì„± ì¸ë²¤í† ë¦¬ë¡œ ìƒí’ˆì„ ë°›ê²Œ',0),(136460,3791,'he','×§×‘×œ×ª ×¤×¨×™×˜×™× ×œ×ª×•×š ×”×ž×œ××™ ×©×‘×• × ×•×¦×¨ ×¡×“×¨ ××™×Ÿ ×¨×›×™×©×”',0),(136461,3791,'el','Î›Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÎµ Î±Ï€Î¿Î³ÏÎ±Ï†Î® ÏŒÏ€Î¿Ï… Î´ÎµÎ½ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(136462,3791,'zh','æŽ¥æ”¶é¡¹ç›®åˆ°é‡‡è´­è®¢å•æœªåˆ›å»ºçš„åº“å­˜\r\n',0),(136463,3791,'sv','Inleverera artiklar i lagret dÃ¤r inga kÃ¶p ordning skapad',0),(136464,3791,'it','Ricevere articoli in magazzino dove nessun acquisto ordine creato',0),(136465,3791,'tl','',0),(136466,3791,'th','Receive Items into Inventory where NO Purchase Order Created',0),(136467,3791,'hi','à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤œà¤¹à¤¾à¤‚ à¤•à¥‹à¤ˆ à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(136468,3791,'ms','Menerima barang ke dalam inventori di mana tiada pembelian perintah dicipta',0),(136469,3791,'ar','Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ø£ØµÙ†Ø§Ù ÙÙŠ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø­ÙŠØ« Ù„Ø§ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(136470,3791,'fr','RÃ©ception des articles en stock lorsqu\'aucune crÃ©ation de commande achat',0),(136471,3791,'jp','è³¼å…¥æ³¨æ–‡ã?Œä½œæˆ?ã?•ã‚Œã?¦ã?„ã?ªã?„åœ¨åº«ã?¸å“?ç›®ã‚’å?—é ˜',0),(136472,3791,'pt','Receber itens em estoque, onde nenhum criado de ordem de compra',0),(136473,3791,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð²Ð°Ñ€Ñ‹ Ð½Ð° ÑÐºÐ»Ð°Ð´, Ð³Ð´Ðµ Ð½Ðµ ÑÐ¾Ð·Ð´Ð°Ð½ Ð·Ð°ÐºÐ°Ð· Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(136474,3791,'es','Recibir Items en Inventario en donde NO se Crearon Ordenes de Compra',0),(136475,3791,'de','Artikel in den Bestand zu erhalten, wo keine kaufen Bestellung hergestellt',0),(136476,3791,'en','Receive Items into Inventory where NO Purchase Order Created',0),(136477,3792,'is','',0),(136478,3792,'dr','Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§Ù‡Ø§ Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(136479,3792,'pr','Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§Ù‡Ø§ Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(136480,3792,'tr','Maddeler iÃ§in PO alacaÄŸÄ±',0),(136481,3792,'pl','Odbieranie przedmiotÃ³w na PO',0),(136482,3792,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° PO',0),(136483,3792,'ur','Ù¾ÙˆØ³Ù¹ Ù¾Ø± Ø§Ø´ÛŒØ§ ÙˆØµÙˆÙ„ Ú©Ø±ÛŒÚº',0),(136484,3792,'sr','ÐŸÑ€Ð¸Ð¼Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ð½Ð° Ð¿Ð¾-Ð°',0),(136485,3792,'vi','Nháº­n hÃ ng trong Ä‘Æ¡n mua hÃ ng',0),(136486,3792,'af','Ontvang Items op AB',0),(136487,3792,'ro','Primi elemente pe PO',0),(136488,3792,'et','Ãœksuste PO',0),(136489,3792,'si','Prejmite elemente na PO',0),(136490,3792,'ba','Menerima barang di PO',0),(136491,3792,'nl','Ontvangen Items op PO',0),(136492,3792,'fi','Vastaanota nimikkeet PO',0),(136493,3792,'no','FÃ¥ elementer pÃ¥ PO',0),(136494,3792,'da','Modtage varer pÃ¥ PO',0),(136495,3792,'ko','ì‚¬ì„œí•¨ì— ìžˆëŠ” í•­ëª©ì„ ë°›ì„',0),(136496,3792,'he','×§×‘×œ×ª ×¤×¨×™×˜×™× ×¢×œ ×¤×•',0),(136497,3792,'el','Î›Î¬Î²ÎµÏ„Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏ„Î·Î½ PO',0),(136498,3792,'zh','æŽ¥æ”¶è®¢å•ä¸Šçš„é¡¹ç›®\r\n',0),(136499,3792,'sv','Ta emot objekt pÃ¥ PO',0),(136500,3792,'it','Ricevere articoli sul PO',0),(136501,3792,'tl','',0),(136502,3792,'th','&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3609;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(136503,3792,'hi','PO à¤ªà¤° à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(136504,3792,'ms','Menerima item pada PO',0),(136505,3792,'ar','Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ø£ØµÙ†Ø§Ù ÙÙŠ Ø¨Ùˆ',0),(136506,3792,'fr','Recevoir des articles sur la PO',0),(136507,3792,'jp','POã?®å“?ç›®ã‚’å?—é ˜',0),(136508,3792,'pt','Receber itens na PO',0),(136509,3792,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð²Ð°Ñ€Ñ‹ Ð½Ð° PO',0),(136510,3792,'es','Recibir Items en OC',0),(136511,3792,'de','Artikel auf Bestellung erhalten',0),(136512,3792,'en','Receive Items on PO',0),(136513,3793,'is','',0),(136514,3793,'dr','Ø¯Ø±ÙŠØ§ÙØª Ø¨Ø¯ÙˆÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(136515,3793,'pr','Ø¯Ø±ÙŠØ§ÙØª Ø¨Ø¯ÙˆÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(136516,3793,'tr','SipariÅŸ alma',0),(136517,3793,'pl','OtrzymaÄ‡ bez PO',0),(136518,3793,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚Ðµ Ð±ÐµÐ· PO',0),(136519,3793,'ur','Ø¨ØºÛŒØ± Ù¾Ùˆ ÙˆØµÙˆÙ„ Ú©Ø±ÛŒÚº',0),(136520,3793,'sr','ÐŸÑ€Ð¸Ð¼Ð¸Ñ‚Ð¸ Ð±ÐµÐ· ÐŸÐž',0),(136521,3793,'vi','Nháº­n khÃ´ng cÃ³ Ä‘Æ¡n mua hÃ ng',0),(136522,3793,'af','Ontvang Items Sonder AB',0),(136523,3793,'ro','Primi fÄƒrÄƒ PO',0),(136524,3793,'et','Vastu ilma PO',0),(136525,3793,'si','Prejeli brez PO',0),(136526,3793,'ba','Menerima tanpa PO',0),(136527,3793,'nl','Ontvangen zonder PO',0),(136528,3793,'fi','Vastaanottaa ilman PO',0),(136529,3793,'no','Motta uten PO',0),(136530,3793,'da','Modtag uden PO',0),(136531,3793,'ko','í¬ ì—†ì´ ìˆ˜ì‹ ',0),(136532,3793,'he','×œ×§×‘×œ ×ž×‘×œ×™ ×¤×•',0),(136533,3793,'el','Î›Î¬Î²ÎµÏ„Îµ Ï‡Ï‰ÏÎ¯Ï‚ PO',0),(136534,3793,'zh','å—æœªæœ‰è®¢å•çš„\r\n',0),(136535,3793,'sv','Utan PO',0),(136536,3793,'it','Ricevere senza PO',0),(136537,3793,'tl','',0),(136538,3793,'th','&#3619;&#3633;&#3610;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(136539,3793,'hi','PO à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(136540,3793,'ms','Menerima tanpa PO',0),(136541,3793,'ar','ØªÙ„Ù‚ÙŠ Ø¯ÙˆÙ† Ø¨Ùˆ',0),(136542,3793,'fr','Recevoir sans PO',0),(136543,3793,'jp','POã?ªã?—ã?§å?—é ˜',0),(136544,3793,'pt','Receber sem PO',0),(136545,3793,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ñ‚ÑŒ Ð±ÐµÐ· PO',0),(136546,3793,'es','Recibir Sin OC',0),(136547,3793,'de','Erhalten, ohne PO',0),(136548,3793,'en','Receive Without PO',0),(136549,3794,'is','',0),(136550,3794,'dr','Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù„ÙŠØ³Øª ',0),(136551,3794,'pr','Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù„ÙŠØ³Øª ',0),(136552,3794,'tr','Listeyi yeniden yapma',0),(136553,3794,'pl','Wykonaj ponownie listÄ™',0),(136554,3794,'bg','Ð’ÑŠÑ€Ð½Ð¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(136555,3794,'ur','ÙÛØ±Ø³Øª Ú©Ø§ Ø§Ø¹Ø§Ø¯Û Ú©Ø±ÛŒÚº',0),(136556,3794,'sr','ÐŸÐ¾Ð½Ð°Ð²Ñ™Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ',0),(136557,3794,'vi','Danh sÃ¡ch lÃ m láº¡i',0),(136558,3794,'af','Oordoen lys',0),(136559,3794,'ro','Refacere lista',0),(136560,3794,'et','Tee uuesti loend',0),(136561,3794,'si','Uveljavi seznam',0),(136562,3794,'ba','Mengulang daftar',0),(136563,3794,'nl','Lijst opnieuw',0),(136564,3794,'fi','Tee luettelo',0),(136565,3794,'no','GjÃ¸r om listen',0),(136566,3794,'da','Redo liste',0),(136567,3794,'ko','ë‹¤ì‹œ ì‹¤í–‰ ëª©ë¡',0),(136568,3794,'he','×‘×¦×¢ ×©×•×‘ ×‘×¨×©×™×ž×”',0),(136569,3794,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· Î±Î½Î±Î¯ÏÎµÏƒÎ·Ï‚ Î»Î¯ÏƒÏ„Î±',0),(136570,3794,'zh','é‡åšåå•\r\n',0),(136571,3794,'sv','GÃ¶r om listan',0),(136572,3794,'it','Rifare la lista',0),(136573,3794,'tl','',0),(136574,3794,'th','&#3607;&#3635;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3627;&#3617;&#3656;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(136575,3794,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¥‹ à¤«à¤¿à¤° à¤¸à¥‡ à¤•à¤°à¥‡à¤‚',0),(136576,3794,'ms','Buat semula senarai',0),(136577,3794,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ù‚Ø§Ø¦Ù…Ø©',0),(136578,3794,'fr','Refaire la liste',0),(136579,3794,'jp','ã‚„ã‚Šç›´ã?—ãƒªã‚¹ãƒˆ',0),(136580,3794,'pt','Refazer a lista',0),(136581,3794,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(136582,3794,'es','Lista de Cosas Para Rehacer',0),(136583,3794,'de','Redo-Liste',0),(136584,3794,'en','Redo List',0),(136585,3795,'is','',0),(136586,3795,'dr','Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ú¯Ø²Ø§Ø±Ø´ â€“ Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ù„ÙŠØ³Øª ÙƒÙ†ÙŠØ¯ Ø¨Ø§ ÙŠÙƒ Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡',0),(136587,3795,'pr','Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ú¯Ø²Ø§Ø±Ø´ â€“ Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ù„ÙŠØ³Øª ÙƒÙ†ÙŠØ¯ Ø¨Ø§ ÙŠÙƒ Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡',0),(136588,3795,'tr','Liste gÃ¶steren emirleri ile belirli bir dÃ¶nemde bir yinele',0),(136589,3795,'pl','Lista zamÃ³wieÅ„ wyÅ›wietlone przerobiÄ‡ w danym okresie',0),(136590,3795,'bg','Ð¡Ð¿Ð¸ÑÑŠÐºÑŠÑ‚ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ñ Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð·Ð° Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð¾Ñ‚ Ð²Ñ€ÐµÐ¼Ðµ',0),(136591,3795,'ur','ÙÛØ±Ø³Øª Ø¯Ú©Ú¾Ø§Ù†Û’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ù…Ù‚Ø±Ø±Û Ù…Ø¯Øª Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ø§Ø¹Ø§Ø¯Û Ú©Ø±ÛŒÚº',0),(136592,3795,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÐ¾Ñ˜Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ ÑÐ° Ñ˜Ðµ Ð¿Ð¾Ð½Ð°Ð²Ñ™Ð°ÑšÐµ Ð·Ð° Ð´Ð°Ñ‚Ð¸ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(136593,3795,'vi','Danh sÃ¡ch nhá»¯ng Ä‘Æ¡n hÃ ng pháº£i cÃ³ hÃ ng lÃ m láº¡i trong 1 thá»i ká»³',0),(136594,3795,'af','Lys toon bestellings met \'n oordoen vir \'n gegewe tydperk',0),(136595,3795,'ro','Lista rezultate comenzi cu o refacere pentru o anumitÄƒ perioadÄƒ',0),(136596,3795,'et','Loendi kuvamine tellimusi uuesti teha teostanud',0),(136597,3795,'si','Seznam prikazuje naroÄila z uveljavi za dano obdobje',0),(136598,3795,'ba','Daftar menampilkan pesanan dengan mengulang untuk suatu periode tertentu',0),(136599,3795,'nl','Lijst weergegeven: Orders met een opnieuw gedurende een bepaalde periode',0),(136600,3795,'fi','Luettelo nÃ¤yttÃ¤Ã¤ tilaukset tee tietyn ajan',0),(136601,3795,'no','Listen viser ordrer med en gjÃ¸r om for en gitt periode',0),(136602,3795,'da','Listen viser ordrer med en Redo for en Given periode',0),(136603,3795,'ko','ì§€ì • ëœ ê¸°ê°„ ë™ì•ˆ ë‹¤ì‹œ ì‹¤í–‰ ëª©ë¡ í‘œì‹œ ëª…ë ¹',0),(136604,3795,'he','×¨×©×™×ž×ª ×”×–×ž× ×•×ª ×ž×¨××” ×¢× ×—×•×–×¨ ×¢×‘×•×¨ ×ª×§×•×¤×” × ×ª×•× ×”',0),(136605,3795,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î ÏÎ¿Î²Î¿Î»Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Î¼Îµ Î¼Î¹Î± ÎµÏ€Î±Î½Î¬Î»Î·ÏˆÎ· Î³Î¹Î± Î¼Î¹Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î· Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(136606,3795,'zh','åå•æ˜¾ç¤ºè§„å®šæ—¶é—´å†…é‡åšçš„è®¢å•\r\n',0),(136607,3795,'sv','Listan visar order med en Redo fÃ¶r en Given Period',0),(136608,3795,'it','Elenco visualizzando ordini con una ripetizione per un determinato periodo',0),(136609,3795,'tl','',0),(136610,3795,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3626;&#3604;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3635;&#3651;&#3627;&#3617;&#3656;&#3586;&#3629;&#3591;&#3594;&#3656;&#3623;&#3591;&#3609;&#3637;&#3657;',0),(136611,3795,'hi','à¤¸à¥‚à¤šà¥€ à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¤¿à¤¸à¥€ à¤¦à¥€ à¤—à¤ˆ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤«à¤¿à¤° à¤¸à¥‡ à¤•à¤°à¥‡à¤‚',0),(136612,3795,'ms','Senarai yang menunjukkan perintah dengan buat semula untuk tempoh tertentu',0),(136613,3795,'ar','Ø£ÙˆØ§Ù…Ø± Ø¥Ø¸Ù‡Ø§Ø± Ù‚Ø§Ø¦Ù…Ø© Ù…Ø¹ Ø¥Ø¹Ø§Ø¯ØªÙ‡ Ù„ÙØªØ±Ø© Ù…Ø¹ÙŠÙ†Ø©',0),(136614,3795,'fr','Commandes affichage liste avec une restauration par progression pendant une pÃ©riode donnÃ©e',0),(136615,3795,'jp','ä¸Žã?ˆã‚‰ã‚Œã?ŸæœŸé–“ã?®ã‚„ã‚Šç›´ã?—ã?®ã?‚ã?£ã?Ÿæ³¨æ–‡ã‚’è¡¨ç¤ºã?™ã‚‹ãƒªã‚¹ãƒˆ',0),(136616,3795,'pt','Lista apresentando as ordens com um refazer para um determinado perÃ­odo',0),(136617,3795,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½Ñ‹ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ñ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð° Ð·Ð° Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´.',0),(136618,3795,'es','Lista Mostrando Ordenes con Rehacer para un PerÃ­odo Dado',0),(136619,3795,'de','Liste Ergebnis AuftrÃ¤ge mit einem Redo fÃ¼r einen bestimmten Zeitraum',0),(136620,3795,'en','List Showing Orders with a Redo for a Given Period',0),(136621,3796,'is','',0),(136622,3796,'dr','ØªØ®ÙÙŠÙØ§Øª Ù…Ø¹ÙŠÙ†  Ø§Ø² Ø­Ù‚ÙˆÙ‚  ÙƒØ§Ø±Ù…Ù†Ø¯ Ú¯Ø±ÙØªÙ‡ Ø´ÙˆØ¯ ',0),(136623,3796,'pr','ØªØ®ÙÙŠÙØ§Øª Ù…Ø¹ÙŠÙ†  Ø§Ø² Ø­Ù‚ÙˆÙ‚  ÙƒØ§Ø±Ù…Ù†Ø¯ Ú¯Ø±ÙØªÙ‡ Ø´ÙˆØ¯ ',0),(136624,3796,'tr','Ã‡alÄ±ÅŸanÄ±n Ã¶deme yapÄ±lacak dÃ¼zenli kesintiler',0),(136625,3796,'pl','Regularne odliczeÅ„ od pracownika pÅ‚aci',0),(136626,3796,'bg','Ð ÐµÐ´Ð¾Ð²Ð½Ð¸ ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸ Ð¾Ñ‚ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚',0),(136627,3796,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ø§Ø¯Ø§ Ø³Û’ Ù„Û’ Ù„ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú©Û’ Ù„Ø¦Û’ Ø¨Ø§Ù‚Ø§Ø¹Ø¯Û Ú©Ù¹ÙˆØªÛŒ',0),(136628,3796,'sr','Ð ÐµÐ´Ð¾Ð²Ð½Ðµ Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ Ð±ÑƒÐ´Ðµ Ð¾Ð´ÑƒÐ·ÐµÑ‚ Ð¿Ð»Ð°Ñ‚Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(136629,3796,'vi','Giáº£m trá»« thÆ°á»ng ká»³ trong lÆ°Æ¡ng nhÃ¢n viÃªn',0),(136630,3796,'af','Gereelde Aftrekkings wat Afgetrek moet word van Werknemer Besoldiging',0),(136631,3796,'ro','Deduceri regulate pentru a fi luate de la angajat plÄƒti',0),(136632,3796,'et','Regulaarne mahaarvamiste vÃµetakse tÃ¶Ã¶taja maksma',0),(136633,3796,'si','Redne odbitki od delavca plaÄa odvzame',0),(136634,3796,'ba','Pengurangan biasa diambil daripada membayar karyawan',0),(136635,3796,'nl','Regelmatige aftrek te nemen van werknemer betalen',0),(136636,3796,'fi','SÃ¤Ã¤nnÃ¶llinen vÃ¤hennykset otetaan tyÃ¶ntekijÃ¤',0),(136637,3796,'no','Vanlig fradrag tas fra ansatte betale',0),(136638,3796,'da','RegelmÃ¦ssig fradrag skal tages fra medarbejderen betale',0),(136639,3796,'ko','ì§ì› ê¸‰ë£Œì—ì„œ ì£¼ì˜ê°€ ì •ê¸° ê³µì œ',0),(136640,3796,'he','× ×™×›×•×™×™× ×¨×’×™×œ ×œ×”×™×œ×§×— ×ž×Ÿ ×”×¢×•×‘×“ ×œ×©×œ×',0),(136641,3796,'el','Î¤Î±ÎºÏ„Î¹ÎºÎ® Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î»Î·Ï†Î¸Î¿ÏÎ½ Î±Ï€ÏŒ Pay-Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚',0),(136642,3796,'zh','ä»Žå‘˜å·¥å·¥èµ„ä¸­æ‹¿å‡ºçš„å¸¸è§„æ‰£é™¤\r\n',0),(136643,3796,'sv','Regelbundna avdrag tas frÃ¥n arbetstagaren betala',0),(136644,3796,'it','Deduzioni regolari per essere preso da dipendente paga',0),(136645,3796,'tl','',0),(136646,3796,'th','Regular Deductions to be Taken from Employee Pay',0),(136647,3796,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨ à¤¸à¥‡ à¤²à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(136648,3796,'ms','Potongan tetap perlu diambil dari pekerja membayar',0),(136649,3796,'ar','Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª Ø§Ù„Ø¹Ø§Ø¯ÙŠØ© Ø§Ù„ØªÙŠ Ø³ØªØªØ®Ø° Ù…Ù† \"Ø¯ÙØ¹ Ø§Ù„Ù…ÙˆØ¸Ù\"',0),(136650,3796,'fr','Retenues normales soit prÃ©levÃ© sur la paie de l\'employÃ©',0),(136651,3796,'jp','å¾“æ¥­å“¡çµ¦ä¸Žã?‹ã‚‰å¼•ã?‹ã‚Œã‚‹å®šæœŸæŽ§é™¤',0),(136652,3796,'pt','DeduÃ§Ãµes regulares a ter de pagar empregado',0),(136653,3796,'ru','Ð ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ñ‹Ðµ Ð£Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ Ð¸Ð· ÐžÐ¿Ð»Ð°Ñ‚Ñ‹ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(136654,3796,'es','Deducciones Regulares que se TomarÃ¡ de Sueldo de Empleado',0),(136655,3796,'de','RegelmÃ¤ÃŸige AbzÃ¼ge zu entnehmenden Mitarbeiter bezahlen',0),(136656,3796,'en','Regular Deductions to be Taken from Employee Pay',0),(136657,3797,'is','',0),(136658,3797,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª ',0),(136659,3797,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª ',0),(136660,3797,'tr','RaporlarÄ±',0),(136661,3797,'pl','Raporty',0),(136662,3797,'bg','ÐžÑ‚Ñ‡ÐµÑ‚Ð¸',0),(136663,3797,'ur','Ø±Ù¾ÙˆØ±Ù¹ÙˆÚº',0),(136664,3797,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(136665,3797,'vi','BÃ¡o CÃ¡o',0),(136666,3797,'af','Verslae',0),(136667,3797,'ro','Rapoarte',0),(136668,3797,'et','Aruanded',0),(136669,3797,'si','PoroÄila',0),(136670,3797,'ba','Laporan',0),(136671,3797,'nl','Rapporten',0),(136672,3797,'fi','Raportit',0),(136673,3797,'no','Rapporter',0),(136674,3797,'da','Rapporter',0),(136675,3797,'ko','ë³´ê³ ì„œ',0),(136676,3797,'he','×“×•×—×•×ª',0),(136677,3797,'el','Î•ÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(136678,3797,'zh','æŠ¥å‘Š\r\n',0),(136679,3797,'sv','Rapporter',0),(136680,3797,'it','Rapporti',0),(136681,3797,'tl','',0),(136682,3797,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(136683,3797,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(136684,3797,'ms','Laporan-laporan',0),(136685,3797,'ar','Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ±',0),(136686,3797,'fr','Rapports',0),(136687,3797,'jp','ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(136688,3797,'pt','RelatÃ³rios',0),(136689,3797,'ru','ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹',0),(136690,3797,'es','Informes',0),(136691,3797,'de','Berichte',0),(136692,3797,'en','Reports',0),(136693,3798,'is','',0),(136694,3798,'dr',':  Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø§Ø®ØªÙ„Ø§Ù â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø­Ø¬Ù… â€“ Ø§Ø­ØµØ§Ø¦ÛŒÙ‡  Ù¾ÙŠØ´ Ø¨ÛŒØ¬Ú©Ù‡Ø§ Ùˆ ØºÙŠØ±Ù‡ ',0),(136695,3798,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ú¯Ø²Ø§Ø±Ø´Ø§Øª  :  Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù…ØºØ§ÙŠØ±Øª â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø­Ø¬Ù… â€“ Ø¢Ù…Ø§Ø± Ù¾ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ùˆ ØºÙŠØ±Ù‡ ',0),(136696,3798,'tr','Varyans raporlarÄ±, birim raporlarÄ±, performans istatistikleri, vb.',0),(136697,3798,'pl','Odchylenie raporty, wielkoÅ›Ä‡ raporty, statystyki wydajnoÅ›ci, itp.',0),(136698,3798,'bg','Ð”Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸, Ð¢Ð¾Ð¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸, ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð´Ð°Ð½Ð½Ð¸ Ð¸ Ð´Ñ€.',0),(136699,3798,'ur','ØªØºÛŒØ± Ø±Ù¾ÙˆØ±Ù¹ÛŒÚºØŒ Ø­Ø¬Ù… Ø±Ù¾ÙˆØ±Ù¹ÛŒÚºØŒ Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±ØŒ ÙˆØºÛŒØ±Û Û”',0),(136700,3798,'sr','ÐžÐ´ÑÑ‚ÑƒÐ¿Ð°ÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ, Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ, ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð°, Ð¸Ñ‚Ð´.',0),(136701,3798,'vi','BÃ¡o cÃ¡o chÃªnh lá»‡ch, khá»‘i lÆ°á»£nng, thá»‘ng kÃª thá»±c hiá»‡n, vv',0),(136702,3798,'af','Afwykingsverslae, Volume Verslae, Werksverrigting Statistieke, ens.',0),(136703,3798,'ro','VarianÅ£a rapoarte, rapoarte de volum, statistici de performanÅ£Äƒ, etc.',0),(136704,3798,'et','Dispersiooni aruanded, mahu aruannete, jÃµudlusstatistika jne.',0),(136705,3798,'si','Varianca poroÄila obsega poroÄila, statistiko uspeÅ¡nosti, itd.',0),(136706,3798,'ba','Laporan varians, Volume laporan, statistik kinerja, dll.',0),(136707,3798,'nl','Variantie rapporten, Volume rapporten, prestatiestatistieken, enz.',0),(136708,3798,'fi','Varianssi raportit, aseman raportit, tehokkuustilastoja.',0),(136709,3798,'no','Varians rapporter, volum rapporter, resultatstatistikk, etc.',0),(136710,3798,'da','Varians rapporter, volumen rapporter, statistik over ydeevne mv.',0),(136711,3798,'ko','ë¶„ì‚° ë³´ê³ ì„œ, ë³¼ë¥¨ ë³´ê³ ì„œ, ì‹¤ì  í†µê³„, ë“±ë“±.',0),(136712,3798,'he','×¡×˜×™×” ×“×•×—×•×ª, ×“×•×—×•×ª × ×¤×—, ×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×, ×•×›×• \'.',0),(136713,3798,'el','Î”Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ· ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚, ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ ÏŒÎ³ÎºÎ¿Ï…, ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Ï€ÏŒÎ´Î¿ÏƒÎ·Ï‚, ÎºÎ»Ï€.',0),(136714,3798,'zh','å·®å¼‚æŠ¥å‘Šï¼Œæ•°é‡æŠ¥å‘Šï¼Œç»©æ•ˆç»Ÿè®¡ç­‰\r\n',0),(136715,3798,'sv','Varians rapporter, volym rapporter, statistik Ã¶ver nÃ¤tverksprestanda, etc.',0),(136716,3798,'it','Varianza relazioni, rapporti di Volume, le statistiche sulle prestazioni, ecc.',0),(136717,3798,'tl','',0),(136718,3798,'th','Variance Reports, Volume Reports, Performance Statistics, etc.',0),(136719,3798,'hi','à¤µà¤¿à¤šà¤°à¤£ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ, à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥‡à¤‚, à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¥‡ à¤†à¤à¤•à¤¡à¤¼à¥‡, à¤†à¤¦à¤¿à¥¤',0),(136720,3798,'ms','Laporan perbezaan jumlah laporan, statistik prestasi, dan lain-lain.',0),(136721,3798,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„ÙØ±Ù‚ØŒ ØªÙ‚Ø§Ø±ÙŠØ± ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†ØŒ ÙˆØ¥Ø­ØµØ§Ø¡Ø§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡ØŒ Ø¥Ù„Ø®.',0),(136722,3798,'fr','Rapports sur les Ã©carts, Volume de rapports, des statistiques de Performance, etc..',0),(136723,3798,'jp','å·®é¡?ãƒ¬ãƒ?ãƒ¼ãƒˆã€?å‡ºæ?¥é«˜ãƒ¬ãƒ?ãƒ¼ãƒˆã€?æ¥­ç¸¾çµ±è¨ˆã€?ã?ªã?©',0),(136724,3798,'pt','RelatÃ³rios de variÃ¢ncia, Volume de relatÃ³rios, estatÃ­sticas de desempenho, etc.',0),(136725,3798,'ru','Ð”Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´Ñ‹, Ð¾Ð±ÑŠÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¾Ð², ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð¸ Ñ‚.Ð´.',0),(136726,3798,'es','Informes de VariaciÃ³n, Informes de VolÃºmen, Estadisticas de DesempeÃ±o, etc.',0),(136727,3798,'de','Varianz-Berichte, Band Berichte, Performance-Statistiken.',0),(136728,3798,'en','Variance Reports, Volume Reports, Performance Statistics, etc.',0),(136729,3799,'is','',0),(136730,3799,'dr','(Ù…Ø¬ÙˆØ²) ÙØ±Ù…Ø§ÛŒØ´ Ú†Ø§Ù¾ ',0),(136731,3799,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯  Ø¨Ù„ÙŠØ·(Ù…Ø¬ÙˆØ²) Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(136732,3799,'tr','Yeni baskÄ± baskÄ± sipariÅŸi Bilet',0),(136733,3799,'pl','Przedruk kolejnoÅ›Ä‡ drukowania biletÃ³w',0),(136734,3799,'bg','ÐŸÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð±Ð¸Ð»ÐµÑ‚',0),(136735,3799,'ur','Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù¹Ú©Ù¹',0),(136736,3799,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¨Ñ‚Ð°Ð¼Ð¿Ð°Ñ˜ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(136737,3799,'vi','In láº¡i vÃ© Ä‘Æ¡n hÃ ng in',0),(136738,3799,'af','Herdruk Druk Bestellingkaartjie',0),(136739,3799,'ro','Bilet de ordine imprimare retipÄƒrire',0),(136740,3799,'et','KordustrÃ¼kk printimise jÃ¤rjekorras Piletite',0),(136741,3799,'si','Ponatis vrstni red tiskanja vozovnice',0),(136742,3799,'ba','Cetak ulang pesanan cetakan Tiket',0),(136743,3799,'nl','Herdruk afdrukvolgorde Ticket',0),(136744,3799,'fi','Uusintapainos tulostusjÃ¤rjestystÃ¤ lippu',0),(136745,3799,'no','Opptrykk rekkefÃ¸lge billett',0),(136746,3799,'da','Genoptryk udskriftsrÃ¦kkefÃ¸lgen billet',0),(136747,3799,'ko','ë¬´ë‹¨ ì „ìž¬ ì¸ì‡„ ìˆœì„œ í‹°ì¼“',0),(136748,3799,'he','×”×“×¤×¡×” ×ž×—×“×© ××ª ×¡×“×¨ ×”×”×“×¤×¡×” ×”×›×¨×˜×™×¡',0),(136749,3799,'el','Î‘Î½Î¬Ï„Ï…Ï€Î¿ ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(136750,3799,'zh','é‡å°æ‰“å°è®¢å•ç¥¨æ®\r\n',0),(136751,3799,'sv','Nytryck utskriftsordning biljett',0),(136752,3799,'it','Ristampa ordine stampa biglietto',0),(136753,3799,'tl','',0),(136754,3799,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3633;&#3659;&#3623;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(136755,3799,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤Ÿà¤¿à¤•à¤Ÿ',0),(136756,3799,'ms','Pencetakan semula cetak Tiket',0),(136757,3799,'ar','Ø·Ø¨Ø¹ Ø§Ù„ØªØ°Ø§ÙƒØ± Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(136758,3799,'fr','RÃ©impression ordre d\'impression Ticket',0),(136759,3799,'jp','å?°åˆ·æ³¨æ–‡ãƒ?ã‚±ãƒƒãƒˆã?®å†?å?°åˆ·',0),(136760,3799,'pt','Bilhete de ordem de impressÃ£o reimpressÃ£o',0),(136761,3799,'ru','ÐŸÐµÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚ÐºÐ° Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð±Ð¸Ð»ÐµÑ‚Ð°',0),(136762,3799,'es','Reimprimir Boleto de Orden de ImpresiÃ³n',0),(136763,3799,'de','Nachdruck Print Order Ticket',0),(136764,3799,'en','Reprint Print Order Ticket',0),(136765,3800,'is','',0),(136766,3800,'dr','(Ù…Ø¬ÙˆØ²',0),(136767,3800,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø¨Ù„ÙŠØ·(Ù…Ø¬ÙˆØ²',0),(136768,3800,'tr','Bilet BasÄ±m',0),(136769,3800,'pl','WydrukowaÄ‡ bilet',0),(136770,3800,'bg','ÐŸÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ Ð±Ð¸Ð»ÐµÑ‚',0),(136771,3800,'ur','Ù¹Ú©Ù¹ Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹',0),(136772,3800,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(136773,3800,'vi','In láº¡i vÃ©',0),(136774,3800,'af','Herdruk Kaartjie',0),(136775,3800,'ro','Bilet de retipÄƒrire',0),(136776,3800,'et','KordustrÃ¼kk Piletite',0),(136777,3800,'si','Ponatis vozovnice',0),(136778,3800,'ba','Mencetak ulang Tiket',0),(136779,3800,'nl','Herdruk Ticket',0),(136780,3800,'fi','Uusintapainos lippu',0),(136781,3800,'no','Opptrykk billett',0),(136782,3800,'da','Genoptryk billet',0),(136783,3800,'ko','ìž¬ë°œí–‰ í•­ê³µê¶Œ',0),(136784,3800,'he','×”×“×¤×¡ ×©×•×‘ ×›×¨×˜×™×¡',0),(136785,3800,'el','Î‘Î½Î¬Ï„Ï…Ï€Î¿ ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(136786,3800,'zh','é‡å°ç¥¨æ®\r\n',0),(136787,3800,'sv','Nytryck biljett',0),(136788,3800,'it','Ristampa biglietto',0),(136789,3800,'tl','',0),(136790,3800,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3633;&#3659;&#3623;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(136791,3800,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤Ÿà¤¿à¤•à¤Ÿ',0),(136792,3800,'ms','Pencetakan semula Tiket.',0),(136793,3800,'ar','Ø·Ø¨Ø¹ Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(136794,3800,'fr','Billet de rÃ©impression',0),(136795,3800,'jp','ãƒ?ã‚±ãƒƒãƒˆã?®å†?å?°åˆ·',0),(136796,3800,'pt','Reimprimir Ticket',0),(136797,3800,'ru','ÐŸÐµÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚ÐºÐ° Ð±Ð¸Ð»ÐµÑ‚',0),(136798,3800,'es','Reimprimir Boleto',0),(136799,3800,'de','Reprint-Ticket',0),(136800,3800,'en','Reprint Ticket',0),(136801,3801,'is','',0),(136802,3801,'dr','Ø¹Ù…Ù„ Ù¾Ø³Øª  Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯',0),(136803,3801,'pr','Ø¹Ù…Ù„ Ù¾Ø³Øª  Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯',0),(136804,3801,'tr','Genel muhasebe sonrasÄ± eylem ters',0),(136805,3801,'pl','OdwrÃ³ciÄ‡ dziaÅ‚anie ogÃ³lne ksiÄ™gi Post',0),(136806,3801,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¸Ñ‚Ðµ Ð³ÐµÐ½ÐµÑ€Ð°Ð» Ð›ÐµÐ´Ð¶ÑŠÑ€ ÑÐ»ÐµÐ´ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(136807,3801,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ù¾ÙˆØ³Ù¹ Ø¹Ù…Ù„ Ù…Ø¹Ú©ÙˆØ³ Ú©Ø±ÛŒÚº',0),(136808,3801,'sr','ÐžÐ±Ñ€Ð½ÑƒÑ‚Ð¸ Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ ÐŸÐ¾ÑÑ‚ Ð°ÐºÑ†Ð¸Ñ˜Ð°',0),(136809,3801,'vi','Káº¿t Chuyá»ƒn BÃºt ToÃ¡n Sá»• CÃ¡i NgÆ°á»£c',0),(136810,3801,'af','Terugskryf van Algemene Grootboek Pos Aksie',0),(136811,3801,'ro','Inversa Post de registru General de acÅ£iune',0),(136812,3801,'et','Reverse Ãœldised pearaamatu Post tegevus',0),(136813,3801,'si','Reverse General Ledger Post ukrepa',0),(136814,3801,'ba','Reverse Aksi General Ledger posting',0),(136815,3801,'nl','General Ledger Post actie terugdraaien',0),(136816,3801,'fi','KÃ¤Ã¤nteinen General Ledger Post toiminta',0),(136817,3801,'no','Omvendt General Ledger innlegget handlingen',0),(136818,3801,'da','Vende General Ledger Post Action',0),(136819,3801,'ko','ì¼ë°˜ ë ˆì € ê²Œì‹œë¬¼ ì•¡ì…˜ ì—­ë°©í–¥',0),(136820,3801,'he','×”×¤×•×š ×¤×¢×•×œ×” ×›×œ×œ×™ ×¡×¤×¨ ×¨××©×™ ×¤×•×¡×˜',0),(136821,3801,'el','Î‘Î½Ï„Î¯ÏƒÏ„ÏÎ¿Ï†Î· Î³ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® Î¸Î­ÏƒÎ· Î´ÏÎ¬ÏƒÎ·Ï‚',0),(136822,3801,'zh','é€†å‘æ€»å¸å‘å¸ƒè¡ŒåŠ¨\r\n',0),(136823,3801,'sv','OmvÃ¤nd General Ledger Post Action',0),(136824,3801,'it','General Ledger Post azione inversa',0),(136825,3801,'tl','',0),(136826,3801,'th','&#3585;&#3621;&#3633;&#3610;&#3604;&#3657;&#3634;&#3609;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3',0),(136827,3801,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤°à¤¿à¤µà¤°à¥à¤¸',0),(136828,3801,'ms','Songsang tindakan Post Lejar Am',0),(136829,3801,'ar','Ø¹ÙƒØ³ Ø§Ù„Ø¹Ù…Ù„ ÙˆØ¸ÙŠÙØ© Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(136830,3801,'fr','Inverser l\'Action Post grand livre gÃ©nÃ©ral',0),(136831,3801,'jp','ï¼§ï¼¬è¨ˆä¸Šã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã‚’ç„¡åŠ¹ã?«ã?™ã‚‹',0),(136832,3801,'pt','Reverter a aÃ§Ã£o do General Ledger Post',0),(136833,3801,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹ ÐºÐ½Ð¸Ð³Ð¸ Ð¿Ð¾ÑÑ‚',0),(136834,3801,'es','Reversar AcciÃ³n de Asentar el Libro Mayor',0),(136835,3801,'de','Umkehren Sie General Ledger Post-Aktion',0),(136836,3801,'en','Reverse General Ledger Post Action',0),(136837,3802,'is','',0),(136838,3802,'dr','Ø«Ø¨Øª Ø¯Ø± Ø¯ÙØªØ± Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯',0),(136839,3802,'pr','Ø«Ø¨Øª Ø¯Ø± Ø¯ÙØªØ± Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯',0),(136840,3802,'tr','Ters ilanlarÄ±',0),(136841,3802,'pl','OdwrÃ³ciÄ‡ komentarze',0),(136842,3802,'bg','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‚Ðµ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ð¸Ñ',0),(136843,3802,'ur','Ø§Ø´Ø§Ø¹ØªÛŒÚº Ù…Ø¹Ú©ÙˆØ³ Ú©Ø±ÛŒÚº',0),(136844,3802,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ ÐºÑšÐ¸Ð¶ÐµÑšÐ°',0),(136845,3802,'vi','Viáº¿t ngÆ°á»£c káº¿t chuyá»ƒn',0),(136846,3802,'af','Terugskryf van Posterings',0),(136847,3802,'ro','Inversa postÄƒri',0),(136848,3802,'et','Ãœmber pÃ¶Ã¶rata',0),(136849,3802,'si','Povratne objave',0),(136850,3802,'ba','Membalikkan posting',0),(136851,3802,'nl','Omgekeerde Postings',0),(136852,3802,'fi','Peruuttaa kirjaukset',0),(136853,3802,'no','Reversere bokfÃ¸ringer',0),(136854,3802,'da','TilbagefÃ¸re posteringer',0),(136855,3802,'ko','ë°˜ì „ í¬ìŠ¤íŒ…',0),(136856,3802,'he','×¤×¨×¡×•×ž×™ ×”×¤×•×›×”',0),(136857,3802,'el','Î‘Î½Ï„Î¹Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Ï„Ï‰Î½ Î»Î±Î½Î¸Î±ÏƒÎ¼Î­Î½Ï‰Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÏ‰Î½',0),(136858,3802,'zh','åå‘å¼ è´´\r\n',0),(136859,3802,'sv','Ã…terfÃ¶ra bokfÃ¶ringar',0),(136860,3802,'it','Invertire i commenti',0),(136861,3802,'tl','',0),(136862,3802,'th','&#3606;&#3629;&#3618;&#3585;&#3621;&#3633;&#3610;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(136863,3802,'hi','à¤°à¤¿à¤µà¤°à¥à¤¸ à¤ªà¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤—',0),(136864,3802,'ms','Catatan terbalik',0),(136865,3802,'ar','Ø¹ÙƒØ³ ØªØ±Ø­ÙŠÙ„Ø§Øª Ø§Ù„Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(136866,3802,'fr','Contrepasser validations',0),(136867,3802,'jp','ä»•è¨³å¸³è¨ˆä¸Šã?®å?–æ¶ˆã?—',0),(136868,3802,'pt','Postagens de reversos',0),(136869,3802,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾Ð¹ Ð¿Ñ€Ð¾Ð²Ð¾Ð´ÐºÐ¸',0),(136870,3802,'es','Reversar Asientos',0),(136871,3802,'de','Stornieren von Buchungen',0),(136872,3802,'en','Reverse Postings',0),(136873,3803,'is','',0),(136874,3803,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(136875,3803,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(136876,3803,'tr','GÃ¶zden sipariÅŸ maliyeti',0),(136877,3803,'pl','PrzeglÄ…d KolejnoÅ›Ä‡ kosztÃ³w',0),(136878,3803,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(136879,3803,'ur','Ø¬Ø§Ø¦Ø²Û ØªØ±ØªÛŒØ¨ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(136880,3803,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(136881,3803,'vi','BÃ¬nh duyá»‡t giÃ¡ thÃ nh Ä‘Æ¡n hÃ ng',0),(136882,3803,'af','Hersiening orde koste',0),(136883,3803,'ro','Costurile de ordine de revizuire',0),(136884,3803,'et','LÃ¤bivaatamise korra kulud',0),(136885,3803,'si','Pregled nalog stroÅ¡kov',0),(136886,3803,'ba','Tinjauan Order biaya',0),(136887,3803,'nl','Vergelijk Kosten',0),(136888,3803,'fi','Tarkastelun kustannuksia',0),(136889,3803,'no','Gjennomgang bestilling kostnader',0),(136890,3803,'da','Anmeldelse omkostninger',0),(136891,3803,'ko','ê²€í†  ì£¼ë¬¸ ë¹„ìš©',0),(136892,3803,'he','×‘×—×Ÿ ×ž×—×™×¨×™ ×”×–×ž× ×•×ª',0),(136893,3803,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î³Î¹Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(136894,3803,'zh','å¤å®¡è®¢å•æˆæœ¬\r\n',0),(136895,3803,'sv','Recension fÃ¶r kostnader',0),(136896,3803,'it','Recensione ordine costi',0),(136897,3803,'tl','',0),(136898,3803,'th','&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(136899,3803,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¥à¤°à¤® à¤²à¤¾à¤—à¤¤',0),(136900,3803,'ms','Kajian kos pesanan',0),(136901,3803,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶ Ù†Ø¸Ø§Ù… Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(136902,3803,'fr','CoÃ»ts de commande de rÃ©vision',0),(136903,3803,'jp','ç™ºæ³¨è²»ã?®è¦‹ç›´ã?—',0),(136904,3803,'pt','Custos de pedido de revisÃ£o',0),(136905,3803,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(136906,3803,'es','Revisar Costos de Ordenes',0),(136907,3803,'de','Bewertung Auftragskosten',0),(136908,3803,'en','Review Order Costs',0),(136909,3804,'is','',0),(136910,3804,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´  Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(136911,3804,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´  Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(136912,3804,'tr','SipariÅŸ maliyetlerini/fiyatlarÄ±nÄ± gÃ¶zden geÃ§irin',0),(136913,3804,'pl','PrzeglÄ…d KolejnoÅ›Ä‡ koszty/ceny',0),(136914,3804,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸/Ñ†ÐµÐ½Ð¸',0),(136915,3804,'ur','Ø¬Ø§Ø¦Ø²Û ØªØ±ØªÛŒØ¨ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª/Ù‚ÛŒÙ…ØªÛŒÚº',0),(136916,3804,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð°Ð»Ð¾Ð³Ð°/Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(136917,3804,'vi','BÃ¬nh duyá»‡t giÃ¡ thÃ nh/giÃ¡ bÃ¡n Ä‘Æ¡n hÃ ng',0),(136918,3804,'af','Hersien orde koste pryse',0),(136919,3804,'ro','Revizuirea ordinea costuri/preÅ£uri',0),(136920,3804,'et','LÃ¤bivaatamise korra kulud/hinnad',0),(136921,3804,'si','Pregled nalog stroÅ¡ke/cene',0),(136922,3804,'ba','Meninjau pesanan biaya/harga',0),(136923,3804,'nl','Vergelijk Kosten uitgebreid',0),(136924,3804,'fi','Arvostelu tilaus kustannuksia tai hintoja',0),(136925,3804,'no','Gjennomgang for varekost/priser',0),(136926,3804,'da','Anmeld ordre omkostninger/priser',0),(136927,3804,'ko','ê²€í†  ì£¼ë¬¸ ë¹„ìš©/ê°€ê²©',0),(136928,3804,'he','×¡×§×™×¨×ª ×¢×œ×•×™×•×ª/×ž×—×™×¨×™× ×©×œ ×”×–×ž× ×•×ª',0),(136929,3804,'el','Î‘Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ· Ï„Î¬Î¾Î·Ï‚/ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(136930,3804,'zh','å¤å®¡è®¢å•æˆæœ¬/ä»·æ ¼\r\n',0),(136931,3804,'sv','Granska ordern /-priser',0),(136932,3804,'it','Recensione ordine costi/prezzi',0),(136933,3804,'tl','',0),(136934,3804,'th','&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;/&#3619;&#3634;&#3588;&#3634;',0),(136935,3804,'hi','à¤•à¥à¤°à¤® à¤²à¤¾à¤—à¤¤/à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(136936,3804,'ms','Mengkaji semula perintah kos/harga',0),(136937,3804,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ/Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(136938,3804,'fr','Examiner l\'ordonnance coÃ»ts/prix',0),(136939,3804,'jp','ç™ºæ³¨è²»/å€¤æ®µã?®è¦‹ç›´ã?—',0),(136940,3804,'pt','Ordem de anÃ¡lise custos/preÃ§os',0),(136941,3804,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð·Ð°ÐºÐ°Ð·Ð° Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹/Ñ†ÐµÐ½Ñ‹',0),(136942,3804,'es','Revisar Costos de Ordenes/Precios',0),(136943,3804,'de','Review Order Kosten/Preise',0),(136944,3804,'en','Review Order Costs/Prices',0),(136945,3805,'is','',0),(136946,3805,'dr','Ø¹Ù…Ù„ÙŠØ§ØªÙ‡Ø§ÙŠ ÙØ±ÙˆØ´',0),(136947,3805,'pr','Ø¹Ù…Ù„ÙŠØ§ØªÙ‡Ø§ÙŠ ÙØ±ÙˆØ´',0),(136948,3805,'tr','SatÄ±ÅŸ iÅŸlemleri',0),(136949,3805,'pl','SprzedaÅ¼y akcji',0),(136950,3805,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(136951,3805,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø§Ø¹Ù…Ø§Ù„',0),(136952,3805,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ñ€Ð°Ð´ÑšÐµ',0),(136953,3805,'vi','Hoáº¡t Ä‘á»™ng bÃ¡n hÃ ng',0),(136954,3805,'af','Verkoopsaksies',0),(136955,3805,'ro','Vanzare actiuni',0),(136956,3805,'et','MÃ¼Ã¼gi toimingud',0),(136957,3805,'si','Prodajne akcije',0),(136958,3805,'ba','Tindakan penjualan',0),(136959,3805,'nl','Verkoop acties',0),(136960,3805,'fi','Myynnin toiminnot',0),(136961,3805,'no','Salg handlinger',0),(136962,3805,'da','Salg handlinger',0),(136963,3805,'ko','íŒë§¤ ìž‘ì—…',0),(136964,3805,'he','×¤×¢×•×œ×•×ª ×ž×›×™×¨×”',0),(136965,3805,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î´ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(136966,3805,'zh','é”€å”®è¡ŒåŠ¨\r\n',0),(136967,3805,'sv','FÃ¶rsÃ¤ljning Ã¥tgÃ¤rder',0),(136968,3805,'it','Vendita azioni',0),(136969,3805,'tl','',0),(136970,3805,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(136971,3805,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾à¤à¤',0),(136972,3805,'ms','Tindakan-tindakan jualan',0),(136973,3805,'ar','Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„ØªÙˆØ±ÙŠØ¯',0),(136974,3805,'fr','Ventes Actions',0),(136975,3805,'jp','è²©å£²è¡Œå‹•',0),(136976,3805,'pt','AÃ§Ãµes de vendas',0),(136977,3805,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(136978,3805,'es','Acciones de Ventas',0),(136979,3805,'de','Verkaufsaktionen',0),(136980,3805,'en','Sales Actions',0),(136981,3806,'is','',0),(136982,3806,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ',0),(136983,3806,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ',0),(136984,3806,'tr','SatÄ±ÅŸ Kategoriler',0),(136985,3806,'pl','SprzedaÅ¼y kategorii',0),(136986,3806,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(136987,3806,'ur','Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(136988,3806,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(136989,3806,'vi','Thá»ƒ loáº¡i bÃ¡n hÃ ng',0),(136990,3806,'af','VerkoopskategoriÃ«',0),(136991,3806,'ro','VÃ¢nzÄƒri categorii',0),(136992,3806,'et','Tootekategooria',0),(136993,3806,'si','Prodaja kategorije',0),(136994,3806,'ba','Kategori Penjualan',0),(136995,3806,'nl','Verkoopcategorie',0),(136996,3806,'fi','Myynti luokka',0),(136997,3806,'no','Salg kategorier',0),(136998,3806,'da','Salg kategorier',0),(136999,3806,'ko','íŒë§¤ ì¹´í…Œê³ ë¦¬',0),(137000,3806,'he','×§×˜×’×•×¨×™×•×ª ×ž×›×™×¨×•×ª',0),(137001,3806,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(137002,3806,'zh','é”€å”®ç±»åˆ«\r\n',0),(137003,3806,'sv','FÃ¶rsÃ¤ljningskategori',0),(137004,3806,'it','Categorie vendite',0),(137005,3806,'tl','',0),(137006,3806,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(137007,3806,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚',0),(137008,3806,'ms','Kategori jualan',0),(137009,3806,'ar','ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(137010,3806,'fr','CatÃ©gories de ventes',0),(137011,3806,'jp','è²©å£²ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(137012,3806,'pt','Categorias vendas',0),(137013,3806,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(137014,3806,'es','CategorÃ­as de Ventas',0),(137015,3806,'de','Vertrieb Kategorien',0),(137016,3806,'en','Sales Categories',0),(137017,3807,'is','',0),(137018,3807,'dr','Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ ',0),(137019,3807,'pr','Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ ',0),(137020,3807,'tr','SatÄ±ÅŸ personeli',0),(137021,3807,'pl','Personel sprzedaÅ¼y',0),(137022,3807,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(137023,3807,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø±',0),(137024,3807,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(137025,3807,'vi','NhÃ¢n viÃªn kinh doanh',0),(137026,3807,'af','Verkoopspersoneel',0),(137027,3807,'ro','Personal de vÃ¢nzÄƒri',0),(137028,3807,'et','MÃ¼Ã¼gimees',0),(137029,3807,'si','Prodajno osebje',0),(137030,3807,'ba','Personil penjualan',0),(137031,3807,'nl','Verkooppersoneel',0),(137032,3807,'fi','MyyntihenkilÃ¶stÃ¶Ã¤',0),(137033,3807,'no','Selgere',0),(137034,3807,'da','Salgspersonale',0),(137035,3807,'ko','íŒë§¤ ì§ì›',0),(137036,3807,'he','×¦×•×•×ª ×ž×›×™×¨×•×ª',0),(137037,3807,'el','Î ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ¿Ï Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(137038,3807,'zh','é”€å”®äººå‘˜\r\n',0),(137039,3807,'sv','FÃ¶rsÃ¤ljningspersonal',0),(137040,3807,'it','Personale di vendita',0),(137041,3807,'tl','',0),(137042,3807,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(137043,3807,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚',0),(137044,3807,'ms','Kakitangan jualan',0),(137045,3807,'ar','Ù…ÙˆØ¸ÙÙˆ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(137046,3807,'fr','Personnel de vente',0),(137047,3807,'jp','è²©å£²å“¡',0),(137048,3807,'pt','Pessoal de vendas',0),(137049,3807,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(137050,3807,'es','Personal de Ventas',0),(137051,3807,'de','Verkaufspersonal',0),(137052,3807,'en','Sales Personnel',0),(137053,3808,'is','',0),(137054,3808,'dr','- Ø§ÙØ²ÙˆØ¯Ù†  Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†',0),(137055,3808,'pr','Ù…Ù†ÙˆÙŠ ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´- Ø§ÙØ²ÙˆØ¯Ù†  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ',0),(137056,3808,'tr','Ä°ÅŸlem Ekle/GÃ¼ncelle',0),(137057,3808,'pl','Proces Dodaj/Aktualizuj',0),(137058,3808,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑÐ° Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(137059,3808,'ur','Ø¹Ù…Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(137060,3808,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(137061,3808,'vi','ThÃªm/cáº­p nháº­t quy trÃ¬nh',0),(137062,3808,'af','Proses Byvoeg/Opdateer',0),(137063,3808,'ro','Procesul AdÄƒugaÅ£i/actualizaÅ£i',0),(137064,3808,'et','Protsessi lisamine/uuendamine',0),(137065,3808,'si','Proces Dodaj/posodobi',0),(137066,3808,'ba','Proses Tambahkan/Perbarui',0),(137067,3808,'nl','Proces toevoegen/bijwerken',0),(137068,3808,'fi','Prosessi lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(137069,3808,'no','Prosessen/Oppdater',0),(137070,3808,'da','Processen TilfÃ¸j/opdater',0),(137071,3808,'ko','í”„ë¡œì„¸ìŠ¤ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(137072,3808,'he','×”×•×¡×£/×¢×“×›×Ÿ ×ª×”×œ×™×š',0),(137073,3808,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(137074,3808,'zh','å¤„ç†æ–°å¢ž/æ›´æ–°\r\n',0),(137075,3808,'sv','Processen LÃ¤gg till/uppdatera',0),(137076,3808,'it','Aggiungere/aggiornare un processo',0),(137077,3808,'tl','',0),(137078,3808,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;',0),(137079,3808,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(137080,3808,'ms','Proses Tambah/Kemaskini',0),(137081,3808,'ar','Ø¹Ù…Ù„ÙŠØ© Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(137082,3808,'fr','Processus ajouter/mettre Ã  jour',0),(137083,3808,'jp','è²©å£²é?Žç¨‹ã?®ã€€è¿½åŠ /æ›´æ–°',0),(137084,3808,'pt','Adicionar/atualizar do processo',0),(137085,3808,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(137086,3808,'es','Proceso Agregar/Actualizar',0),(137087,3808,'de','Prozess hinzufÃ¼gen/aktualisieren',0),(137088,3808,'en','Process Add/Update',0),(137089,3809,'is','',0),(137090,3809,'dr','Ø¯Ù„Ø§ÙŠÙ„ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(137091,3809,'pr','Ø¯Ù„Ø§ÙŠÙ„ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(137092,3809,'tr','SatÄ±ÅŸ vergisi muafiyet nedenleri',0),(137093,3809,'pl','Przyczyny zwolnienia z podatku',0),(137094,3809,'bg','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð¸ Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(137095,3809,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡ ÙˆØ¬ÙˆÛØ§Øª Ú©ÛŒ Ø¨Ù†Ø§ Ù¾Ø±',0),(137096,3809,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¸Ð·ÑƒÐ·ÐµÑ›Ñƒ Ñ€Ð°Ð·Ð»Ð¾Ð³Ðµ',0),(137097,3809,'vi','NguyÃªn nhÃ¢n miá»…n trá»« thuáº¿ bÃ¡n hÃ ng',0),(137098,3809,'af','Verkoopsbelasting Vrystellingsredes',0),(137099,3809,'ro','Motive de scutire de impozitul pe vÃ¢nzÄƒri',0),(137100,3809,'et','KÃ¤ibemaksuvabastuse pÃµhjused',0),(137101,3809,'si','Razlogi za oprostitev prometnega davka',0),(137102,3809,'ba','Alasan Pembebasan pajak penjualan',0),(137103,3809,'nl','Sales Tax vrijstelling redenen',0),(137104,3809,'fi','ArvonlisÃ¤veron vapautus syistÃ¤',0),(137105,3809,'no','Mva-fritak grunner',0),(137106,3809,'da','Sales Tax fritagelse grunde',0),(137107,3809,'ko','íŒë§¤ì„¸ ë©´ì œ ì´ìœ ',0),(137108,3809,'he','×¡×™×‘×•×ª ×¤×˜×•×¨ ×ž×¢ ×ž',0),(137109,3809,'el','Î›ÏŒÎ³Î¿Ï…Ï‚ Î±Ï€Î±Î»Î»Î±Î³Î®Ï‚ Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(137110,3809,'zh','å…å¾è¥ä¸šç¨Žçš„åŽŸå› \r\n',0),(137111,3809,'sv','Moms undantaget skÃ¤l',0),(137112,3809,'it','Motivi di esenzione IVA',0),(137113,3809,'tl','',0),(137114,3809,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3651;&#3609;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(137115,3809,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤›à¥‚à¤Ÿ à¤•à¤¾à¤°à¤£à¥‹à¤‚',0),(137116,3809,'ms','Sebab-sebab pengecualian cukai jualan',0),(137117,3809,'ar','Ø£Ø³Ø¨Ø§Ø¨ Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ù…Ù† Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(137118,3809,'fr','Raisons d\'Exemption de taxe de vente',0),(137119,3809,'jp','å£²ä¸Šç¨ŽæŽ§é™¤ç?†ç”±',0),(137120,3809,'pt','RazÃµes de isenÃ§Ã£o de imposto sobre vendas',0),(137121,3809,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ñ‹ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(137122,3809,'es','Razones para Exenciones de IVA',0),(137123,3809,'de','Umsatzsteuer-Befreiung-GrÃ¼nde',0),(137124,3809,'en','Sales Tax Exemption Reasons',0),(137125,3810,'is','',0),(137126,3810,'dr','Ù†Ø±Ø® Ù‡Ø§ Ùˆ Ù†Ø§Ù… Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(137127,3810,'pr','Ù†Ø±Ø® Ù‡Ø§ Ùˆ Ù†Ø§Ù… Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(137128,3810,'tr','SatÄ±ÅŸ vergisi oranlarÄ± ve adlarÄ±',0),(137129,3810,'pl','Nazwy i stawki podatku',0),(137130,3810,'bg','Ð¡Ñ‚Ð°Ð²ÐºÐ¸ Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð¸ Ð¸Ð¼ÐµÐ½Ð°',0),(137131,3810,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø´Ø±Ø­ Ø§ÙˆØ± Ù†Ø§Ù…',0),(137132,3810,'sr','Ð¡Ñ‚Ð¾Ð¿Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¸ Ð¸Ð¼ÐµÐ½Ð°',0),(137133,3810,'vi','GiÃ¡ & TÃªn thuáº¿ bÃ¡n hÃ ng',0),(137134,3810,'af','Verkoopsbelastingkoerse en -Name',0),(137135,3810,'ro','Ratele de impozit pe vÃ¢nzÄƒri ÅŸi numele',0),(137136,3810,'et','KÃ¤ibemaksumÃ¤Ã¤rad ja -nimed',0),(137137,3810,'si','Prodajno davÄnih stopenj in imena',0),(137138,3810,'ba','Tarif pajak penjualan dan nama',0),(137139,3810,'nl','BTW-tarieven en namen',0),(137140,3810,'fi','ArvonlisÃ¤veroprosentit ja nimet',0),(137141,3810,'no','Mva-kurser og navn',0),(137142,3810,'da','Salg skattesatser og navne',0),(137143,3810,'ko','íŒë§¤ ì„¸ìœ¨ ë° ì´ë¦„',0),(137144,3810,'he','×©×™×¢×•×¨×™ ×ž×¢ ×ž ×•×©×ž×•×ª',0),(137145,3810,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Ï„Ï‰Î½ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½ ÏƒÏ…Î½Ï„ÎµÎ»ÎµÏƒÏ„ÏŽÎ½ ÎºÎ±Î¹ Î¿Î½ÏŒÎ¼Î±Ï„Î±',0),(137146,3810,'zh','è¥ä¸šç¨ŽçŽ‡å’Œåç§°\r\n',0),(137147,3810,'sv','Momssatser och namn',0),(137148,3810,'it','I nomi e le aliquote dell\'imposta sulle vendite',0),(137149,3810,'tl','',0),(137150,3810,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3649;&#3621;&#3632;&#3594;&#3639;&#3656;&#3629;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(137151,3810,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤•à¥€ à¤¦à¤°à¥‡à¤‚ à¤”à¤° à¤¨à¤¾à¤®',0),(137152,3810,'ms','Kadar cukai jualan dan nama-nama',0),(137153,3810,'ar','Ø£Ø³Ù…Ø§Ø¡ ÙˆÙ…Ø¹Ø¯Ù„Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(137154,3810,'fr','Les noms et les taux de taxe de vente',0),(137155,3810,'jp','å£²ä¸Šç¨ŽçŽ‡ã?¨å??å‰?',0),(137156,3810,'pt','Nomes e taxas de imposto sobre vendas',0),(137157,3810,'ru','Ð¡Ñ‚Ð°Ð²ÐºÐ¸ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¸ Ð¸Ð¼ÐµÐ½Ð°',0),(137158,3810,'es','Tasas de IVA y Nombres',0),(137159,3810,'de','Umsatzsteuer-Preise und Namen',0),(137160,3810,'en','Sales Tax Rates and Names',0),(137161,3811,'is','',0),(137162,3811,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(137163,3811,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(137164,3811,'tr','SatÄ±ÅŸ vergisi raporu',0),(137165,3811,'pl','Raport podatku',0),(137166,3811,'bg','Ð”Ð°Ð½ÑŠÐº Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(137167,3811,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø±Ù¾ÙˆØ±Ù¹',0),(137168,3811,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(137169,3811,'vi','BÃ¡o cÃ¡o thuáº¿ kinh doanh',0),(137170,3811,'af','Verkoopsbelasting Verslag',0),(137171,3811,'ro','Impozit pe vÃ¢nzÄƒri raportul',0),(137172,3811,'et','KÃ¤ibemaksu aruanne',0),(137173,3811,'si','PoroÄilo prometnega davka',0),(137174,3811,'ba','Laporan pajak penjualan',0),(137175,3811,'nl','BTW-rapporten',0),(137176,3811,'fi','ALV-raportti',0),(137177,3811,'no','Mva-rapport',0),(137178,3811,'da','Momsrapport',0),(137179,3811,'ko','íŒë§¤ ì„¸ê¸ˆ ë³´ê³ ì„œ',0),(137180,3811,'he','×“×•×— ×ž×¡ ×ž×›×™×¨×•×ª',0),(137181,3811,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(137182,3811,'zh','é”€å”®ç¨Žçš„æŠ¥å‘Š\r\n',0),(137183,3811,'sv','Momsrapporten',0),(137184,3811,'it','Report IVA',0),(137185,3811,'tl','',0),(137186,3811,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(137187,3811,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(137188,3811,'ms','Laporan cukai jualan',0),(137189,3811,'ar','ØªÙ‚Ø±ÙŠØ± Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(137190,3811,'fr','Rapport de la taxe de vente',0),(137191,3811,'jp','è²©å£²ç¨Žãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(137192,3811,'pt','RelatÃ³rio de imposto sobre vendas',0),(137193,3811,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ ÐŸÐ¾ ÐÐ°Ð»Ð¾Ð³Ñƒ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(137194,3811,'es','Informe de IVA',0),(137195,3811,'de','MehrwertsteuererklÃ¤rung',0),(137196,3811,'en','Sales Tax Report',0),(137197,3812,'is','',0),(137198,3812,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ',0),(137199,3812,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ',0),(137200,3812,'tr','SatÄ±ÅŸ vergileri',0),(137201,3812,'pl','Podatek',0),(137202,3812,'bg','Ð”Ð°Ð½ÑŠÑ†Ð¸ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(137203,3812,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³',0),(137204,3812,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð¿Ð¾Ñ€ÐµÐ·',0),(137205,3812,'vi','Thuáº¿ bÃ¡n hÃ ng',0),(137206,3812,'af','Verkoopsbelastings',0),(137207,3812,'ro','Taxa la vÃ¢nzÄƒri',0),(137208,3812,'et','MÃ¼Ã¼gimaks',0),(137209,3812,'si','Obveznost za prometni davek',0),(137210,3812,'ba','Pajak penjualan',0),(137211,3812,'nl','Belastingen op de verkoop',0),(137212,3812,'fi','ArvonlisÃ¤verot',0),(137213,3812,'no','Merverdiavgift',0),(137214,3812,'da','Moms',0),(137215,3812,'ko','íŒë§¤ ì„¸ê¸ˆ',0),(137216,3812,'he','×ž×™×¡×™ ×ž×›×™×¨×•×ª',0),(137217,3812,'el','Î¦ÏŒÏÎ¿Î¹ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(137218,3812,'zh','é”€å”®ç¨Ž\r\n',0),(137219,3812,'sv','Moms',0),(137220,3812,'it','Imposte sulle vendite',0),(137221,3812,'tl','',0),(137222,3812,'th','&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(137223,3812,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥‹à¤‚',0),(137224,3812,'ms','Cukai jualan',0),(137225,3812,'ar','Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(137226,3812,'fr','Taxes de vente',0),(137227,3812,'jp','è²©å£²ç¨Ž',0),(137228,3812,'pt','Impostos sobre vendas',0),(137229,3812,'ru','ÐÐ°Ð»Ð¾Ð³Ð¸ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(137230,3812,'es','Impuesto Sobre Valor Agregado',0),(137231,3812,'de','Umsatzsteuer',0),(137232,3812,'en','Sales Taxes',0),(137233,3813,'is','',0),(137234,3813,'dr','ÙÙ‡Ø±Ø³Øª Ø¨Ù†Ø¯ÙŠ',0),(137235,3813,'pr','ÙÙ‡Ø±Ø³Øª Ø¨Ù†Ø¯ÙŠ',0),(137236,3813,'tr','Zamanlama',0),(137237,3813,'pl','Planowanie',0),(137238,3813,'bg','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°Ð½Ðµ',0),(137239,3813,'ur','Ø¬Ø¯ÙˆÙ„ Ù…Ù‚Ø±Ø± Ú©Ø±Ù†Û’ ÙˆØ§Ù„Ø§',0),(137240,3813,'sr','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°ÑšÐµ',0),(137241,3813,'vi','Káº¿ hoáº¡ch',0),(137242,3813,'af','Besig',0),(137243,3813,'ro','Programarea',0),(137244,3813,'et','Planeerimine',0),(137245,3813,'si','Razporejanje',0),(137246,3813,'ba','Penjadwalan',0),(137247,3813,'nl','Planning',0),(137248,3813,'fi','Ajoitus',0),(137249,3813,'no','Planlegging',0),(137250,3813,'da','PlanlÃ¦gning',0),(137251,3813,'ko','ì¼ì •',0),(137252,3813,'he','×ª×–×ž×•×Ÿ',0),(137253,3813,'el','Î ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÎ¼ÏŒÏ‚',0),(137254,3813,'zh','è°ƒåº¦\r\n',0),(137255,3813,'sv','SchemalÃ¤ggning',0),(137256,3813,'it','Programmazione',0),(137257,3813,'tl','',0),(137258,3813,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;',0),(137259,3813,'hi','à¤¶à¥‡à¤¡à¥à¤¯à¥‚à¤²à¤¿à¤‚à¤—',0),(137260,3813,'ms','Penjadualan',0),(137261,3813,'ar','Ø¬Ø¯ÙˆÙ„Ø©',0),(137262,3813,'fr','Ordonnancement',0),(137263,3813,'jp','ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒªãƒ³ã‚°',0),(137264,3813,'pt','Agendamento',0),(137265,3813,'ru','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(137266,3813,'es','ProgramaciÃ³n',0),(137267,3813,'de','Planung',0),(137268,3813,'en','Scheduling',0),(137269,3814,'is','',0),(137270,3814,'dr','/ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø¨Ø§Ø±Ú¯ÙŠØ±ÙŠ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡(Ø®Ø±ÙŠØ¯',0),(137271,3814,'pr','ÙÙ‡Ø±Ø³Øª Ø¨Ù†Ø¯ÙŠ / Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø¨Ø§Ø±Ú¯ÙŠØ±ÙŠ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡(Ø®Ø±ÙŠØ¯',0),(137272,3814,'tr','Planlama/dÃ¼kkan raporlarÄ± yÃ¼kleniyor',0),(137273,3814,'pl','Planowanie/sklep Å‚adowanie sprawozdaÅ„',0),(137274,3814,'bg','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°Ð½Ðµ/ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Ð·Ð° Ð·Ð°Ñ€ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸Ñ‚Ðµ',0),(137275,3814,'ur','Ø¬Ø¯ÙˆÙ„ Ù…Ù‚Ø±Ø± Ú©Ø±Ù†Û’ ÙˆØ§Ù„Ø§/Ø±Ù¾ÙˆØ±Ù¹ÛŒÚº Ù„ÙˆÚˆ Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©ÛŒ Ø¯Ú©Ø§Ù†',0),(137276,3814,'sr','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°ÑšÐµ /Ð¡Ñ…Ð¾Ð¿ ÑƒÑ‡Ð¸Ñ‚Ð°Ð²Ð°ÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(137277,3814,'vi','BÃ¡o cÃ¡o táº£i vá»/Ä‘á»‹nh ká»³',0),(137278,3814,'af','Skeduleer/Werkswinkel Vrag Verslae',0),(137279,3814,'ro','Programarea/magazin rapoarte de Ã®ncÄƒrcare',0),(137280,3814,'et','Planeerimine/Shop laadimine aruanded',0),(137281,3814,'si','Razporejanje/Shop nakladanje poroÄila',0),(137282,3814,'ba','Penjadwalan/toko memuat laporan',0),(137283,3814,'nl','Planning/productieverdeling rapporten',0),(137284,3814,'fi','Ajoitus/Shop lastaus raportit',0),(137285,3814,'no','Planlegging/Shop lasting rapporter',0),(137286,3814,'da','PlanlÃ¦gning/produktionsbelastning rapporter',0),(137287,3814,'ko','ì˜ˆì•½/ì‡¼í•‘ ë³´ê³ ì„œ ë¡œë“œ',0),(137288,3814,'he','×ª×–×ž×•×Ÿ/×—× ×•×ª ×˜×¢×™× ×ª ×“×•×—×•×ª',0),(137289,3814,'el','Î ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÎ¼ÏŒÏ‚/ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± Ï†ÏŒÏÏ„Ï‰ÏƒÎ· ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(137290,3814,'zh','è°ƒåº¦/åº—è½½å…¥æŠ¥å‘Š\r\n',0),(137291,3814,'sv','SchemalÃ¤ggning/butik laddar rapporter',0),(137292,3814,'it','Programmazione/negozio caricamento rapporti',0),(137293,3814,'tl','',0),(137294,3814,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;/&#3585;&#3634;&#3619;&#3650;&#3627;&#3621;&#3604;&#3619;&#3657;&#3634;&#3609;&#3588;&#3657;&#3634;',0),(137295,3814,'hi','à¤¶à¥‡à¤¡à¥à¤¯à¥‚à¤²à¤¿à¤‚à¤—/à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤²à¥‹à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨',0),(137296,3814,'ms','Penjadualan/kedai memuatkan Laporan',0),(137297,3814,'ar','ÙˆØ±Ø´Ø© Ø¬Ø¯ÙˆÙ„Ø© ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ±',0),(137298,3814,'fr','Planification/Boutique chargement de rapports',0),(137299,3814,'jp','Scheduling/Shop Loading Reports',0),(137300,3814,'pt','RelatÃ³rios de carregamento agendamento/loja',0),(137301,3814,'ru','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ/Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¾Ð²',0),(137302,3814,'es','ProgramaciÃ³n/Taller Informes de Cargos',0),(137303,3814,'de','Planung/Shop Laden von Berichten',0),(137304,3814,'en','Scheduling/Shop Loading Reports',0),(137305,3815,'is','',0),(137306,3815,'dr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ ',0),(137307,3815,'pr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ ',0),(137308,3815,'tr','Set mali yÄ±l',0),(137309,3815,'pl','Zestaw rok obrachunkowy',0),(137310,3815,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(137311,3815,'ur','Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„',0),(137312,3815,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(137313,3815,'vi','Äáº·t nÄƒm tÃ i chÃ­nh',0),(137314,3815,'af','Stel Fisiese Jaar',0),(137315,3815,'ro','Set Anul Fiscal',0),(137316,3815,'et','Sea majandusaasta',0),(137317,3815,'si','Nastavite proraÄunsko leto',0),(137318,3815,'ba','Set tahun fiskal',0),(137319,3815,'nl','Boekjaar instellen',0),(137320,3815,'fi','MÃ¤Ã¤ritÃ¤ tilikauden',0),(137321,3815,'no','Angi regnskapsÃ¥r',0),(137322,3815,'da','Angiv regnskabsÃ¥ret',0),(137323,3815,'ko','ì„¤ì •ëœ íšŒê³„ ì—°ë„',0),(137324,3815,'he','×”×’×“×¨×ª ×©× ×ª ×”×›×¡×¤×™×',0),(137325,3815,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ ÎŸÎ™ÎšÎŸÎ.',0),(137326,3815,'zh','è®¾ç½®ä¼šè®¡å¹´åº¦\r\n',0),(137327,3815,'sv','Ange rÃ¤kenskapsÃ¥ret',0),(137328,3815,'it','Impostato l\'anno fiscale',0),(137329,3815,'tl','',0),(137330,3815,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3611;&#3637;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(137331,3815,'hi','à¤¸à¥‡à¤Ÿ à¤µà¤¿à¤¤à¥à¤¤à¥€à¤¯ à¤µà¤°à¥à¤·',0),(137332,3815,'ms','Tahun fiskal yang ditetapkan',0),(137333,3815,'ar','ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(137334,3815,'fr','Set exercice',0),(137335,3815,'jp','ä¼šè¨ˆå¹´åº¦ã‚’ã‚»ãƒƒãƒˆ',0),(137336,3815,'pt','ExercÃ­cio conjunto',0),(137337,3815,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´',0),(137338,3815,'es','Configurar Ejercicio Fiscal',0),(137339,3815,'de','Set GeschÃ¤ftsjahr',0),(137340,3815,'en','Set Fiscal Year',0),(137341,3816,'is','',0),(137342,3816,'dr','ØªÙ†Ø¸ÙŠÙ… Ø§ÙˆÙ„ÙˆÙŠØª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(137343,3816,'pr','ØªÙ†Ø¸ÙŠÙ… Ø§ÙˆÙ„ÙˆÙŠØª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(137344,3816,'tr','AlÄ±ÅŸveriÅŸ sepeti iÃ§in tercihlerini ayarlama',0),(137345,3816,'pl','Zestaw preferencjach do koszyka',0),(137346,3816,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½Ð¸Ñ Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐºÐ°Ñ‚Ð°',0),(137347,3816,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ ØªØ±Ø¬ÛŒØ­Ø§Øª Ù…Ø±ØªØ¨ Ú©Ø±ÛŒÚº',0),(137348,3816,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ Ð¶ÐµÑ™ÐµÐ½Ð¸Ñ… Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ð¡Ñ…Ð¾Ð¿Ð¿Ð¸Ð½Ð³ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(137349,3816,'vi','Äáº·t Æ°a thÃ­ch cho giá» hÃ ng',0),(137350,3816,'af','Stel voorkeure vir Shopping Cart',0),(137351,3816,'ro','SetaÅ£i preferinÅ£ele pentru coÅŸul de cumpÄƒrÄƒturi',0),(137352,3816,'et','Sea eelistused ostukorv',0),(137353,3816,'si','DoloÄite nastavitve za nakupovalni voziÄek',0),(137354,3816,'ba','Menetapkan preferensi untuk keranjang belanja',0),(137355,3816,'nl','Stel de voorkeuren voor uw winkelwagentje',0),(137356,3816,'fi','MÃ¤Ã¤rittÃ¤Ã¤ Ostoskori',0),(137357,3816,'no','Angi innstillinger for handlekurv',0),(137358,3816,'da','Angive indstillinger for indk Â¢ bskurv',0),(137359,3816,'ko','ì‡¼í•‘ ë°”êµ¬ë‹ˆì— ëŒ€ í•œ ê¸°ë³¸ ì„¤ì •ëœ ì§€ì •',0),(137360,3816,'he','×œ×”×’×“×™×¨ ×”×¢×“×¤×•×ª ×¢×‘×•×¨ ×¢×’×œ×ª ×§× ×™×•×ª',0),(137361,3816,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ Ï€ÏÎ¿Ï„Î¹Î¼Î®ÏƒÎµÏ‰Î½ Î³Î¹Î± ÎºÎ±Î»Î¬Î¸Î¹ Î±Î³Î¿ÏÏŽÎ½',0),(137362,3816,'zh','è®¾ç½®è´­ç‰©è½¦é¦–é€‰é¡¹\r\n',0),(137363,3816,'sv','Ange instÃ¤llningar fÃ¶r kundvagn',0),(137364,3816,'it','Impostare le preferenze per lo Shopping Cart',0),(137365,3816,'tl','',0),(137366,3816,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3619;&#3606;&#3648;&#3586;&#3655;&#3609;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(137367,3816,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¾à¤¥à¤®à¤¿à¤•à¤¤à¤¾à¤à¤ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(137368,3816,'ms','Set keutamaan untuk belanja',0),(137369,3816,'ar','ØªØ¹ÙŠÙŠÙ† ØªÙØ¶ÙŠÙ„Ø§Øª Ù„Ø¹Ø±Ø¨Ø© Ø§Ù„ØªØ³ÙˆÙ‚',0),(137370,3816,'fr','DÃ©finir des prÃ©fÃ©rences pour votre panier',0),(137371,3816,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°ã‚«ãƒ¼ãƒˆã?®å„ªå…ˆè¨­å®š',0),(137372,3816,'pt','Definir preferÃªncias para o carrinho de compras',0),(137373,3816,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐº Ð´Ð»Ñ ÐºÐ¾Ñ€Ð·Ð¸Ð½Ñ‹',0),(137374,3816,'es','Configurar PreferÃªncias',0),(137375,3816,'de','Festlegen von Einstellungen fÃ¼r Einkaufswagen',0),(137376,3816,'en','Set Preferences for Shopping Cart',0),(137377,3817,'is','',0),(137378,3817,'dr',': Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø´Ø±ÙƒØª Ø®ÙˆØ¯ ØªÙ†Ø¸ÙŠÙ… ÙƒÙ†ÙŠØ¯ . Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙˆØ§Ø±Ø¯Ø§Øª / ØµØ§Ø¯Ø±Ø§Øª ',0),(137379,3817,'pr','ØªÙ†Ø¸ÙŠÙ… Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ : Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø´Ø±ÙƒØª Ø®ÙˆØ¯ ØªÙ†Ø¸ÙŠÙ… ÙƒÙ†ÙŠØ¯ . Ø¬Ø¯ÙˆÙ„ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙˆØ§Ø±Ø¯Ø§Øª / ØµØ§Ø¯Ø±Ø§Øª ',0),(137380,3817,'tr','Mali yÄ±l iÃ§in ÅŸirket ayarlayÄ±n. Alma/verme hesap planÄ±',0),(137381,3817,'pl','Zestaw roku obrachunkowego dla Twojej firmy. Import/eksport planu kont',0),(137382,3817,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð·Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° Ñ„Ð¸Ñ€Ð¼Ð°. Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ/ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¾Ð¿Ð»Ð°Ð½',0),(137383,3817,'ur','Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ø¢Ù¾ Ú©ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…Ø±ØªØ¨ Ú©Ø±ÛŒÚº Û” Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ø¯Ø±Ø¢Ù…Ø¯/Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ú†Ø§Ø±Ù¹',0),(137384,3817,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð·Ð° Ð²Ð°ÑˆÐµ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ðµ. Ð£Ð²Ð¾Ð· Ð¸ Ð¸Ð·Ð²Ð¾Ð· ÐºÐ¾Ð½Ñ‚Ð½Ð¸ Ð¿Ð»Ð°Ð½',0),(137385,3817,'vi','Äáº·t nÄƒm tÃ i chÃ­nh cho cty nÃ y. Biá»ƒu Ä‘á»“ Nháº­p/Xuáº¥t cá»§a TK',0),(137386,3817,'af','Stel Fisiese Jaar vir U Onderneming. Tabel van Rekeninge Invoer/Uitvoer ',0),(137387,3817,'ro','Set anului Fiscal pentru compania dumneavoastrÄƒ. Import/Export de conturi',0),(137388,3817,'et','Seada finantsaasta firmale. Impordi/ekspordi kontoplaani',0),(137389,3817,'si','Nastavite proraÄunsko leto za vaÅ¡e podjetje. Uvoz/izvoz Kontni naÄrt',0),(137390,3817,'ba','Menetapkan tahun fiskal untuk perusahaan Anda. Impor/ekspor kode akun',0),(137391,3817,'nl','Het fiscale jaar ingesteld voor uw bedrijf. Rekeningschema importeren/exporteren',0),(137392,3817,'fi','MÃ¤Ã¤rittÃ¤Ã¤ tilivuoden yrityksellesi. Tuonti/vienti Tilikartta',0),(137393,3817,'no','Angi regnskapsÃ¥ret for firmaet. Import/eksport kontoplanen',0),(137394,3817,'da','Angiv regnskabsÃ¥ret for din virksomhed. Import/eksport kontoplan',0),(137395,3817,'ko','ê·€í•˜ì˜ íšŒì‚¬ì— ëŒ€ í•œ íšŒê³„ ì—°ë„ ì„¤ì • í•©ë‹ˆë‹¤. ê°€ì ¸ì˜¤ê¸°/ë‚´ë³´ë‚´ê¸° ê³„ì • ì°¨íŠ¸',0),(137396,3817,'he','×”×’×“×¨ ××ª ×©× ×ª ×”×›×¡×¤×™× ×©×œ ×”×—×‘×¨×” ×©×œ×š. ×™×™×‘×•×/×™×™×¦×•× ×ª×¨×©×™× ×ª×™×§×™ ×œ×§×•×—×•×ª',0),(137397,3817,'el','Î Î¿Ï… Ï„Î¿ Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÏƒÎ±Ï‚. Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ¾Î±Î³Ï‰Î³Î® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ‡Î­Î´Î¹Î¿',0),(137398,3817,'zh','è®¾å®šä¸ºè´µå…¬å¸è´¢å¹´ã€‚å¯¼å…¥/å¯¼å‡ºå¸ç›®å›¾è¡¨\r\n',0),(137399,3817,'sv','Ange rÃ¤kenskapsÃ¥ret fÃ¶r ditt fÃ¶retag. Importera/exportera kontoplanen',0),(137400,3817,'it','Impostare l\'anno fiscale per la vostra azienda. Importazione/esportazione piano dei conti',0),(137401,3817,'tl','',0),(137402,3817,'th','Set the Fiscal Year for Your Company. Import/Export Chart of Accounts',0),(137403,3817,'hi','à¤µà¤¿à¤¤à¥à¤¤ à¤µà¤°à¥à¤· à¤†à¤ªà¤•à¥€ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚à¥¤ à¤†à¤¯à¤¾à¤¤/à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¤¾ à¤šà¤¾à¤°à¥à¤Ÿ',0),(137404,3817,'ms','Menetapkan tahun fiskal bagi syarikat anda. Import/Eksport Carta akaun',0),(137405,3817,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ù„Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ. Ù…Ø®Ø·Ø· Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯/Ø§Ù„ØªØµØ¯ÙŠØ± Ù…Ù† Ø­Ø³Ø§Ø¨Ø§Øª',0),(137406,3817,'fr','L\'exercice de la valeur pour votre entreprise. Importation/exportation comptable',0),(137407,3817,'jp','ä¼šç¤¾ã?®ä¼šè¨ˆå¹´åº¦ã‚’è¨­å®šã?—ã€?å‹˜å®šç§‘ç›®ä¸€è¦§è¡¨ã‚’ã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆ/ã‚¨ã‚¯ã‚¹ãƒ?ãƒ¼ãƒˆã?™ã‚‹ã€‚',0),(137408,3817,'pt','Conjunto do ano Fiscal para sua empresa. Plano de contas de importaÃ§Ã£o/exportaÃ§Ã£o',0),(137409,3817,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´ Ð´Ð»Ñ Ð²Ð°ÑˆÐµÐ¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸. Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚/ÑÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð¿Ð»Ð°Ð½Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(137410,3817,'es','Configurar el Ejercicio Fiscal para su Empresa. Importar/Exportar CÃ¡talogo de Cuentas',0),(137411,3817,'de','Legen Sie das GeschÃ¤ftsjahr, fÃ¼r Ihr Unternehmen. Import/Export Kontenplan',0),(137412,3817,'en','Set the Fiscal Year for Your Company. Import/Export Chart of Accounts',0),(137413,3818,'is','',0),(137414,3818,'dr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯Ù‰ Ø¨Ø±Ø§ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(137415,3818,'pr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯Ù‰ Ø¨Ø±Ø§ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(137416,3818,'tr','Derecelendirme Ã¶lÃ§eÄŸi personel deÄŸerlendirme kullanmak iÃ§in ayarlama',0),(137417,3818,'pl','UmieszczaÃ¦ w gÃ³rze ocena skali do uÅ¼ytku w opinii pracownikÃ³w',0),(137418,3818,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´Ðµ ÑÐºÐ°Ð»Ð° Ð·Ð° Ð¾Ñ†ÐµÐ½ÐºÐ° Ð·Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð² ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¾Ñ‚Ð·Ð¸Ð²Ð°',0),(137419,3818,'ur','Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©Û’ Ù¾ÛŒÙ…Ø§Ù†Û’ Ù…ÛŒÚº Ù…Ù„Ø§Ø²Ù… Ø¬Ø§Ø¦Ø²Û’ Ù…ÛŒÚº Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ø§Ù¾',0),(137420,3818,'sr','ÐŸÐ¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð¾Ñ†ÐµÐ½Ð° Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ Ñƒ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ ÐºÑ€Ð¸Ñ‚Ð¸ÐºÐµ',0),(137421,3818,'vi','Äáº·t thang Ä‘Ã¡nh giÃ¡ Ä‘á»ƒ dÃ¹ng trong Ä‘Ã¡nh giÃ¡ nhÃ¢n viÃªn',0),(137422,3818,'af','Stel gradering skaal vir gebruik in werknemer resensies',0),(137423,3818,'ro','ÃŽnfiinÅ£at Rating Scale pentru utilizarea Ã®n angajat clienÅ£ilor',0),(137424,3818,'et','Saate seadistada hindamisskaala kasutamine tÃ¶Ã¶taja arvustust',0),(137425,3818,'si','Nastavite ocenjevalna lestvica za uporabo v zaposlenega gostov',0),(137426,3818,'ba','Mengatur skala Rating untuk digunakan dalam karyawan ulasan',0),(137427,3818,'nl','Instellen van Rating schaal voor gebruik in werknemer beoordelingen',0),(137428,3818,'fi','MÃ¤Ã¤ritÃ¤ Arviointiasteikko kÃ¤ytettÃ¤vÃ¤ksi tyÃ¶ntekijÃ¤n arvioita',0),(137429,3818,'no','Definere vurderingsskala for bruk i ansatte',0),(137430,3818,'da','Oprette Rating Scale til brug i medarbejder anmeldelser',0),(137431,3818,'ko','ì§ì› í›„ê¸°ì— ì‚¬ìš© í•˜ê¸° ìœ„í•´ í‰ê°€ ê·œëª¨ ì„¤ì •',0),(137432,3818,'he','×”×’×“×¨×ª ×¡×•×œ× ×“×™×¨×•×’ ×œ×©×™×ž×•×© ×”×¢×•×‘×“ ×”×“×¢×ª',0),(137433,3818,'el','ÎˆÏ‡ÎµÎ¹ ÏƒÏ…ÏƒÏ„Î±Î¸ÎµÎ¯ ÎºÎ»Î¯Î¼Î±ÎºÎ± ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ·Ï‚ Î³Î¹Î± Ï‡ÏÎ®ÏƒÎ· ÏƒÎµ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿ ÏƒÏ‡ÏŒÎ»Î¹Î±',0),(137434,3818,'zh','è®¾ç½®ç”¨äºŽå‘˜å·¥å®¡æŸ¥ä¸­çš„è¯„å®šé‡è¡¨\r\n',0),(137435,3818,'sv','StÃ¤ll in skala fÃ¶r anvÃ¤ndning i anstÃ¤lld recensioner',0),(137436,3818,'it','Impostare la scala di valutazione per l\'uso in dipendente recensioni',0),(137437,3818,'tl','',0),(137438,3818,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3605;&#3633;&#3623;&#3623;&#3633;&#3604;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3651;&#3594;&#3657;&#3651;&#3609;&#3',0),(137439,3818,'hi','à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¸à¥à¤•à¥‡à¤² à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤®à¥‡à¤‚ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(137440,3818,'ms','Menubuhkan skala penarafan untuk kegunaan pekerja Ulasan',0),(137441,3818,'ar','Ù‚Ù… Ø¨Ø¥Ø¹Ø¯Ø§Ø¯ \"Ù…Ù‚ÙŠØ§Ø³ ØªØµÙ†ÙŠÙ\" Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…Ù‡Ø§ ÙÙŠ \"Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ù…ÙˆØ¸Ù\"',0),(137442,3818,'fr','Mettre en place une Ã©chelle d\'Ã©valuation pour une utilisation dans les commentaires de l\'employÃ©',0),(137443,3818,'jp','å¾“æ¥­å“¡è©•ä¾¡ã?«ä½¿ç”¨ã?™ã‚‹è©•ä¾¡å°ºåº¦ã?®è¨­å®š',0),(137444,3818,'pt','Configurar a escala de classificaÃ§Ã£o para uso em avaliaÃ§Ãµes de empregado',0),(137445,3818,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³Ð¾Ð²Ð¾Ð¹ ÑˆÐºÐ°Ð»Ðµ Ð´Ð»Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð² ÐžÑ‚Ð·Ñ‹Ð²Ñ‹ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(137446,3818,'es','Configurar Escala de ValuaciÃ³n para Uso en Revisiones de Empleados',0),(137447,3818,'de','Rating Scale fÃ¼r den Einsatz in Mitarbeiterbeurteilungen einrichten',0),(137448,3818,'en','Set up Rating Scale for Use in Employee Reviews',0),(137449,3819,'is','',0),(137450,3819,'dr','- ÙØ±Ù…Ø§ÛŒØ´ÙŠ ÙƒØ±Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ Ø®ÙˆØ¯',0),(137451,3819,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§ÙŠÙ…ÙŠÙ„- Ø³ÙØ§Ø±Ø´ÙŠ ÙƒØ±Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ Ø®ÙˆØ¯',0),(137452,3819,'tr','E-postanÄ±zÄ± Ã¶zelleÅŸtirin',0),(137453,3819,'pl','Dostosuj swÃ³j adres E-mail',0),(137454,3819,'bg','ÐŸÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ð¿Ð¾Ñ‰Ð°',0),(137455,3819,'ur','Ø¢Ù¾ Ú©Û’ Ø§ÛŒ Ù…ÛŒÙ„ ØªØ®ØµÛŒØµ Ú©Ø±ÛŒÚº',0),(137456,3819,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’Ð°Ð²Ð°ÑšÐµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(137457,3819,'vi','Chá»‰nh sá»­a Email cá»§a báº¡n',0),(137458,3819,'af','Pas u E-pos aan',0),(137459,3819,'ro','PersonalizaÅ£i adresa de E-mail',0),(137460,3819,'et','Kohalda e-kirja',0),(137461,3819,'si','Prilagodite svojo e-poÅ¡to',0),(137462,3819,'ba','Menyesuaikan E-mail',0),(137463,3819,'nl','Uw e-mailberichten aanpassen',0),(137464,3819,'fi','Mukauta sÃ¤hkÃ¶postisi',0),(137465,3819,'no','Tilpasse e-post',0),(137466,3819,'da','Tilpas din E-mail',0),(137467,3819,'ko','ì „ìž ë©”ì¼ ì‚¬ìš©ìž ì§€ì •',0),(137468,3819,'he','×”×ª×× ××™×©×™×ª ××ª ×”×“×•××¨ ×”××œ×§×˜×¨×•× ×™ ×©×œ×š',0),(137469,3819,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼ÏŒÏƒÎµÏ„Îµ ÏƒÎ±Ï‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(137470,3819,'zh','è‡ªå®šä¹‰æ‚¨çš„ç”µå­é‚®ä»¶\r\n',0),(137471,3819,'sv','Anpassa din e-post',0),(137472,3819,'it','Personalizza la tua E-mail',0),(137473,3819,'tl','',0),(137474,3819,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(137475,3819,'hi','à¤†à¤ªà¤•à¥‡ à¤ˆ-à¤®à¥‡à¤² à¤•à¥‹ à¤…à¤¨à¥à¤•à¥‚à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(137476,3819,'ms','Sesuaikan e-mel anda',0),(137477,3819,'ar','ØªØ®ØµÙŠØµ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(137478,3819,'fr','Personnaliser votre messagerie',0),(137479,3819,'jp','Eãƒ¡ãƒ¼ãƒ«ã?®ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚º',0),(137480,3819,'pt','Personalize seu E-mail',0),(137481,3819,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(137482,3819,'es','Personalizar su Email',0),(137483,3819,'de','Ihre e-Mail-Adresse anpassen',0),(137484,3819,'en','Customize your E-mail',0),(137485,3820,'is','',0),(137486,3820,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(137487,3820,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(137488,3820,'tr','Kurulum - genel muhasebe',0),(137489,3820,'pl','Instalator - ksiÄ™gi',0),(137490,3820,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - ÐºÐ½Ð¸Ð³Ð°',0),(137491,3820,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ - Ú©Ú¾Ø§ØªØ§',0),(137492,3820,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - ÐºÑšÐ¸Ð³Ðµ',0),(137493,3820,'vi','Setup - Sá»• cÃ¡i',0),(137494,3820,'af','Opstelling - Grootboek',0),(137495,3820,'ro','Configurare - reg.',0),(137496,3820,'et','Seaded',0),(137497,3820,'si','Setup - knjige',0),(137498,3820,'ba','Pengaturan - Ledger',0),(137499,3820,'nl','Setup - Ledger',0),(137500,3820,'fi','Setup - kirjanpidon',0),(137501,3820,'no','Oppsett - finans',0),(137502,3820,'da','Setup - finans',0),(137503,3820,'ko','ì„¤ì •-ë ˆì €',0),(137504,3820,'he','×”×’×“×¨×•×ª - ×—×©×‘×•× ××•×ª',0),(137505,3820,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· - Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®',0),(137506,3820,'zh','è®¾ç½® -åˆ†ç±»å¸\r\n',0),(137507,3820,'sv','Setup - redovisning',0),(137508,3820,'it','Installazione - contabilitÃ ',0),(137509,3820,'tl','',0),(137510,3820,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634; - &#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(137511,3820,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - à¤–à¤¾à¤¤à¤¾à¤¬à¤¹à¥€',0),(137512,3820,'ms','Persediaan - Lejar',0),(137513,3820,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø°',0),(137514,3820,'fr','Installation - grand livre',0),(137515,3820,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ãƒ¼',0),(137516,3820,'pt','InstalaÃ§Ã£o - Ledger',0),(137517,3820,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ - Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÐšÐ½Ð¸Ð³Ð°',0),(137518,3820,'es','ConfiguraciÃ³n - Libro Mayor',0),(137519,3820,'de','Setup - Ledger',0),(137520,3820,'en','Setup - Ledger',0),(137521,3821,'is','',0),(137522,3821,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(137523,3821,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(137524,3821,'tr','Kurulum - stok',0),(137525,3821,'pl','Instalator - spis',0),(137526,3821,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ð·Ð°Ð¿Ð°ÑÐ¸',0),(137527,3821,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ - Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(137528,3821,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - Ð·Ð°Ð»Ð¸Ñ…Ðµ',0),(137529,3821,'vi','Setup - HÃ ng Trong Kho',0),(137530,3821,'af','Opstelling - Voorraad',0),(137531,3821,'ro','Configurare - inventar',0),(137532,3821,'et','Seaded',0),(137533,3821,'si','Setup - zaloge',0),(137534,3821,'ba','Pengaturan - persediaan',0),(137535,3821,'nl','Setup - inventaris',0),(137536,3821,'fi','Asetukset - varasto',0),(137537,3821,'no','Oppsett - lager',0),(137538,3821,'da','Setup - lager',0),(137539,3821,'ko','ì„¤ì •-ìž¬ê³ ',0),(137540,3821,'he','×”×’×“×¨×•×ª - ×ž×œ××™',0),(137541,3821,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· - Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(137542,3821,'zh','è®¾ç½®- åº“å­˜\r\n',0),(137543,3821,'sv','Setup - inventering',0),(137544,3821,'it','Installazione - inventario',0),(137545,3821,'tl','',0),(137546,3821,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634; - &#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(137547,3821,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€',0),(137548,3821,'ms','Persediaan - inventori',0),(137549,3821,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(137550,3821,'fr','Installation - l\'inventaire',0),(137551,3821,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ãƒ¼åœ¨åº«',0),(137552,3821,'pt','InstalaÃ§Ã£o - inventÃ¡rio',0),(137553,3821,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ - Ð¡ÐºÐ»Ð°Ð´',0),(137554,3821,'es','ConfiguraciÃ³n - Inventario',0),(137555,3821,'de','Setup - Inventar',0),(137556,3821,'en','Setup - Inventory',0),(137557,3822,'is','',0),(137558,3822,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(137559,3822,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(137560,3822,'tr','Kurulum - BorÃ§lar',0),(137561,3822,'pl','Setup - zobowiÄ…zania',0),(137562,3822,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(137563,3822,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ - Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³',0),(137564,3822,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(137565,3822,'vi','Setup Pháº£i Tráº£',0),(137566,3822,'af','Opstelling - Uitgawes (RB)',0),(137567,3822,'ro','Configurare - datorii',0),(137568,3822,'et','Seaded',0),(137569,3822,'si','Namestitev - obveznosti',0),(137570,3822,'ba','Pengaturan - hutang',0),(137571,3822,'nl','Setup - schulden',0),(137572,3822,'fi','Setup - Ostovelat',0),(137573,3822,'no','Oppsett - leverandÃ¸rgjeld',0),(137574,3822,'da','Setup - gÃ¦ld',0),(137575,3822,'ko','ì„¤ì •-ë¯¸ì§€ê¸‰ê¸ˆ',0),(137576,3822,'he','×”×’×“×¨×•×ª - ×œ×ª×©×œ×•×',0),(137577,3822,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· - Î Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(137578,3822,'zh','è®¾ç½® -åº”ä»˜è´¦æ¬¾\r\n',0),(137579,3822,'sv','Setup - LeverantÃ¶rsskulder',0),(137580,3822,'it','Installazione - debiti',0),(137581,3822,'tl','',0),(137582,3822,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634; - &#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(137583,3822,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - Payables',0),(137584,3822,'ms','Persediaan - pemiutang',0),(137585,3822,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(137586,3822,'fr','Configuration - comptes fournisseurs',0),(137587,3822,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ãƒ¼å¾Œæ‰•ã?„',0),(137588,3822,'pt','ConfiguraÃ§Ã£o - pagamentos',0),(137589,3822,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ - ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ°',0),(137590,3822,'es','ConfiguraciÃ³n - Proveedores',0),(137591,3822,'de','Setup - Verbindlichkeiten',0),(137592,3822,'en','Setup - Payables',0),(137593,3823,'is','',0),(137594,3823,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(137595,3823,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(137596,3823,'tr','Kurulum - bordro',0),(137597,3823,'pl','Instalator - listy pÅ‚ac',0),(137598,3823,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ð¢Ð Ð—',0),(137599,3823,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ - Ù¾Û’ Ø±ÙˆÙ„',0),(137600,3823,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - Ð¿Ð»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº',0),(137601,3823,'vi','Setup Báº£ng LÆ°Æ¡ng',0),(137602,3823,'af','Opstelling - Loonrol',0),(137603,3823,'ro','Configurare - salarizare',0),(137604,3823,'et','Seaded',0),(137605,3823,'si','Setup - izplaÄane plaÄe',0),(137606,3823,'ba','Pengaturan - penggajian',0),(137607,3823,'nl','Setup - Payroll',0),(137608,3823,'fi','Setup - Palkanlaskenta',0),(137609,3823,'no','Oppsett - lÃ¸nn',0),(137610,3823,'da','Setup - lÃ¸n',0),(137611,3823,'ko','ì„¤ì •-ê¸‰ì—¬',0),(137612,3823,'he','×”×’×“×¨×•×ª - ×ž×©×›×•×¨×•×ª',0),(137613,3823,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· - Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(137614,3823,'zh','è®¾ç½®- å·¥èµ„\r\n',0),(137615,3823,'sv','Setup - lÃ¶n',0),(137616,3823,'it','Installazione - Payroll',0),(137617,3823,'tl','',0),(137618,3823,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634; - &#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(137619,3823,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - à¤ªà¥‡à¤°à¥‹à¤²',0),(137620,3823,'ms','Persediaan - gaji',0),(137621,3823,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(137622,3823,'fr','Installation - paie',0),(137623,3823,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ãƒ¼äººä»¶è²»',0),(137624,3823,'pt','InstalaÃ§Ã£o - folha de pagamento',0),(137625,3823,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ - ÐÐ°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ Ð—/ÐŸÐ»Ð°Ñ‚Ñ‹',0),(137626,3823,'es','ConfiguraciÃ³n - NÃ³mina',0),(137627,3823,'de','Setup - Abrechnung',0),(137628,3823,'en','Setup - Payroll',0),(137629,3824,'is','',0),(137630,3824,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ',0),(137631,3824,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ',0),(137632,3824,'tr','FaturalandÄ±rma kurulum',0),(137633,3824,'pl','Konfiguracja fakturowania',0),(137634,3824,'bg','Ð˜Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ñ‰Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(137635,3824,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(137636,3824,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ð¾Ð½Ð¸ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(137637,3824,'vi','Setup - Pháº£i Thu',0),(137638,3824,'af','Opstelling fakturering',0),(137639,3824,'ro','Instalare de facturare',0),(137640,3824,'et','Seaded',0),(137641,3824,'si','Nastavitev obraÄuna',0),(137642,3824,'ba','Setup penagihan',0),(137643,3824,'nl','Setup facturering',0),(137644,3824,'fi','MÃ¤Ã¤ritettÃ¤vÃ¤ laskutus',0),(137645,3824,'no','Installasjonsprogrammet fakturering',0),(137646,3824,'da','OpsÃ¦tning af fakturering',0),(137647,3824,'ko','ê²°ì œ ì„¤ì •',0),(137648,3824,'he','×—×™×•×‘ ×”×”×ª×§× ×”',0),(137649,3824,'el','Î§ÏÎ­Ï‰ÏƒÎ· ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(137650,3824,'zh','è®¾ç½® -åº”æ”¶è´¦æ¬¾\r\n',0),(137651,3824,'sv','Installationsprogrammet fÃ¶r fakturering',0),(137652,3824,'it','Installazione di fatturazione',0),(137653,3824,'tl','',0),(137654,3824,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634; - &#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(137655,3824,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¬à¤¿à¤²à¤¿à¤‚à¤—',0),(137656,3824,'ms','Persediaan bil',0),(137657,3824,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(137658,3824,'fr','Le programme d\'installation de facturation',0),(137659,3824,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ãƒ¼å£²æŽ›é‡‘',0),(137660,3824,'pt','CobranÃ§a de instalaÃ§Ã£o',0),(137661,3824,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ - ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð°',0),(137662,3824,'es','ConfiguraciÃ³n - Cuentas por Cobrar',0),(137663,3824,'de','Setup-Abrechnung',0),(137664,3824,'en','Setup Billing',0),(137665,3825,'is','',0),(137666,3825,'dr',': Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ Ø®Ø§Ø±Ø¬ÙŠ â€“Ø¨Ø±Ú¯Ù‡ Ù‡Ø§ÙŠ ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø§Øµ',0),(137667,3825,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙƒÙ„ÙŠ : Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ Ø®Ø§Ø±Ø¬ÙŠ â€“Ø¨Ø±Ú¯Ù‡ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø§Øµ',0),(137668,3825,'tr','DÄ±ÅŸ alÄ±mlarda Ã¶zel sipariÅŸ kaÄŸÄ±tlarÄ± standart iÅŸaretlemeleri',0),(137669,3825,'pl','Standardowych znacznikÃ³w poza zakupÃ³w, specjalne zamÃ³wienia dokumentÃ³w',0),(137670,3825,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Markups Ð·Ð° Ð²ÑŠÐ½ÑˆÐ½Ð¸ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸, ÑÐ¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(137671,3825,'ur','Ø¨Ø§ÛØ± Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒØŒ Ø®ØµÙˆØµÛŒ Ø¢Ø±ÚˆØ± Ú©Û’ Ú©Ø§ØºØ°Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø¢Ø±Ú©Ùˆ',0),(137672,3825,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ ÐœÐ°Ñ€ÐºÑƒÐ¿Ñ Ð·Ð° Ð¸Ð·Ð²Ð°Ð½ Ð½Ð°Ð±Ð°Ð²ÐºÐµ, ÑÐ¿ÐµÑ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ Ð¿Ð°Ð¿Ð¸Ñ€Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(137673,3825,'vi','CÃ´ng thÃªm chuáº©n vá»›i dá»‹ch vá»¥ bÃªn ngoÃ i, Trang Ä‘Æ¡n hÃ ng Ä‘áº·c biá»‡t',0),(137674,3825,'af','Standaard Markups vir buite aankope, spesiale bestelling vraestelle',0),(137675,3825,'ro','Adaosurilor standard pentru achiziÅ£iile din afara, hÃ¢rtiile speciale',0),(137676,3825,'et','Standard mÃ¤rked vÃ¤ljastpoolt ostu tellimuse eripabereid',0),(137677,3825,'si','Standardnih oznak za nakupe zunaj, poseben vrstni red dokumentov',0),(137678,3825,'ba','Markup standar untuk pembelian di luar, karya-karya pesanan khusus',0),(137679,3825,'nl','Standaard markeringen voor buiten aankopen, speciale Order Papers',0),(137680,3825,'fi','Standard katteet ulkopuolella ostoksia, jotta erikoispaperit',0),(137681,3825,'no','Standard markeringer for utenfor kjÃ¸p for spesialpapir',0),(137682,3825,'da','Standard opmÃ¦rkninger for uden for indkÃ¸b, ordre specialpapir',0),(137683,3825,'ko','ì™¸ë¶€ êµ¬ë§¤, íŠ¹ìˆ˜ ì£¼ë¬¸ ìš©ì§€ì— ëŒ€ í•œ í‘œì¤€ ë§ˆí¬ì—…',0),(137684,3825,'he','×¡×™×ž×•× ×™× ×¡×˜× ×“×¨×˜×™ ×¢×‘×•×¨ ×¨×›×™×©×•×ª ×ž×‘×—×•×¥, ×¡×“×¨ ×“×¤×™× ×ž×™×•×—×“×™×',0),(137685,3825,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ Ï€ÎµÏÎ¹Î¸ÏŽÏÎ¹Î± ÎºÎ­ÏÎ´Î¿Ï…Ï‚ Î³Î¹Î± Ï„Î¹Ï‚ ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÎ­Ï‚ Î±Î³Î¿ÏÎ­Ï‚, ÎµÎ¹Î´Î¹ÎºÎ¬ Ï‡Î±ÏÏ„Î¹Î¬',0),(137686,3825,'zh','æ ‡å‡†æ ‡è®°å¤–éƒ¨é‡‡è´­ï¼Œç‰¹æ®Šè®¢å•æ–‡ä»¶\r\n',0),(137687,3825,'sv','Standard markeringar fÃ¶r utanfÃ¶r inkÃ¶p, bestÃ¤lla specialpapper',0),(137688,3825,'it','Marcature standard per acquisti di fuori, carte speciali di ordine',0),(137689,3825,'tl','',0),(137690,3825,'th','Standard Markups for Outside Purchases, Special Order Papers',0),(137691,3825,'hi','à¤¬à¤¾à¤¹à¤° à¤–à¤°à¥€à¤¦, à¤µà¤¿à¤¶à¥‡à¤· à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤•à¤¾à¤—à¤œà¤¾à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¨à¤• Markups',0),(137692,3825,'ms','Standard sedia untuk pembelian di luar, kertas-kertas perintah Khas',0),(137693,3825,'ar','Ø¹Ù„Ø§Ù…Ø§Øª Ù‚ÙŠØ§Ø³ÙŠØ© Ù„Ø®Ø§Ø±Ø¬ Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø´Ø±Ø§Ø¡ØŒ Ø®Ø§ØµØ© ØªØ±ØªÙŠØ¨ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚',0),(137694,3825,'fr','Annotations standards pour des achats externes, des papiers spÃ©ciaux d\'ordre',0),(137695,3825,'jp','å¤–éƒ¨è³¼å…¥ã‚„ç‰¹åˆ¥æ³¨æ–‡ç´™ã?ªã?©ã?®æ¨™æº–å€¤ä¸Šã?’',0),(137696,3825,'pt','MarcaÃ§Ãµes padrÃ£o para compras fora, papÃ©is especiais de ordem',0),(137697,3825,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ Ð½Ð°Ñ†ÐµÐ½ÐºÐ¸ Ð´Ð»Ñ Ð²Ð½ÐµÑˆÐ½Ð¸Ñ… Ð·Ð°ÐºÑƒÐ¿Ð¾Ðº, Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚',0),(137698,3825,'es','Encarecimientos EstÃ¡ndares para Compras Afueras, Documentos de Ordenes Especiales',0),(137699,3825,'de','Standard-Markierungen fÃ¼r auÃŸen EinkÃ¤ufe Reihenfolge Spezialpapiere',0),(137700,3825,'en','Standard Markups for Outside Purchases, Special Order Papers',0),(137701,3826,'is','',0),(137702,3826,'dr',': Ø«Ø¨Øª / Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(137703,3826,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ù…Ø§Ø´ÙŠÙ†ÙŠ : Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(137704,3826,'tr','Makine aile hesaplamalar girin/gÃ¼ncelleme',0),(137705,3826,'pl','WprowadÅº/aktualizacja maszyny obliczeÅ„ dla rodzin z dzieÄ‡mi',0),(137706,3826,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(137707,3826,'ur','Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù† Ø­Ø³Ø§Ø¨ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(137708,3826,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ðµ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(137709,3826,'vi','Nháº­p/Cáº­p nháº­t tÃ­nh toÃ¡n dÃ²ng mÃ¡y gia Ä‘Ã¬nh',0),(137710,3826,'af','Tik/Update masjien familie berekeninge',0),(137711,3826,'ro','IntroduceÅ£i/actualizare masina familiei calcule',0),(137712,3826,'et','Kohapeal pere arvutused sisestamine/ajakohastamine',0),(137713,3826,'si','Vnesite/posodobitev stroj druÅ¾ine izraÄuni',0),(137714,3826,'ba','Masukkan/Update mesin keluarga perhitungan',0),(137715,3826,'nl','Machine familie berekeningen invoeren/bijwerken',0),(137716,3826,'fi','PÃ¤ivittÃ¤minen kone perhe laskelmat',0),(137717,3826,'no','Angi/Oppdater maskin familien beregninger',0),(137718,3826,'da','Indtaste/opdatere maskinen familie beregninger',0),(137719,3826,'ko','ê¸°ê³„ ê°€ì¡± ê³„ì‚° ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(137720,3826,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×ž×—×©×‘ ×—×™×©×•×‘×™ ×”×ž×©×¤×—×”',0),(137721,3826,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î·Ï‡Î±Î½Î® Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(137722,3826,'zh','è¾“å…¥/æ›´æ–°æœºç³»åˆ—è®¡ç®—\r\n',0),(137723,3826,'sv','Ange/uppdatera maskinen familj berÃ¤kningar',0),(137724,3826,'it','Inserisci/Aggiorna macchina famiglia calcoli',0),(137725,3826,'tl','',0),(137726,3826,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(137727,3826,'hi','à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤—à¤£à¤¨à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(137728,3826,'ms','Masukkan/Kemaskini Mesin pengiraan keluarga',0),(137729,3826,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³Ø±Ø© Ø¢Ù„Ø©',0),(137730,3826,'fr','Entrez/mise Ã  jour Machine familiale calculs',0),(137731,3826,'jp','æ©Ÿæ¢°ç³»çµ±è¨ˆç®—ã?®å…¥åŠ›/æ›´æ–°',0),(137732,3826,'pt','Inserir/atualizar cÃ¡lculos famÃ­lia mÃ¡quina',0),(137733,3826,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ ÑÐµÐ¼ÑŒÐ¸ Ñ€Ð°ÑÑ‡ÐµÑ‚Ñ‹',0),(137734,3826,'es','Introducir/Actualizar CÃ¡lculos de Familia de MÃ¡quinas',0),(137735,3826,'de','Geben Sie/Update Maschine Familie Berechnungen',0),(137736,3826,'en','Enter/Update Machine Family Calculations',0),(137737,3827,'is','',0),(137738,3827,'dr',': Ø«Ø¨Øª / Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(137739,3827,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø§Ø´ÙŠÙ†ÙŠ : Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(137740,3827,'tr','Makine aile bilgileri girin/gÃ¼ncelleme',0),(137741,3827,'pl','WprowadÅº/aktualizacja informacji rodziny maszyny',0),(137742,3827,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(137743,3827,'ur','Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(137744,3827,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(137745,3827,'vi','Nháº­p/Cáº­p nháº­t thÃ´ng tin dÃ²ng mÃ¡y gia Ä‘Ã¬nh',0),(137746,3827,'af','Tik/Update masjien familie inligting',0),(137747,3827,'ro','IntroduceÅ£i/actualizare maÅŸinÄƒ de familie informaÅ£ii',0),(137748,3827,'et','Masin perekonna informatsiooni sisestamine/ajakohastamine',0),(137749,3827,'si','Vnos/posodobitev stroj druÅ¾inske podatke',0),(137750,3827,'ba','Masukkan/Update informasi keluarga mesin',0),(137751,3827,'nl','Machine familie informatie invoeren/bijwerken',0),(137752,3827,'fi','PÃ¤ivittÃ¤minen kone perheen tiedot',0),(137753,3827,'no','Angi/oppdatere maskinen familie informasjon',0),(137754,3827,'da','Indtaste/opdatere maskinen familiemÃ¦ssige oplysninger',0),(137755,3827,'ko','ê¸°ê³„ ê°€ì¡± ì •ë³´ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(137756,3827,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×¤×¨×˜×™ ×”×ž×©×¤×—×” ×ž×›×•× ×”',0),(137757,3827,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¿Î¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î·Ï‡Î±Î½Î®Î¼Î±Ï„Î¿Ï‚',0),(137758,3827,'zh','è¾“å…¥/æ›´æ–°æœºç³»åˆ—ä¿¡æ¯\r\n',0),(137759,3827,'sv','Ange/uppdatera familj maskininformation',0),(137760,3827,'it','Inserisci/Aggiorna informazioni sulla famiglia di macchina',0),(137761,3827,'tl','',0),(137762,3827,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(137763,3827,'hi','à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(137764,3827,'ms','Masukkan/Kemaskini Maklumat keluarga Mesin',0),(137765,3827,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¬Ù‡Ø§Ø² Ø§Ù„Ø£Ø³Ø±Ø©',0),(137766,3827,'fr','Entrez/mise Ã  jour des renseignements sur la famille Machine',0),(137767,3827,'jp','æ©Ÿæ¢°ç³»çµ±æƒ…å ±ã?®å…¥åŠ›/æ›´æ–°',0),(137768,3827,'pt','Inserir/atualizar InformaÃ§Ã£o da famÃ­lia mÃ¡quina',0),(137769,3827,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ ÑÐµÐ¼ÑŒÐµ',0),(137770,3827,'es','Introducir/Actualizar InformaciÃ³n de Familia de MÃ¡quinas',0),(137771,3827,'de','Geben Sie/Update Maschine Familieninformationen',0),(137772,3827,'en','Enter/Update Machine Family Information',0),(137773,3828,'is','',0),(137774,3828,'dr',': Ø«Ø¨Øª / Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¬ÙˆØ§Ø¨ Ù‡Ø§ÙŠ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø±',0),(137775,3828,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾ Ø¬ÙˆØ§Ø¨ Ù‡Ø§ÙŠ Ù¾ÙŠØ´ ÙØ±Ø¶ : Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬ÙˆØ§Ø¨ Ù‡Ø§ÙŠ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø±',0),(137776,3828,'tr','Worktypes iÃ§in varsayÄ±lan yanÄ±t-e doÄŸru girmek/gÃ¼ncelleme',0),(137777,3828,'pl','WprowadÅº/aktualizacja domyÅ›lnej odpowiedzi dla Worktypes',0),(137778,3828,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð·Ð° Worktypes',0),(137779,3828,'ur','Ø¯Ø§Ø®Ù„/Ø·Û’ Ø´Ø¯Û Ø¬ÙˆØ§Ø¨Ø§Øª Ú©Û’ ÙˆÙˆØ±Ú©ØªÛŒÙ¾Ø§Ø³ Ú©Û’ Ù„ÛŒÛ’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(137780,3828,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾Ð³ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€Ð° Ð·Ð° WÐ¾Ñ€ÐºÑ‚yÐ¿ÐµÑ',0),(137781,3828,'vi','Nháº­p/Cáº­p nháº­t tráº£ lá»i máº·c Ä‘á»‹nh cho loáº¡i cÃ´ng viá»‡c',0),(137782,3828,'af','Tik/Update verstek reaksies vir Worktypes',0),(137783,3828,'ro','IntroduceÅ£i/Update implicit rÄƒspunsuri pentru Worktypes',0),(137784,3828,'et','Sisestage/vÃ¤rskendus vaikimisi vastused Worktypes',0),(137785,3828,'si','Vnos/posodobitev privzeti odgovor za Worktypes',0),(137786,3828,'ba','Masukkan/Update Default tanggapan untuk Worktypes',0),(137787,3828,'nl','Invoeren/bijwerken standaard reacties voor Worktypes',0),(137788,3828,'fi','PÃ¤ivittÃ¤minen oletus Vastaus ajaksi Worktypes',0),(137789,3828,'no','Angi/Oppdater standard svar for Worktypes',0),(137790,3828,'da','Indtaste/opdatere standard svar til Worktypes',0),(137791,3828,'ko','Worktypesì— ëŒ€ í•œ ê¸°ë³¸ ì‘ë‹µ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(137792,3828,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×ª×’×•×‘×•×ª ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×‘×•×¨ Worktypes',0),(137793,3828,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Î±Ï€Î±Î½Ï„Î®ÏƒÎµÎ¹Ï‚ Î³Î¹Î± Worktypes',0),(137794,3828,'zh','è¾“å…¥/æ›´æ–°å·¥ä½œç±»åž‹çš„é»˜è®¤å“åº”\r\n',0),(137795,3828,'sv','Ange/uppdatera standard svar fÃ¶r Worktypes',0),(137796,3828,'it','Immettere/aggiornamento delle risposte predefinite per Worktypes',0),(137797,3828,'tl','',0),(137798,3828,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3605;&#3629;&#3610;&#3626;&#3609;&#3629;&#3591;&#3586;&#3629;&#3591;&#',0),(137799,3828,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤‰à¤¤à¥à¤¤à¤° Worktypes à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(137800,3828,'ms','Masukkan/Kemaskini maklum balas lalai untuk Worktypes',0),(137801,3828,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø±Ø¯ÙˆØ¯ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ù„ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠØ³',0),(137802,3828,'fr','Entrez/mise Ã  jour par dÃ©faut les rÃ©ponses pour Worktypes',0),(137803,3828,'jp','ä»•äº‹å†…å®¹ã?«å¯¾ã?™ã‚‹æ—¢å®šå›žç­”ã?®å…¥åŠ›/æ›´æ–°',0),(137804,3828,'pt','Inserir/atualizar respostas padrÃ£o para Worktypes',0),(137805,3828,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ð²ÐµÑ‚Ð¾Ð² Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ Worktypes',0),(137806,3828,'es','Introducir/Actualizar Respuestas por Defecto de Tipos de Trabajo ',0),(137807,3828,'de','Geben Sie/Update Standard Antworten fÃ¼r Worktypes',0),(137808,3828,'en','Enter/Update Default Responses for Worktypes',0),(137809,3829,'is','',0),(137810,3829,'dr',': : Ø«Ø¨Øª / Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ±Ù…ÙˆÙ„Ù‡Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ',0),(137811,3829,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾ ÙØ±Ù…ÙˆÙ„Ù‡Ø§ : : Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±Ù…ÙˆÙ„Ù‡Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ',0),(137812,3829,'tr','Aile hesaplamalar iÃ§in kullanÄ±lmak Ã¼zere girin/gÃ¼ncelleme hesaplama formÃ¼lleri',0),(137813,3829,'pl','Wzory obliczeÅ„ wprowadÅº/aktualizacja stosowanÄ… do obliczenia rodziny',0),(137814,3829,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð¸ Ð·Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ Ð·Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(137815,3829,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø­Ø³Ø§Ø¨ ÙØ§Ø±Ù…ÙˆÙ„ÙˆÚº Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Û’ Ø­Ø³Ø§Ø¨ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(137816,3829,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ðµ Ð·Ð° Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ Ñ›Ðµ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð·Ð° Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ° Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð°',0),(137817,3829,'vi','Nháº­p/Cáº­p nháº­t cÃ´ng thá»©c tÃ­nh dÃ¹ng cho tÃ­nh toÃ¡n gia Ä‘Ã¬nh',0),(137818,3829,'af','Tik/Update berekening formules word gebruik vir familie berekeninge',0),(137819,3829,'ro','Intra/actualizare formule de calcul pentru a fi utilizate pentru calcule de familie',0),(137820,3829,'et','Sisestamine/ajakohastamine arvutamise valemites kasutada kasutatakse pere',0),(137821,3829,'si','Vnesite posodobitev izraÄuna formule za izraÄune druÅ¾ine',0),(137822,3829,'ba','Masukkan Update perhitungan rumus untuk digunakan untuk perhitungan keluarga',0),(137823,3829,'nl','Invoeren/bijwerken berekeningsformules moet worden gebruikt voor berekeningen van de familie',0),(137824,3829,'fi','PÃ¤ivittÃ¤minen laskentakaavoja perheen laskennassa kÃ¤ytetyn',0),(137825,3829,'no','Angi/Oppdater beregningsformler brukes til familien beregninger',0),(137826,3829,'da','Indtaste/opdatere beregningsformler skal bruges til beregninger af familien',0),(137827,3829,'ko','ê°€ì¡± ê³„ì‚°ì— ì‚¬ìš©í•  ìž…ë ¥/ì—…ë°ì´íŠ¸ ê³„ì‚° ìˆ˜ì‹',0),(137828,3829,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ × ×•×¡×—××•×ª ×—×™×©×•×‘ ×›×“×™ ×œ×©×ž×© ×œ×—×™×©×•×‘×™× ×”×ž×©×¤×—×”',0),(137829,3829,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Ï…Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Ï€Î¿Ï… Î¸Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ Ï„Î·Ï‚ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±Ï‚',0),(137830,3829,'zh','è¾“å…¥/æ›´æ–°ç”¨äºŽç³»åˆ—è®¡ç®—çš„è®¡ç®—å…¬å¼\r\n',0),(137831,3829,'sv','Ange/uppdatera formler som skall anvÃ¤ndas fÃ¶r familjen berÃ¤kningar',0),(137832,3829,'it','Inserisci/Aggiorna le formule di calcolo da utilizzare per i calcoli di famiglia',0),(137833,3829,'tl','',0),(137834,3829,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3641;&#3605;&#3619;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3651;&#3594;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#',0),(137835,3829,'hi','à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤¸à¥‚à¤¤à¥à¤°',0),(137836,3829,'ms','Masukkan/Kemaskini pengiraan formula yang akan digunakan untuk pengiraan dalam keluarga',0),(137837,3829,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« \"Ø­Ø³Ø§Ø¨ Ø§Ù„ØµÙŠØº\" Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…Ù‡Ø§ \"Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³Ø±Ø©\"',0),(137838,3829,'fr','Inscrire/mettre Ã  jour les formules de calcul Ã  utiliser pour les calculs de la famille',0),(137839,3829,'jp','ç³»çµ±è¨ˆç®—ã?«ä½¿ç”¨ã?™ã‚‹è¨ˆç®—å¼?ã?®å…¥åŠ›/æ›´æ–°',0),(137840,3829,'pt','Inserir/atualizar fÃ³rmulas de cÃ¡lculo a ser usado para cÃ¡lculos de famÃ­lia',0),(137841,3829,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ñ‹ Ð´Ð»Ñ Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ð¹ ÑÐµÐ¼ÑŒÐ¸',0),(137842,3829,'es','Introducir/Actualizar Formulas de CÃ¡lculo que se UsarÃ¡n para CÃ¡lculos de Familia',0),(137843,3829,'de','Geben Sie/Update Berechnungsformeln fÃ¼r Familie Berechnungen verwendet werden',0),(137844,3829,'en','Enter/Update Calculation Formulas to be used for Family Calculations',0),(137845,3830,'is','',0),(137846,3830,'dr',': : Ø«Ø¨Øª / Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù„ÙŠØ³Øª Ø¯Ù„Ø§ÙŠÙ„ ØªØ§Ø®ÙŠØ± ÙØ±Ù…Ø§ÛŒØ´Ø§Øª ',0),(137847,3830,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾ Ø¯Ù„Ø§ÙŠÙ„ ØªØ§Ø®ÙŠØ± Ø§Ø±Ø³Ø§Ù„ : : Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ø¯Ù„Ø§ÙŠÙ„ ØªØ§Ø®ÙŠØ± Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(137848,3830,'tr','Neden geÃ§ emirler nedenleri girin/gÃ¼ncelleme listesi',0),(137849,3830,'pl','WprowadÅº/Aktualizacja listy powodÃ³w dlaczego zamÃ³wienia sÄ… koniec',0),(137850,3830,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð½Ð° Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð¸Ñ‚Ðµ, Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐ° ÐºÑŠÑÐ½Ð¾',0),(137851,3830,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ ÙÛØ±Ø³Øª Ú©Ø§ Ú©ÛŒÙˆÚº Ø­Ú©Ù… Ù…Ø±Ø­ÙˆÙ… ÛÛŒÚº ÙˆØ¬ÙˆÛØ§Øª Ú©ÛŒ Ø¨Ù†Ø§ Ù¾Ø±',0),(137852,3830,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð»Ð¸ÑÑ‚Ñƒ Ð¾Ð´ Ñ€Ð°Ð·Ð»Ð¾Ð³Ð° Ð·Ð°ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ° ÑÑƒ ÐºÐ°ÑÐ½Ð¸Ñ˜Ðµ',0),(137853,3830,'vi','Nháº­p/Cáº­p nháº­t danh sÃ¡ch nguyÃªn nhÃ¢n vÃ¬ sao Ä‘Æ¡n hÃ ng trá»…',0),(137854,3830,'af','Tik/Update lys van redes hoekom bestellings is laat',0),(137855,3830,'ro','IntroduceÅ£i/actualizaÅ£i lista de motive ce comenzi sunt Late',0),(137856,3830,'et','Sisestamine/ajakohastamine nimekirja ning pÃµhjused, miks tellimused on emastega',0),(137857,3830,'si','Vnesite posodobitev seznam razlogov zakaj naroÄila so pozno',0),(137858,3830,'ba','Masukkan Update daftar dari alasan mengapa perintah akhir',0),(137859,3830,'nl','Voer/Update lijst van redenen waarom Orders Late zijn',0),(137860,3830,'fi','PÃ¤ivittÃ¤minen luettelon syitÃ¤ tilaukset ovat myÃ¶hÃ¤ssÃ¤',0),(137861,3830,'no','Angi/Oppdater listen av grunnene hvorfor ordrer er sent',0),(137862,3830,'da','Indtaste/opdatere listen af grunde til ordrer er forsinket',0),(137863,3830,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ ëª©ë¡ì˜ ì´ìœ  ì£¼ë¬¸ì„ ëŠ¦ê²Œ',0),(137864,3830,'he','×”×¡×™×‘×•×ª ×©×œ ×¨×©×™×ž×ª ×”×–×Ÿ/×¢×“×›×•×Ÿ ×œ×ž×” ×”×”×•×¨××•×ª ×”×Ÿ ×ž××•×—×¨',0),(137865,3830,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î± Ï„Î¿Ï… Î»ÏŒÎ³Î¿Ï…Ï‚ Î³Î¹Î±Ï„Î¯ Î¿Î¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÎµÎ¯Î½Î±Î¹ Î±ÏÎ³Î¬',0),(137866,3830,'zh','è¾“å…¥/æ›´æ–°è®¢å•è¿Ÿåˆ°åŽŸå› åˆ—è¡¨\r\n',0),(137867,3830,'sv','Ange/uppdatera listan av skÃ¤l varfÃ¶r bestÃ¤llningar Ã¤r sent',0),(137868,3830,'it','Inserisci/Aggiorna elenco di motivi per cui gli ordini sono Late',0),(137869,3830,'tl','',0),(137870,3830,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3623;&#3656;&#3634;&#3607;&#3635;&#3652;&#3617;&#3588;&#3635;&#',0),(137871,3830,'hi','à¤¸à¥à¤µà¤°à¥à¤—à¥€à¤¯ à¤†à¤¦à¥‡à¤¶ à¤•à¥à¤¯à¥‹à¤‚ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤•à¤¾à¤°à¤£à¥‹à¤‚ à¤•à¥‡ à¤¦à¤°à¥à¤œ/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥‚à¤šà¥€',0),(137872,3830,'ms','Masukkan/Kemaskini senarai dari sebab-sebab mengapa perintah yang lewat',0),(137873,3830,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« \"Ù‚Ø§Ø¦Ù…Ø© Ù…Ù† Ø£Ø³Ø¨Ø§Ø¨\" Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(137874,3830,'fr','Inscrire/mettre Ã  jour liste de raisons pour lesquelles les ordres sont tardif',0),(137875,3830,'jp','æ³¨æ–‡ã?®é?…å»¶ç?†ç”±ãƒªã‚¹ãƒˆã?®å…¥åŠ›/æ›´æ–°',0),(137876,3830,'pt','Inserir/atualizar lista de razÃµes pelas quais sÃ£o as ordens Late',0),(137877,3830,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½, Ð¿Ð¾Ñ‡ÐµÐ¼Ñƒ Ð·Ð°ÐºÐ°Ð·Ñ‹ ÑÐ²Ð»ÑÑŽÑ‚ÑÑ Ð² ÐºÐ¾Ð½Ñ†Ðµ',0),(137878,3830,'es','Introducir/Actualizar Lista de Razones por quÃ© los Ordenes estan Tarde',0),(137879,3830,'de','Geben Sie/Update Liste der GrÃ¼nde, warum AuftrÃ¤ge Late',0),(137880,3830,'en','Enter/Update List of Reasons why Orders are Late',0),(137881,3831,'is','',0),(137882,3831,'dr',': Ø«Ø¨Øª / Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ú†Ø§Ù¾ Ù…Ø­Ù„ Ù‡Ø§',0),(137883,3831,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾ Ù…Ø­Ù„ Ù‡Ø§ : Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú†Ø§Ù¾ Ù…Ø­Ù„ Ù‡Ø§',0),(137884,3831,'tr','YazdÄ±rma konumlarÄ± girin/gÃ¼ncelleme',0),(137885,3831,'pl','WprowadÅº/aktualizacja punktach druku',0),(137886,3831,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¼ÐµÑÑ‚Ð°',0),(137887,3831,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(137888,3831,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(137889,3831,'vi','Nháº­p/Cáº­p nháº­t vá»‹ trÃ­ in',0),(137890,3831,'af','Invoer/Opdateer Uitdrukbare Punte',0),(137891,3831,'ro','IntroduceÅ£i/actualizare imprimare locatii',0),(137892,3831,'et','Prindi asukohtade sisestamine/ajakohastamine',0),(137893,3831,'si','Vnos/posodobitev tiskanja lokacijah',0),(137894,3831,'ba','Masukkan/Update cetak lokasi',0),(137895,3831,'nl','Afdruklocaties invoeren/bijwerken',0),(137896,3831,'fi','PÃ¤ivittÃ¤minen tulosta sijainnit',0),(137897,3831,'no','Angi/Oppdater ut steder',0),(137898,3831,'da','Indtaste/opdatere Print steder',0),(137899,3831,'ko','ì¸ì‡„ ìœ„ì¹˜ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(137900,3831,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×ž×™×§×•×ž×™ ×”×“×¤×¡×”',0),(137901,3831,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚',0),(137902,3831,'zh','è¾“å…¥/æ›´æ–°æ‰“å°ä½ç½®\r\n',0),(137903,3831,'sv','Ange/uppdatera Print platser',0),(137904,3831,'it','Inserisci/Aggiorna stampa posizioni',0),(137905,3831,'tl','',0),(137906,3831,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(137907,3831,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¸à¥à¤¥à¤¾à¤¨ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(137908,3831,'ms','Masukkan/kemas kini lokasi cetakan',0),(137909,3831,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(137910,3831,'fr','Entrer/mise Ã  jour des emplacements de lâ€™impression',0),(137911,3831,'jp','å?°åˆ·ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?®å…¥åŠ›/æ›´æ–°',0),(137912,3831,'pt','Inserir/atualizar locais de impressÃ£o',0),(137913,3831,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¹',0),(137914,3831,'es','Introducir/Actualizar Colocaciones de ImpresiÃ³n',0),(137915,3831,'de','Geben Sie/Update Druckstandorten',0),(137916,3831,'en','Enter/Update Print Locations',0),(137917,3832,'is','',0),(137918,3832,'dr',': Ø«Ø¨Øª / Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù…Ø§Ø´ÙŠÙ† Ù‡Ø§',0),(137919,3832,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾ Ù…Ø§Ø´ÙŠÙ† Ù‡Ø§  : Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ø´ÙŠÙ† Ù‡Ø§',0),(137920,3832,'tr','Makineleri girin/gÃ¼ncelleme',0),(137921,3832,'pl','WprowadÅº/aktualizacji maszyn',0),(137922,3832,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð¸',0),(137923,3832,'ur','Ù…Ø´ÛŒÙ†ÛŒÚº Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(137924,3832,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¼Ð°ÑˆÐ¸Ð½Ðµ',0),(137925,3832,'vi','Nháº­p/Cáº­p nháº­t mÃ¡y ',0),(137926,3832,'af','Tik/Update masjiene',0),(137927,3832,'ro','IntroduceÅ£i/actualizare masini',0),(137928,3832,'et','Masinad sisestamine/ajakohastamine',0),(137929,3832,'si','Vnos/posodobitev stroji',0),(137930,3832,'ba','Masukkan/Update mesin',0),(137931,3832,'nl','Invoeren/bijwerken Machines',0),(137932,3832,'fi','PÃ¤ivittÃ¤minen koneet',0),(137933,3832,'no','Angi/Oppdater maskiner',0),(137934,3832,'da','Indtaste/opdatere maskiner',0),(137935,3832,'ko','ì»´í“¨í„° ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(137936,3832,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×©×œ ×ž×›×•× ×•×ª',0),(137937,3832,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î·Ï‡Î±Î½Î­Ï‚',0),(137938,3832,'zh','è¾“å…¥/æ›´æ–°æœº\r\n',0),(137939,3832,'sv','Ange/uppdatera maskiner',0),(137940,3832,'it','Immettere/aggiornamento macchine',0),(137941,3832,'tl','',0),(137942,3832,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(137943,3832,'hi','à¤®à¤¶à¥€à¤¨à¥‡à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(137944,3832,'ms','Masukkan/Kemaskini Mesin',0),(137945,3832,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£Ø¬Ù‡Ø²Ø©',0),(137946,3832,'fr','Inscrire/mettre Ã  jour des Machines',0),(137947,3832,'jp','æ©Ÿæ¢°ã?®å…¥åŠ›/æ›´æ–°',0),(137948,3832,'pt','Inserir/atualizar mÃ¡quinas',0),(137949,3832,'ru','Ð’Ð²Ð¾Ð´/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹',0),(137950,3832,'es','Introducir/Actualizar  MÃ¡quinas',0),(137951,3832,'de','Geben Sie/Update Maschinen',0),(137952,3832,'en','Enter/Update Machines',0),(137953,3833,'is','',0),(137954,3833,'dr',': Ø«Ø¨Øª / Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù…ÙØ§Ø¯Ú¯Ø¯Ø§Ù…Ø³Ø§Ø²ÙŠ Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª ÙØ±Ù…Ø§ÛŒØ´ ',0),(137955,3833,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾ Ù…ÙØ§Ø¯ Ø§Ù†Ø¨Ø§Ø±Ø³Ø§Ø²ÙŠ : Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…ÙØ§Ø¯Ø§Ù†Ø¨Ø§Ø±Ø³Ø§Ø²ÙŠ Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ ',0),(137956,3833,'tr','SipariÅŸ giriÅŸi iÃ§in stok girin/gÃ¼ncelleme amaÃ§larÄ±',0),(137957,3833,'pl','WprowadÅº/aktualizacja celÃ³w magazynie do wprowadzania zamÃ³wieÅ„',0),(137958,3833,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ»Ð¸Ñ‚Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´ Ð·Ð° Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(137959,3833,'ur','Ø¢Ø±ÚˆØ± Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ù…Ù‚Ø§ØµØ¯ Ù…ÛŒÚº Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(137960,3833,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÑÐ²Ñ€Ñ…Ðµ ÑÐ° Ð°ÐºÑ†Ð¸Ñ˜Ð°Ð¼Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(137961,3833,'vi','Nháº­p/Cáº­p nháº­t má»¥c Ä‘Ã­ch hÃ ng tá»“n kho Ä‘á»ƒ nháº­p Ä‘Æ¡n hÃ ng',0),(137962,3833,'af','Tik/Update doeleindes van voorraad vir orde inskrywing',0),(137963,3833,'ro','IntroduceÅ£i/actualizare sensul stoc pentru intrarea comenzii',0),(137964,3833,'et','Sisestamine/ajakohastamine tÃ¤henduses tellimus varude',0),(137965,3833,'si','Vnesite posodobitev namene podlago za naroÄila',0),(137966,3833,'ba','Masukkan Update tujuan stok untuk masuk pesanan',0),(137967,3833,'nl','Invoeren/bijwerken doeleinden van materieel voor orderinvoer',0),(137968,3833,'fi','PÃ¤ivittÃ¤minen sovellettaessa Stock Order Entry',0),(137969,3833,'no','Angi/Oppdater formÃ¥l lager for bestilling',0),(137970,3833,'da','Indtast/opdatering med henblik pÃ¥ lager for ordreindtastning',0),(137971,3833,'ko','ì£¼ë¬¸ í•­ëª©ì— ëŒ€ í•œ ìž¬ê³ ì˜ ìž…ë ¥/ì—…ë°ì´íŠ¸ ëª©ì ',0),(137972,3833,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×”×ž×˜×¨×•×ª ×©×œ ×ž× ×™×” ×¢×œ Order Entry',0),(137973,3833,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÎºÎ¿Ï€Î¿ÏÏ‚ Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î³Î¹Î± ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(137974,3833,'zh','è¾“å…¥/æ›´æ–°è®¢å•æ¡ç›®åº“å­˜çš„ç›®çš„\r\n',0),(137975,3833,'sv','Ange/uppdatera tillÃ¤mpningen av lager fÃ¶r orderregistrering',0),(137976,3833,'it','Inserisci/Aggiorna fini del magazzino per inserimento ordini',0),(137977,3833,'tl','',0),(137978,3833,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3623;&#3633;&#3605;&#3606;&#3640;&#3611;&#3619;&#3632;&#3626;&#3591;&#3588;&#3660;&#3586;&#3629;&#3591;&#3626;&#3605;&#3658;&#3629;&#3588;&#3648;&#3614;&#3639;&#3656;&#',0),(137979,3833,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤¯à¥‹à¤œà¤¨à¥‹à¤‚ à¤•à¥‡ à¤•à¥à¤°à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥‡à¤¯à¤° à¤•à¥€',0),(137980,3833,'ms','Tujuan masukkan/Kemaskini stok untuk kemasukan pesanan',0),(137981,3833,'ar','Ø£ØºØ±Ø§Ø¶ Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù„Ø¯Ø®ÙˆÙ„ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(137982,3833,'fr','Inscrire/mettre Ã  jour des fins de Stock pour la saisie des commandes',0),(137983,3833,'jp','Enter/Update Purposes of Stock for Order Entry',0),(137984,3833,'pt','Inserir/atualizar efeitos do estoque para entrada de pedidos',0),(137985,3833,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ»ÐµÐ¹ Ñ„Ð¾Ð½Ð´Ð° Ð´Ð»Ñ Ð²Ð²Ð¾Ð´Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(137986,3833,'es','Introducir/Actualizar PropÃ³sitos de Stock para la Entrada de Ordenes',0),(137987,3833,'de','Geben Sie/Update Zwecke der Lager fÃ¼r die Auftragserfassung',0),(137988,3833,'en','Enter/Update Purposes of Stock for Order Entry',0),(137989,3834,'is','',0),(137990,3834,'dr',':  Ø«Ø¨Øª / Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø±',0),(137991,3834,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾ Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± :  Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø±',0),(137992,3834,'tr','Worktypes girmek/gÃ¼ncelleme',0),(137993,3834,'pl','WprowadÅº/aktualizacja Worktypes',0),(137994,3834,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Worktypes',0),(137995,3834,'ur','ÙˆÙˆØ±Ú©Ù¹ÛŒÙ¾Ø§Ø³ Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(137996,3834,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ WÐ¾Ñ€ÐºÑ‚yÐ¿ÐµÑ',0),(137997,3834,'vi','Nháº­p/Cáº­p nháº­t loáº¡i cÃ´ng viá»‡c ',0),(137998,3834,'af','Invoer/Opdateer Werkstipes',0),(137999,3834,'ro','IntroduceÅ£i/actualizare Worktypes',0),(138000,3834,'et','Worktypes sisestamine/ajakohastamine',0),(138001,3834,'si','Vnos/posodobitev Worktypes',0),(138002,3834,'ba','Masukkan/Update Worktypes',0),(138003,3834,'nl','Invoeren/bijwerken Worktypes',0),(138004,3834,'fi','PÃ¤ivittÃ¤minen Worktypes',0),(138005,3834,'no','Angi/Oppdater Worktypes',0),(138006,3834,'da','Indtaste/opdatere Worktypes',0),(138007,3834,'ko','Worktypes ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(138008,3834,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ Worktypes',0),(138009,3834,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Worktypes',0),(138010,3834,'zh','è¾“å…¥/æ›´æ–°å·¥ä½œç±»åž‹\r\n',0),(138011,3834,'sv','Ange/uppdatera Worktypes',0),(138012,3834,'it','Inserisci/Aggiorna Worktypes',0),(138013,3834,'tl','',0),(138014,3834,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(138015,3834,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/Worktypes à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(138016,3834,'ms','Masukkan/kemas kini Worktypes',0),(138017,3834,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠØ³',0),(138018,3834,'fr','Inscrire/mettre Ã  jour Worktypes',0),(138019,3834,'jp','ä»•äº‹å†…å®¹ã?®å…¥åŠ›/æ›´æ–°',0),(138020,3834,'pt','Inserir/atualizar Worktypes',0),(138021,3834,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿Ñ‹ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(138022,3834,'es','Introducir/Actualizar tipos de trabajo',0),(138023,3834,'de','Geben Sie/Update Worktypes',0),(138024,3834,'en','Enter/Update Worktypes',0),(138025,3835,'is','',0),(138026,3835,'dr',': Ø§ÙŠØ¬Ø§Ø¯ / Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù†Ø§Ù… Ù‡Ø§ Ùˆ ÙØ±Ù…Ø§ÛŒØ´ Ø¨Ø±Ø§ÙŠ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ø¹Ù…ÙˆÙ…ÙŠ Ø¯Ø± Ø·ÙŠ ØªÙˆÙ„ÙŠØ¯ ',0),(138027,3835,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ : Ø§ÙŠØ¬Ø§Ø¯ / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ù… Ù‡Ø§ Ùˆ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ø¹Ù…ÙˆÙ…ÙŠ Ø¯Ø± Ø·ÙŠ ØªÙˆÙ„ÙŠØ¯ ',0),(138028,3835,'tr','OluÅŸtur/GÃ¼ncelleÅŸtir adlarÄ± ve Ã¼retim iÃ§inde Work alanlarÄ± iÃ§in sipariÅŸ',0),(138029,3835,'pl','UtwÃ³rz/Aktualizuj nazwy i kolejnoÅ›Ä‡ obszarÃ³w Work ogÃ³lne w produkcji',0),(138030,3835,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð¼ÐµÐ½Ð° Ð¸ Ñ€ÐµÐ´ Ð·Ð° Ð¾Ð±Ñ‰Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ Ð² Ñ€Ð°Ð¼ÐºÐ¸Ñ‚Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(138031,3835,'ur','ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù†Ø§Ù… Ø§ÙˆØ± Ø§Ø³ Ú©ÛŒ Ù¾ÛŒØ¯Ø§ÙˆØ§Ø± Ú©Û’ Ø§Ù†Ø¯Ø± Ø¬Ù†Ø±Ù„ Ú©Ø§Ù… Ø¹Ù„Ø§Ù‚ÙˆÚº Ú©ÛŒÙ„Ø¦Û’ Ø¢Ø±ÚˆØ±',0),(138032,3835,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ /Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¸Ð¼ÐµÐ½Ð° Ð¸ Ñ€ÐµÐ´ Ð·Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð»Ð° WÐ¾Ñ€Ðº Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ ÑƒÐ½ÑƒÑ‚Ð°Ñ€ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑšÐµ',0),(138033,3835,'vi','Táº¡o/cáº­p nháº­t tÃªn & Ä‘Æ¡n hÃ ng cho khu vá»±c lÃ m viá»‡c chung trong sáº£n xuáº¥t',0),(138034,3835,'af','Skep/Update name en orde vir algemene Work Areas binne produksie',0),(138035,3835,'ro','Creare/actualizare nume si comanda pentru zonele de Work General Ã®n producÅ£ie',0),(138036,3835,'et','Luua vÃµi uuendada nimed ja tellimuse Ã¼ldine Work alade piires tootmiseks',0),(138037,3835,'si','Ustvarjanje/posodabljanje imena in naroÄilo za sploÅ¡no delovnih podroÄjih v proizvodnji',0),(138038,3835,'ba','Nama-nama membuat Update dan ketertiban untuk umum Work area dalam produksi',0),(138039,3835,'nl','Maken of bijwerken namen en volgorde voor algemene Work gebieden binnen productie',0),(138040,3835,'fi','Luo/pÃ¤ivitÃ¤ nimiÃ¤ ja jÃ¤rjestystÃ¤ yleinen alat tuotanto',0),(138041,3835,'no','Opprett/oppdater navn og rekkefÃ¸lge for General Work omrÃ¥der innen produksjon',0),(138042,3835,'da','Opret/Opdater navne og rÃ¦kkefÃ¸lgen for General Work omrÃ¥der inden for produktion',0),(138043,3835,'ko','ë§Œë“¤ê¸°/ì—…ë°ì´íŠ¸ ì´ë¦„ ë° ìƒì‚° ë‚´ì˜ ì¼ë°˜ ìž‘ì—… ì˜ì—­ì— ëŒ€ í•œ ìˆœì„œ',0),(138044,3835,'he','×™×¦×™×¨×”/×¢×“×›×•×Ÿ ×©×ž×•×ª ×•×¡×“×¨ ×¢×‘×•×¨ ×¤×™× ×•×ª ×¢×‘×•×“×” ×›×œ×œ×™ ×‘×ª×•×š ×”×¤×§×”',0),(138045,3835,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¿Î½ÏŒÎ¼Î±Ï„Î± ÎºÎ±Î¹ Î³Î¹Î± Ï‡ÏŽÏÎ¿Ï…Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î³ÎµÎ½Î¹ÎºÎ¬ Î¼Î­ÏƒÎ± Ï€Î±ÏÎ±Î³Ï‰Î³Î®Ï‚',0),(138046,3835,'zh','åˆ›å»º/æ›´æ–°åœ¨ä¸€èˆ¬å·¥ä½œåŒºåŸŸå†…çš„åç§°æˆ–é¡ºåº\r\n',0),(138047,3835,'sv','Skapa eller uppdatera namn och ordning fÃ¶r allmÃ¤nna omrÃ¥den inom produktion',0),(138048,3835,'it','Creare o aggiornare i nomi e l\'ordine per ambienti di lavoro generale all\'interno della produzione',0),(138049,3835,'tl','',0),(138050,3835,'th','Create/Update Names and order for General Work Areas within production',0),(138051,3835,'hi','à¤¬à¤¨à¤¾à¤à¤/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¨à¤¾à¤® à¤”à¤° à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¨ à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤°à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶',0),(138052,3835,'ms','Perintah Am Work kawasan dalam pengeluaran dan mencipta/Kemaskini nama',0),(138053,3835,'ar','Ø¥Ù†Ø´Ø§Ø¡/ØªØ­Ø¯ÙŠØ« \"Ø§Ù„Ø£Ø³Ù…Ø§Ø¡\" ÙˆØ§Ù„ØªØ±ØªÙŠØ¨ Ù„Ù…Ø¬Ø§Ù„Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¹Ø§Ù…Ø© Ø¯Ø§Ø®Ù„ Ø§Ù„Ø¥Ù†ØªØ§Ø¬',0),(138054,3835,'fr','CrÃ©er/mettre Ã  jour les noms et l\'ordre gÃ©nÃ©ral espaces de travail au sein de la production',0),(138055,3835,'jp','è£½é€ ä¸­ã?®ä¸€èˆ¬ä½œæ¥­ç¯„å›²ã?®å??å‰?ã?¨æ³¨æ–‡ã‚’ä½œæˆ?/æ›´æ–°',0),(138056,3835,'pt','Criar/atualizar nomes e ordem para Ã¡reas de trabalho geral dentro de produÃ§Ã£o',0),(138057,3835,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¸Ð¼ÐµÐ½Ð° Ð¸ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð´Ð»Ñ Ð¾Ð±Ñ‰ÐµÐ³Ð¾ Ð¾Ð±Ð»Ð°ÑÑ‚ÐµÐ¹ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð² Ñ€Ð°Ð¼ÐºÐ°Ñ… Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð°',0),(138058,3835,'es','Crear/Actualizar Nombres y orden para Ãreas General de Trabajo dentro la producciÃ³n',0),(138059,3835,'de','Erstellen/aktualisieren Namen und Reihenfolge fÃ¼r allgemeine Arbeitsbereiche innerhalb der Produktion',0),(138060,3835,'en','Create/Update Names and order for General Work Areas within production',0),(138061,3836,'is','',0),(138062,3836,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(138063,3836,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(138064,3836,'tr','Sevk edilen sipariÅŸler',0),(138065,3836,'pl','ZamÃ³wienia wysyÅ‚ane',0),(138066,3836,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(138067,3836,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(138068,3836,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(138069,3836,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ chuyá»ƒn',0),(138070,3836,'af','Versende Bestellings',0),(138071,3836,'ro','Comenzile expediate',0),(138072,3836,'et','LÃ¤hetatud tellimuste',0),(138073,3836,'si','Ob dobavi naroÄila',0),(138074,3836,'ba','Pesanan dikirim',0),(138075,3836,'nl','Verzonden bestellingen',0),(138076,3836,'fi','LÃ¤hetetyt tilaukset',0),(138077,3836,'no','Sendte bestillinger',0),(138078,3836,'da','Afsendt ordrer',0),(138079,3836,'ko','ë°°ì†¡ëœ ì£¼ë¬¸',0),(138080,3836,'he','×”×–×ž× ×•×ª ×©× ×©×œ×—×”',0),(138081,3836,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(138082,3836,'zh','å‘è´§çš„è®¢å•\r\n',0),(138083,3836,'sv','Levererade order',0),(138084,3836,'it','Ordini spediti',0),(138085,3836,'tl','',0),(138086,3836,'th','&#3651;&#3610;&#3626;&#3656;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(138087,3836,'hi','à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶',0),(138088,3836,'ms','Pesanan yang dihantar',0),(138089,3836,'ar','Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(138090,3836,'fr','Commandes expÃ©diÃ©es',0),(138091,3836,'jp','ç™ºé€?æ¸ˆã?®æ³¨æ–‡',0),(138092,3836,'pt','Pedidos enviados',0),(138093,3836,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(138094,3836,'es','Ordenes Enviados',0),(138095,3836,'de','Gelieferte Bestellungen',0),(138096,3836,'en','Shipped Orders',0),(138097,3837,'is','',0),(138098,3837,'dr','/ Ø±ÙˆØ´ Ù‡Ø§',0),(138099,3837,'pr','Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ / Ø±ÙˆØ´ Ù‡Ø§',0),(138100,3837,'tr','Nakliye gemisi/yÃ¶ntemleri',0),(138101,3837,'pl','PrzewoÅºnik/metody wysyÅ‚ki',0),(138102,3837,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡/Ð¼ÐµÑ‚Ð¾Ð´Ð¸ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(138103,3837,'ur','Ú©ÛŒØ±ÛŒØ¦Ø±/Ø·Ø±ÛŒÙ‚Û Ú©ÛŒ ØªØ±Ø³ÛŒÙ„',0),(138104,3837,'sr','ÐÐ¾ÑÐ°Ñ‡ /ÐÐ°Ñ‡Ð¸Ð½Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(138105,3837,'vi','HÃ£ng váº­n chuyá»ƒn/PhÆ°Æ¡ng thá»©c',0),(138106,3837,'af','Versendingskarweier/Metodes',0),(138107,3837,'ro','Operatorul de transport/metoda de transport',0),(138108,3837,'et','Laevanduse vedaja/meetodid',0),(138109,3837,'si','Storim prevoznik',0),(138110,3837,'ba','Pembawa metode pengiriman',0),(138111,3837,'nl','Vervoerder/verzendmethoden',0),(138112,3837,'fi','Postikulut harjoittaja',0),(138113,3837,'no','Leveringsmetoder Carrier',0),(138114,3837,'da','Forsendelsesmetoder luftfartsselskab',0),(138115,3837,'ko','ë°°ì†¡ ìºë¦¬ì–´/ë°©ë²•',0),(138116,3837,'he','×ž× ×©×/×©×™×˜×•×ª ×ž×©×œ×•×—',0),(138117,3837,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Î±Ï‚/ÎœÎµÎ¸Î¿Î´Î¿Î¹ Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î·Ï‚',0),(138118,3837,'zh','èˆªè¿æ‰¿è¿äºº/æ–¹æ³•\r\n',0),(138119,3837,'sv','Leveransmetoder bÃ¤rare',0),(138120,3837,'it','Metodi di spedizione vettore',0),(138121,3837,'tl','',0),(138122,3837,'th','&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;/&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;',0),(138123,3837,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¾à¤¹à¤•/à¤¤à¤°à¥€à¤•à¥‹à¤‚',0),(138124,3837,'ms','Kapal pengangkut/kaedah',0),(138125,3837,'ar','Ø·Ø±Ù‚ Ø§Ù„Ø´Ø­Ù†/Ø§Ù„Ù†Ø§Ù‚Ù„ÙˆÙ†',0),(138126,3837,'fr','Transporteur/mÃ©thodes d\'expÃ©dition',0),(138127,3837,'jp','è¼¸é€?ã€€/æ–¹æ³•',0),(138128,3837,'pt','Transportadora/mÃ©todos de envio',0),(138129,3837,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº/Ð¼ÐµÑ‚Ð¾Ð´Ñ‹ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(138130,3837,'es','Transportador de EnvÃ­os/MÃ©tedos',0),(138131,3837,'de','Carrier/Versandarten',0),(138132,3837,'en','Shipping Carrier/Methods',0),(138133,3838,'is','',0),(138134,3838,'dr','( Ø®Ø±ÙŠØ¯ ÙØ±ÙˆØ´Ú¯Ø§Ù‡- ÙƒØ§Ø±Ø®Ø§Ù†Ù‡',0),(138135,3838,'pr','Ø¨Ø§Ø±Ú¯ÙŠØ±ÙŠ( Ø®Ø±ÙŠØ¯ ÙØ±ÙˆØ´Ú¯Ø§Ù‡- ÙƒØ§Ø±Ø®Ø§Ù†Ù‡',0),(138136,3838,'tr','DÃ¼kkanÄ± yÃ¼kleme',0),(138137,3838,'pl','Åadowanie sklepu',0),(138138,3838,'bg','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Ð·Ð° Ñ‚Ð¾Ð²Ð°Ñ€ÐµÐ½Ðµ',0),(138139,3838,'ur','Ø¯Ú©Ø§Ù† Ù„ÙˆÚˆ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(138140,3838,'sr','Ð Ð°Ð´ÑšÐ° ÑƒÑ‡Ð¸Ñ‚Ð°Ð²Ð°ÑšÐ°',0),(138141,3838,'vi','Táº£i Shop',0),(138142,3838,'af','Winkel laai',0),(138143,3838,'ro','Magazin de Ã®ncÄƒrcare',0),(138144,3838,'et','Shop laadimine',0),(138145,3838,'si','Shop nakladanja',0),(138146,3838,'ba','Toko Loading',0),(138147,3838,'nl','Productieverdeling',0),(138148,3838,'fi','Shop lastaus',0),(138149,3838,'no','Shop lasting',0),(138150,3838,'da','Shop lastning',0),(138151,3838,'ko','ê°€ ê²Œ ë¡œë“œ',0),(138152,3838,'he','×—× ×•×ª ×˜×¢×™× ×”',0),(138153,3838,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± Ï†ÏŒÏÏ„Ï‰ÏƒÎ·Ï‚',0),(138154,3838,'zh','è½½å…¥è´­ç‰©\r\n',0),(138155,3838,'sv','Shop lastning',0),(138156,3838,'it','Negozio caricamento',0),(138157,3838,'tl','',0),(138158,3838,'th','&#3585;&#3634;&#3619;&#3650;&#3627;&#3621;&#3604;&#3619;&#3657;&#3634;&#3609;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;',0),(138159,3838,'hi','à¤²à¥‹à¤¡ à¤¹à¥‹ à¤°à¤¹à¤¾ à¤¹à¥ˆ à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨',0),(138160,3838,'ms','Memuatkan kedai',0),(138161,3838,'ar','ØªØ­Ù…ÙŠÙ„ Ù…ØªØ¬Ø±',0),(138162,3838,'fr','Chargement de la boutique',0),(138163,3838,'jp','Shop Loading',0),(138164,3838,'pt','Carregamento de loja',0),(138165,3838,'ru','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(138166,3838,'es','Taller Cargamento',0),(138167,3838,'de','Werkstattauslastung',0),(138168,3838,'en','Shop Loading',0),(138169,3839,'is','',0),(138170,3839,'dr','( Ø®Ø±ÙŠØ¯ ÙØ±ÙˆØ´Ú¯Ø§Ù‡- ÙƒØ§Ø±Ø®Ø§Ù†Ù‡  Ø·Ø¨Ù‚  Ø±ÙˆØ² â€“ Ù‡ÙØªÙ‡  Ù…Ø§Ù‡ ',0),(138171,3839,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø¨Ø§Ø±Ú¯ÙŠØ±ÙŠ( Ø®Ø±ÙŠØ¯ ÙØ±ÙˆØ´Ú¯Ø§Ù‡- ÙƒØ§Ø±Ø®Ø§Ù†Ù‡  Ø·Ø¨Ù‚  Ø±ÙˆØ² â€“ Ù‡ÙØªÙ‡  Ù…Ø§Ù‡ ',0),(138172,3839,'tr','GÃ¼n, hafta, ay yÃ¼kleme raporlarÄ± - shop',0),(138173,3839,'pl','Sklep raporty zaÅ‚adunek - dzieÅ„, tydzieÅ„, miesiÄ…c',0),(138174,3839,'bg','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Ð½Ð°Ñ‚Ð¾Ð²Ð°Ñ€Ð²Ð°Ð½Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸ - Ð¾Ñ‚ Ð´ÐµÐ½, ÑÐµÐ´Ð¼Ð¸Ñ†Ð°, Ð¼ÐµÑÐµÑ†',0),(138175,3839,'ur','Ø¯Ú©Ø§Ù† Ù„ÙˆÚˆÙ†Ú¯ Ø±Ù¾ÙˆØ±Ù¹ÛŒÚº - Ø¯Ù†ØŒ ÛÙØªÛØŒ Ù…ÛÛŒÙ†Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(138176,3839,'sr','Ð Ð°Ð´ÑšÐ° ÑƒÑ‡Ð¸Ñ‚Ð°Ð²Ð°ÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ - Ð·Ð° Ð´Ð°Ð½, ÑÐµÐ´Ð¼Ð¸Ñ†Ñƒ, Ð¼ÐµÑÐµÑ†',0),(138177,3839,'vi','BÃ¡o cÃ¡o táº£i - theo ngÃ y, tuáº§n, thÃ¡ng',0),(138178,3839,'af','Werkswinkel Vrag Verslae - per dag, week, maand',0),(138179,3839,'ro','Rapoarte de Ã®ncÄƒrcare magazin - de zi, sÄƒptÄƒmÃ¢nÄƒ, lunÄƒ',0),(138180,3839,'et','Shop laadimine aruanded pÃ¤ev, nÃ¤dal, kuu-',0),(138181,3839,'si','Shop nakladanje poroÄila - dan, teden, mesec',0),(138182,3839,'ba','Laporan Loading toko - oleh hari, Minggu, bulan',0),(138183,3839,'nl','Winkel laden verslagen - van de dag, week, maand',0),(138184,3839,'fi','Selaa lastaus raportit - pÃ¤ivÃ¤, viikko, kuukausi',0),(138185,3839,'no','Shop lasting rapporter - etter dag, uke, mÃ¥ned',0),(138186,3839,'da','Shop lastning betÃ¦nkninger - dag, uge, mÃ¥ned',0),(138187,3839,'ko','ì¼, ì£¼, ë‹¬ì— ì˜í•´ ë¡œë“œ ë³´ê³ ì„œ-ì‡¼í•‘',0),(138188,3839,'he','×—× ×•×ª ×“×•×—×•×ª ×˜×¢×™× ×” - ×œ×¤×™ ×™×•×, ×©×‘×•×¢, ×—×•×“×©',0),(138189,3839,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± Ï†ÏŒÏÏ„Ï‰ÏƒÎ·Ï‚ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ - Î±Ï€ÏŒ Ï„Î·Î½ Î·Î¼Î­ÏÎ±, ÎµÎ²Î´Î¿Î¼Î¬Î´Î±, Î¼Î®Î½Î±',0),(138190,3839,'zh','è´­ç‰©è½½å…¥æŠ¥å‘Š -æŒ‰å¤©ï¼Œå‘¨ï¼Œæœˆ\r\n',0),(138191,3839,'sv','Shop lastning rapporter - dag, vecka, mÃ¥nad',0),(138192,3839,'it','Negozio caricamento rapporti - di giorno, settimana, mese',0),(138193,3839,'tl','',0),(138194,3839,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3650;&#3627;&#3621;&#3604;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3657;&#3634;&#3609;-D/W/M',0),(138195,3839,'hi','à¤¦à¥à¤•à¤¾à¤¨ à¤²à¥‹à¤¡à¤¿à¤‚à¤— à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ - à¤¦à¤¿à¤¨, à¤¹à¤«à¥à¤¤à¥‡, à¤®à¤¹à¥€à¤¨à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(138196,3839,'ms','Kedai memuatkan laporan - oleh hari, minggu, bulan',0),(138197,3839,'ar','Ù…ØªØ¬Ø± ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ±-Ø¨ÙŠÙˆÙ…ØŒ Ø£Ø³Ø¨ÙˆØ¹ØŒ Ø´Ù‡Ø±',0),(138198,3839,'fr','Rapports de chargement Boutique - par jour, semaine, mois',0),(138199,3839,'jp','Shop Loading Reports - by day, week, month',0),(138200,3839,'pt','RelatÃ³rios de carregamento de loja - por dia, semana, mÃªs',0),(138201,3839,'ru','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¾Ð² - Ð½Ð° Ð´ÐµÐ½ÑŒ, Ð½ÐµÐ´ÐµÐ»ÑŽ, Ð¼ÐµÑÑÑ†',0),(138202,3839,'es','Informes de Taller Cargamento',0),(138203,3839,'de','Einkauf laden Berichten - nach Tag, Woche, Monat',0),(138204,3839,'en','Shop Loading Reports - by day, week, month',0),(138205,3840,'is','',0),(138206,3840,'dr','Ù…Ø¯ÙŠØ±ÙŠØª Ø®Ø±ÙŠØ¯ ',0),(138207,3840,'pr','Ù…Ø¯ÙŠØ±ÙŠØª Ø®Ø±ÙŠØ¯ ',0),(138208,3840,'tr','YÃ¶netim alÄ±ÅŸveriÅŸ',0),(138209,3840,'pl','Zakupy administracji',0),(138210,3840,'bg','ÐŸÐ°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(138211,3840,'ur','Ø§Ù†ØªØ¸Ø§Ù…ÛŒÛ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(138212,3840,'sr','Ð£ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ñƒ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ðµ',0),(138213,3840,'vi','Quáº£n Trá»‹ Mua Sáº¯m ',0),(138214,3840,'af','Aankope Administrasie',0),(138215,3840,'ro','Administrarea de cumpÄƒrÄƒturi',0),(138216,3840,'et','Uudised Administration',0),(138217,3840,'si','Nakupovanje v uprava',0),(138218,3840,'ba','Belanja administrasi',0),(138219,3840,'nl','Winkelen Administration',0),(138220,3840,'fi','Ostokset hallinto',0),(138221,3840,'no','Shopping administrasjon',0),(138222,3840,'da','Shopping Administration',0),(138223,3840,'ko','ì‡¼í•‘ ê´€ë¦¬',0),(138224,3840,'he','× ×™×”×•×œ ×”×§× ×™×•×ª',0),(138225,3840,'el','Î”Î¹Î¿Î¯ÎºÎ·ÏƒÎ· Î±Î³Î¿ÏÏŽÎ½',0),(138226,3840,'zh','è´­ç‰©ç®¡ç†\r\n',0),(138227,3840,'sv','Shopping Administration',0),(138228,3840,'it','Amministrazione commerciale',0),(138229,3840,'tl','',0),(138230,3840,'th','&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3627;&#3634;&#3619;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(138231,3840,'hi','à¤ªà¥à¤°à¤¶à¤¾à¤¸à¤¨ à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€',0),(138232,3840,'ms','Pentadbiran membeli-belah',0),(138233,3840,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„ØªØ³ÙˆÙ‚',0),(138234,3840,'fr','Achats Administration',0),(138235,3840,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°ç®¡ç?†',0),(138236,3840,'pt','AdministraÃ§Ã£o de compras',0),(138237,3840,'ru','Ð¨Ð¾Ð¿Ð¿Ð¸Ð½Ð³ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸',0),(138238,3840,'es','AdministraciÃ³n de Compras',0),(138239,3840,'de','Einkaufen Administration',0),(138240,3840,'en','Shopping Administration',0),(138241,3841,'is','',0),(138242,3841,'dr','ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª Ø§ÙˆÙ„ÙˆÙŠØª Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª ',0),(138243,3841,'pr','ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª Ø§ÙˆÙ„ÙˆÙŠØª Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª ',0),(138244,3841,'tr','AlÄ±ÅŸveriÅŸ sepeti ve yÃ¶netim sepeti tercihleri',0),(138245,3841,'pl','Koszyk na zakupy i administracji koszyka preferencji',0),(138246,3841,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐºÐ° Ð·Ð° Ð¿Ð°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐºÐ°Ñ‚Ð° Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½Ð¸Ñ',0),(138247,3841,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ø§ÙˆØ± ØªØ±Ø¬ÛŒØ­Ø§Øª Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ú©Û’ Ø§Ù†ØªØ¸Ø§Ù…',0),(138248,3841,'sr','ÐšÐ¾Ð»Ð¸Ñ†Ð° Ð¸ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾Ð´ ÐºÐ¾Ð»Ð¸Ñ†Ð° Ð¿Ñ€ÐµÑ„ÐµÑ€ÐµÐ½Ñ†Ðµ',0),(138249,3841,'vi','Giá» HÃ ng & Quáº£n Trá»‹ Giá» HÃ ng Æ¯a ThÃ­ch',0),(138250,3841,'af','Winkeltrollie Item en Administrasie van Aankoop Voorkeure',0),(138251,3841,'ro','Cosul de cumparaturi si administrarea de Cart PreferinÅ£e',0),(138252,3841,'et','Ostukorv ja ostukorv soodustuste haldus',0),(138253,3841,'si','Nakupovalni voziÄek in uprava voziÄek preferencialov',0),(138254,3841,'ba','Administrasi preferensi keranjang dan keranjang belanja',0),(138255,3841,'nl','Winkelwagen en het beheer van voorkeuren van de kar',0),(138256,3841,'fi','Ostoskori ja hallinnon Cart-asetusten',0),(138257,3841,'no','Handlekurven og administrasjon av handlevognen innstillinger',0),(138258,3841,'da','IndkÃ¸bskurv og Administration af vogn prÃ¦ferencer',0),(138259,3841,'ko','ì‡¼í•‘ ì¹´íŠ¸ ë° ì¹´íŠ¸ í™˜ê²½ ì„¤ì •ì˜ ê´€ë¦¬',0),(138260,3841,'he','×¢×’×œ×ª ×”×§× ×™×•×ª, × ×™×”×•×œ ×”×¢×“×¤×•×ª ×”×¢×’×œ×”',0),(138261,3841,'el','ÎšÎ±Î»Î¬Î¸Î¹ Î±Î³Î¿ÏÏŽÎ½ ÎºÎ±Î¹ Ï„Î·Î½ Î´Î¹Î¿Î¯ÎºÎ·ÏƒÎ· Ï„Î·Ï‚ Cart Ï€ÏÎ¿Ï„Î¹Î¼Î®ÏƒÎµÎ¹Ï‚',0),(138262,3841,'zh','è´­ç‰©è½¦ä¸Žè½¦é¦–é€‰é¡¹ç®¡ç†\r\n',0),(138263,3841,'sv','Kundvagn och Administration av vagn instÃ¤llningar',0),(138264,3841,'it','Carrello e gestione delle preferenze del carrello',0),(138265,3841,'tl','',0),(138266,3841,'th','&#3619;&#3606;&#3648;&#3586;&#3655;&#3609;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3619;&#3632;&#3610;&#3610;&#3586;&#3629;&#3591;&#3588;&#3',0),(138267,3841,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤”à¤° à¤—à¤¾à¤¡à¤¼à¥€ à¤µà¤°à¥€à¤¯à¤¤à¤¾à¤“à¤‚ à¤•à¤¾ à¤ªà¥à¤°à¤¶à¤¾à¤¸à¤¨',0),(138268,3841,'ms','Pentadbiran keutamaan troli dan troli membeli-belah',0),(138269,3841,'ar','Ø¹Ø±Ø¨Ø© Ø§Ù„ØªØ³ÙˆÙ‚ ÙˆØ¥Ø¯Ø§Ø±Ø© ØªÙØ¶ÙŠÙ„Ø§Øª Ø¹Ø±Ø¨Ø©',0),(138270,3841,'fr','Panier d\'achat et l\'Administration des prÃ©fÃ©rences de chariot',0),(138271,3841,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°ã‚«ãƒ¼ãƒˆã?¨ã‚«ãƒ¼ãƒˆå„ªå…ˆæ¨©ã?®ç®¡ç?†',0),(138272,3841,'pt','Carrinho de compras e administraÃ§Ã£o de preferÃªncias de carrinho',0),(138273,3841,'ru','ÐšÐ¾Ñ€Ð·Ð¸Ð½Ð° Ð¸ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ ÐºÐ¾Ñ€Ð·Ð¸Ð½Ñƒ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚ÐµÐ½Ð¸Ð¹',0),(138274,3841,'es','Carrito de Compras y AdministraciÃ³n de PreferÃªncias de Carrito',0),(138275,3841,'de','Warenkorb und Administration der Systemeinstellung \"Warenkorb\"',0),(138276,3841,'en','Shopping Cart and Administration of Cart Preferences',0),(138277,3842,'is','',0),(138278,3842,'dr','Ù†Ø¸Ø±Ø§Øª Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(138279,3842,'pr','Ù†Ø¸Ø±Ø§Øª Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(138280,3842,'tr','Standart yorum Ã¼zerinde tÄ±rnak kullanmak iÃ§in',0),(138281,3842,'pl','Standardowe komentarze do korzystania na Cytaty',0),(138282,3842,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸Ñ‚Ðµ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸ Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð·Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(138283,3842,'ur','Ù‚ÛŒÙ…Øª Ù¾Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø¹ÛŒØ§Ø±ÛŒ ØªØ¨ØµØ±Û’',0),(138284,3842,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ðµ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð½Ð° Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð°',0),(138285,3842,'vi','Nháº­n xÃ©t chuáº©n dÃ¹ng trong bÃ¡o giÃ¡',0),(138286,3842,'af','Standaard Opmerkings om te gebruik Op Kwotasies',0),(138287,3842,'ro','Comentarii standard pentru a utiliza pe citate',0),(138288,3842,'et','Standard kommentaarid kasutamise kohta Quotes',0),(138289,3842,'si','Standard pripombe rabiti na Quotes',0),(138290,3842,'ba','Standar komentar untuk menggunakan pada mengutip',0),(138291,3842,'nl','Standaard opmerkingen te gebruiken op Quotes',0),(138292,3842,'fi','Standard kommentit kÃ¤ytÃ¶stÃ¤ On lainaa',0),(138293,3842,'no','Standard kommentarer til bruk pÃ¥ sitater',0),(138294,3842,'da','Standard kommentarer til brug pÃ¥ citater',0),(138295,3842,'ko','ì— ë”°ì˜´í‘œë¥¼ ì‚¬ìš© í•˜ ì—¬ í‘œì¤€ ì˜ê²¬',0),(138296,3842,'he','×”×¢×¨×•×ª ×¨×’×™×œ ×œ×”×©×ª×ž×© ×‘×¦×™×˜×•×˜×™×',0),(138297,3842,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ ÏƒÏ‡ÏŒÎ»Î¹Î± Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î±Ï€Î¿ÏƒÏ€Î¬ÏƒÎ¼Î±Ï„Î±',0),(138298,3842,'zh','æ ‡å‡†ç”¨äºŽæŠ¥ä»·çš„æ³¨é‡Š',0),(138299,3842,'sv','Standard kommentarer att anvÃ¤nda pÃ¥ citat',0),(138300,3842,'it','Commenti standard da utilizzare su cita',0),(138301,3842,'tl','',0),(138302,3842,'th','&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3588;&#3623;&#3634;&#3617;&#3648;&#3627;&#3655;&#3609;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3',0),(138303,3842,'hi','à¤®à¤¾à¤¨à¤• à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¤¿à¤¯à¤¾à¤ à¤ªà¤° à¤‰à¤¦à¥à¤§à¤°à¤£ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(138304,3842,'ms','Komen yang standard untuk digunakan pada sebut harga',0),(138305,3842,'ar','ØªØ¹Ù„ÙŠÙ‚Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ø§Ø³ØªØ®Ø¯Ø§Ù…Ù‡Ø§ \"ÙÙŠ Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±\"',0),(138306,3842,'fr','Commentaires standard Ã  utiliser sur le cite',0),(138307,3842,'jp','è¦‹ç©?ã‚Šä¸Šã?«ä½¿ç”¨ã?™ã‚‹æ¨™æº–ã‚³ãƒ¡ãƒ³ãƒˆ',0),(138308,3842,'pt','ComentÃ¡rios padrÃ£o para usar em citaÃ§Ãµes',0),(138309,3842,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¸ Ð´Ð»Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð½Ð° ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(138310,3842,'es','Comentarios EstÃ¡ndares para usar en Cotizaciones',0),(138311,3842,'de','Standard Kommentare auf Zitate verwenden',0),(138312,3842,'en','Standard Comments to use On Quotes',0),(138313,3843,'is','',0),(138314,3843,'dr','Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  Ø¯ÙØªØ± ÙƒÙ„ ',0),(138315,3843,'pr','Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  Ø¯ÙØªØ± ÙƒÙ„ ',0),(138316,3843,'tr','Standart GL hesabÄ±',0),(138317,3843,'pl','Konto standardowe GL',0),(138318,3843,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(138319,3843,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(138320,3843,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(138321,3843,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Chuáº©n',0),(138322,3843,'af','Standaard AG Rekening',0),(138323,3843,'ro','Contul standard GL',0),(138324,3843,'et','Standard pearaamatukontole',0),(138325,3843,'si','Standard GL raÄun',0),(138326,3843,'ba','GL standar Account',0),(138327,3843,'nl','Standaard GL Account',0),(138328,3843,'fi','Standard Kirjanpitotilin pÃ¤Ã¤tilin',0),(138329,3843,'no','Standard gi-konto',0),(138330,3843,'da','Standard GL konto',0),(138331,3843,'ko','í‘œì¤€ GL ê³„ì •',0),(138332,3843,'he','×—×©×‘×•×Ÿ ×¨×’×™×œ GL',0),(138333,3843,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Standard Î³/Î»',0),(138334,3843,'zh','æ ‡å‡†ä¸€èˆ¬åˆ†ç±»å¸\r\n',0),(138335,3843,'sv','Standard GL konto',0),(138336,3843,'it','Conto standard GL',0),(138337,3843,'tl','',0),(138338,3843,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(138339,3843,'hi','à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‡',0),(138340,3843,'ms','Akaun standard GL',0),(138341,3843,'ar','Ø­Ø³Ø§Ø¨ Ù‚ÙŠØ§Ø³ÙŠ Ù…Ù† Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(138342,3843,'fr','Compte GL standard',0),(138343,3843,'jp','æ¨™æº–GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(138344,3843,'pt','Conta padrÃ£o GL',0),(138345,3843,'ru','Ð¡Ñ‡ÐµÑ‚ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ GL',0),(138346,3843,'es','Cuenta de LM EstÃ¡ndar',0),(138347,3843,'de','Standard Sako',0),(138348,3843,'en','Standard GL Account',0),(138349,3844,'is','',0),(138350,3844,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  Ø¯ÙØªØ± ÙƒÙ„',0),(138351,3844,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  Ø¯ÙØªØ± ÙƒÙ„',0),(138352,3844,'tr','Standart GL hesaplarÄ±',0),(138353,3844,'pl','GL standardowych kont',0),(138354,3844,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ GL ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(138355,3844,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(138356,3844,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð“Ð› Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(138357,3844,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Chuáº©n',0),(138358,3844,'af','Standaard AG Rekeninge',0),(138359,3844,'ro','Conturi standard GL',0),(138360,3844,'et','Standard GL kontod',0),(138361,3844,'si','Standard GL raÄunov',0),(138362,3844,'ba','GL standar account',0),(138363,3844,'nl','Standaard GL Accounts',0),(138364,3844,'fi','Standard GL tilit',0),(138365,3844,'no','Standard GL kontoer',0),(138366,3844,'da','Standard GL konti',0),(138367,3844,'ko','í‘œì¤€ GL ê³„ì •',0),(138368,3844,'he','×—×©×‘×•× ×•×ª ×¡×˜× ×“×¨×˜×™ GL',0),(138369,3844,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(138370,3844,'zh','æ ‡å‡†æ€»å¸è´¦ç›®\r\n',0),(138371,3844,'sv','Standard GL konton',0),(138372,3844,'it','Conti standard GL',0),(138373,3844,'tl','',0),(138374,3844,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(138375,3844,'hi','à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‹à¤‚',0),(138376,3844,'ms','Akaun standard GL',0),(138377,3844,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ù‚ÙŠØ§Ø³ÙŠØ© Ù…Ù† Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(138378,3844,'fr','Comptes GL standard',0),(138379,3844,'jp','æ¨™æº–GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(138380,3844,'pt','Contas padrÃ£o GL',0),(138381,3844,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ GL ÑÑ‡ÐµÑ‚Ð°',0),(138382,3844,'es','Cuentas de LM EstÃ¡ndares',0),(138383,3844,'de','Standard GL-Konten',0),(138384,3844,'en','Standard GL Accounts',0),(138385,3845,'is','',0),(138386,3845,'dr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(138387,3845,'pr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(138388,3845,'tr','Standart biÃ§imlendirme setleri',0),(138389,3845,'pl','Zestawy standardowych znacznikÃ³w',0),(138390,3845,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¸',0),(138391,3845,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ØªØ§ ÛÛ’',0),(138392,3845,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð·Ð½Ð°ÐºÐµ ÑÐºÑƒÐ¿Ð¾Ð²Ð°',0),(138393,3845,'vi','GiÃ¡ cÃ´ng thÃªm chuáº©n',0),(138394,3845,'af','Standaard Prysverhoging',0),(138395,3845,'ro','Seturi de marcare standard',0),(138396,3845,'et','Standardne mÃ¤rgistuskeel komplektid',0),(138397,3845,'si','Standardni oznaÄevalni sklopov',0),(138398,3845,'ba','Markup standar set',0),(138399,3845,'nl','Standaardcoderingstaal Sets',0),(138400,3845,'fi','Standardi merkintÃ¤kieli setit',0),(138401,3845,'no','Standard kode sett',0),(138402,3845,'da','Standard Markup sÃ¦t',0),(138403,3845,'ko','í‘œì¤€ íƒœê·¸ ì§‘í•©',0),(138404,3845,'he','×”×¡×™×ž×•×Ÿ ×”×¡×˜× ×“×¨×˜×™×ª ×¡×˜×™×',0),(138405,3845,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ ÏƒÏÎ½Î¿Î»Î±',0),(138406,3845,'zh','æ ‡å‡†æ ‡è®°\r\n',0),(138407,3845,'sv','Standard Markup uppsÃ¤ttningar',0),(138408,3845,'it','Markup standard set',0),(138409,3845,'tl','',0),(138410,3845,'th','&#3619;&#3634;&#3588;&#3634;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(138411,3845,'hi','à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ',0),(138412,3845,'ms','Set Standard penanda',0),(138413,3845,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(138414,3845,'fr','Ensembles de balisage standard',0),(138415,3845,'jp','æ¨™æº–å€¤ä¸Šã?’',0),(138416,3845,'pt','Conjuntos padrÃ£o de marcaÃ§Ã£o',0),(138417,3845,'ru','ÐÐ°Ð±Ð¾Ñ€Ñ‹ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(138418,3845,'es','Margen EstÃ¡ndar',0),(138419,3845,'de','Standard-Markup-Sets',0),(138420,3845,'en','Standard Markup Sets',0),(138421,3846,'is','',0),(138422,3846,'dr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ØªÙ†Ø¸ÙŠÙ… Ù…ÙŠ Ø´ÙˆØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø®ÙˆØ¯ÙƒØ§Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(138423,3846,'pr','Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ØªÙ†Ø¸ÙŠÙ… Ù…ÙŠ Ø´ÙˆØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙØ²Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø®ÙˆØ¯ÙƒØ§Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(138424,3846,'tr','Auto-iÅŸaretleme kadar stok iÃ§in standart biÃ§imlendirme ayarlar',0),(138425,3846,'pl','Standardowych zestawÃ³w znacznikÃ³w dla Auto-oznaczania siÄ™ zapasÃ³w',0),(138426,3846,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð° ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¸ Ð·Ð° Ð°Ð²Ñ‚Ð¾-Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(138427,3846,'ur','Ø®ÙˆØ¯ Ù†Ø´Ø§Ù† Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ØªØ§ ÛÛ’',0),(138428,3846,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð·Ð½Ð°ÐºÐµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™Ð° Ð·Ð° Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð¾Ð·Ð½Ð°Ñ‡Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(138429,3846,'vi','Má»©c Cá»™ng ThÃªm Chuáº©n Cho HÃ ng Trong Kho Tá»± Äá»™ng Cá»™ng ThÃªm',0),(138430,3846,'af','Standaard Markup stelle vir Outo-merk van voorraad',0),(138431,3846,'ro','Seturi de marcare standard pentru Auto-marcarea inventar',0),(138432,3846,'et','Standardne mÃ¤rgistuskeel seab Auto-mÃ¤rgistamise kuni varude',0),(138433,3846,'si','Standardni oznaÄevalni nastavi samodejno oznaÄevanje zaloge',0),(138434,3846,'ba','Set Markup standar untuk Auto-Marking atas persediaan',0),(138435,3846,'nl','Standaardcoderingstaal ingesteld voor Auto-markering inventarisatie',0),(138436,3846,'fi','Standardi merkintÃ¤kieli asettaa Auto-merkinnÃ¤n inventaariossa',0),(138437,3846,'no','Standard kode angir for Auto-merking opp lager',0),(138438,3846,'da','Standard Markup sÃ¦t til Auto-mÃ¦rkning opgÃ¸relse',0),(138439,3846,'ko','ìž¬ê³ ë¥¼ ìžë™ ë§ˆí‚¹ í‘œì¤€ íƒœê·¸ ì§‘í•©',0),(138440,3846,'he','×”×¡×™×ž×•×Ÿ ×”×¡×˜× ×“×¨×˜×™×ª ×ž×’×“×™×¨×” ×¢×‘×•×¨ ×¡×™×ž×•×Ÿ ××•×˜×•×ž×˜×™ ××ª ×”×ž×œ××™',0),(138441,3846,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ Ï€Î¿Ï… Î¸Î­Ï„ÎµÎ¹ Î³Î¹Î± Ï„Î¿ Auto-ÏƒÎ®Î¼Î±Î½ÏƒÎ· Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(138442,3846,'zh','è‡ªåŠ¨æ ‡è®°åº“å­˜çš„æ ‡å‡†æ ‡è®°é›†\r\n',0),(138443,3846,'sv','StandarduppsÃ¤ttningar Markup fÃ¶r Auto-mÃ¤rkning inventering',0),(138444,3846,'it','Set standard di Markup per Auto-marcatura inventario',0),(138445,3846,'tl','',0),(138446,3846,'th','&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3619;&#3634;&#3588;&#3634;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;&#3626;&#3635;&#3',0),(138447,3846,'hi','à¤‘à¤Ÿà¥‹-à¤…à¤‚à¤•à¤¨ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤…à¤ª à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¨à¤• à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ',0),(138448,3846,'ms','Set penanda piawaian untuk Auto-tanda sehingga inventori',0),(138449,3846,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ù„Ù„Ø³ÙŠØ§Ø±Ø§Øª-ÙˆØ³Ù… ÙŠØµÙ„ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(138450,3846,'fr','Balisage standard dÃ©finit pour Auto-marquage vers le haut de l\'inventaire',0),(138451,3846,'jp','è‡ªå‹•å€¤ä¸Šã?’åœ¨åº«ã?®æ¨™æº–å€¤ä¸Šã?’è¨­å®š',0),(138452,3846,'pt','Conjuntos padrÃ£o de marcaÃ§Ã£o para marcaÃ§Ã£o automÃ¡tica de inventÃ¡rio',0),(138453,3846,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð°Ñ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ° ÑƒÑÑ‚Ð°Ð½Ð°Ð²Ð»Ð¸Ð²Ð°ÐµÑ‚ Ð´Ð»Ñ Ð°Ð²Ñ‚Ð¾-Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð¾Ð²ÐºÐ¸ Ð²Ð²ÐµÑ€Ñ… Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(138454,3846,'es','Juegos de Ecarecimiento EstÃ¡ndar para Auto-Encarecimiento de Inventario',0),(138455,3846,'de','StandardmÃ¤ÃŸig wird fÃ¼r Auto-Kennzeichnung Bestandsaufnahme',0),(138456,3846,'en','Standard Markup Sets for Auto-Marking up Inventory',0),(138457,3847,'is','',0),(138458,3847,'dr','/ Ú†Ø§Ù¾   ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù‡Ø§',0),(138459,3847,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡  / Ú†Ø§Ù¾   ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù‡Ø§',0),(138460,3847,'tr','Deyimleri GÃ¶rÃ¼ntÃ¼le/YazdÄ±r',0),(138461,3847,'pl','WyÅ›wietl/drukuj instrukcji',0),(138462,3847,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´/Ð¿ÐµÑ‡Ð°Ñ‚ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(138463,3847,'ur','Ù…Ù†Ø¸Ø±/Ø¨ÛŒØ§Ù†Ø§Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(138464,3847,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· /ÐŸÑ€Ð¸Ð½Ñ‚ Ð¸Ð·Ñ˜Ð°Ð²Ðµ',0),(138465,3847,'vi','Xem/In Sao kÃª',0),(138466,3847,'af','Besigtig/Druk Staat',0),(138467,3847,'ro','Vezi/declaraÅ£ii de imprimare',0),(138468,3847,'et','Vaata/Prindi vÃ¤ljavÃµtteid',0),(138469,3847,'si','Poglej/Natisni izjave',0),(138470,3847,'ba','Lihat/Cetak laporan',0),(138471,3847,'nl','Weergeven/afdrukken verklaringen',0),(138472,3847,'fi','NÃ¤ytÃ¤ tai tulosta lausumat',0),(138473,3847,'no','Vis/Skriv ut uttalelser',0),(138474,3847,'da','Se/Udskriv udtalelser',0),(138475,3847,'ko','ë³´ê¸°/ì¸ì‡„ ë¬¸ì˜',0),(138476,3847,'he','×”×¦×’/×”×“×¤×¡ ×”×¦×”×¨×•×ª',0),(138477,3847,'el','Î ÏÎ¿Î²Î¿Î»Î®/Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î´Î·Î»ÏŽÏƒÎµÎ¹Ï‚',0),(138478,3847,'zh','æŸ¥çœ‹/æ‰“å°å£°æ˜Ž\r\n',0),(138479,3847,'sv','View/Print uttalanden',0),(138480,3847,'it','Visualizza/stampa dichiarazioni',0),(138481,3847,'tl','',0),(138482,3847,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;/&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(138483,3847,'hi','à¤¦à¥ƒà¤¶à¥à¤¯/à¤¬à¤¯à¤¾à¤¨ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(138484,3847,'ms','View/Print penyata',0),(138485,3847,'ar','Ø¹Ø±Ø¶/Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(138486,3847,'fr','Visualiser/imprimer des dÃ©clarations',0),(138487,3847,'jp','æ±ºç®—æ›¸ã€€è¡¨ç¤º/å?°åˆ·',0),(138488,3847,'pt','Ver/imprimir instruÃ§Ãµes',0),(138489,3847,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(138490,3847,'es','Ver/Imprimir Declaraciones',0),(138491,3847,'de','Drucken Sie anzeigen/Anweisungen',0),(138492,3847,'en','Statements',0),(138493,3848,'is','',0),(138494,3848,'dr','(Ù…Ù†ØªØ¸Ø±) ØªØ¹ÙˆÛŒÙ‚ ',0),(138495,3848,'pr','ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´Ø§Øª(Ù…Ù†ØªØ¸Ø±) Ù…Ø¹ÙˆÙ‚ ',0),(138496,3848,'tr','Bekleyen sipariÅŸler durumunu',0),(138497,3848,'pl','Stan zamÃ³wieÅ„',0),(138498,3848,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð²Ð¸ÑÑÑ‰Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(138499,3848,'ur','Ø§Ø´Ø®Ø§Øµ Ú©Û’ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(138500,3848,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ°',0),(138501,3848,'vi','TÃ¬nh tráº¡ng Ä‘Æ¡n hÃ ng chÆ°a thá»±c hiá»‡n',0),(138502,3848,'af','Status van Afwagtende Bestellings',0),(138503,3848,'ro','Statutul de pÃ¢nÄƒ la ordinele',0),(138504,3848,'et','Oleku ootel tellimused',0),(138505,3848,'si','Stanje ÄakajoÄih nalogov',0),(138506,3848,'ba','Status Pending Order',0),(138507,3848,'nl','Status van bestellingen',0),(138508,3848,'fi','Odottavien tilausten tila',0),(138509,3848,'no','Statusen for ventende bestillinger',0),(138510,3848,'da','Status for afventende ordrer',0),(138511,3848,'ko','ì£¼ë¬¸ ì¤‘ì¸ ìƒíƒœ',0),(138512,3848,'he','×”×ž×¦×‘ ×©×œ ×”×•×¨××•×ª ×ž×ž×ª×™× ×•×ª',0),(138513,3848,'el','ÎšÎ±Î¸ÎµÏƒÏ„ÏŽÏ‚ Ï„Ï‰Î½ ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(138514,3848,'zh','æŒ‚å•çŠ¶æ€\r\n',0),(138515,3848,'sv','Statusen fÃ¶r vÃ¤ntande order',0),(138516,3848,'it','Stato di ordini pendenti',0),(138517,3848,'tl','',0),(138518,3848,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(138519,3848,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(138520,3848,'ms','Status pesanan dagangan tertunda',0),(138521,3848,'ar','Ø­Ø§Ù„Ø© Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(138522,3848,'fr','Statut des commandes en attente',0),(138523,3848,'jp','ä¿?ç•™ä¸­æ³¨æ–‡ã?®çŠ¶æ³?',0),(138524,3848,'pt','Status de ordens pendentes',0),(138525,3848,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ñ Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(138526,3848,'es','Staus de Ordenes Pendientes',0),(138527,3848,'de','Status der ausstehenden Bestellungen',0),(138528,3848,'en','Status of Pending Orders',0),(138529,3849,'is','',0),(138530,3849,'dr','Ù†ÙŠØ§Ø²Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(138531,3849,'pr','Ù†ÙŠØ§Ø²Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(138532,3849,'tr','Stok ihtiyaÃ§larÄ±nÄ±',0),(138533,3849,'pl','PieÅ„ potrzeb',0),(138534,3849,'bg','Ð‘Ð¾Ñ€ÑÐ¾Ð²Ð° Ð½ÑƒÐ¶Ð´Ð¸',0),(138535,3849,'ur','Ø³Ù¹Ø§Ú© Ú©ÛŒ Ø¶Ø±ÙˆØ±ÛŒØ§Øª',0),(138536,3849,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°Ð¼Ð°',0),(138537,3849,'vi','Nhu cáº§u HÃ ng tá»“n',0),(138538,3849,'af','Voorraad Benodig',0),(138539,3849,'ro','Necesar stoc',0),(138540,3849,'et','Varude vajadusi',0),(138541,3849,'si','Osnovne potrebe',0),(138542,3849,'ba','Kebutuhan saham',0),(138543,3849,'nl','Voorraad behoeften',0),(138544,3849,'fi','Varastossa tarpeisiin',0),(138545,3849,'no','Lager behov',0),(138546,3849,'da','Stock behov',0),(138547,3849,'ko','ìž¬ê³  ìš”êµ¬',0),(138548,3849,'he','×”×¦×¨×›×™× ×ž× ×™×•×ª',0),(138549,3849,'el','Î‘Î½Î¬Î³ÎºÎµÏ‚ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(138550,3849,'zh','åº“å­˜éœ€æ±‚\r\n',0),(138551,3849,'sv','Lager behov',0),(138552,3849,'it','Esigenze di magazzino',0),(138553,3849,'tl','',0),(138554,3849,'th','&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(138555,3849,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(138556,3849,'ms','Keperluan stok',0),(138557,3849,'ar','Ø§Ø­ØªÙŠØ§Ø¬Ø§Øª Ø§Ù„Ø£Ø³Ù‡Ù…',0),(138558,3849,'fr','Besoins de stock',0),(138559,3849,'jp','åœ¨åº«ã?®å¿…è¦?æ€§',0),(138560,3849,'pt','Necessidades de estoque',0),(138561,3849,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ñ… Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ÑÑ‚Ð¸',0),(138562,3849,'es','Stock Necesidades',0),(138563,3849,'de','Hat BedÃ¼rfnisse',0),(138564,3849,'en','Stock Needs',0),(138565,3850,'is','',0),(138566,3850,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù†ÙŠØ§Ø²Ù…Ù†Ø¯ÙŠÙ‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø§Ø®Ù„ÙŠ Ø³Ø§Ø²Ù…Ø§Ù† ',0),(138567,3850,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù†ÙŠØ§Ø²Ù…Ù†Ø¯ÙŠÙ‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø§Ø®Ù„ÙŠ Ø³Ø§Ø²Ù…Ø§Ù† ',0),(138568,3850,'tr','Kurum iÃ§i sipariÅŸler iÃ§in stok gereksinimlerinin raporu',0),(138569,3850,'pl','Raport czas wymagania dla zleceÅ„ wewnÄ™trznych',0),(138570,3850,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð½Ð° ÑÐºÐ»Ð°Ð´ Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð² ÐºÑŠÑ‰Ð°Ñ‚Ð°',0),(138571,3850,'ur','Ú¯Ú¾Ø± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ø§Ø³Ù¹Ø§Ú© Ú©ÛŒ Ø¶Ø±ÙˆØ±ÛŒØ§Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(138572,3850,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð·Ð°Ð»Ð¸Ñ…Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾Ð³ Ð·Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(138573,3850,'vi','BÃ¡o cÃ¡o hÃ ng cáº§n thiáº¿t cho Ä‘Æ¡n hÃ ng ná»™i bá»™',0),(138574,3850,'af','Verslag van Voorraad Benodighede vir bestellings inhuisig',0),(138575,3850,'ro','Raport necesar stoc pentru comenzi interne',0),(138576,3850,'et','EttevÃµttesiseste tellimuste varu nÃµudeid aruande',0),(138577,3850,'si','PoroÄilo o zalogi zahteve naroÄila in-house',0),(138578,3850,'ba','Laporan saham persyaratan untuk pesanan rumah',0),(138579,3850,'nl','Verslag van voorraad eisen voor bestellingen in-house',0),(138580,3850,'fi','Koskevien vaatimusten laatimista tilaukset talon',0),(138581,3850,'no','Rapporten lager krav for bestillinger in-house',0),(138582,3850,'da','Rapport fra lager krav for ordrer in-house',0),(138583,3850,'ko','ì£¼ë¬¸ ìžì²´ì— ëŒ€ í•œ ìž¬ê³  ìš”êµ¬ ì‚¬í•­ ë³´ê³ ì„œ',0),(138584,3850,'he','×“×• ×— ×ž×œ××™ ×”×“×¨×™×©×•×ª ×¢×‘×•×¨ ×”×–×ž× ×•×ª ×œ×œ× ×¦×•×¨×š ×‘×ž×™×§×•×¨ ×—×•×¥',0),(138585,3850,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î·Ï‚ Î±Ï€Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ Ï…Î»Î¹ÎºÎ¿Ï Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚-ÏƒÏ€Î¯Ï„Î¹',0),(138586,3850,'zh','è®¢å•å†…éƒ¨åº“å­˜è¦æ±‚æŠ¥å‘Š\r\n',0),(138587,3850,'sv','BetÃ¤nkande av lager krav fÃ¶r order internt',0),(138588,3850,'it','Rapporto di Stock requisiti per gli ordini interni',0),(138589,3850,'tl','',0),(138590,3850,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3626;&#3605;&#3658;&#3629;&#3588;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3',0),(138591,3850,'hi','à¤˜à¤° à¤®à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤Ÿà¥‰à¤• à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾à¤“à¤‚ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(138592,3850,'ms','Laporan keperluan stok bagi perintah-perintah dalaman',0),(138593,3850,'ar','ØªÙ‚Ø±ÙŠØ± \"ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ø§Ø­ØªÙŠØ§Ø¬Ø§Øª\" Ù„Ø£ÙˆØ§Ù…Ø± Ø¯Ø§Ø®Ù„ÙŠØ©',0),(138594,3850,'fr','Rapport des exigences de Stock pour les commandes internes',0),(138595,3850,'jp','ç¤¾å†…æ³¨æ–‡ã?®å¿…è¦?åœ¨åº«ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(138596,3850,'pt','RelatÃ³rio de estoque requisitos para ordens internas',0),(138597,3850,'ru','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð¤Ð¾Ð½Ð´Ð° Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ð¹ Ð´Ð»Ñ Ð²Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(138598,3850,'es','Informe de Requerimientos de Stock para Ordenes en-casa',0),(138599,3850,'de','Bericht der Lager-Anforderungen fÃ¼r AuftrÃ¤ge Inhouse',0),(138600,3850,'en','Report of Stock Requirements for orders in-house',0),(138601,3851,'is','',0),(138602,3851,'dr','Ø®Ù„Ø§ØµÙ‡ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(138603,3851,'pr','Ø®Ù„Ø§ØµÙ‡ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(138604,3851,'tr','YaÅŸlanma - Ã–zeti',0),(138605,3851,'pl','Starzenie siÄ™ - podsumowanie',0),(138606,3851,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ - Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(138607,3851,'ur','Ø®Ø³ØªÛ - Ø®Ù„Ø§ØµÛ',0),(138608,3851,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ - Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(138609,3851,'vi','Tá»•ng Há»£p - SÆ¡ káº¿t',0),(138610,3851,'af','Ouderdom - Opsomming',0),(138611,3851,'ro','ÃŽmbÄƒtrÃ¢nirea - Scurta descriere',0),(138612,3851,'et','Vananemine - KokkuvÃµte',0),(138613,3851,'si','Staranje - Povzetek',0),(138614,3851,'ba','Penuaan - ringkasan',0),(138615,3851,'nl','Veroudering - samenvatting',0),(138616,3851,'fi','IkÃ¤Ã¤ntyminen - Yhteenveto',0),(138617,3851,'no','Aldring - Sammendrag',0),(138618,3851,'da','Aldring - ResumÃ©',0),(138619,3851,'ko','ë…¸í™”-ìš”ì•½',0),(138620,3851,'he','×”×–×“×§× ×•×ª - ×ª×§×¦×™×¨',0),(138621,3851,'el','Î“Î®ÏÎ±Î½ÏƒÎ· - Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(138622,3851,'zh','è€åŒ–- â€‹â€‹æ‘˜è¦\r\n',0),(138623,3851,'sv','Ã…ldrande - Sammanfattning',0),(138624,3851,'it','Invecchiamento - Sommario',0),(138625,3851,'tl','',0),(138626,3851,'th','&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;&#3650;&#3604;&#3618;&#3626;&#3619;&#3640;&#3611;',0),(138627,3851,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ - à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(138628,3851,'ms','Penuaan - ringkasan',0),(138629,3851,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©-Ù…Ù„Ø®Øµ',0),(138630,3851,'fr','Vieillissement - RÃ©sumÃ©',0),(138631,3851,'jp','discount/penalty summary  ãƒ‡ã‚£ã‚¹ã‚«ã‚¦ãƒ³ãƒˆ/ç½°é‡‘ã€€é›†è¨ˆ',0),(138632,3851,'pt','Envelhecimento - Resumo',0),(138633,3851,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ - Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(138634,3851,'es','AntigÃ¼edad - Resumen',0),(138635,3851,'de','Aging - Zusammenfassung',0),(138636,3851,'en','Aging - Summary',0),(138637,3852,'is','',0),(138638,3852,'dr','Ø®Ù„Ø§ØµÙ‡ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(138639,3852,'pr','Ø®Ù„Ø§ØµÙ‡ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(138640,3852,'tr','Fatura Ã–zeti listeleri',0),(138641,3852,'pl','Podsumowanie listy faktur',0),(138642,3852,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½Ð¸ ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(138643,3852,'ur','Ø®Ù„Ø§ØµÛ Ø²Ù„Ø²Ù„Û ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ',0),(138644,3852,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð»Ð¸ÑÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(138645,3852,'vi','Danh sÃ¡ch tá»•ng há»£p hÃ³a Ä‘Æ¡n',0),(138646,3852,'af','Opsommingslyste van Fakture',0),(138647,3852,'ro','Sumarul listelor de facturi',0),(138648,3852,'et','Ning arvete',0),(138649,3852,'si','Povzetek sezname raÄunov',0),(138650,3852,'ba','Daftar ringkasan tagihan',0),(138651,3852,'nl','Samenvatting lijsten van facturen',0),(138652,3852,'fi','Yhteenveto-luettelot laskujen',0),(138653,3852,'no','Sammendrag lister over fakturaer',0),(138654,3852,'da','Sammenfattende lister over fakturaer',0),(138655,3852,'ko','ì²­êµ¬ì„œì˜ ìš”ì•½ ëª©ë¡',0),(138656,3852,'he','×¨×©×™×ž×•×ª ×¡×™×›×•× ×©×œ ×—×©×‘×•× ×™×•×ª',0),(138657,3852,'el','Î£Ï…Î½Î¿Ï€Ï„Î¹ÎºÎ¿Î¯ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Ï„Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(138658,3852,'zh','å‘ç¥¨çš„æ‘˜è¦åˆ—è¡¨\r\n',0),(138659,3852,'sv','Sammanfattning listor av fakturor',0),(138660,3852,'it','Liste di riepilogo delle fatture',0),(138661,3852,'tl','',0),(138662,3852,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(138663,3852,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(138664,3852,'ms','Ringkasan senarai invois',0),(138665,3852,'ar','Ù‚ÙˆØ§Ø¦Ù… Ù…ÙˆØ¬Ø²Ø© Ù…Ù† Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(138666,3852,'fr','Liste sommaire des factures',0),(138667,3852,'jp','è«‹æ±‚æ›¸ã‚µãƒžãƒªãƒ¼ãƒªã‚¹ãƒˆ',0),(138668,3852,'pt','Listas resumidas de facturas',0),(138669,3852,'ru','Ð¡Ð²Ð¾Ð´Ð½Ñ‹Ðµ ÑÐ¿Ð¸ÑÐºÐ¸ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(138670,3852,'es','Listas de Resumen de Facturas',0),(138671,3852,'de','Zusammenfassende Liste der Rechnungen',0),(138672,3852,'en','Summary Lists of Invoices',0),(138673,3853,'is','',0),(138674,3853,'dr','Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(138675,3853,'pr','Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(138676,3853,'tr','Fatura Ã–zeti',0),(138677,3853,'pl','Podsumowanie faktury',0),(138678,3853,'bg','Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(138679,3853,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(138680,3853,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(138681,3853,'vi','Tá»•ng há»£p hÃ³a Ä‘Æ¡n',0),(138682,3853,'af','Opsomming van Fakture',0),(138683,3853,'ro','Sumarul facturilor',0),(138684,3853,'et','Arvete Kogusumma',0),(138685,3853,'si','Povzetek raÄunov',0),(138686,3853,'ba','Ringkasan tagihan',0),(138687,3853,'nl','Samenvatting van facturen',0),(138688,3853,'fi','Yhteenveto laskujen',0),(138689,3853,'no','Sammendrag av fakturaer',0),(138690,3853,'da','ResumÃ© af fakturaer',0),(138691,3853,'ko','ì²­êµ¬ì„œì˜ ìš”ì•½',0),(138692,3853,'he','×¡×™×›×•× ×©×œ ×—×©×‘×•× ×™×•×ª',0),(138693,3853,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Ï„Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(138694,3853,'zh','å‘ç¥¨æ‘˜è¦\r\n',0),(138695,3853,'sv','Sammanfattning av fakturor',0),(138696,3853,'it','Riepilogo delle fatture',0),(138697,3853,'tl','',0),(138698,3853,'th','&#3626;&#3619;&#3640;&#3611;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(138699,3853,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(138700,3853,'ms','Ringkasan invois',0),(138701,3853,'ar','Ù…Ù„Ø®Ù‘Øµ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(138702,3853,'fr','RÃ©sumÃ© des factures',0),(138703,3853,'jp','è«‹æ±‚æ›¸ã?®é›†è¨ˆ',0),(138704,3853,'pt','Resumo de facturas',0),(138705,3853,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(138706,3853,'es','Resumen de Facturas',0),(138707,3853,'de','Zusammenfassung der Rechnungen',0),(138708,3853,'en','Summary of Invoices',0),(138709,3854,'is','',0),(138710,3854,'dr','Ø¯Ù„Ø§ÙŠÙ„ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ÙØ±ÙˆØ´ ',0),(138711,3854,'pr','Ø¯Ù„Ø§ÙŠÙ„ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ÙØ±ÙˆØ´ ',0),(138712,3854,'tr','SatÄ±ÅŸ vergisi muafiyet nedenleri',0),(138713,3854,'pl','Przyczyny zwolnienia z podatku',0),(138714,3854,'bg','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð¸ Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(138715,3854,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡ ÙˆØ¬ÙˆÛØ§Øª Ú©ÛŒ Ø¨Ù†Ø§ Ù¾Ø±',0),(138716,3854,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¸Ð·ÑƒÐ·ÐµÑ›Ñƒ Ñ€Ð°Ð·Ð»Ð¾Ð³Ðµ',0),(138717,3854,'vi','LÃ½ do Miá»…n thuáº¿ bÃ¡n hÃ ng',0),(138718,3854,'af','Redes vir Verkoopsbelasting Vrystelling',0),(138719,3854,'ro','Motive de scutire de impozitul pe vÃ¢nzÄƒri',0),(138720,3854,'et','MÃ¼Ã¼gimaksu vabastuse pÃµhjused',0),(138721,3854,'si','Razlogi za oprostitev prometnega davka',0),(138722,3854,'ba','Alasan Pembebasan pajak penjualan',0),(138723,3854,'nl','Sales Tax vrijstelling redenen',0),(138724,3854,'fi','ArvonlisÃ¤veron vapautus syistÃ¤',0),(138725,3854,'no','Mva-fritak grunner',0),(138726,3854,'da','Sales Tax fritagelse grunde',0),(138727,3854,'ko','íŒë§¤ì„¸ ë©´ì œ ì´ìœ ',0),(138728,3854,'he','×¡×™×‘×•×ª ×¤×˜×•×¨ ×ž×¢ ×ž',0),(138729,3854,'el','Î›ÏŒÎ³Î¿Ï…Ï‚ Î±Ï€Î±Î»Î»Î±Î³Î®Ï‚ Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(138730,3854,'zh','å…å¾è¥ä¸šç¨Žçš„åŽŸå› \r\n',0),(138731,3854,'sv','Moms undantaget skÃ¤l',0),(138732,3854,'it','Motivi di esenzione IVA',0),(138733,3854,'tl','',0),(138734,3854,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3651;&#3609;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(138735,3854,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤›à¥‚à¤Ÿ à¤•à¤¾à¤°à¤£à¥‹à¤‚',0),(138736,3854,'ms','Sebab-sebab pengecualian cukai jualan',0),(138737,3854,'ar','Ø£Ø³Ø¨Ø§Ø¨ Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ',0),(138738,3854,'fr','Raisons d\'Exemption de taxe de vente',0),(138739,3854,'jp','è²©å£²ç¨ŽæŽ§é™¤ã?®ç?†ç”±',0),(138740,3854,'pt','RazÃµes de isenÃ§Ã£o de imposto sobre vendas',0),(138741,3854,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ ÐžÑ‚ ÐÐ°Ð»Ð¾Ð³Ð° Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(138742,3854,'es','Razones de Exenciones de IVA',0),(138743,3854,'de','Umsatzsteuer-Befreiung-GrÃ¼nde',0),(138744,3854,'en','Sales Tax Exemption Reasons',0),(138745,3855,'is','',0),(138746,3855,'dr','Ø²Ù…Ø§Ù†  Ùˆ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(138747,3855,'pr','Ø²Ù…Ø§Ù†  Ùˆ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(138748,3855,'tr','Zaman & malzemeleri',0),(138749,3855,'pl','Czas & materiaÅ‚Ã³w',0),(138750,3855,'bg','Ð’Ñ€ÐµÐ¼Ðµ & Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸',0),(138751,3855,'ur','ÙˆÙ‚Øª & Ù…ÙˆØ§Ø¯',0),(138752,3855,'sr','Ð’Ñ€ÐµÐ¼ÐµÐ½Ð° Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð°',0),(138753,3855,'vi','Thá»i gian vÃ  nguyÃªn liá»‡u',0),(138754,3855,'af','Tyd en Materiale',0),(138755,3855,'ro','Timp & materiale',0),(138756,3855,'et','Aeg & materjalid',0),(138757,3855,'si','ÄŒas & materialov',0),(138758,3855,'ba','Waktu & bahan',0),(138759,3855,'nl','Tijd & materialen',0),(138760,3855,'fi','Tuolloin & materiaalit',0),(138761,3855,'no','Tid & materialer',0),(138762,3855,'da','Tid & materialer',0),(138763,3855,'ko','ì‹œê°„ & ìžë£Œ',0),(138764,3855,'he','×–×ž×Ÿ ×•×—×•×ž×¨×™×',0),(138765,3855,'el','Î§ÏÏŒÎ½Î¿ & Ï…Î»Î¹ÎºÎ¬',0),(138766,3855,'zh','æ—¶é—´ä¸Žææ–™\r\n',0),(138767,3855,'sv','Tid & material',0),(138768,3855,'it','Tempo & materiali',0),(138769,3855,'tl','',0),(138770,3855,'th','&#3648;&#3623;&#3621;&#3634;&#3649;&#3621;&#3632;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(138771,3855,'hi','à¤¸à¤®à¤¯ & à¤¸à¤¾à¤®à¤—à¥à¤°à¤¿à¤¯à¥‹à¤‚',0),(138772,3855,'ms','Bahan-bahan & masa',0),(138773,3855,'ar','Ù…ÙˆØ§Ø¯ Ø¢Ù†Ø¯ Ø§Ù„ÙˆÙ‚Øª',0),(138774,3855,'fr','MatÃ©riaux & de temps',0),(138775,3855,'jp','æ™‚é–“ã?¨æ??æ–™',0),(138776,3855,'pt','Materiais & de tempo',0),(138777,3855,'ru','Ð’Ñ€ÐµÐ¼Ñ & ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹',0),(138778,3855,'es','Tiempo & Materiales',0),(138779,3855,'de','Zeit- & -Materialien',0),(138780,3855,'en','Time & Materials',0),(138781,3856,'is','',0),(138782,3856,'dr','Ø«Ø¨Øª Ø²Ù…Ø§Ù† Ùˆ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(138783,3856,'pr','Ø«Ø¨Øª Ø²Ù…Ø§Ù† Ùˆ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(138784,3856,'tr','Zaman ve malzeme sipariÅŸ YazdÄ±r iÃ§in girin',0),(138785,3856,'pl','WprowadÅº czas i materiaÅ‚y do druku zamÃ³wienia',0),(138786,3856,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ñ€ÐµÐ¼Ðµ Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(138787,3856,'ur','ÙˆÙ‚Øª Ø§ÙˆØ± Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ù…ÙˆØ§Ø¯ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(138788,3856,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð²Ñ€ÐµÐ¼Ðµ Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð» Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(138789,3856,'vi','Nháº­p Thá»i gian vÃ  nguyÃªn liá»‡u cho in Ä‘Æ¡n hÃ ng ',0),(138790,3856,'af','Voer tyd en materiaal vir die gedrukte bestellings',0),(138791,3856,'ro','Intre timp ÅŸi materiale pentru comenzi de imprimare',0),(138792,3856,'et','Sisestage aeg ja materjalid trÃ¼kitÃ¶Ã¶de tellimused',0),(138793,3856,'si','Vnesite Äas in materialov za tiskanje nalogov',0),(138794,3856,'ba','Masukkan waktu dan bahan-bahan untuk pesanan cetak',0),(138795,3856,'nl','Geef tijd en materialen voor afdrukken bestellingen',0),(138796,3856,'fi','Anna aika ja materiaali tulosta tilaukset',0),(138797,3856,'no','Angi tid og materialer for bestilling',0),(138798,3856,'da','Angiv tid og materialer til aftryksbestillinger',0),(138799,3856,'ko','ì‹œê°„ ë° ì¸ì‡„ ì£¼ë¬¸ ìžë£Œ ìž…ë ¥',0),(138800,3856,'he','×”×–×Ÿ ×–×ž×Ÿ ×•×—×•×ž×¨×™× ×¢×‘×•×¨ ×”×“×¤×¡×•×ª',0),(138801,3856,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ ÏŽÏÎ± ÎºÎ±Î¹ Ï…Î»Î¹ÎºÎ¬ Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(138802,3856,'zh','ä¸ºæ‰“å°è®¢å•è¾“å…¥æ—¶é—´å’Œææ–™\r\n',0),(138803,3856,'sv','Ange tid och material fÃ¶r print order',0),(138804,3856,'it','Inserire ora e materiali per gli ordini di stampa',0),(138805,3856,'tl','',0),(138806,3856,'th','&#3611;&#3657;&#3629;&#3609;&#3648;&#3623;&#3621;&#3634;&#3649;&#3621;&#3632;&#3611;&#3633;&#3592;&#3592;&#3633;&#3618;&#3648;&#3614;&#3639;&#3656;&#3629;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3',0),(138807,3856,'hi','à¤¸à¤®à¤¯ à¤”à¤° à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(138808,3856,'ms','Masukkan masa dan bahan-bahan untuk cetakan arahan',0),(138809,3856,'ar','Ø£Ø¯Ø®Ù„ Ø§Ù„ÙˆÙ‚Øª ÙˆØ§Ù„Ù…ÙˆØ§Ø¯ Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(138810,3856,'fr','Entrez temps et matÃ©riaux pour les commandes',0),(138811,3856,'jp','å?°åˆ·æ³¨æ–‡ã?®ã?Ÿã‚?ã?®æ™‚é–“ã?¨æ??æ–™ã?®å…¥åŠ›',0),(138812,3856,'pt','Digite o tempo e materiais para impressÃ£o ordens',0),(138813,3856,'ru','Ð’Ð²ÐµÑÑ‚Ð¸ Ð’Ñ€ÐµÐ¼Ñ Ð¸ ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(138814,3856,'es','Introducir Tiempo y Materiales para Ordenes de ImpresiÃ³n',0),(138815,3856,'de','Geben Sie Zeit- und Materialaufwand fÃ¼r DruckauftrÃ¤ge',0),(138816,3856,'en','Enter Time and Materials for print Orders',0),(138817,3857,'is','',0),(138818,3857,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù‡Ø§ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(138819,3857,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù‡Ø§ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(138820,3857,'tr','ParÃ§a yerine getirilmesi iÅŸlemleri',0),(138821,3857,'pl','Åšledzenie realizacji procesÃ³w',0),(138822,3857,'bg','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¸',0),(138823,3857,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û ØªÚ©Ù…ÛŒÙ„ Ø¹Ù…Ù„',0),(138824,3857,'sr','ÐŸÑ€Ð°Ñ›ÐµÑšÐµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ',0),(138825,3857,'vi','Theo dÃµi QuÃ¡ trÃ¬nh hoÃ n táº¥t',0),(138826,3857,'af','Uitvoeringsprosesse Spoor',0),(138827,3857,'ro','UrmÄƒri Ã®ndeplinirea proceselor',0),(138828,3857,'et','Pala tÃ¤itmine protsesside',0),(138829,3857,'si','Skladbo izpolnitve procesov',0),(138830,3857,'ba','Melacak proses pemenuhan',0),(138831,3857,'nl','Vervulling processen bijhouden',0),(138832,3857,'fi','Seuraa tÃ¤yttÃ¤minen prosesseja',0),(138833,3857,'no','Spore oppfyllelse prosesser',0),(138834,3857,'da','Spore opfyldelse processer',0),(138835,3857,'ko','ì‹¤í˜„ í”„ë¡œì„¸ìŠ¤ ì¶”ì ',0),(138836,3857,'he','×ž×¢×§×‘ ××—×¨ ×ª×”×œ×™×›×™ ×”×’×©×ž×”',0),(138837,3857,'el','Î Î±ÏÎ±ÎºÎ¿Î»Î¿Ï…Î¸ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯ÎµÏ‚',0),(138838,3857,'zh','å®žæ–½è¿‡ç¨‹è·Ÿè¸ª\r\n',0),(138839,3857,'sv','SpÃ¥ra uppfyllelse processer',0),(138840,3857,'it','Monitorare i processi di realizzazione',0),(138841,3857,'tl','',0),(138842,3857,'th','&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(138843,3857,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾à¤“à¤‚ à¤•à¥‹ à¤Ÿà¥à¤°à¥ˆà¤•',0),(138844,3857,'ms','Mengesan pencapaian proses',0),(138845,3857,'ar','ØªØ¹Ù‚Ø¨ Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„ÙˆÙØ§Ø¡',0),(138846,3857,'fr','Effectuer le suivi des processus de rÃ©alisation',0),(138847,3857,'jp','å±¥è¡Œé?Žç¨‹ã?®è¿½è·¡',0),(138848,3857,'pt','Controlar os processos de realizaÃ§Ã£o',0),(138849,3857,'ru','ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ñ‚ÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ð²',0),(138850,3857,'es','Procesos de Cumpimiento de Rastreos',0),(138851,3857,'de','Track-Fulfillment-Prozesse',0),(138852,3857,'en','Track Fulfillment Processes',0),(138853,3858,'is','',0),(138854,3858,'dr','Ù†Ø§Ù… Ù‡Ø§ÙŠ ÙˆØ§Ø­Ø¯ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(138855,3858,'pr','Ù†Ø§Ù… Ù‡Ø§ÙŠ ÙˆØ§Ø­Ø¯ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(138856,3858,'tr','SatÄ±lan maddeler iÃ§in birim adlarÄ±',0),(138857,3858,'pl','Nazwy jednostek sprzedanych',0),(138858,3858,'bg','Ð˜Ð¼ÐµÐ½Ð° Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(138859,3858,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ ÙØ±ÙˆØ®Øª Ú©Û’ Ù„Ø¦Û’ ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù…',0),(138860,3858,'sr','Ð˜Ð¼ÐµÐ½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(138861,3858,'vi','TÃªn Ä‘Æ¡n vá»‹ cho hÃ ng Ä‘Ã£ bÃ¡n',0),(138862,3858,'af','Eenheidname vir Items Verkoop',0),(138863,3858,'ro','Nume de unitatea pentru produse vandute',0),(138864,3858,'et','Ãœksuste nimede mÃ¼Ã¼dud',0),(138865,3858,'si','Imena enote za artikle',0),(138866,3858,'ba','Nama unit untuk barang-barang yang dijual',0),(138867,3858,'nl','De namen van eenheden voor verkochte objecten',0),(138868,3858,'fi','YksikÃ¶iden nimien myytyjen nimikkeiden',0),(138869,3858,'no','Enhetsnavn for solgte varer',0),(138870,3858,'da','Enhed navne for solgte varer',0),(138871,3858,'ko','ìƒí’ˆ íŒë§¤ì— ëŒ€ í•œ ìž¥ì¹˜ ì´ë¦„',0),(138872,3858,'he','×™×—×™×“×ª ×©×ž×•×ª ×¢×‘×•×¨ ×”×¤×¨×™×˜×™× ×©× ×ž×›×¨×•',0),(138873,3858,'el','ÎœÎ¿Î½Î¬Î´Î± Î¿Î½ÏŒÎ¼Î±Ï„Î± Î³Î¹Î± Ï„Î± ÎµÎ¯Î´Î· Ï€Î¿Ï… Ï€Î¿Ï…Î»Î®Î¸Î·ÎºÎ±Î½',0),(138874,3858,'zh','å‡ºå”®çš„ç‰©å“å•ä½åç§°\r\n',0),(138875,3858,'sv','Namn fÃ¶r sÃ¥lda artiklar',0),(138876,3858,'it','I nomi di unitÃ  per gli articoli venduti',0),(138877,3858,'tl','',0),(138878,3858,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3586;&#3634;&#3618;',0),(138879,3858,'hi','à¤†à¤‡à¤Ÿà¤® à¤¬à¥‡à¤šà¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤•à¥‡ à¤¨à¤¾à¤®',0),(138880,3858,'ms','Nama unit untuk dijual',0),(138881,3858,'ar','Ø£Ø³Ù…Ø§Ø¡ ÙˆØ­Ø¯Ø© Ù„Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø¨Ø§Ø¹Ø©',0),(138882,3858,'fr','Noms des unitÃ©s pour les articles vendus',0),(138883,3858,'jp','è²©å£²æ¸ˆå“?ç›®ã?®å?˜ä½?å??',0),(138884,3858,'pt','Nomes de unidade para itens vendidos',0),(138885,3858,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ñ Ð•Ð´Ð¸Ð½Ð¸Ñ† Ð´Ð»Ñ ÐŸÑ€Ð¾Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(138886,3858,'es','Nombres de Unidades para Items Vendidos',0),(138887,3858,'de','Einheitennamen fÃ¼r verkauften Artikel',0),(138888,3858,'en','Unit Names for Items Sold',0),(138889,3859,'is','',0),(138890,3859,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ±ÙŠ Ø°Ø®ÙŠØ±Ù‡ Ùˆ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(138891,3859,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ±ÙŠ Ø°Ø®ÙŠØ±Ù‡ Ùˆ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(138892,3859,'tr','Ã‡orap ve stok satÄ±n alma iÃ§in Ã¶lÃ§Ã¼ birimleri',0),(138893,3859,'pl','Jednostki miary dla hodowli i zakup zapasÃ³w',0),(138894,3859,'bg','ÐœÐµÑ€Ð½Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ð¾Ñ‚Ð³Ð»ÐµÐ¶Ð´Ð°Ð½Ðµ Ð¸ Ð·Ð°ÐºÑƒÐ¿ÑƒÐ²Ð°Ð½Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(138895,3859,'ur','Ø°Ø®ÛŒØ±Û Ú©Ø±Ù†Û’ Ø§ÙˆØ± Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù¾ÛŒÙ…Ø§Ø¦Ø´ Ú©ÛŒ Ø§Ú©Ø§Ø¦ÛŒØ§Úº',0),(138896,3859,'sr','ÐœÐµÑ€Ð½Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð·Ð° Ð¼ÐµÐ½Ðµ Ð¸ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(138897,3859,'vi','ÄÆ¡n Vá»‹ TÃ­nh ToÃ¡n Cho HÃ ng Tá»“n & Mua HÃ ng Trong Kho',0),(138898,3859,'af','Hoeveelheidseenhede vir Bevoorrading en Aankope Voorraad',0),(138899,3859,'ro','UnitÄƒÅ£i de mÄƒsurÄƒ pentru stocarea ÅŸi cumpÄƒrare stocuri',0),(138900,3859,'et','MÃµÃµtÃ¼hikute ladustamine ja varude osta',0),(138901,3859,'si','Merske enote za naselitve in nakup zaloge',0),(138902,3859,'ba','Satuan ukur untuk kaus kaki dan pembelian persediaan',0),(138903,3859,'nl','Maateenheden voor tricotst en aankoop van de voorraad',0),(138904,3859,'fi','SileÃ¤Ã¤ ja ostaa varaston mittayksikÃ¶t',0),(138905,3859,'no','Enheter for strÃ¸mpe og kjÃ¸pe inventar',0),(138906,3859,'da','MÃ¥leenheder for lagerfÃ¸ring og kÃ¸b af lager',0),(138907,3859,'ko','ìŠ¤íƒ€í‚¹ í•˜ ê³  ìž¬ê³ ë¥¼ êµ¬ìž…ì— ëŒ€ í•œ ì¸¡ì • ë‹¨ìœ„',0),(138908,3859,'he','×™×—×™×“×•×ª ×ž×™×“×” ×’×¨×‘ ×•×¨×›×™×©×ª ×ž×œ××™',0),(138909,3859,'el','ÎœÎ¿Î½Î¬Î´ÎµÏ‚ Î¼Î­Ï„ÏÎ·ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· ÎºÎ±Î¹ Ï„Î·Î½ Î±Î³Î¿ÏÎ¬ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(138910,3859,'zh','åº“å­˜å“ˆè´­ä¹°åº“å­˜çš„è®¡é‡å•ä½\r\n',0),(138911,3859,'sv','MÃ¥ttenheter fÃ¶r lagerhÃ¥llning och kÃ¶pa inventering',0),(138912,3859,'it','UnitÃ  di misura per lo stoccaggio e l\'acquisto di inventario',0),(138913,3859,'tl','',0),(138914,3859,'th','Units of Measure for Stocking and Purchasing Inventory',0),(138915,3859,'hi','à¤®à¥‹à¤œà¤¾ à¤”à¤° à¤®à¤¾à¤² à¤•à¥€ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤ª à¤•à¥€ à¤‡à¤•à¤¾à¤‡à¤¯à¤¾à¤',0),(138916,3859,'ms','Unit ukuran bagi stok dan pembelian inventori',0),(138917,3859,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ Ù„ØªØ®Ø²ÙŠÙ† ÙˆØ´Ø±Ø§Ø¡ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(138918,3859,'fr','UnitÃ©s de mesure pour le stockage et l\'achat d\'inventaire',0),(138919,3859,'jp','ä»•å…¥ã‚Œã?¨è³¼å…¥åœ¨åº«ã?®è¨ˆé‡?å?˜ä½?',0),(138920,3859,'pt','Unidades de medida para estocagem e inventÃ¡rio de compra',0),(138921,3859,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ñ‹ Ð¸Ð·Ð¼ÐµÑ€ÐµÐ½Ð¸Ñ Ð´Ð»Ñ Ñ‡ÑƒÐ»Ð¾Ðº Ð¸ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(138922,3859,'es','Unidades de Medida para Almacenar y Comprar Inventario ',0),(138923,3859,'de','MaÃŸeinheiten fÃ¼r Lagerung und Einkauf Inventur',0),(138924,3859,'en','Units of Measure for Stocking and Purchasing Inventory',0),(138925,3860,'is','',0),(138926,3860,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÙŠØ¯ ',0),(138927,3860,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(138928,3860,'tr','Girin/gÃ¼ncelleme PO',0),(138929,3860,'pl','PO wprowadÅº/aktualizacja',0),(138930,3860,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° PO',0),(138931,3860,'ur','Ù¾Ùˆ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(138932,3860,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐŸÐž',0),(138933,3860,'vi','Nháº­p/Cáº­p Nháº­t ÄÆ¡n Mua HÃ ng',0),(138934,3860,'af','Invoer/Opdateer AB',0),(138935,3860,'ro','IntroduceÅ£i/actualizare PO',0),(138936,3860,'et','PO sisestamine/ajakohastamine',0),(138937,3860,'si','Vnesite posodobitev PO',0),(138938,3860,'ba','Masukkan Update PO',0),(138939,3860,'nl','Invoeren/bijwerken PO',0),(138940,3860,'fi','PÃ¤ivittÃ¤minen PO',0),(138941,3860,'no','Angi/Oppdater PO',0),(138942,3860,'da','Indtast/opdatering PO',0),(138943,3860,'ko','í¬ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(138944,3860,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×©×œ ×¤×•',0),(138945,3860,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· PO',0),(138946,3860,'zh','è¾“å…¥/æ›´æ–°é‡‡è´­è®¢å•\r\n',0),(138947,3860,'sv','Ange/uppdatera PO',0),(138948,3860,'it','Inserisci/Aggiorna PO',0),(138949,3860,'tl','',0),(138950,3860,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;',0),(138951,3860,'hi','PO à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(138952,3860,'ms','Masukkan/Kemaskini PO',0),(138953,3860,'ar','Øµ. Ø¨Ø§Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ«.',0),(138954,3860,'fr','Entrez/mise Ã  jour PO',0),(138955,3860,'jp','æ³¨æ–‡æ›¸ã?®å…¥åŠ›/æ›´æ–°',0),(138956,3860,'pt','Inserir/atualizar PO',0),(138957,3860,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ PO',0),(138958,3860,'es','Introducir/Actualizar OC',0),(138959,3860,'de','Geben Sie/Update PO',0),(138960,3860,'en','Enter/Update PO',0),(138961,3861,'is','',0),(138962,3861,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯',0),(138963,3861,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯',0),(138964,3861,'tr','Varolan bir satÄ±nalma sipariÅŸini gÃ¼ncelleÅŸtirmek',0),(138965,3861,'pl','Aktualizacja istniejÄ…cego zlecenia/zamÃ³wienia zakupu',0),(138966,3861,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(138967,3861,'ur','Ø§ÛŒÚ© Ù…ÙˆØ¬ÙˆØ¯Û Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(138968,3861,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ñƒ Ð¸Ð·Ð»Ð°Ð·Ð½Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(138969,3861,'vi','Cáº­p Nháº­t 1 ÄÆ¡n Mua HÃ ng Hiá»‡n Táº¡i',0),(138970,3861,'af','Opdateer \'n Bestaande Aankoopbestelling',0),(138971,3861,'ro','Actualizarea unei comenzi de cumpÄƒrare',0),(138972,3861,'et','Uuendada olemasoleva ostutellimusega',0),(138973,3861,'si','Posodobitev obstojeÄih nabavni nalog',0),(138974,3861,'ba','Update pesanan pembelian yang ada',0),(138975,3861,'nl','Een bestaande inkooporder bijwerken',0),(138976,3861,'fi','PÃ¤ivitys olemassa olevaan ostotilaukseen',0),(138977,3861,'no','Oppdatere en eksisterende bestilling',0),(138978,3861,'da','Opdatere en eksisterende indkÃ¸bsordre',0),(138979,3861,'ko','ê¸°ì¡´ ì£¼ë¬¸ì„œ ì—…ë°ì´íŠ¸',0),(138980,3861,'he','×¢×“×›×•×Ÿ ×”×–×ž× ×” ×¨×›×™×©×” ×§×™×™×ž×ª',0),(138981,3861,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Î¼Î¹Î± Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎ± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(138982,3861,'zh','æ›´æ–°çŽ°æœ‰çš„é‡‡è´­è®¢å•\r\n',0),(138983,3861,'sv','Uppdatera en befintlig inkÃ¶psorder',0),(138984,3861,'it','Aggiornare un ordine di acquisto esistente',0),(138985,3861,'tl','',0),(138986,3861,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(138987,3861,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤à¤• à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶',0),(138988,3861,'ms','Kemaskini Terakhir pesanan belian yang sedia ada',0),(138989,3861,'ar','ØªØ­Ø¯ÙŠØ« Ø£Ù…Ø± Ø´Ø±Ø§Ø¡ Ù…ÙˆØ¬ÙˆØ¯',0),(138990,3861,'fr','Mise Ã  jour d\'un bon de commande existantes',0),(138991,3861,'jp','æ—¢å­˜ã?®ç™ºæ³¨æ›¸ã‚’æ›´æ–°',0),(138992,3861,'pt','Atualizar uma ordem de compra existente',0),(138993,3861,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(138994,3861,'es','Actualizar un Orden de Compra Existente',0),(138995,3861,'de','Update einer bestehenden Bestellung',0),(138996,3861,'en','Update an Existing Purchase Order',0),(138997,3862,'is','',0),(138998,3862,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ ÙØ§ÙƒØªÙˆØ±',0),(138999,3862,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ ÙØ§ÙƒØªÙˆØ±',0),(139000,3862,'tr','FaturayÄ± GÃ¼ncelleÅŸtir',0),(139001,3862,'pl','Aktualizacji faktury',0),(139002,3862,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(139003,3862,'ur','Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(139004,3862,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(139005,3862,'vi','Cáº­p Nháº­t 1 HÃ³a ÄÆ¡n',0),(139006,3862,'af','Opdateer \'n Faktuur',0),(139007,3862,'ro','Update o facturÄƒ',0),(139008,3862,'et','Uuendatud arve',0),(139009,3862,'si','Posodobitev raÄuna',0),(139010,3862,'ba','Memperbarui faktur',0),(139011,3862,'nl','Bijwerken van een factuur',0),(139012,3862,'fi','PÃ¤ivitÃ¤ laskun',0),(139013,3862,'no','Oppdatere en faktura',0),(139014,3862,'da','Opdater en faktura',0),(139015,3862,'ko','ì—…ë°ì´íŠ¸ëŠ” ì†¡ìž¥',0),(139016,3862,'he','×¢×“×›×Ÿ ×—×©×‘×•× ×™×ª',0),(139017,3862,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(139018,3862,'zh','æ›´æ–°å‘ç¥¨\r\n',0),(139019,3862,'sv','Uppdatera en faktura',0),(139020,3862,'it','Aggiornare una fattura',0),(139021,3862,'tl','',0),(139022,3862,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(139023,3862,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤à¤• à¤šà¤¾à¤²à¤¾à¤¨',0),(139024,3862,'ms','Kemaskini invois',0),(139025,3862,'ar','ØªØ­Ø¯ÙŠØ« ÙØ§ØªÙˆØ±Ø©',0),(139026,3862,'fr','Mise Ã  jour une facture',0),(139027,3862,'jp','è«‹æ±‚æ›¸ã?®æ›´æ–°',0),(139028,3862,'pt','Atualizar uma factura',0),(139029,3862,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð¡Ñ‡ÐµÑ‚',0),(139030,3862,'es','Actualizar una factura',0),(139031,3862,'de','Update eine Rechnung',0),(139032,3862,'en','Update an Invoice',0),(139033,3863,'is','',0),(139034,3863,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(139035,3863,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(139036,3863,'tr','FaturayÄ± GÃ¼ncelleÅŸtir',0),(139037,3863,'pl','Aktualizacji faktury',0),(139038,3863,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(139039,3863,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(139040,3863,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(139041,3863,'vi','Cáº­p Nháº­t HÃ³a ÄÆ¡n',0),(139042,3863,'af','Opdateer Faktuur',0),(139043,3863,'ro','Actualizare facturÄƒ',0),(139044,3863,'et','Arve uuendama',0),(139045,3863,'si','Posodobitev raÄuna',0),(139046,3863,'ba','Memperbarui faktur',0),(139047,3863,'nl','Update factuur',0),(139048,3863,'fi','PÃ¤ivitÃ¤ laskun',0),(139049,3863,'no','Oppdatere faktura',0),(139050,3863,'da','Opdatere fakturaen',0),(139051,3863,'ko','ì—…ë°ì´íŠ¸ ì†¡ìž¥',0),(139052,3863,'he','×¢×“×›×•×Ÿ ×—×©×‘×•× ×™×ª',0),(139053,3863,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(139054,3863,'zh','æ›´æ–°å‘ç¥¨\r\n',0),(139055,3863,'sv','Uppdatera fakturan',0),(139056,3863,'it','Aggiornamento fattura',0),(139057,3863,'tl','',0),(139058,3863,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(139059,3863,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(139060,3863,'ms','Kemaskini invois',0),(139061,3863,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(139062,3863,'fr','Mise Ã  jour de la facture',0),(139063,3863,'jp','è«‹æ±‚æ›¸ã?®æ›´æ–°',0),(139064,3863,'pt','Factura de atualizaÃ§Ã£o',0),(139065,3863,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚',0),(139066,3863,'es','Actualizar Factura',0),(139067,3863,'de','Rechnung Ã¼berarbeiten',0),(139068,3863,'en','Update Invoice',0),(139069,3864,'is','',0),(139070,3864,'dr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ùˆ Ø­Ù‚ÙˆÙ‚ ',0),(139071,3864,'pr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ùˆ Ø­Ù‚ÙˆÙ‚ ',0),(139072,3864,'tr','KullanÄ±cÄ±lar ve haklar',0),(139073,3864,'pl','UÅ¼ytkownikÃ³w i praw',0),(139074,3864,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸ Ð¸ Ð¿Ñ€Ð°Ð²Ð°',0),(139075,3864,'ur','ØµØ§Ø±ÙÛŒÙ† Ø§ÙˆØ± Ø­Ù‚ÙˆÙ‚',0),(139076,3864,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸Ð¼Ð° Ð¸ Ð¿Ñ€Ð°Ð²Ð¸Ð¼Ð°',0),(139077,3864,'vi','NgÆ°á»i Sá»­ Dá»¥ng & PhÃ¢n Quyá»n',0),(139078,3864,'af','Gebruikers en Aanspraak',0),(139079,3864,'ro','Utilizatori si drepturi',0),(139080,3864,'et','Kasutajad ja Ãµigused',0),(139081,3864,'si','Uporabniki in pravice',0),(139082,3864,'ba','Pengguna dan hak',0),(139083,3864,'nl','Gebruikers en Rechten',0),(139084,3864,'fi','KÃ¤yttÃ¤jien ja oikeuksien',0),(139085,3864,'no','Brukere og rettigheter',0),(139086,3864,'da','Brugere og rettigheder',0),(139087,3864,'ko','ì‚¬ìš©ìž ë° ê¶Œí•œ',0),(139088,3864,'he','×ž×©×ª×ž×©×™× ×•×–×›×•×™×•×ª',0),(139089,3864,'el','Î§ÏÎ®ÏƒÏ„ÎµÏ‚ ÎºÎ±Î¹ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î±',0),(139090,3864,'zh','ç”¨æˆ·å’Œæƒåˆ©\r\n',0),(139091,3864,'sv','AnvÃ¤ndare och rÃ¤ttigheter',0),(139092,3864,'it','Gli utenti e i diritti',0),(139093,3864,'tl','',0),(139094,3864,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(139095,3864,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤”à¤° à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(139096,3864,'ms','Pengguna dan hak-hak',0),(139097,3864,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙˆÙ† Ùˆ Ø§Ù„Ø­Ù‚ÙˆÙ‚',0),(139098,3864,'fr','Utilisateurs et droits',0),(139099,3864,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?¨æ¨©åˆ©',0),(139100,3864,'pt','UsuÃ¡rios e direitos',0),(139101,3864,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸ Ð¸ ÐŸÑ€Ð°Ð²Ð°',0),(139102,3864,'es','Usuarios y Derechos',0),(139103,3864,'de','Benutzer und Rechte',0),(139104,3864,'en','Users and Rights',0),(139105,3865,'is','',0),(139106,3865,'dr','Ù…ØºØ§ÙŠØ±Øª Ø¨ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¨Ø±Ø¢ÙˆØ±Ø¯ÙŠ Ùˆ ÙˆØ§Ù‚Ø¹ÙŠ ',0),(139107,3865,'pr','Ù…ØºØ§ÙŠØ±Øª Ø¨ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¨Ø±Ø¢ÙˆØ±Ø¯ÙŠ Ùˆ ÙˆØ§Ù‚Ø¹ÙŠ ',0),(139108,3865,'tr','ArasÄ±ndaki farkÄ± tahmin ve fiili maliyetleri',0),(139109,3865,'pl','Odchylenie miÄ™dzy szacunkowÄ… i rzeczywiste koszty',0),(139110,3865,'bg','Ð Ð°Ð·Ð»Ð¸ÐºÐ° Ð¼ÐµÐ¶Ð´Ñƒ Ð¾Ñ†ÐµÐ½ÑÐ²Ð° Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(139111,3865,'ur','ØªØºÛŒØ± Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† Ù„Ú¯Ø§ÛŒØ§ Ú¯ÛŒØ§ Ø§ÙˆØ± Ø§Ú©Ø§Ù„Ø³ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(139112,3865,'sr','ÐžÐ´ÑÑ‚ÑƒÐ¿Ð°ÑšÐµ Ð¸Ð·Ð¼ÐµÑ’Ñƒ Ð¿Ñ€Ð¾Ñ†ÐµÑšÑƒÑ˜Ðµ Ð¸ ÑÑ‚Ð²Ð°Ñ€Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(139113,3865,'vi','ChÃªnh lá»‡ch giá»¯a dá»± trÃ¹ vÃ  giÃ¡ thÃ nh thá»±c táº¿',0),(139114,3865,'af','Afwyking tussen Beraamde en Werklike Kostes',0),(139115,3865,'ro','VarianÅ£a estimatÄƒ Ã®ntre ÅŸi costurile reale',0),(139116,3865,'et','Dispersioon vahel hinnangulised ja tegelikud nÃ¤itajad kulud',0),(139117,3865,'si','Med ocenjeno varianco in stroÅ¡ke za opravljeno delo',0),(139118,3865,'ba','Varians antara diperkirakan dengan biaya Actuals',0),(139119,3865,'nl','Variantie tussen geschatte en werkelijke kosten',0),(139120,3865,'fi','Varianssi vÃ¤lillÃ¤ arvioitu ja todelliset kustannukset',0),(139121,3865,'no','Avvik mellom beregnede og faktiske kostnader',0),(139122,3865,'da','Afvigelsen mellem anslÃ¥ede og faktiske omkostninger',0),(139123,3865,'ko','ë¶„ì‚° ì‚¬ì´ ì˜ˆìƒ ë° ì‹¤ì œ ë¹„ìš©',0),(139124,3865,'he','×”×©×•× ×•×ª ×‘×™×Ÿ ××•×ž×“×Ÿ ×•×¢×œ×•×™×•×ª ×‘×¤×•×¢×œ',0),(139125,3865,'el','Î”Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ· Î¼ÎµÏ„Î±Î¾Ï Ï„Î·Ï‚ ÎµÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î·Ï‚ ÎºÎ±Î¹ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(139126,3865,'zh','ä¼°è®¡å’Œå®žé™…æˆæœ¬ä¹‹é—´çš„å·®å¼‚\r\n',0),(139127,3865,'sv','Variansen mellan berÃ¤knade och verkliga kostnader',0),(139128,3865,'it','Varianza stimata tra costi effettivi e',0),(139129,3865,'tl','',0),(139130,3865,'th','&#3588;&#3623;&#3634;&#3617;&#3605;&#3656;&#3634;&#3591;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3649;&#3621;&#3632;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3592;&#3619;&#3636;&#3',0),(139131,3865,'hi','à¤µà¤¿à¤šà¤°à¤£ à¤•à¥‡ à¤¬à¥€à¤š à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤”à¤° à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤²à¤¾à¤—à¤¤',0),(139132,3865,'ms','Perbezaan antara anggaran dan kos Actuals',0),(139133,3865,'ar','Ø§Ù„ÙØ±Ù‚ Ø¨ÙŠÙ† Ø§Ù„Ù…Ù‚Ø¯Ø± ÙˆØ§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„ÙØ¹Ù„ÙŠØ©',0),(139134,3865,'fr','Variance estimÃ©e entre coÃ»ts rÃ©els et',0),(139135,3865,'jp','è¦‹ç©?ã‚Šã?¨å®Ÿè²»ã?®å·®é¡?',0),(139136,3865,'pt','VariÃ¢ncia estimada entre custos reais e',0),(139137,3865,'ru','Ð Ð°Ð·Ð½Ð¸Ñ†Ð° Ð¼ÐµÐ¶Ð´Ñƒ Ð¾Ñ†ÐµÐ½ÐºÐ°Ð¼ Ð¸ Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(139138,3865,'es','Diferencia entre Costos Estimados y Actuales',0),(139139,3865,'de','Varianz zwischen geschÃ¤tzt und aktuelle Werte Kosten',0),(139140,3865,'en','Variance between Estimated and Actuals Costs',0),(139141,3866,'is','',0),(139142,3866,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª',0),(139143,3866,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ Ú¯Ø²Ø§Ø±Ø´Ø§Øª',0),(139144,3866,'tr','SatÄ±cÄ± GiriÅŸ/gÃ¼ncelleme - raporlar',0),(139145,3866,'pl','Zapis dostawcy/aktualizacja - raporty',0),(139146,3866,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ - Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(139147,3866,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§Ù†Ø¯Ø±Ø§Ø¬/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº - Ø±Ù¾ÙˆØ±Ù¹',0),(139148,3866,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÑƒÐ½Ð¾Ñ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ - Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(139149,3866,'vi','Nháº­p/Cáº­p Nháº­t NgÆ°á»i BÃ¡n - BÃ¡o CÃ¡o',0),(139150,3866,'af','Verskaffer Inskrywing/Opdatering - Verslae',0),(139151,3866,'ro','Furnizor de intrare/Update - rapoarte',0),(139152,3866,'et','Hankija kanne/Update - aruanded',0),(139153,3866,'si','Prodajalec vnos/posodobitev - poroÄila',0),(139154,3866,'ba','Penjual Entry/Update - laporan',0),(139155,3866,'nl','Leverancier Entry/Update - verslagen',0),(139156,3866,'fi','Toimittajan merkintÃ¤/PÃ¤ivitÃ¤ - raportit',0),(139157,3866,'no','LeverandÃ¸r oppfÃ¸ring/oppdatere - rapporter',0),(139158,3866,'da','Kreditor post/Update - rapporter',0),(139159,3866,'ko','ê³µê¸‰ ì—…ì²´ í•­ëª©/ì—…ë°ì´íŠ¸-ë³´ê³ ì„œ',0),(139160,3866,'he','×”×¡×¤×§ ×›× ×™×¡×”/×¢×“×›×•×Ÿ - ×“×•×—×•×ª',0),(139161,3866,'el','Î•Î³Î³ÏÎ±Ï†Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· - ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(139162,3866,'zh','ä¾›åº”å•†è¿›å…¥/æ›´æ–°- æŠ¥å‘Š\r\n',0),(139163,3866,'sv','LeverantÃ¶r posten/uppdatera - rapporter',0),(139164,3866,'it','Voce/aggiornamento del fornitore - report',0),(139165,3866,'tl','',0),(139166,3866,'th','&#3648;&#3586;&#3657;&#3634;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(139167,3866,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿/à¤…à¤¦à¥à¤¯à¤¤à¤¨ - à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(139168,3866,'ms','Penjual Entry/Update - Laporan',0),(139169,3866,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(139170,3866,'fr','Fournisseur saisie/mise Ã  jour - rapports',0),(139171,3866,'jp','æ¥­è€…ã?®å…¥åŠ›/æ›´æ–°ãƒ¼ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(139172,3866,'pt','Entrada/atualizaÃ§Ã£o do fornecedor - relatÃ³rios',0),(139173,3866,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ - Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹',0),(139174,3866,'es','Proveedor Introducir/Actualizar - Informes',0),(139175,3866,'de','Anbieter-Eintrag/Update - Berichte',0),(139176,3866,'en','Vendor Entry/Update - Reports',0),(139177,3867,'is','',0),(139178,3867,'dr','/ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(139179,3867,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ / Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(139180,3867,'tr','SatÄ±cÄ± listeler/etiketleri',0),(139181,3867,'pl','Dostawca list/etykiety',0),(139182,3867,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ¿Ð¸ÑÑŠÑ†Ð¸/ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(139183,3867,'ur','ÙˆÛŒÙ†ÚˆØ± ÙÛØ±Ø³ØªÛŒÚº/Ù„ÛŒØ¨Ù„',0),(139184,3867,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð»Ð¸ÑÑ‚Ðµ/Ð¾Ð·Ð½Ð°ÐºÐµ',0),(139185,3867,'vi','Danh sÃ¡ch NgÆ°á»i bÃ¡n/NhÃ£n',0),(139186,3867,'af','Verskaffer Lyste/Ettikette',0),(139187,3867,'ro','Furnizor de liste/Etichete',0),(139188,3867,'et','Hankija nimekirjad/Sildid',0),(139189,3867,'si','Prodajalec seznama/nalepke',0),(139190,3867,'ba','Penjual daftar/label',0),(139191,3867,'nl','Verkoper lijsten/Labels',0),(139192,3867,'fi','Toimittajan luetteloita ja merkinnÃ¤t',0),(139193,3867,'no','LeverandÃ¸ren lister/etiketter',0),(139194,3867,'da','Kreditor lister/etiketter',0),(139195,3867,'ko','ê³µê¸‰ ì—…ì²´ ëª©ë¡/ë ˆì´ë¸”',0),(139196,3867,'he','×ª×•×•×™×•×ª/×¨×©×™×ž×•×ª ×¡×¤×§',0),(139197,3867,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½/Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚',0),(139198,3867,'zh','ä¾›åº”å•†åå•/æ ‡ç­¾\r\n',0),(139199,3867,'sv','LeverantÃ¶r listor/etiketter',0),(139200,3867,'it','Vendor List/etichette',0),(139201,3867,'tl','',0),(139202,3867,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;/&#3611;&#3657;&#3634;&#3618;&#3585;&#3635;&#3585;&#3633;&#3610;',0),(139203,3867,'hi','à¤²à¥‡à¤¬à¤² à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥‚à¤šà¥€ /',0),(139204,3867,'ms','Senarai penjual/label',0),(139205,3867,'ar','Ù‚ÙˆØ§Ø¦Ù…/Ù…Ù„ØµÙ‚Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(139206,3867,'fr','Vendeur de listes/Ã©tiquettes',0),(139207,3867,'jp','æ¥­è€…ã€€ãƒªã‚¹ãƒˆ/ãƒ©ãƒ™ãƒ«',0),(139208,3867,'pt','Listas de fornecedores/rÃ³tulos',0),(139209,3867,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²/ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸',0),(139210,3867,'es','Listas/Etiquetas de Proveedores',0),(139211,3867,'de','Hersteller-Listen/Etiketten',0),(139212,3867,'en','Vendor Lists/Labels',0),(139213,3868,'is','',0),(139214,3868,'dr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù†  ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(139215,3868,'pr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù†  ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(139216,3868,'tr','SatÄ±cÄ± GiriÅŸ kullanÄ±cÄ±lar',0),(139217,3868,'pl','Dostawcy logowania uÅ¼ytkownikÃ³w',0),(139218,3868,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð²Ñ…Ð¾Ð´ Ð·Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(139219,3868,'ur','ÙˆÛŒÙ†ÚˆØ± Ù„Ø§Ú¯ Ø§Ù† ØµØ§Ø±ÙÛŒÙ†',0),(139220,3868,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(139221,3868,'vi','TÃªn ÄÄƒng Nháº­p NgÆ°á»i BÃ¡n B2B',0),(139222,3868,'af','Verskaffer Gebruikers Aantekening',0),(139223,3868,'ro','Utlizatori furnizor cu logare',0),(139224,3868,'et','Hankija Login kasutajad',0),(139225,3868,'si','Prodajalec prijavo uporabnikov',0),(139226,3868,'ba','Penjual Login pengguna',0),(139227,3868,'nl','Leverancier Login gebruikers',0),(139228,3868,'fi','Toimittajan kirjautuminen kÃ¤yttÃ¤jille',0),(139229,3868,'no','LeverandÃ¸ren logikk brukere',0),(139230,3868,'da','LeverandÃ¸r Login brugere',0),(139231,3868,'ko','ê³µê¸‰ ì—…ì²´ ë¡œê·¸ì¸ ì‚¬ìš©ìž',0),(139232,3868,'he','×”×¡×¤×§ ×›× ×™×¡×” ×œ×ž×©×ª×ž×©×™×',0),(139233,3868,'el','ÎŸÎ¹ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ ÎµÎ¯ÏƒÎ¿Î´Î¿Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(139234,3868,'zh','ä¾›åº”å•†ç™»å½•ç”¨æˆ·\r\n',0),(139235,3868,'sv','Inloggning leverantÃ¶rsanvÃ¤ndare',0),(139236,3868,'it','Utenti di accesso fornitore',0),(139237,3868,'tl','',0),(139238,3868,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3648;&#3611;&#3655;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;',0),(139239,3868,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤²à¥‰à¤—à¤¿à¤¨ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(139240,3868,'ms','Penjual Login pengguna',0),(139241,3868,'ar','Ø§Ù„Ù…ÙˆØ±Ø¯ ØªØ³Ø¬ÙŠÙ„ Ø¯Ø®ÙˆÙ„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(139242,3868,'fr','Utilisateurs de connexion fournisseur',0),(139243,3868,'jp','æ¥­è€…ãƒ­ã‚°ã‚¤ãƒ³ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(139244,3868,'pt','UsuÃ¡rios de Login do fornecedor',0),(139245,3868,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð²Ñ…Ð¾Ð´Ð° Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(139246,3868,'es','Proveedor Login Usuarios',0),(139247,3868,'de','HÃ¤ndler Login Benutzer',0),(139248,3868,'en','Vendor Login Users',0),(139249,3869,'is','',0),(139250,3869,'dr','/ Ø¢Ù¾Ø¯ÛŒØª  ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(139251,3869,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(139252,3869,'tr','SatÄ±cÄ± Ekle/GÃ¼ncelle',0),(139253,3869,'pl','Dodawanie dostawcy/aktualizacja',0),(139254,3869,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(139255,3869,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(139256,3869,'sr','/ ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(139257,3869,'vi','ThÃªm/cáº­p nháº­t NgÆ°á»i bÃ¡n',0),(139258,3869,'af','Handelaar byvoeg/opdatering',0),(139259,3869,'ro','Furnizor Adauga/Actualizeaza',0),(139260,3869,'et','Hankija andmete lisamine/uuendamine',0),(139261,3869,'si','Prodajalec Dodaj/posodobi',0),(139262,3869,'ba','Penjual Tambahkan/Perbarui',0),(139263,3869,'nl','Leverancier toevoegen/bijwerken',0),(139264,3869,'fi','Toimittajan lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(139265,3869,'no','LeverandÃ¸r/Oppdater',0),(139266,3869,'da','LeverandÃ¸ren tilfÃ¸jer/opdatering',0),(139267,3869,'ko','ê³µê¸‰ ì—…ì²´ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(139268,3869,'he','×”×•×¡×£/×¢×“×›×Ÿ ×¡×¤×§',0),(139269,3869,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(139270,3869,'zh','ä¾›åº”å•†æ–°å¢ž/æ›´æ–°\r\n',0),(139271,3869,'sv','LeverantÃ¶ren lÃ¤gger till/uppdatera',0),(139272,3869,'it','Aggiungere/aggiornamento del fornitore',0),(139273,3869,'tl','',0),(139274,3869,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3629;&#3633;&#3614;&#3648;&#3604;&#3605;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(139275,3869,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(139276,3869,'ms','Penjual Tambah/Kemaskini',0),(139277,3869,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù…ÙˆØ±Ø¯',0),(139278,3869,'fr','Vendeur ajouter/mettre Ã  jour',0),(139279,3869,'jp','æ¥­è€…ã€€è¿½åŠ /æ›´æ–°',0),(139280,3869,'pt','Adicionar/atualizar do fornecedor',0),(139281,3869,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(139282,3869,'es','Proveedor Agregar/Actualizar',0),(139283,3869,'de','Anbieter hinzufÃ¼gen/aktualisieren',0),(139284,3869,'en','Vendor Add/Update',0),(139285,3870,'is','',0),(139286,3870,'dr','/ Ù„ØºÙˆ Ú†Ùƒ Ù‡Ø§ ',0),(139287,3870,'pr','Ù†Ù…Ø§ÙŠØ´ / Ù„ØºÙˆ Ú†Ùƒ Ù‡Ø§ ',0),(139288,3870,'tr','GÃ¶rÃ¼nÃ¼m/iptal denetimleri',0),(139289,3870,'pl','Widok/Anuluj kontroli',0),(139290,3870,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´/Ð¾Ñ‚ÐºÐ°Ð· Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(139291,3870,'ur','Ù…Ù†Ø¸Ø±/Ù…Ù†Ø³ÙˆØ® Ú†ÛŒÚ©',0),(139292,3870,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· /ÐžÑ‚ÐºÐ°Ð¶Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(139293,3870,'vi','Xem/Há»§y SÃ©c',0),(139294,3870,'af','Besigtig/Kanselleer Tjeks',0),(139295,3870,'ro','Vezi/anuleazÄƒ controale',0),(139296,3870,'et','Vaata/Muuda kontrolli',0),(139297,3870,'si','Pogled/PrekliÄi preverjanje',0),(139298,3870,'ba','Lihat/membatalkan cek',0),(139299,3870,'nl','Bekijken/annuleren controles',0),(139300,3870,'fi','Katso/Peruuta tarkastukset',0),(139301,3870,'no','Vis/Avbestill sjekker',0),(139302,3870,'da','Se/annullere Checks',0),(139303,3870,'ko','ë³´ê¸°/ì·¨ì†Œ í™•ì¸',0),(139304,3870,'he','×”×¦×’/×‘×˜×œ ×¦\'×§×™×',0),(139305,3870,'el','Î ÏÎ¿Î²Î¿Î»Î®/Î±ÎºÏÏÏ‰ÏƒÎ· ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚',0),(139306,3870,'zh','æŸ¥çœ‹/å–æ¶ˆæ”¯ç¥¨\r\n',0),(139307,3870,'sv','Visa/Avbryt kontroller',0),(139308,3870,'it','Visualizza/Cancella controlli',0),(139309,3870,'tl','',0),(139310,3870,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;/&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3594;&#3655;&#3588;',0),(139311,3870,'hi','à¤¦à¥ƒà¤¶à¥à¤¯/à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚ à¤šà¥‡à¤•',0),(139312,3870,'ms','Pemeriksaan paparan/Batal',0),(139313,3870,'ar','Ø¹Ø±Ø¶/Ø¥Ù„ØºØ§Ø¡ Ø§Ù„ØµÙƒÙˆÙƒ',0),(139314,3870,'fr','ContrÃ´les de consulter/annuler',0),(139315,3870,'jp','å°?åˆ‡æ‰‹ã€€è¡¨ç¤º/ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(139316,3870,'pt','Ver/cancelar cheques',0),(139317,3870,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ/Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(139318,3870,'es','Visionar/Cancelar Cheques',0),(139319,3870,'de','Anzeigen/Abbrechen-PrÃ¼fungen',0),(139320,3870,'en','View/Cancel Checks',0),(139321,3871,'is','',0),(139322,3871,'dr','/ Ù„ØºÙˆ Ú†Ùƒ Ù‡Ø§ÙŠ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(139323,3871,'pr','Ù†Ù…Ø§ÙŠØ´ / Ù„ØºÙˆ Ú†Ùƒ Ù‡Ø§ÙŠ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(139324,3871,'tr','GÃ¶rÃ¼nÃ¼m/yazÄ±lÄ± BorÃ§lar Ã§ekleri iptal',0),(139325,3871,'pl','Zobacz/Anuluj czekÃ³w za naleÅ¼noÅ›ci napisane',0),(139326,3871,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´/Ð¾Ñ‚ÐºÐ°Ð· Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¿Ð¸ÑÐ¼ÐµÐ½Ð¾',0),(139327,3871,'ur','Ù…Ù†Ø¸Ø±/Ù„Ú©Ú¾Ø§ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú†ÛŒÚ© Ù…Ù†Ø³ÙˆØ®',0),(139328,3871,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· /ÐžÑ‚ÐºÐ°Ð¶Ð¸ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(139329,3871,'vi','Xem/Há»§y SÃ©c Pháº£i Tráº£ ÄÃ£ Viáº¿t',0),(139330,3871,'af','Besigtig/Kanselleer Betaalbare Tjeks Uitgemaak',0),(139331,3871,'ro','Vezi/anulare datorii controale scris',0),(139332,3871,'et','Vaata/TÃ¼hista vÃµlad kontrolli kirjutada',0),(139333,3871,'si','Pogled/ukinitev obveznosti preverjanja koncu',0),(139334,3871,'ba','Lihat/membatalkan hutang cek ditulis',0),(139335,3871,'nl','Bekijken/annuleren schulden controles geschreven',0),(139336,3871,'fi','Katso/Peruuta velat tarkastuksia kirjoitettu',0),(139337,3871,'no','Vis/Avbestill leverandÃ¸rgjeld sjekker skrevet',0),(139338,3871,'da','Se/Annuller kreditorstyring kontrol skrevet',0),(139339,3871,'ko','ë³´ê¸°/ì·¨ì†Œ ë¯¸ì§€ê¸‰ê¸ˆ ê²€ì‚¬ ìž‘ì„±',0),(139340,3871,'he','×¦×¤×™×™×”/×‘×™×˜×•×œ ×”×¦\'×§×™× ×–×›××™× × ×›×ª×‘',0),(139341,3871,'el','Î ÏÎ¿Î²Î¿Î»Î®/Î±ÎºÏÏÏ‰ÏƒÎ· Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Î³ÏÎ±Ï€Ï„Î®',0),(139342,3871,'zh','æŸ¥çœ‹/å–æ¶ˆåº”ä»˜ä¹¦é¢æ£€æŸ¥\r\n',0),(139343,3871,'sv','Visa/Avbryt LeverantÃ¶rsskulder kontroller skrivna',0),(139344,3871,'it','Visualizza/Cancella i debiti controlli scritti',0),(139345,3871,'tl','',0),(139346,3871,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;/&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(139347,3871,'hi','à¤¦à¥ƒà¤¶à¥à¤¯/à¤²à¤¿à¤–à¤¾ Payables à¤šà¥‡à¤• à¤°à¤¦à¥à¤¦',0),(139348,3871,'ms','Pandangan/membatalkan pembayaran cek ditulis',0),(139349,3871,'ar','Ø¹Ø±Ø¶/Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© ÙƒØªØ¨',0),(139350,3871,'fr','Consulter/annuler des comptes fournisseurs de chÃ¨ques Ã©mis',0),(139351,3871,'jp','æ›¸ã??è¾¼ã?¿æ¸ˆæ”¯æ‰•å°?åˆ‡æ‰‹ã?®è¡¨ç¤º/ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(139352,3871,'pt','Ver/cancelar pagamentos cheques escritos',0),(139353,3871,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ð¾Ñ‚Ð¼ÐµÐ½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ñ‡ÐµÐºÐ¾Ð²',0),(139354,3871,'es','Ver/Cancelar Cheques de Proveedores Elaborados',0),(139355,3871,'de','Ansicht/Cancel Verbindlichkeiten PrÃ¼fungen geschrieben',0),(139356,3871,'en','View/Cancel Payables Checks Written',0),(139357,3872,'is','',0),(139358,3872,'dr','/ ØªØºÙŠÙŠØ±  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§',0),(139359,3872,'pr','Ù†Ù…Ø§ÙŠØ´ / ØªØºÙŠÙŠØ±  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§',0),(139360,3872,'tr','FaturalarÄ± gÃ¶rÃ¼ntÃ¼leme/deÄŸiÅŸtirme',0),(139361,3872,'pl','Zmiana widoku/rachunki',0),(139362,3872,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´/Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(139363,3872,'ur','Ù…Ù†Ø¸Ø±/Ø¨Ù„ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(139364,3872,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· /Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(139365,3872,'vi','Xem/Thay Äá»•i HÃ³a ÄÆ¡n',0),(139366,3872,'af','Besigtig/Verander Rekeninge',0),(139367,3872,'ro','Vezi/schimbare facturile',0),(139368,3872,'et','Vaata/Muuda arved',0),(139369,3872,'si','Pogled/sprememba menice',0),(139370,3872,'ba','Lihat/Ubah tagihan',0),(139371,3872,'nl','Bekijken/wijzigen rekeningen',0),(139372,3872,'fi','Tarkasteleminen ja muuttaminen laskut',0),(139373,3872,'no','Vise/endre regninger',0),(139374,3872,'da','Se/Ã¦ndre regninger',0),(139375,3872,'ko','ë³´ê¸°/ë³€ê²½ ì²­êµ¬ì„œ',0),(139376,3872,'he','×”×¦×’×”/×©×™× ×•×™ ×©×œ ×”×—×©×‘×•× ×•×ª',0),(139377,3872,'el','Î ÏÎ¿Î²Î¿Î»Î®/Î±Î»Î»Î±Î³Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(139378,3872,'zh','æŸ¥çœ‹/æ›´æ”¹æ¡ä¾‹è‰æ¡ˆ\r\n',0),(139379,3872,'sv','Visa/Ã¤ndra rÃ¤kningar',0),(139380,3872,'it','Visualizzazione/modifica fatture',0),(139381,3872,'tl','',0),(139382,3872,'th','&#3649;&#3626;&#3604;&#3591;/&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(139383,3872,'hi','à¤¦à¥ƒà¤¶à¥à¤¯/à¤¬à¤¿à¤² à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(139384,3872,'ms','Pemandangan/perubahan bil-bil',0),(139385,3872,'ar','Ø¹Ø±Ø¶/ØªØºÙŠÙŠØ± ÙÙˆØ§ØªÙŠØ±',0),(139386,3872,'fr','Voir/changer factures',0),(139387,3872,'jp','è«‹æ±‚æ›¸ã?®è¡¨ç¤º/ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(139388,3872,'pt','Exibir/alterar contas',0),(139389,3872,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(139390,3872,'es','Visionar/Cambiar Recibos',0),(139391,3872,'de','Ã„ndern Sie anzeigen/Rechnungen',0),(139392,3872,'en','View/Change Bills',0),(139393,3873,'is','',0),(139394,3873,'dr','/ ØªØºÙŠÙŠØ± ÙØ±Ù…Ø§ÛŒØ´ ',0),(139395,3873,'pr','Ù†Ù…Ø§ÙŠØ´ / ØªØºÙŠÙŠØ± Ø³ÙØ§Ø±Ø´ ',0),(139396,3873,'tr','GÃ¶rÃ¼nÃ¼m/sipariÅŸi DeÄŸiÅŸtir',0),(139397,3873,'pl','Zmiana kolejnoÅ›ci widoku',0),(139398,3873,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´/Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(139399,3873,'ur','Ù…Ù†Ø¸Ø±/ØªØ±ØªÛŒØ¨ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(139400,3873,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· /ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´',0),(139401,3873,'vi','Xem/Thay Ä‘á»•i Ä‘Æ¡n hÃ ng',0),(139402,3873,'af','Besigtig/Verander Bestelling',0),(139403,3873,'ro','Vezi/schimba ordinea',0),(139404,3873,'et','Vaata/Muuda jÃ¤rjekorras',0),(139405,3873,'si','Pogled/spremeni vrstni red',0),(139406,3873,'ba','Lihat/Ubah urutan',0),(139407,3873,'nl','Bekijken/wijzigen volgorde',0),(139408,3873,'fi','Tarkasteleminen ja muuttaminen jÃ¤rjestyksessÃ¤',0),(139409,3873,'no','Vise/endre rekkefÃ¸lgen',0),(139410,3873,'da','Se/Ã¦ndre rÃ¦kkefÃ¸lge',0),(139411,3873,'ko','ë³´ê¸°/ë³€ê²½ ìˆœì„œ',0),(139412,3873,'he','×”×¦×’×”/×©×™× ×•×™ ×©×œ ×¡×“×¨',0),(139413,3873,'el','Î ÏÎ¿Î²Î¿Î»Î®/Î±Î»Î»Î±Î³Î® ÏƒÎµÎ¹ÏÎ¬Ï‚',0),(139414,3873,'zh','æŸ¥çœ‹/ä¿®æ”¹è®¢å•\r\n',0),(139415,3873,'sv','Visa/Ã¤ndra ordning',0),(139416,3873,'it','Visualizzazione/Modifica ordine',0),(139417,3873,'tl','',0),(139418,3873,'th','&#3649;&#3626;&#3604;&#3591;/&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(139419,3873,'hi','à¤¦à¥ƒà¤¶à¥à¤¯/à¤•à¥à¤°à¤® à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(139420,3873,'ms','Pemandangan/mengubah perintah',0),(139421,3873,'ar','Ø¹Ø±Ø¶/ØªØºÙŠÙŠØ± Ø§Ù„Ù†Ø¸Ø§Ù…',0),(139422,3873,'fr','Voir/changer ordre',0),(139423,3873,'jp','æ³¨æ–‡ã?®è¡¨ç¤º/ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(139424,3873,'pt','Exibir/alterar ordem',0),(139425,3873,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ð°',0),(139426,3873,'es','Visionar/Cambiar Orden',0),(139427,3873,'de','Ã„ndern Sie anzeigen/bestellen',0),(139428,3873,'en','View/Change Order',0),(139429,3874,'is','',0),(139430,3874,'dr','/ ØªØºÙŠÙŠØ± ÙØ±Ù…Ø§ÛŒØ´Ø§Øª ',0),(139431,3874,'pr','Ù†Ù…Ø§ÙŠØ´ / ØªØºÙŠÙŠØ± Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(139432,3874,'tr','GÃ¶rÃ¼nÃ¼m/sÄ±ra deÄŸiÅŸtirme iÅŸlemi sayÄ±sÄ±',0),(139433,3874,'pl','Zmiana widoku/zamÃ³wienia',0),(139434,3874,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´/Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(139435,3874,'ur','Ù…Ù†Ø¸Ø±/ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(139436,3874,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· /Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(139437,3874,'vi','Xem/Thay Ä‘á»•i Ä‘Æ¡n hÃ ng',0),(139438,3874,'af','Besigtig/Verander Bestellings',0),(139439,3874,'ro','Vezi/schimba comenzile',0),(139440,3874,'et','Vaata/Muuda tellimusi',0),(139441,3874,'si','Pogled/spremembe naroÄila',0),(139442,3874,'ba','Lihat perubahan pesanan',0),(139443,3874,'nl','Orders bekijken/wijzigen',0),(139444,3874,'fi','Tarkasteleminen ja muuttaminen tilaukset',0),(139445,3874,'no','Vise/endre bestillinger',0),(139446,3874,'da','Se/Ã¦ndre ordrer',0),(139447,3874,'ko','ì£¼ë¬¸ ë³´ê¸°/ë³€ê²½',0),(139448,3874,'he','×”×¦×’×”/×©×™× ×•×™ ×©×œ ×”×•×¨××•×ª',0),(139449,3874,'el','Î ÏÎ¿Î²Î¿Î»Î®/Î±Î»Î»Î±Î³Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(139450,3874,'zh','æŸ¥çœ‹/æ›´æ”¹è®¢å•\r\n',0),(139451,3874,'sv','Visa/Ã¤ndra order',0),(139452,3874,'it','Visualizzazione/modifica ordini',0),(139453,3874,'tl','',0),(139454,3874,'th','&#3649;&#3626;&#3604;&#3591;/&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(139455,3874,'hi','à¤¦à¥ƒà¤¶à¥à¤¯/à¤¬à¤¦à¤²à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(139456,3874,'ms','Pemandangan/mengubah perintah',0),(139457,3874,'ar','Ø¹Ø±Ø¶/ØªØºÙŠÙŠØ± Ø£ÙˆØ§Ù…Ø±',0),(139458,3874,'fr','Afficher/modifier les commandes',0),(139459,3874,'jp','æ³¨æ–‡ã?®è¡¨ç¤º/ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(139460,3874,'pt','Exibir/alterar ordens',0),(139461,3874,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(139462,3874,'es','Visionar/Cambiar Ordenes',0),(139463,3874,'de','Bestellungen anzeigen/Ã¤ndern',0),(139464,3874,'en','View/Change Orders',0),(139465,3875,'is','',0),(139466,3875,'dr','Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(139467,3875,'pr','Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(139468,3875,'tr','GÃ¶rÃ¼nÃ¼m mÃ¼ÅŸteri hesabÄ±',0),(139469,3875,'pl','Widok konta klienta',0),(139470,3875,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(139471,3875,'ur','Ù…Ù†Ø¸Ø± Ú©Ø³Ù¹Ù…Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(139472,3875,'sr','Ð Ð°Ñ‡ÑƒÐ½ ÐºÑƒÐ¿Ñ†Ð° Ñƒ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ñƒ',0),(139473,3875,'vi','Xem TK KhÃ¡ch HÃ ng',0),(139474,3875,'af','Besigtig Klant/KliÃ«nt Rekening',0),(139475,3875,'ro','Contul de client Vezi',0),(139476,3875,'et','Vaata kliendi kontot',0),(139477,3875,'si','RaÄun kupca pogled',0),(139478,3875,'ba','Lihat rekening',0),(139479,3875,'nl','De Account van de klant van de weergave',0),(139480,3875,'fi','NÃ¤ytÃ¤ asiakastili',0),(139481,3875,'no','Vis kundekontoen',0),(139482,3875,'da','Se kundekonto',0),(139483,3875,'ko','ë³´ê¸° ê³ ê° ê³„ì •',0),(139484,3875,'he','×”×¦×’ ×—×©×‘×•×Ÿ ×œ×§×•×—',0),(139485,3875,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€ÎµÎ»Î¬Ï„Î·',0),(139486,3875,'zh','æŸ¥çœ‹ç”¨æˆ·çš„å¸æˆ·\r\n',0),(139487,3875,'sv','Visa kundkontot',0),(139488,3875,'it','Visualizzazione conto cliente',0),(139489,3875,'tl','',0),(139490,3875,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(139491,3875,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤—à¥à¤°à¤¾à¤¹à¤• à¤–à¤¾à¤¤à¤¾',0),(139492,3875,'ms','Akaun pelanggan View',0),(139493,3875,'ar','Ø¹Ø±Ø¶ Ø­Ø³Ø§Ø¨ Ø²Ø¨ÙˆÙ†',0),(139494,3875,'fr','Afficher le compte client',0),(139495,3875,'jp','é¡§å®¢ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¡¨ç¤º',0),(139496,3875,'pt','Conta de cliente de vista',0),(139497,3875,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐŸÑ€Ð¾Ñ„Ð¸Ð»Ñ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(139498,3875,'es','Ver Cuenta de Cliente',0),(139499,3875,'de','Kunden-Konto anzeigen',0),(139500,3875,'en','View Customer Account',0),(139501,3876,'is','',0),(139502,3876,'dr','Ù†Ù…Ø§ÙŠØ´ ÙˆØ¶Ø¹ÙŠØª Ø­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(139503,3876,'pr','Ù†Ù…Ø§ÙŠØ´ ÙˆØ¶Ø¹ÙŠØª Ø­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(139504,3876,'tr','MÃ¼ÅŸteri hesap durumunu gÃ¶rÃ¼ntÃ¼le',0),(139505,3876,'pl','WyÅ›wietlanie stanu konta klienta',0),(139506,3876,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð·Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(139507,3876,'ur','Ú©Ø³Ù¹Ù…Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø­Ø§Ù„Øª Ú©Ø§ Ù…Ù†Ø¸Ø± Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(139508,3876,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ñ€Ð°Ñ‡ÑƒÐ½Ð° ÐºÑƒÐ¿Ñ†Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·',0),(139509,3876,'vi','Xem TÃ¬nh Tráº¡ng TK KhÃ¡ch HÃ ng',0),(139510,3876,'af','Besigtig Klant/KliÃ«nt Rekeningstatus',0),(139511,3876,'ro','Vezi starea contului de client',0),(139512,3876,'et','Vaata kliendi konto staatust',0),(139513,3876,'si','Ogled stanja raÄun kupca',0),(139514,3876,'ba','Lihat Status Account pelanggan',0),(139515,3876,'nl','De Status van de Account van de klant van weergeven',0),(139516,3876,'fi','NÃ¤ytÃ¤ asiakkaan tilin tila',0),(139517,3876,'no','Vis kunde kontostatus',0),(139518,3876,'da','Se kunde kontostatus',0),(139519,3876,'ko','ê³ ê° ê³„ì • ìƒíƒœ ë³´ê¸°',0),(139520,3876,'he','×”×¦×’ ×ž×¦×‘ ×—×©×‘×•×Ÿ ×”×œ×§×•×—',0),(139521,3876,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€ÎµÎ»Î¬Ï„Î·',0),(139522,3876,'zh','æŸ¥çœ‹ç”¨æˆ·çš„å¸æˆ·çŠ¶æ€\r\n',0),(139523,3876,'sv','Visa kund kontostatus',0),(139524,3876,'it','Mostra lo stato dell\'Account cliente',0),(139525,3876,'tl','',0),(139526,3876,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(139527,3876,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(139528,3876,'ms','Paparan Status akaun pelanggan',0),(139529,3876,'ar','Ø¹Ø±Ø¶ Ø­Ø§Ù„Ø© Ø­Ø³Ø§Ø¨ Ø²Ø¨ÙˆÙ†',0),(139530,3876,'fr','Afficher l\'Ã©tat de compte client',0),(139531,3876,'jp','é¡§å®¢å?£åº§çŠ¶æ³?ã?®è¡¨ç¤º',0),(139532,3876,'pt','Ver Status da conta do cliente',0),(139533,3876,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¡Ñ‚Ð°Ñ‚ÑƒÑÐ° ÐŸÑ€Ð¾Ñ„Ð¸Ð»Ñ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(139534,3876,'es','Ver Status de Cuenta de Cliente',0),(139535,3876,'de','Kunden-Account-Anzeigestatus',0),(139536,3876,'en','View Customer Account Status',0),(139537,3877,'is','',0),(139538,3877,'dr','Ù†Ù…Ø§ÙŠØ´ ÙŠØ§ ØªØºÙŠÙŠØ± Ù†ÙˆØ§Ø­ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(139539,3877,'pr','Ù†Ù…Ø§ÙŠØ´ ÙŠØ§ ØªØºÙŠÙŠØ± Ù†ÙˆØ§Ø­ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(139540,3877,'tr','GÃ¶rÃ¼ntÃ¼le veya DeÄŸiÅŸtir bordro vergi bÃ¶lgeleri',0),(139541,3877,'pl','Widok lub zmiany pÅ‚ac podatku dzielnic',0),(139542,3877,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð¢Ð Ð— Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(139543,3877,'ur','Ù…Ù†Ø¸Ø± ÛŒØ§ ØªØ¨Ø¯ÛŒÙ„ Ù¾Û’ Ø±ÙˆÙ„ Ù¹ÛŒÚ©Ø³ Ø§Ø¶Ù„Ø§Ø¹',0),(139544,3877,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¸Ð»Ð¸ ÑƒÐ±Ð¸Ñ€Ð°Ñ‚Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(139545,3877,'vi','Xem hay thay Ä‘á»•i Quáº­n Ä‘Ã³ng thuáº¿ lÆ°Æ¡ng',0),(139546,3877,'af','Besigtig of Verander Loonrol Belasting Distrikte',0),(139547,3877,'ro','Vizualizare sau modificare salarizare fiscalÄƒ districte',0),(139548,3877,'et','Kuva vÃµi Muuda palgafondi maksu linnaosades',0),(139549,3877,'si','Ogled ali sprememba na izplaÄane plaÄe davek okoliÅ¡ev',0),(139550,3877,'ba','Lihat atau perubahan penggajian pajak daerah',0),(139551,3877,'nl','Weergave of verandering Payroll belastingen districten',0),(139552,3877,'fi','NÃ¤ytÃ¤ tai muuta palkanlaskennan vero piirit',0),(139553,3877,'no','Vis eller endre lÃ¸nn skatt distrikter',0),(139554,3877,'da','Se eller Ã¦ndre lÃ¸nningslisten skat distrikter',0),(139555,3877,'ko','ë³´ê¸° ë˜ëŠ” ë³€ê²½ ê¸‰ì—¬ ì„¸ê¸ˆ ì§€êµ¬',0),(139556,3877,'he','×ª×¦×•×’×” ××• ×©×™× ×•×™ ×ž×—×•×–×•×ª ×ž×¡ ×©×›×¨',0),(139557,3877,'el','Î ÏÎ¿Î²Î¿Î»Î® Î® Î±Î»Î»Î±Î³Î® Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ­Ï‚ Ï€ÎµÏÎ¹Ï†Î­ÏÎµÎ¹ÎµÏ‚',0),(139558,3877,'zh','æŸ¥çœ‹æˆ–æ›´æ”¹å·¥èµ„ç¨ŽåŒº\r\n',0),(139559,3877,'sv','Visa eller Ã¤ndra LÃ¶nelista skatt distrikt',0),(139560,3877,'it','Visualizzazione o modifica Payroll Tax distretti',0),(139561,3877,'tl','',0),(139562,3877,'th','&#3604;&#3641;&#3627;&#3619;&#3639;&#3629;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3648;&#3586;&#3605;&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(139563,3877,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤¯à¤¾ à¤¬à¤¦à¤²à¥‡à¤‚ à¤ªà¥‡à¤°à¥‹à¤² à¤Ÿà¥ˆà¤•à¥à¤¸ à¤œà¤¿à¤²à¥‹à¤‚',0),(139564,3877,'ms','Lihat atau tukar gaji cukai Daerah',0),(139565,3877,'ar','Ø¹Ø±Ø¶ Ø£Ùˆ ØªØºÙŠÙŠØ± Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø¶Ø±ÙŠØ¨Ø© Ù…Ù‚Ø§Ø·Ø¹Ø§Øª',0),(139566,3877,'fr','Affichage ou modification paie impÃ´t Districts',0),(139567,3877,'jp','çµ¦ä¸Žç¨ŽåŒºåˆ†ã?®è¡¨ç¤ºã‚‚ã?—ã??ã?¯å¤‰æ›´',0),(139568,3877,'pt','Vista ou mudanÃ§a da folha de pagamento imposto distritos',0),(139569,3877,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¸Ð»Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ñ… Ð¾ÐºÑ€ÑƒÐ³Ð¾Ð²',0),(139570,3877,'es','Ver o Cambiar Distritos de Impuestos de NÃ³mina',0),(139571,3877,'de','Anzeigen oder Ã¤ndern Payroll Tax Bezirke',0),(139572,3877,'en','View or Change Payroll Tax Districts',0),(139573,3878,'is','',0),(139574,3878,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(139575,3878,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(139576,3878,'tr','GÃ¶rÃ¼nÃ¼m sevk edilen sipariÅŸler',0),(139577,3878,'pl','Widok wysÅ‚ane zamÃ³wienia',0),(139578,3878,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(139579,3878,'ur','Ù…Ù†Ø¸Ø± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(139580,3878,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð»Ð¸ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(139581,3878,'vi','Xem Ä‘Æ¡n hÃ ng Ä‘Ã£ chuyá»ƒn',0),(139582,3878,'af','Besigtig Bestelling Versend',0),(139583,3878,'ro','Vezi livrat ordinele',0),(139584,3878,'et','Vaata tarnitud tellimusi',0),(139585,3878,'si','Pogled dobavljeni naroÄila',0),(139586,3878,'ba','Lihat dikirim pesanan',0),(139587,3878,'nl','Weergave verzonden Orders',0),(139588,3878,'fi','Katso lÃ¤hettÃ¤neet tilauksia',0),(139589,3878,'no','Vis direkteleveringsordrer',0),(139590,3878,'da','Se afsendt ordrer',0),(139591,3878,'ko','ë³´ê¸° ì£¼ë¬¸ ë°°ì†¡',0),(139592,3878,'he','×”×¦×’ ×”×–×ž× ×•×ª ×©× ×©×œ×—×•',0),(139593,3878,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(139594,3878,'zh','æŸ¥çœ‹è®¢å•å‡ºè´§\r\n',0),(139595,3878,'sv','Visa levereras order',0),(139596,3878,'it','Vista spediti ordini',0),(139597,3878,'tl','',0),(139598,3878,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(139599,3878,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(139600,3878,'ms','Paparan dihantar pesanan',0),(139601,3878,'ar','Ø¹Ø±Ø¶ Ø£ÙˆØ§Ù…Ø± ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(139602,3878,'fr','Avis expÃ©diÃ© arrÃªtÃ©s',0),(139603,3878,'jp','ç™ºé€?æ¸ˆæ³¨æ–‡ã?®è¡¨ç¤º',0),(139604,3878,'pt','Vista enviadas ordens',0),(139605,3878,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(139606,3878,'es','Ver Ordenes Enviados',0),(139607,3878,'de','Ansicht gelieferte Bestellungen',0),(139608,3878,'en','View Shipped Orders',0),(139609,3879,'is','',0),(139610,3879,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(139611,3879,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(139612,3879,'tr','Sevk edilen sipariÅŸler',0),(139613,3879,'pl','ZamÃ³wienia wysyÅ‚ane',0),(139614,3879,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(139615,3879,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(139616,3879,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(139617,3879,'vi','Xem Ä‘Æ¡n hÃ ng Ä‘Ã£ chuyá»ƒn',0),(139618,3879,'af','Besigtig Versende Bestellings',0),(139619,3879,'ro','Comenzile expediate',0),(139620,3879,'et','Vaata tarnitud tellimusi',0),(139621,3879,'si','Ob dobavi naroÄila',0),(139622,3879,'ba','Pesanan dikirim',0),(139623,3879,'nl','Verzonden bestellingen',0),(139624,3879,'fi','LÃ¤hetetyt tilaukset',0),(139625,3879,'no','Sendte bestillinger',0),(139626,3879,'da','Afsendt ordrer',0),(139627,3879,'ko','ë°°ì†¡ëœ ì£¼ë¬¸',0),(139628,3879,'he','×”×¦×’ ×”×–×ž× ×•×ª ×©× ×©×œ×—×•',0),(139629,3879,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(139630,3879,'zh','æŸ¥çœ‹å‘è´§çš„è®¢å•\r\n',0),(139631,3879,'sv','Levererade order',0),(139632,3879,'it','Ordini spediti',0),(139633,3879,'tl','',0),(139634,3879,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3605;&#3634;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(139635,3879,'hi','à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶',0),(139636,3879,'ms','Pesanan yang dihantar',0),(139637,3879,'ar','Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(139638,3879,'fr','Commandes expÃ©diÃ©es',0),(139639,3879,'jp','ç™ºé€?æ¸ˆã?¿æ³¨æ–‡ã‚’è¡¨ç¤º',0),(139640,3879,'pt','Pedidos enviados',0),(139641,3879,'ru','Ð¡Ð¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(139642,3879,'es','Ver Ordenes Enviados',0),(139643,3879,'de','Gelieferte Bestellungen',0),(139644,3879,'en','Shipped Orders',0),(139645,3880,'is','',0),(139646,3880,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(139647,3880,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(139648,3880,'tr','Vergi tÃ¼rÃ¼ gÃ¼ncelleÅŸtirme',0),(139649,3880,'pl','Podatek typu Update',0),(139650,3880,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ñ‚Ð¸Ð¿ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(139651,3880,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(139652,3880,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð²Ñ€ÑÑ‚Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(139653,3880,'vi','Cáº­p Nháº­t Loáº¡i Thuáº¿',0),(139654,3880,'af','Belastingtipe Opdateer',0),(139655,3880,'ro','Actualizare de tip fiscal',0),(139656,3880,'et','Makse uuendus',0),(139657,3880,'si','Vrsta davÄne Update',0),(139658,3880,'ba','Pajak jenis Update',0),(139659,3880,'nl','Fiscale Type Update',0),(139660,3880,'fi','Vero-tyypin pÃ¤ivitys',0),(139661,3880,'no','Skatt Type Update',0),(139662,3880,'da','Skat Type opdatering',0),(139663,3880,'ko','ì„¸ê¸ˆ ìœ í˜• ì—…ë°ì´íŠ¸',0),(139664,3880,'he','×¢×“×›×Ÿ ×¡×•×’ ×ž×¡',0),(139665,3880,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Ï…',0),(139666,3880,'zh','ç¨Žé¡¹ç§ç±»æ›´æ–°\r\n',0),(139667,3880,'sv','Skatt typ uppdatering',0),(139668,3880,'it','Aggiornamento di tipo fiscale',0),(139669,3880,'tl','',0),(139670,3880,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;',0),(139671,3880,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(139672,3880,'ms','Kemaskini jenis cukai',0),(139673,3880,'ar','ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(139674,3880,'fr','Mise Ã  jour du Type de taxe',0),(139675,3880,'jp','ç¨Žã?®ç¨®é¡žã‚’æ›´æ–°',0),(139676,3880,'pt','ActualizaÃ§Ã£o do tipo de imposto',0),(139677,3880,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿ ÐÐ°Ð»Ð¾Ð³Ð°',0),(139678,3880,'es','Actualizar Tipo de Impuesto',0),(139679,3880,'de','Steuer-Typ-Update',0),(139680,3880,'en','Tax Type Update',0),(139681,3881,'is','',0),(139682,3881,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ ',0),(139683,3881,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ ',0),(139684,3881,'tr','SipariÅŸ birimi raporlarÄ±',0),(139685,3881,'pl','Raporty wielkoÅ›ci zamÃ³wienia',0),(139686,3881,'bg','Ð ÐµÐ´ Ñ‚Ð¾Ð¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(139687,3881,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ø­Ø¬Ù… Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(139688,3881,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(139689,3881,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng',0),(139690,3881,'af','Bestel Volume Verslag',0),(139691,3881,'ro','Rapoarte de volumul comenzii',0),(139692,3881,'et','Order Volume Reports',0),(139693,3881,'si','Naloga obsega poroÄila',0),(139694,3881,'ba','Urutan Volume laporan',0),(139695,3881,'nl','Volume Opdrachtrapporten',0),(139696,3881,'fi','MÃ¤Ã¤rÃ¤n raportteja',0),(139697,3881,'no','RekkefÃ¸lgen volum rapporter',0),(139698,3881,'da','Ordre volumen rapporter',0),(139699,3881,'ko','ì£¼ë¬¸ ë³¼ë¥¨ ë³´ê³ ì„œ',0),(139700,3881,'he','×”×–×ž× ×ª ××—×¡×•×Ÿ ×“×•×—×•×ª',0),(139701,3881,'el','Î•ÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ ÏŒÎ³ÎºÎ¿Ï… Î³Î¹Î±',0),(139702,3881,'zh','è®¢å•é‡æŠ¥å‘Š\r\n',0),(139703,3881,'sv','Ordning volym rapporter',0),(139704,3881,'it','Rapporti di Volume di ordine',0),(139705,3881,'tl','',0),(139706,3881,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(139707,3881,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥‡à¤‚',0),(139708,3881,'ms','Laporan jumlah perintah',0),(139709,3881,'ar','ØªÙ‚Ø§Ø±ÙŠØ± ÙˆØ­Ø¯Ø© ØªØ®Ø²ÙŠÙ† Ø§Ù„Ù†Ø¸Ø§Ù…',0),(139710,3881,'fr','Rapports de Volume de commande',0),(139711,3881,'jp','æ³¨æ–‡é«˜ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(139712,3881,'pt','RelatÃ³rios de Volume de pedidos',0),(139713,3881,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¾Ð±ÑŠÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¾Ð²',0),(139714,3881,'es','Informes de VolÃºmen de Ordenes',0),(139715,3881,'de','Band Berichte anfordern',0),(139716,3881,'en','Order Volume Reports',0),(139717,3882,'is','',0),(139718,3882,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… ',0),(139719,3882,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… ',0),(139720,3882,'tr','Birimi raporu',0),(139721,3882,'pl','WielkoÅ›Ä‡ raportu',0),(139722,3882,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼',0),(139723,3882,'ur','ØµÙˆØª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(139724,3882,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(139725,3882,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng',0),(139726,3882,'af','Volume Verslag',0),(139727,3882,'ro','Raport de volum',0),(139728,3882,'et','Volume Report',0),(139729,3882,'si','PoroÄilo obsega',0),(139730,3882,'ba','Volume laporan',0),(139731,3882,'nl','Volume verslag',0),(139732,3882,'fi','MÃ¤Ã¤rÃ¤-raportin',0),(139733,3882,'no','Volum',0),(139734,3882,'da','Volumen rapport',0),(139735,3882,'ko','ë³¼ë¥¨ ë³´ê³ ì„œ',0),(139736,3882,'he','×›×¨×š ×—',0),(139737,3882,'el','ÎŸ ÏŒÎ³ÎºÎ¿Ï‚ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ·',0),(139738,3882,'zh','é‡çš„æŠ¥å‘Š\r\n',0),(139739,3882,'sv','Rapporten volym',0),(139740,3882,'it','Volume relazione',0),(139741,3882,'tl','',0),(139742,3882,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(139743,3882,'hi','à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(139744,3882,'ms','Laporan jumlah',0),(139745,3882,'ar','Ø­Ø¬Ù… Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(139746,3882,'fr','Rapport de volume',0),(139747,3882,'jp','å®¹é‡?ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(139748,3882,'pt','RelatÃ³rio de volume',0),(139749,3882,'ru','ÐžÐ±ÑŠÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð°',0),(139750,3882,'es','Informe de VolÃºmen',0),(139751,3882,'de','Volume-Bericht',0),(139752,3882,'en','Volume Report',0),(139753,3883,'is','',0),(139754,3883,'dr','Ú©Ø§Ù„Ø§Ù‡Ø§Ù‰ Ø¯Ø± Ø­Ø§Ù„ Ø³Ø§Ø®Øª',0),(139755,3883,'pr','Ú©Ø§Ù„Ø§Ù‡Ø§Ù‰ Ø¯Ø± Ø­Ø§Ù„ Ø³Ø§Ø®Øª',0),(139756,3883,'tr','SÃ¼ren iÅŸ',0),(139757,3883,'pl','Praca w toku',0),(139758,3883,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð² Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(139759,3883,'ur','Ø§Ø³ Ø¹Ù…Ù„ Ù…ÛŒÚº Ú©Ø§Ù…',0),(139760,3883,'sr','Ð Ð°Ð´ Ñƒ Ñ‚Ð¾ÐºÑƒ',0),(139761,3883,'vi','CÃ´ng viá»‡c Ä‘ang lÃ m',0),(139762,3883,'af','Werk in Proses',0),(139763,3883,'ro','WIP',0),(139764,3883,'et','TÃ¶Ã¶tÃ¶lemises',0),(139765,3883,'si','Delo v procesu',0),(139766,3883,'ba','Bekerja dalam proses',0),(139767,3883,'nl','Werken In proces',0),(139768,3883,'fi','KeskenerÃ¤iset tyÃ¶t',0),(139769,3883,'no','Varer i arbeid',0),(139770,3883,'da','Arbejde i processen',0),(139771,3883,'ko','ê³¼ì •ì—ì„œ ì¼',0),(139772,3883,'he','×‘×¢×‘×•×“×” ×‘×ª×”×œ×™×š',0),(139773,3883,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÏƒÎµ ÎµÎ¾Î­Î»Î¹Î¾Î·',0),(139774,3883,'zh','å·¥ä½œæµç¨‹\r\n',0),(139775,3883,'sv','Produkter i arbete',0),(139776,3883,'it','Lavori In corso',0),(139777,3883,'tl','',0),(139778,3883,'th','&#3585;&#3634;&#3619;&#3607;&#3635;&#3591;&#3634;&#3609;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;',0),(139779,3883,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤®à¥‡à¤‚ à¤•à¤¾à¤®',0),(139780,3883,'ms','Kerja dalam proses',0),(139781,3883,'ar','Ø§Ù„Ø¹Ù…Ù„ ÙÙŠ Ø¹Ù…Ù„ÙŠØ©',0),(139782,3883,'fr','Travaux en cours',0),(139783,3883,'jp','å‡¦ç?†ä¸­ã?®ä½œæ¥­',0),(139784,3883,'pt','Trabalho em processo',0),(139785,3883,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð² Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐµ',0),(139786,3883,'es','Trabajo en Proceso',0),(139787,3883,'de','Unfertige Erzeugnisse',0),(139788,3883,'en','Work In Process',0),(139789,3884,'is','',0),(139790,3884,'dr','- Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…ØªØ¹Ù„Ù‚Ù‡ Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Ø§ÛŒØ´ÙŠ ÙƒÙ‡ Ù‡Ù†ÙˆØ² Ø¯Ø§Ø®Ù„ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡ Ø§Ø³Øª ',0),(139791,3884,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ú©Ø§Ù„Ø§Ù‡Ø§Ù‰ Ø¯Ø± Ø­Ø§Ù„ Ø³Ø§Ø®Øª- Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…ØªØ¹Ù„Ù‚Ù‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ÙŠ ÙƒÙ‡ Ù‡Ù†ÙˆØ² Ø¯Ø§Ø®Ù„ ÙƒØ§Ø±Ø®Ø§Ù†Ù‡ Ø§Ø³Øª ',0),(139792,3884,'tr','Maliyet raporu iÃ§in emir hala ÅŸirket iÃ§inde tahakkuk',0),(139793,3884,'pl','Sprawozdanie dotyczÄ…ce kosztÃ³w naliczonych dla zamÃ³wienia jeszcze we wÅ‚asnym zakresie',0),(139794,3884,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ, Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð²ÑÐµ Ð¾Ñ‰Ðµ Ð² ÐºÑŠÑ‰Ð°Ñ‚Ð°',0),(139795,3884,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©Ø§ Ø¢Ø±ÚˆØ± Ú©Û’ Ù„Ø¦Û’ Ú¯Ú¾Ø± Ø§Ø¨Ú¾ÛŒ ØªÚ© ØªÙ…Ø§Ù… ÛÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§',0),(139796,3884,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°Ð½Ð¸Ñ… Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð¸ Ð´Ð°Ñ™Ðµ ÑƒÐ½ÑƒÑ‚Ð°Ñ€ Ð¾Ñ€Ð³Ð°Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ðµ',0),(139797,3884,'vi','BÃ¡o cÃ¡o giÃ¡ hÃ ng lÅ©y káº¿ cho nhá»¯ng Ä‘Æ¡n hÃ ng tá»“n',0),(139798,3884,'af','Verslag van oopgeloopte kostes vir bestelling steeds in-huisig',0),(139799,3884,'ro','Raportul WIP',0),(139800,3884,'et','Aruanne kogunenud tellimuste kohta, mis on lÃ¤hetamata',0),(139801,3884,'si','PoroÄilo stroÅ¡ki obraÄunane za naroÄila Å¡e vedno in-house',0),(139802,3884,'ba','Laporan dari biaya yang masih harus dibayar untuk pesanan masih rumah',0),(139803,3884,'nl','Verslag over de kosten toenemen voor bestellingen nog intern',0),(139804,3884,'fi','Raportin kustannusten jaksotettu tilauksia vielÃ¤ talon',0),(139805,3884,'no','Rapport om kostnader pÃ¥lÃ¸pt for bestillinger fortsatt internt',0),(139806,3884,'da','Rapport om omkostninger periodiseres for ordrer stadig in-house',0),(139807,3884,'ko','ë¹„ìš© ë³´ê³ ì„œ ì£¼ë¬¸ ì—¬ì „ížˆ ì¡°ì§ ë‚´ì—ì„œ ë°œìƒ í•œ',0),(139808,3884,'he','×“×• ×— ×©×œ ×¢×œ×•×™×•×ª × ×¦×‘×¨ ×œ×”×–×ž× ×•×ª ×¢×“×™×™×Ÿ ×‘×ª×•×š ×”×‘×™×ª',0),(139809,3884,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î¿Ï… ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï„Ï‰Î½ Î´ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Ï‰Î½ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±ÎºÏŒÎ¼Î±-ÏƒÏ€Î¯Ï„Î¹',0),(139810,3884,'zh','å¯¹åº“å†…è®¢å•ç´¯è®¡æˆæœ¬çš„æŠ¥å‘Š\r\n',0),(139811,3884,'sv','Rapport Ã¶ver kostnader tillkommer fÃ¶r bestÃ¤llningar fortfarande in-house',0),(139812,3884,'it','Relazione dei costi maturati per ordini ancora in-House',0),(139813,3884,'tl','',0),(139814,3884,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3',0),(139815,3884,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¥€ à¤²à¤¾à¤—à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤…à¤­à¥€ à¤­à¥€ à¤˜à¤° à¤®à¥‡à¤‚ à¤…à¤°à¥à¤œà¤¿à¤¤',0),(139816,3884,'ms','Laporan bayaran terakru bagi pesanan masih sendiri',0),(139817,3884,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ù„Ø£ÙˆØ§Ù…Ø± Ù„Ø§ ÙŠØ²Ø§Ù„ Ø¯Ø§Ø®Ù„ÙŠØ§',0),(139818,3884,'fr','Rapport des coÃ»ts accumulÃ©s pour les commandes toujours interne',0),(139819,3884,'jp','ç¤¾å†…ã?«ã?¾ã? ã?‚ã‚‹æ³¨æ–‡ã?®ç´¯ç©?è²»ç”¨ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(139820,3884,'pt','RelatÃ³rio de custos acrescidos para ordens ainda internamente',0),(139821,3884,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾ Ñ€Ð°ÑÑ…Ð¾Ð´Ð°Ñ… Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð½Ñ‹Ðµ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¿Ð¾-Ð¿Ñ€ÐµÐ¶Ð½ÐµÐ¼Ñƒ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¼Ð¸ ÑÐ¸Ð»Ð°Ð¼Ð¸',0),(139822,3884,'es','Informe de costos acumulados para ordenes todavÃ­a en casa',0),(139823,3884,'de','Bericht zu Kosten angefallen fÃ¼r Bestellungen noch intern',0),(139824,3884,'en','Report of costs accrued for orders still in-house',0),(139825,3885,'is','',0),(139826,3885,'dr','Ù†ÙˆØ´ØªÙ† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø¹Ù…Ù„ÙƒØ±Ø¯ ÙŠÙƒ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(139827,3885,'pr','Ù†ÙˆØ´ØªÙ† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø¹Ù…Ù„ÙƒØ±Ø¯ ÙŠÙƒ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(139828,3885,'tr','Bir Ã§alÄ±ÅŸanÄ±n performans gÃ¶zden geÃ§irme',0),(139829,3885,'pl','Napisz recenzjÄ™ wydajnoÅ›Ä‡ pracownika',0),(139830,3885,'bg','ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° ÐµÑ„ÐµÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(139831,3885,'ur','Ø§ÛŒÚ© Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©ÛŒ ØªØ­Ø±ÛŒØ±',0),(139832,3885,'sr','ÐÐ°Ð¿Ð¸ÑÐ°Ð¾ Ñ˜Ðµ ÑÑ‚ÑƒÐ´Ð¸Ñ˜Ñƒ ÑƒÑ‡Ð¸Ð½ÐºÐ° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(139833,3885,'vi','Viáº¿t báº£ng Ä‘Ã¡nh giÃ¡ nÄƒng lá»±c cá»§a 1 nhÃ¢n viÃªn',0),(139834,3885,'af','Skryf \'n Werknemers Prestasie Oorsig',0),(139835,3885,'ro','Scrie o revizuire de performanÅ£Äƒ angajat',0),(139836,3885,'et','Kirjuta tÃ¶Ã¶taja arengu iseloomustus',0),(139837,3885,'si','NapiÅ¡ite pregled uspeÅ¡nosti zaposlenih',0),(139838,3885,'ba','Menulis tinjauan kinerja karyawan',0),(139839,3885,'nl','Schrijf een recensie van werknemer prestaties',0),(139840,3885,'fi','Kirjoita tyÃ¶ntekijÃ¤n arviointi',0),(139841,3885,'no','Skrive en ansatt ytelse gjennomgang',0),(139842,3885,'da','Skrive en medarbejder resultatanalyse',0),(139843,3885,'ko','ì§ì› ì„±ëŠ¥ ë¦¬ë·°ë¥¼ ì¨ì£¼ì„¸ìš”',0),(139844,3885,'he','×œ×›×ª×•×‘ ×¡×§×™×¨×” ×‘×™×¦×•×¢×™ ×”×¢×•×‘×“',0),(139845,3885,'el','Î“ÏÎ¬ÏˆÏ„Îµ Î¼Î¹Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Î±Ï€ÏŒÎ´Î¿ÏƒÎ·Ï‚ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(139846,3885,'zh','å†™ä¸€å‘˜å·¥ç»©æ•ˆå®¡æ ¸\r\n',0),(139847,3885,'sv','Skriva en Employee Performance Review',0),(139848,3885,'it','Scrivi una recensione di prestazioni dipendente',0),(139849,3885,'tl','',0),(139850,3885,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3585;&#3634;&#3619;&#3607;&#3610;&#3607;&#3623;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(139851,3885,'hi','à¤à¤• à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥‡ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤²à¤¿à¤–à¤¨à¥‡',0),(139852,3885,'ms','Menulis kajian prestasi pekerja',0),(139853,3885,'ar','ÙƒØªØ§Ø¨Ø© Ø¨Ø§Ø³ØªØ¹Ø±Ø§Ø¶ Ø£Ø¯Ø§Ø¡ Ø§Ù„Ù…ÙˆØ¸Ù',0),(139854,3885,'fr','Ã‰crire un examen du rendement',0),(139855,3885,'jp','å¾“æ¥­å“¡å‹¤å‹™è©•å®šã‚’æ›¸ã??',0),(139856,3885,'pt','Escrever uma revisÃ£o de desempenho do empregado',0),(139857,3885,'ru','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ð¾Ð±Ð·Ð¾Ñ€ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(139858,3885,'es','Escribir una RevisiÃ³n de DesempeÃ±o de Empleado',0),(139859,3885,'de','Schreiben eines Mitarbeiterleistungsbewertung',0),(139860,3885,'en','Write an Employee Performance Review',0),(139861,3886,'is','',0),(139862,3886,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§',0),(139863,3886,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§',0),(139864,3886,'tr','Ã‡ek yazmak',0),(139865,3886,'pl','Napisz kontroli',0),(139866,3886,'bg','ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(139867,3886,'ur','Ø¢Ù¾ Ú†ÛŒÚ© Ù„Ú©Ú¾',0),(139868,3886,'sr','ÐŸÐ¸ÑÐ°ÑšÐµ Ñ‡ÐµÐºÐ¾Ð²Ð°',0),(139869,3886,'vi','Viáº¿t SÃ©c',0),(139870,3886,'af','Skryf Tjeks',0),(139871,3886,'ro','Scrie CEC-uri',0),(139872,3886,'et','Kirjuta tÅ¡ekid',0),(139873,3886,'si','Pisati pregledi',0),(139874,3886,'ba','Menulis cek',0),(139875,3886,'nl','Controles schrijven',0),(139876,3886,'fi','Kirjoittakaa tarkastusten',0),(139877,3886,'no','Skrive',0),(139878,3886,'da','Skrive Checks',0),(139879,3886,'ko','ê²€ì‚¬ë¥¼ ìž‘ì„±',0),(139880,3886,'he','×œ×›×ª×•×‘ ×¦\'×§×™×',0),(139881,3886,'el','Î“ÏÎ¬ÏˆÏ„Îµ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚',0),(139882,3886,'zh','å¼€æ”¯ç¥¨\r\n',0),(139883,3886,'sv','Skriva kontroller',0),(139884,3886,'it','Scrivere controlli',0),(139885,3886,'tl','',0),(139886,3886,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;',0),(139887,3886,'hi','à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡',0),(139888,3886,'ms','Menulis cek',0),(139889,3886,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„ØµÙƒÙˆÙƒ',0),(139890,3886,'fr','Ã‰crire des contrÃ´les',0),(139891,3886,'jp','å°?åˆ‡æ‰‹ã‚’æ›¸ã??',0),(139892,3886,'pt','Cheques',0),(139893,3886,'ru','Ð’Ñ‹Ð¿Ð¸ÑÑ‹Ð²Ð°Ñ‚ÑŒ Ñ‡ÐµÐºÐ¸',0),(139894,3886,'es','Elaborar Cheques',0),(139895,3886,'de','PrÃ¼fungen zu schreiben',0),(139896,3886,'en','Write Checks',0),(139897,3887,'is','',0),(139898,3887,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§ Ø·Ø¨Ù‚ ØªØ§Ø±ÙŠØ® ',0),(139899,3887,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§ Ø·Ø¨Ù‚ ØªØ§Ø±ÙŠØ® ',0),(139900,3887,'tr','Tarihe gÃ¶re Ã§ekler yazmak',0),(139901,3887,'pl','Napisz kontroli wedÅ‚ug daty',0),(139902,3887,'bg','ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¿Ð¾ Ð´Ð°Ñ‚Ð°',0),(139903,3887,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ú†ÛŒÚ© Ù„Ú©Ú¾',0),(139904,3887,'sr','ÐŸÐ¸ÑÐ°ÑšÐµ Ñ‡ÐµÐºÐ¾Ð²Ð° Ð¿Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ñƒ',0),(139905,3887,'vi','Viáº¿t SÃ©c theo ngÃ y',0),(139906,3887,'af','Skryf Tjeks per Datum',0),(139907,3887,'ro','Scrie CECD-uri dupa data',0),(139908,3887,'et','Kirjuta tÅ¡ekid kuupÃ¤evaga',0),(139909,3887,'si','PiÅ¡ejo pregledov po datumu',0),(139910,3887,'ba','Menulis cek oleh tanggal',0),(139911,3887,'nl','Controles door datum schrijven',0),(139912,3887,'fi','Kirjoittaa tarkistaa pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n mukaan',0),(139913,3887,'no','Skrive etter dato',0),(139914,3887,'da','Skriv kontrol af dato',0),(139915,3887,'ko','ë‚ ì§œë³„ìœ¼ë¡œ ê²€ì‚¬ë¥¼ ìž‘ì„±',0),(139916,3887,'he','×œ×›×ª×•×‘ ×¦\'×§×™× ×œ×¤×™ ×ª××¨×™×š',0),(139917,3887,'el','Î“ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿Ï…Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Î¼Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(139918,3887,'zh','æŒ‰æ—¥æœŸå†™æ”¯ç¥¨\r\n',0),(139919,3887,'sv','Skriva kontroller av datum',0),(139920,3887,'it','Scrivere assegni di data',0),(139921,3887,'tl','',0),(139922,3887,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3604;&#3657;&#3623;&#3618;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(139923,3887,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡',0),(139924,3887,'ms','Menulis cek mengikut tarikh',0),(139925,3887,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø¨ØªØ§Ø±ÙŠØ®',0),(139926,3887,'fr','Ã‰crire des chÃ¨ques par Date',0),(139927,3887,'jp','Write Checks by Date',0),(139928,3887,'pt','Cheques por data',0),(139929,3887,'ru','Ð’Ñ‹Ð¿Ð¸ÑÑ‹Ð²Ð°Ñ‚ÑŒ Ñ‡ÐµÐºÐ¸ Ð¿Ð¾ Ð´Ð°Ñ‚Ðµ',0),(139930,3887,'es','Elaborar Cheques por Fecha',0),(139931,3887,'de','Schreiben Schecks nach Datum',0),(139932,3887,'en','Write Checks by Date',0),(139933,3888,'is','',0),(139934,3888,'dr','(ÙŠØ§ Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(139935,3888,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø¨Ø±Ø§ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø®Ø§Øµ(ÙŠØ§ Ù‚Ø³Ù…ØªÙŠ Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(139936,3888,'tr','Belirli faturalarÄ± iÃ§in Ã§ekler yazmak (veya kÄ±smi Ã¶deme yapmak)',0),(139937,3888,'pl','KsiÄ…Å¼eczkÄ… dla konkretnych rachunkÃ³w (lub czÄ™Å›ciowe pÅ‚atnoÅ›ci)',0),(139938,3888,'bg','ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð·Ð° ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸ (Ð¸Ð»Ð¸ Ñ‡Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ)',0),(139939,3888,'ur','Ù…Ø®ØµÙˆØµ Ø¨ÙÙ„ Ú©Û’ Ù„ÛŒÛ’ Ø¢Ù¾ Ú†ÛŒÚ© Ù„Ú©Ú¾ (ÛŒØ§ Ø¬Ø²ÙˆÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø±ØªÛ’)',0),(139940,3888,'sr','ÐŸÐ¸ÑˆÐµÑ‚Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð·Ð° Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ (Ð¸Ð»Ð¸ Ð´ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð¸ Ñ€Ð°Ñ‚Ð°Ð¼Ð°)',0),(139941,3888,'vi','Viáº¿t SÃ©c Cho HÃ³a ÄÆ¡n Cá»¥ Thá»ƒ (Hay thanh toÃ¡n 1 pháº§n) ',0),(139942,3888,'af','Skryf Tjek vir Spesifieke Rekeninge (of maak gedeeltelike betalings)',0),(139943,3888,'ro','Scrie controalelor pentru facturile de specifice (sau plÄƒÈ›i parÈ›iale)',0),(139944,3888,'et','*Write Checks for Specific Bills (or make partial payments)',0),(139945,3888,'si','PiÅ¡ejo pregledov za posebne raÄune (ali izdelavo delnih plaÄil)',0),(139946,3888,'ba','Menulis cek untuk tagihan tertentu (atau melakukan pembayaran parsial)',0),(139947,3888,'nl','Controles schrijven voor specifieke Bills (of gedeeltelijke betalingen maken)',0),(139948,3888,'fi','Kirjoittakaa tarkastusten erityisiÃ¤ laskuja (tai osittainen maksaminen)',0),(139949,3888,'no','Skrive for bestemte regninger (eller foreta delvise betalinger)',0),(139950,3888,'da','Skrive Checks for specifikke regninger (eller foretage delvis betaling)',0),(139951,3888,'ko','íŠ¹ì • ìš”ê¸ˆì— ëŒ€ í•œ ìˆ˜ í‘œë¥¼ ìž‘ì„± (ë˜ëŠ” ë¶€ë¶„ ìƒí™˜)',0),(139952,3888,'he','×œ×›×ª×•×‘ ×¦\'×§×™× ×¢×‘×•×¨ ×—×©×‘×•× ×•×ª ×¡×¤×¦×™×¤×™×™× (××• ×ª×©×œ×•×ž×™× ×—×œ×§×™×™×)',0),(139953,3888,'el','Î“ÏÎ¬Ï†Ï‰ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Î³Î¹Î± ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î± Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î± (Î® Î¼ÎµÏÎ¹ÎºÎ® Ï€Î»Î·ÏÏ‰Î¼Î®)',0),(139954,3888,'zh','ä¸ºç‰¹å®šå¸å•å†™å‘ç¥¨ï¼ˆæˆ–éƒ¨åˆ†ä»˜æ¬¾ï¼‰\r\n',0),(139955,3888,'sv','Skriver kontroller fÃ¶r specifika rÃ¤kningar (eller gÃ¶ra delbetalningar)',0),(139956,3888,'it','Scrivere controlli specifici Bills (o effettuare pagamenti parziali)',0),(139957,3888,'tl','',0),(139958,3888,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3610;&#3636;&#3621;&#3607;&#3637;&#3656;&#3619;&#3632;&#3610;&#3640; (&#3627;&#3619;&#3639;&#3629;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&',0),(139959,3888,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤¬à¤¿à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡ (à¤¯à¤¾ à¤†à¤‚à¤¶à¤¿à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°)',0),(139960,3888,'ms','Menulis cek untuk bil-bil tertentu (atau membuat bayaran sebahagian)',0),(139961,3888,'ar','ÙƒØªØ§Ø¨Ø© ØµÙƒÙˆÙƒ Ù„Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ù…Ø­Ø¯Ù‘Ø¯Ø© Ø£Ùˆ Ø³Ø¯Ø§Ø¯ Ø¬Ø²Ø¦ÙŠÙ‘',0),(139962,3888,'fr','Ã‰crire des chÃ¨ques pour les projets de loi spÃ©cifique (ou faire des paiements partiels)',0),(139963,3888,'jp','ç‰¹å®šè«‹æ±‚æ›¸ã?®å°?åˆ‡æ‰‹æ›¸ã??è¾¼ã?¿ï¼ˆã‚‚ã?—ã??ã?¯éƒ¨åˆ†æ‰•ã?„ï¼‰',0),(139964,3888,'pt','Cheques para as contas especÃ­ficas (ou fazer pagamentos parciais)',0),(139965,3888,'ru','Ð’Ñ‹Ð¿Ð¸ÑÑ‹Ð²Ð°Ñ‚ÑŒ Ñ‡ÐµÐºÐ¸ Ð´Ð»Ñ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¾Ð² (Ð¸Ð»Ð¸ ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ Ñ‡Ð°ÑÑ‚Ð¸Ñ‡Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸)',0),(139966,3888,'es','Elaborar Cheques para Facturas EspecÃ­ficas (o hace pagos parciales)',0),(139967,3888,'de','Kontrollen fÃ¼r bestimmte Rechnungen schreiben (oder Teilzahlungen zu machen)',0),(139968,3888,'en','Write Checks for Specific Bills (or make partial payments)',0),(139969,3889,'is','',0),(139970,3889,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§ÙŠ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ ',0),(139971,3889,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§ÙŠ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ ',0),(139972,3889,'tr','Belirtilen Ã§ekleri yazmak',0),(139973,3889,'pl','Napisz kontrole, okreÅ›lone',0),(139974,3889,'bg','ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸, Ð¿Ð¾ÑÐ¾Ñ‡ÐµÐ½Ð¸',0),(139975,3889,'ur','Ø¢Ù¾ Ú©Ø§ Ø§Ø®ØªØµØ§ØµÛŒ Ú†ÛŒÚ© Ù„Ú©Ú¾',0),(139976,3889,'sr','ÐŸÐ¸ÑÐµÐ¼Ð¾ Ñ†ÐµÐºÐ¾Ð²Ðµ Ð½Ð°Ð²ÐµÐ´ÐµÐ½',0),(139977,3889,'vi','Viáº¿t SÃ©c cá»¥ thá»ƒ',0),(139978,3889,'af','Uitskryf van Gespesifiseerde Tjeks ',0),(139979,3889,'ro','Scrie controalele menÅ£ionate',0),(139980,3889,'et','*Write Checks Specified',0),(139981,3889,'si','PiÅ¡ejo pregledov doloÄena',0),(139982,3889,'ba','Menulis cek yang ditentukan',0),(139983,3889,'nl','Controles opgegeven schrijven',0),(139984,3889,'fi','Kirjoittaa tarkoitetut tarkastukset',0),(139985,3889,'no','Skrive angitt',0),(139986,3889,'da','Skrive kontrol angivet',0),(139987,3889,'ko','ì§€ì • ëœ ê²€ì‚¬ë¥¼ ìž‘ì„±',0),(139988,3889,'he','×œ×›×ª×•×‘ ×¦\'×§×™× ×©×¦×•×™×Ÿ',0),(139989,3889,'el','Î“ÏÎ¬ÏˆÏ„Îµ ÎµÎ»Î­Î³Ï‡Ï‰Î½ Ï€Î¿Ï… Î±Î½Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹',0),(139990,3889,'zh','å¼€æ”¯ç¥¨æŒ‡å®š\r\n',0),(139991,3889,'sv','Skriva kontroller som anges',0),(139992,3889,'it','Scrivere controlli specificati',0),(139993,3889,'tl','',0),(139994,3889,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3592;&#3634;&#3632;&#3592;&#3591;',0),(139995,3889,'hi','à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡',0),(139996,3889,'ms','Menulis cek yang dinyatakan',0),(139997,3889,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(139998,3889,'fr','Ã‰crire des contrÃ´les mentionnÃ©s',0),(139999,3889,'jp','Write Checks Specific',0),(140000,3889,'pt','Cheques especificado',0),(140001,3889,'ru','ÐÐ°Ð¿Ð¸ÑˆÐ¸Ñ‚Ðµ ÑƒÐºÐ°Ð·Ð°Ð½Ð½Ñ‹Ðµ Ñ‡ÐµÐºÐ¸',0),(140002,3889,'es','Escribir cheques especificados',0),(140003,3889,'de','Schreiben Schecks angegeben',0),(140004,3889,'en','Write Checks Specified',0),(140005,3890,'is','',0),(140006,3890,'dr','Ù†ÙˆØ´ØªÙ† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(140007,3890,'pr','Ù†ÙˆØ´ØªÙ† Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(140008,3890,'tr','Ã‡alÄ±ÅŸan bir daha gÃ¶zden geÃ§irme yeni/DÃ¼zenle',0),(140009,3890,'pl','Pracownik przeglÄ…d nowych/edycja',0),(140010,3890,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð½Ð¾Ð² Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(140011,3890,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù†Ø¦ÛŒ/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(140012,3890,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð¾Ð²Ð¸Ñ…/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(140013,3890,'vi','Viáº¿t báº£ng Ä‘Ã¡nh giÃ¡ 1 nhÃ¢n viÃªn',0),(140014,3890,'af','Skryf Werknemer Oorsig',0),(140015,3890,'ro','Scrie analiza angajatilor',0),(140016,3890,'et','Kirjuta tÃ¶Ã¶taja iseloomustus',0),(140017,3890,'si','Zaposlenega pregled novih/Uredi',0),(140018,3890,'ba','Karyawan Review baru/Edit',0),(140019,3890,'nl','Werknemer Review nieuwe/bewerken',0),(140020,3890,'fi','TyÃ¶ntekijÃ¤n uudelleen uusi tai Muokkaa',0),(140021,3890,'no','Ansatte gjennomgang ny/Rediger',0),(140022,3890,'da','Medarbejder anmeldelse ny/Rediger',0),(140023,3890,'ko','ì§ì› ê²€í†  ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘',0),(140024,3890,'he','×”×¢×•×‘×“ ×¡×§×™×¨×” ×—×“×©×”/×¢×¨×™×›×”',0),(140025,3890,'el','Î‘Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(140026,3890,'zh','æ–°å»º/ç¼–è¾‘å‘˜å·¥å®¡æ ¸\r\n',0),(140027,3890,'sv','AnstÃ¤lld recension ny/redigera',0),(140028,3890,'it','Dipendente recensione nuovo/modifica',0),(140029,3890,'tl','',0),(140030,3890,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(140031,3890,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤¨à¤/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(140032,3890,'ms','Pekerja kajian baru/Edit',0),(140033,3890,'ar','Ø¥Ù†Ø´Ø§Ø¡ ØªÙ‚Ø±ÙŠØ± ØªÙ‚ÙŠÙŠÙ… Ù…ÙˆØ¸Ù',0),(140034,3890,'fr','EmployÃ© nouvelle rÃ©vision/modification',0),(140035,3890,'jp','å¾“æ¥­å“¡è©•ä¾¡ã‚’æ›¸ã??',0),(140036,3890,'pt','Empregado revisÃ£o novo/editar',0),(140037,3890,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº Ð¾Ð±Ð·Ð¾Ñ€ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ/Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(140038,3890,'es','Escribir RevisiÃ³n de Empleado',0),(140039,3890,'de','Mitarbeiter Review neu/bearbeiten',0),(140040,3890,'en','Employee Review New/Edit',0),(140041,3891,'is','',0),(140042,3891,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§ÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(140043,3891,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§ÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(140044,3891,'tr','Bordro Ã§ek yazmak',0),(140045,3891,'pl','Napisz kontroli pÅ‚ac',0),(140046,3891,'bg','ÐÐ°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(140047,3891,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú†ÛŒÚ© Ù„Ú©Ú¾',0),(140048,3891,'sr','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(140049,3891,'vi','Viáº¿t sÃ©c báº£ng lÆ°Æ¡ng',0),(140050,3891,'af','Skryf Loonrol Tjeks',0),(140051,3891,'ro','Scrie salarizare controale',0),(140052,3891,'et','Kirjuta palgakviitungid',0),(140053,3891,'si','Pisati preglede na izplaÄane plaÄe',0),(140054,3891,'ba','Menulis penggajian cek',0),(140055,3891,'nl','Payroll controles schrijven',0),(140056,3891,'fi','Kirjoittaa palkkalistoilla tarkastukset',0),(140057,3891,'no','Skrive lÃ¸nn sjekker',0),(140058,3891,'da','Skrive lÃ¸nningslisten kontrol',0),(140059,3891,'ko','ê¸‰ì—¬ ìˆ˜ í‘œë¥¼ ìž‘ì„±',0),(140060,3891,'he','×œ×›×ª×•×‘ ×”×ž×©×›×•×¨×•×ª',0),(140061,3891,'el','Î“ÏÎ¬ÏˆÏ„Îµ ÎµÏ€Î¹Ï„Î±Î³Î­Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(140062,3891,'zh','å†™å·¥èµ„æ”¯ç¥¨\r\n',0),(140063,3891,'sv','Skriva lÃ¶ner kontroller',0),(140064,3891,'it','Scrivere assegni del libro paga',0),(140065,3891,'tl','',0),(140066,3891,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3605;&#3633;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(140067,3891,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡',0),(140068,3891,'ms','Tulis cek gaji',0),(140069,3891,'ar','ÙƒØªØ§Ø¨Ø© Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(140070,3891,'fr','Ã‰crire des chÃ¨ques de paie',0),(140071,3891,'jp','çµ¦ä¸Žå°?åˆ‡æ‰‹ã?®æ›¸ã??è¾¼ã?¿',0),(140072,3891,'pt','Folha de pagamento de cheques',0),(140073,3891,'ru','Ð’Ñ‹Ð¿Ð¸ÑÑ‹Ð²Ð°Ñ‚ÑŒ Ñ‡ÐµÐºÐ¸ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(140074,3891,'es','Escribir Cheques de NÃ³mina',0),(140075,3891,'de','Payroll-PrÃ¼fungen zu schreiben',0),(140076,3891,'en','Write Payroll Checks',0),(140077,3892,'is','',0),(140078,3892,'dr','ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(140079,3892,'pr','ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(140080,3892,'tr','Ã‡alÄ±ÅŸan faaliyet',0),(140081,3892,'pl','AktywnoÅ›Ä‡ pracownika',0),(140082,3892,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(140083,3892,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(140084,3892,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(140085,3892,'vi','Hoáº¡t Ä‘á»™ng nhÃ¢n viÃªn',0),(140086,3892,'af','Werknemer Aktiwiteit',0),(140087,3892,'ro','Activitatea angajatului',0),(140088,3892,'et','TÃ¶Ã¶taja tegevused',0),(140089,3892,'si','Dejavnosti zaposlenega',0),(140090,3892,'ba','Aktivitas karyawan',0),(140091,3892,'nl','Werknemer activiteit',0),(140092,3892,'fi','TyÃ¶ntekijÃ¤n toimintaa',0),(140093,3892,'no','Arbeidstakeren aktiviteten',0),(140094,3892,'da','Medarbejder aktivitet',0),(140095,3892,'ko','ì§ì› í™œë™',0),(140096,3892,'he','×¤×¢×™×œ×•×ª ×¢×•×‘×“',0),(140097,3892,'el','Î”ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(140098,3892,'zh','å‘˜å·¥æ´»åŠ¨\r\n',0),(140099,3892,'sv','AnstÃ¤lld aktivitet',0),(140100,3892,'it','AttivitÃ  dipendente',0),(140101,3892,'tl','',0),(140102,3892,'th','&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(140103,3892,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(140104,3892,'ms','Aktiviti kakitangan',0),(140105,3892,'ar','Ù†Ø´Ø§Ø· Ø§Ù„Ù…ÙˆØ¸Ù',0),(140106,3892,'fr','ActivitÃ© de l\'employÃ©',0),(140107,3892,'jp','å¾“æ¥­å“¡æ´»å‹•',0),(140108,3892,'pt','Atividade de empregado',0),(140109,3892,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(140110,3892,'es','Actividad de Empleados ',0),(140111,3892,'de','Mitarbeiter TÃ¤tigkeit',0),(140112,3892,'en','Employee Activity',0),(140113,3893,'is','',0),(140114,3893,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(140115,3893,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(140116,3893,'tr','Ã‡alÄ±ÅŸan faaliyet raporlarÄ±',0),(140117,3893,'pl','Raporty aktywnoÅ›ci',0),(140118,3893,'bg','ÐžÑ‚Ñ‡ÐµÑ‚Ð¸ Ð·Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ',0),(140119,3893,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ÛŒÚº',0),(140120,3893,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸Ð¼Ð°',0),(140121,3893,'vi','BÃ¡o cÃ¡o hoáº¡t Ä‘á»™ng cá»§a nhÃ¢n viÃªn',0),(140122,3893,'af','Werknemer Aktiwiteitsverslae',0),(140123,3893,'ro','Rapoarte despre activitatea angajatului',0),(140124,3893,'et','TÃ¶Ã¶tajate tegevuste aruanne',0),(140125,3893,'si','PoroÄila o dejavnosti zaposlenega',0),(140126,3893,'ba','Laporan aktivitas karyawan',0),(140127,3893,'nl','Activiteitenverslagen van de werknemer',0),(140128,3893,'fi','TyÃ¶ntekijÃ¤n toimintakertomukset',0),(140129,3893,'no','Aktivitet ansattrapporter',0),(140130,3893,'da','Medarbejder aktivitetsrapporter',0),(140131,3893,'ko','ì§ì› í™œë™ ë³´ê³ ì„œ',0),(140132,3893,'he','×“×•×—×•×ª ×¤×¢×™×œ×•×ª ×”×¢×•×‘×“',0),(140133,3893,'el','Î•ÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(140134,3893,'zh','å‘˜å·¥æ´»åŠ¨æŠ¥å‘Š\r\n',0),(140135,3893,'sv','AnstÃ¤lld aktivitetsrapporter',0),(140136,3893,'it','Relazioni di attivitÃ  dipendente',0),(140137,3893,'tl','',0),(140138,3893,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(140139,3893,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥‹à¤‚',0),(140140,3893,'ms','Laporan aktiviti pekerja',0),(140141,3893,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ù†Ø´Ø§Ø· Ø§Ù„Ù…ÙˆØ¸Ù',0),(140142,3893,'fr','Rapports d\'activitÃ© des employÃ©s',0),(140143,3893,'jp','å¾“æ¥­å“¡æ´»å‹•ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(140144,3893,'pt','RelatÃ³rios de atividade de empregado',0),(140145,3893,'ru','ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(140146,3893,'es','Actividad de Empleados Informes',0),(140147,3893,'de','Mitarbeiter-TÃ¤tigkeitsberichte',0),(140148,3893,'en','Employee Activity Reports',0),(140149,3894,'is','',0),(140150,3894,'dr','Ù…ØªÙ† Ø¨Ø±Ø§ÙŠ \r\n Jon',0),(140151,3894,'pr','Ù…ØªÙ† Ø¨Ø±Ø§ÙŠ \r\n Jon',0),(140152,3894,'tr','Jon iÃ§in metin',0),(140153,3894,'pl','Tekst Jon',0),(140154,3894,'bg','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Ð”Ð¶Ð¾Ð½',0),(140155,3894,'ur','ÛŒØ­ÛŒÛŒÙ° Ú©Û’ Ù„ÛŒÛ’ Ù…ØªÙ†',0),(140156,3894,'sr','Ð¢ÐµÐºÑÑ‚ Ð·Ð° ÐˆÐ¾Ð½',0),(140157,3894,'vi','VÄƒn báº£n cho Jon',0),(140158,3894,'af','Skryf aan Jon',0),(140159,3894,'ro','Textul pentru Jon',0),(140160,3894,'et','Jon tekst',0),(140161,3894,'si','Besedilo za Jon',0),(140162,3894,'ba','Teks untuk Jon',0),(140163,3894,'nl','Tekst voor Jon',0),(140164,3894,'fi','Teksti Jon',0),(140165,3894,'no','Tekst for Jon',0),(140166,3894,'da','Tekst til Jon',0),(140167,3894,'ko','ì¡´ì— ëŒ€ í•œ í…ìŠ¤íŠ¸',0),(140168,3894,'he','×˜×§×¡×˜ ×¢×‘×•×¨ ×’\'×•×Ÿ',0),(140169,3894,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Î³Î¹Î± Jon',0),(140170,3894,'zh','æ–‡å­—ä¹”æ©\r\n',0),(140171,3894,'sv','Text fÃ¶r Jon',0),(140172,3894,'it','Testo di Jon',0),(140173,3894,'tl','',0),(140174,3894,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610; Jon',0),(140175,3894,'hi','à¤œà¥‰à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤ ',0),(140176,3894,'ms','Teks untuk Jon',0),(140177,3894,'ar','Ù†Øµ Ø¬ÙˆÙ†',0),(140178,3894,'fr','Texte pour Jon',0),(140179,3894,'jp','Text for Jon',0),(140180,3894,'pt','Texto para Jon',0),(140181,3894,'ru','Ð¢ÐµÐºÑÑ‚ Ð´Ð»Ñ Ð”Ð¶Ð¾Ð½',0),(140182,3894,'es','Texto para Jon',0),(140183,3894,'de','Text fÃ¼r Jon',0),(140184,3894,'en','Text for Jon',0),(140185,3895,'is','',0),(140186,3895,'dr','Ù…ØªÙ† Ø¨Ø±Ø§ÙŠ\r\n Donovon',0),(140187,3895,'pr','Ù…ØªÙ† Ø¨Ø±Ø§ÙŠ\r\n Donovon',0),(140188,3895,'tr','Metin Donovon',0),(140189,3895,'pl','Tekst Donovon',0),(140190,3895,'bg','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Donovon',0),(140191,3895,'ur','Ø¯ÙˆÙ†ÙˆÙˆØ§Ù† Ú©Û’ Ù„ÛŒÛ’ Ù…ØªÙ†',0),(140192,3895,'sr','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Ð”Ð¾Ð½Ð¾Ð²Ð¾Ð½',0),(140193,3895,'vi','VÄƒn báº£n cho Donovon',0),(140194,3895,'af','Skryf aan Donovan',0),(140195,3895,'ro','Text pentru Donovon',0),(140196,3895,'et','Teksti Donovon',0),(140197,3895,'si','Besedilo za Donovon',0),(140198,3895,'ba','Teks untuk Donovon',0),(140199,3895,'nl','Tekst voor Donovon',0),(140200,3895,'fi','Tekstin Donovon',0),(140201,3895,'no','Tekst for Donovon',0),(140202,3895,'da','Tekst for Donovon',0),(140203,3895,'ko','Donovonì— ëŒ€ í•œ í…ìŠ¤íŠ¸',0),(140204,3895,'he','×˜×§×¡×˜ ×¢×‘×•×¨ Donovon',0),(140205,3895,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Î³Î¹Î± Ï„Î·Î½ Donovon',0),(140206,3895,'zh','æ–‡å­—Donovon\r\n',0),(140207,3895,'sv','Text fÃ¶r Donovon',0),(140208,3895,'it','Testo per Donovon',0),(140209,3895,'tl','',0),(140210,3895,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610; Donovon',0),(140211,3895,'hi','Donovon à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤ ',0),(140212,3895,'ms','Teks untuk Donovon',0),(140213,3895,'ar','Ù†Øµ Ø¯ÙˆÙ†ÙˆÙÙ†',0),(140214,3895,'fr','Texte pour Donovon',0),(140215,3895,'jp','Text for Donovon',0),(140216,3895,'pt','Texto para raphachan',0),(140217,3895,'ru','Ð¢ÐµÐºÑÑ‚ Ð´Ð»Ñ Donovon',0),(140218,3895,'es','Texto para Donovan',0),(140219,3895,'de','Text fÃ¼r Donovon',0),(140220,3895,'en','Text for Donovon',0),(140221,3896,'is','',0),(140222,3896,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(140223,3896,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(140224,3896,'tr','Standart Ã¶lÃ§Ã¼ silme hatasÄ±.',0),(140225,3896,'pl','BÅ‚Ä…d podczas usuwania standardowej wielkoÅ›ci.',0),(140226,3896,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ€Ð¸.',0),(140227,3896,'ur','Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ø³Ø§Ø¦Ø² Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ ÛÛ’ Û”',0),(140228,3896,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ðµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ.',0),(140229,3896,'vi','Lá»—i xÃ³a cá»¡ chuáº©n',0),(140230,3896,'af','Fout standaard grootte te skrap.',0),(140231,3896,'ro','Eroare la È™tergerea dimensiunea standard.',0),(140232,3896,'et','TÃµrge kustutamisel standard suurus.',0),(140233,3896,'si','Napaka pri brisanju standardne velikosti.',0),(140234,3896,'ba','Error menghapus ukuran standar.',0),(140235,3896,'nl','Fout bij het verwijderen van standaard formaat.',0),(140236,3896,'fi','Virhe poistettaessa vakiokoko.',0),(140237,3896,'no','Feil ved sletting av standard stÃ¸rrelse.',0),(140238,3896,'da','Fejl ved sletning af standard stÃ¸rrelse.',0),(140239,3896,'ko','í‘œì¤€ í¬ê¸°ë¥¼ ì‚­ì œ í•˜ëŠ” ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(140240,3896,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×‘×’×•×“×œ ×¡×˜× ×“×¨×˜×™.',0),(140241,3896,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎºÎ±Î½Î¿Î½Î¹ÎºÎ¿Ï Î¼ÎµÎ³Î­Î¸Î¿Ï…Ï‚.',0),(140242,3896,'zh','é”™è¯¯åˆ é™¤æ ‡å‡†å°ºå¯¸ã€‚',0),(140243,3896,'sv','Fel ta bort standard storlek.',0),(140244,3896,'it','Errore eliminazione di dimensioni standard.',0),(140245,3896,'tl','',0),(140246,3896,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3586;&#3609;&#3634;&#3604;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;',0),(140247,3896,'hi','à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤° à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¥¤',0),(140248,3896,'ms','Ralat Menghapuskan saiz standard.',0),(140249,3896,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ.',0),(140250,3896,'fr','Erreur de suppression de taille standard.',0),(140251,3896,'jp','æ¨™æº–ã‚µã‚¤ã‚ºã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(140252,3896,'pt','Erro ao excluir o tamanho padrÃ£o.',0),(140253,3896,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð³Ð¾ Ñ€Ð°Ð·Ð¼ÐµÑ€Ð°.',0),(140254,3896,'es','Error eliminando tamaÃ±o estÃ¡ndar',0),(140255,3896,'de','Fehler beim LÃ¶schen der standard-GrÃ¶ÃŸe.',0),(140256,3896,'en','Error deleting standard size.',0),(140257,3897,'is','',0),(140258,3897,'dr','11* 17  ÙŠØ§ 8.5 * 14',0),(140259,3897,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ÙŠÙƒ Ø±Ù†Ú¯ â€“ Ø§Ú¯Ø± Ù…Ù…ÙƒÙ† Ø§Ø³Øª  Ù„Ø·ÙØ§ Ù†Ù…ÙˆÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§ÙÙŠ ÙŠØ§ ÙƒÙ¾ÙŠ Ù‡Ø§ÙŠ Ø¢Ù…Ø§Ø¯Ù‡ Ú†Ø§Ù¾ Ø±Ø§ Ø¬Ù‡Øª ØªÙ†Ø¸ÙŠÙ… Ù…ØªØ¹Ø¯Ø¯ ØªÙ‡ÙŠÙ‡ ÙƒÙ†ÙŠØ¯ Ø±ÙˆÙŠ  11* 17  ÙŠØ§ 8.5 * 14\r\nØ§ÙŠÙ† ÙƒØ§Ø± Ø³Ø±',0),(140260,3897,'tr','<b>1-renkli resimleri:</b> MÃ¼mkÃ¼nse, yeterli Ã¶rnekleri veya Ã§oklu 11 \"x 17\" veya 8,5 \"x 14\" kurmak iÃ§in kamera hazÄ±r kopya veriniz.  Bu kadar Ã§abuk yola Ã§Ä±kmak sipariÅŸ bizim sistemi kadar hÄ±zlandÄ±rÄ±r.',0),(140261,3897,'pl','<b>1-kolorowa grafika:</b> JeÅ›li to moÅ¼liwe proszÄ™ podaÄ‡ wystarczajÄ…cÄ… iloÅ›Ä‡ prÃ³bek lub kopie gotowy aparat ustawiÄ‡ wiele na 11 \"x 17\" lub 8,5 \"x 14\".  To przyspiesza nasz system, ktÃ³ry pozwala aby statek szybciej.',0),(140262,3897,'bg','<b>1-Ñ†Ð²ÑÑ‚ Ð¿Ñ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð¸Ñ:</b> ÐÐºÐ¾ Ðµ Ð²ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð¾ Ð¼Ð¾Ð»Ñ Ð´Ð° Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ Ð¿Ñ€Ð¾Ð±Ð¸ Ð¸Ð»Ð¸ ÐºÐ°Ð¼ÐµÑ€Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¸ ÐºÐ¾Ð¿Ð¸Ñ Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´Ð°Ñ‚ Ð¼Ð½Ð¾Ð¶ÐµÑÑ‚Ð²Ð¾ Ð½Ð° 11 \"x 17\" Ð¸Ð»Ð¸ 8,5 \"x',0),(140263,3897,'ur','<b>1-Ø±Ù†Ú¯ Ø¢Ø±Ù¹ ÙˆØ±Ú©:</b> Ø§Ú¯Ø± Ù…Ù…Ú©Ù† ÛÙˆ ØªÙˆ Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ú©Ø§ÙÛŒ Ù†Ù…ÙˆÙ†ÙˆÚº ÛŒØ§ Ú©Ø«ÛŒØ± 11 \"x 17\" ÛŒØ§ 8.5 \"x 14\" Ù¾Ø± Ø³ÛŒÙ¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©ÛŒÙ…Ø±Û’ ØªÛŒØ§Ø± Ù†Ù‚ÙˆÙ„ ÙØ±Ø§ÛÙ… Ú©Ø±ØªÛ’ ÛÛŒÚº Û”  ÛŒÛ ÛÙ…Ø§Ø±Û’ Ù†Ø',0),(140264,3897,'sr','<b>Ð¦Ñ€Ñ‚ÐµÐ¶ 1-Ð±Ð¾Ñ˜Ð°:</b> ÐÐºÐ¾ Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ, Ð¼Ð¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° ÑÐµ Ð´Ð¾Ð²Ð¾Ñ™Ð½Ð¾ ÑƒÐ·Ð¾Ñ€Ð°ÐºÐ° Ð¸Ð»Ð¸ ÐºÐ°Ð¼ÐµÑ€Ð° ÑÐ¿Ñ€ÐµÐ¼Ð½Ð° ÐºÐ¾Ð¿Ð¸Ñ˜Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ð¾Ð´ÐµÑÐ¸Ð»Ð¸ Ð²Ð¸ÑˆÐµ Ð½Ð° 11 \"x 17\" Ð¸Ð»Ð¸ 8.5 \"x 14\".  ÐžÐ²Ð¾ ÑƒÐ±Ñ€Ð·Ð',0),(140265,3897,'vi','<b>1-Máº«u thiáº¿t káº¿ máº§u:</b> Náº¿u cÃ³ thá»ƒ vui lÃ²ng cung cáº¥p Ä‘á»§ vÃ­ dá»¥ hay báº£n sao camera Ä‘á»ƒ set up Ä‘a kÃ­ch cá»¡ 11\"x17\" hay 8.5\"x14\". Äiá»u nÃ y sáº½ giÃºp há»‡ thá»‘ng cá»§a chÃºng tÃ´i lÃ m nhanh hÆ¡n & hoÃ n táº¥t yÃªu cáº§u v',0),(140266,3897,'af','<b>1-Color Artwork:</b> Indien moontlik, verskaf asseblief genoeg voorbeelde of kameragereed kopie om veelvuldige op te stel op 11\"x17\" or 8.5\"x14\".  Die verhoog die spoed van u sisteem wat daartoe lei dat u bestelling vinnger versend word.',0),(140267,3897,'ro','<b>1-culoare opera de arta:</b> DacÄƒ este posibil, furnizaÅ£i suficiente probe sau camera copii gata sÄƒ Ã®nfiinÅ£eze multiple pe 11 \"x 17\" sau 8.5 \"x 14\".  Acest lucru accelereazÄƒ de sistemul nostru, care permite comenzii sÄƒ navÄƒ mai repede.',0),(140268,3897,'et','<b>1-vÃ¤rvi kujundus:</b> VÃµimaluse korral esitage piisavalt proove vÃµi kaamera valmis eksemplarid seadistada mitu 11 \"x 17\" vÃµi 8,5 \"x 14\".  See kiirendab meie sÃ¼steem, mis vÃµimaldab teie tellimuse laeva vÃ¤lja kiiremini.',0),(140269,3897,'si','<b>1-barvni umetnine:</b> ÄŒe je mogoÄe, navedite dovolj vzorcev ali fotoaparat pripravljen kopije vzpostaviti veÄ na 11 \"x 17\" ali 8,5 \"x 14\".  To pospeÅ¡i naÅ¡ sistem, ki omogoÄa vaÅ¡e naroÄilo na ladjo ven hitreje.',0),(140270,3897,'ba','<b>1-warna Artwork:</b> Jika memungkinkan, Harap memberikan cukup sampel atau salinan kamera siap untuk mengatur beberapa pada 11 \"x 17\" atau 8,5 \"x 14\".  Hal ini mempercepat sistem yang memungkinkan Anda agar kapal keluar lebih cepat.',0),(140271,3897,'nl','<b>1-kleur illustraties:</b> Indien mogelijk, geef genoeg monsters of camera klaar kopieÃ«n meerdere instellen op 11 \"x 17\" of 8,5 \"x 14\".  Dit versnelt ons systeem waarmee uw order om het schip uit sneller.',0),(140272,3897,'fi','<b>1-vÃ¤ri kuvitus:</b> Jos mahdollista anna tarpeeksi nÃ¤ytteitÃ¤ tai kamera valmiina jÃ¤ljennÃ¶kset perustettu useita 11 \"x 17\" tai 8,5 \"x 14\".  TÃ¤mÃ¤ nopeuttaa jÃ¤rjestelmÃ¤mme, jonka avulla tilaus toimitetaan nopeammin.',0),(140273,3897,'no','<b>1-color kunstverk:</b> Hvis mulig, vennligst oppgi nok prÃ¸ver eller kameraet klar Kopier sette flere opp pÃ¥ 11 x 17-tommers eller 8,5 \"x 14\".  Dette raskere vÃ¥rt system hvilke innrÃ¸mmer for Ã¥ sende ut raskere.',0),(140274,3897,'da','<b>1-farve illustrationer:</b> Hvis det er muligt, bedes du give nok prÃ¸ver eller kamera klar kopier til at oprette flere pÃ¥ 11 \"x 17\" eller 8,5 \"x 14\".  Dette fremskynder vores system, der tillader din ordre til skibet ud hurtigere.',0),(140275,3897,'ko','<b>1-ì»¬ëŸ¬ ì‚½í™”:</b> ê°€ëŠ¥ í•˜ë©´ ì¶©ë¶„ í•œ ìƒ˜í”Œ ë˜ëŠ” 11 \"x 17\" ë˜ëŠ” 8.5 \"x 14\" ë‹¤ì¤‘ ì„¤ì • ì¹´ë©”ë¼ ì¤€ë¹„ ì‚¬ë³¸ì„ ì œê³µ í•´ ì£¼ì‹­ì‹œì˜¤.  ì´ ì£¼ë¬¸ì„ ë” ë¹¨ë¦¬ ì¶œì‹œí•  ìˆ˜ ìžˆë„ë¡ ìš°ë¦¬ì˜ ì‹œìŠ¤í…œ ì†ë„ê°€ í–¥ìƒ ë©ë‹ˆë‹¤.',0),(140276,3897,'he','<b>1-×¦×‘×¢ ×‘×’×¨×¤×™×§×”:</b> ×‘×ž×™×“×ª ×”××¤×©×¨, × × ×œ×¡×¤×§ ×ž×¡×¤×™×§ ×“×•×’×ž××•×ª ××• ×ž×¦×œ×ž×” ×¢×•×ª×§×™× ×ž×•×›×Ÿ ×œ×”×’×“×™×¨ ×ž×¡×¤×¨ 11 \"x 17\" ××• 8.5 \"x 14\".  ×–×” ×ž××™×¥ ×”×ž×¢×¨×›×ª ×©×œ× ×•, ×ž×” ×©×ž××¤×©×¨ ××ª ×”×”×–×ž× ×”',0),(140277,3897,'el','<b>1-Î­Î³Ï‡ÏÏ‰Î¼Î± Î³ÏÎ±Ï†Î¹ÎºÎ¬:</b> Î‘Î½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„ÏŒÎ½, ÎºÎ±Î»ÎµÎ¯ÏƒÎ¸Îµ Î½Î± Ï€Î±ÏÎ¬ÏƒÏ‡ÎµÏ„Îµ ÎµÏ€Î±ÏÎºÎ® Î´ÎµÎ¯Î³Î¼Î±Ï„Î± Î® ÎºÎ¬Î¼ÎµÏÎ± Î­Ï„Î¿Î¹Î¼Î· Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î±, Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Ï€Î¿Î»Î»Î±Ï€Î»Î­Ï‚ Î³Î¹Î± 11 \"x 1',0),(140278,3897,'zh','çš„<b>å•è‰²ç¨¿ï¼šå¦‚æžœå¯èƒ½ï¼Œè¯·æä¾›æ ·å“æˆ–ç›¸æœºå‡†å¤‡è¶³å¤Ÿçš„å‰¯æœ¬ä¸Šè®¾ç½®å¤šä¸ª11â€œx17â€œæˆ–8.5â€œx14â€œã€‚è¿™åŠ å¿«äº†æˆ‘ä»¬çš„ç³»ç»Ÿï¼Œä½¿æ‚¨çš„è®¢å•\r\n',0),(140279,3897,'sv','<b>1-fÃ¤rg konstverk:</b> Om mÃ¶jligt, ge tillrÃ¤ckligt prover eller kameran redo kopior att inrÃ¤tta flera pÃ¥ 11 \"x 17\" eller 8,5 \"x 14\".  Detta snabbar upp vÃ¥ra system som tillÃ¥ter din bestÃ¤llning att skickas snabbare.',0),(140280,3897,'it','<b>1-colore opera d\'arte:</b> Se possibile, fornire abbastanza campioni o copie pronto telecamera per impostare multiple su 11 \"x 17\" o 8,5 \"x 14\".  Questo accelera il nostro sistema che permette il tuo ordine a spedire fuori piÃ¹ rapidamente.',0),(140281,3897,'tl','',0),(140282,3897,'th','<b>1-Color Artwork:</b> If possible, please provide enough samples or camera ready copies to set multiple up on 11\"x17\" or 8.5\"x14\".  This speeds up our system which allows your order to ship out quicker.',0),(140283,3897,'hi','<b>1-à¤°à¤‚à¤— à¤•à¤²à¤¾à¤•à¥ƒà¤¤à¤¿:</b> à¤¯à¤¦à¤¿ à¤¸à¤‚à¤­à¤µ à¤¹à¥‹ à¤¤à¥‹, à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤°à¥à¤¯à¤¾à¤ªà¥à¤¤ à¤¨à¤®à¥‚à¤¨à¥‹à¤‚ à¤¯à¤¾ à¤à¤•à¤¾à¤§à¤¿à¤• 11 \"x 17\" à¤¯à¤¾ 8.5 \"x 14\" à¤ªà¤° à¤¸à¥‡à¤Ÿ à¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥ˆà',0),(140284,3897,'ms','<b>Karya seni warna-1:</b> Jika boleh, sila berikan cukup sampel atau kamera sedia salinan untuk menyediakan pelbagai 11 \"x 17\" atau 8.5 \"x 14\".  Ini mempercepatkan sistem kita yang membolehkan pesanan anda untuk menghantar lebih cepat.',0),(140285,3897,'ar','<b>1-Ù„ÙˆÙ† Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ÙÙ†ÙŠ:</b> Ø¥Ø°Ø§ ÙƒØ§Ù† Ø°Ù„Ùƒ Ù…Ù…ÙƒÙ†Ø§Ù‹ØŒ ÙŠØ±Ø¬Ù‰ ØªÙ‚Ø¯ÙŠÙ… Ù…Ø§ ÙŠÙƒÙÙŠ Ù…Ù† Ø¹ÙŠÙ†Ø§Øª Ø£Ùˆ Ù†Ø³Ø® Ø§Ù„ÙƒØ§Ù…ÙŠØ±Ø§ Ø¬Ø§Ù‡Ø²Ø© Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ù…ØªØ¹Ø¯Ø¯Ø© Ø¹Ù„Ù‰ 11 \"x 17\" Ø£Ùˆ \"8.5 Ã— 14 Ø¨ÙˆØµØ©.  ÙˆÙ‡Ø°Ø§ ÙŠØ³Ø±Ø¹ Ù†',0),(140286,3897,'fr','<b>Oeuvre 1-couleur :</b> Si possible, veuillez fournir suffisamment Ã©chantillons ou copies prÃªt appareil photo installÃ© multiple sur 11 Â« x 17 Â» ou 8,5 Â« x 14 Â».  Cela accÃ©lÃ¨re notre systÃ¨me qui permet Ã  votre commande Ã  expÃ©dier plus vite.',0),(140287,3897,'jp','<b>1-Color Artwork:</b> If possible, please provide enough samples or camera ready copies to set multiple up on 11\"x17\" or 8.5\"x14\".  This speeds up our system which allows your order to ship out quicker.',0),(140288,3897,'pt','<b>Arte-final 1-cor:</b> Se possÃ­vel, forneÃ§a bastante amostras ou cÃ³pias pronto de cÃ¢mera para configurar mÃºltiplos em 11 \"x 17\" ou 8,5 \"x 14\".  Isso acelera o nosso sistema que permite a sua ordem para enviar para fora mais rapidamente.',0),(140289,3897,'ru','<b>1-Ñ†Ð²ÐµÑ‚Ð½Ñ‹Ðµ Ð¸Ð»Ð»ÑŽÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸:</b> Ð•ÑÐ»Ð¸ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð¿Ñ€Ð¸Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ñ‚Ð¾Ñ‡Ð½Ð¾ Ð¾Ð±Ñ€Ð°Ð·Ñ†Ð¾Ð² Ð¸Ð»Ð¸ Ð³Ð¾Ñ‚Ð¾Ð²Ñ‹Ñ… ÐºÐ¾Ð¿Ð¸Ð¹ ÐºÐ°Ð¼ÐµÑ€Ñ‹ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð½Ð° 11 Â«x 17Â» Ð¸Ð»Ð¸ 8,5 \"x 14\".  Ð',0),(140290,3897,'es','<b>1-Dibujos en Color:</b> Si es posible, por favor proporcionar suficientes muestras o cÃ³pias listas para fotografÃ­a para imprimir multiples de 11\"x17\" o 8.5\"x14\". Esta acciÃ³n aclera su orden para enviar mÃ¡s rÃ¡pido',0),(140291,3897,'de','<b>1-Farben-Artwork:</b> Wenn mÃ¶glich, bitte geben Sie genÃ¼gend Proben oder die Frist zur Einreichung der Multiple auf 11 \"x 17\" oder 8,5 \"x 14\" einzurichten.  Dies beschleunigt unser System, wodurch Ihre Bestellung schneller ausliefern kÃ¶nnen.',0),(140292,3897,'en','<b>1-Color Artwork:</b> If possible, please provide enough samples or camera ready copies to set multiple up on 11\"x17\" or 8.5\"x14\".  This speeds up our system which allows your order to ship out quicker.',0),(140293,3898,'is','',0),(140294,3898,'dr','- Ù†ÙƒØ§Øª ÙˆÙŠÚ˜Ù‡ Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø¯Ùˆ Ø±Ù†Ú¯: ÙƒØ§Ø±Ù‡Ø§ÙŠ Ù‡Ù†Ø±ÙŠ Ø¨Ø§ÙŠØ¯ Ø¢Ù…Ø§Ø¯Ù‡ Ú†Ø§Ù¾ Ø¨Ø§Ø´Ù†Ø¯-Ø±Ù†Ú¯ ØªÙÙƒÙŠÙƒ Ø´Ø¯Ù‡ Ùˆ ØªÙ†Ø¸ÙŠÙ… Ø´ÙˆØ¯ Ø¨Ù‡ ØªØ¹Ø¯Ø§Ø¯ Ø²ÙŠØ§Ø¯ Ø·Ø¨Ù‚',0),(140295,3898,'pr','Ù†ÙƒØ§Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¯Ùˆ Ø±Ù†Ú¯- Ù†ÙƒØ§Øª ÙˆÙŠÚ˜Ù‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ùˆ Ø±Ù†Ú¯: ÙƒØ§Ø±Ù‡Ø§ÙŠ Ù‡Ù†Ø±ÙŠ Ø¨Ø§ÙŠØ¯ Ø¢Ù…Ø§Ø¯Ù‡ Ú†Ø§Ù¾ Ø¨Ø§Ø´Ù†Ø¯-Ø±Ù†Ú¯ ØªÙÙƒÙŠÙƒ Ø´Ø¯Ù‡ Ùˆ ØªÙ†Ø¸ÙŠÙ… Ø´ÙˆØ¯ Ø¨Ù‡ ØªØ¹Ø¯Ø§Ø¯ Ø²ÙŠØ§Ø¯ Ø·Ø¨Ù‚\r\n8.5\"x11\", 8.5',0),(140296,3898,'tr','<b>2-renk sipariÅŸleri iÃ§in Ã¶zel notlar:</b> Resimleri kamera hazÄ±r, renk ayrÄ±lmÄ±ÅŸ ve Ã§ok olarak 8.5 \"x 11\", 8,5 \"x 14\" veya 11 \"x 17\" kompozisyon Ã¶nlemek iÃ§in ayarlamak masraf saÄŸlanmalÄ±dÄ±r.  Bu formu sÄ±kÄ± kayÄ±t olmadan yukarÄ±da seÃ§tiÄŸi',0),(140297,3898,'pl','<b>Specjalne uwagi dotyczÄ…ce zamÃ³wienia 2-kolor:</b> Grafika musi posiadaÄ‡ aparat fotograficzny gotowy, kolor oddzielone i ustawiÄ‡ tyle na 8,5 \"x 11\", 8.5 \"x 14\" i 11 \"x 17\" aby uniknÄ…Ä‡ skÅ‚ad opÅ‚at.  Ten formularz jest notowane bez rejestracji moc',0),(140298,3898,'bg','<b>Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ 2-Ñ†Ð²ÑÑ‚:</b> ÐŸÑ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð¸Ñ Ð½Ð° Ð¸Ð·ÐºÑƒÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð° ÐºÐ°Ð¼ÐµÑ€Ð° Ð³Ð¾Ñ‚Ð¾Ð², Ñ†Ð²ÑÑ‚ Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸ Ð¸ ÐºÐ¾Ð»ÐºÐ¾Ñ‚Ð¾ ÑÐµ Ð¼Ð',0),(140299,3898,'ur','<b>2-Ø±Ù†Ú¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ø®ØµÙˆØµÛŒ Ù†ÙˆÙ¹:</b> Ø¢Ø±Ù¹ ÙˆØ±Ú© Ú©ÛŒÙ…Ø±Û’ Ø±Ù†Ú¯ Ø¹Ù„ÛŒØ­Ø¯Û Ú©Ø± Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø¨ÛØª Ø³Û’ 8.5 \"x 11\" ØŒ 8.5 \"x 14\" ØŒ ÛŒØ§ 11 \"x 17\" Ù¾Ø± Ø³Ø§Ø®Øª Ø³Û’ Ø¨Ú†Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Û’ Ù„ÛŒÛ’ Øª',0),(140300,3898,'sr','<b>ÐŸÐ¾ÑÐµÐ±Ð½Ðµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð·Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ 2-Ð±Ð¾Ñ˜Ð°:</b> Ð¦Ñ€Ñ‚ÐµÐ¶ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾Ð´ ÑƒÑÐ»Ð¾Ð²Ð¾Ð¼ Ð´Ð° ÐºÐ°Ð¼ÐµÑ€Ð° Ñ˜Ðµ ÑÐ¿Ñ€ÐµÐ¼Ð½Ð°, Ð±Ð¾Ñ˜Ð° Ñ€Ð°Ð·Ð´Ð²Ð¾Ñ˜ÐµÐ½Ðµ Ð¸ Ð¿Ð¾Ð´ÐµÑÐ¸Ñ‚Ð¸ ÐºÐ°Ð¾ Ð¼Ð½Ð¾Ð³Ð¸ Ð½Ð° 8.5 \"x 11\", 8.5 \"',0),(140301,3898,'vi','<b>ChÃº Ã½ Ä‘áº·c biá»‡t cho máº«u thiáº¿t káº¿ hai máº§u:</b> Máº«u thiáº¿t káº¿ pháº£i sáºµn sÃ ng cho camera, phÃ¢n máº§u vÃ  theo kÃ­ch cá»¡ 8.5\"x11\", 8.5\"x14\", hay 11\"x17\" Ä‘á»ƒ trÃ¡nh phÃ­ káº¿t há»£p.  Máº«u nÃ y bÃ¡o giÃ¡ chÆ°a Ä‘Äƒng kÃ½ trá»« kh',0),(140302,3898,'af','<b>Spesiale Notas vir 2-Kleur Bestellings:</b> Artwork moet kamera-gereed verskaf word, aparte kleur moet gestel word en soveel moontlik moet op 8.5\"x11\", 8.5\"x14\", or 11\"x17\" gepas word om saamstellingsveranderinge te vermy.  Hierdie vorm is aangehaal so',0),(140303,3898,'ro','<b>Note speciale pentru 2 culori comenzi:</b> Opera de arta, trebuie prevÄƒzute camera gata, culoare separate ÅŸi a Ã®nfiinÅ£at ca multe 8.5 \"x 11\", 8.5 \"x 14\" sau 11 \"x 17\" pentru a evita compoziÅ£ia taxe.  Acest formular este citat fÄƒrÄƒ Ã®nregistrare ',0),(140304,3898,'et','<b>KahevÃ¤rviline tellimuste mÃ¤rkusi:</b> Kunstiteoseid tuleb esitada kaamera valmis vÃ¤rvi eraldatud ja seadistada nii palju 8,5 \"x 11\", 8,5 \"x 14\" vÃµi 11 \"x 17\" vÃ¤ltida koostise tasud.  Sellel vormil on noteeritud tihe registreeringuta kui eespool mÃ',0),(140305,3898,'si','<b>Posebne opombe za 2-barvna naroÄila:</b> Umetnine, predloÅ¾iti kamera pripravljena, barva loÄeni in nastavite toliko na 8,5 \"x 11\", 8,5 \"x 14\" ali 11 \"x 17\" da bi se izognili sestavo stroÅ¡kov.  Ta obrazec izrazimo brez tesen registracije, razen Äe ',0),(140306,3898,'ba','<b>Catatan khusus untuk pesanan 2-warna:</b> Karya seni harus disediakan kamera siap, warna dipisahkan dan mengatur sebanyak di 8.5 \"x 11\", 8.5 \"x 14\" atau 11 \"x 17\" untuk menghindari komposisi biaya.  Formulir ini dikutip tanpa registrasi ketat kecuali j',0),(140307,3898,'nl','<b>Speciale notities voor 2-Color bestellingen:</b> Illustratie moet worden verstrekt camera klaar, kleur gescheiden en ingesteld als veel op 8,5 \"x 11\", 8,5 \"x 14\" of 11 \"x 17\" om te voorkomen dat samenstelling kosten.  Dit formulier wordt geciteerd zond',0),(140308,3898,'fi','<b>2-vÃ¤ri tilauksia koskevia erityishuomautuksia:</b> Kuvitus on annettava kamera valmiina vÃ¤ri erottaa ja perustaa niin monta 8,5 \"x 11\" 8,5 \"x 14\" tai 11 \"x 17\" vÃ¤lttÃ¤Ã¤ koostumus maksuja.  TÃ¤mÃ¤n lomakkeen on lainattu tiukka rekisterÃ¶itymÃ¤ttÃ¤, ',0),(140309,3898,'no','<b>Spesielle merknader for to farger bestillinger:</b> Kunstverk mÃ¥ angis kameraet klart, fargen skilt og satt sÃ¥ mange opp pÃ¥ 8,5 \"x 11\" 8,5 \"x 14\" eller 11 x 17-tommers for Ã¥ unngÃ¥ komposisjon kostnader.  Dette skjemaet er en uten stramme registrer',0),(140310,3898,'da','<b>SÃ¦rlige noter for 2-Color ordrer:</b> Illustrationen skal gives kameraet klar, farve adskilt og sÃ¦tte sÃ¥ mange op pÃ¥ 8,5 \"x 11\", 8,5 \"x 14\" eller 11 \"x 17\" for at undgÃ¥ sammensÃ¦tning afgifter.  Denne form er citeret uden stramme registrering, hvi',0),(140311,3898,'ko','<b>2 ìƒ‰ìƒ ìˆœì„œë¥¼ ìœ„í•œ íŠ¹ë³„ í•œ ë…¸íŠ¸:</b> ì•„íŠ¸ ì›Œí¬ëŠ” ì¹´ë©”ë¼ ìƒ‰ìƒ êµ¬ë¶„ ë° ì„¤ì • ë§Œí¼ 8.5 \"x 11\", 8.5 \"x 14\", ë˜ëŠ” 11 \"x 17\" êµ¬ì„± í•˜ì§€ ì•Šìœ¼ë ¤ë©´ ì¤€ë¹„ ìš”ê¸ˆ ì œê³µ ë˜ì–´ì•¼ í•©ë‹ˆë‹¤.  ìœ„ì—ì„œ ì„ íƒ ë˜ì§€ ì•Šì€ ê²',0),(140312,3898,'he','<b>×¤×ª×§×™× ×ž×™×•×—×“×™× ×œ×ž×–×ž×™× ×™× 2-×¦×‘×¢:</b> ×”×’×¨×¤×™×§×” ×—×™×™×‘ ×œ×”×™× ×ª×Ÿ ×—×™×•×‘×™× ×”×ž×¦×œ×ž×” ×ž×•×›× ×”, ×¦×‘×¢ ×ž×•×¤×¨×“×™× ×•×œ×”×’×“×™×¨ ×›×ž×” ×©×™×•×ª×¨ 8.5 \"x 11 ××™× ×¥ \', 8.5\" x 14\" ××• 11\" x 17\" ×›×“×™ ×œ×ž× ×•×¢',0),(140313,3898,'el','<b>Î•Î¹Î´Î¹ÎºÎ­Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ 2-Ï‡ÏÏŽÎ¼Î±:</b> ÎˆÏÎ³Î¿ Ï„Î­Ï‡Î½Î·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€Î±ÏÎ­Ï‡Î¿Î½Ï„Î±Î¹ ÎºÎ¬Î¼ÎµÏÎ± Î­Ï„Î¿Î¹Î¼Î·, Î½Î± Ï‡ÏÏŽÎ¼Î± Î´Î¹Î±Ï‡Ï‰ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹ ÎºÎ±Î¹ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ ',0),(140314,3898,'zh','çš„<b>ä¸“ç”¨åŒè‰²è®¢å•å¤‡æ³¨ï¼šä½œå“å¿…é¡»æä¾›ç›¸æœºå‡†å¤‡å¥½ï¼Œé¢œè‰²åˆ†å¼€ï¼Œå°½å¯èƒ½å¤šä¸Š8.5â€œçš„X11â€œï¼Œ8.5â€œx14â€œæˆ–11â€œx17â€œï¼Œä»¥é¿å…è´¹ç”¨ç»„æˆä¸€å¥—ã€‚è¿™ç§å½¢å¼æ˜¯æ²¡æœ‰ç´§æ³¨å†Œï¼Œé™¤éžå¼•ç”¨ä¸Šé¢é€‰æ‹©ã€‚\r\n',0),(140315,3898,'sv','<b>FÃ¶r 2-fÃ¤rg bestÃ¤llningar:</b> Teckningen mÃ¥ste ges kameran redo, fÃ¤rg separeras och stÃ¤lla sÃ¥ mÃ¥nga upp pÃ¥ 8,5 \"x 11\", 8,5 \"x 14\" eller 11 \"x 17\" fÃ¶r att undvika sammansÃ¤ttning avgifter.  Denna form citeras utan trÃ¥nga registrering om inte ',0),(140316,3898,'it','<b>Note particolari per ordini di 2 colori:</b> Opera d\'arte Ã¨ necessario prevedere spese fotocamera pronta, colore separati e imposta come molti 8,5 \"x 11\", 8.5 \"x 14\" o 11 \"x 17\" per evitare la composizione.  Questa forma Ã¨ citata senza registrazione ',0),(140317,3898,'tl','',0),(140318,3898,'th','<b>Special Notes for 2-Color Orders:</b> Artwork must be provided camera ready, color separated and set as many up on 8.5\"x11\", 8.5\"x14\", or 11\"x17\" to avoid composition charges.  This form is quoted without tight registration unless selected above.',0),(140319,3898,'hi','<b>2-à¤°à¤‚à¤— à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤¶à¥‡à¤· à¤¨à¥‹à¤Ÿ:</b> à¤•à¤²à¤¾à¤•à¥ƒà¤¤à¤¿ à¤•à¥ˆà¤®à¤°à¤¾ à¤¤à¥ˆà¤¯à¤¾à¤°, à¤°à¤‚à¤— à¤…à¤²à¤— à¤¹à¥‹ à¤”à¤° à¤•à¤ˆ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ 8.5 \"x 11\", 8.5 \"x 14\" à¤¯à¤¾ 11 \"x 17\" à¤ªà¤° à¤°à¤šà¤¨',0),(140320,3898,'ms','<b>Nota-Nota khas untuk Tempahan 2-warna:</b> Karya seni perlu disediakan caj kamera siap, warna yang terpisah dan menyediakan seberapa banyak pada 8.5 \"x 11\", 8.5 \"x 14\" atau 11 \"x 17\" untuk mengelakkan komposisi.  Borang ini dipetik tanpa pendaftaran ke',0),(140321,3898,'ar','<b>Ø§Ù„Ù…Ø°ÙƒØ±Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ù„Ø£ÙˆØ§Ù…Ø± 2-Ø§Ù„Ù„ÙˆÙ†:</b> ÙŠØ¬Ø¨ ØªÙˆÙÙŠØ± Ø±Ø³ÙˆÙ… Ø§Ù„ÙƒØ§Ù…ÙŠØ±Ø§ Ø¬Ø§Ù‡Ø²Ø©ØŒ Ù„ÙˆÙ† ÙØµÙ„ ÙˆØªØ¹ÙŠÙŠÙ† Ø£ÙƒØ¨Ø± Ø¹Ø¯Ø¯ Ù…Ù…ÙƒÙ† Ø¹Ù„Ù‰ \"8.5 Ã— 11 Ø¨ÙˆØµØ©ØŒ 8.5\" Ã— 14 \"Ø£Ùˆ 11\" x 17 \"ØªØ¬Ù†Ø¨ ØªÙƒÙˆÙŠÙ† Ø§Ù„Ø¹',0),(140322,3898,'fr','<b>Des Notes spÃ©ciales pour les commandes de 2 couleurs :</b> Oeuvre prÃ©voir frais de l\'appareil prÃªt, couleur sÃ©parÃ©es et crÃ©Ã© autant sur 8,5 Â« x 11 Â», 8,5 Â« x 14 Â» ou 11 Â« x 17 Â» pour Ã©viter la composition.  Ce formulaire est citÃ© sans in',0),(140323,3898,'jp','<b>Special Notes for 2-Color Orders:</b> Artwork must be provided camera ready, color separated and set as many up on 8.5\"x11\", 8.5\"x14\", or 11\"x17\" to avoid composition charges.  This form is quoted without tight registration unless selected above.',0),(140324,3898,'pt','<b>Notas especiais para encomendas de 2 cores:</b> Arte-final deve ser fornecido acusaÃ§Ãµes de cÃ¢mera pronta, cor separada e configurar como muitos em 8,5 \"x 11\", 8,5 \"x 14\" ou 11 \"x 17\" para evitar a composiÃ§Ã£o.  Este formulÃ¡rio Ã© citado sem regist',0),(140325,3898,'ru','<b>Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² 2-Ñ†Ð²ÐµÑ‚:</b> Ð˜Ð»Ð»ÑŽÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ñ‹ ÐºÐ°Ð¼ÐµÑ€Ñ‹ Ð³Ð¾Ñ‚Ð¾Ð²Ñ‹, Ñ†Ð²ÐµÑ‚Ð° Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ñ‹ Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐºÐ°Ðº Ð¼Ð½Ð¾Ð³Ð¸',0),(140326,3898,'es','<b>Notas Especiales para Ordenes de 2 Colores:<b> Dibujos debe ser proporcionados listos para fotografÃ­a, separados por colores y se pone en 8.5\"x11\", 8.5\"x14\",o 11\"x17\" para evitar cargos de composiciÃ³n. Este formulario se cotiza sin registro estricto ',0),(140327,3898,'de','<b>Spezielle Hinweise fÃ¼r 2-Farben-Bestellungen:</b> Bildmaterial Kamera bereit, Farbe getrennt und so viele bis auf 8,5 \"x 11\", 8,5 \"x 14\" oder 11 \"x 17\" um Komposition zu vermeiden GebÃ¼hren vorzusehen.  Dieses Formular ist ohne enge Registrierung sofe',0),(140328,3898,'en','<b>Special Notes for 2-Color Orders:</b> Artwork must be provided camera ready, color separated and set as many up on 8.5\"x11\", 8.5\"x14\", or 11\"x17\" to avoid composition charges.  This form is quoted without tight registration unless selected above.',0),(140329,3899,'is','',0),(140330,3899,'dr','- ØªØ±ÙƒÙŠØ¨ Ùˆ Ø§Ø¬Ø²Ø§Ø¡ Ø§Ù„ØµØ§Ù‚ Ø´Ø¯Ù‡ = 35.00$Ø¯Ø± Ø³Ø§Ø¹Øª( Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø² 6.00$',0),(140331,3899,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ- ØªØ±ÙƒÙŠØ¨ Ùˆ Ø§Ø¬Ø²Ø§Ø¡ Ø§Ù„ØµØ§Ù‚ Ø´Ø¯Ù‡ = 35.00$Ø¯Ø± Ø³Ø§Ø¹Øª( Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø² 6.00$\r\n',0),(140332,3899,'tr','<b>Kompozisyon/YapÄ±ÅŸtÄ±r Up:</b> 35,00 $/ saat (min. fiyat istemek $ 6,00)',0),(140333,3899,'pl','<b>SkÅ‚ad i wkleiÄ‡ do:</b> 35,00 dolarÃ³w na godzinÄ™ (min. za $6.00)',0),(140334,3899,'bg','<b>Ð¡ÑŠÑÑ‚Ð°Ð²/Ð¿Ð°ÑÑ‚Ð° Ð½Ð°Ð³Ð¾Ñ€Ðµ:</b> $ 35,00/Ñ‡Ð°Ñ (Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ñ‚Ð°ÐºÑÐ° Ð¾Ñ‚ $6,00)',0),(140335,3899,'ur','<b>Ø§Ù¾ Ø³Ø§Ø®Øª/Ú†Ø³Ù¾Ø§Úº Ú©Ø± Ø¯ÛŒÚº:</b> ÚˆØ§Ù„Ø± 35.00 Ú¯Ú¾Ù†Ù¹Û’ (Ù…Ù†Ù¹ Ú†Ø§Ø±Ø¬ 6.00 ÚˆØ§Ù„Ø±)',0),(140336,3899,'sr','<b>Ð¡Ð°ÑÑ‚Ð°Ð²/ÐÐ°Ð»ÐµÐ¿Ð¸ Ð³Ð¾Ñ€Ðµ:</b> 35,00 $/ ÑÐ°Ñ‚ (Ð¼Ð¸Ð½. Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ð¾Ð´ $ 6,00)',0),(140337,3899,'vi','<b>ThÃ nh pháº§n/Cáº¯t dÃ¡n:</b> $35.00/giá» (phÃ­ tá»‘i thiá»ƒu lÃ  $6.00)',0),(140338,3899,'af','<b>Samestelling/Paste Up:</b>$35.00/uur (min. fooi van $6.00)',0),(140339,3899,'ro','<b>CompoziÅ£ie/Paste sus:</b> 35.00 dolari pe orÄƒ (min. taxa de $6.00)',0),(140340,3899,'et','<b>Koostis/kleebi Ã¼les:</b> $ 35,00/tund (min. tasu $6.00)',0),(140341,3899,'si','<b>Sestava/Prilepi gor:</b> 35,00 $/ uro (min. stroÅ¡ek $6.00)',0),(140342,3899,'ba','<b>Komposisi/Paste Up:</b> $ 35,00/jam (minimum biaya sebesar $6.00)',0),(140343,3899,'nl','<b>Samenstelling/plakken Up:</b> $35.00/ uur (min. toeslag van $6,00)',0),(140344,3899,'fi','<b>Koostumus/LiitÃ¤ ylÃ¶s:</b> 35,00 dollaria tunnissa (min. vastaan 6,00 dollaria)',0),(140345,3899,'no','<b>Sammensetning/lime opp:</b> $ 35,00/time (min. kostnad pÃ¥ $6.00)',0),(140346,3899,'da','<b>SammensÃ¦tning/Paste op:</b> $ 35,00/time (min. gebyr af $6,00)',0),(140347,3899,'ko','<b>ìµœëŒ€ êµ¬ì„±/ë¶™ì—¬ë„£ê¸°:</b> $35.00/ì‹œê°„ ($6.00ì˜ ë¶„ ìš”ê¸ˆ)',0),(140348,3899,'he','<b>×”×¨×›×‘/×”×“×‘×§ ×œ×ž×¢×œ×”:</b> $35.00/ ×©×¢×” (×ž×™× ×™×ž×œ×™×ª ×ª×©×œ×•× ×©×œ $6.00)',0),(140349,3899,'el','<b>Î£ÏÎ½Î¸ÎµÏƒÎ·/ÎµÏ€Î¹ÎºÏŒÎ»Î»Î·ÏƒÎ· ÎµÏ€Î¬Î½Ï‰:</b> 35,00 Î´Î¿Î»Î¬ÏÎ¹Î±/ÏŽÏÎ± (ÎµÎ»Î¬Ï‡Î¹ÏƒÏ„Î· Ï‡ÏÎ­Ï‰ÏƒÎ· 6,00 Î´Î¿Î»Î¬ÏÎ¹Î±)',0),(140350,3899,'zh','çš„<b>æˆåˆ†/è´´å‡ºæ¥ï¼š$35.00/hourï¼ˆæœ€ä½Žæ”¶è´¹$ 6.00\r\n',0),(140351,3899,'sv','<b>SammansÃ¤ttning/klistra upp:</b> $ 35,00/timme (min. kostnad av $6,00)',0),(140352,3899,'it','<b>Composizione/incolla Up:</b> $ 35,00/ora (min spesa $6,00)',0),(140353,3899,'tl','',0),(140354,3899,'th','<b>Composition/Paste Up:</b> $35.00/hour (min. charge of $6.00)',0),(140355,3899,'hi','<b>à¤°à¤šà¤¨à¤¾/à¤šà¤¿à¤ªà¤•à¤¾à¤à¤ à¤…à¤ª:</b> $35.00/ à¤˜à¤‚à¤Ÿà¤¾ ($6.00 à¤•à¥€ à¤®à¤¿. à¤ªà¥à¤°à¤­à¤¾à¤°)',0),(140356,3899,'ms','<b>Komposisi/Paste sehingga:</b> $ 35,00/jam (minimum caj sebanyak $6.00)',0),(140357,3899,'ar','<b>ØªÙƒÙˆÙŠÙ†/Ù„ØµÙ‚ \"Ø­ØªÙ‰\":</b> 35.00 Ø¯ÙˆÙ„Ø§Ø± Ù„ÙƒÙ„ Ø³Ø§Ø¹Ø© (Ø±Ø³ÙˆÙ… Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† $6.00)',0),(140358,3899,'fr','<b>Composition/coller vers le haut :</b> 35,00 $/ heure (min. des frais de $6.00)',0),(140359,3899,'jp','<b>æ¤?å­—/è²¼è¾¼ã?¿æ ¡äº†ç´™ï¼š<b/>ï¼„35ï¼Ž00/æ™‚é–“ï¼ˆæœ€ä½Žæ–™é‡‘ï¼„6.00ï¼‰',0),(140360,3899,'pt','<b>ComposiÃ§Ã£o/colar acima:</b> $ 35,00/hora (min. taxa de r $6,00)',0),(140361,3899,'ru','<b>Ð¡Ð¾ÑÑ‚Ð°Ð² Ð¸ Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ Ð²Ð²ÐµÑ€Ñ…:</b> $35.00/ Ñ‡Ð°Ñ (Ð¼Ð¸Ð½ Ð¿Ð»Ð°Ñ‚Ð° Ð¾Ñ‚ $6.00)',0),(140362,3899,'es','<b>ComposiciÃ³n/Empastar Arriba:</b>$35.00/hora (cargo mÃ­nimo de $6.00)',0),(140363,3899,'de','<b>Zusammensetzung/Paste oben:</b> $ 35,00/Stunde (min. Aufpreis von $6,00)',0),(140364,3899,'en','<b>Composition/Paste Up:</b> $35.00/hour (min. charge of $6.00)',0),(140365,3900,'is','',0),(140366,3900,'dr','Ø¨Ø±Ø§ÙŠ ØªØ§Ø²Ù‡ ÙƒØ±Ø¯Ù† ØµÙØ­Ù‡ ØªØµÙˆÙŠØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(140367,3900,'pr','Ø¨Ø±Ø§ÙŠ ØªØ§Ø²Ù‡ ÙƒØ±Ø¯Ù† ØµÙØ­Ù‡ ØªØµÙˆÙŠØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(140368,3900,'tr','Yenileme iÃ§in tÄ±klayÄ±n',0),(140369,3900,'pl','Kliknij, aby odÅ›wieÅ¼yÄ‡',0),(140370,3900,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¾Ð±Ð½Ð¾Ð²Ð¸',0),(140371,3900,'ur','Ú©Û’ Ù„Ø¦Û’ Ø±ÛŒÙØ±ÛŒØ´ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(140372,3900,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð ÐµÑ„Ñ€ÐµÑÑ…',0),(140373,3900,'vi','Nháº¥n Ä‘á»ƒ lÃ m má»›i',0),(140374,3900,'af','Kliek om te Verfris',0),(140375,3900,'ro','FaceÅ£i clic pe ReÃ®mprospÄƒtare',0),(140376,3900,'et','KlÃµpsake nuppu VÃ¤rskenda',0),(140377,3900,'si','Kliknite, Äe Å¾elite osveÅ¾iti',0),(140378,3900,'ba','Klik untuk Refresh',0),(140379,3900,'nl','Klik op te vernieuwen',0),(140380,3900,'fi','Valitse PÃ¤ivitÃ¤',0),(140381,3900,'no','Klikk for Ã¥ oppdatere',0),(140382,3900,'da','Klik for at opdatere',0),(140383,3900,'ko','ìƒˆë¡œ ê³ ì¹¨ì„ í´ë¦­ í•©ë‹ˆë‹¤',0),(140384,3900,'he','×œ×—×¥ ×¢×œ ×¨×¢× ×Ÿ',0),(140385,3900,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Ï„Î·Î½ Î±Î½Î±Î½Î­Ï‰ÏƒÎ·',0),(140386,3900,'zh','ç‚¹å‡»åˆ·æ–°\r\n',0),(140387,3900,'sv','Klicka fÃ¶r att uppdatera',0),(140388,3900,'it','Clicca per aggiornare',0),(140389,3900,'tl','',0),(140390,3900,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3619;&#3637;&#3648;&#3615;&#3619;&#3594;',0),(140391,3900,'hi','à¤¤à¤¾à¤œà¤¼à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(140392,3900,'ms','Klik untuk Refresh',0),(140393,3900,'ar','Ø£Ù†Ù‚Ø± Ù„Ù„ØªØ­Ø¯ÙŠØ«',0),(140394,3900,'fr','Cliquer pour actualiser',0),(140395,3900,'jp','æ›´æ–°ã?™ã‚‹',0),(140396,3900,'pt','Clique para atualizar',0),(140397,3900,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(140398,3900,'es','Click para Refrescar',0),(140399,3900,'de','Klicken Sie auf Refresh',0),(140400,3900,'en','Click to Refresh',0),(140401,3901,'is','',0),(140402,3901,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ ',0),(140403,3901,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ ',0),(140404,3901,'tr','fiziksel stok GÃ¼ncelleÅŸtirmesi',0),(140405,3901,'pl','Aktualizacja inwentaryzacji',0),(140406,3901,'bg','Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¾Ñ‚ Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(140407,3901,'ur','Ø³Û’ Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(140408,3901,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¸Ð· Ð¿Ð¾Ð¿Ð¸ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(140409,3901,'vi','cáº­p nháº­t hÃ ng hÃ³a thá»±c táº¿',0),(140410,3901,'af','opdatering vanaf fisiese voorraad',0),(140411,3901,'ro','Update din inventar fizic',0),(140412,3901,'et','Update alates inventuuri',0),(140413,3901,'si','Update iz popisa',0),(140414,3901,'ba','update dari persediaan fisik',0),(140415,3901,'nl','Update van fysieke inventaris',0),(140416,3901,'fi','PÃ¤ivitÃ¤ fyysinen varasto',0),(140417,3901,'no','oppdatere fra vareopptelling',0),(140418,3901,'da','opdatere fra lageropgÃ¸relse',0),(140419,3901,'ko','ì‹¤ì œ ìž¬ê³ ì—ì„œ ì—…ë°ì´íŠ¸',0),(140420,3901,'he','×¢×“×›×•×Ÿ ×©×œ ×”×ž×œ××™ ×”×¤×™×–×™',0),(140421,3901,'el','ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€ÏŒ Ï„Î· Ï†Ï…ÏƒÎ¹ÎºÎ® Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(140422,3901,'zh','ä»Žå®žç‰©ç›˜å­˜æ›´æ–°\r\n',0),(140423,3901,'sv','uppdatering frÃ¥n inventering',0),(140424,3901,'it','aggiornamento dall\'inventario fisico',0),(140425,3901,'tl','',0),(140426,3901,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3592;&#3634;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(140427,3901,'hi','à¤­à¥Œà¤¤à¤¿à¤• à¤¸à¥‚à¤šà¥€ à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(140428,3901,'ms','Kemaskini terakhir dari inventori fizikal',0),(140429,3901,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ« Ù…Ù† Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(140430,3901,'fr','mise Ã  jour de l\'inventaire physique',0),(140431,3901,'jp','æœŸæœ«æ£šå?¸ã?‹ã‚‰æ›´æ–°',0),(140432,3901,'pt','atualizaÃ§Ã£o de inventÃ¡rio fÃ­sico',0),(140433,3901,'ru','Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¸Ð· Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¾Ð¹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(140434,3901,'es','actualizar del inventario fÃ­sica',0),(140435,3901,'de','Update vom Inventur',0),(140436,3901,'en','update from physical inventory',0),(140437,3902,'is','',0),(140438,3902,'dr','Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(140439,3902,'pr','Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(140440,3902,'tr','VeritabanÄ±',0),(140441,3902,'pl','Bazy danych',0),(140442,3902,'bg','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(140443,3902,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ',0),(140444,3902,'sr','Ð‘Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(140445,3902,'vi','Dá»¯ Liá»‡u',0),(140446,3902,'af','Databasis',0),(140447,3902,'ro','Baza de date',0),(140448,3902,'et','Andmebaas',0),(140449,3902,'si','Zbirke podatkov',0),(140450,3902,'ba','Database',0),(140451,3902,'nl','Database',0),(140452,3902,'fi','Tietokanta',0),(140453,3902,'no','Databasen',0),(140454,3902,'da','Database',0),(140455,3902,'ko','ë°ì´í„°ë² ì´ìŠ¤',0),(140456,3902,'he','×ž×¡×“ × ×ª×•× ×™×',0),(140457,3902,'el','Î’Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(140458,3902,'zh','æ•°æ®åº“\r\n',0),(140459,3902,'sv','Databas',0),(140460,3902,'it','Database',0),(140461,3902,'tl','',0),(140462,3902,'th','&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(140463,3902,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸',0),(140464,3902,'ms','Pangkalan data',0),(140465,3902,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª',0),(140466,3902,'fr','Base de donnÃ©es',0),(140467,3902,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹',0),(140468,3902,'pt','Banco de dados',0),(140469,3902,'ru','Ð‘Ð°Ð·Ð° Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(140470,3902,'es','Base de Datos',0),(140471,3902,'de','Datenbank',0),(140472,3902,'en','Database',0),(140473,3903,'is','',0),(140474,3903,'dr','Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡',0),(140475,3903,'pr','Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡',0),(140476,3903,'tr','Sunucu',0),(140477,3903,'pl','Serwer',0),(140478,3903,'bg','Ð¡ÑŠÑ€Ð²ÑŠÑ€',0),(140479,3903,'ur','Ù¾ÛŒØ´ Ú©Ø§Ø±',0),(140480,3903,'sr','Ð¡ÐµÑ€Ð²ÐµÑ€',0),(140481,3903,'vi','MÃ¡y chá»§',0),(140482,3903,'af','Bediener',0),(140483,3903,'ro','Server',0),(140484,3903,'et','Server',0),(140485,3903,'si','StreÅ¾nik',0),(140486,3903,'ba','Server',0),(140487,3903,'nl','Server',0),(140488,3903,'fi','Palvelin',0),(140489,3903,'no','Server',0),(140490,3903,'da','Server',0),(140491,3903,'ko','ì„œë²„',0),(140492,3903,'he','×©×¨×ª',0),(140493,3903,'el','Î”Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î®',0),(140494,3903,'zh','æœåŠ¡å™¨\r\n',0),(140495,3903,'sv','Server',0),(140496,3903,'it','Server',0),(140497,3903,'tl','',0),(140498,3903,'th','&#3648;&#3595;&#3636;&#3615;&#3648;&#3623;&#3629;&#3619;&#3660;',0),(140499,3903,'hi','à¤¸à¤°à¥à¤µà¤°',0),(140500,3903,'ms','Pelayan',0),(140501,3903,'ar','Ø®Ø§Ø¯Ù…',0),(140502,3903,'fr','Serveur',0),(140503,3903,'jp','ã‚µãƒ¼ãƒ?ãƒ¼',0),(140504,3903,'pt','Servidor',0),(140505,3903,'ru','Ð¡ÐµÑ€Ð²ÐµÑ€Ð°',0),(140506,3903,'es','Servidor',0),(140507,3903,'de','Server',0),(140508,3903,'en','Server',0),(140509,3904,'is','',0),(140510,3904,'dr','Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª  Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ ',0),(140511,3904,'pr','Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª  Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ ',0),(140512,3904,'tr','Faturalanan sipariÅŸ YazdÄ±r',0),(140513,3904,'pl','Zapowiadane druku zamÃ³wienia',0),(140514,3904,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(140515,3904,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(140516,3904,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÐµÐ½ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(140517,3904,'vi','ÄÆ¡n Äáº·t HÃ ng In Láº­p HÃ³a ÄÆ¡n',0),(140518,3904,'af','Gefaktuureerde Gedrukte Bestellings',0),(140519,3904,'ro','Facturat ordine de imprimare',0),(140520,3904,'et','Arve trÃ¼kitÃ¶Ã¶de tellimused',0),(140521,3904,'si','ZaraÄunali tiskanje nalogov',0),(140522,3904,'ba','Urutan Cetakan Tagihan Pesanan',0),(140523,3904,'nl','Gefactureerde afdrukken bestellingen',0),(140524,3904,'fi','Tulosta tilaukset laskutetaan',0),(140525,3904,'no','Fakturert bestilling',0),(140526,3904,'da','Faktureret aftryksbestillinger',0),(140527,3904,'ko','ì¸ì‡„ ì£¼ë¬¸ ì²­êµ¬',0),(140528,3904,'he','×”×—×™×•×‘ ×”×“×¤×¡×•×ª',0),(140529,3904,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³ÎµÎ¯Ï„Î±Î¹ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½',0),(140530,3904,'zh','å¸å•æ‰“å°è®¢å•\r\n',0),(140531,3904,'sv','Faktureras Print Order',0),(140532,3904,'it','Ordini Fatturati Stampati',0),(140533,3904,'tl','',0),(140534,3904,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3610;&#3636;&#3621;&#3651;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(140535,3904,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾',0),(140536,3904,'ms','Pesanan cetakan yang dibilkan sebanyak',0),(140537,3904,'ar','ÙÙˆØ§ØªÙŠØ± Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(140538,3904,'fr','Commandes facturÃ©es',0),(140539,3904,'jp','è«‹æ±‚æ¸ˆæ³¨æ–‡',0),(140540,3904,'pt','Ordens de impressÃ£o faturadas',0),(140541,3904,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(140542,3904,'es','Pedidos de ImpresiÃ³n Facturados',0),(140543,3904,'de','DruckauftrÃ¤ge in Rechnung gestellt',0),(140544,3904,'en','Billed Print Orders',0),(140545,3905,'is','',0),(140546,3905,'dr','( Ø¬Ø²Ø¡ Ø¶Ø§ÙŠØ¹Ø§Øª Ù…ÙˆØ§Ø¯ Ø´Ø¯)',0),(140547,3905,'pr','ØµÙØ­Ø§Øª Ø§Ø¶Ø§ÙÙŠ Ø¯ÙˆØ± Ø§Ù†Ø¯Ø§Ø®ØªÙ‡ Ø´Ø¯ ( Ø¬Ø²Ø¡ Ø¶Ø§ÙŠØ¹Ø§Øª Ù…ÙˆØ§Ø¯ Ø´Ø¯)',0),(140548,3905,'tr','Ekstra yaprak hurda',0),(140549,3905,'pl','Dodatkowe arkusze zÅ‚om',0),(140550,3905,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð»Ð¸ÑÑ‚Ð¾Ð²Ðµ ÑÐºÑ€Ð°Ð¿',0),(140551,3905,'ur','Ø§Ø¶Ø§ÙÛŒ Ø´ÛŒÙ¹Ø³ Ø³Ú©Ø±ÛŒÙ¾',0),(140552,3905,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ð»Ð¸ÑÑ‚ ÑˆÐºÐ°Ñ€Ñ‚Ð°',0),(140553,3905,'vi','Pháº¿ liá»‡u trang thÃªm',0),(140554,3905,'af','Bykomende Velle Skrootyster',0),(140555,3905,'ro','Resturi de foi suplimentare',0),(140556,3905,'et','Lisalehed jÃ¤Ã¤gid',0),(140557,3905,'si','Ostanki dodatnih listov',0),(140558,3905,'ba','Tambahan lembar memo',0),(140559,3905,'nl','Extra bladen schroot',0),(140560,3905,'fi','YlimÃ¤Ã¤rÃ¤inen romu',0),(140561,3905,'no','Ekstra ark skrap',0),(140562,3905,'da','Ekstra ark skrot',0),(140563,3905,'ko','ì—‘ìŠ¤íŠ¸ë¼ ì‹œíŠ¸ ìŠ¤í¬ëž©',0),(140564,3905,'he','×’×œ×™×•× ×•×ª × ×•×¡×¤×™× ×’×¨×•×˜××•×ª',0),(140565,3905,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Ï†ÏÎ»Î»Î± Î¸ÏÎ±ÏÏƒÎ¼Î±Ï„Î±',0),(140566,3905,'zh','é¢å¤–åºŸè¡¨\r\n',0),(140567,3905,'sv','Extra lakan skrot',0),(140568,3905,'it','Rottami di fogli supplementari',0),(140569,3905,'tl','',0),(140570,3905,'th','&#3627;&#3609;&#3657;&#3634;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3586;&#3609;&#3634;&#3604;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(140571,3905,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤šà¤¾à¤¦à¤°à¥‡à¤‚ à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª',0),(140572,3905,'ms','Helaian tambahan sekerap',0),(140573,3905,'ar','Ø®Ø±Ø¯Ø© Ø£ÙˆØ±Ø§Ù‚ Ø¥Ø¶Ø§ÙÙŠØ©',0),(140574,3905,'fr','Autres feuilles Scrap',0),(140575,3905,'jp','Extra Sheets Scrap',0),(140576,3905,'pt','Sucata de folhas extra',0),(140577,3905,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð»Ð¸ÑÑ‚Ñ‹ Ð»Ð¾Ð¼Ð°',0),(140578,3905,'es','Hojas Extra Desechas',0),(140579,3905,'de','Weitere BlÃ¤tter Schrott',0),(140580,3905,'en','Extra Sheets Scrap',0),(140581,3906,'is','',0),(140582,3906,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú†Ø§Ù¾ ',0),(140583,3906,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú†Ø§Ù¾ ',0),(140584,3906,'tr','BasÄ±n boyutu',0),(140585,3906,'pl','NaciÅ›nij przycisk rozmiar',0),(140586,3906,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð¿Ñ€ÐµÑÐ°Ñ‚Ð°',0),(140587,3906,'ur','Ù¾Ø±ÛŒØ³ Ø³Ø§Ø¦Ø²',0),(140588,3906,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(140589,3906,'vi','KÃ­ch cá»¡ bÃ¡o ',0),(140590,3906,'af','Druk grootte',0),(140591,3906,'ro','ApÄƒsaÅ£i dimensiunea',0),(140592,3906,'et','Vajutage suurus',0),(140593,3906,'si','Velikost tiska',0),(140594,3906,'ba','Ukuran celana',0),(140595,3906,'nl','Druk op grootte',0),(140596,3906,'fi','Paina kokoa',0),(140597,3906,'no','Trykk stÃ¸rrelse',0),(140598,3906,'da','Tryk pÃ¥ stÃ¸rrelse',0),(140599,3906,'ko','ë³´ë„ í¬ê¸°',0),(140600,3906,'he','×”×§×© ×‘×’×•×“×œ',0),(140601,3906,'el','Î Î±Ï„Î®ÏƒÏ„Îµ Ï„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚',0),(140602,3906,'zh','æ‰“å°å°ºå¯¸\r\n',0),(140603,3906,'sv','Tryck pÃ¥ storlek',0),(140604,3906,'it','Dimensione di stampa',0),(140605,3906,'tl','',0),(140606,3906,'th','&#3585;&#3604;&#3586;&#3609;&#3634;&#3604;',0),(140607,3906,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(140608,3906,'ms','Saiz Seluar',0),(140609,3906,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø­Ø¬Ù…',0),(140610,3906,'fr','Taille de presse',0),(140611,3906,'jp','ãƒ—ãƒ¬ã‚¹ã‚µã‚¤ã‚º',0),(140612,3906,'pt','Tamanho de imprensa',0),(140613,3906,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¿Ñ€ÐµÑÑ',0),(140614,3906,'es','Prensa TamaÃ±o',0),(140615,3906,'de','Presse-GrÃ¶ÃŸe',0),(140616,3906,'en','Press Size',0),(140617,3907,'is','',0),(140618,3907,'dr','Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ ',0),(140619,3907,'pr','Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ ',0),(140620,3907,'tr','GÃ¶rÃ¼nÃ¼m hesabÄ±',0),(140621,3907,'pl','Widok konta',0),(140622,3907,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð¿Ñ€Ð¾Ñ„Ð¸Ð»Ð°',0),(140623,3907,'ur','Ù…Ù†Ø¸Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(140624,3907,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð½Ð°Ð»Ð¾Ð³Ð°',0),(140625,3907,'vi','Xem TK',0),(140626,3907,'af','Besigtig Rekening',0),(140627,3907,'ro','Vezi cont',0),(140628,3907,'et','Vaata staatust',0),(140629,3907,'si','Pogled raÄun',0),(140630,3907,'ba','Lihat Account',0),(140631,3907,'nl','Weergave Account',0),(140632,3907,'fi','NÃ¤ytÃ¤ tili',0),(140633,3907,'no','Vis konto',0),(140634,3907,'da','Se konto',0),(140635,3907,'ko','ë³´ê¸° ê³„ì •',0),(140636,3907,'he','×”×¦×’ ×—×©×‘×•×Ÿ',0),(140637,3907,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(140638,3907,'zh','æŸ¥çœ‹å¸æˆ·\r\n',0),(140639,3907,'sv','Visa konto',0),(140640,3907,'it','Vista Account',0),(140641,3907,'tl','',0),(140642,3907,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(140643,3907,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤–à¤¾à¤¤à¤¾',0),(140644,3907,'ms','Paparan akaun',0),(140645,3907,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(140646,3907,'fr','Afficher le compte',0),(140647,3907,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¦‹ã‚‹',0),(140648,3907,'pt','Ver conta',0),(140649,3907,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÑ‡ÐµÑ‚Ð°',0),(140650,3907,'es','Ver Cuenta',0),(140651,3907,'de','Konto anzeigen',0),(140652,3907,'en','View Account',0),(140653,3908,'is','',0),(140654,3908,'dr','(Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡)',0),(140655,3908,'pr','Ø­Ø³Ø§Ø¨ Ù…Ø¹ÙˆÙ‚ (Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡)',0),(140656,3908,'tr','Vadesi geÃ§miÅŸ hesap',0),(140657,3908,'pl','Konto zalegÅ‚ych',0),(140658,3908,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸',0),(140659,3908,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…ÙˆØ®Ø±',0),(140660,3908,'sr','Ð Ð°Ñ‡ÑƒÐ½ ÑÐ° Ð¿Ñ€ÐµÐºÐ¾Ñ€Ð°Ñ‡ÐµÐ½Ð¸Ð¼ Ñ€Ð¾ÐºÐ¾Ð¼',0),(140661,3908,'vi','TK QuÃ¡ Háº¡n',0),(140662,3908,'af','Agterstallige Rekening',0),(140663,3908,'ro','Cont depasit',0),(140664,3908,'et','Konto viivise mÃ¤Ã¤r',0),(140665,3908,'si','RaÄun zapadlih',0),(140666,3908,'ba','Akun Lewat Batas Waktu',0),(140667,3908,'nl','Achterstallige rekening',0),(140668,3908,'fi','Huomioon myÃ¶hÃ¤ssÃ¤',0),(140669,3908,'no','Konto som er forfalt',0),(140670,3908,'da','Konto forfaldne',0),(140671,3908,'ko','ì—°ì²´ ê³„ì •',0),(140672,3908,'he','×©×œ ×”×—×©×‘×•×Ÿ',0),(140673,3908,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï ÎºÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ®ÏƒÎµÎ¹',0),(140674,3908,'zh','éŽæœŸå¸æˆ·\r\n',0),(140675,3908,'sv','Konto fÃ¶rfallna',0),(140676,3908,'it','Conto in ritardo',0),(140677,3908,'tl','',0),(140678,3908,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(140679,3908,'hi','à¤–à¤¾à¤¤à¤¾ à¤…à¤¤à¤¿à¤¦à¥‡à¤¯',0),(140680,3908,'ms','Akaun lampau tempoh',0),(140681,3908,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(140682,3908,'fr','Compte en souffrance',0),(140683,3908,'jp','æœŸé™?çµŒé?Žå‹˜å®š',0),(140684,3908,'pt','Conta em atraso',0),(140685,3908,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ñ…',0),(140686,3908,'es','Cuenta Atrasada',0),(140687,3908,'de','Konto Ã¼berfÃ¤llig',0),(140688,3908,'en','Account Overdue',0),(140689,3909,'is','',0),(140690,3909,'dr','(Ú†Ø±Ø®Ø´',0),(140691,3909,'pr','ÙƒØ§Ø±  Ùˆ Ù†ÙˆØ¨Øª(Ú†Ø±Ø®Ø´',0),(140692,3909,'tr','Ä°ÅŸ & dÃ¶nÃ¼ÅŸ',0),(140693,3909,'pl','Praca & kolei',0),(140694,3909,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° & Ð·Ð°Ð²Ð¾Ð¹',0),(140695,3909,'ur','Ú©Ø§Ù… & Ø¨Ø§Ø±ÛŒ',0),(140696,3909,'sr','Ð Ð°Ð´ Ð¸ Ñ€ÐµÐ´',0),(140697,3909,'vi','CÃ´ng viá»‡c & LÆ°á»£t',0),(140698,3909,'af','Werk & draai',0),(140699,3909,'ro','Munca & Turn',0),(140700,3909,'et','TÃ¶Ã¶ & Vahetus',0),(140701,3909,'si','Delo & Turn',0),(140702,3909,'ba','Pekerjaan & giliran',0),(140703,3909,'nl','Werk & beurt',0),(140704,3909,'fi','TyÃ¶n & puolestaan',0),(140705,3909,'no','Arbeid & tur',0),(140706,3909,'da','Arbejde & tur',0),(140707,3909,'ko','ìž‘ì—… & ì°¨ë¡€',0),(140708,3909,'he','×”×ª×•×¨ & ×¢×‘×•×“×”',0),(140709,3909,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± & ÏƒÏ„ÏÎ¿Ï†Î®',0),(140710,3909,'zh','å·¥ä½œåŠè½¬å‘\r\n',0),(140711,3909,'sv','Arbete & tur',0),(140712,3909,'it','Turno di lavoro &',0),(140713,3909,'tl','',0),(140714,3909,'th','&#3591;&#3634;&#3609;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;',0),(140715,3909,'hi','à¤•à¤¾à¤® & à¤¬à¤¾à¤°à¥€',0),(140716,3909,'ms','Giliran & kerja',0),(140717,3909,'ar','Ø¯ÙˆØ±Ø© Ø¹Ù…Ù„ Ø¢Ù†Ø¯',0),(140718,3909,'fr','Tour & de travail',0),(140719,3909,'jp','Work & Turn',0),(140720,3909,'pt','Turno de trabalho &',0),(140721,3909,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° & Ð¿Ð¾Ð²Ð¾Ñ€Ð¾Ñ‚',0),(140722,3909,'es','Trabajar y Voltear',0),(140723,3909,'de','Arbeit & Zuges',0),(140724,3909,'en','Work & Turn',0),(140725,3910,'is','',0),(140726,3910,'dr','(Ø¶Ø±Ø±',0),(140727,3910,'pr','ÙƒØ§Ø± Ùˆ Ø´ÙƒØ³Øª(Ø²ÙŠØ§Ù†',0),(140728,3910,'tr','Ä°ÅŸ & Flop',0),(140729,3910,'pl','Praca & Flop',0),(140730,3910,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° & Ñ„Ð»Ð¾Ð¿Ð°',0),(140731,3910,'ur','& Ú©Ø§Ù… Ù†Ú©Ø§Ù…',0),(140732,3910,'sr','ÐŸÐ¾ÑÐ»Ð° & Ð¤Ð»Ð¾Ð¿',0),(140733,3910,'vi','CÃ´ng viá»‡c & tháº¥t báº¡i',0),(140734,3910,'af','Werk & Flop',0),(140735,3910,'ro','Munca & Flop',0),(140736,3910,'et','Work & Flop',0),(140737,3910,'si','Delo & Flop',0),(140738,3910,'ba','Pekerjaan & Flop',0),(140739,3910,'nl','Werk & Flop',0),(140740,3910,'fi','TyÃ¶n & floppi',0),(140741,3910,'no','Arbeid & floppen',0),(140742,3910,'da','Arbejde & Flop',0),(140743,3910,'ko','ìž‘ì—… & í”Œë¡­',0),(140744,3910,'he','×¢×‘×•×“×” & ×¤×œ×•×¤',0),(140745,3910,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± & Flop',0),(140746,3910,'zh','å·¥ä½œä¸Žè·³é«˜\r\n',0),(140747,3910,'sv','Arbete & floppen',0),(140748,3910,'it','Lavoro & Flop',0),(140749,3910,'tl','',0),(140750,3910,'th','&#3591;&#3634;&#3609;&#3649;&#3621;&#3632;&#3588;&#3623;&#3634;&#3617;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(140751,3910,'hi','à¤•à¤¾à¤® & à¤«à¥à¤²à¥‰à¤ª',0),(140752,3910,'ms','Kerja & Flop',0),(140753,3910,'ar','Ø§Ù„ØªØ®Ø¨Ø· Ø¢Ù†Ø¯ ÙÙŠ Ø§Ù„Ø¹Ù…Ù„',0),(140754,3910,'fr','Travail & Flop',0),(140755,3910,'jp','Work & Flop',0),(140756,3910,'pt','Trabalho & Flop',0),(140757,3910,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° & Ñ„Ð»Ð¾Ð¿',0),(140758,3910,'es','Trabajar & Dormir',0),(140759,3910,'de','Arbeit- & -Flop',0),(140760,3910,'en','Work & Flop',0),(140761,3911,'is','',0),(140762,3911,'dr','-ÙƒØ§Ø± Ùˆ Ø´ÙƒØ³Øª / Ú†Ø±Ø®Ø´(ØªØ¨Ø¯ÙŠÙ„',0),(140763,3911,'pr','Ø§ÙƒÙ†ÙˆÙ† Ú†Ø§Ù¾ ÙƒÙ†ÙŠØ¯ -ÙƒØ§Ø± Ùˆ Ø´ÙƒØ³Øª / Ú†Ø±Ø®Ø´(ØªØ¨Ø¯ÙŠÙ„',0),(140764,3911,'tr','Ä°ÅŸ & Flop/kapat',0),(140765,3911,'pl','Praca & Flop/Turn',0),(140766,3911,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° & Ñ„Ð»Ð¾Ð¿Ð°/Ð·Ð°Ð²Ð¾Ð¹',0),(140767,3911,'ur','Ú©Ø§Ù… & Ù†Ú©Ø§Ù…/Ù…ÙˆÚ‘',0),(140768,3911,'sr','ÐŸÐ¾ÑÐ»Ð° & Ð¤Ð»Ð¾Ð¿/Ñ€ÐµÐ´',0),(140769,3911,'vi','CÃ´ng viá»‡c & tháº¥t báº¡i/chuyá»ƒn',0),(140770,3911,'af','Werk & \"Flop/\"Turn\"',0),(140771,3911,'ro','Munca & Flop/Turn',0),(140772,3911,'et','TÃ¶Ã¶ & Flop/omakorda',0),(140773,3911,'si','Delo & Flop/Turn',0),(140774,3911,'ba','Pekerjaan & Flop/giliran',0),(140775,3911,'nl','Werk & Flop/Turn',0),(140776,3911,'fi','TyÃ¶n & floppi/Piilota',0),(140777,3911,'no','Arbeid & floppen/slukke',0),(140778,3911,'da','Arbejde & Flop/Turn',0),(140779,3911,'ko','ìž‘ì—… & í”Œë¡­/ë°©í–¥',0),(140780,3911,'he','×¢×‘×•×“×” & ×¤×œ×•×¤/×”×ª×•×¨',0),(140781,3911,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± & Flop/ÏƒÎµÎ¹ÏÎ¬',0),(140782,3911,'zh','å·¥ä½œå¤±è´¥/å¼€å¯\r\n',0),(140783,3911,'sv','Arbete & Flop/Turn',0),(140784,3911,'it','Lavoro & Flop/Turn',0),(140785,3911,'tl','',0),(140786,3911,'th','&#3591;&#3634;&#3609;&#3649;&#3621;&#3632;&#3588;&#3623;&#3634;&#3617;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;/&#3627;&#3609;&#3657;&#3634;&#3607;&#3637;&#3656;',0),(140787,3911,'hi','à¤•à¤¾à¤® & à¤«à¥à¤²à¥‰à¤ª/à¤®à¥‹à¤¡à¤¼',0),(140788,3911,'ms','Kerja & Flop/pusingan',0),(140789,3911,'ar','Ø¹Ù…Ù„ Ø¢Ù†Ø¯ Ø§Ù„ØªØ®Ø¨Ø·/Ø¯ÙˆØ±Ø©',0),(140790,3911,'fr','Travail & Flop/tour',0),(140791,3911,'jp','Work & Flop/Turn',0),(140792,3911,'pt','Trabalho & Flop/Turn',0),(140793,3911,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° & Ñ„Ð»Ð¾Ð¿Ðµ/Ð¿Ð¾Ð²Ð¾Ñ€Ð¾Ñ‚',0),(140794,3911,'es','Trabajar & Turno',0),(140795,3911,'de','Arbeit & Flop/Turn',0),(140796,3911,'en','Work & Flop/Turn',0),(140797,3912,'is','',0),(140798,3912,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„ ',0),(140799,3912,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„ ',0),(140800,3912,'tr','Ä°ÅŸ #',0),(140801,3912,'pl','Praca #',0),(140802,3912,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚ #',0),(140803,3912,'ur','Ø¬Ø§Ø¨ #',0),(140804,3912,'sr','ÐŸÐ¾ÑÐ°Ð¾ #',0),(140805,3912,'vi','Job sá»‘',0),(140806,3912,'af','Werkstuk#',0),(140807,3912,'ro','Job #',0),(140808,3912,'et','TÃ¶Ã¶ #',0),(140809,3912,'si','Delo #',0),(140810,3912,'ba','Pekerjaan #',0),(140811,3912,'nl','Taak #',0),(140812,3912,'fi','TyÃ¶numero',0),(140813,3912,'no','Jobbnummer',0),(140814,3912,'da','Job #',0),(140815,3912,'ko','ìž‘ì—… #',0),(140816,3912,'he','#×¢×‘×•×“×”',0),(140817,3912,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± #',0),(140818,3912,'zh','å·¥ä½œï¼ƒ\r\n',0),(140819,3912,'sv','Jobb #',0),(140820,3912,'it','Lavoro #',0),(140821,3912,'tl','',0),(140822,3912,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3591;&#3634;&#3609;',0),(140823,3912,'hi','à¤¨à¥Œà¤•à¤°à¥€ #',0),(140824,3912,'ms','Kerja #',0),(140825,3912,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© #',0),(140826,3912,'fr','Job #',0),(140827,3912,'jp','ä»•äº‹ç•ªå?·',0),(140828,3912,'pt','Trabalho #',0),(140829,3912,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ #',0),(140830,3912,'es','Trabajo#',0),(140831,3912,'de','Job-',0),(140832,3912,'en','Job#',0),(140833,3913,'is','',0),(140834,3913,'dr','ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(140835,3913,'pr','ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(140836,3913,'tr','SatÄ±ldÄ±',0),(140837,3913,'pl','Sprzedany',0),(140838,3913,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¸ Ð½Ð°',0),(140839,3913,'ur','ÙØ±ÙˆØ®Øª Ú©Û’ Ù„Ø¦Û’',0),(140840,3913,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ‚Ð¾',0),(140841,3913,'vi','ÄÃ£ bÃ¡n cho',0),(140842,3913,'af','Verkoop Aan',0),(140843,3913,'ro','A vÃ¢ndut',0),(140844,3913,'et','Arve Aadress',0),(140845,3913,'si','Prodana',0),(140846,3913,'ba','Dijual kepada',0),(140847,3913,'nl','Verkocht aan',0),(140848,3913,'fi','MyydÃ¤Ã¤n',0),(140849,3913,'no','Solgt til',0),(140850,3913,'da','Solgt til',0),(140851,3913,'ko','ì— ê²Œ íŒë§¤',0),(140852,3913,'he','× ×ž×›×¨ ×œ',0),(140853,3913,'el','Î Ï‰Î»Î¿ÏÎ½Ï„Î±Î¹',0),(140854,3913,'zh','å‡ºå”®ç»™\r\n',0),(140855,3913,'sv','SÃ¤ljs till',0),(140856,3913,'it','Venduto a',0),(140857,3913,'tl','',0),(140858,3913,'th','&#3586;&#3634;&#3618;&#3652;&#3611;&#3618;&#3633;&#3591;',0),(140859,3913,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥‡à¤š à¤¦à¤¿à¤¯à¤¾',0),(140860,3913,'ms','Dijual kepada',0),(140861,3913,'ar','ØªØ¨Ø§Ø¹ Ø¥Ù„Ù‰',0),(140862,3913,'fr','Vendu Ã ',0),(140863,3913,'jp','è²©å£²å…ˆ',0),(140864,3913,'pt','Vendida para',0),(140865,3913,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð½Ð¾',0),(140866,3913,'es','Vendido A',0),(140867,3913,'de','Verkauft an',0),(140868,3913,'en','Sold To',0),(140869,3914,'is','',0),(140870,3914,'dr','ÙØ±Ù… ',0),(140871,3914,'pr','ÙØ±Ù… ',0),(140872,3914,'tr','Formu',0),(140873,3914,'pl','Formularz',0),(140874,3914,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€',0),(140875,3914,'ur','Ø´Ú©Ù„',0),(140876,3914,'sr','ÐžÐ±Ñ€Ð°Ð·Ð°Ñ†',0),(140877,3914,'vi','Tá»«',0),(140878,3914,'af','Vorm',0),(140879,3914,'ro','Forma',0),(140880,3914,'et','Vorm',0),(140881,3914,'si','Obrazec',0),(140882,3914,'ba','Formulir',0),(140883,3914,'nl','Formulier',0),(140884,3914,'fi','Lomake',0),(140885,3914,'no','Skjemaet',0),(140886,3914,'da','Form',0),(140887,3914,'ko','ì–‘ì‹',0),(140888,3914,'he','×˜×•×¤×¡',0),(140889,3914,'el','ÎœÎ¿ÏÏ†Î®',0),(140890,3914,'zh','è¡¨æ ¼\r\n',0),(140891,3914,'sv','Form',0),(140892,3914,'it','Modulo',0),(140893,3914,'tl','',0),(140894,3914,'th','&#3649;&#3610;&#3610;&#3615;&#3629;&#3619;&#3660;&#3617;',0),(140895,3914,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤°',0),(140896,3914,'ms','Borang',0),(140897,3914,'ar','Ø§Ù„Ù†Ù…ÙˆØ°Ø¬',0),(140898,3914,'fr','Formulaire',0),(140899,3914,'jp','ãƒ•ã‚©ãƒ¼ãƒ ',0),(140900,3914,'pt','FormulÃ¡rio',0),(140901,3914,'ru','ÐžÑ‚',0),(140902,3914,'es','Formulario',0),(140903,3914,'de','Formular',0),(140904,3914,'en','Form',0),(140905,3915,'is','',0),(140906,3915,'dr','Ø§Ø«Ø± Ù‡Ù†Ø±ÙŠ',0),(140907,3915,'pr','Ø§Ø«Ø± Ù‡Ù†Ø±ÙŠ',0),(140908,3915,'tr','Sanat',0),(140909,3915,'pl','Grafika',0),(140910,3915,'bg','ÐŸÑ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð¸Ñ Ð½Ð° Ð¸Ð·ÐºÑƒÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(140911,3915,'ur','Ø¢Ø±Ù¹ ÙˆØ±Ú©',0),(140912,3915,'sr','Ð¦Ñ€Ñ‚ÐµÐ¶',0),(140913,3915,'vi','Máº«u Thiáº¿t Káº¿',0),(140914,3915,'af','Kunswerk',0),(140915,3915,'ro','Opera de arta',0),(140916,3915,'et','Kunstilooming',0),(140917,3915,'si','Umetnine',0),(140918,3915,'ba','Karya seni',0),(140919,3915,'nl','Illustraties',0),(140920,3915,'fi','Taidetta',0),(140921,3915,'no','Kunstverk',0),(140922,3915,'da','Illustrationer',0),(140923,3915,'ko','ì•„íŠ¸ ì›Œí¬',0),(140924,3915,'he','×’×¨×¤×™×§×”',0),(140925,3915,'el','ÎˆÏÎ³Î¿ Ï„Î­Ï‡Î½Î·Ï‚',0),(140926,3915,'zh','è‰ºæœ¯å“\r\n',0),(140927,3915,'sv','Konstverk',0),(140928,3915,'it','Opera d\'arte',0),(140929,3915,'tl','',0),(140930,3915,'th','&#3591;&#3634;&#3609;&#3624;&#3636;&#3621;&#3611;&#3632;',0),(140931,3915,'hi','à¤•à¤²à¤¾à¤•à¥ƒà¤¤à¤¿',0),(140932,3915,'ms','Karya seni',0),(140933,3915,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ÙÙ†ÙŠ',0),(140934,3915,'fr','Oeuvre',0),(140935,3915,'jp','ã‚¢ãƒ¼ãƒˆãƒ¯ãƒ¼ã‚¯',0),(140936,3915,'pt','Arte-final',0),(140937,3915,'ru','Ð˜Ð»Ð»ÑŽÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸',0),(140938,3915,'es','IlustraciÃ³n',0),(140939,3915,'de','Bildmaterial',0),(140940,3915,'en','Artwork',0),(140941,3916,'is','',0),(140942,3916,'dr','Ø¢Ù…Ø§Ø¯Ù‡ ÙÙŠÙ„Ù…Ø¨Ø±Ø¯Ø§Ø±ÙŠ',0),(140943,3916,'pr','Ø¢Ù…Ø§Ø¯Ù‡ ÙÙŠÙ„Ù…Ø¨Ø±Ø¯Ø§Ø±ÙŠ',0),(140944,3916,'tr','Kamera hazÄ±r',0),(140945,3916,'pl','Gotowy aparat',0),(140946,3916,'bg','ÐšÐ°Ð¼ÐµÑ€Ð° Ð³Ð¾Ñ‚Ð¾Ð²',0),(140947,3916,'ur','Ú©ÛŒÙ…Ø±Û ØªÛŒØ§Ø±',0),(140948,3916,'sr','ÐšÐ°Ð¼ÐµÑ€Ð° ÑÐ¿Ñ€ÐµÐ¼Ð½Ð°',0),(140949,3916,'vi','Camera sáºµn sÃ ng',0),(140950,3916,'af','Kamera is Gereed',0),(140951,3916,'ro','Aparat de fotografiat gata',0),(140952,3916,'et','Kaamera valmis',0),(140953,3916,'si','Fotoaparat pripravljen',0),(140954,3916,'ba','Kamera siap',0),(140955,3916,'nl','Camera klaar',0),(140956,3916,'fi','Kamera valmiina',0),(140957,3916,'no','Kameraet klar',0),(140958,3916,'da','Kameraet klar',0),(140959,3916,'ko','ì¹´ë©”ë¼ ì¤€ë¹„',0),(140960,3916,'he','×”×ž×¦×œ×ž×” ×ž×•×›× ×”',0),(140961,3916,'el','ÎšÎ¬Î¼ÎµÏÎ± Î­Ï„Î¿Î¹Î¼Î·',0),(140962,3916,'zh','ç›¸æœºå‡†å¤‡\r\n',0),(140963,3916,'sv','Kameran redo',0),(140964,3916,'it','Macchina fotografica pronta',0),(140965,3916,'tl','',0),(140966,3916,'th','&#3585;&#3621;&#3657;&#3629;&#3591;&#3614;&#3619;&#3657;&#3629;&#3617;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(140967,3916,'hi','à¤•à¥ˆà¤®à¤°à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¯à¤¾à¤°',0),(140968,3916,'ms','Sedia kamera',0),(140969,3916,'ar','Ø§Ù„ÙƒØ§Ù…ÙŠØ±Ø§ Ø¬Ø§Ù‡Ø²Ø©',0),(140970,3916,'fr','Appareil prÃªt',0),(140971,3916,'jp','ã‚«ãƒ¡ãƒ©æº–å‚™æ¸ˆ',0),(140972,3916,'pt','CÃ¢mera pronta',0),(140973,3916,'ru','ÐšÐ°Ð¼ÐµÑ€Ñ‹ Ð³Ð¾Ñ‚Ð¾Ð²Ñ‹',0),(140974,3916,'es','Camera Lista',0),(140975,3916,'de','Kamera-Ready',0),(140976,3916,'en','Camera Ready',0),(140977,3917,'is','',0),(140978,3917,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ ',0),(140979,3917,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ ',0),(140980,3917,'tr','TalimatlarÄ±',0),(140981,3917,'pl','Instrukcje',0),(140982,3917,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(140983,3917,'ur','ÛØ¯Ø§ÛŒØ§Øª',0),(140984,3917,'sr','Ð£Ð¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(140985,3917,'vi','Chá»‰ dáº«n',0),(140986,3917,'af','Instruksies',0),(140987,3917,'ro','InstrucÅ£iuni',0),(140988,3917,'et','Juhised',0),(140989,3917,'si','Navodila',0),(140990,3917,'ba','Petunjuk',0),(140991,3917,'nl','Instructies',0),(140992,3917,'fi','Ohjeet',0),(140993,3917,'no','Instruksjoner',0),(140994,3917,'da','Instruktioner',0),(140995,3917,'ko','ì§€ì¹¨',0),(140996,3917,'he','×”×•×¨××•×ª',0),(140997,3917,'el','ÎŸÎ´Î·Î³Î¯ÎµÏ‚',0),(140998,3917,'zh','è¯´æ˜Ž\r\n',0),(140999,3917,'sv','Instruktioner',0),(141000,3917,'it','Istruzioni',0),(141001,3917,'tl','',0),(141002,3917,'th','&#3623;&#3636;&#3608;&#3637;&#3651;&#3594;&#3657;',0),(141003,3917,'hi','à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(141004,3917,'ms','Arahan',0),(141005,3917,'ar','Ø£Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(141006,3917,'fr','Instructions',0),(141007,3917,'jp','ã‚¤ãƒ³ã‚¹ãƒˆãƒ©ã‚¯ã‚·ãƒ§ãƒ³',0),(141008,3917,'pt','InstruÃ§Ãµes',0),(141009,3917,'ru','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(141010,3917,'es','Instrucciones',0),(141011,3917,'de','Anweisungen',0),(141012,3917,'en','Instructions',0),(141013,3918,'is','',0),(141014,3918,'dr','Ø­Ø±ÙˆÙÚ†ÙŠÙ†',0),(141015,3918,'pr','Ø­Ø±ÙˆÙÚ†ÙŠÙ†',0),(141016,3918,'tr','Dizgici',0),(141017,3918,'pl','SkÅ‚adacz',0),(141018,3918,'bg','Ð¡Ð»Ð¾Ð²Ð¾ÑÐ»Ð°Ð³Ð°Ñ‚ÐµÐ»',0),(141019,3918,'ur','Ù¹ÛŒÙ¾ÛŒØ³ÛŒÙ¹Ø±',0),(141020,3918,'sr','Ð¡Ð»Ð¾Ð²Ð¾ÑÐ»Ð°Ð³Ð°Ð¸',0),(141021,3918,'vi','MÃ¡y Ä‘Ã¡nh chá»¯',0),(141022,3918,'af','Typesetter',0),(141023,3918,'ro','Menegementul',0),(141024,3918,'et','TÃµmmise',0),(141025,3918,'si','SlagaÄ',0),(141026,3918,'ba','Typesetter',0),(141027,3918,'nl','Zetter',0),(141028,3918,'fi','Latoja',0),(141029,3918,'no','Typografen',0),(141030,3918,'da','Typograf',0),(141031,3918,'ko','ì‹ìž',0),(141032,3918,'he','×”×¡×“×¨',0),(141033,3918,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¹Î¿Î¸Î­Ï„Î·',0),(141034,3918,'zh','æŽ’å­—å·¥äºº\r\n',0),(141035,3918,'sv','SÃ¤ttare',0),(141036,3918,'it','Tipografo',0),(141037,3918,'tl','',0),(141038,3918,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3612;&#3641;&#3657;&#3585;&#3656;&#3633;&#3657;&#3629;&#3605;&#3633;&#3657;&#3591;',0),(141039,3918,'hi','à¤Ÿà¤¾à¤‡à¤ª à¤¬à¥ˆà¤ à¤¨à¥‡à¤µà¤¾à¤²à¤¾',0),(141040,3918,'ms','Typesetter',0),(141041,3918,'ar','Ø§Ù„Ø·Ø¨Ø§Ø¹',0),(141042,3918,'fr','Typographe',0),(141043,3918,'jp','ã‚¿ã‚¤ãƒ—ã‚»ãƒƒã‚¿ãƒ¼',0),(141044,3918,'pt','TipÃ³grafo',0),(141045,3918,'ru','ÐÐ°Ð±Ð¾Ñ€Ñ‰Ð¸Ðº',0),(141046,3918,'es','Cajista',0),(141047,3918,'de','Schriftsetzer',0),(141048,3918,'en','Typesetter',0),(141049,3919,'is','',0),(141050,3919,'dr','( Ø¯Ø± Ú¯ÙŠØ± ÙƒØ±Ø¯Ù†â€Œ ÙŠØ§ Ø´Ø¯Ù†â€Œ',0),(141051,3919,'pr','Ø²Ù…Ø§Ù† Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢Ù…Ø¯Ù‡( Ø¯Ø± Ú¯ÙŠØ± ÙƒØ±Ø¯Ù†â€Œ ÙŠØ§ Ø´Ø¯Ù†â€Œ',0),(141052,3919,'tr','Zaman yer',0),(141053,3919,'pl','Czasowe',0),(141054,3919,'bg','Ð’Ñ€ÐµÐ¼ÐµÑ‚Ð¾, ÑƒÑ‡Ð°ÑÑ‚Ð²Ð°Ñ‰Ð¸',0),(141055,3919,'ur','ÙˆÙ‚Øª Ù…Ù„ÙˆØ«',0),(141056,3919,'sr','ÐŸÑƒÑ‚ ÑƒÐ¿Ð»ÐµÑ‚ÐµÐ½',0),(141057,3919,'vi','Thá»i gian tham gia',0),(141058,3919,'af','Tyd Betrokke',0),(141059,3919,'ro','Timp implicate',0),(141060,3919,'et','Aega seotud',0),(141061,3919,'si','ÄŒasa, ki sodelujejo',0),(141062,3919,'ba','Waktu terlibat',0),(141063,3919,'nl','Tijd betrokken',0),(141064,3919,'fi','Ajan mukana',0),(141065,3919,'no','Tiden involvert',0),(141066,3919,'da','Tidsforbruget',0),(141067,3919,'ko','ì‹œê°„ ê´€ë ¨ëœ',0),(141068,3919,'he','×–×ž×Ÿ ×ž×¢×•×¨×‘',0),(141069,3919,'el','Î§ÏÏŒÎ½Î¿ ÏƒÏ…Î¼Î¼ÎµÏ„Î­Ï‡Î¿Ï…Î½',0),(141070,3919,'zh','æ‰€èŠ±è´¹çš„æ—¶é—´\r\n',0),(141071,3919,'sv','Tid inblandade',0),(141072,3919,'it','Tempo coinvolti',0),(141073,3919,'tl','',0),(141074,3919,'th','&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591;',0),(141075,3919,'hi','à¤¸à¤®à¤¯ à¤¶à¤¾à¤®à¤¿à¤²',0),(141076,3919,'ms','Masa yang terlibat',0),(141077,3919,'ar','ÙˆÙ‚Øª Ø§Ù„Ù…Ø´Ø§Ø±ÙƒØ©',0),(141078,3919,'fr','Temps impliquÃ©s',0),(141079,3919,'jp','å?«ã?¾ã‚Œã?Ÿæ™‚é–“',0),(141080,3919,'pt','Tempo envolvido',0),(141081,3919,'ru','Ð’Ñ€ÐµÐ¼Ñ',0),(141082,3919,'es','Tiempo Involucrado',0),(141083,3919,'de','Zeitaufwand',0),(141084,3919,'en','Time Involved',0),(141085,3920,'is','',0),(141086,3920,'dr','ÙƒÙ„ Ø²Ù…Ø§Ù† Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´Ø¯',0),(141087,3920,'pr','ÙƒÙ„ Ø²Ù…Ø§Ù† Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´Ø¯',0),(141088,3920,'tr','Toplam zaman yer',0),(141089,3920,'pl','CaÅ‚kowity czas zaangaÅ¼owany',0),(141090,3920,'bg','ÐžÐ±Ñ‰Ð¾ Ð²Ñ€ÐµÐ¼Ðµ, ÑƒÑ‡Ð°ÑÑ‚Ð²Ð°Ñ‰Ð¸',0),(141091,3920,'ur','Ú©Ù„ ÙˆÙ‚Øª Ù…Ù„ÙˆØ«',0),(141092,3920,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ ÑƒÐ¿Ð»ÐµÑ‚ÐµÐ½',0),(141093,3920,'vi','Tá»•ng cá»™ng thá»i gian tham gia',0),(141094,3920,'af','Totale Tyd Gespandeer',0),(141095,3920,'ro','Timpul total implicat',0),(141096,3920,'et','Koguaeg seotud',0),(141097,3920,'si','Skupni Äas, ki so vkljuÄeni',0),(141098,3920,'ba','Total waktu terlibat',0),(141099,3920,'nl','Totale tijd betrokken',0),(141100,3920,'fi','Koko ajan mukana',0),(141101,3920,'no','Total tid involvert',0),(141102,3920,'da','Samlede tid involveret',0),(141103,3920,'ko','ì´ ì‹œê°„',0),(141104,3920,'he','×”×–×ž×Ÿ ×”×›×•×œ×œ ×ž×¢×•×¨×‘',0),(141105,3920,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒÏ‚ Ï‡ÏÏŒÎ½Î¿Ï‚ Ï€Î¿Ï… ÎµÎ¼Ï€Î»Î­ÎºÎ¿Î½Ï„Î±Î¹',0),(141106,3920,'zh','æ¶‰åŠçš„æ€»æ—¶é—´\r\n',0),(141107,3920,'sv','Total tid inblandade',0),(141108,3920,'it','Tempo totale coinvolti',0),(141109,3920,'tl','',0),(141110,3920,'th','&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(141111,3920,'hi','à¤•à¥à¤² à¤¸à¤®à¤¯ à¤¶à¤¾à¤®à¤¿à¤²',0),(141112,3920,'ms','Jumlah masa terlibat',0),(141113,3920,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ù…Ø´Ø§Ø±ÙƒØ©',0),(141114,3920,'fr','Temps total impliquÃ©s',0),(141115,3920,'jp','å?«ã?¾ã‚Œã?Ÿå?ˆè¨ˆæ™‚é–“',0),(141116,3920,'pt','Tempo total envolvido',0),(141117,3920,'ru','ÐžÐ±Ñ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ',0),(141118,3920,'es','Tiempo Total Involucrado',0),(141119,3920,'de','Total Aufwand',0),(141120,3920,'en','Total Time Involved',0),(141121,3921,'is','',0),(141122,3921,'dr','Ú†Ø§Ù¾',0),(141123,3921,'pr','Ú†Ø§Ù¾',0),(141124,3921,'tr','BasÄ±n',0),(141125,3921,'pl','NaciÅ›nij przycisk',0),(141126,3921,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ',0),(141127,3921,'ur','Ù¾Ø±ÛŒØ³',0),(141128,3921,'sr','ÐÐ¾Ð²Ð¸Ð½Ð°Ñ€Ðµ',0),(141129,3921,'vi','In ',0),(141130,3921,'af','Press',0),(141131,3921,'ro','Comunicat de presÄƒ',0),(141132,3921,'et','Vajutage',0),(141133,3921,'si','Press',0),(141134,3921,'ba','Tekan',0),(141135,3921,'nl','Druk op',0),(141136,3921,'fi','Paina',0),(141137,3921,'no','Trykk',0),(141138,3921,'da','Tryk pÃ¥',0),(141139,3921,'ko','ë³´ë„ ìžë£Œ',0),(141140,3921,'he','×”×¢×™×ª×•× ×•×ª',0),(141141,3921,'el','Î¤ÏÏ€Î¿Ï…',0),(141142,3921,'zh','å°åˆ·',0),(141143,3921,'sv','Tryck pÃ¥',0),(141144,3921,'it','Stampa',0),(141145,3921,'tl','',0),(141146,3921,'th','&#3585;&#3604;',0),(141147,3921,'hi','à¤ªà¥à¤°à¥‡à¤¸',0),(141148,3921,'ms','Seluar',0),(141149,3921,'ar','Ø§Ù„ØµØ­Ø§ÙØ©',0),(141150,3921,'fr','Presse',0),(141151,3921,'jp','ãƒ—ãƒ¬ã‚¹',0),(141152,3921,'pt','Imprensa',0),(141153,3921,'ru','ÐŸÑ€ÐµÑÑ',0),(141154,3921,'es','Prensa',0),(141155,3921,'de','Presse',0),(141156,3921,'en','Press',0),(141157,3922,'is','',0),(141158,3922,'dr','(ÙˆØ±Ù‚ Ù‡Ø§',0),(141159,3922,'pr','Ø¨Ø±Ú¯Ù‡ Ù‡Ø§(ÙˆØ±Ù‚ Ù‡Ø§',0),(141160,3922,'tr','Ã‡arÅŸaf',0),(141161,3922,'pl','Arkusze',0),(141162,3922,'bg','Ð›Ð¸ÑÑ‚Ð¾Ð²Ðµ',0),(141163,3922,'ur','Ø§ÙˆØ±Ø§Ù‚',0),(141164,3922,'sr','Ð›Ð¸ÑÑ‚Ð¾Ð²Ðµ',0),(141165,3922,'vi','Trang',0),(141166,3922,'af','Velle',0),(141167,3922,'ro','Foi',0),(141168,3922,'et','Lehed',0),(141169,3922,'si','Listi',0),(141170,3922,'ba','Lembar',0),(141171,3922,'nl','Bladen',0),(141172,3922,'fi','Lakanat',0),(141173,3922,'no','Ark',0),(141174,3922,'da','Ark',0),(141175,3922,'ko','ì‹œíŠ¸',0),(141176,3922,'he','×’×œ×™×•× ×•×ª',0),(141177,3922,'el','Î¦ÏÎ»Î»Î±',0),(141178,3922,'zh','å¼ \r\n',0),(141179,3922,'sv','Ark',0),(141180,3922,'it','Fogli',0),(141181,3922,'tl','',0),(141182,3922,'th','&#3649;&#3612;&#3656;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(141183,3922,'hi','à¤¶à¥€à¤Ÿà¥à¤¸',0),(141184,3922,'ms','Cadar',0),(141185,3922,'ar','ÙˆØ±Ù‚Ø§Øª',0),(141186,3922,'fr','Feuilles',0),(141187,3922,'jp','ã‚·ãƒ¼ãƒˆ',0),(141188,3922,'pt','Folhas',0),(141189,3922,'ru','Ð›Ð¸ÑÑ‚Ñ‹',0),(141190,3922,'es','Hojas',0),(141191,3922,'de','BlÃ¤tter',0),(141192,3922,'en','Sheets',0),(141193,3923,'is','',0),(141194,3923,'dr','Ø¬Ù‡Øª Ù‡Ø§',0),(141195,3923,'pr','Ø¬Ù‡Øª Ù‡Ø§',0),(141196,3923,'tr','Ä°ki taraf',0),(141197,3923,'pl','Boki',0),(141198,3923,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸',0),(141199,3923,'ur','Ø§Ø·Ø±Ø§Ù',0),(141200,3923,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ðµ',0),(141201,3923,'vi','Máº·t',0),(141202,3923,'af','Kante',0),(141203,3923,'ro','PÄƒrÅ£i',0),(141204,3923,'et','KÃ¼lgedel',0),(141205,3923,'si','Straneh',0),(141206,3923,'ba','Sisi',0),(141207,3923,'nl','Zijden',0),(141208,3923,'fi','Osapuolet',0),(141209,3923,'no','Sider',0),(141210,3923,'da','Sider',0),(141211,3923,'ko','ì¸¡ë©´',0),(141212,3923,'he','×¦×“×“×™×',0),(141213,3923,'el','Î Î»ÎµÏ…ÏÎ­Ï‚',0),(141214,3923,'zh','ä¾§\r\n',0),(141215,3923,'sv','Sidor',0),(141216,3923,'it','Dimensioni-',0),(141217,3923,'tl','',0),(141218,3923,'th','&#3604;&#3657;&#3634;&#3609;',0),(141219,3923,'hi','à¤ªà¤•à¥à¤·à¥‹à¤‚',0),(141220,3923,'ms','Belah pihak',0),(141221,3923,'ar','Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠÙ†',0),(141222,3923,'fr','CÃ´tÃ©s',0),(141223,3923,'jp','å?´é?¢',0),(141224,3923,'pt','Lados',0),(141225,3923,'ru','Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(141226,3923,'es','Lados',0),(141227,3923,'de','Seiten',0),(141228,3923,'en','Sides',0),(141229,3924,'is','',0),(141230,3924,'dr','Ù¾Ø§Ø±Ú†Ù‡ Ú©Ø§Ø±ÙŠ',0),(141231,3924,'pr','Ù¾Ø§Ø±Ú†Ù‡ Ú©Ø§Ø±ÙŠ',0),(141232,3924,'tr','Ä°ÅŸ parÃ§a',0),(141233,3924,'pl','KawaÅ‚ek pracy',0),(141234,3924,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(141235,3924,'ur','Ù¹Ú©Ú‘Ø§ Ú©Ø§Ù…',0),(141236,3924,'sr','Ð ÐµÐ·Ð±Ð°Ñ€ÐµÑšÐµ',0),(141237,3924,'vi','Pháº§n cÃ´ng viá»‡c',0),(141238,3924,'af','Stukwerk',0),(141239,3924,'ro','Piesa de lucru',0),(141240,3924,'et','TÃ¼kk tÃ¶Ã¶d',0),(141241,3924,'si','Kos dela',0),(141242,3924,'ba','Bagian pekerjaan',0),(141243,3924,'nl','Werk',0),(141244,3924,'fi','TyÃ¶',0),(141245,3924,'no','Stykkarbeid',0),(141246,3924,'da','Stykke arbejde',0),(141247,3924,'ko','ìž‘í’ˆ',0),(141248,3924,'he','×—×ª×™×›×ª ×¢×‘×•×“×”',0),(141249,3924,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(141250,3924,'zh','è®¡ä»¶\r\n',0),(141251,3924,'sv','Stycke arbete',0),(141252,3924,'it','Pezzo di lavoro',0),(141253,3924,'tl','',0),(141254,3924,'th','&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;',0),(141255,3924,'hi','à¤Ÿà¥à¤•à¤¡à¤¼à¤¾ à¤•à¤¾à¤®',0),(141256,3924,'ms','Bahagian kerja',0),(141257,3924,'ar','Ù‚Ø·Ø¹Ø© Ø§Ù„Ø¹Ù…Ù„',0),(141258,3924,'fr','PiÃ¨ce travail',0),(141259,3924,'jp','å‡ºæ?¥é«˜åˆ¶',0),(141260,3924,'pt','PeÃ§a de trabalho',0),(141261,3924,'ru','Ð§Ð°ÑÑ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(141262,3924,'es','Trabajo por Pieza',0),(141263,3924,'de','Akkordarbeit',0),(141264,3924,'en','Piece Work',0),(141265,3925,'is','',0),(141266,3925,'dr','Ú†Ø§Ù¾ Ø­Ø±Ù Ø§ÙˆÙ„ Ù†Ø§Ù… ÙˆÙ†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ Ø§Ù¾Ø±Ø§ØªÙˆØ±',0),(141267,3925,'pr','Ú†Ø§Ù¾ Ø­Ø±Ù Ø§ÙˆÙ„ Ù†Ø§Ù… ÙˆÙ†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ Ø§Ù¾Ø±Ø§ØªÙˆØ±',0),(141268,3925,'tr','BasÄ±n operatÃ¶r baÅŸ harfleri',0),(141269,3925,'pl','NaciÅ›nij operatorem inicjaÅ‚y',0),(141270,3925,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€ Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ð»Ð¸',0),(141271,3925,'ur','Ù¾Ø±ÛŒØ³ Ø¢Ù¾Ø±ÛŒÙ¹Ø± Ù…Ø®ØªØµØ± Ø¯Ø³ØªØ®Ø·',0),(141272,3925,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€ Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð»Ð¸',0),(141273,3925,'vi','Váº­n hÃ ng in lÃºc ban Ä‘áº§u',0),(141274,3925,'af','Druk operateur voorletters',0),(141275,3925,'ro','ApÄƒsaÅ£i iniÅ£ialele operatorului',0),(141276,3925,'et','Vajutage kasutaja initsiaalid',0),(141277,3925,'si','ZaÄetnice Operator tisku',0),(141278,3925,'ba','Tekan Operator inisial',0),(141279,3925,'nl','Druk op Operator initialen',0),(141280,3925,'fi','Paina operaattori nimikirjaimet',0),(141281,3925,'no','Trykk operatÃ¸r initialer',0),(141282,3925,'da','Tryk pÃ¥ operatÃ¸ren initialer',0),(141283,3925,'ko','ë³´ë„ ì—°ì‚°ìž ì´ë‹ˆì…œ',0),(141284,3925,'he','×œ×—×¥ ×¢×œ ××•×¤×¨×˜×•×¨ ×¨××©×™ ×”×ª×™×‘×•×ª',0),(141285,3925,'el','Î Î¹Î­ÏƒÏ„Îµ Î±ÏÏ‡Î¹ÎºÎ¬ Ï‡ÎµÎ¹ÏÎ¹ÏƒÏ„Î®',0),(141286,3925,'zh','æŒ‰æ“ä½œå£°æ¯\r\n\r\n',0),(141287,3925,'sv','Tryck pÃ¥ operatÃ¶rens initialer',0),(141288,3925,'it','Stampa operatore iniziali',0),(141289,3925,'tl','',0),(141290,3925,'th','&#3585;&#3604;&#3605;&#3633;&#3623;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;&#3648;&#3610;&#3639;&#3657;&#3629;&#3591;&#3605;&#3657;&#3609;',0),(141291,3925,'hi','à¤‘à¤ªà¤°à¥‡à¤Ÿà¤° à¤ªà¤¹à¤²à¥‡ à¤…à¤•à¥à¤·à¤° à¤¦à¤¬à¤¾à¤à¤',0),(141292,3925,'ms','Tekan nama pengendali',0),(141293,3925,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø§Ù„Ø£Ø­Ø±Ù Ø§Ù„Ø£ÙˆÙ„Ù‰ Ù…Ù† Ø§Ø³Ù… Ø§Ù„Ù…Ø´ØºÙ„',0),(141294,3925,'fr','Appuyez sur les initiales de l\'opÃ©rateur',0),(141295,3925,'jp','Press Operator Initials',0),(141296,3925,'pt','Imprensa operador iniciais',0),(141297,3925,'ru','Ð˜Ð½Ð¸Ñ†Ð¸Ð°Ð»Ñ‹ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ð° Ð¿Ñ€ÐµÑÑ',0),(141298,3925,'es','Prensa Iniciales de Operador',0),(141299,3925,'de','Press Operator Initialen',0),(141300,3925,'en','Press Operator Initials',0),(141301,3926,'is','',0),(141302,3926,'dr','ØªÙˆØ¶ÙŠØ­Ø§Øª',0),(141303,3926,'pr','ØªÙˆØ¶ÙŠØ­Ø§Øª',0),(141304,3926,'tr','AÃ§Ä±klamalar',0),(141305,3926,'pl','Uwagi',0),(141306,3926,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(141307,3926,'ur','ØªØ¨ØµØ±Û’',0),(141308,3926,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð°',0),(141309,3926,'vi','Nháº­n xÃ©t',0),(141310,3926,'af','Opmerkings',0),(141311,3926,'ro','Remarci',0),(141312,3926,'et','MÃ¤rkused',0),(141313,3926,'si','Pripombe',0),(141314,3926,'ba','Komentar',0),(141315,3926,'nl','Opmerkingen',0),(141316,3926,'fi','Huomautukset',0),(141317,3926,'no','Bemerkninger',0),(141318,3926,'da','BemÃ¦rkninger',0),(141319,3926,'ko','ë°œì–¸',0),(141320,3926,'he','×”×¢×¨×•×ª',0),(141321,3926,'el','Î Î±ÏÎ±Ï„Î·ÏÎ®ÏƒÎµÎ¹Ï‚',0),(141322,3926,'zh','å¤‡æ³¨\r\n',0),(141323,3926,'sv','AnmÃ¤rkningar',0),(141324,3926,'it','Osservazioni',0),(141325,3926,'tl','',0),(141326,3926,'th','&#3586;&#3657;&#3629;&#3626;&#3633;&#3591;&#3648;&#3585;&#3605;',0),(141327,3926,'hi','à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€',0),(141328,3926,'ms','Kata-kata',0),(141329,3926,'ar','Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(141330,3926,'fr','Remarques',0),(141331,3926,'jp','ãƒªãƒžãƒ¼ã‚¯',0),(141332,3926,'pt','ObservaÃ§Ãµes',0),(141333,3926,'ru','Ð—Ð°Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(141334,3926,'es','Observaciones',0),(141335,3926,'de','Bemerkungen',0),(141336,3926,'en','Remarks',0),(141337,3927,'is','',0),(141338,3927,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ ',0),(141339,3927,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ ',0),(141340,3927,'tr','Ambalaj Not',0),(141341,3927,'pl','Opako',0),(141342,3927,'bg','ÐžÐ¿Ð°ÐºÐ¾Ð²ÐºÐ° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(141343,3927,'ur','Ù¾ÛŒÚ©Ø¬Ù†Ú¯ Ù†ÙˆÙ¹',0),(141344,3927,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° Ð·Ð° Ð¿Ð°ÐºÐ¾Ð²Ð°ÑšÐµ',0),(141345,3927,'vi','Ghi chÃº Ä‘Ã³ng gÃ³i',0),(141346,3927,'af','Verpakkingsnota',0),(141347,3927,'ro','NotÄƒ de ambalare',0),(141348,3927,'et','Pakendi MÃ¤rkus',0),(141349,3927,'si','Opomba embalaÅ¾e',0),(141350,3927,'ba','Kemasan catatan',0),(141351,3927,'nl','Verpakking Opmerking',0),(141352,3927,'fi','Pakkaus Huomautus',0),(141353,3927,'no','Emballasje Merk',0),(141354,3927,'da','Emballage BemÃ¦rk',0),(141355,3927,'ko','í¬ìž¥ ì°¸ê³ ',0),(141356,3927,'he','×”×¢×¨×” ××¨×™×–×”',0),(141357,3927,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· ÏƒÏ…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î±Ï‚',0),(141358,3927,'zh','å°è£…è¯´æ˜Ž\r\n',0),(141359,3927,'sv','FÃ¶rpackning Obs',0),(141360,3927,'it','Nota di imballaggio',0),(141361,3927,'tl','',0),(141362,3927,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;',0),(141363,3927,'hi','à¤ªà¥ˆà¤•à¥‡à¤œà¤¿à¤‚à¤— à¤¨à¥‹à¤Ÿ',0),(141364,3927,'ms','Nota pembungkusan',0),(141365,3927,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„ØªØºÙ„ÙŠÙ',0),(141366,3927,'fr','Note de l\'emballage',0),(141367,3927,'jp','æ¢±åŒ…ãƒ¡ãƒ¢',0),(141368,3927,'pt','Embalagem Nota',0),(141369,3927,'ru','Ð£Ð¿Ð°ÐºÐ¾Ð²ÐºÐ° ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(141370,3927,'es','Nota de Embalaje',0),(141371,3927,'de','Verpackung-Hinweis',0),(141372,3927,'en','Packaging Note',0),(141373,3928,'is','',0),(141374,3928,'dr','Ø§Ø±Ø²Ø´ ',0),(141375,3928,'pr','Ø§Ø±Ø²Ø´ ',0),(141376,3928,'tr','DeÄŸer',0),(141377,3928,'pl','Warto',0),(141378,3928,'bg','Ð£ÑŠÑ€Ñ‚',0),(141379,3928,'ur','Ù…Ø§Ù„ÛŒØª',0),(141380,3928,'sr','Ð’Ñ€ÐµÐ´Ð¸',0),(141381,3928,'vi','Trá»‹ giÃ¡',0),(141382,3928,'af','Die moeite werd',0),(141383,3928,'ro','Valoare',0),(141384,3928,'et','VÃ¤Ã¤rtus',0),(141385,3928,'si','Vredno',0),(141386,3928,'ba','Senilai',0),(141387,3928,'nl','Waarde',0),(141388,3928,'fi','Worth',0),(141389,3928,'no','Verdt',0),(141390,3928,'da','VÃ¦rd',0),(141391,3928,'ko','ê°€ì¹˜',0),(141392,3928,'he','×©×•×•×”',0),(141393,3928,'el','Î‘Î¾Î¯Î¶ÎµÎ¹ Î½Î±',0),(141394,3928,'zh','å€¼å¾—\r\n',0),(141395,3928,'sv','VÃ¤rt',0),(141396,3928,'it','Vale la pena',0),(141397,3928,'tl','',0),(141398,3928,'th','&#3617;&#3637;&#3619;&#3634;&#3588;&#3634;',0),(141399,3928,'hi','à¤µà¤°à¥à¤¥',0),(141400,3928,'ms','Bernilai',0),(141401,3928,'ar','ÙˆÙˆØ±Ø«',0),(141402,3928,'fr','Worth',0),(141403,3928,'jp','ä¾¡å€¤',0),(141404,3928,'pt','Vale a pena',0),(141405,3928,'ru','Ð¡Ñ‚Ð¾Ð¸Ñ‚',0),(141406,3928,'es','Valor',0),(141407,3928,'de','Wert',0),(141408,3928,'en','Worth',0),(141409,3929,'is','',0),(141410,3929,'dr','Ø³Ø§Ø®Øª ',0),(141411,3929,'pr','Ø³Ø§Ø®Øª ',0),(141412,3929,'tr','Kompozisyon',0),(141413,3929,'pl','SkÅ‚ad',0),(141414,3929,'bg','Ð¡ÑŠÑÑ‚Ð°Ð²',0),(141415,3929,'ur','Ø³Ø§Ø®Øª',0),(141416,3929,'sr','Ð¡Ð°ÑÑ‚Ð°Ð²',0),(141417,3929,'vi','ThÃ nh pháº§n',0),(141418,3929,'af','Samestelling',0),(141419,3929,'ro','CompoziÅ£ia',0),(141420,3929,'et','Koostis',0),(141421,3929,'si','Sestava',0),(141422,3929,'ba','Komposisi',0),(141423,3929,'nl','Samenstelling',0),(141424,3929,'fi','Kokoonpano',0),(141425,3929,'no','Komposisjon',0),(141426,3929,'da','SammensÃ¦tning',0),(141427,3929,'ko','êµ¬ì„±',0),(141428,3929,'he','×§×•×ž×¤×•×–×™×¦×™×”',0),(141429,3929,'el','Î£ÏÎ½Î¸ÎµÏƒÎ·',0),(141430,3929,'zh','ç»„æˆ\r\n',0),(141431,3929,'sv','SammansÃ¤ttning',0),(141432,3929,'it','Composizione',0),(141433,3929,'tl','',0),(141434,3929,'th','&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(141435,3929,'hi','à¤°à¤šà¤¨à¤¾',0),(141436,3929,'ms','Komposisi',0),(141437,3929,'ar','ØªÙƒÙˆÙŠÙ†',0),(141438,3929,'fr','Composition',0),(141439,3929,'jp','çµ„ç¹”',0),(141440,3929,'pt','ComposiÃ§Ã£o',0),(141441,3929,'ru','Ð¡Ð¾ÑÑ‚Ð°Ð²',0),(141442,3929,'es','ComposiciÃ³n',0),(141443,3929,'de','Zusammensetzung',0),(141444,3929,'en','Composition',0),(141445,3930,'is','',0),(141446,3930,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(141447,3930,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(141448,3930,'tr','MÃ¼ÅŸteri notlarÄ±',0),(141449,3930,'pl','Uwagi klienta',0),(141450,3930,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(141451,3930,'ur','Ú©Ø³Ù¹Ù…Ø± Ù†ÙˆÙ¹',0),(141452,3930,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(141453,3930,'vi','Ghi chÃº KhÃ¡ch hÃ ng',0),(141454,3930,'af','Klant / KliÃ«nt Nota\'s',0),(141455,3930,'ro','Note de client',0),(141456,3930,'et','Kliendi mÃ¤rkused',0),(141457,3930,'si','Kupcev ugotavlja',0),(141458,3930,'ba','Catatan pelanggan',0),(141459,3930,'nl','Klant notities',0),(141460,3930,'fi','Asiakkaan huomautuksia',0),(141461,3930,'no','Kunden notater',0),(141462,3930,'da','Kunde noter',0),(141463,3930,'ko','ê³ ê° ë©”ëª¨',0),(141464,3930,'he','×”×¢×¨×•×ª ×”×œ×§×•×—',0),(141465,3930,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(141466,3930,'zh','å®¢æˆ·å¤‡æ³¨\r\n',0),(141467,3930,'sv','Kunden anteckningar',0),(141468,3930,'it','Note sul cliente',0),(141469,3930,'tl','',0),(141470,3930,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(141471,3930,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¥‹à¤Ÿà¥à¤¸',0),(141472,3930,'ms','Baca Nota',0),(141473,3930,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(141474,3930,'fr','Client Notes',0),(141475,3930,'jp','é¡§å®¢ãƒ¡ãƒ¢',0),(141476,3930,'pt','Notas do cliente',0),(141477,3930,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(141478,3930,'es','Cliente Notas',0),(141479,3930,'de','Customer Notes',0),(141480,3930,'en','Customer Notes',0),(141481,3931,'is','',0),(141482,3931,'dr','Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ ',0),(141483,3931,'pr','Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ ',0),(141484,3931,'tr','Ambalaj',0),(141485,3931,'pl','Opakowania',0),(141486,3931,'bg','ÐžÐ¿Ð°ÐºÐ¾Ð²ÐºÐ°',0),(141487,3931,'ur','Ù¾ÛŒÚ©Ø¬Ù†Ú¯',0),(141488,3931,'sr','ÐÐ¼Ð±Ð°Ð»Ð°Ð¶Ð°',0),(141489,3931,'vi','ÄÃ³ng gÃ³i',0),(141490,3931,'af','Verpakking',0),(141491,3931,'ro','Ambalaje',0),(141492,3931,'et','Pakend',0),(141493,3931,'si','EmbalaÅ¾e',0),(141494,3931,'ba','Kemasan',0),(141495,3931,'nl','Verpakking',0),(141496,3931,'fi','Pakkaus',0),(141497,3931,'no','Emballasje',0),(141498,3931,'da','Emballage',0),(141499,3931,'ko','í¬ìž¥',0),(141500,3931,'he','××¨×™×–×”',0),(141501,3931,'el','Î£Ï…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î±',0),(141502,3931,'zh','åŒ…è£…\r\n',0),(141503,3931,'sv','FÃ¶rpackning',0),(141504,3931,'it','Imballaggio',0),(141505,3931,'tl','',0),(141506,3931,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;',0),(141507,3931,'hi','à¤ªà¥ˆà¤•à¥‡à¤œà¤¿à¤‚à¤—',0),(141508,3931,'ms','Pembungkusan',0),(141509,3931,'ar','Ø§Ù„ØªØ¹Ø¨Ø¦Ø© ÙˆØ§Ù„ØªØºÙ„ÙŠÙ',0),(141510,3931,'fr','Emballage',0),(141511,3931,'jp','æ¢±åŒ…',0),(141512,3931,'pt','Embalagens',0),(141513,3931,'ru','Ð£Ð¿Ð°ÐºÐ¾Ð²ÐºÐ°',0),(141514,3931,'es','Embalaje',0),(141515,3931,'de','Verpackung',0),(141516,3931,'en','Packaging',0),(141517,3932,'is','',0),(141518,3932,'dr','-',0),(141519,3932,'pr','Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡ ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡-',0),(141520,3932,'tr','Ciltevi',0),(141521,3932,'pl','Introligatornia',0),(141522,3932,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð°',0),(141523,3932,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ',0),(141524,3932,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y',0),(141525,3932,'vi','ÄÃ³ng sÃ¡ch',0),(141526,3932,'af','Bindery',0),(141527,3932,'ro','Legatorie',0),(141528,3932,'et','Kirjansitomo',0),(141529,3932,'si','Knjigoveznica',0),(141530,3932,'ba','Bindery',0),(141531,3932,'nl','Bindery',0),(141532,3932,'fi','Kantata',0),(141533,3932,'no','Bindingen',0),(141534,3932,'da','Bindery',0),(141535,3932,'ko','ë°”ì¸ë”ë¦¬',0),(141536,3932,'he','Bindery',0),(141537,3932,'el','Bindery',0),(141538,3932,'zh','è£…è®¢\r\n',0),(141539,3932,'sv','Binderi',0),(141540,3932,'it','Legatoria',0),(141541,3932,'tl','',0),(141542,3932,'th','&#3649;&#3615;&#3657;&#3617;',0),(141543,3932,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚',0),(141544,3932,'ms','Bindery',0),(141545,3932,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª',0),(141546,3932,'fr','FaÃ§onnage',0),(141547,3932,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼',0),(141548,3932,'pt','Bindery',0),(141549,3932,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ',0),(141550,3932,'es','Encuadernadora',0),(141551,3932,'de','Buchbinderei',0),(141552,3932,'en','Bindery',0),(141553,3933,'is','',0),(141554,3933,'dr','Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø³Ù‚Ù Ø§Ø¹ØªØ¨Ø§Ø± ',0),(141555,3933,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø³Ù‚Ù Ø§Ø¹ØªØ¨Ø§Ø± ',0),(141556,3933,'tr','Kredi sÄ±nÄ±rÄ±',0),(141557,3933,'pl','Ponad Limit kredytowy',0),(141558,3933,'bg','ÐÐ°Ð´ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸Ñ Ð»Ð¸Ð¼Ð¸Ñ‚',0),(141559,3933,'ur','Ø§ÙˆÙ¾Ø± Ú©ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ø­Ø¯',0),(141560,3933,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð»Ð¸Ð¼Ð¸Ñ‚',0),(141561,3933,'vi','QuÃ¡ Háº¡n Má»©c TÃ­n Dá»¥ng',0),(141562,3933,'af','Oorskry Kredietlimiet',0),(141563,3933,'ro','Peste limita de Credit',0),(141564,3933,'et','Ãœle krediidilimiit',0),(141565,3933,'si','Nad limita',0),(141566,3933,'ba','Atas batas kredit',0),(141567,3933,'nl','Over kredietlimiet',0),(141568,3933,'fi','Yli luottoraja',0),(141569,3933,'no','Over kredittgrensen',0),(141570,3933,'da','Over kreditmaksimum',0),(141571,3933,'ko','ì‹ ìš© í•œë„ ì´ˆê³¼',0),(141572,3933,'he','×ž×ž×’×‘×œ×ª ×”××©×¨××™',0),(141573,3933,'el','Î Î­ÏÎ± Î±Ï€ÏŒ Ï„Î¿ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ ÏŒÏÎ¹Î¿',0),(141574,3933,'zh','è¶…è¿‡ä¿¡ç”¨é¢åº¦\r\n',0),(141575,3933,'sv','Ã–ver kreditgrÃ¤ns',0),(141576,3933,'it','Oltre il limite di credito',0),(141577,3933,'tl','',0),(141578,3933,'th','&#3648;&#3585;&#3636;&#3609;&#3623;&#3591;&#3648;&#3591;&#3636;&#3609;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(141579,3933,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¸à¥€à¤®à¤¾ à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(141580,3933,'ms','Melebihi had kredit',0),(141581,3933,'ar','Ø¹Ù„Ù‰ Ø­Ø¯ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(141582,3933,'fr','Plus de limite de crÃ©dit',0),(141583,3933,'jp','è²¸ä»˜é™?åº¦è¶…é?Ž',0),(141584,3933,'pt','Limite de crÃ©dito',0),(141585,3933,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¹ Ð›Ð¸Ð¼Ð¸Ñ‚',0),(141586,3933,'es','MÃ¡s que el LÃ­mite de CrÃ©dito',0),(141587,3933,'de','Ãœber Kreditlimit',0),(141588,3933,'en','Over Credit Limit',0),(141589,3934,'is','',0),(141590,3934,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø³Ø§Ø®Øª ',0),(141591,3934,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø³Ø§Ø®Øª ',0),(141592,3934,'tr','Kompozisyon fiyat listesi gÃ¼ncelleme',0),(141593,3934,'pl','Aktualizacja listy skÅ‚ad ceny',0),(141594,3934,'bg','Ð¡ÑŠÑÑ‚Ð°Ð² Ñ†ÐµÐ½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(141595,3934,'ur','Ø³Ø§Ø®Øª Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(141596,3934,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ñ†ÐµÐ½Ðµ ÑÐ°ÑÑ‚Ð°Ð²',0),(141597,3934,'vi','Cáº­p Nháº­t GiÃ¡ Cá»§a CÃ¡c ThÃ nh Pháº§n',0),(141598,3934,'af','Saamgestelde Pryslyss Opdateer',0),(141599,3934,'ro','CompoziÅ£ia Pret lista actualizare',0),(141600,3934,'et','Koosseisu nimekiri Hinnauuendus',0),(141601,3934,'si','Sestava cena seznam posodobitev',0),(141602,3934,'ba','Komposisi harga daftar Update',0),(141603,3934,'nl','Samenstelling prijs lijst Update',0),(141604,3934,'fi','Koostumus hinnasto PÃ¤ivitÃ¤',0),(141605,3934,'no','Sammensetning Prisoppdatering liste',0),(141606,3934,'da','SammensÃ¦tning pris liste Update',0),(141607,3934,'ko','êµ¬ì„± ê°€ê²© ëª©ë¡ ì—…ë°ì´íŠ¸',0),(141608,3934,'he','×¢×“×›×•×Ÿ ×¨×©×™×ž×ª ×ž×—×™×¨ ×”×¨×›×‘',0),(141609,3934,'el','Î£ÏÎ½Î¸ÎµÏƒÎ· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¯ÏƒÏ„Î± Ï„Î¹Î¼ÏŽÎ½',0),(141610,3934,'zh','æž„æˆä»·æ ¼è¡¨æ›´æ–°\r\n',0),(141611,3934,'sv','SammansÃ¤ttning prisuppdatering',0),(141612,3934,'it','Composizione prezzo List Update',0),(141613,3934,'tl','',0),(141614,3934,'th','&#3619;&#3634;&#3618;&#3619;&#3634;&#3588;&#3634;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3607;&#3637;&#3656;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(141615,3934,'hi','à¤°à¤šà¤¨à¤¾ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(141616,3934,'ms','Komposisi harga senarai Kemaskini',0),(141617,3934,'ar','ØªÙƒÙˆÙŠÙ† ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(141618,3934,'fr','Composition Prix liste mise Ã  jour',0),(141619,3934,'jp','æ§‹æˆ?ä¾¡æ ¼è¡¨ã?®æ›´æ–°',0),(141620,3934,'pt','AtualizaÃ§Ã£o de lista de preÃ§o de composiÃ§Ã£o',0),(141621,3934,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° ÑÐ¾ÑÑ‚Ð°Ð² Ð¦ÐµÐ½Ð°',0),(141622,3934,'es','Actualizar Lista de Precios de ComposiciÃ³n',0),(141623,3934,'de','Zusammensetzung Preis Liste Update',0),(141624,3934,'en','Composition Price List Update',0),(141625,3935,'is','',0),(141626,3935,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ØªØ±ÙƒÙŠØ¨ Ø¬Ø¯ÙŠØ¯ ',0),(141627,3935,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ØªØ±ÙƒÙŠØ¨ Ø¬Ø¯ÙŠØ¯ ',0),(141628,3935,'tr','Yeni kompozisyon tÃ¼rÃ¼ Ekle',0),(141629,3935,'pl','DodaÄ‡ nowy typ skÅ‚adu',0),(141630,3935,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð² ÑÑŠÑÑ‚Ð°Ð² Ñ‚Ð¸Ð¿',0),(141631,3935,'ur','Ù†Ø¦ÛŒ ØªØ±Ú©ÛŒØ¨ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(141632,3935,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ ÑÐ°ÑÑ‚Ð°Ð² Ñ‚Ð¸Ð¿',0),(141633,3935,'vi','ThÃªm ThÃ nh Pháº§n Má»›i',0),(141634,3935,'af','Nuwe Konstruksie Tipe Byvoeg',0),(141635,3935,'ro','Adauga noul tip de compozitie',0),(141636,3935,'et','Lisada uus koostis tÃ¼Ã¼p',0),(141637,3935,'si','Dodati novo vrsto sestava',0),(141638,3935,'ba','Menambahkan jenis komposisi baru',0),(141639,3935,'nl','Nieuwe samenstelling Type toevoegen',0),(141640,3935,'fi','LisÃ¤tÃ¤ uusi kokoonpano',0),(141641,3935,'no','Legge til nye kroppsbygning',0),(141642,3935,'da','TilfÃ¸je nye sammensÃ¦tning Type',0),(141643,3935,'ko','ìƒˆë¡œìš´ êµ¬ì„± í˜•ì‹ ì¶”ê°€',0),(141644,3935,'he','×”×•×¡×£ ×¡×•×’ ×”×¨×›×‘ ×—×“×©',0),(141645,3935,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï„ÏÏ€Î¿Ï… ÏƒÏÎ½Î¸ÎµÏƒÎ·',0),(141646,3935,'zh','å¢žåŠ æ–°çš„ç»„æˆå½¢å¼\r\n',0),(141647,3935,'sv','LÃ¤gga till ny sammansÃ¤ttning typ',0),(141648,3935,'it','Aggiungere nuovo tipo di composizione',0),(141649,3935,'tl','',0),(141650,3935,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(141651,3935,'hi','à¤¨à¤ˆ à¤¸à¤‚à¤°à¤šà¤¨à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(141652,3935,'ms','Tambah jenis komposisi baru',0),(141653,3935,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„ØªØ´ÙƒÙŠÙ„ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(141654,3935,'fr','Ajouter Typ de Composition',0),(141655,3935,'jp','æ–°è¦?æ§‹æˆ?ã‚¿ã‚¤ãƒ—ã?®è¿½åŠ ',0),(141656,3935,'pt','Adicionar o novo tipo de composiÃ§Ã£o',0),(141657,3935,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ‚Ð¸Ð¿ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸',0),(141658,3935,'es','Agregar Nuevo Tipo de ComposiciÃ³n',0),(141659,3935,'de','Neue Zusammensetzung Typ hinzufÃ¼gen',0),(141660,3935,'en','Add New Composition Type',0),(141661,3936,'is','',0),(141662,3936,'dr','Ù†Ø§Ù… Ø³Ø§Ø®Øª ',0),(141663,3936,'pr','Ù†Ø§Ù… Ø³Ø§Ø®Øª ',0),(141664,3936,'tr','Kompozisyon adÄ±',0),(141665,3936,'pl','Nazwa kompozycji',0),(141666,3936,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÑŠÑÑ‚Ð°Ð²Ð°',0),(141667,3936,'ur','Ø³Ø§Ø®Øª Ú©Ø§ Ù†Ø§Ù…',0),(141668,3936,'sr','Ð¡Ð°ÑÑ‚Ð°Ð² Ð¸Ð¼Ðµ',0),(141669,3936,'vi','TÃªn thÃ nh pháº§n',0),(141670,3936,'af','Saamgestelde Naam',0),(141671,3936,'ro','CompoziÅ£ia numele',0),(141672,3936,'et','Koosseisu nimi',0),(141673,3936,'si','Sestava ime',0),(141674,3936,'ba','Komposisi nama',0),(141675,3936,'nl','Samenstelling naam',0),(141676,3936,'fi','Kokoonpanon nimi',0),(141677,3936,'no','Sammensetning navn',0),(141678,3936,'da','SammensÃ¦tning navn',0),(141679,3936,'ko','êµ¬ì„± ì´ë¦„',0),(141680,3936,'he','×©× ×”×”×¨×›×‘',0),(141681,3936,'el','Î£ÏÎ½Î¸ÎµÏƒÎ· ÏŒÎ½Î¿Î¼Î±',0),(141682,3936,'zh','æˆåˆ†åç§°\r\n',0),(141683,3936,'sv','SammansÃ¤ttning namn',0),(141684,3936,'it','Nome composizione',0),(141685,3936,'tl','',0),(141686,3936,'th','&#3594;&#3639;&#3656;&#3629;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(141687,3936,'hi','à¤°à¤šà¤¨à¤¾ à¤•à¤¾ à¤¨à¤¾à¤®',0),(141688,3936,'ms','Nama komposisi',0),(141689,3936,'ar','ØªÙƒÙˆÙŠÙ† Ø§Ù„Ø§Ø³Ù…',0),(141690,3936,'fr','Nom de la composition',0),(141691,3936,'jp','æ§‹æˆ?å??',0),(141692,3936,'pt','Nome da composiÃ§Ã£o',0),(141693,3936,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸',0),(141694,3936,'es','Nombre de ComposiciÃ³n',0),(141695,3936,'de','Kompositionsnamen',0),(141696,3936,'en','Composition Name',0),(141697,3937,'is','',0),(141698,3937,'dr','Ù†ÙˆØ¹ Ø³Ø§Ø®Øª ',0),(141699,3937,'pr','Ù†ÙˆØ¹ Ø³Ø§Ø®Øª ',0),(141700,3937,'tr','Kompozisyon tÃ¼rÃ¼',0),(141701,3937,'pl','SkÅ‚ad typu',0),(141702,3937,'bg','Ð¡ÑŠÑÑ‚Ð°Ð² Ñ‚Ð¸Ð¿',0),(141703,3937,'ur','Ø³Ø§Ø®Øª Ú©ÛŒ Ù‚Ø³Ù…',0),(141704,3937,'sr','Ð¡Ð°ÑÑ‚Ð°Ð² Ñ‚Ð¸Ð¿',0),(141705,3937,'vi','Loáº¡i thÃ nh pháº§n',0),(141706,3937,'af','Samestelling tipe',0),(141707,3937,'ro','Tip de compozitie',0),(141708,3937,'et','Koostise liik',0),(141709,3937,'si','Vrsta sestava',0),(141710,3937,'ba','Komposisi jenis',0),(141711,3937,'nl','Type samenstelling',0),(141712,3937,'fi','Koostumus tyyppi',0),(141713,3937,'no','Kroppsbygning',0),(141714,3937,'da','SammensÃ¦tning Type',0),(141715,3937,'ko','êµ¬ì„± ìœ í˜•',0),(141716,3937,'he','×¡×•×’ ×”×¨×›×‘',0),(141717,3937,'el','Î£ÏÎ½Î¸ÎµÏƒÎ· Ï„ÏÏ€Î¿Ï…',0),(141718,3937,'zh','ç»„æˆåž‹\r\n',0),(141719,3937,'sv','SammansÃ¤ttning typ',0),(141720,3937,'it','Composizione tipo',0),(141721,3937,'tl','',0),(141722,3937,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(141723,3937,'hi','à¤¸à¤‚à¤°à¤šà¤¨à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(141724,3937,'ms','Jenis komposisi',0),(141725,3937,'ar','ØªÙƒÙˆÙŠÙ† Ù†ÙˆØ¹',0),(141726,3937,'fr','Composition Type',0),(141727,3937,'jp','æ§‹æˆ?ã‚¿ã‚¤ãƒ—',0),(141728,3937,'pt','Tipo de composiÃ§Ã£o',0),(141729,3937,'ru','Ð¢Ð¸Ð¿ ÑÐ¾ÑÑ‚Ð°Ð²Ð°',0),(141730,3937,'es','Tipo de ComposiciÃ³n',0),(141731,3937,'de','Zusammensetzung-Typ',0),(141732,3937,'en','Composition Type',0),(141733,3938,'is','',0),(141734,3938,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙˆØ§Ø¨Ø¹ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ±ÙƒÙŠØ¨',0),(141735,3938,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙˆØ§Ø¨Ø¹ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ±ÙƒÙŠØ¨',0),(141736,3938,'tr','Bu kompozisyon iÃ§in gÃ¼ncelleÅŸtirme iÅŸlevleri',0),(141737,3938,'pl','Aktualizacja funkcji dla tego skÅ‚adu',0),(141738,3938,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ ÑÑŠÑÑ‚Ð°Ð²',0),(141739,3938,'ur','Ø§Ø³ Ø³Ø§Ø®Øª Ú©Û’ Ø§ÙØ¹Ø§Ù„ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(141740,3938,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¾Ð²Ð°Ñ˜ ÑÐ°ÑÑ‚Ð°Ð²',0),(141741,3938,'vi','Cáº­p Nháº­t Chá»©c NÄƒng Cho ThÃ nh Pháº§n NÃ y',0),(141742,3938,'af','Opdateer Funksies vir hierdie Samestelling',0),(141743,3938,'ro','FuncÅ£ii de actualizare pentru aceasta compozitie',0),(141744,3938,'et','Muudetud tegevused selle koostis',0),(141745,3938,'si','Posodobi funkcije za ta sestava',0),(141746,3938,'ba','Fungsi update untuk komposisi ini',0),(141747,3938,'nl','Bijwerken van functies voor deze compositie',0),(141748,3938,'fi','PÃ¤ivitys toimintoja kokoonpano',0),(141749,3938,'no','Oppdatere funksjoner for denne komposisjonen',0),(141750,3938,'da','Opdater funktioner til denne sammensÃ¦tning',0),(141751,3938,'ko','ì´ êµ¬ì„±ì— ëŒ€ í•œ ì—…ë°ì´íŠ¸ ê¸°ëŠ¥',0),(141752,3938,'he','×¢×“×›×•×Ÿ ×¤×•× ×§×¦×™×•×ª ×¢×‘×•×¨ ×”×¨×›×‘ ×”×–×”',0),(141753,3938,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¹ÏŽÎ½ Î³Î¹Î± Î±Ï…Ï„Î® ÏƒÏÎ½Î¸ÎµÏƒÎ·',0),(141754,3938,'zh','æ›´æ–°è¿™ä¸ªç»„æˆçš„åŠŸèƒ½\r\n',0),(141755,3938,'sv','Uppdatera funktioner fÃ¶r denna sammansÃ¤ttning',0),(141756,3938,'it','Funzioni di aggiornamento per questa composizione',0),(141757,3938,'tl','',0),(141758,3938,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3609;&#3657;&#3634;&#3607;&#3637;&#3656;&#3586;&#3629;&#3591;&#3626;&#3656;&#3623;&#3609;&#3609;&#3637;&#3657;',0),(141759,3938,'hi','à¤‡à¤¸ à¤¸à¤‚à¤°à¤šà¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾à¤°à¥à¤¯ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(141760,3938,'ms','Fungsi Kemaskini bagi komposisi ini',0),(141761,3938,'ar','ØªØ­Ø¯ÙŠØ« ÙˆØ¸Ø§Ø¦Ù Ù„Ù‡Ø°Ø§ Ø§Ù„ØªØ´ÙƒÙŠÙ„',0),(141762,3938,'fr','Fonctions de mise Ã  jour pour cette Composition',0),(141763,3938,'jp','ã?“ã?®æ§‹æˆ?ã?®æ©Ÿèƒ½ã‚’æ›´æ–°ã?™ã‚‹',0),(141764,3938,'pt','FunÃ§Ãµes de atualizaÃ§Ã£o para esta composiÃ§Ã£o',0),(141765,3938,'ru','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð´Ð»Ñ Ð´Ð°Ð½Ð½Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸',0),(141766,3938,'es','Actualizar Funciones para esta OperaciÃ³n',0),(141767,3938,'de','Update-Funktionen fÃ¼r diese Komposition',0),(141768,3938,'en','Update Functions for this Composition',0),(141769,3939,'is','',0),(141770,3939,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø³Ø§Ø®Øª',0),(141771,3939,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø³Ø§Ø®Øª',0),(141772,3939,'tr','BileÅŸim iÅŸlevleri gÃ¼ncelleÅŸtirme',0),(141773,3939,'pl','SkÅ‚ad funkcje aktualizacji',0),(141774,3939,'bg','Ð¡ÑŠÑÑ‚Ð°Ð² Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(141775,3939,'ur','Ø³Ø§Ø®Øª Ú©Û’ Ø§ÙØ¹Ø§Ù„ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(141776,3939,'sr','Ð¡Ð°ÑÑ‚Ð°Ð² Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(141777,3939,'vi','Cáº­p Nháº­t thÃ nh pháº§n chá»©c nÄƒng ',0),(141778,3939,'af','Saamgestelde Funksies Opdateer',0),(141779,3939,'ro','ComponenÅ£a funcÅ£ii de actualizare',0),(141780,3939,'et','Koostise funktsioonide vÃ¤rskendus',0),(141781,3939,'si','Sestava funkcije Update',0),(141782,3939,'ba','Komposisi fungsi Update',0),(141783,3939,'nl','Samenstelling functies Update',0),(141784,3939,'fi','Koostumus tehtÃ¤vien pÃ¤ivitys',0),(141785,3939,'no','Sammensetning funksjoner oppdatering',0),(141786,3939,'da','SammensÃ¦tning funktioner opdatering',0),(141787,3939,'ko','êµ¬ì„± ê¸°ëŠ¥ ì—…ë°ì´íŠ¸',0),(141788,3939,'he','×§×•×ž×¤×•×–×™×¦×™×” ×¤×•× ×§×¦×™×•×ª ×¢×“×›×•×Ÿ',0),(141789,3939,'el','Î£ÏÎ½Î¸ÎµÏƒÎ· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚',0),(141790,3939,'zh','ç»„æˆèŒèƒ½æ›´æ–°\r\n',0),(141791,3939,'sv','SammansÃ¤ttningen funktioner uppdatering',0),(141792,3939,'it','Composizione funzioni Update',0),(141793,3939,'tl','',0),(141794,3939,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3656;&#3609;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(141795,3939,'hi','à¤¸à¤‚à¤°à¤šà¤¨à¤¾ à¤•à¤¾à¤°à¥à¤¯ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(141796,3939,'ms','Komposisi fungsi Kemaskini',0),(141797,3939,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ù‡Ø§Ù… Ø§Ù„ØªÙƒÙˆÙŠÙ†',0),(141798,3939,'fr','Mise Ã  jour des fonctions de composition',0),(141799,3939,'jp','æ§‹æˆ?æ©Ÿèƒ½ã?®æ›´æ–°',0),(141800,3939,'pt','AtualizaÃ§Ã£o de funÃ§Ãµes de composiÃ§Ã£o',0),(141801,3939,'ru','ÐšÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(141802,3939,'es','Actualizar Funciones de Composiciones ',0),(141803,3939,'de','Zusammensetzung Funktionen Update',0),(141804,3939,'en','Composition Functions Update',0),(141805,3940,'is','',0),(141806,3940,'dr','Ù†Ø§Ù…  ÙØ¹Ø§Ù„ÙŠØª Ø³Ø§Ø®Øª ',0),(141807,3940,'pr','Ù†Ø§Ù…  ÙØ¹Ø§Ù„ÙŠØª Ø³Ø§Ø®Øª ',0),(141808,3940,'tr','Kompozisyon iÅŸlev adÄ±',0),(141809,3940,'pl','Nazwa funkcji skÅ‚ad',0),(141810,3940,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÑŠÑÑ‚Ð°Ð²Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(141811,3940,'ur','ØªØ±Ú©ÛŒØ¨ Ø¯Ø§Ù„Û Ú©Û’ Ù†Ø§Ù…',0),(141812,3940,'sr','Ð˜Ð¼Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ ÑÐ°ÑÑ‚Ð°Ð²',0),(141813,3940,'vi','TÃªn cá»§a chá»©c nÄƒng thÃ nh pháº§n',0),(141814,3940,'af','Naam van samestelling funksie',0),(141815,3940,'ro','Numele funcÅ£iei compoziÅ£ia',0),(141816,3940,'et','Koostise funktsiooni nimi',0),(141817,3940,'si','Ime funkcije sestava',0),(141818,3940,'ba','Nama komposisi fungsi',0),(141819,3940,'nl','Naam van samenstelling functie',0),(141820,3940,'fi','Koostumus funktion nimi',0),(141821,3940,'no','Navnet pÃ¥ komposisjon funksjon',0),(141822,3940,'da','Navnet pÃ¥ sammensÃ¦tningen funktion',0),(141823,3940,'ko','êµ¬ì„± í•¨ìˆ˜ ì´ë¦„',0),(141824,3940,'he','×©× ×©×œ ×¤×•× ×§×¦×™×” ×§×•×ž×¤×•×–×™×¦×™×”',0),(141825,3940,'el','ÎŒÎ½Î¿Î¼Î± ÏƒÏ…Î½Î¬ÏÏ„Î·ÏƒÎ·Ï‚ ÏƒÏÎ½Î¸ÎµÏƒÎ·',0),(141826,3940,'zh','å¤åˆåŠŸèƒ½çš„åç§°\r\n',0),(141827,3940,'sv','Namnet pÃ¥ sammansÃ¤ttning funktion',0),(141828,3940,'it','Nome della funzione di composizione',0),(141829,3940,'tl','',0),(141830,3940,'th','&#3594;&#3639;&#3656;&#3629;&#3586;&#3629;&#3591;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3656;&#3609;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(141831,3940,'hi','à¤¸à¤‚à¤°à¤šà¤¨à¤¾ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤•à¤¾ à¤¨à¤¾à¤®',0),(141832,3940,'ms','Nama fungsi komposisi',0),(141833,3940,'ar','Ø§Ø³Ù… Ø§Ù„Ø¯Ø§Ù„Ø© ØªÙƒÙˆÙŠÙ†',0),(141834,3940,'fr','Nom de la fonction de Composition',0),(141835,3940,'jp','æ§‹æˆ?æ©Ÿèƒ½ã?®å??å‰?',0),(141836,3940,'pt','Nome da funÃ§Ã£o de composiÃ§Ã£o',0),(141837,3940,'ru','Ð˜Ð¼Ñ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸, ÑÐ¾ÑÑ‚Ð°Ð²',0),(141838,3940,'es','Nombre de FunciÃ³n de ComposiciÃ³n',0),(141839,3940,'de','Name der Komposition-Funktion',0),(141840,3940,'en','Name of Composition Function',0),(141841,3941,'is','',0),(141842,3941,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ø³Ø§Ø®Øª',0),(141843,3941,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ø³Ø§Ø®Øª',0),(141844,3941,'tr','Kompozisyon iÅŸlev ekleme',0),(141845,3941,'pl','SkÅ‚ad funkcji Dodaj',0),(141846,3941,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÑŠÑÑ‚Ð°Ð²Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(141847,3941,'ur','ØªØ±Ú©ÛŒØ¨ Ø¯Ø§Ù„Û Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(141848,3941,'sr','Ð”Ð¾Ð´Ð°Ñ˜ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ˜Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°',0),(141849,3941,'vi','ThÃªm chá»©c nÄƒng thÃ nh pháº§n',0),(141850,3941,'af','Samestelling funksie voeg',0),(141851,3941,'ro','FuncÅ£ie de compoziÅ£ia Adauga',0),(141852,3941,'et','Koostise funktsiooni lisada',0),(141853,3941,'si','Sestavi funkcije Dodaj',0),(141854,3941,'ba','Menambahkan komposisi fungsi',0),(141855,3941,'nl','Samenstelling functie toevoegen',0),(141856,3941,'fi','Koostumus funktion lisÃ¤Ã¤minen',0),(141857,3941,'no','Sammensetning funksjonen legge',0),(141858,3941,'da','SammensÃ¦tning funktion tilfÃ¸je',0),(141859,3941,'ko','êµ¬ì„± í•¨ìˆ˜ ì¶”ê°€',0),(141860,3941,'he','×”×•×¡×¤×ª ×¤×•× ×§×¦×™×” ×§×•×ž×¤×•×–×™×¦×™×”',0),(141861,3941,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÏƒÏÎ½Î¸ÎµÏƒÎ· Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(141862,3941,'zh','ç»„åˆåŠŸèƒ½æ·»åŠ \r\n',0),(141863,3941,'sv','SammansÃ¤ttning funktionen LÃ¤gg till',0),(141864,3941,'it','Aggiungere la funzione di composizione',0),(141865,3941,'tl','',0),(141866,3941,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3656;&#3609;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(141867,3941,'hi','à¤¸à¤‚à¤°à¤šà¤¨à¤¾ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(141868,3941,'ms','Menambah fungsi komposisi',0),(141869,3941,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ¸ÙŠÙØ© Ø§Ù„ØªÙƒÙˆÙŠÙ†',0),(141870,3941,'fr','Ajouter la fonction de composition',0),(141871,3941,'jp','æ§‹æˆ?æ©Ÿèƒ½ã?®è¿½åŠ ',0),(141872,3941,'pt','ComposiÃ§Ã£o funÃ§Ã£o adicionar',0),(141873,3941,'ru','Ð¡Ð¾ÑÑ‚Ð°Ð² Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(141874,3941,'es','FunciÃ³n de ComposiciÃ³n Agregada',0),(141875,3941,'de','Zusammensetzung-Funktion hinzufÃ¼gen',0),(141876,3941,'en','Composition Function Add',0),(141877,3942,'is','',0),(141878,3942,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ§Ø¨Ø¹ Ø§Ø³Ø§Ø³Ù†Ø§Ù…Ù‡ (Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯)',0),(141879,3942,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ§Ø¨Ø¹ Ø§Ø³Ø§Ø³Ù†Ø§Ù…Ù‡ (Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯)',0),(141880,3942,'tr','Bu kompozisyon iÅŸlev iÃ§in gÃ¼ncelleÅŸtirme Ã¼cretleri',0),(141881,3942,'pl','Aktualizacja opÅ‚at za ta funkcja skÅ‚adu',0),(141882,3942,'bg','Ð¢Ð°ÐºÑÐ¸ Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸ÑÑ‚Ð° ÑÑŠÑÑ‚Ð°Ð²',0),(141883,3942,'ur','Ø§Ø³ Ú©ÛŒ Ø³Ø§Ø®Øª Ú©ÛŒ ØªÙ‚Ø±ÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Û’ ØªØ­Øª',0),(141884,3942,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ð°Ð¼Ð° Ð·Ð° Ð¾Ð²Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ ÑÐ°ÑÑ‚Ð°Ð²',0),(141885,3942,'vi','Cáº­p Nháº­t Thay Äá»•i Cho ThÃ nh Pháº§n Chá»©c NÄƒng nÃ y',0),(141886,3942,'af','Opdateer Kostes vir hierdie Saamgestelde Funksie',0),(141887,3942,'ro','Taxele de actualizare pentru aceastÄƒ funcÅ£ie de compoziÅ£ia',0),(141888,3942,'et','Update funktsioon koosseisu eest',0),(141889,3942,'si','Posodobitev stroÅ¡kov za to funkcijo sestava',0),(141890,3942,'ba','Biaya pembaruan untuk fungsi komposisi ini',0),(141891,3942,'nl','Update kosten voor deze samenstelling-functie',0),(141892,3942,'fi','PÃ¤ivitys perittÃ¤vÃ¤t kokoonpano-toiminto',0),(141893,3942,'no','Oppdatere kostnader for komposisjon funksjonen',0),(141894,3942,'da','Opdatering gebyrer for denne sammensÃ¦tning funktion',0),(141895,3942,'ko','ì´ êµ¬ì„± ê¸°ëŠ¥ì— ëŒ€ í•œ ì—…ë°ì´íŠ¸ ë¹„ìš©',0),(141896,3942,'he','×¢×“×›×Ÿ ×—×™×•×‘×™× ×¢×‘×•×¨ ×¤×•× ×§×¦×™×” ×–×• ×”×¨×›×‘',0),(141897,3942,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï‡ÏÎµÏŽÏƒÎµÏ‰Î½ Î³Î¹Î± Ï„Î· ÏƒÏ…Î½Î¬ÏÏ„Î·ÏƒÎ· Î±Ï…Ï„Î® ÏƒÏÎ½Î¸ÎµÏƒÎ·',0),(141898,3942,'zh','æ›´æ–°è¿™ä¸ªç»„åˆåŠŸèƒ½æ”¶è´¹\r\n',0),(141899,3942,'sv','Uppdatering avgifter fÃ¶r denna sammansÃ¤ttning funktion',0),(141900,3942,'it','Spese di aggiornamento per questa funzione di composizione',0),(141901,3942,'tl','',0),(141902,3942,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3586;&#3629;&#3',0),(141903,3942,'hi','à¤¯à¤¹ à¤¸à¤‚à¤°à¤šà¤¨à¤¾ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(141904,3942,'ms','Kemaskini caj-caj untuk fungsi komposisi ini',0),(141905,3942,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„ØªØ­Ø¯ÙŠØ« Ù„Ù‡Ø°Ù‡ \"Ø§Ù„Ø¯Ø§Ù„Ø© ØªÙƒÙˆÙŠÙ†\"',0),(141906,3942,'fr','Frais de mise Ã  jour pour cette fonction de la Composition',0),(141907,3942,'jp','ã?“ã?®æ§‹æˆ?æ©Ÿèƒ½ã?®å¤‰æ›´ã?®æ›´æ–°',0),(141908,3942,'pt','Taxas de atualizaÃ§Ã£o para esta funÃ§Ã£o de composiÃ§Ã£o',0),(141909,3942,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ±Ð¾Ñ€Ð¾Ð² Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸',0),(141910,3942,'es','Actualizar Cargos para esta FunciÃ³n de ComposiciÃ³n',0),(141911,3942,'de','Update-GebÃ¼hren fÃ¼r diese Komposition-Funktion',0),(141912,3942,'en','Update Charges for this Composition Function',0),(141913,3943,'is','',0),(141914,3943,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø§Ù†ØªØ®Ø§Ø¨  Ù„ÙŠØ³Øª  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ§Ø¨Ø¹ Ø§Ø³Ø§Ø³Ù†Ø§Ù…Ù‡ (Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯)',0),(141915,3943,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†ØªØ®Ø§Ø¨  Ù„ÙŠØ³Øª  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ§Ø¨Ø¹ Ø§Ø³Ø§Ø³Ù†Ø§Ù…Ù‡ (Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯)',0),(141916,3943,'tr','GÃ¼ncelleÅŸtirme listesi bu kompozisyon iÅŸlev seÃ§in',0),(141917,3943,'pl','Aktualizacja listy wybierz dla tej funkcji skÅ‚ad',0),(141918,3943,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ¿Ð¸ÑÑŠÐº Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸ÑÑ‚Ð° ÑÑŠÑÑ‚Ð°Ð²',0),(141919,3943,'ur','Ø§Ø³ Ø³Ø§Ø®Øª Ú©Û’ ÙØ¹Ù„ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ ÙÛØ±Ø³Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(141920,3943,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð·Ð° Ð¾Ð²Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ ÑÐ°ÑÑ‚Ð°Ð²',0),(141921,3943,'vi','ThÃªm/Cáº­p Nháº­t Danh SÃ¡ch ÄÃ£ Chá»n cho Chá»©c NÄƒng BiÃªn Soáº¡n',0),(141922,3943,'af','Opdateer die Geselekteerde Lys vir hierdie Saamgestelde Funksie',0),(141923,3943,'ro','Update SelectaÈ›i lista pentru aceastÄƒ funcÅ£ie de compoziÅ£ia',0),(141924,3943,'et','VÃ¤rskenduste loendis Valige selle koostise funktsiooni',0),(141925,3943,'si','Izberite seznam posodobitev za sestavo funkcijo',0),(141926,3943,'ba','Memperbarui daftar pilih untuk fungsi komposisi ini',0),(141927,3943,'nl','Selecteer lijst bijwerken voor deze samenstelling functie',0),(141928,3943,'fi','Valitse mainituille kokoonpano-toiminto',0),(141929,3943,'no','Oppdatere listen Velg for komposisjon funksjonen',0),(141930,3943,'da','Opdatere listen VÃ¦lg for denne sammensÃ¦tning funktion',0),(141931,3943,'ko','ì´ êµ¬ì„± ê¸°ëŠ¥ì— ëŒ€ í•œ ì„ íƒ ëª©ë¡ ì—…ë°ì´íŠ¸',0),(141932,3943,'he','×‘×¨×©×™×ž×” ×‘×—×¨ ×¢×“×›×•×Ÿ ×¢×‘×•×¨ ×¤×•× ×§×¦×™×” ×–×• ×”×¨×›×‘',0),(141933,3943,'el','Î›Î¯ÏƒÏ„Î± ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³Î¹Î± Ï„Î· ÏƒÏ…Î½Î¬ÏÏ„Î·ÏƒÎ· Î±Ï…Ï„Î® ÏƒÏÎ½Î¸ÎµÏƒÎ·',0),(141934,3943,'zh','æ›´æ–°è¿™ç§ç»„åˆåŠŸèƒ½çš„é€‰æ‹©ç›®å½•\r\n',0),(141935,3943,'sv','Uppdatera listan VÃ¤lj fÃ¶r denna sammansÃ¤ttning funktion',0),(141936,3943,'it','Aggiornamento elenco selezionare per questa funzione di composizione',0),(141937,3943,'tl','',0),(141938,3943,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3609;&#3626;&#3',0),(141939,3943,'hi','à¤‡à¤¸ à¤°à¤šà¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤¸à¥‚à¤šà¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(141940,3943,'ms','Mengemaskini senarai pilih untuk fungsi komposisi ini',0),(141941,3943,'ar','ØªØ­Ø¯ÙŠØ« \"Ù‚Ø§Ø¦Ù…Ø© Ø­Ø¯Ø¯\" Ù„Ù‡Ø°Ù‡ \"Ø§Ù„Ø¯Ø§Ù„Ø© ØªÙƒÙˆÙŠÙ†\"',0),(141942,3943,'fr','Mise Ã  jour de la liste SÃ©lectionner pour cette fonction de la Composition',0),(141943,3943,'jp','ã?“ã?®æ§‹æˆ?æ©Ÿèƒ½ã?®é?¸æŠžè‚¢ãƒªã‚¹ãƒˆã‚’æ›´æ–°',0),(141944,3943,'pt','Atualizar lista Selecione para esta funÃ§Ã£o de composiÃ§Ã£o',0),(141945,3943,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¹ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(141946,3943,'es','Actualizar Lista de SelecciÃ³n para esta FunciÃ³n de ComposiciÃ³n',0),(141947,3943,'de','WÃ¤hlen Sie Update-Liste fÃ¼r diese Komposition-Funktion',0),(141948,3943,'en','Update Select List for this Composition Function',0),(141949,3944,'is','',0),(141950,3944,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù‚ÙŠÙ…Øª Ø¨Ø±Ø§ÙŠ  ÙØ¹Ø§Ù„ÙŠØª Ø³Ø§Ø®Øª',0),(141951,3944,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù‚ÙŠÙ…Øª Ø¨Ø±Ø§ÙŠ  ÙØ¹Ø§Ù„ÙŠØª Ø³Ø§Ø®Øª',0),(141952,3944,'tr','Kompozisyon iÅŸlevi iÃ§in fiyat gÃ¼ncelleÅŸtirme',0),(141953,3944,'pl','Cena aktualizacji funkcji skÅ‚ad',0),(141954,3944,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ñ†ÐµÐ½Ð°Ñ‚Ð° Ð·Ð° ÑÑŠÑÑ‚Ð°Ð²Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(141955,3944,'ur','Ø³Ø§Ø®Øª ÙØ¹Ù„ Ú©Û’ Ù„Ø¦Û’ Ù‚ÛŒÙ…Øª Ø§Ù¾ ÚˆÛŒÙ¹',0),(141956,3944,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ†ÐµÐ½Ðµ Ð·Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ˜Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°',0),(141957,3944,'vi','Cáº­p Nháº­t GiÃ¡ Cho CÃ¡c ThÃ nh Pháº§n Chá»©c nÄƒng',0),(141958,3944,'af','Prysopdatering vir Saamgestelde Funksie',0),(141959,3944,'ro','Actualizare de preÅ£ pentru funcÅ£ia de compozitie',0),(141960,3944,'et','Hinnauuendus koostise funktsiooni',0),(141961,3944,'si','Posodobitev cene za sestavo funkcijo',0),(141962,3944,'ba','Pembaruan harga untuk komposisi fungsi',0),(141963,3944,'nl','Prijsbijwerking voor samenstelling functie',0),(141964,3944,'fi','HinnanpÃ¤ivitys kokoonpano-toiminto',0),(141965,3944,'no','Prisoppdatering for komposisjon funksjon',0),(141966,3944,'da','Prisopdatering for sammensÃ¦tning funktion',0),(141967,3944,'ko','êµ¬ì„± ê¸°ëŠ¥ì— ëŒ€ í•œ ê°€ê²© ì—…ë°ì´íŠ¸',0),(141968,3944,'he','×¢×“×›×•×Ÿ ×ž×—×™×¨ ×œ×ª×¤×§×•×“ ×”×¨×›×‘',0),(141969,3944,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¹Î¼ÏŽÎ½ Î³Î¹Î± ÏƒÏÎ½Î¸ÎµÏƒÎ· Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(141970,3944,'zh','ä»·æ ¼ç»„åˆåŠŸèƒ½æ›´æ–°\r\n',0),(141971,3944,'sv','Prisuppdatering fÃ¶r sammansÃ¤ttning funktion',0),(141972,3944,'it','Aggiornamento prezzi per funzione di composizione',0),(141973,3944,'tl','',0),(141974,3944,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3656;&#3609;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(141975,3944,'hi','à¤¸à¤‚à¤°à¤šà¤¨à¤¾ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‚à¤²à¥à¤¯ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(141976,3944,'ms','Kemaskini harga bagi fungsi komposisi',0),(141977,3944,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù„ØªÙƒÙˆÙŠÙ† ÙˆØ¸ÙŠÙØ©',0),(141978,3944,'fr','Mise Ã  jour de prix pour la fonction de Composition',0),(141979,3944,'jp','æ§‹æˆ?æ©Ÿèƒ½ã?®ä¾¡æ ¼æ›´æ–°',0),(141980,3944,'pt','AtualizaÃ§Ã£o de preÃ§o para composiÃ§Ã£o de funÃ§Ã£o',0),(141981,3944,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½ Ð´Ð»Ñ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(141982,3944,'es','ActualizaciÃ³n de Precio para FunciÃ³n de ComposiciÃ³n',0),(141983,3944,'de','Preisaktualisierung fÃ¼r Komposition-Funktion',0),(141984,3944,'en','Price Update for Composition Function',0),(141985,3945,'is','',0),(141986,3945,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÙŠØ³Øª Ø«Ø¨Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª Ø³Ø§Ø®Øª',0),(141987,3945,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÙŠØ³Øª Ø«Ø¨Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª Ø³Ø§Ø®Øª',0),(141988,3945,'tr','Bu kompozisyon iÅŸlev iÃ§in liste girdileri seÃ§me',0),(141989,3945,'pl','Wybierz pozycje listy dla tej funkcji skÅ‚ad',0),(141990,3945,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸Ñ‚Ðµ Ð² ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð½Ð° ÑÑŠÑÑ‚Ð°Ð²Ð°',0),(141991,3945,'ur','Ø§Ø³ Ø³Ø§Ø®Øª Ú©Û’ ÙØ¹Ù„ Ú©Û’ Ù„ÛŒÛ’ ÙÛØ±Ø³Øª Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(141992,3945,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð»Ð¸ÑÑ‚Ðµ Ð·Ð° Ð¾Ð²Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ ÑÐ°ÑÑ‚Ð°Ð²',0),(141993,3945,'vi','Chá»n CÃ¡c Entry cho thÃ nh pháº§n chá»©c nÄƒng nÃ y',0),(141994,3945,'af','Kies Lysinskrywings vir hierdie Saamgestelde Funksie',0),(141995,3945,'ro','SelectaÅ£i lista de intrÄƒri pentru aceastÄƒ funcÅ£ie de compoziÅ£ia',0),(141996,3945,'et','Valige kirjed selle koostise funktsiooni',0),(141997,3945,'si','Izberite seznam vnosov za sestavo funkcijo',0),(141998,3945,'ba','Pilih entri daftar untuk fungsi komposisi ini',0),(141999,3945,'nl','Vermeldingen in de lijst selecteren voor de functie van deze samenstelling',0),(142000,3945,'fi','Valitse merkinnÃ¤t kokoonpano-toiminto',0),(142001,3945,'no','Velg oppfÃ¸ringer for komposisjon funksjonen',0),(142002,3945,'da','VÃ¦lg liste indgange til denne sammensÃ¦tning funktion',0),(142003,3945,'ko','ì´ êµ¬ì„± ê¸°ëŠ¥ì— ëŒ€ í•œ ëª©ë¡ í•­ëª©ì„ ì„ íƒ',0),(142004,3945,'he','×‘×—×¨ ×¢×¨×›×™ ×¨×©×™×ž×” ×¢×‘×•×¨ ×¤×•× ×§×¦×™×” ×–×• ×”×¨×›×‘',0),(142005,3945,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ¯ÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î· ÏƒÏ…Î½Î¬ÏÏ„Î·ÏƒÎ· Î±Ï…Ï„Î® ÏƒÏÎ½Î¸ÎµÏƒÎ·',0),(142006,3945,'zh','æ­¤ç»„åˆåŠŸèƒ½çš„é€‰æ‹©åˆ—è¡¨é¡¹\r\n',0),(142007,3945,'sv','Markera poster i listan fÃ¶r denna sammansÃ¤ttning funktion',0),(142008,3945,'it','Selezionare le voci dell\'elenco per questa funzione di composizione',0),(142009,3945,'tl','',0),(142010,3945,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3629;&#3591;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3656;&#3609;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3',0),(142011,3945,'hi','à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤¸à¤‚à¤°à¤šà¤¨à¤¾ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(142012,3945,'ms','Pilih entri senarai untuk fungsi komposisi ini',0),(142013,3945,'ar','Ø­Ø¯Ø¯ \"Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©\" Ù„Ù‡Ø°Ù‡ \"Ø§Ù„Ø¯Ø§Ù„Ø© ØªÙƒÙˆÙŠÙ†\"',0),(142014,3945,'fr','SÃ©lectionnez les entrÃ©es de la liste pour cette fonction de la Composition',0),(142015,3945,'jp','ã?“ã?®æ§‹æˆ?æ©Ÿèƒ½ã?®ãƒªã‚¹ãƒˆã‚¨ãƒ³ãƒˆãƒªãƒ¼ã‚’é?¸æŠž',0),(142016,3945,'pt','Selecione a lista de entradas para esta funÃ§Ã£o de composiÃ§Ã£o',0),(142017,3945,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÑÐ¿Ð¸ÑÐºÐ° Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(142018,3945,'es','Seleccionar Entradas de Lista para esta FunciÃ³n de ComposiciÃ³n',0),(142019,3945,'de','WÃ¤hlen Sie EintrÃ¤ge fÃ¼r diese Komposition-Funktion',0),(142020,3945,'en','Select List Entries for this Composition Function',0),(142021,3946,'is','',0),(142022,3946,'dr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(142023,3946,'pr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(142024,3946,'tr','Fiyat/Ä°K',0),(142025,3946,'pl','Cena/Hr',0),(142026,3946,'bg','Ð¦ÐµÐ½Ð°/Hr',0),(142027,3946,'ur','Ù‚ÛŒÙ…Øª/Hr',0),(142028,3946,'sr','Ð¦ÐµÐ½Ð°/Ð¥Ñ€',0),(142029,3946,'vi','GiÃ¡/Giá»',0),(142030,3946,'af','Prys/Uur',0),(142031,3946,'ro','PreÅ£/orÄƒ',0),(142032,3946,'et','Hind/Hr',0),(142033,3946,'si','Cena/Hr',0),(142034,3946,'ba','Harga/Hr',0),(142035,3946,'nl','Prijs/Hr',0),(142036,3946,'fi','Hinta/h',0),(142037,3946,'no','Pris/Hr',0),(142038,3946,'da','Pris/Hr',0),(142039,3946,'ko','ê°€ê²©/Hr',0),(142040,3946,'he','×ž×—×™×¨ ×œ×©×¢×”',0),(142041,3946,'el','Î¤Î¹Î¼Î®/Hr',0),(142042,3946,'zh','ä»·æ ¼/å°æ—¶\r\n',0),(142043,3946,'sv','Pris/timme',0),(142044,3946,'it','Prezzo/Hr',0),(142045,3946,'tl','',0),(142046,3946,'th','&#3619;&#3634;&#3588;&#3634;/&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(142047,3946,'hi','à¤•à¥€à¤®à¤¤/Hr',0),(142048,3946,'ms','Harga/Hr',0),(142049,3946,'ar','Ø§Ù„Ø³Ø¹Ø±/Ø§Ù„Ù…ÙˆØ§Ø±Ø¯ Ø§Ù„Ø¨Ø´Ø±ÙŠØ©',0),(142050,3946,'fr','Prix/Hr',0),(142051,3946,'jp','å€¤æ®µ/æ™‚é–“',0),(142052,3946,'pt','PreÃ§o/Hr',0),(142053,3946,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ/Ð§Ð°Ñ',0),(142054,3946,'es','Precio/Hora',0),(142055,3946,'de','Preis/Stunde',0),(142056,3946,'en','Price/Hr',0),(142057,3947,'is','',0),(142058,3947,'dr','/ Ø³Ø§Ø¹Øª ',0),(142059,3947,'pr','Ù‡Ø²ÙŠÙ†Ù‡ / Ø³Ø§Ø¹Øª ',0),(142060,3947,'tr','Maliyet/Ä°K',0),(142061,3947,'pl','Koszt/Hr',0),(142062,3947,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸/Hr',0),(142063,3947,'ur','Ù„Ø§Ú¯Øª/Hr',0),(142064,3947,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº/Ð¥Ñ€',0),(142065,3947,'vi','GiÃ¡ / giá»',0),(142066,3947,'af','Koste/Uur',0),(142067,3947,'ro','Cost/orÄƒ',0),(142068,3947,'et','Kulu/Hr',0),(142069,3947,'si','StroÅ¡ki/Hr',0),(142070,3947,'ba','Biaya/Hr',0),(142071,3947,'nl','Kosten/Hr',0),(142072,3947,'fi','Kustannukset/Hr',0),(142073,3947,'no','Kostnad/Hr',0),(142074,3947,'da','Omkostninger/Hr',0),(142075,3947,'ko','ë¹„ìš©/ì‹œê°„',0),(142076,3947,'he','×¢×œ×•×ª ×œ×©×¢×”',0),(142077,3947,'el','ÎšÏŒÏƒÏ„Î¿Ï‚/Hr',0),(142078,3947,'zh','æˆæœ¬/å°æ—¶\r\n',0),(142079,3947,'sv','Kostnad/timme',0),(142080,3947,'it','Costo/Hr',0),(142081,3947,'tl','',0),(142082,3947,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;/&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(142083,3947,'hi','à¤²à¤¾à¤—à¤¤/Hr',0),(142084,3947,'ms','Kos/Sumber Manusia',0),(142085,3947,'ar','Ø§Ù„ØªÙƒÙ„ÙØ©/Ø§Ù„Ù…ÙˆØ§Ø±Ø¯ Ø§Ù„Ø¨Ø´Ø±ÙŠØ©',0),(142086,3947,'fr','CoÃ»t/Hr',0),(142087,3947,'jp','è²»ç”¨/æ™‚é–“',0),(142088,3947,'pt','Custo/Hr',0),(142089,3947,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ/Hr',0),(142090,3947,'es','Costo/Hora',0),(142091,3947,'de','Kosten/Std.',0),(142092,3947,'en','Cost/Hr',0),(142093,3948,'is','',0),(142094,3948,'dr','Ø²Ù…Ø§Ù† ',0),(142095,3948,'pr','Ø²Ù…Ø§Ù† ',0),(142096,3948,'tr','Zaman',0),(142097,3948,'pl','Czas',0),(142098,3948,'bg','Ð’Ñ€ÐµÐ¼Ðµ',0),(142099,3948,'ur','ÙˆÙ‚Øª',0),(142100,3948,'sr','Ð’Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(142101,3948,'vi','Thá»i gian',0),(142102,3948,'af','Tyd',0),(142103,3948,'ro','Timp',0),(142104,3948,'et','Aeg',0),(142105,3948,'si','ÄŒas',0),(142106,3948,'ba','Waktu',0),(142107,3948,'nl','Tijd',0),(142108,3948,'fi','Aika',0),(142109,3948,'no','Tid',0),(142110,3948,'da','Tid',0),(142111,3948,'ko','ì‹œê°„',0),(142112,3948,'he','×–×ž×Ÿ',0),(142113,3948,'el','Î§ÏÏŒÎ½Î¿Ï‚',0),(142114,3948,'zh','æ—¶é—´\r\n',0),(142115,3948,'sv','Tid',0),(142116,3948,'it','Tempo',0),(142117,3948,'tl','',0),(142118,3948,'th','&#3648;&#3623;&#3621;&#3634;',0),(142119,3948,'hi','à¤¸à¤®à¤¯',0),(142120,3948,'ms','Masa',0),(142121,3948,'ar','Ø§Ù„ÙˆÙ‚Øª',0),(142122,3948,'fr','Temps',0),(142123,3948,'jp','æ™‚é–“',0),(142124,3948,'pt','Tempo',0),(142125,3948,'ru','Ð’Ñ€ÐµÐ¼Ñ',0),(142126,3948,'es','Tiempo',0),(142127,3948,'de','Zeit',0),(142128,3948,'en','Time',0),(142129,3949,'is','',0),(142130,3949,'dr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(142131,3949,'pr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(142132,3949,'tr','Malzemeleri',0),(142133,3949,'pl','MateriaÅ‚y',0),(142134,3949,'bg','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸',0),(142135,3949,'ur','Ù…ÙˆØ§Ø¯',0),(142136,3949,'sr','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð¸',0),(142137,3949,'vi','Váº­t liá»‡u',0),(142138,3949,'af','Materiale',0),(142139,3949,'ro','Materiale',0),(142140,3949,'et','Materjalid',0),(142141,3949,'si','Materialov',0),(142142,3949,'ba','Bahan',0),(142143,3949,'nl','Materialen',0),(142144,3949,'fi','Materiaalit',0),(142145,3949,'no','Materialer',0),(142146,3949,'da','Materialer',0),(142147,3949,'ko','ìž¬ë£Œ',0),(142148,3949,'he','×—×•×ž×¨×™×',0),(142149,3949,'el','Î¥Î»Î¹ÎºÎ¬',0),(142150,3949,'zh','ææ–™\r\n',0),(142151,3949,'sv','Material',0),(142152,3949,'it','Materiali',0),(142153,3949,'tl','',0),(142154,3949,'th','&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(142155,3949,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€',0),(142156,3949,'ms','Bahan-bahan',0),(142157,3949,'ar','Ø§Ù„Ù…ÙˆØ§Ø¯',0),(142158,3949,'fr','MatÃ©riaux',0),(142159,3949,'jp','è³‡æ–™',0),(142160,3949,'pt','Materiais',0),(142161,3949,'ru','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹',0),(142162,3949,'es','Materiales',0),(142163,3949,'de','Materialien',0),(142164,3949,'en','Materials',0),(142165,3950,'is','',0),(142166,3950,'dr','Ù‚ÙŠÙ…Øª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ ',0),(142167,3950,'pr','Ù‚ÙŠÙ…Øª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ ',0),(142168,3950,'tr','Toplam fiyatÄ±',0),(142169,3950,'pl','Cena',0),(142170,3950,'bg','ÐžÑ‡Ð°ÐºÐ²Ð°Ð½Ð° Ñ†ÐµÐ½Ð°',0),(142171,3950,'ur','ØªÙˆØ³ÛŒØ¹ Ú©Ø±Ø¯Û Ù‚ÛŒÙ…Øª',0),(142172,3950,'sr','ÐŸÑ€Ð¾ÑˆÐ¸Ñ€ÐµÐ½Ð° Ñ†ÐµÐ½Ð°',0),(142173,3950,'vi','GiÃ¡ gia háº¡n',0),(142174,3950,'af','Uitgebreide prys',0),(142175,3950,'ro','Pret extinsÄƒ',0),(142176,3950,'et','Laiendatud hind',0),(142177,3950,'si','Skupna cena',0),(142178,3950,'ba','Harga diperpanjang',0),(142179,3950,'nl','Factuurprijs',0),(142180,3950,'fi','Laajennettu hinta',0),(142181,3950,'no','Utvidet pris',0),(142182,3950,'da','Udvidede pris',0),(142183,3950,'ko','í™•ìž¥ ëœ ê°€ê²©',0),(142184,3950,'he','×”×ž×—×™×¨ ×”×ž×•×¨×—×‘',0),(142185,3950,'el','Î”Î¹ÎµÏ…ÏÏ…Î¼Î­Î½Î· Ï„Î¹Î¼Î®',0),(142186,3950,'zh','æ€»ä»·\r\n',0),(142187,3950,'sv','UtÃ¶kat pris',0),(142188,3950,'it','Prezzo complessivo',0),(142189,3950,'tl','',0),(142190,3950,'th','&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3586;&#3618;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(142191,3950,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°à¤¿à¤¤ à¤®à¥‚à¤²à¥à¤¯',0),(142192,3950,'ms','Harga dilanjutkan',0),(142193,3950,'ar','Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ù…ÙˆØ³Ø¹',0),(142194,3950,'fr','Prix total',0),(142195,3950,'jp','æ‹¡å¼µä¾¡æ ¼',0),(142196,3950,'pt','PreÃ§o estendido',0),(142197,3950,'ru','ÐžÑ‚Ð¿ÑƒÑÐºÐ½Ð¾Ð¹ Ñ†ÐµÐ½Ñ‹',0),(142198,3950,'es','Precio Extendido',0),(142199,3950,'de','Endpreis',0),(142200,3950,'en','Extended Price',0),(142201,3951,'is','',0),(142202,3951,'dr','(Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡) Ø¯Ø± Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(142203,3951,'pr','Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´Ø¯Ù‡(Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡) Ø¯Ø± Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(142204,3951,'tr','(Fiyat dahil)',0),(142205,3951,'pl','(Wliczone w ceny)',0),(142206,3951,'bg','(Ð’ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¾ Ð² Ñ†ÐµÐ½Ð°Ñ‚Ð°)',0),(142207,3951,'ur','(Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ù…ÛŒÚº Ø´Ø§Ù…Ù„)',0),(142208,3951,'sr','(Ð£ÐºÑ™ÑƒÑ‡ÐµÐ½ Ñƒ Ð¾Ð´Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ†ÐµÐ½Ð°)',0),(142209,3951,'vi','(ÄÃ£ bao gá»“m trong giÃ¡)',0),(142210,3951,'af','(Ingesluit by Prysberekening)',0),(142211,3951,'ro','(Inclus Ã®n preÅ£)',0),(142212,3951,'et','(Sisaldub hinnas)',0),(142213,3951,'si','(VkljuÄeno v ceno)',0),(142214,3951,'ba','(Termasuk dalam harga)',0),(142215,3951,'nl','(Inbegrepen in de prijs)',0),(142216,3951,'fi','(SisÃ¤ltyy hintaan)',0),(142217,3951,'no','(Inkludert i prisen)',0),(142218,3951,'da','(Inkluderet i pris)',0),(142219,3951,'ko','(ê°€ê²©ì— í¬í•¨)',0),(142220,3951,'he','(×›×•×œ×œ ×ž×—×™×¨×™×)',0),(142221,3951,'el','(Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÏ„Î±Î¹ ÏƒÏ„Î·Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·)',0),(142222,3951,'zh','ï¼ˆå®šä»·ä¸­å«ï¼‰\r\n',0),(142223,3951,'sv','(IngÃ¥r i prissÃ¤ttning)',0),(142224,3951,'it','(Incluso nel prezzo)',0),(142225,3951,'tl','',0),(142226,3951,'th','&#3619;&#3623;&#3617;&#3651;&#3609;&#3619;&#3634;&#3588;&#3634;&#3649;&#3621;&#3657;&#3623;',0),(142227,3951,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤²)',0),(142228,3951,'ms','(Termasuk dalam harga)',0),(142229,3951,'ar','(Ø§Ù„Ù…Ø¯Ø±Ø¬Ø© ÙÙŠ Ø§Ù„ØªØ³Ø¹ÙŠØ±)',0),(142230,3951,'fr','(Inclus dans le prix)',0),(142231,3951,'jp','ï¼ˆå€¤ä»˜ã?‘ã?«å?«ã?¾ã‚Œã‚‹ï¼‰',0),(142232,3951,'pt','(IncluÃ­do no preÃ§o)',0),(142233,3951,'ru','(Ð’ÐºÐ»ÑŽÑ‡ÐµÐ½ Ð² ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ)',0),(142234,3951,'es','(Incluido en Precio)',0),(142235,3951,'de','(Im Preis inbegriffen)',0),(142236,3951,'en','(Included in Pricing)',0),(142237,3952,'is','',0),(142238,3952,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(142239,3952,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(142240,3952,'tr','DueDate geÃ§miÅŸi',0),(142241,3952,'pl','Historia DueDate',0),(142242,3952,'bg','Duedate Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(142243,3952,'ur','Ø¯ÙˆØ§Ø¯Ø§Ù¹ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(142244,3952,'sr','ÐšÑ€Ð°Ñ˜Ð½Ð¸ Ñ€Ð¾Ðº Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(142245,3952,'vi','Lá»‹ch sá»­ ngÃ y Ä‘áº¿n háº¡n',0),(142246,3952,'af','Verskuldigde Datum Geskiedenis',0),(142247,3952,'ro','Istoria Duedate',0),(142248,3952,'et','Duedate ajalugu',0),(142249,3952,'si','Da bi duedate zgodovine',0),(142250,3952,'ba','Perlu sejarah',0),(142251,3952,'nl','DueDate geschiedenis',0),(142252,3952,'fi','Parasta historia',0),(142253,3952,'no','Duedate historie',0),(142254,3952,'da','Duedate historie',0),(142255,3952,'ko','Duedate ì—­ì‚¬',0),(142256,3952,'he','×”×™×¡×˜×•×¨×™×” Duedate',0),(142257,3952,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(142258,3952,'zh','åˆ°æœŸæ—¥çš„åŽ†å²\r\n',0),(142259,3952,'sv','DueDate historia',0),(142260,3952,'it','Storia DueDate',0),(142261,3952,'tl','',0),(142262,3952,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(142263,3952,'hi','Duedate à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(142264,3952,'ms','Duedate sejarah',0),(142265,3952,'ar','ØªØ§Ø±ÙŠØ® Ø¯ÙˆÙŠØ¯Ø§ØªÙŠ',0),(142266,3952,'fr','DueDate histoire',0),(142267,3952,'jp','ç· åˆ‡æœŸæ—¥å±¥æ­´',0),(142268,3952,'pt','HistÃ³ria de DueDate',0),(142269,3952,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ DueDate',0),(142270,3952,'es','Fecha de Vencimiento Historia',0),(142271,3952,'de','DueDate-Geschichte',0),(142272,3952,'en','Duedate History',0),(142273,3953,'is','',0),(142274,3953,'dr','ÙˆÙ‚ØªÙŠ ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(142275,3953,'pr','ÙˆÙ‚ØªÙŠ ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(142276,3953,'tr','Zaman deÄŸiÅŸti',0),(142277,3953,'pl','Po zmianie',0),(142278,3953,'bg','ÐŸÑ€Ð¸ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð°',0),(142279,3953,'ur','Ø¬Ø¨ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(142280,3953,'sr','ÐšÐ°Ð´Ð° ÑÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð»Ð¾',0),(142281,3953,'vi','Khi thay Ä‘á»•i',0),(142282,3953,'af','Het Wanneer Verander',0),(142283,3953,'ro','Atunci cÃ¢nd a schimbat',0),(142284,3953,'et','Kui on muudetud',0),(142285,3953,'si','Kadar se spremeni',0),(142286,3953,'ba','Ketika berubah',0),(142287,3953,'nl','Wanneer gewijzigd',0),(142288,3953,'fi','Muuttuessa',0),(142289,3953,'no','NÃ¥r endres',0),(142290,3953,'da','NÃ¥r Ã¦ndret',0),(142291,3953,'ko','ë³€ê²½ í•˜ëŠ” ê²½ìš°',0),(142292,3953,'he','×›××©×¨ ×ž×©×ª× ×”',0),(142293,3953,'el','ÎŒÏ„Î±Î½ Î±Î»Î»Î¬Î¾ÎµÎ¹',0),(142294,3953,'zh','å½“\r\n',0),(142295,3953,'sv','NÃ¤r Ã¤ndras',0),(142296,3953,'it','Quando modificate',0),(142297,3953,'tl','',0),(142298,3953,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3648;&#3617;&#3639;&#3656;&#3629;&#3652;&#3627;&#3619;&#3656;',0),(142299,3953,'hi','à¤œà¤¬ à¤¬à¤¦à¤²à¤¾',0),(142300,3953,'ms','Apabila diubah',0),(142301,3953,'ar','Ø¹Ù†Ø¯ ØªØºÙŠÙŠØ±',0),(142302,3953,'fr','Quand a changÃ©',0),(142303,3953,'jp','å¤‰æ›´æ™‚',0),(142304,3953,'pt','Quando alterado',0),(142305,3953,'ru','ÐŸÑ€Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¸',0),(142306,3953,'es','Cuando se CambiÃ³',0),(142307,3953,'de','Wenn geÃ¤ndert',0),(142308,3953,'en','When',0),(142309,3954,'is','',0),(142310,3954,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(142311,3954,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(142312,3954,'tr','MÃ¼ÅŸteri PO',0),(142313,3954,'pl','Klient PO',0),(142314,3954,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ PO',0),(142315,3954,'ur','Ú©Ø³Ù¹Ù…Ø± Ù¾Ùˆ',0),(142316,3954,'sr','ÐšÑƒÐ¿Ð°Ñ† ÐŸÐž',0),(142317,3954,'vi','ÄÆ¡n mua hÃ ng KhÃ¡ch hÃ ng',0),(142318,3954,'af','Klant / KliÃ«nt AN',0),(142319,3954,'ro','Client PO',0),(142320,3954,'et','Kliendi ostutellimus',0),(142321,3954,'si','Kupca PO',0),(142322,3954,'ba','Pelanggan PO',0),(142323,3954,'nl','Klant PO',0),(142324,3954,'fi','Asiakkaan PO',0),(142325,3954,'no','Kunden PO',0),(142326,3954,'da','Kunde PO',0),(142327,3954,'ko','ê³ ê° PO',0),(142328,3954,'he','×œ×§×•×—×•×ª ×¤×•',0),(142329,3954,'el','Î ÎµÎ»Î±Ï„ÏŽÎ½ Î±Î½Î¬',0),(142330,3954,'zh','å®¢æˆ·è®¢å•\r\n',0),(142331,3954,'sv','Kundens InkÃ¶psordernummer',0),(142332,3954,'it','Ufficio Postale cliente',0),(142333,3954,'tl','',0),(142334,3954,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(142335,3954,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¥‹',0),(142336,3954,'ms','Baca PO',0),(142337,3954,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¨Ùˆ',0),(142338,3954,'fr','Client PO',0),(142339,3954,'jp','é¡§å®¢æ³¨æ–‡æ›¸',0),(142340,3954,'pt','Cliente PO',0),(142341,3954,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ PO',0),(142342,3954,'es','Cliente OC',0),(142343,3954,'de','Kunde PO',0),(142344,3954,'en','Customer PO',0),(142345,3955,'is','',0),(142346,3955,'dr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ Ø±Ø§ Ø¯Ø± Ø·ÙŠ Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ ',0),(142347,3955,'pr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ Ø±Ø§ Ø¯Ø± Ø·ÙŠ Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ ',0),(142348,3955,'tr','Talimatlar sipariÅŸ giriÅŸi sÄ±rasÄ±nda sorabilir miyim?',0),(142349,3955,'pl','Zapytaj instrukcje podczas wprowadzania zamÃ³wieÅ„?',0),(142350,3955,'bg','ÐŸÐ¸Ñ‚Ð°Ð¹ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸?',0),(142351,3955,'ur','ÛØ¯Ø§ÛŒØ§Øª Ù…ÛŒÚº Ø¢Ø±ÚˆØ± Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ú©ÛÛŒÚºØŸ',0),(142352,3955,'sr','ÐŸÐ¸Ñ‚Ð°Ñ˜ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ñ‚Ð¾ÐºÐ¾Ð¼ ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð°?',0),(142353,3955,'vi','Cáº§n HÆ°á»›ng Dáº«n Khi Nháº­p ÄÆ¡n HÃ ng?',0),(142354,3955,'af','Vra instruksies tydens orde inskrywing?',0),(142355,3955,'ro','Cere instrucÅ£iunile Ã®n timpul ordin intrare?',0),(142356,3955,'et','KÃ¼sima juhiseid tellimuse sisestamise kÃ¤igus?',0),(142357,3955,'si','VpraÅ¡ajte navodila med naroÄila?',0),(142358,3955,'ba','Bertanya petunjuk selama masuk pesanan?',0),(142359,3955,'nl','Vragen instructies tijdens orderinvoer?',0),(142360,3955,'fi','Kysy ohjeita tilausta?',0),(142361,3955,'no','SpÃ¸r instruksjoner ved bestilling?',0),(142362,3955,'da','SpÃ¸rg instruktioner under ordreindtastning?',0),(142363,3955,'ko','ì£¼ë¬¸ ìž…ë ¥ í•˜ëŠ” ë™ì•ˆ ì§€ì¹¨ì„ ë¬¼ì–´?',0),(142364,3955,'he','×œ×‘×§×© ×”×•×¨××•×ª ×‘×ž×”×œ×š ×”×–× ×ª ×”×”×–×ž× ×”?',0),(142365,3955,'el','Î–Î·Ï„Î®ÏƒÏ‰ Î¿Î´Î·Î³Î¯ÎµÏ‚ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±;',0),(142366,3955,'zh','è¦æ±‚åœ¨è®¢å•è¾“å…¥æŒ‡ä»¤ï¼Ÿ\r\n',0),(142367,3955,'sv','FrÃ¥ga instruktioner under orderregistreringen?',0),(142368,3955,'it','Chiedere istruzioni durante l\'immissione dell\'ordine?',0),(142369,3955,'tl','',0),(142370,3955,'th','&#3606;&#3634;&#3617;&#3619;&#3632;&#3618;&#3632;&#3585;&#3634;&#3619;&#3649;&#3609;&#3632;&#3609;&#3635;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(142371,3955,'hi','à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤•à¥à¤°à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤ªà¥‚à¤›à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(142372,3955,'ms','Tanya arahan semasa kemasukan pesanan?',0),(142373,3955,'ar','Ø£Ø·Ù„Ø¨ Ø¥Ø±Ø´Ø§Ø¯Ø§Øª Ø£Ø«Ù†Ø§Ø¡ Ø¯Ø®ÙˆÙ„ Ø§Ù„Ù†Ø¸Ø§Ù…ØŸ',0),(142374,3955,'fr','Demander les Instructions pendant la saisie de l\'ordre ?',0),(142375,3955,'jp','å?—æ³¨ä¸­ã‚¤ãƒ³ã‚¹ãƒˆãƒ©ã‚¯ã‚·ãƒ§ãƒ³ã‚’è?žã??ã?¾ã?™ã?‹ï¼Ÿ',0),(142376,3955,'pt','Pedir instruÃ§Ãµes durante a entrada de ordem?',0),(142377,3955,'ru','ÐŸÐ¾Ð¿Ñ€Ð¾ÑÐ¸Ñ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ñ Ð²Ð²Ð¾Ð´Ð° Ð·Ð°ÐºÐ°Ð·Ð°?',0),(142378,3955,'es','Pedir Instrucciones Durante Entrada de Pedidos',0),(142379,3955,'de','Fragen Sie Anweisungen wÃ¤hrend der Auftragserfassung?',0),(142380,3955,'en','Ask Instructions during Order Entry?',0),(142381,3956,'is','',0),(142382,3956,'dr','_Ø­Ù…Ù„ Ø¨Ù‡ _',0),(142383,3956,'pr','Ø§ÙØ²ÙˆØ¯Ù† _Ø­Ù…Ù„ Ø¨Ù‡ _',0),(142384,3956,'tr','Gemiye Ekle',0),(142385,3956,'pl','DodaÄ‡ statku',0),(142386,3956,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(142387,3956,'ur','Ú©Ø´ØªÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(142388,3956,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð±Ñ€Ð¾Ð´ Ð´Ð°',0),(142389,3956,'vi','ThÃªm Chuyá»ƒn Äáº¿n',0),(142390,3956,'af','Versend Aan Byvoeg',0),(142391,3956,'ro','Adauga nava sÄƒ',0),(142392,3956,'et','Lisa tarneaadress',0),(142393,3956,'si','Dodaj ladji',0),(142394,3956,'ba','Tambahkan kapal untuk',0),(142395,3956,'nl','Verzendadres toevoegen',0),(142396,3956,'fi','LisÃ¤Ã¤ aluksen',0),(142397,3956,'no','Legge til skip',0),(142398,3956,'da','TilfÃ¸je skib til',0),(142399,3956,'ko','ë°°ë¥¼ ì¶”ê°€',0),(142400,3956,'he','×”×•×¡×£ ××ª ×”×¡×¤×™× ×”',0),(142401,3956,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î± Ï€Î»Î¿Î¯Ï‰Î½ Î½Î±',0),(142402,3956,'zh','å¢žåŠ äº¤è´§ç‚¹\r\n',0),(142403,3956,'sv','LÃ¤gg till fartyget fÃ¶r att',0),(142404,3956,'it','Aggiungi nave a',0),(142405,3956,'tl','',0),(142406,3956,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3606;&#3638;&#3591;',0),(142407,3956,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(142408,3956,'ms','Tambah kapal',0),(142409,3956,'ar','Ø£Ø¶Ù Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(142410,3956,'fr','Ajouter Ship To',0),(142411,3956,'jp','ç™ºé€?å…ˆè¿½åŠ ',0),(142412,3956,'pt','Adicionar o navio para',0),(142413,3956,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑƒÐ´Ð½Ð¾',0),(142414,3956,'es','Agregar Enviar A',0),(142415,3956,'de','FÃ¼gen Sie Ship zu',0),(142416,3956,'en','Add Ship To',0),(142417,3957,'is','',0),(142418,3957,'dr','Ø³ÙØ§Ø±Ø´ ÙˆÙŠÚ˜Ù‡ Ú†Ø§Ù¾ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±ØŸ',0),(142419,3957,'pr','Ø³ÙØ§Ø±Ø´ ÙˆÙŠÚ˜Ù‡ Ú†Ø§Ù¾ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±ØŸ',0),(142420,3957,'tr','Ã–zel sipariÅŸ basÄ±n stok?',0),(142421,3957,'pl','Specjalne zamÃ³wienia naciÅ›nij przycisk Stock?',0),(142422,3957,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÑÑŠÑÑ‚Ð°Ð²?',0),(142423,3957,'ur','Ø®ØµÙˆØµÛŒ Ø­Ú©Ù… Ù¾Ø±ÛŒØ³ Ø§Ø³Ù¹Ø§Ú©ØŸ',0),(142424,3957,'sr','ÐŸÐ¾ÑÐµÐ±Ð½Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ?',0),(142425,3957,'vi','ÄÆ¡n hÃ ng Ä‘áº·c biá»‡t chuyá»ƒn sang hÃ ng tá»“n kho?',0),(142426,3957,'af','Spesiale bestelling Press voorraad?',0),(142427,3957,'ro','Speciale pentru presÄƒ stoc?',0),(142428,3957,'et','Eritellimisel Press laos?',0),(142429,3957,'si','Posebnem naroÄilu tiska Stock?',0),(142430,3957,'ba','Pesanan khusus pers saham?',0),(142431,3957,'nl','Speciale bestelling druk op voorraad?',0),(142432,3957,'fi','Tilauksesta paina varastossa?',0),(142433,3957,'no','Spesialbestilling trykk lager?',0),(142434,3957,'da','Specialordre Tryk pÃ¥ lager?',0),(142435,3957,'ko','íŠ¹ë³„ ì£¼ë¬¸ ë³´ë„ ì‚¬ì§„?',0),(142436,3957,'he','×”×–×ž× ×” ×ž×™×•×—×“×ª ×”×¢×™×ª×•× ×•×ª ×ž× ×™×•×ª?',0),(142437,3957,'el','\"Î•Î¹Î´Î¹ÎºÎ® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±\" Ï„ÏÏ€Î¿Ï… Î±Ï€ÏŒÎ¸ÎµÎ¼Î±;',0),(142438,3957,'zh','ç‰¹åˆ«è®¢è´­æŒ‰è‚¡ç¥¨ï¼Ÿ\r\n',0),(142439,3957,'sv','Specialorder tryck pÃ¥ lager?',0),(142440,3957,'it','Ordine speciale stampa Stock?',0),(142441,3957,'tl','',0),(142442,3957,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3648;&#3593;&#3614;&#3634;&#3632;&#3585;&#3604;&#3611;&#3640;&#3656;&#3617;&#3626;&#3605;&#3658;&#3629;&#3588;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(142443,3957,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¥‡à¤¸ à¤¶à¥‡à¤¯à¤°?',0),(142444,3957,'ms','Tempahan Khas akhbar saham?',0),(142445,3957,'ar','Ø£Ù…Ø± Ø®Ø§Øµ Ø§Ù„ØµØ­Ø§ÙØ© Ø§Ù„Ø£Ø³Ù‡Ù…ØŸ',0),(142446,3957,'fr','Commande spÃ©ciale presse Stock ?',0),(142447,3957,'jp','Special Order Press Stock?',0),(142448,3957,'pt','Ordem especial imprensa Stock?',0),(142449,3957,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð· Ð¿Ñ€ÐµÑÑ ÑÐºÐ»Ð°Ð´Ðµ?',0),(142450,3957,'es','Orden Especial de Stock para Imprimir',0),(142451,3957,'de','Sonderauftrag Presse einzubringen?',0),(142452,3957,'en','Special Order Press Stock?',0),(142453,3958,'is','',0),(142454,3958,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø¨Ø¹Ø¯  Ø§Ø² ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ±  Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡  Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(142455,3958,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø¨Ø¹Ø¯  Ø§Ø² ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ±  Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡  Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(142456,3958,'tr','Ã–denmemiÅŸ gÃ¼n son sipariÅŸ giriÅŸ uyarÄ± iÃ§in gecikmiÅŸ dÃ¼ÅŸÃ¼nmeye tarihi fatura',0),(142457,3958,'pl','Data do rozwaÅ¼enia jako zalegÅ‚ych dla zamÃ³wienia wpis ostrzeÅ¼enia faktury niezapÅ‚acone dni ostatnich',0),(142458,3958,'bg','ÐÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð´Ð½Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð´Ð°Ñ‚Ð° Ð´Ð° ÑÐµ Ñ€Ð°Ð·Ð³Ð»ÐµÐ´Ð° ÐºÐ°Ñ‚Ð¾ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸ Ð·Ð° Ð¿Ñ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð° Ð·Ð°Ð¿Ð¸Ñ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(142459,3958,'ur','ØªØ§Ø±ÛŒØ® Ø¢Ø±ÚˆØ± Ø§Ù†Ù¹Ø±ÛŒ ØªÙ†Ø¨ÛŒÛ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù…ÙˆØ®Ø± Ù¾Ø± ØºÙˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û Ø¯Ù† Ú¯Ø²Ø´ØªÛ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(142460,3958,'sr','ÐŸÑ€Ð¾Ñ‚ÐµÐºÐ»Ð¸Ñ… Ð½ÐµÐ¿Ð»Ð°Ñ›ÐµÐ½Ð¸Ñ… Ð´Ð°Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð´Ð° Ñ€Ð°Ð·Ð¼Ð¾Ñ‚Ñ€Ð¸ ÑÐ° Ð¿Ñ€ÐµÐºÐ¾Ñ€Ð°Ñ‡ÐµÐ½Ð¸Ð¼ Ñ€Ð¾ÐºÐ¾Ð¼ Ð·Ð° Ñ€ÐµÐ´ Ð¡Ñ‚Ð°Ð²ÐºÐ° ÑƒÐ¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ',0),(142461,3958,'vi','Nháº­p cáº£nh bÃ¡o sá»‘ ngÃ y quÃ¡ háº¡n thanh toÃ¡n cho Ä‘Æ¡n hÃ ng',0),(142462,3958,'af','Onbetaalde dae afgelope faktuur datum om te oorweeg as agterstallige vir orde inskrywing waarskuwing',0),(142463,3958,'ro','NeplÄƒtite zile trecut factura data sÄƒ ia Ã®n considerare ca restante pentru avertizare de intrare comanda',0),(142464,3958,'et','Tasumata pÃ¤eva viimase arve kuupÃ¤ev kaaluda nii ammu et kanne hoiatus',0),(142465,3958,'si','Preteklih dni neplaÄanega raÄuna datum upoÅ¡tevati kot zapadla za naroÄilo vnos opozorilo',0),(142466,3958,'ba','Tidak dibayar hari masa lalu faktur tanggal untuk mempertimbangkan sebagai terlambat untuk urutan catatan peringatan',0),(142467,3958,'nl','Onbetaalde dagen afgelopen factuurdatum te overwegen als te laat voor de order entry waarschuwing',0),(142468,3958,'fi','Maksamattomat pÃ¤ivÃ¤Ã¤ laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ harkitsemaan myÃ¶hÃ¤ssÃ¤ jotta merkintÃ¤ varoitus',0),(142469,3958,'no','Ubetalte dager etter fakturadato vurdere som forfalt for ordre oppfÃ¸ring advarsel',0),(142470,3958,'da','Ubetalte dage sidste faktura dato at betragte som forfalden til orden post advarsel',0),(142471,3958,'ko','ë¬´ ë³´ìˆ˜ ì¼ ì†¡ìž¥ ë‚ ì§œ ìˆœì„œ í•­ëª© ê²½ê³ ì— ëŒ€ í•œ ì—°ì²´ ê³ ë ¤ í•˜',0),(142472,3958,'he','×™×ž×™× ×©×œ× ×©×•×œ×ž×• ×—×©×‘×•× ×™×•×ª ×ª××¨×™×š ×œ×©×§×•×œ ×¢×“×™× ×•×ª ×›×ž×• ×¡×“×¨ ×”×›× ×™×¡×” ××–×”×¨×”',0),(142473,3958,'el','Î‘Ï€Î»Î®ÏÏ‰Ï„Î¿Î¹ Î·Î¼Î­ÏÎµÏ‚ Ï€Î±ÏÎµÎ»Î¸ÏŒÎ½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î½Î± ÎµÎ¾ÎµÏ„Î¬ÏƒÎµÎ¹ Ï‰Ï‚ ÎµÎºÏ€ÏÏŒÎ¸ÎµÏƒÎ¼ÎµÏ‚ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(142474,3958,'zh','æœªä»˜æ˜”æ—¥å‘ç¥¨æ—¥æœŸè§†ä¸ºé€¾æœŸè®¢å•è¾“å…¥è­¦å‘Š\r\n',0),(142475,3958,'sv','Obetalda dagar efter fakturadatum Ã¶vervÃ¤ga sÃ¥ fÃ¶rfallna fÃ¶r order post varning',0),(142476,3958,'it','Data da considerare come scaduti per avviso voce ordine della fattura non pagati giorni passati',0),(142477,3958,'tl','',0),(142478,3958,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3588;&#3657;&#3634;&#3591;&#3594;&#3635;&#3619;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657; &#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634;&#',0),(142479,3958,'hi','à¤…à¤µà¥ˆà¤¤à¤¨à¤¿à¤• à¤ªà¤¿à¤›à¤²à¥‡ à¤¦à¤¿à¤¨à¥‹à¤‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥à¤°à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤šà¥‡à¤¤à¤¾à¤µà¤¨à¥€ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤…à¤¤à¤¿à¤¦à¥‡à¤¯ à¤ªà¤° à¤µà¤¿à¤šà¤¾à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(142480,3958,'ms','Tidak bergaji hari lalu invois tarikh untuk mempertimbangkan seperti tertunggak bagi perintah kemasukan amaran',0),(142481,3958,'ar','Ø¯ÙˆÙ† Ø£Ø¬Ø± Ø§Ù„Ø£ÙŠØ§Ù… Ø§Ù„Ù…Ø§Ø¶ÙŠØ© Ø§Ù„ÙØ§ØªÙˆØ±Ø© ØªØ§Ø±ÙŠØ® Ø§Ù„Ù†Ø¸Ø± ÙƒÙ…Ø§ ØªØ£Ø®Ø± Ù„Ø£Ù…Ø± Ø¥Ø¯Ø®Ø§Ù„ ØªØ­Ø°ÙŠØ±',0),(142482,3958,'fr','Durant les jours passÃ©s date dâ€™examiner aussi en retard pour lâ€™avertissement dâ€™entrÃ©e afin de la facture',0),(142483,3958,'jp','æœŸé™?çµŒé?Žã?¨ã?¿ã?ªã?•ã‚Œã€?è­¦å‘Šã‚’å‡ºã?•ã‚Œã‚‹è«‹æ±‚æ›¸æœŸæ—¥ã‚’é?Žã?Žã?Ÿæœªæ‰•ã?„æ—¥æ•°',0),(142484,3958,'pt','Dias nÃ£o pagos data de fatura passada para considerar como vencido para o aviso de entrada de ordem',0),(142485,3958,'ru','ÐÐµÐ¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð´Ð½Ð¸ ÑÑ‡ÐµÑ‚Ð° Ð”Ð°Ñ‚Ð° Ð´Ð»Ñ Ñ€Ð°ÑÑÐ¼Ð¾Ñ‚Ñ€ÐµÐ½Ð¸Ñ ÐºÐ°Ðº Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð´Ð»Ñ Ð¿Ñ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ñ Ð²Ð²Ð¾Ð´Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(142486,3958,'es','DÃ­as no pagados desde la fecha de la factura para considerar vencida para el aviso de introducir el orden',0),(142487,3958,'de','Unbezahlte Tage letzten Rechnungsdatum als Ã¼berfÃ¤llig fÃ¼r Bestellung Eintrag Warnung betrachten',0),(142488,3958,'en','Unpaid days past invoice date to consider as overdue for order entry warning',0),(142489,3959,'is','',0),(142490,3959,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ú†Ø§Ù¾ ',0),(142491,3959,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ú†Ø§Ù¾ ',0),(142492,3959,'tr','YazdÄ±rma kategorisi gÃ¼ncelleÅŸtirme',0),(142493,3959,'pl','Drukowanie kategorii aktualizacji',0),(142494,3959,'bg','ÐŸÐµÑ‡Ð°Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(142495,3959,'ur','Ø·Ø¨Ø§Ø¹Øª Ø²Ù…Ø±Û ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(142496,3959,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(142497,3959,'vi','Cáº­p Nháº­t Thá»ƒ Loáº¡i In',0),(142498,3959,'af','Druk kategorie bywerking',0),(142499,3959,'ro','Categoria Update de imprimare',0),(142500,3959,'et','Printimise kategooria Update',0),(142501,3959,'si','Tiskanje kategorije posodobitev',0),(142502,3959,'ba','Percetakan kategori Update',0),(142503,3959,'nl','Afdrukken categorie Update',0),(142504,3959,'fi','Tulostaminen luokka pÃ¤ivitys',0),(142505,3959,'no','Utskrift kategori oppdatering',0),(142506,3959,'da','Udskrivning kategori opdatering',0),(142507,3959,'ko','ì¸ì‡„ ë²”ì£¼ ì—…ë°ì´íŠ¸',0),(142508,3959,'he','×¢×“×›×•×Ÿ ×§×˜×’×•×¨×™×” ×”×“×¤×¡×”',0),(142509,3959,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(142510,3959,'zh','æ‰“å°åˆ†ç±»æ›´æ–°\r\n',0),(142511,3959,'sv','Utskrift kategori uppdatering',0),(142512,3959,'it','Aggiornamento categoria stampa',0),(142513,3959,'tl','',0),(142514,3959,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(142515,3959,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(142516,3959,'ms','Percetakan kategori Kemaskini',0),(142517,3959,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙØ¦Ø© Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(142518,3959,'fr','Mise Ã  jour de la catÃ©gorie d\'impression',0),(142519,3959,'jp','å?°åˆ·ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®æ›´æ–°',0),(142520,3959,'pt','ImpressÃ£o categoria atualizaÃ§Ã£o',0),(142521,3959,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ ÐŸÐµÑ‡Ð°Ñ‚Ð¸',0),(142522,3959,'es','ActualizaciÃ³n de CategorÃ­a de Imprenta',0),(142523,3959,'de','Drucken Kategorie-Update',0),(142524,3959,'en','Printing Category Update',0),(142525,3960,'is','',0),(142526,3960,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ú†Ø§Ù¾ ',0),(142527,3960,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ú†Ø§Ù¾ ',0),(142528,3960,'tr','YazdÄ±rma kategorisi Ekle',0),(142529,3960,'pl','Drukowanie kategorii Dodaj',0),(142530,3960,'bg','ÐŸÐµÑ‡Ð°Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(142531,3960,'ur','Ø·Ø¨Ø§Ø¹Øª Ø²Ù…Ø±Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(142532,3960,'sr','Ð”Ð¾Ð´Ð°Ñ˜ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(142533,3960,'vi','ThÃªm thá»ƒ loáº¡i in',0),(142534,3960,'af','Druk kategorie voeg',0),(142535,3960,'ro','Adauga categorie de imprimare',0),(142536,3960,'et','Printimise kategooria lisamine',0),(142537,3960,'si','Tiskanje kategorije dodate',0),(142538,3960,'ba','Tambahkan kategori Percetakan',0),(142539,3960,'nl','Categorie Afdrukken toevoegen',0),(142540,3960,'fi','Tulostaminen luokka lisÃ¤Ã¤',0),(142541,3960,'no','Printing kategori legge',0),(142542,3960,'da','Udskrivning kategori tilfÃ¸je',0),(142543,3960,'ko','ì¸ì‡„ ë²”ì£¼ ì¶”ê°€',0),(142544,3960,'he','×”×•×¡×£ ×§×˜×’×•×¨×™×” ×”×“×¤×¡×”',0),(142545,3960,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(142546,3960,'zh','æ‰“å°åˆ†ç±»æ·»åŠ \r\n',0),(142547,3960,'sv','Utskrift kategori LÃ¤gg till',0),(142548,3960,'it','Aggiungi categoria stampa',0),(142549,3960,'tl','',0),(142550,3960,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(142551,3960,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(142552,3960,'ms','Tambah Kategori percetakan',0),(142553,3960,'ar','Ø¥Ø¶Ø§ÙØ© ÙØ¦Ø© Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(142554,3960,'fr','Ajouter catÃ©gorie impression',0),(142555,3960,'jp','å?°åˆ·ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®è¿½åŠ ',0),(142556,3960,'pt','Categoria de impressÃ£o adicionar',0),(142557,3960,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ ÐŸÐµÑ‡Ð°Ñ‚Ð¸',0),(142558,3960,'es','Agregar CategorÃ­a de Imprenta',0),(142559,3960,'de','Drucken Kategorie hinzufÃ¼gen',0),(142560,3960,'en','Printing Category Add',0),(142561,3961,'is','',0),(142562,3961,'dr','Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´',0),(142563,3961,'pr','Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´',0),(142564,3961,'tr','SatÄ±ÅŸ Kategori',0),(142565,3961,'pl','SprzedaÅ¼y kategorii',0),(142566,3961,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(142567,3961,'ur','Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û',0),(142568,3961,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(142569,3961,'vi','Thá»ƒ loáº¡i bÃ¡n hÃ ng',0),(142570,3961,'af','Verkope Kategorie',0),(142571,3961,'ro','VÃ¢nzÄƒri Categorie',0),(142572,3961,'et','MÃ¼Ã¼k kategooria',0),(142573,3961,'si','Prodaja kategorije',0),(142574,3961,'ba','Penjualan Kategori',0),(142575,3961,'nl','Verkoop categorie',0),(142576,3961,'fi','Myyntiluokan',0),(142577,3961,'no','Salg kategori',0),(142578,3961,'da','Salgskategori',0),(142579,3961,'ko','íŒë§¤ ì¹´í…Œê³ ë¦¬',0),(142580,3961,'he','×§×˜×’×•×¨×™×™×ª ×ž×›×™×¨×•×ª',0),(142581,3961,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(142582,3961,'zh','é”€å”®ç±»\r\n',0),(142583,3961,'sv','FÃ¶rsÃ¤ljningskategori',0),(142584,3961,'it','Categoria vendita',0),(142585,3961,'tl','',0),(142586,3961,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(142587,3961,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(142588,3961,'ms','Kategori jualan',0),(142589,3961,'ar','ØªØµÙ†ÙŠÙ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(142590,3961,'fr','CatÃ©gorie de ventes',0),(142591,3961,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(142592,3961,'pt','Categoria vendas',0),(142593,3961,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(142594,3961,'es','CategorÃ­a de Ventas',0),(142595,3961,'de','Verkauf Kategorie',0),(142596,3961,'en','Sales Category',0),(142597,3962,'is','',0),(142598,3962,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ø¬Ø¯ÙŠØ¯ ',0),(142599,3962,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ø¬Ø¯ÙŠØ¯ ',0),(142600,3962,'tr','Yeni YazdÄ±rma dÃ¼zeni',0),(142601,3962,'pl','Nowe zamÃ³wienie drukowania',0),(142602,3962,'bg','ÐÐ¾Ð² Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(142603,3962,'ur','Ù†Ø¦Û’ Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ',0),(142604,3962,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ°',0),(142605,3962,'vi','ÄÆ¡n Äáº·t HÃ ng  In Má»›i',0),(142606,3962,'af','Nuwe Uitgedrukte Bestelling',0),(142607,3962,'ro','Noua ordine de imprimare',0),(142608,3962,'et','Prindi viitemÃ¤rgi',0),(142609,3962,'si','Nov vrstni red tiskanja',0),(142610,3962,'ba','Orde Baru cetak',0),(142611,3962,'nl','Nieuwe afdrukvolgorde',0),(142612,3962,'fi','Uusi tulostusjÃ¤rjestys',0),(142613,3962,'no','Ny rekkefÃ¸lge',0),(142614,3962,'da','Nye udskriftsrÃ¦kkefÃ¸lgen',0),(142615,3962,'ko','ìƒˆë¡œìš´ ì¸ì‡„ ìˆœì„œ',0),(142616,3962,'he','×¡×“×¨ ×”×“×¤×¡×” ×—×“×©',0),(142617,3962,'el','ÎÎ­Î± ÏƒÎµÎ¹ÏÎ¬ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(142618,3962,'zh','å¢žåŠ æ–°çš„æ‰“å°è®¢å•\r\n',0),(142619,3962,'sv','Ny utskriftsorder',0),(142620,3962,'it','Nuovo ordine di stampa',0),(142621,3962,'tl','',0),(142622,3962,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(142623,3962,'hi','à¤¨à¤ˆ à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤®',0),(142624,3962,'ms','Pesanan cetakan baru',0),(142625,3962,'ar','Ø£Ù…Ø± Ø·Ø¨Ø§Ø¹Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(142626,3962,'fr','Nouvelle commande dâ€™impression',0),(142627,3962,'jp','æ–°è¦?å?°åˆ·æ³¨æ–‡',0),(142628,3962,'pt','Nova ordem de impressÃ£o',0),(142629,3962,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(142630,3962,'es','Nuevo Pedido de ImpresiÃ³n',0),(142631,3962,'de','Neuen Druckauftrag',0),(142632,3962,'en','New Print Order',0),(142633,3963,'is','',0),(142634,3963,'dr','Ø¬Ø§ÙŠ ÙˆÙŠÚ˜Ù‡ Ø¨Ø±Ú†Ø³Ø¨ ',0),(142635,3963,'pr','Ø¬Ø§ÙŠ ÙˆÙŠÚ˜Ù‡ Ø¨Ø±Ú†Ø³Ø¨ ',0),(142636,3963,'tr','Kutusu etiketi',0),(142637,3963,'pl','Etykieta pola',0),(142638,3963,'bg','Ð•Ñ‚Ð¸ÐºÐµÑ‚ Ð½Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð¾',0),(142639,3963,'ur','Ø®Ø§Ù†Û Ù„ÛŒØ¨Ù„',0),(142640,3963,'sr','ÐŸÐ¾Ñ™Ðµ Ð·Ð° Ð¾Ð·Ð½Ð°ÐºÑƒ',0),(142641,3963,'vi','NhÃ£n há»™p',0),(142642,3963,'af','Karton Etiket',0),(142643,3963,'ro','Eticheta casetei',0),(142644,3963,'et','Box Label',0),(142645,3963,'si','Oznako polja',0),(142646,3963,'ba','Kotak Label',0),(142647,3963,'nl','Vak Label',0),(142648,3963,'fi','Hakuruudun otsikko',0),(142649,3963,'no','Etikett',0),(142650,3963,'da','Etiket til sÃ¸gefeltet',0),(142651,3963,'ko','ìƒìž ë ˆì´ë¸”',0),(142652,3963,'he','×ª×•×•×™×ª ×§×•×¤×¡×',0),(142653,3963,'el','Î•Ï„Î¹ÎºÎ­Ï„Î± Ï€Î»Î±Î¹ÏƒÎ¯Î¿Ï…',0),(142654,3963,'zh','æ¡†æ ‡ç­¾\r\n',0),(142655,3963,'sv','Etikett',0),(142656,3963,'it','Etichetta della scatola',0),(142657,3963,'tl','',0),(142658,3963,'th','&#3593;&#3621;&#3634;&#3585;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(142659,3963,'hi','à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥‡ à¤²à¥‡à¤¬à¤²',0),(142660,3963,'ms','Label kotak',0),(142661,3963,'ar','ØªØ³Ù…ÙŠØ© Ù…Ø±Ø¨Ø¹',0),(142662,3963,'fr','Ã‰tiquette de la zone',0),(142663,3963,'jp','ãƒœãƒƒã‚¯ã‚¹ãƒ©ãƒ™ãƒ«',0),(142664,3963,'pt','Etiqueta da caixa',0),(142665,3963,'ru','ÐœÐµÑ‚ÐºÐ°',0),(142666,3963,'es','Etiqueta de Caja',0),(142667,3963,'de','Feld Etikett',0),(142668,3963,'en','Box Label',0),(142669,3964,'is','',0),(142670,3964,'dr','Ú†Ø§Ù¾ Ø±Ø³ÙŠØ¯ Ø¶Ù…ÙŠÙ…Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(142671,3964,'pr','Ú†Ø§Ù¾ Ø±Ø³ÙŠØ¯ Ø¶Ù…ÙŠÙ…Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(142672,3964,'tr','Sevk irsaliyesi',0),(142673,3964,'pl','Opakowanie poÅ›lizgu',0),(142674,3964,'bg','ÐžÐ¿Ð°ÐºÐ¾Ð²Ð°Ð½Ðµ Ð¿Ñ€Ð¸Ð¿Ð»ÑŠÐ·Ð²Ð°Ð½Ðµ',0),(142675,3964,'ur','Ù¾ÛŒÚ©Ø§Ù†Ú¯ Ù¾Ø±Ú†ÛŒ',0),(142676,3964,'sr','ÐŸÐ°ÐºÐ¾Ð²Ð°ÑšÐµ Ð¡Ð»Ð¸Ð¿',0),(142677,3964,'vi','Phiáº¿u Ä‘Ã³ng hÃ ng',0),(142678,3964,'af','Packing strokie',0),(142679,3964,'ro','Ambalare alunecare',0),(142680,3964,'et','Pakkimiskeskuse libisemine',0),(142681,3964,'si','EmbalaÅ¾e-zdrsa',0),(142682,3964,'ba','Slip pengepakan',0),(142683,3964,'nl','Verpakking Slip',0),(142684,3964,'fi','Pakkaus lipsahdus',0),(142685,3964,'no','Pakking Slip',0),(142686,3964,'da','Pakning Slip',0),(142687,3964,'ko','íŒ¨í‚¹ ìŠ¬ë¦½',0),(142688,3964,'he','p,eh, trhzv',0),(142689,3964,'el','Î£Ï…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î±Ï‚ Î¿Î»Î¯ÏƒÎ¸Î·ÏƒÎ·Ï‚',0),(142690,3964,'zh','è£…ç®±å•\r\n',0),(142691,3964,'sv','FÃ¶rpackning Slip',0),(142692,3964,'it','Macchine per imballaggio Slip',0),(142693,3964,'tl','',0),(142694,3964,'th','&#3626;&#3621;&#3636;&#3611;&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;',0),(142695,3964,'hi','à¤ªà¥ˆà¤•à¤¿à¤‚à¤— à¤ªà¤°à¥à¤šà¥€',0),(142696,3964,'ms','Packing Slip',0),(142697,3964,'ar','ÙƒØ´Ù Ø§Ù„ØªØ¹Ø¨Ø¦Ø©',0),(142698,3964,'fr','Bordereau d\'emballage',0),(142699,3964,'jp','æ¢±åŒ…ä¼?ç¥¨',0),(142700,3964,'pt','Embalagem Slip',0),(142701,3964,'ru','Ð£Ð¿Ð°ÐºÐ¾Ð²ÐºÐ¸ ÑÐºÐ¾Ð»ÑŒÐ¶ÐµÐ½Ð¸Ñ',0),(142702,3964,'es','Lista de Empaque',0),(142703,3964,'de','Packing Slip',0),(142704,3964,'en','Packing Slip',0),(142705,3965,'is','',0),(142706,3965,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‡Ø§',0),(142707,3965,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‡Ø§',0),(142708,3965,'tr','BoyutlarÄ± GÃ¼ncelleÅŸtir',0),(142709,3965,'pl','Aktualizacja rozmiarÃ³w',0),(142710,3965,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€Ð¸',0),(142711,3965,'ur','Ø³Ø§Ø¦Ø² Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(142712,3965,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(142713,3965,'vi','Cáº­p Nháº­t KÃ­ch Cá»¡',0),(142714,3965,'af','Opdateer Groottes',0),(142715,3965,'ro','Dimensiuni de actualizare',0),(142716,3965,'et','Muudetud suurusega',0),(142717,3965,'si','Posodobitev velikosti',0),(142718,3965,'ba','Memperbarui ukuran',0),(142719,3965,'nl','Update maten',0),(142720,3965,'fi','PÃ¤ivitÃ¤ koot',0),(142721,3965,'no','Oppdatere stÃ¸rrelser',0),(142722,3965,'da','Opdatere stÃ¸rrelser',0),(142723,3965,'ko','ì—…ë°ì´íŠ¸ í¬ê¸°',0),(142724,3965,'he','×¢×“×›×•×Ÿ ×’×“×œ×™×',0),(142725,3965,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼ÎµÎ³Î­Î¸Î·',0),(142726,3965,'zh','æ›´æ–°å°ºå¯¸\r\n',0),(142727,3965,'sv','Uppdatera storlekar',0),(142728,3965,'it','Aggiornamento formati',0),(142729,3965,'tl','',0),(142730,3965,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3609;&#3634;&#3604;',0),(142731,3965,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤†à¤•à¤¾à¤°',0),(142732,3965,'ms','Kemaskini Terakhir saiz',0),(142733,3965,'ar','Ø£Ø­Ø¬Ø§Ù… Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(142734,3965,'fr','Mise Ã  jour de tailles',0),(142735,3965,'jp','ã‚µã‚¤ã‚ºæ›´æ–°',0),(142736,3965,'pt','Tamanhos de atualizaÃ§Ã£o',0),(142737,3965,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°Ð·Ð¼ÐµÑ€Ð¾Ð²',0),(142738,3965,'es','Actualizar TamaÃ±os',0),(142739,3965,'de','Update-GrÃ¶ÃŸen',0),(142740,3965,'en','Update Sizes',0),(142741,3966,'is','',0),(142742,3966,'dr','Ù„ÙŠØ³Øª Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú†Ø§Ù¾  Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(142743,3966,'pr','Ù„ÙŠØ³Øª Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú†Ø§Ù¾  Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(142744,3966,'tr','Hisse senedi basÄ±n boyut listesi',0),(142745,3966,'pl','PieÅ„ prasy rozmiar listy',0),(142746,3966,'bg','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ð° Ð½Ð°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÑÐ¿Ð¸ÑÑŠÐºÐ° Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(142747,3966,'ur','Ø§Ø³Ù¹Ø§Ú© Ù¾Ø±ÛŒØ³ Ú©Û’ Ø³Ø§Ø¦Ø² Ú©ÛŒ ÙÛØ±Ø³Øª',0),(142748,3966,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð»Ð¸ÑÑ‚Ð°',0),(142749,3966,'vi','Danh sÃ¡ch cá»¡ hÃ ng bÃ¡o chÃ­ tá»“n',0),(142750,3966,'af','Voorraad Press grootte lys',0),(142751,3966,'ro','Lista de dimensiuni presa stoc',0),(142752,3966,'et','Varude Press suurus loend',0),(142753,3966,'si','Seznam velikosti zalog Press',0),(142754,3966,'ba','Daftar ukuran celana saham',0),(142755,3966,'nl','Voorraad Press grootte lijst',0),(142756,3966,'fi','Varastossa paina koko-luettelosta',0),(142757,3966,'no','Lager trykk-listen',0),(142758,3966,'da','Stock tryk stÃ¸rrelse liste',0),(142759,3966,'ko','ì‚¬ì§„ ë³´ë„ í¬ê¸° ëª©ë¡',0),(142760,3966,'he','×”×¢×™×ª×•× ×•×ª ×ž× ×™×•×ª ×’×•×“×œ ×”×¨×©×™×ž×”',0),(142761,3966,'el','Î›Î¯ÏƒÏ„Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î¼ÎµÏ„Î¿Ï‡ÏŽÎ½ Ï„ÏÏ€Î¿Ï…',0),(142762,3966,'zh','è‚¡ç¥¨æŒ‰å°ºå¯¸è¡¨\r\n',0),(142763,3966,'sv','Listan med lager tryck',0),(142764,3966,'it','Elenco dimensioni stampa magazzino',0),(142765,3966,'tl','',0),(142766,3966,'th','&#3626;&#3605;&#3658;&#3629;&#3588;&#3585;&#3604;&#3611;&#3640;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3609;&#3634;&#3604;',0),(142767,3966,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤ªà¥à¤°à¥‡à¤¸ à¤†à¤•à¤¾à¤° à¤¸à¥‚à¤šà¥€',0),(142768,3966,'ms','Senarai saiz Seluar saham',0),(142769,3966,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø¬Ù… Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„ØµØ­Ø§ÙØ©',0),(142770,3966,'fr','Stock presse taille liste',0),(142771,3966,'jp','åœ¨åº«ãƒ—ãƒ¬ã‚¹ã‚µã‚¤ã‚ºãƒªã‚¹ãƒˆ',0),(142772,3966,'pt','Lista de tamanho de estoque imprensa',0),(142773,3966,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð¿Ñ€ÐµÑÑ',0),(142774,3966,'es','Lista de TamaÃ±o de Imprenta de Stock',0),(142775,3966,'de','Hat GrÃ¶ÃŸe-Presseverteiler',0),(142776,3966,'en','Stock Press Size List',0),(142777,3967,'is','',0),(142778,3967,'dr','ØªØ¹ÙŠÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª Ø¬Ø¯ÙŠØ¯',0),(142779,3967,'pr','ØªØ¹ÙŠÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª Ø¬Ø¯ÙŠØ¯',0),(142780,3967,'tr','Yeni eylem atama',0),(142781,3967,'pl','PrzypisaÄ‡ nowÄ… akcjÄ™',0),(142782,3967,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(142783,3967,'ur','Ù†Ø¦Û’ Ø¹Ù…Ù„ Ú©Ùˆ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(142784,3967,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ñ€Ð°Ð´ÑšÑƒ',0),(142785,3967,'vi','Chá»‰ Äá»‹nh HÃ nh Äá»™ng Má»›i',0),(142786,3967,'af','Nuwe Aksie Toestaan',0),(142787,3967,'ro','Atribui noua acÅ£iune',0),(142788,3967,'et','MÃ¤Ã¤ra uus tegevus',0),(142789,3967,'si','Dodelite nov ukrep.',0),(142790,3967,'ba','Menetapkan tindakan baru',0),(142791,3967,'nl','Nieuwe actie toewijzen',0),(142792,3967,'fi','MÃ¤Ã¤ritÃ¤ uusi toiminto',0),(142793,3967,'no','Tilordne nye',0),(142794,3967,'da','Tildele nye handling',0),(142795,3967,'ko','ìƒˆ ìž‘ì—… í• ë‹¹',0),(142796,3967,'he','×œ×”×§×¦×•×ª ×¤×¢×•×œ×” ×—×“×©×”',0),(142797,3967,'el','Î•ÎºÏ‡Ï‰ÏÎ®ÏƒÎµÏ„Îµ Î½Î­Î± Î´ÏÎ¬ÏƒÎ·',0),(142798,3967,'zh','æŒ‡å®šæ–°åŠ¨ä½œ\r\n',0),(142799,3967,'sv','Tilldela nya Ã¥tgÃ¤rd',0),(142800,3967,'it','Assegnare la nuova azione',0),(142801,3967,'tl','',0),(142802,3967,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3651;&#3627;&#3617;&#3656;',0),(142803,3967,'hi','à¤¨à¤ˆ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(142804,3967,'ms','Memperuntukkan tindakan baru',0),(142805,3967,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(142806,3967,'fr','Assigner une Action nouvelle',0),(142807,3967,'jp','æ–°è¦?ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã?®å‰²ã‚Šå½“ã?¦',0),(142808,3967,'pt','Atribuir nova aÃ§Ã£o',0),(142809,3967,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(142810,3967,'es','Asignar Nueva AcciÃ³n',0),(142811,3967,'de','Neue Aktion zuweisen',0),(142812,3967,'en','Assign New Action',0),(142813,3968,'is','',0),(142814,3968,'dr','ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(142815,3968,'pr','ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(142816,3968,'tr','TamamlanmÄ±ÅŸ eylem',0),(142817,3968,'pl','Akcja zakoÅ„czone',0),(142818,3968,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(142819,3968,'ur','Ù…Ú©Ù…Ù„ Ø¹Ù…Ù„',0),(142820,3968,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸Ñ… Ð°ÐºÑ†Ð¸Ñ˜Ð°',0),(142821,3968,'vi','HÃ nh Ä‘á»™ng hoÃ n thÃ nh',0),(142822,3968,'af','Voltooide Aksie',0),(142823,3968,'ro','Completat de acÅ£iune',0),(142824,3968,'et','LÃµpetatud tegevuste',0),(142825,3968,'si','DokonÄana dejanja',0),(142826,3968,'ba','Tindakan yang sudah lengkap',0),(142827,3968,'nl','Voltooide actie',0),(142828,3968,'fi','Teko',0),(142829,3968,'no','FullfÃ¸rt handling',0),(142830,3968,'da','FuldfÃ¸rt handling',0),(142831,3968,'ko','ì™„ë£Œ ëœ ìž‘ì—…',0),(142832,3968,'he','×”×¤×¢×•×œ×” ×”×•×©×œ×ž×”',0),(142833,3968,'el','ÎŸÎ»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½Î· ÎµÎ½Î­ÏÎ³ÎµÎ¹Î±',0),(142834,3968,'zh','å®ŒæˆåŠ¨ä½œ\r\n',0),(142835,3968,'sv','GenomfÃ¶rda Ã¥tgÃ¤rder',0),(142836,3968,'it','Azione completata',0),(142837,3968,'tl','',0),(142838,3968,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;',0),(142839,3968,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(142840,3968,'ms','Tindakan selesai',0),(142841,3968,'ar','Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ù…Ù†Ø¬Ø²Ø©',0),(142842,3968,'fr','Action terminÃ©e',0),(142843,3968,'jp','å®Œäº†ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(142844,3968,'pt','AÃ§Ã£o concluÃ­da',0),(142845,3968,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ð¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(142846,3968,'es','AcciÃ³n Completado',0),(142847,3968,'de','Abgeschlossene Aktion',0),(142848,3968,'en','Completed Action',0),(142849,3969,'is','',0),(142850,3969,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ ',0),(142851,3969,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ ',0),(142852,3969,'tr','Mevcut mÃ¼ÅŸteriler<br>SatÄ±ÅŸ bilgileri',0),(142853,3969,'pl','Klienci z istniejÄ…cych<br>Informacje dotyczÄ…ce sprzedaÅ¼y',0),(142854,3969,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸ ÑÑŠÑ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸<br>Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(142855,3969,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ù…ÙˆØ¬ÙˆØ¯Û Ú©Û’ Ø³Ø§ØªÚ¾<br>Ø³ÛŒÙ„Ø² Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(142856,3969,'sr','ÐšÑƒÐ¿Ñ†Ð¸ ÑÐ° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸Ð¼<br>Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¸',0),(142857,3969,'vi','KhÃ¡ch hÃ ng vá»›ithÃ´ng tin kinh doanh hiá»‡n táº¡i',0),(142858,3969,'af','KliÃ«nte met bestaande<br>Verkope inligting',0),(142859,3969,'ro','ClienÅ£ii cu existente<br>InformaÈ›ii vÃ¢nzÄƒri',0),(142860,3969,'et','Hotelli olemasolevate<br>MÃ¼Ã¼giinfo',0),(142861,3969,'si','Stranke z obstojeÄimi<br>Informacije o prodaji',0),(142862,3969,'ba','Pelanggan yang sudah ada<br>Informasi penjualan',0),(142863,3969,'nl','Klanten met bestaande<br>Informatie over de verkoop',0),(142864,3969,'fi','Asiakkaat, joilla on olemassa<br>Myyntitiedot',0),(142865,3969,'no','Kunder med eksisterende<br>Informasjon',0),(142866,3969,'da','Kunder med eksisterende<br>Salgsoplysninger',0),(142867,3969,'ko','ê¸°ì¡´ ê³ ê°<br>íŒë§¤ ì •ë³´',0),(142868,3969,'he','×œ×œ×§×•×—×•×ª ×§×™×™×ž×™×<br>×ž×™×“×¢ ××•×“×•×ª ×ž×›×™×¨×•×ª',0),(142869,3969,'el','Î¤Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î¼Îµ Ï„Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î±<br>Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(142870,3969,'zh','é”€å”®å®¢æˆ·ä¸ŽçŽ°æœ‰çš„é”€å”®ä¿¡æ¯\r\n',0),(142871,3969,'sv','Kunder med befintliga<br>FÃ¶rsÃ¤ljningsinformation',0),(142872,3969,'it','Clienti con esistente<br>Informazioni sulle vendite',0),(142873,3969,'tl','',0),(142874,3969,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3617;&#3637;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3629;&#3618;&#3641;&#3656;',0),(142875,3969,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤®à¥Œà¤œà¥‚à¤¦à¤¾<br>à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¥‚à¤šà¤¨à¤¾',0),(142876,3969,'ms','Pelanggan sedia ada<br>Maklumat jualan',0),(142877,3969,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…Ø¹ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©<br>Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(142878,3969,'fr','Clients actuels<br>Informations sur les ventes',0),(142879,3969,'jp','æ—¢å­˜ã‚»ãƒ¼ãƒ«ã‚¹æƒ…å ±<br>ã?®ã?‚ã‚‹é¡§å®¢',0),(142880,3969,'pt','Clientes existentes<br>InformaÃ§Ãµes de vendas',0),(142881,3969,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹ Ñ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÐµÐ¹<br>Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÐµÐ¹ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(142882,3969,'es','Clientes con InformaciÃ³n<br>de Ventas existente',0),(142883,3969,'de','Kunden mit bestehenden<br>Verkaufsinformationen',0),(142884,3969,'en','Customers with existing<br>Sales Information',0),(142885,3970,'is','',0),(142886,3970,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ù‡ÙŠÚ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´',0),(142887,3970,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ù‡ÙŠÚ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´',0),(142888,3970,'tr','HiÃ§bir mÃ¼ÅŸteriler<br>SatÄ±ÅŸ bilgileri',0),(142889,3970,'pl','Klienci bez<br>Informacje dotyczÄ…ce sprzedaÅ¼y',0),(142890,3970,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ñ Ð½Ðµ<br>Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(142891,3970,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾ Ù†ÛÛŒÚº<br>Ø³ÛŒÙ„Ø² Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(142892,3970,'sr','ÐšÑƒÐ¿Ñ†Ð¸ Ð±ÐµÐ·<br>Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¸',0),(142893,3970,'vi','KhÃ¡ch hÃ ng vá»›ithÃ´ng tin kinh doanh',0),(142894,3970,'af','KliÃ«nte met geen<br>Verkope inligting',0),(142895,3970,'ro','ClienÅ£ii cu nici o<br>InformaÈ›ii vÃ¢nzÄƒri',0),(142896,3970,'et','Hotelli nr<br>MÃ¼Ã¼giinfo',0),(142897,3970,'si','Uporabniki brez<br>Informacije o prodaji',0),(142898,3970,'ba','Pelanggan tanpa<br>Informasi penjualan',0),(142899,3970,'nl','Klanten zonder<br>Informatie over de verkoop',0),(142900,3970,'fi','Asiakkaiden kanssa ei<br>Myyntitiedot',0),(142901,3970,'no','Kunder uten<br>Informasjon',0),(142902,3970,'da','Kunder med no<br>Salgsoplysninger',0),(142903,3970,'ko','ì—†ì´ ê³ ê°<br>íŒë§¤ ì •ë³´',0),(142904,3970,'he','×”×œ×§×•×—×•×ª ×œ×œ×<br>×ž×™×“×¢ ××•×“×•×ª ×ž×›×™×¨×•×ª',0),(142905,3970,'el','ÎŸÎ¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¿Ï… Î´ÎµÎ½<br>Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(142906,3970,'zh','å®¢æˆ·å¦é”€å”®ä¿¡æ¯\r\n',0),(142907,3970,'sv','Kunder med nr<br>FÃ¶rsÃ¤ljningsinformation',0),(142908,3970,'it','Clienti senza<br>Informazioni sulle vendite',0),(142909,3970,'tl','',0),(142910,3970,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(142911,3970,'hi','à¤•à¥‹à¤ˆ à¤¸à¤¾à¤¥ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚<br>à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¥‚à¤šà¤¨à¤¾',0),(142912,3970,'ms','Pelanggan tanpa<br>Maklumat jualan',0),(142913,3970,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…Ø¹ Ø¹Ø¯Ù… ÙˆØ¬ÙˆØ¯<br>Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(142914,3970,'fr','Clients non<br>Informations sur les ventes',0),(142915,3970,'jp','ã‚»ãƒ¼ãƒ«ã‚¹æƒ…å ±<br>ã?®ã?ªã?„é¡§å®¢',0),(142916,3970,'pt','Clientes com nÃ£o<br>InformaÃ§Ãµes de vendas',0),(142917,3970,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹ Ñ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²Ð¸ÐµÐ¼<br>Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(142918,3970,'es','Clientes sin<br>InformaciÃ³n de Ventas',0),(142919,3970,'de','Kunden Nein<br>Verkaufsinformationen',0),(142920,3970,'en','Customers with no<br>Sales Information',0),(142921,3971,'is','',0),(142922,3971,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø± Ø«Ø¨Øª Ø¬Ø¯ÙŠØ¯ ',0),(142923,3971,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø± Ø«Ø¨Øª Ø¬Ø¯ÙŠØ¯ ',0),(142924,3971,'tr','Yeni bir giriÅŸ Kaydet',0),(142925,3971,'pl','Zapisz jako nowy wpis',0),(142926,3971,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ ÐºÐ°Ñ‚Ð¾ Ð½Ð¾Ð² Ð·Ð°Ð¿Ð¸Ñ',0),(142927,3971,'ur','Ù†ÛŒØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(142928,3971,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ ÐºÐ°Ð¾ Ð½Ð¾Ð²Ð¸ ÑƒÐ½Ð¾Ñ',0),(142929,3971,'vi','Sao LÆ°u LÃ  Má»™t Entry Má»›i',0),(142930,3971,'af','Stoor as Nuwe Inskrywing',0),(142931,3971,'ro','Salvare ca noua intrare',0),(142932,3971,'et','Salesta uus sisestus',0),(142933,3971,'si','Shranite kot nov vnos',0),(142934,3971,'ba','Simpan sebagai entri baru',0),(142935,3971,'nl','Opslaan als nieuw item',0),(142936,3971,'fi','Tallenna uusi tietue',0),(142937,3971,'no','Lagre som ny oppfÃ¸ring',0),(142938,3971,'da','Gem som ny post',0),(142939,3971,'ko','ìƒˆ í•­ëª©ìœ¼ë¡œ ì €ìž¥',0),(142940,3971,'he','×©×ž×™×¨×ª ×¢×¨×š ×—×“×©',0),(142941,3971,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï‰Ï‚ Î½Î­Î± ÎµÎ³Î³ÏÎ±Ï†Î®',0),(142942,3971,'zh','å¦å­˜ä¸ºæ–°æ¡ç›®\r\n',0),(142943,3971,'sv','Spara som ny post',0),(142944,3971,'it','Salva come nuova voce',0),(142945,3971,'tl','',0),(142946,3971,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(142947,3971,'hi','à¤¨à¤ˆ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(142948,3971,'ms','Simpan sebagai entri baru',0),(142949,3971,'ar','Ø­ÙØ¸ ÙƒØ¥Ø¯Ø®Ø§Ù„ Ø¬Ø¯ÙŠØ¯',0),(142950,3971,'fr','Enregistrer en tant que nouvelle entrÃ©e',0),(142951,3971,'jp','æ–°è¦?ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?¨ã?—ã?¦ä¿?å­˜',0),(142952,3971,'pt','Salvar como nova entrada',0),(142953,3971,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ ÐºÐ°Ðº Ð½Ð¾Ð²ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(142954,3971,'es','Guardar como Nueva Entrada',0),(142955,3971,'de','Als neuen Eintrag speichern',0),(142956,3971,'en','Save as New Entry',0),(142957,3972,'is','',0),(142958,3972,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø± ØªØºÙŠÙŠØ±Ø§Øª ',0),(142959,3972,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø± ØªØºÙŠÙŠØ±Ø§Øª ',0),(142960,3972,'tr','DeÄŸiÅŸiklikleri Kaydet',0),(142961,3972,'pl','Zapisz zmiany',0),(142962,3972,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ ÐºÐ°Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(142963,3972,'ur','Ø·ÙˆØ± Ù¾Ø± ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(142964,3972,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ ÐºÐ°Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(142965,3972,'vi','Sao lÆ°u nhÆ° lÃ  thay Ä‘á»•i',0),(142966,3972,'af','Stoor as Veranderinge',0),(142967,3972,'ro','Salvare ca modificÄƒrile',0),(142968,3972,'et','Salvesta muudatused',0),(142969,3972,'si','Shrani kot spremembe',0),(142970,3972,'ba','Simpan perubahan',0),(142971,3972,'nl','Opslaan als wijzigingen',0),(142972,3972,'fi','Tallenna muutokset',0),(142973,3972,'no','Lagre som endringer',0),(142974,3972,'da','Gemme som Ã¦ndringer',0),(142975,3972,'ko','ë³€ê²½ ë‚´ìš© ì €ìž¥',0),(142976,3972,'he','×©×ž×™×¨×ª ×©×™× ×•×™×™×',0),(142977,3972,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï‰Ï‚ Î±Î»Î»Î±Î³Î­Ï‚',0),(142978,3972,'zh','å¦å­˜ä¸ºå˜æ›´\r\n',0),(142979,3972,'sv','Spara som fÃ¶rÃ¤ndringar',0),(142980,3972,'it','Salvare le modifiche',0),(142981,3972,'tl','',0),(142982,3972,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(142983,3972,'hi','à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¥‹à¤‚ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¤¾',0),(142984,3972,'ms','Simpan sebagai perubahan',0),(142985,3972,'ar','Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(142986,3972,'fr','Enregistrer en tant que modifications',0),(142987,3972,'jp','å¤‰æ›´ã?¨ã?—ã?¦ä¿?å­˜',0),(142988,3972,'pt','Salve como alteraÃ§Ãµes',0),(142989,3972,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(142990,3972,'es','Guardar como Cambios',0),(142991,3972,'de','Als Ã„nderungen speichern',0),(142992,3972,'en','Save as Changes',0),(142993,3973,'is','',0),(142994,3973,'dr','Ø§ÙŠÙ† ÙŠÙƒ Ø¢Ø²Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¦Ù…ÙŠ Ø§Ø³Øª',0),(142995,3973,'pr','Ø§ÙŠÙ† ÙŠÙƒ Ø¢Ø²Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¦Ù…ÙŠ Ø§Ø³Øª',0),(142996,3973,'tr','Bu bir test sabit oldu. DeÄŸil mi.',0),(142997,3973,'pl','To byÅ‚ staÅ‚y test. Nie to nie.',0),(142998,3973,'bg','Ð¢Ð¾Ð²Ð° Ðµ Ñ‚ÐµÑÑ‚ ÐºÐ¾Ð½ÑÑ‚Ð°Ð½Ñ‚Ð°. ÐÐµ Ñ‚Ð¾Ð²Ð° Ð½Ðµ Ðµ.',0),(142999,3973,'ur','ÛŒÛ Ù¹ÛŒØ³Ù¹ Ù…Ø³Ù„Ø³Ù„ ØªÚ¾Ø§ Û” Ú©ÙˆØ¦ÛŒ ÛŒÛ Ù†ÛÛŒÚº ÛÛ’.',0),(143000,3973,'sr','ÐžÐ²Ð¾ Ñ˜Ðµ Ð±Ð¸Ð¾ Ñ‚ÐµÑÑ‚ ÐºÐ¾Ð½ÑÑ‚Ð°Ð½Ñ‚Ð°. ÐÐµ , Ð½Ð¸Ñ˜Ðµ.',0),(143001,3973,'vi','ÄÃ¢y lÃ  kiá»ƒm tra tiáº¿p. KhÃ´ng, khÃ´ng pháº£i',0),(143002,3973,'af','Dit was \'n toets konstante. Nee, dit is nie.',0),(143003,3973,'ro','Acest lucru a fost o constantÄƒ de testare. Nu, nu.',0),(143004,3973,'et','See oli katse konstant. Ei see ei ole.',0),(143005,3973,'si','To je bil test konstanta. Ne to ni.',0),(143006,3973,'ba','Ini adalah tes konstan. Tidak ada itu tidak.',0),(143007,3973,'nl','Dit was een test-constante. Nee het is niet.',0),(143008,3973,'fi','TÃ¤mÃ¤ oli testi vakio. Ei se ole.',0),(143009,3973,'no','Dette var en test konstant. Nei det er ikke.',0),(143010,3973,'da','Det var en test konstant. Nej det er ikke.',0),(143011,3973,'ko','ì´ê²ƒì€ í…ŒìŠ¤íŠ¸ ì¼ì • ì´ì—ˆë‹¤. ê·¸ê²ƒì€ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(143012,3973,'he','×–×” ×”×™×” ×ž×‘×—×Ÿ ×§×‘×•×¢. ×œ× ×–×” ×œ×-',0),(143013,3973,'el','Î‘Ï…Ï„ÏŒ Î®Ï„Î±Î½ Î¼Î¹Î± Î´Î¿ÎºÎ¹Î¼Î® ÏƒÏ„Î±Î¸ÎµÏÎ¬. ÎŒÏ‡Î¹, Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹.',0),(143014,3973,'zh','è¿™æ˜¯ä¸€ä¸ªæµ‹è¯•å¸¸æ•°ã€‚ä¸ï¼Œä¸æ˜¯ã€‚\r\n',0),(143015,3973,'sv','Detta var ett test konstant. Nej det Ã¤r inte.',0),(143016,3973,'it','Questa era una prova costante. No non Ã¨.',0),(143017,3973,'tl','',0),(143018,3973,'th','&#3609;&#3637;&#3657;&#3588;&#3639;&#3629;&#3585;&#3634;&#3619;&#3607;&#3604;&#3626;&#3629;&#3610;&#3588;&#3656;&#3634;&#3588;&#3591;&#3607;&#3637;&#3656;',0),(143019,3973,'hi','à¤¯à¤¹ à¤à¤• à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤¨à¤¿à¤°à¤‚à¤¤à¤° à¤—à¤¯à¤¾ à¤¥à¤¾à¥¤ à¤¨à¤¹à¥€à¤‚ à¤¯à¤¹ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(143020,3973,'ms','Ini adalah pemalar ujian. Tidak bukan.',0),(143021,3973,'ar','ÙˆÙƒØ§Ù† Ù‡Ø°Ø§ Ø§Ø®ØªØ¨Ø§Ø± Ø«Ø§Ø¨Øª. Ù„Ø§ Ø£Ù†Ù‡Ø§ Ù„ÙŠØ³Øª.',0),(143022,3973,'fr','Il s\'agissait d\'une constante d\'essai. Non, il n\'est pas.',0),(143023,3973,'jp','ã?“ã‚Œã?¯ãƒ†ã‚¹ãƒˆå®šæ•°ã?§ã?—ã?Ÿã€‚ã?„ã?„ã?ˆã€?ã?¡ã?Œã?„ã?¾ã?™ã€‚',0),(143024,3973,'pt','Isto foi um teste constante. NÃ£o Ã© nÃ£o.',0),(143025,3973,'ru','Ð­Ñ‚Ð¾ Ð±Ñ‹Ð» Ð¿Ð¾ÑÑ‚Ð¾ÑÐ½Ð½Ñ‹Ð¹ Ñ‚ÐµÑÑ‚. ÐÐµÑ‚ ÑÑ‚Ð¾ Ð½Ðµ Ñ‚Ð°Ðº.',0),(143026,3973,'es','Este es una constante de prueba. No no es.',0),(143027,3973,'de','Das ist ein unverÃƒÂ¤nderlicher Test. Nicht ist es nicht.',0),(143028,3973,'en','This was a test constant. No it isn\'t.',0),(143029,3974,'is','',0),(143030,3974,'dr','2',0),(143031,3974,'pr','Ø§ÙŠÙ† ÙŠÙƒ Ø¢Ø²Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¦Ù…ÙŠ Ø§Ø³Øª   2',0),(143032,3974,'tr','Bu bir testti, sÃ¼rekli 2.',0),(143033,3974,'pl','To byÅ‚ test staÅ‚a 2.',0),(143034,3974,'bg','Ð¢Ð¾Ð²Ð° Ðµ Ñ‚ÐµÑÑ‚ Ð¿Ð¾ÑÑ‚Ð¾ÑÐ½Ð½Ð¾ 2.',0),(143035,3974,'ur','ÛŒÛ Ø§ÛŒÚ© Ù¹ÛŒØ³Ù¹ Ù…Ø³Ù„Ø³Ù„ 2 ØªÚ¾Ø§ Û”',0),(143036,3974,'sr','ÐžÐ²Ð¾ Ñ˜Ðµ Ð±Ð¸Ð¾ Ñ‚ÐµÑÑ‚ ÐºÐ¾Ð½ÑÑ‚Ð°Ð½Ñ‚Ð° 2.',0),(143037,3974,'vi','ÄÃ¢y lÃ  kiá»ƒm tra tiáº¿p 2',0),(143038,3974,'af','Dit was \'n toets konstante 2.',0),(143039,3974,'ro','Acest lucru a fost un test 2 constantÄƒ.',0),(143040,3974,'et','See oli katse pidev 2.',0),(143041,3974,'si','To je bil test konstantno 2.',0),(143042,3974,'ba','Ini adalah tes 2 konstan.',0),(143043,3974,'nl','Dit was een test constante 2.',0),(143044,3974,'fi','TÃ¤mÃ¤ oli testi jatkuva 2.',0),(143045,3974,'no','Dette var en test konstant 2.',0),(143046,3974,'da','Det var en test konstant 2.',0),(143047,3974,'ko','ì´ê²ƒì€ í…ŒìŠ¤íŠ¸ ì¼ì • 2ìž…ë‹ˆë‹¤.',0),(143048,3974,'he','×–×” ×”×™×” ×ž×‘×—×Ÿ ×§×‘×•×¢ 2.',0),(143049,3974,'el','Î‘Ï…Ï„Î® Î®Ï„Î±Î½ Î¼Î¹Î± Î´Î¿ÎºÎ¹Î¼Î® ÏƒÏ„Î±Î¸ÎµÏÎ® 2.',0),(143050,3974,'zh','è¿™æ˜¯ä¸€ä¸ªæµ‹è¯•å¸¸é‡2ã€‚\r\n',0),(143051,3974,'sv','Detta var ett test konstant 2.',0),(143052,3974,'it','Questa era una prova costante 2.',0),(143053,3974,'tl','',0),(143054,3974,'th','&#3609;&#3637;&#3657;&#3588;&#3639;&#3629;&#3585;&#3634;&#3619;&#3607;&#3604;&#3626;&#3629;&#3610;&#3588;&#3656;&#3634;&#3588;&#3591;&#3607;&#3637;&#3656; 2',0),(143055,3974,'hi','à¤¯à¤¹ à¤à¤• à¤¨à¤¿à¤°à¤‚à¤¤à¤° 2 à¤Ÿà¥‡à¤¸à¥à¤Ÿ à¤¥à¤¾à¥¤',0),(143056,3974,'ms','Ini adalah satu ujian berterusan 2.',0),(143057,3974,'ar','ÙˆÙƒØ§Ù† Ù‡Ø°Ø§ Ø§Ø®ØªØ¨Ø§Ø± 2 Ø«Ø§Ø¨ØªØ©.',0),(143058,3974,'fr','Il s\'agissait d\'un test 2 constant.',0),(143059,3974,'jp','ã?“ã‚Œã?¯ãƒ†ã‚¹ãƒˆå®šæ•°ï¼’ã?§ã?—ã?Ÿã€‚',0),(143060,3974,'pt','Isto foi um teste constante 2.',0),(143061,3974,'ru','Ð­Ñ‚Ð¾ Ð±Ñ‹Ð» Ñ‚ÐµÑÑ‚ Ð¿Ð¾ÑÑ‚Ð¾ÑÐ½Ð½Ð¾ 2.',0),(143062,3974,'es','Este es una constante de prueba. No no es. 2',0),(143063,3974,'de','Das war ein Test konstant 2.',0),(143064,3974,'en','This was a test constant 2.',0),(143065,3975,'is','',0),(143066,3975,'dr','3',0),(143067,3975,'pr','Ø§ÙŠÙ† ÙŠÙƒ Ø¢Ø²Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¦Ù…ÙŠ Ø§Ø³Øª   3',0),(143068,3975,'tr','Bu bir denemedir, sÃ¼rekli 3.',0),(143069,3975,'pl','Jest to badanie staÅ‚y 3.',0),(143070,3975,'bg','Ð¢Ð¾Ð²Ð° Ðµ Ñ‚ÐµÑÑ‚ Ð½Ð° Ð¿Ð¾ÑÑ‚Ð¾ÑÐ½Ð½Ð° 3.',0),(143071,3975,'ur','ÙŠÛ Ø§ÙŠÚ© Ø§Ù…ØªØ­Ø§Ù† Ù…Ø³Ù„Ø³Ù„ 3 ÛÛ’ Û”',0),(143072,3975,'sr','ÐžÐ²Ð¾ Ñ˜Ðµ Ñ‚ÐµÑÑ‚ ÐºÐ¾Ð½ÑÑ‚Ð°Ð½Ñ‚Ð° 3.',0),(143073,3975,'vi','ÄÃ¢y lÃ  kiá»ƒm tra tiáº¿p 3',0),(143074,3975,'af','Dit is \'n konstante 3-toets.',0),(143075,3975,'ro','Acesta este un test 3 constantÄƒ.',0),(143076,3975,'et','See on test pidev 3.',0),(143077,3975,'si','To je test konstantno 3.',0),(143078,3975,'ba','Ini adalah tes 3 konstan.',0),(143079,3975,'nl','Dit is een test constante 3.',0),(143080,3975,'fi','TÃ¤mÃ¤ on testi jatkuvasti 3.',0),(143081,3975,'no','Dette er en test konstant 3.',0),(143082,3975,'da','Dette er en test konstant 3.',0),(143083,3975,'ko','ì´ê²ƒì€ í…ŒìŠ¤íŠ¸ ì¼ì • 3ìž…ë‹ˆë‹¤.',0),(143084,3975,'he','×–×”×• ×ž×‘×—×Ÿ 3 ×ž×ª×ž×“×ª.',0),(143085,3975,'el','Î‘Ï…Ï„ÏŒ ÎµÎ¯Î½Î±Î¹ Î¼Î¹Î± Î´Î¿ÎºÎ¹Î¼Î® ÏƒÏ„Î±Î¸ÎµÏÎ® 3.',0),(143086,3975,'zh','è¿™æ˜¯ä¸€ä¸ªæµ‹è¯•å¸¸æ•°3ã€‚\r\n',0),(143087,3975,'sv','Detta Ã¤r ett test konstant 3.',0),(143088,3975,'it','Questa Ã¨ una prova costante 3.',0),(143089,3975,'tl','',0),(143090,3975,'th','&#3609;&#3637;&#3657;&#3588;&#3639;&#3629;&#3585;&#3634;&#3619;&#3607;&#3604;&#3626;&#3629;&#3610;&#3588;&#3656;&#3634;&#3588;&#3591;&#3607;&#3637;&#3656; 3',0),(143091,3975,'hi','à¤¯à¤¹ à¤à¤• à¤¨à¤¿à¤°à¤‚à¤¤à¤° 3 à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤¹à¥ˆà¥¤',0),(143092,3975,'ms','Ini adalah satu ujian berterusan 3.',0),(143093,3975,'ar','Ù‡Ø°Ø§ Ø§Ø®ØªØ¨Ø§Ø± 3 Ø«Ø§Ø¨ØªØ©.',0),(143094,3975,'fr','Il s\'agit d\'un critÃ¨re constant 3.',0),(143095,3975,'jp','ã?“ã‚Œã?¯ãƒ†ã‚¹ãƒˆå®šæ•°ï¼“ã?§ã?™ã€‚',0),(143096,3975,'pt','Este Ã© um teste 3 constante.',0),(143097,3975,'ru','Ð­Ñ‚Ð¾ Ñ‚ÐµÑÑ‚ Ð¿Ð¾ÑÑ‚Ð¾ÑÐ½Ð½Ð¾ 3.',0),(143098,3975,'es','Este es una constante de prueba. No no es. 3',0),(143099,3975,'de','Dies ist ein Test konstant 3.',0),(143100,3975,'en','This is a test constant 3.',0),(143101,3976,'is','',0),(143102,3976,'dr','4',0),(143103,3976,'pr','Ø§ÙŠÙ† ÙŠÙƒ Ø¢Ø²Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¦Ù…ÙŠ Ø§Ø³Øª 4',0),(143104,3976,'tr','Bu bir denemedir, sÃ¼rekli 4.',0),(143105,3976,'pl','Jest to test 4 staÅ‚e.',0),(143106,3976,'bg','Ð¢Ð¾Ð²Ð° Ðµ Ñ‚ÐµÑÑ‚ Ð½Ð° Ð¿Ð¾ÑÑ‚Ð¾ÑÐ½Ð½Ð° 4.',0),(143107,3976,'ur','ÙŠÛ Ø§ÙŠÚ© Ø§Ù…ØªØ­Ø§Ù† Ù…Ø³Ù„Ø³Ù„ 4 ÛÛ’ Û”',0),(143108,3976,'sr','ÐžÐ²Ð¾ Ñ˜Ðµ Ñ‚ÐµÑÑ‚ ÐºÐ¾Ð½ÑÑ‚Ð°Ð½Ñ‚Ð½Ð° 4.',0),(143109,3976,'vi','ÄÃ¢y lÃ  kiá»ƒm tra tiáº¿p 4',0),(143110,3976,'af','Dit is \'n konstante 4-toets.',0),(143111,3976,'ro','Acesta este un test 4 constantÄƒ.',0),(143112,3976,'et','See on test pidev 4.',0),(143113,3976,'si','To je test stalnih 4.',0),(143114,3976,'ba','Ini adalah tes 4 konstan.',0),(143115,3976,'nl','Dit is een test constante 4.',0),(143116,3976,'fi','TÃ¤mÃ¤ on testi jatkuvasti 4.',0),(143117,3976,'no','Dette er en test konstant 4.',0),(143118,3976,'da','Dette er en test konstant 4.',0),(143119,3976,'ko','ì´ê²ƒì€ í…ŒìŠ¤íŠ¸ ì¼ì • 4ìž…ë‹ˆë‹¤.',0),(143120,3976,'he','×–×”×• ×ž×‘×—×Ÿ 4 ×§×‘×•×¢.',0),(143121,3976,'el','Î‘Ï…Ï„ÏŒ ÎµÎ¯Î½Î±Î¹ Î¼Î¹Î± Î´Î¿ÎºÎ¹Î¼Î® ÏƒÏ„Î±Î¸ÎµÏÎ® 4.',0),(143122,3976,'zh','è¿™æ˜¯ä¸€ä¸ªæµ‹è¯•å¸¸æ•°4ã€‚\r\n',0),(143123,3976,'sv','Detta Ã¤r ett test konstant 4.',0),(143124,3976,'it','Questa Ã¨ una prova costante 4.',0),(143125,3976,'tl','',0),(143126,3976,'th','&#3609;&#3637;&#3657;&#3588;&#3639;&#3629;&#3585;&#3634;&#3619;&#3607;&#3604;&#3626;&#3629;&#3610;&#3588;&#3656;&#3634;&#3588;&#3591;&#3607;&#3637;&#3656; 4',0),(143127,3976,'hi','à¤¯à¤¹ à¤à¤• à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤²à¤—à¤¾à¤¤à¤¾à¤° 4 à¤¹à¥ˆà¥¤',0),(143128,3976,'ms','Ini adalah satu ujian berterusan 4.',0),(143129,3976,'ar','Ù‡Ø°Ø§ Ø§Ø®ØªØ¨Ø§Ø± 4 Ø§Ù„Ù…Ø³ØªÙ…Ø±.',0),(143130,3976,'fr','Il s\'agit d\'un test 4 constant.',0),(143131,3976,'jp','ã?“ã‚Œã?¯ãƒ†ã‚¹ãƒˆå®šæ•°ï¼”ã?§ã?™ã€‚',0),(143132,3976,'pt','Este Ã© um teste constante 4.',0),(143133,3976,'ru','Ð­Ñ‚Ð¾ Ñ‚ÐµÑÑ‚ Ð¿Ð¾ÑÑ‚Ð¾ÑÐ½Ð½Ð¾ 4.',0),(143134,3976,'es','Este es una constante de prueba. No no es. 4',0),(143135,3976,'de','Dies ist ein Test Konstante 4.',0),(143136,3976,'en','This is a test constant 4.',0),(143137,3977,'is','',0),(143138,3977,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ',0),(143139,3977,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ',0),(143140,3977,'tr','Orijinalleri sayÄ±sÄ±',0),(143141,3977,'pl','Liczba oryginaÅ‚Ã³w',0),(143142,3977,'bg','Ð‘Ñ€Ð¾Ð¹ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸',0),(143143,3977,'ur','Ø§ØµÙ„ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(143144,3977,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð°',0),(143145,3977,'vi','Sá»‘ báº£n gá»‘c',0),(143146,3977,'af','Aantal Oorspronklikes',0),(143147,3977,'ro','NumÄƒrul de exemplare originale',0),(143148,3977,'et','Originaaleksemplaride arv',0),(143149,3977,'si','Å tevilo originali',0),(143150,3977,'ba','Jumlah aslinya',0),(143151,3977,'nl','Aantal originelen',0),(143152,3977,'fi','AlkuperÃ¤iskappaleiden lukumÃ¤Ã¤rÃ¤',0),(143153,3977,'no','Antall originaler',0),(143154,3977,'da','Antallet af originaler',0),(143155,3977,'ko','ì›ëž˜ ìˆ˜',0),(143156,3977,'he','×ž×¡×¤×¨ ×”×ž×§×•×¨×™×™×',0),(143157,3977,'el','Î‘ÏÎ¹Î¸Î¼Î¿Ï Ï„Ï‰Î½ Ï€ÏÏ‰Ï„Î¿Ï„ÏÏ€Ï‰Î½',0),(143158,3977,'zh','åŽŸç‰©æ•°é‡\r\n',0),(143159,3977,'sv','Antal original',0),(143160,3977,'it','Numero di originali',0),(143161,3977,'tl','',0),(143162,3977,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;',0),(143163,3977,'hi','à¤®à¥‚à¤² à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(143164,3977,'ms','Bilangan asal',0),(143165,3977,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø£ØµÙ„ÙŠØ©',0),(143166,3977,'fr','Nombre d\'originaux',0),(143167,3977,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«ã?®æ•°',0),(143168,3977,'pt','NÃºmero de originais',0),(143169,3977,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¾Ð²',0),(143170,3977,'es','NÃºmero de Originales',0),(143171,3977,'de','Anzahl der originale',0),(143172,3977,'en','Number of Originals',0),(143173,3978,'is','',0),(143174,3978,'dr','Ú†Ú¯ÙˆÙ†Ù‡ Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯',0),(143175,3978,'pr','Ú†Ú¯ÙˆÙ†Ù‡ Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯',0),(143176,3978,'tr','AslÄ± nasÄ±l gÃ¶nderilmiÅŸ',0),(143177,3978,'pl','Dodano jak oryginaÅ‚y',0),(143178,3978,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸, Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð¸ ÐºÐ°Ðº',0),(143179,3978,'ur','Ø§ØµÙ„ Ú©Ø³ Ø·Ø±Ø­ Ù…ÛŒÚº Ù†Û’ Ø¹Ø±Ø¶ Ú©ÛŒØ§',0),(143180,3978,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸ Ð¿Ñ€ÐµÐ´Ð°Ð¾ ÐºÐ°ÐºÐ¾',0),(143181,3978,'vi','Ná»™p NguyÃªn báº£n nhÆ° tháº¿ nÃ o',0),(143182,3978,'af','Hoe is Oorspronklikes Ingedien',0),(143183,3978,'ro','Originalele transmise cum',0),(143184,3978,'et','Kuidas esitada originaalid',0),(143185,3978,'si','Kako predloÅ¾iti izvirnike',0),(143186,3978,'ba','Aslinya disampaikan bagaimana',0),(143187,3978,'nl','Originelen hoe afkomstig',0),(143188,3978,'fi','AlkuperÃ¤iset lÃ¤hettÃ¤neet miten',0),(143189,3978,'no','Originaler innsendt hvordan',0),(143190,3978,'da','Originalerne indsendt hvordan',0),(143191,3978,'ko','ì›ë³¸ ì œì¶œ ë°©ë²•',0),(143192,3978,'he','×”×ž×§×•×¨×™×™× × ××¡×¤×• ××™×š',0),(143193,3978,'el','Î ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î± Ï…Ï€Î¿Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ Ï€ÏŽÏ‚',0),(143194,3978,'zh','å¦‚ä½•æäº¤åŽŸä»¶\r\n',0),(143195,3978,'sv','Originalen skickats in hur',0),(143196,3978,'it','Originali presentati come',0),(143197,3978,'tl','',0),(143198,3978,'th','&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;&#3648;&#3626;&#3609;&#3629;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3619;',0),(143199,3978,'hi','à¤•à¥ˆà¤¸à¥‡ à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤ à¤®à¥‚à¤²',0),(143200,3978,'ms','Asal dikemukakan bagaimana',0),(143201,3978,'ar','Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø£ØµÙ„ÙŠØ© Ø§Ù„Ù…Ù‚Ø¯Ù…Ø© ÙƒÙŠÙ',0),(143202,3978,'fr','Originaux soumis comment',0),(143203,3978,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«æ??å‡ºæ–¹æ³•',0),(143204,3978,'pt','Originais, apresentados como',0),(143205,3978,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ñ‹ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ… ÐºÐ°Ðº',0),(143206,3978,'es','Originales Presentados Como',0),(143207,3978,'de','Originale wie eingereicht',0),(143208,3978,'en','Originals Submitted How',0),(143209,3979,'is','',0),(143210,3979,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø®Ø§Ø±Ø¬ Ø§Ø² Ø¨Ø±Ú¯Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§',0),(143211,3979,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø®Ø§Ø±Ø¬ Ø§Ø² Ø¨Ø±Ú¯Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§',0),(143212,3979,'tr','NumarasÄ± dÄ±ÅŸÄ±nda hisse senedi levha',0),(143213,3979,'pl','Numer arkusza pieÅ„',0),(143214,3979,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð¾Ñ‚ Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ Ð»Ð¸ÑÑ‚',0),(143215,3979,'ur','Ù†Ù…Ø¨Ø± Ø§Ø³Ù¹Ø§Ú© ÙˆØ±Ù‚ Ø³Û’ Ø¨Ø§ÛØ±',0),(143216,3979,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¸Ð· Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¾Ð³ Ð»Ð¸ÑÑ‚',0),(143217,3979,'vi','Sá»‘ trang Ä‘Ã£ háº¿t hÃ ng',0),(143218,3979,'af','Getal uit voorraad vel',0),(143219,3979,'ro','NumÄƒrul din foaie de stoc',0),(143220,3979,'et','Numbri vÃ¤lja varude leht',0),(143221,3979,'si','Å tevilka iz stanja zalog',0),(143222,3979,'ba','Nomor dari lembar saham',0),(143223,3979,'nl','Nummer uit voorraad blad',0),(143224,3979,'fi','Numero ulkopuolella varastossa arkki',0),(143225,3979,'no','Nummer ut av lager ark',0),(143226,3979,'da','Antallet af Stock ark',0),(143227,3979,'ko','ì£¼ì‹ ìž¥ ì¤‘ ë²ˆí˜¸',0),(143228,3979,'he','×ž×¡×¤×¨ ×ž×ª×•×š ×’×™×œ×™×•×Ÿ ×ž× ×™×•×ª',0),(143229,3979,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Ï€ÏŒ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï†ÏÎ»Î»Î¿',0),(143230,3979,'zh','è¶…å‡ºè´§æ•°è¡¨\r\n',0),(143231,3979,'sv','Antal ur lager blad',0),(143232,3979,'it','Numero magazzino lamiera',0),(143233,3979,'tl','',0),(143234,3979,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3607;&#3637;&#3656;&#3627;&#3617;&#3604;',0),(143235,3979,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤šà¤¾à¤¦à¤° à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(143236,3979,'ms','Nombor daripada kira-kira saham',0),(143237,3979,'ar','Ø¹Ø¯Ø¯ Ù…Ù† Ø§Ù„Ø£Ø³Ù‡Ù… ÙˆØ±Ù‚Ø©',0),(143238,3979,'fr','NumÃ©ro hors Stock feuille',0),(143239,3979,'jp','Number Out of Stock Sheet',0),(143240,3979,'pt','NÃºmero da folha de estoque',0),(143241,3979,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¸Ð· Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð»Ð¸ÑÑ‚',0),(143242,3979,'es','Hoja de NÃºmero afuera de Stock',0),(143243,3979,'de','Anzahl aus Lager',0),(143244,3979,'en','Number Out of Stock Sheet',0),(143245,3980,'is','',0),(143246,3980,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø±Ù†Ú¯Ù‡Ø§',0),(143247,3980,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø±Ù†Ú¯Ù‡Ø§',0),(143248,3980,'tr','# Renkler',0),(143249,3980,'pl','# Kolory',0),(143250,3980,'bg','# Ð¦Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(143251,3980,'ur','# Ø±Ù†Ú¯',0),(143252,3980,'sr','# Ð‘Ð¾Ñ˜Ðµ',0),(143253,3980,'vi','Sá»‘ máº§u',0),(143254,3980,'af','# Kleure',0),(143255,3980,'ro','# Culori',0),(143256,3980,'et','# VÃ¤rvid',0),(143257,3980,'si','# Barve',0),(143258,3980,'ba','# Warna',0),(143259,3980,'nl','# Kleuren',0),(143260,3980,'fi','# VÃ¤rit',0),(143261,3980,'no','# Farger',0),(143262,3980,'da','# Farver',0),(143263,3980,'ko','# ìƒ‰ìƒ',0),(143264,3980,'he','×¦×‘×¢×™× #',0),(143265,3980,'el','# Î§ÏÏŽÎ¼Î±Ï„Î±',0),(143266,3980,'zh','ï¼ƒé¢œè‰²\r\n',0),(143267,3980,'sv','# FÃ¤rger',0),(143268,3980,'it','# Colori',0),(143269,3980,'tl','',0),(143270,3980,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3626;&#3637;',0),(143271,3980,'hi','# à¤°à¤‚à¤—',0),(143272,3980,'ms','# Warna',0),(143273,3980,'ar','# Ø£Ù„ÙˆØ§Ù†',0),(143274,3980,'fr','# Couleurs',0),(143275,3980,'jp','è‰²ã?®æ•°',0),(143276,3980,'pt','# Cores',0),(143277,3980,'ru','# Ð¦Ð²ÐµÑ‚Ð¾Ð²',0),(143278,3980,'es','# Colores',0),(143279,3980,'de','# Farben',0),(143280,3980,'en','# Colors',0),(143281,3981,'is','',0),(143282,3981,'dr','Ù„ÙŠØ³Øª Ø±Ù†Ú¯Ù‡Ø§ ',0),(143283,3981,'pr','Ù„ÙŠØ³Øª Ø±Ù†Ú¯Ù‡Ø§ ',0),(143284,3981,'tr','Renkler listesi',0),(143285,3981,'pl','Lista kolorÃ³w',0),(143286,3981,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(143287,3981,'ur','Ø±Ù†Ú¯ÙˆÚº Ú©ÛŒ ÙÛØ±Ø³Øª',0),(143288,3981,'sr','Ð‘Ð¾Ñ˜Ð° Ð»Ð¸ÑÑ‚Ð°',0),(143289,3981,'vi','Danh sÃ¡ch máº§u',0),(143290,3981,'af','Kleure Lys',0),(143291,3981,'ro','Lista de culori',0),(143292,3981,'et','VÃ¤rvide loend',0),(143293,3981,'si','Seznam barv',0),(143294,3981,'ba','Daftar warna',0),(143295,3981,'nl','Kleuren lijst',0),(143296,3981,'fi','VÃ¤rit-luettelosta',0),(143297,3981,'no','Farger-listen',0),(143298,3981,'da','Farver liste',0),(143299,3981,'ko','ìƒ‰ìƒ ëª©ë¡',0),(143300,3981,'he','×¨×©×™×ž×ª ×¦×‘×¢×™×',0),(143301,3981,'el','Î›Î¯ÏƒÏ„Î± Ï‡ÏÏŽÎ¼Î±Ï„Î±',0),(143302,3981,'zh','é¢œè‰²åˆ—è¡¨\r\n',0),(143303,3981,'sv','FÃ¤rger lista',0),(143304,3981,'it','Lista dei colori',0),(143305,3981,'tl','',0),(143306,3981,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3637;',0),(143307,3981,'hi','à¤°à¤‚à¤— à¤¸à¥‚à¤šà¥€',0),(143308,3981,'ms','Senarai warna',0),(143309,3981,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ù„ÙˆØ§Ù†',0),(143310,3981,'fr','Liste des couleurs',0),(143311,3981,'jp','ã‚«ãƒ©ãƒ¼ãƒªã‚¹ãƒˆ',0),(143312,3981,'pt','Lista de cores',0),(143313,3981,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¦Ð²ÐµÑ‚Ð¾Ð²',0),(143314,3981,'es','Lista de Colores',0),(143315,3981,'de','Liste Farben',0),(143316,3981,'en','Colors List',0),(143317,3982,'is','',0),(143318,3982,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(143319,3982,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(143320,3982,'tr','Stok Ekle',0),(143321,3982,'pl','Dodaj czas',0),(143322,3982,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ ÑÑŠÑÑ‚Ð°Ð²',0),(143323,3982,'ur','Ø§Ø³Ù¹Ø§Ú© Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(143324,3982,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(143325,3982,'vi','ThÃªm HÃ ng',0),(143326,3982,'af','Voorraad Byvoeg',0),(143327,3982,'ro','AdÄƒugaÅ£i stoc',0),(143328,3982,'et','Lisa Stock',0),(143329,3982,'si','Dodaj parka',0),(143330,3982,'ba','Tambahkan kaldu',0),(143331,3982,'nl','Voeg voorraad',0),(143332,3982,'fi','LisÃ¤Ã¤ kalustoa',0),(143333,3982,'no','Legg lager',0),(143334,3982,'da','TilfÃ¸j lager',0),(143335,3982,'ko','ì‚¬ì§„ ì¶”ê°€',0),(143336,3982,'he','×”×•×¡×£ ×ž×œ××™',0),(143337,3982,'el','Î¡Î¯Ï‡Î½Î¿Ï…Î¼Îµ Î¶Ï‰Î¼ÏŒ',0),(143338,3982,'zh','å¢žåŠ è‚¡ç¥¨\r\n',0),(143339,3982,'sv','LÃ¤gga till lager',0),(143340,3982,'it','Aggiungere brodo',0),(143341,3982,'tl','',0),(143342,3982,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3605;&#3655;&#3629;&#3585;',0),(143343,3982,'hi','à¤¶à¥‡à¤¯à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(143344,3982,'ms','Tambah stok',0),(143345,3982,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø£Ø³Ù‡Ù…',0),(143346,3982,'fr','Ajoutez le bouillon',0),(143347,3982,'jp','åœ¨åº«ã?®è¿½åŠ ',0),(143348,3982,'pt','Adicionar aÃ§Ãµes',0),(143349,3982,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð±ÑƒÐ»ÑŒÐ¾Ð½',0),(143350,3982,'es','Agregar Stock',0),(143351,3982,'de','HinzufÃ¼gen von Aktien',0),(143352,3982,'en','Add Stock',0),(143353,3983,'is','',0),(143354,3983,'dr','Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø§ÙŠÙ† Ù‚Ø³Ù…Øª',0),(143355,3983,'pr','Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø§ÙŠÙ† Ù‚Ø³Ù…Øª',0),(143356,3983,'tr','AslÄ± bu bÃ¶lÃ¼mÃ¼',0),(143357,3983,'pl','OryginaÅ‚y tej czÄ™Å›ci',0),(143358,3983,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ñ‡Ð°ÑÑ‚',0),(143359,3983,'ur','Ø§ØµÙ„ ÛŒÛ Ø­ØµÛ',0),(143360,3983,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸ Ð¾Ð²Ð°Ñ˜ Ð´ÐµÐ¾',0),(143361,3983,'vi','Pháº§n NguyÃªn báº£n nÃ y',0),(143362,3983,'af','Oorspronklikes Hierdie deel',0),(143363,3983,'ro','Originalele aceastÄƒ parte',0),(143364,3983,'et','Originaalid selles osas',0),(143365,3983,'si','Originali ta del',0),(143366,3983,'ba','Aslinya bagian ini',0),(143367,3983,'nl','Originelen dit deel',0),(143368,3983,'fi','AlkuperÃ¤iset tÃ¤mÃ¤n osan',0),(143369,3983,'no','Originaler denne delen',0),(143370,3983,'da','Originalerne denne del',0),(143371,3983,'ko','ì›ëž˜ê°€ì´ ë¶€ë¶„ì€',0),(143372,3983,'he','×”×ž×§×•×¨×™×™× ××ª ×”×—×œ×§ ×”×–×”',0),(143373,3983,'el','Î ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î± Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î­ÏÎ¿Ï‚',0),(143374,3983,'zh','åŽŸä»¶æœ¬éƒ¨åˆ†\r\n',0),(143375,3983,'sv','Original denna del',0),(143376,3983,'it','Gli originali questa parte',0),(143377,3983,'tl','',0),(143378,3983,'th','&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;&#3586;&#3629;&#3591;&#3626;&#3656;&#3623;&#3609;&#3609;&#3637;&#3657;',0),(143379,3983,'hi','à¤®à¥‚à¤² à¤‡à¤¸ à¤­à¤¾à¤—',0);
INSERT INTO `langdef` VALUES (143380,3983,'ms','Asal bahagian ini',0),(143381,3983,'ar','Ø£ØµÙˆÙ„ Ù‡Ø°Ø§ Ø§Ù„Ø¬Ø²Ø¡',0),(143382,3983,'fr','Originaux cette partie',0),(143383,3983,'jp','Originals This Part',0),(143384,3983,'pt','Originais esta parte',0),(143385,3983,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ñ‹ ÑÑ‚Ð¾Ð¹ Ñ‡Ð°ÑÑ‚Ð¸',0),(143386,3983,'es','Originales Esta Parte',0),(143387,3983,'de','Originale dieser Teil',0),(143388,3983,'en','Originals This Part',0),(143389,3984,'is','',0),(143390,3984,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(143391,3984,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(143392,3984,'tr','Standart Ã¶lÃ§Ã¼ler',0),(143393,3984,'pl','Rozmiary standardowe',0),(143394,3984,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ€Ð¸',0),(143395,3984,'ur','Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ø³Ø§Ø¦Ø²',0),(143396,3984,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(143397,3984,'vi','Cá»¡ chuáº©n',0),(143398,3984,'af','Standaard Groottes',0),(143399,3984,'ro','Dimensiuni standard',0),(143400,3984,'et','Standard suurused',0),(143401,3984,'si','Standardne velikosti',0),(143402,3984,'ba','Ukuran standar',0),(143403,3984,'nl','Standaard maten',0),(143404,3984,'fi','Vakiokoot',0),(143405,3984,'no','Standard stÃ¸rrelser',0),(143406,3984,'da','Standard stÃ¸rrelser',0),(143407,3984,'ko','í‘œì¤€ í¬ê¸°',0),(143408,3984,'he','×”×’×“×œ×™× ×”×¡×˜× ×“×¨×˜×™×™×',0),(143409,3984,'el','Î¤Ï…Ï€Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î± Î¼ÎµÎ³Î­Î¸Î·',0),(143410,3984,'zh','æ ‡å‡†å°ºå¯¸\r\n',0),(143411,3984,'sv','Standardstorlekar',0),(143412,3984,'it','Misure standard',0),(143413,3984,'tl','',0),(143414,3984,'th','&#3586;&#3609;&#3634;&#3604;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(143415,3984,'hi','à¤®à¤¾à¤¨à¤• à¤†à¤•à¤¾à¤°',0),(143416,3984,'ms','Saiz standard',0),(143417,3984,'ar','Ø§Ù„Ø£Ø­Ø¬Ø§Ù… Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(143418,3984,'fr','Tailles standard',0),(143419,3984,'jp','æ¨™æº–ã‚µã‚¤ã‚º',0),(143420,3984,'pt','Tamanhos padrÃ£o',0),(143421,3984,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ Ð Ð°Ð·Ð¼ÐµÑ€Ñ‹',0),(143422,3984,'es','TamaÃ±os EstÃ¡ndares',0),(143423,3984,'de','StandardgrÃ¶ÃŸen',0),(143424,3984,'en','Standard Sizes',0),(143425,3985,'is','',0),(143426,3985,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬ÙˆÙ‡Ø±Ù‡Ø§',0),(143427,3985,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬ÙˆÙ‡Ø±Ù‡Ø§',0),(143428,3985,'tr','MÃ¼rekkepler gÃ¼ncelleÅŸtirme',0),(143429,3985,'pl','Aktualizacja farby',0),(143430,3985,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(143431,3985,'ur','Ø§Ù†Ú©Ø³ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(143432,3985,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð°',0),(143433,3985,'vi','Cáº­p Nháº­t Má»±c',0),(143434,3985,'af','Ink bywerking',0),(143435,3985,'ro','Cerneluri Update',0),(143436,3985,'et','Tindid Update',0),(143437,3985,'si','Posodobitev Ärnila',0),(143438,3985,'ba','Tinta Update',0),(143439,3985,'nl','Inkten Update',0),(143440,3985,'fi','Musteet pÃ¤ivitys',0),(143441,3985,'no','Blekk oppdatering',0),(143442,3985,'da','Trykfarver opdatering',0),(143443,3985,'ko','ìž‰í¬ ì—…ë°ì´íŠ¸',0),(143444,3985,'he','×¢×“×›×•×Ÿ ×“×™×•',0),(143445,3985,'el','ÎœÎµÎ»Î¬Î½Î¹Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(143446,3985,'zh','æ²¹å¢¨æ›´æ–°\r\n',0),(143447,3985,'sv','BlÃ¤ck uppdatering',0),(143448,3985,'it','Aggiornamento di inchiostri',0),(143449,3985,'tl','',0),(143450,3985,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3638;&#3585;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(143451,3985,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(143452,3985,'ms','Kemaskini dakwat',0),(143453,3985,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£Ø­Ø¨Ø§Ø±',0),(143454,3985,'fr','Mise Ã  jour des encres',0),(143455,3985,'jp','ã‚¤ãƒ³ã‚¯ã?®æ›´æ–°',0),(143456,3985,'pt','AtualizaÃ§Ã£o de tintas',0),(143457,3985,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐºÑ€Ð°ÑÐºÐ¸',0),(143458,3985,'es','Tintas Actualizar',0),(143459,3985,'de','Tinten-Update',0),(143460,3985,'en','Inks Update',0),(143461,3986,'is','',0),(143462,3986,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ Ø¬ÙˆÙ‡Ø± ',0),(143463,3986,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ Ø¬ÙˆÙ‡Ø± ',0),(143464,3986,'tr','MÃ¼rekkep genel bilgi',0),(143465,3986,'pl','Informacje ogÃ³lne atrament',0),(143466,3986,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð¾Ð±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(143467,3986,'ur','Ø§Ù†Ú© Ø¬Ù†Ø±Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(143468,3986,'sr','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð˜Ð½Ñ„Ð¾',0),(143469,3986,'vi','ThÃ´ng Tin má»±c chung',0),(143470,3986,'af','Ink Algemene Inligting',0),(143471,3986,'ro','CernealÄƒ General Info',0),(143472,3986,'et','Tindi Ãœldinfo',0),(143473,3986,'si','ÄŒrnilo sploÅ¡ne informacije',0),(143474,3986,'ba','Info Umum tinta',0),(143475,3986,'nl','Inkt Algemene Info',0),(143476,3986,'fi','Muste yleistiedot',0),(143477,3986,'no','Blekk General Info',0),(143478,3986,'da','BlÃ¦k General Info',0),(143479,3986,'ko','ìž‰í¬ ì¼ë°˜ ì •ë³´',0),(143480,3986,'he','×ž×™×“×¢ ×›×œ×œ×™ ×“×™×•',0),(143481,3986,'el','ÎœÎµÎ»Î¬Î½Î¹ Î³ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(143482,3986,'zh','æ²¹å¢¨ä¸€èˆ¬ä¿¡æ¯\r\n',0),(143483,3986,'sv','BlÃ¤ck allmÃ¤n Info',0),(143484,3986,'it','Inchiostro General Info',0),(143485,3986,'tl','',0),(143486,3986,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3586;&#3629;&#3591;&#3627;&#3617;&#3638;&#3585;',0),(143487,3986,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(143488,3986,'ms','Maklumat am dakwat',0),(143489,3986,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø© Ø§Ù„Ø­Ø¨Ø±',0),(143490,3986,'fr','Infos gÃ©nÃ©rales de l\'encre',0),(143491,3986,'jp','ã‚¤ãƒ³ã‚¯ä¸€èˆ¬æƒ…å ±',0),(143492,3986,'pt','InformaÃ§Ã£o geral de tinta',0),(143493,3986,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð°-ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(143494,3986,'es','Tinta Info General',0),(143495,3986,'de','Tinte-allgemeine Infos',0),(143496,3986,'en','Ink General Info',0),(143497,3987,'is','',0),(143498,3987,'dr','(ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡)Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(143499,3987,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª (ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡)Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(143500,3987,'tr','BaÄŸlayÄ±cÄ± fiyat listesi',0),(143501,3987,'pl','Introligatornia Cennik',0),(143502,3987,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(143503,3987,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(143504,3987,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(143505,3987,'vi','Danh sÃ¡ch giÃ¡ Ä‘Ã³ng sÃ¡ch',0),(143506,3987,'af','Bindery prys lys',0),(143507,3987,'ro','Lista de pret legatorie',0),(143508,3987,'et','Kirjansitomo hinnakiri',0),(143509,3987,'si','Knjigoveznica cenik',0),(143510,3987,'ba','Daftar harga bindery',0),(143511,3987,'nl','Bindery-prijslijst',0),(143512,3987,'fi','Bindery-hinnasto',0),(143513,3987,'no','Bindingen prisliste',0),(143514,3987,'da','Bindery prisliste',0),(143515,3987,'ko','ë°”ì¸ë”ë¦¬ ê°€ê²©í‘œ',0),(143516,3987,'he','×ž×—×™×¨×•×Ÿ bindery',0),(143517,3987,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ bindery',0),(143518,3987,'zh','è£…è®¢ä»·ç›®è¡¨\r\n',0),(143519,3987,'sv','Bindery prislista',0),(143520,3987,'it','Listino prezzi della legatoria',0),(143521,3987,'tl','',0),(143522,3987,'th','&#3649;&#3615;&#3657;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(143523,3987,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€',0),(143524,3987,'ms','Senarai Harga bindery',0),(143525,3987,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(143526,3987,'fr','Liste de prix de faÃ§onnage',0),(143527,3987,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ä¾¡æ ¼è¡¨',0),(143528,3987,'pt','Lista de preÃ§o de encadernaÃ§Ã£o',0),(143529,3987,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(143530,3987,'es','Encuadernadora, Lista de Precios',0),(143531,3987,'de','Buchbinderei-Preisliste',0),(143532,3987,'en','Bindery Price List',0),(143533,3988,'is','',0),(143534,3988,'dr','ØªÙ†Ø¸ÙŠÙ… Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(143535,3988,'pr','ØªÙ†Ø¸ÙŠÙ… Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(143536,3988,'tr','Fiyat listesi kurulumu',0),(143537,3988,'pl','Cena lista konfiguracji',0),(143538,3988,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð¸ ÑÐ¿Ð¸ÑÑŠÐº ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(143539,3988,'ur','Ù‚ÛŒÙ…Øª ÙÛØ±Ø³Øª Ø³ÛŒÙ¹ Ø§Ù¾',0),(143540,3988,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ñ†ÐµÐ½Ðµ',0),(143541,3988,'vi','Setup Báº£ng GiÃ¡',0),(143542,3988,'af','Pryslys Opstelling',0),(143543,3988,'ro','Pret lista Setup',0),(143544,3988,'et','Hind loetelu seadistamise',0),(143545,3988,'si','Cena seznam nastavitev',0),(143546,3988,'ba','Setup daftar harga',0),(143547,3988,'nl','Prijs lijst Setup',0),(143548,3988,'fi','Hinta luettelo asetukset',0),(143549,3988,'no','Pris liste oppsett',0),(143550,3988,'da','Pris liste Setup',0),(143551,3988,'ko','ê°€ê²© ëª©ë¡ ì„¤ì¹˜',0),(143552,3988,'he','×”×’×“×¨×ª ×ž×—×™×¨×•×Ÿ',0),(143553,3988,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î± ÏÏÎ¸Î¼Î¹ÏƒÎ·',0),(143554,3988,'zh','ä»·æ ¼è¡¨è®¾ç½®\r\n',0),(143555,3988,'sv','Pris lista Setup',0),(143556,3988,'it','Prezzo lista Setup',0),(143557,3988,'tl','',0),(143558,3988,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(143559,3988,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(143560,3988,'ms','Persediaan senarai harga',0),(143561,3988,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(143562,3988,'fr','ParamÃ¨tres de liste de tarifs',0),(143563,3988,'jp','ä¾¡æ ¼è¡¨è¨­å®š',0),(143564,3988,'pt','ConfiguraÃ§Ã£o de lista de preÃ§o',0),(143565,3988,'ru','Ð¦ÐµÐ½Ð° ÑÐ¿Ð¸ÑÐºÐ° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(143566,3988,'es','ConfiguraciÃ³n de lista de Precios',0),(143567,3988,'de','Preis Liste Setup',0),(143568,3988,'en','Price List Setup',0),(143569,3989,'is','',0),(143570,3989,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø³Ø§Ø®Øª ',0),(143571,3989,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ø³Ø§Ø®Øª ',0),(143572,3989,'tr','Kompozisyon fiyat listesi',0),(143573,3989,'pl','SkÅ‚ad Cennik',0),(143574,3989,'bg','Ð¡ÑŠÑÑ‚Ð°Ð² Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(143575,3989,'ur','Ø³Ø§Ø®Øª Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(143576,3989,'sr','Ð¡Ð°ÑÑ‚Ð°Ð² Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(143577,3989,'vi','GiÃ¡ thÃ nh pháº§n',0),(143578,3989,'af','Saamgestelde Pryslys',0),(143579,3989,'ro','Lista de pret compozitie',0),(143580,3989,'et','Koostise hinnakiri',0),(143581,3989,'si','Sestava cenika',0),(143582,3989,'ba','Daftar harga komposisi',0),(143583,3989,'nl','Samenstelling-prijslijst',0),(143584,3989,'fi','Koostumus hinnasto',0),(143585,3989,'no','Sammensetning prisliste',0),(143586,3989,'da','SammensÃ¦tning prisliste',0),(143587,3989,'ko','êµ¬ì„± ê°€ê²© ë¦¬ìŠ¤íŠ¸',0),(143588,3989,'he','×ž×—×™×¨×•×Ÿ ×”×¨×›×‘',0),(143589,3989,'el','Î£ÏÎ½Î¸ÎµÏƒÎ·-Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚',0),(143590,3989,'zh','æˆåˆ†ä»·ç›®è¡¨\r\n',0),(143591,3989,'sv','SammansÃ¤ttning prislista',0),(143592,3989,'it','Composizione prezzo di listino',0),(143593,3989,'tl','',0),(143594,3989,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(143595,3989,'hi','à¤°à¤šà¤¨à¤¾ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€',0),(143596,3989,'ms','Senarai Harga komposisi',0),(143597,3989,'ar','ØªÙƒÙˆÙŠÙ† Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(143598,3989,'fr','Liste de prix de composition',0),(143599,3989,'jp','æ§‹æˆ?ä¾¡æ ¼è¡¨',0),(143600,3989,'pt','Lista de preÃ§o de composiÃ§Ã£o',0),(143601,3989,'ru','ÐšÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ-Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(143602,3989,'es','Lista de Precios de ComposiciÃ³n',0),(143603,3989,'de','Zusammensetzung-Preisliste',0),(143604,3989,'en','Composition Price List',0),(143605,3990,'is','',0),(143606,3990,'dr','Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(143607,3990,'pr','Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(143608,3990,'tr','Yeni teklif',0),(143609,3990,'pl','Nowe oferty',0),(143610,3990,'bg','ÐÐ¾Ð²Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(143611,3990,'ur','Ù†Ø¦Û’ Ø§Ù‚ØªØ¨Ø§Ø³',0),(143612,3990,'sr','ÐÐ¾Ð²Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(143613,3990,'vi','BÃ¡o giÃ¡ má»›i',0),(143614,3990,'af','Nuwe Kwotasie',0),(143615,3990,'ro','Nou citat',0),(143616,3990,'et','Uus pakkumine',0),(143617,3990,'si','Nove ponudbe',0),(143618,3990,'ba','Baru kutipan',0),(143619,3990,'nl','Nieuwe offerte',0),(143620,3990,'fi','Uusi tarjous',0),(143621,3990,'no','Ny forespÃ¸rsel',0),(143622,3990,'da','Nyt tilbud',0),(143623,3990,'ko','ìƒˆ ê²¬ì ',0),(143624,3990,'he','×”×¦×¢×ª ×ž×—×™×¨ ×—×“×©×”',0),(143625,3990,'el','ÎÎ­Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(143626,3990,'zh','æ–°çš„æŠ¥ä»·\r\n',0),(143627,3990,'sv','Ny offert',0),(143628,3990,'it','Nuova citazione',0),(143629,3990,'tl','',0),(143630,3990,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(143631,3990,'hi','à¤¨à¤ˆ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(143632,3990,'ms','Sebut harga baru',0),(143633,3990,'ar','Ø¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ Ø¬Ø¯ÙŠØ¯',0),(143634,3990,'fr','Nouveau Devis',0),(143635,3990,'jp','æ–°è¦?è¦‹ç©?ã‚Š',0),(143636,3990,'pt','Nova cotaÃ§Ã£o',0),(143637,3990,'ru','ÐÐ¾Ð²Ð°Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(143638,3990,'es','Nueva CotizaciÃ³n',0),(143639,3990,'de','Neues Angebot',0),(143640,3990,'en','New Quote',0),(143641,3991,'is','',0),(143642,3991,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§ÙŠÙ…ÙŠÙ„',0),(143643,3991,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§ÙŠÙ…ÙŠÙ„',0),(143644,3991,'tr','E-posta Ekle',0),(143645,3991,'pl','DodaÄ‡ E-mail',0),(143646,3991,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¸Ð¼ÐµÐ¹Ð»',0),(143647,3991,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(143648,3991,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(143649,3991,'vi','ThÃªm Email',0),(143650,3991,'af','E-pos Byvoeg',0),(143651,3991,'ro','Adauga Email',0),(143652,3991,'et','Lisa e-mail',0),(143653,3991,'si','Dodaj Email',0),(143654,3991,'ba','Tambahkan Email',0),(143655,3991,'nl','E-mail toevoegen',0),(143656,3991,'fi','LisÃ¤Ã¤ sÃ¤hkÃ¶posti',0),(143657,3991,'no','Legge til epost',0),(143658,3991,'da','TilfÃ¸je E-mail',0),(143659,3991,'ko','ì´ë©”ì¼ ì¶”ê°€',0),(143660,3991,'he','×”×•×¡×£ ×“×•×\"×œ',0),(143661,3991,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Email',0),(143662,3991,'zh','å¢žåŠ ç”µå­é‚®ä»¶\r\n',0),(143663,3991,'sv','LÃ¤gga till e-',0),(143664,3991,'it','Aggiungi Email',0),(143665,3991,'tl','',0),(143666,3991,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(143667,3991,'hi','à¤ˆà¤®à¥‡à¤² à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(143668,3991,'ms','Tambah e-mel',0),(143669,3991,'ar','Ø£Ø¶Ù Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(143670,3991,'fr','Ajouter Courriel',0),(143671,3991,'jp','Eãƒ¡ãƒ¼ãƒ«è¿½åŠ ',0),(143672,3991,'pt','Adicionar E-mail',0),(143673,3991,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Email',0),(143674,3991,'es','Agregar Email',0),(143675,3991,'de','FÃ¼gen Sie E-Mail',0),(143676,3991,'en','Add Email',0),(143677,3992,'is','',0),(143678,3992,'dr',': Ø´Ù…Ø§ Ù…Ø¹Ø§Ø´  Ø¶Ø±ÙˆØ±ÙŠ Ø¨Ø±Ø§ÙŠ Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø§ÙŠÙ† ØµÙØ­Ù‡ Ø±Ø§ Ù†Ø¯Ø§Ø±ÙŠØ¯ ',0),(143679,3992,'pr','Ø¹Ø¯Ù… ØµÙ„Ø§Ø­ÙŠØª: Ø´Ù…Ø§ Ø­Ù‚ÙˆÙ‚  Ø¶Ø±ÙˆØ±ÙŠ Ø¨Ø±Ø§ÙŠ Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø§ÙŠÙ† ØµÙØ­Ù‡ Ø±Ø§ Ù†Ø¯Ø§Ø±ÙŠØ¯ ',0),(143680,3992,'tr','Bu sayfaya eriÅŸmek iÃ§in gerekli haklara sahip deÄŸil.',0),(143681,3992,'pl','Nie masz niezbÄ™dne prawa dostÄ™pu do tej strony.',0),(143682,3992,'bg','ÐÑÐ¼Ð°Ñ‚Ðµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ñ‚Ð°Ð·Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°.',0),(143683,3992,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§Ø³ ØµÙØ­Û’ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ø¯ÛŒÙ†Û’ Ú©Û’ Ù„Ø§Ø²Ù…ÛŒ Ø­Ù‚ÙˆÙ‚ Ù†ÛÛŒÚº ÛÛŒÚº Û”',0),(143684,3992,'sr','ÐÐµÐ¼Ð°Ñ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¾Ð²Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸.',0),(143685,3992,'vi','Báº¡n khÃ´ng Ä‘Æ°á»£c cáº¥p quyá»n vÃ o trang nÃ y',0),(143686,3992,'af','Jy nie oor die nodige regte beskik om toegang tot hierdie bladsy.',0),(143687,3992,'ro','Nu aveÅ£i drepturile necesare pentru a accesa aceastÄƒ paginÄƒ.',0),(143688,3992,'et','Teil pole sellele lehele juurdepÃ¤Ã¤suks vajalikke Ãµigusi.',0),(143689,3992,'si','Nimate potrebnih pravic za dostop do te strani.',0),(143690,3992,'ba','Anda tidak memiliki hak yang diperlukan untuk mengakses halaman ini.',0),(143691,3992,'nl','U hoeft niet de benodigde rechten om deze pagina te openen.',0),(143692,3992,'fi','Sinulla ei ole tarvittavia oikeuksia kÃ¤yttÃ¤Ã¤ tÃ¤tÃ¤ sivua.',0),(143693,3992,'no','Du har ikke nÃ¸dvendige rettigheter til denne siden.',0),(143694,3992,'da','Du har ikke de nÃ¸dvendige rettigheder til at fÃ¥ adgang til denne side.',0),(143695,3992,'ko','ì´ íŽ˜ì´ì§€ì— ì•¡ì„¸ìŠ¤ í•˜ë ¤ë©´ í•„ìš”í•œ ê¶Œí•œì´ í•„ìš”ê°€ ì—†ìŠµë‹ˆë‹¤.',0),(143696,3992,'he','××™×Ÿ ×œ×š ××ª ×”×–×›×•×™×•×ª ×”×“×¨×•×©×•×ª ×›×“×™ ×œ×’×©×ª ×œ×“×£ ×–×”.',0),(143697,3992,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Ï„Î± Î±Ï€Î±ÏÎ±Î¯Ï„Î·Ï„Î± Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Î³Î¹Î± Î½Î± Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ»Î¯Î´Î±.',0),(143698,3992,'zh','æ‚¨æ²¡æœ‰å¿…è¦çš„æƒé™è®¿é—®æ­¤é¡µé¢ã€‚\r\n',0),(143699,3992,'sv','Du har inte rÃ¤ttigheterna som krÃ¤vs fÃ¶r att fÃ¥ tillgÃ¥ng till denna sida.',0),(143700,3992,'it','Non hai i diritti necessari per accedere a questa pagina.',0),(143701,3992,'tl','',0),(143702,3992,'th','&#3588;&#3640;&#3603;&#3652;&#3617;&#3656;&#3592;&#3635;&#3648;&#3611;&#3655;&#3609;&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3626;&#3636;&#3607;&#3608;&#3636;&#3660;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3651;&#3609;&#3',0),(143703,3992,'hi','à¤†à¤ª à¤‡à¤¸ à¤ªà¥ƒà¤·à¥à¤  à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤µà¤¶à¥à¤¯à¤• à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(143704,3992,'ms','Anda tidak mempunyai hak-hak yang diperlukan untuk mengakses Laman ini.',0),(143705,3992,'ar','Ù„ÙŠØ³ Ù„Ø¯ÙŠÙƒ Ø§Ù„Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù„Ø§Ø²Ù…Ø© Ù„Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ù‡Ø°Ù‡ Ø§Ù„ØµÙØ­Ø©.',0),(143706,3992,'fr','Vous n\'avez pas les droits nÃ©cessaires pour accÃ©der Ã  cette page.',0),(143707,3992,'jp','ã?“ã?®ãƒšãƒ¼ã‚¸ã?«ã‚¢ã‚¯ã‚»ã‚¹ã?™ã‚‹ã?Ÿã‚?ã?«å¿…è¦?ã?ªæ¨©åˆ©ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(143708,3992,'pt','VocÃª nÃ£o tem os direitos necessÃ¡rios para acessar esta pÃ¡gina.',0),(143709,3992,'ru','ÐÐµÑ‚ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ñ‹Ñ… Ð¿Ñ€Ð°Ð² Ð´Ð»Ñ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ðº ÑÑ‚Ð¾Ð¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ.',0),(143710,3992,'es','No tiene los derechos necesarios para accesar esta pÃ¡gina',0),(143711,3992,'de','Sie haben nicht die erforderlichen Rechte auf diese Seite zuzugreifen.',0),(143712,3992,'en','You do not have the necessary rights to access this page.',0),(143713,3993,'is','',0),(143714,3993,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ù†ÙŠØ³Øª',0),(143715,3993,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ù†ÙŠØ³Øª',0),(143716,3993,'tr','Hisse senedi bulamÄ±yorum',0),(143717,3993,'pl','Nie moÅ¼na odnaleÅºÄ‡ zasobu',0),(143718,3993,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ ÑÑŠÑÑ‚Ð°Ð²',0),(143719,3993,'ur','Ø§Ø³Ù¹Ø§Ú© Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©ØªØ§',0),(143720,3993,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(143721,3993,'vi','KhÃ´ng thá»ƒ tháº¥y hÃ ng tá»“n',0),(143722,3993,'af','Nie instaat om Voorraad te Vind',0),(143723,3993,'ro','Nu pot gÄƒsi stoc',0),(143724,3993,'et','Laos ei leidu',0),(143725,3993,'si','Vekanje odkriti staleÅ¾',0),(143726,3993,'ba','Tidak dapat menemukan saham',0),(143727,3993,'nl','Kan bestand niet vinden',0),(143728,3993,'fi','Ei lÃ¶ydy varastosta',0),(143729,3993,'no','Finner ikke lager',0),(143730,3993,'da','Kan ikke finde lager',0),(143731,3993,'ko','ì£¼ì‹ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(143732,3993,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×¦×•× ×ž× ×™×•×ª',0),(143733,3993,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î²ÏÏ‰ Ï„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(143734,3993,'zh','æ‰¾ä¸åˆ°è‚¡ç¥¨\r\n',0),(143735,3993,'sv','Kan inte hitta lager',0),(143736,3993,'it','Non Ã¨ possibile trovare Stock',0),(143737,3993,'tl','',0),(143738,3993,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3626;&#3605;&#3655;&#3629;&#3585;',0),(143739,3993,'hi','à¤¶à¥‡à¤¯à¤° à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¤à¤¾',0),(143740,3993,'ms','Tidak dapat mencari saham',0),(143741,3993,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(143742,3993,'fr','Impossible de trouver Stock',0),(143743,3993,'jp','åœ¨åº«ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(143744,3993,'pt','NÃ£o consigo encontrar o estoque',0),(143745,3993,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð½Ð°Ð¹Ñ‚Ð¸ Ð°ÐºÑ†Ð¸Ð¸',0),(143746,3993,'es','No se puede encontrar Stock',0),(143747,3993,'de','Lager kann nicht gefunden werden.',0),(143748,3993,'en','Cannot Find Stock',0),(143749,3994,'is','',0),(143750,3994,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ',0),(143751,3994,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ',0),(143752,3994,'tr','Hata ekleme',0),(143753,3994,'pl','BÅ‚Ä…d dodawania',0),(143754,3994,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(143755,3994,'ur','Ù†Ù‚Øµ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(143756,3994,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ',0),(143757,3994,'vi','ThÃªm bá»‹ lá»—i',0),(143758,3994,'af','Fout by te voeg',0),(143759,3994,'ro','AdÄƒugarea de eroare',0),(143760,3994,'et','Viga lisamine',0),(143761,3994,'si','Napaka pri dodajanju',0),(143762,3994,'ba','Menambahkan kesalahan',0),(143763,3994,'nl','Fout toe te voegen',0),(143764,3994,'fi','Virhe lisÃ¤Ã¤minen',0),(143765,3994,'no','Feil Ã¥ legge',0),(143766,3994,'da','TilfÃ¸jelse af fejl',0),(143767,3994,'ko','ì˜¤ë¥˜ ì¶”ê°€',0),(143768,3994,'he','×©×’×™××” ×‘×”×•×¡×¤×”',0),(143769,3994,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ†Î¬Î»Î¼Î±',0),(143770,3994,'zh','é”™è¯¯æ·»åŠ ',0),(143771,3994,'sv','Fel att lÃ¤gga',0),(143772,3994,'it','Aggiunta di errore',0),(143773,3994,'tl','',0),(143774,3994,'th','&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(143775,3994,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(143776,3994,'ms','Ralat menambah',0),(143777,3994,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø¥Ø¶Ø§ÙØ©',0),(143778,3994,'fr','Erreur ajout',0),(143779,3994,'jp','è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(143780,3994,'pt','Erro adicionando',0),(143781,3994,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(143782,3994,'es','Error Agregando',0),(143783,3994,'de','Fehler hinzufÃ¼gen',0),(143784,3994,'en','Error Adding',0),(143785,3995,'is','',0),(143786,3995,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù†',0),(143787,3995,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù†',0),(143788,3995,'tr','GÃ¼ncelleÅŸtirme hatasÄ±',0),(143789,3995,'pl','BÅ‚Ä…d podczas aktualizowania',0),(143790,3995,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(143791,3995,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(143792,3995,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(143793,3995,'vi','Lá»—i cáº­p nháº­t',0),(143794,3995,'af','Opdateringsfout',0),(143795,3995,'ro','Eroare de actualizare',0),(143796,3995,'et','Viga ajakohastamine',0),(143797,3995,'si','Napaka pri posodabljanju',0),(143798,3995,'ba','Kesalahan update',0),(143799,3995,'nl','Fout bijwerken',0),(143800,3995,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤',0),(143801,3995,'no','Feil oppdatering',0),(143802,3995,'da','Opdatering af fejl',0),(143803,3995,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸',0),(143804,3995,'he','×©×’×™××” ×‘×¢×“×›×•×Ÿ',0),(143805,3995,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¬Î¸Î¿Ï…Ï‚',0),(143806,3995,'zh','é”™è¯¯æ›´æ–°',0),(143807,3995,'sv','Fel uppdatering',0),(143808,3995,'it','Errore aggiornamento',0),(143809,3995,'tl','',0),(143810,3995,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(143811,3995,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¤¾',0),(143812,3995,'ms','Mengemaskini ralat',0),(143813,3995,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(143814,3995,'fr','Erreur mise Ã  jour',0),(143815,3995,'jp','æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(143816,3995,'pt','Erro de atualizaÃ§Ã£o',0),(143817,3995,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸',0),(143818,3995,'es','Error Actualizando',0),(143819,3995,'de','Fehler beim Aktualisieren',0),(143820,3995,'en','Error Updating',0),(143821,3996,'is','',0),(143822,3996,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(143823,3996,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(143824,3996,'tr','Bu iÅŸ tÃ¼rÃ¼ Sil',0),(143825,3996,'pl','UsunÄ…Ä‡ ten typ pracy',0),(143826,3996,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(143827,3996,'ur','Ø§Ø³ Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(143828,3996,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð°',0),(143829,3996,'vi','XÃ³a loáº¡i cÃ´ng viá»‡c nÃ y',0),(143830,3996,'af','Skrap hierdie Werktipe',0),(143831,3996,'ro','ÅžtergeÅ£i acest tip de munca',0),(143832,3996,'et','Kustuta see tÃ¶Ã¶ tÃ¼Ã¼p',0),(143833,3996,'si','Izbrisati to vrsto dela',0),(143834,3996,'ba','Menghapus jenis pekerjaan ini',0),(143835,3996,'nl','Dit Type werk verwijderen',0),(143836,3996,'fi','Poista tÃ¤mÃ¤ tyÃ¶',0),(143837,3996,'no','Slette denne arbeidstypen',0),(143838,3996,'da','Slet denne arbejdstype',0),(143839,3996,'ko','ì´ ìž‘ì—… í˜•ì‹ ì‚­ì œ',0),(143840,3996,'he','×œ×ž×—×•×§ ××ª ×¡×•×’ ×”×¢×‘×•×“×” ×”×–×”',0),(143841,3996,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï„ÏÏ€Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(143842,3996,'zh','åˆ é™¤æ­¤å·¥ä½œç±»åž‹\r\n',0),(143843,3996,'sv','Ta bort detta arbetstyp',0),(143844,3996,'it','Cancella questo tipo di lavoro',0),(143845,3996,'tl','',0),(143846,3996,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(143847,3996,'hi','à¤‡à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(143848,3996,'ms','Menghapuskan jenis kerja ini',0),(143849,3996,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ \"Ø§Ù„Ù†ÙˆØ¹ Ù…Ù† Ø§Ù„Ø¹Ù…Ù„\"',0),(143850,3996,'fr','Supprimer ce Type de travail',0),(143851,3996,'jp','ã?“ã?®å‹¤å‹™ã‚¿ã‚¤ãƒ—ã‚’æ¶ˆåŽ»',0),(143852,3996,'pt','Excluir este tipo de trabalho',0),(143853,3996,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(143854,3996,'es','Eliminar este Tipo de Trabajo',0),(143855,3996,'de','Diese Art von Arbeit zu lÃ¶schen',0),(143856,3996,'en','Delete this Work Type',0),(143857,3997,'is','',0),(143858,3997,'dr','3',0),(143859,3997,'pr','3',0),(143860,3997,'tr','3',0),(143861,3997,'pl','3',0),(143862,3997,'bg','3',0),(143863,3997,'ur','ØªÛŒÙ†',0),(143864,3997,'sr','3',0),(143865,3997,'vi','3',0),(143866,3997,'af','3',0),(143867,3997,'ro','3',0),(143868,3997,'et','3',0),(143869,3997,'si','3',0),(143870,3997,'ba','3',0),(143871,3997,'nl','3',0),(143872,3997,'fi','3',0),(143873,3997,'no','3',0),(143874,3997,'da','3',0),(143875,3997,'ko','3',0),(143876,3997,'he','3',0),(143877,3997,'el','3',0),(143878,3997,'zh','3',0),(143879,3997,'sv','3',0),(143880,3997,'it','3',0),(143881,3997,'tl','',0),(143882,3997,'th','3',0),(143883,3997,'hi','3',0),(143884,3997,'ms','3',0),(143885,3997,'ar','3',0),(143886,3997,'fr','3',0),(143887,3997,'jp','3',0),(143888,3997,'pt','3',0),(143889,3997,'ru','3',0),(143890,3997,'es','3',0),(143891,3997,'de','3',0),(143892,3997,'en','3',0),(143893,3998,'is','',0),(143894,3998,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(143895,3998,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(143896,3998,'tr','Yeni Ã§alÄ±ÅŸma alanÄ± ekleme',0),(143897,3998,'pl','Dodaj nowe miejsca pracy',0),(143898,3998,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(143899,3998,'ur','Ù†ÛŒØ§ Ú©Ø§Ù… Ø¹Ù„Ø§Ù‚Û Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(143900,3998,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð¿Ñ€Ð¾ÑÑ‚Ð¾Ñ€Ð°',0),(143901,3998,'vi','ThÃªm Khu Vá»±c LÃ m Viá»‡c Má»›i',0),(143902,3998,'af','Nuwe Werk Area Byvoeg',0),(143903,3998,'ro','Adauga noi zona de lucru',0),(143904,3998,'et','Lisage uus tÃ¶Ã¶piirkond',0),(143905,3998,'si','Dodaj nov delovni prostor',0),(143906,3998,'ba','Menambahkan baru Area kerja',0),(143907,3998,'nl','Toevoegen van nieuwe werkgebied',0),(143908,3998,'fi','LisÃ¤Ã¤ uusi tyÃ¶alue',0),(143909,3998,'no','Legge til nye arbeidsomrÃ¥det',0),(143910,3998,'da','TilfÃ¸je nye arbejdsomrÃ¥de',0),(143911,3998,'ko','ìƒˆ ìž‘ì—… ì˜ì—­ì„ ì¶”ê°€',0),(143912,3998,'he','×”×•×¡×£ ×©×˜×— ×¢×‘×•×“×” ×—×“×©',0),(143913,3998,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï‡ÏŽÏÎ¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(143914,3998,'zh','å¢žåŠ æ–°åŠžå…¬åŒº\r\n',0),(143915,3998,'sv','LÃ¤gg till ny arbetsplats',0),(143916,3998,'it','Aggiungere la nuova Area di lavoro',0),(143917,3998,'tl','',0),(143918,3998,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(143919,3998,'hi','à¤¨à¤ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(143920,3998,'ms','Menambah kawasan kerja baru',0),(143921,3998,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø³Ø§Ø­Ø© Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(143922,3998,'fr','Ajouter la nouvelle zone de travail',0),(143923,3998,'jp','æ–°è¦?ä»•äº‹åœ°åŸŸã?®è¿½åŠ ',0),(143924,3998,'pt','Adicionar a nova Ã¡rea de trabalho',0),(143925,3998,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(143926,3998,'es','Agregar Nueva Ãrea de Trabajo',0),(143927,3998,'de','FÃ¼gen neuer Arbeitsbereich hinzu',0),(143928,3998,'en','Add New Work Area',0),(143929,3999,'is','',0),(143930,3999,'dr','Ø§ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØµØ§Ø¯Ø± Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(143931,3999,'pr','Ø§ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØµØ§Ø¯Ø± Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(143932,3999,'tr','Bu onay numarasÄ± zaten yayÄ±nladÄ±.',0),(143933,3999,'pl','Wydano juÅ¼ ten numer czeku.',0),(143934,3999,'bg','Ð¢Ð°Ð·Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð¾Ð¼ÐµÑ€ Ð²ÐµÑ‡Ðµ Ðµ Ð±Ð¸Ð» Ð¸Ð·Ð´Ð°Ð´ÐµÐ½.',0),(143935,3999,'ur','Ø§Ø³ Ú†ÛŒÚ© Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ø¬Ø§Ø±ÛŒ Ú©ÛŒ Ú¯Ø¦ÛŒ ÛÛ’ Û”',0),(143936,3999,'sr','ÐžÐ²Ð°Ñ˜ Ð±Ñ€Ð¾Ñ˜ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð²ÐµÑ› Ð¸Ð·Ð´Ð°Ð¾.',0),(143937,3999,'vi','Sá»‘ SÃ©c nÃ y Ä‘Ã£ phÃ¡t hÃ nh',0),(143938,3999,'af','Hierdie tjeknommer is alreeds uitgereik.',0),(143939,3999,'ro','Acest numÄƒr de selectare a fost deja eliberat.',0),(143940,3999,'et','Juba vÃ¤lja antud tÅ¡eki numbri.',0),(143941,3999,'si','To potrditveno Å¡tevilko Å¾e izdano.',0),(143942,3999,'ba','Nomor check ini telah dikeluarkan.',0),(143943,3999,'nl','Dit nummer van de cheque heeft reeds afgegeven.',0),(143944,3999,'fi','Sekin numero on jo annettu.',0),(143945,3999,'no','Denne sjekknummeret er allerede utstedt.',0),(143946,3999,'da','Denne checknummeret er allerede blevet udstedt.',0),(143947,3999,'ko','ì´ í™•ì¸ ë²ˆí˜¸ì— ì´ë¯¸ ë°œê¸‰ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(143948,3999,'he','×ž×¡×¤×¨ ×”×©×™×§ ×”×–×” ×›×‘×¨ ×”×•× ×¤×§.',0),(143949,3999,'el','ÎŸ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Ï…Ï„ÏŒÏ‚ Î­Î»ÎµÎ³Ï‡Î¿Ï‚ Î­Ï‡ÎµÎ¹ Î®Î´Î· ÎµÎºÎ´Î¿Î¸ÎµÎ¯.',0),(143950,3999,'zh','è¿™æ”¯ç¥¨å·ç å·²ç»å°å‘',0),(143951,3999,'sv','Kontrollera numret har redan utfÃ¤rdats.',0),(143952,3999,'it','Questo numero di controllo Ã¨ giÃ  stato rilasciato.',0),(143953,3999,'tl','',0),(143954,3999,'th','&#3648;&#3594;&#3655;&#3588;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3609;&#3637;&#3657;&#3617;&#3637;&#3612;&#3621;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(143955,3999,'hi','à¤¯à¤¹ à¤šà¥‡à¤• à¤¨à¤‚à¤¬à¤° à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤œà¤¾à¤°à¥€ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(143956,3999,'ms','Nombor Daftar ini telah dikeluarkan.',0),(143957,3999,'ar','ÙˆÙ‚Ø¯ ØµØ¯Ø± Ø¨Ø§Ù„ÙØ¹Ù„ Ù‡Ø°Ø§ Ø±Ù‚Ù… Ø§Ù„Ø´ÙŠÙƒ.',0),(143958,3999,'fr','Ce numÃ©ro de chÃ¨que a dÃ©jÃ  Ã©tÃ© Ã©mis.',0),(143959,3999,'jp','ã?“ã?®å°?åˆ‡æ‰‹ç•ªå?·ã?¯ã?™ã?§ã?«ç™ºè¡Œã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(143960,3999,'pt','Este nÃºmero de cheque jÃ¡ foi emitido.',0),(143961,3999,'ru','Ð­Ñ‚Ð¾Ñ‚ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ ÑƒÐ¶Ðµ Ð±Ñ‹Ð» Ð¸Ð·Ð´Ð°Ð½.',0),(143962,3999,'es','Este numero de cheque ya se emitiÃ³',0),(143963,3999,'de','Diese Nummer wurde bereits ausgestellt.',0),(143964,3999,'en','This check number has already been issued.',0),(143965,4000,'is','',0),(143966,4000,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(143967,4000,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(143968,4000,'tr','Fatura gÃ¼ncelleÅŸtirmesi baÅŸarÄ±sÄ±z oldu',0),(143969,4000,'pl','Bill aktualizacja nie powiodÅ‚a siÄ™',0),(143970,4000,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑÐ½Ð¾',0),(143971,4000,'ur','Ø¨Ù„ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(143972,4000,'sr','Ð‘Ð¸Ð» Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(143973,4000,'vi','Cáº­p Nháº­t HÃ³a ÄÆ¡n tháº¥t báº¡i',0),(143974,4000,'af','Wetsontwerp bywerking het misluk',0),(143975,4000,'ro','Bill Update nu a reuÈ™it',0),(143976,4000,'et','Bill vÃ¤rskendamine nurjus',0),(143977,4000,'si','Bill posodobitev ni uspela',0),(143978,4000,'ba','Bill Update gagal',0),(143979,4000,'nl','Bill Update is mislukt',0),(143980,4000,'fi','Bill pÃ¤ivitys epÃ¤onnistui',0),(143981,4000,'no','Bill oppdatering mislyktes',0),(143982,4000,'da','Bill opdateringen mislykkedes',0),(143983,4000,'ko','ë¹Œ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(143984,4000,'he','×‘×™×œ ×¢×“×›×•×Ÿ × ×›×©×œ',0),(143985,4000,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Bill',0),(143986,4000,'zh','å¸å•æ›´æ–°å¤±è´¥\r\n',0),(143987,4000,'sv','Bill uppdateringen misslyckades',0),(143988,4000,'it','Bill aggiornamento fallito',0),(143989,4000,'tl','',0),(143990,4000,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3636;&#3621;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(143991,4000,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²',0),(143992,4000,'ms','Gagal Kemaskini Rang undang-undang',0),(143993,4000,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø¨ÙŠÙ„',0),(143994,4000,'fr','Mise Ã  jour du projet de loi a Ã©chouÃ©',0),(143995,4000,'jp','è«‹æ±‚æ›¸ã?®æ›´æ–°ã?Œã?§ã??ã?¾ã?›ã‚“',0),(143996,4000,'pt','Falha na atualizaÃ§Ã£o do Bill',0),(143997,4000,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð‘Ð¸Ð»Ð»',0),(143998,4000,'es','Factura ActualizaciÃ³n FallÃ³',0),(143999,4000,'de','Bill-Update fehlgeschlagen',0),(144000,4000,'en','Bill Update Failed',0),(144001,4001,'is','',0),(144002,4001,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¢Ø¯Ø±Ø³ _Ø­Ù…Ù„ Ø¨Ù‡ _',0),(144003,4001,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¢Ø¯Ø±Ø³ _Ø­Ù…Ù„ Ø¨Ù‡ _',0),(144004,4001,'tr','Gemi adreslere Ekle/GÃ¼ncelle',0),(144005,4001,'pl','Dodaj/Aktualizuj statku do adresÃ³w',0),(144006,4001,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð± Ð·Ð° Ð°Ð´Ñ€ÐµÑÐ¸',0),(144007,4001,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ù¾ØªÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(144008,4001,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð±Ñ€Ð¾Ð´ Ð½Ð° Ð°Ð´Ñ€ÐµÑÐµ',0),(144009,4001,'vi','ThÃªm/Cáº­p Nháº­t ÄÆ¡n Váº­n Chuyá»ƒn Äáº¿n Äá»‹a Chá»‰',0),(144010,4001,'af','Versend Aan Adresse Byvoeg/Opdateer',0),(144011,4001,'ro','AdÄƒugaÅ£i/actualizaÅ£i navei la adrese',0),(144012,4001,'et','Lisa/Uuenda tarneaadresse',0),(144013,4001,'si','Dodaj/posodobi ladje za naslove',0),(144014,4001,'ba','Tambahkan/Perbarui kapal ke alamat',0),(144015,4001,'nl','Schip naar adressen toevoegen/bijwerken',0),(144016,4001,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ toimitusosoite-kenttiin',0),(144017,4001,'no','Legg til/Oppdater lever til-adresser',0),(144018,4001,'da','TilfÃ¸j/opdater skib til adresser',0),(144019,4001,'ko','ìš´ì†¡ì§€ ì£¼ì†Œ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(144020,4001,'he','×”×•×¡×£/×¢×“×›×Ÿ ×œ×ž×©×œ×•×—',0),(144021,4001,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹/ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Ï„Î¿ Ï€Î»Î¿Î¯Î¿ ÏƒÎµ Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚',0),(144022,4001,'zh','å¢žåŠ /æ›´æ–°äº¤è´§åœ°å€\r\n',0),(144023,4001,'sv','LÃ¤gg till/uppdatera fartyget till adresser',0),(144024,4001,'it','Aggiungere o aggiornare la nave agli indirizzi',0),(144025,4001,'tl','',0),(144026,4001,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3659;',0),(144027,4001,'hi','à¤œà¤¹à¤¾à¤œ à¤ªà¤¤à¥‹à¤‚ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(144028,4001,'ms','Tambah/Kemaskini kapal ke alamat',0),(144029,4001,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯Ø¨Ø« Ø¹Ù†Ø§ÙˆÙŠÙ† Ø§Ù„Ø´Ø­Ù†',0),(144030,4001,'fr','Ajouter/mettre Ã  jour un navire aux adresses',0),(144031,4001,'jp','ç™ºé€?å…ˆä½?æ‰€ã?®è¿½åŠ /æ›´æ–°',0),(144032,4001,'pt','Adicionar/atualizar o navio para endereÃ§os',0),(144033,4001,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿Ð¾ Ð°Ð´Ñ€ÐµÑÐ°Ð¼',0),(144034,4001,'es','Agregar/Actualizar Direcciones de EnvÃ­os',0),(144035,4001,'de','Schiff-Adressen hinzufÃ¼gen/aktualisieren',0),(144036,4001,'en','Add/Update Ship To Addresses',0),(144037,4002,'is','',0),(144038,4002,'dr','12',0),(144039,4002,'pr','12',0),(144040,4002,'tr','12',0),(144041,4002,'pl','12',0),(144042,4002,'bg','12',0),(144043,4002,'ur','Ø¨Ø§Ø±Û',0),(144044,4002,'sr','12',0),(144045,4002,'vi','12',0),(144046,4002,'af','12',0),(144047,4002,'ro','12',0),(144048,4002,'et','12',0),(144049,4002,'si','12',0),(144050,4002,'ba','12',0),(144051,4002,'nl','12',0),(144052,4002,'fi','12',0),(144053,4002,'no','12',0),(144054,4002,'da','12',0),(144055,4002,'ko','12',0),(144056,4002,'he','12',0),(144057,4002,'el','12',0),(144058,4002,'zh','12',0),(144059,4002,'sv','12',0),(144060,4002,'it','12',0),(144061,4002,'tl','labingdalawa',0),(144062,4002,'th','12',0),(144063,4002,'hi','12',0),(144064,4002,'ms','12',0),(144065,4002,'ar','12',0),(144066,4002,'fr','12',0),(144067,4002,'jp','12',0),(144068,4002,'pt','12',0),(144069,4002,'ru','12',0),(144070,4002,'es','12',0),(144071,4002,'de','12',0),(144072,4002,'en','12',0),(144073,4003,'is','',0),(144074,4003,'dr','6',0),(144075,4003,'pr','6',0),(144076,4003,'tr','6',0),(144077,4003,'pl','6',0),(144078,4003,'bg','6',0),(144079,4003,'ur','Ú†Ú¾Û’',0),(144080,4003,'sr','6',0),(144081,4003,'vi','6',0),(144082,4003,'af','6',0),(144083,4003,'ro','6',0),(144084,4003,'et','6',0),(144085,4003,'si','6',0),(144086,4003,'ba','6',0),(144087,4003,'nl','6',0),(144088,4003,'fi','6',0),(144089,4003,'no','6',0),(144090,4003,'da','6',0),(144091,4003,'ko','6',0),(144092,4003,'he','6',0),(144093,4003,'el','6',0),(144094,4003,'zh','6',0),(144095,4003,'sv','6',0),(144096,4003,'it','6',0),(144097,4003,'tl','',0),(144098,4003,'th','6',0),(144099,4003,'hi','6',0),(144100,4003,'ms','6',0),(144101,4003,'ar','6',0),(144102,4003,'fr','6',0),(144103,4003,'jp','6',0),(144104,4003,'pt','6',0),(144105,4003,'ru','6',0),(144106,4003,'es','6',0),(144107,4003,'de','6',0),(144108,4003,'en','6',0),(144109,4004,'is','',0),(144110,4004,'dr','9',0),(144111,4004,'pr','9',0),(144112,4004,'tr','9',0),(144113,4004,'pl','9',0),(144114,4004,'bg','9',0),(144115,4004,'ur','Ù†Ùˆ',0),(144116,4004,'sr','9',0),(144117,4004,'vi','9',0),(144118,4004,'af','9',0),(144119,4004,'ro','9',0),(144120,4004,'et','9',0),(144121,4004,'si','9',0),(144122,4004,'ba','9',0),(144123,4004,'nl','9',0),(144124,4004,'fi','9',0),(144125,4004,'no','9',0),(144126,4004,'da','9',0),(144127,4004,'ko','9',0),(144128,4004,'he','9',0),(144129,4004,'el','9',0),(144130,4004,'zh','9',0),(144131,4004,'sv','9',0),(144132,4004,'it','9',0),(144133,4004,'tl','',0),(144134,4004,'th','9',0),(144135,4004,'hi','9',0),(144136,4004,'ms','9',0),(144137,4004,'ar','9',0),(144138,4004,'fr','9',0),(144139,4004,'jp','9',0),(144140,4004,'pt','9',0),(144141,4004,'ru','9',0),(144142,4004,'es','9',0),(144143,4004,'de','9',0),(144144,4004,'en','9',0),(144145,4005,'is','',0),(144146,4005,'dr','(Ø§Ø¯Ø§Ù…Ù‡ ÙŠØ§ÙØªÙ‡',0),(144147,4005,'pr','Ø¯Ø§Ø¦Ù… (Ø§Ø¯Ø§Ù…Ù‡ ÙŠØ§ÙØªÙ‡',0),(144148,4005,'tr','Devam etti',0),(144149,4005,'pl','CiÄ…g dalszy',0),(144150,4005,'bg','ÐŸÑ€Ð¾Ð´ÑŠÐ»Ð¶Ð°Ð²Ð°',0),(144151,4005,'ur','Ø¬Ø§Ø±ÛŒ',0),(144152,4005,'sr','ÐÐ°ÑÑ‚Ð°Ð²Ð¸Ð¾ Ñ˜Ðµ',0),(144153,4005,'vi','Tiáº¿p tá»¥c',0),(144154,4005,'af','Voortgesit',0),(144155,4005,'ro','A continuat',0),(144156,4005,'et','JÃ¤tkus',0),(144157,4005,'si','Nadaljevala',0),(144158,4005,'ba','Terus',0),(144159,4005,'nl','Voortgezet',0),(144160,4005,'fi','Edelleen',0),(144161,4005,'no','Fortsatte',0),(144162,4005,'da','Fortsatte',0),(144163,4005,'ko','ê³„ì†',0),(144164,4005,'he','×”×ž×©×š',0),(144165,4005,'el','Î£Ï…Î½Î­Ï‡Î¹ÏƒÎµ',0),(144166,4005,'zh','ç»­\r\n',0),(144167,4005,'sv','Fortsatte',0),(144168,4005,'it','Continuato',0),(144169,4005,'tl','',0),(144170,4005,'th','&#3605;&#3656;&#3629;&#3652;&#3611;',0),(144171,4005,'hi','à¤œà¤¾à¤°à¥€ à¤°à¤–à¤¾',0),(144172,4005,'ms','Terus',0),(144173,4005,'ar','ÙˆÙˆØ§ØµÙ„',0),(144174,4005,'fr','Suite',0),(144175,4005,'jp','ç¶šã??',0),(144176,4005,'pt','Continuou',0),(144177,4005,'ru','Ð—Ð°ÐºÐ¾Ð½Ñ‡ÐµÐ½Ð¾',0),(144178,4005,'es','Continuado',0),(144179,4005,'de','Weiter',0),(144180,4005,'en','Continued',0),(144181,4006,'is','',0),(144182,4006,'dr','Ù‡ÙŠÚ† Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(144183,4006,'pr','Ù‡ÙŠÚ† Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(144184,4006,'tr','HiÃ§bir sevkiyat bulundu',0),(144185,4006,'pl','Nie wysyÅ‚ek Znalezione',0),(144186,4006,'bg','ÐÑÐ¼Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(144187,4006,'ur','Ù…Ù„Ø§ Ù†ÛÛŒÚº Ù„ÛŒØªÛŒ',0),(144188,4006,'sr','ÐÐµÐ¼Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð½Ð°ÑˆÐ°Ð¾',0),(144189,4006,'vi','KhÃ´ng tÃ¬m tháº¥y chuyáº¿n hÃ ng',0),(144190,4006,'af','Geen Versendings Gevind',0),(144191,4006,'ro','Nici transporturile gÄƒsit',0),(144192,4006,'et','Ei leidnud saadetised',0),(144193,4006,'si','Ne poÅ¡iljke naÅ¡el',0),(144194,4006,'ba','Tidak ada pengiriman yang ditemukan',0),(144195,4006,'nl','Geen zendingen gevonden',0),(144196,4006,'fi','LÃ¤hetystÃ¤ ei lÃ¶ytynyt',0),(144197,4006,'no','Ingen leveringer funnet',0),(144198,4006,'da','Ingen leverancer fundet',0),(144199,4006,'ko','ì•„ë‹ˆ ì¶œí•˜ ëŸ‰ ë°œê²¬',0),(144200,4006,'he','××™×Ÿ ×ž×©×œ×•×—×™× × ×ž×¦××•',0),(144201,4006,'el','Î”ÎµÎ½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(144202,4006,'zh','æ²¡æœ‰å‘çŽ°è´§ç‰©\r\n',0),(144203,4006,'sv','Inga transporter hittade',0),(144204,4006,'it','No spedizioni trovate',0),(144205,4006,'tl','',0),(144206,4006,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(144207,4006,'hi','à¤•à¥‹à¤ˆ à¤²à¤¦à¤¾à¤¨ à¤®à¤¿à¤²à¤¾',0),(144208,4006,'ms','Tiada penghantaran yang dijumpai',0),(144209,4006,'ar','Ø§Ù„Ø´Ø­Ù†Ø§Øª Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(144210,4006,'fr','Aucune expÃ©dition trouvÃ©e',0),(144211,4006,'jp','ç™ºé€?ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(144212,4006,'pt','Sem carregamentos encontrados',0),(144213,4006,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾ Ð³Ñ€ÑƒÐ·Ð¾Ð²',0),(144214,4006,'es','No se Encontraron EnvÃ­os',0),(144215,4006,'de','Keine Sendungen gefunden',0),(144216,4006,'en','No Shipments Found',0),(144217,4007,'is','',0),(144218,4007,'dr','Ù„ÙŠØ³Øª Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(144219,4007,'pr','Ù„ÙŠØ³Øª Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(144220,4007,'tr','Sevkiyat listesi',0),(144221,4007,'pl','ListÄ™ wysyÅ‚kowÄ…',0),(144222,4007,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ñ ÑÐ¿Ð¸ÑÑŠÐº',0),(144223,4007,'ur','Ú©Ú¾ÛŒÙ¾ ÙÛØ±Ø³Øª',0),(144224,4007,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(144225,4007,'vi','Danh sÃ¡ch chuyáº¿n hÃ ng',0),(144226,4007,'af','Besendingslyste',0),(144227,4007,'ro','Expediere listÄƒ',0),(144228,4007,'et','Saadetiste loend',0),(144229,4007,'si','Seznam dobavnice',0),(144230,4007,'ba','Daftar pengiriman',0),(144231,4007,'nl','Overzicht van verzendingen',0),(144232,4007,'fi','LÃ¤hetysluettelo',0),(144233,4007,'no','Forsendelsesliste',0),(144234,4007,'da','Forsendelsesliste',0),(144235,4007,'ko','í™”ë¬¼ ëª©ë¡',0),(144236,4007,'he','×¨×©×™×ž×ª ×ž×©×œ×•×—',0),(144237,4007,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»ÏŽÎ½ Î‘Ï€Î¿Î¸',0),(144238,4007,'zh','è£…è¿æ¸…å•\r\n',0),(144239,4007,'sv','FÃ¶rsÃ¤ndelselista',0),(144240,4007,'it','Lista di spedizione',0),(144241,4007,'tl','',0),(144242,4007,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(144243,4007,'hi','à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤¸à¥‚à¤šà¥€',0),(144244,4007,'ms','Senarai penghantaran',0),(144245,4007,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø´Ø­Ù†',0),(144246,4007,'fr','Liste des expÃ©ditions',0),(144247,4007,'jp','ç™ºé€?ãƒªã‚¹ãƒˆ',0),(144248,4007,'pt','Lista de remessa',0),(144249,4007,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(144250,4007,'es','Lista de EnvÃ­os',0),(144251,4007,'de','Versand-Liste',0),(144252,4007,'en','Shipment List',0),(144253,4008,'is','',0),(144254,4008,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(144255,4008,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(144256,4008,'tr','SipariÅŸ GÃ¼ncelleÅŸtirmesi',0),(144257,4008,'pl','ZamÃ³wienie aktualizacji',0),(144258,4008,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(144259,4008,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(144260,4008,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(144261,4008,'vi','thÃ nh cÃ´ng',0),(144262,4008,'af','Bestelling Opdatering',0),(144263,4008,'ro','Comanda Update',0),(144264,4008,'et','Tellimuse uuendamine',0),(144265,4008,'si','Da posodobitev',0),(144266,4008,'ba','Update pesanan',0),(144267,4008,'nl','Volgorde Update',0),(144268,4008,'fi','PÃ¤ivitys',0),(144269,4008,'no','Ordreoppdatering',0),(144270,4008,'da','Ordrevedligeholdelse.',0),(144271,4008,'ko','ì£¼ë¬¸ ì—…ë°ì´íŠ¸',0),(144272,4008,'he','×¢×“×›×•×Ÿ ×”×–×ž× ×”',0),(144273,4008,'el','Î”Î¹Î¬Ï„Î±Î¾Î· Update',0),(144274,4008,'zh','è®¢è´­æ›´æ–°\r\n',0),(144275,4008,'sv','Orderuppdatering',0),(144276,4008,'it','Aggiornamento ordine',0),(144277,4008,'tl','',0),(144278,4008,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(144279,4008,'hi','à¤•à¥à¤°à¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(144280,4008,'ms','Arahan Kemaskini',0),(144281,4008,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù†Ø¸Ø§Ù…',0),(144282,4008,'fr','Mise Ã  jour de la commande',0),(144283,4008,'jp','æ³¨æ–‡ã?®æ›´æ–°',0),(144284,4008,'pt','AtualizaÃ§Ã£o de ordem',0),(144285,4008,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·',0),(144286,4008,'es','Orden Actualizar',0),(144287,4008,'de','Bestellung-Update',0),(144288,4008,'en','Order Update',0),(144289,4009,'is','',0),(144290,4009,'dr','(Ù…Ø¬ÙˆØ²',0),(144291,4009,'pr','Ú†Ø§Ù¾ Ø¨Ù„ÙŠØ·(Ù…Ø¬ÙˆØ²',0),(144292,4009,'tr','BaskÄ± bilet',0),(144293,4009,'pl','WydrukowaÄ‡ bilet',0),(144294,4009,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð±Ð¸Ð»ÐµÑ‚Ð¸',0),(144295,4009,'ur','Ù¹Ú©Ù¹ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(144296,4009,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(144297,4009,'vi','In vÃ©',0),(144298,4009,'af','Druk Kaartjie',0),(144299,4009,'ro','Bilet de imprimare',0),(144300,4009,'et','Piletite printimine',0),(144301,4009,'si','Tiskanje vozovnice',0),(144302,4009,'ba','Mencetak tiket',0),(144303,4009,'nl','Ticket afgedrukt',0),(144304,4009,'fi','Tulostaa lippu',0),(144305,4009,'no','Skrive ut billetten',0),(144306,4009,'da','Udskrive billet',0),(144307,4009,'ko','ì¸ì‡„ í‹°ì¼“',0),(144308,4009,'he','×œ×”×“×¤×™×¡ ×›×¨×˜×™×¡',0),(144309,4009,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„Î¿Ï… ÎµÎ¹ÏƒÎ¹Ï„Î·ÏÎ¯Î¿Ï…',0),(144310,4009,'zh','æ‰“å°æ­¤å•æ®\r\n',0),(144311,4009,'sv','Skriva ut biljetten',0),(144312,4009,'it','Stampare il biglietto',0),(144313,4009,'tl','',0),(144314,4009,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3633;&#3659;&#3623;',0),(144315,4009,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤Ÿà¤¿à¤•à¤Ÿ',0),(144316,4009,'ms','Cetakan Tiket',0),(144317,4009,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªØ°ÙƒØ±Ø©',0),(144318,4009,'fr','Ticket d\'impression',0),(144319,4009,'jp','ãƒ?ã‚±ãƒƒãƒˆå?°åˆ·',0),(144320,4009,'pt','Imprimir o bilhete',0),(144321,4009,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚',0),(144322,4009,'es','Boleto de ImpresiÃ³n',0),(144323,4009,'de','Ticket ausdrucken',0),(144324,4009,'en','Print Ticket',0),(144325,4010,'is','',0),(144326,4010,'dr','Ø­Ø°Ù Ø§ÙŠÙ†\r\n Non',0),(144327,4010,'pr','Ø­Ø°Ù Ø§ÙŠÙ†\r\n Non',0),(144328,4010,'tr','Silin bu sigara',0),(144329,4010,'pl','DelegowaÄ‡ ten nie',0),(144330,4010,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ð¡Ñ‚Ð°Ð¸ Ð·Ð°',0),(144331,4010,'ur','Ø§Ø³ ØºÛŒØ± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(144332,4010,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ ÐÐ¾Ð½',0),(144333,4010,'vi','XÃ³a KhÃ´ng nÃ y',0),(144334,4010,'af','Skrap hierdie Nie',0),(144335,4010,'ro','ÅžtergeÅ£i acest Non',0),(144336,4010,'et','Kustuta see Standard',0),(144337,4010,'si','IzbriÅ¡ite ta Non',0),(144338,4010,'ba','Menghapus bebas ini',0),(144339,4010,'nl','Deze niet verwijderen',0),(144340,4010,'fi','Poista tÃ¤mÃ¤ Wi',0),(144341,4010,'no','Slette denne ikke',0),(144342,4010,'da','Slet denne ikke',0),(144343,4010,'ko','ì´ ë¹„ë¥¼ ì‚­ì œ',0),(144344,4010,'he','×œ×ž×—×•×§ ×œ×œ× ×–×”',0),(144345,4010,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î·',0),(144346,4010,'zh','åˆ é™¤æ­¤éž\r\n',0),(144347,4010,'sv','Ta bort denna icke',0),(144348,4010,'it','Eliminare questo Non',0),(144349,4010,'tl','',0),(144350,4010,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3609;&#3637;&#3657;',0),(144351,4010,'hi','à¤‡à¤¸ à¤—à¥ˆà¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(144352,4010,'ms','Menghapuskan bebas ini',0),(144353,4010,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø¹Ø¯Ù…',0),(144354,4010,'fr','Supprimer cette Non',0),(144355,4010,'jp','ã?“ã?®ï¼®ï½?ï½Žã‚’æ¶ˆåŽ»',0),(144356,4010,'pt','Excluir este nÃ£o',0),(144357,4010,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(144358,4010,'es','Eliminar este Non',0),(144359,4010,'de','LÃ¶schen Sie diese nicht',0),(144360,4010,'en','Delete this Non',0),(144361,4011,'is','',0),(144362,4011,'dr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ø§Ø¶Ø§ÙÙŠ',0),(144363,4011,'pr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ø§Ø¶Ø§ÙÙŠ',0),(144364,4011,'tr','Ek deÄŸiÅŸiklikleri kaydet',0),(144365,4011,'pl','Zapisz dodatkowe zmiany',0),(144366,4011,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(144367,4011,'ur','Ø§Ø¶Ø§ÙÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(144368,4011,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ‚Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ñ€Ð¾Ð¼Ñ˜ÐµÐ½Ðµ',0),(144369,4011,'vi','Sao lÆ°u thay Ä‘á»•i thÃªm',0),(144370,4011,'af','Stoor Addisionele Veranderinge',0),(144371,4011,'ro','Salvare modificÄƒri suplimentare',0),(144372,4011,'et','Salvesta lisamuudatused',0),(144373,4011,'si','Shrani dodatne spremembe',0),(144374,4011,'ba','Simpan perubahan tambahan',0),(144375,4011,'nl','Extra wijzigingen opslaan',0),(144376,4011,'fi','Tallenna muutoksia',0),(144377,4011,'no','Lagre endringer',0),(144378,4011,'da','Gemme yderligere Ã¦ndringer',0),(144379,4011,'ko','ì¶”ê°€ ë³€ê²½ ì €ìž¥',0),(144380,4011,'he','×©×ž×•×¨ ×©×™× ×•×™×™× × ×•×¡×¤×™×',0),(144381,4011,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï€ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Î±Î»Î»Î±Î³Î­Ï‚',0),(144382,4011,'zh','ä¿å­˜é™„åŠ å˜æ›´\r\n',0),(144383,4011,'sv','Spara ytterligare Ã¤ndringar',0),(144384,4011,'it','Salvare le modifiche aggiuntive',0),(144385,4011,'tl','',0),(144386,4011,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3607;&#3637;&#3656;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(144387,4011,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(144388,4011,'ms','Simpan perubahan tambahan',0),(144389,4011,'ar','Ø­ÙØ¸ ØªØºÙŠÙŠØ±Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ©',0),(144390,4011,'fr','Enregistrer les modifications supplÃ©mentaires',0),(144391,4011,'jp','è¿½åŠ æ–™é‡‘ã?®ä¿?å­˜',0),(144392,4011,'pt','Salvar alteraÃ§Ãµes adicionais',0),(144393,4011,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(144394,4011,'es','Guadar Cambios Adicionales',0),(144395,4011,'de','ZusÃ¤tzliche Ã„nderungen speichern',0),(144396,4011,'en','Save Additional Changes',0),(144397,4012,'is','',0),(144398,4012,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡ÙŠÚ† Ú†ÙŠØ² Ø¬Ø¯ÙŠØ¯ ',0),(144399,4012,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡ÙŠÚ† Ú†ÙŠØ² Ø¬Ø¯ÙŠØ¯ ',0),(144400,4012,'tr','Yeni ekle Sigara',0),(144401,4012,'pl','Dodaj nowy nie',0),(144402,4012,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð·Ð°',0),(144403,4012,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº Ù†ÛŒØ§ ØºÛŒØ±',0),(144404,4012,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ ÐºÐ¾Ñ˜Ð¸ Ð½Ð¸ÑÑƒ',0),(144405,4012,'vi','ThÃªm Non Má»›i',0),(144406,4012,'af','Voeg nuwe nie',0),(144407,4012,'ro','AdÄƒuga noi Non',0),(144408,4012,'et','Lisa uus mitte',0),(144409,4012,'si','Dodati nove brez',0),(144410,4012,'ba','Tambah baru bebas',0),(144411,4012,'nl','Nieuwe toevoegen niet',0),(144412,4012,'fi','LisÃ¤Ã¤ uusi ei',0),(144413,4012,'no','Legge til nye ikke',0),(144414,4012,'da','TilfÃ¸j ny ikke',0),(144415,4012,'ko','ìƒˆë¡œìš´ ì¶”ê°€ ë¹„',0),(144416,4012,'he','×”×•×¡×¤×ª ×—×“×© ×©××™× ×•',0),(144417,4012,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Ï‰Î½ Î¼Î·',0),(144418,4012,'zh','å¢žåŠ æ–°çš„éž\r\n',0),(144419,4012,'sv','LÃ¤gga till nya icke',0),(144420,4012,'it','Aggiungi nuovo Non',0),(144421,4012,'tl','',0),(144422,4012,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(144423,4012,'hi','à¤¨à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤—à¥ˆà¤°',0),(144424,4012,'ms','Tambah baru bebas',0),(144425,4012,'ar','Ø¥Ø¶Ø§ÙØ© Ø¬Ø¯ÙŠØ¯Ø© ØºÙŠØ±',0),(144426,4012,'fr','Ajouter de nouveaux Non',0),(144427,4012,'jp','æ–°è¦?ï¼®ï½?ï½Žã‚’è¿½åŠ ',0),(144428,4012,'pt','Adicionar novo nÃ£o',0),(144429,4012,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(144430,4012,'es','Agregar Nuevo Non',0),(144431,4012,'de','FÃ¼gen Sie neue nicht',0),(144432,4012,'en','Add New Non',0),(144433,4013,'is','',0),(144434,4013,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø´ÙˆØ¯',0),(144435,4013,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø´ÙˆØ¯',0),(144436,4013,'tr','GÃ¼ncelleÅŸtirme Sigara',0),(144437,4013,'pl','Aktualizacja nie',0),(144438,4013,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð·Ð°',0),(144439,4013,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ ØºÛŒØ±',0),(144440,4013,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÐºÐ¾Ñ˜Ðµ Ð½Ð¸ÑÑƒ',0),(144441,4013,'vi','Cáº­p Nháº­t khÃ´ng',0),(144442,4013,'af','Opdateer Geen',0),(144443,4013,'ro','Actualizare Non',0),(144444,4013,'et','Update mitte',0),(144445,4013,'si','Niso posodobitve',0),(144446,4013,'ba','Pembaruan bebas',0),(144447,4013,'nl','Update niet',0),(144448,4013,'fi','PÃ¤ivitys ei',0),(144449,4013,'no','Oppdateringen ikke',0),(144450,4013,'da','Opdatering ikke',0),(144451,4013,'ko','ë¹„ ì—…ë°ì´íŠ¸',0),(144452,4013,'he','×¢×“×›×•×Ÿ ×©××™× ×•',0),(144453,4013,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î·',0),(144454,4013,'zh','æ›´æ–°éž\r\n',0),(144455,4013,'sv','Uppdatera icke',0),(144456,4013,'it','Aggiornamento Non',0),(144457,4013,'tl','',0),(144458,4013,'th','&#3652;&#3617;&#3656;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(144459,4013,'hi','à¤—à¥ˆà¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(144460,4013,'ms','Kemas kini yang bebas',0),(144461,4013,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(144462,4013,'fr','Mise Ã  jour Non',0),(144463,4013,'jp','ï¼®ï½?ï½Žã?®æ›´æ–°',0),(144464,4013,'pt','AtualizaÃ§Ã£o nÃ£o',0),(144465,4013,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(144466,4013,'es','Actualizar Non',0),(144467,4013,'de','Update nicht',0),(144468,4013,'en','Update Non',0),(144469,4014,'is','',0),(144470,4014,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙƒØªÙˆØ± ',0),(144471,4014,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙƒØªÙˆØ± ',0),(144472,4014,'tr','Hata fatura oluÅŸturma',0),(144473,4014,'pl','BÅ‚Ä…d tworzenia faktury',0),(144474,4014,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(144475,4014,'ur','Ù†Ù‚Øµ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’',0),(144476,4014,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(144477,4014,'vi','Lá»—i táº¡o hÃ³a Ä‘Æ¡n',0),(144478,4014,'af','Fout skep faktuur',0),(144479,4014,'ro','Eroare creare facturÄƒ',0),(144480,4014,'et','TÃµrke loomise arvelt',0),(144481,4014,'si','Napaka pri ustvarjanju raÄuna',0),(144482,4014,'ba','Kesalahan membuat faktur',0),(144483,4014,'nl','Fout maken factuur',0),(144484,4014,'fi','Luo lasku',0),(144485,4014,'no','Feil under oppretting av faktura',0),(144486,4014,'da','Fejl at oprette faktura',0),(144487,4014,'ko','ì˜¤ë¥˜ ë§Œë“¤ê¸° ì†¡ìž¥',0),(144488,4014,'he','×©×’×™××ª ×™×¦×™×¨×ª ×—×©×‘×•× ×™×ª',0),(144489,4014,'el','Î£Ï†Î¬Î»Î¼Î± Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(144490,4014,'zh','é”™è¯¯åˆ›å»ºå‘ç¥¨\r\n',0),(144491,4014,'sv','Fel att skapa faktura',0),(144492,4014,'it','Errore creazione fattura',0),(144493,4014,'tl','',0),(144494,4014,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(144495,4014,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤šà¤¾à¤²à¤¾à¤¨',0),(144496,4014,'ms','Ralat mencipta invois',0),(144497,4014,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(144498,4014,'fr','Erreur crÃ©ation de facture',0),(144499,4014,'jp','è«‹æ±‚æ›¸ä½œæˆ?ã‚¨ãƒ©ãƒ¼',0),(144500,4014,'pt','Erro criando factura',0),(144501,4014,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ð¸ Ð¡Ñ‡ÐµÑ‚Ð°',0),(144502,4014,'es','Error Creando Factura',0),(144503,4014,'de','Fehler erstellen Rechnung',0),(144504,4014,'en','Error Creating Invoice',0),(144505,4015,'is','',0),(144506,4015,'dr','Ø§Ø¨Ø²Ø§Ø±',0),(144507,4015,'pr','Ø§Ø¨Ø²Ø§Ø±',0),(144508,4015,'tr','AraÃ§lar',0),(144509,4015,'pl','NarzÄ™dzia',0),(144510,4015,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(144511,4015,'ur','ÙÙˆØ±Ù… Ú©Û’ Ø§ÙˆØ²Ø§Ø±',0),(144512,4015,'sr','ÐÐ»Ð°Ñ‚ÐºÐµ',0),(144513,4015,'vi','CÃ´ng cá»¥',0),(144514,4015,'af','Gereedskap',0),(144515,4015,'ro','Instrumente',0),(144516,4015,'et','TÃ¶Ã¶riistad',0),(144517,4015,'si','Orodja',0),(144518,4015,'ba','Alat',0),(144519,4015,'nl','Hulpprogramma \'s',0),(144520,4015,'fi','TyÃ¶kalut',0),(144521,4015,'no','VerktÃ¸y',0),(144522,4015,'da','VÃ¦rktÃ¸jer',0),(144523,4015,'ko','ë„êµ¬',0),(144524,4015,'he','×›×œ×™×',0),(144525,4015,'el','Î•ÏÎ³Î±Î»ÎµÎ¯Î±',0),(144526,4015,'zh','å·¥å…·\r\n',0),(144527,4015,'sv','Verktyg',0),(144528,4015,'it','Strumenti',0),(144529,4015,'tl','',0),(144530,4015,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;',0),(144531,4015,'hi','à¤‰à¤ªà¤•à¤°à¤£',0),(144532,4015,'ms','Alat-alat',0),(144533,4015,'ar','Ø§Ù„Ø£Ø¯ÙˆØ§Øª',0),(144534,4015,'fr','Outils',0),(144535,4015,'jp','ãƒ„ãƒ¼ãƒ«',0),(144536,4015,'pt','Ferramentas',0),(144537,4015,'ru','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(144538,4015,'es','Herramientas',0),(144539,4015,'de','Werkzeuge',0),(144540,4015,'en','Tools',0),(144541,4016,'is','',0),(144542,4016,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(144543,4016,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(144544,4016,'tr','MÃ¼ÅŸteri Ekle',0),(144545,4016,'pl','Dodaj klienta',0),(144546,4016,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(144547,4016,'ur','Ú¯Ø§ÛÚ© Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(144548,4016,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÑƒÐ¿Ñ†Ð°',0),(144549,4016,'vi','ThÃªm KhÃ¡ch HÃ ng',0),(144550,4016,'af','Voeg Klant/KliÃ«nt by',0),(144551,4016,'ro','Adauga client',0),(144552,4016,'et','Lisa Klient',0),(144553,4016,'si','Dodajanje kupcev',0),(144554,4016,'ba','Tambahkan pelanggan',0),(144555,4016,'nl','Klant toevoegen',0),(144556,4016,'fi','LisÃ¤Ã¤ asiakas',0),(144557,4016,'no','Legge til kunde',0),(144558,4016,'da','TilfÃ¸je kunde',0),(144559,4016,'ko','ê³ ê° ì¶”ê°€',0),(144560,4016,'he','×”×•×¡×£ ×œ×§×•×—',0),(144561,4016,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€ÎµÎ»Î¬Ï„Î·',0),(144562,4016,'zh','å¢žåŠ å®¢æˆ·\r\n',0),(144563,4016,'sv','LÃ¤gg till kund',0),(144564,4016,'it','Aggiungi cliente',0),(144565,4016,'tl','',0),(144566,4016,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(144567,4016,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(144568,4016,'ms','Tambah Baca',0),(144569,4016,'ar','Ø¥Ø¶Ø§ÙØ© Ø²Ø¨ÙˆÙ†',0),(144570,4016,'fr','Ajouter Client',0),(144571,4016,'jp','é¡§å®¢è¿½åŠ ',0),(144572,4016,'pt','Adicionar cliente',0),(144573,4016,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(144574,4016,'es','Agregar Cliente',0),(144575,4016,'de','Kunden anlegen',0),(144576,4016,'en','Add Customer',0),(144577,4017,'is','',0),(144578,4017,'dr','Ø¬Ø³ØªØ¬Ùˆ ',0),(144579,4017,'pr','Ø¬Ø³ØªØ¬Ùˆ ',0),(144580,4017,'tr','Arama',0),(144581,4017,'pl','Wyszukiwania',0),(144582,4017,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ',0),(144583,4017,'ur','Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(144584,4017,'sr','Ð—Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(144585,4017,'vi','TÃ¬m',0),(144586,4017,'af','Opsoek',0),(144587,4017,'ro','CÄƒutare',0),(144588,4017,'et','Otsing',0),(144589,4017,'si','Za iskanje',0),(144590,4017,'ba','Lookup',0),(144591,4017,'nl','Opzoeken',0),(144592,4017,'fi','Haku',0),(144593,4017,'no','Oppslag',0),(144594,4017,'da','Opslag',0),(144595,4017,'ko','ì¡°íšŒ',0),(144596,4017,'he','×‘×“×™×§×ª ×ž×™×“×¢',0),(144597,4017,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(144598,4017,'zh','æŸ¥æ‰¾\r\n',0),(144599,4017,'sv','SÃ¶kning',0),(144600,4017,'it','Ricerca',0),(144601,4017,'tl','',0),(144602,4017,'th','&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;',0),(144603,4017,'hi','à¤²à¥à¤•à¤…à¤ª',0),(144604,4017,'ms','Carian',0),(144605,4017,'ar','Ø¨Ø­Ø«',0),(144606,4017,'fr','Recherche',0),(144607,4017,'jp','å?‚ç…§',0),(144608,4017,'pt','Pesquisa',0),(144609,4017,'ru','ÐŸÐ¾Ð¸ÑÐº',0),(144610,4017,'es','Buscar',0),(144611,4017,'de','Lookup',0),(144612,4017,'en','Lookup',0),(144613,4018,'is','',0),(144614,4018,'dr','Ú¯Ø±ÙˆÙ‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(144615,4018,'pr','Ú¯Ø±ÙˆÙ‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(144616,4018,'tr','Stok Kategori',0),(144617,4018,'pl','Spis kategorii',0),(144618,4018,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(144619,4018,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø²Ù…Ø±Û',0),(144620,4018,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(144621,4018,'vi','Thá»ƒ loáº¡i hÃ ng hÃ³a',0),(144622,4018,'af','Inventaris Kategorie',0),(144623,4018,'ro','Categorie Inventar',0),(144624,4018,'et','Varude kategooria',0),(144625,4018,'si','Zaloge kategorije',0),(144626,4018,'ba','Kategori persediaan',0),(144627,4018,'nl','Inventaris categorie',0),(144628,4018,'fi','Varaston luokka',0),(144629,4018,'no','Lager kategori',0),(144630,4018,'da','Oversigt kategori',0),(144631,4018,'ko','ì¸ë²¤í† ë¦¬ ì¹´í…Œê³ ë¦¬',0),(144632,4018,'he','×ž×œ××™ ×§×˜×’×•×¨×™×”',0),(144633,4018,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(144634,4018,'zh','å­˜è´§ç±»åˆ«\r\n',0),(144635,4018,'sv','Inventering kategori',0),(144636,4018,'it','Inventario categoria',0),(144637,4018,'tl','',0),(144638,4018,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(144639,4018,'hi','à¤¸à¥‚à¤šà¥€ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(144640,4018,'ms','Kategori inventori',0),(144641,4018,'ar','ØªØµÙ†ÙŠÙ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(144642,4018,'fr','CatÃ©gorie de l\'inventaire',0),(144643,4018,'jp','åœ¨åº«ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(144644,4018,'pt','Categoria de inventÃ¡rio',0),(144645,4018,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(144646,4018,'es','CategorÃ­a de Inventario',0),(144647,4018,'de','Inventar-Kategorie',0),(144648,4018,'en','Inventory Category',0),(144649,4019,'is','',0),(144650,4019,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚Ø§Ú† Ø¬Ø¯ÙŠØ¯ ',0),(144651,4019,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚Ø§Ú† Ø¬Ø¯ÙŠØ¯ ',0),(144652,4019,'tr','Yeni dilim eklemek',0),(144653,4019,'pl','DodaÄ‡ nowy plasterek',0),(144654,4019,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð¿Ð°Ñ€Ñ‡Ðµ',0),(144655,4019,'ur','Ù†Ø¦Û’ Ù‚Ø§Ø´ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(144656,4019,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ ÐºÐ¾Ð¼Ð°Ð´',0),(144657,4019,'vi','ThÃªm Slice Má»›i',0),(144658,4019,'af','Nuwe Skyf Byvoeg',0),(144659,4019,'ro','Adauga nouÄƒ felie',0),(144660,4019,'et','Lisa uus sektor',0),(144661,4019,'si','Dodajte nove rezina',0),(144662,4019,'ba','Tambahkan Slice baru',0),(144663,4019,'nl','Nieuw segment toevoegen',0),(144664,4019,'fi','LisÃ¤Ã¤ uudet Slice',0),(144665,4019,'no','Legg nye skive',0),(144666,4019,'da','TilfÃ¸je nye skive',0),(144667,4019,'ko','ìƒˆ ë¶„í•  ì˜ì—­ì„ ì¶”ê°€',0),(144668,4019,'he','×œ×”×•×¡×™×£ ×¤×¨×•×¡×” ×—×“×©×”',0),(144669,4019,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Slice',0),(144670,4019,'zh','å¢žåŠ æ–°çš„é¡µ\r\n',0),(144671,4019,'sv','LÃ¤gg nya skiva',0),(144672,4019,'it','Aggiungi nuova Slice',0),(144673,4019,'tl','',0),(144674,4019,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3656;&#3591;',0),(144675,4019,'hi','à¤¨à¤ à¤Ÿà¥à¤•à¤¡à¤¼à¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(144676,4019,'ms','Tambah hirisan yang baru',0),(144677,4019,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙŠØ­Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(144678,4019,'fr','Ajouter nouvelle tranche',0),(144679,4019,'jp','æ–°è¦?ã‚¹ãƒ©ã‚¤ã‚¹ã?®è¿½åŠ ',0),(144680,4019,'pt','Adicionar nova fatia',0),(144681,4019,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ„Ñ€Ð°Ð³Ð¼ÐµÐ½Ñ‚',0),(144682,4019,'es','Agregar Nueva Rebanada',0),(144683,4019,'de','FÃ¼gen Sie neues Slice',0),(144684,4019,'en','Add New Slice',0),(144685,4020,'is','',0),(144686,4020,'dr','Ù†Ù…ÙˆØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(144687,4020,'pr','Ù†Ù…ÙˆØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(144688,4020,'tr','Yeni pasta',0),(144689,4020,'pl','Nowy koÅ‚owy',0),(144690,4020,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ð°Ð¹',0),(144691,4020,'ur','Ù†Ø¦Û’ Ù¾Ø§Ø¦ÛŒ',0),(144692,4020,'sr','ÐÐ¾Ð²Ð¸ ÐºÑ€ÑƒÐ¶Ð½Ð¸',0),(144693,4020,'vi','á»ng má»›i',0),(144694,4020,'af','Nuwe Sirkeldiagram',0),(144695,4020,'ro','Noi Pie',0),(144696,4020,'et','Uus sektordiagramm',0),(144697,4020,'si','Nov Pie',0),(144698,4020,'ba','Baru Pie',0),(144699,4020,'nl','Nieuwe Pie',0),(144700,4020,'fi','Uusi Pie',0),(144701,4020,'no','Nye Pie',0),(144702,4020,'da','Nye Pie',0),(144703,4020,'ko','ìƒˆë¡œìš´ íŒŒì´',0),(144704,4020,'he','×¢×•×’×” ×—×“×©×”',0),(144705,4020,'el','ÎÎ­Î± Ï€Î¯Ï„Î±',0),(144706,4020,'zh','æ–°çš„é¥¼å›¾\r\n',0),(144707,4020,'sv','Nya paj',0),(144708,4020,'it','Nuova torta',0),(144709,4020,'tl','',0),(144710,4020,'th','Pie &#3651;&#3627;&#3617;&#3656;',0),(144711,4020,'hi','à¤¨à¤ˆ à¤ªà¤¾à¤ˆ',0),(144712,4020,'ms','Pai baru',0),(144713,4020,'ar','Ù…Ø®Ø·Ù‘Ø· Ø¯Ø§Ø¦Ø±ÙŠ Ø¬Ø¯ÙŠØ¯',0),(144714,4020,'fr','Nouvelle tarte',0),(144715,4020,'jp','æ–°è¦?ãƒ‘ã‚¤',0),(144716,4020,'pt','Torta de Nova',0),(144717,4020,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¸Ñ€Ð¾Ð³',0),(144718,4020,'es','Nuevo GrÃ¡fica Pie',0),(144719,4020,'de','Neue Pie',0),(144720,4020,'en','New Pie',0),(144721,4021,'is','',0),(144722,4021,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù…Ø§Ù†Ø¯Ù‡',0),(144723,4021,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù…Ø§Ù†Ø¯Ù‡',0),(144724,4021,'tr','Denge ileri',0),(144725,4021,'pl','Saldo do przodu',0),(144726,4021,'bg','Ð‘Ð°Ð»Ð°Ð½Ñ Ð½Ð°Ð¿Ñ€ÐµÐ´',0),(144727,4021,'ur','Ø¢Ú¯Û’ Ø¨Ú‘Ú¾Ù†Û’ Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† ØªÙˆØ§Ø²Ù†',0),(144728,4021,'sr','Ð¡Ð°Ð»Ð´Ð¾ Ð½Ð°Ð¿Ñ€ÐµÐ´',0),(144729,4021,'vi','Sá»‘ dÆ° mang sang',0),(144730,4021,'af','Balans Oorgebring',0),(144731,4021,'ro','Echilibru cu nerÄƒbdare',0),(144732,4021,'et','Tasakaalu ettepoole',0),(144733,4021,'si','Ravnovesje naprej',0),(144734,4021,'ba','Keseimbangan ke depan',0),(144735,4021,'nl','Evenwicht vooruit',0),(144736,4021,'fi','Tasapaino eteenpÃ¤in',0),(144737,4021,'no','Balanse frem',0),(144738,4021,'da','Saldo frem',0),(144739,4021,'ko','ì•žìœ¼ë¡œ ê· í˜•',0),(144740,4021,'he','××™×–×•×Ÿ ×§×“×™×ž×”',0),(144741,4021,'el','Î™ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±Ï‚ Ï€ÏÎ¿Ï‚ Ï„Î± ÎµÎ¼Ï€ÏÏŒÏ‚',0),(144742,4021,'zh','ä½™é¢è½¬å‘\r\n',0),(144743,4021,'sv','Balansera fram',0),(144744,4021,'it','Equilibrio in avanti',0),(144745,4021,'tl','',0),(144746,4021,'th','&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3621;&#3656;&#3623;&#3591;&#3627;&#3609;&#3657;&#3634;',0),(144747,4021,'hi','à¤¶à¥‡à¤· à¤†à¤—à¥‡',0),(144748,4021,'ms','Baki ke hadapan',0),(144749,4021,'ar','Ø§Ù„ØªÙˆØ§Ø²Ù† Ø¥Ù„Ù‰ Ø§Ù„Ø£Ù…Ø§Ù…',0),(144750,4021,'fr','Solde reportÃ©',0),(144751,4021,'jp','ç¹°è¶Šæ®‹é«˜',0),(144752,4021,'pt','EquilÃ­brio para a frente',0),(144753,4021,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ Ð²Ð¿ÐµÑ€ÐµÐ´',0),(144754,4021,'es','Saldo de Entrada',0),(144755,4021,'de','Balancieren vorwÃ¤rts',0),(144756,4021,'en','Balance Forward',0),(144757,4022,'is','',0),(144758,4022,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(144759,4022,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(144760,4022,'tr','Stok hareketi',0),(144761,4022,'pl','Ruch zapasÃ³w',0),(144762,4022,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(144763,4022,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(144764,4022,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾Ñ‚ÐµÐ·',0),(144765,4022,'vi','Chuyá»ƒn HÃ ng',0),(144766,4022,'af','Voorraad Beweeg',0),(144767,4022,'ro','Inventarul mutare',0),(144768,4022,'et','Varude liikumine',0),(144769,4022,'si','Premik zaloge',0),(144770,4022,'ba','Bergerak persediaan',0),(144771,4022,'nl','Voorraad verplaatsen',0),(144772,4022,'fi','Varaston siirto',0),(144773,4022,'no','Lager trekk',0),(144774,4022,'da','Lageret flytte',0),(144775,4022,'ko','ìž¬ê³  ì´ë™',0),(144776,4022,'he','×”×ž×”×œ×š ×ž×œ××™',0),(144777,4022,'el','ÎšÎ¯Î½Î·ÏƒÎ· Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(144778,4022,'zh','åº“å­˜ç§»åŠ¨\r\n',0),(144779,4022,'sv','Inventering flytta',0),(144780,4022,'it','Inventario mossa',0),(144781,4022,'tl','',0),(144782,4022,'th','&#3585;&#3634;&#3619;&#3648;&#3588;&#3621;&#3639;&#3656;&#3629;&#3609;&#3618;&#3657;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(144783,4022,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤šà¤¾à¤²',0),(144784,4022,'ms','Inventori bergerak',0),(144785,4022,'ar','Ù†Ù‚Ù„ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(144786,4022,'fr','DÃ©mÃ©nagement de l\'inventaire',0),(144787,4022,'jp','åœ¨åº«ç§»å‹•',0),(144788,4022,'pt','Movimento de estoque',0),(144789,4022,'ru','Ð”Ð²Ð¸Ð³Ð°Ñ‚ÑŒÑÑ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(144790,4022,'es','Mover el Inventario',0),(144791,4022,'de','Inventar verschieben',0),(144792,4022,'en','Inventory Move',0),(144793,4023,'is','',0),(144794,4023,'dr','Pad Left  Ù„Ø§ÙŠÙ‡ Ú†Ù¾',0),(144795,4023,'pr',' Pad Left  Ù„Ø§ÙŠÙ‡ Ú†Ù¾',0),(144796,4023,'tr',' Sol pad',0),(144797,4023,'pl',' PodkÅ‚adka po lewej',0),(144798,4023,'bg',' Ð¢Ð°Ð¼Ð¿Ð¾Ð½ Ð»ÑÐ²',0),(144799,4023,'ur',' Ø¨Ø§Ø¦ÛŒÚº Ù¾ÛŒÚˆ',0),(144800,4023,'sr',' ÐŸÐ¾Ð´Ð»Ð¾Ð³Ð° Ð·Ð° Ð¾ÑÑ‚Ð°Ð»Ð¾',0),(144801,4023,'vi','Miáº¿ng Ä‘á»‡m trÃ¡i',0),(144802,4023,'af',' Pad links',0),(144803,4023,'ro',' Tampon stÃ¢nga',0),(144804,4023,'et',' PADI vasak',0),(144805,4023,'si',' Pad levo',0),(144806,4023,'ba',' Pad kiri',0),(144807,4023,'nl',' Pad links',0),(144808,4023,'fi',' Pad vasen',0),(144809,4023,'no',' Pad venstre',0),(144810,4023,'da',' Pad til venstre',0),(144811,4023,'ko',' ì™¼ìª½ íŒ¨ë“œ',0),(144812,4023,'he',' ×ž×©×˜×— ×©×ž××œ',0),(144813,4023,'el',' ÎœÎ±Î¾Î¹Î»Î¬ÏÎ¹ Î±ÏÎ¹ÏƒÏ„ÎµÏÎ¬',0),(144814,4023,'zh','å·¦åž«\r\n',0),(144815,4023,'sv',' Pad vÃ¤nster',0),(144816,4023,'it',' Pad a sinistra',0),(144817,4023,'tl','',0),(144818,4023,'th','&#3648;&#3610;&#3634;&#3632;&#3621;&#3629;&#3591;&#3627;&#3617;&#3638;&#3585;&#3605;&#3637;&#3605;&#3619;&#3634;&#3604;&#3657;&#3634;&#3609;&#3595;&#3657;&#3634;&#3618;',0),(144819,4023,'hi',' à¤ªà¥ˆà¤¡ à¤¬à¤¾à¤à¤',0),(144820,4023,'ms',' Pad kiri',0),(144821,4023,'ar',' ÙˆØ³Ø§Ø¯Ø© Ø§Ù„ÙŠØ³Ø§Ø±',0),(144822,4023,'fr',' Coussinet gauche',0),(144823,4023,'jp','ãƒ‘ãƒƒãƒ‰ã®å·¦æ–¹å‘',0),(144824,4023,'pt',' Bloco de esquerda',0),(144825,4023,'ru',' Pad ÑÐ»ÐµÐ²Ð°',0),(144826,4023,'es','Cojinar a la Izquierda',0),(144827,4023,'de',' Pad Links',0),(144828,4023,'en',' Pad Left',0),(144829,4024,'is','',0),(144830,4024,'dr','(Ø³Ø±ÙŠ Ù¾ÙŠØ§Ù…',0),(144831,4024,'pr','Ø§Ù…ØªØ­Ø§Ù† Ø±Ø´ØªÙ‡ (Ø³Ø±ÙŠ Ù¾ÙŠØ§Ù…',0),(144832,4024,'tr','SÄ±nama dizesi',0),(144833,4024,'pl','Test String',0),(144834,4024,'bg','Ð¢ÐµÑÑ‚Ð¾Ð²Ð¸Ñ Ð½Ð¸Ð·',0),(144835,4024,'ur','Ø³Ù„Ú© Ú©ÛŒ Ø¬Ø§Ù†Ú†',0),(144836,4024,'sr','Ð¢ÐµÑÑ‚ Ð½Ð¸ÑÐºÐµ',0),(144837,4024,'vi','DÃ¢y kiá»ƒm tra',0),(144838,4024,'af','Toets tou',0),(144839,4024,'ro','Åžir de testare',0),(144840,4024,'et','Test String',0),(144841,4024,'si','Preskusni niz',0),(144842,4024,'ba','Menguji String',0),(144843,4024,'nl','Testtekenreeks',0),(144844,4024,'fi','Merkkijono',0),(144845,4024,'no','Teststrengen',0),(144846,4024,'da','Test streng',0),(144847,4024,'ko','í…ŒìŠ¤íŠ¸ ë¬¸ìžì—´',0),(144848,4024,'he','×ž×—×¨×•×–×ª ×”×‘×“×™×§×”',0),(144849,4024,'el','Î£Ï…Î¼Î²Î¿Î»Î¿ÏƒÎµÎ¹ÏÎ¬ Î´Î¿ÎºÎ¹Î¼Î®',0),(144850,4024,'zh','æµ‹è¯•å­—ç¬¦ä¸²\r\n',0),(144851,4024,'sv','Testa String',0),(144852,4024,'it','Stringa di prova',0),(144853,4024,'tl','',0),(144854,4024,'th','&#3607;&#3604;&#3626;&#3629;&#3610;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3648;&#3619;&#3637;&#3618;&#3591;&#3648;&#3611;&#3655;&#3609;&#3649;&#3606;&#3623;',0),(144855,4024,'hi','à¤¸à¥à¤Ÿà¥à¤°à¤¿à¤‚à¤— à¤•à¤¾ à¤ªà¤°à¥€à¤•à¥à¤·à¤£',0),(144856,4024,'ms','Rentetan ujian',0),(144857,4024,'ar','Ø§Ø®ØªØ¨Ø§Ø± Ø³Ù„Ø³Ù„Ø©',0),(144858,4024,'fr','Test String',0),(144859,4024,'jp','ãƒ†ã‚¹ãƒˆæ–‡å­—åˆ—',0),(144860,4024,'pt','SeqÃ¼Ãªncia de teste',0),(144861,4024,'ru','Ð¢ÐµÑÑ‚Ð¾Ð²Ð°Ñ ÑÑ‚Ñ€Ð¾ÐºÐ°',0),(144862,4024,'es','Serie de Prueba',0),(144863,4024,'de','Teststring',0),(144864,4024,'en','Test String',0),(144865,4025,'is','',0),(144866,4025,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø®ÙˆØ§Ù†Ø¯Ù† Ø²Ø¨Ø§Ù† ',0),(144867,4025,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø®ÙˆØ§Ù†Ø¯Ù† Ø²Ø¨Ø§Ù† ',0),(144868,4025,'tr','Hata okuma dil',0),(144869,4025,'pl','BÅ‚Ä…d odczytu jÄ™zyka',0),(144870,4025,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ñ‡ÐµÑ‚ÐµÐ½Ðµ ÐµÐ·Ð¸Ðº',0),(144871,4025,'ur','Ù†Ù‚Øµ Ù¾Ú‘Ú¾Ù†Û’ Ø²Ø¨Ø§Ù†',0),(144872,4025,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ñ‡Ð¸Ñ‚Ð°ÑšÐ° Ñ˜ÐµÐ·Ð¸Ðº',0),(144873,4025,'vi','Lá»—i khi Ä‘á»c ngÃ´n ngá»¯',0),(144874,4025,'af','Fout met Lees van Taal',0),(144875,4025,'ro','Eroare citire limba',0),(144876,4025,'et','Viga lugemisel',0),(144877,4025,'si','Napaka pri branju jezik',0),(144878,4025,'ba','Kesalahan membaca bahasa',0),(144879,4025,'nl','Fout lezing taal',0),(144880,4025,'fi','Virhe lukeminen kieli',0),(144881,4025,'no','Feil Reading sprÃ¥k',0),(144882,4025,'da','Fejl lÃ¦sning sprog',0),(144883,4025,'ko','ì˜¤ë¥˜ ì½ê¸° ì–¸ì–´',0),(144884,4025,'he','×©×’×™××” ×‘×§×¨×™××” ×©×¤×”',0),(144885,4025,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î½Î¬Î³Î½Ï‰ÏƒÎ·Ï‚ Î³Î»ÏŽÏƒÏƒÎ±',0),(144886,4025,'zh','è¯»è¯­è¨€é”™è¯¯',0),(144887,4025,'sv','Fel lÃ¤sning sprÃ¥k',0),(144888,4025,'it','Errore lettura lingua',0),(144889,4025,'tl','',0),(144890,4025,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3629;&#3656;&#3634;&#3609;&#3616;&#3634;&#3625;&#3634;',0),(144891,4025,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¤ à¤¨ à¤­à¤¾à¤·à¤¾',0),(144892,4025,'ms','Ralat membaca Bahasa',0),(144893,4025,'ar','Ø®Ø·Ø£ ÙÙŠ Ù‚Ø±Ø§Ø¡Ø© Ø§Ù„Ù„ØºØ©',0),(144894,4025,'fr','Erreur de lecture de langue',0),(144895,4025,'jp','è¨€èªžã?®èª­ã?¿å?–ã‚Šã‚¨ãƒ©ãƒ¼',0),(144896,4025,'pt','Erro leitura linguagem',0),(144897,4025,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð§Ñ‚ÐµÐ½Ð¸Ð¸ Ð¯Ð·Ñ‹ÐºÐ°',0),(144898,4025,'es','Error Leyendo Lenguaje',0),(144899,4025,'de','Fehler lesen Sprache',0),(144900,4025,'en','Error Reading Language',0),(144901,4026,'is','',0),(144902,4026,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(144903,4026,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(144904,4026,'tr','SipariÅŸ fatura listesi YazdÄ±r',0),(144905,4026,'pl','Lista zapowiadane druku zamÃ³wienia',0),(144906,4026,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(144907,4026,'ur','ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ø§Ù„Ù„Ø§Ø¯ Û”',0),(144908,4026,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(144909,4026,'vi','Danh SÃ¡ch cÃ¡c Ä‘Æ¡n hÃ ng in Ä‘Ã£ ra hÃ³a Ä‘Æ¡n',0),(144910,4026,'af','Lys Gefaktureerde Bestellings Uitgedruk',0),(144911,4026,'ro','Lista facturat ordine de imprimare',0),(144912,4026,'et','Arve loendi trÃ¼kitÃ¶Ã¶de tellimused',0),(144913,4026,'si','Seznam zaraÄunali tiskanje nalogov',0),(144914,4026,'ba','Daftar ditagih cetak pesanan',0),(144915,4026,'nl','Lijst gefactureerd afdrukken bestellingen',0),(144916,4026,'fi','Luettelo laskutetaan tulosta tilaukset',0),(144917,4026,'no','Listen fakturert bestilling',0),(144918,4026,'da','Listen faktureret aftryksbestillinger',0),(144919,4026,'ko','ì²­êµ¬ ëª©ë¡ ì¸ì‡„ ì£¼ë¬¸',0),(144920,4026,'he','×¨×©×™×ž×ª ×ž×—×•×™×‘ ×”×“×¤×¡×•×ª',0),(144921,4026,'el','Î›Î¯ÏƒÏ„Î± Ï„Î¹Î¼Î¿Î»Î¿Î³ÎµÎ¯Ï„Î±Î¹ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½',0),(144922,4026,'zh','åˆ—å‡ºå¸å•çš„æ‰“å°è®¢å•\r\n',0),(144923,4026,'sv','Lista faktureras Print Order',0),(144924,4026,'it','Ordini di stampa elenco fatturato',0),(144925,4026,'tl','',0),(144926,4026,'th','&#3626;&#3633;&#3656;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(144927,4026,'hi','à¤¬à¤¿à¤² à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¸à¥‚à¤šà¥€ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶',0),(144928,4026,'ms','Pesanan cetakan senarai yang dibilkan',0),(144929,4026,'ar','Ù‚Ø§Ø¦Ù…Ø© ÙÙˆØ§ØªÙŠØ± Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(144930,4026,'fr','Commandes liste facturÃ©',0),(144931,4026,'jp','è«‹æ±‚æ¸ˆå?°åˆ·æ³¨æ–‡ã?®ãƒªã‚¹ãƒˆ',0),(144932,4026,'pt','Ordens de impressÃ£o de lista de bico',0),(144933,4026,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(144934,4026,'es','Listar Ordenes de ImpresiÃ³n Facturadas',0),(144935,4026,'de','Liste in Rechnung gestellt-DruckauftrÃ¤ge',0),(144936,4026,'en','List Billed Print Orders',0),(144937,4027,'is','',0),(144938,4027,'dr','Ø§Ø±ØªÙØ§Ø¹ Ø¨Ø±Ø­Ø³Ø¨ Ø§ÙŠÙ†Ú† Ù‡Ø± ',0),(144939,4027,'pr','Ø§Ø±ØªÙØ§Ø¹ Ø¨Ø±Ø­Ø³Ø¨ Ø§ÙŠÙ†Ú† Ù‡Ø± ',0),(144940,4027,'tr','Ä°nÃ§ yÃ¼kseklik',0),(144941,4027,'pl','Cali wysokoÅ›ci',0),(144942,4027,'bg','Ð˜Ð½Ñ‡Ð° Ð²Ð¸ÑÐ¾Ñ‡Ð¸Ð½Ð°',0),(144943,4027,'ur','Ø§Ù†Ú† Ú©ÛŒ Ø§ÙˆÙ†Ú†Ø§Ø¦ÛŒ ÛØ±',0),(144944,4027,'sr','Ð˜Ð½Ñ‡Ð° Ð²Ð¸ÑÐ¸Ð½Ð°',0),(144945,4027,'vi','Äá»™ cao theo Inch má»—i',0),(144946,4027,'af','Duim hoogte elke',0),(144947,4027,'ro','Inch Ã®nÄƒlÅ£ime fiecare',0),(144948,4027,'et','Tolli kÃµrgusega',0),(144949,4027,'si','Palcev viÅ¡ina',0),(144950,4027,'ba','Inci tinggi masing-masing',0),(144951,4027,'nl','Inch hoogte',0),(144952,4027,'fi','Tuumaa korkeus',0),(144953,4027,'no','Tommer hÃ¸yde hver',0),(144954,4027,'da','Inches hÃ¸jde, hver',0),(144955,4027,'ko','ì¸ì¹˜ ë†’ì´',0),(144956,4027,'he','×¡ ×ž ×’×•×‘×”',0),(144957,4027,'el','ÎŠÎ½Ï„ÏƒÎµÏ‚ ÏÏˆÎ¿Ï‚ ÎºÎ¬Î¸Îµ',0),(144958,4027,'zh','æ¯è‹±å¯¸çš„èº«é«˜\r\n',0),(144959,4027,'sv','Inches hÃ¶jd varje',0),(144960,4027,'it','Pollici di altezza ogni',0),(144961,4027,'tl','',0),(144962,4027,'th','&#3588;&#3623;&#3634;&#3617;&#3626;&#3641;&#3591; (&#3609;&#3636;&#3657;&#3623;) &#3649;&#3605;&#3656;&#3621;&#3632;&#3594;&#3636;&#3657;&#3609;',0),(144963,4027,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤‡à¤‚à¤š à¤Šà¤à¤šà¤¾à¤ˆ',0),(144964,4027,'ms','Inci ketinggian setiap',0),(144965,4027,'ar','Ø§Ø±ØªÙØ§Ø¹ ÙƒÙ„ Ø¨ÙˆØµØ©',0),(144966,4027,'fr','Pouces de hauteur chaque',0),(144967,4027,'jp','å?„é«˜ã?•ã?®ã‚¤ãƒ³ãƒ?',0),(144968,4027,'pt','Polegadas de altura cada',0),(144969,4027,'ru','Ð”ÑŽÐ¹Ð¼Ð¾Ð² Ð²Ñ‹ÑÐ¾Ñ‚Ð¾Ð¹',0),(144970,4027,'es','Altura en Pulgadas Cada Uno',0),(144971,4027,'de','Jeder Zoll HÃ¶he',0),(144972,4027,'en','Inches Height Each',0),(144973,4028,'is','',0),(144974,4028,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø®Ù„Ø§ØµÙ‡ Ø´Ù†Ø§Ø³Ù‡ Ø­Ø³Ø§Ø¨ ',0),(144975,4028,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø®Ù„Ø§ØµÙ‡ Ø´Ù†Ø§Ø³Ù‡ Ø­Ø³Ø§Ø¨ ',0),(144976,4028,'tr','Ã–zet hesap kimliÄŸi gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(144977,4028,'pl','BÅ‚Ä…d podczas aktualizowania podsumowania identyfikator konta',0),(144978,4028,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° ID',0),(144979,4028,'ur','Ø®Ù„Ø§ØµÛ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(144980,4028,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ° Ð˜Ð” Ð½Ð°Ð»Ð¾Ð³Ð°',0),(144981,4028,'vi','Cáº­p Nháº­t BÃ¡o CÃ¡o ID TK bá»‹ lá»—i',0),(144982,4028,'af','Fout bywerking opsomming-rekening-ID',0),(144983,4028,'ro','Eroare la actualizarea Rezumat cont ID',0),(144984,4028,'et','Viga ajakohastamine kokkuvÃµtlik konto ID',0),(144985,4028,'si','Napaka pri posodabljanju Povzetek ID raÄuna',0),(144986,4028,'ba','Kesalahan update ringkasan Account ID',0),(144987,4028,'nl','Fout bij het bijwerken van samenvatting Account-ID',0),(144988,4028,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ Yhteenveto tilin tunnus',0),(144989,4028,'no','Feil under oppdatering av Sammendrag konto-ID',0),(144990,4028,'da','Fejl under opdatering af sammenfattende konto-ID',0),(144991,4028,'ko','ì˜¤ë¥˜ ìš”ì•½ ê³„ì • IDë¥¼ ì—…ë°ì´íŠ¸',0),(144992,4028,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¡×™×›×•× ×ž×–×”×” ×—×©×‘×•×Ÿ',0),(144993,4028,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ ÏƒÏÎ½Î¿ÏˆÎ·Ï‚ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÎ¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(144994,4028,'zh','é”™è¯¯æ›´æ–°æ±‡æ€»å¸æˆ·èº«ä»½',0),(144995,4028,'sv','Gick inte att uppdatera Sammanfattning konto-ID',0),(144996,4028,'it','Errore di aggiornamento riepilogo Account ID',0),(144997,4028,'tl','',0),(144998,4028,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3619;&#3640;&#3611;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(144999,4028,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤–à¤¾à¤¤à¤¾ ID à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(145000,4028,'ms','Ralat dalam mengemas kini ringkasan akaun ID',0),(145001,4028,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù…Ù„Ø®Øµ Ø­Ø³Ø§Ø¨ Ù…Ø¹Ø±Ù',0),(145002,4028,'fr','Erreur mise Ã  jour Sommaire compte ID',0),(145003,4028,'jp','ã‚µãƒžãƒªãƒ¼ã‚¢ã‚«ã‚¦ãƒ³ãƒˆï¼©ï¼¤ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(145004,4028,'pt','Erro ao atualizar o ID da conta Resumo',0),(145005,4028,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ€ÐµÐ·ÑŽÐ¼Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(145006,4028,'es','Error actualizando ID de Cuenta Sumaria',0),(145007,4028,'de','Fehler beim Aktualisieren der Zusammenfassung Konto-ID',0),(145008,4028,'en','Error Updating Summary Account ID',0),(145009,4029,'is','',0),(145010,4029,'dr','Ø§ÙˆÙ„ÙŠÙ† Ø¯ÙˆØ±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(145011,4029,'pr','Ø§ÙˆÙ„ÙŠÙ† Ø¯ÙˆØ±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(145012,4029,'tr','Ä°lk sipariÅŸi dÃ¶nemi',0),(145013,4029,'pl','Pierwszy okres zamÃ³wienia',0),(145014,4029,'bg','ÐŸÑŠÑ€Ð²Ð¸ Ñ€ÐµÐ´ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(145015,4029,'ur','Ù¾ÛÙ„Û’ Ø¢Ø±ÚˆØ± Ø¯ÙˆØ±',0),(145016,4029,'sr','ÐŸÑ€Ð²Ð¸ Ñ€ÐµÐ´ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(145017,4029,'vi','Thá»i ká»³ Ä‘áº·t hÃ ng Äáº§u tiÃªn',0),(145018,4029,'af','Eerste Bestelling Periode',0),(145019,4029,'ro','Prima perioadÄƒ de ordine',0),(145020,4029,'et','Esimese tellimuse perioodi',0),(145021,4029,'si','Prvo naroÄilo obdobje',0),(145022,4029,'ba','Masa Orde pertama',0),(145023,4029,'nl','Eerste orde periode',0),(145024,4029,'fi','EnsimmÃ¤isen tilauksen aikana',0),(145025,4029,'no','For perioden',0),(145026,4029,'da','FÃ¸rste ordre periode',0),(145027,4029,'ko','ì²« ë²ˆì§¸ ìˆœì„œ ê¸°ê°„',0),(145028,4029,'he','×¡×“×¨ ×œ×’×ž×¨×™×™.',0),(145029,4029,'el','Î ÏÏŽÏ„Î· ÏƒÎµÎ¹ÏÎ¬ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(145030,4029,'zh','ç¬¬ä¸€æœŸ\r\n',0),(145031,4029,'sv','FÃ¶rsta ordern perioden',0),(145032,4029,'it','Primo periodo di ordine',0),(145033,4029,'tl','',0),(145034,4029,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3621;&#3635;&#3604;&#3633;&#3610;&#3649;&#3619;&#3585;',0),(145035,4029,'hi','à¤ªà¤¹à¤²à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤…à¤µà¤§à¤¿',0),(145036,4029,'ms','Tempoh perintah yang pertama',0),(145037,4029,'ar','Ø§Ù„ÙØªØ±Ø© Ø§Ù„Ø£ÙˆÙ„Ù‰ ÙÙŠ Ø§Ù„ØªØ±ØªÙŠØ¨',0),(145038,4029,'fr','PremiÃ¨re pÃ©riode de l\'ordre',0),(145039,4029,'jp','æœ€åˆ?ã?®æ³¨æ–‡æœŸé–“',0),(145040,4029,'pt','Primeiro perÃ­odo de ordem',0),(145041,4029,'ru','ÐŸÐµÑ€Ð²Ñ‹Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð·Ð°ÐºÐ°Ð·Ð°',0),(145042,4029,'es','Primer PerÃ­odo de Orden',0),(145043,4029,'de','Erste Bestellung-Periode',0),(145044,4029,'en','First Order Period',0),(145045,4030,'is','',0),(145046,4030,'dr','Ø¯ÙˆØ±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¯ÙˆÙ… ',0),(145047,4030,'pr','Ø¯ÙˆØ±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¯ÙˆÙ… ',0),(145048,4030,'tr','Ä°kinci sipariÅŸi dÃ¶nemi',0),(145049,4030,'pl','Drugi okres zamÃ³wienia',0),(145050,4030,'bg','Ð’Ñ‚Ð¾Ñ€Ð¸ÑÑ‚ Ñ€ÐµÐ´ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(145051,4030,'ur','Ø¯ÙˆØ³Ø±Ø§ Ø­Ú©Ù… Ø¯ÙˆØ±',0),(145052,4030,'sr','Ð”Ñ€ÑƒÐ³Ð¸ Ñ€ÐµÐ´ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(145053,4030,'vi','Giai Ä‘oáº¡n Ä‘áº·t hÃ ng thá»© hai',0),(145054,4030,'af','Tweede Bestel Periode',0),(145055,4030,'ro','A doua perioadÄƒ de ordine',0),(145056,4030,'et','Teises jÃ¤rjekorras perioodi',0),(145057,4030,'si','Drugo obdobje nalog',0),(145058,4030,'ba','Masa Orde kedua',0),(145059,4030,'nl','Tweede orde periode',0),(145060,4030,'fi','Toinen huoltotilauskauden aikana',0),(145061,4030,'no','Andre rekkefÃ¸lge periode',0),(145062,4030,'da','Anden rÃ¦kkefÃ¸lge periode',0),(145063,4030,'ko','ë‘ ë²ˆì§¸ ì£¼ë¬¸ ê¸°ê°„',0),(145064,4030,'he','×ª×§×•×¤×ª ×”×¡×“×¨ ×”×©× ×™',0),(145065,4030,'el','Î”ÎµÏÏ„ÎµÏÎ· ÏƒÎµÎ¹ÏÎ¬ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(145066,4030,'zh','ç¬¬äºŒè®¢å•æœŸ\r\n',0),(145067,4030,'sv','Andra fÃ¶r perioden',0),(145068,4030,'it','Secondo periodo di ordine',0),(145069,4030,'tl','',0),(145070,4030,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3621;&#3635;&#3604;&#3633;&#3610;&#3607;&#3637;&#3656; 2',0),(145071,4030,'hi','à¤¦à¥‚à¤¸à¤°à¤¾ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤…à¤µà¤§à¤¿',0),(145072,4030,'ms','Tempoh perintah yang kedua',0),(145073,4030,'ar','Ø§Ù„ÙØªØ±Ø© Ø§Ù„Ø«Ø§Ù†ÙŠØ© Ù„Ù„Ù†Ø¸Ø§Ù…',0),(145074,4030,'fr','DeuxiÃ¨me pÃ©riode de l\'ordre',0),(145075,4030,'jp','ï¼’ã?¤ç›®ã?®æ³¨æ–‡æœŸé–“',0),(145076,4030,'pt','Segundo perÃ­odo de ordem',0),(145077,4030,'ru','Ð’Ñ‚Ð¾Ñ€Ð¾Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð·Ð°ÐºÐ°Ð·Ð°',0),(145078,4030,'es','Segundo PerÃ­odo de Ordenes',0),(145079,4030,'de','Zweite Bestellung-Periode',0),(145080,4030,'en','Second Order Period',0),(145081,4031,'is','',0),(145082,4031,'dr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(145083,4031,'pr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(145084,4031,'tr','SipariÅŸ beklemeye',0),(145085,4031,'pl','ZÅ‚Ã³Å¼ zamÃ³wienie na luku',0),(145086,4031,'bg','ÐœÑÑÑ‚Ð¾ Ñ€ÐµÐ´ Ð½Ð° Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(145087,4031,'ur','ØªØ±ØªÛŒØ¨ ÛÙˆÙ„Úˆ Ù¾Ø± Ø±Ú©Ú¾ÛŒÚº Û”',0),(145088,4031,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(145089,4031,'vi','Äá»ƒ Ä‘Æ¡n hÃ ng táº¡m ngÆ°ng',0),(145090,4031,'af','Plaas bestelling op hou',0),(145091,4031,'ro','Plasa comanda pe \"hold\"',0),(145092,4031,'et','Esitage tellimus ootel',0),(145093,4031,'si','Se naroÄilo na Äakanju',0),(145094,4031,'ba','Memesan ditahan',0),(145095,4031,'nl','Bestellen in de wachtstand',0),(145096,4031,'fi','Asettaa jÃ¤rjestyksen pitoon',0),(145097,4031,'no','Bestiller pÃ¥ vent',0),(145098,4031,'da','Afgiver ordre pÃ¥ Hold',0),(145099,4031,'ko','ë³´ë¥˜ ì£¼ë¬¸',0),(145100,4031,'he','×”×–×ž× ×” ×‘×”×ž×ª× ×”',0),(145101,4031,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÎµ Î±Î½Î±Î¼Î¿Î½Î®',0),(145102,4031,'zh','å®‰æŽ’è®¢å•ä¿ç•™\r\n',0),(145103,4031,'sv','BestÃ¤llning pÃ¥ is',0),(145104,4031,'it','Mettere ordine in attesa',0),(145105,4031,'tl','',0),(145106,4031,'th','&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3617;&#3639;&#3629;',0),(145107,4031,'hi','à¤¹à¥‹à¤²à¥à¤¡ à¤ªà¤° à¤†à¤¦à¥‡à¤¶ à¤œà¤—à¤¹',0),(145108,4031,'ms','Perintah tempat penahanan',0),(145109,4031,'ar','ØªØ±ØªÙŠØ¨ Ù…ÙƒØ§Ù† Ø§Ù„Ø§Ù†ØªØ¸Ø§Ø±',0),(145110,4031,'fr','Passer une commande en attente',0),(145111,4031,'jp','ä¿?ç•™ä¸­ã?®æ³¨æ–‡ã‚’ã?™ã‚‹',0),(145112,4031,'pt','Coloque ordem em espera',0),(145113,4031,'ru','ÐŸÐµÑ€ÐµÐ½ÐµÑÑ‚Ð¸ Ð—Ð°ÐºÐ°Ð· Ð² ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ðµ',0),(145114,4031,'es','Poner Orden en Reserva',0),(145115,4031,'de','Bestellung auf Eis',0),(145116,4031,'en','Place Order on Hold',0),(145117,4032,'is','',0),(145118,4032,'dr','(Ú¯Ø¯Ø§Ù… Ø¬Ù†Ø³',0),(145119,4032,'pr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ Ø§Ø² Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ† (Ø§Ù†Ø¨Ø§Ø± ÙƒØ§Ù„Ø§',0),(145120,4032,'tr','Emir beklemeden KaldÄ±r',0),(145121,4032,'pl','UsuÅ„ zamÃ³wienie do luku',0),(145122,4032,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð½ÐµÑ‚Ðµ Ñ€ÐµÐ´ Ð¾Ñ‚ Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(145123,4032,'ur','ØªØ±ØªÛŒØ¨ ÛÙˆÙ„Úˆ Ø³Û’ ÛÙ¹Ø§',0),(145124,4032,'sr','Ð£ÐºÐ»Ð°ÑšÐ°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¸Ð· Ð·Ð°Ð´Ñ€ÑˆÐºÑƒ',0),(145125,4032,'vi','ÄÆ°a Ä‘Æ¡n hÃ ng táº¡m ngÆ°ng sang thá»±c hiá»‡n',0),(145126,4032,'af','Verwyder orde van hou',0),(145127,4032,'ro','EliminaÅ£i comanda din suspendare',0),(145128,4032,'et','Tellimuse ootelt',0),(145129,4032,'si','Naloga odstraniti iz zadrÅ¾anja',0),(145130,4032,'ba','Menghapus pesanan dari memegang',0),(145131,4032,'nl','Verwijderen uit wachtruimte',0),(145132,4032,'fi','Poistaminen pidosta',0),(145133,4032,'no','Fjern ordre fra sperring',0),(145134,4032,'da','Fjerne ordre fra venteposition',0),(145135,4032,'ko','ì£¼ë¬¸ ë³´ë¥˜ì—ì„œ ì œê±°',0),(145136,4032,'he','×œ×”×¡×™×¨ ×¡×“×¨ ×ž×”×ž×ª× ×”',0),(145137,4032,'el','ÎšÎ±Ï„Î±ÏÎ³Î®ÏƒÎµÏ„Îµ ÏƒÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ Î´Î¹Î±Ï„Î®ÏÎ·ÏƒÎ·',0),(145138,4032,'zh','ä»ŽçŽ°æœ‰ä¸­ç§»é™¤\r\n',0),(145139,4032,'sv','Ta bort Order frÃ¥n undantag',0),(145140,4032,'it','Rimuovere l\'ordine da tenere',0),(145141,4032,'tl','',0),(145142,4032,'th','&#3621;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3606;&#3639;&#3629;&#3652;&#3623;&#3657;',0),(145143,4032,'hi','à¤•à¥à¤°à¤® à¤¹à¥‹à¤²à¥à¤¡ à¤¸à¥‡ à¤¨à¤¿à¤•à¤¾à¤²à¤¨à¤¾',0),(145144,4032,'ms','Alih Keluar perintah daripada penahanan',0),(145145,4032,'ar','Ø¥Ø²Ø§Ù„Ø© Ø§Ù„Ù†Ø¸Ø§Ù… Ù…Ù† Ø¹Ù‚Ø¯',0),(145146,4032,'fr','Supprimer l\'ordre de cale',0),(145147,4032,'jp','ä¿?ç•™ä¸­ã?‹ã‚‰æ³¨æ–‡ã‚’æ¶ˆåŽ»',0),(145148,4032,'pt','Remover ordem de porÃ£o',0),(145149,4032,'ru','Ð£Ð±Ñ€Ð°Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð· Ð˜Ð· ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ñ',0),(145150,4032,'es','Eliminar Orden De En Espera',0),(145151,4032,'de','Entfernen Sie halten Ordnung',0),(145152,4032,'en','Remove Order From Hold',0),(145153,4033,'is','',0),(145154,4033,'dr','(ÙØ±ÙˆØ´',0),(145155,4033,'pr','Ú†Ø§Ù¾ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø­Ø±Ø§Ø¬(ÙØ±ÙˆØ´',0),(145156,4033,'tr','SatÄ±ÅŸ kategorilerini yazdÄ±rÄ±n',0),(145157,4033,'pl','Drukowanie kategorii sprzedaÅ¼y',0),(145158,4033,'bg','ÐŸÐµÑ‡Ð°Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(145159,4033,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø²Ù…Ø±ÙˆÚº Ú©Ùˆ Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº',0),(145160,4033,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(145161,4033,'vi','Thá»ƒ loáº¡i kinh doanh in',0),(145162,4033,'af','Druk VerkoopskategoriÃ«',0),(145163,4033,'ro','Categorii imprimare de vÃ¢nzÄƒri',0),(145164,4033,'et','Saate printida mÃ¼Ã¼gi Kategooriad',0),(145165,4033,'si','Natisni zvrsti prodaje',0),(145166,4033,'ba','Cetak Kategori Penjualan',0),(145167,4033,'nl','Verkoopcategorie afdrukken',0),(145168,4033,'fi','Tulosta myynnin Luokat',0),(145169,4033,'no','Skrive ut salg kategorier',0),(145170,4033,'da','Udskrive salg kategorier',0),(145171,4033,'ko','ì¸ì‡„ íŒë§¤ ì¹´í…Œê³ ë¦¬',0),(145172,4033,'he','×”×“×¤×¡ ×§×˜×’×•×¨×™×•×ª ×ž×›×™×¨×•×ª',0),(145173,4033,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(145174,4033,'zh','æ‰“å°é”€å”®ç±»åˆ«\r\n',0),(145175,4033,'sv','Skriva ut fÃ¶rsÃ¤ljningskategori',0),(145176,4033,'it','Categorie vendite stampa',0),(145177,4033,'tl','',0),(145178,4033,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(145179,4033,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(145180,4033,'ms','Kategori jualan cetak',0),(145181,4033,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(145182,4033,'fr','Imprimer les catÃ©gories ventes',0),(145183,4033,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®å?°åˆ·',0),(145184,4033,'pt','Categorias vendas impressÃ£o',0),(145185,4033,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(145186,4033,'es','CategorÃ­as de Ventas de ImpresiÃ³n',0),(145187,4033,'de','Drucken Vertrieb Kategorien',0),(145188,4033,'en','Print Sales Categories',0),(145189,4034,'is','',0),(145190,4034,'dr','Ø§ÙØ²ÙˆØ¯Ù†  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(145191,4034,'pr','Ø§ÙØ²ÙˆØ¯Ù†  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(145192,4034,'tr','AlÄ±ntÄ± notlar ekleyin/gÃ¼ncelleyin',0),(145193,4034,'pl','Notatki wycenÄ™ Dodaj/Aktualizuj',0),(145194,4034,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²ÑÑ‚ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(145195,4034,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†ÙˆÙ¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(145196,4034,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° ÐÐ¾Ñ‚ÐµÑ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(145197,4034,'vi','ThÃªm/Cáº­p nháº­t ghi chÃº BÃ¡o giÃ¡',0),(145198,4034,'af','Kwotasie Notas Skep/Opdateer',0),(145199,4034,'ro','Citat note AdÄƒugaÅ£i/actualizaÅ£i',0),(145200,4034,'et','Hinnapakkumise mÃ¤rkmete lisamine/uuendamine',0),(145201,4034,'si','Citiram ugotavlja Dodaj/posodobi',0),(145202,4034,'ba','Mengutip catatan Tambahkan/Perbarui',0),(145203,4034,'nl','Offerte notities toevoegen/bijwerken',0),(145204,4034,'fi','Lainaus toteaa lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(145205,4034,'no','Sitere notater/Oppdater',0),(145206,4034,'da','Citat noter TilfÃ¸j/opdater',0),(145207,4034,'ko','ë”°ì˜´í‘œë¥¼ ë©”ëª¨ë¥¼ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(145208,4034,'he','×”×¢×¨×•×ª ×œ×”×¦×¢×ª ×ž×—×™×¨ ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(145209,4034,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(145210,4034,'zh','æ–°å¢ž/æ›´æ–°æŠ¥ä»·è¯´æ˜Ž\r\n',0),(145211,4034,'sv','Citera anteckningar LÃ¤gg till/uppdatera',0),(145212,4034,'it','Citazione note aggiungere/aggiornare',0),(145213,4034,'tl','',0),(145214,4034,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(145215,4034,'hi','à¤¬à¥‹à¤²à¥€ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(145216,4034,'ms','Petikan Nota Tambah/Kemaskini',0),(145217,4034,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(145218,4034,'fr','Citation Notes ajouter/mettre Ã  jour',0),(145219,4034,'jp','è¦‹ç©?ã‚Šãƒ¡ãƒ¢ã?®è¿½åŠ /æ›´æ–°',0),(145220,4034,'pt','Notas de citaÃ§Ã£o adicionar/atualizar',0),(145221,4034,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€ÑƒÑŽ Ð¾Ñ‚Ð¼ÐµÑ‡Ð°ÐµÑ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(145222,4034,'es','CotizaciÃ³n Notas Agregar/Actualizar',0),(145223,4034,'de','Zitat Notizen hinzufÃ¼gen/aktualisieren',0),(145224,4034,'en','Quote Notes Add/Update',0),(145225,4035,'is','',0),(145226,4035,'dr','0 - Ø®Ù„Ø§ØµÙ‡ Ù†Ø´Ø¯Ù‡',0),(145227,4035,'pr','0 - Ø®Ù„Ø§ØµÙ‡ Ù†Ø´Ø¯Ù‡',0),(145228,4035,'tr','0 - deÄŸil Ã¶zetlenmiÅŸtir',0),(145229,4035,'pl','0 - nie podsumowane',0),(145230,4035,'bg','0 - Ð½Ðµ Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½Ð¸',0),(145231,4035,'ur','ØµÙØ± Û” Ú¯Ù…Ù†Ø§Ù… ',0),(145232,4035,'sr','0 - Ð½Ðµ Ñ€ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°Ñ‚Ð¸',0),(145233,4035,'vi','0 - khÃ´ng tá»•ng cá»™ng',0),(145234,4035,'af','0 - nie opgesom',0),(145235,4035,'ro','0 - neadunate',0),(145236,4035,'et','0 - mitte kokku',0),(145237,4035,'si','0 - ni povzeti',0),(145238,4035,'ba','0 - tidak dijumlahkan',0),(145239,4035,'nl','0 - niet worden samengevat',0),(145240,4035,'fi','0 - ei Yhteenveto',0),(145241,4035,'no','0 - ikke oppsummert',0),(145242,4035,'da','0 - ikke opsummeret',0),(145243,4035,'ko','0-ìš”ì•½ ë˜ì§€',0),(145244,4035,'he','0 - ×œ× ×¡×™×›×',0),(145245,4035,'el','0 - Î´ÎµÎ½ ÏƒÏ…Î½Î¿ÏˆÎ¯Î¶Î¿Î½Ï„Î±Î¹',0),(145246,4035,'zh','0 - ä¸èƒ½æ€»ç»“\r\n',0),(145247,4035,'sv','0 - ej summerade',0),(145248,4035,'it','0 - non catalogato',0),(145249,4035,'tl','wala - hindi buod',0),(145250,4035,'th','à¸¢à¸±à¸‡à¹„à¸¡à¹ˆà¸–à¸¹à¸à¸£à¸§à¸¡',0),(145251,4035,'hi','0 - à¤¸à¤‚à¤•à¥à¤·à¥‡à¤ª à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚',0),(145252,4035,'ms','0 - tidak diringkaskan',0),(145253,4035,'ar','0 - ØºÙŠØ± Ù…Ù„Ø®Ù‘Øµ',0),(145254,4035,'fr','0 - Non RÃ©sumÃ©',0),(145255,4035,'jp','ï¼?ï¼?ã‚µãƒžãƒ©ã‚¤ã‚ºã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(145256,4035,'pt','0 - nÃ£o resumidas',0),(145257,4035,'ru','0 - Ð½Ðµ ÑÑƒÐ¼Ð¼Ð¸Ñ€ÑƒÑŽÑ‚ÑÑ',0),(145258,4035,'es','0 - no totalizado',0),(145259,4035,'de','0 - nicht summiert',0),(145260,4035,'en','0 - not summarized',0),(145261,4036,'is','',0),(145262,4036,'dr','120 + Ø±ÙˆØ²Ù‡Ø§',0),(145263,4036,'pr','120 + Ø±ÙˆØ²Ù‡Ø§',0),(145264,4036,'tr','120 + gÃ¼n',0),(145265,4036,'pl','120 + dni',0),(145266,4036,'bg','120 + Ð´Ð½Ð¸',0),(145267,4036,'ur','Ø§ÛŒÚ© Ø³Ùˆ Ø¨ÛŒØ³ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø¯Ù† ',0),(145268,4036,'sr','120 + Ð´Ð°Ð½Ð°',0),(145269,4036,'vi','120 + NgÃ y',0),(145270,4036,'af','120 + Dae',0),(145271,4036,'ro','120 + Zile',0),(145272,4036,'et','120 + pÃ¤eva',0),(145273,4036,'si','120 + dni',0),(145274,4036,'ba','120 + Hari',0),(145275,4036,'nl','120 + dagen',0),(145276,4036,'fi','120 + pÃ¤ivÃ¤Ã¤',0),(145277,4036,'no','120 + dager',0),(145278,4036,'da','120 + dage',0),(145279,4036,'ko','120 + ì¼',0),(145280,4036,'he','120 + ×™×ž×™×',0),(145281,4036,'el','120 + Î—Î¼Î­ÏÎµÏ‚',0),(145282,4036,'zh','120 + å¤©',0),(145283,4036,'sv','120 + dagar',0),(145284,4036,'it','PiÃ¹ di 120 giorni',0),(145285,4036,'tl','isang daan at dalawampung mas higit pang mga araw',0),(145286,4036,'th','à¹€à¸à¸´à¸™ 120 à¸§à¸±à¸™',0),(145287,4036,'hi','120 + à¤¦à¤¿à¤¨',0),(145288,4036,'ms','120 + hari',0),(145289,4036,'ar','120 + Ø§Ù„Ø£ÙŠØ§Ù…',0),(145290,4036,'fr','120 Jours de Plus',0),(145291,4036,'jp','120æ—¥ä»¥ä¸Š',0),(145292,4036,'pt','120 + dias',0),(145293,4036,'ru','120 + Ð”Ð½Ð¸',0),(145294,4036,'es','+ 120 DÃ­as',0),(145295,4036,'de','120 + Tage',0),(145296,4036,'en','120 + Days',0),(145297,4037,'is','',0),(145298,4037,'dr','30 Ø±ÙˆØ²',0),(145299,4037,'pr','30 Ø±ÙˆØ²',0),(145300,4037,'tr','30 gÃ¼n',0),(145301,4037,'pl','30 dni',0),(145302,4037,'bg','30 Ð´Ð½Ð¸',0),(145303,4037,'ur','ØªÛŒØ³ Ø¯Ù†',0),(145304,4037,'sr','30 Ð´Ð°Ð½Ð°',0),(145305,4037,'vi','30 NgÃ y',0),(145306,4037,'af','30 Dae',0),(145307,4037,'ro','30 de zile',0),(145308,4037,'et','30 pÃ¤eva',0),(145309,4037,'si','30 dni',0),(145310,4037,'ba','30 Hari',0),(145311,4037,'nl','30 dagem',0),(145312,4037,'fi','30 pÃ¤ivÃ¤Ã¤',0),(145313,4037,'no','30 dager',0),(145314,4037,'da','30 dage',0),(145315,4037,'ko','30 ì¼',0),(145316,4037,'he','×™×•× 30',0),(145317,4037,'el','30 Î—Î¼Î­ÏÎµÏ‚',0),(145318,4037,'zh','30å¤©',0),(145319,4037,'sv','30 Dagar',0),(145320,4037,'it','30 Giorni',0),(145321,4037,'tl','',0),(145322,4037,'th','30 à¸§à¸±à¸™',0),(145323,4037,'hi','30 à¤¦à¤¿à¤¨',0),(145324,4037,'ms','30 hari',0),(145325,4037,'ar','Ø«Ù„Ø§Ø«ÙˆÙ† ÙŠÙˆÙ…Ø§',0),(145326,4037,'fr','30 Jours',0),(145327,4037,'jp','ï¼“ï¼?æ—¥',0),(145328,4037,'pt','30 dias',0),(145329,4037,'ru','30 Ð”Ð½ÐµÐ¹',0),(145330,4037,'es','30 DÃ­as',0),(145331,4037,'de','30 Tage',0),(145332,4037,'en','30 Days',0),(145333,4038,'is','',0),(145334,4038,'dr','30 Ø±ÙˆØ² Ø¢Ø²Ù…Ø§ÛŒØ´ÛŒ',0),(145335,4038,'pr','30 Ø±ÙˆØ² Ø¢Ø²Ù…Ø§ÛŒØ´ÛŒ',0),(145336,4038,'tr','30 gÃ¼n deneme',0),(145337,4038,'pl','30 czasy prÃ³ba',0),(145338,4038,'bg','30 days Ð¾Ð¿Ð¸Ñ‚',0),(145339,4038,'ur','ØªÛŒØ³ Ø¯Ù† Ú©Ø§ ',0),(145340,4038,'sr','Ð¡ÑƒÑ’ÐµÑšÐµ Ð·Ð° 30 Ð´Ð°Ð½Ð°',0),(145341,4038,'vi','Thá»­ 30 NgÃ y',0),(145342,4038,'af','30 Dae Proef',0),(145343,4038,'ro','30 de zile de TEST',0),(145344,4038,'et','30 PÃ¤evane Prooviperiood',0),(145345,4038,'si','Poskusnih 30 dni',0),(145346,4038,'ba','30 Hari Percobaan',0),(145347,4038,'nl','30 dagen proef',0),(145348,4038,'fi','30 days karsintakilpailu',0),(145349,4038,'no','30 dager prÃ¸ve',0),(145350,4038,'da','30 dage retssag',0),(145351,4038,'ko','30 ì¼ í‰ê°€íŒ',0),(145352,4038,'he','â€30 ×™×ž×™ × ×¡×™×•×Ÿ',0),(145353,4038,'el','Î”Î¿ÎºÎ¹Î¼Î® 30 Î—Î¼ÎµÏÏŽÎ½',0),(145354,4038,'zh','30å¤©è¯•ç”¨',0),(145355,4038,'sv','30-Dagars Prov',0),(145356,4038,'it','Prova di 30 giorni',0),(145357,4038,'tl','',0),(145358,4038,'th','à¸—à¸”à¸¥à¸­à¸‡ 30 à¸§à¸±à¸™',0),(145359,4038,'hi','30 à¤¦à¤¿à¤¨ à¤ªà¤°à¥€à¤•à¥à¤·à¤£',0),(145360,4038,'ms','Percubaan 30 hari',0),(145361,4038,'ar','30 ÙŠÙˆÙ…Ø§ Ù„Ù„Ù…Ø­Ø§ÙƒÙ…Ø©',0),(145362,4038,'fr','30 Jours d\'essai',0),(145363,4038,'jp','ç„¡åˆ¶é™?æ™‚é–“ã?®ä½¿ç”¨',0),(145364,4038,'pt','30 dias de teste',0),(145365,4038,'ru','30 Ð´Ð½ÐµÐ¹ Ð¿Ñ€Ð¾Ð±Ð½Ð¾Ð¹ Ð²ÐµÑ€ÑÐ¸Ð¸',0),(145366,4038,'es','30 DÃ­as de Prueba',0),(145367,4038,'de','30 Tage Testversion',0),(145368,4038,'en','30 Days Trial',0),(145369,4039,'is','',0),(145370,4039,'dr','60 Ø±ÙˆØ²Ù‡',0),(145371,4039,'pr','60 Ø±ÙˆØ²Ù‡',0),(145372,4039,'tr','60 gÃ¼n',0),(145373,4039,'pl','60 dni',0),(145374,4039,'bg','60 Ð´Ð½Ð¸',0),(145375,4039,'ur','Ø³Ø§Ù¹Ú¾ Ø¯Ù†',0),(145376,4039,'sr','60 Ð´Ð°Ð½Ð°',0),(145377,4039,'vi','60 NgÃ y',0),(145378,4039,'af','60 Dae',0),(145379,4039,'ro','60 de zile',0),(145380,4039,'et','60 pÃ¤eva',0),(145381,4039,'si','60 dni',0),(145382,4039,'ba','60 Hari',0),(145383,4039,'nl','60 dagen',0),(145384,4039,'fi','60 pv',0),(145385,4039,'no','60 dager',0),(145386,4039,'da','60 dage',0),(145387,4039,'ko','60 ì¼',0),(145388,4039,'he','â€60 ×™×•×',0),(145389,4039,'el','60 Î—Î¼Î­ÏÎµÏ‚',0),(145390,4039,'zh','60 å¤©',0),(145391,4039,'sv','60 dagar',0),(145392,4039,'it','60 giorni',0),(145393,4039,'tl','',0),(145394,4039,'th','60 à¸§à¸±à¸™',0),(145395,4039,'hi','60 à¤¦à¤¿à¤¨',0),(145396,4039,'ms','60 hari',0),(145397,4039,'ar','Ø³ØªÙˆÙ† ÙŠÙˆÙ…Ø§',0),(145398,4039,'fr','60 Jours',0),(145399,4039,'jp','60æ—¥',0),(145400,4039,'pt','60 dias',0),(145401,4039,'ru','60 Ð”Ð½ÐµÐ¹',0),(145402,4039,'es','60 DÃ­as',0),(145403,4039,'de','60 Tage',0),(145404,4039,'en','60 Days',0),(145405,4040,'is','',0),(145406,4040,'dr','90 Ø±ÙˆØ²Ù‡',0),(145407,4040,'pr','90 Ø±ÙˆØ²Ù‡',0),(145408,4040,'tr','90 gÃ¼n',0),(145409,4040,'pl','90 dni',0),(145410,4040,'bg','90 Ð´Ð½Ð¸',0),(145411,4040,'ur','Ù†ÙˆÛ’ Ø¯Ù†',0),(145412,4040,'sr','90 Ð´Ð°Ð½Ð°',0),(145413,4040,'vi','90 NgÃ y',0),(145414,4040,'af','90 Dae',0),(145415,4040,'ro','90 de zile',0),(145416,4040,'et','90 pÃ¤eva',0),(145417,4040,'si','90 dni',0),(145418,4040,'ba','90 Hari',0),(145419,4040,'nl','90 dagen',0),(145420,4040,'fi','90 pv',0),(145421,4040,'no','90 dager',0),(145422,4040,'da','90 dage',0),(145423,4040,'ko','90 ì¼',0),(145424,4040,'he','â€90 ×™×•×',0),(145425,4040,'el','90 Î—Î¼Î­ÏÎµÏ‚',0),(145426,4040,'zh','90 å¤©',0),(145427,4040,'sv','90 dagar',0),(145428,4040,'it','90 giorni',0),(145429,4040,'tl','',0),(145430,4040,'th','90 à¸§à¸±à¸™',0),(145431,4040,'hi','90 à¤¦à¤¿à¤¨',0),(145432,4040,'ms','90 hari',0),(145433,4040,'ar','ØªØ³Ø¹ÙˆÙ† ÙŠÙˆÙ…Ø§',0),(145434,4040,'fr','90 Jours',0),(145435,4040,'jp','90æ—¥',0),(145436,4040,'pt','90 dias',0),(145437,4040,'ru','90 Ð”Ð½ÐµÐ¹',0),(145438,4040,'es','90 DÃ­as',0),(145439,4040,'de','90 Tage',0),(145440,4040,'en','90 Days',0),(145441,4041,'is','',0),(145442,4041,'dr','1000 ØµÙØ­Ù‡ ',0),(145443,4041,'pr','Ø§Ø±ØªÙØ§Ø¹ Ø¨Ø±Ø­Ø³Ø¨ Ø§ÙŠÙ†Ú† Ù‡Ø± 1000 ØµÙØ­Ù‡ ',0),(145444,4041,'tr','1000 adet baÅŸÄ±na inÃ§ yÃ¼kseklik',0),(145445,4041,'pl','Cali wysokoÅ›ci na 1000 arkuszy',0),(145446,4041,'bg','Ð˜Ð½Ñ‡Ð° Ð²Ð¸ÑÐ¾Ñ‡Ð¸Ð½Ð° Ð½Ð° 1000 Ð»Ð¸ÑÑ‚Ð°',0),(145447,4041,'ur','Ø§ÛŒÚ© ÛØ²Ø§Ø± Ø§ÙˆØ±Ø§Ù‚ ÙÛŒ Ø§Ù†Ú† Ú©ÛŒ Ø§ÙˆÙ†Ú†Ø§Ø¦ÛŒ',0),(145448,4041,'sr','Ð’Ð¸ÑÐ¸Ð½Ð° Ð¸Ð½Ñ‡Ð° Ð¿Ð¾ 1000 Ð»Ð¸ÑÑ‚Ð¾Ð²Ð°',0),(145449,4041,'vi','Äá»™ cao theo Inch má»—i 1000 trang',0),(145450,4041,'af','Duim hoogte per 1000 blaaie',0),(145451,4041,'ro','Inci inaltime pe 1000 coli',0),(145452,4041,'et','Tolli kÃµrguse kohta 1000 lehte',0),(145453,4041,'si','Palcev viÅ¡ina na 1000 listov',0),(145454,4041,'ba','Inci tinggi per 1000 lembar',0),(145455,4041,'nl','Inch hoogte per 1000 bladen',0),(145456,4041,'fi','Tuumaa korkeus / 1000 arkkia',0),(145457,4041,'no','Tommer hÃ¸yde per 1000 ark',0),(145458,4041,'da','Inches hÃ¸jde pr. 1000 ark',0),(145459,4041,'ko','1000 ìž¥ ë‹¹ ì¸ì¹˜ ë†’ì´',0),(145460,4041,'he','×¡× ×˜×™×ž×˜×¨×™× ×œ×’×•×‘×” ×œ×›×œ 1000 ×’×™×œ×™×•× ×•×ª',0),(145461,4041,'el','ÎŽÏˆÎ¿Ï‚ Î¯Î½Ï„ÏƒÎµÏ‚ Î±Î½Î¬ 1000 Ï†ÏÎ»Î»Î±',0),(145462,4041,'zh','æ¯1000å¼ çš„é«˜åº¦ï¼ˆè‹±å¯¸ï¼‰\r\n',0),(145463,4041,'sv','Inches hÃ¶jd per 1000 ark',0),(145464,4041,'it','Pollici di altezza per ogni 1000 fogli',0),(145465,4041,'tl','',0),(145466,4041,'th','&#3588;&#3623;&#3634;&#3617;&#3626;&#3641;&#3591;(&#3609;&#3636;&#3657;&#3623;) &#3605;&#3656;&#3629; 1000 &#3649;&#3612;&#3656;&#3609;',0),(145467,4041,'hi','1000 à¤šà¤¾à¤¦à¤°à¥‡à¤‚ à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤‚à¤š à¤Šà¤à¤šà¤¾à¤ˆ',0),(145468,4041,'ms','Inci ketinggian setiap helaian 1000',0),(145469,4041,'ar','Ø§Ø±ØªÙØ§Ø¹ Ø¨ÙˆØµØ© ÙƒÙ„ Ø£ÙˆØ±Ø§Ù‚ 1000',0),(145470,4041,'fr','Pouces de hauteur par 1000 feuilles',0),(145471,4041,'jp','Inches Height per 1000 sheets',0),(145472,4041,'pt','Polegadas de altura por 1000 folhas',0),(145473,4041,'ru','Ð”ÑŽÐ¹Ð¼Ð¾Ð² Ð²Ñ‹ÑÐ¾Ñ‚Ð¾Ð¹ Ð² 1000 Ð»Ð¸ÑÑ‚Ð¾Ð²',0),(145474,4041,'es','Altura en Pulgadas por 1,000 hojas',0),(145475,4041,'de','Zoll HÃ¶he pro 1000 Blatt',0),(145476,4041,'en','Inches Height per 1000 sheets',0),(145477,4042,'is','',0),(145478,4042,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ±Ø§ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(145479,4042,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ±Ø§ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(145480,4042,'tr','En son sevk edilen maddeleri',0),(145481,4042,'pl','Ostatnio wysÅ‚ane elementy',0),(145482,4042,'bg','ÐÐ°ÑÐºÐ¾Ñ€Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(145483,4042,'ur','Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ø§Ø´ÛŒØ§Ø¡',0),(145484,4042,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸Ñ… Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(145485,4042,'vi','HÃ ng vá»«a chuyá»ƒn gáº§n Ä‘Ã¢y',0),(145486,4042,'af','Onlangse Versende Items',0),(145487,4042,'ro','Recent Articole expediate',0),(145488,4042,'et','Hiljuti tarnitud kaubad',0),(145489,4042,'si','Nedavno dobavljene artikle',0),(145490,4042,'ba','Baru saja dikirim item',0),(145491,4042,'nl','Onlangs verzonden artikelen',0),(145492,4042,'fi','Ã„skettÃ¤in toimitetut nimikkeet',0),(145493,4042,'no','Nylig sendte elementer',0),(145494,4042,'da','Seneste afsendte varer',0),(145495,4042,'ko','ìµœê·¼ ë°œì†¡ëœ í’ˆëª©',0),(145496,4042,'he','×¤×¨×™×˜×™× ×©× ×©×œ×—×• ×œ××—×¨×•× ×”',0),(145497,4042,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î± Î±Ï€Î¿ÏƒÏ„Î­Î»Î»ÎµÏ„Î±Î¹ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(145498,4042,'zh','æœ€è¿‘è£…è¿çš„é¡¹ç›®\r\n',0),(145499,4042,'sv','Nyligen levererade artiklar',0),(145500,4042,'it','Recentemente spediti articoli',0),(145501,4042,'tl','',0),(145502,4042,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;',0),(145503,4042,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤®',0),(145504,4042,'ms','Tempahan barang-barang dihantar',0),(145505,4042,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ù…Ø¤Ø®Ø±Ø§',0),(145506,4042,'fr','RÃ©cemment des articles expÃ©diÃ©s',0),(145507,4042,'jp','æœ€è¿‘ç™ºé€?ã?•ã‚Œã?Ÿå“?ç›®',0),(145508,4042,'pt','Recentemente enviados itens',0),(145509,4042,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¾ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ñ‹',0),(145510,4042,'es','Items Enviados Recientemente',0),(145511,4042,'de','KÃ¼rzlich gelieferten Artikel',0),(145512,4042,'en','Recently Shipped Items',0),(145513,4043,'is','',0),(145514,4043,'dr','Ø¹ØµØ± Ø¨Ø®ÙŠØ±',0),(145515,4043,'pr','Ø¹ØµØ± Ø¨Ø®ÙŠØ±',0),(145516,4043,'tr','Ä°yi gÃ¼nler',0),(145517,4043,'pl','DzieÅ„ dobry',0),(145518,4043,'bg','Ð”Ð¾Ð±ÑŠÑ€ Ð´ÐµÐ½',0),(145519,4043,'ur','Ø§Ø³Ù„Ø§Ù… Ùˆ Ø¹Ù„ÙŠÚ©Ù…',0),(145520,4043,'sr','Ð´Ð¾Ð±Ð°Ñ€ Ð´Ð°Ð½',0),(145521,4043,'vi','ChÃ o buá»•i chiá»u',0),(145522,4043,'af','Goeiemiddag',0),(145523,4043,'ro','bunÄƒ ziua',0),(145524,4043,'et','Tere pÃ¤evast',0),(145525,4043,'si','dober dan',0),(145526,4043,'ba','Selamat sore',0),(145527,4043,'nl','Goedemiddag',0),(145528,4043,'fi','HyvÃ¤Ã¤ iltapÃ¤ivÃ¤Ã¤',0),(145529,4043,'no','god ettermiddag',0),(145530,4043,'da','God eftermiddag',0),(145531,4043,'ko','ì•ˆë…•í•˜ì„¸ìš”',0),(145532,4043,'he','×¦×”×¨×™×™× ×˜×•×‘×™×',0),(145533,4043,'el','ÎšÎ±Î»ÏŒ Î±Ï€ÏŒÎ³ÎµÏ…Î¼Î±',0),(145534,4043,'zh','ä¸‹åˆå¥½\r\n',0),(145535,4043,'sv','God eftermiddag',0),(145536,4043,'it','Buon pomeriggio',0),(145537,4043,'tl','',0),(145538,4043,'th','&#3626;&#3623;&#3633;&#3626;&#3604;&#3637;&#3605;&#3629;&#3609;&#3610;&#3656;&#3634;&#3618;',0),(145539,4043,'hi','à¤—à¥à¤¡ à¤‘à¤«à¤¼à¥à¤Ÿà¤°à¤¨à¥‚à¤¨',0),(145540,4043,'ms','selamat tengah hari',0),(145541,4043,'ar','Ù…Ø³Ø§Ø¡ Ø§Ù„Ø®ÙŠØ±',0),(145542,4043,'fr','Bonjour',0),(145543,4043,'jp','ã?“ã‚“ã?«ã?¡ã?¯',0),(145544,4043,'pt','Boa tarde',0),(145545,4043,'ru','Ð”Ð¾Ð±Ñ€Ñ‹Ð¹ Ð”ÐµÐ½ÑŒ',0),(145546,4043,'es','Buenos Tardes',0),(145547,4043,'de','Mahlzeit',0),(145548,4043,'en','Good Afternoon',0),(145549,4044,'is','',0),(145550,4044,'dr','Ø´Ø¨ Ø¨Ø®ÙŠØ±',0),(145551,4044,'pr','Ø´Ø¨ Ø¨Ø®ÙŠØ±',0),(145552,4044,'tr','Ä°yi akÅŸamlar',0),(145553,4044,'pl','Dobry wieczÃ³r',0),(145554,4044,'bg','Ð”Ð¾Ð±ÑŠÑ€ Ð²ÐµÑ‡ÐµÑ€',0),(145555,4044,'ur','Ø´Ø§Ù… Ø¨Ø®ÙŠØ±',0),(145556,4044,'sr','Ð´Ð¾Ð±Ñ€Ð¾ Ð²ÐµÑ‡Ðµ',0),(145557,4044,'vi','ChÃ o buá»•i tá»‘i',0),(145558,4044,'af','Goeienaand',0),(145559,4044,'ro','buna seara',0),(145560,4044,'et','Tere Ãµhtust',0),(145561,4044,'si','dober veÄer',0),(145562,4044,'ba','Selamat malam',0),(145563,4044,'nl','Goedenavond',0),(145564,4044,'fi','HyvÃ¤Ã¤ iltaa',0),(145565,4044,'no','god kveld',0),(145566,4044,'da','Godaften',0),(145567,4044,'ko','ì•ˆë…•í•˜ì„¸ìš”',0),(145568,4044,'he','×¢×¨×‘ ×˜×•×‘',0),(145569,4044,'el','ÎšÎ±Î»Î·ÏƒÏ€Î­ÏÎ±',0),(145570,4044,'zh','æ™šä¸Šå¥½\r\n',0),(145571,4044,'sv','God kvÃ¤ll',0),(145572,4044,'it','Buonasera',0),(145573,4044,'tl','',0),(145574,4044,'th','&#3626;&#3623;&#3633;&#3626;&#3604;&#3637;&#3605;&#3629;&#3609;&#3648;&#3618;&#3655;&#3609;',0),(145575,4044,'hi','à¤¶à¥à¤­ à¤¸à¤‚à¤§à¥à¤¯à¤¾',0),(145576,4044,'ms','selamat petang',0),(145577,4044,'ar','Ù…Ø³Ø§Ø¡ Ø§Ù„Ø®ÙŠØ±',0),(145578,4044,'fr','Bonsoir',0),(145579,4044,'jp','ã?“ã‚“ã?°ã‚“ã?¯',0),(145580,4044,'pt','Boa noite',0),(145581,4044,'ru','Ð”Ð¾Ð±Ñ€Ñ‹Ð¹ Ð’ÐµÑ‡ÐµÑ€',0),(145582,4044,'es','Buenos Tardes',0),(145583,4044,'de','Guten Abend',0),(145584,4044,'en','Good Evening',0),(145585,4045,'is','',0),(145586,4045,'dr','ØµØ¨Ø­ Ø¨Ø®ÙŠØ± ',0),(145587,4045,'pr','ØµØ¨Ø­ Ø¨Ø®ÙŠØ± ',0),(145588,4045,'tr','GÃ¼naydÄ±n',0),(145589,4045,'pl','DzieÅ„ dobry',0),(145590,4045,'bg','Ð”Ð¾Ð±Ñ€Ð¾ ÑƒÑ‚Ñ€Ð¾',0),(145591,4045,'ur','ØµØ¨Ø­ Ø¨Ø®ÙŠØ±',0),(145592,4045,'sr','Ð´Ð¾Ð±Ñ€Ð¾ Ñ˜ÑƒÑ‚Ñ€Ð¾',0),(145593,4045,'vi','ChÃ o buá»•i sÃ¡ng',0),(145594,4045,'af','GoeiemÃ´re',0),(145595,4045,'ro','buna dimineaÅ£a',0),(145596,4045,'et','Tere hommikust',0),(145597,4045,'si','dobro jutro',0),(145598,4045,'ba','Selamat pagi',0),(145599,4045,'nl','Goedemorgen',0),(145600,4045,'fi','HyvÃ¤Ã¤ huomenta',0),(145601,4045,'no','god morgen',0),(145602,4045,'da','Godmorgen',0),(145603,4045,'ko','ì•ˆë…•í•˜ì„¸ìš”',0),(145604,4045,'he','×‘×•×§×¨ ×˜×•×‘',0),(145605,4045,'el','ÎšÎ±Î»Î·Î¼Î­ÏÎ±',0),(145606,4045,'zh','æ—©å®‰\r\n',0),(145607,4045,'sv','God morgon',0),(145608,4045,'it','Buongiorno',0),(145609,4045,'tl','',0),(145610,4045,'th','&#3626;&#3623;&#3633;&#3626;&#3604;&#3637;&#3605;&#3629;&#3609;&#3648;&#3594;&#3657;&#3634;',0),(145611,4045,'hi','à¤¸à¥à¤ªà¥à¤°à¤­à¤¾à¤¤',0),(145612,4045,'ms','selamat pagi',0),(145613,4045,'ar','ØµØ¨Ø§Ø­ Ø§Ù„Ø®ÙŠØ±',0),(145614,4045,'fr','Bonjour',0),(145615,4045,'jp','ã?Šã?¯ã‚ˆã?†ã?”ã?–ã?„ã?¾ã?™',0),(145616,4045,'pt','Bom dia',0),(145617,4045,'ru','Ð”Ð¾Ð±Ñ€Ð¾Ðµ Ð£Ñ‚Ñ€Ð¾',0),(145618,4045,'es','Buenos DÃ­as',0),(145619,4045,'de','Guten Morgen',0),(145620,4045,'en','Good Morning',0),(145621,4046,'is','',0),(145622,4046,'dr','Ø³Ø§Ø®Øª Ø¨Ø± Ø§Ø³Ø§Ø³ Ø³ÙØ§Ø±Ø´ ',0),(145623,4046,'pr','Ø³Ø§Ø®Øª Ø¨Ø± Ø§Ø³Ø§Ø³ Ø³ÙØ§Ø±Ø´ ',0),(145624,4046,'tr','Ã–zelleÅŸtir',0),(145625,4046,'pl','Dostosuj',0),(145626,4046,'bg','ÐŸÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(145627,4046,'ur','ØªØ®ØµÛŒØµ Ú©Ø±ÛŒÚº',0),(145628,4046,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’Ð°Ð²Ð°ÑšÐµ',0),(145629,4046,'vi','Theo Ã½ muá»‘n',0),(145630,4046,'af','Aanpassing',0),(145631,4046,'ro','Personaliza',0),(145632,4046,'et','Kohanda',0),(145633,4046,'si','Prilagodite',0),(145634,4046,'ba','Menyesuaikan',0),(145635,4046,'nl','Aanpassen',0),(145636,4046,'fi','Mukauta',0),(145637,4046,'no','Tilpasse',0),(145638,4046,'da','Tilpasse',0),(145639,4046,'ko','ì‚¬ìš©ìž ì§€ì •',0),(145640,4046,'he','×”×ª×× ××™×©×™×ª',0),(145641,4046,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼ÏŒÏƒÎµÏ„Îµ',0),(145642,4046,'zh','å®¢æˆ·å®šåˆ¶',0),(145643,4046,'sv','Anpassa',0),(145644,4046,'it','Personalizza',0),(145645,4046,'tl','',0),(145646,4046,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(145647,4046,'hi','à¤…à¤¨à¥à¤•à¥‚à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(145648,4046,'ms','Menyesuaikan',0),(145649,4046,'ar','ØªØ®ØµÙŠØµ',0),(145650,4046,'fr','Personnaliser',0),(145651,4046,'jp','ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚º',0),(145652,4046,'pt','Personalizar',0),(145653,4046,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ',0),(145654,4046,'es','Personalizar',0),(145655,4046,'de','Anpassen',0),(145656,4046,'en','Customize',0),(145657,4047,'is','',0),(145658,4047,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(145659,4047,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(145660,4047,'tr','Ã–ÄŸeleri rapor gÃ¶rÃ¼nÃ¼mÃ¼ sevk',0),(145661,4047,'pl','Widok wysÅ‚ane elementy raportu',0),(145662,4047,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(145663,4047,'ur','Ù…Ù†Ø¸Ø± Ù…ÛŒÚº Ø§Ø´ÛŒØ§ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(145664,4047,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(145665,4047,'vi','Xem bÃ¡o cÃ¡o hÃ ng Ä‘Ã£ chuyá»ƒn',0),(145666,4047,'af','Besigtig Versende Items Verslag',0),(145667,4047,'ro','Vezi raportul Articole expediate',0),(145668,4047,'et','Vaata tarnitud kaupade aruannet',0),(145669,4047,'si','Pogled poÅ¡iljajo poroÄila o elementih',0),(145670,4047,'ba','Lihat dikirim item laporan',0),(145671,4047,'nl','Weergave verzonden rapport Items',0),(145672,4047,'fi','NÃ¤ytÃ¤ lÃ¤hetetty kohteiden raportti',0),(145673,4047,'no','Vis sendt rapporten elementer',0),(145674,4047,'da','Se afsendt rapport elementer',0),(145675,4047,'ko','ë³´ê¸° í•­ëª© ë³´ê³ ì„œ ë°œì†¡',0),(145676,4047,'he','×ª×¦×•×’×ª ×“×•×— ×”×¤×¨×™×˜×™× ×©× ×©×œ×—×•',0),(145677,4047,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯ Î­ÎºÎ¸ÎµÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(145678,4047,'zh','æŸ¥çœ‹è¿é€çš„é¡¹ç›®æŠ¥å‘Š\r\n',0),(145679,4047,'sv','Visa levererades rapporten objekt',0),(145680,4047,'it','Vista spediti oggetti relazione',0),(145681,4047,'tl','',0),(145682,4047,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(145683,4047,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤†à¤‡à¤Ÿà¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(145684,4047,'ms','Paparan dihantar laporan item',0),(145685,4047,'ar','Ø¹Ø±Ø¶ Ø´Ø­Ù† Ø¨Ù†ÙˆØ¯ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(145686,4047,'fr','Avis expÃ©diÃ© points rapport',0),(145687,4047,'jp','é…?é€?æ¸ˆå“?ç›®ãƒ¬ãƒ?ãƒ¼ãƒˆã‚’è¦‹ã‚‹',0),(145688,4047,'pt','Vista enviado relatÃ³rio itens',0),(145689,4047,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐžÑ‚Ñ‡ÐµÑ‚Ð° ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ… Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(145690,4047,'es','Visionar Informe de Items Enviados',0),(145691,4047,'de','Ansicht geliefert Bericht Artikel',0),(145692,4047,'en','View Shipped Items Report',0),(145693,4048,'is','',0),(145694,4048,'dr','NolaPro',0),(145695,4048,'pr','NolaPro',0),(145696,4048,'tr','NolaPro',0),(145697,4048,'pl','NolaPro',0),(145698,4048,'bg','NolaPro',0),(145699,4048,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ',0),(145700,4048,'sr','ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾',0),(145701,4048,'vi','NolaPro',0),(145702,4048,'af','NolaPro',0),(145703,4048,'ro','NolaPro',0),(145704,4048,'et','NolaPro',0),(145705,4048,'si','NolaPro',0),(145706,4048,'ba','NolaPro',0),(145707,4048,'nl','NolaPro',0),(145708,4048,'fi','NolaPro',0),(145709,4048,'no','NolaPro',0),(145710,4048,'da','NolaPro',0),(145711,4048,'ko','NolaPro',0),(145712,4048,'he','NolaPro',0),(145713,4048,'el','NolaPro',0),(145714,4048,'zh','NolaPro\r\n',0),(145715,4048,'sv','NolaPro',0),(145716,4048,'it','NolaPro',0),(145717,4048,'tl','',0),(145718,4048,'th','NolaPro',0),(145719,4048,'hi','NolaPro',0),(145720,4048,'ms','NolaPro',0),(145721,4048,'ar','Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ',0),(145722,4048,'fr','NolaPro',0),(145723,4048,'jp','NolaPro',0),(145724,4048,'pt','NolaPro',0),(145725,4048,'ru','NolaPro',0),(145726,4048,'es','NolaPro',0),(145727,4048,'de','Artikel',0),(145728,4048,'en','NolaPro',0),(145729,4049,'is','',0),(145730,4049,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡',0),(145731,4049,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡',0),(145732,4049,'tr','Emir rapor gÃ¶rÃ¼nÃ¼mÃ¼ sevk',0),(145733,4049,'pl','Widok wysÅ‚ane zamÃ³wienia raportu',0),(145734,4049,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(145735,4049,'ur','Ù…Ù†Ø¸Ø± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(145736,4049,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð»Ð¸ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(145737,4049,'vi','Xem bÃ¡o cÃ¡o Ä‘Æ¡n hÃ ng Ä‘Ã£ chuyá»ƒn',0),(145738,4049,'af','Besigtig Versende Bestellingsverslag',0),(145739,4049,'ro','Vezi livrat ordinele raport',0),(145740,4049,'et','Vaata tarnitud tellimuste aruannet',0),(145741,4049,'si','Pogled dobavljeni naroÄil poroÄilo',0),(145742,4049,'ba','Lihat laporan pesanan dikirim',0),(145743,4049,'nl','Weergave verzonden Orders verslag',0),(145744,4049,'fi','Katso toimitetut tilaukset-raportti',0),(145745,4049,'no','Vis sendt ordrene rapporten',0),(145746,4049,'da','Se afsendt ordrer rapport',0),(145747,4049,'ko','ë³´ê¸° ì£¼ë¬¸ ë³´ê³ ì„œ ë°œì†¡',0),(145748,4049,'he','×ª×¦×•×’×ª ×“×•×— ×”×–×ž× ×•×ª ×©× ×©×œ×—×•',0),(145749,4049,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯ Î±Î½Î±Ï†Î¿ÏÎ¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(145750,4049,'zh','æŸ¥çœ‹å‘è´§çš„è®¢å•æŠ¥å‘Š\r\n',0),(145751,4049,'sv','Visa levereras rapport',0),(145752,4049,'it','Vista spediti ordini relazione',0),(145753,4049,'tl','',0),(145754,4049,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(145755,4049,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(145756,4049,'ms','Paparan dihantar laporan pesanan',0),(145757,4049,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ± Ø£ÙˆØ§Ù…Ø± ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(145758,4049,'fr','Vue livrÃ© commandes rapport',0),(145759,4049,'jp','ç™ºé€?æ¸ˆæ³¨æ–‡ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(145760,4049,'pt','Vista enviado relatÃ³rio de ordens',0),(145761,4049,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐžÑ‚Ñ‡ÐµÑ‚Ð° ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(145762,4049,'es','Visionar Informe de Ordenes Enviados',0),(145763,4049,'de','Ansicht geliefert Bestellbericht',0),(145764,4049,'en','View Shipped Orders Report',0),(145765,4050,'is','',0),(145766,4050,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(145767,4050,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(145768,4050,'tr','AÃ§Ä±k SipariÅŸler raporu gÃ¶rÃ¼ntÃ¼le',0),(145769,4050,'pl','WyÅ›wietl raport otwartych zamÃ³wieÅ„',0),(145770,4050,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(145771,4050,'ur','Ù…Ù†Ø¸Ø± Ú©Ú¾Ù„Û’ Ø¢Ø±ÚˆØ±Ø² Ø±Ù¾ÙˆØ±Ù¹',0),(145772,4050,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð·Ð²Ñ˜ÐµÑˆÑ‚Ð°Ñ˜ ÐžÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(145773,4050,'vi','Xem bÃ¡o cÃ¡o Ä‘Æ¡n hÃ ng má»Ÿ',0),(145774,4050,'af','Besigtig Oop Bestellingsverslag',0),(145775,4050,'ro','Vizualizare raport ordinele deschise',0),(145776,4050,'et','Vaata avatud tellimuste aruannet',0),(145777,4050,'si','Ogled odprte naloge poroÄila',0),(145778,4050,'ba','Lihat pesanan buka laporan',0),(145779,4050,'nl','Open Orders rapport weergeven',0),(145780,4050,'fi','NÃ¤ytÃ¤ avoimet tilaukset-raportti',0),(145781,4050,'no','Vis Ã¥pne rapport',0),(145782,4050,'da','Vis rapport for Ã¥bne ordrer',0),(145783,4050,'ko','ë³´ê³ ì„œ ë³´ê¸° ì—´ê¸° ëª…ë ¹',0),(145784,4050,'he','×”×¦×’ ×“×•×— ×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª',0),(145785,4050,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î±',0),(145786,4050,'zh','æŸ¥çœ‹å…¬å¼€çš„è®¢å•æŠ¥å‘Š\r\n',0),(145787,4050,'sv','Visa Ã¶ppna order rapport',0),(145788,4050,'it','Visualizza Report ordini aperti',0),(145789,4050,'tl','',0),(145790,4050,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(145791,4050,'hi','à¤–à¥à¤²à¤¾ à¤†à¤¦à¥‡à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(145792,4050,'ms','Lihat pesanan terbuka Laporan',0),(145793,4050,'ar','Ø¹Ø±Ø¶ Ø£ÙˆØ§Ù…Ø± ÙØªØ­ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(145794,4050,'fr','Afficher le rapport commandes ouvertes',0),(145795,4050,'jp','ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(145796,4050,'pt','Exibir relatÃ³rio de pedidos abertos',0),(145797,4050,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐžÑ‚Ñ‡ÐµÑ‚Ð° ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(145798,4050,'es','Visionar Informe de Ordenes Abiertos',0),(145799,4050,'de','Offene Orders-Bericht anzeigen',0),(145800,4050,'en','View Open Orders Report',0),(145801,4051,'is','',0),(145802,4051,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¶Ø¹ÙŠØª Ø§Ø¬Ø±Ø§Ø¡',0),(145803,4051,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¶Ø¹ÙŠØª Ø§Ø¬Ø±Ø§Ø¡',0),(145804,4051,'tr','Performans istatistikleri raporu gÃ¶rÃ¼ntÃ¼le',0),(145805,4051,'pl','WyÅ›wietl raport statystyki wydajnoÅ›ci',0),(145806,4051,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ¿Ñ€Ð°Ð²ÐºÐ°Ñ‚Ð° Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(145807,4051,'ur','Ù…Ù†Ø¸Ø± Ú©ÛŒ Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ÙˆØ´Ù…Ø§Ø± Ø±Ù¾ÙˆØ±Ù¹',0),(145808,4051,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ¸ Ð¡Ñ‚Ð°Ñ‚Ñ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(145809,4051,'vi','Xem bÃ¡o cÃ¡o thá»‘ng kÃª cÃ´ng viá»‡c',0),(145810,4051,'af','Besigtig Werksverrigting Statistiek Verslag',0),(145811,4051,'ro','Vezi performanÅ£Äƒ Stats raport',0),(145812,4051,'et','Vaata jÃµudluse statistika aruannet',0),(145813,4051,'si','Ogled predstava statistika poroÄila',0),(145814,4051,'ba','Lihat laporan statistik kinerja',0),(145815,4051,'nl','Weergave prestaties Stats verslag',0),(145816,4051,'fi','NÃ¤ytÃ¤ suorituskyky tilastot raportti',0),(145817,4051,'no','Vis statistikk rapport',0),(145818,4051,'da','Se statistik effektivitetsrapport',0),(145819,4051,'ko','ì„±ëŠ¥ í†µê³„ ë³´ê³ ì„œ ë³´ê¸°',0),(145820,4051,'he','×”×¦×’ ×“×•×— ×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×',0),(145821,4051,'el','Î ÏÎ¿Î²Î¿Î»Î® ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½ Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(145822,4051,'zh','æŸ¥çœ‹ç»©æ•ˆç»Ÿè®¡æŠ¥å‘Š\r\n',0),(145823,4051,'sv','Visa prestanda Stats rapport',0),(145824,4051,'it','Visualizzazione Report di prestazioni Stats',0),(145825,4051,'tl','',0),(145826,4051,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(145827,4051,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(145828,4051,'ms','Laporan Statistik prestasi View',0),(145829,4051,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ± Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡',0),(145830,4051,'fr','Vue rapport de performances Stats',0),(145831,4051,'jp','æ¥­ç¸¾çŠ¶æ³?ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(145832,4051,'pt','RelatÃ³rio de estatÃ­sticas de desempenho de exibiÃ§Ã£o',0),(145833,4051,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐžÑ‚Ñ‡ÐµÑ‚Ð° Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ¸ ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(145834,4051,'es','Visionar Informe de EstadÃ­sticas de Funcionamiento',0),(145835,4051,'de','Performance-Statistik-Bericht anzeigen',0),(145836,4051,'en','View Performance Stats Report',0),(145837,4052,'is','',0),(145838,4052,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² Ù†Ø²Ø¯ÙŠÙƒ Ø¨Ù‡ Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(145839,4052,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² Ù†Ø²Ø¯ÙŠÙƒ Ø¨Ù‡ Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(145840,4052,'tr','AÃ§Ä±k SipariÅŸler nedeniyle yaklaÅŸan tarihi',0),(145841,4052,'pl','Otwarcie zamÃ³wieÅ„ zbliÅ¼a siÄ™ odpowiednim terminie',0),(145842,4052,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÑ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸Ñ‚Ðµ Ð½Ð°Ð±Ð»Ð¸Ð¶Ð°Ð²Ð° Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(145843,4052,'ur','Ù…Ù‚Ø±Ø±Û ØªÙ‚Ø±ÛŒØ¨Ø§ Ù‚Ø±ÛŒØ¨ ØªÚ¾ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ú©Ú¾ÙˆÙ„Ù†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(145844,4052,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð´Ð° ÑÐµ Ð±Ð»Ð¸Ð¶Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(145845,4052,'vi','Má»Ÿ ÄÆ¡n HÃ ng gáº§n Ä‘áº¿n háº¡n',0),(145846,4052,'af','Oop Bestellings Nader Verskuldigde Datum',0),(145847,4052,'ro','Deschide comenzi apropie cuvenit data',0),(145848,4052,'et','TÃ¤htajale lÃ¤henevad avatud tellimused',0),(145849,4052,'si','Odprite naroÄila bliÅ¾a zaradi datuma',0),(145850,4052,'ba','Membuka perintah mendekati jatuh tempo tanggal',0),(145851,4052,'nl','Openstaande Orders bijna Due datum',0),(145852,4052,'fi','Avoimet tilaukset lÃ¤hestymÃ¤ssÃ¤ asianmukaisesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(145853,4052,'no','Ã…pne ordrer nÃ¦rmer forfallsdato dato',0),(145854,4052,'da','Ã…bne ordrer nÃ¦rmer sig behÃ¸rig dato',0),(145855,4052,'ko','ì—´ ë•Œë¬¸ì— ê·¼ì ‘ í•˜ëŠ” ì£¼ë¬¸ ë‚ ì§œ',0),(145856,4052,'he','×¤×ª×™×—×ª ×”×–×ž× ×•×ª ×ž×ª×§×¨×‘×™× ×™×¢×“ ×ª××¨×™×š',0),(145857,4052,'el','Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î± Ï€Î»Î·ÏƒÎ¹Î¬Î¶ÎµÎ¹ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(145858,4052,'zh','æœªç»“è®¢å•æŽ¥è¿‘æˆªæ­¢æ—¥æœŸ\r\n',0),(145859,4052,'sv','Ã–ppna order nÃ¤rmar sig Due Date',0),(145860,4052,'it','Aprire ordini avvicinando la scadenza Data',0),(145861,4052,'tl','',0),(145862,4052,'th','&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3651;&#3585;&#3621;&#3657;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(145863,4052,'hi','à¤–à¥‹à¤²à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶ à¤•à¤—à¤¾à¤° à¤ªà¤° à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¿à¤¥à¤¿',0),(145864,4052,'ms','Membuat pesanan yang hampir habis tempoh tarikh',0),(145865,4052,'ar','ÙØªØ­ Ø£ÙˆØ§Ù…Ø± ØªÙ‚ØªØ±Ø¨ Ù…Ù† Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(145866,4052,'fr','Ouvrir commandes presque Due Date',0),(145867,4052,'jp','æœŸæ—¥ã?Œè¿‘ã?¥ã?„ã?¦ã?„ã‚‹æ³¨æ–‡ã‚’é–‹ã??',0),(145868,4052,'pt','Abrir ordens aproximando Due Date',0),(145869,4052,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹ ÐŸÑ€Ð¸Ð±Ð»Ð¸Ð¶Ð°ÑŽÑ‰Ð¸ÐµÑÑ Ðš Ð”Ð°Ñ‚Ðµ ÐžÐ¿Ð»Ð°Ñ‚Ñ‹',0),(145870,4052,'es','Ordenes Abiertos Acercando el DÃ­a de Vencimiento',0),(145871,4052,'de','Ã–ffnen Sie Bestellungen, die kurz vor dem Due Date',0),(145872,4052,'en','Open Orders Nearing Due Date',0),(145873,4053,'is','',0),(145874,4053,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡ ',0),(145875,4053,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡ ',0),(145876,4053,'tr','AÃ§Ä±k sipariÅŸler Ã¼zerinde vade tarihi',0),(145877,4053,'pl','Otwarcie zamÃ³wieÅ„ w odpowiednim terminie',0),(145878,4053,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÑ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸Ñ‚Ðµ Ð½Ð°Ð´ Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(145879,4053,'ur','Ú©Ú¾ÙˆÙ„Ù†Û’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(145880,4053,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð¿Ñ€ÐµÐºÐ¾ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(145881,4053,'vi','ÄÆ¡n hÃ ng má»Ÿ quÃ¡ háº¡n',0),(145882,4053,'af','Oop Bestellings Agterstallige Datum',0),(145883,4053,'ro','Deschide comenzi peste cuvenit data',0),(145884,4053,'et','TÃ¤htaja Ã¼letanud avatud tellimused',0),(145885,4053,'si','Odprite naroÄila zapadle datum',0),(145886,4053,'ba','Membuka perintah berakhir karena tanggal',0),(145887,4053,'nl','Openstaande Orders Over tijd datum',0),(145888,4053,'fi','Avoimet tilaukset yli, koska pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(145889,4053,'no','Ã…pne ordrer forfalte dato',0),(145890,4053,'da','Ã…bne ordrer Over Due dato',0),(145891,4053,'ko','ì£¼ë¬¸ ë•Œë¬¸ì— ì˜¤í”ˆ ë‚ ì§œ',0),(145892,4053,'he','×¤×ª×™×—×ª ×”×–×ž× ×•×ª ×¤×’ ×ª××¨×™×š',0),(145893,4053,'el','Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î± Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(145894,4053,'zh','æœªç»“è®¢å•è¶…è¿‡æˆªæ­¢æ—¥æœŸ\r\n',0),(145895,4053,'sv','Ã–ppna order Ã¶ver Due Date',0),(145896,4053,'it','Ordini aperti oltre la scadenza Data',0),(145897,4053,'tl','',0),(145898,4053,'th','&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(145899,4053,'hi','à¤–à¥‹à¤²à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¿à¤¥à¤¿',0),(145900,4053,'ms','Membuat pesanan ke atas disebabkan oleh tarikh',0),(145901,4053,'ar','Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…ÙØªÙˆØ­Ø© Ø¹Ù„Ù‰ Ù…Ø¯Ù‰ Ù…Ø±Ø§Ø¹Ø§Ø© ØªØ§Ø±ÙŠØ®',0),(145902,4053,'fr','Ordres ouverts Ã  Ã©chÃ©ance Date',0),(145903,4053,'jp','æœŸæ—¥ã?Œé?Žã?Žã?¦ã?„ã‚‹æ³¨æ–‡ã‚’é–‹ã??',0),(145904,4053,'pt','Abrir ordens sobre Due Date',0),(145905,4053,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð¡ ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¾Ð¹ Ð”Ð°Ñ‚Ð¾Ð¹ ÐžÐ¿Ð»Ð°Ñ‚Ñ‹',0),(145906,4053,'es','Ordenes Abiertos mÃ¡s de la Fecha de Vencimiento',0),(145907,4053,'de','Ã–ffnen von Bestellungen Ã¼ber Due Date',0),(145908,4053,'en','Open Orders Over Due Date',0),(145909,4054,'is','',0),(145910,4054,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø®ÙŠØ±Ø§ Ø­Ù…Ù„ Ø´Ø¯Ù‡',0),(145911,4054,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø®ÙŠØ±Ø§ Ø­Ù…Ù„ Ø´Ø¯Ù‡',0),(145912,4054,'tr','En son sevk edilen sipariÅŸler',0),(145913,4054,'pl','Niedawno wydane rozkazy',0),(145914,4054,'bg','ÐÐ°ÑÐºÐ¾Ñ€Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(145915,4054,'ur','Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(145916,4054,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸Ñ… Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°',0),(145917,4054,'vi','ÄÆ¡n hÃ ng chuyá»ƒn gáº§n Ä‘Ã¢y',0),(145918,4054,'af','Onlangse Versende Bestellings',0),(145919,4054,'ro','Recent comenzile expediate',0),(145920,4054,'et','Hiljuti tarnitud tellimusd',0),(145921,4054,'si','Nedavno poÅ¡iljajo naroÄila',0),(145922,4054,'ba','Baru saja dikirim pesanan',0),(145923,4054,'nl','Onlangs verzonden Orders',0),(145924,4054,'fi','Ã„skettÃ¤in lÃ¤hetetyt tilaukset',0),(145925,4054,'no','Nylig sendte bestillinger',0),(145926,4054,'da','For nylig leverede ordrer',0),(145927,4054,'ko','ìµœê·¼ ë°°ì†¡ëœ ì£¼ë¬¸',0),(145928,4054,'he','×”×–×ž× ×•×ª ×©× ×©×œ×—×• ×œ××—×¨×•× ×”',0),(145929,4054,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î± Î¼ÎµÏ„Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(145930,4054,'zh','æœ€è¿‘å‘è´§çš„è®¢å•\r\n',0),(145931,4054,'sv','Nyligen levererade order',0),(145932,4054,'it','Recentemente gli ordini spediti',0),(145933,4054,'tl','',0),(145934,4054,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(145935,4054,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶',0),(145936,4054,'ms','Tempahan dihantar pesanan',0),(145937,4054,'ar','Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ù…Ø¤Ø®Ø±Ø§',0),(145938,4054,'fr','RÃ©cemment les commandes expÃ©diÃ©es',0),(145939,4054,'jp','æœ€è¿‘ã?®ç™ºé€?æ¸ˆæ³¨æ–‡',0),(145940,4054,'pt','Recentemente enviadas ordens',0),(145941,4054,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¾ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(145942,4054,'es','Ordenes Enviados Recientemente',0),(145943,4054,'de','KÃ¼rzlich versandten Bestellungen',0),(145944,4054,'en','Recently Shipped Orders',0),(145945,4055,'is','',0),(145946,4055,'dr','30 Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡ ',0),(145947,4055,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ Ø¨Ø±Ø§ÙŠ 30 Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡ ',0),(145948,4055,'tr','Performans istatistikleri - 30 gÃ¼n',0),(145949,4055,'pl','Statystyki wydajnoÅ›ci - 30 dni',0),(145950,4055,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ - 30 Ð´Ð½Ð¸',0),(145951,4055,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± - 30 Ø¯Ù†',0),(145952,4055,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð° - 30 Ð´Ð°Ð½Ð°',0),(145953,4055,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c cho 30 ngÃ y qua',0),(145954,4055,'af','Prestasie Statistieke Vir Afgelope 30 Dae',0),(145955,4055,'ro','Statistici de performanÅ£Äƒ - 30 de zile',0),(145956,4055,'et','JÃµudluse statistika viimase 30 pÃ¤eva kohta',0),(145957,4055,'si','Statistiko uspeÅ¡nosti - 30 dni',0),(145958,4055,'ba','Statistik kinerja - 30 hari',0),(145959,4055,'nl','Prestatiestatistieken - 30 dagen',0),(145960,4055,'fi','Tehokkuustilastoja - 30 pÃ¤ivÃ¤Ã¤',0),(145961,4055,'no','Resultatstatistikk - 30 dager',0),(145962,4055,'da','Effektivitetsstatistikker - 30 dage',0),(145963,4055,'ko','ì„±ëŠ¥ í†µê³„-30 ì¼',0),(145964,4055,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™× - 30 ×™×ž×™×',0),(145965,4055,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½ - 30 Î·Î¼Î­ÏÎµÏ‚',0),(145966,4055,'zh','å¯¹äºŽè¿‡åŽ»30å¤©çš„ä¸šç»©ç»Ÿè®¡\r\n',0),(145967,4055,'sv','Prestandastatistik - 30 dagar',0),(145968,4055,'it','Statistiche delle prestazioni - 30 giorni',0),(145969,4055,'tl','',0),(145970,4055,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634; 30 &#3623;&#3633;&#3609;',0),(145971,4055,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡ - 30 à¤¦à¤¿à¤¨',0),(145972,4055,'ms','Statistik prestasi - 30 hari',0),(145973,4055,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡--30 ÙŠÙˆÙ…Ø§',0),(145974,4055,'fr','Statistiques de performances - 30 jours',0),(145975,4055,'jp','é?ŽåŽ»30æ—¥ã?®æ¥­ç¸¾çµ±è¨ˆ',0),(145976,4055,'pt','EstatÃ­sticas de desempenho - 30 dias',0),(145977,4055,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð—Ð° ÐŸÑ€Ð¾ÑˆÐµÐ´Ð¸Ðµ 30 Ð”Ð½ÐµÐ¹',0),(145978,4055,'es','EstadÃ­sticas de DesempeÃ±o Para Los 30 DÃ­as Anteriores',0),(145979,4055,'de','Performance-Statistiken - 30 Tage',0),(145980,4055,'en','Performance Statistics - 30 Days',0),(145981,4056,'is','',0),(145982,4056,'dr','(Ù…ÙˆØ¹Ø¯Ù‡Ø§',0),(145983,4056,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² (Ø³Ø±Ø±Ø³ÙŠØ¯Ù‡Ø§',0),(145984,4056,'tr','AÃ§Ä±k SipariÅŸler (son tarih)',0),(145985,4056,'pl','Otwarte zamÃ³wienia (terminy)',0),(145986,4056,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÑ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸Ñ‚Ðµ (Ð¿Ð°Ð´ÐµÐ¶Ð¸)',0),(145987,4056,'ur','Ú©Ú¾ÙˆÙ„Ù†Û’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª (Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®ÙˆÚº)',0),(145988,4056,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ (Ð´Ð°Ñ‚ÑƒÐ¼)',0),(145989,4056,'vi','Má»Ÿ ÄÆ¡n HÃ ng (Thá»i Háº¡n)',0),(145990,4056,'af','Oop Bestellings (Verskuldige Datums)',0),(145991,4056,'ro','DeschidÄƒ comenzi (datele)',0),(145992,4056,'et','Avatud tellimuste tÃ¤htajad',0),(145993,4056,'si','Odprete naroÄila (datumov zapadlosti)',0),(145994,4056,'ba','Membuka perintah (Tempo)',0),(145995,4056,'nl','Openstaande Orders (vervaldatums)',0),(145996,4056,'fi','Avoimet tilaukset (erÃ¤pÃ¤ivÃ¤t)',0),(145997,4056,'no','Ã…pne ordrer (forfallsdatoer)',0),(145998,4056,'da','Ã…bne ordrer (forfaldsdatoer)',0),(145999,4056,'ko','ì£¼ë¬¸ ì—´ê³  (ê¸°í•œ)',0),(146000,4056,'he','(×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª (×ª××¨×™×›×™ ×¤×™×¨×¢×•×Ÿ',0),(146001,4056,'el','Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î± (Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚)',0),(146002,4056,'zh','æœªç»“è®¢å•ï¼ˆäº¤è´§æœŸï¼‰\r\n',0),(146003,4056,'sv','Ã–ppna order (fÃ¶rfallodatum)',0),(146004,4056,'it','Ordini aperti (scadenze)',0),(146005,4056,'tl','',0),(146006,4056,'th','&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; (&#3623;&#3633;&#3609;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;)',0),(146007,4056,'hi','à¤–à¥‹à¤²à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ (à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•)',0),(146008,4056,'ms','Membuat pesanan (tarikh akhir)',0),(146009,4056,'ar','ÙØªØ­ Ø£ÙˆØ§Ù…Ø± (ØªÙˆØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚)',0),(146010,4056,'fr','Ordres ouverts (Dates d\'Ã©chÃ©ance)',0),(146011,4056,'jp','ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡ï¼ˆç· åˆ‡æ—¥ï¼‰',0),(146012,4056,'pt','Abrir ordens (datas de vencimento)',0),(146013,4056,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹ (Ð”Ð°Ñ‚Ñ‹ ÐžÐ¿Ð»Ð°Ñ‚Ñ‹)',0),(146014,4056,'es','Ordenes Abiertos (Fecha de Vencimiento)',0),(146015,4056,'de','Ã–ffnen Sie Bestellungen (FÃ¤lligkeit)',0),(146016,4056,'en','Open Orders (Due Dates)',0),(146017,4057,'is','',0),(146018,4057,'dr','(15 Ø±ÙˆØ² ',0),(146019,4057,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ (15 Ø±ÙˆØ² ',0),(146020,4057,'tr','Performans istatistikleri: 15 gÃ¼n',0),(146021,4057,'pl','Statystyki skutecznoÅ›ci: 15 dni',0),(146022,4057,'bg','Ð”Ð°Ð½Ð½Ð¸: 15 Ð´Ð½Ð¸',0),(146023,4057,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±: 15 Ø¯Ù†',0),(146024,4057,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð°: 15 Ð´Ð°Ð½Ð°',0),(146025,4057,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c (15 ngÃ y)',0),(146026,4057,'af','Prestasie Statistieke (15 Dae)',0),(146027,4057,'ro','Statistici de performanÅ£Äƒ: 15 zile',0),(146028,4057,'et','JÃµudluse statistika (15 pÃ¤eva)',0),(146029,4057,'si','Statistiko uspeÅ¡nosti: 15 dni',0),(146030,4057,'ba','Statistik kinerja: 15 hari',0),(146031,4057,'nl','Prestatiestatistieken: 15 dagen',0),(146032,4057,'fi','Tehokkuustilastot: 15 pÃ¤ivÃ¤Ã¤',0),(146033,4057,'no','Resultatstatistikk: 15 dager',0),(146034,4057,'da','Effektivitetsstatistikker: 15 dage',0),(146035,4057,'ko','ì‹¤ì  í†µê³„: 15 ì¼',0),(146036,4057,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×: 15 ×™×ž×™×',0),(146037,4057,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½: 15 Î·Î¼Î­ÏÎµÏ‚',0),(146038,4057,'zh','ç»©æ•ˆç»Ÿè®¡ï¼ˆ15å¤©ï¼‰\r\n',0),(146039,4057,'sv','Resultatstatistik: 15 dagar',0),(146040,4057,'it','Le statistiche sulle prestazioni: 15 giorni',0),(146041,4057,'tl','',0),(146042,4057,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636; (15 &#3623;&#3633;&#3609;)',0),(146043,4057,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡: 15 à¤¦à¤¿à¤¨à¥‹à¤‚',0),(146044,4057,'ms','Statistik prestasi: 15 hari',0),(146045,4057,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡: 15 ÙŠÙˆÙ…Ø§',0),(146046,4057,'fr','Statistiques de performance : 15 jours',0),(146047,4057,'jp','æ¥­ç¸¾çµ±è¨ˆï¼ˆ15æ—¥é–“ï¼‰',0),(146048,4057,'pt','EstatÃ­sticas de desempenho: 15 dias',0),(146049,4057,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ (15 Ð”Ð½ÐµÐ¹)',0),(146050,4057,'es','EstadÃ­sticas de DesempeÃ±o (15 DÃ­as)',0),(146051,4057,'de','Performance-Statistiken: 15 Tage',0),(146052,4057,'en','Performance Statistics: 15 Days',0),(146053,4058,'is','',0),(146054,4058,'dr','(30 Ø±ÙˆØ²',0),(146055,4058,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ (30 Ø±ÙˆØ²',0),(146056,4058,'tr','Performans istatistikleri: 30 gÃ¼n',0),(146057,4058,'pl','Statystyki skutecznoÅ›ci: 30 dni',0),(146058,4058,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ: 30 Ð´Ð½Ð¸',0),(146059,4058,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±: 30 Ø¯Ù†',0),(146060,4058,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð°: 30 Ð´Ð°Ð½Ð°',0),(146061,4058,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c (30 ngÃ y)',0),(146062,4058,'af','Prestasie Statistieke (30 Dae)',0),(146063,4058,'ro','Statistici de performanÅ£Äƒ: 30 zile',0),(146064,4058,'et','JÃµudluse statistika (30 pÃ¤eva)',0),(146065,4058,'si','Statistiko uspeÅ¡nosti: 30 dni',0),(146066,4058,'ba','Statistik kinerja: 30 hari',0),(146067,4058,'nl','Prestatiestatistieken: 30 dagen',0),(146068,4058,'fi','Tehokkuustilastot: 30 pÃ¤ivÃ¤Ã¤',0),(146069,4058,'no','Resultatstatistikk: 30 dager',0),(146070,4058,'da','Effektivitetsstatistikker: 30 dage',0),(146071,4058,'ko','ì‹¤ì  í†µê³„: 30 ì¼',0),(146072,4058,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×: 30 ×™×ž×™×',0),(146073,4058,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½: 30 Î·Î¼Î­ÏÎµÏ‚',0),(146074,4058,'zh','ç»©æ•ˆç»Ÿè®¡ï¼ˆ30å¤©ï¼‰\r\n',0),(146075,4058,'sv','Resultatstatistik: 30 dagar',0),(146076,4058,'it','Le statistiche sulle prestazioni: 30 giorni',0),(146077,4058,'tl','',0),(146078,4058,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636; (30 &#3623;&#3633;&#3609;)',0),(146079,4058,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡: 30 à¤¦à¤¿à¤¨à¥‹à¤‚',0),(146080,4058,'ms','Statistik prestasi: 30 hari',0),(146081,4058,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡: 30 ÙŠÙˆÙ…Ø§',0),(146082,4058,'fr','Statistiques de performance : 30 jours',0),(146083,4058,'jp','æ¥­ç¸¾çµ±è¨ˆï¼ˆ30æ—¥é–“ï¼‰',0),(146084,4058,'pt','EstatÃ­sticas de desempenho: 30 dias',0),(146085,4058,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ (30 Ð”Ð½ÐµÐ¹)',0),(146086,4058,'es','EstadÃ­sticas de DesempeÃ±o (30 DÃ­as)',0),(146087,4058,'de','Performance-Statistiken: 30 Tage',0),(146088,4058,'en','Performance Statistics: 30 Days',0),(146089,4059,'is','',0),(146090,4059,'dr','( 60 Ø±ÙˆØ²',0),(146091,4059,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ ( 60 Ø±ÙˆØ²',0),(146092,4059,'tr','Performans istatistikleri: 60 gÃ¼n',0),(146093,4059,'pl','Statystyki skutecznoÅ›ci: 60 dni',0),(146094,4059,'bg','Ð”Ð°Ð½Ð½Ð¸: 60 Ð´Ð½Ð¸',0),(146095,4059,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±: 60 Ø¯Ù†',0),(146096,4059,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð°: 60 Ð´Ð°Ð½Ð°',0),(146097,4059,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c (60 ngÃ y)',0),(146098,4059,'af','Prestasie Statistieke (60 Dae)',0),(146099,4059,'ro','Statistici de performanÅ£Äƒ: 60 zile',0),(146100,4059,'et','JÃµudluse statistika (60 pÃ¤eva)',0),(146101,4059,'si','Statistiko uspeÅ¡nosti: 60 dni',0),(146102,4059,'ba','Statistik kinerja: 60 hari',0),(146103,4059,'nl','Prestatiestatistieken: 60 dagen',0),(146104,4059,'fi','Tehokkuustilastot: 60 pÃ¤ivÃ¤Ã¤',0),(146105,4059,'no','Resultatstatistikk: 60 dager',0),(146106,4059,'da','Effektivitetsstatistikker: 60 dage',0),(146107,4059,'ko','ì‹¤ì  í†µê³„: 60 ì¼',0),(146108,4059,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×: 60 ×™×ž×™×',0),(146109,4059,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½: 60 Î·Î¼Î­ÏÎµÏ‚',0),(146110,4059,'zh','ç»©æ•ˆç»Ÿè®¡ï¼ˆ60å¤©ï¼‰\r\n',0),(146111,4059,'sv','Resultatstatistik: 60 dagar',0),(146112,4059,'it','Le statistiche sulle prestazioni: 60 giorni',0),(146113,4059,'tl','',0),(146114,4059,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636; (60 &#3623;&#3633;&#3609;)',0),(146115,4059,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡: 60 à¤¦à¤¿à¤¨',0),(146116,4059,'ms','Statistik prestasi: 60 hari',0),(146117,4059,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡: 60 ÙŠÙˆÙ…Ø§',0),(146118,4059,'fr','Statistiques de performance : 60 jours',0),(146119,4059,'jp','æ¥­ç¸¾çµ±è¨ˆï¼ˆ60æ—¥é–“ï¼‰',0),(146120,4059,'pt','EstatÃ­sticas de desempenho: 60 dias',0),(146121,4059,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ (60 Ð”Ð½ÐµÐ¹)',0),(146122,4059,'es','EstadÃ­sticas de DesempeÃ±o (60 DÃ­as)',0),(146123,4059,'de','Performance-Statistiken: 60 Tage',0),(146124,4059,'en','Performance Statistics: 60 Days',0),(146125,4060,'is','',0),(146126,4060,'dr','( 90 Ø±ÙˆØ²',0),(146127,4060,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ ( 90 Ø±ÙˆØ²',0),(146128,4060,'tr','Performans istatistikleri: 90 gÃ¼n',0),(146129,4060,'pl','Statystyki skutecznoÅ›ci: 90 dni',0),(146130,4060,'bg','Ð”Ð°Ð½Ð½Ð¸: 90 Ð´Ð½Ð¸',0),(146131,4060,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±: 90 Ø¯Ù†',0),(146132,4060,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð°: 90 Ð´Ð°Ð½Ð°',0),(146133,4060,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c (90 ngÃ y)',0),(146134,4060,'af','Prestasie Statistieke (90 Dae)',0),(146135,4060,'ro','Statistici de performanÅ£Äƒ: 90 de zile',0),(146136,4060,'et','JÃµudluse statistika (90 pÃ¤eva)',0),(146137,4060,'si','Statistiko uspeÅ¡nosti: 90 dni',0),(146138,4060,'ba','Statistik kinerja: 90 hari',0),(146139,4060,'nl','Prestatiestatistieken: 90 dagen',0),(146140,4060,'fi','Tehokkuustilastot: 90 pÃ¤ivÃ¤Ã¤',0),(146141,4060,'no','Resultatstatistikk: 90 dager',0),(146142,4060,'da','Effektivitetsstatistikker: 90 dage',0),(146143,4060,'ko','ì‹¤ì  í†µê³„: 90 ì¼',0),(146144,4060,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×: 90 ×™×•×',0),(146145,4060,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½: 90 Î·Î¼Î­ÏÎµÏ‚',0),(146146,4060,'zh','ç»©æ•ˆç»Ÿè®¡ï¼ˆ90å¤©ï¼‰\r\n',0),(146147,4060,'sv','Resultatstatistik: 90 dagar',0),(146148,4060,'it','Le statistiche sulle prestazioni: 90 giorni',0),(146149,4060,'tl','',0),(146150,4060,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636; (90 &#3623;&#3633;&#3609;)',0),(146151,4060,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡: 90 à¤¦à¤¿à¤¨à¥‹à¤‚',0),(146152,4060,'ms','Statistik prestasi: 90 hari',0),(146153,4060,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡: 90 ÙŠÙˆÙ…Ø§',0),(146154,4060,'fr','Statistiques de performances : 90 jours',0),(146155,4060,'jp','æ¥­ç¸¾çµ±è¨ˆï¼ˆ90æ—¥é–“ï¼‰',0),(146156,4060,'pt','EstatÃ­sticas de desempenho: 90 dias',0),(146157,4060,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ (90 Ð”Ð½ÐµÐ¹)',0),(146158,4060,'es','EstadÃ­sticas de DesempeÃ±o (90 DÃ­as)',0),(146159,4060,'de','Performance-Statistiken: 90 Tage',0),(146160,4060,'en','Performance Statistics: 90 Days',0),(146161,4061,'is','',0),(146162,4061,'dr','15 Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡ ',0),(146163,4061,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ Ø¨Ø±Ø§ÙŠ 15 Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡ ',0),(146164,4061,'tr','Performans istatistikleri - 15 gÃ¼n',0),(146165,4061,'pl','Statystyki wydajnoÅ›ci - 15 dni',0),(146166,4061,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð´Ð°Ð½Ð½Ð¸-15 Ð´Ð½Ð¸',0),(146167,4061,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± - 15 Ø¯Ù†',0),(146168,4061,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð° - 15 Ð´Ð°Ð½Ð°',0),(146169,4061,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c cho 15 ngÃ y qua',0),(146170,4061,'af','Prestasie Statistieke Vir Afgelope 15 Dae',0),(146171,4061,'ro','Statistici de performanÅ£Äƒ - 15 zile',0),(146172,4061,'et','JÃµudluse statistika viimase 15 pÃ¤eva kohta',0),(146173,4061,'si','Statistiko uspeÅ¡nosti - 15 dni',0),(146174,4061,'ba','Statistik kinerja - 15 hari',0),(146175,4061,'nl','Prestatiestatistieken - 15 dagen',0),(146176,4061,'fi','Tehokkuustilastoja - 15 pÃ¤ivÃ¤Ã¤',0),(146177,4061,'no','Resultatstatistikk - 15 dager',0),(146178,4061,'da','Effektivitetsstatistikker - 15 dage',0),(146179,4061,'ko','ì„±ëŠ¥ í†µê³„-15 ì¼',0),(146180,4061,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™× - 15 ×™×ž×™×',0),(146181,4061,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½ - 15 Î·Î¼Î­ÏÎµÏ‚',0),(146182,4061,'zh','å¯¹äºŽè¿‡åŽ»15å¤©ä¸šç»©ç»Ÿè®¡\r\n',0),(146183,4061,'sv','Prestandastatistik - 15 dagar',0),(146184,4061,'it','Statistiche sulle prestazioni - 15 giorni',0),(146185,4061,'tl','',0),(146186,4061,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634; 15 &#3623;&#3633;&#3609;',0),(146187,4061,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡ - 15 à¤¦à¤¿à¤¨',0),(146188,4061,'ms','Statistik prestasi - 15 hari',0),(146189,4061,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡-15 ÙŠÙˆÙ…Ø§',0),(146190,4061,'fr','Statistiques de performances - 15 jours',0),(146191,4061,'jp','é?ŽåŽ»15æ—¥é–“ã?®æ¥­ç¸¾çµ±è¨ˆ',0),(146192,4061,'pt','EstatÃ­sticas de desempenho - 15 dias',0),(146193,4061,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð—Ð° ÐŸÑ€Ð¾ÑˆÐµÐ´Ð¸Ðµ 15 Ð”Ð½ÐµÐ¹',0),(146194,4061,'es','EstadÃ­sticas de DesempeÃ±o Para Los 15 DÃ­as Anteriores',0),(146195,4061,'de','Performance-Statistiken - 15 Tage',0),(146196,4061,'en','Performance Statistics - 15 Days',0),(146197,4062,'is','',0),(146198,4062,'dr','60 Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡ ',0),(146199,4062,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ Ø¨Ø±Ø§ÙŠ 60 Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡ ',0),(146200,4062,'tr','Performans istatistikleri - 60 gÃ¼n',0),(146201,4062,'pl','Statystyki wydajnoÅ›ci - 60 dni',0),(146202,4062,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð´Ð°Ð½Ð½Ð¸-60 Ð´Ð½Ð¸',0),(146203,4062,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± - 60 Ø¯Ù†',0),(146204,4062,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð° - 60 Ð´Ð°Ð½Ð°',0),(146205,4062,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c cho 60 ngÃ y qua',0),(146206,4062,'af','Prestasie Statistieke Vir Afgelope 60 Dae',0),(146207,4062,'ro','Statistici de performanÅ£Äƒ - 60 de zile',0),(146208,4062,'et','JÃµudluse statistika viimase 60 pÃ¤eva kohta',0),(146209,4062,'si','Statistiko uspeÅ¡nosti - 60 dni',0),(146210,4062,'ba','Statistik kinerja - 60 hari',0),(146211,4062,'nl','Prestatiestatistieken - 60 dagen',0),(146212,4062,'fi','Tehokkuustilastoja - 60 pÃ¤ivÃ¤Ã¤',0),(146213,4062,'no','Resultatstatistikk - 60 dager',0),(146214,4062,'da','Effektivitetsstatistikker - 60 dage',0),(146215,4062,'ko','ì„±ëŠ¥ í†µê³„-60 ì¼',0),(146216,4062,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™× - 60 ×™×ž×™×',0),(146217,4062,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½ - 60 Î·Î¼Î­ÏÎµÏ‚',0),(146218,4062,'zh','å¯¹äºŽè¿‡åŽ»60å¤©çš„ä¸šç»©ç»Ÿè®¡\r\n',0),(146219,4062,'sv','Prestandastatistik - 60 dagar',0),(146220,4062,'it','Statistiche sulle prestazioni - 60 giorni',0),(146221,4062,'tl','',0),(146222,4062,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634; 60 &#3623;&#3633;&#3609;',0),(146223,4062,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡ - 60 à¤¦à¤¿à¤¨à¥‹à¤‚',0),(146224,4062,'ms','Statistik prestasi - 60 hari',0),(146225,4062,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡-60 ÙŠÙˆÙ…Ø§',0),(146226,4062,'fr','Statistiques de performances - 60 jours',0),(146227,4062,'jp','é?ŽåŽ»60æ—¥é–“ã?®æ¥­ç¸¾çµ±è¨ˆ',0),(146228,4062,'pt','EstatÃ­sticas de desempenho - 60 dias',0),(146229,4062,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð—Ð°  ÐŸÑ€Ð¾ÑˆÐµÐ´Ð¸Ðµ 60 Ð”Ð½ÐµÐ¹',0),(146230,4062,'es','EstadÃ­sticas de DesempeÃ±o Para Los 60 DÃ­as Anteriores',0),(146231,4062,'de','Performance-Statistiken - 60 Tage',0),(146232,4062,'en','Performance Statistics - 60 Days',0),(146233,4063,'is','',0),(146234,4063,'dr','90 Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡ ',0),(146235,4063,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ Ø¨Ø±Ø§ÙŠ 90 Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡ ',0),(146236,4063,'tr','Performans istatistikleri - 90 gÃ¼n',0),(146237,4063,'pl','Statystyki wydajnoÅ›ci - 90 dni',0),(146238,4063,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð´Ð°Ð½Ð½Ð¸-90 Ð´Ð½Ð¸',0),(146239,4063,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± - 90 Ø¯Ù†',0),(146240,4063,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð° - 90 Ð´Ð°Ð½Ð°',0),(146241,4063,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c cho 90 ngÃ y qua',0),(146242,4063,'af','Prestasie Statistieke Vir Afgelope 90 Dae',0),(146243,4063,'ro','Statistici de performanÅ£Äƒ - 90 de zile',0),(146244,4063,'et','JÃµudluse statistika viimase 90 pÃ¤eva kohta',0),(146245,4063,'si','Statistiko uspeÅ¡nosti - 90 dni',0),(146246,4063,'ba','Statistik kinerja - 90 hari',0),(146247,4063,'nl','Prestatiestatistieken - 90 dagen',0),(146248,4063,'fi','Tehokkuustilastoja - 90 pÃ¤ivÃ¤Ã¤',0),(146249,4063,'no','Resultatstatistikk - 90 dager',0),(146250,4063,'da','Effektivitetsstatistikker - 90 dage',0),(146251,4063,'ko','ì„±ëŠ¥ í†µê³„-90 ì¼',0),(146252,4063,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™× - 90 ×™×ž×™×',0),(146253,4063,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½ - 90 Î·Î¼Î­ÏÎµÏ‚',0),(146254,4063,'zh','å¯¹äºŽè¿‡åŽ»90å¤©çš„ä¸šç»©ç»Ÿè®¡\r\n',0),(146255,4063,'sv','Prestandastatistik - 90 dagar',0),(146256,4063,'it','Statistiche sulle prestazioni - 90 giorni',0),(146257,4063,'tl','',0),(146258,4063,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634; 90 &#3623;&#3633;&#3609;',0),(146259,4063,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡ - 90 à¤¦à¤¿à¤¨',0),(146260,4063,'ms','Statistik prestasi - 90 hari',0),(146261,4063,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡-90 ÙŠÙˆÙ…Ø§',0),(146262,4063,'fr','Statistiques de performances - 90 jours',0),(146263,4063,'jp','é?ŽåŽ»90æ—¥é–“ã?®æ¥­ç¸¾çµ±è¨ˆ',0),(146264,4063,'pt','EstatÃ­sticas de desempenho - 90 dias',0),(146265,4063,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð—Ð°  ÐŸÑ€Ð¾ÑˆÐµÐ´Ð¸Ðµ 90 Ð”Ð½ÐµÐ¹',0),(146266,4063,'es','EstadÃ­sticas de DesempeÃ±o Para Los 90 DÃ­as Anteriores',0),(146267,4063,'de','Performance-Statistiken - 90 Tage',0),(146268,4063,'en','Performance Statistics - 90 Days',0),(146269,4064,'is','',0),(146270,4064,'dr','Ù†ÙŠØ§Ø²Ù‡Ø§ÙŠ Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ø²Ø¯ÙŠÙƒ Ø§Ù†Ø¨Ø§Ø± ',0),(146271,4064,'pr','Ù†ÙŠØ§Ø²Ù‡Ø§ÙŠ Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ø²Ø¯ÙŠÙƒ Ø§Ù†Ø¨Ø§Ø± ',0),(146272,4064,'tr','YaklaÅŸan stok ihtiyaÃ§larÄ±nÄ±',0),(146273,4064,'pl','NadchodzÄ…ce potrzeby pieÅ„',0),(146274,4064,'bg','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸ Ð°ÐºÑ†Ð¸Ð¸ Ð½ÑƒÐ¶Ð´Ð¸',0),(146275,4064,'ur','Ø§Ù†Û’ ÙˆØ§Ù„Û’ Ø³Ù¹Ø§Ú© Ú©ÛŒ Ø¶Ø±ÙˆØ±ÛŒØ§Øª',0),(146276,4064,'sr','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°Ð¼Ð°',0),(146277,4064,'vi','YÃªu cáº§u hÃ ng kho sáº¯p cáº§n',0),(146278,4064,'af','Opkomende Voorraad Benodighede',0),(146279,4064,'ro','Nevoilor viitoare de stoc',0),(146280,4064,'et','Tulemas varude vajadusi',0),(146281,4064,'si','PrihajajoÄi parka potrebam',0),(146282,4064,'ba','Kebutuhan saham mendatang',0),(146283,4064,'nl','Aankomende voorraad behoeften',0),(146284,4064,'fi','Tuleva varastossa tarpeisiin',0),(146285,4064,'no','Kommende lager behov',0),(146286,4064,'da','Kommende Stock behov',0),(146287,4064,'ko','ê³§ ìž¬ê³  í•„ìš”',0),(146288,4064,'he','×¦×¨×›×™× ×¢×ª×™×“×™×™× ×ž× ×™×•×ª',0),(146289,4064,'el','Î•Ï€ÎµÏÏ‡ÏŒÎ¼ÎµÎ½ÎµÏ‚ Î±Î½Î¬Î³ÎºÎµÏ‚ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(146290,4064,'zh','å³å°†åˆ°æ¥çš„åº“å­˜éœ€è¦\r\n',0),(146291,4064,'sv','Kommande lager behov',0),(146292,4064,'it','Imminente necessitÃ  di magazzino',0),(146293,4064,'tl','',0),(146294,4064,'th','&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;',0),(146295,4064,'hi','à¤†à¤—à¤¾à¤®à¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤œà¤°à¥‚à¤°à¤¤à¥‹à¤‚',0),(146296,4064,'ms','Keperluan stok akan datang',0),(146297,4064,'ar','Ø§Ø­ØªÙŠØ§Ø¬Ø§Øª Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù‚Ø§Ø¯Ù…Ø©',0),(146298,4064,'fr','Besoins de Stock Ã  venir',0),(146299,4064,'jp','Upcoming Stock Needs',0),(146300,4064,'pt','Futuras necessidades de estoque',0),(146301,4064,'ru','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸Ðµ Ð°ÐºÑ†Ð¸Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ÑÑ‚Ð¸',0),(146302,4064,'es','Necesidades de Stock Venidero',0),(146303,4064,'de','Bevorstehende hat BedÃ¼rfnisse',0),(146304,4064,'en','Upcoming Stock Needs',0),(146305,4065,'is','',0),(146306,4065,'dr','Ø´Ø±Ø­ ',0),(146307,4065,'pr','Ø´Ø±Ø­ ',0),(146308,4065,'tr','DESC.',0),(146309,4065,'pl','DESC.',0),(146310,4065,'bg','ÐÐ¸Ð·Ñ….',0),(146311,4065,'ur','Ø¯ÛŒØ³Ú© Û”',0),(146312,4065,'sr','Ð”Ð•Ð¡Ð¦.',0),(146313,4065,'vi','MÃ´ táº£',0),(146314,4065,'af','Beskr.',0),(146315,4065,'ro','Desc.',0),(146316,4065,'et','Desc.',0),(146317,4065,'si','DESC.',0),(146318,4065,'ba','Desc.',0),(146319,4065,'nl','Desc.',0),(146320,4065,'fi','Kuvaus.',0),(146321,4065,'no','DESC.',0),(146322,4065,'da','/ / Beskr.',0),(146323,4065,'ko','Descìž…ë‹ˆë‹¤.',0),(146324,4065,'he','×ª×™××•×¨',0),(146325,4065,'el','DESC.',0),(146326,4065,'zh','å›¾ç¤ºã€‚\r\n',0),(146327,4065,'sv','Desc.',0),(146328,4065,'it','DESC.',0),(146329,4065,'tl','',0),(146330,4065,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(146331,4065,'hi','Desc.',0),(146332,4065,'ms','Desc.',0),(146333,4065,'ar','Ø§Ù„Ø¨ÙŠØ§Ù†',0),(146334,4065,'fr','DESC.',0),(146335,4065,'jp','è§£èª¬',0),(146336,4065,'pt','Desc.',0),(146337,4065,'ru','ÐžÐ¿Ð¸Ñ.',0),(146338,4065,'es','Desc.',0),(146339,4065,'de','DESC.',0),(146340,4065,'en','Desc.',0),(146341,4066,'is','',0),(146342,4066,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¨Ø§Ø² Ù†Ø²Ø¯ÙŠÙƒ Ø¨Ù‡ Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(146343,4066,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¨Ø§Ø² Ù†Ø²Ø¯ÙŠÙƒ Ø¨Ù‡ Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(146344,4066,'tr','AÃ§Ä±k sipariÅŸ YazdÄ±r vadesi yaklaÅŸan tarihi',0),(146345,4066,'pl','OtwÃ³rz drukowania zamÃ³wieÅ„ zbliÅ¼a siÄ™ odpowiednim terminie',0),(146346,4066,'bg','ÐžÑ‚Ð²Ð¾Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð±Ð»Ð¸Ð¶Ð°Ð²Ð° Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(146347,4066,'ur','Ú©Ú¾ÙˆÙ„ÛŒÚº Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø­Ú©Ù… ÙˆØ§Ø¬Ø¨ ØªÙ‚Ø±ÛŒØ¨Ø§ Ù‚Ø±ÛŒØ¨ ØªÚ¾ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(146348,4066,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð±Ð»Ð¸Ð¶Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(146349,4066,'vi','Má»Ÿ Ä‘Æ¡n hÃ ng in gáº§n Ä‘áº¿n háº¡n',0),(146350,4066,'af','Oop druk bestellings nader verskuldigde datum',0),(146351,4066,'ro','Deschide comenzi imprimare apropie cuvenit data',0),(146352,4066,'et','Avada trÃ¼kitÃ¶Ã¶de tellimused lÃ¤henemas Due Date',0),(146353,4066,'si','Odprite tiskanja naroÄil bliÅ¾a zaradi datuma',0),(146354,4066,'ba','Membuka order cetak mendekati jatuh tempo tanggal',0),(146355,4066,'nl','Openstaande afdrukken Orders bijna Due datum',0),(146356,4066,'fi','Avaa Tulosta tilaukset lÃ¤hestymÃ¤ssÃ¤ asianmukaisesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(146357,4066,'no','Ã…pne bestilling nÃ¦rmer forfallsdato dato',0),(146358,4066,'da','Ã…bn aftryksbestillinger nÃ¦rmer sig behÃ¸rig dato',0),(146359,4066,'ko','ì—´ ë•Œë¬¸ì— ê·¼ì ‘ ì¸ì‡„ ì£¼ë¬¸ ë‚ ì§œ',0),(146360,4066,'he','×¤×ª×— ×”×“×¤×¡×•×ª ×ž×ª×§×¨×‘×™× ×™×¢×“ ×ª××¨×™×š',0),(146361,4066,'el','Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Ï€Î¿Ï… Ï€Î»Î·ÏƒÎ¹Î¬Î¶ÎµÎ¹ Ï„Î· Î´Î­Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(146362,4066,'zh','æœªç»“æ‰“å°è®¢å•æŽ¥è¿‘æˆªæ­¢æ—¥æœŸ\r\n',0),(146363,4066,'sv','Ã–ppna Print Order nÃ¤rmar sig Due Date',0),(146364,4066,'it','Aprire la stampa ordini, avvicinandosi la scadenza Data',0),(146365,4066,'tl','',0),(146366,4066,'th','&#3648;&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3651;&#3585;&#3621;&#3657;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3',0),(146367,4066,'hi','à¤–à¥‹à¤²à¥‡à¤‚ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤•à¤—à¤¾à¤° à¤ªà¤° à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¿à¤¥à¤¿',0),(146368,4066,'ms','Membuat pesanan cetakan yang hampir habis tempoh tarikh',0),(146369,4066,'ar','ÙØªØ­ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ØªÙŠ ØªÙ‚ØªØ±Ø¨ Ù…Ù† Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(146370,4066,'fr','Ouvrir commandes presque Due Date',0),(146371,4066,'jp','æœŸæ—¥é–“è¿‘ã?®ã‚ªãƒ¼ãƒ—ãƒ³å?°åˆ·æ³¨æ–‡',0),(146372,4066,'pt','Abrir ordens de impressÃ£o se aproximando Due Date',0),(146373,4066,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð±Ð»Ð¸Ð·Ð¸Ñ‚ÑÑ Ðº Ð½Ð°Ð´Ð»ÐµÐ¶Ð°Ñ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹',0),(146374,4066,'es','Ordenes de ImpresiÃ³n Abiertos Acercando la Fecha de Vencimiento',0),(146375,4066,'de','Ã–ffnen Sie DruckauftrÃ¤ge, die kurz vor dem Due Date',0),(146376,4066,'en','Open Print Orders Nearing Due Date',0),(146377,4067,'is','',0),(146378,4067,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¨Ø§Ø² Ø§Ø² ØªØ§Ø±ÙŠØ® Ú¯Ø°Ø´ØªÙ‡ ',0),(146379,4067,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¨Ø§Ø² Ø§Ø² ØªØ§Ø±ÙŠØ® Ú¯Ø°Ø´ØªÙ‡ ',0),(146380,4067,'tr','Vade sipariÅŸ YazdÄ±r aÃ§Ä±k tarihi',0),(146381,4067,'pl','OtwÃ³rz druk zamÃ³wienia na odpowiednim terminie',0),(146382,4067,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÑ‚Ðµ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð´ Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(146383,4067,'ur','Ú©Ú¾ÙˆÙ„ÛŒÚº Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(146384,4067,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð¿Ñ€ÐµÐºÐ¾ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(146385,4067,'vi','Má»Ÿ Ä‘Æ¡n hÃ ng in quÃ¡ háº¡n',0),(146386,4067,'af','Oop druk bestellings oor die verskuldigde datum',0),(146387,4067,'ro','Deschide comenzi de imprimare peste cuvenit data',0),(146388,4067,'et','Avage trÃ¼kitÃ¶Ã¶de tellimused Ã¼le tÃµttu kuupÃ¤ev',0),(146389,4067,'si','Odprite tiskanja naroÄil zapadle datum',0),(146390,4067,'ba','Membuka order cetak berakhir karena tanggal',0),(146391,4067,'nl','Afdrukken Orders openen Over tijd datum',0),(146392,4067,'fi','Avaa Tulosta Tilaukset yli, koska pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(146393,4067,'no','Ã…pne bestilling forfalte dato',0),(146394,4067,'da','Ã…bn Print ordrer Over Due dato',0),(146395,4067,'ko','ì¸ì‡„ ì£¼ë¬¸ ë•Œë¬¸ì— ì˜¤í”ˆ ë‚ ì§œ',0),(146396,4067,'he','×¤×ª×— ×”×“×¤×¡×•×ª ×¤×’ ×ª××¨×™×š',0),(146397,4067,'el','Î‘Î½Î¿Î¯Î¾Ï„Îµ Ï„Î¹Ï‚ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½ Ï€Î­ÏÎ± Î±Ï€ÏŒ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(146398,4067,'zh','æœªç»“æ‰“å°è®¢å•è¶…è¿‡æˆªæ­¢æ—¥æœŸ\r\n',0),(146399,4067,'sv','Ã–ppna Print Order Ã¶ver Due Date',0),(146400,4067,'it','Stampa ordini aperti oltre la scadenza Data',0),(146401,4067,'tl','',0),(146402,4067,'th','&#3648;&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(146403,4067,'hi','à¤–à¥‹à¤²à¥‡à¤‚ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤ªà¤° à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¿à¤¥à¤¿',0),(146404,4067,'ms','Membuat pesanan cetakan ke atas disebabkan oleh tarikh',0),(146405,4067,'ar','ÙØªØ­ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø¹Ù„Ù‰ Ù…Ø¯Ù‰ Ù…Ø±Ø§Ø¹Ø§Ø© ØªØ§Ø±ÙŠØ®',0),(146406,4067,'fr','Ouvrir les commandes Ã  Ã©chÃ©ance Date',0),(146407,4067,'jp','æœŸæ—¥çµŒé?Žã?®ã‚ªãƒ¼ãƒ—ãƒ³å?°åˆ·æ³¨æ–‡',0),(146408,4067,'pt','Abrir ordens de impressÃ£o sobre Due Date',0),(146409,4067,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð´Ð°Ñ‚Ñ‹',0),(146410,4067,'es','Ordenes de ImpresiÃ³n Abiertos MÃ¡s de la Fecha de Vencimiento',0),(146411,4067,'de','Ã–ffnen Sie DruckauftrÃ¤ge Ã¼ber Due Date',0),(146412,4067,'en','Open Print Orders Over Due Date',0),(146413,4068,'is','',0),(146414,4068,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡ ',0),(146415,4068,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡ ',0),(146416,4068,'tr','GecikmiÅŸ sipariÅŸ raporu gÃ¶rÃ¼ntÃ¼le',0),(146417,4068,'pl','WyÅ›wietl raport zalegÅ‚e zamÃ³wienia',0),(146418,4068,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð½ÐµÐ¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(146419,4068,'ur','Ù…Ù†Ø¸Ø± Ù…ÙˆØ®Ø± Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø±Ù¾ÙˆØ±Ù¹',0),(146420,4068,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð·Ð²Ñ˜ÐµÑˆÑ‚Ð°Ñ˜ Ð´Ð¾ÑÐ¿ÐµÐ»Ð¸Ð¼ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(146421,4068,'vi','Xem bÃ¡o cÃ¡o Ä‘Æ¡n hÃ ng quÃ¡ háº¡n',0),(146422,4068,'af','Besigtig Uitstaande Bestelling Verslag',0),(146423,4068,'ro','Vizualizare comenzi restante raport',0),(146424,4068,'et','Vaata tÃ¤htaja Ã¼letanud tellimuste aruannet',0),(146425,4068,'si','Ogled zaostalih naroÄil poroÄila',0),(146426,4068,'ba','Lihat pesanan tertunda laporan',0),(146427,4068,'nl','Rapport van de openstaande Orders weergeven',0),(146428,4068,'fi','NÃ¤ytÃ¤ myÃ¶hÃ¤ssÃ¤ olevat Tilaukset-raportti',0),(146429,4068,'no','Vis forfalte ordrer rapport',0),(146430,4068,'da','Vis forsinkede ordrer rapport',0),(146431,4068,'ko','ì—°ì²´ ì£¼ë¬¸ ë³´ê³ ì„œ ë³´ê¸°',0),(146432,4068,'he','×”×¦×’ ×“×•×— ×”×–×ž× ×•×ª ×©×¤×¨×¢×•× ×Ÿ ×—×œ×£',0),(146433,4068,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ ÎµÎºÏ€ÏÏŒÎ¸ÎµÏƒÎ¼ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(146434,4068,'zh','æŸ¥çœ‹é€¾æœŸè®¢å•æŠ¥è¡¨\r\n',0),(146435,4068,'sv','Visa fÃ¶rsenade order rapport',0),(146436,4068,'it','Visualizza Report ordini in ritardo',0),(146437,4068,'tl','',0),(146438,4068,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(146439,4068,'hi','à¤…à¤¤à¤¿à¤¦à¥‡à¤¯ à¤†à¤¦à¥‡à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(146440,4068,'ms','Lihat pesanan tertunggak Laporan',0),(146441,4068,'ar','Ø¹Ø±Ø¶ Ø£ÙˆØ§Ù…Ø± ØªØ£Ø®Ø±Øª ÙÙŠ ØªÙ‚Ø¯ÙŠÙ… Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(146442,4068,'fr','Afficher le rapport des commandes en retard',0),(146443,4068,'jp','æœŸé™?çµŒé?Žæ³¨æ–‡ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(146444,4068,'pt','Exibir relatÃ³rio de pedidos em atraso',0),(146445,4068,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(146446,4068,'es','Visionar Informe de Ordenes Demorosos',0),(146447,4068,'de','ÃœberfÃ¤llige Bestellungen-Bericht anzeigen',0),(146448,4068,'en','View Overdue Orders Report',0),(146449,4069,'is','',0),(146450,4069,'dr','Ù‡ÙŠÚ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(146451,4069,'pr','Ù‡ÙŠÚ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(146452,4069,'tr','TÄ±rnak yok bulundu',0),(146453,4069,'pl','Nie cytuje, Znalezione',0),(146454,4069,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(146455,4069,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ ÙˆØ§ÙˆÛŒÙ†',0),(146456,4069,'sr','Ð‘ÐµÐ· ÐºÐ¾Ñ˜Ðµ ÑÐµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ',0),(146457,4069,'vi','KhÃ´ng tháº¥y bÃ¡o giÃ¡',0),(146458,4069,'af','Geen Kwotasies Gevind',0),(146459,4069,'ro','Nu citate gÄƒsit',0),(146460,4069,'et','Nr hinnapakkumisi leidsin',0),(146461,4069,'si','Brez narekovajev, najti',0),(146462,4069,'ba','Tanpa tanda kutip yang ditemukan',0),(146463,4069,'nl','Geen offertes gevonden',0),(146464,4069,'fi','Ei lainausmerkkejÃ¤ lÃ¶ytyi',0),(146465,4069,'no','Uten anfÃ¸rselstegn funnet',0),(146466,4069,'da','Ingen tilbud fundet',0),(146467,4069,'ko','ì°¾ì€ ë”°ì˜´í‘œ',0),(146468,4069,'he','×œ× × ×ž×¦××• ×”×¦×¢×•×ª ×ž×—×™×¨',0),(146469,4069,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Ï„Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(146470,4069,'zh','æ²¡æœ‰æ‰¾åˆ°æŠ¥ä»·\r\n',0),(146471,4069,'sv','Inga citationstecken hittade',0),(146472,4069,'it','Senza virgolette trovati',0),(146473,4069,'tl','',0),(146474,4069,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(146475,4069,'hi','à¤•à¥‹à¤ˆ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤ªà¤¾à¤¯à¤¾',0),(146476,4069,'ms','Tiada sebut harga yang ditemui',0),(146477,4069,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¹Ø±ÙˆØ¶ Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(146478,4069,'fr','Sans guillemets trouvÃ©s',0),(146479,4069,'jp','è¦‹ç©?ã‚Šã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(146480,4069,'pt','Sem aspas encontradas',0),(146481,4069,'ru','Ð‘ÐµÐ· ÐºÐ°Ð²Ñ‹Ñ‡ÐµÐº Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(146482,4069,'es','No se Encontraron Cotizaciones',0),(146483,4069,'de','Keine Angebote gefunden',0),(146484,4069,'en','No Quotes Found',0),(146485,4070,'is','',0),(146486,4070,'dr','ØªØ§Ø±ÙŠØ® Ø³ÙØ§Ø±Ø´ ',0),(146487,4070,'pr','ØªØ§Ø±ÙŠØ® Ø³ÙØ§Ø±Ø´ ',0),(146488,4070,'tr','SipariÅŸ tarihi',0),(146489,4070,'pl','Data zamÃ³wienia',0),(146490,4070,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(146491,4070,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(146492,4070,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(146493,4070,'vi','NgÃ y Ä‘áº·t hÃ ng',0),(146494,4070,'af','Besteldatum',0),(146495,4070,'ro','Data comenzii',0),(146496,4070,'et','Tellimuse kuupÃ¤ev',0),(146497,4070,'si','Datum naloga',0),(146498,4070,'ba','Tanggal order',0),(146499,4070,'nl','Orderdatum',0),(146500,4070,'fi','Tilauksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(146501,4070,'no','Ordredato',0),(146502,4070,'da','Ordredato',0),(146503,4070,'ko','ì£¼ë¬¸ ë‚ ì§œ',0),(146504,4070,'he','×ª××¨×™×š ×”×–×ž× ×”',0),(146505,4070,'el','Î—Î¼/Î½Î¯Î± ÎµÎ½Ï„Î¿Î»Î®Ï‚',0),(146506,4070,'zh','è®¢è´­æ—¥æœŸ\r\n',0),(146507,4070,'sv','Orderdatum',0),(146508,4070,'it','Data ordine',0),(146509,4070,'tl','',0),(146510,4070,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(146511,4070,'hi','à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(146512,4070,'ms','Tarikh Perintah',0),(146513,4070,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(146514,4070,'fr','Date de la commande',0),(146515,4070,'jp','æ³¨æ–‡æ—¥',0),(146516,4070,'pt','Data do pedido',0),(146517,4070,'ru','Ð”Ð°Ñ‚Ð° Ð—Ð°ÐºÐ°Ð·Ð°',0),(146518,4070,'es','Fecha de Orden',0),(146519,4070,'de','Bestelldatum',0),(146520,4070,'en','Order Date',0),(146521,4071,'is','',0),(146522,4071,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§Ø®ÙŠØ±',0),(146523,4071,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§Ø®ÙŠØ±',0),(146524,4071,'tr','Son teklifleri',0),(146525,4071,'pl','Najnowsze oferty',0),(146526,4071,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(146527,4071,'ur','Ø­Ø§Ù„ÛŒÛ ÙˆØ§ÙˆÛŒÙ†',0),(146528,4071,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(146529,4071,'vi','BÃ¡o giÃ¡ gáº§n Ä‘Ã¢y',0),(146530,4071,'af','Onlangse Kwotasies',0),(146531,4071,'ro','Ultimele citate',0),(146532,4071,'et','Viimatised hinnapakkumised',0),(146533,4071,'si','Nedavne ponudbe',0),(146534,4071,'ba','Kutipan hari',0),(146535,4071,'nl','Recente citaten',0),(146536,4071,'fi','Viimeaikaiset tarjoukset',0),(146537,4071,'no','Siste tilbud',0),(146538,4071,'da','De seneste citater',0),(146539,4071,'ko','ìµœê·¼ ë”°ì˜´í‘œ',0),(146540,4071,'he','×”×¦×¢×•×ª ×ž×—×™×¨ ××—×¨×•× ×•×ª',0),(146541,4071,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(146542,4071,'zh','è¿‘æœŸæŠ¥ä»·\r\n',0),(146543,4071,'sv','Senaste citat',0),(146544,4071,'it','Citazioni recenti',0),(146545,4071,'tl','',0),(146546,4071,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3648;&#3617;&#3639;&#3656;&#3629;&#3648;&#3619;&#3655;&#3623; &#3654; &#3609;&#3637;&#3657;',0),(146547,4071,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤•à¥‡ à¤•à¥‹à¤Ÿ',0),(146548,4071,'ms','Sebut harga terkini',0),(146549,4071,'ar','Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(146550,4071,'fr','Ces derniÃ¨res citations',0),(146551,4071,'jp','æœ€è¿‘ã?®è¦‹ç©?ã‚Š',0),(146552,4071,'pt','CotaÃ§Ãµes recentes',0),(146553,4071,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(146554,4071,'es','Cotizaciones Recientes',0),(146555,4071,'de','Aktuelle Angebote',0),(146556,4071,'en','Recent Quotes',0),(146557,4072,'is','',0),(146558,4072,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(146559,4072,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(146560,4072,'tr','TÄ±rnak raporu gÃ¶rÃ¼ntÃ¼le',0),(146561,4072,'pl','WyÅ›wietl raport Cytaty',0),(146562,4072,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(146563,4072,'ur','Ù…Ù†Ø¸Ø± ÙˆØ§ÙˆÛŒÙ† Ø±Ù¾ÙˆØ±Ù¹',0),(146564,4072,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¸Ð·Ð²Ñ˜ÐµÑˆÑ‚Ð°Ñ˜',0),(146565,4072,'vi','Xem bÃ¡o cÃ¡o bÃ¡o giÃ¡',0),(146566,4072,'af','Besigtig Kwotasies Verslag',0),(146567,4072,'ro','Vezi citate raport',0),(146568,4072,'et','Vaata hinnapakkumisi aruanne',0),(146569,4072,'si','Ogled ponudbe poroÄila',0),(146570,4072,'ba','Lihat kutipan laporan',0),(146571,4072,'nl','Rapport van de offertes weergeven',0),(146572,4072,'fi','Katso tarjoukset-raportti',0),(146573,4072,'no','Vis sitater rapport',0),(146574,4072,'da','Vis citater rapport',0),(146575,4072,'ko','ë”°ì˜´í‘œ ë³´ê³ ì„œ ë³´ê¸°',0),(146576,4072,'he','×”×¦×’ ×“×•×— ×”×¦×¢×•×ª ×ž×—×™×¨',0),(146577,4072,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(146578,4072,'zh','æŸ¥çœ‹è¡Œæƒ…æŠ¥å‘Š\r\n',0),(146579,4072,'sv','Visa citat rapport',0),(146580,4072,'it','Visualizza Report citazioni',0),(146581,4072,'tl','',0),(146582,4072,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(146583,4072,'hi','à¤•à¥‹à¤Ÿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(146584,4072,'ms','Lihat petikan Laporan',0),(146585,4072,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(146586,4072,'fr','Afficher le rapport citations',0),(146587,4072,'jp','è¦‹ç©?ã‚Šãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(146588,4072,'pt','Exibir relatÃ³rio de CotaÃ§Ãµes',0),(146589,4072,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(146590,4072,'es','Visionar Informe de Cotizaciones',0),(146591,4072,'de','Zitate-Bericht anzeigen',0),(146592,4072,'en','View Quotes Report',0),(146593,4073,'is','',0),(146594,4073,'dr','( ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ù…ÙˆØ¹Ø¯',0),(146595,4073,'pr','Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª ( ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ø³Ø±Ø±Ø³ÙŠØ¯',0),(146596,4073,'tr','SipariÅŸleri yazdÄ±rma (son tarih)',0),(146597,4073,'pl','Drukuj zamÃ³wienia (terminy)',0),(146598,4073,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ (Ð¿Ð°Ð´ÐµÐ¶Ð¸)',0),(146599,4073,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ (Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®ÙˆÚº)',0),(146600,4073,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° (Ð´Ð°Ñ‚ÑƒÐ¼)',0),(146601,4073,'vi','In Ä‘Æ¡n hÃ ng (Ä‘áº¿n háº¡n)',0),(146602,4073,'af','Druk Bestellings (Verskuldige Datums)',0),(146603,4073,'ro','ImprimaÅ£i comenzi (datele)',0),(146604,4073,'et','Printimiseks (tÃ¤htpÃ¤evad)',0),(146605,4073,'si','Tiskanje nalogov (datumov zapadlosti)',0),(146606,4073,'ba','Cetak pesanan (Tempo)',0),(146607,4073,'nl','Orders afdrukken (vervaldatums)',0),(146608,4073,'fi','Tulostaa tilaukset (erÃ¤pÃ¤ivÃ¤t)',0),(146609,4073,'no','Skrive ut (forfallsdatoer)',0),(146610,4073,'da','Udskriv ordrer (forfaldsdatoer)',0),(146611,4073,'ko','ì£¼ë¬¸ ì¸ì‡„ (ê¸°í•œ)',0),(146612,4073,'he','×”×“×¤×¡ ×”×–×ž× ×•×ª (×ª××¨×™×›×™ ×”×™×¢×“)',0),(146613,4073,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ (Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚)',0),(146614,4073,'zh','æ‰“å°è®¢å•ï¼ˆäº¤è´§æœŸï¼‰\r\n',0),(146615,4073,'sv','Skriva ut order (fÃ¶rfallodatum)',0),(146616,4073,'it','Stampare gli ordini (scadenze)',0),(146617,4073,'tl','',0),(146618,4073,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; (&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;)',0),(146619,4073,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¥à¤¦à¥à¤°à¤£ (à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•)',0),(146620,4073,'ms','Cetak pesanan (tarikh akhir)',0),(146621,4073,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø£ÙˆØ§Ù…Ø± (ØªÙˆØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚)',0),(146622,4073,'fr','Imprimer les commandes (Dates d\'Ã©chÃ©ance)',0),(146623,4073,'jp','æ³¨æ–‡ã?®å?°åˆ·ï¼ˆæœŸæ—¥ï¼‰',0),(146624,4073,'pt','Imprimir ordens (datas de vencimento)',0),(146625,4073,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·Ð¾Ð² (ÐŸÐ¾ Ð”Ð°Ñ‚Ð°Ð¼)',0),(146626,4073,'es','Ordenes de Imprimir (Fechas de Vencimiento)',0),(146627,4073,'de','Drucken der Bestellungen (FÃ¤lligkeit)',0),(146628,4073,'en','Print Orders (Due Dates)',0),(146629,4074,'is','',0),(146630,4074,'dr','Ù‡ÙŠÚ† Ø§Ø¹Ù„Ø§Ù… Ù†ÙŠØ§Ø²ÙŠ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡',0),(146631,4074,'pr','Ù‡ÙŠÚ† Ø§Ø¹Ù„Ø§Ù… Ù†ÙŠØ§Ø²ÙŠ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡',0),(146632,4074,'tr','Stok buldum ihtiyacÄ±',0),(146633,4074,'pl','Nie zapasÃ³w musi znaleÅºÄ‡',0),(146634,4074,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ÑÑ‚ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(146635,4074,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ø§Ø³Ù¹Ø§Ú© Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(146636,4074,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸',0),(146637,4074,'vi','KhÃ´ng cáº§n tÃ¬m hÃ ng tá»“n',0),(146638,4074,'af','Geen Voorraadbenodighede Gevind',0),(146639,4074,'ro','Nici un stoc trebuie gÄƒsite',0),(146640,4074,'et','Ladu pole vaja leida',0),(146641,4074,'si','Ne zaloge mora najti',0),(146642,4074,'ba','Ada stok kebutuhan ditemukan',0),(146643,4074,'nl','Geen voorraad moet gevonden',0),(146644,4074,'fi','Ei varastossa on lÃ¶ytynyt',0),(146645,4074,'no','Ingen lager mÃ¥ funnet',0),(146646,4074,'da','Ingen lager behov fundet',0),(146647,4074,'ko','ìž¬ê³  ì—†ìŒ í•„ìš” ë°œê²¬',0),(146648,4074,'he','××™×Ÿ ×ž× ×™×•×ª ×¦×¨×™×š ×œ×ž×¦×•×',0),(146649,4074,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î²ÏÎµÎ¸ÎµÎ¯',0),(146650,4074,'zh','æ²¡æœ‰æ‰¾åˆ°åº“å­˜éœ€è¦\r\n',0),(146651,4074,'sv','Inga lager behÃ¶ver hittade',0),(146652,4074,'it','Ha bisogno di alcuna scorta trovato',0),(146653,4074,'tl','',0),(146654,4074,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(146655,4074,'hi','à¤•à¥‹à¤ˆ à¤¶à¥‡à¤¯à¤° à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥ˆ à¤ªà¤¾à¤¯à¤¾',0),(146656,4074,'ms','Tiada stok keperluan mendapati',0),(146657,4074,'ar','ÙŠØ­ØªØ§Ø¬ Ù„Ø§ Ø§Ù„Ø£Ø³Ù‡Ù… ÙˆØ¬Ø¯Øª',0),(146658,4074,'fr','Aucun Stock ne doit trouvÃ©',0),(146659,4074,'jp','No Stock Needs Found',0),(146660,4074,'pt','Nenhum estoque precisa encontrado',0),(146661,4074,'ru','ÐÐµÑ‚ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð½Ð°Ð¹Ñ‚Ð¸',0),(146662,4074,'es','No se Encontraron Necesidades de Stock',0),(146663,4074,'de','Kein bestand muss gefunden',0),(146664,4074,'en','No Stock Needs Found',0),(146665,4075,'is','',0),(146666,4075,'dr',' Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø±',0),(146667,4075,'pr',' Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø±',0),(146668,4075,'tr','Eldeki',0),(146669,4075,'pl','Onhand',0),(146670,4075,'bg','Onhand',0),(146671,4075,'ur','Ø§ÙˆÙ†Ø­Ù†Úˆ',0),(146672,4075,'sr','ÐÐ° Ñ€ÑƒÑ†Ð¸',0),(146673,4075,'vi','Sáºµn cÃ³',0),(146674,4075,'af','Op Hand',0),(146675,4075,'ro','Onhand',0),(146676,4075,'et','TaastÃ¤itmise',0),(146677,4075,'si','Onhand',0),(146678,4075,'ba','Onhand',0),(146679,4075,'nl','Onhand',0),(146680,4075,'fi','Onhand',0),(146681,4075,'no','Onhand',0),(146682,4075,'da','Onhand',0),(146683,4075,'ko','Onhand',0),(146684,4075,'he','×‘× ×ž×¦×',0),(146685,4075,'el','Onhand',0),(146686,4075,'zh','çŽ°æœ‰é‡\r\n',0),(146687,4075,'sv','Onhand',0),(146688,4075,'it','OnHand',0),(146689,4075,'tl','',0),(146690,4075,'th','&#3651;&#3609;&#3617;&#3639;&#3629;',0),(146691,4075,'hi','Onhand',0),(146692,4075,'ms','Onhand',0),(146693,4075,'ar','Onhand',0),(146694,4075,'fr','OnHand',0),(146695,4075,'jp','æ‰‹æŒ?ã?¡',0),(146696,4075,'pt','OnHand',0),(146697,4075,'ru','OnHand',0),(146698,4075,'es','Disponible',0),(146699,4075,'de','OnHand',0),(146700,4075,'en','On Hand',0),(146701,4076,'is','',0),(146702,4076,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø§Ø¹Ù„Ø§Ù… Ù†ÙŠØ§Ø² Ø§Ù†Ø¨Ø§Ø± ',0),(146703,4076,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø§Ø¹Ù„Ø§Ù… Ù†ÙŠØ§Ø² Ø§Ù†Ø¨Ø§Ø± ',0),(146704,4076,'tr','Rapor GÃ¶rÃ¼nÃ¼mÃ¼ stok ihtiyacÄ±',0),(146705,4076,'pl','Widok zapasÃ³w musi raportu',0),(146706,4076,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÑÑŠÑÑ‚Ð°Ð² ÑÐµ Ð½ÑƒÐ¶Ð´Ð°Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(146707,4076,'ur','Ù…Ù†Ø¸Ø± Ø§Ø³Ù¹Ø§Ú© Ø±Ù¾ÙˆØ±Ù¹ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(146708,4076,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð Ð¾Ð±Ð¸ Ñ‚Ñ€ÐµÐ±Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(146709,4076,'vi','Xem bÃ¡o cÃ¡o hÃ ng cáº§n dÃ¹ng',0),(146710,4076,'af','Besigtig Noodsaaklike Voorraadverslag',0),(146711,4076,'ro','Vezi stoc trebuie raportul',0),(146712,4076,'et','Vaata lao kriitiliste artikklite aruannet',0),(146713,4076,'si','Ogled parka mora poroÄilo',0),(146714,4076,'ba','Lihat stok kebutuhan laporan',0),(146715,4076,'nl','Weergave voorraad moet verslag',0),(146716,4076,'fi','Katso aikatauluja raportti',0),(146717,4076,'no','Vis lager mÃ¥ rapporten',0),(146718,4076,'da','Se Stock behov rapport',0),(146719,4076,'ko','ë³´ê¸° ì£¼ì‹ ë³´ê³ ì„œ í•„ìš”',0),(146720,4076,'he','×ª×¦×•×’×ª ×ž× ×™×•×ª ×¦×¨×™×š ×“×• ×—',0),(146721,4076,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Ï‡ÏÎµÎ¹Î¬Î¶ÎµÏ„Î±Î¹ Î­ÎºÎ¸ÎµÏƒÎ·',0),(146722,4076,'zh','æŸ¥çœ‹åº“å­˜éœ€æ±‚çš„æŠ¥å‘Š\r\n',0),(146723,4076,'sv','Visa lager behÃ¶ver rapport',0),(146724,4076,'it','Stock di vista ha bisogno di relazione',0),(146725,4076,'tl','',0),(146726,4076,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(146727,4076,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥ƒà¤¶à¥à¤¯ à¤¶à¥‡à¤¯à¤° à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(146728,4076,'ms','Lihat stok keperluan Laporan',0),(146729,4076,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ù‡Ù… ÙŠØ­ØªØ§Ø¬ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(146730,4076,'fr','Vue Stock a besoin de rapport',0),(146731,4076,'jp','View Stock Needs Report',0),(146732,4076,'pt','Exibir estoque precisa de relatÃ³rio',0),(146733,4076,'ru','Ð’Ð¸Ð´ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(146734,4076,'es','Ver Informe de Necesidades de Stock',0),(146735,4076,'de','Ansicht Lager braucht Bericht',0),(146736,4076,'en','View Stock Needs Report',0),(146737,4077,'is','',0),(146738,4077,'dr','(ÙØ±ÙˆØ´) ØªØ¹ÙˆÛŒÙ‚',0),(146739,4077,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø­Ø±Ø§Ø¬(ÙØ±ÙˆØ´) Ù…Ø¹ÙˆÙ‚',0),(146740,4077,'tr','Bekleyen satÄ±ÅŸ genel bakÄ±ÅŸ',0),(146741,4077,'pl','Czasu przeglÄ…d sprzedaÅ¼y',0),(146742,4077,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(146743,4077,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø³ÛŒÙ„Ø² Ú©Ø§ Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ø¬Ø§Ø¦Ø²Û',0),(146744,4077,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(146745,4077,'vi','Äang treo Ä‘Ã¡nh giÃ¡ káº¿t quáº£ kinh doanh',0),(146746,4077,'af','Afwagtende Verkope Oorsig',0),(146747,4077,'ro','Prezentare Ã®n curs vÃ¢nzÄƒri',0),(146748,4077,'et','Ootel mÃ¼Ã¼gi Ã¼levaade',0),(146749,4077,'si','ÄŒakajoÄi pregled prodaje',0),(146750,4077,'ba','Ikhtisar penjualan tertunda',0),(146751,4077,'nl','Hangende verkoop overzicht',0),(146752,4077,'fi','Odottaa myynnin yleiskuvaus',0),(146753,4077,'no','Ventende salg oversikt',0),(146754,4077,'da','Ventende salg oversigt',0),(146755,4077,'ko','ë³´ë¥˜ íŒë§¤ ê°œìš”',0),(146756,4077,'he','×¡×§×™×¨×” ×›×œ×œ×™×ª ×©×œ ×ž×›×™×¨×•×ª ×ž×ž×ª×™× ×•×ª',0),(146757,4077,'el','Î•ÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ ÎµÏ€Î¹ÏƒÎºÏŒÏ€Î·ÏƒÎ·',0),(146758,4077,'zh','å¾…åŠžé”€å”®æ¦‚è¿°\r\n',0),(146759,4077,'sv','VÃ¤ntande fÃ¶rsÃ¤ljning Ã¶versikt',0),(146760,4077,'it','Panoramica di vendite in sospeso',0),(146761,4077,'tl','',0),(146762,4077,'th','&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(146763,4077,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤…à¤µà¤²à¥‹à¤•à¤¨',0),(146764,4077,'ms','Gambaran keseluruhan jualan yang belum selesai',0),(146765,4077,'ar','Ù†Ø¸Ø±Ø© Ø¹Ø§Ù…Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(146766,4077,'fr','AperÃ§u de vente en attente',0),(146767,4077,'jp','ä¿?ç•™ä¸­ã‚»ãƒ¼ãƒ«ã‚¹æ¦‚æ‹¬',0),(146768,4077,'pt','VisÃ£o geral de vendas pendente',0),(146769,4077,'ru','ÐžÐ±Ð·Ð¾Ñ€ ÐŸÑ€Ð¾Ð´Ð°Ð¶ Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(146770,4077,'es','Vistazo General de Ventas Pendiente',0),(146771,4077,'de','Ausstehende VerkaufsÃ¼bersicht',0),(146772,4077,'en','Pending Sales Overview',0),(146773,4078,'is','',0),(146774,4078,'dr','(ÙØ±ÙˆØ´ Ù‡Ø§',0),(146775,4078,'pr','ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± Ø­Ø±Ø§Ø¬(ÙØ±ÙˆØ´ Ù‡Ø§',0),(146776,4078,'tr','Son satÄ±ÅŸ iÅŸlemleri',0),(146777,4078,'pl','Ostatnie akcje sprzedaÅ¼y',0),(146778,4078,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(146779,4078,'ur','Ø­Ø§Ù„ÛŒÛ Ø³ÛŒÙ„Ø² Ú©Û’ Ø§Ø¹Ù…Ø§Ù„',0),(146780,4078,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(146781,4078,'vi','Hoáº¡t Ä‘á»™ng kinh doanh gáº§n Ä‘Ã¢y',0),(146782,4078,'af','Onlangse Verkoopsaksies',0),(146783,4078,'ro','AcÅ£iunile recente vÃ¢nzÄƒri',0),(146784,4078,'et','MÃ¼Ã¼gi tegevusest',0),(146785,4078,'si','Nedavni prodaja ukrepi',0),(146786,4078,'ba','Penjualan hari tindakan',0),(146787,4078,'nl','Recente verkoop acties',0),(146788,4078,'fi','Myynnin toiminnot',0),(146789,4078,'no','Siste salg handlinger',0),(146790,4078,'da','Seneste salg handlinger',0),(146791,4078,'ko','ìµœê·¼ íŒë§¤ ìž‘ì—…',0),(146792,4078,'he','×”×¤×¢×•×œ×•×ª ×”××—×¨×•× ×•×ª ×ž×›×™×¨×•×ª',0),(146793,4078,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ ÎµÎ½Î­ÏÎ³ÎµÎ¹ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(146794,4078,'zh','æœ€è¿‘çš„é”€å”®è¡ŒåŠ¨\r\n',0),(146795,4078,'sv','Senaste fÃ¶rsÃ¤ljning Ã¥tgÃ¤rder',0),(146796,4078,'it','Azioni recenti vendite',0),(146797,4078,'tl','',0),(146798,4078,'th','&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3649;&#3621;&#3657;&#3623;',0),(146799,4078,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥à¤°à¤¿à¤¯à¤¾à¤à¤',0),(146800,4078,'ms','Tindakan jualan hari',0),(146801,4078,'ar','Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(146802,4078,'fr','Actions de ventes rÃ©centes',0),(146803,4078,'jp','æœ€è¿‘ã?®ã‚»ãƒ¼ãƒ«ã‚¹æ´»å‹•',0),(146804,4078,'pt','AÃ§Ãµes de vendas recentes',0),(146805,4078,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¸Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(146806,4078,'es','Movimientos de Ventas Recientes',0),(146807,4078,'de','Aktuelle Verkaufsaktionen',0),(146808,4078,'en','Recent Sales Actions',0),(146809,4079,'is','',0),(146810,4079,'dr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ÙŠ Ù†Ø²Ø¯ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø³Ø± Ø±Ø³ÙŠØ¯ ',0),(146811,4079,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ÙŠ Ù†Ø²Ø¯ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø³Ø± Ø±Ø³ÙŠØ¯ ',0),(146812,4079,'tr','Faturalar nedeniyle yaklaÅŸan tarihi',0),(146813,4079,'pl','Data faktury bliski ukoÅ„czenia',0),(146814,4079,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸, Ð½Ð°Ð±Ð»Ð¸Ð¶Ð°Ð²Ð° Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(146815,4079,'ur','Ù…Ù‚Ø±Ø±Û ØªÙ‚Ø±ÛŒØ¨Ø§ Ù‚Ø±ÛŒØ¨ ØªÚ¾ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(146816,4079,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° ÑÐµ Ð±Ð»Ð¸Ð¶Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(146817,4079,'vi','HÃ³a Ä‘Æ¡n gáº§n ngÃ y Ä‘áº¿n háº¡n',0),(146818,4079,'af','Fakture nader Betalingsdatum ',0),(146819,4079,'ro','Facturi care se apropie de termenul de plata',0),(146820,4079,'et','MaksetÃ¤htajale lÃ¤henevad arved',0),(146821,4079,'si','RaÄuni, ki se bliÅ¾a zaradi datum',0),(146822,4079,'ba','Tanggal faktur mendekati jatuh tempo',0),(146823,4079,'nl','Facturen bijna Due Date',0),(146824,4079,'fi','Laskujen lÃ¤hestymÃ¤ssÃ¤ Due Date',0),(146825,4079,'no','Fakturaer nÃ¦rmer forfallsdato dato',0),(146826,4079,'da','Fakturaer nÃ¦rmer sig behÃ¸rig dato',0),(146827,4079,'ko','ë•Œë¬¸ì— ê·¼ì ‘ í•˜ëŠ” ì†¡ìž¥ ë‚ ì§œ',0),(146828,4079,'he','×—×©×‘×•× ×™×•×ª ×ž×ª×§×¨×‘×™× ×™×¢×“ ×ª××¨×™×š',0),(146829,4079,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… Ï€Î»Î·ÏƒÎ¹Î¬Î¶ÎµÎ¹ Ï„Î· Î´Î­Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(146830,4079,'zh','å‘ç¥¨ä¸´è¿‘æˆªæ­¢æ—¥æœŸ\r\n',0),(146831,4079,'sv','Fakturor som nÃ¤rmar sig Due Date',0),(146832,4079,'it','Fatture, avvicinandosi la scadenza Data',0),(146833,4079,'tl','',0),(146834,4079,'th','&#3585;&#3656;&#3629;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(146835,4079,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¤¿à¤¯à¤¤ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤¤à¤¾à¤°à¥€à¤–',0),(146836,4079,'ms','Invois-invois yang hampir habis tempoh tarikh',0),(146837,4079,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªÙŠ ØªÙ‚ØªØ±Ø¨ Ù…Ù† Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(146838,4079,'fr','Factures presque Due Date',0),(146839,4079,'jp','æœŸæ—¥ã?Œè¿‘ã?¥ã?„ã?¦ã?„ã‚‹è«‹æ±‚æ›¸',0),(146840,4079,'pt','Facturas, aproximando a devida Data',0),(146841,4079,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÐŸÑ€Ð¸Ð±Ð»Ð¸Ð¶Ð°ÑŽÑ‰Ð¸ÐµÑÑ Ðš Ð”Ð°Ñ‚Ðµ ÐžÐ¿Ð»Ð°Ñ‚Ñ‹',0),(146842,4079,'es','Facturas Acercando la fecha de Vencimiento',0),(146843,4079,'de','Rechnungen, die kurz vor dem Due Date',0),(146844,4079,'en','Invoices Nearing Due Date',0),(146845,4080,'is','',0),(146846,4080,'dr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ÙŠ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ú¯Ø°Ø´ØªÙ‡',0),(146847,4080,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ÙŠ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ú¯Ø°Ø´ØªÙ‡',0),(146848,4080,'tr','Faturaya vade tarihi',0),(146849,4080,'pl','Data faktury zalegÅ‚oÅ›ci',0),(146850,4080,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð½Ð°Ð´ Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(146851,4080,'ur','ØªØ§Ø±ÛŒØ® Ù…Ù‚Ø±Ø±Û Ù¾Ø± ÙˆØ¨Ø¬Ù„ÛŒ',0),(146852,4080,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð° Ð¿Ñ€ÐµÐºÐ¾ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(146853,4080,'vi','HÃ³a Ä‘Æ¡n quÃ¡ ngÃ y Ä‘áº¿n háº¡n',0),(146854,4080,'af','Fakture Agterstallige Datum',0),(146855,4080,'ro','Facturi cu termen depasit',0),(146856,4080,'et','MaksetÃ¤htaja Ã¼letanud arved',0),(146857,4080,'si','RaÄuni zapadle datum',0),(146858,4080,'ba','Tanggal faktur berakhir karena',0),(146859,4080,'nl','Facturen Over tijd datum',0),(146860,4080,'fi','Laskuja yli, koska pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(146861,4080,'no','Fakturaer forfalte dato',0),(146862,4080,'da','Fakturaer Over Due dato',0),(146863,4080,'ko','ë•Œë¬¸ì— ì¸ë³´ì´ìŠ¤ ë‚ ì§œ',0),(146864,4080,'he','×—×©×‘×•× ×™×•×ª ×¤×’ ×ª××¨×™×š',0),(146865,4080,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(146866,4080,'zh','è¶…è¿‡å‘ç¥¨åˆ°æœŸæ—¥\r\n',0),(146867,4080,'sv','Fakturor Ã¶ver Due Date',0),(146868,4080,'it','Fatture oltre la scadenza Data',0),(146869,4080,'tl','',0),(146870,4080,'th','&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(146871,4080,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¤¿à¤¯à¤¤ à¤ªà¤° à¤¤à¤¾à¤°à¥€à¤–',0),(146872,4080,'ms','Tarikh invois ke atas disebabkan oleh',0),(146873,4080,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø¹Ù„Ù‰ Ø§Ù„ÙˆØ§Ø¬Ø¨',0),(146874,4080,'fr','Jour des factures Ã  Ã©chÃ©ance',0),(146875,4080,'jp','æœŸæ—¥ã?®é?Žã?Žã?Ÿè«‹æ±‚æ›¸',0),(146876,4080,'pt','Faturas com vencimento Data',0),(146877,4080,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¡ ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¾Ð¹ Ð”Ð°Ñ‚Ð¾Ð¹ ÐžÐ¿Ð»Ð°Ñ‚Ñ‹',0),(146878,4080,'es','Facturas Fecha de Vencimiento',0),(146879,4080,'de','Rechnungen Ã¼ber Due Date',0),(146880,4080,'en','Invoices Over Due Date',0),(146881,4081,'is','',0),(146882,4081,'dr','Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(146883,4081,'pr','Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(146884,4081,'tr','HiÃ§ fatura bulundu',0),(146885,4081,'pl','Nie faktury Znalezione',0),(146886,4081,'bg','ÐÑÐ¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(146887,4081,'ur','Ú©ÙˆØ¦ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ù¾Ø§ÛŒØ§',0),(146888,4081,'sr','ÐÐµÐ¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(146889,4081,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ³a Ä‘Æ¡n',0),(146890,4081,'af','Geen Fakture Gevind',0),(146891,4081,'ro','Nici facturile gÄƒsit',0),(146892,4081,'et','Ãœhtegi arvet ei leitud',0),(146893,4081,'si','Ni raÄunih naÅ¡el',0),(146894,4081,'ba','Faktur tidak ditemukan',0),(146895,4081,'nl','Geen facturen gevonden',0),(146896,4081,'fi','Laskuja ei lÃ¶ydy',0),(146897,4081,'no','Ingen fakturaer funnet',0),(146898,4081,'da','Ingen fakturaer fundet',0),(146899,4081,'ko','ë°œê²¬ ì•„ë¬´ ì²­êµ¬ì„œ',0),(146900,4081,'he','×œ× × ×ž×¦××• ×—×©×‘×•× ×™×•×ª',0),(146901,4081,'el','Î”ÎµÎ½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(146902,4081,'zh','æ²¡æœ‰æ‰¾åˆ°å‘ç¥¨\r\n',0),(146903,4081,'sv','Inga fakturor hittade',0),(146904,4081,'it','Nessun fatture trovate',0),(146905,4081,'tl','',0),(146906,4081,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(146907,4081,'hi','à¤•à¥‹à¤ˆ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸à¥‡à¤¸ à¤ªà¤¾à¤¯à¤¾',0),(146908,4081,'ms','Tiada invois yang ditemui',0),(146909,4081,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨',0),(146910,4081,'fr','Aucune facture trouvÃ©',0),(146911,4081,'jp','è«‹æ±‚æ›¸ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(146912,4081,'pt','NÃ£o hÃ¡ facturas encontradas',0),(146913,4081,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(146914,4081,'es','No se encontraron facturas',0),(146915,4081,'de','Keine Rechnungen gefunden',0),(146916,4081,'en','No Invoices Found',0),(146917,4082,'is','',0),(146918,4082,'dr','Ù†Ù…Ø§ÙŠØ´ Ø®Ù„Ø§ØµÙ‡ Ú¯Ø²Ø§Ø±Ø´ ÙØ§ÙƒØªÙˆØ± ',0),(146919,4082,'pr','Ù†Ù…Ø§ÙŠØ´ Ø®Ù„Ø§ØµÙ‡ Ú¯Ø²Ø§Ø±Ø´ ÙØ§ÙƒØªÙˆØ± ',0),(146920,4082,'tr','Fatura raporundaki Ã¶zetini gÃ¶rÃ¼ntÃ¼le',0),(146921,4082,'pl','WyÅ›wietl podsumowanie dotyczÄ…ce raportu \"faktura\"',0),(146922,4082,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð½Ð° Ð´Ð¾ÐºÐ»Ð°Ð´ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(146923,4082,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ú©Ø§ Ø®Ù„Ø§ØµÛ Ú©Ø§ Ù…Ù†Ø¸Ø± Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(146924,4082,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð° Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(146925,4082,'vi','Xem bÃ¡o cÃ¡o tá»•ng há»£p hÃ³a Ä‘Æ¡n',0),(146926,4082,'af','Besigting Opsomming van Faktuur Verslag',0),(146927,4082,'ro','Vezi Rezumat de raportul facturÄƒ',0),(146928,4082,'et','View Summary of Invoice Report',0),(146929,4082,'si','Pogled povzetek raÄuna poroÄila',0),(146930,4082,'ba','Lihat ringkasan laporan faktur',0),(146931,4082,'nl','Weergave Samenvatting van het factuurrapport',0),(146932,4082,'fi','NÃ¤ytÃ¤ Yhteenveto lasku-raporttiin',0),(146933,4082,'no','Vis sammendrag av fakturarapporten',0),(146934,4082,'da','Se oversigt over fakturarapport',0),(146935,4082,'ko','ì†¡ìž¥ ë³´ê³ ì„œì˜ ìš”ì•½ ë³´ê¸°',0),(146936,4082,'he','×”×¦×’×ª ×¡×™×›×•× ×©×œ ×“×•×— ×—×©×‘×•× ×™×•×ª',0),(146937,4082,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€ÎµÏÎ¯Î»Î·ÏˆÎ· Ï„Î¿Ï… Î­ÎºÎ¸ÎµÏƒÎ· \"Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿\"',0),(146938,4082,'zh','æŸ¥çœ‹å‘ç¥¨æ‘˜è¦çš„æŠ¥å‘Š\r\n',0),(146939,4082,'sv','Visa Sammanfattning av fakturarapporten',0),(146940,4082,'it','Visualizzazione Riepilogo del Report fattura',0),(146941,4082,'tl','',0),(146942,4082,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(146943,4082,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¦à¥‡à¤–à¥‡à¤‚',0),(146944,4082,'ms','Paparan ringkasan laporan invois',0),(146945,4082,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ± Ù…Ù„Ø®Ù‘Øµ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(146946,4082,'fr','Afficher le rÃ©sumÃ© du rapport de la facture',0),(146947,4082,'jp','è«‹æ±‚æ›¸ãƒ¬ãƒ?ãƒ¼ãƒˆã?®ã‚µãƒžãƒªãƒ¼ã‚’è¦‹ã‚‹',0),(146948,4082,'pt','Resumo de exibiÃ§Ã£o do relatÃ³rio fatura',0),(146949,4082,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ñ€ÐµÐ·ÑŽÐ¼Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´Ð° ÑÑ‡ÐµÑ‚Ð°',0),(146950,4082,'es','Ver Informe de ResÃºmen de Factura',0),(146951,4082,'de','Rechnungsbericht Zusammenfassung anzeigen',0),(146952,4082,'en','View Summary of Invoice Report',0),(146953,4083,'is','',0),(146954,4083,'dr','ØªØ®Ù…ÙŠÙ† Ø²Ø¯Ù†',0),(146955,4083,'pr','ØªØ®Ù…ÙŠÙ† Ø²Ø¯Ù†',0),(146956,4083,'tr','Tahmini',0),(146957,4083,'pl','Oszacowanie',0),(146958,4083,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð°Ñ‚Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(146959,4083,'ur','Ø§Ù†Ø¯Ø§Ø²Û',0),(146960,4083,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°',0),(146961,4083,'vi','Dá»± trÃ¹',0),(146962,4083,'af','Skatting',0),(146963,4083,'ro','Estimare',0),(146964,4083,'et','Hinnang',0),(146965,4083,'si','Ocena',0),(146966,4083,'ba','Perkiraan',0),(146967,4083,'nl','Schatting',0),(146968,4083,'fi','Arvio',0),(146969,4083,'no','Anslag',0),(146970,4083,'da','SkÃ¸n',0),(146971,4083,'ko','ê²¬ì ',0),(146972,4083,'he','×”×¢×¨×›×”',0),(146973,4083,'el','Î•ÎºÏ„Î¯Î¼Î·ÏƒÎ·',0),(146974,4083,'zh','é¢„è®¡',0),(146975,4083,'sv','Uppskattning',0),(146976,4083,'it','Stima',0),(146977,4083,'tl','',0),(146978,4083,'th','&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;',0),(146979,4083,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(146980,4083,'ms','Anggaran',0),(146981,4083,'ar','Ø§Ù„ØªÙ‚Ø¯ÙŠØ±',0),(146982,4083,'fr','Estimation',0),(146983,4083,'jp','è¦‹ç©?ã‚Š',0),(146984,4083,'pt','Estimativa',0),(146985,4083,'ru','ÐžÑ†ÐµÐ½ÐºÐ°',0),(146986,4083,'es','EstimaciÃ³n',0),(146987,4083,'de','SchÃ¤tzung',0),(146988,4083,'en','Estimate',0),(146989,4084,'is','',0),(146990,4084,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ  ',0),(146991,4084,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ  ',0),(146992,4084,'tr','KurÅŸun',0),(146993,4084,'pl','ProwadziÄ‡',0),(146994,4084,'bg','ÐžÐ»Ð¾Ð²Ð¾',0),(146995,4084,'ur','Ø¨Ø±ØªØ±ÛŒ',0),(146996,4084,'sr','ÐŸÐ¾Ñ‚ÐµÐ½Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾Ð³ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(146997,4084,'vi','Dáº«n Ä‘áº§u',0),(146998,4084,'af','Lei',0),(146999,4084,'ro','Plumb',0),(147000,4084,'et','Plii',0),(147001,4084,'si','Svinec',0),(147002,4084,'ba','Memimpin',0),(147003,4084,'nl','Leiden',0),(147004,4084,'fi','Johtaa',0),(147005,4084,'no','Bly',0),(147006,4084,'da','Bly',0),(147007,4084,'ko','ë¦¬ë“œ',0),(147008,4084,'he','×¢×•×¤×¨×ª',0),(147009,4084,'el','ÎŸÎ´Î·Î³Î®ÏƒÎµÎ¹',0),(147010,4084,'zh','å¼•å¯¼\r\n',0),(147011,4084,'sv','Leda',0),(147012,4084,'it','Piombo',0),(147013,4084,'tl','',0),(147014,4084,'th','&#3609;&#3635;&#3627;&#3609;&#3657;&#3634;',0),(147015,4084,'hi','à¤²à¥€à¤¡',0),(147016,4084,'ms','Membawa',0),(147017,4084,'ar','ÙŠØ¤Ø¯ÙŠ',0),(147018,4084,'fr','Plomb',0),(147019,4084,'jp','ãƒªãƒ¼ãƒ‰',0),(147020,4084,'pt','Chumbo',0),(147021,4084,'ru','Ð¡Ð²Ð¸Ð½ÐµÑ†',0),(147022,4084,'es','Dirigir',0),(147023,4084,'de','FÃ¼hren',0),(147024,4084,'en','Lead',0),(147025,4085,'is','',0),(147026,4085,'dr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ Ù…Ø¹ÙˆÙ‚ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡',0),(147027,4085,'pr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ Ù…Ø¹ÙˆÙ‚ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡',0),(147028,4085,'tr','SatÄ±ÅŸ bulundu bekleyen yok',0),(147029,4085,'pl','Nie znaleziono do czasu sprzedaÅ¼y',0),(147030,4085,'bg','ÐÑÐ¼Ð° Ñ‡Ð°ÐºÐ°Ñ‰Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(147031,4085,'ur','Ø³ÛŒÙ„Ø² Ø§Ù„ØªÙˆØ§ Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(147032,4085,'sr','ÐÐµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(147033,4085,'vi','KhÃ´ng tháº¥y sales Ä‘ang treo',0),(147034,4085,'af','Geen Afwagtende Verkope Gevind',0),(147035,4085,'ro','Nu Ã®n curs de vÃ¢nzare constatat',0),(147036,4085,'et','Nr kuni leidsin mÃ¼Ã¼k',0),(147037,4085,'si','Ni ÄakajoÄih prodaje naÅ¡el',0),(147038,4085,'ba','Tidak menunggu penjualan ditemukan',0),(147039,4085,'nl','Geen in afwachting van verkoop gevonden',0),(147040,4085,'fi','MitÃ¤Ã¤n kunnes myynti lÃ¶ytÃ¤nyt',0),(147041,4085,'no','Ingen ventende salg funnet',0),(147042,4085,'da','Ikke fundet ventende salg',0),(147043,4085,'ko','ë³´ë¥˜ íŒë§¤ ì°¾ì„ ìˆ˜ ì—†ìŒ',0),(147044,4085,'he','. ×œ× ×ž×ž×ª×™× ×™× ×ž×›×™×¨×•×ª ×ž×¦×',0),(147045,4085,'el','Î”ÎµÎ½ ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(147046,4085,'zh','æ²¡æœ‰æ‰¾åˆ°å¾…å®Œæˆé”€å”®\r\n',0),(147047,4085,'sv','Nr avvaktan fÃ¶rsÃ¤ljning hittade',0),(147048,4085,'it','No, in attesa di vendite trovato',0),(147049,4085,'tl','',0),(147050,4085,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(147051,4085,'hi','à¤•à¥‹à¤ˆ à¤²à¤‚à¤¬à¤¿à¤¤ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤ªà¤¾à¤¯à¤¾',0),(147052,4085,'ms','Tidak bergantung kepada jualan ditemui',0),(147053,4085,'ar','Ù„Ø§ Ø±ÙŠØ«Ù…Ø§ ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(147054,4085,'fr','Non, dans l\'attente de ventes trouvÃ©',0),(147055,4085,'jp','ä¿?ç•™ä¸­ã‚»ãƒ¼ãƒ«ã‚¹ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(147056,4085,'pt','NÃ£o vendas pendentes encontrado',0),(147057,4085,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸ Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(147058,4085,'es','No se Encontraron Ventas Pendientes',0),(147059,4085,'de','Nein ausstehende VerkÃ¤ufe gefunden',0),(147060,4085,'en','No Pending Sales Found',0),(147061,4086,'is','',0),(147062,4086,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ ÙØ±ÙˆØ´ Ù‡Ø§',0),(147063,4086,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ ÙØ±ÙˆØ´ Ù‡Ø§',0),(147064,4086,'tr','SatÄ±ÅŸ Ã–zeti raporu gÃ¶rÃ¼ntÃ¼le',0),(147065,4086,'pl','WyÅ›wietl raport sprzedaÅ¼y przeglÄ…d',0),(147066,4086,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(147067,4086,'ur','Ù…Ù†Ø¸Ø± Ø³ÛŒÙ„Ø² Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ø±Ù¾ÙˆØ±Ù¹',0),(147068,4086,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð·Ð²Ñ˜ÐµÑˆÑ‚Ð°Ñ˜ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(147069,4086,'vi','Xem bÃ¡o cÃ¡o tá»•ng quÃ¡t kinh doanh',0),(147070,4086,'af','Besigtig Verkoop Oorsig Verslag',0),(147071,4086,'ro','Vizualizare raport de vÃ¢nzÄƒri de ansamblu',0),(147072,4086,'et','Vaata lÃ¤bimÃ¼Ã¼gi Ã¼levaatlikku aruannet',0),(147073,4086,'si','Ogled prodajnega pregled poroÄila',0),(147074,4086,'ba','Lihat laporan penjualan Ikhtisar',0),(147075,4086,'nl','Rapport van de verkoop overzicht weergeven',0),(147076,4086,'fi','NÃ¤ytÃ¤ myynnin yleiskatsaus raportti',0),(147077,4086,'no','Vis salg oversiktsrapporten',0),(147078,4086,'da','Se salg oversigtsrapport',0),(147079,4086,'ko','íŒë§¤ ê°œìš” ë³´ê³ ì„œ ë³´ê¸°',0),(147080,4086,'he','×”×¦×’ ×“×•×— ×¡×§×™×¨×” ×¢×œ ×ž×›×™×¨×•×ª',0),(147081,4086,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎµÏ€Î¹ÏƒÎºÏŒÏ€Î·ÏƒÎ·',0),(147082,4086,'zh','æŸ¥çœ‹é”€å”®æ¦‚è¿°æŠ¥å‘Š\r\n',0),(147083,4086,'sv','Visa fÃ¶rsÃ¤ljning Ã¶versiktsrapport',0),(147084,4086,'it','Vista panoramica di Sales Report',0),(147085,4086,'tl','',0),(147086,4086,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(147087,4086,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤…à¤µà¤²à¥‹à¤•à¤¨ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(147088,4086,'ms','Lihat gambaran keseluruhan jualan Laporan',0),(147089,4086,'ar','Ø¹Ø±Ø¶ Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ù†Ø¸Ø±Ø© Ø¹Ø§Ù…Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(147090,4086,'fr','Afficher le rapport aperÃ§u vente',0),(147091,4086,'jp','ã‚»ãƒ¼ãƒ«ã‚¹æ¦‚æ‹¬ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(147092,4086,'pt','Exibir relatÃ³rio de Resumo de vendas',0),(147093,4086,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¾Ð±Ð·Ð¾Ñ€Ð½Ñ‹Ð¹ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(147094,4086,'es','Visionar Informe de Sumario de Ventas',0),(147095,4086,'de','VerkaufsÃ¼bersicht Bericht anzeigen',0),(147096,4086,'en','View Sales Overview Report',0),(147097,4087,'is','',0),(147098,4087,'dr','Ù‡ÙŠÚ† Ù¾Ø±Ø¯Ø§Ø®ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡',0),(147099,4087,'pr','Ù‡ÙŠÚ† Ù¾Ø±Ø¯Ø§Ø®ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡',0),(147100,4087,'tr','Ã–deme yok bulundu',0),(147101,4087,'pl','PÅ‚atnoÅ›ci, nie znaleziono',0),(147102,4087,'bg','ÐÐµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(147103,4087,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(147104,4087,'sr','ÐÐµÐ¼Ð° Ð¸ÑÐ¿Ð»Ð°Ñ‚Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(147105,4087,'vi','ChÆ°a tÃ¬m tháº¥y thanh toÃ¡n',0),(147106,4087,'af','Geen Betalings Gevind',0),(147107,4087,'ro','Nici o platÄƒ gÄƒsit',0),(147108,4087,'et','Makseid ei leitud',0),(147109,4087,'si','Brez plaÄila ugotovila',0),(147110,4087,'ba','Tidak ada pembayaran yang ditemukan',0),(147111,4087,'nl','Geen betalingen gevonden',0),(147112,4087,'fi','Maksuja ei lÃ¶ytynyt',0),(147113,4087,'no','Ingen betalinger funnet',0),(147114,4087,'da','Ingen betalinger, der er fundet',0),(147115,4087,'ko','ì•„ë‹ˆ ì§€ë¶ˆ ë°œê²¬',0),(147116,4087,'he','×œ× × ×ž×¦××• ×ª×©×œ×•×ž×™×',0),(147117,4087,'el','ÎšÎ±Î¼Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î® Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(147118,4087,'zh','æ²¡æœ‰å‘çŽ°ä»»ä½•ä»˜æ¬¾\r\n',0),(147119,4087,'sv','Inga utbetalningar hittade',0),(147120,4087,'it','Nessun pagamento trovato',0),(147121,4087,'tl','',0),(147122,4087,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(147123,4087,'hi','à¤•à¥‹à¤ˆ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¾à¤¯à¤¾',0),(147124,4087,'ms','Tiada bayaran yang ditemui',0),(147125,4087,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(147126,4087,'fr','Aucun paiement trouvÃ©',0),(147127,4087,'jp','æ”¯æ‰•ã?„ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(147128,4087,'pt','NÃ£o hÃ¡ pagamentos encontrados',0),(147129,4087,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(147130,4087,'es','No se Encontraron Pagos',0),(147131,4087,'de','Keine Zahlungen gefunden',0),(147132,4087,'en','No Payments Found',0),(147133,4088,'is','',0),(147134,4088,'dr','(Ø§Ù‚Ø³Ø§Ø·)Ø§Ø®ÙŠØ±',0),(147135,4088,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ(Ø§Ù‚Ø³Ø§Ø·)Ø§Ø®ÙŠØ±',0),(147136,4088,'tr','Son Ã¶deme',0),(147137,4088,'pl','Ostatnie pÅ‚atnoÅ›ci',0),(147138,4088,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(147139,4088,'ur','Ø­Ø§Ù„ÛŒÛ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(147140,4088,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(147141,4088,'vi','Thanh toÃ¡n gáº§n Ä‘Ã¢y',0),(147142,4088,'af','Onlangse Betalings',0),(147143,4088,'ro','Recente plÄƒÅ£i',0),(147144,4088,'et','Hiljutised maksed',0),(147145,4088,'si','Nedavni plaÄila',0),(147146,4088,'ba','Tanggal pembayaran',0),(147147,4088,'nl','Recente betalingen',0),(147148,4088,'fi','Hotelliin maksut',0),(147149,4088,'no','Nylige betalinger',0),(147150,4088,'da','Seneste betalinger',0),(147151,4088,'ko','ìµœê·¼ ì§€ê¸‰',0),(147152,4088,'he','×ª×©×œ×•×ž×™× ××—×¨×•× ×™×',0),(147153,4088,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(147154,4088,'zh','æœ€è¿‘ä»˜æ¬¾\r\n',0),(147155,4088,'sv','Senaste betalningar',0),(147156,4088,'it','Pagamenti recenti',0),(147157,4088,'tl','',0),(147158,4088,'th','&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3649;&#3621;&#3657;&#3623;',0),(147159,4088,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(147160,4088,'ms','Hari pembayaran',0),(147161,4088,'ar','Ø§Ù„Ø¯ÙØ¹Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(147162,4088,'fr','Paiements rÃ©cents',0),(147163,4088,'jp','æœ€è¿‘ã?®æ”¯æ‰•ã?„',0),(147164,4088,'pt','Pagamentos recentes',0),(147165,4088,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¸Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸',0),(147166,4088,'es','Pagos Recientes',0),(147167,4088,'de','Den letzten Zahlungen',0),(147168,4088,'en','Recent Payments',0),(147169,4089,'is','',0),(147170,4089,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(147171,4089,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(147172,4089,'tr','Ã–deme geÃ§miÅŸi raporu gÃ¶rÃ¼ntÃ¼le',0),(147173,4089,'pl','Zobacz raport historia pÅ‚atnoÅ›ci',0),(147174,4089,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(147175,4089,'ur','Ù…Ù†Ø¸Ø± Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø±Ù¾ÙˆØ±Ù¹',0),(147176,4089,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(147177,4089,'vi','Xem bÃ¡o cÃ¡o lá»‹ch sá»­ thanh toÃ¡n',0),(147178,4089,'af','Besigtig Betalingsgeskiedenisverslag',0),(147179,4089,'ro','Raport de istorie Vezi plata',0),(147180,4089,'et','Vaata maksete ajaloo aruannet',0),(147181,4089,'si','Ogled plaÄilo zgodovino poroÄila',0),(147182,4089,'ba','Lihat laporan sejarah pembayaran',0),(147183,4089,'nl','Weergave rapport voor de geschiedenis van de betaling',0),(147184,4089,'fi','Katso historia maksuraportti',0),(147185,4089,'no','Vis betaling historie rapport',0),(147186,4089,'da','Vis betaling historie rapport',0),(147187,4089,'ko','ì§€ë¶ˆ ê¸°ë¡ ë³´ê³ ì„œ ë³´ê¸°',0),(147188,4089,'he','×ª×¦×•×’×ª ×”×ª×©×œ×•× ×‘×”×™×¡×˜×•×¨×™×”',0),(147189,4089,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ Î¹ÏƒÏ„Î¿ÏÎ¯Î± Ï„Î·Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(147190,4089,'zh','æŸ¥çœ‹ä»˜æ¬¾åŽ†å²æŠ¥å‘Š\r\n',0),(147191,4089,'sv','Visa betalning historia rapport',0),(147192,4089,'it','Relazione di storia vista pagamento',0),(147193,4089,'tl','',0),(147194,4089,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(147195,4089,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(147196,4089,'ms','Lihat laporan sejarah pembayaran',0),(147197,4089,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ± Ù…Ø­ÙÙˆØ¸Ø§Øª Ø§Ù„Ø¯ÙØ¹',0),(147198,4089,'fr','Rapport d\'historique de paiement Voir',0),(147199,4089,'jp','æ”¯æ‰•å±¥æ­´ãƒ¬ãƒ?ãƒ¼ãƒˆã‚’è¦‹ã‚‹',0),(147200,4089,'pt','Exibir relatÃ³rio de histÃ³rico de pagamento',0),(147201,4089,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐžÑ‚Ñ‡ÐµÑ‚Ð° Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ð¸ ÐŸÐ»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(147202,4089,'es','Visionar Informe de Historia de Pagos',0),(147203,4089,'de','Zahlung-Geschichte-Bericht anzeigen',0),(147204,4089,'en','View Payment History Report',0),(147205,4090,'is','',0),(147206,4090,'dr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØª ÙØ±ÙˆØ´ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(147207,4090,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØª ÙØ±ÙˆØ´ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(147208,4090,'tr','Bulunan satÄ±ÅŸ bir eylem yok',0),(147209,4090,'pl','Brak sprzedaÅ¼y akcji Znalezione',0),(147210,4090,'bg','ÐÑÐ¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(147211,4090,'ur','Ú©ÙˆØ¦ÛŒ Ø³ÛŒÙ„Ø² Ø§Ø¹Ù…Ø§Ù„ Ù†ÛÛŒÚº Ù…Ù„Û’',0),(147212,4090,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð°ÑˆÐ»Ð¸',0),(147213,4090,'vi','KhÃ´ng tháº¥y hÃ nh Ä‘á»™ng bÃ¡n hÃ ng',0),(147214,4090,'af','Geen Verkoopsaksies Gevind',0),(147215,4090,'ro','Nu acÅ£iunile vÃ¢nzÄƒri gÄƒsit',0),(147216,4090,'et','Leitud mÃ¼Ã¼gi toiminguid pole',0),(147217,4090,'si','Ni prodaje dejanja, ki so',0),(147218,4090,'ba','Tidak ada tindakan penjualan yang ditemukan',0),(147219,4090,'nl','Geen verkoop acties gevonden',0),(147220,4090,'fi','Myynnin toimintoja ei lÃ¶ytynyt',0),(147221,4090,'no','Ingen salg handlinger ble funnet',0),(147222,4090,'da','Ingen salg handlinger fundet',0),(147223,4090,'ko','ì•„ë‹ˆ íŒë§¤ ìž‘ì—… ë°œê²¬',0),(147224,4090,'he','××™×Ÿ ×¤×¢×•×œ×•×ª ×”×ž×›×™×¨×” × ×ž×¦××•',0),(147225,4090,'el','Î”ÎµÎ½ ÎµÎ½ÎµÏÎ³ÎµÎ¹ÏŽÎ½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€Î¿Ï… Î´Î¹Î±Ï€Î¹ÏƒÏ„ÏŽÎ¸Î·ÎºÎµ',0),(147226,4090,'zh','æ²¡æœ‰æ‰¾åˆ°é”€å”®è¡Œä¸º\r\n',0),(147227,4090,'sv','Ingen fÃ¶rsÃ¤ljning Ã¥tgÃ¤rder konstaterade',0),(147228,4090,'it','Nessuna vendita azioni trovate',0),(147229,4090,'tl','',0),(147230,4090,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(147231,4090,'hi','à¤•à¥‹à¤ˆ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾à¤à¤ à¤ªà¤¾à¤¯à¤¾',0),(147232,4090,'ms','Tiada jualan yang ditemui',0),(147233,4090,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ÙˆØ¬Ø¯Øª',0),(147234,4090,'fr','Aucune action de vente trouvÃ©es',0),(147235,4090,'jp','ã‚»ãƒ¼ãƒ«ã‚¹æ´»å‹•ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(147236,4090,'pt','Nenhuma aÃ§Ã£o de vendas encontradas',0),(147237,4090,'ru','ÐÐµÑ‚ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹Ñ… Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(147238,4090,'es','No se Encontraron Acciones de Ventas',0),(147239,4090,'de','Keine Verkaufsaktionen gefunden',0),(147240,4090,'en','No Sales Actions Found',0),(147241,4091,'is','',0),(147242,4091,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª ÙØ±ÙˆØ´ ',0),(147243,4091,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª ÙØ±ÙˆØ´ ',0),(147244,4091,'tr','SatÄ±ÅŸ eylem raporu gÃ¶rÃ¼ntÃ¼le',0),(147245,4091,'pl','WyÅ›wietl raport sprzedaÅ¼y akcji',0),(147246,4091,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(147247,4091,'ur','Ù…Ù†Ø¸Ø± Ø³ÛŒÙ„Ø² Ø§ÛŒÚ©Ø´Ù† Ø±Ù¾ÙˆØ±Ù¹',0),(147248,4091,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð·Ð²Ñ˜ÐµÑˆÑ‚Ð°Ñ˜ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(147249,4091,'vi','Xem bÃ¡o cÃ¡o hoáº¡t Ä‘á»™ng kinh doanh',0),(147250,4091,'af','Besigtig Verkoop Aksie Verslag',0),(147251,4091,'ro','Vizualizare vÃ¢nzÄƒri acÅ£iune raport',0),(147252,4091,'et','Vaata mÃ¼Ã¼gitegevuste aruannet',0),(147253,4091,'si','Ogled poroÄila prodajne akcije',0),(147254,4091,'ba','Lihat aksi penjualan laporan',0),(147255,4091,'nl','Verkoop actie rapport weergeven',0),(147256,4091,'fi','NÃ¤ytÃ¤ myynnin toimintakertomus',0),(147257,4091,'no','Vis salg handling rapport',0),(147258,4091,'da','Vis salg aktion rapport',0),(147259,4091,'ko','íŒë§¤ ìž‘ì—… ë³´ê³ ì„œ ë³´ê¸°',0),(147260,4091,'he','×”×¦×’ ×“×•×— ×¤×¢×•×œ×” ×ž×›×™×¨×•×ª',0),(147261,4091,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î´ÏÎ¬ÏƒÎ·',0),(147262,4091,'zh','æŸ¥çœ‹é”€å”®è¡ŒåŠ¨æŠ¥å‘Š\r\n',0),(147263,4091,'sv','Visa fÃ¶rsÃ¤ljning Ã¥tgÃ¤rder rapport',0),(147264,4091,'it','Visualizza Report vendite azione',0),(147265,4091,'tl','',0),(147266,4091,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(147267,4091,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(147268,4091,'ms','Lihat jualan tindakan Laporan',0),(147269,4091,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ± Ø¹Ù…Ù„ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(147270,4091,'fr','Afficher le rapport vente Action',0),(147271,4091,'jp','ã‚»ãƒ¼ãƒ«ã‚¹æ´»å‹•ãƒ¬ãƒ?ãƒ¼ãƒˆã‚’è¦‹ã‚‹',0),(147272,4091,'pt','Exibir relatÃ³rio de aÃ§Ã£o de vendas',0),(147273,4091,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐžÑ‚Ñ‡ÐµÑ‚Ð° Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(147274,4091,'es','Visionar Informe de AcciÃ³n de Ventas',0),(147275,4091,'de','Verkauf Aktion Bericht anzeigen',0),(147276,4091,'en','View Sales Action Report',0),(147277,4092,'is','',0),(147278,4092,'dr','(ØªØ§Ø±ÙŠØ® Ù…ÙˆØ¹Ø¯',0),(147279,4092,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ (ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯',0),(147280,4092,'tr','Faturalar (son tarih)',0),(147281,4092,'pl','Faktur (terminy)',0),(147282,4092,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ (Ð¿Ð°Ð´ÐµÐ¶Ð¸)',0),(147283,4092,'ur','ÙˆØ¨Ø¬Ù„ÛŒ (Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®ÙˆÚº)',0),(147284,4092,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° (Ð´Ð°Ñ‚ÑƒÐ¼)',0),(147285,4092,'vi','HÃ³a Ä‘Æ¡n (ngÃ y Ä‘áº¿n háº¡n)',0),(147286,4092,'af','Fakture (Datums Verskuldig)',0),(147287,4092,'ro','Facturi (Termene de plata)',0),(147288,4092,'et','Arved (TÃ¤htajad)',0),(147289,4092,'si','RaÄunov (datumov zapadlosti)',0),(147290,4092,'ba','Faktur (Tempo)',0),(147291,4092,'nl','Facturen (vervaldatums)',0),(147292,4092,'fi','Laskut (erÃ¤pÃ¤ivÃ¤t)',0),(147293,4092,'no','Fakturaer (forfallsdatoer)',0),(147294,4092,'da','Fakturaer (forfaldsdatoer)',0),(147295,4092,'ko','ì†¡ìž¥ (ê¸°í•œ)',0),(147296,4092,'he','×—×©×‘×•× ×™×•×ª (×ª××¨×™×›×™ ×”×™×¢×“)',0),(147297,4092,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± (Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚)',0),(147298,4092,'zh','å‘ç¥¨ï¼ˆäº¤è´§æœŸï¼‰\r\n',0),(147299,4092,'sv','Fakturor (fÃ¶rfallodatum)',0),(147300,4092,'it','Fatture (scadenze)',0),(147301,4092,'tl','',0),(147302,4092,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657; (&#3623;&#3633;&#3609;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;)',0),(147303,4092,'hi','à¤šà¤¾à¤²à¤¾à¤¨ (à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•)',0),(147304,4092,'ms','Invois (tarikh akhir)',0),(147305,4092,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± (ØªÙˆØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚)',0),(147306,4092,'fr','Factures (Dates d\'Ã©chÃ©ance)',0),(147307,4092,'jp','è«‹æ±‚æ›¸ï¼ˆæœŸæ—¥ï¼‰',0),(147308,4092,'pt','Facturas (datas de vencimento)',0),(147309,4092,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ (ÑÑ€Ð¾ÐºÐ¸)',0),(147310,4092,'es','Facturas (Fechas de Vencimiento)',0),(147311,4092,'de','Rechnungen (FÃ¤lligkeit)',0),(147312,4092,'en','Invoices (Due Dates)',0),(147313,4093,'is','',0),(147314,4093,'dr','Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ â€“ ÙƒÙˆØªØ§Ù‡ ',0),(147315,4093,'pr','Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ â€“ ÙƒÙˆØªØ§Ù‡ ',0),(147316,4093,'tr','Yeni dÃ¼zen - kÄ±sa',0),(147317,4093,'pl','Nowy porzÄ…dek - KrÃ³tki',0),(147318,4093,'bg','ÐÐ¾Ð² Ñ€ÐµÐ´ - ÐºÑ€Ð°Ñ‚ÐºÐ¾',0),(147319,4093,'ur','Ù†Ø¦Û’ Ø¢Ø±ÚˆØ± - Ù…Ø®ØªØµØ±',0),(147320,4093,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº - ÐºÑ€Ð°Ñ‚ÐºÐ¸',0),(147321,4093,'vi','ÄÆ¡n Ä‘áº·t hÃ ng má»›i - ngáº¯n',0),(147322,4093,'af','Nuwe orde - kort',0),(147323,4093,'ro','Noua ordine - scurt',0),(147324,4093,'et','Uus tellimus - lÃ¼hike',0),(147325,4093,'si','New Order - kratke',0),(147326,4093,'ba','Orde Baru - pendek',0),(147327,4093,'nl','New Order - korte',0),(147328,4093,'fi','Uusi jÃ¤rjestys â€“ lyhyt',0),(147329,4093,'no','Ny ordre - kort',0),(147330,4093,'da','Ny ordre - kort',0),(147331,4093,'ko','ìƒˆë¡œìš´ ìˆœì„œ-ì§§ì€',0),(147332,4093,'he','×¡×“×¨ ×—×“×© - ×§×¦×¨',0),(147333,4093,'el','ÎÎ­Î± Ï„Î¬Î¾Î· - ÏƒÏÎ½Ï„Î¿Î¼Î¿ Ï‡ÏÎ¿Î½Î¹ÎºÏŒ',0),(147334,4093,'zh','æ–°ç§©åº- çŸ­\r\n',0),(147335,4093,'sv','Ny Order - kort',0),(147336,4093,'it','Nuovo ordine - in breve',0),(147337,4093,'tl','',0),(147338,4093,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656; - &#3649;&#3610;&#3610;&#3618;&#3656;&#3629;',0),(147339,4093,'hi','à¤¨à¤ à¤†à¤¦à¥‡à¤¶ - à¤²à¤˜à¥',0),(147340,4093,'ms','Perintah baru - pendek',0),(147341,4093,'ar','Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¬Ø¯ÙŠØ¯--Ù‚ØµÙŠØ±Ø©',0),(147342,4093,'fr','New Order - court',0),(147343,4093,'jp','æ–°è¦?æ³¨æ–‡ãƒ¼ã‚·ãƒ§ãƒ¼ãƒˆ',0),(147344,4093,'pt','Nova ordem - curto',0),(147345,4093,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð—Ð°ÐºÐ°Ð· - ÐšÐ¾Ñ€Ð¾Ñ‚ÐºÐ¸Ð¹',0),(147346,4093,'es','Nuevo Orden - Corto',0),(147347,4093,'de','New Order - Short',0),(147348,4093,'en','New Order - Short',0),(147349,4094,'is','',0),(147350,4094,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¬Ø¯ÙŠØ¯ â€“ ÙØ±Ù… ÙƒÙˆØªØ§Ù‡ ',0),(147351,4094,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¬Ø¯ÙŠØ¯ â€“ ÙØ±Ù… ÙƒÙˆØªØ§Ù‡ ',0),(147352,4094,'tr','Yeni YazdÄ±rma dÃ¼zeni - kÄ±sa formu',0),(147353,4094,'pl','Nowy druk zamÃ³wienia - krÃ³tka forma',0),(147354,4094,'bg','ÐÐ¾Ð² Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ - ÐºÑ€Ð°Ñ‚ÐºÐ° Ñ„Ð¾Ñ€Ð¼Ð°',0),(147355,4094,'ur','Ù†Ø¦Û’ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¢Ø±ÚˆØ± - Ù…Ø®ØªØµØ± ÙØ§Ø±Ù…',0),(147356,4094,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ° - ÐšÑ€Ð°Ñ‚ÐºÐ° Ñ„Ð¾Ñ€Ð¼Ð°',0),(147357,4094,'vi','ÄÆ¡n hÃ ng in má»›i - dáº¡ng ngáº¯n',0),(147358,4094,'af','Nuwe orde - kort vorm druk',0),(147359,4094,'ro','Noua ordine imprimare - scurt formular',0),(147360,4094,'et','Uus printimise jÃ¤rjekorras - lÃ¼hivorm',0),(147361,4094,'si','Nov vrstni red tiskanja - kratki obliki',0),(147362,4094,'ba','Orde Baru cetak - formulir singkat',0),(147363,4094,'nl','Nieuwe afdrukvolgorde - korte vorm',0),(147364,4094,'fi','Uusi tulostusjÃ¤rjestystÃ¤ - lyhyt muoto',0),(147365,4094,'no','Ny rekkefÃ¸lge - kortformen',0),(147366,4094,'da','Nye udskriftsrÃ¦kkefÃ¸lgen - kort Form',0),(147367,4094,'ko','ìƒˆë¡œìš´ ì¸ì‡„ ìˆœì„œ-ì•½ì‹',0),(147368,4094,'he','×¡×“×¨ ×”×“×¤×¡×” ×—×“×© - ×˜×•×¤×¡ ×§×¦×¨',0),(147369,4094,'el','ÎÎ­Î± ÏƒÎµÎ¹ÏÎ¬ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ - ÏƒÏÎ½Ï„Î¿Î¼Î· Î¼Î¿ÏÏ†Î®',0),(147370,4094,'zh','æ–°çš„æ‰“å°è®¢å• -çŸ­è¡¨\r\n',0),(147371,4094,'sv','Nya utskriftsordning - kort Form',0),(147372,4094,'it','Nuovo ordine di stampa - forma breve',0),(147373,4094,'tl','',0),(147374,4094,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656; - &#3649;&#3610;&#3610;&#3618;&#3656;&#3629;',0),(147375,4094,'hi','à¤¨à¤ˆ à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® - à¤²à¤˜à¥ à¤°à¥‚à¤ª',0),(147376,4094,'ms','Pesanan cetakan baru - borang ringkas',0),(147377,4094,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©-Ø§Ù„Ù†Ù…ÙˆØ°Ø¬ Ø§Ù„Ù‚ØµÙŠØ±',0),(147378,4094,'fr','Nouvelle commande d\'impression - version abrÃ©gÃ©e',0),(147379,4094,'jp','æ–°è¦?å?°åˆ·æ³¨æ–‡ãƒ¼ã‚·ãƒ§ãƒ¼ãƒˆãƒ•ã‚©ãƒ¼ãƒ ',0),(147380,4094,'pt','Nova ordem de impressÃ£o - forma abreviada',0),(147381,4094,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ - ÐºÐ¾Ñ€Ð¾Ñ‚ÐºÐ°Ñ Ñ„Ð¾Ñ€Ð¼Ð°',0),(147382,4094,'es','Nuevo Orden de ImpresiÃ³n - Formulario Corto',0),(147383,4094,'de','Neue Druckreihenfolge - Kurzform',0),(147384,4094,'en','New Print Order - Short Form',0),(147385,4095,'is','',0),(147386,4095,'dr','Ú†Ø§Ù¾ ',0),(147387,4095,'pr','Ú†Ø§Ù¾ ',0),(147388,4095,'tr','YazdÄ±rma',0),(147389,4095,'pl','Drukowanie',0),(147390,4095,'bg','ÐŸÐµÑ‡Ð°Ñ‚',0),(147391,4095,'ur','Ø·Ø¨Ø§Ø¹Øª',0),(147392,4095,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(147393,4095,'vi','Äang in',0),(147394,4095,'af','Besig om te Druk',0),(147395,4095,'ro','Imprimare',0),(147396,4095,'et','TrÃ¼kin...',0),(147397,4095,'si','Tiskanje',0),(147398,4095,'ba','Percetakan',0),(147399,4095,'nl','Afdrukken',0),(147400,4095,'fi','Tulostaminen',0),(147401,4095,'no','Utskrift',0),(147402,4095,'da','Udskrivning',0),(147403,4095,'ko','ì¸ì‡„',0),(147404,4095,'he','×ž×“×¤×™×¡',0),(147405,4095,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(147406,4095,'zh','æ‰“å°\r\n',0),(147407,4095,'sv','Utskrift',0),(147408,4095,'it','Stampa',0),(147409,4095,'tl','',0),(147410,4095,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(147411,4095,'hi','à¤®à¥à¤¦à¥à¤°à¤£',0),(147412,4095,'ms','Percetakan',0),(147413,4095,'ar','Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(147414,4095,'fr','Impression',0),(147415,4095,'jp','å?°åˆ·',0),(147416,4095,'pt','ImpressÃ£o',0),(147417,4095,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(147418,4095,'es','Imprenta',0),(147419,4095,'de','Drucken',0),(147420,4095,'en','Printing',0),(147421,4096,'is','',0),(147422,4096,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø¨Ø¹Ø¯ÙŠ ',0),(147423,4096,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø¨Ø¹Ø¯ÙŠ ',0),(147424,4096,'tr','Daha sonra gÃ¶zden geÃ§irilmek Ã¼zere Kaydet',0),(147425,4096,'pl','ZapisaÄ‡ do pÃ³Åºniejszego przejrzenia',0),(147426,4096,'bg','Ð—Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð·Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð²Ð°Ñ‰ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(147427,4096,'ur','Ø¨Ø¹Ø¯ Ù…ÛŒÚº Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(147428,4096,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð·Ð° ÐºÐ°ÑÐ½Ð¸Ñ˜Ðµ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(147429,4096,'vi','Sao lÆ°u Ä‘á»ƒ Ä‘Ã¡nh giÃ¡ sau',0),(147430,4096,'af','Stoor vir latere hersiening',0),(147431,4096,'ro','A salva pentru mai tÃ¢rziu examinare',0),(147432,4096,'et','Salvesta hilisemaks lÃ¤bivaatamiseks',0),(147433,4096,'si','Shrani za kasnejÅ¡i pregled',0),(147434,4096,'ba','Hemat untuk meninjau',0),(147435,4096,'nl','Opslaan voor Later kunt bekijken',0),(147436,4096,'fi','Tallentaa myÃ¶hempÃ¤Ã¤ tarkastelua varten',0),(147437,4096,'no','Lagre for senere gjennomgang',0),(147438,4096,'da','Gemme til senere gennemsyn',0),(147439,4096,'ko','ë‚˜ì¤‘ì— ê²€í† ì— ëŒ€ í•œ ì €ìž¥',0),(147440,4096,'he','×©×ž×•×¨ ×œ×¡×§×™×¨×” ×ž××•×—×¨×ª ×™×•×ª×¨',0),(147441,4096,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Î³Î¹Î± Î±ÏÎ³ÏŒÏ„ÎµÏÎ± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(147442,4096,'zh','é™¤åŽæ¥å›žé¡¾\r\n',0),(147443,4096,'sv','Spara fÃ¶r senare granskning',0),(147444,4096,'it','Risparmiare per la successiva revisione',0),(147445,4096,'tl','',0),(147446,4096,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3616;&#3634;&#3618;&#3627;&#3621;&#3633;&#3591;',0),(147447,4096,'hi','à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(147448,4096,'ms','Simpan untuk kajian semula kemudian',0),(147449,4096,'ar','Ø­ÙØ¸ Ù„Ø§Ø³ØªØ¹Ø±Ø§Ø¶ Ù„Ø§Ø­Ù‚',0),(147450,4096,'fr','Conserver pour consultation ultÃ©rieure',0),(147451,4096,'jp','ã?‚ã?¨ã?§ç¢ºèª?ã?™ã‚‹ã?Ÿã‚?ã?«ä¿?å­˜ã?™ã‚‹',0),(147452,4096,'pt','Salvar para revisÃ£o posterior',0),(147453,4096,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð´Ð»Ñ Ð¿Ð¾ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ³Ð¾ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð°',0),(147454,4096,'es','Guardar para RevisiÃ³n MÃ¡s Tarde',0),(147455,4096,'de','FÃ¼r eine spÃ¤tere ÃœberprÃ¼fung speichern',0),(147456,4096,'en','Save for Later Review',0),(147457,4097,'is','',0),(147458,4097,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø·Ø¨Ù‚ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(147459,4097,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø·Ø¨Ù‚ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(147460,4097,'tr','Maliyet merkezi ayrÄ±ntÄ±sÄ±',0),(147461,4097,'pl','SzczegÃ³Å‚owo przez MPK',0),(147462,4097,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð» Ð¾Ñ‚ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(147463,4097,'ur','Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ú©Ø² Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªÙØµÛŒÙ„',0),(147464,4097,'sr','Ð”ÐµÑ‚Ð°Ñ™ Ð¿Ð¾ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(147465,4097,'vi','Chi tiáº¿t theo Cost Center',0),(147466,4097,'af','Detail per Koste Sentrum',0),(147467,4097,'ro','Detaliu de Cost Center',0),(147468,4097,'et','Ãœksikasjade rÃ¼hmitusalus Kulukeskus',0),(147469,4097,'si','Podrobnosti s stroÅ¡kovno srediÅ¡Äe',0),(147470,4097,'ba','Detail oleh biaya Pusat',0),(147471,4097,'nl','Detail door kosten Center',0),(147472,4097,'fi','Yksityiskohtaisesti kustannuspaikka',0),(147473,4097,'no','Detalj av kostsenter',0),(147474,4097,'da','Detalje af bÃ¦reren',0),(147475,4097,'ko','ë¹„ìš© ì„¼í„° ì„¸ë¶€',0),(147476,4097,'he','×¤×™×¨×•×˜ ×¢×œ-×™×“×™ ×ž×¨×›×– ×¢×œ×•×™×•×ª',0),(147477,4097,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î±Ï€ÏŒ Ï„Î¿ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(147478,4097,'zh','è¯¦ç»†çš„æˆæœ¬ä¸­å¿ƒ\r\n',0),(147479,4097,'sv','Detalj av kostnadsstÃ¤lle',0),(147480,4097,'it','Dettaglio di centro di costo',0),(147481,4097,'tl','',0),(147482,4097,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3650;&#3604;&#3618;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;',0),(147483,4097,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(147484,4097,'ms','Terperinci oleh Pusat kos',0),(147485,4097,'ar','Ø§Ù„ØªÙØ§ØµÙŠÙ„ Ø¨Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(147486,4097,'fr','DÃ©tail par centre de coÃ»ts',0),(147487,4097,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?®è©³ç´°',0),(147488,4097,'pt','Detalhe por centro de custo',0),(147489,4097,'ru','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ð¿Ð¾ ÐœÐ’Ð—',0),(147490,4097,'es','Detalle por Centro de Costos',0),(147491,4097,'de','Detail nach Kostenstelle',0),(147492,4097,'en','Detail by Cost Center',0),(147493,4098,'is','',0),(147494,4098,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ ',0),(147495,4098,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ ',0),(147496,4098,'tr','SipariÅŸ ayrÄ±ntÄ±sÄ±',0),(147497,4098,'pl','SzczegÃ³Å‚y zamÃ³wienia',0),(147498,4098,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(147499,4098,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªÙØµÛŒÙ„',0),(147500,4098,'sr','Ð”ÐµÑ‚Ð°Ñ™ Ð¿Ð¾ Ð½Ð°Ñ€ÐµÐ´Ð±Ð¸',0),(147501,4098,'vi','Chi tiáº¿t theo Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(147502,4098,'af','Detail per Bestelling',0),(147503,4098,'ro','Detalii comanda',0),(147504,4098,'et','Tellimuse Ã¼ksikasjad',0),(147505,4098,'si','Podrobnosti o po vrstnem redu',0),(147506,4098,'ba','Detail pesanan',0),(147507,4098,'nl','Detail door Order',0),(147508,4098,'fi','Yksityiskohtaisesti tilauksesta',0),(147509,4098,'no','Detalj av',0),(147510,4098,'da','Detalje af ordre',0),(147511,4098,'ko','ì£¼ë¬¸ ì„¸ë¶€ ì‚¬í•­',0),(147512,4098,'he','×¤×™×¨×•×˜ ×œ×¤×™ ×”×–×ž× ×”',0),(147513,4098,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î´Î¹',0),(147514,4098,'zh','è¯¦ç»†è®¢è´­\r\n',0),(147515,4098,'sv','Detalj av Order',0),(147516,4098,'it','Dettaglio di ordine',0),(147517,4098,'tl','',0),(147518,4098,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3650;&#3604;&#3618;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(147519,4098,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤†à¤¦à¥‡à¤¶ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(147520,4098,'ms','Terperinci oleh perintah',0),(147521,4098,'ar','Ø§Ù„ØªÙØ§ØµÙŠÙ„ Ø¨Ø§Ù„ØªØ±ØªÙŠØ¨',0),(147522,4098,'fr','DÃ©tail par le dÃ©cret',0),(147523,4098,'jp','æ³¨æ–‡ã?®è©³ç´°',0),(147524,4098,'pt','Detalhe por ordem',0),(147525,4098,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð¿Ð¾ Ð—Ð°ÐºÐ°Ð·Ñƒ',0),(147526,4098,'es','Detalle por Orden',0),(147527,4098,'de','Detail im Auftrag',0),(147528,4098,'en','Detail by Order',0),(147529,4099,'is','',0),(147530,4099,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†ÙˆØ¹ Ú¯Ø²Ø§Ø±Ø´',0),(147531,4099,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†ÙˆØ¹ Ú¯Ø²Ø§Ø±Ø´',0),(147532,4099,'tr','Rapor tipini seÃ§in',0),(147533,4099,'pl','Wybierz typ raportu',0),(147534,4099,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿Ð° Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(147535,4099,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ù‚Ø³Ù… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(147536,4099,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(147537,4099,'vi','Chá»n loáº¡i bÃ¡o cÃ¡o',0),(147538,4099,'af','Kies Verslagtipe',0),(147539,4099,'ro','SelectaÅ£i tipul de raport',0),(147540,4099,'et','Vali aruande tÃ¼Ã¼p',0),(147541,4099,'si','Izberite vrsto poroÄila',0),(147542,4099,'ba','Pilih jenis laporan',0),(147543,4099,'nl','Selecteer rapporttype',0),(147544,4099,'fi','Valitse raporttityyppi',0),(147545,4099,'no','Velg rapporttype',0),(147546,4099,'da','VÃ¦lg rapporttype',0),(147547,4099,'ko','ë³´ê³ ì„œ ìœ í˜• ì„ íƒ',0),(147548,4099,'he','×‘×—×¨ ×¡×•×’ ×“×•×—',0),(147549,4099,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„ÏÏ€Î¿ \"Î±Î½Î±Ï†Î¿ÏÎ¬\"',0),(147550,4099,'zh','é€‰æ‹©æŠ¥å‘Šç±»åž‹\r\n',0),(147551,4099,'sv','VÃ¤lj typ av rapport',0),(147552,4099,'it','Selezionare il tipo di rapporto',0),(147553,4099,'tl','',0),(147554,4099,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(147555,4099,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(147556,4099,'ms','Pilih jenis laporan',0),(147557,4099,'ar','Ø­Ø¯Ø¯ Ù†ÙˆØ¹ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(147558,4099,'fr','SÃ©lectionnez le Type de rapport',0),(147559,4099,'jp','ãƒ¬ãƒ?ãƒ¼ãƒˆã‚¿ã‚¤ãƒ—ã?®é?¸æŠž',0),(147560,4099,'pt','Selecione o tipo de relatÃ³rio',0),(147561,4099,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¢Ð¸Ð¿ ÐžÑ‚Ñ‡ÐµÑ‚Ð°',0),(147562,4099,'es','Seleccionar Tipo de Informe',0),(147563,4099,'de','WÃ¤hlen Sie Bericht',0),(147564,4099,'en','Select Report Type',0),(147565,4100,'is','',0),(147566,4100,'dr','Ø®Ù„Ø§ØµÙ‡ Ø¨Ø§ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(147567,4100,'pr','Ø®Ù„Ø§ØµÙ‡ Ø¨Ø§ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(147568,4100,'tr','Maliyet Merkezi tarafÄ±ndan Ã–zeti',0),(147569,4100,'pl','Podsumowanie przez MPK',0),(147570,4100,'bg','Ð ÐµÐ·ÑŽÐ¼Ðµ Ð¾Ñ‚ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(147571,4100,'ur','Ø®Ù„Ø§ØµÛ Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ú©Ø² Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(147572,4100,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð¿Ð¾ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(147573,4100,'vi','Tá»•ng há»£p Cost Center',0),(147574,4100,'af','Opsomming per Koste Sentrum',0),(147575,4100,'ro','Rezumat de Cost Center',0),(147576,4100,'et','Kulukeskuse KokkuvÃµte',0),(147577,4100,'si','Povzetek stroÅ¡kov center',0),(147578,4100,'ba','Ringkasan oleh biaya Pusat',0),(147579,4100,'nl','Samenvatting door kostenplaats',0),(147580,4100,'fi','Yhteenveto kustannuspaikka',0),(147581,4100,'no','Sammendrag av kostsenter',0),(147582,4100,'da','ResumÃ© af bÃ¦reren',0),(147583,4100,'ko','ë¹„ìš© ì„¼í„° ìš”ì•½',0),(147584,4100,'he','×¡×™×›×•× ×¢×œ-×™×“×™ ×ž×¨×›×– ×¢×œ×•×™×•×ª',0),(147585,4100,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Î±Ï€ÏŒ Ï„Î¿ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(147586,4100,'zh','æŒ‰æˆæœ¬ä¸­å¿ƒæ‘˜è¦\r\n',0),(147587,4100,'sv','Sammanfattning av kostnadsstÃ¤lle',0),(147588,4100,'it','Riepilogo di centro di costo',0),(147589,4100,'tl','',0),(147590,4100,'th','&#3626;&#3619;&#3640;&#3611;&#3650;&#3604;&#3618;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;',0),(147591,4100,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(147592,4100,'ms','Ringkasan oleh Pusat kos',0),(147593,4100,'ar','Ù…Ù„Ø®Ù‘Øµ Ø¨Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(147594,4100,'fr','RÃ©sumÃ© par centre de coÃ»ts',0),(147595,4100,'jp','ã‚³ã‚¹ãƒˆã‚»ãƒ³ã‚¿ãƒ¼ã?®ã‚µãƒžãƒªãƒ¼',0),(147596,4100,'pt','Resumo por centro de custo',0),(147597,4100,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ Ð¿Ð¾ ÐœÐ’Ð—',0),(147598,4100,'es','ResÃºmen por Centro de Costos',0),(147599,4100,'de','Zusammenfassung nach Kostenstelle',0),(147600,4100,'en','Summary by Cost Center',0),(147601,4101,'is','',0),(147602,4101,'dr','Ø®Ù„Ø§ØµÙ‡ Ø¨Ø§ Ø³ÙØ§Ø±Ø´ ',0),(147603,4101,'pr','Ø®Ù„Ø§ØµÙ‡ Ø¨Ø§ Ø³ÙØ§Ø±Ø´ ',0),(147604,4101,'tr','SipariÅŸ Ã–zeti',0),(147605,4101,'pl','Podsumowanie zamÃ³wienia',0),(147606,4101,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(147607,4101,'ur','ØªØ±ØªÛŒØ¨ ÙˆØ§Ø± Ø®Ù„Ø§ØµÛ',0),(147608,4101,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð¿Ð¾ Ð½Ð°Ñ€ÐµÐ´Ð±Ð¸',0),(147609,4101,'vi','Tá»•ng cá»™ng theo Ä‘Æ¡n hÃ ng',0),(147610,4101,'af','Opsomming per Bestelling',0),(147611,4101,'ro','Rezumat de ordine',0),(147612,4101,'et','Tellimuse KokkuvÃµte',0),(147613,4101,'si','Povzetek po naroÄilu',0),(147614,4101,'ba','Ringkasan oleh perintah',0),(147615,4101,'nl','Samenvatting van bestelling',0),(147616,4101,'fi','Yhteenveto tilauksesta',0),(147617,4101,'no','Sammendrag av',0),(147618,4101,'da','ResumÃ© af ordre',0),(147619,4101,'ko','ì£¼ë¬¸ ìš”ì•½',0),(147620,4101,'he','×¡×™×›×•× ×œ×¤×™ ×”×–×ž× ×”',0),(147621,4101,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Î´Î¹',0),(147622,4101,'zh','æŒ‰è®¢å•æ‘˜è¦\r\n',0),(147623,4101,'sv','Sammanfattning av Order',0),(147624,4101,'it','Riepilogo di ordine',0),(147625,4101,'tl','',0),(147626,4101,'th','&#3626;&#3619;&#3640;&#3611;&#3650;&#3604;&#3618;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(147627,4101,'hi','à¤†à¤¦à¥‡à¤¶ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(147628,4101,'ms','Ringkasan oleh perintah',0),(147629,4101,'ar','Ù…Ù„Ø®Øµ Ø­Ø³Ø¨ Ø§Ù„ØªØ±ØªÙŠØ¨',0),(147630,4101,'fr','Sommaire par ordre',0),(147631,4101,'jp','æ³¨æ–‡ã?®ã‚µãƒžãƒªãƒ¼',0),(147632,4101,'pt','Resumo por ordem',0),(147633,4101,'ru','Ð ÐµÑ„ÐµÑ€Ð°Ñ‚ Ð½Ð° Ð·Ð°ÐºÐ°Ð·',0),(147634,4101,'es','ResÃºmen por Orden',0),(147635,4101,'de','Zusammenfassung von bestellen',0),(147636,4101,'en','Summary by Order',0),(147637,4102,'is','',0),(147638,4102,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(147639,4102,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(147640,4102,'tr','Birim baÅŸÄ±na sayÄ±',0),(147641,4102,'pl','Numer na jednostkÄ™',0),(147642,4102,'bg','Ð‘Ñ€Ð¾Ð¹ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(147643,4102,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù†Ù…Ø¨Ø±',0),(147644,4102,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(147645,4102,'vi','Sá»‘ má»—i Ä‘Æ¡n vá»‹',0),(147646,4102,'af','Aantal per Eenheid',0),(147647,4102,'ro','NumÄƒr pe unitate',0),(147648,4102,'et','Arv Ã¼hiku kohta',0),(147649,4102,'si','Å tevilka na enoto',0),(147650,4102,'ba','Jumlah per Unit',0),(147651,4102,'nl','Aantal per eenheid',0),(147652,4102,'fi','MÃ¤Ã¤rÃ¤ per yksikkÃ¶',0),(147653,4102,'no','Antall per enhet',0),(147654,4102,'da','Antallet pr. enhed',0),(147655,4102,'ko','ë‹¨ìœ„ë‹¹ ìˆ˜',0),(147656,4102,'he','×ž×¡×¤×¨ ×œ×™×—×™×“×”',0),(147657,4102,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î±',0),(147658,4102,'zh','æ¯å•ä½æ•°ç›®\r\n',0),(147659,4102,'sv','Antal per enhet',0),(147660,4102,'it','Numero per unitÃ  di',0),(147661,4102,'tl','',0),(147662,4102,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(147663,4102,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤•à¤¾à¤ˆ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(147664,4102,'ms','Jumlah seunit',0),(147665,4102,'ar','Ø¹Ø¯Ø¯ ÙƒÙ„ ÙˆØ­Ø¯Ø©',0),(147666,4102,'fr','Nombre par unitÃ©',0),(147667,4102,'jp','å?˜ä½?ã?”ã?¨ã?®æ•°',0),(147668,4102,'pt','NÃºmero por unidade',0),(147669,4102,'ru','Ð§Ð¸ÑÐ»Ð¾ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(147670,4102,'es','NÃºmero por Unidad',0),(147671,4102,'de','Anzahl pro Einheit',0),(147672,4102,'en','Number per Unit',0),(147673,4103,'is','',0),(147674,4103,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ',0),(147675,4103,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ',0),(147676,4103,'tr','Yol izleme',0),(147677,4103,'pl','ProwadziÄ‡ Å›ledzenie',0),(147678,4103,'bg','ÐžÐ»Ð¾Ð²Ð¾ Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(147679,4103,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ú©ÛŒ Ù‚ÛŒØ§Ø¯Øª',0),(147680,4103,'sr','Ð¢Ñ€Ð°Ð³ Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ',0),(147681,4103,'vi','DÃ² tÃ¬m dáº«n Ä‘áº§u',0),(147682,4103,'af','Lood dop',0),(147683,4103,'ro','UrmÄƒrire de plumb',0),(147684,4103,'et','Plii jÃ¤lgimine',0),(147685,4103,'si','Svinec sledenje',0),(147686,4103,'ba','Memimpin pelacakan',0),(147687,4103,'nl','Leiden Tracking',0),(147688,4103,'fi','Lyijy seuranta',0),(147689,4103,'no','Lede sporing',0),(147690,4103,'da','Lede Tracking',0),(147691,4103,'ko','ë¦¬ë“œ ì¶”ì ',0),(147692,4103,'he','×œ×”×•×‘×™×œ ×ž×¢×§×‘',0),(147693,4103,'el','ÎŸÎ´Î·Î³Î®ÏƒÎµÎ¹ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚',0),(147694,4103,'zh','é“…è·Ÿè¸ª\r\n',0),(147695,4103,'sv','Leda spÃ¥rning',0),(147696,4103,'it','Monitoraggio dei lead',0),(147697,4103,'tl','',0),(147698,4103,'th','&#3612;&#3641;&#3657;&#3609;&#3635;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(147699,4103,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤•à¤¾ à¤¨à¥‡à¤¤à¥ƒà¤¤à¥à¤µ',0),(147700,4103,'ms','Membawa menjejaki',0),(147701,4103,'ar','ÙŠØ¤Ø¯ÙŠ ØªØªØ¨Ø¹',0),(147702,4103,'fr','Plomb de suivi',0),(147703,4103,'jp','æœ‰åŠ›é¡§å®¢ã?®ç®¡ç?†',0),(147704,4103,'pt','Chumbo de rastreamento',0),(147705,4103,'ru','ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ ÑÐ²Ð¸Ð½Ñ†Ð°',0),(147706,4103,'es','Persigue de Contactos',0),(147707,4103,'de','Lead Tracking',0),(147708,4103,'en','Lead Tracking',0),(147709,4104,'is','',0),(147710,4104,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(147711,4104,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(147712,4104,'tr','Kurulum - izleme yol',0),(147713,4104,'pl','Setup - prowadziÄ‡ Å›ledzenie',0),(147714,4104,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ð¾Ð»Ð¾Ð²Ð¾ Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(147715,4104,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ - Ú©Ú¾ÙˆØ¬ Ú©ÛŒ Ù‚ÛŒØ§Ø¯Øª',0),(147716,4104,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - Ð¾Ð»Ð¾Ð²Ð¾ Ð¿Ñ€Ð°Ñ›ÐµÑšÐ°',0),(147717,4104,'vi','Setup - DÃ² tÃ¬m',0),(147718,4104,'af','Opstelling - lood dop',0),(147719,4104,'ro','Configurare - plumb de urmÄƒrire',0),(147720,4104,'et','Seaded',0),(147721,4104,'si','Namestitev - Svinec sledenje',0),(147722,4104,'ba','Pengaturan - memimpin pelacakan',0),(147723,4104,'nl','Setup - Tracking leiden',0),(147724,4104,'fi','Asetukset - Lyijy seuranta',0),(147725,4104,'no','Oppsett - bly sporing',0),(147726,4104,'da','Setup - fÃ¸re Tracking',0),(147727,4104,'ko','ì„¤ì •-ë¦¬ë“œ ì¶”ì ',0),(147728,4104,'he','×ª×•×›× ×™×ª ×”×”×ª×§× ×” - ×œ×”×•×‘×™×œ ×ž×¢×§×‘',0),(147729,4104,'el','Î¡ÏÎ¸Î¼Î¹ÏƒÎ· - Î¼ÏŒÎ»Ï…Î²Î´Î¿ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚',0),(147730,4104,'zh','è®¾ç½® -é“…è·Ÿè¸ª\r\n',0),(147731,4104,'sv','Setup - Lead Tracking',0),(147732,4104,'it','Setup - monitoraggio dei Lead',0),(147733,4104,'tl','',0),(147734,4104,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634; - &#3609;&#3635;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(147735,4104,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤•à¤¾ à¤¨à¥‡à¤¤à¥ƒà¤¤à¥à¤µ',0),(147736,4104,'ms','Persediaan - membawa menjejaki',0),(147737,4104,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-ÙŠØ¤Ø¯ÙŠ ØªØªØ¨Ø¹',0),(147738,4104,'fr','Installation - plomb suivi',0),(147739,4104,'jp','æœ‰åŠ›é¡§å®¢ç®¡ç?†ã?®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(147740,4104,'pt','InstalaÃ§Ã£o - chumbo de rastreamento',0),(147741,4104,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° - ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ ÑÐ²Ð¸Ð½Ñ†Ð°',0),(147742,4104,'es','ConfiguraciÃ³n - Persigue de Contactos',0),(147743,4104,'de','Setup - Lead Tracking',0),(147744,4104,'en','Setup - Lead Tracking',0),(147745,4105,'is','',0),(147746,4105,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§',0),(147747,4105,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§',0),(147748,4105,'tr','BÃ¼tÃ§eleri',0),(147749,4105,'pl','BudÅ¼ety',0),(147750,4105,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð¸',0),(147751,4105,'ur','ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹)',0),(147752,4105,'sr','Ð‘ÑƒÑŸÐµÑ‚Ðµ',0),(147753,4105,'vi','NgÃ¢n sÃ¡ch',0),(147754,4105,'af','Begrotings',0),(147755,4105,'ro','Bugete',0),(147756,4105,'et','Eelarved',0),(147757,4105,'si','ProraÄuni',0),(147758,4105,'ba','Anggaran',0),(147759,4105,'nl','Begrotingen',0),(147760,4105,'fi','Budjetit',0),(147761,4105,'no','Budsjetter',0),(147762,4105,'da','Budgetter',0),(147763,4105,'ko','ì˜ˆì‚°',0),(147764,4105,'he','×ª×§×¦×™×‘×™×',0),(147765,4105,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(147766,4105,'zh','è´¢æ”¿é¢„ç®—æ¡ˆ\r\n',0),(147767,4105,'sv','Budgetar',0),(147768,4105,'it','Bilanci',0),(147769,4105,'tl','',0),(147770,4105,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(147771,4105,'hi','à¤¬à¤œà¤Ÿ',0),(147772,4105,'ms','Belanjawan',0),(147773,4105,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª',0),(147774,4105,'fr','Budgets',0),(147775,4105,'jp','äºˆç®—',0),(147776,4105,'pt','OrÃ§amentos',0),(147777,4105,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ñ‹',0),(147778,4105,'es','Presupuestos',0),(147779,4105,'de','Haushalte',0),(147780,4105,'en','Budgets',0),(147781,4106,'is','',0),(147782,4106,'dr','Ù…Ø¨Ù„Øº ÙƒÙ„',0),(147783,4106,'pr','Ù…Ø¨Ù„Øº ÙƒÙ„',0),(147784,4106,'tr','Genel toplam',0),(147785,4106,'pl','OgÃ³Å‚em',0),(147786,4106,'bg','ÐžÐ±Ñ‰Ð° ÑÑƒÐ¼Ð°',0),(147787,4106,'ur','Ø¨Ú‘Ø§ Ù…ÛŒØ²Ø§Ù†',0),(147788,4106,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ð·Ð±Ð¸Ñ€',0),(147789,4106,'vi','Tá»•ng sá»‘ ',0),(147790,4106,'af','Groot Totaal',0),(147791,4106,'ro','Marele Total',0),(147792,4106,'et','KÃµik kokku',0),(147793,4106,'si','Skupno vsoto',0),(147794,4106,'ba','Grand Total',0),(147795,4106,'nl','Eindtotaal',0),(147796,4106,'fi','Loppusumma',0),(147797,4106,'no','Totalsum',0),(147798,4106,'da','Hovedtotal',0),(147799,4106,'ko','ê·¸ëžœë“œ ì´',0),(147800,4106,'he','×”×¡×›×•× ×”×›×•×œ×œ',0),(147801,4106,'el','Î“ÎµÎ½Î¹ÎºÏŒ ÏƒÏÎ½Î¿Î»Î¿',0),(147802,4106,'zh','ç´¯è®¡\r\n',0),(147803,4106,'sv','Totalsumma',0),(147804,4106,'it','Totale complessivo',0),(147805,4106,'tl','',0),(147806,4106,'th','&#3618;&#3629;&#3604;&#3648;&#3591;&#3636;&#3609;',0),(147807,4106,'hi','à¤®à¤¹à¤¾à¤¯à¥‹à¤—',0),(147808,4106,'ms','Jumlah besar-besaran',0),(147809,4106,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙƒÙ„ÙŠ',0),(147810,4106,'fr','Total gÃ©nÃ©ral',0),(147811,4106,'jp','ç·?è¨ˆ',0),(147812,4106,'pt','Total geral',0),(147813,4106,'ru','ÐžÐ±Ñ‰Ð¸Ð¹ Ð¸Ñ‚Ð¾Ð³',0),(147814,4106,'es','Gran Total',0),(147815,4106,'de','Gesamtsumme',0),(147816,4106,'en','Grand Total',0),(147817,4107,'is','',0),(147818,4107,'dr','Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù†Ù‡ ',0),(147819,4107,'pr','Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù†Ù‡ ',0),(147820,4107,'tr','Stoktan deÄŸil',0),(147821,4107,'pl','Nie z magazynu',0),(147822,4107,'bg','ÐÐµ Ð¾Ñ‚ ÑÐºÐ»Ð°Ð´',0),(147823,4107,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø³Û’ Ù†ÛÛŒÚº',0),(147824,4107,'sr','ÐÐµ Ð¸Ð· Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(147825,4107,'vi','KhÃ´ng Pháº£i HÃ ng Trong Kho',0),(147826,4107,'af','Nie Vanuit Voorraad',0),(147827,4107,'ro','Nu din inventar',0),(147828,4107,'et','Mitte maha',0),(147829,4107,'si','Ne iz zaloge',0),(147830,4107,'ba','Bukan dari persediaan',0),(147831,4107,'nl','Niet uit voorraad',0),(147832,4107,'fi','Ei varastosta',0),(147833,4107,'no','Ikke fra lageret',0),(147834,4107,'da','Ikke fra lageret',0),(147835,4107,'ko','ìž¬ê³ ì—ì„œ',0),(147836,4107,'he','×œ× ×ž×Ÿ ×”×ž×œ××™',0),(147837,4107,'el','Î”ÎµÎ½ Î±Ï€ÏŒ Ï„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(147838,4107,'zh','ä¸æ¥è‡ªåº“å­˜\r\n',0),(147839,4107,'sv','Inte frÃ¥n lagret',0),(147840,4107,'it','Non dall\'inventario',0),(147841,4107,'tl','',0),(147842,4107,'th','&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3592;&#3634;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(147843,4107,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥‡ à¤¨à¤¹à¥€à¤‚',0),(147844,4107,'ms','Bukan daripada inventori',0),(147845,4107,'ar','Ù„ÙŠØ³ Ù…Ù† Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(147846,4107,'fr','Pas de stock',0),(147847,4107,'jp','åœ¨åº«ã?‹ã‚‰ã?§ã?¯ã?ªã??',0),(147848,4107,'pt','NÃ£o de inventÃ¡rio',0),(147849,4107,'ru','ÐÐµ Ð¸Ð· ÐºÐ°Ð´Ð°ÑÑ‚Ñ€Ð°',0),(147850,4107,'es','No de Inventario',0),(147851,4107,'de','Nicht aus dem Lager',0),(147852,4107,'en','Not From Inventory',0),(147853,4108,'is','',0),(147854,4108,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… ÙƒØ§Ø±Ø§ÙƒØªØ± ',0),(147855,4108,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… ÙƒØ§Ø±Ø§ÙƒØªØ± ',0),(147856,4108,'tr','Max karakter',0),(147857,4108,'pl','Max znakÃ³w',0),(147858,4108,'bg','ÐœÐ°ÐºÑ Ð·Ð½Ð°Ñ†Ð¸',0),(147859,4108,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ú©Ø±ÛŒÚ©Ù¹Ø±',0),(147860,4108,'sr','ÐœÐ°x Ð·Ð½Ð°ÐºÐ¾Ð²Ð°',0),(147861,4108,'vi','KÃ½ tá»± tá»‘i Ä‘a',0),(147862,4108,'af','Maks Karakters',0),(147863,4108,'ro','Max caractere',0),(147864,4108,'et','Maksimaalselt mÃ¤rke',0),(147865,4108,'si','Max znakov',0),(147866,4108,'ba','Max karakter',0),(147867,4108,'nl','Max tekens',0),(147868,4108,'fi','Max merkkiÃ¤',0),(147869,4108,'no','Max tegn',0),(147870,4108,'da','Max tegn',0),(147871,4108,'ko','ìµœëŒ€ ë¬¸ìž',0),(147872,4108,'he','×ž×§×¡ ×ª×•×•×™×',0),(147873,4108,'el','Î§Î±ÏÎ±ÎºÏ„Î®ÏÎµÏ‚ Max',0),(147874,4108,'zh','æœ€å¤§ç¬¦å·\r\n',0),(147875,4108,'sv','Max tecken',0),(147876,4108,'it','Max caratteri',0),(147877,4108,'tl','',0),(147878,4108,'th','&#3605;&#3633;&#3623;&#3629;&#3633;&#3585;&#3625;&#3619;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(147879,4108,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤µà¤°à¥à¤£',0),(147880,4108,'ms','Watak-watak Max',0),(147881,4108,'ar','Ø£Ø­Ø±Ù Ù…Ø§ÙƒØ³',0),(147882,4108,'fr','CaractÃ¨res max',0),(147883,4108,'jp','æœ€å¤§æ–‡å­—æ•°',0),(147884,4108,'pt','Personagens Max',0),(147885,4108,'ru','ÐœÐ°ÐºÑ ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¾Ð²',0),(147886,4108,'es','Max CarÃ¡cteres',0),(147887,4108,'de','Max. Zeichen',0),(147888,4108,'en','Max Characters',0),(147889,4109,'is','',0),(147890,4109,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª ',0),(147891,4109,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª ',0),(147892,4109,'tr','Web sitesi',0),(147893,4109,'pl','Strona internetowa',0),(147894,4109,'bg','Ð£ÐµÐ±ÑÐ°Ð¹Ñ‚',0),(147895,4109,'ur','ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹',0),(147896,4109,'sr','WÐµÐ± Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(147897,4109,'vi','Trang Web',0),(147898,4109,'af','Webwerf',0),(147899,4109,'ro','Site-ul',0),(147900,4109,'et','Veebileht',0),(147901,4109,'si','Spletna stran',0),(147902,4109,'ba','Situs web',0),(147903,4109,'nl','Website',0),(147904,4109,'fi','Sivusto',0),(147905,4109,'no','Nettsted',0),(147906,4109,'da','Hjemmeside',0),(147907,4109,'ko','ì›¹ì‚¬ì´íŠ¸',0),(147908,4109,'he','××ª×¨',0),(147909,4109,'el','Î™ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î±',0),(147910,4109,'zh','ç½‘ç«™\r\n',0),(147911,4109,'sv','Hemsida',0),(147912,4109,'it','Sito Web',0),(147913,4109,'tl','',0),(147914,4109,'th','&#3648;&#3623;&#3655;&#3611;&#3652;&#3595;&#3604;&#3660;',0),(147915,4109,'hi','à¤µà¥‡à¤¬à¤¸à¤¾à¤‡à¤Ÿ',0),(147916,4109,'ms','Laman web',0),(147917,4109,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø¨ÙƒØ© Ø§Ù„Ø¹Ù†ÙƒØ¨ÙˆØªÙŠØ©',0),(147918,4109,'fr','Site Web',0),(147919,4109,'jp','ã‚¦ã‚§ãƒ–ã‚µã‚¤ãƒˆ',0),(147920,4109,'pt','Site',0),(147921,4109,'ru','Ð’ÐµÐ±-ÑÐ°Ð¹Ñ‚',0),(147922,4109,'es','Sitio Web',0),(147923,4109,'de','Webseite',0),(147924,4109,'en','Website',0),(147925,4110,'is','',0),(147926,4110,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(147927,4110,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(147928,4110,'tr','MÃ¼ÅŸteri listesi',0),(147929,4110,'pl','Lista klientÃ³w',0),(147930,4110,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(147931,4110,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ÙÛØ±Ø³Øª',0),(147932,4110,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(147933,4110,'vi','Danh sÃ¡ch KhÃ¡ch hÃ ng',0),(147934,4110,'af','Klant / KliÃ«nt Lyste',0),(147935,4110,'ro','Lista de client',0),(147936,4110,'et','Klientide nimekirjad',0),(147937,4110,'si','Seznam kupcev',0),(147938,4110,'ba','Daftar pelanggan',0),(147939,4110,'nl','Klantenlijst',0),(147940,4110,'fi','Asiakasluettelo',0),(147941,4110,'no','Kundeoversikt',0),(147942,4110,'da','Kundeliste',0),(147943,4110,'ko','ê³ ê° ëª©ë¡',0),(147944,4110,'he','×¨×©×™×ž×ª ×œ×§×•×—×•×ª',0),(147945,4110,'el','Î ÎµÎ»Î±Ï„Î¿Î»ÏŒÎ³Î¹Î¿',0),(147946,4110,'zh','å®¢æˆ·åå•\r\n',0),(147947,4110,'sv','Kundlista',0),(147948,4110,'it','Elenco dei clienti',0),(147949,4110,'tl','',0),(147950,4110,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(147951,4110,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‚à¤šà¥€',0),(147952,4110,'ms','Senarai pelanggan',0),(147953,4110,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(147954,4110,'fr','Liste des clients',0),(147955,4110,'jp','é¡§å®¢ãƒªã‚¹ãƒˆ',0),(147956,4110,'pt','Lista de clientes',0),(147957,4110,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(147958,4110,'es','Cliente Listas',0),(147959,4110,'de','Kundenliste',0),(147960,4110,'en','Customer List',0),(147961,4111,'is','',0),(147962,4111,'dr','Ø­Ø³Ø§Ø¨ Ø®Ø§Ù†Ù‡ ',0),(147963,4111,'pr','Ø­Ø³Ø§Ø¨ Ø®Ø§Ù†Ù‡ ',0),(147964,4111,'tr','Evi hesabÄ±nÄ±',0),(147965,4111,'pl','Dom konta',0),(147966,4111,'bg','ÐšÑŠÑ‰Ð°Ñ‚Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð°',0),(147967,4111,'ur','Ú¯Ú¾Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(147968,4111,'sr','ÐšÑƒÑ›Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(147969,4111,'vi','TK nhÃ ',0),(147970,4111,'af','Huis rekening',0),(147971,4111,'ro','Contul de casa',0),(147972,4111,'et','Maja konto',0),(147973,4111,'si','HiÅ¡a raÄun',0),(147974,4111,'ba','Rumah Account',0),(147975,4111,'nl','Huis Account',0),(147976,4111,'fi','Talon tilille',0),(147977,4111,'no','Kontoen',0),(147978,4111,'da','House konto',0),(147979,4111,'ko','ì§‘ ê³„ì •',0),(147980,4111,'he','×—×©×‘×•×Ÿ ×”×‘×™×ª',0),(147981,4111,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÏ„Î¿ ÏƒÏ€Î¯Ï„Î¹',0),(147982,4111,'zh','æˆ¿å­æˆ·å£\r\n',0),(147983,4111,'sv','Hus konto',0),(147984,4111,'it','Casa conto',0),(147985,4111,'tl','',0),(147986,4111,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(147987,4111,'hi','à¤¹à¤¾à¤‰à¤¸ à¤–à¤¾à¤¤à¥‡',0),(147988,4111,'ms','Akaun rumah',0),(147989,4111,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨ÙŠØª',0),(147990,4111,'fr','Compte de la maison',0),(147991,4111,'jp','ãƒ?ã‚¦ã‚¹ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(147992,4111,'pt','Conta de casa',0),(147993,4111,'ru','Ð”Ð¾Ð¼ ÑÑ‡ÐµÑ‚Ð°',0),(147994,4111,'es','Cuenta de Casa',0),(147995,4111,'de','Haus-Konto',0),(147996,4111,'en','House Account',0),(147997,4112,'is','',0),(147998,4112,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø±Ø§ Ø§ÙƒÙ†ÙˆÙ† Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(147999,4112,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø±Ø§ Ø§ÙƒÙ†ÙˆÙ† Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(148000,4112,'tr','Yeni satÄ±cÄ± taÅŸÄ±yÄ±cÄ± olarak seÃ§',0),(148001,4112,'pl','Wybierz nowego dostawcy jako noÅ›nik',0),(148002,4112,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð² Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÐºÐ°Ñ‚Ð¾ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(148003,4112,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± Ú†Ù†ÛŒÚº',0),(148004,4112,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸ Ð½Ð¾Ð²Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÐºÐ°Ð¾ Ð½Ð¾ÑÐ°Ñ‡',0),(148005,4112,'vi','Chá»n ngÆ°á»i bÃ¡n lÃ  hÃ£ng váº­n chuyá»ƒn',0),(148006,4112,'af','Kies \'n Nuwe Verskaffer as \'n Karweier',0),(148007,4112,'ro','Alege noul furnizor ca operator de transport',0),(148008,4112,'et','Vali uus tarnija vedajana',0),(148009,4112,'si','Izbrati novega dobavitelja kot prevoznik',0),(148010,4112,'ba','Memilih Vendor baru sebagai pembawa',0),(148011,4112,'nl','Kies nieuwe leverancier als drager',0),(148012,4112,'fi','Valitse uuden toimittajan harjoittaja',0),(148013,4112,'no','Velg leverandÃ¸r som bÃ¦rer',0),(148014,4112,'da','VÃ¦lg ny kreditor som transportÃ¸r',0),(148015,4112,'ko','ìºë¦¬ì–´ë¡œ ìƒˆ ê³µê¸‰ ì—…ì²´ë¥¼ ì„ íƒ',0),(148016,4112,'he','×œ×‘×—×•×¨ ×¡×¤×§ ×—×“×© ×›× ×©×',0),(148017,4112,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î½Î­Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï‰Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±Ï‚',0),(148018,4112,'zh','æŒ‘é€‰æ–°çš„ä¾›åº”å•†ä¸ºæ‰¿è¿å•†\r\n',0),(148019,4112,'sv','VÃ¤lj ny leverantÃ¶r som bÃ¤rare',0),(148020,4112,'it','Scegliere nuovo fornitore come elemento portante',0),(148021,4112,'tl','',0),(148022,4112,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3648;&#3611;&#3655;&#3609;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(148023,4112,'hi','à¤•à¥ˆà¤°à¤¿à¤¯à¤° à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤‰à¤ à¤¾à¤“',0),(148024,4112,'ms','Memilih pembekal baru sebagai pengangkut',0),(148025,4112,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø¨Ø§Ø¦Ø¹ Ø¬Ø¯ÙŠØ¯ ÙƒØ§Ù„Ù†Ø§Ù‚Ù„',0),(148026,4112,'fr','Choisissez nouveau vendeur comme transporteur',0),(148027,4112,'jp','é…?é€?æ¥­è€…ã?¨ã?—ã?¦æ–°è¦?æ¥­è€…ã‚’é?¸æŠž',0),(148028,4112,'pt','Escolher novo fornecedor como portador',0),(148029,4112,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐÐ¾Ð²Ð¾Ð³Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° ÐºÐ°Ðº ÐšÑƒÑ€ÑŒÐµÑ€Ð°',0),(148030,4112,'es','Seleccionar Nuevo Proveedor como Transportador',0),(148031,4112,'de','WÃ¤hlen Sie neue Anbieter als TrÃ¤ger',0),(148032,4112,'en','Pick New Vendor as Carrier',0),(148033,4113,'is','',0),(148034,4113,'dr','Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(148035,4113,'pr','Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(148036,4113,'tr','AlÄ±nan',0),(148037,4113,'pl','PodjÄ™te',0),(148038,4113,'bg','Ð’Ð·ÐµÑ‚Ð¸',0),(148039,4113,'ur','Ù„Û’ Ù„ÛŒØ§',0),(148040,4113,'sr','Ð£Ð·ÐµÐ¾',0),(148041,4113,'vi','ÄÃ£ láº¥y',0),(148042,4113,'af','Geneem',0),(148043,4113,'ro','Luate',0),(148044,4113,'et','VÃµetud',0),(148045,4113,'si','Sprejeti',0),(148046,4113,'ba','Diambil',0),(148047,4113,'nl','Genomen',0),(148048,4113,'fi','Ottaa',0),(148049,4113,'no','Tatt',0),(148050,4113,'da','Taget',0),(148051,4113,'ko','ì´¬ì˜',0),(148052,4113,'he','× ×œ×§×—',0),(148053,4113,'el','Î›Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹',0),(148054,4113,'zh','è¢«æ‹¿\r\n',0),(148055,4113,'sv','Tagit',0),(148056,4113,'it','Preso',0),(148057,4113,'tl','',0),(148058,4113,'th','&#3607;&#3635;&#3649;&#3621;&#3657;&#3623;',0),(148059,4113,'hi','à¤²à¥‡ à¤²à¤¿à¤¯à¤¾',0),(148060,4113,'ms','Diambil',0),(148061,4113,'ar','Ø§ØªØ®Ø°Øª',0),(148062,4113,'fr','Prises',0),(148063,4113,'jp','å?–ã‚‰ã‚Œã?¦ã?„ã‚‹',0),(148064,4113,'pt','Tomadas',0),(148065,4113,'ru','ÐŸÑ€Ð¸Ð½ÑÑ‚Ð¾',0),(148066,4113,'es','Tomado',0),(148067,4113,'de','Genommen',0),(148068,4113,'en','Taken',0),(148069,4114,'is','',0),(148070,4114,'dr','(Ù‚Ø³Ù…ØªÙ‡Ø§',0),(148071,4114,'pr','Ù‚Ø·Ø¹Ø§Øª (Ù‚Ø³Ù…ØªÙ‡Ø§',0),(148072,4114,'tr','ParÃ§alarÄ±',0),(148073,4114,'pl','KawaÅ‚ki',0),(148074,4114,'bg','ÐŸÐ°Ñ€Ñ‡ÐµÑ‚Ð°',0),(148075,4114,'ur','Ù¹Ú©Ú‘Û’ Ù¹Ú©Ú‘Û’',0),(148076,4114,'sr','ÐšÐ¾Ð¼Ð°Ð´Ðµ',0),(148077,4114,'vi','Miáº¿ng',0),(148078,4114,'af','Stukke',0),(148079,4114,'ro','Piese',0),(148080,4114,'et','TÃ¼kid',0),(148081,4114,'si','Kosov',0),(148082,4114,'ba','Potongan-potongan',0),(148083,4114,'nl','Stukken',0),(148084,4114,'fi','Kappaletta',0),(148085,4114,'no','Stykker',0),(148086,4114,'da','Stykker',0),(148087,4114,'ko','ì¡°ê°',0),(148088,4114,'he','×—×ª×™×›×•×ª',0),(148089,4114,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹Î±',0),(148090,4114,'zh','ç‰‡\r\n',0),(148091,4114,'sv','Bitar',0),(148092,4114,'it','Pezzi',0),(148093,4114,'tl','',0),(148094,4114,'th','&#3594;&#3636;&#3657;&#3609;',0),(148095,4114,'hi','à¤Ÿà¥à¤•à¤¡à¤¼à¥‡',0),(148096,4114,'ms','Keping',0),(148097,4114,'ar','Ù‚Ø·Ø¹Ø©',0),(148098,4114,'fr','PiÃ¨ces',0),(148099,4114,'jp','éƒ¨åˆ†',0),(148100,4114,'pt','PeÃ§as',0),(148101,4114,'ru','Ð¨Ñ‚ÑƒÐº',0),(148102,4114,'es','Pedazos',0),(148103,4114,'de','StÃ¼cke',0),(148104,4114,'en','Pieces',0),(148105,4115,'is','',0),(148106,4115,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ¹Ø§Ù„ÙŠØª ',0),(148107,4115,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ¹Ø§Ù„ÙŠØª ',0),(148108,4115,'tr','Eylem tarihi',0),(148109,4115,'pl','Historia dziaÅ‚aÅ„',0),(148110,4115,'bg','Ð¥Ñ€Ð¾Ð½Ð¾Ð»Ð¾Ð³Ð¸Ñ Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸ÑÑ‚Ð°',0),(148111,4115,'ur','Ø¹Ù…Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(148112,4115,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ Ñ€Ð°Ð´ÑšÐ¸',0),(148113,4115,'vi','Lá»‹ch Sá»­ HÃ nh Äá»™ng',0),(148114,4115,'af','Aksie',0),(148115,4115,'ro','Istoricul actiunii',0),(148116,4115,'et','Toiminguajalugu',0),(148117,4115,'si','Zgodovina dejanja',0),(148118,4115,'ba','Kronologi Tindakan',0),(148119,4115,'nl','Actie geschiedenis',0),(148120,4115,'fi','Toimintahistoria',0),(148121,4115,'no','Handlingslogg',0),(148122,4115,'da','Handling historie',0),(148123,4115,'ko','ì•¡ì…˜ ì—­ì‚¬',0),(148124,4115,'he','×”×™×¡×˜×•×¨×™×™×ª ×¤×¢×•×œ×”',0),(148125,4115,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ ÎµÎ½ÎµÏÎ³ÎµÎ¹ÏŽÎ½',0),(148126,4115,'zh','åŠ¨ä½œå²\r\n',0),(148127,4115,'sv','Ã…tgÃ¤rd historia',0),(148128,4115,'it','Storico delle azioni',0),(148129,4115,'tl','',0),(148130,4115,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(148131,4115,'hi','à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(148132,4115,'ms','Sejarah tindakan',0),(148133,4115,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¹Ù…Ù„',0),(148134,4115,'fr','Historique d\'Action',0),(148135,4115,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³å±¥æ­´',0),(148136,4115,'pt','HistÃ³ria de aÃ§Ã£o',0),(148137,4115,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹',0),(148138,4115,'es','AcciÃ³n HistÃ³rico',0),(148139,4115,'de','Aktion-Geschichte',0),(148140,4115,'en','Action History',0),(148141,4116,'is','',0),(148142,4116,'dr',' Ù…Ø·Ø§Ø¨Ù‚ØªÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(148143,4116,'pr',' Ù…Ø·Ø§Ø¨Ù‚ØªÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(148144,4116,'tr','Bu eÅŸleÅŸme arama seÃ§enekleri.',0),(148145,4116,'pl','OdpowiednikÃ³w dla tych opcji wyszukiwania.',0),(148146,4116,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ñ Ð·Ð° Ñ‚ÐµÐ·Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ.',0),(148147,4116,'ur','Ø§Ù† Ù„ÙˆÚ¯ÙˆÚº Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº Ø§Ø®ØªÛŒØ§Ø±Ø§Øª ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº Û”',0),(148148,4116,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð·Ð° Ð¾Ð½Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°.',0),(148149,4116,'vi','KhÃ´ng tÃ¬m tháº¥y theo tiÃªu chÃ­ tÃ¬m kiáº¿m',0),(148150,4116,'af','Geen pasmaats vir diÃ© soek opsies.',0),(148151,4116,'ro','Nicio potrivire pentru cei opÅ£iuni de cÄƒutare.',0),(148152,4116,'et','Vastavusi neile otsinguvÃµimalusi.',0),(148153,4116,'si','Ni zadetkov za tiste moÅ¾nosti iskanja.',0),(148154,4116,'ba','Tidak cocok untuk orang-orang pilihan pencarian.',0),(148155,4116,'nl','Geen wedstrijden voor degenen zoeken opties.',0),(148156,4116,'fi','Ei hakutuloksia niiden hakuvaihtoehtoja.',0),(148157,4116,'no','Ingen treff for de sÃ¸ke valgmulighetene.',0),(148158,4116,'da','Ingen kampe for dem sÃ¸gemuligheder.',0),(148159,4116,'ko','ê·¸ì— ëŒ€ í•œ ì¼ì¹˜ ê²€ìƒ‰ ì˜µì…˜.',0),(148160,4116,'he','. ××™×Ÿ ×”×ª××ž×•×ª ×¢×‘×•×¨ ××œ×” ×—×™×¤×•×© ××¤×©×¨×•×™×•×ª.',0),(148161,4116,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÏƒÏ…Î¼Ï†Ï‰Î½Î¯ÎµÏ‚ Î³Î¹Î± ÎµÎºÎµÎ¯Î½Î¿Ï…Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚.',0),(148162,4116,'zh','ä¸Žæœç´¢é€‰é¡¹ä¸åŒ¹é…ã€‚\r\n',0),(148163,4116,'sv','Inga matcher fÃ¶r dem sÃ¶ka optionerna.',0),(148164,4116,'it','Nessun risultato per queste opzioni di ricerca.',0),(148165,4116,'tl','',0),(148166,4116,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(148167,4116,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤‰à¤¨ à¤²à¥‹à¤—à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ à¤µà¤¿à¤•à¤²à¥à¤ªà¥¤',0),(148168,4116,'ms','Tiada padanan bagi orang-orang pilihan carian.',0),(148169,4116,'ar','Ø§Ù„Ø¨Ø­Ø« Ù„Ø§ ÙŠØ·Ø§Ø¨Ù‚ Ù„ØªÙ„Ùƒ Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª.',0),(148170,4116,'fr','Aucune correspondance pour les options de recherche.',0),(148171,4116,'jp','ã??ã‚Œã‚‰ã?®æ¤œç´¢ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?«ã?¯ä¸€è‡´ã?™ã‚‹ã‚‚ã?®ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(148172,4116,'pt','Nenhuma correspondÃªncia para as opÃ§Ãµes de busca.',0),(148173,4116,'ru','ÐÐµÑ‚ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¸Ð¹ Ð´Ð»Ñ ÑÑ‚Ð¸Ñ… Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð² Ð¿Ð¾Ð¸ÑÐºÐ°.',0),(148174,4116,'es','No habÃ­a equivalencias para estas opciones de busqueda',0),(148175,4116,'de','Keine Treffer fÃ¼r diejenigen Suchoptionen.',0),(148176,4116,'en','No matches for those search options.',0),(148177,4117,'is','',0),(148178,4117,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ Ø¯ÙŠÚ¯Ø± ',0),(148179,4117,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ Ø¯ÙŠÚ¯Ø± ',0),(148180,4117,'tr','BaÅŸka bir kategori seÃ§in',0),(148181,4117,'pl','Wybierz innÄ… kategoriÄ™',0),(148182,4117,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ñ€ÑƒÐ³Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(148183,4117,'ur','Ø§ÛŒÚ© Ù‚Ø³Ù… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(148184,4117,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(148185,4117,'vi','Chá»n thá»ƒ loáº¡i khÃ¡c',0),(148186,4117,'af','Kies \'n Ander Kategorie',0),(148187,4117,'ro','SelectaÅ£i o altÄƒ categorie',0),(148188,4117,'et','Valige mÃµni muu kategooria',0),(148189,4117,'si','Izberite drugo kategorijo',0),(148190,4117,'ba','Pilih kategori lain',0),(148191,4117,'nl','Selecteer een andere categorie',0),(148192,4117,'fi','Valitse jokin toinen luokka',0),(148193,4117,'no','Velg en annen kategori',0),(148194,4117,'da','VÃ¦lg en anden kategori',0),(148195,4117,'ko','ë‹¤ë¥¸ ì¹´í…Œê³ ë¦¬ ì„ íƒ',0),(148196,4117,'he','×‘×—×¨ ×¢×•×“ ×§×˜×’×•×¨×™×”',0),(148197,4117,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î¬Î»Î»Î· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(148198,4117,'zh','é€‰æ‹©å…¶ä»–ç±»åˆ«\r\n',0),(148199,4117,'sv','VÃ¤lj en annan kategori',0),(148200,4117,'it','Selezionare un\'altra categoria',0),(148201,4117,'tl','',0),(148202,4117,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3629;&#3639;&#3656;&#3609;&#3654;',0),(148203,4117,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(148204,4117,'ms','Pilih kategori lain',0),(148205,4117,'ar','Ø¥Ø®ØªÙŠØ§Ø± ØªØµÙ†ÙŠÙ Ø¢Ø®Ø±',0),(148206,4117,'fr','SÃ©lectionner une autre catÃ©gorie',0),(148207,4117,'jp','ä»–ã?®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®é?¸æŠž',0),(148208,4117,'pt','Selecione outra categoria',0),(148209,4117,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³ÑƒÑŽ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(148210,4117,'es','Seleccionar Otra CategorÃ­a',0),(148211,4117,'de','WÃ¤hlen Sie eine andere Kategorie',0),(148212,4117,'en','Select Another Category',0),(148213,4118,'is','',0),(148214,4118,'dr','Ø¨Ù‡Ø±Ù‡ Ø§ÙˆÙ„ÙŠÙ‡',0),(148215,4118,'pr','Ø¨Ù‡Ø±Ù‡ Ø§ÙˆÙ„ÙŠÙ‡',0),(148216,4118,'tr','Ã–nceden faiz',0),(148217,4118,'pl','WczeÅ›niejsze zainteresowania',0),(148218,4118,'bg','Ð Ð°Ð½ÐµÐ½ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(148219,4118,'ur','Ù¾ÛŒØ´Ú¯ÛŒ Ø¯Ù„Ú†Ø³Ù¾ÛŒ',0),(148220,4118,'sr','Ð˜Ð³ÑƒÐ¼Ð°Ð½ ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(148221,4118,'vi','LÃ£i suáº¥t trÆ°á»›c',0),(148222,4118,'af','Vorige Rente',0),(148223,4118,'ro','ÃŽnainte de interes',0),(148224,4118,'et','Eelnev huvi',0),(148225,4118,'si','Predhodno obresti',0),(148226,4118,'ba','Bunga sebelumnya',0),(148227,4118,'nl','Voorafgaande belang',0),(148228,4118,'fi','EtukÃ¤teen kiinnostusta',0),(148229,4118,'no','Tidligere interesse',0),(148230,4118,'da','ForudgÃ¥ende interesse',0),(148231,4118,'ko','ì´ì „ ê´€ì‹¬',0),(148232,4118,'he','×¨×™×‘×™×ª ×ž×•×§×“×ž×ª',0),(148233,4118,'el','Î¤ÏÎ¬Î²Î·Î¾Îµ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¿Ï‡Î®',0),(148234,4118,'zh','ä¼˜å…ˆåˆ©æ¯\r\n',0),(148235,4118,'sv','Tidigare intresse',0),(148236,4118,'it','Interesse precedente',0),(148237,4118,'tl','',0),(148238,4118,'th','&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3607;&#3637;&#3656;&#3617;&#3637;&#3617;&#3634;&#3585;&#3656;&#3629;&#3609;',0),(148239,4118,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤¬à¥à¤¯à¤¾à¤œ',0),(148240,4118,'ms','Faedah terlebih dahulu',0),(148241,4118,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(148242,4118,'fr','IntÃ©rÃªt antÃ©rieur',0),(148243,4118,'jp','ä»¥å‰?ã?®åˆ©å­?',0),(148244,4118,'pt','Interesse prÃ©vio',0),(148245,4118,'ru','Ð Ð°Ð½ÐµÐµ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(148246,4118,'es','InterÃ©ses Anteriores',0),(148247,4118,'de','Vorherige Interesse',0),(148248,4118,'en','Prior Interest',0),(148249,4119,'is','',0),(148250,4119,'dr','Ø±ÙˆÙŠ ÙØ§ÙƒØªÙˆØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¢Ù†Ø±Ø§ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ†ÙŠØ¯',0),(148251,4119,'pr','Ø±ÙˆÙŠ ÙØ§ÙƒØªÙˆØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¢Ù†Ø±Ø§ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ†ÙŠØ¯',0),(148252,4119,'tr','Fatura dÃ¼zenlemek iÃ§in tÄ±klatÄ±n',0),(148253,4119,'pl','Kliknij na fakturze do edycji',0),(148254,4119,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(148255,4119,'ur','Ù¾Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(148256,4119,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(148257,4119,'vi','Nháº¥n VÃ o HÃ³a ÄÆ¡n Äá»ƒ Sá»­a',0),(148258,4119,'af','Kliek op Faktuur om te Redigeer',0),(148259,4119,'ro','FaceÅ£i clic pe facturÄƒ pentru a edita',0),(148260,4119,'et','Muutmiseks klÃµpsa arvele',0),(148261,4119,'si','Kliknite na raÄunu za urejanje',0),(148262,4119,'ba','Klik pada faktur untuk mengedit',0),(148263,4119,'nl','Klik op factuur om te bewerken',0),(148264,4119,'fi','Klikkaa laskun muokkaaminen',0),(148265,4119,'no','Klikk pÃ¥ faktura redigere',0),(148266,4119,'da','Klik pÃ¥ faktura til at redigere',0),(148267,4119,'ko','ì†¡ìž¥ íŽ¸ì§‘ì„ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(148268,4119,'he','×œ×—×¥ ×¢×œ ×”×—×©×‘×•× ×™×ª ×›×“×™ ×œ×¢×¨×•×š',0),(148269,4119,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿, Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(148270,4119,'zh','åœ¨å‘ç¥¨ä¸Šç‚¹å‡»ä»¥ç¼–è¾‘\r\n',0),(148271,4119,'sv','Klicka pÃ¥ fakturan att redigera',0),(148272,4119,'it','Fare clic su fattura per modificare',0),(148273,4119,'tl','',0),(148274,4119,'th','&#3588;&#3621;&#3636;&#3585;&#3610;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(148275,4119,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤ªà¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(148276,4119,'ms','Klik pada invois untuk mengedit',0),(148277,4119,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ ÙØ§ØªÙˆØ±Ø© ØªØ­Ø±ÙŠØ±',0),(148278,4119,'fr','Cliquez sur facture Ã©diter',0),(148279,4119,'jp','è«‹æ±‚æ›¸ã‚’ç·¨é›†ã?™ã‚‹',0),(148280,4119,'pt','Clique na factura para editar',0),(148281,4119,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð½Ð° Ð¡Ñ‡ÐµÑ‚ Ð´Ð»Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(148282,4119,'es','Click sobre Factura para Editar',0),(148283,4119,'de','Klicken Sie auf Rechnung bearbeiten',0),(148284,4119,'en','Click on Invoice to Edit',0),(148285,4120,'is','',0),(148286,4120,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ ',0),(148287,4120,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ ',0),(148288,4120,'tr','FaturalandÄ±rÄ±lmamÄ±ÅŸ tamamlanan stok sipariÅŸleri',0),(148289,4120,'pl','ZleceÅ„ nieopÅ‚aconych wypeÅ‚niony zapasÃ³w',0),(148290,4120,'bg','Unbilled Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(148291,4120,'ur','ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„ Ù…Ú©Ù…Ù„ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(148292,4120,'sr','Ð£Ð½Ð±Ð¸Ð»Ð»ÐµÐ´ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(148293,4120,'vi','Nhá»¯ng ÄÆ¡n HÃ ng Trong Kho ÄÃ£ HoÃ n Táº¥t NhÆ°ng ChÆ°a Thanh ToÃ¡n',0),(148294,4120,'af','Ongefaktureerde Bestelde Voorraad Bestellings',0),(148295,4120,'ro','Comenzi de unbilled completat inventar',0),(148296,4120,'et','Arveldamata komplekteeritud laoorderite',0),(148297,4120,'si','Unbilled izpolnjen popis naroÄila',0),(148298,4120,'ba','Tertagih inventaris selesai pesanan',0),(148299,4120,'nl','Ongefactureerde voltooide inventaris Orders',0),(148300,4120,'fi','Unbilled valmis varaston tilaukset',0),(148301,4120,'no','Fakturert fullfÃ¸rt lagerordrer',0),(148302,4120,'da','Faktureret udfyldte lagerordrer',0),(148303,4120,'ko','ë° ì™„ë£Œ ëœ ìž¬ê³  ì£¼ë¬¸',0),(148304,4120,'he','×”×–×ž× ×•×ª ×ž×œ××™ ×©×”×•×©×œ×ž×• unbilled',0),(148305,4120,'el','Î‘Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î· Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½Î· Î±Ï€Î¿Î³ÏÎ±Ï†Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(148306,4120,'zh','æœªå…¥è´¦å®Œæ•´çš„å­˜è´§è®¢å•\r\n',0),(148307,4120,'sv','Relaterade avslutade lagerorder',0),(148308,4120,'it','AttivitÃ  non ancora fatturate completato inventario ordini',0),(148309,4120,'tl','',0),(148310,4120,'th','&#3652;&#3617;&#3656;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;&#3607;&#3637;&#3',0),(148311,4120,'hi','à¤ªà¥‚à¤°à¤¾ à¤®à¤¾à¤² unbilled à¤†à¤¦à¥‡à¤¶',0),(148312,4120,'ms','Pesanan inventori siap lepas',0),(148313,4120,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ù…ÙƒØªÙ…Ù„ ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(148314,4120,'fr','Commandes de stock terminÃ©e non facturÃ©s',0),(148315,4120,'jp','æœªè«‹æ±‚å®Œäº†æ¸ˆåœ¨åº«æ³¨æ–‡',0),(148316,4120,'pt','Ordens de inventÃ¡rio concluÃ­do nÃ£o faturada',0),(148317,4120,'ru','ÐÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ ÑÐºÐ»Ð°Ð´ÑÐºÐ¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(148318,4120,'es','Ordenes de Inventario Completados No Facturados',0),(148319,4120,'de','Noch nicht fakturierte abgeschlossenen LagerauftrÃ¤gen',0),(148320,4120,'en','Unbilled Completed Inventory Orders',0),(148321,4121,'is','',0),(148322,4121,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ ',0),(148323,4121,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ ',0),(148324,4121,'tr','FaturalandÄ±rÄ±lmamÄ±ÅŸ stok sipariÅŸleri',0),(148325,4121,'pl','ZleceÅ„ nieopÅ‚aconych zapasÃ³w',0),(148326,4121,'bg','Unbilled Ð·Ð°Ð¿Ð°ÑÐ¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(148327,4121,'ur','ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(148328,4121,'sr','Ð£Ð½Ð±Ð¸Ð»Ð»ÐµÐ´ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(148329,4121,'vi','Nhá»¯ng ÄÆ¡n HÃ ng Trong Kho ChÆ°a Thanh ToÃ¡n',0),(148330,4121,'af','Ongefaktureerde Voorraad Bestellings',0),(148331,4121,'ro','Comenzi de unbilled stoc',0),(148332,4121,'et','Arveldamata laoorderite',0),(148333,4121,'si','Unbilled popis naroÄila',0),(148334,4121,'ba','Tertagih persediaan pesanan',0),(148335,4121,'nl','Ongefactureerde inventaris Orders',0),(148336,4121,'fi','Unbilled varastotilauksia',0),(148337,4121,'no','Fakturert lagerordrer',0),(148338,4121,'da','Faktureret lagerordrer',0),(148339,4121,'ko','ë° ìž¬ê³  ì£¼ë¬¸',0),(148340,4121,'he','×”×–×ž× ×•×ª ×ž×œ××™ unbilled',0),(148341,4121,'el','Î‘Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î· Î±Ï€Î¿Î³ÏÎ±Ï†Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(148342,4121,'zh','æœªå…¥è´¦çš„åº“å­˜è®¢å•\r\n',0),(148343,4121,'sv','Relaterade lagerorder',0),(148344,4121,'it','AttivitÃ  non ancora fatturate inventario ordini',0),(148345,4121,'tl','',0),(148346,4121,'th','&#3652;&#3617;&#3656;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;',0),(148347,4121,'hi','à¤®à¤¾à¤² unbilled à¤†à¤¦à¥‡à¤¶',0),(148348,4121,'ms','Pesanan inventori lepas',0),(148349,4121,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(148350,4121,'fr','Commandes de stock non facturÃ©s',0),(148351,4121,'jp','æœªè«‹æ±‚åœ¨åº«æ³¨æ–‡',0),(148352,4121,'pt','Ordens de inventÃ¡rio nÃ£o faturada',0),(148353,4121,'ru','ÐÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… ÑÐºÐ»Ð°Ð´ÑÐºÐ¸Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(148354,4121,'es','Ordenes de Inventario No Facturados',0),(148355,4121,'de','Noch nicht fakturierte LagerauftrÃ¤gen',0),(148356,4121,'en','Unbilled Inventory Orders',0),(148357,4122,'is','',0),(148358,4122,'dr','(Ú†Ø§Ù¾): Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÙŠ (Ú†Ø§Ù¾) Ø¨Ø¹Ù„Ø§ÙˆÙ‡(Ø¶Ø§ÙŠØ¹Ø§Øª) Ø¨Ø±ÙŠØ¯Ù‡ ÙƒØªØ§Ø¨',0),(148359,4122,'pr','Ø´Ø±Ø­ Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÙŠ (Ú†Ø§Ù¾): Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÙŠ (Ú†Ø§Ù¾) Ø¨Ø¹Ù„Ø§ÙˆÙ‡(Ø¶Ø§ÙŠØ¹Ø§Øª) Ø¨Ø±ÙŠØ¯Ù‡ ÙƒØªØ§Ø¨',0),(148360,4122,'tr','GÃ¶sterimleri artÄ± hurda',0),(148361,4122,'pl','WraÅ¼enia oraz zÅ‚om',0),(148362,4122,'bg','Ð’Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸ÑÑ‚Ð° Ð¿Ð»ÑŽÑ ÑÐºÑ€Ð°Ð¿',0),(148363,4122,'ur','Ù†Ù‚ÙˆØ´ Ú©Û’ Ø¹Ù„Ø§ÙˆÛ Ø³Ú©Ø±ÛŒÙ¾',0),(148364,4122,'sr','Ð£Ñ‚Ð¸ÑÑ†Ð¸ ÐŸÐ»ÑƒÑ ÑˆÐºÐ°Ñ€Ñ‚Ð°',0),(148365,4122,'vi','áº¤n tÆ°á»£ng vÃ  Pháº¿ liá»‡u',0),(148366,4122,'af','Indrukke Plus knipsel',0),(148367,4122,'ro','Impresii Plus resturi',0),(148368,4122,'et','Muljeid pluss jÃ¤Ã¤gid',0),(148369,4122,'si','Vtisi Plus ostanki',0),(148370,4122,'ba','Tayangan ditambah Scrap',0),(148371,4122,'nl','Indrukken Plus schroot',0),(148372,4122,'fi','NÃ¤yttÃ¶kerrat Plus romu',0),(148373,4122,'no','Visninger pluss skrap',0),(148374,4122,'da','Indtryk Plus skrot',0),(148375,4122,'ko','ë…¸ì¶œ í”ŒëŸ¬ìŠ¤ ìŠ¤í¬ëž©',0),(148376,4122,'he','×¨×©×ž×™× ×•×¢×•×“ ×’×¨×•×˜××•×ª',0),(148377,4122,'el','Î•Î½Ï„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚ ÏƒÏ…Î½ Î¸ÏÎ±ÏÏƒÎ¼Î±Ï„Î±',0),(148378,4122,'zh','å°è±¡åŠ åºŸé’¢\r\n',0),(148379,4122,'sv','Intryck Plus skrot',0),(148380,4122,'it','Impressioni piÃ¹ rottami',0),(148381,4122,'tl','',0),(148382,4122,'th','&#3591;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;&#3610;&#3623;&#3585;&#3626;&#3656;&#3623;&#3609;&#3648;&#3621;&#3655;&#3585; &#3654;',0),(148383,4122,'hi','à¤›à¤¾à¤ªà¥‡à¤‚ à¤ªà¥à¤²à¤¸ à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª',0),(148384,4122,'ms','Jejak Plus sekerap',0),(148385,4122,'ar','Ø§Ù„Ø¸Ù‡ÙˆØ± Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø®Ø±Ø¯Ø©',0),(148386,4122,'fr','Impressions Plus Scrap',0),(148387,4122,'jp','Impressions Plus Scrap',0),(148388,4122,'pt','ImpressÃµes mais sucata',0),(148389,4122,'ru','Ð’Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸Ñ Ð¿Ð»ÑŽÑ Ð»Ð¾Ð¼Ð°',0),(148390,4122,'es','Impresiones MÃ¡s Desechos',0),(148391,4122,'de','Impressionen Plus Schrott',0),(148392,4122,'en','Impressions Plus Scrap',0),(148393,4123,'is','',0),(148394,4123,'dr','Ù…Ø¨Ù†Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(148395,4123,'pr','Ù…Ø¨Ù†Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(148396,4123,'tr','ParÃ§a baÅŸÄ± iÅŸ olarak',0),(148397,4123,'pl','Akordowym',0),(148398,4123,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ð¾ÑÐ½Ð¾Ð²Ð°',0),(148399,4123,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯',0),(148400,4123,'sr','ÐžÑÐ½Ð¾Ð²Ð° Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(148401,4123,'vi','Ná»n táº£ng Viá»‡c khoÃ¡n',0),(148402,4123,'af','Stukwerk Basis',0),(148403,4123,'ro','BazÄƒ de acord',0),(148404,4123,'et','TÃ¼kitÃ¶Ã¶ alusel',0),(148405,4123,'si','Akord podlaga',0),(148406,4123,'ba','Piecework dasar',0),(148407,4123,'nl','Stukloon Basis',0),(148408,4123,'fi','Urakan perusteella',0),(148409,4123,'no','StykkavlÃ¸nning Basis',0),(148410,4123,'da','Akkordarbejde grundlag',0),(148411,4123,'ko','Piecework ê¸°ì´ˆ',0),(148412,4123,'he','×‘×¡×™×¡ ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(148413,4123,'el','ÎšÏ„Î¯ÏƒÎµÏ„Îµ',0),(148414,4123,'zh','è®¡ä»¶\r\n',0),(148415,4123,'sv','Ackord grund',0),(148416,4123,'it','Base del lavoro a cottimo',0),(148417,4123,'tl','',0),(148418,4123,'th','&#3627;&#3621;&#3633;&#3585;&#3585;&#3634;&#3619;&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;',0),(148419,4123,'hi','Piecework à¤†à¤§à¤¾à¤°',0),(148420,4123,'ms','Asas piecework',0),(148421,4123,'ar','Ø£Ø³Ø§Ø³ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(148422,4123,'fr','Ã€ la piÃ¨ce',0),(148423,4123,'jp','å‡ºæ?¥é«˜ãƒ™ãƒ¼ã‚¹',0),(148424,4123,'pt','Base de trabalho por tarefa',0),(148425,4123,'ru','ÐžÑÐ½Ð¾Ð²Ð¾Ð¹ ÑÐ´ÐµÐ»ÑŒÐ½Ð¾Ð¹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(148426,4123,'es','Base de Trabajo por Pieza',0),(148427,4123,'de','Akkord-Basis',0),(148428,4123,'en','Piecework Basis',0),(148429,4124,'is','',0),(148430,4124,'dr','Ù†Ø§Ù… Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(148431,4124,'pr','Ù†Ø§Ù… Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(148432,4124,'tr','ParÃ§a baÅŸÄ± iÅŸ adÄ±',0),(148433,4124,'pl','Nazwa pracy akordowej',0),(148434,4124,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð±Ñ€Ð¾Ð¹ÐºÐ°',0),(148435,4124,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ú©Û’ Ù†Ø§Ù…',0),(148436,4124,'sr','Ð˜Ð¼Ðµ Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(148437,4124,'vi','TÃªn Viá»‡c khoÃ¡n',0),(148438,4124,'af','Stukswerk Naam',0),(148439,4124,'ro','Acord nume',0),(148440,4124,'et','TÃ¼kitÃ¶Ã¶ nimi',0),(148441,4124,'si','Akord ime',0),(148442,4124,'ba','Nama piecework',0),(148443,4124,'nl','Stukloon naam',0),(148444,4124,'fi','Urakka nimi',0),(148445,4124,'no','StykkavlÃ¸nning navn',0),(148446,4124,'da','Akkordarbejde navn',0),(148447,4124,'ko','Piecework ì´ë¦„',0),(148448,4124,'he','×©× ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(148449,4124,'el','ÎŒÎ½Î¿Î¼Î± ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(148450,4124,'zh','è®¡ä»¶åç§°\r\n',0),(148451,4124,'sv','Ackord namn',0),(148452,4124,'it','Nome del lavoro a cottimo',0),(148453,4124,'tl','',0),(148454,4124,'th','&#3594;&#3639;&#3656;&#3629;&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;',0),(148455,4124,'hi','Piecework à¤¨à¤¾à¤®',0),(148456,4124,'ms','Nama piecework',0),(148457,4124,'ar','Ø§Ø³Ù… Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(148458,4124,'fr','Nom de la piÃ¨ce',0),(148459,4124,'jp','å‡ºæ?¥é«˜å??',0),(148460,4124,'pt','Nome do trabalho por tarefa',0),(148461,4124,'ru','Ð˜Ð¼Ñ ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(148462,4124,'es','Nombre de Trabajo por Pieza',0),(148463,4124,'de','Akkord-Namen',0),(148464,4124,'en','Piecework Name',0),(148465,4125,'is','',0),(148466,4125,'dr','(ÙˆØ±Ù‚) Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ø¶Ø§ÙŠØ¹Ø§Øª(Ø¨Ø±ÙŠØ¯Ù‡ ÙƒØ§ØºØ°',0),(148467,4125,'pr','Ø¨Ø±Ú¯Ù‡ (ÙˆØ±Ù‚) Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ø¶Ø§ÙŠØ¹Ø§Øª(Ø¨Ø±ÙŠØ¯Ù‡ ÙƒØ§ØºØ°',0),(148468,4125,'tr','Yaprak artÄ± hurda',0),(148469,4125,'pl','Arkusze oraz zÅ‚om',0),(148470,4125,'bg','Ð›Ð¸ÑÑ‚Ð¾Ð²Ðµ Ð¿Ð»ÑŽÑ ÑÐºÑ€Ð°Ð¿',0),(148471,4125,'ur','Ø§ÙˆØ±Ø§Ù‚ Ù¾Ù„Ø³ Ø³Ú©Ø±ÛŒÙ¾',0),(148472,4125,'sr','Ð›Ð¸ÑÑ‚Ð¾Ð²Ð¸ ÐŸÐ»ÑƒÑ ÑˆÐºÐ°Ñ€Ñ‚Ð°',0),(148473,4125,'vi','Trang thÃªm pháº¿ liá»‡u',0),(148474,4125,'af','Velle Plus knipsel',0),(148475,4125,'ro','Foi Plus resturi',0),(148476,4125,'et','Lehed pluss jÃ¤Ã¤gid',0),(148477,4125,'si','Listi Plus ostanki',0),(148478,4125,'ba','Lembar ditambah Scrap',0),(148479,4125,'nl','Bladen Plus schroot',0),(148480,4125,'fi','Arkkia Plus romu',0),(148481,4125,'no','Ark pluss skrap',0),(148482,4125,'da','Ark Plus skrot',0),(148483,4125,'ko','ì‹œíŠ¸ í”ŒëŸ¬ìŠ¤ ìŠ¤í¬ëž©',0),(148484,4125,'he','×ž×¦×¢×™× ×¤×œ×•×¡ ×’×¨×•×˜××•×ª',0),(148485,4125,'el','Î¦ÏÎ»Î»Î± ÎºÎ±Î¸ÏŽÏ‚ ÎºÎ±Î¹ Î¸ÏÎ±ÏÏƒÎ¼Î±Ï„Î±',0),(148486,4125,'zh','è¡¨åŠ åºŸ\r\n',0),(148487,4125,'sv','Lakan Plus skrot',0),(148488,4125,'it','Fogli piÃ¹ rottami',0),(148489,4125,'tl','',0),(148490,4125,'th','&#3649;&#3612;&#3656;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3610;&#3623;&#3585;&#3648;&#3624;&#3625;&#3648;&#3621;&#3655;&#3585; &#3654;',0),(148491,4125,'hi','à¤šà¤¾à¤¦à¤°à¥‡à¤‚ à¤ªà¥à¤²à¤¸ à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª',0),(148492,4125,'ms','Cadar Plus sekerap',0),(148493,4125,'ar','Ø£ÙˆØ±Ø§Ù‚ Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø®Ø±Ø¯Ø©',0),(148494,4125,'fr','Feuilles Plus Scrap',0),(148495,4125,'jp','Sheets Plus Scrap',0),(148496,4125,'pt','Folhas mais sucata',0),(148497,4125,'ru','Ð›Ð¸ÑÑ‚Ð¾Ð² Ð¿Ð»ÑŽÑ Ð»Ð¾Ð¼Ð°',0),(148498,4125,'es','Hojas MÃ¡s Desechas',0),(148499,4125,'de','BlÃ¤tter Plus Schrott',0),(148500,4125,'en','Sheets Plus Scrap',0),(148501,4126,'is','',0),(148502,4126,'dr','Ø§Ø² Ø·Ø±ÙŠÙ‚',0),(148503,4126,'pr','Ø§Ø² Ø·Ø±ÙŠÙ‚',0),(148504,4126,'tr','Via',0),(148505,4126,'pl','Za poÅ›rednictwem',0),(148506,4126,'bg','Ð§Ñ€ÐµÐ·',0),(148507,4126,'ur','Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(148508,4126,'sr','ÐŸÑƒÑ‚ÐµÐ¼',0),(148509,4126,'vi','Qua',0),(148510,4126,'af','Via',0),(148511,4126,'ro','Prin intermediul',0),(148512,4126,'et','Via',0),(148513,4126,'si','Preko',0),(148514,4126,'ba','Melalui',0),(148515,4126,'nl','Via',0),(148516,4126,'fi','Kautta',0),(148517,4126,'no','Via',0),(148518,4126,'da','Via',0),(148519,4126,'ko','í†µí•´',0),(148520,4126,'he','×•×™×”',0),(148521,4126,'el','ÎœÎ­ÏƒÏ‰',0),(148522,4126,'zh','é€šè¿‡\r\n',0),(148523,4126,'sv','Via',0),(148524,4126,'it','Via',0),(148525,4126,'tl','',0),(148526,4126,'th','&#3650;&#3604;&#3618;&#3607;&#3634;&#3591;',0),(148527,4126,'hi','à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡',0),(148528,4126,'ms','Melalui',0),(148529,4126,'ar','Ø¹Ù† Ø·Ø±ÙŠÙ‚',0),(148530,4126,'fr','Par l\'intermÃ©diaire',0),(148531,4126,'jp','çµŒç”±',0),(148532,4126,'pt','Oi?',0),(148533,4126,'ru','Ð§ÐµÑ€ÐµÐ·',0),(148534,4126,'es','Via',0),(148535,4126,'de','Ãœber',0),(148536,4126,'en','Via',0),(148537,4127,'is','',0),(148538,4127,'dr','Ù‡Ù…Ù‡ ÙØ¹Ø§Ù„ÙŠØª',0),(148539,4127,'pr','Ù‡Ù…Ù‡ ÙØ¹Ø§Ù„ÙŠØª',0),(148540,4127,'tr','TÃ¼m etkinlikler',0),(148541,4127,'pl','Wszystkie dziaÅ‚ania',0),(148542,4127,'bg','Ð¦ÑÐ»Ð°Ñ‚Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(148543,4127,'ur','ØªÙ…Ø§Ù… Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(148544,4127,'sr','Ð¡Ð²Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(148545,4127,'vi','Táº¥t Cáº£ CÃ¡c Hoáº¡t Äá»™ng',0),(148546,4127,'af','Alle Aktiwiteite',0),(148547,4127,'ro','Orice activitate de',0),(148548,4127,'et','Kogu tegevus',0),(148549,4127,'si','Vse dejavnosti',0),(148550,4127,'ba','Semua aktivitas',0),(148551,4127,'nl','Alle activiteiten',0),(148552,4127,'fi','Kaikki toiminta',0),(148553,4127,'no','All aktivitet',0),(148554,4127,'da','Alle aktivitet',0),(148555,4127,'ko','ëª¨ë“  í™œë™',0),(148556,4127,'he','×›×œ ×”×¤×¢×™×œ×•×ª',0),(148557,4127,'el','ÎšÎ¬Î¸Îµ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(148558,4127,'zh','æ‰€æœ‰æ´»åŠ¨\r\n',0),(148559,4127,'sv','All verksamhet',0),(148560,4127,'it','Tutte le attivitÃ ',0),(148561,4127,'tl','',0),(148562,4127,'th','&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(148563,4127,'hi','à¤¸à¤­à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(148564,4127,'ms','Semua aktiviti',0),(148565,4127,'ar','ÙƒÙ„ Ù†Ø´Ø§Ø·',0),(148566,4127,'fr','Toutes les activitÃ©s',0),(148567,4127,'jp','å…¨ã?¦ã?®ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£',0),(148568,4127,'pt','Todas as atividades',0),(148569,4127,'ru','Ð’ÑÑ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ',0),(148570,4127,'es','Toda Actividad',0),(148571,4127,'de','Alle AktivitÃ¤ten',0),(148572,4127,'en','All Activity',0),(148573,4128,'is','',0),(148574,4128,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø±Ø§ÙŠ ',0),(148575,4128,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø±Ø§ÙŠ ',0),(148576,4128,'tr','Bilgi iÃ§in',0),(148577,4128,'pl','Informacje dla',0),(148578,4128,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð°',0),(148579,4128,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ù„Ø¦Û’',0),(148580,4128,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°',0),(148581,4128,'vi','ThÃ´ng Tin cho',0),(148582,4128,'af','Inligting Vir',0),(148583,4128,'ro','Informatie pentru',0),(148584,4128,'et','Teave',0),(148585,4128,'si','Informacije za',0),(148586,4128,'ba','Informasi untuk',0),(148587,4128,'nl','Informatie voor',0),(148588,4128,'fi','LisÃ¤tietoja',0),(148589,4128,'no','Informasjon For',0),(148590,4128,'da','Information til',0),(148591,4128,'ko','ì— ëŒ€ í•œ ì •ë³´',0),(148592,4128,'he','×ž×™×“×¢ ×¢×‘×•×¨',0),(148593,4128,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î±',0),(148594,4128,'zh','ä¿¡æ¯å¯¹äºŽ\r\n',0),(148595,4128,'sv','Information fÃ¶r',0),(148596,4128,'it','Informazioni per',0),(148597,4128,'tl','',0),(148598,4128,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(148599,4128,'hi','à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(148600,4128,'ms','Maklumat untuk',0),(148601,4128,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ù†',0),(148602,4128,'fr','Informations pour',0),(148603,4128,'jp','ï½žã?®æƒ…å ±',0),(148604,4128,'pt','InformaÃ§Ãµes para',0),(148605,4128,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð”Ð»Ñ',0),(148606,4128,'es','InformaciÃ³n Para',0),(148607,4128,'de','Informationen fÃ¼r',0),(148608,4128,'en','Information For',0),(148609,4129,'is','',0),(148610,4129,'dr','ØªØ§Ø±ÙŠØ® ÙØ¹Ø§Ù„ÙŠØª',0),(148611,4129,'pr','ØªØ§Ø±ÙŠØ® ÙØ¹Ø§Ù„ÙŠØª',0),(148612,4129,'tr','Eylem tarihi',0),(148613,4129,'pl','Akcja Data',0),(148614,4129,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(148615,4129,'ur','Ø¹Ù…Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(148616,4129,'sr','ÐÐºÑ†Ð¸Ñ˜Ðµ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(148617,4129,'vi','NgÃ y HÃ nh Äá»™ng',0),(148618,4129,'af','Aksiedatum',0),(148619,4129,'ro','Data actiunii',0),(148620,4129,'et','Tegevuse kuupÃ¤ev',0),(148621,4129,'si','Datum dejanja',0),(148622,4129,'ba','Tanggal Pelaksanaan',0),(148623,4129,'nl','Datum van de actie',0),(148624,4129,'fi','Toimenpiteen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(148625,4129,'no','Handlingsdato',0),(148626,4129,'da','Aktionsdato',0),(148627,4129,'ko','ìž‘ì—… ë‚ ì§œ',0),(148628,4129,'he','×ª××¨×™×š ×¤×¢×•×œ×”',0),(148629,4129,'el','Î—Î¼.',0),(148630,4129,'zh','åŠ¨ä½œæ—¥æœŸ\r\n',0),(148631,4129,'sv','Ã…tgÃ¤rdsdatum',0),(148632,4129,'it','Data dell\'azione',0),(148633,4129,'tl','',0),(148634,4129,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(148635,4129,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(148636,4129,'ms','Tarikh tindakan',0),(148637,4129,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¹Ù…Ù„',0),(148638,4129,'fr','Date d\'Action',0),(148639,4129,'jp','æ´»å‹•æ—¥',0),(148640,4129,'pt','Data aÃ§Ã£o',0),(148641,4129,'ru','Ð”Ð°Ñ‚Ð° Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(148642,4129,'es','Fecha AcciÃ³n',0),(148643,4129,'de','AktivitÃ¤tsdatum',0),(148644,4129,'en','Action Date',0),(148645,4130,'is','',0),(148646,4130,'dr','ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(148647,4130,'pr','ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(148648,4130,'tr','Itemcode',0),(148649,4130,'pl','Itemcode',0),(148650,4130,'bg','Itemcode',0),(148651,4130,'ur','Ø§Ù¹ÛŒÙ…Ú©ÙˆØ¯ÛŒ',0),(148652,4130,'sr','Ð˜Ñ‚ÐµÐ¼Ñ†Ð¾Ð´Ðµ',0),(148653,4130,'vi','MÃ£ hÃ ng',0),(148654,4130,'af','Itemkode',0),(148655,4130,'ro','Itemcode',0),(148656,4130,'et','Tootekood',0),(148657,4130,'si','Itemcode',0),(148658,4130,'ba','Itemcode',0),(148659,4130,'nl','Itemcode',0),(148660,4130,'fi','Itemcode',0),(148661,4130,'no','Itemcode',0),(148662,4130,'da','Itemcode',0),(148663,4130,'ko','Itemcode',0),(148664,4130,'he','×§×•×“ ×¤×¨×™×˜',0),(148665,4130,'el','Itemcode',0),(148666,4130,'zh','äº§å“ä»£ç ',0),(148667,4130,'sv','Itemcode',0),(148668,4130,'it','ItemCode',0),(148669,4130,'tl','',0),(148670,4130,'th','&#3619;&#3627;&#3633;&#3626;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(148671,4130,'hi','Itemcode',0),(148672,4130,'ms','Itemcode',0),(148673,4130,'ar','Ø±Ù…Ø² Ø§Ù„ØµÙ†Ù',0),(148674,4130,'fr','ItemCode',0),(148675,4130,'jp','å“?ç›®ã‚³ãƒ¼ãƒ‰',0),(148676,4130,'pt','ItemCode',0),(148677,4130,'ru','ÐšÐ¾Ð´ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(148678,4130,'es','ItemcÃ³digo',0),(148679,4130,'de','Itemcode',0),(148680,4130,'en','Itemcode',0),(148681,4131,'is','',0),(148682,4131,'dr','Ø«Ø¨Øª ',0),(148683,4131,'pr','Ø«Ø¨Øª ',0),(148684,4131,'tr','Girin',0),(148685,4131,'pl','WprowadÅº',0),(148686,4131,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ',0),(148687,4131,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(148688,4131,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ',0),(148689,4131,'vi','Nháº­p',0),(148690,4131,'af','Invoer',0),(148691,4131,'ro','IntroduceÅ£i',0),(148692,4131,'et','Sisestage',0),(148693,4131,'si','Vnesite',0),(148694,4131,'ba','Masukkan',0),(148695,4131,'nl','Voer',0),(148696,4131,'fi','Kirjoita',0),(148697,4131,'no','Angi',0),(148698,4131,'da','Angiv',0),(148699,4131,'ko','ìž…ë ¥',0),(148700,4131,'he','×”×–×Ÿ',0),(148701,4131,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ',0),(148702,4131,'zh','è¾“å…¥',0),(148703,4131,'sv','Ange',0),(148704,4131,'it','Immettere',0),(148705,4131,'tl','',0),(148706,4131,'th','&#3611;&#3657;&#3629;&#3609;',0),(148707,4131,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(148708,4131,'ms','Masukkan',0),(148709,4131,'ar','Ø£Ø¯Ø®Ù„',0),(148710,4131,'fr','Entrez',0),(148711,4131,'jp','å…¥åŠ›',0),(148712,4131,'pt','Digite',0),(148713,4131,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ',0),(148714,4131,'es','Ingresar',0),(148715,4131,'de','Geben Sie',0),(148716,4131,'en','Enter',0),(148717,4132,'is','',0),(148718,4132,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø³Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ Ø§Ø¬Ù†Ø§Ø³ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³ ',0),(148719,4132,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ Ø§Ø¬Ù†Ø§Ø³ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(148720,4132,'tr','YapÄ± sipariÅŸler stok maddeleri iÃ§in girin/gÃ¼ncelleme',0),(148721,4132,'pl','WprowadÅº/Aktualizacja kompilacji zamÃ³wieÅ„ dla towarÃ³w magazynowych',0),(148722,4132,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(148723,4132,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ù„Ø¦Û’ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(148724,4132,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(148725,4132,'vi','Nháº­p/Cáº­p Nháº­t ÄÆ¡n HÃ ng cho MÃ£ HÃ ng HÃ³a',0),(148726,4132,'af','Tik/Update bouvorm bestellings vir voorraad Items',0),(148727,4132,'ro','IntroduceÅ£i/Update Build comenzi pentru obiecte de inventar',0),(148728,4132,'et','Laokaupade ehitada tellimuste sisestamine/ajakohastamine',0),(148729,4132,'si','Vnos/posodobitev graditi nalogi za artikle v zalogi',0),(148730,4132,'ba','Masukkan/Update Build pesanan untuk barang-barang inventaris',0),(148731,4132,'nl','Build Orders voor voorraadartikelen invoeren/bijwerken',0),(148732,4132,'fi','PÃ¤ivittÃ¤minen rakentaa varastonimikkeiden tilaukset',0),(148733,4132,'no','Angi/oppdatere bygge ordrer for varer pÃ¥ lager',0),(148734,4132,'da','Indtaste/opdatere opbygge ordrer for lagervarer',0),(148735,4132,'ko','ìž¬ê³  ëª©ë¡ í’ˆëª©ì— ëŒ€ í•œ ë¹Œë“œ ì£¼ë¬¸ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(148736,4132,'he','×”×›× ×¡/×¢×“×›×Ÿ ×”×–×ž× ×•×ª ×‘× ×™×” ×¢×‘×•×¨ ×¤×¨×™×˜×™ ×ž×œ××™',0),(148737,4132,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ/ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Build Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î³Î¹Î± ÎµÎ¯Î´Î· Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(148738,4132,'zh','è¾“å…¥/æ›´æ–°å­˜è´§å»ºè®¾é¡¹ç›®è®¢å•',0),(148739,4132,'sv','Ange/uppdatera bygga order fÃ¶r lagerartiklar',0),(148740,4132,'it','Inserisci/Aggiorna compilazione ordini per articoli di magazzino',0),(148741,4132,'tl','',0),(148742,4132,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&',0),(148743,4132,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤°à¥à¤®à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(148744,4132,'ms','Masukkan/Kemaskini Tempahan membina item inventori',0),(148745,4132,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡ Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(148746,4132,'fr','Entrez/mise Ã  jour Build Orders pour articles en stock',0),(148747,4132,'jp','åœ¨åº«å“?ç›®ã?®çµ„ç«‹æ³¨æ–‡ã?®å…¥åŠ›/æ›´æ–°',0),(148748,4132,'pt','Inserir/atualizar ordens de construÃ§Ã£o para itens de estoque',0),(148749,4132,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð´Ð»Ñ Ð½Ð¾Ð¼ÐµÐ½ÐºÐ»Ð°Ñ‚ÑƒÑ€Ñ‹',0),(148750,4132,'es','Introducir/Actualizar Pedidos de ConstrucciÃ³n para Items de Inventario',0),(148751,4132,'de','Geben Sie/Update Baureihenfolgen fÃ¼r Lagerartikel',0),(148752,4132,'en','Enter/Update Build Orders for Inventory Items',0),(148753,4133,'is','',0),(148754,4133,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(148755,4133,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(148756,4133,'tr','Liste oluÅŸturma sipariÅŸler',0),(148757,4133,'pl','BudowaÄ‡ lista zleceÅ„',0),(148758,4133,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(148759,4133,'ur','ÙÛØ±Ø³Øª ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(148760,4133,'sr','Ð›Ð¸ÑÑ‚Ð° Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(148761,4133,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(148762,4133,'af','Lys Geboude Bestellings',0),(148763,4133,'ro','Ordinele de a construi lista',0),(148764,4133,'et','Nimekiri ehitada tellimused',0),(148765,4133,'si','Seznam graditi naroÄila',0),(148766,4133,'ba','Daftar membangun perintah',0),(148767,4133,'nl','Lijst Build Orders',0),(148768,4133,'fi','Lista rakentaa tilaukset',0),(148769,4133,'no','Liste bygge bestillinger',0),(148770,4133,'da','Listen bygge ordrer',0),(148771,4133,'ko','ëª©ë¡ ë¹Œë“œ ìˆœì„œ',0),(148772,4133,'he','×¨×©×™×ž×ª ×”×•×¨××•×ª ×‘× ×™×”',0),(148773,4133,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(148774,4133,'zh','åˆ—å‡ºç”Ÿæˆè®¢å•\r\n',0),(148775,4133,'sv','Lista bygga order',0),(148776,4133,'it','Elenco compilazione ordini',0),(148777,4133,'tl','',0),(148778,4133,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(148779,4133,'hi','à¤¸à¥‚à¤šà¥€ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤†à¤¦à¥‡à¤¶',0),(148780,4133,'ms','Perintah membina senarai',0),(148781,4133,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(148782,4133,'fr','Liste Build Orders',0),(148783,4133,'jp','åˆ¶ä½œæ³¨æ–‡ã?®ãƒªã‚¹ãƒˆ',0),(148784,4133,'pt','Lista de ordens de construÃ§Ã£o',0),(148785,4133,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(148786,4133,'es','Lista Ordenes de ConstrucciÃ³n',0),(148787,4133,'de','Liste Build Orders',0),(148788,4133,'en','List Build Orders',0),(148789,4134,'is','',0),(148790,4134,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ',0),(148791,4134,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ',0),(148792,4134,'tr','SipariÅŸleri listesi Ã¼rÃ¼n reÃ§etesini tamamlandÄ±',0),(148793,4134,'pl','Lista BOM zakoÅ„czone zlecenia',0),(148794,4134,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑÐ½Ð¾ Ð¸Ð·Ð´ÐµÐ»Ð¸Ðµ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÑÐ²Ð°Ð»Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(148795,4134,'ur','ÙÛØ±Ø³Øª Ø¨Ù„ Ù…ÙˆØ§Ø¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§',0),(148796,4134,'sr','Ð›Ð¸ÑÑ‚Ð° ÑÐ°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ð° Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(148797,4134,'vi','Danh SÃ¡ch CÃ¡c ÄÆ¡n HÃ ng NguyÃªn Váº­t Liá»‡u ÄÃ£ HoÃ n Táº¥t',0),(148798,4134,'af','Lys van Materiaalrekening Voorraaditems',0),(148799,4134,'ro','ListÄƒ listÄƒ de materiale realizate comenzi',0),(148800,4134,'et','Nimekiri komplekt tÃ¤ita tellimusi',0),(148801,4134,'si','Seznam kosovnica dokonÄana naroÄila',0),(148802,4134,'ba','Daftar tagihan bahan menyelesaikan pesanan',0),(148803,4134,'nl','Lijst Stuklijst voltooid Orders',0),(148804,4134,'fi','Luettelo tuoterakenne valmiiksi tilaukset',0),(148805,4134,'no','Listen stykkliste fullfÃ¸rt ordre',0),(148806,4134,'da','Liste over stykliste afsluttet ordrer',0),(148807,4134,'ko','ìž¬ë£Œì˜ ëª©ë¡ ë¹Œ ì£¼ë¬¸ ì™„ë£Œ',0),(148808,4134,'he','×‘×™×œ ×¨×©×™×ž×” ×©×œ ×—×•×ž×¨×™× ×œ×”×©×œ×™× ×”×–×ž× ×•×ª',0),(148809,4134,'el','Î›Î¯ÏƒÏ„Î± Ï€Î¯Î½Î±ÎºÎ±Ï‚ Ï…Î»Î¹ÎºÏŽÎ½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(148810,4134,'zh','ææ–™æ¸…å•å®Œæˆè®¢å•åå•\r\n',0),(148811,4134,'sv','Lista stycklista avslutade bestÃ¤llningar',0),(148812,4134,'it','Distinta elenco materiali completato gli ordini',0),(148813,4134,'tl','',0),(148814,4134,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3636;&#3621;&#3586;&#3629;&#3591;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610; &#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#',0),(148815,4134,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤¬à¤¿à¤² à¤ªà¥‚à¤°à¤¾ à¤†à¤¦à¥‡à¤¶',0),(148816,4134,'ms','Bil senarai bahan-bahan siap pesanan',0),(148817,4134,'ar','Ø¨ÙŠÙ„ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ§Ø¯ Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ø£ÙˆØ§Ù…Ø±',0),(148818,4134,'fr','Liste nomenclature exÃ©cutÃ© les commandes',0),(148819,4134,'jp','æ??æ–™å®Œäº†æ³¨æ–‡ã?®è«‹æ±‚æ›¸ã‚’ãƒªã‚¹ãƒˆã?™ã‚‹',0),(148820,4134,'pt','Lista de lista de materiais completou as ordens',0),(148821,4134,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð‘Ð¸Ð»Ð» Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð² Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(148822,4134,'es','Listar la Lista de Materiales Orenes Completados',0),(148823,4134,'de','Liste StÃ¼ckliste Abgeschlossene Bestellungen',0),(148824,4134,'en','List Bill of Materials Completed Orders',0),(148825,4135,'is','',0),(148826,4135,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø³Ø§Ø®Øª',0),(148827,4135,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª',0),(148828,4135,'tr','YapÄ± emir girin/gÃ¼ncelleme',0),(148829,4135,'pl','WprowadÅº/Aktualizacja kompilacji zamÃ³wieÅ„',0),(148830,4135,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(148831,4135,'ur','ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(148832,4135,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(148833,4135,'vi','Nháº­p/Cáº­p Nháº­t ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(148834,4135,'af','Invoer/Opdateer Geboude Bestellings',0),(148835,4135,'ro','IntroduceÅ£i/Update Build comenzi',0),(148836,4135,'et','Ehitada tellimuste sisestamine/ajakohastamine',0),(148837,4135,'si','Vnos/posodobitev graditi naroÄila',0),(148838,4135,'ba','Memasukkan/Koreksi Pembuatan Pesanan',0),(148839,4135,'nl','Build Orders invoeren/bijwerken',0),(148840,4135,'fi','PÃ¤ivittÃ¤minen rakentaa tilaukset',0),(148841,4135,'no','Angi/oppdatere bygge bestillinger',0),(148842,4135,'da','Indtaste/opdatere opbygge ordrer',0),(148843,4135,'ko','ë¹Œë“œ ëª…ë ¹ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(148844,4135,'he','×”×›× ×¡/×¢×“×›×Ÿ ×”×–×ž× ×•×ª ×‘× ×™×”',0),(148845,4135,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ/ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Build Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(148846,4135,'zh','è¾“å…¥/æ›´æ–°ç”Ÿæˆè®¢å•',0),(148847,4135,'sv','Ange/uppdatera bygga order',0),(148848,4135,'it','Inserisci/Aggiorna compilazione ordini',0),(148849,4135,'tl','',0),(148850,4135,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(148851,4135,'hi','à¤¬à¤¿à¤²à¥à¤¡ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(148852,4135,'ms','Masukkan/Kemaskini membina pesanan',0),(148853,4135,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(148854,4135,'fr','Entrez/mise Ã  jour Build Orders',0),(148855,4135,'jp','åˆ¶ä½œæ³¨æ–‡ã?®ã€€è¨˜å¸³/æ›´æ–°',0),(148856,4135,'pt','Inserir/atualizar ordens de construÃ§Ã£o',0),(148857,4135,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(148858,4135,'es','Introducir/Actualizar Ordenes de ConstrucciÃ³n',0),(148859,4135,'de','Geben Sie/Update Baureihenfolgen',0),(148860,4135,'en','Enter/Update Build Orders',0),(148861,4136,'is','',0),(148862,4136,'dr','Ø®ØµÙˆØµÙŠ ',0),(148863,4136,'pr','Ø®ØµÙˆØµÙŠ ',0),(148864,4136,'tr','Ã–zel',0),(148865,4136,'pl','Prywatne',0),(148866,4136,'bg','Ð§Ð°ÑÑ‚Ð½Ð¸',0),(148867,4136,'ur','Ø°Ø§ØªÛŒ',0),(148868,4136,'sr','ÐŸÑ€Ð¸Ð²Ð°Ñ‚Ð½Ð¸',0),(148869,4136,'vi','RiÃªng tÆ°',0),(148870,4136,'af','Privaat',0),(148871,4136,'ro','Privat',0),(148872,4136,'et','Privaatne',0),(148873,4136,'si','Zasebno',0),(148874,4136,'ba','Pribadi',0),(148875,4136,'nl','PrivÃ©',0),(148876,4136,'fi','Oma',0),(148877,4136,'no','Privat',0),(148878,4136,'da','Privat',0),(148879,4136,'ko','ê°œì¸',0),(148880,4136,'he','×¤×¨×˜×™',0),(148881,4136,'el','Î ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÏŒ',0),(148882,4136,'zh','ç§äºº\r\n',0),(148883,4136,'sv','Privat',0),(148884,4136,'it','Privato',0),(148885,4136,'tl','',0),(148886,4136,'th','&#3626;&#3656;&#3623;&#3609;&#3605;&#3633;&#3623;',0),(148887,4136,'hi','à¤¨à¤¿à¤œà¥€',0),(148888,4136,'ms','Peribadi',0),(148889,4136,'ar','Ø®ØµÙˆØµÙŠ',0),(148890,4136,'fr','PrivÃ©',0),(148891,4136,'jp','ãƒ—ãƒ©ã‚¤ãƒ™ãƒ¼ãƒˆ',0),(148892,4136,'pt','Privada',0),(148893,4136,'ru','Ð§ÐÐ¡Ð¢ÐÐžÐ•',0),(148894,4136,'es','Privado',0),(148895,4136,'de','Private',0),(148896,4136,'en','Private',0),(148897,4137,'is','',0),(148898,4137,'dr','ÙˆØµÙˆÙ„ Ú©Ù†Ù†Ø¯Ù‡ Ø´Ø®Øµ Ø¯ÙŠÚ¯Ø±ÙŠ ÙƒÙ‡ Ø§ÙŠÙ† Ù¾ÙŠØºØ§Ù… Ø±Ø§ Ø¯Ø±ÙŠØ§ÙØª ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª Ø±Ø§ Ù†Ù…ÙŠ Ø¨ÙŠÙ†Ø¯ ',0),(148899,4137,'pr','ÙˆØµÙˆÙ„ Ú©Ù†Ù†Ø¯Ù‡ Ø´Ø®Øµ Ø¯ÙŠÚ¯Ø±ÙŠ ÙƒÙ‡ Ø§ÙŠÙ† Ù¾ÙŠØºØ§Ù… Ø±Ø§ Ø¯Ø±ÙŠØ§ÙØª ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª Ø±Ø§ Ù†Ù…ÙŠ Ø¨ÙŠÙ†Ø¯ ',0),(148900,4137,'tr','AlÄ±cÄ±lar, baÅŸka kim bu mesajÄ± aldÄ± gÃ¶rmÃ¼yorum.',0),(148901,4137,'pl','Adresaci nie widaÄ‡, kto otrzymaÅ‚ tÄ™ wiadomoÅ›Ä‡.',0),(148902,4137,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð½Ðµ Ð²Ð¸Ð¶Ð´Ð°Ð¼ ÐºÐ¾Ð¹ Ð´Ñ€ÑƒÐ³ Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð» Ñ‚Ð¾Ð²Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ.',0),(148903,4137,'ur','ÙˆØµÙˆÙ„ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† ÛÛ’ ÛÛ’ Ú©ÙˆØ¦ÛŒ Ø¬Ùˆ ÛŒÛ Ù¾ÛŒØºØ§Ù… Ù…ÙˆØµÙˆÙ„ Ù†ÛÛŒÚº Ø¯ÛŒÚ©Ú¾ØªÛ’ Û”',0),(148904,4137,'sr','ÐŸÑ€Ð¸Ð¼Ð°Ð¾Ñ†Ð¸ Ð½Ðµ Ð²Ð¸Ð´Ðµ ÐºÐ¾ Ñ˜Ðµ Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾ Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€ÑƒÐºÑƒ.',0),(148905,4137,'vi','NgÆ°á»i nháº­n khÃ´ng tháº¥y ai Ä‘Ã£ nháº­n tin nháº¯n nÃ y',0),(148906,4137,'af','Ontvangers sien nie wie anders hierdie boodskap ontvang het nie.',0),(148907,4137,'ro','Destinatari nu vÄƒd cine a primit acest mesaj.',0),(148908,4137,'et','Saajad ei nÃ¤e, kes veel on selle sÃµnumi saanud',0),(148909,4137,'si','Prejemniki ne vidim, kdo je prejel to sporoÄilo.',0),(148910,4137,'ba','Penerima tidak melihat siapa pun yang telah menerima pesan ini.',0),(148911,4137,'nl','Ontvangers doen niet zien wie dit bericht heeft ontvangen.',0),(148912,4137,'fi','Vastaanottajat eivÃ¤t nÃ¤e, kuka muu on saanut tÃ¤mÃ¤n viestin.',0),(148913,4137,'no','Mottakerne ser ikke hvem har mottatt denne meldingen.',0),(148914,4137,'da','Modtagerne kan ikke se hvem der ellers har modtaget denne besked.',0),(148915,4137,'ko','ë°›ëŠ” ì‚¬ëžŒ ë³¼ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ëˆ„ê°€ì´ ë©”ì‹œì§€ë¥¼ ë°›ì•˜ìŠµë‹ˆë‹¤.',0),(148916,4137,'he','× ×ž×¢× ×™× ×œ× ×¨×•××” ×ž×™ ×¢×•×“ ×§×™×‘×œ ×”×•×“×¢×” ×–×•.',0),(148917,4137,'el','Î Î±ÏÎ±Î»Î®Ï€Ï„ÎµÏ‚ Î´ÎµÎ½ Î²Î»Î­Ï€Ï‰ Ï€Î¿Î¹Î¿Ï‚ Î¬Î»Î»Î¿Ï‚ Î­Ï‡ÎµÎ¹ Î»Î¬Î²ÎµÎ¹ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î®Î½Ï…Î¼Î±.',0),(148918,4137,'zh','æ”¶ä»¶äººæ— æ³•æŸ¥é˜…æ”¶åˆ°æ­¤æ¶ˆæ¯çš„å…¶ä»–äººã€‚\r\n',0),(148919,4137,'sv','Mottagarna ser inte vilka andra har fÃ¥tt detta meddelande.',0),(148920,4137,'it','I destinatari non vedono chi altro ha ricevuto questo messaggio.',0),(148921,4137,'tl','',0),(148922,4137,'th','Recipients do not see who else has received this message.',0),(148923,4137,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤¦à¥‡à¤–à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤”à¤° à¤•à¥Œà¤¨ à¤¯à¤¹ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤† à¤¹à¥ˆà¥¤',0),(148924,4137,'ms','Penerima tidak nampak yang lain telah menerima mesej ini.',0),(148925,4137,'ar','Ù„Ø§ Ø£Ø±Ù‰ Ø§Ù„Ù…Ø³ØªÙ„Ù…ÙŠÙ† Ø§Ù„Ø°ÙŠÙ† Ø¢Ø®Ø± ØªÙ„Ù‚ÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ø±Ø³Ø§Ù„Ø©.',0),(148926,4137,'fr','BÃ©nÃ©ficiaires ne voient pas qui d\'autre a reÃ§u ce message.',0),(148927,4137,'jp','å?—å?–äººã?«ã?¯ä»–ã?«èª°ã?Œã?“ã?®ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’å?—ã?‘ã?Ÿã?‹è¦‹ã?ˆã?¾ã?›ã‚“',0),(148928,4137,'pt','Os destinatÃ¡rios nÃ£o vejo quem mais recebeu essa mensagem.',0),(148929,4137,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»Ð¸ Ð½Ðµ Ð²Ð¸Ð´ÑÑ‚, ÐºÑ‚Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð» ÑÑ‚Ð¾ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ.',0),(148930,4137,'es','Recipientes no ven quien mÃ¡s ha recibido este mensaje',0),(148931,4137,'de','EmpfÃ¤nger sehen nicht, wer diese Nachricht erhalten hat.',0),(148932,4137,'en','Recipients do not see who else has received this message.',0),(148933,4138,'is','',0),(148934,4138,'dr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(148935,4138,'pr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(148936,4138,'tr','Fatura tarihi',0),(148937,4138,'pl','Daty faktury',0),(148938,4138,'bg','Ð”Ð°Ñ‚Ð¸ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(148939,4138,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®ÛŒÚº',0),(148940,4138,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(148941,4138,'vi','NgÃ y HÃ³a Ä‘Æ¡n',0),(148942,4138,'af','Faktuurdatums',0),(148943,4138,'ro','Datele facturii',0),(148944,4138,'et','Arvete kuupÃ¤evad',0),(148945,4138,'si','Datumi raÄunov',0),(148946,4138,'ba','Tanggal faktur',0),(148947,4138,'nl','Factuurdatum',0),(148948,4138,'fi','Laskujen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(148949,4138,'no','Fakturadato',0),(148950,4138,'da','Faktureringsdato',0),(148951,4138,'ko','ì†¡ìž¥ ë‚ ì§œ',0),(148952,4138,'he','×ª××¨×™×›×™ ×—×©×‘×•× ×™×ª',0),(148953,4138,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(148954,4138,'zh','å‘ç¥¨æ—¥æœŸ\r\n',0),(148955,4138,'sv','Fakturadatum',0),(148956,4138,'it','Date di fattura',0),(148957,4138,'tl','',0),(148958,4138,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(148959,4138,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤',0),(148960,4138,'ms','Tarikh invois',0),(148961,4138,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(148962,4138,'fr','Dates de la facture',0),(148963,4138,'jp','è«‹æ±‚æ›¸æ—¥ä»˜',0),(148964,4138,'pt','Datas de fatura',0),(148965,4138,'ru','Ð”Ð°Ñ‚Ñ‹ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(148966,4138,'es','Fechas de Facturas',0),(148967,4138,'de','Rechnungsdaten',0),(148968,4138,'en','Invoice Dates',0),(148969,4139,'is','',0),(148970,4139,'dr',': Ú†Ùƒ Ù‡Ø§ÙŠ Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡ Ø¨Ø§ÙŠØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ú†Ø§Ù¾ Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ù†Ø¯  Ùˆ Ø§Ø² Ø¯Ø§Ø®Ù„ Ù†Ù…ÙˆÙ†Ù‡ Ù„ÙŠØ³Øª Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡ Ù„ØºÙˆ Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ù†Ø¯ ',0),(148971,4139,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ú†Ùƒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ : Ú†Ùƒ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø§ÙŠØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ú†Ø§Ù¾ Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ù†Ø¯  Ùˆ Ø§Ø² Ø¯Ø§Ø®Ù„ Ù†Ù…ÙˆÙ†Ù‡ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù„ØºÙˆ Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ù†Ø¯ ',0),(148972,4139,'tr','Not: Bordro Ã§ek yeniden basÄ±ldÄ± ve gelen bordro modÃ¼lÃ¼ iÃ§inde geÃ§ersiz.',0),(148973,4139,'pl','Uwaga: Kontroli pÅ‚ac musi byÄ‡ przedrukowane i uniewaÅ¼nione z w Module listy pÅ‚ac.',0),(148974,4139,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ°: Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ñ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð½Ð¸ Ð¸ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½ Ð¾Ñ‚ Ð² Ñ€Ð°Ð¼ÐºÐ¸Ñ‚Ðµ Ð½Ð° Ð¼Ð¾Ð´ÑƒÐ» Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸.',0),(148975,4139,'ur','Ù†ÙˆÙ¹: Ù¾Û’ Ø±ÙˆÙ„ Ú†ÛŒÚ© Ø¯ÙˆØ¨Ø§Ø±Û Ø·Ø¨Ø¹ Ø´Ø¯Û Ø§ÙˆØ± Ú†Ø§ÛÛŒØ¦Û’ Ù¾Û’ Ø±ÙˆÙ„ Ú©Û’ Ù…Ø§ÚˆÛŒÙˆÙ„ Ú©Û’ Ø§Ù†Ø¯Ø± Ø³Û’ ÙˆÙˆØ§ÚˆÛŒØ¯ ÛÛŒÚº Û”',0),(148976,4139,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° : ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð´Ð°Ñ˜Ñƒ Ð¸ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ Ð¸Ð· Ñƒ Ð¾ÐºÐ²Ð¸Ñ€Ñƒ Ð¼Ð¾Ð´ÑƒÐ»Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº.',0),(148977,4139,'vi','ChÃº Ã: SÃ©c Tráº£ LÆ°Æ¡ng pháº£i in láº¡i & há»§y khi á»Ÿ mÃ´ Ä‘un lÆ°Æ¡ng',0),(148978,4139,'af','L.W.: Loonroltjeks moet vanuit die Loonrol Module herdruk en geskrap word.',0),(148979,4139,'ro','NotÄƒ: Salarizare controalele trebuie sÄƒ fie retipÄƒritÄƒ ÅŸi anulate de la modulul de salarizare.',0),(148980,4139,'et','MÃ¤rkus: Palgaarvestuse kontrollimine peab kordustrÃ¼kk ja kehtetu alates palgaarvestuse mooduli.',0),(148981,4139,'si','Opomba: Payroll preverjanja mora biti ponatis in razveljavi od v modulu plaÄe.',0),(148982,4139,'ba','Catatan: Penggajian cek harus dicetak dan voided dari dalam modul penggajian.',0),(148983,4139,'nl','Opmerking: Payroll controles moeten worden herdrukt en vernietigde uit binnen de Payroll-Module.',0),(148984,4139,'fi','Huomautus: Payroll tarkastukset on uusintapainos ja mitÃ¤tÃ¶ity Palkanlaskenta-moduulin.',0),(148985,4139,'no','Merk: LÃ¸nn sjekker mÃ¥ gjengitt og kansellert fra i lÃ¸nn-modulen.',0),(148986,4139,'da','BemÃ¦rk: LÃ¸nningslisten kontrol skal genoptrykt og nedlagte fra inden for modulet lÃ¸nningslisten.',0),(148987,4139,'ko','ì°¸ê³ : ê¸‰ì—¬ ìˆ˜ í‘œ ì¦ ì‡„ í•˜ ê³  ê¸‰ì—¬ ëª¨ë“ˆ ë‚´ì—ì„œ ë¬´íš¨ ë  í•´ì•¼ í•©ë‹ˆë‹¤.',0),(148988,4139,'he','×”×¢×¨×”: ×”×ž×©×›×•×¨×•×ª ×—×™×™×‘ ×œ×”×™×•×ª ×”×•×“×¤×¡ ×ž×—×“×©, ×ª×•×§×¤×” ×©×œ ×”×ž×•×“×•×œ ×©×œ ×ž×©×›×•×¨×•×ª.',0),(148989,4139,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·: Î•Ï€Î¹Ï„Î±Î³Î­Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î±Î½Î±Ï„Ï…Ï€Ï‰Î¸ÎµÎ¯ ÎºÎ±Î¹ Î±ÎºÏ…ÏÏŽÎ½ÎµÏ„Î±Î¹ Î±Ï€ÏŒ ÏƒÏ„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ Ï„Î·Ï‚ ÎµÎ½ÏŒÏ„Î·Ï„Î±Ï‚ Ï„Î·Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚.',0),(148990,4139,'zh','æ³¨ï¼šå·¥èµ„æ”¯ç¥¨å¿…é¡»é‡å°å¹¶ä¸”ä»Žè–ªé‡‘æ¨¡å—å†…éƒ¨è„±ç¦»ã€‚\r\n',0),(148991,4139,'sv','Obs: LÃ¶ner kontroller mÃ¥ste omtryckt och annullerad frÃ¥n inom modulen lÃ¶nelistan.',0),(148992,4139,'it','Nota: Payroll controlli devono essere ristampati e annullati all\'interno del modulo paghe.',0),(148993,4139,'tl','',0),(148994,4139,'th','NOTE: Payroll Checks must be reprinted and voided from within the Payroll Module.',0),(148995,4139,'hi','à¤¨à¥‹à¤Ÿ: à¤ªà¥‡à¤°à¥‹à¤² à¤šà¥‡à¤• à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ reprinted à¤”à¤° à¤ªà¥‡à¤°à¥‹à¤² à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤¸à¥‡ voided.',0),(148996,4139,'ms','Nota: Cek gaji mesti dicetak semula dan voided dari dalam modul gaji.',0),(148997,4139,'ar','Ù…Ù„Ø§Ø­Ø¸Ø©: ÙŠØ¬Ø¨ Ø·Ø¨Ø¹ Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø±ÙˆØ§ØªØ¨ ÙˆØªÙØ±Øº Ù…Ù† Ø¶Ù…Ù† \"ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª\".',0),(148998,4139,'fr','NOTE : ChÃ¨ques de paie doivent Ãªtre rÃ©imprimÃ©s et annulÃ©s de dans le Module de paie.',0),(148999,4139,'jp','ãƒ¡ãƒ¢ï¼šçµ¦ä¸Žå°?åˆ‡æ‰‹ã?¯å†?å?°åˆ·ã?•ã‚Œã€?çµ¦ä¸Žãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã?®ä¸­ã?‹ã‚‰ç ´æ£„ã?•ã‚Œã?ªã??ã?¦ã?¯è¡Œã?‘ã?¾ã?›ã‚“ã€‚',0),(149000,4139,'pt','Nota: Pagamentos devem ser reproduzidos e anulados de dentro do mÃ³dulo de folha de pagamento.',0),(149001,4139,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ: Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð½Ñ‹ Ð¸ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð» Ð¾Ñ‚ Ð² Ð¿Ñ€ÐµÐ´ÐµÐ»Ð°Ñ… Ð¼Ð¾Ð´ÑƒÐ»Ñ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹.',0),(149002,4139,'es','NOTA: Cheques de NÃ³mina se reimprimen y anulados dentro del MÃ³dulo de la NÃ³mina',0),(149003,4139,'de','Hinweis: Personalabrechnung Kontrollen mÃ¼ssen nachgedruckt und stornierte von innerhalb des Payroll-Moduls.',0),(149004,4139,'en','NOTE: Payroll Checks must be reprinted and voided from within the Payroll Module.',0),(149005,4140,'is','',0),(149006,4140,'dr','Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø± ØªÙˆÙ„ÙŠØ¯ ',0),(149007,4140,'pr','Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø± ØªÙˆÙ„ÙŠØ¯ ',0),(149008,4140,'tr','ÃœrÃ¼n grafiÄŸi Sil',0),(149009,4140,'pl','Usuwanie produktu grafika',0),(149010,4140,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÐ½ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚',0),(149011,4140,'ur','Ù…ØµÙ†ÙˆØ¹Û Ú¯Ø±Ø§ÙÛŒ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(149012,4140,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(149013,4140,'vi','XÃ³a sáº£n pháº©m Ä‘á»“ há»a',0),(149014,4140,'af','Skrap Produk Grafika',0),(149015,4140,'ro','Åžtergere produs grafic',0),(149016,4140,'et','Kustuta toote pilt',0),(149017,4140,'si','Izbrisati grafiÄni izdelek',0),(149018,4140,'ba','Menghapus produk grafis',0),(149019,4140,'nl','Product afbeelding verwijderen',0),(149020,4140,'fi','Poista tuotteen kuva',0),(149021,4140,'no','Slette produktet grafikk',0),(149022,4140,'da','Slette fabrikat grafik',0),(149023,4140,'ko','ì œí’ˆ ê·¸ëž˜í”½ ì‚­ì œ',0),(149024,4140,'he','×ž×—×§ ×ž×•×¦×¨ ×’×¨×¤×™',0),(149025,4140,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚ Î³ÏÎ±Ï†Î¹ÎºÏŒ',0),(149026,4140,'zh','åˆªé™¤ç”¢å“åœ–ç‰‡',0),(149027,4140,'sv','Ta bort produkten grafik',0),(149028,4140,'it','Eliminare il prodotto grafico',0),(149029,4140,'tl','',0),(149030,4140,'th','&#3621;&#3610;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3585;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(149031,4140,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤• à¤¹à¤Ÿà¤¾à¤à¤',0),(149032,4140,'ms','Menghapuskan produk grafik',0),(149033,4140,'ar','Ø­Ø°Ù ØµÙˆØ±Ø© Ø§Ù„ØµÙ†Ù',0),(149034,4140,'fr','Supprimer produit graphique',0),(149035,4140,'jp','è£½å“?ç”»åƒ?ã?®æ¶ˆåŽ»',0),(149036,4140,'pt','Excluir produto grÃ¡fico',0),(149037,4140,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¾Ð³Ð¾ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(149038,4140,'es','Eliminar GrÃ¡fica de Producto',0),(149039,4140,'de','Produkt Grafik lÃ¶schen',0),(149040,4140,'en','Delete Product Graphic',0),(149041,4141,'is','',0),(149042,4141,'dr','Ø­Ø°Ù Ø¨Ø±Ú¯ ØªÙˆÙ„ÙŠØ¯ ',0),(149043,4141,'pr','Ø­Ø°Ù Ø¨Ø±Ú¯ ØªÙˆÙ„ÙŠØ¯ ',0),(149044,4141,'tr','ÃœrÃ¼n sayfasÄ± silmek',0),(149045,4141,'pl','UsuÅ„ arkusz produktu',0),(149046,4141,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸ÑÑ‚ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚',0),(149047,4141,'ur','Ù…ØµÙ†ÙˆØ¹Û ÙˆØ±Ù‚ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(149048,4141,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð»Ð¸ÑÑ‚Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(149049,4141,'vi','XÃ³a trang sáº£n pháº©m',0),(149050,4141,'af','Skrap produk vel',0),(149051,4141,'ro','Åžtergere produs foaie',0),(149052,4141,'et','Kustuta tooteleht',0),(149053,4141,'si','Izbrisati Product list',0),(149054,4141,'ba','Menghapus Produk Sheet',0),(149055,4141,'nl','Productfiche verwijderen',0),(149056,4141,'fi','Poista tuote-esite',0),(149057,4141,'no','Slette produktark',0),(149058,4141,'da','Slette produktblad',0),(149059,4141,'ko','ì œí’ˆ ì‹œíŠ¸ ì‚­ì œ',0),(149060,4141,'he','×œ×ž×—×•×§ ×ž×•×¦×¨ ×”×’×™×œ×™×•×Ÿ',0),(149061,4141,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï†Ï…Î»Î»Î¬Î´Î¹Î¿ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚',0),(149062,4141,'zh','åˆªé™¤ç”¢å“æ¸…å–®',0),(149063,4141,'sv','Ta bort produktblad',0),(149064,4141,'it','Eliminare la scheda prodotto',0),(149065,4141,'tl','',0),(149066,4141,'th','&#3621;&#3610;&#3649;&#3612;&#3656;&#3609;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(149067,4141,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤ªà¤¤à¥à¤°à¤• à¤¹à¤Ÿà¤¾à¤à¤',0),(149068,4141,'ms','Hapus kira-kira produk',0),(149069,4141,'ar','Ø­Ø°Ù Ù…Ù„ÙÙ‘ Ù…ÙˆØ§ØµÙØ§Øª Ø§Ù„ØµÙ†Ù',0),(149070,4141,'fr','Supprimer la fiche produit',0),(149071,4141,'jp','è£½å“?ã‚·ãƒ¼ãƒˆã?®æ¶ˆåŽ»',0),(149072,4141,'pt','Excluir folha de produto',0),(149073,4141,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° Ð»Ð¸ÑÑ‚Ð°',0),(149074,4141,'es','Eliminar Hoja de Producto',0),(149075,4141,'de','Produktblatt lÃ¶schen',0),(149076,4141,'en','Delete Product Sheet',0),(149077,4142,'is','',0),(149078,4142,'dr','Ùˆ Ø¨Ø§Ù„Ø§',0),(149079,4142,'pr','Ùˆ Ø¨Ø§Ù„Ø§',0),(149080,4142,'tr','Ve Ã¼zeri',0),(149081,4142,'pl','I w gÃ³rÄ™',0),(149082,4142,'bg','Ð˜ Ð½Ð°Ð³Ð¾Ñ€Ðµ',0),(149083,4142,'ur','Ø§ÙˆØ± Ø§Ù¾',0),(149084,4142,'sr','Ð˜ Ð³Ð¾Ñ€Ðµ',0),(149085,4142,'vi','VÃ  Cao HÆ¡n',0),(149086,4142,'af','En op',0),(149087,4142,'ro','Åži pÃ¢nÄƒ',0),(149088,4142,'et','Ja kuni',0),(149089,4142,'si','In Up',0),(149090,4142,'ba','Dan Up',0),(149091,4142,'nl','En hoger',0),(149092,4142,'fi','Ja jopa',0),(149093,4142,'no','Og opp',0),(149094,4142,'da','Og op',0),(149095,4142,'ko','ìµœëŒ€',0),(149096,4142,'he','×•×ž×¢×œ×”',0),(149097,4142,'el','ÎšÎ±Î¹ Î¼Î­Ï‡ÏÎ¹',0),(149098,4142,'zh','å’Œä¸Š\r\n',0),(149099,4142,'sv','Och upp',0),(149100,4142,'it','E fino',0),(149101,4142,'tl','',0),(149102,4142,'th','&#3649;&#3621;&#3632;&#3586;&#3657;&#3634;&#3591;&#3610;&#3609;',0),(149103,4142,'hi','à¤”à¤° à¤Šà¤ªà¤°',0),(149104,4142,'ms','Dan sehingga',0),(149105,4142,'ar','ÙˆÙŠØµÙ„',0),(149106,4142,'fr','Et Up',0),(149107,4142,'jp','ã‚ˆã‚Šä¸Š',0),(149108,4142,'pt','E atÃ©',0),(149109,4142,'ru','Ð˜ Ð²Ð²ÐµÑ€Ñ…',0),(149110,4142,'es','Y Arriba',0),(149111,4142,'de','Und bis',0),(149112,4142,'en','And Up',0),(149113,4143,'is','',0),(149114,4143,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù¾Ø§ÙŠÙ‡ Ù‡Ø±',0),(149115,4143,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù¾Ø§ÙŠÙ‡ Ù‡Ø±',0),(149116,4143,'tr','Temel Maliyet EsasÄ±',0),(149117,4143,'pl','Podstawowy koszt',0),(149118,4143,'bg','Ð‘Ð°Ð·Ð¾Ð²Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð° Ð½Ð°',0),(149119,4143,'ur','Ø¨Ù†ÛŒØ§Ø¯ÛŒ Ù‚ÛŒÙ…Øª ÙÛŒ',0),(149120,4143,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾',0),(149121,4143,'vi','GiÃ¡ thÃ nh cÆ¡ báº£n má»—i',0),(149122,4143,'af','Basiskoste Per',0),(149123,4143,'ro','Costul de bazÄƒ pe',0),(149124,4143,'et','Baasi pealt',0),(149125,4143,'si','Osnove stroÅ¡kov na',0),(149126,4143,'ba','Dasar biaya Per',0),(149127,4143,'nl','Basiskosten Per',0),(149128,4143,'fi','Base kustannukset',0),(149129,4143,'no','Base pris Per',0),(149130,4143,'da','Grundpris pr.',0),(149131,4143,'ko','ë‹¹ ê¸°ë³¸ ë¹„ìš©',0),(149132,4143,'he','×¢×œ×•×ª ×”×‘×¡×™×¡ ×œ×›×œ',0),(149133,4143,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ Î²Î¬ÏƒÎ·Ï‚',0),(149134,4143,'zh','åŸºæœ¬æˆæœ¬æ¯',0),(149135,4143,'sv','Bas kostnad Per',0),(149136,4143,'it','Costo base Per',0),(149137,4143,'tl','',0),(149138,4143,'th','&#3600;&#3634;&#3609;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3605;&#3656;&#3629;',0),(149139,4143,'hi','à¤¬à¥‡à¤¸ à¤®à¥‚à¤²à¥à¤¯ à¤ªà¥à¤°à¤¤à¤¿',0),(149140,4143,'ms','Asas bayaran',0),(149141,4143,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ø£Ø³Ø§Ø³ÙŠØ© Ù„Ù„ÙˆØ§Ø­Ø¯',0),(149142,4143,'fr','CoÃ»t de base par',0),(149143,4143,'jp','ãƒ¼ã?”ã?¨ã?®åŸºæº–åŽŸä¾¡',0),(149144,4143,'pt','Base de custo por',0),(149145,4143,'ru','Ð‘Ð°Ð·Ð¾Ð²Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(149146,4143,'es','Base Costo Por',0),(149147,4143,'de','Grundkosten pro',0),(149148,4143,'en','Base Cost Per',0),(149149,4144,'is','',0),(149150,4144,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø± ',0),(149151,4144,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø± ',0),(149152,4144,'tr','BaÅŸÄ± maliyet',0),(149153,4144,'pl','Koszt',0),(149154,4144,'bg','Ð¦ÐµÐ½Ð° Ð½Ð°',0),(149155,4144,'ur','ÙÛŒ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(149156,4144,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾',0),(149157,4144,'vi','GiÃ¡ má»—i',0),(149158,4144,'af','Koste Per',0),(149159,4144,'ro','Costul pe',0),(149160,4144,'et','Hind inimese kohta',0),(149161,4144,'si','StroÅ¡ki na',0),(149162,4144,'ba','Biaya Per',0),(149163,4144,'nl','Kosten Per',0),(149164,4144,'fi','Hinta Per',0),(149165,4144,'no','Kostnad Per',0),(149166,4144,'da','Omkostning pr.',0),(149167,4144,'ko','ë‹¹ ë¹„ìš©',0),(149168,4144,'he','×¢×œ×•×ª',0),(149169,4144,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬',0),(149170,4144,'zh','æ¯æ¬¡æˆæœ¬\r\n',0),(149171,4144,'sv','Kostnad Per',0),(149172,4144,'it','Costo Per',0),(149173,4144,'tl','',0),(149174,4144,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3605;&#3656;&#3629;',0),(149175,4144,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤²à¤¾à¤—à¤¤',0),(149176,4144,'ms','Kos setiap',0),(149177,4144,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ù„ÙƒÙ„',0),(149178,4144,'fr','CoÃ»t par',0),(149179,4144,'jp','å?˜ä¾¡',0),(149180,4144,'pt','Custo por',0),(149181,4144,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(149182,4144,'es','Costo Por',0),(149183,4144,'de','Kosten pro',0),(149184,4144,'en','Cost Per',0),(149185,4145,'is','',0),(149186,4145,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯  Ø¨Ù„Ù‡',0),(149187,4145,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯  Ø¨Ù„Ù‡',0),(149188,4145,'tr','Tamam alÄ±nan Ã¶ÄŸeler',0),(149189,4145,'pl','Pozycje OK',0),(149190,4145,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ ÐžÐš',0),(149191,4145,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©Ùˆ Ù¹Ú¾ÛŒÚ© Ù…Ù„ÛŒ',0),(149192,4145,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ»Ðµ ÐºÐ¾Ñ˜Ð¸ ÑÑƒ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð¸ Ñƒ Ñ€ÐµÐ´Ñƒ',0),(149193,4145,'vi','Nháº­n hÃ ng OK',0),(149194,4145,'af','Items Ontvang OK',0),(149195,4145,'ro','Elemente primit OK',0),(149196,4145,'et','Punkte saanud OK',0),(149197,4145,'si','Artiklih OK',0),(149198,4145,'ba','Item yang diterima OK',0),(149199,4145,'nl','Artikelen ontvangen OK',0),(149200,4145,'fi','Vastaanotetut OK',0),(149201,4145,'no','Varer mottatt OK',0),(149202,4145,'da','Varer modtaget OK',0),(149203,4145,'ko','í•­ëª© í™•ì¸ì„ ë°›ì€',0),(149204,4145,'he','×¤×¨×™×˜×™× ×©×”×ª×§×‘×œ×• ×‘×¡×“×¨',0),(149205,4145,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Î­Î»Î±Î²Îµ Î±Ï€ÏŒ ÎµÎ½Ï„Î¬Î¾ÎµÎ¹',0),(149206,4145,'zh','é¡¹ç›®æŽ¥æ”¶æˆåŠŸ\r\n',0),(149207,4145,'sv','Artiklar som mottagits OK',0),(149208,4145,'it','Elementi ricevuti OK',0),(149209,4145,'tl','',0),(149210,4145,'th','&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3605;&#3585;&#3621;&#3591;',0),(149211,4145,'hi','à¤†à¤‡à¤Ÿà¤® à¤ à¥€à¤• à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(149212,4145,'ms','Item-item yang diterima OK',0),(149213,4145,'ar','Ø§Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø³ØªÙ„Ù…Ø© Ù…ÙˆØ§ÙÙ‚',0),(149214,4145,'fr','Articles de rÃ©ception OK',0),(149215,4145,'jp','å“?ç›®å?—é ˜OK',0),(149216,4145,'pt','Itens recebidos OK',0),(149217,4145,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ ÐžÐš',0),(149218,4145,'es','Items Recibidos OK',0),(149219,4145,'de','Elemente empfangen OK',0),(149220,4145,'en','Items Received OK',0),(149221,4146,'is','',0),(149222,4146,'dr','Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù† Ø§ÙŠÙ†  Ù…Ù‚Ø¯Ø§Ø± ',0),(149223,4146,'pr','Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù† Ø§ÙŠÙ†  Ù…Ù‚Ø¯Ø§Ø± ',0),(149224,4146,'tr','Bu miktar kadar',0),(149225,4146,'pl','Do tej iloÅ›ci',0),(149226,4146,'bg','Ð”Ð¾ Ñ‚Ð¾Ð²Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾Ñ‚',0),(149227,4146,'ur','Ø§Ø³ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± ØªÚ©',0),(149228,4146,'sr','Ð—Ð°Ð²Ð¸ÑÐ¸ Ð¾Ð´ Ð¾Ð²Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(149229,4146,'vi','LÃªn tá»›i sá»‘ lÆ°á»£ng nÃ y cá»§a',0),(149230,4146,'af','Tot hierdie hoeveelheid',0),(149231,4146,'ro','PÃ¢nÄƒ la aceastÄƒ cantitate de',0),(149232,4146,'et','Kogusest jÃ¤tkub kuni',0),(149233,4146,'si','Do te koliÄine',0),(149234,4146,'ba','Sampai dengan jumlah ini',0),(149235,4146,'nl','Tot deze hoeveelheid',0),(149236,4146,'fi','Jopa tÃ¤stÃ¤ mÃ¤Ã¤rÃ¤stÃ¤',0),(149237,4146,'no','Til dette vareantallet',0),(149238,4146,'da','Denne mÃ¦ngde af',0),(149239,4146,'ko','ì´ ì–‘ê¹Œì§€',0),(149240,4146,'he','×¢×“ ×›×ž×•×ª ×–×• ×©×œ',0),(149241,4146,'el','ÎœÎ­Ï‡ÏÎ¹ Î±Ï…Ï„Î® Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï„Î·Ï‚',0),(149242,4146,'zh','å¤šè¾¾è¿™ä¸ªæ•°é‡\r\n',0),(149243,4146,'sv','Denna kvantitet av',0),(149244,4146,'it','Fino a questa quantitÃ  di',0),(149245,4146,'tl','',0),(149246,4146,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3629;&#3591;&#3609;&#3637;&#3657;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;',0),(149247,4146,'hi','à¤‡à¤¸ à¤•à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(149248,4146,'ms','Sehingga ini kuantiti',0),(149249,4146,'ar','ÙŠØµÙ„ Ø¥Ù„Ù‰ Ù‡Ø°Ù‡ Ø§Ù„ÙƒÙ…ÙŠØ© Ù…Ù†',0),(149250,4146,'fr','Jusqu\'Ã  cette quantitÃ© de',0),(149251,4146,'jp','ã?“ã?®é‡?ã?¾ã?§',0),(149252,4146,'pt','AtÃ© essa quantidade de',0),(149253,4146,'ru','Ð”Ð¾ ÑÑ‚Ð¾Ð³Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(149254,4146,'es','Hasta esta Cantidad de',0),(149255,4146,'de','Bis zu dieser Menge',0),(149256,4146,'en','Up to this Quantity of',0),(149257,4147,'is','',0),(149258,4147,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø®ÙŠØ±Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù†  Ø¹Ø±Ø¶Ù‡ ÙƒÙ†Ù†Ø¯Ù‡ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ØªØ¹ÙŠÙŠÙ† Ù†Ø´Ø¯',0),(149259,4147,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø®ÙŠØ±Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù†  Ø¹Ø±Ø¶Ù‡ ÙƒÙ†Ù†Ø¯Ù‡ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ØªØ¹ÙŠÙŠÙ† Ù†Ø´Ø¯',0),(149260,4147,'tr','SatÄ±cÄ± ÅŸu anda bu Ã¶ÄŸe iÃ§in bir tedarikÃ§i olarak ayarlamak.',0),(149261,4147,'pl','Dostawcy nie obecnie skonfigurowane jako dostawca dla tego elementu.',0),(149262,4147,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ð½Ðµ Ð·Ð°Ð´Ð°Ð´Ðµ ÐºÐ°Ñ‚Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ».',0),(149263,4147,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§Ø³ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ø³Ù¾Ù„Ø§Ø¦Ø± Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ ÙÛŒ Ø§Ù„Ø­Ø§Ù„ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(149264,4147,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ñ˜Ðµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾Ð´ÐµÑˆÐµÐ½Ð° ÐºÐ°Ð¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð».',0),(149265,4147,'vi','NgÆ°á»i bÃ¡n chÆ°a setup lÃ  nhÃ  cung cáº¥p cho hÃ ng nÃ y.',0),(149266,4147,'af','Verskaffer is nie huidiglik opgestel as \'n verskaffer vir hierdie item nie.',0),(149267,4147,'ro','VÃ¢nzÄƒtorul nu este configurat ca un furnizor pentru acest element.',0),(149268,4147,'et','Hankija selle kauba tarnija ei saa praegu luua.',0),(149269,4147,'si','Prodajalec ne trenutno nastavljeni kot dobavitelj za ta element.',0),(149270,4147,'ba','Penjual tidak sedang mengatur sebagai pemasok untuk item ini.',0),(149271,4147,'nl','Leverancier niet momenteel is ingesteld als een leverancier voor dit object.',0),(149272,4147,'fi','Toimittaja ei tÃ¤llÃ¤ hetkellÃ¤ on mÃ¤Ã¤ritetty Nimikkeen toimittaja.',0),(149273,4147,'no','LeverandÃ¸ren ikke er definert som en leverandÃ¸r for denne varen.',0),(149274,4147,'da','LeverandÃ¸ren ikke i Ã¸jeblikket konfigureret som en leverandÃ¸r for dette element.',0),(149275,4147,'ko','ê³µê¸‰ ì—…ì²´ëŠ” í˜„ìž¬ì´ í•­ëª©ì— ëŒ€ í•œ ê³µê¸‰ìžë¡œ ì„¤ì •í•©ë‹ˆë‹¤.',0),(149276,4147,'he','×”×¡×¤×§ ×œ× ×›×™×•× ×œ×”×’×“×™×¨ ×›×¡×¤×§ ×¢×‘×•×¨ ×¤×¨×™×˜ ×–×”.',0),(149277,4147,'el','Î•Ï€Î¯ Ï„Î¿Ï… Ï€Î±ÏÏŒÎ½Ï„Î¿Ï‚ Î´ÎµÎ½ Î¿ÏÎ¯ÏƒÎµÏ„Îµ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï‰Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿.',0),(149278,4147,'zh','ä¾›åº”å•†ç›®å‰æ²¡æœ‰è®¾ç«‹ä¸ºæœ¬é¡¹ç›®çš„ä¾›åº”å•†ã€‚\r\n',0),(149279,4147,'sv','LeverantÃ¶ren som fÃ¶r nÃ¤rvarande inte instÃ¤lld som leverantÃ¶r fÃ¶r objektet.',0),(149280,4147,'it','Fornitore non attualmente impostato come fornitore per questo elemento.',0),(149281,4147,'tl','',0),(149282,4147,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3648;&#3611;&#3655;&#3609;&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3627;&#3634;&#3623;&#3633;&#3',0),(149283,4147,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤†à¤ªà¥‚à¤°à¥à¤¤à¤¿à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤…à¤ªà¥¤',0),(149284,4147,'ms','Penjual tidak kini ditubuhkan sebagai pembekal untuk item ini.',0),(149285,4147,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ ØºÙŠØ± Ù…Ø­Ø¯Ù‘Ø¯ Ø­Ø§Ù„ÙŠØ§ ÙƒÙ…ØµØ¯Ø± Ù„Ù‡Ø°Ø§ Ø§Ù„ØµÙ†Ù',0),(149286,4147,'fr','Vendeur pas actuellement mis en place en tant que fournisseur pour cet Ã©lÃ©ment.',0),(149287,4147,'jp','ã?“ã?®å“?ç›®ã?®ä»•å…¥å…ˆã?®æ¥­è€…ã?Œç?¾åœ¨æŒ‡å®šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(149288,4147,'pt','Fornecedor nÃ£o estÃ¡ configurado como um fornecedor para este item.',0),(149289,4147,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ† Ð² Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð½Ðµ ÑÐ¾Ð·Ð´Ð°Ð½ ÐºÐ°Ðº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°.',0),(149290,4147,'es','Proveedor no actualmente configurado como un proveedor para este item',0),(149291,4147,'de','Kreditor eingerichtet derzeit nicht als Lieferant fÃ¼r dieses Element.',0),(149292,4147,'en','Vendor not currently set up as a supplier for this item.',0),(149293,4148,'is','',0),(149294,4148,'dr','Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ú†Ù†Ø¯ Ø¯Ù‚ÙŠÙ‚Ù‡ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø·ÙˆÙ„ Ø¨ÙƒØ´Ø¯ ',0),(149295,4148,'pr','Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ú†Ù†Ø¯ Ø¯Ù‚ÙŠÙ‚Ù‡ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø·ÙˆÙ„ Ø¨ÙƒØ´Ø¯ ',0),(149296,4148,'tr','Bu iÅŸlem birkaÃ§ dakika sÃ¼rebilir.',0),(149297,4148,'pl','MoÅ¼e to potrwaÄ‡ kilka minut.',0),(149298,4148,'bg','Ð¢Ð¾Ð²Ð° Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ñ‚Ð½ÐµÐ¼Ðµ Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð¸, Ð·Ð° Ð´Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð¸.',0),(149299,4148,'ur','ÛŒÛ Ø¹Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú†Ù†Ø¯ Ù…Ù†Ù¹ Ù„Ú¯ Ø³Ú©ØªØ§ ÛÛ’ Û”',0),(149300,4148,'sr','ÐžÐ²Ð¾ Ð¼Ð¾Ð¶Ðµ Ð¿Ð¾Ñ‚Ñ€Ð°Ñ˜Ð°Ñ‚Ð¸ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð° Ð·Ð° Ð¾Ð±Ñ€Ð°Ð´Ñƒ.',0),(149301,4148,'vi','Cáº§n vÃ i phÃºt Ä‘á»ƒ xá»­ lÃ½',0),(149302,4148,'af','Dit mag dalk \'n paar minute neem om te verwerk.',0),(149303,4148,'ro','Aceasta poate dura cÃ¢teva minute pentru a procesa.',0),(149304,4148,'et','Selleks vÃµib kuluda mÃµni minut tÃ¶Ã¶delda.',0),(149305,4148,'si','To lahko traja nekaj minut za obdelavo.',0),(149306,4148,'ba','Ini mungkin memakan waktu beberapa menit untuk proses.',0),(149307,4148,'nl','Dit duurt een paar minuten om te verwerken.',0),(149308,4148,'fi','TÃ¤mÃ¤ voi kestÃ¤Ã¤ muutaman minuutin kÃ¤sitellÃ¤.',0),(149309,4148,'no','Dette kan ta noen minutter Ã¥ behandle.',0),(149310,4148,'da','Dette kan tage et par minutter til at behandle.',0),(149311,4148,'ko','ì´ ì²˜ë¦¬ í•˜ëŠ” ë° ëª‡ ë¶„ ì •ë„ ê±¸ë¦´ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(149312,4148,'he','×¤×¢×•×œ×” ×–×• ×¢×©×•×™×” ×œ×”×™×ž×©×š ×ž×¡×¤×¨ ×“×§×•×ª ×›×“×™ ×œ×¢×‘×“.',0),(149313,4148,'el','Î‘Ï…Ï„ÏŒ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î¹Î±ÏÎºÎ­ÏƒÎµÎ¹ Î¼ÎµÏÎ¹ÎºÎ¬ Î»ÎµÏ€Ï„Î¬ Î³Î¹Î± Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±.',0),(149314,4148,'zh','è¿™å¯èƒ½éœ€è¦å‡ åˆ†é’Ÿçš„æ—¶é—´æ¥å¤„ç†ã€‚\r\n',0),(149315,4148,'sv','Detta kan ta nÃ¥gra minuter att bearbeta.',0),(149316,4148,'it','L\'operazione potrebbe richiedere alcuni minuti per elaborare.',0),(149317,4148,'tl','',0),(149318,4148,'th','&#3629;&#3634;&#3592;&#3592;&#3632;&#3651;&#3594;&#3657;&#3648;&#3623;&#3621;&#3634;&#3609;&#3657;&#3629;&#3618;&#3651;&#3609;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;',0),(149319,4148,'hi','à¤¯à¤¹ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤› à¤®à¤¿à¤¨à¤Ÿ à¤²à¤— à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(149320,4148,'ms','Ini mungkin mengambil beberapa minit untuk memproses.',0),(149321,4148,'ar','Ù‚Ø¯ ÙŠØ³ØªØºØ±Ù‚ Ù‡Ø°Ø§ Ø¨Ø¶Ø¹ Ø¯Ù‚Ø§Ø¦Ù‚ Ø¹Ù…Ù„ÙŠØ©.',0),(149322,4148,'fr','Cela peut prendre quelques minutes pour traiter.',0),(149323,4148,'jp','å‡¦ç?†ã?™ã‚‹ã?®ã?«ï¼’ãƒ»ï¼“åˆ†ã?‹ã?‹ã‚Šã?¾ã?™',0),(149324,4148,'pt','Isto pode levar alguns minutos para processar.',0),(149325,4148,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ñ€Ð¾Ñ†ÐµÑÑ Ð¼Ð¾Ð¶ÐµÑ‚ Ð·Ð°Ð½ÑÑ‚ÑŒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚.',0),(149326,4148,'es','Ã‰ste debe tomar unos minutos para procesar',0),(149327,4148,'de','Dies dauert ein paar Minuten verarbeiten.',0),(149328,4148,'en','This may take a few minutes to process.',0),(149329,4149,'is','',0),(149330,4149,'dr','Ù‡ÙŠÚ† Ø§Ø³Ù†Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(149331,4149,'pr','Ù‡ÙŠÚ† Ø§Ø³Ù†Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(149332,4149,'tr','Ã–deme kayÄ±t bulunamadÄ±',0),(149333,4149,'pl','Nie znaleziono rekordÃ³w pÅ‚atnoÅ›ci',0),(149334,4149,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(149335,4149,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ù…Ù„Ø§ ÛÛ’',0),(149336,4149,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð¸Ñ… Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(149337,4149,'vi','ChÆ°a tÃ¬m tháº¥y há»“ sÆ¡ thanh toÃ¡n',0),(149338,4149,'af','Geen Betalingsrekords Gevind',0),(149339,4149,'ro','Nici o platÄƒ Inregistrari gasite',0),(149340,4149,'et','Makse kirjeid ei leitud',0),(149341,4149,'si','Ni najdenih zapisov plaÄilo',0),(149342,4149,'ba','Tidak ada catatan pembayaran yang ditemukan',0),(149343,4149,'nl','Geen betaling Records gevonden',0),(149344,4149,'fi','Maksun merkintÃ¶jÃ¤ ei lÃ¶ydy',0),(149345,4149,'no','Finner ingen betalingsposter',0),(149346,4149,'da','Ingen betaling oplysninger fundet',0),(149347,4149,'ko','ì•„ë‹ˆ ì§€ë¶ˆ ë ˆì½”ë“œê°€ ì—†ìŠµë‹ˆë‹¤.',0),(149348,4149,'he','×œ× × ×ž×¦××• ×¨×©×•×ž×•×ª ×”×ª×©×œ×•×',0),(149349,4149,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(149350,4149,'zh','æ²¡æœ‰æ‰¾åˆ°æ”¯ä»˜è®°å½•\r\n',0),(149351,4149,'sv','Hittade inga betalning poster',0),(149352,4149,'it','Nessun record di pagamento trovato',0),(149353,4149,'tl','',0),(149354,4149,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(149355,4149,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(149356,4149,'ms','Tiada rekod pembayaran yang ditemui',0),(149357,4149,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø¯ÙØ¹',0),(149358,4149,'fr','Aucun documents de paiement trouvÃ©s',0),(149359,4149,'jp','æ”¯æ‰•è¨˜éŒ²ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(149360,4149,'pt','NÃ£o foram encontrados registos de pagamento',0),(149361,4149,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(149362,4149,'es','No se Encontraron Records de Pagos',0),(149363,4149,'de','Keine Zahlung DatensÃƒ Â¤ tze gefunden',0),(149364,4149,'en','No Payment Records Found',0),(149365,4150,'is','',0),(149366,4150,'dr','Ø§Ø² Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÙŠÙ† Ø®Ø±ÙˆØ¬ Ø§Ø² Ø³ÙŠØ³ØªÙ… Ø´Ù…Ø§',0),(149367,4150,'pr','Ø§Ø² Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÙŠÙ† Ø®Ø±ÙˆØ¬ Ø§Ø² Ø³ÙŠØ³ØªÙ… Ø´Ù…Ø§',0),(149368,4150,'tr','Beri senin son oturum kapatma',0),(149369,4150,'pl','Od swojego ostatniego wylogowania',0),(149370,4150,'bg','ÐžÑ‚ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ ÑÐ¸ Ð¸Ð·Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(149371,4150,'ur','Ú†ÙˆÙ†Ú©Û Ø¢Ù¾ Ø¢Ø®Ø±ÛŒ Ù„Ø§Ú¯ Ø¢ Ø¤Ù¹ ÛÙˆÚº',0),(149372,4150,'sr','ÐžÐ´ Ñ‚Ð²Ð¾Ñ˜Ðµ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ ÑÐµ Ð¾Ð´Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ',0),(149373,4150,'vi','Tá»« khi báº¡n Ä‘Äƒng xuáº¥t láº§n cuá»‘i',0),(149374,4150,'af','Sedert U Laas Uitgeteken het',0),(149375,4150,'ro','Deoarece dumneavoastrÄƒ ultima Logout',0),(149376,4150,'et','Sinu viimasest vÃ¤ljalogimisest',0),(149377,4150,'si','Od zadnje odjave',0),(149378,4150,'ba','Sejak Anda terakhir Logout',0),(149379,4150,'nl','Sinds uw laatste Logout',0),(149380,4150,'fi','Koska viime Logout',0),(149381,4150,'no','Siden din siste utlogging',0),(149382,4150,'da','Siden din sidste Logout',0),(149383,4150,'ko','ë‹¹ì‹ ì˜ ë§ˆì§€ë§‰ ë¡œê·¸ ì•„ì›ƒë¶€í„°',0),(149384,4150,'he','×ž××– ×”×ª× ×ª×§×•×ª ×”××—×¨×•×Ÿ ×©×œ×š',0),(149385,4150,'el','Î‘Ï€ÏŒ ÏƒÎ±Ï‚ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î±Ï€Î¿ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(149386,4150,'zh','è‡ªæ‚¨ä¸Šæ¬¡é€€å‡º\r\n',0),(149387,4150,'sv','Sedan din senaste logga ut',0),(149388,4150,'it','Dal tuo ultimo Logout',0),(149389,4150,'tl','',0),(149390,4150,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(149391,4150,'hi','à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥‡ à¤…à¤ªà¤¨à¥‡ à¤ªà¤¿à¤›à¤²à¥‡ à¤²à¥‰à¤—à¤†à¤‰à¤Ÿ',0),(149392,4150,'ms','Sejak anda log keluar lepas',0),(149393,4150,'ar','ÙˆÙ…Ù†Ø° Ø®Ø±ÙˆØ¬ Ø§Ù„Ø£Ø®ÙŠØ± Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(149394,4150,'fr','Depuis votre derniÃ¨re dÃ©connexion',0),(149395,4150,'jp','æœ€å¾Œã?®ãƒ­ã‚°ã‚¢ã‚¦ãƒˆã?‹ã‚‰',0),(149396,4150,'pt','Desde seu Ãºltimo Logout',0),(149397,4150,'ru','Ð¡ ÐœÐ¾Ð¼ÐµÐ½Ñ‚Ð° ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ Ð’Ñ…Ð¾Ð´Ð°',0),(149398,4150,'es','Desde Su Ãšltimo Logout',0),(149399,4150,'de','Seit Ihrem letzten Logout',0),(149400,4150,'en','Since Your Last Logout',0),(149401,4151,'is','',0),(149402,4151,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¬Ø¯ÙŠØ¯ ',0),(149403,4151,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¬Ø¯ÙŠØ¯ ',0),(149404,4151,'tr','Yeni mÃ¼ÅŸteriler',0),(149405,4151,'pl','Nowych klientÃ³w',0),(149406,4151,'bg','ÐÐ¾Ð²Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(149407,4151,'ur','Ù†Ø¦Û’ ØµØ§Ø±ÙÛŒÙ†',0),(149408,4151,'sr','ÐÐ¾Ð²Ðµ ÐºÑƒÐ¿Ñ†Ðµ',0),(149409,4151,'vi','KhÃ¡ch hÃ ng má»›i',0),(149410,4151,'af','Nuwe Klante/KliÃ«nte',0),(149411,4151,'ro','ClienÅ£ii noi',0),(149412,4151,'et','Uued kliendid',0),(149413,4151,'si','Nove stranke',0),(149414,4151,'ba','Pelanggan Baru',0),(149415,4151,'nl','Nieuwe klanten',0),(149416,4151,'fi','Uusia asiakkaita',0),(149417,4151,'no','Nye kunder',0),(149418,4151,'da','Nye kunder',0),(149419,4151,'ko','ìƒˆë¡œìš´ ê³ ê°',0),(149420,4151,'he','×œ×§×•×—×•×ª ×—×“×©×™×',0),(149421,4151,'el','ÎÎ­Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(149422,4151,'zh','æ–°å®¢æˆ·',0),(149423,4151,'sv','Nya kunder',0),(149424,4151,'it','Nuovi clienti',0),(149425,4151,'tl','',0),(149426,4151,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(149427,4151,'hi','à¤¨à¤ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(149428,4151,'ms','Pelanggan baru',0),(149429,4151,'ar','Ø²Ø¨Ø§Ø¦Ù† Ø¬Ø¯Ø¯',0),(149430,4151,'fr','Nouveaux clients',0),(149431,4151,'jp','æ–°è¦?é¡§å®¢',0),(149432,4151,'pt','Novos clientes',0),(149433,4151,'ru','ÐÐ¾Ð²Ñ‹Ðµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹',0),(149434,4151,'es','Nuevos Clientes',0),(149435,4151,'de','Neue Kunden',0),(149436,4151,'en','New Customers',0),(149437,4152,'is','',0),(149438,4152,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÙŠØ¯ ',0),(149439,4152,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÙŠØ¯ ',0),(149440,4152,'tr','Yeni sipariÅŸler',0),(149441,4152,'pl','Nowe zamÃ³wienia',0),(149442,4152,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(149443,4152,'ur','Ù†Ø¦Û’ Ø§Ø­Ú©Ø§Ù… Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚',0),(149444,4152,'sr','ÐÐ¾Ð²Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(149445,4152,'vi','ÄÆ¡n Ä‘áº·t hÃ ng má»›i',0),(149446,4152,'af','Nuwe Bestellings',0),(149447,4152,'ro','Comenzile noi',0),(149448,4152,'et','Uued tellimused',0),(149449,4152,'si','Nova naroÄila',0),(149450,4152,'ba','Pesanan baru',0),(149451,4152,'nl','Nieuwe Orders',0),(149452,4152,'fi','Uusia tilauksia',0),(149453,4152,'no','Nye ordrer',0),(149454,4152,'da','Nye ordrer',0),(149455,4152,'ko','ì‹ ê·œ ì£¼ë¬¸',0),(149456,4152,'he','×”×–×ž× ×•×ª ×—×“×©×•×ª',0),(149457,4152,'el','ÎÎ­ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(149458,4152,'zh','æ–°è®¢å•\r\n',0),(149459,4152,'sv','Nya order',0),(149460,4152,'it','Nuovi ordini',0),(149461,4152,'tl','',0),(149462,4152,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3649;&#3621;&#3632;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(149463,4152,'hi','à¤¨à¤ à¤†à¤¦à¥‡à¤¶',0),(149464,4152,'ms','Perintah baru',0),(149465,4152,'ar','Ø·Ù„Ø¨ÙŠØ§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(149466,4152,'fr','Commandes nouveau',0),(149467,4152,'jp','æ–°è¦?æ³¨æ–‡',0),(149468,4152,'pt','Novas ordens',0),(149469,4152,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(149470,4152,'es','Nuevos Ordenes',0),(149471,4152,'de','Neue AuftrÃ¤ge',0),(149472,4152,'en','New Orders',0),(149473,4153,'is','',0),(149474,4153,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(149475,4153,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(149476,4153,'tr','Sevk edilen sipariÅŸler',0),(149477,4153,'pl','ZamÃ³wienia wysyÅ‚ane',0),(149478,4153,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(149479,4153,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(149480,4153,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(149481,4153,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ chuyá»ƒn',0),(149482,4153,'af','Versende Bestellings',0),(149483,4153,'ro','Comenzile expediate',0),(149484,4153,'et','Tarnitud tellimused',0),(149485,4153,'si','Ob dobavi naroÄila',0),(149486,4153,'ba','Pesanan dikirim',0),(149487,4153,'nl','Verzonden bestellingen',0),(149488,4153,'fi','LÃ¤hetetyt tilaukset',0),(149489,4153,'no','Sendte bestillinger',0),(149490,4153,'da','Afsendt ordrer',0),(149491,4153,'ko','ë°°ì†¡ëœ ì£¼ë¬¸',0),(149492,4153,'he','×”×–×ž× ×•×ª ×©× ×©×œ×—×•',0),(149493,4153,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(149494,4153,'zh','å‘è´§çš„è®¢å•\r\n',0),(149495,4153,'sv','Levererade order',0),(149496,4153,'it','Ordini spediti',0),(149497,4153,'tl','',0),(149498,4153,'th','&#3651;&#3610;&#3626;&#3656;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(149499,4153,'hi','à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶',0),(149500,4153,'ms','Pesanan yang dihantar',0),(149501,4153,'ar','Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(149502,4153,'fr','Commandes envoyes',0),(149503,4153,'jp','ç™ºé€?æ¸ˆæ³¨æ–‡',0),(149504,4153,'pt','Pedidos enviados',0),(149505,4153,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(149506,4153,'es','Ordenes Enviados',0),(149507,4153,'de','Gelieferte Bestellungen',0),(149508,4153,'en','Shipped Orders',0),(149509,4154,'is','',0),(149510,4154,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø®ÙŠØ±Ø§ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(149511,4154,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø®ÙŠØ±Ø§ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(149512,4154,'tr','Son zamanlarda alÄ±nan sipariÅŸler',0),(149513,4154,'pl','Niedawno otrzymaÅ‚ zamÃ³wienia',0),(149514,4154,'bg','ÐÐ°ÑÐºÐ¾Ñ€Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(149515,4154,'ur','Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº ÙˆØµÙˆÙ„ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(149516,4154,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(149517,4154,'vi','ÄÆ¡n hÃ ng nháº­n gáº§n Ä‘Ã¢y',0),(149518,4154,'af','Onlangse Ontvangde Bestellings',0),(149519,4154,'ro','Recent primit comenzi',0),(149520,4154,'et','Hiljuti saadud tellimused',0),(149521,4154,'si','Nedavno prejemalo naroÄila',0),(149522,4154,'ba','Baru saja menerima pesanan',0),(149523,4154,'nl','Onlangs ontvangen Orders',0),(149524,4154,'fi','Ã„skettÃ¤in tilauksia',0),(149525,4154,'no','Sist mottatte ordrer',0),(149526,4154,'da','For nylig modtaget ordrer',0),(149527,4154,'ko','ìµœê·¼ ë°›ì€ ì£¼ë¬¸',0),(149528,4154,'he','×”×–×ž× ×•×ª ×©×”×ª×§×‘×œ×• ×œ××—×¨×•× ×”',0),(149529,4154,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î± Î»Î¬Î²ÎµÎ¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(149530,4154,'zh','æœ€è¿‘æ”¶åˆ°çš„è®¢å•\r\n',0),(149531,4154,'sv','Nyligen mottagna order',0),(149532,4154,'it','Recentemente gli ordini ricevuti',0),(149533,4154,'tl','',0),(149534,4154,'th','&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3649;&#3621;&#3657;&#3623;',0),(149535,4154,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤†à¤¦à¥‡à¤¶',0),(149536,4154,'ms','Tempahan tempahan diterima',0),(149537,4154,'ar','Ù…Ø¤Ø®Ø±Ø§ ØªÙ„Ù‚Øª Ø£ÙˆØ§Ù…Ø±',0),(149538,4154,'fr','RÃ©cemment les ordres reÃ§us',0),(149539,4154,'jp','æœ€è¿‘å?—ã?‘ã?Ÿæ³¨æ–‡',0),(149540,4154,'pt','Recentemente recebeu ordens',0),(149541,4154,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¾ ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(149542,4154,'es','Ordenes Recientemente Recibidos',0),(149543,4154,'de','KÃ¼rzlich eingegangenen Bestellungen',0),(149544,4154,'en','Recently Received Orders',0),(149545,4155,'is','',0),(149546,4155,'dr','ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(149547,4155,'pr','ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²',0),(149548,4155,'tr','TÃ¼m aÃ§Ä±k sipariÅŸler',0),(149549,4155,'pl','Wszystkie otwarte zlecenia',0),(149550,4155,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(149551,4155,'ur','ØªÙ…Ø§Ù… Ú©Ú¾Ù„ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(149552,4155,'sr','Ð¡Ð²Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(149553,4155,'vi','Táº¥t cáº£ Ä‘Æ¡n hÃ ng má»Ÿ',0),(149554,4155,'af','Alle Oop Bestellings',0),(149555,4155,'ro','Ordinele deschise',0),(149556,4155,'et','KÃµik avatud tellimused',0),(149557,4155,'si','Vsa odprta naroÄila',0),(149558,4155,'ba','Semua pesanan',0),(149559,4155,'nl','Alle Open Orders',0),(149560,4155,'fi','Kaikki avoimet tilaukset',0),(149561,4155,'no','Alle Ã¥pne ordrer',0),(149562,4155,'da','Alle Ã¥bne ordrer',0),(149563,4155,'ko','ì—´ë ¤ ìžˆëŠ” ëª¨ë“  ëª…ë ¹',0),(149564,4155,'he','×›×œ ×”×”×–×ž× ×•×ª ×”×¤×ª×•×—×•×ª',0),(149565,4155,'el','ÎŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î±Î½Î¿Î¹ÎºÏ„Î­Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(149566,4155,'zh','æ‰€æœ‰æœªç»“è®¢å•\r\n',0),(149567,4155,'sv','Alla Ã¶ppna order',0),(149568,4155,'it','Ordini tutti aperti',0),(149569,4155,'tl','',0),(149570,4155,'th','&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(149571,4155,'hi','à¤¸à¤­à¥€ à¤–à¥à¤²à¥‡ à¤†à¤¦à¥‡à¤¶',0),(149572,4155,'ms','Perintah terbuka',0),(149573,4155,'ar','Ø£ÙˆØ§Ù…Ø± ÙØªØ­ Ø¬Ù…ÙŠØ¹',0),(149574,4155,'fr','Commandes ouvertes',0),(149575,4155,'jp','å…¨ã?¦ã?®ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡',0),(149576,4155,'pt','Aberto todas as ordens',0),(149577,4155,'ru','Ð’ÑÐµ ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(149578,4155,'es','Todos los Ordenes Abiertos',0),(149579,4155,'de','Alle offenen Bestellungen',0),(149580,4155,'en','All Open Orders',0),(149581,4156,'is','',0),(149582,4156,'dr','7 Ø±ÙˆØ²Ù‡',0),(149583,4156,'pr','7 Ø±ÙˆØ²Ù‡',0),(149584,4156,'tr','7 gÃ¼n',0),(149585,4156,'pl','7 dni',0),(149586,4156,'bg','7 Ð´Ð½Ð¸',0),(149587,4156,'ur','Ø³Ø§Øª Ø¯Ù†',0),(149588,4156,'sr','7 Ð´Ð°Ð½Ð°',0),(149589,4156,'vi','7 ngÃ y',0),(149590,4156,'af','7 dae',0),(149591,4156,'ro','7 zile',0),(149592,4156,'et','7 pÃ¤eva',0),(149593,4156,'si','7 dni',0),(149594,4156,'ba','7 Hari',0),(149595,4156,'nl','7 dagen',0),(149596,4156,'fi','7 pv',0),(149597,4156,'no','7 dager',0),(149598,4156,'da','7 dage',0),(149599,4156,'ko','7 ì¼',0),(149600,4156,'he','â€7 ×™×ž×™×',0),(149601,4156,'el','7 Î—Î¼Î­ÏÎµÏ‚',0),(149602,4156,'zh','7 å¤©',0),(149603,4156,'sv','7 dagar',0),(149604,4156,'it','7 giorni',0),(149605,4156,'tl','',0),(149606,4156,'th','7 à¸§à¸±à¸™',0),(149607,4156,'hi','7 à¤¦à¤¿à¤¨',0),(149608,4156,'ms','7 hari',0),(149609,4156,'ar','Ø³Ø¨Ø¹Ø© Ø£ÙŠØ§Ù…',0),(149610,4156,'fr','7 Jours',0),(149611,4156,'jp','ï¼—æ—¥',0),(149612,4156,'pt','7 dias',0),(149613,4156,'ru','7 Ð´Ð½ÐµÐ¹',0),(149614,4156,'es','7 dÃ­as',0),(149615,4156,'de','7 Tage',0),(149616,4156,'en','7 days',0),(149617,4157,'is','',0),(149618,4157,'dr','ØªØ§Ø±ÙŠØ® Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(149619,4157,'pr','ØªØ§Ø±ÙŠØ® Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(149620,4157,'tr','AlÄ±nan',0),(149621,4157,'pl','OtrzymaÅ‚',0),(149622,4157,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸',0),(149623,4157,'ur','Ù…ÙˆØµÙˆÙ„',0),(149624,4157,'sr','ÐŸÑ€Ð¸Ð¼Ð¸Ð¾',0),(149625,4157,'vi','ÄÃ£ nháº­n',0),(149626,4157,'af','Ontvang',0),(149627,4157,'ro','Primit',0),(149628,4157,'et','Saadud',0),(149629,4157,'si','Prejel',0),(149630,4157,'ba','Menerima',0),(149631,4157,'nl','Ontvangen',0),(149632,4157,'fi','Saanut',0),(149633,4157,'no','Mottatt',0),(149634,4157,'da','Modtaget',0),(149635,4157,'ko','ë°›ì€',0),(149636,4157,'he','×”×ª×§×‘×œ',0),(149637,4157,'el','ÎˆÎ»Î±Î²Îµ',0),(149638,4157,'zh','æ”¶åˆ°\r\n',0),(149639,4157,'sv','Fick',0),(149640,4157,'it','Ricevuto',0),(149641,4157,'tl','',0),(149642,4157,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(149643,4157,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(149644,4157,'ms','Diterima',0),(149645,4157,'ar','ÙˆØªÙ„Ù‚Ù‰',0),(149646,4157,'fr','ReÃ§u',0),(149647,4157,'jp','å?—é ˜æ¸ˆ',0),(149648,4157,'pt','Recebido',0),(149649,4157,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ð»',0),(149650,4157,'es','Recibido',0),(149651,4157,'de','Empfangen',0),(149652,4157,'en','Received',0),(149653,4158,'is','',0),(149654,4158,'dr','Ù‡Ù…Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² ',0),(149655,4158,'pr','Ù‡Ù…Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² ',0),(149656,4158,'tr','TÃ¼m aÃ§Ä±k sipariÅŸler',0),(149657,4158,'pl','Wszystkie otwarte zlecenia',0),(149658,4158,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(149659,4158,'ur','ØªÙ…Ø§Ù… Ú©Ú¾Ù„ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(149660,4158,'sr','Ð¡Ð²Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(149661,4158,'vi','Táº¥t Cáº£ CÃ¡c ÄÆ¡n Äáº·t HÃ ng Äang Má»Ÿ',0),(149662,4158,'af','Alle Open Bestellings',0),(149663,4158,'ro','Ordinele deschise',0),(149664,4158,'et','KÃµik avatud tellimused',0),(149665,4158,'si','Vsa odprta naroÄila',0),(149666,4158,'ba','Semua Pesanan yang terbuka',0),(149667,4158,'nl','Alle Open Orders',0),(149668,4158,'fi','Kaikki avoimet tilaukset',0),(149669,4158,'no','Alle Ã¥pne ordrer',0),(149670,4158,'da','Alle Ã¥bne ordrer',0),(149671,4158,'ko','ì—´ë ¤ ìžˆëŠ” ëª¨ë“  ëª…ë ¹',0),(149672,4158,'he','×›×œ ×”×”×–×ž× ×•×ª ×”×¤×ª×•×—×•×ª',0),(149673,4158,'el','ÎŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î±Î½Î¿Î¹ÎºÏ„Î­Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(149674,4158,'zh','æ‰€æœ‰æœªç»“è®¢å•\r\n',0),(149675,4158,'sv','Alla Ã¶ppna order',0),(149676,4158,'it','Ordini Aperti Tutti',0),(149677,4158,'tl','',0),(149678,4158,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3611;&#3636;&#3604;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(149679,4158,'hi','à¤¸à¤­à¥€ à¤–à¥à¤²à¥‡ à¤†à¤¦à¥‡à¤¶',0),(149680,4158,'ms','Perintah terbuka',0),(149681,4158,'ar','Ø£ÙˆØ§Ù…Ø± ÙØªØ­ Ø¬Ù…ÙŠØ¹',0),(149682,4158,'fr','Commandes ouvertes',0),(149683,4158,'jp','å…¨ã?¦ã?®ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡',0),(149684,4158,'pt','Aberto todas as ordens',0),(149685,4158,'ru','Ð’ÑÐµ ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(149686,4158,'es','Todo los Pedidos Abiertos',0),(149687,4158,'de','Alle offenen Bestellungen',0),(149688,4158,'en','All Open Orders',0),(149689,4159,'is','',0),(149690,4159,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø§Ø®ÙŠØ±Ø§ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ ',0),(149691,4159,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø§Ø®ÙŠØ±Ø§ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ ',0),(149692,4159,'tr','Son zamanlarda eklenen mÃ¼ÅŸteriler',0),(149693,4159,'pl','Ostatnio dodane klienci',0),(149694,4159,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(149695,4159,'ur','Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ú¯Ø§ÛÚ©',0),(149696,4159,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¾ ÐºÑƒÐ¿Ñ†Ðµ',0),(149697,4159,'vi','KhÃ¡ch hÃ ng thÃªm vÃ o gáº§n Ä‘Ã¢y ',0),(149698,4159,'af','Onlangs Geskepte Klante/KliÃ«nte',0),(149699,4159,'ro','Recent adÄƒugat clienÅ£ii',0),(149700,4159,'et','Hiljuti lisatud kliendid',0),(149701,4159,'si','Nedavno dodano stranke',0),(149702,4159,'ba','Baru saja ditambahkan pelanggan',0),(149703,4159,'nl','Onlangs toegevoegde klanten',0),(149704,4159,'fi','Ã„skettÃ¤in lisÃ¤tty asiakkaat',0),(149705,4159,'no','Nylig lagt til kunder',0),(149706,4159,'da','For nylig tilfÃ¸jet kunder',0),(149707,4159,'ko','ìµœê·¼ ì¶”ê°€ ëœ ê³ ê°',0),(149708,4159,'he','×œ×§×•×—×•×ª ×©× ×•×¡×¤×• ×œ××—×¨×•× ×”',0),(149709,4159,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î± Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(149710,4159,'zh','è¿‘æœŸæ–°å¢žå®¢æˆ·\r\n',0),(149711,4159,'sv','Nyligen tillagda kunder',0),(149712,4159,'it','Recentemente aggiunti clienti',0),(149713,4159,'tl','',0),(149714,4159,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(149715,4159,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡ à¤—à¤ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(149716,4159,'ms','Tempahan tambahan pelanggan',0),(149717,4159,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ØªÙ… Ø¥Ø¶Ø§ÙØªÙ‡Ù… Ù…Ø¤Ø®Ø±Ø§',0),(149718,4159,'fr','RÃ©cemment ajoutÃ©s clients',0),(149719,4159,'jp','æœ€è¿‘è¿½åŠ ã?•ã‚Œã?Ÿé¡§å®¢',0),(149720,4159,'pt','Recentemente adicionados clientes',0),(149721,4159,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹',0),(149722,4159,'es','Clientes Agregados Recientemente',0),(149723,4159,'de','KÃ¼rzlich hinzugefÃ¼gte Kunden',0),(149724,4159,'en','Recently Added Customers',0),(149725,4160,'is','',0),(149726,4160,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ§Ø±ÙŠØ® ',0),(149727,4160,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ§Ø±ÙŠØ® ',0),(149728,4160,'tr','Tarih Ekle',0),(149729,4160,'pl','Dodawanie daty',0),(149730,4160,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(149731,4160,'ur','ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(149732,4160,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(149733,4160,'vi','ThÃªm NgÃ y',0),(149734,4160,'af','Voeg \'n Datum by',0),(149735,4160,'ro','Adauga data',0),(149736,4160,'et','Lisa kuupÃ¤ev',0),(149737,4160,'si','Dodajte datum',0),(149738,4160,'ba','Tambahkan tanggal',0),(149739,4160,'nl','Datum toevoegen',0),(149740,4160,'fi','LisÃ¤Ã¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(149741,4160,'no','Legge dato',0),(149742,4160,'da','TilfÃ¸je dato',0),(149743,4160,'ko','ë‚ ì§œ ì¶”ê°€',0),(149744,4160,'he','×”×•×¡×£ ×ª××¨×™×š',0),(149745,4160,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(149746,4160,'zh','å¢žåŠ æ—¥æœŸ',0),(149747,4160,'sv','LÃ¤gg till datum',0),(149748,4160,'it','Aggiungi data',0),(149749,4160,'tl','',0),(149750,4160,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(149751,4160,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(149752,4160,'ms','Tambah tarikh',0),(149753,4160,'ar','Ø£Ø¶Ù ØªØ§Ø±ÙŠØ®',0),(149754,4160,'fr','Ajouter Date',0),(149755,4160,'jp','è¿½åŠ æ¸ˆ',0),(149756,4160,'pt','Adicionar Data',0),(149757,4160,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ð°Ñ‚Ñƒ',0),(149758,4160,'es','Agregar Fecha',0),(149759,4160,'de','HinzugefÃ¼gt',0),(149760,4160,'en','Add Date',0),(149761,4161,'is','',0),(149762,4161,'dr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø±',0),(149763,4161,'pr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø±',0),(149764,4161,'tr','MÃ¼ÅŸteri listesini gÃ¶rÃ¼ntÃ¼le',0),(149765,4161,'pl','Widok lista klientÃ³w',0),(149766,4161,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº',0),(149767,4161,'ur','Ù…Ù†Ø¸Ø± Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ÙÛØ±Ø³Øª',0),(149768,4161,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð»Ð¸ÑÑ‚Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(149769,4161,'vi','Xem danh sÃ¡ch khÃ¡ch hÃ ng ',0),(149770,4161,'af','Besigtig Klant/KliÃ«nt Lys',0),(149771,4161,'ro','Vezi lista de client',0),(149772,4161,'et','Vaata kliedinimekirja',0),(149773,4161,'si','Seznam kupcev pogled',0),(149774,4161,'ba','Lihat daftar pelanggan',0),(149775,4161,'nl','Bekijk de lijst van de klant',0),(149776,4161,'fi','NÃ¤ytÃ¤ asiakasluettelo',0),(149777,4161,'no','Vis kundelisten',0),(149778,4161,'da','Se kundeliste',0),(149779,4161,'ko','ê³ ê° ëª©ë¡ ë³´ê¸°',0),(149780,4161,'he','×ª×¦×•×’×ª ×¨×©×™×ž×ª ×œ×§×•×—×•×ª',0),(149781,4161,'el','Î›Î¯ÏƒÏ„Î± Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Ï€ÏÎ¿Î²Î¿Î»Î®',0),(149782,4161,'zh','æŸ¥çœ‹å®¢æˆ·åå•\r\n',0),(149783,4161,'sv','Visa kundlista',0),(149784,4161,'it','Vedi la lista dei clienti',0),(149785,4161,'tl','',0),(149786,4161,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(149787,4161,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‚à¤šà¥€ à¤¦à¥‡à¤–à¥‡à¤‚',0),(149788,4161,'ms','Lihat senarai pelanggan',0),(149789,4161,'ar','Ø¹Ø±Ø¶ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(149790,4161,'fr','Liste d\'affichage de client',0),(149791,4161,'jp','é¡§å®¢ãƒªã‚¹ãƒˆã‚’è¦‹ã‚‹',0),(149792,4161,'pt','Ver lista de cliente',0),(149793,4161,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¡Ð¿Ð¸ÑÐºÐ° ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(149794,4161,'es','Visionar Lista de Clientes',0),(149795,4161,'de','Ansicht-Kundenliste',0),(149796,4161,'en','View Customer List',0),(149797,4162,'is','',0),(149798,4162,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(149799,4162,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(149800,4162,'tr','TamamlanmÄ±ÅŸ sipariÅŸleri',0),(149801,4162,'pl','ZamÃ³wienia ukoÅ„czone',0),(149802,4162,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½',0),(149803,4162,'ur','Ù…Ú©Ù…Ù„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(149804,4162,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð°',0),(149805,4162,'vi','ÄÆ¡n Äáº·t HÃ ng HoÃ n ThÃ nh',0),(149806,4162,'af','Bestellings Voltooi',0),(149807,4162,'ro','Comenzi finalizate',0),(149808,4162,'et','LÃµpetatud tellimused',0),(149809,4162,'si','DokonÄana naroÄila',0),(149810,4162,'ba','Pesanan Terpenuhi',0),(149811,4162,'nl','Bestellingen voltooid',0),(149812,4162,'fi','Tilaukset pÃ¤Ã¤tÃ¶kseen',0),(149813,4162,'no','Bestillinger',0),(149814,4162,'da','Ordrer afsluttet',0),(149815,4162,'ko','ì£¼ë¬¸ ì™„ë£Œ',0),(149816,4162,'he','×”×”×–×ž× ×•×ª ×”×¡×ª×™×™×ž×•',0),(149817,4162,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(149818,4162,'zh','è®¢å•å®Œæˆ\r\n',0),(149819,4162,'sv','Order slutfÃ¶rts',0),(149820,4162,'it','Ordini Completati',0),(149821,4162,'tl','',0),(149822,4162,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;',0),(149823,4162,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥‚à¤°à¤¾',0),(149824,4162,'ms','Perintah-perintah yang telah siap',0),(149825,4162,'ar','Ø¥Ù†Ø¬Ø§Ø² Ø·Ù„Ø¨Ø§Øª',0),(149826,4162,'fr','Commandes complete',0),(149827,4162,'jp','å®Œäº†ã?—ã?Ÿæ³¨æ–‡',0),(149828,4162,'pt','Encomendas concluÃ­das',0),(149829,4162,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹',0),(149830,4162,'es','Pedidos Completados',0),(149831,4162,'de','Abgeschlossene Bestellungen',0),(149832,4162,'en','Orders Completed',0),(149833,4163,'is','',0),(149834,4163,'dr','Ø¯Ù„Ø§Ø± ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(149835,4163,'pr','Ø¯Ù„Ø§Ø± ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(149836,4163,'tr','Dolar tamamlandÄ±',0),(149837,4163,'pl','DolarÃ³w zakoÅ„czone',0),(149838,4163,'bg','Ð”Ð¾Ð»Ð°Ñ€Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½',0),(149839,4163,'ur','ÚˆØ§Ù„Ø± Ù…Ú©Ù…Ù„',0),(149840,4163,'sr','Ð”Ð¾Ð»Ð°Ñ€Ð° Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð°',0),(149841,4163,'vi','HoÃ n thÃ nh dola',0),(149842,4163,'af','Dollars voltooi',0),(149843,4163,'ro','Completat de dolari',0),(149844,4163,'et','Eurot lÃµpetatud',0),(149845,4163,'si','Dolarjev, ki so zakljuÄili',0),(149846,4163,'ba','Dolar selesai',0),(149847,4163,'nl','Dollar voltooid',0),(149848,4163,'fi','Dollareita valmis',0),(149849,4163,'no','Dollar fullfÃ¸rt',0),(149850,4163,'da','Dollars afsluttet',0),(149851,4163,'ko','ì™„ë£Œ ë‹¬ëŸ¬',0),(149852,4163,'he','×“×•×œ×¨ ×”×•×©×œ×ž×”',0),(149853,4163,'el','Î”Î¿Î»Î±ÏÎ¯Ï‰Î½ Ï€Î¿Ï… Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ¸Î·ÎºÎµ',0),(149854,4163,'zh','ç¾Žå…ƒå·²å®Œæˆ\r\n',0),(149855,4163,'sv','Dollar avslutade',0),(149856,4163,'it','Dollari completati',0),(149857,4163,'tl','',0),(149858,4163,'th','&#3648;&#3591;&#3636;&#3609;&#3604;&#3629;&#3621;&#3621;&#3656;&#3634;&#3619;&#3660;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(149859,4163,'hi','à¤ªà¥‚à¤°à¤¾ à¤¡à¥‰à¤²à¤°',0),(149860,4163,'ms','Ringgit yang siap',0),(149861,4163,'ar','Ø¯ÙˆÙ„Ø§Ø± Ø£Ù†Ø¬Ø²Øª',0),(149862,4163,'fr','Dollars terminÃ©s',0),(149863,4163,'jp','å®Œäº†æ¸ˆé‡‘é¡?åˆ†',0),(149864,4163,'pt','DÃ³lares concluÃ­das',0),(149865,4163,'ru','Ð”Ð¾Ð»Ð»Ð°Ñ€Ð¾Ð² Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°',0),(149866,4163,'es','DÃ³lares Completados',0),(149867,4163,'de','Dollar abgeschlossen',0),(149868,4163,'en','Dollars Completed',0),(149869,4164,'is','',0),(149870,4164,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(149871,4164,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(149872,4164,'tr','Fulfillment sipariÅŸler birimi raporu',0),(149873,4164,'pl','Realizacja zamÃ³wienia raportu',0),(149874,4164,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(149875,4164,'ur','ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹',0),(149876,4164,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(149877,4164,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(149878,4164,'af','Uitvoeringsbestelling Volume Verslag',0),(149879,4164,'ro','ÃŽndeplinirea comenzilor volumul raport',0),(149880,4164,'et','Plaanitud tellimuste mahu aruande',0),(149881,4164,'si','Izpolnitev naroÄila obseg poroÄila',0),(149882,4164,'ba','Laporan Volume pemenuhan pesanan',0),(149883,4164,'nl','Vervulling Orders Volume verslag',0),(149884,4164,'fi','TÃ¤yttÃ¤minen tilausten mÃ¤Ã¤rÃ¤-raportin',0),(149885,4164,'no','FullfÃ¸ringen bestillinger volum rapport',0),(149886,4164,'da','Opfyldelse ordrer volumen rapport',0),(149887,4164,'ko','í–‰ ì£¼ë¬¸ ë³¼ë¥¨ ë³´ê³ ì„œ',0),(149888,4164,'he','×ž×™×ž×•×© ×”×–×ž× ×•×ª ×›×¨×š ×—',0),(149889,4164,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Î¿ ÏŒÎ³ÎºÎ¿Ï‚ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ·',0),(149890,4164,'zh','å®Œæˆè®¢å•æ•°é‡çš„æŠ¥å‘Š\r\n',0),(149891,4164,'sv','Uppfyllelse rapporten order volym',0),(149892,4164,'it','Rapporto Volume di evasione ordini',0),(149893,4164,'tl','',0),(149894,4164,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(149895,4164,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(149896,4164,'ms','Memenuhi perintah kelantangan Laporan',0),(149897,4164,'ar','ÙˆÙØ§Ø¡ Ø£ÙˆØ§Ù…Ø± Ø­Ø¬Ù… Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(149898,4164,'fr','Rapport de volumes de commandes Fulfillment',0),(149899,4164,'jp','å±¥è¡Œæ³¨æ–‡é‡?ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(149900,4164,'pt','RelatÃ³rio de Volume de ordens de cumprimento',0),(149901,4164,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¾Ð±ÑŠÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð°',0),(149902,4164,'es','Ordenes de Cumplimiento Informe de VolÃºmen',0),(149903,4164,'de','ErfÃ¼llung Bestellbericht Volume',0),(149904,4164,'en','Fulfillment Orders Volume Report',0),(149905,4165,'is','',0),(149906,4165,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù‡ ',0),(149907,4165,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù‡ ',0),(149908,4165,'tr','Faturalanan sipariÅŸ',0),(149909,4165,'pl','Zafakturowane zamÃ³wienia',0),(149910,4165,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(149911,4165,'ur','Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(149912,4165,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(149913,4165,'vi','ÄÆ¡n Ä‘áº·t hÃ ng Ä‘Ã£ ra hÃ³a Ä‘on',0),(149914,4165,'af','Gefaktureerde Bestellings',0),(149915,4165,'ro','Comenzi Facturate',0),(149916,4165,'et','Arveldatud tellimuste',0),(149917,4165,'si','KnjiÅ¾ene naloge',0),(149918,4165,'ba','Pesanan yang dibuatkan Faktur',0),(149919,4165,'nl','Gefactureerde Orders',0),(149920,4165,'fi','Laskutetut tilaukset',0),(149921,4165,'no','Fakturerte ordrer',0),(149922,4165,'da','Fakturerede ordrer',0),(149923,4165,'ko','ë°œë¶€ ì£¼ë¬¸',0),(149924,4165,'he','×”×–×ž× ×•×ª ×¢× ×—×©×‘×•× ×™×ª',0),(149925,4165,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½ÎµÏ‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(149926,4165,'zh','å‘ç¥¨å®šå•',0),(149927,4165,'sv','Fakturerade order',0),(149928,4165,'it','Ordini fatturati',0),(149929,4165,'tl','',0),(149930,4165,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(149931,4165,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¤¿à¤ à¤—à¤ à¤†à¤¦à¥‡à¤¶',0),(149932,4165,'ms','Invois pesanan',0),(149933,4165,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(149934,4165,'fr','Commandes facture',0),(149935,4165,'jp','è«‹æ±‚ã?•ã‚Œã?Ÿæ³¨æ–‡',0),(149936,4165,'pt','Pedidos faturados',0),(149937,4165,'ru','Ð ÐµÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(149938,4165,'es','Ordenes Facturados',0),(149939,4165,'de','Fakturierten AuftrÃ¤ge',0),(149940,4165,'en','Invoiced Orders',0),(149941,4166,'is','',0),(149942,4166,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(149943,4166,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(149944,4166,'tr','# SipariÅŸler',0),(149945,4166,'pl','# ZamÃ³wienia',0),(149946,4166,'bg','# ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(149947,4166,'ur','# Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(149948,4166,'sr','# ÐÐ°Ñ€ÐµÑ’ÐµÑšÐ°',0),(149949,4166,'vi','Sá»‘ ÄÆ¡n Äáº·t HÃ ng',0),(149950,4166,'af','# Bestellings',0),(149951,4166,'ro','# Comenzi',0),(149952,4166,'et','# Tellimused',0),(149953,4166,'si','# NaroÄila',0),(149954,4166,'ba','# Pesanan',0),(149955,4166,'nl','# Orders',0),(149956,4166,'fi','# Tilaukset',0),(149957,4166,'no','# Ordrer',0),(149958,4166,'da','# Ordrer',0),(149959,4166,'ko','# ì£¼ë¬¸',0),(149960,4166,'he','# ×”×–×ž× ×•×ª',0),(149961,4166,'el','# Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(149962,4166,'zh','# å®šå•',0),(149963,4166,'sv','# BestÃ¤llningar',0),(149964,4166,'it','# Ordini',0),(149965,4166,'tl','',0),(149966,4166,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(149967,4166,'hi','# à¤†à¤¦à¥‡à¤¶',0),(149968,4166,'ms','# Pesanan',0),(149969,4166,'ar','# Ø£ÙˆØ§Ù…Ø±',0),(149970,4166,'fr','# Commandes',0),(149971,4166,'jp','æ³¨æ–‡æ•°',0),(149972,4166,'pt','# Ordens',0),(149973,4166,'ru','# Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(149974,4166,'es','# Ordenes',0),(149975,4166,'de','-Bestellungen',0),(149976,4166,'en','# Orders',0),(149977,4167,'is','',0),(149978,4167,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(149979,4167,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(149980,4167,'tr','Yerine getirilmesi sipariÅŸ birimi ayrÄ±ntÄ±larÄ±',0),(149981,4167,'pl','SzczegÃ³Å‚y wielkoÅ›ci realizacji zamÃ³wienia',0),(149982,4167,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¾Ð±ÐµÐ¼ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(149983,4167,'ur','Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ ØµÙˆØª Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(149984,4167,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð”ÐµÑ‚Ð°Ñ™Ð¸ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½',0),(149985,4167,'vi','Chi tiáº¿t khá»‘i lÆ°á»£ng ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(149986,4167,'af','Uitvoeringsbestelling Volume Details',0),(149987,4167,'ro','ÃŽndeplinirea comenzii volumul detalii',0),(149988,4167,'et','Plaanitud tellimuse mahu Ã¼ksikasjad',0),(149989,4167,'si','Podrobnosti o naroÄilu obseg izpolnitve',0),(149990,4167,'ba','Pemenuhan Order Volume rincian',0),(149991,4167,'nl','Vervulling volgorde Volume Details',0),(149992,4167,'fi','TÃ¤yttÃ¤minen mÃ¤Ã¤rÃ¤ Tilaustiedot',0),(149993,4167,'no','Oppfyllelsen Ordredetaljer volum',0),(149994,4167,'da','Opfyldelse ordreoplysninger volumen',0),(149995,4167,'ko','í–‰ ì£¼ë¬¸ ë³¼ë¥¨ ì •ë³´',0),(149996,4167,'he','×”×’×©×ž×” Order Details × ×¤×—',0),(149997,4167,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÏŒÎ³ÎºÎ¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(149998,4167,'zh','å±¥è¡Œè®¢å•é‡çš„è¯¦æƒ…\r\n',0),(149999,4167,'sv','Uppfyllelse Orderdetaljer volym',0),(150000,4167,'it','Evasione ordine Volume dettagli',0),(150001,4167,'tl','',0),(150002,4167,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(150003,4167,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤µà¤¿à¤µà¤°à¤£',0),(150004,4167,'ms','Butir-butir jumlah pesanan memenuhi',0),(150005,4167,'ar','ÙˆÙØ§Ø¡ Ø§Ù„Ù†Ø¸Ø§Ù… Ø­Ø¬Ù… Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(150006,4167,'fr','DÃ©tails de rÃ©alisation commande Volume',0),(150007,4167,'jp','å±¥è¡Œæ³¨æ–‡é‡?è©³ç´°',0),(150008,4167,'pt','Detalhes de Volume de pedidos de cumprimento',0),(150009,4167,'ru','ÐžÐ±ÑŠÐµÐ¼ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(150010,4167,'es','Orden de Cumplimiento Detalles de VolÃºmen',0),(150011,4167,'de','ErfÃ¼llung Bestelldetails Volume',0),(150012,4167,'en','Fulfillment Order Volume Details',0),(150013,4168,'is','',0),(150014,4168,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(150015,4168,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(150016,4168,'tr','Yerine getirilmesi sipariÅŸ birimi ayrÄ±ntÄ±larÄ±',0),(150017,4168,'pl','SzczegÃ³Å‚y wielkoÅ›ci realizacji zamÃ³wienia',0),(150018,4168,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¾Ð±ÐµÐ¼ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(150019,4168,'ur','Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ ØµÙˆØª Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(150020,4168,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð”ÐµÑ‚Ð°Ñ™Ð¸ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½',0),(150021,4168,'vi','Chi tiáº¿t khá»‘i lÆ°á»£ng ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(150022,4168,'af','Uitvoeringsbestelling Volume Details',0),(150023,4168,'ro','ÃŽndeplinirea comenzii volumul detalii',0),(150024,4168,'et','Plaanitud tellimuse mahu Ã¼ksikasjad',0),(150025,4168,'si','Podrobnosti o naroÄilu obseg izpolnitve',0),(150026,4168,'ba','Pemenuhan Order Volume rincian',0),(150027,4168,'nl','Vervulling volgorde Volume Details',0),(150028,4168,'fi','TÃ¤yttÃ¤minen mÃ¤Ã¤rÃ¤ Tilaustiedot',0),(150029,4168,'no','Oppfyllelsen Ordredetaljer volum',0),(150030,4168,'da','Opfyldelse ordreoplysninger volumen',0),(150031,4168,'ko','í–‰ ì£¼ë¬¸ ë³¼ë¥¨ ì •ë³´',0),(150032,4168,'he','×”×’×©×ž×” Order Details × ×¤×—',0),(150033,4168,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÏŒÎ³ÎºÎ¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(150034,4168,'zh','å±¥è¡Œè®¢å•é‡çš„è¯¦æƒ…\r\n',0),(150035,4168,'sv','Uppfyllelse Orderdetaljer volym',0),(150036,4168,'it','Evasione ordine Volume dettagli',0),(150037,4168,'tl','',0),(150038,4168,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(150039,4168,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤µà¤¿à¤µà¤°à¤£',0),(150040,4168,'ms','Butir-butir jumlah pesanan memenuhi',0),(150041,4168,'ar','ÙˆÙØ§Ø¡ Ø§Ù„Ù†Ø¸Ø§Ù… Ø­Ø¬Ù… Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(150042,4168,'fr','DÃ©tails de rÃ©alisation commande Volume',0),(150043,4168,'jp','å±¥è¡Œæ³¨æ–‡é‡?è©³ç´°',0),(150044,4168,'pt','Detalhes de Volume de pedidos de cumprimento',0),(150045,4168,'ru','ÐžÐ±ÑŠÐµÐ¼ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(150046,4168,'es','Orden de Cumplimiento Detalles de VolÃºmen',0),(150047,4168,'de','ErfÃ¼llung Bestelldetails Volume',0),(150048,4168,'en','Fulfillment Order Volume Details',0),(150049,4169,'is','',0),(150050,4169,'dr','ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù‡ ',0),(150051,4169,'pr','ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù‡ ',0),(150052,4169,'tr','FaturalanmamÄ±ÅŸ',0),(150053,4169,'pl','Zafakturowane',0),(150054,4169,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¾',0),(150055,4169,'ur','Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯',0),(150056,4169,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð¸',0),(150057,4169,'vi','ÄÃ£ ra HÃ³a Ä‘Æ¡n',0),(150058,4169,'af','Fakture',0),(150059,4169,'ro','Facturat',0),(150060,4169,'et','Arveldatud',0),(150061,4169,'si','Fakturirano',0),(150062,4169,'ba','Ditagih',0),(150063,4169,'nl','Gefactureerd',0),(150064,4169,'fi','Laskutettu',0),(150065,4169,'no','Fakturert',0),(150066,4169,'da','Faktureret',0),(150067,4169,'ko','ì²­êµ¬',0),(150068,4169,'he','×—×•×™×‘',0),(150069,4169,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î·',0),(150070,4169,'zh','å¼€å…·å‘ç¥¨\r\n',0),(150071,4169,'sv','Fakturerade',0),(150072,4169,'it','Fatturata',0),(150073,4169,'tl','',0),(150074,4169,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(150075,4169,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(150076,4169,'ms','Invois',0),(150077,4169,'ar','Ù…ÙÙˆØªØ±',0),(150078,4169,'fr','FacturÃ©e',0),(150079,4169,'jp','è«‹æ±‚æ¸ˆ',0),(150080,4169,'pt','Facturado',0),(150081,4169,'ru','Ð’Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚',0),(150082,4169,'es','Facturado',0),(150083,4169,'de','In Rechnung gestellt',0),(150084,4169,'en','Invoiced',0),(150085,4170,'is','',0),(150086,4170,'dr','( Ù…Ø¨Ù„Øº)  Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(150087,4170,'pr','Ù…Ù‚Ø¯Ø§Ø±( Ù…Ø¨Ù„Øº)  Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(150088,4170,'tr','BaÄŸlayÄ±cÄ± miktar',0),(150089,4170,'pl','IloÅ›Ä‡ wiÄ…zaÅ„',0),(150090,4170,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(150091,4170,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(150092,4170,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(150093,4170,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã³ng sÃ¡ch',0),(150094,4170,'af','Bindery hoeveelheid',0),(150095,4170,'ro','Cantitatea de legatorie',0),(150096,4170,'et','Kirjansitomo kogus',0),(150097,4170,'si','Knjigoveznica koliÄina',0),(150098,4170,'ba','Jumlah bindery',0),(150099,4170,'nl','Bindery hoeveelheid',0),(150100,4170,'fi','Kantata mÃ¤Ã¤rÃ¤',0),(150101,4170,'no','Bindingen antall',0),(150102,4170,'da','Bindery mÃ¦ngde',0),(150103,4170,'ko','ë°”ì¸ë”ë¦¬ ìˆ˜ëŸ‰',0),(150104,4170,'he','×›×ž×•×ª bindery',0),(150105,4170,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± bindery',0),(150106,4170,'zh','è£…è®¢æ•°é‡\r\n',0),(150107,4170,'sv','Bindery kvantitet',0),(150108,4170,'it','QuantitÃ  di legatoria',0),(150109,4170,'tl','',0),(150110,4170,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3649;&#3615;&#3657;&#3617;\n',0),(150111,4170,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(150112,4170,'ms','Kuantiti bindery',0),(150113,4170,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ÙƒÙ…ÙŠØ©',0),(150114,4170,'fr','QuantitÃ© de faÃ§onnage',0),(150115,4170,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼æ•°é‡?',0),(150116,4170,'pt','Quantidade de bindery',0),(150117,4170,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÑÑ‹Ð»Ð¾Ðº Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð‘Ð”',0),(150118,4170,'es','Encuadernadora Cantidad',0),(150119,4170,'de','Buchbinderei Menge',0),(150120,4170,'en','Bindery Quantity',0),(150121,4171,'is','',0),(150122,4171,'dr','* Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§',0),(150123,4171,'pr','Ú†Ø§Ù¾ Ù…Ù‚Ø¯Ø§Ø± * Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§',0),(150124,4171,'tr','(BasÄ±n miktar x sayÄ±sÄ± kadar)',0),(150125,4171,'pl','(NaciÅ›nij iloÅ›Ä‡ x liczbÄ™ w gÃ³rÄ™)',0),(150126,4171,'bg','(ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ… Ð±Ñ€Ð¾Ñ Ð½Ð°Ð³Ð¾Ñ€Ðµ)',0),(150127,4171,'ur','(Ù¾Ø±ÛŒØ³ Ù‚ÛŒ Ø¹Ø¯Ø¯ x)',0),(150128,4171,'sr','(ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ ÐšÐ¾Ð» x Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð²Ð¸ÑˆÐµ)',0),(150129,4171,'vi','(Sá»‘ lÆ°á»£ng in x Sá»‘)',0),(150130,4171,'af','(Druk Qty x getal op)',0),(150131,4171,'ro','(ApÄƒsaÅ£i cantit x numÄƒrul de sus)',0),(150132,4171,'et','(Vajutage kogus x numbri Ã¼les)',0),(150133,4171,'si','(Pritisnite koliÄina x Å¡tevilo navzgor)',0),(150134,4171,'ba','(Tekan Qty x jumlah Up)',0),(150135,4171,'nl','(Druk op aantal x aantal omhoog)',0),(150136,4171,'fi','(Paina mÃ¤Ã¤rÃ¤ x luvun ylÃ¶spÃ¤in)',0),(150137,4171,'no','(Trykk antall x tall oppover)',0),(150138,4171,'da','(Tryk pÃ¥ antal x antal op)',0),(150139,4171,'ko','(ìˆ˜ëŸ‰ì„ ëˆŒëŸ¬ x ìµœëŒ€ ìˆ˜)',0),(150140,4171,'he','(×”×§×© ×¢×œ ×›×ž×•×ª x ×ž×¡×¤×¨ ×ž×¢×œ×”)',0),(150141,4171,'el','(Î Î±Ï„Î®ÏƒÏ„Îµ Qty x Î±ÏÎ¹Î¸Î¼ÏŒ Ï€ÏÎ¿Ï‚ Ï„Î± ÎµÏ€Î¬Î½Ï‰)',0),(150142,4171,'zh','ï¼ˆæŒ‰æ•°é‡Xæ•°å­—ä¸Šï¼‰\r\n',0),(150143,4171,'sv','(Tryck pÃ¥ antal x antal upp)',0),(150144,4171,'it','(Premere q. tÃ  x numero fino)',0),(150145,4171,'tl','',0),(150146,4171,'th','(&#3585;&#3604; &#3611;&#3619;&#3636;&#3617;&#3634;&#3603;*&#3592;&#3635;&#3609;&#3623;&#3609;)',0),(150147,4171,'hi','(à¤ªà¥à¤°à¥‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤…à¤ª à¤¸à¤‚à¤–à¥à¤¯à¤¾ x)',0),(150148,4171,'ms','(Tekan Qty x nombor sehingga)',0),(150149,4171,'ar','(Ø§Ø¶ØºØ· Qty Ã— Ø¹Ø¯Ø¯ ÙŠØµÙ„)',0),(150150,4171,'fr','(Appuyez sur QtÃ© x nombre vers le haut)',0),(150151,4171,'jp','(Press Qty x Number Up)',0),(150152,4171,'pt','(Pressione Qtde x nÃºmero acima)',0),(150153,4171,'ru','(ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Qty x Ð½Ð¾Ð¼ÐµÑ€ Ð²Ð²ÐµÑ€Ñ…)',0),(150154,4171,'es','(Oprimir Cant. x NÃºmero ArrÃ­ba)',0),(150155,4171,'de','(DrÃ¼cken Sie Qty x Anzahl Up)',0),(150156,4171,'en','(Press Qty x Number Up)',0),(150157,4172,'is','',0),(150158,4172,'dr','(Ø¬Ø§ÙŠ Ù…Ù‡Ø±): Ù…Ù‚Ø¯Ø§Ø± * Ø±Ù†Ú¯Ù‡Ø§',0),(150159,4172,'pr','Ø´Ø±Ø­ Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÙŠ (Ø¬Ø§ÙŠ Ù…Ù‡Ø±): Ù…Ù‚Ø¯Ø§Ø± * Ø±Ù†Ú¯Ù‡Ø§',0),(150160,4172,'tr','(BasÄ±n miktar Renkler x)',0),(150161,4172,'pl','(NaciÅ›nij iloÅ›Ä‡ x kolory)',0),(150162,4172,'bg','(ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ)',0),(150163,4172,'ur','(Ù¾Ø±ÛŒØ³ Ù‚ÛŒ Ø±Ù†Ú¯ x)',0),(150164,4172,'sr','(ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ ÐšÐ¾Ð» x Ð±Ð¾Ñ˜Ð°)',0),(150165,4172,'vi','(Sá»‘ bÃ¡o x Máº§u)',0),(150166,4172,'af','(Druk Qty x kleure)',0),(150167,4172,'ro','(ApÄƒsaÅ£i cantit x culori)',0),(150168,4172,'et','(Vajutage kogus x vÃ¤rvid)',0),(150169,4172,'si','(Pritisnite koliÄina x barve)',0),(150170,4172,'ba','(Tekan Qty x warna)',0),(150171,4172,'nl','(Druk op aantal x kleuren)',0),(150172,4172,'fi','(Paina mÃ¤Ã¤rÃ¤ x vÃ¤rit)',0),(150173,4172,'no','(Trykk antall x farger)',0),(150174,4172,'da','(Tryk pÃ¥ antal x farver)',0),(150175,4172,'ko','(ìˆ˜ëŸ‰ì„ ëˆŒëŸ¬ ìƒ‰ x)',0),(150176,4172,'he','(×”×§×© ×¢×œ ×›×ž×•×ª x ×¦×‘×¢×™×)',0),(150177,4172,'el','(Î Î±Ï„Î®ÏƒÏ„Îµ Qty x Ï‡ÏÏŽÎ¼Î±Ï„Î±)',0),(150178,4172,'zh','ï¼ˆæŒ‰æ•°é‡xé¢œè‰²ï¼‰\r\n',0),(150179,4172,'sv','(Tryck pÃ¥ antal x fÃ¤rger)',0),(150180,4172,'it','(Premere q. tÃ  x colori)',0),(150181,4172,'tl','',0),(150182,4172,'th','(&#3585;&#3604; &#3611;&#3619;&#3636;&#3617;&#3634;&#3603; * &#3626;&#3637;)',0),(150183,4172,'hi','(à¤ªà¥à¤°à¥‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤°à¤‚à¤— x)',0),(150184,4172,'ms','(Tekan Qty x warna)',0),(150185,4172,'ar','(Ø§Ø¶ØºØ· Qty Ã— Ø£Ù„ÙˆØ§Ù†)',0),(150186,4172,'fr','(Appuyez sur QtÃ© x couleurs)',0),(150187,4172,'jp','ï¼ˆãƒ—ãƒ¬ã‚¹æ•°é‡?Ã—è‰²æ•°ï¼‰',0),(150188,4172,'pt','(Pressione Qtde x cores)',0),(150189,4172,'ru','(ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐšÐ¾Ð»-Ð²Ð¾ Ñ†Ð²ÐµÑ‚Ð¾Ð²)',0),(150190,4172,'es','(Prensa Cant. x Colores)',0),(150191,4172,'de','(DrÃ¼cken Sie Qty x Farben)',0),(150192,4172,'en','(Press Qty x Colors)',0),(150193,4173,'is','',0),(150194,4173,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø±',0),(150195,4173,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø±',0),(150196,4173,'tr','Ä°ÅŸ sipariÅŸ miktarÄ±',0),(150197,4173,'pl','Pracy iloÅ›Ä‡ zamÃ³wienia',0),(150198,4173,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(150199,4173,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(150200,4173,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(150201,4173,'vi','Sá»‘ lÆ°á»£ng Job',0),(150202,4173,'af','Werk bestel hoeveelheid',0),(150203,4173,'ro','Job pentru cantitatea',0),(150204,4173,'et','Projekti tellimuse kogus',0),(150205,4173,'si','KoliÄina naloga delo',0),(150206,4173,'ba','Kuantitas Order pekerjaan',0),(150207,4173,'nl','Baan orderaantal',0),(150208,4173,'fi','TyÃ¶n mÃ¤Ã¤rÃ¤n',0),(150209,4173,'no','Jobb bestillingsantall',0),(150210,4173,'da','Job ordrestÃ¸rrelse',0),(150211,4173,'ko','ìž‘ì—… ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(150212,4173,'he','×›×ž×•×ª ×”×–×ž× ×ª ×¢×‘×•×“×”',0),(150213,4173,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î Î¿Ïƒ',0),(150214,4173,'zh','å·¥ä½œé¡ºåºæ•°é‡\r\n',0),(150215,4173,'sv','Jobb fÃ¶r kvantitet',0),(150216,4173,'it','QuantitÃ  di ordine di lavoro',0),(150217,4173,'tl','',0),(150218,4173,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3591;&#3634;&#3609;&#3626;&#3633;&#3657;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(150219,4173,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(150220,4173,'ms','Kuantiti pesanan kerja',0),(150221,4173,'ar','ÙƒÙ…ÙŠØ© Ø£Ù…Ø± Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(150222,4173,'fr','QuantitÃ© d\'ordre de travail',0),(150223,4173,'jp','ä½œæ¥­æ³¨æ–‡æ•°é‡?',0),(150224,4173,'pt','Quantidade de ordem de trabalho',0),(150225,4173,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(150226,4173,'es','Cantidad de Ordenes de Trabajo',0),(150227,4173,'de','Job-Bestellmenge',0),(150228,4173,'en','Job Order Quantity',0),(150229,4174,'is','',0),(150230,4174,'dr','Ù…Ù‚Ø¯Ø§Ø± Ú†Ø§Ù¾',0),(150231,4174,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú†Ø§Ù¾',0),(150232,4174,'tr','BasÄ±n miktar',0),(150233,4174,'pl','IloÅ›Ä‡ prasy',0),(150234,4174,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(150235,4174,'ur','Ù¾Ø±ÛŒØ³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(150236,4174,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(150237,4174,'vi','Sá»‘ lÆ°á»£ng bÃ¡o',0),(150238,4174,'af','Hoeveelheid druk',0),(150239,4174,'ro','Cantitatea de presÄƒ',0),(150240,4174,'et','Vajutage kogus',0),(150241,4174,'si','Pritisnite koliÄina',0),(150242,4174,'ba','Tekan kuantitas',0),(150243,4174,'nl','Druk op hoeveelheid',0),(150244,4174,'fi','Paina mÃ¤Ã¤rÃ¤',0),(150245,4174,'no','Trykk antall',0),(150246,4174,'da','Tryk pÃ¥ mÃ¦ngde',0),(150247,4174,'ko','ë³´ë„ ìˆ˜ëŸ‰',0),(150248,4174,'he','×”×§×© ×¢×œ ×›×ž×•×ª',0),(150249,4174,'el','Î Î±Ï„Î®ÏƒÏ„Îµ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(150250,4174,'zh','å°åˆ·æ•°é‡\r\n',0),(150251,4174,'sv','Tryck pÃ¥ kvantitet',0),(150252,4174,'it','QuantitÃ  di stampa',0),(150253,4174,'tl','',0),(150254,4174,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3585;&#3604;',0),(150255,4174,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(150256,4174,'ms','Tekan kuantiti',0),(150257,4174,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(150258,4174,'fr','QuantitÃ© de presse',0),(150259,4174,'jp','ãƒ—ãƒ¬ã‚¹æ•°é‡?',0),(150260,4174,'pt','Quantidade de imprensa',0),(150261,4174,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€ÐµÑÑ',0),(150262,4174,'es','Prensa Cantidad',0),(150263,4174,'de','DrÃ¼cken Sie die Menge',0),(150264,4174,'en','Press Quantity',0),(150265,4175,'is','',0),(150266,4175,'dr','* ØªØ¹Ø¯Ø§Ø¯ Ù‚Ø³Ù…ØªÙ‡Ø§ Ø¨Ø± Ø¹Ø¯Ø¯ Ø¨Ø§Ù„Ø§+Ø¶Ø§ÙŠØ¹Ø§Øª )',0),(150267,4175,'pr','Ø´Ø±Ø­ Ù…Ù‚Ø¯Ø§Ø± Ú†Ø§Ù¾ â€“ Ù…Ù‚Ø¯Ø§Ø± Ø´ØºÙ„ * ØªØ¹Ø¯Ø§Ø¯ Ù‚Ø³Ù…ØªÙ‡Ø§ Ø¨Ø± Ø¹Ø¯Ø¯ Ø¨Ø§Ù„Ø§+Ø¶Ø§ÙŠØ¹Ø§Øª )',0),(150268,4175,'tr','((Ä°ÅŸ miktarÄ± * /Number kadar parÃ§a sayÄ±sÄ±nÄ±) + hurda)',0),(150269,4175,'pl','((IloÅ›Ä‡ pracy * numer czÄ™Å›ci /Number siÄ™) + zÅ‚om)',0),(150270,4175,'bg','((ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ * Ð±Ñ€Ð¾Ð¹ Ñ‡Ð°ÑÑ‚Ð¸/Ð±Ñ€Ð¾Ð¹ Ð¿Ñ€ÐµÐ· Ð½Ð°Ð³Ð¾Ñ€Ðµ) + ÑÐºÑ€Ð°Ð¿)',0),(150271,4175,'ur','((Ù…Ù„Ø§Ø²Ù…Øª Ù…Ù‚Ø¯Ø§Ø± * /Number Ø§Ù¾ Ø­ØµÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯) + Ø³Ú©Ø±ÛŒÙ¾)',0),(150272,4175,'sr','((ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ð¾ÑÐ»Ð° * Ð±Ñ€Ð¾Ñ˜ Ð´ÐµÐ»Ð¾Ð²Ð° /ÐÑƒÐ¼Ð±ÐµÑ€ Ð³Ð¾Ñ€Ðµ) + ÑˆÐºÐ°Ñ€Ñ‚)',0),(150273,4175,'vi','((Sá»‘ lÆ°á»£ng Job * Sá»‘ cá»§a phá»¥ tÃ¹ng /Sá»‘ trÃªn) + Pháº¿ liá»‡u)',0),(150274,4175,'af','((Werk hoeveelheid * aantal dele /Number Up) + knipsel)',0),(150275,4175,'ro','((Job cantitatea * numÄƒr de piese /Number sus) + resturi)',0),(150276,4175,'et','((Projekti kogus * osasid/abi saajate Ã¼les) + jÃ¤Ã¤gid)',0),(150277,4175,'si','((Job koliÄina * Å¡tevilo delov /Number gor) + ostanki)',0),(150278,4175,'ba','((Kuantitas pekerjaan * jumlah bagian /Number Up) + Scrap)',0),(150279,4175,'nl','((Job hoeveelheid * aantal onderdelen /Number Up) + schroot)',0),(150280,4175,'fi','((Projektin mÃ¤Ã¤rÃ¤ * osiin laskentakaavalla ylÃ¶s) + romu)',0),(150281,4175,'no','((Jobb antall * antall deler /Number opp) + skrap)',0),(150282,4175,'da','((Antal sager * antal dele /Number op) + skrot)',0),(150283,4175,'ko','((ìž‘ì—… ìˆ˜ëŸ‰ * /Number ìµœëŒ€ ë¶€í’ˆ ë²ˆí˜¸) + ìŠ¤í¬ëž©)',0),(150284,4175,'he','((×›×ž×•×ª ×”×¢×‘×•×“×” * ×ž×¡×¤×¨ ×”×—×œ×§×™× /Number ×œ×ž×¢×œ×”) + ×’×¨×•×˜××•×ª)',0),(150285,4175,'el','((Î Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ * Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½ Ï„Î¼Î·Î¼Î¬Ï„Ï‰Î½/Î±ÏÎ¹Î¸ÂµÏŒ ÎµÏ€Î¬Î½Ï‰) + Î¸ÏÎ±ÏÏƒÎ¼Î±Ï„Î±)',0),(150286,4175,'zh','ï¼ˆï¼ˆå°åˆ·æ•°é‡Ã—éƒ¨åˆ†æ•°/å¢žåŠ æ•°ï¼‰+åºŸæ–™ï¼‰\r\n',0),(150287,4175,'sv','((Projektantal * antal delar /Number upp) + skrot)',0),(150288,4175,'it','((QuantitÃ  di lavoro * numero di parti /numero Up) + rottami)',0),(150289,4175,'tl','',0),(150290,4175,'th','((Job Quantity * Number of parts /Number Up) + Scrap)',0),(150291,4175,'hi','((à¤¨à¥Œà¤•à¤°à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ * à¤…à¤ª /Number à¤­à¤¾à¤—à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾) + à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª)',0),(150292,4175,'ms','((Kuantiti kerja * bilangan bahagian-bahagian /Number Up) + sekerap)',0),(150293,4175,'ar','((Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ÙˆØ¸ÙŠÙØ© * Ø¹Ø¯Ø¯ Ø§Ù„Ø£Ø¬Ø²Ø§Ø¡ Ø§Ù„Ù…Ù†ØªØ¬Ø© Ø­ØªÙ‰) + Ø§Ù„Ø®Ø±Ø¯Ø©)',0),(150294,4175,'fr','((QuantitÃ© de travail * nombre de piÃ¨ces alternatif vers le haut) + ferraille)',0),(150295,4175,'jp','((Job Quantity * Number of parts /Number Up) + Scrap)',0),(150296,4175,'pt','((Quantidade de trabalho * nÃºmero de peÃ§as /Number acima) + sucata)',0),(150297,4175,'ru','((ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ñ… * ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ‡Ð°ÑÑ‚ÐµÐ¹, ÑÐ¾Ð¾Ð±Ñ‰Ð¸Ð²ÑˆÐ¸Ñ… Ð²Ð²ÐµÑ€Ñ…) + Ð»Ð¾Ð¼Ð°)',0),(150298,4175,'es','((Cantidad de Trabajo * NÃºmero de partes/NÃºmero de hacer) + Desechas)',0),(150299,4175,'de','((Job Menge * Anzahl der Teile /Number Up) + Schrott)',0),(150300,4175,'en','((Job Quantity * Number of parts /Number Up) + Scrap)',0),(150301,4176,'is','',0),(150302,4176,'dr','Ø­Ù…Ù„ ØªÙ‚Ø³ÙŠÙ… Ø´Ø¯Ù‡ ',0),(150303,4176,'pr','Ø­Ù…Ù„ ØªÙ‚Ø³ÙŠÙ… Ø´Ø¯Ù‡ ',0),(150304,4176,'tr','Gemi ayrÄ±ldÄ±!',0),(150305,4176,'pl','PodziaÅ‚ statku!',0),(150306,4176,'bg','Ð Ð°Ð·Ð´ÐµÐ»ÑÐ½Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð°!',0),(150307,4176,'ur','Ø¬ÛØ§Ø² ØªÙ‚Ø³ÛŒÙ… ÛÙˆ Ú¯Ø¦ÛŒ ÛÛ’!',0),(150308,4176,'sr','Ð‘Ñ€Ð¾Ð´ ÑÐµ Ñ€Ð°Ð·Ð´Ð²Ð¾Ñ˜Ð¸Ð¼Ð¾!',0),(150309,4176,'vi','Chia chuyáº¿n hÃ ng',0),(150310,4176,'af','Verdeel Versending!',0),(150311,4176,'ro','Split navÄƒ!',0),(150312,4176,'et','TÃ¼kelda laeva!',0),(150313,4176,'si','Delih ladje!',0),(150314,4176,'ba','Membagi kapal!',0),(150315,4176,'nl','Split schip!',0),(150316,4176,'fi','Jakaa aluksen!',0),(150317,4176,'no','Delt skipet!',0),(150318,4176,'da','Opdele skibet!',0),(150319,4176,'ko','ë¶„í•  ë°°!',0),(150320,4176,'he','×œ×¤×¦×œ ××ª ×”×¡×¤×™× ×”!',0),(150321,4176,'el','Split Ï„Î¿ Ï€Î»Î¿Î¯Î¿!',0),(150322,4176,'zh','åˆ†å¼€è´§è¿ï¼\r\n',0),(150323,4176,'sv','Split fartyg!',0),(150324,4176,'it','Dividere la nave!',0),(150325,4176,'tl','',0),(150326,4176,'th','&#3649;&#3618;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;!',0),(150327,4176,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤µà¤¿à¤­à¤¾à¤œà¤¿à¤¤!',0),(150328,4176,'ms','Berpecah kapal!',0),(150329,4176,'ar','ØªÙ‚Ø³ÙŠÙ… Ø§Ù„Ø³ÙÙŠÙ†Ø©!',0),(150330,4176,'fr','Split Ship !',0),(150331,4176,'jp','ç™ºé€?ã‚’åˆ†ã?‘ã‚‹ï¼?',0),(150332,4176,'pt','Dividir o navio!',0),(150333,4176,'ru','Ð Ð°Ð·Ð±Ð¸Ñ‚ÑŒ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ!',0),(150334,4176,'es','EnvÃ­o Partido!',0),(150335,4176,'de','Split Schiff!',0),(150336,4176,'en','Split Ship!',0),(150337,4177,'is','',0),(150338,4177,'dr','7 Ø±ÙˆØ²',0),(150339,4177,'pr','7 Ø±ÙˆØ²',0),(150340,4177,'tr','7 gÃ¼n',0),(150341,4177,'pl','7 dzieÅ„',0),(150342,4177,'bg','7 Ð´ÐµÐ½',0),(150343,4177,'ur','Ø³Ø§Øª Ø¯Ù†',0),(150344,4177,'sr','7 Ð´Ð°Ð½Ð°',0),(150345,4177,'vi','7 NgÃ y',0),(150346,4177,'af','7 Dae',0),(150347,4177,'ro','a 7-a zi',0),(150348,4177,'et','7 PÃ¤eva',0),(150349,4177,'si','7 dni',0),(150350,4177,'ba','7 Hari',0),(150351,4177,'nl','7 dag',0),(150352,4177,'fi','7 pv',0),(150353,4177,'no','7 dagers',0),(150354,4177,'da','7-dages',0),(150355,4177,'ko','7 ì¼',0),(150356,4177,'he','×™×•× 7',0),(150357,4177,'el','7 Î—Î¼Î­ÏÎµÏ‚',0),(150358,4177,'zh','7 å¤©',0),(150359,4177,'sv','7 dag',0),(150360,4177,'it','7 giorni',0),(150361,4177,'tl','',0),(150362,4177,'th','7 à¸§à¸±à¸™',0),(150363,4177,'hi','7 à¤¦à¤¿à¤¨',0),(150364,4177,'ms','7 hari',0),(150365,4177,'ar','ÙŠÙˆÙ… 7',0),(150366,4177,'fr','7 Jour',0),(150367,4177,'jp','ï¼—æ—¥',0),(150368,4177,'pt','Dia 7',0),(150369,4177,'ru','7 Ð”Ð½ÐµÐ¹',0),(150370,4177,'es','7 DÃ­as',0),(150371,4177,'de','7 Tag',0),(150372,4177,'en','7 Day',0),(150373,4178,'is','',0),(150374,4178,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´  ',0),(150375,4178,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´  ',0),(150376,4178,'tr','SipariÅŸ birimi raporu gÃ¶rÃ¼ntÃ¼le',0),(150377,4178,'pl','WyÅ›wietl raport wielkoÅ›ci zamÃ³wienia',0),(150378,4178,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(150379,4178,'ur','Ù…Ù†Ø¸Ø± ØªØ±ØªÛŒØ¨ ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹',0),(150380,4178,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(150381,4178,'vi','Xem bÃ¡o cÃ¡o khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng',0),(150382,4178,'af','Besigtig Bestellingsvolume Verslag',0),(150383,4178,'ro','Vizualizare comanda volum raport',0),(150384,4178,'et','Vaata tellimuse mahuaruannet',0),(150385,4178,'si','Ogled nalog obsega poroÄila',0),(150386,4178,'ba','Lihat urutan Volume laporan',0),(150387,4178,'nl','Volgorde Volume-rapport weergeven',0),(150388,4178,'fi','NÃ¤ytÃ¤ tilauksen mÃ¤Ã¤rÃ¤ raportti',0),(150389,4178,'no','Vis volum rapport',0),(150390,4178,'da','Vis ordre volumen rapport',0),(150391,4178,'ko','ì£¼ë¬¸ ë³¼ë¥¨ ë³´ê³ ì„œ ë³´ê¸°',0),(150392,4178,'he','×”×¦×’ ×¡×“×¨ × ×¤×— ×“×•×—',0),(150393,4178,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏŒÎ³ÎºÎ¿Ï… Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(150394,4178,'zh','æŸ¥çœ‹è®¢å•é‡ç”³æŠ¥è¡¨\r\n',0),(150395,4178,'sv','Visa Order volym rapport',0),(150396,4178,'it','Visualizza ordine Volume rapporto',0),(150397,4178,'tl','',0),(150398,4178,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(150399,4178,'hi','à¤†à¤¦à¥‡à¤¶ à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(150400,4178,'ms','Laporan jumlah pesanan View',0),(150401,4178,'ar','Ø¹Ø±Ø¶ ØªØ±ØªÙŠØ¨ Ø­Ø¬Ù… Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(150402,4178,'fr','Vue Ã‰tat de commande Volume',0),(150403,4178,'jp','å?—æ³¨é¡?ãƒ¬ãƒ?ãƒ¼ãƒˆã‚’è¦‹ã‚‹',0),(150404,4178,'pt','Exibir relatÃ³rio de Volume de ordem',0),(150405,4178,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð¾Ð±ÑŠÐµÐ¼ Ð·Ð°ÐºÐ°Ð·Ð°',0),(150406,4178,'es','Ver Informe de VolÃºmen de Ordenes',0),(150407,4178,'de','Bestellung-Volume-Bericht anzeigen',0),(150408,4178,'en','View Order Volume Report',0),(150409,4179,'is','',0),(150410,4179,'dr',': 12 Ù…Ø§Ù‡ ',0),(150411,4179,'pr','Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´  : 12 Ù…Ø§Ù‡ ',0),(150412,4179,'tr','12 aylÄ±k hacim - sipariÅŸ',0),(150413,4179,'pl','ZamÃ³w Tom - 12 miesiÄ™cy',0),(150414,4179,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð¾Ð±ÐµÐ¼ - 12 Ð¼ÐµÑÐµÑ†Ð°',0),(150415,4179,'ur','ØµÙˆØª - 12 Ù…Ø§Û Ú©Ø§ Ø­Ú©Ù…',0),(150416,4179,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - 12 Ð¼ÐµÑÐµÑ†Ð¸',0),(150417,4179,'vi','Khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng: 12 thÃ¡ng',0),(150418,4179,'af','Bestelling Volume:  12 Maande',0),(150419,4179,'ro','Comanda volum - 12 luni',0),(150420,4179,'et','Tellimuse maht - 12 kuu',0),(150421,4179,'si','Naloga obsega - 12 mesec',0),(150422,4179,'ba','Memesan Volume - 12 bulan',0),(150423,4179,'nl','Bestel Volume - 12 maand',0),(150424,4179,'fi','Tilaa Volume - 12 kuukauden',0),(150425,4179,'no','Bestille volum - 12 mÃ¥neder',0),(150426,4179,'da','Bestil Volume - 12 mÃ¥neders',0),(150427,4179,'ko','ì£¼ë¬¸ ì–‘-12 ê°œì›”',0),(150428,4179,'he','×”×–×ž× ×ª ××—×¡×•×Ÿ - 12 ×—×•×“×©×™×',0),(150429,4179,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Ï„ÏŒÎ¼Î¿Ï‚ - 12 Î¼Î·Î½ÏŽÎ½',0),(150430,4179,'zh','12ä¸ªæœˆçš„è®¢å•é‡\r\n',0),(150431,4179,'sv','BestÃ¤ll volym - 12 mÃ¥naders',0),(150432,4179,'it','Ordinare il Volume - 12 mesi',0),(150433,4179,'tl','',0),(150434,4179,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; : 12 &#3648;&#3604;&#3639;&#3629;&#3609;',0),(150435,4179,'hi','à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® - 12 à¤®à¤¾à¤¹ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(150436,4179,'ms','Perintah Volume - 12 bulan',0),(150437,4179,'ar','Ø£Ù…Ø± Ø­Ø¬Ù…-Ø§Ù„Ø´Ù‡Ø± 12',0),(150438,4179,'fr','Commande Volume - 12 mois',0),(150439,4179,'jp','å?—æ³¨é¡?ï¼š12ãƒ¶æœˆ',0),(150440,4179,'pt','Ordem Volume - 12 meses',0),(150441,4179,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾Ð±ÑŠÐµÐ¼ - 12 Ð¼ÐµÑÑÑ†ÐµÐ²',0),(150442,4179,'es','VolÃºmen de Ordenes: 12 Meses',0),(150443,4179,'de','Auftragsvolumen Sie - 12 Monate',0),(150444,4179,'en','Order Volume - 12 Month',0),(150445,4180,'is','',0),(150446,4180,'dr',':7 Ø±ÙˆØ²',0),(150447,4180,'pr','Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´  :7 Ø±ÙˆØ²',0),(150448,4180,'tr','SipariÅŸ hacmi: 7 gÃ¼n',0),(150449,4180,'pl','WielkoÅ›Ä‡ zamÃ³wienia: 7 dni',0),(150450,4180,'bg','ÐžÐ±ÐµÐ¼: 7 Ð´ÐµÐ½',0),(150451,4180,'ur','ØªØ±ØªÛŒØ¨ ØµÙˆØª: 7 Ø¯Ù†',0),(150452,4180,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½: 7 Ð´Ð°Ð½Ð°',0),(150453,4180,'vi','Khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng: 7 ngÃ y',0),(150454,4180,'af','Bestelling Volume:  7 Dae',0),(150455,4180,'ro','Volumul de ordine: 7 zile',0),(150456,4180,'et','Kogus: 7 pÃ¤eva',0),(150457,4180,'si','Obseg nalog: 7 dni',0),(150458,4180,'ba','Urutan Volume: 7 hari',0),(150459,4180,'nl','Ordervolume: 7 dagen',0),(150460,4180,'fi','Tilauskanta: 7 pÃ¤ivÃ¤Ã¤',0),(150461,4180,'no','RekkefÃ¸lgen volumet: 7 dager',0),(150462,4180,'da','Ordrebeholdning: 7 dages',0),(150463,4180,'ko','ì£¼ë¬¸ ì–‘: 7 ì¼',0),(150464,4180,'he','×¡×“×¨ × ×¤×—: ×™×•× 7',0),(150465,4180,'el','ÎŒÎ³ÎºÎ¿Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚: 7Î®Î¼ÎµÏÎ·',0),(150466,4180,'zh','è®¢å•é‡ï¼š7æ—¥\r\n',0),(150467,4180,'sv','Ordervolymen: 7 dagar',0),(150468,4180,'it','Volume di ordine: giorno 7',0),(150469,4180,'tl','',0),(150470,4180,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; : 7 &#3623;&#3633;&#3609;',0),(150471,4180,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾: 7 à¤¦à¤¿à¤¨',0),(150472,4180,'ms','Jumlah Pesanan: 7 hari',0),(150473,4180,'ar','ÙˆØ­Ø¯Ø© ØªØ®Ø²ÙŠÙ† Ø§Ù„Ù†Ø¸Ø§Ù…: 7 ÙŠÙˆÙ…',0),(150474,4180,'fr','Volume de la commande: 7 jours',0),(150475,4180,'jp','å?—æ³¨é¡?ï¼š7æ—¥é–“',0),(150476,4180,'pt','Volume de ordem: 7 dias',0),(150477,4180,'ru','ÐžÐ±ÑŠÐµÐ¼ Ð·Ð°ÐºÐ°Ð·Ð°: 7 Ð´Ð½ÐµÐ¹',0),(150478,4180,'es','VolÃºmen de Ordenes: 7 DÃ­as',0),(150479,4180,'de','Auftragsvolumen: 7 Tage',0),(150480,4180,'en','Order Volume: 7 Day',0),(150481,4181,'is','',0),(150482,4181,'dr',': 8 Ù‡ÙØªÙ‡ ',0),(150483,4181,'pr','Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´  : 8 Ù‡ÙØªÙ‡ ',0),(150484,4181,'tr','Hacim - 8 hafta sipariÅŸ',0),(150485,4181,'pl','ZamÃ³w Tom - 8 tydzieÅ„',0),(150486,4181,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ñ‚Ðµ Ð¾Ð±ÐµÐ¼ - 8 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(150487,4181,'ur','ØµÙˆØª - 8 ÛÙØªÛ’ Ú©Ø§ Ø­Ú©Ù…',0),(150488,4181,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - 8 Ð½ÐµÐ´ÐµÑ™Ð°',0),(150489,4181,'vi','Khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng: 8 tuáº§n',0),(150490,4181,'af','Bestelling Volume:  8 Weke',0),(150491,4181,'ro','Comanda volum - 8 sÄƒptÄƒmÃ¢ni',0),(150492,4181,'et','Tellimuse maht - 8 nÃ¤dala',0),(150493,4181,'si','NaroÄite nosilca - 8 teden',0),(150494,4181,'ba','Memesan Volume - 8 minggu',0),(150495,4181,'nl','Bestel Volume - 8 weken',0),(150496,4181,'fi','Tilaa Volume - 8 viikkoa',0),(150497,4181,'no','Bestille volum - 8 ukers',0),(150498,4181,'da','Bestil volumen - 8 uge',0),(150499,4181,'ko','ì£¼ë¬¸ ì–‘-8 ì£¼',0),(150500,4181,'he','×”×–×ž× ×ª ××—×¡×•×Ÿ - ×©×‘×•×¢ 8',0),(150501,4181,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î¤ÏŒÎ¼Î¿Ï‚ - 8 ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(150502,4181,'zh','è®¢å•é‡ï¼š8å‘¨\r\n',0),(150503,4181,'sv','BestÃ¤lla volym - 8 vecka',0),(150504,4181,'it','Ordinare il Volume - settimana 8',0),(150505,4181,'tl','',0),(150506,4181,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; : 8 &#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(150507,4181,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ - 8 à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(150508,4181,'ms','Perintah Volume - 8 minggu',0),(150509,4181,'ar','ØªØ±ØªÙŠØ¨ ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†--Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ 8',0),(150510,4181,'fr','Commander le Volume - semaine 8',0),(150511,4181,'jp','å?—æ³¨é¡?ï¼š8é€±é–“',0),(150512,4181,'pt','Encomendar Volume - semana 8',0),(150513,4181,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾Ð±ÑŠÐµÐ¼ - 8 Ð½ÐµÐ´ÐµÐ»Ñ',0),(150514,4181,'es','VolÃºmen de Ordenes: 8 Semanas',0),(150515,4181,'de','Auftragsvolumen Sie - 8 Wochen',0),(150516,4181,'en','Order Volume - 8 Week',0),(150517,4182,'is','',0),(150518,4182,'dr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†',0),(150519,4182,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†',0),(150520,4182,'tr','En iyi 10 mÃ¼ÅŸteriler',0),(150521,4182,'pl','10 najlepszych klientÃ³w',0),(150522,4182,'bg','Ð¢Ð¾Ð¿ 10 ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(150523,4182,'ur','Ù¹Ø§Ù¾ 10 ØµØ§Ø±ÙÛŒÙ†',0),(150524,4182,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(150525,4182,'vi','MÆ°á»i khÃ¡ch hÃ ng cao nháº¥t ',0),(150526,4182,'af','Top 10 Klante/KliÃ«nte',0),(150527,4182,'ro','Top 10 clienÅ£ii',0),(150528,4182,'et','Top 10 kliendid',0),(150529,4182,'si','Top 10 stranke',0),(150530,4182,'ba','Top 10 pelanggan',0),(150531,4182,'nl','Top 10 klanten',0),(150532,4182,'fi','Top 10 hotellia',0),(150533,4182,'no','Topp 10 kunder',0),(150534,4182,'da','Top 10 kunder',0),(150535,4182,'ko','í†± 10 ê³ ê°',0),(150536,4182,'he','×”×¢×œ×™×•×Ÿ 10 ×”×œ×§×•×—×•×ª',0),(150537,4182,'el','Top 10 Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(150538,4182,'zh','å‰åå®¶å®¢æˆ·\r\n',0),(150539,4182,'sv','Topp 10 kunder',0),(150540,4182,'it','Top 10 clienti',0),(150541,4182,'tl','',0),(150542,4182,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(150543,4182,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(150544,4182,'ms','Top 10 pelanggan',0),(150545,4182,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¹Ù…Ù„Ø§Ø¡',0),(150546,4182,'fr','Top 10 clients',0),(150547,4182,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?é¡§å®¢',0),(150548,4182,'pt','Top 10 clientes',0),(150549,4182,'ru','Ð¢Ð¾Ð¿ 10 ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(150550,4182,'es','Los 10 Clientes Principales ',0),(150551,4182,'de','Kunden, die Top-10',0),(150552,4182,'en','Top 10 Customers',0),(150553,4183,'is','',0),(150554,4183,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ± ',0),(150555,4183,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ± ',0),(150556,4183,'tr','Fatura Ã–zeti raporunu gÃ¶rÃ¼ntÃ¼le',0),(150557,4183,'pl','Zobacz faktura skrÃ³cone sprawozdanie',0),(150558,4183,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(150559,4183,'ur','Ù…Ù†Ø¸Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø®Ù„Ø§ØµÛ Ø±Ù¾ÙˆØ±Ù¹',0),(150560,4183,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÑÐ° Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ¾Ð¼',0),(150561,4183,'vi','Xem bÃ¡o cÃ¡o hÃ³a Ä‘Æ¡n tá»•ng há»£p',0),(150562,4183,'af','Besigtig Faktuur Opsommingsverslag',0),(150563,4183,'ro','Vezi raportul facturÄƒ sumarÄƒ',0),(150564,4183,'et','Kuva arve KokkuvÃµttev aruanne',0),(150565,4183,'si','Ogled raÄuna Povzetek poroÄila',0),(150566,4183,'ba','Lihat faktur ringkasan laporan',0),(150567,4183,'nl','Samenvatting rapport weergeven factuur',0),(150568,4183,'fi','NÃ¤ytÃ¤ laskun Yhteenveto-raportti',0),(150569,4183,'no','Vis fakturaen sammendragsrapport',0),(150570,4183,'da','Se faktura sammenfattende rapport',0),(150571,4183,'ko','ì†¡ìž¥ ìš”ì•½ ë³´ê³ ì„œ ë³´ê¸°',0),(150572,4183,'he','×”×¦×’ ×—×©×‘×•× ×™×ª ×“×•×— ×¡×™×›×•×',0),(150573,4183,'el','Î ÏÎ¿Î²Î¿Î»Î® ÏƒÏÎ½Î¿ÏˆÎ·Ï‚ Î­ÎºÎ¸ÎµÏƒÎ· \"Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿\"',0),(150574,4183,'zh','æŸ¥çœ‹å‘ç¥¨æ±‡æ€»æŠ¥è¡¨\r\n',0),(150575,4183,'sv','Visa faktura Sammanfattning rapport',0),(150576,4183,'it','Visualizzazione Report di riepilogo fattura',0),(150577,4183,'tl','',0),(150578,4183,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(150579,4183,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(150580,4183,'ms','Lihat invois ringkasan laporan',0),(150581,4183,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ± Ù…Ù„Ø®Ù‘Øµ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(150582,4183,'fr','Voir rapport de synthÃ¨se de facture',0),(150583,4183,'jp','è«‹æ±‚æ›¸ã‚µãƒžãƒªãƒ¼ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(150584,4183,'pt','Exibir relatÃ³rio de Resumo de factura',0),(150585,4183,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÑ‡ÐµÑ‚Ð° ÑÐ²Ð¾Ð´Ð½Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(150586,4183,'es','Visionar Informe de ResÃºmen de Facturas',0),(150587,4183,'de','Zusammenfassender Bericht des anzeigen-Rechnung',0),(150588,4183,'en','View Invoice Summary Report',0),(150589,4184,'is','',0),(150590,4184,'dr','(Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† : Ø³ÙŠ (30)  Ø±ÙˆØ² ',0),(150591,4184,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† (Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† : Ø³ÙŠ (30)  Ø±ÙˆØ² ',0),(150592,4184,'tr','En iyi 10 mÃ¼ÅŸteriler: 30 gÃ¼n',0),(150593,4184,'pl','10 najlepszych klientÃ³w: 30 dni',0),(150594,4184,'bg','Ð¢Ð¾Ð¿ 10 ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸: 30 Ð´Ð½Ð¸',0),(150595,4184,'ur','Ú¯Ø§ÛÚ© Ù¹Ø§Ù¾ 10: 30 Ø¯Ù†',0),(150596,4184,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÐºÑƒÐ¿Ð°Ñ†Ð°: 30 Ð´Ð°Ð½Ð°',0),(150597,4184,'vi','MÆ°á»i khÃ¡ch hÃ ng cao nháº¥t: 30 ngÃ y',0),(150598,4184,'af','Top 10 Kliente/Klante:  30 Dae',0),(150599,4184,'ro','ClienÅ£ii de top 10: 30 zile',0),(150600,4184,'et','Top 10 kliendid: 30 pÃ¤eva',0),(150601,4184,'si','Top 10 stranke: 30 dni',0),(150602,4184,'ba','Pelanggan atas 10: 30 hari',0),(150603,4184,'nl','Top 10 klanten: 30 dagen',0),(150604,4184,'fi','Top 10 asiakkaat: 30 pÃ¤ivÃ¤Ã¤',0),(150605,4184,'no','Topp 10 kunder: 30 dager',0),(150606,4184,'da','Top 10 kunder: 30 dage',0),(150607,4184,'ko','í†± 10 ê³ ê°: 30 ì¼',0),(150608,4184,'he','×”×¢×œ×™×•×Ÿ 10 ×œ×§×•×—×•×ª: 30 ×™×ž×™×',0),(150609,4184,'el','Top 10 Ï€ÎµÎ»Î¬Ï„ÎµÏ‚: 30 Î·Î¼Î­ÏÎµÏ‚',0),(150610,4184,'zh','å‰åä½å®¢æˆ·ï¼š30å¤©\r\n',0),(150611,4184,'sv','Topp 10 kunder: 30 dagar',0),(150612,4184,'it','10 migliori clienti: 30 giorni',0),(150613,4184,'tl','',0),(150614,4184,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3604;&#3637;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604; : 30 &#3623;&#3633;&#3609;',0),(150615,4184,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚: 30 à¤¦à¤¿à¤¨',0),(150616,4184,'ms','Top 10 pelanggan: 30 hari',0),(150617,4184,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø£Ø¹Ù„Ù‰ 10: 30 ÙŠÙˆÙ…Ø§',0),(150618,4184,'fr','Top 10 clients : 30 jours',0),(150619,4184,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?é¡§å®¢ï¼š30æ—¥é–“',0),(150620,4184,'pt','Top 10 clientes: 30 dias',0),(150621,4184,'ru','Ð¢Ð¾Ð¿ 10 ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²: 30 Ð”Ð½ÐµÐ¹',0),(150622,4184,'es','Los 10 Clientes Principales: 30 DÃ­as',0),(150623,4184,'de','Kunden, die Top-10: 30 Tage',0),(150624,4184,'en','Top 10 Customers: 30 Days',0),(150625,4185,'is','',0),(150626,4185,'dr','(Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† : ÙŠÙƒ Ø³Ø§Ù„ ',0),(150627,4185,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† (Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† : ÙŠÙƒ Ø³Ø§Ù„ ',0),(150628,4185,'tr','En iyi 10 mÃ¼ÅŸteriler: 1 yÄ±l',0),(150629,4185,'pl','10 najlepszych klientÃ³w: 1 rok',0),(150630,4185,'bg','Ð¢Ð¾Ð¿ 10 ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸: 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(150631,4185,'ur','Ù¹Ø§Ù¾ 10 Ú¯Ø§ÛÚ©: 1 Ø³Ø§Ù„',0),(150632,4185,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÐºÑƒÐ¿Ð°Ñ†Ð°: 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(150633,4185,'vi','MÆ°á»i khÃ¡ch hÃ ng cao nháº¥t: 1 nÄƒm',0),(150634,4185,'af','Top 10 Kliente/Klante:  1 Jaar',0),(150635,4185,'ro','Top 10 clienÅ£i: 1 an',0),(150636,4185,'et','Top 10 kliendid: 1 aasta',0),(150637,4185,'si','Top 10 stranke: 1 leto',0),(150638,4185,'ba','Top 10 pelanggan: 1 tahun',0),(150639,4185,'nl','Top 10 klanten: 1 jaar',0),(150640,4185,'fi','Top 10 asiakkaat: 1 vuosi',0),(150641,4185,'no','Topp 10 kunder: 1 Ã¥r',0),(150642,4185,'da','Top 10 kunder: 1 Ã¥r',0),(150643,4185,'ko','í†± 10 ê³ ê°: 1 ë…„',0),(150644,4185,'he','×”×¢×œ×™×•×Ÿ 10 ×”×œ×§×•×—×•×ª: 1 ×©× ×”',0),(150645,4185,'el','Top 10 Ï€ÎµÎ»Î¬Ï„ÎµÏ‚: 1 Î­Ï„Î¿Ï‚',0),(150646,4185,'zh','å‰åä½å®¢æˆ·ï¼š1å¹´\r\n',0),(150647,4185,'sv','Topp 10 kunder: 1 Ã¥r',0),(150648,4185,'it','10 migliori clienti: 1 anno',0),(150649,4185,'tl','',0),(150650,4185,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3604;&#3637;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604; : 1 &#3611;&#3637;',0),(150651,4185,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚: 1 à¤µà¤°à¥à¤·',0),(150652,4185,'ms','Top 10 pelanggan: 1 tahun',0),(150653,4185,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø£Ø¹Ù„Ù‰ 10: 1 Ø³Ù†Ø©',0),(150654,4185,'fr','Top 10 clients: 1 an',0),(150655,4185,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?é¡§å®¢ï¼š1å¹´',0),(150656,4185,'pt','Top 10 clientes: 1 ano',0),(150657,4185,'ru','Ð¢Ð¾Ð¿ 10 ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²: 1 Ð“Ð¾Ð´',0),(150658,4185,'es','Los 10 Clientes Principales: 1 AÃ±o',0),(150659,4185,'de','Top 10-Kunden: 1 Jahr',0),(150660,4185,'en','Top 10 Customers: 1 Year',0),(150661,4186,'is','',0),(150662,4186,'dr','ÙØ±ÙˆØ´ Ø¯Ù„Ø§Ø± ',0),(150663,4186,'pr','ÙØ±ÙˆØ´ Ø¯Ù„Ø§Ø± ',0),(150664,4186,'tr','Dolar satÄ±ÅŸ',0),(150665,4186,'pl','SprzedaÅ¼y dolara',0),(150666,4186,'bg','Ð”Ð¾Ð»Ð°Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(150667,4186,'ur','ÚˆØ§Ù„Ø± Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(150668,4186,'sr','Ð”Ð¾Ð»Ð°Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(150669,4186,'vi','BÃ¡n Dola',0),(150670,4186,'af','Dollar verkope',0),(150671,4186,'ro','Dolar vÃ¢nzÄƒri',0),(150672,4186,'et','Dollar mÃ¼Ã¼k',0),(150673,4186,'si','Dolar prodaje',0),(150674,4186,'ba','Dolar penjualan',0),(150675,4186,'nl','Dollar verkoop',0),(150676,4186,'fi','Liikevaihtoa',0),(150677,4186,'no','Dollar salg',0),(150678,4186,'da','Dollar salg',0),(150679,4186,'ko','ë‹¬ëŸ¬ íŒë§¤',0),(150680,4186,'he','×“×•×œ×¨ ×ž×›×™×¨×•×ª',0),(150681,4186,'el','Î”Î¿Î»Î¬ÏÎ¹Î¿ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(150682,4186,'zh','ç¾Žå…ƒé”€å”®é¢\r\n',0),(150683,4186,'sv','Dollar fÃ¶rsÃ¤ljning',0),(150684,4186,'it','Vendite del dollaro',0),(150685,4186,'tl','',0),(150686,4186,'th','&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;',0),(150687,4186,'hi','à¤¡à¥‰à¤²à¤° à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(150688,4186,'ms','Jualan dolar',0),(150689,4186,'ar','Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø¯ÙˆÙ„Ø§Ø±',0),(150690,4186,'fr','Ventes de dollar',0),(150691,4186,'jp','$$ Sales',0),(150692,4186,'pt','Vendas de dÃ³lar',0),(150693,4186,'ru','Ð”Ð¾Ð»Ð»Ð°Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(150694,4186,'es','Ventas en DÃ³lares',0),(150695,4186,'de','Dollar Umsatz',0),(150696,4186,'en','Dollar Sales',0),(150697,4187,'is','',0),(150698,4187,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(150699,4187,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(150700,4187,'tr','SatÄ±lan miktar',0),(150701,4187,'pl','IloÅ›Ä‡ sprzedanych',0),(150702,4187,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¸',0),(150703,4187,'ur','ÙØ±ÙˆØ®Øª Ù‚ÛŒ',0),(150704,4187,'sr','ÐšÐ¾Ð» Ñ˜Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¾',0),(150705,4187,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ bÃ¡n',0),(150706,4187,'af','Hoev. Verkoop',0),(150707,4187,'ro','Cantit vÃ¢ndute',0),(150708,4187,'et','MÃ¼Ã¼dud kogus',0),(150709,4187,'si','KoliÄina prodaje',0),(150710,4187,'ba','Qty dijual',0),(150711,4187,'nl','Aantal verkocht',0),(150712,4187,'fi','MÃ¤Ã¤rÃ¤, myyty',0),(150713,4187,'no','Antall solgt',0),(150714,4187,'da','Antal solgte',0),(150715,4187,'ko','íŒë§¤ ìˆ˜ëŸ‰',0),(150716,4187,'he','×›×ž×•×ª × ×ž×›×¨',0),(150717,4187,'el','Î Î¿Ï…Î»Î·Î¼Î­Î½Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(150718,4187,'zh','é”€å”®æ•°é‡\r\n',0),(150719,4187,'sv','Antal sÃ¥lda',0),(150720,4187,'it','Q. tÃ  venduto',0),(150721,4187,'tl','',0),(150722,4187,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3586;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(150723,4187,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¬à¥‡à¤šà¤¾',0),(150724,4187,'ms','Qty yang dijual',0),(150725,4187,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¨Ø§Ø¹Ø©',0),(150726,4187,'fr','QuantitÃ© vendue',0),(150727,4187,'jp','è²©å£²æ¸ˆæ•°é‡?',0),(150728,4187,'pt','Qtde vendida',0),(150729,4187,'ru','ÐšÐ¾Ð»-Ð²Ð¾ ÐŸÑ€Ð¾Ð´Ð°Ð½Ð¾',0),(150730,4187,'es','Cantidad Vendida',0),(150731,4187,'de','Qty verkauft',0),(150732,4187,'en','Qty Sold',0),(150733,4188,'is','',0),(150734,4188,'dr','(Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø¬Ù†Ø³Ù‡Ø§: Ù…Ø§Ù‡',0),(150735,4188,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† (Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) ÙƒØ§Ù„Ø§Ù‡Ø§: Ù…Ø§Ù‡',0),(150736,4188,'tr','En iyi 10 Ã¶ÄŸeler: 30 gÃ¼n',0),(150737,4188,'pl','10 najlepszych elementÃ³w: 30 dni',0),(150738,4188,'bg','Ð¢Ð¾Ð¿ 10 ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸: 30 Ð´Ð½Ð¸',0),(150739,4188,'ur','Ù¹Ø§Ù¾ 10 Ø§Ø´ÛŒØ§Ø¡: 30 Ø¯Ù†',0),(150740,4188,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÑÑ‚Ð°Ð²ÐºÐ¸: 30 Ð´Ð°Ð½Ð°',0),(150741,4188,'vi','10 hÃ ng cao nháº¥t: 30 ngÃ y ',0),(150742,4188,'af','Top 10 Items:  30 Dae',0),(150743,4188,'ro','Top 10 articole: 30 zile',0),(150744,4188,'et','Top 10 punktid: 30 pÃ¤eva',0),(150745,4188,'si','Top 10 elementov: 30 dni',0),(150746,4188,'ba','Top 10 item: 30 hari',0),(150747,4188,'nl','Top 10 Items: 30 dagen',0),(150748,4188,'fi','Top 10 kohteet: 30 pÃ¤ivÃ¤Ã¤',0),(150749,4188,'no','Topp 10 elementer: 30 dager',0),(150750,4188,'da','Top 10 elementer: 30 dage',0),(150751,4188,'ko','ìƒìœ„ 10 ê°œ í•­ëª©: 30 ì¼',0),(150752,4188,'he','×”×¢×œ×™×•×Ÿ 10 ×¤×¨×™×˜×™×: 30 ×™×ž×™×',0),(150753,4188,'el','Top 10 ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±: 30 Î·Î¼Î­ÏÎµÏ‚',0),(150754,4188,'zh','å‰åä¸ªé¡¹ç›®ï¼š30å¤©\r\n',0),(150755,4188,'sv','Topp 10 objekt: 30 dagar',0),(150756,4188,'it','Top 10 articoli: 30 giorni',0),(150757,4188,'tl','',0),(150758,4188,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3604;&#3637;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604; : 30 &#3623;&#3633;&#3609;',0),(150759,4188,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤†à¤‡à¤Ÿà¤®: 30 à¤¦à¤¿à¤¨',0),(150760,4188,'ms','Top 10 item: 30 hari',0),(150761,4188,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¨Ù†ÙˆØ¯: 30 ÙŠÙˆÙ…Ø§',0),(150762,4188,'fr','Top 10 Articles : 30 jours',0),(150763,4188,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?å“?ç›®ï¼š30æ—¥é–“',0),(150764,4188,'pt','Top 10 itens: 30 dias',0),(150765,4188,'ru','Ð¢Ð¾Ð¿ 10 Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²: 30 Ð”Ð½ÐµÐ¹',0),(150766,4188,'es','Los 10 Items Principales: 30 DÃ­as',0),(150767,4188,'de','Top 10 Positionen: 30 Tage',0),(150768,4188,'en','Top 10 Items: 30 Days',0),(150769,4189,'is','',0),(150770,4189,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ù„Ø§',0),(150771,4189,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ù„Ø§',0),(150772,4189,'tr','Madde etkinlik raporunu gÃ¶rÃ¼ntÃ¼leyin',0),(150773,4189,'pl','Zobacz element sprawozdania z dziaÅ‚alnoÅ›ci',0),(150774,4189,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð°',0),(150775,4189,'ur','Ù…Ù†Ø¸Ø± Ø´Û’ Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒÙˆÚº Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(150776,4189,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÑ‚Ð°Ð²ÐºÑƒ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(150777,4189,'vi','Xem bÃ¡o cÃ¡o luÃ¢n chuyá»ƒn hÃ ng hÃ³a',0),(150778,4189,'af','Besigtig Item Aktiwiteitsverslag',0),(150779,4189,'ro','Vezi articol raport de activitate',0),(150780,4189,'et','Saate vaadata kauba tegevusaruanne',0),(150781,4189,'si','Pregledovati poroÄilo o dejavnostih',0),(150782,4189,'ba','Lihat Item laporan kegiatan',0),(150783,4189,'nl','Activiteitenverslag object bekijken',0),(150784,4189,'fi','NÃ¤ytÃ¤ nimikkeen toimintakertomus',0),(150785,4189,'no','Vis aktivitetsrapport',0),(150786,4189,'da','Se punkt aktivitetsrapport',0),(150787,4189,'ko','í™œë™ ë³´ê³ ì„œ í•­ëª© ë³´ê¸°',0),(150788,4189,'he','×”×¦×’ ×¤×¨×™×˜ ×“×•×— ×¤×¢×™×œ×•×ª',0),(150789,4189,'el','Î”ÎµÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î­ÎºÎ¸ÎµÏƒÎ· Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï„Î®Ï„Ï‰Î½',0),(150790,4189,'zh','æŸ¥çœ‹é¡¹ç›®æ´»åŠ¨æŠ¥å‘Š\r\n',0),(150791,4189,'sv','Visa verksamhetsrapport',0),(150792,4189,'it','Elemento Mostra Report attivitÃ ',0),(150793,4189,'tl','',0),(150794,4189,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(150795,4189,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(150796,4189,'ms','Lihat perkara Laporan aktiviti',0),(150797,4189,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ± Ø­Ø±ÙƒØ© Ø§Ù„ØµÙ†Ù',0),(150798,4189,'fr','DÃ©couvre point de rapport d\'activitÃ©',0),(150799,4189,'jp','å“?ç›®æ´»å‹•ãƒ¬ãƒ?ãƒ¼ãƒˆã‚’è¦‹ã‚‹',0),(150800,4189,'pt','Ver Item relatÃ³rio de atividade',0),(150801,4189,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð¾ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(150802,4189,'es','Visionar Informe de Actividad de los Items',0),(150803,4189,'de','Zeigen Artikel TÃ¤tigkeitsbericht an',0),(150804,4189,'en','View Item Activity Report',0),(150805,4190,'is','',0),(150806,4190,'dr','(Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø¬Ù†Ø³Ù‡Ø§: Ø³ÙŠ (30)  Ø±ÙˆØ²',0),(150807,4190,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† (Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) ÙƒØ§Ù„Ø§Ù‡Ø§: Ø³ÙŠ (30)  Ø±ÙˆØ²',0),(150808,4190,'tr','En iyi 10 Ã¶ÄŸeler: 30 gÃ¼n',0),(150809,4190,'pl','10 najlepszych elementÃ³w: 30 dni',0),(150810,4190,'bg','Ð¢Ð¾Ð¿ 10 ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸: 30 Ð´Ð½Ð¸',0),(150811,4190,'ur','Ù¹Ø§Ù¾ 10 Ø§Ø´ÛŒØ§Ø¡: 30 Ø¯Ù†',0),(150812,4190,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÑÑ‚Ð°Ð²ÐºÐ¸: 30 Ð´Ð°Ð½Ð°',0),(150813,4190,'vi','10 hÃ ng cao nháº¥t: 30 ngÃ y ',0),(150814,4190,'af','Top 10 Items:  30 Dae',0),(150815,4190,'ro','Top 10 articole: 30 zile',0),(150816,4190,'et','Top 10 punktid: 30 pÃ¤eva',0),(150817,4190,'si','Top 10 elementov: 30 dni',0),(150818,4190,'ba','Top 10 item: 30 hari',0),(150819,4190,'nl','Top 10 Items: 30 dagen',0),(150820,4190,'fi','Top 10 kohteet: 30 pÃ¤ivÃ¤Ã¤',0),(150821,4190,'no','Topp 10 elementer: 30 dager',0),(150822,4190,'da','Top 10 elementer: 30 dage',0),(150823,4190,'ko','ìƒìœ„ 10 ê°œ í•­ëª©: 30 ì¼',0),(150824,4190,'he','×”×¢×œ×™×•×Ÿ 10 ×¤×¨×™×˜×™×: 30 ×™×ž×™×',0),(150825,4190,'el','Top 10 ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±: 30 Î·Î¼Î­ÏÎµÏ‚',0),(150826,4190,'zh','å‰åä¸ªé¡¹ç›®ï¼š30å¤©\r\n',0),(150827,4190,'sv','Topp 10 objekt: 30 dagar',0),(150828,4190,'it','Top 10 articoli: 30 giorni',0),(150829,4190,'tl','',0),(150830,4190,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3604;&#3637;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604; : 30 &#3623;&#3633;&#3609;',0),(150831,4190,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤†à¤‡à¤Ÿà¤®: 30 à¤¦à¤¿à¤¨',0),(150832,4190,'ms','Top 10 item: 30 hari',0),(150833,4190,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¨Ù†ÙˆØ¯: 30 ÙŠÙˆÙ…Ø§',0),(150834,4190,'fr','Top 10 Articles : 30 jours',0),(150835,4190,'jp','ãƒˆãƒƒãƒ—10å“?ç›®ï¼š30æ—¥é–“',0),(150836,4190,'pt','Top 10 itens: 30 dias',0),(150837,4190,'ru','Ð¢Ð¾Ð¿ 10 Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²: 30 Ð”Ð½ÐµÐ¹',0),(150838,4190,'es','Los 10 Items Principales: 30 DÃ­as',0),(150839,4190,'de','Top 10 Positionen: 30 Tage',0),(150840,4190,'en','Top 10 Items: 30 Days',0),(150841,4191,'is','',0),(150842,4191,'dr','(Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø¬Ù†Ø³Ù‡Ø§: ÙŠÙƒ Ø³Ø§Ù„',0),(150843,4191,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† (Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) ÙƒØ§Ù„Ø§Ù‡Ø§: ÙŠÙƒ Ø³Ø§Ù„',0),(150844,4191,'tr','En iyi 10 Ã¶ÄŸeler: 1 yÄ±l',0),(150845,4191,'pl','10 najlepszych elementÃ³w: 1 rok',0),(150846,4191,'bg','Ð¢Ð¾Ð¿ 10 ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸: 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(150847,4191,'ur','Ù¹Ø§Ù¾ 10 Ø§Ø´ÛŒØ§Ø¡: 1 Ø³Ø§Ù„',0),(150848,4191,'sr','Ð¢Ð¾Ð¿ 10 Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°: 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(150849,4191,'vi','10 hÃ ng cao nháº¥t: 1 nÄƒm',0),(150850,4191,'af','Top 10 Items:  1 Jaar',0),(150851,4191,'ro','Top 10 elemente: 1 an',0),(150852,4191,'et','Top 10 punktid: 1 aasta',0),(150853,4191,'si','Top 10 elementov: 1 leto',0),(150854,4191,'ba','Top 10 item: 1 tahun',0),(150855,4191,'nl','Top 10 Items: 1 jaar',0),(150856,4191,'fi','Top 10 kohteet: 1 vuosi',0),(150857,4191,'no','Topp 10 elementer: 1 Ã¥r',0),(150858,4191,'da','Top 10 elementer: 1 Ã¥r',0),(150859,4191,'ko','ìƒìœ„ 10 ê°œ í•­ëª©: 1 ë…„',0),(150860,4191,'he','×”×¢×œ×™×•×Ÿ 10 ×¤×¨×™×˜×™×: 1 ×©× ×”',0),(150861,4191,'el','Top 10 ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±: 1 Î­Ï„Î¿Ï‚',0),(150862,4191,'zh','å‰åä¸ªé¡¹ç›®ï¼š1å¹´\r\n',0),(150863,4191,'sv','Topp 10 objekt: 1 Ã¥r',0),(150864,4191,'it','Top 10 articoli: 1 anno',0),(150865,4191,'tl','',0),(150866,4191,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3604;&#3637;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604; : 1 &#3611;&#3637;&#3656;',0),(150867,4191,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤†à¤‡à¤Ÿà¤®à¥à¤¸: 1 à¤µà¤°à¥à¤·',0),(150868,4191,'ms','Top 10 item: 1 tahun',0),(150869,4191,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¨Ù†ÙˆØ¯: 1 Ø³Ù†Ø©',0),(150870,4191,'fr','Top 10 Articles: 1 an',0),(150871,4191,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?å“?ç›®ï¼š1å¹´',0),(150872,4191,'pt','Top 10 itens: 1 ano',0),(150873,4191,'ru','Ð¢Ð¾Ð¿ 10 Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²: 1 Ð“Ð¾Ð´',0),(150874,4191,'es','Los 10 Items Principales: 1 AÃ±o',0),(150875,4191,'de','Top 10-Positionen: 1 Jahr',0),(150876,4191,'en','Top 10 Items: 1 Year',0),(150877,4192,'is','',0),(150878,4192,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(150879,4192,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(150880,4192,'tr','Toplam maliyet',0),(150881,4192,'pl','CaÅ‚kowity koszt',0),(150882,4192,'bg','ÐžÐ±Ñ‰Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(150883,4192,'ur','Ú©Ù„ Ù„Ø§Ú¯Øª',0),(150884,4192,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(150885,4192,'vi','Tá»•ng giÃ¡ thÃ nh',0),(150886,4192,'af','Totale Koste',0),(150887,4192,'ro','Costul total',0),(150888,4192,'et','Kulu kokku',0),(150889,4192,'si','Skupni stroÅ¡ki',0),(150890,4192,'ba','Total biaya',0),(150891,4192,'nl','Totale kosten',0),(150892,4192,'fi','Kokonaiskustannukset',0),(150893,4192,'no','Totale kostnader',0),(150894,4192,'da','Samlede omkostninger',0),(150895,4192,'ko','ì´ ë¹„ìš©',0),(150896,4192,'he','×¡×”\"×› ×¢×œ×•×ª',0),(150897,4192,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(150898,4192,'zh','æ€»æˆæœ¬\r\n',0),(150899,4192,'sv','Total kostnad',0),(150900,4192,'it','Costo totale',0),(150901,4192,'tl','',0),(150902,4192,'th','&#3619;&#3623;&#3617;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(150903,4192,'hi','à¤•à¥à¤² à¤²à¤¾à¤—à¤¤',0),(150904,4192,'ms','Jumlah kos',0),(150905,4192,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ØªÙƒÙ„ÙØ©',0),(150906,4192,'fr','CoÃ»t total',0),(150907,4192,'jp','å?ˆè¨ˆè²»ç”¨',0),(150908,4192,'pt','Custo total',0),(150909,4192,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(150910,4192,'es','Costo Total',0),(150911,4192,'de','Gesamtkosten',0),(150912,4192,'en','Total Cost',0),(150913,4193,'is','',0),(150914,4193,'dr','Ø¯Ø±ØµØ¯ Ø³ÙˆØ¯ ',0),(150915,4193,'pr','Ø¯Ø±ØµØ¯ Ø³ÙˆØ¯ ',0),(150916,4193,'tr','YÃ¼zde kÃ¢r',0),(150917,4193,'pl','Procent zysku',0),(150918,4193,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(150919,4193,'ur','ÙÛŒØµØ¯ Ù…Ù†Ø§ÙØ¹',0),(150920,4193,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð°',0),(150921,4193,'vi','Pháº§n trÄƒm lá»£i nhuáº­n',0),(150922,4193,'af','Persent Wins',0),(150923,4193,'ro','Procentul de Profit',0),(150924,4193,'et','Protsentuaalne kasum',0),(150925,4193,'si','Odstotek dobiÄka',0),(150926,4193,'ba','Persen keuntungan',0),(150927,4193,'nl','Percentage winst',0),(150928,4193,'fi','Prosenttia voittoa',0),(150929,4193,'no','Prosent fortjeneste',0),(150930,4193,'da','Procentvis avance',0),(150931,4193,'ko','ë°±ë¶„ìœ¨ ì´ìµ',0),(150932,4193,'he','××—×•×– ×¨×•×•×—',0),(150933,4193,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎºÎ­ÏÎ´Î¿Ï…Ï‚',0),(150934,4193,'zh','åˆ©æ¶¦ç™¾åˆ†æ¯”\r\n',0),(150935,4193,'sv','Procent vinst',0),(150936,4193,'it','Percentuale di profitto',0),(150937,4193,'tl','',0),(150938,4193,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3585;&#3635;&#3652;&#3619;',0),(150939,4193,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤²à¤¾à¤­',0),(150940,4193,'ms','Peratus keuntungan',0),(150941,4193,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù…Ù† Ø§Ù„Ø±Ø¨Ø­',0),(150942,4193,'fr','Pourcentage de Profit',0),(150943,4193,'jp','åˆ©ç›ŠçŽ‡',0),(150944,4193,'pt','Lucro percentual',0),(150945,4193,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸',0),(150946,4193,'es','Porciento de Utilidad',0),(150947,4193,'de','Prozent Gewinn',0),(150948,4193,'en','Percent Profit',0),(150949,4194,'is','',0),(150950,4194,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‚ÙŠÙ…Øª ',0),(150951,4194,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‚ÙŠÙ…Øª ',0),(150952,4194,'tr','Toplam fiyat',0),(150953,4194,'pl','CaÅ‚kowita cena',0),(150954,4194,'bg','ÐžÐ±Ñ‰Ð° Ñ†ÐµÐ½Ð°',0),(150955,4194,'ur','Ú©Ù„ Ù‚ÛŒÙ…Øª',0),(150956,4194,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ñ†ÐµÐ½Ð°',0),(150957,4194,'vi','Tá»•ng giÃ¡',0),(150958,4194,'af','Totale Prys',0),(150959,4194,'ro','PreÅ£ total',0),(150960,4194,'et','Hind kokku',0),(150961,4194,'si','Skupna cena',0),(150962,4194,'ba','Total harga',0),(150963,4194,'nl','Totaalprijs',0),(150964,4194,'fi','Kokonaishinta',0),(150965,4194,'no','SalgsbelÃ¸p',0),(150966,4194,'da','Samlet pris',0),(150967,4194,'ko','ì´ ê°€ê²©',0),(150968,4194,'he','×¡×”',0),(150969,4194,'el','Î£Ï…Î½.Ï„Î¹Î¼Î®',0),(150970,4194,'zh','æ€»ä»·æ ¼\r\n',0),(150971,4194,'sv','Totalpris',0),(150972,4194,'it','Prezzo totale',0),(150973,4194,'tl','',0),(150974,4194,'th','&#3619;&#3634;&#3588;&#3634;&#3619;&#3623;&#3617;',0),(150975,4194,'hi','à¤•à¥à¤² à¤®à¥‚à¤²à¥à¤¯',0),(150976,4194,'ms','Jumlah harga',0),(150977,4194,'ar','Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(150978,4194,'fr','Prix total',0),(150979,4194,'jp','å?ˆè¨ˆ',0),(150980,4194,'pt','PreÃ§o total',0),(150981,4194,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(150982,4194,'es','Precio Total',0),(150983,4194,'de','Gesamtpreis',0),(150984,4194,'en','Total Price',0),(150985,4195,'is','',0),(150986,4195,'dr',': Ø³ÙŠ 30 Ø±ÙˆØ² ',0),(150987,4195,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø³ÙˆØ¯ Ø¢ÙˆØ± : Ø³ÙŠ 30 Ø±ÙˆØ² ',0),(150988,4195,'tr','En iyi 10 kar Ã¶ÄŸeler: 30 gÃ¼n',0),(150989,4195,'pl','Zysk 10 najlepszych elementÃ³w: 30 dni',0),(150990,4195,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸: 30 Ð´Ð½Ð¸',0),(150991,4195,'ur','Ù¹Ø§Ù¾ 10 Ù…Ù†Ø§ÙØ¹ Ø§Ø´ÛŒØ§Ø¡: 30 Ø¯Ù†',0),(150992,4195,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð¾Ð±Ð¸Ñ‚ÐºÐ°: 30 Ð´Ð°Ð½Ð°',0),(150993,4195,'vi','10 hÃ ng lÃ£i cao nháº¥t: 30 ngÃ y ',0),(150994,4195,'af','Top 10 Winsgewende Items:  30 Dag',0),(150995,4195,'ro','Top 10 elemente de Profit: 30 zile',0),(150996,4195,'et','Top 10 kasumi kaubad: 30 pÃ¤eva',0),(150997,4195,'si','Top 10 dobiÄek elementov: 30 dni',0),(150998,4195,'ba','Top 10 keuntungan item: 30 hari',0),(150999,4195,'nl','Top 10 winst Items: 30 dagen',0),(151000,4195,'fi','Top 10 voittoa kohteet: 30 pÃ¤ivÃ¤Ã¤',0),(151001,4195,'no','Topp 10 overskudd elementer: 30 dager',0),(151002,4195,'da','Top 10 Profit emner: 30 dage',0),(151003,4195,'ko','í†± 10 ì´ìµ í•­ëª©: 30 ì¼',0),(151004,4195,'he','×”×¢×œ×™×•×Ÿ 10 ×¤×¨×™×˜×™× ×¨×•×•×—: 30 ×™×•×',0),(151005,4195,'el','Top 10 ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÎºÎ­ÏÎ´Î¿Ï‚: 30 Î·Î¼ÎµÏÏŽÎ½',0),(151006,4195,'zh','å‰10ååˆ©æ¶¦çš„é¡¹ç›®ï¼š30å¤©\r\n',0),(151007,4195,'sv','Topp 10 vinst objekt: 30 dagars',0),(151008,4195,'it','Top 10 articoli di profitto: 30 giorni',0),(151009,4195,'tl','',0),(151010,4195,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3585;&#3635;&#3652;&#3619; : 30&#3623;&#3633;&#3609;',0),(151011,4195,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤²à¤¾à¤­ à¤†à¤‡à¤Ÿà¤®: 30 à¤¦à¤¿à¤¨',0),(151012,4195,'ms','Item keuntungan Top 10: 30 hari',0),(151013,4195,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¨Ù†ÙˆØ¯ Ø§Ù„Ø£Ø±Ø¨Ø§Ø­: 30 ÙŠÙˆÙ…',0),(151014,4195,'fr','Top 10 Articles de Profit : 30 jours',0),(151015,4195,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?å?Žç›Šå“?ç›®ï¼š30æ—¥é–“',0),(151016,4195,'pt','Top 10 itens de lucro: 30 dias',0),(151017,4195,'ru','Ð¢Ð¾Ð¿ 10 Ð¿ÑƒÐ½ÐºÑ‚Ð¾Ð² Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸: 30 Ð´Ð½ÐµÐ¹',0),(151018,4195,'es','Los 10 Items Principales de MÃ¡s Utilidad: 30 DÃ­as',0),(151019,4195,'de','Top 10 Ergebnis Elemente: 30 Tage',0),(151020,4195,'en','Top 10 Profit Items: 30 Day',0),(151021,4196,'is','',0),(151022,4196,'dr',': ÙŠÙƒ Ø³Ø§Ù„ ',0),(151023,4196,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø³ÙˆØ¯ Ø¢ÙˆØ± : ÙŠÙƒ Ø³Ø§Ù„ ',0),(151024,4196,'tr','En iyi 10 kar Ã¶ÄŸeler: 1 yÄ±l',0),(151025,4196,'pl','Zysk 10 najlepszych elementÃ³w: 1 rok',0),(151026,4196,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸: 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(151027,4196,'ur','Ù¹Ø§Ù¾ 10 Ù…Ù†Ø§ÙØ¹ Ø§Ø´ÛŒØ§Ø¡: 1 Ø³Ø§Ù„',0),(151028,4196,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð¾Ð±Ð¸Ñ‚ÐºÐ°: 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(151029,4196,'vi','10 hÃ ng lÃ£i cao nháº¥t: 1 nÄƒm',0),(151030,4196,'af','Top 10 Winsgewende Items:  1 Jaar',0),(151031,4196,'ro','Top 10 Profit elemente: 1 an',0),(151032,4196,'et','Top 10 kasumi esemed: 1 aasta',0),(151033,4196,'si','Top 10 dobiÄek elemente: 1 leto',0),(151034,4196,'ba','Top 10 keuntungan item: 1 tahun',0),(151035,4196,'nl','Top 10 winst Items: 1 jaar',0),(151036,4196,'fi','Top 10 voittoa kohteet: 1 vuosi',0),(151037,4196,'no','Topp 10 overskudd elementer: 1 Ã¥r',0),(151038,4196,'da','Top 10 Profit elementer: 1 Ã¥r',0),(151039,4196,'ko','í†± 10 ì´ìµ í•­ëª©: 1 ë…„',0),(151040,4196,'he','×”×¢×œ×™×•×Ÿ 10 ×¤×¨×™×˜×™× ×¨×•×•×—: 1 ×©× ×”',0),(151041,4196,'el','Top 10 ÎºÎµÏÎ´ÏŽÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±: 1 Î­Ï„Î¿Ï‚',0),(151042,4196,'zh','å‰10ååˆ©æ¶¦çš„é¡¹ç›®ï¼š1å¹´\r\n',0),(151043,4196,'sv','Topp 10 vinst objekt: 1 Ã¥r',0),(151044,4196,'it','Top 10 articoli di profitto: 1 anno',0),(151045,4196,'tl','',0),(151046,4196,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3585;&#3635;&#3652;&#3619; : 1&#3611;&#3637;',0),(151047,4196,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤²à¤¾à¤­ à¤†à¤‡à¤Ÿà¤®: 1 à¤µà¤°à¥à¤·',0),(151048,4196,'ms','Top 10 keuntungan item: 1 tahun',0),(151049,4196,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø±Ø¨Ø­: 1 Ø³Ù†Ø©',0),(151050,4196,'fr','Top 10 Articles de rÃ©sultat: 1 an',0),(151051,4196,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?å?Žç›Šå“?ç›®ï¼š1å¹´',0),(151052,4196,'pt','Top 10 itens de lucro: 1 ano',0),(151053,4196,'ru','Ð¢Ð¾Ð¿ 10 Ð¿ÑƒÐ½ÐºÑ‚Ð¾Ð² Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸: 1 Ð³Ð¾Ð´',0),(151054,4196,'es','Los 10 Items Principales de MÃ¡s Utilidad: 1 AÃ±o',0),(151055,4196,'de','Top 10 Ergebnis Elemente: 1 Jahr',0),(151056,4196,'en','Top 10 Profit Items: 1 Year',0),(151057,4197,'is','',0),(151058,4197,'dr',': Ø³ÙŠ 30 Ø±ÙˆØ²',0),(151059,4197,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø³ÙˆØ¯ Ø¢ÙˆØ± : Ø³ÙŠ 30 Ø±ÙˆØ²',0),(151060,4197,'tr','En iyi 10 kar Ã¶ÄŸeler: 30 gÃ¼n',0),(151061,4197,'pl','Zysk 10 najlepszych elementÃ³w: 30 dni',0),(151062,4197,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸: 30 Ð´Ð½Ð¸',0),(151063,4197,'ur','Ù¹Ø§Ù¾ 10 Ù…Ù†Ø§ÙØ¹ Ø§Ø´ÛŒØ§Ø¡: 30 Ø¯Ù†',0),(151064,4197,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð¾Ð±Ð¸Ñ‚ÐºÐ°: 30 Ð´Ð°Ð½Ð°',0),(151065,4197,'vi','10 hÃ ng lÃ£i cao nháº¥t: 30 ngÃ y ',0),(151066,4197,'af','Top 10 Winsgewende Items:  30 Dae',0),(151067,4197,'ro','Top 10 elemente de Profit: 30 zile',0),(151068,4197,'et','Top 10 kasumi kaubad: 30 pÃ¤eva',0),(151069,4197,'si','Top 10 dobiÄek elementov: 30 dni',0),(151070,4197,'ba','Top 10 keuntungan item: 30 hari',0),(151071,4197,'nl','Top 10 winst Items: 30 dagen',0),(151072,4197,'fi','Top 10 voittoa kohteet: 30 pÃ¤ivÃ¤Ã¤',0),(151073,4197,'no','Topp 10 overskudd elementer: 30 dager',0),(151074,4197,'da','Top 10 Profit emner: 30 dage',0),(151075,4197,'ko','í†± 10 ì´ìµ í•­ëª©: 30 ì¼',0),(151076,4197,'he','×”×¢×œ×™×•×Ÿ 10 ×¤×¨×™×˜×™× ×¨×•×•×—: 30 ×™×ž×™×',0),(151077,4197,'el','Top 10 ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÎºÎ­ÏÎ´Î¿Ï‚: 30 Î·Î¼Î­ÏÎµÏ‚',0),(151078,4197,'zh','å‰10ååˆ©æ¶¦çš„é¡¹ç›®ï¼š30å¤©\r\n',0),(151079,4197,'sv','Topp 10 vinst objekt: 30 dagar',0),(151080,4197,'it','Top 10 articoli di profitto: 30 giorni',0),(151081,4197,'tl','',0),(151082,4197,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3585;&#3635;&#3652;&#3619; : 30&#3623;&#3633;&#3609;',0),(151083,4197,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤²à¤¾à¤­ à¤†à¤‡à¤Ÿà¤®: 30 à¤¦à¤¿à¤¨',0),(151084,4197,'ms','Item keuntungan Top 10: 30 hari',0),(151085,4197,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¨Ù†ÙˆØ¯ Ø§Ù„Ø£Ø±Ø¨Ø§Ø­: 30 ÙŠÙˆÙ…Ø§',0),(151086,4197,'fr','Top 10 Articles de Profit : 30 jours',0),(151087,4197,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?å?Žç›Šå“?ç›®ï¼š30æ—¥é–“',0),(151088,4197,'pt','Top 10 itens de lucro: 30 dias',0),(151089,4197,'ru','Ð¢Ð¾Ð¿ 10 Ð¿ÑƒÐ½ÐºÑ‚Ð¾Ð² Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸: 30 Ð´Ð½ÐµÐ¹',0),(151090,4197,'es','Los 10 Items Principales de MÃ¡s Utilidad: 30 DÃ­as',0),(151091,4197,'de','Top 10 Ergebnis Elemente: 30 Tage',0),(151092,4197,'en','Top 10 Profit Items: 30 Days',0),(151093,4198,'is','',0),(151094,4198,'dr',': ÙŠÙƒ Ø³Ø§Ù„ ',0),(151095,4198,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø³ÙˆØ¯ Ø¢ÙˆØ± : ÙŠÙƒ Ø³Ø§Ù„ ',0),(151096,4198,'tr','En iyi 10 kar Ã¶ÄŸeler: 1 yÄ±l',0),(151097,4198,'pl','Zysk 10 najlepszych elementÃ³w: 1 rok',0),(151098,4198,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸: 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(151099,4198,'ur','Ù¹Ø§Ù¾ 10 Ù…Ù†Ø§ÙØ¹ Ø§Ø´ÛŒØ§Ø¡: 1 Ø³Ø§Ù„',0),(151100,4198,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð¾Ð±Ð¸Ñ‚ÐºÐ°: 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(151101,4198,'vi','10 hÃ ng lÃ£i cao nháº¥t: 1 nÄƒm',0),(151102,4198,'af','Top 10 Winsgewende Items:  1 Jaar',0),(151103,4198,'ro','Top 10 Profit elemente: 1 an',0),(151104,4198,'et','Top 10 kasumi esemed: 1 aasta',0),(151105,4198,'si','Top 10 dobiÄek elemente: 1 leto',0),(151106,4198,'ba','Top 10 keuntungan item: 1 tahun',0),(151107,4198,'nl','Top 10 winst Items: 1 jaar',0),(151108,4198,'fi','Top 10 voittoa kohteet: 1 vuosi',0),(151109,4198,'no','Topp 10 overskudd elementer: 1 Ã¥r',0),(151110,4198,'da','Top 10 Profit elementer: 1 Ã¥r',0),(151111,4198,'ko','í†± 10 ì´ìµ í•­ëª©: 1 ë…„',0),(151112,4198,'he','×”×¢×œ×™×•×Ÿ 10 ×¤×¨×™×˜×™× ×¨×•×•×—: 1 ×©× ×”',0),(151113,4198,'el','Top 10 ÎºÎµÏÎ´ÏŽÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±: 1 Î­Ï„Î¿Ï‚',0),(151114,4198,'zh','åˆ©æ¶¦å‰10åçš„é¡¹ç›®ï¼š1å¹´\r\n',0),(151115,4198,'sv','Topp 10 vinst objekt: 1 Ã¥r',0),(151116,4198,'it','Top 10 articoli di profitto: 1 anno',0),(151117,4198,'tl','',0),(151118,4198,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3585;&#3635;&#3652;&#3619; : 1&#3611;&#3637;',0),(151119,4198,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤²à¤¾à¤­ à¤†à¤‡à¤Ÿà¤®: 1 à¤µà¤°à¥à¤·',0),(151120,4198,'ms','Top 10 keuntungan item: 1 tahun',0),(151121,4198,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø±Ø¨Ø­: 1 Ø³Ù†Ø©',0),(151122,4198,'fr','Top 10 Articles de rÃ©sultat: 1 an',0),(151123,4198,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?å?Žç›Šå“?ç›®ï¼š1å¹´',0),(151124,4198,'pt','Top 10 itens de lucro: 1 ano',0),(151125,4198,'ru','Ð¢Ð¾Ð¿ 10 Ð¿ÑƒÐ½ÐºÑ‚Ð¾Ð² Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸: 1 Ð³Ð¾Ð´',0),(151126,4198,'es','Los 10 Items Principales de MÃ¡s Utilidad: 1 AÃ±o',0),(151127,4198,'de','Top 10 Ergebnis Elemente: 1 Jahr',0),(151128,4198,'en','Top 10 Profit Items: 1 Year',0),(151129,4199,'is','',0),(151130,4199,'dr','(Ø«Ø¨Øª) (ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(151131,4199,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª(Ø«Ø¨Øª) (ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡) Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø¨Ú©Ù‡',0),(151132,4199,'tr','BaÄŸlayÄ±cÄ± Not',0),(151133,4199,'pl','Uwaga introligatornia',0),(151134,4199,'bg','ÐšÐ½Ð¸Ð³Ð¾Ð²ÐµÐ·Ð½Ð¸Ñ†Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(151135,4199,'ur','Ø¨Ø§Ù†ÚˆØ±ÛŒ Ù†ÙˆÙ¹',0),(151136,4199,'sr','Ð‘Ð¸Ð½Ð´ÐµÑ€y ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(151137,4199,'vi','Ghi chÃº Ä‘Ã³ng sÃ¡ch',0),(151138,4199,'af','Bindery Nota',0),(151139,4199,'ro','NotÄƒ de legatorie',0),(151140,4199,'et','Kirjansitomo MÃ¤rkus',0),(151141,4199,'si','Knjigoveznica Opomba',0),(151142,4199,'ba','Bindery catatan',0),(151143,4199,'nl','Bindery Opmerking',0),(151144,4199,'fi','Bindery-Huomautus',0),(151145,4199,'no','Bindingen Merk',0),(151146,4199,'da','Bindery BemÃ¦rk',0),(151147,4199,'ko','ë°”ì¸ë”ë¦¬ ì°¸ê³ ',0),(151148,4199,'he','×”×¢×¨×” ×ž×¡×•×’ bindery',0),(151149,4199,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· bindery',0),(151150,4199,'zh','è£…è®¢å¤‡æ³¨\r\n',0),(151151,4199,'sv','Bindery Obs',0),(151152,4199,'it','Nota legatoria',0),(151153,4199,'tl','',0),(151154,4199,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3649;&#3615;&#3657;&#3617;',0),(151155,4199,'hi','à¤œà¤¿à¤²à¥à¤¦ à¤®à¥ˆà¤‚ à¤¨à¥‹à¤Ÿ',0),(151156,4199,'ms','Nota bindery',0),(151157,4199,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª',0),(151158,4199,'fr','Note de faÃ§onnage',0),(151159,4199,'jp','ãƒ?ã‚¤ãƒ³ãƒ€ãƒªãƒ¼ãƒ¡ãƒ¢',0),(151160,4199,'pt','Nota de bindery',0),(151161,4199,'ru','ÐŸÐµÑ€ÐµÐ¿Ð»ÐµÑ‚Ð½Ð°Ñ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(151162,4199,'es','Nota de Encuadernadora',0),(151163,4199,'de','Buchbinderei-Hinweis',0),(151164,4199,'en','Bindery Note',0),(151165,4200,'is','',0),(151166,4200,'dr',': Ø³ÙŠ  30 Ø±ÙˆØ² ',0),(151167,4200,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø³ÙˆØ¯ Ø¢ÙˆØ± ØªØ±ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† : Ø³ÙŠ  30 Ø±ÙˆØ² ',0),(151168,4200,'tr','Top 10 en karlÄ± mÃ¼ÅŸteriler - 30 gÃ¼n',0),(151169,4200,'pl','Top 10 najbardziej dochodowych klientÃ³w - 30 dni',0),(151170,4200,'bg','Ð¢Ð¾Ð¿ 10 Ð½Ð°Ð¹-Ð¿ÐµÑ‡ÐµÐ»Ð¸Ð²ÑˆÐ¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ - 30 Ð´Ð½Ð¸',0),(151171,4200,'ur','Ø§ÙˆÙ¾Ø± 10 Ø³Ø¨ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù…Ù†Ø§ÙØ¹ Ø¨Ø®Ø´ Ú¯Ø§ÛÚ©ÙˆÚº - 30 Ø¯Ù†',0),(151172,4200,'sr','ÐÐ°Ñ˜Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð°Ð±Ð¸Ð»Ð½Ð¸Ñ˜Ð¸ ÐºÑƒÐ¿Ñ†Ð¸ Ð¿Ñ€Ð²Ð¸Ñ… 10 - 30 Ð´Ð°Ð½Ð°',0),(151173,4200,'vi','MÆ°á»i khÃ¡ch hÃ ng lÃ£i nháº¥t: 30 ngÃ y  ',0),(151174,4200,'af','Top 10 Mees Winsgewende Klante/KliÃ«nte:  30 Dae',0),(151175,4200,'ro','Top 10 cele mai profitabile clienÅ£ii - 30 de zile',0),(151176,4200,'et','Top 10 kÃµige kasumlikumad kliendid - 30 pÃ¤eva',0),(151177,4200,'si','Top 10 najbolj dobiÄkonosne stranke - 30 dni',0),(151178,4200,'ba','Top 10 paling menguntungkan pelanggan - 30 hari',0),(151179,4200,'nl','Top 10 meest winstgevende klanten - 30 dagen',0),(151180,4200,'fi','Top 10 tuottavimmat Asiakkaamme - 30 pÃ¤ivÃ¤Ã¤',0),(151181,4200,'no','Topp 10 mest lÃ¸nnsomme kunder - 30 dager',0),(151182,4200,'da','Top 10 mest Profitable kunder - 30 dage',0),(151183,4200,'ko','í†± 10 ê°€ìž¥ ìˆ˜ìµì„± ìžˆëŠ” ê³ ê°-30 ì¼',0),(151184,4200,'he','×”×œ×§×•×—×•×ª ×”×¨×•×•×—×™×™× ×‘×™×•×ª×¨ top 10 - 30 ×™×ž×™×',0),(151185,4200,'el','Top 10 Ï€Î¹Î¿ Î±Ï€Î¿Î´Î¿Ï„Î¹ÎºÎ¿ÏÏ‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ - 30 Î·Î¼Î­ÏÎµÏ‚',0),(151186,4200,'zh','å‰åä½æœ€æœ‰ä»·å€¼çš„å®¢æˆ·ï¼š30å¤©\r\n',0),(151187,4200,'sv','Topp 10 mest lÃ¶nsamma kunder - 30 dagar',0),(151188,4200,'it','Clienti piÃ¹ redditizi di Top 10 - 30 giorni',0),(151189,4200,'tl','',0),(151190,4200,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3607;&#3635;&#3585;&#3635;&#3652;&#3619;&#3604;&#3637;&#3626;&#3640;&#3604; : 30&#3623;&#3633;&#3609;',0),(151191,4200,'hi','à¤šà¥‹à¤Ÿà¥€ à¤•à¥‡ 10 à¤¸à¤¬à¤¸à¥‡ à¤²à¤¾à¤­à¤¦à¤¾à¤¯à¤• à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ - 30 à¤¦à¤¿à¤¨',0),(151192,4200,'ms','Top 10 paling menguntungkan pelanggan - 30 hari',0),(151193,4200,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø£ÙƒØ«Ø± Ø±Ø¨Ø­ÙŠØ© Ø£Ø¹Ù„Ù‰ 10-30 ÙŠÙˆÙ…Ø§',0),(151194,4200,'fr','Top 10 des clients plus rentables - 30 jours',0),(151195,4200,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?æœ€é«˜å?Žç›Šé¡§å®¢ï¼š30æ—¥é–“',0),(151196,4200,'pt','Top 10 mais rentÃ¡veis clientes - 30 dias',0),(151197,4200,'ru','Ð¢Ð¾Ð¿-10 ÑÐ°Ð¼Ñ‹Ñ… Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒÐ½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² - 30 Ð´Ð½ÐµÐ¹',0),(151198,4200,'es','Los 10 Clientes Principales que Generan la MÃ¡s Utilidad: 30 DÃ­as',0),(151199,4200,'de','Top 10 profitabelsten Kunden - 30 Tage',0),(151200,4200,'en','Top 10 Most Profitable Customers - 30 Days',0),(151201,4201,'is','',0),(151202,4201,'dr',': ÙŠÙƒ Ø³Ø§Ù„',0),(151203,4201,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø³ÙˆØ¯ Ø¢ÙˆØ± ØªØ±ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† : ÙŠÙƒ Ø³Ø§Ù„',0),(151204,4201,'tr','Top 10 en karlÄ± mÃ¼ÅŸteriler - 1 yÄ±l',0),(151205,4201,'pl','Top 10 najbardziej dochodowych klientÃ³w - 1 rok',0),(151206,4201,'bg','Ð¢Ð¾Ð¿ 10 Ð½Ð°Ð¹-Ð¿ÐµÑ‡ÐµÐ»Ð¸Ð²ÑˆÐ¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(151207,4201,'ur','Ø§ÙˆÙ¾Ø± 10 Ø³Ø¨ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù…Ù†Ø§ÙØ¹ Ø¨Ø®Ø´ Ú¯Ø§ÛÚ©ÙˆÚº - 1 Ø³Ø§Ù„',0),(151208,4201,'sr','Ð¢Ð¾Ð¿ 10 Ð½Ð°Ñ˜Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð°Ð±Ð¸Ð»Ð½Ð¸Ñ˜Ð¸Ñ… ÐºÑƒÐ¿Ð°Ñ†Ð° â€“ 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(151209,4201,'vi','MÆ°á»i khÃ¡ch hÃ ng lÃ£i nháº¥t: 1 nÄƒm',0),(151210,4201,'af','Top 10 Mees Winsgewende Klante/KliÃ«nte:  1 Jaar',0),(151211,4201,'ro','Top 10 cele mai profitabile clienÅ£ii - 1 an',0),(151212,4201,'et','Top 10 kÃµige kasumlikumad kliendid - 1 aasta',0),(151213,4201,'si','Top 10 najbolj dobiÄkonosne stranke - 1 leto',0),(151214,4201,'ba','Top 10 paling menguntungkan pelanggan - 1 tahun',0),(151215,4201,'nl','Top 10 meest winstgevende klanten - 1 jaar',0),(151216,4201,'fi','Top 10 tuottavimmat Asiakkaamme - 1 vuosi',0),(151217,4201,'no','Topp 10 mest lÃ¸nnsomme kunder - 1 Ã¥r',0),(151218,4201,'da','Top 10 mest Profitable kunder - 1 Ã¥r',0),(151219,4201,'ko','í†± 10 ê°€ìž¥ ìˆ˜ìµì„± ìžˆëŠ” ê³ ê°-1 ë…„',0),(151220,4201,'he','×”×œ×§×•×—×•×ª ×”×¨×•×•×—×™×™× ×‘×™×•×ª×¨ top 10 - 1 ×©× ×”',0),(151221,4201,'el','Top 10 Ï€Î¹Î¿ Î±Ï€Î¿Î´Î¿Ï„Î¹ÎºÎ¿ÏÏ‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ - 1 Î­Ï„Î¿Ï‚',0),(151222,4201,'zh','å‰åä½æœ€æœ‰ä»·å€¼çš„å®¢æˆ·ï¼š1å¹´\r\n',0),(151223,4201,'sv','Topp 10 mest lÃ¶nsamma kunder - 1 Ã¥r',0),(151224,4201,'it','Top 10 clienti piÃ¹ redditizi - 1 anno',0),(151225,4201,'tl','',0),(151226,4201,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3607;&#3635;&#3585;&#3635;&#3652;&#3619;&#3604;&#3637;&#3626;&#3640;&#3604; : 1 &#3611;&#3637;&#3656;',0),(151227,4201,'hi','à¤šà¥‹à¤Ÿà¥€ à¤•à¥‡ 10 à¤¸à¤¬à¤¸à¥‡ à¤²à¤¾à¤­à¤¦à¤¾à¤¯à¤• à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ - 1 à¤¸à¤¾à¤²',0),(151228,4201,'ms','Top 10 paling menguntungkan pelanggan - 1 tahun',0),(151229,4201,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø£ÙƒØ«Ø± Ø±Ø¨Ø­ÙŠØ© Ø£Ø¹Ù„Ù‰ 10-Ø³Ù†Ø© 1',0),(151230,4201,'fr','Top 10 plus rentables clients - 1 an',0),(151231,4201,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?æœ€é«˜å?Žç›Šé¡§å®¢ï¼š1å¹´',0),(151232,4201,'pt','Top 10 mais rentÃ¡veis clientes - 1 ano',0),(151233,4201,'ru','Ð¢Ð¾Ð¿-10 ÑÐ°Ð¼Ñ‹Ñ… Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒÐ½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² - 1 Ð³Ð¾Ð´',0),(151234,4201,'es','Los 10 Clientes Principales que Generan la MÃ¡s Utilidad: 1 AÃ±o',0),(151235,4201,'de','Top 10 profitabelsten Kunden - 1 Jahr',0),(151236,4201,'en','Top 10 Most Profitable Customers - 1 Year',0),(151237,4202,'is','',0),(151238,4202,'dr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡',0),(151239,4202,'pr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡',0),(151240,4202,'tr','Aile adÄ±',0),(151241,4202,'pl','Nazwisko',0),(151242,4202,'bg','Ð¤Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(151243,4202,'ur','Ø®Ø§Ù†Ø¯Ø§Ù†ÛŒ Ù†Ø§Ù…',0),(151244,4202,'sr','ÐŸÑ€ÐµÐ·Ð¸Ð¼Ðµ',0),(151245,4202,'vi','TÃªn Gia ÄÃ¬nh ',0),(151246,4202,'af','Familienaam',0),(151247,4202,'ro','Nume de familie',0),(151248,4202,'et','Perekonnanimi',0),(151249,4202,'si','Priimek',0),(151250,4202,'ba','Nama keluarga',0),(151251,4202,'nl','Familienaam',0),(151252,4202,'fi','Sukunimi',0),(151253,4202,'no','Etternavn',0),(151254,4202,'da','Efternavn',0),(151255,4202,'ko','ê°€ì¡± ì´ë¦„',0),(151256,4202,'he','×©× ×ž×©×¤×—×”',0),(151257,4202,'el','Î•Ï€ÏŽÎ½Ï…Î¼Î¿',0),(151258,4202,'zh','å§“\r\n',0),(151259,4202,'sv','Efternamn',0),(151260,4202,'it','Nome di famiglia',0),(151261,4202,'tl','',0),(151262,4202,'th','&#3609;&#3634;&#3617;&#3626;&#3585;&#3640;&#3621;',0),(151263,4202,'hi','à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤•à¥‡ à¤¨à¤¾à¤®',0),(151264,4202,'ms','Nama keluarga',0),(151265,4202,'ar','Ø¥Ø³Ù… Ø§Ù„ÙØµÙŠÙ„Ø©',0),(151266,4202,'fr','Nom de famille',0),(151267,4202,'jp','å§“å??',0),(151268,4202,'pt','Nome de famÃ­lia',0),(151269,4202,'ru','Ð¤Ð°Ð¼Ð¸Ð»Ð¸Ñ',0),(151270,4202,'es','Nombre de Familia',0),(151271,4202,'de','Familienname',0),(151272,4202,'en','Family Name',0),(151273,4203,'is','',0),(151274,4203,'dr','IPH',0),(151275,4203,'pr','IPH',0),(151276,4203,'tr','IPH',0),(151277,4203,'pl','IPH',0),(151278,4203,'bg','IPH',0),(151279,4203,'ur','Ø§Ù',0),(151280,4203,'sr','Ð˜ÐŸÐ¥',0),(151281,4203,'vi','IPH',0),(151282,4203,'af','IPH',0),(151283,4203,'ro','IPH',0),(151284,4203,'et','IPH',0),(151285,4203,'si','IPH',0),(151286,4203,'ba','IPH',0),(151287,4203,'nl','WIV',0),(151288,4203,'fi','IPH',0),(151289,4203,'no','IPH',0),(151290,4203,'da','IPH',0),(151291,4203,'ko','IPH',0),(151292,4203,'he','IPH',0),(151293,4203,'el','IPH',0),(151294,4203,'zh','æ¯å°æ—¶æ‰“å°\r\n',0),(151295,4203,'sv','IPH',0),(151296,4203,'it','IPH',0),(151297,4203,'tl','',0),(151298,4203,'th','IPH',0),(151299,4203,'hi','IPH',0),(151300,4203,'ms','IPH',0),(151301,4203,'ar','Ø§Ù„Ù…Ø¹Ù‡Ø¯',0),(151302,4203,'fr','IPH',0),(151303,4203,'jp','IPH',0),(151304,4203,'pt','IPH',0),(151305,4203,'ru','Ð¡Ð›Ð£Ð§Ð',0),(151306,4203,'es','IPH',0),(151307,4203,'de','IPH',0),(151308,4203,'en','IPH',0),(151309,4204,'is','',0),(151310,4204,'dr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ø´ÙŠÙ† ',0),(151311,4204,'pr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ø´ÙŠÙ† ',0),(151312,4204,'tr','Makine aileler',0),(151313,4204,'pl','Maszyna rodzin',0),(151314,4204,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð°',0),(151315,4204,'ur','Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù†',0),(151316,4204,'sr','Ð¤Ð°Ð¼Ð¸Ð»Ð¸Ñ˜Ðµ',0),(151317,4204,'vi','DÃ²ng mÃ¡y gia Ä‘Ã¬nh',0),(151318,4204,'af','Masjien Families',0),(151319,4204,'ro','MaÅŸinÄƒ de familii',0),(151320,4204,'et','Kohapeal peredele',0),(151321,4204,'si','Stroj druÅ¾ine',0),(151322,4204,'ba','Mesin keluarga',0),(151323,4204,'nl','Machine gezinnen',0),(151324,4204,'fi','Koneen Perheet',0),(151325,4204,'no','Maskinen familier',0),(151326,4204,'da','Maskine familier',0),(151327,4204,'ko','ê¸°ê³„ ê°€ì¡±',0),(151328,4204,'he','×ž×›×•× ×ª ×ž×©×¤×—×•×ª',0),(151329,4204,'el','ÎœÎ·Ï‡Î±Î½Î® Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹ÎµÏ‚',0),(151330,4204,'zh','æœºç³»åˆ—\r\n',0),(151331,4204,'sv','Maskin familjer',0),(151332,4204,'it','Macchina famiglie',0),(151333,4204,'tl','',0),(151334,4204,'th','&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(151335,4204,'hi','à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤°à¥‹à¤‚',0),(151336,4204,'ms','Keluarga Mesin',0),(151337,4204,'ar','Ø¢Ù„Ø© Ø§Ù„Ø£Ø³Ø±',0),(151338,4204,'fr','Familles de machine',0),(151339,4204,'jp','æ©Ÿæ¢°ç³»çµ±',0),(151340,4204,'pt','FamÃ­lias de mÃ¡quina',0),(151341,4204,'ru','ÐœÐ°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹',0),(151342,4204,'es','Familias de MÃ¡quinas',0),(151343,4204,'de','Maschine Familien',0),(151344,4204,'en','Machine Families',0),(151345,4205,'is','',0),(151346,4205,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø±Ù†Ú¯Ù‡Ø§ ',0),(151347,4205,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø±Ù†Ú¯Ù‡Ø§ ',0),(151348,4205,'tr','Maksimum renk',0),(151349,4205,'pl','Maksymalna kolory',0),(151350,4205,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¾ Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(151351,4205,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø±Ù†Ú¯',0),(151352,4205,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð±Ð¾Ñ˜Ðµ',0),(151353,4205,'vi','Máº§u tá»‘i Ä‘a',0),(151354,4205,'af','Maksimum Kleure',0),(151355,4205,'ro','Maxim culori',0),(151356,4205,'et','Maksimaalne vÃ¤rvid',0),(151357,4205,'si','NajveÄ barve',0),(151358,4205,'ba','Warna maksimum',0),(151359,4205,'nl','Maximale kleuren',0),(151360,4205,'fi','Suurin vÃ¤rit',0),(151361,4205,'no','Maksimal farger',0),(151362,4205,'da','Maksimale farver',0),(151363,4205,'ko','ìµœëŒ€ ìƒ‰ìƒ',0),(151364,4205,'he','×”×¦×‘×¢×™× ×”×ž×¨×‘×™',0),(151365,4205,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Ï‡ÏÏŽÎ¼Î±Ï„Î±',0),(151366,4205,'zh','æœ€å¤šè‰²å½©\r\n',0),(151367,4205,'sv','Maximal fÃ¤rger',0),(151368,4205,'it','Massimi colori',0),(151369,4205,'tl','',0),(151370,4205,'th','&#3626;&#3637;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(151371,4205,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤°à¤‚à¤—',0),(151372,4205,'ms','Warna-warna yang maksimum',0),(151373,4205,'ar','Ø£Ù„ÙˆØ§Ù† ÙƒØ­Ø¯ Ø£Ù‚ØµÙ‰',0),(151374,4205,'fr','Couleurs maximales',0),(151375,4205,'jp','æœ€å¤§è‰²æ•°',0),(151376,4205,'pt','MÃ¡ximos cores',0),(151377,4205,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÑ€Ð°ÑÐ¾Ðº',0),(151378,4205,'es','Colores MÃ¡ximos',0),(151379,4205,'de','Maximale Farben',0),(151380,4205,'en','Maximum Colors',0),(151381,4206,'is','',0),(151382,4206,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ùˆ Ù…ÙŠÙ†ÙŠÙ…Ù… Ù…Ù‚Ø¯Ø§Ø± Ù…Ø±Ø¬Ø¹ Ø¨Ø±Ø§ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ú†Ø§Ù¾ÙŠ ',0),(151383,4206,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ùˆ Ù…ÙŠÙ†ÙŠÙ…Ù… Ù…Ù‚Ø¯Ø§Ø± Ù…Ø±Ø¬Ø¹ Ø¨Ø±Ø§ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ú†Ø§Ù¾ÙŠ ',0),(151384,4206,'tr','Max ve Min deÄŸerleri yazdÄ±rma iÅŸlemleri iÃ§in',0),(151385,4206,'pl','Max i Min wartoÅ›ci dla operacji drukowania',0),(151386,4206,'bg','ÐœÐ°ÐºÑ Ð¸ Ð¼Ð¸Ð½ ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(151387,4206,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø§ÙˆØ± Ú©Ù… Ø§Ø² Ú©Ù… Ø§Ù‚Ø¯Ø§Ø± Ø·Ø¨Ø§Ø¹Øª Ú©ÛŒ Ú©Ø§Ø±ÙˆØ§Ø¦ÛŒÙˆÚº Ú©Û’ Ù„Ø¦Û’',0),(151388,4206,'sr','ÐœÐ°x Ð¸ ÐœÐ¸Ð½ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ðµ',0),(151389,4206,'vi','GiÃ¡ trá»‹ tá»‘i Ä‘a & tá»‘i thiá»ƒu cho hoáº¡t Ä‘á»™ng IN',0),(151390,4206,'af','Max en Min waardes vir DRUKWERK bedrywighede',0),(151391,4206,'ro','Max ÅŸi Min valorile pentru operaÅ£iunile de imprimare',0),(151392,4206,'et','Max ja Min vÃ¤Ã¤rtused PRINTIMISE toiminguid',0),(151393,4206,'si','Max in Min vrednosti za tiskanje operacije',0),(151394,4206,'ba','Max dan nilai-nilai Min untuk pencetakan operasi',0),(151395,4206,'nl','Max en Min waarden voor afdrukken operaties',0),(151396,4206,'fi','Max ja Min arvojen tulostaminen toimintojen',0),(151397,4206,'no','Max og laveste verdiene for utskrift operasjoner',0),(151398,4206,'da','Max og min. vÃ¦rdier for udskrivning operationer',0),(151399,4206,'ko','Maxì™€ Min ê°’ ì¸ì‡„ ìž‘ì—…ì— ëŒ€ í•œ',0),(151400,4206,'he','×ž×§×¡ ×•×¢×¨×›×™ ×ž×™× ×™×ž×•× ×œ×¤×¢×•×œ×•×ª ×”×“×¤×¡×”',0),(151401,4206,'el','Max ÎºÎ±Î¹ Min Ï„Î¹Î¼Î­Ï‚ Î³Î¹Î± ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Î•ÎšÎ¤ÎŽÎ Î©Î£Î—Î£',0),(151402,4206,'zh','å°åˆ·æ“ä½œçš„æœ€å¤§å€¼å’Œæœ€å°å€¼\r\n',0),(151403,4206,'sv','Max och Min vÃ¤rden fÃ¶r utskrift',0),(151404,4206,'it','Max e Min valori per le operazioni di stampa',0),(151405,4206,'tl','',0),(151406,4206,'th','&#3588;&#3656;&#3634;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3649;&#3621;&#3632;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;&#3',0),(151407,4206,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤”à¤° à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤®à¥‚à¤²à¥à¤¯à¥‹à¤‚ à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥‡ à¤¸à¤‚à¤šà¤¾à¤²à¤¨ à¤•à¥‡ à¤²à¤¿à¤',0),(151408,4206,'ms','Max dan Min nilai-nilai bagi operasi percetakan',0),(151409,4206,'ar','Ù…Ø§ÙƒØ³ ÙˆÙ‚ÙŠÙ… Ø¯Ù‚ÙŠÙ‚Ø© Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(151410,4206,'fr','Max et Min pour les services d\'imprimerie',0),(151411,4206,'jp','å?°åˆ·ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã?®æœ€å¤§æœ€å°?ä¾¡å€¤',0),(151412,4206,'pt','Max e Min os valores para operaÃ§Ãµes de impressÃ£o',0),(151413,4206,'ru','Max Ð¸ Min Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð´Ð»Ñ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(151414,4206,'es','Max y Min Valores para IMPRIMIR Operaciones',0),(151415,4206,'de','Max und Min-Werte fÃ¼r Druck-Operationen',0),(151416,4206,'en','Max and Min Values for PRINTING Operations',0),(151417,4207,'is','',0),(151418,4207,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ø±Ù†Ú¯Ù‡Ø§ ',0),(151419,4207,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ø±Ù†Ú¯Ù‡Ø§ ',0),(151420,4207,'tr','Minimum renk',0),(151421,4207,'pl','Minimalne kolory',0),(151422,4207,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(151423,4207,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø±Ù†Ú¯',0),(151424,4207,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð±Ð¾Ñ˜Ðµ',0),(151425,4207,'vi','Máº§u Tá»‘i thiá»ƒu',0),(151426,4207,'af','Minimum kleure',0),(151427,4207,'ro','Minim culori',0),(151428,4207,'et','Minimaalne vÃ¤rvid',0),(151429,4207,'si','Najmanj barve',0),(151430,4207,'ba','Minimum warna',0),(151431,4207,'nl','Minimale kleuren',0),(151432,4207,'fi','VÃ¤hintÃ¤Ã¤n vÃ¤rejÃ¤',0),(151433,4207,'no','Minimum farger',0),(151434,4207,'da','Minimum farver',0),(151435,4207,'ko','ìµœì†Œ ìƒ‰ìƒ',0),(151436,4207,'he','×¦×‘×¢×™× ×ž×™× ×™×ž×•×',0),(151437,4207,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î· Ï‡ÏÏŽÎ¼Î±Ï„Î±',0),(151438,4207,'zh','æœ€å°‘çš„è‰²å½©\r\n',0),(151439,4207,'sv','Minsta fÃ¤rger',0),(151440,4207,'it','Colori minimi',0),(151441,4207,'tl','',0),(151442,4207,'th','&#3626;&#3637;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(151443,4207,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤°à¤‚à¤—',0),(151444,4207,'ms','Warna-warna yang minimum',0),(151445,4207,'ar','Ø£Ù„ÙˆØ§Ù† Ø§Ù„Ø¯Ù†ÙŠØ§',0),(151446,4207,'fr','Couleurs minimums',0),(151447,4207,'jp','æœ€å°?è‰²æ•°',0),(151448,4207,'pt','Cores mÃ­nimas',0),(151449,4207,'ru','ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼ Ñ†Ð²ÐµÑ‚Ð¾Ð²',0),(151450,4207,'es','Colores MÃ­nimos',0),(151451,4207,'de','Minimale Farben',0),(151452,4207,'en','Minimum colors',0),(151453,4208,'is','',0),(151454,4208,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¨Ø±Ú¯Ù‡',0),(151455,4208,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¨Ø±Ú¯Ù‡',0),(151456,4208,'tr','En az yaprak boyutu',0),(151457,4208,'pl','Rozmiar minimalny arkusza',0),(151458,4208,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(151459,4208,'ur','Ú©Ù… Ø§Ø² Ú©Ù… ÙˆØ±Ù‚ Ø³Ø§Ø¦Ø²',0),(151460,4208,'sr','Ð›Ð¸ÑÑ‚ Ð·Ð° Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ñƒ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(151461,4208,'vi','Cá»¡ trang Tá»‘i thiá»ƒu',0),(151462,4208,'af','Minimum Velgrootte',0),(151463,4208,'ro','Dimensiune minimÄƒ foaie',0),(151464,4208,'et','Minimaalne lehe suurus',0),(151465,4208,'si','Velikost minimalne lista',0),(151466,4208,'ba','Ukuran minimum lembar',0),(151467,4208,'nl','Minimale papierformaat',0),(151468,4208,'fi','VÃ¤hintÃ¤Ã¤n arkkikoko',0),(151469,4208,'no','Minimum arkstÃ¸rrelse',0),(151470,4208,'da','Minimum arkstÃ¸rrelse',0),(151471,4208,'ko','ìµœì†Œ ìš©ì§€ í¬ê¸°',0),(151472,4208,'he','×’×•×“×œ ×’×™×œ×™×•×Ÿ ×ž×™× ×™×ž×œ×™',0),(151473,4208,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚',0),(151474,4208,'zh','æœ€å°çº¸å¼ å°ºå¯¸\r\n',0),(151475,4208,'sv','Minsta arkstorlek',0),(151476,4208,'it','Formato del foglio minimo',0),(151477,4208,'tl','',0),(151478,4208,'th','&#3586;&#3609;&#3634;&#3604;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(151479,4208,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤ªà¤¤à¥à¤°à¤• à¤†à¤•à¤¾à¤°',0),(151480,4208,'ms','Saiz minimum lembaran',0),(151481,4208,'ar','Ø­Ø¬Ù… ÙˆØ±Ù‚Ø© Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰',0),(151482,4208,'fr','Taille minimale de la feuille',0),(151483,4208,'jp','æœ€å°?ã‚·ãƒ¼ãƒˆã‚µã‚¤ã‚º',0),(151484,4208,'pt','Tamanho mÃ­nimo da folha',0),(151485,4208,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð»Ð¸ÑÑ‚Ð°',0),(151486,4208,'es','TamaÃ±o de Hoja MÃ­nimo',0),(151487,4208,'de','Minimale Bogenformat',0),(151488,4208,'en','Minimum Sheet Size',0),(151489,4209,'is','',0),(151490,4209,'dr',': ÙÙ‚Ø· Ø§Ø² Ø§ÙŠÙ† Ø³Ø·Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ø¹Ù…Ù„ÙŠØ§Øª Ú†Ø§Ù¾ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(151491,4209,'pr','ØªÙˆØ¬Ù‡ : ÙÙ‚Ø· Ø§Ø² Ø§ÙŠÙ† Ø³Ø·Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ø¹Ù…Ù„ÙŠØ§Øª Ú†Ø§Ù¾ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(151492,4209,'tr','Not: YazdÄ±rma iÅŸlemleri aksi takdirde sadece bu Ã§izgi kullanÄ±n.',0),(151493,4209,'pl','Uwaga: NaleÅ¼y uÅ¼ywaÄ‡ tylko tej linii, jeÅ›li nie operacji drukowania',0),(151494,4209,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ°: Ð”Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ ÑÐ°Ð¼Ð¾ Ñ‚Ð¾Ð·Ð¸ Ñ€ÐµÐ´, Ð°ÐºÐ¾ Ð½Ðµ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(151495,4209,'ur','Ù†ÙˆÙ¹: Ù…ÛŒÚº Ø§Ø³ Ù„Ø§Ø¦Ù† Ø³Û’ ØµØ±Ù Ø§ÛŒÚ© Ù¾Ø±Ù†Ù¹Ù†Ú¯ Ø¢Ù¾Ø±ÛŒØ´Ù† Ù†ÛÛŒÚº ØªÙˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Û”',0),(151496,4209,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° : ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Ð¾Ð²Ð°Ñ˜ Ñ€ÐµÐ´, Ð°ÐºÐ¾ Ð½Ðµ Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ðµ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(151497,4209,'vi','Ghi ChÃº: Chá»‰ dÃ¹ng dÃ²ng nÃ y náº¿u khÃ´ng pháº£i lÃ  1 hÃ nh Ä‘á»™ng IN',0),(151498,4209,'af','Nota: Gebruik slegs hierdie lyn as nie \'n DRUKWERK bedrywighede',0),(151499,4209,'ro','NotÄƒ: UtilizaÅ£i numai aceastÄƒ linie, dacÄƒ nu o operaÅ£iile de tipÄƒrire',0),(151500,4209,'et','MÃ¤rkus: Kasutage ainult selle rea, kui mitte PRINTIMISE toiminguid',0),(151501,4209,'si','Opomba: Uporabljajte samo to vrstico, Äe ni tiskanje operacije',0),(151502,4209,'ba','Catatan: Gunakan hanya baris ini jika tidak operasi Percetakan',0),(151503,4209,'nl','Opmerking: Gebruik alleen deze lijn als niet een afdrukken operaties',0),(151504,4209,'fi','Huomautus: KÃ¤ytÃ¤ vain tÃ¤mÃ¤n rivin, jos ei tulostus toiminnot',0),(151505,4209,'no','Merk: Bruk bare denne linjen hvis ikke en utskrift virksomhet',0),(151506,4209,'da','BemÃ¦rk: Brug kun denne linje, hvis ikke en udskrivning operationer',0),(151507,4209,'ko','ì°¸ê³ :ì´ ì¤„ë§Œ í•˜ì§€ ì•Šì„ ê²½ìš° ì¸ì‡„ ìž‘ì—…ì„ ì‚¬ìš©',0),(151508,4209,'he','×”×¢×¨×”: ×”×©×ª×ž×© ×¨×§ ××ª ×”×§×• ×”×–×” ×× ×œ× ×¢×œ ×¤×¢×•×œ×•×ª ×”×“×¤×¡×”',0),(151509,4209,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·: Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Î¼ÏŒÎ½Î¿ Î±Ï…Ï„Î® Ï„Î· Î³ÏÎ±Î¼Î¼Î®, Î±Î½ ÏŒÏ‡Î¹ Î­Î½Î± ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Î•ÎšÎ¤ÎŽÎ Î©Î£Î—Î£',0),(151510,4209,'zh','æ³¨ï¼šå¦‚æžœä¸æ˜¯å°åˆ·æ“ä½œåªèƒ½ä½¿ç”¨è¿™è¡Œ\r\n',0),(151511,4209,'sv','Obs: AnvÃ¤nd endast denna rad om inte en utskrift verksamhet',0),(151512,4209,'it','Nota: Utilizzare solo questa linea, se non un\'operazioni di stampa',0),(151513,4209,'tl','',0),(151514,4209,'th','Note: Use Only this line if NOT a PRINTING Operations',0),(151515,4209,'hi','à¤¨à¥‹à¤Ÿ: à¤¯à¤¦à¤¿ à¤•à¥‹à¤ˆ à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¤¾à¤°à¥à¤¯ à¤¨à¤¹à¥€à¤‚ à¤•à¥‡à¤µà¤² à¤‡à¤¸ à¤²à¤¾à¤‡à¤¨ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(151516,4209,'ms','Nota: Menggunakan hanya garisan ini jika tidak operasi percetakan',0),(151517,4209,'ar','Ù…Ù„Ø§Ø­Ø¸Ø©: Ø§Ø³ØªØ®Ø¯Ù… Ù‡Ø°Ø§ Ø§Ù„Ø³Ø·Ø± ÙÙ‚Ø· Ø¥Ø°Ø§ Ù„Ù… ÙŠÙƒÙ† Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(151518,4209,'fr','Remarque : Utilisez uniquement cette ligne si ce n\'est une imprimerie',0),(151519,4209,'jp','ãƒ¡ãƒ¢ï¼šå?°åˆ·ã‚ªãƒšãƒ¬ãƒ¼ã‚·ãƒ§ãƒ³ã?§ã?¯ã?ªã?„å ´å?ˆã?®ã?¿ã?“ã?®ãƒ©ã‚¤ãƒ³ã‚’ä½¿ã?†',0),(151520,4209,'pt','Nota: Utilize apenas esta linha se nÃ£o uma operaÃ§Ãµes de impressÃ£o',0),(151521,4209,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ: Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÑÑ‚Ð¾Ð¹ Ð»Ð¸Ð½Ð¸Ð¸, ÐµÑÐ»Ð¸ Ð½Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(151522,4209,'es','Nota: usa Soloeste linea si NO es una OperaciÃ³n de ImpresiÃ³n',0),(151523,4209,'de','Hinweis: Verwenden Sie nur diese Zeile, wenn keine Druck-Operationen',0),(151524,4209,'en','Note: Use Only this line if NOT a PRINTING Operations',0),(151525,4210,'is','',0),(151526,4210,'dr','ÙŠÙƒ Ø¬Ù‡ØªÙŠ',0),(151527,4210,'pr','ÙŠÙƒ Ø¬Ù‡ØªÙŠ',0),(151528,4210,'tr','Tek taraflÄ±',0),(151529,4210,'pl','Jednostronny',0),(151530,4210,'bg','Ð•Ð´Ð½Ð¾ÑÑ‚Ñ€Ð°Ð½Ð½Ð¾',0),(151531,4210,'ur','Ø§ÛŒÚ© Ø·Ø±ÙÛ',0),(151532,4210,'sr','ÐˆÐµÐ´Ð°Ð½ Ñ˜Ðµ ÑÑ‚Ð°Ð¾ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ñƒ',0),(151533,4210,'vi','Má»™t Máº·t',0),(151534,4210,'af','Een geskaar',0),(151535,4210,'ro','Unul faÅ£Äƒ-verso',0),(151536,4210,'et','Ãœks kahepoolne',0),(151537,4210,'si','Enosmeren',0),(151538,4210,'ba','Salah satu sisi',0),(151539,4210,'nl','Een dubbelzijdig',0),(151540,4210,'fi','Yksipuolinen',0),(151541,4210,'no','Ensidig',0),(151542,4210,'da','En dobbeltsidet',0),(151543,4210,'ko','í•˜ë‚˜ ë©´',0),(151544,4210,'he','×¦×“ ××—×“',0),(151545,4210,'el','ÎœÎ¯Î± ÏŒÏˆÎ·Ï‚',0),(151546,4210,'zh','å•è¾¹\r\n',0),(151547,4210,'sv','En dubbelsidig',0),(151548,4210,'it','Uno parteggiato',0),(151549,4210,'tl','',0),(151550,4210,'th','&#3627;&#3609;&#3638;&#3656;&#3591;&#3627;&#3609;&#3657;&#3634;',0),(151551,4210,'hi','à¤à¤• à¤¤à¤°à¤«à¤¾',0),(151552,4210,'ms','Salah satu muka',0),(151553,4210,'ar','Ø£Ø­Ø¯ Ø§Ù„ÙˆØ¬Ù‡ÙŠÙ†',0),(151554,4210,'fr','Une face',0),(151555,4210,'jp','ä¸€é?¢ã?®',0),(151556,4210,'pt','Uma face',0),(151557,4210,'ru','ÐžÐ´Ð½Ð¾ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð½Ð¸Ð¹',0),(151558,4210,'es','De Un Solo Lado',0),(151559,4210,'de','Einseitig',0),(151560,4210,'en','One Sided',0),(151561,4211,'is','',0),(151562,4211,'dr','Ø¨Ø§Ù„Ø§ØªØ± ',0),(151563,4211,'pr','Ø¨Ø§Ù„Ø§ØªØ± ',0),(151564,4211,'tr','Ãœzerinde',0),(151565,4211,'pl','Nad',0),(151566,4211,'bg','ÐÐ°Ð´',0),(151567,4211,'ur','Ø§ÙˆÙˆØ±',0),(151568,4211,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¾',0),(151569,4211,'vi','HÆ¡n',0),(151570,4211,'af','Meer As',0),(151571,4211,'ro','Peste',0),(151572,4211,'et','Ãœle',0),(151573,4211,'si','Nad',0),(151574,4211,'ba','Atas',0),(151575,4211,'nl','Over',0),(151576,4211,'fi','Yli',0),(151577,4211,'no','Over',0),(151578,4211,'da','Over',0),(151579,4211,'ko','ì´ìƒ',0),(151580,4211,'he','×ž×¢×œ',0),(151581,4211,'el','ÎšÎ±Ï„Î¬ Ï„Î· Î´Î¹Î¬ÏÎºÎµÎ¹Î±',0),(151582,4211,'zh','è¶…è¿‡\r\n',0),(151583,4211,'sv','Ã–ver',0),(151584,4211,'it','Sopra',0),(151585,4211,'tl','',0),(151586,4211,'th','&#3648;&#3585;&#3636;&#3609;',0),(151587,4211,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(151588,4211,'ms','Ke atas',0),(151589,4211,'ar','Ø¹Ù„Ù‰ Ù…Ø¯Ù‰',0),(151590,4211,'fr','Sur',0),(151591,4211,'jp','è¶…é?Ž',0),(151592,4211,'pt','Sobre',0),(151593,4211,'ru','ÐÐ°Ð´',0),(151594,4211,'es','MÃ¡s que',0),(151595,4211,'de','Ãœber',0),(151596,4211,'en','Over',0),(151597,4212,'is','',0),(151598,4212,'dr','Ù‚ÙŠÙ…Øª Ø´ÙƒØ³ØªÙ‡ Ø´Ø¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(151599,4212,'pr','Ù‚ÙŠÙ…Øª Ø´ÙƒØ³ØªÙ‡ Ø´Ø¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(151600,4212,'tr','Bu aile iÃ§in fiyat kÄ±rÄ±yor',0),(151601,4212,'pl','Cena przerwy dla tej rodziny',0),(151602,4212,'bg','Ð¦ÐµÐ½Ð°Ñ‚Ð° ÑÐµ Ð¿Ð¾ÑÐ²Ð¸ Ð·Ð° Ñ‚Ð¾Ð²Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(151603,4212,'ur','Ù‚ÛŒÙ…Øª Ù¹ÙˆÙ¹ Ø¬Ø§ØªØ§ ÛÛ’ Ø§Ø³ Ú©Û’ Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Û’ Ù„ÛŒÛ’',0),(151604,4212,'sr','Ð¦ÐµÐ½Ð° Ñ˜Ðµ ÑÐ»Ð°Ð¼Ð° Ð·Ð° Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ñƒ',0),(151605,4212,'vi','PhÃ¢n chia giÃ¡ cho gia dÃ¬nh nÃ y',0),(151606,4212,'af','Prys vir hierdie gesin breek',0),(151607,4212,'ro','PreÅ£ul pauze pentru aceastÄƒ familie',0),(151608,4212,'et','Hind puruneb see pere',0),(151609,4212,'si','Cena odmori za to druÅ¾ino',0),(151610,4212,'ba','Harga istirahat untuk keluarga ini',0),(151611,4212,'nl','Prijs breekt voor deze familie',0),(151612,4212,'fi','Hinta rikkoo tÃ¤mÃ¤n perheen',0),(151613,4212,'no','Pris bryter for denne familien',0),(151614,4212,'da','Pris bryder for denne familie',0),(151615,4212,'ko','ì´ ê°€ì¡±ì— ëŒ€ í•œ ê°€ê²© ë‚˜ëˆ„ê¸°',0),(151616,4212,'he','×ž×—×™×¨ ×©×•×‘×¨ ×¢×‘×•×¨ ×”×ž×©×¤×—×” ×”×–×•',0),(151617,4212,'el','Î¤Î¹Î¼Î® Î´Î¹Î±Î»ÎµÎ¯Î¼Î¼Î±Ï„Î± Î³Î¹Î± Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±',0),(151618,4212,'zh','ä»·æ ¼ç³»åˆ—çªç ´\r\n',0),(151619,4212,'sv','Pris bryter fÃ¶r denna familj',0),(151620,4212,'it','Prezzo rompe per questa famiglia',0),(151621,4212,'tl','',0),(151622,4212,'th','&#3627;&#3618;&#3640;&#3604;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3633;&#3623;&#3609;&#3637;&#3657;',0),(151623,4212,'hi','à¤•à¥€à¤®à¤¤ à¤Ÿà¥‚à¤Ÿà¤¤à¤¾ à¤¹à¥ˆ à¤‡à¤¸ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤',0),(151624,4212,'ms','Harga pecah bagi keluarga ini',0),(151625,4212,'ar','ÙÙˆØ§ØµÙ„ Ø§Ù„Ø³Ø¹Ø± Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø£Ø³Ø±Ø©',0),(151626,4212,'fr','Prix casse pour cette famille',0),(151627,4212,'jp','ã?“ã?®ç³»çµ±ã?®å€¤å´©ã‚Œ',0),(151628,4212,'pt','Quebras de preÃ§o para essa famÃ­lia',0),(151629,4212,'ru','Ð¦ÐµÐ½Ð° Ð¿ÐµÑ€ÐµÑ€Ñ‹Ð²Ñ‹ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÑÐµÐ¼ÑŒÐ¸',0),(151630,4212,'es','Descuentos de Precios para esta Familia',0),(151631,4212,'de','Preis fÃ¼r diese Familie bricht',0),(151632,4212,'en','Price Breaks for this Family',0),(151633,4213,'is','',0),(151634,4213,'dr','Ù…Ù‚Ø¯Ø§Ø± ,  Ù‚ÙŠÙ…Øª Ø§Ø³Øª',0),(151635,4213,'pr','Ù…Ù‚Ø¯Ø§Ø± ,  Ù‚ÙŠÙ…Øª Ø§Ø³Øª',0),(151636,4213,'tr','Miktar, fiyattÄ±r',0),(151637,4213,'pl','IloÅ›Ä‡, Cena jest',0),(151638,4213,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, Ñ†ÐµÐ½Ð°Ñ‚Ð° Ðµ',0),(151639,4213,'ur','ØªØ¹Ø¯Ø§Ø¯ØŒ Ù‚ÛŒÙ…Øª ÛÛ’ Û”',0),(151640,4213,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° , Ñ†ÐµÐ½Ð° Ñ˜Ðµ',0),(151641,4213,'vi','Sá»‘ lÆ°á»£ng, giÃ¡ lÃ ',0),(151642,4213,'af','Hoeveelheid, Prys is',0),(151643,4213,'ro','Cantitatea, preÅ£ul este',0),(151644,4213,'et','Kogus, hind on',0),(151645,4213,'si','KoliÄina, cena je',0),(151646,4213,'ba','Kuantitas, harganya',0),(151647,4213,'nl','Hoeveelheid, prijs Is',0),(151648,4213,'fi','MÃ¤Ã¤rÃ¤, hinta on',0),(151649,4213,'no','Antall, pris er',0),(151650,4213,'da','MÃ¦ngde, pris er',0),(151651,4213,'ko','ìˆ˜ëŸ‰, ê°€ê²© ì´ë‹¤',0),(151652,4213,'he','×”×›×ž×•×ª, ×”×ž×—×™×¨ ×”×•×',0),(151653,4213,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î±, Î· Ï„Î¹Î¼Î® ÎµÎ¯Î½Î±Î¹',0),(151654,4213,'zh','æ•°é‡ï¼Œä»·æ ¼ä¸º\r\n',0),(151655,4213,'sv','Kvantitet, pris Ã¤r',0),(151656,4213,'it','QuantitÃ , prezzo Ã¨',0),(151657,4213,'tl','',0),(151658,4213,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;, &#3619;&#3634;&#3588;&#3634;&#3588;&#3639;&#3629;',0),(151659,4213,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾, à¤®à¥‚à¤²à¥à¤¯ à¤¹à¥ˆ',0),(151660,4213,'ms','Kuantiti, harga adalah',0),(151661,4213,'ar','Ø§Ù„ÙƒÙ…ÙŠØ©ØŒ Ø§Ù„Ø³Ø¹Ø±',0),(151662,4213,'fr','QuantitÃ©, le prix est',0),(151663,4213,'jp','æ•°é‡?ã€?å€¤æ®µã?¯',0),(151664,4213,'pt','Quantidade, o preÃ§o Ã©',0),(151665,4213,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, Ð¦ÐµÐ½Ð° ÑÐ²Ð»ÑÐµÑ‚ÑÑ',0),(151666,4213,'es','Cant., Precio Es',0),(151667,4213,'de','Menge, ist Preis',0),(151668,4213,'en','Quantity, Price Is',0),(151669,4214,'is','',0),(151670,4214,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡',0),(151671,4214,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡',0),(151672,4214,'tr','Aile seÃ§in',0),(151673,4214,'pl','Wybierz rodzinÄ™',0),(151674,4214,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(151675,4214,'ur','Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(151676,4214,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ñƒ',0),(151677,4214,'vi','Chá»n Gia ÄÃ¬nh ',0),(151678,4214,'af','Kies gesin',0),(151679,4214,'ro','SelectaÅ£i familie',0),(151680,4214,'et','Valige pere',0),(151681,4214,'si','Izberite druÅ¾ine',0),(151682,4214,'ba','Pilih keluarga',0),(151683,4214,'nl','Selecteer familie',0),(151684,4214,'fi','Valitse perhe',0),(151685,4214,'no','Velg familie',0),(151686,4214,'da','VÃ¦lg familie',0),(151687,4214,'ko','ì œí’ˆêµ° ì„ íƒ',0),(151688,4214,'he','×‘×—×¨ ×ž×©×¤×—×”',0),(151689,4214,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±',0),(151690,4214,'zh','é€‰æ‹©ç³»åˆ—\r\n',0),(151691,4214,'sv','VÃ¤lj familj',0),(151692,4214,'it','Selezionare la famiglia',0),(151693,4214,'tl','',0),(151694,4214,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3633;&#3623;',0),(151695,4214,'hi','à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(151696,4214,'ms','Pilih keluarga',0),(151697,4214,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø£Ø³Ø±Ø©',0),(151698,4214,'fr','SÃ©lectionnez la famille',0),(151699,4214,'jp','ç³»çµ±ã?®é?¸æŠž',0),(151700,4214,'pt','Selecione a famÃ­lia',0),(151701,4214,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(151702,4214,'es','Seleccionar Familia',0),(151703,4214,'de','WÃ¤hlen Sie Familie',0),(151704,4214,'en','Select Family',0),(151705,4215,'is','',0),(151706,4215,'dr','(Ø§Ú¯Ø± Ù‚Ø§Ø¨Ù„ Ø§Ø¬Ø±Ø§Ø¡ Ø§Ø³Øª',0),(151707,4215,'pr','Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ø¯Ø± Ù‡Ø± ÙˆØ±Ù‚ ØªÙˆÙ„ÙŠØ¯ (Ø§Ú¯Ø± Ù‚Ø§Ø¨Ù„ Ø§Ø¬Ø±Ø§Ø¡ Ø§Ø³Øª',0),(151708,4215,'tr','SatÄ±ÅŸ FiyatÄ± levha Ã¼retim bazÄ±nda (varsa)',0),(151709,4215,'pl','SprzedaÅ¼ cena za arkusz produkcji (jeÅ›li dotyczy)',0),(151710,4215,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð½Ð° Ñ†ÐµÐ½Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° Ð»Ð¸ÑÑ‚ (Ð°ÐºÐ¾ Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸Ð¼Ð¾)',0),(151711,4215,'ur','ÙˆØ±Ù‚ Ú©ÛŒ Ù¾ÛŒØ¯Ø§ÙˆØ§Ø± ÙÛŒ Ù‚ÛŒÙ…Øª (Ø§Ú¯Ø± Ù„Ø§Ú¯Ùˆ ÛÙˆ) ÙØ±ÙˆØ®Øª',0),(151712,4215,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ñƒ Ñ†ÐµÐ½Ñƒ Ð¿Ð¾ Ð»Ð¸ÑÑ‚ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑšÐµ (Ð°ÐºÐ¾ Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð°)',0),(151713,4215,'vi','GiÃ¡ bÃ¡n má»—i trang sáº£n pháº©m (náº¿u cÃ³)',0),(151714,4215,'af','Verkoopsprys per Produksie Vel (indien toepaslik) ',0),(151715,4215,'ro','Pret pe foaie de producÅ£ie de vÃ¢nzare (dupÄƒ caz)',0),(151716,4215,'et','MÃ¼Ã¼gihinna kohta spoonilehtede tootmiseks (vajadusel)',0),(151717,4215,'si','Prodajna cena na list proizvodnje (po potrebi)',0),(151718,4215,'ba','Menjual harga per lembar produksi (jika berlaku)',0),(151719,4215,'nl','Verkoopprijs per blad productie (indien van toepassing)',0),(151720,4215,'fi','Myyntihinta per arkki tuotanto (tarvittaessa)',0),(151721,4215,'no','Salgspris per ark produksjon (hvis aktuelt)',0),(151722,4215,'da','Salgspris pr. ark produktion (hvis relevant)',0),(151723,4215,'ko','íŒë§¤ ì‹œíŠ¸ ìƒì‚° ë‹¹ ê°€ê²© (ê°€ëŠ¥í•œ ê²½ìš°)',0),(151724,4215,'he','×ž×—×™×¨ ×œ×›×œ ×’×™×œ×™×•×Ÿ ×™×™×¦×•×¨ ×”×ž×›×™×¨×” (×× ×¨×œ×•×•× ×˜×™)',0),(151725,4215,'el','Î ÏŽÎ»Î·ÏƒÎ· Ï„Î¹Î¼Î® Î±Î½Î¬ Ï†ÏÎ»Î»Î¿ Ï€Î±ÏÎ±Î³Ï‰Î³Î®Ï‚ (ÎºÎ±Ï„Î¬ Ï€ÎµÏÎ¯Ï€Ï„Ï‰ÏƒÎ·)',0),(151726,4215,'zh','æ¯å•ç”Ÿäº§é”€å”®ä»·æ ¼ï¼ˆå¦‚é€‚ç”¨ï¼‰\r\n',0),(151727,4215,'sv','FÃ¶rsÃ¤ljningspris per ark produktion (om tillÃ¤mpligt)',0),(151728,4215,'it','Prezzo per la produzione del foglio di vendita (se applicabile)',0),(151729,4215,'tl','',0),(151730,4215,'th','&#3619;&#3634;&#3588;&#3634;&#3586;&#3634;&#3618;&#3605;&#3656;&#3629;&#3612;&#3621;&#3636;&#3605;&#3612;&#3621;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;(if applicable)',0),(151731,4215,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤®à¥‚à¤²à¥à¤¯ à¤¶à¥€à¤Ÿ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¨ à¤ªà¥à¤°à¤¤à¤¿ (à¤¯à¤¦à¤¿ à¤²à¤¾à¤—à¥‚ à¤¹à¥‹)',0),(151732,4215,'ms','Menjual harga pengeluaran kira-kira (jika berkenaan)',0),(151733,4215,'ar','Ø¨ÙŠØ¹ Ø³Ø¹Ø± \"Ø§Ù„Ø¥Ù†ØªØ§Ø¬ ÙˆØ±Ù‚Ø©\" (Ø¥Ø°Ø§ ÙƒØ§Ù† Ù‚Ø§Ø¨Ù„Ø§Ù‹ Ù„Ù„ØªØ·Ø¨ÙŠÙ‚)',0),(151734,4215,'fr','Prix Production de tÃ´les de vente (si applicable)',0),(151735,4215,'jp','Selling Price per Sheet Production (if applicable)',0),(151736,4215,'pt','PreÃ§o por folha de produÃ§Ã£o de venda (se aplicÃ¡vel)',0),(151737,4215,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð½Ð°Ñ Ñ†ÐµÐ½Ð° Ð·Ð° Ð»Ð¸ÑÑ‚ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð° (ÐµÑÐ»Ð¸ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ð¼Ð¾)',0),(151738,4215,'es','Precio de Venta por ProducciÃ³n de Hojas (si aplicable) ',0),(151739,4215,'de','Verkaufspreis pro Plattenherstellung (falls zutreffend)',0),(151740,4215,'en','Selling Price per Sheet Production (if applicable)',0),(151741,4216,'is','',0),(151742,4216,'dr','Ø¯Ùˆ Ø·Ø±ÙÙ‡',0),(151743,4216,'pr','Ø¯Ùˆ Ø·Ø±ÙÙ‡',0),(151744,4216,'tr','Ä°ki taraflÄ±',0),(151745,4216,'pl','2-stronne',0),(151746,4216,'bg','Ð”Ð²ÑƒÑÑ‚Ñ€Ð°Ð½Ð½Ð¾',0),(151747,4216,'ur','Ø¯Ùˆ Ø·Ø±ÙÛ',0),(151748,4216,'sr','Ð”Ð²Ð¾ÑÑ‚Ñ€Ð°Ð½Ð¾',0),(151749,4216,'vi','Hai máº·t',0),(151750,4216,'af','Twee geskaar',0),(151751,4216,'ro','DouÄƒ feÅ£e',0),(151752,4216,'et','Kaks poolt',0),(151753,4216,'si','Dvostransko',0),(151754,4216,'ba','Dua sisi',0),(151755,4216,'nl','Dubbelzijdige',0),(151756,4216,'fi','Kaksipuolinen',0),(151757,4216,'no','Tosidig',0),(151758,4216,'da','To sidet',0),(151759,4216,'ko','ë‘ ê°€ì§€ ì–‘ë©´',0),(151760,4216,'he','×©× ×™ ×”×¦×“×“×™×',0),(151761,4216,'el','Î”ÏÎ¿ ÏŒÏˆÎµÏ‰Î½',0),(151762,4216,'zh','åŒé¢\r\n',0),(151763,4216,'sv','TvÃ¥sidig',0),(151764,4216,'it','Due lati',0),(151765,4216,'tl','',0),(151766,4216,'th','2 &#3604;&#3657;&#3634;&#3609;',0),(151767,4216,'hi','à¤¦à¥‹ à¤¤à¤°à¤«à¤¾',0),(151768,4216,'ms','Dua belah',0),(151769,4216,'ar','Ø§Ø«Ù†ÙŠÙ† Ù…Ù† Ø¬Ø§Ù†Ø¨',0),(151770,4216,'fr','2 facer',0),(151771,4216,'jp','2é?¢ã?®',0),(151772,4216,'pt','Dois lados',0),(151773,4216,'ru','Ð”Ð²ÑƒÑ…ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð½ÑÑ',0),(151774,4216,'es','Con Dos Caras',0),(151775,4216,'de','Beidseitig',0),(151776,4216,'en','Two Sided',0),(151777,4217,'is','',0),(151778,4217,'dr','Ø¯Ùˆ Ø·Ø±ÙÙ‡ Ø§Ú¯Ø± Ù‚Ø§Ø¨Ù„ Ø§Ø¬Ø±Ø§ Ø§Ø³Øª',0),(151779,4217,'pr','Ø¯Ùˆ Ø·Ø±ÙÙ‡ Ø§Ú¯Ø± Ù‚Ø§Ø¨Ù„ Ø§Ø¬Ø±Ø§ Ø§Ø³Øª',0),(151780,4217,'tr','Ã‡ift taraflÄ± (varsa)',0),(151781,4217,'pl','Dwustronnie (jeÅ›li dotyczy)',0),(151782,4217,'bg','Ð”Ð²ÑƒÑÑ‚Ñ€Ð°Ð½Ð½Ð¾ (Ð°ÐºÐ¾ Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸Ð¼Ð¾)',0),(151783,4217,'ur','Ø¯Ùˆ (Ø§Ú¯Ø± Ù„Ø§Ú¯Ùˆ ÛÙˆ) Ø·Ø±ÙÛ',0),(151784,4217,'sr','Ð”Ð²Ð¾ÑÑ‚Ñ€Ð°Ð½Ð¾ (Ð°ÐºÐ¾ Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð°)',0),(151785,4217,'vi','Hai máº·t (náº¿u Ã¡p dá»¥ng)',0),(151786,4217,'af','Twee geskaar (indien van toepassing)',0),(151787,4217,'ro','DouÄƒ laturi (dupÄƒ caz)',0),(151788,4217,'et','Kaks poolt (vajaduse korral)',0),(151789,4217,'si','Dvostransko (po potrebi)',0),(151790,4217,'ba','Dua sisi (jika berlaku)',0),(151791,4217,'nl','Dubbelzijdige (indien van toepassing)',0),(151792,4217,'fi','Kaksipuolinen (tarvittaessa)',0),(151793,4217,'no','Tosidig (hvis aktuelt)',0),(151794,4217,'da','To sidet (hvis relevant)',0),(151795,4217,'ko','ë‘ ê°€ì§€ ì–‘ë©´ (ìžˆëŠ” ê²½ìš°)',0),(151796,4217,'he','×©× ×™ ×”×¦×“×“×™× (×× ×¨×œ×•×•× ×˜×™)',0),(151797,4217,'el','Î”ÏÎ¿ ÏŒÏˆÎµÏ‰Î½ (ÎºÎ±Ï„Î¬ Ï€ÎµÏÎ¯Ï€Ï„Ï‰ÏƒÎ·)',0),(151798,4217,'zh','åŒé¢ï¼ˆå¦‚é€‚ç”¨ï¼‰\r\n',0),(151799,4217,'sv','TvÃ¥sidig (om tillÃ¤mpligt)',0),(151800,4217,'it','Due lati (se applicabile)',0),(151801,4217,'tl','',0),(151802,4217,'th','2 &#3604;&#3657;&#3634;&#3609;',0),(151803,4217,'hi','à¤¦à¥‹ à¤¤à¤°à¤«à¤¾ (à¤¯à¤¦à¤¿ à¤²à¤¾à¤—à¥‚ à¤¹à¥‹)',0),(151804,4217,'ms','Dua belah (jika berkenaan)',0),(151805,4217,'ar','Ø¹Ù„Ù‰ Ù‡Ø°ÙŠÙ† Ø§Ù„ÙˆØ¬Ù‡ÙŠÙ† (Ø¥Ø°Ø§ ÙƒØ§Ù† Ù‚Ø§Ø¨Ù„Ø§Ù‹ Ù„Ù„ØªØ·Ø¨ÙŠÙ‚)',0),(151806,4217,'fr','2 facer (si applicable)',0),(151807,4217,'jp','2é?¢ã?®ï¼ˆè©²å½“ã?™ã‚‹å ´å?ˆï¼‰',0),(151808,4217,'pt','Dois lados (se aplicÃ¡vel)',0),(151809,4217,'ru','Ð”Ð²ÑƒÑ…ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð½Ð¸Ð¹ (ÐµÑÐ»Ð¸ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ð¼Ð¾)',0),(151810,4217,'es','Con Dos Caras (si aplicable)',0),(151811,4217,'de','Beidseitig (falls zutreffend)',0),(151812,4217,'en','Two Sided (if applicable)',0),(151813,4218,'is','',0),(151814,4218,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(151815,4218,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(151816,4218,'tr','Makine aile eklemek',0),(151817,4218,'pl','Dodaj maszyny rodziny',0),(151818,4218,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(151819,4218,'ur','Ù…Ø´ÛŒÙ† Ú©Û’ Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(151820,4218,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð°',0),(151821,4218,'vi','ThÃªm DÃ²ng MÃ¡y Gia ÄÃ¬nh ',0),(151822,4218,'af','Masjien Familie Byvoeg',0),(151823,4218,'ro','Adauga familie produse',0),(151824,4218,'et','Lisa masin pere',0),(151825,4218,'si','Dodaj stroj druÅ¾ine',0),(151826,4218,'ba','Tambahkan mesin keluarga',0),(151827,4218,'nl','Machine familie toevoegen',0),(151828,4218,'fi','LisÃ¤Ã¤ kone perhe',0),(151829,4218,'no','Legge til maskin familien',0),(151830,4218,'da','TilfÃ¸je maskine familie',0),(151831,4218,'ko','ì»´í“¨í„° ê°€ì¡± ì¶”ê°€',0),(151832,4218,'he','×”×•×¡×£ ×ž×©×¤×—×ª ×ž×›×©×™×¨×™×',0),(151833,4218,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î·Ï‡Î±Î½Î® Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±',0),(151834,4218,'zh','å¢žåŠ æœºå™¨ç³»åˆ—\r\n',0),(151835,4218,'sv','LÃ¤gg till maskinfamilj',0),(151836,4218,'it','Aggiungere la famiglia di macchine',0),(151837,4218,'tl','',0),(151838,4218,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(151839,4218,'hi','à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(151840,4218,'ms','Menambah Mesin keluarga',0),(151841,4218,'ar','Ø¥Ø¶Ø§ÙØ© Ø¢Ù„Ø© Ø§Ù„Ø£Ø³Ø±Ø©',0),(151842,4218,'fr','Ajouter Type de Machine ',0),(151843,4218,'jp','æ©Ÿæ¢°ç³»çµ±ã?®è¿½åŠ ',0),(151844,4218,'pt','Adicionar famÃ­lia mÃ¡quina',0),(151845,4218,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾ Ð¼Ð°ÑˆÐ¸Ð½',0),(151846,4218,'es','Agregar Familia de MÃ¡quinas',0),(151847,4218,'de','Maschine Familie hinzufÃ¼gen',0),(151848,4218,'en','Add Machine Family',0),(151849,4219,'is','',0),(151850,4219,'dr','Ù‚Ø³Ù…Øª Ø²ÙŠØ± ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ ÙŠØ§ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ÙƒØ§Ø±ÙŠ Ø¯ÙŠØ¬ÙŠØªØ§Ù„ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø§Ø³Øª',0),(151851,4219,'pr','Ù‚Ø³Ù…Øª Ø²ÙŠØ± ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ ÙŠØ§ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ÙƒØ§Ø±ÙŠ Ø¯ÙŠØ¬ÙŠØªØ§Ù„ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø§Ø³Øª',0),(151852,4219,'tr','AÅŸaÄŸÄ±da yalnÄ±zca yazdÄ±rma veya dijital Workareas iÃ§in gerekli',0),(151853,4219,'pl','PoniÅ¼ej tylko potrzebne do drukowania lub cyfrowy odseparowanych miej',0),(151854,4219,'bg','ÐŸÐ¾-Ð´Ð¾Ð»Ñƒ ÑÐ°Ð¼Ð¾, Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¸Ð»Ð¸ Ñ†Ð¸Ñ„Ñ€Ð¾Ð² Workareas',0),(151855,4219,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ ØµØ±Ù Ù¾Ø±Ù†Ù¹ ÛŒØ§ ÚˆÛŒØ¬ÛŒÙ¹Ù„ ÙˆÙˆØ±Ú©Ø§Ø±ÛŒØ³ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø±Ú©Ø§Ø±',0),(151856,4219,'sr','Ð˜ÑÐ¿Ð¾Ð´ Ñ˜ÐµÐ´Ð¸Ð½Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¸ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð»Ð¸ Ð´Ð¸Ð³Ð¸Ñ‚Ð°Ð»Ð½Ðµ WÐ¾Ñ€ÐºÐ°Ñ€ÐµÐ°Ñ',0),(151857,4219,'vi','DÆ°á»›i Ä‘Ã¢y chá»‰ cáº§n cho In hay khu vá»±c lÃ m viá»‡c ká»¹ thuáº­t sá»‘',0),(151858,4219,'af','Hieronder net nodig vir gedrukte of digitale Workareas',0),(151859,4219,'ro','Mai jos numai necesare pentru imprimare sau DIGITAL Workareas',0),(151860,4219,'et','Allpool ainult vaja PRINTIMISEKS vÃµi digitaalne Workareas',0),(151861,4219,'si','Spodaj je samo potreben za tisk ali digitalni Workareas',0),(151862,4219,'ba','Di bawah ini hanya diperlukan untuk mencetak atau DIGITAL Workareas',0),(151863,4219,'nl','Hieronder enige die nodig zijn voor afdrukken of digitale Workareas',0),(151864,4219,'fi','Alla vain tarvitaan Tulosta tai digitaalinen Workareas',0),(151865,4219,'no','Under bare nÃ¸dvendig for utskrift eller DIGITAL Workareas',0),(151866,4219,'da','Under kun skal bruges til PRINT eller DIGITAL Workareas',0),(151867,4219,'ko','ì¸ì‡„ ë˜ëŠ” ë””ì§€í„¸ Workareasì— í•„ìš”í•œ ìœ ì¼í•œ ì•„ëž˜',0),(151868,4219,'he','×œ×”×œ×Ÿ ×¨×§ ×œ×¦×•×¨×š ×”×“×¤×¡×” ××• Workareas ×“×™×’×™×˜×œ×™',0),(151869,4219,'el','ÎšÎ¬Ï„Ï‰ Î±Ï€ÏŒ Ï„Î¿ Î¼ÏŒÎ½Î¿ Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ Î•ÎšÎ¤ÎŽÎ Î©Î£Î— Î® ÏˆÎ·Ï†Î¹Î±ÎºÎ® ÎµÏ€Î¹Ï†Î¬Î½ÎµÎ¹ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÏƒÏ„Î¿',0),(151870,4219,'zh','ä¸‹é¢åªéœ€è¦è¿›è¡Œæ‰“å°æˆ–æ•°å­—åŒ–å·¥ä½œåŒº\r\n',0),(151871,4219,'sv','Nedan endast behÃ¶vs fÃ¶r utskrift eller DIGITAL Workareas',0),(151872,4219,'it','Sotto solo necessari per la stampa o digitale Workareas',0),(151873,4219,'tl','',0),(151874,4219,'th','&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;&#3627;&#3619;&#3',0),(151875,4219,'hi','à¤•à¥‡à¤µà¤² à¤¨à¥€à¤šà¥‡ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¯à¤¾ à¤¡à¤¿à¤œà¤¿à¤Ÿà¤² Workareas à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(151876,4219,'ms','Ke bawah sahaja yang diperlukan untuk cetakan atau DIGITAL Workareas',0),(151877,4219,'ar','Ø£Ø¯Ù†Ø§Ù‡ ÙÙ‚Ø· Ø¨Ø­Ø§Ø¬Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø© Ø£Ùˆ ÙˆÙˆØ±ÙƒØ§Ø±ÙŠØ³ Ø§Ù„Ø±Ù‚Ù…ÙŠØ©',0),(151878,4219,'fr','Ci-dessous uniquement nÃ©cessaire pour le PRINT ou DIGITAL Workareas',0),(151879,4219,'jp','ä¸‹è¨˜ã?¯å?°åˆ·ã?‹ãƒ‡ã‚¸ã‚¿ãƒ«ä½œæ¥­ç¯„å›²ã?®ã?Ÿã‚?ã? ã?‘ã?«ã?®ã?¿å¿…è¦?ã?§ã?™',0),(151880,4219,'pt','Abaixo a Ãºnica necessÃ¡ria para impressÃ£o ou Workareas DIGITAL',0),(151881,4219,'ru','ÐÐ¸Ð¶Ðµ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ñ‹Ðµ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð¸Ð»Ð¸ Ñ†Ð¸Ñ„Ñ€Ð¾Ð²Ð¾Ð¹ Workareas',0),(151882,4219,'es','Abajo SOLO Necesitado para Ã¡reas de Trabajo de IMPRESIÃ“N o DIGITAL',0),(151883,4219,'de','Unten nur erforderlich fÃ¼r PRINT oder DIGITAL Workareas',0),(151884,4219,'en','Below ONLY Needed for PRINT or DIGITAL Workareas',0),(151885,4220,'is','',0),(151886,4220,'dr','Ø¨Ø²Ø±Ú¯ØªØ± ÙŠØ§ ÙƒÙ…ØªØ± Ø§Ø²',0),(151887,4220,'pr','Ø¨Ø²Ø±Ú¯ØªØ± ÙŠØ§ ÙƒÙ…ØªØ± Ø§Ø²',0),(151888,4220,'tr','Daha fazla veya daha az daha',0),(151889,4220,'pl','WiÄ™ksza lub mniejsza niÅ¼',0),(151890,4220,'bg','ÐŸÐ¾-Ð³Ð¾Ð»ÑÐ¼Ð° Ð¸Ð»Ð¸ Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¾Ñ‚',0),(151891,4220,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ÛŒØ§ Ø§Ø³ Ø³Û’ Ú©Ù… Ú©Û’ Ù…Ù‚Ø§Ø¨Ù„Û’',0),(151892,4220,'sr','Ð’ÐµÑ›Ðµ Ð¸Ð»Ð¸ Ð¼Ð°ÑšÐµ Ð¾Ð´',0),(151893,4220,'vi','Lá»›n hÆ¡n hay nhá» hÆ¡n',0),(151894,4220,'af','Groter of Minder As',0),(151895,4220,'ro','Mai mare sau mai micÄƒ decÃ¢t',0),(151896,4220,'et','Suurem vÃµi vÃ¤iksem kui',0),(151897,4220,'si','VeÄji ali manjÅ¡i od',0),(151898,4220,'ba','Lebih besar atau kurang daripada',0),(151899,4220,'nl','Groter of kleiner is dan',0),(151900,4220,'fi','Suurempi tai pienempi kuin',0),(151901,4220,'no','StÃ¸rre eller mindre enn',0),(151902,4220,'da','StÃ¸rre eller mindre end',0),(151903,4220,'ko','í°ì§€ ë˜ëŠ” ìž‘ì€ì§€ ë³´ë‹¤',0),(151904,4220,'he','×¤×—×•×ª ××• ×™×•×ª×¨ ×ž××©×¨',0),(151905,4220,'el','ÎœÎµÎ³Î±Î»ÏÏ„ÎµÏÎ¿Ï‚ Î® Î¼Î¹ÎºÏÏŒÏ„ÎµÏÎ¿Ï‚ Î±Ï€ÏŒ ÏŒ, Ï„Î¹',0),(151906,4220,'zh','å¤§äºŽæˆ–å°äºŽ\r\n',0),(151907,4220,'sv','StÃ¶rre eller mindre Ã¤n',0),(151908,4220,'it','Maggiore o minore rispetto',0),(151909,4220,'tl','',0),(151910,4220,'th','&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3627;&#3619;&#3639;&#3629;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;',0),(151911,4220,'hi','à¤…à¤§à¤¿à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¯à¤¾ à¤•à¤® à¤¸à¥‡',0),(151912,4220,'ms','Lebih atau kurang daripada',0),(151913,4220,'ar','Ø£ÙƒØ¨Ø± Ø£Ùˆ Ø£Ù‚Ù„ Ù…Ù†',0),(151914,4220,'fr','SupÃ©rieur ou infÃ©rieur Ã ',0),(151915,4220,'jp','ä»¥ä¸Šã‚‚ã?—ã??ã?¯ä»¥ä¸‹',0),(151916,4220,'pt','Maior ou menor do que',0),(151917,4220,'ru','Ð‘Ð¾Ð»ÑŒÑˆÐµ Ð¸Ð»Ð¸ Ð¼ÐµÐ½ÑŒÑˆÐµ, Ñ‡ÐµÐ¼',0),(151918,4220,'es','MÃ¡s Que o Menos Que',0),(151919,4220,'de','GrÃ¶ÃŸer oder kleiner als',0),(151920,4220,'en','Greater or Less Than',0),(151921,4221,'is','',0),(151922,4221,'dr','Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ',0),(151923,4221,'pr','Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ',0),(151924,4221,'tr','Daha bÃ¼yÃ¼k',0),(151925,4221,'pl','WiÄ™ksza niÅ¼',0),(151926,4221,'bg','ÐŸÐ¾-Ð³Ð¾Ð»ÑÐ¼Ð° Ð¾Ñ‚',0),(151927,4221,'ur','Ø¨Ø±ØªØ± Ø§Ø²',0),(151928,4221,'sr','Ð’ÐµÑ›Ðµ Ð¾Ð´',0),(151929,4221,'vi','Lá»›n hÆ¡n ',0),(151930,4221,'af','Groter As',0),(151931,4221,'ro','Mai mare decÃ¢t',0),(151932,4221,'et','Suurem kui',0),(151933,4221,'si','VeÄja od',0),(151934,4221,'ba','Lebih besar dari',0),(151935,4221,'nl','Groter dan',0),(151936,4221,'fi','Suurempi kuin',0),(151937,4221,'no','StÃ¸rre enn',0),(151938,4221,'da','StÃ¸rre end',0),(151939,4221,'ko','ë³´ë‹¤ í°',0),(151940,4221,'he','×’×“×•×œ ×ž-',0),(151941,4221,'el','ÎœÎµÎ³Î±Î»ÏÏ„ÎµÏÎ· Î±Ï€ÏŒ',0),(151942,4221,'zh','å¤§äºŽ\r\n',0),(151943,4221,'sv','StÃ¶rre Ã¤n',0),(151944,4221,'it','Maggiore di',0),(151945,4221,'tl','',0),(151946,4221,'th','&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;',0),(151947,4221,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(151948,4221,'ms','Lebih besar daripada',0),(151949,4221,'ar','Ø£ÙƒØ¨Ø± Ù…Ù†',0),(151950,4221,'fr','SupÃ©rieure Ã ',0),(151951,4221,'jp','ä»¥ä¸Š',0),(151952,4221,'pt','Maior que',0),(151953,4221,'ru','Ð‘Ð¾Ð»ÑŒÑˆÐµ, Ñ‡ÐµÐ¼',0),(151954,4221,'es','MÃ¡s Que',0),(151955,4221,'de','GrÃ¶ÃŸer als',0),(151956,4221,'en','Greater Than',0),(151957,4222,'is','',0),(151958,4222,'dr','ÙƒÙ…ØªØ± Ø§Ø² ',0),(151959,4222,'pr','ÙƒÙ…ØªØ± Ø§Ø² ',0),(151960,4222,'tr','Daha az',0),(151961,4222,'pl','Mniej niÅ¼',0),(151962,4222,'bg','ÐŸÐ¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¾Ñ‚',0),(151963,4222,'ur','Ø³Û’ Ú©Ù…',0),(151964,4222,'sr','ÐœÐ°ÑšÐµ Ð¾Ð´',0),(151965,4222,'vi','Ãt hÆ¡n',0),(151966,4222,'af','Minder As',0),(151967,4222,'ro','Mai puÅ£in',0),(151968,4222,'et','VÃ¤hem kui',0),(151969,4222,'si','Manj kot',0),(151970,4222,'ba','Kurang dari',0),(151971,4222,'nl','Minder dan',0),(151972,4222,'fi','Alle',0),(151973,4222,'no','Mindre enn',0),(151974,4222,'da','Mindre end',0),(151975,4222,'ko','ë¯¸ë§Œ',0),(151976,4222,'he','×¤×—×•×ª ×ž',0),(151977,4222,'el','Î›Î¹Î³ÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ',0),(151978,4222,'zh','å°‘äºŽ\r\n',0),(151979,4222,'sv','Mindre Ã¤n',0),(151980,4222,'it','Meno di',0),(151981,4222,'tl','',0),(151982,4222,'th','&#3627;&#3633;&#3585;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;',0),(151983,4222,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤®',0),(151984,4222,'ms','Kurang daripada',0),(151985,4222,'ar','Ø£Ù‚Ù„',0),(151986,4222,'fr','Moins de',0),(151987,4222,'jp','ä»¥ä¸‹',0),(151988,4222,'pt','Menos de',0),(151989,4222,'ru','ÐœÐµÐ½ÑŒÑˆÐµ Ð§ÐµÐ¼',0),(151990,4222,'es','Menos Que',0),(151991,4222,'de','Weniger als',0),(151992,4222,'en','Less Than',0),(151993,4223,'is','',0),(151994,4223,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ú†Ø§Ù¾ Ø¯Ø± Ø±ÙˆØ² ',0),(151995,4223,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ú†Ø§Ù¾ Ø¯Ø± Ø±ÙˆØ² ',0),(151996,4223,'tr','GÃ¼n baÅŸÄ±na GÃ¶sterim Max',0),(151997,4223,'pl','Max wyÅ›wietleÅ„ dziennie',0),(151998,4223,'bg','ÐœÐ°ÐºÑ Ð¸Ð¼Ð¿Ñ€ÐµÑÐ¸Ð¸ Ð½Ð° Ð´ÐµÐ½',0),(151999,4223,'ur','Ù…ÛŒÚ©Ø³ Ù†Ù‚ÙˆØ´ ÙÛŒ Ø¯Ù†',0),(152000,4223,'sr','ÐœÐ°x ÑƒÑ‚Ð¸ÑÐºÐµ Ð´Ð½ÐµÐ²Ð½Ð¾',0),(152001,4223,'vi','áº¤n tÆ°á»£ng tá»‘i Ä‘a má»—i ngÃ y',0),(152002,4223,'af','Max indrukke per dag',0),(152003,4223,'ro','Max afiÅŸÄƒri pe zi',0),(152004,4223,'et','Max muljeid iga pÃ¤ev',0),(152005,4223,'si','Max prikazov na dan',0),(152006,4223,'ba','Max tayangan per hari',0),(152007,4223,'nl','Max vertoningen per dag',0),(152008,4223,'fi','Max nÃ¤yttÃ¶kertoja pÃ¤ivÃ¤ssÃ¤',0),(152009,4223,'no','Max visninger per dag',0),(152010,4223,'da','Max visninger pr. dag',0),(152011,4223,'ko','í•˜ë£¨ ìµœëŒ€ ë…¸ì¶œ',0),(152012,4223,'he','×ž×§×¡ ×¨×©×ž×™× ×œ×™×•×',0),(152013,4223,'el','Max ÎµÎ¼Ï†Î±Î½Î¯ÏƒÎµÎ¹Ï‚ Î±Î½Î¬ Î·Î¼Î­ÏÎ±',0),(152014,4223,'zh','æ¯èŠ‚æœ€é«˜å±•ç¤ºæ¬¡æ•°\r\n',0),(152015,4223,'sv','Max visningar per dag',0),(152016,4223,'it','Max impressioni al giorno',0),(152017,4223,'tl','',0),(152018,4223,'th','&#3591;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3605;&#3656;&#3629;&#3623;&#3633;&#3609;',0),(152019,4223,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤¦à¤¿à¤¨ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤›à¤¾à¤ªà¥‡à¤‚',0),(152020,4223,'ms','Jejak Max sehari',0),(152021,4223,'ar','Ø§Ù†Ø·Ø¨Ø§Ø¹Ø§Øª Ù…Ø§ÙƒØ³ ÙŠÙˆÙ…ÙŠØ§',0),(152022,4223,'fr','Impressions de max par jour',0),(152023,4223,'jp','Max Impressions per Day',0),(152024,4223,'pt','Max impressÃµes por dia',0),(152025,4223,'ru','ÐœÐ°ÐºÑ Ð¿Ð¾ÐºÐ°Ð·Ð¾Ð² Ð² Ð´ÐµÐ½ÑŒ',0),(152026,4223,'es','Max Impresiones por DÃ­a',0),(152027,4223,'de','Max Impressionen pro Tag',0),(152028,4223,'en','Max Impressions per Day',0),(152029,4224,'is','',0),(152030,4224,'dr','Ø¶Ø±Ø¨ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ù…ØªØ¹Ø§Ø±Ù  Ø¨ÙˆØ³ÙŠÙ„Ù‡\r\n IPH ',0),(152031,4224,'pr','Ø¶Ø±Ø¨ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ù…ØªØ¹Ø§Ø±Ù  Ø¨ÙˆØ³ÙŠÙ„Ù‡\r\n IPH ',0),(152032,4224,'tr','Normal IPH tarafÄ±ndan Ã§arpÄ±n',0),(152033,4224,'pl','PomnoÅ¼yÄ‡ normalnÄ… IPH przez',0),(152034,4224,'bg','Ð£Ð¼Ð½Ð¾Ð¶ÐµÑ‚Ðµ Ð½Ð¾Ñ€Ð¼Ð°Ð»Ð½Ð¾ IPH Ð¾Ñ‚',0),(152035,4224,'ur','Ø¹Ø§Ù… Ø§Ù Ú©ÛŒ Ø¶Ø±Ø¨',0),(152036,4224,'sr','ÐœÐ½Ð¾Ð¶ÐµÑšÐµ Ð½Ð¾Ñ€Ð¼Ð°Ð»Ð½Ð¾ Ð˜ÐŸÐ¥ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(152037,4224,'vi','IPH thÃ´ng thÆ°á»ng Ä‘a táº§ng bá»Ÿi',0),(152038,4224,'af','Vermenigvuldig gewone IPH deur',0),(152039,4224,'ro','Multiplica IPH normale de',0),(152040,4224,'et','Korruta tavaline IPH poolt',0),(152041,4224,'si','MnoÅ¾enje obiÄajen IJV z',0),(152042,4224,'ba','Kalikan Normal IPH oleh',0),(152043,4224,'nl','Normale WIV door vermenigvuldigen',0),(152044,4224,'fi','Kerro normaali IPH mennessÃ¤',0),(152045,4224,'no','Multipliser Normal IPH av',0),(152046,4224,'da','Multiplicer normale IPH af',0),(152047,4224,'ko','ì¦ì‹ í•˜ ì—¬ ì •ìƒì ì¸ IPH',0),(152048,4224,'he','IPH ×”×›×¤×œ ×”×¨×’×™×œ ×¢×œ-×™×“×™',0),(152049,4224,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î¬ÏƒÏ„Îµ ÎºÎ±Î½Î¿Î½Î¹ÎºÎ® IPH Î±Ï€ÏŒ',0),(152050,4224,'zh','æ­£å¸¸IPHä¹˜ä»¥\r\n',0),(152051,4224,'sv','Multiplicera normala IPH av',0),(152052,4224,'it','Moltiplicare IPH normale di',0),(152053,4224,'tl','',0),(152054,4224,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3592;&#3635;&#3609;&#3623;&#3609; IPH &#3611;&#3585;&#3605;&#3636;&#3650;&#3604;&#3618;',0),(152055,4224,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ IPH à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤—à¥à¤£à¤¾',0),(152056,4224,'ms','Membiak IPH biasa oleh',0),(152057,4224,'ar','Ø§Ù„Ù…Ø¹Ù‡Ø¯ Ø§Ù„Ø¹Ø§Ø¯ÙŠØ© Ø§Ù„ØªÙŠ ØªØªÙƒØ§Ø«Ø±',0),(152058,4224,'fr','Multipliez IPH Normal par',0),(152059,4224,'jp','ï½žã?«æ¨™æº–ï¼©ï¼°ï¼¨ã‚’ã?‹ã?‘ã‚‹',0),(152060,4224,'pt','Multiplicar IPH Normal por',0),(152061,4224,'ru','Ð£Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚ÑŒ Ð½Ð¾Ñ€Ð¼Ð°Ð»ÑŒÐ½Ð¾Ð¹ IPH',0),(152062,4224,'es','Multiplicar IPH Normal por',0),(152063,4224,'de','Normale IPH durch Multiplizieren',0),(152064,4224,'en','Multiply Normal IPH by',0),(152065,4225,'is','',0),(152066,4225,'dr','Ø¶Ø±Ø¨ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ù…ØªØ¹Ø§Ø±Ù  Ø¨ÙˆØ³ÙŠÙ„Ù‡',0),(152067,4225,'pr','Ø¶Ø±Ø¨ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ù…ØªØ¹Ø§Ø±Ù  Ø¨ÙˆØ³ÙŠÙ„Ù‡',0),(152068,4225,'tr','Normal fiyatÄ± ile Ã§arpÄ±n',0),(152069,4225,'pl','PomnoÅ¼yÄ‡ normalnÄ… cenÄ™ przez',0),(152070,4225,'bg','Ð£Ð¼Ð½Ð¾Ð¶ÐµÑ‚Ðµ Ð½Ð¾Ñ€Ð¼Ð°Ð»Ð½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð° Ð¾Ñ‚',0),(152071,4225,'ur','Ø¹Ø§Ù… Ù‚ÛŒÙ…Øª Ø³Û’ Ø¶Ø±Ø¨',0),(152072,4225,'sr','ÐœÐ½Ð¾Ð¶ÐµÑšÐµ Ð½Ð¾Ñ€Ð¼Ð°Ð»Ð½Ð° Ñ†ÐµÐ½Ð° Ð¿Ð¾',0),(152073,4225,'vi','GiÃ¡ thÃ´ng thÆ°á»ng Ä‘a táº§ng bá»Ÿi',0),(152074,4225,'af','Vermenigvuldig Normale Pryse deur',0),(152075,4225,'ro','Multiplica preÅ£ul Normal de',0),(152076,4225,'et','Korruta Tavahind poolt',0),(152077,4225,'si','MnoÅ¾enje obiÄajen cena, ki jo',0),(152078,4225,'ba','Mengalikan Harga Normal oleh',0),(152079,4225,'nl','Normale prijs bij vermenigvuldigen',0),(152080,4225,'fi','Kertaa normaali hinta',0),(152081,4225,'no','Multipliser Normal pris av',0),(152082,4225,'da','Multiplicer Normal pris af',0),(152083,4225,'ko','í•˜ ì—¬ ì •ìƒ ê°€ê²©ì„ ê³±í•˜ë©´',0),(152084,4225,'he','×ž×—×™×¨ ×¨×’×™×œ ×”×›×¤×œ ×ž××ª',0),(152085,4225,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î¬ÏƒÏ„Îµ ÎºÎ±Î½Î¿Î½Î¹ÎºÎ® Ï„Î¹Î¼Î® Î±Ï€ÏŒ',0),(152086,4225,'zh','æ­£å¸¸ä»·æ ¼ä¹˜ä»¥\r\n',0),(152087,4225,'sv','Multiplicera normala priset av',0),(152088,4225,'it','Moltiplicare il prezzo normale di',0),(152089,4225,'tl','',0),(152090,4225,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3592;&#3635;&#3609;&#3623;&#3609;&#3619;&#3634;&#3588;&#3634;&#3611;&#3585;&#3605;&#3636;&#3650;&#3604;&#3618;',0),(152091,4225,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤•à¥€à¤®à¤¤ à¤¸à¥‡ à¤—à¥à¤£à¤¾ à¤•à¤°à¥‡à¤‚',0),(152092,4225,'ms','Membiak harga biasa oleh',0),(152093,4225,'ar','Ø¶Ø±Ø¨ Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø¹Ø§Ø¯ÙŠ Ù‚Ø¨Ù„',0),(152094,4225,'fr','Multipliez le Prix Normal de',0),(152095,4225,'jp','ï½žã?«æ¨™æº–ä¾¡æ ¼ã‚’ã?‹ã?‘ã‚‹',0),(152096,4225,'pt','Multiplique o preÃ§o Normal por',0),(152097,4225,'ru','Ð£Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚ÑŒ Ð½Ð¾Ñ€Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ñ†ÐµÐ½Ð°',0),(152098,4225,'es','Multiplicar Precio Normal por',0),(152099,4225,'de','Normalpreis von multiplizieren',0),(152100,4225,'en','Multiply Normal Price by',0),(152101,4226,'is','',0),(152102,4226,'dr','ÙƒØ§Ù„Ø§Ø¯Ø± Ø³Ø§Ø¹Øª Ø¬Ø¯ÙŠØ¯ \r\n IPH',0),(152103,4226,'pr','ÙƒØ§Ù„Ø§Ø¯Ø± Ø³Ø§Ø¹Øª Ø¬Ø¯ÙŠØ¯ \r\n IPH',0),(152104,4226,'tr','Yeni IPH',0),(152105,4226,'pl','Nowe IPH',0),(152106,4226,'bg','ÐÐ¾Ð²Ð¸ IPH',0),(152107,4226,'ur','Ù†Ø¦Û’ Ø§Ù',0),(152108,4226,'sr','ÐÐ¾Ð²Ð¸ Ð˜ÐŸÐ¥',0),(152109,4226,'vi','IPH má»›i',0),(152110,4226,'af','Nuwe IPH',0),(152111,4226,'ro','Noi IPH',0),(152112,4226,'et','Uus IPH',0),(152113,4226,'si','Novega IPH',0),(152114,4226,'ba','Baru IPH',0),(152115,4226,'nl','Nieuwe WIV',0),(152116,4226,'fi','Uusi IPH',0),(152117,4226,'no','Nye IPH',0),(152118,4226,'da','Nye IPH',0),(152119,4226,'ko','ìƒˆ IPH',0),(152120,4226,'he','IPH ×—×“×©',0),(152121,4226,'el','ÎÎ­Î± IPH',0),(152122,4226,'zh','æ–°çš„å°åˆ·æ¯å°æ—¶\r\n',0),(152123,4226,'sv','Nya IPH',0),(152124,4226,'it','Nuovo IPH',0),(152125,4226,'tl','',0),(152126,4226,'th','IPH &#3651;&#3627;&#3617;&#3656;',0),(152127,4226,'hi','à¤¨à¤¯à¤¾ IPH',0),(152128,4226,'ms','Baru IPH',0),(152129,4226,'ar','Ø§Ù„Ù…Ø¹Ù‡Ø¯ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(152130,4226,'fr','Nouveau IPH',0),(152131,4226,'jp','æ–°è¦?ï¼©ï¼°ï¼¨',0),(152132,4226,'pt','Novo IPH',0),(152133,4226,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð¡Ð›Ð£Ð§Ð',0),(152134,4226,'es','Nuevo IPH',0),(152135,4226,'de','Neue IPH',0),(152136,4226,'en','New IPH',0),(152137,4227,'is','',0),(152138,4227,'dr','Ø´ÙƒØ³ØªÙ† Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ ',0),(152139,4227,'pr','Ø´ÙƒØ³ØªÙ† Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ ',0),(152140,4227,'tr','Yeni fiyat kÄ±rmak',0),(152141,4227,'pl','Nowe rozbicie ceny',0),(152142,4227,'bg','ÐÐ¾Ð²Ð° Ñ†ÐµÐ½Ð° Ð¿Ð¾Ñ‡Ð¸Ð²ÐºÐ°',0),(152143,4227,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª ØªÙˆÚ‘',0),(152144,4227,'sr','ÐÐ¾Ð²Ð° Ñ†ÐµÐ½Ð° Ð¿Ð°ÑƒÐ·Ðµ',0),(152145,4227,'vi','PhÃ¢n chia giÃ¡ má»›i',0),(152146,4227,'af','Nuwe prys breek',0),(152147,4227,'ro','Nou Pret pauzÄƒ',0),(152148,4227,'et','Uus hinnavahe',0),(152149,4227,'si','Nova cena odmor',0),(152150,4227,'ba','Baru harga istirahat',0),(152151,4227,'nl','Nieuwe prijsonderbreking',0),(152152,4227,'fi','Uusi hintaero',0),(152153,4227,'no','Nye prisen pause',0),(152154,4227,'da','Ny pris pause',0),(152155,4227,'ko','ìƒˆë¡œìš´ ê°€ê²© íœ´ì‹',0),(152156,4227,'he','×¨×¤×™×“×•×ª ×ž×—×™×¨',0),(152157,4227,'el','ÎÎ­Î± Ï„Î¹Î¼Î® Î´Î¹Î¬Î»ÎµÎ¹Î¼Î¼Î±',0),(152158,4227,'zh','æ–°çš„ä»·æ ¼çªç ´\r\n',0),(152159,4227,'sv','Ny pris Break',0),(152160,4227,'it','Nuovo prezzo Break',0),(152161,4227,'tl','',0),(152162,4227,'th','&#3605;&#3633;&#3604;&#3651;&#3627;&#3617;&#3656;&#3619;&#3634;&#3588;&#3634;',0),(152163,4227,'hi','à¤¨à¤ à¤®à¥‚à¤²à¥à¤¯ à¤•à¥‹ à¤¤à¥‹à¤¡à¤¼',0),(152164,4227,'ms','Baru harga percutian',0),(152165,4227,'ar','ÙƒØ³Ø± Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(152166,4227,'fr','Nouveau saut de prix',0),(152167,4227,'jp','æ–°è¦?å€¤å´©ã‚Œ',0),(152168,4227,'pt','Novo intervalo de preÃ§o',0),(152169,4227,'ru','ÐÐ¾Ð²Ð°Ñ Ñ†ÐµÐ½Ð° Ð¿ÐµÑ€ÐµÑ€Ñ‹Ð²',0),(152170,4227,'es','Nuevo ReducciÃ³n de Precios',0),(152171,4227,'de','Neue Preis-Pause',0),(152172,4227,'en','New Price Break',0),(152173,4228,'is','',0),(152174,4228,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(152175,4228,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(152176,4228,'tr','Makine aile gÃ¼ncelleme',0),(152177,4228,'pl','Aktualizacja komputera rodziny',0),(152178,4228,'bg','Update Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(152179,4228,'ur','Ù…Ø´ÛŒÙ† Ú©Û’ Ø®Ø§Ù†Ø¯Ø§Ù† Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(152180,4228,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð°',0),(152181,4228,'vi','Cáº­p Nháº­t DÃ²ng mÃ¡y',0),(152182,4228,'af','Bywerking masjien familie',0),(152183,4228,'ro','Actualizare masina de familie',0),(152184,4228,'et','Update masin perele',0),(152185,4228,'si','Posodobitev stroj druÅ¾ine',0),(152186,4228,'ba','Memperbarui mesin keluarga',0),(152187,4228,'nl','Update Machine familie',0),(152188,4228,'fi','PÃ¤ivitys kone perhe',0),(152189,4228,'no','Oppdatere maskin familien',0),(152190,4228,'da','Opdatere maskine familie',0),(152191,4228,'ko','ì—…ë°ì´íŠ¸ ê¸° ê°€ì¡±',0),(152192,4228,'he','×¢×“×›×•×Ÿ ×ž×—×©×‘ ×ž×©×¤×—×ª×™',0),(152193,4228,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Î¼Î·Ï‡Î±Î½Î®',0),(152194,4228,'zh','æ›´æ–°æœºç³»åˆ—\r\n',0),(152195,4228,'sv','Uppdatera maskin familj',0),(152196,4228,'it','Aggiornare la macchina di famiglia',0),(152197,4228,'tl','',0),(152198,4228,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(152199,4228,'hi','à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(152200,4228,'ms','Kemaskini Terakhir keluarga Mesin',0),(152201,4228,'ar','ØªØ­Ø¯ÙŠØ« Ø¬Ù‡Ø§Ø² Ø§Ù„Ø£Ø³Ø±Ø©',0),(152202,4228,'fr','Mise Ã  jour Machine familiale',0),(152203,4228,'jp','æ©Ÿæ¢°ç³»çµ±ã?®æ›´æ–°',0),(152204,4228,'pt','FamÃ­lia de mÃ¡quina de atualizaÃ§Ã£o',0),(152205,4228,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ ÑÐµÐ¼ÑŒÐ¸',0),(152206,4228,'es','Actualizar Familia de MÃ¡quinas',0),(152207,4228,'de','Update Maschine Familie',0),(152208,4228,'en','Update Machine Family',0),(152209,4229,'is','',0),(152210,4229,'dr','ÙˆØ²Ù† ÙŠØ§ Ø¹Ø±Ø¶',0),(152211,4229,'pr','ÙˆØ²Ù† ÙŠØ§ Ø¹Ø±Ø¶',0),(152212,4229,'tr','AÄŸÄ±rlÄ±k veya geniÅŸliÄŸi',0),(152213,4229,'pl','Waga lub szerokoÅ›Ä‡',0),(152214,4229,'bg','Ð¢ÐµÐ³Ð»Ð¾ Ð¸Ð»Ð¸ ÑˆÐ¸Ñ€Ð¸Ð½Ð°',0),(152215,4229,'ur','ÙˆØ²Ù† ÛŒØ§ Ú†ÙˆÚ‘Ø§Ø¦ÛŒ',0),(152216,4229,'sr','Ð¢ÐµÐ¶Ð¸Ð½Ð° Ð¸Ð»Ð¸ ÑˆÐ¸Ñ€Ð¸Ð½Ð°',0),(152217,4229,'vi','Trá»ng lÆ°á»£ng hay chiá»u rá»™ng',0),(152218,4229,'af','Gewig of Wydte',0),(152219,4229,'ro','Greutate sau lÄƒÅ£ime',0),(152220,4229,'et','Kaal vÃµi laius',0),(152221,4229,'si','TeÅ¾a ali Å¡irino',0),(152222,4229,'ba','Berat atau lebar',0),(152223,4229,'nl','Gewicht of breedte',0),(152224,4229,'fi','Paino tai leveys',0),(152225,4229,'no','Vekt eller bredde',0),(152226,4229,'da','VÃ¦gt eller bredde',0),(152227,4229,'ko','ë¬´ê²Œ ë˜ëŠ” í­',0),(152228,4229,'he','×ž×©×§×œ ××• ×¨×•×—×‘',0),(152229,4229,'el','Î’Î¬ÏÎ¿Ï‚ Î® Ï€Î»Î¬Ï„Î¿Ï‚',0),(152230,4229,'zh','é‡é‡æˆ–å®½åº¦\r\n',0),(152231,4229,'sv','Vikt eller bredd',0),(152232,4229,'it','Peso o larghezza',0),(152233,4229,'tl','',0),(152234,4229,'th','&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;&#3627;&#3619;&#3639;&#3629;&#3588;&#3623;&#3634;&#3617;&#3585;&#3623;&#3657;&#3634;&#3591;',0),(152235,4229,'hi','à¤µà¤œà¤¨ à¤¯à¤¾ à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ',0),(152236,4229,'ms','Berat atau lebar',0),(152237,4229,'ar','Ø§Ù„ÙˆØ²Ù† Ø£Ùˆ Ø§Ù„Ø¹Ø±Ø¶',0),(152238,4229,'fr','Poids ou largeur',0),(152239,4229,'jp','é‡?ã?•ã?‹å¹…',0),(152240,4229,'pt','Peso ou largura',0),(152241,4229,'ru','Ð’ÐµÑ Ð¸Ð»Ð¸ ÑˆÐ¸Ñ€Ð¸Ð½Ñ‹',0),(152242,4229,'es','Peso o Anchura',0),(152243,4229,'de','Gewicht oder Breite',0),(152244,4229,'en','Weight or Width',0),(152245,4230,'is','',0),(152246,4230,'dr','(ÙˆØ²Ù† Ø§ØµÙ„ÙŠ/MWT',0),(152247,4230,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡  (ÙˆØ²Ù† Ø§ØµÙ„ÙŠ/MWT',0),(152248,4230,'tr','Zaman boyutu/MWT',0),(152249,4230,'pl','Gdy rozmiar/MWT',0),(152250,4230,'bg','ÐšÐ¾Ð³Ð°Ñ‚Ð¾ Ñ€Ð°Ð·Ð¼ÐµÑ€/MWT',0),(152251,4230,'ur','Ø¬Ø¨ Ø³Ø§Ø¦Ø²/Ø§ØªÙˆÙ¹',0),(152252,4230,'sr','ÐšÐ°Ð´Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð°/ÐœWÐ¢',0),(152253,4230,'vi','Khi kÃ­ch cá»¡/MWT',0),(152254,4230,'af','Wanneer grootte/MWT',0),(152255,4230,'ro','CÃ¢nd dimensiunea/MW Termici',0),(152256,4230,'et','*When Size/MWT',0),(152257,4230,'si','Ko velikost/MWT',0),(152258,4230,'ba','Ketika ukuran MWT',0),(152259,4230,'nl','Als grootte/MWT',0),(152260,4230,'fi','Kun koon/MWT',0),(152261,4230,'no','NÃ¥r stÃ¸rrelsen/MWT',0),(152262,4230,'da','NÃ¥r stÃ¸rrelse/MWT',0),(152263,4230,'ko','ë•Œ í¬ê¸°/MWT',0),(152264,4230,'he','×›××©×¨ ×’×•×“×œ/MWT',0),(152265,4230,'el','ÎŒÏ„Î±Î½ Ï„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚/MWT',0),(152266,4230,'zh','å½“å°ºå¯¸/çš„é‡é‡1000å¼ çº¸\r\n',0),(152267,4230,'sv','NÃ¤r storlek/MWT',0),(152268,4230,'it','Quando la dimensione/MWT',0),(152269,4230,'tl','',0),(152270,4230,'th','&#3648;&#3617;&#3639;&#3656;&#3629; &#3652;&#3595;&#3626;&#3660;/MWT',0),(152271,4230,'hi','à¤œà¤¬ à¤†à¤•à¤¾à¤°/MWT',0),(152272,4230,'ms','Apabila saiz/MWT',0),(152273,4230,'ar','Ø¹Ù†Ø¯ Ø­Ø¬Ù…/MWT',0),(152274,4230,'fr','Lorsque la taille/MWT',0),(152275,4230,'jp','ã‚µã‚¤ã‚º/ï¼­ï¼·ï¼´ã?®æ™‚',0),(152276,4230,'pt','Quando o tamanho/MWT',0),(152277,4230,'ru','ÐšÐ¾Ð³Ð´Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€/ÐœÐ’Ñ‚',0),(152278,4230,'es','Cuando TamaÃ±o/MWT',0),(152279,4230,'de','Wenn GrÃ¶ÃŸe/MWT',0),(152280,4230,'en','When Size/MWT',0),(152281,4231,'is','',0),(152282,4231,'dr','ÙÙ‚Ø· Ø¯Ø§Ø®Ù„ÙŠ ',0),(152283,4231,'pr','ÙÙ‚Ø· Ø¯Ø§Ø®Ù„ÙŠ ',0),(152284,4231,'tr','Ä°Ã§ sadece',0),(152285,4231,'pl','WewnÄ™trzne tylko',0),(152286,4231,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ ÑÐ°Ð¼Ð¾',0),(152287,4231,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ ØµØ±Ù',0),(152288,4231,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ° ÑÐ°Ð¼Ð¾',0),(152289,4231,'vi','Chá»‰ cho ná»™i bá»™',0),(152290,4231,'af','Slegs Intern',0),(152291,4231,'ro','Interne numai',0),(152292,4231,'et','Sisemine ainult',0),(152293,4231,'si','Notranji le',0),(152294,4231,'ba','Internal hanya',0),(152295,4231,'nl','Interne alleen',0),(152296,4231,'fi','SisÃ¤inen vain',0),(152297,4231,'no','Intern bare',0),(152298,4231,'da','Interne kun',0),(152299,4231,'ko','ë‚´ë¶€ë§Œ',0),(152300,4231,'he','×¤× ×™×ž×™ ×‘×œ×‘×“',0),(152301,4231,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® Î¼ÏŒÎ½Î¿',0),(152302,4231,'zh','ä»…é™å†…éƒ¨\r\n',0),(152303,4231,'sv','Inre bara',0),(152304,4231,'it','Interno solo',0),(152305,4231,'tl','',0),(152306,4231,'th','&#3616;&#3634;&#3618;&#3651;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(152307,4231,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤•à¥‡à¤µà¤²',0),(152308,4231,'ms','Dalaman sahaja',0),(152309,4231,'ar','Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ© ÙÙ‚Ø·',0),(152310,4231,'fr','Interne uniquement',0),(152311,4231,'jp','ç¤¾å†…åˆ©ç”¨é™?å®š',0),(152312,4231,'pt','Interno somente',0),(152313,4231,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ðµ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(152314,4231,'es','Internal Solamente',0),(152315,4231,'de','Interne nur',0),(152316,4231,'en','Internal Only',0),(152317,4232,'is','',0),(152318,4232,'dr','Ù†ÙˆØ¹ Ø¬ÙˆØ§Ø¨ ',0),(152319,4232,'pr','Ù†ÙˆØ¹ Ø¬ÙˆØ§Ø¨ ',0),(152320,4232,'tr','YanÄ±t tÃ¼rÃ¼',0),(152321,4232,'pl','Typ odpowiedzi',0),(152322,4232,'bg','Ð¢Ð¸Ð¿ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(152323,4232,'ur','Ø¬ÙˆØ§Ø¨ Ú©ÛŒ Ù‚Ø³Ù…',0),(152324,4232,'sr','Ð¢Ð¸Ð¿ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€Ð°',0),(152325,4232,'vi','Loáº¡i tráº£ lá»i',0),(152326,4232,'af','Tipe reaksie',0),(152327,4232,'ro','RÄƒspuns de tip',0),(152328,4232,'et','Vastuse tÃ¼Ã¼p',0),(152329,4232,'si','Vrsta odziva',0),(152330,4232,'ba','Jenis respon',0),(152331,4232,'nl','Antwoord Type',0),(152332,4232,'fi','Vastauksen tyyppi',0),(152333,4232,'no','Svartypen',0),(152334,4232,'da','Svartypen',0),(152335,4232,'ko','ì‘ë‹µ ìœ í˜•',0),(152336,4232,'he','×¡×•×’ ×ž×¢× ×”',0),(152337,4232,'el','Î‘Ï€Î¬Î½Ï„Î·ÏƒÎ· Ï„Î¿Ï… Ï„ÏÏ€Î¿Ï…',0),(152338,4232,'zh','å“åº”ç±»åž‹\r\n',0),(152339,4232,'sv','Svarstyp',0),(152340,4232,'it','Tipo di risposta',0),(152341,4232,'tl','',0),(152342,4232,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;',0),(152343,4232,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥à¤¤à¥à¤¤à¤° à¤ªà¥à¤°à¤•à¤¾à¤°',0),(152344,4232,'ms','Jenis maklumbalas',0),(152345,4232,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø§Ø³ØªØ¬Ø§Ø¨Ø©',0),(152346,4232,'fr','Type de rÃ©ponse',0),(152347,4232,'jp','è¿”ç­”ã‚¿ã‚¤ãƒ—',0),(152348,4232,'pt','Tipo de resposta',0),(152349,4232,'ru','Ð¢Ð¸Ð¿ Ð¾Ñ‚Ð²ÐµÑ‚Ð°',0),(152350,4232,'es','Tipo de Respuesta',0),(152351,4232,'de','Antworttyp',0),(152352,4232,'en','Response Type',0),(152353,4233,'is','',0),(152354,4233,'dr','Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ ',0),(152355,4233,'pr','Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ ',0),(152356,4233,'tr','SeÃ§im listesi',0),(152357,4233,'pl','Listy wyboru',0),(152358,4233,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€',0),(152359,4233,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(152360,4233,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€',0),(152361,4233,'vi','Danh sÃ¡ch lá»±a chá»n',0),(152362,4233,'af','Seleksie lys',0),(152363,4233,'ro','ListÄƒ de selectare',0),(152364,4233,'et','Valikuloend',0),(152365,4233,'si','Seznam za izbiro',0),(152366,4233,'ba','Daftar pilihan',0),(152367,4233,'nl','Keuzelijst',0),(152368,4233,'fi','Valintaluettelossa',0),(152369,4233,'no','Valglisten',0),(152370,4233,'da','Selection List',0),(152371,4233,'ko','ì„ íƒ ëª©ë¡',0),(152372,4233,'he','×¨×©×™×ž×” ×¢× ××¤×©×¨×•×™×•×ª ×‘×—×™×¨×”',0),(152373,4233,'el','Î›Î¯ÏƒÏ„Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(152374,4233,'zh','é€‰æ‹©åˆ—è¡¨\r\n',0),(152375,4233,'sv','Urvalslistan',0),(152376,4233,'it','Elenco di selezione',0),(152377,4233,'tl','',0),(152378,4233,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(152379,4233,'hi','à¤šà¤¯à¤¨ à¤¸à¥‚à¤šà¥€',0),(152380,4233,'ms','Senarai pilihan',0),(152381,4233,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±Ø§Øª',0),(152382,4233,'fr','Liste de sÃ©lection',0),(152383,4233,'jp','é?¸æŠžãƒªã‚¹ãƒˆ',0),(152384,4233,'pt','Lista de seleÃ§Ã£o',0),(152385,4233,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð’Ñ‹Ð±Ð¾Ñ€Ð°',0),(152386,4233,'es','Lista de SelecciÃ³n',0),(152387,4233,'de','Auswahlliste',0),(152388,4233,'en','Selection List',0),(152389,4234,'is','',0),(152390,4234,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(152391,4234,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(152392,4234,'tr','Yeni hesaplama ekleme',0),(152393,4234,'pl','DodaÄ‡ nowe obliczenia',0),(152394,4234,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ',0),(152395,4234,'ur','Ù†Ø¦Û’ Ø­Ø³Ø§Ø¨ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(152396,4234,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(152397,4234,'vi','ThÃªm TÃ­nh ToÃ¡n Má»›i',0),(152398,4234,'af','Nuwe Berekening Byvoeg',0),(152399,4234,'ro','Adauga calcul nou',0),(152400,4234,'et','Lisa uus kalkulatsioon',0),(152401,4234,'si','Dodaj nov izraÄun',0),(152402,4234,'ba','Menambahkan baru perhitungan',0),(152403,4234,'nl','Toevoegen van nieuwe berekening',0),(152404,4234,'fi','LisÃ¤Ã¤ uusi laskenta',0),(152405,4234,'no','Legg til ny beregning',0),(152406,4234,'da','TilfÃ¸j ny beregning',0),(152407,4234,'ko','ìƒˆ ê³„ì‚°ì„ ì¶”ê°€',0),(152408,4234,'he','×”×•×¡×£ ×—×™×©×•×‘ ×—×“×©',0),(152409,4234,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ',0),(152410,4234,'zh','å¢žåŠ æ–°çš„è®¡ç®—\r\n',0),(152411,4234,'sv','LÃ¤gg till ny berÃ¤kning',0),(152412,4234,'it','Aggiungi nuovo calcolo',0),(152413,4234,'tl','',0),(152414,4234,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(152415,4234,'hi','à¤¨à¤ à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(152416,4234,'ms','Tambah pengiraan baru',0),(152417,4234,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯',0),(152418,4234,'fr','Ajouter Nouvelle Calculation',0),(152419,4234,'jp','æ–°è¦?è¨ˆç®—ã?®è¿½åŠ ',0),(152420,4234,'pt','Adicionar novo cÃ¡lculo',0),(152421,4234,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²ÑƒÑŽ ÐšÐ°Ð»ÑŒÐºÑƒÐ»ÑÑ†Ð¸ÑŽ',0),(152422,4234,'es','Agregar Nuevo CÃ¡lculo',0),(152423,4234,'de','FÃ¼gen Sie neue Berechnung',0),(152424,4234,'en','Add New Calculation',0),(152425,4235,'is','',0),(152426,4235,'dr','Ù…Ø­Ø§Ø³Ø¨Ø§Øª',0),(152427,4235,'pr','Ù…Ø­Ø§Ø³Ø¨Ø§Øª',0),(152428,4235,'tr','Hesaplamalar',0),(152429,4235,'pl','Obliczenia',0),(152430,4235,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(152431,4235,'ur','Ø­Ø³Ø§Ø¨',0),(152432,4235,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ°',0),(152433,4235,'vi','TÃ­nh toÃ¡n',0),(152434,4235,'af','Berekeninge',0),(152435,4235,'ro','Calculele',0),(152436,4235,'et','Arvutused',0),(152437,4235,'si','IzraÄuni',0),(152438,4235,'ba','Perhitungan',0),(152439,4235,'nl','Berekeningen',0),(152440,4235,'fi','Laskelmat',0),(152441,4235,'no','Beregninger',0),(152442,4235,'da','Beregninger',0),(152443,4235,'ko','ê³„ì‚°',0),(152444,4235,'he','×—×™×©×•×‘×™×',0),(152445,4235,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Î¯',0),(152446,4235,'zh','è®¡ç®—\r\n',0),(152447,4235,'sv','BerÃ¤kningar',0),(152448,4235,'it','Calcoli',0),(152449,4235,'tl','',0),(152450,4235,'th','&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(152451,4235,'hi','à¤—à¤£à¤¨à¤¾',0),(152452,4235,'ms','Pengiraan',0),(152453,4235,'ar','Ø§Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ÙŠØ©',0),(152454,4235,'fr','Calculs',0),(152455,4235,'jp','è¨ˆç®—',0),(152456,4235,'pt','CÃ¡lculos',0),(152457,4235,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ñ‹',0),(152458,4235,'es','CÃ¡lculos',0),(152459,4235,'de','Berechnungen',0),(152460,4235,'en','Calculations',0),(152461,4236,'is','',0),(152462,4236,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø­Ø§Ø³Ø¨Ù‡ ',0),(152463,4236,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø­Ø§Ø³Ø¨Ù‡ ',0),(152464,4236,'tr','Hesaplama miktar',0),(152465,4236,'pl','Obliczenie iloÅ›ci',0),(152466,4236,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(152467,4236,'ur','Ø­Ø³Ø§Ø¨ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(152468,4236,'sr','ÐžÐ±Ñ€Ð°Ñ‡ÑƒÐ½ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(152469,4236,'vi','Sá»‘ lÆ°á»£ng tÃ­nh toÃ¡n',0),(152470,4236,'af','Berekende Hoeveelheid',0),(152471,4236,'ro','Calcul cantitatea',0),(152472,4236,'et','Arvutuse kogus',0),(152473,4236,'si','IzraÄun koliÄine',0),(152474,4236,'ba','Perhitungan jumlah',0),(152475,4236,'nl','Berekening hoeveelheid',0),(152476,4236,'fi','Laskelman mÃ¤Ã¤rÃ¤',0),(152477,4236,'no','Beregningsantallet',0),(152478,4236,'da','BeregningsmÃ¦ngde',0),(152479,4236,'ko','ê³„ì‚° ìˆ˜ëŸ‰',0),(152480,4236,'he','×—×™×©×•×‘ ×›×ž×•×ª',0),(152481,4236,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±Ï‚',0),(152482,4236,'zh','è®¡ç®—é‡\r\n',0),(152483,4236,'sv','BerÃ¤kningskvantiteten',0),(152484,4236,'it','Calcolo quantitÃ ',0),(152485,4236,'tl','',0),(152486,4236,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(152487,4236,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(152488,4236,'ms','Pengiraan kuantiti',0),(152489,4236,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(152490,4236,'fr','QuantitÃ© de calcul',0),(152491,4236,'jp','è¨ˆç®—æ•°é‡?',0),(152492,4236,'pt','Quantidade de cÃ¡lculo',0),(152493,4236,'ru','Ð Ð°ÑÑ‡ÐµÑ‚ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(152494,4236,'es','Cantidad de CÃ¡lculo',0),(152495,4236,'de','Berechnung Menge',0),(152496,4236,'en','Calculation Quantity',0),(152497,4237,'is','',0),(152498,4237,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(152499,4237,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(152500,4237,'tr','Hesaplama dÃ¼zenleme',0),(152501,4237,'pl','Edycji obliczeÅ„',0),(152502,4237,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ',0),(152503,4237,'ur','Ø­Ø³Ø§Ø¨ ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(152504,4237,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(152505,4237,'vi','Chá»‰nh Sá»­a TÃ­nh ToÃ¡n',0),(152506,4237,'af','Redigeer Berekening',0),(152507,4237,'ro','Calculul de editare',0),(152508,4237,'et','Redigeerimine arvutamisel',0),(152509,4237,'si','Urejanje izraÄun',0),(152510,4237,'ba','Mengedit perhitungan',0),(152511,4237,'nl','Bewerken van berekening',0),(152512,4237,'fi','Muokkaaminen laskennan',0),(152513,4237,'no','Redigere beregning',0),(152514,4237,'da','Redigering af beregning',0),(152515,4237,'ko','ê³„ì‚° íŽ¸ì§‘',0),(152516,4237,'he','×¢×¨×™×›×ª ×—×™×©×•×‘',0),(152517,4237,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(152518,4237,'zh','ç¼–è¾‘è®¡ç®—\r\n',0),(152519,4237,'sv','Redigera berÃ¤kning',0),(152520,4237,'it','Calcolo di editing',0),(152521,4237,'tl','',0),(152522,4237,'th','&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(152523,4237,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(152524,4237,'ms','Menyunting pengiraan',0),(152525,4237,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø­Ø³Ø§Ø¨',0),(152526,4237,'fr','Calcul d\'Ã©dition',0),(152527,4237,'jp','è¨ˆç®—ã?®ç·¨é›†',0),(152528,4237,'pt','CÃ¡lculo de ediÃ§Ã£o',0),(152529,4237,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ€Ð°ÑÑ‡ÐµÑ‚',0),(152530,4237,'es','Editando el CÃ¡lculo',0),(152531,4237,'de','Bearbeiten Berechnung',0),(152532,4237,'en','Editing Calculation',0),(152533,4238,'is','',0),(152534,4238,'dr','Ø®Ø·Ø§ â€“ Ø¯Ø³ØªÙˆØ± Ù†Ø§ Ø¯Ø±Ø³Øª ',0),(152535,4238,'pr','Ø®Ø·Ø§ â€“ Ø¯Ø³ØªÙˆØ± Ù†Ø§ Ø¯Ø±Ø³Øª ',0),(152536,4238,'tr','Hata-GeÃ§ersiz komut',0),(152537,4238,'pl','BÅ‚Ä…d, nieprawidÅ‚owe polecenie',0),(152538,4238,'bg','Ð“Ñ€ÐµÑˆÐºÐ°, ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð° ÐºÐ¾Ð¼Ð°Ð½Ð´Ð°',0),(152539,4238,'ur','Ù†Ù‚ØµØŒ Ù†Ø§Ø¬Ø§Ø¦Ø² Ø­Ú©Ù…',0),(152540,4238,'sr','Ð“Ñ€ÐµÑˆÐºÐ° , Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð° ÐºÐ¾Ð¼Ð°Ð½Ð´Ð°',0),(152541,4238,'vi','Lá»—i, Lá»‡nh vÃ´ hiá»‡u',0),(152542,4238,'af','Fout, Ongeldige Opdrag',0),(152543,4238,'ro','Eroare, comandÄƒ invalidÄƒ',0),(152544,4238,'et','TÃµrge, Sobimatu kÃ¤sk',0),(152545,4238,'si','Zmota, bolehen zapoved',0),(152546,4238,'ba','Kesalahan, Invalid Command',0),(152547,4238,'nl','Fout, ongeldige opdracht',0),(152548,4238,'fi','Virhe, virheellinen komento',0),(152549,4238,'no','Feil, ugyldig kommando',0),(152550,4238,'da','Fejl, ugyldig kommando',0),(152551,4238,'ko','ì˜¤ë¥˜, ìž˜ëª» ëœ ëª…ë ¹',0),(152552,4238,'he','×©×’×™××”, ×¤×§×•×“×” ×œ× ×—×•×§×™×ª',0),(152553,4238,'el','Î£Ï†Î¬Î»Î¼Î±, Î¼Î· Î­Î³ÎºÏ…ÏÎ· ÎµÎ½Ï„Î¿Î»Î®',0),(152554,4238,'zh','é”™è¯¯ï¼Œæ— æ•ˆçš„å‘½ä»¤',0),(152555,4238,'sv','Fel, ogiltigt kommando',0),(152556,4238,'it','Errore, comando non valido',0),(152557,4238,'tl','',0),(152558,4238,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3612;&#3636;&#3604;',0),(152559,4238,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿, à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤†à¤¦à¥‡à¤¶',0),(152560,4238,'ms','Ralat, arahan tidak sah',0),(152561,4238,'ar','Ø®Ø·Ø£ØŒ Ø§Ù„Ø£Ù…Ø± ØºÙŠØ± ØµØ§Ù„Ø­',0),(152562,4238,'fr','Erreur, commande non valide',0),(152563,4238,'jp','ã‚¨ãƒ©ãƒ¼ã€?ç„¡åŠ¹ã?ªã‚³ãƒžãƒ³ãƒ‰ã?§ã?™',0),(152564,4238,'pt','Erro, comando invÃ¡lido',0),(152565,4238,'ru','ÐžÑˆÐ¸Ð±ÐºÐ°, Ð½ÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð°Ñ ÐºÐ¾Ð¼Ð°Ð½Ð´Ð°',0),(152566,4238,'es','Error, Mandato InvÃ¡lido',0),(152567,4238,'de','Fehler: UngÃ¼ltiger Befehl',0),(152568,4238,'en','Error, Invalid Command',0),(152569,4239,'is','',0),(152570,4239,'dr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(152571,4239,'pr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(152572,4239,'tr','Aile',0),(152573,4239,'pl','Rodzina',0),(152574,4239,'bg','Ð¡ÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(152575,4239,'ur','Ø®Ø§Ù†Ø¯Ø§Ù†',0),(152576,4239,'sr','ÐŸÐ¾Ñ€Ð¾Ð´Ð¸Ñ†Ð°',0),(152577,4239,'vi','Gia ÄÃ¬nh ',0),(152578,4239,'af','Familie',0),(152579,4239,'ro','Familia',0),(152580,4239,'et','Perekond',0),(152581,4239,'si','DruÅ¾ina',0),(152582,4239,'ba','Keluarga',0),(152583,4239,'nl','Familie',0),(152584,4239,'fi','Perhe',0),(152585,4239,'no','Familie',0),(152586,4239,'da','Familie',0),(152587,4239,'ko','ê°€ì¡±',0),(152588,4239,'he','×”×ž×©×¤×—×”',0),(152589,4239,'el','ÎŸÎ¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±',0),(152590,4239,'zh','å®¶åº­\r\n',0),(152591,4239,'sv','Familjen',0),(152592,4239,'it','Famiglia',0),(152593,4239,'tl','',0),(152594,4239,'th','&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3633;&#3623;',0),(152595,4239,'hi','à¤ªà¤°à¤¿à¤µà¤¾à¤°',0),(152596,4239,'ms','Keluarga',0),(152597,4239,'ar','Ø§Ù„Ø£Ø³Ø±Ø©',0),(152598,4239,'fr','Famille',0),(152599,4239,'jp','ç³»çµ±',0),(152600,4239,'pt','FamÃ­lia',0),(152601,4239,'ru','Ð¡ÐµÐ¼ÑŒÑ',0),(152602,4239,'es','Familia',0),(152603,4239,'de','Familie',0),(152604,4239,'en','Family',0),(152605,4240,'is','',0),(152606,4240,'dr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(152607,4240,'pr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(152608,4240,'tr','Not Found Aile',0),(152609,4240,'pl','Rodziny nie znaleziono',0),(152610,4240,'bg','Ð¡ÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(152611,4240,'ur','Ø®Ø§Ù†Ø¯Ø§Ù† Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(152612,4240,'sr','ÐŸÐ¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(152613,4240,'vi','KhÃ´ng tÃ¬m tháº¥y Gia ÄÃ¬nh ',0),(152614,4240,'af','Familie Nie Gevind',0),(152615,4240,'ro','Familia nu a fost gÄƒsit',0),(152616,4240,'et','Leidmata pereliikmed',0),(152617,4240,'si','DruÅ¾ine ni mogoÄe najti',0),(152618,4240,'ba','Keluarga tidak ditemukan',0),(152619,4240,'nl','Familie niet gevonden',0),(152620,4240,'fi','Perhe ei lÃ¶ydy',0),(152621,4240,'no','Familien ikke funnet',0),(152622,4240,'da','Familien ikke fundet',0),(152623,4240,'ko','ê°€ì¡±ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(152624,4240,'he','×”×ž×©×¤×—×” ×œ× × ×ž×¦×',0),(152625,4240,'el','ÎŸÎ¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Ï€Î¿Ï… Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(152626,4240,'zh','å®¶åº­æ‰¾ä¸åˆ°\r\n',0),(152627,4240,'sv','Familjen hittades inte',0),(152628,4240,'it','Famiglia non trovato',0),(152629,4240,'tl','',0),(152630,4240,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3626;&#3585;&#3640;&#3621;',0),(152631,4240,'hi','à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(152632,4240,'ms','Keluarga yang tidak dijumpai',0),(152633,4240,'ar','Ø§Ù„ÙØµÙŠÙ„Ø© ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(152634,4240,'fr','Famille introuvable',0),(152635,4240,'jp','ç³»çµ±ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(152636,4240,'pt','FamÃ­lia nÃ£o encontrada',0),(152637,4240,'ru','Ð¡ÐµÐ¼ÑŒÑ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(152638,4240,'es','Familia No se EncontrÃ³',0),(152639,4240,'de','Familie nicht gefunden',0),(152640,4240,'en','Family Not Found',0),(152641,4241,'is','',0),(152642,4241,'dr','Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø³ÙˆØ§Ù„ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡  ',0),(152643,4241,'pr','Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø³ÙˆØ§Ù„ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡  ',0),(152644,4241,'tr','Aile soru hesaplamalarÄ±',0),(152645,4241,'pl','Rodzina pytanie obliczeÅ„',0),(152646,4241,'bg','Ð¡ÐµÐ¼ÐµÐµÐ½ Ð²ÑŠÐ¿Ñ€Ð¾Ñ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(152647,4241,'ur','Ø®Ø§Ù†Ø¯Ø§Ù† Ø³ÙˆØ§Ù„ Ø­Ø³Ø§Ø¨',0),(152648,4241,'sr','ÐŸÐ¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ð¿Ð¸Ñ‚Ð°ÑšÐµ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ°',0),(152649,4241,'vi','TÃ­nh toÃ¡n cÃ¢u há»i gia Ä‘Ã¬nh',0),(152650,4241,'af','Familie Vraag Berekeninge',0),(152651,4241,'ro','Calculele de familie Ã®ntrebare',0),(152652,4241,'et','Pere kÃ¼simus arvutused',0),(152653,4241,'si','DruÅ¾inski vpraÅ¡anje izraÄuni',0),(152654,4241,'ba','Perhitungan keluarga pertanyaan',0),(152655,4241,'nl','Familie vraag berekeningen',0),(152656,4241,'fi','Perheen kysymys laskelmat',0),(152657,4241,'no','Familien spÃ¸rsmÃ¥let beregninger',0),(152658,4241,'da','Familie spÃ¸rgsmÃ¥l beregninger',0),(152659,4241,'ko','ê°€ì¡± ì§ˆë¬¸ ê³„ì‚°',0),(152660,4241,'he','×©××œ×” ×ž×©×¤×—×” ×—×™×©×•×‘×™×',0),(152661,4241,'el','Î•ÏÏŽÏ„Î·ÏƒÎ· Ï„Î¿Ï… Î¿Î¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ¬ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(152662,4241,'zh','å®¶åº­é—®é¢˜çš„è®¡ç®—\r\n',0),(152663,4241,'sv','Familj frÃ¥ga berÃ¤kningar',0),(152664,4241,'it','Famiglia domanda calcoli',0),(152665,4241,'tl','',0),(152666,4241,'th','&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3588;&#3635;&#3606;&#3634;&#3617;&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3633;&#3623;',0),(152667,4241,'hi','à¤ªà¤¾à¤°à¤¿à¤µà¤¾à¤°à¤¿à¤• à¤ªà¥à¤°à¤¶à¥à¤¨ à¤—à¤£à¤¨à¤¾',0),(152668,4241,'ms','Keluarga soalan pengiraan',0),(152669,4241,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³Ø±Ø© Ù…Ø³Ø£Ù„Ø©',0),(152670,4241,'fr','Question famille calculs',0),(152671,4241,'jp','ç³»çµ±è³ªå•?è¨ˆç®—',0),(152672,4241,'pt','CÃ¡lculos de questÃ£o familiar',0),(152673,4241,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ñ‹ ÑÐµÐ¼ÐµÐ¹Ð½Ñ‹Ð¹ Ð²Ð¾Ð¿Ñ€Ð¾Ñ',0),(152674,4241,'es','CÃ¡lculos de Cuestiones de Familia',0),(152675,4241,'de','Familie Frage Berechnungen',0),(152676,4241,'en','Family Question Calculations',0),(152677,4242,'is','',0),(152678,4242,'dr','Ø¶Ø±Ø¨ ÙƒÙ†Ù†Ø¯Ù‡ Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(152679,4242,'pr','Ø¶Ø±Ø¨ ÙƒÙ†Ù†Ø¯Ù‡ Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(152680,4242,'tr','BiÃ§imlendirme Ã§arpanÄ±',0),(152681,4242,'pl','MnoÅ¼nik znacznikÃ³w',0),(152682,4242,'bg','ÐœÐ°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚ÐµÐ»',0),(152683,4242,'ur','Ù…Ø§Ø±Ú© Ø§Ù¾ Ú©Û’ Ø¶Ø§Ø±Ø¨',0),(152684,4242,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ Ð¼Ð½Ð¾Ð¶Ð¸Ð»Ð°Ñ†',0),(152685,4242,'vi','Cá»™ng thÃªm',0),(152686,4242,'af','Markup vermenigvuldiger',0),(152687,4242,'ro','Multiplicator de marcare',0),(152688,4242,'et','MÃ¤rgistuse kordaja',0),(152689,4242,'si','Markup multiplikator',0),(152690,4242,'ba','Markup Multiplier',0),(152691,4242,'nl','Markup Multiplier',0),(152692,4242,'fi','Markup kerroin',0),(152693,4242,'no','Markering multiplikator',0),(152694,4242,'da','Markup multiplikator',0),(152695,4242,'ko','íƒœê·¸ ìŠ¹ìˆ˜',0),(152696,4242,'he','×¡×™×ž×•×Ÿ ×ž×›×¤×™×œ',0),(152697,4242,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î®Ï‚ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(152698,4242,'zh','æ ‡è®°å¢žåŠ è€…\r\n',0),(152699,4242,'sv','Markup multiplikator',0),(152700,4242,'it','Moltiplicatore di markup',0),(152701,4242,'tl','',0),(152702,4242,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3605;&#3633;&#3623;&#3588;&#3641;&#3603;',0),(152703,4242,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤—à¥à¤£à¤•',0),(152704,4242,'ms','Pengganda penanda',0),(152705,4242,'ar','ØªØ±Ù…ÙŠØ² Ù…Ø¶Ø§Ø¹Ù',0),(152706,4242,'fr','Multiplicateur de balisage',0),(152707,4242,'jp','å€¤ä¸Šã?’å€?çŽ‡',0),(152708,4242,'pt','Multiplicador de marcaÃ§Ã£o',0),(152709,4242,'ru','Ð Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸ Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒ',0),(152710,4242,'es','Encarecimiento Multiplicador',0),(152711,4242,'de','Markup-Multiplikator',0),(152712,4242,'en','Markup Multiplier',0),(152713,4243,'is','',0),(152714,4243,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(152715,4243,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(152716,4243,'tr','Malzeme maliyeti',0),(152717,4243,'pl','Koszt materiaÅ‚Ã³w',0),(152718,4243,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸',0),(152719,4243,'ur','Ù…ÙˆØ§Ø¯ Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(152720,4243,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð°',0),(152721,4243,'vi','Chi phÃ­ nguyÃªn váº­t liá»‡u',0),(152722,4243,'af','Materiale Koste',0),(152723,4243,'ro','Costul materialelor',0),(152724,4243,'et','Materjalide kulu',0),(152725,4243,'si','StroÅ¡ki materiala',0),(152726,4243,'ba','Biaya bahan',0),(152727,4243,'nl','Kosten van materialen',0),(152728,4243,'fi','Materiaalien kustannukset',0),(152729,4243,'no','Materialer kostnader',0),(152730,4243,'da','Materialer omkostninger',0),(152731,4243,'ko','ìž¬ë£Œ ë¹„ìš©',0),(152732,4243,'he','×¢×œ×•×ª ×—×•×ž×¨×™×',0),(152733,4243,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï…Î»Î¹ÎºÏŽÎ½',0),(152734,4243,'zh','ææ–™æˆæœ¬\r\n',0),(152735,4243,'sv','Material kostnad',0),(152736,4243,'it','Costo dei materiali',0),(152737,4243,'tl','',0),(152738,4243,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(152739,4243,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤²à¤¾à¤—à¤¤',0),(152740,4243,'ms','Kos bahan-bahan',0),(152741,4243,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ù…ÙˆØ§Ø¯',0),(152742,4243,'fr','CoÃ»t des matÃ©riaux',0),(152743,4243,'jp','æ??æ–™è²»',0),(152744,4243,'pt','Custo de materiais',0),(152745,4243,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð²',0),(152746,4243,'es','Costo de Materiales',0),(152747,4243,'de','Materialien Kosten',0),(152748,4243,'en','Materials Cost',0),(152749,4244,'is','',0),(152750,4244,'dr','Ù‡ÙŠÚ† Ú†ÙŠØ² Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(152751,4244,'pr','Ù‡ÙŠÚ† Ú†ÙŠØ² Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(152752,4244,'tr','HiÃ§bir ÅŸey eklendi',0),(152753,4244,'pl','Nic dodaÄ‡',0),(152754,4244,'bg','ÐÐ¸Ñ‰Ð¾ Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ',0),(152755,4244,'ur','Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ú©Ú†Ú¾ Ø¨Ú¾ÛŒ Ù†ÛÛŒÚº',0),(152756,4244,'sr','Ð‘ÐµÐ· Ð´Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(152757,4244,'vi','KhÃ´ng cÃ³ gÃ¬ Ä‘á»ƒ thÃªm',0),(152758,4244,'af','Niks bygevoeg',0),(152759,4244,'ro','Nimic de adaugat',0),(152760,4244,'et','Midagi lisada',0),(152761,4244,'si','NiÄ ne doda',0),(152762,4244,'ba','Ada ditambahkan',0),(152763,4244,'nl','Niets toegevoegd',0),(152764,4244,'fi','Ei lisÃ¤tty',0),(152765,4244,'no','Ingenting lagt',0),(152766,4244,'da','Intet tilfÃ¸jet',0),(152767,4244,'ko','ì•„ë¬´ê²ƒë„ ì¶”ê°€',0),(152768,4244,'he','×“×‘×¨ × ×•×¡×£',0),(152769,4244,'el','Î¤Î¯Ï€Î¿Ï„Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯',0),(152770,4244,'zh','æ²¡æœ‰æ–°å¢ž\r\n',0),(152771,4244,'sv','Ingenting till',0),(152772,4244,'it','Nulla aggiunto',0),(152773,4244,'tl','',0),(152774,4244,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(152775,4244,'hi','à¤•à¥à¤› à¤­à¥€ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(152776,4244,'ms','Apa-apa yang ditambah',0),(152777,4244,'ar','Ù„Ø§ Ø´ÙŠØ¡ ÙŠØ¶Ø§Ù',0),(152778,4244,'fr','Rien a ajoutÃ©',0),(152779,4244,'jp','ä½•ã‚‚è¿½åŠ ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(152780,4244,'pt','Nada adicionado',0),(152781,4244,'ru','ÐÐ¸Ñ‡ÐµÐ³Ð¾ ÐÐµ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾',0),(152782,4244,'es','Nada Agregada',0),(152783,4244,'de','Nichts hinzugefÃ¼gt',0),(152784,4244,'en','Nothing Added',0),(152785,4245,'is','',0),(152786,4245,'dr','Ù‡ÙŠÚ† Ú†ÙŠØ² Ø¨Ù‡ Ø±ÙˆØ²  Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(152787,4245,'pr','Ù‡ÙŠÚ† Ú†ÙŠØ² Ø¨Ù‡ Ø±ÙˆØ²  Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(152788,4245,'tr','HiÃ§bir gÃ¼ncelleme',0),(152789,4245,'pl','Nic nie aktualizowane',0),(152790,4245,'bg','ÐÐ¸Ñ‰Ð¾ Updated',0),(152791,4245,'ur','Ú©Ú†Ú¾ Ø¨Ú¾ÛŒ Ù†ÛÛŒÚº ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(152792,4245,'sr','ÐÐ¸ÑˆÑ‚Ð° Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(152793,4245,'vi','KhÃ´ng cÃ³ gÃ¬ cáº­p nháº­t',0),(152794,4245,'af','Opdatering nie Plaasgevind',0),(152795,4245,'ro','Nimic actualizat',0),(152796,4245,'et','Midagi uuendatud',0),(152797,4245,'si','NiÄ posodobljena',0),(152798,4245,'ba','Tidak ada yang diperbarui',0),(152799,4245,'nl','Niets bijgewerkt',0),(152800,4245,'fi','Ei ensinkÃ¤Ã¤n ajantasaistaa',0),(152801,4245,'no','Ingenting oppdatert',0),(152802,4245,'da','Intet opdateret',0),(152803,4245,'ko','ì—…ë°ì´íŠ¸ ì•„ë¬´ê²ƒë„',0),(152804,4245,'he','×©×•× ×“×‘×¨ ×œ× ×ž×ª×¢×“×›×Ÿ',0),(152805,4245,'el','Î¤Î¯Ï€Î¿Ï„Î± Î´ÎµÎ½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ½Î¿Î½Ï„Î±Î¹',0),(152806,4245,'zh','æ²¡æœ‰æ›´æ–°\r\n',0),(152807,4245,'sv','Ingenting uppdaterad',0),(152808,4245,'it','Niente aggiornato',0),(152809,4245,'tl','',0),(152810,4245,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(152811,4245,'hi','à¤•à¥à¤› à¤­à¥€ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾',0),(152812,4245,'ms','Apa-apa yang dikemaskini',0),(152813,4245,'ar','Ù„Ø§ Ø´ÙŠØ¡ ØªØ­Ø¯ÙŠØ«',0),(152814,4245,'fr','Rien mis Ã  jour',0),(152815,4245,'jp','ä½•ã‚‚æ›´æ–°ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(152816,4245,'pt','Nada atualizado',0),(152817,4245,'ru','ÐÐ¸Ñ‡ÐµÐ³Ð¾ ÐÐµ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾',0),(152818,4245,'es','Nada Actualizada',0),(152819,4245,'de','Nichts aktualisiert',0),(152820,4245,'en','Nothing Updated',0),(152821,4246,'is','',0),(152822,4246,'dr',': Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ø´ÙŠÙ† Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙØ²ÙˆØ¯Ù† Ø¢Ù†Ù‡Ø§ Ø§ØµÙ„Ø§Ø­  ÙƒÙ†ÙŠØ¯',0),(152823,4246,'pr','Ø¨Ø¯ÙˆÙ† Ø³ÙˆØ§Ù„: Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ø´ÙŠÙ† Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙØ²ÙˆØ¯Ù† Ø¢Ù†Ù‡Ø§ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ†ÙŠØ¯',0),(152824,4246,'tr','Soru: Makine aileler onlarÄ± eklemek iÃ§in DÃ¼zenle',0),(152825,4246,'pl','Nie pytania: Edytuj maszyna rodzin je dodaÄ‡',0),(152826,4246,'bg','ÐÑÐ¼Ð° Ð²ÑŠÐ¿Ñ€Ð¾ÑÐ¸: Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð° Ð´Ð° Ð³Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ',0),(152827,4246,'ur','Ú©ÙˆØ¦ÛŒ Ø³ÙˆØ§Ù„: Ù…Ø´ÛŒÙ† Ú©Û’ Ø®Ø§Ù†Ø¯Ø§Ù†ÙˆÚº Ú©Ùˆ Ø§Ù† Ú©Û’ Ø§Ø¶Ø§ÙÛ’ Ú©Û’ Ù„ÛŒÛ’ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(152828,4246,'sr','ÐÐµÐ¼Ð° Ð¿Ð¸Ñ‚Ð°ÑšÐ°: Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ˜Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ñ… Ð´Ð¾Ð´Ð°Ð»Ð¸',0),(152829,4246,'vi','KhÃ´ng Há»i: Sá»­a DÃ²ng MÃ¡y MÃ³c Äá»ƒ ThÃªm VÃ o',0),(152830,4246,'af','Geen Vrae:  Redigeer Masjien Families om Skep',0),(152831,4246,'ro','Nici o Ã®ntrebare: Editare maÅŸinÄƒ de familii pentru a le adÄƒuga',0),(152832,4246,'et','Ãœhtegi kÃ¼simust: Muuta kohapeal peredele lisamiseks',0),(152833,4246,'si','Brez vpraÅ¡anja: Urejanje stroj druÅ¾in, ki jih dodate',0),(152834,4246,'ba','Tidak ada pertanyaan: Mengedit mesin keluarga untuk menambahkannya',0),(152835,4246,'nl','Geen vragen: Bewerken Machine Families toe te voegen',0),(152836,4246,'fi','KysymyksiÃ¤: Muokkaa kone perheet lisÃ¤tÃ¤ ne',0),(152837,4246,'no','Ingen spÃ¸rsmÃ¥l: Redigere maskin familier Ã¥ legge dem',0),(152838,4246,'da','Ingen spÃ¸rgsmÃ¥l: Rediger maskine familier at tilfÃ¸je dem.',0),(152839,4246,'ko','ì¶”ê°€ ì§ˆë¬¸: íŽ¸ì§‘ ê¸°ê³„ ê°€ì¡±',0),(152840,4246,'he','××™×Ÿ ×©××œ×•×ª: ×¢×¨×™×›×” ×ž×›×•× ×ª ×ž×©×¤×—×•×ª ×›×“×™ ×œ×”×•×¡×™×£ ××•×ª×',0),(152841,4246,'el','ÎšÎ±Î¼Î¯Î± ÎµÏÏŽÏ„Î·ÏƒÎ·: Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼Î·Ï‡Î±Î½Î® Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹ÎµÏ‚ Î³Î¹Î± Î½Î± Ï„Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(152842,4246,'zh','æ²¡æœ‰é—®é¢˜ï¼šç¼–è¾‘æœºç³»åˆ—å°†æ·»åŠ å®ƒä»¬\r\n',0),(152843,4246,'sv','Inga frÃ¥gor: Redigera maskin familjer att lÃ¤gga till dem',0),(152844,4246,'it','Nessuna domanda: Modifica macchina famiglie per aggiungerli',0),(152845,4246,'tl','',0),(152846,4246,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3588;&#3635;&#3606;&#3634;&#3617; &#3649;&#3585;&#3657;&#3652;&#3586;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3614;&#',0),(152847,4246,'hi','à¤•à¥‹à¤ˆ à¤¸à¤µà¤¾à¤² à¤¨à¤¹à¥€à¤‚: à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤°à¥‹à¤‚ à¤®à¥‡à¤‚ à¤‰à¤¨à¥à¤¹à¥‡ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(152848,4246,'ms','Ada soalan: Edit Mesin keluarga untuk menambah mereka',0),(152849,4246,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£Ø³Ø¦Ù„Ø©: ØªØ­Ø±ÙŠØ± Ø§Ù„Ø£Ø³Ø± Ø¢Ù„Ø© Ø¥Ø¶Ø§ÙØªÙ‡Ø§',0),(152850,4246,'fr','Pas de Questions : Edit Machine familles afin de les ajouter',0),(152851,4246,'jp','è³ªå•?ã?ªã?—ï¼šã??ã‚Œã‚‰ã‚’è¿½åŠ ã?™ã‚‹ã?«ã?¯æ©Ÿæ¢°ç³»çµ±ã‚’ç·¨é›†ã?—ã?¦ä¸‹ã?•ã?„',0),(152852,4246,'pt','Sem perguntas: Editar famÃ­lias de mÃ¡quina para adicionÃ¡-los',0),(152853,4246,'ru','ÐÐµÑ‚ Ð²Ð¾Ð¿Ñ€Ð¾ÑÐ¾Ð²: Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ Ð´Ð»Ñ Ð¸Ñ… Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(152854,4246,'es','No Hay Preguntas: Editar Familias de MÃ¡quinas para Agregarlas',0),(152855,4246,'de','Keine Fragen: Edit Maschine Familien hinzufÃ¼gen',0),(152856,4246,'en','No Questions: Edit Machine Families to Add Them',0),(152857,4247,'is','',0),(152858,4247,'dr','ÙŠÙƒØ¨Ø§Ø± Ø¯Ø± Ù‡Ø± Ø´ØºÙ„ ',0),(152859,4247,'pr','ÙŠÙƒØ¨Ø§Ø± Ø¯Ø± Ù‡Ø± Ø´ØºÙ„ ',0),(152860,4247,'tr','Bir kez iÅŸ baÅŸÄ±na',0),(152861,4247,'pl','Raz w pracy',0),(152862,4247,'bg','Ð’ÐµÐ´Ð½ÑŠÐ¶ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(152863,4247,'ur','Ø§ÛŒÚ© Ø¨Ø§Ø± Ú©Ø§Ù… ÙÛŒ',0),(152864,4247,'sr','ÐˆÐµÐ´Ð½Ð¾Ð¼ Ð¿Ð¾ Ð¿Ð¾ÑÐ»Ñƒ',0),(152865,4247,'vi','Má»™t láº§n má»™t Job',0),(152866,4247,'af','Een keer Per taak',0),(152867,4247,'ro','O datÄƒ pe Job',0),(152868,4247,'et','Iga tÃ¶Ã¶',0),(152869,4247,'si','Enkrat na delo',0),(152870,4247,'ba','Sekali Per pekerjaan',0),(152871,4247,'nl','Eenmaal Per baan',0),(152872,4247,'fi','Kun tyÃ¶paikkaa kohden',0),(152873,4247,'no','Hver jobb',0),(152874,4247,'da','Ã‰n gang pr. Job',0),(152875,4247,'ko','ìž‘ì—… ë‹¹ í•œ ë²ˆ',0),(152876,4247,'he','×¤×¢× ××—×ª ×œ×›×œ ×ž×©×¨×”',0),(152877,4247,'el','ÎœÎ¯Î± Ï†Î¿ÏÎ¬ Î±Î½Î¬ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(152878,4247,'zh','æ¯ä½œä¸šä¸€æ¬¡\r\n',0),(152879,4247,'sv','En gÃ¥ng Per jobb',0),(152880,4247,'it','Una volta al lavoro',0),(152881,4247,'tl','',0),(152882,4247,'th','&#3627;&#3609;&#3638;&#3656;&#3591;&#3588;&#3619;&#3633;&#3657;&#3591;&#3605;&#3656;&#3629;&#3591;&#3634;&#3609;',0),(152883,4247,'hi','à¤à¤• à¤¬à¤¾à¤° à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¥à¤°à¤¤à¤¿',0),(152884,4247,'ms','Sekali satu kerja',0),(152885,4247,'ar','Ù…Ø±Ø© ÙˆØ§Ø­Ø¯Ø© Ù„ÙƒÙ„ Ù…Ù‡Ù…Ø©',0),(152886,4247,'fr','Une fois par poste',0),(152887,4247,'jp','ä½œæ¥­ã?«ã?¤ã??ä¸€å›ž',0),(152888,4247,'pt','Uma vez por emprego',0),(152889,4247,'ru','ÐžÐ´Ð¸Ð½ Ñ€Ð°Ð· Ð² Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(152890,4247,'es','Una Vez Por Trabajo',0),(152891,4247,'de','Einmal pro Auftrag',0),(152892,4247,'en','Once Per Job',0),(152893,4248,'is','',0),(152894,4248,'dr','Ø·Ø¨Ù‚ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(152895,4248,'pr','Ø·Ø¨Ù‚ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(152896,4248,'tr','Sadece malzemeleri',0),(152897,4248,'pl','Na materiaÅ‚y tylko',0),(152898,4248,'bg','ÐÐ° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸, ÑÐ°Ð¼Ð¾',0),(152899,4248,'ur','ØµØ±Ù Ù…ÙˆØ§Ø¯ Ù¾Ø±',0),(152900,4248,'sr','ÐÐ° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð¸Ð¼Ð° ÑÐ°Ð¼Ð¾',0),(152901,4248,'vi','Chá»‰ váº­t liá»‡u',0),(152902,4248,'af','Op materiaal slegs',0),(152903,4248,'ro','Materiale numai',0),(152904,4248,'et','Materjale Ã¼ksnes',0),(152905,4248,'si','Na materialov samo',0),(152906,4248,'ba','Bahan hanya',0),(152907,4248,'nl','Op materialen alleen',0),(152908,4248,'fi','Materiaaleja vain',0),(152909,4248,'no','PÃ¥ materialer bare',0),(152910,4248,'da','PÃ¥ kun materialer',0),(152911,4248,'ko','ìž¬ë£Œë§Œ',0),(152912,4248,'he','×¢×œ ×—×•×ž×¨×™× ×‘×œ×‘×“',0),(152913,4248,'el','Î£Ï„Î± Ï…Î»Î¹ÎºÎ¬ Î¼ÏŒÎ½Î¿',0),(152914,4248,'zh','åªæœ‰å¯¹ææ–™\r\n',0),(152915,4248,'sv','PÃ¥ material endast',0),(152916,4248,'it','Su materiali solo',0),(152917,4248,'tl','',0),(152918,4248,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(152919,4248,'hi','à¤•à¥‡à¤µà¤² à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤ªà¤°',0),(152920,4248,'ms','Bahan sahaja',0),(152921,4248,'ar','Ø¹Ù„Ù‰ Ù…ÙˆØ§Ø¯ ÙÙ‚Ø·',0),(152922,4248,'fr','Sur matÃ©riaux seulement',0),(152923,4248,'jp','æ??æ–™ã?«ã?¤ã?„ã?¦ã?®ã?¿',0),(152924,4248,'pt','Em materiais apenas',0),(152925,4248,'ru','ÐŸÐ¾ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð°Ð¼ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(152926,4248,'es','Solo En Materiales',0),(152927,4248,'de','Auf Materialien nur',0),(152928,4248,'en','On Materials Only',0),(152929,4249,'is','',0),(152930,4249,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙˆØ§Ù„ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(152931,4249,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙˆØ§Ù„ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(152932,4249,'tr','Soru hesaplamalarÄ± gÃ¼ncelleÅŸtirmek',0),(152933,4249,'pl','Aktualizacja pytanie obliczeÅ„',0),(152934,4249,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð²ÑŠÐ¿Ñ€Ð¾Ñ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(152935,4249,'ur','Ø³ÙˆØ§Ù„ Ø­Ø³Ø§Ø¨Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(152936,4249,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¿Ð¸Ñ‚Ð°ÑšÐµ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ°',0),(152937,4249,'vi','Cáº­p Nháº­t CÃ¢u Há»i TÃ­nh ToÃ¡n',0),(152938,4249,'af','Opdateer van Vraag Berekeninge',0),(152939,4249,'ro','Calculele de Ã®ntrebare actualizare',0),(152940,4249,'et','Update kÃ¼simus arvutused',0),(152941,4249,'si','Update vpraÅ¡anje izraÄuni',0),(152942,4249,'ba','Memperbarui pertanyaan perhitungan',0),(152943,4249,'nl','Update vraag berekeningen',0),(152944,4249,'fi','PÃ¤ivitÃ¤ kysymys laskelmat',0),(152945,4249,'no','Oppdatere spÃ¸rsmÃ¥l beregninger',0),(152946,4249,'da','Opdatere spÃ¸rgsmÃ¥l beregninger',0),(152947,4249,'ko','ì—…ë°ì´íŠ¸ ì§ˆë¬¸ ê³„ì‚°',0),(152948,4249,'he','×¢×“×›×•×Ÿ ×”×©××œ×” ×—×™×©×•×‘×™×',0),(152949,4249,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏÏŽÏ„Î·ÏƒÎ· Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(152950,4249,'zh','æ›´æ–°è®¡ç®—é—®é¢˜\r\n',0),(152951,4249,'sv','Uppdatera frÃ¥gan berÃ¤kningar',0),(152952,4249,'it','Aggiornamento domanda calcoli',0),(152953,4249,'tl','',0),(152954,4249,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3588;&#3635;&#3606;&#3634;&#3617;',0),(152955,4249,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨ à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(152956,4249,'ms','Kemaskini Terakhir soalan pengiraan',0),(152957,4249,'ar','Ø§Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ÙŠØ© ÙÙŠ Ù…Ø³Ø£Ù„Ø© Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(152958,4249,'fr','Mise Ã  jour Question calculs',0),(152959,4249,'jp','è³ªå•?è¨ˆç®—ã?®æ›´æ–°',0),(152960,4249,'pt','CÃ¡lculos de pergunta de atualizaÃ§Ã£o',0),(152961,4249,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð²Ð¾Ð¿Ñ€Ð¾Ñ Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(152962,4249,'es','Actualizar CÃ¡lculos de Preguntas',0),(152963,4249,'de','Update Frage Berechnungen',0),(152964,4249,'en','Update Question Calculations',0),(152965,4250,'is','',0),(152966,4250,'dr','Ù‚ÙŠÙ…Øª Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(152967,4250,'pr','Ù‚ÙŠÙ…Øª Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(152968,4250,'tr','BiÃ§imlendirme fiyat',0),(152969,4250,'pl','Cena znacznikÃ³w',0),(152970,4250,'bg','ÐœÐ°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ Ñ†ÐµÐ½Ð°',0),(152971,4250,'ur','Ù…Ø§Ø±Ú© Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(152972,4250,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ Ñ†ÐµÐ½Ð°',0),(152973,4250,'vi','GiÃ¡ cá»™ng thÃªm',0),(152974,4250,'af','Markup prys',0),(152975,4250,'ro','Pret de marcare',0),(152976,4250,'et','MÃ¤rgistuskeel hind',0),(152977,4250,'si','Cena oznak',0),(152978,4250,'ba','Markup harga',0),(152979,4250,'nl','Markup prijs',0),(152980,4250,'fi','Markup hinta',0),(152981,4250,'no','Markering pris',0),(152982,4250,'da','Markup pris',0),(152983,4250,'ko','íƒœê·¸ ê°€ê²©',0),(152984,4250,'he','×¡×™×ž×•×Ÿ ×ž×—×™×¨',0),(152985,4250,'el','Î¤Î¹Î¼Î® ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(152986,4250,'zh','æ ‡ç¤ºä»·æ ¼\r\n',0),(152987,4250,'sv','Markup pris',0),(152988,4250,'it','Codice prezzo',0),(152989,4250,'tl','',0),(152990,4250,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(152991,4250,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤®à¥‚à¤²à¥à¤¯',0),(152992,4250,'ms','Markup harga',0),(152993,4250,'ar','Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø³Ø¹Ø±',0),(152994,4250,'fr','Prix de balisage',0),(152995,4250,'jp','å€¤ä¸Šã?’ä¾¡æ ¼',0),(152996,4250,'pt','PreÃ§o de marcaÃ§Ã£o',0),(152997,4250,'ru','Ð¦ÐµÐ½Ð° Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(152998,4250,'es','Encarecimiento Precio',0),(152999,4250,'de','Markup-Preis',0),(153000,4250,'en','Markup Price',0),(153001,4251,'is','',0),(153002,4251,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø§Ø´ÙŠÙ† ',0),(153003,4251,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø§Ø´ÙŠÙ† ',0),(153004,4251,'tr','Makine ayrÄ±ntÄ±larÄ± ekleme',0),(153005,4251,'pl','Dodaj szczegÃ³Å‚y maszyny',0),(153006,4251,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð½Ð¸ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(153007,4251,'ur','Ù…Ø´ÛŒÙ† Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(153008,4251,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´ÐµÑ‚Ð°Ñ™Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(153009,4251,'vi','ThÃªm Chi Tiáº¿t MÃ¡y MÃ³c',0),(153010,4251,'af','Masjienbesonderhede Byvoeg',0),(153011,4251,'ro','Adauga detalii produs',0),(153012,4251,'et','Lisa masina Ã¼ksikasju',0),(153013,4251,'si','Dodajte podrobnosti stroj',0),(153014,4251,'ba','Menambahkan rincian mesin',0),(153015,4251,'nl','Machine Details toevoegen',0),(153016,4251,'fi','LisÃ¤Ã¤ koneen tiedot',0),(153017,4251,'no','Legge til maskinen detaljer',0),(153018,4251,'da','TilfÃ¸je maskine detaljer',0),(153019,4251,'ko','ì»´í“¨í„° ì„¸ë¶€ ì •ë³´ ì¶”ê°€',0),(153020,4251,'he','×”×•×¡×£ ×¤×¨×˜×™ ×ž×›×©×™×¨',0),(153021,4251,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î¼Î·Ï‡Î±Î½Î®Î¼Î±Ï„Î¿Ï‚',0),(153022,4251,'zh','å¢žåŠ æœºå™¨è¯¦ç»†ä¿¡æ¯\r\n',0),(153023,4251,'sv','LÃ¤gga till information om automaten',0),(153024,4251,'it','Aggiungere dettagli della macchina',0),(153025,4251,'tl','',0),(153026,4251,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(153027,4251,'hi','à¤®à¤¶à¥€à¤¨ à¤µà¤¿à¤µà¤°à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(153028,4251,'ms','Tambah butiran Mesin',0),(153029,4251,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¬Ù‡Ø§Ø²',0),(153030,4251,'fr','Ajouter Details de Machine',0),(153031,4251,'jp','æ©Ÿæ¢°è©³ç´°ã?®è¿½åŠ ',0),(153032,4251,'pt','Adicionar detalhes da mÃ¡quina',0),(153033,4251,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹',0),(153034,4251,'es','Agregar Detalles de MÃ¡quina',0),(153035,4251,'de','HinzufÃ¼gen von GerÃ¤tedaten',0),(153036,4251,'en','Add Machine Details',0),(153037,4252,'is','',0),(153038,4252,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù…Ø§Ø´ÙŠÙ† Ø§ÙŠÙ† Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(153039,4252,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù…Ø§Ø´ÙŠÙ† Ø§ÙŠÙ† Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(153040,4252,'tr','VarsayÄ±lan makine bu aile',0),(153041,4252,'pl','DomyÅ›lnie maszyna tej rodziny',0),(153042,4252,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð° Ñ‚Ð¾Ð²Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(153043,4252,'ur','Ø·Û’ Ø´Ø¯Û Ù…Ø´ÛŒÙ† Ø§Ø³ Ø®Ø§Ù†Ø¯Ø§Ù†',0),(153044,4252,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð¾Ð²Ðµ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ðµ',0),(153045,4252,'vi','MÃ¡y máº·c Ä‘á»‹nh cho gia Ä‘Ã¬nh nÃ y',0),(153046,4252,'af','Verstek masjien hierdie gesin',0),(153047,4252,'ro','MaÅŸinÄƒ de implicit aceastÄƒ familie',0),(153048,4252,'et','Vaikimisi masin selle pere',0),(153049,4252,'si','Privzeti stroj te druÅ¾ine',0),(153050,4252,'ba','Default mesin keluarga ini',0),(153051,4252,'nl','Standaard Machine deze familie',0),(153052,4252,'fi','Oletuksena pÃ¤Ã¤llÃ¤ tÃ¤mÃ¤n perheen',0),(153053,4252,'no','Standard maskin denne familien',0),(153054,4252,'da','Standardmaskine denne familie',0),(153055,4252,'ko','ê¸°ë³¸ ì»´í“¨í„°ê°€ì´ ê°€ì¡±',0),(153056,4252,'he','×ž×›×•× ×ª ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×”×ž×©×¤×—×” ×”×–××ª',0),(153057,4252,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¼Î·Ï‡Î±Î½Î® Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±Ï‚',0),(153058,4252,'zh','é»˜è®¤æ­¤æœºç³»åˆ—\r\n',0),(153059,4252,'sv','Standard maskin denna familj',0),(153060,4252,'it','Macchina predefinita questa famiglia',0),(153061,4252,'tl','',0),(153062,4252,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3609;&#3637;&#3657;',0),(153063,4252,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¤¶à¥€à¤¨ à¤‡à¤¸ à¤ªà¤°à¤¿à¤µà¤¾à¤°',0),(153064,4252,'ms','Mesin lalai keluarga ini',0),(153065,4252,'ar','Ø§Ù„Ø¥Ù„Ù‡ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ù‡Ø°Ù‡ Ø§Ù„Ø£Ø³Ø±Ø©',0),(153066,4252,'fr','Machine par dÃ©faut cette famille',0),(153067,4252,'jp','ã?“ã?®ç³»çµ±ã?®æ—¢å®šæ©Ÿæ¢°',0),(153068,4252,'pt','MÃ¡quina padrÃ£o desta famÃ­lia',0),(153069,4252,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÑ‚Ð° ÑÐµÐ¼ÑŒÑ',0),(153070,4252,'es','MÃ¡quina de Esta Familia por Defecto',0),(153071,4252,'de','Standard-Maschine dieser Familie',0),(153072,4252,'en','Default Machine This Family',0),(153073,4253,'is','',0),(153074,4253,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¯Ø±Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(153075,4253,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¯Ø±Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(153076,4253,'tr','Saat baÅŸÄ±na iÅŸgÃ¼cÃ¼ maliyeti',0),(153077,4253,'pl','Koszt pracy na godzinÄ™',0),(153078,4253,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ñ‚Ñ€ÑƒÐ´ Ð½Ð° Ñ‡Ð°Ñ',0),(153079,4253,'ur','Ù…Ø²Ø¯ÙˆØ± Ú©ÛŒ Ù‚ÛŒÙ…Øª ÙÛŒ Ú¯Ú¾Ù†Ù¹Û',0),(153080,4253,'sr','Ð Ð°Ð´ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ ÑÐ°Ñ‚Ñƒ',0),(153081,4253,'vi','Chi PhÃ­ nhÃ¢n cÃ´ng má»™t giá»',0),(153082,4253,'af','Arbeid Koste per Uur',0),(153083,4253,'ro','Costul forÅ£ei de muncÄƒ pe orÄƒ',0),(153084,4253,'et','Labor tunnikulu',0),(153085,4253,'si','StroÅ¡ek dela na uro',0),(153086,4253,'ba','Biaya tenaga kerja Per jam',0),(153087,4253,'nl','Arbeid kosten Per uur',0),(153088,4253,'fi','TyÃ¶kustannus Per tunti',0),(153089,4253,'no','Ap. kostnad Per time',0),(153090,4253,'da','Labor omkostninger pr. time',0),(153091,4253,'ko','ì‹œê°„ë‹¹ ë…¸ë™ ë¹„ìš©',0),(153092,4253,'he','×¢×œ×•×ª ×¢×‘×•×“×” ×œ×©×¢×”',0),(153093,4253,'el','Î•ÏÎ³Î±Ï„Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ ÏŽÏÎ±',0),(153094,4253,'zh','åŠ³åŠ¨åŠ›æˆæœ¬æ¯å°æ—¶\r\n',0),(153095,4253,'sv','Arbets kostnaden Per timme',0),(153096,4253,'it','Costo manodopera all\'ora',0),(153097,4253,'tl','',0),(153098,4253,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3588;&#3656;&#3634;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(153099,4253,'hi','à¤¶à¥à¤°à¤® à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾',0),(153100,4253,'ms','Kos buruh Per jam',0),(153101,4253,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ø¹Ù…Ø§Ù„Ø© Ù„Ù„Ø³Ø§Ø¹Ø© Ø§Ù„ÙˆØ§Ø­Ø¯Ø©',0),(153102,4253,'fr','CoÃ»t du travail par heure',0),(153103,4253,'jp','æ™‚é–“æ¯Ž',0),(153104,4253,'pt','Custo do trabalho por hora',0),(153105,4253,'ru','Ð¢Ñ€ÑƒÐ´Ð¾Ð²Ñ‹Ðµ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹ Ð² Ñ‡Ð°Ñ',0),(153106,4253,'es','Costo de Labor por Hora',0),(153107,4253,'de','Labor Kosten pro Stunde',0),(153108,4253,'en','Labor Cost Per Hour',0),(153109,4254,'is','',0),(153110,4254,'dr','Ù…Ø§Ø´ÙŠÙ† Ù‡Ø§',0),(153111,4254,'pr','Ù…Ø§Ø´ÙŠÙ† Ù‡Ø§',0),(153112,4254,'tr','Makineleri',0),(153113,4254,'pl','Maszyny',0),(153114,4254,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð¸',0),(153115,4254,'ur','Ù…Ø´ÛŒÙ†ÛŒÚº',0),(153116,4254,'sr','ÐœÐ°ÑˆÐ¸Ð½Ðµ',0),(153117,4254,'vi','MÃ¡y',0),(153118,4254,'af','Masjiene',0),(153119,4254,'ro','Masini',0),(153120,4254,'et','Masinad',0),(153121,4254,'si','Stroji',0),(153122,4254,'ba','Mesin',0),(153123,4254,'nl','Machines',0),(153124,4254,'fi','Koneet',0),(153125,4254,'no','Maskiner',0),(153126,4254,'da','Maskiner',0),(153127,4254,'ko','ê¸°ê³„',0),(153128,4254,'he','×ž×›×•× ×•×ª',0),(153129,4254,'el','ÎœÎ·Ï‡Î±Î½Î­Ï‚',0),(153130,4254,'zh','æœº\r\n',0),(153131,4254,'sv','Maskiner',0),(153132,4254,'it','Macchine',0),(153133,4254,'tl','',0),(153134,4254,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(153135,4254,'hi','à¤®à¤¶à¥€à¤¨à¥‡à¤‚',0),(153136,4254,'ms','Mesin',0),(153137,4254,'ar','Ø¢Ù„Ø§Øª',0),(153138,4254,'fr','Machines',0),(153139,4254,'jp','æ©Ÿæ¢°',0),(153140,4254,'pt','MÃ¡quinas',0),(153141,4254,'ru','ÐœÐ°ÑˆÐ¸Ð½Ñ‹',0),(153142,4254,'es','MÃ¡quinas',0),(153143,4254,'de','Maschinen',0),(153144,4254,'en','Machines',0),(153145,4255,'is','',0),(153146,4255,'dr','Ù…Ø§Ø´ÙŠÙ† Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(153147,4255,'pr','Ù…Ø§Ø´ÙŠÙ† Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(153148,4255,'tr','Makine ekledi',0),(153149,4255,'pl','Maszyna dodane',0),(153150,4255,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸',0),(153151,4255,'ur','Ù…Ø´ÛŒÙ† Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(153152,4255,'sr','ÐœÐ°ÑˆÐ¸Ð½Ð° Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð¾',0),(153153,4255,'vi','ÄÃ£ thÃªm MÃ¡y',0),(153154,4255,'af','Masjien Bygevoeg',0),(153155,4255,'ro','MaÅŸinÄƒ de adÄƒugat',0),(153156,4255,'et','Lisatud masin',0),(153157,4255,'si','Stroj, doda',0),(153158,4255,'ba','Mesin ditambahkan',0),(153159,4255,'nl','Machine toegevoegd',0),(153160,4255,'fi','Kone lisÃ¤si',0),(153161,4255,'no','Maskinen lagt',0),(153162,4255,'da','Maskine tilfÃ¸jet',0),(153163,4255,'ko','ì»´í“¨í„° ì¶”ê°€',0),(153164,4255,'he','×ž×›×•× ×ª ×”×•×¡×™×£',0),(153165,4255,'el','ÎœÎ·Ï‡Î±Î½Î® Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯',0),(153166,4255,'zh','æ–°å¢žçš„æœº\r\n',0),(153167,4255,'sv','Maskinen lagt',0),(153168,4255,'it','Macchina aggiunto',0),(153169,4255,'tl','',0),(153170,4255,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3649;&#3621;&#3657;&#3623;',0),(153171,4255,'hi','à¤®à¤¶à¥€à¤¨ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾',0),(153172,4255,'ms','Mesin yang ditambah',0),(153173,4255,'ar','ÙˆØ£Ø¶Ø§Ù Ø§Ù„Ø¬Ù‡Ø§Ø²',0),(153174,4255,'fr','Machine a ajoutÃ©',0),(153175,4255,'jp','æ©Ÿæ¢°ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(153176,4255,'pt','MÃ¡quina adicionada',0),(153177,4255,'ru','ÐœÐ°ÑˆÐ¸Ð½Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(153178,4255,'es','MÃ¡quina Agregada',0),(153179,4255,'de','Maschine hinzugefÃ¼gt',0),(153180,4255,'en','Machine Added',0),(153181,4256,'is','',0),(153182,4256,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ø´ÙŠÙ† Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(153183,4256,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ø´ÙŠÙ† Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(153184,4256,'tr','Makinenin maliyeti saat baÅŸÄ±na',0),(153185,4256,'pl','Koszt maszyny na godzinÄ™',0),(153186,4256,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð° Ñ‡Ð°Ñ',0),(153187,4256,'ur','Ù…Ø´ÛŒÙ† Ú©ÛŒ Ù‚ÛŒÙ…Øª ÙÛŒ Ú¯Ú¾Ù†Ù¹Û',0),(153188,4256,'sr','ÐœÐ°ÑˆÐ¸Ð½Ð° Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ ÑÐ°Ñ‚Ñƒ',0),(153189,4256,'vi','Chi phÃ­ mÃ¡y má»—i giá»',0),(153190,4256,'af','Masjien Koste Per Uur',0),(153191,4256,'ro','MaÅŸinÄƒ de Cost pe orÄƒ',0),(153192,4256,'et','Kohapeal on tunnikulu',0),(153193,4256,'si','StroÅ¡ki stroj na uro',0),(153194,4256,'ba','Mesin biaya Per jam',0),(153195,4256,'nl','Machine kosten Per uur',0),(153196,4256,'fi','Machine Cost / tunti',0),(153197,4256,'no','Maskinen kostnad Per time',0),(153198,4256,'da','Maskine omkostningen pr. time',0),(153199,4256,'ko','ì‹œê°„ë‹¹ ê¸°ê³„ ë¹„ìš©',0),(153200,4256,'he','×ž×—×©×‘ ×¢×œ×•×ª ×œ×©×¢×”',0),(153201,4256,'el','Î©ÏÎ¹Î±Î¯Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ Î¼Î·Ï‡Î±Î½Î®Ï‚',0),(153202,4256,'zh','æ¯å°æ—¶æœºå™¨æˆæœ¬\r\n',0),(153203,4256,'sv','Maskin kostnad Per timme',0),(153204,4256,'it','Costo macchina all\'ora',0),(153205,4256,'tl','',0),(153206,4256,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(153207,4256,'hi','à¤®à¤¶à¥€à¤¨ à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾',0),(153208,4256,'ms','Kos Mesin Per jam',0),(153209,4256,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ø¢Ù„Ø© Ù„ÙƒÙ„ Ø³Ø§Ø¹Ø©',0),(153210,4256,'fr','CoÃ»t de la machine Ã  l\'heure',0),(153211,4256,'jp','æ™‚é–“æ¯Žæ©Ÿæ¢°è²»',0),(153212,4256,'pt','Custo de mÃ¡quina por hora',0),(153213,4256,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ Ð² Ñ‡Ð°Ñ',0),(153214,4256,'es','MÃ¡quina Costo Por Hora',0),(153215,4256,'de','Preis pro Stunde',0),(153216,4256,'en','Machine Cost Per Hour',0),(153217,4257,'is','',0),(153218,4257,'dr','ÙƒØ³Ø±ÙŠÙ‡Ø§ÙŠ Ù…Ø§Ø´ÙŠÙ† â€“ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(153219,4257,'pr','ÙƒØ³Ø±ÙŠÙ‡Ø§ÙŠ Ù…Ø§Ø´ÙŠÙ† â€“ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø§Ø´ÙŠÙ† ',0),(153220,4257,'tr','Makineyi yoksun id_machine',0),(153221,4257,'pl','Maszyna id_machine brakuje',0),(153222,4257,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð°Ñ‚Ð° Ð½Ðµ Ðµ id_machine',0),(153223,4257,'ur','Ù…Ø´ÛŒÙ† Ù„Ø§Ú©Ú¾ id_machine',0),(153224,4257,'sr','ÐœÐ°ÑˆÐ¸Ð½Ð° Ð½ÐµÐ¼Ð° Ð¸Ð´_Ð¼Ð°Ñ†Ñ…Ð¸Ð½Ðµ',0),(153225,4257,'vi','MÃ¡y thiáº¿u ID mÃ¡y',0),(153226,4257,'af','Masjien nie id_machine',0),(153227,4257,'ro','Masina nu are id_machine',0),(153228,4257,'et','Kohapeal puudub id_machine',0),(153229,4257,'si','Stroj nima id_machine',0),(153230,4257,'ba','Mesin kekurangan id_machine',0),(153231,4257,'nl','Machine mist id_machine',0),(153232,4257,'fi','Kone ei ole id_machine',0),(153233,4257,'no','Maskinen mangler id_machine',0),(153234,4257,'da','Maskinen mangler id_machine',0),(153235,4257,'ko','ê¸°ê³„ ë¶€ì¡± id_machine',0),(153236,4257,'he','×ž×›×•× ×ª ×—×¡×¨ id_machine',0),(153237,4257,'el','ÎœÎ·Ï‡Î±Î½Î® ÏƒÏ„ÎµÏÎµÎ¯Ï„Î±Î¹ id_machine',0),(153238,4257,'zh','ç¼ºä¹è¯†åˆ«ç æœºæœºå™¨\r\n',0),(153239,4257,'sv','Maskinen saknar id_machine',0),(153240,4257,'it','Macchina manca id_machine',0),(153241,4257,'tl','',0),(153242,4257,'th','&#3586;&#3634;&#3604;&#3649;&#3588;&#3621;&#3609;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619; &#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(153243,4257,'hi','à¤®à¤¶à¥€à¤¨ à¤•à¤¾ à¤…à¤­à¤¾à¤µ id_machine',0),(153244,4257,'ms','Mesin tidak id_machine',0),(153245,4257,'ar','Id_machine ÙŠÙØªÙ‚Ø± Ø¥Ù„Ù‰ Ø§Ù„Ø¬Ù‡Ø§Ø²',0),(153246,4257,'fr','Machine manque id_machine',0),(153247,4257,'jp','æ©Ÿæ¢°ã?«ã?¯id_machineã?Œè¶³ã‚Šã?¾ã?›ã‚“',0),(153248,4257,'pt','Id_machine falta de mÃ¡quina',0),(153249,4257,'ru','ÐœÐ°ÑˆÐ¸Ð½Ð° id_machine Ð½Ðµ Ñ…Ð²Ð°Ñ‚Ð°ÐµÑ‚',0),(153250,4257,'es','MÃ¡quina Falta id_MÃ¡quina',0),(153251,4257,'de','Maschine fehlt id_machine',0),(153252,4257,'en','Machine Lacks id_machine',0),(153253,4258,'is','',0),(153254,4258,'dr','Ù†Ø§Ù… Ù…Ø§Ø´ÙŠÙ† ',0),(153255,4258,'pr','Ù†Ø§Ù… Ù…Ø§Ø´ÙŠÙ† ',0),(153256,4258,'tr','Makine adÄ±',0),(153257,4258,'pl','Nazwa komputera',0),(153258,4258,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(153259,4258,'ur','Ù…Ø´ÛŒÙ† Ú©Û’ Ù†Ø§Ù…',0),(153260,4258,'sr','Ð˜Ð¼Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ðµ',0),(153261,4258,'vi','TÃªn mÃ¡y',0),(153262,4258,'af','Masjien Naam',0),(153263,4258,'ro','Machine nume',0),(153264,4258,'et','Arvuti nimi',0),(153265,4258,'si','Ime raÄunalnika',0),(153266,4258,'ba','Nama mesin',0),(153267,4258,'nl','Naam van machine',0),(153268,4258,'fi','Koneen nimi',0),(153269,4258,'no','Maskinnavnet',0),(153270,4258,'da','Apparat benÃ¦vne',0),(153271,4258,'ko','ì»´í“¨í„° ì´ë¦„',0),(153272,4258,'he','×©× ×ž×—×©×‘',0),(153273,4258,'el','ÎŒÎ½Î¿Î¼Î± Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„Î®',0),(153274,4258,'zh','æœºå™¨åç§°\r\n',0),(153275,4258,'sv','Maskinnamn',0),(153276,4258,'it','Nome della macchina',0),(153277,4258,'tl','',0),(153278,4258,'th','&#3594;&#3639;&#3656;&#3629;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(153279,4258,'hi','à¤®à¤¶à¥€à¤¨ à¤¨à¤¾à¤®',0),(153280,4258,'ms','Nama Mesin',0),(153281,4258,'ar','Ø¥Ø³Ù… Ø§Ù„Ø¢Ù„Ø©',0),(153282,4258,'fr','Nom de l\'ordinateur',0),(153283,4258,'jp','æ©Ÿæ¢°å??',0),(153284,4258,'pt','Nome da mÃ¡quina',0),(153285,4258,'ru','Ð˜Ð¼Ñ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹',0),(153286,4258,'es','Nombre de MÃ¡quina',0),(153287,4258,'de','Name des Computers',0),(153288,4258,'en','Machine Name',0),(153289,4259,'is','',0),(153290,4259,'dr','Ù…Ø§Ø´ÙŠÙ† Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯  ',0),(153291,4259,'pr','Ù…Ø§Ø´ÙŠÙ† Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯  ',0),(153292,4259,'tr','Makine gÃ¼ncellendi',0),(153293,4259,'pl','Maszyna aktualizowane',0),(153294,4259,'bg','ÐœÐ°ÑˆÐ¸Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°',0),(153295,4259,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ù…Ø´ÛŒÙ†',0),(153296,4259,'sr','ÐœÐ°ÑˆÐ¸Ð½Ð° Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(153297,4259,'vi','Cáº­p Nháº­t mÃ¡y',0),(153298,4259,'af','Masjien Opdateer',0),(153299,4259,'ro','MaÅŸinÄƒ actualizat',0),(153300,4259,'et','Uuendatud masin',0),(153301,4259,'si','Stroj posodobljen',0),(153302,4259,'ba','Mesin yang diperbarui',0),(153303,4259,'nl','Machine bijgewerkt',0),(153304,4259,'fi','Kone pÃ¤ivitetty',0),(153305,4259,'no','Maskinen oppdatert',0),(153306,4259,'da','Maskine opdateret',0),(153307,4259,'ko','ì»´í“¨í„° ì—…ë°ì´íŠ¸',0),(153308,4259,'he','×ž×›×•× ×ª ×ž×¢×•×“×›×Ÿ',0),(153309,4259,'el','ÎœÎ·Ï‡Î±Î½Î® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(153310,4259,'zh','æœºæ›´æ–°\r\n',0),(153311,4259,'sv','Maskinen uppdaterad',0),(153312,4259,'it','Macchina aggiornato',0),(153313,4259,'tl','',0),(153314,4259,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(153315,4259,'hi','à¤®à¤¶à¥€à¤¨ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(153316,4259,'ms','Mesin yang dikemaskini',0),(153317,4259,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¬Ù‡Ø§Ø²',0),(153318,4259,'fr','Machine mis Ã  jour',0),(153319,4259,'jp','æ©Ÿæ¢°ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(153320,4259,'pt','MÃ¡quina atualizada',0),(153321,4259,'ru','ÐœÐ°ÑˆÐ¸Ð½Ð° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(153322,4259,'es','MÃ¡quina Actualizada',0),(153323,4259,'de','Maschine aktualisiert',0),(153324,4259,'en','Machine Updated',0),(153325,4260,'is','',0),(153326,4260,'dr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¹Ø¯Ø¯ ØµØ­ÙŠØ­ Ø¨Ø§Ø´Ø¯ ',0),(153327,4260,'pr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¹Ø¯Ø¯ ØµØ­ÙŠØ­ Ø¨Ø§Ø´Ø¯ ',0),(153328,4260,'tr','Bir tamsayÄ± olmalÄ±dÄ±r',0),(153329,4260,'pl','Musi byÄ‡ liczbÄ… caÅ‚kowitÄ…',0),(153330,4260,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ñ†ÑÐ»Ð¾ Ñ‡Ð¸ÑÐ»Ð¾',0),(153331,4260,'ur','Ø³Ø§Ù„Ù… Ø¹Ø¯Ø¯ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(153332,4260,'sr','ÐœÐ¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ñ†ÐµÐ¾ Ð±Ñ€Ð¾Ñ˜',0),(153333,4260,'vi','Pháº£i lÃ  sá»‘ nguyÃªn',0),(153334,4260,'af','\'N heelgetal moet wees',0),(153335,4260,'ro','Trebuie sÄƒ fie un numÄƒr Ã®ntreg',0),(153336,4260,'et','Peab olema tÃ¤isarv',0),(153337,4260,'si','Mora biti celo Å¡tevilo',0),(153338,4260,'ba','Harus menjadi Integer',0),(153339,4260,'nl','Moet een geheel getal',0),(153340,4260,'fi','On oltava kokonaisluku',0),(153341,4260,'no','MÃ¥ vÃ¦re et heltall',0),(153342,4260,'da','Skal vÃ¦re et heltal',0),(153343,4260,'ko','ì •ìˆ˜ ì—¬ì•¼ í•©ë‹ˆë‹¤.',0),(153344,4260,'he','×—×™×™×‘ ×œ×”×™×•×ª ×ž×¡×¤×¨ ×©×œ×',0),(153345,4260,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î±ÎºÎ­ÏÎ±Î¹Î¿Ï‚',0),(153346,4260,'zh','å¿…é¡»ä¸ºæ•´æ•°\r\n',0),(153347,4260,'sv','MÃ¥ste vara ett heltal',0),(153348,4260,'it','Deve essere un numero intero',0),(153349,4260,'tl','',0),(153350,4260,'th','&#3605;&#3657;&#3629;&#3591;&#3648;&#3611;&#3655;&#3609;&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3605;&#3655;&#3617;',0),(153351,4260,'hi','à¤•à¥‹à¤ˆ à¤ªà¥‚à¤°à¥à¤£à¤¾à¤‚à¤• à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(153352,4260,'ms','Mesti Integer',0),(153353,4260,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø¹Ø¯Ø¯ ØµØ­ÙŠØ­',0),(153354,4260,'fr','Doit Ãªtre un entier',0),(153355,4260,'jp','æ•´æ•°ã?§ã?ªã??ã?¦ã?¯ã?ªã‚Šã?¾ã?›ã‚“',0),(153356,4260,'pt','Deve ser um nÃºmero inteiro',0),(153357,4260,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ñ†ÐµÐ»Ñ‹Ð¼',0),(153358,4260,'es','Debe estar en Entero',0),(153359,4260,'de','Eine Ganzzahl muss sein',0),(153360,4260,'en','Must be an Integer',0),(153361,4261,'is','',0),(153362,4261,'dr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¹Ø¯Ø¯ Ù…Ø«Ø¨Øª ÙŠØ§ ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(153363,4261,'pr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¹Ø¯Ø¯ Ù…Ø«Ø¨Øª ÙŠØ§ ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(153364,4261,'tr','Pozitif bir sayÄ± veya sÄ±fÄ±r olmalÄ±dÄ±r',0),(153365,4261,'pl','Musi byÄ‡ liczbÄ… dodatniÄ… lub zerem',0),(153366,4261,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ð¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ñ‡Ð¸ÑÐ»Ð¾ Ð¸Ð»Ð¸ Ð½ÑƒÐ»Ð°',0),(153367,4261,'ur','Ø§ÛŒÚ© Ù…Ø«Ø¨Øª Ø¹Ø¯Ø¯ ÛŒØ§ ØµÙØ± ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒÛ’',0),(153368,4261,'sr','ÐœÐ¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾Ð·Ð¸Ñ‚Ð¸Ð²Ð°Ð½ Ð±Ñ€Ð¾Ñ˜ Ð¸Ð»Ð¸ Ð½ÑƒÐ»Ð°',0),(153369,4261,'vi','Pháº£i lÃ  sá»‘ dÆ°Æ¡ng hoáº·c 0',0),(153370,4261,'af','Moet \'n Positiewe Syfer wees of Nul',0),(153371,4261,'ro','Trebuie sÄƒ fie un numÄƒr pozitiv sau Zero',0),(153372,4261,'et','Peab olema positiivne number vÃµi null',0),(153373,4261,'si','Mora biti pozitivno Å¡tevilo ali niÄla',0),(153374,4261,'ba','Harus sejumlah positif atau nol',0),(153375,4261,'nl','Moet een positief getal of nul',0),(153376,4261,'fi','TÃ¤ytyy olla positiivinen luku tai nolla',0),(153377,4261,'no','MÃ¥ vÃ¦re et positivt tall eller null',0),(153378,4261,'da','Skal vÃ¦re et positivt tal eller nul',0),(153379,4261,'ko','ì–‘ìˆ˜ ë˜ëŠ” 0 ì´ì–´ì•¼ í•©ë‹ˆë‹¤.',0),(153380,4261,'he','×—×™×™×‘ ×œ×”×™×•×ª ×ž×¡×¤×¨ ×—×™×•×‘×™ ××• ××¤×¡',0),(153381,4261,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î­Î½Î±Ï‚ Î¸ÎµÏ„Î¹ÎºÏŒÏ‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î® Ï„Î¿ Î¼Î·Î´Î­Î½',0),(153382,4261,'zh','å¿…é¡»æ˜¯æ­£æ•°æˆ–é›¶\r\n',0),(153383,4261,'sv','MÃ¥ste vara ett positivt tal eller noll',0),(153384,4261,'it','Deve essere un numero positivo o Zero',0),(153385,4261,'tl','',0),(153386,4261,'th','&#3605;&#3657;&#3629;&#3591;&#3648;&#3611;&#3655;&#3609;&#3592;&#3635;&#3609;&#3623;&#3609;&#3610;&#3623;&#3585;&#3627;&#3619;&#3639;&#3629;&#3624;&#3641;&#3609;&#3618;&#3660;',0),(153387,4261,'hi','à¤à¤• à¤§à¤¨à¤¾à¤¤à¥à¤®à¤• à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¯à¤¾ à¤¶à¥‚à¤¨à¥à¤¯ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(153388,4261,'ms','Mesti suatu nombor positif atau sifar',0),(153389,4261,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø¹Ø¯Ø¯Ø§ ØµØ­ÙŠØ­Ø§Ù‹ Ù…ÙˆØ¬Ø¨Ø§Ù‹ Ø£Ùˆ ØµÙØ±Ø§Ù‹',0),(153390,4261,'fr','Doit Ãªtre un nombre positif ou zÃ©ro',0),(153391,4261,'jp','æ­£æ•°ã‚‚ã?—ã??ã?¯ï¼?ã?§ã?ªã??ã?¦ã?¯ã?ªã‚Šã?¾ã?›ã‚“',0),(153392,4261,'pt','Deve ser um nÃºmero positivo ou Zero',0),(153393,4261,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ð¿Ð¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ñ‡Ð¸ÑÐ»Ð¾ Ð¸Ð»Ð¸ Ð½Ð¾Ð»ÑŒ',0),(153394,4261,'es','Debe estar un NÃºmero Positivo o Cero',0),(153395,4261,'de','Eine Positive Zahl oder NULL muss sein',0),(153396,4261,'en','Must be a Positive Number or Zero',0),(153397,4262,'is','',0),(153398,4262,'dr','Ø¨Ø§ÙŠØ¯ Ø¹Ø¯Ø¯ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(153399,4262,'pr','Ø¨Ø§ÙŠØ¯ Ø¹Ø¯Ø¯ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(153400,4262,'tr','SayÄ±sal olmalÄ±dÄ±r',0),(153401,4262,'pl','Musi byÄ‡ numeryczny',0),(153402,4262,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ñ†Ð¸Ñ„Ñ€Ð¾Ð²',0),(153403,4262,'ur','Ø¹Ø¯Ø¯ÛŒ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(153404,4262,'sr','ÐœÐ¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð½ÑƒÐ¼ÐµÑ€Ð¸Ñ‡ÐºÐ°',0),(153405,4262,'vi','Pháº£i lÃ  Sá»‘',0),(153406,4262,'af','Numeriese moet word',0),(153407,4262,'ro','Trebuie sÄƒ fie Numeric',0),(153408,4262,'et','Peab olema arvuline',0),(153409,4262,'si','Mora biti Å¡tevilski',0),(153410,4262,'ba','Harus numerik',0),(153411,4262,'nl','Numerieke moet worden',0),(153412,4262,'fi','On oltava numeerinen',0),(153413,4262,'no','MÃ¥ vÃ¦re numerisk',0),(153414,4262,'da','Skal vÃ¦re numerisk',0),(153415,4262,'ko','ìˆ«ìž ì—¬ì•¼ í•©ë‹ˆë‹¤.',0),(153416,4262,'he','×—×™×™×‘ ×œ×”×™×•×ª ×ž×¡×¤×¨×™',0),(153417,4262,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î±ÏÎ¹Î¸Î¼Î·Ï„Î¹ÎºÏŒ',0),(153418,4262,'zh','å¿…é¡»æ˜¯æ•°å­—\r\n',0),(153419,4262,'sv','MÃ¥ste vara numeriska',0),(153420,4262,'it','Deve essere numerico',0),(153421,4262,'tl','',0),(153422,4262,'th','&#3605;&#3657;&#3629;&#3591;&#3648;&#3611;&#3655;&#3609;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;',0),(153423,4262,'hi','à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤• à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(153424,4262,'ms','Mesti angka',0),(153425,4262,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙƒÙˆÙ† Ø±Ù‚Ù…ÙŠØ©',0),(153426,4262,'fr','Doit Ãªtre numÃ©rique',0),(153427,4262,'jp','æ•°å­—ã?§ã?ªã??ã?¦ã?¯ã?ªã‚Šã?¾ã?›ã‚“',0),(153428,4262,'pt','Deve ser numÃ©rico',0),(153429,4262,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ñ‡Ð¸ÑÐ»Ð¾Ð²Ð¾Ð¹',0),(153430,4262,'es','Debe ser Numerico',0),(153431,4262,'de','Numerisch muss sein',0),(153432,4262,'en','Must be Numeric',0),(153433,4263,'is','',0),(153434,4263,'dr','Ø²Ù…Ø§Ù† Ø§Ù¾Ø±Ø§ØªÙˆØ±',0),(153435,4263,'pr','Ø²Ù…Ø§Ù† Ø§Ù¾Ø±Ø§ØªÙˆØ±',0),(153436,4263,'tr','Ä°ÅŸleÃ§ sÃ¼resi',0),(153437,4263,'pl','Czasu operatora',0),(153438,4263,'bg','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(153439,4263,'ur','Ø¢Ù¾Ø±ÛŒÙ¹Ø± ÙˆÙ‚Øª',0),(153440,4263,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ‚ÐµÑ€ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(153441,4263,'vi','Thá»i gian NgÆ°á»i Ä‘iá»u hÃ nh',0),(153442,4263,'af','Operateur Tyd',0),(153443,4263,'ro','Operatorul de timp',0),(153444,4263,'et','Operaatoriaja',0),(153445,4263,'si','Operaterja',0),(153446,4263,'ba','Operator waktu',0),(153447,4263,'nl','Exploitant tijd',0),(153448,4263,'fi','Operaattorin ajan',0),(153449,4263,'no','OperatÃ¸rtiden',0),(153450,4263,'da','OperatÃ¸rtid',0),(153451,4263,'ko','í†µì‹  ì‹œê°„',0),(153452,4263,'he','×”×ž×¤×¢×™×œ ×‘×–×ž×Ÿ',0),(153453,4263,'el','Î§ÎµÎ¹ÏÎ¹ÏƒÏ„Î®Ï‚ Ï‡ÏÏŒÎ½Î¿',0),(153454,4263,'zh','æ“ä½œå™¨æ—¶é—´\r\n',0),(153455,4263,'sv','OperatÃ¶rstiden',0),(153456,4263,'it','Operatore tempo',0),(153457,4263,'tl','',0),(153458,4263,'th','&#3648;&#3623;&#3621;&#3634;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;',0),(153459,4263,'hi','à¤‘à¤ªà¤°à¥‡à¤Ÿà¤° à¤¸à¤®à¤¯',0),(153460,4263,'ms','Masa operator',0),(153461,4263,'ar','Ø¹Ø§Ù…Ù„ Ø§Ù„ÙˆÙ‚Øª',0),(153462,4263,'fr','Temps de l\'opÃ©rateur',0),(153463,4263,'jp','ã‚ªãƒšãƒ¬ãƒ¼ã‚¿ãƒ¼æ™‚é–“',0),(153464,4263,'pt','Tempo do operador',0),(153465,4263,'ru','Ð’Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ð°',0),(153466,4263,'es','Tiempo de Operador',0),(153467,4263,'de','Bedienerzeit',0),(153468,4263,'en','Operator Time',0),(153469,4264,'is','',0),(153470,4264,'dr','Ø²Ù…Ø§Ù† Ø§Ù¾Ø±Ø§ØªÙˆØ±  Ø¨Ù‡ Ø²Ù…Ø§Ù† Ù…Ø§Ø´ÙŠÙ†',0),(153471,4264,'pr','Ø²Ù…Ø§Ù† Ø§Ù¾Ø±Ø§ØªÙˆØ±  Ø¨Ù‡ Ø²Ù…Ø§Ù† Ù…Ø§Ø´ÙŠÙ†',0),(153472,4264,'tr','OperatÃ¶r zaman makinesi zaman',0),(153473,4264,'pl','Czas operatora maszyny',0),(153474,4264,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ð° Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°Ñ‚Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(153475,4264,'ur','ÙˆÙ‚Øª Ù…Ø´ÛŒÙ† Ú©Û’ Ù„Ø¦Û’ Ø¢Ù¾Ø±ÛŒÙ¹Ø± ÙˆÙ‚Øª',0),(153476,4264,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ‚ÐµÑ€ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð´Ð° Ð²Ñ€ÐµÐ¼Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ€Ð°',0),(153477,4264,'vi','Thá»i gian NgÆ°á»i Ä‘iá»u hÃ nh tá»›i thá»i gian mÃ¡y',0),(153478,4264,'af','Operateur van tyd tot tyd masjien',0),(153479,4264,'ro','Operatorul timp Ã®n maÅŸinÄƒ de timp',0),(153480,4264,'et','Operaatoriaja masinas aeg',0),(153481,4264,'si','Upravljavec Äasa do Äasa stroj',0),(153482,4264,'ba','Operator waktu ke waktu mesin',0),(153483,4264,'nl','Exploitant tijd tot tijd Machine',0),(153484,4264,'fi','Operaattorin ajan kone aika',0),(153485,4264,'no','OperatÃ¸rtiden maskin tid',0),(153486,4264,'da','OperatÃ¸rtid til maskinen',0),(153487,4264,'ko','ì»´í“¨í„° ì‹œê°„ í†µì‹  ì‹œê°„',0),(153488,4264,'he','×–×ž×Ÿ ×ž×¤×¢×™×œ ×ž×›×•× ×ª ×–×ž×Ÿ',0),(153489,4264,'el','Î§ÎµÎ¹ÏÎ¹ÏƒÏ„Î®Ï‚ ÎºÎ±Î¹ÏÎ¿Ï ÎµÎ¹Ï‚ ÎºÎ±Î¹ÏÏŒÎ½ Î¼Î·Ï‡Î±Î½Î®',0),(153490,4264,'zh','æœºå™¨æ—¶é—´æ“ä½œå™¨æ—¶é—´\r\n',0),(153491,4264,'sv','OperatÃ¶rstid till maskin',0),(153492,4264,'it','Volta di operatore in volta, macchina',0),(153493,4264,'tl','',0),(153494,4264,'th','&#3648;&#3623;&#3621;&#3634;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;&#3652;&#3611;&#3626;&#3641;&#3656;&#3648;&#3623;&#3621;&#3634;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(153495,4264,'hi','à¤‘à¤ªà¤°à¥‡à¤Ÿà¤° à¤¸à¤®à¤¯ à¤®à¤¶à¥€à¤¨ à¤¸à¤®à¤¯ à¤•à¥‹',0),(153496,4264,'ms','Pengendali semasa ke semasa Mesin',0),(153497,4264,'ar','Ø¹Ø§Ù…Ù„ Ø§Ù„ÙˆÙ‚Øª Ù„Ø§Ù„Ø© Ø§Ù„Ø²Ù…Ù†',0),(153498,4264,'fr','Temps opÃ©rateur/temps Machine',0),(153499,4264,'jp','é?‹è»¢æ™‚é–“ã?®ã‚ªãƒšãƒ¬ãƒ¼ã‚¿ãƒ¼æ™‚é–“',0),(153500,4264,'pt','Hora de operador de mÃ¡quina de tempo',0),(153501,4264,'ru','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(153502,4264,'es','Tiempo de Operador a Tiempo de MÃ¡quina',0),(153503,4264,'de','Bedienerzeit, Maschinenzeit',0),(153504,4264,'en','Operator Time to Machine Time',0),(153505,4265,'is','',0),(153506,4265,'dr','Ø¶Ø±ÙˆØ±ÙŠ',0),(153507,4265,'pr','Ø¶Ø±ÙˆØ±ÙŠ',0),(153508,4265,'tr','Gerekli',0),(153509,4265,'pl','Wymagane',0),(153510,4265,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð°',0),(153511,4265,'ur','Ø¯Ø±Ú©Ø§Ø±',0),(153512,4265,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ',0),(153513,4265,'vi','ÄÃ£ yÃªu cáº§u',0),(153514,4265,'af','Benodig',0),(153515,4265,'ro','Necesare',0),(153516,4265,'et','Kohustuslik',0),(153517,4265,'si','Zahteva',0),(153518,4265,'ba','Diperlukan',0),(153519,4265,'nl','Vereist',0),(153520,4265,'fi','Tarvitaan',0),(153521,4265,'no','Kreves',0),(153522,4265,'da','KrÃ¦ves',0),(153523,4265,'ko','í•„ìˆ˜',0),(153524,4265,'he','× ×“×¨×©',0),(153525,4265,'el','Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(153526,4265,'zh','è¦æ±‚\r\n',0),(153527,4265,'sv','KrÃ¤vs',0),(153528,4265,'it','Obbligatorio',0),(153529,4265,'tl','',0),(153530,4265,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(153531,4265,'hi','à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(153532,4265,'ms','Diperlukan',0),(153533,4265,'ar','Ù…Ø·Ù„ÙˆØ¨',0),(153534,4265,'fr','Obligatoire',0),(153535,4265,'jp','å¿…è¦?ã?ª',0),(153536,4265,'pt','NecessÃ¡rio',0),(153537,4265,'ru','ÐžÐ±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾',0),(153538,4265,'es','Requerido',0),(153539,4265,'de','Erforderlich',0),(153540,4265,'en','Required',0),(153541,4266,'is','',0),(153542,4266,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø§Ø´ÙŠÙ† ',0),(153543,4266,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø§Ø´ÙŠÙ† ',0),(153544,4266,'tr','Makineyi seÃ§in',0),(153545,4266,'pl','Wybierz urzÄ…dzenie',0),(153546,4266,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(153547,4266,'ur','Ù…Ø´ÛŒÙ† Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(153548,4266,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ñƒ',0),(153549,4266,'vi','Chá»n mÃ¡y',0),(153550,4266,'af','Kies masjien',0),(153551,4266,'ro','SelectaÅ£i masina',0),(153552,4266,'et','Vali masin',0),(153553,4266,'si','Izberite stroj',0),(153554,4266,'ba','Pilih mesin',0),(153555,4266,'nl','Selecteer Machine',0),(153556,4266,'fi','Valitse',0),(153557,4266,'no','Velg maskin',0),(153558,4266,'da','VÃ¦lg maskine',0),(153559,4266,'ko','ì»´í“¨í„° ì„ íƒ',0),(153560,4266,'he','×‘×—×¨ ×ž×›×•× ×”',0),(153561,4266,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î·Ï‡Î±Î½Î®',0),(153562,4266,'zh','é€‰æ‹©æœºå™¨\r\n',0),(153563,4266,'sv','VÃ¤lj maskin',0),(153564,4266,'it','Seleziona macchina',0),(153565,4266,'tl','',0),(153566,4266,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(153567,4266,'hi','à¤®à¤¶à¥€à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(153568,4266,'ms','Pilih Mesin',0),(153569,4266,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø¬Ù‡Ø§Ø²',0),(153570,4266,'fr','SÃ©lectionnez la Machine',0),(153571,4266,'jp','æ©Ÿæ¢°ã?®é?¸æŠž',0),(153572,4266,'pt','Selecione a mÃ¡quina',0),(153573,4266,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¼Ð°ÑˆÐ¸Ð½Ñƒ',0),(153574,4266,'es','Seleccionar MÃ¡quina',0),(153575,4266,'de','WÃ¤hlen Sie Computer',0),(153576,4266,'en','Select Machine',0),(153577,4267,'is','',0),(153578,4267,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÙŠØ§Ù„',0),(153579,4267,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÙŠØ§Ù„',0),(153580,4267,'tr','Seri numarasÄ±',0),(153581,4267,'pl','Numer seryjny',0),(153582,4267,'bg','Ð¡ÐµÑ€Ð¸ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(153583,4267,'ur','Ø³ÛŒØ±ÛŒÙ„ Ù†Ù…Ø¨Ø±',0),(153584,4267,'sr','Ð¡ÐµÑ€Ð¸Ñ˜ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(153585,4267,'vi','Sá»‘ thá»© tá»±',0),(153586,4267,'af','Serie Nommer',0),(153587,4267,'ro','NumÄƒrul de serie',0),(153588,4267,'et','Seerianumber',0),(153589,4267,'si','Serijska Å¡tevilka',0),(153590,4267,'ba','Nomor seri',0),(153591,4267,'nl','Serienummer',0),(153592,4267,'fi','Sarjanumero',0),(153593,4267,'no','LÃ¸penummer',0),(153594,4267,'da','LÃ¸benummer',0),(153595,4267,'ko','ì¼ë ¨ ë²ˆí˜¸',0),(153596,4267,'he','×ž×¡×¤×¨ ×¡×™×“×•×¨×™',0),(153597,4267,'el','Î‘ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(153598,4267,'zh','åºåˆ—å·\r\n',0),(153599,4267,'sv','Serienummer',0),(153600,4267,'it','Numero di serie',0),(153601,4267,'tl','',0),(153602,4267,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;',0),(153603,4267,'hi','à¤¸à¥€à¤°à¤¿à¤¯à¤² à¤¨à¤‚à¤¬à¤°',0),(153604,4267,'ms','Nombor siri',0),(153605,4267,'ar','Ø§Ù„Ø±Ù‚Ù… Ø§Ù„Ù…ØªØ³Ù„Ø³Ù„',0),(153606,4267,'fr','NumÃ©ro de sÃ©rie',0),(153607,4267,'jp','ã‚·ãƒªã‚¢ãƒ«ãƒŠãƒ³ãƒ?ãƒ¼',0),(153608,4267,'pt','NÃºmero de sÃ©rie',0),(153609,4267,'ru','Ð¡ÐµÑ€Ð¸Ð¹Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€',0),(153610,4267,'es','NÃºmero de Serie',0),(153611,4267,'de','Seriennummer',0),(153612,4267,'en','Serial Number',0),(153613,4268,'is','',0),(153614,4268,'dr','1- 100 Ø¨Ø§Ø´Ø¯ ',0),(153615,4268,'pr','Ø¨Ø§ÙŠØ¯ Ø§Ø² 1- 100 Ø¨Ø§Ø´Ø¯ ',0),(153616,4268,'tr','1-100-meli var olmak',0),(153617,4268,'pl','Powinno byÄ‡ 1-100',0),(153618,4268,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ 1-100',0),(153619,4268,'ur','1-100 ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(153620,4268,'sr','Ð¢Ñ€ÐµÐ±Ð° Ð´Ð° Ð±ÑƒÐ´Ðµ 1-100',0),(153621,4268,'vi','Pháº£i lÃ  1-100',0),(153622,4268,'af','Behoort 1-100',0),(153623,4268,'ro','Ar trebui sÄƒ fie 1-100',0),(153624,4268,'et','Peaks olema 1-100',0),(153625,4268,'si','Mora biti 1-100',0),(153626,4268,'ba','Harus dapat 1-100',0),(153627,4268,'nl','Moet 1-100',0),(153628,4268,'fi','PitÃ¤isi olla 1-100',0),(153629,4268,'no','Skal 1-100',0),(153630,4268,'da','BÃ¸r vÃ¦re 1-100',0),(153631,4268,'ko','1-100 ìˆ˜ í•œë‹¤',0),(153632,4268,'he','×¦×¨×™×š ×œ×”×™×•×ª 1-100',0),(153633,4268,'el','Î˜Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ 1-100',0),(153634,4268,'zh','åº”åœ¨1-100\r\n',0),(153635,4268,'sv','BÃ¶r vara 1-100',0),(153636,4268,'it','1-100',0),(153637,4268,'tl','',0),(153638,4268,'th','&#3588;&#3623;&#3619;&#3592;&#3632;&#3648;&#3611;&#3655;&#3609; 1-100',0),(153639,4268,'hi','1-100 à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(153640,4268,'ms','Sepatutnya 1-100',0),(153641,4268,'ar','ÙˆÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ÙŠÙƒÙˆÙ† 1-100',0),(153642,4268,'fr','Devrait Ãªtre de 1-100',0),(153643,4268,'jp','ï¼‘ï¼?ï¼‘ï¼?ï¼?ã?§ã?ªã?‘ã‚Œã?°ã?ªã‚Šã?¾ã?›ã‚“',0),(153644,4268,'pt','Deve ser 1-100',0),(153645,4268,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ 1-100',0),(153646,4268,'es','Debe ser 1-100',0),(153647,4268,'de','Sollte 1-100',0),(153648,4268,'en','Should be 1-100',0),(153649,4269,'is','',0),(153650,4269,'dr','Ø¨Ø§ÙŠØ¯ ØµÙØ± ÙŠØ§  Ø¨Ø²Ø±Ú¯ØªØ± Ø¨Ø§Ø´Ø¯ ',0),(153651,4269,'pr','Ø¨Ø§ÙŠØ¯ ØµÙØ± ÙŠØ§  Ø¨Ø²Ø±Ú¯ØªØ± Ø¨Ø§Ø´Ø¯ ',0),(153652,4269,'tr','SÄ±fÄ±r olmalÄ± veya daha bÃ¼yÃ¼k',0),(153653,4269,'pl','Powinno byÄ‡ Zero lub wiÄ™kszÄ…',0),(153654,4269,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð½ÑƒÐ»Ð° Ð¸Ð»Ð¸ Ð¿Ð¾-Ð³Ð¾Ð»ÑÐ¼',0),(153655,4269,'ur','Ø¨Ù†Ø¯ÛŒ ØµÙØ± ÛÙˆÙ†ÛŒ Ú†Ø§ÛØ¦Û’ ÛŒØ§ Ø§Ø³ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(153656,4269,'sr','Ð¢Ñ€ÐµÐ±Ð° Ð±Ð¸Ñ‚Ð¸ Ð½ÑƒÐ»Ð° Ð¸Ð»Ð¸ Ð²ÐµÑ›Ð°',0),(153657,4269,'vi','Pháº£i lÃ  Zero hoáº·c lá»›n hÆ¡n',0),(153658,4269,'af','Behoort nul of groter',0),(153659,4269,'ro','Ar trebui sÄƒ fie Zero sau mai mare',0),(153660,4269,'et','Peab olema null vÃµi suurem',0),(153661,4269,'si','Mora biti niÄ ali veÄje',0),(153662,4269,'ba','Harus nol atau lebih besar',0),(153663,4269,'nl','Moet nul of meer',0),(153664,4269,'fi','Tulisi olla nolla tai suurempi',0),(153665,4269,'no','BÃ¸r vÃ¦re null eller stÃ¸rre',0),(153666,4269,'da','Skal vÃ¦re nul eller stÃ¸rre',0),(153667,4269,'ko','0ì´ ë˜ì–´ì•¼ ì´ìƒ',0),(153668,4269,'he','×¦×¨×™×š ×œ×”×™×•×ª ××¤×¡ ××• ×™×•×ª×¨',0),(153669,4269,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼Î·Î´ÎµÎ½Î¹ÎºÏŒÏ‚ Î® Î¼ÎµÎ³Î±Î»ÏÏ„ÎµÏÎ·',0),(153670,4269,'zh','åº”ä¸ºå¤§äºŽç­‰äºŽé›¶\r\n',0),(153671,4269,'sv','Ska vara noll eller stÃ¶rre',0),(153672,4269,'it','Deve essere Zero o maggiore',0),(153673,4269,'tl','',0),(153674,4269,'th','&#3588;&#3623;&#3619;&#3592;&#3632;&#3648;&#3611;&#3655;&#3609;&#3624;&#3641;&#3609;&#3618;&#3660;&#3627;&#3619;&#3639;&#3629;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(153675,4269,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤ à¤¯à¤¾ à¤…à¤§à¤¿à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(153676,4269,'ms','Harus menjadi sifar atau lebih',0),(153677,4269,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙƒÙˆÙ† ØµÙØ±Ø§Ù‹ Ø£Ùˆ Ø£ÙƒØ¨Ø±',0),(153678,4269,'fr','Doit Ãªtre Ã©gal Ã  zÃ©ro ou supÃ©rieure',0),(153679,4269,'jp','ï¼?ã?‹ã??ã‚Œä»¥ä¸Šã?§ã?ªã?‘ã‚Œã?°ã?ªã‚Šã?¾ã?›ã‚“',0),(153680,4269,'pt','Deve ser Zero ou maior',0),(153681,4269,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð²Ð½Ð¾ Ð½ÑƒÐ»ÑŽ Ð¸Ð»Ð¸ Ð±Ð¾Ð»ÑŒÑˆÐµ',0),(153682,4269,'es','Debe Ser Cero o MÃ¡s ',0),(153683,4269,'de','Sollte NULL oder grÃ¶ÃŸer',0),(153684,4269,'en','Should be Zero or Greater',0),(153685,4270,'is','',0),(153686,4270,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø§Ø´ÙŠÙ† ',0),(153687,4270,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø§Ø´ÙŠÙ† ',0),(153688,4270,'tr','Makine bilgileri gÃ¼ncellemek',0),(153689,4270,'pl','Informacje na temat aktualizacji komputera',0),(153690,4270,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð½Ð¸ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(153691,4270,'ur','Ù…Ø´ÛŒÙ† Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(153692,4270,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(153693,4270,'vi','Cáº­p Nháº­t Chi Tiáº¿t MÃ¡y',0),(153694,4270,'af','Bywerking masjien besonderhede',0),(153695,4270,'ro','Detalii masina de actualizare',0),(153696,4270,'et','Masin VÃ¤rskendusteave',0),(153697,4270,'si','Posodobitev stroj podrobnosti',0),(153698,4270,'ba','Memperbarui rincian mesin',0),(153699,4270,'nl','Update Machine Details',0),(153700,4270,'fi','Koneen tiedot',0),(153701,4270,'no','Detaljer for maskinen',0),(153702,4270,'da','Opdatere maskine detaljer',0),(153703,4270,'ko','ì»´í“¨í„° ì„¸ë¶€ ì •ë³´ ì—…ë°ì´íŠ¸',0),(153704,4270,'he','×¢×“×›×•×Ÿ ×¤×¨×˜×™× ×”×ž×›×•× ×”',0),(153705,4270,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î¼Î·Ï‡Î±Î½Î®Î¼Î±Ï„Î¿Ï‚',0),(153706,4270,'zh','æ›´æ–°æœºè¯¦ç»†ä¿¡æ¯\r\n',0),(153707,4270,'sv','Uppdatera information om automaten',0),(153708,4270,'it','Aggiornare i dettagli della macchina',0),(153709,4270,'tl','',0),(153710,4270,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(153711,4270,'hi','à¤®à¤¶à¥€à¤¨ à¤µà¤¿à¤µà¤°à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(153712,4270,'ms','Butir-butir Mesin Kemaskini',0),(153713,4270,'ar','ØªØ­Ø¯ÙŠØ« ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¬Ù‡Ø§Ø²',0),(153714,4270,'fr','Mettre Ã  jour les dÃ©tails de la Machine',0),(153715,4270,'jp','æ©Ÿæ¢°è©³ç´°ã?®æ›´æ–°',0),(153716,4270,'pt','Atualizar detalhes da mÃ¡quina',0),(153717,4270,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´ÐµÑ‚Ð°Ð»ÐµÐ¹ Ð¼Ð°ÑˆÐ¸Ð½',0),(153718,4270,'es','Actualizar Detalles de MÃ¡quinas',0),(153719,4270,'de','Update Maschine Details',0),(153720,4270,'en','Update Machine Details',0),(153721,4271,'is','',0),(153722,4271,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø§Ø´ÙŠÙ†',0),(153723,4271,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø§Ø´ÙŠÙ†',0),(153724,4271,'tr','Makine bilgileri gÃ¼ncelleme',0),(153725,4271,'pl','Aktualizacja informacji o urzÄ…dzeniu',0),(153726,4271,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(153727,4271,'ur','Ù…Ø´ÛŒÙ† Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(153728,4271,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð½Ð°Ð´Ð¾Ð¿ÑƒÐ½Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(153729,4271,'vi','Cáº­p Nháº­t ThÃ´ng Tin MÃ¡y',0),(153730,4271,'af','Opdateer Masjien Inligting',0),(153731,4271,'ro','ActualizaÅ£i informaÅ£iile de maÅŸinÄƒ',0),(153732,4271,'et','Masin teabe vÃ¤rskendamine',0),(153733,4271,'si','Informacije o posodobitvi stroj',0),(153734,4271,'ba','Memperbarui informasi mesin',0),(153735,4271,'nl','Machine updategegevens',0),(153736,4271,'fi','PÃ¤ivitÃ¤ laitteen tietoja',0),(153737,4271,'no','Informasjon om maskinen',0),(153738,4271,'da','Opdatere maskine oplysninger',0),(153739,4271,'ko','ê¸°ê³„ ì •ë³´ ì—…ë°ì´íŠ¸',0),(153740,4271,'he','×¢×“×›×•×Ÿ ×”×ž×—×©×‘ ×ž×™×“×¢',0),(153741,4271,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ Î¼Î·Ï‡Î±Î½Î®',0),(153742,4271,'zh','æ›´æ–°è®¾å¤‡ä¿¡æ¯\r\n',0),(153743,4271,'sv','Uppdatera maskininformation',0),(153744,4271,'it','Aggiornare le informazioni della macchina',0),(153745,4271,'tl','',0),(153746,4271,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(153747,4271,'hi','à¤®à¤¶à¥€à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(153748,4271,'ms','Mengemaskini maklumat Mesin',0),(153749,4271,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¬Ù‡Ø§Ø²',0),(153750,4271,'fr','Mettre Ã  jour les informations de la Machine',0),(153751,4271,'jp','æ©Ÿæ¢°æƒ…å ±ã?®æ›´æ–°',0),(153752,4271,'pt','Atualizar informaÃ§Ãµes de mÃ¡quina',0),(153753,4271,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(153754,4271,'es','Actualizar Informacion de MÃ¡quinas',0),(153755,4271,'de','Update-Informationen',0),(153756,4271,'en','Update Machine Information',0),(153757,4272,'is','',0),(153758,4272,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯',0),(153759,4272,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯',0),(153760,4272,'tr','Yeni alt tÃ¼rÃ¼ Ekle',0),(153761,4272,'pl','Dodawanie nowego podtypu',0),(153762,4272,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(153763,4272,'ur','Ù†ÛŒØ§ Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(153764,4272,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð¿Ð¾Ð´Ð²Ñ€ÑÑ‚Ðµ',0),(153765,4272,'vi','ThÃªm Loáº¡i Phá»¥',0),(153766,4272,'af','Voeg \'n Nuwe Sub-tipe by',0),(153767,4272,'ro','Adauga o noua subcategorie',0),(153768,4272,'et','Lisada uue alamtÃ¼Ã¼bi',0),(153769,4272,'si','Dodaj nov podtip',0),(153770,4272,'ba','Menambahkan baru subtipe',0),(153771,4272,'nl','Toevoegen nieuw Subtype van het',0),(153772,4272,'fi','LisÃ¤tÃ¤Ã¤n uusi alatyyppi',0),(153773,4272,'no','Legge til nye undertypen',0),(153774,4272,'da','TilfÃ¸je nye undertype',0),(153775,4272,'ko','ìƒˆ í•˜ìœ„ ìœ í˜• ì¶”ê°€',0),(153776,4272,'he','×”×•×¡×£ ×¡×•×’ ×ž×©× ×” ×—×“×©',0),(153777,4272,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Ï…Ï€ÏŒÏ„Ï…Ï€Î¿',0),(153778,4272,'zh','å¢žåŠ æ–°å­ç±»åž‹\r\n',0),(153779,4272,'sv','LÃ¤gg till ny subtyp',0),(153780,4272,'it','Aggiungi nuovo sottotipo',0),(153781,4272,'tl','',0),(153782,4272,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;',0),(153783,4272,'hi','à¤¨à¤ˆ Subtype à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(153784,4272,'ms','Tambah Subtype baru',0),(153785,4272,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ ÙØ±Ø¹ÙŠ Ø¬Ø¯ÙŠØ¯',0),(153786,4272,'fr','Ajouter Nouvelle sous-type',0),(153787,4272,'jp','æ–°è¦?ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã?®è¿½åŠ ',0),(153788,4272,'pt','Adicionar novo subtipo',0),(153789,4272,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(153790,4272,'es','Agregar Nuevo Subtipo',0),(153791,4272,'de','FÃ¼gen neuen Subtyp hinzu',0),(153792,4272,'en','Add New Subtype',0),(153793,4273,'is','',0),(153794,4273,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¬Ø¯ÙŠØ¯',0),(153795,4273,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± Ø¬Ø¯ÙŠØ¯',0),(153796,4273,'tr','Yeni Worktype eklemek',0),(153797,4273,'pl','Dodaj nowÄ… Worktype',0),(153798,4273,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ Worktype',0),(153799,4273,'ur','Ù†Ø¦Û’ ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(153800,4273,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ WÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ',0),(153801,4273,'vi','ThÃªm Loáº¡i CÃ´ng Viá»‡c Má»›i',0),(153802,4273,'af','Voeg \'n Nuwe Werkstipe by',0),(153803,4273,'ro','Adauga un nou mod de lucru',0),(153804,4273,'et','Lisa uus Worktype',0),(153805,4273,'si','Dodajte nov Worktype',0),(153806,4273,'ba','Tambah Worktype baru',0),(153807,4273,'nl','Toevoegen van nieuwe Worktype',0),(153808,4273,'fi','LisÃ¤Ã¤ uusi Worktype',0),(153809,4273,'no','Legge til nye Worktype',0),(153810,4273,'da','TilfÃ¸je nye Worktype',0),(153811,4273,'ko','ìƒˆ Worktypeë¥¼ ì¶”ê°€',0),(153812,4273,'he','×”×•×¡×£ ×¡×•×’ ×¢×‘×•×“×” ×—×“×©',0),(153813,4273,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Worktype',0),(153814,4273,'zh','å¢žåŠ æ–°çš„å·¥ä½œç±»åž‹\r\n',0),(153815,4273,'sv','LÃ¤gg till nya Worktype',0),(153816,4273,'it','Aggiungi nuovo Worktype',0),(153817,4273,'tl','',0),(153818,4273,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(153819,4273,'hi','à¤¨à¤ˆ Worktype à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(153820,4273,'ms','Menambah Worktype baru',0),(153821,4273,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ Ø¬Ø¯ÙŠØ¯Ø©',0),(153822,4273,'fr','Ajouter Nouveau type de travaille',0),(153823,4273,'jp','æ–°è¦?ä»•äº‹å†…å®¹ã?®è¿½åŠ ',0),(153824,4273,'pt','Adicionar novo Worktype',0),(153825,4273,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(153826,4273,'es','Agregar Nuevo Tipo de Trabajo',0),(153827,4273,'de','Neuen Worktype hinzufÃ¼gen',0),(153828,4273,'en','Add New Worktype',0),(153829,4274,'is','',0),(153830,4274,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(153831,4274,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(153832,4274,'tr','Worktype Ekle',0),(153833,4274,'pl','Dodaj Worktype',0),(153834,4274,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Worktype',0),(153835,4274,'ur','ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(153836,4274,'sr','Ð”Ð¾Ð´Ð°Ñ˜ WÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ',0),(153837,4274,'vi','ThÃªm Loáº¡i CÃ´ng Viá»‡c',0),(153838,4274,'af','Werktipe Byvoeg',0),(153839,4274,'ro','Adauga Worktype',0),(153840,4274,'et','Lisada Worktype',0),(153841,4274,'si','Dodaj Worktype',0),(153842,4274,'ba','Tambahkan Worktype',0),(153843,4274,'nl','Worktype toevoegen',0),(153844,4274,'fi','LisÃ¤Ã¤ Worktype',0),(153845,4274,'no','Legge til Worktype',0),(153846,4274,'da','TilfÃ¸j Worktype',0),(153847,4274,'ko','Worktype ì¶”ê°€',0),(153848,4274,'he','×”×•×¡×¤×ª Worktype',0),(153849,4274,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Worktype',0),(153850,4274,'zh','å¢žåŠ å·¥ä½œç±»åž‹\r\n',0),(153851,4274,'sv','LÃ¤gg till Worktype',0),(153852,4274,'it','Aggiungi Worktype',0),(153853,4274,'tl','',0),(153854,4274,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;',0),(153855,4274,'hi','Worktype à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(153856,4274,'ms','Tambah Worktype',0),(153857,4274,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ',0),(153858,4274,'fr','Ajouter Association',0),(153859,4274,'jp','ä»•äº‹å†…å®¹ã?®è¿½åŠ ',0),(153860,4274,'pt','Adicionar Worktype',0),(153861,4274,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(153862,4274,'es','Agregar Tipo de Trabajo',0),(153863,4274,'de','Worktype hinzufÃ¼gen',0),(153864,4274,'en','Add Worktype',0),(153865,4275,'is','',0),(153866,4275,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(153867,4275,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(153868,4275,'tr','Worktype ayrÄ±ntÄ±larÄ± ekleme',0),(153869,4275,'pl','Dodaj szczegÃ³Å‚y Worktype',0),(153870,4275,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÑ‚Ðµ Worktype Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸',0),(153871,4275,'ur','ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(153872,4275,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ WÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(153873,4275,'vi','ThÃªm Chi Tiáº¿t Loáº¡i CÃ´ng Viá»‡c ',0),(153874,4275,'af','Voeg Worktype besonderhede',0),(153875,4275,'ro','Adauga Worktype detalii',0),(153876,4275,'et','Lisa Worktype andmed',0),(153877,4275,'si','Dodaj Worktype podrobnosti',0),(153878,4275,'ba','Menambahkan rincian Worktype',0),(153879,4275,'nl','Voeg Worktype Details',0),(153880,4275,'fi','LisÃ¤Ã¤ Worktype tiedot',0),(153881,4275,'no','Legge til Worktype detaljer',0),(153882,4275,'da','TilfÃ¸j Worktype detaljer',0),(153883,4275,'ko','Worktype ì„¸ë¶€ ì‚¬í•­ ì¶”ê°€',0),(153884,4275,'he','×œ×”×•×¡×™×£ ×¤×¨×˜×™× Worktype',0),(153885,4275,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Worktype',0),(153886,4275,'zh','å¢žåŠ å·¥ä½œç±»åž‹è¯¦ç»†ä¿¡æ¯\r\n',0),(153887,4275,'sv','LÃ¤gg till Worktype Detaljer',0),(153888,4275,'it','Aggiungi Worktype dettagli',0),(153889,4275,'tl','',0),(153890,4275,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;',0),(153891,4275,'hi','Worktype à¤µà¤¿à¤µà¤°à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(153892,4275,'ms','Tambah butiran Worktype',0),(153893,4275,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ',0),(153894,4275,'fr','Ajouter des dÃ©tails de lâ€™Association',0),(153895,4275,'jp','ä»•äº‹å†…å®¹è©³ç´°ã?®è¿½åŠ ',0),(153896,4275,'pt','Adicionar detalhes de Worktype',0),(153897,4275,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð¢Ð¸Ð¿Ð° Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(153898,4275,'es','Agregar Detalles del Tipo de Trabajo ',0),(153899,4275,'de','Worktype Details hinzufÃ¼gen',0),(153900,4275,'en','Add Worktype Details',0),(153901,4276,'is','',0),(153902,4276,'dr','Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯ ÙØ±Ø¹ÙŠ Ø¨Ø³ØªÙ‡ Ø´ÙˆØ¯',0),(153903,4276,'pr','Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯ ÙØ±Ø¹ÙŠ Ø¨Ø³ØªÙ‡ Ø´ÙˆØ¯',0),(153904,4276,'tr','TaÅŸeron',0),(153905,4276,'pl','MogÄ… byÄ‡ wykonywane przez podwykonawcÃ³w',0),(153906,4276,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ÐµÐ½ Ð·Ð° Ð¿Ð¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(153907,4276,'ur','Ø³Ø¨Ú©ÙˆÙ†Ù¹Ø±Ø§Ú©Ù¹Ø¯ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ ÛÛ’',0),(153908,4276,'sr','ÐœÐ¾Ð³Ñƒ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÐ¿ÑƒÑÑ‚Ð¸Ð»Ð°',0),(153909,4276,'vi','KhÃ´ng cho tháº§u phá»¥',0),(153910,4276,'af','Subcontracted kan word',0),(153911,4276,'ro','Pot fi subcontractate',0),(153912,4276,'et','VÃµimalik alltÃ¶Ã¶vÃµtu',0),(153913,4276,'si','Lahko podizvajalcev',0),(153914,4276,'ba','Dapat subkontrak',0),(153915,4276,'nl','Kan worden uitbesteed',0),(153916,4276,'fi','Voidaan siirtÃ¤Ã¤ alihankintana',0),(153917,4276,'no','Kan vÃ¦re underleveranser',0),(153918,4276,'da','Kan blive givet i underentreprise',0),(153919,4276,'ko','ì•„ë‹ˆ ê²  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(153920,4276,'he','×™×›×•×œ ×œ×”×™×•×ª ×§×‘×œ× ×™ ×ž×©× ×”',0),(153921,4276,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î½Î± Î´Î¿Î¸ÎµÎ¯ Ï‰Ï‚ Ï…Ï€ÎµÏÎ³Î¿Î»Î±Î²Î¯Î±',0),(153922,4276,'zh','å¯è½¬åŒ…\r\n',0),(153923,4276,'sv','Kan bli utlagt',0),(153924,4276,'it','PuÃ² essere subappaltato',0),(153925,4276,'tl','',0),(153926,4276,'th','&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3626;&#3633;&#3597;&#3597;&#3634;&#3618;&#3656;&#3629;&#3618;&#3652;&#3604;&#3657;&#3652;&#3627;&#3617;',0),(153927,4276,'hi','Subcontracted à¤¹à¥‹ à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(153928,4276,'ms','Boleh kerja',0),(153929,4276,'ar','ÙŠÙ…ÙƒÙ† Ø£Ù† ÙŠÙƒÙˆÙ† Ø§Ù„ØªØ¹Ø§Ù‚Ø¯ Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù†',0),(153930,4276,'fr','Peut Ãªtre sous-traitÃ©',0),(153931,4276,'jp','ä¸‹è«‹ã?‘å?¯èƒ½',0),(153932,4276,'pt','Pode ser subcontratado',0),(153933,4276,'ru','ÐœÐ¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ ÑÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´Ð°',0),(153934,4276,'es','Se puede estar Sub-Contratado',0),(153935,4276,'de','KÃ¶nnen vergeben werden',0),(153936,4276,'en','Can be Subcontracted',0),(153937,4277,'is','',0),(153938,4277,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ù‡  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø§ÙŠÙ† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¯Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯',0),(153939,4277,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ù‡  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø§ÙŠÙ† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¯Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯',0),(153940,4277,'tr','KaÄŸÄ±t stok malzeme bu alt kategorilerini kullanabilirsiniz',0),(153941,4277,'pl','MoÅ¼na uÅ¼yÄ‡ kategorii ksiÄ™gi zapasÃ³w materiaÅ‚Ã³w tego podtypu',0),(153942,4277,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð½Ð° Ñ…Ð°Ñ€Ñ‚Ð¸Ñ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ñ‚Ð¾Ð·Ð¸ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(153943,4277,'ur','Ú©Ø§ØºØ° Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…ÙˆØ§Ø¯ Ø§Ø³ Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù… Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(153944,4277,'sr','ÐœÐ¾Ð¶ÐµÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð¿Ð°Ð¿Ð¸Ñ€ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð° Ð¾Ð²Ð°Ñ˜ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(153945,4277,'vi','CÃ³ thá» sá»­ dá»¥ng NhÃ³m HÃ ng Giáº¥y Thá»ƒ Loáº¡i nÃ y',0),(153946,4277,'af','KategoriÃ« van Papier Voorraad Materiale wat hierdie Sub-tipe kan Gebruik',0),(153947,4277,'ro','Categorii de materiale de inventar hÃ¢rtie acest subtip pot folosi',0),(153948,4277,'et','Raamatus lao materjalide alamliigist tulenev kategooriad saab kasutada',0),(153949,4277,'si','Lahko uporabite kategorije papir zaloge materialov ta podtip',0),(153950,4277,'ba','Jenis kertas persediaan bahan subtipe ini dapat menggunakan',0),(153951,4277,'nl','Soorten papier inventaris stoffen deze Subtype kunnen gebruiken',0),(153952,4277,'fi','Varaston paperimateriaalien tÃ¤mÃ¤ alatyyppi luokka kÃ¤yttÃ¤Ã¤',0),(153953,4277,'no','Kategorier av papir lager materialer denne undertypen kan bruke',0),(153954,4277,'da','Kategorier af papir opgÃ¸relse materialer denne undertype kan bruge',0),(153955,4277,'ko','ì¢…ì´ ìž¬ê³  ìžë£Œê°€ì´ í•˜ìœ„ ë²”ì£¼ë¥¼ ì‚¬ìš©í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(153956,4277,'he','×§×˜×’×•×¨×™×•×ª ×©×œ × ×™×™×¨ ×ž×œ××™ ×—×•×ž×¨×™× ×ª×ª-×¡×•×’ ×–×” × ×™×ª×Ÿ ×œ×”×©×ª×ž×©',0),(153957,4277,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Ï…Î»Î¹ÎºÏŽÎ½ Î±Ï€Î¿Î³ÏÎ±Ï†Î® Ï‡Î±ÏÏ„Î¯ Î±Ï…Ï„ÏŒÏ‚ Î¿ Ï…Ï€ÏŒÏ„Ï…Ï€Î¿Ï‚ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ',0),(153958,4277,'zh','çº¸å¼ çš„åº“å­˜ææ–™åˆ†ç±»è¿™ä¸€äºšåž‹å¯ä»¥ä½¿ç”¨\r\n',0),(153959,4277,'sv','Kategorier av papper lager material denna subtyp kan anvÃ¤nda',0),(153960,4277,'it','Categorie di materiali cartacei di inventario questo sottotipo possono utilizzare',0),(153961,4277,'tl','',0),(153962,4277,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3586;&#3629;&#3591;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625; &#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629; &#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&',0),(153963,4277,'hi','à¤•à¤¾à¤—à¤œ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤‡à¤¸ Subtype à¤•à¥€ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(153964,4277,'ms','Kategori kertas inventori bahan Subtype ini boleh menggunakan',0),(153965,4277,'ar','ÙŠÙ…ÙƒÙ† Ø§Ø³ØªØ®Ø¯Ø§Ù… ÙØ¦Ø§Øª Ù…Ù† \"Ø§Ù„ÙˆØ±Ù‚Ø© Ù…ÙˆØ§Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†\" Ù‡Ø°Ø§ Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(153966,4277,'fr','CatÃ©gories de matiÃ¨res de l\'inventaire papier ce sous-type peuvent utiliser',0),(153967,4277,'jp','ã?“ã?®ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã?®ç´™åœ¨åº«æ??æ–™ã?®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œä½¿ç”¨ã?§ã??ã‚‹ã?®ã?¯',0),(153968,4277,'pt','Categorias de materiais de estoque de papel este subtipo podem usar',0),(153969,4277,'ru','ÐœÐ¾Ð¶Ð½Ð¾ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð² ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(153970,4277,'es','CategorÃ­as de Inventario de Materiales de Papel este Subtipo puede usar',0),(153971,4277,'de','Kategorien von Inventar Papierwerkstoffe dieser Subtyp kÃ¶nnen',0),(153972,4277,'en','Categories of Paper Inventory Materials this Subtype can Use',0),(153973,4278,'is','',0),(153974,4278,'dr','Ø­Ø°Ù ',0),(153975,4278,'pr','Ø­Ø°Ù ',0),(153976,4278,'tr','Del',0),(153977,4278,'pl','Del',0),(153978,4278,'bg','Ð”ÐµÐ»',0),(153979,4278,'ur','ÚˆÛŒÙ„',0),(153980,4278,'sr','Ð”ÐµÐ»',0),(153981,4278,'vi','XÃ³a',0),(153982,4278,'af','Skrap',0),(153983,4278,'ro','Del',0),(153984,4278,'et','Del',0),(153985,4278,'si','Del',0),(153986,4278,'ba','Del',0),(153987,4278,'nl','Del',0),(153988,4278,'fi','Del',0),(153989,4278,'no','Del',0),(153990,4278,'da','Del',0),(153991,4278,'ko','ë¸',0),(153992,4278,'he','×“×œ',0),(153993,4278,'el','Del',0),(153994,4278,'zh','åˆ é™¤\r\n',0),(153995,4278,'sv','Del',0),(153996,4278,'it','Del',0),(153997,4278,'tl','',0),(153998,4278,'th','&#3621;&#3610;',0),(153999,4278,'hi','Del',0),(154000,4278,'ms','Del',0),(154001,4278,'ar','Ø¯ÙŠÙ„',0),(154002,4278,'fr','Del',0),(154003,4278,'jp','æ¶ˆåŽ»',0),(154004,4278,'pt','Del',0),(154005,4278,'ru','Ð”ÐµÐ»ÑŒ',0),(154006,4278,'es','Elim',0),(154007,4278,'de','Del',0),(154008,4278,'en','Del',0),(154009,4279,'is','',0),(154010,4279,'dr','Ø´Ø±Ø­ Ø¯Ø± Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù¾ÙŠØ¯Ø§ Ù†Ù…ÙŠ Ø´ÙˆØ¯ ',0),(154011,4279,'pr','Ø´Ø±Ø­ Ø¯Ø± Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù¾ÙŠØ¯Ø§ Ù†Ù…ÙŠ Ø´ÙˆØ¯ ',0),(154012,4279,'tr','AÃ§Ä±klama iÃ§inde alt tÃ¼rÃ¼ eksik',0),(154013,4279,'pl','Opis brakuje w podtypie',0),(154014,4279,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð² Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154015,4279,'ur','ØªØµØ±ÛŒØ­ Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… Ù…ÛŒÚº ØºØ§Ø¦Ø¨ ÛÛ’',0),(154016,4279,'sr','ÐžÐ¿Ð¸Ñ Ñ˜Ðµ Ð½ÐµÑÑ‚Ð°Ð¾ Ñƒ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154017,4279,'vi','Thiáº¿u mÃ´ táº£ loáº¡i phá»¥',0),(154018,4279,'af','Beskrywing word vermis in subtype',0),(154019,4279,'ro','Descriere lipseÅŸte Ã®n subtip',0),(154020,4279,'et','Kirjeldus puudub alatÃ¼Ã¼p',0),(154021,4279,'si','Opis manjka v podtip',0),(154022,4279,'ba','Deskripsi hilang dalam subtipe',0),(154023,4279,'nl','Beschrijving ontbreekt in subtype',0),(154024,4279,'fi','Kuvaus puuttuu alatyyppi',0),(154025,4279,'no','Beskrivelse mangler i undertype',0),(154026,4279,'da','Beskrivelse er mangler i undertype',0),(154027,4279,'ko','ì„¤ëª… í•˜ìœ„ì—ì„œ ëˆ„ë½ ëœ',0),(154028,4279,'he','×ª×™××•×¨ ×—×¡×¨ ×‘×¡×•×’',0),(154029,4279,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î»ÎµÎ¯Ï€ÎµÎ¹ ÏƒÎµ Ï…Ï€ÏŒÏ„Ï…Ï€Î¿',0),(154030,4279,'zh','è¯´æ˜Žä¸­ç¼ºå°‘äºšåž‹\r\n',0),(154031,4279,'sv','Beskrivning saknas i subtyp',0),(154032,4279,'it','Descrizione manca nel sottotipo',0),(154033,4279,'tl','',0),(154034,4279,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;',0),(154035,4279,'hi','à¤µà¤¿à¤µà¤°à¤£ subtype à¤®à¥‡à¤‚ à¤—à¥à¤® à¤¹à¥ˆ',0),(154036,4279,'ms','Keterangan yang hilang dalam subtype',0),(154037,4279,'ar','ÙˆØµÙ Ù…ÙÙ‚ÙˆØ¯ ÙÙŠ Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(154038,4279,'fr','Description est manquante dans le sous-type',0),(154039,4279,'jp','ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã?«è§£èª¬ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(154040,4279,'pt','DescriÃ§Ã£o estÃ¡ falta no subtipo',0),(154041,4279,'ru','Ð’ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(154042,4279,'es','DescripciÃ³n es faltante en el Subtipo',0),(154043,4279,'de','Beschreibung fehlt Untertyp',0),(154044,4279,'en','Description is missing in subtype',0),(154045,4280,'is','',0),(154046,4280,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(154047,4280,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(154048,4280,'tr','DÃ¼zenleme',0),(154049,4280,'pl','Edycji',0),(154050,4280,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(154051,4280,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Ø§Ø±ÛŒ',0),(154052,4280,'sr','Ð—Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(154053,4280,'vi','Äang Chá»‰nh Sá»­a',0),(154054,4280,'af','Redigeering',0),(154055,4280,'ro','Editare',0),(154056,4280,'et','Muutmine',0),(154057,4280,'si','Urejanje',0),(154058,4280,'ba','Mengedit',0),(154059,4280,'nl','Bewerken',0),(154060,4280,'fi','Muokkaaminen',0),(154061,4280,'no','Redigering',0),(154062,4280,'da','Redigering',0),(154063,4280,'ko','íŽ¸ì§‘',0),(154064,4280,'he','×¢×¨×™×›×”',0),(154065,4280,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(154066,4280,'zh','ç¼–è¾‘\r\n',0),(154067,4280,'sv','Redigering',0),(154068,4280,'it','Modifica',0),(154069,4280,'tl','',0),(154070,4280,'th','&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(154071,4280,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(154072,4280,'ms','Penyuntingan',0),(154073,4280,'ar','ØªØ­Ø±ÙŠØ±',0),(154074,4280,'fr','Ã‰dition',0),(154075,4280,'jp','ç·¨é›†',0),(154076,4280,'pt','EdiÃ§Ã£o',0),(154077,4280,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(154078,4280,'es','Editando',0),(154079,4280,'de','Bearbeiten',0),(154080,4280,'en','Editing',0),(154081,4281,'is','',0),(154082,4281,'dr','( ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ ) Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ø§ÙŠÙ† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(154083,4281,'pr','ØªÙˆØ§Ø¨Ø¹ ( ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ ) Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ø§ÙŠÙ† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(154084,4281,'tr','Aile iÅŸlevleri bu alt tÃ¼r kullanabilirsiniz',0),(154085,4281,'pl','MoÅ¼na uÅ¼ywaÄ‡ rodziny funkcji tego podtypu',0),(154086,4281,'bg','Ð¡ÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ñ‚Ð¾Ð·Ð¸ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚',0),(154087,4281,'ur','Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Û’ Ø§ÙØ¹Ø§Ù„ Ø§Ø³ Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(154088,4281,'sr','ÐŸÐ¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ Ð¾Ð²Ð°Ñ˜ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸.',0),(154089,4281,'vi','Chá»©c nÄƒng Gia ÄÃ¬nh dÃ¹ng cho loáº¡i nÃ y cÃ³ thá»ƒ sá»­ dá»¥ng',0),(154090,4281,'af','Familie funksies hierdie Subtype gebruik kan',0),(154091,4281,'ro','PuteÅ£i utiliza funcÅ£iile familiei acest subtip',0),(154092,4281,'et','Perekonna funktsioonid alamliigist tulenev saab kasutada',0),(154093,4281,'si','Lahko uporabite funkcije druÅ¾ine te podvrste',0),(154094,4281,'ba','Keluarga fungsi subtipe ini dapat menggunakan',0),(154095,4281,'nl','Familie functies deze Subtype kunnen gebruiken',0),(154096,4281,'fi','Perhejuhlia tÃ¤mÃ¤ alatyyppi voi kÃ¤yttÃ¤Ã¤',0),(154097,4281,'no','Familien funksjoner denne undertypen kan bruke',0),(154098,4281,'da','Familiens funktioner denne undertype kan bruge',0),(154099,4281,'ko','ê°€ì¡± ê¸°ëŠ¥ì´ í•˜ìœ„ì´ ìœ í˜•ì„ ì‚¬ìš©í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(154100,4281,'he','×ž×©×¤×—×ª ×¤×•× ×§×¦×™×•×ª ×ª×ª-×¡×•×’ ×–×” × ×™×ª×Ÿ ×œ×”×©×ª×ž×©',0),(154101,4281,'el','ÎŸÎ¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ® Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚ Î±Ï…Ï„ÏŒÏ‚ Î¿ Ï…Ï€ÏŒÏ„Ï…Ï€Î¿Ï‚ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ',0),(154102,4281,'zh','å®¶åº­çš„åŠŸèƒ½è¿™ä¸€äºšåž‹å¯ä»¥ä½¿ç”¨\r\n',0),(154103,4281,'sv','Familj funktioner denna subtyp kan anvÃ¤nda',0),(154104,4281,'it','Famiglie funzioni questo sottotipo possono utilizzare',0),(154105,4281,'tl','',0),(154106,4281,'th','&#3627;&#3609;&#3657;&#3634;&#3607;&#3637;&#3656;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;&#3609;&#3637;&#3657;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;',0),(154107,4281,'hi','à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤‡à¤¸ Subtype à¤«à¤¼à¤‚à¤•à¥à¤¶à¤‚à¤¸ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(154108,4281,'ms','Fungsi-fungsi keluarga Subtype ini boleh menggunakan',0),(154109,4281,'ar','ÙŠÙ…ÙƒÙ† Ø§Ø³ØªØ®Ø¯Ø§Ù… ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø£Ø³Ø±Ø© Ù‡Ø°Ø§ Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(154110,4281,'fr','Fonctions familiales ce sous-type peuvent utiliser',0),(154111,4281,'jp','ã?“ã?®ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã?®ç³»çµ±æ©Ÿèƒ½ã?Œä½¿ç”¨ã?§ã??ã‚‹ã?®ã?¯',0),(154112,4281,'pt','FamÃ­lia funÃ§Ãµes este subtipo podem usar',0),(154113,4281,'ru','ÐœÐ¾Ð¶Ð½Ð¾ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ ÑÐµÐ¼ÑŒÐ¸ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154114,4281,'es','Funciones de Familia este Subtipo puede utilizar',0),(154115,4281,'de','Familienfeiern dieser Subtyp kÃ¶nnen',0),(154116,4281,'en','Family Functions this Subtype can Use',0),(154117,4282,'is','',0),(154118,4282,'dr','ÙƒØ§Ù„Ø§ Ø¨Ø§ Ø§ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø·Ø¹Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(154119,4282,'pr','ÙƒØ§Ù„Ø§ Ø¨Ø§ Ø§ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø·Ø¹Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(154120,4282,'tr','ParÃ§a numarasÄ± ile Ã¶ÄŸe bulunamadÄ±',0),(154121,4282,'pl','Nie odnaleziono elementu z numerem',0),(154122,4282,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½ Ñ Ð¿Ð°Ñ€Ñ‚Ð¸Ð´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(154123,4282,'ur','Ø­ØµÛ Ù†Ù…Ø¨Ø± Ú©Û’ Ø³Ø§ØªÚ¾ Ø´Û’ Ù†ÛÛŒÚº Ù…Ù„ÛŒ ØªÚ¾ÛŒ',0),(154124,4282,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° ÑÐ° Ð±Ñ€Ð¾Ñ˜Ð° Ð´ÐµÐ»Ð°',0),(154125,4282,'vi','HÃ ng vá»›i sá»‘ phá»¥ tÃ¹ng khÃ´ng tÃ¬m tháº¥y',0),(154126,4282,'af','Items met onderdeelnommer was nie gevind',0),(154127,4282,'ro','Elementul nu a fost gÄƒsit cu numÄƒrul de componentÄƒ',0),(154128,4282,'et','Ãœksust ei leitud osa number',0),(154129,4282,'si','Elementa ni bilo mogoÄe najti s Å¡tevilko dela',0),(154130,4282,'ba','Barang tidak ditemukan dengan nomor bagian',0),(154131,4282,'nl','Object is niet gevonden met onderdeelnummer',0),(154132,4282,'fi','Kohdetta ei lÃ¶ytynyt tuotenumerolla',0),(154133,4282,'no','Elementet ble ikke funnet med delenummer',0),(154134,4282,'da','Elementet blev ikke fundet med reservedelsnummer',0),(154135,4282,'ko','ë¶€í’ˆ ë²ˆí˜¸ë¥¼ ê°€ì§„ í•­ëª©ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(154136,4282,'he','×”×¤×¨×™×˜ ×œ× × ×ž×¦××” ×¢× ×ž×¡×¤×¨ ×—×œ×§',0),(154137,4282,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ Î¼Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î¼ÎµÏÏŽÎ½',0),(154138,4282,'zh','é¡¹ç›®æ²¡æœ‰ä¸Žé›¶ä»¶ç¼–å·ä¸€åŒå‘çŽ°\r\n',0),(154139,4282,'sv','Objektet hittades inte med artikelnummer',0),(154140,4282,'it','Elemento non Ã¨ stato trovato con numero parte',0),(154141,4282,'tl','',0),(154142,4282,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3633;&#3610;&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;',0),(154143,4282,'hi','à¤­à¤¾à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(154144,4282,'ms','Item tidak dapat ditemui dengan sebahagian jumlah',0),(154145,4282,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ù†ØµØ± Ù…Ø¹ Ø±Ù‚Ù… Ø§Ù„Ø¬Ø²Ø¡',0),(154146,4282,'fr','Point n\'a pas Ã©tÃ© trouvÃ© avec le numÃ©ro de piÃ¨ce',0),(154147,4282,'jp','éƒ¨å“?ç•ªå?·ã?§ã?¯å“?ç›®ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(154148,4282,'pt','Item nÃ£o foi encontrado com o nÃºmero da peÃ§a',0),(154149,4282,'ru','Ð¢Ð¾Ð²Ð°Ñ€ Ð¿Ð¾ Ñ‡Ð°ÑÑ‚Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ðµ Ð±Ñ‹Ð» Ð½Ð°Ð¹Ð´ÐµÐ½',0),(154150,4282,'es','Item no se encontrÃ³ con nÃºmero de parte',0),(154151,4282,'de','Element wurde nicht gefunden mit der Teilenummer',0),(154152,4282,'en','Item was not found with part number',0),(154153,4283,'is','',0),(154154,4283,'dr','Ù†Ø§Ù… Ø¯Ø± Ù†ÙˆØ¹ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(154155,4283,'pr','Ù†Ø§Ù… Ø¯Ø± Ù†ÙˆØ¹ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(154156,4283,'tr','Ad iÃ§inde alt tÃ¼rÃ¼ eksik',0),(154157,4283,'pl','Brakuje nazwy w podtypie',0),(154158,4283,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° Ð¸Ð¼ÐµÑ‚Ð¾ Ð² Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154159,4283,'ur','Ù†Ø§Ù… Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… Ù…ÛŒÚº ØºØ§Ø¦Ø¨ ÛÛ’',0),(154160,4283,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ð¸Ð¼Ðµ Ñƒ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154161,4283,'vi','Thiáº¿u tÃªn trong loáº¡i phá»¥',0),(154162,4283,'af','Naam is vermis in sub-tipe',0),(154163,4283,'ro','LipseÈ™te numele Ã®n subtip',0),(154164,4283,'et','Nimi puudub alatÃ¼Ã¼p',0),(154165,4283,'si','Manjka ime v podtip',0),(154166,4283,'ba','Nama hilang dalam subtipe',0),(154167,4283,'nl','Naam ontbreekt in subtype',0),(154168,4283,'fi','Nimi puuttuu alatyyppi',0),(154169,4283,'no','Navnet mangler i undertype',0),(154170,4283,'da','Navn mangler i undertype',0),(154171,4283,'ko','ì´ë¦„ì´ í•˜ìœ„ í˜•ì‹ì— ì—†ìŠµë‹ˆë‹¤.',0),(154172,4283,'he','×”×©× ×—×¡×¨ ×‘×¡×•×’',0),(154173,4283,'el','Î›ÎµÎ¯Ï€ÎµÎ¹ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± ÏƒÎµ Ï…Ï€ÏŒÏ„Ï…Ï€Î¿',0),(154174,4283,'zh','åç§°ä¸­ç¼ºå°‘äºšåž‹\r\n',0),(154175,4283,'sv','Namn saknas i subtyp',0),(154176,4283,'it','Manca il nome nel sottotipo',0),(154177,4283,'tl','',0),(154178,4283,'th','&#3594;&#3639;&#3656;&#3629;&#3617;&#3637;&#3588;&#3623;&#3634;&#3617;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;',0),(154179,4283,'hi','à¤¨à¤¾à¤® subtype à¤®à¥‡à¤‚ à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§ à¤¹à¥ˆ',0),(154180,4283,'ms','Nama yang hilang dalam subtype',0),(154181,4283,'ar','Ø§Ø³Ù… Ù…ÙÙ‚ÙˆØ¯ ÙÙŠ Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(154182,4283,'fr','Nom est manquant dans le sous-type',0),(154183,4283,'jp','ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã?«å??å‰?ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(154184,4283,'pt','Nome estÃ¡ faltando no subtipo',0),(154185,4283,'ru','Ð˜Ð¼Ñ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð² Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154186,4283,'es','Nombre falta en el subtipo',0),(154187,4283,'de','Name fehlt Untertyp',0),(154188,4283,'en','Name is missing in subtype',0),(154189,4284,'is','',0),(154190,4284,'dr','Ù†Ø§Ù… Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(154191,4284,'pr','Ù†Ø§Ù… Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(154192,4284,'tr','DeÄŸil verilen ad',0),(154193,4284,'pl','Nie podano nazwy',0),(154194,4284,'bg','Ð˜Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ð½Ðµ',0),(154195,4284,'ur','Ú©Ø§ Ù†Ø§Ù… Ù†ÛÛŒÚº Ø¯ÛŒØ§',0),(154196,4284,'sr','ÐÐ¸Ñ˜Ðµ Ð´Ð°Ñ‚Ð¾ Ð¸Ð¼Ðµ',0),(154197,4284,'vi','ChÆ°a cho tÃªn',0),(154198,4284,'af','Naam nie gegee',0),(154199,4284,'ro','Numele nu a dat',0),(154200,4284,'et','Nime ei antud',0),(154201,4284,'si','Ime ni',0),(154202,4284,'ba','Tidak diberi nama',0),(154203,4284,'nl','Naam niet gegeven',0),(154204,4284,'fi','NimeÃ¤ ei mÃ¤Ã¤ritetty',0),(154205,4284,'no','Navnet ikke',0),(154206,4284,'da','Navn ikke givet',0),(154207,4284,'ko','ì´ë¦„ì„ ë¶€ì—¬ í•˜ì§€',0),(154208,4284,'he','×©× ×œ× × ×™×ª× ×”',0),(154209,4284,'el','Î”ÎµÎ½ Î´ÏŒÎ¸Î·ÎºÎµ ÏŒÎ½Î¿Î¼Î±',0),(154210,4284,'zh','åç§°æ²¡æœ‰ç»™\r\n\r\nType text or a website address or translate a document.\r\nCancel\r\nListenRead phonetically\r\nEnglish to Chinese (Simplified) translation\r\nåç§°æ²¡æœ‰ç»™å‡º\r\n',0),(154211,4284,'sv','Namn som inte',0),(154212,4284,'it','Nome non dato',0),(154213,4284,'tl','',0),(154214,4284,'th','&#3652;&#3617;&#3656;&#3649;&#3626;&#3604;&#3591;&#3594;&#3639;&#3656;&#3629;',0),(154215,4284,'hi','à¤¨à¤¾à¤® à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤¯à¤¾',0),(154216,4284,'ms','Nama yang tidak diberi',0),(154217,4284,'ar','Ø§Ù„Ø§Ø³Ù… Ù†Ø¸Ø±Ø§Ù‹ Ù„Ø¹Ø¯Ù…',0),(154218,4284,'fr','Nom ne pas donnÃ©',0),(154219,4284,'jp','å??å‰?ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(154220,4284,'pt','Nome dado nÃ£o',0),(154221,4284,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐÐµ Ð”Ð°Ð½Ð¾',0),(154222,4284,'es','No se diÃ³ el Nombre',0),(154223,4284,'de','Name nicht gegeben',0),(154224,4284,'en','Name not given',0),(154225,4285,'is','',0),(154226,4285,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø³Ù…Øª ',0),(154227,4285,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø³Ù…Øª ',0),(154228,4285,'tr','ParÃ§a No.',0),(154229,4285,'pl','Nr zam.',0),(154230,4285,'bg','Ð§Ð°ÑÑ‚ Ð½Ð¾Ð¼ÐµÑ€',0),(154231,4285,'ur','Ø­ØµÛ Ù†Ù…Ø¨Ø±',0),(154232,4285,'sr','Ð‘Ñ€.',0),(154233,4285,'vi','Sá»‘ phá»¥ tÃ¹ng',0),(154234,4285,'af','Onderdeel No.',0),(154235,4285,'ro','Cod',0),(154236,4285,'et','Osa nr.',0),(154237,4285,'si','Del Å¡t.',0),(154238,4285,'ba','Bahagian No.',0),(154239,4285,'nl','Deel nr.',0),(154240,4285,'fi','OSANRO',0),(154241,4285,'no','Nr.',0),(154242,4285,'da','Varenr.',0),(154243,4285,'ko','ë¶€í’ˆ ë²ˆí˜¸',0),(154244,4285,'he','×—×œ×§ ×ž×¡×¤×¨',0),(154245,4285,'el','Î‘Ï.',0),(154246,4285,'zh','éƒ¨ä»¶å·\r\n',0),(154247,4285,'sv','Kat.nr.',0),(154248,4285,'it','N. di parte',0),(154249,4285,'tl','',0),(154250,4285,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3626;&#3656;&#3623;&#3609;',0),(154251,4285,'hi','à¤­à¤¾à¤— à¤¸à¤‚',0),(154252,4285,'ms','Bahagian No.',0),(154253,4285,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¬Ø²Ø¡',0),(154254,4285,'fr','RÃ©fÃ©rence no.',0),(154255,4285,'jp','éƒ¨å“?ç•ªå?·',0),(154256,4285,'pt','Parte n. Âº',0),(154257,4285,'ru','ÐÑ€Ñ‚.ÐÑ€.',0),(154258,4285,'es','Nu. de Parte',0),(154259,4285,'de','Art.-Nr.',0),(154260,4285,'en','Part No.',0),(154261,4286,'is','',0),(154262,4286,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ø²ÙŠØ± Ù†Ù…ÙˆÙ†Ù‡ Ú¯Ù… Ù…ÙŠ Ø´ÙˆØ¯ ',0),(154263,4286,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ø²ÙŠØ± Ù†Ù…ÙˆÙ†Ù‡ Ú¯Ù… Ù…ÙŠ Ø´ÙˆØ¯ ',0),(154264,4286,'tr','Alt tÃ¼r, eksik miktar olduÄŸunu',0),(154265,4286,'pl','IloÅ›Ä‡ jest brak w podtypie',0),(154266,4286,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ðµ Ð»Ð¸Ð¿ÑÐ²Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð² Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154267,4286,'ur','ØªØ¹Ø¯Ø§Ø¯ Ù…ÛŒÚº Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… ØºØ§Ø¦Ø¨ ÛÛ’ Û”',0),(154268,4286,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜Ðµ ÐºÐ°Ñ€Ð¸ÐºÐ° Ñƒ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154269,4286,'vi','Sá»‘ lÆ°á»£ng bá»‹ thiáº¿u loáº¡i phá»¥',0),(154270,4286,'af','Hoeveelheid is Missing in Subtype',0),(154271,4286,'ro','Cantitatea este lipsÄƒ Ã®n subtip',0),(154272,4286,'et','Kogus puudub alatÃ¼Ã¼p',0),(154273,4286,'si','KoliÄina manjka v podtip',0),(154274,4286,'ba','Jumlah yang hilang di subtipe',0),(154275,4286,'nl','Hoeveelheid ontbreekt in Subtype',0),(154276,4286,'fi','MÃ¤Ã¤rÃ¤ puuttuu alatyyppi',0),(154277,4286,'no','Antallet er mangler i undertype',0),(154278,4286,'da','MÃ¦ngde er savnet i undertype',0),(154279,4286,'ko','í•˜ìœ„ í˜•ì‹ì— ëˆ„ë½ì€',0),(154280,4286,'he','×›×ž×•×ª ×”×•× × ×¢×“×¨ ×¡×•×’ ×ž×©× ×”',0),(154281,4286,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎµÎ¯Î½Î±Î¹ Ï‡Î±Î¼Î­Î½Î¿Ï‚ ÏƒÎµ Ï…Ï€ÏŒÏ„Ï…Ï€Î¿',0),(154282,4286,'zh','æ•°é‡æ˜¯ç¼ºå°‘äºšåž‹\r\n',0),(154283,4286,'sv','Kvantitet saknas i subtyp',0),(154284,4286,'it','QuantitÃ  Ã¨ mancante nel sottotipo',0),(154285,4286,'tl','',0),(154286,4286,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3617;&#3637;&#3588;&#3623;&#3634;&#3617;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;',0),(154287,4286,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ Subtype à¤®à¥‡à¤‚ à¤—à¥à¤® à¤¹à¥ˆ',0),(154288,4286,'ms','Kuantiti adalah hilang dalam Subtype',0),(154289,4286,'ar','Ù‡Ùˆ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ÙÙ‚ÙˆØ¯Ø© ÙÙŠ Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(154290,4286,'fr','QuantitÃ© est manquant dans le sous-type',0),(154291,4286,'jp','ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã?«æ•°é‡?ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(154292,4286,'pt','A quantidade Ã© ausente no subtipo',0),(154293,4286,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð² Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154294,4286,'es','Cantidad se FaltÃ³ en SubTipo',0),(154295,4286,'de','Menge fehlt Untertyp',0),(154296,4286,'en','Quantity is Missing in Subtype',0),(154297,4287,'is','',0),(154298,4287,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(154299,4287,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(154300,4287,'tr','Bir Worktype seÃ§in',0),(154301,4287,'pl','Wybierz Worktype',0),(154302,4287,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Worktype',0),(154303,4287,'ur','Ø§ÛŒÚ© ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(154304,4287,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½ÐµÐºÐ¸ WÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ',0),(154305,4287,'vi','Lá»±a chá»n loáº¡i cÃ´ng viá»‡c',0),(154306,4287,'af','Kies \'n Worktype',0),(154307,4287,'ro','SelectaÅ£i o Worktype',0),(154308,4287,'et','Valige oma Worktype',0),(154309,4287,'si','Izberite a Worktype',0),(154310,4287,'ba','Pilih Worktype',0),(154311,4287,'nl','Selecteer een Worktype',0),(154312,4287,'fi','Valitse Worktype',0),(154313,4287,'no','Velg en Worktype',0),(154314,4287,'da','VÃ¦lg en Worktype',0),(154315,4287,'ko','Worktypeì„ ì„ íƒ',0),(154316,4287,'he','×‘×—×¨ ×¡×•×’ ×¢×‘×•×“×”',0),(154317,4287,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Worktype',0),(154318,4287,'zh','é€‰æ‹©å·¥ä½œç±»åž‹\r\n',0),(154319,4287,'sv','VÃ¤lj en Worktype',0),(154320,4287,'it','Selezionare una Worktype',0),(154321,4287,'tl','',0),(154322,4287,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(154323,4287,'hi','à¤à¤• Worktype à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(154324,4287,'ms','Pilih Worktype yang',0),(154325,4287,'ar','Ø­Ø¯Ø¯ ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ',0),(154326,4287,'fr','SÃ©lectionnez une association',0),(154327,4287,'jp','ä»•äº‹å†…å®¹ã?®é?¸æŠž',0),(154328,4287,'pt','Selecione um Worktype',0),(154329,4287,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¢Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(154330,4287,'es','Seleccionar un Tipo de Trabajo',0),(154331,4287,'de','WÃ¤hlen Sie eine Worktype',0),(154332,4287,'en','Select a Worktype',0),(154333,4288,'is','',0),(154334,4288,'dr','(ÙˆÙŠÚ˜Ù‡) Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³  Ø§ÙŠÙ† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(154335,4288,'pr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø«Ø§Ø¨Øª(ÙˆÙŠÚ˜Ù‡) Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§  Ø§ÙŠÙ† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(154336,4288,'tr','Bu alt tÃ¼r kullanabilirsiniz belirli stok malzeme',0),(154337,4288,'pl','Spis materiaÅ‚Ã³w tego podtypu sÅ‚uÅ¼y',0),(154338,4288,'bg','Ð¡ÐºÐ»Ð°Ð´ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ Ñ‚Ð¾Ð·Ð¸ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154339,4288,'ur','Ù…Ø®ØµÙˆØµ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…ÙˆØ§Ø¯ Ø§Ø³ Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(154340,4288,'sr','ÐžÐ´Ñ€ÐµÑ’ÐµÐ½Ðµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¼Ð¾Ð¶ÐµÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð¾Ð²Ð°Ñ˜ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154341,4288,'vi','NhÃ³m Phá»¥ nÃ y cÃ³ thá»ƒ sá»­ dá»¥ng NguyÃªn Liá»‡u HÃ ng Trong Kho Cá»¥ Thá»ƒ ',0),(154342,4288,'af','Spesifieke voorraad materiaal hierdie Subtype gebruik kan',0),(154343,4288,'ro','Stocuri materiale pot folosi acest subtip',0),(154344,4288,'et','Seda alamliiki vÃµite kasutada varude erimaterjalidele',0),(154345,4288,'si','Posebne zaloge materialov, lahko uporabite ta podtip',0),(154346,4288,'ba','Spesifik bahan persediaan subtipe ini dapat menggunakan',0),(154347,4288,'nl','Specifieke inventaris materialen die deze Subtype kunt gebruiken',0),(154348,4288,'fi','TÃ¤mÃ¤ alatyyppi kÃ¤yttÃ¤Ã¤ varaston materiaaleissa',0),(154349,4288,'no','Spesifikke lager materialer denne undertypen kan bruke',0),(154350,4288,'da','Specifik opgÃ¸relse materialer denne undertype kan bruge',0),(154351,4288,'ko','ì´ í•˜ìœ„ í˜•ì‹ ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” íŠ¹ì • ìž¬ê³  ìžë£Œ',0),(154352,4288,'he','×¡×¤×¦×™×¤×™×ª ×ž×œ××™ ×—×•×ž×¨×™× ×©×ª×ª-×¡×•×’ ×–×” × ×™×ª×Ÿ ×œ×”×©×ª×ž×©',0),(154353,4288,'el','Î£Ï…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î± Ï…Î»Î¹ÎºÎ¬ Î±Ï€Î¿Î³ÏÎ±Ï†Î® Î±Ï…Ï„ÏŒÏ‚ Î¿ Ï…Ï€ÏŒÏ„Ï…Ï€Î¿Ï‚ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ',0),(154354,4288,'zh','ç‰¹å®šåº“å­˜ææ–™æ¸…å•æ­¤äºšåž‹å¯ä»¥ä½¿ç”¨\r\n',0),(154355,4288,'sv','SÃ¤rskilda lager material denna subtyp kan anvÃ¤nda',0),(154356,4288,'it','Materiali specifici di inventario che questo sottotipo puÃ² utilizzare',0),(154357,4288,'tl','',0),(154358,4288,'th','&#3619;&#3632;&#3610;&#3640;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;&#3609;&#3637;&#3657;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3',0),(154359,4288,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤¸à¥‚à¤šà¥€ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤‡à¤¸ Subtype à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(154360,4288,'ms','Bahan-bahan inventori tertentu Subtype ini boleh menggunakan',0),(154361,4288,'ar','Ù…ÙˆØ§Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù…Ø­Ø¯Ø¯Ø© ÙˆÙŠÙ…ÙƒÙ† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù‡Ø°Ø§ Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(154362,4288,'fr','Certaines matiÃ¨res de l\'inventaire que ce sous-type peut utiliser',0),(154363,4288,'jp','ã?“ã?®ã‚µãƒ—ã‚¿ã‚¤ãƒ—ã?Œä½¿ç”¨ã?§ã??ã‚‹ç‰¹å®šåœ¨åº«æ??æ–™',0),(154364,4288,'pt','Materiais especÃ­ficos de inventÃ¡rio que pode usar este subtipo',0),(154365,4288,'ru','ÐšÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ñ‹Ðµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¼Ð¾Ð³ÑƒÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(154366,4288,'es','Materiales EspecÃ­ficos de Inventario que este subtipo puede Usar ',0),(154367,4288,'de','Bestimmten Inventar-Werkstoffen, die diesem Untertyp verwenden kÃ¶nnen',0),(154368,4288,'en','Specific Inventory Materials this Subtype can Use',0),(154369,4289,'is','',0),(154370,4289,'dr','Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(154371,4289,'pr','Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(154372,4289,'tr','Alt tÃ¼rÃ¼',0),(154373,4289,'pl','Podtyp',0),(154374,4289,'bg','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿',0),(154375,4289,'ur','Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù…',0),(154376,4289,'sr','ÐŸÐ¾Ð´Ð²Ñ€ÑÑ‚Ð°',0),(154377,4289,'vi','Loáº¡i phá»¥',0),(154378,4289,'af','Subtype',0),(154379,4289,'ro','Subtip',0),(154380,4289,'et','Alamliik',0),(154381,4289,'si','Podtip',0),(154382,4289,'ba','Subtipe',0),(154383,4289,'nl','Subtype',0),(154384,4289,'fi','Alatyypin',0),(154385,4289,'no','Undertypen',0),(154386,4289,'da','Undertype',0),(154387,4289,'ko','í•˜ìœ„ í˜•ì‹',0),(154388,4289,'he','×¡×•×’ ×ž×©× ×”',0),(154389,4289,'el','Î”ÎµÏ…Ï„ÎµÏÎµÏÏ‰Î½ Ï„ÏÏ€Î¿Ï‚',0),(154390,4289,'zh','äºšåž‹\r\n',0),(154391,4289,'sv','Undertyp',0),(154392,4289,'it','Sottotipo',0),(154393,4289,'tl','',0),(154394,4289,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;',0),(154395,4289,'hi','Subtype',0),(154396,4289,'ms','Subtype',0),(154397,4289,'ar','Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(154398,4289,'fr','Sous-type',0),(154399,4289,'jp','ã‚µãƒ–ã‚¿ã‚¤ãƒ—',0),(154400,4289,'pt','Subtipo',0),(154401,4289,'ru','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿',0),(154402,4289,'es','Subtipo',0),(154403,4289,'de','Subtyp',0),(154404,4289,'en','Subtype',0),(154405,4290,'is','',0),(154406,4290,'dr','Ù†Ø§Ù… Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(154407,4290,'pr','Ù†Ø§Ù… Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(154408,4290,'tr','Alt tÃ¼rÃ¼ adÄ±',0),(154409,4290,'pl','Nazwa podtypu',0),(154410,4290,'bg','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿ Ð¸Ð¼Ðµ',0),(154411,4290,'ur','Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… Ú©Ø§ Ù†Ø§Ù…',0),(154412,4290,'sr','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿ Ð¸Ð¼Ðµ',0),(154413,4290,'vi','TÃªn loáº¡i phá»¥',0),(154414,4290,'af','Subtipe Name',0),(154415,4290,'ro','Subtip numele',0),(154416,4290,'et','AlamtÃ¼Ã¼bi nimi',0),(154417,4290,'si','Ime podvrste',0),(154418,4290,'ba','Nama subtipe',0),(154419,4290,'nl','Subtype naam',0),(154420,4290,'fi','Alatyypin nimi',0),(154421,4290,'no','Undertypen navn',0),(154422,4290,'da','Undertype navn',0),(154423,4290,'ko','í•˜ìœ„ í˜•ì‹ ì´ë¦„',0),(154424,4290,'he','×¡×•×’ ×ž×©× ×” ×©×',0),(154425,4290,'el','Î¥Ï€ÏŒÏ„Ï…Ï€Î¿ ÏŒÎ½Î¿Î¼Î±',0),(154426,4290,'zh','äºšåž‹åç§°\r\n',0),(154427,4290,'sv','Undertyp namn',0),(154428,4290,'it','Nome del sottotipo',0),(154429,4290,'tl','',0),(154430,4290,'th','&#3594;&#3639;&#3656;&#3629;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;',0),(154431,4290,'hi','Subtype à¤¨à¤¾à¤®',0),(154432,4290,'ms','Nama subtype',0),(154433,4290,'ar','Ø¥Ø³Ù… Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(154434,4290,'fr','Nom de sous-type',0),(154435,4290,'jp','ã‚µãƒ–ã‚¿ã‚¤ãƒ—å??',0),(154436,4290,'pt','Nome de subtipo',0),(154437,4290,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿Ð°',0),(154438,4290,'es','Nombre de Subtipo',0),(154439,4290,'de','Subtyp-Name',0),(154440,4290,'en','Subtype Name',0),(154441,4291,'is','',0),(154442,4291,'dr','Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(154443,4291,'pr','Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(154444,4291,'tr','Alt tÃ¼rÃ¼',0),(154445,4291,'pl','Podtyp',0),(154446,4291,'bg','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿',0),(154447,4291,'ur','Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù…',0),(154448,4291,'sr','ÐŸÐ¾Ð´Ð²Ñ€ÑÑ‚Ð°',0),(154449,4291,'vi','Loáº¡i phá»¥',0),(154450,4291,'af','Subtype',0),(154451,4291,'ro','Subtip',0),(154452,4291,'et','Alamliik',0),(154453,4291,'si','Podtip',0),(154454,4291,'ba','Subtipe',0),(154455,4291,'nl','Subtype',0),(154456,4291,'fi','Alatyypin',0),(154457,4291,'no','Undertypen',0),(154458,4291,'da','Undertype',0),(154459,4291,'ko','í•˜ìœ„ í˜•ì‹',0),(154460,4291,'he','×¡×•×’ ×ž×©× ×”',0),(154461,4291,'el','Î”ÎµÏ…Ï„ÎµÏÎµÏÏ‰Î½ Ï„ÏÏ€Î¿Ï‚',0),(154462,4291,'zh','äºšåž‹\r\n',0),(154463,4291,'sv','Undertyp',0),(154464,4291,'it','Sottotipo',0),(154465,4291,'tl','',0),(154466,4291,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;',0),(154467,4291,'hi','Subtype',0),(154468,4291,'ms','Subtype',0),(154469,4291,'ar','Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(154470,4291,'fr','Sous-type',0),(154471,4291,'jp','ã‚µãƒ–ã‚¿ã‚¤ãƒ—',0),(154472,4291,'pt','Subtipo',0),(154473,4291,'ru','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿',0),(154474,4291,'es','Subtipo',0),(154475,4291,'de','Subtyp',0),(154476,4291,'en','Subtype',0),(154477,4292,'is','',0),(154478,4292,'dr','(Ù†Ù…ÙˆÙ†Ù‡ ÙƒØ§Ø±',0),(154479,4292,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ ÙƒØ§Ø±(Ù†Ù…ÙˆÙ†Ù‡ ÙƒØ§Ø±',0),(154480,4292,'tr','GÃ¼ncelleme Worktype',0),(154481,4292,'pl','Aktualizacja Worktype',0),(154482,4292,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Worktype',0),(154483,4292,'ur','ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(154484,4292,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ WÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ',0),(154485,4292,'vi','Cáº­p nháº­t loáº¡i cÃ´ng viá»‡c',0),(154486,4292,'af','Opdateer Werktipe',0),(154487,4292,'ro','Actualizare Worktype',0),(154488,4292,'et','Uuenda Worktype',0),(154489,4292,'si','Posodobitev Worktype',0),(154490,4292,'ba','Worktype pembaruan',0),(154491,4292,'nl','Update Worktype',0),(154492,4292,'fi','PÃ¤ivitÃ¤ Worktype',0),(154493,4292,'no','Oppdatere Worktype',0),(154494,4292,'da','Opdater Worktype',0),(154495,4292,'ko','ì—…ë°ì´íŠ¸ Worktype',0),(154496,4292,'he','×¢×“×›×•×Ÿ Worktype',0),(154497,4292,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Worktype',0),(154498,4292,'zh','æ›´æ–°å·¥ä½œç±»åž‹\r\n',0),(154499,4292,'sv','Uppdatera Worktype',0),(154500,4292,'it','Aggiornamento Worktype',0),(154501,4292,'tl','',0),(154502,4292,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(154503,4292,'hi','Worktype à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(154504,4292,'ms','Kemaskini Terakhir Worktype',0),(154505,4292,'ar','ØªØ­Ø¯ÙŠØ« ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ',0),(154506,4292,'fr','Association de mise Ã  jour',0),(154507,4292,'jp','ä»•äº‹å†…å®¹ã?®æ›´æ–°',0),(154508,4292,'pt','AtualizaÃ§Ã£o Worktype',0),(154509,4292,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(154510,4292,'es','Actualizar Tipo de Trabajo',0),(154511,4292,'de','Update Worktype',0),(154512,4292,'en','Update Worktype',0),(154513,4293,'is','',0),(154514,4293,'dr','(Ù†Ù…ÙˆÙ†Ù‡ ÙƒØ§Ø±',0),(154515,4293,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ù†ÙˆØ¹ ÙƒØ§Ø±(Ù†Ù…ÙˆÙ†Ù‡ ÙƒØ§Ø±',0),(154516,4293,'tr','GÃ¼ncelleÅŸtirme Worktype ayrÄ±ntÄ±larÄ±',0),(154517,4293,'pl','SzczegÃ³Å‚y Worktype uaktualniÄ‡',0),(154518,4293,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Worktype Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(154519,4293,'ur','ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(154520,4293,'sr','WÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ Ð´ÐµÑ‚Ð°Ñ™Ð¸ Ð¾ Ð¸ÑÐ¿Ñ€Ð°Ð²Ñ†Ð¸',0),(154521,4293,'vi','Cáº­p nháº­t chi tiáº¿t loáº¡i cÃ´ng viá»‡c',0),(154522,4293,'af','Opdateer Werktipe Besonderhede',0),(154523,4293,'ro','Actualizare Worktype detalii',0),(154524,4293,'et','Worktype Ã¼ksikasjade uuendamiseks',0),(154525,4293,'si','Posodobitev Worktype podrobnosti',0),(154526,4293,'ba','Memperbarui rincian Worktype',0),(154527,4293,'nl','Update Worktype Details',0),(154528,4293,'fi','PÃ¤ivittÃ¤Ã¤ Worktype tiedot',0),(154529,4293,'no','Detaljer for Worktype',0),(154530,4293,'da','Opdatere Worktype detaljer',0),(154531,4293,'ko','Worktype ì •ë³´ ì—…ë°ì´íŠ¸',0),(154532,4293,'he','×¢×“×›×•×Ÿ ×¤×¨×˜×™× Worktype',0),(154533,4293,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Worktype',0),(154534,4293,'zh','æ›´æ–°å·¥ä½œç±»åž‹çš„è¯¦ç»†ä¿¡æ¯\r\n',0),(154535,4293,'sv','Uppdatera Worktype Detaljer',0),(154536,4293,'it','Aggiornamento Worktype dettagli',0),(154537,4293,'tl','',0),(154538,4293,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(154539,4293,'hi','Worktype à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(154540,4293,'ms','Kemaskini Terakhir Worktype maklumat',0),(154541,4293,'ar','ØªØ­Ø¯ÙŠØ« ØªÙØ§ØµÙŠÙ„ ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ',0),(154542,4293,'fr','Mettre Ã  jour les dÃ©tails de l\'Association',0),(154543,4293,'jp','ä»•äº‹å†…å®¹è©³ç´°ã?®æ›´æ–°',0),(154544,4293,'pt','Detalhes de atualizaÃ§Ã£o Worktype',0),(154545,4293,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð¢Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(154546,4293,'es','Actualizar Detalles de Tipo de Trabajo',0),(154547,4293,'de','Update-Worktype-Details',0),(154548,4293,'en','Update Worktype Details',0),(154549,4294,'is','',0),(154550,4294,'dr','(Ù†Ù…ÙˆÙ†Ù‡ ÙƒØ§Ø±',0),(154551,4294,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†ÙˆØ¹ ÙƒØ§Ø±(Ù†Ù…ÙˆÙ†Ù‡ ÙƒØ§Ø±',0),(154552,4294,'tr','Worktype bilgilerini gÃ¼ncelleÅŸtirme',0),(154553,4294,'pl','Informacje o aktualizacji Worktype',0),(154554,4294,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Worktype Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(154555,4294,'ur','ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(154556,4294,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð½Ð°Ð´Ð¾Ð¿ÑƒÐ½Ð¸ Ð·Ð° WÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ',0),(154557,4294,'vi','Cáº­p nháº­t thÃ´ng tin loáº¡i cÃ´ng viá»‡c',0),(154558,4294,'af','Opdateer Werktipe Inskrywing',0),(154559,4294,'ro','ActualizaÅ£i informaÅ£iile de Worktype',0),(154560,4294,'et','Worktype teabe vÃ¤rskendamine',0),(154561,4294,'si','Posodobite informacije o Worktype',0),(154562,4294,'ba','Memperbarui informasi Worktype',0),(154563,4294,'nl','Worktype informatie bijwerken',0),(154564,4294,'fi','Worktype tietojen pÃ¤ivittÃ¤minen',0),(154565,4294,'no','Worktype oppdateringsinformasjon',0),(154566,4294,'da','Opdatere Worktype oplysninger',0),(154567,4294,'ko','Worktype ì •ë³´ ì—…ë°ì´íŠ¸',0),(154568,4294,'he','×œ×¢×“×›×Ÿ ×ž×™×“×¢ Worktype',0),(154569,4294,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ Worktype',0),(154570,4294,'zh','æ›´æ–°å·¥ä½œç±»åž‹ä¿¡æ¯\r\n',0),(154571,4294,'sv','Uppdatera Information om Worktype',0),(154572,4294,'it','Informazioni sull\'aggiornamento del Worktype',0),(154573,4294,'tl','',0),(154574,4294,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(154575,4294,'hi','Worktype à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(154576,4294,'ms','Mengemaskini maklumat Worktype',0),(154577,4294,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ',0),(154578,4294,'fr','Mettre Ã  jour les informations de l\'Association',0),(154579,4294,'jp','ä»•äº‹å†…å®¹æƒ…å ±ã?®æ›´æ–°',0),(154580,4294,'pt','Atualizar informaÃ§Ãµes de Worktype',0),(154581,4294,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð¢Ð¸Ð¿Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(154582,4294,'es','Actualizar InformaciÃ³n de Tipo de Trabajo',0),(154583,4294,'de','Update-Worktype Informationen',0),(154584,4294,'en','Update Worktype Information',0),(154585,4295,'is','',0),(154586,4295,'dr','Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù† Ù…Ù‚Ø¯Ø§Ø±',0),(154587,4295,'pr','Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù† Ù…Ù‚Ø¯Ø§Ø±',0),(154588,4295,'tr','Miktar kadar',0),(154589,4295,'pl','Do iloÅ›ci',0),(154590,4295,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(154591,4295,'ur','Ù…Ù‚Ø¯Ø§Ø± ØªÚ©',0),(154592,4295,'sr','Ð—Ð°Ð²Ð¸ÑÐ¸ Ð¾Ð´ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(154593,4295,'vi','LÃªn tá»›i sá»‘ lÆ°á»£ng',0),(154594,4295,'af','Tot die hoeveelheid',0),(154595,4295,'ro','PÃ¢nÄƒ la cantitatea',0),(154596,4295,'et','Koguse piires',0),(154597,4295,'si','Do koliÄine',0),(154598,4295,'ba','Sampai dengan kuantitas',0),(154599,4295,'nl','Maximaal aantal',0),(154600,4295,'fi','Seuraavien mÃ¤Ã¤rien',0),(154601,4295,'no','Opp antall',0),(154602,4295,'da','MÃ¦ngde',0),(154603,4295,'ko','ì–‘ê¹Œì§€',0),(154604,4295,'he','×¢×“ ×›×ž×•×ª',0),(154605,4295,'el','ÎœÎ­Ï‡ÏÎ¹ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(154606,4295,'zh','å¤šè¾¾æ•°é‡\r\n',0),(154607,4295,'sv','Kvantitet',0),(154608,4295,'it','Fino alla quantitÃ ',0),(154609,4295,'tl','',0),(154610,4295,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;',0),(154611,4295,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¤à¤•',0),(154612,4295,'ms','Sehingga kuantiti',0),(154613,4295,'ar','ÙŠØµÙ„ Ø¥Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(154614,4295,'fr','Jusqu\'Ã  la quantitÃ©',0),(154615,4295,'jp','æ•°é‡?ä»¥ä¸‹',0),(154616,4295,'pt','AtÃ© quantidade',0),(154617,4295,'ru','Ð”Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(154618,4295,'es','Hasta Cantidad',0),(154619,4295,'de','Menge',0),(154620,4295,'en','Up to Quantity',0),(154621,4296,'is','',0),(154622,4296,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù†',0),(154623,4296,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù†',0),(154624,4296,'tr','Her zamanki gÃ¼n tamamlamak iÃ§in',0),(154625,4296,'pl','Zwykle dni do zakoÅ„czenia',0),(154626,4296,'bg','ÐžÐ±Ð¸Ñ‡Ð°Ð¹Ð½Ð¸Ñ‚Ðµ Ð´Ð½Ð¸ Ð·Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ',0),(154627,4296,'ur','Ù…Ú©Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛÙ…ÛŒØ´Û Ú©ÛŒ Ø·Ø±Ø­ Ø§ÛŒØ§Ù…',0),(154628,4296,'sr','Ð£Ð¾Ð±Ð¸Ñ‡Ð°Ñ˜ÐµÐ½Ð¸ Ð´Ð°Ð½Ð° Ð´Ð° ÑÐµ ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð¸Ñ€Ð°',0),(154629,4296,'vi','DÃ¹ng ngÃ y Ä‘á»ƒ hoÃ n táº¥t',0),(154630,4296,'af','Gewone dae om te voltooi',0),(154631,4296,'ro','Obicei de zile pentru a finaliza',0),(154632,4296,'et','Tavaline pÃ¤eva lÃµpetamiseks',0),(154633,4296,'si','ObiÄajnih dni za dokonÄanje',0),(154634,4296,'ba','Hari biasa untuk menyelesaikan',0),(154635,4296,'nl','Gebruikelijke dagen om te voltooien',0),(154636,4296,'fi','Tavallista pÃ¤ivÃ¤Ã¤',0),(154637,4296,'no','Vanlige dager Ã¥ fullfÃ¸re',0),(154638,4296,'da','SÃ¦dvanlige dage at fuldfÃ¸re',0),(154639,4296,'ko','í‰ì†Œ ì¼',0),(154640,4296,'he','×‘×™×ž×™× ×”×¨×’×™×œ×™× ×›×“×™ ×œ×”×©×œ×™×',0),(154641,4296,'el','Î£Ï…Î½Î®Î¸Î· Î·Î¼Î­ÏÎµÏ‚ Î³Î¹Î± Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(154642,4296,'zh','ä¸€èˆ¬å®Œæˆå¤©æ•°\r\n',0),(154643,4296,'sv','Vanliga dagar att slutfÃ¶ra',0),(154644,4296,'it','Soliti giorni per completare',0),(154645,4296,'tl','',0),(154646,4296,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3611;&#3585;&#3605;&#3636;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(154647,4296,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤ªà¥‚à¤°à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(154648,4296,'ms','Hari biasa untuk',0),(154649,4296,'ar','Ø§Ù„Ø£ÙŠØ§Ù… Ø§Ù„Ù…Ø¹ØªØ§Ø¯Ø© Ù„Ø¥ÙƒÙ…Ø§Ù„',0),(154650,4296,'fr','Jours habituels de remplir',0),(154651,4296,'jp','å®Œäº†ã?¾ã?§ã?®é€šå¸¸æ—¥æ•°',0),(154652,4296,'pt','Habituais dias para completar',0),(154653,4296,'ru','ÐžÐ±Ñ‹Ñ‡Ð½Ñ‹Ðµ Ð´Ð½Ð¸ Ð´Ð»Ñ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ',0),(154654,4296,'es','DÃ­as Usuales para Completar',0),(154655,4296,'de','Ãœblichen Tage in Anspruch',0),(154656,4296,'en','Usual Days to Complete',0),(154657,4297,'is','',0),(154658,4297,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù…Ø¹Ù…ÙˆÙ„ Ø§Ø² Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ Ø´ØºÙ„ ',0),(154659,4297,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù…Ø¹Ù…ÙˆÙ„ Ø§Ø² Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ Ø´ØºÙ„ ',0),(154660,4297,'tr','Her zamanki gibi iÅŸ bÃ¶lÃ¼mleri sayÄ±sÄ±',0),(154661,4297,'pl','Zwykle liczba czÄ™Å›ci pracy',0),(154662,4297,'bg','ÐžÐ±Ð¸Ñ‡Ð°ÐµÐ½ Ð±Ñ€Ð¾Ð¹ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‡Ð°ÑÑ‚Ð¸',0),(154663,4297,'ur','ÛÙ…ÛŒØ´Û Ú©ÛŒ Ø·Ø±Ø­ Ø­ØµÛ’ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ú©ÛŒ Ù…Ù„Ø§Ø²Ù…Øª',0),(154664,4297,'sr','Ð£Ð¾Ð±Ð¸Ñ‡Ð°Ñ˜ÐµÐ½Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð´ÐµÐ»Ð¾Ð²Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(154665,4297,'vi','Sá»‘ thÃ´ng thÆ°á»ng cho pháº§n Job',0),(154666,4297,'af','Gewone aantal werk dele',0),(154667,4297,'ro','De obicei numÄƒrul de piese de Job',0),(154668,4297,'et','Tavaline arv tÃ¶Ã¶ osad',0),(154669,4297,'si','ObiÄajno Å¡tevilo delov, delo',0),(154670,4297,'ba','Biasanya jumlah bagian pekerjaan',0),(154671,4297,'nl','Gebruikelijke aantal baan delen',0),(154672,4297,'fi','Tavallinen tyÃ¶ osien mÃ¤Ã¤rÃ¤',0),(154673,4297,'no','Vanlig antall jobb deler',0),(154674,4297,'da','SÃ¦dvanlige antal Job dele',0),(154675,4297,'ko','ìž‘ì—… ë¶€í’ˆì˜ ì¼ë°˜ì ì¸ ìˆ«ìž',0),(154676,4297,'he','×”×ž×¡×¤×¨ ×”×¨×’×™×œ ×©×œ ×”×¢×‘×•×“×” ×—×œ×§×™×',0),(154677,4297,'el','Î£Ï…Î½Î®Î¸Î·Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½ Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î¼Î­ÏÎ·',0),(154678,4297,'zh','ä¸€èˆ¬å·¥ä½œéƒ¨ä»¶æ•°\r\n',0),(154679,4297,'sv','Vanliga antalet jobb delar',0),(154680,4297,'it','Solito numero di parti di lavoro',0),(154681,4297,'tl','',0),(154682,4297,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3611;&#3585;&#3605;&#3636;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;&#3626;&#3656;&#3623;&#3609;&#3609;&#3637;&#3657;',0),(154683,4297,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤­à¤¾à¤—à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯',0),(154684,4297,'ms','Biasa bilangan bahagian-bahagian kerja',0),(154685,4297,'ar','Ø§Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ù…Ø¹ØªØ§Ø¯ Ù…Ù† Ø§Ù„Ø£Ø¬Ø²Ø§Ø¡ Ø§Ù„Ù…Ù‡Ù…Ø©',0),(154686,4297,'fr','Nombre habituel des Ã©lÃ©ments de travail',0),(154687,4297,'jp','ä½œæ¥­éƒ¨å“?ã?®é€šå¸¸æ•°',0),(154688,4297,'pt','NÃºmero habitual das peÃ§as de trabalho',0),(154689,4297,'ru','ÐžÐ±Ñ‹Ñ‡Ð½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ñ… Ñ‡Ð°ÑÑ‚ÐµÐ¹',0),(154690,4297,'es','NÃºmero Usual de Partes de Trabajo',0),(154691,4297,'de','Ãœbliche Zahl von Job teilen',0),(154692,4297,'en','Usual Number of Job Parts',0),(154693,4298,'is','',0),(154694,4298,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(154695,4298,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(154696,4298,'tr','Worktype',0),(154697,4298,'pl','Worktype',0),(154698,4298,'bg','Worktype',0),(154699,4298,'ur','ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ',0),(154700,4298,'sr','WÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ',0),(154701,4298,'vi','Loáº¡i cÃ´ng viá»‡c',0),(154702,4298,'af','Werktipe',0),(154703,4298,'ro','Worktype',0),(154704,4298,'et','TÃ¶Ã¶ liik',0),(154705,4298,'si','Worktype',0),(154706,4298,'ba','Worktype',0),(154707,4298,'nl','Worktype',0),(154708,4298,'fi','Worktype',0),(154709,4298,'no','Worktype',0),(154710,4298,'da','Worktype',0),(154711,4298,'ko','Worktype',0),(154712,4298,'he','Worktype',0),(154713,4298,'el','Worktype',0),(154714,4298,'zh','å·¥ä½œç±»åž‹\r\n',0),(154715,4298,'sv','Worktype',0),(154716,4298,'it','Worktype',0),(154717,4298,'tl','',0),(154718,4298,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(154719,4298,'hi','Worktype',0),(154720,4298,'ms','Worktype',0),(154721,4298,'ar','ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ',0),(154722,4298,'fr','Association',0),(154723,4298,'jp','ä»•äº‹å†…å®¹',0),(154724,4298,'pt','Worktype',0),(154725,4298,'ru','Ð¢Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(154726,4298,'es','Tipo de Trabajo',0),(154727,4298,'de','Worktype',0),(154728,4298,'en','Worktype',0),(154729,4299,'is','',0),(154730,4299,'dr','Ù†Ø¨ÙˆØ¯ Ø´Ù†Ø§Ø³Ù‡ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(154731,4299,'pr','Ù†Ø¨ÙˆØ¯ Ø´Ù†Ø§Ø³Ù‡ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(154732,4299,'tr','Worktype id_worktype yoksun',0),(154733,4299,'pl','Worktype nie ma id_worktype',0),(154734,4299,'bg','Worktype Ð»Ð¸Ð¿ÑÐ²Ð° id_worktype',0),(154735,4299,'ur','ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ id_worktype Ú©Ø§ ÙÙ‚Ø¯Ø§Ù†',0),(154736,4299,'sr','WÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ Ð½ÐµÐ¼Ð° Ð¸Ð´_wÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ',0),(154737,4299,'vi','Loáº¡i cÃ´ng viá»‡c thiáº¿u id Loáº¡i cÃ´ng viá»‡c',0),(154738,4299,'af','Worktype id_worktype ontbreek',0),(154739,4299,'ro','Worktype nu are id_worktype',0),(154740,4299,'et','Worktype lacks id_worktype',0),(154741,4299,'si','Worktype nima id_worktype',0),(154742,4299,'ba','Worktype kurang id_worktype',0),(154743,4299,'nl','Worktype mist id_worktype',0),(154744,4299,'fi','Worktype ei ole id_worktype',0),(154745,4299,'no','Worktype mangler id_worktype',0),(154746,4299,'da','Worktype mangler id_worktype',0),(154747,4299,'ko','Worktype ë¶€ì¡± id_worktype',0),(154748,4299,'he','Worktype ×—×¡×¨ id_worktype',0),(154749,4299,'el','Worktype ÏƒÏ„ÎµÏÎµÎ¯Ï„Î±Î¹ id_worktype',0),(154750,4299,'zh','å·¥ä½œç±»åž‹ç¼ºå°‘å¸å·å·¥ä½œç±»åž‹\r\n',0),(154751,4299,'sv','Worktype saknar id_worktype',0),(154752,4299,'it','Worktype manca id_worktype',0),(154753,4299,'tl','',0),(154754,4299,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3586;&#3634;&#3604;&#3649;&#3588;&#3621;&#3609;&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(154755,4299,'hi','Worktype id_worktype à¤•à¤¾ à¤…à¤­à¤¾à¤µ',0),(154756,4299,'ms','Worktype tidak id_worktype',0),(154757,4299,'ar','ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ ÙŠÙØªÙ‚Ø± Ø¥Ù„Ù‰ id_worktype',0),(154758,4299,'fr','Association n\'a pas d\'id_worktype',0),(154759,4299,'jp','ä»•äº‹å†…å®¹ã?«ã?¯id_worktypeã?Œè¶³ã‚Šã?¾ã?›ã‚“',0),(154760,4299,'pt','Carece de Worktype id_worktype',0),(154761,4299,'ru','Worktype Ð½Ðµ Ñ…Ð²Ð°Ñ‚Ð°ÐµÑ‚ id_worktype',0),(154762,4299,'es','Tipo de Trabajo falta tipo de trabajo id',0),(154763,4299,'de','Worktype fehlt id_worktype',0),(154764,4299,'en','Worktype lacks id_worktype',0),(154765,4300,'is','',0),(154766,4300,'dr','Ø¬ÙˆØ§Ø¨ Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(154767,4300,'pr','Ø¬ÙˆØ§Ø¨ Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(154768,4300,'tr','VarsayÄ±lan yanÄ±t',0),(154769,4300,'pl','OdpowiedÅº domyÅ›lna',0),(154770,4300,'bg','ÐžÑ‚Ð³Ð¾Ð²Ð¾Ñ€ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(154771,4300,'ur','Ø·Û’ Ø´Ø¯Û Ø¬ÙˆØ§Ø¨ÛŒ Ø¹Ù…Ù„',0),(154772,4300,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€',0),(154773,4300,'vi','Tráº£ lá»i Máº·c Ä‘á»‹nh',0),(154774,4300,'af','Verstekte Terugvoering',0),(154775,4300,'ro','Raspuns implicit',0),(154776,4300,'et','Reageerimisaeg vaikimisi',0),(154777,4300,'si','Privzeti odziv',0),(154778,4300,'ba','Respon default',0),(154779,4300,'nl','Standaardantwoord',0),(154780,4300,'fi','Oletusvastausaika',0),(154781,4300,'no','Standardsvar',0),(154782,4300,'da','Standardsvar',0),(154783,4300,'ko','ê¸°ë³¸ ì‘ë‹µ',0),(154784,4300,'he','×ª×’×•×‘×” ×”×ž×©×ž×©×ª ×›×‘×¨×™×¨×ª ×ž×—×“×œ',0),(154785,4300,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î±Ï€ÏŒÎºÏÎ¹ÏƒÎ·',0),(154786,4300,'zh','é»˜è®¤å“åº”\r\n',0),(154787,4300,'sv','Standardsvar',0),(154788,4300,'it','Risposta predefinita',0),(154789,4300,'tl','',0),(154790,4300,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;',0),(154791,4300,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿à¤¸à¤¾à¤¦',0),(154792,4300,'ms','Tindak balas lalai',0),(154793,4300,'ar','Ø§Ù„Ø§Ø³ØªØ¬Ø§Ø¨Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(154794,4300,'fr','RÃ©ponse par dÃ©faut',0),(154795,4300,'jp','æ—¢å®šå›žç­”',0),(154796,4300,'pt','Resposta padrÃ£o',0),(154797,4300,'ru','ÐžÑ‚ÐºÐ»Ð¸Ðº Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(154798,4300,'es','Respuesta por Defecto',0),(154799,4300,'de','Standardantwort',0),(154800,4300,'en','Default Response',0),(154801,4301,'is','',0),(154802,4301,'dr','Ø¬ÙˆØ§Ø¨ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± ',0),(154803,4301,'pr','Ø¬ÙˆØ§Ø¨ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± ',0),(154804,4301,'tr','VarsayÄ±lan yanÄ±t iÃ§in Worktypes',0),(154805,4301,'pl','DomyÅ›lnie odpowiedzi dla Worktypes',0),(154806,4301,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ Ð·Ð° Worktypes',0),(154807,4301,'ur','Ø·Û’ Ø´Ø¯Û Ø¬ÙˆØ§Ø¨ÛŒ Ø¹Ù…Ù„ ÙˆÙˆØ±Ú©ØªÛŒÙ¾Ø§Ø³ Ú©Û’ Ù„ÛŒÛ’',0),(154808,4301,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€Ðµ Ð·Ð° WÐ¾Ñ€ÐºÑ‚yÐ¿ÐµÑ',0),(154809,4301,'vi','Tráº£ lá»i Máº·c Ä‘á»‹nh cho loáº¡i cÃ´ng viá»‡c',0),(154810,4301,'af','Verstekte Terugvoering vir Werktipes',0),(154811,4301,'ro','RÄƒspuns implicit pentru Worktypes',0),(154812,4301,'et','Vaikimisi vastused Worktypes',0),(154813,4301,'si','Privzeti odgovor za Worktypes',0),(154814,4301,'ba','Default tanggapan untuk Worktypes',0),(154815,4301,'nl','Standaard Responsie voor Worktypes',0),(154816,4301,'fi','Oletusarvoinen vastaus Worktypes',0),(154817,4301,'no','Standard svar for Worktypes',0),(154818,4301,'da','Standard svar til Worktypes',0),(154819,4301,'ko','Worktypesì— ëŒ€ í•œ ê¸°ë³¸ ì‘ë‹µ',0),(154820,4301,'he','×ª×’×•×‘×•×ª ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×‘×•×¨ Worktypes',0),(154821,4301,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Î±Ï€Î±Î½Ï„Î®ÏƒÎµÎ¹Ï‚ Î³Î¹Î± Worktypes',0),(154822,4301,'zh','å·¥ä½œç±»åž‹çš„é»˜è®¤å“åº”\r\n',0),(154823,4301,'sv','Standard Svaren fÃ¶r Worktypes',0),(154824,4301,'it','Risposte predefinite per Worktypes',0),(154825,4301,'tl','',0),(154826,4301,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;&#3586;&#3629;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(154827,4301,'hi','Worktypes à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤ªà¥à¤°à¤¤à¥à¤¯à¥à¤¤à¥à¤¤à¤°',0),(154828,4301,'ms','Balas lalai bagi Worktypes',0),(154829,4301,'ar','Ø§Ù„Ø§Ø³ØªØ¬Ø§Ø¨Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠØ³',0),(154830,4301,'fr','Par dÃ©faut les rÃ©ponses pour Worktypes',0),(154831,4301,'jp','ä»•äº‹å†…å®¹ã?®è¦?å®šå›žç­”',0),(154832,4301,'pt','Respostas de padrÃ£o para Worktypes',0),(154833,4301,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¾Ñ‚Ð²ÐµÑ‚Ñ‹ Ð´Ð»Ñ Worktypes',0),(154834,4301,'es','Respuestas por Defecto para Tipos de Trabajo',0),(154835,4301,'de','Standardreaktionen fÃ¼r Worktypes',0),(154836,4301,'en','Default Responses for Worktypes',0),(154837,4302,'is','',0),(154838,4302,'dr','Ù‡ÙŠÚ† Ú¯Ø²ÙŠÙ†Ø´ÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(154839,4302,'pr','Ù‡ÙŠÚ† Ú¯Ø²ÙŠÙ†Ø´ÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(154840,4302,'tr','HiÃ§bir seÃ§im bulundu',0),(154841,4302,'pl','Å»adne opcje nie znaleziono',0),(154842,4302,'bg','ÐÑÐ¼Ð° Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸ ÑÐµÐ»ÐµÐºÑ†Ð¸Ð¸',0),(154843,4302,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù†ÛÛŒÚº',0),(154844,4302,'sr','ÐÐµÐ¼Ð° Ð¾Ð´Ð°Ð±Ð¸Ñ€Ð¸',0),(154845,4302,'vi','KhÃ´ng tháº¥y lá»±a chá»n',0),(154846,4302,'af','Geen Seleksies Gevind',0),(154847,4302,'ro','Nici selecÅ£ii gÄƒsit',0),(154848,4302,'et','Ãœhtegi valikut leitud',0),(154849,4302,'si','Nobene izbire, najdemo',0),(154850,4302,'ba','Tidak ada pilihan yang ditemukan',0),(154851,4302,'nl','Geen selecties gevonden',0),(154852,4302,'fi','Valintoja ei lÃ¶ytynyt',0),(154853,4302,'no','Ingen valg funnet',0),(154854,4302,'da','Ingen valg fundet',0),(154855,4302,'ko','ë°œê²¬ ì—†ìŒ ì„ íƒ',0),(154856,4302,'he','××™×Ÿ ×‘×—×™×¨×•×ª × ×ž×¦××•',0),(154857,4302,'el','Î”ÎµÎ½ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Ï€Î¿Ï…',0),(154858,4302,'zh','æ²¡æœ‰æ‰¾åˆ°é€‰æ‹©\r\n',0),(154859,4302,'sv','Inga val hittade',0),(154860,4302,'it','Nessuna selezione trovata',0),(154861,4302,'tl','',0),(154862,4302,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(154863,4302,'hi','à¤šà¤¯à¤¨ à¤ªà¤¾à¤¯à¤¾ à¤¨à¤¹à¥€à¤‚',0),(154864,4302,'ms','Tiada pilihan yang dijumpai',0),(154865,4302,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ ØªØ­Ø¯ÙŠØ¯Ø§Øª',0),(154866,4302,'fr','Pas trouvÃ©es de sÃ©lections',0),(154867,4302,'jp','é?¸æŠžè‚¢ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(154868,4302,'pt','NÃ£o encontradas de seleÃ§Ãµes',0),(154869,4302,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½',0),(154870,4302,'es','No se Encontraron Selecciones',0),(154871,4302,'de','Keine Auswahl gefunden',0),(154872,4302,'en','No Selections Found',0),(154873,4303,'is','',0),(154874,4303,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ø± Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(154875,4303,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ø± Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(154876,4303,'tr','Ä°ÅŸ alt tÃ¼rÃ¼nÃ¼ seÃ§in',0),(154877,4303,'pl','Wybierz podtyp pracy',0),(154878,4303,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(154879,4303,'ur','Ú©Ø§Ù… Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(154880,4303,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿ Ñ€Ð°Ð´',0),(154881,4303,'vi','chá»n loáº¡i cÃ´ng viá»‡c',0),(154882,4303,'af','Kies die werk Subtype',0),(154883,4303,'ro','SelectaÈ›i subtipul de lucru',0),(154884,4303,'et','Valige tÃ¶Ã¶ alatÃ¼Ã¼p',0),(154885,4303,'si','izberite podvrsto delo',0),(154886,4303,'ba','Pilih pekerjaan subtipe',0),(154887,4303,'nl','Selecteer werk Subtype',0),(154888,4303,'fi','Valitse tyÃ¶n alatyyppi',0),(154889,4303,'no','Velg arbeid undertype',0),(154890,4303,'da','VÃ¦lg arbejde undertype',0),(154891,4303,'ko','ìž‘ì—… í•˜ìœ„ ì„ íƒ',0),(154892,4303,'he','×‘×—×¨ ×¡×•×’ ×©×œ ×¢×‘×•×“×”',0),(154893,4303,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï…Ï€Î¿ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(154894,4303,'zh','é€‰æ‹©å·¥ä½œäºšåž‹\r\n',0),(154895,4303,'sv','vÃ¤lja arbete undertyp',0),(154896,4303,'it','Selezionare il sottotipo di lavoro',0),(154897,4303,'tl','',0),(154898,4303,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3618;&#3656;&#3629;&#3618;',0),(154899,4303,'hi','à¤•à¤¾à¤® Subtype à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(154900,4303,'ms','Pilih kerja Subtype',0),(154901,4303,'ar','Ø­Ø¯Ø¯ \"Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ Ù„Ù„Ø¹Ù…Ù„\"',0),(154902,4303,'fr','SÃ©lectionnez le sous-type de travail',0),(154903,4303,'jp','ä½œæ¥­ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã?®é?¸æŠž',0),(154904,4303,'pt','Selecione o subtipo de trabalho',0),(154905,4303,'ru','Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(154906,4303,'es','seleccionar Tipo de Trabajo',0),(154907,4303,'de','WÃ¤hlen Sie Arbeit Untertyp',0),(154908,4303,'en','select Work Subtype',0),(154909,4304,'is','',0),(154910,4304,'dr','Ù†ÙˆØ¹ Ù…Ø­Ø§Ø³Ø¨Ù‡ ',0),(154911,4304,'pr','Ù†ÙˆØ¹ Ù…Ø­Ø§Ø³Ø¨Ù‡ ',0),(154912,4304,'tr','Hesaplama tipi',0),(154913,4304,'pl','Typ kalkulacji',0),(154914,4304,'bg','Ð’Ð¸Ð´ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ',0),(154915,4304,'ur','Ø­Ø³Ø§Ø¨ Ú©ÛŒ Ù‚Ø³Ù…',0),(154916,4304,'sr','Ð’Ñ€ÑÑ‚Ð° Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(154917,4304,'vi','Loáº¡i TÃ­nh toÃ¡n',0),(154918,4304,'af','Berekende Tipe',0),(154919,4304,'ro','Tip calcul',0),(154920,4304,'et','Kalkulatsiooni tÃ¼Ã¼p',0),(154921,4304,'si','Vrsta izraÄuna',0),(154922,4304,'ba','Jenis perhitungan',0),(154923,4304,'nl','Berekeningssoort',0),(154924,4304,'fi','Laskentatyyppi',0),(154925,4304,'no','Beregning',0),(154926,4304,'da','Beregningstypen',0),(154927,4304,'ko','ê³„ì‚° ìœ í˜•',0),(154928,4304,'he','×¡×•×’ ×—×™×©×•×‘',0),(154929,4304,'el','Î¤ÏÏ€Î¿Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(154930,4304,'zh','è®¡ç®—ç±»åž‹\r\n',0),(154931,4304,'sv','BerÃ¤kningstypen',0),(154932,4304,'it','Tipo di calcolo',0),(154933,4304,'tl','',0),(154934,4304,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(154935,4304,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(154936,4304,'ms','Pengiraan jenis',0),(154937,4304,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(154938,4304,'fr','Type de calcul',0),(154939,4304,'jp','è¨ˆç®—ã‚¿ã‚¤ãƒ—',0),(154940,4304,'pt','Tipo de cÃ¡lculo',0),(154941,4304,'ru','Ð¢Ð¸Ð¿ ÐšÐ°Ð»ÑŒÐºÑƒÐ»ÑÑ†Ð¸Ð¸',0),(154942,4304,'es','Tipo de CÃ¡lculo',0),(154943,4304,'de','Berechnungsart',0),(154944,4304,'en','Calculation Type',0),(154945,4305,'is','',0),(154946,4305,'dr','ØªÙ‚Ø³ÙŠÙ… Ø¨ÙˆØ³ÙŠÙ„Ù‡ ÙƒØ§Ù„Ø§ Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª \r\n IPH',0),(154947,4305,'pr','ØªÙ‚Ø³ÙŠÙ… Ø¨ÙˆØ³ÙŠÙ„Ù‡ ÙƒØ§Ù„Ø§ Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª \r\n IPH',0),(154948,4305,'tr','IPH tarafÄ±ndan bÃ¶lmek',0),(154949,4305,'pl','PodzieliÄ‡ przez IPH',0),(154950,4305,'bg','Ð Ð°Ð·Ð´ÐµÐ»ÐµÑ‚Ðµ Ð½Ð° IPH',0),(154951,4305,'ur','Ø§Ù Ú©ÛŒ ØªÙ‚Ø³ÛŒÙ…',0),(154952,4305,'sr','ÐŸÐ¾Ð´ÐµÐ»Ð¸Ñ‚Ð¸ ÑÐ° Ð˜ÐŸÐ¥',0),(154953,4305,'vi','Chia theo IPH',0),(154954,4305,'af','Verdeel deur IPH',0),(154955,4305,'ro','ÃŽmpÄƒrÅ£iÅ£i de IPH',0),(154956,4305,'et','Jagage IPH',0),(154957,4305,'si','Razdelite jih IJV',0),(154958,4305,'ba','Membagi dengan IPH',0),(154959,4305,'nl','Verdelen door WIV',0),(154960,4305,'fi','Jakaa IPH',0),(154961,4305,'no','Dele IPH',0),(154962,4305,'da','Dividere med IPH',0),(154963,4305,'ko','IPHë¥¼ ë‚˜ëˆ„ì–´',0),(154964,4305,'he','×ž×ª×—×œ×§ IPH',0),(154965,4305,'el','Î”Î¹Î±Î¹ÏÎ­ÏƒÏ„Îµ Î¼Îµ IPH',0),(154966,4305,'zh','é™¤ä»¥æ¯å°æ—¶çš„é¡¹ç›®\r\n',0),(154967,4305,'sv','Dela upp av IPH',0),(154968,4305,'it','Dividere per IPH',0),(154969,4305,'tl','',0),(154970,4305,'th','&#3649;&#3610;&#3656;&#3591;&#3626;&#3656;&#3623;&#3609;&#3650;&#3604;&#3618; IPH',0),(154971,4305,'hi','IPH à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤«à¥‚à¤Ÿ à¤¡à¤¾à¤²à¥‹',0),(154972,4305,'ms','Bahagi IPH',0),(154973,4305,'ar','Ø§Ù„Ù‚Ø³Ù…Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø¹Ù‡Ø¯',0),(154974,4305,'fr','Diviser par IPH',0),(154975,4305,'jp','ï¼©ï¼°ï¼¨ã?§åˆ†å‰²',0),(154976,4305,'pt','Dividir pelo IPH',0),(154977,4305,'ru','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÑŒ Ð¾Ñ‚ Ð¡Ð›Ð£Ð§Ð',0),(154978,4305,'es','Dividir por IPH',0),(154979,4305,'de','Dividieren durch IPH',0),(154980,4305,'en','Divide by IPH',0),(154981,4306,'is','',0),(154982,4306,'dr','ÙØ±Ù…ÙˆÙ„Ù‡Ø§ ',0),(154983,4306,'pr','ÙØ±Ù…ÙˆÙ„Ù‡Ø§ ',0),(154984,4306,'tr','FormÃ¼l',0),(154985,4306,'pl','FormuÅ‚a',0),(154986,4306,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð°',0),(154987,4306,'ur','ÙØ§Ø±Ù…ÙˆÙ„Ø§',0),(154988,4306,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð°',0),(154989,4306,'vi','CÃ´ng thá»©c',0),(154990,4306,'af','Formule',0),(154991,4306,'ro','Formula',0),(154992,4306,'et','Valem',0),(154993,4306,'si','Formula',0),(154994,4306,'ba','Rumus',0),(154995,4306,'nl','Formule',0),(154996,4306,'fi','Kaava',0),(154997,4306,'no','Formel',0),(154998,4306,'da','Formel',0),(154999,4306,'ko','ìˆ˜ì‹',0),(155000,4306,'he','×”× ×•×¡×—×”',0),(155001,4306,'el','Î¤ÏÏ€Î¿Ï‚',0),(155002,4306,'zh','å…¬å¼\r\n',0),(155003,4306,'sv','Formel',0),(155004,4306,'it','Formula',0),(155005,4306,'tl','',0),(155006,4306,'th','&#3626;&#3641;&#3605;&#3619;',0),(155007,4306,'hi','à¤¸à¥‚à¤¤à¥à¤°',0),(155008,4306,'ms','Formula',0),(155009,4306,'ar','Ø§Ù„ØµÙŠØºØ©',0),(155010,4306,'fr','Formule',0),(155011,4306,'jp','å¼?',0),(155012,4306,'pt','FÃ³rmula',0),(155013,4306,'ru','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð°',0),(155014,4306,'es','Formula',0),(155015,4306,'de','Formel',0),(155016,4306,'en','Formula',0),(155017,4307,'is','',0),(155018,4307,'dr','ÙØ±Ù…ÙˆÙ„Ù‡Ø§ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(155019,4307,'pr','ÙØ±Ù…ÙˆÙ„Ù‡Ø§ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(155020,4307,'tr','FormÃ¼l eklendi',0),(155021,4307,'pl','FormuÅ‚a dodaje',0),(155022,4307,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½',0),(155023,4307,'ur','ÙØ§Ø±Ù…ÙˆÙ„Ø§ Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(155024,4307,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð¾',0),(155025,4307,'vi','ThÃªm cÃ´ng thá»©c',0),(155026,4307,'af','Formule Bygevoeg',0),(155027,4307,'ro','FormulÄƒ adaugÄƒ',0),(155028,4307,'et','Lisatud valem',0),(155029,4307,'si','Formula, doda',0),(155030,4307,'ba','Formula yang ditambahkan',0),(155031,4307,'nl','Formule toegevoegd',0),(155032,4307,'fi','Kaava lisÃ¤tÃ¤Ã¤n',0),(155033,4307,'no','Formelen legges',0),(155034,4307,'da','Formel tilfÃ¸jet',0),(155035,4307,'ko','ìˆ˜ì‹ ì¶”ê°€',0),(155036,4307,'he','× ×•×¡×—×” × ×•×¡×¤×ª',0),(155037,4307,'el','Î¤ÏÏ€Î¿Ï‚ Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯',0),(155038,4307,'zh','æ–°å¢žå…¬å¼\r\n',0),(155039,4307,'sv','Formeln lÃ¤ggs',0),(155040,4307,'it','Formula aggiunto',0),(155041,4307,'tl','',0),(155042,4307,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3641;&#3605;&#3619;&#3649;&#3621;&#3657;&#3623;',0),(155043,4307,'hi','à¤¸à¥‚à¤¤à¥à¤° à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾',0),(155044,4307,'ms','Formula yang ditambah',0),(155045,4307,'ar','Ø¥Ø¶Ø§ÙØ© ØµÙŠØºØ©',0),(155046,4307,'fr','Formule ajoutÃ©',0),(155047,4307,'jp','å¼?ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(155048,4307,'pt','FÃ³rmula adicionada',0),(155049,4307,'ru','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(155050,4307,'es','Formula Agregado',0),(155051,4307,'de','Formel hinzugefÃ¼gt',0),(155052,4307,'en','Formula Added',0),(155053,4308,'is','',0),(155054,4308,'dr','ÙØ±Ù…ÙˆÙ„ Ø­Ø°Ù Ø´Ø¯ ',0),(155055,4308,'pr','ÙØ±Ù…ÙˆÙ„ Ø­Ø°Ù Ø´Ø¯ ',0),(155056,4308,'tr','SilinmiÅŸ formÃ¼lÃ¼',0),(155057,4308,'pl','FormuÅ‚a usuniÄ™te',0),(155058,4308,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸',0),(155059,4308,'ur','Ø­Ø°Ù Ø´Ø¯Û ÙØ§Ø±Ù…ÙˆÙ„Ø§',0),(155060,4308,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ñ˜Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½',0),(155061,4308,'vi','XÃ³a cÃ´ng thá»©c',0),(155062,4308,'af','Formule Geskrap',0),(155063,4308,'ro','Formula eliminÄƒ',0),(155064,4308,'et','VÃ¤lja valem',0),(155065,4308,'si','Formula Ärta',0),(155066,4308,'ba','Formula yang dihapus',0),(155067,4308,'nl','Formule verwijderd',0),(155068,4308,'fi','Kaava poistetaan',0),(155069,4308,'no','Formelen slettet',0),(155070,4308,'da','Formel slettet',0),(155071,4308,'ko','ìˆ˜ì‹ ì‚­ì œ',0),(155072,4308,'he','× ×•×¡×—×” × ×ž×—×§',0),(155073,4308,'el','Î¤ÏÏ€Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯',0),(155074,4308,'zh','å…¬å¼åˆ é™¤\r\n',0),(155075,4308,'sv','Formel tas bort',0),(155076,4308,'it','Formula eliminato',0),(155077,4308,'tl','',0),(155078,4308,'th','&#3626;&#3641;&#3605;&#3619;&#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(155079,4308,'hi','à¤¸à¥‚à¤¤à¥à¤° à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(155080,4308,'ms','Formula yang dihapuskan',0),(155081,4308,'ar','Ø­Ø°Ù Ø§Ù„ØµÙŠØºØ©',0),(155082,4308,'fr','Formule supprimÃ©e',0),(155083,4308,'jp','å¼?ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(155084,4308,'pt','FÃ³rmula eliminada',0),(155085,4308,'ru','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð£Ð´Ð°Ð»ÐµÐ½Ð°',0),(155086,4308,'es','Formula Eliminado',0),(155087,4308,'de','Formel gelÃ¶scht',0),(155088,4308,'en','Formula Deleted',0),(155089,4309,'is','',0),(155090,4309,'dr','Ù…Ø¯ÙŠØ±ÙŠØª ÙØ±Ù…ÙˆÙ„ Ø¨Ø±Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(155091,4309,'pr','Ù…Ø¯ÙŠØ±ÙŠØª ÙØ±Ù…ÙˆÙ„ Ø¨Ø±Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(155092,4309,'tr','Hesaplamalar iÃ§in formÃ¼l yÃ¶netimi',0),(155093,4309,'pl','FormuÅ‚y zarzÄ…dzania dla obliczeÅ„',0),(155094,4309,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð¸ Ð·Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(155095,4309,'ur','Ø­Ø³Ø§Ø¨ Ú©Û’ Ù„ÛŒÛ’ ÙØ§Ø±Ù…ÙˆÙ„Ø§ Ø¨Ù†Ø¯ÙˆØ¨Ø³Øª',0),(155096,4309,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ð·Ð° Ð¿Ñ€Ð¾Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(155097,4309,'vi','Quáº£n lÃ½ cÃ´ng thá»©c Ä‘á»ƒ tÃ­nh',0),(155098,4309,'af','Formule bestuur vir berekeninge',0),(155099,4309,'ro','Formula de Management pentru calcule',0),(155100,4309,'et','Valemi juhtimise arvutused',0),(155101,4309,'si','Formula upravljanja za izraÄune',0),(155102,4309,'ba','Manajemen rumus untuk perhitungan',0),(155103,4309,'nl','Formule Management voor berekeningen',0),(155104,4309,'fi','Kaavan johdon laskelmat',0),(155105,4309,'no','Formel Management for beregninger',0),(155106,4309,'da','Formel ledelse for beregninger',0),(155107,4309,'ko','ê³„ì‚°ì„ ìœ„í•œ ìˆ˜ì‹ ê´€ë¦¬',0),(155108,4309,'he','× ×™×”×•×œ ×”× ×•×¡×—××•×ª ×œ×—×™×©×•×‘×™×',0),(155109,4309,'el','Î¤ÏÏ€Î¿Ï‚ Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚ Î³Î¹Î± Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(155110,4309,'zh','è®¡ç®—å…¬å¼ç®¡ç†\r\n',0),(155111,4309,'sv','Formeln Management fÃ¶r berÃ¤kningar',0),(155112,4309,'it','Gestione formule per i calcoli',0),(155113,4309,'tl','',0),(155114,4309,'th','&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3626;&#3641;&#3605;&#3619;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(155115,4309,'hi','à¤—à¤£à¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‚à¤¤à¥à¤° à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨',0),(155116,4309,'ms','Pengurusan formula untuk pengiraan',0),(155117,4309,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„ØµÙŠØºØ© Ù„Ø¥Ø¬Ø±Ø§Ø¡ Ø§Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ÙŠØ©',0),(155118,4309,'fr','Gestion des formule pour les calculs',0),(155119,4309,'jp','è¨ˆç®—ã?®ãƒ•ã‚©ãƒ¼ãƒŸãƒ¥ãƒ©ç®¡ç?†',0),(155120,4309,'pt','Gerenciamento de fÃ³rmula para cÃ¡lculos',0),(155121,4309,'ru','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð´Ð»Ñ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(155122,4309,'es','AdministraciÃ³n de Formula para CÃ¡lculos',0),(155123,4309,'de','Formel-Management fÃ¼r Berechnungen',0),(155124,4309,'en','Formula Management for Calculations',0),(155125,4310,'is','',0),(155126,4310,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙØ±Ù…ÙˆÙ„ ',0),(155127,4310,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙØ±Ù…ÙˆÙ„ ',0),(155128,4310,'tr','GÃ¼ncellenme Tarihi formÃ¼lÃ¼',0),(155129,4310,'pl','FormuÅ‚a aktualizowane',0),(155130,4310,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð°',0),(155131,4310,'ur','ÙØ§Ø±Ù…ÙˆÙ„Ø§ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(155132,4310,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(155133,4310,'vi','Cáº­p nháº­t cÃ´ng thá»©c',0),(155134,4310,'af','Formule Opdateer',0),(155135,4310,'ro','Formula actualizat',0),(155136,4310,'et','Uuendatud valem',0),(155137,4310,'si','Formulo, ki posodablja',0),(155138,4310,'ba','Formula Diperbarui',0),(155139,4310,'nl','Formule bijgewerkt',0),(155140,4310,'fi','Kaava pÃ¤ivittÃ¤Ã¤',0),(155141,4310,'no','Formelen oppdatert',0),(155142,4310,'da','Formel opdateret',0),(155143,4310,'ko','ìˆ˜ì‹ ì—…ë°ì´íŠ¸',0),(155144,4310,'he','× ×•×¡×—×ª ×¢×“×›×•×Ÿ',0),(155145,4310,'el','Î¤ÏÏ€Î¿Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(155146,4310,'zh','å…¬å¼æ›´æ–°\r\n',0),(155147,4310,'sv','Formel uppdateras',0),(155148,4310,'it','Formula aggiornata',0),(155149,4310,'tl','',0),(155150,4310,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3641;&#3605;&#3619;',0),(155151,4310,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¿à¤¤ à¤¸à¥‚à¤¤à¥à¤°',0),(155152,4310,'ms','Formula yang dikemaskini',0),(155153,4310,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ØµÙŠØºØ©',0),(155154,4310,'fr','Formule de mise Ã  jour',0),(155155,4310,'jp','å¼?ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(155156,4310,'pt','FÃ³rmula atualizada',0),(155157,4310,'ru','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(155158,4310,'es','Formula Actualizada',0),(155159,4310,'de','Formel aktualisiert',0),(155160,4310,'en','Formula Updated',0),(155161,4311,'is','',0),(155162,4311,'dr','Q11 ÙŠØ§ Q10 Ø¨Ø±Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ÙÙ‚Ø· ÙŠÙƒØ¨Ø§Ø± Ø¯Ø± Ù‡Ø± Ø´ØºÙ„  Ø¯Ø± ÙØ±Ù…ÙˆÙ„ ÙÙ‚Ø· Ø¯Ùˆ Ù…Ù‚Ø¯Ø§Ø± Ø²ÙŠØ± Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(155163,4311,'pr',' Q11 ÙŠØ§ Q10 Ø¨Ø±Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ÙÙ‚Ø· ÙŠÙƒØ¨Ø§Ø± Ø¯Ø± Ù‡Ø± Ø´ØºÙ„  Ø¯Ø± ÙØ±Ù…ÙˆÙ„ ÙÙ‚Ø· Ø¯Ùˆ Ù…Ù‚Ø¯Ø§Ø± Ø²ÙŠØ± Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ \r\n\r\n',0),(155164,4311,'tr','Bir kez iÅŸ baÅŸÄ±na hesaplamalarÄ± tek S11 veya Q10 formÃ¼lde seÃ§in iÃ§in',0),(155165,4311,'pl','Dla obliczenia raz za zadanie wybraÄ‡ tylko P11 lub Q10 w formule',0),(155166,4311,'bg','Ð—Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ÑÑ‚Ð° Ð½Ð° Ð²ÐµÐ´Ð½ÑŠÐ¶ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ°Ð¼Ð¾ Ð’11 Ð¸Ð»Ð¸ Q10 Ð²ÑŠÐ² Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð°Ñ‚Ð°',0),(155167,4311,'ur','Ø§Ø³ Ù„Ø¦Û’ Ø§ÛŒÚ© Ø¨Ø§Ø± Ú©Ø§Ù… ÙÛŒ Ú©Ø§ Ø­Ø³Ø§Ø¨ ØµØ±Ù Q11 ÛŒØ§ Q10 Ù…ÛŒÚº ÙØ§Ø±Ù…ÙˆÙ„Ø§ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(155168,4311,'sr','Ð—Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð°ÑšÐµ Ñ˜ÐµÐ´Ð½Ð¾Ð¼ Ð¿Ð¾ Ð¿Ð¾ÑÐ»Ñƒ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Q11 Ð¸Ð»Ð¸ Q10 Ñƒ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð¸',0),(155169,4311,'vi','Äá»ƒ tÃ­nh toÃ¡n má»—i láº§n má»™t Job CHá»ˆ chá»n Q11 hay Q10 trong cÃ´ng thá»©c',0),(155170,4311,'af','Vir berekeninge van een keer per taak kies slegs Q11 of Q10 in die formule',0),(155171,4311,'ro','Pentru calcule de datÄƒ per lucrare selectaÅ£i numai Q11 sau Q10 Ã®n Formula',0),(155172,4311,'et','Sest Ã¼ks kord tÃ¶Ã¶ arvutused valige ainult Q11 vÃµi Q10 valem',0),(155173,4311,'si','Za izraÄune enkrat na delo izberite samo v11 ali Q10 v formuli',0),(155174,4311,'ba','Untuk perhitungan sekali per pekerjaan pilih hanya Q11 atau Q10 dalam Formula',0),(155175,4311,'nl','Voor berekeningen van eenmaal per baan selecteert u enige Q11 of Q10 in de formule',0),(155176,4311,'fi','Laskelmat kerran tyÃ¶kohtainen valita vain Q11 tai Q10 kaava',0),(155177,4311,'no','For beregning av Ã©n gang per jobb velger bare S11 eller Q10 i formelen',0),(155178,4311,'da','For beregninger af Ã©n gang pr. Job VÃ¦lg kun SP11 eller Q10 i formlen',0),(155179,4311,'ko','ìž‘ì—… ë‹¹ í•œ ë²ˆ ê³„ì‚° ìˆ˜ì‹ì—ì„œ ìœ ì¼í•œ Q11 ë˜ëŠ” Q10 ì„ íƒ',0),(155180,4311,'he','×¢×‘×•×¨ ×—×™×©×•×‘×™× ×©×œ ×¤×¢× ×œ×›×œ ×ž×©×¨×” ×‘×—×¨ ×¨×§ Q11 ××• Q10 ×‘× ×•×¡×—×”',0),(155181,4311,'el','Î“Î¹Î± Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ Ï†Î¿ÏÎ¬ ÎºÎ¬Î¸Îµ ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î¼ÏŒÎ½Î¿ Q11 Î® Q10 ÏƒÏ„Î¿Î½ Ï„ÏÏ€Î¿',0),(155182,4311,'zh','å¯¹äºŽæ¯ä¸ªä½œä¸šçš„ä¸€æ¬¡è®¡ç®—åªé€‰æ‹©å…¬å¼ä¸­çš„Q11æˆ–Q10\r\n',0),(155183,4311,'sv','FÃ¶r berÃ¤kningar av en gÃ¥ng per jobb vÃ¤ljer du endast Q11 eller Q10 i formeln',0),(155184,4311,'it','Per i calcoli di una volta al lavoro selezionare solo Q11 o Q10 nella Formula',0),(155185,4311,'tl','',0),(155186,4311,'th','For Calculations of Once per Job Select ONLY Q11 or Q10 in the Formula',0),(155187,4311,'hi','à¤²à¤¿à¤ à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¥à¤°à¤¤à¤¿ à¤à¤• à¤¬à¤¾à¤° à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤•à¥‡à¤µà¤² Q11 à¤¯à¤¾ Q10 à¤•à¤¾ à¤¸à¥‚à¤¤à¥à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(155188,4311,'ms','Untuk pengiraan sekali setiap kerja pilih hanya S11 atau Q10 dalam Formula',0),(155189,4311,'ar','Ù„ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ÙŠØ© Ù„Ù…Ø±Ø© ÙˆØ§Ø­Ø¯Ø© Ù„ÙƒÙ„ ÙˆØ¸ÙŠÙØ© ÙÙ‚Ø· Q11 Ø£Ùˆ Q10 ÙÙŠ Ø§Ù„ØµÙŠØºØ©',0),(155190,4311,'fr','Pour les calculs d\'une fois par poste sÃ©lectionnez seulement Q11 ou Q10 dans la formule',0),(155191,4311,'jp','For Calculations of Once per Job Select ONLY Q11 or Q10 in the Formula',0),(155192,4311,'pt','Para os cÃ¡lculos de uma vez por trabalho selecionam apenas Q11 ou Q10 na fÃ³rmula',0),(155193,4311,'ru','Ð”Ð»Ñ Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð¾Ð´Ð¸Ð½ Ñ€Ð°Ð· Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Q11 Ð¸Ð»Ð¸ Q10 Ð² Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ðµ',0),(155194,4311,'es','Para CÃ¡lculos de Una Vez por Trabajo. Selecciona SOLAMENTE Q11 o Q10 en la Formula',0),(155195,4311,'de','FÃ¼r Berechnungen von einmal pro Auftrag nur F11 oder Q10 in der Formel auswÃ¤hlen',0),(155196,4311,'en','For Calculations of Once per Job Select ONLY Q11 or Q10 in the Formula',0),(155197,4312,'is','',0),(155198,4312,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø´ØºÙ„ ',0),(155199,4312,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø´ØºÙ„ ',0),(155200,4312,'tr','Ä°ÅŸ miktarÄ±',0),(155201,4312,'pl','IloÅ›Ä‡ pracy',0),(155202,4312,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(155203,4312,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(155204,4312,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ð¾ÑÐ»Ð°',0),(155205,4312,'vi','Sá»‘ lÆ°á»£ng Job',0),(155206,4312,'af','Kontrakwerk Hoeveelheid',0),(155207,4312,'ro','Cantitatea de Job',0),(155208,4312,'et','Projekti kogus',0),(155209,4312,'si','Delo koliÄina',0),(155210,4312,'ba','Jumlah pekerjaan',0),(155211,4312,'nl','Baan hoeveelheid',0),(155212,4312,'fi','Projektin mÃ¤Ã¤rÃ¤',0),(155213,4312,'no','Jobb antall',0),(155214,4312,'da','Antal sager',0),(155215,4312,'ko','ìž‘ì—… ìˆ˜ëŸ‰',0),(155216,4312,'he','×›×ž×•×ª ×¢×‘×•×“×”',0),(155217,4312,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚ Î­ÏÎ³Î¿Ï…',0),(155218,4312,'zh','æ‹›è˜æ•°é‡\r\n',0),(155219,4312,'sv','Projektantal',0),(155220,4312,'it','QuantitÃ  di lavoro',0),(155221,4312,'tl','',0),(155222,4312,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3591;&#3634;&#3609;',0),(155223,4312,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(155224,4312,'ms','Kuantiti kerja',0),(155225,4312,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(155226,4312,'fr','QuantitÃ© de travail',0),(155227,4312,'jp','ä½œæ¥­æ•°é‡?',0),(155228,4312,'pt','Quantidade de trabalho',0),(155229,4312,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ð¹',0),(155230,4312,'es','Trabajo Cantidad',0),(155231,4312,'de','Job-Menge',0),(155232,4312,'en','Job Quantity',0),(155233,4313,'is','',0),(155234,4313,'dr','Ù‡ÙŠÚ† ÙØ±Ù…ÙˆÙ„ÙŠ ØªØ¹Ø±ÙŠÙ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(155235,4313,'pr','Ù‡ÙŠÚ† ÙØ±Ù…ÙˆÙ„ÙŠ ØªØ¹Ø±ÙŠÙ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(155236,4313,'tr','TanÄ±mlÄ± hiÃ§bir formÃ¼lleri',0),(155237,4313,'pl','Å»adnych formuÅ‚ okreÅ›lonych',0),(155238,4313,'bg','ÐÑÐ¼Ð° Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ€Ð°Ð½Ð¸ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð¸',0),(155239,4313,'ur','Ú©ÙˆØ¦ÛŒ ÙØ§Ø±Ù…ÙˆÙ„Û’ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(155240,4313,'sr','ÐÐµÐ¼Ð° Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ðµ Ð´ÐµÑ„Ð¸Ð½Ð¸ÑÐ°Ð½',0),(155241,4313,'vi','ChÆ°a Ä‘á»‹nh nghÄ©a cÃ´ng thá»©c',0),(155242,4313,'af','Geen formules gedefinieer',0),(155243,4313,'ro','Nici formule definite',0),(155244,4313,'et','Ei ole kindlaks mÃ¤Ã¤ratud valemeid',0),(155245,4313,'si','Ne formule, opredeljene',0),(155246,4313,'ba','Tidak ada formula yang ditetapkan',0),(155247,4313,'nl','Geen formules gedefinieerd',0),(155248,4313,'fi','MikÃ¤Ã¤n kaava mÃ¤Ã¤ritellÃ¤Ã¤n',0),(155249,4313,'no','Ingen formler definert',0),(155250,4313,'da','Ingen formler defineres',0),(155251,4313,'ko','ì•„ë‹ˆ ìˆ˜ì‹ ì •ì˜',0),(155252,4313,'he','××™×Ÿ × ×•×¡×—××•×ª ×©×”×•×’×“×¨×•',0),(155253,4313,'el','Î”ÎµÎ½ Ï„Î¿Ï…Ï‚ Ï„ÏÏ€Î¿Ï…Ï‚ Ï€Î¿Ï… Î¿ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹',0),(155254,4313,'zh','æ²¡æœ‰å…¬å¼å®šä¹‰\r\n',0),(155255,4313,'sv','Inga formler som definieras',0),(155256,4313,'it','Senza formule definite',0),(155257,4313,'tl','',0),(155258,4313,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3626;&#3641;&#3605;&#3619;',0),(155259,4313,'hi','à¤•à¥‹à¤ˆ à¤¸à¥‚à¤¤à¥à¤° à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¿à¤¤',0),(155260,4313,'ms','Tiada formula yang ditakrifkan',0),(155261,4313,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ ØµÙŠØº Ù…Ø­Ø¯Ø¯Ø©',0),(155262,4313,'fr','Aucune formule dÃ©finie',0),(155263,4313,'jp','å¼?ã?Œå®šã‚?ã‚‰ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(155264,4313,'pt','NÃ£o hÃ¡ fÃ³rmulas definidas',0),(155265,4313,'ru','ÐÐµ Ð² Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð°Ñ…, Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ñ‹Ñ…',0),(155266,4313,'es','No se Definieron unos FÃ³rmulas',0),(155267,4313,'de','Keine Formeln definiert',0),(155268,4313,'en','No Formulas Defined',0),(155269,4314,'is','',0),(155270,4314,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¬Ù‡Øª Ù‡Ø§ ',0),(155271,4314,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¬Ù‡Øª Ù‡Ø§ ',0),(155272,4314,'tr','KenarlarÄ±n sayÄ±sÄ±nÄ±',0),(155273,4314,'pl','Liczba stron',0),(155274,4314,'bg','Ð‘Ñ€Ð¾Ð¹ ÑÑ‚Ñ€Ð°Ð½Ð¸',0),(155275,4314,'ur','Ø§Ø·Ø±Ø§Ù Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(155276,4314,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(155277,4314,'vi','Sá»‘ máº·t',0),(155278,4314,'af','Aantal Kante',0),(155279,4314,'ro','NumÄƒrul de laturi',0),(155280,4314,'et','Mitu kÃ¼lge',0),(155281,4314,'si','Å tevilom stranic',0),(155282,4314,'ba','Jumlah sisi',0),(155283,4314,'nl','Aantal zijden',0),(155284,4314,'fi','Monelta suunnalta',0),(155285,4314,'no','Antall sider',0),(155286,4314,'da','Antallet af sider',0),(155287,4314,'ko','ì¸¡ì˜ ìˆ˜',0),(155288,4314,'he','×ž×¡×¤×¨ ×©×œ ×¤××•×ª',0),(155289,4314,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Ï„Ï‰Î½ Ï€Î»ÎµÏ…ÏÏŽÎ½',0),(155290,4314,'zh','å¯èƒ½çš„é›¶ä»¶æ•°é‡\r\n',0),(155291,4314,'sv','Antalet sidor',0),(155292,4314,'it','Numero di lati',0),(155293,4314,'tl','',0),(155294,4314,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3604;&#3657;&#3634;&#3609;',0),(155295,4314,'hi','à¤ªà¤•à¥à¤·à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(155296,4314,'ms','Bilangan sisi',0),(155297,4314,'ar','Ø¹Ø¯Ø¯ Ù…Ù† Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠÙ†',0),(155298,4314,'fr','Nombre de cÃ´tÃ©s',0),(155299,4314,'jp','å?´é?¢ã?®æ•°',0),(155300,4314,'pt','NÃºmero de lados',0),(155301,4314,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÑ‚Ð¾Ñ€Ð¾Ð½',0),(155302,4314,'es','NÃºmero de Lados',0),(155303,4314,'de','Anzahl der Seiten',0),(155304,4314,'en','Number of Sides',0),(155305,4315,'is','',0),(155306,4315,'dr','(Ø´Ù…Ø§Ø±Ù‡) Ø¨Ø§Ù„Ø§ Ø±ÙˆÙŠ Ø¨Ø±Ú¯Ù‡',0),(155307,4315,'pr','ØªØ¹Ø¯Ø§Ø¯(Ø´Ù…Ø§Ø±Ù‡) Ø¨Ø§Ù„Ø§ Ø±ÙˆÙŠ Ø¨Ø±Ú¯Ù‡',0),(155308,4315,'tr','Sayfadaki sayÄ±yÄ±',0),(155309,4315,'pl','Numer siÄ™ na arkuszu',0),(155310,4315,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð»Ð¸ÑÑ‚Ð°',0),(155311,4315,'ur','Ø¹Ø¯Ø¯ Ú©Ùˆ ÙˆØ±Ù‚ Ù¾Ø±',0),(155312,4315,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½Ð°Ð²Ð¸ÑˆÐµ Ð½Ð° Ñ€Ð°Ð´Ð½Ð¾Ð¼ Ð»Ð¸ÑÑ‚Ñƒ',0),(155313,4315,'vi','Sá»‘ lÃªn trang',0),(155314,4315,'af','Nommer op op vel',0),(155315,4315,'ro','NumÄƒr pe foaie',0),(155316,4315,'et','Numbri Ã¼les lehele',0),(155317,4315,'si','Å tevilo navzgor na list',0),(155318,4315,'ba','Jumlah up pada lembar',0),(155319,4315,'nl','Nummer omhoog op blad',0),(155320,4315,'fi','Luvun ylÃ¶spÃ¤in arkin',0),(155321,4315,'no','Tall oppover pÃ¥ ark',0),(155322,4315,'da','Nummer op pÃ¥ ark',0),(155323,4315,'ko','ì‹œíŠ¸ë¥¼ ìˆ˜',0),(155324,4315,'he','×ž×¡×¤×¨ ×ž×¢×œ×” ×¢×œ ×’×™×œ×™×•×Ÿ',0),(155325,4315,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Ï€ÏÎ¿Ï‚ Ï„Î± ÎµÏ€Î¬Î½Ï‰ ÏƒÏ„Î¿ Ï†ÏÎ»Î»Î¿',0),(155326,4315,'zh','è¡¨ä¸Šæ•°é‡å¢žåŠ \r\n',0),(155327,4315,'sv','Nummer upp pÃ¥ ark',0),(155328,4315,'it','Numero fino sul foglio',0),(155329,4315,'tl','',0),(155330,4315,'th','&#3607;&#3635;&#3651;&#3627;&#3657;&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;&#3610;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(155331,4315,'hi','à¤ªà¤¤à¥à¤°à¤• à¤ªà¤° à¤Šà¤ªà¤° à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(155332,4315,'ms','Nombor sehingga kira-kira',0),(155333,4315,'ar','Ø±Ù‚Ù… Ø§Ù„ØªØ³Ø¬ÙŠÙ„ Ø¹Ù„Ù‰ ÙˆØ±Ù‚Ø©',0),(155334,4315,'fr','Nombre vers le haut sur la feuille',0),(155335,4315,'jp','Number up on Sheet',0),(155336,4315,'pt','NÃºmero acima na folha',0),(155337,4315,'ru','Ð§Ð¸ÑÐ»Ð¾ Ð²Ð²ÐµÑ€Ñ… Ð½Ð° Ð»Ð¸ÑÑ‚Ðµ',0),(155338,4315,'es','NÃºmero mostrado en la hoja',0),(155339,4315,'de','Anzahl up auf Blatt',0),(155340,4315,'en','Number up on Sheet',0),(155341,4316,'is','',0),(155342,4316,'dr','Ø¬ÙˆØ§Ø¨ Ø¹Ø¯Ø¯ÙŠ',0),(155343,4316,'pr','Ø¬ÙˆØ§Ø¨ Ø¹Ø¯Ø¯ÙŠ',0),(155344,4316,'tr','SayÄ±sal cevap',0),(155345,4316,'pl','OdpowiedÅº liczbowÄ…',0),(155346,4316,'bg','Ð¦Ð¸Ñ„Ñ€Ð¾Ð²Ð¸ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€Ð¸',0),(155347,4316,'ur','Ù†Ù…Ø¨Ø±ÛŒ Ø¬ÙˆØ§Ø¨',0),(155348,4316,'sr','ÐÑƒÐ¼ÐµÑ€Ð¸Ñ‡ÐºÐ¸ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€',0),(155349,4316,'vi','Tráº£ lá»i sá»‘',0),(155350,4316,'af','Numeriese Antwoord',0),(155351,4316,'ro','Raspuns numeric',0),(155352,4316,'et','Numbriline vastus',0),(155353,4316,'si','Å tevilski odgovor',0),(155354,4316,'ba','Jawaban numerik',0),(155355,4316,'nl','Numeriek antwoord',0),(155356,4316,'fi','Numeerinen vastaus',0),(155357,4316,'no','Numerisk svar',0),(155358,4316,'da','Numerisk svar',0),(155359,4316,'ko','ìˆ«ìž ëŒ€ë‹µ',0),(155360,4316,'he','×ª×©×•×‘×” ×ž×¡×¤×¨×™×ª',0),(155361,4316,'el','Î‘ÏÎ¹Î¸Î¼Î·Ï„Î¹ÎºÎ® Î±Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(155362,4316,'zh','æ•°å€¼ç­”æ¡ˆ\r\n',0),(155363,4316,'sv','Numeriskt svar',0),(155364,4316,'it','Risposta numerica',0),(155365,4316,'tl','',0),(155366,4316,'th','&#3605;&#3629;&#3610;&#3648;&#3611;&#3655;&#3609;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;',0),(155367,4316,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾à¤¤à¥à¤®à¤• à¤œà¤µà¤¾à¤¬',0),(155368,4316,'ms','Angka jawapan',0),(155369,4316,'ar','Ø¬ÙˆØ§Ø¨ Ø±Ù‚Ù…ÙŠ',0),(155370,4316,'fr','RÃ©ponse numÃ©rique',0),(155371,4316,'jp','æ•°å­—å›žç­”',0),(155372,4316,'pt','Resposta numÃ©rica',0),(155373,4316,'ru','Ð§Ð¸ÑÐ»Ð¾Ð²Ð¾Ð¹ ÐžÑ‚Ð²ÐµÑ‚',0),(155374,4316,'es','Respuesta NumÃ©rica',0),(155375,4316,'de','Numerische Antwort',0),(155376,4316,'en','Numeric Answer',0),(155377,4317,'is','',0),(155378,4317,'dr','Ø²Ù…Ø§Ù† Ø¯ÙŠÚ¯Ø± ',0),(155379,4317,'pr','Ø²Ù…Ø§Ù† Ø¯ÙŠÚ¯Ø± ',0),(155380,4317,'tr','TimeClock baÅŸka zaman',0),(155381,4317,'pl','TimeClock innym razem',0),(155382,4317,'bg','TimeClock Ð´Ñ€ÑƒÐ³Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(155383,4317,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ø¯ÙˆØ³Ø±Û’ ÙˆÙ‚Øª',0),(155384,4317,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð´Ñ€ÑƒÐ³Ð¸ Ð¿ÑƒÑ‚',0),(155385,4317,'vi','Thá»i gian khÃ¡c',0),(155386,4317,'af','Ander Tyd',0),(155387,4317,'ro','Ceas timp alte',0),(155388,4317,'et','TimeClock muul ajal',0),(155389,4317,'si','TimeClock drugi Äas',0),(155390,4317,'ba','Timeclock waktu lain',0),(155391,4317,'nl','Klok andere tijd',0),(155392,4317,'fi','Timeclock toiste',0),(155393,4317,'no','TimeClock andre gang',0),(155394,4317,'da','Timeclock anden gang',0),(155395,4317,'ko','ë‹¤ë¥¸ ì‹œê°„ì— Timeclock',0),(155396,4317,'he','×–×ž×Ÿ ××—×¨',0),(155397,4317,'el','Timeclock Î¬Î»Î»Î· Ï†Î¿ÏÎ¬',0),(155398,4317,'zh','å…¶ä»–æ—¶é—´\r\n',0),(155399,4317,'sv','Timeclock andra tid',0),(155400,4317,'it','Timeclock altra volta',0),(155401,4317,'tl','',0),(155402,4317,'th','&#3648;&#3623;&#3621;&#3634;&#3629;&#3639;&#3656;&#3609;',0),(155403,4317,'hi','Timeclock à¤…à¤¨à¥à¤¯ à¤¸à¤®à¤¯',0),(155404,4317,'ms','Timeclock masa',0),(155405,4317,'ar','ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(155406,4317,'fr','Timeclock autres temps',0),(155407,4317,'jp','ä»–ã?®æ™‚é–“',0),(155408,4317,'pt','Timeclock outra vez',0),(155409,4317,'ru','Ð”Ñ€ÑƒÐ³Ð¾Ðµ Ð’Ñ€ÐµÐ¼Ñ',0),(155410,4317,'es','Otro Tiempo',0),(155411,4317,'de','Timeclock andermal',0),(155412,4317,'en','Timeclock Other Time',0),(155413,4318,'is','',0),(155414,4318,'dr','Ø·ÙˆÙ„ ÙƒØ§ØºØ°',0),(155415,4318,'pr','Ø·ÙˆÙ„ ÙƒØ§ØºØ°',0),(155416,4318,'tr','KaÄŸÄ±t uzunluÄŸu',0),(155417,4318,'pl','DÅ‚ugoÅ›Ä‡ papieru',0),(155418,4318,'bg','Ð¥Ð°Ñ€Ñ‚Ð¸ÑÑ‚Ð° Ð´ÑŠÐ»Ð¶Ð¸Ð½Ð°',0),(155419,4318,'ur','Ú©Ø§ØºØ° Ú©ÛŒ Ù„Ù…Ø¨Ø§Ø¦ÛŒ',0),(155420,4318,'sr','Ð”ÑƒÐ¶Ð¸Ð½Ð° Ð¿Ð°Ð¿Ð¸Ñ€Ð°',0),(155421,4318,'vi','Chiá»u dÃ i giáº¥y',0),(155422,4318,'af','Papierlengte',0),(155423,4318,'ro','Lungime de hÃ¢rtie',0),(155424,4318,'et','Paberi pikkus',0),(155425,4318,'si','DolÅ¾ina papirja',0),(155426,4318,'ba','Panjang kertas',0),(155427,4318,'nl','Papierlengte',0),(155428,4318,'fi','Paperipituus',0),(155429,4318,'no','Papirlengden',0),(155430,4318,'da','PapirlÃ¦ngde',0),(155431,4318,'ko','ìš©ì§€ ê¸¸ì´',0),(155432,4318,'he','××•×¨×š ×“×£',0),(155433,4318,'el','Î¤Î¿ Î¼Î®ÎºÎ¿Ï‚ Î­Î³Î³ÏÎ±Ï†Î¿',0),(155434,4318,'zh','çº¸å¼ é•¿åº¦\r\n',0),(155435,4318,'sv','PapperslÃ¤ngden',0),(155436,4318,'it','Lunghezza carta',0),(155437,4318,'tl','',0),(155438,4318,'th','&#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623;&#3586;&#3629;&#3591;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(155439,4318,'hi','à¤•à¤¾à¤—à¤œ à¤•à¥€ à¤²à¤‚à¤¬à¤¾à¤ˆ',0),(155440,4318,'ms','Panjang kertas',0),(155441,4318,'ar','Ø·ÙˆÙ„ Ø§Ù„ÙˆØ±Ù‚Ø©',0),(155442,4318,'fr','Longueur de papier',0),(155443,4318,'jp','ç´™é•·ã?•',0),(155444,4318,'pt','Comprimento do papel',0),(155445,4318,'ru','Ð”Ð»Ð¸Ð½Ð° Ð±ÑƒÐ¼Ð°Ð³Ð¸',0),(155446,4318,'es','Largo de Papel',0),(155447,4318,'de','PapierlÃ¤nge',0),(155448,4318,'en','Paper Length',0),(155449,4319,'is','',0),(155450,4319,'dr','Ø¹Ø±Ø¶ ÙƒØ§ØºØ°',0),(155451,4319,'pr','Ø¹Ø±Ø¶ ÙƒØ§ØºØ°',0),(155452,4319,'tr','KaÄŸÄ±t geniÅŸliÄŸi',0),(155453,4319,'pl','SzerokoÅ›Ä‡ papieru',0),(155454,4319,'bg','Ð¨Ð¸Ñ€Ð¸Ð½Ð°Ñ‚Ð° Ð½Ð° Ñ…Ð°Ñ€Ñ‚Ð¸ÑÑ‚Ð°',0),(155455,4319,'ur','Ú©Ø§ØºØ° Ú†ÙˆÚ‘Ø§Ø¦ÛŒ',0),(155456,4319,'sr','Ð¨Ð¸Ñ€Ð¸Ð½Ð° Ð¿Ð°Ð¿Ð¸Ñ€Ð°',0),(155457,4319,'vi','Chiá»u rá»™ng giáº¥y',0),(155458,4319,'af','Papierwydte',0),(155459,4319,'ro','LÄƒÈ›ime hÃ¢rtie',0),(155460,4319,'et','Paberi laius',0),(155461,4319,'si','Å irina papirja',0),(155462,4319,'ba','Lebar kertas',0),(155463,4319,'nl','Breedte van het papier',0),(155464,4319,'fi','Paperin leveys',0),(155465,4319,'no','Papirbredde',0),(155466,4319,'da','Papirbredde',0),(155467,4319,'ko','ìš©ì§€ ë„ˆë¹„',0),(155468,4319,'he','×¨×•×—×‘ ×“×£',0),(155469,4319,'el','Î Î»Î¬Ï„Î¿Ï‚ Ï‡Î±ÏÏ„Î¹Î¿Ï',0),(155470,4319,'zh','çº¸å¼ å®½åº¦\r\n',0),(155471,4319,'sv','Pappersbredd',0),(155472,4319,'it','Larghezza carta',0),(155473,4319,'tl','',0),(155474,4319,'th','&#3588;&#3623;&#3634;&#3617;&#3585;&#3623;&#3657;&#3634;&#3591;&#3586;&#3629;&#3591;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(155475,4319,'hi','à¤•à¤¾à¤—à¤¼à¤œà¤¼ à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ',0),(155476,4319,'ms','Lebar kertas',0),(155477,4319,'ar','Ø¹Ø±Ø¶ Ø§Ù„ÙˆØ±Ù‚Ø©',0),(155478,4319,'fr','Largeur du papier',0),(155479,4319,'jp','ç´™å¹…',0),(155480,4319,'pt','Largura do papel',0),(155481,4319,'ru','Ð¨Ð¸Ñ€Ð¸Ð½Ð° Ð±ÑƒÐ¼Ð°Ð³Ð¸',0),(155482,4319,'es','Anchura de Papel',0),(155483,4319,'de','Papierbreite',0),(155484,4319,'en','Paper Width',0),(155485,4320,'is','',0),(155486,4320,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù‡Ø± Ù‚Ø³Ù…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(155487,4320,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù‡Ø± Ù‚Ø³Ù…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(155488,4320,'tr','Miktar her bÃ¶lÃ¼mÃ¼ (stok)',0),(155489,4320,'pl','IloÅ›Ä‡ kaÅ¼dej czÄ™Å›ci (czas)',0),(155490,4320,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²ÑÑÐºÐ° Ñ‡Ð°ÑÑ‚ (ÑÐºÐ»Ð°Ð´)',0),(155491,4320,'ur','Ù…Ù‚Ø¯Ø§Ø± ÛØ± Ø­ØµÛ’ (Ø§Ø³Ù¹Ø§Ú©)',0),(155492,4320,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑÐ²Ð°ÐºÐ¸ ÑÐµÐ³Ð¼ÐµÐ½Ñ‚ (Ð°ÐºÑ†Ð¸Ñ˜Ð°)',0),(155493,4320,'vi','Sá»‘ lÆ°á»£ng má»—i phá»¥ tÃ¹ng (hÃ ng tá»“n)',0),(155494,4320,'af','Hoeveelheid Elke Onderdeel (Voorraad)',0),(155495,4320,'ro','Cantitatea fiecare parte (stoc)',0),(155496,4320,'et','Kogus iga osa (laos)',0),(155497,4320,'si','KoliÄina vsakega dela (zalog)',0),(155498,4320,'ba','Kuantitas setiap bagian (Stock)',0),(155499,4320,'nl','Hoeveelheid elk deel (Stock)',0),(155500,4320,'fi','MÃ¤Ã¤rÃ¤ kunkin osan (varastossa)',0),(155501,4320,'no','Antall hver del (Stock)',0),(155502,4320,'da','MÃ¦ngde hver del (lager)',0),(155503,4320,'ko','ìˆ˜ëŸ‰ ê° ë¶€ë¶„ (ì£¼ì‹)',0),(155504,4320,'he','×›×ž×•×ª ×›×œ ×—×œ×§ (×ž× ×™×•×ª)',0),(155505,4320,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎºÎ¬Î¸Îµ Î¼Î­ÏÎ¿Ï‚ (Stock)',0),(155506,4320,'zh','å„ä¸ªéƒ¨ä»¶çš„æ•°é‡ï¼ˆè‚¡ï¼‰\r\n',0),(155507,4320,'sv','Kvantitet varje del (lager)',0),(155508,4320,'it','QuantitÃ  ogni parte (Stock)',0),(155509,4320,'tl','',0),(155510,4320,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3649;&#3605;&#3656;&#3621;&#3632;&#3626;&#3656;&#3623;&#3609; (&#3626;&#3605;&#3658;&#3629;&#3585;)',0),(155511,4320,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤­à¤¾à¤— (à¤¶à¥‡à¤¯à¤°)',0),(155512,4320,'ms','Kuantiti setiap bahagian (saham)',0),(155513,4320,'ar','ÙƒÙ…ÙŠØ© ÙƒÙ„ Ø¬Ø²Ø¡ (Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ©)',0),(155514,4320,'fr','QuantitÃ© chaque partie (Stock)',0),(155515,4320,'jp','éƒ¨å“?ã?”ã?¨ã?®æ•°é‡?ï¼ˆåœ¨åº«ï¼‰',0),(155516,4320,'pt','Quantidade cada parte (estoque)',0),(155517,4320,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÐ°Ð¶Ð´Ð¾Ð¹ Ñ‡Ð°ÑÑ‚Ð¸ (ÑÑ‚Ð¾Ðº)',0),(155518,4320,'es','Cantidad Cada Parte (Stock)',0),(155519,4320,'de','Menge jeder Teil (Stock)',0),(155520,4320,'en','Quantity Each Part (Stock)',0),(155521,4321,'is','',0),(155522,4321,'dr','Ù†ØªÙŠØ¬Ù‡ Ø³Ø§Ø¹Ø§Øª Ø§Ø³Øª ',0),(155523,4321,'pr','Ù†ØªÙŠØ¬Ù‡ Ø³Ø§Ø¹Ø§Øª Ø§Ø³Øª ',0),(155524,4321,'tr','Saat sonucudur',0),(155525,4321,'pl','Wynik jest godzin',0),(155526,4321,'bg','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚ÑŠÑ‚ Ðµ Ñ‡Ð°ÑÐ°',0),(155527,4321,'ur','Ù†ØªÛŒØ¬Û Ú¯Ú¾Ù†Ù¹Û’ ÛÛ’ Û”',0),(155528,4321,'sr','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚ Ñ˜Ðµ ÑÐ°Ñ‚Ð¸',0),(155529,4321,'vi','Káº¿t quáº£ lÃ  giá» ',0),(155530,4321,'af','Resultate is Ure',0),(155531,4321,'ro','Rezultatul este de ore',0),(155532,4321,'et','Tulemuseks on tundi',0),(155533,4321,'si','Rezultat je ur',0),(155534,4321,'ba','Hasilnya adalah jam',0),(155535,4321,'nl','Resultaat is uur',0),(155536,4321,'fi','Tulos on',0),(155537,4321,'no','Resultatet er timer',0),(155538,4321,'da','Resultatet er timer',0),(155539,4321,'ko','ê²°ê³¼ ì‹œê°„',0),(155540,4321,'he','×”×ª×•×¦××” ×”×™× ×©×¢×•×ª',0),(155541,4321,'el','Î‘Ï€Î¿Ï„Î­Î»ÎµÏƒÎ¼Î± ÎµÎ¯Î½Î±Î¹ ÏŽÏÎµÏ‚',0),(155542,4321,'zh','ç»“æžœæ˜¯å°æ—¶\r\n',0),(155543,4321,'sv','Resultatet Ã¤r timmar',0),(155544,4321,'it','Risultato Ã¨ ore',0),(155545,4321,'tl','',0),(155546,4321,'th','&#3612;&#3621;&#3621;&#3633;&#3614;&#3608;&#3660;&#3648;&#3611;&#3655;&#3609;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(155547,4321,'hi','à¤¨à¤¤à¥€à¤œà¤¾ à¤¹à¥ˆ à¤˜à¤‚à¤Ÿà¥‹à¤‚',0),(155548,4321,'ms','Hasilnya adalah jam',0),(155549,4321,'ar','ÙˆØ§Ù„Ù†ØªÙŠØ¬Ø© Ù‡ÙŠ Ø³Ø§Ø¹Ø§Øª',0),(155550,4321,'fr','Il en rÃ©sulte heures',0),(155551,4321,'jp','çµ?æžœã?¯å‹¤å‹™æ™‚é–“ã?§ã?™',0),(155552,4321,'pt','Resultado Ã© horas',0),(155553,4321,'ru','Ð ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ð¾Ð¼ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ñ‡Ð°ÑÐ¾Ð²',0),(155554,4321,'es','Resultado es Horas',0),(155555,4321,'de','Ergebnis ist Stunden',0),(155556,4321,'en','Result is Hours',0),(155557,4322,'is','',0),(155558,4322,'dr','Ø²Ù…Ø§Ù† Ø§Ø¬Ø±Ø§',0),(155559,4322,'pr','Ø²Ù…Ø§Ù† Ø§Ø¬Ø±Ø§',0),(155560,4322,'tr','Ã‡alÄ±ÅŸma ZamanÄ±',0),(155561,4322,'pl','Czas jednostkowy',0),(155562,4322,'bg','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(155563,4322,'ur','Ú†Ù„Øª ÙˆÙ‚Øª',0),(155564,4322,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð¸Ð·Ð²Ð¾Ñ’ÐµÑšÐ°',0),(155565,4322,'vi','Cháº¡y thá»i gian',0),(155566,4322,'af','Loop Tyd',0),(155567,4322,'ro','Timpul de rulare',0),(155568,4322,'et','KÃ¤itusaeg',0),(155569,4322,'si','ÄŒas izdelave',0),(155570,4322,'ba','Waktu berjalan',0),(155571,4322,'nl','Bewerkingstijd',0),(155572,4322,'fi','Ajoaika',0),(155573,4322,'no','KjÃ¸retid',0),(155574,4322,'da','LÃ¸be tid',0),(155575,4322,'ko','ì‹¤í–‰ ì‹œê°„',0),(155576,4322,'he','×‘×–×ž×Ÿ ×¨×™×¦×”',0),(155577,4322,'el','Î§ÏÏŒÎ½Î¿Ï‚ ÎµÎºÏ„Î­Î»ÎµÏƒÎ·Ï‚',0),(155578,4322,'zh','è¿è¡Œæ—¶é—´\r\n',0),(155579,4322,'sv','KÃ¶rtid',0),(155580,4322,'it','Tempo di esecuzione',0),(155581,4322,'tl','',0),(155582,4322,'th','&#3648;&#3623;&#3621;&#3634;&#3605;&#3656;&#3629;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;',0),(155583,4322,'hi','à¤°à¤¨ à¤Ÿà¤¾à¤‡à¤®',0),(155584,4322,'ms','Jalankan masa',0),(155585,4322,'ar','ÙˆÙ‚Øª Ø§Ù„ØªØ´ØºÙŠÙ„',0),(155586,4322,'fr','Moment de l\'exÃ©cution',0),(155587,4322,'jp','å®Ÿè¡Œæ™‚é–“',0),(155588,4322,'pt','Tempo de execuÃ§Ã£o',0),(155589,4322,'ru','Ð’Ð¾ Ð²Ñ€ÐµÐ¼Ñ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(155590,4322,'es','Tiempo de Corrida',0),(155591,4322,'de','Laufzeit',0),(155592,4322,'en','Run Time',0),(155593,4323,'is','',0),(155594,4323,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ ÙØ±Ù…ÙˆÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ',0),(155595,4323,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ ÙØ±Ù…ÙˆÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ',0),(155596,4323,'tr','GÃ¼ncelleÅŸtirme iÃ§in bir formÃ¼l seÃ§in',0),(155597,4323,'pl','Wybierz wzÃ³r do aktualizacji',0),(155598,4323,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(155599,4323,'ur','Ø§ÛŒÚ© ÙØ§Ø±Ù…ÙˆÙ„Ø§ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(155600,4323,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ñƒ Ð·Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(155601,4323,'vi','Chá»n 1 cÃ´ng thá»©c Ä‘á»ƒ cáº­p nháº­t',0),(155602,4323,'af','Selekteer \'n Formule om te Opdateer',0),(155603,4323,'ro','SelectaÅ£i o formulÄƒ pentru actualizare',0),(155604,4323,'et','Valige VÃ¤rskenda valem',0),(155605,4323,'si','Izberite formulo za posodobitev',0),(155606,4323,'ba','Pilih Formula Update',0),(155607,4323,'nl','Een formule aan Update selecteert',0),(155608,4323,'fi','Valitse kaava, jolla pÃ¤ivitys',0),(155609,4323,'no','Velg en formel for Ã¥ oppdatere',0),(155610,4323,'da','VÃ¦lg en formel til opdatering',0),(155611,4323,'ko','ì—…ë°ì´íŠ¸ í•˜ëŠ” ìˆ˜ì‹ì„ ì„ íƒí•©ë‹ˆë‹¤',0),(155612,4323,'he','×‘×—×¨ ×‘× ×•×¡×—×” ×œ×¢×“×›×•×Ÿ',0),(155613,4323,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î±Î½ Ï„ÏÏ€Î¿ Î³Î¹Î± Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(155614,4323,'zh','é€‰æ‹©ä¸€ä¸ªå…¬å¼æ¥æ›´æ–°\r\n',0),(155615,4323,'sv','VÃ¤lj en formel fÃ¶r att uppdatera',0),(155616,4323,'it','Scegliere una Formula di aggiornamento',0),(155617,4323,'tl','',0),(155618,4323,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3641;&#3605;&#3619;&#3607;&#3637;&#3656;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(155619,4323,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤¸à¥€ à¤¸à¥‚à¤¤à¥à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(155620,4323,'ms','Pilih satu Formula untuk Kemaskini',0),(155621,4323,'ar','Ø­Ø¯Ø¯ ØµÙŠØºØ© Ù„Ù„ØªØ­Ø¯ÙŠØ«',0),(155622,4323,'fr','Choisissez une formule de mise Ã  jour',0),(155623,4323,'jp','æ›´æ–°ã?™ã‚‹å¼?ã?®é?¸æŠž',0),(155624,4323,'pt','Selecione uma fÃ³rmula para atualizaÃ§Ã£o',0),(155625,4323,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ñƒ Ð´Ð»Ñ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(155626,4323,'es','Seleccionar una Formula para Actualizar',0),(155627,4323,'de','WÃ¤hlen Sie eine Formel, um Update',0),(155628,4323,'en','Select a Formula to Update',0),(155629,4324,'is','',0),(155630,4324,'dr','Ø®Ù„Ø§ØµÙ‡ Ù†ÙˆÙŠØ³ÙŠ Ø¨Ø±Ø§ ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± ÙØ±Ù…ÙˆÙ„ Ù‡Ø§',0),(155631,4324,'pr','Ø®Ù„Ø§ØµÙ‡ Ù†ÙˆÙŠØ³ÙŠ Ø¨Ø±Ø§ ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± ÙØ±Ù…ÙˆÙ„ Ù‡Ø§',0),(155632,4324,'tr','Steno formÃ¼lleri kullanmak iÃ§in',0),(155633,4324,'pl','SkrÃ³t do wykorzystania w formuÅ‚ach',0),(155634,4324,'bg','Ð¡Ñ‚ÐµÐ½Ð¾Ð³Ñ€Ð°Ð¼Ð¸Ñ‚Ðµ Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð²ÑŠÐ² Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð¸',0),(155635,4324,'ur','ÙØ§Ø±Ù…ÙˆÙ„Û’ Ù…ÛŒÚº Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø´ÙˆØ±Ù¹Ø­Ù†Úˆ',0),(155636,4324,'sr','Ð¡ÐºÑ€Ð°Ñ›ÐµÐ½Ð¸Ñ†Ð° Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ Ñƒ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð°Ð¼Ð°',0),(155637,4324,'vi','PhÃ©p tá»‘c kÃ½ dÃ¹ng trong cÃ´ng thá»©c',0),(155638,4324,'af','Snelskrif vir gebruik in formules',0),(155639,4324,'ro','Prescurtare pentru utilizarea Ã®n formule',0),(155640,4324,'et','LÃ¼hendvormina kasutamine valemites',0),(155641,4324,'si','OkrajÅ¡ava za uporabo v formulah',0),(155642,4324,'ba','Singkatan untuk digunakan dalam formula',0),(155643,4324,'nl','Steno voor gebruik in formules',0),(155644,4324,'fi','LyhenteenÃ¤ kÃ¤ytetÃ¤Ã¤n kaavoissa',0),(155645,4324,'no','Forkortelse for bruk i formler',0),(155646,4324,'da','Forkortelse til brug i formler',0),(155647,4324,'ko','ìˆ˜ì‹ì—ì„œ ì‚¬ìš© í•˜ê¸° ìœ„í•´ ì†ê¸°',0),(155648,4324,'he','×§×™×¦×•×¨ ×œ×©×™×ž×•×© ×‘× ×•×¡×—××•×ª',0),(155649,4324,'el','Î£Ï…Î½Ï„Î¿Î¼Î¿Î³ÏÎ±Ï†Î¯Î± Î³Î¹Î± Ï‡ÏÎ®ÏƒÎ· ÏƒÎµ Ï„ÏÏ€Î¿Ï…Ï‚',0),(155650,4324,'zh','åœ¨å…¬å¼ä¸­ä½¿ç”¨çš„ç®€å†™\r\n',0),(155651,4324,'sv','FÃ¶rkortning fÃ¶r anvÃ¤ndning i formler',0),(155652,4324,'it','Stenografia per uso nelle formule',0),(155653,4324,'tl','',0),(155654,4324,'th','&#3594;&#3623;&#3648;&#3621;&#3586;&#3648;&#3614;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3651;&#3609;&#3626;&#3641;&#3605;&#3619;',0),(155655,4324,'hi','à¤¸à¥‚à¤¤à¥à¤°à¥‹à¤‚ à¤®à¥‡à¤‚ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¶à¥à¤²à¤¿à¤ªà¤¿',0),(155656,4324,'ms','Singkatan untuk digunakan dalam Formula',0),(155657,4324,'ar','Ø§Ø®ØªØ²Ø§Ù„ Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…Ù‡Ø§ ÙÙŠ Ø§Ù„ØµÙŠØº',0),(155658,4324,'fr','Raccourci pour utilisation dans les formules',0),(155659,4324,'jp','å¼?ã?«ä½¿ç”¨ã?™ã‚‹ç•¥è¨˜',0),(155660,4324,'pt','Taquigrafia para uso em fÃ³rmulas',0),(155661,4324,'ru','Ð£ÑÐ»Ð¾Ð²Ð½Ð¾Ðµ Ð¾Ð±Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð´Ð»Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð² Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð°Ñ…',0),(155662,4324,'es','Abreviatura para uso en FÃ³rmulas',0),(155663,4324,'de','Kurzform fÃ¼r den Einsatz in Formeln',0),(155664,4324,'en','Shorthand for use in Formulas',0),(155665,4325,'is','',0),(155666,4325,'dr','Ø§Ù…ØªØ­Ø§Ù† Ø§ÙŠÙ† ',0),(155667,4325,'pr','Ø§Ù…ØªØ­Ø§Ù† Ø§ÙŠÙ† ',0),(155668,4325,'tr','Bu test',0),(155669,4325,'pl','Test ten',0),(155670,4325,'bg','Ð¢Ð¾Ð·Ð¸ Ñ‚ÐµÑÑ‚',0),(155671,4325,'ur','ÛŒÛ Ù¹ÛŒØ³Ù¹',0),(155672,4325,'sr','Ð¢ÐµÑÑ‚Ð¸Ñ€Ð°Ñ˜ Ð¾Ð²Ð¾',0),(155673,4325,'vi','Kiá»ƒm tra cÃ¡i nÃ y',0),(155674,4325,'af','Toets Hierdie',0),(155675,4325,'ro','Testa acest lucru',0),(155676,4325,'et','Seda kontrollida',0),(155677,4325,'si','Ta test',0),(155678,4325,'ba','Tes ini',0),(155679,4325,'nl','Deze test',0),(155680,4325,'fi','Testata tÃ¤tÃ¤',0),(155681,4325,'no','Teste dette',0),(155682,4325,'da','Teste dette',0),(155683,4325,'ko','ì´ í…ŒìŠ¤íŠ¸',0),(155684,4325,'he','×–×” ×ž×‘×—×Ÿ',0),(155685,4325,'el','Î”Î¿ÎºÎ¹Î¼Î® Î±Ï…Ï„ÏŒ',0),(155686,4325,'zh','æµ‹è¯•æ­¤\r\n',0),(155687,4325,'sv','Testa detta',0),(155688,4325,'it','Prova questa',0),(155689,4325,'tl','',0),(155690,4325,'th','&#3607;&#3604;&#3626;&#3629;&#3610;&#3609;&#3637;&#3657;',0),(155691,4325,'hi','à¤‡à¤¸ à¤ªà¤°à¥€à¤•à¥à¤·à¤£',0),(155692,4325,'ms','Ujian ini',0),(155693,4325,'ar','Ù‡Ø°Ø§ Ø§Ù„Ø§Ø®ØªØ¨Ø§Ø±',0),(155694,4325,'fr','Tester cette',0),(155695,4325,'jp','ã?“ã‚Œã‚’ãƒ†ã‚¹ãƒˆã?™ã‚‹',0),(155696,4325,'pt','Testar isso',0),(155697,4325,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾',0),(155698,4325,'es','Probar Ã‰ste',0),(155699,4325,'de','Testen Sie dies',0),(155700,4325,'en','Test This',0),(155701,4326,'is','',0),(155702,4326,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾ÙŠØ¯Ø§ ÙƒØ±Ø¯Ù† Ù†ÙŠØ³Øª ',0),(155703,4326,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾ÙŠØ¯Ø§ ÙƒØ±Ø¯Ù† Ù†ÙŠØ³Øª ',0),(155704,4326,'tr','Yapamaz-e doÄŸru bulmak',0),(155705,4326,'pl','NiesÅ‚abnÄ…cy wobec znaleÅºÄ‡',0),(155706,4326,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸',0),(155707,4326,'ur','ØªÙ„Ø§Ø´ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(155708,4326,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸',0),(155709,4326,'vi','KhÃ´ng tÃ¬m tháº¥y',0),(155710,4326,'af','Kan nie vind nie',0),(155711,4326,'ro','Imposibilitatea de a gÄƒsi',0),(155712,4326,'et','Ei saa leida',0),(155713,4326,'si','Ni mogoÄe najti',0),(155714,4326,'ba','Tidak dapat menemukan',0),(155715,4326,'nl','Niet in staat om te zoeken',0),(155716,4326,'fi','Estynyt jotta hankkia',0),(155717,4326,'no','Kan ikke finne',0),(155718,4326,'da','Stand til at finde',0),(155719,4326,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(155720,4326,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×¦×•×',0),(155721,4326,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· ÎµÏÏÎµÏƒÎ·',0),(155722,4326,'zh','æ— æ³•æ‰¾åˆ°\r\n',0),(155723,4326,'sv','Det gick inte att hitta',0),(155724,4326,'it','Incapace di trovare',0),(155725,4326,'tl','',0),(155726,4326,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3588;&#3657;&#3609;&#3627;&#3634;',0),(155727,4326,'hi','à¤¢à¥‚à¤à¤¢à¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(155728,4326,'ms','Tidak dapat mencari',0),(155729,4326,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(155730,4326,'fr','Incapable de trouver',0),(155731,4326,'jp','è¦‹ã?¤ã?‘ã‚‰ã‚Œã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(155732,4326,'pt','NÃ£o foi possÃ­vel encontrar',0),(155733,4326,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð½Ð°Ð¹Ñ‚Ð¸',0),(155734,4326,'es','No se Puede Encontrar',0),(155735,4326,'de','Nicht in der Lage zu finden',0),(155736,4326,'en','Unable to Find',0),(155737,4327,'is','',0),(155738,4327,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡',0),(155739,4327,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡',0),(155740,4327,'tr','Hesaplama',0),(155741,4327,'pl','Obliczanie',0),(155742,4327,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ',0),(155743,4327,'ur','Ø­Ø³Ø§Ø¨',0),(155744,4327,'sr','ÐžÐ±Ñ€Ð°Ñ‡ÑƒÐ½',0),(155745,4327,'vi','TÃ­nh toÃ¡n',0),(155746,4327,'af','Berekening',0),(155747,4327,'ro','Calculul',0),(155748,4327,'et','Arvutamine',0),(155749,4327,'si','IzraÄun',0),(155750,4327,'ba','Perhitungan',0),(155751,4327,'nl','Berekening',0),(155752,4327,'fi','Laskenta',0),(155753,4327,'no','Beregning',0),(155754,4327,'da','Beregning',0),(155755,4327,'ko','ê³„ì‚°',0),(155756,4327,'he','×—×™×©×•×‘',0),(155757,4327,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚',0),(155758,4327,'zh','è®¡ç®—\r\n',0),(155759,4327,'sv','BerÃ¤kning',0),(155760,4327,'it','Calcolo',0),(155761,4327,'tl','',0),(155762,4327,'th','&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(155763,4327,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¨',0),(155764,4327,'ms','Pengiraan',0),(155765,4327,'ar','Ø­Ø³Ø§Ø¨',0),(155766,4327,'fr','Calcul',0),(155767,4327,'jp','è¨ˆç®—',0),(155768,4327,'pt','CÃ¡lculo',0),(155769,4327,'ru','Ð Ð°ÑÑ‡ÐµÑ‚',0),(155770,4327,'es','CÃ¡lculo',0),(155771,4327,'de','Berechnung',0),(155772,4327,'en','Calculation',0),(155773,4328,'is','',0),(155774,4328,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù†Ø§Ø¯Ø±Ø³Øª',0),(155775,4328,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù†Ø§Ø¯Ø±Ø³Øª',0),(155776,4328,'tr','GeÃ§ersiz hesaplama',0),(155777,4328,'pl','NieprawidÅ‚owe obliczenie',0),(155778,4328,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ',0),(155779,4328,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ø­Ø³Ø§Ø¨',0),(155780,4328,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(155781,4328,'vi','TÃ­nh toÃ¡n vÃ´ hiá»‡u',0),(155782,4328,'af','Ongeldige Berekening',0),(155783,4328,'ro','Calculul nevalid',0),(155784,4328,'et','Sobimatu arvutamine',0),(155785,4328,'si','Neveljaven izraÄun',0),(155786,4328,'ba','Perhitungan tidak valid',0),(155787,4328,'nl','Ongeldige berekening',0),(155788,4328,'fi','Virheellinen laskelma',0),(155789,4328,'no','Ugyldig beregning',0),(155790,4328,'da','Ugyldig beregning',0),(155791,4328,'ko','ìž˜ëª» ëœ ê³„ì‚°',0),(155792,4328,'he','×—×™×©×•×‘ ×œ× ×—×•×§×™ ',0),(155793,4328,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(155794,4328,'zh','æ— æ•ˆçš„è®¡ç®—\r\n',0),(155795,4328,'sv','Ogiltig berÃ¤kning',0),(155796,4328,'it','Calcolo non valido',0),(155797,4328,'tl','',0),(155798,4328,'th','&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3651;&#3594;&#3657;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;\n',0),(155799,4328,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤—à¤£à¤¨à¤¾',0),(155800,4328,'ms','Pengiraan tidak sah',0),(155801,4328,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ ØºÙŠØ± ØµØ§Ù„Ø­',0),(155802,4328,'fr','Calcul non valide',0),(155803,4328,'jp','ç„¡åŠ¹ã?ªè¨ˆç®—',0),(155804,4328,'pt','CÃ¡lculo invÃ¡lido',0),(155805,4328,'ru','ÐÐµÐ²ÐµÑ€Ð½Ñ‹Ð¹ Ñ€Ð°ÑÑ‡ÐµÑ‚',0),(155806,4328,'es','CÃ¡lculo InvÃ¡lido',0),(155807,4328,'de','UngÃ¼ltige Berechnung',0),(155808,4328,'en','Invalid Calculation',0),(155809,4329,'is','',0),(155810,4329,'dr','Ù†ØªÙŠØ¬Ù‡',0),(155811,4329,'pr','Ù†ØªÙŠØ¬Ù‡',0),(155812,4329,'tr','SonuÃ§',0),(155813,4329,'pl','Wynik',0),(155814,4329,'bg','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚',0),(155815,4329,'ur','Ù†ØªÛŒØ¬Û',0),(155816,4329,'sr','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚',0),(155817,4329,'vi','Káº¿t quáº£',0),(155818,4329,'af','Uitslag',0),(155819,4329,'ro','Rezultatul',0),(155820,4329,'et','Tulemus',0),(155821,4329,'si','Rezultat',0),(155822,4329,'ba','Hasil',0),(155823,4329,'nl','Resultaat',0),(155824,4329,'fi','Tulos',0),(155825,4329,'no','Resultatet',0),(155826,4329,'da','Resultat',0),(155827,4329,'ko','ê²°ê³¼',0),(155828,4329,'he','×ª×•×¦××”',0),(155829,4329,'el','Î‘Ï€Î¿Ï„Î­Î»ÎµÏƒÎ¼Î±',0),(155830,4329,'zh','ç»“æžœ\r\n',0),(155831,4329,'sv','Resultat',0),(155832,4329,'it','Risultato',0),(155833,4329,'tl','',0),(155834,4329,'th','&#3612;&#3621;&#3621;&#3633;&#3614;&#3608;&#3660;',0),(155835,4329,'hi','à¤ªà¤°à¤¿à¤£à¤¾à¤®',0),(155836,4329,'ms','Keputusan',0),(155837,4329,'ar','Ø§Ù„Ù†ØªÙŠØ¬Ø©',0),(155838,4329,'fr','RÃ©sultat',0),(155839,4329,'jp','çµ?æžœ',0),(155840,4329,'pt','Resultado',0),(155841,4329,'ru','Ð ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚',0),(155842,4329,'es','Resultado',0),(155843,4329,'de','Ergebnis',0),(155844,4329,'en','Result',0),(155845,4330,'is','',0),(155846,4330,'dr','Ø®Ù„Ø§ØµÙ‡ Ù†ÙˆÙŠØ³ÙŠ',0),(155847,4330,'pr','Ø®Ù„Ø§ØµÙ‡ Ù†ÙˆÙŠØ³ÙŠ',0),(155848,4330,'tr','Kestirme',0),(155849,4330,'pl','SkrÃ³t',0),(155850,4330,'bg','Ð¡Ñ‚ÐµÐ½Ð¾Ð³Ñ€Ð°Ñ„',0),(155851,4330,'ur','Ø´ÙˆØ±Ù¹Ø­Ù†Úˆ',0),(155852,4330,'sr','Ð’Ñ€Ð»Ð¾ ÐºÑ€Ð°Ñ‚ÐºÐ¾',0),(155853,4330,'vi','PhÃ©p tá»‘c kÃ½',0),(155854,4330,'af','Snelskrif',0),(155855,4330,'ro','Prescurtare',0),(155856,4330,'et','Stenografisti',0),(155857,4330,'si','OkrajÅ¡ava',0),(155858,4330,'ba','Singkatan',0),(155859,4330,'nl','Steno',0),(155860,4330,'fi','Pika',0),(155861,4330,'no','Stenografi',0),(155862,4330,'da','Stenografi',0),(155863,4330,'ko','ì†ê¸°',0),(155864,4330,'he','×§×¦×¨× ×•×ª',0),(155865,4330,'el','Î£Ï„ÎµÎ½Î¿Î³ÏÎ±Ï†Î¯Î±',0),(155866,4330,'zh','é€Ÿè®°\r\n',0),(155867,4330,'sv','Stenografi',0),(155868,4330,'it','Stenografia',0),(155869,4330,'tl','',0),(155870,4330,'th','&#3594;&#3623;&#3648;&#3621;&#3586;',0),(155871,4330,'hi','à¤†à¤¶à¥à¤²à¤¿à¤ªà¤¿',0),(155872,4330,'ms','Singkatan',0),(155873,4330,'ar','Ø§Ù„Ø§Ø®ØªØ²Ø§Ù„',0),(155874,4330,'fr','StÃ©nographie',0),(155875,4330,'jp','é€Ÿè¨˜',0),(155876,4330,'pt','Taquigrafia',0),(155877,4330,'ru','Ð¡Ñ‚ÐµÐ½Ð¾Ð³Ñ€Ð°Ñ„Ð¸ÑŽ',0),(155878,4330,'es','TaquigrafÃ­a',0),(155879,4330,'de','Kurzschrift',0),(155880,4330,'en','Shorthand',0),(155881,4331,'is','',0),(155882,4331,'dr','ØªØ¹ÙŠÙŠÙ† Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§',0),(155883,4331,'pr','ØªØ¹ÙŠÙŠÙ† Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§',0),(155884,4331,'tr','HesaplamayÄ± belirtin',0),(155885,4331,'pl','OkreÅ›l obliczenia tutaj',0),(155886,4331,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ñ‚ÑƒÐº',0),(155887,4331,'ur','ÛŒÛØ§Úº Ø­Ø³Ø§Ø¨ Ú©Ø§ Ø§Ø®ØªØµØ§Øµ Ú©Ø±ÛŒÚº',0),(155888,4331,'sr','ÐžÐ´Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ Ð¾Ð²Ð´Ðµ',0),(155889,4331,'vi','Cá»¥ thá»ƒ tÃ­nh toÃ¡n á»Ÿ Ä‘Ã¢y',0),(155890,4331,'af','Spesifiseer die berekening hier',0),(155891,4331,'ro','SpecificaÅ£i calculul aici',0),(155892,4331,'et','MÃ¤Ã¤ra arvutamisel on siin',0),(155893,4331,'si','DoloÄite izraÄun tukaj',0),(155894,4331,'ba','Tentukan perhitungan di sini',0),(155895,4331,'nl','De berekening hier opgeven',0),(155896,4331,'fi','MÃ¤Ã¤ritÃ¤ laskenta tÃ¤Ã¤llÃ¤',0),(155897,4331,'no','Angi beregningen her',0),(155898,4331,'da','Angiv beregningen her',0),(155899,4331,'ko','ì—¬ê¸° ê³„ì‚° ì§€ì •',0),(155900,4331,'he','×¦×™×™×Ÿ ××ª ×”×—×™×©×•×‘.',0),(155901,4331,'el','ÎšÎ±Î¸Î¿ÏÎ¯ÏƒÏ„Îµ Ï„Î¿Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ ÎµÎ´ÏŽ',0),(155902,4331,'zh','åœ¨è¿™é‡ŒæŒ‡å®šè®¡ç®—\r\n',0),(155903,4331,'sv','Ange berÃ¤kningen hÃ¤r',0),(155904,4331,'it','Specifica il calcolo qui',0),(155905,4331,'tl','',0),(155906,4331,'th','&#3619;&#3632;&#3610;&#3640;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3609;&#3637;&#3657;',0),(155907,4331,'hi','à¤¯à¤¹à¤¾à¤ à¤—à¤£à¤¨à¤¾ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(155908,4331,'ms','Menentukan pengiraan di sini',0),(155909,4331,'ar','ØªØ­Ø¯ÙŠØ¯ Ø­Ø³Ø§Ø¨ Ù‡Ù†Ø§',0),(155910,4331,'fr','SpÃ©cifiez le calcul ici',0),(155911,4331,'jp','è¨ˆç®—ã‚’ã?“ã?“ã?§ç‰¹å®šã?™ã‚‹',0),(155912,4331,'pt','Especifique o cÃ¡lculo aqui',0),(155913,4331,'ru','Ð£ÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ Ñ€Ð°ÑÑ‡ÐµÑ‚',0),(155914,4331,'es','Especificar los CÃ¡lculos Aqui',0),(155915,4331,'de','Geben Sie hier die Berechnung',0),(155916,4331,'en','Specify the Calculation Here',0),(155917,4332,'is','',0),(155918,4332,'dr','Ø§Ù…ØªØ­Ø§Ù† Ù…Ø­Ø§Ø³Ø¨Ù‡ ',0),(155919,4332,'pr','Ø§Ù…ØªØ­Ø§Ù† Ù…Ø­Ø§Ø³Ø¨Ù‡ ',0),(155920,4332,'tr','Test hesaplama',0),(155921,4332,'pl','Obliczenie testu',0),(155922,4332,'bg','Ð¢ÐµÑÑ‚ Ð·Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ',0),(155923,4332,'ur','Ø­Ø³Ø§Ø¨ Ú©ÛŒ Ø¬Ø§Ù†Ú†',0),(155924,4332,'sr','Ð¢ÐµÑÑ‚ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(155925,4332,'vi','Kiá»ƒm tra tÃ­nh toÃ¡n',0),(155926,4332,'af','Toets Berekening',0),(155927,4332,'ro','Test de calcul',0),(155928,4332,'et','Test arvutamine',0),(155929,4332,'si','Test izraÄun',0),(155930,4332,'ba','Menguji perhitungan',0),(155931,4332,'nl','Test berekening',0),(155932,4332,'fi','Testaa laskenta',0),(155933,4332,'no','Test beregningen',0),(155934,4332,'da','Test beregning',0),(155935,4332,'ko','ê³„ì‚°ì„ í…ŒìŠ¤íŠ¸',0),(155936,4332,'he','×œ×‘×“×•×§ ××ª ×”×—×™×©×•×‘',0),(155937,4332,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Ï„Î·Ï‚ Î´Î¿ÎºÎ¹Î¼Î®Ï‚',0),(155938,4332,'zh','æµ‹è¯•è®¡ç®—\r\n',0),(155939,4332,'sv','Testa berÃ¤kning',0),(155940,4332,'it','Prova di calcolo',0),(155941,4332,'tl','',0),(155942,4332,'th','&#3607;&#3604;&#3626;&#3629;&#3610;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(155943,4332,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤•à¤¾ à¤ªà¤°à¥€à¤•à¥à¤·à¤£',0),(155944,4332,'ms','Pengiraan ujian',0),(155945,4332,'ar','Ø§Ø®ØªØ¨Ø§Ø± Ø­Ø³Ø§Ø¨',0),(155946,4332,'fr','Test de calcul',0),(155947,4332,'jp','ãƒ†ã‚¹ãƒˆè¨ˆç®—',0),(155948,4332,'pt','CÃ¡lculo de teste',0),(155949,4332,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(155950,4332,'es','CÃ¡culo de Prueba',0),(155951,4332,'de','Test-Berechnung',0),(155952,4332,'en','Test Calculation',0),(155953,4333,'is','',0),(155954,4333,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾ÙŠØ¯Ø§ ÙƒØ±Ø¯Ù† ÙØ±Ù…ÙˆÙ„ Ù‡Ø§ Ù†ÙŠØ³Øª',0),(155955,4333,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾ÙŠØ¯Ø§ ÙƒØ±Ø¯Ù† ÙØ±Ù…ÙˆÙ„ Ù‡Ø§ Ù†ÙŠØ³Øª',0),(155956,4333,'tr','FormÃ¼l bulunamadÄ±',0),(155957,4333,'pl','Nie moÅ¼na odnaleÅºÄ‡ formuÅ‚y',0),(155958,4333,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð½Ð°Ð¼ÐµÑ€Ð¸ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð°',0),(155959,4333,'ur','ÙØ§Ø±Ù…ÙˆÙ„Ø§ Ú©Ùˆ ØªÙ„Ø§Ø´ Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(155960,4333,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ñƒ',0),(155961,4333,'vi','KhÃ´ng tháº¥y cÃ´ng thá»©c',0),(155962,4333,'af','Kon nie formule',0),(155963,4333,'ro','Imposibil de gÄƒsit Formula',0),(155964,4333,'et','Ei leitud valem',0),(155965,4333,'si','Ni mogoÄe najti formulo',0),(155966,4333,'ba','Tidak dapat menemukan Formula',0),(155967,4333,'nl','Niet in staat om formule te vinden',0),(155968,4333,'fi','Ei lÃ¶ydy kaava',0),(155969,4333,'no','Finner ikke formel',0),(155970,4333,'da','AfskÃ¥ret fra hitte formel',0),(155971,4333,'ko','ìˆ˜ì‹ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(155972,4333,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×¦×•× × ×•×¡×—×”',0),(155973,4333,'el','Î£Îµ Î¸Î­ÏƒÎ· Î½Î± Î²ÏÎµÎ¹ Ï†ÏŒÏÎ¼Î¿Ï…Î»Î±',0),(155974,4333,'zh','æ— æ³•æ‰¾åˆ°å…¬å¼\r\n',0),(155975,4333,'sv','Det gick inte att hitta formel',0),(155976,4333,'it','Impossibile trovare la Formula',0),(155977,4333,'tl','',0),(155978,4333,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3588;&#3657;&#3609;&#3627;&#3634;&#3626;&#3641;&#3605;&#3619;',0),(155979,4333,'hi','à¤¸à¥‚à¤¤à¥à¤° à¤–à¥‹à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(155980,4333,'ms','Tidak dapat mencari Formula',0),(155981,4333,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ ØµÙŠØºØ©',0),(155982,4333,'fr','Impossible de trouver la formule',0),(155983,4333,'jp','å¼?ã‚’è¦‹ã?¤ã?‘ã‚‹ã?“ã?¨ã?Œã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(155984,4333,'pt','Incapaz de encontrar a fÃ³rmula',0),(155985,4333,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÐÐ°Ð¹Ñ‚Ð¸ Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ñƒ',0),(155986,4333,'es','No se Puede Encontrar la FÃ³rmula ',0),(155987,4333,'de','Formel gefunden',0),(155988,4333,'en','Unable to Find Formula',0),(155989,4334,'is','',0),(155990,4334,'dr','Ù…Ù‚Ø¯Ø§Ø±  Ø¨Ø±Ø§ÙŠ Ø¢Ø²Ù…Ø§ÙŠØ´ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(155991,4334,'pr','Ù…Ù‚Ø¯Ø§Ø±  Ø¨Ø±Ø§ÙŠ Ø¢Ø²Ù…Ø§ÙŠØ´ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(155992,4334,'tr','DeÄŸer Test hesaplama iÃ§in',0),(155993,4334,'pl','WartoÅ›Ä‡ dla obliczeÅ„ Test',0),(155994,4334,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð·Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÑÑ‚Ð° Ð·Ð°',0),(155995,4334,'ur','Ù¹ÛŒØ³Ù¹ Ú©Û’ Ù…Ø­Ø§Ø³Ø¨Û Ú©Û’ Ù„Ø¦Û’ Ù‚Ø¯Ø±',0),(155996,4334,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ Ð·Ð° Ð¢ÐµÑÑ‚ Ð¿Ñ€Ð¾Ñ€Ð°Ñ‡ÑƒÐ½',0),(155997,4334,'vi','GiÃ¡ trá»‹ tá»›i kiá»ƒm tra ',0),(155998,4334,'af','Waarde vir toets aanspreeklikheid',0),(155999,4334,'ro','Valoarea pentru testul de calcul',0),(156000,4334,'et','VÃ¤Ã¤rtuse Test arvutus',0),(156001,4334,'si','Vrednost za Test raÄunanja',0),(156002,4334,'ba','Nilai untuk tes komputasi',0),(156003,4334,'nl','Waarde voor de berekening van de Test',0),(156004,4334,'fi','Testi laskenta-arvo',0),(156005,4334,'no','Verdien for Test beregningen',0),(156006,4334,'da','VÃ¦rdi for Test beregning',0),(156007,4334,'ko','í…ŒìŠ¤íŠ¸ ê³„ì‚° ê°’',0),(156008,4334,'he','×¢×¨×š ×œ×—×™×©×•×‘×™×•×ª ×ž×‘×—×Ÿ',0),(156009,4334,'el','Î‘Î¾Î¯Î± Î³Î¹Î± Ï„Î¿Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Ï„Î·Ï‚ Î´Î¿ÎºÎ¹Î¼Î®Ï‚',0),(156010,4334,'zh','è¯•éªŒè®¡ç®—å€¼\r\n',0),(156011,4334,'sv','VÃ¤rde fÃ¶r testet utrÃ¤kning',0),(156012,4334,'it','Valore per il calcolo del Test',0),(156013,4334,'tl','',0),(156014,4334,'th','&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3607;&#3604;&#3626;&#3629;&#3610;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;',0),(156015,4334,'hi','à¤…à¤­à¤¿à¤•à¤²à¤¨ à¤•à¥‡ à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¨',0),(156016,4334,'ms','Nilai bagi pengiraan ujian',0),(156017,4334,'ar','Ù‚ÙŠÙ…Ø© Ù„Ø§Ø®ØªØ¨Ø§Ø± Ø¹Ù…Ù„ÙŠØ© Ø­Ø³Ø§Ø¨ÙŠØ©',0),(156018,4334,'fr','Valeur pour le calcul de l\'essai',0),(156019,4334,'jp','ãƒ†ã‚¹ãƒˆè¨ˆç®—ã?®ä¾¡å€¤',0),(156020,4334,'pt','Valor para cÃ¡lculo de teste',0),(156021,4334,'ru','Ð”Ð»Ñ Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ñ‚ÐµÑÑ‚',0),(156022,4334,'es','Valor para ComputaciÃ³n de Prueba',0),(156023,4334,'de','Wert fÃ¼r Test-Berechnung',0),(156024,4334,'en','Value for Test Computation',0),(156025,4335,'is','',0),(156026,4335,'dr','(Ø¹Ø±Ø¶Ù‡',0),(156027,4335,'pr','Ù‡Ù…Ú†Ù†ÙŠÙ† Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯(Ø¹Ø±Ø¶Ù‡',0),(156028,4335,'tr','AyrÄ±ca teklif',0),(156029,4335,'pl','RÃ³wnieÅ¼ oferta',0),(156030,4335,'bg','Ð¡ÑŠÑ‰Ð¾ Ñ‚Ð°ÐºÐ° Ð¿Ñ€ÐµÐ´Ð»Ð°Ð³Ð°Ð¼Ðµ',0),(156031,4335,'ur','Ø¨Ú¾ÛŒ Ù¾ÛŒØ´ Ú©Ø±ØªÛ’ ÛÛŒÚº',0),(156032,4335,'sr','Ð¢Ð°ÐºÐ¾Ñ’Ðµ Ð½ÑƒÐ´Ðµ',0),(156033,4335,'vi','CÅ©ng ChÃ o HÃ ng',0),(156034,4335,'af','Bied ook',0),(156035,4335,'ro','De asemenea, oferta',0),(156036,4335,'et','Pakkuda ka',0),(156037,4335,'si','Tudi ponudba',0),(156038,4335,'ba','Juga menawarkan',0),(156039,4335,'nl','Ook bieden',0),(156040,4335,'fi','Tarjoavat myÃ¶s',0),(156041,4335,'no','Tilby ogsÃ¥',0),(156042,4335,'da','Tilbyde ogsÃ¥',0),(156043,4335,'ko','ë˜í•œ ì œê³µ',0),(156044,4335,'he','×ž×¦×™×¢×™× ×’×',0),(156045,4335,'el','Î•Ï€Î¯ÏƒÎ·Ï‚ Ï€ÏÎ¿ÏƒÏ†Î­ÏÎ¿Ï…Î½',0),(156046,4335,'zh','è¿˜æä¾›\r\n',0),(156047,4335,'sv','Erbjuder Ã¤ven',0),(156048,4335,'it','Offrono anche',0),(156049,4335,'tl','',0),(156050,4335,'th','&#3618;&#3633;&#3591;&#3651;&#3627;&#3657;',0),(156051,4335,'hi','à¤­à¥€ à¤ªà¥‡à¤¶à¤•à¤¶',0),(156052,4335,'ms','Juga menawarkan',0),(156053,4335,'ar','ÙƒÙ…Ø§ ØªÙ‚Ø¯Ù…',0),(156054,4335,'fr','Offrons Ã©galement',0),(156055,4335,'jp','ï½žã‚‚æ??æ¡ˆ',0),(156056,4335,'pt','TambÃ©m oferecemos',0),(156057,4335,'ru','Ð¢Ð°ÐºÐ¶Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð°Ð³Ð°ÐµÐ¼',0),(156058,4335,'es','TambiÃ©n Ofrecer',0),(156059,4335,'de','Bieten auch',0),(156060,4335,'en','Also Offer',0),(156061,4336,'is','',0),(156062,4336,'dr','ÙØ§ØµÙ„Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ø¨ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ùˆ Ø¯Ø±ÙŠØ§ÙØª Ø¢Ù†\r\n(Ø²Ù…Ø§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ )',0),(156063,4336,'pr','ÙØ§ØµÙ„Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ø¨ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ùˆ Ø¯Ø±ÙŠØ§ÙØª Ø¢Ù†\r\n(Ø²Ù…Ø§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ )',0),(156064,4336,'tr','SaÄŸlama sÃ¼resi',0),(156065,4336,'pl','Czas realizacji',0),(156066,4336,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(156067,4336,'ur','ÙˆÙ‚Øª Ú©ÛŒ Ù‚ÛŒØ§Ø¯Øª',0),(156068,4336,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ñ†Ð¸ÐºÐ»ÑƒÑÐ°',0),(156069,4336,'vi','Thá»i gian Dáº«n Ä‘áº§u',0),(156070,4336,'af','Voorloop tyd',0),(156071,4336,'ro','timp de pregÄƒtire',0),(156072,4336,'et','Kestus',0),(156073,4336,'si','Äasovna priprava',0),(156074,4336,'ba','Waktu pimpin',0),(156075,4336,'nl','Levertijd',0),(156076,4336,'fi','Toimitusaika',0),(156077,4336,'no','behandlingstid',0),(156078,4336,'da','TidsforlÃ¸b',0),(156079,4336,'ko','ë¦¬ë“œ íƒ€ìž„',0),(156080,4336,'he','×–×ž×Ÿ ××¡×¤×§×”',0),(156081,4336,'el','Î§ÏÏŒÎ½Î¿Ï‚ Ï€ÏÎ¿Ï€Î¿ÏÎµÏ…ÏŒÎ¼ÎµÎ½Î¿Ï…',0),(156082,4336,'zh','æå‰æœŸ\r\n',0),(156083,4336,'sv','Leveranstid',0),(156084,4336,'it','Lead time',0),(156085,4336,'tl','',0),(156086,4336,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3619;&#3629;&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(156087,4336,'hi','à¤–à¤¼à¤¾à¤¸ à¤¸à¤®à¤¯',0),(156088,4336,'ms','Masa',0),(156089,4336,'ar','ÙØªØ±Ø© Ø¥Ù†ØªØ§Ø¬',0),(156090,4336,'fr','Delai',0),(156091,4336,'jp','ãƒªãƒ¼ãƒ‰æ™‚é–“',0),(156092,4336,'pt','Tempo de espera',0),(156093,4336,'ru','Ð¡Ñ€Ð¾Ðº Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(156094,4336,'es','Plazo de Entrega',0),(156095,4336,'de','Vorlaufzeit',0),(156096,4336,'en','Lead Time',0),(156097,4337,'is','',0),(156098,4337,'dr','5',0),(156099,4337,'pr','Ø§Ù…ØªÙŠØ§Ø²  5',0),(156100,4337,'tr','Nokta #5',0),(156101,4337,'pl','Punkt #5',0),(156102,4337,'bg','Ð¢Ð¾Ñ‡ÐºÐ° #5',0),(156103,4337,'ur','Ù…Ù‚Ø§Ù… #5',0),(156104,4337,'sr','Ð¢Ð°Ñ‡ÐºÐ° #5',0),(156105,4337,'vi','Äiá»ƒm sá»‘ 5',0),(156106,4337,'af','Punt #5',0),(156107,4337,'ro','Punctul #5',0),(156108,4337,'et','Punkt #5',0),(156109,4337,'si','ToÄka #5',0),(156110,4337,'ba','Point #5',0),(156111,4337,'nl','Punt #5',0),(156112,4337,'fi','Kohta #5',0),(156113,4337,'no','Pek #5',0),(156114,4337,'da','Punkt #5',0),(156115,4337,'ko','í¬ì¸íŠ¸ #5',0),(156116,4337,'he','× ×§×•×“×ª #5',0),(156117,4337,'el','Î£Î·Î¼ÎµÎ¯Î¿ #5',0),(156118,4337,'zh','ç‚¹ï¼ƒ5\r\n',0),(156119,4337,'sv','Punkt #5',0),(156120,4337,'it','Punto #5',0),(156121,4337,'tl','',0),(156122,4337,'th','&#3586;&#3657;&#3629; 5',0),(156123,4337,'hi','#5 à¤¬à¤¿à¤‚à¤¦à¥',0),(156124,4337,'ms','Point #5',0),(156125,4337,'ar','Ù†Ù‚Ø·Ø© #5',0),(156126,4337,'fr','Point #5',0),(156127,4337,'jp','ãƒ?ã‚¤ãƒ³ãƒˆ#ï¼•',0),(156128,4337,'pt','Ponto #5',0),(156129,4337,'ru','ÐŸÑƒÐ½ÐºÑ‚ #5',0),(156130,4337,'es','Punto #5',0),(156131,4337,'de','Nummer #5',0),(156132,4337,'en','Point #5',0),(156133,4338,'is','',0),(156134,4338,'dr','4',0),(156135,4338,'pr','Ø§Ù…ØªÙŠØ§Ø² 4',0),(156136,4338,'tr','Nokta #4',0),(156137,4338,'pl','Punkt #4',0),(156138,4338,'bg','Ð¢Ð¾Ñ‡ÐºÐ° #4',0),(156139,4338,'ur','Ù…Ù‚Ø§Ù… #4',0),(156140,4338,'sr','Ð¢Ð°Ñ‡ÐºÐ° #4',0),(156141,4338,'vi','Äiá»ƒm sá»‘ 4',0),(156142,4338,'af','Punt #4',0),(156143,4338,'ro','Punctul #4',0),(156144,4338,'et','Punkt #4',0),(156145,4338,'si','ToÄka #4',0),(156146,4338,'ba','Titik #4',0),(156147,4338,'nl','Punt #4',0),(156148,4338,'fi','Kohta #4',0),(156149,4338,'no','Punkt #4',0),(156150,4338,'da','Punkt #4',0),(156151,4338,'ko','í¬ì¸íŠ¸ #4',0),(156152,4338,'he','× ×§×•×“×ª #4',0),(156153,4338,'el','Î£Î·Î¼ÎµÎ¯Î¿ #4',0),(156154,4338,'zh','ç‚¹ï¼ƒ4\r\n',0),(156155,4338,'sv','Punkt #4',0),(156156,4338,'it','Punto #4',0),(156157,4338,'tl','',0),(156158,4338,'th','&#3586;&#3657;&#3629; 4',0),(156159,4338,'hi','#4 à¤¬à¤¿à¤‚à¤¦à¥',0),(156160,4338,'ms','Point #4',0),(156161,4338,'ar','Ù†Ù‚Ø·Ø© #4',0),(156162,4338,'fr','Point #4',0),(156163,4338,'jp','ãƒ?ã‚¤ãƒ³ãƒˆ#ï¼”',0),(156164,4338,'pt','Ponto #4',0),(156165,4338,'ru','ÐŸÑƒÐ½ÐºÑ‚ #4',0),(156166,4338,'es','Punto #4',0),(156167,4338,'de','Punkt #4',0),(156168,4338,'en','Point #4',0),(156169,4339,'is','',0),(156170,4339,'dr','1',0),(156171,4339,'pr','Ù†Ù‚Ø·Ù‡    1',0),(156172,4339,'tr','#1 puan',0),(156173,4339,'pl','Punkt #1',0),(156174,4339,'bg','Ð¢Ð¾Ñ‡ÐºÐ° #1',0),(156175,4339,'ur','Ù…Ù‚Ø§Ù… #1',0),(156176,4339,'sr','Ð¢Ð°Ñ‡ÐºÐ° #1',0),(156177,4339,'vi','Äiá»ƒm sá»‘ 1',0),(156178,4339,'af','Punt #1',0),(156179,4339,'ro','Punctul #1',0),(156180,4339,'et','Punkt #1',0),(156181,4339,'si','ToÄka #1',0),(156182,4339,'ba','Point #1',0),(156183,4339,'nl','Punt #1',0),(156184,4339,'fi','Kohta #1',0),(156185,4339,'no','Punkt #1',0),(156186,4339,'da','Punkt #1',0),(156187,4339,'ko','í¬ì¸íŠ¸ #1',0),(156188,4339,'he','× ×§×•×“×ª #1',0),(156189,4339,'el','Î£Î·Î¼ÎµÎ¯Î¿ #1',0),(156190,4339,'zh','ç‚¹ï¼ƒ1\r\n',0),(156191,4339,'sv','Punkt #1',0),(156192,4339,'it','Punto #1',0),(156193,4339,'tl','',0),(156194,4339,'th','&#3586;&#3657;&#3629; 1',0),(156195,4339,'hi','#1 à¤¬à¤¿à¤‚à¤¦à¥',0),(156196,4339,'ms','Point #1',0),(156197,4339,'ar','Ù†Ù‚Ø·Ø© #1',0),(156198,4339,'fr','Point #1',0),(156199,4339,'jp','ãƒ?ã‚¤ãƒ³ãƒˆ#ï¼‘',0),(156200,4339,'pt','Ponto #1',0),(156201,4339,'ru','ÐŸÑƒÐ½ÐºÑ‚ #1',0),(156202,4339,'es','Punto #1',0),(156203,4339,'de','Nummer #1',0),(156204,4339,'en','Point #1',0),(156205,4340,'is','',0),(156206,4340,'dr','6',0),(156207,4340,'pr','Ù†Ù‚Ø·Ù‡    6',0),(156208,4340,'tr','Nokta #6',0),(156209,4340,'pl','Punkt #6',0),(156210,4340,'bg','Ð¢Ð¾Ñ‡ÐºÐ° #6',0),(156211,4340,'ur','Ù…Ù‚Ø§Ù… #6',0),(156212,4340,'sr','ÐŸÐ¾Ð¸Ð½Ñ‚ #6',0),(156213,4340,'vi','Äiá»ƒm sá»‘ 6',0),(156214,4340,'af','Punt #6',0),(156215,4340,'ro','Punctul #6',0),(156216,4340,'et','Punkti #6',0),(156217,4340,'si','ToÄka #6',0),(156218,4340,'ba','Point #6',0),(156219,4340,'nl','Punt #6',0),(156220,4340,'fi','Kohta #6',0),(156221,4340,'no','Point #6',0),(156222,4340,'da','Punkt #6',0),(156223,4340,'ko','í¬ì¸íŠ¸ #6',0),(156224,4340,'he','× ×§×•×“×ª #6',0),(156225,4340,'el','Î£Î·Î¼ÎµÎ¯Î¿ #6',0),(156226,4340,'zh','ç‚¹ï¼ƒ6\r\n',0),(156227,4340,'sv','Punkt #6',0),(156228,4340,'it','Punto #6',0),(156229,4340,'tl','',0),(156230,4340,'th','&#3586;&#3657;&#3629; 6',0),(156231,4340,'hi','#6 à¤¬à¤¿à¤‚à¤¦à¥',0),(156232,4340,'ms','Point #6',0),(156233,4340,'ar','Ù†Ù‚Ø·Ø© #6',0),(156234,4340,'fr','Point #6',0),(156235,4340,'jp','ãƒ?ã‚¤ãƒ³ãƒˆ#ï¼–',0),(156236,4340,'pt','Ponto #6',0),(156237,4340,'ru','ÐŸÑƒÐ½ÐºÑ‚ #6',0),(156238,4340,'es','Punto #6',0),(156239,4340,'de','Nummer #6',0),(156240,4340,'en','Point #6',0),(156241,4341,'is','',0),(156242,4341,'dr','3',0),(156243,4341,'pr','Ù†Ù‚Ø·Ù‡    3',0),(156244,4341,'tr','Nokta #3',0),(156245,4341,'pl','Punkt #3',0),(156246,4341,'bg','Ð¢Ð¾Ñ‡ÐºÐ° #3',0),(156247,4341,'ur','Ù…Ù‚Ø§Ù… #3',0),(156248,4341,'sr','Ð¢Ð°Ñ‡ÐºÐ° #3',0),(156249,4341,'vi','Äiá»ƒm sá»‘ 3',0),(156250,4341,'af','Punt #3',0),(156251,4341,'ro','Punctul #3',0),(156252,4341,'et','Punkt #3',0),(156253,4341,'si','ToÄka #3',0),(156254,4341,'ba','Point #3',0),(156255,4341,'nl','Punt #3',0),(156256,4341,'fi','Kohta #3',0),(156257,4341,'no','Punkt #3',0),(156258,4341,'da','Punkt #3',0),(156259,4341,'ko','í¬ì¸íŠ¸ #3',0),(156260,4341,'he','×”×¦×‘×¢ #3',0),(156261,4341,'el','Î£Î·Î¼ÎµÎ¯Î¿ #3',0),(156262,4341,'zh','ç‚¹ï¼ƒ3\r\n',0),(156263,4341,'sv','Punkt #3',0),(156264,4341,'it','Punto #3',0),(156265,4341,'tl','',0),(156266,4341,'th','&#3586;&#3657;&#3629; 3',0),(156267,4341,'hi','#3 à¤¬à¤¿à¤‚à¤¦à¥',0),(156268,4341,'ms','Point #3',0),(156269,4341,'ar','Ù†Ù‚Ø·Ø© #3',0),(156270,4341,'fr','Point #3',0),(156271,4341,'jp','ãƒ?ã‚¤ãƒ³ãƒˆ#ï¼“',0),(156272,4341,'pt','Ponto #3',0),(156273,4341,'ru','ÐŸÑƒÐ½ÐºÑ‚ #3',0),(156274,4341,'es','Punto #3',0),(156275,4341,'de','Punkt #3',0),(156276,4341,'en','Point #3',0),(156277,4342,'is','',0),(156278,4342,'dr','2',0),(156279,4342,'pr','Ù†Ù‚Ø·Ù‡    2',0),(156280,4342,'tr','NoktasÄ± #2',0),(156281,4342,'pl','Punkt #2',0),(156282,4342,'bg','Ð¢Ð¾Ñ‡ÐºÐ° #2',0),(156283,4342,'ur','Ù…Ù‚Ø§Ù… #2',0),(156284,4342,'sr','Ð¢Ð°Ñ‡ÐºÐ° #2',0),(156285,4342,'vi','Äiá»ƒm sá»‘ 2',0),(156286,4342,'af','Punt #2',0),(156287,4342,'ro','Punctul #2',0),(156288,4342,'et','Punkt #2',0),(156289,4342,'si','ToÄka #2',0),(156290,4342,'ba','Point #2',0),(156291,4342,'nl','Punt #2',0),(156292,4342,'fi','Kohta #2',0),(156293,4342,'no','Punkt #2',0),(156294,4342,'da','Punkt #2',0),(156295,4342,'ko','í¬ì¸íŠ¸ #2',0),(156296,4342,'he','× ×§×•×“×ª #2',0),(156297,4342,'el','Î£Î·Î¼ÎµÎ¯Î¿ #2',0),(156298,4342,'zh','ç‚¹ï¼ƒ2\r\n',0),(156299,4342,'sv','Punkt #2',0),(156300,4342,'it','Punto #2',0),(156301,4342,'tl','',0),(156302,4342,'th','&#3586;&#3657;&#3629; 2',0),(156303,4342,'hi','à¤¬à¤¿à¤‚à¤¦à¥ #2',0),(156304,4342,'ms','Point #2',0),(156305,4342,'ar','Ù†Ù‚Ø·Ø© #2',0),(156306,4342,'fr','Point #2',0),(156307,4342,'jp','ãƒ?ã‚¤ãƒ³ãƒˆ#ï¼’',0),(156308,4342,'pt','Ponto #2',0),(156309,4342,'ru','ÐŸÑƒÐ½ÐºÑ‚ #2',0),(156310,4342,'es','Punto #2',0),(156311,4342,'de','Nummer #2',0),(156312,4342,'en','Point #2',0),(156313,4343,'is','',0),(156314,4343,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ…ÙŠÙ„ Ùˆ Ù‚Ø§Ù„Ø¨ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(156315,4343,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ…ÙŠÙ„ Ùˆ Ù‚Ø§Ù„Ø¨ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(156316,4343,'tr','E-posta ve PDF formatÄ±nda alÄ±ntÄ± yapmak iÃ§in kurulum',0),(156317,4343,'pl','Ustawienia E-mail i PDF format Cytaty',0),(156318,4343,'bg','Ð˜Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ñ‰Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð° Ð·Ð° ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ð¿Ð¾Ñ‰Ð° Ð¸ PDF Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸ Ð·Ð°',0),(156319,4343,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÙˆØ± Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ø±Ù…ÛŒÙ¹ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø±Ø¬ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ø§Ù¾',0),(156320,4343,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð•Ð¼Ð°Ð¸Ð» Ð¸ ÐŸÐ”Ð¤ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(156321,4343,'vi','Setup Email & BÃ¡o giÃ¡ dáº¡ng PDF',0),(156322,4343,'af','Opstelling van E-pos en PDF lÃªerformaat \"quotes\"',0),(156323,4343,'ro','Configurare pentru E-mail ÅŸi PDF format de citate',0),(156324,4343,'et','Seadistus e-posti ja PDF formaadis pakkumised',0),(156325,4343,'si','Namestitveni program za e-poÅ¡to in PDF oblika ponudbe',0),(156326,4343,'ba','Setup untuk Email dan PDF format kutipan',0),(156327,4343,'nl','Setup voor E-mail en PDF aanhalingstekens opmaken',0),(156328,4343,'fi','Asetukset sÃ¤hkÃ¶postin ja PDF muodossa lainausmerkit',0),(156329,4343,'no','Oppsett for e-post og PDF format sitater',0),(156330,4343,'da','Setup for E-mail og PDF format citater',0),(156331,4343,'ko','ì´ë©”ì¼ ë° PDF í˜•ì‹ ë”°ì˜´í‘œì— ëŒ€ í•œ ì„¤ì •',0),(156332,4343,'he','×”×’×“×¨×ª ×“×•× ×œ ×•- PDF ×¤×•×¨×ž×˜ ×œ×”×¦×¢×ª ×ž×—×™×¨',0),(156333,4343,'el','Î¡ÏÎ¸Î¼Î¹ÏƒÎ· Î³Î¹Î± Ï„Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ ÎºÎ±Î¹ PDF Î¼Î¿ÏÏ†Î® ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(156334,4343,'zh','é¢å‘ç”µå­é‚®ä»¶å’ŒPDFæ ¼å¼è®¾ç½®æŠ¥ä»·\r\n',0),(156335,4343,'sv','InstÃ¤llningar fÃ¶r e-post och PDF format citat',0),(156336,4343,'it','Configurazione per Email e PDF formato citazioni',0),(156337,4343,'tl','',0),(156338,4343,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3586;&#3629;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3649;&#3621;&#3632;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3648;&#3',0),(156339,4343,'hi','à¤ˆà¤®à¥‡à¤² à¤”à¤° PDF à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª à¤‰à¤¦à¥à¤§à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(156340,4343,'ms','Persediaan e-mel dan PDF format Sebut harga',0),(156341,4343,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ù„Ø¹Ø±ÙˆØ¶ ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠØŒ ÙˆÙ‚ÙˆØ§Øª Ø§Ù„Ø¯ÙØ§Ø¹ Ø§Ù„Ø´Ø¹Ø¨ÙŠ',0),(156342,4343,'fr','Programme d\'installation pour E-mail et PDF format citations',0),(156343,4343,'jp','ï¼¥ãƒ¡ãƒ¼ãƒ«ã?¨ï¼°ï¼¤ï¼¦ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆã?®è¦‹ç©?ã‚Šè¨­å®š',0),(156344,4343,'pt','InstalaÃ§Ã£o para citaÃ§Ãµes de formato de Email e PDF',0),(156345,4343,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð´Ð»Ñ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð¸ PDF Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(156346,4343,'es','ConfiguraciÃ³n para formatos de cotizaciones de Email y PDF',0),(156347,4343,'de','Setup fÃ¼r E-Mail- und PDF-Format-Zitate',0),(156348,4343,'en','Setup for Email and PDF format quotes',0),(156349,4344,'is','',0),(156350,4344,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®Ù„Ø§ØµÙ‡ Ø³Ø·Ø­ Ø¯ÙØªØ± ÙƒÙ„',0),(156351,4344,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®Ù„Ø§ØµÙ‡ Ø³Ø·Ø­ Ø¯ÙØªØ± ÙƒÙ„',0),(156352,4344,'tr','Genel biÃ§imlendirme bilgileri',0),(156353,4344,'pl','Informacje ogÃ³lne znacznikÃ³w',0),(156354,4344,'bg','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(156355,4344,'ur','Ø¬Ù†Ø±Ù„ Ù…Ø§Ø±Ú© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(156356,4344,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð½Ð°Ð·Ð½Ð°ÐºÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(156357,4344,'vi','ThÃ´ng tin cá»™ng thÃªm chung',0),(156358,4344,'af','Algemene Prysverhoging Inligting',0),(156359,4344,'ro','InformaÅ£ii generale Markup',0),(156360,4344,'et','Ãœldine mÃ¤rgistus teave',0),(156361,4344,'si','Markup sploÅ¡ne informacije',0),(156362,4344,'ba','Informasi umum Markup',0),(156363,4344,'nl','Generaal Markup informatie',0),(156364,4344,'fi','Yleinen Markup tiedot',0),(156365,4344,'no','General Markup informasjon',0),(156366,4344,'da','General Markup oplysninger',0),(156367,4344,'ko','ì¼ë°˜ íƒœê·¸ ì •ë³´',0),(156368,4344,'he','×ž×™×“×¢ ×›×œ×œ×™ ×¡×™×ž×•×Ÿ',0),(156369,4344,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³ÎµÎ½Î¹ÎºÎ®Ï‚ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(156370,4344,'zh','ä¸€èˆ¬æ ‡è®°ä¿¡æ¯\r\n',0),(156371,4344,'sv','AllmÃ¤nna Markup Information',0),(156372,4344,'it','Informazioni generali Markup',0),(156373,4344,'tl','',0),(156374,4344,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(156375,4344,'hi','à¤œà¤¨à¤°à¤² à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(156376,4344,'ms','Maklumat am penanda',0),(156377,4344,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø©',0),(156378,4344,'fr','Information gÃ©nÃ©rale balisage',0),(156379,4344,'jp','ä¸€èˆ¬å€¤ä¸Šã?’æƒ…å ±',0),(156380,4344,'pt','InformaÃ§Ã£o geral de marcaÃ§Ã£o',0),(156381,4344,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ñ… ÐÐ°Ð´Ð±Ð°Ð²Ð¾Ðº',0),(156382,4344,'es','InformaciÃ³n General de Encarecimiento',0),(156383,4344,'de','General Markup-Informationen',0),(156384,4344,'en','General Markup Information',0),(156385,4345,'is','',0),(156386,4345,'dr','(Ø­ÙˆØ§Ù„Ù‡ ) Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(156387,4345,'pr','Ù‡Ø¯Ù Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª (Ø­ÙˆØ§Ù„Ù‡ ) Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(156388,4345,'tr','Ã‡alÄ±ÅŸma alanÄ± amaÃ§ atama',0),(156389,4345,'pl','PrzydziaÅ‚ obszaru celu',0),(156390,4345,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð¿Ð»Ð¾Ñ‰ Ñ†ÐµÐ» Ð¿Ñ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ',0),(156391,4345,'ur','Ú©Ø§Ù… Ú©Û’ Ø¹Ù„Ø§Ù‚Û’ Ù…Ù‚ØµØ¯ ØªÙÙˆÛŒØ¶',0),(156392,4345,'sr','Ð Ð°Ð´Ð½Ð¸ Ð¿Ñ€Ð¾ÑÑ‚Ð¾Ñ€ ÑÐ²Ñ€Ñ…Ñƒ Ð·Ð°Ð´Ð°Ñ‚Ð°Ðº',0),(156393,4345,'vi','Chá»‰ Ä‘á»‹nh má»¥c Ä‘Ã­ch Khu vá»±c lÃ m viá»‡c',0),(156394,4345,'af','Werk Area doel opdrag',0),(156395,4345,'ro','LucreazÄƒ cesiunea de scop domeniu',0),(156396,4345,'et','TÃ¶Ã¶ ala eesmÃ¤rgi mÃ¤Ã¤ramine',0),(156397,4345,'si','Delo podroÄju namen dodelitve',0),(156398,4345,'ba','Penetapan tujuan Area kerja',0),(156399,4345,'nl','Werk gebied doel toewijzing',0),(156400,4345,'fi','Alueen tarkoitus tyÃ¶mÃ¤Ã¤rÃ¤ysten',0),(156401,4345,'no','Arbeidsoppdrag omrÃ¥det formÃ¥l',0),(156402,4345,'da','Arbejdstildeling omrÃ¥de formÃ¥l',0),(156403,4345,'ko','ìž‘ì—… ì˜ì—­ ëª©ì  í• ë‹¹',0),(156404,4345,'he','××–×•×¨ ×ž×˜×¨×” ×ž×©×™×ž×ª ×¢×‘×•×“×”',0),(156405,4345,'el','Î£ÎºÎ¿Ï€ÏŒ Ï„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(156406,4345,'zh','å·¥ä½œåŒºåŸŸç›®çš„åˆ†é…\r\n',0),(156407,4345,'sv','OmrÃ¥de syftet med hjÃ¤lp av arbetstilldelning',0),(156408,4345,'it','Lavoro zona scopo assegnazione',0),(156409,4345,'tl','',0),(156410,4345,'th','&#3585;&#3634;&#3619;&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;&#3591;&#3634;&#3609;&#3651;&#3609;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(156411,4345,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤ªà¥à¤°à¤¯à¥‹à¤œà¤¨ à¤…à¤¸à¤¾à¤‡à¤¨à¤®à¥‡à¤‚à¤Ÿ',0),(156412,4345,'ms','Kerja kawasan tujuan tugasan',0),(156413,4345,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„ØºØ±Ø¶ ÙÙŠ Ù…Ø¬Ø§Ù„ Ø§Ù„Ø¹Ù…Ù„',0),(156414,4345,'fr','Zone objet affectation de travail',0),(156415,4345,'jp','ä½œæ¥­åœ°åŸŸç›®çš„å‰²ã‚Šå½“ã?¦',0),(156416,4345,'pt','AtribuiÃ§Ã£o de finalidade de Ã¡rea de trabalho',0),(156417,4345,'ru','ÐžÐ±Ð»Ð°ÑÑ‚Ð¸ Ñ†ÐµÐ»ÑŒ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(156418,4345,'es','Ãrea de Trabajo AsignaciÃ³n de PrÃ³positos',0),(156419,4345,'de','Bereich Zweck Arbeitseinsatz',0),(156420,4345,'en','Work Area Purpose Assignment',0),(156421,4346,'is','',0),(156422,4346,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ',0),(156423,4346,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ',0),(156424,4346,'tr','GÃ¼ncelleÅŸtirme sÄ±rasÄ±nda hata oluÅŸtu',0),(156425,4346,'pl','BÅ‚Ä…d podczas aktualizacji',0),(156426,4346,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(156427,4346,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ',0),(156428,4346,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(156429,4346,'vi','Cáº­p nháº­t bá»‹ lá»—i',0),(156430,4346,'af','Fout het ingesluip Gedurende Opdatering.',0),(156431,4346,'ro','Eroare Ã®n timpul actualizÄƒrii',0),(156432,4346,'et','TÃµrge vÃ¤rskendamisel',0),(156433,4346,'si','Napaka pri posodabljanju',0),(156434,4346,'ba','Error selama Update',0),(156435,4346,'nl','Fout tijdens het bijwerken',0),(156436,4346,'fi','Virhe pÃ¤ivityksen',0),(156437,4346,'no','Feil under oppdatering',0),(156438,4346,'da','Fejl under opdatering',0),(156439,4346,'ko','ì—…ë°ì´íŠ¸ ì¤‘ ì˜¤ë¥˜ ë°œìƒ',0),(156440,4346,'he','×©×’×™××” ×‘×ž×©×š ×”×¢×“×›×•×Ÿ',0),(156441,4346,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(156442,4346,'zh','æ›´æ–°æœŸé—´å‘ç”Ÿé”™è¯¯',0),(156443,4346,'sv','Fel vid uppdatering',0),(156444,4346,'it','Errore durante l\'aggiornamento',0),(156445,4346,'tl','',0),(156446,4346,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(156447,4346,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(156448,4346,'ms','Ralat semasa',0),(156449,4346,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(156450,4346,'fr','Erreur lors de la mise Ã  jour',0),(156451,4346,'jp','æ›´æ–°ä¸­ã‚¨ãƒ©ãƒ¼',0),(156452,4346,'pt','Erro durante a atualizaÃ§Ã£o',0),(156453,4346,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸',0),(156454,4346,'es','Error Durante Actualizar',0),(156455,4346,'de','Fehler beim Update',0),(156456,4346,'en','Error During Update',0),(156457,4347,'is','',0),(156458,4347,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¢Ø®Ø±ÙŠÙ† Ø¯Ù„ÙŠÙ„ ',0),(156459,4347,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¢Ø®Ø±ÙŠÙ† Ø¯Ù„ÙŠÙ„ ',0),(156460,4347,'tr','Hata ekleme geÃ§ nedeni',0),(156461,4347,'pl','BÅ‚Ä…d dodawania powÃ³d pÃ³Åºno',0),(156462,4347,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÑ€Ð°Ñ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(156463,4347,'ur','Ù†Ù‚Øµ Ø§Ø¶Ø§ÙÛ Ù…Ø±Ø­ÙˆÙ… Ú©ÛŒ ÙˆØ¬Û',0),(156464,4347,'sr','Ð“Ñ€ÐµÑˆÐºÐµ Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ ÐºÐ°ÑÐ½Ð¾ Ñ€Ð°Ð·Ð»Ð¾Ð³',0),(156465,4347,'vi','ThÃªm nguyÃªn nhÃ¢n cháº­m trá»… bá»‹ lá»—i',0),(156466,4347,'af','Fout voeg laat rede',0),(156467,4347,'ro','Eroare adÄƒugarea tÃ¢rziu motiv',0),(156468,4347,'et','Viga lisades hilinemise pÃµhjus',0),(156469,4347,'si','Napaka pri dodajanju pozno razlog',0),(156470,4347,'ba','Alasan akhir menambahkan kesalahan',0),(156471,4347,'nl','Fout toe te voegen laat reden',0),(156472,4347,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ myÃ¶hÃ¤Ã¤n syy',0),(156473,4347,'no','Feil Ã¥ legge sent grunn',0),(156474,4347,'da','Fejl tilfÃ¸je sent grund',0),(156475,4347,'ko','ì˜¤ë¥˜ ì¶”ê°€ ëŠ¦ì€ ì´ìœ ',0),(156476,4347,'he','×”×•×¡×¤×ª ×¡×™×‘×” ×ž××•×—×¨ ×©×’×™××”',0),(156477,4347,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±ÏÎ³Î¬ Î»ÏŒÎ³Î¿Ï‚',0),(156478,4347,'zh','é”™è¯¯ï¼šæ–°å¢žè¿Ÿåˆ°çš„åŽŸå› ',0),(156479,4347,'sv','Fel att lÃ¤gga till slutet anledning',0),(156480,4347,'it','Errore aggiunta tarda motivo',0),(156481,4347,'tl','',0),(156482,4347,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(156483,4347,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¦à¥‡à¤° à¤•à¤¾à¤°à¤£ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(156484,4347,'ms','Ralat menambah lewat sebab',0),(156485,4347,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø³Ø¨Ø¨ Ø£ÙˆØ§Ø®Ø±',0),(156486,4347,'fr','Erreur ajout fin motif',0),(156487,4347,'jp','é?…å»¶ç?†ç”±ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(156488,4347,'pt','Erro adicionando tarde motivo',0),(156489,4347,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÐºÐ¾Ð½Ñ†Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(156490,4347,'es','Error Agregando RazÃ³n por a Tardanza',0),(156491,4347,'de','Fehler hinzufÃ¼gen Ende Grund',0),(156492,4347,'en','Error Adding Late Reason',0),(156493,4348,'is','',0),(156494,4348,'dr','(Ø§Ø®ÙŠØ±',0),(156495,4348,'pr','Ø§ÙØ²ÙˆØ¯Ù†  Ø¯Ù„ÙŠÙ„ Ú¯Ø°Ø´ØªÙ‡ (Ø§Ø®ÙŠØ±',0),(156496,4348,'tr','GeÃ§ bir sebep ekleyin',0),(156497,4348,'pl','Dlatego pod koniec dodaÄ‡',0),(156498,4348,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÑ€Ð°Ñ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(156499,4348,'ur','ÙˆØ¬Û Ø³Û’ ØªØ§Ø®ÛŒØ± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(156500,4348,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÐ°ÑÐ½Ð¾ Ñ€Ð°Ð·Ð»Ð¾Ð³',0),(156501,4348,'vi','ThÃªm NguyÃªn nhÃ¢n muá»™n',0),(156502,4348,'af','Laat daarom voeg',0),(156503,4348,'ro','Adauga tÃ¢rziu motiv',0),(156504,4348,'et','Hilinemise pÃµhjust lisada',0),(156505,4348,'si','Dodaj pozno razlog',0),(156506,4348,'ba','Menambahkan alasan akhir',0),(156507,4348,'nl','Laat reden toevoegen',0),(156508,4348,'fi','MyÃ¶hÃ¤Ã¤n syy lisÃ¤Ã¤',0),(156509,4348,'no','Sen grunn legge',0),(156510,4348,'da','Sen derfor tilfÃ¸je',0),(156511,4348,'ko','ëŠ¦ì€ ì´ìœ  ì¶”ê°€',0),(156512,4348,'he','×”×•×¡×¤×ª ×¡×™×‘×” ×ž××•×—×¨',0),(156513,4348,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î±ÏÎ³Î¬ Ï„Î¿ Î»ÏŒÎ³Î¿',0),(156514,4348,'zh','é€¾æœŸåŽŸå› æ–°å¢ž\r\n',0),(156515,4348,'sv','Sent dÃ¤rfÃ¶r lÃ¤gga till',0),(156516,4348,'it','Motivo fine aggiungere',0),(156517,4348,'tl','',0),(156518,4348,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3621;&#3656;&#3634;&#3594;&#3657;&#3634;',0),(156519,4348,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤•à¤¾à¤°à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(156520,4348,'ms','Lewat sebab Tambah',0),(156521,4348,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø³Ø¨Ø¨ ÙÙŠ ÙˆÙ‚Øª Ù…ØªØ£Ø®Ø±',0),(156522,4348,'fr','Ajouter raison fin',0),(156523,4348,'jp','é?…å»¶ç?†ç”±ã?®è¿½åŠ ',0),(156524,4348,'pt','RazÃ£o final adicionar',0),(156525,4348,'ru','ÐšÐ¾Ð½Ñ†Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(156526,4348,'es','ExplicaciÃ³n Tarde Agregar',0),(156527,4348,'de','SpÃ¤ten Grund hinzufÃ¼gen',0),(156528,4348,'en','Late Reason Add',0),(156529,4349,'is','',0),(156530,4349,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙØ§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(156531,4349,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙØ§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(156532,4349,'tr','Hisse senedi amacÄ± eklemek',0),(156533,4349,'pl','PieÅ„ celu Dodaj',0),(156534,4349,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´ Ñ†ÐµÐ»',0),(156535,4349,'ur','Ø§Ø³Ù¹Ø§Ú© Ù…Ù‚ØµØ¯ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(156536,4349,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ð° ÑÐ²Ñ€Ñ…Ñƒ',0),(156537,4349,'vi','ThÃªm Má»¥c Ä‘Ã­ch HÃ ng tá»“n',0),(156538,4349,'af','Voorraad doel voeg',0),(156539,4349,'ro','AdÄƒugaÅ£i stoc scop',0),(156540,4349,'et','Varu selleks lisamine',0),(156541,4349,'si','Dodaj parka namen',0),(156542,4349,'ba','Tambahkan saham tujuan',0),(156543,4349,'nl','Voorraad doel toevoegen',0),(156544,4349,'fi','Varastossa tarkoitus lisÃ¤tÃ¤',0),(156545,4349,'no','Lager formÃ¥l legge',0),(156546,4349,'da','Stock formÃ¥let tilfÃ¸je',0),(156547,4349,'ko','ìž¬ê³  ëª©ì  ì¶”ê°€',0),(156548,4349,'he','×ª×›×œ×™×ª ×ž× ×™×•×ª ×œ×”×•×¡×™×£',0),(156549,4349,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± ÏƒÎºÎ¿Ï€ÏŒ',0),(156550,4349,'zh','æ–°å¢žåº“å­˜ç›®çš„\r\n',0),(156551,4349,'sv','Stock syfte lÃ¤gga till',0),(156552,4349,'it','Dipinga scopo aggiungere',0),(156553,4349,'tl','',0),(156554,4349,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3623;&#3633;&#3605;&#3606;&#3640;&#3611;&#3619;&#3632;&#3626;&#3591;&#3588;&#3660;&#3586;&#3629;&#3591;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(156555,4349,'hi','à¤‰à¤¦à¥à¤¦à¥‡à¤¶à¥à¤¯ à¤•à¥‡ à¤¶à¥‡à¤¯à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(156556,4349,'ms','Menambah saham tujuan',0),(156557,4349,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø£Ø³Ù‡Ù… ÙˆØ§Ù„ØºØ±Ø¶',0),(156558,4349,'fr','Ajouter fin stock',0),(156559,4349,'jp','åœ¨åº«ç›®çš„ã?®è¿½åŠ ',0),(156560,4349,'pt','Adicionar o propÃ³sito das aÃ§Ãµes',0),(156561,4349,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ð¹ Ñ†ÐµÐ»ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(156562,4349,'es','PropÃ³sito de Stock Agregar',0),(156563,4349,'de','Hat Zweck hinzufÃ¼gen',0),(156564,4349,'en','Stock Purpose Add',0),(156565,4350,'is','',0),(156566,4350,'dr','Ù…Ù‚Ø§Ø¯ÙŠØ±',0),(156567,4350,'pr','Ù…Ù‚Ø§Ø¯ÙŠØ±',0),(156568,4350,'tr','TutarlarÄ±',0),(156569,4350,'pl','Kwoty',0),(156570,4350,'bg','Ð¡ÑƒÐ¼Ð¸',0),(156571,4350,'ur','Ù…Ù‚Ø¯Ø§Ø±',0),(156572,4350,'sr','Ð˜Ð·Ð½Ð¾ÑÐ¸',0),(156573,4350,'vi','CÃ¡c Sá»‘ LÆ°á»£ng',0),(156574,4350,'af','Bedrae',0),(156575,4350,'ro','Sumele',0),(156576,4350,'et','Summad',0),(156577,4350,'si','Zneski',0),(156578,4350,'ba','Jumlah',0),(156579,4350,'nl','Bedragen',0),(156580,4350,'fi','MÃ¤Ã¤rÃ¤t',0),(156581,4350,'no','BelÃ¸p',0),(156582,4350,'da','BelÃ¸b',0),(156583,4350,'ko','ê¸ˆì•¡',0),(156584,4350,'he','×›×ž×•×™×•×ª',0),(156585,4350,'el','Î Î¿ÏƒÎ¬',0),(156586,4350,'zh','é‡‘é¢\r\n',0),(156587,4350,'sv','Belopp',0),(156588,4350,'it','Importi',0),(156589,4350,'tl','',0),(156590,4350,'th','&#3592;&#3635;&#3609;&#3623;&#3609;',0),(156591,4350,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(156592,4350,'ms','Jumlah',0),(156593,4350,'ar','Ø§Ù„Ù…Ø¨Ø§Ù„Øº',0),(156594,4350,'fr','Montants',0),(156595,4350,'jp','ç·?é¡?',0),(156596,4350,'pt','Montantes',0),(156597,4350,'ru','Ð¡ÑƒÐ¼Ð¼Ñ‹',0),(156598,4350,'es','Cantidades',0),(156599,4350,'de','BetrÃ¤ge',0),(156600,4350,'en','Amounts',0),(156601,4351,'is','',0),(156602,4351,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ÙŠ Ø¨Ø§ Ù…Ø¹ÙŠØ§Ø±Ù‡Ø§ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(156603,4351,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ÙŠ Ø¨Ø§ Ù…Ø¹ÙŠØ§Ø±Ù‡Ø§ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(156604,4351,'tr','HiÃ§bir emir eÅŸleÅŸtirme Ã¶lÃ§Ã¼tÃ¼',0),(156605,4351,'pl','Å»adne kryteria dopasowania zamÃ³wienia',0),(156606,4351,'bg','ÐÐ¸ÐºÐ°ÐºÐ²Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¼Ð°Ñ‡ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ð¸',0),(156607,4351,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø§Ø±ÛŒ Ù…ÛŒÚ† Ú©Ø³ÙˆÙ¹ÛŒ',0),(156608,4351,'sr','ÐÐµÐ¼Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ñ˜ÑƒÐ¼Ðµ Ð·Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐµ',0),(156609,4351,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n hÃ ng phÃ¹ há»£p vá»›i tiÃªu chÃ­',0),(156610,4351,'af','Geen Bestellings \"Match\" Kriteria',0),(156611,4351,'ro','Nici un criteriu de meci comenzi',0),(156612,4351,'et','Ãœkski tellimus ei vasta kriteeriumitele',0),(156613,4351,'si','Ni nalogi tekmo meril',0),(156614,4351,'ba','Tidak ada pesanan sesuai kriteria',0),(156615,4351,'nl','Geen Orders vergelijkingscriteria',0),(156616,4351,'fi','Ei tilauksia vastaavuusehto',0),(156617,4351,'no','Ingen ordrer treffvilkÃ¥rene',0),(156618,4351,'da','Ingen ordrer sÃ¸gekriterier',0),(156619,4351,'ko','ì•„ë‹ˆ ì£¼ë¬¸ ì¼ì¹˜ ì¡°ê±´',0),(156620,4351,'he','××™×Ÿ ×§×¨×™×˜×¨×™×•× ×™× ×”×ª××ž×” ×”×–×ž× ×•×ª',0),(156621,4351,'el','Î§Ï‰ÏÎ¯Ï‚ ÎºÏÎ¹Ï„Î®ÏÎ¹Î± Î±Î³ÏŽÎ½Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(156622,4351,'zh','æ²¡æœ‰ç¬¦åˆæ ‡å‡†çš„è®¢å•\r\n',0),(156623,4351,'sv','Inga bestÃ¤llningar matchningsvillkor',0),(156624,4351,'it','Nessun criterio di corrispondenza di ordini',0),(156625,4351,'tl','',0),(156626,4351,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3605;&#3619;&#3591;&#3585;&#3633;&#3610;&#3585;&#3633;&#3610;&#3648;&#3585;&#3603;&#3601;&#3660;',0),(156627,4351,'hi','à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤®à¥ˆà¤š à¤®à¤¾à¤ªà¤¦à¤‚à¤¡',0),(156628,4351,'ms','Tiada perintah yang sepadan dengan kriteria',0),(156629,4351,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø·Ù„Ø¨ÙŠØ§Øª ØªØ·Ø§Ø¨Ù‚ Ø§Ù„Ù…Ø¹Ø§ÙŠÙŠØ±',0),(156630,4351,'fr','Aucun critÃ¨re de correspondance d\'ordres',0),(156631,4351,'jp','åŸºæº–ã?«ä¸€è‡´ã?™ã‚‹æ³¨æ–‡ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(156632,4351,'pt','NÃ£o hÃ¡ critÃ©rios de correspondÃªncia de ordens',0),(156633,4351,'ru','ÐÐµÑ‚ Ð—Ð°ÐºÐ°Ð·Ð¾Ð² Ð¡Ð¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… ÐšÑ€Ð¸Ñ‚ÐµÑ€Ð¸ÑÐ¼',0),(156634,4351,'es','Ningunos Ordenes Emparejaron los Criterios',0),(156635,4351,'de','Keine Bestellungen Ãœbereinstimmungskriterien',0),(156636,4351,'en','No Orders Match Criteria',0),(156637,4352,'is','',0),(156638,4352,'dr','Ø¯Ø±ØµØ¯ Ú†Ø§Ù¾ ',0),(156639,4352,'pr','Ø¯Ø±ØµØ¯ Ú†Ø§Ù¾ ',0),(156640,4352,'tr','% GÃ¶sterim',0),(156641,4352,'pl','% wyÅ›wietleÅ„',0),(156642,4352,'bg','% Ð¾Ñ‚ Ð¸Ð¼Ð¿Ñ€ÐµÑÐ¸Ð¸',0),(156643,4352,'ur','Ù†Ù‚ÙˆØ´ Ú©Ø§ ÙÛŒØµØ¯',0),(156644,4352,'sr','% Ð¾Ð´ ÑƒÑ‚Ð¸ÑÐ°ÐºÐ°',0),(156645,4352,'vi','% cá»§a áº¥n tÆ°á»£ng',0),(156646,4352,'af','% van indrukke',0),(156647,4352,'ro','% de impresii',0),(156648,4352,'et','Muljeid %',0),(156649,4352,'si','% Prikazov',0),(156650,4352,'ba','% dari tayangan',0),(156651,4352,'nl','% van indrukken',0),(156652,4352,'fi','% nÃ¤yttÃ¶kerrat',0),(156653,4352,'no','% visninger',0),(156654,4352,'da','% af visninger',0),(156655,4352,'ko','ë…¸ì¶œì˜ %',0),(156656,4352,'he','××—×•×– ×¨×©×ž×™×',0),(156657,4352,'el','% Ï„Î¿Ï… ÎµÎ½Ï„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚',0),(156658,4352,'zh','ï¼…çš„å°è±¡\r\n',0),(156659,4352,'sv','% av intryck',0),(156660,4352,'it','% di impressioni',0),(156661,4352,'tl','',0),(156662,4352,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(156663,4352,'hi','à¤›à¤¾à¤ªà¥‹à¤‚ à¤•à¤¾ %',0),(156664,4352,'ms','% tayangan',0),(156665,4352,'ar','% Ù…Ù† Ø§Ù„Ø§Ù†Ø·Ø¨Ø§Ø¹Ø§Øª',0),(156666,4352,'fr','% d\'Impressions',0),(156667,4352,'jp','% of Impressions',0),(156668,4352,'pt','% de impressÃµes',0),(156669,4352,'ru','% Ð¾Ñ‚ Ð²Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸Ð¹',0),(156670,4352,'es','% de Impresiones',0),(156671,4352,'de','% der EindrÃ¼cke',0),(156672,4352,'en','% of Impressions',0),(156673,4353,'is','',0),(156674,4353,'dr','Ø¯Ø±ØµØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(156675,4353,'pr','Ø¯Ø±ØµØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(156676,4353,'tr','sipariÅŸlerin %',0),(156677,4353,'pl','% zamÃ³wieÅ„',0),(156678,4353,'bg','% Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸Ñ‚Ðµ',0),(156679,4353,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ø§ ÙÛŒØµØ¯',0),(156680,4353,'sr','% Ð¾Ð´ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(156681,4353,'vi','% cá»§a Ä‘Æ¡n hÃ ng',0),(156682,4353,'af','% van Bestellings',0),(156683,4353,'ro','% de comenzi',0),(156684,4353,'et','Tellimuste %',0),(156685,4353,'si','% NaroÄil',0),(156686,4353,'ba','% dari pesanan',0),(156687,4353,'nl','% van Orders',0),(156688,4353,'fi','% Tilauksista',0),(156689,4353,'no','% av bestillinger',0),(156690,4353,'da','% af ordrer',0),(156691,4353,'ko','ëª…ë ¹ì˜ %',0),(156692,4353,'he','% ×©×œ ×”×–×ž× ×•×ª',0),(156693,4353,'el','% Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(156694,4353,'zh','ï¼…çš„è®¢å•\r\n',0),(156695,4353,'sv','% av order',0),(156696,4353,'it','% degli ordini',0),(156697,4353,'tl','',0),(156698,4353,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(156699,4353,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ %',0),(156700,4353,'ms','% daripada perintah-perintah',0),(156701,4353,'ar','% Ù…Ù† Ø£ÙˆØ§Ù…Ø±',0),(156702,4353,'fr','% des commandes',0),(156703,4353,'jp','æ³¨æ–‡ã?®æ¯”çŽ‡',0),(156704,4353,'pt','% das encomendas',0),(156705,4353,'ru','% Ð¾Ñ‚ Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(156706,4353,'es','% de Ordenes',0),(156707,4353,'de','% der AuftrÃ¤ge',0),(156708,4353,'en','% of Orders',0),(156709,4354,'is','',0),(156710,4354,'dr','ØªØ§Ø±ÙŠØ® Ù‚ÙŠÙ…Øª ',0),(156711,4354,'pr','ØªØ§Ø±ÙŠØ® Ù‚ÙŠÙ…Øª ',0),(156712,4354,'tr','Fiyat tarihi',0),(156713,4354,'pl','Cena Data',0),(156714,4354,'bg','Ð¦ÐµÐ½Ð° Ð´Ð°Ñ‚Ð°',0),(156715,4354,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(156716,4354,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ†ÐµÐ½Ðµ',0),(156717,4354,'vi','NgÃ y giÃ¡',0),(156718,4354,'af','Prys Datum',0),(156719,4354,'ro','Pret data',0),(156720,4354,'et','Hinna kuupÃ¤ev',0),(156721,4354,'si','Cena datum',0),(156722,4354,'ba','Harga tanggal',0),(156723,4354,'nl','Prijs datum',0),(156724,4354,'fi','Hinnan pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(156725,4354,'no','Pris dato',0),(156726,4354,'da','Pris dato',0),(156727,4354,'ko','ê°€ê²© ë‚ ì§œ',0),(156728,4354,'he','×ž×—×™×¨ ×ª××¨×™×š',0),(156729,4354,'el','Î¤Î¹Î¼Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(156730,4354,'zh','ä»·æ ¼æ—¥æœŸ\r\n',0),(156731,4354,'sv','Pris datum',0),(156732,4354,'it','Prezzo data',0),(156733,4354,'tl','',0),(156734,4354,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;',0),(156735,4354,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(156736,4354,'ms','Tarikh harga',0),(156737,4354,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(156738,4354,'fr','Date du cours',0),(156739,4354,'jp','ä¾¡æ ¼è¨­å®šæ—¥',0),(156740,4354,'pt','PreÃ§o data',0),(156741,4354,'ru','Ð¦ÐµÐ½Ð° Ð”Ð°Ñ‚Ð°',0),(156742,4354,'es','Fecha de Precio',0),(156743,4354,'de','Preis Datum',0),(156744,4354,'en','Price Date',0),(156745,4355,'is','',0),(156746,4355,'dr','Ø¢Ù…Ø§Ø± Ø¨Ù‡ Ù…ÙˆÙ‚Ø¹ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡',0),(156747,4355,'pr','Ø¢Ù…Ø§Ø± Ø¨Ù‡ Ù…ÙˆÙ‚Ø¹ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡',0),(156748,4355,'tr','BasÄ±mevi zaman istatistikleri',0),(156749,4355,'pl','Drukarnia na czas statystyki',0),(156750,4355,'bg','ÐŸÐµÑ‡Ð°Ñ‚Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð½Ð° Ð²Ñ€ÐµÐ¼ÐµÑ‚Ð¾ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(156751,4355,'ur','Ù¾Ø±Ø§Ù†Ù¹Ø´ÙˆÙ¾ ÙˆÙ‚Øª Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± Ù¾Ø±',0),(156752,4355,'sr','ÐŸÑ€Ð¸Ð½Ñ‚ÑÑ…Ð¾Ð¿ Ð½Ð° ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÑƒ',0),(156753,4355,'vi','Thá»‘ng kÃª Ä‘Ãºng giá» cá»§a shop in',0),(156754,4355,'af','Printshop op tyd statistiek',0),(156755,4355,'ro','Printshop timp statisticÄƒ',0),(156756,4355,'et','TrÃ¼kikojale aja statistika',0),(156757,4355,'si','Tiskarne na Äasu statistike',0),(156758,4355,'ba','Printshop pada waktu Statistik',0),(156759,4355,'nl','PrintShop op tijd statistieken',0),(156760,4355,'fi','Painotalon tilastot',0),(156761,4355,'no','Trykkeriets pÃ¥ statistikk',0),(156762,4355,'da','Trykkeri pÃ¥ statistik over',0),(156763,4355,'ko','ì‹œê°„ í†µê³„ Printshop',0),(156764,4355,'he','×”×™×™×¢×•×¥ ×¢×œ ×”×–×ž×Ÿ ×¡×˜×˜×™×¡×˜×™×§×•×ª',0),(156765,4355,'el','Î¤Ï…Ï€Î¿Î³ÏÎ±Ï†ÎµÎ¯Î¿Ï… Ï‡ÏÏŒÎ½Î¿ ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÏŽÎ½',0),(156766,4355,'zh','ç‰ˆç”»åœ¨æ—¶é—´ç»Ÿè®¡\r\n',0),(156767,4355,'sv','Tryckeriet pÃ¥ tid statistik',0),(156768,4355,'it','PrintShop su statistiche tempo',0),(156769,4355,'tl','',0),(156770,4355,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3619;&#3657;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;&#3607;&#3637;&#3656;&#3605;&#3619;&#3591;&#3605;&#3656;&#3629;&#3648;&#3623;&#3621;&#3634;',0),(156771,4355,'hi','à¤¸à¤®à¤¯ à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤•à¥€ à¤ªà¤° Printshop',0),(156772,4355,'ms','Printshop statistik masa',0),(156773,4355,'ar','Ø§Ù„Ù…Ø·Ø¨Ø¹Ø© ÙÙŠ ÙˆÙ‚Øª Ø§Ù„Ø¥Ø­ØµØ§Ø¡',0),(156774,4355,'fr','Atelier sur les statistiques de temps',0),(156775,4355,'jp','Printshop On Time Statistics',0),(156776,4355,'pt','Tipografia em estatÃ­sticas de tempo',0),(156777,4355,'ru','Ð¢Ð¸Ð¿Ð¾Ð³Ñ€Ð°Ñ„Ð¸Ð¸ Ð¿Ð¾ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐµ Ð²Ñ€ÐµÐ¼Ñ',0),(156778,4355,'es','EstadÃ­sticas de Printshop en Tiempo',0),(156779,4355,'de','PrintShop auf Statistiken',0),(156780,4355,'en','Printshop On Time Statistics',0),(156781,4356,'is','',0),(156782,4356,'dr','Ø¢Ù…Ø§Ø± Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡ Ø¨Ø±Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ù‡Ø§ ',0),(156783,4356,'pr','Ø¢Ù…Ø§Ø± Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡ Ø¨Ø±Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ù‡Ø§ ',0),(156784,4356,'tr','Tarihler iÃ§in basÄ±mevi istatistikleri',0),(156785,4356,'pl','Drukarnia statystyki dla dat',0),(156786,4356,'bg','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ€Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð° Ð´Ð°Ñ‚Ð¸',0),(156787,4356,'ur','ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©Û’ Ù„Ø¦Û’ Ù¾Ø±Ø§Ù†Ù¹Ø´ÙˆÙ¾ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±',0),(156788,4356,'sr','ÐŸÑ€Ð¸Ð½Ñ‚ÑÑ…Ð¾Ð¿ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÑƒ Ð·Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ðµ',0),(156789,4356,'vi','Thá»‘ng kÃª cá»§a shop in cho ngÃ y',0),(156790,4356,'af','Printshop statistiek vir datums',0),(156791,4356,'ro','Printshop statistici pentru dvs.',0),(156792,4356,'et','TrÃ¼kikojale statistika saamiseks kuupÃ¤evi',0),(156793,4356,'si','Tiskarni statistika za datume',0),(156794,4356,'ba','Printshop statistik untuk tanggal',0),(156795,4356,'nl','PrintShop statistieken voor datums',0),(156796,4356,'fi','Painotalon tilastot pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(156797,4356,'no','Trykkeriets statistikk for datoer',0),(156798,4356,'da','Printshop statistikker for datoer',0),(156799,4356,'ko','ë‚ ì§œì— ëŒ€ í•œ Printshop í†µê³„',0),(156800,4356,'he','×”×™×™×¢×•×¥ ×¡×˜×˜×™×¡×˜×™×§×” ×¢×‘×•×¨ ×ª××¨×™×›×™×',0),(156801,4356,'el','Î¤Ï…Ï€Î¿Î³ÏÎ±Ï†ÎµÎ¯Î¿Ï… ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î³Î¹Î± Ï„Î¹Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(156802,4356,'zh','ç»Ÿè®¡çš„æ—¥æœŸç‰ˆç”»\r\n',0),(156803,4356,'sv','Tryckeriet statistik fÃ¶r datum',0),(156804,4356,'it','PrintShop statistiche per date',0),(156805,4356,'tl','',0),(156806,4356,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3619;&#3657;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(156807,4356,'hi','Printshop à¤¤à¤¾à¤°à¥€à¤–à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤•à¥€',0),(156808,4356,'ms','Printshop statistik pada tarikh',0),(156809,4356,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ù…Ø·Ø¨Ø¹Ø© Ù„Ù„ØªÙˆØ§Ø±ÙŠØ®',0),(156810,4356,'fr','PrintShop statistiques pour les Dates',0),(156811,4356,'jp','Printshop Statistics for Dates',0),(156812,4356,'pt','EstatÃ­sticas de tipografia para datas',0),(156813,4356,'ru','Ð¢Ð¸Ð¿Ð¾Ð³Ñ€Ð°Ñ„Ð¸Ð¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð´Ð»Ñ Ð´Ð°Ñ‚',0),(156814,4356,'es','EstadÃ­sticas de Printshop para Fechas',0),(156815,4356,'de','PrintShop-Statistik fÃ¼r Dates',0),(156816,4356,'en','Printshop Statistics for Dates',0),(156817,4357,'is','',0),(156818,4357,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ ',0),(156819,4357,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ ',0),(156820,4357,'tr','SipariÅŸ durumunu seÃ§in',0),(156821,4357,'pl','Wybierz stan zamÃ³wienia',0),(156822,4357,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(156823,4357,'ur','Ø­Ú©Ù… Ú©ÛŒ Ø­ÛŒØ«ÛŒØª Ø³Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(156824,4357,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(156825,4357,'vi','Chá»n tÃ¬nh tráº¡ng Ä‘Æ¡n hÃ ng',0),(156826,4357,'af','Selekteer Bestellingstatus',0),(156827,4357,'ro','SelectaÅ£i starea comenzii',0),(156828,4357,'et','Valige tellimuse olek',0),(156829,4357,'si','Izberite stanje naloga',0),(156830,4357,'ba','Pilih Status pesanan',0),(156831,4357,'nl','Selecteer Status van bestelling',0),(156832,4357,'fi','Valitse huoltotilauksen tila',0),(156833,4357,'no','Velg bestillingsstatus',0),(156834,4357,'da','VÃ¦lg ordrestatus',0),(156835,4357,'ko','ì£¼ë¬¸ ìƒíƒœ ì„ íƒ',0),(156836,4357,'he','×‘×—×¨ ××ª ×ž×¦×‘ ×”×”×–×ž× ×”',0),(156837,4357,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(156838,4357,'zh','é€‰æ‹©è®¢å•çŠ¶æ€\r\n',0),(156839,4357,'sv','VÃ¤lj produktionsorderns Status',0),(156840,4357,'it','Selezionare lo stato dell\'ordine',0),(156841,4357,'tl','',0),(156842,4357,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3606;&#3634;&#3609;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(156843,4357,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(156844,4357,'ms','Pilih Status pesanan',0),(156845,4357,'ar','Ø­Ø¯Ø¯ Ø­Ø§Ù„Ø© Ø·Ù„Ø¨Ùƒ',0),(156846,4357,'fr','SÃ©lectionnez le statut des commandes',0),(156847,4357,'jp','æ³¨æ–‡çŠ¶æ³?ã?®é?¸æŠž',0),(156848,4357,'pt','Selecione o Status do pedido',0),(156849,4357,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð—Ð°ÐºÐ°Ð·Ð°',0),(156850,4357,'es','Seleccionar Status de Orden',0),(156851,4357,'de','WÃ¤hlen Sie den Bestellstatus',0),(156852,4357,'en','Select Order Status',0),(156853,4358,'is','',0),(156854,4358,'dr','(Ø´Ø±ÙˆØ¹',0),(156855,4358,'pr','ØªØ§Ø±ÙŠØ® Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²Ù‰(Ø´Ø±ÙˆØ¹',0),(156856,4358,'tr','BaÅŸlangÄ±Ã§ tarihi',0),(156857,4358,'pl','Data poczÄ…tkowa',0),(156858,4358,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(156859,4358,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØªØ§Ø±ÛŒØ®',0),(156860,4358,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(156861,4358,'vi','NgÃ y Báº¯t Äáº§u',0),(156862,4358,'af','Aanvangsdatum',0),(156863,4358,'ro','Data de Ã®nceput',0),(156864,4358,'et','AlguskuupÃ¤ev',0),(156865,4358,'si','ZaÄetni datum',0),(156866,4358,'ba','Tanggal mulai',0),(156867,4358,'nl','Begindatum',0),(156868,4358,'fi','AloituspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(156869,4358,'no','Startdato',0),(156870,4358,'da','Startdato',0),(156871,4358,'ko','ì‹œìž‘ ë‚ ì§œ',0),(156872,4358,'he','×ª××¨×™×š ×”×”×ª×—×œ×”',0),(156873,4358,'el','Î—Î¼/Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(156874,4358,'zh','å¯åŠ¨æ—¥æœŸ\r\n',0),(156875,4358,'sv','Startdatum',0),(156876,4358,'it','Data di partenza',0),(156877,4358,'tl','',0),(156878,4358,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(156879,4358,'hi','à¤¶à¥à¤°à¥‚ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤¤à¤¿à¤¥à¤¿',0),(156880,4358,'ms','Tarikh permulaan',0),(156881,4358,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(156882,4358,'fr','Date de dÃ©part',0),(156883,4358,'jp','é–‹å§‹æ—¥',0),(156884,4358,'pt','Data de inÃ­cio',0),(156885,4358,'ru','ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ð°Ñ Ð”Ð°Ñ‚Ð°',0),(156886,4358,'es','Fecha de Inicio',0),(156887,4358,'de','Startdatum',0),(156888,4358,'en','Starting Date',0),(156889,4359,'is','',0),(156890,4359,'dr','(Ø´Ø±ÙˆØ¹) Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø³Øª . Ø±Ø¬ÙˆØ¹ Ø¨Ù‡ Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ø¢Ø®Ø±ÙŠÙ† Ù…Ø§Ù‡ ',0),(156891,4359,'pr','ØªØ§Ø±ÙŠØ® Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²Ù‰(Ø´Ø±ÙˆØ¹) Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø³Øª . Ø±Ø¬ÙˆØ¹ Ø¨Ù‡ Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ø¢Ø®Ø±ÙŠÙ† Ù…Ø§Ù‡ ',0),(156892,4359,'tr','BaÅŸlangÄ±Ã§ tarihi bitiÅŸ tarihinden sonra. Rapor iÃ§in son bir aydÄ±r dÃ¶nÃ¼lÃ¼yor.',0),(156893,4359,'pl','PoczÄ…wszy od daty po daty koÅ„cowej. PowrÃ³t do raportu za ostatni miesiÄ…c.',0),(156894,4359,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° ÑÐ»ÐµÐ´ ÐºÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°. Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° Ð·Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ Ð¼ÐµÑÐµÑ†.',0),(156895,4359,'ur','ØªØ§Ø±ÛŒØ® Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©Û’ Ø¨Ø¹Ø¯ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û” Ø±Ù¾ÙˆØ±Ù¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú¯Ø²Ø´ØªÛ Ù…Ø§Û Ø§Ù„Ù¹Ø§ Ø±ÛØ§ ÛÛ’ Ø¯Ø±.',0),(156896,4359,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð°ÐºÐ¾Ð½ ÐºÑ€Ð°Ñ˜ÑšÐµÐ³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°. Ð’Ñ€Ð°Ñ›Ð°ÑšÐµ Ð½Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð·Ð° Ð¿Ñ€Ð¾ÑˆÐ»Ð¾Ð³ Ð¼ÐµÑÐµÑ†Ð°.',0),(156897,4359,'vi','NgÃ y báº¯t Ä‘áº§u lá»›n hÆ¡n ngÃ y káº¿t thÃºc. Äáº£o ngÆ°á»£c bÃ¡o cÃ¡o thÃ¡ng cuá»‘i',0),(156898,4359,'af','Begin datum na datum eindig. Verslag nie terugskakel vir die laaste maand.',0),(156899,4359,'ro','Incepand cu data dupÄƒ data de sfÃ¢rÅŸit. Revenirea la raport pentru ultima lunÄƒ.',0),(156900,4359,'et','AlguskuupÃ¤ev on pÃ¤rast lÃµppkuupÃ¤eva. Ennistamine aruande eelmisel kuul.',0),(156901,4359,'si','ZaÄetni datum po konÄni datum. VraÄanje na poroÄila za prejÅ¡nji mesec.',0),(156902,4359,'ba','Mulai tanggal setelah tanggal berakhirnya. Kembali ke laporan untuk bulan lalu.',0),(156903,4359,'nl','Begindatum na de einddatum. Terug te keren naar de verslag voor vorige maand.',0),(156904,4359,'fi','AloituspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ jÃ¤lkeen viimeinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤. Palataan raportin viime kuussa.',0),(156905,4359,'no','Startdatoen etter sluttdato. Gjenoppretter rapport for siste mÃ¥neden.',0),(156906,4359,'da','Start dato efter slutdato. Vende tilbage til betÃ¦nkning i sidste mÃ¥ned.',0),(156907,4359,'ko','ì¢…ë£Œ ë‚ ì§œ í›„ì— ë‚ ì§œë¥¼ ì‹œìž‘ í•©ë‹ˆë‹¤. ì§€ë‚œ ë‹¬ì— ëŒ€ í•œ ë³´ê³ ì„œë¥¼ ë˜ëŒë¦¬ê¸°.',0),(156908,4359,'he','×ž×ª×—×™×œ ×ª××¨×™×š ×œ××—×¨ ×ª××¨×™×š ×¡×’×™×¨×”. ×—×•×–×¨ ×œ×“×•×•×— ×‘×—×•×“×© ×”××—×¨×•×Ÿ.',0),(156909,4359,'el','ÎžÎµÎºÎ¹Î½ÏŽÎ½Ï„Î±Ï‚ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¼ÎµÏ„Î¬ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚. Î•Ï€Î±Î½Î­ÏÏ‡Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ· Î³Î¹Î± Ï„Î¿Î½ Ï€ÎµÏÎ±ÏƒÎ¼Î­Î½Î¿ Î¼Î®Î½Î±.',0),(156910,4359,'zh','å¼€å§‹æ—¥å‰åœ¨ç»“æŸæ—¥æœŸåŽã€‚è¿”å›žåˆ°æœ€åŽä¸€ä¸ªæœˆçš„æŠ¥å‘Šã€‚\r\n',0),(156911,4359,'sv','Start datum efter slutdatumet. Ã…tergÃ¥ till rapporten fÃ¶r fÃ¶rra mÃ¥naden.',0),(156912,4359,'it','A partire da data dopo Data fine. Tornando al rapporto per il mese scorso.',0),(156913,4359,'tl','',0),(156914,4359,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3627;&#3621;&#3633;&#3591;&#3592;&#3634;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3623;&#3633;&#3609;. &#3588;&#3639;&#3609;&#3619;&#3634;&#3618;&#3591;&#3634;&',0),(156915,4359,'hi','à¤¶à¥à¤°à¥‚ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦à¥¤ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¿à¤›à¤²à¥‡ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥€ à¤“à¤° à¤²à¥Œà¤Ÿà¤¨à¤¾à¥¤',0),(156916,4359,'ms','Bermula tarikh selepas berakhir tarikh. Kembali kepada laporan bagi bulan lepas.',0),(156917,4359,'ar','Ø§Ø¨ØªØ¯Ø§Ø¡ Ù…Ù† ØªØ§Ø±ÙŠØ® Ø¨Ø¹Ø¯ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡. Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ù„Ù„Ø´Ù‡Ø± Ø§Ù„Ù…Ø§Ø¶ÙŠ.',0),(156918,4359,'fr','Ã€ partir de la Date aprÃ¨s la Date de fin. Revenant sur le rapport pour le dernier mois.',0),(156919,4359,'jp','é–‹å§‹æ—¥ã?Œçµ‚äº†æ—¥ã‚ˆã‚Šå¾Œã?§ã?™ã€‚å…ˆæœˆã?®ãƒ¬ãƒ?ãƒ¼ãƒˆã?«æˆ»ã?£ã?¦ã?„ã?¾ã?™ã€‚',0),(156920,4359,'pt','ComeÃ§ando data apÃ³s a data de encerramento. Voltando ao relatÃ³rio para o mÃªs passado.',0),(156921,4359,'ru','Ð”Ð°Ñ‚Ð° ÐÐ°Ñ‡Ð°Ð»Ð° ÐŸÐžÐ¡Ð›Ð• Ð”Ð°Ñ‚Ñ‹ ÐšÐ¾Ð½Ñ†Ð°. Ð’Ñ€Ð½ÑƒÑ‚ÑŒÑÑ Ð´Ð»Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° Ð·Ð° Ð¿Ñ€Ð¾ÑˆÐ»Ñ‹Ð¹ Ð¼ÐµÑÑÑ†.',0),(156922,4359,'es','Fecha de Inicio DESPUÃ‰S de la Fecha de TerminaciÃ³n. Revertiendo al informe para el Ãºltimo mes',0),(156923,4359,'de','Des Startdatums nach Enddatum. ZurÃ¼cksetzen auf Bericht fÃ¼r im letzten Monat.',0),(156924,4359,'en','Starting Date AFTER Ending Date. Reverting to report for last month.',0),(156925,4360,'is','',0),(156926,4360,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ø´Ø¯Ù‡  Ø¨Ù„Ù‡',0),(156927,4360,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ø´Ø¯Ù‡  Ø¨Ù„Ù‡',0),(156928,4360,'tr','Tamam kabul',0),(156929,4360,'pl','Akceptowane OK',0),(156930,4360,'bg','ÐŸÑ€Ð¸ÐµÑ‚Ð¾ Ð´Ð¾Ð±Ñ€Ðµ',0),(156931,4360,'ur','ÛØ§Úº Ù¹Ú¾ÛŒÚ© ÛÛ’ Ø³Ø§Ù„Ø§Ù†Û',0),(156932,4360,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ñ˜Ðµ Ð¿Ñ€Ð¸Ñ…Ð²Ð°Ñ‚Ð¸Ð¾',0),(156933,4360,'vi','Cháº¥p Nháº­n OK',0),(156934,4360,'af','Aangeneem OK',0),(156935,4360,'ro','Acceptat OK',0),(156936,4360,'et','Aksepteerimine OK',0),(156937,4360,'si','Sprejeta OK',0),(156938,4360,'ba','Deterima OK',0),(156939,4360,'nl','Geaccepteerd OK',0),(156940,4360,'fi','HyvÃ¤ksyÃ¤ OK',0),(156941,4360,'no','Akseptert OK',0),(156942,4360,'da','Accepteret OK',0),(156943,4360,'ko','í™•ì¸ í—ˆìš©',0),(156944,4360,'he','×ž×ª×§×‘×œ×™× ×˜×•×‘',0),(156945,4360,'el','ÎˆÎ³Î¹Î½Îµ Î‘Ï€Î¿Î´ÎµÎºÏ„ÏŒ ÎŸÎš ',0),(156946,4360,'zh','æˆåŠŸæŽ¥æ”¶',0),(156947,4360,'sv','Accepterad OK',0),(156948,4360,'it','Accettato (Ok)',0),(156949,4360,'tl','',0),(156950,4360,'th','à¸•à¸à¸¥à¸‡à¸¢à¸­à¸¡à¸£à¸±à¸š',0),(156951,4360,'hi','à¤ à¥€à¤• à¤¹à¥ˆ à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤¿à¤ à¤œà¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(156952,4360,'ms','Diterima OK',0),(156953,4360,'ar','Ù‚Ø¨Ù„Øª Ø·ÙŠØ¨',0),(156954,4360,'fr','AcceptÃ© OK',0),(156955,4360,'jp','æ‰¿èª?ï¼¯ï¼«',0),(156956,4360,'pt','Aceito OK',0),(156957,4360,'ru','ÐŸÑ€Ð¸Ð½ÑÑ‚ ÐžÐš',0),(156958,4360,'es','OK Aceptado',0),(156959,4360,'de','Angenommen',0),(156960,4360,'en','Accepted OK',0),(156961,4361,'is','',0),(156962,4361,'dr','/ Ù‡Ù…Ù‡',0),(156963,4361,'pr','Ù‡ÙŠÚ†  / Ù‡Ù…Ù‡',0),(156964,4361,'tr','Herhangi/tÃ¼m',0),(156965,4361,'pl','Wszystkie',0),(156966,4361,'bg','Ð’ÑÑÐºÐ¾/Ð²ÑÐ¸Ñ‡ÐºÐ¸',0),(156967,4361,'ur','Ú©Ø³ÛŒ Ø¨Ú¾ÛŒ/ØªÙ…Ø§Ù…',0),(156968,4361,'sr','Ð‘Ð¸Ð»Ð¾ ÐºÐ¾Ñ˜Ð¸/ÑÐ²Ðµ',0),(156969,4361,'vi','Báº¥t ká»³/Táº¥t Cáº£',0),(156970,4361,'af','Enige/Alle',0),(156971,4361,'ro','Orice/toate',0),(156972,4361,'et','Mistahes/KÃµik',0),(156973,4361,'si','Vsako/vse',0),(156974,4361,'ba','Setiap/semua',0),(156975,4361,'nl','Elke/alle',0),(156976,4361,'fi','Kaikki/kaikki',0),(156977,4361,'no','Enhver/alle',0),(156978,4361,'da','Enhver/alle',0),(156979,4361,'ko','ëª¨ë“ ',0),(156980,4361,'he','×›×œ/×›×œ',0),(156981,4361,'el','ÎŸÏ€Î¿Î¹Î±Î´Î®Ï€Î¿Ï„Îµ/ÏŒÎ»Î±',0),(156982,4361,'zh','ä»»ä½•/æ‰€æœ‰\r\n',0),(156983,4361,'sv','Eventuella/alla',0),(156984,4361,'it','Ogni',0),(156985,4361,'tl','',0),(156986,4361,'th','&#3610;&#3634;&#3591;&#3626;&#3636;&#3656;&#3591;/&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(156987,4361,'hi','à¤•à¤¿à¤¸à¥€ à¤­à¥€/à¤¸à¤¬',0),(156988,4361,'ms','Apa-apa/semua',0),(156989,4361,'ar','Ø£ÙŠ/ÙƒØ§ÙØ©',0),(156990,4361,'fr','Tout/tous',0),(156991,4361,'jp','ã?©ã‚Œã?‹/ã?™ã?¹ã?¦',0),(156992,4361,'pt','Todos os',0),(156993,4361,'ru','Ð›ÑŽÐ±Ð¾Ð¹/Ð’ÑÐµ',0),(156994,4361,'es','Alguno/Todo',0),(156995,4361,'de','Alle/All',0),(156996,4361,'en','Any/All',0),(156997,4362,'is','',0),(156998,4362,'dr',' Ø§Ù†ØªØ®Ø§Ø¨ ÙˆØ¶Ø¹ÙŠØª  Ø§Ø«Ø¨Ø§Øª Ø³ÙØ§Ø±Ø´',0),(156999,4362,'pr',' Ø§Ù†ØªØ®Ø§Ø¨ ÙˆØ¶Ø¹ÙŠØª  Ø§Ø«Ø¨Ø§Øª Ø³ÙØ§Ø±Ø´',0),(157000,4362,'tr','SipariÅŸ kanÄ±tÄ± durumunu seÃ§in',0),(157001,4362,'pl','Wybierz dowÃ³d stan zamÃ³wienia',0),(157002,4362,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð·Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(157003,4362,'ur','Ø­Ú©Ù… Ú©Û’ Ø«Ø¨ÙˆØª Ú©ÛŒ Ø­ÛŒØ«ÛŒØª Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(157004,4362,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð¾ÐºÐ°Ð· ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(157005,4362,'vi','Chá»n tÃ¬nh tráº¡ng chá»©ng minh cá»§a Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(157006,4362,'af','Kies volgorde bewys Status',0),(157007,4362,'ro','Alege starea comenzii dovada',0),(157008,4362,'et','Valige tellimuse tÃµend staatuse',0),(157009,4362,'si','Izberite stanje naloga dokaz',0),(157010,4362,'ba','Pilih Status Order bukti',0),(157011,4362,'nl','Kies bewijs orderstatus',0),(157012,4362,'fi','Valitse tilauksen todiste tila',0),(157013,4362,'no','Velg bevis bestillingsstatus',0),(157014,4362,'da','VÃ¦lg bevis ordrestatus',0),(157015,4362,'ko','ì£¼ë¬¸ ì¦ê±° ìƒíƒœ ì„ íƒ',0),(157016,4362,'he','×‘×—×¨ ××ª ×ž×¦×‘ ×”×”×–×ž× ×” ×”×•×›×—×”',0),(157017,4362,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(157018,4362,'zh','é€‰æ‹©è®¢å•çŠ¶å†µè¯æ˜Ž\r\n',0),(157019,4362,'sv','VÃ¤lj Status fÃ¶r bevis',0),(157020,4362,'it','Scegliere prova stato ordine',0),(157021,4362,'tl','',0),(157022,4362,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3626;&#3606;&#3634;&#3609;&#3632;&#3612;&#3656;&#3634;&#3609;&#3585;&#3634;&#3619;&#3607;&#3604;&#3626;&#3629;&#3610;',0),(157023,4362,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤¬à¥‚à¤¤ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤šà¥à¤¨à¥‡à¤‚',0),(157024,4362,'ms','Pilih Status pesanan bukti',0),(157025,4362,'ar','Ø§Ø®ØªØ± Ø£Ù…Ø± Ø¥Ø«Ø¨Ø§Øª Ø­Ø§Ù„Ø©',0),(157026,4362,'fr','Choisissez l\'Ã‰tat une preuve de la commande',0),(157027,4362,'jp','æ³¨æ–‡æ ¡æ­£çŠ¶æ³?ã?®é?¸æŠž',0),(157028,4362,'pt','Escolher a prova de Status do pedido',0),(157029,4362,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð·Ð°ÐºÐ°Ð·Ð°',0),(157030,4362,'es','Seleccionar Status de ConfirmaciÃ³n de Pedido de ImpresiÃ³n',0),(157031,4362,'de','WÃ¤hlen Sie Beweis Bestellstatus',0),(157032,4362,'en','Choose Order Proof Status',0),(157033,4363,'is','',0),(157034,4363,'dr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(157035,4363,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(157036,4363,'tr','Vade tarihi',0),(157037,4363,'pl','Data ukoÅ„czenia',0),(157038,4363,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶',0),(157039,4363,'ur','ØªØ§Ø±ÛŒØ® Ù…Ù‚Ø±Ø±Û',0),(157040,4363,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð´Ð¾ÑÐ¿ÐµÑ›Ð°',0),(157041,4363,'vi','NgÃ y Ä‘áº¿n háº¡n',0),(157042,4363,'af','Datum Verskuldig',0),(157043,4363,'ro','Data scadenÅ£ei',0),(157044,4363,'et','Kehtivuse tÃ¤htaeg',0),(157045,4363,'si','Datum zapadlosti',0),(157046,4363,'ba','Tanggal jatuh tempo',0),(157047,4363,'nl','Datum vervaldatum',0),(157048,4363,'fi','MennessÃ¤ asianmukaisesti',0),(157049,4363,'no','Dato grunn',0),(157050,4363,'da','Dato Due',0),(157051,4363,'ko','ê¸°í•œ ë‚ ì§œ',0),(157052,4363,'he','×ª××¨×™×š ×™×¢×“',0),(157053,4363,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(157054,4363,'zh','åˆ°æœŸæ—¥\r\n',0),(157055,4363,'sv','Datum vederbÃ¶rlig',0),(157056,4363,'it','Data di scadenza',0),(157057,4363,'tl','',0),(157058,4363,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(157059,4363,'hi','à¤¦à¥‡à¤¯ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(157060,4363,'ms','Tarikh habis tempoh',0),(157061,4363,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø³ØªØ­Ù‚Ø§Ù‚',0),(157062,4363,'fr','Date d\'Ã©chÃ©ance',0),(157063,4363,'jp','æœŸæ—¥',0),(157064,4363,'pt','Data de vencimento',0),(157065,4363,'ru','Ð”Ð°Ñ‚Ð° Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾',0),(157066,4363,'es','Fecha Vencida',0),(157067,4363,'de','Due Date',0),(157068,4363,'en','Date Due',0),(157069,4364,'is','',0),(157070,4364,'dr','ØªØ§Ø±ÙŠØ® ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(157071,4364,'pr','ØªØ§Ø±ÙŠØ® ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(157072,4364,'tr','GÃ¶nderme tarihi',0),(157073,4364,'pl','DatÄ…',0),(157074,4364,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð°, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(157075,4364,'ur','ØªØ§Ø±ÛŒØ® Ø¨Ú¾ÛŒØ¬Ø§',0),(157076,4364,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÑÐ»Ð°ÑšÐ°',0),(157077,4364,'vi','NgÃ y gá»­i',0),(157078,4364,'af','Datum Gestuur',0),(157079,4364,'ro','Data trimiterii',0),(157080,4364,'et','Saatmise kuupÃ¤ev',0),(157081,4364,'si','Datum poÅ¡iljanja',0),(157082,4364,'ba','Tanggal yang dikirim',0),(157083,4364,'nl','Datum verzonden',0),(157084,4364,'fi','LÃ¤hettÃ¤mistÃ¤',0),(157085,4364,'no','Sendte',0),(157086,4364,'da','Dato sendt',0),(157087,4364,'ko','ë³´ë‚¸ ë‚ ì§œ',0),(157088,4364,'he','×ª××¨×™×š ×©×œ×™×—×”',0),(157089,4364,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(157090,4364,'zh','å‘é€æ—¥æœŸ\r\n',0),(157091,4364,'sv','Datum skickas',0),(157092,4364,'it','Data inviata',0),(157093,4364,'tl','',0),(157094,4364,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;',0),(157095,4364,'hi','à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(157096,4364,'ms','Tarikh dihantar',0),(157097,4364,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø±Ø³Ø§Ù„',0),(157098,4364,'fr','Date d\'envoi',0),(157099,4364,'jp','ç™ºé€?æ—¥',0),(157100,4364,'pt','Data enviada',0),(157101,4364,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(157102,4364,'es','Fecha Enviada',0),(157103,4364,'de','Absendedatum',0),(157104,4364,'en','Date Sent',0),(157105,4365,'is','',0),(157106,4365,'dr','For All Items',0),(157107,4365,'pr','For All Items',0),(157108,4365,'tr','TÃ¼m Ã¶ÄŸeler iÃ§in',0),(157109,4365,'pl','Dla wszystkich elementÃ³w',0),(157110,4365,'bg','Ð—Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(157111,4365,'ur','ØªÙ…Ø§Ù… Ø§Ø´ÛŒØ§ Ú©Û’ Ù„ÛŒÛ’',0),(157112,4365,'sr','Ð—Ð° ÑÐ²Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ',0),(157113,4365,'vi','Cho táº¥t cáº£ cÃ¡c máº·t hÃ ng',0),(157114,4365,'af','Vir Alle Items',0),(157115,4365,'ro','Pentru toate elementele',0),(157116,4365,'et','KÃµigi kirjete',0),(157117,4365,'si','Za vse artikle',0),(157118,4365,'ba','Untuk semua jenis barang',0),(157119,4365,'nl','Voor alle Items',0),(157120,4365,'fi','Kaikki kohteet',0),(157121,4365,'no','For alle elementer',0),(157122,4365,'da','For alle varer',0),(157123,4365,'ko','ëª¨ë“  í•­ëª©ì— ëŒ€ í•œ',0),(157124,4365,'he','×œ×›×œ ×”×¤×¨×™×˜×™×',0),(157125,4365,'el','Î“Î¹Î± ÏŒÎ»Î± Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(157126,4365,'zh','æ‰€æœ‰é¡¹ç›®\r\n',0),(157127,4365,'sv','FÃ¶r alla artiklar',0),(157128,4365,'it','Per tutti gli articoli',0),(157129,4365,'tl','',0),(157130,4365,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(157131,4365,'hi','à¤¸à¤­à¥€ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤',0),(157132,4365,'ms','Bagi semua item',0),(157133,4365,'ar','Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(157134,4365,'fr','Pour tous les Articles',0),(157135,4365,'jp','å…¨ã?¦ã?®å“?ç›®',0),(157136,4365,'pt','Para todos os itens',0),(157137,4365,'ru','Ð”Ð»Ñ Ð’ÑÐµÑ… Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(157138,4365,'es','Para Todos los Items',0),(157139,4365,'de','FÃ¼r alle Elemente',0),(157140,4365,'en','For All Items',0),(157141,4366,'is','',0),(157142,4366,'dr','Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ø´Ø¯Ù‡ Ùˆ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(157143,4366,'pr','Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ø´Ø¯Ù‡ Ùˆ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(157144,4366,'tr','Kabul ve tamamlanmÄ±ÅŸ maddeler iÃ§in',0),(157145,4366,'pl','Dla przedmiotÃ³w akceptowane i zakoÅ„czone',0),(157146,4366,'bg','Ð—Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸, Ð¿Ñ€Ð¸ÐµÑ‚Ð¸ Ð¸ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½',0),(157147,4366,'ur','Ú©Û’ Ù„Ø¦Û’ Ù‚Ø¨ÙˆÙ„ Ú©Ø± Ù„ÛŒØ§ Ø§ÙˆØ± Ù…Ú©Ù…Ù„ Ø¢Ø¦Ù¹Ù…',0),(157148,4366,'sr','Ð—Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð¿Ñ€Ð¸Ñ…Ð²Ð°Ñ‚Ð¸Ð¾ Ð¸ Ð´Ð¾Ð²Ñ€ÑˆÐ¸Ñ‚Ð¸',0),(157149,4366,'vi','DÃ nh cho hÃ ng Ä‘Ã£ cháº¥p nháº­n & hoÃ n táº¥t',0),(157150,4366,'af','Vir Items Aanvaar en Voltooi',0),(157151,4366,'ro','Pentru elemente acceptate ÅŸi completat',0),(157152,4366,'et','Kaupade vastu ja lÃµpetatud',0),(157153,4366,'si','Za elemente, ki so sprejeti in dokonÄati',0),(157154,4366,'ba','Untuk barang-barang diterima dan selesai',0),(157155,4366,'nl','Voor Items aanvaard en voltooid',0),(157156,4366,'fi','Nimikkeiden hyvÃ¤ksytty ja valmis',0),(157157,4366,'no','For varer akseptert og fullfÃ¸rt',0),(157158,4366,'da','For varer, accepteret og gennemfÃ¸rt',0),(157159,4366,'ko','ì ‘ìˆ˜ ì™„ë£Œ ëœ í•­ëª©ì— ëŒ€ í•œ',0),(157160,4366,'he','×¢×‘×•×¨ ×¤×¨×™×˜×™× ×•×ž×§×•×‘×œ×™× ×”×•×©×œ×ž×”',0),(157161,4366,'el','Î“Î¹Î± ÎµÎ¯Î´Î· Î±Ï€Î¿Î´ÎµÎºÏ„Î® ÎºÎ±Î¹ Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(157162,4366,'zh','æŽ¥å—å’Œå®Œæˆçš„é¡¹ç›®\r\n',0),(157163,4366,'sv','FÃ¶r artiklar accepterade och avslutade',0),(157164,4366,'it','Per gli articoli accettati e completato',0),(157165,4366,'tl','',0),(157166,4366,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3618;&#3629;&#3617;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3607;&#3635;&#3651;&#3627;&#3657;&#3626;&#3617;&#3610;&#3641;&#3',0),(157167,4366,'hi','à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤¿à¤ à¤œà¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤”à¤° à¤ªà¥‚à¤°à¥à¤£ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤',0),(157168,4366,'ms','Bagi item-item yang diterima dan diselesaikan',0),(157169,4366,'ar','Ù„Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…Ù‚Ø¨ÙˆÙ„Ø© ÙˆØ£ÙƒÙ…Ù„Øª',0),(157170,4366,'fr','Pour les articles acceptÃ©s et terminÃ©',0),(157171,4366,'jp','æ‰¿èª?æ¸ˆã€?å®Œäº†æ¸ˆå“?ç›®ã?®',0),(157172,4366,'pt','Para itens aceitos e concluÃ­da',0),(157173,4366,'ru','Ð”Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² ÑÐ¾Ð³Ð»Ð°ÑÐ¸Ð»ÑÑ Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¾',0),(157174,4366,'es','Para Items Aceptados y Completados',0),(157175,4366,'de','FÃ¼r Elemente akzeptiert und abgeschlossen',0),(157176,4366,'en','For Items Accepted and Completed',0),(157177,4367,'is','',0),(157178,4367,'dr','Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´ØªÙŠ ÙƒÙ‡ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ø¯Ø§Ø±Ù†Ø¯ ',0),(157179,4367,'pr','Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´ØªÙŠ ÙƒÙ‡ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ø¯Ø§Ø±Ù†Ø¯ ',0),(157180,4367,'tr','DÃ¶ndÃ¼rÃ¼len Ã¶ÄŸeler iÃ§in revizyon ihtiyacÄ±',0),(157181,4367,'pl','Elementy zwrÃ³cone wymagajÄ…ce zmiany',0),(157182,4367,'bg','Ð—Ð° Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸ ÑÐµ Ð½Ð°Ð»Ð°Ð³Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(157183,4367,'ur','Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª Ø§Ù† Ø¢Ø¦Ù¹Ù… Ú©Û’ Ù„Ø¦Û’ ÙˆØ§Ù¾Ø³ Ø¢Ø¦Û’',0),(157184,4367,'sr','Ð—Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ð°',0),(157185,4367,'vi','DÃ nh cho hÃ ng cáº§n chá»‰nh sá»­a',0),(157186,4367,'af','Vir Items Teruggestuur wat Repetensiewerk benodig',0),(157187,4367,'ro','Pentru elemente returnate au nevoie de revizuire',0),(157188,4367,'et','Esemed tagastatakse vajavad muutmist',0),(157189,4367,'si','Za elemente vrnjena uboÅ¡tvo, revizija',0),(157190,4367,'ba','Untuk item kembali perlu revisi',0),(157191,4367,'nl','Voor artikelen dat is teruggezonden herziening nodig',0),(157192,4367,'fi','Palautettavien tarvitsevat tarkistamista varten',0),(157193,4367,'no','For varer returneres trenger revisjon',0),(157194,4367,'da','For varer returneres krÃ¦ver Revision',0),(157195,4367,'ko','í•­ëª©ì— ëŒ€ í•œ ë°˜í™˜ ê°œì • í•„ìš”',0),(157196,4367,'he','×¢×‘×•×¨ ×”×¤×¨×™×˜×™× ×”×ž×•×—×–×¨×™× ×¦×•×¨×š ×ž×”×“×•×¨×”',0),(157197,4367,'el','Î“Î¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Ï€Î¿Ï… ÎµÏ€Î¹ÏƒÏ„ÏÎ­Ï†Î¿Î½Ï„Î±Î¹ Ï€Î¿Ï… Ï‡ÏÎµÎ¹Î¬Î¶Î¿Î½Ï„Î±Î¹ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(157198,4367,'zh','å¯¹äºŽè¿”å›žçš„é¡¹ç›®éœ€è¦ä¿®è®¢\r\n',0),(157199,4367,'sv','FÃ¶r objekt som returneras behÃ¶ver Ã¶versyn',0),(157200,4367,'it','Per gli elementi restituiti che necessitano di revisione',0),(157201,4367,'tl','',0),(157202,4367,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3588;&#3639;&#3609;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(157203,4367,'hi','à¤œà¤¼à¤°à¥‚à¤°à¤¤ à¤•à¥‡ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤‡à¤Ÿà¤® à¤²à¥Œà¤Ÿà¤¾à¤',0),(157204,4367,'ms','Bagi barang-barang yang dikembalikan memerlukan penyemakan',0),(157205,4367,'ar','Ø¹Ø§Ø¯ Ù„Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„ØªÙŠ ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ Ù…Ø±Ø§Ø¬Ø¹Ø©',0),(157206,4367,'fr','Pour les articles retournÃ©s qui ont besoin de rÃ©vision',0),(157207,4367,'jp','ä¿®æ­£è¦?è¿”å?´æ¸ˆå“?ç›®ã?®',0),(157208,4367,'pt','Por itens devolvidos precisando de revisÃ£o',0),(157209,4367,'ru','Ð”Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð², Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð½Ñ‹Ñ… Ð´Ð»Ñ Ð½ÑƒÐ¶Ð´Ð°ÑŽÑ‰Ð¸Ñ…ÑÑ Ð¿ÐµÑ€ÐµÑÐ¼Ð¾Ñ‚Ñ€Ð°',0),(157210,4367,'es','Para Items Retornados que Necesitan RevisiÃ³n',0),(157211,4367,'de','FÃ¼r Elemente zurÃ¼ckgegeben, die Revision benÃ¶tigen',0),(157212,4367,'en','For Items Returned Needing Revision',0),(157213,4368,'is','',0),(157214,4368,'dr','Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ùˆ Ù‡Ù†ÙˆØ² Ø¯Ø± Ø­Ø§Ù„Øª Ø§Ù†ØªØ¸Ø§Ø± Ù‡Ø³ØªÙ†Ø¯ ',0),(157215,4368,'pr','Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ùˆ Ù‡Ù†ÙˆØ² Ø¯Ø± Ø­Ø§Ù„Øª Ø§Ù†ØªØ¸Ø§Ø± Ù‡Ø³ØªÙ†Ø¯ ',0),(157216,4368,'tr','Ã–ÄŸeler iÃ§in gÃ¶nderilen ve hala beklemede',0),(157217,4368,'pl','Elementy wysÅ‚ane i jeszcze w toku postÄ™powania',0),(157218,4368,'bg','Ð—Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð¸ Ð²Ð¸ÑÑÑ‰Ð¾',0),(157219,4368,'ur','Ø§Ù† Ø¢Ø¦Ù¹Ù… Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬Ø§ Ø§ÙˆØ± Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§ Ø§Ø¨ Ø¨Ú¾ÛŒ',0),(157220,4368,'sr','Ð—Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¸ Ð´Ð°Ñ™Ðµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(157221,4368,'vi','DÃ nh cho hÃ ng Ä‘Ã£ gá»­i & Ä‘ang treo',0),(157222,4368,'af','Vir Items Gestuur en Steeds in Afwagting',0),(157223,4368,'ro','Pentru Elemente trimise ÅŸi Ã®ncÄƒ Ã®n aÅŸteptare',0),(157224,4368,'et','Ãœksusi saata ja pooleli',0),(157225,4368,'si','Za elemente poslal in Å¡e teÄejo',0),(157226,4368,'ba','Untuk item dikirim dan masih tertunda',0),(157227,4368,'nl','Voor Items verzonden en nog steeds in afwachting van',0),(157228,4368,'fi','Nimikkeiden lÃ¤hetti ja vireillÃ¤',0),(157229,4368,'no','For elementer sendt og fortsatt venter',0),(157230,4368,'da','For varer sendt og stadig afventer',0),(157231,4368,'ko','í•­ëª©ì— ëŒ€ í•œ ì „ì†¡ ë° ë³´ë¥˜ ì•„ì§ë„',0),(157232,4368,'he','×¢×‘×•×¨ ×¤×¨×™×˜×™× ×©× ×©×œ×—×•, ×¢×“×™×™×Ÿ ×ž×ž×ª×™× ×™×',0),(157233,4368,'el','Î“Î¹Î± Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ ÎºÎ±Î¹ ÎµÎºÎºÏÎµÎ¼ÎµÎ¯ Î±ÎºÏŒÎ¼Î·',0),(157234,4368,'zh','å¯¹äºŽå‘é€å’Œä»å¾…åŠžçš„é¡¹ç›®\r\n',0),(157235,4368,'sv','FÃ¶r artiklar skickas och Ã¤nnu inte har avgjorts',0),(157236,4368,'it','Per gli articoli inviati e ancora in sospeso',0),(157237,4368,'tl','',0),(157238,4368,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;&#3649;&#3621;&#3632;&#3618;&#3633;&#3591;&#3588;&#3591;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3',0),(157239,4368,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œà¤¾ à¤¹à¥ˆ à¤”à¤° à¤²à¤‚à¤¬à¤¿à¤¤ à¤…à¤­à¥€ à¤­à¥€',0),(157240,4368,'ms','Bagi barangan yang dihantar dan masih belum selesai',0),(157241,4368,'ar','Ù„Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…Ø±Ø³Ù„Ø©ØŒ ÙˆÙ…Ø§ Ø²Ø§Ù„Øª Ù…Ø¹Ù„Ù‚Ø©',0),(157242,4368,'fr','Pour les articles envoyÃ©s et encore pendante',0),(157243,4368,'jp','ç™ºé€?æ¸ˆã€?ä¿?ç•™ä¸­å“?ç›®ã?®',0),(157244,4368,'pt','Para itens enviados e ainda pendente',0),(157245,4368,'ru','Ð”Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð², Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ… Ð¸ Ð¿Ð¾ÐºÐ° ÐµÑ‰Ðµ Ð½Ðµ',0),(157246,4368,'es','Para Items Enviados y TodavÃ­a Pendientes',0),(157247,4368,'de','FÃ¼r Elemente gesendet und noch anhÃ¤ngig',0),(157248,4368,'en','For Items Sent and Still Pending',0),(157249,4369,'is','',0),(157250,4369,'dr','Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ø¯Ø§Ø±Ø¯ ',0),(157251,4369,'pr','Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ø¯Ø§Ø±Ø¯ ',0),(157252,4369,'tr','Revizyon ihtiyacÄ±',0),(157253,4369,'pl','Potrzebuje zmian',0),(157254,4369,'bg','Ð¡Ðµ Ð½ÑƒÐ¶Ð´Ð°Ðµ Ð¾Ñ‚ Ð¿Ñ€ÐµÑ€Ð°Ð·Ð³Ð»ÐµÐ¶Ð´Ð°Ð½Ðµ',0),(157255,4369,'ur','Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(157256,4369,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ñ˜Ðµ Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ð°',0),(157257,4369,'vi','Cáº§n chá»‰nh sá»­a',0),(157258,4369,'af','Hersiening moet',0),(157259,4369,'ro','Are nevoie de revizuire',0),(157260,4369,'et','Vajab muutmist',0),(157261,4369,'si','Potrebe revizije',0),(157262,4369,'ba','Perlu revisi',0),(157263,4369,'nl','Moet herzien',0),(157264,4369,'fi','On muutettava',0),(157265,4369,'no','Trenger revisjon',0),(157266,4369,'da','Behov for Revision',0),(157267,4369,'ko','ê°œì • í•„ìš”',0),(157268,4369,'he','×¦×¨×™×š ×ª×™×§×•×Ÿ',0),(157269,4369,'el','Î§ÏÎµÎ¹Î¬Î¶ÎµÏ„Î±Î¹ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(157270,4369,'zh','éœ€è¦ä¿®è®¢\r\n',0),(157271,4369,'sv','BehÃ¶ver Ã¶versyn',0),(157272,4369,'it','Ha bisogno di revisione',0),(157273,4369,'tl','',0),(157274,4369,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(157275,4369,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(157276,4369,'ms','Perlu semakan semula',0),(157277,4369,'ar','ÙŠØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ Ù…Ø±Ø§Ø¬Ø¹Ø©',0),(157278,4369,'fr','Besoins de rÃ©vision',0),(157279,4369,'jp','ä¿®æ­£è¦?',0),(157280,4369,'pt','Precisa de revisÃ£o',0),(157281,4369,'ru','ÐÑƒÐ¶Ð´Ð°ÐµÑ‚ÑÑ Ð² Ð¿ÐµÑ€ÐµÑÐ¼Ð¾Ñ‚Ñ€Ðµ',0),(157282,4369,'es','Se necesita RevisiÃ³n',0),(157283,4369,'de','Braucht Revision',0),(157284,4369,'en','Needs Revision',0),(157285,4370,'is','',0),(157286,4370,'dr','Ù„ÙŠØ³Øª ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³Ù†Ø¯',0),(157287,4370,'pr','Ù„ÙŠØ³Øª ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³Ù†Ø¯',0),(157288,4370,'tr','KanÄ±t geÃ§miÅŸ listesi',0),(157289,4370,'pl','DowÃ³d historii listy',0),(157290,4370,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ ÑÐ¿Ð¸ÑÑŠÐº',0),(157291,4370,'ur','Ø«Ø¨ÙˆØª Ø³Ø§Ø¨Ù‚Ø§Øª ÙÛØ±Ø³Øª',0),(157292,4370,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ Ð´Ð¾ÐºÐ°Ð·',0),(157293,4370,'vi','Danh sÃ¡ch Lá»‹ch sá»­ Báº£n in thá»­',0),(157294,4370,'af','Bewys die geskiedenis-lys',0),(157295,4370,'ro','Lista istoricului dovada',0),(157296,4370,'et','TÃµend ajalooloend',0),(157297,4370,'si','Seznam dokaz zgodovine',0),(157298,4370,'ba','Daftar Riwayat bukti',0),(157299,4370,'nl','Bewijs geschiedenislijst',0),(157300,4370,'fi','Todiste historialuettelo',0),(157301,4370,'no','Bevis logglisten',0),(157302,4370,'da','Bevis oversigtslisten',0),(157303,4370,'ko','ì¦ê±° ê¸°ë¡ ëª©ë¡',0),(157304,4370,'he','×¨×©×™×ž×ª ×”×”×™×¡×˜×•×¨×™×” ×”×•×›×—×”',0),(157305,4370,'el','Î›Î¯ÏƒÏ„Î± Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÎ¿Ï Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î·',0),(157306,4370,'zh','è¯æ˜ŽåŽ†å²è®°å½•åˆ—è¡¨\r\n',0),(157307,4370,'sv','Bevis historiklistan',0),(157308,4370,'it','Elenco cronologia prova',0),(157309,4370,'tl','',0),(157310,4370,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(157311,4370,'hi','à¤¸à¤¬à¥‚à¤¤ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤¸à¥‚à¤šà¥€',0),(157312,4370,'ms','Senarai bukti sejarah',0),(157313,4370,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(157314,4370,'fr','Preuve historique',0),(157315,4370,'jp','æ ¡æ­£å±¥æ­´ãƒªã‚¹ãƒˆ',0),(157316,4370,'pt','Lista de prova de histÃ³ria',0),(157317,4370,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸',0),(157318,4370,'es','Lista de la Historia de Pruebas de ImpresiÃ³n',0),(157319,4370,'de','Beweis Verlaufsliste',0),(157320,4370,'en','Proof History List',0),(157321,4371,'is','',0),(157322,4371,'dr','Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³Ù†Ø¯ ',0),(157323,4371,'pr','Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³Ù†Ø¯ ',0),(157324,4371,'tr','DÃ¼zeltme GeÃ§miÅŸi raporu',0),(157325,4371,'pl','DowÃ³d historii raportu',0),(157326,4371,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(157327,4371,'ur','Ø«Ø¨ÙˆØª ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(157328,4371,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð¸ Ð´Ð¾ÐºÐ°Ð·',0),(157329,4371,'vi','BÃ¡o cÃ¡o lá»‹ch sá»­ báº£n in thá»­',0),(157330,4371,'af','Proef Geskiedkundige Verslag',0),(157331,4371,'ro','Dovada istorie raport',0),(157332,4371,'et','TÃµend ajaloo aruanne',0),(157333,4371,'si','Dokaz zgodovina poroÄilo',0),(157334,4371,'ba','Bukti sejarah laporan',0),(157335,4371,'nl','Bewijs History Report',0),(157336,4371,'fi','Todiste historiaraportti',0),(157337,4371,'no','Loggrapport for bevis',0),(157338,4371,'da','Bevis historie rapport',0),(157339,4371,'ko','ì¦ê±° ê¸°ë¡ ë³´ê³ ì„œ',0),(157340,4371,'he','×”×•×›×—×” ×‘×”×™×¡×˜×•×¨×™×”',0),(157341,4371,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(157342,4371,'zh','è¯æ˜ŽåŽ†å²æŠ¥å‘Š\r\n',0),(157343,4371,'sv','Bevis historia',0),(157344,4371,'it','Rapporto di prova della storia',0),(157345,4371,'tl','',0),(157346,4371,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(157347,4371,'hi','à¤¸à¤¬à¥‚à¤¤ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(157348,4371,'ms','Bukti sejarah laporan',0),(157349,4371,'ar','ØªÙ‚Ø±ÙŠØ± Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(157350,4371,'fr','Rapport d\'historique de preuve',0),(157351,4371,'jp','æ ¡æ­£å±¥æ­´ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(157352,4371,'pt','RelatÃ³rio da prova de histÃ³ria',0),(157353,4371,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸',0),(157354,4371,'es','Informe de Historia de Pruebas de ImpresiÃ³n',0),(157355,4371,'de','Beweis Verlaufsbericht',0),(157356,4371,'en','Proof History Report',0),(157357,4372,'is','',0),(157358,4372,'dr','ØªØ§Ø±ÙŠØ® Ø¬ÙˆØ§Ø¨',0),(157359,4372,'pr','ØªØ§Ø±ÙŠØ® Ø¬ÙˆØ§Ø¨',0),(157360,4372,'tr','YanÄ±t tarihi',0),(157361,4372,'pl','Data odpowiedzi',0),(157362,4372,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(157363,4372,'ur','Ø¬ÙˆØ§Ø¨ÛŒ Ø¹Ù…Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(157364,4372,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ð´Ð·Ð¸Ð²Ð°',0),(157365,4372,'vi','NgÃ y tráº£ lá»i',0),(157366,4372,'af','Reaksie datum',0),(157367,4372,'ro','Data rÄƒspunsului',0),(157368,4372,'et','Reageerimise kuupÃ¤ev',0),(157369,4372,'si','Datum odziva',0),(157370,4372,'ba','Respon tanggal',0),(157371,4372,'nl','Datum van reactie',0),(157372,4372,'fi','Response pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(157373,4372,'no','Responsdato',0),(157374,4372,'da','Svardato',0),(157375,4372,'ko','ì‘ë‹µ ë‚ ì§œ',0),(157376,4372,'he','×ª××¨×™×š ×ž×¢× ×”',0),(157377,4372,'el','Î—Î¼/Î½Î¯Î± Î‘Ï€ÏŒÎºÏÎ¹ÏƒÎ·Ï‚',0),(157378,4372,'zh','å“åº”æ—¥æœŸ\r\n',0),(157379,4372,'sv','Svarsdatum',0),(157380,4372,'it','Data di risposta',0),(157381,4372,'tl','',0),(157382,4372,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;',0),(157383,4372,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¸à¤¾à¤¦ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(157384,4372,'ms','Respon tarikh',0),(157385,4372,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø±Ø¯',0),(157386,4372,'fr','Date de la rÃ©ponse',0),(157387,4372,'jp','è¿”ç­”æ—¥',0),(157388,4372,'pt','Data resposta',0),(157389,4372,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð²ÐµÑ‚Ð°',0),(157390,4372,'es','Fecha de Respuesta',0),(157391,4372,'de','Antwort am',0),(157392,4372,'en','Response Date',0),(157393,4373,'is','',0),(157394,4373,'dr','(ØªØ¹ÙˆÛŒÙ‚ ',0),(157395,4373,'pr','ÙØ±Ø³ØªØ§Ø¯Ù‡ ÙŠØ§ Ù…Ù†ØªØ¸Ø±(Ù…Ø¹ÙˆÙ‚ ',0),(157396,4373,'tr','GÃ¶nderilen veya beklemede',0),(157397,4373,'pl','WysÅ‚ane lub oczekujÄ…ce',0),(157398,4373,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð¸Ð»Ð¸ Ð²Ð¸ÑÑÑ‰Ð¸',0),(157399,4373,'ur','Ø¨Ú¾ÛŒØ¬Ø§ ÛŒØ§ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(157400,4373,'sr','ÐŸÐ¾ÑÐ»Ð°Ð¾ Ð¸Ð»Ð¸ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(157401,4373,'vi','Gá»­i hay Ä‘ang treo',0),(157402,4373,'af','Gestuur of Afwagtend',0),(157403,4373,'ro','Trimis sau Ã®n aÅŸteptare',0),(157404,4373,'et','Saadetud vÃµi ootel',0),(157405,4373,'si','Poslana ali ÄakajoÄe',0),(157406,4373,'ba','Dikirim atau ditunda',0),(157407,4373,'nl','Verzonden of in behandeling',0),(157408,4373,'fi','LÃ¤hettÃ¤nyt tai odottaa',0),(157409,4373,'no','Sendt eller venter',0),(157410,4373,'da','Sendt eller ventende',0),(157411,4373,'ko','ì „ì†¡ ë˜ëŠ” ë³´ë¥˜ ì¤‘',0),(157412,4373,'he','×©×œ×— ××• ×ž×ž×ª×™×Ÿ',0),(157413,4373,'el','Î‘Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ Î® ÎµÎºÎºÏÎµÎ¼ÎµÎ¯',0),(157414,4373,'zh','å‘é€æˆ–å¾…å®š\r\n',0),(157415,4373,'sv','Skickas eller vÃ¤ntande',0),(157416,4373,'it','Inviato o in sospeso',0),(157417,4373,'tl','',0),(157418,4373,'th','&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;&#3627;&#3619;&#3639;&#3629;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(157419,4373,'hi','à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¯à¤¾ à¤²à¤‚à¤¬à¤¿à¤¤',0),(157420,4373,'ms','Dihantar atau belum selesai',0),(157421,4373,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø£Ùˆ Ù…Ø¹Ù„Ù‚Ø©',0),(157422,4373,'fr','EnvoyÃ© ou en attente',0),(157423,4373,'jp','é€?ä¿¡æ¸ˆ/ä¿?ç•™ä¸­',0),(157424,4373,'pt','Enviado ou pendente',0),(157425,4373,'ru','ÐŸÐ¾ÑÐ»Ð°Ð» Ð¸Ð»Ð¸ Ð¾Ð¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ',0),(157426,4373,'es','Enviado o Pendiente',0),(157427,4373,'de','Gesendet oder ausstehende',0),(157428,4373,'en','Sent or Pending',0),(157429,4374,'is','',0),(157430,4374,'dr','/ Ù…Ù†ØªØ¸Ø±(ØªØ¹ÙˆÛŒÙ‚ ',0),(157431,4374,'pr','ÙØ±Ø³ØªØ§Ø¯Ù‡  / Ù…Ù†ØªØ¸Ø±(Ù…Ø¹ÙˆÙ‚ ',0),(157432,4374,'tr','GÃ¶nderilen/beklemede',0),(157433,4374,'pl','WysÅ‚ane/czasu',0),(157434,4374,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸/Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ',0),(157435,4374,'ur','Ù…Ø±Ø³Ù„Û/Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(157436,4374,'sr','ÐŸÐ¾ÑÐ»Ð°Ð¾ /Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(157437,4374,'vi','Gá»­i/Ä‘ang treo',0),(157438,4374,'af','Gestuur/Afwagtend',0),(157439,4374,'ro','Trimis/pÃ¢nÄƒ',0),(157440,4374,'et','Saadetud/ootel',0),(157441,4374,'si','Poslal/dokler',0),(157442,4374,'ba','Dikirim/tertunda',0),(157443,4374,'nl','Verzonden/in afwachting van',0),(157444,4374,'fi','LÃ¤hettÃ¤nyt/kesken',0),(157445,4374,'no','Sendt/ventende',0),(157446,4374,'da','Sendt/behandling',0),(157447,4374,'ko','ì „ì†¡/ë³´ë¥˜',0),(157448,4374,'he','×©×œ×— ×ž×ž×ª×™× ×™× /',0),(157449,4374,'el','Î‘Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹/ÎµÎºÎºÏÎµÎ¼ÎµÎ¯',0),(157450,4374,'zh','å‘é€/å¾…å®š\r\n',0),(157451,4374,'sv','Skickade/pÃ¥gÃ¥ende',0),(157452,4374,'it','Inviati/in attesa',0),(157453,4374,'tl','',0),(157454,4374,'th','&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;/&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(157455,4374,'hi','à¤­à¥‡à¤œà¤¾/à¤²à¤‚à¤¬à¤¿à¤¤',0),(157456,4374,'ms','Dihantar/menunggu',0),(157457,4374,'ar','Ø£Ø±Ø³Ù„/Ù…Ø¹Ù„Ù‚Ø©',0),(157458,4374,'fr','EnvoyÃ© ou en attente',0),(157459,4374,'jp','é€?ä¿¡æ¸ˆ/ä¿?ç•™ä¸­',0),(157460,4374,'pt','Enviado/pendentes',0),(157461,4374,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾/Ð´Ð¾',0),(157462,4374,'es','Enviado/Pendiente',0),(157463,4374,'de','Gesendet/ausstehende',0),(157464,4374,'en','Sent/Pending',0),(157465,4375,'is','',0),(157466,4375,'dr','ÙØ¹Ø§Ù„ÙŠØª ',0),(157467,4375,'pr','ÙØ¹Ø§Ù„ÙŠØª ',0),(157468,4375,'tr','YasasÄ±',0),(157469,4375,'pl','Ustawy',0),(157470,4375,'bg','ÐÐºÑ‚',0),(157471,4375,'ur','Ø§ÛŒÚ©Ù¹',0),(157472,4375,'sr','Ð§Ð¸Ð½',0),(157473,4375,'vi','TK',0),(157474,4375,'af','handel',0),(157475,4375,'ro','Act',0),(157476,4375,'et','Seaduse',0),(157477,4375,'si','Zakon',0),(157478,4375,'ba','Act',0),(157479,4375,'nl','Wet',0),(157480,4375,'fi','Lain',0),(157481,4375,'no','Loven',0),(157482,4375,'da','Act',0),(157483,4375,'ko','ë²•',0),(157484,4375,'he','×ž×¢×©×”',0),(157485,4375,'el','Î ÏÎ¬Î¾Î·',0),(157486,4375,'zh','æ³•æ¡ˆ\r\n',0),(157487,4375,'sv','Act',0),(157488,4375,'it','Atto',0),(157489,4375,'tl','',0),(157490,4375,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(157491,4375,'hi','à¤…à¤§à¤¿à¤¨à¤¿à¤¯à¤®',0),(157492,4375,'ms','Akta',0),(157493,4375,'ar','Ù‚Ø§Ù†ÙˆÙ†',0),(157494,4375,'fr','Act',0),(157495,4375,'jp','è¡Œå‹•',0),(157496,4375,'pt','Ato',0),(157497,4375,'ru','ÐÐºÑ‚',0),(157498,4375,'es','Acta',0),(157499,4375,'de','Akt',0),(157500,4375,'en','Act',0),(157501,4376,'is','',0),(157502,4376,'dr','ØªØ§Ø±ÙŠØ® Ù‡Ø§',0),(157503,4376,'pr','ØªØ§Ø±ÙŠØ® Ù‡Ø§',0),(157504,4376,'tr','Tarihleri',0),(157505,4376,'pl','Daty',0),(157506,4376,'bg','Ð”Ð°Ñ‚Ð¸',0),(157507,4376,'ur','ØªÙˆØ§Ø±ÛŒØ®',0),(157508,4376,'sr','Ð”Ð°Ñ‚ÑƒÐ¼Ð¸',0),(157509,4376,'vi','NgÃ y',0),(157510,4376,'af','Datums',0),(157511,4376,'ro','Datele',0),(157512,4376,'et','KuupÃ¤evad',0),(157513,4376,'si','Datumi',0),(157514,4376,'ba','Tanggal',0),(157515,4376,'nl','Datums',0),(157516,4376,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(157517,4376,'no','Datoer',0),(157518,4376,'da','Datoer',0),(157519,4376,'ko','ë‚ ì§œ',0),(157520,4376,'he','×ª××¨×™×›×™×',0),(157521,4376,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(157522,4376,'zh','æ—¥æœŸ\r\n',0),(157523,4376,'sv','Datum',0),(157524,4376,'it','Date',0),(157525,4376,'tl','',0),(157526,4376,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(157527,4376,'hi','à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤',0),(157528,4376,'ms','Tarikh',0),(157529,4376,'ar','Ø§Ù„ØªÙˆØ§Ø±ÙŠØ®',0),(157530,4376,'fr','Dates',0),(157531,4376,'jp','æ—¥ã?«ã?¡',0),(157532,4376,'pt','Datas',0),(157533,4376,'ru','Ð”Ð°Ñ‚Ñ‹',0),(157534,4376,'es','Fechas',0),(157535,4376,'de','Termine',0),(157536,4376,'en','Dates',0),(157537,4377,'is','',0),(157538,4377,'dr','Est  ØªØ®Ù…ÙŠÙ†',0),(157539,4377,'pr','Est  ØªØ®Ù…ÙŠÙ†',0),(157540,4377,'tr','EST',0),(157541,4377,'pl','Est',0),(157542,4377,'bg','EST',0),(157543,4377,'ur','Est',0),(157544,4377,'sr','Ð•ÑÑ‚',0),(157545,4377,'vi','Dá»± trÃ¹',0),(157546,4377,'af','Est',0),(157547,4377,'ro','Est',0),(157548,4377,'et','EST',0),(157549,4377,'si','EST',0),(157550,4377,'ba','Est',0),(157551,4377,'nl','Est',0),(157552,4377,'fi','Est',0),(157553,4377,'no','EST',0),(157554,4377,'da','EST',0),(157555,4377,'ko','ë™ë¶€ í‘œì¤€ì‹œ',0),(157556,4377,'he','Est',0),(157557,4377,'el','EST',0),(157558,4377,'zh','é¢„è®¡\r\n',0),(157559,4377,'sv','Est',0),(157560,4377,'it','Est',0),(157561,4377,'tl','',0),(157562,4377,'th','&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619; &#3585;&#3634;&#3619;&#3605;&#3637;&#3619;&#3634;&#3588;&#3634;',0),(157563,4377,'hi','à¤‡ à¤à¤¸ à¤Ÿà¥€',0),(157564,4377,'ms','Est',0),(157565,4377,'ar','Est',0),(157566,4377,'fr','HNE',0),(157567,4377,'jp','è¦‹ç©?ã‚Š',0),(157568,4377,'pt','Est',0),(157569,4377,'ru','EST',0),(157570,4377,'es','Est',0),(157571,4377,'de','EST',0),(157572,4377,'en','Est',0),(157573,4378,'is','',0),(157574,4378,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(157575,4378,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(157576,4378,'tr','BÄ°TMÄ°Åž bir tarih aralÄ±ÄŸÄ± seÃ§in',0),(157577,4378,'pl','Wybierz gotowy zakres dat.',0),(157578,4378,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(157579,4378,'ur','ØªÚ©Ù…ÛŒÙ„ Ø´Ø¯Û ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(157580,4378,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð“ÐžÐ¢ÐžÐ’Ð˜Ð¥ Ð¾Ð¿ÑÐµÐ³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(157581,4378,'vi','Lá»±a chá»n pháº¡m vi ngÃ y káº¿t thÃºc',0),(157582,4378,'af','Selekteer \'n VOLTOOIDE Datumreeks',0),(157583,4378,'ro','SelectaÅ£i un interval FINIT de Date',0),(157584,4378,'et','Valige valmis kuupÃ¤evavahemik',0),(157585,4378,'si','Izberite konÄni datumski obseg',0),(157586,4378,'ba','Pilih rentang tanggal selesai',0),(157587,4378,'nl','Selecteer een klaar datumbereik',0),(157588,4378,'fi','Valitse valmis pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤alue',0),(157589,4378,'no','Velg et ferdig datointervall',0),(157590,4378,'da','VÃ¦lg en fÃ¦rdig datointerval',0),(157591,4378,'ko','ì™„ë£Œ ë‚ ì§œ ë²”ìœ„ ì„ íƒ',0),(157592,4378,'he','×‘×—×¨ ×˜×•×•×— ×ª××¨×™×›×™× ×¡×™×™×',0),(157593,4378,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½Î¿ ÎµÏÏÎ¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½',0),(157594,4378,'zh','é€‰æ‹©ä¸€ä¸ªå®Œæˆçš„æ—¥æœŸèŒƒå›´\r\n',0),(157595,4378,'sv','VÃ¤lj en fÃ¤rdig datumintervall',0),(157596,4378,'it','Selezionare un intervallo di Date finito',0),(157597,4378,'tl','',0),(157598,4378,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3594;&#3656;&#3623;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3648;&#3626;&#3619;&#3655;&#3592;',0),(157599,4378,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(157600,4378,'ms','Memilih julat tarikh siap',0),(157601,4378,'ar','Ø­Ø¯Ø¯ Ù†Ø·Ø§Ù‚ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(157602,4378,'fr','SÃ©lectionnez une plage de dates fini',0),(157603,4378,'jp','çµ‚äº†æ¸ˆæ—¥ã?®ç¯„å›²ã‚’é?¸æŠž',0),(157604,4378,'pt','Selecione um intervalo de concluÃ­do',0),(157605,4378,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ',0),(157606,4378,'es','Seleccionar un Rango de Fechas de Terminar',0),(157607,4378,'de','Einen fertigen Datumsbereich auswÃ¤hlen',0),(157608,4378,'en','Select a FINISHED Date Range',0),(157609,4379,'is','',0),(157610,4379,'dr','Ù…ØºØ§ÙŠØ±Øª Ù‡Ø§',0),(157611,4379,'pr','Ù…ØºØ§ÙŠØ±Øª Ù‡Ø§',0),(157612,4379,'tr','Varyanslar',0),(157613,4379,'pl','Wariancji',0),(157614,4379,'bg','Ð”Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ð¸',0),(157615,4379,'ur','Ù…ØªØºÛŒØ±Ø§Øª',0),(157616,4379,'sr','ÐžÐ´ÑÑ‚ÑƒÐ¿Ð°ÑšÐ°',0),(157617,4379,'vi','ChÃªnh lá»‡ch',0),(157618,4379,'af','Afwykings',0),(157619,4379,'ro','VarianÅ£e',0),(157620,4379,'et','Dispersioon',0),(157621,4379,'si','Varianc',0),(157622,4379,'ba','Varians',0),(157623,4379,'nl','Varianties',0),(157624,4379,'fi','Varianssit',0),(157625,4379,'no','Avvik',0),(157626,4379,'da','Afvigelser',0),(157627,4379,'ko','ë¶„ì‚°',0),(157628,4379,'he','×¡×˜×™×•×ª',0),(157629,4379,'el','Î”Î¹Î±ÎºÏ…Î¼Î¬Î½ÏƒÎµÎ¹Ï‚',0),(157630,4379,'zh','å·®å¼‚\r\n',0),(157631,4379,'sv','Avvikelser',0),(157632,4379,'it','Varianze',0),(157633,4379,'tl','',0),(157634,4379,'th','&#3585;&#3634;&#3619;&#3612;&#3633;&#3609;&#3649;&#3611;&#3619;',0),(157635,4379,'hi','à¤ªà¥à¤°à¤¸à¤°à¤£',0),(157636,4379,'ms','Perbezaan',0),(157637,4379,'ar','Ø§Ù„ÙØ±ÙˆÙ‚',0),(157638,4379,'fr','Variances',0),(157639,4379,'jp','å·®é¡?',0),(157640,4379,'pt','VariÃ¢ncias',0),(157641,4379,'ru','ÐžÑ‚ÐºÐ»Ð¾Ð½ÐµÐ½Ð¸Ñ',0),(157642,4379,'es','Variaciones',0),(157643,4379,'de','Varianzen',0),(157644,4379,'en','Variances',0),(157645,4380,'is','',0),(157646,4380,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(157647,4380,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(157648,4380,'tr','Stok yeniden sipariÅŸ listesi',0),(157649,4380,'pl','Lista ponownego',0),(157650,4380,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(157651,4380,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø±ÛŒÚ©Ø§Ø±ÚˆØ± Ú©ÛŒ ÙÛØ±Ø³Øª',0),(157652,4380,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(157653,4380,'vi','Danh SÃ¡ch Äáº·t HÃ ng Láº¡i',0),(157654,4380,'af','Inventaris Herbestel Lys',0),(157655,4380,'ro','Stoc reordona lista',0),(157656,4380,'et','Varude kordustellimise loend',0),(157657,4380,'si','Seznam zaloge naroÄanja',0),(157658,4380,'ba','Daftar inventaris menyusun ulang',0),(157659,4380,'nl','Bestelfrequentie inventarislijst',0),(157660,4380,'fi','Reorder luettelossa',0),(157661,4380,'no','Ordne inventarliste',0),(157662,4380,'da','Omarrangere lagerliste',0),(157663,4380,'ko','ìž¬ê³  ìˆœì„œ ëª©ë¡',0),(157664,4380,'he','×¨×©×™×ž×ª ×—×™×“×•×© ×ž×œ××™',0),(157665,4380,'el','Î‘Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î»Î¯ÏƒÏ„Î± Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(157666,4380,'zh','åº“å­˜é‡æ–°æŽ’åºåå•\r\n',0),(157667,4380,'sv','Ordna Inventarielista',0),(157668,4380,'it','Lista di riordino di inventario',0),(157669,4380,'tl','',0),(157670,4380,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(157671,4380,'hi','à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(157672,4380,'ms','Inventori susun semula senarai',0),(157673,4380,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¬Ø±Ø¯ Ø¨Ø¥Ø¹Ø§Ø¯Ø© ØªØ±ØªÙŠØ¨',0),(157674,4380,'fr','Liste de rÃ©approvisionnement des stocks',0),(157675,4380,'jp','åœ¨åº«å†?æ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(157676,4380,'pt','Lista de reposiÃ§Ã£o de inventÃ¡rio',0),(157677,4380,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿ÐµÑ€ÐµÑƒÐ¿Ð¾Ñ€ÑÐ´Ð¾Ñ‡Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(157678,4380,'es','Lista de Reorden de Inventario',0),(157679,4380,'de','Reorder Inventarliste',0),(157680,4380,'en','Inventory Reorder List',0),(157681,4381,'is','',0),(157682,4381,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯ ÙƒØ§Ù„Ø§',0),(157683,4381,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯ ÙƒØ§Ù„Ø§',0),(157684,4381,'tr','Maddenin yeniden sipariÅŸ listesi',0),(157685,4381,'pl','KolejnoÅ›Ä‡ pozycji listy',0),(157686,4381,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð·Ð° Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(157687,4381,'ur','Ø´Û’ ÙÛØ±Ø³Øª Ø±ÛŒÚ©Ø§Ø±ÚˆØ±',0),(157688,4381,'sr','Ð›Ð¸ÑÑ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(157689,4381,'vi','Danh sÃ¡ch hÃ ng Ä‘áº·t láº¡i',0),(157690,4381,'af','Item Herbestellys',0),(157691,4381,'ro','Reordona lista',0),(157692,4381,'et','Kauba kordustellimuse loend',0),(157693,4381,'si','Seznam artiklov naroÄanja',0),(157694,4381,'ba','Daftar menyusun ulang item',0),(157695,4381,'nl','Bestelfrequentie itemlijst',0),(157696,4381,'fi','JÃ¤rjestÃ¤ Nimikeluettelo',0),(157697,4381,'no','Ordne elementlisten',0),(157698,4381,'da','Omarrangere elementlisten',0),(157699,4381,'ko','í•­ëª© ìˆœì„œ ë³€ê²½ ëª©ë¡',0),(157700,4381,'he','×¨×©×™×ž×ª ×¡×“×¨ ×ž×—×“×© ×¤×¨×™×˜×™×',0),(157701,4381,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎµÎ¹Î´ÏŽÎ½',0),(157702,4381,'zh','é¡¹ç›®é‡æ–°æŽ’åºåå•\r\n',0),(157703,4381,'sv','Ordna Artikellista',0),(157704,4381,'it','Elenco di riordino di elementi',0),(157705,4381,'tl','',0),(157706,4381,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;',0),(157707,4381,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¸à¥‚à¤šà¥€',0),(157708,4381,'ms','Item susun semula senarai',0),(157709,4381,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¥Ø¹Ø§Ø¯Ø© Ø·Ù„Ø¨ Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(157710,4381,'fr','Liste d\'Ã©lÃ©ments de commande',0),(157711,4381,'jp','å†?æ³¨æ–‡ã‚‹ãƒªã‚¹ãƒˆ',0),(157712,4381,'pt','Lista de itens de reposiÃ§Ã£o',0),(157713,4381,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð½Ñ‹Ñ… Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(157714,4381,'es','Item Lista de Reordenar',0),(157715,4381,'de','ArtikelÃ¼bersicht reorganisieren',0),(157716,4381,'en','Item Reorder List',0),(157717,4382,'is','',0),(157718,4382,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø²ÙŠØ± Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(157719,4382,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø²ÙŠØ± Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(157720,4382,'tr','AÅŸaÄŸÄ±da yeniden sipariÅŸ Mkt.',0),(157721,4382,'pl','IloÅ›Ä‡ poniÅ¼ej ponownego',0),(157722,4382,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð´ Ñ‚Ð¾Ñ‡ÐºÐ°Ñ‚Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(157723,4382,'ur','Ø±ÛŒÚ©Ø§Ø±ÚˆØ± Ù†ÛŒÚ†Û’ Ù‚ÛŒ',0),(157724,4382,'sr','ÐšÐ¾Ð» Ð¸ÑÐ¿Ð¾Ð´ Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(157725,4382,'vi','Sá»‘ lÆ°á»£ng Ä‘áº·t hÃ ng láº¡i ',0),(157726,4382,'af','Hoev. Onder Herbestelvlak',0),(157727,4382,'ro','Cantit reluare comandÄƒ de mai jos',0),(157728,4382,'et','Allpool kordustellimuse kogus',0),(157729,4382,'si','Kakovost pod signalno',0),(157730,4382,'ba','Qty di bawah menyusun ulang',0),(157731,4382,'nl','Aantal hieronder opnieuw ordenen',0),(157732,4382,'fi','MÃ¤Ã¤rÃ¤, alle JÃ¤rjestÃ¤',0),(157733,4382,'no','Antall under ordne',0),(157734,4382,'da','Antal under Ordn igen',0),(157735,4382,'ko','ì•„ëž˜ ìˆœì„œ Qty',0),(157736,4382,'he','×›×ž×•×ª ×œ×”×œ×Ÿ ×¡×“×¨ ×ž×—×“×©',0),(157737,4382,'el','Qty Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(157738,4382,'zh','ä¸‹é¢å†è®¢è´­æ•°é‡\r\n',0),(157739,4382,'sv','Antal under ordna',0),(157740,4382,'it','Q. tÃ  sotto riordino',0),(157741,4382,'tl','',0),(157742,4382,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;&#3586;&#3657;&#3634;&#3591;&#3621;&#3656;&#3634;&#3591;',0),(157743,4382,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¨à¥€à¤šà¥‡',0),(157744,4382,'ms','Qty di bawah susun semula',0),(157745,4382,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø£Ø¯Ù†Ø§Ù‡ Ø¥Ø¹Ø§Ø¯Ø© ØªØ±ØªÙŠØ¨',0),(157746,4382,'fr','QuantitÃ© infÃ©rieure Ã  rÃ©organiser',0),(157747,4382,'jp','ä¸‹è¨˜å†?æ³¨æ–‡æ•°é‡?',0),(157748,4382,'pt','Qty abaixo reordenar',0),(157749,4382,'ru','ÐšÐ¾Ð»-Ð²Ð¾ ÐÐ¸Ð¶Ðµ ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾Ð³Ð¾ Ð—Ð°ÐºÐ°Ð·Ð°',0),(157750,4382,'es','Cant. Abajo de Reordenar',0),(157751,4382,'de','Qty unter Reorder',0),(157752,4382,'en','Qty Below Reorder',0),(157753,4383,'is','',0),(157754,4383,'dr','Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(157755,4383,'pr','Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(157756,4383,'tr','Ä°ÅŸlenen miktar',0),(157757,4383,'pl','IloÅ›Ä‡ popeÅ‚nionych',0),(157758,4383,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¸Ð·Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸',0),(157759,4383,'ur','Ù‚ÛŒ Ú©Ø§ Ø§Ø±ØªÚ©Ø§Ø¨ Ú©ÛŒØ§',0),(157760,4383,'sr','ÐšÐ¾Ð» Ð¿Ð¾Ñ‡Ð¸Ð½Ð¸Ð¾',0),(157761,4383,'vi','Sá»‘ lÆ°á»£ng cam káº¿t',0),(157762,4383,'af','Qty gepleeg',0),(157763,4383,'ro','Cantit comise',0),(157764,4383,'et','Toime pandud kogus',0),(157765,4383,'si','KoliÄina, storjeno',0),(157766,4383,'ba','Qty berkomitmen',0),(157767,4383,'nl','Aantal begaan',0),(157768,4383,'fi','Sidottu mÃ¤Ã¤rÃ¤',0),(157769,4383,'no','Antall forpliktet',0),(157770,4383,'da','Antal begÃ¥et',0),(157771,4383,'ko','íˆ¬ìž… ìˆ˜ëŸ‰',0),(157772,4383,'he','×›×ž×•×ª ×‘×™×¦×¢',0),(157773,4383,'el','Qty Î´Î¹Î±Ï€ÏÎ¬Î¾ÎµÎ¹',0),(157774,4383,'zh','æ•°é‡æ‰¿è¯º\r\n',0),(157775,4383,'sv','Antal begÃ¥tt',0),(157776,4383,'it','Qty commesso',0),(157777,4383,'tl','',0),(157778,4383,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;&#3651;&#3627;&#3657;',0),(157779,4383,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§',0),(157780,4383,'ms','Qty yang komited',0),(157781,4383,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ Ø§Ø±ØªÙƒØ¨Øª',0),(157782,4383,'fr','Qty commis',0),(157783,4383,'jp','ç™ºæ³¨æ•°é‡?',0),(157784,4383,'pt','Qty comprometida',0),(157785,4383,'ru','ÐšÐ¾Ð»-Ð²Ð¾ ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ñ…',0),(157786,4383,'es','Cant. Comprometida',0),(157787,4383,'de','Qty begangen',0),(157788,4383,'en','Qty Committed',0),(157789,4384,'is','',0),(157790,4384,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ø§Ù†Ø¨Ø§Ø± ',0),(157791,4384,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ø§Ù†Ø¨Ø§Ø± ',0),(157792,4384,'tr','Stok miktarÄ±',0),(157793,4384,'pl','IloÅ›Ä‡ w magazynie',0),(157794,4384,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(157795,4384,'ur','Ø§Ø³Ù¹Ø§Ú© Ù…ÛŒÚº Ù‚ÛŒ',0),(157796,4384,'sr','ÐšÐ¾Ð» Ð½Ð° Ð»Ð°Ð³ÐµÑ€Ñƒ',0),(157797,4384,'vi','Sá»‘ lÆ°á»£ng trong tá»“n',0),(157798,4384,'af','Hoev In Voorraad',0),(157799,4384,'ro','Cantit Ã®n stoc',0),(157800,4384,'et','Kogus laos',0),(157801,4384,'si','KoliÄina na zalogi',0),(157802,4384,'ba','Qty dalam saham',0),(157803,4384,'nl','Aantal In voorraad',0),(157804,4384,'fi','Kpl varastossa',0),(157805,4384,'no','Ant pÃ¥ lager',0),(157806,4384,'da','Antal pÃ¥ lager',0),(157807,4384,'ko','ìž¬ê³  ìˆ˜ëŸ‰',0),(157808,4384,'he','×›×ž×•×ª ×‘×ž×œ××™',0),(157809,4384,'el','Qty ÏƒÎµ Î±Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(157810,4384,'zh','åº“å­˜æ•°é‡\r\n',0),(157811,4384,'sv','Antal i lager',0),(157812,4384,'it','Q. tÃ  In magazzino',0),(157813,4384,'tl','',0),(157814,4384,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3651;&#3609;&#3626;&#3605;&#3658;&#3629;&#3585;',0),(157815,4384,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤®à¥‡à¤‚ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(157816,4384,'ms','Qty dalam stok',0),(157817,4384,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© ÙÙŠ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(157818,4384,'fr','QtÃ© en Stock',0),(157819,4384,'jp','åœ¨åº«æ•°é‡?',0),(157820,4384,'pt','Qtde em estoque',0),(157821,4384,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ðµ',0),(157822,4384,'es','Cant. en stock',0),(157823,4384,'de','Menge auf Lager',0),(157824,4384,'en','Qty In Stock',0),(157825,4385,'is','',0),(157826,4385,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ ',0),(157827,4385,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ ',0),(157828,4385,'tr','SipariÅŸteki Miktar',0),(157829,4385,'pl','IloÅ›Ä‡ na zamÃ³wieniu',0),(157830,4385,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(157831,4385,'ur','Ù‚ÛŒ Ú©Û’ Ø­Ú©Ù… Ù¾Ø±',0),(157832,4385,'sr','ÐŸÐ¾Ñ€ÑƒÑ‡ÐµÐ½Ð°',0),(157833,4385,'vi','Sá»‘ lÆ°á»£ng trÃªn Ä‘Æ¡n hÃ ng',0),(157834,4385,'af','Hoev. Op Bestelling',0),(157835,4385,'ro','Cantit pe comandÄƒ',0),(157836,4385,'et','Kogus tellimusel',0),(157837,4385,'si','KoliÄina naroÄila',0),(157838,4385,'ba','Qty pesanan',0),(157839,4385,'nl','Aantal op bestelling',0),(157840,4385,'fi','TilausmÃ¤Ã¤rÃ¤',0),(157841,4385,'no','Antall i ordre',0),(157842,4385,'da','Antal i ordre',0),(157843,4385,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(157844,4385,'he','×›×ž×•×ª ×‘×”×–×ž× ×”',0),(157845,4385,'el','Î Î¿Ïƒ / Ï„Î± ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(157846,4385,'zh','è®¢è´­æ•°é‡\r\n',0),(157847,4385,'sv','Antal pÃ¥ bestÃ¤llning',0),(157848,4385,'it','Qty su ordine',0),(157849,4385,'tl','',0),(157850,4385,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3651;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(157851,4385,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°',0),(157852,4385,'ms','Qty dengan arahan',0),(157853,4385,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø¹Ù„Ù‰ Ø§Ù„ØªØ±ØªÙŠØ¨',0),(157854,4385,'fr','QtÃ© sur commande',0),(157855,4385,'jp','æ³¨æ–‡ä¸­æ•°é‡?',0),(157856,4385,'pt','Qty na ordem',0),(157857,4385,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð’ Ð—Ð°ÐºÐ°Ð·Ðµ',0),(157858,4385,'es','Cantidad en Pedido',0),(157859,4385,'de','Qty auf Bestellung',0),(157860,4385,'en','Qty On Order',0),(157861,4386,'is','',0),(157862,4386,'dr','Ø³Ø·Ø­ Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(157863,4386,'pr','Ø³Ø·Ø­ Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(157864,4386,'tr','Yeniden sÄ±ralama dÃ¼zeyi',0),(157865,4386,'pl','Zmiana kolejnoÅ›ci poziom',0),(157866,4386,'bg','ÐÐ¸Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(157867,4386,'ur','Ø³Ø·Ø­ Ø±ÛŒÚ©Ø§Ø±ÚˆØ±',0),(157868,4386,'sr','ÐŸÐ¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ° Ð½Ð¸Ð²Ð¾',0),(157869,4386,'vi','Má»©c Ä‘áº·t hÃ ng láº¡i',0),(157870,4386,'af','Herbestelvlak',0),(157871,4386,'ro','Reordona nivel',0),(157872,4386,'et','Uuendamise tase',0),(157873,4386,'si','Raven prerazporeditve',0),(157874,4386,'ba','Menyusun ulang tingkat',0),(157875,4386,'nl','Volgorde niveau',0),(157876,4386,'fi','Reorder tasolla',0),(157877,4386,'no','Ordne nivÃ¥',0),(157878,4386,'da','Genbestille niveau',0),(157879,4386,'ko','ìˆ˜ì¤€ ìˆœì„œ',0),(157880,4386,'he','×¡×™×“×•×¨ ×ž×—×“×© ×©×œ ×¨×ž×ª',0),(157881,4386,'el','Î‘Î½Î±Î´Î¹Î¬Ï„Î±Î¾Î· ÎµÏ€Î¯Ï€ÎµÎ´Î¿',0),(157882,4386,'zh','é‡æ–°æŽ’åºçº§åˆ«\r\n',0),(157883,4386,'sv','Ã„ndra ordning pÃ¥ nivÃ¥',0),(157884,4386,'it','Livello di riordino',0),(157885,4386,'tl','',0),(157886,4386,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(157887,4386,'hi','à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤¸à¥à¤¤à¤°',0),(157888,4386,'ms','Susun semula peringkat',0),(157889,4386,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªØ±ØªÙŠØ¨ Ù…Ø³ØªÙˆÙ‰',0),(157890,4386,'fr','RÃ©organiser le niveau',0),(157891,4386,'jp','ãƒ¬ã‚³ãƒ¼ãƒ€ãƒ¼ãƒ¬ãƒ™ãƒ«',0),(157892,4386,'pt','Reordenar a nÃ­vel',0),(157893,4386,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾Ð³Ð¾ Ð—Ð°ÐºÐ°Ð·Ð°',0),(157894,4386,'es','Nivel de Reordenar',0),(157895,4386,'de','Meldebestand',0),(157896,4386,'en','Reorder Level',0),(157897,4387,'is','',0),(157898,4387,'dr','ÙƒÙ„ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(157899,4387,'pr','ÙƒÙ„ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(157900,4387,'tr','Toplam Ã¶ÄŸe sayÄ±sÄ±',0),(157901,4387,'pl','CaÅ‚kowitej pozycji',0),(157902,4387,'bg','ÐžÐ±Ñ‰Ð¾ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(157903,4387,'ur','Ú©Ù„ Ø§Ø´ÛŒØ§Ø¡',0),(157904,4387,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(157905,4387,'vi','Tá»•ng cá»™ng hÃ ng',0),(157906,4387,'af','Totale Items',0),(157907,4387,'ro','Total elemente',0),(157908,4387,'et','Ãœksusi kokku',0),(157909,4387,'si','Skupno Å¡tevilo elementov',0),(157910,4387,'ba','Total item',0),(157911,4387,'nl','Eindtotaalitems',0),(157912,4387,'fi','Kohteiden mÃ¤Ã¤rÃ¤',0),(157913,4387,'no','Totalt antall artikler',0),(157914,4387,'da','Samlede emner',0),(157915,4387,'ko','ì´ í•­ëª©',0),(157916,4387,'he','×¡×” ×› ×¤×¨×™×˜×™×',0),(157917,4387,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î±Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î±',0),(157918,4387,'zh','æ€»é¡¹ç›®\r\n',0),(157919,4387,'sv','Totala poster',0),(157920,4387,'it','Articoli totali',0),(157921,4387,'tl','',0),(157922,4387,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(157923,4387,'hi','à¤•à¥à¤² à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(157924,4387,'ms','Jumlah item',0),(157925,4387,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(157926,4387,'fr','Total des Ã©lÃ©ments',0),(157927,4387,'jp','å“?ç›®å?ˆè¨ˆ',0),(157928,4387,'pt','Total de itens',0),(157929,4387,'ru','Ð’ÑÐµÐ³Ð¾ Ð½Ð°Ð¸Ð¼ÐµÐ½Ð¾Ð²Ð°Ð½Ð¸Ð¹',0),(157930,4387,'es','Items Totales',0),(157931,4387,'de','Total Items',0),(157932,4387,'en','Total Items',0),(157933,4388,'is','',0),(157934,4388,'dr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø±ÙˆØ²Ø§Ù†Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(157935,4388,'pr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø±ÙˆØ²Ø§Ù†Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(157936,4388,'tr','SipariÅŸ gÃ¼nlÃ¼k hacim raporu yazdÄ±r',0),(157937,4388,'pl','Drukuj raport dzienny wielkoÅ›Ä‡ zamÃ³wienia',0),(157938,4388,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð½ÐµÐ²ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(157939,4388,'ur','ØªØ±ØªÛŒØ¨ Ø±ÙˆØ²Ø§Ù†Û ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(157940,4388,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð´Ð½ÐµÐ²Ð½Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(157941,4388,'vi','BÃ¡o cÃ¡o sá»‘ lÆ°á»£ng Ä‘Æ¡n Ä‘áº·t hÃ ng in hÃ ng ngÃ y',0),(157942,4388,'af','Uitdruk van Daaglikse Bestellingsvolume Verslag ',0),(157943,4388,'ro','Comanda raport zilnic volum de imprimare',0),(157944,4388,'et','Tellimuse igapÃ¤evane mahu aruande printimist',0),(157945,4388,'si','Tiskanje nalog dnevni obseg poroÄila',0),(157946,4388,'ba','Mencetak Laporan Volume harian Order',0),(157947,4388,'nl','Volgorde dagelijkse Volume rapport afdrukken',0),(157948,4388,'fi','Tulostaa pÃ¤ivittÃ¤inen mÃ¤Ã¤rÃ¤ raportti',0),(157949,4388,'no','Skrive ut daglig volum rapport',0),(157950,4388,'da','Udskrive daglige volumen rapport',0),(157951,4388,'ko','ì£¼ë¬¸ ì¼ì¼ ë³¼ë¥¨ ë³´ê³ ì„œ ì¸ì‡„',0),(157952,4388,'he','×”×“×¤×¡ ×“×•×— × ×¤×— ×™×•×ž×™ ×¡×“×¨',0),(157953,4388,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎºÎ±Î¸Î·Î¼ÎµÏÎ¹Î½Î® ÏŒÎ³ÎºÎ¿Ï…',0),(157954,4388,'zh','æ¯æ—¥é‡ç”³æŠ¥è¡¨æ‰“å°å‘½ä»¤\r\n',0),(157955,4388,'sv','Skriva ut Order daglig volym rapport',0),(157956,4388,'it','Stampare il rapporto di Volume giornaliero di ordine',0),(157957,4388,'tl','',0),(157958,4388,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;',0),(157959,4388,'hi','à¤•à¥à¤°à¤® à¤¦à¥ˆà¤¨à¤¿à¤• à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(157960,4388,'ms','Mencetak laporan jumlah pesanan harian',0),(157961,4388,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªÙ‚Ø±ÙŠØ± Ø­Ø¬Ù… ÙŠÙˆÙ…ÙŠØ© Ø£Ù…Ø±',0),(157962,4388,'fr','Imprimer l\'ordre le rapport Volume quotidien',0),(157963,4388,'jp','å?°åˆ·æ³¨æ–‡æ—¥æ¯Žå‡ºæ?¥é«˜ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(157964,4388,'pt','Imprimir relatÃ³rio de Volume DiÃ¡rio de ordem',0),(157965,4388,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð° ÐµÐ¶ÐµÐ´Ð½ÐµÐ²Ð½Ñ‹Ð¹ Ð¾Ð±ÑŠÐµÐ¼ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(157966,4388,'es','Orden de ImpresiÃ³n Informe Diario de VolÃºmen',0),(157967,4388,'de','Bestellung Band Tagesbericht drucken',0),(157968,4388,'en','Print Order Daily Volume Report',0),(157969,4389,'is','',0),(157970,4389,'dr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ ',0),(157971,4389,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ ',0),(157972,4389,'tr','HiÃ§ bir etkinlik',0),(157973,4389,'pl','Brak aktywnoÅ›ci dla',0),(157974,4389,'bg','ÐÑÐ¼Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð°',0),(157975,4389,'ur','Ú©ÙˆØ¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©Û’ Ù„Ø¦Û’',0),(157976,4389,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð°',0),(157977,4389,'vi','KhÃ´ng hoáº¡t Ä‘á»™ng cho',0),(157978,4389,'af','Geen Aktiwiteit Vir',0),(157979,4389,'ro','Nici o activitate pentru',0),(157980,4389,'et','Tegevusi pole:',0),(157981,4389,'si','Nobene dejavnosti',0),(157982,4389,'ba','Tidak ada kegiatan untuk',0),(157983,4389,'nl','Geen enkele activiteit plaatsvindt',0),(157984,4389,'fi','Ei',0),(157985,4389,'no','Ingen aktivitet For',0),(157986,4389,'da','Ingen aktivitet For',0),(157987,4389,'ko','ì— ëŒ€ í•œ í™œë™ì´ ì—†ìŠµë‹ˆë‹¤',0),(157988,4389,'he','××™×Ÿ ×¤×¢×™×œ×•×ª ×‘×ž×©×š',0),(157989,4389,'el','ÎšÎ±Î¼Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î³Î¹Î±',0),(157990,4389,'zh','æ— æ´»åŠ¨\r\n',0),(157991,4389,'sv','Ingen aktivitet fÃ¶r',0),(157992,4389,'it','Nessuna attivitÃ  per',0),(157993,4389,'tl','',0),(157994,4389,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(157995,4389,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(157996,4389,'ms','Tiada aktiviti bagi',0),(157997,4389,'ar','Ù„Ø§ Ù†Ø´Ø§Ø·',0),(157998,4389,'fr','Aucune activitÃ© pour',0),(157999,4389,'jp','ï½žã?®æ´»å‹•ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(158000,4389,'pt','Nenhuma atividade para',0),(158001,4389,'ru','ÐÐµÑ‚ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð—Ð°',0),(158002,4389,'es','No Hay Actividad Para',0),(158003,4389,'de','Keine AktivitÃ¤t fÃ¼r',0),(158004,4389,'en','No Activity For',0),(158005,4390,'is','',0),(158006,4390,'dr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(158007,4390,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(158008,4390,'tr','GeÃ§erli ay iÃ§in hiÃ§ bir etkinlik',0),(158009,4390,'pl','Brak aktywnoÅ›ci w bieÅ¼Ä…cym miesiÄ…cu',0),(158010,4390,'bg','ÐÑÐ¼Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° Ñ‚ÐµÐºÑƒÑ‰Ð¸Ñ Ð¼ÐµÑÐµÑ†',0),(158011,4390,'ur','Ø±ÙˆØ§Úº Ù…Ø§Û Ú©Û’ Ù„Ø¦Û’ Ú©ÙˆØ¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(158012,4390,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ñ‚ÐµÐºÑƒÑ›Ð¸ Ð¼ÐµÑÐµÑ†',0),(158013,4390,'vi','KhÃ´ng hoáº¡t Ä‘á»™ng cho thÃ¡ng nÃ y',0),(158014,4390,'af','Geen Aktiwiteit vir die Huidige Maand',0),(158015,4390,'ro','Nici o activitate pentru luna curentÄƒ',0),(158016,4390,'et','KÃ¤esoleval kuul tegevusi pole',0),(158017,4390,'si','Ne dejavnosti za tekoÄi mesec',0),(158018,4390,'ba','Tidak ada kegiatan untuk bulan ini',0),(158019,4390,'nl','Geen activiteit voor de huidige maand',0),(158020,4390,'fi','Passiiviset kuluvan kuukauden',0),(158021,4390,'no','Ingen aktivitet For gjeldende mÃ¥ned',0),(158022,4390,'da','Ingen aktivitet For den aktuelle mÃ¥ned',0),(158023,4390,'ko','í˜„ìž¬ ë‹¬ì— ëŒ€ í•œ í™œë™ì´ ì—†ìŠµë‹ˆë‹¤',0),(158024,4390,'he','××™×Ÿ ×¤×¢×™×œ×•×ª ×¢×‘×•×¨ ×”×—×•×“×© ×”× ×•×›×—×™',0),(158025,4390,'el','ÎšÎ±Î¼Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î³Î¹Î± Ï„Î¿Î½ Ï„ÏÎ­Ï‡Î¿Î½Ï„Î± Î¼Î®Î½Î±',0),(158026,4390,'zh','å½“å‰æœˆæ²¡æœ‰æ´»åŠ¨\r\n',0),(158027,4390,'sv','Ingen aktivitet fÃ¶r den aktuella mÃ¥naden',0),(158028,4390,'it','Nessuna attivitÃ  per il mese corrente',0),(158029,4390,'tl','',0),(158030,4390,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3648;&#3604;&#3639;&#3629;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(158031,4390,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(158032,4390,'ms','Tiada aktiviti bulan semasa',0),(158033,4390,'ar','Ù„Ø§ Ù†Ø´Ø§Ø· Ù„Ù„Ø´Ù‡Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(158034,4390,'fr','Aucune activitÃ© pour le mois en cours',0),(158035,4390,'jp','ä»Šæœˆã?®æ´»å‹•ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(158036,4390,'pt','Nenhuma atividade para o mÃªs atual',0),(158037,4390,'ru','ÐÐµÑ‚ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð—Ð° Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ ÐœÐµÑÑÑ†',0),(158038,4390,'es','No Hay Actividad Para el Mes Actual',0),(158039,4390,'de','Keine Ereignisse fÃ¼r den aktuellen Monat',0),(158040,4390,'en','No Activity For the Current Month',0),(158041,4391,'is','',0),(158042,4391,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(158043,4391,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(158044,4391,'tr','# SipariÅŸler',0),(158045,4391,'pl','# ZamÃ³wienia',0),(158046,4391,'bg','# ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(158047,4391,'ur','# Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(158048,4391,'sr','# ÐÐ°Ñ€ÐµÑ’ÐµÑšÐ°',0),(158049,4391,'vi','Sá»‘ ÄÆ¡n Äáº·t HÃ ng',0),(158050,4391,'af','# Bestellings',0),(158051,4391,'ro','# Comenzi',0),(158052,4391,'et','Tellimuste arv',0),(158053,4391,'si','# NaroÄila',0),(158054,4391,'ba','# Pesanan',0),(158055,4391,'nl','# Orders',0),(158056,4391,'fi','# Tilaukset',0),(158057,4391,'no','# Ordrer',0),(158058,4391,'da','# Ordrer',0),(158059,4391,'ko','# ì£¼ë¬¸',0),(158060,4391,'he','# ×”×–×ž× ×•×ª',0),(158061,4391,'el','# Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(158062,4391,'zh','ï¼ƒè®¢å•\r\n',0),(158063,4391,'sv','# BestÃ¤llningar',0),(158064,4391,'it','# Ordini',0),(158065,4391,'tl','',0),(158066,4391,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(158067,4391,'hi','# à¤†à¤¦à¥‡à¤¶',0),(158068,4391,'ms','# Pesanan',0),(158069,4391,'ar','# Ø£ÙˆØ§Ù…Ø±',0),(158070,4391,'fr','# Commandes',0),(158071,4391,'jp','æ³¨æ–‡æ•°',0),(158072,4391,'pt','# Ordens',0),(158073,4391,'ru','# Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(158074,4391,'es','# Ordenes',0),(158075,4391,'de','-Bestellungen',0),(158076,4391,'en','# Orders',0),(158077,4392,'is','',0),(158078,4392,'dr','Ù‚Ø¨ÙˆÙ„ Ø¬Ù‡Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(158079,4392,'pr','Ù‚Ø¨ÙˆÙ„ Ø¬Ù‡Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(158080,4392,'tr','Tamam Bill iÃ§in',0),(158081,4392,'pl','Ok do ustawy',0),(158082,4392,'bg','Ð”Ð¾Ð±Ñ€Ðµ, Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(158083,4392,'ur','Ù¹Ú¾ÙŠÚ© ÛÛ’ Ø¨Ù„ Ù…ÛŒÚº',0),(158084,4392,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð° Ð°ÐºÐ¾ Ð‘Ð¸Ð»Ð»',0),(158085,4392,'vi','OK Ä‘á»ƒ ra hÃ³a Ä‘Æ¡n',0),(158086,4392,'af','OK om Wetsontwerp',0),(158087,4392,'ro','OK de Bill',0),(158088,4392,'et','OK Bill',0),(158089,4392,'si','Ok, Bill',0),(158090,4392,'ba','OK untuk tagihan',0),(158091,4392,'nl','O.k. aan Bill',0),(158092,4392,'fi','OK Bill',0),(158093,4392,'no','OK Bill',0),(158094,4392,'da','OK til Bill',0),(158095,4392,'ko','ì²­êµ¬ì„œ í™•ì¸',0),(158096,4392,'he','×‘×¡×“×¨ ×‘×™×œ',0),(158097,4392,'el','Î•Î½Ï„Î¬Î¾ÎµÎ¹ Î½Î± Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(158098,4392,'zh','ç¡®å®šå¼€å•\r\n',0),(158099,4392,'sv','OK till Bill',0),(158100,4392,'it','OK a Bill',0),(158101,4392,'tl','',0),(158102,4392,'th','&#3605;&#3585;&#3621;&#3591;&#3652;&#3611;&#3618;&#3633;&#3591;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(158103,4392,'hi','à¤ à¥€à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²',0),(158104,4392,'ms','OK untuk Rang undang-undang',0),(158105,4392,'ar','Ù…ÙˆØ§ÙÙ‚ Ù„Ù„Ù‚Ø§Ù†ÙˆÙ†',0),(158106,4392,'fr','OK pour le projet de loi',0),(158107,4392,'jp','è«‹æ±‚æº–å‚™å®Œäº†',0),(158108,4392,'pt','OK para Bill',0),(158109,4392,'ru','OK, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð‘Ð¸Ð»Ð»',0),(158110,4392,'es','OK para Facturar',0),(158111,4392,'de','Ordnung, Bill',0),(158112,4392,'en','Ok to Bill',0),(158113,4393,'is','',0),(158114,4393,'dr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø±ÙˆØ²Ø§Ù†Ù‡ Ø³ÙØ§Ø±Ø´',0),(158115,4393,'pr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø±ÙˆØ²Ø§Ù†Ù‡ Ø³ÙØ§Ø±Ø´',0),(158116,4393,'tr','SipariÅŸ gÃ¼nlÃ¼k hacim raporu yazdÄ±r',0),(158117,4393,'pl','Drukuj raport dzienny wielkoÅ›Ä‡ zamÃ³wienia',0),(158118,4393,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð½ÐµÐ²ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(158119,4393,'ur','ØªØ±ØªÛŒØ¨ Ø±ÙˆØ²Ø§Ù†Û ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(158120,4393,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð´Ð½ÐµÐ²Ð½Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(158121,4393,'vi','In bÃ¡o cÃ¡o khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng',0),(158122,4393,'af','Druk Bestelling Daaglikse Volume Verslag',0),(158123,4393,'ro','Comanda raport zilnic volum de imprimare',0),(158124,4393,'et','Tellimuse igapÃ¤evane mahu aruande printimist',0),(158125,4393,'si','Tiskanje nalog dnevni obseg poroÄila',0),(158126,4393,'ba','Mencetak Laporan Volume harian Order',0),(158127,4393,'nl','Volgorde dagelijkse Volume rapport afdrukken',0),(158128,4393,'fi','Tulostaa pÃ¤ivittÃ¤inen mÃ¤Ã¤rÃ¤ raportti',0),(158129,4393,'no','Skrive ut daglig volum rapport',0),(158130,4393,'da','Udskrive daglige volumen rapport',0),(158131,4393,'ko','ì£¼ë¬¸ ì¼ì¼ ë³¼ë¥¨ ë³´ê³ ì„œ ì¸ì‡„',0),(158132,4393,'he','×”×“×¤×¡ ×“×•×— × ×¤×— ×™×•×ž×™ ×¡×“×¨',0),(158133,4393,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎºÎ±Î¸Î·Î¼ÎµÏÎ¹Î½Î® ÏŒÎ³ÎºÎ¿Ï…',0),(158134,4393,'zh','æ‰“å°è®¢å•æ¯æ—¥é‡æŠ¥å‘Š\r\n',0),(158135,4393,'sv','Skriva ut Order daglig volym rapport',0),(158136,4393,'it','Stampare il rapporto di Volume giornaliero di ordine',0),(158137,4393,'tl','',0),(158138,4393,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3593;&#3610;&#3633;&#3610;&#3607;&#3640;&#3585;&#3623;&#3633;&#3609;',0),(158139,4393,'hi','à¤•à¥à¤°à¤® à¤¦à¥ˆà¤¨à¤¿à¤• à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(158140,4393,'ms','Mencetak laporan jumlah pesanan harian',0),(158141,4393,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªÙ‚Ø±ÙŠØ± Ø­Ø¬Ù… ÙŠÙˆÙ…ÙŠØ© Ø£Ù…Ø±',0),(158142,4393,'fr','Imprimer l\'ordre le rapport Volume quotidien',0),(158143,4393,'jp','å?°åˆ·æ³¨æ–‡',0),(158144,4393,'pt','Imprimir relatÃ³rio de Volume DiÃ¡rio de ordem',0),(158145,4393,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð° ÐµÐ¶ÐµÐ´Ð½ÐµÐ²Ð½Ñ‹Ð¹ Ð¾Ð±ÑŠÐµÐ¼ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(158146,4393,'es','Informe de VolÃºmen Diario de Orden de Imprimir',0),(158147,4393,'de','Bestellung Band Tagesbericht drucken',0),(158148,4393,'en','Print Order Daily Volume Report',0),(158149,4394,'is','',0),(158150,4394,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù…Ø§Ù‡ ÙˆØ³Ø§Ù„',0),(158151,4394,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù…Ø§Ù‡ ÙˆØ³Ø§Ù„',0),(158152,4394,'tr','Bir ay ve yÄ±l seÃ§in',0),(158153,4394,'pl','Wybierz miesiÄ…c i rok',0),(158154,4394,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ´Ð¸Ð½ Ð¼ÐµÑÐµÑ† Ð¸ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(158155,4394,'ur','Ø§ÛŒÚ© Ù…ÛÛŒÙ†Û Ø§ÙˆØ± Ø³Ø§Ù„ Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(158156,4394,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼ÐµÑÐµÑ† Ð¸ Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(158157,4394,'vi','Lá»±a chá»n 1 thÃ¡ng & NÄƒm',0),(158158,4394,'af','Kies \'n Maand en Jaar',0),(158159,4394,'ro','SelectaÅ£i o lunÄƒ ÅŸi an',0),(158160,4394,'et','Vali kuu ja aasta',0),(158161,4394,'si','Izberite mesec in leto',0),(158162,4394,'ba','Pilih bulan dan tahun',0),(158163,4394,'nl','Selecteer een maand en jaar',0),(158164,4394,'fi','Valitse kuukausi ja vuosi',0),(158165,4394,'no','Velg en mÃ¥ned og Ã¥r',0),(158166,4394,'da','VÃ¦lg en mÃ¥ned og Ã¥r',0),(158167,4394,'ko','ì›” ë° ì—°ë„ ì„ íƒ',0),(158168,4394,'he','×‘×—×¨ ×—×•×“×© ×•×©× ×”',0),(158169,4394,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Î¼Î®Î½Î± ÎºÎ±Î¹ Ï„Î¿ Î­Ï„Î¿Ï‚',0),(158170,4394,'zh','é€‰æ‹©ä¸€ä¸ªæœˆä»½å’Œå¹´ä»½\r\n',0),(158171,4394,'sv','VÃ¤lj en mÃ¥nad och Ã¥r',0),(158172,4394,'it','Selezionare un mese e anno',0),(158173,4394,'tl','',0),(158174,4394,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3648;&#3604;&#3639;&#3629;&#3609;&#3649;&#3621;&#3632;&#3611;&#3637;',0),(158175,4394,'hi','à¤à¤• à¤®à¤¹à¥€à¤¨à¤¾ à¤”à¤° à¤µà¤°à¥à¤· à¤šà¥à¤¨à¥‡à¤‚',0),(158176,4394,'ms','Pilih bulan dan tahun',0),(158177,4394,'ar','Ù‚Ù… Ø¨ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø´Ù‡Ø± ÙˆØ§Ù„Ø³Ù†Ø©',0),(158178,4394,'fr','SÃ©lectionnez un mois et l\'annÃ©e',0),(158179,4394,'jp','æœˆã?¨å¹´ã?®é?¸æŠž',0),(158180,4394,'pt','Selecione um mÃªs e ano',0),(158181,4394,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐœÐµÑÑÑ† Ð¸ Ð“Ð¾Ð´',0),(158182,4394,'es','Seleccionar un Mes y un AÃ±o',0),(158183,4394,'de','WÃ¤hlen Sie Monat und Jahr',0),(158184,4394,'en','Select a Month and Year',0),(158185,4395,'is','',0),(158186,4395,'dr','AA Ø¯Ø§Ù„Ø±',0),(158187,4395,'pr','AA Ø¯Ù„Ø§Ø±',0),(158188,4395,'tr','AA dolar',0),(158189,4395,'pl','AA dolarÃ³w',0),(158190,4395,'bg','ÐÐ Ð´Ð¾Ð»Ð°Ñ€Ð°',0),(158191,4395,'ur','ÚˆØ¨Ù„ Ø§Û’ ÚˆØ§Ù„Ø±Ø²',0),(158192,4395,'sr','ÐÐ Ð´Ð¾Ð»Ð°Ñ€Ð°',0),(158193,4395,'vi','AA Dollars',0),(158194,4395,'af','AA Dollar',0),(158195,4395,'ro','AA Dolari',0),(158196,4395,'et','AA dollarit',0),(158197,4395,'si','AA dolarjev',0),(158198,4395,'ba','Rupiah AA',0),(158199,4395,'nl','AA Dollars',0),(158200,4395,'fi','AA dollaria',0),(158201,4395,'no','AA dollar',0),(158202,4395,'da','AA Dollars',0),(158203,4395,'ko','AA ë‹¬ëŸ¬',0),(158204,4395,'he','×“×•×œ×¨ AA',0),(158205,4395,'el','Î‘Î‘ Î”Î¿Î»Î¬ÏÎ¹Î±',0),(158206,4395,'zh','AA å…ƒ',0),(158207,4395,'sv','AA dollar',0),(158208,4395,'it','AA Dollari',0),(158209,4395,'tl','',0),(158210,4395,'th','AA DOLLARS',0),(158211,4395,'hi','à¤. à¤. à¤¡à¥‰à¤²à¤°',0),(158212,4395,'ms','AA dolar',0),(158213,4395,'ar','Ø£Ù„Ù Ø¯ÙˆÙ„Ø§Ø± Ø£Ù…Ø±ÙŠÙƒÙŠ',0),(158214,4395,'fr','Dollars AA',0),(158215,4395,'jp','ï¼¡ï¼¡ãƒ‰ãƒ«',0),(158216,4395,'pt','AA dÃ³lares',0),(158217,4395,'ru','ÐÐ Ð´Ð¾Ð»Ð»Ð°Ñ€Ð¾Ð²',0),(158218,4395,'es','AA DÃ³lares',0),(158219,4395,'de','AA Euro',0),(158220,4395,'en','AA Dollars',0),(158221,4396,'is','',0),(158222,4396,'dr','AA Ù…Ù‚Ø¯Ø§Ø±',0),(158223,4396,'pr','AA Ù…Ù‚Ø¯Ø§Ø±',0),(158224,4396,'tr','AA miktar',0),(158225,4396,'pl','IloÅ›Ä‡ AA',0),(158226,4396,'bg','ÐÐ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(158227,4396,'ur','ÚˆØ¨Ù„ Ø§Û’ Ù…Ù‚Ø¯Ø§Ø±',0),(158228,4396,'sr','ÐÐ ÐšÐ¾Ð».',0),(158229,4396,'vi','AA Sá»‘ LÆ°á»£ng',0),(158230,4396,'af','AA Hoev.',0),(158231,4396,'ro','AA Cant.',0),(158232,4396,'et','AA kogus',0),(158233,4396,'si','AA kol',0),(158234,4396,'ba','Jumlah AA',0),(158235,4396,'nl','AA Qty',0),(158236,4396,'fi','AA mÃ¤Ã¤rÃ¤',0),(158237,4396,'no','AA Ant',0),(158238,4396,'da','AA Qty',0),(158239,4396,'ko','AA ìˆ˜ëŸ‰',0),(158240,4396,'he','×›×ž×•×ª AA',0),(158241,4396,'el','Î‘Î‘ Î Î¿Ïƒ.',0),(158242,4396,'zh','AA è´¨é‡',0),(158243,4396,'sv','AA Kvt',0),(158244,4396,'it','AA QtÃ ',0),(158245,4396,'tl','',0),(158246,4396,'th','AA QTY',0),(158247,4396,'hi','à¤. à¤. à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(158248,4396,'ms','AA Qty',0),(158249,4396,'ar','AA Qty',0),(158250,4396,'fr','Quantite AA',0),(158251,4396,'jp','ï¼¡ï¼¡æ•°é‡?',0),(158252,4396,'pt','AA Qty',0),(158253,4396,'ru','AA Qty',0),(158254,4396,'es','AA Cant.',0),(158255,4396,'de','AA Anzahl',0),(158256,4396,'en','AA Qty',0),(158257,4397,'is','',0),(158258,4397,'dr','Ø´Ø±Ø­',0),(158259,4397,'pr','Ø´Ø±Ø­',0),(158260,4397,'tr','AÃ§Ä±klama',0),(158261,4397,'pl','WyjaÅ›nienie',0),(158262,4397,'bg','ÐžÐ±ÑÑÐ½ÐµÐ½Ð¸Ðµ',0),(158263,4397,'ur','ÙˆØ¶Ø§Ø­Øª',0),(158264,4397,'sr','ÐžÐ±Ñ˜Ð°ÑˆÑšÐµÑšÐµ',0),(158265,4397,'vi','Giáº£i thÃ­ch',0),(158266,4397,'af','Verduideliking',0),(158267,4397,'ro','ExplicaÅ£ie',0),(158268,4397,'et','Selgitus',0),(158269,4397,'si','Razlaga',0),(158270,4397,'ba','Penjelasan',0),(158271,4397,'nl','Uitleg',0),(158272,4397,'fi','Selitys',0),(158273,4397,'no','Forklaring',0),(158274,4397,'da','Forklaring',0),(158275,4397,'ko','ì„¤ëª…',0),(158276,4397,'he','×”×¡×‘×¨',0),(158277,4397,'el','Î•Î¾Î®Î³Î·ÏƒÎ·',0),(158278,4397,'zh','è§£é‡Š\r\n',0),(158279,4397,'sv','FÃ¶rklaring',0),(158280,4397,'it','Spiegazione',0),(158281,4397,'tl','',0),(158282,4397,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(158283,4397,'hi','à¤µà¤¿à¤µà¤°à¤£',0),(158284,4397,'ms','Penjelasan',0),(158285,4397,'ar','ØªÙˆØ¶ÙŠØ­',0),(158286,4397,'fr','Explication',0),(158287,4397,'jp','èª¬æ˜Ž',0),(158288,4397,'pt','ExplicaÃ§Ã£o',0),(158289,4397,'ru','ÐžÐ±ÑŠÑÑÐ½ÐµÐ½Ð¸Ðµ',0),(158290,4397,'es','ExplicaciÃ³n',0),(158291,4397,'de','ErklÃ¤rung',0),(158292,4397,'en','Explanation',0),(158293,4398,'is','',0),(158294,4398,'dr','Ø¯Ù„Ø§Ø±  Ø¯Ø§Ø®Ù„ÙŠ ',0),(158295,4398,'pr','Ø¯Ù„Ø§Ø±  Ø¯Ø§Ø®Ù„ÙŠ ',0),(158296,4398,'tr','Ä°Ã§ $$',0),(158297,4398,'pl','WewnÄ™trzne $$',0),(158298,4398,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð° $$',0),(158299,4398,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ $$',0),(158300,4398,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ° $ $',0),(158301,4398,'vi','Ná»™i bá»™ $$',0),(158302,4398,'af','Interne $$',0),(158303,4398,'ro','Interne $$',0),(158304,4398,'et','Sisemine $$',0),(158305,4398,'si','Notranji $$',0),(158306,4398,'ba','Internal $$',0),(158307,4398,'nl','Interne $$',0),(158308,4398,'fi','SisÃ¤inen $$',0),(158309,4398,'no','Intern $$',0),(158310,4398,'da','Interne $$',0),(158311,4398,'ko','ë‚´ë¶€ $ $',0),(158312,4398,'he','×¤× ×™×ž×™×ª $$',0),(158313,4398,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® $$',0),(158314,4398,'zh','å†…éƒ¨$ $\r\n',0),(158315,4398,'sv','Inre $$',0),(158316,4398,'it','Interno $$',0),(158317,4398,'tl','',0),(158318,4398,'th','&#3604;&#3629;&#3621;&#3621;&#3656;&#3634;&#3619;&#3660;&#3616;&#3634;&#3618;&#3651;&#3609;',0),(158319,4398,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• $$',0),(158320,4398,'ms','Dalaman $$',0),(158321,4398,'ar','Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ© $$',0),(158322,4398,'fr','Interne $$',0),(158323,4398,'jp','å†…éƒ¨$$',0),(158324,4398,'pt','Interna $$',0),(158325,4398,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ðµ $$',0),(158326,4398,'es','Internal $$',0),(158327,4398,'de','Interne $$',0),(158328,4398,'en','Internal $$',0),(158329,4399,'is','',0),(158330,4399,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø§Ø®Ù„ÙŠ',0),(158331,4399,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø§Ø®Ù„ÙŠ',0),(158332,4399,'tr','Ä°Ã§ Mkt.',0),(158333,4399,'pl','IloÅ›Ä‡ wewnÄ™trznych',0),(158334,4399,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ ÐºÐ¾Ð»',0),(158335,4399,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ù‚ÛŒ',0),(158336,4399,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ° ÐšÐ¾Ð».',0),(158337,4399,'vi','Sá»‘ lÆ°á»£ng ná»™i bá»™',0),(158338,4399,'af','Interne Hoev.',0),(158339,4399,'ro','Cantit interne',0),(158340,4399,'et','Sisemine kogus',0),(158341,4399,'si','KoliÄina notranjega',0),(158342,4399,'ba','Internal Qty',0),(158343,4399,'nl','Interne Qty',0),(158344,4399,'fi','SisÃ¤inen mÃ¤Ã¤rÃ¤',0),(158345,4399,'no','Intern Ant',0),(158346,4399,'da','Interne Qty',0),(158347,4399,'ko','ë‚´ë¶€ ìˆ˜ëŸ‰',0),(158348,4399,'he','×›×ž×•×ª ×¤× ×™×ž×™',0),(158349,4399,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® Qty',0),(158350,4399,'zh','å†…éƒ¨æ•°é‡\r\n',0),(158351,4399,'sv','Inre Kvt',0),(158352,4399,'it','Interno Qty',0),(158353,4399,'tl','',0),(158354,4399,'th','&#3616;&#3634;&#3618;&#3651;&#3610;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(158355,4399,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(158356,4399,'ms','Qty dalaman',0),(158357,4399,'ar','Ø§Ù„ÙƒÙ…Ù‘ÙŠØ© Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(158358,4399,'fr','Qty interne',0),(158359,4399,'jp','å†…éƒ¨æ•°é‡?',0),(158360,4399,'pt','Qty interno',0),(158361,4399,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ð¹ Ð¾Ð±ÑŠÐµÐ¼',0),(158362,4399,'es','Internal Cant',0),(158363,4399,'de','Interne Qty',0),(158364,4399,'en','Internal Qty',0),(158365,4400,'is','',0),(158366,4400,'dr','Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(158367,4400,'pr','Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(158368,4400,'tr','Malzeme Yinele',0),(158369,4400,'pl','PowtÃ³rz materiaÅ‚',0),(158370,4400,'bg','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð½Ð¸ Redo',0),(158371,4400,'ur','Ù…Ø§Ø¯ÛŒ Ø§Ø¹Ø§Ø¯Û Ú©Ø±ÛŒÚº',0),(158372,4400,'sr','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð½Ð¸ ÐŸÐ¾Ð½Ð¾Ð²Ð¸ Ñ€Ð°Ð´ÑšÑƒ',0),(158373,4400,'vi','LÃ m láº¡i Váº­t liá»‡u',0),(158374,4400,'af','Materiaal Oordoen',0),(158375,4400,'ro','Materiale de refacere',0),(158376,4400,'et','Materjali uuestitegemine',0),(158377,4400,'si','Material uveljavi',0),(158378,4400,'ba','Bahan mengulang',0),(158379,4400,'nl','MateriÃ«le opnieuw',0),(158380,4400,'fi','Materiaalin tee',0),(158381,4400,'no','Materielle Redo',0),(158382,4400,'da','Materielle Redo',0),(158383,4400,'ko','ì†Œìž¬ ë‹¤ì‹œ ì‹¤í–‰',0),(158384,4400,'he','×‘×¦×¢ ×©×•×‘ ×’×©×ž×™',0),(158385,4400,'el','Î¥Î»Î¹ÎºÏŒ ÎµÏ€Î±Î½Î¬Î»Î·ÏˆÎ·',0),(158386,4400,'zh','ææ–™é‡åš\r\n',0),(158387,4400,'sv','Material gÃ¶r om',0),(158388,4400,'it','Redo materiale',0),(158389,4400,'tl','',0),(158390,4400,'th','&#3607;&#3635;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3651;&#3627;&#3617;&#3656;',0),(158391,4400,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤«à¤¿à¤° à¤¸à¥‡ à¤•à¤°à¥‡à¤‚',0),(158392,4400,'ms','Buat semula bahan',0),(158393,4400,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø§Ù„Ù…ÙˆØ§Ø¯',0),(158394,4400,'fr','MatiÃ¨re Redo',0),(158395,4400,'jp','æ??æ–™ã‚„ã‚Šç›´ã?—',0),(158396,4400,'pt','Refazer material',0),(158397,4400,'ru','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð» Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð°',0),(158398,4400,'es','Material Rehacer',0),(158399,4400,'de','Materiell Redo',0),(158400,4400,'en','Material Redo',0),(158401,4401,'is','',0),(158402,4401,'dr','Ø¢Ù…Ø§Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(158403,4401,'pr','Ø¢Ù…Ø§Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(158404,4401,'tr','Malzeme Yinele istatistik',0),(158405,4401,'pl','PowtÃ³rz materiaÅ‚ statystyki',0),(158406,4401,'bg','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð½Ð¸Ñ‚Ðµ Redo ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(158407,4401,'ur','Ù…Ø§Ø¯ÛŒ Ø§Ø¹Ø§Ø¯Û Ú©Ø±ÛŒÚº Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±',0),(158408,4401,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð½Ðµ ÐŸÐ¾Ð½Ð¾Ð²Ð¸ Ñ€Ð°Ð´ÑšÑƒ',0),(158409,4401,'vi','Sá»‘ thá»‘ng kÃª LÃ m láº¡i Váº­t liá»‡u',0),(158410,4401,'af','Materiaal Oordoen Statistieke',0),(158411,4401,'ro','Materiale Redo statistici',0),(158412,4401,'et','Materjali Redo statistika',0),(158413,4401,'si','Material uveljavi statistika',0),(158414,4401,'ba','Bahan mengulang Statistik',0),(158415,4401,'nl','MateriÃ«le opnieuw statistieken',0),(158416,4401,'fi','Materiaalin tee tilastot',0),(158417,4401,'no','Materielle Redo statistikk',0),(158418,4401,'da','Materielle Redo statistik',0),(158419,4401,'ko','ìž¬ë£Œ ë‹¤ì‹œ ì‹¤í–‰ í†µê³„',0),(158420,4401,'he','×‘×¦×¢ ×©×•×‘ ×’×©×ž×™ ×¡×˜×˜×™×¡×˜×™×§×”',0),(158421,4401,'el','Î¥Î»Î¹ÎºÏŒ ÎµÏ€Î±Î½Î¬Î»Î·ÏˆÎ· ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ­Ï‚',0),(158422,4401,'zh','ææ–™é‡åšç»Ÿè®¡\r\n',0),(158423,4401,'sv','Material gÃ¶r om statistik',0),(158424,4401,'it','Materiale Redo statistiche',0),(158425,4401,'tl','',0),(158426,4401,'th','&#3607;&#3635;&#3626;&#3606;&#3636;&#3605;&#3636;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3651;&#3627;&#3617;&#3656;',0),(158427,4401,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤¦à¥‹à¤¹à¤°à¤¾à¤à¤ à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤•à¥€',0),(158428,4401,'ms','Perangkaan penting buat semula',0),(158429,4401,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø¥Ø¹Ø§Ø¯Ø© Ø§Ù„Ù…ÙˆØ§Ø¯',0),(158430,4401,'fr','Statistiques de matÃ©riel de restauration par progression',0),(158431,4401,'jp','æ??æ–™ã‚„ã‚Šç›´ã?—çµ±è¨ˆ',0),(158432,4401,'pt','EstatÃ­sticas de refazer material',0),(158433,4401,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð² Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð°',0),(158434,4401,'es','Material Rehacer EstadÃ­sticas',0),(158435,4401,'de','Materiell Redo-Statistik',0),(158436,4401,'en','Material Redo Statistics',0),(158437,4402,'is','',0),(158438,4402,'dr','Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…Ù‚Ø¯Ø§Ø± ØªÙˆÙ„ÙŠØ¯ ',0),(158439,4402,'pr','Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…Ù‚Ø¯Ø§Ø± ØªÙˆÙ„ÙŠØ¯ ',0),(158440,4402,'tr','Ãœretim miktarÄ± Yinele',0),(158441,4402,'pl','PowtÃ³rz iloÅ›Ä‡ produkcji',0),(158442,4402,'bg','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Redo',0),(158443,4402,'ur','Ù¾ÛŒØ¯Ø§ÙˆØ§Ø± Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¹Ø§Ø¯Û Ú©Ø±ÛŒÚº',0),(158444,4402,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¸ Ñ€Ð°Ð´ÑšÑƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑšÑƒ',0),(158445,4402,'vi','LÃ m láº¡i sá»‘ lÆ°á»£ng sáº£n xuáº¥t',0),(158446,4402,'af','Produksie hoeveelheid oordoen',0),(158447,4402,'ro','Refacere de cantitatea de producÅ£ie',0),(158448,4402,'et','Tootmise kogus uuestitegemine',0),(158449,4402,'si','Uveljavi koliÄina proizvodnje',0),(158450,4402,'ba','Mengulang kuantitas produksi',0),(158451,4402,'nl','Productie hoeveelheid opnieuw',0),(158452,4402,'fi','Tuotannon mÃ¤Ã¤rÃ¤ tee',0),(158453,4402,'no','Produksjon antall Redo',0),(158454,4402,'da','Produktion mÃ¦ngde Redo',0),(158455,4402,'ko','ìƒì‚° ìˆ˜ëŸ‰ ë‹¤ì‹œ ì‹¤í–‰',0),(158456,4402,'he','×™×™×¦×•×¨ ×›×ž×•×ª ×‘×¦×¢ ×©×•×‘',0),(158457,4402,'el','Î•Ï€Î±Î½Î¬Î»Î·ÏˆÎ· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î±ÏÎ±Î³Ï‰Î³Î®Ï‚',0),(158458,4402,'zh','ç”Ÿäº§æ‰¹é‡é‡åš\r\n',0),(158459,4402,'sv','Produktion antal gÃ¶r om',0),(158460,4402,'it','Redo di quantitÃ  di produzione',0),(158461,4402,'tl','',0),(158462,4402,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3651;&#3627;&#3617;&#3656;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(158463,4402,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¨ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤«à¤¿à¤° à¤¸à¥‡ à¤•à¤°à¥‡à¤‚',0),(158464,4402,'ms','Buat semula kuantiti pengeluaran',0),(158465,4402,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø¥Ù†ØªØ§Ø¬ ÙƒÙ…ÙŠØ©',0),(158466,4402,'fr','Production quantitÃ© Redo',0),(158467,4402,'jp','è£½é€ æ•°é‡?ã‚„ã‚Šç›´ã?—',0),(158468,4402,'pt','Redo de quantidade de produÃ§Ã£o',0),(158469,4402,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð¾Ð²',0),(158470,4402,'es','Rehacer cantidad de ProducciÃ³n',0),(158471,4402,'de','Produktion QuantitÃ¤t Redo',0),(158472,4402,'en','Production Quantity Redo',0),(158473,4403,'is','',0),(158474,4403,'dr','Ø¢Ù…Ø§Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ ØªÙˆÙ„ÙŠØ¯ ',0),(158475,4403,'pr','Ø¢Ù…Ø§Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ ØªÙˆÙ„ÙŠØ¯ ',0),(158476,4403,'tr','Ãœretim istatistikleri Yinele',0),(158477,4403,'pl','Produkcja przerobiÄ‡ statystyki',0),(158478,4403,'bg','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ Ð’ÑŠÑ€Ð½Ð¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(158479,4403,'ur','Ù¾ÛŒØ¯Ø§ÙˆØ§Ø± Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± Ú©Ø§ Ø§Ø¹Ø§Ø¯Û Ú©Ø±ÛŒÚº',0),(158480,4403,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑšÑƒ ÐŸÐ¾Ð½Ð¾Ð²Ð¸ Ñ€Ð°Ð´ÑšÑƒ',0),(158481,4403,'vi','Thá»‘ng kÃª sáº£n xuáº¥t láº¡i',0),(158482,4403,'af','Produksie oordoen statistiek',0),(158483,4403,'ro','Statistica producÅ£iei de refacere',0),(158484,4403,'et','Redo tootmisstatistika',0),(158485,4403,'si','Proizvodnje uveljavi statistike',0),(158486,4403,'ba','Produksi mengulang Statistik',0),(158487,4403,'nl','Productie opnieuw statistieken',0),(158488,4403,'fi','Tee tilastot',0),(158489,4403,'no','GjÃ¸r om produksjonsstatistikk',0),(158490,4403,'da','Redo produktionsstatistikker',0),(158491,4403,'ko','ìƒì‚° ë‹¤ì‹œ ì‹¤í–‰ í†µê³„',0),(158492,4403,'he','×”×¡×˜×˜×™×¡×˜×™×§×” ×”×™×™×¦×•×¨ ×‘×¦×¢ ×©×•×‘',0),(158493,4403,'el','Î•Ï€Î±Î½Î¬Î»Î·ÏˆÎ· Ï„Ï‰Î½ ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÏŽÎ½ Ï€Î±ÏÎ±Î³Ï‰Î³Î®Ï‚',0),(158494,4403,'zh','ç”Ÿäº§é‡åšç»Ÿè®¡\r\n',0),(158495,4403,'sv','GÃ¶r om statistiken',0),(158496,4403,'it','Statistiche di produzione Redo',0),(158497,4403,'tl','',0),(158498,4403,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3595;&#3657;&#3635;',0),(158499,4403,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¨ à¤•à¥‡ à¤†à¤à¤•à¤¡à¤¼à¥‡ à¤•à¥‹ à¤«à¤¿à¤° à¤¸à¥‡ à¤•à¤°à¥‡à¤‚',0),(158500,4403,'ms','Statistik buat semula pengeluaran',0),(158501,4403,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø¥Ù†ØªØ§Ø¬ Ø§Ù„Ø¥Ø­ØµØ§Ø¡Ø§Øª',0),(158502,4403,'fr','Statistiques de production Redo',0),(158503,4403,'jp','è£½é€ ã‚„ã‚Šç›´ã?—çµ±è¨ˆ',0),(158504,4403,'pt','EstatÃ­sticas de produÃ§Ã£o Redo',0),(158505,4403,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð° Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð°',0),(158506,4403,'es','EstadÃ­sticas de Rehacer la ProducciÃ³n',0),(158507,4403,'de','Redo Produktionsstatistiken',0),(158508,4403,'en','Production Redo Statistics',0),(158509,4404,'is','',0),(158510,4404,'dr','Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¢Ù…Ø§Ø±\r\nREDO STATS',0),(158511,4404,'pr','Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¢Ù…Ø§Ø±\r\nREDO STATS',0),(158512,4404,'tr','Ä°statistikleri yeniden yapma',0),(158513,4404,'pl','Wykonaj ponownie statystyki',0),(158514,4404,'bg','Ð’ÑŠÑ€Ð½Ð¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(158515,4404,'ur','Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ÙˆØ´Ù…Ø§Ø± Ú©Ø§ Ø§Ø¹Ø§Ø¯Û Ú©Ø±ÛŒÚº',0),(158516,4404,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¸ Ñ€Ð°Ð´ÑšÑƒ Ð¡Ñ‚Ð°Ñ‚Ñ',0),(158517,4404,'vi','Thá»‘ng kÃª lÃ m láº¡i',0),(158518,4404,'af','Oordoen nie statistiek',0),(158519,4404,'ro','Refacere statistici',0),(158520,4404,'et','Uuesti teha Stats',0),(158521,4404,'si','Uveljavi statistika',0),(158522,4404,'ba','Mengulang Statistik',0),(158523,4404,'nl','Opnieuw Stats',0),(158524,4404,'fi','Redo tilastot',0),(158525,4404,'no','GjÃ¸r om statistikk',0),(158526,4404,'da','Redo statistik',0),(158527,4404,'ko','í†µê³„ë¥¼ ë‹¤ì‹œ ì‹¤í–‰',0),(158528,4404,'he','×‘×¦×¢ ×©×•×‘ ×¡×˜×˜×™×¡×˜×™×§×”',0),(158529,4404,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· Î±Î½Î±Î¯ÏÎµÏƒÎ·Ï‚ ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬',0),(158530,4404,'zh','é‡åšç»Ÿè®¡\r\n',0),(158531,4404,'sv','GÃ¶r om statistik',0),(158532,4404,'it','Rifare Stats',0),(158533,4404,'tl','',0),(158534,4404,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3585;&#3634;&#3619;&#3607;&#3635;&#3651;&#3627;&#3617;&#3656;',0),(158535,4404,'hi','à¤†à¤à¤•à¤¡à¤¼à¥‡ à¤ªà¥à¤¨: à¤•à¤°à¥‡à¤‚',0),(158536,4404,'ms','Buat semula statistik',0),(158537,4404,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª',0),(158538,4404,'fr','Refaire des Stats',0),(158539,4404,'jp','ã‚„ã‚Šç›´ã?—çµ±è¨ˆ',0),(158540,4404,'pt','Refazer Stats',0),(158541,4404,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð¸Ñ‚ÑŒ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(158542,4404,'es','Rehacer EstadÃ­sticas',0),(158543,4404,'de','Redo-Statistik',0),(158544,4404,'en','Redo Stats',0),(158545,4405,'is','',0),(158546,4405,'dr','Redo Stats for Period',0),(158547,4405,'pr','Redo Stats for Period',0),(158548,4405,'tr','Ä°statistik dÃ¶nemi iÃ§in yeniden yapmak.',0),(158549,4405,'pl','Wykonaj ponownie statystyki dla okresu',0),(158550,4405,'bg','Ð’ÑŠÑ€Ð½Ð¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(158551,4405,'ur','Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ÙˆØ´Ù…Ø§Ø± Ù…Ø¯Øª Ú©Û’ Ù„ÛŒÛ’ Ø§Ø¹Ø§Ø¯Û Ú©Ø±ÛŒÚº',0),(158552,4405,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐµ Ð·Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(158553,4405,'vi','Thá»‘ng kÃª lÃ m láº¡i trong thá»i ká»³',0),(158554,4405,'af','Oordoen verbruikerstatistieke vir tydperk',0),(158555,4405,'ro','Refacere statistici pentru perioada',0),(158556,4405,'et','Uuesti teha Stats perioodiks',0),(158557,4405,'si','Uveljavi statistika za obdobje',0),(158558,4405,'ba','Mengulang statistik untuk periode',0),(158559,4405,'nl','Stats opnieuw gedurende',0),(158560,4405,'fi','Redo tilastot ajan',0),(158561,4405,'no','GjÃ¸r om statistikk for periode',0),(158562,4405,'da','Redo statistik for perioden',0),(158563,4405,'ko','ê¸°ê°„ì— ëŒ€ í•œ í†µê³„ë¥¼ ë‹¤ì‹œ ì‹¤í–‰',0),(158564,4405,'he','×‘×¦×¢ ×ž×—×“×© ×¡×˜×˜×™×¡×˜×™×§×ª ×œ×ª×§×•×¤×”',0),(158565,4405,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· Î±Î½Î±Î¯ÏÎµÏƒÎ·Ï‚ ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ Î³Î¹Î± Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(158566,4405,'zh','æœŸå†…çš„é‡åšç»Ÿè®¡\r\n',0),(158567,4405,'sv','GÃ¶r om statistik fÃ¶r perioden',0),(158568,4405,'it','Rifare Stats per periodo',0),(158569,4405,'tl','',0),(158570,4405,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3585;&#3634;&#3619;&#3607;&#3635;&#3651;&#3627;&#3617;&#3656;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(158571,4405,'hi','à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤à¤•à¤¡à¤¼à¥‡ à¤ªà¥à¤¨: à¤•à¤°à¥‡à¤‚',0),(158572,4405,'ms','Buat semula statistik bagi tempoh',0),(158573,4405,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ù„Ù„ÙØªØ±Ø©',0),(158574,4405,'fr','Refaire des Stats pour la pÃ©riode',0),(158575,4405,'jp','æœŸé–“å†…ã‚„ã‚Šç›´ã?—çµ±è¨ˆ',0),(158576,4405,'pt','Refazer Stats por perÃ­odo',0),(158577,4405,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð¸Ñ‚ÑŒ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(158578,4405,'es','Rehacer EstadÃ­sticas para el PerÃ­odo',0),(158579,4405,'de','Statistiken fÃ¼r Zeitraum wiederholen',0),(158580,4405,'en','Redo Stats for Period',0),(158581,4406,'is','',0),(158582,4406,'dr','Ø²Ù…Ø§Ù† Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ ',0),(158583,4406,'pr','Ø²Ù…Ø§Ù† Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ ',0),(158584,4406,'tr','Zaman Yinele',0),(158585,4406,'pl','Czas przerobiÄ‡',0),(158586,4406,'bg','Ð’Ñ€ÐµÐ¼Ðµ Redo',0),(158587,4406,'ur','ÙˆÙ‚Øª Ø§Ø¹Ø§Ø¯Û Ú©Ø±ÛŒÚº',0),(158588,4406,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¸ Ñ€Ð°Ð´ÑšÑƒ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(158589,4406,'vi','Thá»i gian lÃ m láº¡i',0),(158590,4406,'af','Tyd Herinvoer',0),(158591,4406,'ro','Timp reface',0),(158592,4406,'et','Aeg uuesti teha',0),(158593,4406,'si','ÄŒas uveljavi',0),(158594,4406,'ba','Waktu mengulang',0),(158595,4406,'nl','Tijd opnieuw',0),(158596,4406,'fi','Aika Redo',0),(158597,4406,'no','Tid gjÃ¸r om',0),(158598,4406,'da','Tid Redo',0),(158599,4406,'ko','ì‹œê°„ ë‹¤ì‹œ ì‹¤í–‰',0),(158600,4406,'he','×‘×¦×¢ ×©×•×‘ ×¤×¢×',0),(158601,4406,'el','Î•Ï€Î±Î½Î¬Î»Î·ÏˆÎ· Ï„Î¿Ï… Ï‡ÏÏŒÎ½Î¿Ï…',0),(158602,4406,'zh','æ—¶é—´é‡åš\r\n',0),(158603,4406,'sv','Tiden gÃ¶r om',0),(158604,4406,'it','Tempo Redo',0),(158605,4406,'tl','',0),(158606,4406,'th','&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3651;&#3627;&#3617;&#3656;',0),(158607,4406,'hi','à¤¸à¤®à¤¯ à¤«à¤¿à¤° à¤¸à¥‡ à¤•à¤°à¥‡à¤‚',0),(158608,4406,'ms','Buat semula masa',0),(158609,4406,'ar','ÙˆÙ‚Øª Ø§Ù„Ø¥Ø¹Ø§Ø¯Ø©',0),(158610,4406,'fr','Temps de rÃ©tablissement',0),(158611,4406,'jp','Time Redo',0),(158612,4406,'pt','Tempo de refazer',0),(158613,4406,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð°',0),(158614,4406,'es','Tiempo Rehacer',0),(158615,4406,'de','Zeit wiederholen',0),(158616,4406,'en','Time Redo',0),(158617,4407,'is','',0),(158618,4407,'dr','Ø¢Ù…Ø§Ø± Ø²Ù…Ø§Ù† Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ ',0),(158619,4407,'pr','Ø¢Ù…Ø§Ø± Ø²Ù…Ø§Ù† Ø§Ù†Ø¬Ø§Ù… Ø¯ÙˆØ¨Ø§Ø±Ù‡ ',0),(158620,4407,'tr','Zaman Yinele istatistikleri',0),(158621,4407,'pl','Czas ponownie statystyki',0),(158622,4407,'bg','Ð’Ñ€ÐµÐ¼Ðµ Redo ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(158623,4407,'ur','ÙˆÙ‚Øª Ø§Ø¹Ø§Ø¯Û Ú©Ø±ÛŒÚº Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±',0),(158624,4407,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¸ Ñ€Ð°Ð´ÑšÑƒ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÑƒ',0),(158625,4407,'vi','Thá»‘ng kÃª Thá»i gian lÃ m láº¡i',0),(158626,4407,'af','Tyd Herinvoer Statistieke',0),(158627,4407,'ro','Timp reface statistici',0),(158628,4407,'et','Aeg uuesti teha statistikat',0),(158629,4407,'si','ÄŒasu uveljavi statistike',0),(158630,4407,'ba','Waktu mengulang Statistik',0),(158631,4407,'nl','Tijd opnieuw statistieken',0),(158632,4407,'fi','Tee tilastot',0),(158633,4407,'no','GjÃ¸r om statistikk',0),(158634,4407,'da','Tid Redo statistik',0),(158635,4407,'ko','ì‹œê°„ ë‹¤ì‹œ ì‹¤í–‰ í†µê³„',0),(158636,4407,'he','×¡×˜×˜×™×¡×˜×™×§×•×ª ×©×œ ×‘×¦×¢ ×©×•×‘',0),(158637,4407,'el','Î•Ï€Î±Î½Î¬Î»Î·ÏˆÎ· ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬',0),(158638,4407,'zh','ç»Ÿè®¡æ—¶é—´é‡åš\r\n',0),(158639,4407,'sv','Tid gÃ¶ra om Statistikcentralen',0),(158640,4407,'it','Tempo Redo statistiche',0),(158641,4407,'tl','',0),(158642,4407,'th','&#3607;&#3635;&#3626;&#3606;&#3636;&#3605;&#3636;&#3648;&#3623;&#3621;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(158643,4407,'hi','à¤¸à¤®à¤¯ à¤«à¤¿à¤° à¤¸à¥‡ à¤•à¤°à¤¨à¤¾ à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤•à¥€',0),(158644,4407,'ms','Masa buat semula statistik',0),(158645,4407,'ar','Ø¥Ø­ØµØ§Ø¡Ø§Øª ÙˆÙ‚Øª Ø§Ù„Ø¥Ø¹Ø§Ø¯Ø©',0),(158646,4407,'fr','Statistiques de temps de rÃ©tablissement',0),(158647,4407,'jp','Time Redo Statistics',0),(158648,4407,'pt','Tempo refazer estatÃ­sticas',0),(158649,4407,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð°',0),(158650,4407,'es','Tiempo Rehacer EstadÃ­sticas',0),(158651,4407,'de','Redo-Statistiken',0),(158652,4407,'en','Time Redo Statistics',0),(158653,4408,'is','',0),(158654,4408,'dr','AA',0),(158655,4408,'pr','AA',0),(158656,4408,'tr','AA',0),(158657,4408,'pl','AA',0),(158658,4408,'bg','AA',0),(158659,4408,'ur','ÚˆØ¨Ù„ Ø§Û’',0),(158660,4408,'sr','ÐÐ',0),(158661,4408,'vi','AA',0),(158662,4408,'af','AA',0),(158663,4408,'ro','AA',0),(158664,4408,'et','AA',0),(158665,4408,'si','AA',0),(158666,4408,'ba','AA',0),(158667,4408,'nl','AA',0),(158668,4408,'fi','AA',0),(158669,4408,'no','AA',0),(158670,4408,'da','AA',0),(158671,4408,'ko','AA',0),(158672,4408,'he','AA',0),(158673,4408,'el','Î‘Î‘',0),(158674,4408,'zh','AA',0),(158675,4408,'sv','AA',0),(158676,4408,'it','AA',0),(158677,4408,'tl','',0),(158678,4408,'th','AA',0),(158679,4408,'hi','à¤. à¤.',0),(158680,4408,'ms','AA',0),(158681,4408,'ar','AA',0),(158682,4408,'fr','AA',0),(158683,4408,'jp','AA',0),(158684,4408,'pt','AA',0),(158685,4408,'ru','AA',0),(158686,4408,'es','AA',0),(158687,4408,'de','AA',0),(158688,4408,'en','AA',0),(158689,4409,'is','',0),(158690,4409,'dr','(Ø¯Ú¯Ø±Ú¯ÙˆÙ†ÙŠ)',0),(158691,4409,'pr','ØªØºÙŠÙŠØ± (Ø¯Ú¯Ø±Ú¯ÙˆÙ†ÙŠ)',0),(158692,4409,'tr','DeÄŸiÅŸiklik',0),(158693,4409,'pl','Zmiana',0),(158694,4409,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð°',0),(158695,4409,'ur','Ø±Ø¯ÙˆØ¨Ø¯Ù„',0),(158696,4409,'sr','Ð˜Ð·Ð¼ÐµÐ½Ð°',0),(158697,4409,'vi','Chá»‰nh Sá»­a',0),(158698,4409,'af','Verandering',0),(158699,4409,'ro','Modificarea',0),(158700,4409,'et','Muutmine',0),(158701,4409,'si','Sprememba',0),(158702,4409,'ba','Perubahan',0),(158703,4409,'nl','Wijziging',0),(158704,4409,'fi','Muuttaminen',0),(158705,4409,'no','Endring',0),(158706,4409,'da','Ã†ndring',0),(158707,4409,'ko','ë³€ê²½',0),(158708,4409,'he','×©×™× ×•×™',0),(158709,4409,'el','Î‘Î»Î»Î¿Î¯Ï‰ÏƒÎ·',0),(158710,4409,'zh','æ”¹é€ \r\n',0),(158711,4409,'sv','FÃ¶rÃ¤ndring',0),(158712,4409,'it','Alterazione',0),(158713,4409,'tl','',0),(158714,4409,'th','&#3585;&#3634;&#3619;&#3604;&#3633;&#3604;&#3649;&#3611;&#3621;&#3591;',0),(158715,4409,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(158716,4409,'ms','Pindaan',0),(158717,4409,'ar','ØªØºÙŠÙŠØ±',0),(158718,4409,'fr','AltÃ©ration',0),(158719,4409,'jp','å¤‰æ›´',0),(158720,4409,'pt','AlteraÃ§Ã£o',0),(158721,4409,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(158722,4409,'es','AlteraciÃ³n',0),(158723,4409,'de','VerÃ¤nderung',0),(158724,4409,'en','Alteration',0),(158725,4410,'is','',0),(158726,4410,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(158727,4410,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(158728,4410,'tr','Fatura tutarÄ±',0),(158729,4410,'pl','Kwota na rachunku',0),(158730,4410,'bg','Ð’ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(158731,4410,'ur','Ø¨Ù„ Ù…ÛŒÚº Ø±Ù‚Ù…',0),(158732,4410,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° Ð‘Ð¸Ð»Ð»Ð°',0),(158733,4410,'vi','Sá»‘ Tiá»n TrÃªn HÃ³a ÄÆ¡n',0),(158734,4410,'af','Wetsontwerp beloop',0),(158735,4410,'ro','Suma de Bill',0),(158736,4410,'et','Arve summa',0),(158737,4410,'si','ZnaÅ¡ajo Bill',0),(158738,4410,'ba','Jumlah tagihan',0),(158739,4410,'nl','Oplopen tot Bill',0),(158740,4410,'fi','Laskun mÃ¤Ã¤rÃ¤',0),(158741,4410,'no','BelÃ¸p til Bill',0),(158742,4410,'da','BelÃ¸be sig til Bill',0),(158743,4410,'ko','ë¹Œ ê¸ˆì•¡',0),(158744,4410,'he','×¡×›×•× ×‘×™×œ',0),(158745,4410,'el','Î‘Î½Î­Î»Î¸ÎµÎ¹ ÏƒÎµ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(158746,4410,'zh','è´¦å•é‡‘é¢\r\n',0),(158747,4410,'sv','UppgÃ¥ till Bill',0),(158748,4410,'it','Ammontano a Bill',0),(158749,4410,'tl','',0),(158750,4410,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(158751,4410,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤² à¤•à¥€ à¤°à¤¾à¤¶à¤¿',0),(158752,4410,'ms','Jumlah bil',0),(158753,4410,'ar','Ù…Ø¨Ù„Øº Ø¨ÙŠÙ„',0),(158754,4410,'fr','S\'Ã©lÃ¨vent Ã  Bill',0),(158755,4410,'jp','è«‹æ±‚é¡?',0),(158756,4410,'pt','Quantidade de Bill',0),(158757,4410,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð½Ð° ÑÑ‡ÐµÑ‚',0),(158758,4410,'es','Monto a Facturar',0),(158759,4410,'de','Belaufen sich auf Bill',0),(158760,4410,'en','Amount to Bill',0),(158761,4411,'is','',0),(158762,4411,'dr','-ÙØ±Ù…Ø§ÛŒØ´ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø³ØªÙ‡ Ø´Ø¯',0),(158763,4411,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª-Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø³ØªÙ‡ Ø´Ø¯',0),(158764,4411,'tr','DeÄŸil kaydedilen deÄŸiÅŸiklikler: SipariÅŸ zaten kapalÄ±',0),(158765,4411,'pl','Nie zapisano zmian: ZamÃ³w juz zamkniÄ™te',0),(158766,4411,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð½Ðµ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ñ‚: Ð ÐµÐ´ Ð²ÐµÑ‡Ðµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(158767,4411,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº: Ø­Ú©Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ø¨Ù†Ø¯',0),(158768,4411,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ðµ Ð½Ð¸ÑÑƒ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½Ðµ: ÐÐ°Ð»Ð¾Ð³ Ð²ÐµÑ› Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(158769,4411,'vi','ChÆ°a Sao LÆ°u Thay Äá»•i: ÄÆ¡n Äáº·t hÃ ng Ä‘Ã£ Ä‘Ã³ng',0),(158770,4411,'af','Veranderinge Nie Gestoor:  Bestelling Alreeds Gesluit',0),(158771,4411,'ro','ModificÄƒrile nu sunt salvate: Comanda deja Ã®nchis',0),(158772,4411,'et','Muutusi ei salvestatud: JÃ¤rjekorras juba suletud',0),(158773,4411,'si','Spremembe, ki se ne shranijo: NaroÄilo Å¾e zaprto',0),(158774,4411,'ba','Perubahan yang tidak disimpan: Order sudah ditutup',0),(158775,4411,'nl','Wijzigingen niet opgeslagen: Order al gesloten',0),(158776,4411,'fi','Muutoksia ei voi tallentaa: Tilaus jo suljettu',0),(158777,4411,'no','Endringer ikke lagres: Orden allerede stengt',0),(158778,4411,'da','Ã†ndringerne gemmes ikke: Bestil allerede lukket',0),(158779,4411,'ko','ì €ìž¥ ë˜ì§€ ì•Šì€ ë³€ê²½ ì‚¬í•­: ì´ë¯¸ ë‹«ížŒ ì£¼ë¬¸',0),(158780,4411,'he','×©×™× ×•×™×™× ×œ× × ×©×ž×¨: ×¡×“×¨ ×›×‘×¨ ×¡×’×•×¨',0),(158781,4411,'el','ÎŸÎ¹ Î±Î»Î»Î±Î³Î­Ï‚ Î´ÎµÎ½ Î±Ï€Î¿Î¸Î·ÎºÎµÏÎ¿Î½Ï„Î±Î¹: Î£ÎµÎ¹ÏÎ¬ Î®Î´Î· ÎºÎ»ÎµÎ¯ÏƒÎµÎ¹',0),(158782,4411,'zh','ä¸ä¿å­˜æ›´æ”¹ï¼šè®¢å•å·²ç»å…³é—­\r\n',0),(158783,4411,'sv','Ã„ndringar som inte sparats: BestÃ¤lla redan stÃ¤ngt',0),(158784,4411,'it','Le modifiche non salvate: Ordine giÃ  chiuso',0),(158785,4411,'tl','',0),(158786,4411,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;:&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#',0),(158787,4411,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¨à¤¹à¥€à¤‚ à¤¸à¤¹à¥‡à¤œà¥‡ à¤—à¤: à¤†à¤¦à¥‡à¤¶ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(158788,4411,'ms','Perubahan yang tidak disimpan: Perintah sudah ditutup',0),(158789,4411,'ar','Ù„Ø§ ÙŠØªÙ… Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª: Ø£Ù…Ø± Ø¨Ø§Ù„ÙØ¹Ù„ Ø¥ØºÙ„Ø§Ù‚',0),(158790,4411,'fr','Les modifications non enregistrÃ©es : Ordre dÃ©jÃ  fermÃ©.',0),(158791,4411,'jp','å¤‰æ›´ã?Œä¿?å­˜ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“ãƒ¼æ³¨æ–‡ã?Œã?™ã?§ã?«çµ‚äº†ã?—ã?¦ã?¾ã?™',0),(158792,4411,'pt','AlteraÃ§Ãµes nÃ£o salvas: Ordem jÃ¡ estÃ¡ fechado',0),(158793,4411,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ ÐÐµ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹: Ð—Ð°ÐºÐ°Ð· Ð£Ð¶Ðµ Ð—Ð°ÐºÑ€Ñ‹Ñ‚',0),(158794,4411,'es','Cambios No Guardados: Pedido ya Cerrado',0),(158795,4411,'de','Ã„nderungen nicht gespeichert: Bestellen Sie bereits geschlossen',0),(158796,4411,'en','Changes Not Saved: Order Already Closed',0),(158797,4412,'is','',0),(158798,4412,'dr','Ù„ÙŠØ³Øª Ø¬Ø²Ø¦ÙŠØ§Øª Ø²Ù…Ø§Ù† ÙˆØ§Ù‚Ø¹ÙŠ Ùˆ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(158799,4412,'pr','Ù„ÙŠØ³Øª Ø¬Ø²Ø¦ÙŠØ§Øª Ø²Ù…Ø§Ù† ÙˆØ§Ù‚Ø¹ÙŠ Ùˆ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(158800,4412,'tr','GerÃ§ek zaman ve malzeme sipariÅŸi iÃ§in ayrÄ±ntÄ±lÄ± listesi',0),(158801,4412,'pl','SzczegÃ³Å‚owy wykaz rzeczywisty czas i materiaÅ‚y dla zamÃ³wienia',0),(158802,4412,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¾Ñ‚Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(158803,4412,'ur','Ø§ØµÙ„ ÙˆÙ‚Øª Ø§ÙˆØ± ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ Ù…ÙˆØ§Ø¯ Ú©ÛŒ ØªÙØµÛŒÙ„ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(158804,4412,'sr','Ð”ÐµÑ‚Ð°Ñ™ Ð»Ð¸ÑÑ‚Ð° ÑÑ‚Ð²Ð°Ñ€Ð½Ð¾Ð³ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð° Ð·Ð° Ð½Ð°Ð»Ð¾Ð³',0),(158805,4412,'vi','Danh sÃ¡ch chi tiáº¿t thá»i gian thá»±c táº¿ & nguyÃªn váº­t liá»‡u cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(158806,4412,'af','Verstekte Lys van Werklike Tyd en Materiale vir Bestelling',0),(158807,4412,'ro','ListÄƒ de detaliu de real timp ÅŸi materiale pentru comanda',0),(158808,4412,'et','Ãœksikasjalik loetelu tegelik aja- ja materjalikulu tellimuse',0),(158809,4412,'si','Podrobnost seznama dejanski Äas in materialov za nalog',0),(158810,4412,'ba','Daftar rinci waktu aktual dan bahan-bahan untuk Order',0),(158811,4412,'nl','Lijst van de detail van de werkelijke tijd en materialen voor Order',0),(158812,4412,'fi','Todellinen ajan ja materiaalien tilauksen tiedot-luettelosta',0),(158813,4412,'no','Detaljert liste over faktisk tid og materialer for ordre',0),(158814,4412,'da','Detaljeret liste over faktiske tid og materialer til ordren',0),(158815,4412,'ko','ì‹¤ì œ ì‹œê°„ ë° ìˆœì„œì— ëŒ€ í•œ ìžë£Œì˜ ìƒì„¸ ëª©ë¡',0),(158816,4412,'he','×¤×™×¨×•×˜ ×¨×©×™×ž×ª ×–×ž×Ÿ ×‘×¤×•×¢×œ ×•×—×•×ž×¨×™× ×¢×‘×•×¨ ×”×–×ž× ×”',0),(158817,4412,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î»Î¯ÏƒÏ„Î± Î¼Îµ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÏŒ Ï‡ÏÏŒÎ½Î¿ ÎºÎ±Î¹ Ï…Î»Î¹ÎºÎ¬ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(158818,4412,'zh','è¯¦ç»†åå•å®žé™…æ—¶é—´å’Œææ–™è®¢å•\r\n',0),(158819,4412,'sv','Detalj lista Ã¶ver faktiska tid och material fÃ¶r ordern',0),(158820,4412,'it','Elenco di dettaglio di materiali per ordine e tempo effettivo',0),(158821,4412,'tl','',0),(158822,4412,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3648;&#3623;&#3621;&#3634;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3649;&#3621;&#3632;&#3623;&#3633;&#3',0),(158823,4412,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤¸à¤®à¤¯ à¤”à¤° à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(158824,4412,'ms','Senarai terperinci masa sebenar dan bahan-bahan untuk pesanan',0),(158825,4412,'ar','Ù‚Ø§Ø¦Ù…Ø© ØªÙØ§ØµÙŠÙ„ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„ÙØ¹Ù„ÙŠ ÙˆÙ…ÙˆØ§Ø¯ Ù„Ù„Ù†Ø¸Ø§Ù…',0),(158826,4412,'fr','Liste dÃ©taillÃ©e des temps rÃ©el et de matÃ©riaux pour l\'ordre',0),(158827,4412,'jp','å®Ÿæ™‚é–“ã?¨æ³¨æ–‡æ??æ–™ã?®è©³ç´°ãƒªã‚¹ãƒˆ',0),(158828,4412,'pt','Lista de detalhes de tempo real e materiais para a ordem',0),(158829,4412,'ru','Ð”ÐµÑ‚Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ð³Ð¾ Ð’Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð¸ ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð² Ð´Ð»Ñ Ð—Ð°ÐºÐ°Ð·Ð°',0),(158830,4412,'es','Detalle de Lista de Tiempo Actual y Materiales del Orden',0),(158831,4412,'de','Detailliste der tatsÃ¤chlichen Zeit- und Materialaufwand fÃ¼r Bestellung',0),(158832,4412,'en','Detail List of Actual Time and Materials for Order',0),(158833,4413,'is','',0),(158834,4413,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ ',0),(158835,4413,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ ',0),(158836,4413,'tr','GeniÅŸletilmiÅŸ maliyet',0),(158837,4413,'pl','Koszt rozszerzone',0),(158838,4413,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(158839,4413,'ur','ØªÙˆØ³ÛŒØ¹ Ú©Ø±Ø¯Û Ù‚ÛŒÙ…Øª',0),(158840,4413,'sr','ÐŸÑ€Ð¾ÑˆÐ¸Ñ€ÐµÐ½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(158841,4413,'vi','GiÃ¡ thÃ nh má»Ÿ rá»™ng',0),(158842,4413,'af','Uitgebreide koste',0),(158843,4413,'ro','Cost complet',0),(158844,4413,'et','Laiendatud hind',0),(158845,4413,'si','RazÅ¡irjena cena',0),(158846,4413,'ba','Biaya diperpanjang',0),(158847,4413,'nl','Uitgebreide kosten',0),(158848,4413,'fi','Laajennettu hinta',0),(158849,4413,'no','Utvidet kostnad',0),(158850,4413,'da','Udvidet omkostninger',0),(158851,4413,'ko','í™•ìž¥ëœ ë¹„ìš©',0),(158852,4413,'he','×¢×œ×•×ª ×ž×•×¨×—×‘',0),(158853,4413,'el','Î•ÎºÏ„ÎµÏ„Î±Î¼Î­Î½Î· ÎºÏŒÏƒÏ„Î¿Ï‚',0),(158854,4413,'zh','æ€»æˆæœ¬\r\n',0),(158855,4413,'sv','UtÃ¶kade kostnader',0),(158856,4413,'it','Costo estesa',0),(158857,4413,'tl','',0),(158858,4413,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3607;&#3637;&#3656;&#3586;&#3618;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;',0);
INSERT INTO `langdef` VALUES (158859,4413,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°à¤¿à¤¤ à¤²à¤¾à¤—à¤¤',0),(158860,4413,'ms','Kos melanjutkan',0),(158861,4413,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ù…ÙˆØ³Ø¹Ø©',0),(158862,4413,'fr','CoÃ»t total de',0),(158863,4413,'jp','æ‹¡å¼µè²»ç”¨',0),(158864,4413,'pt','Custo estendido',0),(158865,4413,'ru','Ð Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ð¹ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(158866,4413,'es','Cost Extendido',0),(158867,4413,'de','Erweiterten Kosten',0),(158868,4413,'en','Extended Cost',0),(158869,4414,'is','',0),(158870,4414,'dr','Ø¯Ø§Ø®Ù„ÙŠ ',0),(158871,4414,'pr','Ø¯Ø§Ø®Ù„ÙŠ ',0),(158872,4414,'tr','Ä°Ã§',0),(158873,4414,'pl','WewnÄ™trzne',0),(158874,4414,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸',0),(158875,4414,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ',0),(158876,4414,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ°',0),(158877,4414,'vi','Ná»™i bá»™',0),(158878,4414,'af','Interne',0),(158879,4414,'ro','Interne',0),(158880,4414,'et','Sisemine',0),(158881,4414,'si','Notranji',0),(158882,4414,'ba','Internal',0),(158883,4414,'nl','Interne',0),(158884,4414,'fi','SisÃ¤inen',0),(158885,4414,'no','Intern',0),(158886,4414,'da','Interne',0),(158887,4414,'ko','ë‚´ë¶€',0),(158888,4414,'he','×¤× ×™×ž×™',0),(158889,4414,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ®',0),(158890,4414,'zh','å†…éƒ¨\r\n',0),(158891,4414,'sv','Inre',0),(158892,4414,'it','Interno',0),(158893,4414,'tl','',0),(158894,4414,'th','&#3616;&#3634;&#3618;&#3651;&#3609;',0),(158895,4414,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤•',0),(158896,4414,'ms','Dalaman',0),(158897,4414,'ar','Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(158898,4414,'fr','Interne',0),(158899,4414,'jp','å†…éƒ¨',0),(158900,4414,'pt','Interno',0),(158901,4414,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ðµ',0),(158902,4414,'es','Internal',0),(158903,4414,'de','Interne',0),(158904,4414,'en','Internal',0),(158905,4415,'is','',0),(158906,4415,'dr','ÙˆØ§Ø­Ø¯ Ù‡Ø²ÙŠÙ†Ù‡',0),(158907,4415,'pr','ÙˆØ§Ø­Ø¯ Ù‡Ø²ÙŠÙ†Ù‡',0),(158908,4415,'tr','Birim maliyeti',0),(158909,4415,'pl','Koszt jednostkowy',0),(158910,4415,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(158911,4415,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(158912,4415,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(158913,4415,'vi','GiÃ¡ thÃ nh 1 Ä‘Æ¡n vá»‹',0),(158914,4415,'af','Eenheidskostes',0),(158915,4415,'ro','Cost unitar',0),(158916,4415,'et','Ãœhiku omahind',0),(158917,4415,'si','StroÅ¡ek enote',0),(158918,4415,'ba','Biaya unit',0),(158919,4415,'nl','Kosten per eenheid',0),(158920,4415,'fi','YksikkÃ¶kustannus',0),(158921,4415,'no','Enhetskosten',0),(158922,4415,'da','Kostpris',0),(158923,4415,'ko','ë‹¨ìœ„ ë¹„ìš©',0),(158924,4415,'he','×ž×—×™×¨ ×™×—×™×“×”',0),(158925,4415,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(158926,4415,'zh','å•ä½æˆæœ¬\r\n',0),(158927,4415,'sv','Styckkostnad',0),(158928,4415,'it','Costo unitario',0),(158929,4415,'tl','',0),(158930,4415,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3629;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(158931,4415,'hi','à¤‡à¤•à¤¾à¤ˆ à¤²à¤¾à¤—à¤¤',0),(158932,4415,'ms','Kos seunit',0),(158933,4415,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„ÙˆØ­Ø¯Ø©',0),(158934,4415,'fr','CoÃ»t unitaire',0),(158935,4415,'jp','å?˜ä¾¡',0),(158936,4415,'pt','Custo unitÃ¡rio',0),(158937,4415,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(158938,4415,'es','Costo de Unidad',0),(158939,4415,'de','Einstandspreis',0),(158940,4415,'en','Unit Cost',0),(158941,4416,'is','',0),(158942,4416,'dr','ØªØ§Ø±ÙŠØ® Ø¯Ø±  ',0),(158943,4416,'pr','ØªØ§Ø±ÙŠØ® Ø¯Ø±  ',0),(158944,4416,'tr','Tarih',0),(158945,4416,'pl','Data w',0),(158946,4416,'bg','Ð”Ð°Ñ‚Ð° Ð²',0),(158947,4416,'ur','ØªØ§Ø±ÛŒØ® Ù…ÛŒÚº',0),(158948,4416,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñƒ',0),(158949,4416,'vi','NgÃ y vÃ o',0),(158950,4416,'af','Datum In',0),(158951,4416,'ro','Data Ã®n',0),(158952,4416,'et','KuupÃ¤ev',0),(158953,4416,'si','Datum v',0),(158954,4416,'ba','Tanggal',0),(158955,4416,'nl','Datum In',0),(158956,4416,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(158957,4416,'no','Dato i',0),(158958,4416,'da','Dato i',0),(158959,4416,'ko','ë‚ ì§œ',0),(158960,4416,'he','×ª××¨×™×š',0),(158961,4416,'el','Î£Î®Î¼ÎµÏÎ±',0),(158962,4416,'zh','æ—¥æœŸ\r\n',0),(158963,4416,'sv','Datum i',0),(158964,4416,'it','Data In',0),(158965,4416,'tl','',0),(158966,4416,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3586;&#3657;&#3634;',0),(158967,4416,'hi','à¤®à¥‡à¤‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(158968,4416,'ms','Tarikh di',0),(158969,4416,'ar','ÙˆØ­ØªÙ‰ Ø§Ù„Ø¢Ù† ÙÙŠ',0),(158970,4416,'fr','Date d\'entrÃ©e en',0),(158971,4416,'jp','å?—ä»˜æ—¥',0),(158972,4416,'pt','Data em',0),(158973,4416,'ru','Ð”Ð°Ñ‚Ð° Ð²',0),(158974,4416,'es','Fecha Entrada',0),(158975,4416,'de','Datum In',0),(158976,4416,'en','Date In',0),(158977,4417,'is','',0),(158978,4417,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù†ÙŠØ§Ø²Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(158979,4417,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù†ÙŠØ§Ø²Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(158980,4417,'tr','Hisse senedi rapor ihtiyacÄ±',0),(158981,4417,'pl','Czas potrzebuje raportu',0),(158982,4417,'bg','Ð¡ÑŠÑÑ‚Ð°Ð² ÑÐµ Ð½ÑƒÐ¶Ð´Ð°Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(158983,4417,'ur','Ø§Ø³Ù¹Ø§Ú© Ø±Ù¾ÙˆØ±Ù¹ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(158984,4417,'sr','Ð Ð¾Ð±Ð¸ Ñ‚Ñ€ÐµÐ±Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(158985,4417,'vi','BÃ¡o cÃ¡o hÃ ng cáº§n thiáº¿t',0),(158986,4417,'af','Verslag van Voorraad Benodig ',0),(158987,4417,'ro','Raport necesar stoc',0),(158988,4417,'et','Varu vajab aruanne',0),(158989,4417,'si','Stock potrebuje poroÄilo',0),(158990,4417,'ba','Saham kebutuhan laporan',0),(158991,4417,'nl','Voorraad moet verslag',0),(158992,4417,'fi','Aikatauluja raportti',0),(158993,4417,'no','Lager mÃ¥ rapporten',0),(158994,4417,'da','Stock behov rapport',0),(158995,4417,'ko','ì£¼ì‹ ë³´ê³ ì„œ í•„ìš”',0),(158996,4417,'he','×ž× ×™×•×ª ×¦×¨×™×š ×“×• ×—',0),(158997,4417,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Ï‡ÏÎµÎ¹Î¬Î¶ÎµÏ„Î±Î¹ Î­ÎºÎ¸ÎµÏƒÎ·',0),(158998,4417,'zh','åº“å­˜éœ€è¦çš„æŠ¥å‘Š\r\n',0),(158999,4417,'sv','Lager behÃ¶ver rapport',0),(159000,4417,'it','Magazzino ha bisogno di relazione',0),(159001,4417,'tl','',0),(159002,4417,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(159003,4417,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥ˆ',0),(159004,4417,'ms','Stok memerlukan laporan',0),(159005,4417,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… ÙŠØ­ØªØ§Ø¬ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(159006,4417,'fr','Stock a besoin de rapport',0),(159007,4417,'jp','Stock Needs Report',0),(159008,4417,'pt','Estoque precisa de relatÃ³rio',0),(159009,4417,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¤Ð¾Ð½Ð´Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ÑÑ‚ÐµÐ¹',0),(159010,4417,'es','Informe de Necesidades de Stock ',0),(159011,4417,'de','Lager braucht Bericht',0),(159012,4417,'en','Stock Needs Report',0),(159013,4418,'is','',0),(159014,4418,'dr','Ú©Ø§Ù„Ø§Ù‡Ø§Ù‰ Ø¯Ø± Ø­Ø§Ù„ Ø³Ø§Ø®Øª',0),(159015,4418,'pr','Ú©Ø§Ù„Ø§Ù‡Ø§Ù‰ Ø¯Ø± Ø­Ø§Ù„ Ø³Ø§Ø®Øª',0),(159016,4418,'tr','SÃ¼ren iÅŸ',0),(159017,4418,'pl','Praca w toku',0),(159018,4418,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð² Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(159019,4418,'ur','Ø§Ø³ Ø¹Ù…Ù„ Ù…ÛŒÚº Ú©Ø§Ù…',0),(159020,4418,'sr','Ð Ð°Ð´ Ñƒ Ñ‚Ð¾ÐºÑƒ',0),(159021,4418,'vi','CÃ´ng viá»‡c Ä‘ang tiáº¿n hÃ ng',0),(159022,4418,'af','Werk Aan Die Gang',0),(159023,4418,'ro','Lucra Ã®n procesul',0),(159024,4418,'et','TÃ¶Ã¶ kÃ¤ib',0),(159025,4418,'si','Delo v procesu',0),(159026,4418,'ba','Bekerja dalam proses',0),(159027,4418,'nl','Werken In proces',0),(159028,4418,'fi','KeskenerÃ¤iset tyÃ¶t',0),(159029,4418,'no','Varer i arbeid',0),(159030,4418,'da','Arbejde i processen',0),(159031,4418,'ko','ê³¼ì •ì—ì„œ ì¼',0),(159032,4418,'he','×‘×¢×‘×•×“×” ×‘×ª×”×œ×™×š',0),(159033,4418,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÏƒÎµ ÎµÎ¾Î­Î»Î¹Î¾Î·',0),(159034,4418,'zh','å·¥ä½œè¿‡ç¨‹\r\n',0),(159035,4418,'sv','Produkter i arbete',0),(159036,4418,'it','Lavori In corso',0),(159037,4418,'tl','',0),(159038,4418,'th','&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3651;&#3609;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;',0),(159039,4418,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤®à¥‡à¤‚ à¤•à¤¾à¤®',0),(159040,4418,'ms','Kerja dalam proses',0),(159041,4418,'ar','Ø§Ù„Ø¹Ù…Ù„ ÙÙŠ Ø¹Ù…Ù„ÙŠØ©',0),(159042,4418,'fr','Travaux en cours',0),(159043,4418,'jp','å‡¦ç?†ä¸­ä½œæ¥­',0),(159044,4418,'pt','Trabalho em processo',0),(159045,4418,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð² Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐµ',0),(159046,4418,'es','Trabajo en proceso',0),(159047,4418,'de','Unfertige Erzeugnisse',0),(159048,4418,'en','Work In Process',0),(159049,4419,'is','',0),(159050,4419,'dr','Ù‚ÙŠÙ…Øª ÙˆØ§Ù‚Ø¹Ù‰',0),(159051,4419,'pr','Ù‚ÙŠÙ…Øª ÙˆØ§Ù‚Ø¹Ù‰',0),(159052,4419,'tr','GerÃ§ek fiyat',0),(159053,4419,'pl','Rzeczywista cena',0),(159054,4419,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð° Ñ†ÐµÐ½Ð°',0),(159055,4419,'ur','Ø§ØµÙ„ Ù‚ÛŒÙ…Øª',0),(159056,4419,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ñƒ Ñ†ÐµÐ½Ñƒ',0),(159057,4419,'vi','GiÃ¡ Thá»±c Táº¿',0),(159058,4419,'af','Werklike Prys',0),(159059,4419,'ro','Pret actual',0),(159060,4419,'et','Tegelik hind',0),(159061,4419,'si','Dejanska cena',0),(159062,4419,'ba','Harga Aktual',0),(159063,4419,'nl','Werkelijke prijs',0),(159064,4419,'fi','Todellinen hinta',0),(159065,4419,'no','Faktiske prisen',0),(159066,4419,'da','Faktiske pris',0),(159067,4419,'ko','ì‹¤ì œ ê°€ê²©',0),(159068,4419,'he','×”×ž×—×™×¨×™× ×‘×¤×•×¢×œ',0),(159069,4419,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® Ï„Î¹Î¼Î®',0),(159070,4419,'zh','å®žé™…ä»·æ ¼\r\n',0),(159071,4419,'sv','Faktiska priset',0),(159072,4419,'it','Prezzo effettivo',0),(159073,4419,'tl','',0),(159074,4419,'th','&#3619;&#3634;&#3588;&#3634;&#3592;&#3619;&#3636;&#3591;',0),(159075,4419,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤®à¥‚à¤²à¥à¤¯',0),(159076,4419,'ms','Harga sebenar',0),(159077,4419,'ar','Ø§Ù„Ø³Ø¹Ø± Ø§Ù„ÙØ¹Ù„ÙŠ',0),(159078,4419,'fr','Prix RÃ©elle',0),(159079,4419,'jp','å®Ÿè²»',0),(159080,4419,'pt','PreÃ§o real',0),(159081,4419,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ°Ñ Ñ†ÐµÐ½Ð°',0),(159082,4419,'es','Precio Actual',0),(159083,4419,'de','Der aktuelle Preis',0),(159084,4419,'en','Actual Price',0),(159085,4420,'is','',0),(159086,4420,'dr','Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(159087,4420,'pr','Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(159088,4420,'tr','Fatura tutarÄ±',0),(159089,4420,'pl','Kwota pÅ‚atna',0),(159090,4420,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð° ÑÑƒÐ¼Ð°',0),(159091,4420,'ur','Ø±Ù‚Ù… Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(159092,4420,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(159093,4420,'vi','Sá»‘ Tiá»n Xuáº¥t HÃ³a ÄÆ¡n',0),(159094,4420,'af','Bedrag weerspieÃ«l',0),(159095,4420,'ro','Suma facturatÄƒ',0),(159096,4420,'et','Arve summa',0),(159097,4420,'si','ZaraÄunani znesek',0),(159098,4420,'ba','Jumlah yang ditagih',0),(159099,4420,'nl','Gefactureerd bedrag',0),(159100,4420,'fi','Laskutettu mÃ¤Ã¤rÃ¤',0),(159101,4420,'no','BelÃ¸pet faktureres',0),(159102,4420,'da','Faktureret belÃ¸b',0),(159103,4420,'ko','ì²­êµ¬ ê¸ˆì•¡',0),(159104,4420,'he','×¡×›×•× ×©×—×•×™×‘',0),(159105,4420,'el','Î Î¿ÏƒÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(159106,4420,'zh','ç»“ç®—é‡‘é¢\r\n',0),(159107,4420,'sv','Beloppet faktureras',0),(159108,4420,'it','Importo fatturato',0),(159109,4420,'tl','',0),(159110,4420,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(159111,4420,'hi','à¤¬à¤¿à¤² à¤•à¥€ à¤—à¤ˆ à¤°à¤¾à¤¶à¤¿',0),(159112,4420,'ms','Jumlah yang dibilkan',0),(159113,4420,'ar','Ù…Ø¨Ù„Øº Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(159114,4420,'fr','Montant facturÃ©',0),(159115,4420,'jp','è«‹æ±‚é¡?',0),(159116,4420,'pt','Quantidade faturada',0),(159117,4420,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÑ‡ÐµÑ‚Ð°',0),(159118,4420,'es','Cantidad Facturada',0),(159119,4420,'de','Betrag in Rechnung gestellt',0),(159120,4420,'en','Amount Billed',0),(159121,4421,'is','',0),(159122,4421,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§Ø² Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªÙ‡ÙŠÙ‡   ÙƒÙ†ÙŠØ¯ØŸ',0),(159123,4421,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§Ø² Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªÙ‡ÙŠÙ‡   ÙƒÙ†ÙŠØ¯ØŸ',0),(159124,4421,'tr','Bu sipariÅŸ iÃ§in Bill istediÄŸinizden emin misiniz',0),(159125,4421,'pl','Czy jesteÅ› pewien, Å¼e chcesz do tego celu',0),(159126,4421,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð°',0),(159127,4421,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ø³ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ Ø¨Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº',0),(159128,4421,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð‘Ð¸Ð» Ð½Ð°Ñ€ÑƒÑŸÐ±Ð° Ð·Ð°',0),(159129,4421,'vi','Xuáº¥t hÃ³a Ä‘Æ¡n ÄÆ¡n Äáº·t HÃ ng nÃ y cho?',0),(159130,4421,'af','Is U seker u wil hierdie Bestalling Faktureer Vir',0),(159131,4421,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ lege acest ordin pentru',0),(159132,4421,'et','Kas kindlasti arve selle tellimuse jaoks',0),(159133,4421,'si','Ali ste prepriÄani, da Å¾elite Bill ta nalog za',0),(159134,4421,'ba','Apakah Anda yakin Anda ingin tagihan ini agar',0),(159135,4421,'nl','Weet u zeker dat u wilt factureren deze volgorde',0),(159136,4421,'fi','Oletko varmasti Bill jÃ¤rjestyksessÃ¤',0),(159137,4421,'no','Er du sikker pÃ¥ at du vil fakturere denne rekkefÃ¸lgen For',0),(159138,4421,'da','Er du sikker pÃ¥ du vil fakturere ordren For',0),(159139,4421,'ko','ë‹¹ì‹ ì€ì´ ìœ„í•´ì„œ ì²­êµ¬ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ',0),(159140,4421,'he','? ××ª×” ×‘×˜×•×— ×©××ª×” ×¨×•×¦×” ×¦×• ×–×” ×¢×‘×•×¨ ×‘×™×œ',0),(159141,4421,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î®ÏƒÎµÎ¹ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬',0),(159142,4421,'zh','ä½ ç¡®å®šä½ æƒ³è¦ä¸ºæ­¤è®¢å•ä»˜æ¬¾\r\n',0),(159143,4421,'sv','Ã„r du sÃ¤ker du vill fakturera ordern fÃ¶r',0),(159144,4421,'it','Sei sicuro che vuoi fatturare quest\'ordine per',0),(159145,4421,'tl','',0),(159146,4421,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3649;&#3621;&#3657;&#3623;&#3627;&#3619;&#3639;&#3629;&#3623;&#3656;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;&#3626;&#3635;&#3627;&#3619;&#3',0),(159147,4421,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤¹à¥ˆà¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(159148,4421,'ms','Adakah anda pasti anda mahu bil Perintah ini bagi',0),(159149,4421,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ù‡Ø°Ø§ Ù…Ù† Ø£Ø¬Ù„',0),(159150,4421,'fr','ÃŠtes-vous certain de que vouloir facturer cet ordre pour',0),(159151,4421,'jp','ã?“ã?®æ³¨æ–‡ã‚’è«‹æ±‚ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(159152,4421,'pt','Tem certeza que quer esta ordem para a conta',0),(159153,4421,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð‘Ð¸Ð»Ð» ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð´Ð»Ñ',0),(159154,4421,'es','Â¿Esta seguro que quiere Facturar este Pedido Para?',0),(159155,4421,'de','Sind Sie sicher, dass Sie diese Bestellung fakturieren mÃ¶chten',0),(159156,4421,'en','Are You Sure You Want to Bill This Order For',0),(159157,4422,'is','',0),(159158,4422,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ù…ÙˆÙ„Ù',0),(159159,4422,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ù…ÙˆÙ„Ù',0),(159160,4422,'tr','Yazar deÄŸiÅŸiklikleri',0),(159161,4422,'pl','Autor zmian',0),(159162,4422,'bg','ÐÐ²Ñ‚Ð¾Ñ€ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(159163,4422,'ur','Ù…ØµÙ†Ù Ú©ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ',0),(159164,4422,'sr','ÐÑƒÑ‚Ð¾Ñ€ Ð¿Ñ€ÐµÐ¿Ñ€Ð°Ð²ÐºÐµ',0),(159165,4422,'vi','TÃ¡c Giáº£ Chá»‰nh Sá»­a',0),(159166,4422,'af','Outeur Veranderinge',0),(159167,4422,'ro','ModificÄƒri de autor',0),(159168,4422,'et','Autor Ã¼mberehitus',0),(159169,4422,'si','Avtor sprememb',0),(159170,4422,'ba','Penulis perubahan',0),(159171,4422,'nl','Auteur wijzigingen',0),(159172,4422,'fi','Kirjoittaja muutoksia',0),(159173,4422,'no','Forfatteren endringer',0),(159174,4422,'da','Forfatteren Ã¦ndringer',0),(159175,4422,'ko','ì €ìž ë³€ê²½',0),(159176,4422,'he','×©×™× ×•×™×™× ×ž×—×‘×¨',0),(159177,4422,'el','Î£Ï…Î³Î³ÏÎ±Ï†Î­Î±Ï‚ Î¼ÎµÏ„Î±Î²Î¿Î»Î­Ï‚',0),(159178,4422,'zh','æŽˆæƒäººå˜æ›´\r\n',0),(159179,4422,'sv','FÃ¶rfattare fÃ¶rÃ¤ndringar',0),(159180,4422,'it','Autore alterazioni',0),(159181,4422,'tl','',0),(159182,4422,'th','&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3612;&#3641;&#3657;&#3649;&#3605;&#3656;&#3591;',0),(159183,4422,'hi','à¤²à¥‡à¤–à¤• à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(159184,4422,'ms','Pengubahsuaian penulis',0),(159185,4422,'ar','Ø§Ù„Ù…Ø¤Ù„Ù Ø§Ù„ØªØ¹Ø¯ÙŠÙ„Ø§Øª',0),(159186,4422,'fr','AltÃ©rations de l\'auteur',0),(159187,4422,'jp','è‘—è€…å¤‰æ›´',0),(159188,4422,'pt','AlteraÃ§Ãµes de autor',0),(159189,4422,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ ÐÐ²Ñ‚Ð¾Ñ€Ð°',0),(159190,4422,'es','Alteraciones de Autor',0),(159191,4422,'de','Autor Ã„nderungen',0),(159192,4422,'en','Author Alterations',0),(159193,4423,'is','',0),(159194,4423,'dr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ Ø¯Ø±',0),(159195,4423,'pr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ Ø¯Ø±',0),(159196,4423,'tr','Olarak faturalandÄ±rÄ±lÄ±r',0),(159197,4423,'pl','Zapowiadane na',0),(159198,4423,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸ Ð½Ð°',0),(159199,4423,'ur','Ù¾Ø± Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(159200,4423,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð½Ð°',0),(159201,4423,'vi','Láº­p HÃ³a ÄÆ¡n VÃ o1a',0),(159202,4423,'af','WeerspieÃ«l op',0),(159203,4423,'ro','Facturat pe',0),(159204,4423,'et','Arve kohta',0),(159205,4423,'si','ZaraÄunavajo na',0),(159206,4423,'ba','Ditagih pada',0),(159207,4423,'nl','Gefactureerd op',0),(159208,4423,'fi','Laskutetaan',0),(159209,4423,'no','Fakturert pÃ¥',0),(159210,4423,'da','Faktureret pÃ¥',0),(159211,4423,'ko','ì— ì²­êµ¬',0),(159212,4423,'he','×”×—×™×•×‘ ×¢×œ',0),(159213,4423,'el','Î§ÏÎµÏŽÎ½Î¿Î½Ï„Î±Î¹',0),(159214,4423,'zh','å¸å•å…³äºŽ\r\n',0),(159215,4423,'sv','Faktureras',0),(159216,4423,'it','Fatturati su',0),(159217,4423,'tl','',0),(159218,4423,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3623;&#3634;&#3591;&#3610;&#3636;&#3621;',0),(159219,4423,'hi','à¤ªà¤° à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾',0),(159220,4423,'ms','Dibilkan pada',0),(159221,4423,'ar','ÙÙˆØ§ØªÙŠØ±',0),(159222,4423,'fr','FacturÃ© le',0),(159223,4423,'jp','è«‹æ±‚æ—¥',0),(159224,4423,'pt','Faturado na',0),(159225,4423,'ru','Ð’Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚ Ð½Ð°',0),(159226,4423,'es','Facturado En',0),(159227,4423,'de','Auf Rechnung',0),(159228,4423,'en','Billed On',0),(159229,4424,'is','',0),(159230,4424,'dr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªÙˆØ³Ø·',0),(159231,4424,'pr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªÙˆØ³Ø·',0),(159232,4424,'tr','TarafÄ±ndan fatura',0),(159233,4424,'pl','Zapowiadane przez',0),(159234,4424,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸ Ð¾Ñ‚',0),(159235,4424,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(159236,4424,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(159237,4424,'vi','HÃ³a ÄÆ¡n Láº­p Bá»Ÿi',0),(159238,4424,'af','Vereken Deur',0),(159239,4424,'ro','Facturat de',0),(159240,4424,'et','Maksustatakse poolt',0),(159241,4424,'si','ZaraÄunali s strani',0),(159242,4424,'ba','Ditagih oleh',0),(159243,4424,'nl','Gefactureerd door',0),(159244,4424,'fi','Laskuttaa',0),(159245,4424,'no','Faktureres av',0),(159246,4424,'da','Faktureret ved',0),(159247,4424,'ko','ì²­êµ¬',0),(159248,4424,'he','×—×™×•×‘ ×¢\"×™',0),(159249,4424,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î¿Ï‚ Î±Ï€ÏŒ',0),(159250,4424,'zh','è®¡è´¹\r\n',0),(159251,4424,'sv','Faktureras av',0),(159252,4424,'it','Fatturati da',0),(159253,4424,'tl','',0),(159254,4424,'th','&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3650;&#3604;&#3618;',0),(159255,4424,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾',0),(159256,4424,'ms','Baki akaun',0),(159257,4424,'ar','ÙˆØµÙØª Ø¨ÙˆØ§Ø³Ø·Ø©',0),(159258,4424,'fr','FacturÃ© par',0),(159259,4424,'jp','è«‹æ±‚è€…',0),(159260,4424,'pt','Faturado pelo',0),(159261,4424,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð°',0),(159262,4424,'es','Facturado Por',0),(159263,4424,'de','Von in Rechnung gestellt',0),(159264,4424,'en','Billed By',0),(159265,4425,'is','',0),(159266,4425,'dr','Ù„ØºÙˆ Ø«Ø¨Øª',0),(159267,4425,'pr','Ù„ØºÙˆ Ø«Ø¨Øª',0),(159268,4425,'tr','GiriÅŸ iptali',0),(159269,4425,'pl','AnulowaÄ‡ wpis',0),(159270,4425,'bg','ÐžÑ‚Ð¼ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ°',0),(159271,4425,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº',0),(159272,4425,'sr','ÐžÑ‚ÐºÐ°Ð¶Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ',0),(159273,4425,'vi','Há»§y Entry',0),(159274,4425,'af','Kanseleer Inskrywing',0),(159275,4425,'ro','Anula intrare',0),(159276,4425,'et','TÃ¼hista kanne',0),(159277,4425,'si','Preklicati vnos',0),(159278,4425,'ba','Membatalkan catatan',0),(159279,4425,'nl','Invoer annuleren',0),(159280,4425,'fi','Peruuta tapahtuma',0),(159281,4425,'no','Avbryte innskriving',0),(159282,4425,'da','Annullere posten',0),(159283,4425,'ko','í•­ëª© ì·¨ì†Œ',0),(159284,4425,'he','×‘×™×˜×•×œ ×¢×¨×š',0),(159285,4425,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î±ÎºÏÏÏ‰ÏƒÎ·',0),(159286,4425,'zh','å–æ¶ˆè¾“å…¥\r\n',0),(159287,4425,'sv','Avbryta transaktionen',0),(159288,4425,'it','Annullare iscrizione',0),(159289,4425,'tl','',0),(159290,4425,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(159291,4425,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‹ à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚',0),(159292,4425,'ms','Membatalkan penyertaan',0),(159293,4425,'ar','Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(159294,4425,'fr','Annuler entrÃ©e',0),(159295,4425,'jp','ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?®å?–ã‚Šæ¶ˆã?—',0),(159296,4425,'pt','Cancelar a entrada',0),(159297,4425,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ð²Ð¾Ð´',0),(159298,4425,'es','Cancelar Entrada',0),(159299,4425,'de','\"Abbrechen\"-Eintrag',0),(159300,4425,'en','Cancel Entry',0),(159301,4426,'is','',0),(159302,4426,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø±Ø§ ØªØºÙŠÙŠØ±  Ø¯Ù‡ÙŠØ¯',0),(159303,4426,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø±Ø§ ØªØºÙŠÙŠØ±  Ø¯Ù‡ÙŠØ¯',0),(159304,4426,'tr','Buraya tÄ±klayÄ±n deÄŸiÅŸtirmek iÃ§in son tarih',0),(159305,4426,'pl','Kliknij tutaj, aby zmieniÄ‡ termin',0),(159306,4426,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶',0),(159307,4426,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ ØªØ§Ø±ÛŒØ®',0),(159308,4426,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(159309,4426,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ Ä‘á»•i thá»i háº¡n',0),(159310,4426,'af','Kliek Hier om die Datum Verskuldig te verander',0),(159311,4426,'ro','Click aici pentru a schimba data scadenÅ£ei',0),(159312,4426,'et','Vajuta siia, et muuta tÃ¤htpÃ¤ev',0),(159313,4426,'si','Kliknite tukaj za spremembo datuma zapadlosti',0),(159314,4426,'ba','Klik di sini untuk perubahan tanggal jatuh tempo',0),(159315,4426,'nl','Klik hier om verandering vervaldatum',0),(159316,4426,'fi','Klikkaa Vaihda erÃ¤pÃ¤ivÃ¤Ã¤',0),(159317,4426,'no','Klikk her for Ã¥ endre forfallsdato',0),(159318,4426,'da','Klik her for at Ã¦ndre forfaldsdatoen',0),(159319,4426,'ko','ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ ì—¬ ë³€ê²½ ê¸°í•œ',0),(159320,4426,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×©× ×•×ª ×ª××¨×™×š ×™×¢×“',0),(159321,4426,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î±Î»Î»Î±Î³Î® Î—Î¼/Î½Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(159322,4426,'zh','ç‚¹å‡»è¿™é‡Œæ›´æ”¹æˆªæ­¢æ—¥æœŸ\r\n',0),(159323,4426,'sv','Klicka hÃ¤r fÃ¶r att Ã¤ndra fÃ¶rfallodatum',0),(159324,4426,'it','Clicca qui per cambiare data di scadenza',0),(159325,4426,'tl','',0),(159326,4426,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3623;&#3633;&#3609;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3',0),(159327,4426,'hi','à¤¯à¤¹à¤¾à¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(159328,4426,'ms','Klik di sini untuk perubahan tarikh akhir',0),(159329,4426,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(159330,4426,'fr','Cliquer pour un changement de Date d\'Ã©chÃ©ance',0),(159331,4426,'jp','æœŸæ—¥ã‚’å¤‰æ›´ã?™ã‚‹',0),(159332,4426,'pt','Clique aqui para alterar Data de vencimento',0),(159333,4426,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑ€Ð¾Ðº',0),(159334,4426,'es','Click aquÃ­ para Cambiar Fecha de Vencimiento',0),(159335,4426,'de','Klicken Sie hier, um Ã„nderung FÃ¤lligkeitsdatum',0),(159336,4426,'en','Click Here to Change Due Date',0),(159337,4427,'is','',0),(159338,4427,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠÙŠ Ø§Ø±Ø³Ø§Ù„  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø±Ø§ ØªØºÙŠÙŠØ± Ø¯Ù‡ÙŠØ¯',0),(159339,4427,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠÙŠ Ø§Ø±Ø³Ø§Ù„  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø±Ø§ ØªØºÙŠÙŠØ± Ø¯Ù‡ÙŠØ¯',0),(159340,4427,'tr','Burada bu sipariÅŸ iÃ§in nihai teslimat tarihini deÄŸiÅŸtir\'i tÄ±klatÄ±n',0),(159341,4427,'pl','Kliknij tutaj aby zmiany koÅ„cowej daty dla tego zamÃ³wienia',0),(159342,4427,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÐºÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(159343,4427,'ur','ÛŒÛØ§Úº ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¢Ø®Ø±ÛŒ Ø¬ÛØ§Ø² ØªØ§Ø±ÛŒØ® Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(159344,4427,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ ÐºÐ¾Ð½Ð°Ñ‡Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(159345,4427,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ thay Ä‘á»•i ngÃ y váº­n chuyá»ƒn cuá»‘i cÃ¹ng cá»§a Ä‘Æ¡n Ä‘áº·t hÃ ng nÃ y',0),(159346,4427,'af','Kliek Hier om die Finale Versendingsdatum vir hierdie Bestelling te Verander',0),(159347,4427,'ro','Click aici pentru a schimba data finalÄƒ de livrare pentru aceastÄƒ comandÄƒ',0),(159348,4427,'et','Vajuta siia, et muutus laeva lÃµppkuupÃ¤ev selle tellimuse',0),(159349,4427,'si','Kliknite tukaj, da spremenite konÄni datum za ta nalog',0),(159350,4427,'ba','Klik di sini untuk perubahan tanggal kapal akhir Orde ini',0),(159351,4427,'nl','Klik hier om te wijzigen de laatste verzenddatum voor deze Order',0),(159352,4427,'fi','Klikkaa tÃ¤stÃ¤ muutos viimeinen lÃ¤hetyspÃ¤ivÃ¤ tÃ¤ssÃ¤ jÃ¤rjestyksessÃ¤',0),(159353,4427,'no','Klikk her for Ã¥ endre siste leveringsdatoen for denne bestillingen',0),(159354,4427,'da','Klik her for at Ã¦ndre den endelige afsendelsesdato for denne ordre',0),(159355,4427,'ko','ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤ ë³€ê²½ ë§ˆì§€ë§‰ ë°°ì†¡ì¼ì´ì´ ì£¼ë¬¸ì— ëŒ€ í•œ',0),(159356,4427,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×©× ×•×ª ×ª××¨×™×š ×”×¡×¤×™× ×” ×¢×‘×•×¨ ×”×–×ž× ×” ×–×•',0),(159357,4427,'el','ÎšÎ»Î¹ÎºÎµÎ´ÏŽ ÏƒÎµ Î±Î»Î»Î±Î³Î® ÏƒÏ„Î·Î½ Ï„ÎµÎ»Î¹ÎºÎ® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬',0),(159358,4427,'zh','ç‚¹å‡»è¿™é‡Œæ›´æ”¹æ­¤å‘½ä»¤çš„æœ€åŽäº¤è´§æ—¥æœŸ\r\n',0),(159359,4427,'sv','Klicka hÃ¤r fÃ¶r att Ã¤ndra det sista fartyget datum fÃ¶r den hÃ¤r ordern',0),(159360,4427,'it','Clicca qui per cambiare la data di spedizione finale per questo ordine',0),(159361,4427,'tl','',0),(159362,4427,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;&#3588;&#3619;&#3633;&#3657;&#3591;&#3',0),(159363,4427,'hi','à¤¯à¤¹à¤¾à¤ à¤…à¤‚à¤¤à¤¿à¤® à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(159364,4427,'ms','Klik di sini untuk perubahan tarikh kapal akhir untuk pesanan ini',0),(159365,4427,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„ØªØºÙŠÙŠØ± \"ØªØ§Ø±ÙŠØ® Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ\" Ù„Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(159366,4427,'fr','Cliquez ici pour changer la Date finale du navire pour cet ordre',0),(159367,4427,'jp','ã?“ã?®æ³¨æ–‡ã?®æœ€çµ‚ç™ºé€?æ—¥ã‚’å¤‰æ›´ã?™ã‚‹ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(159368,4427,'pt','Clique aqui para alterar a Data Final do navio para esta ordem',0),(159369,4427,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð¡ÑŽÐ´Ð° Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐšÐ¾Ð½ÐµÑ‡Ð½ÑƒÑŽ Ð”Ð°Ñ‚Ñƒ ÐžÑ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ Ð—Ð°ÐºÐ°Ð·Ð°',0),(159370,4427,'es','Click aquÃ­ para Cambiar la Fecha Final de Enviar para este Pedido',0),(159371,4427,'de','Klicken Sie hier an den Wandel der letzten Lieferdatum fÃ¼r diese Bestellung',0),(159372,4427,'en','Click Here to Change the Final Ship Date for this Order',0),(159373,4428,'is','',0),(159374,4428,'dr','(Ø¹Ù…Ù„ÙƒØ±Ø¯) Ø±Ø§  Ù…Ø®ÙÙŠ ÙƒÙ†ÙŠØ¯  Ù†Ù‡ Ø§Ø®ÙŠØ±Ø§ Ø¯Ø± Ø§ÙŠÙ† ÙØ±Ù…Ø§ÛŒØ´ Ø¨Ø±Ø§ÙŠ ',0),(159375,4428,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ ÙƒØ§Ø± (Ø¹Ù…Ù„ÙƒØ±Ø¯) Ø±Ø§  Ù…Ø®ÙÙŠ ÙƒÙ†ÙŠØ¯  Ù†Ù‡ Ø§Ø®ÙŠØ±Ø§ Ø¯Ø± Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ ',0),(159376,4428,'tr','HIDE Ã§alÄ±ÅŸmalarÄ± ÅŸu anda bu sipariÅŸ iÃ§in tÄ±klayÄ±n',0),(159377,4428,'pl','Kliknij tutaj, aby ukryÄ‡ pracy nie jest obecnie na tym aby',0),(159378,4428,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¡ÐšÐ Ð˜Ð• Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð°',0),(159379,4428,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ Ù¾Ø± ÙÛŒ Ø§Ù„Ø­Ø§Ù„ Ù†ÛÛŒÚº Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº Ú©Ø§Ù… Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(159380,4428,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð´Ð° Ð¡ÐšÐ Ð˜Ð’ÐÐŠÐ• Ð¿Ð¾ÑÐ»Ð° Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð½Ð¸Ñ˜Ðµ Ñƒ Ð¾Ð²Ð¾Ð¼ Ð½Ð°Ð»Ð¾Ð³Ñƒ Ð·Ð°',0),(159381,4428,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ giáº¥u cÃ´ng viá»‡c khÃ´ng bao gá»“m trong Ä‘Æ¡n Ä‘áº·t hÃ ng nÃ y cho',0),(159382,4428,'af','Kliek Hier om Werk te VERBERG Wat Nie Huidiglik Aangetoon Word Op Hierdie Bestelling Vir',0),(159383,4428,'ro','Click aici pentru a ascunde activitatea nu Ã®n prezent pe aceastÄƒ ordine pentru',0),(159384,4428,'et','Vajuta siia, et PEITA tÃ¶Ã¶ pole praegu maksekorraldus',0),(159385,4428,'si','Kliknite tukaj, da Skrij dela trenutno ni na ta nalog za',0),(159386,4428,'ba','Klik di sini untuk MENYEMBUNYIKAN pekerjaan ini agar tidak sedang',0),(159387,4428,'nl','Klik hier om te verbergen werken op dit moment niet aan deze volgorde',0),(159388,4428,'fi','Klikkaa tÃ¤stÃ¤ PIILOTTAA tyÃ¶tÃ¤ ei ole tÃ¤llÃ¤ hetkellÃ¤ jÃ¤rjestyksessÃ¤',0),(159389,4428,'no','Klikk her for Ã¥ SKJULE arbeidet ikke pÃ¥ denne rekkefÃ¸lgen For',0),(159390,4428,'da','Klik her for at skjule arbejde ikke i Ã¸jeblikket pÃ¥ denne ordre til',0),(159391,4428,'ko','ì´ ìˆœì„œì— í˜„ìž¬ ìž‘ì—… ìˆ¨ê¸°ê¸° í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­í•©ë‹ˆë‹¤',0),(159392,4428,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×”×¡×ª×¨ ×¢×‘×•×“×” ×œ× ×›×™×•× ×¢×œ ×¦×• ×–×” ×¢×‘×•×¨',0),(159393,4428,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î‘Î ÎŒÎšÎ¡Î¥Î¨Î— ÎµÏÎ³Î±ÏƒÎ¯Î± Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÎ®Î¼ÎµÏÎ± ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Î³Î¹Î±',0),(159394,4428,'zh','ç‚¹å‡»æ­¤å¤„å¯éšè—æ­¤è®¢å•ä¸Šçš„éžè¿‘æœŸå·¥ä½œç”¨äºŽ',0),(159395,4428,'sv','Klicka hÃ¤r fÃ¶r att dÃ¶lja arbete fÃ¶r nÃ¤rvarande inte pÃ¥ denna bestÃ¤llning fÃ¶r',0),(159396,4428,'it','Clicca qui per nascondere lavori attualmente non in questo ordine per',0),(159397,4428,'tl','',0),(159398,4428,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3595;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3607;&#3635;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3',0),(159399,4428,'hi','à¤›à¥à¤ªà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤¨à¤¹à¥€à¤‚ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤•à¤¾à¤® à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(159400,4428,'ms','Klik di sini untuk SOROK kerja-kerja tidak kini Perintah ini bagi',0),(159401,4428,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø¹Ù…Ù„ Ù„ÙŠØ³ Ø­Ø§Ù„ÙŠØ§ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(159402,4428,'fr','Cliquez ici pour masquer travail pas actuellement sur cette commande pour',0),(159403,4428,'jp','ï½žã?®ã?“ã?®æ³¨æ–‡ä¸Šã?«ç?¾åœ¨ã?ªã?„ä½œæ¥­ã‚’éš ã?™ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(159404,4428,'pt','Clique aqui para ocultar trabalhos nÃ£o atualmente sobre esta ordem para',0),(159405,4428,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐºÑ€Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð½Ðµ Ð² Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð½Ð° ÑÑ‚Ð¾Ñ‚ Ð·Ð°ÐºÐ°Ð· Ð´Ð»Ñ',0),(159406,4428,'es','Click AquÃ­ para imprimir TODO en el Grupo',0),(159407,4428,'de','Klicken Sie hier um ausblenden arbeiten derzeit nicht an diese Bestellung',0),(159408,4428,'en','Click Here to HIDE Work Not Currently On This Order For',0),(159409,4429,'is','',0),(159410,4429,'dr','(Ø¹Ù…Ù„ÙƒØ±Ø¯)  Ø±Ø§ Ù†Ø´Ø§Ù† Ø¯Ù‡ÙŠØ¯  Ù†Ù‡ Ø§Ø®ÙŠØ±Ø§  Ø¯Ø± Ø§ÙŠÙ† ÙØ±Ù…Ø§ÛŒØ´ Ø¨Ø±Ø§ÙŠ',0),(159411,4429,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ ÙƒØ§Ø± (Ø¹Ù…Ù„ÙƒØ±Ø¯)  Ø±Ø§ Ù†Ø´Ø§Ù† Ø¯Ù‡ÙŠØ¯  Ù†Ù‡ Ø§Ø®ÙŠØ±Ø§  Ø¯Ø± Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ',0),(159412,4429,'tr','Bu sipariÅŸ iÃ§in ÅŸu anda SHOW Ã§alÄ±ÅŸmalarÄ± iÃ§in tÄ±klayÄ±n',0),(159413,4429,'pl','Kliknij tutaj, do pracy nie jest obecnie na tym aby',0),(159414,4429,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° ÐŸÐžÐšÐÐ—Ð’ÐÐ¢ Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚Ð° Ð½Ðµ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð°',0),(159415,4429,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ Ù¾Ø± ÙÛŒ Ø§Ù„Ø­Ø§Ù„ Ù†ÛÛŒÚº Ø´Ùˆ Ú©Û’ Ú©Ø§Ù… Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(159416,4429,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð´Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ðµ Ñ€Ð°Ð´ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð½Ð¸Ñ˜Ðµ Ð½Ð° Ð¾Ð²Ð¾Ð¼ Ð½Ð°Ð»Ð¾Ð³Ñƒ Ð·Ð°',0),(159417,4429,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ hiá»ƒn thá»‹ cÃ´ng viá»‡c khÃ´ng bao gá»“m trong Ä‘Æ¡n Ä‘áº·t hÃ ng nÃ y cho',0),(159418,4429,'af','Kliek Hier om Werk te WYS Wat Nie Huidiglik Verskyn Op Hierdie Bestelling Vir',0),(159419,4429,'ro','Click aici pentru a AratÄƒ munca nu Ã®n prezent pe aceastÄƒ ordine pentru',0),(159420,4429,'et','Vajuta siia, et NÃ¤ita tÃ¶Ã¶ pole praegu maksekorraldus',0),(159421,4429,'si','Kliknite tukaj, da KAÅ½EJO dela trenutno ni na ta nalog za',0),(159422,4429,'ba','Klik di sini untuk Tampilkan kerja saat ini tidak pada ini agar',0),(159423,4429,'nl','Klik hier om Toon werk niet momenteel op deze volgorde',0),(159424,4429,'fi','Napsauttamalla NÃ¤ytÃ¤ tyÃ¶tÃ¤ ei ole tÃ¤llÃ¤ hetkellÃ¤ jÃ¤rjestyksessÃ¤',0),(159425,4429,'no','Klikk her for Ã¥ Vis arbeid ikke er pÃ¥ denne rekkefÃ¸lgen For',0),(159426,4429,'da','Klik her for at Vis arbejde ikke i Ã¸jeblikket pÃ¥ denne ordre til',0),(159427,4429,'ko','ì´ ìˆœì„œì— í˜„ìž¬ ë³´ê¸° ìž‘ì—… í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­í•©ë‹ˆë‹¤',0),(159428,4429,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×”×¦×’ ×¢×‘×•×“×” ×œ× ×›×™×•× ×¢×œ ×¦×• ×–×” ×¢×‘×•×¨',0),(159429,4429,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î± Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÎ®Î¼ÎµÏÎ± ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Î³Î¹Î±',0),(159430,4429,'zh','ç‚¹å‡»è¿™é‡Œæ¥æ˜¾ç¤ºå·¥ä½œï¼Œè€Œéžå½“å‰åœ¨æ­¤è®¢è´­\r\n',0),(159431,4429,'sv','Klicka hÃ¤r fÃ¶r att Visa arbete fÃ¶r nÃ¤rvarande inte pÃ¥ denna bestÃ¤llning fÃ¶r',0),(159432,4429,'it','Clicca qui per Visualizza lavori attualmente non in questo ordine per',0),(159433,4429,'tl','',0),(159434,4429,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3650;&#3594;&#3623;&#3660;&#3585;&#3634;&#3619;&#3607;&#3635;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3',0),(159435,4429,'hi','à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤¨à¤¹à¥€à¤‚ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤•à¤¾à¤® à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(159436,4429,'ms','Klik di sini untuk menunjukkan kerja-kerja tidak kini Perintah ini bagi',0),(159437,4429,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¹Ù…Ù„ Ù„ÙŠØ³ Ø­Ø§Ù„ÙŠØ§ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(159438,4429,'fr','Cliquez ici pour voir la travail pas actuellement sur cette commande pour',0),(159439,4429,'jp','ï½žã?®ã?“ã?®æ³¨æ–‡ä¸Šã?«ç?¾åœ¨ã?ªã?„ä½œæ¥­ã‚’è¡¨ç¤ºã?™ã‚‹ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(159440,4429,'pt','Clique aqui para mostrar trabalho nÃ£o atualmente sobre esta ordem para',0),(159441,4429,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð½Ðµ Ð² Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð½Ð° ÑÑ‚Ð¾Ñ‚ Ð·Ð°ÐºÐ°Ð· Ð´Ð»Ñ',0),(159442,4429,'es','Click AquÃ­ para MOSTRAR Trabajo No Actualmente en Este Pedido Para',0),(159443,4429,'de','Klicken Sie hier fÃ¼r Karte arbeiten derzeit nicht an diese Bestellung',0),(159444,4429,'en','Click Here to SHOW Work Not Currently On This Order For',0),(159445,4430,'is','',0),(159446,4430,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(159447,4430,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(159448,4430,'tr','Tamamlanan Ã§alÄ±ÅŸan numarasÄ±',0),(159449,4430,'pl','Liczba zakoÅ„czonych pracownika',0),(159450,4430,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(159451,4430,'ur','Ù…Ú©Ù…Ù„ Ù…Ù„Ø§Ø²Ù… Ù†Ù…Ø¨Ø±',0),(159452,4430,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸Ñ… Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(159453,4430,'vi','Sá»‘ nhÃ¢n viÃªn ÄÃ£ hoÃ n thÃ nh',0),(159454,4430,'af','Voltooide Werknemernommer',0),(159455,4430,'ro','NumÄƒrul de completat angajat',0),(159456,4430,'et','LÃµpetatud tÃ¶Ã¶taja kood',0),(159457,4430,'si','Å tevilo dokonÄanih zaposlenega',0),(159458,4430,'ba','Nomor selesai karyawan',0),(159459,4430,'nl','Voltooide werknemersnummer',0),(159460,4430,'fi','Valmistunut tyÃ¶ntekijÃ¤numero',0),(159461,4430,'no','FullfÃ¸rt ansattnummeret',0),(159462,4430,'da','Udfyldte medarbejdernummer',0),(159463,4430,'ko','ì™„ì„± ëœ ì§ì› ë²ˆí˜¸',0),(159464,4430,'he','×ž×¡×¤×¨ ×”×¢×•×‘×“ ×©×”×•×©×œ×ž×•',0),(159465,4430,'el','ÎŸÎ»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½Î· ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï…',0),(159466,4430,'zh','å®Œæˆå‘˜å·¥äººæ•°\r\n',0),(159467,4430,'sv','Avslutade anstÃ¤llningsnummer',0),(159468,4430,'it','Numero dipendente completato',0),(159469,4430,'tl','',0),(159470,4430,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;',0),(159471,4430,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤•à¤¿à¤ à¤—à¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(159472,4430,'ms','Nombor pekerja lengkap',0),(159473,4430,'ar','Ø±Ù‚Ù… Ø§Ù„Ù…ÙˆØ¸Ù Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø©',0),(159474,4430,'fr','NumÃ©ro d\'employÃ© dÃ»ment rempli',0),(159475,4430,'jp','å¾“æ¥­å“¡ç•ªå?·ã?®å®Œäº†',0),(159476,4430,'pt','NÃºmero de funcionÃ¡rio concluÃ­do',0),(159477,4430,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ Ð¢Ð°Ð±ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(159478,4430,'es','NÃºmero de Empleado Completado',0),(159479,4430,'de','Abgeschlossene Mitarbeiternummer',0),(159480,4430,'en','Completed Employee Number',0),(159481,4431,'is','',0),(159482,4431,'dr','5 Ø±ÙˆØ²  Ø§Ø² ØªØ§Ø±ÙŠØ® Ù…ÙˆØ¹Ø¯ Ø¨Ø§Ø´Ø¯ ',0),(159483,4431,'pr','ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ® Ø¨Ø§ÙŠØ¯ Ø¸Ø±Ù  5 Ø±ÙˆØ²  Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø¨Ø§Ø´Ø¯ ',0),(159484,4431,'tr','Tarih deÄŸiÅŸikliÄŸi-meli var olmak orijinal vadesi 5 gÃ¼n iÃ§inde tarihi',0),(159485,4431,'pl','Zmiana daty muszÄ… byÄ‡ w ciÄ…gu 5 dni oryginalny Due Data',0),(159486,4431,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð² Ñ€Ð°Ð¼ÐºÐ¸Ñ‚Ðµ Ð½Ð° 5 Ð´Ð½Ð¸ Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶-Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð» Ð´Ð°Ñ‚Ð°',0),(159487,4431,'ur','ØªØ§Ø±ÛŒØ® ØªØ¨Ø¯ÛŒÙ„ÛŒ Ø§ØµÙ„ Ù…Ù‚Ø±Ø±Û Ú©Û’ 5 Ø¯Ù†ÙˆÚº Ú©Û’ Ø§Ù†Ø¯Ø± Ø§Ù†Ø¯Ø± ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒÛ’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(159488,4431,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ñƒ Ñ€Ð¾ÐºÑƒ Ð¾Ð´ 5 Ð´Ð°Ð½Ð° Ð¾Ð´ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(159489,4431,'vi','NgÃ y thay Ä‘á»•i pháº£i trong 5 ngÃ y tá»« ngÃ y Ä‘áº¿n háº¡n gá»‘c',0),(159490,4431,'af','Datum Verandering Moet Binne 5 Dae van die Oorspronklike Verskuldigde Datum',0),(159491,4431,'ro','Modifica data trebuie sÄƒ fie Ã®n termen de 5 zile de Original Due data',0),(159492,4431,'et','KuupÃ¤eva muutmine ei tohi esialgsest 5 pÃ¤eva kuupÃ¤ev',0),(159493,4431,'si','Sprememba datuma mora biti v roku 5 dni po prvotni zapadlosti datum',0),(159494,4431,'ba','Ubah tanggal harus dalam 5 hari setelah Due asli tanggal',0),(159495,4431,'nl','Datumwijziging moet worden binnen de 5 dagen van de oorspronkelijke Due datum',0),(159496,4431,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n muutoksen on oltava alkuperÃ¤isen erÃ¤pÃ¤ivÃ¤n 5 pÃ¤ivÃ¤n kuluessa pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(159497,4431,'no','Endring mÃ¥ vÃ¦re innen 5 dager av opprinnelige Due dato',0),(159498,4431,'da','Dato Ã¦ndringen skal vÃ¦re inden for 5 dage fra den oprindelige forfaldsdato dato',0),(159499,4431,'ko','ì›ëž˜ ê¸°í•œ 5 ì¼ ì´ë‚´ ì—¬ì•¼ í•©ë‹ˆë‹¤ ë‚ ì§œ ë³€ê²½ ë‚ ì§œ',0),(159500,4431,'he','×ª××¨×™×š ×©×™× ×•×™ ×—×™×™×‘ ×œ×”×™×•×ª ×‘×ª×•×š 5 ×™×ž×™× ×©×œ ×”×ž×§×•×¨×™ ×ª××¨×™×š',0),(159501,4431,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î»Î»Î±Î³Î® Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎµÎ½Ï„ÏŒÏ‚ 5 Î·Î¼ÎµÏÏŽÎ½ Î±Ï€ÏŒ Ï„Î·Î½ Î±ÏÏ‡Î¹ÎºÎ® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(159502,4431,'zh','æ›´æ”¹æ—¥æœŸå¿…é¡»åœ¨åŽŸåˆ°æœŸæ—¥5å¤©å†…\r\n',0),(159503,4431,'sv','Datum Ã¤ndra mÃ¥ste vara inom 5 dagar efter det ursprungliga fÃ¶rfallodatumet datum',0),(159504,4431,'it','Cambio di data deve essere entro 5 giorni la scadenza originale data',0),(159505,4431,'tl','',0),(159506,4431,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3632;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3652;&#3604;&#3657;&#3605;&#3657;&#3629;&#3591;&#3652;&#3617;&#3656;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3',0),(159507,4431,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¬à¤¦à¤²à¥‡à¤‚ à¤®à¥‚à¤² à¤¨à¤¿à¤¯à¤¤ à¤•à¥‡ 5 à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(159508,4431,'ms','Perubahan tarikh hendaklah dalam tempoh 5 hari dari Due asal tarikh',0),(159509,4431,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØºÙŠÙŠØ± ÙÙŠ ØºØ¶ÙˆÙ† 5 Ø£ÙŠØ§Ù… Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø§Ù„Ø£ØµÙ„ÙŠ ØªØ§Ø±ÙŠØ®',0),(159510,4431,'fr','Changement de date doit Ãªtre dans les 5 jours de l\'Ã©chÃ©ance initiale Date',0),(159511,4431,'jp','æ—¥ã?«ã?¡å¤‰æ›´ã?¯ã‚ªãƒªã‚¸ãƒŠãƒ«æœŸæ—¥ã?®ï¼•æ—¥ä»¥å†…ã?§ã?ªã?‘ã‚Œã?°ã?„ã?‘ã?¾ã?›ã‚“',0),(159512,4431,'pt','AlteraÃ§Ã£o de data deve ser no prazo de 5 dias do vencimento Original data',0),(159513,4431,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð´Ð°Ñ‚Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ Ð² Ñ‚ÐµÑ‡ÐµÐ½Ð¸Ðµ 5 Ð´Ð½ÐµÐ¹ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð¹ Ð”Ð°Ñ‚Ð°',0),(159514,4431,'es','Cambio de Fecha Debe Estar Dentro de 5 DÃ­as de la Fecha Vencida Original',0),(159515,4431,'de','DatumsÃ¤nderung muÃŸ innerhalb von 5 Tagen nach dem ursprÃ¼nglichen FÃ¤lligkeitsdatum Datum',0),(159516,4431,'en','Date Change Must Be Within 5 Days of the Original Due Date',0),(159517,4432,'is','',0),(159518,4432,'dr','ØªØ§Ø±ÙŠØ® â€“ Ø²Ù…Ø§Ù† ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(159519,4432,'pr','ØªØ§Ø±ÙŠØ® â€“ Ø²Ù…Ø§Ù† ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(159520,4432,'tr','Tarih ve saat tamamlandÄ±',0),(159521,4432,'pl','Czas wypeÅ‚niony',0),(159522,4432,'bg','Ð”Ð°Ñ‚Ð°/Ñ‡Ð°Ñ Ð½Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸',0),(159523,4432,'ur','ØªØ§Ø±ÛŒØ®/ÙˆÙ‚Øª Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§',0),(159524,4432,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ /Ð²Ñ€ÐµÐ¼Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð°',0),(159525,4432,'vi','NgÃ y/thá»i gian hoÃ n táº¥t',0),(159526,4432,'af','Datum/Tyd Voltooi',0),(159527,4432,'ro','Data/ora completat',0),(159528,4432,'et','LÃµpetatud kuupÃ¤ev',0),(159529,4432,'si','Datum/Äas konÄana',0),(159530,4432,'ba','Tanggal/jam selesai',0),(159531,4432,'nl','Datum/tijd voltooid',0),(159532,4432,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ ja kellonaika pÃ¤Ã¤tÃ¶kseen',0),(159533,4432,'no','Dato/klokkeslett fullfÃ¸rt',0),(159534,4432,'da','Dato/tid afsluttet',0),(159535,4432,'ko','ë‚ ì§œ/ì‹œê°„ ì™„ë£Œ',0),(159536,4432,'he','×ª××¨×™×š/×©×¢×” ×”×•×©×œ×ž×”',0),(159537,4432,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±/ÏŽÏÎ± Ï€Î¿Ï… Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ¸Î·ÎºÎµ',0),(159538,4432,'zh','æ—¥æœŸ/æ—¶é—´å†…å®Œæˆ\r\n',0),(159539,4432,'sv','Datum/tid avslutade',0),(159540,4432,'it','Data e ora completato',0),(159541,4432,'tl','',0),(159542,4432,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;/&#3648;&#3623;&#3621;&#3634; &#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(159543,4432,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤•/à¤¸à¤®à¤¯ à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤—à¤¯à¤¾',0),(159544,4432,'ms','Masa/tarikh siap',0),(159545,4432,'ar','ØªØ§Ø±ÙŠØ®/ÙˆÙ‚Øª Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(159546,4432,'fr','Date/heure terminÃ©',0),(159547,4432,'jp','å®Œäº†æ—¥æ™‚',0),(159548,4432,'pt','Data/hora concluÃ­da',0),(159549,4432,'ru','Ð”Ð°Ñ‚Ð°/Ð’Ñ€ÐµÐ¼Ñ Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹',0),(159550,4432,'es','Fecha/Hora Completada',0),(159551,4432,'de','Datum/Uhrzeit abgeschlossen',0),(159552,4432,'en','Date/Time Completed',0),(159553,4433,'is','',0),(159554,4433,'dr','Ø´Ø±Ø­ ÙƒØ§Ø± ',0),(159555,4433,'pr','Ø´Ø±Ø­ ÙƒØ§Ø± ',0),(159556,4433,'tr','Ä°ÅŸ aÃ§Ä±klamasÄ±',0),(159557,4433,'pl','Opis pracy',0),(159558,4433,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚Ð°',0),(159559,4433,'ur','Ú©Ø§Ù… Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(159560,4433,'sr','ÐžÐ¿Ð¸Ñ Ñ€Ð°Ð´Ð°',0),(159561,4433,'vi','MÃ´ táº£ cÃ´ng viá»‡c',0),(159562,4433,'af','Beskrywing van Werk',0),(159563,4433,'ro','Descrierea/de control de lucru',0),(159564,4433,'et','TÃ¶Ã¶ kirjeldus',0),(159565,4433,'si','Opis dela',0),(159566,4433,'ba','Deskripsi pekerjaan',0),(159567,4433,'nl','Beschrijving van het werk',0),(159568,4433,'fi','Kuvaus',0),(159569,4433,'no','Beskrivelse arbeid',0),(159570,4433,'da','Beskrivelse af arbejdet',0),(159571,4433,'ko','ìž‘í’ˆ ì„¤ëª…',0),(159572,4433,'he','×ª×™××•×¨ ×¢×‘×•×“×”',0),(159573,4433,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Î­ÏÎ³Î¿Ï…',0),(159574,4433,'zh','å·¥ä½œæè¿°\r\n',0),(159575,4433,'sv','Beskrivning av arbete',0),(159576,4433,'it','Descrizione del lavoro',0),(159577,4433,'tl','',0),(159578,4433,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;',0),(159579,4433,'hi','à¤•à¤¾à¤® à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(159580,4433,'ms','Huraian kerja',0),(159581,4433,'ar','ÙˆØµÙ Ù„Ù„Ø¹Ù…Ù„',0),(159582,4433,'fr','Devis',0),(159583,4433,'jp','ä»•äº‹ã?®è§£èª¬',0),(159584,4433,'pt','DescriÃ§Ã£o do trabalho',0),(159585,4433,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(159586,4433,'es','DescripciÃ³n de Trabajo',0),(159587,4433,'de','Beschreibung des Werkes',0),(159588,4433,'en','Description of Work',0),(159589,4434,'is','',0),(159590,4434,'dr','Ø¯Ù„Ø§Ø± Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ ',0),(159591,4434,'pr','Ø¯Ù„Ø§Ø± Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ ',0),(159592,4434,'tr','$$ / Adet',0),(159593,4434,'pl','$$ / Szt',0),(159594,4434,'bg','$ $$ / Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð°',0),(159595,4434,'ur','$$ / ÛŒÙˆÙ†Ù¹',0),(159596,4434,'sr','$ $ / ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(159597,4434,'vi','$$/ÄÆ¡n vá»‹',0),(159598,4434,'af','$$ / Eenheid',0),(159599,4434,'ro','$$ / Buc',0),(159600,4434,'et','Eurot Ã¼hiku kohta',0),(159601,4434,'si','$$ / Enoto',0),(159602,4434,'ba','$$ / Unit',0),(159603,4434,'nl','$$ / Eenheid',0),(159604,4434,'fi','$$ / YksikkÃ¶',0),(159605,4434,'no','$$ / Enhet',0),(159606,4434,'da','$$ / Enhed',0),(159607,4434,'ko','$$ / ë‹¨ìœ„',0),(159608,4434,'he','$$ ×œ×™×—×™×“×”',0),(159609,4434,'el','$$ / ÎœÎ¿Î½Î¬Î´Î±',0),(159610,4434,'zh','ç¾Žå…ƒè®¡ç®—å•ä½\r\n',0),(159611,4434,'sv','$$ / Enhet',0),(159612,4434,'it','$$ Per unitÃ ',0),(159613,4434,'tl','',0),(159614,4434,'th','$$/&#3627;&#3609;&#3656;&#3623;&#3618;',0),(159615,4434,'hi','$$ / à¤‡à¤•à¤¾à¤ˆ',0),(159616,4434,'ms','$$ / Unit',0),(159617,4434,'ar','$$/Ø§Ù„ÙˆØ­Ø¯Ø©',0),(159618,4434,'fr','$$ / UnitÃ©',0),(159619,4434,'jp','$$/å€‹',0),(159620,4434,'pt','$$ / Unidade',0),(159621,4434,'ru','$$ / Ð‘Ð»Ð¾Ðº',0),(159622,4434,'es','$$/Unidad',0),(159623,4434,'de','$$ / Einheit',0),(159624,4434,'en','$$/Unit',0),(159625,4435,'is','',0),(159626,4435,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªØ§Ø±ÙŠØ® ',0),(159627,4435,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªØ§Ø±ÙŠØ® ',0),(159628,4435,'tr','Tarihi DÃ¼zenle',0),(159629,4435,'pl','Edytuj datÄ™',0),(159630,4435,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(159631,4435,'ur','ØªØ§Ø±ÛŒØ® ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(159632,4435,'sr','Ð£Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(159633,4435,'vi','Sá»­a NgÃ y',0),(159634,4435,'af','Redigeer Datum',0),(159635,4435,'ro','Editare data',0),(159636,4435,'et','Muuda kupÃ¤eva',0),(159637,4435,'si','Urejanje datum',0),(159638,4435,'ba','Tanggal Edit',0),(159639,4435,'nl','Datum wijzigen',0),(159640,4435,'fi','Edit pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(159641,4435,'no','Rediger dato',0),(159642,4435,'da','Rediger dato',0),(159643,4435,'ko','ë‚ ì§œ íŽ¸ì§‘',0),(159644,4435,'he','×¢×¨×•×š ×ª××¨×™×š',0),(159645,4435,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(159646,4435,'zh','ç¼–è¾‘æ—¥æœŸ\r\n',0),(159647,4435,'sv','Redigera datum',0),(159648,4435,'it','Data di modifica',0),(159649,4435,'tl','',0),(159650,4435,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(159651,4435,'hi','à¤¤à¤¿à¤¥à¤¿ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(159652,4435,'ms','Menyunting tarikh',0),(159653,4435,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(159654,4435,'fr','Modifier Date',0),(159655,4435,'jp','ç·¨é›†æ—¥',0),(159656,4435,'pt','Editar data',0),(159657,4435,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð”Ð°Ñ‚Ñƒ',0),(159658,4435,'es','Editar Fecha',0),(159659,4435,'de','Bearbeitungsdatum',0),(159660,4435,'en','Edit Date',0),(159661,4436,'is','',0),(159662,4436,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³ØªØ®Ø¯Ø§Ù… ',0),(159663,4436,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³ØªØ®Ø¯Ø§Ù… ',0),(159664,4436,'tr','EMP #',0),(159665,4436,'pl','EMP #',0),(159666,4436,'bg','Ð•Ð¼Ð¸ #',0),(159667,4436,'ur','Ù¾ #',0),(159668,4436,'sr','Ð•ÐœÐŸ #',0),(159669,4436,'vi','Sá»‘ EMP',0),(159670,4436,'af','Werkn.#',0),(159671,4436,'ro','EMP #',0),(159672,4436,'et','EMP #',0),(159673,4436,'si','EMP #',0),(159674,4436,'ba','EMP #',0),(159675,4436,'nl','EMP #',0),(159676,4436,'fi','EMP #',0),(159677,4436,'no','EMP #',0),(159678,4436,'da','EMP #',0),(159679,4436,'ko','Emp #',0),(159680,4436,'he','Emp #',0),(159681,4436,'el','EMP #',0),(159682,4436,'zh','ç”µç£è„‰å†²ï¼ƒ\r\n',0),(159683,4436,'sv','EMP #',0),(159684,4436,'it','EMP #',0),(159685,4436,'tl','',0),(159686,4436,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586; Emp ',0),(159687,4436,'hi','Emp #',0),(159688,4436,'ms','EMP #',0),(159689,4436,'ar','Ø§Ù„Ø´Ø±Ø§ÙƒØ© Ø§Ù„Ø£ÙˆØ±Ùˆ-Ù…ØªÙˆØ³Ø·ÙŠØ© #',0),(159690,4436,'fr','EMP #',0),(159691,4436,'jp','å¾“æ¥­å“¡ç•ªå?·',0),(159692,4436,'pt','EMP #',0),(159693,4436,'ru','EMP #',0),(159694,4436,'es','Emp#',0),(159695,4436,'de','EMP-',0),(159696,4436,'en','Emp#',0),(159697,4437,'is','',0),(159698,4437,'dr','  ÙŠÙƒØ³Ø§Ù† Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ ',0),(159699,4437,'pr','  ÙŠÙƒØ³Ø§Ù† Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ ',0),(159700,4437,'tr','Tahmini eÅŸit',0),(159701,4437,'pl','RÃ³wne okoÅ‚o',0),(159702,4437,'bg','Ð Ð°Ð²ÐµÐ½ Ð¿Ñ€Ð¸Ð±Ð»Ð¸Ð·Ð¸Ñ‚ÐµÐ»Ð½Ð¾',0),(159703,4437,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¨Ø±Ø§Ø¨Ø±',0),(159704,4437,'sr','ÐˆÐµÐ´Ð½Ð°ÐºÐ¾ Ð¾Ñ‚Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐµ',0),(159705,4437,'vi','Dá»± trÃ¹ cÃ¢n báº±ng',0),(159706,4437,'af','Gelyke beraam',0),(159707,4437,'ro','Egal estimat',0),(159708,4437,'et','Hinnanguliselt vÃµrdsete',0),(159709,4437,'si','Enaka ocenjeni',0),(159710,4437,'ba','Perkiraan yang sama',0),(159711,4437,'nl','Gelijke geschat',0),(159712,4437,'fi','Sama arvioitu',0),(159713,4437,'no','Lik beregnet',0),(159714,4437,'da','Lige anslÃ¥et',0),(159715,4437,'ko','ë™ë“± í•˜ ê²Œ ì¶”ì •',0),(159716,4437,'he','×©×•×•×” ×ž×•×¢×¨×š',0),(159717,4437,'el','ÎŠÏƒÎµÏ‚ ÎµÎºÏ„Î¹Î¼Î¬Ï„Î±Î¹',0),(159718,4437,'zh','ç›¸ç­‰çš„ä¼°è®¡',0),(159719,4437,'sv','Lika uppskattad',0),(159720,4437,'it','Pari stimato',0),(159721,4437,'tl','',0),(159722,4437,'th','&#3648;&#3607;&#3656;&#3634;&#3585;&#3633;&#3610;&#3607;&#3637;&#3656;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;',0),(159723,4437,'hi','à¤¬à¤°à¤¾à¤¬à¤° à¤•à¤¾ à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(159724,4437,'ms','Yang sama dianggarkan',0),(159725,4437,'ar','Ø§Ù„Ù…Ø³Ø§ÙˆØ§Ø© ÙÙŠ Ø§Ù„Ù…Ù‚Ø¯Ø±Ø©',0),(159726,4437,'fr','Ã‰galitÃ© estimÃ©e',0),(159727,4437,'jp','è¦‹ç©?ã‚Šã?¨å?Œé¡?',0),(159728,4437,'pt','Estima-se ser igual',0),(159729,4437,'ru','Ð Ð°Ð²Ð½Ð° Ð¿Ñ€Ð¸Ð¼ÐµÑ€Ð½Ð¾',0),(159730,4437,'es','Igual Estimado',0),(159731,4437,'de','Gleich geschÃ¤tzt',0),(159732,4437,'en','Equal Estimated',0),(159733,4438,'is','',0),(159734,4438,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ ',0),(159735,4438,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ ',0),(159736,4438,'tr','Maliyet tahmini',0),(159737,4438,'pl','Szacowany koszt',0),(159738,4438,'bg','ÐŸÑ€Ð¾Ð³Ð½Ð¾Ð·Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(159739,4438,'ur','Ù„Ø§Ú¯Øª Ú©Ø§ ØªØ®Ù…ÛŒÙ†Û',0),(159740,4438,'sr','ÐŸÑ€ÐµÐ´Ð²Ð¸Ñ’ÐµÐ½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(159741,4438,'vi','GiÃ¡ thÃ nh Æ°á»›c tÃ­nh',0),(159742,4438,'af','Kosteberaming',0),(159743,4438,'ro','Cost estimativ',0),(159744,4438,'et','Hinnanguline kulu',0),(159745,4438,'si','Ocenjeni stroÅ¡ki',0),(159746,4438,'ba','Perkiraan biaya',0),(159747,4438,'nl','Geschatte kosten',0),(159748,4438,'fi','Arvioidut kustannukset',0),(159749,4438,'no','AnslÃ¥tt kostnad',0),(159750,4438,'da','AnslÃ¥ede omkostninger',0),(159751,4438,'ko','ì˜ˆìƒëœ ë¹„ìš©',0),(159752,4438,'he','×”×¢×œ×•×ª ×”×ž×©×•×¢×¨×ª',0),(159753,4438,'el','Î•ÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(159754,4438,'zh','ä¼°è®¡æˆæœ¬\r\n',0),(159755,4438,'sv','BerÃ¤knad kostnad',0),(159756,4438,'it','Costo stimato',0),(159757,4438,'tl','',0),(159758,4438,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3650;&#3604;&#3618;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(159759,4438,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤²à¤¾à¤—à¤¤',0),(159760,4438,'ms','Anggaran kos',0),(159761,4438,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„ØªÙ‚Ø¯ÙŠØ±ÙŠØ©',0),(159762,4438,'fr','CoÃ»t estimatif',0),(159763,4438,'jp','è¦‹ç©?ã‚‚ã‚Šè²»ç”¨',0),(159764,4438,'pt','Custo estimado',0),(159765,4438,'ru','Ð¡Ð¼ÐµÑ‚Ð½Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(159766,4438,'es','Costo Estimado',0),(159767,4438,'de','GeschÃ¤tzte Kosten',0),(159768,4438,'en','Estimated Cost',0),(159769,4439,'is','',0),(159770,4439,'dr','Ù‚ÙŠÙ…Øª ØªØ®Ù…ÙŠÙ†ÙŠ',0),(159771,4439,'pr','Ù‚ÙŠÙ…Øª ØªØ®Ù…ÙŠÙ†ÙŠ',0),(159772,4439,'tr','Tahmini fiyat',0),(159773,4439,'pl','Szacunkowa cena',0),(159774,4439,'bg','ÐŸÑ€Ð¸Ð±Ð»Ð¸Ð·Ð¸Ñ‚ÐµÐ»Ð½Ð° Ñ†ÐµÐ½Ð°',0),(159775,4439,'ur','ØªØ®Ù…ÛŒÙ†ÛŒ Ù‚ÛŒÙ…Øª',0),(159776,4439,'sr','ÐŸÑ€ÐµÐ´Ð²Ð¸Ñ’ÐµÐ½Ð¾Ñ˜ Ñ†ÐµÐ½Ð¸',0),(159777,4439,'vi','GiÃ¡ Dá»± trÃ¹',0),(159778,4439,'af','Geskatte Prys',0),(159779,4439,'ro','PreÅ£ estimat',0),(159780,4439,'et','Arvestuslik hind',0),(159781,4439,'si','Ocenjena cena',0),(159782,4439,'ba','Perkiraan harga',0),(159783,4439,'nl','Geschatte prijs',0),(159784,4439,'fi','Arvioitu hinta',0),(159785,4439,'no','Antatt pris',0),(159786,4439,'da','SkÃ¸nnede pris',0),(159787,4439,'ko','ì˜ˆìƒëœ ê°€ê²©',0),(159788,4439,'he','×ž×—×™×¨ ×ž×©×•×¢×¨',0),(159789,4439,'el','Î•ÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Ï„Î¹Î¼Î®',0),(159790,4439,'zh','ä¼°è®¡ä»·æ ¼\r\n',0),(159791,4439,'sv','Uppskattat pris',0),(159792,4439,'it','Prezzo stimato',0),(159793,4439,'tl','',0),(159794,4439,'th','&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;',0),(159795,4439,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤®à¥‚à¤²à¥à¤¯',0),(159796,4439,'ms','Anggaran harga',0),(159797,4439,'ar','Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ù…Ù‚Ø¯Ø±',0),(159798,4439,'fr','Prix estimÃ©',0),(159799,4439,'jp','è¦‹ç©?ã‚‚ã‚Šä¾¡æ ¼',0),(159800,4439,'pt','PreÃ§o estimado',0),(159801,4439,'ru','ÐžÑ€Ð¸ÐµÐ½Ñ‚Ð¸Ñ€Ð¾Ð²Ð¾Ñ‡Ð½Ð°Ñ Ñ†ÐµÐ½Ð°',0),(159802,4439,'es','Precio Estimado',0),(159803,4439,'de','GeschÃ¤tzter Preis',0),(159804,4439,'en','Estimated Price',0),(159805,4440,'is','',0),(159806,4440,'dr','Ù¾Ø± ÙƒØ±Ø¯Ù† ',0),(159807,4440,'pr','Ù¾Ø± ÙƒØ±Ø¯Ù† ',0),(159808,4440,'tr','Dolgu',0),(159809,4440,'pl','WypeÅ‚nienia',0),(159810,4440,'bg','Ð—Ð°Ð¿ÑŠÐ»Ð²Ð°Ð½Ðµ',0),(159811,4440,'ur','Ø¨Ú¾Ø±ÛŒÚº',0),(159812,4440,'sr','ÐŸÐ¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ',0),(159813,4440,'vi','Äiá»n',0),(159814,4440,'af','Vul',0),(159815,4440,'ro','Umple',0),(159816,4440,'et','TÃ¤itke',0),(159817,4440,'si','Polnilo',0),(159818,4440,'ba','Mengisi',0),(159819,4440,'nl','Vullen',0),(159820,4440,'fi','TÃ¤ytÃ¤',0),(159821,4440,'no','Fyll',0),(159822,4440,'da','Fyld',0),(159823,4440,'ko','ì±„ìš°ê¸°',0),(159824,4440,'he','×ž×™×œ×•×™',0),(159825,4440,'el','Î“Î­Î¼Î¹ÏƒÎ¼Î±',0),(159826,4440,'zh','å¡«å†™\r\n',0),(159827,4440,'sv','Fyll',0),(159828,4440,'it','Riempimento',0),(159829,4440,'tl','',0),(159830,4440,'th','&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;',0),(159831,4440,'hi','à¤­à¤°à¤£',0),(159832,4440,'ms','Mengisi',0),(159833,4440,'ar','Ù…Ù„Ø¡',0),(159834,4440,'fr','Remplissage',0),(159835,4440,'jp','è¨˜å…¥',0),(159836,4440,'pt','Preenchimento',0),(159837,4440,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ',0),(159838,4440,'es','Llenar',0),(159839,4440,'de','FÃ¼llung',0),(159840,4440,'en','Fill',0),(159841,4441,'is','',0),(159842,4441,'dr','Ø¢Ø®Ø±ÙŠÙ†  ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„',0),(159843,4441,'pr','Ø¢Ø®Ø±ÙŠÙ†  ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„',0),(159844,4441,'tr','Son teslim tarihi',0),(159845,4441,'pl','Ostateczne daty',0),(159846,4441,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¾ ÐºÐ¾Ñ€Ð°Ð±',0),(159847,4441,'ur','Ø¢Ø®Ø±ÛŒ Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(159848,4441,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð±Ñ€Ð¾Ð´',0),(159849,4441,'vi','NgÃ y chuyáº¿n hÃ ng cuá»‘i',0),(159850,4441,'af','Finale Sendingsdatum',0),(159851,4441,'ro','Data finalÄƒ navei',0),(159852,4441,'et','LÃµplik lÃ¤hetuskuupÃ¤ev',0),(159853,4441,'si','KonÄni datum',0),(159854,4441,'ba','Tanggal akhir kapal',0),(159855,4441,'nl','Laatste verzenddatum',0),(159856,4441,'fi','Viimeinen lÃ¤hetyspÃ¤ivÃ¤',0),(159857,4441,'no','Siste forsendelsesdato',0),(159858,4441,'da','Sidste skib dato',0),(159859,4441,'ko','ë§ˆì§€ë§‰ ë°°ì†¡ì¼',0),(159860,4441,'he','×ª××¨×™×š ×ž×©×œ×•×— ×”×¡×•×¤×™',0),(159861,4441,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î·Ï‚ Ï„ÎµÎ»Î¹ÎºÎ® Ï€Î»Î¿Î¯Î¿',0),(159862,4441,'zh','æœ€åŽå‘è´§æ—¥æœŸ\r\n',0),(159863,4441,'sv','Sista transportdatum',0),(159864,4441,'it','Data di spedizione finale',0),(159865,4441,'tl','',0),(159866,4441,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(159867,4441,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(159868,4441,'ms','Tarikh akhir kapal',0),(159869,4441,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ',0),(159870,4441,'fr','Date d\'expÃ©dition finale',0),(159871,4441,'jp','æœ€çµ‚ç™ºé€?æ—¥',0),(159872,4441,'pt','Data de envio final',0),(159873,4441,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(159874,4441,'es','Fecha Final de EnvÃ­o',0),(159875,4441,'de','EndgÃ¼ltige Lieferdatum',0),(159876,4441,'en','Final Ship Date',0),(159877,4442,'is','',0),(159878,4442,'dr','Ù†Ø±Ø® Ø³Ø§Ø¹ØªÙŠ',0),(159879,4442,'pr','Ù†Ø±Ø® Ø³Ø§Ø¹ØªÙŠ',0),(159880,4442,'tr','Hrly oranÄ±',0),(159881,4442,'pl','Kurs hrly',0),(159882,4442,'bg','Hrly ÐºÑƒÑ€Ñ',0),(159883,4442,'ur','ÛØ± Ø´Ø±Ø­',0),(159884,4442,'sr','Ð¥Ñ€Ð»y ÑÑ‚Ð¾Ð¿Ð°',0),(159885,4442,'vi','GiÃ¡ HÃ ng giá»',0),(159886,4442,'af','Uurl. Tarief',0),(159887,4442,'ro','Rata de Hrly',0),(159888,4442,'et','Hrly mÃ¤Ã¤r',0),(159889,4442,'si','Hrly stopnja',0),(159890,4442,'ba','Tingkat Hrly',0),(159891,4442,'nl','Hrly tarief',0),(159892,4442,'fi','Hrly mÃ¤Ã¤rÃ¤',0),(159893,4442,'no','Hrly Rate',0),(159894,4442,'da','Hrly sats',0),(159895,4442,'ko','Hrly ì†ë„',0),(159896,4442,'he','Hrly ×§×¦×‘',0),(159897,4442,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Hrly',0),(159898,4442,'zh','æ—¶è–ª\r\n',0),(159899,4442,'sv','Hrly hastighet',0),(159900,4442,'it','Tasso di hrly',0),(159901,4442,'tl','',0),(159902,4442,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3619;&#3634;&#3618;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(159903,4442,'hi','Hrly à¤¦à¤°',0),(159904,4442,'ms','Kadar Hrly',0),(159905,4442,'ar','Ù…Ø¹Ø¯Ù„ Ù‡Ø±Ù„ÙŠ',0),(159906,4442,'fr','Taux de hrly',0),(159907,4442,'jp','æ™‚çµ¦',0),(159908,4442,'pt','Taxa de hrly',0),(159909,4442,'ru','Hrly ÑÑ‚Ð°Ð²ÐºÐ°',0),(159910,4442,'es','Tasa Por Hora',0),(159911,4442,'de','HRLY Rate',0),(159912,4442,'en','Hrly Rate',0),(159913,4443,'is','',0),(159914,4443,'dr','(Ú†Ø§Ù¾) Ù…Ø§Ø´ÙŠÙ† Ø­Ø³Ø§Ø¨ ',0),(159915,4443,'pr','Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÙŠ (Ú†Ø§Ù¾) Ù…Ø§Ø´ÙŠÙ† Ø­Ø³Ø§Ø¨ ',0),(159916,4443,'tr','GÃ¶sterimler hesap makinesi',0),(159917,4443,'pl','Kalkulator wyÅ›wietleÅ„',0),(159918,4443,'bg','Ð’Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸ÑÑ‚Ð° ÐºÐ°Ð»ÐºÑƒÐ»Ð°Ñ‚Ð¾Ñ€',0),(159919,4443,'ur','Ù†Ù‚ÙˆØ´ Ú©ÛŒÙ„Ú©ÙˆÙ„ÛŒÙ¹Ø±',0),(159920,4443,'sr','Ð£Ñ‚Ð¸ÑÑ†Ð¸ ÐºÐ°Ð»ÐºÑƒÐ»Ð°Ñ‚Ð¾Ñ€',0),(159921,4443,'vi','TÃ­nh áº¤n tÆ°á»£ng',0),(159922,4443,'af','Indrukke sakrekenaar',0),(159923,4443,'ro','Impresii Calculator',0),(159924,4443,'et','Muljeid kalkulaator',0),(159925,4443,'si','Vtisi kalkulator',0),(159926,4443,'ba','Tayangan Kalkulator',0),(159927,4443,'nl','Indrukken Calculator',0),(159928,4443,'fi','NÃ¤yttÃ¶kerrat Laskin',0),(159929,4443,'no','Visninger kalkulator',0),(159930,4443,'da','Indtryk lommeregner',0),(159931,4443,'ko','ë…¸ì¶œ ìˆ˜ ê³„ì‚°ê¸°',0),(159932,4443,'he','×¨×©×ž×™× ×ž×—×©×‘×•×Ÿ',0),(159933,4443,'el','Î•Î½Ï„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚ Î±ÏÎ¹Î¸Î¼Î¿Î¼Î·Ï‡Î±Î½Î®',0),(159934,4443,'zh','å°è±¡è®¡ç®—å™¨\r\n',0),(159935,4443,'sv','Intryck kalkylatorn',0),(159936,4443,'it','Impressioni calcolatrice',0),(159937,4443,'tl','',0),(159938,4443,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3588;&#3636;&#3604;&#3648;&#3621;&#3586;&#3591;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(159939,4443,'hi','à¤›à¤¾à¤ªà¥‡à¤‚ à¤•à¥ˆà¤²à¤•à¥à¤¯à¥‚à¤²à¥‡à¤Ÿà¤°',0),(159940,4443,'ms','Jejak Kalkulator',0),(159941,4443,'ar','Ø­Ø§Ø³Ø¨Ø© Ø§Ù„Ø§Ù†Ø·Ø¨Ø§Ø¹Ø§Øª',0),(159942,4443,'fr','Calculatrice d\'impressions',0),(159943,4443,'jp','åˆ·è¨ˆç®—æ©Ÿ',0),(159944,4443,'pt','Calculadora de impressÃµes',0),(159945,4443,'ru','Ð’Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸Ñ ÐºÐ°Ð»ÑŒÐºÑƒÐ»ÑÑ‚Ð¾Ñ€',0),(159946,4443,'es','Impresiones Calculador',0),(159947,4443,'de','Impressionen-Rechner',0),(159948,4443,'en','Impressions Calculator',0),(159949,4444,'is','',0),(159950,4444,'dr','ÙˆØ§Ù‚Ø¹ÙŠ Ø³Ø§Ø®ØªÙ† ',0),(159951,4444,'pr','ÙˆØ§Ù‚Ø¹ÙŠ Ø³Ø§Ø®ØªÙ† ',0),(159952,4444,'tr','Fiili deÄŸerler yapmak',0),(159953,4444,'pl','Aby wartoÅ›ci rzeczywistych',0),(159954,4444,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ñ‚ÐµÐºÑƒÑ‰Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(159955,4444,'ur','Ø§Ú©Ø§Ù„Ø³ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(159956,4444,'sr','ÐÐµÐºÐ° ÑÑ‚Ð°ÑšÐ°',0),(159957,4444,'vi','Thá»±c táº¿',0),(159958,4444,'af','Maak Actuals',0),(159959,4444,'ro','Face reale',0),(159960,4444,'et','Teha tegelikud nÃ¤itajad',0),(159961,4444,'si','Da opravljeno delo',0),(159962,4444,'ba','Membuat Actuals',0),(159963,4444,'nl','Maken van werkelijke waarden',0),(159964,4444,'fi','TehdÃ¤ todellisia arvoja',0),(159965,4444,'no','GjÃ¸re faktiske data',0),(159966,4444,'da','GÃ¸re faktiske oplysninger',0),(159967,4444,'ko','ì‹¤ì œ ë°ì´í„°ë¥¼ í™•ì¸',0),(159968,4444,'he','×œ×”×¤×•×š ××ª ×”× ×ª×•× ×™× ×‘×¤×•×¢×œ',0),(159969,4444,'el','ÎšÎ¬Î½ÎµÎ¹ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(159970,4444,'zh','å®žè´§\r\n',0),(159971,4444,'sv','GÃ¶ra verkliga vÃ¤rden',0),(159972,4444,'it','Rendere i valori effettivi',0),(159973,4444,'tl','',0),(159974,4444,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3649;&#3621;&#3632;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(159975,4444,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤¬à¤¨à¤¾à¤¨à¥‡',0),(159976,4444,'ms','Membuat Actuals',0),(159977,4444,'ar','Ø¬Ø¹Ù„ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ÙØ¹Ù„ÙŠ',0),(159978,4444,'fr','Faire des dÃ©penses rÃ©elles',0),(159979,4444,'jp','å®Ÿéš›ã?®ã‚‚ã?®ã?¨ã?™ã‚‹',0),(159980,4444,'pt','Tornar os dados efetivos',0),(159981,4444,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(159982,4444,'es','Hacer Actuales',0),(159983,4444,'de','Aktuelle Werte zu machen',0),(159984,4444,'en','Make Actuals',0),(159985,4445,'is','',0),(159986,4445,'dr','Ø§Ù†Ø¨Ø§Ø± Ù†Ø´Ø¯Ù‡ â€“ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ÙŠØ§ Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(159987,4445,'pr','Ø§Ù†Ø¨Ø§Ø± Ù†Ø´Ø¯Ù‡ â€“ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ÙŠØ§ Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(159988,4445,'tr','DeÄŸil Vended hisse senedi veya kapalÄ±',0),(159989,4445,'pl','Nie czas, nabyci przez opiekuna nr lub zamkniÄ™te',0),(159990,4445,'bg','ÐÐµ ÑÑŠÑÑ‚Ð°Ð², Vended Ð¸Ð»Ð¸ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(159991,4445,'ur','Ù†Û Ø§Ø³Ù¹Ø§Ú©ØŒ ÙˆØ§Ù†ÚˆÛŒØ¯ ÛŒØ§ Ø¨Ù†Ø¯',0),(159992,4445,'sr','ÐÐµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ, Ð½Ð°Ñ†Ñ€Ñ‚Ð°Ð½Ð¾ Ð¸Ð»Ð¸ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð°',0),(159993,4445,'vi','KhÃ´ng pháº£i hÃ ng tá»“n, Ä‘Ã£ bÃ¡n hay khÃ³a sá»•',0),(159994,4445,'af','Nie voorraad, Vended of gesluit',0),(159995,4445,'ro','Nu stoc, Vended sau Ã®nchise',0),(159996,4445,'et','Ei varu, Vended vÃµi suletud',0),(159997,4445,'si','Ne zaloge, Vended ali zaprta',0),(159998,4445,'ba','Tidak saham, Vended atau ditutup',0),(159999,4445,'nl','Geen voorraad, verkochte of gesloten',0),(160000,4445,'fi','Ei varastossa, Vended tai suljettu',0),(160001,4445,'no','Ikke lager, Vended eller lukket',0),(160002,4445,'da','Ikke materiel, Vended eller lukket',0),(160003,4445,'ko','ì•„ë‹ˆ ì£¼ì‹, Vended ë˜ëŠ” íì‡„',0),(160004,4445,'he','×œ× ×ž× ×™×•×ª, Vended ××• ×¡×’×•×¨×”',0),(160005,4445,'el','Î”ÎµÎ½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½, Vended Î® ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŒ',0),(160006,4445,'zh','ä¸ºåº“å­˜ï¼Œå‡ºå”®æˆ–å…³é—­\r\n',0),(160007,4445,'sv','Inte lager, Vended eller stÃ¤ngd',0),(160008,4445,'it','Stock, Vended o chiuso',0),(160009,4445,'tl','',0),(160010,4445,'th','&#3652;&#3617;&#3656;&#3626;&#3605;&#3655;&#3629;&#3585;,&#3586;&#3634;&#3618;&#3627;&#3619;&#3639;&#3629;&#3611;&#3636;&#3604;',0),(160011,4445,'hi','Vended à¤¯à¤¾ à¤¬à¤‚à¤¦ à¤•à¤° à¤¨à¤¹à¥€à¤‚ à¤¶à¥‡à¤¯à¤°,',0),(160012,4445,'ms','Bukan saham, Vended atau ditutup',0),(160013,4445,'ar','Ù„Ø§ Ø§Ù„Ø£Ø³Ù‡Ù… Ø£Ùˆ ÙÙŠÙ†Ø¯ÙŠØ¯ Ø£Ùˆ Ù…ØºÙ„Ù‚Ø©',0),(160014,4445,'fr','Pas de Stock, vendue ou fermÃ©e',0),(160015,4445,'jp','åœ¨åº«ã?ªã?—ã€?è²©å£²æ¸ˆã‚‚ã?—ã??ã?¯çµ‚äº†æ¸ˆ',0),(160016,4445,'pt','NÃ£o circulante, Vended ou fechado',0),(160017,4445,'ru','ÐÐµ Ð°ÐºÑ†Ð¸Ð¸, Vended Ð¸Ð»Ð¸ Ð·Ð°ÐºÑ€Ñ‹Ñ‚',0),(160018,4445,'es','No es Stock, Vendido o Cerrado',0),(160019,4445,'de','Nicht Lager, Vended oder geschlossen',0),(160020,4445,'en','Not Stock, Vended or Closed',0),(160021,4446,'is','',0),(160022,4446,'dr','Ù‚Ø¨ÙˆÙ„ ØªÙˆØ³Ø·',0),(160023,4446,'pr','Ù‚Ø¨ÙˆÙ„ ØªÙˆØ³Ø·',0),(160024,4446,'tr','TarafÄ±ndan Tamam',0),(160025,4446,'pl','OK przez',0),(160026,4446,'bg','ÐžÐš Ð¾Ñ‚',0),(160027,4446,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¹Ú¾ÛŒÚ©',0),(160028,4446,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ð¿Ð¾',0),(160029,4446,'vi','OK bá»Ÿi',0),(160030,4446,'af','Deur OK',0),(160031,4446,'ro','OK de',0),(160032,4446,'et','OK poolt',0),(160033,4446,'si','OK z',0),(160034,4446,'ba','OK oleh',0),(160035,4446,'nl','OK door',0),(160036,4446,'fi','OK mennessÃ¤',0),(160037,4446,'no','OK av',0),(160038,4446,'da','OK ved',0),(160039,4446,'ko','ì— ì˜í•´ í™•ì¸',0),(160040,4446,'he','×˜×•×‘ ×¢×œ-×™×“×™',0),(160041,4446,'el','ÎŸ.Îº. Î±Ï€ÏŒ',0),(160042,4446,'zh','ç¡®è®¤\r\n',0),(160043,4446,'sv','OK av',0),(160044,4446,'it','OK da',0),(160045,4446,'tl','',0),(160046,4446,'th','&#3605;&#3585;&#3621;&#3591;&#3650;&#3604;&#3618;',0),(160047,4446,'hi','à¤ à¥€à¤• à¤¹à¥ˆ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(160048,4446,'ms','OK oleh',0),(160049,4446,'ar','Ø·ÙŠØ¨ Ù‚Ø¨Ù„',0),(160050,4446,'fr','OK par',0),(160051,4446,'jp','ï½žã?«ã‚ˆã‚Šæ‰¿èª?',0),(160052,4446,'pt','OK, por',0),(160053,4446,'ru','ÐžÐš',0),(160054,4446,'es','OK Por',0),(160055,4446,'de','Von OK',0),(160056,4446,'en','OK By',0),(160057,4447,'is','',0),(160058,4447,'dr','Ù„Ø·ÙØ§ ØªØºÙŠÙŠØ±Ø§Øª Ø®ÙˆØ¯ Ø±Ø§ Ø°Ø®ÙŠØ±Ù‡ ÙŠØ§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯ ',0),(160059,4447,'pr','Ù„Ø·ÙØ§ ØªØºÙŠÙŠØ±Ø§Øª Ø®ÙˆØ¯ Ø±Ø§ Ø°Ø®ÙŠØ±Ù‡ ÙŠØ§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯ ',0),(160060,4447,'tr','LÃ¼tfen kaydedebilir veya deÄŸiÅŸikliklerinizi iptal etmek',0),(160061,4447,'pl','ProszÄ™ zapisaÄ‡ lub anulowaÄ‡ zmiany',0),(160062,4447,'bg','ÐœÐ¾Ð»Ñ Ð·Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¸Ð»Ð¸ Ð´Ð° Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(160063,4447,'ur','Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº ÛŒØ§ Ø¢Ù¾ Ú©ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº',0),(160064,4447,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ ÑÐ¿Ð°ÑÐ¸ Ð¸Ð»Ð¸ Ð¾Ñ‚ÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(160065,4447,'vi','Sao lÆ°u hay há»§y thay Ä‘á»•i cá»§a báº¡n',0),(160066,4447,'af','Stoor of Kanselleer asseblief U Veranderinge',0),(160067,4447,'ro','VÄƒ rugÄƒm sÄƒ salvaÅ£i sau anula modificÄƒrile',0),(160068,4447,'et','Palun salvesta vÃµi tÃ¼hista muudatused',0),(160069,4447,'si','Prosim shranite ali Å¾elite preklicati spremembe',0),(160070,4447,'ba','Harap menyimpan atau membatalkan perubahan Anda',0),(160071,4447,'nl','Gelieve te slaan of uw wijzigingen annuleren',0),(160072,4447,'fi','Tallenna tai Peruuta muutokset',0),(160073,4447,'no','Vennligst lagre eller avbryte endringene',0),(160074,4447,'da','Kan du gemme eller annullere Ã¦ndringer',0),(160075,4447,'ko','ì €ìž¥ í•˜ê±°ë‚˜ ë³€ê²½ ë‚´ìš©ì„ ì·¨ì†Œ í•˜ì‹­ì‹œì˜¤',0),(160076,4447,'he','× × ×©×ž×•×¨ ××• ×œ×‘×˜×œ ××ª ×”×©×™× ×•×™×™× ×©×‘×™×¦×¢×ª',0),(160077,4447,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Î® Î½Î± Î±ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚ ÏƒÎ±Ï‚',0),(160078,4447,'zh','è¯·ä¿å­˜æˆ–å–æ¶ˆæ‚¨çš„æ›´æ”¹\r\n',0),(160079,4447,'sv','VÃ¤nligen spara eller Ã¥ngra dina Ã¤ndringar',0),(160080,4447,'it','Si prega di salvare o annullare le modifiche',0),(160081,4447,'tl','',0),(160082,4447,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3627;&#3619;&#3639;&#3629;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3586;&#3',0),(160083,4447,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¾ à¤…à¤ªà¤¨à¥‡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¥‹à¤‚ à¤•à¥‹ à¤°à¤¦à¥à¤¦',0),(160084,4447,'ms','Sila simpan atau membatalkan perubahan anda',0),(160085,4447,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø­ÙØ¸ Ø£Ùˆ Ø¥Ù„ØºØ§Ø¡ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(160086,4447,'fr','S\'il vous plaÃ®t enregistrer ou annuler vos modifications',0),(160087,4447,'jp','å¤‰æ›´ã‚’ä¿?å­˜ã?‹ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?—ã?¦ã??ã? ã?•ã?„',0),(160088,4447,'pt','Por favor, salvar ou cancelar as alteraÃ§Ãµes',0),(160089,4447,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¸Ð»Ð¸ ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð’Ð°ÑˆÐ¸ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(160090,4447,'es','Por Favor Guardar o Cancelar Sus Cambios',0),(160091,4447,'de','Bitte speichern Sie oder Abbrechen Sie die Ã„nderungen',0),(160092,4447,'en','Please Save or Cancel Your Changes',0),(160093,4448,'is','',0),(160094,4448,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(160095,4448,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(160096,4448,'tr','YazdÄ±rma sÄ±rasÄ±nÄ± arama',0),(160097,4448,'pl','KolejnoÅ›Ä‡ drukowania wyszukiwania',0),(160098,4448,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(160099,4448,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(160100,4448,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(160101,4448,'vi','TÃ¬m Ä‘Æ¡n hÃ ng in',0),(160102,4448,'af','Druk orde opsoek',0),(160103,4448,'ro','Imprima ordinea Lookup',0),(160104,4448,'et','Printida tellimuse otsing',0),(160105,4448,'si','Vrstni red tiskanja za iskanje',0),(160106,4448,'ba','Pesanan cetakan Lookup',0),(160107,4448,'nl','Afdrukvolgorde Lookup',0),(160108,4448,'fi','TulostusjÃ¤rjestyksen haku',0),(160109,4448,'no','UtskriftsrekkefÃ¸lge oppslag',0),(160110,4448,'da','Udskrive ordre opslag',0),(160111,4448,'ko','ì¸ì‡„ ì£¼ë¬¸ ì¡°íšŒ',0),(160112,4448,'he','×‘×“×™×§×ª ×¡×“×¨ ×”×”×“×¤×¡×”',0),(160113,4448,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ‰Î½',0),(160114,4448,'zh','æ‰“å°è®¢å•æŸ¥æ‰¾\r\n',0),(160115,4448,'sv','Utskriftsordning Lookup',0),(160116,4448,'it','Ordine di stampa Lookup',0),(160117,4448,'tl','',0),(160118,4448,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(160119,4448,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤‘à¤°à¥à¤¡à¤° à¤²à¥à¤•à¤…à¤ª',0),(160120,4448,'ms','Lookup cetak',0),(160121,4448,'ar','Ø¨Ø­Ø« Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(160122,4448,'fr','Recherche de l\'ordre d\'impression',0),(160123,4448,'jp','å?°åˆ·æ³¨æ–‡æ¤œç´¢',0),(160124,4448,'pt','Pesquisa de ordem de impressÃ£o',0),(160125,4448,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ ÐŸÐ¾Ð¸ÑÐº',0),(160126,4448,'es','Busqueda del Orden de Imprimir',0),(160127,4448,'de','Druckreihenfolge Lookup',0),(160128,4448,'en','Print Order Lookup',0),(160129,4449,'is','',0),(160130,4449,'dr','Ø´Ø±Ø§ÙŠØ· Ø³Ù†Ø¯ ',0),(160131,4449,'pr','Ø´Ø±Ø§ÙŠØ· Ø³Ù†Ø¯ ',0),(160132,4449,'tr','KanÄ±t durumu',0),(160133,4449,'pl','Stan dowÃ³d',0),(160134,4449,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(160135,4449,'ur','Ø«Ø¨ÙˆØª Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(160136,4449,'sr','Ð”Ð¾ÐºÐ°Ð· ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(160137,4449,'vi','TÃ¬nh tráº¡ng Báº£n in thá»­',0),(160138,4449,'af','Bewys Status',0),(160139,4449,'ro','Dovada statutului',0),(160140,4449,'et','TÃµend staatuse',0),(160141,4449,'si','Dokaz Status',0),(160142,4449,'ba','Bukti Status',0),(160143,4449,'nl','Bewijs Status',0),(160144,4449,'fi','Todiste tila',0),(160145,4449,'no','Bevis Status',0),(160146,4449,'da','Bevis for Status',0),(160147,4449,'ko','ì¦ê±° ìƒíƒœ',0),(160148,4449,'he','×ž×¦×‘ ×”×•×›×—×”',0),(160149,4449,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(160150,4449,'zh','è¯æ˜Žåœ°ä½\r\n',0),(160151,4449,'sv','Bevis Status',0),(160152,4449,'it','Prova Status',0),(160153,4449,'tl','',0),(160154,4449,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(160155,4449,'hi','à¤¸à¤¬à¥‚à¤¤ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(160156,4449,'ms','Bukti Status',0),(160157,4449,'ar','Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰ Ø­Ø§Ù„Ø©',0),(160158,4449,'fr','Preuve de statut',0),(160159,4449,'jp','æ ¡æ­£çŠ¶æ³?',0),(160160,4449,'pt','Prova de Status',0),(160161,4449,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(160162,4449,'es','Status de la Prueba de ImpresiÃ³n',0),(160163,4449,'de','Beweis-Status',0),(160164,4449,'en','Proof Status',0),(160165,4450,'is','',0),(160166,4450,'dr','Ø¨Ø±Ú¯Ø´ØªÙŠ Ù‚Ø¨ÙˆÙ„ Ø§Ø³Øª ',0),(160167,4450,'pr','Ø¨Ø±Ú¯Ø´ØªÙŠ Ù‚Ø¨ÙˆÙ„ Ø§Ø³Øª ',0),(160168,4450,'tr','Tamam dÃ¶ndÃ¼',0),(160169,4450,'pl','PowrÃ³ciÅ‚ OK',0),(160170,4450,'bg','Ð’Ñ€ÑŠÑ‰Ð° Ð´Ð¾Ð±Ñ€Ðµ',0),(160171,4450,'ur','Ù¹Ú¾ÛŒÚ© ÛÛ’ Ù„ÙˆÙ¹ Ø¢Ø¦Û’',0),(160172,4450,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ð¾ ÑÐµ Ñƒ Ñ€ÐµÐ´Ñƒ',0),(160173,4450,'vi','Trá»Ÿ láº¡i OK',0),(160174,4450,'af','OK terug',0),(160175,4450,'ro','S-a Ã®ntors OK',0),(160176,4450,'et','Tagastab OK',0),(160177,4450,'si','Vrnjen redu',0),(160178,4450,'ba','Kembali OK',0),(160179,4450,'nl','OK geretourneerd',0),(160180,4450,'fi','Palauttaa OK',0),(160181,4450,'no','Returnerte OK',0),(160182,4450,'da','Returneret OK',0),(160183,4450,'ko','í™•ì¸ ë°˜í™˜',0),(160184,4450,'he','×—×–×¨×• ×‘×¡×“×¨',0),(160185,4450,'el','Î•Ï€Î­ÏƒÏ„ÏÎµÏˆÎµ ÎµÎ½Ï„Î¬Î¾ÎµÎ¹',0),(160186,4450,'zh','ç¡®è®¤è¿”å›ž\r\n',0),(160187,4450,'sv','Ã…tervÃ¤nde OK',0),(160188,4450,'it','Tornato OK',0),(160189,4450,'tl','',0),(160190,4450,'th','&#3605;&#3585;&#3621;&#3591;&#3588;&#3639;&#3609;',0),(160191,4450,'hi','à¤ à¥€à¤• à¤¹à¥ˆ à¤²à¥Œà¤Ÿ à¤†à¤',0),(160192,4450,'ms','Kembali OK',0),(160193,4450,'ar','Ø¹Ø§Ø¯ Ø·ÙŠØ¨',0),(160194,4450,'fr','Retour OK',0),(160195,4450,'jp','è¿”å?´ãƒ¼å¤‰æ›´ã?ªã?—',0),(160196,4450,'pt','Retornado OK',0),(160197,4450,'ru','Ð’ÐµÑ€Ð½ÑƒÐ»ÑÑ ÐžÐš',0),(160198,4450,'es','Regresado OK',0),(160199,4450,'de','OK zurÃ¼ckgegeben',0),(160200,4450,'en','Returned OK',0),(160201,4451,'is','',0),(160202,4451,'dr','ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(160203,4451,'pr','ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(160204,4451,'tr','DÃ¶ndÃ¼rÃ¼len gÃ¶zden geÃ§ir',0),(160205,4451,'pl','ZwrÃ³cone zmiany',0),(160206,4451,'bg','Ð’ÑŠÑ€Ð½Ð°Ñ‚Ð¸Ñ‚Ðµ Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(160207,4451,'ur','ÙˆØ§Ù¾Ø³ÛŒ Ù¾Ø± Ø¨Ú¾ÛŒ Ù†Ø¸Ø±Ù Ø«Ø§Ù†ÛŒ',0),(160208,4451,'sr','Ð’Ñ€Ð°Ñ›ÐµÐ½Ð¸ Ñ€ÐµÐ²Ð¸Ð´Ð¸Ñ€Ð°Ñ‚Ð¸',0),(160209,4451,'vi','Chá»‰nh sá»­a Trá»Ÿ láº¡i',0),(160210,4451,'af','Teruggestuurde hersien',0),(160211,4451,'ro','Returnate revizuire',0),(160212,4451,'et','Tagastatud Ã¼le vaatama',0),(160213,4451,'si','Vrnjeno Preglej',0),(160214,4451,'ba','Kembali merevisi',0),(160215,4451,'nl','Geretourneerde herzien',0),(160216,4451,'fi','Palautettu tarkistaa',0),(160217,4451,'no','Returnerte revidere',0),(160218,4451,'da','Returnerede revidere',0),(160219,4451,'ko','ë°˜í™˜ ëœ ê°œì •',0),(160220,4451,'he','×ª×§×Ÿ ×”×ž×•×—×–×¨',0),(160221,4451,'el','Î•Ï€Î±Î½ÎµÎ¹ÏƒÎ±Î³ÏŒÎ¼ÎµÎ½Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(160222,4451,'zh','è¿”å›žä¿®æ”¹\r\n',0),(160223,4451,'sv','Returnerade revidera',0),(160224,4451,'it','Rivedere restituito',0),(160225,4451,'tl','',0),(160226,4451,'th','&#3585;&#3634;&#3619;&#3585;&#3621;&#3633;&#3610;&#3617;&#3634;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(160227,4451,'hi','à¤²à¥Œà¤Ÿà¥‡ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨',0),(160228,4451,'ms','Dikembalikan atas berubah',0),(160229,4451,'ar','ØªÙ†Ù‚Ø­ Ø¹Ø§Ø¯',0),(160230,4451,'fr','Revise retournÃ©',0),(160231,4451,'jp','è¿”å?´ãƒ¼å¤‰æ›´æœ‰ã‚Š',0),(160232,4451,'pt','Revisar retornado',0),(160233,4451,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð½Ñ‹Ð¹ Ð¿ÐµÑ€ÐµÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ',0),(160234,4451,'es','Regresado Revisar',0),(160235,4451,'de','ZurÃ¼ckgegebene Ã¼berarbeiten',0),(160236,4451,'en','Returned Revise',0),(160237,4452,'is','',0),(160238,4452,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø¨Ø¯ÙˆÙ† Ù‚ÙŠÙ…Øª ÙƒÙ„',0),(160239,4452,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø¨Ø¯ÙˆÙ† Ù‚ÙŠÙ…Øª ÙƒÙ„',0),(160240,4452,'tr','Toplam fiyat ile Kaydet',0),(160241,4452,'pl','Zapisz nie cena caÅ‚kowita',0),(160242,4452,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð±ÐµÐ· Ð¾Ð±Ñ‰Ð° Ñ†ÐµÐ½Ð°',0),(160243,4452,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ù„ Ù‚ÛŒÙ…Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(160244,4452,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜Ñ‚Ðµ Ð½ÐµÐ¼Ð° ÑƒÐºÑƒÐ¿Ð½Ð° Ñ†ÐµÐ½Ð°',0),(160245,4452,'vi','Sao lÆ°u khÃ´ng cÃ³ tá»•ng giÃ¡',0),(160246,4452,'af','Stoor met geen totale prys',0),(160247,4452,'ro','SalvaÅ£i cu nici un preÅ£ Total',0),(160248,4452,'et','Salvestage Hind kokku',0),(160249,4452,'si','Shranite s ni skupna cena',0),(160250,4452,'ba','Simpan dengan Total harga',0),(160251,4452,'nl','Opslaan met geen totale prijs',0),(160252,4452,'fi','Tallenna ei kokonaishinta',0),(160253,4452,'no','Lagre med ingen salgsbelÃ¸p',0),(160254,4452,'da','Gem med ingen samlede pris',0),(160255,4452,'ko','ì´ ê°€ê²©ìœ¼ë¡œ ì €ìž¥',0),(160256,4452,'he','×œ×©×ž×•×¨ ×¢× ××™×Ÿ ×ž×—×™×¨',0),(160257,4452,'el','Î•ÎºÏ„ÏŒÏ‚ Î±Ï€ÏŒ Î¼Îµ Î´ÎµÎ½ ÏƒÏ…Î½.Ï„Î¹Î¼Î®',0),(160258,4452,'zh','ä¿å­˜åœ¨æ²¡æœ‰æ€»ä»·æ ¼\r\n',0),(160259,4452,'sv','Spara med ingen totalpris',0),(160260,4452,'it','Salvare senza prezzo totale',0),(160261,4452,'tl','',0),(160262,4452,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3588;&#3634;&#3619;&#3623;&#3617;',0),(160263,4452,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤² à¤•à¥€à¤®à¤¤ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(160264,4452,'ms','Simpan dengan tiada harga jumlah',0),(160265,4452,'ar','Ø­ÙØ¸ Ù…Ø¹ Ù„Ø§ Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(160266,4452,'fr','Enregistrer sans prix Total',0),(160267,4452,'jp','å?ˆè¨ˆä¾¡æ ¼ã?®ã?ªã?„ã?¾ã?¾ä¿?å­˜ã?™ã‚‹',0),(160268,4452,'pt','Salvar sem preÃ§o Total',0),(160269,4452,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ñ Ð½Ðµ ÐžÐ±Ñ‰Ð°Ñ Ñ†ÐµÐ½Ð°',0),(160270,4452,'es','Guardar Sin Precio Total',0),(160271,4452,'de','Sparen Sie mit kein Gesamtpreis',0),(160272,4452,'en','Save With No Total Price',0),(160273,4453,'is','',0),(160274,4453,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ Ù…Ø®ØªÙ„Ù',0),(160275,4453,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ Ù…Ø®ØªÙ„Ù',0),(160276,4453,'tr','FarklÄ± bir dÃ¼zen seÃ§in',0),(160277,4453,'pl','Wybierz inny porzÄ…dek',0),(160278,4453,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ€Ð°Ð·Ð»Ð¸Ñ‡ÐµÐ½ Ñ€ÐµÐ´',0),(160279,4453,'ur','Ù…Ø®ØªÙ„Ù ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(160280,4453,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð¸Ñ‚Ðµ',0),(160281,4453,'vi','Chá»n cÃ¡c Ä‘Æ¡n hÃ ng khÃ¡c nhau',0),(160282,4453,'af','Selekteer \'n Ander Bestelling',0),(160283,4453,'ro','SelectaÅ£i diferite ordine',0),(160284,4453,'et','Valige teises jÃ¤rjekorras',0),(160285,4453,'si','Izberite razliÄnih nalog',0),(160286,4453,'ba','Pilih urutan berbeda',0),(160287,4453,'nl','Selecteer verschillende Order',0),(160288,4453,'fi','Valitse eri jÃ¤rjestyksessÃ¤',0),(160289,4453,'no','Velg rekkefÃ¸lgen',0),(160290,4453,'da','VÃ¦lg anden rÃ¦kkefÃ¸lge',0),(160291,4453,'ko','ë‹¤ë¥¸ ìˆœì„œë¥¼ ì„ íƒ',0),(160292,4453,'he','×‘×—×¨ ×”×–×ž× ×” ××—×¨×ª',0),(160293,4453,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÎ® ÏƒÎµÎ¹ÏÎ¬',0),(160294,4453,'zh','é€‰æ‹©ä¸åŒçš„é¡ºåº\r\n',0),(160295,4453,'sv','VÃ¤lj annan ordning',0),(160296,4453,'it','Selezionare ordine diverso',0),(160297,4453,'tl','',0),(160298,4453,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3649;&#3605;&#3585;&#3605;&#3656;&#3634;&#3591;',0),(160299,4453,'hi','à¤…à¤²à¤— à¤…à¤²à¤— à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(160300,4453,'ms','Pilih pesanan yang berbeza',0),(160301,4453,'ar','Ø­Ø¯Ø¯ ØªØ±ØªÙŠØ¨ Ù…Ø®ØªÙ„Ù',0),(160302,4453,'fr','SÃ©lectionnez ordre diffÃ©rent',0),(160303,4453,'jp','åˆ¥ã?®æ³¨æ–‡ã‚’é?¸æŠž',0),(160304,4453,'pt','Selecione ordem diferente',0),(160305,4453,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð¹ Ð—Ð°ÐºÐ°Ð·',0),(160306,4453,'es','Seleccionar Orden Diferente',0),(160307,4453,'de','WÃ¤hlen Sie anderen Reihenfolge',0),(160308,4453,'en','Select Different Order',0),(160309,4454,'is','',0),(160310,4454,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´  Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª Ø²Ù…Ø§Ù†  Ùˆ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(160311,4454,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´  Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª Ø²Ù…Ø§Ù†  Ùˆ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(160312,4454,'tr','Zaman & malzeme giriÅŸ sÄ±rayÄ± seÃ§in',0),(160313,4454,'pl','Wybierz aby czas & materiaÅ‚Ã³w wejÅ›cia',0),(160314,4454,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð²Ñ€ÐµÐ¼Ðµ & Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð·Ð°Ð¿Ð¸Ñ',0),(160315,4454,'ur','Ø¢Ø±ÚˆØ± ÙˆÙ‚Øª & Ù…ÙˆØ§Ø¯ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(160316,4454,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð²Ñ€ÐµÐ¼Ðµ & Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(160317,4454,'vi','Chá»n ÄÆ¡n HÃ ng Cho Entry Thá»i Gian & NguyÃªn Váº­t Liá»‡u',0),(160318,4454,'af','Selekteer Bestelling vir Tyd en Materiaal Inskrywing',0),(160319,4454,'ro','SelectaÅ£i comanda pentru timp & materiale de intrare',0),(160320,4454,'et','Valige selleks aega & materjalide kanne',0),(160321,4454,'si','Izberite nalog za Äas & vnos materialov',0),(160322,4454,'ba','Pilih agar waktu & bahan entri',0),(160323,4454,'nl','Selecteer Order voor tijd & materialen post',0),(160324,4454,'fi','Valitse jotta aika & materiaalien merkintÃ¤',0),(160325,4454,'no','Velg rekkefÃ¸lge for tiden & materialer oppfÃ¸ring',0),(160326,4454,'da','VÃ¦lge orden for tid & materialer post',0),(160327,4454,'ko','ìœ„í•´ì„œ ì‹œê°„ & ìžë£Œ í•­ëª© ì„ íƒ',0),(160328,4454,'he','×‘×—×¨ ×¡×“×¨ ×¢×‘×•×¨ ×–×ž×Ÿ & ×—×•×ž×¨×™ ×”×–× ×”',0),(160329,4454,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÏƒÎµÎ¹ÏÎ¬ Î³Î¹Î± Ï‡ÏÏŒÎ½Î¿ & Ï…Î»Î¹ÎºÎ¬ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(160330,4454,'zh','é€‰æ‹©è®¢å•çš„æ—¶é—´ä¸Žææ–™æ¡ç›®\r\n',0),(160331,4454,'sv','VÃ¤lj fÃ¶r tid & material intrÃ¤de',0),(160332,4454,'it','Selezionare l\'ordine per tempo & entrata materiali',0),(160333,4454,'tl','',0),(160334,4454,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3648;&#3623;&#3621;&#3634; & &#3611;&#3657;&#3629;&#3609;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(160335,4454,'hi','à¤¸à¤®à¤¯ & à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(160336,4454,'ms','Pilih pesanan bagi masa & kemasukan bahan-bahan',0),(160337,4454,'ar','Ø­Ø¯Ø¯ ØªØ±ØªÙŠØ¨ Ù„Ù„ÙˆÙ‚Øª Ø¢Ù†Ø¯ Ø¯Ø®ÙˆÙ„ Ø§Ù„Ù…ÙˆØ§Ø¯',0),(160338,4454,'fr','SÃ©lectionnez ordre de temps & l\'entrÃ©e de matÃ©riaux',0),(160339,4454,'jp','æ™‚é–“ã?¨æ??æ–™ã?®å…¥åŠ›æ³¨æ–‡ã‚’é?¸æŠž',0),(160340,4454,'pt','Selecione ordem para tempo & entrada de materiais',0),(160341,4454,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð· Ð´Ð»Ñ Ð’Ð²Ð¾Ð´Ð° Ð’Ñ€ÐµÐ¼ÐµÐ½Ð¸ & ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð²',0),(160342,4454,'es','Seleccionar Orden para la Entrada de Tiempo y Materiales',0),(160343,4454,'de','Auftrag fÃ¼r Zeit & Materialien-Eintrag auswÃ¤hlen',0),(160344,4454,'en','Select Order for Time & Materials Entry',0),(160345,4455,'is','',0),(160346,4455,'dr','( Ø§Ø±Ø³Ø§Ù„ )Ø¨Ù‡ Ù†Ø§Ù… ',0),(160347,4455,'pr','Ø­Ù…Ù„( Ø§Ø±Ø³Ø§Ù„ )Ø¨Ù‡ Ù†Ø§Ù… ',0),(160348,4455,'tr','Sevk yeri adÄ±',0),(160349,4455,'pl','Nazwa odbiorcy',0),(160350,4455,'bg','Ð˜Ð¼Ðµ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(160351,4455,'ur','Ø¬ÛØ§Ø² Ú©Û’ Ù†Ø§Ù…',0),(160352,4455,'sr','Ð˜Ð¼Ðµ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(160353,4455,'vi','Chuyá»ƒn Ä‘áº¿n tÃªn',0),(160354,4455,'af','Versend Na Staat (Landsgebied)',0),(160355,4455,'ro','Livrare-la nume',0),(160356,4455,'et','Tarnida nimele',0),(160357,4455,'si','Imena dobave',0),(160358,4455,'ba','Kapal ke nama',0),(160359,4455,'nl','Verzendnaam',0),(160360,4455,'fi','Toimitusasiakkaan nimi',0),(160361,4455,'no','Lever til-navn',0),(160362,4455,'da','Leveringsnavnet',0),(160363,4455,'ko','ìš´ì†¡ì§€ ì´ë¦„',0),(160364,4455,'he','×œ×ž×©×œ×•×— ×©×',0),(160365,4455,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ Î¿Î½Î¿Î¼Î±ÏƒÎ¯Î±',0),(160366,4455,'zh','æ”¶è´§åç§°\r\n',0),(160367,4455,'sv','Leveransnamnet',0),(160368,4455,'it','Spedire a nome',0),(160369,4455,'tl','',0),(160370,4455,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3594;&#3639;&#3656;&#3629;',0),(160371,4455,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤¨à¤¾à¤®',0),(160372,4455,'ms','Kapal untuk nama',0),(160373,4455,'ar','Ø§Ø³Ù… Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(160374,4455,'fr','Nom du navire d\'',0),(160375,4455,'jp','é…?é€?å…ˆå??',0),(160376,4455,'pt','Nome do navio-a',0),(160377,4455,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÑÑƒÐ´Ð½Ð°',0),(160378,4455,'es','Enviar-A Nombre',0),(160379,4455,'de','Lieferadresse Name',0),(160380,4455,'en','Ship-to Name',0),(160381,4456,'is','',0),(160382,4456,'dr','ØªØ¹ÙŠÙŠÙ† Ø¢Ø®Ø±ÙŠÙ† Ø¯Ù„ÙŠÙ„ ØªØ­ÙˆÙŠÙ„',0),(160383,4456,'pr','ØªØ¹ÙŠÙŠÙ† Ø¢Ø®Ø±ÙŠÙ† Ø¯Ù„ÙŠÙ„ ØªØ­ÙˆÙŠÙ„',0),(160384,4456,'tr','GeÃ§ Teslimat nedeni belirtin',0),(160385,4456,'pl','OkreÅ›l koniec powodu dostawy',0),(160386,4456,'bg','Ð£ÐºÐ°Ð¶ÐµÑ‚Ðµ ÐºÑ€Ð°Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(160387,4456,'ur','Ù…Ø±Ø­ÙˆÙ… Ú©ÛŒ Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú©ÛŒ ÙˆØ¬Û Ú©Ø§ Ø§Ø®ØªØµØ§Øµ Ú©Ø±ÛŒÚº',0),(160388,4456,'sr','ÐÐ°Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ°ÑÐ½Ð¾ Ñ€Ð°Ð·Ð»Ð¾Ð³ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(160389,4456,'vi','Cá»¥ thá»ƒ 1 nguyÃªn nhÃ¢n giao hÃ ng muá»™n',0),(160390,4456,'af','Laat lewering rede spesifiseer',0),(160391,4456,'ro','SpecificaÅ£i motivul pentru livrare Ã®ntÃ¢rziere',0),(160392,4456,'et','MÃ¤Ã¤rake hilja TarnepÃµhjuse',0),(160393,4456,'si','Navedite razlog za pozno dostavo',0),(160394,4456,'ba','Menentukan akhir pengiriman alasan',0),(160395,4456,'nl','Late levering reden opgeven',0),(160396,4456,'fi','MÃ¤Ã¤ritÃ¤ myÃ¶hÃ¤ssÃ¤ toimituksen syy',0),(160397,4456,'no','Angi slutten LeveringsÃ¥rsaken',0),(160398,4456,'da','Angive slutningen leveringsÃ¥rsagen',0),(160399,4456,'ko','ëŠ¦ê²Œ ì „ë‹¬ ì´ìœ ë¥¼ ì§€ì •í•˜ì‹œì˜¤',0),(160400,4456,'he','×œ×¦×™×™×Ÿ ×¡×™×‘×” ×ž×©×œ×•×— ×ž××•×—×¨',0),(160401,4456,'el','ÎšÎ±Î¸Î¿ÏÎ¯ÏƒÎµÏ„Îµ Ï„Î­Î»Î· Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ· Î»ÏŒÎ³Î¿Ï‚',0),(160402,4456,'zh','æŒ‡å®šäº¤è´§è¿Ÿå»¶çš„åŽŸå› \r\n',0),(160403,4456,'sv','Ange sena leveransorsaken',0),(160404,4456,'it','Specificare il motivo di consegna tardiva',0),(160405,4456,'tl','',0),(160406,4456,'th','&#3619;&#3632;&#3610;&#3640;&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3626;&#3656;&#3591;&#3607;&#3637;&#3656;&#3621;&#3656;&#3634;&#3594;&#3657;&#3634;',0),(160407,4456,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤ªà¥à¤°à¤¸à¤µ à¤•à¤¾à¤°à¤£ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(160408,4456,'ms','Tentukan lewat penghantaran sebab',0),(160409,4456,'ar','ØªØ­Ø¯ÙŠØ¯ Ø³Ø¨Ø¨ Ø§Ù„ØªØ³Ù„ÙŠÙ… Ø§Ù„Ù…ØªØ£Ø®Ø±',0),(160410,4456,'fr','SpÃ©cifier la raison de livraison tardive',0),(160411,4456,'jp','ç´?å“?é?…å»¶ç?†ç”±ã?®ç‰¹å®š',0),(160412,4456,'pt','Especificar o motivo de entrega atrasada',0),(160413,4456,'ru','Ð£ÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ñƒ Ð¿Ð¾Ð·Ð´Ð½ÐµÐ¹ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(160414,4456,'es','Especificar RazÃ³n de Entrega Demorosa',0),(160415,4456,'de','VerspÃ¤tete Lieferung Grund angeben',0),(160416,4456,'en','Specify Late Delivery Reason',0),(160417,4457,'is','',0),(160418,4457,'dr','Ø´Ø±ÙˆØ¹',0),(160419,4457,'pr','Ø´Ø±ÙˆØ¹',0),(160420,4457,'tr','BaÅŸlat',0),(160421,4457,'pl','Start',0),(160422,4457,'bg','Ð¡Ñ‚Ð°Ñ€Ñ‚',0),(160423,4457,'ur','Ø´Ø±ÙˆØ¹ Ú©Ø±ÛŒÚº',0),(160424,4457,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº',0),(160425,4457,'vi','Báº¯t Äáº§u',0),(160426,4457,'af','Begin',0),(160427,4457,'ro','ÃŽncepe',0),(160428,4457,'et','Start',0),(160429,4457,'si','ZaÄetek',0),(160430,4457,'ba','Mulai',0),(160431,4457,'nl','Start',0),(160432,4457,'fi','KÃ¤ynnistÃ¤',0),(160433,4457,'no','Start',0),(160434,4457,'da','Start',0),(160435,4457,'ko','ì‹œìž‘',0),(160436,4457,'he','×”×ª×—×œ',0),(160437,4457,'el','ÎˆÎ½Î±ÏÎ¾Î·',0),(160438,4457,'zh','å¼€å§‹\r\n',0),(160439,4457,'sv','Start',0),(160440,4457,'it','Inizio',0),(160441,4457,'tl','',0),(160442,4457,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(160443,4457,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤•à¤°à¥‡à¤‚',0),(160444,4457,'ms','Mula',0),(160445,4457,'ar','Ø¨Ø¯Ø¡ ØªØ´ØºÙŠÙ„',0),(160446,4457,'fr','DÃ©but',0),(160447,4457,'jp','ã‚¹ã‚¿ãƒ¼ãƒˆ',0),(160448,4457,'pt','InÃ­cio',0),(160449,4457,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾',0),(160450,4457,'es','Comenzar',0),(160451,4457,'de','Start',0),(160452,4457,'en','Start',0),(160453,4458,'is','',0),(160454,4458,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(160455,4458,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(160456,4458,'tr','SeÃ§ili stok',0),(160457,4458,'pl','Czas wybrane',0),(160458,4458,'bg','Ð¡ÑŠÑÑ‚Ð°Ð², Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(160459,4458,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ø§Ø³Ù¹Ø§Ú©',0),(160460,4458,'sr','ÐÐºÑ†Ð¸Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½',0),(160461,4458,'vi','HÃ ng tá»“n Ä‘Ã£ chá»n',0),(160462,4458,'af','Voorraad gekies',0),(160463,4458,'ro','Stoc selectate',0),(160464,4458,'et','Ladu valitud',0),(160465,4458,'si','Zalog, izbrana',0),(160466,4458,'ba','Saham yang dipilih',0),(160467,4458,'nl','Voorraad geselecteerd',0),(160468,4458,'fi','Varastossa valittu',0),(160469,4458,'no','Lager valgt',0),(160470,4458,'da','Lager valgte',0),(160471,4458,'ko','ì£¼ì‹ ì„ íƒ',0),(160472,4458,'he','×”×ž× ×™×•×ª ×©× ×‘×—×¨×•',0),(160473,4458,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(160474,4458,'zh','å·²é€‰çš„åº“å­˜\r\n',0),(160475,4458,'sv','Lager markerad',0),(160476,4458,'it','Magazzino selezionato',0),(160477,4458,'tl','',0),(160478,4458,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(160479,4458,'hi','à¤¶à¥‡à¤¯à¤° à¤•à¤¾ à¤šà¤¯à¤¨',0),(160480,4458,'ms','Saham yang dipilih',0),(160481,4458,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(160482,4458,'fr','Stock sÃ©lectionnÃ©',0),(160483,4458,'jp','é?¸æŠžã?•ã‚Œã?Ÿåœ¨åº«',0),(160484,4458,'pt','Estoque selecionado',0),(160485,4458,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð°Ñ',0),(160486,4458,'es','Stock Seleccionado',0),(160487,4458,'de','Lager ausgewÃ¤hlt',0),(160488,4458,'en','Stock Selected',0),(160489,4459,'is','',0),(160490,4459,'dr','ØªÙˆÙ‚Ù',0),(160491,4459,'pr','ØªÙˆÙ‚Ù',0),(160492,4459,'tr','Durdur',0),(160493,4459,'pl','Przystanek',0),(160494,4459,'bg','Ð¡Ñ‚Ð¾Ð¿',0),(160495,4459,'ur','Ø±ÙˆÚ©',0),(160496,4459,'sr','ÐŸÑ€ÐµÑÑ‚Ð°Ð½Ð¸',0),(160497,4459,'vi','Dá»«ng láº¡i',0),(160498,4459,'af','Stop',0),(160499,4459,'ro','opreÅŸte-te',0),(160500,4459,'et','Stopp',0),(160501,4459,'si','ustavi se',0),(160502,4459,'ba','Stop',0),(160503,4459,'nl','Stop',0),(160504,4459,'fi','Seis',0),(160505,4459,'no','stopp',0),(160506,4459,'da','Stop',0),(160507,4459,'ko','ì¤‘ì§€',0),(160508,4459,'he','×¢×¦×•×¨',0),(160509,4459,'el','Î£Ï„Î±Î¼Î¬Ï„Î±',0),(160510,4459,'zh','åœæ­¢\r\n',0),(160511,4459,'sv','Stanna',0),(160512,4459,'it','Fermata',0),(160513,4459,'tl','',0),(160514,4459,'th','&#3627;&#3618;&#3640;&#3604;',0),(160515,4459,'hi','à¤°à¥à¤•à¥‹',0),(160516,4459,'ms','Berhenti',0),(160517,4459,'ar','ÙˆÙ‚Ù',0),(160518,4459,'fr','ArrÃªt',0),(160519,4459,'jp','ã‚¹ãƒˆãƒƒãƒ—',0),(160520,4459,'pt','Parar',0),(160521,4459,'ru','ÐžÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ°',0),(160522,4459,'es','Suspender',0),(160523,4459,'de','Stop',0),(160524,4459,'en','Stop',0),(160525,4460,'is','',0),(160526,4460,'dr','Ø¨Ø±Ø§ÙŠ ØªÙ‡ÙŠÙ‡ Ú©Ø±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(160527,4460,'pr','Ø¨Ø±Ø§ÙŠ ØªÙ‡ÙŠÙ‡ Ú©Ø±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(160528,4460,'tr','Bill iÃ§in',0),(160529,4460,'pl','Do rachunku',0),(160530,4460,'bg','ÐšÑŠÐ¼ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(160531,4460,'ur','Ø¨Ù„ Ù…ÛŒÚº',0),(160532,4460,'sr','Ð‘Ð¸Ð»Ñƒ',0),(160533,4460,'vi','Äá»ƒ Ra HÃ³a ÄÆ¡n',0),(160534,4460,'af','Om die Wetsontwerp',0),(160535,4460,'ro','La factura',0),(160536,4460,'et','Bill',0),(160537,4460,'si','Bill',0),(160538,4460,'ba','Untuk tagihan',0),(160539,4460,'nl','Bill',0),(160540,4460,'fi','Bill',0),(160541,4460,'no','Bill',0),(160542,4460,'da','Til Bill',0),(160543,4460,'ko','ë¹Œ',0),(160544,4460,'he','×œ×‘×™×œ',0),(160545,4460,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(160546,4460,'zh','å¸å•\r\n',0),(160547,4460,'sv','Till Bill',0),(160548,4460,'it','A Bill',0),(160549,4460,'tl','',0),(160550,4460,'th','&#3606;&#3638;&#3591;&#3610;&#3636;&#3621;',0),(160551,4460,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²',0),(160552,4460,'ms','Kepada Rang undang-undang',0),(160553,4460,'ar','Ù„Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ†',0),(160554,4460,'fr','Projet de loi',0),(160555,4460,'jp','è«‹æ±‚',0),(160556,4460,'pt','Para Bill',0),(160557,4460,'ru','Ð”Ð»Ñ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(160558,4460,'es','A Factrurar',0),(160559,4460,'de','Bill',0),(160560,4460,'en','To Bill',0),(160561,4461,'is','',0),(160562,4461,'dr','. Ø®Ø·Ø§ Ø¯Ø± Ù…Ø±Ø­Ù„Ù‡ ',0),(160563,4461,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ØºÙˆ Ø´Ø¯ . Ø®Ø·Ø§ Ø¯Ø± Ù…Ø±Ø­Ù„Ù‡ ',0),(160564,4461,'tr','GÃ¼ncelleme iptal edildi: adÄ±mda hata',0),(160565,4461,'pl','Aktualizacja odwoÅ‚any: bÅ‚Ä…d w kroku',0),(160566,4461,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ: Ð³Ñ€ÐµÑˆÐºÐ° Ð² ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(160567,4461,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒ: Ù…Ø±Ø­Ù„Û Ù…ÛŒÚº Ù†Ù‚Øµ',0),(160568,4461,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ð½ Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð¾: Ð³Ñ€ÐµÑˆÐºÐ° Ñƒ ÐºÐ¾Ñ€Ð°ÐºÑƒ',0),(160569,4461,'vi','Cáº­p nháº­t há»§y bá»: Bá»‹ lá»—i',0),(160570,4461,'af','Opdatering Gekanseleer:  Fout ontstaan in Stap',0),(160571,4461,'ro','Actualizat anulate: eroare Ã®n pas',0),(160572,4461,'et','Uuendatud tÃ¼histatud: viga samm',0),(160573,4461,'si','Posodobljena odpovedan: Napaka v korak',0),(160574,4461,'ba','Diperbarui dibatalkan: kesalahan dalam langkah',0),(160575,4461,'nl','Bijgewerkt geannuleerd: fout in stap',0),(160576,4461,'fi','PÃ¤ivitetty peruutetaan: virhe vaiheessa',0),(160577,4461,'no','Oppdatert avbrutt: feil i trinn',0),(160578,4461,'da','Opdateret aflyst: fejl i trin',0),(160579,4461,'ko','ì—…ë°ì´íŠ¸ ì·¨ì†Œ: ë‹¨ê³„ì—ì„œ ì˜¤ë¥˜ê°€',0),(160580,4461,'he','×¢×“×›×•×Ÿ ×‘×•×˜×œ: ×©×’×™××” ×‘×©×œ×‘',0),(160581,4461,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±ÎºÏ…ÏÏ‰Î¸ÎµÎ¯: ÏƒÏ†Î¬Î»Î¼Î± ÏƒÏ„Î¿ Î²Î®Î¼Î±',0),(160582,4461,'zh','æ›´æ–°å–æ¶ˆï¼šé”™è¯¯çš„æ­¥éª¤\r\n',0),(160583,4461,'sv','Uppdaterad annulleras: fel i steg',0),(160584,4461,'it','Aggiornato annullato: errore nel passaggio',0),(160585,4461,'tl','',0),(160586,4461,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;:&#3586;&#3633;&#3657;&#3609;&#3605;&#3629;&#3609;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(160587,4461,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤°à¤¦à¥à¤¦: à¤šà¤°à¤£ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(160588,4461,'ms','Dikemaskini dibatalkan: ralat dalam langkah',0),(160589,4461,'ar','ØªØ­Ø¯ÙŠØ« ØªÙ… Ø¥Ù„ØºØ§Ø¡: Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø®Ø·ÙˆØ©',0),(160590,4461,'fr','Mise Ã  jour annulÃ©e : erreur Ã  l\'Ã©tape',0),(160591,4461,'jp','æ›´æ–°ã?Œã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?•ã‚Œã?¾ã?—ã?Ÿï¼šå‡¦ç?†ä¸­ã‚¨ãƒ©ãƒ¼',0),(160592,4461,'pt','Atualizado cancelada: erro na etapa',0),(160593,4461,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹: ÐžÑˆÐ¸Ð±ÐºÐ° Ð² Ð¨Ð°Ð³Ðµ',0),(160594,4461,'es','Actualizaciones Canceladas: Error en Paso',0),(160595,4461,'de','Updated abgesagt: Fehler im Schritt',0),(160596,4461,'en','Updated Cancelled: Error in Step',0),(160597,4462,'is','',0),(160598,4462,'dr','(Ø§Ø±Ø³Ø§Ù„ ) Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(160599,4462,'pr','Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø­Ù…Ù„ (Ø§Ø±Ø³Ø§Ù„ ) Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(160600,4462,'tr','SipariÅŸ sevk',0),(160601,4462,'pl','ZamÃ³wienie zostaÅ‚o wysÅ‚ane',0),(160602,4462,'bg','Ð’Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ðµ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð°',0),(160603,4462,'ur','Ø¢Ù¾ Ø­Ú©Ù… Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(160604,4462,'sr','Ð¢Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½',0),(160605,4462,'vi','ÄÆ¡n hÃ ng cá»§a báº¡n Ä‘Ã£ chuyá»ƒn',0),(160606,4462,'af','U BESTELLING is VERSEND.',0),(160607,4462,'ro','Comanda dumneavoastra a fost expediata',0),(160608,4462,'et','Teie tellimus on lÃ¤hetatud',0),(160609,4462,'si','Ste nalog Å¾e dobavili',0),(160610,4462,'ba','Pesanan Anda telah dikirim',0),(160611,4462,'nl','U bestelling is verzonden',0),(160612,4462,'fi','Sinun tilaus on toimitettu',0),(160613,4462,'no','Du har blitt bestilt',0),(160614,4462,'da','Du bestiller er blevet afsendt',0),(160615,4462,'ko','ì£¼ë¬¸ ì¶œí•˜',0),(160616,4462,'he','×”×”×–×ž× ×” × ×©×œ×—×”',0),(160617,4462,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÎ±Ï‚ Î­Ï‡ÎµÎ¹ Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯',0),(160618,4462,'zh','æ‚¨çš„è®¢å•å·²å‘è´§\r\n',0),(160619,4462,'sv','Du bestÃ¤ller har levererats',0),(160620,4462,'it','Ãˆ l\'ordine Ã¨ stato spedito',0),(160621,4462,'tl','',0),(160622,4462,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(160623,4462,'hi','à¤†à¤ª à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(160624,4462,'ms','Pesanan anda telah dihantar',0),(160625,4462,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ù„Ùƒ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(160626,4462,'fr','Vous commande a Ã©tÃ© expÃ©diÃ©e',0),(160627,4462,'jp','æ³¨æ–‡ã?Œç™ºé€?ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(160628,4462,'pt','A ordem foi enviada',0),(160629,4462,'ru','Ð’Ð°Ñˆ Ð—Ð°ÐºÐ°Ð· Ð‘Ñ‹Ð» ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½',0),(160630,4462,'es','Su pedido ha sido enviada',0),(160631,4462,'de','Bestellung wurde versandt',0),(160632,4462,'en','You Order Has Been Shipped',0),(160633,4463,'is','',0),(160634,4463,'dr','Ø´Ù…Ø§ Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ù†ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(160635,4463,'pr','Ø´Ù…Ø§ Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ù†ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(160636,4463,'tr','Bir miktar girmediniz',0),(160637,4463,'pl','Nie podaÅ‚eÅ› iloÅ›Ä‡',0),(160638,4463,'bg','ÐÐµ ÑÑ‚Ðµ Ð²ÑŠÐ²ÐµÐ»Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(160639,4463,'ur','Ø¢Ù¾ Ú©ÛŒ Ø§ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø§Ø®Ù„ Ù†ÛÛŒÚº Ú©ÛŒØ§ ÛÛ’',0),(160640,4463,'sr','ÐÐµ ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(160641,4463,'vi','Báº¡n chÆ°a thÃªm sá»‘ lÆ°á»£ng',0),(160642,4463,'af','U het nie \'n HOEVEELHEID ingevoer nie.',0),(160643,4463,'ro','Nu ati introdus cantitatea',0),(160644,4463,'et','Te ei ole sisestanud kogust',0),(160645,4463,'si','Niste vnesli koliÄino',0),(160646,4463,'ba','Anda belum memasukkan kuantitas',0),(160647,4463,'nl','You Have Not Entered een hoeveelheid',0),(160648,4463,'fi','Et ole syÃ¶ttÃ¤nyt mÃ¤Ã¤rÃ¤Ã¤',0),(160649,4463,'no','Du har ikke angitt et antall',0),(160650,4463,'da','Du har ikke indtastet et antal',0),(160651,4463,'ko','ìˆ˜ëŸ‰ì„ ìž…ë ¥ í•˜ì§€ ì•Šì•˜ìŠµë‹ˆë‹¤.',0),(160652,4463,'he','×œ× ×œ×”×–×™×Ÿ ×›×ž×•×ª',0),(160653,4463,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÎ¹ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(160654,4463,'zh','ä½ è¿˜æ²¡æœ‰è¾“å…¥ä¸€ä¸ªæ•°é‡\r\n',0),(160655,4463,'sv','Du har inte angett ett antal',0),(160656,4463,'it','Non hai inserito una quantitÃ ',0),(160657,4463,'tl','',0),(160658,4463,'th','&#3588;&#3640;&#3603;&#3585;&#3619;&#3629;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3649;&#3621;&#3632;&#3627;&#3619;&#3639;&#3629;&#3648;&#3623;&#3621;&#3634;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(160659,4463,'hi','à¤†à¤ª à¤à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ',0),(160660,4463,'ms','Anda tidak memasukkan kuantiti yang',0),(160661,4463,'ar','Ù„Ù… ØªÙ‚Ù… Ø¨Ø¥Ø¯Ø®Ø§Ù„ ÙƒÙ…ÙŠØ©',0),(160662,4463,'fr','Vous n\'avez pas entrÃ© une quantitÃ©',0),(160663,4463,'jp','æ•°é‡?ã?Œå…¥åŠ›ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(160664,4463,'pt','VocÃª nÃ£o inseriu uma quantidade',0),(160665,4463,'ru','Ð’Ñ‹ ÐÐµ Ð’Ð²ÐµÐ»Ð¸ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(160666,4463,'es','No ha introducido una cantidad',0),(160667,4463,'de','Sie haben eine Menge nicht eingegeben.',0),(160668,4463,'en','You Have Not Entered a Quantity',0),(160669,4464,'is','',0),(160670,4464,'dr','Ø¨Ø§ Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ø¹Ø¨Ù‡ Ù…Ù† ØªØµØ¯ÙŠÙ‚ Ù…ÙŠ ÙƒÙ†Ù… ÙƒÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø± Ø±Ø§Ø¬Ø¹ Ø¨Ù‡ Ø§ÙŠÙ† ØªØºÙŠÙŠØ± ØªÙ…Ø§Ø³ Ú¯Ø±ÙØªÙ‡ Ø¨ÙˆØ¯',0),(160671,4464,'pr','Ø¨Ø§ Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ø¹Ø¨Ù‡ Ù…Ù† ØªØµØ¯ÙŠÙ‚ Ù…ÙŠ ÙƒÙ†Ù… ÙƒÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø± Ø±Ø§Ø¬Ø¹ Ø¨Ù‡ Ø§ÙŠÙ† ØªØºÙŠÙŠØ± ØªÙ…Ø§Ø³ Ú¯Ø±ÙØªÙ‡ Ø¨ÙˆØ¯',0),(160672,4464,'tr','Bu kutuyu iÅŸaretleyerek, mÃ¼ÅŸteri bu deÄŸiÅŸiklik hakkÄ±nda temasa geÃ§tiÄŸini bildiririm.',0),(160673,4464,'pl','ZaznaczajÄ…c to pole, zaÅ›wiadczam, Å¼e klient zostaÅ‚ nawiÄ…zany o tej zmianie',0),(160674,4464,'bg','Ð§Ñ€ÐµÐ· Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ñ‚Ð¾Ð²Ð° Ð¿Ð¾Ð»Ðµ, Ð°Ð· Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´Ð°Ð²Ð°Ð¼, Ñ‡Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑŠÑ‚ Ðµ Ð±Ð¸Ð» Ñ‚ÑŠÑ€ÑÐµÐ½ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(160675,4464,'ur','ÛŒÛ Ø¨Ø§Ú©Ø³ Ú©ÛŒ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ø¬Ú¾Û’ Ø¬Ùˆ Ú¯Ø§ÛÚ© Ø§Ø³ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Û’ Ø¨Ø§Ø±Û’ Ù…ÛŒÚº Ø±Ø§Ø¨Ø·Û Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ ØªØµØ¯ÛŒÙ‚',0),(160676,4464,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð°ÑšÐµÐ¼ Ð¾Ð²Ñƒ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ, ÑƒÑ‚Ð²Ñ€Ð´Ð¸Ð¼ Ð´Ð° Ñ˜Ðµ ÐºÑƒÐ¿Ð°Ñ† ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ð¸ Ð¾ Ð¾Ð²Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(160677,4464,'vi','Khi Ä‘Ã¡nh dáº¥u nÃ y tÃ´i xÃ¡c nháº­n ráº±ng khÃ¡ch hÃ ng Ä‘Ã£ Ä‘Æ°á»£c thÃ´ng bÃ¡o vá» thay Ä‘á»•i',0),(160678,4464,'af','Deur die boksie te merk, bevestig ek dat die klant/kliÃ«nt gekontak is omtrent hierdie verandering',0),(160679,4464,'ro','BifÃ¢nd aceastÄƒ casetÄƒ, certific cÄƒ clientul a fost contactat despre aceastÄƒ schimbare',0),(160680,4464,'et','Ruudu kontrollides kinnitan klient Ã¼hendust sÃµnagi see muutus',0),(160681,4464,'si','Z izbiro tega polja, potrjujem, da je stranka stik o tej spremembi',0),(160682,4464,'ba','Dengan mencentang kotak ini, saya menyatakan bahwa nasabah telah dihubungi mengenai perubahan ini',0),(160683,4464,'nl','Door dit vakje aan te vinken, verklaar ik dat de klant heeft benaderd over deze wijziging',0),(160684,4464,'fi','TÃ¤mÃ¤n ruudun rastittamalla todistaa asiakkaan yhteyttÃ¤ tÃ¤stÃ¤ muutoksesta',0),(160685,4464,'no','Merker denne boksen, bekrefter jeg at kunden har blitt kontaktet om denne endringen',0),(160686,4464,'da','Ved at markere dette felt, attesterer, at kunden er blevet kontaktet om denne Ã¦ndring',0),(160687,4464,'ko','ì´ í™•ì¸ëž€ì„ ì„ íƒ í•˜ ì—¬ ê³ ê°ì´ì´ ë³€í™”ì— ëŒ€í•´ ì—°ë½ì„ ì¦ëª…í•©ë‹ˆë‹¤',0),(160688,4464,'he','×¢×œ ×™×“×™ ×¡×™×ž×•×Ÿ ×ª×™×‘×” ×–×•, ×©××§×‘×¢ ×›×™ ×”×œ×§×•×— × ×•×¦×¨ ×§×©×¨ ×¢× ×œ×’×‘×™ ×©×™× ×•×™ ×–×”',0),(160689,4464,'el','Î•Ï€Î¹Î»Î­Î³Î¿Î½Ï„Î±Ï‚ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿, Î²ÎµÎ²Î±Î¹ÏŽÎ½Ï‰ ÏŒÏ„Î¹ Î¿ Ï€ÎµÎ»Î¬Ï„Î·Ï‚ Î­Ï‡ÎµÎ¹ ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î± ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î±Î»Î»Î±Î³Î®',0),(160690,4464,'zh','é€‰ä¸­æ­¤æ¡†ï¼Œæˆ‘ä¿è¯å®¢æˆ·\r\n',0),(160691,4464,'sv','Genom att markera denna ruta, intygar att kunden har blivit kontaktad om denna fÃ¶rÃ¤ndring',0),(160692,4464,'it','Selezionando questa casella, certifico che il cliente Ã¨ stato contattato circa questo cambiamento',0),(160693,4464,'tl','',0),(160694,4464,'th','&#3650;&#3604;&#3618;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3585;&#3621;&#3656;&#3629;&#3591;&#3609;&#3637;&#3657; &#3593;&#3633;&#3609;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;&#3623;&#3656;&#3634;&#3621;&#3641;&#3585;&#',0),(160695,4464,'hi','à¤‡à¤¸ à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¤•à¥‡, à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤®à¤¾à¤£à¤¿à¤¤ à¤¹à¥ˆ à¤•à¤¿ à¤—à¥à¤°à¤¾à¤¹à¤• à¤‡à¤¸ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥‡ à¤¬à¤¾à¤°à¥‡ à¤®à¥‡à¤‚ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(160696,4464,'ms','Dengan menanda kotak ini, saya mengesahkan bahawa pelanggan telah dihubungi mengenai perubahan ini',0),(160697,4464,'ar','Ø¨ØªØ­Ø¯ÙŠØ¯ Ù‡Ø°Ø§ Ø§Ù„Ù…Ø±Ø¨Ø¹ØŒ ÙˆØ£Ø´Ù‡Ø¯ Ø£Ù†Ù‡ ØªÙ… Ø§Ù„Ø§ØªØµØ§Ù„ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø­ÙˆÙ„ Ù‡Ø°Ø§ Ø§Ù„ØªØºÙŠÙŠØ±',0),(160698,4464,'fr','En cochant cette case, je certifie que le client a Ã©tÃ© contactÃ© sur cette modification',0),(160699,4464,'jp','ã?“ã?®ãƒœãƒƒã‚¯ã‚¹ã‚’ãƒ?ã‚§ãƒƒã‚¯ã?™ã‚‹ã?“ã?¨ã?«ã‚ˆã‚Šã€?é¡§å®¢ã?Œã?“ã?®å¤‰æ›´ã?«ã?¤ã?„ã?¦é€£çµ¡ã‚’å?—ã?‘ã?¦ã?„ã‚‹ã?“ã?¨ã‚’ä¿?è¨¼ã?—ã?¾ã?™ã€‚',0),(160700,4464,'pt','Marcando esta caixa, certifico que o cliente foi contactado sobre esta mudanÃ§a',0),(160701,4464,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ð² ÑÑ‚Ð¾Ñ‚ Ñ„Ð»Ð°Ð¶Ð¾Ðº, Ñ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´Ð°ÑŽ, Ñ‡Ñ‚Ð¾ Ð±Ñ‹Ð»Ð¾ ÑÐ²ÑÐ·Ð°Ð»ÑÑ Ð·Ð°ÐºÐ°Ð·Ñ‡Ð¸Ðº Ð¾Ð± ÑÑ‚Ð¾Ð¼ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¸',0),(160702,4464,'es','Cuando marco esta caja certifico que el cliente ha sido contactado sobe este cambio',0),(160703,4464,'de','Durch Ankreuzen dieses Feldes bestÃ¤tige ich, dass der Kunde Ã¼ber diese Ã„nderung kontaktiert wurde',0),(160704,4464,'en','By checking this box, I certify that the customer has been contacted about this change',0),(160705,4465,'is','',0),(160706,4465,'dr','ØªØ§Ø±ÙŠØ® ØªØºÙŠÙŠØ±',0),(160707,4465,'pr','ØªØ§Ø±ÙŠØ® ØªØºÙŠÙŠØ±',0),(160708,4465,'tr','DeÄŸiÅŸiklik tarihi',0),(160709,4465,'pl','Zmiana daty',0),(160710,4465,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(160711,4465,'ur','ØªØ§Ø±ÛŒØ® ØªØ¨Ø¯ÛŒÙ„',0),(160712,4465,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(160713,4465,'vi','Thay Ä‘á»•i ngÃ y',0),(160714,4465,'af','Veranderd Datum',0),(160715,4465,'ro','Schimba data',0),(160716,4465,'et','KuupÃ¤eva muutmine',0),(160717,4465,'si','Datum spremembe',0),(160718,4465,'ba','Ubah tanggal',0),(160719,4465,'nl','Datum wijzigen',0),(160720,4465,'fi','Muuta pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(160721,4465,'no','Endre dato',0),(160722,4465,'da','Ã†ndre dato',0),(160723,4465,'ko','ë³€ê²½ ë‚ ì§œ',0),(160724,4465,'he','×©×™× ×•×™ ×ª××¨×™×š',0),(160725,4465,'el','Î‘Î»Î»Î±Î³Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚',0),(160726,4465,'zh','æ›´æ”¹æ—¥æœŸ\r\n',0),(160727,4465,'sv','Ã„ndra datum',0),(160728,4465,'it','Data di modifica',0),(160729,4465,'tl','',0),(160730,4465,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(160731,4465,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¬à¤¦à¤²à¥‡à¤‚',0),(160732,4465,'ms','Tukar tarikh',0),(160733,4465,'ar','ØªØºÙŠÙŠØ± Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(160734,4465,'fr','Date de modification',0),(160735,4465,'jp','æ—¥ã?«ã?¡å¤‰æ›´',0),(160736,4465,'pt','Alterar Data',0),(160737,4465,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð”Ð°Ñ‚Ñƒ',0),(160738,4465,'es','Cambiar Fecha',0),(160739,4465,'de','Datum Ã¤ndern',0),(160740,4465,'en','Change Date',0),(160741,4466,'is','',0),(160742,4466,'dr','Ø«Ø¨Øª ØªØ§Ø±ÙŠØ®  Ø¬Ø¯ÙŠØ¯ Ø¯Ø± Ø´ÙƒÙ„ Ø¯Ù‚ÙŠÙ‚Ø§ Ù…Ø´Ø§Ø¨Ù‡ ØªØ§Ø±ÙŠØ® Ù‚Ø¯ÙŠÙ… ',0),(160743,4466,'pr','Ø«Ø¨Øª ØªØ§Ø±ÙŠØ®  Ø¬Ø¯ÙŠØ¯ Ø¯Ø± Ø´ÙƒÙ„ Ø¯Ù‚ÙŠÙ‚Ø§ Ù…Ø´Ø§Ø¨Ù‡ ØªØ§Ø±ÙŠØ® Ù‚Ø¯ÙŠÙ… ',0),(160744,4466,'tr','Eski tarihi tam olarak aynÄ± biÃ§imde yeni tarihi girin',0),(160745,4466,'pl','WprowadÅº nowÄ… datÄ™ w dokÅ‚adnie ten sam Format jako stare daty',0),(160746,4466,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð° Ð´Ð°Ñ‚Ð° Ð² Ñ‚Ð¾Ñ‡Ð½Ð¾ ÑÑŠÑ‰Ð¸Ñ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ°Ñ‚Ð¾ ÑÑ‚Ð°Ñ€Ð° Ð´Ð°Ñ‚Ð°',0),(160747,4466,'ur','Ù¾Ø±Ø§Ù†ÛŒ ØªØ§Ø±ÛŒØ® Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø¨Ø§Ù„Ú©Ù„ Ø§ÛŒÚ© ÛÛŒ Ø´Ú©Ù„ Ù…ÛŒÚº Ù†Ø¦ÛŒ ØªØ§Ø±ÛŒØ® Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(160748,4466,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñƒ Ð¸ÑÑ‚Ð¾Ð¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ ÐºÐ°Ð¾ ÑÑ‚Ð°Ñ€Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(160749,4466,'vi','Nháº­p ngÃ y má»›i theo Ä‘Ãºng máº«u cá»§a ngÃ y cÅ©',0),(160750,4466,'af','Voer Nuwe Datum in Presies dieselfde Formaat as Ou Datum',0),(160751,4466,'ro','IntroduceÅ£i data de noi exact acelaÅŸi Format ca data vechi',0),(160752,4466,'et','Sisesta uus kuupÃ¤ev tÃ¤pselt samas formaadis kui vana kuupÃ¤ev',0),(160753,4466,'si','Nastopiti nov rok v toÄno enako obliko kot stare datum',0),(160754,4466,'ba','Masukkan tanggal baru dalam Format yang sama sebagai tanggal tua',0),(160755,4466,'nl','Nieuwe datum invoeren in precies hetzelfde formaat als oude datum',0),(160756,4466,'fi','Astua veres ajoittaa tÃ¤smÃ¤lleen samassa muodossa kuin vanha pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(160757,4466,'no','Angi ny dato i nÃ¸yaktig samme Format som gamle dato',0),(160758,4466,'da','Angiv nye dato i prÃ¦cis det samme Format som gamle dato',0),(160759,4466,'ko','ì •í™• í•˜ ê²Œì™€ ê°™ì€ í˜•ì‹ìœ¼ë¡œ ëœ ë‚ ì§œì— ìƒˆ ë‚ ì§œë¥¼ ìž…ë ¥',0),(160760,4466,'he','×”×–×Ÿ ×ª××¨×™×š ×—×“×© ×‘×“×™×•×§ ×‘××•×ª×” ×ª×‘× ×™×ª ×›×ª××¨×™×š ×”×™×©×Ÿ',0),(160761,4466,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î½Î­Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÏƒÎµ Î±ÎºÏÎ¹Î²ÏŽÏ‚ Ï„Î·Î½ Î¯Î´Î¹Î± Î¼Î¿ÏÏ†Î® Î¼Îµ Ï€Î±Î»Î¹Î¬ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(160762,4466,'zh','è¾“å…¥ä¸Žæ—§æ—¥æœŸæ ¼å¼å®Œå…¨ä¸€æ ·çš„æ–°æ—¥æœŸ',0),(160763,4466,'sv','Ange nya datum i exakt samma Format som gamla datum',0),(160764,4466,'it','Immettere la nuova data in esattamente lo stesso formato di vecchia data',0),(160765,4466,'tl','',0),(160766,4466,'th','&#3611;&#3657;&#3629;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3627;&#3617;&#3656;&#3651;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3623;&#3656;&#3634;&#3648;&#3627;&#3617;&#3639;&#3629;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3',0),(160767,4466,'hi','à¤¨à¤ˆ à¤¤à¤¾à¤°à¥€à¤– à¤ªà¥à¤°à¤¾à¤¨à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤à¤• à¤¹à¥€ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(160768,4466,'ms','Masukkan tarikh baru betul-betul Format yang sama seperti tarikh lama',0),(160769,4466,'ar','Ù‚Ù… Ø¨Ø¥Ø¯Ø®Ø§Ù„ \"ØªØ§Ø±ÙŠØ® Ø¬Ø¯ÙŠØ¯\" ÙÙŠ Ø¨Ø§Ù„Ø¶Ø¨Ø· Ø¨Ù†ÙØ³ ØªÙ†Ø³ÙŠÙ‚ \"Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ù‚Ø¯ÙŠÙ…\"',0),(160770,4466,'fr','Entrez la nouvelle Date dans exactement le mÃªme Format que lâ€™ancienne Date',0),(160771,4466,'jp','å?¤ã?„æ—¥ã?«ã?¡ã‚’å…¨ã??å?Œã?˜ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆã?§æ–°ã?—ã?„æ—¥ã?«ã?¡ã‚’å…¥åŠ›',0),(160772,4466,'pt','Digite a nova data em exatamente o mesmo formato de data antiga',0),(160773,4466,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð²ÑƒÑŽ Ð´Ð°Ñ‚Ñƒ Ð² Ñ‚Ð¾Ð¼ Ð¶Ðµ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ, Ñ‡Ñ‚Ð¾ ÑÑ‚Ð°Ñ€Ð°Ñ Ð”Ð°Ñ‚Ð°',0),(160774,4466,'es','Introducir Nueva Fecha en Exactamente el Mismo Formato de la Fecha Vieja',0),(160775,4466,'de','Neuer Termin in genau das gleiche Format wie alte Datum eingeben',0),(160776,4466,'en','Enter New Date in Exactly the same Format as Old Date',0),(160777,4467,'is','',0),(160778,4467,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ ',0),(160779,4467,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ ',0),(160780,4467,'tr','Hata alma sipariÅŸ bilgileri',0),(160781,4467,'pl','BÅ‚Ä…d pobierania informacji o zamÃ³wieniu',0),(160782,4467,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(160783,4467,'ur','Ù†Ù‚Øµ ØªØ±ØªÛŒØ¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(160784,4467,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð³Ñ€ÐµÑˆÐºÐµ',0),(160785,4467,'vi','Lá»—i khi truy váº¥n thÃ´ng tin Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(160786,4467,'af','Fout met Herwinning van Bestellings Inligting',0),(160787,4467,'ro','Eroare de preluarea comenzii informaÅ£ii',0),(160788,4467,'et','TÃµrge allalaadimisel tellimisinfo',0),(160789,4467,'si','Napaka pri pridobivanju informacije o naroÄilu',0),(160790,4467,'ba','Informasi Order mengambil kesalahan',0),(160791,4467,'nl','Fout bij ophalen van bestelgegevens',0),(160792,4467,'fi','Virhe noudettaessa tilauksen tiedot',0),(160793,4467,'no','Feil under henting av informasjon',0),(160794,4467,'da','Fejl under hentning af ordreoplysninger',0),(160795,4467,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ì£¼ë¬¸ ì •ë³´',0),(160796,4467,'he','×©×’×™××” ×‘××—×–×•×¨ ×ž×™×“×¢ ××•×“×•×ª ×”×–×ž× ×•×ª',0),(160797,4467,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï„Î¬Î¾Î·Ï‚',0),(160798,4467,'zh','é”™è¯¯æ£€ç´¢è®¢å•ä¿¡æ¯\r\n',0),(160799,4467,'sv','Fel hÃ¤mtar orderinformation',0),(160800,4467,'it','Informazioni sull\'ordine di recupero di errore',0),(160801,4467,'tl','',0),(160802,4467,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(160803,4467,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥à¤°à¤® à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤ªà¥à¤¨à¤ƒà¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(160804,4467,'ms','Ralat mendapatkan maklumat pesanan',0),(160805,4467,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¬Ù„Ø¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(160806,4467,'fr','Erreur rÃ©cupÃ©rer des informations de commande',0),(160807,4467,'jp','æ³¨æ–‡æƒ…å ±ã?®å?Žé›†ã‚¨ãƒ©ãƒ¼',0),(160808,4467,'pt','Erro Recuperando informaÃ§Ãµes de ordem',0),(160809,4467,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð’Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð—Ð°ÐºÐ°Ð·Ð°',0),(160810,4467,'es','Error Recogiendo InformaciÃ³n de Ordenes',0),(160811,4467,'de','Fehler beim Abrufen der Bestellinformationen',0),(160812,4467,'en','Error Retrieving Order Information',0),(160813,4468,'is','',0),(160814,4468,'dr','Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ® â€“ Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ù†Ø§Ù… ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…  Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®ÙˆØ¯  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯  Ùˆ Ø¬Ø¹Ø¨Ù‡ Ø²ÙŠØ± Ø±Ø§ Ú†Ùƒ ÙƒÙ†ÙŠØ¯ ',0),(160815,4468,'pr','Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ® â€“ Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ù†Ø§Ù… ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…  Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®ÙˆØ¯  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯  Ùˆ Ø¬Ø¹Ø¨Ù‡ Ø²ÙŠØ± Ø±Ø§ Ú†Ùƒ ÙƒÙ†ÙŠØ¯ ',0),(160816,4468,'tr','Tarihi deÄŸiÅŸtirmek iÃ§in oturum aÃ§ma adÄ±nÄ±zÄ± ve parolanÄ±zÄ± girin ve aÅŸaÄŸÄ±daki kutuyu iÅŸaretleyin',0),(160817,4468,'pl','Aby zmieniÄ‡ datÄ™, naleÅ¼y wpisaÄ‡ swÃ³j login i hasÅ‚o i zaznacz pole poniÅ¼ej',0),(160818,4468,'bg','Ð—Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð°Ñ‚Ð°, Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð°ÑˆÐµÑ‚Ð¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¾Ñ‚Ð¼ÐµÑ‚ÐºÐ° Ð² ÐºÐ²Ð°Ð´Ñ€Ð°Ñ‚Ñ‡ÐµÑ‚Ð¾ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ',0),(160819,4468,'ur','ØªØ§Ø±ÛŒØ® ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ØŒ ØªÙ…Ú¾ÛŒÚº Ø§Ù¾Ù†Ø§ Ù„Ø§Ú¯ Ø§Ù† Ù†Ø§Ù… Ø§ÙˆØ± Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù†ÛŒÚ†Û’ Ø®Ø§Ù†Û Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(160820,4468,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð»Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼, Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð²Ð°ÑˆÐµ Ð¸Ð¼Ðµ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð¸ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð¾Ð²Ð¾ Ð¿Ð¾Ñ™Ðµ',0),(160821,4468,'vi','Äá»ƒ thay Ä‘á»•i ngÃ y báº¡n pháº£i nháº­p tÃªn Ä‘Äƒng nháº­p, máº­t mÃ£ vÃ  Ä‘Ã¡nh dáº¥u vÃ o há»™p dÆ°á»›i Ä‘Ã¢y',0),(160822,4468,'af','Ten einde die Datum te verander moet u, u Aantekennaam en Wagwoord invoer en die boksies onderaan merk',0),(160823,4468,'ro','Pentru a modifica data, trebuie sÄƒ introduceÅ£i numele ÅŸi parola ÅŸi bifaÅ£i caseta de mai jos',0),(160824,4468,'et','KuupÃ¤eva muutmiseks peate sisestama oma kasutajanimi ja parool ja mÃ¤rkige ruut',0),(160825,4468,'si','Da se spremeni datum, morate vnesti vaÅ¡e prijavno ime in geslo in potrdite polje spodaj',0),(160826,4468,'ba','Untuk mengubah tanggal, Anda harus memasukkan nama login dan password Anda dan centang kotak di bawah ini',0),(160827,4468,'nl','Om de datum wijzigt, moet u uw loginnaam en wachtwoord invoeren en onderstaand selectievakje in',0),(160828,4468,'fi','Jotta heilahdus ajoittaa, sinun tulee kÃ¤yttÃ¤jÃ¤tunnus ja salasana ja valitse seuraava valintaruutu',0),(160829,4468,'no','For Ã¥ endre datoen, mÃ¥ du angi brukernavn og passord og Merk boksen nedenfor',0),(160830,4468,'da','For at Ã¦ndre datoen, skal du indtaste dit login-navn og adgangskode og Marker afkrydsningsfeltet nedenfor',0),(160831,4468,'ko','ë‚ ì§œë¥¼ ë³€ê²½ í•˜ë ¤ë©´ ë¡œê·¸ì¸ ì´ë¦„ ë° ì•”í˜¸ë¥¼ ìž…ë ¥ í•˜ ê³  ì•„ëž˜ ìƒìžë¥¼ í™•ì¸ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(160832,4468,'he','×›×“×™ ×œ×©× ×•×ª ××ª ×”×ª××¨×™×š, ×¢×œ×™×š ×œ×”×–×™×Ÿ ××ª ×©× ×”×ž×©×ª×ž×© ×•×”×¡×™×¡×ž×” ×©×œ×š, ×¡×ž×Ÿ ××ª ×”×ª×™×‘×” ×©×œ×”×œ×Ÿ',0),(160833,4468,'el','Î“Î¹Î± Î½Î± Î±Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±, Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· ÎºÎ±Î¹ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÎºÎ±Î¹ Ï„Î¿ ÎºÎ¿Ï…Ï„Î¬ÎºÎ¹ ÎºÎ¬Ï„Ï‰',0),(160834,4468,'zh','ä¸ºäº†æ”¹å˜æ—¥æœŸï¼Œä½ å¿…é¡»è¾“å…¥ä½ çš„ç™»å½•åå’Œå¯†ç ï¼Œå¹¶é€‰ä¸­ä¸‹é¢çš„æ¡†\r\n',0),(160835,4468,'sv','FÃ¶r att Ã¤ndra datum mÃ¥ste du ange ditt inloggningsnamn och lÃ¶senord och markera rutan nedan',0),(160836,4468,'it','Al fine di modificare la data, Ã¨ necessario immettere il nome di login e la password e selezionare la casella qui sotto',0),(160837,4468,'tl','',0),(160838,4468,'th','In order to change the date, you must enter your login name and password and check the box below',0),(160839,4468,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤¬à¤¦à¤²à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤†à¤ªà¤•à¥‹ à¤…à¤ªà¤¨à¥‡ à¤²à¥‰à¤—à¤¿à¤¨ à¤¨à¤¾à¤® à¤”à¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥‹ à¤šà¥‡à¤• à¤•à¤°à¥‡à¤‚',0),(160840,4468,'ms','Untuk mengubah tarikh, anda perlu memasukkan nama login dan kata laluan anda dan semak kotak di bawah',0),(160841,4468,'ar','Ù„ØªØºÙŠÙŠØ± Ø§Ù„ØªØ§Ø±ÙŠØ®ØŒ ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ø³Ù… ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ ÙˆÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ ÙˆØ§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ù…Ø±Ø¨Ø¹ Ø£Ø¯Ù†Ø§Ù‡',0),(160842,4468,'fr','Afin de changer la date, vous devez entrer votre nom dâ€™utilisateur et mot de passe et cocher la case ci-dessous',0),(160843,4468,'jp','æ—¥ä»˜ã‚’å¤‰æ›´ã?™ã‚‹ã?Ÿã‚?ã?«ã?¯ã€?ãƒ­ã‚°ã‚¤ãƒ³å??ã?¨ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã?—ã?¦ä¸‹ã?®ãƒœãƒƒã‚¯ã‚¹ã‚’ãƒ?ã‚§ãƒƒã‚¯ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(160844,4468,'pt','A fim de alterar a data, vocÃª deve digitar seu nome de login e senha e marque a caixa abaixo',0),(160845,4468,'ru','Ð”Ð»Ñ Ñ‚Ð¾Ð³Ð¾, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð´Ð°Ñ‚Ñƒ, Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð»Ð¾Ð³Ð¸Ð½ Ð¸ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ñ„Ð»Ð°Ð¶Ð¾Ðº Ð½Ð¸Ð¶Ðµ',0),(160846,4468,'es','Para cambiar la fecha, debe ingresar su nombre de login y clave y tachar el cajoncito abajo',0),(160847,4468,'de','Um das Datum zu Ã¤ndern, mÃ¼ssen Sie Ihren Login-Namen und Passwort eingeben und aktivieren Sie das KontrollkÃ¤stchen',0),(160848,4468,'en','In order to change the date, you must enter your login name and password and check the box below',0),(160849,4469,'is','',0),(160850,4469,'dr','Ù†Ø§Ù… ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…',0),(160851,4469,'pr','Ù†Ø§Ù… ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…',0),(160852,4469,'tr','Oturum aÃ§ma adÄ±',0),(160853,4469,'pl','Nazwa logowania',0),(160854,4469,'bg','Ð˜Ð¼Ðµ Ð·Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(160855,4469,'ur','Ù„Ø§Ú¯ Ø§Ù† Ù†Ø§Ù…',0),(160856,4469,'sr','Ð˜Ð¼Ðµ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ',0),(160857,4469,'vi','TÃªn ÄÄƒng nháº­p',0),(160858,4469,'af','Aanteken Naam',0),(160859,4469,'ro','Nume de login',0),(160860,4469,'et','Kasutajatunnus',0),(160861,4469,'si','Prijavo ime',0),(160862,4469,'ba','Nama login',0),(160863,4469,'nl','Login naam',0),(160864,4469,'fi','KÃ¤yttÃ¤jÃ¤tunnus',0),(160865,4469,'no','PÃ¥loggingsnavnet',0),(160866,4469,'da','Login-navn',0),(160867,4469,'ko','ë¡œê·¸ì¸ ì´ë¦„',0),(160868,4469,'he','×©× ×›× ×™×¡×”',0),(160869,4469,'el','ÎŒÎ½Î¿Î¼Î± ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚',0),(160870,4469,'zh','ç™»å½•å\r\n',0),(160871,4469,'sv','Inloggningsnamn',0),(160872,4469,'it','Nome di login',0),(160873,4469,'tl','',0),(160874,4469,'th','Login Name',0),(160875,4469,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤¨à¤¾à¤®',0),(160876,4469,'ms','Nama log masuk',0),(160877,4469,'ar','Ø¥Ø³Ù… Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(160878,4469,'fr','Nom de connexion',0),(160879,4469,'jp','ãƒ­ã‚°ã‚¤ãƒ³å??',0),(160880,4469,'pt','Nome de login',0),(160881,4469,'ru','Ð˜Ð¼Ñ Ð›Ð¾Ð³Ð¸Ð½Ð°',0),(160882,4469,'es','Login Nombre',0),(160883,4469,'de','Login-Name',0),(160884,4469,'en','Login Name',0),(160885,4470,'is','',0),(160886,4470,'dr','Ù…Ø·Ù…Ø¦Ù† Ø¨Ø§Ø´ÙŠØ¯ ÙƒÙ‡ Ù†Ø§Ù… Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø´Ù…Ø§ ØµØ­ÙŠØ­ Ø§Ø³Øª ',0),(160887,4470,'pr','Ù…Ø·Ù…Ø¦Ù† Ø¨Ø§Ø´ÙŠØ¯ ÙƒÙ‡ Ù†Ø§Ù… Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø´Ù…Ø§ ØµØ­ÙŠØ­ Ø§Ø³Øª ',0),(160888,4470,'tr','Oturum aÃ§ma adÄ± ve parolanÄ±zÄ±n doÄŸru olduÄŸundan emin olun',0),(160889,4470,'pl','Upewnij siÄ™, Å¼e twÃ³j login i hasÅ‚o sÄ… poprawne',0),(160890,4470,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð²Ð°ÑˆÐµÑ‚Ð¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð° ÑÐ° Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¸',0),(160891,4470,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ù„Ø§Ú¯ Ø§Ù† Ù†Ø§Ù… Ø§ÙˆØ± Ù¾Ø§Ø³ ÙˆØ±Úˆ ØµØ­ÛŒØ­ ÛÛŒÚº',0),(160892,4470,'sr','Ð£Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÑÐµ Ð´Ð° Ð²Ð°ÑˆÐµ Ð¸Ð¼Ðµ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð¸ Ð»Ð¾Ð·Ð¸Ð½ÐºÐ° Ð¸ÑÐ¿Ñ€Ð°Ð²Ð½Ð¸',0),(160893,4470,'vi','Kiá»ƒm Tra Láº¡i TÃªn & Máº­t MÃ£ Cá»§a Báº¡n',0),(160894,4470,'af','Maak seker u aantekennaam en wagwoord is korrek',0),(160895,4470,'ro','Verificati corectitudinea numelui de utilizator si a cuvantului-cheie',0),(160896,4470,'et','Veendu, et su kasutajanimi ja salasÃµna oleksid Ãµiged',0),(160897,4470,'si','Poskrbite, da vaÅ¡e prijavno ime in geslo pravilna',0),(160898,4470,'ba','Pastikan nama login dan password yang benar',0),(160899,4470,'nl','Controleer of dat uw loginnaam en wachtwoord juist zijn',0),(160900,4470,'fi','Varmista kÃ¤yttÃ¤jÃ¤tunnus ja salasana ovat oikein',0),(160901,4470,'no','Kontroller at brukernavnet og passordet er riktig',0),(160902,4470,'da','SÃ¸rg for dit login og password er korrekte',0),(160903,4470,'ko','ë¡œê·¸ì¸ ì´ë¦„ ë° ì•”í˜¸ë¥¼ ì˜¬ë°”ë¥¸ì§€ í™•ì¸ í•˜ì‹­ì‹œì˜¤',0),(160904,4470,'he','×•×“× ×›×™ ×©× ×”×ž×©×ª×ž×© ×•×”×¡×™×¡×ž×” ×©×œ×š × ×›×•× ×•×ª',0),(160905,4470,'el','Î’ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ ÏƒÎ±Ï‚ ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· ÎºÎ±Î¹ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹ ÏƒÏ‰ÏƒÏ„Î­Ï‚',0),(160906,4470,'zh','ç¡®ä¿ä½ çš„ç™»å½•åå’Œå¯†ç æ˜¯æ­£ç¡®çš„\r\n',0),(160907,4470,'sv','Kontrollera att ditt inloggningsnamn och lÃ¶senord Ã¤r korrekta',0),(160908,4470,'it','Assicurarsi che il nome di login e la password sono corretti',0),(160909,4470,'tl','',0),(160910,4470,'th','&#3651;&#3627;&#3657;&#3649;&#3609;&#3656;&#3651;&#3592;&#3623;&#3656;&#3634;&#3594;&#3639;&#3656;&#3629;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;&#3649;&#3621;&#3632;&#3',0),(160911,4470,'hi','à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ªà¤•à¥‡ à¤²à¥‰à¤—à¤¿à¤¨ à¤¨à¤¾à¤® à¤”à¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¸à¤¹à¥€ à¤¹à¥ˆà¤‚',0),(160912,4470,'ms','Pastikan nama login dan kata laluan anda adalah betul',0),(160913,4470,'ar','ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù† Ø§Ø³Ù… ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ ÙˆÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ Ø§Ù„ØµØ­ÙŠØ­Ø©',0),(160914,4470,'fr','Assurez-vous que votre nom d\'utilisateur et le mot de passe sont corrects',0),(160915,4470,'jp','ãƒ­ã‚°ã‚¤ãƒ³å??ã?¨ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã?Œæ­£ã?—ã?„ã?‹ç¢ºèª?ã?—ã?¦ã??ã? ã?•ã?„',0),(160916,4470,'pt','Verifique se que seu nome de login e senha estÃ£o corretos',0),(160917,4470,'ru','Ð£Ð±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ Ñ‡Ñ‚Ð¾ Ð»Ð¾Ð³Ð¸Ð½ Ð¸ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð²Ð²ÐµÐ´ÐµÐ½Ñ‹ Ð²ÐµÑ€Ð½Ð¾',0),(160918,4470,'es','Asegurar que su nombre de login y su clave son correctos',0),(160919,4470,'de','Stellen Sie sicher, dass Ihren Anmeldenamen und Ihr Kennwort korrekt sind',0),(160920,4470,'en','Make sure your login name and password are correct',0),(160921,4471,'is','',0),(160922,4471,'dr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(160923,4471,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(160924,4471,'tr','Yeni Son Tarih',0),(160925,4471,'pl','Nowy termin',0),(160926,4471,'bg','ÐÐ¾Ð² ÑÑ€Ð¾Ðº Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(160927,4471,'ur','Ù†Ø¦Û’ Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(160928,4471,'sr','ÐÐ¾Ð²Ð¸ Ñ€Ð¾Ðº Ð¸Ð·Ð²Ñ€ÑˆÐµÑšÐ°:',0),(160929,4471,'vi','NgÃ y Ä‘áº¿n háº¡n má»›i',0),(160930,4471,'af','Nuwe Verskuldige Datum',0),(160931,4471,'ro','Data scadentÄƒ noi',0),(160932,4471,'et','Uus tÃ¤htaeg',0),(160933,4471,'si','Nov rok',0),(160934,4471,'ba','Baru jatuh tempo',0),(160935,4471,'nl','Nieuwe vervaldatum',0),(160936,4471,'fi','Uusi erÃ¤pÃ¤ivÃ¤',0),(160937,4471,'no','Nye forfallsdato',0),(160938,4471,'da','Nye forfaldsdato',0),(160939,4471,'ko','ìƒˆ ê¸°í•œ ë‚ ì§œ',0),(160940,4471,'he','×ª××¨×™×š ×™×¢×“ ×—×“×©',0),(160941,4471,'el','ÎÎ­Î± Ï€ÏÎ¿Î¸ÎµÏƒÎ¼Î¯Î±',0),(160942,4471,'zh','æ–°çš„åˆ°æœŸæ—¥æœŸ\r\n',0),(160943,4471,'sv','Nya fÃ¶rfallodatum',0),(160944,4471,'it','Nuova scadenza',0),(160945,4471,'tl','',0),(160946,4471,'th','&#3623;&#3633;&#3609;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(160947,4471,'hi','à¤¨à¤ à¤•à¤¾à¤°à¤£ à¤¤à¤¿à¤¥à¤¿',0),(160948,4471,'ms','Tarikh akhir pembayaran baru',0),(160949,4471,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(160950,4471,'fr','Nouvelle Ã©chÃ©ance',0),(160951,4471,'jp','æ–°è¦?æœŸæ—¥',0),(160952,4471,'pt','Data de vencimento do novo',0),(160953,4471,'ru','ÐÐ¾Ð²Ð¾Ðµ ÐŸÐ¾ Ð”Ð°Ñ‚Ðµ',0),(160954,4471,'es','Nueva Fecha de Vencimiento',0),(160955,4471,'de','Neue FÃ¤lligkeitsdatum',0),(160956,4471,'en','New Due Date',0),(160957,4472,'is','',0),(160958,4472,'dr','(Ø¯ÛŒÙˆÙ† ) Ø¬Ø¯ÙŠØ¯ ',0),(160959,4472,'pr','Ø²Ù…Ø§Ù† Ø³Ø±Ø±Ø³ÙŠØ¯ (Ø¨Ø¯Ù‡ÙŠ) Ø¬Ø¯ÙŠØ¯ ',0),(160960,4472,'tr','Nedeniyle yeni zaman',0),(160961,4472,'pl','Nowe spowodowane czas',0),(160962,4472,'bg','ÐÐ¾Ð² Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð²Ñ€ÐµÐ¼Ðµ',0),(160963,4472,'ur','Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ù†ÛŒØ§ ÙˆÙ‚Øª',0),(160964,4472,'sr','ÐÐ¾Ð²Ð¸ Ñ‚ÐµÑ€Ð¼Ð¸Ð½ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(160965,4472,'vi','Thá»i gian Ä‘áº¿n háº¡n má»›i',0),(160966,4472,'af','Nuwe Verskuldigde Tyd',0),(160967,4472,'ro','Noi din cauza timpului',0),(160968,4472,'et','Uus tÃ¤htaeg',0),(160969,4472,'si','Zaradi novega Äasa',0),(160970,4472,'ba','Baru karena waktu',0),(160971,4472,'nl','Nieuwe verschuldigde tijd',0),(160972,4472,'fi','Uusi erÃ¤pÃ¤ivÃ¤ aika',0),(160973,4472,'no','Ny grunn tid',0),(160974,4472,'da','Nye grund tid',0),(160975,4472,'ko','ì¸í•´ ìƒˆë¡œìš´ ì‹œê°„',0),(160976,4472,'he','×—×“×© ×‘×©×œ ×”×–×ž×Ÿ',0),(160977,4472,'el','ÎÎ­Î± Î»ÏŒÎ³Ï‰ Ï‡ÏÏŒÎ½Î¿Ï…',0),(160978,4472,'zh','æ–°çš„åˆ°æœŸæ—¶é—´\r\n',0),(160979,4472,'sv','Nya vederbÃ¶rlig tid',0),(160980,4472,'it','Nuova causa tempo',0),(160981,4472,'tl','',0),(160982,4472,'th','&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(160983,4472,'hi','à¤•à¤¾à¤°à¤£ à¤¨à¤¯à¤¾ à¤¸à¤®à¤¯',0),(160984,4472,'ms','Baru disebabkan oleh masa',0),(160985,4472,'ar','Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø§Ù„ÙˆØ§Ø¬Ø¨ ÙˆÙ‚Øª',0),(160986,4472,'fr','Nouvelle raison fois',0),(160987,4472,'jp','æ–°è¦?ç· åˆ‡æ™‚é–“',0),(160988,4472,'pt','Novo devido tempo',0),(160989,4472,'ru','ÐÐ¾Ð²Ð¾Ðµ ÐŸÐ¾ Ð’Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(160990,4472,'es','Nuevo Tiempo de Vencimiento',0),(160991,4472,'de','Aufgrund neuer Zeit',0),(160992,4472,'en','New Due Time',0),(160993,4473,'is','',0),(160994,4473,'dr','ØªØ§Ø±ÙŠØ® Ùˆ Ø²Ù…Ø§Ù† Ø³Ø±Ø±Ø³ÙŠØ¯ Ù‚Ø¨Ù„ÙŠ',0),(160995,4473,'pr','ØªØ§Ø±ÙŠØ® Ùˆ Ø²Ù…Ø§Ù† Ø³Ø±Ø±Ø³ÙŠØ¯ Ù‚Ø¨Ù„ÙŠ',0),(160996,4473,'tr','Eski bitiÅŸ tarihi ve saati',0),(160997,4473,'pl','Starej daty i czasu',0),(160998,4473,'bg','Ð¡Ñ‚Ð°Ñ€Ð¸ Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð° Ð¸ Ñ‡Ð°Ñ',0),(160999,4473,'ur','ØªØ§Ø±ÛŒØ® Ø§ÙˆØ± ÙˆÙ‚Øª Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ù¾Ø±Ø§Ù†Û’',0),(161000,4473,'sr','Ð¡Ñ‚Ð°Ñ€Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¸ Ð²Ñ€ÐµÐ¼Ðµ',0),(161001,4473,'vi','NgÃ y & thá»i gian Ä‘áº¿n háº¡n cÅ©',0),(161002,4473,'af','Vorige Verskuldige Datum en Tyd',0),(161003,4473,'ro','Vechi datorate data ÅŸi ora',0),(161004,4473,'et','Vana tÃ¤htaeg ja kord',0),(161005,4473,'si','Stari datum in Äas',0),(161006,4473,'ba','Lama karena tanggal dan waktu',0),(161007,4473,'nl','Oude einddatum en -tijd',0),(161008,4473,'fi','Vanha pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ ja aika',0),(161009,4473,'no','Gamle forfallsdato og tid',0),(161010,4473,'da','Gamle forfaldsdato og tid',0),(161011,4473,'ko','ë‚ ì§œ ë° ì‹œê°„ ì´ì „',0),(161012,4473,'he','×–×§×Ÿ ×¢×§×‘ ×ª××¨×™×š ×•×©×¢×”',0),(161013,4473,'el','Î Î±Î»Î¹Î¬ Î»ÏŒÎ³Ï‰ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ±Î¹ ÏŽÏÎ±',0),(161014,4473,'zh','æ—§æˆªæ­¢æ—¥æœŸå’Œæ—¶é—´\r\n',0),(161015,4473,'sv','Gamla fÃ¶rfallodatum och tid',0),(161016,4473,'it','Vecchia scadenza e tempo',0),(161017,4473,'tl','',0),(161018,4473,'th','&#3623;&#3633;&#3609;&#3648;&#3623;&#3621;&#3634;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;&#3648;&#3585;&#3656;&#3634;',0),(161019,4473,'hi','à¤ªà¥à¤°à¤¾à¤¨à¥‡ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤”à¤° à¤¸à¤®à¤¯',0),(161020,4473,'ms','Lama kerana tarikh dan masa',0),(161021,4473,'ar','Ø§Ù„Ù‚Ø¯ÙŠÙ…Ø© Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„ØªØ§Ø±ÙŠØ® ÙˆØ§Ù„ÙˆÙ‚Øª',0),(161022,4473,'fr','Vieux Due Date et l\'heure',0),(161023,4473,'jp','æ—§ç· åˆ‡æ—¥ã?¨ç· åˆ‡æ™‚é–“',0),(161024,4473,'pt','Velho devido a data e hora',0),(161025,4473,'ru','Ð¡Ñ‚Ð°Ñ€Ñ‹Ð¹ Ð´Ð°Ñ‚Ñƒ Ð¸ Ð²Ñ€ÐµÐ¼Ñ',0),(161026,4473,'es','Fecha de Vencimiento Antigua y Tiempo',0),(161027,4473,'de','Alte FÃ¤lligkeitsdatum und Zeit',0),(161028,4473,'en','Old Due Date and Time',0),(161029,4474,'is','',0),(161030,4474,'dr','Ø´Ù…Ø§',0),(161031,4474,'pr','Ø´Ù…Ø§',0),(161032,4474,'tr','Sen',0),(161033,4474,'pl','Ty',0),(161034,4474,'bg','Ð’Ð¸Ðµ',0),(161035,4474,'ur','Ø¢Ù¾',0),(161036,4474,'sr','Ð¢Ð¸',0),(161037,4474,'vi','Báº¡n',0),(161038,4474,'af','U',0),(161039,4474,'ro','Tu',0),(161040,4474,'et','Teie',0),(161041,4474,'si','Vi',0),(161042,4474,'ba','Anda',0),(161043,4474,'nl','U',0),(161044,4474,'fi','Voit',0),(161045,4474,'no','Du',0),(161046,4474,'da','Du',0),(161047,4474,'ko','ë‹¹ì‹ ',0),(161048,4474,'he','××ª×”',0),(161049,4474,'el','Î£Î±Ï‚',0),(161050,4474,'zh','ä½ \r\n',0),(161051,4474,'sv','Du',0),(161052,4474,'it','Si',0),(161053,4474,'tl','',0),(161054,4474,'th','&#3588;&#3640;&#3603;',0),(161055,4474,'hi','à¤¤à¥à¤®',0),(161056,4474,'ms','Anda',0),(161057,4474,'ar','Ø£Ù†Øª',0),(161058,4474,'fr','Vous',0),(161059,4474,'jp','ã‚ãªãŸ',0),(161060,4474,'pt','VocÃª',0),(161061,4474,'ru','Ð’Ñ‹',0),(161062,4474,'es','Usted',0),(161063,4474,'de','Sie',0),(161064,4474,'en','You',0),(161065,4475,'is','',0),(161066,4475,'dr','Ø´Ù…Ø§ Ù…Ø¬Ø§Ø² Ø¨Ù‡ Ø§ÙŠØ¬Ø§Ø¯ Ø§ÙŠÙ† ØªØºÙŠÙŠØ± Ù†ÙŠØ³ØªÙŠØ¯',0),(161067,4475,'pr','Ø´Ù…Ø§ Ù…Ø¬Ø§Ø² Ø¨Ù‡ Ø§ÙŠØ¬Ø§Ø¯ Ø§ÙŠÙ† ØªØºÙŠÙŠØ± Ù†ÙŠØ³ØªÙŠØ¯',0),(161068,4475,'tr','Bu deÄŸiÅŸikliÄŸi yapmak iÃ§in yetkili olduÄŸunu',0),(161069,4475,'pl','JesteÅ›, nie sÄ… upowaÅ¼nieni do tego zmieniÄ‡',0),(161070,4475,'bg','Ð’Ð¸Ðµ ÑÑ‚Ðµ, Ð½ÑÐ¼Ð° Ð¿Ñ€Ð°Ð²Ð¾ Ð´Ð° ÑÐµ Ñ‚Ð°Ð·Ð¸ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(161071,4475,'ur','Ø¢Ù¾ Ú©Ùˆ Ù†Û ÛŒÛ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Ø±Ù†Û’ Ú©Û’ Ù…Ø¬Ø§Ø² ÛÛŒÚº',0),(161072,4475,'sr','Ð’Ð¸ ÑÑ‚Ðµ, Ð½ÐµÐ¼Ð°Ñ‚Ðµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ñƒ Ð´Ð° Ñ‚Ð¾ ÑƒÑ‡Ð¸Ð½Ð¸Ñ‚Ðµ',0),(161073,4475,'vi','Báº¡n khÃ´ng Ä‘Æ°á»£c cáº¥p quyá»n Ä‘á»ƒ thá»±c hiá»‡n thay Ä‘á»•i nÃ y',0),(161074,4475,'af','U is nie gemagtig om hierdie Verandering te maak.',0),(161075,4475,'ro','Nu aveti autorizare sa faceti aceasta schimbare',0),(161076,4475,'et','Teil ei ole Ãµigusi selle muudatuse tegemiseks',0),(161077,4475,'si','Vi ste dovoljeno spremeniti',0),(161078,4475,'ba','Yang tidak berwenang untuk melakukan perubahan ini',0),(161079,4475,'nl','U bent niet gemachtigd om deze verandering te maken',0),(161080,4475,'fi','Te aari ei hyvÃ¤ksytty jotta tÃ¤mÃ¤ muutos',0),(161081,4475,'no','Du er ikke autorisert til Ã¥ gjÃ¸re denne endringen',0),(161082,4475,'da','Du er ikke autoriseret til at foretage denne Ã¦ndring',0),(161083,4475,'ko','ìžˆìŠµë‹ˆë‹¤ì´ ë³€ê²½í•  ìˆ˜ ìžˆëŠ” ê¶Œí•œì´ ì—†ìŠµë‹ˆë‹¤.',0),(161084,4475,'he','××ª×” ×œ× ×¨×©××™ ×œ×‘×¦×¢ ××ª ×”×©×™× ×•×™',0),(161085,4475,'el','Î•Î¯ÏƒÏ„Îµ Î´ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î½Î± ÎºÎ¬Î½ÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î±Î»Î»Î±Î³Î®',0),(161086,4475,'zh','æ‚¨æ— æƒè¿›è¡Œæ­¤æ›´æ”¹\r\n',0),(161087,4475,'sv','Du Ã¤r inte behÃ¶rig att gÃ¶ra denna fÃ¶rÃ¤ndring',0),(161088,4475,'it','Non sei autorizzati ad effettuare questa modifica',0),(161089,4475,'tl','',0),(161090,4475,'th','&#3588;&#3640;&#3603;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3617;&#3629;&#3610;&#3629;&#3635;&#3609;&#3634;&#3592;&#3651;&#3627;&#3657;&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3',0),(161091,4475,'hi','à¤†à¤ª à¤¯à¤¹ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤§à¤¿à¤•à¥ƒà¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¤‚',0),(161092,4475,'ms','Anda adalah tidak dibenarkan untuk membuat perubahan ini',0),(161093,4475,'ar','ØºÙŠØ± Ù…Ø³Ù…ÙˆØ­ Ù„Ùƒ Ø¨Ø£Ù† ØªØ¹Ù…Ù„ Ù‡Ø°Ø§ Ø§Ù„ØªØºÙŠÙŠØ±',0),(161094,4475,'fr','Vous Ãªtes pas autorisÃ© Ã  effectuer cette modification',0),(161095,4475,'jp','ã?“ã‚Œã‚’å¤‰æ›´ã?™ã‚‹æ¨©é™?ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(161096,4475,'pt','VocÃª Ã© que nÃ£o autorizado a fazer esta mudanÃ§a',0),(161097,4475,'ru','Ð’Ð°Ð¼ ÐÐµ Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾ Ð”ÐµÐ»Ð°Ñ‚ÑŒ ÑÑ‚Ð¸ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(161098,4475,'es','No estÃ¡ autorizado para hacer este cambio',0),(161099,4475,'de','Sie sind nicht berechtigt, diese Ã„nderung vorzunehmen',0),(161100,4475,'en','You are Not Authorized to Make this Change',0),(161101,4476,'is','',0),(161102,4476,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø¬Ø¹Ø¨Ù‡ Ø²ÙŠØ± Ø±Ø§ Ø¨Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ùˆ Ø³Ù¾Ø³ Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÙŠØ¯ ',0),(161103,4476,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø¬Ø¹Ø¨Ù‡ Ø²ÙŠØ± Ø±Ø§ Ø¨Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ùˆ Ø³Ù¾Ø³ Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÙŠØ¯ ',0),(161104,4476,'tr','Devam etmek iÃ§in aÅŸaÄŸÄ±daki kutuyu iÅŸaretleyin gerekir',0),(161105,4476,'pl','NaleÅ¼y sprawdziÄ‡ poniÅ¼ej pole, aby kontynuowaÄ‡',0),(161106,4476,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸ ÐºÐ²Ð°Ð´Ñ€Ð°Ñ‚Ñ‡ÐµÑ‚Ð¾ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ, Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸',0),(161107,4476,'ur','Ø¢Ù¾ Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†ÛŒÚ†Û’ Ø®Ø§Ù†Û Ù¾Ú‘ØªØ§Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(161108,4476,'sr','Ð’Ð¸ Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð¾Ð²Ð¾ Ð¿Ð¾Ñ™Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸',0),(161109,4476,'vi','Báº¡n pháº£i Ä‘Ã¡nh dáº¥u há»™p dÆ°á»›i Ä‘Ã¢y Ä‘á»ƒ tiáº¿p tá»¥c',0),(161110,4476,'af','U moet die onderste Blokkie merk om voort te gaan.',0),(161111,4476,'ro','Trebuie sÄƒ bifaÅ£i caseta de mai jos pentru a continua',0),(161112,4476,'et','Te peate tegema linnukese kastikesse ennem kui saate jÃ¤tkata',0),(161113,4476,'si','Potrdite polje spodaj za nadaljevanje',0),(161114,4476,'ba','Anda harus memeriksa kotak di bawah ini untuk melanjutkan',0),(161115,4476,'nl','U moet het selectievakje hieronder om door te gaan',0),(161116,4476,'fi','Kuittaa alla jatkaa',0),(161117,4476,'no','Du mÃ¥ sjekke boksen nedenfor for Ã¥ fortsette',0),(161118,4476,'da','Du skal tjekke boksen nedenfor for at fortsÃ¦tte',0),(161119,4476,'ko','ê³„ì† í•˜ë ¤ë©´ ì•„ëž˜ í™•ì¸ëž€ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(161120,4476,'he','×™×© ×œ×‘×“×•×§ ××ª ×”×ª×™×‘×” ×©×œ×”×œ×Ÿ ×›×“×™ ×œ×”×ž×©×™×š',0),(161121,4476,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ»Î­Î³Î¾ÎµÏ„Îµ Ï„Î¿ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ Î³Î¹Î± Î½Î± ÏƒÏ…Î½ÎµÏ‡Î¯ÏƒÎµÏ„Îµ',0),(161122,4476,'zh','ä½ å¿…é¡»é€‰ä¸­ä¸‹é¢çš„é€‰æ¡†ä»¥ç»§ç»­\r\n',0),(161123,4476,'sv','Du mÃ¥ste markera rutan nedan fÃ¶r att fortsÃ¤tta',0),(161124,4476,'it','Ãˆ necessario controllare la casella qui sotto per continuare',0),(161125,4476,'tl','',0),(161126,4476,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3594;&#3656;&#3629;&#3591;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;&#3605;&#3656;&#3629;&#3652;&#3611;',0),(161127,4476,'hi','à¤†à¤ª à¤œà¤¾à¤°à¥€ à¤°à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(161128,4476,'ms','Anda mesti menyemak kotak di bawah untuk terus',0),(161129,4476,'ar','ÙŠØ¬Ø¨ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ù…Ø±Ø¨Ø¹ Ø£Ø¯Ù†Ø§Ù‡ Ù…ÙˆØ§ØµÙ„Ø©',0),(161130,4476,'fr','Vous devez cocher la case ci-dessous pour continuer',0),(161131,4476,'jp','ç¶šã?‘ã‚‹ã?«ã?¯ä¸‹ã?®ãƒœãƒƒã‚¯ã‚¹ã‚’ãƒ?ã‚§ãƒƒã‚¯ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(161132,4476,'pt','VocÃª deve marcar a caixa abaixo para continuar',0),(161133,4476,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð»Ðµ Ð½Ð¸Ð¶Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÑŒ',0),(161134,4476,'es','Debe chequear la caja abajo para continuar',0),(161135,4476,'de','Sie mÃ¼ssen den Kasten unten weiterhin Ã¼berprÃ¼fen.',0),(161136,4476,'en','You Must Check the Box Below to Continue',0),(161137,4477,'is','',0),(161138,4477,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø²Ù…Ø§Ù† Ø¬Ø¯ÙŠØ¯ Ù¾Ø± ÙƒÙ†ÙŠØ¯ ',0),(161139,4477,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø²Ù…Ø§Ù† Ø¬Ø¯ÙŠØ¯ Ù¾Ø± ÙƒÙ†ÙŠØ¯ ',0),(161140,4477,'tr','Yeni bir sÃ¼re iÃ§inde doldurmanÄ±z gerekir',0),(161141,4477,'pl','NaleÅ¼y wprowadziÄ‡ nowy czas',0),(161142,4477,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚Ðµ Ð½Ð¾Ð² Ñ‡Ð°Ñ',0),(161143,4477,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù†ÛŒØ§ ÙˆÙ‚Øª Ù…ÛŒÚº Ø¨Ú¾Ø± Ú†Ø§ÛÛŒÛ’',0),(161144,4477,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ð¿ÑƒÐ½Ð¸Ñ‚Ð¸ Ð½Ð¾Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(161145,4477,'vi','Báº¡n pháº£i Ä‘iá»n thá»i gian má»›i',0),(161146,4477,'af','U moet \'n Nuwe Tyd Invul',0),(161147,4477,'ro','Trebuie sa completai intr-un nou timp',0),(161148,4477,'et','Te peate sisestama uue aja',0),(161149,4477,'si','Izpolniti morate nov Äas',0),(161150,4477,'ba','Anda harus mengisi waktu baru',0),(161151,4477,'nl','You Must Fill in een nieuwe tijd',0),(161152,4477,'fi','Kirjoita uusi aika',0),(161153,4477,'no','Du mÃ¥ fylle ut et nytt tidspunkt',0),(161154,4477,'da','Du skal udfylde et nyt tidspunkt',0),(161155,4477,'ko','ìƒˆë¡œìš´ ì‹œê°„ì— ìž‘ì„± í•´ì•¼ í•©ë‹ˆë‹¤.',0),(161156,4477,'he','×¢×œ×™×š ×œ×ž×œ× ×–×ž×Ÿ ×—×“×©',0),(161157,4477,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÏƒÎµÏ„Îµ Î­Î½Î± Î½Î­Î¿ Ï‡ÏÏŒÎ½Î¿',0),(161158,4477,'zh','ä½ å¿…é¡»å¡«å†™ä¸€ä»½æ–°æ—¶é—´\r\n',0),(161159,4477,'sv','Du mÃ¥ste fylla i en ny tid',0),(161160,4477,'it','Ãˆ necessario compilare un nuovo tempo',0),(161161,4477,'tl','',0),(161162,4477,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3651;&#3626;&#3656;&#3648;&#3623;&#3621;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(161163,4477,'hi','à¤†à¤ª à¤à¤• à¤¨à¤ à¤¸à¤®à¤¯ à¤®à¥‡à¤‚ à¤­à¤°à¤¨à¥‡ à¤šà¤¾à¤¹à¤¿à¤',0),(161164,4477,'ms','Anda mesti mengisi masa yang baru',0),(161165,4477,'ar','ÙŠØ¬Ø¨ Ù…Ù„Ø¡ ÙˆÙ‚Øª Ø¬Ø¯ÙŠØ¯',0),(161166,4477,'fr','Vous devez remplir une nouvelle fois.',0),(161167,4477,'jp','æ–°æ™‚é–“ã‚’è¨˜å…¥ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(161168,4477,'pt','Tem de preencher um novo tempo',0),(161169,4477,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð—Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð² ÐÐ¾Ð²Ð¾Ðµ Ð’Ñ€ÐµÐ¼Ñ',0),(161170,4477,'es','Debe llenar un nuevo tiempo',0),(161171,4477,'de','Sie mÃ¼ssen in eine neue Zeit ausfÃ¼llen.',0),(161172,4477,'en','You Must Fill in a New Time',0),(161173,4478,'is','',0),(161174,4478,'dr','Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ',0),(161175,4478,'pr','Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ',0),(161176,4478,'tr','Orijinalleri',0),(161177,4478,'pl','OryginaÅ‚y',0),(161178,4478,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸Ñ‚Ðµ',0),(161179,4478,'ur','Ø§ØµÙ„',0),(161180,4478,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸',0),(161181,4478,'vi','NguyÃªn báº£n',0),(161182,4478,'af','Oorspronklike',0),(161183,4478,'ro','Originalele',0),(161184,4478,'et','Originaalid',0),(161185,4478,'si','Originali',0),(161186,4478,'ba','Aslinya',0),(161187,4478,'nl','Originelen',0),(161188,4478,'fi','AlkuperÃ¤iset',0),(161189,4478,'no','Originaler',0),(161190,4478,'da','Originaler',0),(161191,4478,'ko','ì›ë³¸',0),(161192,4478,'he','×ž×§×•×¨×™×™×',0),(161193,4478,'el','Î ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î±',0),(161194,4478,'zh','åŽŸä»¶\r\n',0),(161195,4478,'sv','Original',0),(161196,4478,'it','Originali',0),(161197,4478,'tl','',0),(161198,4478,'th','&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;',0),(161199,4478,'hi','à¤®à¥‚à¤²',0),(161200,4478,'ms','Asal',0),(161201,4478,'ar','Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø£ØµÙ„ÙŠØ©',0),(161202,4478,'fr','Originaux',0),(161203,4478,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«',0),(161204,4478,'pt','Originais',0),(161205,4478,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ñ‹',0),(161206,4478,'es','Originales',0),(161207,4478,'de','Originale',0),(161208,4478,'en','Originals',0),(161209,4479,'is','',0),(161210,4479,'dr','Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(161211,4479,'pr','Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(161212,4479,'tr','YazdÄ±rma sÄ±rasÄ±nÄ± bulunamadÄ±',0),(161213,4479,'pl','KolejnoÅ›Ä‡ drukowania nie znaleziono',0),(161214,4479,'bg','Ð ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(161215,4479,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(161216,4479,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(161217,4479,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n hÃ ng in',0),(161218,4479,'af','Druk Bestelling nie gevind',0),(161219,4479,'ro','Ordine de imprimare nu a fost gÄƒsit',0),(161220,4479,'et','Prindi ei leitud',0),(161221,4479,'si','Vrstni red tiskanja ni bilo mogoÄe najti',0),(161222,4479,'ba','Pesanan cetakan tidak ditemukan',0),(161223,4479,'nl','Afdrukvolgorde niet gevonden',0),(161224,4479,'fi','Ei lÃ¶ydy tulostusjÃ¤rjestys',0),(161225,4479,'no','UtskriftsrekkefÃ¸lge ikke funnet',0),(161226,4479,'da','Udskrive ordre blev ikke fundet',0),(161227,4479,'ko','ì¸ì‡„ ëª…ë ¹ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(161228,4479,'he','×¡×“×¨ ×”×”×“×¤×¡×” ×œ× × ×ž×¦×',0),(161229,4479,'el','Î£ÎµÎ¹ÏÎ¬ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(161230,4479,'zh','æ‰“å°è®¢å•æœªæ‰¾åˆ°\r\n',0),(161231,4479,'sv','Utskriftsordning hittades inte',0),(161232,4479,'it','Ordine di stampa non trovato',0),(161233,4479,'tl','',0),(161234,4479,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(161235,4479,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(161236,4479,'ms','Cetak tidak dijumpai',0),(161237,4479,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ ØªØ±ØªÙŠØ¨ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(161238,4479,'fr','Ordre d\'impression non trouvÃ©',0),(161239,4479,'jp','å?°åˆ·æ³¨æ–‡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(161240,4479,'pt','Ordem de impressÃ£o nÃ£o encontrado',0),(161241,4479,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(161242,4479,'es','No se encontrÃ³ el Orden de Imprimir',0),(161243,4479,'de','Druckreihenfolge nicht gefunden',0),(161244,4479,'en','Print order not found',0),(161245,4480,'is','',0),(161246,4480,'dr','/ ÙŠØ§ Ø²Ù…Ø§Ù† Ù†Ø§Ø¯Ø±Ø³Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(161247,4480,'pr','Ø´Ù…Ø§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ùˆ / ÙŠØ§ Ø²Ù…Ø§Ù† Ù†Ø§Ø¯Ø±Ø³Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(161248,4480,'tr','GeÃ§ersiz bir tarih ve/veya saat girdiniz',0),(161249,4480,'pl','PodaÅ‚eÅ› nieprawidÅ‚owÄ… datÄ™ lub czas',0),(161250,4480,'bg','Ð’ÑŠÐ²ÐµÐ´Ð¾Ñ…Ñ‚Ðµ Ð½ÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð° Ð´Ð°Ñ‚Ð° Ð¸/Ð¸Ð»Ð¸ Ñ‡Ð°Ñ',0),(161251,4480,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù†Ø§Ø¬Ø§Ø¦Ø² ØªØ§Ø±ÛŒØ® Ø§ÙˆØ±/ÛŒØ§ ÙˆÙ‚Øª Ø¯Ø§Ø®Ù„ Ú©ÛŒØ§ ÛÛ’',0),(161252,4480,'sr','ÐšÐ¾Ñ˜Ñƒ ÑÑ‚Ðµ ÑƒÐ½ÐµÐ»Ð¸ Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¸/Ð¸Ð»Ð¸ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(161253,4480,'vi','Báº¡n Ä‘Ã£ nháº­p 1 ngÃ y vÃ /hay 1 thá»i gian vÃ´ hiá»‡u',0),(161254,4480,'af','U het \'n ONGELDIGE DATUM en/of TYD ingevoer.',0),(161255,4480,'ro','Ati introdus data si ora invalide',0),(161256,4480,'et','Te olete sisestanud vale kellaaja vÃµi kuupÃ¤eva',0),(161257,4480,'si','Vnesli ste neveljaven datum / Äas',0),(161258,4480,'ba','Anda telah memasukkan tanggal tidak valid dan/atau waktu',0),(161259,4480,'nl','U hebt een ongeldige datum en/of tijd',0),(161260,4480,'fi','Olet syÃ¶ttÃ¤nyt virheellisen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n ja ajan',0),(161261,4480,'no','Du har angitt en ugyldig dato og/eller',0),(161262,4480,'da','Du har indtastet en ugyldig dato og/eller tid',0),(161263,4480,'ko','ìž˜ëª» ëœ ë‚ ì§œ ë° ì‹œê°„ ìž…ë ¥',0),(161264,4480,'he','×”×–× ×ª ×ª××¨×™×š ×œ× ×—×•×§×™ ×•/××• ×–×ž×Ÿ',0),(161265,4480,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³Î±Ï„Îµ Î¼Î¹Î± Î¼Î· Î­Î³ÎºÏ…ÏÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î®/ÎºÎ±Î¹ Ï„Î¿ Ï‡ÏÏŒÎ½Î¿',0),(161266,4480,'zh','æ‚¨è¾“å…¥äº†ä¸€ä¸ªæ— æ•ˆçš„æ—¥æœŸå’Œ/æˆ–æ—¶é—´\r\n',0),(161267,4480,'sv','Du har angett ett ogiltigt datum / tid',0),(161268,4480,'it','Hai inserito una data non valida e/o il tempo',0),(161269,4480,'tl','',0),(161270,4480,'th','&#3588;&#3640;&#3603;&#3585;&#3619;&#3629;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3649;&#3621;&#3632;&#3627;&#3619;&#3639;&#3629;&#3648;&#3623;&#3621;&#3634;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(161271,4480,'hi','à¤†à¤ªà¤¨à¥‡ à¤à¤• à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤”à¤°/à¤¯à¤¾ à¤¸à¤®à¤¯ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ',0),(161272,4480,'ms','Anda telah memasukkan satu tarikh yang tidak sah dan/atau masa',0),(161273,4480,'ar','Ù„Ù‚Ø¯ Ù‚Ù…Øª Ø¨Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ® ØºÙŠØ± ØµØ§Ù„Ø­ Ùˆ/Ø£Ùˆ Ø§Ù„ÙˆÙ‚Øª',0),(161274,4480,'fr','Vous avez entrÃ© une date non valide et/ou de la durÃ©e',0),(161275,4480,'jp','ç„¡åŠ¹ã?ªæ—¥ã?«ã?¡ã?¨æ™‚é–“ã‚’å…¥åŠ›ã?—ã?¦ã?„ã?¾ã?™',0),(161276,4480,'pt','VocÃª digitou uma data invÃ¡lida e/ou tempo',0),(161277,4480,'ru','Ð’Ñ‹ Ð²Ð²ÐµÐ»Ð¸ Ð½ÐµÐ´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½ÑƒÑŽ Ð´Ð°Ñ‚Ñƒ Ð¸/Ð¸Ð»Ð¸ Ð²Ñ€ÐµÐ¼Ñ',0),(161278,4480,'es','Ha introducido una fecha y/o hora invÃ¡lida  ',0),(161279,4480,'de','Sie haben ein ungÃ¼ltiges Datum und/oder Uhrzeit eingegeben.',0),(161280,4480,'en','You have entered an invalid date and/or time',0),(161281,4481,'is','',0),(161282,4481,'dr','Ù†Ø§Ù… Ø®Ø±ÙŠØ¯Ø§Ø±',0),(161283,4481,'pr','Ù†Ø§Ù… Ø®Ø±ÙŠØ¯Ø§Ø±',0),(161284,4481,'tr','MÃ¼ÅŸteri adÄ±',0),(161285,4481,'pl','Nazwa klienta',0),(161286,4481,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(161287,4481,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù†Ø§Ù…',0),(161288,4481,'sr','Ð˜Ð¼Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(161289,4481,'vi','TÃªn KhÃ¡ch hÃ ng',0),(161290,4481,'af','Klant / KliÃ«nt Naam',0),(161291,4481,'ro','Numele clientului',0),(161292,4481,'et','Kliendi nimi',0),(161293,4481,'si','Ime kupca',0),(161294,4481,'ba','Nama pelanggan',0),(161295,4481,'nl','Naam van klant',0),(161296,4481,'fi','Asiakkaan nimi',0),(161297,4481,'no','Kundenavn',0),(161298,4481,'da','Kundenavn',0),(161299,4481,'ko','ê³ ê° ì´ë¦„',0),(161300,4481,'he','×©× ×œ×§×•×—',0),(161301,4481,'el','ÎŒÎ½Î¿Î¼Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(161302,4481,'zh','å®¢æˆ·å§“å',0),(161303,4481,'sv','Kundens namn',0),(161304,4481,'it','Nome cliente',0),(161305,4481,'tl','',0),(161306,4481,'th','&#3594;&#3639;&#3656;&#3629;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(161307,4481,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤¨à¤¾à¤®',0),(161308,4481,'ms','Nama pelanggan',0),(161309,4481,'ar','Ø¥Ø³Ù… Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(161310,4481,'fr','Nom du client',0),(161311,4481,'jp','é¡§å®¢å??',0),(161312,4481,'pt','Nome do cliente',0),(161313,4481,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° ',0),(161314,4481,'es','Cliente Nombre',0),(161315,4481,'de','Name des Kunden',0),(161316,4481,'en','Customer Name',0),(161317,4482,'is','',0),(161318,4482,'dr','Ø±ÙˆØ²Ù‡Ø§ ØªØ§ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù† Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§ÙŠÙŠØ¯ ',0),(161319,4482,'pr','Ø±ÙˆØ²Ù‡Ø§ ØªØ§ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù† Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§ÙŠÙŠØ¯ ',0),(161320,4482,'tr','OnaylandÄ±ktan sonra gÃ¼n',0),(161321,4482,'pl','Dni po zatwierdzeniu',0),(161322,4482,'bg','Ð”Ð½Ð¸ Ð´Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸Ñ‚Ðµ ÑÐ»ÐµÐ´ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(161323,4482,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Û’ Ø¨Ø¹Ø¯ Ù…Ú©Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ù†',0),(161324,4482,'sr','Ð”Ð°Ð½Ð° Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐ¸Ð»Ð¸ Ð½Ð°ÐºÐ¾Ð½ Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐ°',0),(161325,4482,'vi','NgÃ y cáº§n Ä‘á»ƒ hoÃ n thÃ nh sau khi cháº¥p thuáº­n',0),(161326,4482,'af','Dae om te voltooi sodra goedkeuring verkry is',0),(161327,4482,'ro','Zile dupÄƒ aprobarea',0),(161328,4482,'et','PÃ¤eva pÃ¤rast tÃ¤ielikku',0),(161329,4482,'si','Dni za dokonÄanje po odobritvi',0),(161330,4482,'ba','Hari untuk menyelesaikan persetujuan setelah',0),(161331,4482,'nl','Dagen om te voltooien na goedkeuring',0),(161332,4482,'fi','PÃ¤ivÃ¤Ã¤ saatuaan',0),(161333,4482,'no','Dager Ã¥ fullfÃ¸re etter godkjenning',0),(161334,4482,'da','Dage til at fuldfÃ¸re efter godkendelse',0),(161335,4482,'ko','ìŠ¹ì¸ í›„ ì™„ë£Œ ì¼',0),(161336,4482,'he','×™×ž×™× ×œ××—×¨ ××™×©×•×¨',0),(161337,4482,'el','Î—Î¼Î­ÏÎµÏ‚ Î³Î¹Î± Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ Î¼ÎµÏ„Î¬ Ï„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ·',0),(161338,4482,'zh','å®¡æ‰¹åŽæ—¥å†…å®Œæˆ\r\n',0),(161339,4482,'sv','Dagar att slutfÃ¶ra efter godkÃ¤nnande',0),(161340,4482,'it','Giorni per completare dopo approvazione',0),(161341,4482,'tl','',0),(161342,4482,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3627;&#3621;&#3633;&#3591;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;',0),(161343,4482,'hi','à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤ªà¥‚à¤°à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(161344,4482,'ms','Hari untuk selepas kelulusan',0),(161345,4482,'ar','Ø£ÙŠØ§Ù… Ù„Ø¥ÙƒÙ…Ø§Ù„ Ø¨Ø¹Ø¯ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø©',0),(161346,4482,'fr','Jours pour se terminer aprÃ¨s approbation',0),(161347,4482,'jp','æ‰¿èª?å¾Œå®Œäº†ã?¾ã?§ã?®æ—¥æ•°',0),(161348,4482,'pt','Dias para completar apÃ³s aprovaÃ§Ã£o',0),(161349,4482,'ru','Ð”Ð½ÐµÐ¹ Ð¿Ð¾ÑÐ»Ðµ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(161350,4482,'es','DÃ­as para Completar despuÃ©s de la aprobaciÃ³n',0),(161351,4482,'de','Tage nach der Genehmigung',0),(161352,4482,'en','Days to complete after approval',0),(161353,4483,'is','',0),(161354,4483,'dr','Ø±ÙˆØ²Ù‡Ø§ ØªØ§ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù† Ø³ÙØ§Ø±Ø´  Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§ÙŠÙŠØ¯ ',0),(161355,4483,'pr','Ø±ÙˆØ²Ù‡Ø§ ØªØ§ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù† Ø³ÙØ§Ø±Ø´  Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§ÙŠÙŠØ¯ ',0),(161356,4483,'tr','SipariÅŸ onaylandÄ±ktan sonra tamamlamak iÃ§in gÃ¼n',0),(161357,4483,'pl','Dni do zakoÅ„czenia zlecenia po zatwierdzeniu',0),(161358,4483,'bg','Ð”Ð½Ð¸ Ð´Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°, ÑÐ»ÐµÐ´ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(161359,4483,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Û’ Ø¨Ø¹Ø¯ ØªØ±ØªÛŒØ¨ Ù…Ú©Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ù†',0),(161360,4483,'sr','Ð”Ð°Ð½Ð° Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐ¸Ð»Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ Ð½Ð°ÐºÐ¾Ð½ Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐ°',0),(161361,4483,'vi','Sá»‘ ngÃ y hoÃ n táº¥t Ä‘Æ¡n Ä‘áº·t hÃ ng sau khi Ä‘Æ°á»£c duyá»‡t',0),(161362,4483,'af','Dae om Bestelling te voltooi sodra goedkeuring verkry is',0),(161363,4483,'ro','Zile pentru a finaliza comanda dupÄƒ aprobarea',0),(161364,4483,'et','PÃ¤eva tellimuse kinnitamise jÃ¤rel',0),(161365,4483,'si','Dni za dokonÄanje nalog po odobritvi',0),(161366,4483,'ba','Hari untuk menyelesaikan pesanan setelah persetujuan',0),(161367,4483,'nl','Dagen om bestelling te voltooien na goedkeuring',0),(161368,4483,'fi','PÃ¤ivÃ¤Ã¤ tilauksen hyvÃ¤ksymisen jÃ¤lkeen',0),(161369,4483,'no','Dager Ã¥ fullfÃ¸re bestillingen etter godkjenning',0),(161370,4483,'da','Dage til at udfÃ¸re ordren efter godkendelse',0),(161371,4483,'ko','ìŠ¹ì¸ í›„ ì£¼ë¬¸ ì™„ë£Œ ì¼',0),(161372,4483,'he','×™×ž×™× ×œ×”×©×œ×ž×ª ×”×¡×“×¨ ×œ××—×¨ ××™×©×•×¨',0),(161373,4483,'el','Î—Î¼Î­ÏÎµÏ‚ Î³Î¹Î± Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ Î­Î³ÎºÏÎ¹ÏƒÎ·',0),(161374,4483,'zh','å®¡æ‰¹åŽå®Œæˆè®¢å•å¤©æ•°\r\n',0),(161375,4483,'sv','Dagar att slutfÃ¶ra order efter godkÃ¤nnande',0),(161376,4483,'it','Giorni per completare l\'ordine dopo l\'approvazione',0),(161377,4483,'tl','',0),(161378,4483,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3627;&#3621;&#3633;&#3591;&#3592;&#3634;&#3585;&#3585;&#3',0),(161379,4483,'hi','à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤ªà¥‚à¤°à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(161380,4483,'ms','Hari untuk melengkapkan perintah selepas kelulusan',0),(161381,4483,'ar','Ø£ÙŠØ§Ù… Ø§Ø³ØªÙƒÙ…Ø§Ù„ Ø§Ù„Ù†Ø¸Ø§Ù… Ø¨Ø¹Ø¯ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø©',0),(161382,4483,'fr','Jours pour complÃ©ter la commande aprÃ¨s approbation',0),(161383,4483,'jp','æ‰¿èª?å¾Œæ³¨æ–‡å®Œäº†ã?¾ã?§ã?®æ—¥æ•°',0),(161384,4483,'pt','Dias para concluir o pedido apÃ³s a aprovaÃ§Ã£o',0),(161385,4483,'ru','Ð”Ð½Ð¸ Ð´Ð»Ñ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ð¿Ð¾ÑÐ»Ðµ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(161386,4483,'es','DÃ­as para Completar el Orden despuÃ©s de la aprobaciÃ³n',0),(161387,4483,'de','Tage bestellen Sie nach Genehmigung',0),(161388,4483,'en','Days to complete order after approval',0),(161389,4484,'is','',0),(161390,4484,'dr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ù†Ø¯ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´ ',0),(161391,4484,'pr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ù†Ø¯ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´ ',0),(161392,4484,'tr','Yeni kanÄ±t bilgi iÃ§in yazdÄ±rma sÄ±rasÄ±nÄ± girin',0),(161393,4484,'pl','WprowadÅº nowe informacje dowÃ³d KolejnoÅ›Ä‡ drukowania',0),(161394,4484,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(161395,4484,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù†Ø¦Û’ Ø«Ø¨ÙˆØª Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(161396,4484,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð´Ð¾ÐºÐ°Ð· Ð¸Ð½Ñ„Ð¾ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(161397,4484,'vi','Nháº­p thÃ´ng tin chá»©ng nháº­n má»›i cho Ä‘Æ¡n Ä‘áº·t hÃ ng in',0),(161398,4484,'af','Voer Nuwe proef Inligting in vir Gedrukte Bestelling',0),(161399,4484,'ro','IntroduceÅ£i informaÅ£ii noi de dovada pentru comanda de imprimare',0),(161400,4484,'et','Saate sisestada uus tÃµend info Prindi tellimuse',0),(161401,4484,'si','Vnesite nov dokaz info za vrstni red tiskanja',0),(161402,4484,'ba','Masukkan info bukti baru untuk pesanan cetakan',0),(161403,4484,'nl','Voer nieuwe bewijs info voor afdrukvolgorde',0),(161404,4484,'fi','Kirjoita uusi todiste info tulostusjÃ¤rjestys',0),(161405,4484,'no','Angi nye bevis info for rekkefÃ¸lge',0),(161406,4484,'da','Angiv nye bevis info for udskriftsrÃ¦kkefÃ¸lgen',0),(161407,4484,'ko','ì¸ì‡„ ìˆœì„œì— ëŒ€ í•œ ìƒˆë¡œìš´ ì¦ëª… ì •ë³´ë¥¼ ìž…ë ¥',0),(161408,4484,'he','×”×–×Ÿ ×ž×™×“×¢ ×”×•×›×—×” ×—×“×© ×¢×‘×•×¨ ×¡×“×¨ ×”×”×“×¤×¡×”',0),(161409,4484,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î·Î½ Î½Î­Î± Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± ÏƒÎµÎ¹ÏÎ¬ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(161410,4484,'zh','è¾“å…¥æ–°çš„è¯æ˜Žèµ„æ–™æ‰“å°æŒ‡ä»¤',0),(161411,4484,'sv','Ange nya bevis info fÃ¶r utskriftsordning',0),(161412,4484,'it','Inserisci nuove informazioni prova per ordine di stampa',0),(161413,4484,'tl','',0),(161414,4484,'th','&#3611;&#3657;&#3629;&#3609;&#3605;&#3633;&#3623;&#3629;&#3618;&#3656;&#3634;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3',0),(161415,4484,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤ à¤¸à¤¬à¥‚à¤¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(161416,4484,'ms','Masukkan maklumat baru bukti untuk cetak',0),(161417,4484,'ar','Ø£Ø¯Ø®Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ù„ÙŠÙ„ Ø¬Ø¯ÙŠØ¯ Ù„Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(161418,4484,'fr','Entrez les nouvelles infos preuve pour ordre dâ€™impression',0),(161419,4484,'jp','å?°åˆ·æ³¨æ–‡ã?¸ã?®æ–°è¦?æ§‹æˆ?æƒ…å ±ã?®å…¥åŠ›',0),(161420,4484,'pt','Digite a informaÃ§Ã£o nova prova para a ordem de impressÃ£o',0),(161421,4484,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¾Ðµ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð·Ð°ÐºÐ°Ð·Ð°',0),(161422,4484,'es','Introducir info de nueva prueba de impresiÃ³n para orden de impresiÃ³n',0),(161423,4484,'de','Neues Beweis Info zum Drucken Auftrag erfassen',0),(161424,4484,'en','Enter new proof info for print order',0),(161425,4485,'is','',0),(161426,4485,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø³Ù†Ø¯',0),(161427,4485,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø³Ù†Ø¯',0),(161428,4485,'tr','DÄ±ÅŸarÄ± iÃ§in kanÄ±t oluÅŸturulurken hata oluÅŸtu',0),(161429,4485,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas tworzenia siÄ™ w na dowÃ³d',0),(161430,4485,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð²ÑŠÐ½ Ð·Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(161431,4485,'ur','Ù†Ù‚Øµ Ø¨Ø§ÛØ± Ú©Û’ Ù„Ø¦Û’ Ø¯Ù„ÛŒÙ„ Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’',0),(161432,4485,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ð½Ð°Ð¿Ð¾Ñ™Ðµ Ð´Ð° Ð´Ð¾ÐºÐ°Ð·',0),(161433,4485,'vi','Lá»—i táº¡o báº£n in thá»­',0),(161434,4485,'af','Fout skep uit om te bewys',0),(161435,4485,'ro','Eroare la crearea afarÄƒ la dovada',0),(161436,4485,'et','Ei Ãµnnestu luua vÃ¤lja et tÃµend',0),(161437,4485,'si','Napaka pri ustvarjanju ven za dokaz',0),(161438,4485,'ba','Error membuat keluar untuk bukti',0),(161439,4485,'nl','Fout bij het maken van uit tot bewijs',0),(161440,4485,'fi','Virhe luotaessa, jotta todiste',0),(161441,4485,'no','Feil under oppretting av ut Ã¥ Proof',0),(161442,4485,'da','Fejl under oprettelse til bevis',0),(161443,4485,'ko','ë°–ìœ¼ë¡œ ì¦ê±°ë¥¼ ë§Œë“œëŠ” ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤',0),(161444,4485,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×”×—×•×¦×” ×›×“×™ ×”×•×›×—×”',0),(161445,4485,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î­Î¾Ï‰ Î½Î± Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î·',0),(161446,4485,'zh','é”™è¯¯åˆ›å»ºè¾“å‡ºè¯æ˜Ž',0),(161447,4485,'sv','Fel vid skapande av ut till bevis',0),(161448,4485,'it','Errore creazione fuori a prova',0),(161449,4485,'tl','',0),(161450,4485,'th','Error creating Out To Proof',0),(161451,4485,'hi','à¤¬à¤¾à¤¹à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¬à¥‚à¤¤ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(161452,4485,'ms','Ralat ketika mencipta keluar untuk bukti',0),(161453,4485,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ \"Ø£ØµÙ„ Ù„Ø¥Ø«Ø¨Ø§Øª\"',0),(161454,4485,'fr','Erreur de crÃ©ation du dehors Ã  la preuve',0),(161455,4485,'jp','Error creating Out To Proof',0),(161456,4485,'pt','Erro ao criar fora de prova',0),(161457,4485,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸, Ð´Ð»Ñ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(161458,4485,'es','Error creando Fuera para Prueba de Imresion',0),(161459,4485,'de','Fehler beim Erstellen des heraus zum Nachweis',0),(161460,4485,'en','Error creating Out To Proof',0),(161461,4486,'is','',0),(161462,4486,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙÙƒØ³ ',0),(161463,4486,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙÙƒØ³ ',0),(161464,4486,'tr','Faks #',0),(161465,4486,'pl','Faks #',0),(161466,4486,'bg','Ð¤Ð°ÐºÑ #',0),(161467,4486,'ur','ÙÛŒÚ©Ø³ Ù†Ù…Ø¨Ø±',0),(161468,4486,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑÐ°',0),(161469,4486,'vi','Fax sá»‘',0),(161470,4486,'af','Faks #',0),(161471,4486,'ro','Fax #',0),(161472,4486,'et','Faksi #',0),(161473,4486,'si','Fax #',0),(161474,4486,'ba','Faks #',0),(161475,4486,'nl','Fax #',0),(161476,4486,'fi','Faksin #',0),(161477,4486,'no','Faks #',0),(161478,4486,'da','Fax #',0),(161479,4486,'ko','# íŒ©ìŠ¤',0),(161480,4486,'he','×¤×§×¡ #',0),(161481,4486,'el','ÎÎ¿ Ï†Î±Î¾',0),(161482,4486,'zh','ä¼ çœŸï¼ƒ\r\n',0),(161483,4486,'sv','Fax #',0),(161484,4486,'it','Fax #',0),(161485,4486,'tl','',0),(161486,4486,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3650;&#3607;&#3619;&#3626;&#3634;&#3619;',0),(161487,4486,'hi','à¤«à¤¼à¥ˆà¤•à¥à¤¸ #',0),(161488,4486,'ms','Faks #',0),(161489,4486,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ù…ØµÙˆÙ‘Ø±',0),(161490,4486,'fr','No de Fax',0),(161491,4486,'jp','ãƒ•ã‚¡ãƒƒã‚¯ã‚¹ç•ªå?·',0),(161492,4486,'pt','Fax #',0),(161493,4486,'ru','Ð¤Ð°ÐºÑ #',0),(161494,4486,'es','Fax #',0),(161495,4486,'de','Fax #',0),(161496,4486,'en','Fax #',0),(161497,4487,'is','',0),(161498,4487,'dr','Ú¯Ø±Ø§ÙÙŠÙƒ Ù‡Ø§ÙŠ ÙØ±Ù… ÙÙƒØ³ ',0),(161499,4487,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ Ù‡Ø§ÙŠ ÙØ±Ù… ÙÙƒØ³ ',0),(161500,4487,'tr','Grafik Faks formu',0),(161501,4487,'pl','Grafika faks formularz',0),(161502,4487,'bg','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ñ„Ð°ÐºÑ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€',0),(161503,4487,'ur','Ú¯Ø±Ø§ÙÚ©Ø³ ÙÛŒÚ©Ø³ ÙØ§Ø±Ù…',0),(161504,4487,'sr','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐºÐ¸ Ñ„Ð°ÐºÑ Ð¾Ð±Ñ€Ð°ÑÑ†Ð°',0),(161505,4487,'vi','Äá»“ Há»a Fax tá»«',0),(161506,4487,'af','Grafiese Faks Vorm',0),(161507,4487,'ro','Forma de Fax grafica',0),(161508,4487,'et','Graafika Faks vorm',0),(161509,4487,'si','Grafika faksu obrazec',0),(161510,4487,'ba','Grafis Faks formulir',0),(161511,4487,'nl','Grafische faxformulier',0),(161512,4487,'fi','Faksi-malli-grafiikka',0),(161513,4487,'no','Grafikk faksskjemaet',0),(161514,4487,'da','Grafik Fax formular',0),(161515,4487,'ko','ê·¸ëž˜í”½ íŒ©ìŠ¤ ì–‘ì‹',0),(161516,4487,'he','×˜×•×¤×¡ ×”×¤×§×¡ ×’×¨×¤×™×§×”',0),(161517,4487,'el','Î“ÏÎ±Ï†Î¹ÎºÎ¬ ÏƒÎµ Î¼Î¿ÏÏ†Î® Fax',0),(161518,4487,'zh','å›¾å½¢ä¼ çœŸè¡¨æ ¼\r\n',0),(161519,4487,'sv','Grafik Fax formulÃ¤r',0),(161520,4487,'it','Modulo Fax di grafica',0),(161521,4487,'tl','',0),(161522,4487,'th','&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3650;&#3607;&#3619;&#3626;&#3634;&#3619;',0),(161523,4487,'hi','à¤—à¥à¤°à¤¾à¤«à¤¿à¤•à¥à¤¸ à¤«à¤¼à¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤ªà¤¤à¥à¤°',0),(161524,4487,'ms','Borang Perkhidmatan Faks grafik',0),(161525,4487,'ar','Ù†Ù…ÙˆØ°Ø¬ Ø§Ù„ÙØ§ÙƒØ³ Ø§Ù„Ø±Ø³ÙˆÙ…Ø§Øª',0),(161526,4487,'fr','Graphique le formulaire par tÃ©lÃ©copieur',0),(161527,4487,'jp','ç”»åƒ?ãƒ•ã‚¡ãƒƒã‚¯ã‚¹ãƒ•ã‚©ãƒ¼ãƒ ',0),(161528,4487,'pt','FormulÃ¡rio de Fax de grÃ¡ficos',0),(161529,4487,'ru','Ð¤Ð¾Ñ€Ð¼Ð° Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ° Ð¤Ð°ÐºÑ',0),(161530,4487,'es','GrÃ¡fica Formulario de Fax',0),(161531,4487,'de','Grafik-Fax-Formular',0),(161532,4487,'en','Graphics Fax Form',0),(161533,4488,'is','',0),(161534,4488,'dr','Ø¹Ø¶Ùˆ ØªÙŠÙ… Ú¯Ø±Ø§ÙÙŠÙƒ ÙƒÙ‡ Ø§ÙŠÙ† Ø³Ù†Ø¯ Ø±Ø§ Ø§ÙŠØ¬Ø§Ø¯ ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª',0),(161535,4488,'pr','Ø¹Ø¶Ùˆ ØªÙŠÙ… Ú¯Ø±Ø§ÙÙŠÙƒ ÙƒÙ‡ Ø§ÙŠÙ† Ø³Ù†Ø¯ Ø±Ø§ Ø§ÙŠØ¬Ø§Ø¯ ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª',0),(161536,4488,'tr','Bu kanÄ±t oluÅŸturan grafik ekibi Ã¼yesi',0),(161537,4488,'pl','Grafika czÅ‚onka zespoÅ‚u, ktÃ³ry stworzyÅ‚ ten dowÃ³d',0),(161538,4488,'bg','Ð§Ð»ÐµÐ½ Ð½Ð° ÐµÐºÐ¸Ð¿Ð° Ð½Ð° Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°, ÐºÐ¾Ð¹Ñ‚Ð¾ Ðµ ÑÑŠÐ·Ð´Ð°Ð» Ñ‚Ð¾Ð²Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(161539,4488,'ur','Ú¯Ø±Ø§ÙÚ©Ø³ Ù¹ÛŒÙ… Ú©Û’ Ø±Ú©Ù† Ø¬Ø³ Ú©Ø§ Ø«Ø¨ÙˆØª ÛÙ¹Ù„Ø± Ú©Û’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(161540,4488,'sr','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐµ Ð¸Ð· Ñ‚Ð¸Ð¼Ð° ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð¾ Ð¾Ð²Ð°Ñ˜ Ð´Ð¾ÐºÐ°Ð·',0),(161541,4488,'vi','ThÃ nh viÃªn Ä‘á»™i Äá»“ Há»a táº¡o ra báº£n in thá»­',0),(161542,4488,'af','Grafiese spanlid wie hierdie proef geskep het',0),(161543,4488,'ro','Grafica membru al echipei care a creat aceastÄƒ dovadÄƒ',0),(161544,4488,'et','Graafika meeskonnaliige, kes lÃµi selle tÃµendi',0),(161545,4488,'si','Grafika Älan ekipe, ki je ustvaril ta dokaz',0),(161546,4488,'ba','Anggota tim grafis yang menciptakan bukti ini',0),(161547,4488,'nl','Grafische teamlid die dit bewijs gemaakt',0),(161548,4488,'fi','Grafiikka tiimin jÃ¤sen, joka on luonut tÃ¤tÃ¤ todisteena',0),(161549,4488,'no','Grafikk gruppemedlemmet som opprettet denne bevis',0),(161550,4488,'da','Grafik teammedlem, der har oprettet dette bevis',0),(161551,4488,'ko','ì´ ì¦ê±°ë¥¼ ìž‘ì„± í•˜ëŠ” ê·¸ëž˜í”½ íŒ€ êµ¬ì„±ì›',0),(161552,4488,'he','×—×‘×¨ ×¦×•×•×ª ×”×’×¨×¤×™×§×” ×©×™×¦×¨ ×”×”×•×›×—×” ×”×–××ª',0),(161553,4488,'el','ÎœÎ­Î»Î¿Ï‚ Ï„Î·Ï‚ Î¿Î¼Î¬Î´Î±Ï‚ Î³ÏÎ±Ï†Î¹ÎºÏŽÎ½ Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿ÏÏÎ³Î·ÏƒÎµ Î±Ï…Ï„Î® Ï„Î·Î½ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î·',0),(161554,4488,'zh','å›¾å½¢ç»„åˆ›é€ äº†è¿™æ–¹é¢è¯æ®çš„æˆå‘˜â€‹â€‹\r\n',0),(161555,4488,'sv','Grafik gruppmedlem som skapade detta bevis',0),(161556,4488,'it','Membro del team di grafica che ha creato questa prova',0),(161557,4488,'tl','',0),(161558,4488,'th','&#3651;&#3626;&#3656;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3607;&#3637;&#3617;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3612;&#3641;&#3657;&#3595;&#3638;&#3656;&#3591;&#3626;&#3619;&#3657;&#3634;&#3591;&#3626;&#3619;&#3619;&#3588;&#3660;&#3',0),(161559,4488,'hi','à¤—à¥à¤°à¤¾à¤«à¤¿à¤•à¥à¤¸ à¤Ÿà¥€à¤® à¤•à¥‡ à¤¸à¤¦à¤¸à¥à¤¯ à¤¹à¥ˆ à¤œà¥‹ à¤‡à¤¸ à¤¸à¤¬à¥‚à¤¤ à¤¬à¤¨à¤¾à¤¯à¤¾',0),(161560,4488,'ms','Ahli pasukan grafik yang mencipta bukti ini',0),(161561,4488,'ar','Ø±Ø³ÙˆÙ…Ø§Øª Ø¹Ø¶Ùˆ Ø§Ù„ÙØ±ÙŠÙ‚ Ø§Ù„Ø°ÙŠ Ù‚Ø§Ù… Ø¨Ø¥Ù†Ø´Ø§Ø¡ Ù‡Ø°Ø§ Ø§Ù„Ø¯Ù„ÙŠÙ„',0),(161562,4488,'fr','Membre de l\'Ã©quipe graphique qui a crÃ©Ã© cette preuve',0),(161563,4488,'jp','Graphics team member who created this proof',0),(161564,4488,'pt','Membro da equipe grÃ¡fica que criou esta prova',0),(161565,4488,'ru','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ñ‡Ð»ÐµÐ½Ð° ÐºÐ¾Ð¼Ð°Ð½Ð´Ñ‹, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ð¹ ÑÐ¾Ð·Ð´Ð°Ð» ÑÑ‚Ð¾ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾',0),(161566,4488,'es','GrÃ¡fica miembro de equipo a quien creÃ³ esta prueba de impresiÃ³n',0),(161567,4488,'de','Grafik-Teammitglied, diesen Beweis erstellt',0),(161568,4488,'en','Graphics team member who created this proof',0),(161569,4489,'is','',0),(161570,4489,'dr','Ø§Ú¯Ø± Ù‡Ø± Ú†ÙŠØ²ÙŠ Ø¯Ø± Ø§ÙŠÙ† Ø§Ø±Ø³Ø§Ù„ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ ÙŠØ§ ØªØ­Ø±ÙŠÙ Ø´Ø¯Ù‡ Ø§Ø³Øª Ù„Ø·ÙØ§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(161571,4489,'pr','Ø§Ú¯Ø± Ù‡Ø± Ú†ÙŠØ²ÙŠ Ø¯Ø± Ø§ÙŠÙ† Ø§Ø±Ø³Ø§Ù„ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ ÙŠØ§ ØªØ­Ø±ÙŠÙ Ø´Ø¯Ù‡ Ø§Ø³Øª Ù„Ø·ÙØ§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(161572,4489,'tr','LÃ¼tfen bir ÅŸey eksik veya bozuk bu ÅŸanzÄ±man ise',0),(161573,4489,'pl','JeÅ›li coÅ› jest brak lub znieksztaÅ‚cony w tej transmisji prosimy o kontakt',0),(161574,4489,'bg','ÐÐºÐ¾ Ð½ÐµÑ‰Ð¾ Ð»Ð¸Ð¿ÑÐ²Ð° Ð¸Ð»Ð¸ Ð¸Ð·ÐºÑ€Ð¸Ð²ÐµÐ½Ð¸ Ð² Ñ‚Ð¾Ð²Ð° Ð¿Ñ€ÐµÐ´Ð°Ð²Ð°Ð½Ðµ ÑÐµ ÑÐ²ÑŠÑ€Ð¶ÐµÑ‚Ðµ',0),(161575,4489,'ur','Ú©Ú†Ú¾ ØºØ§Ø¦Ø¨ ÛÛŒÚº ÛŒØ§ Ø§Ø³ Ú©ÛŒ ØªØ±Ø³ÛŒÙ„ Ù…ÛŒÚº Ù…Ø³Ø® Ø´Ø¯Û ÛÛ’ ØªÙˆ Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº',0),(161576,4489,'sr','Ð£ÐºÐ¾Ð»Ð¸ÐºÐ¾ Ð½ÐµÑˆÑ‚Ð¾ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ð¸Ð»Ð¸ Ñ˜Ðµ Ð¸ÑÐºÑ€Ð¸Ð²Ñ™ÐµÐ½Ð¾ Ñƒ Ð¾Ð²Ð°Ñ˜ Ð¿Ñ€ÐµÐ½Ð¾Ñ Ð¾Ð±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ',0),(161577,4489,'vi','Náº¿u giao dá»‹ch bá»‹ máº¥t hay Ä‘á»©t Ä‘oáº¡n vui lÃ²ng liÃªn há»‡',0),(161578,4489,'af','Indien enigiets ontbreek of verwronge is in hierdie oordrag kontak asseblief',0),(161579,4489,'ro','DacÄƒ ceva lipseÅŸte sau distorsionat Ã®n acest transport va rugam sa contactati',0),(161580,4489,'et','Kui midagi puudub vÃµi on andmed edastamisel moondunud, siis vÃµtke palun Ã¼hendust',0),(161581,4489,'si','ÄŒe kar koli manjka ali izkrivljena na ta prenos se obrnite na',0),(161582,4489,'ba','Jika ada sesuatu hilang atau terdistorsi dalam transmisi ini silahkan hubungi',0),(161583,4489,'nl','Als om het even wat ontbreekt of vervormd weergegeven in deze transmissie Neem contact op met',0),(161584,4489,'fi','Jos jotain puuttuu tai vÃ¤Ã¤ristynyt tÃ¤mÃ¤ siirto ota yhteyttÃ¤',0),(161585,4489,'no','Hvis noe mangler eller forvrengt i denne overfÃ¸ring kontakt',0),(161586,4489,'da','Hvis noget mangler eller forvrÃ¦nget i denne overfÃ¸rsel kan du kontakte',0),(161587,4489,'ko','ì•„ë¬´ê²ƒë„ ì—†ê±°ë‚˜ì´ ì „ì†¡ì— ì™œê³¡ ëœ ê²½ìš° ë¬¸ì˜ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(161588,4489,'he','×× ×ž×©×”×• ×—×¡×¨ ××• ×ž×¢×•×•×ª×ª ×‘×©×™×“×•×¨ ×”×–×” ×× × ×¦×¨×• ×§×©×¨',0),(161589,4489,'el','Î‘Î½ ÎºÎ¬Ï„Î¹ ÎµÎ¯Î½Î±Î¹ Î»ÎµÎ¯Ï€ÎµÎ¹ Î® ÎµÎ¯Î½Î±Î¹ Ï€Î±ÏÎ±Î¼Î¿ÏÏ†Ï‰Î¼Î­Î½Î· ÏƒÎµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î¼ÎµÏ„Î¬Î´Î¿ÏƒÎ· ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î®ÏƒÏ„Îµ',0),(161590,4489,'zh','å¦‚æžœåœ¨ä¼ è¾“ä¸­æœ‰ä»€ä¹ˆé—æ¼æˆ–æ‰­æ›²ï¼Œè¯·è”ç³»\r\n',0),(161591,4489,'sv','Om nÃ¥got saknas eller fÃ¶rvrÃ¤ngd i denna Ã¶verfÃ¶ring kontakta',0),(161592,4489,'it','Se qualcosa manca o distorta in questa trasmissione si prega di contattare',0),(161593,4489,'tl','',0),(161594,4489,'th','If anything is missing or distorted in this transmission please contact',0),(161595,4489,'hi','à¤…à¤—à¤° à¤•à¥à¤› à¤­à¥€ à¤¯à¤¾à¤¦ à¤† à¤°à¤¹à¥€ à¤¹à¥ˆ à¤¯à¤¾ à¤‡à¤¸ à¤¸à¤‚à¤šà¤°à¤£ à¤®à¥‡à¤‚ à¤µà¤¿à¤•à¥ƒà¤¤ à¤¹à¥ˆ à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚',0),(161596,4489,'ms','Jika ada sesuatu yang hilang atau herot dalam penghantaran ini Sila hubungi',0),(161597,4489,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø£ÙŠ Ø´ÙŠØ¡ Ù…ÙÙ‚ÙˆØ¯ Ø£Ùˆ Ù…Ø´ÙˆÙ‡Ø© ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„Ø§ØªØµØ§Ù„',0),(161598,4489,'fr','Si un Ã©lÃ©ment est manquant ou dÃ©formÃ©e dans cette transmission s\'il vous plaÃ®t contacter',0),(161599,4489,'jp','ã?“ã?®é€?ä¿¡ä¸­ã?«ä½•ã?‹ã?Œã?ªã??ã?ªã?£ã?Ÿã‚Šã€?ã‚†ã?Œã‚?ã‚‰ã‚Œã?Ÿã‚Šã?—ã?Ÿã‚‰ã€?é€£çµ¡ã?—ã?¦ã??ã? ã?•ã?„',0),(161600,4489,'pt','Se algo estiver faltando ou distorcida nesta transmissÃ£o entre em contato',0),(161601,4489,'ru','Ð•ÑÐ»Ð¸ Ñ‡Ñ‚Ð¾-Ñ‚Ð¾ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¸Ð»Ð¸ Ð¸ÑÐºÐ°Ð¶ÐµÐ½ Ð² ÑÑ‚Ð¾Ð¹ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ðµ Ð¾Ð±Ñ€Ð°Ñ‰Ð°Ð¹Ñ‚ÐµÑÑŒ',0),(161602,4489,'es','Si algo se falta o esta distorsionado en esta transmisiÃ³n por favor contacta',0),(161603,4489,'de','Wenn etwas fehlt oder verzerrte in dieses Getriebes ist kontaktieren Sie bitte',0),(161604,4489,'en','If anything is missing or distorted in this transmission please contact',0),(161605,4490,'is','',0),(161606,4490,'dr','Ø§Ú¯Ø± Ø¢Ù†Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø±Ø¶Ø§ÙŠØª Ø´Ù…Ø§ Ù‡Ø³ØªÙ†Ø¯ â€“Ø¨Ø±Ú¯Ù‡ Ù…Ø¯Ø±Ùƒ Ø²ÙŠØ± Ø±Ø§ Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†ÙŠØ¯ Ùˆ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø§ÙŠÙ…ÙŠÙ„ ÙŠØ§ ÙÙƒØ³ Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†ÙŠØ¯ ',0),(161607,4490,'pr','Ø§Ú¯Ø± Ø¢Ù†Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø±Ø¶Ø§ÙŠØª Ø´Ù…Ø§ Ù‡Ø³ØªÙ†Ø¯ â€“Ø¨Ø±Ú¯Ù‡ Ù…Ø¯Ø±Ùƒ Ø²ÙŠØ± Ø±Ø§ Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†ÙŠØ¯ Ùˆ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø§ÙŠÙ…ÙŠÙ„ ÙŠØ§ ÙÙƒØ³ Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†ÙŠØ¯ ',0),(161608,4490,'tr','Prova sayfasÄ±nÄ± tÄ±klatÄ±n ve posta veya faks yoluyla iade memnun olduklarÄ±nÄ±, kayÄ±t',0),(161609,4490,'pl','JeÅ›li sÄ… one do zadowolenia, podpisanie arkusza prÃ³bnego poniÅ¼ej i z powrotem za poÅ›rednictwem faksu lub poczty',0),(161610,4490,'bg','ÐÐºÐ¾ Ñ‚Ðµ ÑÐ° Ð´Ð° Ð²Ð¸ ÑƒÐ´Ð¾Ð²Ð»ÐµÑ‚Ð²Ð¾Ñ€Ð¸, Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð° Ð»Ð¸ÑÑ‚ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ Ð¸ Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ Ð¿Ð¾ Ð¿Ð¾Ñ‰Ð°Ñ‚Ð° Ð¸Ð»Ð¸ Ð¿Ð¾ Ð¤Ð°ÐºÑ',0),(161611,4490,'ur','Ø§Ú¯Ø± ÙˆÛ Ø¢Ù¾ Ú©Û’ Ø§Ø·Ù…ÛŒÙ†Ø§Ù† Ú©Û’ Ù„Ø¦Û’ ÛÛŒÚºØŒ Ù†ÛŒÚ†Û’ Ø§ÙˆØ± Ù…ÛŒÙ„ ÛŒØ§ ÙÛŒÚ©Ø³ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ ÙˆØ§Ù¾Ø³ÛŒ Ú©Ø§ Ø«Ø¨ÙˆØª ÙˆØ±Ù‚ Ø³Ø§Ø¦Ù† Ø§Ù† Ú©Ø±ÛŒÚº Û”',0),(161612,4490,'sr','ÐÐºÐ¾ ÑÑƒ Ð¾Ð½Ð¸ Ð·Ð°Ð´Ð¾Ð²Ð¾Ñ™Ð½Ð¸, Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð´Ð¾ÐºÐ°Ð· Ð»Ð¸ÑÑ‚ Ð¸ÑÐ¿Ð¾Ð´ Ð¸ Ð¿Ð¾Ð²Ñ€Ð°Ñ›Ð°Ñ˜ Ð¿ÑƒÑ‚ÐµÐ¼ Ð¿Ð¾ÑˆÑ‚Ðµ Ð¸Ð»Ð¸ Ñ„Ð°ÐºÑÐ°',0),(161613,4490,'vi','Náº¿u báº¡n thá»a mÃ£n hÃ£y kÃ½ báº£n in thá»­ dÆ°á»›i Ä‘Ã¢y & fax hay email láº¡i cho chÃºng tÃ´i',0),(161614,4490,'af','As hulle jou bevrediging, teken die bewys vel hieronder en terug via e-pos of faks',0),(161615,4490,'ro','ÃŽn cazul Ã®n care acestea sunt spre satisfacÅ£ia dumneavoastrÄƒ, semneazÄƒ foaia de dovada de mai jos ÅŸi retur prin poÅŸtÄƒ sau fax',0),(161616,4490,'et','Kui nad on oma rahulolu, allkirjastada tÃµend lehte allapoole ja saatja e-posti vÃµi faksi teel',0),(161617,4490,'si','ÄŒe so vaÅ¡e zadovoljstvo, podpisati ponjave dokazilo spodaj in vrnitev preko poÅ¡te ali faksa',0),(161618,4490,'ba','Jika mereka untuk kepuasan Anda, menandatangani lembar bukti di bawah ini dan kembali melalui surat atau Faks',0),(161619,4490,'nl','Als ze naar uw tevredenheid, ondertekenen het controlevel hieronder en terug te keren via e-mail of fax',0),(161620,4490,'fi','Jos ne ovat teidÃ¤n tyytyvÃ¤isyys, kirjaudu vedosarkki alla ja palata postitse tai faksilla',0),(161621,4490,'no','Hvis de er til tilfredshet, registrere korrekturarket nedenfor og tilbake via e-post eller faks',0),(161622,4490,'da','Hvis de er til din tilfredshed, underskrive det korrekturark for fotos nedenfor og tilbage via mail eller fax',0),(161623,4490,'ko','ë§Œì•½ ê·¸ë“¤ì´ ë‹¹ì‹ ì˜ ë§Œì¡±ì—, ì„œëª… ì•„ëž˜ í•˜ ê³  ë©”ì¼ ë˜ëŠ” íŒ©ìŠ¤ë¥¼ í†µí•´ ë°˜í™˜ êµì •ì§€',0),(161624,4490,'he','×× ×”× ×œ×©×‘×™×¢×•×ª ×¨×¦×•× ×š, ×—×ª×™×ž×” ×‘×’×™×œ×™×•×Ÿ ×”×”×’×”×” ×œ×”×œ×Ÿ ×•×œ×—×–×•×¨ ×‘×“×•××¨ ××• ×¤×§×¡',0),(161625,4490,'el','Î•Î¬Î½ Ï€ÏÏŒÎºÎµÎ¹Ï„Î±Î¹ Î½Î± ÏƒÎ±Ï‚ Î¹ÎºÎ±Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ·, Ï…Ï€Î¿Î³ÏÎ¬Ï†ÎµÎ¹ Ï„Î¿ Ï†ÏÎ»Î»Î¿ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ ÎºÎ±Î¹ ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚ Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î® Ï†Î±Î¾',0),(161626,4490,'zh','å¦‚æžœæ‚¨æ»¡æ„ä»–ä»¬ï¼Œç­¾ç½²ä»¥ä¸‹è¯æ˜Žè¡¨å’Œé€šè¿‡é‚®å¯„æˆ–ä¼ çœŸ\r\n',0),(161627,4490,'sv','Om de Ã¤r till din belÃ¥tenhet, underteckna provarket nedan och tillbaka via mail eller fax',0),(161628,4490,'it','Se sono di vostro gradimento, firmare il foglio di prova qui sotto e restituito via mail o fax',0),(161629,4490,'tl','',0),(161630,4490,'th','If they are to your satisfaction, sign the proof sheet below and return via mail or fax',0),(161631,4490,'hi','à¤…à¤—à¤° à¤µà¥‡ à¤…à¤ªà¤¨à¥€ à¤¸à¤‚à¤¤à¥à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚, à¤¨à¥€à¤šà¥‡ à¤”à¤° à¤®à¥‡à¤² à¤¯à¤¾ à¤«à¥ˆà¤•à¥à¤¸ à¤•à¥‡ à¤œà¤°à¤¿à¤ à¤µà¤¾à¤ªà¤¸à¥€ à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤° à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°',0),(161632,4490,'ms','Jika mereka adalah untuk kepuasan anda, mendaftar dalam kira-kira bukti di bawah dan pulangan melalui mel atau Faks',0),(161633,4490,'ar','Ø¥Ø°Ø§ Ù„Ù… ØªÙƒÙ† Ø¹Ù„Ù‰ Ø§Ù„Ø§Ø±ØªÙŠØ§Ø­ Ø§Ù„Ø®Ø§Øµ Ø¨ÙƒØŒ Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù„Ù‰ ÙˆØ±Ù‚Ø© Ø§Ù„Ø§Ø®ØªØ¨Ø§Ø± Ø£Ø¯Ù†Ø§Ù‡ ÙˆØ§Ù„Ø¹ÙˆØ¯Ø© Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø£Ùˆ Ø§Ù„ÙØ§ÙƒØ³',0),(161634,4490,'fr','S\'ils sont Ã  votre entiÃ¨re satisfaction, signer la feuille de preuve ci-dessous et retour par courrier ou par fax',0),(161635,4490,'jp','ã‚‚ã?—ã?”æº€è¶³é ‚ã?‘ã?¾ã?—ã?Ÿã‚‰ã€?ä¸‹ã?®æ ¡æ­£ã‚·ãƒ¼ãƒˆã?«ç½²å??ã?—ã€?ãƒ¡ãƒ¼ãƒ«ã?‹ãƒ•ã‚¡ãƒƒã‚¯ã‚¹ã?«ã?¦è¿”å?´ã?—ã?¦ã??ã? ã?•ã?„',0),(161636,4490,'pt','Se eles sÃ£o a sua satisfaÃ§Ã£o, assinar a folha de prova abaixo e retorno via correio ou fax',0),(161637,4490,'ru','Ð•ÑÐ»Ð¸ Ð¾Ð½Ð¸ Ðº Ð²Ð°ÑˆÐµÐ¼Ñƒ ÑƒÐ´Ð¾Ð²Ð»ÐµÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ÑŽ, Ð¿Ð¾Ð´Ð¿Ð¸ÑˆÐ¸Ñ‚Ðµ Ð»Ð¸ÑÑ‚ Ð¿Ñ€Ð¾Ð±Ð½Ñ‹Ñ… Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚ÐºÐ¾Ð² Ð½Ð¸Ð¶Ðµ Ð¸ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð° Ð¿Ð¾ Ð¿Ð¾Ñ‡Ñ‚Ðµ Ð¸Ð»Ð¸ Ñ„Ð°ÐºÑÑƒ',0),(161638,4490,'es','Si estan a su satisfacciÃ³n, firma la hoja de prueba de impresiÃ³n abajo y regresa por email o fax',0),(161639,4490,'de','Wenn sie zu Ihrer Zufriedenheit sind, melden Sie dem Korrekturbogen unten und zurÃ¼ck per Post oder fax',0),(161640,4490,'en','If they are to your satisfaction, sign the proof sheet below and return via mail or fax',0),(161641,4491,'is','',0),(161642,4491,'dr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØºÙŠÙŠØ±Ø§Øª ÙŠØ§ ØªØµØ­ÙŠØ­ Ø¯Ø§Ø±ÙŠØ¯ â€“ Ù„Ø·ÙØ§ Ø¨Ù‡ Ù…Ø§ ÙÙƒØ³ ÙƒÙ†ÙŠØ¯ ÙŠØ§ Ø¨Ø§ Ù…Ø§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(161643,4491,'pr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØºÙŠÙŠØ±Ø§Øª ÙŠØ§ ØªØµØ­ÙŠØ­ Ø¯Ø§Ø±ÙŠØ¯ â€“ Ù„Ø·ÙØ§ Ø¨Ù‡ Ù…Ø§ ÙÙƒØ³ ÙƒÙ†ÙŠØ¯ ÙŠØ§ Ø¨Ø§ Ù…Ø§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(161644,4491,'tr','DeÄŸiÅŸiklik veya dÃ¼zeltme gerekiyorsa, lÃ¼tfen bize geri Faks veya bizi arayÄ±n',0),(161645,4491,'pl','JeÅ›li potrzebujesz zmiany lub korekty, proszÄ™ nam powrÃ³t faksu lub zadzwoÅ„ do nas',0),(161646,4491,'bg','ÐÐºÐ¾ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¸Ð»Ð¸ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸, Ð¼Ð¾Ð»Ñ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÑ‚Ðµ Ð½Ð¸ Ð¿Ð¾ fax Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾ Ð¸Ð»Ð¸ Ð½Ð¸ ÑÐµ Ð¾Ð±Ð°Ð´ÐµÑ‚Ðµ',0),(161647,4491,'ur','Ø§Ú¯Ø± Ø¢Ù¾ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº ÛŒØ§ Ø§ØµÙ„Ø§Ø­Ø§Øª Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ ØªÙˆ Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÛÙ…ÛŒÚº ÙˆØ§Ù¾Ø³ ÙÛŒÚ©Ø³ ÛŒØ§ ÛÙ…ÛŒÚº Ø§ÛŒÚ© ÙÙˆÙ† Ú©Ø± Ø¯ÛŒÙ†Ø§',0),(161648,4491,'sr','ÐÐºÐ¾ Ð²Ð°Ð¼ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð° Ð¸Ð»Ð¸ Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐµ, Ð¼Ð¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð½Ð°Ð¼ Ð¿Ð¾ÑÐ»Ð°Ñ‚Ð¸ Ð½Ð°Ð·Ð°Ð´ Ð¸Ð»Ð¸ Ð½Ð°Ñ Ð½Ð°Ð·Ð¾Ð²Ð¸',0),(161649,4491,'vi','Náº¿u cáº§n thay Ä‘á»•i hay chá»‰nh sá»­a vui lÃ²ng fax hoáº·c gá»i Ä‘iá»‡n cho chÃºng tÃ´i',0),(161650,4491,'af','Indien u enige veranderinge of wysigings verlang, stuur \'n faks of skakel ons',0),(161651,4491,'ro','DacÄƒ aveÅ£i nevoie de modificÄƒri sau corecturi, vÄƒ rugÄƒm sÄƒ fax-ne Ã®napoi sau sÄƒ ne dea un apel',0),(161652,4491,'et','Kui Te vajate muudatusi vÃµi parandusi, vÃµtke Ã¼hendust e-posti teel teenindus@nolapro.eu vÃµi helistage meile',0),(161653,4491,'si','ÄŒe morate spremembe ali popravki, prosim fax nas nazaj ali pa nas pokliÄite',0),(161654,4491,'ba','Jika Anda memerlukan perubahan atau koreksi, silakan Faks kami kembali atau hubungi kami',0),(161655,4491,'nl','Als u wijzigingen of correcties nodig hebt, kunt u fax ons terug of geef ons een seintje',0),(161656,4491,'fi','Jos tarvitset muutoksia tai korjauksia, lÃ¤hetÃ¤ ne takaisin tai soita',0),(161657,4491,'no','Hvis du trenger endringer eller korreksjoner, kan fakse oss tilbake eller ring oss',0),(161658,4491,'da','Hvis du har brug for Ã¦ndringer eller rettelser, venligst fax os tilbage eller Giv os et kald',0),(161659,4491,'ko','ë³€ê²½ ë˜ëŠ” ìˆ˜ì • í•´ì•¼ í•˜ëŠ” ê²½ìš° ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤ ë‹¤ì‹œ ìš°ë¦¬ì„ íŒ©ìŠ¤ ë˜ëŠ” ì „í™” ì£¼ì„¸ìš”',0),(161660,4491,'he','×× ××ª×” ×–×§×•×§ ×©×™× ×•×™×™× ××• ×ª×™×§×•× ×™×, × × ×¤×§×¡ ×œ× ×• ×‘×—×–×¨×” ××• ×ª×ª×§×©×¨ ××œ×™× ×•',0),(161661,4491,'el','Î•Î¬Î½ Ï‡ÏÎµÎ¹Î¬Î¶ÎµÏƒÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚ Î® Î´Î¹Î¿ÏÎ¸ÏŽÏƒÎµÎ¹Ï‚, Ï€Î±ÏÎ±ÎºÎ±Î»ÏŽ fax Î¼Î±Ï‚ Ï€Î¯ÏƒÏ‰, Î® Î½Î± Î¼Î±Ï‚ Î´ÏŽÏƒÎµÎ¹ Î¼Î¹Î± ÎºÎ»Î®ÏƒÎ·',0),(161662,4491,'zh','å¦‚æžœæ‚¨éœ€è¦æ›´æ”¹æˆ–æ›´æ­£ï¼Œè¯·å›žæˆ–å‘ä¼ çœŸç»™æˆ‘ä»¬æˆ–æ‰“ç”µè¯ç»™æˆ‘ä»¬\r\n',0),(161663,4491,'sv','Om du behÃ¶ver Ã¤ndringar eller korrigeringar, vÃ¤nligen faxa tillbaka eller ring oss',0),(161664,4491,'it','Se avete bisogno di modifiche o correzioni, per favore ci fax indietro o darci una chiamata',0),(161665,4491,'tl','',0),(161666,4491,'th','If you need changes or corrections, please fax us back or give us a call',0),(161667,4491,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¯à¤¾ à¤¸à¥à¤§à¤¾à¤° à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥ˆ, à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¹à¤®à¥‡à¤‚ à¤µà¤¾à¤ªà¤¸ à¤«à¥ˆà¤•à¥à¤¸ à¤¯à¤¾ à¤¹à¤®à¥‡à¤‚ à¤à¤• à¤«à¥‹à¤¨ à¤•à¤° à¤¦à¥‡à¤¨à¤¾',0),(161668,4491,'ms','Jika anda memerlukan perubahan atau pembetulan, sila Faks kami kembali atau hubungi kami',0),(161669,4491,'ar','Ø¥Ø°Ø§ ÙƒÙ†Øª Ø¨Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰ ØªØµØ­ÙŠØ­Ø§Øª Ø£Ùˆ ØªØºÙŠÙŠØ±Ø§ØªØŒ Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„ÙØ§ÙƒØ³ Ù„Ù†Ø§ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ Ø£Ùˆ ÙŠÙ‚Ø¯Ù… Ù„Ù†Ø§ Ø¯Ø¹ÙˆØ©',0),(161670,4491,'fr','Si vous avez besoin de changements ou des corrections, veuillez nous envoyer une tÃ©lÃ©copie retour ou donnez-nous un appel',0),(161671,4491,'jp','ã‚‚ã?—å¤‰æ›´ã‚„ä¿®æ­£ã?Œã?‚ã‚Šã?¾ã?—ã?Ÿã‚‰ã€?ãƒ•ã‚¡ãƒƒã‚¯ã‚¹ã?§è¿”é€?ã‚‚ã?—ã??ã?¯ã?Šé›»è©±ä¸‹ã?•ã?„',0),(161672,4491,'pt','Se precisar de alteraÃ§Ãµes ou correÃ§Ãµes, por favor envie fax de volta ou ligue para nÃ³s',0),(161673,4491,'ru','Ð•ÑÐ»Ð¸ Ð²Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ñ‡Ñ‚Ð¾-Ñ‚Ð¾ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð»Ð¸Ð±Ð¾ Ð¾Ñ‚ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÑŒÑ‚Ðµ Ð½Ð°Ð¼ Ñ„Ð°ÐºÑ Ð¸Ð»Ð¸ Ð¿ÐµÑ€ÐµÐ·Ð²Ð¾Ð½Ð¸Ñ‚Ðµ',0),(161674,4491,'es','Si necesita cambios o correcciones, por favor nos manda un fax o nos llama',0),(161675,4491,'de','Wenn Sie Ã„nderungen oder Korrekturen, bitte faxen Sie uns oder rufen Sie uns an',0),(161676,4491,'en','If you need changes or corrections, please fax us back or give us a call',0),(161677,4492,'is','',0),(161678,4492,'dr','/ Ø¨Ø±Ú¯Ø´Øª ',0),(161679,4492,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ù…Ø¯Ø±Ùƒ  ÙØ±Ø³ØªØ§Ø¯Ù†  / Ø¨Ø±Ú¯Ø´Øª ',0),(161680,4492,'tr','KanÄ±t gÃ¶nder/dÃ¶nÃ¼ÅŸ iÃ§in sipariÅŸ',0),(161681,4492,'pl','Aby dowÃ³d Send/Return',0),(161682,4492,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ/Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ',0),(161683,4492,'ur','Ø«Ø¨ÙˆØª Ø¨Ú¾ÛŒØ¬ÛŒÚº/ÙˆØ§Ù¾Ø³ÛŒ Ú©ÛŒÙ„Ø¦Û’ Ø¢Ø±ÚˆØ±',0),(161684,4492,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° Ð´Ð¾ÐºÐ°Ð· ÑÐ»Ð°ÑšÐµ/Ð¿Ð¾Ð²Ñ€Ð°Ñ‚Ð°Ðº',0),(161685,4492,'vi','Gá»­i/quay láº¡i YÃªu cáº§u xÃ¡c nháº­n',0),(161686,4492,'af','Bestelling vir bewys stuur/opbrengs',0),(161687,4492,'ro','Pentru ca dovada Send/Return',0),(161688,4492,'et','Selleks, et tÃµendit saada/tagastamine',0),(161689,4492,'si','Nalog za dokaz spodbuda/odziv',0),(161690,4492,'ba','Agar mengirim/kembali bukti',0),(161691,4492,'nl','Volgorde voor bewijs Send/Return',0),(161692,4492,'fi','Jotta todiste Send/Return',0),(161693,4492,'no','For at bevis sende/retur',0),(161694,4492,'da','RÃ¦kkefÃ¸lge for bevis Send/Return',0),(161695,4492,'ko','ìœ„í•´ì„œ ì¦ê±° ë³´ë‚´/ë°˜í™˜',0),(161696,4492,'he','×¡×“×¨ ×¢×‘×•×¨ ×©×œ×™×—×” ×”×•×›×—×” ×”×œ×•×š ×•×©×•×‘',0),(161697,4492,'el','Î“Î¹Î± Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®/ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(161698,4492,'zh','å‘é€/è¿”å›žè¯æ˜Žè®¢å•\r\n',0),(161699,4492,'sv','FÃ¶r bevis skicka/RETUR',0),(161700,4492,'it','Ordine per la prova di Send/Return',0),(161701,4492,'tl','',0),(161702,4492,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3626;&#3656;&#3591;/&#3588;&#3639;&#3609;',0),(161703,4492,'hi','à¤¸à¤¬à¥‚à¤¤ à¤­à¥‡à¤œ/à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶',0),(161704,4492,'ms','Untuk hantar/kembali bukti',0),(161705,4492,'ar','Ø§Ù„ØªØ±ØªÙŠØ¨ Ù„Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰ Ø¥Ø±Ø³Ø§Ù„/Ø¹ÙˆØ¯Ø©',0),(161706,4492,'fr','Pour qu\'une preuve d\'envoi/retour',0),(161707,4492,'jp','æ ¡æ­£æ³¨æ–‡é€?ä¿¡/è¿”å?´',0),(161708,4492,'pt','Ordem para envio/retorno Ã  prova',0),(161709,4492,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð° Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ Ð¸ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ñ',0),(161710,4492,'es','Pedido para Prueba de ImpresiÃ³n Enviar/Regresar',0),(161711,4492,'de','Bestellung fÃ¼r Beweis Send/Return',0),(161712,4492,'en','Order for Proof Send/Return',0),(161713,4493,'is','',0),(161714,4493,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ù†Ø¯ Ø³ÙØ§Ø±Ø´ ',0),(161715,4493,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ù†Ø¯ Ø³ÙØ§Ø±Ø´ ',0),(161716,4493,'tr','KanÄ±t sipariÅŸ numarasÄ±',0),(161717,4493,'pl','Numer dowodu',0),(161718,4493,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(161719,4493,'ur','Ø«Ø¨ÙˆØª Ù†Ù…Ø¨Ø± Ú©Ø§ Ø­Ú©Ù…',0),(161720,4493,'sr','Ð”Ð¾ÐºÐ°Ð· Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(161721,4493,'vi','Sá»‘ chá»©ng nháº­n Ä‘Æ¡n hÃ ng',0),(161722,4493,'af','Bestelling \"Proof\" Nommer',0),(161723,4493,'ro','NumÄƒrul de ordine dovada',0),(161724,4493,'et','TÃµend jÃ¤rjekorranumber',0),(161725,4493,'si','Dokaz Å¡tevilka naloga',0),(161726,4493,'ba','Nomor pesanan bukti',0),(161727,4493,'nl','Bewijs ordernummer',0),(161728,4493,'fi','Todiste numero',0),(161729,4493,'no','Ordrenummeret bevis',0),(161730,4493,'da','Ordrenummer bevis',0),(161731,4493,'ko','ì£¼ë¬¸ ì¦ê±° ìˆ˜',0),(161732,4493,'he','×ž×¡×¤×¨ ×”×–×ž× ×” ×”×•×›×—×”',0),(161733,4493,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î‘ÏÎ¾Ï‰Î½Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(161734,4493,'zh','è®¢å•è¯æ˜Žç¼–å·\r\n',0),(161735,4493,'sv','Bevis nummer',0),(161736,4493,'it','Prova numero ordine',0),(161737,4493,'tl','',0),(161738,4493,'th','&#3605;&#3619;&#3623;&#3592;&#3619;&#3656;&#3634;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(161739,4493,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤¬à¥‚à¤¤ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(161740,4493,'ms','Nombor bukti pesanan',0),(161741,4493,'ar','Ø±Ù‚Ù… Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰ Ø£Ù…Ø±',0),(161742,4493,'fr','Preuve numÃ©ro de commande',0),(161743,4493,'jp','æ³¨æ–‡æ ¡æ­£ç•ªå?·',0),(161744,4493,'pt','NÃºmero de prova ordem',0),(161745,4493,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(161746,4493,'es','Orden NÃºmero de Prueba de ImpresiÃ³n',0),(161747,4493,'de','Beweis Bestellnummer',0),(161748,4493,'en','Order Proof Number',0),(161749,4494,'is','',0),(161750,4494,'dr','(Ø«Ø§Ø¨Øª Ù†Ø´Ø¯Ù‡) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(161751,4494,'pr','Ø®Ø§Ø±Ø¬ Ø§Ø² Ù…Ø¯Ø±Ùƒ(Ø«Ø§Ø¨Øª Ù†Ø´Ø¯Ù‡) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(161752,4494,'tr','DÄ±ÅŸarÄ± iÃ§in kanÄ±t baÅŸarÄ±yla oluÅŸturuldu',0),(161753,4494,'pl','Na dowÃ³d zostaÅ‚ utworzony pomyÅ›lnie',0),(161754,4494,'bg','Ð”Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(161755,4494,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ù†Ø§ Ø«Ø¨ÙˆØª Ú©Û’ Ù„ÛŒÛ’ Ø¨Ø§ÛØ±',0),(161756,4494,'sr','Ð£ Ð½Ð°Ð¼Ð° Ð´Ð¾ÐºÐ°Ð· Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°',0),(161757,4494,'vi','Táº¡o NgoÃ i báº£n in thá»­ thÃ nh cÃ´ng',0),(161758,4494,'af','Uit om te bewys suksesvol geskep',0),(161759,4494,'ro','AfarÄƒ la dovada creat cu succes',0),(161760,4494,'et','VÃ¤lja tÃµendi loomine Ãµnnestus',0),(161761,4494,'si','Ven za dokaz uspeÅ¡no ustvarjen',0),(161762,4494,'ba','Untuk bukti yang dibuat dengan sukses',0),(161763,4494,'nl','Out bewijs met succes gemaakt',0),(161764,4494,'fi','Ulos todiste luonti onnistui',0),(161765,4494,'no','Ut bevis opprettet',0),(161766,4494,'da','Ud til bevis oprettet',0),(161767,4494,'ko','ì„±ê³µì ìœ¼ë¡œ ë§Œë“  ì¦ê±°ë¥¼',0),(161768,4494,'he','×”×—×•×¦×” ×”×•×›×—×” × ×•×¦×¨×• ×‘×”×¦×œ×—×”',0),(161769,4494,'el','ÎˆÎ¾Ï‰ ÏƒÏ„Î·Î½ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(161770,4494,'zh','å‡ºè¯æ˜Žåˆ›å»ºæˆåŠŸ\r\n',0),(161771,4494,'sv','Ut till bevis har skapats',0),(161772,4494,'it','Fuori di prova creato con successo',0),(161773,4494,'tl','',0),(161774,4494,'th','&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(161775,4494,'hi','à¤¬à¤¾à¤¹à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¨à¤¾à¤ à¤—à¤ à¤¸à¤¬à¥‚à¤¤',0),(161776,4494,'ms','Keluar untuk bukti yang berjaya dicipta',0),(161777,4494,'ar','Ø¨Ø§Ù„Ø®Ø§Ø±Ø¬ Ù„Ø¥Ø«Ø¨Ø§Øª ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(161778,4494,'fr','Ã€ preuve, crÃ©Ã©e avec succÃ¨s',0),(161779,4494,'jp','Out to Proof created successfully',0),(161780,4494,'pt','A prova criada com sucesso',0),(161781,4494,'ru','Ð’ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½',0),(161782,4494,'es','Fuera para Prueba de ImpresiÃ³n creado exitosamente',0),(161783,4494,'de','Raus zum Beweis wurde erfolgreich erstellt.',0),(161784,4494,'en','Out to Proof created successfully',0),(161785,4495,'is','',0),(161786,4495,'dr','- Ú†Ø§Ù¾ ÙØ±Ù…',0),(161787,4495,'pr','Ø®Ø§Ø±Ø¬ Ø¯Ø± Ù…Ø¯Ø±Ùƒ  - Ú†Ø§Ù¾ ÙØ±Ù…',0),(161788,4495,'tr','DÄ±ÅŸarÄ± iÃ§in kanÄ±t - formu yazdÄ±r',0),(161789,4495,'pl','Na dowÃ³d - Drukuj formularz',0),(161790,4495,'bg','Ð˜Ð·Ð»ÑÐ·ÑŠÐ» Ð·Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ - Ñ„Ð¾Ñ€Ð¼Ð° Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(161791,4495,'ur','Ø¨Ø§ÛØ± Ú©Ø±Ù†Û’ Ú©Ø§ Ø«Ø¨ÙˆØª - ÙØ§Ø±Ù… Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº',0),(161792,4495,'sr','ÐÐ°Ð¿Ð¾Ñ™Ðµ Ð½Ð° Ð´Ð¾ÐºÐ°Ð· - ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ†Ð°',0),(161793,4495,'vi','NgoÃ i báº£n in thá»­ - Máº«u in',0),(161794,4495,'af','Uit om te bewys - druk vorm',0),(161795,4495,'ro','AfarÄƒ la dovada - imprimÄƒ formularul',0),(161796,4495,'et','Out Proof - Prindi vorm',0),(161797,4495,'si','Ven za dokaz - Natisni obrazec',0),(161798,4495,'ba','Keluar untuk bukti - cetak formulir',0),(161799,4495,'nl','Out To Proof - formulier afdrukken',0),(161800,4495,'fi','Ulos nÃ¤yttÃ¶ - lomakkeen tulostaminen',0),(161801,4495,'no','Ut bevis - skjemaet',0),(161802,4495,'da','Ud til bevis - Udskriv formularen',0),(161803,4495,'ko','ì–‘ì‹ì„ ì¸ì‡„ ì¦ê±°-ë°–ìœ¼ë¡œ',0),(161804,4495,'he','×”×—×•×¦×” ×”×•×›×—×” - ×œ×”×“×¤×™×¡ ××ª ×”×˜×•×¤×¡',0),(161805,4495,'el','ÎˆÎ¾Ï‰ ÏƒÏ„Î·Î½ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· - Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï†ÏŒÏÎ¼Î±Ï‚',0),(161806,4495,'zh','å‡ºè¯æ˜Ž- æ‰“å°è¡¨æ ¼\r\n',0),(161807,4495,'sv','Ut till bevis - Skriv ut formulÃ¤r',0),(161808,4495,'it','Uscire a prova - stampare il modulo',0),(161809,4495,'tl','',0),(161810,4495,'th','&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609; - &#3614;&#3636;&#3617;&#3614;&#3660;&#3615;&#3629;&#3619;&#3660;&#3617;',0),(161811,4495,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¬à¥‚à¤¤ - à¤¬à¤¾à¤¹à¤°',0),(161812,4495,'ms','Keluar untuk bukti - cetak borang',0),(161813,4495,'ar','Ø¨Ø§Ù„Ø®Ø§Ø±Ø¬ Ù„Ø¥Ø«Ø¨Ø§Øª-Ø·Ø¨Ø§Ø¹Ø© Ù†Ù…ÙˆØ°Ø¬',0),(161814,4495,'fr','Sortir Ã  la preuve - imprimer le formulaire',0),(161815,4495,'jp','Out To Proof - Print Form',0),(161816,4495,'pt','Fora a prova - imprimir formulÃ¡rio',0),(161817,4495,'ru','Ð˜Ð· Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð° - Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ñ„Ð¾Ñ€Ð¼Ñ‹',0),(161818,4495,'es','Fuera para Prueba de ImpresiÃ³n - Formulario de Imprimir',0),(161819,4495,'de','Out To Proof - Formular drucken',0),(161820,4495,'en','Out To Proof - Print Form',0),(161821,4496,'is','',0),(161822,4496,'dr','Ù„Ø·ÙØ§ Ø§ÙŠÙ† Ø±Ø§ ÙŠÙƒ Ø§ÙˆÙ„ÙˆÙŠØª Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÙŠØ¯ ÙƒÙ‡ Ø´Ù…Ø§ ØªØ§Ø±ÙŠØ® Ø³Ø± Ø±Ø³ÙŠØ¯ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø±Ø§ ØªØ·Ø§Ø¨Ù‚ Ø¯Ø§Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(161823,4496,'pr','Ù„Ø·ÙØ§ Ø§ÙŠÙ† Ø±Ø§ ÙŠÙƒ Ø§ÙˆÙ„ÙˆÙŠØª Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÙŠØ¯ ÙƒÙ‡ Ø´Ù…Ø§ ØªØ§Ø±ÙŠØ® Ø³Ø± Ø±Ø³ÙŠØ¯ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø±Ø§ ØªØ·Ø§Ø¨Ù‚ Ø¯Ø§Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(161824,4496,'tr','LÃ¼tfen bu biz senin gerekli karÅŸÄ±lamak saÄŸlamak iÃ§in bir Ã¶ncelik haline son tarih',0),(161825,4496,'pl','NaleÅ¼y nadaÄ‡ priorytet do zapewnienia, Å¼e spotykamy siÄ™ wymagane termin',0),(161826,4496,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð¾Ð²Ð° Ðµ Ð¿Ñ€Ð¸Ð¾Ñ€Ð¸Ñ‚ÐµÑ‚ Ð´Ð° Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð¸Ñ€Ð°Ñ‚, Ñ‡Ðµ ÑÐµ ÑÑ€ÐµÑ‰Ð°Ð¼Ðµ Ð¸Ð·Ð¸ÑÐºÐ²Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶',0),(161827,4496,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÛŒÛ Ù¾ÙˆØ±Ø§ Ú©Û ÛÙ… Ø¢Ù¾ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª Ú©Ùˆ ÛŒÙ‚ÛŒÙ†ÛŒ Ø¨Ù†Ø§Ù†Û’ Ú©Ùˆ ØªØ±Ø¬ÛŒØ­ Ø¯ÛŒØªÛ’ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ ØªØ§Ø±ÛŒØ®',0),(161828,4496,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ Ð¾Ð²Ð¾ Ð¿Ñ€Ð¸Ð¾Ñ€Ð¸Ñ‚ÐµÑ‚ Ð´Ð° Ð¾ÑÐ¸Ð³ÑƒÑ€Ð° Ð´Ð° ÑÐµ Ð²Ð¸Ð´Ð¸Ð¼Ð¾ Ñ‚Ð²Ð¾Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(161829,4496,'vi','Vui lÃ²ng Æ°u tiÃªn cho viá»‡c nÃ y trÆ°á»›c Ä‘á»ƒ chÃºng tÃ´i cÃ³ thá»ƒ giao hÃ ng Ä‘Ãºng háº¡n',0),(161830,4496,'af','Maak dit asseblief \'n prioriteit om seker te maak dat ons u nodige verskuldigde datum bereik',0),(161831,4496,'ro','VÄƒ rugÄƒm sÄƒ faceÅ£i acest lucru o prioritate pentru a se asigura cÄƒ ne vom Ã®ntÃ¢lni dumneavoastrÄƒ cere data scadenÅ£ei',0),(161832,4496,'et','Palun tehke see prioriteet tÃ¤ita oma nÃµutud tÃ¤htpÃ¤evaks',0),(161833,4496,'si','Prosimo, da to prednostna naloga za zagotovitev, da sreÄamo vaÅ¡e zahtevane datum zapadlosti',0),(161834,4496,'ba','Silakan membuat ini menjadi prioritas untuk memastikan bahwa kami memenuhi Anda diperlukan tanggal jatuh tempo',0),(161835,4496,'nl','Maak dit een prioriteit om ervoor te zorgen dat we voldoen aan uw vereiste vervaldatum',0),(161836,4496,'fi','Tee tÃ¤mÃ¤ ensisijaisesti huolta sinun tarvitse erÃ¤pÃ¤ivÃ¤',0),(161837,4496,'no','Vennligst gjÃ¸r dette til en prioritet Ã¥ sikre at vi mÃ¸ter den nÃ¸dvendige forfallsdato',0),(161838,4496,'da','Venligst gÃ¸re dette til en prioritet at sikre, at vi opfylder dit behov forfaldsdato',0),(161839,4496,'ko','ì´ ê²Œ ìš°ë¦¬ê°€ ë‹¹ì‹ ì˜ í•„ìš” ì¶©ì¡± ìš°ì„ ê¶Œ ê¸°í•œ',0),(161840,4496,'he','. ×‘×‘×§×©×” ×©×–×” ×™×”×™×” ×‘×¢×“×™×¤×•×ª ×”×¨××©×•× ×” ×›×“×™ ×œ×”×‘×˜×™×— ×›×™ ×× ×—× ×• × ×¤×’×©×™× required ×ª××¨×™×š ×™×¢×“',0),(161841,4496,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎºÎ¬Î½ÎµÏ„Îµ Î±Ï…Ï„ÏŒ Ï‰Ï‚ Ï€ÏÎ¿Ï„ÎµÏÎ±Î¹ÏŒÏ„Î·Ï„Î± Î½Î± Î´Î¹Î±ÏƒÏ†Î±Î»Î¯ÏƒÎ¿Ï…Î¼Îµ ÏŒÏ„Î¹ Î¸Î± Î¹ÎºÎ±Î½Î¿Ï€Î¿Î¹Î®ÏƒÎ¿Ï…Î¼Îµ ÏƒÎ±Ï‚ Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î—Î¼/Î½Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(161842,4496,'zh','è¯·ä½¿ä¹‹æˆä¸ºé¦–è¦ä»»åŠ¡ä»¥ç¡®ä¿æˆ‘ä»¬æ»¡è¶³æ‚¨è¦æ±‚çš„æˆªæ­¢æ—¥æœŸ\r\n',0),(161843,4496,'sv','VÃ¤nligen gÃ¶ra detta till en prioritet att se till att vi uppfyller din krÃ¤vs fÃ¶rfallodatum',0),(161844,4496,'it','Si prega di fare questo una prioritÃ  per garantire che incontriamo vostro richiesto Data scadenza',0),(161845,4496,'tl','',0),(161846,4496,'th','Please make this a priority to ensure that we meet your required due date',0),(161847,4496,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¯à¤¹ à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤¹à¤® à¤†à¤ªà¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤•à¥‹ à¤ªà¥‚à¤°à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤ªà¥à¤°à¤¾à¤¥à¤®à¤¿à¤•à¤¤à¤¾ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(161848,4496,'ms','Sila membuat ini keutamaan untuk memastikan bahawa kita memenuhi anda dikehendaki tarikh matang',0),(161849,4496,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¬Ø¹Ù„ Ù‡Ø°Ø§ Ø£ÙˆÙ„ÙˆÙŠØ© Ø¶Ù…Ø§Ù† Ø£Ù† Ù†Ù„ØªÙ‚ÙŠ Ø¨Ùƒ Ù…Ø·Ù„ÙˆØ¨ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(161850,4496,'fr','S\'il vous plaÃ®t faire une prioritÃ© afin d\'assurer que nous rencontrons votre requis date d\'Ã©chÃ©ance',0),(161851,4496,'jp','å¿…è¦?ã?ªæœŸæ—¥ã?«é–“ã?«å?ˆã?†ã‚ˆã?†ç¢ºå®Ÿã?«ã?™ã‚‹ã?Ÿã‚?ã?“ã‚Œã‚’å„ªå…ˆã?™ã‚‹ã€‚',0),(161852,4496,'pt','Por favor, faÃ§a isto uma prioridade para garantir que podemos atender sua exigida data de vencimento',0),(161853,4496,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑÐ´ÐµÐ»Ð°Ð¹Ñ‚Ðµ ÑÑ‚Ð¾ Ð¿Ñ€Ð¸Ð¾Ñ€Ð¸Ñ‚ÐµÑ‚, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡Ð¸Ñ‚ÑŒ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¸Ðµ Ð²Ð°ÑˆÐµÐ³Ð¾ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð”Ð°Ñ‚Ð°',0),(161854,4496,'es','Por favor hacer este acciÃ³n un prioridad para asegurar que se satisfacer la fecha de vencimiento',0),(161855,4496,'de','Bitte stellen Sie dies eine PrioritÃ¤t, um sicherzustellen, dass wir Ihre erforderlichen erfÃ¼llen FÃ¤lligkeitsdatum',0),(161856,4496,'en','Please make this a priority to ensure that we meet your required due date',0),(161857,4497,'is','',0),(161858,4497,'dr','Ù„Ø·ÙØ§ ØµÙØ­Ø§Øª Ø²ÙŠØ± Ø±Ø§ ØªØµØ­ÙŠØ­ ÙƒÙ†ÙŠØ¯ ',0),(161859,4497,'pr','Ù„Ø·ÙØ§ ØµÙØ­Ø§Øª Ø²ÙŠØ± Ø±Ø§ ØªØµØ­ÙŠØ­ ÙƒÙ†ÙŠØ¯ ',0),(161860,4497,'tr','LÃ¼tfen aÅŸaÄŸÄ±daki sayfalarÄ± tashih',0),(161861,4497,'pl','Prosimy o przeczytanie nastÄ™pujÄ…cych stron',0),(161862,4497,'bg','ÐœÐ¾Ð»Ñ Ð´Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÑ‚ ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(161863,4497,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ ØµÙØ­Ø§Øª Ú©ÛŒ Ø§ØµÙ„Ø§Ø­',0),(161864,4497,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ»ÐµÐ´ÐµÑ›Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(161865,4497,'vi','Vui lÃ²ng Ä‘á»c kiá»ƒm tra nhá»¯ng trang sau',0),(161866,4497,'af','Proeflees asseblief die volgende blaaie',0),(161867,4497,'ro','VÄƒ rugÄƒm sÄƒ proofread urmÄƒtoarele pagini',0),(161868,4497,'et','Palun teostage jÃ¤rgnevatel lehtedel vigadeparandus',0),(161869,4497,'si','Prosim korekturu na naslednjih straneh',0),(161870,4497,'ba','Harap mengoreksi Halaman berikut',0),(161871,4497,'nl','Gelieve de volgende pagina\'s te proeflezen',0),(161872,4497,'fi','Severity seuraavilla sivuilla',0),(161873,4497,'no','Vennligst korrekturlese fÃ¸lgende sider',0),(161874,4497,'da','Venligst lÃ¦se korrektur pÃ¥ de fÃ¸lgende sider',0),(161875,4497,'ko','ë‹¤ìŒ íŽ˜ì´ì§€ë¥¼ êµì • í•˜ì‹­ì‹œì˜¤',0),(161876,4497,'he','× × ×œ×”×’×™×” ×”×¢×ž×•×“×™× ×”×‘××™×',0),(161877,4497,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Î½Î± Î´Î¹Î¿ÏÎ¸ÏŽÏƒÎ¿Ï…Î½ Ï„Î¹Ï‚ Î±ÎºÏŒÎ»Î¿Ï…Î¸ÎµÏ‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚',0),(161878,4497,'zh','è¯·æ ¡å¯¹ä»¥ä¸‹é¡µé¢\r\n',0),(161879,4497,'sv','VÃ¤nligen korrekturlÃ¤sa fÃ¶ljande sidor',0),(161880,4497,'it','Per favore Correggi le pagine seguenti',0),(161881,4497,'tl','',0),(161882,4497,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3629;&#3656;&#3634;&#3609;&#3619;&#3656;&#3634;&#3591;&#3607;&#3637;&#3656;&#3627;&#3609;&#3657;&#3634;&#3586;&#3657;&#3634;&#3591;&#3621;&#3656;&#3634;&#3591;&#3609;&#3637;&#3657;',0),(161883,4497,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¨à¤¿à¤®à¥à¤¨ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤ à¥€à¤• à¤•à¤°à¤¨à¤¾',0),(161884,4497,'ms','Sila baca lagi laman berikut',0),(161885,4497,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¯Ù‚ÙŠÙ‚ Ø§Ù„ØµÙØ­Ø§Øª Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(161886,4497,'fr','Veuillez relire les pages qui suivent',0),(161887,4497,'jp','æ¬¡ã?®ãƒšãƒ¼ã‚¸ã‚’æ§‹æˆ?ã?—ã?¦ã??ã? ã?•ã?„',0),(161888,4497,'pt','Por favor, revise as seguintes pÃ¡ginas',0),(161889,4497,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÐ¹Ñ‚Ðµ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹',0),(161890,4497,'es','Por Favor corregir el texto delas siguentes pÃ¡ginas',0),(161891,4497,'de','Korrigieren Sie bitte die folgenden Seiten',0),(161892,4497,'en','Please proofread the following pages',0),(161893,4498,'is','',0),(161894,4498,'dr','Ù„Ø·ÙØ§ Ø§ÙŠÙ† Ø¨Ø±Ú¯Ù‡ Ø³Ù†Ø¯ Ø±Ø§ Ø¨Ø§ Ø°ÙƒØ± ØªØ§Ø±ÙŠØ® Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†ÙŠØ¯  Ùˆ Ø¨ÙØ±Ø³ØªÙŠØ¯ Ø¨Ù‡ ',0),(161895,4498,'pr','Ù„Ø·ÙØ§ Ø§ÙŠÙ† Ø¨Ø±Ú¯Ù‡ Ø³Ù†Ø¯ Ø±Ø§ Ø¨Ø§ Ø°ÙƒØ± ØªØ§Ø±ÙŠØ® Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†ÙŠØ¯  Ùˆ Ø¨ÙØ±Ø³ØªÙŠØ¯ Ø¨Ù‡ ',0),(161896,4498,'tr','LÃ¼tfen imzalayÄ±n ve bu prova sayfasÄ± Tarih ve geri dÃ¶ner',0),(161897,4498,'pl','ProszÄ™ zarejestrowaÄ‡ i data tego arkusza prÃ³bnego i odesÅ‚aÄ‡ go do',0),(161898,4498,'bg','ÐœÐ¾Ð»Ñ Ð²Ð»ÐµÐ·Ñ‚Ðµ Ð¸ Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð»Ð¸ÑÑ‚ Ð¸ Ð³Ð¾ Ð²Ñ€ÑŠÑ‰Ð° ÐºÑŠÐ¼',0),(161899,4498,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø³Ø§Ø¦Ù† Ø§Ù† Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø§Ø³ Ú©Ø§ Ø«Ø¨ÙˆØª ÙˆØ±Ù‚ ØªØ§Ø±ÛŒØ® Ø§ÙˆØ± Ø§Ø³Û’ ÙˆØ§Ù¾Ø³',0),(161900,4498,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¾Ð²Ð°Ñ˜ Ð´Ð¾ÐºÐ°Ð· Ð»Ð¸ÑÑ‚ Ð¸ Ð´Ð° ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸',0),(161901,4498,'vi','Vui lÃ²ng kÃ½, ghi ngÃ y báº£n in thá»­ nÃ y & gá»­i láº¡i cho',0),(161902,4498,'af','Onderteken en dateer Asseblief hierdie proefvel en besorg dit terug na',0),(161903,4498,'ro','VÄƒ rugÄƒm sÄƒ semneze ÅŸi data aceastÄƒ foaie de dovada ÅŸi returnaÅ£i-l la',0),(161904,4498,'et','Palun Logi ja praeguseks selle tÃµendi leht ja tagastab',0),(161905,4498,'si','Prosim prijavite in datum Ta osnutek in ga vrne za',0),(161906,4498,'ba','Silakan masuk dan tanggal lembar bukti ini dan kembali ke',0),(161907,4498,'nl','Gelieve te ondertekenen en dateren van dit bewijs blad en terug te sturen naar',0),(161908,4498,'fi','Kirjaudu ja toistaiseksi tÃ¤mÃ¤ vedosarkki ja palauttaa sen',0),(161909,4498,'no','Logg deg og dato dette korrekturarket og returnere det til',0),(161910,4498,'da','Venligst underskrive og dato dette indeksprint og returnere det til',0),(161911,4498,'ko','ì œë°œ ì„œëª… í•˜ ê³ ì´ êµì •ì§€ ë‚ ì§œì™€ ê·¸ê²ƒì„ ë°˜í™˜í•©ë‹ˆë‹¤',0),(161912,4498,'he','× × ×œ×—×ª×•×, ×ª××¨×™×š ×’×™×œ×™×•×Ÿ ×–×” ×”×•×›×—×”, ×œ×”×—×–×™×¨ ×œ×• ××ª',0),(161913,4498,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ ÎºÎ±Î¹ ÏƒÎ®Î¼ÎµÏÎ± Î±Ï…Ï„ÏŒ Ï„Î¿ Ï†ÏÎ»Î»Î¿ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· ÎºÎ±Î¹ Î½Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ­ÏˆÎµÎ¹',0),(161914,4498,'zh','è¯·ç­¾åå¹¶æ³¨æ˜Žè¿™è¯æ˜Žæ—¥æœŸè¡¨å¹¶äº¤å›ž\r\n',0),(161915,4498,'sv','VÃ¤nligen underteckna och datum hÃ¤r provark och returnera den till',0),(161916,4498,'it','Accedi e oggi questo foglio di prova e restituirlo al',0),(161917,4498,'tl','',0),(161918,4498,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3649;&#3621;&#3632;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3619;&#3656;&#3634;&#3591;&#3609;&#3637;&#3657;&#3649;&#3',0),(161919,4498,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤‡à¤¸ à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤° à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤”à¤° à¤‡à¤¸à¥‡ à¤µà¤¾à¤ªà¤¸',0),(161920,4498,'ms','Sila daftar dan tarikh lembaran bukti ini dan kembali kepada',0),(161921,4498,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªÙˆÙ‚ÙŠØ¹ ÙˆØªØ§Ø±ÙŠØ® Ù‡Ø°Ø§ ÙˆØ±Ù‚Ø© Ø§Ù„Ø§Ø®ØªØ¨Ø§Ø± ÙˆØ¥Ø¹Ø§Ø¯ØªÙ‡ Ø¥Ù„Ù‰',0),(161922,4498,'fr','Veuillez signer et dater cette feuille de preuve et le retourner Ã ',0),(161923,4498,'jp','ã?“ã?®æ ¡æ­£ã‚·ãƒ¼ãƒˆã?«ç½²å??ã?¨æ—¥ã?«ã?¡ã‚’ã?„ã‚Œã?¦ï½žã?¾ã?§è¿”å?´ã?—ã?¦ã??ã? ã?•ã?„',0),(161924,4498,'pt','Por favor assine e data esta folha de prova e devolvÃª-lo',0),(161925,4498,'ru','ÐŸÑ€Ð¾ÑÑŒÐ±Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ð¸ Ð”Ð°Ñ‚Ð° ÑÑ‚Ð¾Ñ‚ Ð»Ð¸ÑÑ‚ Ð¿Ñ€Ð¾Ð±Ð½Ñ‹Ñ… Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚ÐºÐ¾Ð² Ð¸ Ð²ÐµÑ€Ð½ÑƒÑ‚ÑŒ ÐµÐ³Ð¾',0),(161926,4498,'es','Por favor firmar y fechar esta prueba de impresiÃ³n y devuelvala a',0),(161927,4498,'de','Bitte unterschreiben und datieren diese Korrekturbogen und bringe Sie',0),(161928,4498,'en','Please sign and date this proof sheet and return it to',0),(161929,4499,'is','',0),(161930,4499,'dr','Ú†Ø§Ù¾ Ø³Ù†Ø¯ ÙÙƒØ³ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(161931,4499,'pr','Ú†Ø§Ù¾ Ø³Ù†Ø¯ ÙÙƒØ³ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(161932,4499,'tr','Faks saÄŸlamasÄ± iÃ§in sipariÅŸ YazdÄ±r',0),(161933,4499,'pl','WydrukowaÄ‡ faks dowÃ³d na zamÃ³wienie',0),(161934,4499,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ñ„Ð°ÐºÑ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(161935,4499,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ ÙÛŒÚ©Ø³ Ú©Ø§ Ø«Ø¨ÙˆØª',0),(161936,4499,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñ„Ð°ÐºÑÐ° Ð´Ð¾ÐºÐ°Ð·Ð° Ð·Ð° Ð½Ð°Ð»Ð¾Ð³',0),(161937,4499,'vi','In fax chá»©ng nháº­n cho Ä‘Æ¡n hÃ ng',0),(161938,4499,'af','Druk Faksbewys vir Bestelling',0),(161939,4499,'ro','Imprimare Fax dovada pentru comanda',0),(161940,4499,'et','Prindi Faks tÃµend selle kohta, et',0),(161941,4499,'si','Natisni faks dokaz za nalog',0),(161942,4499,'ba','Faks Cetak bukti untuk Order',0),(161943,4499,'nl','Afdrukken Fax bewijs voor Order',0),(161944,4499,'fi','Tulosta Faksi tilauksen',0),(161945,4499,'no','Skrive ut fakshistorikk bevis for ordre',0),(161946,4499,'da','Udskrive faxen bevis for ordre',0),(161947,4499,'ko','ì£¼ë¬¸ íŒ©ìŠ¤ êµì •ë³¸ ì¸ì‡„',0),(161948,4499,'he','×”×“×¤×¡×ª ×¤×§×¡ ×”×•×›×—×” ×¢×‘×•×¨ ×”×–×ž× ×”',0),(161949,4499,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Ï†Î±Î¾ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(161950,4499,'zh','æ‰“å°è®¢å•ä¼ çœŸè¯æ˜Ž\r\n',0),(161951,4499,'sv','Skriva ut Fax bevis fÃ¶r bestÃ¤llning',0),(161952,4499,'it','Prova di stampa Fax per ordine',0),(161953,4499,'tl','',0),(161954,4499,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3656;&#3634;&#3591;&#3650;&#3607;&#3619;&#3626;&#3634;&#3619;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(161955,4499,'hi','à¤«à¥ˆà¤•à¥à¤¸ à¤¸à¤¬à¥‚à¤¤ à¤•à¥‡ à¤•à¥à¤°à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(161956,4499,'ms','Cetak Perkhidmatan Faks bukti untuk pesanan',0),(161957,4499,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ÙØ§ÙƒØ³ Ø¥Ø«Ø¨Ø§Øª Ù„ØªØ±ØªÙŠØ¨',0),(161958,4499,'fr','Preuve d\'impression Fax pour commander',0),(161959,4499,'jp','æ³¨æ–‡ã?®ãƒ•ã‚¡ãƒƒã‚¯ã‚¹æ§‹æˆ?ã‚’å?°åˆ·',0),(161960,4499,'pt','Prova de impressÃ£o de Fax para a ordem',0),(161961,4499,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ñ„Ð°ÐºÑ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(161962,4499,'es','Imprimir Fax Prueba de ImpresiÃ³n para el Orden',0),(161963,4499,'de','Drucken Sie Fax Beweis fÃ¼r Bestellung',0),(161964,4499,'en','Print Fax Proof for Order',0),(161965,4500,'is','',0),(161966,4500,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(161967,4500,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(161968,4500,'tr','BaskÄ± sipariÅŸ numarasÄ±',0),(161969,4500,'pl','Numer zlecenia druku',0),(161970,4500,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(161971,4500,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù†Ù…Ø¨Ø±',0),(161972,4500,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(161973,4500,'vi','Sá»‘ Ä‘Æ¡n hÃ ng in',0),(161974,4500,'af','Druk Bestelnommer',0),(161975,4500,'ro','NumÄƒrul de ordine de imprimare',0),(161976,4500,'et','Printida tellimuse kood',0),(161977,4500,'si','Vrstni red tiskanja veÄ',0),(161978,4500,'ba','Nomor pesanan cetak',0),(161979,4500,'nl','Afdrukvolgorde nummer',0),(161980,4500,'fi','Tulostuksen jÃ¤rjestysnumero',0),(161981,4500,'no','Skrive ut nummeret',0),(161982,4500,'da','Udskrive ordrenummer',0),(161983,4500,'ko','ì¸ì‡„ ì£¼ë¬¸ ë²ˆí˜¸',0),(161984,4500,'he','×”×“×¤×¡ ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(161985,4500,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(161986,4500,'zh','æ‰“å°è®¢å•å·\r\n',0),(161987,4500,'sv','Skriva ordernummer',0),(161988,4500,'it','Numero di ordine di stampa',0),(161989,4500,'tl','',0),(161990,4500,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(161991,4500,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(161992,4500,'ms','Cetak nombor pesanan',0),(161993,4500,'ar','Ø±Ù‚Ù… Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(161994,4500,'fr','NumÃ©ro de commande d\'impression',0),(161995,4500,'jp','å?°åˆ·æ³¨æ–‡ç•ªå?·',0),(161996,4500,'pt','NÃºmero de ordem de impressÃ£o',0),(161997,4500,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(161998,4500,'es','NÃºmero de Orden de Imprimir',0),(161999,4500,'de','Bestellnummer zu drucken',0),(162000,4500,'en','Print Order Number',0),(162001,4501,'is','',0),(162002,4501,'dr','Ø§Ù‚Ø¯Ø§Ù… Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(162003,4501,'pr','Ø§Ù‚Ø¯Ø§Ù… Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(162004,4501,'tr','SipariÅŸ ile devam',0),(162005,4501,'pl','KontynuowaÄ‡ zamÃ³wienie',0),(162006,4501,'bg','ÐŸÑ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸ Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(162007,4501,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ø³Ø§ØªÚ¾ Ø¢Ú¯Û’ Ø¨Ú‘Ú¾Ù†Ø§',0),(162008,4501,'sr','ÐÐ°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ ÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(162009,4501,'vi','Tiáº¿n hÃ ng Ä‘áº·t hÃ ng',0),(162010,4501,'af','Gaan voort met Bestelling',0),(162011,4501,'ro','Continua cu comanda',0),(162012,4501,'et','Et jÃ¤tkata',0),(162013,4501,'si','Nadaljujte z naroÄilom',0),(162014,4501,'ba','Melanjutkan dengan pesanan',0),(162015,4501,'nl','Doorgaan met bestelling',0),(162016,4501,'fi','Tilaa',0),(162017,4501,'no','Fortsette med ordre',0),(162018,4501,'da','FortsÃ¦t med rÃ¦kkefÃ¸lgen',0),(162019,4501,'ko','ì£¼ë¬¸ ì§„í–‰',0),(162020,4501,'he','. ×”×ž×©×š ×¢× ×¡×“×¨',0),(162021,4501,'el','Î ÏÎ¿Ï‡Ï‰ÏÎ®ÏƒÎµÏ„Îµ ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(162022,4501,'zh','å¤„ç†è®¢å•\r\n',0),(162023,4501,'sv','FortsÃ¤tt med ordning',0),(162024,4501,'it','Procedere con ordine',0),(162025,4501,'tl','',0),(162026,4501,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3605;&#3656;&#3629;&#3652;&#3611;&#3604;&#3657;&#3623;&#3618;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(162027,4501,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤—à¥‡ à¤¬à¤¢à¤¼à¤¨à¤¾',0),(162028,4501,'ms','Teruskan dengan perintah',0),(162029,4501,'ar','Ø§Ù„Ù…Ø¶ÙŠ Ù‚Ø¯Ù…Ø§ ÙÙŠ Ø§Ù„ØªØ±ØªÙŠØ¨',0),(162030,4501,'fr','ProcÃ©der Ã  la commande',0),(162031,4501,'jp','æ³¨æ–‡ã‚’å®Ÿè¡Œã?™ã‚‹',0),(162032,4501,'pt','Proceder com ordem',0),(162033,4501,'ru','ÐŸÑ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(162034,4501,'es','Proceder con el Orden',0),(162035,4501,'de','Mit der Bestellung fortfahren',0),(162036,4501,'en','Proceed with Order',0),(162037,4502,'is','',0),(162038,4502,'dr','ØªØ§Ø±ÙŠØ® Ø§ÙŠØ¬Ø§Ø¯ Ù…Ø¯Ø±Ùƒ',0),(162039,4502,'pr','ØªØ§Ø±ÙŠØ® Ø§ÙŠØ¬Ø§Ø¯ Ù…Ø¯Ø±Ùƒ',0),(162040,4502,'tr','KanÄ±t oluÅŸturma tarihi',0),(162041,4502,'pl','DowÃ³d daty utworzenia',0),(162042,4502,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(162043,4502,'ur','Ø¯Ù„ÛŒÙ„ Ø¨Ù†Ø§Ù†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(162044,4502,'sr','Ð”Ð¾ÐºÐ°Ð· Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(162045,4502,'vi','NgÃ y táº¡o Báº£n in thá»­',0),(162046,4502,'af','Proef Skeppingsdautm',0),(162047,4502,'ro','Dovada crea data',0),(162048,4502,'et','TÃµend Loo kuupÃ¤ev',0),(162049,4502,'si','Dokaz ustvarjeno',0),(162050,4502,'ba','Bukti tanggal pembuatan',0),(162051,4502,'nl','Bewijs aanmaakdatum',0),(162052,4502,'fi','Todiste luontipÃ¤ivÃ¤',0),(162053,4502,'no','Bevis opprettingsdatoen',0),(162054,4502,'da','Bevis oprette dato',0),(162055,4502,'ko','ì¦ëª… ìž‘ì„± ë‚ ì§œ',0),(162056,4502,'he','×”×•×›×—×” ×œ×™×¦×•×¨ ×ª××¨×™×š',0),(162057,4502,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚',0),(162058,4502,'zh','è¯æ˜Žåˆ›å»ºæ—¥æœŸ\r\n',0),(162059,4502,'sv','Bevis skapa datum',0),(162060,4502,'it','Prova creare data',0),(162061,4502,'tl','',0),(162062,4502,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(162063,4502,'hi','à¤¸à¤¬à¥‚à¤¤ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(162064,4502,'ms','Bukti mencipta tarikh',0),(162065,4502,'ar','Ø¥Ø«Ø¨Ø§Øª ØªØ§Ø±ÙŠØ® Ø¥Ù†Ø´Ø§Ø¡',0),(162066,4502,'fr','Preuve crÃ©er Date',0),(162067,4502,'jp','æ ¡æ­£ä½œæˆ?æ—¥',0),(162068,4502,'pt','Prova criar data',0),(162069,4502,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð”Ð°Ñ‚Ð° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ',0),(162070,4502,'es','Prueba de ImpresiÃ³n Fecha de CreaciÃ³n',0),(162071,4502,'de','Nachweis erstellen Datum',0),(162072,4502,'en','Proof Create Date',0),(162073,4503,'is','',0),(162074,4503,'dr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø³Ù†Ø¯ ',0),(162075,4503,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø³Ù†Ø¯ ',0),(162076,4503,'tr','KanÄ±t vade tarihi',0),(162077,4503,'pl','DowÃ³d ukoÅ„czenia Data',0),(162078,4503,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾, Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(162079,4503,'ur','Ø«Ø¨ÙˆØª Ú©ÛŒ Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(162080,4503,'sr','Ð”Ð¾ÐºÐ°Ð· ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(162081,4503,'vi','NgÃ y Ä‘áº¿n háº¡n Báº£n in thá»­',0),(162082,4503,'af','Proef Verskuldigde Datum',0),(162083,4503,'ro','Dovada datoritÄƒ data',0),(162084,4503,'et','TÃµendid Due Date',0),(162085,4503,'si','Dokaz zaradi datuma',0),(162086,4503,'ba','Bukti Due Date',0),(162087,4503,'nl','Bewijs Due datum',0),(162088,4503,'fi','Todiste asianmukaisesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(162089,4503,'no','Bevis grunn dato',0),(162090,4503,'da','Bevis for behÃ¸rig dato',0),(162091,4503,'ko','ì¸í•´ ì¦ëª… ë‚ ì§œ',0),(162092,4503,'he','×”×•×›×—×” ×™×¢×“ ×ª××¨×™×š',0),(162093,4503,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(162094,4503,'zh','è¯æ˜Žæˆªæ­¢æ—¥æœŸ\r\n',0),(162095,4503,'sv','Bevis Due Date',0),(162096,4503,'it','Prova la scadenza Data',0),(162097,4503,'tl','',0),(162098,4503,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3586;&#3629;&#3591;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(162099,4503,'hi','à¤¸à¤¬à¥‚à¤¤ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(162100,4503,'ms','Bukti habis tempoh tarikh',0),(162101,4503,'ar','Ø¥Ø«Ø¨Ø§Øª Ø§Ù„ÙˆØ§Ø¬Ø¨ ØªØ§Ø±ÙŠØ®',0),(162102,4503,'fr','Preuve de Due Date',0),(162103,4503,'jp','æ ¡æ­£æœŸæ—¥',0),(162104,4503,'pt','Devido a prova data',0),(162105,4503,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð¹ Ð”Ð°Ñ‚Ð°',0),(162106,4503,'es','Prueba de ImpresiÃ³n Fecha de Venciiento',0),(162107,4503,'de','Nachweis Due Date',0),(162108,4503,'en','Proof Due Date',0),(162109,4504,'is','',0),(162110,4504,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ø³Ù†Ø¯ ',0),(162111,4504,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ø³Ù†Ø¯ ',0),(162112,4504,'tr','KanÄ±t notlarÄ±',0),(162113,4504,'pl','Dowodem informacji dodatkowej',0),(162114,4504,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(162115,4504,'ur','Ø«Ø¨ÙˆØª Ù†ÙˆÙ¹',0),(162116,4504,'sr','Ð”Ð¾ÐºÐ°Ð· Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(162117,4504,'vi','Ghi chÃº Báº£n in thá»­',0),(162118,4504,'af','Proefnotas',0),(162119,4504,'ro','Dovada note',0),(162120,4504,'et','TÃµend mÃ¤rkmed',0),(162121,4504,'si','Dokaz opombe',0),(162122,4504,'ba','Bukti catatan',0),(162123,4504,'nl','Bewijs Notes',0),(162124,4504,'fi','Todiste toteaa',0),(162125,4504,'no','Bevis notater',0),(162126,4504,'da','Bevis noter',0),(162127,4504,'ko','ì¦ê±° ë…¸íŠ¸',0),(162128,4504,'he','×”×¢×¨×•×ª ×”×•×›×—×”',0),(162129,4504,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(162130,4504,'zh','è¯æ˜Žç¥¨æ®\r\n',0),(162131,4504,'sv','Bevis anteckningar',0),(162132,4504,'it','Prova note',0),(162133,4504,'tl','',0),(162134,4504,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(162135,4504,'hi','à¤¸à¤¬à¥‚à¤¤ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(162136,4504,'ms','Nota-Nota bukti',0),(162137,4504,'ar','Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(162138,4504,'fr','Informations sur la preuve',0),(162139,4504,'jp','æ ¡æ­£ãƒ¡ãƒ¢',0),(162140,4504,'pt','Notas de prova',0),(162141,4504,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(162142,4504,'es','Pruebas de ImpresiÃ³n Notas',0),(162143,4504,'de','Beweis Notes',0),(162144,4504,'en','Proof Notes',0),(162145,4505,'is','',0),(162146,4505,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ù†Ø¯   ØªØ§Ø±ÙŠØ® Ø§Ø±Ø³Ø§Ù„',0),(162147,4505,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ù†Ø¯   ØªØ§Ø±ÙŠØ® Ø§Ø±Ø³Ø§Ù„',0),(162148,4505,'tr','KanÄ±t numarasÄ±/gÃ¶nderme tarihi',0),(162149,4505,'pl','DowÃ³d daty numer/wysÅ‚ane',0),(162150,4505,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð½Ð¾Ð¼ÐµÑ€/Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð´Ð°Ñ‚Ð°',0),(162151,4505,'ur','Ø«Ø¨ÙˆØª Ù†Ù…Ø¨Ø±/Ø¨Ú¾ÛŒØ¬Ø§ ØªØ§Ø±ÛŒØ®',0),(162152,4505,'sr','Ð”Ð¾ÐºÐ°Ð· Ð±Ñ€Ð¾Ñ˜/Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼',0),(162153,4505,'vi','Sá»‘ Báº£n in thá»­/ngÃ y gá»­i',0),(162154,4505,'af','Bewys nommer/gestuur datum',0),(162155,4505,'ro','Dovada numÄƒrul/trimis data',0),(162156,4505,'et','TÃµendi Number/saatmise kuupÃ¤ev',0),(162157,4505,'si','Dokaz Å¡tevilka/Sent rok',0),(162158,4505,'ba','Bukti nomor/dikirim tanggal',0),(162159,4505,'nl','Bewijs nummer/verzonden datum',0),(162160,4505,'fi','Todiste numero/lÃ¤hetetty pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(162161,4505,'no','Bevis nummer/sendt dato',0),(162162,4505,'da','Bevis nummer/sendt dato',0),(162163,4505,'ko','ì¦ê±° ë²ˆí˜¸/ë³´ë‚¸ ë‚ ì§œ',0),(162164,4505,'he','×ª××¨×™×š ×ž×¡×¤×¨/×©×œ×—×” ×”×•×›×—×”',0),(162165,4505,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±ÏÎ¹Î¸Î¼ÏŒÏ‚/Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(162166,4505,'zh','è¯ä»¶å·ç /å‘é€æ—¥æœŸ\r\n',0),(162167,4505,'sv','Bevis nummer/skickas datum',0),(162168,4505,'it','Prova data numero/inviato',0),(162169,4505,'tl','',0),(162170,4505,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;/&#3626;&#3656;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(162171,4505,'hi','à¤ªà¥à¤°à¥‚à¤« à¤¨à¤‚à¤¬à¤°/à¤­à¥‡à¤œà¥‡ à¤—à¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(162172,4505,'ms','Bukti tarikh nombor/dihantar.',0),(162173,4505,'ar','Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰ ØªØ§Ø±ÙŠØ® Ø¥Ø±Ø³Ø§Ù„Ù‡Ø§/Ø¹Ø¯Ø¯',0),(162174,4505,'fr','Preuve Date Nombre/envoyÃ©',0),(162175,4505,'jp','æ ¡æ­£ç•ªå?·/é€?ä¿¡æ—¥',0),(162176,4505,'pt','Data prova nÃºmero/enviados',0),(162177,4505,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€/Ð”Ð°Ñ‚Ð°',0),(162178,4505,'es','Prueba de ImpresiÃ³n NÃºmero/Fecha de EnvÃ­o',0),(162179,4505,'de','Beweis Nummer/gesendeten Datum',0),(162180,4505,'en','Proof Number/Sent Date',0),(162181,4506,'is','',0),(162182,4506,'dr','Ø³Ù†Ø¯ Ù‚Ø¨ÙˆÙ„ ÙˆÙ‚ØªÙŠ Ø§Ø³Øª',0),(162183,4506,'pr','Ø³Ù†Ø¯ Ù‚Ø¨ÙˆÙ„ ÙˆÙ‚ØªÙŠ Ø§Ø³Øª',0),(162184,4506,'tr','KanÄ±t olarak tamam-olduÄŸunu',0),(162185,4506,'pl','DowÃ³d OK-jest',0),(162186,4506,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ ÐžÐš ÐºÐ°Ñ‚Ð¾-Ðµ',0),(162187,4506,'ur','Ø«Ø¨ÙˆØª Ú©Û’ Ù„ÛŒÛ’ Ù¹Ú¾ÛŒÚ© ÛÛ’ Ú©Û’ Ø·ÙˆØ± Ù¾Ø±-ÛÛ’',0),(162188,4506,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ð´Ð¾ÐºÐ°Ð· ÐºÐ°Ð¾-Ñ˜Ðµ',0),(162189,4506,'vi','Báº£n in thá»­ OK nhÆ° hiá»‡n tráº¡ng',0),(162190,4506,'af','Bewys OK As-Is',0),(162191,4506,'ro','Dovada OK ca-este',0),(162192,4506,'et','TÃµend OK nagu-on',0),(162193,4506,'si','Dokaz OK kot-je',0),(162194,4506,'ba','Bukti OK sebagai-adalah',0),(162195,4506,'nl','Bewijs OK als-Is',0),(162196,4506,'fi','Todiste OK-on',0),(162197,4506,'no','Bevis OK som-er',0),(162198,4506,'da','Bevis OK som-er',0),(162199,4506,'ko','ë¡œ ì¦ëª… í™•ì¸-ì€',0),(162200,4506,'he','×”×•×›×—×” ××™×©×•×¨ ×›×ž×•-×”×•×',0),(162201,4506,'el','OK Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Ï‰Ï‚-ÎµÎ¯Î½Î±Î¹',0),(162202,4506,'zh','è¯æ˜Žç¡®è®¤åŽŸæ ·\r\n',0),(162203,4506,'sv','Bevis OK som-Ã¤r',0),(162204,4506,'it','OK prova come-Ã¨',0),(162205,4506,'tl','',0),(162206,4506,'th','&#3605;&#3585;&#3621;&#3591;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;&#3648;&#3611;&#3655;&#3609;&#3652;&#3611;&#3605;&#3634;&#3617;&#3609;&#3637;&#3657;',0),(162207,4506,'hi','à¤¸à¤¬à¥‚à¤¤ à¤•à¥‡ à¤ à¥€à¤• à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚-à¤¹à¥ˆ',0),(162208,4506,'ms','Bukti OK sebagai-adalah',0),(162209,4506,'ar','Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰ \"Ù…ÙˆØ§ÙÙ‚\" ÙƒÙ…Ø§-Ù‡Ùˆ',0),(162210,4506,'fr','Preuve OK tant que-est',0),(162211,4506,'jp','æ ¡æ­£ã??ã?®ã?¾ã?¾ã?§ï¼¯ï¼«',0),(162212,4506,'pt','Prova OK como-Ã©',0),(162213,4506,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ ÐžÐš ÐºÐ°Ðº-ÑÑ‚Ð¾',0),(162214,4506,'es','Prueba de ImpresiÃ³n OK AsÃ­',0),(162215,4506,'de','Nachweis OK als-ist',0),(162216,4506,'en','Proof OK As-Is',0),(162217,4507,'is','',0),(162218,4507,'dr','ØªØ§Ø±ÙŠØ® Ø¬ÙˆØ§Ø¨ Ø³Ù†Ø¯ ',0),(162219,4507,'pr','ØªØ§Ø±ÙŠØ® Ø¬ÙˆØ§Ø¨ Ø³Ù†Ø¯ ',0),(162220,4507,'tr','KanÄ±t yanÄ±tlama tarihi',0),(162221,4507,'pl','Data dowodu reakcji',0),(162222,4507,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(162223,4507,'ur','Ø«Ø¨ÙˆØª Ú©Û’ Ø¬ÙˆØ§Ø¨ ØªØ§Ø±ÛŒØ®',0),(162224,4507,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ð´Ð·Ð¸Ð²Ð° Ð´Ð¾ÐºÐ°Ð·',0),(162225,4507,'vi','NgÃ y tráº£ lá»i Báº£n in thá»­',0),(162226,4507,'af','Bewys reaksie datum',0),(162227,4507,'ro','Data dovada rÄƒspunsului',0),(162228,4507,'et','TÃµend reageerimise kuupÃ¤ev',0),(162229,4507,'si','Dokaz odzivni datum',0),(162230,4507,'ba','Bukti respon tanggal',0),(162231,4507,'nl','Bewijs responsdatum',0),(162232,4507,'fi','Todiste Vastauspvm',0),(162233,4507,'no','Bevis Responsdato',0),(162234,4507,'da','Bevis Svardato',0),(162235,4507,'ko','ì¦ê±° ì‘ë‹µ ë‚ ì§œ',0),(162236,4507,'he','×ª××¨×™×š ×”×ª×’×•×‘×” ×”×•×›×—×”',0),(162237,4507,'el','Î—Î¼/Î½Î¯Î± Î‘Ï€ÏŒÎºÏÎ¹ÏƒÎ·Ï‚ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î·',0),(162238,4507,'zh','è¯æ˜Žç­”å¤ä¹‹æ—¥\r\n',0),(162239,4507,'sv','Bevis svarsdatum',0),(162240,4507,'it','Data prova di risposta',0),(162241,4507,'tl','',0),(162242,4507,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(162243,4507,'hi','à¤¸à¤¬à¥‚à¤¤ à¤ªà¥à¤°à¤¤à¤¿à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(162244,4507,'ms','Respon bukti tarikh',0),(162245,4507,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø±Ø¯ Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰',0),(162246,4507,'fr','Date de la rÃ©ponse de preuve',0),(162247,4507,'jp','æ ¡æ­£å›žç­”æ—¥',0),(162248,4507,'pt','Resposta prova data',0),(162249,4507,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð¾Ñ‚Ð²ÐµÑ‚ Ð”Ð°Ñ‚Ð°',0),(162250,4507,'es','Fecha de Responder a Prueba de ImpresiÃ³n',0),(162251,4507,'de','Beweis Antwortdatum',0),(162252,4507,'en','Proof Response Date',0),(162253,4508,'is','',0),(162254,4508,'dr','Ø¨Ø±Ú¯Ù‡ Ø³Ù†Ø¯ ',0),(162255,4508,'pr','Ø¨Ø±Ú¯Ù‡ Ø³Ù†Ø¯ ',0),(162256,4508,'tr','Prova sayfasÄ±',0),(162257,4508,'pl','Arkusza prÃ³bnego',0),(162258,4508,'bg','Ð›Ð¸ÑÑ‚',0),(162259,4508,'ur','Ø«Ø¨ÙˆØª ÙˆØ±Ù‚',0),(162260,4508,'sr','Ð”Ð¾ÐºÐ°Ð· Ð»Ð¸ÑÑ‚',0),(162261,4508,'vi','Báº£ng Báº£n in thá»­',0),(162262,4508,'af','Bewys vel',0),(162263,4508,'ro','Dovada foaie',0),(162264,4508,'et','TÃµend leht',0),(162265,4508,'si','Osnutek',0),(162266,4508,'ba','Lembar bukti',0),(162267,4508,'nl','Controlevel',0),(162268,4508,'fi','Vedosarkki',0),(162269,4508,'no','Korrekturarket',0),(162270,4508,'da','Korrekturarket',0),(162271,4508,'ko','êµì •ì§€',0),(162272,4508,'he','×‘×’×™×œ×™×•×Ÿ ×”×”×’×”×”',0),(162273,4508,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Ï†ÏÎ»Î»Î¿',0),(162274,4508,'zh','è¯æ˜Žè¡¨\r\n',0),(162275,4508,'sv','Provarket',0),(162276,4508,'it','Foglio di prova',0),(162277,4508,'tl','',0),(162278,4508,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(162279,4508,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤°',0),(162280,4508,'ms','Kira-kira bukti',0),(162281,4508,'ar','ÙˆØ±Ù‚Ø© Ø§Ù„Ø§Ø®ØªØ¨Ø§Ø±',0),(162282,4508,'fr','Feuille de preuve',0),(162283,4508,'jp','æ ¡æ­£ã‚·ãƒ¼ãƒˆ',0),(162284,4508,'pt','Folha de prova',0),(162285,4508,'ru','Ð›Ð¸ÑÑ‚ Ð¿Ñ€Ð¾Ð±Ð½Ñ‹Ñ… Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚ÐºÐ¾Ð²',0),(162286,4508,'es','Hoja de Prueba de ImpresiÃ³n',0),(162287,4508,'de','Korrekturbogen',0),(162288,4508,'en','Proof Sheet',0),(162289,4509,'is','',0),(162290,4509,'dr','Ø³Ø·Ø­ Ø´Ø±Ø§ÙŠØ· Ø³Ù†Ø¯ ',0),(162291,4509,'pr','Ø³Ø·Ø­ Ø´Ø±Ø§ÙŠØ· Ø³Ù†Ø¯ ',0),(162292,4509,'tr','KanÄ±t durumu dÃ¼zeyi',0),(162293,4509,'pl','Stan dowÃ³d poziomu',0),(162294,4509,'bg','ÐÐ¸Ð²Ð¾ Ð½Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(162295,4509,'ur','Ø«Ø¨ÙˆØª Ú©ÛŒ Ø­ÛŒØ«ÛŒØª Ø³Ø·Ø­',0),(162296,4509,'sr','Ð”Ð¾ÐºÐ°Ð· ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð¸Ð²Ð¾',0),(162297,4509,'vi','Má»©c TÃ¬nh tráº¡ng Báº£n in thá»­',0),(162298,4509,'af','Bewys Status vlak',0),(162299,4509,'ro','Dovada statutului nivel',0),(162300,4509,'et','TÃµend staatuse taset',0),(162301,4509,'si','Dokaz Status ravni',0),(162302,4509,'ba','Bukti Status tingkat',0),(162303,4509,'nl','Bewijs Status nivo',0),(162304,4509,'fi','Todiste tila-taso',0),(162305,4509,'no','Bevis statusnivÃ¥',0),(162306,4509,'da','Bevis statusniveau',0),(162307,4509,'ko','ì¦ê±° ìƒíƒœ ìˆ˜ì¤€',0),(162308,4509,'he','×¨×ž×ª ×”×•×›×—×” ×ž×¦×‘',0),(162309,4509,'el','Î•Ï€Î¯Ï€ÎµÎ´Î¿ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(162310,4509,'zh','è¯æ˜ŽçŠ¶æ€çº§åˆ«\r\n',0),(162311,4509,'sv','Bevis statusnivÃ¥',0),(162312,4509,'it','Livello di prova di stato',0),(162313,4509,'tl','',0),(162314,4509,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3626;&#3606;&#3634;&#3609;&#3632;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(162315,4509,'hi','à¤¸à¤¬à¥‚à¤¤ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¸à¥à¤¤à¤°',0),(162316,4509,'ms','Bukti Status tahap',0),(162317,4509,'ar','ÙˆØ¶Ø¹ Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰ Ù…Ø³ØªÙˆÙ‰',0),(162318,4509,'fr','Niveau de preuve de statut',0),(162319,4509,'jp','æ ¡æ­£çŠ¶æ³?ãƒ¬ãƒ™ãƒ«',0),(162320,4509,'pt','NÃ­vel de Status de prova',0),(162321,4509,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ñ',0),(162322,4509,'es','Nivel de Status de la Prueba de ImpresiÃ³n',0),(162323,4509,'de','Beweis-Status-Stufe',0),(162324,4509,'en','Proof Status Level',0),(162325,4510,'is','',0),(162326,4510,'dr','Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø§ØµÙ„Ø§Ø­ Ø¯Ø§Ø±Ø¯ ',0),(162327,4510,'pr','Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø§ØµÙ„Ø§Ø­ Ø¯Ø§Ø±Ø¯ ',0),(162328,4510,'tr','Gerekli dÃ¼zeltmeleri',0),(162329,4510,'pl','Poprawki potrzebne',0),(162330,4510,'bg','Ð ÐµÐ²Ð¸Ð·Ð¸Ð¸Ñ‚Ðµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸',0),(162331,4510,'ur','Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(162332,4510,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ñ˜Ðµ Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ð°',0),(162333,4510,'vi','Cáº§n Chá»‰nh sá»­a',0),(162334,4510,'af','Hersienings nodig',0),(162335,4510,'ro','Revizuirile necesare',0),(162336,4510,'et','Vajalikud parandused',0),(162337,4510,'si','Revizije potrebna',0),(162338,4510,'ba','Revisi yang diperlukan',0),(162339,4510,'nl','Herzieningen nodig',0),(162340,4510,'fi','Muutoksia tarvitaan',0),(162341,4510,'no','Endringer trengte',0),(162342,4510,'da','Revisioner behov',0),(162343,4510,'ko','ê°œì • í•„ìš”',0),(162344,4510,'he','×”×ª×™×§×•× ×™× ×”×“×¨×•×©×™×',0),(162345,4510,'el','Î‘Î½Î±Î¸ÎµÏ‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(162346,4510,'zh','éœ€è¦ä¿®è®¢\r\n',0),(162347,4510,'sv','Revideringar behÃ¶vs',0),(162348,4510,'it','Revisioni necessarie',0),(162349,4510,'tl','',0),(162350,4510,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(162351,4510,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(162352,4510,'ms','Semakan diperlukan',0),(162353,4510,'ar','Ø§Ù„ØªÙ†Ù‚ÙŠØ­Ø§Øª Ø§Ù„Ù„Ø§Ø²Ù…Ø©',0),(162354,4510,'fr','RÃ©visions nÃ©cessaires',0),(162355,4510,'jp','ä¿®æ­£è¦?',0),(162356,4510,'pt','RevisÃµes necessÃ¡rias',0),(162357,4510,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ñ‹Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(162358,4510,'es','Se Necesita Revisiones',0),(162359,4510,'de','Revisionen erforderlich',0),(162360,4510,'en','Revisions Needed',0),(162361,4511,'is','',0),(162362,4511,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù…Ø¯Ø±Ùƒ Ø¯ÙŠÚ¯Ø±ÙŠ',0),(162363,4511,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù…Ø¯Ø±Ùƒ Ø¯ÙŠÚ¯Ø±ÙŠ',0),(162364,4511,'tr','Bir baÅŸka kanÄ±tÄ± gÃ¶ndermek',0),(162365,4511,'pl','WysÅ‚aÄ‡ kolejny dowÃ³d',0),(162366,4511,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸Ð¼ Ð´Ñ€ÑƒÐ³Ð¾ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(162367,4511,'ur','Ø¢Ù¾Ø³ Ù…ÛŒÚº Ø«Ø¨ÙˆØª Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(162368,4511,'sr','ÐŸÐ¾ÑÐ»Ð°Ñ‚Ð¸ Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ð´Ð¾ÐºÐ°Ð·',0),(162369,4511,'vi','Gá»­i báº£n in thá»­ khÃ¡c',0),(162370,4511,'af','Stuur \'n Ander Proef',0),(162371,4511,'ro','Trimite alta dovada',0),(162372,4511,'et','Saada teise tÃµend',0),(162373,4511,'si','PoÅ¡lji drugo dokazilo',0),(162374,4511,'ba','Mengirim lain bukti',0),(162375,4511,'nl','Stuur een ander bewijs',0),(162376,4511,'fi','LÃ¤hetÃ¤ toinen todiste',0),(162377,4511,'no','Sende en bevis',0),(162378,4511,'da','Send en anden bevis',0),(162379,4511,'ko','ë‹¤ë¥¸ ì¦ê±° ë³´ë‚´',0),(162380,4511,'he','×œ×©×œ×•×— ×¢×•×“ ×”×•×›×—×”',0),(162381,4511,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Î¼Î¹Î± Î¬Î»Î»Î· Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î·',0),(162382,4511,'zh','å‘é€çš„å¦ä¸€è¯æ˜Ž\r\n',0),(162383,4511,'sv','Skicka en annan bevis',0),(162384,4511,'it','Invia un\'altra prova',0),(162385,4511,'tl','',0),(162386,4511,'th','&#3626;&#3656;&#3591;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(162387,4511,'hi','à¤à¤• à¤”à¤° à¤¸à¤¬à¥‚à¤¤ à¤­à¥‡à¤œà¥‡à¤‚',0),(162388,4511,'ms','Menghantar satu lagi bukti',0),(162389,4511,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¢Ø®Ø± Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰',0),(162390,4511,'fr','Envoyer une autre preuve',0),(162391,4511,'jp','ä»–ã?®æ ¡æ­£ã‚’é€?ä¿¡',0),(162392,4511,'pt','Enviar outra prova',0),(162393,4511,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¾Ðµ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾',0),(162394,4511,'es','Mandar Otra Prueba de ImpresiÃ³n',0),(162395,4511,'de','Ein anderer Beweis zu senden',0),(162396,4511,'en','Send Another Proof',0),(162397,4512,'is','',0),(162398,4512,'dr','/ Ù…Ù†ØªØ¸Ø±(Ù…Ø´Ø±ÙˆØ·',0),(162399,4512,'pr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ / Ù…Ù†ØªØ¸Ø±(Ù…Ø´Ø±ÙˆØ·',0),(162400,4512,'tr','GÃ¶nderilen/beklemede',0),(162401,4512,'pl','WysÅ‚ane/czasu',0),(162402,4512,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸/Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ',0),(162403,4512,'ur','Ù…Ø±Ø³Ù„Û/Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(162404,4512,'sr','ÐŸÐ¾ÑÐ»Ð°Ð¾ /Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(162405,4512,'vi','ÄÃ£ gá»­i/Äang treo',0),(162406,4512,'af','Gestuur/Afwagtend',0),(162407,4512,'ro','Trimis/pÃ¢nÄƒ',0),(162408,4512,'et','Saadetud/ootel',0),(162409,4512,'si','Poslal/dokler',0),(162410,4512,'ba','Dikirim/tertunda',0),(162411,4512,'nl','Verzonden/in afwachting van',0),(162412,4512,'fi','LÃ¤hettÃ¤nyt/kesken',0),(162413,4512,'no','Sendt/ventende',0),(162414,4512,'da','Sendt/behandling',0),(162415,4512,'ko','ì „ì†¡/ë³´ë¥˜',0),(162416,4512,'he','×©×œ×— ×ž×ž×ª×™× ×™× /',0),(162417,4512,'el','Î‘Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹/ÎµÎºÎºÏÎµÎ¼ÎµÎ¯',0),(162418,4512,'zh','å‘é€/å¾…å®š\r\n',0),(162419,4512,'sv','Skickade/pÃ¥gÃ¥ende',0),(162420,4512,'it','Inviati/in attesa',0),(162421,4512,'tl','',0),(162422,4512,'th','&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;/&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(162423,4512,'hi','à¤­à¥‡à¤œà¤¾/à¤²à¤‚à¤¬à¤¿à¤¤',0),(162424,4512,'ms','Dihantar/menunggu',0),(162425,4512,'ar','Ø£Ø±Ø³Ù„/Ù…Ø¹Ù„Ù‚Ø©',0),(162426,4512,'fr','EnvoyÃ© ou en attente',0),(162427,4512,'jp','é€?ä¿¡æ¸ˆ/ä¿?ç•™ä¸­',0),(162428,4512,'pt','Enviado/pendentes',0),(162429,4512,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾/Ð´Ð¾',0),(162430,4512,'es','Enviado/Pendiente',0),(162431,4512,'de','Gesendet/ausstehende',0),(162432,4512,'en','Sent/Pending',0),(162433,4513,'is','',0),(162434,4513,'dr','Ø§Ù…Ø¶Ø§Ø¡',0),(162435,4513,'pr','Ø§Ù…Ø¶Ø§Ø¡',0),(162436,4513,'tr','Ä°mza',0),(162437,4513,'pl','Podpis',0),(162438,4513,'bg','ÐŸÐ¾Ð´Ð¿Ð¸Ñ',0),(162439,4513,'ur','Ø¯Ø³ØªØ®Ø·',0),(162440,4513,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸Ñ',0),(162441,4513,'vi','Chá»¯ kÃ½',0),(162442,4513,'af','Hantekening',0),(162443,4513,'ro','SemnÄƒtura',0),(162444,4513,'et','Allkiri',0),(162445,4513,'si','Podpis',0),(162446,4513,'ba','Tanda tangan',0),(162447,4513,'nl','Handtekening',0),(162448,4513,'fi','Allekirjoitus',0),(162449,4513,'no','Signatur',0),(162450,4513,'da','Underskrift',0),(162451,4513,'ko','ì„œëª…',0),(162452,4513,'he','×—×ª×™×ž×”',0),(162453,4513,'el','Î¥Ï€Î¿Î³ÏÎ±Ï†Î®',0),(162454,4513,'zh','ç­¾å\r\n',0),(162455,4513,'sv','Signatur',0),(162456,4513,'it','Firma',0),(162457,4513,'tl','',0),(162458,4513,'th','&#3621;&#3634;&#3618;&#3648;&#3595;&#3655;&#3609;',0),(162459,4513,'hi','à¤¹à¤¸à¥ à¤¤à¤¾à¤•à¥à¤·à¤°',0),(162460,4513,'ms','Tandatangan',0),(162461,4513,'ar','Ø§Ù„ØªÙˆÙ‚ÙŠØ¹',0),(162462,4513,'fr','Signature',0),(162463,4513,'jp','ç½²å??',0),(162464,4513,'pt','Assinatura',0),(162465,4513,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÑŒ',0),(162466,4513,'es','Firma',0),(162467,4513,'de','Signatur',0),(162468,4513,'en','Signature',0),(162469,4514,'is','',0),(162470,4514,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ù†ÙŠØ³Øª ',0),(162471,4514,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ù†ÙŠØ³Øª ',0),(162472,4514,'tr','PDF dosyasÄ± oluÅŸturulamÄ±yor',0),(162473,4514,'pl','Nie moÅ¼na utworzyÄ‡ pliku PDF',0),(162474,4514,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´Ðµ PDF Ñ„Ð°Ð¹Ð»',0),(162475,4514,'ur','Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ø¦Ù„ Ø¨Ù†Ø§Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(162476,4514,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ ÐŸÐ”Ð¤ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(162477,4514,'vi','KhÃ´ng thá»ƒ táº¡o há»“ sÆ¡ PDF',0),(162478,4514,'af','Skep van PDF LÃªer is Onmoontlik',0),(162479,4514,'ro','Imposibil de creat fiÅŸierul PDF',0),(162480,4514,'et','Ei saa luua PDF-faili',0),(162481,4514,'si','PDF datoteke ni mogoÄe ustvariti',0),(162482,4514,'ba','Tidak dapat membuat PDF File',0),(162483,4514,'nl','Unable to Create PDF-bestand',0),(162484,4514,'fi','Ei voi luoda PDF-tiedoston',0),(162485,4514,'no','Kan ikke opprette PDF fil',0),(162486,4514,'da','Stand til at skabe PDF-fil',0),(162487,4514,'ko','PDF íŒŒì¼ì„ ë§Œë“¤ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(162488,4514,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×™×¦×•×¨ ×§×•×‘×¥ PDF',0),(162489,4514,'el','Î‘Î½Î¯ÎºÎ±Î½Î¿Ï‚ ÏƒÎµ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³ÏŽ Î±ÏÏ‡ÎµÎ¯Î¿ PDF',0),(162490,4514,'zh','æ— æ³•åˆ›å»ºPDFæ–‡ä»¶\r\n',0),(162491,4514,'sv','Det gick inte att skapa PDF-fil',0),(162492,4514,'it','Impossibile creare il File PDF',0),(162493,4514,'tl','',0),(162494,4514,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3626;&#3619;&#3657;&#3634;&#3591;&#3652;&#3615;&#3621;&#3660; PDF',0),(162495,4514,'hi','PDF à¤«à¤¼à¤¾à¤‡à¤² à¤¬à¤¨à¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(162496,4514,'ms','Tidak dapat mencipta fail PDF',0),(162497,4514,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¥Ù†Ø´Ø§Ø¡ Ù…Ù„Ù PDF',0),(162498,4514,'fr','Impossible de crÃ©er le fichier PDF',0),(162499,4514,'jp','PDFãƒ•ã‚¡ã‚¤ãƒ«ã?Œä½œæˆ?ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(162500,4514,'pt','NÃ£o Ã© possÃ­vel criar arquivo PDF',0),(162501,4514,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ PDF Ð¤Ð°Ð¹Ð»',0),(162502,4514,'es','No se Puede Crear file de PDF',0),(162503,4514,'de','Nicht in der Lage, PDF-Datei erstellen',0),(162504,4514,'en','Unable to Create PDF File',0),(162505,4515,'is','',0),(162506,4515,'dr','Ù…Ø§ Ø´ØºÙ„ Ø´Ù…Ø§ Ø±Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†ÙŠÙ… Ú†Ø§Ù¾ ÙƒÙ†ÙŠÙ… ØªØ§ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ù…Ø§ Ø§ÙŠÙ† ÙØ±Ù… Ø§Ù…Ø¶Ø§ Ø´Ø¯Ù‡ Ø±Ø§ Ø¯Ø±ÙŠØ§ÙØª ÙƒÙ†ÙŠÙ…  ',0),(162507,4515,'pr','Ù…Ø§ Ø´ØºÙ„ Ø´Ù…Ø§ Ø±Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†ÙŠÙ… Ú†Ø§Ù¾ ÙƒÙ†ÙŠÙ… ØªØ§ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ù…Ø§ Ø§ÙŠÙ† ÙØ±Ù… Ø§Ù…Ø¶Ø§ Ø´Ø¯Ù‡ Ø±Ø§ Ø¯Ø±ÙŠØ§ÙØª ÙƒÙ†ÙŠÙ…  ',0),(162508,4515,'tr','Bu imzalÄ± form aldÄ±ÄŸÄ±mÄ±z kadar senin iÅŸi yazdÄ±ramÄ±yor',0),(162509,4515,'pl','Nie moÅ¼emy wydrukowaÄ‡ swojÄ… pracÄ™, dopÃ³ki otrzymamy ten podpisany Formularz',0),(162510,4515,'bg','ÐÐ¸Ðµ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿ÐµÑ‡Ð°Ñ‚Ð° ÑÐ¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð°, Ð´Ð¾ÐºÐ°Ñ‚Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸ Ñ‚Ð¾Ð·Ð¸ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€',0),(162511,4515,'ur','ÛÙ… Ø§Ø³ Ú©ÛŒ Ø¯Ø³ØªØ®Ø· Ø´Ø¯Û ÙØ§Ø±Ù… Ù…ÙˆØµÙˆÙ„ ÛÙˆØ¦Û’ ÛÛŒÚº ÛŒÛØ§Úº ØªÚ© Ú©Û ÛÙ… Ø§Ù¾Ù†Ø§ Ú©Ø§Ù… Ù†ÛÛŒÚº Ú†Ú¾Ø§Ù¾ Ø³Ú©ØªØ§',0),(162512,4515,'sr','ÐœÐ¸ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð° ÑÐ²Ð¾Ñ˜ Ð¿Ð¾ÑÐ°Ð¾, Ð´Ð¾Ðº ÑÐ¼Ð¾ Ð´Ð¾Ð±Ð¸Ð»Ð¸ Ð¾Ð²Ð°Ñ˜ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ†',0),(162513,4515,'vi','ChÃºng tÃ´i khÃ´ng thá»ƒ in Job cá»§a báº¡n cho Ä‘áº¿n khi nháº­n Ä‘Æ°á»£c Ä‘Æ¡n Ä‘Ã£ kÃ½',0),(162514,4515,'af','Ons kan nie jou werk druk totdat ons hierdie getekende vorm ontvang het',0),(162515,4515,'ro','Noi nu poate imprima treaba ta, pÃ¢nÄƒ cÃ¢nd am primit acest formular semnat',0),(162516,4515,'et','Me ei see trÃ¼kkida Teie tÃ¶Ã¶d kuni Te ei ole tÃ¤itnud seda vormi',0),(162517,4515,'si','Ni mogoÄe natisniti svoje delo, dokler smo prejeli podpisanega obrazca',0),(162518,4515,'ba','Kami tidak dapat mencetak pekerjaan Anda hingga kami menerima formulir ini ditandatangani',0),(162519,4515,'nl','Wij kunnen niet uw afdruktaak totdat we hebben ontvangen deze ondertekende formulier',0),(162520,4515,'fi','Me voi tulostaa tyÃ¶si, ennen kuin olemme saaneet allekirjoitetun lomakkeen',0),(162521,4515,'no','Vi kan ikke skrive ut jobben fÃ¸r vi har mottatt denne signert skjema',0),(162522,4515,'da','Vi kan ikke udskrive dit job, fÃ¸r vi har modtaget dette underskrevne formular',0),(162523,4515,'ko','ì´ ì„œëª…ëœ ì–‘ì‹ì„ ë°›ì€ ë•Œê¹Œì§€ ìš°ë¦¬ ì§ìž¥ì„ ì¸ì‡„í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(162524,4515,'he','×× ×—× ×• ×œ× × ×™×ª×Ÿ ×œ×”×“×¤×™×¡ ××ª ×”×¢×‘×•×“×” ×©×œ×š ×¢×“ ×§×™×‘×œ× ×• ×˜×•×¤×¡ ×–×” ×—×ª×•×',0),(162525,4515,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ¼Îµ Î½Î± Ï„Ï…Ï€ÏŽÏƒÎ¿Ï…Î¼Îµ ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÎ±Ï‚ Î¼Î­Ï‡ÏÎ¹ Î½Î± Î­Ï‡Î¿Ï…Î¼Îµ Î»Î¬Î²ÎµÎ¹ Î±Ï…Ï„Î® Ï„Î· Î¼Î¿ÏÏ†Î® Ï…Ï€Î¿Î³ÏÎ±Ï†Î®',0),(162526,4515,'zh','ç›´åˆ°æˆ‘ä»¬å·²ç»æ”¶åˆ°æ­¤ç­¾ç½²çš„è¡¨æ ¼æˆ‘ä»¬æ‰èƒ½æ‰“å°ä½œä¸šï¼Œ\r\n',0),(162527,4515,'sv','Vi kan inte skriva ut ditt jobb tills vi har fÃ¥tt denna undertecknade formulÃ¤ret',0),(162528,4515,'it','Noi non possiamo stampare il vostro lavoro fino a quando abbiamo ricevuto questo modulo firmato',0),(162529,4515,'tl','',0),(162530,4515,'th','We cannot print your job until we have received this signed form',0),(162531,4515,'hi','à¤¹à¤® à¤…à¤ªà¤¨à¥€ à¤¨à¥Œà¤•à¤°à¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤œà¤¬ à¤¤à¤• à¤¹à¤® à¤‡à¤¸ à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤¿à¤¤ à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤† à¤¹à¥ˆ',0),(162532,4515,'ms','Kita tidak boleh mencetak kerja anda sehingga kami telah menerima borang ini ditandatangani',0),(162533,4515,'ar','ÙˆÙ†Ø­Ù† Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù…Ù‡Ù…Ø© Ø­ØªÙ‰ Ø£Ù†Ù†Ø§ ØªÙ„Ù‚ÙŠÙ†Ø§ Ù‡Ø°Ø§ Ø§Ù„Ù†Ù…ÙˆØ°Ø¬ Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(162534,4515,'fr','Nous ne pouvons pas imprimer votre travail jusqu\'Ã  ce que nous avons reÃ§u ce formulaire signÃ©',0),(162535,4515,'jp','ã?“ã?®ç½²å??æ¸ˆãƒ•ã‚©ãƒ¼ãƒ ã‚’å?—ã?‘å?–ã‚‹ã?¾ã?§ã?“ã?®ä½œæ¥­ã‚’å?°åˆ·ã?§ã??ã?¾ã?›ã‚“',0),(162536,4515,'pt','NÃ³s nÃ£o podemos imprimir seu trabalho atÃ© recebemos este formulÃ¡rio assinado',0),(162537,4515,'ru','ÐœÑ‹ Ð½Ðµ Ð¼Ð¾Ð³ÑƒÑ‚ Ð½Ð°Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð²Ð°ÑˆÑƒ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð´Ð¾ Ñ‚ÐµÑ… Ð¿Ð¾Ñ€, Ð¿Ð¾ÐºÐ° Ð¼Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»Ð¸ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð½Ð¾Ð¹ Ñ„Ð¾Ñ€Ð¼Ñ‹',0),(162538,4515,'es','No podemos imprimir su trabajo hasta que recibimos este formulario firmado',0),(162539,4515,'de','Wir kÃ¶nnen nicht Ihren Job drucken, bis wir diese unterzeichnete Formular erhalten haben',0),(162540,4515,'en','We cannot print your job until we have received this signed form',0),(162541,4516,'is','',0),(162542,4516,'dr','Ø´ØºÙ„ Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ú†Ø§Ù¾ Ø´ÙˆØ¯ ØªØ§ ÙˆÙ‚ØªÙŠ ÙƒÙ‡ Ø¬Ø¹Ø¨Ù‡ Ù…Ù†Ø§Ø³Ø¨ Ø¨Ø±Ø±Ø³ÙŠ Ø´ÙˆØ¯ Ùˆ ÙØ±Ù… Ø§Ù…Ø¶Ø§ Ø´ÙˆØ¯ ',0),(162543,4516,'pr','Ø´ØºÙ„ Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ú†Ø§Ù¾ Ø´ÙˆØ¯ ØªØ§ ÙˆÙ‚ØªÙŠ ÙƒÙ‡ Ø¬Ø¹Ø¨Ù‡ Ù…Ù†Ø§Ø³Ø¨ Ø¨Ø±Ø±Ø³ÙŠ Ø´ÙˆØ¯ Ùˆ ÙØ±Ù… Ø§Ù…Ø¶Ø§ Ø´ÙˆØ¯ ',0),(162544,4516,'tr','Ä°ÅŸinizi kadar uygun kutuyu kontrol edilir ve imzaladÄ±m yazdÄ±rÄ±lamÄ±yor',0),(162545,4516,'pl','Zadania nie mogÄ… byÄ‡ drukowane, dopiero odpowiednie pole jest sprawdzony i podpisany Formularz',0),(162546,4516,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°, Ð´Ð¾ÐºÐ°Ñ‚Ð¾ ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚Ð½Ð¾Ñ‚Ð¾ Ð¿Ð¾Ð»Ðµ Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½ Ð¸ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€',0),(162547,4516,'ur','Ø¢Ù¾ Ú©Ø§ Ú©Ø§Ù… Ù†ÛÛŒÚº ÛŒÛØ§Úº ØªÚ© Ú©Û Ù…Ù†Ø§Ø³Ø¨ Ø®Ø§Ù†Û Ù¾Ú‘ØªØ§Ù„ Ø´Ø¯Û ÛÛ’ Ø§ÙˆØ± ÙØ§Ø±Ù… Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú†Ú¾Ø§Ù¾ÛŒ Ø¬Ø§ Ø³Ú©ØªÛŒÚº',0),(162548,4516,'sr','Ð¢Ð²Ð¾Ñ˜ Ð¿Ð¾ÑÐ°Ð¾ ÑÐµ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ‚Ð¸ Ð´Ð¾Ðº Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½ Ð¸Ð·Ð±Ð¾Ñ€ Ñƒ Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð°Ñ˜ÑƒÑ›ÐµÐ¼ Ð¿Ð¾Ñ™Ñƒ Ð¸ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ†',0),(162549,4516,'vi','Job cá»§a báº¡n khÃ´ng thá»ƒ in Ä‘áº¿n khi há»™p thÃ­ch há»£p Ä‘Ã£ chá»n & máº«u Ä‘Ã£ kÃ½',0),(162550,4516,'af','U WERKSOPDRAG kan nie UITGEDRUK word totdat die gepasde boksie nie GEMERK is en die vorm geteken is nie',0),(162551,4516,'ro','Treaba ta nu poate fi tipÄƒrita pÃ¢nÄƒ cand caseta corespunzÄƒtoare nu este verificata ÅŸi semnata',0),(162552,4516,'et','Teie ametit ei saa trÃ¼kkida ennem kui Ãµiges kastis on linnuke tehtud ja allkirjastatud',0),(162553,4516,'si','VaÅ¡e delo ni mogoÄe natisniti, dokler se preveri ustrezno polje in je obrazec podpisati',0),(162554,4516,'ba','Pekerjaan Anda tidak dapat dicetak sampai kotak dicentang dan menandatangani formulir',0),(162555,4516,'nl','Uw baan kan niet worden afgedrukt totdat het juiste selectievakje is ingeschakeld en het formulier ondertekend',0),(162556,4516,'fi','TyÃ¶si ei voi tulostaa, ennen kuin sopiva valintaruutu on valittuna ja lomakkeen kirjautunut',0),(162557,4516,'no','Jobben kan ikke skrives til den aktuelle boksen kontrolleres og skjemaet signert',0),(162558,4516,'da','Dit job kan ikke udskrives, indtil den relevante boks er kontrollerede og form underskrevet',0),(162559,4516,'ko','ì ì ˆ í•œ í™•ì¸ëž€ì„ ì„ íƒ í•˜ ê³  ì–‘ì‹ì„ ì„œëª… ë  ë•Œê¹Œì§€ ìž‘ì—…ì„ ì¸ì‡„í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(162560,4516,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×“×¤×™×¡ ××ª ×”×¢×‘×•×“×” ×©×œ×š ×¢×“ ×‘×ª×™×‘×” ×”×ž×ª××™×ž×” × ×‘×“×§×ª ×•×—×ª× ×”×˜×•×¤×¡',0),(162561,4516,'el','Î— Î´Î¿Ï…Î»ÎµÎ¹Î¬ ÏƒÎ¿Ï… Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î³Î¯Î½ÎµÎ¹ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î¼Î­Ï‡ÏÎ¹ Ï„Î¿ ÎºÎ±Ï„Î¬Î»Î»Î·Î»Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ ÎµÎ¯Î½Î±Î¹ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎºÎ±Î¹ Ï„Î·Î½ Ï…Ï€Î¿Î³ÎµÎ³ÏÎ±Î¼Î¼Î­Î½Î·',0),(162562,4516,'zh','ä½ çš„å·¥ä½œä¸èƒ½æ‰“å°ï¼Œç›´åˆ°é€‰ä¸­é€‚å½“çš„é€‰æ¡†å’Œç­¾è®¢çš„è¡¨æ ¼\r\n',0),(162563,4516,'sv','Ditt jobb kan inte skrivas ut tills rutan Ã¤r markerad och form undertecknat',0),(162564,4516,'it','Il tuo lavoro non puÃ² essere stampato fino a quando Ã¨ selezionata la casella appropriata e il modulo firmato',0),(162565,4516,'tl','',0),(162566,4516,'th','Your job cannot be printed until the appropriate box is checked and the form signed',0),(162567,4516,'hi','à¤†à¤ªà¤•à¥€ à¤¨à¥Œà¤•à¤°à¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤œà¤¬ à¤¤à¤• à¤‰à¤ªà¤¯à¥à¤•à¥à¤¤ à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¥€ à¤¹à¥ˆ à¤”à¤° à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤¿à¤',0),(162568,4516,'ms','Kerja anda tidak dapat dicetak sehingga kotak yang sesuai disemak dan ditandatangani',0),(162569,4516,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø­ØªÙ‰ ÙŠØªÙ… Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ù…Ø±Ø¨Ø¹ Ø§Ù„Ù…Ù†Ø§Ø³Ø¨ ÙˆØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ù†Ù…ÙˆØ°Ø¬',0),(162570,4516,'fr','Votre travail ne peut pas Ãªtre imprimÃ© jusqu\'Ã  ce que la case correspondante est cochÃ©e et le formulaire signÃ©',0),(162571,4516,'jp','é?©åˆ‡ã?ªãƒœãƒƒã‚¯ã‚¹ã?Œãƒ?ã‚§ãƒƒã‚¯ã?•ã‚Œãƒ•ã‚©ãƒ¼ãƒ ã?«ç½²å??ã?•ã‚Œã‚‹ã?¾ã?§ã?¯ã€?ã?‚ã?ªã?Ÿã?®ä½œæ¥­ã‚’å?°åˆ·ã?™ã‚‹ã?“ã?¨ã?¯ã?§ã??ã?¾ã?›ã‚“',0),(162572,4516,'pt','Seu trabalho nÃ£o pode ser impresso atÃ© a caixa apropriada Ã© verificada e o formulÃ¡rio assinado',0),(162573,4516,'ru','Ð’Ð°ÑˆÐ° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð½Ð°Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð½ Ð´Ð¾ Ñ‚ÐµÑ… Ð¿Ð¾Ñ€, Ð¿Ð¾ÐºÐ° ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ Ñ„Ð»Ð°Ð¶Ð¾Ðº ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½ Ð¸ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ñ„Ð¾Ñ€Ð¼Ñƒ',0),(162574,4516,'es','Su trabajo no puede ser impreso hasta que selecciona la caja apropiada y la forma estÃ© firmada',0),(162575,4516,'de','Ihre Arbeit kann nicht gedruckt werden, bis das entsprechende KontrollkÃ¤stchen aktiviert ist und das Formular unterschrieben',0),(162576,4516,'en','Your job cannot be printed until the appropriate box is checked and the form signed',0),(162577,4517,'is','',0),(162578,4517,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø§Ø¯Ø±Ø³Øª Ø¨Ø±Ø§ÙŠ ',0),(162579,4517,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø§Ø¯Ø±Ø³Øª Ø¨Ø±Ø§ÙŠ ',0),(162580,4517,'tr','YanlÄ±ÅŸ parola',0),(162581,4517,'pl','NieprawidÅ‚owe hasÅ‚o',0),(162582,4517,'bg','ÐÐµÐ¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð·Ð°',0),(162583,4517,'ur','ØºÙ„Ø· Ù¾Ø§Ø³ ÙˆØ±Úˆ Ú©Û’ Ù„ÛŒÛ’',0),(162584,4517,'sr','ÐÐµÐ¸ÑÐ¿Ñ€Ð°Ð²Ð½Ð° Ð»Ð¾Ð·Ð¸Ð½ÐºÐ° Ð·Ð°',0),(162585,4517,'vi','Máº­t kháº©u khÃ´ng Ä‘Ãºng cho',0),(162586,4517,'af','Foutiewe wagwoord vir',0),(162587,4517,'ro','ParolÄƒ incorectÄƒ pentru',0),(162588,4517,'et','Vale salasÃµna',0),(162589,4517,'si','Nepravilno geslo za',0),(162590,4517,'ba','Password yang salah untuk',0),(162591,4517,'nl','Onjuist wachtwoord voor',0),(162592,4517,'fi','Virheellinen salasana',0),(162593,4517,'no','Feil passord for',0),(162594,4517,'da','Forkert adgangskode for',0),(162595,4517,'ko','ì— ëŒ€ í•œ ìž˜ëª» ëœ ì•”í˜¸',0),(162596,4517,'he','×¡×™×¡×ž×” ×©×’×•×™×” ×¢×‘×•×¨',0),(162597,4517,'el','Î•ÏƒÏ†Î±Î»Î¼Î­Î½Î¿Ï‚ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î³Î¹Î±',0),(162598,4517,'zh','ä¸æ­£ç¡®çš„å¯†ç \r\n',0),(162599,4517,'sv','Felaktigt lÃ¶senord fÃ¶r',0),(162600,4517,'it','Password errata per',0),(162601,4517,'tl','',0),(162602,4517,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(162603,4517,'hi','à¤—à¤¼à¤²à¤¤ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤•à¥‡ à¤²à¤¿à¤',0),(162604,4517,'ms','Kata laluan yang betul untuk',0),(162605,4517,'ar','ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± ØºÙŠØ± ØµØ­ÙŠØ­Ø©',0),(162606,4517,'fr','Mot de passe incorrect pour',0),(162607,4517,'jp','ï½žã?®é–“é?•ã?£ã?Ÿãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰',0),(162608,4517,'pt','Senha incorreta para',0),(162609,4517,'ru','ÐÐµÐ²ÐµÑ€Ð½Ñ‹Ð¹ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð´Ð»Ñ',0),(162610,4517,'es','Clave incorrecto para',0),(162611,4517,'de','Falsches Kennwort fÃ¼r',0),(162612,4517,'en','Incorrect password for',0),(162613,4518,'is','',0),(162614,4518,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´ØºÙ„',0),(162615,4518,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´ØºÙ„',0),(162616,4518,'tr','Bu iÅŸ iÃ§in Ã§alÄ±ÅŸanlarÄ± seÃ§in',0),(162617,4518,'pl','Wybierz pracownikÃ³w do tej pracy',0),(162618,4518,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(162619,4518,'ur','Ø§Ø³ Ú©Ø§Ù… Ú©Û’ Ù„ÛŒÛ’ Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(162620,4518,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾',0),(162621,4518,'vi','Chá»n NhÃ¢n ViÃªn Cho Job',0),(162622,4518,'af','Kies Werknemers vir hierdie Projek',0),(162623,4518,'ro','SelectaÅ£i angajaÅ£i pentru acest Job',0),(162624,4518,'et','Vali selle tÃ¶Ã¶koha jaoks tÃ¶Ã¶taja',0),(162625,4518,'si','Izberite zaposlenih za ta posel',0),(162626,4518,'ba','Select karyawan untuk pekerjaan ini',0),(162627,4518,'nl','Werknemers-aanmeldingformulier voor selecteren',0),(162628,4518,'fi','Valitse tyÃ¶ntekijÃ¤t tÃ¤mÃ¤n tyÃ¶n',0),(162629,4518,'no','Velg ansatte for jobben',0),(162630,4518,'da','VÃ¦lg medarbejdere for dette Job',0),(162631,4518,'ko','ì´ ìž‘ì—…ì— ëŒ€ í•œ ì§ì›ì„ ì„ íƒ',0),(162632,4518,'he','×‘×—×¨ ×¢×•×‘×“×™× ×œ×¢×‘×•×“×” ×”×–××ª',0),(162633,4518,'el','Î•Ï€Î¹Î»Î­Î¾ÎµÏ„Îµ Ï„Î¿Ï…Ï‚ Ï…Ï€Î±Î»Î»Î®Î»Î¿Ï…Ï‚ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(162634,4518,'zh','é€‰æ‹©è¿™ä¸ªå·¥ä½œé›‡å‘˜\r\n',0),(162635,4518,'sv','VÃ¤lj medarbetare fÃ¶r detta jobb',0),(162636,4518,'it','Seleziona collaboratori per questo lavoro',0),(162637,4518,'tl','',0),(162638,4518,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(162639,4518,'hi','à¤‡à¤¸ à¤•à¤¾à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(162640,4518,'ms','Pilih pekerja bagi kerja ini',0),(162641,4518,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ† Ù„Ù‡Ø°Ù‡ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(162642,4518,'fr','SÃ©lectionnez les employÃ©s pour ce travail',0),(162643,4518,'jp','ã?“ã?®ä»•äº‹ã?®å¾“æ¥­å“¡ã‚’é?¸æŠž',0),(162644,4518,'pt','Selecionar funcionÃ¡rios para este trabalho',0),(162645,4518,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² Ð´Ð»Ñ Ð´Ð°Ð½Ð½Ð¾Ð¹ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(162646,4518,'es','Seleccionar Empleados para este Trabajo',0),(162647,4518,'de','WÃ¤hlen Sie Mitarbeiter fÃ¼r diesen Job',0),(162648,4518,'en','Select Employees for this Job',0),(162649,4519,'is','',0),(162650,4519,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø²ÙŠØ±  Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ Ø§Ù†Ø¯ ',0),(162651,4519,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø²ÙŠØ±  Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ Ø§Ù†Ø¯ ',0),(162652,4519,'tr','AÅŸaÄŸÄ±daki Ã§alÄ±ÅŸanlarÄ±n eklenmiÅŸtir',0),(162653,4519,'pl','Dodano nastÄ™pujÄ…ce pracownikÃ³w',0),(162654,4519,'bg','Ð¡Ð»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸',0),(162655,4519,'ur','Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(162656,4519,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÑÑƒ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(162657,4519,'vi','NhÃ¢n viÃªn nÃ y Ä‘Ã£ Ä‘Æ°á»£c thÃªm vÃ o',0),(162658,4519,'af','Die volgende Werkeners is Bygevoeg',0),(162659,4519,'ro','AngajaÅ£ii urmÄƒtoarele au fost adÄƒugate',0),(162660,4519,'et','JÃ¤rgnevad tÃ¶Ã¶tajad lisati',0),(162661,4519,'si','Naslednje zaposlenih so bile dodane',0),(162662,4519,'ba','Karyawan berikut telah ditambahkan',0),(162663,4519,'nl','de volgende werknemer is toegevoegd',0),(162664,4519,'fi','Seuraavat tyÃ¶ntekijÃ¤t on lisÃ¤tty',0),(162665,4519,'no','De fÃ¸lgende ansatte har lagt',0),(162666,4519,'da','De fÃ¸lgende medarbejdere er blevet tilfÃ¸jet',0),(162667,4519,'ko','ë‹¤ìŒ ì§ì› ì¶”ê°€ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(162668,4519,'he','×”×¢×•×‘×“×™× ×”×‘××™× × ×•×¡×¤×•',0),(162669,4519,'el','Î ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎ±Î½ Î¿Î¹ ÎµÎ¾Î®Ï‚ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Î¹',0),(162670,4519,'zh','ä¸‹é¢çš„å‘˜å·¥å·²æ–°å¢ž\r\n',0),(162671,4519,'sv','FÃ¶ljande anstÃ¤llda har lagts',0),(162672,4519,'it','Sono stati aggiunti i seguenti dipendenti',0),(162673,4519,'tl','',0),(162674,4519,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3605;&#3656;&#3629;&#3652;&#3611;&#3609;&#3637;&#3657;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(162675,4519,'hi','à¤¨à¤¿à¤®à¥à¤¨ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(162676,4519,'ms','Pekerja-pekerja berikut telah ditambah',0),(162677,4519,'ar','ØªÙ… Ø¥Ø¶Ø§ÙØ© \"Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ† Ø§Ù„ØªØ§Ù„ÙŠØ©\"',0),(162678,4519,'fr','Les employÃ©s suivants ont Ã©tÃ© ajoutÃ©s',0),(162679,4519,'jp','æ¬¡ã?®å¾“æ¥­å“¡ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(162680,4519,'pt','Foram adicionados os seguintes empregados',0),(162681,4519,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¸ Ð±Ñ‹Ð»Ð¸ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(162682,4519,'es','Los Siguentes Empleados se Agregaron',0),(162683,4519,'de','Folgende Mitarbeiter sind hinzugekommen',0),(162684,4519,'en','The Following Employees have been Added',0),(162685,4520,'is','',0),(162686,4520,'dr','Ø§ÙŠÙ† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± Ø§ÙŠÙ† Ø´ØºÙ„ Ù…Ø´ØºÙˆÙ„ Ø¨Ù‡ ÙƒØ§Ø± Ø§Ø³Øª ',0),(162687,4520,'pr','Ø§ÙŠÙ† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± Ø§ÙŠÙ† Ø´ØºÙ„ Ù…Ø´ØºÙˆÙ„ Ø¨Ù‡ ÙƒØ§Ø± Ø§Ø³Øª ',0),(162688,4520,'tr','Bu Ã§alÄ±ÅŸan zaten bu iÅŸte Ã§alÄ±ÅŸmaya',0),(162689,4520,'pl','Pracownik pracuje juÅ¼ w tej pracy',0),(162690,4520,'bg','Ð¢Ð¾Ð·Ð¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ðµ Ð²ÐµÑ‡Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð¸ Ð¿Ð¾ Ñ‚Ð¾Ð·Ð¸ Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(162691,4520,'ur','Ø§Ø³ Ú©Û’ Ù…Ù„Ø§Ø²Ù… Ù¾ÛÙ„Û’ ÛÛŒ ÛŒÛ Ú©Ø§Ù… Ù¾Ø± Ú©Ø§Ù… Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(162692,4520,'sr','Ð¢Ð°Ñ˜ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ñ€Ð°Ð´Ð¸ Ð½Ð° Ð¾Ð²Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾',0),(162693,4520,'vi','NhÃ¢n ViÃªn nÃ y hiá»‡n Ä‘ang lÃ m Job nÃ y',0),(162694,4520,'af','Hierdie Werknemer werk alreeds aan hierdie werkstuk',0),(162695,4520,'ro','Acest angajat lucreazÄƒ deja pe acest loc de muncÄƒ',0),(162696,4520,'et','TÃ¶Ã¶taja tÃ¶Ã¶tab selle tÃ¶Ã¶',0),(162697,4520,'si','Ta delavec Å¾e dela na tem delovnem mestu',0),(162698,4520,'ba','Karyawan ini sudah bekerja pada pekerjaan ini',0),(162699,4520,'nl','Deze werknemer werkt al op deze baan',0),(162700,4520,'fi','TÃ¤mÃ¤ tyÃ¶ntekijÃ¤ on jo aloittanut tÃ¤mÃ¤n tyÃ¶n',0),(162701,4520,'no','Denne ansatte arbeider allerede med denne jobben',0),(162702,4520,'da','Denne medarbejder allerede arbejdet pÃ¥ dette job',0),(162703,4520,'ko','ì´ ì§ì›ì€ ì´ë¯¸ì´ ì¼ì— ë…¸ë ¥ í•˜',0),(162704,4520,'he','×¢×•×‘×“ ×–×” ×›×‘×¨ ×¢×•×‘×“ ×¢×œ ×”×¢×‘×•×“×” ×”×–××ª',0),(162705,4520,'el','Î‘Ï…Ï„ÏŒ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ ÎµÏÎ³Î¬Î¶ÎµÏ„Î±Î¹ Î®Î´Î· Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(162706,4520,'zh','è¿™åé›‡å‘˜å·²ç»åœ¨åšè¿™ä¸ªå·¥ä½œ\r\n',0),(162707,4520,'sv','Medarbetaren arbetar redan pÃ¥ jobbet',0),(162708,4520,'it','Questo dipendente sta giÃ  lavorando su questo lavoro',0),(162709,4520,'tl','',0),(162710,4520,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;&#3585;&#3635;&#3621;&#3633;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;&#3651;&#3609;&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;&#3649;&#3621;&#3657;&#3623;',0),(162711,4520,'hi','à¤‡à¤¸ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤¸ à¤•à¤¾à¤® à¤ªà¤° à¤•à¤¾à¤® à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(162712,4520,'ms','Pekerja ini sudah bekerja pada kerja ini',0),(162713,4520,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ¸Ù ØªØ¹Ù…Ù„ Ø¨Ø§Ù„ÙØ¹Ù„ ÙÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ù…Ù‡Ù…Ø©',0),(162714,4520,'fr','Cet employÃ© travaille dÃ©jÃ  sur ce travail',0),(162715,4520,'jp','ã?“ã?®å¾“æ¥­å“¡ã?¯ã?™ã?§ã?«ã?“ã?®ä»•äº‹ã‚’æ‹…å½“ã?—ã?¦ã?„ã?¾ã?™',0),(162716,4520,'pt','Este funcionÃ¡rio jÃ¡ estÃ¡ trabalhando neste trabalho',0),(162717,4520,'ru','Ð­Ñ‚Ð¾Ñ‚ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº ÑƒÐ¶Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð°ÐµÑ‚ Ð½Ð° ÑÑ‚Ð¾Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ðµ',0),(162718,4520,'es','Este Empleado ya esta trabajando en este trabajo',0),(162719,4520,'de','Dieser Mitarbeiter arbeitet bereits an dieser Stelle',0),(162720,4520,'en','This Employee is already working on this job',0),(162721,4521,'is','',0),(162722,4521,'dr','Ø§ÙŠÙ† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø§Ø®ÙŠØ±Ø§ Ù…Ø´ØºÙˆÙ„ Ø¨Ù‡ ÙƒØ§Ø± Ø§Ø³Øª ',0),(162723,4521,'pr','Ø§ÙŠÙ† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø§Ø®ÙŠØ±Ø§ Ù…Ø´ØºÙˆÙ„ Ø¨Ù‡ ÙƒØ§Ø± Ø§Ø³Øª ',0),(162724,4521,'tr','Bu Ã§alÄ±ÅŸanÄ±n ÅŸu anda Ã§alÄ±ÅŸÄ±yor',0),(162725,4521,'pl','Ten pracownik aktualnie pracuje',0),(162726,4521,'bg','Ð¢Ð¾Ð·Ð¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ðµ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð¸',0),(162727,4521,'ur','Ø§Ø³ Ú©Û’ Ù…Ù„Ø§Ø²Ù… Ø§Ø³ ÙˆÙ‚Øª Ú©Ø§Ù… Ú©Ø± Ø±ÛÛŒ ÛÛ’',0),(162728,4521,'sr','Ð¢Ð°Ñ˜ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ñ€Ð°Ð´Ð¸',0),(162729,4521,'vi','NhÃ¢n ViÃªn nÃ y hiá»‡n Ä‘ang lÃ m viá»‡c',0),(162730,4521,'af','Hierdie Werknemer is tans indiens',0),(162731,4521,'ro','Acest angajat este in retea',0),(162732,4521,'et','TÃ¶Ã¶taja tÃ¶Ã¶tab praegu',0),(162733,4521,'si','Ta zaposleni trenutno deluje',0),(162734,4521,'ba','Karyawan ini saat ini bekerja',0),(162735,4521,'nl','Deze werknemer werkt momenteel',0),(162736,4521,'fi','TÃ¤mÃ¤ tyÃ¶ntekijÃ¤ on parhaillaan',0),(162737,4521,'no','Denne ansatte jobber',0),(162738,4521,'da','Denne medarbejder arbejder i Ã¸jeblikket',0),(162739,4521,'ko','ì´ ì§ì›ì€ í˜„ìž¬ ìž‘ì—…',0),(162740,4521,'he','×¢×•×‘×“ ×–×” ×¢×•×‘×“ ×›×¢×ª',0),(162741,4521,'el','Î•ÏÎ³Î¬Î¶ÎµÏ„Î±Î¹ ÎµÏ€Î¯ Ï„Î¿Ï… Ï€Î±ÏÏŒÎ½Ï„Î¿Ï‚ Î±Ï…Ï„ÏŒ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(162742,4521,'zh','è¿™åé›‡å‘˜ç›®å‰åœ¨å·¥ä½œ\r\n',0),(162743,4521,'sv','Denna medarbetare arbetar fÃ¶r nÃ¤rvarande',0),(162744,4521,'it','Questo dipendente sta attualmente lavorando',0),(162745,4521,'tl','',0),(162746,4521,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3585;&#3635;&#3621;&#3633;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;&#3629;&#3618;&#3641;&#3656;',0),(162747,4521,'hi','à¤‡à¤¸ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤•à¤¾à¤® à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(162748,4521,'ms','Pekerja ini kini sedang',0),(162749,4521,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ¸Ù ÙŠØ¹Ù…Ù„ Ø­Ø§Ù„ÙŠØ§',0),(162750,4521,'fr','Cet employÃ© travaille actuellement',0),(162751,4521,'jp','ã?“ã?®å¾“æ¥­å“¡ã?¯ç?¾åœ¨ä»•äº‹ä¸­ã?§ã?™',0),(162752,4521,'pt','Este empregado estÃ¡ trabalhando atualmente',0),(162753,4521,'ru','Ð­Ñ‚Ð¾Ñ‚ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ð°ÐµÑ‚ Ð² Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ',0),(162754,4521,'es','Este Empleado ya esta actualmente trabajando',0),(162755,4521,'de','Dieser Mitarbeiter arbeitet derzeit',0),(162756,4521,'en','This Employee is currently working',0),(162757,4522,'is','',0),(162758,4522,'dr','Ø²Ù…Ø§Ù†  Ùˆ  Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø«Ø¨Øª Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(162759,4522,'pr','Ø²Ù…Ø§Ù†  Ùˆ  Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø«Ø¨Øª Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(162760,4522,'tr','Zaman ve malzeme giriÅŸ iÃ§in sipariÅŸ',0),(162761,4522,'pl','Czas i materiaÅ‚y wejÅ›cia na zamÃ³wienie',0),(162762,4522,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(162763,4522,'ur','ÙˆÙ‚Øª Ø§ÙˆØ± Ù…ÙˆØ§Ø¯ Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’',0),(162764,4522,'sr','Ð’Ñ€ÐµÐ¼ÐµÐ½Ñƒ Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð¸Ð¼Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(162765,4522,'vi','Nháº­p Thá»i Gian & NguyÃªn Váº­t Liá»‡u Cho ÄÆ¡n HÃ ng',0),(162766,4522,'af','Tyd en Materiale Inskrywing vir Bestelling',0),(162767,4522,'ro','Timp ÅŸi materiale de intrare pentru comanda',0),(162768,4522,'et','Aega ja materjale suunamise jÃ¤rjekorras',0),(162769,4522,'si','ÄŒas in materialov vnos za nalog',0),(162770,4522,'ba','Waktu dan bahan entri untuk Order',0),(162771,4522,'nl','Tijd en materialen vermelding voor Order',0),(162772,4522,'fi','Aikaa ja materiaalit merkintÃ¤ tilauksen',0),(162773,4522,'no','Tid og materialer oppfÃ¸ringen for ordre',0),(162774,4522,'da','Tid og materialer post for rÃ¦kkefÃ¸lge',0),(162775,4522,'ko','ì‹œê°„ ë° ìˆœì„œì— ëŒ€ í•œ ìžë£Œ í•­ëª©',0),(162776,4522,'he','×—×•×ž×¨×™ ×”×–× ×” ×¢×‘×•×¨ ×”×–×ž× ×ª ×•×–×ž×Ÿ',0),(162777,4522,'el','Î§ÏÏŒÎ½Î¿ ÎºÎ±Î¹ Ï…Î»Î¹ÎºÎ¬ Ï…Ï€Î±Î³Ï‰Î³Î®Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(162778,4522,'zh','è®¢å•æ—¶é—´å’Œææ–™æ¡ç›®\r\n',0),(162779,4522,'sv','Tid och material-post fÃ¶r bestÃ¤llning',0),(162780,4522,'it','Tempo e voce materiali per ordine',0),(162781,4522,'tl','',0),(162782,4522,'th','&#3648;&#3623;&#3621;&#3634;&#3649;&#3621;&#3632;&#3611;&#3633;&#3592;&#3592;&#3633;&#3618;&#3607;&#3637;&#3656;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(162783,4522,'hi','à¤¸à¤®à¤¯ à¤”à¤° à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(162784,4522,'ms','Masa dan kemasukan bahan-bahan untuk pesanan',0),(162785,4522,'ar','Ø§Ù„ÙˆÙ‚Øª ÙˆØ¥Ø¯Ø®Ø§Ù„ Ù…ÙˆØ§Ø¯ Ù„Ù„Ù†Ø¸Ø§Ù…',0),(162786,4522,'fr','Temps et l\'entrÃ©e de matÃ©riaux d\'ordre',0),(162787,4522,'jp','æ³¨æ–‡ã?®æ™‚é–“ã?¨æ??æ–™å…¥åŠ›',0),(162788,4522,'pt','Tempo e entrada de materiais para a ordem',0),(162789,4522,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð’Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð¸ ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð² Ð´Ð»Ñ Ð—Ð°ÐºÐ°Ð·Ð°',0),(162790,4522,'es','Entradas de Tiempo y Materiales del Orden',0),(162791,4522,'de','Zeit und Materialien Eintrag fÃ¼r Bestellung',0),(162792,4522,'en','Time and Materials Entry for Order',0),(162793,4523,'is','',0),(162794,4523,'dr','(Ù…Ø´Ø±ÙˆØ·',0),(162795,4523,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª Ù…Ø¹Ù„Ù‚(Ù…Ø´Ø±ÙˆØ·',0),(162796,4523,'tr','Bekleyen yapÄ± sipariÅŸler',0),(162797,4523,'pl','Czasu wykonania zamÃ³wienia',0),(162798,4523,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(162799,4523,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(162800,4523,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(162801,4523,'vi','ChÆ°a lÃ m Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(162802,4523,'af','Afwagtende Geboude Bestellings',0),(162803,4523,'ro','Ordinele Ã®n aÈ™teptare construi',0),(162804,4523,'et','Ootel ehitada tellimused',0),(162805,4523,'si','ÄŒakajoÄe graditi naroÄila',0),(162806,4523,'ba','Membangun pending order',0),(162807,4523,'nl','In behandeling Build Orders',0),(162808,4523,'fi','Odottava rakentaa tilaukset',0),(162809,4523,'no','Ventende bygge bestillinger',0),(162810,4523,'da','Ventende bygge ordrer',0),(162811,4523,'ko','ë³´ë¥˜ ì¤‘ì¸ ë¹Œë“œ ì˜¤ë”',0),(162812,4523,'he','×”×–×ž× ×•×ª ×ž×ž×ª×™× ×•×ª ×œ×‘× ×•×ª',0),(162813,4523,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± ÎšÎ‘Î¤Î‘Î£ÎšÎ•Î¥Î—Î£',0),(162814,4523,'zh','å¾…æž„ç­‘é¡ºåº\r\n',0),(162815,4523,'sv','VÃ¤ntande bygga order',0),(162816,4523,'it','Ordini in corso di compilazione',0),(162817,4523,'tl','',0),(162818,4523,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(162819,4523,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤†à¤¦à¥‡à¤¶',0),(162820,4523,'ms','Pesanan belum selesai membina',0),(162821,4523,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡ Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(162822,4523,'fr','Commandes en attente de Build',0),(162823,4523,'jp','ä¿?ç•™ä¸­ã?®çµ„ç«‹æ³¨æ–‡',0),(162824,4523,'pt','Ordens de construÃ§Ã£o pendentes',0),(162825,4523,'ru','Ð”Ð¾ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(162826,4523,'es','Ordenes de ConstrucciÃ³n Pendientes',0),(162827,4523,'de','Ausstehende Build Orders',0),(162828,4523,'en','Pending Build Orders',0),(162829,4524,'is','',0),(162830,4524,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚ ',0),(162831,4524,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚ ',0),(162832,4524,'tr','Bekleyen satÄ±nalma sipariÅŸleri',0),(162833,4524,'pl','ZamÃ³wienia oczekujÄ…ce',0),(162834,4524,'bg','Ð§Ð°ÐºÐ°Ñ‰Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(162835,4524,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(162836,4524,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð½Ð°Ð±Ð°Ð²Ñ™ÐµÐ½Ð¾Ð³',0),(162837,4524,'vi','ÄÆ¡n mua hÃ ng chÆ°a lÃ m',0),(162838,4524,'af','Afwagtende Aankoopbestellings',0),(162839,4524,'ro','Comenzi de cumpÄƒrare Ã®n aÅŸteptare',0),(162840,4524,'et','Ootel ostutellimused',0),(162841,4524,'si','NereÅ¡en nabavni nalogi',0),(162842,4524,'ba','Pesanan tertunda pembelian',0),(162843,4524,'nl','In behandeling inkooporders',0),(162844,4524,'fi','Odottavat ostotilaukset',0),(162845,4524,'no','Ventende bestillinger',0),(162846,4524,'da','Ventende indkÃ¸bsordrer',0),(162847,4524,'ko','ë³´ë¥˜ ì¤‘ì¸ êµ¬ë§¤ ì£¼ë¬¸ì„œ',0),(162848,4524,'he','×”×–×ž× ×•×ª ×¨×›×© ×ž×ž×ª×™× ×•×ª',0),(162849,4524,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Î³Î¿ÏÏŽÎ½ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î±',0),(162850,4524,'zh','å¾…é‡‡è´­è®¢å•\r\n',0),(162851,4524,'sv','VÃ¤ntande inkÃ¶psorder',0),(162852,4524,'it','Ordini di acquisto in sospeso',0),(162853,4524,'tl','',0),(162854,4524,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(162855,4524,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(162856,4524,'ms','Pesanan pembelian yang belum selesai',0),(162857,4524,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡ Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(162858,4524,'fr','Commandes en attente',0),(162859,4524,'jp','ä¿?ç•™ä¸­ã?®ç™ºæ³¨æ›¸',0),(162860,4524,'pt','Ordens de compra pendentes',0),(162861,4524,'ru','ÐžÐ¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(162862,4524,'es','Ordenes de Compra Pendientes',0),(162863,4524,'de','Ausstehende Bestellungen',0),(162864,4524,'en','Pending Purchase Orders',0),(162865,4525,'is','',0),(162866,4525,'dr','(Ø±Ø³ÙŠØ¯Ù‡Ø§) Ø¨Ø¯ÙˆÙ† ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÙŠØ¯ ',0),(162867,4525,'pr','Ø¯Ø±ÙŠØ§ÙØªÙ‡Ø§(Ø±Ø³ÙŠØ¯Ù‡Ø§) Ø¨Ø¯ÙˆÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(162868,4525,'tr','Makbuzlar olmadan PO',0),(162869,4525,'pl','Przychody bez PO',0),(162870,4525,'bg','ÐŸÑ€Ð¸Ñ…Ð¾Ð´Ð¸ Ð±ÐµÐ· PO',0),(162871,4525,'ur','Ø±Ø³ÛŒØ¯ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©Û’ Ø¨ØºÛŒØ±',0),(162872,4525,'sr','ÐŸÑ€Ð¸Ð·Ð½Ð°Ð½Ð¸Ñ†Ðµ Ð±ÐµÐ· ÐŸÐž',0),(162873,4525,'vi','BiÃªn nháº­n khÃ´ng Ä‘Æ¡n mua hÃ ng',0),(162874,4525,'af','Kwitansie sonder AB',0),(162875,4525,'ro','ÃŽncasÄƒri fÄƒrÄƒ PO',0),(162876,4525,'et','Tulud ilma PO',0),(162877,4525,'si','Potrdila brez PO',0),(162878,4525,'ba','Penerimaan tanpa PO',0),(162879,4525,'nl','Ontvangsten zonder PO',0),(162880,4525,'fi','Tulot ilman PO',0),(162881,4525,'no','Mottak uten PO',0),(162882,4525,'da','IndtÃ¦gter uden PO',0),(162883,4525,'ko','í¬ ì—†ì´ ì˜ìˆ˜ì¦',0),(162884,4525,'he','×§×‘×œ×•×ª ×ž×‘×œ×™ ×¤×•',0),(162885,4525,'el','Î‘Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ Ï‡Ï‰ÏÎ¯Ï‚ PO',0),(162886,4525,'zh','æ²¡æœ‰è®¢å•çš„æ”¶æ®\r\n',0),(162887,4525,'sv','Inleveranser utan PO',0),(162888,4525,'it','Entrate senza PO',0),(162889,4525,'tl','',0),(162890,4525,'th','&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(162891,4525,'hi','PO à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚',0),(162892,4525,'ms','Resit tanpa PO',0),(162893,4525,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ø¯ÙˆÙ† Ø¨Ùˆ',0),(162894,4525,'fr','Recettes sans PO',0),(162895,4525,'jp','ç™ºæ³¨æ›¸ã?ªã?—ã?®é ˜å?Žæ›¸',0),(162896,4525,'pt','Recibos sem PO',0),(162897,4525,'ru','ÐšÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð±ÐµÐ· PO',0),(162898,4525,'es','Recibos Sin OC',0),(162899,4525,'de','Einnahmen ohne PO',0),(162900,4525,'en','Receipts Without PO',0),(162901,4526,'is','',0),(162902,4526,'dr','(Ø±Ø³ÙŠØ¯Ù‡Ø§) Ø¨Ø§ ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÙŠØ¯',0),(162903,4526,'pr','Ø¯Ø±ÙŠØ§ÙØªÙ‡Ø§(Ø±Ø³ÙŠØ¯Ù‡Ø§) Ø¨Ø§ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(162904,4526,'tr','AlÄ±ndÄ± bilgileriyle PO',0),(162905,4526,'pl','WpÅ‚ywy z PO',0),(162906,4526,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ñ PO',0),(162907,4526,'ur','Ø±Ø³ÛŒØ¯ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©Û’ Ø³Ø§ØªÚ¾',0),(162908,4526,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ðµ ÑƒÐ· ÐŸÐž',0),(162909,4526,'vi','BiÃªn nháº­n vá»›i Ä‘Æ¡n mua hÃ ng',0),(162910,4526,'af','Kwitansie Met AB',0),(162911,4526,'ro','RecepÅ£iile cu PO',0),(162912,4526,'et','Laekumised PO',0),(162913,4526,'si','Potrdila z PO',0),(162914,4526,'ba','Penerimaan dengan PO',0),(162915,4526,'nl','Ontvangsten met PO',0),(162916,4526,'fi','Kuittausta PO',0),(162917,4526,'no','Mottak med PO',0),(162918,4526,'da','Kvitteringer med PO',0),(162919,4526,'ko','í¬ì™€ ì˜ìˆ˜ì¦',0),(162920,4526,'he','×§×‘×œ×•×ª ×¢× ×¤×•',0),(162921,4526,'el','ÎˆÏƒÎ¿Î´Î± Î¼Îµ PO',0),(162922,4526,'zh','æœ‰è®¢å•çš„æ”¶æ®\r\n',0),(162923,4526,'sv','Kvitton med PO',0),(162924,4526,'it','Entrate con PO',0),(162925,4526,'tl','',0),(162926,4526,'th','&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(162927,4526,'hi','à¤ªà¥‹ à¤¸à¤¾à¤¥ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚',0),(162928,4526,'ms','Resit dengan PO',0),(162929,4526,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ù…Ø¹ Ø¨Ùˆ',0),(162930,4526,'fr','Recettes avec PO',0),(162931,4526,'jp','ç™ºæ³¨æ›¸ã?‚ã‚Šã?®é ˜å?Žæ›¸',0),(162932,4526,'pt','Receitas com PO',0),(162933,4526,'ru','ÐšÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ñ PO',0),(162934,4526,'es','Recibos Con OC',0),(162935,4526,'de','Einnahmen mit PO',0),(162936,4526,'en','Receipts With PO',0),(162937,4527,'is','',0),(162938,4527,'dr','Ø§ØµÙ„Ø§Ø­Ø§Øª Ø§Ø®ÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(162939,4527,'pr','Ø§ØµÙ„Ø§Ø­Ø§Øª Ø§Ø®ÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(162940,4527,'tr','Son stok ayarlamalarÄ±',0),(162941,4527,'pl','Ostatnie korekty magazynu',0),(162942,4527,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°',0),(162943,4527,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(162944,4527,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(162945,4527,'vi','Chá»‰nh Sá»­a HÃ ng Trong Kho Má»›i Nháº¥t',0),(162946,4527,'af','Onlangse Voorraad Aanpassings',0),(162947,4527,'ro','Recente ajustÄƒrile de stocuri',0),(162948,4527,'et','Tehtud varude tÃ¤psustused',0),(162949,4527,'si','Nedavni popravki vrednosti zaloge',0),(162950,4527,'ba','Hari persediaan penyesuaian',0),(162951,4527,'nl','Recente voorraadherwaarderingen',0),(162952,4527,'fi','Hotelliin varastomuutokset',0),(162953,4527,'no','Siste lagerjusteringer',0),(162954,4527,'da','Seneste lagerreguleringer',0),(162955,4527,'ko','ìµœê·¼ ìž¬ê³  ì¡°ì •',0),(162956,4527,'he','×”×ª××ž×•×ª ×ž×œ××™ ×œ××—×¨×•× ×”',0),(162957,4527,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(162958,4527,'zh','æœ€è¿‘çš„åº“å­˜è°ƒæ•´\r\n',0),(162959,4527,'sv','Senaste lagerjusteringar',0),(162960,4527,'it','Recenti rettifiche di magazzino',0),(162961,4527,'tl','',0),(162962,4527,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(162963,4527,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(162964,4527,'ms','Hari inventori pelarasan',0),(162965,4527,'ar','Ø§Ù„Ø£Ø®ÙŠØ±Ø© ØªØ¹Ø¯ÙŠÙ„Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(162966,4527,'fr','RÃ©cents ajustements d\'inventaire',0),(162967,4527,'jp','æœ€è¿‘ã?®åœ¨åº«èª¿æ•´',0),(162968,4527,'pt','Ãšltimos ajustes de inventÃ¡rio',0),(162969,4527,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(162970,4527,'es','Ajustes de Inventario Reciente',0),(162971,4527,'de','Den letzten Lagerregulierungen',0),(162972,4527,'en','Recent Inventory Adjustments',0),(162973,4528,'is','',0),(162974,4528,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø§ØµÙ„Ø§Ø­Ø§Øª',0),(162975,4528,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø§ØµÙ„Ø§Ø­Ø§Øª',0),(162976,4528,'tr','Toplam ayarlamalar',0),(162977,4528,'pl','CaÅ‚kowitej korekty',0),(162978,4528,'bg','ÐžÐ±Ñ‰Ð¾ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸',0),(162979,4528,'ur','Ú©Ù„ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(162980,4528,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ð°',0),(162981,4528,'vi','Tá»•ng cá»™ng chá»‰nh sá»­a',0),(162982,4528,'af','Totale Aanpassings',0),(162983,4528,'ro','Total ajustÄƒri',0),(162984,4528,'et','Korrigeerimised kokku',0),(162985,4528,'si','Skupni popravki',0),(162986,4528,'ba','Total penyesuaian',0),(162987,4528,'nl','Totale aanpassingen',0),(162988,4528,'fi','Oikaisut yhteensÃ¤',0),(162989,4528,'no','Totale justeringer',0),(162990,4528,'da','Samlede justeringer',0),(162991,4528,'ko','ì´ ì¡°ì •',0),(162992,4528,'he','×¡×” ×› ×”×ª××ž×•×ª',0),(162993,4528,'el','Î£ÏÎ½Î¿Î»Î¿ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³ÏŽÎ½',0),(162994,4528,'zh','å…±æœ‰è°ƒæ•´\r\n',0),(162995,4528,'sv','Totalt justeringar',0),(162996,4528,'it','Totale rettifiche',0),(162997,4528,'tl','',0),(162998,4528,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;',0),(162999,4528,'hi','à¤•à¥à¤² à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(163000,4528,'ms','Jumlah pelarasan',0),(163001,4528,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ØªØ¹Ø¯ÙŠÙ„Ø§Øª',0),(163002,4528,'fr','Total des rajustements',0),(163003,4528,'jp','èª¿æ•´å?ˆè¨ˆ',0),(163004,4528,'pt','Ajustes totais',0),(163005,4528,'ru','ÐžÐ±Ñ‰Ð°Ñ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ°',0),(163006,4528,'es','Ajustes Totales',0),(163007,4528,'de','Total Anpassungen',0),(163008,4528,'en','Total Adjustments',0),(163009,4529,'is','',0),(163010,4529,'dr','Ù…ØµØ±Ù  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø·Ø¨Ù‚ Ú¯Ø±ÙˆÙ‡ ',0),(163011,4529,'pr','Ù…ØµØ±Ù  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø·Ø¨Ù‚ Ú¯Ø±ÙˆÙ‡ ',0),(163012,4529,'tr','Kategoriye gÃ¶re stok kullanÄ±mÄ±',0),(163013,4529,'pl','ZuÅ¼ycie zapasÃ³w wedÅ‚ug kategorii',0),(163014,4529,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°ÐµÐ¼Ð¾ÑÑ‚ Ð½Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(163015,4529,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø²Ù…Ø±Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(163016,4529,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸',0),(163017,4529,'vi','HÃ ng HÃ³a Sá»­ Dá»¥ng Theo Thá»ƒ Loáº¡i',0),(163018,4529,'af','Voorraad Gebruik Per Kategorie',0),(163019,4529,'ro','Stocuri de utilizare categorii',0),(163020,4529,'et','Varude kasutamine kategooriate kaupa',0),(163021,4529,'si','Zaloge navada po kategoriji',0),(163022,4529,'ba','Penggunaan persediaan berdasarkan Kategori',0),(163023,4529,'nl','Inventaris gebruik door categorie',0),(163024,4529,'fi','Sivustovaraston kÃ¤yttÃ¶ luokittain',0),(163025,4529,'no','Lager bruk av kategorien',0),(163026,4529,'da','Lageret brugen af kategori',0),(163027,4529,'ko','ë²”ì£¼ë³„ìœ¼ë¡œ ì¸ë²¤í† ë¦¬ ì‚¬ìš©',0),(163028,4529,'he','×©×™×ž×•×© ×‘×ž×œ××™ ×¢×œ ×¤×™ ×§×˜×’×•×¨×™×”',0),(163029,4529,'el','Î§ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î±Î½Î¬ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(163030,4529,'zh','åº“å­˜ä½¿ç”¨æŒ‰ç±»åˆ«\r\n',0),(163031,4529,'sv','Inventering anvÃ¤ndning av kategori',0),(163032,4529,'it','Utilizzo di inventario di categoria',0),(163033,4529,'tl','',0),(163034,4529,'th','&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3648;&#3611;&#3655;&#3609;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(163035,4529,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥‚à¤šà¥€ à¤‰à¤ªà¤¯à¥‹à¤—',0),(163036,4529,'ms','Penggunaan inventori mengikut Kategori',0),(163037,4529,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø­Ø³Ø¨ Ø§Ù„ÙØ¦Ø©',0),(163038,4529,'fr','Utilisation de l\'inventaire par catÃ©gorie',0),(163039,4529,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼åˆ¥åœ¨åº«ä½¿ç”¨',0),(163040,4529,'pt','Uso de estoque por categoria',0),(163041,4529,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÐ¼',0),(163042,4529,'es','Uso de Inventario por CategorÃ­a',0),(163043,4529,'de','Inventar-Nutzung durch Kategorie',0),(163044,4529,'en','Inventory Usage By Category',0),(163045,4530,'is','',0),(163046,4530,'dr','Ø¢Ø®Ø±ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡ ',0),(163047,4530,'pr','Ø¢Ø®Ø±ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡ ',0),(163048,4530,'tr','Son iÅŸlem',0),(163049,4530,'pl','Ostatniej transakcji',0),(163050,4530,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð°Ñ‚Ð° ÑÐ´ÐµÐ»ÐºÐ°',0),(163051,4530,'ur','Ø¢Ø®Ø±ÛŒ Ù„ÛŒÙ† Ø¯ÛŒÙ†',0),(163052,4530,'sr','ÐŸÑ€Ð¾ÑˆÐ»Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(163053,4530,'vi','Giao dá»‹ch cuá»‘i cÃ¹ng',0),(163054,4530,'af','Laaste Transaksie',0),(163055,4530,'ro','Ultima tranzactie',0),(163056,4530,'et','Viimase kande',0),(163057,4530,'si','Zadnje transakcije',0),(163058,4530,'ba','Transaksi terakhir',0),(163059,4530,'nl','Laatste transactie',0),(163060,4530,'fi','Viimeisen tapahtuman',0),(163061,4530,'no','Siste transaksjonen',0),(163062,4530,'da','Sidste postering',0),(163063,4530,'ko','ë§ˆì§€ë§‰ íŠ¸ëžœìž­ì…˜',0),(163064,4530,'he','×¢×¡×§×” ××—×¨×•× ×”',0),(163065,4530,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎºÎ¯Î½Î·ÏƒÎ·',0),(163066,4530,'zh','æœ€åŽä¸€ç¬”äº¤æ˜“\r\n',0),(163067,4530,'sv','Senaste transaktion',0),(163068,4530,'it','Ultima transazione',0),(163069,4530,'tl','',0),(163070,4530,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3608;&#3640;&#3619;&#3585;&#3636;&#3592;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(163071,4530,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨',0),(163072,4530,'ms','Tarikh urus niaga',0),(163073,4530,'ar','Ø¢Ø®Ø± Ø¹Ù…Ù„ÙŠØ©',0),(163074,4530,'fr','DerniÃ¨re Transaction',0),(163075,4530,'jp','æœ€çµ‚å?–å¼•',0),(163076,4530,'pt','Ãšltima transaÃ§Ã£o',0),(163077,4530,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÑÐ´ÐµÐ»ÐºÐ¸',0),(163078,4530,'es','Ãšltima TransacciÃ³n',0),(163079,4530,'de','Letzte Transaktion',0),(163080,4530,'en','Last Transaction',0),(163081,4531,'is','',0),(163082,4531,'dr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(163083,4531,'pr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(163084,4531,'tr','Hareketleri',0),(163085,4531,'pl','Transakcje',0),(163086,4531,'bg','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(163087,4531,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ†',0),(163088,4531,'sr','Ð¢Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(163089,4531,'vi','Giao dá»‹ch ',0),(163090,4531,'af','Transaksies',0),(163091,4531,'ro','TranzacÅ£ii',0),(163092,4531,'et','Tehingud',0),(163093,4531,'si','Transakcije',0),(163094,4531,'ba','Transaksi',0),(163095,4531,'nl','Transacties',0),(163096,4531,'fi','Tapahtumat',0),(163097,4531,'no','Transaksjoner',0),(163098,4531,'da','Transaktioner',0),(163099,4531,'ko','ê±°ëž˜',0),(163100,4531,'he','×¢×¡×§××•×ª',0),(163101,4531,'el','Î£Ï…Î½Î±Î»Î»Î±Î³Î­Ï‚',0),(163102,4531,'zh','äº¤æ˜“\r\n',0),(163103,4531,'sv','Transaktioner',0),(163104,4531,'it','Transazioni',0),(163105,4531,'tl','',0),(163106,4531,'th','&#3585;&#3634;&#3619;&#3607;&#3635;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(163107,4531,'hi','à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨',0),(163108,4531,'ms','Urus niaga',0),(163109,4531,'ar','Ø§Ù„Ø¹Ù…Ù„ÙŠØ§Øª',0),(163110,4531,'fr','Transactions',0),(163111,4531,'jp','å?–å¼•',0),(163112,4531,'pt','TransaÃ§Ãµes',0),(163113,4531,'ru','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(163114,4531,'es','Transacciones',0),(163115,4531,'de','Transaktionen',0),(163116,4531,'en','Transactions',0),(163117,4532,'is','',0),(163118,4532,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(163119,4532,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(163120,4532,'tr','Hisse senedi',0),(163121,4532,'pl','W magazynie',0),(163122,4532,'bg','ÐÐ° ÑÐºÐ»Ð°Ð´',0),(163123,4532,'ur','Ø§Ø³Ù¹Ø§Ú© Ù…ÛŒÚº',0),(163124,4532,'sr','ÐÐ° Ð»Ð°Ð³ÐµÑ€Ñƒ',0),(163125,4532,'vi','Trong hÃ ng tá»“n',0),(163126,4532,'af','In Voorraad',0),(163127,4532,'ro','ÃŽn stoc',0),(163128,4532,'et','Laos',0),(163129,4532,'si','Na zalogi',0),(163130,4532,'ba','Dalam stok',0),(163131,4532,'nl','In voorraad',0),(163132,4532,'fi','Varastossa',0),(163133,4532,'no','PÃ¥ lager',0),(163134,4532,'da','PÃ¥ lager',0),(163135,4532,'ko','ìž¬ê³  ìžˆìŒ',0),(163136,4532,'he','×‘×ž×œ××™',0),(163137,4532,'el','Î£Îµ Î±Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(163138,4532,'zh','åº“å­˜\r\n',0),(163139,4532,'sv','I lager',0),(163140,4532,'it','In Stock',0),(163141,4532,'tl','',0),(163142,4532,'th','&#3651;&#3609;&#3626;&#3605;&#3655;&#3629;&#3585;',0),(163143,4532,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤®à¥‡à¤‚',0),(163144,4532,'ms','Dalam stok',0),(163145,4532,'ar','ÙÙŠ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(163146,4532,'fr','En Stock',0),(163147,4532,'jp','åœ¨åº«ä¸­',0),(163148,4532,'pt','Em estoque',0),(163149,4532,'ru','ÐÐ° ÑÐºÐ»Ð°Ð´Ðµ',0),(163150,4532,'es','En Stock',0),(163151,4532,'de','Auf Lager',0),(163152,4532,'en','In Stock',0),(163153,4533,'is','',0),(163154,4533,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(163155,4533,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(163156,4533,'tr','HiÃ§bir PO',0),(163157,4533,'pl','Nie PO',0),(163158,4533,'bg','ÐÑÐ¼Ð° PO',0),(163159,4533,'ur','Ú©ÙˆØ¦ÛŒ Ù¾Ùˆ',0),(163160,4533,'sr','ÐÐµÐ¼Ð° ÐŸÐž',0),(163161,4533,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n mua hÃ ng',0),(163162,4533,'af','Geen AB',0),(163163,4533,'ro','Nu PO',0),(163164,4533,'et','Nr PO',0),(163165,4533,'si','Ne PO',0),(163166,4533,'ba','PO tidak',0),(163167,4533,'nl','Geen PO',0),(163168,4533,'fi','No PO',0),(163169,4533,'no','Ingen PO',0),(163170,4533,'da','Ingen PO',0),(163171,4533,'ko','ì•„ë‹ˆ í¬',0),(163172,4533,'he','××™×Ÿ ×¤×•',0),(163173,4533,'el','PO Î´ÎµÎ½',0),(163174,4533,'zh','æ²¡æœ‰è®¢å•\r\n',0),(163175,4533,'sv','Inga PO',0),(163176,4533,'it','No PO',0),(163177,4533,'tl','',0),(163178,4533,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(163179,4533,'hi','à¤•à¥‹à¤ˆ à¤ªà¥‹',0),(163180,4533,'ms','PO tidak',0),(163181,4533,'ar','Ù„Ø§ Ø¨Ùˆ',0),(163182,4533,'fr','Aucun PO',0),(163183,4533,'jp','ç™ºæ³¨æ›¸ã?ªã?—',0),(163184,4533,'pt','NÃ£o PO',0),(163185,4533,'ru','ÐÐµ Ð Ð¾',0),(163186,4533,'es','No hay OC',0),(163187,4533,'de','Kein PO',0),(163188,4533,'en','No PO',0),(163189,4534,'is','',0),(163190,4534,'dr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯ ÙƒØ§Ù„Ø§ ',0),(163191,4534,'pr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯ ÙƒØ§Ù„Ø§ ',0),(163192,4534,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ Ã¶ÄŸesini yeniden sipariÅŸ listesi',0),(163193,4534,'pl','Widok elementu ZmieÅ„ kolejnoÅ›Ä‡ listy',0),(163194,4534,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(163195,4534,'ur','Ø±ÛŒÚ©Ø§Ø±ÚˆØ± ÙÛØ±Ø³Øª Ù…Ù†Ø¸Ø± Ø´Û’',0),(163196,4534,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ° Ð»Ð¸ÑÑ‚Ðµ',0),(163197,4534,'vi','Xem danh sÃ¡ch hÃ ng Ä‘áº·t láº¡i',0),(163198,4534,'af','Besigtig Item Herbestellingslys',0),(163199,4534,'ro','Vezi pct. reordona lista',0),(163200,4534,'et','Saate vaadata kauba kordustellimuse loend',0),(163201,4534,'si','Ogled elementa preurejanje seznama',0),(163202,4534,'ba','Lihat Item menyusun ulang daftar',0),(163203,4534,'nl','Lijst van weergave Item opnieuw ordenen',0),(163204,4534,'fi','NÃ¤ytÃ¤ JÃ¤rjestÃ¤ Nimikeluettelo',0),(163205,4534,'no','Vis Ordne liste',0),(163206,4534,'da','Se vareoversigten Ordn igen',0),(163207,4534,'ko','ëª©ë¡ ë³´ê¸° í•­ëª© ìˆœì„œ ë³€ê²½',0),(163208,4534,'he','×ª×¦×•×’×ª ×¨×©×™×ž×ª ×¤×¨×™×˜×™× ×—×™×“×•×©',0),(163209,4534,'el','Î ÏÎ¿Î²Î¿Î»Î® ÏƒÎ·Î¼ÎµÎ¯Î¿ Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î»Î¯ÏƒÏ„Î±Ï‚',0),(163210,4534,'zh','æŸ¥çœ‹é¡¹ç›®é‡æ–°è®¢è´­åˆ—è¡¨\r\n',0),(163211,4534,'sv','Visa artikellista fÃ¶r bestÃ¤llning',0),(163212,4534,'it','Elenco di riordino di elementi di vista',0),(163213,4534,'tl','',0),(163214,4534,'th','&#3604;&#3641;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3585;&#3621;&#3633;&#3610;&#3617;&#3634;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(163215,4534,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¸à¥‚à¤šà¥€ à¤¦à¥‡à¤–à¥‡à¤‚',0),(163216,4534,'ms','Lihat Item susun semula senarai',0),(163217,4534,'ar','Ø¹Ø±Ø¶ Ø¹Ù†ØµØ± Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø¥Ø¹Ø§Ø¯Ø© ØªØ±ØªÙŠØ¨',0),(163218,4534,'fr','Liste d\'affichage de point de rÃ©approvisionnement',0),(163219,4534,'jp','å“?ç›®å†?æ³¨æ–‡ãƒªã‚¹ãƒˆã?®è¡¨ç¤º',0),(163220,4534,'pt','Ver Item reordenar lista',0),(163221,4534,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¡Ð¿Ð¸ÑÐºÐ° ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð½Ñ‹Ñ… Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(163222,4534,'es','Visionar Lista de Items Reordenados',0),(163223,4534,'de','Ansicht Reorder Artikelliste',0),(163224,4534,'en','View Item Reorder List',0),(163225,4535,'is','',0),(163226,4535,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(163227,4535,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(163228,4535,'tr','Yeni stok maddeleri',0),(163229,4535,'pl','Nowych zapasÃ³w',0),(163230,4535,'bg','ÐÐ¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(163231,4535,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ù†Ø¦ÛŒ Ø§Ø´ÛŒØ§',0),(163232,4535,'sr','ÐÐ¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð¸ Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(163233,4535,'vi','Danh SÃ¡ch HÃ ng Trong Kho Má»›i',0),(163234,4535,'af','Nuwe Voorraad Items',0),(163235,4535,'ro','Noi obiecte de inventar',0),(163236,4535,'et','Uus laokaupade',0),(163237,4535,'si','Nove elemente zaloge',0),(163238,4535,'ba','Barang-barang inventaris baru',0),(163239,4535,'nl','Nieuwe voorraadartikelen',0),(163240,4535,'fi','Varaston uutuuksia',0),(163241,4535,'no','Nye lagervarer',0),(163242,4535,'da','Nye lagervarer',0),(163243,4535,'ko','ìƒˆë¡œìš´ ìž¬ê³  ëª©ë¡ í’ˆëª©',0),(163244,4535,'he','×¤×¨×™×˜×™ ×ž×œ××™ ×—×“×©×™×',0),(163245,4535,'el','ÎÎ­Î± ÎµÎ¯Î´Î· Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(163246,4535,'zh','æ–°çš„åº“å­˜ç‰©å“\r\n',0),(163247,4535,'sv','Nya lagerartiklar',0),(163248,4535,'it','Nuovi articoli di magazzino',0),(163249,4535,'tl','',0),(163250,4535,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(163251,4535,'hi','à¤¨à¤ˆ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤®',0),(163252,4535,'ms','Item inventori baru',0),(163253,4535,'ar','Ø£ØµÙ†Ø§Ù Ù…Ø®Ø²ÙˆÙ† Ø¬Ø¯ÙŠØ¯Ø©',0),(163254,4535,'fr','Nouveaux articles en stock',0),(163255,4535,'jp','æ–°è¦?åœ¨åº«å“?ç›®',0),(163256,4535,'pt','Novos itens de inventÃ¡rio',0),(163257,4535,'ru','ÐÐ¾Ð²Ð°Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð½Ð¾-Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ñ… Ñ†ÐµÐ½Ð½Ð¾ÑÑ‚ÐµÐ¹',0),(163258,4535,'es','Nuevo Items de Inventario',0),(163259,4535,'de','Neue Lagerartikel',0),(163260,4535,'en','New Inventory Items',0),(163261,4536,'is','',0),(163262,4536,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(163263,4536,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(163264,4536,'tr','Toplam yeni Ã¶ÄŸeler',0),(163265,4536,'pl','CaÅ‚kowita nowe elementy',0),(163266,4536,'bg','ÐžÐ±Ñ‰Ð¾ Ð½Ð¾Ð²Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(163267,4536,'ur','Ú©Ù„ Ù†Ø¦ÛŒ Ø§Ø´ÛŒØ§Ø¡',0),(163268,4536,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð½Ð¾Ð²Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸',0),(163269,4536,'vi','Tá»•ng cá»™ng hÃ ng má»›i',0),(163270,4536,'af','Totale Nuwe Items',0),(163271,4536,'ro','Total elemente noi',0),(163272,4536,'et','Uusi Ã¼ksusi kokku',0),(163273,4536,'si','Skupno Å¡tevilo novih elementov',0),(163274,4536,'ba','Total item baru',0),(163275,4536,'nl','Totaal nieuwe Items',0),(163276,4536,'fi','YhteensÃ¤ uusia kohteita',0),(163277,4536,'no','Totalt nye elementer',0),(163278,4536,'da','Samlede nye emner',0),(163279,4536,'ko','ì´ ìƒˆ í•­ëª©',0),(163280,4536,'he','×¡×š ×›×œ ×”×¤×¨×™×˜×™× ×”×—×“×©×™×',0),(163281,4536,'el','Î£ÏÎ½Î¿Î»Î¿ Î½Î­Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(163282,4536,'zh','æ€»è®¡æ–°é¡¹ç›®\r\n',0),(163283,4536,'sv','Totala nya objekt',0),(163284,4536,'it','Totali nuovi elementi',0),(163285,4536,'tl','',0),(163286,4536,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3627;&#3617;&#3656;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(163287,4536,'hi','à¤•à¥à¤² à¤¨à¤ à¤†à¤‡à¤Ÿà¤®',0),(163288,4536,'ms','Jumlah item yang baru',0),(163289,4536,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(163290,4536,'fr','NouveautÃ©s de totales',0),(163291,4536,'jp','æ–°è¦?å“?ç›®å?ˆè¨ˆ',0),(163292,4536,'pt','Total de itens novos',0),(163293,4536,'ru','Ð’ÑÐµÐ³Ð¾ Ð½Ð¾Ð²Ñ‹Ñ… ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(163294,4536,'es','Total Nuevos Items',0),(163295,4536,'de','Insgesamt neue Artikel',0),(163296,4536,'en','Total New Items',0),(163297,4537,'is','',0),(163298,4537,'dr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§',0),(163299,4537,'pr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§',0),(163300,4537,'tr','Madde listesini gÃ¶rÃ¼ntÃ¼leyin',0),(163301,4537,'pl','Widok elementu listy',0),(163302,4537,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº',0),(163303,4537,'ur','ÙÛØ±Ø³Øª Ù…Ù†Ø¸Ø± Ø´Û’',0),(163304,4537,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð»Ð¸ÑÑ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(163305,4537,'vi','Xem danh sÃ¡ch hÃ ng',0),(163306,4537,'af','Besigtig Item Lys',0),(163307,4537,'ro','Vezi lista de element',0),(163308,4537,'et','Saate vaadata kauba loend',0),(163309,4537,'si','Ogled elementa seznama',0),(163310,4537,'ba','Lihat Item daftar',0),(163311,4537,'nl','Itemlijst weergave',0),(163312,4537,'fi','NÃ¤ytÃ¤ Nimikeluettelo',0),(163313,4537,'no','Vis liste',0),(163314,4537,'da','Se elementlisten',0),(163315,4537,'ko','í•­ëª© ëª©ë¡ ë³´ê¸°',0),(163316,4537,'he','×”×¦×’ ×¨×©×™×ž×ª ×¤×¨×™×˜×™×',0),(163317,4537,'el','Î ÏÎ¿Î²Î¿Î»Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î»Î¯ÏƒÏ„Î±Ï‚',0),(163318,4537,'zh','æŸ¥çœ‹é¡¹ç›®åˆ—è¡¨\r\n',0),(163319,4537,'sv','Visa Artikellista',0),(163320,4537,'it','Elenco di elementi di visualizzazione',0),(163321,4537,'tl','',0),(163322,4537,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(163323,4537,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥‚à¤šà¥€ à¤¦à¥‡à¤–à¥‡à¤‚',0),(163324,4537,'ms','Lihat Item senarai',0),(163325,4537,'ar','Ø¹Ø±Ø¶ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(163326,4537,'fr','Liste de point de vue',0),(163327,4537,'jp','å“?ç›®ãƒªã‚¹ãƒˆã‚’è¦‹ã‚‹',0),(163328,4537,'pt','Ver Item lista',0),(163329,4537,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¡Ð¿Ð¸ÑÐºÐ° Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(163330,4537,'es','Visionar Lista de Items',0),(163331,4537,'de','Artikel-Anzeigeliste',0),(163332,4537,'en','View Item List',0),(163333,4538,'is','',0),(163334,4538,'dr','Ø´Ù…Ø§Ø±Ù‡ Ú©Ø§Ø¯Ø±',0),(163335,4538,'pr','Ø´Ù…Ø§Ø±Ù‡ Ú©Ø§Ø¯Ø±',0),(163336,4538,'tr','BO #',0),(163337,4538,'pl','BO #',0),(163338,4538,'bg','Ð‘Ðž #',0),(163339,4538,'ur','Ø¨Ùˆ #',0),(163340,4538,'sr','Ð‘Ðž #',0),(163341,4538,'vi','Sá»‘ BO',0),(163342,4538,'af','BO #',0),(163343,4538,'ro','BO #',0),(163344,4538,'et','BO #',0),(163345,4538,'si','BO #',0),(163346,4538,'ba','BO #',0),(163347,4538,'nl','BO #',0),(163348,4538,'fi','BO #',0),(163349,4538,'no','BO #',0),(163350,4538,'da','BO #',0),(163351,4538,'ko','ë³´ #',0),(163352,4538,'he','×‘×• #',0),(163353,4538,'el','BO #',0),(163354,4538,'zh','ä¸šåŠ¡å¯¹è±¡ï¼ƒ\r\n',0),(163355,4538,'sv','BO #',0),(163356,4538,'it','CIAD',0),(163357,4538,'tl','',0),(163358,4538,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3610;&#3636;&#3621;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(163359,4538,'hi','à¤¬à¥‹ #',0),(163360,4538,'ms','BO #',0),(163361,4538,'ar','Ø¨Ùˆ #',0),(163362,4538,'fr','BO #',0),(163363,4538,'jp','ï¼¢ï¼¯ç•ªå?·',0),(163364,4538,'pt','BO #',0),(163365,4538,'ru','Ð‘Ðž #',0),(163366,4538,'es','BO #',0),(163367,4538,'de','BO #',0),(163368,4538,'en','BO #',0),(163369,4539,'is','',0),(163370,4539,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(163371,4539,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(163372,4539,'tr','Bulunan yapÄ± emir',0),(163373,4539,'pl','Nie budowaÄ‡ zamÃ³wienia Znalezione',0),(163374,4539,'bg','Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(163375,4539,'ur','Ù¾Ø§ÛŒØ§ Ù†Û ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(163376,4539,'sr','ÐÐµÐ¼Ð° Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(163377,4539,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(163378,4539,'af','Geen Geboude Bestellings Gevind',0),(163379,4539,'ro','Nici o ordine construi gÄƒsit',0),(163380,4539,'et','Pole ehitada tellimusi leitud',0),(163381,4539,'si','Ne graditi naroÄila naÅ¡el',0),(163382,4539,'ba','Tidak ada order membangun yang ditemukan',0),(163383,4539,'nl','Geen Build Orders gevonden',0),(163384,4539,'fi','Rakentaa tilauksia ei lÃ¶ytynyt',0),(163385,4539,'no','Ingen bygge bestillinger funnet',0),(163386,4539,'da','Ingen bygge ordrer fundet',0),(163387,4539,'ko','ë°œê²¬ ì—†ìŒ ë¹Œë“œ ìˆœì„œ',0),(163388,4539,'he','×¤×§×•×“×•×ª ×œ×‘× ×•×ª × ×ž×¦××•',0),(163389,4539,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(163390,4539,'zh','æœªæ‰¾åˆ°æž„å»ºè®¢å•\r\n',0),(163391,4539,'sv','Inga bygga order hittade',0),(163392,4539,'it','Nessun ordine di compilazione trovato',0),(163393,4539,'tl','',0),(163394,4539,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(163395,4539,'hi','à¤•à¥‹à¤ˆ à¤¬à¤¿à¤²à¥à¤¡ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(163396,4539,'ms','Tiada pesanan membina yang ditemui',0),(163397,4539,'ar','Ù„Ø§ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡ Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(163398,4539,'fr','Aucune commande Build trouvÃ©',0),(163399,4539,'jp','çµ„ç«‹æ³¨æ–‡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(163400,4539,'pt','Sem ordens de construÃ§Ã£o encontrados',0),(163401,4539,'ru','ÐÐ°Ð¹Ð´ÐµÐ½Ð¾ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð½Ðµ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ',0),(163402,4539,'es','No se encontrÃ³ Ordenes de ConstrucciÃ³n',0),(163403,4539,'de','Keine Build AuftrÃ¤ge gefunden',0),(163404,4539,'en','No Build Orders Found',0),(163405,4540,'is','',0),(163406,4540,'dr','(Ù…Ù†ØªØ¸Ø±) ØªØ¹ÙˆÛŒÙ‚',0),(163407,4540,'pr','ÙƒÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª(Ù…Ù†ØªØ¸Ø±) Ù…Ø¹ÙˆÙ‚',0),(163408,4540,'tr','Toplam bekleyen yapÄ± sipariÅŸler',0),(163409,4540,'pl','Suma czasu wykonania zamÃ³wienia',0),(163410,4540,'bg','ÐžÐ±Ñ‰Ð¾ Ñ‡Ð°ÐºÐ°Ñ‰Ð¸ Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(163411,4540,'ur','Ú©Ù„ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(163412,4540,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(163413,4540,'vi','Táº¥t cáº£ cÃ¡c Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng chÆ°a thá»±c hiá»‡n',0),(163414,4540,'af','Bereken Afwagtende Geboude Bestellings',0),(163415,4540,'ro','TotalÄƒ pÃ¢nÄƒ la a construi comenzi',0),(163416,4540,'et','Kokku ootel ehitada tellimused',0),(163417,4540,'si','Skupaj ÄakajoÄih graditi naroÄila',0),(163418,4540,'ba','Jumlah pesanan tertunda membangun',0),(163419,4540,'nl','Total in behandeling Build Orders',0),(163420,4540,'fi','YhteensÃ¤ vireillÃ¤ rakentaa tilaukset',0),(163421,4540,'no','Totalt antall ventende bygge bestillinger',0),(163422,4540,'da','Samlede ventende bygge ordrer',0),(163423,4540,'ko','ë³´ë¥˜ ì¤‘ì¸ ë¹Œë“œ ì˜¤ë” ì´',0),(163424,4540,'he','×¡×” ×› ×”×–×ž× ×•×ª ×ž×ž×ª×™× ×•×ª ×œ×‘× ×•×ª',0),(163425,4540,'el','Î£ÏÎ½Î¿Î»Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± ÎšÎ‘Î¤Î‘Î£ÎšÎ•Î¥Î—Î£',0),(163426,4540,'zh','æ€»è®¡å¾…ç”Ÿæˆè®¢å•\r\n',0),(163427,4540,'sv','Totalt antal vÃ¤ntande bygga order',0),(163428,4540,'it','Totale ordini in sospeso Build',0),(163429,4540,'tl','',0),(163430,4540,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3619;&#3629;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(163431,4540,'hi','à¤•à¥à¤² à¤²à¤‚à¤¬à¤¿à¤¤ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤†à¤¦à¥‡à¤¶',0),(163432,4540,'ms','Jumlah pesanan belum selesai membina',0),(163433,4540,'ar','Ø¹Ø¯Ø¯ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡ Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(163434,4540,'fr','Total des commandes en attente de Build',0),(163435,4540,'jp','ä¿?ç•™ä¸­çµ„ç«‹æ³¨æ–‡ã?®å?ˆè¨ˆ',0),(163436,4540,'pt','Total de ordens de construÃ§Ã£o pendentes',0),(163437,4540,'ru','Ð’ÑÐµÐ³Ð¾ Ð´Ð¾ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(163438,4540,'es','Total de Ordenes de ConstrucciÃ³n Pendientes',0),(163439,4540,'de','Insgesamt ausstehenden Build Orders',0),(163440,4540,'en','Total Pending Build Orders',0),(163441,4541,'is','',0),(163442,4541,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(163443,4541,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(163444,4541,'tr','YapÄ± sipariÅŸleri gÃ¶rÃ¼ntÃ¼le',0),(163445,4541,'pl','Zobacz wykonania zamÃ³wienia',0),(163446,4541,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¡Ñ‚Ñ€Ð¾Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(163447,4541,'ur','Ù…Ù†Ø¸Ø± Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(163448,4541,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(163449,4541,'vi','Xem Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(163450,4541,'af','Besigtig Geboude Bestellings',0),(163451,4541,'ro','Vezi construi comenzi',0),(163452,4541,'et','Vaade ehitada tellimused',0),(163453,4541,'si','Pogled graditi naroÄila',0),(163454,4541,'ba','Lihat membangun perintah',0),(163455,4541,'nl','Build bestellingen bekijken',0),(163456,4541,'fi','NÃ¤ytÃ¤ rakentaa tilaukset',0),(163457,4541,'no','Vis bygge bestillinger',0),(163458,4541,'da','Se opbygge ordrer',0),(163459,4541,'ko','ë¹Œë“œ ì£¼ë¬¸ ë³´ê¸°',0),(163460,4541,'he','×ª×¦×•×’×ª ×œ×‘× ×•×ª ×”×–×ž× ×•×ª',0),(163461,4541,'el','Î†Ï€Î¿ÏˆÎ· ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(163462,4541,'zh','æŸ¥çœ‹ç”Ÿæˆè®¢å•\r\n',0),(163463,4541,'sv','Visa bygga order',0),(163464,4541,'it','Vista compilazione ordini',0),(163465,4541,'tl','',0),(163466,4541,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(163467,4541,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¬à¤¨à¤¾à¤à¤ à¤†à¤¦à¥‡à¤¶',0),(163468,4541,'ms','Perintah membina paparan',0),(163469,4541,'ar','Ø¹Ø±Ø¶ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(163470,4541,'fr','Vue Build Orders',0),(163471,4541,'jp','çµ„ç«‹æ³¨æ–‡ã‚’è¦‹ã‚‹',0),(163472,4541,'pt','Exibir ordens de construÃ§Ã£o',0),(163473,4541,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(163474,4541,'es','Visionar Ordenes de ConstrucciÃ³n',0),(163475,4541,'de','Build Bestellungen einsehen',0),(163476,4541,'en','View Build Orders',0),(163477,4542,'is','',0),(163478,4542,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(163479,4542,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(163480,4542,'tr','HiÃ§bir POs bulundu',0),(163481,4542,'pl','Nie POs Znalezione',0),(163482,4542,'bg','ÐÐµ ÐŸÐ¾Ð· Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(163483,4542,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù†',0),(163484,4542,'sr','ÐÐµÐ¼Ð° ÐŸÐžÑ Ð½Ð°ÑˆÐ°Ð¾',0),(163485,4542,'vi','ChÆ°a tháº¥y Ä‘Æ¡n mua hÃ ng',0),(163486,4542,'af','Geen ABs Gevind',0),(163487,4542,'ro','Nu POs gÄƒsit',0),(163488,4542,'et','Nr POs leitud',0),(163489,4542,'si','Ne POs naÅ¡el',0),(163490,4542,'ba','POs tidak ditemukan',0),(163491,4542,'nl','Geen POs gevonden',0),(163492,4542,'fi','Ei POs lÃ¶ytyi',0),(163493,4542,'no','Ingen POs funnet',0),(163494,4542,'da','Ingen POs fundet',0),(163495,4542,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” í¬ìŠ¤',0),(163496,4542,'he','××™×Ÿ POs × ×ž×¦××•',0),(163497,4542,'el','Î”ÎµÎ½ Î Î©Î£ Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(163498,4542,'zh','æ²¡æœ‰æ‰¾åˆ°é‡‡è´­è®¢å•\r\n',0),(163499,4542,'sv','Ingen POs hittade',0),(163500,4542,'it','No POs trovato',0),(163501,4542,'tl','',0),(163502,4542,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(163503,4542,'hi','à¤•à¥‹à¤ˆ POs à¤ªà¤¾à¤¯à¤¾',0),(163504,4542,'ms','Tiada POs yang ditemui',0),(163505,4542,'ar','Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(163506,4542,'fr','Aucun point de vente trouvÃ©s',0),(163507,4542,'jp','ç™ºæ³¨æ›¸ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(163508,4542,'pt','NÃ£o POs encontrados',0),(163509,4542,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾ POs',0),(163510,4542,'es','No se Encontraron OCs',0),(163511,4542,'de','Keine POs gefunden',0),(163512,4542,'en','No POs Found',0),(163513,4543,'is','',0),(163514,4543,'dr','(Ù…Ù†ØªØ¸Ø±) ØªØ¹ÙˆÛŒÙ‚',0),(163515,4543,'pr','ÙƒÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯(Ù…Ù†ØªØ¸Ø±) Ù…Ø¹ÙˆÙ‚',0),(163516,4543,'tr','POs bekleyen toplam',0),(163517,4543,'pl','CaÅ‚kowitego czasu POs',0),(163518,4543,'bg','ÐžÐ±Ñ‰Ð¾ Ñ‡Ð°ÐºÐ°Ñ‰Ð¸ POs',0),(163519,4543,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§ Ú©Ù„',0),(163520,4543,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ ÐŸÐžÑ',0),(163521,4543,'vi','Tá»•ng cá»™ng Ä‘Æ¡n mua hÃ ng Ä‘ang treo',0),(163522,4543,'af','Bereken Afwagtende ABs',0),(163523,4543,'ro','TotalÄƒ pÃ¢nÄƒ la POs',0),(163524,4543,'et','Kokku kuni POs',0),(163525,4543,'si','Skupno do POs',0),(163526,4543,'ba','Total tertunda POs',0),(163527,4543,'nl','Totale in afwachting van POs',0),(163528,4543,'fi','YhteensÃ¤ ennen POs',0),(163529,4543,'no','Totale ventende POs',0),(163530,4543,'da','Samlede ventende POs',0),(163531,4543,'ko','POs ë³´ë¥˜ ì¤‘ì¸ ì´',0),(163532,4543,'he','×¡×” ×› ×ž×ž×ª×™× ×™× POs',0),(163533,4543,'el','Î£ÏÎ½Î¿Î»Î¿ ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î® POs',0),(163534,4543,'zh','æ€»è®¡å¾…åŠžé‡‡è´­è®¢å•\r\n',0),(163535,4543,'sv','Totala avvaktan POs',0),(163536,4543,'it','Totale in attesa di POs',0),(163537,4543,'tl','',0),(163538,4543,'th','&#3618;&#3633;&#3591;&#3619;&#3629;&#3629;&#3618;&#3641;&#3656;&#3607;&#3637;&#3656;&#3592;&#3640;&#3604;&#3586;&#3634;&#3618;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(163539,4543,'hi','POs à¤²à¤‚à¤¬à¤¿à¤¤ à¤•à¥à¤²',0),(163540,4543,'ms','Jumlah sementara menunggu POs',0),(163541,4543,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù†ØªØ¸Ø§Ø±Ø§ Ù„Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹',0),(163542,4543,'fr','Total dans l\'attente de POs',0),(163543,4543,'jp','ä¿?ç•™ä¸­ç™ºæ³¨æ›¸ã?®å?ˆè¨ˆ',0),(163544,4543,'pt','Total pendente POs',0),(163545,4543,'ru','Ð’ÑÐµÐ³Ð¾ Ð´Ð¾ POs',0),(163546,4543,'es','Total OCs Pendientes',0),(163547,4543,'de','Gesamt bis POs',0),(163548,4543,'en','Total Pending POs',0),(163549,4544,'is','',0),(163550,4544,'dr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(163551,4544,'pr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(163552,4544,'tr','Stok PO listesini gÃ¶rÃ¼ntÃ¼le',0),(163553,4544,'pl','Widok listy zapasÃ³w PO',0),(163554,4544,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿Ð¾ ÑÐ¿Ð¸ÑÑŠÐº',0),(163555,4544,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù¾Ùˆ ÙÛØ±Ø³Øª Ø¯ÛŒÚ©Ú¾Ù†Ø§',0),(163556,4544,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° ÐŸÐž Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°',0),(163557,4544,'vi','Xem Danh SÃ¡ch ÄÆ¡n Mua HÃ ng Trong Kho',0),(163558,4544,'af','Besigtig Voorraad AB Lys',0),(163559,4544,'ro','Vezi lista de inventar PO',0),(163560,4544,'et','Varude PO loend',0),(163561,4544,'si','Oglejte si seznam zaloge PO',0),(163562,4544,'ba','Lihat daftar inventaris PO',0),(163563,4544,'nl','Weergave inventarislijst PO',0),(163564,4544,'fi','Katso Inventaarioluettelo PO',0),(163565,4544,'no','Vis inventarliste PO',0),(163566,4544,'da','Se lagerliste PO',0),(163567,4544,'ko','ë³´ê¸° ì¸ë²¤í† ë¦¬ í¬ ëª©ë¡',0),(163568,4544,'he','×ª×¦×•×’×ª ×¨×©×™×ž×ª ×”×ž×œ××™ ×¤×•',0),(163569,4544,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»Î¯ÏƒÏ„Î±Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ PO',0),(163570,4544,'zh','æŸ¥çœ‹åº“å­˜è®¢å•åˆ—è¡¨\r\n',0),(163571,4544,'sv','Visa Inventarielista PO',0),(163572,4544,'it','Vedi la lista inventario PO',0),(163573,4544,'tl','',0),(163574,4544,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(163575,4544,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤ªà¥‹ à¤¸à¥‚à¤šà¥€ à¤¦à¥‡à¤–à¥‡à¤‚',0),(163576,4544,'ms','Lihat senarai inventori PO',0),(163577,4544,'ar','Ø¹Ø±Ø¶ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ø±Ø¯ Ø¨Ùˆ',0),(163578,4544,'fr','Liste d\'affichage de l\'inventaire PO',0),(163579,4544,'jp','åœ¨åº«ç™ºæ³¨ãƒªã‚¹ãƒˆã?®è¡¨ç¤º',0),(163580,4544,'pt','Ver lista de inventÃ¡rio PO',0),(163581,4544,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð Ð¾',0),(163582,4544,'es','Visionar Lista de OC de Inventario',0),(163583,4544,'de','Ansicht-Inventarliste PO',0),(163584,4544,'en','View Inventory PO List',0),(163585,4545,'is','',0),(163586,4545,'dr','Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø¯ÙˆÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(163587,4545,'pr','Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø¯ÙˆÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(163588,4545,'tr','Stok giriÅŸlerini olmadan PO',0),(163589,4545,'pl','PrzyjÄ™Ä‡ magazynowych bez PO',0),(163590,4545,'bg','ÐžÐ¿Ð¸Ñ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð±ÐµÐ· PO',0),(163591,4545,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©Û’ Ø¨ØºÛŒØ±',0),(163592,4545,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ Ð±ÐµÐ· ÐŸÐž',0),(163593,4545,'vi','BiÃªn Nháº­n HÃ ng KhÃ´ng CÃ³ ÄÆ¡n Mua HÃ ng',0),(163594,4545,'af','Voorraad ontvangste sonder PO',0),(163595,4545,'ro','ÃŽncasÄƒrile inventarierea fÄƒrÄƒ PO',0),(163596,4545,'et','Lao sissetulekute ilma PO',0),(163597,4545,'si','Zaloge prejemki brez PO',0),(163598,4545,'ba','Persediaan penerimaan tanpa PO',0),(163599,4545,'nl','Inventaris ontvangsten zonder PO',0),(163600,4545,'fi','Varastovastaanottojen ilman PO',0),(163601,4545,'no','Lagermottak uten PO',0),(163602,4545,'da','Lagertilgange uden PO',0),(163603,4545,'ko','í¬ ì—†ì´ ìž¬ê³  ì˜ìˆ˜ì¦',0),(163604,4545,'he','×ž×œ××™ ×§×‘×œ×•×ª ×ž×‘×œ×™ ×¤×•',0),(163605,4545,'el','Î Î±ÏÎ±Î»Î±Î²Î­Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Ï‡Ï‰ÏÎ¯Ï‚ PO',0),(163606,4545,'zh','æ²¡æœ‰è®¢å•å­˜è´§å‡­è¯\r\n',0),(163607,4545,'sv','Lagerinleveranser utan PO',0),(163608,4545,'it','Inventario ricevute senza PO',0),(163609,4545,'tl','',0),(163610,4545,'th','&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3',0),(163611,4545,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤°à¤¸à¥€à¤¦à¥‡à¤‚ PO à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾',0),(163612,4545,'ms','Inventori resit tanpa PO',0),(163613,4545,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¯ÙˆÙ† Ø¨Ùˆ',0),(163614,4545,'fr','RÃ©ceptions de stock sans PO',0),(163615,4545,'jp','ç™ºæ³¨æ›¸ã?ªã?—ã?®åœ¨åº«é ˜å?Žæ›¸',0),(163616,4545,'pt','Recibos de inventÃ¡rio sem PO',0),(163617,4545,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð±ÐµÐ· PO',0),(163618,4545,'es','Recibos de Inventario Sin OC',0),(163619,4545,'de','Inventar Quittungen ohne PO',0),(163620,4545,'en','Inventory Receipts Without PO',0),(163621,4546,'is','',0),(163622,4546,'dr','ØªØ§Ø±ÙŠØ® Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(163623,4546,'pr','ØªØ§Ø±ÙŠØ® Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(163624,4546,'tr','AlÄ±nma Tarihi',0),(163625,4546,'pl','Daty otrzymania',0),(163626,4546,'bg','Ð”Ð°Ñ‚Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ',0),(163627,4546,'ur','Ù…ÙˆØµÙˆÙ„Û Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(163628,4546,'sr','Ð”Ð°Ñ‚ÑƒÐ¼Ñƒ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð°',0),(163629,4546,'vi','NgÃ y Nháº­n',0),(163630,4546,'af','Ontvangsdatum',0),(163631,4546,'ro','Data primite',0),(163632,4546,'et','VastuvÃµtukuupÃ¤eva',0),(163633,4546,'si','Datumu prejetja',0),(163634,4546,'ba','Diterima tanggal',0),(163635,4546,'nl','Ontvangstdatum',0),(163636,4546,'fi','VastaanottamispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n',0),(163637,4546,'no','Mottaksdato',0),(163638,4546,'da','Modtagelsesdato',0),(163639,4546,'ko','ë°›ì€ ë‚ ì§œ',0),(163640,4546,'he','×ª××¨×™×š ×”×§×‘×œ×”',0),(163641,4546,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î±ÏÎ±Î»Î±Î²Î®Ï‚',0),(163642,4546,'zh','æ”¶æ¬¾æ—¥æœŸ\r\n',0),(163643,4546,'sv','Mottagningsdatum',0),(163644,4546,'it','Data di ricezione',0),(163645,4546,'tl','',0),(163646,4546,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(163647,4546,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(163648,4546,'ms','Tarikh diterima',0),(163649,4546,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªÙ„Ø§Ù…',0),(163650,4546,'fr','Date de rÃ©ception',0),(163651,4546,'jp','å?—é ˜æ—¥',0),(163652,4546,'pt','Data de recebimento',0),(163653,4546,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ',0),(163654,4546,'es','Fecha Recibido',0),(163655,4546,'de','Empfangsdatum',0),(163656,4546,'en','Received Date',0),(163657,4547,'is','',0),(163658,4547,'dr','ÙƒÙ„ Ø±Ø³ÙŠØ¯ Ù‡Ø§',0),(163659,4547,'pr','ÙƒÙ„ Ø±Ø³ÙŠØ¯ Ù‡Ø§',0),(163660,4547,'tr','Toplam GiriÅŸler',0),(163661,4547,'pl','CaÅ‚kowite wpÅ‚ywy',0),(163662,4547,'bg','ÐžÐ±Ñ‰Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸',0),(163663,4547,'ur','Ú©Ù„ Ú©ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº',0),(163664,4547,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ',0),(163665,4547,'vi','Tá»•ng cá»™ng biÃªn nháº­n',0),(163666,4547,'af','Totale Ontvangste',0),(163667,4547,'ro','Veniturile totale',0),(163668,4547,'et','Kogutulud',0),(163669,4547,'si','Skupni prejemki',0),(163670,4547,'ba','Total penerimaan',0),(163671,4547,'nl','Totale ontvangsten',0),(163672,4547,'fi','Kokonaistulot',0),(163673,4547,'no','Massemedias',0),(163674,4547,'da','Samlede indtÃ¦gter',0),(163675,4547,'ko','ì´ ìˆ˜ë ¹ì•¡',0),(163676,4547,'he','×¡×” ×› ×§×‘×œ×•×ª',0),(163677,4547,'el','ÎŸÎ¹ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ­Ï‚ ÎµÎ¹ÏƒÏ€ÏÎ¬Î¾ÎµÎ¹Ï‚',0),(163678,4547,'zh','æ€»ç¥¨æ®\r\n',0),(163679,4547,'sv','Totala intÃ¤kter',0),(163680,4547,'it','Totale entrate',0),(163681,4547,'tl','',0),(163682,4547,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(163683,4547,'hi','à¤•à¥à¤² à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚',0),(163684,4547,'ms','Jumlah terimaan',0),(163685,4547,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª',0),(163686,4547,'fr','Recettes totales',0),(163687,4547,'jp','é ˜å?Žæ›¸å?ˆè¨ˆ',0),(163688,4547,'pt','Receitas totais',0),(163689,4547,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ð¾ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ð¹',0),(163690,4547,'es','Recibos Totales',0),(163691,4547,'de','Gesamteinnahmen',0),(163692,4547,'en','Total Receipts',0),(163693,4548,'is','',0),(163694,4548,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø±ÙŠØ§ÙØª  Ù†Ù‡ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(163695,4548,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø±ÙŠØ§ÙØª  Ù†Ù‡ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(163696,4548,'tr','PO bir liste gÃ¶rÃ¼nÃ¼mÃ¼ alma',0),(163697,4548,'pl','Widok otrzymywaÄ‡ nie listy PO',0),(163698,4548,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½ÑÐ¼Ð° PO ÑÐ¿Ð¸ÑÑŠÐº',0),(163699,4548,'ur','Ù…Ù†Ø¸Ø± ÙˆØµÙˆÙ„ Ù†Û Ù¾Ùˆ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(163700,4548,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð´Ð¾Ð±Ð¸Ñ‚Ð¸ Ð½ÐµÐ¼Ð° ÐŸÐž Ð»Ð¸ÑÑ‚Ð¸',0),(163701,4548,'vi','Xem nháº­n chÆ°a cÃ³ danh sÃ¡ch Ä‘Æ¡n mua hÃ ng ',0),(163702,4548,'af','Bekyk ontvang geen PO-lys',0),(163703,4548,'ro','Vezi primi nici o listÄƒ de PO',0),(163704,4548,'et','Vaade saada nr PO nimekirja',0),(163705,4548,'si','Ogled prejeti seznam ni PO',0),(163706,4548,'ba','Lihat menerima tidak ada daftar PO',0),(163707,4548,'nl','Weergave ontvangen geen PO-lijst',0),(163708,4548,'fi','NÃ¤yttÃ¤Ã¤ vastaanottaa luetteloa ei PO',0),(163709,4548,'no','Vis fÃ¥r ingen PO-liste',0),(163710,4548,'da','Se modtager ingen PO liste',0),(163711,4548,'ko','ë³´ê¸° ë°›ì„ í¬ ëª©ë¡',0),(163712,4548,'he','×ª×¦×•×’×ª ×œ×§×‘×œ ×©×•× ×¨×©×™×ž×” ×¤×•',0),(163713,4548,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»Î¬Î²ÎµÏ„Îµ ÎºÎ±Î¼Î¯Î± Î»Î¯ÏƒÏ„Î± PO',0),(163714,4548,'zh','æŸ¥çœ‹æ”¶åˆ°ä»»ä½•è®¢å•åˆ—è¡¨\r\n',0),(163715,4548,'sv','Visa fÃ¥r ingen PO-lista',0),(163716,4548,'it','Vista non ricevere nessun elenco di PO',0),(163717,4548,'tl','',0),(163718,4548,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(163719,4548,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¹à¥€à¤‚ PO à¤¸à¥‚à¤šà¥€',0),(163720,4548,'ms','Lihat menerima senarai PO tidak',0),(163721,4548,'ar','Ø¹Ø±Ø¶ ØªØªÙ„Ù‚Ù‰ Ù‚Ø§Ø¦Ù…Ø© Ù„Ø§ Ø¨Ùˆ',0),(163722,4548,'fr','Vue ne recevoir aucune liste de PO',0),(163723,4548,'jp','ç™ºæ³¨æ›¸æœªå?—é ˜ãƒªã‚¹ãƒˆã?®è¡¨ç¤º',0),(163724,4548,'pt','Vista nÃ£o receber nenhuma lista de PO',0),(163725,4548,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¿Ð¾Ð»ÑƒÑ‡Ð°ÑŽÑ‚ ÑÐ¿Ð¸ÑÐ¾Ðº Ð½Ðµ PO',0),(163726,4548,'es','Visionar Lista de Recibir No OC',0),(163727,4548,'de','Ansicht erhalten keine PO-Liste',0),(163728,4548,'en','View Receive No PO List',0),(163729,4549,'is','',0),(163730,4549,'dr','Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(163731,4549,'pr','Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(163732,4549,'tr','Stok giriÅŸleri ile PO',0),(163733,4549,'pl','Spis wpÅ‚ywy z PO',0),(163734,4549,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð·Ð° ÑÐºÐ»Ð°Ð´ Ñ PO',0),(163735,4549,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©Û’ Ø³Ø§ØªÚ¾',0),(163736,4549,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ ÑƒÐ· ÐŸÐž',0),(163737,4549,'vi','BiÃªn Nháº­n HÃ ng CÃ³ ÄÆ¡n Mua HÃ ng',0),(163738,4549,'af','Voorraad ontvangste met PO',0),(163739,4549,'ro','ÃŽncasÄƒrile inventarierea cu PO',0),(163740,4549,'et','Lao sissetulekute PO',0),(163741,4549,'si','Zaloge prevzemnic s PO',0),(163742,4549,'ba','Persediaan kuitansi dengan PO',0),(163743,4549,'nl','Inventaris ontvangsten met PO',0),(163744,4549,'fi','Varastovastaanottojen PO',0),(163745,4549,'no','Lagermottak med PO',0),(163746,4549,'da','Lagertilgange med PO',0),(163747,4549,'ko','í¬ì™€ ìž¬ê³  ì˜ìˆ˜ì¦',0),(163748,4549,'he','×ž×œ××™ ×§×‘×œ×•×ª ×¢× ×¤×•',0),(163749,4549,'el','Î Î±ÏÎ±Î»Î±Î²Î­Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î¼Îµ PO',0),(163750,4549,'zh','æœ‰è®¢å•å­˜è´§å‡­è¯\r\n',0),(163751,4549,'sv','Lagerinleveranser med PO',0),(163752,4549,'it','Inventario ricevute con PO',0),(163753,4549,'tl','',0),(163754,4549,'th','&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3651;&#3610;&#3626;&#3633;&#3',0),(163755,4549,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤°à¤¸à¥€à¤¦à¥‡à¤‚ à¤ªà¥‹ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(163756,4549,'ms','Inventori resit dengan PO',0),(163757,4549,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù…Ø¹ Ø¨Ùˆ',0),(163758,4549,'fr','RÃ©ceptions de stock avec PO',0),(163759,4549,'jp','ç™ºæ³¨æ›¸ã?‚ã‚Šã?®å“?ç›®é ˜å?Žæ›¸',0),(163760,4549,'pt','Recibos de inventÃ¡rio com PO',0),(163761,4549,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ñ PO',0),(163762,4549,'es','Recibos de Inventario Con OC',0),(163763,4549,'de','Inventar-Einnahmen mit PO',0),(163764,4549,'en','Inventory Receipts With PO',0),(163765,4550,'is','',0),(163766,4550,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(163767,4550,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(163768,4550,'tr','Yeni yapÄ± sipariÅŸler',0),(163769,4550,'pl','Nowe wykonania zamÃ³wienia',0),(163770,4550,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(163771,4550,'ur','Ù†Ø¦ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(163772,4550,'sr','ÐÐ¾Ð²Ð° Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(163773,4550,'vi','ÄÆ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng má»›i',0),(163774,4550,'af','Nuwe Geboude Bestellings',0),(163775,4550,'ro','Comenzile noi de a construi',0),(163776,4550,'et','Uued tootmistellimused',0),(163777,4550,'si','Nova naroÄila graditi',0),(163778,4550,'ba','Perintah membangun baru',0),(163779,4550,'nl','Nieuwe Build Orders',0),(163780,4550,'fi','Rakentaa tilausten',0),(163781,4550,'no','Nye bygge bestillinger',0),(163782,4550,'da','Nye Build ordrer',0),(163783,4550,'ko','ìƒˆë¡œìš´ ë¹Œë“œ ìˆœì„œ',0),(163784,4550,'he','×”×–×ž× ×•×ª ×‘× ×™×™×” ×—×“×©×•×ª',0),(163785,4550,'el','ÎÎ­Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(163786,4550,'zh','æ–°ç”Ÿæˆè®¢å•\r\n',0),(163787,4550,'sv','Nya bygga order',0),(163788,4550,'it','Nuova compilazione ordini',0),(163789,4550,'tl','',0),(163790,4550,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(163791,4550,'hi','à¤¨à¤ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤†à¤¦à¥‡à¤¶',0),(163792,4550,'ms','Perintah membina baru',0),(163793,4550,'ar','Ø£ÙˆØ§Ù…Ø± Ø¨Ù†Ø§Ø¡ Ø¬Ø¯ÙŠØ¯Ø©',0),(163794,4550,'fr','Nouvelles commandes de gÃ©nÃ©ration',0),(163795,4550,'jp','æ–°è¦?çµ„ç«‹æ³¨æ–‡',0),(163796,4550,'pt','Novas ordens de construÃ§Ã£o',0),(163797,4550,'ru','ÐÐ¾Ð²Ñ‹Ðµ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(163798,4550,'es','Nuevos Ordenes de ConstrucciÃ³n',0),(163799,4550,'de','Neue Build-AuftrÃ¤ge',0),(163800,4550,'en','New Build Orders',0),(163801,4551,'is','',0),(163802,4551,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯  ',0),(163803,4551,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯  ',0),(163804,4551,'tr','Yeni Ã¶ÄŸeler',0),(163805,4551,'pl','Nowe elementy',0),(163806,4551,'bg','ÐÐ¾Ð²Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(163807,4551,'ur','Ù†Ø¦ÛŒ Ø§Ø´ÛŒØ§',0),(163808,4551,'sr','ÐÐ¾Ð²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(163809,4551,'vi','HÃ ng má»›i',0),(163810,4551,'af','Nuwe Items',0),(163811,4551,'ro','Elemente noi',0),(163812,4551,'et','Uued tooted',0),(163813,4551,'si','Nove elemente',0),(163814,4551,'ba','Item baru',0),(163815,4551,'nl','Nieuwe Items',0),(163816,4551,'fi','Uudet kohteet',0),(163817,4551,'no','Nye elementer',0),(163818,4551,'da','Nye varer',0),(163819,4551,'ko','ìƒˆ í•­ëª©',0),(163820,4551,'he','×¤×¨×™×˜×™× ×—×“×©×™×',0),(163821,4551,'el','ÎÎ­Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(163822,4551,'zh','æ–°é¡¹ç›®\r\n',0),(163823,4551,'sv','Nya objekt',0),(163824,4551,'it','Nuovi elementi',0),(163825,4551,'tl','',0),(163826,4551,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3627;&#3617;&#3656;',0),(163827,4551,'hi','à¤¨à¤ à¤†à¤‡à¤Ÿà¤®',0),(163828,4551,'ms','Item baru',0),(163829,4551,'ar','Ø£ØµÙ†Ø§Ù Ø¬Ø¯ÙŠØ¯Ø©',0),(163830,4551,'fr','NouveautÃ©s',0),(163831,4551,'jp','æ–°è¦?å“?ç›®',0),(163832,4551,'pt','Novos itens',0),(163833,4551,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ñ‹',0),(163834,4551,'es','Nuevos Items',0),(163835,4551,'de','Neue Elemente',0),(163836,4551,'en','New Items',0),(163837,4552,'is','',0),(163838,4552,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(163839,4552,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(163840,4552,'tr','Yeni satÄ±nalma sipariÅŸleri',0),(163841,4552,'pl','Nowych zamÃ³wieÅ„ zakupu',0),(163842,4552,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(163843,4552,'ur','Ù†Ø¦ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(163844,4552,'sr','ÐÐ¾Ð²Ðµ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(163845,4552,'vi','ÄÆ¡n mua hÃ ng má»›i',0),(163846,4552,'af','Nuwe Aankoopbestellings',0),(163847,4552,'ro','Noi comenzi de cumpÄƒrare',0),(163848,4552,'et','Uued ostutellimused',0),(163849,4552,'si','Novih nabavnih nalogov',0),(163850,4552,'ba','Pesanan pembelian baru',0),(163851,4552,'nl','Nieuwe inkooporders',0),(163852,4552,'fi','Uusille ostotilauksille',0),(163853,4552,'no','Nye bestillinger',0),(163854,4552,'da','Nye indkÃ¸bsordrer',0),(163855,4552,'ko','ìƒˆë¡œìš´ êµ¬ë§¤ ì£¼ë¬¸',0),(163856,4552,'he','×”×–×ž× ×•×ª ×¨×›×™×©×” ×—×“×©×•×ª',0),(163857,4552,'el','ÎÎ­ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Î³Î¿ÏÎ¬Ï‚',0),(163858,4552,'zh','æ–°çš„é‡‡è´­è®¢å•\r\n',0),(163859,4552,'sv','Nya inkÃ¶psorder',0),(163860,4552,'it','Nuovi ordini di acquisto',0),(163861,4552,'tl','',0),(163862,4552,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(163863,4552,'hi','à¤¨à¤ˆ à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(163864,4552,'ms','Pesanan pembelian baru',0),(163865,4552,'ar','Ø·Ù„Ø¨Ø§Øª Ø´Ø±Ø§Ø¡ Ø¬Ø¯ÙŠØ¯Ø©',0),(163866,4552,'fr','Commandes achats nouveau',0),(163867,4552,'jp','æ–°è¦?è³¼è²·æ³¨æ–‡',0),(163868,4552,'pt','Novas ordens de compra',0),(163869,4552,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(163870,4552,'es','Nuevos Ordenes de Compra',0),(163871,4552,'de','Neue Bestellungen',0),(163872,4552,'en','New Purchase Orders',0),(163873,4553,'is','',0),(163874,4553,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ ',0),(163875,4553,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ ',0),(163876,4553,'tr','AlÄ±nan satÄ±nalma sipariÅŸleri',0),(163877,4553,'pl','Otrzymane zamÃ³wienia zakupu',0),(163878,4553,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(163879,4553,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…ÙˆØµÙˆÙ„',0),(163880,4553,'sr','Ð˜Ð·Ð»Ð°Ð·Ð½Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ',0),(163881,4553,'vi','ÄÃ£ nháº­n ÄÆ¡n Mua HÃ ng',0),(163882,4553,'af','Aankoopbestellings Ontvang',0),(163883,4553,'ro','Comenzi de cumpÄƒrare primit',0),(163884,4553,'et','Ostutellimuste, saabunud',0),(163885,4553,'si','Nabavnih nalogov, prejetih',0),(163886,4553,'ba','Menerima pesanan pembelian',0),(163887,4553,'nl','Purchase Orders ontvangen',0),(163888,4553,'fi','Ostaa tilaukset',0),(163889,4553,'no','Bestillinger som er mottatt',0),(163890,4553,'da','Ordrer modtaget',0),(163891,4553,'ko','êµ¬ë§¤ ì£¼ë¬¸ì„œë¥¼ ë°›ì€',0),(163892,4553,'he','×”×–×ž× ×•×ª ×¨×›×© ×©×”×ª×§×‘×œ×•',0),(163893,4553,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Î³Î¿ÏÏŽÎ½ Ï€Î¿Ï… Ï€Î±ÏÎ±Î»Î®Ï†Î¸Î·ÎºÎ±Î½',0),(163894,4553,'zh','é‡‡è´­è®¢å•æ”¶åˆ°\r\n',0),(163895,4553,'sv','KÃ¶p orderingÃ¥ngen',0),(163896,4553,'it','Ordini di acquisto ricevuti',0),(163897,4553,'tl','',0),(163898,4553,'th','&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(163899,4553,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(163900,4553,'ms','Pesanan pembelian yang diterima',0),(163901,4553,'ar','Ø·Ù„Ø¨Ø§Øª Ø´Ø±Ø§Ø¡ Ù…Ø³ØªÙ„Ù…Ø©',0),(163902,4553,'fr','Bons de commande reÃ§us',0),(163903,4553,'jp','å?—å?–ã?£ã?Ÿç™ºæ³¨æ›¸',0),(163904,4553,'pt','Ordens de compra recebidas',0),(163905,4553,'ru','Ð—Ð°ÐºÐ°Ð·Ð¾Ð², Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ…',0),(163906,4553,'es','Orden de Compras Recibidos',0),(163907,4553,'de','Bestellungen empfangen',0),(163908,4553,'en','Purchase Orders Received',0),(163909,4554,'is','',0),(163910,4554,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ù…ØµØ±Ù ÙƒØ§Ù„Ø§ ',0),(163911,4554,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ù…ØµØ±Ù ÙƒØ§Ù„Ø§ ',0),(163912,4554,'tr','Madde kullanÄ±m raporunu gÃ¶rÃ¼ntÃ¼leyin',0),(163913,4554,'pl','Zobacz element raport uÅ¼ycia',0),(163914,4554,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(163915,4554,'ur','Ù…Ù†Ø¸Ø± Ø´Û’ Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(163916,4554,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÑ‚Ð°Ð²ÐºÑƒ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÑƒ',0),(163917,4554,'vi','Xem bÃ¡o cÃ¡o sá»­ dá»¥ng hÃ ng hÃ³a',0),(163918,4554,'af','Besigtig Item Gebruiksverslag',0),(163919,4554,'ro','Vezi articol raport de utilizare a',0),(163920,4554,'et','Saate vaadata kauba kasutusaruanne',0),(163921,4554,'si','Pregledovati navada referat',0),(163922,4554,'ba','Lihat Item laporan penggunaan',0),(163923,4554,'nl','Het rapport Resourcegebruik object bekijken',0),(163924,4554,'fi','NÃ¤ytÃ¤ nimikkeen kÃ¤yttÃ¶raportti',0),(163925,4554,'no','Vis rapport',0),(163926,4554,'da','Se punkt anvendelsesrapport',0),(163927,4554,'ko','í•­ëª© ì‚¬ìš© í˜„í™© ë³´ê³ ì„œ ë³´ê¸°',0),(163928,4554,'he','×”×¦×’ ×¤×¨×™×˜ ×©×™×ž×•×© ×”×“×•×—',0),(163929,4554,'el','Î ÏÎ¿Î²Î¿Î»Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Ï‡ÏÎ®ÏƒÎ· Î­ÎºÎ¸ÎµÏƒÎ·Ï‚',0),(163930,4554,'zh','æŸ¥çœ‹ç‰©å“ä½¿ç”¨æƒ…å†µæŠ¥å‘Š\r\n',0),(163931,4554,'sv','Visa anvÃ¤ndningsrapporter',0),(163932,4554,'it','Elemento Mostra Report di utilizzo',0),(163933,4554,'tl','',0),(163934,4554,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(163935,4554,'hi','à¤†à¤‡à¤Ÿà¤® à¤‰à¤ªà¤¯à¥‹à¤— à¤°à¤¿à¤°à¥à¤ªà¥‹à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(163936,4554,'ms','Lihat perkara laporan penggunaan',0),(163937,4554,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ± Ø¥Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ù„ØµÙ†Ù',0),(163938,4554,'fr','DÃ©couvre point de rapport d\'utilisation',0),(163939,4554,'jp','å“?ç›®ä½¿ç”¨ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(163940,4554,'pt','Ver os Item de relatÃ³rio de uso',0),(163941,4554,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð¾Ð± Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ð¸',0),(163942,4554,'es','Visionar Informde de Uso de Items',0),(163943,4554,'de','Zeigen Artikel Nutzungsbericht an',0),(163944,4554,'en','View Item Usage Report',0),(163945,4555,'is','',0),(163946,4555,'dr','Ø´Ø±Ø­ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(163947,4555,'pr','Ø´Ø±Ø­ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(163948,4555,'tr','PO aÃ§Ä±klamasÄ±',0),(163949,4555,'pl','PO opis',0),(163950,4555,'bg','PO Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(163951,4555,'ur','Ù¾Ùˆ ØªØµØ±ÛŒØ­',0),(163952,4555,'sr','ÐŸÐž Ð¾Ð¿Ð¸ÑÑƒ',0),(163953,4555,'vi','MÃ´ táº£ Ä‘Æ¡n mua hÃ ng',0),(163954,4555,'af','AB Beskrywing',0),(163955,4555,'ro','Descriere PO',0),(163956,4555,'et','PO kirjeldus',0),(163957,4555,'si','Opis PO',0),(163958,4555,'ba','Deskripsi PO',0),(163959,4555,'nl','PO beschrijving',0),(163960,4555,'fi','PO kuvaus',0),(163961,4555,'no','PO beskrivelse',0),(163962,4555,'da','PO beskrivelse',0),(163963,4555,'ko','ì‚¬ì„œí•¨ ì„¤ëª…',0),(163964,4555,'he','×ª×™××•×¨ ×¤×•',0),(163965,4555,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® PO',0),(163966,4555,'zh','è®¢å•è¯´æ˜Ž\r\n',0),(163967,4555,'sv','PO Beskrivning',0),(163968,4555,'it','PO Descrizione',0),(163969,4555,'tl','',0),(163970,4555,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(163971,4555,'hi','PO à¤µà¤¿à¤µà¤°à¤£',0),(163972,4555,'ms','Keterangan PO',0),(163973,4555,'ar','ÙˆØµÙ Ø¨Ùˆ',0),(163974,4555,'fr','Description PO',0),(163975,4555,'jp','ç™ºæ³¨æ›¸è§£èª¬',0),(163976,4555,'pt','DescriÃ§Ã£o de PO',0),(163977,4555,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ PO',0),(163978,4555,'es','OC DescripciÃ³n',0),(163979,4555,'de','PO-Beschreibung',0),(163980,4555,'en','PO Description',0),(163981,4556,'is','',0),(163982,4556,'dr','Ø³Ù†Ø¯ Ø¯ÙŠÚ¯Ø± ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(163983,4556,'pr','Ø³Ù†Ø¯ Ø¯ÙŠÚ¯Ø± ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(163984,4556,'tr','KanÄ±t yok artÄ±k',0),(163985,4556,'pl','DowÃ³d juÅ¼ nie istnieje',0),(163986,4556,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð²ÐµÑ‡Ðµ Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(163987,4556,'ur','Ø§Ø¨ Ú©ÙˆØ¦ÛŒ Ø«Ø¨ÙˆØª Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(163988,4556,'sr','Ð”Ð¾ÐºÐ°Ð· Ð²Ð¸ÑˆÐµ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(163989,4556,'vi','Báº£n in thá»­ khÃ´ng tá»“n táº¡i',0),(163990,4556,'af','Bewys bestaan nie meer nie',0),(163991,4556,'ro','Dovada nu mai existÄƒ',0),(163992,4556,'et','TÃµend pole enam',0),(163993,4556,'si','Dokaz ne obstaja veÄ',0),(163994,4556,'ba','Bukti tidak ada lagi',0),(163995,4556,'nl','Bewijs bestaat niet meer',0),(163996,4556,'fi','Todiste ei ole enÃ¤Ã¤',0),(163997,4556,'no','Bevis finnes ikke lenger',0),(163998,4556,'da','Bevis findes ikke lÃ¦ngere',0),(163999,4556,'ko','ì¦ê±° ë” ì´ìƒ ì¡´ìž¬ í•˜ì§€',0),(164000,4556,'he','×”×•×›×—×” ×›×‘×¨ ×œ× ×§×™×™×ž×ª',0),(164001,4556,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Ï€Î»Î­Î¿Î½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î±Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚',0),(164002,4556,'zh','è¯æ˜Žä¸å†å­˜åœ¨\r\n',0),(164003,4556,'sv','Bevis finns inte lÃ¤ngre',0),(164004,4556,'it','Prova non esiste piÃ¹',0),(164005,4556,'tl','',0),(164006,4556,'th','&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;&#3652;&#3617;&#3656;&#3617;&#3637;&#3649;&#3621;&#3657;&#3623;',0),(164007,4556,'hi','à¤…à¤¬ à¤•à¥‹à¤ˆ à¤¸à¤¬à¥‚à¤¤ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(164008,4556,'ms','Bukti tidak wujud lagi',0),(164009,4556,'ar','Ù„Ù… ÙŠØ¹Ø¯ Ù…ÙˆØ¬ÙˆØ¯Ø§Ù‹ Ø§Ù„Ø¥Ø«Ø¨Ø§Øª',0),(164010,4556,'fr','La preuve n\'existe plus',0),(164011,4556,'jp','æ ¡æ­£ã?¯ã‚‚ã?†å­˜åœ¨ã?—ã?¾ã?›ã‚“',0),(164012,4556,'pt','Prova nÃ£o existe mais',0),(164013,4556,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾, Ð±Ð¾Ð»ÑŒÑˆÐµ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(164014,4556,'es','Prueba de ImpresiÃ³n ya no existe',0),(164015,4556,'de','Nachweis ist nicht mehr vorhanden.',0),(164016,4556,'en','Proof no longer exists',0),(164017,4557,'is','',0),(164018,4557,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³Ù†Ø¯ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(164019,4557,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³Ù†Ø¯ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(164020,4557,'tr','KanÄ±t iÃ§in sipariÅŸ iÅŸleme',0),(164021,4557,'pl','DowÃ³d przetworzenia na zamÃ³wienie',0),(164022,4557,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð·Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(164023,4557,'ur','Ø«Ø¨ÙˆØª Ú©Û’ Ù„ÛŒÛ’ ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ',0),(164024,4557,'sr','Ð”Ð¾ÐºÐ°Ð· Ð¾Ð±Ñ€Ð°Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(164025,4557,'vi','LÃ m báº£n in thá»­ cho Ä‘Æ¡n hÃ ng',0),(164026,4557,'af','Bewys van Bestellingprosessering',0),(164027,4557,'ro','Dovada de prelucrare pentru comanda',0),(164028,4557,'et','Tellimuse tÃ¶Ã¶tlemise tÃµend',0),(164029,4557,'si','Dokaz za nalog za predelavo',0),(164030,4557,'ba','Bukti pengolahan untuk Order',0),(164031,4557,'nl','Het bewijs van verwerking voor Order',0),(164032,4557,'fi','Todiste tilauksen kÃ¤sittely',0),(164033,4557,'no','Bevis behandling for ordre',0),(164034,4557,'da','Bevis for behandling af ordre',0),(164035,4557,'ko','ì²˜ë¦¬ ìˆœì„œì— ëŒ€ í•œ ì¦ê±°',0),(164036,4557,'he','×”×•×›×—×” ×¢×™×‘×•×“ ×¢×‘×•×¨ ×”×–×ž× ×”',0),(164037,4557,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(164038,4557,'zh','è®¢å•è¯æ˜Žå¤„ç†\r\n',0),(164039,4557,'sv','Bevis fÃ¶r bestÃ¤llning',0),(164040,4557,'it','Prova per ordine di elaborazione',0),(164041,4557,'tl','',0),(164042,4557,'th','&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(164043,4557,'hi','à¤¸à¤¬à¥‚à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(164044,4557,'ms','Bukti yang memproses perintah',0),(164045,4557,'ar','Ø¯Ù„ÙŠÙ„ Ù…Ø¹Ø§Ù„Ø¬Ø© Ù„Ù„Ù†Ø¸Ø§Ù…',0),(164046,4557,'fr','Preuve de traitement de commande',0),(164047,4557,'jp','æ³¨æ–‡å‡¦ç?†ä¸­æ ¡æ­£',0),(164048,4557,'pt','Prova para a ordem de processamento',0),(164049,4557,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾, Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð·Ð°ÐºÐ°Ð·Ð°',0),(164050,4557,'es','Prueba de ImpresiÃ³n Procesando para el Orden',0),(164051,4557,'de','Nachweis Verarbeitung fÃ¼r Bestellung',0),(164052,4557,'en','Proof Processing for Order',0),(164053,4558,'is','',0),(164054,4558,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(164055,4558,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(164056,4558,'tr','KanÄ±t baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(164057,4558,'pl','DowÃ³d pomyÅ›lnie zaktualizowana',0),(164058,4558,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(164059,4558,'ur','Ø«Ø¨ÙˆØª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(164060,4558,'sr','Ð”Ð¾ÐºÐ°Ð· Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(164061,4558,'vi','Báº±ng Chá»©ng Cáº­p Nháº­t ThÃ nh CÃ´ng',0),(164062,4558,'af','Bewys Suksesvol Opdateer',0),(164063,4558,'ro','Dovada actualizat cu succes',0),(164064,4558,'et','VÃ¤rskendatud tÃµend',0),(164065,4558,'si','Dokaz uspeÅ¡no posodobljena',0),(164066,4558,'ba','Bukti yang berhasil',0),(164067,4558,'nl','Bewijs bijgewerkt',0),(164068,4558,'fi','Todiste pÃ¤ivitetty',0),(164069,4558,'no','Bevis oppdatert',0),(164070,4558,'da','Bevis opdateret',0),(164071,4558,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì¦ê±°',0),(164072,4558,'he','×”×•×›×—×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(164073,4558,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(164074,4558,'zh','è¯æ˜Žæ›´æ–°æˆåŠŸ\r\n',0),(164075,4558,'sv','Bevis uppdaterats',0),(164076,4558,'it','Prova aggiornato con successo',0),(164077,4558,'tl','',0),(164078,4558,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(164079,4558,'hi','à¤¸à¤¬à¥‚à¤¤ à¤•à¥‡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(164080,4558,'ms','Bukti berjaya dikemas kini',0),(164081,4558,'ar','Ø¯Ù„ÙŠÙ„ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(164082,4558,'fr','Mis Ã  jour avec succÃ¨s la preuve',0),(164083,4558,'jp','æ ¡æ­£ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(164084,4558,'pt','Prova atualizada com sucesso',0),(164085,4558,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(164086,4558,'es','Prueba de ImpresiÃ³n Actualizada Exitosamente',0),(164087,4558,'de','Nachweis erfolgreich aktualisiert',0),(164088,4558,'en','Proof Updated Successfully',0),(164089,4559,'is','',0),(164090,4559,'dr','Ù…Ø¯Ø±Ùƒ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(164091,4559,'pr','Ù…Ø¯Ø±Ùƒ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(164092,4559,'tr','KanÄ±t dÃ¶ndÃ¼rdÃ¼',0),(164093,4559,'pl','Zwracane dowÃ³d',0),(164094,4559,'bg','Ð’Ñ€ÑŠÑ‰Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(164095,4559,'ur','Ø«Ø¨ÙˆØª Ù„ÙˆÙ¹ Ø¢Ø¦Û’',0),(164096,4559,'sr','Ð”Ð¾ÐºÐ°Ð· Ñ˜Ðµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾.',0),(164097,4559,'vi','Báº£n in thá»­ Trá»Ÿ láº¡i',0),(164098,4559,'af','Bewys teruggestuur',0),(164099,4559,'ro','Dovada a revenit',0),(164100,4559,'et','Tagastatud tÃµend',0),(164101,4559,'si','Vrnil dokaz',0),(164102,4559,'ba','Kembali bukti',0),(164103,4559,'nl','Geretourneerd bewijs',0),(164104,4559,'fi','Palasi todiste',0),(164105,4559,'no','Returnerte bevis',0),(164106,4559,'da','Returneret bevis',0),(164107,4559,'ko','ì¦ê±° ë°˜í™˜',0),(164108,4559,'he','×—×–×¨ ×”×•×›×—×”',0),(164109,4559,'el','Î•Ï€Î­ÏƒÏ„ÏÎµÏˆÎµ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î·',0),(164110,4559,'zh','è¿”å›žçš„è¯æ˜Ž\r\n',0),(164111,4559,'sv','Ã…tervÃ¤nde bevis',0),(164112,4559,'it','Restituito prova',0),(164113,4559,'tl','',0),(164114,4559,'th','&#3588;&#3639;&#3609;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(164115,4559,'hi','à¤¸à¤¬à¥‚à¤¤ à¤²à¥Œà¤Ÿà¥‡',0),(164116,4559,'ms','Kembali bukti',0),(164117,4559,'ar','Ø¹Ø§Ø¯ Ø¨Ø±Ù‡Ø§Ù†',0),(164118,4559,'fr','RetournÃ© une preuve',0),(164119,4559,'jp','è¿”å?´æ¸ˆæ ¡æ­£',0),(164120,4559,'pt','Retornou Ã  prova',0),(164121,4559,'ru','Ð’ÐµÑ€Ð½ÑƒÐ»ÑÑ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾',0),(164122,4559,'es','Prueba de ImpresiÃ³n Devuelta',0),(164123,4559,'de','Beweis zurÃ¼ckgegeben',0),(164124,4559,'en','Returned Proof',0),(164125,4560,'is','',0),(164126,4560,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ø±Ø³ÙŠØ¯ Ù…Ø­Ù…ÙˆÙ„Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(164127,4560,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ø±Ø³ÙŠØ¯ Ù…Ø­Ù…ÙˆÙ„Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(164128,4560,'tr','GÃ¶rÃ¼nÃ¼m sevk irsaliyesi iÃ§in tÄ±klayÄ±n',0),(164129,4560,'pl','Kliknij, aby widok dostawy',0),(164130,4560,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¸Ð·Ð³Ð»ÐµÐ´Ð° Ð¾Ð¿Ð°ÐºÐ¾Ð²Ð°Ð½Ðµ Ð¿Ñ€Ð¸Ð¿Ð»ÑŠÐ·Ð²Ð°Ð½Ðµ',0),(164131,4560,'ur','Ù…Ù†Ø¸Ø± Ù¾ÛŒÚ©Ù†Ú¯ Ù¾Ø±Ú†ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(164132,4560,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð· ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(164133,4560,'vi','Nháº¥n Ä‘á»ƒ xem danh sÃ¡ch Ä‘Ã³ng gÃ³i',0),(164134,4560,'af','Kliek om Verpakkingstaat te Besigtig',0),(164135,4560,'ro','Click sÄƒ Vezi ambalare alunecare',0),(164136,4560,'et','KlÃµpsake vaate saateleht',0),(164137,4560,'si','Kliknite pogled pakiranje zdrs',0),(164138,4560,'ba','Klik untuk lihat Kemasan Slip',0),(164139,4560,'nl','Klik op weergave pakbon',0),(164140,4560,'fi','Valitse NÃ¤ytÃ¤ pakkausluettelo',0),(164141,4560,'no','Klikk for Ã¥ vise fÃ¸lgeseddel',0),(164142,4560,'da','Klik for at se fÃ¸lgeseddel',0),(164143,4560,'ko','ë³´ê¸° í¬ìž¥ ëª…ì„¸ì„œë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(164144,4560,'he','×œ×—×¥ ×¢×œ ×”×¦×’ ×ª×¢×•×“×ª ×”×ž×©×œ×•×—',0),(164145,4560,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Ï€ÏÎ¿Î²Î¿Î»Î® ÏƒÏ…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î±Ï‚ Î¿Î»Î¯ÏƒÎ¸Î·ÏƒÎ·Ï‚',0),(164146,4560,'zh','ç‚¹å‡»æŸ¥çœ‹è£…ç®±å•\r\n',0),(164147,4560,'sv','Klicka fÃ¶r att Visa fÃ¶ljesedel',0),(164148,4560,'it','Clicca per visualizzazione distinta di imballaggio',0),(164149,4560,'tl','',0),(164150,4560,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3610;&#3633;&#3605;&#3619;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3585;&#3635;&#3621;&#3633;&#3591;&#3592;&#3633;&#3604;&#3648;&#3585;&#3655;&#3610;',0),(164151,4560,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤ªà¥ˆà¤•à¤¿à¤‚à¤— à¤ªà¤°à¥à¤šà¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(164152,4560,'ms','Klik untuk Slip pembungkusan View',0),(164153,4560,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ø¹Ø±Ø¶ ÙƒØ´Ù Ø§Ù„ØªØ¹Ø¨Ø¦Ø©',0),(164154,4560,'fr','Cliquer pour une vue de la livraison',0),(164155,4560,'jp','æ¢±åŒ…ä¼?ç¥¨ã‚’è¦‹ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(164156,4560,'pt','Clique a guia de remessa de exibiÃ§Ã£o',0),(164157,4560,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐºÐ½Ð¾Ð¿ÐºÑƒ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¾Ñ‚Ð±Ð¾Ñ€Ð¾Ñ‡Ð½Ð¾Ð¹ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(164158,4560,'es','Click para Ver la Hoja de Embalaje',0),(164159,4560,'de','Klicken Sie auf Ansicht-Lieferschein',0),(164160,4560,'en','Click to View Packing Slip',0),(164161,4561,'is','',0),(164162,4561,'dr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø¢Ø¯Ø±Ø³ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ',0),(164163,4561,'pr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø¢Ø¯Ø±Ø³ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ',0),(164164,4561,'tr','Adresi kullanarak gÃ¶rÃ¼ntÃ¼leme',0),(164165,4561,'pl','WyÅ›wietlacz z adresu za pomocÄ…',0),(164166,4561,'bg','Ð”Ð¸ÑÐ¿Ð»ÐµÑ Ð¾Ñ‚ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð°Ð´Ñ€ÐµÑ',0),(164167,4561,'ur','Ø³Û’ Ù¾ØªÛ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(164168,4561,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð°Ð´Ñ€ÐµÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ðµ',0),(164169,4561,'vi','Hiá»ƒn thá»‹ tá»« Ä‘á»‹a chá»‰ dÃ¹ng',0),(164170,4561,'af','Vertoon van adres gebruik',0),(164171,4561,'ro','AfiÅŸare la adresa folosind',0),(164172,4561,'et','Kuva aadressi kasutamine',0),(164173,4561,'si','Izpis iz naslova uporabe',0),(164174,4561,'ba','Tampilan dari menggunakan alamat',0),(164175,4561,'nl','Display adres gebruiken',0),(164176,4561,'fi','NÃ¤ytÃ¤ osoite kÃ¤yttÃ¤mÃ¤llÃ¤',0),(164177,4561,'no','Skjermen fra adressen bruker',0),(164178,4561,'da','Display fra adresse ved hjÃ¦lp af',0),(164179,4561,'ko','ì£¼ì†Œë¥¼ ì‚¬ìš© í•˜ ì—¬ í‘œì‹œ',0),(164180,4561,'he','×”×ª×¦×•×’×” ×‘××ž×¦×¢×•×ª ×›×ª×•×‘×ª',0),(164181,4561,'el','ÎŸÎ¸ÏŒÎ½Î· Î±Ï€ÏŒ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚',0),(164182,4561,'zh','æ˜¾ç¤ºä»Žåœ°å€ä½¿ç”¨\r\n',0),(164183,4561,'sv','Display frÃ¥n adress anvÃ¤nder',0),(164184,4561,'it','Visualizzazione da indirizzo tramite',0),(164185,4561,'tl','',0),(164186,4561,'th','&#3649;&#3626;&#3604;&#3591;&#3592;&#3634;&#3585;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3607;&#3637;&#3656;&#3585;&#3635;&#3621;&#3633;&#3591;&#3651;&#3594;&#3657;',0),(164187,4561,'hi','à¤ªà¤¤à¥‡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨',0),(164188,4561,'ms','Paparan daripada menggunakan alamat',0),(164189,4561,'ar','Ø§Ù„Ø¹Ø±Ø¶ Ù…Ù† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¹Ù†ÙˆØ§Ù†',0),(164190,4561,'fr','Affichage de l\'adresse Ã  l\'aide',0),(164191,4561,'jp','ï½žã‚’ä½¿ã?£ã?¦ç™ºé€?å…ƒä½?æ‰€ã‚’è¡¨ç¤º',0),(164192,4561,'pt','ExibiÃ§Ã£o de endereÃ§o usando',0),(164193,4561,'ru','Ð”Ð¸ÑÐ¿Ð»ÐµÐ¹ Ð¾Ñ‚ Ð°Ð´Ñ€ÐµÑ Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸ÐµÐ¼',0),(164194,4561,'es','Desplegar DirecciÃ³n DE OrÃ­gen Usando',0),(164195,4561,'de','Anzeige von-Adresse verwendet',0),(164196,4561,'en','Display FROM Address Using',0),(164197,4562,'is','',0),(164198,4562,'dr','Ø±Ø§Ù†Ù†Ø¯Ù‡ ',0),(164199,4562,'pr','Ø±Ø§Ù†Ù†Ø¯Ù‡ ',0),(164200,4562,'tr','SÃ¼rÃ¼cÃ¼',0),(164201,4562,'pl','Sterownik',0),(164202,4562,'bg','Ð¨Ð¾Ñ„ÑŒÐ¾Ñ€',0),(164203,4562,'ur','ÚˆØ±Ø§Ø¦ÛŒÙˆØ±',0),(164204,4562,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°Ñ‡ÐºÐ¸ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼',0),(164205,4562,'vi','LÃ¡i xe',0),(164206,4562,'af','Bestuurder',0),(164207,4562,'ro','ConducÄƒtor auto',0),(164208,4562,'et','Juht',0),(164209,4562,'si','Voznik',0),(164210,4562,'ba','Sopir',0),(164211,4562,'nl','Stuurprogramma',0),(164212,4562,'fi','Ohjain',0),(164213,4562,'no','Driveren',0),(164214,4562,'da','Driver',0),(164215,4562,'ko','ë“œë¼ì´ë²„',0),(164216,4562,'he','×ž× ×”×œ ×”×ª×§×Ÿ',0),(164217,4562,'el','Î ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Î¿Î´Î®Î³Î·ÏƒÎ·Ï‚',0),(164218,4562,'zh','é©±åŠ¨ç¨‹åº\r\n',0),(164219,4562,'sv','FÃ¶raren',0),(164220,4562,'it','Autista',0),(164221,4562,'tl','',0),(164222,4562,'th','&#3588;&#3609;&#3586;&#3633;&#3610;&#3619;&#3606;',0),(164223,4562,'hi','à¤šà¤¾à¤²à¤•',0),(164224,4562,'ms','Pemandu',0),(164225,4562,'ar','Ø¨Ø±Ù†Ø§Ù…Ø¬ Ø§Ù„ØªØ´ØºÙŠÙ„',0),(164226,4562,'fr','Pilote',0),(164227,4562,'jp','ãƒ‰ãƒ©ã‚¤ãƒ?ãƒ¼',0),(164228,4562,'pt','Motorista',0),(164229,4562,'ru','Ð”Ñ€Ð°Ð¹Ð²ÐµÑ€',0),(164230,4562,'es','Controlador',0),(164231,4562,'de','Treiber',0),(164232,4562,'en','Driver',0),(164233,4563,'is','',0),(164234,4563,'dr','(Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù†) ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(164235,4563,'pr','Ø³ÙØ§Ø±Ø´ (Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù†) ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(164236,4563,'tr','SipariÅŸ tamamlandÄ±',0),(164237,4563,'pl','ZamÃ³wienie kompletne',0),(164238,4563,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿ÑŠÐ»Ð½Ð¾',0),(164239,4563,'ur','ØªØ±ØªÛŒØ¨ Ù…Ú©Ù…Ù„',0),(164240,4563,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾',0),(164241,4563,'vi','HoÃ n táº¥t Ä‘Æ¡n hÃ ng',0),(164242,4563,'af','Bestelling Voltooi',0),(164243,4563,'ro','Comanda completÄƒ',0),(164244,4563,'et','Tellimuse lÃµpule viidud',0),(164245,4563,'si','Vrstni red popolnega',0),(164246,4563,'ba','Urutan lengkap',0),(164247,4563,'nl','Bestelling compleet',0),(164248,4563,'fi','Jotta tÃ¤ydellinen',0),(164249,4563,'no','For komplett',0),(164250,4563,'da','Bestil komplet',0),(164251,4563,'ko','ì£¼ë¬¸ ì™„ë£Œ',0),(164252,4563,'he','×”×–×ž× ×” ×”×¡×ª×™×™×ž×”',0),(164253,4563,'el','ÎŸÎ›ÎŸÎšÎ›Î—Î¡Î©Î£Î— Ï€Î±Ï / Î›Î™Î‘Î£',0),(164254,4563,'zh','è®¢è´­å®Œæˆ\r\n',0),(164255,4563,'sv','BestÃ¤ll komplett',0),(164256,4563,'it','Ordine completo',0),(164257,4563,'tl','',0),(164258,4563,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(164259,4563,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥‚à¤°à¤¾',0),(164260,4563,'ms','Pesanan yang lengkap',0),(164261,4563,'ar','ØªØ±ØªÙŠØ¨ ÙƒØ§Ù…Ù„Ø©',0),(164262,4563,'fr','Commande complÃ¨te',0),(164263,4563,'jp','æ³¨æ–‡ã‚’å®Œäº†ã?™ã‚‹',0),(164264,4563,'pt','Ordem completa',0),(164265,4563,'ru','ÐŸÐ¾Ð»Ð½Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(164266,4563,'es','Orden Completo',0),(164267,4563,'de','Bestellung abgeschlossen',0),(164268,4563,'en','Order Complete',0),(164269,4564,'is','',0),(164270,4564,'dr','Ø³ÙØ§Ø±Ø´ Ù…Ø§',0),(164271,4564,'pr','Ø³ÙØ§Ø±Ø´ Ù…Ø§',0),(164272,4564,'tr','Bizim sipariÅŸ',0),(164273,4564,'pl','Nasze zamÃ³wienie',0),(164274,4564,'bg','ÐÐ°ÑˆÐ°Ñ‚Ð° Ñ†ÐµÐ»',0),(164275,4564,'ur','ÛÙ…Ø§Ø±Ø§ Ø¢Ø±ÚˆØ±',0),(164276,4564,'sr','ÐÐ°Ñ™ Ñ€ÐµÐ´',0),(164277,4564,'vi','ÄÆ¡n hÃ ng cá»§a chÃºng tÃ´i',0),(164278,4564,'af','Ons Bestelling',0),(164279,4564,'ro','Ordinul nostru',0),(164280,4564,'et','Meie tellimuse',0),(164281,4564,'si','NaÅ¡ red',0),(164282,4564,'ba','Pesanan',0),(164283,4564,'nl','Onze Order',0),(164284,4564,'fi','Tilaa',0),(164285,4564,'no','VÃ¥r bestilling',0),(164286,4564,'da','Vores ordre',0),(164287,4564,'ko','ìš°ë¦¬ì˜ ìˆœì„œ',0),(164288,4564,'he','×”×”×–×ž× ×” ×©×œ× ×•',0),(164289,4564,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î¼Î±Ï‚',0),(164290,4564,'zh','æˆ‘ä»¬çš„è®¢å•\r\n',0),(164291,4564,'sv','VÃ¥r orden',0),(164292,4564,'it','Il nostro ordine',0),(164293,4564,'tl','',0),(164294,4564,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3614;&#3623;&#3585;&#3648;&#3619;&#3634;',0),(164295,4564,'hi','à¤¹à¤®à¤¾à¤°à¥€ à¤‘à¤°à¥à¤¡à¤°',0),(164296,4564,'ms','Pesanan kami',0),(164297,4564,'ar','Ù„Ø¯ÙŠÙ†Ø§ Ø£Ù…Ø±',0),(164298,4564,'fr','Notre ordre',0),(164299,4564,'jp','ç§?é?”ã?®æ³¨æ–‡',0),(164300,4564,'pt','Nossa ordem',0),(164301,4564,'ru','ÐÐ°Ñˆ Ð—Ð°ÐºÐ°Ð·',0),(164302,4564,'es','Nuestro Orden',0),(164303,4564,'de','Unsere Bestellung',0),(164304,4564,'en','Our Order',0),(164305,4565,'is','',0),(164306,4565,'dr','Ø±Ø³ÙŠØ¯ Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ ',0),(164307,4565,'pr','Ø±Ø³ÙŠØ¯ Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ ',0),(164308,4565,'tr','Sevk irsaliyesi',0),(164309,4565,'pl','Opakowanie poÅ›lizgu',0),(164310,4565,'bg','ÐžÐ¿Ð°ÐºÐ¾Ð²Ð°Ð½Ðµ Ð¿Ñ€Ð¸Ð¿Ð»ÑŠÐ·Ð²Ð°Ð½Ðµ',0),(164311,4565,'ur','Ù¾ÛŒÚ©Ø§Ù†Ú¯ Ù¾Ø±Ú†ÛŒ',0),(164312,4565,'sr','ÐŸÐ°ÐºÐ¾Ð²Ð°ÑšÐµ Ð¡Ð»Ð¸Ð¿',0),(164313,4565,'vi','Phiáº¿u Ä‘Ã³ng hÃ ng',0),(164314,4565,'af','Packing strokie',0),(164315,4565,'ro','Ambalare alunecare',0),(164316,4565,'et','Pakkimiskeskuse libisemine',0),(164317,4565,'si','EmbalaÅ¾e-zdrsa',0),(164318,4565,'ba','Slip pengepakan',0),(164319,4565,'nl','Verpakking Slip',0),(164320,4565,'fi','Pakkaus lipsahdus',0),(164321,4565,'no','Pakking Slip',0),(164322,4565,'da','Pakning Slip',0),(164323,4565,'ko','íŒ¨í‚¹ ìŠ¬ë¦½',0),(164324,4565,'he','×ª×’×™×ª ×ž×©×œ×•×—',0),(164325,4565,'el','Î£Ï…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î±Ï‚ Î¿Î»Î¯ÏƒÎ¸Î·ÏƒÎ·Ï‚',0),(164326,4565,'zh','è£…ç®±å•\r\n',0),(164327,4565,'sv','FÃ¶rpackning Slip',0),(164328,4565,'it','Macchine per imballaggio Slip',0),(164329,4565,'tl','',0),(164330,4565,'th','&#3626;&#3621;&#3636;&#3611;&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;',0),(164331,4565,'hi','à¤ªà¥ˆà¤•à¤¿à¤‚à¤— à¤ªà¤°à¥à¤šà¥€',0),(164332,4565,'ms','Packing Slip',0),(164333,4565,'ar','ÙƒØ´Ù Ø§Ù„ØªØ¹Ø¨Ø¦Ø©',0),(164334,4565,'fr','Bordereau d\'emballage',0),(164335,4565,'jp','æ¢±åŒ…ä¼?ç¥¨',0),(164336,4565,'pt','Embalagem Slip',0),(164337,4565,'ru','Ð£Ð¿Ð°ÐºÐ¾Ð²ÐºÐ¸ ÑÐºÐ¾Ð»ÑŒÐ¶ÐµÐ½Ð¸Ñ',0),(164338,4565,'es','Recibo de Empaque',0),(164339,4565,'de','Packing Slip',0),(164340,4565,'en','Packing Slip',0),(164341,4566,'is','',0),(164342,4566,'dr','Ú†Ø§Ù¾ Ø±Ø³ÙŠØ¯ Ø¶Ù…ÙŠÙ…Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(164343,4566,'pr','Ú†Ø§Ù¾ Ø±Ø³ÙŠØ¯ Ø¶Ù…ÙŠÙ…Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(164344,4566,'tr','SipariÅŸi iÃ§in sevk irsaliyesini yazdÄ±rmak',0),(164345,4566,'pl','Drukowanie dokumentu dostawy dla zamÃ³wienia',0),(164346,4566,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¾Ð¿Ð°ÐºÐ¾Ð²ÐºÐ¸ Ñ‚Ð°Ð»Ð¾Ð½ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(164347,4566,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ù¾ÛŒÚ©Ù†Ú¯ Ù¾Ø±Ú†ÛŒ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(164348,4566,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¡Ð»Ð¸Ð¿ Ð¿Ð°ÐºÐ¾Ð²Ð°ÑšÐµ Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(164349,4566,'vi','In Phiáº¿u Ä‘Ã³ng hÃ ng cho Ä‘Æ¡n hÃ ng',0),(164350,4566,'af','Druk harde strokie vir volgorde',0),(164351,4566,'ro','Ambalare alunecare pentru comanda de imprimare',0),(164352,4566,'et','Printida tellimuse saateleht',0),(164353,4566,'si','Natisniti dobavnico za nalog',0),(164354,4566,'ba','Mencetak Slip pengepakan untuk Order',0),(164355,4566,'nl','Pakbon voor bestelling afdrukken',0),(164356,4566,'fi','Tulosta pakkausluettelo tilaukselle',0),(164357,4566,'no','Skrive ut fÃ¸lgeseddelen for ordre',0),(164358,4566,'da','Udskrive fÃ¸lgesedlen for ordre',0),(164359,4566,'ko','ì£¼ë¬¸ í¬ìž¥ ì „í‘œë¥¼ ì¸ì‡„',0),(164360,4566,'he','×”×“×¤×¡ ××ª ×ª×¢×•×“×ª ×”×ž×©×œ×•×— ×¢×‘×•×¨ ×”×–×ž× ×”',0),(164361,4566,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÏ…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î±Ï‚ Î¿Î»Î¯ÏƒÎ¸Î·ÏƒÎ·Ï‚ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(164362,4566,'zh','æ‰“å°è®¢å•è£…ç®±å•\r\n',0),(164363,4566,'sv','Skriva ut fÃ¶ljesedeln fÃ¶r bestÃ¤llning',0),(164364,4566,'it','Stampare la distinta di imballaggio per ordine',0),(164365,4566,'tl','',0),(164366,4566,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3626;&#3621;&#3636;&#3611;&#3585;&#3634;&#3619;&#3627;&#3637;&#3610;&#3627;&#3656;&#3629;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(164367,4566,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥ˆà¤•à¤¿à¤‚à¤— à¤ªà¤°à¥à¤šà¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(164368,4566,'ms','Cetak Slip pembungkusan bagi perintah',0),(164369,4566,'ar','Ø·Ø¨Ø§Ø¹Ø© ÙƒØ´Ù Ø§Ù„ØªØ¹Ø¨Ø¦Ø© Ù„Ø£Ù…Ø±',0),(164370,4566,'fr','Imprimer le bon de livraison pour la commande',0),(164371,4566,'jp','æ³¨æ–‡ã?®æ¢±åŒ…ä¼?ç¥¨ã‚’å?°åˆ·',0),(164372,4566,'pt','Imprimir a guia de remessa para a ordem',0),(164373,4566,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¾Ñ‚Ð±Ð¾Ñ€Ð¾Ñ‡Ð½Ð¾Ð¹ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(164374,4566,'es','Lista de Empaque de Imprimir para el Orden',0),(164375,4566,'de','Drucken von Lieferschein fÃ¼r Bestellung',0),(164376,4566,'en','Print Packing Slip for Order',0),(164377,4567,'is','',0),(164378,4567,'dr','Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(164379,4567,'pr','Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(164380,4567,'tr','TarafÄ±ndan alÄ±nan',0),(164381,4567,'pl','Otrzymane przez',0),(164382,4567,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¾ Ð¾Ñ‚',0),(164383,4567,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…ÙˆØµÙˆÙ„',0),(164384,4567,'sr','ÐŸÑ€Ð¸Ð¼Ð¸Ð¾',0),(164385,4567,'vi','ÄÃ£ nháº­n bá»Ÿi',0),(164386,4567,'af','Ontvang Deur',0),(164387,4567,'ro','Primite de',0),(164388,4567,'et','Laekunud',0),(164389,4567,'si','Prejme',0),(164390,4567,'ba','Diterima oleh',0),(164391,4567,'nl','Ontvangen door',0),(164392,4567,'fi','Saamat',0),(164393,4567,'no','Mottatt av',0),(164394,4567,'da','Modtaget af',0),(164395,4567,'ko','ë°›ì€',0),(164396,4567,'he','×©×”×ª×§×‘×œ×• ×¢×œ-×™×“×™',0),(164397,4567,'el','Î•Î¹ÏƒÏ€ÏÎ¬Ï„Ï„ÎµÎ¹',0),(164398,4567,'zh','æ”¶æ¬¾æ–¹å¼\r\n',0),(164399,4567,'sv','Emot av',0),(164400,4567,'it','Ricevuto da',0),(164401,4567,'tl','',0),(164402,4567,'th','&#3606;&#3641;&#3585;&#3619;&#3633;&#3610;&#3650;&#3604;&#3618;',0),(164403,4567,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(164404,4567,'ms','Diterima oleh',0),(164405,4567,'ar','Ø§Ù„ØªÙŠ ØªÙ„Ù‚Ø§Ù‡Ø§',0),(164406,4567,'fr','ReÃ§us par',0),(164407,4567,'jp','å?—é ˜è€…',0),(164408,4567,'pt','Recebido por',0),(164409,4567,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ',0),(164410,4567,'es','Recibido Por',0),(164411,4567,'de','Empfangen von',0),(164412,4567,'en','Received By',0),(164413,4568,'is','',0),(164414,4568,'dr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø² Ø·Ø±ÙŠÙ‚ ',0),(164415,4568,'pr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø² Ø·Ø±ÙŠÙ‚ ',0),(164416,4568,'tr','Via sevk',0),(164417,4568,'pl','WysÅ‚ane przez',0),(164418,4568,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÑÑ‚ Ñ‡Ñ€ÐµÐ·',0),(164419,4568,'ur','Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(164420,4568,'sr','Ð”Ð¾Ð¿Ñ€ÐµÐ¼Ð° Ð¿Ñ€ÐµÐºÐ¾',0),(164421,4568,'vi','Chuyá»ƒn qua',0),(164422,4568,'af','Versend Via',0),(164423,4568,'ro','Expediate prin',0),(164424,4568,'et','TranspordiettevÃµte kaudu',0),(164425,4568,'si','Poslano prek',0),(164426,4568,'ba','Dikirim melalui',0),(164427,4568,'nl','Verzonden Via',0),(164428,4568,'fi','Kuljetettiin',0),(164429,4568,'no','Sendt Via',0),(164430,4568,'da','Afsendt Via',0),(164431,4568,'ko','í†µí•´ ë°œì†¡',0),(164432,4568,'he','× ×©×œ×— ×“×¨×š',0),(164433,4568,'el','Î‘Ï€ÎµÏƒÏ„Î¬Î»Î·ÏƒÎ±Î½ Î¼Î­ÏƒÏ‰',0),(164434,4568,'zh','è¿å¾€é€šè¿‡\r\n',0),(164435,4568,'sv','Levereras Via',0),(164436,4568,'it','Spedito Via',0),(164437,4568,'tl','',0),(164438,4568,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;&#3650;&#3604;&#3618;&#3607;&#3634;&#3591;',0),(164439,4568,'hi','à¤•à¥‡ à¤œà¤°à¤¿à¤ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(164440,4568,'ms','Dihantar melalui',0),(164441,4568,'ar','ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ø¹Ù† Ø·Ø±ÙŠÙ‚',0),(164442,4568,'fr','ExpÃ©diÃ©es Via',0),(164443,4568,'jp','ï½žçµŒç”±ç™ºé€?æ¸ˆ',0),(164444,4568,'pt','Enviado Via',0),(164445,4568,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ‡ÐµÑ€ÐµÐ·',0),(164446,4568,'es','Enviado Via',0),(164447,4568,'de','Per',0),(164448,4568,'en','Shipped Via',0),(164449,4569,'is','',0),(164450,4569,'dr','ØªØ­ÙˆÙŠÙ„ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(164451,4569,'pr','ØªØ­ÙˆÙŠÙ„ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(164452,4569,'tr','Standart daÄŸÄ±tÄ±m',0),(164453,4569,'pl','Standar',0),(164454,4569,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(164455,4569,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø­ÙˆØ§Ù„Ú¯ÛŒ',0),(164456,4569,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(164457,4569,'vi','Giao hÃ ng chuáº©n',0),(164458,4569,'af','Standaard Aflewering',0),(164459,4569,'ro','Standard de livrare',0),(164460,4569,'et','Standardne kohaletoimetamine',0),(164461,4569,'si','Standardna dostava',0),(164462,4569,'ba','Standar pengiriman',0),(164463,4569,'nl','Standaardlevering',0),(164464,4569,'fi','Toimituksen sisÃ¤ltÃ¶',0),(164465,4569,'no','Standard levering',0),(164466,4569,'da','Leveringens omfang',0),(164467,4569,'ko','í‘œì¤€ ë°°ë‹¬',0),(164468,4569,'he','×ž×©×œ×•×— ×¨×’×™×œ',0),(164469,4569,'el','Î£Ï„Î¬Î½Ï„Î±Ï ÏƒÏ…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î± Ï€Î±ÏÎ¬Î´ÏƒÎ·Ï‚',0),(164470,4569,'zh','æ ‡å‡†æŠ•é€’\r\n',0),(164471,4569,'sv','Standardleverans',0),(164472,4569,'it','Consegna standard',0),(164473,4569,'tl','',0),(164474,4569,'th','&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3626;&#3656;&#3591;',0),(164475,4569,'hi','à¤®à¤¾à¤¨à¤• à¤¡à¤¿à¤²à¤¿à¤µà¤°à¥€',0),(164476,4569,'ms','Standard penghantaran',0),(164477,4569,'ar','ØªØ³Ù„ÙŠÙ… Ù‚ÙŠØ§Ø³ÙŠØ©',0),(164478,4569,'fr','Livraison standard',0),(164479,4569,'jp','æ¨™æº–ç™ºé€?',0),(164480,4569,'pt','Entrega padrÃ£o',0),(164481,4569,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð°Ñ ÐŸÐ¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(164482,4569,'es','Entrega EstÃ¡ndar',0),(164483,4569,'de','Standardlieferung',0),(164484,4569,'en','Standard Delivery',0),(164485,4570,'is','',0),(164486,4570,'dr','Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(164487,4570,'pr','Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(164488,4570,'tr','SipariÅŸiniz PO',0),(164489,4570,'pl','ZamÃ³wienie PO',0),(164490,4570,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° PO',0),(164491,4570,'ur','Ø¢Ù¾ Ú©Û’ Ø­Ú©Ù… Ù¾Ùˆ',0),(164492,4570,'sr','Ð¢Ð²Ð¾Ñ˜ Ñ€ÐµÐ´, ÐŸÐž',0),(164493,4570,'vi','ÄÆ¡n mua hÃ ng cá»§a báº¡n',0),(164494,4570,'af','U BESTELLING AB',0),(164495,4570,'ro','Comanda dumneavoastra PO',0),(164496,4570,'et','Teie ostutellimus',0),(164497,4570,'si','VaÅ¡e naroÄilo PO',0),(164498,4570,'ba','Pesanan Anda PO',0),(164499,4570,'nl','Uw bestelling PO',0),(164500,4570,'fi','Tilauksesi PO',0),(164501,4570,'no','Bestillingen PO',0),(164502,4570,'da','Din ordre PO',0),(164503,4570,'ko','ì£¼ë¬¸ í¬',0),(164504,4570,'he','×”×”×–×ž× ×” ×©×œ×š ×¤×•',0),(164505,4570,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÎ±Ï‚ PO',0),(164506,4570,'zh','æ‚¨ä¸‹è®¢è®¢å•\r\n',0),(164507,4570,'sv','Din bestÃ¤llning PO',0),(164508,4570,'it','Vostro ordine PO',0),(164509,4570,'tl','',0),(164510,4570,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; &#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(164511,4570,'hi','à¤…à¤ªà¤¨à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¥‹',0),(164512,4570,'ms','Pesanan anda PO',0),(164513,4570,'ar','Øµ. Ø¨ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(164514,4570,'fr','Votre commande PO',0),(164515,4570,'jp','ã?‚ã?ªã?Ÿã?®æ³¨æ–‡ã?®ç™ºæ³¨æ›¸',0),(164516,4570,'pt','Sua ordem PO',0),(164517,4570,'ru','Ð’Ð°Ñˆ Ð·Ð°ÐºÐ°Ð· PO',0),(164518,4570,'es','Su OC de pedido',0),(164519,4570,'de','Ihre Bestellung PO',0),(164520,4570,'en','Your Order PO',0),(164521,4571,'is','',0),(164522,4571,'dr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ú©Ø§Ø¯Ø±',0),(164523,4571,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ú©Ø§Ø¯Ø±',0),(164524,4571,'tr','Kutu etiketleri',0),(164525,4571,'pl','Pole etykiety',0),(164526,4571,'bg','ÐšÑƒÑ‚Ð¸Ñ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(164527,4571,'ur','Ø®Ø§Ù†Û Ù„ÛŒØ¨Ù„',0),(164528,4571,'sr','ÐŸÐ¾Ñ™Ðµ Ð¾Ð·Ð½Ð°ÐºÐµ',0),(164529,4571,'vi','NhÃ£n Há»™p',0),(164530,4571,'af','Boks Ettikette',0),(164531,4571,'ro','Caseta de etichete',0),(164532,4571,'et','Kasti etiketid',0),(164533,4571,'si','Polje oznake',0),(164534,4571,'ba','Kotak label',0),(164535,4571,'nl','Vak Labels',0),(164536,4571,'fi','Box tarrat',0),(164537,4571,'no','Boks',0),(164538,4571,'da','Afkrydsningsfeltet etiketter',0),(164539,4571,'ko','ìƒìž ë ˆì´ë¸”',0),(164540,4571,'he','×‘×ª×™×‘×” ×ª×•×•×™×•×ª',0),(164541,4571,'el','Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚ Ï€Î»Î±Î¯ÏƒÎ¹Î¿',0),(164542,4571,'zh','æ¡†æ ‡ç­¾\r\n',0),(164543,4571,'sv','Rutan etiketter',0),(164544,4571,'it','Casella etichette',0),(164545,4571,'tl','',0),(164546,4571,'th','&#3593;&#3621;&#3634;&#3585;&#3586;&#3629;&#3591;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(164547,4571,'hi','à¤¬à¥‰à¤•à¥à¤¸ à¤²à¥‡à¤¬à¤²',0),(164548,4571,'ms','Label kotak',0),(164549,4571,'ar','ØªØ³Ù…ÙŠØ§Øª Ù…Ø±Ø¨Ø¹',0),(164550,4571,'fr','Ã‰tiquettes de zone',0),(164551,4571,'jp','ãƒœãƒƒã‚¯ã‚¹ãƒ©ãƒ™ãƒ«',0),(164552,4571,'pt','RÃ³tulos de caixa',0),(164553,4571,'ru','Ð¨Ñ‚ÑƒÑ‡Ð½Ð°Ñ ÑƒÐ¿Ð°ÐºÐ¾Ð²ÐºÐ° Ð½Ð°ÐºÐ»ÐµÐ¹ÐºÐ¸',0),(164554,4571,'es','Caja Etiquetas',0),(164555,4571,'de','Etiketten',0),(164556,4571,'en','Box Labels',0),(164557,4572,'is','',0),(164558,4572,'dr','Ù‡Ù…Ù‡ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø§Ø±Ø³Ø§Ù„ Ø´ÙˆØ¯',0),(164559,4572,'pr','Ù‡Ù…Ù‡ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø§Ø±Ø³Ø§Ù„ Ø´ÙˆØ¯',0),(164560,4572,'tr','Tek kalan Mkt. gemi iÃ§in tÄ±klayÄ±n',0),(164561,4572,'pl','Kliknij pozycjÄ™ Wszystkie statek pozostaÅ‚Ä… iloÅ›Ä‡.',0),(164562,4572,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ñ‚Ðµ Ð¾ÑÑ‚Ð°Ð½Ð°Ð»Ð¸Ñ‚Ðµ ÐºÐ¾Ð»',0),(164563,4572,'ur','ØªÙ…Ø§Ù… Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Û Qty. Ø¬ÛØ§Ø² Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(164564,4572,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ²Ðµ Ð´Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚Ðµ ÐŸÑ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð° ÐºÐ¾Ð».',0),(164565,4572,'vi','Nháº¥n Táº¥t cáº£ Ä‘á»ƒ váº­n chuyá»ƒn sá»‘ hÃ ng cÃ²n láº¡i',0),(164566,4572,'af','Kliek ALLE om Oorblywende Hoev. te Versend',0),(164567,4572,'ro','FaceÅ£i clic pe toate pentru a navei cant rÄƒmase.',0),(164568,4572,'et','KlÃµpsa KÃ•IK, et tarnida allesjÃ¤Ã¤nud kogused',0),(164569,4572,'si','Kliknite vse ladje preostala koliÄina',0),(164570,4572,'ba','Klik semua untuk kapal Qty. tersisa',0),(164571,4572,'nl','Klik op alles om te verzenden van resterende aantal',0),(164572,4572,'fi','Valitse kaikki aluksen jÃ¤ljellÃ¤ oleva mÃ¤Ã¤rÃ¤',0),(164573,4572,'no','Klikk alle for Ã¥ sende gjenvÃ¦rende antall',0),(164574,4572,'da','Klik pÃ¥ alt for at skibet Restantal',0),(164575,4572,'ko','ë‚¨ì€ ìˆ˜ëŸ‰ ë°œì†¡ í•˜ë ¤ë©´ ëª¨ë‘ë¥¼ í´ë¦­í•©ë‹ˆë‹¤',0),(164576,4572,'he','×œ×—×¥ ×¢×œ ×›×œ ×”×¡×¤×™× ×” ×›×ž×•×ª × ×•×ª×¨×ª',0),(164577,4572,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® ÏŒÎ»Î¿Î¹ Î³Î¹Î± Î½Î± Î¼ÎµÏ„Î±Ï†Î­ÏÎµÎ¹ Ï„Î¿ Ï€ÎµÎ´Î¯Î¿ Î¥Ï€ÏŒÎ»Î¿Î¹Ï€Î· Î Î¿ÏƒÏŒÏ„.',0),(164578,4572,'zh','å•å‡»æ‰€æœ‰ä»¥è¿é€å‰©ä½™æ•°é‡ã€‚\r\n',0),(164579,4572,'sv','Klicka pÃ¥ alla om du vill skeppa Ã¥terstÃ¥ende Ant.',0),(164580,4572,'it','Fare clic su tutti per nave restante QtÃ ',0),(164581,4572,'tl','',0),(164582,4572,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3648;&#3614;&#3639;&#3656;&#3629;&#3586;&#3609;&#3626;&#3656;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(164583,4572,'hi','à¤¸à¤­à¥€ à¤¶à¥‡à¤· à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(164584,4572,'ms','Klik semua kapal baki Qty.',0),(164585,4572,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„ÙƒÙ„ Ø§Ù„Ø³ÙÙŠÙ†Ø© Qty. Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(164586,4572,'fr','Cliquez sur toutes pour livrer QtÃ© restante',0),(164587,4572,'jp','æ®‹æ•°é‡?ã‚’ç™ºé€?ã?™ã‚‹ã?«ã?¯å…¨ã?¦ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(164588,4572,'pt','Clique em ALL para navio restante Qtd.',0),(164589,4572,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð²ÑÐµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¾ÑÑ‚Ð°Ð²ÑˆÐ¸ÐµÑÑ ÐšÐ¾Ð».',0),(164590,4572,'es','Click TODO para Enviar la Cantidad que Sobra',0),(164591,4572,'de','Klicken Sie auf alle, um die verbleibende Menge Schiff',0),(164592,4572,'en','Click ALL to Ship Remaining Qty.',0),(164593,4573,'is','',0),(164594,4573,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(164595,4573,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(164596,4573,'tr','Zaten sevk',0),(164597,4573,'pl','JuÅ¼ zostaÅ‚o wysÅ‚ane',0),(164598,4573,'bg','Ð’ÐµÑ‡Ðµ ÑÐ° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸',0),(164599,4573,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(164600,4573,'sr','Ð’ÐµÑ› Ñ˜Ðµ Ð¸Ð·Ð²Ñ€ÑˆÐµÐ½',0),(164601,4573,'vi','ÄÃ£ váº­n chuyá»ƒn',0),(164602,4573,'af','Is alreeds versend',0),(164603,4573,'ro','Deja a fost expediat',0),(164604,4573,'et','Praeguseks lÃ¤hetatud',0),(164605,4573,'si','Je Å¾e poslano',0),(164606,4573,'ba','Telah dikirimkan',0),(164607,4573,'nl','Heeft reeds zijn verzonden',0),(164608,4573,'fi','Jo lÃ¤hetetty',0),(164609,4573,'no','Allerede er sendt',0),(164610,4573,'da','Er allerede blevet afsendt',0),(164611,4573,'ko','ì´ë¯¸ ì œê³µ ëœ',0),(164612,4573,'he','×›×‘×¨ × ×©×œ×—×”',0),(164613,4573,'el','ÎˆÏ‡ÎµÎ¹ Î®Î´Î· Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯',0),(164614,4573,'zh','å·²ç»è¿\r\n',0),(164615,4573,'sv','Redan har levererats',0),(164616,4573,'it','Ãˆ giÃ  stato spedito',0),(164617,4573,'tl','',0),(164618,4573,'th','&#3617;&#3637;&#3586;&#3609;&#3626;&#3656;&#3591;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(164619,4573,'hi','à¤ªà¤¹à¤²à¥‡ à¤¹à¥€ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(164620,4573,'ms','Sudah dikirimkan',0),(164621,4573,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ ÙØ¹Ù„Ø§',0),(164622,4573,'fr','A dÃ©jÃ  Ã©tÃ© expÃ©diÃ©e',0),(164623,4573,'jp','ã?™ã?§ã?«ç™ºé€?ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(164624,4573,'pt','JÃ¡ foi enviada',0),(164625,4573,'ru','Ð£Ð¶Ðµ Ð±Ñ‹Ð»Ð° Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð°',0),(164626,4573,'es','Ya ha sido enviado',0),(164627,4573,'de','Hat bereits geliefert wurde',0),(164628,4573,'en','Has already been shipped',0),(164629,4574,'is','',0),(164630,4574,'dr','Ø¢ÙŠØ§ ÙŠÙƒ Ø¹Ø¯Ø¯ Ù…Ù†ÙÙŠ Ø§Ø³Øª',0),(164631,4574,'pr','Ø¢ÙŠØ§ ÙŠÙƒ Ø¹Ø¯Ø¯ Ù…Ù†ÙÙŠ Ø§Ø³Øª',0),(164632,4574,'tr','negatif sayÄ±',0),(164633,4574,'pl','jest liczbÄ… ujemnÄ…',0),(164634,4574,'bg','Ðµ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»Ð½Ð¾ Ñ‡Ð¸ÑÐ»Ð¾',0),(164635,4574,'ur','Ù…Ù†ÙÛŒ Ù†Ù…Ø¨Ø± ÛÛ’',0),(164636,4574,'sr','Ñ˜Ðµ Ð½ÐµÐ³Ð°Ñ‚Ð¸Ð²Ð°Ð½ Ð±Ñ€Ð¾Ñ˜',0),(164637,4574,'vi','lÃ  má»™t sá»‘ Ã¢m',0),(164638,4574,'af','is \'n negatiewe syfer',0),(164639,4574,'ro','este un numÄƒr negativ',0),(164640,4574,'et','on negatiivne arv',0),(164641,4574,'si','negativno Å¡tevilo',0),(164642,4574,'ba','sejumlah negatif',0),(164643,4574,'nl','een negatief getal',0),(164644,4574,'fi','on negatiivinen',0),(164645,4574,'no','et negativt tall',0),(164646,4574,'da','er et negativt tal',0),(164647,4574,'ko','ìŒìˆ˜ ì´ë©´',0),(164648,4574,'he','×”×•× ×ž×¡×¤×¨ ×©×œ×™×œ×™',0),(164649,4574,'el','ÎµÎ¯Î½Î±Î¹ Î±ÏÎ½Î·Ï„Î¹ÎºÏŒÏ‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(164650,4574,'zh','ä¸ºè´Ÿæ•°\r\n',0),(164651,4574,'sv','Ã¤r ett negativt tal',0),(164652,4574,'it','Ã¨ un numero negativo',0),(164653,4574,'tl','',0),(164654,4574,'th','&#3648;&#3611;&#3655;&#3609;&#3592;&#3635;&#3609;&#3623;&#3609;&#3621;&#3610;',0),(164655,4574,'hi','à¤•à¥‹à¤ˆ à¤‹à¤£à¤¾à¤¤à¥à¤®à¤• à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¹à¥ˆ',0),(164656,4574,'ms','nombor negatif',0),(164657,4574,'ar','Ø¹Ø¯Ø¯ Ø³Ø§Ù„Ø¨',0),(164658,4574,'fr','est un nombre nÃ©gatif',0),(164659,4574,'jp','ãƒžã‚¤ãƒŠã‚¹ã?®æ•°å­—ã?§ã?™',0),(164660,4574,'pt','Ã© um nÃºmero negativo',0),(164661,4574,'ru','Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ñ‡Ð¸ÑÐ»Ð¾',0),(164662,4574,'es','es un nÃºmero negativo',0),(164663,4574,'de','eine negative Zahl',0),(164664,4574,'en','is a negative number',0),(164665,4575,'is','',0),(164666,4575,'dr','Ø¢ÙŠØ§ Ø¢Ù…Ø§Ø¯Ù‡ Ø­Ù…Ù„ Ù†ÙŠØ³Øª ØŸ',0),(164667,4575,'pr','Ø¢ÙŠØ§ Ø¢Ù…Ø§Ø¯Ù‡ Ø­Ù…Ù„ Ù†ÙŠØ³Øª ØŸ',0),(164668,4575,'tr','nakliye iÃ§in hazÄ±r deÄŸil',0),(164669,4575,'pl','nie jest gotowy do wysyÅ‚ki',0),(164670,4575,'bg','Ð½Ðµ Ðµ Ð³Ð¾Ñ‚Ð¾Ð² Ð·Ð° ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½Ðµ',0),(164671,4575,'ur','Ø¬ÛØ§Ø² Ø±Ø§Ù†ÛŒ Ú©Û’ Ù„Ø¦Û’ ØªÛŒØ§Ø± Ù†ÛÛŒÚº ÛÛ’',0),(164672,4575,'sr','Ð½Ð¸Ñ˜Ðµ ÑÐ¿Ñ€ÐµÐ¼Ð°Ð½ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(164673,4575,'vi','chÆ°a sáºµn sÃ ng Ä‘á»ƒ váº­n chuyá»ƒn',0),(164674,4575,'af','is nie gereed vir versending',0),(164675,4575,'ro','nu este gata pentru transport maritim',0),(164676,4575,'et','ei vÃµimalda nende saatmine',0),(164677,4575,'si','ni pripravljen za odpremo',0),(164678,4575,'ba','siap untuk pengiriman',0),(164679,4575,'nl','is niet klaar voor verzending',0),(164680,4575,'fi','ei ole valmis lÃ¤hetettÃ¤vÃ¤ksi',0),(164681,4575,'no','er ikke klar for levering',0),(164682,4575,'da','er ikke klar til forsendelse',0),(164683,4575,'ko','ë°°ì†¡ì— ëŒ€ í•œ ì¤€ë¹„ê°€ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(164684,4575,'he','. ×”×•× ×œ× ×ž×•×›×Ÿ ×œ×ž×©×œ×•×—',0),(164685,4575,'el','Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Ï„Î¿Î¹Î¼Î· Î³Î¹Î± Ï„Î· Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(164686,4575,'zh','æ˜¯å¦å‡†å¤‡å¥½å‡ºè´§\r\n',0),(164687,4575,'sv','Ã¤r inte redo fÃ¶r frakt',0),(164688,4575,'it','non Ã¨ pronto per la spedizione',0),(164689,4575,'tl','',0),(164690,4575,'th','&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3614;&#3619;&#3657;&#3629;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(164691,4575,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¯à¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(164692,4575,'ms','bukanlah sedia untuk penghantaran',0),(164693,4575,'ar','ØºÙŠØ± Ø¬Ø§Ù‡Ø² Ù„Ù„Ø´Ø­Ù†',0),(164694,4575,'fr','n\'est pas prÃªt pour l\'expÃ©dition',0),(164695,4575,'jp','ã?¾ã? ç™ºé€?ã?®æº–å‚™ã?Œæ•´ã?£ã?¦ã?„ã?¾ã?›ã‚“',0),(164696,4575,'pt','NÃ£o estÃ¡ pronto para o transporte',0),(164697,4575,'ru','Ð½Ðµ Ð³Ð¾Ñ‚Ð¾Ð²Ð¾ Ðº Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐµ',0),(164698,4575,'es','no esta listo para enviar',0),(164699,4575,'de','ist nicht bereit fÃ¼r den Versand',0),(164700,4575,'en','is not ready for shipping',0),(164701,4576,'is','',0),(164702,4576,'dr','Ø®ÙŠÙ„ÙŠ Ø·ÙˆÙ„Ø§Ù†ÙŠ Ø§Ø³Øª',0),(164703,4576,'pr','Ø®ÙŠÙ„ÙŠ Ø·ÙˆÙ„Ø§Ù†ÙŠ Ø§Ø³Øª',0),(164704,4576,'tr','Ã§ok bÃ¼yÃ¼k',0),(164705,4576,'pl','jest zbyt duÅ¼y',0),(164706,4576,'bg','Ðµ Ñ‚Ð²ÑŠÑ€Ð´Ðµ Ð³Ð¾Ð»ÑÐ¼',0),(164707,4576,'ur','Ø¨ÛØª Ø¨Ú‘Ø§ ÛÛ’',0),(164708,4576,'sr','Ñ˜Ðµ Ð¿Ñ€ÐµÐ²ÐµÐ»Ð¸ÐºÐ°',0),(164709,4576,'vi','quÃ¡ lá»›n',0),(164710,4576,'af','is te groot',0),(164711,4576,'ro','este prea mare',0),(164712,4576,'et','on liiga suur',0),(164713,4576,'si','je prevelika',0),(164714,4576,'ba','terlalu besar',0),(164715,4576,'nl','is te groot',0),(164716,4576,'fi','on liian suuri',0),(164717,4576,'no','er for stor',0),(164718,4576,'da','er for stor',0),(164719,4576,'ko','ë„ˆë¬´ í¬ë©´',0),(164720,4576,'he','×’×“×•×œ ×ž×“×™',0),(164721,4576,'el','ÎµÎ¯Î½Î±Î¹ Ï€Î¿Î»Ï Î¼ÎµÎ³Î¬Î»Î¿',0),(164722,4576,'zh','è¿‡å¤§\r\n',0),(164723,4576,'sv','Ã¤r fÃ¶r stor',0),(164724,4576,'it','Ã¨ troppo grande',0),(164725,4576,'tl','',0),(164726,4576,'th','&#3617;&#3633;&#3609;&#3651;&#3627;&#3597;&#3656;&#3617;&#3634;&#3585;',0),(164727,4576,'hi','à¤¬à¤¹à¥à¤¤ à¤¬à¤¡à¤¼à¤¾ à¤¹à¥ˆ',0),(164728,4576,'ms','terlalu besar',0),(164729,4576,'ar','ÙƒØ¨ÙŠØ± Ø¬Ø¯Ø§Ù‹',0),(164730,4576,'fr','est trop grand',0),(164731,4576,'jp','å¤§ã??ã?™ã?Žã?¾ã?™',0),(164732,4576,'pt','Ã© muito grande',0),(164733,4576,'ru','ÑÐ»Ð¸ÑˆÐºÐ¾Ð¼ Ð±Ð¾Ð»ÑŒÑˆÐ¾Ð¹',0),(164734,4576,'es','es demasiado grande',0),(164735,4576,'de','ist zu groÃŸ',0),(164736,4576,'en','is too large',0),(164737,4577,'is','',0),(164738,4577,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡  Ø³ÙØ§Ø±Ø´ ',0),(164739,4577,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡  Ø³ÙØ§Ø±Ø´ ',0),(164740,4577,'tr','Yeni sevkÄ±yat iÃ§in sipariÅŸ numarasÄ±',0),(164741,4577,'pl','Nowe wydanie dla numeru porzÄ…dkowego',0),(164742,4577,'bg','ÐÐ¾Ð²Ð° Ð¿Ñ€Ð°Ñ‚ÐºÐ° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¾Ð² Ð½Ð¾Ð¼ÐµÑ€',0),(164743,4577,'ur','Ù†Ø¦ÛŒ Ú©Ú¾ÛŒÙ¾ Ù†Ù…Ø¨Ø± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’',0),(164744,4577,'sr','ÐÐ¾Ð²Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð·Ð° Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(164745,4577,'vi','Chuyáº¿n hÃ ng má»›i cho ÄÆ¡n Ä‘áº·t hÃ ng sá»‘',0),(164746,4577,'af','Nuwe Versending vir Bestellingnommer',0),(164747,4577,'ro','Livrare nou pentru numÄƒrul de ordine',0),(164748,4577,'et','Uus tarne tellimusele nr',0),(164749,4577,'si','Nova poÅ¡iljka za zaporedno Å¡tevilko',0),(164750,4577,'ba','Pengiriman baru untuk nomor pesanan',0),(164751,4577,'nl','Nieuwe verzending voor bestellingsnummer',0),(164752,4577,'fi','Uusi lÃ¤hetys tilauksen numero',0),(164753,4577,'no','Nye forsendelsen ordrenummer',0),(164754,4577,'da','Ny leverance for lÃ¸benummer',0),(164755,4577,'ko','ì£¼ë¬¸ ë²ˆí˜¸ì— ëŒ€ í•œ ìƒˆë¡œìš´ ì„ ì ',0),(164756,4577,'he','×ž×©×œ×•×— ×—×“×© ×¢×‘×•×¨ ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(164757,4577,'el','ÎÎ­Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Î³Î¹Î± Ï„Î¿Î½ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(164758,4577,'zh','æ–°è´§çš„è®¢å•ç¼–å·\r\n',0),(164759,4577,'sv','Ny leverans fÃ¶r ordernummer',0),(164760,4577,'it','Nuova spedizione per numero d\'ordine',0),(164761,4577,'tl','',0),(164762,4577,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3651;&#3627;&#3617;&#3656;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3618;',0),(164763,4577,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤ˆ à¤–à¥‡à¤ª',0),(164764,4577,'ms','Baru penghantaran bagi nombor pesanan',0),(164765,4577,'ar','Ø´Ø­Ù†Ø© Ø¬Ø¯ÙŠØ¯Ø© Ù„Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨',0),(164766,4577,'fr','Nouvel arrivage le numÃ©ro d\'ordre',0),(164767,4577,'jp','æ³¨æ–‡ç•ªå?·ã?®æ–°è¦?ç™ºé€?',0),(164768,4577,'pt','Novo carregamento para o nÃºmero de ordem',0),(164769,4577,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð´Ð»Ñ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(164770,4577,'es','Nuevo EnvÃ­o para el NÃºmero de Pedido',0),(164771,4577,'de','Neue Lieferung Bestellnummer',0),(164772,4577,'en','New Shipment for Order Number',0),(164773,4578,'is','',0),(164774,4578,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(164775,4578,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(164776,4578,'tr','SipariÅŸ iÃ§in sevkiyat',0),(164777,4578,'pl','ZamÃ³wienia do wysyÅ‚ki',0),(164778,4578,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(164779,4578,'ur','Ú©Ú¾ÛŒÙ¾ Ú©ÛŒÙ„Ø¦Û’ Ø¢Ø±ÚˆØ±',0),(164780,4578,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(164781,4578,'vi','ÄÆ¡n hÃ ng sáº½ giao',0),(164782,4578,'af','Bestellings vir Versending',0),(164783,4578,'ro','Comenzii de expediere',0),(164784,4578,'et','Tellimuse saatmiseks',0),(164785,4578,'si','Nalog za odpremo',0),(164786,4578,'ba','Pesanan untuk pengiriman',0),(164787,4578,'nl','Volgorde voor verzending',0),(164788,4578,'fi','Jotta lÃ¤hetys',0),(164789,4578,'no','RekkefÃ¸lge for levering',0),(164790,4578,'da','Med henblik pÃ¥ levering',0),(164791,4578,'ko','ì„ ì ì„ ìœ„í•œ ìˆœì„œ',0),(164792,4578,'he','×”×–×ž× ×” ×œ×ž×©×œ×•×—',0),(164793,4578,'el','Î“Î¹Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(164794,4578,'zh','è£…è¿è®¢å•\r\n',0),(164795,4578,'sv','Order fÃ¶r leverans',0),(164796,4578,'it','Ordine per la spedizione',0),(164797,4578,'tl','',0),(164798,4578,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(164799,4578,'hi','à¤ªà¥‹à¤¤ à¤²à¤¦à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶',0),(164800,4578,'ms','Perintah untuk penghantaran',0),(164801,4578,'ar','ØªØ±ØªÙŠØ¨ Ù„Ù„Ø´Ø­Ù†',0),(164802,4578,'fr','Ordre d\'expÃ©dition',0),(164803,4578,'jp','ç™ºé€?ã?®æ³¨æ–‡',0),(164804,4578,'pt','Ordem para carregamento',0),(164805,4578,'ru','Ð—Ð°ÐºÐ°Ð· Ð½Ð° Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·ÐºÑƒ',0),(164806,4578,'es','Pedido para Enviar',0),(164807,4578,'de','Bestellung fÃ¼r den Versand',0),(164808,4578,'en','Order for Shipment',0),(164809,4579,'is','',0),(164810,4579,'dr','Ø³ÙØ§Ø±Ø´ Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(164811,4579,'pr','Ø³ÙØ§Ø±Ø´ Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(164812,4579,'tr','Sevk emri',0),(164813,4579,'pl','ZamÃ³wienia wysyÅ‚ane',0),(164814,4579,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(164815,4579,'ur','Ø­Ú©Ù… Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(164816,4579,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°',0),(164817,4579,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ chuyá»ƒn',0),(164818,4579,'af','Bestelling Versend',0),(164819,4579,'ro','Ordinul expediate',0),(164820,4579,'et','Tellimuse veetud',0),(164821,4579,'si','NaroÄilo poslano',0),(164822,4579,'ba','Pesanan dikirim',0),(164823,4579,'nl','Verzendingen',0),(164824,4579,'fi','Tilaus toimitetaan',0),(164825,4579,'no','Ordre som er sendt',0),(164826,4579,'da','Ordre sendt',0),(164827,4579,'ko','ì£¼ë¬¸ ì¶œí•˜',0),(164828,4579,'he','×”×–×ž× ×” × ×©×œ×—×”',0),(164829,4579,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€Î¿Ï… Î¸Î± ÏƒÏ„Î±Î»ÎµÎ¯',0),(164830,4579,'zh','è®¢å•å‘è´§\r\n',0),(164831,4579,'sv','Ordern levereras',0),(164832,4579,'it','Ordine spedito',0),(164833,4579,'tl','',0),(164834,4579,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(164835,4579,'hi','à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(164836,4579,'ms','Pesanan yang dihantar',0),(164837,4579,'ar','Ø´Ø­Ù†Øª Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(164838,4579,'fr','Commande expÃ©diÃ©e',0),(164839,4579,'jp','ç™ºé€?æ¸ˆæ³¨æ–‡',0),(164840,4579,'pt','Ordem enviado',0),(164841,4579,'ru','Ð—Ð°ÐºÐ°Ð· Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½',0),(164842,4579,'es','Orden Enviado',0),(164843,4579,'de','Versandte Bestellung',0),(164844,4579,'en','Order Shipped',0),(164845,4580,'is','',0),(164846,4580,'dr','Ø­Ù…Ù„ ÙˆÙ†Ù‚Ù„ Ø³ÙØ§Ø±Ø´ ',0),(164847,4580,'pr','Ø­Ù…Ù„ ÙˆÙ†Ù‚Ù„ Ø³ÙØ§Ø±Ø´ ',0),(164848,4580,'tr','SipariÅŸ sevkiyat',0),(164849,4580,'pl','WysyÅ‚ka zamÃ³wienia',0),(164850,4580,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(164851,4580,'ur','ØªØ±ØªÛŒØ¨ Ø´Ù¾Ù†Ú¯',0),(164852,4580,'sr','Ð—Ð°ÐºÐ°ÑÐ½ÐµÐ»Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(164853,4580,'vi','Váº­n chuyá»ƒn',0),(164854,4580,'af','Versending van Bestelling',0),(164855,4580,'ro','Comanda transport',0),(164856,4580,'et','Tellimuse saatmine',0),(164857,4580,'si','Dobava naloga',0),(164858,4580,'ba','Pengiriman pesanan',0),(164859,4580,'nl','Om de verzending',0),(164860,4580,'fi','Tilauksen toimitus',0),(164861,4580,'no','Ordre Norge',0),(164862,4580,'da','Bestil Shipping',0),(164863,4580,'ko','ì£¼ë¬¸ ë°°ì†¡',0),(164864,4580,'he','×”×–×ž× ×ª ×ž×©×œ×•×—',0),(164865,4580,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(164866,4580,'zh','è®¢è´­é€è´§\r\n',0),(164867,4580,'sv','BestÃ¤ll frakt',0),(164868,4580,'it','Spedizione ordine',0),(164869,4580,'tl','',0),(164870,4580,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3605;&#3634;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(164871,4580,'hi','à¤†à¤¦à¥‡à¤¶ à¤¨à¥Œà¤µà¤¹à¤¨',0),(164872,4580,'ms','Penghantaran pesanan',0),(164873,4580,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø´Ø­Ù†',0),(164874,4580,'fr','ExpÃ©dition de la commande',0),(164875,4580,'jp','ç™ºé€?ä¸­æ³¨æ–‡',0),(164876,4580,'pt','Ordem de transporte',0),(164877,4580,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·ÐºÑƒ',0),(164878,4580,'es','Orden Enviando',0),(164879,4580,'de','Versand',0),(164880,4580,'en','Order Shipping',0),(164881,4581,'is','',0),(164882,4581,'dr','Ø¯ÙƒÙ…Ù‡ Ù‚Ø¨ÙˆÙ„ Ø±Ø§ Ø¬Ù‡Øª ØªØ§ÙŠÙŠØ¯  Ú†Ø§Ù¾ Ø¯Ù‡ÙŠØ¯ Ø§Ú¯Ø± Ù…Ù‚Ø¯Ø§Ø± ØµØ­ÙŠØ­ Ø§Ø³Øª ',0),(164883,4581,'pr','Ø¯ÙƒÙ…Ù‡ Ù‚Ø¨ÙˆÙ„ Ø±Ø§ Ø¬Ù‡Øª ØªØ§ÙŠÙŠØ¯  Ú†Ø§Ù¾ Ø¯Ù‡ÙŠØ¯ Ø§Ú¯Ø± Ù…Ù‚Ø¯Ø§Ø± ØµØ­ÙŠØ­ Ø§Ø³Øª ',0),(164884,4581,'tr','Tutar doÄŸru ise Onayla iÃ§in OK tuÅŸuna basÄ±n',0),(164885,4581,'pl','NaciÅ›nij przycisk OK aby umocniÄ‡, jeÅ›li kwota jest poprawny',0),(164886,4581,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ OK Ð·Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ, Ð°ÐºÐ¾ ÑÑƒÐ¼Ð°Ñ‚Ð° Ðµ Ð¿Ñ€Ð°Ð²Ð¸Ð»ÐµÐ½',0),(164887,4581,'ur','Ø§Ú¯Ø± Ø±Ù‚Ù… Ø¯Ø±Ø³Øª ÛÛ’ ØªÙˆ ØªØµØ¯ÛŒÙ‚ Ú©Û’ Ù„ÛŒÛ’ Ù¹Ú¾ÛŒÚ© ÛÛ’ Ø¯Ø¨Ø§Ø¦ÛŒÚº',0),(164888,4581,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ ÐžÐš Ð´Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸, Ð°ÐºÐ¾ Ð¸Ð·Ð½Ð¾Ñ Ñ˜Ðµ Ñƒ Ð¿Ñ€Ð°Ð²Ñƒ',0),(164889,4581,'vi','Nháº¥n OK Ä‘á»ƒ xÃ¡c nháº­n náº¿u sá»‘ tiá»n Ä‘Ãºng',0),(164890,4581,'af','Druk OK om te Bevestig indien die bedrag korrek is',0),(164891,4581,'ro','ApÄƒsaÅ£i OK pentru a confirma dacÄƒ suma este corect',0),(164892,4581,'et','Vajutage OK kinnitate kui summa on korrektne',0),(164893,4581,'si','Pritisnite OK za potrditev, Äe znesek ni pravilna',0),(164894,4581,'ba','Tekan OK untuk konfirmasi jika jumlah benar',0),(164895,4581,'nl','Druk OK om te bevestigen als bedrag klopt',0),(164896,4581,'fi','Paina OK Vahvista, jos summa on oikea',0),(164897,4581,'no','Trykk OK for Ã¥ Bekreft hvis belÃ¸pet er riktig',0),(164898,4581,'da','Tryk OK for at BekrÃ¦ft hvis belÃ¸bet er korrekt',0),(164899,4581,'ko','ê¸ˆì•¡ì€ ì •í™•í•œ í™•ì¸ì„ OK ëˆ„ë¦…ë‹ˆë‹¤',0),(164900,4581,'he','×œ×¢ ×¥×—×œ ×˜×•×‘ ××©×¨ ×× ×›×ž×•×ª × ×›×•× ×”',0),(164901,4581,'el','Î Î±Ï„Î®ÏƒÏ„Îµ OK Î³Î¹Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·, ÎµÎ¬Î½ Ï„Î¿ Ï€Î¿ÏƒÏŒ ÎµÎ¯Î½Î±Î¹ ÏƒÏ‰ÏƒÏ„Î®',0),(164902,4581,'zh','æŒ‰ç¡®å®šä»¥ç¡®è®¤æ˜¯å¦æ˜¯æ­£ç¡®çš„é‡‘é¢\r\n',0),(164903,4581,'sv','Tryck OK fÃ¶r att bekrÃ¤fta om beloppet Ã¤r korrekt',0),(164904,4581,'it','Premere OK per confermare se l\'importo Ã¨ corretto',0),(164905,4581,'tl','',0),(164906,4581,'th','&#3585;&#3604; OK &#3648;&#3614;&#3639;&#3656;&#3629;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3648;&#3617;&#3639;&#3656;&#3629;&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(164907,4581,'hi','à¤…à¤—à¤° à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¤¹à¥€ à¤¹à¥ˆ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ à¥€à¤• à¤¦à¤¬à¤¾à¤à¤',0),(164908,4581,'ms','Tekan OK untuk mengesahkan jika amaun yang betul',0),(164909,4581,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ù…ÙˆØ§ÙÙ‚ Ù„ØªØ£ÙƒÙŠØ¯ Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„ØµØ­ÙŠØ­',0),(164910,4581,'fr','Appuyez sur OK pour confirmer, si le montant est correct',0),(164911,4581,'jp','ç·?é¡?ã?Œæ­£ã?—ã?‘ã‚Œã?°ï¼¯ï¼«ã‚’æŠ¼ã?—ã?¦ã??ã? ã?•ã?„',0),(164912,4581,'pt','Pressione OK para confirmar se a quantidade Ã© correta',0),(164913,4581,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ OK, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ, ÐµÑÐ»Ð¸ ÑÑƒÐ¼Ð¼Ð° Ð²ÐµÑ€Ð½Ð°',0),(164914,4581,'es','Oprimir OK para confirmar si el monto es correcto',0),(164915,4581,'de','DrÃ¼cken Sie OK zu bestÃ¤tigen, wenn Betrag stimmt',0),(164916,4581,'en','Press OK to Confirm if amount is correct',0),(164917,4582,'is','',0),(164918,4582,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‚Ø¨Ù„ÙŠ ',0),(164919,4582,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‚Ø¨Ù„ÙŠ ',0),(164920,4582,'tr','Ã–nceki Sevkiyat ayrÄ±ntÄ±larÄ±',0),(164921,4582,'pl','Poprzednie wydania szczegÃ³Å‚y',0),(164922,4582,'bg','ÐŸÑ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(164923,4582,'ur','Ù¾Ú†Ú¾Ù„Ø§ Ú©Ú¾ÛŒÙ¾ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(164924,4582,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ð¸Ð¼Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(164925,4582,'vi','Chi tiáº¿t chuyáº¿n hÃ ng trÆ°á»›c',0),(164926,4582,'af','Vorige Versending Details',0),(164927,4582,'ro','Anterioare expedierii detalii',0),(164928,4582,'et','Eelmise saadetise andmed',0),(164929,4582,'si','PrejÅ¡nji podatki o poÅ¡iljki',0),(164930,4582,'ba','Sebelumnya pengiriman rincian',0),(164931,4582,'nl','Vorige verzendgegevens',0),(164932,4582,'fi','Edellisen lÃ¤hetyksen tiedot',0),(164933,4582,'no','Forrige forsend.det',0),(164934,4582,'da','Tidligere forsendelsesoplysninger',0),(164935,4582,'ko','ì´ì „ ë°œì†¡ë¬¼ ì„¸ë¶€ ì‚¬í•­',0),(164936,4582,'he','×¤×¨×˜×™ ×ž×©×œ×•×— ×”×§×•×“×',0),(164937,4582,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(164938,4582,'zh','ä»¥å‰çš„è´§ä»¶è¯¦ç»†ä¿¡æ¯\r\n',0),(164939,4582,'sv','Tidigare leverans Detaljer',0),(164940,4582,'it','Dettagli di spedizione precedente',0),(164941,4582,'tl','',0),(164942,4582,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3605;&#3656;&#3585;&#3656;&#3629;&#3609;',0),(164943,4582,'hi','à¤ªà¤¿à¤›à¤²à¤¾ à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤µà¤¿à¤µà¤°à¤£',0),(164944,4582,'ms','Butir-butir penghantaran yang sebelumnya',0),(164945,4582,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(164946,4582,'fr','DÃ©tails d\'expÃ©dition prÃ©cÃ©dente',0),(164947,4582,'jp','å‰?ã?®ç™ºé€?è©³ç´°',0),(164948,4582,'pt','Detalhes de remessa anterior',0),(164949,4582,'ru','ÐŸÑ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð³Ñ€ÑƒÐ·Ð°',0),(164950,4582,'es','Detalles de EnvÃ­os Previos',0),(164951,4582,'de','Vorherige Sendung Informationen',0),(164952,4582,'en','Previous Shipment Details',0),(164953,4583,'is','',0),(164954,4583,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø§Ø±Ø³Ø§Ù„ ÙƒØ±Ø¯Ù† ',0),(164955,4583,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø§Ø±Ø³Ø§Ù„ ÙƒØ±Ø¯Ù† ',0),(164956,4583,'tr','Miktar gÃ¶nderme',0),(164957,4583,'pl','IloÅ›Ä‡ do wysyÅ‚ania',0),(164958,4583,'bg','ÐšÐ¾Ð»-Ð²Ð¾ Ð·Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ',0),(164959,4583,'ur','Ù‚ÛŒ Ø¨Ú¾ÛŒØ¬Ù†Û’ Ú©Ùˆ',0),(164960,4583,'sr','ÐšÐ¾Ð» Ð·Ð° ÑÐ»Ð°ÑšÐµ',0),(164961,4583,'vi','Sá»‘ lÆ°á»£ng Ä‘á»ƒ gá»­i',0),(164962,4583,'af','Hoev. om te Stuur',0),(164963,4583,'ro','Cantitate pentru a trimite',0),(164964,4583,'et','Tk saada',0),(164965,4583,'si','KoliÄina za poÅ¡iljanje',0),(164966,4583,'ba','Qty mengirim',0),(164967,4583,'nl','Aantal te verzenden',0),(164968,4583,'fi','MÃ¤Ã¤rÃ¤ lÃ¤hettÃ¤Ã¤',0),(164969,4583,'no','Ant Ã¥ sende',0),(164970,4583,'da','Antal til at sende',0),(164971,4583,'ko','ì†¡ì‹  í•˜ëŠ” ìˆ˜ëŸ‰',0),(164972,4583,'he','×›×ž×•×ª ×©×œ×—',0),(164973,4583,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î³Î¹Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(164974,4583,'zh','å‘é€æ•°é‡\r\n',0),(164975,4583,'sv','Kvt att skicka',0),(164976,4583,'it','Qty per inviare',0),(164977,4583,'tl','',0),(164978,4583,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3648;&#3614;&#3639;&#3656;&#3629;&#3626;&#3656;&#3591;',0),(164979,4583,'hi','à¤­à¥‡à¤œà¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(164980,4583,'ms','Qty menghantar',0),(164981,4583,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø¥Ù„Ù‰ Ø¥Ø±Ø³Ø§Ù„',0),(164982,4583,'fr','QtÃ© Ã  envoyer',0),(164983,4583,'jp','ç™ºé€?æ•°é‡?',0),(164984,4583,'pt','Qty para enviar',0),(164985,4583,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð´Ð»Ñ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(164986,4583,'es','Cant. para Enviar',0),(164987,4583,'de','Qty senden',0),(164988,4583,'en','Qty to Send',0),(164989,4584,'is','',0),(164990,4584,'dr','ØªÙ†Ø¸ÙŠÙ… Ø¨Ø±Ø§ÙŠ Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(164991,4584,'pr','ØªÙ†Ø¸ÙŠÙ… Ø¨Ø±Ø§ÙŠ Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(164992,4584,'tr','VarsayÄ±lan olarak ayarlama',0),(164993,4584,'pl','Zestaw domyÅ›lne',0),(164994,4584,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(164995,4584,'ur','Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(164996,4584,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð·Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸',0),(164997,4584,'vi','Äáº·t Máº·c Ä‘á»‹nh',0),(164998,4584,'af','Stel verstek',0),(164999,4584,'ro','Setat la Default',0),(165000,4584,'et','Vaikimisi seatud',0),(165001,4584,'si','Nastavljena na privzeto',0),(165002,4584,'ba','Diatur ke Default',0),(165003,4584,'nl','Ingesteld op standaard',0),(165004,4584,'fi','Aseta oletusarvoksi',0),(165005,4584,'no','Satt til standard',0),(165006,4584,'da','Indstillet til standard',0),(165007,4584,'ko','ê¸°ë³¸ìœ¼ë¡œ ì„¤ì •',0),(165008,4584,'he','×”×•×’×“×¨ ×›×‘×¨×™×¨×ª ×”×ž×—×“×œ',0),(165009,4584,'el','ÎŸÏÎ¹ÏƒÏ„ÎµÎ¯ ÏƒÎµ Default',0),(165010,4584,'zh','è®¾ç½®ä¸ºé»˜è®¤\r\n',0),(165011,4584,'sv','InstÃ¤lld pÃ¥ standard',0),(165012,4584,'it','Impostazione predefinita',0),(165013,4584,'tl','',0),(165014,4584,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3611;&#3655;&#3609;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(165015,4584,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(165016,4584,'ms','Ditetapkan kepada lalai',0),(165017,4584,'ar','ØªØ¹ÙŠÙŠÙ† Ø¥Ù„Ù‰ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(165018,4584,'fr','La valeur par dÃ©faut',0),(165019,4584,'jp','æ—¢å®šã?«è¨­å®š',0),(165020,4584,'pt','Definida como padrÃ£o',0),(165021,4584,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(165022,4584,'es','Configurar como Predeterminado',0),(165023,4584,'de','Legen Sie auf Standard',0),(165024,4584,'en','Set to Default',0),(165025,4585,'is','',0),(165026,4585,'dr','(Ø´Ø±ÙˆØ¹',0),(165027,4585,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²Ù‰(Ø´Ø±ÙˆØ¹',0),(165028,4585,'tr','BaÅŸlangÄ±Ã§ miktarÄ±',0),(165029,4585,'pl','PoczÄ…tkowa iloÅ›Ä‡',0),(165030,4585,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° ÐºÐ¾Ð»',0),(165031,4585,'ur','Ù‚ÛŒ Ø´Ø±ÙˆØ¹ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(165032,4585,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ ÐšÐ¾Ð».',0),(165033,4585,'vi','Sá»‘ lÆ°á»£ng báº¯t Ä‘áº§u',0),(165034,4585,'af','Begin Hoev.',0),(165035,4585,'ro','Plecare cantit',0),(165036,4585,'et','Alustades tk',0),(165037,4585,'si','ZaÄetna koliÄina',0),(165038,4585,'ba','Mulai Qty',0),(165039,4585,'nl','Aantal starten',0),(165040,4585,'fi','Alkaen mÃ¤Ã¤rÃ¤',0),(165041,4585,'no','Starter Ant',0),(165042,4585,'da','Start Qty',0),(165043,4585,'ko','ì‹œìž‘ ìˆ˜ëŸ‰',0),(165044,4585,'he','×”×—×œ ×›×ž×•×ª',0),(165045,4585,'el','ÎžÎµÎºÎ¹Î½ÏŽÎ½Ï„Î±Ï‚ Qty',0),(165046,4585,'zh','å¼€å§‹æ•°é‡\r\n',0),(165047,4585,'sv','Start Kvt',0),(165048,4585,'it','Q. tÃ  di partenza',0),(165049,4585,'tl','',0),(165050,4585,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(165051,4585,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¶à¥à¤°à¥‚',0),(165052,4585,'ms','Bermula Qty',0),(165053,4585,'ar','Ø§Ù„ÙƒÙ…Ù‘ÙŠØ© Ø§Ù„Ø¥ÙØªØªØ§Ø­ÙŠØ©',0),(165054,4585,'fr','QuantitÃ© de dÃ©part',0),(165055,4585,'jp','é–‹å§‹æ•°é‡?',0),(165056,4585,'pt','Qtde de partida',0),(165057,4585,'ru','ÐÐ°Ñ‡Ð¸Ð½Ð°Ñ ÑˆÑ‚.',0),(165058,4585,'es','Cant. de Inicio',0),(165059,4585,'de','Ab Menge:',0),(165060,4585,'en','Starting Qty',0),(165061,4586,'is','',0),(165062,4586,'dr','ØªÙ…Ø§Ù… Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(165063,4586,'pr','ØªÙ…Ø§Ù… Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(165064,4586,'tr','Bu sipariÅŸ iÃ§in tÃ¼m miktarÄ± sevk',0),(165065,4586,'pl','CaÅ‚a iloÅ›Ä‡ dla tego zamÃ³wienia zostaÅ‚y wysÅ‚ane',0),(165066,4586,'bg','Ð¦ÑÐ»Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ðµ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð°',0),(165067,4586,'ur','Ù¾ÙˆØ±ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(165068,4586,'sr','Ð¦ÐµÐ»Ñƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ Ð¸Ð·Ð²Ñ€ÑˆÐµÐ½',0),(165069,4586,'vi','Táº¥t cáº£ Ä‘Æ¡n hÃ ng nÃ y Ä‘Ã£ chuyá»ƒn',0),(165070,4586,'af','Die totale hoeveelheid vir hierdie bestelling is versend',0),(165071,4586,'ro','Cantitatea totalÄƒ pentru acest ordin a fost expediat',0),(165072,4586,'et','Kogu kogus selle tellimuse veetud',0),(165073,4586,'si','Celotno koliÄino za to naroÄilo je bilo odpremljeno',0),(165074,4586,'ba','Seluruh kuantitas Ordo ini telah dikirimkan',0),(165075,4586,'nl','De gehele hoeveelheid voor deze order is verzonden',0),(165076,4586,'fi','TÃ¤mÃ¤n tilauksen koko mÃ¤Ã¤rÃ¤ on toimitettu',0),(165077,4586,'no','Hele antallet for denne bestillingen er sendt',0),(165078,4586,'da','Det hele antal til denne ordre er blevet afsendt',0),(165079,4586,'ko','ì´ ì£¼ë¬¸ì˜ ì „ì²´ ìˆ˜ëŸ‰ì„ ë°°ì†¡',0),(165080,4586,'he','×”×›×ž×•×ª ×‘×ž×œ×•××” ×¢×‘×•×¨ ×”×–×ž× ×” ×–×• × ×©×œ×—×”',0),(165081,4586,'el','ÎˆÏ‡ÎµÎ¹ Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯ Î¿Î»ÏŒÎºÎ»Î·ÏÎ· Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬',0),(165082,4586,'zh','è¯¥è®¢å•çš„å…¨éƒ¨æ•°é‡å·²å‘è´§\r\n',0),(165083,4586,'sv','Hela kvantiteten fÃ¶r den hÃ¤r ordern har levererats',0),(165084,4586,'it','L\'intero quantitativo per questo ordine Ã¨ stato spedito',0),(165085,4586,'tl','',0),(165086,4586,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3',0),(165087,4586,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤ªà¥‚à¤°à¥à¤£ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(165088,4586,'ms','Kuantiti keseluruhan pesanan telah dihantar',0),(165089,4586,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø´Ø­Ù† Ø§Ù„ÙƒÙ…ÙŠØ© ÙƒØ§Ù…Ù„Ø© Ù„Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(165090,4586,'fr','La totalitÃ© de cette commande a Ã©tÃ© expÃ©diÃ©e',0),(165091,4586,'jp','ã?“ã?®æ³¨æ–‡ã?®å…¨æ•°é‡?ã?Œç™ºé€?ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(165092,4586,'pt','A totalidade da quantidade para esta ordem foi enviada',0),(165093,4586,'ru','Ð’ÑÐµÐ³Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° Ð±Ñ‹Ð»Ð° Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð°',0),(165094,4586,'es','La cantidad entero de este orden se enviÃ³',0),(165095,4586,'de','Die gesamte Menge fÃ¼r diese Bestellung wurde versandt',0),(165096,4586,'en','The entire quantity for this order has been shipped',0),(165097,4587,'is','',0),(165098,4587,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ ',0),(165099,4587,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ ',0),(165100,4587,'tr','GÃ¶ndermek iÃ§in gereken miktar olarak ayarlandÄ±ÄŸÄ±nÄ±',0),(165101,4587,'pl','IloÅ›Ä‡ do wysyÅ‚ania zostaÅ‚a ustawiona na',0),(165102,4587,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð·Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐ½ Ð´Ð°',0),(165103,4587,'ur','Ø¨Ú¾ÛŒØ¬Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ØªØ¹Ø¯Ø§Ø¯ Ø³ÛŒÙ¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Ú©Û’ Ù„Ø¦Û’',0),(165104,4587,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° ÑÐ»Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð° Ñ˜Ðµ Ð½Ð°',0),(165105,4587,'vi','Sá»‘ lÆ°á»£ng Ä‘á»ƒ gá»­i Ä‘Ã£ Ä‘áº·t Ä‘áº¿n',0),(165106,4587,'af','Die hoeveelheid te stuur is opgestel',0),(165107,4587,'ro','Cantitatea de trimite a fost setat la',0),(165108,4587,'et','Saata kogus on seatud',0),(165109,4587,'si','KoliÄino, poÅ¡iljati nastavljena tako,',0),(165110,4587,'ba','Kuantitas untuk mengirim telah ditetapkan untuk',0),(165111,4587,'nl','Het te verzenden aantal is ingesteld op',0),(165112,4587,'fi','MÃ¤Ã¤rÃ¤ lÃ¤hettÃ¤Ã¤ on asetettu',0),(165113,4587,'no','Antallet som skal sende er satt til',0),(165114,4587,'da','MÃ¦ngden til at sende er indstillet til',0),(165115,4587,'ko','ë³´ë‚¼ ìˆ˜ëŸ‰ ì„¤ì • ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(165116,4587,'he','×”×›×ž×•×ª ×œ×©×œ×•×— ×”×•×’×“×¨ ×œ',0),(165117,4587,'el','Î— Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€ÏÎ¿Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ ÏƒÎµ',0),(165118,4587,'zh','è¦å‘é€çš„æ•°é‡å·²è¢«è®¾ç½®åˆ°\r\n',0),(165119,4587,'sv','Kvantiteten som skall skicka har angetts till',0),(165120,4587,'it','La quantitÃ  da inviare Ã¨ stata impostata su',0),(165121,4587,'tl','',0),(165122,4587,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3606;&#3641;&#3585;&#3605;&#3633;&#3657;&#3591;',0),(165123,4587,'hi','à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(165124,4587,'ms','Kuantiti untuk menghantar telah ditetapkan',0),(165125,4587,'ar','ØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ ØªØ±Ø³Ù„ Ø¥Ù„Ù‰',0),(165126,4587,'fr','La quantitÃ© d\'envoyer a la valeur',0),(165127,4587,'jp','ï½žã?«ç™ºé€?æ•°é‡?ã?Œè¨­å®šã?•ã‚Œã?¾ã?—ã?Ÿ',0),(165128,4587,'pt','Foi definida a quantidade a enviar',0),(165129,4587,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð»Ñ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ ÐµÐ¼Ñƒ Ð±Ñ‹Ð»Ð¾ Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½Ð¾',0),(165130,4587,'es','La cantidad para enviar se fijÃ³ a',0),(165131,4587,'de','Die Menge senden wurde zu eingestellt',0),(165132,4587,'en','The quantity to send has been set to',0),(165133,4588,'is','',0),(165134,4588,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ ØªØ¹ÙŠÙŠÙ†  Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ù…Ù‚Ø¯Ø§Ø±',0),(165135,4588,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ ØªØ¹ÙŠÙŠÙ†  Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ù…Ù‚Ø¯Ø§Ø±',0),(165136,4588,'tr','GÃ¶ndermek iÃ§in miktarÄ± kalan miktar iÃ§in ayarla',0),(165137,4588,'pl','IloÅ›Ä‡ do wysyÅ‚ania zostaÅ‚a ustawiona na pozostaÅ‚Ä… iloÅ›Ä‡',0),(165138,4588,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð·Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ðµ Ð±Ð¸Ð»Ð° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐµÐ½Ð° Ð½Ð° Ð¾ÑÑ‚Ð°Ð²Ð°Ñ‰Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(165139,4588,'ur','Ø¨Ú¾ÛŒØ¬Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ØªØ¹Ø¯Ø§Ø¯ Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(165140,4588,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° ÑÐ»Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð° Ñ˜Ðµ Ð½Ð° ÐŸÑ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(165141,4588,'vi','Sá»‘ lÆ°á»£ng Ä‘á»ƒ gá»­i Ä‘Ã£ Ä‘áº·t Ä‘áº¿n sá»‘ lÆ°á»£ng cÃ²n láº¡i',0),(165142,4588,'af','Die hoeveelheid te stuur is opgestel om die hoeveelheid oorblywende',0),(165143,4588,'ro','Cantitatea de trimite a fost setat la cantitatea rÄƒmasÄƒ',0),(165144,4588,'et','Et Ã¼lejÃ¤Ã¤nud koguse mÃ¤Ã¤ratud kogus saata',0),(165145,4588,'si','KoliÄino, poÅ¡iljati nastavljena tako, da koliÄina preostalih',0),(165146,4588,'ba','Kuantitas untuk mengirim telah ditetapkan untuk jumlah sisa',0),(165147,4588,'nl','Het te verzenden aantal is ingesteld op de hoeveelheid resterende',0),(165148,4588,'fi','MÃ¤Ã¤rÃ¤ lÃ¤hettÃ¤Ã¤ on asetettu jÃ¤ljellÃ¤ olevan mÃ¤Ã¤rÃ¤n',0),(165149,4588,'no','Antallet som skal sende er satt til antall gjenstÃ¥ende',0),(165150,4588,'da','MÃ¦ngden til at sende har vÃ¦ret indstillet til restmÃ¦ngden',0),(165151,4588,'ko','ë³´ë‚¼ ìˆ˜ëŸ‰ ìˆ˜ëŸ‰ ë‚¨ì•„ ì„¤ì • ë˜ì–´',0),(165152,4588,'he','×”×›×ž×•×ª ×œ×©×œ×•×— ×”×’×“×™×¨ ××ª ×”×›×ž×•×ª ×”× ×•×ª×¨×ª',0),(165153,4588,'el','Î— Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€ÏÎ¿Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±Ï‚',0),(165154,4588,'zh','è¦å‘é€çš„æ•°é‡å·²è®¾ç½®åˆ°å‰©ä½™æ•°é‡\r\n',0),(165155,4588,'sv','Kvantiteten som skall skicka har angetts till den kvantitet som Ã¥terstÃ¥r',0),(165156,4588,'it','La quantitÃ  da inviare Ã¨ stata impostata la quantitÃ  rimanente',0),(165157,4588,'tl','',0),(165158,4588,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3648;&#3',0),(165159,4588,'hi','à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¶à¥‡à¤· à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(165160,4588,'ms','Kuantiti untuk menghantar telah disetkan untuk baki kuantiti',0),(165161,4588,'ar','ØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø±Ø§Ø¯ Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(165162,4588,'fr','La quantitÃ© d\'envoyer a Ã©tÃ© fixÃ©e Ã  la quantitÃ© restante',0),(165163,4588,'jp','æ®‹æ•°é‡?ã?«ç™ºé€?æ•°é‡?ã?Œè¨­å®šã?•ã‚Œã?¾ã?—ã?Ÿ',0),(165164,4588,'pt','A quantidade a enviar foi definida como a quantidade restante',0),(165165,4588,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð»Ñ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ ÐµÐ¼Ñƒ Ð±Ñ‹Ð»Ð¾ Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾ÑÑ‚Ð°Ð²ÑˆÐ¸Ñ…ÑÑ',0),(165166,4588,'es','La Cantidad para enviar se fijÃ³ a la cantidad restante',0),(165167,4588,'de','Die Menge senden auf die Menge verbleibenden eingestellt',0),(165168,4588,'en','The quantity to send has been set to the quantity remaining',0),(165169,4589,'is','',0),(165170,4589,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ ØªØ¹ÙŠÙŠÙ†  Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ ØµÙØ±',0),(165171,4589,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ ØªØ¹ÙŠÙŠÙ†  Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ ØµÙØ±',0),(165172,4589,'tr','GÃ¶nderilecek miktar sÄ±fÄ±r olarak ayarlayÄ±n',0),(165173,4589,'pl','IloÅ›Ä‡ do wysyÅ‚ania zostaÅ‚a ustawiona na zero',0),(165174,4589,'bg','Ð• ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐµÐ½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð½ÑƒÐ»Ð°',0),(165175,4589,'ur','ØµÙØ± Ú©Ùˆ Ø¨Ú¾ÛŒØ¬Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ØªØ¹Ø¯Ø§Ø¯ Ø³ÛŒÙ¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(165176,4589,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° ÑÐ»Ð°ÑšÐµ Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð° Ð½Ð° Ð½ÑƒÐ»Ñƒ',0),(165177,4589,'vi','Sá»‘ lÆ°á»£ng Ä‘á»ƒ gá»­i Ä‘Ã£ Ä‘áº·t Ä‘áº¿n 0',0),(165178,4589,'af','Die hoeveelheid te stuur is opgestel na nul',0),(165179,4589,'ro','Cantitatea de trimite a fost setat la zero',0),(165180,4589,'et','Saata kogus on null',0),(165181,4589,'si','KoliÄino, poÅ¡iljati je bila nastavljena na niÄ',0),(165182,4589,'ba','Kuantitas untuk mengirim telah ditetapkan ke nol',0),(165183,4589,'nl','Het te verzenden aantal is ingesteld op nul',0),(165184,4589,'fi','MÃ¤Ã¤rÃ¤ lÃ¤hettÃ¤Ã¤ arvoksi nolla',0),(165185,4589,'no','Antallet som skal sende er satt til null',0),(165186,4589,'da','MÃ¦ngde til send er angivet til nul',0),(165187,4589,'ko','ë³´ë‚¼ ìˆ˜ëŸ‰ 0ìœ¼ë¡œ ì„¤ì • ë˜ì–´',0),(165188,4589,'he','×”×›×ž×•×ª ×œ×©×œ×•×— ×”×•×’×“×¨ ×œ××¤×¡',0),(165189,4589,'el','Î— Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€ÏÎ¿Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ ÏƒÎµ Î¼Î·Î´Î­Î½',0),(165190,4589,'zh','å‘é€çš„æ•°é‡å·²è®¾ç½®ä¸ºé›¶\r\n',0),(165191,4589,'sv','Kvantiteten som skall skicka har angetts till noll',0),(165192,4589,'it','La quantitÃ  da inviare Ã¨ stata impostata a zero',0),(165193,4589,'tl','',0),(165194,4589,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3606;&#3641;&#3585;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3648;&#3611;&#3655;&#3609;&#3624;&#3641;&#3609;&#3618;&#3660;',0),(165195,4589,'hi','à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¶à¥‚à¤¨à¥à¤¯ à¤ªà¤° à¤¸à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(165196,4589,'ms','Kuantiti untuk menghantar telah disetkan untuk sifar',0),(165197,4589,'ar','ØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ ØªØ±Ø³Ù„ Ø¥Ù„Ù‰ Ø§Ù„ØµÙØ±',0),(165198,4589,'fr','La quantitÃ© d\'envoyer a la valeur zÃ©ro',0),(165199,4589,'jp','ç™ºé€?æ•°é‡?ã?Œã‚¼ãƒ­ã?«è¨­å®šã?•ã‚Œã?¾ã?—ã?Ÿ',0),(165200,4589,'pt','A quantidade a enviar foi definida como zero',0),(165201,4589,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð»Ñ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ Ð±Ñ‹Ð»Ð¾ Ñ€Ð°Ð²Ð½Ñ‹Ð¼ Ð½ÑƒÐ»ÑŽ',0),(165202,4589,'es','La Cantidad para enviar se fijÃ³ a cero',0),(165203,4589,'de','Die Menge senden wurde auf NULL gesetzt',0),(165204,4589,'en','The quantity to send has been set to zero',0),(165205,4590,'is','',0),(165206,4590,'dr','(Ø´Ø§Ø®ØµÙŠ) ÙƒÙ‡ Ø´Ù…Ø§ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(165207,4590,'pr','Ù…Ù‚Ø¯Ø§Ø±ÙŠ(Ø´Ø§Ø®ØµÙŠ) ÙƒÙ‡ Ø´Ù…Ø§ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(165208,4590,'tr','GirdiÄŸiniz deÄŸer',0),(165209,4590,'pl','Wprowadzona wartoÅ›Ä‡',0),(165210,4590,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ñ‚Ð°, ÐºÐ¾ÑÑ‚Ð¾ Ð²ÑŠÐ²ÐµÐ´Ð¾Ñ…Ñ‚Ðµ',0),(165211,4590,'ur','Ø¢Ù¾ Ú©ÛŒ Ø¯Ø§Ø®Ù„ Ú©Ø±Ø¯Û Ù‚Ø¯Ø±',0),(165212,4590,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ ÐºÐ¾Ñ˜Ñƒ ÑÑ‚Ðµ ÑƒÐ½ÐµÐ»Ð¸',0),(165213,4590,'vi','GiÃ¡ trá»‹ báº¡n nháº­p ',0),(165214,4590,'af','Die waarde wat u ingevoer het',0),(165215,4590,'ro','Valoarea introdusÄƒ',0),(165216,4590,'et','Sisestatud vÃ¤Ã¤rtus',0),(165217,4590,'si','Vnesena vrednost',0),(165218,4590,'ba','Value yang kamu masukkan',0),(165219,4590,'nl','De waarde die u hebt ingevoerd',0),(165220,4590,'fi','Antamasi arvo',0),(165221,4590,'no','Verdien du har angitt',0),(165222,4590,'da','Den indtastede vÃ¦rdi',0),(165223,4590,'ko','ìž…ë ¥ í•œ ê°’',0),(165224,4590,'he','×”×¢×¨×š ×©×”×–× ×ª',0),(165225,4590,'el','Î— Ï„Î¹Î¼Î® Ï€Î¿Ï… Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÎ±Ï„Îµ',0),(165226,4590,'zh','æ‚¨è¾“å…¥çš„å€¼\r\n',0),(165227,4590,'sv','VÃ¤rdet pÃ¥',0),(165228,4590,'it','Il valore immesso',0),(165229,4590,'tl','',0),(165230,4590,'th','&#3588;&#3656;&#3634;&#3607;&#3637;&#3656;&#3588;&#3640;&#3603;&#3605;&#3585;&#3621;&#3591;',0),(165231,4590,'hi','à¤†à¤ªà¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¦à¤°à¥à¤œ à¤®à¤¾à¤¨',0),(165232,4590,'ms','Nilai yang anda masukkan',0),(165233,4590,'ar','Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„ØªÙŠ Ø£Ø¯Ø®Ù„ØªÙ‡Ø§',0),(165234,4590,'fr','La valeur entrÃ©e',0),(165235,4590,'jp','å…¥åŠ›ã?•ã‚Œã?Ÿä¾¡å€¤',0),(165236,4590,'pt','O valor que vocÃª inseriu',0),(165237,4590,'ru','Ð’Ð²ÐµÐ´ÐµÐ½Ð½Ð¾Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(165238,4590,'es','El valor que entrÃ³',0),(165239,4590,'de','Die von den Ihnen eingegebene Wert',0),(165240,4590,'en','The value you entered',0),(165241,4591,'is','',0),(165242,4591,'dr','(Ø§Ø±Ø³Ø§Ù„ ) Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(165243,4591,'pr','Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø¯Ø±Ø³Øª Ø­Ù…Ù„ (Ø§Ø±Ø³Ø§Ù„ ) Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(165244,4591,'tr','SipariÅŸiniz doÄŸru verilmemiÅŸ',0),(165245,4591,'pl','ZamÃ³wienia nie statek poprawnie',0),(165246,4591,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ðµ Ðµ ÐºÐ¾Ñ€Ð°Ð± Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¾',0),(165247,4591,'ur','Ø¢Ù¾ Ú©Ø§ Ø¢Ø±ÚˆØ± ØµØ­ÛŒØ­ Ø·ÙˆØ± Ù¾Ø± Ø¬ÛØ§Ø² Ù†ÛÛŒÚº Ú©ÛŒØ§',0),(165248,4591,'sr','Ð¢Ð²Ð¾Ñ˜ Ñ€ÐµÐ´ Ð´Ð° Ð»Ð¸ ÑÐµ Ð½ÐµÑ›Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°Ñ‚Ð¸ Ð¸ÑÐ¿Ñ€Ð°Ð²Ð½Ð¾',0),(165249,4591,'vi','ÄÆ¡n hÃ ng cá»§a báº¡n khÃ´ng chuyá»ƒn Ä‘Ãºng',0),(165250,4591,'af','Daar het \'n fout ingesluit met die VERSENDING van u bestelling.',0),(165251,4591,'ro','Comanda dumneavoastra nu a fost expediata corect',0),(165252,4591,'et','Your order did not ship correctly',0),(165253,4591,'si','VaÅ¡e naroÄilo ni storil pravilno ladja',0),(165254,4591,'ba','Pesanan Anda tidak kapal dengan benar',0),(165255,4591,'nl','Uw bestelling hebt niet correct verzonden',0),(165256,4591,'fi','Tilauksesi ei toimitettu oikein',0),(165257,4591,'no','Bestillingen leveres ikke riktig',0),(165258,4591,'da','Din ordre ikke blev leveret korrekt',0),(165259,4591,'ko','ì£¼ë¬¸ ì œëŒ€ë¡œ ì œê³µ ë˜ì§€ ì•Šì•˜ë‹¤',0),(165260,4591,'he','×”×”×–×ž× ×” ×©×œ×š ×œ× ×ª×¡×•×¤×§ ×›×¨××•×™',0),(165261,4591,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÎ±Ï‚ Î´ÎµÎ½ ÏƒÏ‰ÏƒÏ„Î¬ Ï€Î»Î¿Î¯Î¿',0),(165262,4591,'zh','æ‚¨çš„è®¢å•è¿é€ä¸æ­£ç¡®\r\n',0),(165263,4591,'sv','Din order har inte levereras korrekt',0),(165264,4591,'it','L\'ordine non ha fatto spedire correttamente',0),(165265,4591,'tl','',0),(165266,4591,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3629;&#3618;&#3656;&#3634;&#3591;&#3606;&#3641;&#3',0),(165267,4591,'hi','à¤…à¤ªà¤¨à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¸à¤¹à¥€ à¤¢à¤‚à¤— à¤¸à¥‡ à¤œà¤¹à¤¾à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾',0),(165268,4591,'ms','Pesanan anda pula kapal dengan betul',0),(165269,4591,'ar','Ù„Ù… ØªÙ‚Ù… Ø¨Ø´Ø­Ù† Ø·Ù„Ø¨Ùƒ Ø¨Ø´ÙƒÙ„ ØµØ­ÙŠØ­',0),(165270,4591,'fr','Votre commande ne pas livrÃ© correctement',0),(165271,4591,'jp','æ³¨æ–‡ã?Œæ­£ã?—ã??ç™ºé€?ã?•ã‚Œã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(165272,4591,'pt','Sua ordem nÃ£o enviar corretamente',0),(165273,4591,'ru','Ð’Ð°Ñˆ Ð·Ð°ÐºÐ°Ð· Ð½Ðµ ÑÐ´ÐµÐ»Ð°Ð» ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿Ñ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ð¾',0),(165274,4591,'es','Su pedido no se despacho correctamente',0),(165275,4591,'de','Ihre Bestellung wurde korrekt geliefert',0),(165276,4591,'en','Your order did not ship correctly',0),(165277,4592,'is','',0),(165278,4592,'dr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(165279,4592,'pr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(165280,4592,'tr','FiyatlandÄ±rma',0),(165281,4592,'pl','Ceny',0),(165282,4592,'bg','Ð¦ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(165283,4592,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(165284,4592,'sr','Ð¦ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(165285,4592,'vi','GiÃ¡',0),(165286,4592,'af','Pryse',0),(165287,4592,'ro','De stabilire a preÅ£urilor',0),(165288,4592,'et','Hinnakujundus',0),(165289,4592,'si','Cenitev',0),(165290,4592,'ba','Harga',0),(165291,4592,'nl','Prijzen',0),(165292,4592,'fi','Hinnoittelu',0),(165293,4592,'no','Priser',0),(165294,4592,'da','PrissÃ¦tning',0),(165295,4592,'ko','ê°€ê²©',0),(165296,4592,'he','×ª×ž×—×•×¨',0),(165297,4592,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(165298,4592,'zh','å®šä»·\r\n',0),(165299,4592,'sv','PrissÃ¤ttning',0),(165300,4592,'it','Prezzi',0),(165301,4592,'tl','',0),(165302,4592,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;',0),(165303,4592,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(165304,4592,'ms','Harga',0),(165305,4592,'ar','Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(165306,4592,'fr','Tarification',0),(165307,4592,'jp','ä¾¡æ ¼è¨­å®š',0),(165308,4592,'pt','PreÃ§os',0),(165309,4592,'ru','Ð¦ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(165310,4592,'es','FijaciÃ³n de Precios',0),(165311,4592,'de','Preise',0),(165312,4592,'en','Pricing',0),(165313,4593,'is','',0),(165314,4593,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(165315,4593,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(165316,4593,'tr','Hisse senedi bilgileri',0),(165317,4593,'pl','PieÅ„ szczegÃ³Å‚y',0),(165318,4593,'bg','Ð‘Ð¾Ñ€ÑÐ¾Ð²Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(165319,4593,'ur','Ø³Ù¹Ø§Ú© Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(165320,4593,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(165321,4593,'vi','Chi tiáº¿t HÃ ng tá»“n',0),(165322,4593,'af','Voorraad Details',0),(165323,4593,'ro','Detalii stoc',0),(165324,4593,'et','Varude andmetel',0),(165325,4593,'si','Zalog podrobnosti',0),(165326,4593,'ba','Informasi stok',0),(165327,4593,'nl','Voorraad Details',0),(165328,4593,'fi','Kaluston',0),(165329,4593,'no','Lager detaljer',0),(165330,4593,'da','Stock detaljer',0),(165331,4593,'ko','ì£¼ì‹ ì •ë³´',0),(165332,4593,'he','×ž×œ××™ ×¤×¨×˜×™×',0),(165333,4593,'el','Î‘Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(165334,4593,'zh','è‚¡ç¥¨è¯¦ç»†\r\n',0),(165335,4593,'sv','Lager Detaljer',0),(165336,4593,'it','Dettagli magazzino',0),(165337,4593,'tl','',0),(165338,4593,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(165339,4593,'hi','à¤¶à¥‡à¤¯à¤° à¤µà¤¿à¤µà¤°à¤£',0),(165340,4593,'ms','Stok butir-butir',0),(165341,4593,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø£Ø³Ù‡Ù…',0),(165342,4593,'fr','DÃ©tails de stock',0),(165343,4593,'jp','åœ¨åº«è©³ç´°',0),(165344,4593,'pt','Detalhes das aÃ§Ãµes',0),(165345,4593,'ru','Ð‘Ð¸Ñ€Ð¶ÐµÐ²Ñ‹Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(165346,4593,'es','Deatalles de Stock',0),(165347,4593,'de','Hat Informationen',0),(165348,4593,'en','Stock Details',0),(165349,4594,'is','',0),(165350,4594,'dr','Ø¨Ø±Ø±Ø³ÙŠ ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù†',0),(165351,4594,'pr','Ø¨Ø±Ø±Ø³ÙŠ ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù†',0),(165352,4594,'tr','Fatura edilecek tÃ¼m sipariÅŸlerini denetleme',0),(165353,4594,'pl','SprawdÅº wszystkie zamÃ³wienia do zafakturowania',0),(165354,4594,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(165355,4594,'ur','Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ø¬Ø§ Ù„ÛŒÛ’ Ú©Û’ ØªÙ…Ø§Ù… Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(165356,4594,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ²Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(165357,4594,'vi','Kiá»ƒm tra táº¥t cáº£ Ä‘Æ¡n Ä‘áº·t hÃ ng sáº½ xuáº¥t hÃ³a Ä‘Æ¡n',0),(165358,4594,'af','Nasien van Alle Bestellings om Gefaktureer te word',0),(165359,4594,'ro','Verifica toate comenzile sÄƒ fie facturate',0),(165360,4594,'et','MÃ¤rgi kÃµik tellimused arvete vormistamiseks',0),(165361,4594,'si','Preverite vsa naroÄila za fakturiranje',0),(165362,4594,'ba','Cek Semua Pesanan yang akan di buat Faktur',0),(165363,4594,'nl','Alle bestellingen worden gefactureerd bekijken',0),(165364,4594,'fi','Tarkista kaikkien tilausten laskutettavaksi',0),(165365,4594,'no','Sjekk alle bestillinger som skal faktureres',0),(165366,4594,'da','Check alle ordrer skal faktureres',0),(165367,4594,'ko','ëª¨ë“  ì£¼ë¬¸ ì²­êµ¬ í™•ì¸',0),(165368,4594,'he','×œ×‘×“×•×§ ××ª ×›×œ ×”×”×–×ž× ×•×ª ×œ×”× ×¤×§×ª ×—×©×‘×•× ×™×ª',0),(165369,4594,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î¸Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î·Î¸Î¿ÏÎ½',0),(165370,4594,'zh','æ£€æŸ¥æ‰€æœ‰è®¢å•å¼€å‘ç¥¨\r\n',0),(165371,4594,'sv','Kontrollera alla order som ska faktureras',0),(165372,4594,'it','Controllare tutti gli ordini da fatturare',0),(165373,4594,'tl','',0),(165374,4594,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3649;&#3621;&#3657;&#3623;&#3629;&#3629;&#3585;&#3651;&#3610;&#3649;&#3592;&#3657;&#3',0),(165375,4594,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(165376,4594,'ms','Semak semua pesanan untuk dapat invois',0),(165377,4594,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† \"ÙƒØ§ÙØ© Ø£ÙˆØ§Ù…Ø±\" Ù„Ù„ÙÙˆØªØ±Ø©',0),(165378,4594,'fr','VÃ©rifier toutes les commandes Ã  facturer',0),(165379,4594,'jp','è«‹æ±‚ã?™ã‚‹å…¨ã?¦ã?®æ³¨æ–‡ã‚’ç¢ºèª?ã?™ã‚‹',0),(165380,4594,'pt','Verifique todas as ordens para ser faturado',0),(165381,4594,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ðº Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐµ',0),(165382,4594,'es','Chequear Todos los Pedidos que serÃ¡n Facturados',0),(165383,4594,'de','ÃœberprÃ¼fen Sie alle Bestellungen zu fakturierende',0),(165384,4594,'en','Check All Orders to be Invoiced',0),(165385,4595,'is','',0),(165386,4595,'dr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† ØªØ§Ø±ÙŠØ®',0),(165387,4595,'pr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† ØªØ§Ø±ÙŠØ®',0),(165388,4595,'tr','Tam bir Tarih',0),(165389,4595,'pl','PeÅ‚na Data',0),(165390,4595,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð°Ñ‚Ð°',0),(165391,4595,'ur','ØªØ§Ø±ÛŒØ® Ù…Ú©Ù…Ù„',0),(165392,4595,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð´Ð¾Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(165393,4595,'vi','NgÃ y hoÃ n thÃ nh',0),(165394,4595,'af','Voltooide Datum',0),(165395,4595,'ro','Data completÄƒ',0),(165396,4595,'et','LÃµpetatud kuupÃ¤ev',0),(165397,4595,'si','Celotni datum',0),(165398,4595,'ba','Tanggal lengkap',0),(165399,4595,'nl','Datum voltooid',0),(165400,4595,'fi','TÃ¤ydellinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(165401,4595,'no','FullfÃ¸rt dato',0),(165402,4595,'da','Komplet dato',0),(165403,4595,'ko','ì™„ì „ í•œ ë‚ ì§œ',0),(165404,4595,'he','×œ×”×©×œ×™× ××ª ×”×ª××¨×™×š',0),(165405,4595,'el','Î Î»Î®ÏÎ·Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(165406,4595,'zh','å®Œæˆçš„æ—¥æœŸ\r\n',0),(165407,4595,'sv','Komplett datum',0),(165408,4595,'it','Data completa',0),(165409,4595,'tl','',0),(165410,4595,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(165411,4595,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(165412,4595,'ms','Tarikh selesai',0),(165413,4595,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ø¨Ø§Ù„ÙƒØ§Ù…Ù„',0),(165414,4595,'fr','Date complÃ¨te',0),(165415,4595,'jp','å®Œäº†æ—¥',0),(165416,4595,'pt','Data completa',0),(165417,4595,'ru','ÐŸÐ¾Ð»Ð½Ð°Ñ Ð´Ð°Ñ‚Ð°',0),(165418,4595,'es','Completar Fecha',0),(165419,4595,'de','VollstÃ¤ndiges Datum',0),(165420,4595,'en','Complete Date',0),(165421,4596,'is','',0),(165422,4596,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(165423,4596,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(165424,4596,'tr','Bir daha gÃ¶zden geÃ§irme',0),(165425,4596,'pl','PrzeglÄ…d',0),(165426,4596,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´',0),(165427,4596,'ur','Ú©Ø§ Ø¬Ø§Ø¦Ø²Û',0),(165428,4596,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´',0),(165429,4596,'vi','ÄÃ¡nh giÃ¡',0),(165430,4596,'af','Hersiening',0),(165431,4596,'ro','Revizuire',0),(165432,4596,'et','Ãœlevaade',0),(165433,4596,'si','Pregled',0),(165434,4596,'ba','Tinjauan',0),(165435,4596,'nl','Beoordeling',0),(165436,4596,'fi','Review',0),(165437,4596,'no','Gjennomgang',0),(165438,4596,'da','Anmeldelse',0),(165439,4596,'ko','ê²€í† ',0),(165440,4596,'he','×¡×§×™×¨×”',0),(165441,4596,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(165442,4596,'zh','å¤å®¡\r\n',0),(165443,4596,'sv','Recension',0),(165444,4596,'it','Recensione',0),(165445,4596,'tl','',0),(165446,4596,'th','&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;',0),(165447,4596,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(165448,4596,'ms','Kajian semula',0),(165449,4596,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶',0),(165450,4596,'fr','Examen',0),(165451,4596,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼',0),(165452,4596,'pt','RevisÃ£o',0),(165453,4596,'ru','ÐžÐ±Ð·Ð¾Ñ€',0),(165454,4596,'es','Revisar',0),(165455,4596,'de','Bewertung',0),(165456,4596,'en','Review',0),(165457,4597,'is','',0),(165458,4597,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§',0),(165459,4597,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§',0),(165460,4597,'tr','Vergiler',0),(165461,4597,'pl','Podatki',0),(165462,4597,'bg','Ð”Ð°Ð½ÑŠÑ†Ð¸',0),(165463,4597,'ur','Ù¹ÛŒÚ©Ø³',0),(165464,4597,'sr','ÐŸÐ¾Ñ€ÐµÐ·Ð¸',0),(165465,4597,'vi','Thuáº¿',0),(165466,4597,'af','Belastings',0),(165467,4597,'ro','Impozitele',0),(165468,4597,'et','Maksud',0),(165469,4597,'si','Davki',0),(165470,4597,'ba','Pajak',0),(165471,4597,'nl','Belastingen',0),(165472,4597,'fi','Verot',0),(165473,4597,'no','Skatt',0),(165474,4597,'da','Skatter',0),(165475,4597,'ko','ì„¸ê¸ˆ',0),(165476,4597,'he','×ž×™×¡×™×',0),(165477,4597,'el','Î¤Î¿Ï…Ï‚ Ï†ÏŒÏÎ¿Ï…Ï‚',0),(165478,4597,'zh','ç¨Ž\r\n',0),(165479,4597,'sv','Skatter',0),(165480,4597,'it','Tasse',0),(165481,4597,'tl','',0),(165482,4597,'th','&#3616;&#3634;&#3625;&#3637;',0),(165483,4597,'hi','à¤•à¤°à¥‹à¤‚',0),(165484,4597,'ms','Cukai',0),(165485,4597,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(165486,4597,'fr','Taxes',0),(165487,4597,'jp','ç¨Ž',0),(165488,4597,'pt','Impostos',0),(165489,4597,'ru','ÐÐ°Ð»Ð¾Ð³Ð¸',0),(165490,4597,'es','Impuestos',0),(165491,4597,'de','Steuern',0),(165492,4597,'en','Taxes',0),(165493,4598,'is','',0),(165494,4598,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø²ÙŠØ± ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù‡ Ø¨ÙˆØ¯Ù†Ø¯',0),(165495,4598,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø²ÙŠØ± ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù‡ Ø¨ÙˆØ¯Ù†Ø¯',0),(165496,4598,'tr','AÅŸaÄŸÄ±daki sipariÅŸleri faturalanmÄ±ÅŸ',0),(165497,4598,'pl','NastÄ™pujÄ…ce zamÃ³wienia zostaÅ‚y zafakturowane',0),(165498,4598,'bg','Ð¡Ð»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸Ñ‚Ðµ ÑÐ° Ð±Ð¸Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(165499,4598,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ ØªÚ¾Û’',0),(165500,4598,'sr','ÐžÐ²Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ ÑÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð¸.',0),(165501,4598,'vi','Nhá»¯ng Ä‘Æ¡n hÃ ng sau Ä‘Ã£ ra hÃ³a Ä‘Æ¡n',0),(165502,4598,'af','Die volgende Bestellings is Gefaktureer',0),(165503,4598,'ro','Comenzile urmÄƒtoare au fost facturate',0),(165504,4598,'et','Esitati jÃ¤rgmised korraldused',0),(165505,4598,'si','So bili naslednji nalogi fakturirani',0),(165506,4598,'ba','Perintah berikut yang ditagih',0),(165507,4598,'nl','De volgende Orders waren gefactureerd',0),(165508,4598,'fi','Seuraavat laskutettiin',0),(165509,4598,'no','FÃ¸lgende bestillinger er fakturert',0),(165510,4598,'da','De fÃ¸lgende ordrer blev faktureret',0),(165511,4598,'ko','ë‹¤ìŒ ëª…ë ¹ì€ ì²­êµ¬ í–ˆë‹¤',0),(165512,4598,'he','×”×¦×•×•×™× ×”×‘××™× ×”×™×• ×©×—×•×™×‘×•',0),(165513,4598,'el','ÎŸÎ¹ Î±ÎºÏŒÎ»Î¿Ï…Î¸ÎµÏ‚ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î®Î¸Î·ÎºÎ±Î½',0),(165514,4598,'zh','ä»¥ä¸‹è®¢å•å·²ç»å¼€å…·å‘ç¥¨\r\n',0),(165515,4598,'sv','FÃ¶ljande order fakturerades',0),(165516,4598,'it','I seguenti ordini sono stati fatturati',0),(165517,4598,'tl','',0),(165518,4598,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3656;&#3629;&#3652;&#3611;&#3609;&#3637;&#3657;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(165519,4598,'hi','à¤¨à¤¿à¤®à¥à¤¨ à¤†à¤¦à¥‡à¤¶ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(165520,4598,'ms','Perintah-perintah berikut telah invois',0),(165521,4598,'ar','ØªÙ… ÙÙˆØªØ±Ø© \"Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„ØªØ§Ù„ÙŠØ©\"',0),(165522,4598,'fr','Les commandes suivantes sont facturÃ©es',0),(165523,4598,'jp','æ¬¡ã?®æ³¨æ–‡ã?¯è«‹æ±‚æ¸ˆã?§ã?™',0),(165524,4598,'pt','As seguintes ordens foram facturadas',0),(165525,4598,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð¾Ñ€Ð´ÐµÑ€Ð° Ð±Ñ‹Ð»Ð¸ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ñ‹ ÑÑ‡ÐµÑ‚Ð°',0),(165526,4598,'es','Los siguentes ordenes se Facturaron',0),(165527,4598,'de','Folgende AuftrÃ¤ge wurden in Rechnung gestellt',0),(165528,4598,'en','The Following Orders were Invoiced',0),(165529,4599,'is','',0),(165530,4599,'dr','Ø²ÛŒØ± Ù†ÙˆÛŒØ³ Ø§Ø®ØªØµØ§Ø±ÛŒ',0),(165531,4599,'pr','Ø²ÛŒØ± Ù†ÙˆÛŒØ³ Ø§Ø®ØªØµØ§Ø±ÛŒ',0),(165532,4599,'tr','KÄ±saltma efsane',0),(165533,4599,'pl','SkrÃ³t legendy',0),(165534,4599,'bg','Ð¡ÑŠÐºÑ€Ð°Ñ‰ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð»ÐµÐ³ÐµÐ½Ð´Ð°',0),(165535,4599,'ur','Ù…Ø®ØªØµØ± Ø¨ÛŒØ§Ù†  ',0),(165536,4599,'sr','Ð›ÐµÐ³ÐµÐ½Ð´Ð° ÑÐºÑ€Ð°Ñ›ÐµÐ½Ð¸Ñ†Ð°',0),(165537,4599,'vi','Diá»…n Giáº£i Viáº¿t Táº¯t',0),(165538,4599,'af','Afkorting',0),(165539,4599,'ro','Legenda Abrevieri',0),(165540,4599,'et','LÃ¼hend Legend',0),(165541,4599,'si','Kratica legenda',0),(165542,4599,'ba','Daftar Singkatan',0),(165543,4599,'nl','Afkorting legenda',0),(165544,4599,'fi','Lyhenne selitys',0),(165545,4599,'no','Forkortelsen legende',0),(165546,4599,'da','Forkortelsen legende',0),(165547,4599,'ko','ì•½ì–´ ì „ì„¤',0),(165548,4599,'he','×§×™×¦×•×¨ ×ž×§×¨×',0),(165549,4599,'el','Î£Ï…Î½Ï„Î¿Î¼Î¿Î³ÏÎ±Ï†Î¯Î± Î¸ÏÏÎ»Î¿Ï‚',0),(165550,4599,'zh','ç¼©å†™ä¼ å¥‡\r\n',0),(165551,4599,'sv','Beskrivn. fÃ¶rokortningar',0),(165552,4599,'it','Legenda Abbreviazioni',0),(165553,4599,'tl','',0),(165554,4599,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3588;&#3635;&#3618;&#3656;&#3629;',0),(165555,4599,'hi','à¤¸à¤‚à¤•à¥à¤·à¤¿à¤ªà¥à¤¤ à¤•à¤¥à¤¾',0),(165556,4599,'ms','Singkatan lagenda',0),(165557,4599,'ar','Ø£Ø³Ø·ÙˆØ±Ø© Ø§Ø®ØªØµØ§Ø±',0),(165558,4599,'fr','LÃ©gende d\'abrÃ©viation',0),(165559,4599,'jp','çœ?ç•¥å½¢èª¬æ˜Žæ–‡',0),(165560,4599,'pt','Lenda de abreviatura',0),(165561,4599,'ru','ÐÐ±Ð±Ñ€ÐµÐ²Ð¸Ð°Ñ‚ÑƒÑ€Ð° Ð»ÐµÐ³ÐµÐ½Ð´Ð°',0),(165562,4599,'es','Leyenda Abreviatura',0),(165563,4599,'de','AbkÃ¼rzung-Legende',0),(165564,4599,'en','Abbreviation Legend',0),(165565,4600,'is','',0),(165566,4600,'dr','Ø¢Ø¨ÙŠ',0),(165567,4600,'pr','Ø¢Ø¨ÙŠ',0),(165568,4600,'tr','Mavi',0),(165569,4600,'pl','Niebieski',0),(165570,4600,'bg','Ð¡Ð¸Ð½',0),(165571,4600,'ur','Ø¨Ù„ÛŒÙˆ',0),(165572,4600,'sr','ÐŸÐ»Ð°Ð²Ð¸',0),(165573,4600,'vi','Xanh',0),(165574,4600,'af','Blou',0),(165575,4600,'ro','Albastru',0),(165576,4600,'et','Sinine',0),(165577,4600,'si','Modra',0),(165578,4600,'ba','Biru',0),(165579,4600,'nl','Blauw',0),(165580,4600,'fi','Sininen',0),(165581,4600,'no','BlÃ¥',0),(165582,4600,'da','BlÃ¥',0),(165583,4600,'ko','ë¸”ë£¨',0),(165584,4600,'he','×›×—×•×œ',0),(165585,4600,'el','ÎœÏ€Î»Îµ',0),(165586,4600,'zh','è“\r\n',0),(165587,4600,'sv','BlÃ¥',0),(165588,4600,'it','Blu',0),(165589,4600,'tl','',0),(165590,4600,'th','&#3626;&#3637;&#3615;&#3657;&#3634;',0),(165591,4600,'hi','à¤¬à¥à¤²à¥‚',0),(165592,4600,'ms','Biru',0),(165593,4600,'ar','Ø§Ø²Ø±Ù‚',0),(165594,4600,'fr','Bleu',0),(165595,4600,'jp','é?’',0),(165596,4600,'pt','Azul',0),(165597,4600,'ru','Ð¡Ð¸Ð½Ð¸Ð¹',0),(165598,4600,'es','Azul',0),(165599,4600,'de','Blau',0),(165600,4600,'en','Blue',0),(165601,4601,'is','',0),(165602,4601,'dr','Ù…Ø±Ø§Ø­Ù„ Ø§Ø¬Ø±Ø§',0),(165603,4601,'pr','Ù…Ø±Ø§Ø­Ù„ Ø§Ø¬Ø±Ø§',0),(165604,4601,'tr','Tamamlanma adÄ±mlarÄ±nÄ±',0),(165605,4601,'pl','ZakoÅ„czenie krokÃ³w',0),(165606,4601,'bg','Ð¤Ð¸Ð½Ð°Ð»Ð½Ð¸ ÐµÑ‚Ð°Ð¿Ð¸',0),(165607,4601,'ur','ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ù…Ø±Ø§Ø­Ù„',0),(165608,4601,'sr','Ð—Ð°Ð²Ñ€ÑˆÐµÑ‚Ð°Ðº ÐºÐ¾Ñ€Ð°ÐºÐµ',0),(165609,4601,'vi','CÃ¡c bÆ°á»›c hoÃ n thÃ nh',0),(165610,4601,'af','Voltooiing stappe',0),(165611,4601,'ro','Finalizarea paÅŸii',0),(165612,4601,'et','TÃ¤itmise juhised',0),(165613,4601,'si','DokonÄanju korakov',0),(165614,4601,'ba','Selesai langkah',0),(165615,4601,'nl','Voltooiing stappen',0),(165616,4601,'fi','PÃ¤Ã¤tÃ¶kseen vaiheet',0),(165617,4601,'no','FullfÃ¸rt trinnene',0),(165618,4601,'da','Afsluttet trin',0),(165619,4601,'ko','ì™„ë£Œ ë‹¨ê³„',0),(165620,4601,'he','×”×©×œ×ž×ª ×©×œ×‘×™×',0),(165621,4601,'el','ÎŸÎ»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ· Î²Î®Î¼Î±Ï„Î±',0),(165622,4601,'zh','å®Œæˆæ­¥éª¤\r\n',0),(165623,4601,'sv','Avslutad steg',0),(165624,4601,'it','Completamento procedura',0),(165625,4601,'tl','',0),(165626,4601,'th','&#3586;&#3633;&#3657;&#3609;&#3605;&#3629;&#3609;&#3607;&#3637;&#3656;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(165627,4601,'hi','à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹à¤¨à¥‡ à¤•à¥‡ à¤šà¤°à¤£à¥‹à¤‚',0),(165628,4601,'ms','Langkah-langkah penyelesaian',0),(165629,4601,'ar','Ø§Ø³ØªÙƒÙ…Ø§Ù„ Ø§Ù„Ø®Ø·ÙˆØ§Øª',0),(165630,4601,'fr','Ã‰tapes de rÃ©alisation',0),(165631,4601,'jp','å®Œäº†æ‰‹é †',0),(165632,4601,'pt','Etapas de conclusÃ£o',0),(165633,4601,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(165634,4601,'es','Pasos para Completar',0),(165635,4601,'de','Abschluss-Schritte',0),(165636,4601,'en','Completion Steps',0),(165637,4602,'is','',0),(165638,4602,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(165639,4602,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(165640,4602,'tr','AyrÄ±ntÄ±lar',0),(165641,4602,'pl','SzczegÃ³Å‚y',0),(165642,4602,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(165643,4602,'ur','ØªÙØµÛŒÙ„Ø§Øª',0),(165644,4602,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸',0),(165645,4602,'vi','Chi tiáº¿t',0),(165646,4602,'af','Details',0),(165647,4602,'ro','Detalii',0),(165648,4602,'et','Ãœksikasjad',0),(165649,4602,'si','Podrobnosti',0),(165650,4602,'ba','Rincian',0),(165651,4602,'nl','Details',0),(165652,4602,'fi','Tiedot',0),(165653,4602,'no','Detaljer',0),(165654,4602,'da','Detaljer',0),(165655,4602,'ko','ì„¸ë¶€ ì •ë³´',0),(165656,4602,'he','×¤×¨×˜×™×',0),(165657,4602,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(165658,4602,'zh','è¯¦æƒ…\r\n',0),(165659,4602,'sv','Detaljer',0),(165660,4602,'it','Dettagli',0),(165661,4602,'tl','',0),(165662,4602,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(165663,4602,'hi','à¤µà¤¿à¤µà¤°à¤£',0),(165664,4602,'ms','Butir-butir',0),(165665,4602,'ar','Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(165666,4602,'fr','DÃ©tails',0),(165667,4602,'jp','è©³ç´°',0),(165668,4602,'pt','Detalhes',0),(165669,4602,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸',0),(165670,4602,'es','Detalles',0),(165671,4602,'de','Informationen',0),(165672,4602,'en','Details',0),(165673,4603,'is','',0),(165674,4603,'dr','Ø³Ø¨Ø² ',0),(165675,4603,'pr','Ø³Ø¨Ø² ',0),(165676,4603,'tr','YeÅŸil',0),(165677,4603,'pl','Zielony',0),(165678,4603,'bg','Ð“Ñ€Ð¸Ð¹Ð½',0),(165679,4603,'ur','Ø³Ø¨Ø²',0),(165680,4603,'sr','Ð—ÐµÐ»ÐµÐ½Ð¸',0),(165681,4603,'vi','Xanh lÃ¡',0),(165682,4603,'af','Groen',0),(165683,4603,'ro','Verde',0),(165684,4603,'et','Roheline',0),(165685,4603,'si','Zelena',0),(165686,4603,'ba','Hijau',0),(165687,4603,'nl','Green',0),(165688,4603,'fi','VihreÃ¤',0),(165689,4603,'no','GrÃ¸nn',0),(165690,4603,'da','GrÃ¸n',0),(165691,4603,'ko','ê·¸ë¦°',0),(165692,4603,'he','×’×¨×™×Ÿ',0),(165693,4603,'el','Î ÏÎ¬ÏƒÎ¹Î½Î¿',0),(165694,4603,'zh','ç»¿\r\n',0),(165695,4603,'sv','GrÃ¶n',0),(165696,4603,'it','Verde',0),(165697,4603,'tl','',0),(165698,4603,'th','&#3626;&#3637;&#3648;&#3586;&#3637;&#3618;&#3623;',0),(165699,4603,'hi','à¤—à¥à¤°à¥€à¤¨',0),(165700,4603,'ms','Hijau',0),(165701,4603,'ar','Ø£Ø®Ø¶Ø±',0),(165702,4603,'fr','Vert',0),(165703,4603,'jp','ç·‘',0),(165704,4603,'pt','Verde',0),(165705,4603,'ru','Ð—ÐµÐ»ÐµÐ½Ñ‹Ð¹',0),(165706,4603,'es','Verde',0),(165707,4603,'de','Green',0),(165708,4603,'en','Green',0),(165709,4604,'is','',0),(165710,4604,'dr','Ø®Ø§ÙƒØ³ØªØ±ÙŠ ',0),(165711,4604,'pr','Ø®Ø§ÙƒØ³ØªØ±ÙŠ ',0),(165712,4604,'tr','Gri',0),(165713,4604,'pl','Szary',0),(165714,4604,'bg','Ð¡Ð¸Ð²',0),(165715,4604,'ur','Ú¯Ø±Û’',0),(165716,4604,'sr','Ð“Ñ€Ðµy',0),(165717,4604,'vi','XÃ¡m ',0),(165718,4604,'af','Grys',0),(165719,4604,'ro','Gri',0),(165720,4604,'et','Grey',0),(165721,4604,'si','Siva',0),(165722,4604,'ba','Abu-abu',0),(165723,4604,'nl','Grey',0),(165724,4604,'fi','Harmaa',0),(165725,4604,'no','GrÃ¥',0),(165726,4604,'da','GrÃ¥',0),(165727,4604,'ko','ê·¸ë ˆì´',0),(165728,4604,'he','×’×¨×™×™',0),(165729,4604,'el','Î“ÎºÏÎ¹',0),(165730,4604,'zh','ç°è‰²\r\n',0),(165731,4604,'sv','GrÃ¥',0),(165732,4604,'it','Grigio',0),(165733,4604,'tl','',0),(165734,4604,'th','&#3626;&#3637;&#3648;&#3607;&#3634;',0),(165735,4604,'hi','à¤—à¥à¤°à¥‡',0),(165736,4604,'ms','Kelabu',0),(165737,4604,'ar','Ø±Ù…Ø§Ø¯ÙŠ',0),(165738,4604,'fr','Gris',0),(165739,4604,'jp','ç?°è‰²',0),(165740,4604,'pt','Grey',0),(165741,4604,'ru','Ð¡ÐµÑ€Ñ‹Ð¹',0),(165742,4604,'es','Gris',0),(165743,4604,'de','Grau',0),(165744,4604,'en','Grey',0),(165745,4605,'is','',0),(165746,4605,'dr','Ø³Ø§Ø¹Ø§Øª Ù‚Ø¨Ù„ ',0),(165747,4605,'pr','Ø³Ø§Ø¹Ø§Øª Ù‚Ø¨Ù„ ',0),(165748,4605,'tr','saat Ã¶nce',0),(165749,4605,'pl','godzin temu',0),(165750,4605,'bg','Ð¿Ñ€ÐµÐ´Ð¸ Ñ‡Ð°ÑÐ°',0),(165751,4605,'ur','Ú†Ù†Ø¯ Ú¯Ú¾Ù†Ù¹Û’ Ù‚Ø¨Ù„',0),(165752,4605,'sr','Ð¿Ñ€Ðµ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ ÑÐ°Ñ‚Ð¸',0),(165753,4605,'vi','máº¥y giá» trÆ°á»›c',0),(165754,4605,'af','ure terug',0),(165755,4605,'ro','ore Ã®n urmÄƒ',0),(165756,4605,'et','detsember',0),(165757,4605,'si','ur nazaj',0),(165758,4605,'ba','jam yang lalu',0),(165759,4605,'nl','uren geleden',0),(165760,4605,'fi','tuntia sitten',0),(165761,4605,'no','timer siden',0),(165762,4605,'da','timer siden',0),(165763,4605,'ko','ì‹œê°„ ì „',0),(165764,4605,'he','×œ×¤× ×™ ×©×¢×•×ª',0),(165765,4605,'el','ÏŽÏÎµÏ‚ Ï€ÏÎ¹Î½',0),(165766,4605,'zh','å°æ—¶å‰\r\n',0),(165767,4605,'sv','timmar sedan',0),(165768,4605,'it','ore fa',0),(165769,4605,'tl','',0),(165770,4605,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634;&#3649;&#3621;&#3657;&#3623;',0),(165771,4605,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤ªà¤¹à¤²à¥‡',0),(165772,4605,'ms','jam yang lalu',0),(165773,4605,'ar','Ù…Ù†Ø° Ø³Ø§Ø¹Ø§Øª',0),(165774,4605,'fr','Twitter.com',0),(165775,4605,'jp','æ•°æ™‚é–“å‰?',0),(165776,4605,'pt','horas atrÃ¡s',0),(165777,4605,'ru','Ñ‡Ð°ÑÐ¾Ð² Ð½Ð°Ð·Ð°Ð´',0),(165778,4605,'es','hace horas',0),(165779,4605,'de','Tage ago',0),(165780,4605,'en','hours ago',0),(165781,4606,'is','',0),(165782,4606,'dr','Ø¨ÙŠØ´ØªØ± Ø§Ø² ',0),(165783,4606,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² ',0),(165784,4606,'tr','Daha fazla',0),(165785,4606,'pl','WiÄ™cej niÅ¼',0),(165786,4606,'bg','ÐŸÐ¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚',0),(165787,4606,'ur','Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(165788,4606,'sr','Ð’Ð¸ÑˆÐµ Ð¾Ð´',0),(165789,4606,'vi','Nhiá»u hÆ¡n',0),(165790,4606,'af','Meer as',0),(165791,4606,'ro','Mai mult',0),(165792,4606,'et','Rohkem kui',0),(165793,4606,'si','VeÄ kot',0),(165794,4606,'ba','Lebih dari',0),(165795,4606,'nl','Meer dan',0),(165796,4606,'fi','Yli',0),(165797,4606,'no','Mer enn',0),(165798,4606,'da','Mere end',0),(165799,4606,'ko','ì´ìƒ',0),(165800,4606,'he','×™×•×ª×¨ ×ž',0),(165801,4606,'el','Î ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ',0),(165802,4606,'zh','è¶…è¿‡\r\n',0),(165803,4606,'sv','Mer Ã¤n',0),(165804,4606,'it','PiÃ¹ di',0),(165805,4606,'tl','',0),(165806,4606,'th','&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;',0),(165807,4606,'hi','à¤…à¤§à¤¿à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(165808,4606,'ms','Lebih daripada',0),(165809,4606,'ar','Ø£ÙƒØ«Ø± Ù…Ù†',0),(165810,4606,'fr','Plus de',0),(165811,4606,'jp','ï½žä»¥ä¸Š',0),(165812,4606,'pt','Mais do que',0),(165813,4606,'ru','Ð‘Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼',0),(165814,4606,'es','MÃ¡s que',0),(165815,4606,'de','Mehr als',0),(165816,4606,'en','More than',0),(165817,4607,'is','',0),(165818,4607,'dr','Ø¨Ù‡ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ù†ÙŠØ§Ø²ÙŠ Ù†ÙŠØ³Øª ',0),(165819,4607,'pr','Ø¨Ù‡ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ù†ÙŠØ§Ø²ÙŠ Ù†ÙŠØ³Øª ',0),(165820,4607,'tr','Bu sÄ±rada gerekli deÄŸildir',0),(165821,4607,'pl','Nie potrzebne to zamÃ³wienie',0),(165822,4607,'bg','ÐÐµ Ðµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(165823,4607,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª Ù†ÛÛŒÚº',0),(165824,4607,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°Ð½ Ð½Ð°Ð»Ð¾Ð³',0),(165825,4607,'vi','KhÃ´ng cáº§n Ä‘Æ¡n hÃ ng nÃ y',0),(165826,4607,'af','Hierdie orde nie nodig',0),(165827,4607,'ro','Nu este necesar acest ordin',0),(165828,4607,'et','Ei ole vaja selles jÃ¤rjekorras',0),(165829,4607,'si','Ni potrebna ta nalog',0),(165830,4607,'ba','Tidak diperlukan urutan ini',0),(165831,4607,'nl','Niet nodig deze bestelling',0),(165832,4607,'fi','Ei tarvita tÃ¤ssÃ¤ jÃ¤rjestyksessÃ¤',0),(165833,4607,'no','Ikke nÃ¸dvendig denne rekkefÃ¸lgen',0),(165834,4607,'da','Ikke brug for denne ordre',0),(165835,4607,'ko','ì´ ìˆœì„œë¥¼ í•„ìš” í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(165836,4607,'he','×œ× ×¦×¨×™×š ×¦×• ×–×”',0),(165837,4607,'el','Î”ÎµÎ½ Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬',0),(165838,4607,'zh','ä¸éœ€è¦æ­¤è®¢å•\r\n\r\n',0),(165839,4607,'sv','BehÃ¶vs inte denna ordning',0),(165840,4607,'it','Non aveva bisogno di questo ordine',0),(165841,4607,'tl','',0),(165842,4607,'th','&#3652;&#3617;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;',0),(165843,4607,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¨à¤¹à¥€à¤‚',0),(165844,4607,'ms','Tidak diperlukan Perintah ini',0),(165845,4607,'ar','Ù„Ø§ Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(165846,4607,'fr','Pas besoin de cet ordre',0),(165847,4607,'jp','ã?“ã?®æ³¨æ–‡ã?«ã?¯ä¸?å¿…è¦?',0),(165848,4607,'pt','NÃ£o precisava desta ordem',0),(165849,4607,'ru','ÐÐµ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(165850,4607,'es','No necesitado en este orden',0),(165851,4607,'de','Diese Reihenfolge nicht benÃ¶tigt',0),(165852,4607,'en','Not needed this order',0),(165853,4608,'is','',0),(165854,4608,'dr','OK  Ù‚Ø¨ÙˆÙ„',0),(165855,4608,'pr','OK  Ù‚Ø¨ÙˆÙ„',0),(165856,4608,'tr','Tamam',0),(165857,4608,'pl','Ok',0),(165858,4608,'bg','OK',0),(165859,4608,'ur','Ù¹Ú¾ÙŠÚ© ÛÛ’',0),(165860,4608,'sr','Ñƒ Ñ€ÐµÐ´Ñƒ',0),(165861,4608,'vi','OK',0),(165862,4608,'af','Oukei',0),(165863,4608,'ro','ok',0),(165864,4608,'et','Ok',0),(165865,4608,'si','v redu',0),(165866,4608,'ba','Oke',0),(165867,4608,'nl','OK',0),(165868,4608,'fi','Okei',0),(165869,4608,'no','ok',0),(165870,4608,'da','Ok',0),(165871,4608,'ko','ê´œì°®ì•˜ë˜ ê²ƒ',0),(165872,4608,'he','××•×§×™×™',0),(165873,4608,'el','Ok',0),(165874,4608,'zh','ç¡®å®š\r\n',0),(165875,4608,'sv','Okej',0),(165876,4608,'it','Ok',0),(165877,4608,'tl','',0),(165878,4608,'th','&#3618;&#3636;&#3609;&#3618;&#3629;&#3617; ',0),(165879,4608,'hi','à¤ à¥€à¤• à¤¹à¥ˆ',0),(165880,4608,'ms','ok',0),(165881,4608,'ar','Ù…ÙˆØ§ÙÙ‚',0),(165882,4608,'fr','Bien',0),(165883,4608,'jp','OK',0),(165884,4608,'pt','RazoÃ¡vel',0),(165885,4608,'ru','Ð¥Ð¾Ñ€Ð¾ÑˆÐ¾',0),(165886,4608,'es','OK',0),(165887,4608,'de','Okay',0),(165888,4608,'en','OK',0),(165889,4609,'is','',0),(165890,4609,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(165891,4609,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(165892,4609,'tr','AlÄ±nan sipariÅŸler',0),(165893,4609,'pl','Otrzymane zamÃ³wienia',0),(165894,4609,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(165895,4609,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…ÙˆØµÙˆÙ„',0),(165896,4609,'sr','ÐÐ°Ð»Ð¾Ð·Ð¸ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð¸',0),(165897,4609,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ nháº­n',0),(165898,4609,'af','Bestellings Ontvang',0),(165899,4609,'ro','Comenzi primite',0),(165900,4609,'et','Saadud tellimused',0),(165901,4609,'si','Prejetih naroÄil',0),(165902,4609,'ba','Pesanan yang diterima',0),(165903,4609,'nl','Orders ontvangen',0),(165904,4609,'fi','Saadut tilaukset',0),(165905,4609,'no','Bestillinger',0),(165906,4609,'da','Ordrer modtaget',0),(165907,4609,'ko','ì ‘ìˆ˜ ëœ ì£¼ë¬¸',0),(165908,4609,'he','×”×–×ž× ×•×ª ×”×ª×§×‘×œ×•',0),(165909,4609,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹',0),(165910,4609,'zh','è®¢å•æ”¶åˆ°\r\n',0),(165911,4609,'sv','OrderingÃ¥ng',0),(165912,4609,'it','Ordini ricevuti',0),(165913,4609,'tl','',0),(165914,4609,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3649;&#3621;&#3657;&#3623;',0),(165915,4609,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(165916,4609,'ms','Pesanan yang diterima',0),(165917,4609,'ar','ØªÙ„Ù‚ÙŠ Ø£ÙˆØ§Ù…Ø±',0),(165918,4609,'fr','Commandes reÃ§ues',0),(165919,4609,'jp','å?—é ˜æ³¨æ–‡',0),(165920,4609,'pt','Ordens recebidas',0),(165921,4609,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(165922,4609,'es','Pedidos Recibidos',0),(165923,4609,'de','Auftragseingang',0),(165924,4609,'en','Orders Received',0),(165925,4610,'is','',0),(165926,4610,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ ',0),(165927,4610,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ ',0),(165928,4610,'tr','FiyatlarÄ±',0),(165929,4610,'pl','Ceny',0),(165930,4610,'bg','Ð¦ÐµÐ½Ð¸',0),(165931,4610,'ur','Ù‚ÛŒÙ…ØªÛŒÚº',0),(165932,4610,'sr','Ð¦ÐµÐ½Ðµ',0),(165933,4610,'vi','GiÃ¡',0),(165934,4610,'af','Pryse',0),(165935,4610,'ro','Preturi',0),(165936,4610,'et','Hinnad',0),(165937,4610,'si','Cene',0),(165938,4610,'ba','Harga',0),(165939,4610,'nl','Prijzen',0),(165940,4610,'fi','Hinnat',0),(165941,4610,'no','Priser',0),(165942,4610,'da','Priser',0),(165943,4610,'ko','ê°€ê²©',0),(165944,4610,'he','×ž×—×™×¨×™×',0),(165945,4610,'el','Î¤Î¹Î¼Î­Ï‚',0),(165946,4610,'zh','ä»·æ ¼\r\n',0),(165947,4610,'sv','Priser',0),(165948,4610,'it','Prezzi',0),(165949,4610,'tl','',0),(165950,4610,'th','&#3619;&#3634;&#3588;&#3634;',0),(165951,4610,'hi','à¤•à¥€à¤®à¤¤à¥‡à¤‚',0),(165952,4610,'ms','Harga',0),(165953,4610,'ar','Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(165954,4610,'fr','Prix',0),(165955,4610,'jp','å€¤æ®µ',0),(165956,4610,'pt','PreÃ§os',0),(165957,4610,'ru','Ð¦ÐµÐ½Ñ‹',0),(165958,4610,'es','Precios',0),(165959,4610,'de','Preise',0),(165960,4610,'en','Prices',0),(165961,4611,'is','',0),(165962,4611,'dr','Ø§ØµÙ„Ø§Ø­',0),(165963,4611,'pr','Ø§ØµÙ„Ø§Ø­',0),(165964,4611,'tr','Revize',0),(165965,4611,'pl','Popraw',0),(165966,4611,'bg','Ð ÐµÐ²Ð¸Ð·Ð¸Ñ€Ð°',0),(165967,4611,'ur','Ù¾Ø± Ø¨Ú¾ÛŒ Ù†Ø¸Ø±Ù Ø«Ø§Ù†ÛŒ',0),(165968,4611,'sr','Ð ÐµÐ²Ð¸Ð´Ð¸Ñ€Ð°Ñ‚Ð¸',0),(165969,4611,'vi','Chá»‰nh sá»­a',0),(165970,4611,'af','Hersien',0),(165971,4611,'ro','Revizuirea',0),(165972,4611,'et','Vaadata lÃ¤bi',0),(165973,4611,'si','Preglej',0),(165974,4611,'ba','Merevisi',0),(165975,4611,'nl','Herzien',0),(165976,4611,'fi','Tarkistaa',0),(165977,4611,'no','Revidere',0),(165978,4611,'da','Revidere',0),(165979,4611,'ko','ìˆ˜ì •',0),(165980,4611,'he','×œ×ª×§×Ÿ',0),(165981,4611,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(165982,4611,'zh','ä¿®æ”¹\r\n',0),(165983,4611,'sv','Revidera',0),(165984,4611,'it','Rivedere',0),(165985,4611,'tl','',0),(165986,4611,'th','&#3649;&#3585;&#3657;&#3652;&#3586;',0),(165987,4611,'hi','à¤•à¥‹ à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤',0),(165988,4611,'ms','Menyemak semula',0),(165989,4611,'ar','ØªÙ†Ù‚ÙŠØ­',0),(165990,4611,'fr','RÃ©viser',0),(165991,4611,'jp','ä¿®æ­£',0),(165992,4611,'pt','Rever',0),(165993,4611,'ru','ÐŸÐµÑ€ÐµÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ',0),(165994,4611,'es','Revisar',0),(165995,4611,'de','Ãœberarbeiten',0),(165996,4611,'en','Revise',0),(165997,4612,'is','',0),(165998,4612,'dr','T&M Ø²Ù…Ø§Ù† Ùˆ Ø¯Ù‚ÙŠÙ‚Ù‡',0),(165999,4612,'pr','T&M Ø²Ù…Ø§Ù† Ùˆ Ø¯Ù‚ÙŠÙ‚Ù‡',0),(166000,4612,'tr','T & M',0),(166001,4612,'pl','T & M',0),(166002,4612,'bg','Ð¢ & Ðœ',0),(166003,4612,'ur','T & M',0),(166004,4612,'sr','Ð¢ & Ðœ',0),(166005,4612,'vi','T&M',0),(166006,4612,'af','T & M',0),(166007,4612,'ro','T & M',0),(166008,4612,'et','T & M',0),(166009,4612,'si','T & M',0),(166010,4612,'ba','T & M',0),(166011,4612,'nl','T & M',0),(166012,4612,'fi','& TIENHAARA',0),(166013,4612,'no','T & M',0),(166014,4612,'da','T & M',0),(166015,4612,'ko','T & M',0),(166016,4612,'he','T & M',0),(166017,4612,'el','T & M',0),(166018,4612,'zh','Tï¼†M\r\n',0),(166019,4612,'sv','T & M',0),(166020,4612,'it','T & M',0),(166021,4612,'tl','',0),(166022,4612,'th','T&M',0),(166023,4612,'hi','T & M',0),(166024,4612,'ms','T & M',0),(166025,4612,'ar','Ù… ØªÙŠ Ø¢Ù†Ø¯',0),(166026,4612,'fr','T & M',0),(166027,4612,'jp','T&M',0),(166028,4612,'pt','T & M',0),(166029,4612,'ru','T & M',0),(166030,4612,'es','T&M',0),(166031,4612,'de','T- & -M',0),(166032,4612,'en','T&M',0),(166033,4613,'is','',0),(166034,4613,'dr','(Ø­Ù…Ù„Ù‡',0),(166035,4613,'pr','Ø¨Ø§ ÙˆØ¶Ø¹ÙŠØª Ø´Ø¯ÙŠØ¯ (Ø­Ù…Ù„Ù‡',0),(166036,4613,'tr','Rush durumu ile',0),(166037,4613,'pl','status Rush',0),(166038,4613,'bg','Ñ Rush ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(166039,4613,'ur','Ø±Ø´ Ú©ÛŒ Ø­ÛŒØ«ÛŒØª Ú©Û’ Ø³Ø§ØªÚ¾',0),(166040,4613,'sr','ÑÐ° ÑÑ‚Ð°Ñ‚ÑƒÑÐ¾Ð¼ \"Ð ÑƒÑÑ…\"',0),(166041,4613,'vi','Vá»›i tÃ¬nh tráº¡ng gáº¥p',0),(166042,4613,'af','met die stormloop Status',0),(166043,4613,'ro','cu statut de Rush',0),(166044,4613,'et','*with Rush Status',0),(166045,4613,'si','s statusom hitenja',0),(166046,4613,'ba','dengan Rush Status',0),(166047,4613,'nl','met de Rush Status',0),(166048,4613,'fi','Rush tila',0),(166049,4613,'no','med Rush Status',0),(166050,4613,'da','med Rush Status',0),(166051,4613,'ko','ëŸ¬ì‰¬ ìƒíƒœ',0),(166052,4613,'he','×¢× ×ž×¦×‘ ×”×¢×•×ž×¡',0),(166053,4613,'el','Î¼Îµ Ï„Î·Î½ Î²Î¹Î±ÏƒÏÎ½Î· ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(166054,4613,'zh','ä¸Žå¿«é€ŸçŠ¶æ€\r\n',0),(166055,4613,'sv','med Rush Status',0),(166056,4613,'it','con Status di Rush',0),(166057,4613,'tl','',0),(166058,4613,'th','&#3604;&#3657;&#3623;&#3618;&#3626;&#3606;&#3634;&#3609;&#3632;&#3607;&#3637;&#3656;&#3648;&#3619;&#3656;&#3591;&#3619;&#3637;&#3610;',0),(166059,4613,'hi','à¤­à¥€à¤¡à¤¼ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(166060,4613,'ms','dengan tergesa-gesa Status',0),(166061,4613,'ar','Ù…Ø¹ ÙˆØ¶Ø¹ Ø§Ù„Ø§Ù†Ø¯ÙØ§Ø¹',0),(166062,4613,'fr','avec la ruÃ©e vers l\'Ã‰tat',0),(166063,4613,'jp','æ€¥ã?Žã?§',0),(166064,4613,'pt','com Status de Rush',0),(166065,4613,'ru','ÑÐ¾ Ð¡Ñ€Ð¾Ñ‡Ð½Ñ‹Ð¼ Ð¡Ñ‚Ð°Ñ‚ÑƒÑÐ¾Ð¼',0),(166066,4613,'es','con SituaciÃ³n de Apuro',0),(166067,4613,'de','mit Rush-Status',0),(166068,4613,'en','with Rush Status',0),(166069,4614,'is','',0),(166070,4614,'dr','ÙÙ‡Ø±Ø³Øª Ø±Ù†Ú¯ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(166071,4614,'pr','ÙÙ‡Ø±Ø³Øª Ø±Ù†Ú¯ Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(166072,4614,'tr','Ã‡alÄ±ÅŸma alanÄ± renkli gÃ¶sterge',0),(166073,4614,'pl','Praca obszar kolor legenda',0),(166074,4614,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð¿Ð»Ð¾Ñ‰ Ñ†Ð²ÑÑ‚ Ð»ÐµÐ³ÐµÐ½Ð´Ð°',0),(166075,4614,'ur','Ú©Ø§Ù… Ú©Û’ Ø¹Ù„Ø§Ù‚Û’ Ø±Ù†Ú¯ Ø´Ù†Ø§Ø³Ù†Ø¯Û',0),(166076,4614,'sr','Ð›ÐµÐ³ÐµÐ½Ð´Ð° Ð±Ð¾Ñ˜Ð° Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ Ñ€Ð°Ð´Ð°',0),(166077,4614,'vi','MÃ£ máº§u Khu vá»±c lÃ m viá»‡c',0),(166078,4614,'af','Werk Area kleur legende',0),(166079,4614,'ro','Legenda de culoare zona de lucru',0),(166080,4614,'et','TÃ¶Ã¶ ala vÃ¤rvi tÃ¤hendus',0),(166081,4614,'si','Delo podroÄju barva legenda',0),(166082,4614,'ba','Bekerja Area warna legenda',0),(166083,4614,'nl','Werk gebied kleurenlegenda',0),(166084,4614,'fi','TyÃ¶tÃ¤ alueen vÃ¤ri legenda',0),(166085,4614,'no','Arbeid omrÃ¥de fargeforklaringen',0),(166086,4614,'da','Arbejde omrÃ¥de farve legende',0),(166087,4614,'ko','ìž‘ì—… ì˜ì—­ ìƒ‰ ë²”ë¡€',0),(166088,4614,'he','×”×¢×‘×•×“×” ×‘××–×•×¨ ×”×¦×‘×¢ ×ž×§×¨×',0),(166089,4614,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï€ÎµÏÎ¹Î¿Ï‡Î® Ï‡ÏÏŽÎ¼Î± Î¸ÏÏÎ»Î¿Ï‚',0),(166090,4614,'zh','å·¥ä½œåŒºé¢œè‰²å›¾ä¾‹\r\n',0),(166091,4614,'sv','Arbete omrÃ¥det fÃ¤rg Legend',0),(166092,4614,'it','Leggenda colore Area di lavoro',0),(166093,4614,'tl','',0),(166094,4614,'th','&#3626;&#3637;&#3588;&#3635;&#3610;&#3619;&#3619;&#3618;&#3634;&#3618;&#3651;&#3605;&#3657;&#3616;&#3634;&#3614;&#3586;&#3629;&#3591;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3591;&#3634;&#3609;',0),(166095,4614,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤°à¤‚à¤— à¤²à¥€à¤œà¥‡à¤‚à¤¡',0),(166096,4614,'ms','Kerja kawasan warna lagenda',0),(166097,4614,'ar','Ø£Ø³Ø·ÙˆØ±Ø© Ù„ÙˆÙ† Ù…Ø³Ø§Ø­Ø© Ø§Ù„Ø¹Ù…Ù„',0),(166098,4614,'fr','LÃ©gende couleur de zone de travail',0),(166099,4614,'jp','ä½œæ¥­ç¯„å›²è‰²èª¬æ˜Žæ–‡',0),(166100,4614,'pt','Legenda de cor de Ã¡rea de trabalho',0),(166101,4614,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ð¹ ÑƒÐ³Ð¾Ð»Ð¾Ðº Ñ†Ð²ÐµÑ‚ Ð»ÐµÐ³ÐµÐ½Ð´Ð°',0),(166102,4614,'es','Leyenda de Colores de Ãrea de Trabajo',0),(166103,4614,'de','Arbeit Bereich Farblegende',0),(166104,4614,'en','Work Area Color Legend',0),(166105,4615,'is','',0),(166106,4615,'dr','ÙƒØ§Ø± Ù†ÙƒØ±Ø¯ ',0),(166107,4615,'pr','ÙƒØ§Ø± Ù†ÙƒØ±Ø¯ ',0),(166108,4615,'tr','Ä°ÅŸe yaramadÄ±',0),(166109,4615,'pl','Nie dziaÅ‚a',0),(166110,4615,'bg','ÐÐµ Ñ€Ð°Ð±Ð¾Ñ‚Ð¸',0),(166111,4615,'ur','Ú©Ø§Ù… Ø§Ù†Ø¬Ø§Ù… Ù†ÛÛŒÚº Ø¯ÛŒØ§',0),(166112,4615,'sr','ÐÐ¸Ñ˜Ðµ Ñ€Ð°Ð´Ð¸Ð¾',0),(166113,4615,'vi','KhÃ´ng hoáº¡t Ä‘á»™ng',0),(166114,4615,'af','Het nie werk nie',0),(166115,4615,'ro','Nu au de lucru',0),(166116,4615,'et','Ei tÃ¶Ã¶ta',0),(166117,4615,'si','Ni delo',0),(166118,4615,'ba','Tidak bekerja',0),(166119,4615,'nl','Did niet werkzaamheden',0),(166120,4615,'fi','Ei toimi',0),(166121,4615,'no','Fungerte ikke',0),(166122,4615,'da','Gjorde ikke arbejde',0),(166123,4615,'ko','ìž‘ë™ í•˜ì§€ ì•Šì•˜ë‹¤',0),(166124,4615,'he','×œ× ×¢×‘×“',0),(166125,4615,'el','Î”ÎµÎ½ Î»ÎµÎ¹Ï„Î¿ÏÏÎ³Î·ÏƒÎµ',0),(166126,4615,'zh','æ²¡æœ‰å·¥ä½œ\r\n',0),(166127,4615,'sv','Fungerade inte',0),(166128,4615,'it','Non ha funzionato',0),(166129,4615,'tl','',0),(166130,4615,'th','&#3652;&#3617;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(166131,4615,'hi','à¤•à¤¾à¤® à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾',0),(166132,4615,'ms','Tidak berjaya',0),(166133,4615,'ar','Ù„Ù… ØªÙ†Ø¬Ø­',0),(166134,4615,'fr','N\'a pas fonctionnÃ©',0),(166135,4615,'jp','ä½œç”¨ã?—ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(166136,4615,'pt','NÃ£o funcionou',0),(166137,4615,'ru','ÐÐµ Ñ€Ð°Ð±Ð¾Ñ‚Ð°ÐµÑ‚',0),(166138,4615,'es','No se TrabajÃ³',0),(166139,4615,'de','Funktionierte nicht',0),(166140,4615,'en','Did not work',0),(166141,4616,'is','',0),(166142,4616,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡',0),(166143,4616,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡',0),(166144,4616,'tr','Vadesi geÃ§miÅŸ sipariÅŸler',0),(166145,4616,'pl','ZalegÅ‚e zamÃ³wienia',0),(166146,4616,'bg','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(166147,4616,'ur','Ù…ÙˆØ®Ø± Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(166148,4616,'sr','Ð”Ð¾ÑÐ¿ÐµÐ»Ð¸Ð¼ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(166149,4616,'vi','ÄÆ¡n hÃ ng quÃ¡ háº¡n',0),(166150,4616,'af','Agterstallige Bestellings',0),(166151,4616,'ro','Comenzi restante',0),(166152,4616,'et','TÃ¤htaja Ã¼letanud tellimused',0),(166153,4616,'si','Zaostalih naroÄil',0),(166154,4616,'ba','Pesanan yang tertunda',0),(166155,4616,'nl','Achterstallige Orders',0),(166156,4616,'fi','MyÃ¶hÃ¤ssÃ¤ tilaukset',0),(166157,4616,'no','Forfalte ordrer',0),(166158,4616,'da','Forsinkede ordrer',0),(166159,4616,'ko','ì—°ì²´ ì£¼ë¬¸',0),(166160,4616,'he','×”×–×ž× ×•×ª ×©×¤×¨×¢×•× ×Ÿ ×—×œ×£',0),(166161,4616,'el','Î•ÎºÏ€ÏÏŒÎ¸ÎµÏƒÎ¼ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(166162,4616,'zh','é€¾æœŸè®¢å•\r\n',0),(166163,4616,'sv','FÃ¶rsenade order',0),(166164,4616,'it','Ordini in ritardo',0),(166165,4616,'tl','',0),(166166,4616,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(166167,4616,'hi','à¤…à¤¤à¤¿à¤¦à¥‡à¤¯ à¤†à¤¦à¥‡à¤¶',0),(166168,4616,'ms','Melampaui tempoh perintah',0),(166169,4616,'ar','Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(166170,4616,'fr','Commandes en souffrance',0),(166171,4616,'jp','æœŸé™?çµŒé?Žæ³¨æ–‡',0),(166172,4616,'pt','Pedidos em atraso',0),(166173,4616,'ru','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(166174,4616,'es','Ordenes Demorosos',0),(166175,4616,'de','ÃœberfÃ¤llige Bestellungen',0),(166176,4616,'en','Overdue Orders',0),(166177,4617,'is','',0),(166178,4617,'dr','(Ù‚Ø·Ø¹',0),(166179,4617,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù†(Ù‚Ø·Ø¹',0),(166180,4617,'tr','Rapor Cut-off tarihi seÃ§in',0),(166181,4617,'pl','Wybierz Data raportu',0),(166182,4617,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚ ÐºÑ€Ð°ÐµÐ½ ÑÑ€Ð¾Ðº',0),(166183,4617,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú©Ù¹ÙˆØªÛŒ ØªØ§Ø±ÛŒØ® Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(166184,4617,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾Ð´ÑÐµÐ¸Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(166185,4617,'vi','Chá»n ngÃ y káº¿t thÃºc bÃ¡o cÃ¡o',0),(166186,4617,'af','Selekteer Verslag Afsnydatums',0),(166187,4617,'ro','SelectaÅ£i data de ecranare raport',0),(166188,4617,'et','Valige aruande tÃ¤htaeg',0),(166189,4617,'si','Izberite poroÄilo preseÄni dan',0),(166190,4617,'ba','Pilih tanggal Cut-off laporan',0),(166191,4617,'nl','Selecteer verslag Cut-off datum',0),(166192,4617,'fi','Valitse raportin mÃ¤Ã¤rÃ¤aikaan',0),(166193,4617,'no','Velg rapporten Cut-off dato',0),(166194,4617,'da','VÃ¦lg rapporten skÃ¦ringsdato',0),(166195,4617,'ko','ë³´ê³ ì„œ ë§ˆê° ë‚ ì§œ ì„ íƒ',0),(166196,4617,'he','×‘×—×¨ ×ª××¨×™×š ×¡×™×•× ×”×“×• ×—',0),(166197,4617,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÎºÎ¿Ï€Î®Ï‚ Î­ÎºÎ¸ÎµÏƒÎ·',0),(166198,4617,'zh','é€‰æ‹©æŠ¥å‘Šçš„æˆªæ­¢æ—¥æœŸ\r\n',0),(166199,4617,'sv','VÃ¤lj rapporten brytdatum',0),(166200,4617,'it','Selezionare la data di cut-off di relazione',0),(166201,4617,'tl','',0),(166202,4617,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3605;&#3633;&#3604;&#3629;&#3629;&#3585;',0),(166203,4617,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¤Ÿ à¤‘à¤« à¤¤à¤¿à¤¥à¤¿ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(166204,4617,'ms','Pilih tarikh akhir Laporan',0),(166205,4617,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ù…ÙˆØ¹Ø¯ Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ ÙÙŠ ØªÙ‚Ø±ÙŠØ±',0),(166206,4617,'fr','SÃ©lectionnez la Date butoir de rapport',0),(166207,4617,'jp','ãƒ¬ãƒ?ãƒ¼ãƒˆæ±ºç®—æ—¥ã?®é?¸æŠž',0),(166208,4617,'pt','Selecione a data-limite relatÃ³rio',0),(166209,4617,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ñ‹ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(166210,4617,'es','Seleccionar Fecha de Corte de Informe',0),(166211,4617,'de','WÃ¤hlen Sie Bericht-Stichtag',0),(166212,4617,'en','Select Report Cut-off Date',0),(166213,4618,'is','',0),(166214,4618,'dr','Ø±ÙˆÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø§Ø² Ø­Ø§Ù„Øª Ø§Ù†ØªØ¸Ø§Ø±  Ø®Ø§Ø±Ø¬ Ø´ÙˆØ¯',0),(166215,4618,'pr','Ø±ÙˆÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø§Ø² Ø­Ø§Ù„Øª Ø§Ù†ØªØ¸Ø§Ø±  Ø®Ø§Ø±Ø¬ Ø´ÙˆØ¯',0),(166216,4618,'tr','SipariÅŸ numarasÄ± tarihinde bekleme durumundan Ã§Ä±karmak iÃ§in tÄ±klayÄ±n',0),(166217,4618,'pl','Kliknij numer zamÃ³wienia, aby usunÄ…Ä‡ stan wstrzymane',0),(166218,4618,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð·Ð° Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ Ð¾Ñ‚ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾-Ð½Ð¸ÑÐºÐ°',0),(166219,4618,'ur','ÛÙˆÙ„Úˆ Ù¾Ø± Ø­Ø§Ù„Øª Ø³Û’ ÛÙ¹Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(166220,4618,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÐºÐ»Ð¾Ð½Ð¸Ð»Ð¸ ÑÑ‚Ð°Ñ‚ÑƒÑ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(166221,4618,'vi','Nháº¥n vÃ o sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng Ä‘á»ƒ bá» tÃ¬nh tráº¡ng táº¡m dá»«ng',0),(166222,4618,'af','Klik op bestelling nommer van op-hou status te verwyder',0),(166223,4618,'ro','FaceÅ£i clic pe numÄƒrul de ordine pentru a elimina din starea de On-Hold',0),(166224,4618,'et','Kliki jÃ¤rjekorranumbri eemaldamine-ootelepaneku olekut',0),(166225,4618,'si','Kliknite na Å¡tevilko naloga, da odstranijo na imeti status',0),(166226,4618,'ba','Klik pada nomor pesanan untuk menghapus dari status pada mengadakan',0),(166227,4618,'nl','Klik op het ordernummer om te verwijderen van On-Hold status',0),(166228,4618,'fi','Klikkaa numero poistaa pitoon',0),(166229,4618,'no','Klikk pÃ¥ bestillingsnummeret fjerne fra pÃ¥ Hold status',0),(166230,4618,'da','Klik pÃ¥ ordrenummeret fjerne fra pÃ¥ Hold status',0),(166231,4618,'ko','ì£¼ë¬¸ ë²ˆí˜¸ë¥¼ ëŒ€ê¸° ìƒíƒœì—ì„œ ì œê±°ë¥¼ í´ë¦­í•©ë‹ˆë‹¤',0),(166232,4618,'he','×œ×—×¥ ×¢×œ ×ž×¡×¤×¨ ×”×–×ž× ×” ×›×“×™ ×œ×”×¡×™×¨--×œ×”×—×–×™×§ ×ž×¢×ž×“',0),(166233,4618,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î³Î¹Î± Î½Î± Î±Ï†Î±Î¹ÏÎ­ÏƒÎµÎ¹ Î±Ï€ÏŒ Ï„Î¿ ÎºÎ±Î¸ÎµÏƒÏ„ÏŽÏ‚ Ï„Î¿Ï… On-Hold',0),(166234,4618,'zh','ç‚¹å‡»è®¢å•å·ä»¥é™¤åŽ»ä¸Šä¿æŒçŠ¶æ€\r\n',0),(166235,4618,'sv','Klicka pÃ¥ ordernummer ta bort frÃ¥n spÃ¤rrade status',0),(166236,4618,'it','Fare clic sul numero dell\'ordine per togliere lo stato di attesa',0),(166237,4618,'tl','',0),(166238,4618,'th','&#3588;&#3621;&#3636;&#3585;&#3610;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3588;&#3621;&#3639;&#3656;&#3629;&#3609;&#3618;&#3',0),(166239,4618,'hi','à¤ªà¤° à¤ªà¤•à¤¡à¤¼ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¸à¥‡ à¤¨à¤¿à¤•à¤¾à¤²à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(166240,4618,'ms','Klik pada nombor pesanan untuk mengalih keluar daripada status pada mengadakan',0),(166241,4618,'ar','Ø§Ù†Ù‚Ø± Ø¹Ù„Ù‰ Ø±Ù‚Ù… Ø§Ù„Ø£Ù…Ø± Ø¥Ø²Ø§Ù„Ø© Ù…Ù† Ù…Ø±ÙƒØ² ÙÙŠ Ø§Ù„Ø§Ù†ØªØ¸Ø§Ø±',0),(166242,4618,'fr','Cliquez sur le numÃ©ro de commande pour supprimer de statut en attente',0),(166243,4618,'jp','ä¿?ç•™ä¸­çŠ¶æ…‹ã?‹ã‚‰å¤–ã?™ã?«ã?¯æ³¨æ–‡ç•ªå?·ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(166244,4618,'pt','Clique no nÃºmero de ordem para remover do status em espera',0),(166245,4618,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¸Ð· Ð½Ð°-Ð´ÐµÑ€Ð¶Ð¸Ñ‚ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(166246,4618,'es','Click sobre nÃºmero de pedido para eliminar del status En-Espera',0),(166247,4618,'de','Klicken Sie auf die Bestellnummer, On-Hold Status zu entziehen',0),(166248,4618,'en','Click on order number to remove from On-Hold status',0),(166249,4619,'is','',0),(166250,4619,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…   ',0),(166251,4619,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…   ',0),(166252,4619,'tr','Emirleri beklemede',0),(166253,4619,'pl','Wstrzymane zamÃ³wienia',0),(166254,4619,'bg','Ð’ Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(166255,4619,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ø±Ú©Ú¾ÛŒÚº Û”',0),(166256,4619,'sr','ÐÐ° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(166257,4619,'vi','Táº¡m ngÆ°ng Ä‘Æ¡n hÃ ng',0),(166258,4619,'af','Uitgestelde Bestellings',0),(166259,4619,'ro','Å¢ineÅ£i pe comenzi',0),(166260,4619,'et','Ootel tellimused',0),(166261,4619,'si','ZadrÅ¾ano naroÄila',0),(166262,4619,'ba','On Hold pesanan',0),(166263,4619,'nl','Uitgesteld Orders',0),(166264,4619,'fi','Estossa-tilaukset',0),(166265,4619,'no','Avvent ordrer',0),(166266,4619,'da','Afvent ordrer',0),(166267,4619,'ko','ì£¼ë¬¸ ê°œìµœ',0),(166268,4619,'he','×‘×”×ž×ª× ×” ×”×–×ž× ×•×ª',0),(166269,4619,'el','Î£Îµ Î±Î½Î±Î¼Î¿Î½Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(166270,4619,'zh','ä¿æŒè®¢å•\r\n',0),(166271,4619,'sv','Ã… hÃ¥ll order',0),(166272,4619,'it','Tenere in ordini',0),(166273,4619,'tl','',0),(166274,4619,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3606;&#3639;&#3629;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3617;&#3639;&#3629;',0),(166275,4619,'hi','à¤ªà¤° à¤†à¤¦à¥‡à¤¶ à¤ªà¤•à¤¡à¤¼',0),(166276,4619,'ms','Di pegang pesanan',0),(166277,4619,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø±',0),(166278,4619,'fr','En attente des ordres',0),(166279,4619,'jp','ä¿?ç•™ä¸­æ³¨æ–‡',0),(166280,4619,'pt','Ã€ espera de ordens',0),(166281,4619,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(166282,4619,'es','Disponble Ordenes',0),(166283,4619,'de','ZurÃ¼ckgestellte AuftrÃ¤ge',0),(166284,4619,'en','On Hold Orders',0),(166285,4620,'is','',0),(166286,4620,'dr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® Ø§ØªÙ…Ø§Ù…',0),(166287,4620,'pr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® Ø§ØªÙ…Ø§Ù…',0),(166288,4620,'tr','BaÅŸlangÄ±Ã§ bitiÅŸ tarihi',0),(166289,4620,'pl','BEGIN data zakoÅ„czenia',0),(166290,4620,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ Ð½Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð¾',0),(166291,4620,'ur','Ø´Ø±ÙˆØ¹ Ú©Û’ Ù„ÛŒÛ’ ØªÚ©Ù…ÛŒÙ„ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(166292,4620,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð·Ð°Ð²Ñ€ÑˆÐ¸',0),(166293,4620,'vi','NgÃ y báº¯t Ä‘áº§u káº¿t thÃºc',0),(166294,4620,'af','Begin Voltooide Datum',0),(166295,4620,'ro','Data de sosire incep',0),(166296,4620,'et','LÃµpeta alguskuupÃ¤ev',0),(166297,4620,'si','ZaÄetek konÄni datum',0),(166298,4620,'ba','Mulailah selesai tanggal',0),(166299,4620,'nl','Begin einddatum',0),(166300,4620,'fi','Aloita valmistumispÃ¤ivÃ¤',0),(166301,4620,'no','Start sluttdatoen',0),(166302,4620,'da','Begynd slutdato',0),(166303,4620,'ko','ì‹œìž‘ ì™„ë£Œ ë‚ ì§œ',0),(166304,4620,'he','×ª××¨×™×š ×”×¡×™×•× ×‘×’×™×Ÿ',0),(166305,4620,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(166306,4620,'zh','å®Œæˆæ—¥æœŸå¼€å§‹\r\n',0),(166307,4620,'sv','BÃ¶rja slutdatum',0),(166308,4620,'it','Data di fine Begin',0),(166309,4620,'tl','',0),(166310,4620,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3648;&#3626;&#3619;&#3655;&#3592;',0),(166311,4620,'hi','à¤†à¤°à¤‚à¤­ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(166312,4620,'ms','Tarikh selesai mulakan',0),(166313,4620,'ar','ØªØ¨Ø¯Ø£ Ù…Ù† ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡',0),(166314,4620,'fr','Date de fin de Begin',0),(166315,4620,'jp','å®Œäº†æ—¥é–‹å§‹',0),(166316,4620,'pt','Data de tÃ©rmino do Begin',0),(166317,4620,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Begin',0),(166318,4620,'es','Iniciar Fecha Final',0),(166319,4620,'de','BEGIN Endtermin',0),(166320,4620,'en','Begin Finish Date',0),(166321,4621,'is','',0),(166322,4621,'dr','  Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ø§ØªÙ…Ø§Ù… ',0),(166323,4621,'pr','  Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ø§ØªÙ…Ø§Ù… ',0),(166324,4621,'tr','Son bitiÅŸ tarihi',0),(166325,4621,'pl','Koniec daty zakoÅ„czenia',0),(166326,4621,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ Ð½Ð° ÐºÑ€Ð°Ñ',0),(166327,4621,'ur','ØªØ§Ø±ÛŒØ® ØªÚ©Ù…ÛŒÙ„ Ø§Ø®ØªØªØ§Ù…',0),(166328,4621,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð·Ð°Ð²Ñ€ÑˆÐ¸',0),(166329,4621,'vi','NgÃ y káº¿t thÃºc cuá»‘i',0),(166330,4621,'af','End Voltooide Datum',0),(166331,4621,'ro','Data de sosire final',0),(166332,4621,'et','LÃµpeta lÃµppkuupÃ¤ev',0),(166333,4621,'si','KonÄni datum konca',0),(166334,4621,'ba','Tanggal selesai akhir',0),(166335,4621,'nl','Eind einddatum',0),(166336,4621,'fi','Valmis pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(166337,4621,'no','Slutten sluttdatoen',0),(166338,4621,'da','Ende slutdato',0),(166339,4621,'ko','ìµœì¢… ì™„ë£Œ ë‚ ì§œ',0),(166340,4621,'he','×ª××¨×™×š ×¡×™×•× ×¡×™×•×',0),(166341,4621,'el','Î¤Î­Î»Î¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(166342,4621,'zh','ç»“æŸå®Œæˆæ—¥æœŸ',0),(166343,4621,'sv','Slutet slutdatum',0),(166344,4621,'it','Data di fine fine',0),(166345,4621,'tl','',0),(166346,4621,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(166347,4621,'hi','à¤…à¤‚à¤¤ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(166348,4621,'ms','Tarikh selesai tamat',0),(166349,4621,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ ÙÙŠ Ù†Ù‡Ø§ÙŠØ©',0),(166350,4621,'fr','Date de fin fin',0),(166351,4621,'jp','å®Œäº†æ—¥çµ‚äº†',0),(166352,4621,'pt','Data de tÃ©rmino do fim',0),(166353,4621,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(166354,4621,'es','Fecha Final de la TerminaciÃ³n',0),(166355,4621,'de','Ende Endtermin',0),(166356,4621,'en','End Finish Date',0),(166357,4622,'is','',0),(166358,4622,'dr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª  Ù…ÙˆØ§ÙÙ‚Øª Ø¬Ù‡Øª ØªÙ‡ÙŠÙ‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(166359,4622,'pr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª  Ù…ÙˆØ§ÙÙ‚Øª Ø¬Ù‡Øª ØªÙ‡ÙŠÙ‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(166360,4622,'tr','Tamam Bill iÃ§in SipariÅŸler',0),(166361,4622,'pl','ZamÃ³wienia OK-Bill',0),(166362,4622,'bg','Ð—Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÐžÐš ÐºÑŠÐ¼ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(166363,4622,'ur','Ú©Û’ Ù„Ø¦Û’ Ù¹Ú¾ÛŒÚ© ÛÛ’-Ø¨Ù„ Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§ Û”',0),(166364,4622,'sr','Ð—Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ñƒ Ñ€ÐµÐ´Ñƒ-Ð´Ð°-Ð‘Ð¸Ð»Ð»',0),(166365,4622,'vi','DÃ nh Cho ÄÆ¡n hÃ ng OK Ä‘á»ƒ thanh toÃ¡n',0),(166366,4622,'af','Vir Bestellings om te Faktuur',0),(166367,4622,'ro','Pentru comenzi de la OK sÄƒ lege',0),(166368,4622,'et','Tellimuste OK arve',0),(166369,4622,'si','Za naroÄila OK-v-zakon',0),(166370,4622,'ba','Pesanan siap Ditagih',0),(166371,4622,'nl','Voor Orders OK-naar-Bill',0),(166372,4622,'fi','Tilaukset OK Bill',0),(166373,4622,'no','For ordrer OK-til-Bill',0),(166374,4622,'da','For ordrer OK til Bill',0),(166375,4622,'ko','ì£¼ë¬¸ í™•ì¸-ë²•ì•ˆì— ëŒ€ í•œ',0),(166376,4622,'he','×¢×‘×•×¨ ×”×–×ž× ×•×ª ××™×©×•×¨ ×›×“×™-. ×‘×™×œ-',0),(166377,4622,'el','Î“Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ OK-Î½Î±-Bill',0),(166378,4622,'zh','å¦‚éœ€è®¢è´§è¡Œå‡ºè´§\r\n',0),(166379,4622,'sv','FÃ¶r bestÃ¤llningar OK-till-Bill',0),(166380,4622,'it','Per ordini OK-per-Bill',0),(166381,4622,'tl','',0),(166382,4622,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; OK &#3648;&#3614;&#3639;&#3656;&#3629;&#3652;&#3611;&#3626;&#3641;&#3656;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655',0),(166383,4622,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤ à¥€à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²',0),(166384,4622,'ms','Bagi pesanan OK-untuk-Rang undang-undang',0),(166385,4622,'ar','Ù„Ø£ÙˆØ§Ù…Ø± Ù…ÙˆØ§ÙÙ‚ Ù„Ù„Ù‚Ø§Ù†ÙˆÙ†',0),(166386,4622,'fr','Pour les commandes OK-facturation',0),(166387,4622,'jp','æ³¨æ–‡è«‹æ±‚å?¯èƒ½æ—¥ã?®',0),(166388,4622,'pt','Para encomendas OK-to-Bill',0),(166389,4622,'ru','Ð”Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² ÐžÐš to-Bill',0),(166390,4622,'es','Para Ordenes OK-para-Facturar ',0),(166391,4622,'de','Bei Bestellungen OK-to-Bill',0),(166392,4622,'en','For Orders OK-to-Bill',0),(166393,4623,'is','',0),(166394,4623,'dr','Ù‚Ø¨ÙˆÙ„ â€“ Ø¨Ù‡ â€“ ØªØ§Ø±ÙŠØ® ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(166395,4623,'pr','Ù‚Ø¨ÙˆÙ„ â€“ Ø¨Ù‡ â€“ ØªØ§Ø±ÙŠØ® ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(166396,4623,'tr','Tamam fatura tarihi',0),(166397,4623,'pl','Ok do-data',0),(166398,4623,'bg','OK Ð´Ð° Ð±Ð¸Ð» Ð´Ð°Ñ‚Ð°',0),(166399,4623,'ur','Ù¹Ú¾ÛŒÚ© ÛÛ’-Ø¨Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(166400,4623,'sr','Ð£ Ñ€ÐµÐ´Ñƒ-Ð´Ð°-Ð‘Ð¸Ð»Ð» Ð´Ð°Ñ‚ÑƒÐ¼',0),(166401,4623,'vi','NgÃ y OK Ä‘á»ƒ ra hÃ³a Ä‘Æ¡n',0),(166402,4623,'af','OK-te-Wetsontwerp datum',0),(166403,4623,'ro','OK-la-lege data',0),(166404,4623,'et','OK arve kuupÃ¤ev',0),(166405,4623,'si','OK-Bill datum',0),(166406,4623,'ba','OK-untuk-tagihan tanggal',0),(166407,4623,'nl','OK-naar-Bill datum',0),(166408,4623,'fi','OK laskun pÃ¤ivÃ¤ys',0),(166409,4623,'no','OK-til-Bill dato',0),(166410,4623,'da','OK-til-Bill dato',0),(166411,4623,'ko','í™•ì¸-ë¹Œ ë‚ ì§œ',0),(166412,4623,'he','×ª××¨×™×š ××™×©×•×¨ ×›×“×™-. ×‘×™×œ-',0),(166413,4623,'el','ÎŸÎš-Î½Î±-Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(166414,4623,'zh','ç¡®å®šå¼€å•æ—¥æœŸ\r\n',0),(166415,4623,'sv','OK-till-Bill datum',0),(166416,4623,'it','OK-per-fattura data',0),(166417,4623,'tl','',0),(166418,4623,'th','&#3605;&#3585;&#3621;&#3591;&#3652;&#3611;&#3618;&#3633;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3609;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(166419,4623,'hi','à¤ à¥€à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤² à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(166420,4623,'ms','OK untuk bil tarikh',0),(166421,4623,'ar','ØªØ§Ø±ÙŠØ® Ù…ÙˆØ§ÙÙ‚ Ù„Ù„Ù‚Ø§Ù†ÙˆÙ†',0),(166422,4623,'fr','OK-facturation Date',0),(166423,4623,'jp','è«‹æ±‚å?¯èƒ½æ—¥',0),(166424,4623,'pt','Encontro bem-to-Bill',0),(166425,4623,'ru','ÐžÐš to-Bill Ð”Ð°Ñ‚Ð°',0),(166426,4623,'es','OK-hasta-Fecha de Recibo',0),(166427,4623,'de','OK-to-Bill-Datum',0),(166428,4623,'en','Ok-to-Bill Date',0),(166429,4624,'is','',0),(166430,4624,'dr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ Ø§ÙˆÙ„ÙŠÙ‡',0),(166431,4624,'pr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ Ø§ÙˆÙ„ÙŠÙ‡',0),(166432,4624,'tr','Begin sevk tarihi',0),(166433,4624,'pl','BEGIN Data wysyÅ‚ki',0),(166434,4624,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(166435,4624,'ur','Ø´Ø±ÙˆØ¹ Ú©Û’ Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(166436,4624,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð±Ñ€Ð¾Ð´',0),(166437,4624,'vi','NgÃ y báº¯t Ä‘áº§u váº­n chuyá»ƒn',0),(166438,4624,'af','Versendingsdatum Begin op',0),(166439,4624,'ro','Data de livrare Ã®ncepe',0),(166440,4624,'et','Laeva alguskuupÃ¤ev',0),(166441,4624,'si','ZaÄetnim datumom poÅ¡iljanja',0),(166442,4624,'ba','Mulailah kapal tanggal',0),(166443,4624,'nl','Begin verzenddatum',0),(166444,4624,'fi','Aloita alusta alkaen',0),(166445,4624,'no','Start forsendelsesdato',0),(166446,4624,'da','Begynd afsendelsesdato',0),(166447,4624,'ko','ì‹œìž‘ ë°°ì†¡ì¼',0),(166448,4624,'he','×ª××¨×™×š ×ž×©×œ×•×— ×‘×’×™×Ÿ',0),(166449,4624,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(166450,4624,'zh','å¼€å§‹å‘è¿æ—¥æœŸ\r\n',0),(166451,4624,'sv','BÃ¶rja transportdatum',0),(166452,4624,'it','Data di spedizione Begin',0),(166453,4624,'tl','',0),(166454,4624,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;',0),(166455,4624,'hi','à¤†à¤°à¤‚à¤­ à¤¶à¤¿à¤ª à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(166456,4624,'ms','Mulakan kapal tarikh',0),(166457,4624,'ar','ØªØ¨Ø¯Ø£ Ù…Ù† ØªØ§Ø±ÙŠØ® Ø§Ù„Ø´Ø­Ù†',0),(166458,4624,'fr','Date d\'expÃ©dition de Begin',0),(166459,4624,'jp','ç™ºé€?æ—¥é–‹å§‹',0),(166460,4624,'pt','Data de envio do Begin',0),(166461,4624,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(166462,4624,'es','Inicio de la Fecha de EnvÃ­o',0),(166463,4624,'de','BEGIN Lieferdatum',0),(166464,4624,'en','Begin Ship Date',0),(166465,4625,'is','',0),(166466,4625,'dr','Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„',0),(166467,4625,'pr','Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„',0),(166468,4625,'tr','Son teslim tarihi',0),(166469,4625,'pl','Data zakoÅ„czenia statku',0),(166470,4625,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(166471,4625,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²',0),(166472,4625,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ðµ',0),(166473,4625,'vi','Káº¿t thÃºc ngÃ y váº­n chuyá»ƒn ',0),(166474,4625,'af','Eind Versendingsdatum',0),(166475,4625,'ro','Data de sfÃ¢rÅŸit al navei',0),(166476,4625,'et','Laeva lÃµppkuupÃ¤ev',0),(166477,4625,'si','Ladja datum konca',0),(166478,4625,'ba','Akhir kapal tanggal',0),(166479,4625,'nl','Schip einddatum',0),(166480,4625,'fi','Aluksen pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(166481,4625,'no','Slutten forsendelsesdato',0),(166482,4625,'da','Skibet slutdato',0),(166483,4625,'ko','ìµœì¢… ìš´ì†¡ ë‚ ì§œ',0),(166484,4625,'he','×ª××¨×™×š ×¡×™×•× ×”×¡×¤×™× ×”',0),(166485,4625,'el','Î¤Î­Î»Î¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(166486,4625,'zh','ç»“æŸè¿é€æ—¥æœŸ',0),(166487,4625,'sv','End transportdatum',0),(166488,4625,'it','Data di spedizione di fine',0),(166489,4625,'tl','',0),(166490,4625,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(166491,4625,'hi','à¤…à¤‚à¤¤ à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(166492,4625,'ms','Tarikh akhir kapal',0),(166493,4625,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(166494,4625,'fr','Date d\'expÃ©dition de fin',0),(166495,4625,'jp','é…?é€?æ—¥çµ‚äº†',0),(166496,4625,'pt','Data de envio do fim',0),(166497,4625,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(166498,4625,'es','Fecha Final de EnvÃ­o',0),(166499,4625,'de','Schiff Enddatum',0),(166500,4625,'en','End Ship Date',0),(166501,4626,'is','',0),(166502,4626,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(166503,4626,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(166504,4626,'tr','Eldeki toplam',0),(166505,4626,'pl','OgÃ³Å‚em na strony',0),(166506,4626,'bg','ÐžÐ±Ñ‰Ð¾ Ð½Ð° Ñ€ÑŠÐºÐ°',0),(166507,4626,'ur','Ø¬Ø§Ù†Ø¨ Ú©Ù„',0),(166508,4626,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÑÐ° ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(166509,4626,'vi','Tá»•ng cá»™ng cÃ³ sáºµn',0),(166510,4626,'af','Totaal Op Hande',0),(166511,4626,'ro','Total pe parte',0),(166512,4626,'et','Kokku poolt',0),(166513,4626,'si','Skupaj na strani',0),(166514,4626,'ba','Total di tangan',0),(166515,4626,'nl','Total aan kant',0),(166516,4626,'fi','YhteensÃ¤ kÃ¤ytettÃ¤vissÃ¤',0),(166517,4626,'no','Totalt pÃ¥ side',0),(166518,4626,'da','Alt pÃ¥ side',0),(166519,4626,'ko','í•œíŽ¸ ì´',0),(166520,4626,'he','×¡×” ×¢×œ ×™×“',0),(166521,4626,'el','Î£ÏÎ½Î¿Î»Î¿ Î±Ï†',0),(166522,4626,'zh','æ€»æŒåº“\r\n',0),(166523,4626,'sv','Totalt Ã¥',0),(166524,4626,'it','Totale sul mano',0),(166525,4626,'tl','',0),(166526,4626,'th','&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3648;&#3611;&#3655;&#3609;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(166527,4626,'hi','à¤¹à¤¾à¤¥ à¤ªà¤° à¤•à¥à¤²',0),(166528,4626,'ms','Jumlah di tangan',0),(166529,4626,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…ØªØ§Ø­',0),(166530,4626,'fr','Total sur place',0),(166531,4626,'jp','æ‰‹æŒ?ã?¡å?ˆè¨ˆ',0),(166532,4626,'pt','Total por lado',0),(166533,4626,'ru','Ð’ÑÐµÐ³Ð¾ Ñ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(166534,4626,'es','Total En Reserva',0),(166535,4626,'de','Einerseits Total',0),(166536,4626,'en','Total On Hand',0),(166537,4627,'is','',0),(166538,4627,'dr','ØªØ§Ø±ÙŠØ® Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§ÙˆÙ„ÙŠÙ‡',0),(166539,4627,'pr','ØªØ§Ø±ÙŠØ® Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§ÙˆÙ„ÙŠÙ‡',0),(166540,4627,'tr','Begin teklif tarihi',0),(166541,4627,'pl','BEGIN Cytat dnia',0),(166542,4627,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð´Ð°Ñ‚Ð°',0),(166543,4627,'ur','Ø´Ø±ÙˆØ¹ Ú©Û’ Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(166544,4627,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(166545,4627,'vi','NgÃ y báº¯t Ä‘áº§u bÃ¡o giÃ¡',0),(166546,4627,'af','Begin Kwotasie Datum',0),(166547,4627,'ro','Data de citat incep',0),(166548,4627,'et','Hinnapakkumise alguskuupÃ¤ev',0),(166549,4627,'si','ZaÄetni datum ponudbe',0),(166550,4627,'ba','Mulailah kutipan tanggal',0),(166551,4627,'nl','Begin citaat datum',0),(166552,4627,'fi','Tarjouksen aloituspÃ¤ivÃ¤',0),(166553,4627,'no','Start tilbud dato',0),(166554,4627,'da','Begynd citat dato',0),(166555,4627,'ko','ì‹œìž‘ ê²¬ì  ë‚ ì§œ',0),(166556,4627,'he','×ª××¨×™×š ×”×¦×¢×ª ×ž×—×™×¨ ×‘×’×™×Ÿ',0),(166557,4627,'el','ÎžÎµÎºÎ¹Î½Î®ÏƒÏ„Îµ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(166558,4627,'zh','æŠ¥ä»·å¼€å§‹æ—¥æœŸ\r\n',0),(166559,4627,'sv','BÃ¶rja citat datum',0),(166560,4627,'it','Data citazione Begin',0),(166561,4627,'tl','',0),(166562,4627,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(166563,4627,'hi','à¤¶à¥à¤°à¥‚ à¤¬à¥‹à¤²à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(166564,4627,'ms','Mulakan Quote tarikh',0),(166565,4627,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(166566,4627,'fr','Date de soumission de Begin',0),(166567,4627,'jp','è¦‹ç©?ã‚Šæ—¥é–‹å§‹',0),(166568,4627,'pt','Data de citaÃ§Ã£o de Begin',0),(166569,4627,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(166570,4627,'es','Iniciar Fecha de CotizaciÃ³n',0),(166571,4627,'de','Zitat Anfangsdatum',0),(166572,4627,'en','Begin Quote Date',0),(166573,4628,'is','',0),(166574,4628,'dr','ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(166575,4628,'pr','ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(166576,4628,'tr','FiyatlarÄ± deÄŸiÅŸtirme',0),(166577,4628,'pl','Zmiana cen',0),(166578,4628,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ñ†ÐµÐ½Ð¸Ñ‚Ðµ',0),(166579,4628,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(166580,4628,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ñ†ÐµÐ½Ðµ',0),(166581,4628,'vi','Thay Ä‘á»•i giÃ¡',0),(166582,4628,'af','Verander Pryse',0),(166583,4628,'ro','Modificare preturi',0),(166584,4628,'et','Muuda hindu',0),(166585,4628,'si','Sprememba cene',0),(166586,4628,'ba','Perubahan harga',0),(166587,4628,'nl','Prijzen wijzigen',0),(166588,4628,'fi','Muuttaa hintoja',0),(166589,4628,'no','Endre priser',0),(166590,4628,'da','Ã†ndre priser',0),(166591,4628,'ko','ê°€ê²© ë³€ê²½',0),(166592,4628,'he','×œ×©× ×•×ª ×ž×—×™×¨×™×',0),(166593,4628,'el','Î‘Î»Î»Î±Î³Î® Ï„Î¹Î¼ÏŽÎ½',0),(166594,4628,'zh','æ”¹å˜ä»·æ ¼\r\n',0),(166595,4628,'sv','Ã„ndra priser',0),(166596,4628,'it','Modificare i prezzi',0),(166597,4628,'tl','',0),(166598,4628,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3619;&#3634;&#3588;&#3634;',0),(166599,4628,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‡à¤‚',0),(166600,4628,'ms','Perubahan harga',0),(166601,4628,'ar','ØªØºÙŠÙŠØ± Ø£Ø³Ø¹Ø§Ø±',0),(166602,4628,'fr','Modifier les prix de',0),(166603,4628,'jp','å€¤æ®µã‚’å¤‰æ›´ã?™ã‚‹',0),(166604,4628,'pt','Alterar os preÃ§os',0),(166605,4628,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(166606,4628,'es','Cambiar Precios',0),(166607,4628,'de','Preise geÃ¤ndert',0),(166608,4628,'en','Change Prices',0),(166609,4629,'is','',0),(166610,4629,'dr','ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡',0),(166611,4629,'pr','ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡',0),(166612,4629,'tr','DeÄŸiÅŸim fiyatlar alÄ±ntÄ±',0),(166613,4629,'pl','Zmiana podane ceny',0),(166614,4629,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ñ†Ð¸Ñ‚Ð¸Ñ€Ð° Ñ†ÐµÐ½Ð¸',0),(166615,4629,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Û’ Ø­ÙˆØ§Ù„Û’ Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(166616,4629,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ñ˜Ðµ Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð¾ Ñ†ÐµÐ½Ðµ',0),(166617,4629,'vi','Thay Ä‘á»•i Ä‘Æ¡n giÃ¡ trong bÃ¡o giÃ¡',0),(166618,4629,'af','Verander Gekwoteerde Pryse',0),(166619,4629,'ro','Schimbare citat preturi',0),(166620,4629,'et','Noteeritud hindade muutus',0),(166621,4629,'si','Spremembe, ki so kotirane cene',0),(166622,4629,'ba','Perubahan harga dikuotasi',0),(166623,4629,'nl','Verandering geciteerd prijzen',0),(166624,4629,'fi','Muutos noteeratut hinnat',0),(166625,4629,'no','Endre sitert priser',0),(166626,4629,'da','Ã†ndre citeret priser',0),(166627,4629,'ko','ë³€ê²½ ê°€ê²©ì„ ì¸ìš©',0),(166628,4629,'he','×©×™× ×•×™ ×¦×™×˜×˜ ××ª ×”×ž×—×™×¨×™×',0),(166629,4629,'el','Î‘Î»Î»Î±Î³Î® ÎµÎ½Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ Ï„Î¹Î¼ÏŽÎ½',0),(166630,4629,'zh','å˜æ›´çš„æŠ¥ä»·\r\n',0),(166631,4629,'sv','Ã„ndra angivna priser',0),(166632,4629,'it','Cambiamento citato prezzi',0),(166633,4629,'tl','',0),(166634,4629,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(166635,4629,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤®à¥‡à¤‚ à¤‰à¤¦à¥à¤§à¥ƒà¤¤',0),(166636,4629,'ms','Perubahan yang disebut harga',0),(166637,4629,'ar','ÙˆÙ†Ù‚Ù„Øª Ø¹Ù† ØªØºÙŠØ± Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(166638,4629,'fr','Changement de prix cotÃ©s',0),(166639,4629,'jp','è¦‹ç©?ã‚‚ã‚‰ã‚Œã?Ÿå€¤æ®µã‚’å¤‰æ›´ã?™ã‚‹',0),(166640,4629,'pt','MudanÃ§a citado preÃ§os',0),(166641,4629,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ ÑƒÐºÐ°Ð·Ð°Ð½Ñ‹ Ñ†ÐµÐ½Ñ‹',0),(166642,4629,'es','Cambiar Precios Cotizados',0),(166643,4629,'de','Ã„nderung zitiert Preise',0),(166644,4629,'en','Change Quoted Prices',0),(166645,4630,'is','',0),(166646,4630,'dr','Ø±ÙˆÙŠ Ø´Ù…Ø§Ø±Ù‡ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø¬Ù‡Øª ØªØ¨Ø¯ÙŠÙ„ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(166647,4630,'pr','Ø±ÙˆÙŠ Ø´Ù…Ø§Ø±Ù‡ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø¬Ù‡Øª ØªØ¨Ø¯ÙŠÙ„ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(166648,4630,'tr','Teklif numarasÄ± sÄ±rasÄ±nÄ± deÄŸiÅŸtirmek iÃ§in tÄ±klatÄ±n',0),(166649,4630,'pl','Kliknij na numer do konwersji na zamÃ³wienie',0),(166650,4630,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð° Ð·Ð° Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð² Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(166651,4630,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†Ù…Ø¨Ø± Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ØªØ¨Ø¯ÛŒÙ„ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(166652,4630,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð±Ñ€Ð¾Ñ˜ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(166653,4630,'vi','Nháº¥n vÃ o sá»‘ BÃ¡o GiÃ¡ Ä‘á»ƒ chuyá»ƒn sang Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(166654,4630,'af','Kliek op Kwotasie Nommer om Omskakeling na Bestelling te bewerkstellig',0),(166655,4630,'ro','FaceÅ£i clic pe numÄƒrul de citat pentru a converti la comanda',0),(166656,4630,'et','KlÃµpsake kÃ¤sku Teisenda tellimuse pakkumise numbrit',0),(166657,4630,'si','Kliknite na Å¡tevilko ponudbo spremeniti v nalog',0),(166658,4630,'ba','Klik pada nomor kutipan untuk mengkonversi sesuai pesanan',0),(166659,4630,'nl','Klik op offerte nummer converteren om te bestellen',0),(166660,4630,'fi','Klikkaa tarjousnumeron muuntaa tilauksesta',0),(166661,4630,'no','Klikk pÃ¥ tilbudsnummer Ã¥ konvertere til ordre',0),(166662,4630,'da','Klik pÃ¥ tilbudsnummer at konvertere til ordre',0),(166663,4630,'ko','ì£¼ë¬¸ ë³€í™˜ ê²¬ì  ë²ˆí˜¸ë¥¼ í´ë¦­',0),(166664,4630,'he','×œ×—×¥ ×¢×œ ×ž×¡×¤×¨ ×”×¦×¢×ª ×”×ž×—×™×¨ ×›×“×™ ×œ×”×ž×™×¨ ×œ×¤×™ ×”×–×ž× ×”',0),(166665,4630,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚ Î³Î¹Î± Î½Î± Î¼ÎµÏ„Î±Ï„ÏÎ­ÏˆÎµÏ„Îµ ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(166666,4630,'zh','ç‚¹å‡»æŠ¥ä»·å·è½¬æ¢è®¢è´­\r\n',0),(166667,4630,'sv','Klicka pÃ¥ offertnummer konvertera till ordning',0),(166668,4630,'it','Fare clic sul numero di Quote a Converti in ordine',0),(166669,4630,'tl','',0),(166670,4630,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3649;&#3592;&#3657;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3',0),(166671,4630,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¨à¥à¤µà¤°à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥‹à¤²à¥€ à¤¨à¤‚à¤¬à¤° à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(166672,4630,'ms','Klik pada nombor sebut harga untuk Tukar kepada perintah',0),(166673,4630,'ar','Ø£Ù†Ù‚Ø± Ø¹Ù„Ù‰ Ø±Ù‚Ù… Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ù„ØªØ­ÙˆÙŠÙ„Ù‡ Ø¥Ù„Ù‰ Ø·Ù„Ø¨ÙŠØ©',0),(166674,4630,'fr','Cliquez sur le numÃ©ro de devis pour effectuer la conversion Ã  l\'ordre',0),(166675,4630,'jp','è¦‹ç©?ã‚Šç•ªå?·ã‚’æ³¨æ–‡ã?¸å¤‰ã?ˆã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(166676,4630,'pt','Clique no nÃºmero de citaÃ§Ãµes para converter em ordem',0),(166677,4630,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€ ÐºÐ²Ð¾Ñ‚Ñ‹, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ Ð² Ð·Ð°ÐºÐ°Ð·',0),(166678,4630,'es','Click sobre NÃºmero de CotizaciÃ³n para Convertir al Pedido',0),(166679,4630,'de','Klicken Sie auf die Angebotsnummer konvertieren in Ordnung',0),(166680,4630,'en','Click on Quote Number to Convert to Order',0),(166681,4631,'is','',0),(166682,4631,'dr','ØªØºÙŠÙŠØ±  Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(166683,4631,'pr','ØªØºÙŠÙŠØ±  Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(166684,4631,'tr','AlÄ±ntÄ± dÃ¶nÃ¼ÅŸtÃ¼rmek',0),(166685,4631,'pl','PrzekonwertowaÄ‡ ofertÄ™',0),(166686,4631,'bg','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(166687,4631,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù…ÛŒÚº Ø¨Ø¯Ù„ÛŒÚº',0),(166688,4631,'sr','ÐŸÑ€ÐµÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(166689,4631,'vi','BÃ¡o giÃ¡ chuyá»ƒn Ä‘á»•i',0),(166690,4631,'af','Kwotasie Omskakel',0),(166691,4631,'ro','Conversia oferte',0),(166692,4631,'et','Teisenda tsitaat',0),(166693,4631,'si','Ponudbo',0),(166694,4631,'ba','Mengkonversi kutipan',0),(166695,4631,'nl','Zet offerte',0),(166696,4631,'fi','Muunna tarjous',0),(166697,4631,'no','Konvertere tilbud',0),(166698,4631,'da','Konvertere tilbud',0),(166699,4631,'ko','ê²¬ì ì„ ë³€í™˜',0),(166700,4631,'he','×”×ž×¨ ×”×¦×¢×ª ×”×ž×—×™×¨',0),(166701,4631,'el','ÎœÎµÏ„Î±Ï„ÏÎ­ÏˆÎµÏ„Îµ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(166702,4631,'zh','è½¬æ¢æŠ¥ä»·\r\n',0),(166703,4631,'sv','Konvertera citat',0),(166704,4631,'it','Convertire la citazione',0),(166705,4631,'tl','',0),(166706,4631,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(166707,4631,'hi','à¤¬à¥‹à¤²à¥€ à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤',0),(166708,4631,'ms','Menukar Quote',0),(166709,4631,'ar','ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(166710,4631,'fr','Convertir Devis',0),(166711,4631,'jp','è¦‹ç©?ã‚Šã?®å¤‰æ›´',0),(166712,4631,'pt','Converter a citaÃ§Ã£o',0),(166713,4631,'ru','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(166714,4631,'es','Convertir CotizaciÃ³n',0),(166715,4631,'de','Zitat zu konvertieren',0),(166716,4631,'en','Convert Quote',0),(166717,4632,'is','',0),(166718,4632,'dr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„ÙŠØ¯',0),(166719,4632,'pr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„ÙŠØ¯',0),(166720,4632,'tr','Yaratma tarihi',0),(166721,4632,'pl','Data utworzenia',0),(166722,4632,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ',0),(166723,4632,'ur','ØªØ§Ø±ÛŒØ® ØªØ®Ù„ÛŒÙ‚',0),(166724,4632,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(166725,4632,'vi','Táº¡o ngÃ y',0),(166726,4632,'af','Skep Datum',0),(166727,4632,'ro','Crea data',0),(166728,4632,'et','Loo kuupÃ¤ev',0),(166729,4632,'si','Ustvarjeno dne',0),(166730,4632,'ba','Tanggal pembuatan',0),(166731,4632,'nl','Aanmaakdatum',0),(166732,4632,'fi','LuontipÃ¤ivÃ¤',0),(166733,4632,'no','Opprette dato',0),(166734,4632,'da','Oprette dato',0),(166735,4632,'ko','ìƒì„± ë‚ ì§œ',0),(166736,4632,'he','×œ×™×¦×•×¨ ×ª××¨×™×š',0),(166737,4632,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(166738,4632,'zh','åˆ›å»ºæ—¥æœŸ\r\n',0),(166739,4632,'sv','Skapa datum',0),(166740,4632,'it','Creare data',0),(166741,4632,'tl','',0),(166742,4632,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(166743,4632,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¬à¤¨à¤¾à¤à¤',0),(166744,4632,'ms','Tarikh cipta',0),(166745,4632,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(166746,4632,'fr','Date de crÃ©ation',0),(166747,4632,'jp','ä½œæˆ?æ—¥',0),(166748,4632,'pt','Criar data',0),(166749,4632,'ru','Ð”Ð°Ñ‚Ð° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ',0),(166750,4632,'es','Crear Fecha',0),(166751,4632,'de','Erstellungsdatum',0),(166752,4632,'en','Create Date',0),(166753,4633,'is','',0),(166754,4633,'dr','ØªÙ„ÙÙ† Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(166755,4633,'pr','ØªÙ„ÙÙ† Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(166756,4633,'tr','MÃ¼ÅŸteri telefonu',0),(166757,4633,'pl','Telefon klienta',0),(166758,4633,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(166759,4633,'ur','Ú©Ø³Ù¹Ù…Ø± ÙÙˆÙ†',0),(166760,4633,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(166761,4633,'vi','Phone KhÃ¡ch hÃ ng',0),(166762,4633,'af','Klant / KliÃ«nt Telefoon',0),(166763,4633,'ro','Telefonul clientului',0),(166764,4633,'et','Kliendi telefon',0),(166765,4633,'si','Kupec telefon',0),(166766,4633,'ba','Pelanggan telepon',0),(166767,4633,'nl','Telefoon van de klant',0),(166768,4633,'fi','Asiakkaan Puhelin',0),(166769,4633,'no','Kunden telefon',0),(166770,4633,'da','Kunde telefon',0),(166771,4633,'ko','ê³ ê° ì „í™”',0),(166772,4633,'he','×˜×œ×¤×•×Ÿ ×œ×§×•×—',0),(166773,4633,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ Ï€ÎµÎ»Î¬Ï„Î·',0),(166774,4633,'zh','å®¢æˆ·ç”µè¯',0),(166775,4633,'sv','Kunden telefon',0),(166776,4633,'it','Numero di telefono del cliente',0),(166777,4633,'tl','',0),(166778,4633,'th','&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(166779,4633,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤«à¥‹à¤¨',0),(166780,4633,'ms','Telefon pelanggan',0),(166781,4633,'ar','Ù‡Ø§ØªÙ Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(166782,4633,'fr','TÃ©lÃ©phone client',0),(166783,4633,'jp','é¡§å®¢é›»è©±',0),(166784,4633,'pt','Telefone do cliente',0),(166785,4633,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(166786,4633,'es','Cliente TelÃ©fono',0),(166787,4633,'de','Kunden-Telefon',0),(166788,4633,'en','Customer Phone',0),(166789,4634,'is','',0),(166790,4634,'dr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(166791,4634,'pr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(166792,4634,'tr','Son teklif tarihi',0),(166793,4634,'pl','Koniec Cytat dnia',0),(166794,4634,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð°',0),(166795,4634,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø§Ù‚ØªØ¨Ø§Ø³',0),(166796,4634,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(166797,4634,'vi','NgÃ y káº¿t thÃºc bÃ¡o giÃ¡',0),(166798,4634,'af','End Kwotasie Datum',0),(166799,4634,'ro','Data de sfÃ¢rÅŸit al citat',0),(166800,4634,'et','Pakkumise lÃµppkuupÃ¤ev',0),(166801,4634,'si','Datum konca ponudbe',0),(166802,4634,'ba','Akhir kutipan tanggal',0),(166803,4634,'nl','Einde citaat datum',0),(166804,4634,'fi','Tarjouksen pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(166805,4634,'no','Sluttdatoen for tilbud',0),(166806,4634,'da','Citat slutdato',0),(166807,4634,'ko','ìµœì¢… ê²¬ì  ë‚ ì§œ',0),(166808,4634,'he','×ª××¨×™×š ×¡×™×•× ×”×¦×¢×ª ×ž×—×™×¨',0),(166809,4634,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(166810,4634,'zh','ç»“æŸæŠ¥ä»·æ—¥æœŸ',0),(166811,4634,'sv','Slutdatum fÃ¶r offert',0),(166812,4634,'it','Data di fine citazione',0),(166813,4634,'tl','',0),(166814,4634,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(166815,4634,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(166816,4634,'ms','Tarikh sebut harga akhir',0),(166817,4634,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³',0),(166818,4634,'fr','Date de fin citation',0),(166819,4634,'jp','è¦‹ç©?ã‚Šæ—¥çµ‚äº†',0),(166820,4634,'pt','Data de citaÃ§Ã£o final',0),(166821,4634,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(166822,4634,'es','Fecha Final de CotizaciÃ³n',0),(166823,4634,'de','Zitat Enddatum',0),(166824,4634,'en','End Quote Date',0),(166825,4635,'is','',0),(166826,4635,'dr','ÙˆØ¶Ø¹ÙŠØª Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ú†Ù†Ø¯ Ù…Ø¨Ù„ØºÙŠ ',0),(166827,4635,'pr','ÙˆØ¶Ø¹ÙŠØª Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ú†Ù†Ø¯ Ù…Ø¨Ù„ØºÙŠ ',0),(166828,4635,'tr','Ã‡oklu miktar teklif durumu',0),(166829,4635,'pl','Multi iloÅ›Ä‡ cytatem Status',0),(166830,4635,'bg','ÐœÑƒÐ»Ñ‚Ð¸-ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾Ñ„ÐµÑ€Ñ‚Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(166831,4635,'ur','Ú©Ø«ÛŒØ±-Ù‚ÛŒ Ø§Ù‚ØªØ¨Ø§Ø³ Ø­Ø§Ù„Øª',0),(166832,4635,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¼ÑƒÐ»Ñ‚Ð¸-ÐšÐ¾Ð».',0),(166833,4635,'vi','TÃ¬nh tráº¡ng bÃ¡o giÃ¡ Ä‘a lÆ°á»£ng',0),(166834,4635,'af','Multi-Qty aanhaling Status',0),(166835,4635,'ro','Multi-cantit citat statutul',0),(166836,4635,'et','Multi-tk hinnapakkumise olek',0),(166837,4635,'si','Multi-koliÄina ponudbe Status',0),(166838,4635,'ba','Multi-Qty kutipan Status',0),(166839,4635,'nl','Multi-aantal citaat Status',0),(166840,4635,'fi','Multi-mÃ¤Ã¤rÃ¤ tarjouksen tila',0),(166841,4635,'no','Multi-antall tilbud Status',0),(166842,4635,'da','Multi-antal tilbud Status',0),(166843,4635,'ko','ë©€í‹°-ìˆ˜ëŸ‰ ê²¬ì  ìƒíƒœ',0),(166844,4635,'he','×ž×¦×‘ ×”×¦×¢×ª ×ž×—×™×¨ ×¨×‘-×›×ž×•×ª',0),(166845,4635,'el','Multi-Qty Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(166846,4635,'zh','å¤šæ•°é‡æŠ¥ä»·çŠ¶æ€\r\n',0),(166847,4635,'sv','Multi-antal citat Status',0),(166848,4635,'it','Multi-Qty citazione Status',0),(166849,4635,'tl','',0),(166850,4635,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3627;&#3621;&#3634;&#3618;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(166851,4635,'hi','à¤¬à¤¹à¥-à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(166852,4635,'ms','Multi-Qty Quote Status',0),(166853,4635,'ar','Ù…Ø±ÙƒØ² Ø§Ù‚ØªØ¨Ø§Ø³ Ù…ØªØ¹Ø¯Ø¯-Ø§Ù„ÙƒÙ…ÙŠØ©',0),(166854,4635,'fr','Statut devis multi-QtÃ©',0),(166855,4635,'jp','Multi-Qty Quote Status',0),(166856,4635,'pt','Multi-Qty citaÃ§Ã£o Status',0),(166857,4635,'ru','Multi-Qty Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(166858,4635,'es','Status de CotizaciÃ³n Multi-Cant',0),(166859,4635,'de','Multi-Menge Quote Status',0),(166860,4635,'en','Multi-Qty Quote Status',0),(166861,4636,'is','',0),(166862,4636,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(166863,4636,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(166864,4636,'tr','SeÃ§ili olmayan',0),(166865,4636,'pl','Wybrane',0),(166866,4636,'bg','ÐÐµ-Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(166867,4636,'ur','ØºÛŒØ± Ù…Ù†ØªØ®Ø¨',0),(166868,4636,'sr','ÐÐµÐ¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸Ñ…',0),(166869,4636,'vi','ChÆ°a chá»n',0),(166870,4636,'af','Nie-gekies',0),(166871,4636,'ro','Non-selectat',0),(166872,4636,'et','Valitud',0),(166873,4636,'si','Neizbranih',0),(166874,4636,'ba','Dipilih non-',0),(166875,4636,'nl','Niet geselecteerde-',0),(166876,4636,'fi','Ei valittu',0),(166877,4636,'no','Ikke valgte-',0),(166878,4636,'da','Ikke markerede-',0),(166879,4636,'ko','ì„ íƒ ë˜ì§€ ì•Šì€',0),(166880,4636,'he','×©×œ× × ×‘×—×¨×•',0),(166881,4636,'el','ÎœÎ· ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿',0),(166882,4636,'zh','éžé€‰æ‹©\r\n',0),(166883,4636,'sv','Ej vald',0),(166884,4636,'it','Non selezionati',0),(166885,4636,'tl','',0),(166886,4636,'th','&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(166887,4636,'hi','à¤—à¥ˆà¤°-à¤šà¤¯à¤¨à¤¿à¤¤',0),(166888,4636,'ms','Dipilih',0),(166889,4636,'ar','ØºÙŠØ± Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(166890,4636,'fr','Non sÃ©lectionnÃ©',0),(166891,4636,'jp','æœªé?¸æŠž',0),(166892,4636,'pt','NÃ£o selecionado',0),(166893,4636,'ru','ÐÐµ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(166894,4636,'es','No Seleccionado',0),(166895,4636,'de','Nicht ausgewÃ¤hlte',0),(166896,4636,'en','Non-Selected',0),(166897,4637,'is','',0),(166898,4637,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(166899,4637,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(166900,4637,'tr','KullanÄ±lmÄ±yor',0),(166901,4637,'pl','Nie uÅ¼ywany',0),(166902,4637,'bg','ÐÐµ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°',0),(166903,4637,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù†ÛÛŒÚº Ú©ÛŒØ§',0),(166904,4637,'sr','ÐÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(166905,4637,'vi','KhÃ´ng dÃ¹ng',0),(166906,4637,'af','Nie Gebruik',0),(166907,4637,'ro','Nu sunt folosite',0),(166908,4637,'et','Kasutamata',0),(166909,4637,'si','Ne uporablja',0),(166910,4637,'ba','Tidak digunakan',0),(166911,4637,'nl','Niet gebruikt',0),(166912,4637,'fi','Ei kÃ¤ytetÃ¤',0),(166913,4637,'no','Ikke brukt',0),(166914,4637,'da','Ikke bruges',0),(166915,4637,'ko','ì‚¬ìš© ë˜ì§€ ì•ŠëŠ”',0),(166916,4637,'he','×œ× ×ž×©×•×ž×©',0),(166917,4637,'el','Î”ÎµÎ½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹',0),(166918,4637,'zh','ä¸ä½¿ç”¨\r\n',0),(166919,4637,'sv','Inte anvÃ¤nds',0),(166920,4637,'it','Non utilizzato',0),(166921,4637,'tl','',0),(166922,4637,'th','&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3651;&#3594;&#3657;',0),(166923,4637,'hi','à¤ªà¥à¤°à¤¯à¥à¤•à¥à¤¤ à¤¨à¤¹à¥€à¤‚',0),(166924,4637,'ms','Tidak digunakan',0),(166925,4637,'ar','Ù„Ø§ ØªØ³ØªØ®Ø¯Ù…',0),(166926,4637,'fr','Non utilisÃ©',0),(166927,4637,'jp','æœªä½¿ç”¨',0),(166928,4637,'pt','NÃ£o usado',0),(166929,4637,'ru','ÐÐµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ',0),(166930,4637,'es','No Usado',0),(166931,4637,'de','Nicht verwendet',0),(166932,4637,'en','Not Used',0),(166933,4638,'is','',0),(166934,4638,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(166935,4638,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(166936,4638,'tr','Teklif listesi',0),(166937,4638,'pl','Cytat z listy',0),(166938,4638,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(166939,4638,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(166940,4638,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð»Ð¸ÑÑ‚Ñƒ',0),(166941,4638,'vi','Danh sÃ¡ch bÃ¡o giÃ¡',0),(166942,4638,'af','Kwotasie Lys',0),(166943,4638,'ro','Citat lista',0),(166944,4638,'et','Hoolduspakkumiste loend',0),(166945,4638,'si','Citiram seznam',0),(166946,4638,'ba','Daftar kutipan',0),(166947,4638,'nl','Koerslijst',0),(166948,4638,'fi','Huoltotarjouksen luettelo',0),(166949,4638,'no','Sitat-listen',0),(166950,4638,'da','Tilbudsoversigt',0),(166951,4638,'ko','ê²¬ì  ëª©ë¡',0),(166952,4638,'he','×”×¦×¢×ª ×ž×—×™×¨ ×”×¨×©×™×ž×”',0),(166953,4638,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(166954,4638,'zh','æŠ¥ä»·åˆ—è¡¨\r\n',0),(166955,4638,'sv','Citera lista',0),(166956,4638,'it','Lista di citazione',0),(166957,4638,'tl','',0),(166958,4638,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;',0),(166959,4638,'hi','à¤¬à¥‹à¤²à¥€ à¤¸à¥‚à¤šà¥€',0),(166960,4638,'ms','Senarai sebut harga',0),(166961,4638,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(166962,4638,'fr','Liste des devis',0),(166963,4638,'jp','è¦‹ç©?ã‚‚ã‚Šãƒªã‚¹ãƒˆ',0),(166964,4638,'pt','Lista de cotaÃ§Ã£o',0),(166965,4638,'ru','ÐšÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð»Ð¸ÑÑ‚',0),(166966,4638,'es','Lista de Cotizaciones',0),(166967,4638,'de','Kursliste',0),(166968,4638,'en','Quote List',0),(166969,4639,'is','',0),(166970,4639,'dr','ØªØ§Ø±ÙŠØ® Ø§ØµÙ„Ø§Ø­',0),(166971,4639,'pr','ØªØ§Ø±ÙŠØ® Ø§ØµÙ„Ø§Ø­',0),(166972,4639,'tr','Tarihi revize',0),(166973,4639,'pl','Zmiany daty',0),(166974,4639,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½ÑÐ¼Ðµ Ð´Ð°Ñ‚Ð°Ñ‚Ð°',0),(166975,4639,'ur','ØªØ§Ø±ÛŒØ® Ù¾Ø± Ù†Ø¸Ø± Ø«Ø§Ù†ÛŒ',0),(166976,4639,'sr','ÐšÐ¾Ñ€Ð¸Ð³ÑƒÑ˜Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(166977,4639,'vi','NgÃ y Chá»‰nh sá»­a',0),(166978,4639,'af','Datum hersien',0),(166979,4639,'ro','Revizuirea data',0),(166980,4639,'et','Muuta kuupÃ¤ev',0),(166981,4639,'si','Spremeniti datum',0),(166982,4639,'ba','Merevisi tanggal',0),(166983,4639,'nl','Datum herzien',0),(166984,4639,'fi','Tietosuojatietojen',0),(166985,4639,'no','Endre datoen',0),(166986,4639,'da','Revidere dato',0),(166987,4639,'ko','ë‚ ì§œ ìˆ˜ì •',0),(166988,4639,'he','×œ×©× ×•×ª ×ª××¨×™×š',0),(166989,4639,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(166990,4639,'zh','ä¿®æ”¹æ—¥æœŸ\r\n',0),(166991,4639,'sv','Datumet fÃ¶r',0),(166992,4639,'it','Data di revisione',0),(166993,4639,'tl','',0),(166994,4639,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(166995,4639,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤',0),(166996,4639,'ms','Menyemak tarikh',0),(166997,4639,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(166998,4639,'fr','Date de rÃ©vision',0),(166999,4639,'jp','ä¿®æ­£æ—¥',0),(167000,4639,'pt','Data de revisÃ£o',0),(167001,4639,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð° Ð´Ð°Ñ‚Ð°',0),(167002,4639,'es','Fecha de RevisiÃ³n',0),(167003,4639,'de','Datum zu Ã¼berarbeiten',0),(167004,4639,'en','Revise Date',0),(167005,4640,'is','',0),(167006,4640,'dr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(167007,4640,'pr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(167008,4640,'tr','SipariÅŸ iÃ§in',0),(167009,4640,'pl','na zamÃ³wienie',0),(167010,4640,'bg','Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(167011,4640,'ur','Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(167012,4640,'sr','Ð½Ð°Ð»Ð¾Ð³',0),(167013,4640,'vi','Ä‘á»ƒ Äáº·t hÃ ng ',0),(167014,4640,'af','om te Bestel',0),(167015,4640,'ro','la comanda',0),(167016,4640,'et','tellimusele',0),(167017,4640,'si','po naroÄilu',0),(167018,4640,'ba','untuk Order',0),(167019,4640,'nl','om te bestellen',0),(167020,4640,'fi','tilauksesta',0),(167021,4640,'no','Ã¥ bestille',0),(167022,4640,'da','at bestille',0),(167023,4640,'ko','ì£¼ë¬¸',0),(167024,4640,'he','×œ×¤×™ ×”×–×ž× ×”',0),(167025,4640,'el','ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î·',0),(167026,4640,'zh','è®¢è´­\r\n',0),(167027,4640,'sv','att bestÃ¤lla',0),(167028,4640,'it','per ordine',0),(167029,4640,'tl','',0),(167030,4640,'th','&#3606;&#3638;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(167031,4640,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(167032,4640,'ms','kepada perintah',0),(167033,4640,'ar','Ù„ØªØ±ØªÙŠØ¨',0),(167034,4640,'fr','Ã  l\'ordre',0),(167035,4640,'jp','æ³¨æ–‡ã?™ã‚‹',0),(167036,4640,'pt','a ordem',0),(167037,4640,'ru','Ð½Ð° Ð·Ð°ÐºÐ°Ð·',0),(167038,4640,'es','Para Ordenar',0),(167039,4640,'de','um zu bestellen',0),(167040,4640,'en','to Order',0),(167041,4641,'is','',0),(167042,4641,'dr','Ø¨Ø±Ø¯ ',0),(167043,4641,'pr','Ø¨Ø±Ø¯ ',0),(167044,4641,'tr','KazandÄ±',0),(167045,4641,'pl','WygraÅ‚',0),(167046,4641,'bg','Ð¡Ð¿ÐµÑ‡ÐµÐ»Ð¸',0),(167047,4641,'ur','Ø¬ÛŒØª',0),(167048,4641,'sr','ÐžÑÐ²Ð¾Ñ˜Ð¸Ð¾',0),(167049,4641,'vi','Tháº¯ng',0),(167050,4641,'af','Gewen',0),(167051,4641,'ro','A cÃ¢ÅŸtigat',0),(167052,4641,'et','VÃµit',0),(167053,4641,'si','Zmagal',0),(167054,4641,'ba','Memenangkan',0),(167055,4641,'nl','Gewonnen',0),(167056,4641,'fi','Voitti',0),(167057,4641,'no','Vant',0),(167058,4641,'da','Vandt',0),(167059,4641,'ko','ì›',0),(167060,4641,'he','×–×›×”',0),(167061,4641,'el','ÎšÎ­ÏÎ´Î¹ÏƒÎµ',0),(167062,4641,'zh','èƒœåˆ©\r\n',0),(167063,4641,'sv','Vann',0),(167064,4641,'it','Ha vinto',0),(167065,4641,'tl','',0),(167066,4641,'th','&#3594;&#3609;&#3632;',0),(167067,4641,'hi','à¤œà¥€à¤¤à¤¾',0),(167068,4641,'ms','Memenangi',0),(167069,4641,'ar','ÙˆÙØ§Ø²',0),(167070,4641,'fr','GagnÃ©',0),(167071,4641,'jp','ã‚¦ã‚©ãƒ³',0),(167072,4641,'pt','Ganhou',0),(167073,4641,'ru','Ð’Ñ‹Ð¸Ð³Ñ€Ð°Ð»',0),(167074,4641,'es','GanÃ³',0),(167075,4641,'de','Gewonnen',0),(167076,4641,'en','Won',0),(167077,4642,'is','',0),(167078,4642,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(167079,4642,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(167080,4642,'tr','Ek Ã¼cret',0),(167081,4642,'pl','Dodatkowe opÅ‚aty',0),(167082,4642,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(167083,4642,'ur','Ø§Ø¶Ø§ÙÛŒ Ú†Ø§Ø±Ø¬Ø²',0),(167084,4642,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(167085,4642,'vi','CÃ¡c PhÃ­ Cá»™ng ThÃªm',0),(167086,4642,'af','Addisionele Kostes',0),(167087,4642,'ro','Costuri aditionale',0),(167088,4642,'et','Lisatasud',0),(167089,4642,'si','Dodatne stroÅ¡ke',0),(167090,4642,'ba','Biaya Tambahan',0),(167091,4642,'nl','Extra kosten',0),(167092,4642,'fi','LisÃ¤maksut',0),(167093,4642,'no','Tilleggskostnader',0),(167094,4642,'da','Ekstra gebyrer',0),(167095,4642,'ko','ì¶”ê°€ ìš”ê¸ˆ',0),(167096,4642,'he','×—×™×•×‘×™× × ×•×¡×¤×™×',0),(167097,4642,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(167098,4642,'zh','é™„åŠ è´¹ç”¨\r\n',0),(167099,4642,'sv','Ytterligare avgifter',0),(167100,4642,'it','Aliquote addizionale',0),(167101,4642,'tl','',0),(167102,4642,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(167103,4642,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(167104,4642,'ms','Caj tambahan',0),(167105,4642,'ar','Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ©',0),(167106,4642,'fr','Charges SupplÃ©mentaires',0),(167107,4642,'jp','è¿½åŠ æ–™é‡‘',0),(167108,4642,'pt','Encargos adicionais',0),(167109,4642,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(167110,4642,'es','Cargos Adicionales',0),(167111,4642,'de','ZusÃ¤tzliche GebÃ¼hren',0),(167112,4642,'en','Additional Charges',0),(167113,4643,'is','',0),(167114,4643,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ',0),(167115,4643,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ',0),(167116,4643,'tr','Bu Ã¶ÄŸe ekleme',0),(167117,4643,'pl','DodaÄ‡ ten element',0),(167118,4643,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(167119,4643,'ur','Ø§Ø³ Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(167120,4643,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(167121,4643,'vi','ThÃªm Má»¥c nÃ y',0),(167122,4643,'af','Hierdie Item Byvoeg',0),(167123,4643,'ro','AdÄƒugaÈ›i acest element',0),(167124,4643,'et','Lisa see toode',0),(167125,4643,'si','Dodajte element',0),(167126,4643,'ba','Menambahkan Item ini',0),(167127,4643,'nl','Dit object toevoegen',0),(167128,4643,'fi','LisÃ¤Ã¤ kohde',0),(167129,4643,'no','Legge til dette elementet',0),(167130,4643,'da','FÃ¸j dette element',0),(167131,4643,'ko','ì´ í•­ëª© ì¶”ê°€',0),(167132,4643,'he','×œ×”×•×¡×™×£ ×¤×¨×™×˜ ×–×”',0),(167133,4643,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(167134,4643,'zh','å¢žåŠ æ­¤é¡¹ç›®\r\n',0),(167135,4643,'sv','LÃ¤gg till detta objekt',0),(167136,4643,'it','Aggiungere questo elemento',0),(167137,4643,'tl','',0),(167138,4643,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;',0),(167139,4643,'hi','à¤¯à¤¹ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(167140,4643,'ms','Tambah Item ini',0),(167141,4643,'ar','Ø¥Ø¶Ø§ÙØ© Ù‡Ø°Ø§ Ø§Ù„ØµÙ†Ù',0),(167142,4643,'fr','Ajouter cet Ã©lÃ©ment',0),(167143,4643,'jp','ã?“ã?®å“?ç›®ã‚’è¿½åŠ ',0),(167144,4643,'pt','Adicionar este Item',0),(167145,4643,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð­Ñ‚Ð¾Ñ‚ Ð¢Ð¾Ð²Ð°Ñ€',0),(167146,4643,'es','Agregar este item',0),(167147,4643,'de','Dieses Element hinzufÃ¼gen',0),(167148,4643,'en','Add this Item',0),(167149,4644,'is','',0),(167150,4644,'dr','ØªØºÙŠÙŠØ± ØªÙ…Ø§Ù… Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(167151,4644,'pr','ØªØºÙŠÙŠØ± ØªÙ…Ø§Ù… Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(167152,4644,'tr','TÃ¼m fiyatlar deÄŸiÅŸtirme',0),(167153,4644,'pl','ZmieniÄ‡ wszystkie ceny',0),(167154,4644,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ñ†ÐµÐ½Ð¸ ÑÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(167155,4644,'ur','ØªÙ…Ø§Ù… Ù‚ÛŒÙ…ØªÛŒÚº ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(167156,4644,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÑÐ²Ðµ Ñ†ÐµÐ½Ðµ',0),(167157,4644,'vi','Thay Ä‘á»•i táº¥t cáº£ giÃ¡',0),(167158,4644,'af','Verander alle pryse',0),(167159,4644,'ro','Schimba toate preturile',0),(167160,4644,'et','KÃµiki hindu muuta',0),(167161,4644,'si','Spremenite vse cene',0),(167162,4644,'ba','Mengubah semua harga',0),(167163,4644,'nl','Alle prijzen wijzigen',0),(167164,4644,'fi','Muuttaa kaikki hinnat',0),(167165,4644,'no','Endre prisene',0),(167166,4644,'da','Ã†ndre alle priser',0),(167167,4644,'ko','ëª¨ë“  ê°€ê²© ë³€ê²½',0),(167168,4644,'he','×œ×©× ×•×ª ××ª ×›×œ ×”×ž×—×™×¨×™×',0),(167169,4644,'el','Î‘Î»Î»Î±Î³Î® ÏŒÎ»ÎµÏ‚ Î¿Î¹ Ï„Î¹Î¼Î­Ï‚',0),(167170,4644,'zh','å…¨éƒ¨æ›´æ”¹ä»·æ ¼\r\n',0),(167171,4644,'sv','Ã„ndra alla priser',0),(167172,4644,'it','Cambiare tutti i prezzi',0),(167173,4644,'tl','',0),(167174,4644,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3619;&#3634;&#3588;&#3634;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(167175,4644,'hi','à¤¸à¤­à¥€ à¤®à¥‚à¤²à¥à¤¯ à¤¬à¤¦à¤²à¥‡à¤‚',0),(167176,4644,'ms','Tukar semua harga',0),(167177,4644,'ar','ØªØºÙŠÙŠØ± Ø£Ø³Ø¹Ø§Ø± Ø¬Ù…ÙŠØ¹',0),(167178,4644,'fr','Modifier les prix de tous les',0),(167179,4644,'jp','å…¨ã?¦ã?®å€¤æ®µã‚’å¤‰æ›´ã?™ã‚‹',0),(167180,4644,'pt','Mudar todos os preÃ§os',0),(167181,4644,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ñ†ÐµÐ½Ñ‹',0),(167182,4644,'es','Cambiar Todos los Precios',0),(167183,4644,'de','Alle Preise Ã¤ndern',0),(167184,4644,'en','Change All Prices',0),(167185,4645,'is','',0),(167186,4645,'dr','ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ø¨Ù‡ ',0),(167187,4645,'pr','ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ø¨Ù‡ ',0),(167188,4645,'tr','Fiyat-e doÄŸru deÄŸiÅŸtirmek',0),(167189,4645,'pl','Zmiana ceny',0),(167190,4645,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ñ†ÐµÐ½Ð°Ñ‚Ð° Ð½Ð°',0),(167191,4645,'ur','Ù‚ÛŒÙ…Øª Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(167192,4645,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ñ†ÐµÐ½Ð°',0),(167193,4645,'vi','Thay Ä‘á»•i giÃ¡ tá»›i',0),(167194,4645,'af','Verander Prys Na',0),(167195,4645,'ro','Schimba preÅ£ul',0),(167196,4645,'et','Muuda hinda',0),(167197,4645,'si','Sprememba cene',0),(167198,4645,'ba','Perubahan harga',0),(167199,4645,'nl','Prijs te veranderen',0),(167200,4645,'fi','Muuttaa hinta',0),(167201,4645,'no','Endre prisen til',0),(167202,4645,'da','Ã†ndre prisen til',0),(167203,4645,'ko','ê°€ê²© ë³€ê²½',0),(167204,4645,'he','×©×™× ×•×™ ×ž×—×™×¨',0),(167205,4645,'el','Î‘Î»Î»Î±Î³Î® Ï„Î¹Î¼Î® Î½Î±',0),(167206,4645,'zh','æ”¹å˜ä»·æ ¼åˆ°\r\n',0),(167207,4645,'sv','Ã„ndra pris till',0),(167208,4645,'it','Cambiare il prezzo a',0),(167209,4645,'tl','',0),(167210,4645,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3619;&#3634;&#3588;&#3634;&#3652;&#3611;&#3626;&#3641;&#3656;',0),(167211,4645,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¬à¤¦à¤²à¥‡à¤‚',0),(167212,4645,'ms','Perubahan harga untuk',0),(167213,4645,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¥Ù„Ù‰',0),(167214,4645,'fr','Modifier les prix de',0),(167215,4645,'jp','å€¤æ®µã‚’å¤‰æ›´',0),(167216,4645,'pt','MudanÃ§a de preÃ§o a',0),(167217,4645,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ†ÐµÐ½Ñƒ',0),(167218,4645,'es','Cambiar Precio A',0),(167219,4645,'de','Preis zu Ã¤ndern',0),(167220,4645,'en','Change Price To',0),(167221,4646,'is','',0),(167222,4646,'dr','Ù‚ÙŠÙ…Øª Ø¬Ø§Ø±ÙŠ ',0),(167223,4646,'pr','Ù‚ÙŠÙ…Øª Ø¬Ø§Ø±ÙŠ ',0),(167224,4646,'tr','Åžu anki fiyatÄ±',0),(167225,4646,'pl','Aktualna cena',0),(167226,4646,'bg','Ð¢ÐµÐºÑƒÑ‰Ð° Ñ†ÐµÐ½Ð°',0),(167227,4646,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ù‚ÛŒÙ…Øª',0),(167228,4646,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ðµ Ñ†ÐµÐ½Ðµ',0),(167229,4646,'vi','GiÃ¡ hiá»‡n thá»i ',0),(167230,4646,'af','Huidige Prys',0),(167231,4646,'ro','PreÅ£ul curent de',0),(167232,4646,'et','Praegune hind',0),(167233,4646,'si','Trenutna cena',0),(167234,4646,'ba','Harga saat ini',0),(167235,4646,'nl','Huidige prijs',0),(167236,4646,'fi','Nykyinen hinta',0),(167237,4646,'no','Gjeldende pris',0),(167238,4646,'da','NuvÃ¦rende pris',0),(167239,4646,'ko','í˜„ìž¬ ê°€ê²©',0),(167240,4646,'he','×”×ž×—×™×¨ ×”× ×•×›×—×™',0),(167241,4646,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï„Î¹Î¼Î®',0),(167242,4646,'zh','å½“å‰ä»·æ ¼\r\n',0),(167243,4646,'sv','Nuvarande pris',0),(167244,4646,'it','Prezzo corrente',0),(167245,4646,'tl','',0),(167246,4646,'th','&#3619;&#3634;&#3588;&#3634;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(167247,4646,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‚à¤²à¥à¤¯',0),(167248,4646,'ms','Harga semasa',0),(167249,4646,'ar','Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(167250,4646,'fr','Prix actuel',0),(167251,4646,'jp','ç?¾åœ¨ã?®å€¤æ®µ',0),(167252,4646,'pt','PreÃ§o atual',0),(167253,4646,'ru','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ Ñ†ÐµÐ½Ð°',0),(167254,4646,'es','Precio Actual',0),(167255,4646,'de','Aktueller Preis',0),(167256,4646,'en','Current Price',0),(167257,4647,'is','',0),(167258,4647,'dr','ØªØ®ÙÙŠÙ  Ø¬Ù‡Øª Ø§Ø¹Ù…Ø§Ù„ ÙƒØ±Ø¯Ù† ',0),(167259,4647,'pr','ØªØ®ÙÙŠÙ  Ø¬Ù‡Øª Ø§Ø¹Ù…Ø§Ù„ ÙƒØ±Ø¯Ù† ',0),(167260,4647,'tr','Uygulanacak indirim',0),(167261,4647,'pl','ZniÅ¼ki do zastosowania',0),(167262,4647,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð·Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°Ð½Ðµ',0),(167263,4647,'ur','Ù„Ú¯Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø±Ø¹Ø§ÛŒØª',0),(167264,4647,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð·Ð° Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ñƒ',0),(167265,4647,'vi','Chiáº¿t kháº¥u Ä‘á»ƒ Ã¡p dá»¥ng',0),(167266,4647,'af','Korting vir Toepassing',0),(167267,4647,'ro','Reducere a aplica',0),(167268,4647,'et','Allahindluse rakendamiseks',0),(167269,4647,'si','Popust uporabljajo',0),(167270,4647,'ba','Diskon untuk menerapkan',0),(167271,4647,'nl','Korting toe te passen',0),(167272,4647,'fi','Alennuksen saamiseksi',0),(167273,4647,'no','Rabatt gjelder',0),(167274,4647,'da','Rabat til at anvende',0),(167275,4647,'ko','í• ì¸ ì ìš©',0),(167276,4647,'he','×”× ×—×” ×›×“×™ ×œ×”×—×™×œ',0),(167277,4647,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Î½Î± ÎµÏ†Î±ÏÎ¼ÏŒÏƒÎµÎ¹',0),(167278,4647,'zh','æŠ˜æ‰£ç”³è¯·\r\n',0),(167279,4647,'sv','Rabatt att tillÃ¤mpa',0),(167280,4647,'it','Sconto da applicare',0),(167281,4647,'tl','',0),(167282,4647,'th','&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;',0),(167283,4647,'hi','à¤›à¥‚à¤Ÿ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(167284,4647,'ms','Diskaun untuk memohon',0),(167285,4647,'ar','Ø§Ù„Ø®ØµÙ… ØªØ·Ø¨ÙŠÙ‚',0),(167286,4647,'fr','RÃ©duction Ã  appliquer',0),(167287,4647,'jp','é?©ç”¨å‰²å¼•',0),(167288,4647,'pt','Desconto para aplicar',0),(167289,4647,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð´Ð»Ñ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(167290,4647,'es','Descuento para Aplicar',0),(167291,4647,'de','Rabatt anwenden',0),(167292,4647,'en','Discount to Apply',0),(167293,4648,'is','',0),(167294,4648,'dr','ØªÙÙƒÙŠÙƒ Ù‚ÙŠÙ…Øª Ø³ÙØ§Ø±Ø´',0),(167295,4648,'pr','ØªÙÙƒÙŠÙƒ Ù‚ÙŠÙ…Øª Ø³ÙØ§Ø±Ø´',0),(167296,4648,'tr','SipariÅŸ fiyat dÃ¶kÃ¼mÃ¼',0),(167297,4648,'pl','Rozbicie ceny zamÃ³wienia',0),(167298,4648,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ñ†ÐµÐ½Ð° Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(167299,4648,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚',0),(167300,4648,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ñ†ÐµÐ½Ð° ÑÐ»Ð¾Ð¼',0),(167301,4648,'vi','GiÃ¡ chi tiáº¿t cá»§a Ä‘Æ¡n hÃ ng',0),(167302,4648,'af','Bestelprys Ontleding',0),(167303,4648,'ro','Comanda Pret defalcare',0),(167304,4648,'et','Tellimuse hind jaotus',0),(167305,4648,'si','Cena razÄlenitev nalog',0),(167306,4648,'ba','Rincian harga pesanan',0),(167307,4648,'nl','Volgorde prijs verdeling',0),(167308,4648,'fi','Jotta erittely',0),(167309,4648,'no','Bestill sammenbrudd',0),(167310,4648,'da','Bestil pris opdeling',0),(167311,4648,'ko','ì£¼ë¬¸ ê°€ê²© ë¶„ì„',0),(167312,4648,'he','×¡×“×¨ ×”×›×¡×¤×™.',0),(167313,4648,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï„Î¹Î¼Î® ÎºÎ±Ï„Î±Î½Î¿Î¼Î®',0),(167314,4648,'zh','è®¢è´­ä»·æ ¼ç»†ç›®\r\n',0),(167315,4648,'sv','BestÃ¤ll pris uppdelning',0),(167316,4648,'it','Ripartizione del prezzo ordine',0),(167317,4648,'tl','',0),(167318,4648,'th','&#3619;&#3634;&#3588;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3610;&#3619;&#3588;&#3604;&#3634;&#3623;&#3609;&#3660;',0),(167319,4648,'hi','à¤‘à¤°à¥à¤¡à¤° à¤®à¥‚à¤²à¥à¤¯ à¤Ÿà¥‚à¤Ÿà¤¨à¤¾',0),(167320,4648,'ms','Pecahan harga pesanan',0),(167321,4648,'ar','Ø§Ù†Ù‡ÙŠØ§Ø± Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø£Ù…Ø±',0),(167322,4648,'fr','Ventilation du prix ordonnance',0),(167323,4648,'jp','æ³¨æ–‡ä¾¡æ ¼å†…è¨³',0),(167324,4648,'pt','Ordem preÃ§o avaria',0),(167325,4648,'ru','Ð—Ð°ÐºÐ°Ð· Ð¦ÐµÐ½Ð° Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(167326,4648,'es','ItemizaciÃ³n de Precio del Orden',0),(167327,4648,'de','Bestellung PreisaufschlÃ¼sselung',0),(167328,4648,'en','Order Price Breakdown',0),(167329,4649,'is','',0),(167330,4649,'dr','(ØªÙˆÙ„ÙŠØ¯ ÙƒØ±Ø¯Ù†) ÙŠØ§ ÙƒØ§Ø± ',0),(167331,4649,'pr','Ù…Ø­ØµÙˆÙ„(ØªÙˆÙ„ÙŠØ¯ ÙƒØ±Ø¯Ù†) ÙŠØ§ ÙƒØ§Ø± ',0),(167332,4649,'tr','ÃœrÃ¼n ya da iÅŸ',0),(167333,4649,'pl','Produktu lub pracy',0),(167334,4649,'bg','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚ Ð¸Ð»Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚ÑÑ‚',0),(167335,4649,'ur','Ù…ØµÙ†ÙˆØ¹Û ÛŒØ§ Ú©Ø§Ù…',0),(167336,4649,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ Ð¸Ð»Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(167337,4649,'vi','Sáº£n pháº©m hay cÃ´ng viá»‡c',0),(167338,4649,'af','Produk of Werk',0),(167339,4649,'ro','Produsul sau locul de muncÄƒ',0),(167340,4649,'et','Toote vÃµi tÃ¶Ã¶',0),(167341,4649,'si','Izdelka ali dela',0),(167342,4649,'ba','Produk atau pekerjaan',0),(167343,4649,'nl','Product of werk',0),(167344,4649,'fi','Tuotteen tai tyÃ¶n',0),(167345,4649,'no','Produktet eller arbeid',0),(167346,4649,'da','Produkt eller arbejde',0),(167347,4649,'ko','ì œí’ˆ ë˜ëŠ” ìž‘ì—…',0),(167348,4649,'he','×ž×•×¦×¨ ××• ×¢×‘×•×“×”',0),(167349,4649,'el','Î ÏÎ¿ÏŠÏŒÎ½ Î® ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(167350,4649,'zh','äº§å“æˆ–å·¥ä½œ\r\n',0),(167351,4649,'sv','Produkt eller arbete',0),(167352,4649,'it','Prodotto o lavoro',0),(167353,4649,'tl','',0),(167354,4649,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3627;&#3619;&#3639;&#3629;&#3591;&#3634;&#3609;',0),(167355,4649,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤¯à¤¾ à¤•à¤¾à¤®',0),(167356,4649,'ms','Produk atau kerja',0),(167357,4649,'ar','Ø§Ù„Ù…Ù†ØªØ¬ Ø£Ùˆ Ø§Ù„Ø¹Ù…Ù„',0),(167358,4649,'fr','Produit ou du travail',0),(167359,4649,'jp','è£½é€ ã?‹ä½œæ¥­',0),(167360,4649,'pt','Produto ou trabalho',0),(167361,4649,'ru','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚ Ð¸Ð»Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(167362,4649,'es','Producto o Trabajo',0),(167363,4649,'de','Produkt oder eine Arbeit',0),(167364,4649,'en','Product or Work',0),(167365,4650,'is','',0),(167366,4650,'dr','ØªÙÙƒÙŠÙƒ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(167367,4650,'pr','ØªÙÙƒÙŠÙƒ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(167368,4650,'tr','Teklif fiyat dÃ¶kÃ¼mÃ¼',0),(167369,4650,'pl','Rozbicie ceny oferty',0),(167370,4650,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ñ†ÐµÐ½Ð° Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(167371,4650,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚',0),(167372,4650,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ñ†ÐµÐ½Ñƒ ÑÐ»Ð¾Ð¼',0),(167373,4650,'vi','PhÃ¢n chia giÃ¡ BÃ¡o giÃ¡ ',0),(167374,4650,'af','Kwotasieprys Ontleding',0),(167375,4650,'ro','Oferta Pret defalcare',0),(167376,4650,'et','Pakkumise hind jaotus',0),(167377,4650,'si','Citiram ceno razÄlenitev',0),(167378,4650,'ba','Kutipan harga rincian',0),(167379,4650,'nl','Offerte prijs verdeling',0),(167380,4650,'fi','Lainaus erittely',0),(167381,4650,'no','Tilbud sammenbrudd',0),(167382,4650,'da','Tilbud pris opdeling',0),(167383,4650,'ko','ê²¬ì  ê°€ê²© ë¶„ì„',0),(167384,4650,'he','×”×¦×¢×ª ×”×ž×—×™×¨ ×”×›×¡×¤×™.',0),(167385,4650,'el','ÎšÎ±Ï„Î±Î½Î¿Î¼Î® Ï„Î¹Î¼Î® Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(167386,4650,'zh','æŠ¥ä»·ä»·æ ¼ç»†ç›®\r\n',0),(167387,4650,'sv','Offert pris uppdelning',0),(167388,4650,'it','Ripartizione del prezzo preventivo',0),(167389,4650,'tl','',0),(167390,4650,'th','&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3648;&#3610;&#3619;&#3588;&#3604;&#3634;&#3623;&#3609;&#3660;',0),(167391,4650,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥€à¤®à¤¤ à¤Ÿà¥‚à¤Ÿà¤¨à¥‡',0),(167392,4650,'ms','Pecahan harga sebut harga',0),(167393,4650,'ar','Ø§Ù‚ØªØ¨Ø³ Ù…Ù† Ø§Ù†Ù‡ÙŠØ§Ø± Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(167394,4650,'fr','Devis ventilation du prix',0),(167395,4650,'jp','ä¾¡æ ¼å†…è¨³ã?®è¦‹ç©?ã‚‚ã‚Š',0),(167396,4650,'pt','DiscriminaÃ§Ã£o de preÃ§o de cotaÃ§Ã£o',0),(167397,4650,'ru','Ð Ð°Ð·Ð±Ð¸Ð²ÐºÐ° Ñ†ÐµÐ½ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(167398,4650,'es','Detalle de Precio de CotizaciÃ³n',0),(167399,4650,'de','Zitat PreisaufschlÃ¼sselung',0),(167400,4650,'en','Quote Price Breakdown',0),(167401,4651,'is','',0),(167402,4651,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬Ø¯Ø¯ Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(167403,4651,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬Ø¯Ø¯ Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(167404,4651,'tr','FiyatlarÄ± yeniden hesapla',0),(167405,4651,'pl','Obliczanie ceny',0),(167406,4651,'bg','ÐŸÑ€ÐµÐ¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¸',0),(167407,4651,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ Ù¾Ú¾Ø± Ø­Ø³Ø§Ø¨ Ù„Ú¯Ø§Ø¦ÛŒÚº',0),(167408,4651,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð½Ð¾ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ñ†ÐµÐ½Ðµ',0),(167409,4651,'vi','TÃ­nh láº¡i giÃ¡',0),(167410,4651,'af','Herbereken Pryse',0),(167411,4651,'ro','Recalculare preturi',0),(167412,4651,'et','Arvuta hind',0),(167413,4651,'si','PreraÄunavanje cen',0),(167414,4651,'ba','Menghitung ulang harga',0),(167415,4651,'nl','Prijzen berekenen',0),(167416,4651,'fi','Laske hinnat',0),(167417,4651,'no','Beregne priser',0),(167418,4651,'da','Genberegne priserne',0),(167419,4651,'ko','ê°€ê²© ë‹¤ì‹œ ê³„ì‚°',0),(167420,4651,'he','×—×™×©×•×‘ ×ž×—×“×© ×©×œ ×ž×—×™×¨×™×',0),(167421,4651,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯ÏƒÎµÎ¹ ÎµÎº Î½Î­Î¿Ï… Ï„Î¹Î¼Î­Ï‚',0),(167422,4651,'zh','é‡æ–°è®¡ç®—ä»·æ ¼\r\n',0),(167423,4651,'sv','RÃ¤kna om priserna',0),(167424,4651,'it','Ricalcolare i prezzi',0),(167425,4651,'tl','',0),(167426,4651,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3619;&#3634;&#3588;&#3634;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(167427,4651,'hi','à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‡à¤‚ à¤«à¤¿à¤° à¤¸à¥‡ à¤ªà¤°à¤¿à¤•à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(167428,4651,'ms','Recalculate harga',0),(167429,4651,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(167430,4651,'fr','Recalculer le prix',0),(167431,4651,'jp','å€¤æ®µã?®å†?è¨ˆç®—',0),(167432,4651,'pt','Recalcular preÃ§os',0),(167433,4651,'ru','ÐŸÐµÑ€ÐµÑÑ‡ÐµÑ‚ Ñ†ÐµÐ½Ñ‹',0),(167434,4651,'es','Recalcular Precios',0),(167435,4651,'de','Preise berechnen',0),(167436,4651,'en','Recalculate Prices',0),(167437,4652,'is','',0),(167438,4652,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬Ø¯Ø¯ Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯ ',0),(167439,4652,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬Ø¯Ø¯ Ø±Ø§ Ù„ØºÙˆ ÙƒÙ†ÙŠØ¯ ',0),(167440,4652,'tr','Geriye doÄŸru yeniden hesapla',0),(167441,4652,'pl','OdwrÃ³ciÄ‡ Oblicz ponownie',0),(167442,4652,'bg','ÐžÐ±Ñ€Ð°Ñ‚ÐµÐ½ ÐŸÑ€ÐµÐ¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð¹',0),(167443,4652,'ur','Ø±ÛŒÙˆØ±Ø³ Ú©Ø§ Ù¾Ú¾Ø± Ø­Ø³Ø§Ø¨ Ù„Ú¯Ø§Ø¦ÛŒÚº',0),(167444,4652,'sr','ÐžÐ±Ñ€Ð½ÑƒÑ‚Ð¸ Ð¿Ð¾Ð½Ð¾Ð²Ð½Ð¾ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ',0),(167445,4652,'vi','TÃ­nh láº¡i Viáº¿t ngÆ°á»£c ',0),(167446,4652,'af','Omgekeerde herbereken',0),(167447,4652,'ro','Inversa recalculare',0),(167448,4652,'et','Arvuta Ã¼mber pÃ¶Ã¶rata',0),(167449,4652,'si','Reverse PreraÄunaj',0),(167450,4652,'ba','Menghitung ulang reverse',0),(167451,4652,'nl','Omgekeerde herberekenen',0),(167452,4652,'fi','KÃ¤Ã¤nteinen Laske',0),(167453,4652,'no','Omvendt Omberegn',0),(167454,4652,'da','Omvendt Genberegn',0),(167455,4652,'ko','ë¦¬ë²„ìŠ¤ ë‹¤ì‹œ ê³„ì‚°',0),(167456,4652,'he','×—×©×‘ ×ž×—×“×© ×”×¤×•×›×”',0),(167457,4652,'el','Î‘Î½Ï„Î¯ÏƒÏ„ÏÎ¿Ï†Î· Î½Î­Î¿Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚',0),(167458,4652,'zh','åå‘é‡æ–°è®¡ç®—\r\n',0),(167459,4652,'sv','OmvÃ¤nd omberÃ¤kning',0),(167460,4652,'it','Ricalcola inversa',0),(167461,4652,'tl','',0),(167462,4652,'th','&#3585;&#3621;&#3633;&#3610;&#3604;&#3657;&#3634;&#3609;&#3588;&#3635;&#3609;&#3623;&#3603;&#3651;&#3627;&#3617;&#3656;',0),(167463,4652,'hi','à¤°à¤¿à¤µà¤°à¥à¤¸ à¤ªà¥à¤¨à¤°à¥à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤•à¤°à¥‡à¤‚',0),(167464,4652,'ms','Berbalik Recalculate',0),(167465,4652,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø­Ø³Ø§Ø¨ Ø¹ÙƒØ³ÙŠ',0),(167466,4652,'fr','Recalculer inverse',0),(167467,4652,'jp','å†?è¨ˆç®—ã‚’ç„¡åŠ¹ã?«ã?™ã‚‹',0),(167468,4652,'pt','Recalcular reversa',0),(167469,4652,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ñ‹Ð¹ Ð¿ÐµÑ€ÐµÑÑ‡ÐµÑ‚',0),(167470,4652,'es','Reversar Recalcular',0),(167471,4652,'de','Reverse neu berechnen',0),(167472,4652,'en','Reverse Recalculate',0),(167473,4653,'is','',0),(167474,4653,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(167475,4653,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(167476,4653,'tr','GÃ¶zden sipariÅŸ maliyeti',0),(167477,4653,'pl','PrzeglÄ…d KolejnoÅ›Ä‡ kosztÃ³w',0),(167478,4653,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(167479,4653,'ur','Ø¬Ø§Ø¦Ø²Û ØªØ±ØªÛŒØ¨ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(167480,4653,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(167481,4653,'vi','BÃ¬nh duyá»‡t giÃ¡ thÃ nh Ä‘Æ¡n hÃ ng',0),(167482,4653,'af','Herbesigtig Bestellingskostes',0),(167483,4653,'ro','Costurile de ordine de revizuire',0),(167484,4653,'et','LÃ¤bivaatamise korra kulud',0),(167485,4653,'si','Pregled nalog stroÅ¡kov',0),(167486,4653,'ba','Tinjauan Order biaya',0),(167487,4653,'nl','Vergelijk Kosten orders',0),(167488,4653,'fi','Tarkastelun kustannuksia',0),(167489,4653,'no','Gjennomgang bestilling kostnader',0),(167490,4653,'da','Anmeldelse omkostninger',0),(167491,4653,'ko','ê²€í†  ì£¼ë¬¸ ë¹„ìš©',0),(167492,4653,'he','×‘×—×Ÿ ×ž×—×™×¨×™ ×”×–×ž× ×•×ª',0),(167493,4653,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î³Î¹Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(167494,4653,'zh','å¤å®¡è®¢å•æˆæœ¬\r\n',0),(167495,4653,'sv','Recension fÃ¶r kostnader',0),(167496,4653,'it','Recensione ordine costi',0),(167497,4653,'tl','',0),(167498,4653,'th','&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(167499,4653,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¥à¤°à¤® à¤²à¤¾à¤—à¤¤',0),(167500,4653,'ms','Kajian kos pesanan',0),(167501,4653,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶ Ù†Ø¸Ø§Ù… Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(167502,4653,'fr','CoÃ»ts de commande de rÃ©vision',0),(167503,4653,'jp','ç™ºæ³¨è²»ã?®ãƒ¬ãƒ“ãƒ¥ãƒ¼',0),(167504,4653,'pt','Custos de pedido de revisÃ£o',0),(167505,4653,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(167506,4653,'es','Revisar Costos de Ordenes',0),(167507,4653,'de','Bewertung Auftragskosten',0),(167508,4653,'en','Review Order Costs',0),(167509,4654,'is','',0),(167510,4654,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ Ø¬Ù‡Øª Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(167511,4654,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ Ø¬Ù‡Øª Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(167512,4654,'tr','GÃ¶zden geÃ§irme iÃ§in sipariÅŸi seÃ§in',0),(167513,4654,'pl','Wybierz w celu przeglÄ…du',0),(167514,4654,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(167515,4654,'ur','ØªØ±ØªÛŒØ¨ Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(167516,4654,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(167517,4654,'vi','Chá»n Ä‘Æ¡n hÃ ng Ä‘á»ƒ bÃ¬nh duyá»‡t',0),(167518,4654,'af','Selekteer Bestelling om Na te speur',0),(167519,4654,'ro','SelectaÅ£i pentru a revizuire',0),(167520,4654,'et','Valige tellimus Review',0),(167521,4654,'si','Izberite nalog za pregled',0),(167522,4654,'ba','Pilih untuk Review',0),(167523,4654,'nl','Selecteer de optie Order Review',0),(167524,4654,'fi','Valitse tilaus Review',0),(167525,4654,'no','Velg Ã¥ anmelde',0),(167526,4654,'da','VÃ¦lg for at anmelde',0),(167527,4654,'ko','ê²€í†  ìˆœì„œ ì„ íƒ',0),(167528,4654,'he','×‘×—×¨ ×”×–×ž× ×” ×œ×¡×™×§×•×¨',0),(167529,4654,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÏƒÎµÎ¹ÏÎ¬ ÏƒÏ„Î·Î½ Î±Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(167530,4654,'zh','é€‰æ‹©ä»¥å®¡æŸ¥\r\n',0),(167531,4654,'sv','VÃ¤lj fÃ¶r att granska',0),(167532,4654,'it','Selezionare l\'ordine di revisione',0),(167533,4654,'tl','',0),(167534,4654,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;',0),(167535,4654,'hi','à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(167536,4654,'ms','Pilih pesanan untuk kajian',0),(167537,4654,'ar','Ø­Ø¯Ø¯ ØªØ±ØªÙŠØ¨ Ù„Ù„Ø§Ø³ØªØ¹Ø±Ø§Ø¶',0),(167538,4654,'fr','SÃ©lectionnez l\'ordre d\'examen',0),(167539,4654,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼ã?™ã‚‹æ³¨æ–‡ã‚’é?¸æŠž',0),(167540,4654,'pt','Selecione a ordem de avaliaÃ§Ã£o',0),(167541,4654,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð· Ð´Ð»Ñ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð°',0),(167542,4654,'es','Seleccionar Orden para Revisar',0),(167543,4654,'de','WÃ¤hlen Sie Reihenfolge zum Review',0),(167544,4654,'en','Select Order to Review',0),(167545,4655,'is','',0),(167546,4655,'dr','( Ø¨ÙŠØ±ÙˆÙ†ÙŠ',0),(167547,4655,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ ÙƒÙ„ Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´ Ø¯ÙˆØ±Ù‡ Ú¯Ø±Ø¯ÙŠ( Ø¨ÙŠØ±ÙˆÙ†ÙŠ',0),(167548,4655,'tr','Toplam tahmini iÃ§in dÄ±ÅŸ Vended',0),(167549,4655,'pl','Suma oszacowania na zewnÄ…trz nabyci przez opiekuna nr',0),(167550,4655,'bg','ÐžÐ±Ñ‰Ð° Ð¾Ñ†ÐµÐ½ÐºÐ° Ð·Ð° Ð¸Ð·Ð²ÑŠÐ½ Vended',0),(167551,4655,'ur','Ú©Ù„ ØªØ®Ù…ÛŒÙ†Û Ú©Û’ Ù„Ø¦Û’ Ø¨Ø§ÛØ± Ú©ÛŒ Ø·Ø±Ù ÙˆØ§Ù†ÚˆÛŒØ¯',0),(167552,4655,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð° Ð·Ð° Ð½Ð°Ð¿Ð¾Ñ™Ñƒ Ð½Ð°Ñ†Ñ€Ñ‚Ð°Ð½Ð¾.',0),(167553,4655,'vi','Tá»•ng cá»™ng dá»± trá»« cho ngÆ°á»i cung cáº¥p ngoÃ i',0),(167554,4655,'af','Totale Skatting vir Buite-Verkoop',0),(167555,4655,'ro','Total estimativ pentru exterior Vended',0),(167556,4655,'et','Kokku kalkulatsiooni eest vÃ¤ljaspool Vended',0),(167557,4655,'si','Skupna ocena za zunaj Vended',0),(167558,4655,'ba','Jumlah perkiraan untuk di luar Vended',0),(167559,4655,'nl','Total raming voor buiten Vended',0),(167560,4655,'fi','YhteensÃ¤ arvio sillÃ¤ ulkopuolella Vended',0),(167561,4655,'no','Total forhÃ¥ndsberegning for utenfor Vended',0),(167562,4655,'da','Total skÃ¸n for udenfor Vended',0),(167563,4655,'ko','ì´ ì˜ˆìƒ ë°–ì— ì„œ Vendedì— ëŒ€ í•œ',0),(167564,4655,'he','×”×›×•×œ×œ ×œ×”×¢×¨×™×š ×›×™ ×‘×—×•×¥ Vended',0),(167565,4655,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ· Î³Î¹Î± Ï„Î¿ ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÏŒ Vended',0),(167566,4655,'zh','å¤–éƒ¨é”€å”®é¢„è®¡æ€»é¢\r\n',0),(167567,4655,'sv','Total uppskattning fÃ¶r utanfÃ¶r Vended',0),(167568,4655,'it','Totale stima per esterno Vended',0),(167569,4655,'tl','',0),(167570,4655,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(167571,4655,'hi','à¤•à¥à¤² à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤•à¥‡ à¤¬à¤¾à¤¹à¤° Vended à¤•à¥‡ à¤²à¤¿à¤',0),(167572,4655,'ms','Jumlah anggaran untuk di luar Vended',0),(167573,4655,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ØªÙ‚Ø¯ÙŠØ±Ø§Øª Ù„Ø®Ø§Ø±Ø¬ ÙÙŠÙ†Ø¯ÙŠØ¯',0),(167574,4655,'fr','Total estimation car vendue Ã  l\'extÃ©rieur du',0),(167575,4655,'jp','å¤–éƒ¨è²©å£²ã?®è¦‹ç©?ã‚Šå?ˆè¨ˆ',0),(167576,4655,'pt','Total estimativa para fora Vended',0),(167577,4655,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¾Ñ†ÐµÐ½ÐºÐ° Ð·Ð° Ð²Ð½Ðµ Vended',0),(167578,4655,'es','Total Vendido para EstimaciÃ³n Afuera ',0),(167579,4655,'de','Insgesamt SchÃ¤tzung fÃ¼r AuÃŸenaufnahmen Vended',0),(167580,4655,'en','Total Estimate for Outside Vended',0),(167581,4656,'is','',0),(167582,4656,'dr','Ø¬Ù‡Øª Ø§ÙØ²ÙˆØ¯Ù† Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(167583,4656,'pr','Ø¬Ù‡Øª Ø§ÙØ²ÙˆØ¯Ù† Ù‚ÙŠÙ…Øª Ù‡Ø§',0),(167584,4656,'tr','TÃ¼m fiyatlar',0),(167585,4656,'pl','do wszystkich cen',0),(167586,4656,'bg','ÐºÑŠÐ¼ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ†ÐµÐ½Ð¸',0),(167587,4656,'ur','ØªÙ…Ø§Ù… Ù‚ÛŒÙ…ØªÙˆÚº Ù¾Ø±',0),(167588,4656,'sr','Ð´Ð° ÑÐ²Ðµ Ñ†ÐµÐ½Ðµ',0),(167589,4656,'vi','tá»›i táº¥t cáº£ giÃ¡',0),(167590,4656,'af','vir alle Pryse',0),(167591,4656,'ro','la toate preturile',0),(167592,4656,'et','kÃµigile hindadele',0),(167593,4656,'si','v vse cene',0),(167594,4656,'ba','Semua harga',0),(167595,4656,'nl','Alle prijzen',0),(167596,4656,'fi','kaikkiin hintoihin',0),(167597,4656,'no','Alle priser',0),(167598,4656,'da','alle priser',0),(167599,4656,'ko','ëª¨ë“  ê°€ê²©',0),(167600,4656,'he','×œ×›×œ ×”×ž×—×™×¨×™×',0),(167601,4656,'el','Î½Î± ÏŒÎ»ÎµÏ‚ Î¿Î¹ Ï„Î¹Î¼Î­Ï‚',0),(167602,4656,'zh','æ‰€æœ‰ä»·æ ¼\r\n',0),(167603,4656,'sv','till alla priser',0),(167604,4656,'it','a tutti i prezzi',0),(167605,4656,'tl','',0),(167606,4656,'th','&#3606;&#3638;&#3591;&#3619;&#3634;&#3588;&#3634;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(167607,4656,'hi','à¤¸à¤­à¥€ à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤•à¥‹',0),(167608,4656,'ms','untuk semua harga',0),(167609,4656,'ar','Ø£Ù† Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(167610,4656,'fr','Ã  tous les prix',0),(167611,4656,'jp','å…¨ã?¦ã?®ä¾¡æ ¼ã?«',0),(167612,4656,'pt','para todos os preÃ§os',0),(167613,4656,'ru','Ð’ÑÐµ Ñ†ÐµÐ½Ñ‹',0),(167614,4656,'es','a todos los Precios',0),(167615,4656,'de','Alle Preise',0),(167616,4656,'en','to all Prices',0),(167617,4657,'is','',0),(167618,4657,'dr','Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(167619,4657,'pr','Ù†Ø§Ø­ÙŠÙ‡ ÙƒØ§Ø±ÙŠ ',0),(167620,4657,'tr','Ã‡alÄ±ÅŸma alanÄ±',0),(167621,4657,'pl','Obszar roboczy',0),(167622,4657,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(167623,4657,'ur','Ú©Ø§Ù… Ú©Û’ Ø¹Ù„Ø§Ù‚Û’',0),(167624,4657,'sr','Ð Ð°Ð´Ð½Ð¸ Ð¿Ñ€Ð¾ÑÑ‚Ð¾Ñ€',0),(167625,4657,'vi','Khu vá»±c lÃ m viá»‡c',0),(167626,4657,'af','Werkarea',0),(167627,4657,'ro','Zona de lucru',0),(167628,4657,'et','TÃ¶Ã¶ ala',0),(167629,4657,'si','Delovno podroÄje',0),(167630,4657,'ba','Area kerja',0),(167631,4657,'nl','Werkgebied',0),(167632,4657,'fi','TyÃ¶skentelyalue',0),(167633,4657,'no','ArbeidsomrÃ¥det',0),(167634,4657,'da','ArbejdsomrÃ¥de',0),(167635,4657,'ko','ìž‘ì—… ì˜ì—­',0),(167636,4657,'he','×ž×©×˜×— ×¢×‘×•×“×”',0),(167637,4657,'el','Î ÎµÏÎ¹Î¿Ï‡Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(167638,4657,'zh','å·¥ä½œåŒº\r\n',0),(167639,4657,'sv','ArbetsomrÃ¥det',0),(167640,4657,'it','Area di lavoro',0),(167641,4657,'tl','',0),(167642,4657,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(167643,4657,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(167644,4657,'ms','Kawasan kerja',0),(167645,4657,'ar','Ù…Ø¬Ø§Ù„ Ø§Ù„Ø¹Ù…Ù„',0),(167646,4657,'fr','Zone de travail',0),(167647,4657,'jp','å‹¤å‹™åœ°åŸŸ',0),(167648,4657,'pt','Ãrea de trabalho',0),(167649,4657,'ru','ÐžÐ±Ð»Ð°ÑÑ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(167650,4657,'es','Ãrea de Trabajo',0),(167651,4657,'de','Arbeitsbereich',0),(167652,4657,'en','Work Area',0),(167653,4658,'is','',0),(167654,4658,'dr','(Ù‡Ø²ÙŠÙ†Ù‡ ÙˆØ§Ù‚Ø¹ÙŠ)',0),(167655,4658,'pr','Ø¨Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡(Ù‡Ø²ÙŠÙ†Ù‡ ÙˆØ§Ù‚Ø¹ÙŠ)',0),(167656,4658,'tr','Fiili maliyet',0),(167657,4658,'pl','Koszt rzeczywisty',0),(167658,4658,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(167659,4658,'ur','Ø§Ø³ Ú©ÛŒ Ø§ØµÙ„ Ù‚ÛŒÙ…Øª',0),(167660,4658,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(167661,4658,'vi','GiÃ¡ thÃ nh Thá»±c táº¿',0),(167662,4658,'af','Werklike Koste',0),(167663,4658,'ro','Cost actual',0),(167664,4658,'et','Tegelik kulu',0),(167665,4658,'si','Dejanski stroÅ¡ki',0),(167666,4658,'ba','Biaya Aktual',0),(167667,4658,'nl','Werkelijke kosten',0),(167668,4658,'fi','Todelliset kustannukset',0),(167669,4658,'no','Faktiske kostnader',0),(167670,4658,'da','Faktiske omkostninger',0),(167671,4658,'ko','ì‹¤ì œ ë¹„ìš©',0),(167672,4658,'he','×¢×œ×•×ª ×‘×¤×•×¢×œ',0),(167673,4658,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(167674,4658,'zh','å®žé™…æˆæœ¬\r\n',0),(167675,4658,'sv','Faktisk kostnad',0),(167676,4658,'it','Costo attuale',0),(167677,4658,'tl','',0),(167678,4658,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3592;&#3619;&#3636;&#3591;',0),(167679,4658,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤²à¤¾à¤—à¤¤',0),(167680,4658,'ms','Kos sebenar',0),(167681,4658,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„ÙØ¹Ù„ÙŠØ©',0),(167682,4658,'fr','CoÃ»t rÃ©el',0),(167683,4658,'jp','å®Ÿè²»',0),(167684,4658,'pt','Custo real',0),(167685,4658,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(167686,4658,'es','Costo Actual',0),(167687,4658,'de','TatsÃ¤chlichen Kosten',0),(167688,4658,'en','Actual Cost',0),(167689,4659,'is','',0),(167690,4659,'dr','Ù†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø±Ø§ Ú†Ø§Ù¾ Ùˆ Ø§ÙŠÙ…ÙŠÙ„ ÙƒÙ†ÙŠØ¯',0),(167691,4659,'pr','Ù†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø±Ø§ Ú†Ø§Ù¾ Ùˆ Ø§ÙŠÙ…ÙŠÙ„ ÙƒÙ†ÙŠØ¯',0),(167692,4659,'tr','E-posta ve fiyat teklifi yazdÄ±rmak iÃ§in tÄ±klayÄ±nÄ±z',0),(167693,4659,'pl','Kliknij tutaj, aby E-mail i wydrukowaÄ‡ cytat',0),(167694,4659,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¸ Ð´Ð° Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(167695,4659,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø¯ÙŠÙƒÚ¾ÙŠÚº: Ú†Ú¾Ø§Ù¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(167696,4659,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ Ð¸ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(167697,4659,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ Email vÃ  in bÃ¡o giÃ¡',0),(167698,4659,'af','Kliek hier om te E-pos en Druk Kwotasie',0),(167699,4659,'ro','Click aici pentru a E-mail ÅŸi citat de imprimare',0),(167700,4659,'et','Vajuta siia, et e-posti ja Prindi pakkumine',0),(167701,4659,'si','Kliknite tukaj, da Email in natisniti, citat',0),(167702,4659,'ba','Klik di sini untuk Email dan mencetak kutipan',0),(167703,4659,'nl','Klik hier om te e-mailen en offerte afdrukken',0),(167704,4659,'fi','Klikkaa tÃ¤stÃ¤ sÃ¤hkÃ¶postitse ja tulostaa lainaus',0),(167705,4659,'no','Klikk her for Ã¥ sende og skrive ut tilbud',0),(167706,4659,'da','Klik her for at E-mail og udskrive citat',0),(167707,4659,'ko','ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ ì—¬ ì´ë©”ì¼ ê²¬ì  ì¸ì‡„',0),(167708,4659,'he','×œ×—×¦×• ×›××Ÿ ×œ×§×‘×œ×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™ ×•×œ×”×“×¤×™×¡ ×”×¦×¢×ª ×ž×—×™×¨',0),(167709,4659,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± ÏƒÏ„ÎµÎ¯Î»ÎµÏ„Îµ Email ÎºÎ±Î¹ Î½Î± ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(167710,4659,'zh','ç‚¹å‡»è¿™é‡Œä»¥ç”µé‚®å’Œæ‰“å°æŠ¥ä»·\r\n',0),(167711,4659,'sv','Klicka hÃ¤r fÃ¶r att maila och skriva ut offertposter',0),(167712,4659,'it','Clicca qui per E-mail e stampare il preventivo',0),(167713,4659,'tl','',0),(167714,4659,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3626;&#3656;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3649;&#3621;&#3632;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3614;&#3641;&#3604;',0),(167715,4659,'hi','à¤ˆà¤®à¥‡à¤² à¤”à¤° à¤¬à¥‹à¤²à¥€ à¤•à¥‹ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(167716,4659,'ms','Klik di sini untuk e-mel dan mencetak petikan',0),(167717,4659,'ar','Ø£Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¥Ø±Ø³Ø§Ù„ Ùˆ Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(167718,4659,'fr','Cliquez ici pour envoyer un Email et imprimer des devis',0),(167719,4659,'jp','Eãƒ¡ãƒ¼ãƒ«é€?ä¿¡ã?¨è¦‹ç©?ã‚Šå?°åˆ·ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(167720,4659,'pt','Clique aqui para enviar E-mail e imprimir cotaÃ§Ã£o',0),(167721,4659,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(167722,4659,'es','Click AquÃ­ para Mandar un Email y Imprimir la CotizaciÃ³n',0),(167723,4659,'de','Klicken Sie hier, um Email und Drucken zitieren',0),(167724,4659,'en','Click Here to Email and Print Quote',0),(167725,4660,'is','',0),(167726,4660,'dr','Ø´Ø±Ø­ ',0),(167727,4660,'pr','Ø´Ø±Ø­ ',0),(167728,4660,'tr','AÃ§Ä±klama',0),(167729,4660,'pl','Opis',0),(167730,4660,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(167731,4660,'ur','ØªØµØ±ÛŒØ­',0),(167732,4660,'sr','ÐžÐ¿Ð¸Ñ',0),(167733,4660,'vi','MÃ´ Táº£',0),(167734,4660,'af','Beskrywing',0),(167735,4660,'ro','Descriere',0),(167736,4660,'et','Kirjeldus',0),(167737,4660,'si','Opis',0),(167738,4660,'ba','Deskripsi',0),(167739,4660,'nl','Beschrijving',0),(167740,4660,'fi','Kuvaus',0),(167741,4660,'no','Beskrivelse',0),(167742,4660,'da','Beskrivelse',0),(167743,4660,'ko','ì„¤ëª…',0),(167744,4660,'he','×ª×™××•×¨',0),(167745,4660,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(167746,4660,'zh','è¯´æ˜Ž\r\n',0),(167747,4660,'sv','Beskrivning',0),(167748,4660,'it','Descrizione',0),(167749,4660,'tl','',0),(167750,4660,'th','&#3585;&#3634;&#3619;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(167751,4660,'hi','à¤µà¤¿à¤µà¤°à¤£',0),(167752,4660,'ms','Description/kawalan',0),(167753,4660,'ar','Ø§Ù„ÙˆØµÙ',0),(167754,4660,'fr','Description',0),(167755,4660,'jp','è§£èª¬',0),(167756,4660,'pt','DescriÃ§Ã£o',0),(167757,4660,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(167758,4660,'es','DescripciÃ³n',0),(167759,4660,'de','Beschreibung',0),(167760,4660,'en','Description',0),(167761,4661,'is','',0),(167762,4661,'dr','Ù‡ÙŠÚ† Ø§ÙŠÙ…ÙŠÙ„ÙŠ ØªØ§ÙƒÙ†ÙˆÙ† ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(167763,4661,'pr','Ù‡ÙŠÚ† Ø§ÙŠÙ…ÙŠÙ„ÙŠ ØªØ§ÙƒÙ†ÙˆÙ† ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(167764,4661,'tr','HiÃ§bir e-postalarÄ± henÃ¼z girilen olmuÅŸtur',0),(167765,4661,'pl','Nie e-maile zostaÅ‚y wprowadzone jeszcze',0),(167766,4661,'bg','Ð‘ÐµÐ· Ð¸Ð¼ÐµÐ¹Ð»Ð¸ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð²Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð¾Ñ‰Ðµ',0),(167767,4661,'ur','Ú©ÙˆØ¦ÛŒ Ø§ÛŒ Ù…ÛŒÙ„Ø² Ø§Ø¨Ú¾ÛŒ Ø¯Ø§Ø®Ù„ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(167768,4661,'sr','ÐÐµÐ¼Ð° Ðµ-Ð¼Ð°Ð¸Ð»Ð¾Ð²Ðµ Ð±Ð¸Ð»Ð¾ Ð¸Ð¿Ð°Ðº ÑƒÑˆÐ°Ð¾',0),(167769,4661,'vi','Email chÆ°a cÃ³ ná»™i dung',0),(167770,4661,'af','Geen E-posse is Tans Gevoer',0),(167771,4661,'ro','Nu e-mailuri au fost Ã®ncÄƒ introduse',0),(167772,4661,'et','Ei kirju on kantud veel',0),(167773,4661,'si','Brez e-poÅ¡te so bili vneseni Å¡e',0),(167774,4661,'ba','Tidak ada email belum masuk',0),(167775,4661,'nl','Geen E-mails zijn ingevoerd nog',0),(167776,4661,'fi','Ei sÃ¤hkÃ¶posteja on tullut vielÃ¤',0),(167777,4661,'no','Ingen e-post har blitt skrevet ennÃ¥',0),(167778,4661,'da','Ingen E-mails har vÃ¦ret indtastet endnu',0),(167779,4661,'ko','ì•„ë‹ˆ ì´ë©”ì¼ ì•„ì§ ìž…ë ¥ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(167780,4661,'he','×‘×œ×™ ××™×ž×™×™×œ×™× ×™×© ×›×‘×¨ × ×›× ×¡',0),(167781,4661,'el','Î¤Î± Î¼Î·Î½ÏÎ¼Î±Ï„Î± Î´ÎµÎ½ Î­Ï‡Î¿Ï…Î½ ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯ Î±ÎºÏŒÎ¼Î±',0),(167782,4661,'zh','è¿˜æ²¡æœ‰æ²¡æœ‰å·²ç»è¾“å…¥çš„ç”µå­é‚®ä»¶\r\n',0),(167783,4661,'sv','Inga e-postmeddelanden har varit in Ã¤nnu',0),(167784,4661,'it','Non stato inserito ancora nessuna E-mail',0),(167785,4661,'tl','',0),(167786,4661,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3607;&#3637;&#3656;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3651;&#3609;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(167787,4661,'hi','à¤•à¥‹à¤ˆ à¤ˆà¤®à¥‡à¤² à¤…à¤­à¥€ à¤¤à¤• à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(167788,4661,'ms','E-mel tidak telah dimasukkan lagi',0),(167789,4661,'ar','Ù„Ø§ Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù‚Ø¯ ØªÙ… \"Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ Ø¨Ø¹Ø¯\"',0),(167790,4661,'fr','Aucuns courriels n\'ont Ã©tÃ© entrÃ©s encore',0),(167791,4661,'jp','Eãƒ¡ãƒ¼ãƒ«ã?Œã?¾ã? å…¥åŠ›ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(167792,4661,'pt','Sem E-mails foram inseridos ainda',0),(167793,4661,'ru','ÐŸÐ¾ÐºÐ° Ð½ÐµÑ‚ Ð’Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ñ… Email',0),(167794,4661,'es','Ya No se HabÃ­a Entrado Ningunos Emails',0),(167795,4661,'de','Keine E-Mails wurden noch eingegeben',0),(167796,4661,'en','No Emails have been Entered Yet',0),(167797,4662,'is','',0),(167798,4662,'dr','Ù‚ÙŠÙ…Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(167799,4662,'pr','Ù‚ÙŠÙ…Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(167800,4662,'tr','Teklif edilen fiyat',0),(167801,4662,'pl','Cena',0),(167802,4662,'bg','Ð£ÐºÐ°Ð·Ð°Ð½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð°',0),(167803,4662,'ur','Ù†Ù‚Ù„ Ú©ÛŒØ§ Ù‚ÛŒÙ…Øª',0),(167804,4662,'sr','Ð Ð¿Ñ€ÐµÐ½Ð¾ÑÐ¸ Ñ†ÐµÐ½Ð°',0),(167805,4662,'vi','GiÃ¡ Ä‘Ã£ bÃ¡o',0),(167806,4662,'af','Gekwoteerde Pryse',0),(167807,4662,'ro','PreÅ£ul citat',0),(167808,4662,'et','Noteeritud hind',0),(167809,4662,'si','Borzna cena',0),(167810,4662,'ba','Harga dikutip',0),(167811,4662,'nl','Genoteerde prijs',0),(167812,4662,'fi','Tarjoushinta',0),(167813,4662,'no','Tilbudsprisen',0),(167814,4662,'da','BÃ¸rskurs',0),(167815,4662,'ko','ì¸ìš©ëœ ê°€ê²©',0),(167816,4662,'he','×”× ×§×•×‘ ×‘×”×¦×¢×ª ×”×ž×—×™×¨',0),(167817,4662,'el','Î‘Î½Î±Î³ÏÎ±Ï†ÏŒÎ¼ÎµÎ½Î· Ï„Î¹Î¼Î®',0),(167818,4662,'zh','æŠ¥ä»·\r\n',0),(167819,4662,'sv','Marknadskurs',0),(167820,4662,'it','Prezzo quotato',0),(167821,4662,'tl','',0),(167822,4662,'th','&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3649;&#3621;&#3657;&#3623;',0),(167823,4662,'hi','à¤‰à¤¦à¥à¤§à¥ƒà¤¤ à¤®à¥‚à¤²à¥à¤¯',0),(167824,4662,'ms','Disebut harga',0),(167825,4662,'ar','ÙˆÙ†Ù‚Ù„Øª Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(167826,4662,'fr','Prix indiquÃ©',0),(167827,4662,'jp','è¦‹ç©?ã‚‚ã‚Šé¡?',0),(167828,4662,'pt','PreÃ§o entre aspas',0),(167829,4662,'ru','ÐšÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²Ð¾Ñ‡Ð½Ð°Ñ Ñ†ÐµÐ½Ð°',0),(167830,4662,'es','Precio Cotizado',0),(167831,4662,'de','Angebotspreis',0),(167832,4662,'en','Quoted Price',0),(167833,4663,'is','',0),(167834,4663,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´',0),(167835,4663,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´',0),(167836,4663,'tr','SipariÅŸi seÃ§in',0),(167837,4663,'pl','Wybierz kolejnoÅ›Ä‡',0),(167838,4663,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ€ÐµÐ´',0),(167839,4663,'ur','ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(167840,4663,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³',0),(167841,4663,'vi','Chá»n Ä‘Æ¡n hÃ ng',0),(167842,4663,'af','Selekteer Bestelling',0),(167843,4663,'ro','SelectaÅ£i comanda',0),(167844,4663,'et','Valige tellimus',0),(167845,4663,'si','Izberite nalog',0),(167846,4663,'ba','Pilih urutan',0),(167847,4663,'nl','Selecteer Order',0),(167848,4663,'fi','Valitse tilaus',0),(167849,4663,'no','Velg',0),(167850,4663,'da','VÃ¦lg ordre',0),(167851,4663,'ko','ìˆœì„œ ì„ íƒ',0),(167852,4663,'he','×‘×—×¨ ×”×–×ž× ×”',0),(167853,4663,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÏƒÎµÎ¹ÏÎ¬',0),(167854,4663,'zh','é€‰æ‹©è®¢å•\r\n',0),(167855,4663,'sv','VÃ¤lj ordning',0),(167856,4663,'it','Selezionare ordine',0),(167857,4663,'tl','',0),(167858,4663,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(167859,4663,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(167860,4663,'ms','Pilih pesanan',0),(167861,4663,'ar','Ø­Ø¯Ø¯ ØªØ±ØªÙŠØ¨',0),(167862,4663,'fr','SÃ©lectionnez ordre',0),(167863,4663,'jp','æ³¨æ–‡ã‚’é?¸æŠžã?™ã‚‹',0),(167864,4663,'pt','Selecione a ordem',0),(167865,4663,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·',0),(167866,4663,'es','Seleccionar Orden',0),(167867,4663,'de','WÃ¤hlen Sie die Reihenfolge',0),(167868,4663,'en','Select Order',0),(167869,4664,'is','',0),(167870,4664,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§Ø² Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(167871,4664,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§Ø² Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(167872,4664,'tr','AlÄ±ntÄ± dan bu e-posta adresinizi gÃ¶nderin.',0),(167873,4664,'pl','WyÅ›lij ofertÄ™ z tego adresu E-mail',0),(167874,4664,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ',0),(167875,4664,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø³Û’ Ø§Ø³ Ú©Ø§ Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÛŒÚˆØ±ÛŒØ³ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(167876,4664,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ð¸Ð· Ð¿Ð¾ÑˆÐ°Ñ™ÐµÑ‚Ðµ Ð¾Ð²Ñƒ Ðµ-Ð°Ð´Ñ€ÐµÑÑƒ',0),(167877,4664,'vi','Gá»­i BÃ¡o GiÃ¡ tá»« Ä‘á»‹a chá»‰ Email nÃ y',0),(167878,4664,'af','Stuur Kwotasie VANAF hierdie E-posadres',0),(167879,4664,'ro','Trimite citat la aceastÄƒ adresÄƒ de E-mail',0),(167880,4664,'et','Tsitaat: saada E-mail',0),(167881,4664,'si','PoÅ¡lji ponudbo od to Email ogovor',0),(167882,4664,'ba','Mengirim kutipan dari alamat Email ini',0),(167883,4664,'nl','Citaat uit dit e-mailadres verzenden',0),(167884,4664,'fi','LÃ¤hetÃ¤ lainaan tÃ¤hÃ¤n osoitteeseen',0),(167885,4664,'no','Sende sitat fra denne e-postadressen',0),(167886,4664,'da','Send citerer fra denne E-mail-adresse',0),(167887,4664,'ko','ì´ ì´ë©”ì¼ ì£¼ì†Œì—ì„œ ê²¬ì  ë³´ë‚´ê¸°',0),(167888,4664,'he','×©×œ×— ×”×¦×¢×ª ×ž×—×™×¨ ×©×œ ×›×ª×•×‘×ª ×”×“×•× ×œ',0),(167889,4664,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î±Ï€ÏŒ Î±Ï…Ï„Î® Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(167890,4664,'zh','ä»Žæ­¤ç”µå­é‚®ä»¶åœ°å€å‘é€æŠ¥ä»·\r\n',0),(167891,4664,'sv','Skicka offert frÃ¥n denna e-postadress',0),(167892,4664,'it','Inviare preventivo da questo indirizzo Email',0),(167893,4664,'tl','',0),(167894,4664,'th','&#3626;&#3656;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3592;&#3634;&#3585;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3609;&#3',0),(167895,4664,'hi','à¤‡à¤¸ à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¥‡ à¤¸à¥‡ à¤¬à¥‹à¤²à¥€ à¤­à¥‡à¤œà¥‡à¤‚',0),(167896,4664,'ms','Menghantar sebut harga dari alamat e-mel ini',0),(167897,4664,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(167898,4664,'fr','Envoyer devis depuis cette adresse Email',0),(167899,4664,'jp','ã?“ã?®ï¼¥ãƒ¡ãƒ¼ãƒ«ã‚¢ãƒ‰ãƒ¬ã‚¹ã?‹ã‚‰è¦‹ç©?ã‚‚ã‚Šã‚’é€?ã‚‹',0),(167900,4664,'pt','Enviar cotaÃ§Ã£o deste endereÃ§o de E-mail',0),(167901,4664,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°ÑÐ²ÐºÑƒ Ð¾Ñ‚ ÑÑ‚Ð¾Ð³Ð¾ Ð°Ð´Ñ€ÐµÑÐ° ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(167902,4664,'es','Enviar CotizaciÃ³n DE esta DirecciÃ³n de Email',0),(167903,4664,'de','Zitat von diese E-Mail-Adresse senden',0),(167904,4664,'en','Send Quote FROM this Email Address',0),(167905,4665,'is','',0),(167906,4665,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ù‡ Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„',0),(167907,4665,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ù‡ Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„',0),(167908,4665,'tr','Teklif iÃ§in bu e-posta adresinizi gÃ¶nderin.',0),(167909,4665,'pl','WyÅ›lij ofertÄ™ na ten adres E-mail',0),(167910,4665,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ',0),(167911,4665,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Ùˆ Ø§Ø³ Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÛŒÚˆØ±ÛŒØ³ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(167912,4665,'sr','Ð¡Ð»Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð¾Ð²Ñƒ Ðµ-Ð°Ð´Ñ€ÐµÑÑƒ',0),(167913,4665,'vi','Gá»­i BÃ¡o GiÃ¡ Äáº¿n Ä‘á»‹a chá»‰ email nÃ y',0),(167914,4665,'af','Stuur Kwotasie NA hierdie E-posadres',0),(167915,4665,'ro','Trimite citat pentru aceastÄƒ adresÄƒ de E-mail',0),(167916,4665,'et','Saada pakkumine sellele aadressile',0),(167917,4665,'si','Poslati citiram to Email ogovor',0),(167918,4665,'ba','Mengirim Penawaran ke alamat Email ini',0),(167919,4665,'nl','Citeer naar dit e-mailadres verzenden',0),(167920,4665,'fi','LÃ¤hetÃ¤ lainaan tÃ¤hÃ¤n osoitteeseen',0),(167921,4665,'no','Send tilbud til denne e-postadressen',0),(167922,4665,'da','Send tilbud til denne E-mail-adresse',0),(167923,4665,'ko','ì´ ì´ë©”ì¼ ì£¼ì†Œì— ê²¬ì  ë³´ë‚´ê¸°',0),(167924,4665,'he','×©×œ×— ×”×¦×¢×ª ×ž×—×™×¨ ××œ ×›×ª×•×‘×ª ×”×“×•× ×œ',0),(167925,4665,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î½Î± Î±Î½Î±Ï†Î­ÏÏ‰ Î±Ï…Ï„Î® Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(167926,4665,'zh','å‘é€æŠ¥ä»·åˆ°è¿™ä¸ªç”µå­é‚®ä»¶åœ°å€\r\n',0),(167927,4665,'sv','Skicka offert till denna e-postadress',0),(167928,4665,'it','Invia citare a questo indirizzo Email',0),(167929,4665,'tl','',0),(167930,4665,'th','&#3626;&#3656;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3609;&#3',0),(167931,4665,'hi','à¤‡à¤¸ à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¥‡ à¤‰à¤¦à¥à¤§à¥ƒà¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œà¥‡à¤‚',0),(167932,4665,'ms','Hantar sebut harga ke alamat e-mel ini',0),(167933,4665,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¥Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù‡Ø°Ø§',0),(167934,4665,'fr','Envoyer devis Ã  cette adresse E-mail',0),(167935,4665,'jp','ã?“ã?®ï¼¥ãƒ¡ãƒ¼ãƒ«ã‚¢ãƒ‰ãƒ¬ã‚¹ã?«è¦‹ç©?ã‚‚ã‚Šã‚’é€?ã‚‹',0),(167936,4665,'pt','Enviar cotaÃ§Ã£o para este endereÃ§o de E-mail',0),(167937,4665,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°ÑÐ²ÐºÑƒ Ð½Ð° ÑÑ‚Ð¾Ñ‚ Ð°Ð´Ñ€ÐµÑ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(167938,4665,'es','Enviar CotizaciÃ³n A esta DirecciÃ³n de Email',0),(167939,4665,'de','Quote an diese E-Mail-Adresse senden',0),(167940,4665,'en','Send Quote TO this Email Address',0),(167941,4666,'is','',0),(167942,4666,'dr','Ø§ÙŠÙ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§ÙŠÙ…ÙŠÙ„  Ø®ÙˆØ§Ù‡Ø¯ Ø´ÙˆØ¯ Ø¨Ù‡ ',0),(167943,4666,'pr','Ø§ÙŠÙ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§ÙŠÙ…ÙŠÙ„  Ø®ÙˆØ§Ù‡Ø¯ Ø´ÙˆØ¯ Ø¨Ù‡ ',0),(167944,4666,'tr','Bu teklif-ecek var olmak-e-posta',0),(167945,4666,'pl','Ten cytat bÄ™dzie e-mailem do',0),(167946,4666,'bg','Ð¢Ð°Ð·Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ñ‰Ðµ Ð±ÑŠÐ´Ðµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½ Ð¸Ð¼ÐµÐ¹Ð» Ð·Ð°',0),(167947,4666,'ur','Ø§Ø³ Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Ùˆ Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© Ú©Û’ Ù„Ø¦Û’ ÛÙˆ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(167948,4666,'sr','ÐžÐ²Ð°Ñ˜ Ñ†Ð¸Ñ‚Ð°Ñ‚ Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð» Ð´Ð°',0),(167949,4666,'vi','BÃ¡o giÃ¡ nÃ y sáº½ Email tá»›i',0),(167950,4666,'af','Hierdie Kwotasie sal ook per E-pos Aangestuur word',0),(167951,4666,'ro','Acest citat va fi prin E-mail la',0),(167952,4666,'et','See tsitaat on e-postiga',0),(167953,4666,'si','Ta citat hoteti obstati Emailed v',0),(167954,4666,'ba','Kutipan ini akan dikirim melalui email ke',0),(167955,4666,'nl','Dit citaat zal worden gemaild naar',0),(167956,4666,'fi','TÃ¤mÃ¤ lainaus on lÃ¤hettÃ¤nyt',0),(167957,4666,'no','Dette tilbudet vil bli sendt til',0),(167958,4666,'da','Dette citat vil blive e-mailes til',0),(167959,4666,'ko','ì´ ê²¬ì ì„ ì´ë©”ì¼ë¡œ ì „ì†¡ ë  ê²ƒìž…ë‹ˆë‹¤.',0),(167960,4666,'he','×”×¦×¢×ª ×ž×—×™×¨ ×–×• ×ª×”×™×” ×‘×“×•× ×œ',0),(167961,4666,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î¸Î± ÎµÎ¯Î½Î±Î¹ Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î³Î¹Î± Î½Î±',0),(167962,4666,'zh','æ­¤æŠ¥ä»·å°†é€šè¿‡ç”µå­é‚®ä»¶å‘é€ç»™\r\n',0),(167963,4666,'sv','Detta citat kommer att skickas till',0),(167964,4666,'it','Questa citazione sarÃ  inviato via email a',0),(167965,4666,'tl','',0),(167966,4666,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3609;&#3637;&#3657;&#3592;&#3632;&#3606;&#3641;&#3585;&#3626;&#3656;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3606;&#3638;&#3591;',0),(167967,4666,'hi','à¤‡à¤¸ à¤¬à¥‹à¤²à¥€ à¤•à¥‹ à¤ˆà¤®à¥‡à¤² à¤•à¤° à¤¦à¥€ à¤¹à¥‹ à¤œà¤¾à¤à¤—à¤¾',0),(167968,4666,'ms','Petikan ini akan melalui e-mel kepada',0),(167969,4666,'ar','ÙˆØ³ÙŠÙƒÙˆÙ† Ù‡Ø°Ø§ Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³ \"Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¥Ù„Ù‰\"',0),(167970,4666,'fr','Cette citation sera envoyÃ© par courriel Ã ',0),(167971,4666,'jp','ã?“ã?®è¦‹ç©?ã‚‚ã‚Šã?®ï¼¥ãƒ¡ãƒ¼ãƒ«é€?ä»˜å…ˆ',0),(167972,4666,'pt','Esta citaÃ§Ã£o serÃ¡ enviado por email para',0),(167973,4666,'ru','Ð­Ñ‚Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° Ð±ÑƒÐ´ÐµÑ‚ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾ Ð½Ð°',0),(167974,4666,'es','Esta CotizaciÃ³n se MandarÃ¡ por Email A',0),(167975,4666,'de','Dieses Zitat wird Emailed zu sein.',0),(167976,4666,'en','This Quote will be Emailed To',0),(167977,4667,'is','',0),(167978,4667,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§',0),(167979,4667,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§',0),(167980,4667,'tr','Birimleri',0),(167981,4667,'pl','Jednostki',0),(167982,4667,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð¸',0),(167983,4667,'ur','ÛŒÙˆÙ†Ù¹',0),(167984,4667,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(167985,4667,'vi','ÄÆ¡n vá»‹',0),(167986,4667,'af','Eenhede',0),(167987,4667,'ro','UnitÄƒÅ£i',0),(167988,4667,'et','Ãœhikud',0),(167989,4667,'si','Enot',0),(167990,4667,'ba','Unit',0),(167991,4667,'nl','Eenheden',0),(167992,4667,'fi','YksikÃ¶t',0),(167993,4667,'no','Enheter',0),(167994,4667,'da','Enheder',0),(167995,4667,'ko','ë‹¨ìœ„',0),(167996,4667,'he','×™×—×™×“×•×ª',0),(167997,4667,'el','ÎœÎ¿Î½Î¬Î´ÎµÏ‚',0),(167998,4667,'zh','å•ä½\r\n',0),(167999,4667,'sv','Enheter',0),(168000,4667,'it','UnitÃ ',0),(168001,4667,'tl','',0),(168002,4667,'th','&#3627;&#3609;&#3656;&#3623;&#3618;',0),(168003,4667,'hi','à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(168004,4667,'ms','Unit-unit',0),(168005,4667,'ar','ÙˆØ­Ø¯Ø§Øª',0),(168006,4667,'fr','UnitÃ©s',0),(168007,4667,'jp','å?˜ä½?',0),(168008,4667,'pt','Unidades',0),(168009,4667,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(168010,4667,'es','Unidades',0),(168011,4667,'de','Einheiten',0),(168012,4667,'en','Units',0),(168013,4668,'is','',0),(168014,4668,'dr','(Ø¨Ø§ Ø§Ø±Ø²Ø´',0),(168015,4668,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ø±Ø²Ø´ Ú¯Ø°Ø§Ø±ÙŠ Ø´Ø¯Ù‡(Ø¨Ø§ Ø§Ø±Ø²Ø´',0),(168016,4668,'tr','DeÄŸerli mÃ¼ÅŸteri',0),(168017,4668,'pl','WartoÅ›ci klienta',0),(168018,4668,'bg','Ð¦ÐµÐ½ÐµÐ½ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(168019,4668,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ø§ÛÙ…ÛŒØª',0),(168020,4668,'sr','ÐœÐ¾Ð³ÑƒÑ›Ð½Ð¾ÑˆÑ›Ñƒ ÐºÑƒÐ¿Ñ†Ð°',0),(168021,4668,'vi','KhÃ¡ch hÃ ng quan trá»ng',0),(168022,4668,'af','Gewaardeerde KliÃ«nt/Klant',0),(168023,4668,'ro','Client evaluate',0),(168024,4668,'et','Hinnatud klient',0),(168025,4668,'si','Cenjene stranke',0),(168026,4668,'ba','Pelanggan yang terhormat',0),(168027,4668,'nl','Gewaardeerde klant',0),(168028,4668,'fi','Asiakas',0),(168029,4668,'no','Kunde',0),(168030,4668,'da','Kunde',0),(168031,4668,'ko','ì†Œì¤‘í•œ ê³ ê°',0),(168032,4668,'he','×œ×§×•×— ×ž×•×¢×“×£',0),(168033,4668,'el','Î ÎµÎ»Î¬Ï„Î·',0),(168034,4668,'zh','æœ‰ä»·å€¼çš„å®¢æˆ·\r\n',0),(168035,4668,'sv','Kund',0),(168036,4668,'it','Cliente stimato',0),(168037,4668,'tl','',0),(168038,4668,'th','&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(168039,4668,'hi','à¤®à¥‚à¤²à¥à¤¯à¤µà¤¾à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(168040,4668,'ms','Pelanggan',0),(168041,4668,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ù…Ø­ØªØ±Ù…',0),(168042,4668,'fr','Cher client',0),(168043,4668,'jp','å¾—æ„?å…ˆ',0),(168044,4668,'pt','Cliente valioso',0),(168045,4668,'ru','Ð¦ÐµÐ½Ð½Ð¾Ð³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(168046,4668,'es','Cliente Estimado',0),(168047,4668,'de','GeschÃ¤tzter Kunde',0),(168048,4668,'en','Valued Customer',0),(168049,4669,'is','',0),(168050,4669,'dr','Ù‡Ø± ØªØ§Ø®ÙŠØ±ÙŠ Ø¯Ø± ØªØ§ÙŠÙŠØ¯ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ Ø±Ø§ Ø¹Ù‚Ø¨ Ø¨ÙŠÙ†Ø¯Ø§Ø²Ø¯',0),(168051,4669,'pr','Ù‡Ø± ØªØ§Ø®ÙŠØ±ÙŠ Ø¯Ø± ØªØ§ÙŠÙŠØ¯ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ Ø±Ø§ Ø¹Ù‚Ø¨ Ø¨ÙŠÙ†Ø¯Ø§Ø²Ø¯',0),(168052,4669,'tr','Herhangi bir gecikme onay sevk tarihini geciktirebilir.',0),(168053,4669,'pl','Wszelkie opÃ³Åºnienia w homologacji moÅ¼e opÃ³ÅºniÄ‡ Data wysyÅ‚ki',0),(168054,4669,'bg','Ð—Ð°Ð±Ð°Ð²ÑÐ½ÐµÑ‚Ð¾ Ð½Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ñ‚Ð»Ð¾Ð¶Ð¸ Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð°',0),(168055,4669,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ù…ÛŒÚº Ú©ÙˆØ¦ÛŒ ØªØ§Ø®ÛŒØ± ØªØ§Ø®ÛŒØ± Ú©ÛŒ Ø¬Ø§ Ø³Ú©Ø§',0),(168056,4669,'sr','Ð¡Ð²Ð°ÐºÐ¾ ÐºÐ°ÑˆÑšÐµÑšÐµ Ñƒ Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ Ð¼Ð¾Ð¶Ðµ Ð·Ð°Ð´Ñ€Ð¶Ð°Ñ‚Ð¸ Ð±Ñ€Ð¾Ð´ Ð´Ð°Ñ‚ÑƒÐ¼',0),(168057,4669,'vi','Cháº­m trá»… trong phÃª duyá»‡t cÃ³ thá»ƒ lÃ m cháº­m ngÃ y váº­n chuyá»ƒn',0),(168058,4669,'af','Enige oponthoud in die goedkeuring, kan die Versendingsdatum vertraag',0),(168059,4669,'ro','Orice Ã®ntÃ¢rzieri Ã®n aprobarea ar putea Ã®ntÃ¢rzia data navei',0),(168060,4669,'et','KÃµik viivitused kinnitamisel vÃµivad edasi lÃ¼kata tarneaega',0),(168061,4669,'si','KakrÅ¡ne koli zamude pri odobritvi lahko odloÅ¾ijo datum',0),(168062,4669,'ba','Penundaan dalam Persetujuan dapat menunda tanggal kapal',0),(168063,4669,'nl','Eventuele vertragingen in de goedkeuring zou kunnen vertragen de verzenddatum',0),(168064,4669,'fi','HyvÃ¤ksymisen viivÃ¤stymisen viivÃ¤styttÃ¤Ã¤ lÃ¤hetyspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(168065,4669,'no','Forsinkelser i godkjenning kan forsinke forsendelsesdatoen',0),(168066,4669,'da','Enhver forsinkelse i godkendelsen kunne forsinke afsendelsesdatoen',0),(168067,4669,'ko','ìŠ¹ì¸ì— ì–´ë–¤ ì§€ì—° ë°°ì†¡ì¼ ì§€ì—° ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(168068,4669,'he','×›×œ ×”×¢×™×›×•×‘×™× ×‘××™×©×•×¨ ×™×›×•×œ ×œ×¢×›×‘ ××ª ×”×ª××¨×™×š ×”×¡×¤×™× ×”',0),(168069,4669,'el','Î•Î½Î´ÎµÏ‡ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎºÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ®ÏƒÎµÎ¹Ï‚ ÏƒÏ„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ· Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± ÎºÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ®ÏƒÎµÎ¹ Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(168070,4669,'zh','åœ¨æ‰¹å‡†ä»»ä½•æ‹–å»¶å¯èƒ½ä¼šæŽ¨è¿Ÿå‘è´§æ—¥æœŸ\r\n',0),(168071,4669,'sv','Eventuella fÃ¶rseningar i godkÃ¤nnandet kan fÃ¶rsena leveransdatumet',0),(168072,4669,'it','Eventuali ritardi nell\'approvazione potrebbero ritardare la data di spedizione',0),(168073,4669,'tl','',0),(168074,4669,'th','&#3610;&#3634;&#3591;&#3626;&#3636;&#3656;&#3591;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3621;&#3656;&#3634;&#3594;&#3657;&#3634;&#3629;&#3634;&#3592;&#3607;&#3635;&#3651;&#3627;&#3657;&#3623;&#3633;&#3609;&#3607;&#3637;&#3',0),(168075,4669,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¤¿à¤¸à¥€ à¤¦à¥‡à¤°à¥€ à¤•à¥‡ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤®à¥‡à¤‚ à¤¦à¥‡à¤°à¥€ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(168076,4669,'ms','Sebarang kelewatan dalam kelulusan boleh menunda tarikh kapal',0),(168077,4669,'ar','Ø£ÙŠ ØªØ£Ø®ÙŠØ± ÙÙŠ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© ÙŠÙ…ÙƒÙ† Ø£Ù† ÙŠØ¤Ø®Ø± ØªØ§Ø±ÙŠØ® Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(168078,4669,'fr','Tout retard dans l\'approbation pourrait retarder la date d\'expÃ©dition',0),(168079,4669,'jp','æ‰¿èª?ã?«é?…ã‚Œã?Œå‡ºã‚‹ã?¨ç™ºé€?æ—¥ã?Œé?…ã‚Œã‚‹ã?‹ã‚‚ã?—ã‚Œã?¾ã?›ã‚“',0),(168080,4669,'pt','Quaisquer atrasos na aprovaÃ§Ã£o poderiam atrasar a data de envio',0),(168081,4669,'ru','Ð›ÑŽÐ±Ñ‹Ðµ Ð·Ð°Ð´ÐµÑ€Ð¶ÐºÐ¸ Ð² Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ð¸ Ð¼Ð¾Ð¶ÐµÑ‚ Ð·Ð°Ð´ÐµÑ€Ð¶Ð°Ñ‚ÑŒ Ð´Ð°Ñ‚Ñƒ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(168082,4669,'es','Alguna demora en aprobar puede demorar la fecha de envÃ­o',0),(168083,4669,'de','Etwaige VerzÃ¶gerungen bei der Zulassung kÃ¶nnen das Lieferdatum hinausschieben.',0),(168084,4669,'en','Any delays in approval could delay the ship date',0),(168085,4670,'is','',0),(168086,4670,'dr','Ø§Ù…Ø¶Ø§ Ù…Ø¬Ø§Ø²',0),(168087,4670,'pr','Ø§Ù…Ø¶Ø§ Ù…Ø¬Ø§Ø²',0),(168088,4670,'tr','Yetkili imza',0),(168089,4670,'pl','Podpis osoby upowaÅ¼nionej',0),(168090,4670,'bg','ÐžÑ‚Ð¾Ñ€Ð¸Ð·Ð¸Ñ€Ð°Ð½ Ð¿Ð¾Ð´Ð¿Ð¸Ñ',0),(168091,4670,'ur','Ù…Ø¬Ø§Ø² Ø¯Ø³ØªØ®Ø·',0),(168092,4670,'sr','ÐžÐ²Ð»Ð°ÑˆÑ›ÐµÐ½Ð¸ Ð¿Ð¾Ñ‚Ð¿Ð¸Ñ',0),(168093,4670,'vi','Chá»¯ KÃ½ CÃ³ Tháº©m Quyá»n',0),(168094,4670,'af','Gemagtigde Handtekening',0),(168095,4670,'ro','SemnÄƒtura autorizatÄƒ',0),(168096,4670,'et','Kinnitatud allkiri',0),(168097,4670,'si','Podpis pooblaÅ¡Äene osebe',0),(168098,4670,'ba','Signature resmi',0),(168099,4670,'nl','Gemachtigde handtekening',0),(168100,4670,'fi','Valtuutetun allekirjoitus',0),(168101,4670,'no','Autorisert signatur',0),(168102,4670,'da','Autoriserede underskrift',0),(168103,4670,'ko','ì¸ì¦ ëœ ì„œëª…',0),(168104,4670,'he','×ž×•×¨×©×” ×—×ª×™×ž×”',0),(168105,4670,'el','Î¥Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÎ¾Î¿Ï…ÏƒÎ¹Î¿Î´Î¿Ï„Î·Î¼Î­Î½Î¿Ï… Î½Î± Ï…Ï€Î¿Î³ÏÎ¬Ï†ÎµÎ¹',0),(168106,4670,'zh','æŽˆæƒç­¾ç½²\r\n',0),(168107,4670,'sv','GodkÃ¤nda signaturer',0),(168108,4670,'it','Firma autorizzata',0),(168109,4670,'tl','',0),(168110,4670,'th','&#3621;&#3634;&#3618;&#3617;&#3639;&#3629;&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(168111,4670,'hi','à¤ªà¥à¤°à¤¾à¤§à¤¿à¤•à¥ƒà¤¤ à¤¹à¤¸à¥ à¤¤à¤¾à¤•à¥à¤·à¤°',0),(168112,4670,'ms','Tandatangan yang dibenarkan',0),(168113,4670,'ar','Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ù…Ø®ÙˆÙ‘Ù„',0),(168114,4670,'fr','Signature autorisÃ©e',0),(168115,4670,'jp','æ‰¿èª?æ¸ˆç½²å??',0),(168116,4670,'pt','Assinatura autorizada',0),(168117,4670,'ru','ÐÐ²Ñ‚Ð¾Ñ€Ð¸Ð·Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð°Ñ ÐŸÐ¾Ð´Ð¿Ð¸ÑÑŒ',0),(168118,4670,'es','Firma Autorizada',0),(168119,4670,'de','Autorisierte Unterschrift',0),(168120,4670,'en','Authorized Signature',0),(168121,4671,'is','',0),(168122,4671,'dr','24 ',0),(168123,4671,'pr','Ø±ÙˆØ²Ù‡Ø§ Ø·Ø¨Ù‚ Ù…ÙˆØ§ÙÙ‚Øª  Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø³Ù†Ø¯ Ø¯Ø± Ø·ÙŠ 24 ',0),(168124,4671,'tr','mÃ¼ÅŸterinin kanÄ±tÄ± 24 saat iÃ§inde onaylama gÃ¶re gÃ¼n',0),(168125,4671,'pl','dni w oparciu o klienta zatwierdzajÄ…ce dowÃ³d w ciÄ…gu 24 godzin',0),(168126,4671,'bg','Ð´Ð½Ð¸ Ð½Ð° Ð±Ð°Ð·Ð° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑŠÑ‚ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð¸ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð² Ñ€Ð°Ð¼ÐºÐ¸Ñ‚Ðµ Ð½Ð° 24 Ñ‡Ð°ÑÐ°',0),(168127,4671,'ur','Ø¯Ù†ÙˆÚº Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø± Ú©Ø³Ù¹Ù…Ø± Ø«Ø¨ÙˆØª 24 Ú¯Ú¾Ù†Ù¹Û’ Ú©Û’ Ø§Ù†Ø¯Ø± Ø§Ù†Ø¯Ø± Ú©Ø±ØªÛ’ ÛÛŒÚº',0),(168128,4671,'sr','Ð´Ð°Ð½Ð° , Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ Ñ›Ðµ ÐºÑƒÐ¿Ð°Ñ† Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ñ‚Ð¸ Ð´Ð¾ÐºÐ°Ð· Ñƒ Ñ€Ð¾ÐºÑƒ Ð¾Ð´ 24 ÑÐ°Ñ‚Ð°',0),(168129,4671,'vi','ngÃ y dá»±a trÃªn khÃ¡ch hÃ ng cháº¥p thuáº­n báº£n in thá»­ trong vÃ²ng 24h',0),(168130,4671,'af','dae gebasseer op die KliÃ«nt / Klant goedkeuring van proef binne 24 ure',0),(168131,4671,'ro','zile bazate pe client dovada de aprobare Ã®n termen de 24 de ore',0),(168132,4671,'et','pÃ¤eva pÃµhineb kliendipoolse tÃµend 24 tunni jooksul',0),(168133,4671,'si','dni, da kupec potrdi dokaz v 24 urah na osnovi',0),(168134,4671,'ba','hari berdasarkan nasabah menyetujui bukti dalam waktu 24 jam',0),(168135,4671,'nl','dagen op basis van de klant het bewijs goedkeurt binnen 24 uur',0),(168136,4671,'fi','Asiakas hyvÃ¤ksyy todiste 24 tunnin pÃ¤ivÃ¤t',0),(168137,4671,'no','dager etter at kunden godkjenner beviset innen 24 timer',0),(168138,4671,'da','dage baseret pÃ¥ den, at kunden godkender bevis indenfor 24 timer',0),(168139,4671,'ko','24 ì‹œê°„ ì•ˆì— ì¦ê±°ë¥¼ ìŠ¹ì¸ í•˜ëŠ” ê³ ê°ì— ë”°ë¼ ì¼',0),(168140,4671,'he','×™×ž×™× ×ž×‘×•×¡×¡×ª ×¢×œ ×”×œ×§×•×— ×•××™×©×•×¨ ×”×”×•×›×—×” ×ª×•×š 24 ×©×¢×•×ª',0),(168141,4671,'el','Î·Î¼Î­ÏÎµÏ‚ Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î· ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ· Î· Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î¼Î­ÏƒÎ± ÏƒÎµ 24 ÏŽÏÎµÏ‚',0),(168142,4671,'zh','æ ¹æ®å®¢æˆ·24å°æ—¶å†…æ ¸å‡†çš„è¯æ˜ŽåŸºç¡€ä¸Šçš„å¤©æ•°\r\n',0),(168143,4671,'sv','dagar som bygger pÃ¥ att Kunden godkÃ¤nner bevis inom 24 timmar',0),(168144,4671,'it','giorni basati sul cliente che approva la prova entro 24 ore',0),(168145,4671,'tl','',0),(168146,4671,'th','&#3623;&#3633;&#3609;&#3605;&#3634;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3652;&#3604;&#3657;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;&#3616;&#3634;&#3618;&#3651;&#3609; 24 &#3594;&#3633',0),(168147,4671,'hi','à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¬à¥‚à¤¤ à¤•à¥‹ 24 à¤˜à¤‚à¤Ÿà¥‡ à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤°',0),(168148,4671,'ms','hari yang berasaskan pelanggan meluluskan bukti dalam masa 24 jam',0),(168149,4671,'ar','Ø£ÙŠØ§Ù… Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø§Ù„Ø¨Ø±Ù‡Ø§Ù† ÙÙŠ ØºØ¶ÙˆÙ† 24 Ø³Ø§Ø¹Ø©',0),(168150,4671,'fr','jours basÃ©s sur le client portant approbation de la preuve dans les 24 heures',0),(168151,4671,'jp','24æ™‚é–“ä»¥å†…ã?«æ ¡æ­£ã‚’é¡§å®¢ã?Œç¢ºèª?ã?—ã?Ÿå ´å?ˆã‚’åŸºæº–ã?«ã?—ã?Ÿæ—¥æ•°',0),(168152,4671,'pt','dias baseados o cliente aprova a prova dentro de 24 horas',0),(168153,4671,'ru','Ð´Ð½ÐµÐ¹ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°, ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð° Ð² Ñ‚ÐµÑ‡ÐµÐ½Ð¸Ðµ 24 Ñ‡Ð°ÑÐ¾Ð²',0),(168154,4671,'es','DÃ­as basados en la aprobaciÃ³n de la prueba de impresiÃ³n por el cliente dentro de 24 horas',0),(168155,4671,'de','Tage, die auf der Grundlage von dem Kunden zur Genehmigung des Nachweis innerhalb von 24 Stunden',0),(168156,4671,'en','days based on the customer approving the proof within 24 hours',0),(168157,4672,'is','',0),(168158,4672,'dr','Ø¢ÙŠØ§ Ø´Ù…Ø§ Ù…ÙŠ Ø¯Ø§Ù†ÙŠØ¯ ÙƒÙ‡ Ù…Ø§ Ù‡Ù…Ú†Ù†ÙŠÙ† Ø§Ø±Ø§Ø¦Ù‡ Ù…ÙŠØ¯Ù‡ÙŠÙ… ',0),(168159,4672,'pr','Ø¢ÙŠØ§ Ø´Ù…Ø§ Ù…ÙŠ Ø¯Ø§Ù†ÙŠØ¯ ÙƒÙ‡ Ù…Ø§ Ù‡Ù…Ú†Ù†ÙŠÙ† Ø§Ø±Ø§Ø¦Ù‡ Ù…ÙŠØ¯Ù‡ÙŠÙ… ',0),(168160,4672,'tr','AyrÄ±ca sunuyoruz biliyor muydunuz',0),(168161,4672,'pl','Czy wiesz, Å¼e oferujemy rÃ³wnieÅ¼',0),(168162,4672,'bg','Ð—Ð½Ð°ÐµÑ‚Ðµ Ð»Ð¸, Ð½Ð¸Ðµ ÑÑŠÑ‰Ð¾ Ñ‚Ð°ÐºÐ° Ð¿Ñ€ÐµÐ´Ð»Ð°Ð³Ð°Ð¼Ðµ',0),(168163,4672,'ur','ÛÙ… Ø¨Ú¾ÛŒ Ù¾ÛŒØ´ Ú©Ø±ØªÛ’ ÛÛŒÚº Ú©ÛŒØ§ Ø¢Ù¾ Ø¬Ø§Ù†ØªÛ’ ÛÛŒÚº',0),(168164,4672,'sr','Ð—Ð½Ð°Ð¾ ÑÐ¸ Ð´Ð° Ñ˜Ðµ Ñ‚Ð°ÐºÐ¾Ñ’Ðµ Ð½ÑƒÐ´Ð¸Ð¼Ð¾',0),(168165,4672,'vi','Báº¡n cÃ³ biáº¿t chÃºng tÃ´i cÅ©ng cung cáº¥p',0),(168166,4672,'af','Het u geweet ons bied ook',0),(168167,4672,'ro','ÅžtiaÅ£i cÄƒ, de asemenea, oferim',0),(168168,4672,'et','Kas teadsite, et pakume',0),(168169,4672,'si','Ali ste vedeli, vam nudimo tudi',0),(168170,4672,'ba','Apakah Anda tahu kami juga menawarkan',0),(168171,4672,'nl','U wist dat wij bieden ook',0),(168172,4672,'fi','TiesitkÃ¶, ettÃ¤ tarjoamme myÃ¶s',0),(168173,4672,'no','Du visste at vi ogsÃ¥ tilbyr',0),(168174,4672,'da','Du vidste, vi tilbyder ogsÃ¥',0),(168175,4672,'ko','ìš°ë¦¬ëŠ” ë˜í•œ ì œê³µ ì•„ì‹­ë‹ˆê¹Œ',0),(168176,4672,'he','×”×× ×™×“×¢×ª ×©×× ×• ×ž×¦×™×¢×™× ×’×',0),(168177,4672,'el','ÎžÎ­ÏÎ±Ï„Îµ ÏŒÏ„Î¹ Î¼Ï€Î¿ÏÎ¿ÏÎ¼Îµ ÎµÏ€Î¯ÏƒÎ·Ï‚ Î½Î± Ï€ÏÎ¿ÏƒÏ†Î­ÏÎ¿Ï…Î¼Îµ',0),(168178,4672,'zh','ä½ çŸ¥é“ï¼Œæˆ‘ä»¬ä¹Ÿæä¾›\r\n',0),(168179,4672,'sv','Visste du att vi erbjuder ocksÃ¥',0),(168180,4672,'it','Lo sapevate che offriamo',0),(168181,4672,'tl','',0),(168182,4672,'th','&#3588;&#3640;&#3603;&#3619;&#3641;&#3657;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3648;&#3619;&#3634;&#3651;&#3627;&#3657;&#3611;&#3619;&#3632;&#3617;&#3641;&#3621;&#3604;&#3657;&#3623;&#3618;',0),(168183,4672,'hi','à¤†à¤ª à¤œà¤¾à¤¨à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤¹à¤® à¤­à¥€ à¤ªà¥à¤°à¤¦à¤¾à¤¨ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(168184,4672,'ms','Tahukah anda, kami juga menawarkan',0),(168185,4672,'ar','Ù‡Ù„ ØªØ¹Ù„Ù…ÙˆÙ† Ø£Ù†Ù†Ø§ Ù†Ù‚Ø¯Ù… Ø£ÙŠØ¶Ø§',0),(168186,4672,'fr','Saviez-vous que nous offrons aussi',0),(168187,4672,'jp','ï½žã‚‚æ??æ¡ˆã?—ã?¦ã?„ã‚‹ã?“ã?¨ã‚’çŸ¥ã?£ã?¦ã?„ã?¾ã?—ã?Ÿã?‹ï¼Ÿ',0),(168188,4672,'pt','VocÃª sabia que tambÃ©m oferecemos',0),(168189,4672,'ru','Ð—Ð½Ð°ÐµÑ‚Ðµ Ð»Ð¸ Ð²Ñ‹, Ñ‡Ñ‚Ð¾ Ð¼Ñ‹ Ð¿Ñ€ÐµÐ´Ð»Ð°Ð³Ð°ÐµÐ¼',0),(168190,4672,'es','SabÃ­a que tambiÃ©n ofrecemos',0),(168191,4672,'de','Sie wussten, dass wir auch anbieten',0),(168192,4672,'en','Did you know we also offer',0),(168193,4673,'is','',0),(168194,4673,'dr','ØªØ®ÙÙŠÙØ§Øª  Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§ Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ØµÙˆØ±Øª Ù…ÙŠ Ú¯ÙŠØ±Ø¯ Ø§Ø¹Ù…Ø§Ù„ Ù†Ù…ÙŠ Ø´ÙˆØ¯ ',0),(168195,4673,'pr','ØªØ®ÙÙŠÙØ§Øª  Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§ Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ØµÙˆØ±Øª Ù…ÙŠ Ú¯ÙŠØ±Ø¯ Ø§Ø¹Ù…Ø§Ù„ Ù†Ù…ÙŠ Ø´ÙˆØ¯ ',0),(168196,4673,'tr','Kredi kartÄ± ile Ã¶deme iskontolarÄ± geÃ§erli deÄŸildir',0),(168197,4673,'pl','ZniÅ¼ki nie majÄ… zastosowania w przypadku pÅ‚atnoÅ›ci kartÄ… kredytowÄ…',0),(168198,4673,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ð½Ðµ ÑÐµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°Ñ‚ Ð¿Ñ€Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(168199,4673,'ur','Ú©ÛŒ Ø±Ø¹Ø§ÛŒØª Ú©Û’ Ø³Ø§ØªÚ¾ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ ÙˆÙ‚Øª Ú©Ø§ Ø§Ø·Ù„Ø§Ù‚ Ù†ÛÛŒÚº ÛÙˆØªØ§',0),(168200,4673,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚Ð¸ Ð½Ðµ Ð¾Ð´Ð½Ð¾ÑÐµ ÐºÐ°Ð´Ð° Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(168201,4673,'vi','Chiáº¿t kháº¥u khÃ´ng Ã¡p dá»¥ng khi thanh toÃ¡n báº±ng tháº» tÃ­n dá»¥ng',0),(168202,4673,'af','Korting nie verhaal wanneer betaal word met kredietkaart',0),(168203,4673,'ro','Reducerile nu se aplicÄƒ atunci cÃ¢nd plata cu card de credit',0),(168204,4673,'et','Allahindlusi ei kehti krediitkaardiga makstes',0),(168205,4673,'si','Popusti ne veljajo ob plaÄilu s kreditno kartico',0),(168206,4673,'ba','Diskon tidak berlaku bila membayar dengan kartu kredit',0),(168207,4673,'nl','Kortingen zijn niet van toepassing bij het betalen met credit card',0),(168208,4673,'fi','Alennukset eivÃ¤t koske luottokortilla maksettaessa',0),(168209,4673,'no','Rabatter gjelder ikke ved betaling med bankkort',0),(168210,4673,'da','Rabatter gÃ¦lder ikke, nÃ¥r man betaler med kreditkort',0),(168211,4673,'ko','ì‹ ìš© ì¹´ë“œë¡œ ê²°ì œ ì‹œ í• ì¸ ì ìš© ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(168212,4673,'he','×”× ×—×•×ª ××™× ×Ÿ ×—×œ×•×ª ×›××©×¨ ×ž×©×œ×ž×™× ×‘××ž×¦×¢×•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(168213,4673,'el','ÎŸÎ¹ ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ Î´ÎµÎ½ Î¹ÏƒÏ‡ÏÎ¿Ï…Î½ ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î® Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(168214,4673,'zh','æŠ˜æ‰£ä¸é€‚ç”¨äºŽä¿¡ç”¨å¡æ”¯ä»˜æ—¶ï¼Œ\r\n',0),(168215,4673,'sv','Rabatter gÃ¤ller inte vid betalning med kreditkort',0),(168216,4673,'it','Sconti non si applicano quando pagando con carta di credito',0),(168217,4673,'tl','',0),(168218,4673,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3651;&#3627;&#3657;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3648;&#3617;&#3639;&#3656;&#3629;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3604;&#3657;&#3623;&#3618;&#3610;&#3633;&#3',0),(168219,4673,'hi','à¤œà¤¬ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤›à¥‚à¤Ÿ à¤²à¤¾à¤—à¥‚ à¤¨ à¤•à¤°à¥‡à¤‚',0),(168220,4673,'ms','Diskaun tidak akan dikenakan apabila membayar dengan kad kredit',0),(168221,4673,'ar','Ù„Ø§ ÙŠØªÙ… ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª Ø¹Ù†Ø¯ Ø§Ù„Ø¯ÙØ¹ Ø¨Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(168222,4673,'fr','Remises ne s\'appliquent pas lorsque vous payez par carte de crÃ©dit',0),(168223,4673,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰æ‰•ã?„ã?®å ´å?ˆã?¯å‰²å¼•ã?¯é?©ç”¨ã?•ã‚Œã?¾ã?›ã‚“',0),(168224,4673,'pt','Os descontos nÃ£o se aplicam quando pagar com cartÃ£o de crÃ©dito',0),(168225,4673,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ¸ Ð½Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÑÑŽÑ‚ÑÑ Ð¿Ñ€Ð¸ Ð¾Ð¿Ð»Ð°Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(168226,4673,'es','Descuentos no se aplican cuando paga con tarjeta de crÃ©dito',0),(168227,4673,'de','Rabatte gelten nicht, wenn Sie mit Kreditkarte bezahlen',0),(168228,4673,'en','Discounts do not apply when paying with credit card',0),(168229,4674,'is','',0),(168230,4674,'dr','90 Ø±ÙˆØ² ',0),(168231,4674,'pr','Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ¯ 90 Ø±ÙˆØ² ',0),(168232,4674,'tr','90 gÃ¼n boyunca',0),(168233,4674,'pl','Do 90 dni',0),(168234,4674,'bg','Ð—Ð° 90 Ð´Ð½Ð¸',0),(168235,4674,'ur','90 Ø¯Ù† Ú©Û’ Ù„ÛŒÛ’',0),(168236,4674,'sr','Ð—Ð° 90 Ð´Ð°Ð½Ð°',0),(168237,4674,'vi','Cho 90 ngÃ y',0),(168238,4674,'af','Vir 90 Dae',0),(168239,4674,'ro','Pentru 90 de zile',0),(168240,4674,'et','90 pÃ¤eva',0),(168241,4674,'si','90 dni',0),(168242,4674,'ba','Selama 90 hari',0),(168243,4674,'nl','Voor 90 dagen',0),(168244,4674,'fi','90 pÃ¤ivÃ¤Ã¤',0),(168245,4674,'no','I 90 dager',0),(168246,4674,'da','I 90 dage',0),(168247,4674,'ko','90 ì¼ ë™ì•ˆ',0),(168248,4674,'he','×‘×ž×©×š 90 ×™×•×',0),(168249,4674,'el','Î“Î¹Î± 90 Î·Î¼Î­ÏÎµÏ‚',0),(168250,4674,'zh','90å¤©\r\n',0),(168251,4674,'sv','FÃ¶r 90 dagar',0),(168252,4674,'it','Per 90 giorni',0),(168253,4674,'tl','',0),(168254,4674,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;  30 &#3623;&#3633;&#3609;',0),(168255,4674,'hi','90 à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤',0),(168256,4674,'ms','Selama 90 hari',0),(168257,4674,'ar','Ù„Ù…Ø¯Ø© 90 ÙŠÙˆÙ…Ø§',0),(168258,4674,'fr','Pendant 90 jours',0),(168259,4674,'jp','90æ—¥é–“',0),(168260,4674,'pt','Por 90 dias',0),(168261,4674,'ru','Ð—Ð° 90 Ð”Ð½ÐµÐ¹',0),(168262,4674,'es','Para 90 DÃ­as',0),(168263,4674,'de','FÃ¼r 90 Tage',0),(168264,4674,'en','For 90 days',0),(168265,4675,'is','',0),(168266,4675,'dr','Ø²Ù…Ø§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ Ø§Ø³Øª ',0),(168267,4675,'pr','Ø²Ù…Ø§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ Ø§Ø³Øª ',0),(168268,4675,'tr','KurÅŸun ZamanÄ±',0),(168269,4675,'pl','Czas oÅ‚owiu',0),(168270,4675,'bg','Ð“Ñ€Ð°Ð½Ñ†Ð¸Ð¾Ð½Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ðµ',0),(168271,4675,'ur','Ù‚ÛŒØ§Ø¯Øª Ú©Ø§ ÙˆÙ‚Øª ÛÛ’',0),(168272,4675,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ñ†Ð¸ÐºÐ»ÑƒÑÐ° Ñ˜Ðµ',0),(168273,4675,'vi','Thá»i gian Dáº«n Ä‘áº§u lÃ  ',0),(168274,4675,'af','Lood tyd is',0),(168275,4675,'ro','Timp de plumb este',0),(168276,4675,'et','TarnetsÃ¼kli aja on',0),(168277,4675,'si','PretoÄni Äas je',0),(168278,4675,'ba','Memimpin waktu',0),(168279,4675,'nl','Overlappingstijd is de',0),(168280,4675,'fi','Toimitusaika on',0),(168281,4675,'no','Ledetid er',0),(168282,4675,'da','Bly tid er',0),(168283,4675,'ko','ë¦¬ë“œ íƒ€ìž„ì€',0),(168284,4675,'he','×–×ž×Ÿ ×—×¤×™×¤×” ×¤×™×¨×•×©×•',0),(168285,4675,'el','ÎŸ Ï‡ÏÏŒÎ½Î¿Ï‚ Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹',0),(168286,4675,'zh','æå‰æœŸä¸º\r\n',0),(168287,4675,'sv','Ledtiden Ã¤r',0),(168288,4675,'it','Tempo di consegna Ã¨',0),(168289,4675,'tl','',0),(168290,4675,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3619;&#3629;&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3639;&#3629;',0),(168291,4675,'hi','à¤²à¥€à¤¡ à¤¸à¤®à¤¯ à¤¹à¥ˆ',0),(168292,4675,'ms','Masa adalah',0),(168293,4675,'ar','Ø§Ù„Ù…Ù‡Ù„Ø© Ø§Ù„Ø²Ù…Ù†ÙŠØ©',0),(168294,4675,'fr','DÃ©lai est',0),(168295,4675,'jp','ãƒªãƒ¼ãƒ‰æ™‚é–“ã?¯',0),(168296,4675,'pt','Prazo de execuÃ§Ã£o Ã©',0),(168297,4675,'ru','Ð¡Ñ€Ð¾Ðº Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(168298,4675,'es','Plazo de Entrega es',0),(168299,4675,'de','Die Lieferzeit betrÃ¤gt',0),(168300,4675,'en','Lead time is',0),(168301,4676,'is','',0),(168302,4676,'dr','/ Ù†Ø§Ù…',0),(168303,4676,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø³Ù…Øª / Ù†Ø§Ù…',0),(168304,4676,'tr','ParÃ§a numarasÄ± / adÄ±',0),(168305,4676,'pl','CzÄ™Å›Ä‡ #/ nazwa',0),(168306,4676,'bg','Ð§Ð°ÑÑ‚ #/ Ð¸Ð¼Ðµ',0),(168307,4676,'ur','Ø­ØµÛ #/ Ù†Ø§Ù…',0),(168308,4676,'sr','Ð”ÐµÐ¾ #/ Ð¸Ð¼Ðµ',0),(168309,4676,'vi','Phá»¥ tÃ¹ng sá»‘/tÃªn',0),(168310,4676,'af','Onderdeel#/Naam',0),(168311,4676,'ro','Parte #/ nume',0),(168312,4676,'et','Osa #/ nimi',0),(168313,4676,'si','Del #/ ime',0),(168314,4676,'ba','Bagian #/ nama',0),(168315,4676,'nl','Deel #/ naam',0),(168316,4676,'fi','Osa #/ nimi',0),(168317,4676,'no','Del #/ navn',0),(168318,4676,'da','Del #/ navn',0),(168319,4676,'ko','ë¶€í’ˆ ë²ˆí˜¸ / ì´ë¦„',0),(168320,4676,'he','×©×/# ×—×œ×§',0),(168321,4676,'el','ÎœÎ­ÏÎ¿Ï‚ #/ ÏŒÎ½Î¿Î¼Î±',0),(168322,4676,'zh','éƒ¨åˆ†ï¼ƒ/åç§°\r\n',0),(168323,4676,'sv','Del #/ namn',0),(168324,4676,'it','Parte #/ nome',0),(168325,4676,'tl','',0),(168326,4676,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3626;&#3656;&#3623;&#3609;/&#3594;&#3639;&#3656;&#3629;',0),(168327,4676,'hi','à¤­à¤¾à¤— #/ à¤¨à¤¾à¤®',0),(168328,4676,'ms','Bahagian #/ nama',0),(168329,4676,'ar','Ø¬Ø²Ø¡ #/Ø§Ø³Ù…',0),(168330,4676,'fr','Fabricant / nom',0),(168331,4676,'jp','éƒ¨å“?ç•ªå?·/å??å‰?',0),(168332,4676,'pt','Parte #/ nome',0),(168333,4676,'ru','Ð§Ð°ÑÑ‚ÑŒ#/ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ',0),(168334,4676,'es','Parte #/Nombre',0),(168335,4676,'de','Art. #/ Name',0),(168336,4676,'en','Part#/Name',0),(168337,4677,'is','',0),(168338,4677,'dr','Ù„Ø·ÙØ§ Ø§ÙŠÙ† ÙØ±Ù… Ø±Ø§ Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†ÙŠØ¯ Ùˆ Ø¨Ù‡ Ù…Ø§ Ø¨Ø§ ÙÙƒØ³ Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†ÙŠØ¯ Ø¯Ø± ',0),(168339,4677,'pr','Ù„Ø·ÙØ§ Ø§ÙŠÙ† ÙØ±Ù… Ø±Ø§ Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†ÙŠØ¯ Ùˆ Ø¨Ù‡ Ù…Ø§ Ø¨Ø§ ÙÙƒØ³ Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†ÙŠØ¯ Ø¯Ø± ',0),(168340,4677,'tr','LÃ¼tfen bu formu ve bize Faks oturum',0),(168341,4677,'pl','Prosimy o podpisanie tej postaci faksu do nas w',0),(168342,4677,'bg','ÐœÐ¾Ð»Ñ, Ð¿Ð¾Ð´Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€ Ð¸ Ñ„Ð°ÐºÑ ÐºÑŠÐ¼ Ð½Ð°Ñ Ð²',0),(168343,4677,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§Ø³ ÙØ§Ø±Ù… Ø§ÙˆØ± ÙÛŒÚ©Ø³ ÛÙ… Ù¾Ø± Ú©Ùˆ Ø¯ÙˆØ¨Ø§Ø±Û Ø³Ø§Ø¦Ù† Ø§Ù† Ú©Ø±ÛŒÚº',0),(168344,4677,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð¾Ð²Ð°Ñ˜ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ† Ð¸ Ñ„Ð°ÐºÑ Ð´Ð¾ Ð½Ð°Ñ Ð½Ð°',0),(168345,4677,'vi','Vui lÃ²ng kÃ½ & fax láº¡i cho chÃºng tÃ´i',0),(168346,4677,'af','Onderteken asb. hierdie vorm en faks terug na ons by',0),(168347,4677,'ro','VÄƒ rugÄƒm sÄƒ semneze acest formular ÅŸi fax Ã®napoi-ne la',0),(168348,4677,'et','Palun Allkirjastage see vorm ja faksi tagasi meile aadressil',0),(168349,4677,'si','Prosim podpiÅ¡e ta obrazec in fax nazaj na nas v',0),(168350,4677,'ba','Harap menandatangani formulir ini dan Faks kembali ke kami di',0),(168351,4677,'nl','Gelieve aan te melden deze vorm en fax naar ons op',0),(168352,4677,'fi','Kirjaudu tÃ¤ssÃ¤ lomakkeessa ja Faksi meille',0),(168353,4677,'no','Logg dette skjemaet og faks til oss pÃ¥',0),(168354,4677,'da','Venligst underskrive denne formular og fax tilbage til os pÃ¥',0),(168355,4677,'ko','ì´ í˜•íƒœì™€ ë‹¤ì‹œ ìš°ë¦¬ì— ê²Œ íŒ©ìŠ¤ì— ì„œëª… í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(168356,4677,'he','. ×‘×‘×§×©×” ×ª×—×ª×•× ×–×” ×˜×•×¤×¡ ×•×¤×§×¡ ×‘×—×–×¨×” ××œ×™× ×•-',0),(168357,4677,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Ï…Ï€Î¿Î³ÏÎ¬ÏˆÎµÎ¹ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î¿ÏÏ†Î® ÎºÎ±Î¹ Ï†Î±Î¾ Ï€Î¯ÏƒÏ‰ ÏƒÎµ Î¼Î±Ï‚ ÏƒÏ„Î¿',0),(168358,4677,'zh','è¯·ç­¾ç½²æ­¤è¡¨æ ¼ï¼Œå¹¶ä¼ çœŸç»™æˆ‘ä»¬\r\n',0),(168359,4677,'sv','VÃ¤nligen underteckna detta formulÃ¤r och fax till oss pÃ¥',0),(168360,4677,'it','Si prega di firmare questo modulo e fax a noi a',0),(168361,4677,'tl','',0),(168362,4677,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3651;&#3609;&#3615;&#3629;&#3619;&#3660;&#3617;&#3609;&#3637;&#3657;&#3649;&#3621;&#3632;&#3626;&#3656;&#3591;&#3650;&#3607;&#3619;&#3626;&#3634;&#3619;&#3585;&#3621;&#3633;&#3',0),(168363,4677,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤‡à¤¸ à¤«à¤¾à¤°à¥à¤® à¤”à¤° à¤«à¤¼à¥ˆà¤•à¥à¤¸ à¤•à¤°à¤¨à¥‡ à¤ªà¤° à¤¹à¤®à¥‡à¤‚ à¤µà¤¾à¤ªà¤¸ à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(168364,4677,'ms','Sila sign ini borang dan Faks semula kepada kami di',0),(168365,4677,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ù†Ù…ÙˆØ°Ø¬ ÙˆÙØ§ÙƒØ³ Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ±Ø§Ø¡ Ø¨Ø§Ù„Ù†Ø³Ø¨Ø© Ù„Ù†Ø§ ÙÙŠ',0),(168366,4677,'fr','S\'il vous plaÃ®t signer ce formulaire et fax vers nous Ã ',0),(168367,4677,'jp','ã?“ã?®ãƒ•ã‚©ãƒ¼ãƒ ã?«ç½²å??ã?—ã?¦ãƒ•ã‚¡ãƒƒã‚¯ã‚¹ã?§è¿”ä¿¡ã?—ã?¦ã??ã? ã?•ã?„',0),(168368,4677,'pt','Por favor assine este formulÃ¡rio e fax para nÃ³s no',0),(168369,4677,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð¾Ð¹Ð´Ð¸Ñ‚Ðµ ÑÑ‚Ñƒ Ñ„Ð¾Ñ€Ð¼Ñƒ Ð¸ Ð²ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ð½Ð°Ð¼ Ð½Ð° Ð¤Ð°ÐºÑ',0),(168370,4677,'es','Por favor firmar este formulario y regrsar por fax a nosotros a',0),(168371,4677,'de','Bitte unterschreiben Sie das Formular aus und Fax an uns zu',0),(168372,4677,'en','Please sign this form and fax back to us at',0),(168373,4678,'is','',0),(168374,4678,'dr','Ú†Ø§Ù¾ Ù†Ø§Ù… ',0),(168375,4678,'pr','Ú†Ø§Ù¾ Ù†Ø§Ù… ',0),(168376,4678,'tr','YazÄ±cÄ± adÄ±',0),(168377,4678,'pl','Nazwa wydruku',0),(168378,4678,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¸Ð¼Ðµ',0),(168379,4678,'ur','Ù†Ø§Ù… Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(168380,4678,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð¼ÐµÐ½Ð°',0),(168381,4678,'vi','TÃªn In',0),(168382,4678,'af','Druk Naam',0),(168383,4678,'ro','Numele de imprimare',0),(168384,4678,'et','Nimi trÃ¼kitÃ¤htedega',0),(168385,4678,'si','Natisniti ime',0),(168386,4678,'ba','Cetak nama',0),(168387,4678,'nl','Naam afdrukken',0),(168388,4678,'fi','Tekstaa nimi',0),(168389,4678,'no','Navn',0),(168390,4678,'da','Udskriv navn',0),(168391,4678,'ko','ì¸ì‡„ ì´ë¦„',0),(168392,4678,'he','×”×“×¤×¡ ×©×',0),(168393,4678,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(168394,4678,'zh','æ‰“å°åç§°\r\n',0),(168395,4678,'sv','Skriva ut namn',0),(168396,4678,'it','Nome in stampatello',0),(168397,4678,'tl','',0),(168398,4678,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3594;&#3639;&#3656;&#3629;',0),(168399,4678,'hi','à¤¨à¤¾à¤® à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(168400,4678,'ms','Cetak nama',0),(168401,4678,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø§Ø³Ù…',0),(168402,4678,'fr','Nom en lettres moulÃ©es',0),(168403,4678,'jp','å?°åˆ·å??',0),(168404,4678,'pt','Imprimir o nome',0),(168405,4678,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¸Ð¼Ñ',0),(168406,4678,'es','Imprimir Nombre',0),(168407,4678,'de','In Druckbuchstaben',0),(168408,4678,'en','Print Name',0),(168409,4679,'is','',0),(168410,4679,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…Ø¹ØªØ¨Ø±',0),(168411,4679,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…Ø¹ØªØ¨Ø±',0),(168412,4679,'tr','GeÃ§erli teklif',0),(168413,4679,'pl','Oferta waÅ¼na',0),(168414,4679,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð²Ð°Ð»Ð¸Ð´Ð½Ð°',0),(168415,4679,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø¬Ø§Ø¦Ø²',0),(168416,4679,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð²Ð°Ð¶Ð¸',0),(168417,4679,'vi','BÃ¡o giÃ¡ cÃ³ giÃ¡ trá»‹',0),(168418,4679,'af','Geldige Kwotasie',0),(168419,4679,'ro','OfertÄƒ valabilÄƒ',0),(168420,4679,'et','Pakkumine kehtib',0),(168421,4679,'si','Ponudba veljavna',0),(168422,4679,'ba','Penawaran berlaku',0),(168423,4679,'nl','Offerte geldig',0),(168424,4679,'fi','Tarjous voimassa',0),(168425,4679,'no','Tilbud gyldig',0),(168426,4679,'da','Citat gyldig',0),(168427,4679,'ko','ê²¬ì  ìœ íš¨',0),(168428,4679,'he','×”×¦×¢×ª ×”×ž×—×™×¨ ×ª×§×£',0),(168429,4679,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î¹ÏƒÏ‡ÏÎµÎ¹',0),(168430,4679,'zh','æŠ¥ä»·æœ‰æ•ˆ\r\n',0),(168431,4679,'sv','Offert giltig',0),(168432,4679,'it','Offerta valida',0),(168433,4679,'tl','',0),(168434,4679,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(168435,4679,'hi','à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤®à¤¾à¤¨à¥à¤¯',0),(168436,4679,'ms','Sah sebut harga',0),(168437,4679,'ar','Ø§Ù‚ØªØ¨Ø³ ØµØ§Ù„Ø­Ø©',0),(168438,4679,'fr','Prix valables',0),(168439,4679,'jp','è¦‹ç©?ã‚‚ã‚ŠæœŸé™?',0),(168440,4679,'pt','CitaÃ§Ã£o vÃ¡lida',0),(168441,4679,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹',0),(168442,4679,'es','CotizaciÃ³n VÃ¡lida',0),(168443,4679,'de','Angebot gÃ¼ltig',0),(168444,4679,'en','Quote Valid',0),(168445,4680,'is','',0),(168446,4680,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙØ±ÙˆØ´ ',0),(168447,4680,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙØ±ÙˆØ´ ',0),(168448,4680,'tr','SatÄ±ÅŸ temsilcisi',0),(168449,4680,'pl','Przedstawicielem handlowym',0),(168450,4680,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»',0),(168451,4680,'ur','Ø³ÛŒÙ„Ø² Ø¬Ù…ÛÙˆØ±ÛŒÛ',0),(168452,4680,'sr','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð½Ð¸Ðº Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(168453,4680,'vi','NhÃ¢n viÃªn kinh doanh',0),(168454,4680,'af','Verkoopsverteenwoordiger',0),(168455,4680,'ro','Reprezentant de vÃ¢nzÄƒri',0),(168456,4680,'et','MÃ¼Ã¼giesindaja',0),(168457,4680,'si','Prodajni zastopnik',0),(168458,4680,'ba','Perwakilan penjualan',0),(168459,4680,'nl','Verkoopvertegenwoordiger',0),(168460,4680,'fi','Myyntiedustaja',0),(168461,4680,'no','Selger',0),(168462,4680,'da','Salg Rep',0),(168463,4680,'ko','ì˜ì—… ë‹´ë‹¹ìž',0),(168464,4680,'he','× ×¦×™×’ ×ž×›×™×¨×•×ª',0),(168465,4680,'el','Î‘Î½Ï„Î¹Ï€ÏÏŒÏƒÏ‰Ï€Î¿Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(168466,4680,'zh','é”€å”®ä»£è¡¨\r\n',0),(168467,4680,'sv','SÃ¤ljare',0),(168468,4680,'it','Rappresentante vendite',0),(168469,4680,'tl','',0),(168470,4680,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(168471,4680,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿',0),(168472,4680,'ms','Wakil jualan',0),(168473,4680,'ar','Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(168474,4680,'fr','ReprÃ©sentant des ventes',0),(168475,4680,'jp','ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…',0),(168476,4680,'pt','Representante de vendas',0),(168477,4680,'ru','ÐžÑ‚Ð´ÐµÐ»Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(168478,4680,'es','Representante de Ventas',0),(168479,4680,'de','Vertriebsmitarbeiter',0),(168480,4680,'en','Sales Rep',0),(168481,4681,'is','',0),(168482,4681,'dr','(Ù…Ù†Ø¨Ø¹ Ø§Ø­ØªØ±Ø§Ù‚ Ù…Ø¯Ø§Ø± Ú†Ø§Ù¾ÙŠ) Ø¨Ù‡ ',0),(168483,4681,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø§Ø«Ø± Ù‡Ù†Ø±ÙŠ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ(Ù…Ù†Ø¨Ø¹ Ø§Ø­ØªØ±Ø§Ù‚ Ù…Ø¯Ø§Ø± Ú†Ø§Ù¾ÙŠ) Ø¨Ù‡ ',0),(168484,4681,'tr','Elektronik resim gÃ¶nder',0),(168485,4681,'pl','WysÅ‚aÄ‡ elektroniczne kompozycji',0),(168486,4681,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¸ Ð¿Ñ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð¸Ñ Ð½Ð° Ð¸Ð·ÐºÑƒÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(168487,4681,'ur','Ø§Ù„ÛŒÚ©Ù¹Ø±Ø§Ù†Ú© Ø¢Ø±Ù¹ ÙˆØ±Ú© Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(168488,4681,'sr','Ð¡Ð»Ð°ÑšÐµ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÑÐºÐµ Ñ†Ñ€Ñ‚ÐµÐ¶ Ð´Ð°',0),(168489,4681,'vi','Gá»­i máº«u thiáº¿t káº¿ Ä‘iá»‡n tá»­ tá»›i',0),(168490,4681,'af','Stuur elektroniese kunswerk na',0),(168491,4681,'ro','Opera de arta electronice pentru a trimite',0),(168492,4681,'et','Saada elektroonilise kunsti',0),(168493,4681,'si','PoÅ¡lji elektronsko umetnine',0),(168494,4681,'ba','Mengirim karya seni elektronik untuk',0),(168495,4681,'nl','Elektronische illustraties te verzenden',0),(168496,4681,'fi','LÃ¤hetÃ¤ sÃ¤hkÃ¶inen kuvitusta',0),(168497,4681,'no','Sende elektronisk kunstverk til',0),(168498,4681,'da','Send elektronisk illustrationer til',0),(168499,4681,'ko','ì „ìž ì‚½í™”ë¥¼ ë³´ë‚´ê¸°',0),(168500,4681,'he','×©×œ×— ×’×¨×¤×™×§×” ××œ×§×˜×¨×•× ×™×ª ×›×“×™',0),(168501,4681,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Î­ÏÎ³Î¿ Ï„Î­Ï‡Î½Î·Ï‚ Î½Î±',0),(168502,4681,'zh','å‘é€ç”µå­æ’å›¾\r\n',0),(168503,4681,'sv','Skicka elektroniska teckningen till',0),(168504,4681,'it','Inviare l\'opera d\'arte elettronica a',0),(168505,4681,'tl','',0),(168506,4681,'th','&#3626;&#3656;&#3591;&#3591;&#3634;&#3609;&#3624;&#3636;&#3621;&#3611;&#3632;&#3629;&#3636;&#3648;&#3621;&#3655;&#3588;&#3607;&#3619;&#3629;&#3609;&#3636;&#3585;&#3626;&#3660;&#3606;&#3638;&#3591;',0),(168507,4681,'hi','à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤²à¥‡à¤•à¥à¤Ÿà¥à¤°à¥‰à¤¨à¤¿à¤• à¤•à¤²à¤¾à¤•à¥ƒà¤¤à¤¿',0),(168508,4681,'ms','Hantar karya seni elektronik untuk',0),(168509,4681,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ÙÙ†ÙŠ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ø¥Ø±Ø³Ø§Ù„',0),(168510,4681,'fr','Envoyer une oeuvre Ã©lectronique Ã ',0),(168511,4681,'jp','ï½žã?¸é›»å­?èŠ¸è¡“ä½œå“?ã‚’é€?ä¿¡ã?™ã‚‹',0),(168512,4681,'pt','Enviar arte eletrÃ´nica para',0),(168513,4681,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²ÐºÐ° ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ñ… Ñ€Ð°Ð±Ð¾Ñ‚',0),(168514,4681,'es','Enviar ilustraciones electrÃ³nicas a',0),(168515,4681,'de','Elektronisches Bildmaterial zu senden',0),(168516,4681,'en','Send electronic artwork to',0),(168517,4682,'is','',0),(168518,4682,'dr','Ù…ØªØ´ÙƒØ±ÙŠÙ… ÙƒÙ‡ Ø¨Ù‡ Ù…Ø§ Ø§Ø¬Ø§Ø²Ù‡ ÙƒÙ…Ùƒ Ø¯Ø§Ø¯ÙŠØ¯',0),(168519,4682,'pr','Ù…ØªØ´ÙƒØ±ÙŠÙ… ÙƒÙ‡ Ø¨Ù‡ Ù…Ø§ Ø§Ø¬Ø§Ø²Ù‡ ÙƒÙ…Ùƒ Ø¯Ø§Ø¯ÙŠØ¯',0),(168520,4682,'tr','Bize hizmet izin iÃ§in teÅŸekkÃ¼r ederiz',0),(168521,4682,'pl','DziÄ™kujÄ™ za umoÅ¼liwienie nam usÅ‚ugi',0),(168522,4682,'bg','Ð‘Ð»Ð°Ð³Ð¾Ð´Ð°Ñ€Ñ Ð²Ð¸ Ð·Ð° ÐºÐ¾ÐµÑ‚Ð¾ Ð½Ð¸ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÑÐ²Ð° Ð´Ð° Ð±ÑŠÐ´ÐµÐ¼ Ð² ÑƒÑÐ»ÑƒÐ³Ð°',0),(168523,4682,'ur','ÛÙ…ÛŒÚº Ú©ÛŒ Ø®Ø¯Ù…Øª Ú©Ø±Ù†Û’ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÙ†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø´Ú©Ø±ÛŒÛ',0),(168524,4682,'sr','Ð¥Ð²Ð°Ð»Ð° Ñ‚Ð¸ Ð½Ð° Ð´Ð¾Ð·Ð²Ð¾Ð»Ð¸Ð»Ð¸ Ð´Ð° Ð±ÑƒÐ´ÐµÐ¼ Ð½Ð° ÑƒÑÐ»ÑƒÐ·Ð¸',0),(168525,4682,'vi','CÃ¡m Æ¡n báº¡n Ä‘Ã£ sá»­ dá»¥ng dá»‹ch vá»¥ cá»§a chÃºng tÃ´i ',0),(168526,4682,'af','Dankie dat u ons toelaat om u van diens te wees',0),(168527,4682,'ro','VÄƒ mulÅ£umesc pentru permiÅ£Ã¢ndu-ne sÄƒ fie de serviciu',0),(168528,4682,'et','TÃ¤name vÃµimaldab meil teenust',0),(168529,4682,'si','Zahvaljujemo se vam za kar nam omogoÄa, da se storitve',0),(168530,4682,'ba','Terima kasih untuk memungkinkan kita untuk melayani',0),(168531,4682,'nl','Dank u voor het toestaan van ons om van dienst zijn',0),(168532,4682,'fi','Kiitos antaa meille mahdollisuuden palvella',0),(168533,4682,'no','Takk for Ã¥ stÃ¥ til tjeneste',0),(168534,4682,'da','Tak for at lade os vÃ¦re af service',0),(168535,4682,'ko','ì„œë¹„ìŠ¤ ë  ìˆ˜ ìžˆë„ë¡ í•´ ì£¼ì…”ì„œ ê°ì‚¬ í•©ë‹ˆë‹¤',0),(168536,4682,'he','×ª×•×“×” ×©××ª ×ž×¨×©×” ×œ× ×• ×œ×”×™×•×ª ×œ×¢×–×¨',0),(168537,4682,'el','Î£Î±Ï‚ ÎµÏ…Ï‡Î±ÏÎ¹ÏƒÏ„Î¿ÏÎ¼Îµ Ï€Î¿Ï… Î¼Î±Ï‚ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î³Î¹Î± Ï„Î·Î½ ÎµÎ¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ·',0),(168538,4682,'zh','è°¢è°¢ä½ è®©æˆ‘ä»¬æˆä¸ºæ‚¨æœåŠ¡\r\n',0),(168539,4682,'sv','Tack fÃ¶r att tillÃ¥ta oss att stÃ¥ till tjÃ¤nst',0),(168540,4682,'it','Grazie per averci permesso di essere di servizio',0),(168541,4682,'tl','',0),(168542,4682,'th','&#3586;&#3629;&#3610;&#3588;&#3640;&#3603;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3614;&#3623;&#3585;&#3648;&#3619;&#3634;&#3617;&#3634;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(168543,4682,'hi','à¤†à¤ª à¤•à¥€ à¤¸à¥‡à¤µà¤¾ à¤•à¥€ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¤®à¥‡à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤§à¤¨à¥à¤¯à¤µà¤¾à¤¦',0),(168544,4682,'ms','Terima kasih untuk membolehkan kita untuk berkhidmat',0),(168545,4682,'ar','Ø´ÙƒØ±Ø§ Ù„ÙƒÙ… Ø¹Ù„Ù‰ Ø¥ØªØ§Ø­Ø© Ø§Ù„ÙØ±ØµØ© Ù„Ù†Ø§ ØªÙƒÙˆÙ† ÙÙŠ Ø®Ø¯Ù…Ø©',0),(168546,4682,'fr','Merci de nous permettre d\'Ãªtre au service des',0),(168547,4682,'jp','ã?Šæ‰‹ä¼?ã?„ã?•ã?›ã?¦é ‚ã??ã?¾ã?—ã?¦ã?‚ã‚Šã?Œã?¨ã?†ã?”ã?–ã?„ã?¾ã?™ã€‚',0),(168548,4682,'pt','Obrigado por permitir-nos de estar a serviÃ§o',0),(168549,4682,'ru','Ð‘Ð»Ð°Ð³Ð¾Ð´Ð°Ñ€ÑŽ Ð²Ð°Ñ Ð·Ð° Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð½ÑƒÑŽ Ð½Ð°Ð¼ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ÑÑ‚ÑŒ Ð±Ñ‹Ñ‚ÑŒ ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(168550,4682,'es','Gracias a usted para permitirnos atenderles',0),(168551,4682,'de','Vielen Dank fÃ¼r die Erlaubnis zu Diensten',0),(168552,4682,'en','Thank you for allowing us to be of service',0),(168553,4683,'is','',0),(168554,4683,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø²ÙŠØ± Ø¨Ø§ÙŠØ¯ Ø¯Ø± ØªÙ…Ø§Ù… Ù…ÙƒØ§ØªØ¨Ø§Øª Ù…Ø±ØªØ¨Ø· Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯',0),(168555,4683,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø²ÙŠØ± Ø¨Ø§ÙŠØ¯ Ø¯Ø± ØªÙ…Ø§Ù… Ù…ÙƒØ§ØªØ¨Ø§Øª Ù…Ø±ØªØ¨Ø· Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯',0),(168556,4683,'tr','AÅŸaÄŸÄ±daki sayÄ± Ã¼zerinde tÃ¼m tÄ±rnaÄŸÄ± ilgili yazÄ±ÅŸma gÃ¶rÃ¼nmelidir',0),(168557,4683,'pl','NastÄ™pujÄ…cy numer musi znajdowaÄ‡ siÄ™ na wszystkie oferty powiÄ…zanej korespondencji',0),(168558,4683,'bg','Ð¡Ð»ÐµÐ´Ð½Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ñ„Ð¸Ð³ÑƒÑ€Ð¸Ñ€Ð° Ð²ÑŠÑ€Ñ…Ñƒ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð° ÑÐ²ÑŠÑ€Ð·Ð°Ð½Ð¸ ÐºÐ¾Ñ€ÐµÑÐ¿Ð¾Ð½Ð´ÐµÐ½Ñ†Ð¸Ñ',0),(168559,4683,'ur','Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ù†Ù…Ø¨Ø± ØªÙ…Ø§Ù… Ø§Ù‚ØªØ¨Ø§Ø³ Ø³Û’ Ù…ØªØ¹Ù„Ù‚ Ø®Ø· Ùˆ Ú©ØªØ§Ø¨Øª Ù¾Ø± Ø¸Ø§ÛØ± Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(168560,4683,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑÐµ Ð¼Ð¾Ñ€Ð° Ð¿Ð¾Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸ Ð½Ð° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° Ð¡Ñ€Ð¾Ð´Ð½Ðµ Ð¡Ð²Ð° ÐºÐ¾Ñ€ÐµÑÐ¿Ð¾Ð½Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ð°',0),(168561,4683,'vi','Nhá»¯ng sá»‘ sau pháº£i cÃ³ trÃªn táº¥t cáº£ cÃ¡c trao Ä‘á»•i liÃªn quan tá»›i bÃ¡o giÃ¡',0),(168562,4683,'af','Die volgende nommer moet verskyn op alle kwotasie-verwante korrespondensie',0),(168563,4683,'ro','UrmÄƒtorul numÄƒr trebuie sÄƒ aparÄƒ pe toatÄƒ corespondenÅ£a citat conexe',0),(168564,4683,'et','JÃ¤rgmine number peab olema kantud kÃµik quote seotud kirjavahetus',0),(168565,4683,'si','Naslednja Å¡tevilka mora biti na vso ponudbo povezanih korespondenco',0),(168566,4683,'ba','Nomor berikut harus muncul di semua korespondensi kutipan terkait',0),(168567,4683,'nl','Het volgende nummer moet worden weergegeven op alle citaat gerelateerde correspondentie',0),(168568,4683,'fi','Seuraavaa numeroa on sisÃ¤llyttÃ¤vÃ¤ kaikki lainaan liittyvÃ¤t kirjeenvaihto',0),(168569,4683,'no','FÃ¸lgende nummer mÃ¥ vises pÃ¥ alle tilbud relaterte korrespondanse',0),(168570,4683,'da','De fÃ¸lgende tal skal vises pÃ¥ alle citat relaterede korrespondance',0),(168571,4683,'ko','ë‹¤ìŒ ëª¨ë“  ê²¬ì  ê´€ë ¨ëœ í†µì‹ ì— ë‚˜íƒ€ë‚˜ì•¼',0),(168572,4683,'he','×”×ž×¡×¤×¨ ×”×‘× ×—×™×™×‘ ×œ×”×•×¤×™×¢ ×‘×›×œ ×ª×›×ª×•×‘×ª ×”×§×©×•×¨×” ×¦×™×˜×•×˜',0),(168573,4683,'el','ÎŸ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î±Î½Î±Ï†Î­ÏÎµÏ„Î±Î¹ ÏƒÏ„Î·Î½ ÏŒÎ»Î· Î· Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚ Ï€Î¿Ï… ÏƒÏ‡ÎµÏ„Î¯Î¶ÎµÏ„Î±Î¹ Î¼Îµ',0),(168574,4683,'zh','ä¸‹é¢çš„ç¼–å·å¿…é¡»å‡ºçŽ°åœ¨æ‰€æœ‰ç›¸å…³çš„å‡½ä»¶æŠ¥ä»·\r\n',0),(168575,4683,'sv','FÃ¶ljande nummer mÃ¥ste anges pÃ¥ alla citat relaterade korrespondens',0),(168576,4683,'it','Il seguente numero deve comparire su tutta la corrispondenza citazione correlata',0),(168577,4683,'tl','',0),(168578,4683,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3605;&#3656;&#3629;&#3652;&#3611;&#3609;&#3637;&#3657;&#3605;&#3657;&#3629;&#3591;&#3611;&#3619;&#3634;&#3585;&#3599;&#3651;&#3609; &#3651;&#3610;&#3648;&#3626;&#3609;&#3629;&#3619;&#3634;&#3588;&#3634;&#',0),(168579,4683,'hi','à¤¸à¤­à¥€ à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤¸à¤‚à¤¬à¤‚à¤§à¤¿à¤¤ à¤ªà¤¤à¥à¤°à¤¾à¤šà¤¾à¤° à¤ªà¤° à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¥à¤°à¤•à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(168580,4683,'ms','Nombor berikut mesti muncul pada semua surat-menyurat berkaitan petikan',0),(168581,4683,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØ¸Ù‡Ø± Ø±Ù‚Ù… Ø§Ù„ØªØ§Ù„ÙŠ Ø¹Ù„Ù‰ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…Ø±Ø§Ø³Ù„Ø§Øª Ø§Ù„Ù…ØªØµÙ„Ø© Ø¨Ø§Ù‚ØªØ¨Ø§Ø³',0),(168582,4683,'fr','Le numÃ©ro suivant doit apparaÃ®tre sur toute correspondance connexe citation',0),(168583,4683,'jp','æ¬¡ã?®ç•ªå?·ã?¯å¯¾å¿œã?«é–¢é€£ã?—ã?¦å…¨ã?¦ã?®è¦‹ç©?ã‚Šã?«è¡¨ç¤ºã?•ã‚Œã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(168584,4683,'pt','O nÃºmero seguinte deve aparecer na citaÃ§Ã£o relacionada toda a correspondÃªncia',0),(168585,4683,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð½Ð¾Ð¼ÐµÑ€ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¿Ð¾ÑÐ²Ð¸Ñ‚ÑŒÑÑ Ð½Ð° Ð²ÑÐµÑ… Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° Ð¿ÐµÑ€ÐµÐ¿Ð¸ÑÐºÐ°',0),(168586,4683,'es','El nÃºmero siguente debe aparecer en toda la corespondencia relacionada a las cotizaciones',0),(168587,4683,'de','Folgendem muss in AnfÃ¼hrungszeichen Verwandte Schriftverkehr angezeigt werden.',0),(168588,4683,'en','The following number must appear on all quote related correspondence',0),(168589,4684,'is','',0),(168590,4684,'dr','ØªØ§Ø±ÙŠØ® Ø§Ù…Ø±ÙˆØ² ',0),(168591,4684,'pr','ØªØ§Ø±ÙŠØ® Ø§Ù…Ø±ÙˆØ² ',0),(168592,4684,'tr','BugÃ¼nÃ¼n tarihi',0),(168593,4684,'pl','Dzisiejsza data',0),(168594,4684,'bg','Ð”Ð½ÐµÑˆÐ½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(168595,4684,'ur','Ø¢Ø¬ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(168596,4684,'sr','Ð”Ð°Ð½Ð°ÑˆÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(168597,4684,'vi','NgÃ y hÃ´m nay',0),(168598,4684,'af','Vandag se Datum',0),(168599,4684,'ro','Data de astÄƒzi',0),(168600,4684,'et','TÃ¤nane kuupÃ¤ev',0),(168601,4684,'si','DanaÅ¡nji datum',0),(168602,4684,'ba','Tanggal',0),(168603,4684,'nl','De datum van vandaag',0),(168604,4684,'fi','PÃ¤ivÃ¤stÃ¤',0),(168605,4684,'no','Dagens dato',0),(168606,4684,'da','Dags dato',0),(168607,4684,'ko','ì˜¤ëŠ˜ ë‚ ì§œ',0),(168608,4684,'he','×”×ª××¨×™×š ×©×œ ×”×™×•×',0),(168609,4684,'el','Î£Î®Î¼ÎµÏÎ±',0),(168610,4684,'zh','ä»Šå¤©çš„æ—¥æœŸ\r\n',0),(168611,4684,'sv','Dagens datum',0),(168612,4684,'it','Oggi',0),(168613,4684,'tl','',0),(168614,4684,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3623;&#3633;&#3609;&#3609;&#3637;&#3657;',0),(168615,4684,'hi','à¤†à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(168616,4684,'ms','Tarikh hari ini',0),(168617,4684,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙŠÙˆÙ…',0),(168618,4684,'fr','Date du jour',0),(168619,4684,'jp','æœ¬æ—¥ã?®æ—¥ä»˜',0),(168620,4684,'pt','A data de hoje',0),(168621,4684,'ru','Ð¡ÐµÐ³Ð¾Ð´Ð½ÑÑˆÐ½ÑÑ Ð´Ð°Ñ‚Ð°',0),(168622,4684,'es','Fecha de hoy',0),(168623,4684,'de','Heutiges Datum',0),(168624,4684,'en','Today\'s date',0),(168625,4685,'is','',0),(168626,4685,'dr','Ù…Ø¬Ø§Ù†ÙŠ',0),(168627,4685,'pr','Ù…Ø¬Ø§Ù†ÙŠ',0),(168628,4685,'tr','Ãœcretsiz arama',0),(168629,4685,'pl','BezpÅ‚atny numer telefonu',0),(168630,4685,'bg','Ð‘ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð°',0),(168631,4685,'ur','Ù¹ÙˆÙ„ ÙØ±ÛŒ',0),(168632,4685,'sr','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¸',0),(168633,4685,'vi','Gá»i miá»…n phÃ­',0),(168634,4685,'af','Tolvry',0),(168635,4685,'ro','Apelabil gratuit',0),(168636,4685,'et','Tasuta',0),(168637,4685,'si','BrezplaÄna',0),(168638,4685,'ba','Bebas pulsa',0),(168639,4685,'nl','Gratis',0),(168640,4685,'fi','Maksuton',0),(168641,4685,'no','Gratis',0),(168642,4685,'da','Toldfri',0),(168643,4685,'ko','ìˆ˜ì‹ ìž ë¶€ë‹´ ì „í™”',0),(168644,4685,'he','×©×™×—×ª ×—×™× ×',0),(168645,4685,'el','Î§Ï‰ÏÎ¯Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(168646,4685,'zh','å…è´¹ç”µè¯\r\n',0),(168647,4685,'sv','Avgiftsfritt',0),(168648,4685,'it','Numero verde gratuito',0),(168649,4685,'tl','',0),(168650,4685,'th','&#3611;&#3621;&#3629;&#3604;&#3616;&#3634;&#3625;&#3637;',0),(168651,4685,'hi','à¤Ÿà¥‹à¤² à¤«à¥à¤°à¥€',0),(168652,4685,'ms','Talian bebas tol',0),(168653,4685,'ar','Ø§Ù„Ø±Ù‚Ù… Ø§Ù„Ù…Ø¬Ø§Ù†ÙŠ',0),(168654,4685,'fr','Sans frais',0),(168655,4685,'jp','ãƒ•ãƒªãƒ¼ãƒ€ã‚¤ãƒ¤ãƒ«',0),(168656,4685,'pt','LigaÃ§Ã£o gratuita',0),(168657,4685,'ru','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ñ‹Ð¹ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(168658,4685,'es','Sin tarifa',0),(168659,4685,'de','GebÃ¼hrenfreie Nummer',0),(168660,4685,'en','Toll free',0),(168661,4686,'is','',0),(168662,4686,'dr','Ù…Ø§ Ù…Ù†ØªØ¸Ø± ØªÙˆÙ„ÙŠØ¯ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§ Ù‡Ø³ØªÙŠÙ…',0),(168663,4686,'pr','Ù…Ø§ Ù…Ù†ØªØ¸Ø± ØªÙˆÙ„ÙŠØ¯ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§ Ù‡Ø³ØªÙŠÙ…',0),(168664,4686,'tr','Bu sipariÅŸ iÃ§in Ã¼retmek iÃ§in sabÄ±rsÄ±zlanÄ±yoruz',0),(168665,4686,'pl','Czekamy na produkcji to zamÃ³wienie dla Ciebie',0),(168666,4686,'bg','ÐÐ¸Ðµ Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð¼Ðµ Ñ Ð½ÐµÑ‚ÑŠÑ€Ð¿ÐµÐ½Ð¸Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²ÐµÐ¶Ð´Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð²Ð°Ñ',0),(168667,4686,'ur','ÛÙ… Ø¢Ù¾ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ù¾ÛŒØ¯Ø§ÙˆØ§Ø± Ú©Û’ Ø´ÙˆÙ‚ÛŒÙ† ÛÛŒÚº',0),(168668,4686,'sr','Ð Ð°Ð´ÑƒÑ˜ÐµÐ¼Ð¾ ÑÐµ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸ Ð½Ð°Ñ€ÑƒÑŸÐ±Ð° Ð·Ð° Ñ‚ÐµÐ±Ðµ',0),(168669,4686,'vi','ChÃºng tÃ´i mong muá»‘n Ä‘á»ƒ sáº£n xuáº¥t Ä‘Æ¡n hÃ ng nÃ y cho báº¡n',0),(168670,4686,'af','Ons sien daarna uit om hierdie bestelling aan u te verskaf',0),(168671,4686,'ro','AÅŸteptÄƒm cu nerÄƒbdare pentru a produce acest ordin pentru tine',0),(168672,4686,'et','We look forward to producing this order for you',0),(168673,4686,'si','Veselimo se proizvajajo ta nalog za vas',0),(168674,4686,'ba','Kami berharap untuk memproduksi ini agar Anda',0),(168675,4686,'nl','We kijken uit naar het produceren van deze bestelling voor u',0),(168676,4686,'fi','Odotamme tuottaa jÃ¤rjestyksessÃ¤ puolestasi',0),(168677,4686,'no','Vi ser frem til Ã¥ produsere denne rekkefÃ¸lgen for deg',0),(168678,4686,'da','Vi ser frem til at producere denne rÃ¦kkefÃ¸lge for dig',0),(168679,4686,'ko','ë‹¹ì‹ ì„ ìœ„í•´ì´ ì£¼ë¬¸ ìƒì‚°ì„',0),(168680,4686,'he','×× ×• ×ž×¦×¤×™× ×‘×”×¤×§×ª ×¦×• ×–×” ×‘×©×‘×™×œ×š',0),(168681,4686,'el','Î‘Î½Ï…Ï€Î¿Î¼Î¿Î½Î¿ÏÎ¼Îµ Î½Î± Ï€Î±ÏÎ¬Î³Î¿Ï…Î½ Î±Ï…Ï„Î® Ï„Î·Î½ Î´Î¹Î¬Ï„Î±Î¾Î· Î³Î¹Î± ÏƒÎ±Ï‚',0),(168682,4686,'zh','æˆ‘ä»¬æœŸå¾…ç€ä¸ºæ‚¨ç”Ÿäº§æ­¤è®¢å•\r\n',0),(168683,4686,'sv','Vi ser fram emot att producera detta fÃ¶r att du',0),(168684,4686,'it','Saremo lieti di produrre questo ordine per voi',0),(168685,4686,'tl','',0),(168686,4686,'th','We look forward to producing this order for you',0),(168687,4686,'hi','à¤¹à¤® à¤†à¤ª à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¤¤à¥à¤ªà¤° à¤¹à¥ˆà¤‚',0),(168688,4686,'ms','Kami berharap untuk mengeluarkan pesanan ini untuk anda',0),(168689,4686,'ar','ÙˆÙ†Ø­Ù† Ù†ØªØ·Ù„Ø¹ Ø¥Ù„Ù‰ Ø¥Ù†ØªØ§Ø¬ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù… Ù„Ùƒ',0),(168690,4686,'fr','Nous attendons avec impatience Ã  la production de cet ordre pour vous',0),(168691,4686,'jp','ã?“ã?®æ³¨æ–‡ã‚’è£½é€ ã?™ã‚‹ã?®ã‚’æ¥½ã?—ã?¿ã?«ã?—ã?¦ã?Šã‚Šã?¾ã?™',0),(168692,4686,'pt','Estamos ansiosos para produzir esta ordem para vocÃª',0),(168693,4686,'ru','ÐœÑ‹ Ñ Ð½ÐµÑ‚ÐµÑ€Ð¿ÐµÐ½Ð¸ÐµÐ¼ Ð¾Ð¶Ð¸Ð´Ð°ÐµÐ¼ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð° ÑÑ‚Ð¾Ñ‚ Ð·Ð°ÐºÐ°Ð· Ð´Ð»Ñ Ð²Ð°Ñ',0),(168694,4686,'es','Esperamos con gusto producir este orden para usted',0),(168695,4686,'de','Wir freuen uns auf die Herstellung dieser Auftrag fÃ¼r Sie',0),(168696,4686,'en','We look forward to producing this order for you',0),(168697,4687,'is','',0),(168698,4687,'dr','- Ø¢Ù…Ø±ÙŠÙƒÙ† Ø§ÙƒØ³Ù¾Ø±Ø³ Ø±Ø§ Ù…ÙŠ Ù¾Ø°ÙŠØ±ÙŠÙ… Ùˆ Ø¯Ø±ÙŠØ§ÙØªÙŠÙ… ',0),(168699,4687,'pr','Ù…Ø§ Ø§ÙƒÙ†ÙˆÙ† ÙƒØ§Ø±ØªÙ‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ  ÙˆÙŠØ²Ø§ â€“ Ù…Ø³ØªØ± ÙƒØ§Ø±Øª- Ø¢Ù…Ø±ÙŠÙƒÙ† Ø§ÙƒØ³Ù¾Ø±Ø³ Ø±Ø§ Ù…ÙŠ Ù¾Ø°ÙŠØ±ÙŠÙ… Ùˆ Ø¯Ø±ÙŠØ§ÙØªÙŠÙ… ',0),(168700,4687,'tr','Visa, Mastercard, American Express ve Discover ÅŸimdi kabul ediyoruz',0),(168701,4687,'pl','Teraz akceptujemy Visa, Mastercard, American Express i Discover',0),(168702,4687,'bg','Ð’ÐµÑ‡Ðµ Ð¿Ñ€Ð¸ÐµÐ¼Ð°Ð¼Ðµ Visa, Mastercard, American Express Ð¸ ÐžÑ‚ÐºÑ€Ð¸Ð¹Ñ‚Ðµ',0),(168703,4687,'ur','ÛÙ… Ø§Ø¨ ÙˆÛŒØ²Ø§ØŒ Ù…Ø§Ø³Ù¹Ø±Ú©Ø§Ø±ÚˆØŒ Ø§Ù…Ø±ÛŒÚ©Ù† Ø§ÛŒÚ©Ø³Ù¾Ø±ÛŒØ³ Ø§ÙˆØ± Ø¯Ø±ÛŒØ§ÙØª Ù‚Ø¨ÙˆÙ„ Ú©Ø±ÛŒÚº Û”',0),(168704,4687,'sr','Ð¡Ð°Ð´Ð° Ð¿Ñ€Ð¸Ð¼Ð°Ð¼Ð¾ Ð’Ð¸ÑÐ°, ÐœÐ°ÑÑ‚ÐµÑ€Ñ†Ð°Ñ€Ð´, ÐÐ¼ÐµÑ€Ð¸Ñ†Ð°Ð½ Ð•xÐ¿Ñ€ÐµÑÑ Ð¸ Ð”Ð¸ÑÑ†Ð¾Ð²ÐµÑ€',0),(168705,4687,'vi','ChÃºng tÃ´i cháº¥p nháº­n tháº» Visa, Mastercard, American Express, vÃ  Discover',0),(168706,4687,'af','Ons aanvaar nou Visa, Mastercard, American Express, en Discover',0),(168707,4687,'ro','Acum vom accepta Visa, Mastercard, American Express ÅŸi Discover',0),(168708,4687,'et','Aksepteerime Visa, Mastercard, American Express ja Discover kaarte',0),(168709,4687,'si','Zdaj sprejemamo, Visa, Mastercard, American Express ter Discover',0),(168710,4687,'ba','Kini kami menerima Visa, Mastercard, American Express, dan Discover',0),(168711,4687,'nl','Nu accepteren wij Visa, Mastercard, American Express en Discover',0),(168712,4687,'fi','TÃ¤llÃ¤ hetkellÃ¤ hyvÃ¤ksymme Visa, Mastercard, American Express ja Discover',0),(168713,4687,'no','Vi nÃ¥ aksepterer Visa, Mastercard, American Express og Discover',0),(168714,4687,'da','Vi nu accepterer Visa, Mastercard, American Express og Discover',0),(168715,4687,'ko','ìš°ë¦¬ ì§€ê¸ˆ ë¹„ìž, ë§ˆìŠ¤í„° ì¹´ë“œ, ì•„ë©”ë¦¬ì¹¸ ìµìŠ¤í”„ë ˆìŠ¤ì™€ ë””ìŠ¤ ì»¤ë²„ì— ë™ì˜',0),(168716,4687,'he','×¢×›×©×™×• ×× ×—× ×• ×ž×§×‘×œ×™× ×•×™×–×”, ×ž××¡×˜×¨×§××¨×“, ××ž×¨×™×§×Ÿ ××§×¡×¤×¨×¡, ×’×œ×”',0),(168717,4687,'el','Î”ÎµÏ‡ÏŒÎ¼Î±ÏƒÏ„Îµ Ï„ÏŽÏÎ± Visa, Mastercard, American Express ÎºÎ±Î¹ Discover',0),(168718,4687,'zh','çŽ°åœ¨ï¼Œæˆ‘ä»¬æŽ¥å—ç»´è¨ï¼Œä¸‡äº‹è¾¾ï¼Œç¾Žå›½è¿é€šå’Œå‘çŽ°',0),(168719,4687,'sv','Vi nu accepterar Visa, Mastercard, American Express och Discover',0),(168720,4687,'it','Ora Accettiamo Visa, Mastercard, American Express e Discover',0),(168721,4687,'tl','',0),(168722,4687,'th','We now accept Visa, Mastercard, American Express, and Discover',0),(168723,4687,'hi','à¤¹à¤® à¤…à¤¬ à¤µà¥€à¤¸à¤¾, à¤®à¤¾à¤¸à¥à¤Ÿà¤°à¥à¤•à¤¾à¤°à¥à¤¡, à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¨ à¤à¤•à¥à¤¸à¤ªà¥à¤°à¥‡à¤¸ à¤”à¤° à¤¡à¤¿à¤¸à¥à¤•à¤µà¤° à¤•à¥‹ à¤¸à¥à¤µà¥€à¤•à¤¾à¤°',0),(168724,4687,'ms','Kami kini menerima Visa, Mastercard, American Express dan Cari',0),(168725,4687,'ar','Ù†Ø­Ù† Ø§Ù„Ø¢Ù† Ù†Ù‚Ø¨Ù„ ÙÙŠØ²Ø§ØŒ Ù…Ø§Ø³ØªØ±ÙƒØ§Ø±Ø¯ØŒ Ø£Ù…Ø±ÙŠÙƒØ§Ù† Ø¥ÙƒØ³Ø¨Ø±ÙŠØ³ØŒ ÙˆØ§ÙƒØªØ´Ù',0),(168726,4687,'fr','Nous acceptons Visa, Mastercard, American Express et Discover',0),(168727,4687,'jp','ç?¾åœ¨ãƒ“ã‚¶ã€?ãƒžã‚¹ã‚¿ãƒ¼ã‚«ãƒ¼ãƒ‰ã€?ã‚¢ãƒ¡ãƒªã‚«ãƒ³ã‚¨ã‚¯ã‚¹ãƒ—ãƒ¬ã‚¹ã€?ãƒ‡ã‚£ã‚¹ã‚«ãƒ?ãƒ¼ã‚’å?–ã‚Šæ‰±ã?£ã?¦ã?„ã?¾ã?™',0),(168728,4687,'pt','Agora aceitamos Visa, Mastercard, American Express e Discover',0),(168729,4687,'ru','Ð¢ÐµÐ¿ÐµÑ€ÑŒ Ð¼Ñ‹ Ð¿Ñ€Ð¸Ð½Ð¸Ð¼Ð°ÐµÐ¼ Visa, Mastercard, American Express Ð¸ Discover',0),(168730,4687,'es','Ya aceptamos Visa, Mastercard, American Express y Discover',0),(168731,4687,'de','Wir akzeptieren jetzt Visa, Mastercard, American Express und Discover',0),(168732,4687,'en','We now accept Visa, Mastercard, American Express, and Discover',0),(168733,4688,'is','',0),(168734,4688,'dr','Ø´Ù…Ø§ Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ ÙØ±Ù… Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø±Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø®ÙˆØ¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(168735,4688,'pr','Ø´Ù…Ø§ Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ ÙØ±Ù… Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø±Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø®ÙˆØ¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(168736,4688,'tr','Sen-ebilmek kullanma bu teklif formu, satÄ±nalma sipariÅŸi olarak',0),(168737,4688,'pl','MoÅ¼esz uÅ¼yÄ‡ tego formularza oferty jako zamÃ³wienie zakupu',0),(168738,4688,'bg','ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ñ„Ð¾Ñ€Ð¼Ð° ÐºÐ°Ñ‚Ð¾ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(168739,4688,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§Ù¾Ù†ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©Û’ Ø·ÙˆØ± Ù¾Ø± ÛŒÛ Ø§Ù‚ØªØ¨Ø§Ø³ ÙØ§Ø±Ù… Ú©Ùˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(168740,4688,'sr','ÐšÐ°Ð¾ Ñ‚Ð²Ð¾Ñ˜ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð¾Ð²Ð°Ñ˜ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ† Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(168741,4688,'vi','Báº¡n cÃ³ thá»ƒ sá»­ dá»¥ng máº«u bÃ¡o giÃ¡ nÃ y lÃ m Ä‘Æ¡n mua hÃ ng',0),(168742,4688,'af','U kan die KWOTASIE vorm gebruik as u AANKOOPBESTELLING.',0),(168743,4688,'ro','UtilizaÅ£i acest formular de ofertÄƒ ca comenzii de cumpÄƒrare',0),(168744,4688,'et','Te vÃµite seda quote vormi kasutada nagu ostutellmust',0),(168745,4688,'si','Uporabite lahko ta obrazec ponudbe kot nabavni nalog',0),(168746,4688,'ba','Anda dapat menggunakan formulir kutipan ini sebagai order pembelian Anda',0),(168747,4688,'nl','U kunt deze offerteformulier gebruiken als uw inkooporder',0),(168748,4688,'fi','Voit kÃ¤yttÃ¤Ã¤ tÃ¤mÃ¤n tarjouksen lomakkeen ostotilaus',0),(168749,4688,'no','Du kan bruke denne tilbud form som bestillingen',0),(168750,4688,'da','Du kan bruge denne citerer form som din bestilling',0),(168751,4688,'ko','ì´ ê²¬ì  ì–‘ì‹ì„ ì‚¬ìš© í•˜ ì—¬ ê·€í•˜ì˜ êµ¬ë§¤ ì£¼ë¬¸ìœ¼ë¡œ',0),(168752,4688,'he','××ª×” ×™×›×•×œ ×œ×”×©×ª×ž×© ×‘×˜×•×¤×¡ ×”×¦×¢×ª ×”×ž×—×™×¨ ×”×–×” ×›×ž×• ×”×–×ž× ×ª ×”×¨×›×™×©×” ×©×œ×š',0),(168753,4688,'el','ÎœÏ€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Ï…Ï„Î® Ï„Î· Ï†ÏŒÏÎ¼Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚ Ï‰Ï‚ ÏƒÎ±Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(168754,4688,'zh','æ‚¨å¯ä»¥ä½¿ç”¨æ­¤æŠ¥ä»·è¡¨ä½œä¸ºæ‚¨çš„è´­ä¹°è®¢å•\r\n',0),(168755,4688,'sv','Du kan anvÃ¤nda denna offertformulÃ¤ret som din bestÃ¤llning',0),(168756,4688,'it','Ãˆ possibile utilizzare questa forma di citazione come vostro ordine di acquisto',0),(168757,4688,'tl','',0),(168758,4688,'th','&#3588;&#3640;&#3603;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3605;&#3634;&#3617;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3',0),(168759,4688,'hi','à¤†à¤ª à¤…à¤ªà¤¨à¥‡ à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤‡à¤¸ à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤«à¤¾à¤°à¥à¤® à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(168760,4688,'ms','Anda boleh menggunakan borang sebut harga ini sebagai pesanan belian',0),(168761,4688,'ar','ÙŠÙ…ÙƒÙ†Ùƒ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù‡Ø°Ø§ Ø§Ù„Ù†Ù…ÙˆØ°Ø¬ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ÙƒØ£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(168762,4688,'fr','Vous pouvez utiliser ce formulaire de soumission comme votre bon de commande',0),(168763,4688,'jp','ã?“ã?®è¦‹ç©?æ›¸ã‚’ç™ºæ³¨æ›¸ã?¨ã?—ã?¦ä½¿ç”¨ã?§ã??ã?¾ã?™',0),(168764,4688,'pt','VocÃª pode usar essa forma de citaÃ§Ã£o como sua ordem de compra',0),(168765,4688,'ru','Ð’Ñ‹ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ñƒ Ñ„Ð¾Ñ€Ð¼Ñƒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÐºÐ°Ðº Ð²Ð°Ñˆ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(168766,4688,'es','Puede usar este formato de cotizaciÃ³n como su orden de compra',0),(168767,4688,'de','Dieses Angebotsformular kÃ¶nnen Sie als Ihre Bestellung',0),(168768,4688,'en','You can use this quote form as your purchase order',0),(168769,4689,'is','',0),(168770,4689,'dr','Ø±ÙˆÙŠ Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø³ÙØ§Ø±Ø´ Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†ÙŠØ¯',0),(168771,4689,'pr','Ø±ÙˆÙŠ Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø³ÙØ§Ø±Ø´ Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†ÙŠØ¯',0),(168772,4689,'tr','SipariÅŸ onaylamak Ã¼zere iÅŸ numarasÄ±nÄ± tÄ±klatÄ±n',0),(168773,4689,'pl','Kliknij na numer zadania do potwierdzenia zamÃ³wienia',0),(168774,4689,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° Ð´Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(168775,4689,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¬Ø§Ø¨ Ù†Ù…Ø¨Ø± Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(168776,4689,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð±Ñ€Ð¾Ñ˜ Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ð»Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(168777,4689,'vi','Nháº¥n vÃ o sá»‘ Job Ä‘á»ƒ xÃ¡c nháº­n Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(168778,4689,'af','Kliek op Werkstuknommer om Bestelling te Bevestig',0),(168779,4689,'ro','FaceÅ£i clic pe numÄƒrul de Job pentru a confirma comanda',0),(168780,4689,'et','Projekti numbri tellimuse kinnitamiseks vajuta',0),(168781,4689,'si','Kliknite na Å¡tevilka projekta za potrditev naloga',0),(168782,4689,'ba','Klik pada nomor pekerjaan untuk mengkonfirmasi pesanan',0),(168783,4689,'nl','Klik op projectnummer ter bevestiging van bestelling',0),(168784,4689,'fi','Klikkaa projektinumeron vahvista tilaus',0),(168785,4689,'no','Klikk pÃ¥ jobbnummer Ã¥ bekrefte ordre',0),(168786,4689,'da','Klik pÃ¥ jobnummer at bekrÃ¦fte ordren',0),(168787,4689,'ko','ìˆœì„œë¥¼ í™•ì¸ í•˜ë ¤ë©´ ìž‘ì—… ë²ˆí˜¸ í´ë¦­',0),(168788,4689,'he','×œ×—×¥ ×¢×œ ×”×ž×©×™×ž×” ×©×ž×¡×¤×¨×” ×œ××©×¨ ×”×¡×“×¨',0),(168789,4689,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î³Î¹Î± Î½Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(168790,4689,'zh','å¯¹æ‹›è˜äººæ•°ç‚¹å‡»ç¡®è®¤è®¢å•\r\n',0),(168791,4689,'sv','Klicka pÃ¥ jobbnummer att bekrÃ¤fta Order',0),(168792,4689,'it','Clicca sul numero per confermare l\'ordine di lavoro',0),(168793,4689,'tl','',0),(168794,4689,'th','&#3588;&#3621;&#3636;&#3585;&#3610;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3591;&#3634;&#3609;&#3648;&#3614;&#3639;&#3656;&#3629;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3',0),(168795,4689,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(168796,4689,'ms','Klik pada nombor kerja untuk mengesahkan pesanan',0),(168797,4689,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø±Ù‚Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ© Ù„ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø£Ù…Ø±',0),(168798,4689,'fr','Cliquez sur le numÃ©ro d\'emploi afin de confirmer l\'ordonnance',0),(168799,4689,'jp','æ³¨æ–‡ã‚’ç¢ºèª?ã?™ã‚‹ã?«ã?¯ä½œæ¥­ç•ªå?·ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(168800,4689,'pt','Clique no nÃºmero de emprego para confirmar a ordem',0),(168801,4689,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ Ð´Ð»Ñ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(168802,4689,'es','Click sobre el NÃºmero de Trabajo para Confirmar el Pedido',0),(168803,4689,'de','Klicken Sie auf Job-Nummer Bestellung bestÃ¤tigen',0),(168804,4689,'en','Click on Job Number to Confirm Order',0),(168805,4690,'is','',0),(168806,4690,'dr','ØªÙ„ÙÙ† ØªÙ…Ø§Ø³ ',0),(168807,4690,'pr','ØªÙ„ÙÙ† ØªÙ…Ø§Ø³ ',0),(168808,4690,'tr','KiÅŸinin telefonu',0),(168809,4690,'pl','Telefon kontaktowy',0),(168810,4690,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ Ð·Ð° Ð²Ñ€ÑŠÐ·ÐºÐ°',0),(168811,4690,'ur','ÙÙˆÙ† Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº',0),(168812,4690,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(168813,4690,'vi','Phone liÃªn há»‡',0),(168814,4690,'af','Kontak Telefoon',0),(168815,4690,'ro','Telefon de contact',0),(168816,4690,'et','Kontakttelefon',0),(168817,4690,'si','Kontaktni telefon',0),(168818,4690,'ba','Hubungi telepon',0),(168819,4690,'nl','Contact telefoon',0),(168820,4690,'fi','Puhelinnumero',0),(168821,4690,'no','Kontakt telefon',0),(168822,4690,'da','Kontakt telefon',0),(168823,4690,'ko','ì—°ë½ì²˜ ì „í™”',0),(168824,4690,'he','×˜×œ×¤×•×Ÿ ××™×© ×§×©×¨',0),(168825,4690,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚',0),(168826,4690,'zh','è”ç³»ç”µè¯\r\n',0),(168827,4690,'sv','Kontakta telefon',0),(168828,4690,'it','Telefono di contatto',0),(168829,4690,'tl','',0),(168830,4690,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(168831,4690,'hi','à¤«à¥‹à¤¨ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚',0),(168832,4690,'ms','Hubungi telefon',0),(168833,4690,'ar','Ø§Ù„Ø§ØªØµØ§Ù„ Ø¨Ø§Ù„Ù‡Ø§ØªÙ',0),(168834,4690,'fr','TÃ©lÃ©phone de contact',0),(168835,4690,'jp','é€£çµ¡å…ˆé›»è©±',0),(168836,4690,'pt','Telefone de contato',0),(168837,4690,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ñ‹Ð¹ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(168838,4690,'es','TelÃ©fono de Contacto',0),(168839,4690,'de','Kontakt Telefon',0),(168840,4690,'en','Contact Phone',0),(168841,4691,'is','',0),(168842,4691,'dr','ØªØ§Ø±ÙŠØ® Ø§Ø±Ø³Ø§Ù„',0),(168843,4691,'pr','ØªØ§Ø±ÙŠØ® Ø§Ø±Ø³Ø§Ù„',0),(168844,4691,'tr','GÃ¶nderme tarihi',0),(168845,4691,'pl','Data przedstawienia',0),(168846,4691,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ',0),(168847,4691,'ur','ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ø¬Ù…Ø¹ Ú©Ø±Ø§Ø¦ÛŒÚº',0),(168848,4691,'sr','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(168849,4691,'vi','NgÃ y ná»™p',0),(168850,4691,'af','Inhandigingsdatum',0),(168851,4691,'ro','Prezinte data',0),(168852,4691,'et','Esitamise kuupÃ¤ev',0),(168853,4691,'si','PredloÅ¾iti datum',0),(168854,4691,'ba','Tanggal Kirim',0),(168855,4691,'nl','Indienen van datum',0),(168856,4691,'fi','LÃ¤hetys pvm',0),(168857,4691,'no','Sende dato',0),(168858,4691,'da','Indsende dato',0),(168859,4691,'ko','ë“±ë¡ ì‹œê°„',0),(168860,4691,'he','×ª××¨×™×š ×©×œ×™×—×”',0),(168861,4691,'el','Î¥Ï€Î¿Î²Î¬Î»Î¿Ï…Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(168862,4691,'zh','æäº¤æ—¥æœŸ\r\n',0),(168863,4691,'sv','LÃ¤mna in datum',0),(168864,4691,'it','Data di invio',0),(168865,4691,'tl','',0),(168866,4691,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3626;&#3609;&#3629;',0),(168867,4691,'hi','à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(168868,4691,'ms','Tarikh hantar',0),(168869,4691,'ar','ÙŠÙ‚Ø¯Ù… Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(168870,4691,'fr','Soumettre la Date',0),(168871,4691,'jp','æ??å‡ºæ—¥',0),(168872,4691,'pt','Apresentar a data',0),(168873,4691,'ru','Ð”Ð°Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(168874,4691,'es','Presentar Fecha',0),(168875,4691,'de','Datum einreichen',0),(168876,4691,'en','Submit Date',0),(168877,4692,'is','',0),(168878,4692,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(168879,4692,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(168880,4692,'tr','Onaylanmayan sipariÅŸ YazdÄ±r',0),(168881,4692,'pl','Niepotwierdzone zamÃ³wienia druku',0),(168882,4692,'bg','ÐÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(168883,4692,'ur','ØºÛŒØ± Ù…ØµØ¯Ù‚Û Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(168884,4692,'sr','ÐÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð¸Ð¼ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(168885,4692,'vi','ÄÆ¡n HÃ ng in chÆ°a xÃ¡c nháº­n',0),(168886,4692,'af','Onbevestigde Gedrukte Bestellings',0),(168887,4692,'ro','Comenzi neconfirmate de imprimare',0),(168888,4692,'et','Kinnitamata trÃ¼kitÃ¶Ã¶de tellimused',0),(168889,4692,'si','Nepotrjenih naroÄil tiskanje',0),(168890,4692,'ba','Pesanan cetak yang belum dikonfirmasi',0),(168891,4692,'nl','Onbevestigde afdrukken bestellingen',0),(168892,4692,'fi','Vahvistamattomien tulosta tilaukset',0),(168893,4692,'no','Ubekreftet bestilling',0),(168894,4692,'da','UbekrÃ¦ftede aftryksbestillinger',0),(168895,4692,'ko','ë¯¸í™•ì¸ëœ ì¸ì‡„ ì£¼ë¬¸',0),(168896,4692,'he','×”×“×¤×¡×•×ª ×œ× ×ž××•×©×¨×•×ª',0),(168897,4692,'el','Î‘Î½ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰Ï„ÎµÏ‚ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½',0),(168898,4692,'zh','æœªç¡®è®¤çš„æ‰“å°è®¢å•\r\n',0),(168899,4692,'sv','ObekrÃ¤ftade Print Order',0),(168900,4692,'it','Ordini di stampa non confermati',0),(168901,4692,'tl','',0),(168902,4692,'th','&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(168903,4692,'hi','à¤…à¤ªà¥à¤·à¥à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶',0),(168904,4692,'ms','Pesanan cetakan yang belum disahkan',0),(168905,4692,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© ØºÙŠØ± Ù…Ø¤ÙƒØ¯Ø©',0),(168906,4692,'fr','Commandes non confirmÃ©es',0),(168907,4692,'jp','æœªç¢ºèª?å?°åˆ·æ³¨æ–‡',0),(168908,4692,'pt','Ordens de impressÃ£o nÃ£o confirmadas',0),(168909,4692,'ru','ÐÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(168910,4692,'es','Ordenes No Confirmados de ImpresiÃ³n',0),(168911,4692,'de','UnbestÃ¤tigte DruckauftrÃ¤ge',0),(168912,4692,'en','Unconfirmed Print Orders',0),(168913,4693,'is','',0),(168914,4693,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ÙØ±ÙˆØ´ ',0),(168915,4693,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ÙØ±ÙˆØ´ ',0),(168916,4693,'tr','Maliyet satÄ±ÅŸ',0),(168917,4693,'pl','Koszty sprzedaÅ¼y',0),(168918,4693,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(168919,4693,'ur','Ù‚ÛŒÙ…Øª ÙØ±ÙˆØ®Øª',0),(168920,4693,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(168921,4693,'vi','Chi phÃ­ bÃ¡n hÃ ng',0),(168922,4693,'af','Koste van verkope',0),(168923,4693,'ro','-Cost de vÃ¢nzÄƒri',0),(168924,4693,'et','Hinnaga mÃ¼Ã¼k',0),(168925,4693,'si','StroÅ¡ki prodaje',0),(168926,4693,'ba','Biaya penjualan',0),(168927,4693,'nl','Kosten verkoop',0),(168928,4693,'fi','Kustannusten myynti',0),(168929,4693,'no','Pris salg',0),(168930,4693,'da','Pris salg',0),(168931,4693,'ko','ë¹„ìš©ëœ íŒë§¤',0),(168932,4693,'he','×¢×œ×•×ª ×”×ž×›×™×¨×•×ª',0),(168933,4693,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(168934,4693,'zh','é”€å”®æˆæœ¬\r\n',0),(168935,4693,'sv','Kostnad fÃ¶rsÃ¤ljning',0),(168936,4693,'it','Costo di vendita',0),(168937,4693,'tl','',0),(168938,4693,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3634;&#3618;',0),(168939,4693,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(168940,4693,'ms','Kos jualan',0),(168941,4693,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(168942,4693,'fr','CoÃ»t des ventes',0),(168943,4693,'jp','ã‚»ãƒ¼ãƒ«ã‚¹è²»ç”¨',0),(168944,4693,'pt','Custo de vendas',0),(168945,4693,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(168946,4693,'es','Costo Ventas',0),(168947,4693,'de','Kosten Umsatz',0),(168948,4693,'en','Cost Sales',0),(168949,4694,'is','',0),(168950,4694,'dr','Ø®Ø±ÙŠØ¯Ù‡Ø§ ',0),(168951,4694,'pr','Ø®Ø±ÙŠØ¯Ù‡Ø§ ',0),(168952,4694,'tr','AlÄ±mlarÄ±',0),(168953,4694,'pl','Zakupy',0),(168954,4694,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸',0),(168955,4694,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(168956,4694,'sr','ÐÐ°Ð±Ð°Ð²ÐºÐµ',0),(168957,4694,'vi','Mua',0),(168958,4694,'af','Aankope',0),(168959,4694,'ro','AchiziÅ£ii',0),(168960,4694,'et','Ostud',0),(168961,4694,'si','Nakupi',0),(168962,4694,'ba','Pembelian',0),(168963,4694,'nl','Aankopen',0),(168964,4694,'fi','Ostot',0),(168965,4694,'no','KjÃ¸p',0),(168966,4694,'da','KÃ¸b',0),(168967,4694,'ko','êµ¬ë§¤',0),(168968,4694,'he','×¨×›×™×©×•×ª',0),(168969,4694,'el','Î‘Î³Î¿ÏÎ­Ï‚',0),(168970,4694,'zh','è´­ä¹°\r\n',0),(168971,4694,'sv','InkÃ¶p',0),(168972,4694,'it','Acquisti',0),(168973,4694,'tl','',0),(168974,4694,'th','&#3595;&#3639;&#3657;&#3629;',0),(168975,4694,'hi','à¤–à¤°à¥€à¤¦',0),(168976,4694,'ms','Pembelian',0),(168977,4694,'ar','Ø§Ù„Ù…Ø´ØªØ±ÙŠØ§Øª',0),(168978,4694,'fr','Achats',0),(168979,4694,'jp','è³¼å…¥å“?',0),(168980,4694,'pt','Compras',0),(168981,4694,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸',0),(168982,4694,'es','Compras',0),(168983,4694,'de','EinkÃ¤ufe',0),(168984,4694,'en','Purchases',0),(168985,4695,'is','',0),(168986,4695,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡',0),(168987,4695,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡',0),(168988,4695,'tr','DÃ¼zeltilmiÅŸ Mkt.',0),(168989,4695,'pl','IloÅ›Ä‡ dostosowane',0),(168990,4695,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ð¸',0),(168991,4695,'ur','Ù‚ÛŒ Ø§ÛŒÚˆØ¬Ø³Ù¹',0),(168992,4695,'sr','ÐšÐ¾Ñ€Ð¸Ð³Ð¾Ð²Ð°Ð½Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(168993,4695,'vi','Chá»‰nh Sá»‘ lÆ°á»£ng',0),(168994,4695,'af','Hoev. Aangepas',0),(168995,4695,'ro','Cantit ajustate',0),(168996,4695,'et','Kohandatud kogus',0),(168997,4695,'si','Prilagojena koliÄina',0),(168998,4695,'ba','Qty disesuaikan',0),(168999,4695,'nl','Aantal aangepast',0),(169000,4695,'fi','MÃ¤Ã¤rÃ¤ oikaistu',0),(169001,4695,'no','Antall justert',0),(169002,4695,'da','Antal justeret',0),(169003,4695,'ko','ìˆ˜ëŸ‰ ì¡°ì •',0),(169004,4695,'he','×›×ž×•×ª ×ž×•×ª××',0),(169005,4695,'el','Qty Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÏ„ÎµÎ¯',0),(169006,4695,'zh','æ•°é‡è°ƒæ•´\r\n',0),(169007,4695,'sv','Antal justeras',0),(169008,4695,'it','Qty regolata',0),(169009,4695,'tl','',0),(169010,4695,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(169011,4695,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤',0),(169012,4695,'ms','Qty yang diselaraskan',0),(169013,4695,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ ØªÙ… ØªØ¹Ø¯ÙŠÙ„Ù‡Ø§',0),(169014,4695,'fr','Qty ajustÃ©',0),(169015,4695,'jp','èª¿æ•´æ¸ˆæ•°é‡?',0),(169016,4695,'pt','Qty ajustado',0),(169017,4695,'ru','ÐšÐ¾Ð»-Ð²Ð¾ ÑÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð°',0),(169018,4695,'es','Cant. Ajustada',0),(169019,4695,'de','Qty angepasst',0),(169020,4695,'en','Qty Adjusted',0),(169021,4696,'is','',0),(169022,4696,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(169023,4696,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(169024,4696,'tr','SatÄ±lan birim',0),(169025,4696,'pl','Sprzedanych egzemplarzy',0),(169026,4696,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(169027,4696,'ur','ÛŒÙˆÙ†Ù¹ ÙØ±ÙˆØ®Øª',0),(169028,4696,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ‚Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(169029,4696,'vi','ÄÆ¡n vá»‹ Ä‘Ã£ bÃ¡n',0),(169030,4696,'af','Eenhede Verkoop',0),(169031,4696,'ro','UnitÄƒÅ£i vÃ¢ndute',0),(169032,4696,'et','MÃ¼Ã¼dud Ã¼hikute',0),(169033,4696,'si','Prodanih enot',0),(169034,4696,'ba','Unit terjual',0),(169035,4696,'nl','Verkochte eenheden',0),(169036,4696,'fi','Myydyt yksikÃ¶t',0),(169037,4696,'no','Solgte enheter',0),(169038,4696,'da','Enheder solgt',0),(169039,4696,'ko','íŒë§¤ ë‹¨ìœ„',0),(169040,4696,'he','×™×—×™×“×•×ª ×©× ×ž×›×¨×•',0),(169041,4696,'el','ÎœÎ¿Î½Î¬Î´ÎµÏ‚ Ï€Ï‰Î»Î¿ÏÎ½Ï„Î±Î¹',0),(169042,4696,'zh','å•ä½é”€å”®\r\n',0),(169043,4696,'sv','SÃ¥lda enheter',0),(169044,4696,'it','UnitÃ  vendute',0),(169045,4696,'tl','',0),(169046,4696,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(169047,4696,'hi','à¤¬à¥‡à¤šà¤¾ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(169048,4696,'ms','Unit-unit yang dijual',0),(169049,4696,'ar','Ø§Ù„ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù…Ø¨Ø§Ø¹Ø©',0),(169050,4696,'fr','UnitÃ©s vendues',0),(169051,4696,'jp','å£²å?´æ¸ˆå?˜ä½?',0),(169052,4696,'pt','Unidades vendidas',0),(169053,4696,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð•Ð´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(169054,4696,'es','Unidades Vendidos',0),(169055,4696,'de','Verkaufte Einheiten',0),(169056,4696,'en','Units Sold',0),(169057,4697,'is','',0),(169058,4697,'dr','Ù„ØºÙˆ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(169059,4697,'pr','Ù„ØºÙˆ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(169060,4697,'tr','Ä°ptal baÅŸarÄ±sÄ±z oldu',0),(169061,4697,'pl','Anuluj nie powiodÅ‚o siÄ™',0),(169062,4697,'bg','ÐžÑ‚ÐºÐ°Ð· Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(169063,4697,'ur','Ù†Ø§Ú©Ø§Ù… Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº',0),(169064,4697,'sr','\"ÐžÑ‚ÐºÐ°Ð¶Ð¸ \" Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð°',0),(169065,4697,'vi','XÃ³a tháº¥t báº¡i',0),(169066,4697,'af','Kanselleer het misluk',0),(169067,4697,'ro','Revocare a eÅŸuat',0),(169068,4697,'et','Loobu nurjus',0),(169069,4697,'si','Preklic ni uspel',0),(169070,4697,'ba','Membatalkan gagal',0),(169071,4697,'nl','Annuleren is mislukt',0),(169072,4697,'fi','Peruuttaminen epÃ¤onnistui',0),(169073,4697,'no','Avbryt mislyktes',0),(169074,4697,'da','Annuller mislykkedes',0),(169075,4697,'ko','ì·¨ì†Œ ì‹¤íŒ¨',0),(169076,4697,'he','×‘×™×˜×•×œ × ×›×©×œ×”',0),(169077,4697,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(169078,4697,'zh','å–æ¶ˆå¤±è´¥\r\n',0),(169079,4697,'sv','Avbryt misslyckades',0),(169080,4697,'it','Annulla non riuscita',0),(169081,4697,'tl','',0),(169082,4697,'th','&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(169083,4697,'hi','à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(169084,4697,'ms','Batal yang gagal',0),(169085,4697,'ar','Ø¥Ù„ØºØ§Ø¡ Ø§Ù„ÙØ§Ø´Ù„Ø©',0),(169086,4697,'fr','Annuler a Ã©chouÃ©',0),(169087,4697,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(169088,4697,'pt','Cancelar falhado',0),(169089,4697,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(169090,4697,'es','Cancelar FallÃ³',0),(169091,4697,'de','\"Abbrechen\" ist fehlgeschlagen',0),(169092,4697,'en','Cancel Failed',0),(169093,4698,'is','',0),(169094,4698,'dr','ØªØºÙŠÙŠØ± Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø²',0),(169095,4698,'pr','ØªØºÙŠÙŠØ± Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø²',0),(169096,4698,'tr','AÃ§Ä±k sÄ±rasÄ±nÄ± deÄŸiÅŸtir',0),(169097,4698,'pl','Zmienianie kolejnoÅ›ci otwarte',0),(169098,4698,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ñ€ÐµÐ´Ð° Ð½Ð° Ð¾Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ',0),(169099,4698,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Ú¾Ù„ÛŒ ØªØ±ØªÛŒØ¨',0),(169100,4698,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸Ñ… Ð½Ð°Ð»Ð¾Ð³Ð°',0),(169101,4698,'vi','Thay Ä‘á»•i ÄÆ¡n Äáº·t hÃ ng má»Ÿ',0),(169102,4698,'af','Verander Oop Bestelling',0),(169103,4698,'ro','Schimbare comandÄƒ deschis',0),(169104,4698,'et','Muuda avatud tellimust',0),(169105,4698,'si','Spremembo nalog',0),(169106,4698,'ba','Ubah urutan terbuka',0),(169107,4698,'nl','Open wijzigingsopdracht',0),(169108,4698,'fi','Muuta avoin tilaus',0),(169109,4698,'no','Ã…pne endringsordre',0),(169110,4698,'da','Ã†ndring Ã¥bne ordre',0),(169111,4698,'ko','ì˜¤í”ˆ ìˆœì„œ ë³€ê²½',0),(169112,4698,'he','×©×™× ×•×™ ×”×–×ž× ×” ×¤×ª×•×—×”',0),(169113,4698,'el','Î‘Î»Î»Î±Î³Î® Î¬Î½Î¿Î¹Î³Î¼Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(169114,4698,'zh','æ”¹å˜å¼€æ”¾è®¢å•\r\n',0),(169115,4698,'sv','Ã„ndra Ã¶ppen Order',0),(169116,4698,'it','Modifica ordine aperto',0),(169117,4698,'tl','',0),(169118,4698,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(169119,4698,'hi','à¤¬à¤¦à¤²à¥‡à¤‚ à¤–à¥à¤²à¥‡ à¤•à¥à¤°à¤®',0),(169120,4698,'ms','Perintah terbuka perubahan',0),(169121,4698,'ar','ØªØºÙŠÙŠØ± ØªØ±ØªÙŠØ¨ Ù…ÙØªÙˆØ­Ø©',0),(169122,4698,'fr','Modifier l\'ordre ouvert',0),(169123,4698,'jp','è¦‹å‡ºè?·æ³¨æ–‡ã?®å¤‰æ›´',0),(169124,4698,'pt','Alterar a ordem aberta',0),(169125,4698,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ð¹ Ð—Ð°ÐºÐ°Ð·',0),(169126,4698,'es','Cambiar Pedido Abierto',0),(169127,4698,'de','Offene Reihenfolge Ã¤ndern',0),(169128,4698,'en','Change Open Order',0),(169129,4699,'is','',0),(169130,4699,'dr',' Ø­Ø±ÙˆÙ Ø§ÙˆÙ„',0),(169131,4699,'pr',' Ø­Ø±ÙˆÙ Ø§ÙˆÙ„',0),(169132,4699,'tr','BaÅŸ harfleri',0),(169133,4699,'pl','InicjaÅ‚y',0),(169134,4699,'bg','Ð˜Ð½Ð¸Ñ†Ð¸Ð°Ð»Ð¸',0),(169135,4699,'ur','Ù…Ø®ØªØµØ± Ø¯Ø³ØªØ®Ø·',0),(169136,4699,'sr','Ð˜Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð»Ð¸',0),(169137,4699,'vi','Chá»¯ kÃ½',0),(169138,4699,'af','Voorletters',0),(169139,4699,'ro','IniÅ£ialele',0),(169140,4699,'et','Initsiaalid',0),(169141,4699,'si','ZaÄetnice',0),(169142,4699,'ba','Inisial',0),(169143,4699,'nl','Initialen',0),(169144,4699,'fi','Nimikirjaimet',0),(169145,4699,'no','Initialer',0),(169146,4699,'da','Initialer',0),(169147,4699,'ko','ì´ë‹ˆì…œ',0),(169148,4699,'he','×¨××©×™ ×”×ª×™×‘×•×ª',0),(169149,4699,'el','Î¤Î± Î±ÏÏ‡Î¹ÎºÎ¬',0),(169150,4699,'zh','åˆå§‹\r\n',0),(169151,4699,'sv','Initialer',0),(169152,4699,'it','Iniziali',0),(169153,4699,'tl','',0),(169154,4699,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3649;&#3619;&#3585;',0),(169155,4699,'hi','à¤†à¤¦à¥à¤¯à¤•à¥à¤·à¤°',0),(169156,4699,'ms','Singkatan',0),(169157,4699,'ar','Ø§Ù„Ø£Ø­Ø±Ù Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(169158,4699,'fr','Initiales',0),(169159,4699,'jp','ã‚¤ãƒ‹ã‚·ãƒ£ãƒ«',0),(169160,4699,'pt','Iniciais',0),(169161,4699,'ru','Ð˜Ð½Ð¸Ñ†Ð¸Ð°Ð»Ñ‹',0),(169162,4699,'es','Iniciales',0),(169163,4699,'de','Initialen',0),(169164,4699,'en','Initials',0),(169165,4700,'is','',0),(169166,4700,'dr','Ø¨Ø§ÙŠØ¯ Ù†Ø®Ø³ØªÙŠÙ†â€Œ Ø­Ø±ÙˆÙâ€Œ Ù†Ø§Ù…â€Œ Ùˆ Ù†Ø§Ù…â€Œ Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠâ€Œ Ùˆ Ø¯Ù„ÙŠÙ„ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(169167,4700,'pr','Ø¨Ø§ÙŠØ¯ Ù†Ø®Ø³ØªÙŠÙ†â€Œ Ø­Ø±ÙˆÙâ€Œ Ù†Ø§Ù…â€Œ Ùˆ Ù†Ø§Ù…â€Œ Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠâ€Œ Ùˆ Ø¯Ù„ÙŠÙ„ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(169168,4700,'tr','BaÅŸ harfleri ve nedeni girmeniz gerekir',0),(169169,4700,'pl','NaleÅ¼y wprowadziÄ‡ inicjaÅ‚y i powÃ³d',0),(169170,4700,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ð»Ð¸Ñ‚Ðµ Ð¸ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(169171,4700,'ur','ÙˆØ¬Û Ø§ÙˆØ± Ù…Ø®ØªØµØ± Ø¯Ø³ØªØ®Ø· Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(169172,4700,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð»Ð¸ Ð¸ Ñ€Ð°Ð·Ð»Ð¾Ð³',0),(169173,4700,'vi','Pháº£i nháº­p chá»¯ kÃ½ & nguyÃªn nhÃ¢n',0),(169174,4700,'af','Moet Voorletters en Rede Invoer',0),(169175,4700,'ro','Trebuie sÄƒ introduceÅ£i iniÅ£ialele ÅŸi motivul',0),(169176,4700,'et','Peate sisestama initsiaalid ja pÃµhjus',0),(169177,4700,'si','Vnesite zaÄetnici in razlog',0),(169178,4700,'ba','Harus memasukkan inisial dan alasan',0),(169179,4700,'nl','Initialen en reden moet invoeren',0),(169180,4700,'fi','Kirjoita nimikirjaimet ja syy',0),(169181,4700,'no','MÃ¥ angi initialer og grunn',0),(169182,4700,'da','Skal indtaste initialer og grund',0),(169183,4700,'ko','ì´ë‹ˆì…œ ë° ì´ìœ ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(169184,4700,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ××ª ×¨××©×™ ×”×ª×™×‘×•×ª ×•×”×¡×™×‘×”',0),(169185,4700,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î± Î±ÏÏ‡Î¹ÎºÎ¬ ÎºÎ±Î¹ Î»ÏŒÎ³Î¿Ï‚',0),(169186,4700,'zh','å¿…é¡»è¾“å…¥åˆå§‹å€¼å’ŒåŽŸå› \r\n',0),(169187,4700,'sv','MÃ¥ste ange initialer och anledning',0),(169188,4700,'it','Necessario immettere le iniziali e la ragione',0),(169189,4700,'tl','',0),(169190,4700,'th','&#3605;&#3657;&#3629;&#3591;&#3611;&#3657;&#3629;&#3609;&#3629;&#3633;&#3585;&#3625;&#3619;&#3649;&#3619;&#3585;&#3586;&#3629;&#3591;&#3594;&#3639;&#3656;&#3629;&#3649;&#3621;&#3632;&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;',0),(169191,4700,'hi','à¤ªà¥à¤°à¤¥à¤®à¤¾à¤•à¥à¤·à¤° à¤”à¤° à¤•à¤¾à¤°à¤£ à¤¦à¥‡à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(169192,4700,'ms','Mesti masukkan nama dan sebab',0),(169193,4700,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø£Ø­Ø±Ù Ø§Ù„Ø£ÙˆÙ„Ù‰ ÙˆØ§Ù„Ø³Ø¨Ø¨',0),(169194,4700,'fr','Devez entrer initiales et la raison',0),(169195,4700,'jp','ã‚¤ãƒ‹ã‚·ãƒ£ãƒ«ã?¨ç?†ç”±ã‚’å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(169196,4700,'pt','Deve digitar as iniciais e a razÃ£o',0),(169197,4700,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ð»Ñ‹ Ð¸ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ñ‹',0),(169198,4700,'es','Debe Introducir Iniciales y una RazÃ³n',0),(169199,4700,'de','Initialen und Grund geben',0),(169200,4700,'en','Must Enter Initials and Reason',0),(169201,4701,'is','',0),(169202,4701,'dr','Ø¨Ø§ÙŠØ¯ Ø¯Ù„ÙŠÙ„ ÙˆØ§Ø±Ø¯ Ø´ÙˆØ¯ ',0),(169203,4701,'pr','Ø¨Ø§ÙŠØ¯ Ø¯Ù„ÙŠÙ„ ÙˆØ§Ø±Ø¯ Ø´ÙˆØ¯ ',0),(169204,4701,'tr','Nedeni girmeniz gerekir',0),(169205,4701,'pl','Musisz podaÄ‡ powÃ³d',0),(169206,4701,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(169207,4701,'ur','ÙˆØ¬Û Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(169208,4701,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ñ€Ð°Ð·Ð»Ð¾Ð³',0),(169209,4701,'vi','Pháº£i nháº­p nguyÃªn nhÃ¢n',0),(169210,4701,'af','Moet Rede Invoer',0),(169211,4701,'ro','Trebuie sÄƒ introduceÅ£i motiv',0),(169212,4701,'et','Peate sisestama pÃµhjus',0),(169213,4701,'si','Vnesite razlog',0),(169214,4701,'ba','Harus memasukkan alasan',0),(169215,4701,'nl','Reden moet invoeren',0),(169216,4701,'fi','Kirjoita syy',0),(169217,4701,'no','MÃ¥ angi Ã¥rsak',0),(169218,4701,'da','Skal angive Ã¥rsag',0),(169219,4701,'ko','ì´ìœ ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(169220,4701,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×¡×™×‘×”',0),(169221,4701,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ Î»ÏŒÎ³Î¿',0),(169222,4701,'zh','å¿…é¡»è¾“å…¥åŽŸå› \r\n',0),(169223,4701,'sv','MÃ¥ste ange orsak',0),(169224,4701,'it','Inserisci motivo',0),(169225,4701,'tl','',0),(169226,4701,'th','&#3605;&#3657;&#3629;&#3591;&#3611;&#3657;&#3629;&#3609;&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;',0),(169227,4701,'hi','à¤•à¤¾à¤°à¤£ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(169228,4701,'ms','Mesti masukkan sebab',0),(169229,4701,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø³Ø¨Ø¨',0),(169230,4701,'fr','Devez entrer la raison',0),(169231,4701,'jp','ç?†ç”±ã‚’å…¥åŠ›ã?—ã?¦ä¸‹ã?•ã?„',0),(169232,4701,'pt','Deve inserir a razÃ£o',0),(169233,4701,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ñ‹',0),(169234,4701,'es','Debe Introducir una RazÃ³n',0),(169235,4701,'de','Grund muss eingeben werden.',0),(169236,4701,'en','Must Enter Reason',0),(169237,4702,'is','',0),(169238,4702,'dr','Ø³ÙØ§Ø±Ø´ Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ù„ØºÙˆ Ø´Ø¯ ',0),(169239,4702,'pr','Ø³ÙØ§Ø±Ø´ Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ù„ØºÙˆ Ø´Ø¯ ',0),(169240,4702,'tr','SipariÅŸi iptal',0),(169241,4702,'pl','ZamÃ³wienie anulowane',0),(169242,4702,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(169243,4702,'ur','Ø¢Ø±ÚˆØ± Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(169244,4702,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½',0),(169245,4702,'vi','ÄÆ¡n hÃ ng há»§y',0),(169246,4702,'af','Bestelling Gekanselleer',0),(169247,4702,'ro','Ordin anulat',0),(169248,4702,'et','Tellimus tÃ¼histatakse',0),(169249,4702,'si','NaroÄilo preklicano',0),(169250,4702,'ba','Pesanan yang dibatalkan',0),(169251,4702,'nl','Bestelling geannuleerd',0),(169252,4702,'fi','Tilaus peruttu',0),(169253,4702,'no','Bestill avbestilling',0),(169254,4702,'da','Ordre annulleret',0),(169255,4702,'ko','ì£¼ë¬¸ ì·¨ì†Œ',0),(169256,4702,'he','×”×–×ž× ×” ×‘×•×˜×œ×” ×‘×”×¦×œ×—×”',0),(169257,4702,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ',0),(169258,4702,'zh','æŽ’åºå–æ¶ˆ\r\n',0),(169259,4702,'sv','Order annulleras',0),(169260,4702,'it','Ordine annullato',0),(169261,4702,'tl','',0),(169262,4702,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(169263,4702,'hi','à¤‘à¤°à¥à¤¡à¤° à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(169264,4702,'ms','Perintah yang dibatalkan',0),(169265,4702,'ar','Ø£Ù…Ø± Ø¥Ù„ØºØ§Ø¡',0),(169266,4702,'fr','Ordre annulÃ©',0),(169267,4702,'jp','æ³¨æ–‡ã?Œã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(169268,4702,'pt','Ordem cancelada',0),(169269,4702,'ru','Ð—Ð°ÐºÐ°Ð· ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½',0),(169270,4702,'es','Orden Cancelado',0),(169271,4702,'de','Bestellung storniert',0),(169272,4702,'en','Order Cancelled',0),(169273,4703,'is','',0),(169274,4703,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ø´Ø¯ ',0),(169275,4703,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ø´Ø¯ ',0),(169276,4703,'tr','AlÄ±nan sipariÅŸ bilgileri',0),(169277,4703,'pl','Informacje o zamÃ³wieniach, Å¹rÃ³dÅ‚o:',0),(169278,4703,'bg','Ð˜Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð°Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(169279,4703,'ur','ØªØ±ØªÛŒØ¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø§Ø² Ú¯ÛŒØ±',0),(169280,4703,'sr','ÐŸÑ€ÐµÑƒÐ·ÐµÑ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´Ñƒ',0),(169281,4703,'vi','Truy váº¥n thÃ´ng tin Ä‘Æ¡n hÃ ng',0),(169282,4703,'af','Bestelling Informasie Herwin',0),(169283,4703,'ro','InformaÅ£ii despre comenzi, Adus de',0),(169284,4703,'et','Tellimuse teabele',0),(169285,4703,'si','Pridobljene informacije za naroÄilo',0),(169286,4703,'ba','Informasi permintaan yang diperoleh',0),(169287,4703,'nl','Bestelgegevens ontvangen',0),(169288,4703,'fi','Tilauksen tiedot Haettu',0),(169289,4703,'no','Informasjon Hentet',0),(169290,4703,'da','Bestil Information hentes',0),(169291,4703,'ko','ì£¼ë¬¸ ì •ë³´ ê²€ìƒ‰',0),(169292,4703,'he','×ž×™×“×¢ ××•×“×•×ª ×”×–×ž× ×•×ª ×œ××—×–×¨',0),(169293,4703,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï€Î¿Ï… Î±Î½Î±ÎºÏ„Î®Î¸Î·ÎºÎ±Î½',0),(169294,4703,'zh','è®¢è´­ä¿¡æ¯æ£€ç´¢\r\n',0),(169295,4703,'sv','BestÃ¤llningsinformation HÃ¤mtad',0),(169296,4703,'it','Informazioni di ordine Estratto',0),(169297,4703,'tl','',0),(169298,4703,'th','&#3585;&#3634;&#3619;&#3648;&#3629;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3588;&#3639;&#3609;&#3617;&#3634;',0),(169299,4703,'hi','à¤†à¤¦à¥‡à¤¶ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(169300,4703,'ms','Maklumat pesanan yang diambil',0),(169301,4703,'ar','Ø¬Ù„Ø¨Øª Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø·Ù„Ø¨ÙŠÙ‘Ø©',0),(169302,4703,'fr','Informations de commande rÃ©cupÃ©rÃ©es',0),(169303,4703,'jp','æ¤œç´¢ã?•ã‚Œã?Ÿæ³¨æ–‡æƒ…å ±',0),(169304,4703,'pt','InformaÃ§Ãµes de ordem obtidas',0),(169305,4703,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð—Ð°ÐºÐ°Ð·Ð° Ð’Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(169306,4703,'es','InformaciÃ³n de Pedido Recogido',0),(169307,4703,'de','Bestellung Informationen abgerufen',0),(169308,4703,'en','Order Information Retrieved',0),(169309,4704,'is','',0),(169310,4704,'dr','Ø³ÙØ§Ø±Ø´ ÙØ¹Ø§Ù„ Ù†ÙŠØ³Øª',0),(169311,4704,'pr','Ø³ÙØ§Ø±Ø´ ÙØ¹Ø§Ù„ Ù†ÙŠØ³Øª',0),(169312,4704,'tr','Etkin sipariÅŸ deÄŸil',0),(169313,4704,'pl','Zeby nie aktywne',0),(169314,4704,'bg','ÐÐµ Ð¿Ð¾Ñ€ÑŠÑ‡Ð°Ñ‚Ðµ Ð°ÐºÑ‚Ð¸Ð²ÐµÐ½',0),(169315,4704,'ur','ØªØ±ØªÛŒØ¨ Ø²ÛŒØ± Ø¹Ù…Ù„ Ù†ÛÛŒÚº',0),(169316,4704,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð½Ð¸Ñ˜Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð°Ð½',0),(169317,4704,'vi','ÄÆ¡n hÃ ng khÃ´ng kÃ­ch hoáº¡t',0),(169318,4704,'af','Bestel Nie Aktief',0),(169319,4704,'ro','Nu comanda activÄƒ',0),(169320,4704,'et','Tellida pole aktiivne',0),(169321,4704,'si','Da ni aktivna',0),(169322,4704,'ba','Memesan tidak aktif',0),(169323,4704,'nl','Bestel niet actief',0),(169324,4704,'fi','Tilaa ei ole aktiivinen',0),(169325,4704,'no','Bestille ikke aktiv',0),(169326,4704,'da','Bestil ikke aktiv',0),(169327,4704,'ko','í™œì„±í™” ì£¼ë¬¸',0),(169328,4704,'he','×”×”×–×ž× ×” ×œ× ×¤×¢×™×œ×”',0),(169329,4704,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î´ÎµÎ½ ÎµÎ½ÎµÏÎ³ÏŒ',0),(169330,4704,'zh','è®¢è´­ä¸æ´»è·ƒ\r\n',0),(169331,4704,'sv','BestÃ¤ll inte aktiv',0),(169332,4704,'it','Ordinare non attivo',0),(169333,4704,'tl','',0),(169334,4704,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3617;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(169335,4704,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤†à¤¦à¥‡à¤¶ à¤¨à¤¹à¥€à¤‚',0),(169336,4704,'ms','Perintah tidak aktif',0),(169337,4704,'ar','ØªØ±ØªÙŠØ¨ ØºÙŠØ± Ù†Ø´Ø·',0),(169338,4704,'fr','Ne commandez pas Active',0),(169339,4704,'jp','æœ‰åŠ¹ã?§ã?¯ã?ªã?„æ³¨æ–‡',0),(169340,4704,'pt','Ordem nÃ£o ativo',0),(169341,4704,'ru','Ð—Ð°ÐºÐ°Ð· ÐÐµ ÐÐºÑ‚Ð¸Ð²ÐµÐ½',0),(169342,4704,'es','Orden No es Activo',0),(169343,4704,'de','Bestellen Sie nicht aktiv',0),(169344,4704,'en','Order Not Active',0),(169345,4705,'is','',0),(169346,4705,'dr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… Ù‚Ø±Ø§Ø± Ú¯Ø±ÙØª',0),(169347,4705,'pr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… Ù‚Ø±Ø§Ø± Ú¯Ø±ÙØª',0),(169348,4705,'tr','Beklemeye sipariÅŸ',0),(169349,4705,'pl','ZamÃ³wienie na luku',0),(169350,4705,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(169351,4705,'ur','ØªØ±ØªÛŒØ¨ ÛÙˆÙ„Úˆ Ù¾Ø± Ø±Ú©Ú¾Ø§',0),(169352,4705,'sr','ÐÐ°Ð»Ð¾Ð³ ÑÑ‚Ð°Ð²Ñ™ÐµÐ½ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÐµ',0),(169353,4705,'vi','ÄÆ¡n hÃ ng táº¡m ngÆ°ng',0),(169354,4705,'af','Bestelling geplaas op hou',0),(169355,4705,'ro','Comenzi pe \"hold\"',0),(169356,4705,'et','Tellimuse ootele panna',0),(169357,4705,'si','Nalog, ki se dajo na Äakanje',0),(169358,4705,'ba','Pesanan ditempatkan di penahanan',0),(169359,4705,'nl','Bestelling op Hold',0),(169360,4705,'fi','JÃ¤rjestyksen pidossa',0),(169361,4705,'no','Ordre plassert pÃ¥ vent',0),(169362,4705,'da','Ordre, placeret pÃ¥ Hold',0),(169363,4705,'ko','ì£¼ë¬¸ ë³´ë¥˜ì—',0),(169364,4705,'he','×¡×“×¨ ×‘×”×ž×ª× ×”',0),(169365,4705,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÎµ Î±Î½Î±Î¼Î¿Î½Î®',0),(169366,4705,'zh','è®¢å•è¢«æç½®\r\n',0),(169367,4705,'sv','BestÃ¤llningar pÃ¥ hÃ¥ll',0),(169368,4705,'it','Ordine piazzato in attesa',0),(169369,4705,'tl','',0),(169370,4705,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3623;&#3634;&#3591;&#3652;&#3623;&#3657;&#3651;&#3609;&#3617;&#3639;&#3629;&#3649;&#3621;&#3657;&#3623;',0),(169371,4705,'hi','à¤¹à¥‹à¤²à¥à¤¡ à¤ªà¤° à¤°à¤–à¤¾ à¤•à¥à¤°à¤®',0),(169372,4705,'ms','Perintah dipegang',0),(169373,4705,'ar','Ø£Ù…Ø± Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(169374,4705,'fr','Commande passÃ©e en attente',0),(169375,4705,'jp','ä¿?ç•™ä¸­ã?«ã?ªã?£ã?¦ã?„ã‚‹æ³¨æ–‡',0),(169376,4705,'pt','Ordem colocada em espera',0),(169377,4705,'ru','Ð—Ð°ÐºÐ°Ð· ÐŸÐ¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½ Ð² ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ðµ',0),(169378,4705,'es','Orden Puesto en Espera',0),(169379,4705,'de','Bestellung auf Eis',0),(169380,4705,'en','Order Placed on Hold',0),(169381,4706,'is','',0),(169382,4706,'dr','Ø³ÙØ§Ø±Ø´ Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø² Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(169383,4706,'pr','Ø³ÙØ§Ø±Ø´ Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø² Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(169384,4706,'tr','SipariÅŸ Ã¼zerine beklemeden kaldÄ±rÄ±ldÄ±',0),(169385,4706,'pl','Aby usunÄ…Ä‡ na luku',0),(169386,4706,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°, Ð¾Ñ‚ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸ Ð¾Ñ‚ Ð¿Ð¾-Ð½Ð¸ÑÐºÐ°',0),(169387,4706,'ur','Ø¢Ø±ÚˆØ± Ù¾Ø± ÛÙˆÙ„Úˆ Ø³Û’ ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(169388,4706,'sr','Ð ÐµÐ´ ÑƒÐºÐ»Ð¾ÑšÐµÐ½ Ð¸Ð· Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(169389,4706,'vi','RÃºt Ä‘Æ¡n hÃ ng ra khá»i táº¡m ngÆ°ng',0),(169390,4706,'af','Volgorde van op-hou verwyder',0),(169391,4706,'ro','Ordinul scos din pe-Hold',0),(169392,4706,'et','Tellimuse kohta ootelt eemaldamine',0),(169393,4706,'si','Nalog, ki se odstrani iz na Äakanju',0),(169394,4706,'ba','Order yang dihapus dari pada-terus',0),(169395,4706,'nl','Volgorde verwijderd van On-Hold',0),(169396,4706,'fi','Jotta poistaa pidossa',0),(169397,4706,'no','Bestill fjernet fra pÃ¥ Hold',0),(169398,4706,'da','Ordre fjernet fra pÃ¥ Hold',0),(169399,4706,'ko','ì£¼ë¬¸ ëŒ€ê¸°ì—ì„œ ì œê±°',0),(169400,4706,'he','×¡×“×¨ ×ž×•×¡×¨ ×¢×œ-×œ×”×—×–×™×§',0),(169401,4706,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯ Î±Ï€ÏŒ Ï„Î·Î½ On-Hold',0),(169402,4706,'zh','è®¢å•ä»ŽçŽ°æœ‰ä¸­åˆ é™¤\r\n',0),(169403,4706,'sv','Ordning ifrÃ¥n spÃ¤rrade',0),(169404,4706,'it','Ordine rimosso da in attesa',0),(169405,4706,'tl','',0),(169406,4706,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3618;&#3657;&#3634;&#3618;&#3592;&#3634;&#3585;&#3651;&#3609;&#3617;&#3639;&#3629;',0),(169407,4706,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤¹à¥‹à¤²à¥à¤¡ à¤¸à¥‡ à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(169408,4706,'ms','Perintah yang dikeluarkan dari pada mengadakan',0),(169409,4706,'ar','Ø£Ù…Ø± Ø¥Ø²Ø§Ù„ØªÙ‡Ø§ Ù…Ù† Ø¹Ù„Ù‰ Ø¹Ù‚Ø¯',0),(169410,4706,'fr','Ordre retirÃ© en attente',0),(169411,4706,'jp','ä¿?ç•™ä¸­ã?‹ã‚‰ã?¯ã?šã?•ã‚Œã?Ÿæ³¨æ–‡',0),(169412,4706,'pt','Ordem retirado em espera',0),(169413,4706,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ ÐŸÐµÑ€ÐµÐ½ÐµÑÐµÐ½Ð½Ñ‹Ðµ Ð¸Ð· ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ñ',0),(169414,4706,'es','Orden Eliminado de En Espera',0),(169415,4706,'de','Bestellung von On-Hold entfernt',0),(169416,4706,'en','Order Removed from On-Hold',0),(169417,4707,'is','',0),(169418,4707,'dr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(169419,4707,'pr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(169420,4707,'tr','AyrÄ± tutma sipariÅŸ',0),(169421,4707,'pl','Miejsce na zamÃ³wienie posiadajÄ…',0),(169422,4707,'bg','ÐœÑÑÑ‚Ð¾ Ð½Ð° Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(169423,4707,'ur','Ù¾Ø± Ù¾Ú©Ú‘ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ Ø¬Ú¯Û',0),(169424,4707,'sr','Ð¡Ñ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(169425,4707,'vi','Táº¡m ngÆ°ng Ä‘Æ¡n hÃ ng',0),(169426,4707,'af','Plaas op hou orde',0),(169427,4707,'ro','Loc pe magaziilor',0),(169428,4707,'et','Asetage jÃ¤rjekorrast',0),(169429,4707,'si','Postavite na Äakanju nalog',0),(169430,4707,'ba','Tempatkan pesanan terus',0),(169431,4707,'nl','Plaats op Hold volgorde',0),(169432,4707,'fi','Aseta lastausjÃ¤rjestyksen',0),(169433,4707,'no','Plasser pÃ¥ Hold orden',0),(169434,4707,'da','Sted pÃ¥ lastrumsrÃ¦kkefÃ¸lge',0),(169435,4707,'ko','ëŒ€ê¸° ìˆœì„œì—',0),(169436,4707,'he','×ž× ×™×—×™× ×¢×œ ×”×¡×“×¨ ×”×—×¡×™×ž×”',0),(169437,4707,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏ„Î®ÏƒÏ„Îµ ÏƒÏ„Î·Î½ ÏƒÎµÎ¹ÏÎ¬ Ï„Ï‰Î½ ÎºÏ…Ï„ÏŽÎ½',0),(169438,4707,'zh','å®‰æŽ’çŽ°æœ‰è®¢å•\r\n',0),(169439,4707,'sv','Placera pÃ¥ hÃ¥ll ordning',0),(169440,4707,'it','Posizionare su ordine di Hold',0),(169441,4707,'tl','',0),(169442,4707,'th','&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3617;&#3639;&#3629;&#3621;&#3591;',0),(169443,4707,'hi','à¤¹à¥‹à¤²à¥à¤¡ à¤ªà¤° à¤†à¤¦à¥‡à¤¶ à¤œà¤—à¤¹',0),(169444,4707,'ms','Letakkan di atas perintah penahanan',0),(169445,4707,'ar','Ø¶Ø¹ Ø¹Ù„Ù‰ ØªØ±ØªÙŠØ¨ Ø¹Ù‚Ø¯',0),(169446,4707,'fr','Placer sur ordre de cale',0),(169447,4707,'jp','ä¿?ç•™ä¸­æ³¨æ–‡ã?«ã?™ã‚‹',0),(169448,4707,'pt','Coloque na ordem de espera',0),(169449,4707,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·',0),(169450,4707,'es','Hacer Orden Reservado',0),(169451,4707,'de','Setzen Sie auf Hold-Bestellung',0),(169452,4707,'en','Place On Hold Order',0),(169453,4708,'is','',0),(169454,4708,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ØªØ¨Ø¯ÙŠÙ„ Ø´Ø¯ ',0),(169455,4708,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ØªØ¨Ø¯ÙŠÙ„ Ø´Ø¯ ',0),(169456,4708,'tr','SipariÅŸe dÃ¶nÃ¼ÅŸtÃ¼rÃ¼len teklif',0),(169457,4708,'pl','Cytat przerobiony na zamÃ³wienie',0),(169458,4708,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ð¸Ñ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(169459,4708,'ur','Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ØªØ¨Ø¯ÛŒÙ„ Ø§Ù‚ØªØ¨Ø§Ø³',0),(169460,4708,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ð²Ð°Ð½Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(169461,4708,'vi','BÃ¡o giÃ¡ chuyá»ƒn sang Ä‘Æ¡n hÃ ng',0),(169462,4708,'af','Kwotasie \"Converted\" na Bestelling',0),(169463,4708,'ro','Cita convertit la comanda',0),(169464,4708,'et','Tsitaat teisendatud tellida',0),(169465,4708,'si','Citiram pretvorjene po naroÄilu',0),(169466,4708,'ba','Mengutip dikonversi untuk Order',0),(169467,4708,'nl','Citeer geconverteerde om te bestellen',0),(169468,4708,'fi','Tarjous muunnetaan tilauksesta',0),(169469,4708,'no','Sitere omvendt rekkefÃ¸lge',0),(169470,4708,'da','Citere konverterede til ordre',0),(169471,4708,'ko','ì£¼ë¬¸ ë³€í™˜ ê²¬ì ',0),(169472,4708,'he','×”×¦×¢×ª ×ž×—×™×¨ ×”×ž×¨×” ×œ×¤×™ ×”×–×ž× ×”',0),(169473,4708,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Î¼ÎµÏ„Î±Ï„ÏÎ±Ï€ÎµÎ¯ ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î·',0),(169474,4708,'zh','æŠ¥ä»·è½¬æ¢ä¸ºè®¢å•\r\n',0),(169475,4708,'sv','Citera omvandlas till Order',0),(169476,4708,'it','Citare convertito all\'ordine',0),(169477,4708,'tl','',0),(169478,4708,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3652;&#3611;&#3618;&#3633;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(169479,4708,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤•à¥€ à¤—à¤ˆ à¤¬à¥‹à¤²à¥€',0),(169480,4708,'ms','Nyatakan ditukar kepada perintah',0),(169481,4708,'ar','Ø­ÙˆÙ‘Ù„ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ø¥Ù„Ù‰ Ø·Ù„Ø¨ÙŠØ©',0),(169482,4708,'fr','Cite converti Ã  l\'ordre',0),(169483,4708,'jp','æ³¨æ–‡ã?«å¤‰æ›´ã?•ã‚Œã?Ÿè¦‹ç©?ã‚Š',0),(169484,4708,'pt','Citar convertido Ã  ordem',0),(169485,4708,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€ÑƒÑŽ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð½Ð¾Ðµ Ðº Ð¿Ð¾Ñ€ÑÐ´ÐºÑƒ',0),(169486,4708,'es','CotizaciÃ³n Convertida a un Pedido',0),(169487,4708,'de','Zitiere konvertierten bestellen',0),(169488,4708,'en','Quote Converted to Order',0),(169489,4709,'is','',0),(169490,4709,'dr','Ø¯Ù„ÙŠÙ„  Ø¨Ø±Ø§ÙŠ Ø­Ø°Ù ',0),(169491,4709,'pr','Ø¯Ù„ÙŠÙ„  Ø¨Ø±Ø§ÙŠ Ø­Ø°Ù ',0),(169492,4709,'tr','Neden silmek iÃ§in',0),(169493,4709,'pl','Powodem usuwania',0),(169494,4709,'bg','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(169495,4709,'ur','Ø­Ø°Ù Ú©Ø±Ù†Û’ Ú©ÛŒ ÙˆØ¬Û',0),(169496,4709,'sr','Ð Ð°Ð·Ð»Ð¾Ð³ Ð·Ð° Ð±Ñ€Ð¸ÑÐ°ÑšÐµ',0),(169497,4709,'vi','NguyÃªn nhÃ¢n xÃ³a',0),(169498,4709,'af','Rede vir Skraping',0),(169499,4709,'ro','Motivul pentru ÅŸtergerea',0),(169500,4709,'et','PÃµhjus kustutamine',0),(169501,4709,'si','Razlog za izbris',0),(169502,4709,'ba','Alasan untuk menghapus',0),(169503,4709,'nl','Reden voor het verwijderen van',0),(169504,4709,'fi','Syy poistaa',0),(169505,4709,'no','Grunn for sletting',0),(169506,4709,'da','Grunden til at slette',0),(169507,4709,'ko','ì‚­ì œ ì‚¬ìœ ',0),(169508,4709,'he','×¡×™×‘×” ×œ×ž×—×™×§×”',0),(169509,4709,'el','Î›ÏŒÎ³Î¿ Î³Î¹Î± Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(169510,4709,'zh','åˆ é™¤çš„åŽŸå› \r\n',0),(169511,4709,'sv','Anledning fÃ¶r att ta bort',0),(169512,4709,'it','Motivo per l\'eliminazione',0),(169513,4709,'tl','',0),(169514,4709,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;',0),(169515,4709,'hi','à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾à¤°à¤£',0),(169516,4709,'ms','Sebab menghapuskan',0),(169517,4709,'ar','Ø§Ù„Ø³Ø¨Ø¨ Ù„Ø­Ø°Ù',0),(169518,4709,'fr','Raison de la suppression',0),(169519,4709,'jp','æ¶ˆåŽ»ç?†ç”±',0),(169520,4709,'pt','RazÃ£o para a exclusÃ£o de',0),(169521,4709,'ru','ÐžÑÐ½Ð¾Ð²Ð°Ð½Ð¸Ñ Ð´Ð»Ñ Ð¸ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ',0),(169522,4709,'es','RazÃ³n para Eliminar',0),(169523,4709,'de','Grund fÃ¼r das LÃ¶schen',0),(169524,4709,'en','Reason for Deleting',0),(169525,4710,'is','',0),(169526,4710,'dr','Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(169527,4710,'pr','Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(169528,4710,'tr','Beklemeye yerleÅŸtirmek iÃ§in bir neden',0),(169529,4710,'pl','PowÃ³d wprowadzenia zawieszone',0),(169530,4710,'bg','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð°Ñ‚Ð° Ð·Ð° Ð¿ÑƒÑÐºÐ°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(169531,4710,'ur','ÙˆØ¬Û ÛÙˆÙ„Úˆ Ù¾Ø± Ø±Ú©Ú¾ Ø±ÛØ§ ÛÛ’ Û”',0),(169532,4710,'sr','Ð Ð°Ð·Ð»Ð¾Ð³ Ð·Ð° ÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÐµ',0),(169533,4710,'vi','NguyÃªn nhÃ¢n táº¡m ngÆ°ng',0),(169534,4710,'af','Rede vir plasing op hou',0),(169535,4710,'ro','Motivul pentru introducerea pe \"hold\"',0),(169536,4710,'et','Alust pannes ootele',0),(169537,4710,'si','Razlog za dajanje na Äakanju',0),(169538,4710,'ba','Alasan untuk menempatkan ditahan',0),(169539,4710,'nl','Reden voor het plaatsen van wachtstand',0),(169540,4710,'fi','SyynÃ¤ asettaa pitoon',0),(169541,4710,'no','Grunnen til Ã¥ plassere pÃ¥ vent',0),(169542,4710,'da','Grunden til at placere pÃ¥ Hold',0),(169543,4710,'ko','ë³´ë¥˜ì— ëŒ€ í•œ ì´ìœ ',0),(169544,4710,'he','×”×¡×™×‘×” ×œ×”× ×—×” ×‘×”×ž×ª× ×”',0),(169545,4710,'el','Î›ÏŒÎ³Î¿ Î³Î¹Î± Ï„Î· Î´Î¹Î¬Î¸ÎµÏƒÎ· ÏƒÎµ Î±Î½Î±Î¼Î¿Î½Î®',0),(169546,4710,'zh','æç½®çš„åŽŸå› \r\n',0),(169547,4710,'sv','Anledningen till att placera pÃ¥ is',0),(169548,4710,'it','Motivo per mettere in attesa',0),(169549,4710,'tl','',0),(169550,4710,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3651;&#3609;&#3585;&#3634;&#3619;&#3623;&#3634;&#3591;&#3586;&#3629;&#3591;&#3651;&#3609;&#3617;&#3639;&#3629;&#3621;&#3591;',0),(169551,4710,'hi','à¤¹à¥‹à¤²à¥à¤¡ à¤ªà¤° à¤°à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾à¤°à¤£',0),(169552,4710,'ms','Sebab untuk diletakkan di tahan',0),(169553,4710,'ar','Ø§Ù„Ø³Ø¨Ø¨ ÙÙŠ ØªØ¹Ù„ÙŠÙ‚',0),(169554,4710,'fr','Raison de mise en attente',0),(169555,4710,'jp','ä¿?ç•™ä¸­ã?«ã?ªã?£ã?¦ã?„ã‚‹ç?†ç”±',0),(169556,4710,'pt','RazÃ£o para colocar em espera',0),(169557,4710,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° Ð´Ð»Ñ ÐŸÐ¾ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð² ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ðµ',0),(169558,4710,'es','RazÃ³n para Poner en Espera',0),(169559,4710,'de','Grund fÃ¼r die Platzierung auf Eis',0),(169560,4710,'en','Reason for Placing on Hold',0),(169561,4711,'is','',0),(169562,4711,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ â€“Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… Ù‚Ø±Ø§Ø± Ù†Ø¯Ù‡ÙŠØ¯',0),(169563,4711,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ â€“Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… Ù‚Ø±Ø§Ø± Ù†Ø¯Ù‡ÙŠØ¯',0),(169564,4711,'tr','SeÃ§imi - don\'t yer bir dakika dÃ¶nÃ¼ÅŸ',0),(169565,4711,'pl','PowrÃ³t do wyboru - nie miejsce na Hold',0),(169566,4711,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ - Ð½Ðµ Ð¼ÑÑÑ‚Ð¾ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÐ¶Ð´Ð°Ð½Ðµ',0),(169567,4711,'ur','Ø§Ù†ØªØ®Ø§Ø¨ - Ù†ÛÛŒÚº Ø¬Ú¯Û Ù¾Ø± Ù…Ù†Ø¹Ù‚Ø¯ Ú©Ø±Ù†Û’ Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(169568,4711,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ñƒ ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ñƒ - Ð½Ðµ Ð¼ÐµÑÑ‚Ð¾ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(169569,4711,'vi','Trá»Ÿ láº¡i pháº§n lá»±a chá»n - Äá»«ng Ä‘á»ƒ vÃ o táº¡m ngÆ°ng',0),(169570,4711,'af','Keer terug na seleksie - nie plek op hou',0),(169571,4711,'ro','A reveni la selecÅ£ia - nu locul de aÅŸteptare',0),(169572,4711,'et','Naasta valik - ei ole koht ootel',0),(169573,4711,'si','Vrniti izbiro - ne mesto zadrÅ¾ano',0),(169574,4711,'ba','Kembali ke seleksi - jangan tempat pada mengadakan',0),(169575,4711,'nl','Terug naar selectie - niet plaats op van de greep',0),(169576,4711,'fi','Palaa - Ã„lÃ¤ paikka Estossa',0),(169577,4711,'no','GÃ¥ tilbake til valg - ikke sted pÃ¥ vent',0),(169578,4711,'da','Tilbage til valg - ikke plads pÃ¥ Hold',0),(169579,4711,'ko','ëŒì•„ê°€ê¸° ì„ íƒ-ì•ˆ ìž¥ì†Œì—ì„œ ê°œìµœ',0),(169580,4711,'he','×—×–×•×¨ ××œ ×”×‘×—×™×¨×” - ×œ× ×”×ž×§×•× ×‘×”×ž×ª× ×”',0),(169581,4711,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® - Î½Î± Î¼Î·Î½ Î¸Î­ÏƒÎ· ÏƒÎµ Î±Î½Î±Î¼Î¿Î½Î®',0),(169582,4711,'zh','è¿”å›žåˆ°é€‰é¡¹- ä¸è¦æ”¾åœ¨çŽ°æœ‰è¡¨\r\n',0),(169583,4711,'sv','Tillbaka till val - inte plats pÃ¥ hÃ¥ll',0),(169584,4711,'it','Tornare alla selezione - non fare posto in attesa',0),(169585,4711,'tl','',0),(169586,4711,'th','&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585; - &#3629;&#3618;&#3656;&#3634;&#3623;&#3634;&#3591;&#3610;&#3609;&#3617;&#3639;&#3629;',0),(169587,4711,'hi','à¤šà¤¯à¤¨ - Do NOT à¤œà¤—à¤¹ à¤ªà¤° à¤ªà¤•à¤¡à¤¼ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥Œà¤Ÿà¥‡à¤‚',0),(169588,4711,'ms','Kembali ke pilihan - tidak tempat di tahan',0),(169589,4711,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ù„ØªØ­Ø¯ÙŠØ¯-Ù„Ø§ Ù…ÙƒØ§Ù† \"ÙÙŠ Ø¹Ù‚Ø¯\"',0),(169590,4711,'fr','Retour Ã  la sÃ©lection - ne pas lieu en attente',0),(169591,4711,'jp','é?¸æŠžè‚¢ã?¸æˆ»ã‚‹ãƒ¼ä¿?ç•™ä¸­ã?«ã?—ã?ªã?„ã?§ä¸‹ã?•ã?„',0),(169592,4711,'pt','Regressar Ã  selecÃ§Ã£o - nÃ£o lugar On Hold',0),(169593,4711,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ð’Ñ‹Ð±Ð¾Ñ€Ñƒ - ÐÐ• ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ðµ',0),(169594,4711,'es','Regresar a la SelecciÃ³n - NO pone En Espera',0),(169595,4711,'de','ZurÃ¼ck zur Auswahl - nicht Platz auf halten',0),(169596,4711,'en','Return to Selection - Do NOT place On Hold',0),(169597,4712,'is','',0),(169598,4712,'dr','(ØªØ¨Ø¯ÙŠÙ„)Ø¨Ù‡ ÙØ±Ù…Ø§ÛŒØ´',0),(169599,4712,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØªØºÙŠÙŠØ±(ØªØ¨Ø¯ÙŠÙ„)Ø¨Ù‡ Ø³ÙØ§Ø±Ø´',0),(169600,4712,'tr','Hangi miktar sipariÅŸ iÃ§in dÃ¶nÃ¼ÅŸtÃ¼rmek iÃ§in seÃ§in',0),(169601,4712,'pl','Wybierz ktÃ³re iloÅ›Ä‡ do konwersji na zamÃ³wienie',0),(169602,4712,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, Ð·Ð° Ð´Ð° ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ð² Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(169603,4712,'ur','Ø¬Ø³ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± ØªØ¨Ø¯ÛŒÙ„ Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(169604,4712,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ¾Ñ˜Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð¿Ñ€ÐµÑ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(169605,4712,'vi','Chá»n sá»‘ lÆ°á»£ng nÃ o Ä‘á»ƒ chuyá»ƒn sang Ä‘Æ¡n hÃ ng',0),(169606,4712,'af','Kies watter hoeveelheid te omskep om orde te',0),(169607,4712,'ro','SelectaÅ£i cantitatea care sÄƒ converti la comanda',0),(169608,4712,'et','Millise koguse Convert tellimiseks valige',0),(169609,4712,'si','Izberite katere koliÄina pretvori v vrstnem redu',0),(169610,4712,'ba','Pilih mana jumlah untuk mengkonversi sesuai pesanan',0),(169611,4712,'nl','Selecteer welke hoeveelheid converteren om te bestellen',0),(169612,4712,'fi','Valitse mille mÃ¤Ã¤rÃ¤lle haluat muuntaa tilauksesta',0),(169613,4712,'no','Velg hvilke antallet Ã¥ konvertere til ordre',0),(169614,4712,'da','VÃ¦lg hvilken mÃ¦ngde til at konvertere til ordre',0),(169615,4712,'ko','ì£¼ë¬¸ìœ¼ë¡œ ë³€í™˜ í•˜ëŠ” ìˆ˜ëŸ‰ ì„ íƒ',0),(169616,4712,'he','×‘×—×¨ ××™×–×• ×›×ž×•×ª ×”×ž×¨ ×¢×œ ×¡×“×¨',0),(169617,4712,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€Î¿Î¹Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î½Î± Î¼ÎµÏ„Î±Ï„ÏÎ­ÏˆÎµÏ„Îµ ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(169618,4712,'zh','é€‰æ‹©å“ªäº›æ•°é‡è½¬æ¢ä»¥è®¢è´­\r\n',0),(169619,4712,'sv','VÃ¤lj vilken kvantitet konvertera till ordning',0),(169620,4712,'it','Selezionare quale quantitÃ  da convertire in ordine',0),(169621,4712,'tl','',0),(169622,4712,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3595;&#3638;&#3656;&#3591;&#3649;&#3611;&#3621;&#3591;&#3648;&#3611;&#3655;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(169623,4712,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¨à¥à¤µà¤°à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(169624,4712,'ms','Pilih kuantiti yang untuk Tukar kepada perintah',0),(169625,4712,'ar','Ø­Ø¯Ø¯ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ Ù„ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(169626,4712,'fr','SÃ©lectionnez quelle quantitÃ© Ã  convertir en ordre',0),(169627,4712,'jp','ã?©ã?®æ•°é‡?ã‚’æ³¨æ–‡ã?«å¤‰æ›´ã?™ã‚‹ã?‹é?¸æŠžã?—ã?¦ã??ã? ã?•ã?„',0),(169628,4712,'pt','Selecione qual quantidade a converter em ordem',0),(169629,4712,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐšÐ°ÐºÐ¾Ðµ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐŸÐµÑ€ÐµÐ½ÐµÑÑ‚Ð¸ Ð’ Ð—Ð°ÐºÐ°Ð·',0),(169630,4712,'es','Seleccionar Cual Cantidad para Convertir a un Orden',0),(169631,4712,'de','WÃ¤hlen Sie die Menge auf Convert bestellen',0),(169632,4712,'en','Select Which Quantity to Convert to Order',0),(169633,4713,'is','',0),(169634,4713,'dr','ÙØ¹Ø§Ù„ÙŠØª ',0),(169635,4713,'pr','ÙØ¹Ø§Ù„ÙŠØª ',0),(169636,4713,'tr','Etkinlik',0),(169637,4713,'pl','AktywnoÅ›Ä‡',0),(169638,4713,'bg','Ð”ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(169639,4713,'ur','Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(169640,4713,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(169641,4713,'vi','Hoáº¡t Äá»™ng',0),(169642,4713,'af','Aktiwiteit',0),(169643,4713,'ro','Activitate',0),(169644,4713,'et','Tegevus',0),(169645,4713,'si','Dejavnost',0),(169646,4713,'ba','Aktifitas',0),(169647,4713,'nl','Activiteit',0),(169648,4713,'fi','Toiminta',0),(169649,4713,'no','Aktivitet',0),(169650,4713,'da','Aktivitet',0),(169651,4713,'ko','í™œë™',0),(169652,4713,'he','×¤×¢×™×œ×•×ª',0),(169653,4713,'el','Î”ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(169654,4713,'zh','æ´»åŠ¨\r\n',0),(169655,4713,'sv','Aktivitet',0),(169656,4713,'it','AttivitÃ ',0),(169657,4713,'tl','',0),(169658,4713,'th','&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;',0),(169659,4713,'hi','à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(169660,4713,'ms','Aktiviti',0),(169661,4713,'ar','Ø§Ù„Ù†Ø´Ø§Ø·',0),(169662,4713,'fr','ActivitÃ©',0),(169663,4713,'jp','æ´»å‹•',0),(169664,4713,'pt','Atividade',0),(169665,4713,'ru','Ð”ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚ÑŒ',0),(169666,4713,'es','Actividad',0),(169667,4713,'de','AktivitÃ¤t',0),(169668,4713,'en','Activity',0),(169669,4714,'is','',0),(169670,4714,'dr','Ø¨Ø±Ø§ÙŠ Ù†Ø³Ø®Ù‡ Ù‚Ø§Ø¨Ù„ Ú†Ø§Ù¾ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(169671,4714,'pr','Ø¨Ø±Ø§ÙŠ Ù†Ø³Ø®Ù‡ Ù‚Ø§Ø¨Ù„ Ú†Ø§Ù¾ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(169672,4714,'tr','BasÄ±labilir versiyonu iÃ§in tÄ±klayÄ±nÄ±z.',0),(169673,4714,'pl','Kliknij na wersja do druku',0),(169674,4714,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð²ÐµÑ€ÑÐ¸Ñ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(169675,4714,'ur','Ù‚Ø§Ø¨Ù„ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ ÙˆØ±Ú˜Ù† Ú©Û’ Ù„Ø¦Û’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(169676,4714,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð·Ð° Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð° Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ñƒ',0),(169677,4714,'vi','Nháº¥n cho phiÃªn báº£n cÃ³ thá»ƒ in',0),(169678,4714,'af','Kliek vir Uitdrukbare Weergawe',0),(169679,4714,'ro','Click pentru versiune printabila',0),(169680,4714,'et','KlÃµpsake kÃ¤sku Prinditav versioon',0),(169681,4714,'si','Kliknite za Natisljiva razliÄica',0),(169682,4714,'ba','Klik untuk versi cetak',0),(169683,4714,'nl','Klik voor een afdrukbare versie',0),(169684,4714,'fi','Klikkaa Tulostettava versio',0),(169685,4714,'no','Klikk for utskriftsvennlig versjon',0),(169686,4714,'da','Klik for printervenlig udgave',0),(169687,4714,'ko','ì¸ì‡„ ê°€ëŠ¥í•œ ë²„ì „ì— ëŒ€ í•œ í´ë¦­',0),(169688,4714,'he','×œ×—×¥ ×¢×œ ×’×™×¨×¡×” ×œ×”×“×¤×¡×”',0),(169689,4714,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î· Î­ÎºÎ´Î¿ÏƒÎ·',0),(169690,4714,'zh','ç‚¹å‡»å¯æ‰“å°ç‰ˆ\r\n',0),(169691,4714,'sv','Klicka fÃ¶r utskriftsvÃ¤nlig Version',0),(169692,4714,'it','Clicca per la versione stampabile',0),(169693,4714,'tl','',0),(169694,4714,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3593;&#3610;&#3633;&#3610;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3614;&#3636;&#3617;&#3614;&#3660;&#3652;&#3604;&#3657;',0),(169695,4714,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¯à¥‹à¤—à¥à¤¯ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(169696,4714,'ms','Klik untuk versi cetak',0),(169697,4714,'ar','Ø§Ù†Ù‚Ø± Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù†Ø³Ø®Ø© Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(169698,4714,'fr','Cliquez ici pour la Version imprimable',0),(169699,4714,'jp','å?°åˆ·ç”¨ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(169700,4714,'pt','Clique para versÃ£o para impressÃ£o',0),(169701,4714,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð´Ð»Ñ ÐŸÐµÑ‡Ð°Ñ‚Ð½Ð¾Ð¹ Ð’ÐµÑ€ÑÐ¸Ð¸',0),(169702,4714,'es','Click para la VersiÃ³n Imprimible',0),(169703,4714,'de','Hier klicken fÃ¼r Druckversion',0),(169704,4714,'en','Click for Printable Version',0),(169705,4715,'is','',0),(169706,4715,'dr','Ø¨Ø±Ø§ÙŠ  Ø¨Ø±Ú¯Ø´Øª ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(169707,4715,'pr','Ø¨Ø±Ø§ÙŠ  Ø¨Ø±Ú¯Ø´Øª ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(169708,4715,'tr','DÃ¶nmek iÃ§in tÄ±klatÄ±n',0),(169709,4715,'pl','Kliknij powrÃ³t',0),(169710,4715,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ',0),(169711,4715,'ur','Ù…ÛŒÚº ÙˆØ§Ù¾Ø³ÛŒ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(169712,4715,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚Ð°Ðº',0),(169713,4715,'vi','Nháº¥n Ä‘á»ƒ Quay láº¡i',0),(169714,4715,'af','Kliek om Terug te Keer',0),(169715,4715,'ro','Click pentru a reveni',0),(169716,4715,'et','KlÃµpsake nuppu tagasi',0),(169717,4715,'si','Kliknite za vrnitev',0),(169718,4715,'ba','Klik untuk kembali',0),(169719,4715,'nl','Klik op teruggave',0),(169720,4715,'fi','Valitse palata',0),(169721,4715,'no','Klikk tilbake',0),(169722,4715,'da','Klik for at vende tilbage',0),(169723,4715,'ko','ìˆ˜ìµì„ í´ë¦­',0),(169724,4715,'he','×œ×—×¥ ×›×“×™ ×œ×—×–×•×¨',0),(169725,4715,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(169726,4715,'zh','ç‚¹å‡»è¿”å›ž\r\n',0),(169727,4715,'sv','Klicka fÃ¶r att Ã¥tervÃ¤nda',0),(169728,4715,'it','Clicca per tornare indietro',0),(169729,4715,'tl','',0),(169730,4715,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3606;&#3629;&#3618;&#3585;&#3621;&#3633;&#3610;',0),(169731,4715,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(169732,4715,'ms','Klik untuk kembali',0),(169733,4715,'ar','Ø£Ù†Ù‚Ø± Ù„Ù„Ø±Ø¬ÙˆØ¹',0),(169734,4715,'fr','Cliquez sur retour',0),(169735,4715,'jp','æˆ»ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(169736,4715,'pt','Clique para voltar',0),(169737,4715,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ',0),(169738,4715,'es','Click para Regresar',0),(169739,4715,'de','Klicken Sie auf RÃ¼ckkehr',0),(169740,4715,'en','Click to Return',0),(169741,4716,'is','',0),(169742,4716,'dr','ØªØ§Ø±ÙŠØ® Ø®Ø±ÙˆØ¬ ',0),(169743,4716,'pr','ØªØ§Ø±ÙŠØ® Ø®Ø±ÙˆØ¬ ',0),(169744,4716,'tr','Ã‡Ä±kÄ±ÅŸ tarihi',0),(169745,4716,'pl','Data',0),(169746,4716,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(169747,4716,'ur','Ø¨Ø§ÛØ± Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(169748,4716,'sr','Ð˜Ð·Ð»Ð°Ð·Ð¸ Ð½Ð°Ð¿Ð¾Ñ™Ðµ',0),(169749,4716,'vi','NgÃ y ra',0),(169750,4716,'af','Datum Uit',0),(169751,4716,'ro','Data afarÄƒ',0),(169752,4716,'et','KuupÃ¤ev, vÃ¤lja',0),(169753,4716,'si','Datum',0),(169754,4716,'ba','Tanggal keluar',0),(169755,4716,'nl','Datum uit',0),(169756,4716,'fi','MennessÃ¤',0),(169757,4716,'no','Dato ut',0),(169758,4716,'da','Dato ud',0),(169759,4716,'ko','ì•„ì›ƒ ë‚ ì§œ',0),(169760,4716,'he','×œ×¦××ª ×”×—×•×¦×”',0),(169761,4716,'el','Î£Î®Î¼ÎµÏÎ± Î­Î¾Ï‰',0),(169762,4716,'zh','è¿‡æ—¶\r\n',0),(169763,4716,'sv','Datum ut',0),(169764,4716,'it','Data di uscita',0),(169765,4716,'tl','',0),(169766,4716,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3629;&#3629;&#3585;',0),(169767,4716,'hi','à¤¬à¤¾à¤¹à¤° à¤¤à¤¾à¤°à¥€à¤–',0),(169768,4716,'ms','Tarikh Keluar',0),(169769,4716,'ar','ÙˆØ­ØªÙ‰ Ø§Ù„Ø¢Ù† Ø®Ø§Ø±Ø¬',0),(169770,4716,'fr','Date de sortie',0),(169771,4716,'jp','ç™ºé€?æ—¥',0),(169772,4716,'pt','Sair fora',0),(169773,4716,'ru','Ð”Ð°Ñ‚Ð°',0),(169774,4716,'es','Fecha Afuera',0),(169775,4716,'de','Datum aus',0),(169776,4716,'en','Date Out',0),(169777,4717,'is','',0),(169778,4717,'dr','- Ø²Ù…Ø§Ù†  Ø¯Ø± ',0),(169779,4717,'pr','ØªØ§Ø±ÙŠØ®  - Ø²Ù…Ø§Ù†  Ø¯Ø± ',0),(169780,4717,'tr','Tarih ve saat iÃ§inde',0),(169781,4717,'pl','Data/godzina w',0),(169782,4717,'bg','Ð”Ð°Ñ‚Ð°/Ñ‡Ð°Ñ Ð²',0),(169783,4717,'ur','ØªØ§Ø±ÛŒØ®/ÙˆÙ‚Øª Ù…ÛŒÚº',0),(169784,4717,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ /Ð²Ñ€ÐµÐ¼Ðµ Ñƒ',0),(169785,4717,'vi','NgÃ y/thá»i gian vÃ o',0),(169786,4717,'af','Datum/Tyd Ingehandig',0),(169787,4717,'ro','Data/ora Ã®n',0),(169788,4717,'et','KuupÃ¤ev/kellaaeg',0),(169789,4717,'si','Datum in ura v',0),(169790,4717,'ba','Tanggal/waktu di',0),(169791,4717,'nl','Datum/tijd In',0),(169792,4717,'fi','PÃ¤ivÃ¤yksen ja ajan',0),(169793,4717,'no','Dato/klokkeslett i',0),(169794,4717,'da','Dato og klokkeslÃ¦t i',0),(169795,4717,'ko','ë‚ ì§œ/ì‹œê°„ì—ì„œ',0),(169796,4717,'he','×ª××¨×™×š/×©×¢×”',0),(169797,4717,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±/ÏŽÏÎ± ÏƒÎµ',0),(169798,4717,'zh','æ—¥æœŸ/æ—¶é—´\r\n',0),(169799,4717,'sv','Datum och tid i',0),(169800,4717,'it','Data e ora In',0),(169801,4717,'tl','',0),(169802,4717,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;/&#3648;&#3623;&#3621;&#3634; &#3648;&#3586;&#3657;&#3634;',0),(169803,4717,'hi','à¤®à¥‡à¤‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•/à¤¸à¤®à¤¯',0),(169804,4717,'ms','Tarikh/masa dalam',0),(169805,4717,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ®/Ø§Ù„ÙˆÙ‚Øª ÙÙŠ',0),(169806,4717,'fr','Date/heure dans',0),(169807,4717,'jp','å?—ä»˜æ—¥/æ™‚é–“',0),(169808,4717,'pt','Data/hora em',0),(169809,4717,'ru','Ð”Ð°Ñ‚Ð°/Ð’Ñ€ÐµÐ¼Ñ Ð’',0),(169810,4717,'es','Fecha/Hora Entrada',0),(169811,4717,'de','Datum/Uhrzeit In',0),(169812,4717,'en','Date/Time In',0),(169813,4718,'is','',0),(169814,4718,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(169815,4718,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(169816,4718,'tr','Hata alma orijinalleri',0),(169817,4718,'pl','BÅ‚Ä…d pobierania oryginaÅ‚y',0),(169818,4718,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸Ñ‚Ðµ',0),(169819,4718,'ur','Ù†Ù‚Øµ Ø§ØµÙ„ Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(169820,4718,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐ° Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ðµ',0),(169821,4718,'vi','Lá»—i truy váº¥n nguyÃªn báº£n',0),(169822,4718,'af','Fout herwinning oorspronklikes',0),(169823,4718,'ro','Eroare recuperare originale',0),(169824,4718,'et','TÃµrge allalaadimisel originaalid',0),(169825,4718,'si','Napaka pri pridobivanju originali',0),(169826,4718,'ba','Kesalahan mengambil aslinya',0),(169827,4718,'nl','Fout ophalen van originelen',0),(169828,4718,'fi','Virhe noudettaessa alkuperÃ¤iset',0),(169829,4718,'no','Feil under henting av originaler',0),(169830,4718,'da','Fejl under hentning af originaler',0),(169831,4718,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ì›ë³¸',0),(169832,4718,'he','×©×’×™××” ×‘××—×–×•×¨ ×”×ž×§×•×¨×™×™×',0),(169833,4718,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï€ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î±',0),(169834,4718,'zh','é”™è¯¯æ£€ç´¢åŽŸç¨¿',0),(169835,4718,'sv','Fel HÃ¤mta originalen',0),(169836,4718,'it','Errore recuperando gli originali',0),(169837,4718,'tl','',0),(169838,4718,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;',0),(169839,4718,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ à¤®à¥‚à¤²',0),(169840,4718,'ms','Ralat mendapatkan semula dokumen asal',0),(169841,4718,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ø£ØµÙˆÙ„',0),(169842,4718,'fr','Erreur rÃ©cupÃ©rer originaux',0),(169843,4718,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«æ¤œç´¢ã‚¨ãƒ©ãƒ¼',0),(169844,4718,'pt','Erro Recuperando originais',0),(169845,4718,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð’Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð°',0),(169846,4718,'es','Error Recogiendo Originales',0),(169847,4718,'de','Fehler beim Abrufen Originals',0),(169848,4718,'en','Error Retrieving Originals',0),(169849,4719,'is','',0),(169850,4719,'dr','( ÙˆØ±ÙˆØ¯ÙŠ) ØªÙˆØ³Ø·',0),(169851,4719,'pr','Ø¯Ø§Ø¯Ù‡ ( ÙˆØ±ÙˆØ¯ÙŠ) ØªÙˆØ³Ø·',0),(169852,4719,'tr','TarafÄ±ndan giriÅŸ',0),(169853,4719,'pl','WejÅ›cie przez',0),(169854,4719,'bg','Ð’Ñ…Ð¾Ð´ Ñ‡Ñ€ÐµÐ·',0),(169855,4719,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ù† Ù¾Ù¹',0),(169856,4719,'sr','Ð—Ð° ÑƒÐ½Ð¾Ñ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(169857,4719,'vi','Nháº­p vÃ o do',0),(169858,4719,'af','Insette deur',0),(169859,4719,'ro','Intrare prin',0),(169860,4719,'et','Sisestamise teel',0),(169861,4719,'si','VloÅ¾ek z',0),(169862,4719,'ba','Input dengan',0),(169863,4719,'nl','Ingang door',0),(169864,4719,'fi','SyÃ¶ttÃ¤mien',0),(169865,4719,'no','Input av',0),(169866,4719,'da','Input ved',0),(169867,4719,'ko','í•˜ ì—¬ ìž…ë ¥',0),(169868,4719,'he','×§×œ×˜ ×¢×œ-×™×“×™',0),(169869,4719,'el','Î•Î¹ÏƒÏŒÎ´Î¿Ï… Î±Ï€ÏŒ',0),(169870,4719,'zh','å½•å…¥\r\n',0),(169871,4719,'sv','IngÃ¥ng genom',0),(169872,4719,'it','Ingresso di',0),(169873,4719,'tl','',0),(169874,4719,'th','&#3651;&#3626;&#3656;&#3650;&#3604;&#3618;',0),(169875,4719,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‡à¤¨à¤ªà¥à¤Ÿ',0),(169876,4719,'ms','Input oleh',0),(169877,4719,'ar','Ø§Ù„Ù…Ø¯Ø®Ù„Ø§Øª ÙÙŠ Ù…ÙˆØ¹Ø¯ ØºØ§ÙŠØªÙ‡',0),(169878,4719,'fr','EntrÃ©e par',0),(169879,4719,'jp','ï½žã?«ã‚ˆã‚Šå…¥åŠ›',0),(169880,4719,'pt','Entrada por',0),(169881,4719,'ru','Ð’Ñ…Ð¾Ð´ Ð¿Ð¾',0),(169882,4719,'es','Input por',0),(169883,4719,'de','Eingabe von',0),(169884,4719,'en','Input By',0),(169885,4720,'is','',0),(169886,4720,'dr','Ù…Ø­Ù„ Ù†Ø§Ù…Ù‡ Ù†Ú¯Ø§Ø±ÙŠ ',0),(169887,4720,'pr','Ù…Ø­Ù„ Ù†Ø§Ù…Ù‡ Ù†Ú¯Ø§Ø±ÙŠ ',0),(169888,4720,'tr','Posta duraÄŸÄ±',0),(169889,4720,'pl','Stop poczty',0),(169890,4720,'bg','ÐŸÐ¾Ñ‰Ð° ÑÑ‚Ð¾Ð¿',0),(169891,4720,'ur','ÚˆØ§Ú© Ø±ÙˆÚ©',0),(169892,4720,'sr','Ð¡Ñ‚Ð°Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ð¾ÑˆÑ‚Ñƒ',0),(169893,4720,'vi','Há»™p thÆ°',0),(169894,4720,'af','E-pos Stop',0),(169895,4720,'ro','Oprire corespondenÅ£Äƒ',0),(169896,4720,'et','E-posti Stopp',0),(169897,4720,'si','PoÅ¡ta Stop',0),(169898,4720,'ba','Mail Stop',0),(169899,4720,'nl','Mail Stop',0),(169900,4720,'fi','Postilokeron',0),(169901,4720,'no','E stopp',0),(169902,4720,'da','Mail Stop',0),(169903,4720,'ko','ë©”ì¼ ì¤‘ì§€',0),(169904,4720,'he','×ª×—× ×ª ×“×•××¨',0),(169905,4720,'el','Î”Î¹Î±ÎºÎ¿Ï€Î® Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚',0),(169906,4720,'zh','é‚®ä»¶åœæ­¢\r\n',0),(169907,4720,'sv','E-Stop',0),(169908,4720,'it','Mail Stop',0),(169909,4720,'tl','',0),(169910,4720,'th','&#3605;&#3641;&#3657; &#3611;&#3603;.',0),(169911,4720,'hi','à¤®à¥‡à¤² à¤°à¥‹à¤•à¥‡à¤‚',0),(169912,4720,'ms','Hentian mel',0),(169913,4720,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(169914,4720,'fr','ArrÃªt postal',0),(169915,4720,'jp','éƒµä¾¿å?œæ­¢',0),(169916,4720,'pt','Mail Stop',0),(169917,4720,'ru','ÐžÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(169918,4720,'es','Parte adicional de CÃ³digo Postal',0),(169919,4720,'de','Post-Stop',0),(169920,4720,'en','Mail Stop',0),(169921,4721,'is','',0),(169922,4721,'dr','Ø¬Ø¯ÙŠØ¯ ',0),(169923,4721,'pr','Ø¬Ø¯ÙŠØ¯ ',0),(169924,4721,'tr','Yeni',0),(169925,4721,'pl','Nowy',0),(169926,4721,'bg','ÐÐ¾Ð²',0),(169927,4721,'ur','Ù†ÛŒØ§',0),(169928,4721,'sr','ÐÐ¾Ð²Ð¸',0),(169929,4721,'vi','Má»›i',0),(169930,4721,'af','Nuwe',0),(169931,4721,'ro','Noi',0),(169932,4721,'et','Uus',0),(169933,4721,'si','Nove',0),(169934,4721,'ba','Baru',0),(169935,4721,'nl','Nieuw',0),(169936,4721,'fi','Uusi',0),(169937,4721,'no','Nye',0),(169938,4721,'da','Nye',0),(169939,4721,'ko','ìƒˆë¡œìš´ ë‚´ìš©',0),(169940,4721,'he','×—×“×©',0),(169941,4721,'el','ÎÎ­Î±',0),(169942,4721,'zh','æ–°\r\n',0),(169943,4721,'sv','Nya',0),(169944,4721,'it','Nuovo',0),(169945,4721,'tl','',0),(169946,4721,'th','&#3651;&#3627;&#3617;&#3656;',0),(169947,4721,'hi','à¤¨à¤ˆ',0),(169948,4721,'ms','Baru',0),(169949,4721,'ar','Ø¬Ø¯ÙŠØ¯',0),(169950,4721,'fr','Nouveau',0),(169951,4721,'jp','æ–°è¦?',0),(169952,4721,'pt','Novo',0),(169953,4721,'ru','ÐÐ¾Ð²Ð¾Ðµ',0),(169954,4721,'es','Nuevo',0),(169955,4721,'de','Neu',0),(169956,4721,'en','New',0),(169957,4722,'is','',0),(169958,4722,'dr','Ø§Ø¹Ù„Ø§Ù… ÙƒØ±Ø¯Ù† ',0),(169959,4722,'pr','Ø§Ø¹Ù„Ø§Ù… ÙƒØ±Ø¯Ù† ',0),(169960,4722,'tr','Bildir',0),(169961,4722,'pl','Informuj',0),(169962,4722,'bg','Ð£Ð²ÐµÐ´Ð¾Ð¼ÑÐ²Ð°',0),(169963,4722,'ur','Ù…Ø·Ù„Ø¹ Ú©Ø±ÛŒÚº',0),(169964,4722,'sr','ÐžÐ±Ð°Ð²Ð¸Ñ˜ÐµÑÑ‚Ð¸',0),(169965,4722,'vi','ThÃ´ng bÃ¡o',0),(169966,4722,'af','In kennis stel',0),(169967,4722,'ro','Notifica',0),(169968,4722,'et','Teavita',0),(169969,4722,'si','Obvesti',0),(169970,4722,'ba','Memberitahukan',0),(169971,4722,'nl','Houd op de hoogte',0),(169972,4722,'fi','Ilmoitettava',0),(169973,4722,'no','Varsle',0),(169974,4722,'da','Underrette',0),(169975,4722,'ko','ì•Œë¦¼',0),(169976,4722,'he','× × ×œ×”×•×“×™×¢',0),(169977,4722,'el','ÎšÎ¿Î¹Î½Î¿Ï€Î¿Î¹ÎµÎ¯',0),(169978,4722,'zh','é€šçŸ¥\r\n',0),(169979,4722,'sv','Meddela',0),(169980,4722,'it','Notificare',0),(169981,4722,'tl','',0),(169982,4722,'th','&#3649;&#3592;&#3657;&#3591;&#3588;&#3623;&#3634;&#3617;',0),(169983,4722,'hi','à¤¸à¥‚à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(169984,4722,'ms','Memaklumkan kepada',0),(169985,4722,'ar','Ø¥Ø¹Ù„Ø§Ù…',0),(169986,4722,'fr','Notifier',0),(169987,4722,'jp','çŸ¥ã‚‰ã?›ã‚‹',0),(169988,4722,'pt','Notificar',0),(169989,4722,'ru','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(169990,4722,'es','Notificar',0),(169991,4722,'de','Benachrichtigen Sie',0),(169992,4722,'en','Notify',0),(169993,4723,'is','',0),(169994,4723,'dr','Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ØªÙˆØ³Ø·',0),(169995,4723,'pr','Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ØªÙˆØ³Ø·',0),(169996,4723,'tr','Orijinalleri tarafÄ±ndan gÃ¶nderildi',0),(169997,4723,'pl','OryginaÅ‚y przekazywane przez',0),(169998,4723,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸, Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð¸ Ð¾Ñ‚',0),(169999,4723,'ur','Ø§ØµÙ„ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¹Ø±Ø¶ Ú©Ø±Ù†Û’ Ù„Ú¯Û’',0),(170000,4723,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸ , ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð¿Ñ€ÐµÐ´Ð°Ð¾',0),(170001,4723,'vi','Ná»™p NguyÃªn báº£n bá»Ÿi',0),(170002,4723,'af','Oorspronklikes Ingedien Deur',0),(170003,4723,'ro','Originalele transmise de',0),(170004,4723,'et','Poolt originaal',0),(170005,4723,'si','Originali vpisali',0),(170006,4723,'ba','Asli dikirim oleh',0),(170007,4723,'nl','Originelen afkomstig van',0),(170008,4723,'fi','AlkuperÃ¤iset lÃ¤hettÃ¤neet',0),(170009,4723,'no','Originaler innsendt av',0),(170010,4723,'da','Originalerne indsendt af',0),(170011,4723,'ko','ë‹˜ ì›ë³¸',0),(170012,4723,'he','××•×¨×™×’×™× ×œ×™× ×ž××ª',0),(170013,4723,'el','Î ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î± Ï…Ï€Î¿Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ',0),(170014,4723,'zh','æäº¤åŽŸä»¶\r\n',0),(170015,4723,'sv','Originalen som skickats in av',0),(170016,4723,'it','Originali inseriti',0),(170017,4723,'tl','',0),(170018,4723,'th','&#3648;&#3626;&#3609;&#3629;&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;&#3650;&#3604;&#3618;',0),(170019,4723,'hi','à¤®à¥‚à¤² à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤',0),(170020,4723,'ms','Asal yang dikemukakan oleh',0),(170021,4723,'ar','Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø£ØµÙ„ÙŠØ© Ø§Ù„Ù…Ù‚Ø¯Ù…Ø© Ù…Ù†',0),(170022,4723,'fr','Originaux soumis par',0),(170023,4723,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«æ??å‡ºè€…',0),(170024,4723,'pt','Originais submetidos',0),(170025,4723,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ñ‹ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ…',0),(170026,4723,'es','Originales Preentados Por',0),(170027,4723,'de','Originale vorgelegt',0),(170028,4723,'en','Originals Submitted By',0),(170029,4724,'is','',0),(170030,4724,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(170031,4724,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(170032,4724,'tr','Pikap orijinalleri',0),(170033,4724,'pl','OdbiÃ³r oryginaÅ‚y',0),(170034,4724,'bg','ÐŸÐ¸ÐºÐ°Ð¿ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸Ñ‚Ðµ',0),(170035,4724,'ur','Ù¾Ú© Ø§Ù¾ Ø§ØµÙ„',0),(170036,4724,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐ° Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ðµ',0),(170037,4724,'vi','Chá»n trÃªn nguyÃªn báº£n ',0),(170038,4724,'af','Bakkie oorspronklikes',0),(170039,4724,'ro','Pickup originale',0),(170040,4724,'et','Maastur originaalid',0),(170041,4724,'si','Pickup originali',0),(170042,4724,'ba','Pickup aslinya',0),(170043,4724,'nl','Pick-up originelen',0),(170044,4724,'fi','Pickup alkuperÃ¤iset',0),(170045,4724,'no','Pickup originaler',0),(170046,4724,'da','Pickup originaler',0),(170047,4724,'ko','í”½ì—… ì›ë³¸',0),(170048,4724,'he','×˜× ×“×¨ ×”×ž×§×•×¨×™×™×',0),(170049,4724,'el','Pickup Ï„Î± Ï€ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î±',0),(170050,4724,'zh','çš®å¡åŽŸç¨¿\r\n',0),(170051,4724,'sv','Pickup originalen',0),(170052,4724,'it','Pick-up originali',0),(170053,4724,'tl','',0),(170054,4724,'th','&#3648;&#3585;&#3655;&#3610;&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;',0),(170055,4724,'hi','à¤¬à¤Ÿà¥‹à¤°à¤¨à¤¾ à¤®à¥‚à¤²',0),(170056,4724,'ms','Asal kutip',0),(170057,4724,'ar','Ø£ØµÙˆÙ„ Ø¨ÙŠÙƒ Ø¢Ø¨',0),(170058,4724,'fr','Pick-up originaux',0),(170059,4724,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«ã?®å?Žé›†',0),(170060,4724,'pt','Captador originais',0),(170061,4724,'ru','ÐŸÐ¸ÐºÐ°Ð¿ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ñ‹',0),(170062,4724,'es','Recoger Originales',0),(170063,4724,'de','Pickup Originals',0),(170064,4724,'en','Pickup Originals',0),(170065,4725,'is','',0),(170066,4725,'dr','Ú†Ø§Ù¾ Ø´Ø¯Ù‡ ',0),(170067,4725,'pr','Ú†Ø§Ù¾ Ø´Ø¯Ù‡ ',0),(170068,4725,'tr','BaskÄ±lÄ±',0),(170069,4725,'pl','Drukowane',0),(170070,4725,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð½Ð¸',0),(170071,4725,'ur','Ú†Ú¾Ø§Ù¾Ø§',0),(170072,4725,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°',0),(170073,4725,'vi','ÄÃ£ in',0),(170074,4725,'af','Gedruk',0),(170075,4725,'ro','Imprimate',0),(170076,4725,'et','TrÃ¼kitud',0),(170077,4725,'si','Natisnjeno',0),(170078,4725,'ba','Dicetak',0),(170079,4725,'nl','Afgedrukt',0),(170080,4725,'fi','Painettu',0),(170081,4725,'no','Trykt',0),(170082,4725,'da','Trykt',0),(170083,4725,'ko','ì¸ì‡„',0),(170084,4725,'he','×”×•×“×¤×¡',0),(170085,4725,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(170086,4725,'zh','æ‰“å°\r\n',0),(170087,4725,'sv','Tryckt',0),(170088,4725,'it','Stampato',0),(170089,4725,'tl','',0),(170090,4725,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3649;&#3621;&#3657;&#3623;',0),(170091,4725,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤',0),(170092,4725,'ms','Dicetak',0),(170093,4725,'ar','Ø·Ø¨Ø§Ø¹Ø©',0),(170094,4725,'fr','ImprimÃ©',0),(170095,4725,'jp','å?°åˆ·æ¸ˆ',0),(170096,4725,'pt','Impresso',0),(170097,4725,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð½Ð¾',0),(170098,4725,'es','Imprimido',0),(170099,4725,'de','Gedruckt',0),(170100,4725,'en','Printed',0),(170101,4726,'is','',0),(170102,4726,'dr','Ú†Ø§Ù¾ Ø¨Ø§ ÙØ±Ù…Øª Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ',0),(170103,4726,'pr','Ú†Ø§Ù¾ Ø¨Ø§ ÙØ±Ù…Øª Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ',0),(170104,4726,'tr','PDF formatÄ±nda yazdÄ±rÄ±n',0),(170105,4726,'pl','Druk w formacie PDF',0),(170106,4726,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð² PDF Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(170107,4726,'ur','Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ø±Ù…ÛŒÙ¹ Ù…ÛŒÚº Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(170108,4726,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñƒ ÐŸÐ”Ð¤ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(170109,4726,'vi','In theo dáº¡ng PDF',0),(170110,4726,'af','Druk in PDF formaat',0),(170111,4726,'ro','Imprimare in PDF Format',0),(170112,4726,'et','Prindi PDF-formaadis',0),(170113,4726,'si','Tiskanje v PDF formatu',0),(170114,4726,'ba','Mencetak dalam PDF Format',0),(170115,4726,'nl','Afdrukken in PDF-formaat',0),(170116,4726,'fi','Tulosta PDF-muodossa',0),(170117,4726,'no','Skrive ut i PDF-Format',0),(170118,4726,'da','Udskrive i PDF-Format',0),(170119,4726,'ko','PDF í˜•ì‹ìœ¼ë¡œ ì¸ì‡„',0),(170120,4726,'he','PDF ×”×“×¤×¡ ×‘×ª×‘× ×™×ª',0),(170121,4726,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÎµ Î¼Î¿ÏÏ†Î® PDF',0),(170122,4726,'zh','æ‰“å°ä»¥PDFæ ¼å¼\r\n',0),(170123,4726,'sv','Skriva ut i PDF-Format',0),(170124,4726,'it','Stampare in formato PDF',0),(170125,4726,'tl','',0),(170126,4726,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610; PDF',0),(170127,4726,'hi','à¤ªà¥€à¤¡à¥€à¤à¤« à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(170128,4726,'ms','Mencetak dalam PDF Format',0),(170129,4726,'ar','Ø·Ø¨Ø§Ø¹Ø© ÙÙŠ ØªÙ†Ø³ÙŠÙ‚ PDF',0),(170130,4726,'fr','Imprimer au Format PDF',0),(170131,4726,'jp','ï¼°ï¼¤ï¼¦ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆã?§å?°åˆ·',0),(170132,4726,'pt','Imprimir em formato PDF',0),(170133,4726,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð² PDF Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ',0),(170134,4726,'es','Imprimir en el Formato PDF',0),(170135,4726,'de','Drucken im PDF-Format',0),(170136,4726,'en','Print in PDF Format',0),(170137,4727,'is','',0),(170138,4727,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ØªÙˆÙ„ÙŠØ¯ ',0),(170139,4727,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ØªÙˆÙ„ÙŠØ¯ ',0),(170140,4727,'tr','Ãœretim yÃ¶nergeleri',0),(170141,4727,'pl','Instrukcje produkcji',0),(170142,4727,'bg','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²ÐµÐ½Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(170143,4727,'ur','Ù¾ÛŒØ¯Ø§ÙˆØ§Ø± Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(170144,4727,'sr','Ð£Ð¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑšÑƒ',0),(170145,4727,'vi','HÆ°á»›ng dáº«n sáº£n xuáº¥t',0),(170146,4727,'af','Produksie Instruksies',0),(170147,4727,'ro','InstrucÅ£iuni de producÅ£ie',0),(170148,4727,'et','Tootmise juhiseid',0),(170149,4727,'si','Proizvodnja navodila',0),(170150,4727,'ba','Produksi petunjuk',0),(170151,4727,'nl','Productie instructies',0),(170152,4727,'fi','Tuotanto-ohjeet',0),(170153,4727,'no','Produksjon instruksjoner',0),(170154,4727,'da','Produktion instruktioner',0),(170155,4727,'ko','ìƒì‚° ì§€ì‹œ',0),(170156,4727,'he','×”×•×¨××•×ª ×™×™×¦×•×¨',0),(170157,4727,'el','ÎŸÎ´Î·Î³Î¯ÎµÏ‚ Ï€Î±ÏÎ±Î³Ï‰Î³Î®Ï‚',0),(170158,4727,'zh','ç”Ÿäº§çŸ¥æŒ‡ç¤º\r\n',0),(170159,4727,'sv','Produktion instruktioner',0),(170160,4727,'it','Istruzioni di produzione',0),(170161,4727,'tl','',0),(170162,4727,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;',0),(170163,4727,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¨ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(170164,4727,'ms','Pengeluaran arahan',0),(170165,4727,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¥Ù†ØªØ§Ø¬',0),(170166,4727,'fr','Instructions de production',0),(170167,4727,'jp','è£½é€ æŒ‡ç¤º',0),(170168,4727,'pt','InstruÃ§Ãµes de produÃ§Ã£o',0),(170169,4727,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(170170,4727,'es','instrucciones de ProducciÃ³n',0),(170171,4727,'de','Produktion-Anweisungen',0),(170172,4727,'en','Production Instructions',0),(170173,4728,'is','',0),(170174,4728,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ù‡Ù†Ú¯Ø§Ù…ÙŠÙƒÙ‡',0),(170175,4728,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ù‡Ù†Ú¯Ø§Ù…ÙŠÙƒÙ‡',0),(170176,4728,'tr','Olarak yeni BasÄ±m-olduÄŸunu',0),(170177,4728,'pl','Przedruk jako-jest',0),(170178,4728,'bg','ÐŸÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ ÐºÐ°Ñ‚Ð¾-Ðµ',0),(170179,4728,'ur','Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹-ÛÛ’',0),(170180,4728,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ‚Ðµ ÐºÐ°Ð¾-Ñ˜Ðµ',0),(170181,4728,'vi','In láº¡i nhÆ° lÃ ',0),(170182,4728,'af','Herdruk Voetstootse Verkope',0),(170183,4728,'ro','ImprimaÅ£i din nou ca-este',0),(170184,4728,'et','KordustrÃ¼kk nagu-on',0),(170185,4728,'si','Ponatis kot-je',0),(170186,4728,'ba','Mencetak ulang sebagai-adalah',0),(170187,4728,'nl','Herdruk als-Is',0),(170188,4728,'fi','Tulostaa kuin-on',0),(170189,4728,'no','Skrive ut som-er',0),(170190,4728,'da','Genoptrykke som-er',0),(170191,4728,'ko','ë¡œ ë¬´ë‹¨ ì „ìž¬-ì€',0),(170192,4728,'he','×œ×”×“×¤×™×¡ ×ž×—×“×© ×›×ž×•-×”×•×',0),(170193,4728,'el','Î‘Î½Î¬Ï„Ï…Ï€Î¿ Ï‰Ï‚-ÎµÎ¯Î½Î±Î¹',0),(170194,4728,'zh','é‡å°åŽŸæ ·\r\n',0),(170195,4728,'sv','Nytryck som-Ã¤r',0),(170196,4728,'it','Ristampa come-Ã¨',0),(170197,4728,'tl','',0),(170198,4728,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;&#3586;&#3603;&#3632;&#3607;&#3637;&#3656;',0),(170199,4728,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚-à¤¹à¥ˆ',0),(170200,4728,'ms','Juga boleh dicetak semula sebagai-adalah',0),(170201,4728,'ar','Ø·Ø¨Ø¹ ÙƒÙ‡Ùˆ',0),(170202,4728,'fr','RÃ©imprimer comme-est',0),(170203,4728,'jp','ã??ã?®ã?¾ã?¾ã?§å†?å?°åˆ·',0),(170204,4728,'pt','Reimprimir como-Ã©',0),(170205,4728,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÐšÐ°Ðº Ð•ÑÑ‚ÑŒ',0),(170206,4728,'es','Reimprimir Como sea',0),(170207,4728,'de','Als Reprint-ist',0),(170208,4728,'en','Reprint As-Is',0),(170209,4729,'is','',0),(170210,4729,'dr','Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡',0),(170211,4729,'pr','Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡',0),(170212,4729,'tr','Revize',0),(170213,4729,'pl','Poprawione',0),(170214,4729,'bg','ÐŸÑ€ÐµÑ€Ð°Ð±Ð¾Ñ‚ÐµÐ½',0),(170215,4729,'ur','Ù†Ø¸Ø±Ù Ø«Ø§Ù†ÛŒ',0),(170216,4729,'sr','Ð ÐµÐ²Ð¸Ð´Ð¸Ñ€Ð°Ð½',0),(170217,4729,'vi','ÄÃ£ Chá»‰nh sá»­a',0),(170218,4729,'af','Hersien',0),(170219,4729,'ro','Revizuit',0),(170220,4729,'et','Muudetud',0),(170221,4729,'si','Revidirane',0),(170222,4729,'ba','Direvisi',0),(170223,4729,'nl','Herziene versie',0),(170224,4729,'fi','Tarkistettu',0),(170225,4729,'no','Revidert',0),(170226,4729,'da','Revideret',0),(170227,4729,'ko','ê°œì •',0),(170228,4729,'he','×ª×•×§×Ÿ',0),(170229,4729,'el','Î‘Î½Î±Î¸ÎµÏ‰ÏÎ·Î¼Î­Î½Î·',0),(170230,4729,'zh','ä¿®æ”¹\r\n',0),(170231,4729,'sv','Reviderad',0),(170232,4729,'it','Rivisto',0),(170233,4729,'tl','',0),(170234,4729,'th','&#3649;&#3585;&#3657;&#3652;&#3586;',0),(170235,4729,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤',0),(170236,4729,'ms','Disemak semula',0),(170237,4729,'ar','Ø§Ù„Ù…Ù†Ù‚Ø­Ø©',0),(170238,4729,'fr','RÃ©visÃ©',0),(170239,4729,'jp','è¨‚æ­£æ¸ˆ',0),(170240,4729,'pt','Revista',0),(170241,4729,'ru','ÐŸÐµÑ€ÐµÑÐ¼Ð¾Ñ‚Ñ€ÐµÐ½Ð½Ñ‹Ð¹',0),(170242,4729,'es','Revisado',0),(170243,4729,'de','Ãœberarbeitet',0),(170244,4729,'en','Revised',0),(170245,4730,'is','',0),(170246,4730,'dr','Ù…Ø³ÙŠØ± ÙŠØ§Ø¨ÙŠ',0),(170247,4730,'pr','Ù…Ø³ÙŠØ± ÙŠØ§Ø¨ÙŠ',0),(170248,4730,'tr','YÃ¶nlendirme',0),(170249,4730,'pl','Routingu',0),(170250,4730,'bg','ÐœÐ°Ñ€ÑˆÑ€ÑƒÑ‚',0),(170251,4730,'ur','Ø±ÙˆÙ¹ Ø¨Ù†Ø¯ÛŒ',0),(170252,4730,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¸ Ð¿Ð¾ÑÑ‚ÑƒÐ¿Ð°Ðº',0),(170253,4730,'vi','Lá»™ trÃ¬nh',0),(170254,4730,'af','Routing',0),(170255,4730,'ro','Rutare',0),(170256,4730,'et','Marsruut',0),(170257,4730,'si','Usmerjanje',0),(170258,4730,'ba','Routing',0),(170259,4730,'nl','Routering',0),(170260,4730,'fi','Reititys',0),(170261,4730,'no','Ruting',0),(170262,4730,'da','Routing',0),(170263,4730,'ko','ë¼ìš°íŒ…',0),(170264,4730,'he','× ×™×ª×•×‘',0),(170265,4730,'el','Î”ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(170266,4730,'zh','è·¯å¾„\r\n',0),(170267,4730,'sv','Routning',0),(170268,4730,'it','Routing',0),(170269,4730,'tl','',0),(170270,4730,'th','Routing',0),(170271,4730,'hi','à¤°à¥‚à¤Ÿà¤¿à¤‚à¤—',0),(170272,4730,'ms','Penghalaan',0),(170273,4730,'ar','Ø§Ù„ØªÙˆØ¬ÙŠÙ‡',0),(170274,4730,'fr','Routage',0),(170275,4730,'jp','ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°',0),(170276,4730,'pt','Roteamento',0),(170277,4730,'ru','ÐœÐ°Ñ€ÑˆÑ€ÑƒÑ‚Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(170278,4730,'es','Routing',0),(170279,4730,'de','Routing',0),(170280,4730,'en','Routing',0),(170281,4731,'is','',0),(170282,4731,'dr','Ø³Ø±Ø¹Øª Ø§Ø±Ø³Ø§Ù„',0),(170283,4731,'pr','Ø³Ø±Ø¹Øª Ø§Ø±Ø³Ø§Ù„',0),(170284,4731,'tr','YÃ¶nlendirme Rush',0),(170285,4731,'pl','Rush routingu',0),(170286,4731,'bg','Ð¢Ñ€ÐµÑÐºÐ° Ð·Ð° Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(170287,4731,'ur','Ø±ÙˆÙ¹ Ø¨Ù†Ø¯ÛŒ Ø±Ø´',0),(170288,4731,'sr','Ð ÑƒÑÑ… Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¾Ð³ Ð¿Ð¾ÑÑ‚ÑƒÐ¿ÐºÐ°',0),(170289,4731,'vi','Äá»‹nh tuyáº¿n vá»™i',0),(170290,4731,'af','Stormloop Routing',0),(170291,4731,'ro','Rush de rutare',0),(170292,4731,'et','Marsruudi kiirustada',0),(170293,4731,'si','Rush, usmerjanje',0),(170294,4731,'ba','Rush Routing',0),(170295,4731,'nl','Rush routering',0),(170296,4731,'fi','Rush reititys',0),(170297,4731,'no','Rush ruting',0),(170298,4731,'da','Rush Routing',0),(170299,4731,'ko','ëŸ¬ì‰¬ ë¼ìš°íŒ…',0),(170300,4731,'he','×”×¢×•×ž×¡ × ×™×ª×•×‘',0),(170301,4731,'el','Î’Î¹Î±ÏƒÏÎ½Î· Î´ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(170302,4731,'zh','å¿™æ—¶è·¯å¾„\r\n',0),(170303,4731,'sv','Rush-Routning',0),(170304,4731,'it','Rush di Routing',0),(170305,4731,'tl','',0),(170306,4731,'th','&#3585;&#3634;&#3619;&#3623;&#3634;&#3591;&#3648;&#3626;&#3657;&#3609;&#3607;&#3634;&#3591;&#3607;&#3637;&#3656;&#3648;&#3619;&#3656;&#3591;&#3619;&#3637;&#3610;',0),(170307,4731,'hi','à¤°à¥‚à¤Ÿà¤¿à¤‚à¤— à¤°à¤¶',0),(170308,4731,'ms','Tergesa-gesa penghalaan',0),(170309,4731,'ar','Ø±Ø§Ø´ Ø§Ù„ØªÙˆØ¬ÙŠÙ‡',0),(170310,4731,'fr','Rush routage',0),(170311,4731,'jp','æ€¥è¡Œãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°',0),(170312,4731,'pt','Rush roteamento',0),(170313,4731,'ru','ÐŸÐ¸Ðº Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(170314,4731,'es','Routing RÃ¡pida',0),(170315,4731,'de','Rush Routing',0),(170316,4731,'en','Rush Routing',0),(170317,4732,'is','',0),(170318,4732,'dr','Ø­Ù…Ù„ Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(170319,4732,'pr','Ø­Ù…Ù„ Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(170320,4732,'tr','Stok stoktan sevk',0),(170321,4732,'pl','Statek z zapasÃ³w magazynowych',0),(170322,4732,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚ ÑÐºÐ»Ð°Ð´ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(170323,4732,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø³Ù¹Ø§Ú© Ø³Û’ Ø¬ÛØ§Ø²',0),(170324,4732,'sr','Ð‘Ñ€Ð¾Ð´ ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(170325,4732,'vi','Váº­n Chuyá»ƒn Tá»« HÃ ng Trong Kho',0),(170326,4732,'af','Versending vanaf Invetaris Voorraad',0),(170327,4732,'ro','Nava de la valori de inventar',0),(170328,4732,'et','Laeva varude laost',0),(170329,4732,'si','Ladja iz popisa zaloge',0),(170330,4732,'ba','Kapal dari inventarisasi Stock',0),(170331,4732,'nl','Schip uit inventaris voorraad',0),(170332,4732,'fi','Aluksen varasto varastosta',0),(170333,4732,'no','Skip fra lager lager',0),(170334,4732,'da','Skib fra lager lager',0),(170335,4732,'ko','ìž¬ê³  ìž¬ê³ ì—ì„œ ë°°',0),(170336,4732,'he','×”×¡×¤×™× ×” ×©×œ ×ž×œ××™ ×”×ž× ×™×•×ª',0),(170337,4732,'el','Î Î»Î¿Î¯Î¿ Î±Ï€ÏŒ Ï„Î± Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î± Ï„Î·Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(170338,4732,'zh','ä»Žåº“å­˜çŽ°è´§ä¸­è¿é€\r\n',0),(170339,4732,'sv','Levereras frÃ¥n lager lager',0),(170340,4732,'it','Nave da Stock di magazzino',0),(170341,4732,'tl','',0),(170342,4732,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3592;&#3634;&#3585;&#3626;&#3605;&#3658;&#3629;&#3588;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(170343,4732,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥‡ à¤œà¤¹à¤¾à¤œ',0),(170344,4732,'ms','Kapal dari stok inventori',0),(170345,4732,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù…Ù† Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(170346,4732,'fr','ExpÃ©dier de l\'inventaire Stock',0),(170347,4732,'jp','åœ¨åº«ã?‹ã‚‰ç™ºé€?ã?™ã‚‹',0),(170348,4732,'pt','O navio de estoque de inventÃ¡rio',0),(170349,4732,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¸Ð· Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(170350,4732,'es','Enviar de Stock de Inventario',0),(170351,4732,'de','Schiff ab Lager Lager',0),(170352,4732,'en','Ship from Inventory Stock',0),(170353,4733,'is','',0),(170354,4733,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ÙˆÙŠÚ˜Ù‡',0),(170355,4733,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ÙˆÙŠÚ˜Ù‡',0),(170356,4733,'tr','Ã–zel talimatlar',0),(170357,4733,'pl','Specjalne instrukcje',0),(170358,4733,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(170359,4733,'ur','Ø®ØµÙˆØµÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(170360,4733,'sr','ÐŸÐ¾ÑÐµÐ±Ð½Ð° ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(170361,4733,'vi','Chá»‰ dáº«n Ä‘áº·c biá»‡t',0),(170362,4733,'af','Spesiale Instruksies',0),(170363,4733,'ro','InstrucÅ£iuni speciale',0),(170364,4733,'et','Erijuhised',0),(170365,4733,'si','Posebna navodila',0),(170366,4733,'ba','Instruksi khusus',0),(170367,4733,'nl','Speciale instructies',0),(170368,4733,'fi','Erityisohjeet',0),(170369,4733,'no','Spesielle instruksjoner',0),(170370,4733,'da','SÃ¦rlige instruktioner',0),(170371,4733,'ko','íŠ¹ë³„ ì§€ì¹¨',0),(170372,4733,'he','×”×•×¨××•×ª ×ž×™×•×—×“×•×ª',0),(170373,4733,'el','Î•Î¹Î´Î¹ÎºÎ­Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(170374,4733,'zh','ç‰¹æ®Šè¯´æ˜Ž\r\n',0),(170375,4733,'sv','SÃ¤rskilda instruktioner',0),(170376,4733,'it','Istruzioni speciali',0),(170377,4733,'tl','',0),(170378,4733,'th','&#3588;&#3635;&#3649;&#3609;&#3632;&#3609;&#3635;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(170379,4733,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(170380,4733,'ms','Arahan khas',0),(170381,4733,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø®Ø§ØµØ©',0),(170382,4733,'fr','Instructions spÃ©ciales',0),(170383,4733,'jp','ã‚¹ãƒšã‚·ãƒ£ãƒ«ã‚¤ãƒ³ã‚¹ãƒˆãƒ©ã‚¯ã‚·ãƒ§ãƒ³',0),(170384,4733,'pt','InstruÃ§Ãµes especiais',0),(170385,4733,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(170386,4733,'es','Instrucciones Especiales',0),(170387,4733,'de','Besondere Anweisungen',0),(170388,4733,'en','Special Instructions',0),(170389,4734,'is','',0),(170390,4734,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙˆÙŠÚ˜Ù‡',0),(170391,4734,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙˆÙŠÚ˜Ù‡',0),(170392,4734,'tr','Ã–zel Not',0),(170393,4734,'pl','Uwaga specjalna',0),(170394,4734,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð° Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(170395,4734,'ur','Ø®ØµÙˆØµÛŒ Ù†ÙˆÙ¹',0),(170396,4734,'sr','ÐŸÐ¾ÑÐµÐ±Ð½Ðµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(170397,4734,'vi','Ghi chÃº Ä‘áº·c biá»‡t',0),(170398,4734,'af','Spesiale Nota',0),(170399,4734,'ro','NotÄƒ specialÄƒ',0),(170400,4734,'et','Eriline MÃ¤rkus',0),(170401,4734,'si','Posebna Opomba',0),(170402,4734,'ba','Catatan Khusus',0),(170403,4734,'nl','Speciale opmerking',0),(170404,4734,'fi','Erityinen huomautus',0),(170405,4734,'no','Spesiell merknad',0),(170406,4734,'da','Special Note',0),(170407,4734,'ko','íŠ¹ë³„ í•œ ì£¼',0),(170408,4734,'he','×”×¢×¨×” ×ž×™×•×—×“×ª',0),(170409,4734,'el','Î•Î¹Î´Î¹ÎºÎ® Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(170410,4734,'zh','ç‰¹åˆ«æç¤º\r\n',0),(170411,4734,'sv','SÃ¤rskild anmÃ¤rkning',0),(170412,4734,'it','Nota speciale',0),(170413,4734,'tl','',0),(170414,4734,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(170415,4734,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤§à¥à¤¯à¤¾à¤¨ à¤¦à¥‡à¤‚',0),(170416,4734,'ms','Nota Khas',0),(170417,4734,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø®Ø§ØµØ©',0),(170418,4734,'fr','Note spÃ©ciale',0),(170419,4734,'jp','ã‚¹ãƒšã‚·ãƒ£ãƒ«ãƒ¡ãƒ¢',0),(170420,4734,'pt','Nota especial',0),(170421,4734,'ru','ÐžÑÐ¾Ð±Ð°Ñ Ð—Ð°Ð¼ÐµÑ‚ÐºÐ°',0),(170422,4734,'es','Nota Especial',0),(170423,4734,'de','Besonderer Hinweis',0),(170424,4734,'en','Special Note',0),(170425,4735,'is','',0),(170426,4735,'dr','Ù‚Ø³Ù…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(170427,4735,'pr','Ù‚Ø³Ù…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(170428,4735,'tr','Borsa bÃ¶lÃ¼mÃ¼',0),(170429,4735,'pl','CzÄ™Å›Ä‡ zapasÃ³w',0),(170430,4735,'bg','Ð‘Ð¾Ñ€ÑÐ¾Ð²Ð° Ñ‡Ð°ÑÑ‚',0),(170431,4735,'ur','Ø§Ø³Ù¹Ø§Ú© Ø­ØµÛ',0),(170432,4735,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ð´ÐµÐ¾',0),(170433,4735,'vi','Phá»¥ tÃ¹ng HÃ ng tá»“n',0),(170434,4735,'af','Voorraad deel',0),(170435,4735,'ro','Stoc parte',0),(170436,4735,'et','Varude osas',0),(170437,4735,'si','Del zalog',0),(170438,4735,'ba','Stock Part',0),(170439,4735,'nl','Voorraad deel',0),(170440,4735,'fi','Kaluston osa',0),(170441,4735,'no','Lager del',0),(170442,4735,'da','Stock del',0),(170443,4735,'ko','ìž¬ê³  ë¶€í’ˆ',0),(170444,4735,'he','×—×œ×§ ×ž× ×™×•×ª',0),(170445,4735,'el','Î‘Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î¼Î­ÏÎ¿Ï‚',0),(170446,4735,'zh','åº“å­˜éƒ¨åˆ†\r\n',0),(170447,4735,'sv','Lager del',0),(170448,4735,'it','Magazzino parte',0),(170449,4735,'tl','',0),(170450,4735,'th','&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(170451,4735,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤­à¤¾à¤—',0),(170452,4735,'ms','Bahagian saham',0),(170453,4735,'ar','Ø¬Ø²Ø¡ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(170454,4735,'fr','Partie de stock',0),(170455,4735,'jp','åœ¨åº«éƒ¨å“?',0),(170456,4735,'pt','Parte das aÃ§Ãµes',0),(170457,4735,'ru','Ð§Ð°ÑÑ‚ÑŒ Ð°ÐºÑ†Ð¸Ð¹',0),(170458,4735,'es','Parte de Stock',0),(170459,4735,'de','Hat Teil',0),(170460,4735,'en','Stock Part',0),(170461,4736,'is','',0),(170462,4736,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(170463,4736,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(170464,4736,'tr','Stok boyutu',0),(170465,4736,'pl','WielkoÅ›ci stada',0),(170466,4736,'bg','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(170467,4736,'ur','Ø§Ø³Ù¹Ø§Ú© Ø­Ø¬Ù…',0),(170468,4736,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(170469,4736,'vi','Cá»¡ HÃ ng tá»“n',0),(170470,4736,'af','Voorraad Grootte',0),(170471,4736,'ro','Stoc dimensiune',0),(170472,4736,'et','Varude suurust',0),(170473,4736,'si','Osnovna velikost',0),(170474,4736,'ba','Ukuran saham',0),(170475,4736,'nl','Voorraad grootte',0),(170476,4736,'fi','Kannan koon',0),(170477,4736,'no','Lager stÃ¸rrelse',0),(170478,4736,'da','BestandsstÃ¸rrelse',0),(170479,4736,'ko','ì‚¬ì§„ í¬ê¸°',0),(170480,4736,'he','×’×•×“×œ ×ž×œ××™',0),(170481,4736,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(170482,4736,'zh','åº“å­˜é‡\r\n',0),(170483,4736,'sv','BestÃ¥ndets storlek',0),(170484,4736,'it','Dimensioni del materiale grezzo',0),(170485,4736,'tl','',0),(170486,4736,'th','&#3586;&#3609;&#3634;&#3604;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(170487,4736,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(170488,4736,'ms','Stok saiz',0),(170489,4736,'ar','Ø­Ø¬Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(170490,4736,'fr','Taille du stock',0),(170491,4736,'jp','åœ¨åº«ã‚µã‚¤ã‚º',0),(170492,4736,'pt','Tamanho conservado em estoque',0),(170493,4736,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(170494,4736,'es','TamaÃ±o de PropÃ³sito de Stock',0),(170495,4736,'de','BestandsgrÃ¶ÃŸe',0),(170496,4736,'en','Stock Size',0),(170497,4737,'is','',0),(170498,4737,'dr','(Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ†',0),(170499,4737,'pr','ÙØ¹Ø§Ù„ÙŠØª ÙØ±Ø¹ÙŠ (Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ†',0),(170500,4737,'tr','Alt etkinlik',0),(170501,4737,'pl','Sub-dziaÅ‚alnoÅ›Ä‡',0),(170502,4737,'bg','ÐŸÐ¾Ð´-Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(170503,4737,'ur','Ø°ÛŒÙ„ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(170504,4737,'sr','ÐŸÐ¾Ð´-Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(170505,4737,'vi','HÃ nh Ä‘á»™ng phu',0),(170506,4737,'af','Sub-Aktiwiteit',0),(170507,4737,'ro','Sub-activitate',0),(170508,4737,'et','Alam-tegevus',0),(170509,4737,'si','Sub-dejavnost',0),(170510,4737,'ba','Aktivitas sub',0),(170511,4737,'nl','Sub activiteit',0),(170512,4737,'fi','Osa toimintaa',0),(170513,4737,'no','Sub aktivitet',0),(170514,4737,'da','Sub aktivitet',0),(170515,4737,'ko','í•˜ìœ„ ë™ìž‘',0),(170516,4737,'he','×ª×ª ×¤×¢×™×œ×•×ª',0),(170517,4737,'el','Î¥Ï€Î¿-Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(170518,4737,'zh','å°ç»„æ´»åŠ¨\r\n',0),(170519,4737,'sv','Verksamhetsdel',0),(170520,4737,'it','Sub-attivitÃ ',0),(170521,4737,'tl','',0),(170522,4737,'th','&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(170523,4737,'hi','à¤‰à¤ª à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(170524,4737,'ms','Sub aktiviti',0),(170525,4737,'ar','Ø§Ù„Ù†Ø´Ø§Ø· Ø§Ù„ÙØ±Ø¹ÙŠ',0),(170526,4737,'fr','Sous-activitÃ©',0),(170527,4737,'jp','ã‚µãƒ–ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£',0),(170528,4737,'pt','Atividade',0),(170529,4737,'ru','ÐŸÐ¾Ð´Ð²Ð¸Ð´ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(170530,4737,'es','Sub-Actividad',0),(170531,4737,'de','Sub-Activity',0),(170532,4737,'en','Sub-Activity',0),(170533,4738,'is','',0),(170534,4738,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø§ØµÙ„ÙŠ Ù‡Ø§',0),(170535,4738,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø§ØµÙ„ÙŠ Ù‡Ø§',0),(170536,4738,'tr','Toplam orijinalleri',0),(170537,4738,'pl','CaÅ‚kowita oryginaÅ‚y',0),(170538,4738,'bg','ÐžÐ±Ñ‰Ð¾ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸Ñ‚Ðµ',0),(170539,4738,'ur','Ú©Ù„ Ø§ØµÙ„',0),(170540,4738,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ðµ',0),(170541,4738,'vi','Tá»•ng cá»™ng gá»‘c',0),(170542,4738,'af','Totale Oorspronklikes',0),(170543,4738,'ro','Total originale',0),(170544,4738,'et','Kokku originaalid',0),(170545,4738,'si','Skupno originali',0),(170546,4738,'ba','Total aslinya',0),(170547,4738,'nl','Totale originelen',0),(170548,4738,'fi','YhteensÃ¤ alkuperÃ¤iset',0),(170549,4738,'no','Totalt originaler',0),(170550,4738,'da','Samlede originaler',0),(170551,4738,'ko','ì´ ì›ë³¸',0),(170552,4738,'he','×¡×” ×› ×”×ž×§×•×¨×™×™×',0),(170553,4738,'el','Î£ÏÎ½Î¿Î»Î¿ Ï€ÏÏ‰Ï„Î¿Ï„ÏÏ€Ï‰Î½',0),(170554,4738,'zh','å…±æœ‰æ­£æœ¬\r\n',0),(170555,4738,'sv','Totala originalen',0),(170556,4738,'it','Totali originali',0),(170557,4738,'tl','',0),(170558,4738,'th','&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(170559,4738,'hi','à¤•à¥à¤² à¤®à¥‚à¤²',0),(170560,4738,'ms','Jumlah asal',0),(170561,4738,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø£ØµÙˆÙ„',0),(170562,4738,'fr','Total originaux',0),(170563,4738,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«å?ˆè¨ˆ',0),(170564,4738,'pt','Totais originais',0),(170565,4738,'ru','Ð’ÑÐµÐ³Ð¾ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ñ‹',0),(170566,4738,'es','Total Originales',0),(170567,4738,'de','Total Originals',0),(170568,4738,'en','Total Originals',0),(170569,4739,'is','',0),(170570,4739,'dr','ÙˆÙ‚ØªÙŠ Ù‡Ø± Ø¨Ø®Ø´ ÙƒØ§Ø±Ø´ Ø±Ø§ ÙƒØ§Ù…Ù„ ÙƒÙ†Ø¯ ',0),(170571,4739,'pr','ÙˆÙ‚ØªÙŠ Ù‡Ø± Ø¨Ø®Ø´ ÙƒØ§Ø±Ø´ Ø±Ø§ ÙƒØ§Ù…Ù„ ÙƒÙ†Ø¯ ',0),(170572,4739,'tr','Her bÃ¶lÃ¼mÃ¼n gÃ¶revlerini tamamladÄ±ÄŸÄ±nda',0),(170573,4739,'pl','Po kaÅ¼dym departamencie zakoÅ„czeniu zadaÅ„',0),(170574,4739,'bg','ÐšÐ¾Ð³Ð°Ñ‚Ð¾ Ð²ÑÐµÐºÐ¸ Ð¾Ñ‚Ð´ÐµÐ» Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸ Ð·Ð°Ð´Ð°Ñ‡Ð¸',0),(170575,4739,'ur','Ø¬Ø¨ ÛØ± Ø´Ø¹Ø¨Û Ù…Ø¬Ù…ÙˆØ¹Û Ú©Ø§Ø± Ù…Ú©Ù…Ù„ Ú©Ø±ØªØ§ ÛÛ’ Û”',0),(170576,4739,'sr','ÐšÐ°Ð´Ð° Ñ˜Ðµ ÑÐ²Ð°ÐºÐ¾ Ð¾Ð´ÐµÑ™ÐµÑšÐµ Ð´Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð° Ð·Ð°Ð´Ð°Ñ‚ÐºÐµ',0),(170577,4739,'vi','Khi má»—i phÃ²ng ban hoÃ n táº¥t nhiá»‡m vá»¥',0),(170578,4739,'af','Wanneer Elke Departement Take Voltooi',0),(170579,4739,'ro','CÃ¢nd fiecare departament completeazÄƒ sarcini',0),(170580,4739,'et','Kui kÃµik osakonnad lÃµpetavad Ã¼lesande',0),(170581,4739,'si','Ko vsak oddelek dokonÄa naloge',0),(170582,4739,'ba','Ketika masing-masing departemen menyelesaikan',0),(170583,4739,'nl','Wanneer elke afdeling taken voltooit',0),(170584,4739,'fi','Kun kukin osasto suorittaa tehtÃ¤vÃ¤t',0),(170585,4739,'no','NÃ¥r hver avdeling fullfÃ¸rer oppgaver',0),(170586,4739,'da','NÃ¥r hver afdeling fuldfÃ¸rer opgaver',0),(170587,4739,'ko','ê° ë¶€ì„œ ìž‘ì—…ì„ ì™„ë£Œ í•˜ëŠ” ë•Œ',0),(170588,4739,'he','×›××©×¨ ×›×œ ×ž×—×œ×§×” ×•×”×ž×©×œ×™× ×¤×¢×™×œ×•×™×•×ª',0),(170589,4739,'el','ÎŒÏ„Î±Î½ ÎºÎ¬Î¸Îµ Ï„Î¼Î®Î¼Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ½ÎµÎ¹ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚',0),(170590,4739,'zh','å½“æ¯ä¸ªéƒ¨é—¨å®Œæˆä»»åŠ¡\r\n',0),(170591,4739,'sv','NÃ¤r varje avdelning SlutfÃ¶r uppgifter',0),(170592,4739,'it','Quando ogni reparto completa compiti',0),(170593,4739,'tl','',0),(170594,4739,'th','&#3648;&#3617;&#3639;&#3656;&#3629;&#3649;&#3605;&#3656;&#3621;&#3632;&#3627;&#3609;&#3656;&#3623;&#3618;&#3591;&#3634;&#3609;&#3607;&#3635;&#3591;&#3634;&#3609;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(170595,4739,'hi','à¤œà¤¬ à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤µà¤¿à¤­à¤¾à¤— à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥‚à¤°à¥à¤£ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(170596,4739,'ms','Bilakah Jabatan setiap selesai tugas',0),(170597,4739,'ar','Ø¹Ù†Ø¯ Ø§ÙƒØªÙ…Ø§Ù„ ÙƒÙ„ Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ù…Ù‡Ø§Ù…',0),(170598,4739,'fr','Lorsque chaque dÃ©partement termine tÃ¢ches',0),(170599,4739,'jp','ã??ã‚Œã?žã‚Œã?®éƒ¨é–€ã?Œä½œæ¥­ã‚’å®Œäº†ã?—ã?Ÿæ™‚',0),(170600,4739,'pt','Quando cada departamento conclui tarefas',0),(170601,4739,'ru','ÐšÐ¾Ð³Ð´Ð° ÐºÐ°Ð¶Ð´Ñ‹Ð¹ Ð¾Ñ‚Ð´ÐµÐ» Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÑÐµÑ‚ Ð·Ð°Ð´Ð°Ñ‡Ð¸',0),(170602,4739,'es','Cuando Cada Departamento Completa las Tareas',0),(170603,4739,'de','Wenn jede Abteilung Aufgaben abgeschlossen ist',0),(170604,4739,'en','When Each Department Completes Tasks',0),(170605,4740,'is','',0),(170606,4740,'dr','Ú†Ø§Ù¾ Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(170607,4740,'pr','Ú†Ø§Ù¾ Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(170608,4740,'tr','Ã–ÄŸeleri kategoriye YazdÄ±r',0),(170609,4740,'pl','Drukowanie kategorii elementÃ³w',0),(170610,4740,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(170611,4740,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ø²Ù…Ø±Û',0),(170612,4740,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(170613,4740,'vi','In thá»ƒ loáº¡i hÃ ng',0),(170614,4740,'af','Druk Items KategoriÃ«',0),(170615,4740,'ro','Imprima elemente categorie',0),(170616,4740,'et','Prindi kirjed kategooria',0),(170617,4740,'si','Tiskanje elementov Kategorija',0),(170618,4740,'ba','Mencetak item kategori',0),(170619,4740,'nl','Items categorie afdrukken',0),(170620,4740,'fi','Tulostaa Items luokka',0),(170621,4740,'no','Skrive ut Items kategori',0),(170622,4740,'da','Udskrive poster kategori',0),(170623,4740,'ko','ì¸ì‡„ í•­ëª© ë²”ì£¼',0),(170624,4740,'he','×”×“×¤×¡ ×§×˜×’×•×¨×™×™×ª ×¤×¨×™×˜×™×',0),(170625,4740,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÎ¯Î´Î· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(170626,4740,'zh','æ‰“å°é¡¹ç›®åˆ†ç±»\r\n',0),(170627,4740,'sv','Skriva ut artiklar kategori',0),(170628,4740,'it','Categoria Articoli stampa',0),(170629,4740,'tl','',0),(170630,4740,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(170631,4740,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(170632,4740,'ms','Kategori barangan cetakan',0),(170633,4740,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¹Ù†Ø§ØµØ± Ø§Ù„ÙØ¦Ø©',0),(170634,4740,'fr','Imprimer les articles catÃ©gorie',0),(170635,4740,'jp','å“?ç›®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®å?°åˆ·',0),(170636,4740,'pt','Imprimir itens de categoria',0),(170637,4740,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(170638,4740,'es','Imprimir CategorÃ­a de Items',0),(170639,4740,'de','Drucken Kategorie Objekte',0),(170640,4740,'en','Print Items Category',0),(170641,4741,'is','',0),(170642,4741,'dr','Ø³Ø·Ø­ Ú¯Ø±ÙˆÙ‡',0),(170643,4741,'pr','Ø³Ø·Ø­ Ú¯Ø±ÙˆÙ‡',0),(170644,4741,'tr','Kategori dÃ¼zeyi',0),(170645,4741,'pl','Poziom kategorii',0),(170646,4741,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð½Ð¸Ð²Ð¾',0),(170647,4741,'ur','Ø²Ù…Ø±Û Ú©ÛŒ Ø³Ø·Ø­',0),(170648,4741,'sr','ÐÐ¸Ð²Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(170649,4741,'vi','Má»©c thá»ƒ loáº¡i',0),(170650,4741,'af','Kategorie Vlak',0),(170651,4741,'ro','Categorie nivel',0),(170652,4741,'et','Katekooria tase',0),(170653,4741,'si','Â«RavenÂ» Kategorija',0),(170654,4741,'ba','Kategori tingkat',0),(170655,4741,'nl','Categorie niveau',0),(170656,4741,'fi','Luokka-taso',0),(170657,4741,'no','NivÃ¥',0),(170658,4741,'da','Kategoriniveau',0),(170659,4741,'ko','ë²”ì£¼ ìˆ˜ì¤€',0),(170660,4741,'he','×§×˜×’×•×¨×™×” ×¨×ž×ª',0),(170661,4741,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÏ€Î¯Ï€ÎµÎ´Î¿',0),(170662,4741,'zh','ç±»åˆ«å±‚æ¬¡\r\n',0),(170663,4741,'sv','KategorinivÃ¥',0),(170664,4741,'it','Livello di categoria',0),(170665,4741,'tl','',0),(170666,4741,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(170667,4741,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¥à¤¤à¤°',0),(170668,4741,'ms','Aras kategori',0),(170669,4741,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„ØªØµÙ†ÙŠÙ',0),(170670,4741,'fr','Niveau de catÃ©gorie',0),(170671,4741,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ãƒ¬ãƒ™ãƒ«',0),(170672,4741,'pt','NÃ­vel de categoria',0),(170673,4741,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(170674,4741,'es','CategorÃ­a Nivel',0),(170675,4741,'de','Kategorieebene',0),(170676,4741,'en','Category Level',0),(170677,4742,'is','',0),(170678,4742,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø¬Ø³ØªØ¬ÙˆÙŠ ÙØ¹Ù„ÙŠ  Ùˆ Ø³Ø·ÙˆØ­ ',0),(170679,4742,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø¬Ø³ØªØ¬ÙˆÙŠ ÙØ¹Ù„ÙŠ  Ùˆ Ø³Ø·ÙˆØ­ ',0),(170680,4742,'tr','GeÃ§erli arama kategorileri ve dÃ¼zeyleri',0),(170681,4742,'pl','Aktualne kategorie wyszukiwania i poziomÃ³w',0),(170682,4742,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¸ Ð½Ð¸Ð²Ð°',0),(170683,4742,'ur','Ø­Ø§Ù„ÛŒÛ ØªÙ„Ø§Ø´ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù… Ø§ÙˆØ± Ø¯Ø±Ø¬Ø§Øª',0),(170684,4742,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð¸ Ð½Ð¸Ð²Ð¾Ð°',0),(170685,4742,'vi','Thá»ƒ loáº¡i & má»©c tÃ¬m kiáº¿m hiá»‡n thá»i ',0),(170686,4742,'af','Huidige Soektog vir KategoriÃ« en Vlakke',0),(170687,4742,'ro','Curent CÄƒutaÅ£i categorii ÅŸi niveluri de',0),(170688,4742,'et','Praegune otsing kategooria ja tasemed',0),(170689,4742,'si','Trenutno iskanje kategorije in ravni',0),(170690,4742,'ba','Kategori dan Tingkatan Pencarian Terkini',0),(170691,4742,'nl','Huidige zoekcategorieÃ«n en niveaus',0),(170692,4742,'fi','Nykyinen Etsi luokat ja tasot',0),(170693,4742,'no','Gjeldende kategorier og nivÃ¥er',0),(170694,4742,'da','NuvÃ¦rende ransage kategorier og niveauer',0),(170695,4742,'ko','í˜„ìž¬ ê²€ìƒ‰ ë²”ì£¼ ë° ìˆ˜ì¤€',0),(170696,4742,'he','×§×˜×’×•×¨×™×•×ª ×”×—×™×¤×•×© ×”× ×•×›×—×™ ×•×¨×ž×•×ª',0),(170697,4742,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ ÎºÎ±Î¹ Ï„Î± ÎµÏ€Î¯Ï€ÎµÎ´Î±',0),(170698,4742,'zh','å½“å‰æœç´¢ç±»åˆ«å’Œç­‰çº§\r\n',0),(170699,4742,'sv','Nuvarande sÃ¶kning kategorier och nivÃ¥er',0),(170700,4742,'it','Livelli e categorie di ricerca corrente',0),(170701,4742,'tl','',0),(170702,4742,'th','&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;&#3621;&#3635;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;&#3649;&#3621;&#3632;&#3619;&#3632;&#3604;&#3633;&#3610;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(170703,4742,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤–à¥‹à¤œ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤ à¤”à¤° à¤¸à¥à¤¤à¤°à¥‹à¤‚',0),(170704,4742,'ms','Semasa carian kategori dan peringkat',0),(170705,4742,'ar','ÙØ¦Ø§Øª Ø§Ù„Ø¨Ø­Ø« Ø§Ù„Ø­Ø§Ù„ÙŠØ© ÙˆÙ…Ø³ØªÙˆÙŠØ§Øª',0),(170706,4742,'fr','Niveaux et catÃ©gories actuelles de recherche',0),(170707,4742,'jp','ç?¾åœ¨ã?®æ¤œç´¢ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?¨ãƒ¬ãƒ™ãƒ«',0),(170708,4742,'pt','NÃ­veis e categorias de pesquisa atual',0),(170709,4742,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ ÐŸÐ¾Ð¸ÑÐº ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ Ð¸ Ð£Ñ€Ð¾Ð²Ð½ÐµÐ¹',0),(170710,4742,'es','CategorÃ­as y Niveles de Busqueda Actuales y ',0),(170711,4742,'de','Aktuelle Suche Kategorien und Ebenen',0),(170712,4742,'en','Current Search Categories and Levels',0),(170713,4743,'is','',0),(170714,4743,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ ',0),(170715,4743,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ ',0),(170716,4743,'tr','Arama Kategori adÄ±',0),(170717,4743,'pl','Szukaj nazwy kategorii',0),(170718,4743,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ð¸Ð¼Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(170719,4743,'ur','Ù‚Ø³Ù… Ú©Ø§ Ù†Ø§Ù… ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(170720,4743,'sr','Ð˜Ð¼Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ðµ',0),(170721,4743,'vi','TÃ¬m tÃªn thá»ƒ loáº¡i',0),(170722,4743,'af','Soek Kategorie Naam',0),(170723,4743,'ro','Numele de categorie cÄƒutare',0),(170724,4743,'et','Otsi kategooria nime',0),(170725,4743,'si','IÅ¡Äi ime kategorije',0),(170726,4743,'ba','Cari nama kategori',0),(170727,4743,'nl','Zoek de naam van de categorie',0),(170728,4743,'fi','Hae luokkanimi',0),(170729,4743,'no','SÃ¸k kategorinavn',0),(170730,4743,'da','SÃ¸g kategorinavn',0),(170731,4743,'ko','ê²€ìƒ‰ ë²”ì£¼ ì´ë¦„',0),(170732,4743,'he','×—×™×¤×•×© ×§×˜×’×•×¨×™×” ×©×',0),(170733,4743,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÏŒÎ½Î¿Î¼Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚',0),(170734,4743,'zh','æœç´¢ç±»åˆ«åç§°\r\n',0),(170735,4743,'sv','SÃ¶k kategorinamn',0),(170736,4743,'it','Ricerca nome categoria',0),(170737,4743,'tl','',0),(170738,4743,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3594;&#3639;&#3656;&#3629;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(170739,4743,'hi','à¤–à¥‹à¤œ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¨à¤¾à¤®',0),(170740,4743,'ms','Nama kategori carian',0),(170741,4743,'ar','Ø¥Ø³Ù… ØªØµÙ†ÙŠÙ Ø§Ù„Ø¨Ø­Ø«',0),(170742,4743,'fr','Nom de catÃ©gorie de recherche',0),(170743,4743,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼å??ã?®æ¤œç´¢',0),(170744,4743,'pt','Pesquisar por nome de categoria',0),(170745,4743,'ru','ÐŸÐ¾Ð¸ÑÐº ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ñ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(170746,4743,'es','Buscar Nombre de CategorÃ­a',0),(170747,4743,'de','Suche Kategoriename',0),(170748,4743,'en','Search Category Name',0),(170749,4744,'is','',0),(170750,4744,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø³ØªØ¬ÙˆÙŠ Ú¯Ø±ÙˆÙ‡',0),(170751,4744,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø³ØªØ¬ÙˆÙŠ Ú¯Ø±ÙˆÙ‡',0),(170752,4744,'tr','Arama kategorisi Ekle',0),(170753,4744,'pl','Dodaj kategoriÄ™',0),(170754,4744,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(170755,4744,'ur','Ø²Ù…Ø±Û ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(170756,4744,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ðµ',0),(170757,4744,'vi','ThÃªm TÃ¬m thá»ƒ loáº¡i',0),(170758,4744,'af','Soek Katergorie Byvoeg',0),(170759,4744,'ro','CÄƒutaÅ£i categorie Adauga',0),(170760,4744,'et','Otsingu kategooria lisamine',0),(170761,4744,'si','Dodaj kategorijo iskanja',0),(170762,4744,'ba','Tambahkan Kategori Cari',0),(170763,4744,'nl','Zoekcategorie toevoegen',0),(170764,4744,'fi','Etsi luokka lisÃ¤Ã¤',0),(170765,4744,'no','SÃ¸kekategori legge',0),(170766,4744,'da','SÃ¸gekategori tilfÃ¸je',0),(170767,4744,'ko','ê²€ìƒ‰ ì¹´í…Œê³ ë¦¬ ì¶”ê°€',0),(170768,4744,'he','×—×™×¤×•×© ×§×˜×’×•×¨×™×” ×œ×”×•×¡×™×£',0),(170769,4744,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(170770,4744,'zh','æœç´¢ç±»åˆ«æ·»åŠ \r\n',0),(170771,4744,'sv','SÃ¶kkategori LÃ¤gg till',0),(170772,4744,'it','Aggiungi categoria ricerca',0),(170773,4744,'tl','',0),(170774,4744,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(170775,4744,'hi','à¤–à¥‹à¤œ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(170776,4744,'ms','Tambah Kategori carian',0),(170777,4744,'ar','Ø¥Ø¶Ø§ÙØ© ØªØµÙ†ÙŠÙ Ø§Ù„Ø¨Ø­Ø«',0),(170778,4744,'fr','Ajouter catÃ©gorie de recherche',0),(170779,4744,'jp','è¿½åŠ ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®æ¤œç´¢',0),(170780,4744,'pt','Adicionar busca categoria',0),(170781,4744,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð¸ÑÐº Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(170782,4744,'es','Agregar CategorÃ­a de Busqueda',0),(170783,4744,'de','Suche Kategorie hinzufÃ¼gen',0),(170784,4744,'en','Search Category Add',0),(170785,4745,'is','',0),(170786,4745,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø¯ÙŠØ¯ ',0),(170787,4745,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø¯ÙŠØ¯ ',0),(170788,4745,'tr','Ekleme yeni',0),(170789,4745,'pl','Dodawanie nowych',0),(170790,4745,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸',0),(170791,4745,'ur','Ù†ÛŒØ§ Ø§Ø¶Ø§ÙÛ',0),(170792,4745,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾',0),(170793,4745,'vi','ThÃªm Má»›i',0),(170794,4745,'af','Nuwe Bywerking',0),(170795,4745,'ro','Adaugare nou',0),(170796,4745,'et','Lisan uut',0),(170797,4745,'si','Dodajanjem novih',0),(170798,4745,'ba','Penambahan Baru',0),(170799,4745,'nl','Toevoegen van nieuwe',0),(170800,4745,'fi','Uusia',0),(170801,4745,'no','Legge til nye',0),(170802,4745,'da','TilfÃ¸je nye',0),(170803,4745,'ko','ìƒˆë¡œìš´ ì¶”ê°€',0),(170804,4745,'he','×ž×•×¡×™×£ ×—×“×©',0),(170805,4745,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Ï‰Î½',0),(170806,4745,'zh','æ–°å¢žåŠ \r\n',0),(170807,4745,'sv','LÃ¤gga till nya',0),(170808,4745,'it','Aggiungi nuovo',0),(170809,4745,'tl','',0),(170810,4745,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(170811,4745,'hi','à¤¨à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(170812,4745,'ms','Menambah',0),(170813,4745,'ar','Ø¥Ø¶Ø§ÙØ© Ø¬Ø¯ÙŠØ¯',0),(170814,4745,'fr','Ajouter Nouveau',0),(170815,4745,'jp','æ–°è¦?è¿½åŠ ',0),(170816,4745,'pt','Adicionando novos',0),(170817,4745,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÐÐ¾Ð²Ð¾Ð³Ð¾',0),(170818,4745,'es','Agregando Nuevo',0),(170819,4745,'de','Neue hinzufÃ¼gen',0),(170820,4745,'en','Adding New',0),(170821,4746,'is','',0),(170822,4746,'dr','Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø²ÙŠØ±',0),(170823,4746,'pr','Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø²ÙŠØ±',0),(170824,4746,'tr','Ek iÃ§in alÄ±ntÄ± aÅŸaÄŸÄ±da',0),(170825,4746,'pl','Dodatkowe oferty poniÅ¼ej',0),(170826,4746,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð·Ð° Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ',0),(170827,4746,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø¶Ø§ÙÛŒ',0),(170828,4746,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ð·Ð° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð¸ÑÐ¿Ð¾Ð´',0),(170829,4746,'vi','Chi tiáº¿t thÃªm cho bÃ¡o giÃ¡ dÆ°á»›i Ä‘Ã¢y',0),(170830,4746,'af','Addisioneel vir Kwotasie wat volg',0),(170831,4746,'ro','Aditional pentru cotatia de mai jos',0),(170832,4746,'et','TÃ¤iendav pakkumine allpool',0),(170833,4746,'si','Dodatno za citiram spodaj',0),(170834,4746,'ba','Tambahan untuk penawaran dibawah',0),(170835,4746,'nl','Extra voor citaat hieronder',0),(170836,4746,'fi','LisÃ¤Ã¤ lainaus alla',0),(170837,4746,'no','Ekstra for sitatet nedenfor',0),(170838,4746,'da','Yderligere om tilbud nedenfor',0),(170839,4746,'ko','ì•„ëž˜ ê²¬ì ì— ëŒ€ í•œ ì¶”ê°€',0),(170840,4746,'he','× ×•×¡×¤×™× ×œ×”×¦×¢×ª ×œ×”×œ×Ÿ',0),(170841,4746,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Î³Î¹Î± Ï„Î·Î½ Ï€Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰',0),(170842,4746,'zh','å¢žåŠ ä»¥ä¸‹çš„æŠ¥ä»·\r\n',0),(170843,4746,'sv','Ytterligare fÃ¶r citatet nedan',0),(170844,4746,'it','Aggiuntive per la citazione qui sotto',0),(170845,4746,'tl','',0),(170846,4746,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;',0),(170847,4746,'hi','à¤¨à¥€à¤šà¥‡ à¤¦à¥€ à¤—à¤ˆ à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤',0),(170848,4746,'ms','Tambahan bagi quote di bawah',0),(170849,4746,'ar','Ø¥Ø¶Ø§ÙÙŠ Ù„Ù„Ø¹Ø±Ø¶ Ø£Ø¯Ù†Ø§Ù‡',0),(170850,4746,'fr','SupplÃ©mentaire pour Soumission Ci-Dessous',0),(170851,4746,'jp','ä¸‹è¨˜è¦‹ç©?ã‚Šã?¸ã?®è¿½åŠ ',0),(170852,4746,'pt','Adicionais para a citaÃ§Ã£o abaixo',0),(170853,4746,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÐºÐ²Ð¾Ñ‚Ñ‹ Ð½Ð¸Ð¶Ðµ',0),(170854,4746,'es','Adicional para cotizaciÃ³n abajo',0),(170855,4746,'de','ZusÃ¤tzlich Ã¼ber Zitat unten',0),(170856,4746,'en','Additional for quote below',0),(170857,4747,'is','',0),(170858,4747,'dr','Ù…Ù‚Ø§Ø¯ÙŠØ± Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(170859,4747,'pr','Ù…Ù‚Ø§Ø¯ÙŠØ± Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(170860,4747,'tr','Ek teklif miktarlarÄ±nÄ±',0),(170861,4747,'pl','Dodatkowe iloÅ›ci dla notowaÅ„',0),(170862,4747,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð·Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(170863,4747,'ur','Ø§Ø¶Ø§ÙÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø±Ø¬ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(170864,4747,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ Ð·Ð° Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(170865,4747,'vi','Sá»‘ LÆ°á»£ng ThÃªm Cho CÃ¡c BÃ¡o GiÃ¡ ',0),(170866,4747,'af','Adisionele Hoeveelhede vir Kwotasies',0),(170867,4747,'ro','Cantitati suplimentare pentru cotatii',0),(170868,4747,'et','TÃ¤iendavate koguste hinnapakkumisi',0),(170869,4747,'si','Dodatne koliÄine ponudbe',0),(170870,4747,'ba','Penambahan Jumlah Penawaran',0),(170871,4747,'nl','Bijkomende hoeveelheden voor citaten',0),(170872,4747,'fi','LisÃ¤mÃ¤Ã¤rien lainausmerkit',0),(170873,4747,'no','Tilleggsantall for tilbud',0),(170874,4747,'da','Yderligere mÃ¦ngder for citater',0),(170875,4747,'ko','ë”°ì˜´í‘œì— ëŒ€ í•œ ì¶”ê°€ ìˆ˜ëŸ‰',0),(170876,4747,'he','×›×ž×•×™×•×ª × ×•×¡×¤×•×ª ×¢×‘×•×¨ ×”×¦×¢×•×ª ×ž×—×™×¨',0),(170877,4747,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚, Î³Î¹Î± Ï„Î¹Ï‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ­Ï‚',0),(170878,4747,'zh','å¢žåŠ æ•°é‡çš„å ±åƒ¹\r\n',0),(170879,4747,'sv','Ytterligare mÃ¤ngder fÃ¶r citat',0),(170880,4747,'it','Quantitativi supplementari per citazioni',0),(170881,4747,'tl','',0),(170882,4747,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(170883,4747,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(170884,4747,'ms','Tambahan kuantiti bagi sebut harga',0),(170885,4747,'ar','ÙƒÙ…Ù‘ÙŠØ§Øª Ø¥Ø¶Ø§ÙÙŠØ© Ù„Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(170886,4747,'fr','QuantitÃ©s Additionelles pour Soumissions',0),(170887,4747,'jp','è¦‹ç©?ã‚Šã?¸ã?®è¿½åŠ æ•°é‡?',0),(170888,4747,'pt','Quantidades adicionais para citaÃ§Ãµes',0),(170889,4747,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¾Ð±ÑŠÐµÐ¼Ñ‹ Ð´Ð»Ñ ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(170890,4747,'es','Cantidades Adicionales para Cotizaciones',0),(170891,4747,'de','ZusÃ¤tzliche Mengen fÃ¼r Zitate',0),(170892,4747,'en','Additional Quantities for Quotes',0),(170893,4748,'is','',0),(170894,4748,'dr','( Ú¯Ø²Ø§Ø±Ø´Ø§Øª',0),(170895,4748,'pr','ÙƒØªØ§Ø¨Ù‡Ø§( Ú¯Ø²Ø§Ø±Ø´Ø§Øª',0),(170896,4748,'tr','Kitaplar',0),(170897,4748,'pl','KsiÄ…Å¼ki',0),(170898,4748,'bg','ÐšÐ½Ð¸Ð³Ð¸',0),(170899,4748,'ur','Ú©ØªØ§Ø¨ÛŒÚº',0),(170900,4748,'sr','ÐšÑšÐ¸Ð³Ðµ',0),(170901,4748,'vi','SÃ¡ch',0),(170902,4748,'af','Boeke',0),(170903,4748,'ro','Carti',0),(170904,4748,'et','Raamatud',0),(170905,4748,'si','Knjige',0),(170906,4748,'ba','Buku',0),(170907,4748,'nl','Boeken',0),(170908,4748,'fi','Kirjat',0),(170909,4748,'no','BÃ¸ker',0),(170910,4748,'da','BÃ¸ger',0),(170911,4748,'ko','ë„ ì„œ',0),(170912,4748,'he','×¡×¤×¨×™×',0),(170913,4748,'el','Î’Î¹Î²Î»Î¯Î±',0),(170914,4748,'zh','ä¹¦ç±\r\n',0),(170915,4748,'sv','BÃ¶cker',0),(170916,4748,'it','Libri',0),(170917,4748,'tl','',0),(170918,4748,'th','&#3610;&#3633;&#3597;&#3594;&#3637;',0),(170919,4748,'hi','à¤•à¤¿à¤¤à¤¾à¤¬à¥‡à¤‚',0),(170920,4748,'ms','Buku-buku',0),(170921,4748,'ar','Ø§Ù„ÙƒØªØ¨',0),(170922,4748,'fr','Livres',0),(170923,4748,'jp','æœ¬',0),(170924,4748,'pt','Livros',0),(170925,4748,'ru','ÐšÐ½Ð¸Ð³Ð¸',0),(170926,4748,'es','Libros',0),(170927,4748,'de','BÃ¼cher',0),(170928,4748,'en','Books',0),(170929,4749,'is','',0),(170930,4749,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ùˆ Ø°Ø®ÙŠØ±Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(170931,4749,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ùˆ Ø°Ø®ÙŠØ±Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(170932,4749,'tr','Hesaplamak ve teklif olarak kaydet',0),(170933,4749,'pl','Obliczenia i zapisaÄ‡ jako cytat',0),(170934,4749,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð¸ Ð—Ð°Ð¿Ð¸ÑˆÐ¸ ÐºÐ°Ñ‚Ð¾ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(170935,4749,'ur','Ø­Ø³Ø§Ø¨ Ø§ÙˆØ± Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(170936,4749,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ð¸ ÑÐ°Ñ‡ÑƒÐ²Ð°Ñ‚Ðµ ÐºÐ°Ð¾ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(170937,4749,'vi','TÃ­nh & sao lÆ°u nhÆ° bÃ¡o giÃ¡',0),(170938,4749,'af','Bereken en Stoor as Kwotasie',0),(170939,4749,'ro','Calcula ÅŸi de a salva ca citat',0),(170940,4749,'et','Arvutada ja salvestada Quote',0),(170941,4749,'si','IzraÄunajte in shranite kot citat',0),(170942,4749,'ba','Menghitung dan Simpan sebagai kutipan',0),(170943,4749,'nl','Berekenen en opslaan als Quote',0),(170944,4749,'fi','Laske ja tallenna tarjouspyynnÃ¶n',0),(170945,4749,'no','Beregne og lagre som tilbud',0),(170946,4749,'da','Beregne og gemme som citat',0),(170947,4749,'ko','ê³„ì‚° ë° ê²¬ì ìœ¼ë¡œ ì €ìž¥',0),(170948,4749,'he','×œ×—×©×‘ ×•×œ×©×ž×•×¨ ×›×§×•×‘×¥ ×”×¦×¢×ª ×ž×—×™×¨',0),(170949,4749,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ ÎºÎ±Î¹ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï‰Ï‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(170950,4749,'zh','è®¡ç®—å¹¶ä¿å­˜ä¸ºæŠ¥ä»·\r\n',0),(170951,4749,'sv','BerÃ¤kna och spara som citat',0),(170952,4749,'it','Calcolare e salvare come citazione',0),(170953,4749,'tl','',0),(170954,4749,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3649;&#3621;&#3632;&#3592;&#3633;&#3604;&#3648;&#3585;&#3655;&#3610;&#3605;&#3634;&#3617;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(170955,4749,'hi','à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤”à¤° à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(170956,4749,'ms','Mengira dan simpan sebagai Quote',0),(170957,4749,'ar','Ø­Ø³Ø§Ø¨ ÙˆØ­ÙØ¸ ÙƒØ§Ù‚ØªØ¨Ø§Ø³',0),(170958,4749,'fr','Calculer et enregistrer en tant que citation',0),(170959,4749,'jp','è¦‹ç©?ã‚Šã?¨ã?—ã?¦è¨ˆç®—ã€?ä¿?å­˜',0),(170960,4749,'pt','Calcular e salve como citaÃ§Ã£o',0),(170961,4749,'ru','Ð Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð¸ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ ÐºÐ°Ðº Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(170962,4749,'es','Calcular y Guardar como CotizaciÃ³n',0),(170963,4749,'de','Berechnen Sie und speichern Sie als Zitat',0),(170964,4749,'en','Calculate and Save as Quote',0),(170965,4750,'is','',0),(170966,4750,'dr','Ù„ØºÙˆ ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯Ù‡',0),(170967,4750,'pr','Ù„ØºÙˆ ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯Ù‡',0),(170968,4750,'tr','YapÄ±lan deÄŸiÅŸiklikleri iptal et',0),(170969,4750,'pl','AnulowaÄ‡ zmiany wprowadzone',0),(170970,4750,'bg','ÐžÑ‚Ð¼ÐµÐ½Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ, Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÐ½Ð¸',0),(170971,4750,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº',0),(170972,4750,'sr','ÐžÑ‚ÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð½Ð°Ð¿Ñ€Ð°Ð²Ñ™ÐµÐ½Ðµ',0),(170973,4750,'vi','ÄÃ£ thay Ä‘á»•i xÃ³a',0),(170974,4750,'af','Kanselleer veranderinge',0),(170975,4750,'ro','AnulaÅ£i modificÄƒrile',0),(170976,4750,'et','TÃ¼hista muudatused',0),(170977,4750,'si','Preklicati spremembe',0),(170978,4750,'ba','Membatalkan perubahan yang dibuat',0),(170979,4750,'nl','Wijzigingen annuleren',0),(170980,4750,'fi','Peruuttaa tehdyt muutokset',0),(170981,4750,'no','Avbryte endringer',0),(170982,4750,'da','Annullere Ã¦ndringer',0),(170983,4750,'ko','ë³€ê²½ ì‚¬í•­ì„ ì·¨ì†Œí•©ë‹ˆë‹¤',0),(170984,4750,'he','×‘×™×˜×•×œ ×©×™× ×•×™×™×',0),(170985,4750,'el','Î‘ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚ Ï€Î¿Ï… Î­Î³Î¹Î½Î±Î½',0),(170986,4750,'zh','å–æ¶ˆæ‰€åšçš„æ›´æ”¹\r\n',0),(170987,4750,'sv','Avbryta Ã¤ndringarna',0),(170988,4750,'it','Annullare le modifiche apportate',0),(170989,4750,'tl','',0),(170990,4750,'th','&#3607;&#3635;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(170991,4750,'hi','à¤•à¤¿à¤ à¤—à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚',0),(170992,4750,'ms','Membatalkan perubahan dibuat',0),(170993,4750,'ar','Ø¥Ù„ØºØ§Ø¡ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø¬Ø±Ø§Ø¤Ù‡Ø§',0),(170994,4750,'fr','Annuler les modifications apportÃ©es',0),(170995,4750,'jp','å¤‰æ›´ã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(170996,4750,'pt','Cancelar as alteraÃ§Ãµes feitas',0),(170997,4750,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡Ð´ÐµÐ»Ð°Ð½Ð½Ñ‹Ðµ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(170998,4750,'es','Cancelar Cheques Escritos',0),(170999,4750,'de','\"Abbrechen\"-Ã„nderungen',0),(171000,4750,'en','Cancel Changes Made',0),(171001,4751,'is','',0),(171002,4751,'dr','Ù„ØºÙˆ Ø«Ø¨Øª Ù‡Ø§',0),(171003,4751,'pr','Ù„ØºÙˆ Ø«Ø¨Øª Ù‡Ø§',0),(171004,4751,'tr','GiriÅŸleri iptal',0),(171005,4751,'pl','Anuluj wpisy',0),(171006,4751,'bg','ÐžÑ‚Ð¼ÐµÐ½ÑÐ½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(171007,4751,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Ùˆ Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº',0),(171008,4751,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(171009,4751,'vi','XÃ³a bÃºt toÃ¡n',0),(171010,4751,'af','Kanselleer Inskrywings',0),(171011,4751,'ro','Revocare intrÄƒri',0),(171012,4751,'et','TÃ¼hista kanded',0),(171013,4751,'si','PrekliÄi postavke',0),(171014,4751,'ba','Membatalkan entri',0),(171015,4751,'nl','Posten annuleren',0),(171016,4751,'fi','Peruuta tapahtumat',0),(171017,4751,'no','Kansellere poster',0),(171018,4751,'da','Annuller poster',0),(171019,4751,'ko','í•­ëª© ì·¨ì†Œ',0),(171020,4751,'he','×œ×‘×˜×œ ××ª ×¢×¨×›×™',0),(171021,4751,'el','Î‘ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(171022,4751,'zh','å–æ¶ˆè¾“å…¥\r\n',0),(171023,4751,'sv','RÃ¤tta transaktioner',0),(171024,4751,'it','Annullare i movimenti',0),(171025,4751,'tl','',0),(171026,4751,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(171027,4751,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤°à¤¦à¥à¤¦',0),(171028,4751,'ms','Membatalkan penyertaan',0),(171029,4751,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø£Ù…Ø±',0),(171030,4751,'fr','Annuler des Ã©critures',0),(171031,4751,'jp','ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?®ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(171032,4751,'pt','Cancelar as entradas',0),(171033,4751,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(171034,4751,'es','Cancelar Entradas',0),(171035,4751,'de','\"Abbrechen\" EintrÃ¤ge',0),(171036,4751,'en','Cancel Entries',0),(171037,4752,'is','',0),(171038,4752,'dr','ØªØºÙŠÙŠØ± Ø¨Ø±Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ÙƒØ±Ø¯Ù† ÙˆÙ‚ØªÙŠ Ø³ÙØ§Ø±Ø´ Ù‚Ø¨Ù„  ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(171039,4752,'pr','ØªØºÙŠÙŠØ± Ø¨Ø±Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ÙƒØ±Ø¯Ù† ÙˆÙ‚ØªÙŠ Ø³ÙØ§Ø±Ø´ Ù‚Ø¨Ù„  ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(171040,4752,'tr','Yeni Ã¶n sipariÅŸ olarak deÄŸiÅŸen bulunamadÄ±',0),(171041,4752,'pl','Zmiana na nowy jako wczeÅ›niejszego zamÃ³wienia nie znaleziono',0),(171042,4752,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° ÐºÑŠÐ¼ Ð½Ð¾Ð² ÐºÐ°Ñ‚Ð¾ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(171043,4752,'ur','Ù†ÛŒÙˆ Ù¾ÛŒØ´Ú¯ÛŒ Ø­Ú©Ù… Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø¯ÛŒÚ©Ú¾ Ú©Ø± Ø¨Ø¯Ù„ØªØ§ Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(171044,4752,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð½Ð° ÑšÑƒ ÐºÐ°Ð¾ Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(171045,4752,'vi','Äá»•i sang nháº­p má»›i vÃ¬ khÃ´ng tÃ¬m tháº¥y ÄÆ¡n Äáº·t hÃ ng trÆ°á»›c',0),(171046,4752,'af','Verander na nuwe as vooraf bestelling nie gevind nie',0),(171047,4752,'ro','Schimbarea la noua ca prealabil nu a fost gÄƒsit',0),(171048,4752,'et','Uus nagu eelneva tellimuse muutmine ei leitud',0),(171049,4752,'si','Spreminjanje na novo kot predhodnega naroÄila ni mogoÄe najti',0),(171050,4752,'ba','Mengubah baru sebagai pesanan sebelumnya tidak ditemukan',0),(171051,4752,'nl','Omzetten in New als voorafgaande bestelling niet gevonden',0),(171052,4752,'fi','Muuttaa uusi kuten ennen tilausta ei lÃ¶ytynyt',0),(171053,4752,'no','Endre ny som tidligere ikke funnet',0),(171054,4752,'da','Ã†ndre pÃ¥ ny som forudgÃ¥ende ordre ikke fundet',0),(171055,4752,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ì‚¬ì „ ìˆœì„œì™€ ìƒˆë¡œ ë³€ê²½',0),(171056,4752,'he','×©×™× ×•×™ ×¢×œ ×—×“×© ×›×¡×“×¨ ×ž×•×§×“×ž×ª ×œ× × ×ž×¦×',0),(171057,4752,'el','Î‘Î»Î»Î±Î³Î® ÏƒÎµ Î½Î­Î± Ï‰Ï‚ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(171058,4752,'zh','æ‰¾ä¸åˆ°ä»¥å‰è®¢è´­æ›´æ”¹ä¸ºæ–°å»º\r\n',0),(171059,4752,'sv','Byta till nya som tidigare Order hittades inte',0),(171060,4752,'it','Cambiando nuovo come ordine prima non trovato',0),(171061,4752,'tl','',0),(171062,4752,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3594;&#3656;&#3623;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3',0),(171063,4752,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¯à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¦à¤² à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(171064,4752,'ms','Menukar ke baru sebagai perintah terdahulu tidak dijumpai',0),(171065,4752,'ar','ØªØºÙŠÙŠØ± Ø¥Ù„Ù‰ Ø¬Ø¯ÙŠØ¯ \"Ø£Ù…Ø± Ù…Ø³Ø¨Ù‚\" Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(171066,4752,'fr','Changeant Ã  nouveau comme ordre prÃ©alable introuvable',0),(171067,4752,'jp','å‰?ã?®æ³¨æ–‡ã?Œè¦‹ã?¤ã?‹ã‚‰ã?ªã?„ã?®ã?§æ–°è¦?ã?¸å¤‰æ›´ã?™ã‚‹',0),(171068,4752,'pt','Mudando para nova ordem prÃ©via nÃ£o encontrado',0),(171069,4752,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ ÐºÐ°Ðº Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(171070,4752,'es','Cambiando a Nuevo dado que el Pedido Previo no se Encuentra',0),(171071,4752,'de','Ã„ndern auf neu als vorherige Bestellung wurde nicht gefunden.',0),(171072,4752,'en','Changing to New as Prior Order not Found',0),(171073,4753,'is','',0),(171074,4753,'dr','ØªØºÙŠÙŠØ± Ø¨Ø±Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ ÙˆÙ‚ØªÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù…Ø­Ø¶ ØªØ­ÙˆÙŠÙ„  ÙƒØ§Ù„Ø§  ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(171075,4753,'pr','ØªØºÙŠÙŠØ± Ø¨Ø±Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ ÙˆÙ‚ØªÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù…Ø­Ø¶ ØªØ­ÙˆÙŠÙ„  ÙƒØ§Ù„Ø§  ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(171076,4753,'tr','Yeni sipariÅŸ POD Ã¶ÄŸe olarak deÄŸiÅŸen bulunamadÄ±',0),(171077,4753,'pl','Zmiana na zamÃ³wienie nowy pozycji POD nie znaleziono',0),(171078,4753,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° ÐºÑŠÐ¼ Ð½Ð¾Ð² Ñ€ÐµÐ´ ÐºÐ°Ñ‚Ð¾ POD ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(171079,4753,'ur','Ù¾Ú¾Ù„ÛŒ Ø´Û’ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†Ø¦Û’ Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Ø§ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(171080,4753,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð½Ð° Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº ÐºÐ°Ð¾ ÐŸÐ£ÐŸÐžÐ‰ÐÐš ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°.',0),(171081,4753,'vi','Äá»•i sang nháº­p má»›i vÃ¬ khÃ´ng tÃ¬m tháº¥y danh má»¥c POD',0),(171082,4753,'af','Verander na Nuwe Bestelling aangesien POA Item nie Gevind is nie',0),(171083,4753,'ro','Schimbarea la noua ordine ca POD element negÄƒsit',0),(171084,4753,'et','Lendama viitemÃ¤rgi POD kirjena ei leitud',0),(171085,4753,'si','Sprememba v nov red kot POD element ni mogoÄe najti',0),(171086,4753,'ba','Mengubah Orde Baru sebagai POD Item tidak ditemukan',0),(171087,4753,'nl','Omzetten in nieuwe orde als POD Item niet gevonden',0),(171088,4753,'fi','Muuttaminen uudenlaisen POD erÃ¤nÃ¤ ei lÃ¶ydy',0),(171089,4753,'no','Endre til ny ordre som POD ikke funnet',0),(171090,4753,'da','Skift til ny ordre som POD vare ikke fundet',0),(171091,4753,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ í¬ë“œ í•­ëª©ìœ¼ë¡œ ìƒˆë¡œìš´ ìˆœì„œë¥¼ ë³€ê²½',0),(171092,4753,'he','×©×™× ×•×™ ×¡×“×¨ ×—×“×© ×›×¤×¨×™×˜ ×¤×•×“ ×œ× × ×ž×¦×',0),(171093,4753,'el','Î‘Î»Î»Î±Î³Î® ÏƒÎµ Î½Î­Î± Ï„Î¬Î¾Î· Ï‰Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ POD Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(171094,4753,'zh','æ‰¾ä¸åˆ°è´§åˆ°ä»˜æ¬¾ä»¥æ›´æ”¹åˆ°æ–°é¡ºåº',0),(171095,4753,'sv','Ã„ndra till ny Order som POD objekt hittades inte',0),(171096,4753,'it','Cambiando al nuovo ordine come elemento POD non trovato',0),(171097,4753,'tl','',0),(171098,4753,'th','Changing to New Order as POD Item not Found',0),(171099,4753,'hi','POD à¤®à¤¦ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¬à¤¦à¤² à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤',0),(171100,4753,'ms','Perubahan kepada perintah baru sebagai POD Item tidak dijumpai',0),(171101,4753,'ar','ØªØºÙŠÙŠØ± \"Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¬Ø¯ÙŠØ¯\" ÙƒØ¬Ø±Ø§Ø¨ Ø§Ù„Ø¨Ù†Ø¯ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(171102,4753,'fr','Changeant Ã  nouvel ordre comme Ã©lÃ©ment de POD introuvable',0),(171103,4753,'jp','ï¼°ï¼¯ï¼¤å“?ç›®ã?Œè¦‹ã?¤ã?‹ã‚‰ã?ªã?„ã?®ã?§æ–°è¦?æ³¨æ–‡ã?¸å¤‰æ›´ã?™ã‚‹',0),(171104,4753,'pt','Mudando para nova ordem como POD Item nÃ£o encontrado',0),(171105,4753,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð½Ð¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº, Ñ‡Ñ‚Ð¾ Ð¿Ð¾Ð´ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(171106,4753,'es','Cambiando a un Pedido Nuevo porque el Item POD no se Encuentra',0),(171107,4753,'de','Wechsel zu New Order als POD-Element wurde nicht gefunden.',0),(171108,4753,'en','Changing to New Order as POD Item not Found',0),(171109,4754,'is','',0),(171110,4754,'dr','ØªØºÙŠÙŠØ± Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø¨Ø§ ØªØºÙŠÙŠØ±Ø§Øª ÙˆÙ‚ØªÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù…Ø­Ø¶ ØªØ­ÙˆÙŠÙ„  ÙƒØ§Ù„Ø§Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯   ',0),(171111,4754,'pr','ØªØºÙŠÙŠØ± Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø¨Ø§ ØªØºÙŠÙŠØ±Ø§Øª ÙˆÙ‚ØªÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù…Ø­Ø¶ ØªØ­ÙˆÙŠÙ„  ÙƒØ§Ù„Ø§Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯   ',0),(171112,4754,'tr','Reprint iÃ§in deÄŸiÅŸtirme deÄŸiÅŸtirir ile POD Ã¶ÄŸesi olarak zaten oluÅŸturulmuÅŸ',0),(171113,4754,'pl','Zmiana do przedruku zmiany pozycji POD juÅ¼ stworzony',0),(171114,4754,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° ÐºÑŠÐ¼ Ð¿Ñ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ Ñ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚Ð¾ POD ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð²ÐµÑ‡Ðµ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½',0),(171115,4754,'ur','Ù¾ÛŒØ¯Ø§ Ú©Ø±Ù†Û’ Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾ Ù¾Ú¾Ù„ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù¾ÛÙ„Û’ ÛÛŒ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Ø§',0),(171116,4754,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð½Ð° Ð¿Ð¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ ÑÐ° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°Ð¼Ð° ÐºÐ°Ð¾ ÐŸÐ£ÐŸÐžÐ‰ÐÐš Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð²ÐµÑ› ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½',0),(171117,4754,'vi','Thay Ä‘á»•i In láº¡i khi hÃ ng trong Ä‘Æ¡n mua hÃ ng Ä‘Ã£ táº¡o ra',0),(171118,4754,'af','Verander na Heruitdruk met Veranderinge aangesien POA Item Alreeds Bestaan',0),(171119,4754,'ro','Schimbarea sÄƒ imprimaÅ£i din nou cu modificÄƒri ca element de POD deja creat',0),(171120,4754,'et','Lendama kordustrÃ¼kk muutustega nagu POD Ã¼ksuse juba loodud',0),(171121,4754,'si','Spreminjanje za ponatis s spremembami kot element POD Å¾e ustvaril',0),(171122,4754,'ba','Mengubah Reprint dengan perubahan sebagai POD Item sudah diciptakan',0),(171123,4754,'nl','Wijzigen om herdruk met wijzigingen als POD Item al gemaakt',0),(171124,4754,'fi','SiirrytÃ¤Ã¤n uusintapainos muutoksia POD erÃ¤nÃ¤ jo luotu',0),(171125,4754,'no','Endre til opptrykk med endringer som POD allerede opprettet',0),(171126,4754,'da','Ã†ndre til genoptryk med Ã¦ndringer som POD vare allerede oprettet',0),(171127,4754,'ko','ë§Œë“  ë³€ê²½ ê¸°ìž… ë³€í™” í¬ë“œ í•­ëª©ìœ¼ë¡œ ì´ë¯¸',0),(171128,4754,'he','×©×™× ×•×™ ×”×“×¤×¡×” ×ž×—×“×© ×¢× ×©×™× ×•×™×™× ×›×¤×¨×™×˜ POD ×›×‘×¨ × ×•×¦×¨',0),(171129,4754,'el','Î‘Î»Î»Î±Î³Î® ÏƒÎµ Î±Î½Î±Ï„ÏÏ€Ï‰ÏƒÎ· Î¼Îµ Î±Î»Î»Î±Î³Î­Ï‚ Ï‰Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ POD Î®Î´Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸ÎµÎ¯',0),(171130,4754,'zh','è´§åˆ°ä»˜æ¬¾é¡¹ç›®å·²è¿‘åˆ›å»ºï¼Œæ›´æ”¹åˆ°æ›´æ”¹é‡æ–°æ‰“å°\r\n',0),(171131,4754,'sv','Ã„ndra till nytryck med Ã¤ndringar som POD post redan skapats',0),(171132,4754,'it','Cambia ristampa con modifiche come elemento POD giÃ  creato',0),(171133,4754,'tl','',0),(171134,4754,'th','Changing to Reprint with Changes as POD Item Already Created',0),(171135,4754,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥‡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥ POD à¤®à¤¦ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¬à¤¦à¤²à¤¨à¥‡ à¤¬à¤¨à¤¾à¤¯à¤¾',0),(171136,4754,'ms','Perubahan kepada pencetakan semula dengan perubahan sebagai POD Item sudah dicipta',0),(171137,4754,'ar','Ø§Ù„Ù…ØªØºÙŠØ±Ø© Ù„Ø·Ø¨Ø¹ Ù…Ø¹ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª ÙƒØ¨Ù†Ø¯ Ø¬Ø±Ø§Ø¨ Ø³Ø¨Ù‚ Ø¥Ù†Ø´Ø§Ø¤Ù‡',0),(171138,4754,'fr','Changeant Ã  rÃ©impression avec modifications comme POD article dÃ©jÃ  crÃ©Ã©',0),(171139,4754,'jp','ï¼°ï¼¯ï¼¤å“?ç›®ã?Œã?™ã?§ã?«ä½œæˆ?ã?•ã‚Œã?¦ã?„ã‚‹ã?®ã?§ã€?å¤‰æ›´ã‚’ç”Ÿã?‹ã?—ã?¦å†?å?°åˆ·ã?¸å¤‰æ›´ã?™ã‚‹',0),(171140,4754,'pt','Mudando para reimpressÃ£o com alteraÃ§Ãµes como Item POD jÃ¡ criado',0),(171141,4754,'ru','Ð—Ð°Ð¼ÐµÐ½Ð° Ð¿ÐµÑ€ÐµÐ¸Ð·Ð´Ð°Ð½Ð¸Ðµ Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸ÑÐ¼Ð¸ ÐºÐ°Ðº ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ POD ÑƒÐ¶Ðµ ÑÐ¾Ð·Ð´Ð°Ð½',0),(171142,4754,'es','Cambiando a Reimprimir con Cambios porque el Item POD Ya CreyÃ³',0),(171143,4754,'de','Ã„ndern, Reprint mit Ã„nderungen als POD Element bereits erstellt',0),(171144,4754,'en','Changing to Reprint with Changes as POD Item Already Created',0),(171145,4755,'is','',0),(171146,4755,'dr','Ø¨Ø±Ø±Ø³ÙŠ ØªÙ…Ø§Ù… Ù…Ù†Ø§Ø³Ø¨',0),(171147,4755,'pr','Ø¨Ø±Ø±Ø³ÙŠ ØªÙ…Ø§Ù… Ù…Ù†Ø§Ø³Ø¨',0),(171148,4755,'tr','TÃ¼m uygun kontrol',0),(171149,4755,'pl','SprawdÅº wszystkie stosowne',0),(171150,4755,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸',0),(171151,4755,'ur','ØªÙ…Ø§Ù… Ø§Ù¾Ù¾Ø±ÙˆÙ¾Ø±ÛŒØ§Ù¹ÛŒ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(171152,4755,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ²Ðµ ÐÐ¿Ð¿Ñ€Ð¾Ð¿Ñ€Ð¸Ð°Ñ‚Ðµ',0),(171153,4755,'vi','ÄÃ¡nh dáº¥u táº¥t cáº£ nhá»¯ng pháº§n phÃ¹ há»£p',0),(171154,4755,'af','Merk alle toepaslike',0),(171155,4755,'ro','Verifica toate corespunzÄƒtoare',0),(171156,4755,'et','Kontrollige kÃµiki asjakohane',0),(171157,4755,'si','Preverite vse ustrezne',0),(171158,4755,'ba','Periksa semua tepat',0),(171159,4755,'nl','Controleer alle passend',0),(171160,4755,'fi','Tarkista kaikki asianmukaista',0),(171161,4755,'no','Sjekk alle passer',0),(171162,4755,'da','Kontroller alle passende',0),(171163,4755,'ko','ëª¨ë“  ì ì ˆ í•œ í™•ì¸',0),(171164,4755,'he','×‘×“×•×§ ×›×œ ×ž×ª××™×',0),(171165,4755,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î±ÏÎ¼ÏŒÎ´Î¹ÎµÏ‚',0),(171166,4755,'zh','æ£€æŸ¥æ‰€æœ‰é€‚å½“\r\n',0),(171167,4755,'sv','Kontrollera alla lÃ¤mpliga',0),(171168,4755,'it','Controllare tutti gli opportuni',0),(171169,4755,'tl','',0),(171170,4755,'th','&#3648;&#3594;&#3655;&#3588;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3648;&#3605;&#3619;&#3633;&#3618;&#3617;&#3648;&#3629;&#3634;&#3652;&#3623;&#3657;',0),(171171,4755,'hi','à¤¸à¤­à¥€ Appropriate à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(171172,4755,'ms','Semak semua Appropriate',0),(171173,4755,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† ÙƒØ§ÙØ© Ø§Ù„Ù…Ù†Ø§Ø³Ø¨Ø©',0),(171174,4755,'fr','VÃ©rifier la tutelle tous les',0),(171175,4755,'jp','å…¨ã?¦ã?®é?©åˆ‡ã?ªã‚‚ã?®ã‚’ç¢ºèª?',0),(171176,4755,'pt','Verifique todos adequado',0),(171177,4755,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð²ÑÐµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ',0),(171178,4755,'es','Chequear todo Apropriado',0),(171179,4755,'de','ÃœberprÃ¼fen Sie alle angemessenen',0),(171180,4755,'en','Check all Appropriate',0),(171181,4756,'is','',0),(171182,4756,'dr','Ù…Ø´ØªØ±ÙŠ ÙŠÙƒ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª',0),(171183,4756,'pr','Ù…Ø´ØªØ±ÙŠ ÙŠÙƒ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª',0),(171184,4756,'tr','Ä°stemci bir teklif talep etti',0),(171185,4756,'pl','Klient zaÅ¼Ä…daÅ‚ cytat',0),(171186,4756,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑŠÑ‚ Ðµ Ð¿Ð¾Ð¸ÑÐºÐ°Ð» Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(171187,4756,'ur','ÙˆØµÙˆÙ„ Ú©Ø§Ø± Ø§ÛŒÚ© Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ ÛÛ’',0),(171188,4756,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ð·Ð°Ñ…Ñ‚Ð¸Ñ˜ÐµÐ²Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(171189,4756,'vi','KhÃ¡c hÃ ng yÃªu cáº§u bÃ¡o giÃ¡',0),(171190,4756,'af','Klient het \'n kwotasie versoek',0),(171191,4756,'ro','Clientul a solicitat un citat',0),(171192,4756,'et','Klient taotles pakkumist',0),(171193,4756,'si','Odjemalec je zahteval ponudbo',0),(171194,4756,'ba','Klien telah meminta kutipan',0),(171195,4756,'nl','Client een aanvraag heeft ingediend voor een offerte',0),(171196,4756,'fi','Asiakassovellus on pyytÃ¤nyt tarjousta',0),(171197,4756,'no','Klienten har Ã¸nsket et tilbud',0),(171198,4756,'da','Kunden har anmodet om et tilbud',0),(171199,4756,'ko','í´ë¼ì´ì–¸íŠ¸ëŠ” ê²¬ì ì„ ìš”ì²­ í–ˆìŠµë‹ˆë‹¤.',0),(171200,4756,'he','×”×œ×§×•×— ×‘×™×§×© ×”×¦×¢×ª ×ž×—×™×¨',0),(171201,4756,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ Î­Ï‡ÎµÎ¹ Î¶Î·Ï„Î®ÏƒÎµÎ¹ Î¼Î¹Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(171202,4756,'zh','å®¢æˆ·è¦æ±‚æŠ¥ä»·\r\n',0),(171203,4756,'sv','Klienten har begÃ¤rt en offert',0),(171204,4756,'it','Il cliente ha richiesto un preventivo',0),(171205,4756,'tl','',0),(171206,4756,'th','&#3612;&#3641;&#3657;&#3592;&#3657;&#3634;&#3591;&#3586;&#3629;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(171207,4756,'hi','à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ à¤à¤• à¤¬à¥‹à¤²à¥€ à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤•à¤¿à¤¯à¤¾',0),(171208,4756,'ms','Pelanggan telah meminta sebut harga',0),(171209,4756,'ar','Ø·Ù„Ø¨ Ø§Ù„Ø²Ø¨ÙˆÙ† Ø¹Ø±Ø¶Ø§ ',0),(171210,4756,'fr','Client a demandÃ© un devis',0),(171211,4756,'jp','é¡§å®¢ã?¯è¦‹ç©?ã‚Šã‚’è¦?è«‹ä¸­ã?§ã?™',0),(171212,4756,'pt','Cliente solicitou uma citaÃ§Ã£o',0),(171213,4756,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¸Ð» Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(171214,4756,'es','Cliente ha pedido una cotizaciÃ³n',0),(171215,4756,'de','Client hat ein Angebot angefordert.',0),(171216,4756,'en','Client has requested a quote',0),(171217,4757,'is','',0),(171218,4757,'dr','ØªØ§ÙŠÙŠØ¯ ',0),(171219,4757,'pr','ØªØ§ÙŠÙŠØ¯ ',0),(171220,4757,'tr','Onaylayan',0),(171221,4757,'pl','Potwierdzenie',0),(171222,4757,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ',0),(171223,4757,'ur','ØªØµØ¯ÛŒÙ‚',0),(171224,4757,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ñ’ÑƒÑ˜ÑƒÑ›Ð¸',0),(171225,4757,'vi','Äang xÃ¡c nháº­n',0),(171226,4757,'af','Bevestig',0),(171227,4757,'ro','ConfirmÃ¢nd',0),(171228,4757,'et','Kinnitan',0),(171229,4757,'si','Potrjuje',0),(171230,4757,'ba','Mengkonfirmasikan',0),(171231,4757,'nl','Om te bevestigen',0),(171232,4757,'fi','Vahvistaa',0),(171233,4757,'no','Bekrefter',0),(171234,4757,'da','BekrÃ¦fter',0),(171235,4757,'ko','í™•ì¸',0),(171236,4757,'he','×”×ž××©×¨',0),(171237,4757,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÎ½Î¿Î½Ï„Î±Ï‚',0),(171238,4757,'zh','ç¡®è®¤\r\n',0),(171239,4757,'sv','BekrÃ¤ftar',0),(171240,4757,'it','Confermando',0),(171241,4757,'tl','',0),(171242,4757,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(171243,4757,'hi','à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿',0),(171244,4757,'ms','Mengesahkan',0),(171245,4757,'ar','ÙŠØ¤ÙƒØ¯',0),(171246,4757,'fr','Confirmant',0),(171247,4757,'jp','ç¢ºèª?ä¸­',0),(171248,4757,'pt','Confirmando',0),(171249,4757,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´Ð°ÐµÑ‚ÑÑ',0),(171250,4757,'es','Confirmando',0),(171251,4757,'de','BestÃ¤tigung',0),(171252,4757,'en','Confirming',0),(171253,4758,'is','',0),(171254,4758,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(171255,4758,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(171256,4758,'tr','MÃ¼ÅŸteri seÃ§imi',0),(171257,4758,'pl','WybÃ³r klienta',0),(171258,4758,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(171259,4758,'ur','Ú©Ø³Ù¹Ù…Ø± Ø§Ù†ØªØ®Ø§Ø¨',0),(171260,4758,'sr','ÐžÐ´Ð°Ð±Ð¸Ñ€ ÐºÑƒÐ¿Ñ†Ð°',0),(171261,4758,'vi','Lá»±a chá»n KhÃ¡ch hÃ ng',0),(171262,4758,'af','Selekteer KliÃªnt-/Klante',0),(171263,4758,'ro','SelecÅ£ie de client',0),(171264,4758,'et','Kliendi valikul',0),(171265,4758,'si','Izbor kupca',0),(171266,4758,'ba','Pilihan pelanggan',0),(171267,4758,'nl','Klantselectie',0),(171268,4758,'fi','Asiakkaan valinta',0),(171269,4758,'no','Kunden valget',0),(171270,4758,'da','Kundens valg',0),(171271,4758,'ko','ê³ ê° ì„ íƒ',0),(171272,4758,'he','×ž×‘×—×¨ ×œ×§×•×—×•×ª',0),(171273,4758,'el','Î•Ï€Î¹Î»Î¿Î³Î® Ï€ÎµÎ»Î¬Ï„Î·',0),(171274,4758,'zh','å®¢æˆ·é€‰æ‹©\r\n',0),(171275,4758,'sv','Kundens val',0),(171276,4758,'it','Selezione cliente',0),(171277,4758,'tl','',0),(171278,4758,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(171279,4758,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤šà¤¯à¤¨',0),(171280,4758,'ms','Pilihan pelanggan',0),(171281,4758,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(171282,4758,'fr','SÃ©lection de la clientÃ¨le',0),(171283,4758,'jp','é¡§å®¢é?¸æŠžè‚¢',0),(171284,4758,'pt','SeleÃ§Ã£o do cliente',0),(171285,4758,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(171286,4758,'es','Cliente Seleccion',0),(171287,4758,'de','Kundenauswahl',0),(171288,4758,'en','Customer Selection',0),(171289,4759,'is','',0),(171290,4759,'dr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(171291,4759,'pr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(171292,4759,'tr','Ã–zel baskÄ± sipariÅŸi',0),(171293,4759,'pl','Druk na zamÃ³wienie',0),(171294,4759,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(171295,4759,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ',0),(171296,4759,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(171297,4759,'vi','ÄÆ¡n Ä‘áº·t hÃ ng In cá»§a khÃ¡ch hÃ ng',0),(171298,4759,'af','Aangepasde Gedrukte Bestelling',0),(171299,4759,'ro','Ordine de imprimare personalizat',0),(171300,4759,'et','JÃ¤rjestust prindi',0),(171301,4759,'si','Vrstni red tiskanja po meri',0),(171302,4759,'ba','Kustom Orde cetak',0),(171303,4759,'nl','Aangepaste afdrukvolgorde',0),(171304,4759,'fi','Tulosta tilaustyÃ¶nÃ¤',0),(171305,4759,'no','Egendefinert rekkefÃ¸lge',0),(171306,4759,'da','Brugerdefinerede udskriftsrÃ¦kkefÃ¸lgen',0),(171307,4759,'ko','ì‚¬ìš©ìž ì§€ì • ì¸ì‡„ ìˆœì„œ',0),(171308,4759,'he','×¡×“×¨ ×”×“×¤×¡×” ×ž×•×ª××ž×ª ××™×©×™×ª',0),(171309,4759,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· ÏƒÎµÎ¹ÏÎ¬ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(171310,4759,'zh','è‡ªå®šä¹‰æ‰“å°è®¢å•\r\n',0),(171311,4759,'sv','Anpassade utskriftsordning',0),(171312,4759,'it','Ordine di stampa personalizzata',0),(171313,4759,'tl','',0),(171314,4759,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(171315,4759,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤®',0),(171316,4759,'ms','Cetak tersuai',0),(171317,4759,'ar','ØªØ±ØªÙŠØ¨ Ø·Ø¨Ø§Ø¹Ø© Ù…Ø®ØµØµ',0),(171318,4759,'fr','Ordre d\'impression personnalisÃ©',0),(171319,4759,'jp','ç‰¹åˆ¥å?°åˆ·æ³¨æ–‡',0),(171320,4759,'pt','Ordem de impressÃ£o personalizada',0),(171321,4759,'ru','Ð—Ð°ÐºÐ°Ð· Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(171322,4759,'es','Orden de ImpresiÃ³n Personalizado',0),(171323,4759,'de','Benutzerdefinierte Druckreihenfolge',0),(171324,4759,'en','Custom Print Order',0),(171325,4760,'is','',0),(171326,4760,'dr','ØªØ§Ø±ÙŠØ® Ø¬Ù‡Øª Ø­Ù…Ù„ ',0),(171327,4760,'pr','ØªØ§Ø±ÙŠØ® Ø¬Ù‡Øª Ø­Ù…Ù„ ',0),(171328,4760,'tr','Gemiye tarihi',0),(171329,4760,'pl','Data na statku',0),(171330,4760,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(171331,4760,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(171332,4760,'sr','Ð˜Ð·Ð»Ð°Ð·Ð¸Ð¼ Ð½Ð° Ð±Ñ€Ð¾Ð´',0),(171333,4760,'vi','NgÃ y Ä‘á»ƒ chuyá»ƒn',0),(171334,4760,'af','Datum om te Versend',0),(171335,4760,'ro','Data de livrare',0),(171336,4760,'et','Tarneaeg',0),(171337,4760,'si','Datum za ladje',0),(171338,4760,'ba','Tanggal ke kapal',0),(171339,4760,'nl','Datum aan schip',0),(171340,4760,'fi','MennessÃ¤ aluksen',0),(171341,4760,'no','Dato for skip',0),(171342,4760,'da','Dato for skib',0),(171343,4760,'ko','ìš°ì£¼ì„ ì— ë‚ ì§œ',0),(171344,4760,'he','×ª××¨×™×š ×œ×¡×¤×™× ×”',0),(171345,4760,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î»Î¿Î¯Î¿',0),(171346,4760,'zh','è¿é€æ—¥æœŸ\r\n',0),(171347,4760,'sv','Datum fÃ¶r fartyg',0),(171348,4760,'it','Data alla nave',0),(171349,4760,'tl','',0),(171350,4760,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(171351,4760,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(171352,4760,'ms','Tarikh ke kapal',0),(171353,4760,'ar','ÙˆØ­ØªÙ‰ Ø§Ù„Ø¢Ù† Ø¥Ù„Ù‰ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(171354,4760,'fr','Date au navire',0),(171355,4760,'jp','ç™ºé€?æ—¥',0),(171356,4760,'pt','Data de navio',0),(171357,4760,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(171358,4760,'es','Fecha para Enviar',0),(171359,4760,'de','Auf das Schiff',0),(171360,4760,'en','Date to Ship',0),(171361,4761,'is','',0),(171362,4761,'dr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ ',0),(171363,4761,'pr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ ',0),(171364,4761,'tr','SipariÅŸi sil',0),(171365,4761,'pl','UsuÅ„ zamÃ³wienie',0),(171366,4761,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´',0),(171367,4761,'ur','Ø­Ú©Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(171368,4761,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(171369,4761,'vi','XÃ³a ÄÆ¡n Äáº·t HÃ ng',0),(171370,4761,'af','Skrap Bestelling',0),(171371,4761,'ro','ÅžtergeÅ£i comanda',0),(171372,4761,'et','Kustuta tellimus',0),(171373,4761,'si','Izbrisati nalog',0),(171374,4761,'ba','Menghapus pesanan',0),(171375,4761,'nl','Order verwijderen',0),(171376,4761,'fi','Poista tilaus',0),(171377,4761,'no','Slette ordre',0),(171378,4761,'da','Slette bestilling',0),(171379,4761,'ko','ì£¼ë¬¸ ì‚­ì œ',0),(171380,4761,'he','×ž×—×§ ×”×–×ž× ×”',0),(171381,4761,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(171382,4761,'zh','åˆ é™¤è®¢å•\r\n',0),(171383,4761,'sv','Ta bort Order',0),(171384,4761,'it','Eliminare l\'ordine',0),(171385,4761,'tl','',0),(171386,4761,'th','&#3621;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(171387,4761,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(171388,4761,'ms','Padam perintah',0),(171389,4761,'ar','Ø­Ø°Ù Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(171390,4761,'fr','Supprimer l\'ordre',0),(171391,4761,'jp','æ³¨æ–‡ã?®å?–æ¶ˆ',0),(171392,4761,'pt','Excluir a ordem',0),(171393,4761,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·',0),(171394,4761,'es','Eliminar Orden',0),(171395,4761,'de','Auftrag lÃ¶schen',0),(171396,4761,'en','Delete Order',0),(171397,4762,'is','',0),(171398,4762,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªØ­ÙˆÙŠÙ„ ',0),(171399,4762,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªØ­ÙˆÙŠÙ„ ',0),(171400,4762,'tr','Teslimat Bilgisi',0),(171401,4762,'pl','Dostarczania informacji',0),(171402,4762,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(171403,4762,'ur','ÚˆÙ„ÛŒÙˆØ±ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(171404,4762,'sr','ÐŸÐ¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²Ð¸',0),(171405,4762,'vi','ÄÃ£ chuyá»ƒn thÃ´ng tin',0),(171406,4762,'af','Aflewerings Inligting',0),(171407,4762,'ro','InformaÅ£ii de livrare',0),(171408,4762,'et','Tarne Info',0),(171409,4762,'si','Dostava informacij',0),(171410,4762,'ba','Info pengiriman',0),(171411,4762,'nl','Levering-Info',0),(171412,4762,'fi','Toimitus Info',0),(171413,4762,'no','Levering Info',0),(171414,4762,'da','Levering Info',0),(171415,4762,'ko','ë°°ë‹¬ ì •ë³´',0),(171416,4762,'he','×¤×¨×˜×™ ×ž×©×œ×•×—',0),(171417,4762,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(171418,4762,'zh','é…é€ä¿¡æ¯\r\n',0),(171419,4762,'sv','Leverans information',0),(171420,4762,'it','Informazioni di consegna',0),(171421,4762,'tl','',0),(171422,4762,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(171423,4762,'hi','à¤¡à¤¿à¤²à¤¿à¤µà¤°à¥€ à¤‡à¤¨à¥à¤«à¥‹',0),(171424,4762,'ms','Info penghantaran',0),(171425,4762,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(171426,4762,'fr','Info livraison',0),(171427,4762,'jp','é…?é€?æƒ…å ±',0),(171428,4762,'pt','InformaÃ§Ã£o de entrega',0),(171429,4762,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐµ',0),(171430,4762,'es','Info de Entrega',0),(171431,4762,'de','Lieferung Info',0),(171432,4762,'en','Delivery Info',0),(171433,4763,'is','',0),(171434,4763,'dr','Ù…Ù‚Ø¯Ø§Ø± ØªØ­ÙˆÙŠÙ„ Ø¨Ø§ Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´  Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯ ',0),(171435,4763,'pr','Ù…Ù‚Ø¯Ø§Ø± ØªØ­ÙˆÙŠÙ„ Ø¨Ø§ Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´  Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯ ',0),(171436,4763,'tr','Teslimat miktarÄ± sipariÅŸ miktarÄ± eÅŸleÅŸmiyor',0),(171437,4763,'pl','Dostawy iloÅ›Ä‡ nie odpowiada iloÅ›ci zamÃ³wienia',0),(171438,4763,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ðµ ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð° Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(171439,4763,'ur','Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©Û’ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº',0),(171440,4763,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ Ð½Ðµ Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(171441,4763,'vi','Sá»‘ LÆ°á»£ng Giao HÃ ng KhÃ´ng PhÃ¹ Há»£p Vá»›i Sá»‘ LÆ°á»£ng Äáº·t HÃ ng',0),(171442,4763,'af','Afleweringshoeveelheid harmonieer nie met Bestel Hoeveelheid',0),(171443,4763,'ro','Cantitatea de livrare nu se potriveÅŸte cu cantitatea din comanda',0),(171444,4763,'et','Kohale toodud kogus ei vasta tellitud kogusele',0),(171445,4763,'si','KoliÄino se ne ujema z koliÄino naloga',0),(171446,4763,'ba','Jumlah pengiriman tidak cocok kuantitas Order',0),(171447,4763,'nl','Levering hoeveelheid komt niet overeen met het orderaantal',0),(171448,4763,'fi','ToimitusmÃ¤Ã¤rÃ¤ ei vastaa tilauksen mÃ¤Ã¤rÃ¤',0),(171449,4763,'no','Levering antallet ikke samsvarer med antallet',0),(171450,4763,'da','Levering mÃ¦ngde svarer ikke ordrestÃ¸rrelse',0),(171451,4763,'ko','ë‚©í’ˆ ìˆ˜ëŸ‰ ì£¼ë¬¸ ìˆ˜ëŸ‰ì„ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(171452,4763,'he','×›×ž×•×ª ×ž×©×œ×•×— ××™× ×• ×ª×•×× ×›×ž×•×ª ×”×”×–×ž× ×”',0),(171453,4763,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚ Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î Î¿Ïƒ',0),(171454,4763,'zh','äº¤è´§æ•°é‡è®¢è´­æ•°é‡ä¸åŒ¹é…\r\n',0),(171455,4763,'sv','Leverans antalet matchar inte orderkvantiteten',0),(171456,4763,'it','Le quantitÃ  da consegnare non corrispondono a quelle ordinate',0),(171457,4763,'tl','',0),(171458,4763,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3617;&#3656;&#3626;&#3633;&#3617;&#3614;&#3633;&#3609;&#3608;&#3660;&#3585;&#3633;&#3610;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3',0),(171459,4763,'hi','à¤¡à¤¿à¤²à¤¿à¤µà¤°à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(171460,4763,'ms','Kuantiti penghantaran tidak padan dengan kuantiti pesanan',0),(171461,4763,'ar','ØªØ³Ù„ÙŠÙ… Ø§Ù„ÙƒÙ…ÙŠØ© Ù„Ø§ ØªØ·Ø§Ø¨Ù‚ \"ÙƒÙ…ÙŠØ© Ø£Ù…Ø± Ø§Ù„ØªÙˆØ±ÙŠØ¯\"',0),(171462,4763,'fr','QuantitÃ© livrÃ©e ne correspond pas Ã  la quantitÃ© d\'ordre',0),(171463,4763,'jp','é…?é€?æ•°é‡?ã?Œæ³¨æ–‡æ•°é‡?ã?¨é?•ã?„ã?¾ã?™',0),(171464,4763,'pt','Quantidade de entrega nÃ£o Ã© compatÃ­vel com a quantidade da ordem',0),(171465,4763,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ñƒ Ð—Ð°ÐºÐ°Ð·Ð°',0),(171466,4763,'es','Cantidad de Entrega no ',0),(171467,4763,'de','Bestellmenge von Liefermenge nicht Ã¼berein.',0),(171468,4763,'en','Delivery Quantity does not match Order Quantity',0),(171469,4764,'is','',0),(171470,4764,'dr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ   ØªØ­ÙˆÙŠÙ„ Ø¯Ø§Ø¯Ù†  ',0),(171471,4764,'pr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ   ØªØ­ÙˆÙŠÙ„ Ø¯Ø§Ø¯Ù†  ',0),(171472,4764,'tr','Sunun nasÄ±l',0),(171473,4764,'pl','DostarczyÄ‡ jak',0),(171474,4764,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÑÑ‚ ÐºÐ°Ðº',0),(171475,4764,'ur','Ù†Ø¬Ø§Øª Ú©ÛŒØ³Û’',0),(171476,4764,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð¸ ÐºÐ°ÐºÐ¾',0),(171477,4764,'vi','Giao nháº­n nhÆ° tháº¿ nÃ o',0),(171478,4764,'af','Lewer hoe',0),(171479,4764,'ro','Livra cum',0),(171480,4764,'et','Pakkuda kuidas',0),(171481,4764,'si','Zagotavljanje kako',0),(171482,4764,'ba','Memberikan bagaimana',0),(171483,4764,'nl','Leveren hoe',0),(171484,4764,'fi','Antaa miten',0),(171485,4764,'no','Levere hvordan',0),(171486,4764,'da','Levere hvordan',0),(171487,4764,'ko','ì œê³µ ë°©ë²•',0),(171488,4764,'he','×›×™×¦×“ ×œ×©×œ×•×—',0),(171489,4764,'el','Î Î±ÏÎ±Î´ÏŽÏƒÎµÎ¹ Ï€ÏŽÏ‚',0),(171490,4764,'zh','å¦‚ä½•é€è´§\r\n',0),(171491,4764,'sv','Leverera hur',0),(171492,4764,'it','ModalitÃ  di spedizione',0),(171493,4764,'tl','',0),(171494,4764,'th','&#3626;&#3656;&#3591;&#3617;&#3629;&#3610;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3619;',0),(171495,4764,'hi','à¤‰à¤¦à¥à¤§à¤¾à¤° à¤•à¥ˆà¤¸à¥‡',0),(171496,4764,'ms','Menyampaikan bagaimana',0),(171497,4764,'ar','ØªØ³Ù„ÙŠÙ… ÙƒÙŠÙ',0),(171498,4764,'fr','Livrer comment',0),(171499,4764,'jp','é…?é€?æ³•',0),(171500,4764,'pt','Entregar como',0),(171501,4764,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ ÐºÐ°Ðº',0),(171502,4764,'es','Entregar Como',0),(171503,4764,'de','Liefern wie',0),(171504,4764,'en','Deliver How',0),(171505,4765,'is','',0),(171506,4765,'dr','ØªØ­ÙˆÙŠÙ„ Ø¯Ø§Ø¯Ù†  Ø¨Ù‡ Ù†Ø§Ù… ',0),(171507,4765,'pr','ØªØ­ÙˆÙŠÙ„ Ø¯Ø§Ø¯Ù†  Ø¨Ù‡ Ù†Ø§Ù… ',0),(171508,4765,'tr','Teslim adÄ±',0),(171509,4765,'pl','Dostawy do nazwy',0),(171510,4765,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð¾ Ð¸Ð¼ÐµÑ‚Ð¾',0),(171511,4765,'ur','Ù†Ø§Ù… ØªØ±Ø³ÛŒÙ„',0),(171512,4765,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð° Ñƒ Ð¸Ð¼Ðµ',0),(171513,4765,'vi','Chuyá»ƒn tá»›i TÃªn',0),(171514,4765,'af','Aflewering aan Naam',0),(171515,4765,'ro','Livrare la numele',0),(171516,4765,'et','Tarne nimi',0),(171517,4765,'si','Dostava za ime',0),(171518,4765,'ba','Pengiriman ke nama',0),(171519,4765,'nl','Levering aan naam',0),(171520,4765,'fi','Toimituksen nimi',0),(171521,4765,'no','Levering til navn',0),(171522,4765,'da','Levering til navn',0),(171523,4765,'ko','ì´ë¦„ì— ë°°ë‹¬',0),(171524,4765,'he','×ž×¡×™×¨×ª ×©×',0),(171525,4765,'el','Î Î±ÏÎ¬Î´Î¿ÏƒÎ· ÏƒÎµ ÏŒÎ½Î¿Î¼Î±',0),(171526,4765,'zh','é€è´§åˆ°åç§°\r\n',0),(171527,4765,'sv','Leverans till namn',0),(171528,4765,'it','Spedire al nominativo',0),(171529,4765,'tl','',0),(171530,4765,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3651;&#3627;&#3657;&#3612;&#3641;&#3657;&#3619;&#3633;&#3610;&#3594;&#3639;&#3656;&#3629;',0),(171531,4765,'hi','à¤¨à¤¾à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤²à¥€à¤µà¤°à¥€',0),(171532,4765,'ms','Penghantaran untuk nama',0),(171533,4765,'ar','Ø¥ÙŠØµØ§Ù„ Ø¨Ø§Ø³Ù…',0),(171534,4765,'fr','Livraison au nom',0),(171535,4765,'jp','å??å‰?ã?¸ã?®ç™ºé€?',0),(171536,4765,'pt','Entrega de nome',0),(171537,4765,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð² Ð¸Ð¼Ñ',0),(171538,4765,'es','Entregar a Nombre',0),(171539,4765,'de','Belieferung der Name',0),(171540,4765,'en','Delivery to Name',0),(171541,4766,'is','',0),(171542,4766,'dr','Ø´Ø±Ø­ Ø±ÙˆÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(171543,4766,'pr','Ø´Ø±Ø­ Ø±ÙˆÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(171544,4766,'tr','Teklif Ã¼zerinde aÃ§Ä±klamasÄ±',0),(171545,4766,'pl','Opis oferty',0),(171546,4766,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð°',0),(171547,4766,'ur','ÙˆØµÙ Ø§Ù‚ØªØ¨Ø§Ø³ Ù¾Ø±',0),(171548,4766,'sr','ÐžÐ¿Ð¸Ñ Ð½Ð° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(171549,4766,'vi','MÃ´ táº£ bÃ¡o giÃ¡',0),(171550,4766,'af','Beskrywing op Kwotasie',0),(171551,4766,'ro','Descriere ofertÄƒ',0),(171552,4766,'et','Hinnapakkumise kirjeldus',0),(171553,4766,'si','Opis na ponudbo',0),(171554,4766,'ba','Deskripsi pada kutipan',0),(171555,4766,'nl','Beschrijving op offerte',0),(171556,4766,'fi','Kuvaus Quote',0),(171557,4766,'no','Beskrivelse av tilbud',0),(171558,4766,'da','Beskrivelse pÃ¥ tilbud',0),(171559,4766,'ko','ê²¬ì ì— ëŒ€ í•œ ì„¤ëª…',0),(171560,4766,'he','×ª×™××•×¨ ×¢×œ ×”×¦×¢×ª ×ž×—×™×¨',0),(171561,4766,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® ÏƒÎµ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(171562,4766,'zh','æè¿°æŠ¥ä»·\r\n',0),(171563,4766,'sv','Beskrivning pÃ¥ offert',0),(171564,4766,'it','Descrizione su preventivo',0),(171565,4766,'tl','',0),(171566,4766,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(171567,4766,'hi','à¤¬à¥‹à¤²à¥€ à¤ªà¤° à¤µà¤¿à¤µà¤°à¤£',0),(171568,4766,'ms','Keterangan mengenai sebut harga',0),(171569,4766,'ar','Ø§Ù„ÙˆØµÙ Ø¹Ù„Ù‰ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(171570,4766,'fr','Description sur devis',0),(171571,4766,'jp','è¦‹ç©?ã‚Šã?®è¨˜è¿°',0),(171572,4766,'pt','DescriÃ§Ã£o na citaÃ§Ã£o',0),(171573,4766,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(171574,4766,'es','DescripciÃ³n en la CotizaciÃ³n',0),(171575,4766,'de','Beschreibung auf Quote',0),(171576,4766,'en','Description on Quote',0),(171577,4767,'is','',0),(171578,4767,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ØªØ°ÙƒØ±',0),(171579,4767,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ØªØ°ÙƒØ±',0),(171580,4767,'tr','Bildirim iÃ§in e-posta',0),(171581,4767,'pl','E-mail dla powiadomieÅ„',0),(171582,4767,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð·Ð° Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(171583,4767,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹ Ú©Û’ Ù„ÛŒÛ’',0),(171584,4767,'sr','Ð• -Ð¿Ð¾ÑˆÑ‚Ðµ Ð·Ð° Ð¾Ð±Ð°Ð²Ð¸Ñ˜ÐµÑÑ‚Ð¸',0),(171585,4767,'vi','Email thÃ´ng bÃ¡o',0),(171586,4767,'af','E-pos vir Kennisgewings',0),(171587,4767,'ro','E-mail de notificare',0),(171588,4767,'et','E-posti teatamise',0),(171589,4767,'si','Email za obvestilo',0),(171590,4767,'ba','Email pemberitahuan',0),(171591,4767,'nl','E-mail voor kennisgeving',0),(171592,4767,'fi','SÃ¤hkÃ¶posti ilmoituksen',0),(171593,4767,'no','E-post for varsel',0),(171594,4767,'da','Email til anmeldelsen',0),(171595,4767,'ko','ì•Œë¦¼ ì´ë©”ì¼',0),(171596,4767,'he','×“×•× ×¢×‘×•×¨ ×“×™×•×•×—',0),(171597,4767,'el','E-mail Î³Î¹Î± Ï„Î·Î½ ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(171598,4767,'zh','ç”µå­é‚®ä»¶é€šçŸ¥\r\n',0),(171599,4767,'sv','E-post fÃ¶r anmÃ¤lan',0),(171600,4767,'it','E-mail per la notifica',0),(171601,4767,'tl','',0),(171602,4767,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3649;&#3592;&#3657;&#3591;',0),(171603,4767,'hi','à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤ˆà¤®à¥‡à¤²',0),(171604,4767,'ms','E-mel untuk makluman',0),(171605,4767,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø£Ø®Ø·Ø§Ø±',0),(171606,4767,'fr','Courriel de Notification',0),(171607,4767,'jp','é€šçŸ¥ï¼¥ãƒ¡ãƒ¼ãƒ«',0),(171608,4767,'pt','E-mail de notificaÃ§Ã£o',0),(171609,4767,'ru','Email Ð´Ð»Ñ Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(171610,4767,'es','Email para NotificaciÃ³n',0),(171611,4767,'de','E-Mail Benachrichtigung',0),(171612,4767,'en','Email for Notification',0),(171613,4768,'is','',0),(171614,4768,'dr','Ø«Ø¨Øª Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù… ',0),(171615,4768,'pr','Ø«Ø¨Øª Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù… ',0),(171616,4768,'tr','Form numarasÄ± girin',0),(171617,4768,'pl','WprowadÅº numer formularza',0),(171618,4768,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð°',0),(171619,4768,'ur','Ø´Ú©Ù„ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(171620,4768,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð¾Ð±Ñ€Ð°ÑÑ†Ð°',0),(171621,4768,'vi','Nháº­p sá»‘ máº«u',0),(171622,4768,'af','Voer Vormnommer In',0),(171623,4768,'ro','IntroduceÅ£i numÄƒrul de forma',0),(171624,4768,'et','Sisestage vormi Number',0),(171625,4768,'si','Å tevilka obrazca',0),(171626,4768,'ba','Masukkan nomor bentuk',0),(171627,4768,'nl','Formuliernummer invoeren',0),(171628,4768,'fi','Lomakkeen numero',0),(171629,4768,'no','Angi Skjemanummer',0),(171630,4768,'da','Angiv Form nummer',0),(171631,4768,'ko','ì–‘ì‹ ë²ˆí˜¸ ìž…ë ¥',0),(171632,4768,'he','×”×–×Ÿ ×ž×¡×¤×¨ ×˜×•×¤×¡',0),(171633,4768,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î¼Î¿ÏÏ†Î®',0),(171634,4768,'zh','è¾“å…¥è¡¨æ ¼ç¼–å·',0),(171635,4768,'sv','Ange tal Form',0),(171636,4768,'it','Immettere il numero del modulo',0),(171637,4768,'tl','',0),(171638,4768,'th','&#3611;&#3657;&#3629;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3649;&#3610;&#3610;&#3615;&#3629;&#3619;&#3660;&#3617;',0),(171639,4768,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(171640,4768,'ms','Masukkan nombor borang',0),(171641,4768,'ar','Ù‚Ù… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø§Ù„Ù†Ù…ÙˆØ°Ø¬',0),(171642,4768,'fr','Entrez le numÃ©ro du formulaire',0),(171643,4768,'jp','ãƒ•ã‚©ãƒ¼ãƒ ç•ªå?·ã?®å…¥åŠ›',0),(171644,4768,'pt','Digite o nÃºmero do formulÃ¡rio',0),(171645,4768,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ñ„Ð¾Ñ€Ð¼Ñ‹',0),(171646,4768,'es','Introducir NÃºmero del Formulario',0),(171647,4768,'de','Geben Sie Formularnummer',0),(171648,4768,'en','Enter Form Number',0),(171649,4769,'is','',0),(171650,4769,'dr','Ø«Ø¨Øª Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù',0),(171651,4769,'pr','Ø«Ø¨Øª Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù',0),(171652,4769,'tr','POD numarasÄ±nÄ± girin',0),(171653,4769,'pl','WprowadÅº numer POD',0),(171654,4769,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° POD',0),(171655,4769,'ur','Ù¾Ú¾Ù„ÛŒ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(171656,4769,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ ÐºÐ°Ð¿ÑÑƒÐ»Ð°',0),(171657,4769,'vi','Nháº­p sá»‘ Ä‘Æ¡n mua hÃ ng',0),(171658,4769,'af','POA Nommer Invoer',0),(171659,4769,'ro','IntroduceÅ£i numÄƒrul de POD',0),(171660,4769,'et','Sisestage POD Number',0),(171661,4769,'si','Å tevilka POD',0),(171662,4769,'ba','Masukkan nomor POD',0),(171663,4769,'nl','Nummer van de POD',0),(171664,4769,'fi','POD numero',0),(171665,4769,'no','Angi POD nummer',0),(171666,4769,'da','Skriv POD tal',0),(171667,4769,'ko','í¬ë“œ ë²ˆí˜¸ ìž…ë ¥',0),(171668,4769,'he','×”×–×Ÿ ×ž×¡×¤×¨ POD',0),(171669,4769,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ POD',0),(171670,4769,'zh','è¾“å…¥è´§åˆ°ä»˜æ¬¾æ•°\r\n',0),(171671,4769,'sv','Ange POD',0),(171672,4769,'it','Immettere il numero POD',0),(171673,4769,'tl','',0),(171674,4769,'th','&#3611;&#3657;&#3629;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586; POD',0),(171675,4769,'hi','à¤«à¤²à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(171676,4769,'ms','Masukkan nombor POD',0),(171677,4769,'ar','Ù‚Ù… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø¬Ø±Ø§Ø¨',0),(171678,4769,'fr','Entrez le nombre POD',0),(171679,4769,'jp','ï¼°ï¼¯ï¼¤ç•ªå?·ã?®å…¥åŠ›',0),(171680,4769,'pt','Digite o nÃºmero do POD',0),(171681,4769,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ð¾Ð´',0),(171682,4769,'es','Introducir NÃºmero de POD',0),(171683,4769,'de','Geben Sie POD Nummer',0),(171684,4769,'en','Enter POD Number',0),(171685,4770,'is','',0),(171686,4770,'dr','(ÙˆØ§Ø±ÙˆÙ†Ù‡',0),(171687,4770,'pr','Ø±Ùˆ Ø¨Ù‡ Ù¾Ø§ÙŠÙŠÙ† (ÙˆØ§Ø±ÙˆÙ†Ù‡',0),(171688,4770,'tr','YÃ¼z aÅŸaÄŸÄ±',0),(171689,4770,'pl','Wierzchem do doÅ‚u',0),(171690,4770,'bg','Ð¡ Ð»Ð¸Ñ†ÐµÑ‚Ð¾ Ð½Ð°Ð´Ð¾Ð»Ñƒ',0),(171691,4770,'ur','Ú†ÛØ±Û Ù¾Ø³Øª',0),(171692,4770,'sr','Ð›Ð¸Ñ†ÐµÐ¼ Ð½Ð° Ð´Ð¾Ð»Ðµ',0),(171693,4770,'vi','Ãšp máº·t xuá»‘ng',0),(171694,4770,'af','Bokant onder',0),(171695,4770,'ro','Cu faÈ›a Ã®n jos',0),(171696,4770,'et','Mast allpool',0),(171697,4770,'si','Obrnjena navzdol',0),(171698,4770,'ba','Menghadap ke bawah',0),(171699,4770,'nl','Bedrukte zijde naar beneden',0),(171700,4770,'fi','Kuvapuoli alaspÃ¤in',0),(171701,4770,'no','Skriften ned',0),(171702,4770,'da','Forsiden nedad',0),(171703,4770,'ko','ì•„ëž˜ ì–¼êµ´',0),(171704,4770,'he','×¢× ×”×¤× ×™× ×œ×ž×˜×”',0),(171705,4770,'el','ÎŒÏˆÎ· Ï€ÏÎ¿Ï‚ Ï„Î± ÎºÎ¬Ï„Ï‰',0),(171706,4770,'zh','æœä¸‹\r\n',0),(171707,4770,'sv','Framsidan nedÃ¥t',0),(171708,4770,'it','Faccia in giÃ¹',0),(171709,4770,'tl','',0),(171710,4770,'th','&#3588;&#3623;&#3656;&#3635;&#3627;&#3609;&#3657;&#3634;',0),(171711,4770,'hi','à¤šà¥‡à¤¹à¤°à¤¾ à¤¨à¥€à¤šà¥‡',0),(171712,4770,'ms','Bawah',0),(171713,4770,'ar','Ø§Ù„ÙˆØ¬Ù‡ Ù„Ù„Ø£Ø³ÙÙ„',0),(171714,4770,'fr','Face vers le bas',0),(171715,4770,'jp','è¡¨ã?Œä¸‹',0),(171716,4770,'pt','Viradas para baixo',0),(171717,4770,'ru','Ð›Ð¸Ñ†Ð¾Ð¼ Ð²Ð½Ð¸Ð·',0),(171718,4770,'es','Boca Abajo',0),(171719,4770,'de','Verdeckte',0),(171720,4770,'en','Face Down',0),(171721,4771,'is','',0),(171722,4771,'dr','Ø±Ùˆ Ø¨Ù‡ Ø¨Ø§Ù„Ø§ ',0),(171723,4771,'pr','Ø±Ùˆ Ø¨Ù‡ Ø¨Ø§Ù„Ø§ ',0),(171724,4771,'tr','YukarÄ± dÃ¶nÃ¼k',0),(171725,4771,'pl','Wierzchem do gÃ³ry',0),(171726,4771,'bg','Ð¡ Ð»Ð¸Ñ†ÐµÑ‚Ð¾ Ð½Ð°Ð³Ð¾Ñ€Ðµ',0),(171727,4771,'ur','Ù…Ù‚Ø§Ø¨Ù„Û',0),(171728,4771,'sr','Ð›Ð¸Ñ†ÐµÐ¼ Ð½Ð°Ð³Ð¾Ñ€Ðµ',0),(171729,4771,'vi','Ngá»­a máº·t lÃªn',0),(171730,4771,'af','Die gesig',0),(171731,4771,'ro','Cu fata in sus',0),(171732,4771,'et','Lahtine',0),(171733,4771,'si','SooÄiti',0),(171734,4771,'ba','Menghadapi',0),(171735,4771,'nl','Onder ogen zien',0),(171736,4771,'fi','Kuvapuoli ylÃ¶spÃ¤in',0),(171737,4771,'no','Forside opp',0),(171738,4771,'da','Opad',0),(171739,4771,'ko','ì–¼êµ´',0),(171740,4771,'he','×¤× ×™× ×œ×ž×¢×œ×”',0),(171741,4771,'el','Î‘Î½Ï„Î¹Î¼ÎµÏ„Ï‰Ï€Î¯ÏƒÎ¿Ï…Î¼Îµ',0),(171742,4771,'zh','æ­£è§†\r\n',0),(171743,4771,'sv','MÃ¶ta',0),(171744,4771,'it','Faccia in su',0),(171745,4771,'tl','',0),(171746,4771,'th','&#3648;&#3591;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(171747,4771,'hi','à¤•à¤¾ à¤¸à¤¾à¤®à¤¨à¤¾',0),(171748,4771,'ms','Menghadapi cabaran-',0),(171749,4771,'ar','Ø§Ù„ÙˆØ¬Ù‡ Ù„Ù„Ø£Ø¹Ù„Ù‰',0),(171750,4771,'fr','Vers le haut',0),(171751,4771,'jp','è¡¨ã?Œä¸Š',0),(171752,4771,'pt','Face para cima',0),(171753,4771,'ru','Ð›Ð¸Ñ†Ð¾Ð¼ Ð²Ð²ÐµÑ€Ñ…',0),(171754,4771,'es','Boca Arriba',0),(171755,4771,'de','Aufgedeckt',0),(171756,4771,'en','Face Up',0),(171757,4772,'is','',0),(171758,4772,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„Ù‡Ø§ÙŠ Ù†Ù‡Ø§ÙŠÙŠ ',0),(171759,4772,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„Ù‡Ø§ÙŠ Ù†Ù‡Ø§ÙŠÙŠ ',0),(171760,4772,'tr','Son talimatlar',0),(171761,4772,'pl','Ostatnie instrukcje',0),(171762,4772,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(171763,4772,'ur','ÙØ§Ø¦Ù†Ù„ ÛØ¯Ø§ÛŒØ§Øª',0),(171764,4772,'sr','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ñ˜Ðµ',0),(171765,4772,'vi','Chá»‰ dáº©n cuá»‘i cÃ¹ng',0),(171766,4772,'af','Finale instruksies',0),(171767,4772,'ro','InstrucÅ£iuni de finalÄƒ',0),(171768,4772,'et','LÃµplikud juhised',0),(171769,4772,'si','KonÄna navodila',0),(171770,4772,'ba','Instruksi terakhir',0),(171771,4772,'nl','Laatste instructies',0),(171772,4772,'fi','Lopulliset ohjeet',0),(171773,4772,'no','Endelige instruksjoner',0),(171774,4772,'da','Endelige instruktioner',0),(171775,4772,'ko','ìµœì¢… ì§€ì¹¨',0),(171776,4772,'he','×”×•×¨××•×ª ××—×¨×•× ×•×ª',0),(171777,4772,'el','Î¤ÎµÎ»Î¹ÎºÎ® Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(171778,4772,'zh','æœ€åŽæŒ‡ç¤º\r\n',0),(171779,4772,'sv','Sista instruktionerna',0),(171780,4772,'it','Istruzioni finali',0),(171781,4772,'tl','',0),(171782,4772,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(171783,4772,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(171784,4772,'ms','Arahan akhir',0),(171785,4772,'ar','Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ©',0),(171786,4772,'fr','DerniÃ¨res Instructions',0),(171787,4772,'jp','æœ€çµ‚æ”¯æŒ?',0),(171788,4772,'pt','InstruÃ§Ãµes finais',0),(171789,4772,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(171790,4772,'es','Instrucciones Finales',0),(171791,4772,'de','Letzte Anweisungen',0),(171792,4772,'en','Final Instructions',0),(171793,4773,'is','',0),(171794,4773,'dr','Ù†Ø§Ù… ÙØ±Ù… ',0),(171795,4773,'pr','Ù†Ø§Ù… ÙØ±Ù… ',0),(171796,4773,'tr','Formu',0),(171797,4773,'pl','Formularz',0),(171798,4773,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€',0),(171799,4773,'ur','Ø´Ú©Ù„',0),(171800,4773,'sr','ÐžÐ±Ñ€Ð°Ð·Ð°Ñ†',0),(171801,4773,'vi','Tá»«',0),(171802,4773,'af','Vorm',0),(171803,4773,'ro','Forma',0),(171804,4773,'et','Vorm',0),(171805,4773,'si','Obrazec',0),(171806,4773,'ba','Formulir',0),(171807,4773,'nl','Formulier',0),(171808,4773,'fi','Lomake',0),(171809,4773,'no','Skjemaet',0),(171810,4773,'da','Form',0),(171811,4773,'ko','ì–‘ì‹',0),(171812,4773,'he','×˜×•×¤×¡',0),(171813,4773,'el','ÎœÎ¿ÏÏ†Î®',0),(171814,4773,'zh','è¡¨æ ¼\r\n',0),(171815,4773,'sv','Form',0),(171816,4773,'it','Modulo',0),(171817,4773,'tl','',0),(171818,4773,'th','&#3615;&#3629;&#3619;&#3660;&#3617;',0),(171819,4773,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤°',0),(171820,4773,'ms','Borang',0),(171821,4773,'ar','Ø§Ù„Ù†Ù…ÙˆØ°Ø¬',0),(171822,4773,'fr','Formulaire',0),(171823,4773,'jp','ãƒ•ã‚©ãƒ¼ãƒ ',0),(171824,4773,'pt','FormulÃ¡rio',0),(171825,4773,'ru','Ð¤Ð¾Ñ€Ð¼Ð°',0),(171826,4773,'es','Formulario',0),(171827,4773,'de','Formular',0),(171828,4773,'en','Form',0),(171829,4774,'is','',0),(171830,4774,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù… ',0),(171831,4774,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù… ',0),(171832,4774,'tr','Form numarasÄ±',0),(171833,4774,'pl','Numer formularza',0),(171834,4774,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€Ð°',0),(171835,4774,'ur','ÙØ§Ø±Ù… Ù†Ù…Ø¨Ø±',0),(171836,4774,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¾Ð±Ñ€Ð°ÑÑ†Ð°',0),(171837,4774,'vi','Tá»« Sá»‘',0),(171838,4774,'af','Vormnommer',0),(171839,4774,'ro','Formularul numÄƒrul',0),(171840,4774,'et','Vormi Number',0),(171841,4774,'si','Å tevilka obrazca',0),(171842,4774,'ba','Formulir Nomor',0),(171843,4774,'nl','Formuliernummer',0),(171844,4774,'fi','Lomakkeen numero',0),(171845,4774,'no','Skjemanummer',0),(171846,4774,'da','Form nummer',0),(171847,4774,'ko','ì–‘ì‹ ë²ˆí˜¸',0),(171848,4774,'he','×ž×¡×¤×¨ ×˜×•×¤×¡',0),(171849,4774,'el','ÎœÎ¿ÏÏ†Î® Î±ÏÎ¹Î¸Î¼Î¿Ï',0),(171850,4774,'zh','è¡¨æ ¼ç¼–å·\r\n',0),(171851,4774,'sv','Nummer',0),(171852,4774,'it','Numero di forma',0),(171853,4774,'tl','',0),(171854,4774,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3615;&#3629;&#3619;&#3660;&#3617;',0),(171855,4774,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(171856,4774,'ms','Nombor borang',0),(171857,4774,'ar','Ø±Ù‚Ù… Ø§Ù„Ù†Ù…ÙˆØ°Ø¬',0),(171858,4774,'fr','NumÃ©ro du formulaire',0),(171859,4774,'jp','ãƒ•ã‚©ãƒ¼ãƒ ç•ªå?·',0),(171860,4774,'pt','NÃºmero do formulÃ¡rio',0),(171861,4774,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¤Ð¾Ñ€Ð¼Ñ‹',0),(171862,4774,'es','NÃºmero de Formulario',0),(171863,4774,'de','Formularnummer',0),(171864,4774,'en','Form Number',0),(171865,4775,'is','',0),(171866,4775,'dr','( Ù…Ø¬ÙˆØ² ) Ø´ØºÙ„ ',0),(171867,4775,'pr','Ø¨Ø±Ø§ÙŠ Ø¨Ù„ÙŠØ· ( Ù…Ø¬ÙˆØ² ) Ø´ØºÙ„ ',0),(171868,4775,'tr','Ä°ÅŸ bileti iÃ§in',0),(171869,4775,'pl','za bilet',0),(171870,4775,'bg','Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð±Ð¸Ð»ÐµÑ‚',0),(171871,4775,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù¹Ú©Ù¹ Ú©Û’ Ù„Ø¦Û’',0),(171872,4775,'sr','Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾ ÐºÐ°Ñ€Ñ‚Ð°',0),(171873,4775,'vi','dÃ nh cho Phiáº¿u Job',0),(171874,4775,'af','vir werk kaartjie',0),(171875,4775,'ro','pentru un bilet de Job',0),(171876,4775,'et','TÃ¶Ã¶ pilet',0),(171877,4775,'si','za vstopnico za zaposlitev',0),(171878,4775,'ba','untuk pekerjaan Tiket',0),(171879,4775,'nl','voor opdrachtticket',0),(171880,4775,'fi','TyÃ¶ lippu',0),(171881,4775,'no','Jobb billett',0),(171882,4775,'da','for jobbillet',0),(171883,4775,'ko','ìž‘ì—… í‹°ì¼“ì— ëŒ€ í•œ',0),(171884,4775,'he','×¢×‘×•×¨ ×›×¨×˜×™×¡ ×¢×‘×•×“×”',0),(171885,4775,'el','Î³Î¹Î± Job Ticket',0),(171886,4775,'zh','ä½œä¸šæœºç¥¨\r\n',0),(171887,4775,'sv','fÃ¶r jobb biljett',0),(171888,4775,'it','per Job Ticket',0),(171889,4775,'tl','',0),(171890,4775,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3657;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(171891,4775,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤Ÿà¤¿à¤•à¤Ÿ',0),(171892,4775,'ms','bagi Tiket kerja',0),(171893,4775,'ar','Ù„ÙˆØ¸ÙŠÙØ© Ø­Ø¬Ø² Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(171894,4775,'fr','pour le bon de travail',0),(171895,4775,'jp','ä½œæ¥­ç¥¨ã?®',0),(171896,4775,'pt','para tÃ­quete de trabalho',0),(171897,4775,'ru','Ð´Ð»Ñ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(171898,4775,'es','Para Boleto de Trabajo',0),(171899,4775,'de','fÃ¼r Job-Ticket',0),(171900,4775,'en','for Job Ticket',0),(171901,4776,'is','',0),(171902,4776,'dr','Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(171903,4776,'pr','Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(171904,4776,'tr','Stoktan',0),(171905,4776,'pl','Od rÄ™ki',0),(171906,4776,'bg','ÐžÑ‚ ÑÐºÐ»Ð°Ð´',0),(171907,4776,'ur','Ø§Ø³Ù¹Ø§Ú© Ø³Û’',0),(171908,4776,'sr','Ð˜Ð· Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ð°',0),(171909,4776,'vi','Tá»« hÃ ng tá»“n',0),(171910,4776,'af','Vanaf Voorraad',0),(171911,4776,'ro','Din stoc',0),(171912,4776,'et','Laost',0),(171913,4776,'si','Iz zalog',0),(171914,4776,'ba','Dari saham',0),(171915,4776,'nl','Uit voorraad',0),(171916,4776,'fi','Varastosta',0),(171917,4776,'no','Fra lager',0),(171918,4776,'da','Fra lager',0),(171919,4776,'ko','ì£¼ì‹ì—ì„œ',0),(171920,4776,'he','×ž×”×ž×œ××™',0),(171921,4776,'el','Î‘Ï€ÏŒ Ï„Î± Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î±',0),(171922,4776,'zh','çŽ°è´§\r\n',0),(171923,4776,'sv','Lagervara',0),(171924,4776,'it','Da Stock',0),(171925,4776,'tl','',0),(171926,4776,'th','&#3592;&#3634;&#3585;&#3588;&#3621;&#3633;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(171927,4776,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥‡',0),(171928,4776,'ms','Daripada stok',0),(171929,4776,'ar','Ù…Ù† Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(171930,4776,'fr','Du Stock',0),(171931,4776,'jp','åœ¨åº«ã?‹ã‚‰',0),(171932,4776,'pt','Do estoque',0),(171933,4776,'ru','Ð¡Ð¾ ÑÐºÐ»Ð°Ð´Ð°',0),(171934,4776,'es','De stock',0),(171935,4776,'de','Ab Lager',0),(171936,4776,'en','From Stock',0),(171937,4777,'is','',0),(171938,4777,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ù…Ù„ ',0),(171939,4777,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ù…Ù„ ',0),(171940,4777,'tr','TÃ¼m detaylar',0),(171941,4777,'pl','PeÅ‚ne szczegÃ³Å‚y',0),(171942,4777,'bg','ÐŸÑŠÐ»Ð½Ð¸ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸',0),(171943,4777,'ur','Ù…Ú©Ù…Ù„ ØªÙØµÛŒÙ„Ø§Øª',0),(171944,4777,'sr','Ð¡Ð²Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ð¸',0),(171945,4777,'vi','Chi tiáº¿t Ä‘áº§y Ä‘á»§',0),(171946,4777,'af','Volle Details',0),(171947,4777,'ro','Detalii complete',0),(171948,4777,'et','TÃ¤ielikud andmed',0),(171949,4777,'si','Vse podrobnosti',0),(171950,4777,'ba','Rincian lengkap',0),(171951,4777,'nl','Volledige Details',0),(171952,4777,'fi','TÃ¤ydelliset tiedot',0),(171953,4777,'no','Detaljer',0),(171954,4777,'da','Fuld detaljer',0),(171955,4777,'ko','ìƒì„¸',0),(171956,4777,'he','×œ×¤×¨×˜×™× ×ž×œ××™×',0),(171957,4777,'el','Î Î»Î®ÏÎµÎ¹Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(171958,4777,'zh','å…¨éƒ¨è¯¦ç»†èµ„æ–™\r\n',0),(171959,4777,'sv','FullstÃ¤ndig information',0),(171960,4777,'it','Dettagli completi',0),(171961,4777,'tl','',0),(171962,4777,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3648;&#3605;&#3655;&#3617;',0),(171963,4777,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤µà¤¿à¤µà¤°à¤£',0),(171964,4777,'ms','Butir-butir penuh',0),(171965,4777,'ar','ØªÙØ§ØµÙŠÙ„ ÙƒØ§Ù…Ù„Ø©',0),(171966,4777,'fr','Tous les dÃ©tails',0),(171967,4777,'jp','è©³ç´°',0),(171968,4777,'pt','Todos os detalhes',0),(171969,4777,'ru','ÐŸÐ¾Ð»Ð½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(171970,4777,'es','Detalles Completos',0),(171971,4777,'de','Alle Details',0),(171972,4777,'en','Full Details',0),(171973,4778,'is','',0),(171974,4778,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ø´ØºÙ„ ',0),(171975,4778,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ø´ØºÙ„ ',0),(171976,4778,'tr','Genel iÅŸ bilgileri',0),(171977,4778,'pl','Informacje ogÃ³lne zadanie',0),(171978,4778,'bg','ÐžÐ±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(171979,4778,'ur','Ø¬Ù†Ø±Ù„ Ø§ÛŒÙˆØ¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(171980,4778,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð¿Ð¾ÑÐ°Ð¾ Ð˜Ð½Ñ„Ð¾',0),(171981,4778,'vi','ThÃ´ng tin Job chung',0),(171982,4778,'af','Algemene Projek Inligting',0),(171983,4778,'ro','General Job Info',0),(171984,4778,'et','Ãœldine tÃ¶Ã¶ Info',0),(171985,4778,'si','SploÅ¡no delo Info',0),(171986,4778,'ba','Info pekerjaan umum',0),(171987,4778,'nl','Algemene baan Info',0),(171988,4778,'fi','Projektin yleistiedot',0),(171989,4778,'no','General jobb Info',0),(171990,4778,'da','General Job Info',0),(171991,4778,'ko','ì¼ë°˜ ìž‘ì—… ì •ë³´',0),(171992,4778,'he','×ž×™×“×¢ ×›×œ×œ×™ ×”×¢×‘×•×“×”',0),(171993,4778,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(171994,4778,'zh','ä¸€èˆ¬æ‹›è˜ä¿¡æ¯\r\n',0),(171995,4778,'sv','General jobb Info',0),(171996,4778,'it','Generale lavoro Info',0),(171997,4778,'tl','',0),(171998,4778,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3591;&#3634;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(171999,4778,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤¨à¥Œà¤•à¤°à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(172000,4778,'ms','Maklumat kerja am',0),(172001,4778,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¹Ø§Ù…Ø©',0),(172002,4778,'fr','GÃ©nÃ©rale d\'emploi Info',0),(172003,4778,'jp','ä¸€èˆ¬ä»•äº‹æƒ…å ±',0),(172004,4778,'pt','InformaÃ§Ã£o de emprego geral',0),(172005,4778,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(172006,4778,'es','Info General de Trabajo',0),(172007,4778,'de','Allgemeine Informationen zum Job',0),(172008,4778,'en','General Job Info',0),(172009,4779,'is','',0),(172010,4779,'dr','(ÙˆØ¸ÙŠÙÙ‡',0),(172011,4779,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø´ØºÙ„ (ÙˆØ¸ÙŠÙÙ‡',0),(172012,4779,'tr','Ä°ÅŸ ayrÄ±ntÄ±larÄ±',0),(172013,4779,'pl','SzczegÃ³Å‚y pracy',0),(172014,4779,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(172015,4779,'ur','Ø¬Ø§Ø¨ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(172016,4779,'sr','ÐŸÐ¾ÑÐ°Ð¾-Ð´ÐµÑ‚Ð°Ñ™Ð¸',0),(172017,4779,'vi','Chi Tiáº¿t Job',0),(172018,4779,'af','Kontrakwerk Besonderhede',0),(172019,4779,'ro','Detalii Job',0),(172020,4779,'et','TÃ¶Ã¶ Ã¼ksikasjad',0),(172021,4779,'si','Job podrobnosti',0),(172022,4779,'ba','Rincian pekerjaan',0),(172023,4779,'nl','Details vacature',0),(172024,4779,'fi','TyÃ¶n tiedot',0),(172025,4779,'no','Jobbdetaljer',0),(172026,4779,'da','Jobdetaljer',0),(172027,4779,'ko','ìž‘ì—… ì„¸ë¶€ ì‚¬í•­',0),(172028,4779,'he','×¤×¨×˜×™ ×”×¢×‘×•×“×”',0),(172029,4779,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(172030,4779,'zh','æ‹›è˜è¯¦æƒ…\r\n',0),(172031,4779,'sv','Jobbinformation',0),(172032,4779,'it','Particolari di lavoro',0),(172033,4779,'tl','',0),(172034,4779,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3591;&#3634;&#3609;',0),(172035,4779,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤µà¤¿à¤µà¤°à¤£',0),(172036,4779,'ms','Butir-butir kerja',0),(172037,4779,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(172038,4779,'fr','DÃ©tails sur l\'emploi',0),(172039,4779,'jp','ä»•äº‹è©³ç´°',0),(172040,4779,'pt','Detalhes do emprego',0),(172041,4779,'ru','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð²Ð°ÐºÐ°Ð½ÑÐ¸Ð¸',0),(172042,4779,'es','Trabajo Detalles',0),(172043,4779,'de','Job-Details',0),(172044,4779,'en','Job Details',0),(172045,4780,'is','',0),(172046,4780,'dr','(Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù… ) Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(172047,4780,'pr','Ø¨Ø±Ø§ÙŠ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú†Ø§Ù¾ â€“ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø³Ù‡Ø§Ù…(Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ) Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(172048,4780,'tr','YazdÄ±rma boyutu iÃ§in boÅŸ bÄ±rakÄ±n stok boyutu =',0),(172049,4780,'pl','Pozostaw puste do rozmiaru wydruku = wielkoÅ›ci stada',0),(172050,4780,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€ = Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ',0),(172051,4780,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø³Ø§Ø¦Ø² Ú©Û’ Ù„ÛŒÛ’ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº Ø§Ø³Ù¹Ø§Ú© Ø³Ø§Ø¦Ø² =',0),(172052,4780,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ Ð¾Ñ‚Ð¸ÑÐºÐ° = Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð°',0),(172053,4780,'vi','Äá»ƒ trá»‘ng Ä‘á»ƒ cá»¡ in=cá»¡ hÃ ng tá»“n',0),(172054,4780,'af','Laat blanko vir drukgrootte voorraad grootte =',0),(172055,4780,'ro','LÄƒsaÅ£i gol pentru dimensiunea imprimÄƒrii = dimensiunea stoc',0),(172056,4780,'et','JÃ¤tke tÃ¼hjaks prindisuuruse = varude suurust',0),(172057,4780,'si','Pustite prazno za tiskanje velikosti = velikost zalog',0),(172058,4780,'ba','Biarkan kosong untuk ukuran cetak = ukuran saham',0),(172059,4780,'nl','Laat leeg voor afdrukformaat = voorraad grootte',0),(172060,4780,'fi','TyhjÃ¤ tulostuskoko = kannan koon',0),(172061,4780,'no','Tomt for utskriftsstÃ¸rrelse = lager stÃ¸rrelse',0),(172062,4780,'da','Tomt for print stÃ¸rrelse = bestandsstÃ¸rrelse',0),(172063,4780,'ko','ì¸ì‡„ í¬ê¸°ì— ëŒ€ í•œ ë¹„ì›Œ ìž¬ê³  í¬ê¸° =',0),(172064,4780,'he','×ª×©××™×¨ ×¨×™×§ ×¢×‘×•×¨ ×’×•×“×œ ×”×“×¤×¡×” = ×’×•×“×œ ×ž× ×™×•×ª',0),(172065,4780,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î¼Î­Î³ÎµÎ¸Î¿Ï‚ = Ï„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(172066,4780,'zh','æ‰“å°å°ºå¯¸å¤§å°çš„ç•™ç™½=å­˜è´§å¤§å°\r\n',0),(172067,4780,'sv','LÃ¤mna tom fÃ¶r utskriftsstorlek = bestÃ¥ndets storlek',0),(172068,4780,'it','Lasciare vuoto per formato di stampa = dimensioni del materiale grezzo',0),(172069,4780,'tl','',0),(172070,4780,'th','&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3586;&#3609;&#3634;&#3604;&#3614;&#3636;&#3617;&#3614;&#3660;=&#3586;&#3609;&#3634;&#3604;&#3626;&#3605;&#3655;&#3629;&#3585;',0),(172071,4780,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤†à¤•à¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤–à¤¾à¤²à¥€ à¤›à¥‹à¤¡à¤¼ à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¤¾ à¤†à¤•à¤¾à¤° =',0),(172072,4780,'ms','Biarkan kosong untuk cetakan saiz = saiz saham',0),(172073,4780,'ar','Ø§ØªØ±Ùƒ Ø§Ù„Ù…Ø³Ø§Ø­Ø© ÙØ§Ø±ØºØ© Ù„Ø­Ø¬Ù… Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© = Ø­Ø¬Ù… Ø§Ù„Ø£Ø³Ù‡Ù…',0),(172074,4780,'fr','Laisser en blanc pour impression taille = taille du stock',0),(172075,4780,'jp','Leave blank for print size=stock size',0),(172076,4780,'pt','Deixe em branco para impressÃ£o tamanho = tamanho conservado em estoque',0),(172077,4780,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ€ = Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(172078,4780,'es','Dejar en Blanco para imprimir tamaÃ±o=tamaÃ±o de stock',0),(172079,4780,'de','Freilassen fÃ¼r die DruckgrÃ¶ÃŸe = BestandsgrÃ¶ÃŸe',0),(172080,4780,'en','Leave blank for print size=stock size',0),(172081,4781,'is','',0),(172082,4781,'dr','Ø¬Ø³ØªØ¬Ùˆ  Ù¾Ø±Ø¯Ø§Ø®Øª Ø²Ù…Ø§Ù† ØªØ­ÙˆÙŠÙ„ ÙƒØ§Ù„Ø§ \r\n POD',0),(172083,4781,'pr','Ø¬Ø³ØªØ¬Ùˆ  Ù¾Ø±Ø¯Ø§Ø®Øª Ø²Ù…Ø§Ù† ØªØ­ÙˆÙŠÙ„ ÙƒØ§Ù„Ø§ \r\n POD',0),(172084,4781,'tr','Arama ModÃ¼lÃ¼',0),(172085,4781,'pl','Wyszukiwania POD',0),(172086,4781,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ POD',0),(172087,4781,'ur','Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº Ù¾Ú¾Ù„ÛŒ',0),(172088,4781,'sr','Ð—Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ ÐšÐÐŸÐ¡Ð£Ð›Ð£',0),(172089,4781,'vi','TÃ¬m Ä‘Æ¡n mua hÃ ng',0),(172090,4781,'af','POA Opsoek',0),(172091,4781,'ro','CÄƒutare POD',0),(172092,4781,'et','Otsing POD',0),(172093,4781,'si','Iskanje POD',0),(172094,4781,'ba','Lookup POD',0),(172095,4781,'nl','Opzoeken POD',0),(172096,4781,'fi','Haku POD',0),(172097,4781,'no','Oppslag POD',0),(172098,4781,'da','Opslag POD',0),(172099,4781,'ko','ì¡°íšŒ í¬ë“œ',0),(172100,4781,'he','×‘×“×™×§×ª POD',0),(172101,4781,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚ POD',0),(172102,4781,'zh','æŸ¥æ‰¾è´§åˆ°ä»˜æ¬¾å…ˆ\r\n',0),(172103,4781,'sv','Lookup POD',0),(172104,4781,'it','Ricerca POD',0),(172105,4781,'tl','',0),(172106,4781,'th','&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634; POD',0),(172107,4781,'hi','à¤²à¥à¤•à¤…à¤ª à¤«à¤²à¥€',0),(172108,4781,'ms','Lookup POD',0),(172109,4781,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø¬Ø±Ø§Ø¨',0),(172110,4781,'fr','Recherche POD',0),(172111,4781,'jp','PODå?‚ç…§',0),(172112,4781,'pt','POD de pesquisa',0),(172113,4781,'ru','ÐŸÐ¾Ð¸ÑÐº POD',0),(172114,4781,'es','Buscar POD',0),(172115,4781,'de','Suche POD',0),(172116,4781,'en','Lookup POD',0),(172117,4782,'is','',0),(172118,4782,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ù‚Ø¨Ù„ÙŠ ',0),(172119,4782,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ù‚Ø¨Ù„ÙŠ ',0),(172120,4782,'tr','Arama Ã¶n sipariÅŸ',0),(172121,4782,'pl','WczeÅ›niejszego zamÃ³wienia wyszukiwania',0),(172122,4782,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(172123,4782,'ur','Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº Ù¾ÛŒØ´Ú¯ÛŒ ØªØ±ØªÛŒØ¨',0),(172124,4782,'sr','Ð—Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(172125,4782,'vi','TÃ¬m Ä‘Æ¡n hÃ ng trÆ°á»›c',0),(172126,4782,'af','Opsoek vooraf bestelling',0),(172127,4782,'ro','CÄƒutare prealabil',0),(172128,4782,'et','Otsing eelneva tellimuse',0),(172129,4782,'si','Iskanje predhodnega naroÄila',0),(172130,4782,'ba','Lookup sebelum Order',0),(172131,4782,'nl','Opzoeken voorafgaande bestelling',0),(172132,4782,'fi','Haku ennen jÃ¤rjestyksessÃ¤',0),(172133,4782,'no','Oppslag tidligere ordre',0),(172134,4782,'da','Opslag forudgÃ¥ende ordre',0),(172135,4782,'ko','ì¡°íšŒ ì‚¬ì „ ìˆœì„œ',0),(172136,4782,'he','×”×–×ž× ×” ×ž×•×§×“×ž×ª ×‘×“×™×§×ª ×ž×™×“×¢',0),(172137,4782,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(172138,4782,'zh','æŸ¥æ‰¾å‰è®¢è´­\r\n',0),(172139,4782,'sv','SÃ¶kning tidigare Order',0),(172140,4782,'it','Previo ordine di ricerca',0),(172141,4782,'tl','',0),(172142,4782,'th','&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;&#3585;&#3656;&#3629;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(172143,4782,'hi','à¤²à¥à¤•à¤…à¤ª à¤ªà¥‚à¤°à¥à¤µ à¤†à¤¦à¥‡à¤¶',0),(172144,4782,'ms','Carian pesanan terlebih dahulu',0),(172145,4782,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¨Ø­Ø« Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(172146,4782,'fr','Recherche commande antÃ©rieure',0),(172147,4782,'jp','å‰?å›žæ³¨æ–‡å?‚ç…§',0),(172148,4782,'pt','Pesquisa prÃ©via ordem',0),(172149,4782,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ Ð¿Ð¾Ð¸ÑÐºÐ°',0),(172150,4782,'es','Buscar Orden Anterior',0),(172151,4782,'de','Lookup vorherige Bestellung',0),(172152,4782,'en','Lookup Prior Order',0),(172153,4783,'is','',0),(172154,4783,'dr','Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ Ù‡Ø§ ÙŠØ§ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ø§Ø¯Ø±Ø³Øª Ø¨Ø§ Ø±Ù†Ú¯ Ù‚Ø±Ù…Ø² Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø´ÙˆÙ†Ø¯',0),(172155,4783,'pr','Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ Ù‡Ø§ ÙŠØ§ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ø§Ø¯Ø±Ø³Øª Ø¨Ø§ Ø±Ù†Ú¯ Ù‚Ø±Ù…Ø² Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø´ÙˆÙ†Ø¯',0),(172156,4783,'tr','Eksik veya yanlÄ±ÅŸ bilgi kÄ±rmÄ±zÄ± bayraklÄ±',0),(172157,4783,'pl','Brak lub zÅ‚e info flagÄ… w kolorze czerwonym',0),(172158,4783,'bg','Ð›Ð¸Ð¿ÑÐ²Ð°Ñ‰Ð° Ð¸Ð»Ð¸ Ð»Ð¾ÑˆÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ„Ð»Ð°Ð³Ð¾Ð²Ðµ Ð² Ñ‡ÐµÑ€Ð²ÐµÐ½Ð¾',0),(172159,4783,'ur','ØºØ§Ø¦Ø¨ ÛŒØ§ Ø®Ø±Ø§Ø¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÛŒÚº Ø³Ø±Ø® Ù¾Ø±Ú†Ù… Ø¯Ø§Ø±',0),(172160,4783,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ñƒ Ð¸Ð»Ð¸ ÑÑƒ Ð»Ð¾ÑˆÐµ Ð¸Ð½Ñ„Ð¾ Ð·Ð°ÑÑ‚Ð°Ð²Ð¸Ñ†Ð°Ð¼Ð° Ñƒ Ñ†Ñ€Ð²ÐµÐ½Ð¾Ð¼',0),(172161,4783,'vi','ThÃ´ng tin thiáº¿u hay sai in mÃ u Ä‘á»',0),(172162,4783,'af','Vermiste of Swak inligting Bevlag in ROOI',0),(172163,4783,'ro','InformaÅ£ii lipsÄƒ sau rele semnalizat cu roÈ™u',0),(172164,4783,'et','Puuduva vÃµi halva info kiirlipuga mÃ¤rgitud punasega',0),(172165,4783,'si','Manjka ali je nepravilen info zastavico oznaÄena z rdeÄo',0),(172166,4783,'ba','Hilang atau buruk info Flagged merah',0),(172167,4783,'nl','Ontbrekende of slechte info gemarkeerd in het rood',0),(172168,4783,'fi','Puuttuvat tai virheelliset tiedot punaisella merkityt',0),(172169,4783,'no','Manglende eller ugyldig info flagget i rÃ¸dt',0),(172170,4783,'da','Manglende eller dÃ¥rlig info Flagged i rÃ¸d',0),(172171,4783,'ko','ì—†ê±°ë‚˜ ë‚˜ìœ ì •ë³´ ë¹¨ê°„ìƒ‰ í”Œëž˜ê·¸',0),(172172,4783,'he','×ž×™×“×¢ ×—×¡×¨ ××• ×¨×¢ ×ž×¡×•×ž× ×™× ×‘××“×•×',0),(172173,4783,'el','Î›ÎµÎ¯Ï€Î¿Ï…Î½ Î® ÎºÎ±ÎºÎ® Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Îµ ÏƒÎ·Î¼Î±Î¯Î± Î¼Îµ ÎºÏŒÎºÎºÎ¹Î½Î¿ Ï‡ÏÏŽÎ¼Î±',0),(172174,4783,'zh','ä¸¢å¤±æˆ–æŸåçš„çº¢è‰²æ ‡è®°çš„ä¿¡æ¯\r\n',0),(172175,4783,'sv','Saknas eller Ã¤r dÃ¥liga information flaggade i rÃ¶tt',0),(172176,4783,'it','Informazioni mancanti o male contrassegnato in rosso',0),(172177,4783,'tl','',0),(172178,4783,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3627;&#3619;&#3639;&#3629;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3648;&#3611;&#3655;&#3609;&#3626;&#3',0),(172179,4783,'hi','à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§ à¤¹à¥ˆ à¤¯à¤¾ à¤¬à¥à¤°à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤§à¥à¤µà¤œà¤¾à¤‚à¤•à¤¿à¤¤ à¤²à¤¾à¤² à¤°à¤‚à¤— à¤®à¥‡à¤‚',0),(172180,4783,'ms','Maklumat hilang atau buruk bendera merah',0),(172181,4783,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÙÙ‚ÙˆØ¯Ø© Ø£Ùˆ Ø³ÙŠØ¦Ø© Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø¨Ø§Ù„Ù„ÙˆÙ† Ø§Ù„Ø£Ø­Ù…Ø±',0),(172182,4783,'fr','Info manquante ou mauvais Flagged en rouge',0),(172183,4783,'jp','è¶³ã‚Šã?ªã?„æƒ…å ±ã‚„ä¸?æ­£ã?ªæƒ…å ±ã?¯èµ¤ã?§å?°ã?Œã?¤ã?„ã?¦ã?„ã?¾ã?™',0),(172184,4783,'pt','InformaÃ§Ã£o ausente ou mal sinalizadas em vermelho',0),(172185,4783,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¸Ð»Ð¸ Ð¿Ð»Ð¾Ñ…Ð¾ Ð¿Ð¾Ð¼ÐµÑ‡ÐµÐ½Ð¾ ÐºÑ€Ð°ÑÐ½Ñ‹Ð¼',0),(172186,4783,'es','Info Faltante o Mala Marcada en ROJO',0),(172187,4783,'de','BeschÃ¤digten oder fehlenden Informationen gekennzeichnete in rot',0),(172188,4783,'en','Missing or Bad info Flagged in RED',0),(172189,4784,'is','',0),(172190,4784,'dr','Ø¨Ø§ÙŠØ¯ Ø´Ø§Ù…Ù„ Ø¢Ø¯Ø±Ø³ Ø¨Ø§Ø´Ø¯ ',0),(172191,4784,'pr','Ø¨Ø§ÙŠØ¯ Ø´Ø§Ù…Ù„ Ø¢Ø¯Ø±Ø³ Ø¨Ø§Ø´Ø¯ ',0),(172192,4784,'tr','Adres iÃ§ermelidir',0),(172193,4784,'pl','Musi zawieraÄ‡ adres',0),(172194,4784,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ´ÑŠÑ€Ð¶Ð° Ð°Ð´Ñ€ÐµÑ',0),(172195,4784,'ur','Ù¾ØªÛ’ Ú©Ø§ Ø­Ø§Ù…Ù„ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(172196,4784,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° ÑÐ°Ð´Ñ€Ð¶Ð¸ Ð°Ð´Ñ€ÐµÑÑƒ',0),(172197,4784,'vi','Pháº£i chá»©a Ä‘á»‹a chá»‰',0),(172198,4784,'af','Adres moet bevat',0),(172199,4784,'ro','Trebuie sÄƒ conÅ£inÄƒ adresa',0),(172200,4784,'et','Peab sisaldama aadressi',0),(172201,4784,'si','Mora vsebovati naslov',0),(172202,4784,'ba','Harus berisi alamat',0),(172203,4784,'nl','Adres moet bevatten',0),(172204,4784,'fi','On oltava osoite',0),(172205,4784,'no','MÃ¥ inneholde adressen',0),(172206,4784,'da','Skal indeholde adressen',0),(172207,4784,'ko','ì£¼ì†Œë¥¼ í¬í•¨ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(172208,4784,'he','×—×™×™×‘ ×œ×”×›×™×œ ×›×ª×•×‘×ª',0),(172209,4784,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€ÎµÏÎ¹Î­Ï‡ÎµÎ¹ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(172210,4784,'zh','å¿…é¡»åŒ…å«åœ°å€\r\n',0),(172211,4784,'sv','MÃ¥ste innehÃ¥lla adress',0),(172212,4784,'it','Deve contenere l\'indirizzo',0),(172213,4784,'tl','',0),(172214,4784,'th','&#3605;&#3657;&#3629;&#3591;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3604;&#3657;&#3623;&#3618;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(172215,4784,'hi','à¤ªà¤¤à¤¾ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(172216,4784,'ms','Hendaklah mengandungi alamat',0),(172217,4784,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(172218,4784,'fr','Doit contenir l\'adresse',0),(172219,4784,'jp','ä½?æ‰€ã?Œå¿…è¦?ã?§ã?™',0),(172220,4784,'pt','Deve conter o endereÃ§o',0),(172221,4784,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ ÑÐ¾Ð´ÐµÑ€Ð¶Ð°Ñ‚ÑŒ Ð°Ð´Ñ€ÐµÑ',0),(172222,4784,'es','Debe contener una direccciÃ³n',0),(172223,4784,'de','Muss Adresse enthalten',0),(172224,4784,'en','Must contain address',0),(172225,4785,'is','',0),(172226,4785,'dr','Ø¨Ø§ÙŠØ¯ Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ Ø¢Ø¯Ø±Ø³ ØªØ­ÙˆÙŠÙ„ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(172227,4785,'pr','Ø¨Ø§ÙŠØ¯ Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ Ø¢Ø¯Ø±Ø³ ØªØ­ÙˆÙŠÙ„ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(172228,4785,'tr','En az bir teslimat adresi olmalÄ±dÄ±r',0),(172229,4785,'pl','Musi mieÄ‡ co najmniej jeden adres',0),(172230,4785,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð¿Ð¾Ð½Ðµ ÐµÐ´Ð¸Ð½ Ð°Ð´Ñ€ÐµÑ',0),(172231,4785,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø§ÛŒÚ© Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú©Ø§ Ù¾ØªÛ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(172232,4785,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½Ð°Ñ˜Ð¼Ð°ÑšÐµ Ñ˜ÐµÐ´Ð½Ñƒ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ Ð°Ð´Ñ€ÐµÑÐ°',0),(172233,4785,'vi','Pháº£i cÃ³ Ã­t nháº¥t 1 Ä‘á»‹a chá»‰ giao hÃ ng',0),(172234,4785,'af','Moet ten minste een aflewering adres het',0),(172235,4785,'ro','Trebuie sÄƒ aibÄƒ cel puÅ£in o livrare adresa',0),(172236,4785,'et','Peab olema vÃ¤hemalt Ã¼ks tarneaadress',0),(172237,4785,'si','Mora imeti vsaj en naslov',0),(172238,4785,'ba','Harus memiliki alamat pengiriman setidaknya satu',0),(172239,4785,'nl','Moet op zijn minst een leveringsadres',0),(172240,4785,'fi','On oltava vÃ¤hintÃ¤Ã¤n yksi toimitusosoite',0),(172241,4785,'no','MÃ¥ ha minst Ã©n leveringsadresse',0),(172242,4785,'da','Skal have mindst Ã©n leveringsadresse',0),(172243,4785,'ko','ìžˆì–´ì•¼ í•©ë‹ˆë‹¤ í•˜ë‚˜ ì´ìƒì˜ ë°°ë‹¬ ì£¼ì†Œ',0),(172244,4785,'he','×‘×˜×— ×™×© ×›×ª×•×‘×ª ×ž×¡×™×¨×” ××—×ª ×œ×¤×—×•×ª',0),(172245,4785,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î¼Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(172246,4785,'zh','å¿…é¡»è‡³å°‘æœ‰ä¸€ä¸ªé€è´§åœ°å€\r\n',0),(172247,4785,'sv','MÃ¥ste ha minst en leveransadress',0),(172248,4785,'it','Deve avere almeno un indirizzo',0),(172249,4785,'tl','',0),(172250,4785,'th','&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3629;&#3618;&#3656;&#3634;&#3591;&#3609;&#3657;&#3629;&#3618;&#3627;&#3609;&#3638;&#3656;&#3591;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3',0),(172251,4785,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• à¤µà¤¿à¤¤à¤°à¤£ à¤ªà¤¤à¤¾ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(172252,4785,'ms','Mesti mempunyai alamat penghantaran sekurang-kurangnya satu',0),(172253,4785,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„ØªØ³Ù„ÙŠÙ… ÙˆØ§Ø­Ø¯ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„',0),(172254,4785,'fr','Doit avoir au moins une livraison adresse',0),(172255,4785,'jp','ä¸€ç®‡æ‰€ä»¥ä¸Šã?®é…?é€?å…ˆä½?æ‰€ã?Œå¿…è¦?ã?§ã?™',0),(172256,4785,'pt','Deve ter pelo menos um endereÃ§o',0),(172257,4785,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¸Ð¼ÐµÑ‚ÑŒ Ð¿Ð¾ ÐºÑ€Ð°Ð¹Ð½ÐµÐ¹ Ð¼ÐµÑ€Ðµ Ð¾Ð´Ð¸Ð½ Ð°Ð´Ñ€ÐµÑ',0),(172258,4785,'es','Debe Tener por lo menos una dirrecciÃ³n de EnvÃ­o',0),(172259,4785,'de','Muss mindestens eine Lieferadresse',0),(172260,4785,'en','Must have at least one delivery address',0),(172261,4786,'is','',0),(172262,4786,'dr','Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(172263,4786,'pr','Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(172264,4786,'tr','BaskÄ±lÄ± deÄŸil',0),(172265,4786,'pl','Nie drukowane',0),(172266,4786,'bg','ÐÐµ ÑÐµ Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ñ‚',0),(172267,4786,'ur','Ú†Ú¾Ù¾ÛŒ ÛÙˆØ¦ÛŒ Ù†ÛÛŒÚº',0),(172268,4786,'sr','ÐÐµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°',0),(172269,4786,'vi','ChÆ°a in',0),(172270,4786,'af','Nie uitgedruk',0),(172271,4786,'ro','Nu imprimat',0),(172272,4786,'et','Printimata',0),(172273,4786,'si','Ne natisne',0),(172274,4786,'ba','Tidak dicetak',0),(172275,4786,'nl','Niet afgedrukt',0),(172276,4786,'fi','Ei tulosteta',0),(172277,4786,'no','Ikke skrives ut',0),(172278,4786,'da','Udskrives ikke',0),(172279,4786,'ko','ì¸ì‡„ ë˜ì§€ ì•ŠëŠ”ë‹¤',0),(172280,4786,'he','×œ× ×”×•×“×¤×¡',0),(172281,4786,'el','Î”ÎµÎ½ ÎµÎºÏ„Ï…Ï€ÏŽÎ½ÎµÏ„Î±Î¹',0),(172282,4786,'zh','ä¸æ‰“å°\r\n',0),(172283,4786,'sv','Skrivs inte ut',0),(172284,4786,'it','Non stampato',0),(172285,4786,'tl','',0),(172286,4786,'th','&#3652;&#3617;&#3656;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(172287,4786,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚',0),(172288,4786,'ms','Tidak bercetak',0),(172289,4786,'ar','Ù„Ø§ ØªØªÙ… Ø·Ø¨Ø§Ø¹Ø©',0),(172290,4786,'fr','Pas imprimÃ©',0),(172291,4786,'jp','å?°åˆ·ã?•ã‚Œã?¦ã?„ã?ªã?„',0),(172292,4786,'pt','NÃ£o impressos',0),(172293,4786,'ru','ÐÐµ Ñ€Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð½Ð¾',0),(172294,4786,'es','No Imprimido',0),(172295,4786,'de','Nicht gedruckt',0),(172296,4786,'en','Not printed',0),(172297,4787,'is','',0),(172298,4787,'dr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ø² Ø±Ù†Ú¯Ù‡Ø§ ',0),(172299,4787,'pr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ø² Ø±Ù†Ú¯Ù‡Ø§ ',0),(172300,4787,'tr','# Renkler',0),(172301,4787,'pl','# Kolory',0),(172302,4787,'bg','# Ð¦Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(172303,4787,'ur','# Ø±Ù†Ú¯',0),(172304,4787,'sr','# Ð‘Ð¾Ñ˜Ðµ',0),(172305,4787,'vi','Sá»‘ máº§u',0),(172306,4787,'af','# Kleure',0),(172307,4787,'ro','# Culori',0),(172308,4787,'et','# VÃ¤rvid',0),(172309,4787,'si','# Barve',0),(172310,4787,'ba','# Warna',0),(172311,4787,'nl','# Kleuren',0),(172312,4787,'fi','# VÃ¤rit',0),(172313,4787,'no','# Farger',0),(172314,4787,'da','# Farver',0),(172315,4787,'ko','# ìƒ‰ìƒ',0),(172316,4787,'he','# ×¦×‘×¢×™×',0),(172317,4787,'el','# Î§ÏÏŽÎ¼Î±Ï„Î±',0),(172318,4787,'zh','ï¼ƒé¢œè‰²\r\n',0),(172319,4787,'sv','# FÃ¤rger',0),(172320,4787,'it','# Colori',0),(172321,4787,'tl','',0),(172322,4787,'th','&#3626;&#3637;',0),(172323,4787,'hi','# à¤°à¤‚à¤—',0),(172324,4787,'ms','# Warna',0),(172325,4787,'ar','# Ø£Ù„ÙˆØ§Ù†',0),(172326,4787,'fr','# Couleurs',0),(172327,4787,'jp','è‰²ã?®æ•°',0),(172328,4787,'pt','# Cores',0),(172329,4787,'ru','# Ð¦Ð²ÐµÑ‚Ð°',0),(172330,4787,'es','# Colores',0),(172331,4787,'de','# Farben',0),(172332,4787,'en','# Colors',0),(172333,4788,'is','',0),(172334,4788,'dr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ø² Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ',0),(172335,4788,'pr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ø² Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ',0),(172336,4788,'tr','# Orijinal',0),(172337,4788,'pl','# OryginaÅ‚y',0),(172338,4788,'bg','# ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸Ñ‚Ðµ',0),(172339,4788,'ur','# Ø§ØµÙ„',0),(172340,4788,'sr','# ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ðµ',0),(172341,4788,'vi','Sá»‘ gá»‘c',0),(172342,4788,'af','# Oorspronklikes',0),(172343,4788,'ro','# Originale',0),(172344,4788,'et','# Originaalid',0),(172345,4788,'si','# Originali',0),(172346,4788,'ba','# Aslinya',0),(172347,4788,'nl','# Originelen',0),(172348,4788,'fi','# AlkuperÃ¤iset',0),(172349,4788,'no','# Originaler',0),(172350,4788,'da','# Originaler',0),(172351,4788,'ko','# ì›ë³¸',0),(172352,4788,'he','# ×”×ž×§×•×¨×™×™×',0),(172353,4788,'el','# Î ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î±',0),(172354,4788,'zh','ï¼ƒåŽŸç¨¿\r\n',0),(172355,4788,'sv','# Originalen',0),(172356,4788,'it','# Gli originali',0),(172357,4788,'tl','',0),(172358,4788,'th','&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;',0),(172359,4788,'hi','# à¤®à¥‚à¤²',0),(172360,4788,'ms','# Asal',0),(172361,4788,'ar','# Ø£ØµÙˆÙ„',0),(172362,4788,'fr','# Originaux',0),(172363,4788,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«ã?®æ•°',0),(172364,4788,'pt','# Originais',0),(172365,4788,'ru','# ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¾Ð²',0),(172366,4788,'es','# Originales',0),(172367,4788,'de','# Originals',0),(172368,4788,'en','# Originals',0),(172369,4789,'is','',0),(172370,4789,'dr','Ø§Ø²',0),(172371,4789,'pr','Ø§Ø²',0),(172372,4789,'tr','in',0),(172373,4789,'pl','z',0),(172374,4789,'bg','Ð½Ð°',0),(172375,4789,'ur','Ú©ÛŒ',0),(172376,4789,'sr','Ð¾Ð´',0),(172377,4789,'vi','cá»§a',0),(172378,4789,'af','van',0),(172379,4789,'ro','de',0),(172380,4789,'et','kohta',0),(172381,4789,'si','od',0),(172382,4789,'ba','dari',0),(172383,4789,'nl','van',0),(172384,4789,'fi','ja',0),(172385,4789,'no','av',0),(172386,4789,'da','af',0),(172387,4789,'ko','ì˜',0),(172388,4789,'he','×©×œ',0),(172389,4789,'el','Ï„Î¿Ï…',0),(172390,4789,'zh','çš„\r\n',0),(172391,4789,'sv','av',0),(172392,4789,'it','di',0),(172393,4789,'tl','',0),(172394,4789,'th','&#3586;&#3629;&#3591;',0),(172395,4789,'hi','à¤•à¥€',0),(172396,4789,'ms','daripada',0),(172397,4789,'ar','Ù…Ù†',0),(172398,4789,'fr','de',0),(172399,4789,'jp','ï½žã?®',0),(172400,4789,'pt','de',0),(172401,4789,'ru','Ð¸Ð·',0),(172402,4789,'es','de',0),(172403,4789,'de','von',0),(172404,4789,'en','of',0),(172405,4790,'is','',0),(172406,4790,'dr','ÙŠÙƒ Ùˆ Ø¯Ùˆ Ø¬Ù‡Øª ',0),(172407,4790,'pr','ÙŠÙƒ Ùˆ Ø¯Ùˆ Ø¬Ù‡Øª ',0),(172408,4790,'tr','1 & 2 taraflÄ±',0),(172409,4790,'pl','1 & 2 dwustronne',0),(172410,4790,'bg','1 & 2 Ð´Ð²ÑƒÑÑ‚Ñ€Ð°Ð½ÐµÐ½',0),(172411,4790,'ur','1 & 2 Ø·Ø±ÙÛ',0),(172412,4790,'sr','1 Ð¸ 2 ÑÑ‚Ð°Ð¾ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ñƒ',0),(172413,4790,'vi','162 máº·t',0),(172414,4790,'af','1 & 2 geskaar',0),(172415,4790,'ro','1 & 2 laturi',0),(172416,4790,'et','1 & 2 kahepoolne',0),(172417,4790,'si','1 & 2 stranicami',0),(172418,4790,'ba','1 & 2 sisi',0),(172419,4790,'nl','1 & 2-zijdige',0),(172420,4790,'fi','1 & 2 puolinen',0),(172421,4790,'no','1 & 2 sider',0),(172422,4790,'da','1 & 2 sidet',0),(172423,4790,'ko','1 & 2 ë©´',0),(172424,4790,'he','1 & 2 ×¦×“×“×™×',0),(172425,4790,'el','1 & 2 ÏŒÏˆÎµÏ‰Î½',0),(172426,4790,'zh','1ï¼†2åŒé¢\r\n',0),(172427,4790,'sv','1 & 2 sidig',0),(172428,4790,'it','1 & 2 lati',0),(172429,4790,'tl','',0),(172430,4790,'th','1 &#3649;&#3621;&#3632; 2 &#3627;&#3609;&#3657;&#3634;',0),(172431,4790,'hi','1 & 2 à¤¤à¤°à¤«à¤¾',0),(172432,4790,'ms','1 & 2 muka',0),(172433,4790,'ar','ÙˆÙ‚ÙØª 1 Ø¢Ù†Ø¯ 2',0),(172434,4790,'fr','1 & 2 faces',0),(172435,4790,'jp','ï¼‘ï¼†ï¼’ä¸¡é?¢',0),(172436,4790,'pt','1 & 2 lados',0),(172437,4790,'ru','1&2 ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(172438,4790,'es','De 1&2 lados',0),(172439,4790,'de','1 & 2 seitig',0),(172440,4790,'en','1&2 sided',0),(172441,4791,'is','',0),(172442,4791,'dr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚  Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(172443,4791,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚  Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(172444,4791,'tr','Bilgi sÄ±ralama',0),(172445,4791,'pl','KolejnoÅ›Ä‡ wedÅ‚ug informacji',0),(172446,4791,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(172447,4791,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¢Ø±ÚˆØ±',0),(172448,4791,'sr','ÐžÑ€Ð´ÐµÑ€ Ð‘y Ð˜Ð½Ñ„Ð¾',0),(172449,4791,'vi','Äáº·t hÃ ng theo thÃ´ng tin',0),(172450,4791,'af','Bestel Deur Inligting',0),(172451,4791,'ro','Comanda de Info',0),(172452,4791,'et','Telli infot',0),(172453,4791,'si','RazvrÅ¡Äanje po Info',0),(172454,4791,'ba','Order By Info',0),(172455,4791,'nl','Order By Info',0),(172456,4791,'fi','Tilaus info',0),(172457,4791,'no','RekkefÃ¸lgen av Info',0),(172458,4791,'da','Order By Info',0),(172459,4791,'ko','ì£¼ë¬¸ ì •ë³´',0),(172460,4791,'he','×¡×“×¨ ×œ×¤×™ ×¤×¨×˜×™',0),(172461,4791,'el','Î£ÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(172462,4791,'zh','æŒ‰ä¿¡æ¯æŽ’åº\r\n',0),(172463,4791,'sv','BestÃ¤llning av information',0),(172464,4791,'it','Ordine di Info',0),(172465,4791,'tl','',0),(172466,4791,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3650;&#3604;&#3618;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(172467,4791,'hi','à¤†à¤¦à¥‡à¤¶ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(172468,4791,'ms','Perintah oleh maklumat',0),(172469,4791,'ar','Ø§Ù„ØªØ±ØªÙŠØ¨ Ø­Ø³Ø¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(172470,4791,'fr','Ordre par Info',0),(172471,4791,'jp','æƒ…å ±åˆ¥æ³¨æ–‡',0),(172472,4791,'pt','Pedido de informaÃ§Ã£o',0),(172473,4791,'ru','Ð—Ð°ÐºÐ°Ð· ÐŸÐ¾ Ð˜Ð½Ñ„Ð¾',0),(172474,4791,'es','Ordenar Por Info',0),(172475,4791,'de','Bestellung von Info',0),(172476,4791,'en','Order By Info',0),(172477,4792,'is','',0),(172478,4792,'dr','1',0),(172479,4792,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ 1',0),(172480,4792,'tr','SipariÅŸ miktarÄ± #1',0),(172481,4792,'pl','IloÅ›Ä‡ zamÃ³wienia #1',0),(172482,4792,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° #1',0),(172483,4792,'ur','#1 Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©Ø§ Ø¢Ø±ÚˆØ±',0),(172484,4792,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ð° #1',0),(172485,4792,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n hÃ ng sá»‘ 1',0),(172486,4792,'af','Bestellingseenheid #1',0),(172487,4792,'ro','Cantitate comandÄƒ #1',0),(172488,4792,'et','Tellimuse kogus #1',0),(172489,4792,'si','KoliÄina naloga #1',0),(172490,4792,'ba','Kuantitas order #1',0),(172491,4792,'nl','Orderaantal #1',0),(172492,4792,'fi','MÃ¤Ã¤rÃ¤ #1',0),(172493,4792,'no','Antallet #1',0),(172494,4792,'da','Ordreantallet #1',0),(172495,4792,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰ #1',0),(172496,4792,'he','×›×ž×•×ª ×”×–×ž× ×” #1',0),(172497,4792,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ #1',0),(172498,4792,'zh','è®¢è´­æ•°é‡ï¼ƒ1\r\n',0),(172499,4792,'sv','Orderkvantiteten #1',0),(172500,4792,'it','QuantitÃ  di ordine #1',0),(172501,4792,'tl','',0),(172502,4792,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3591;&#3634;&#3609;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586; 1',0),(172503,4792,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾ #1',0),(172504,4792,'ms','Kuantiti pesanan #1',0),(172505,4792,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ø£Ù…Ø± #1',0),(172506,4792,'fr','QuantitÃ© d\'ordre #1',0),(172507,4792,'jp','æ³¨æ–‡æ•°é‡?ï¼‘ç•ª',0),(172508,4792,'pt','Quantidade de ordem #1',0),(172509,4792,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð—Ð°ÐºÐ°Ð·Ð° #1',0),(172510,4792,'es','Cantidad de Ordenes #1',0),(172511,4792,'de','Bestellmenge #1',0),(172512,4792,'en','Order Quantity #1',0),(172513,4793,'is','',0),(172514,4793,'dr','Ù†ÙˆØ¹ Ø³ÙØ§Ø±Ø´ ',0),(172515,4793,'pr','Ù†ÙˆØ¹ Ø³ÙØ§Ø±Ø´ ',0),(172516,4793,'tr','SipariÅŸ tipi',0),(172517,4793,'pl','Typ zamÃ³wienia',0),(172518,4793,'bg','Ð’Ð¸Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(172519,4793,'ur','Ø­Ú©Ù… Ù‚Ø³Ù…',0),(172520,4793,'sr','Ð’Ñ€ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(172521,4793,'vi','Loáº¡i Ä‘Æ¡n hÃ ng',0),(172522,4793,'af','Bestelling Tipe',0),(172523,4793,'ro','Ordinea tip',0),(172524,4793,'et','Tellimuse tÃ¼Ã¼p',0),(172525,4793,'si','Vrsto naloga',0),(172526,4793,'ba','Jenis order',0),(172527,4793,'nl','Ordetype',0),(172528,4793,'fi','Tilauksen tyyppi',0),(172529,4793,'no','Ordretypen',0),(172530,4793,'da','Ordretype',0),(172531,4793,'ko','ì£¼ë¬¸ íƒ€ìž…',0),(172532,4793,'he','×¡×•×’ ×”×–×ž× ×”',0),(172533,4793,'el','Î¤ÏÏ€Î¿Ï… ÎµÎ½Ï„Î¿Î»Î®Ï‚',0),(172534,4793,'zh','è®¢å•ç±»åž‹\r\n',0),(172535,4793,'sv','Ordertypen',0),(172536,4793,'it','Tipo di ordine',0),(172537,4793,'tl','',0),(172538,4793,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(172539,4793,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(172540,4793,'ms','Jenis perintah',0),(172541,4793,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(172542,4793,'fr','Type de commande',0),(172543,4793,'jp','æ³¨æ–‡ã‚¿ã‚¤ãƒ—',0),(172544,4793,'pt','Tipo de ordem',0),(172545,4793,'ru','Ð¢Ð¸Ð¿ Ð—Ð°ÐºÐ°Ð·Ð°',0),(172546,4793,'es','Tipo de Orden',0),(172547,4793,'de','Auftragsart',0),(172548,4793,'en','Order Type',0),(172549,4794,'is','',0),(172550,4794,'dr','Ø¨Ø³ØªÙ‡ Ù‡Ø§',0),(172551,4794,'pr','Ø¨Ø³ØªÙ‡ Ù‡Ø§',0),(172552,4794,'tr','Paketleri',0),(172553,4794,'pl','Pakiety',0),(172554,4794,'bg','ÐŸÐ°ÐºÐµÑ‚Ð¸',0),(172555,4794,'ur','Ù¾ÛŒÚ©',0),(172556,4794,'sr','ÐŸÐ°ÐºÐµÑ‚Ð¸',0),(172557,4794,'vi','ÄÃ³ng hÃ ng ',0),(172558,4794,'af','Pakke',0),(172559,4794,'ro','Pachete',0),(172560,4794,'et','Paketid',0),(172561,4794,'si','Paketi',0),(172562,4794,'ba','Paket',0),(172563,4794,'nl','Verpakkingen',0),(172564,4794,'fi','Pakkauksissa',0),(172565,4794,'no','Pakker',0),(172566,4794,'da','Pakninger',0),(172567,4794,'ko','íŒ©',0),(172568,4794,'he','×—×‘×™×œ×•×ª',0),(172569,4794,'el','Î Î±ÎºÎ­Ï„Î±',0),(172570,4794,'zh','åŒ…\r\n',0),(172571,4794,'sv','FÃ¶rpackningar',0),(172572,4794,'it','Confezioni',0),(172573,4794,'tl','',0),(172574,4794,'th','&#3649;&#3614;&#3655;&#3588;',0),(172575,4794,'hi','à¤ªà¥ˆà¤•à¥à¤¸',0),(172576,4794,'ms','Pek',0),(172577,4794,'ar','Ø­Ø²Ù…',0),(172578,4794,'fr','Packs',0),(172579,4794,'jp','ãƒ‘ãƒƒã‚¯',0),(172580,4794,'pt','Pacotes',0),(172581,4794,'ru','ÐŸÐ°ÐºÐµÑ‚Ñ‹',0),(172582,4794,'es','Paquetes',0),(172583,4794,'de','Packs',0),(172584,4794,'en','Packs',0),(172585,4795,'is','',0),(172586,4795,'dr','Pads  Ø¯ÙØªØ±Ú†Ù‡â€Œ ÙŠØ§Ø¯Ø¯Ø§Ø´Øªâ€Œ',0),(172587,4795,'pr','Pads  Ø¯ÙØªØ±Ú†Ù‡â€Œ ÙŠØ§Ø¯Ø¯Ø§Ø´Øªâ€Œ',0),(172588,4795,'tr','Pedleri',0),(172589,4795,'pl','Klocki',0),(172590,4795,'bg','ÐŸÐ¾Ð´Ð»Ð¾Ð¶ÐºÐ¸',0),(172591,4795,'ur','Ù¾ÛŒÚˆ',0),(172592,4795,'sr','ÐˆÐ°ÑÑ‚ÑƒÑ‡Ð¸Ñ›Ð°',0),(172593,4795,'vi','Miáº¿ng Ä‘á»‡m',0),(172594,4795,'af','Stopsels',0),(172595,4795,'ro','Tampoane',0),(172596,4795,'et','Padjad',0),(172597,4795,'si','Blazinice',0),(172598,4795,'ba','Bantalan',0),(172599,4795,'nl','Pads',0),(172600,4795,'fi','Tyynyt',0),(172601,4795,'no','Pads',0),(172602,4795,'da','Puder',0),(172603,4795,'ko','íŒ¨ë“œ',0),(172604,4795,'he','×¨×¤×™×“×•×ª',0),(172605,4795,'el','ÎœÎ±Î¾Î¹Î»Î¬ÏÎ¹Î±',0),(172606,4795,'zh','åž«\r\n',0),(172607,4795,'sv','Kuddar',0),(172608,4795,'it','Pastiglie',0),(172609,4795,'tl','',0),(172610,4795,'th','&#3648;&#3610;&#3634;&#3632;&#3621;&#3629;&#3591;&#3627;&#3617;&#3638;&#3585;&#3605;&#3637;&#3605;&#3619;&#3634;',0),(172611,4795,'hi','à¤ªà¥ˆà¤¡',0),(172612,4795,'ms','Tuala wanita',0),(172613,4795,'ar','Ù…Ù†ØµØ§Øª',0),(172614,4795,'fr','Tampons',0),(172615,4795,'jp','ãƒ‘ãƒƒãƒ‰',0),(172616,4795,'pt','Almofadas',0),(172617,4795,'ru','ÐšÐ¾Ð»Ð¾Ð´ÐºÐ¸',0),(172618,4795,'es','Cojinetes',0),(172619,4795,'de','Pads',0),(172620,4795,'en','Pads',0),(172621,4796,'is','',0),(172622,4796,'dr','Ø¬Ù‡Øª ØµÙØ­Ù‡',0),(172623,4796,'pr','Ø¬Ù‡Øª ØµÙØ­Ù‡',0),(172624,4796,'tr','Sayfa yÃ¶nÃ¼',0),(172625,4796,'pl','Orientacja strony',0),(172626,4796,'bg','ÐžÑ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð°',0),(172627,4796,'ur','ØµÙØ­Û Ø³Ù…Øª Ø¨Ù†Ø¯ÛŒ',0),(172628,4796,'sr','ÐŸÐ¾Ð»Ð¾Ð¶Ð°Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(172629,4796,'vi','HÆ°á»›ng dáº©n trang',0),(172630,4796,'af','Bladsy OriÃ«ntasie',0),(172631,4796,'ro','Orientarea paginii',0),(172632,4796,'et','LehekÃ¼lje suuna',0),(172633,4796,'si','Usmerjenost strani',0),(172634,4796,'ba','Orientasi halaman',0),(172635,4796,'nl','Afdrukstand',0),(172636,4796,'fi','Sivun suunta',0),(172637,4796,'no','Retning',0),(172638,4796,'da','Sideretning',0),(172639,4796,'ko','íŽ˜ì´ì§€ ë°©í–¥',0),(172640,4796,'he','×›×™×•×•×Ÿ ×¢×ž×•×“',0),(172641,4796,'el','Î ÏÎ¿ÏƒÎ±Î½Î±Ï„Î¿Î»Î¹ÏƒÎ¼ÏŒ Ï„Î·Ï‚ ÏƒÎµÎ»Î¯Î´Î±Ï‚',0),(172642,4796,'zh','é¡µé¢å®šä½\r\n',0),(172643,4796,'sv','Sidorientering',0),(172644,4796,'it','Orientamento della pagina',0),(172645,4796,'tl','',0),(172646,4796,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(172647,4796,'hi','à¤ªà¥ƒà¤·à¥à¤  à¤“à¤°à¤¿à¤à¤‚à¤Ÿà¥‡à¤¶à¤¨',0),(172648,4796,'ms','Orientasi Laman',0),(172649,4796,'ar','Ø§ØªØ¬Ø§Ù‡ Ø§Ù„ØµÙØ­Ø©',0),(172650,4796,'fr','Orientation de la page',0),(172651,4796,'jp','ãƒšãƒ¼ã‚¸ã‚ªãƒªã‚¨ãƒ³ãƒ†ãƒ¼ã‚·ãƒ§ãƒ³',0),(172652,4796,'pt','OrientaÃ§Ã£o da pÃ¡gina',0),(172653,4796,'ru','ÐžÑ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹',0),(172654,4796,'es','OrientaciÃ³n de PÃ¡gina',0),(172655,4796,'de','Seitenausrichtung',0),(172656,4796,'en','Page Orientation',0),(172657,4797,'is','',0),(172658,4797,'dr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾',0),(172659,4797,'pr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾',0),(172660,4797,'tr','Yer yazdÄ±rma dÃ¼zeni',0),(172661,4797,'pl','Miejsce zlecenia druku',0),(172662,4797,'bg','ÐœÑÑÑ‚Ð¾ Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(172663,4797,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ Ø¬Ú¯Û',0),(172664,4797,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¼ÐµÑÑ‚Ð¾',0),(172665,4797,'vi','Äáº·t hÃ ng in',0),(172666,4797,'af','Plek druk orde',0),(172667,4797,'ro','Locul ordine de imprimare',0),(172668,4797,'et','Koht printimise jÃ¤rjekorras',0),(172669,4797,'si','Kraj vrstni red tiskanja',0),(172670,4797,'ba','Agar tempat cetak',0),(172671,4797,'nl','Plaats afdrukvolgorde',0),(172672,4797,'fi','Tulosta tilaa',0),(172673,4797,'no','Sted rekkefÃ¸lge',0),(172674,4797,'da','Sted udskriftsrÃ¦kkefÃ¸lgen',0),(172675,4797,'ko','ì¸ì‡„ ì£¼ë¬¸',0),(172676,4797,'he','×‘×ž×§×•× ×¡×“×¨ ×”×“×¤×¡×”',0),(172677,4797,'el','Î˜Î­ÏƒÎ· Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(172678,4797,'zh','ä¸‹è¾¾æ‰“å°å‘½ä»¤\r\n',0),(172679,4797,'sv','Plats utskriftsordning',0),(172680,4797,'it','Luogo ordine stampa',0),(172681,4797,'tl','',0),(172682,4797,'th','&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(172683,4797,'hi','à¤œà¤—à¤¹ à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤®',0),(172684,4797,'ms','Tempat cetak',0),(172685,4797,'ar','Ù…ÙƒØ§Ù† Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(172686,4797,'fr','Place l\'ordre d\'impression',0),(172687,4797,'jp','å?°åˆ·æ³¨æ–‡ã‚’ç™ºè¡Œ',0),(172688,4797,'pt','Ordem de impressÃ£o do lugar',0),(172689,4797,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð¼ÐµÑÑ‚Ð¾',0),(172690,4797,'es','Hacer Orden de ImpresiÃ³n',0),(172691,4797,'de','Bestellung drucken',0),(172692,4797,'en','Place Print Order',0),(172693,4798,'is','',0),(172694,4798,'dr','POD (Ù¾Ø³Øª Ø·Ø¨Ù‚ ØªØ§Ø±ÙŠØ®',0),(172695,4798,'pr','POD (Ù¾Ø³Øª Ø·Ø¨Ù‚ ØªØ§Ø±ÙŠØ®\r\n(Ù†Ù‚Ø·Ù‡ )Ø¯Ø³ØªÙˆØ± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(172696,4798,'tr','POD sipariÅŸ',0),(172697,4798,'pl','POD zamÃ³wienie',0),(172698,4798,'bg','ÐŸÐžÐ” Ñ€ÐµÐ´',0),(172699,4798,'ur','Ù¾Ú¾Ù„ÛŒ ØªØ±ØªÛŒØ¨',0),(172700,4798,'sr','ÐšÐÐŸÐ¡Ð£Ð›Ð Ð½Ð°Ð»Ð¾Ð³Ð°',0),(172701,4798,'vi','ÄÆ¡n hÃ ng POD',0),(172702,4798,'af','POA Bestelling',0),(172703,4798,'ro','POD ordine',0),(172704,4798,'et','POD jÃ¤rjekorras',0),(172705,4798,'si','Naloga POD',0),(172706,4798,'ba','POD Order',0),(172707,4798,'nl','POD volgorde',0),(172708,4798,'fi','POD jÃ¤rjestyksessÃ¤',0),(172709,4798,'no','POD rekkefÃ¸lge',0),(172710,4798,'da','POD rÃ¦kkefÃ¸lge',0),(172711,4798,'ko','í¬ë“œ ìˆœì„œ',0),(172712,4798,'he','×¡×“×¨ POD',0),(172713,4798,'el','Î£ÎµÎ¹ÏÎ¬ POD',0),(172714,4798,'zh','è´§åˆ°ä»˜æ¬¾çš„è®¢å•\r\n',0),(172715,4798,'sv','POD ordning',0),(172716,4798,'it','Ordine di baccello',0),(172717,4798,'tl','',0),(172718,4798,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; POD',0),(172719,4798,'hi','à¤«à¤²à¥€ à¤•à¥à¤°à¤®',0),(172720,4798,'ms','Perintah POD',0),(172721,4798,'ar','ØªØ±ØªÙŠØ¨ Ù‚Ø±Ù†Ø©',0),(172722,4798,'fr','Ordre POD',0),(172723,4798,'jp','PODæ³¨æ–‡',0),(172724,4798,'pt','Ordem de vagem',0),(172725,4798,'ru','ÐŸÐžÐ” Ð·Ð°ÐºÐ°Ð·',0),(172726,4798,'es','POD Orden',0),(172727,4798,'de','POD-Bestellung',0),(172728,4798,'en','POD Order',0),(172729,4799,'is','',0),(172730,4799,'dr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± Ø¨Ø±Ú¯',0),(172731,4799,'pr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± Ø¨Ø±Ú¯',0),(172732,4799,'tr','Fiyat/levha',0),(172733,4799,'pl','Cena/arkusz',0),(172734,4799,'bg','Ð¦ÐµÐ½Ð°/Ð»Ð¸ÑÑ‚',0),(172735,4799,'ur','Ù‚ÛŒÙ…Øª/ÙˆØ±Ù‚',0),(172736,4799,'sr','Ð¦ÐµÐ½Ð°/Ð»Ð¸ÑÑ‚',0),(172737,4799,'vi','GiÃ¡/Báº£ng',0),(172738,4799,'af','Prys/Vel',0),(172739,4799,'ro','Pret/foaie',0),(172740,4799,'et','Hind/leht',0),(172741,4799,'si','Cena/list',0),(172742,4799,'ba','Harga/lembar',0),(172743,4799,'nl','Prijs per vel',0),(172744,4799,'fi','Hinnasto /',0),(172745,4799,'no','Pris/ark',0),(172746,4799,'da','Pris/ark',0),(172747,4799,'ko','ê°€ê²©/ì‹œíŠ¸',0),(172748,4799,'he','×ž×—×™×¨/×’×™×œ×™×•×Ÿ',0),(172749,4799,'el','Î¤Î¹Î¼Î®/Ï†ÏÎ»Î»Î¿',0),(172750,4799,'zh','ä»·æ ¼/å¼ \r\n',0),(172751,4799,'sv','Pris/ark',0),(172752,4799,'it','Prezzo per foglio',0),(172753,4799,'tl','',0),(172754,4799,'th','&#3619;&#3634;&#3588;&#3634;&#3605;&#3656;&#3629;&#3649;&#3612;&#3656;&#3609;',0),(172755,4799,'hi','à¤•à¥€à¤®à¤¤/à¤šà¤¾à¤¦à¤°',0),(172756,4799,'ms','Harga/lembaran',0),(172757,4799,'ar','Ø§Ù„Ø³Ø¹Ø±/ÙˆØ±Ù‚Ø©',0),(172758,4799,'fr','Prix/feuille',0),(172759,4799,'jp','ä¾¡æ ¼/ã‚·ãƒ¼ãƒˆ',0),(172760,4799,'pt','PreÃ§o/folha',0),(172761,4799,'ru','Ð¦ÐµÐ½Ð°/Ð»Ð¸ÑÑ‚',0),(172762,4799,'es','Precio/Hoja',0),(172763,4799,'de','Preis pro Blatt',0),(172764,4799,'en','Price/Sheet',0),(172765,4800,'is','',0),(172766,4800,'dr','Ú†Ø§Ù¾ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¨Ø±Ú¯Ù‡',0),(172767,4800,'pr','Ú†Ø§Ù¾ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¨Ø±Ú¯Ù‡',0),(172768,4800,'tr','YazÄ±cÄ± sayfa boyutu',0),(172769,4800,'pl','Rozmiar wydruku arkusza',0),(172770,4800,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð»Ð¸ÑÑ‚ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(172771,4800,'ur','Ø³Ø§Ø¦Ø² ÙˆØ±Ù‚ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(172772,4800,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð»Ð¸ÑÑ‚Ð°',0),(172773,4800,'vi','Cá»¡ trang in',0),(172774,4800,'af','Druk Velgrootte',0),(172775,4800,'ro','Dimensiune imprimare foaie',0),(172776,4800,'et','Printida lehe suurus',0),(172777,4800,'si','Velikost tiskanja lista',0),(172778,4800,'ba','Lembar ukuran cetak',0),(172779,4800,'nl','Print papierformaat',0),(172780,4800,'fi','Tulosta arkin koko',0),(172781,4800,'no','Skriver ut arket',0),(172782,4800,'da','Udskrive arkstÃ¸rrelse',0),(172783,4800,'ko','ì¸ì‡„ ìš©ì§€ í¬ê¸°',0),(172784,4800,'he','×’×•×“×œ ×’×™×œ×™×•×Ÿ ×”×”×“×¤×¡×”',0),(172785,4800,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Ï†ÏÎ»Î»Î¿Ï…',0),(172786,4800,'zh','æ‰“å°çº¸å°ºå¯¸\r\n',0),(172787,4800,'sv','Skriva ut arkstorlek',0),(172788,4800,'it','Dimensione del foglio di stampa',0),(172789,4800,'tl','',0),(172790,4800,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3586;&#3609;&#3634;&#3604;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(172791,4800,'hi','à¤ªà¤¤à¥à¤°à¤• à¤†à¤•à¤¾à¤° à¤®à¥‡à¤‚ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤',0),(172792,4800,'ms','Mencetak lembaran saiz',0),(172793,4800,'ar','Ø­Ø¬Ù… ÙˆØ±Ù‚Ø© Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(172794,4800,'fr','Taille de la feuille d\'impression',0),(172795,4800,'jp','å?°åˆ·ã‚·ãƒ¼ãƒˆã‚µã‚¤ã‚º',0),(172796,4800,'pt','Tamanho da folha de impressÃ£o',0),(172797,4800,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¿ÐµÑ‡Ð°Ñ‚Ð½Ð¾Ð³Ð¾ Ð»Ð¸ÑÑ‚Ð°',0),(172798,4800,'es','TamaÃ±o de Hoja de ImpresiÃ³n',0),(172799,4800,'de','BlattgrÃ¶ÃŸe drucken',0),(172800,4800,'en','Print Sheet Size',0),(172801,4801,'is','',0),(172802,4801,'dr','Ú†Ø§Ù¾ Ø¬Ù‡Øª Ù‡Ø§ ',0),(172803,4801,'pr','Ú†Ø§Ù¾ Ø¬Ù‡Øª Ù‡Ø§ ',0),(172804,4801,'tr','YazdÄ±rma tarafÄ±',0),(172805,4801,'pl','Drukowanie stron',0),(172806,4801,'bg','ÐŸÐµÑ‡Ð°Ñ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸',0),(172807,4801,'ur','Ø§Ø·Ø±Ø§Ù Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(172808,4801,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(172809,4801,'vi','Máº·t in ',0),(172810,4801,'af','Druk Kante',0),(172811,4801,'ro','Imprimare pÄƒrÅ£i',0),(172812,4801,'et','Prindi kÃ¼ljed',0),(172813,4801,'si','Tiskanje strani',0),(172814,4801,'ba','Sisi cetak',0),(172815,4801,'nl','Zijden afdrukken',0),(172816,4801,'fi','Tulosta sivut',0),(172817,4801,'no','Skrive ut sider',0),(172818,4801,'da','Udskrive sider',0),(172819,4801,'ko','ì¸ì‡„ ë©´',0),(172820,4801,'he','×œ×”×“×¤×™×¡ ×”×¦×“×“×™×',0),(172821,4801,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Ï€Î»ÎµÏ…ÏÎ­Ï‚',0),(172822,4801,'zh','åŒé¢æ‰“å°\r\n',0),(172823,4801,'sv','Skriva ut sidor',0),(172824,4801,'it','Stampare i lati',0),(172825,4801,'tl','',0),(172826,4801,'th','&#3604;&#3657;&#3634;&#3609;&#3651;&#3609;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(172827,4801,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤ªà¤•à¥à¤·à¥‹à¤‚',0),(172828,4801,'ms','Sisi cetakan',0),(172829,4801,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠÙ†',0),(172830,4801,'fr','Imprimer les cÃ´tÃ©s',0),(172831,4801,'jp','å?°åˆ·é?¢',0),(172832,4801,'pt','Lados de impressÃ£o',0),(172833,4801,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð¸ ÑÑ‚Ð¾Ñ€Ð¾Ð½',0),(172834,4801,'es','Lados de Imprenta',0),(172835,4801,'de','Drucken von Seiten',0),(172836,4801,'en','Print Sides',0),(172837,4802,'is','',0),(172838,4802,'dr','Reams Ù¾Ø§Ù†ØµØ¯ ÙˆØ±Ù‚ ÙƒØ§ØºØ°',0),(172839,4802,'pr','Reams Ù¾Ø§Ù†ØµØ¯ ÙˆØ±Ù‚ ÙƒØ§ØºØ°',0),(172840,4802,'tr','Reams',0),(172841,4802,'pl','Ryz',0),(172842,4802,'bg','Reams',0),(172843,4802,'ur','Ø±ÛŒØ§Ù…Ø³',0),(172844,4802,'sr','Ð¡Ð²ÐµÑ›ÑšÐµÐ²Ð°',0),(172845,4802,'vi','Ram',0),(172846,4802,'af','Rieme',0),(172847,4802,'ro','Topuri',0),(172848,4802,'et','Kasoittain',0),(172849,4802,'si','Zavitkov',0),(172850,4802,'ba','RIM',0),(172851,4802,'nl','Riemen',0),(172852,4802,'fi','Kasoittain',0),(172853,4802,'no','Store',0),(172854,4802,'da','Bunker',0),(172855,4802,'ko','ë‹¤ëŸ‰ì˜ ì¢…ì´',0),(172856,4802,'he','×”×¨×¨×™',0),(172857,4802,'el','Î”ÎµÏƒÎ¼Î¯Î´ÎµÏ‚',0),(172858,4802,'zh','å¤§é‡\r\n',0),(172859,4802,'sv','FÃ¶rpackningar',0),(172860,4802,'it','Risme',0),(172861,4802,'tl','',0),(172862,4802,'th','&#3585;&#3619;&#3632;&#3604;&#3634;&#3625; 500 &#3649;&#3612;&#3656;&#3609;',0),(172863,4802,'hi','Reams',0),(172864,4802,'ms','Semasa menjalani latihan industri',0),(172865,4802,'ar','Ø±Ø²Ù…Ø©',0),(172866,4802,'fr','Rames',0),(172867,4802,'jp','ãƒªãƒ¼ãƒ ',0),(172868,4802,'pt','Resmas',0),(172869,4802,'ru','ÐŸÐ°Ñ‡ÐµÐº',0),(172870,4802,'es','Resma',0),(172871,4802,'de','Ries',0),(172872,4802,'en','Reams',0),(172873,4803,'is','',0),(172874,4803,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªØ±Ø®ÙŠØµ',0),(172875,4803,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªØ±Ø®ÙŠØµ',0),(172876,4803,'tr','SÃ¼rÃ¼m bilgileri',0),(172877,4803,'pl','Informacje o wydaniu',0),(172878,4803,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð²ÐµÑ€ÑÐ¸ÑÑ‚Ð°',0),(172879,4803,'ur','Ø±ÛØ§Ø¦ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(172880,4803,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¸Ð·Ð´Ð°ÑšÑƒ',0),(172881,4803,'vi','ÄÆ°a ThÃ´ng Tin',0),(172882,4803,'af','Inligting Vrystel',0),(172883,4803,'ro','InformaÈ›ii de lansare',0),(172884,4803,'et','Informatsioon Release',0),(172885,4803,'si','Javnost informacije',0),(172886,4803,'ba','Informasi rilis',0),(172887,4803,'nl','Release-informatie',0),(172888,4803,'fi','Julkaisutiedot',0),(172889,4803,'no','Utgivelsesinformasjon',0),(172890,4803,'da','Udgivelsesoplysninger',0),(172891,4803,'ko','ë¦´ë¦¬ìŠ¤ ì •ë³´',0),(172892,4803,'he','×œ×©×—×¨×¨ ×ž×™×“×¢',0),(172893,4803,'el','Î•ÎÎ—ÎœÎ•Î¡Î©Î£Î— Î¤Î¥Î ÎŸÎ¥',0),(172894,4803,'zh','å‘è¡Œä¿¡æ¯\r\n',0),(172895,4803,'sv','Utgivningsinformation',0),(172896,4803,'it','Informazioni sul rilascio',0),(172897,4803,'tl','',0),(172898,4803,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591;&#3585;&#3633;&#3609;',0),(172899,4803,'hi','à¤¸à¥‚à¤šà¤¨à¤¾ à¤œà¤¾à¤°à¥€',0),(172900,4803,'ms','Maklumat keluaran',0),(172901,4803,'ar','Ø§Ù„Ø¥ÙØ±Ø§Ø¬ Ø¹Ù† Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(172902,4803,'fr','Informations sur la version',0),(172903,4803,'jp','ãƒªãƒªãƒ¼ã‚¹æƒ…å ±',0),(172904,4803,'pt','InformaÃ§Ãµes de lanÃ§amento',0),(172905,4803,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð²Ñ‹Ð¿ÑƒÑÐºÐµ',0),(172906,4803,'es','InformaciÃ³n de PublicaciÃ³n',0),(172907,4803,'de','Release-Informationen',0),(172908,4803,'en','Release Information',0),(172909,4804,'is','',0),(172910,4804,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ ÙŠØ§ Ø¬Ø¯ÙŠØ¯ ',0),(172911,4804,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ ÙŠØ§ Ø¬Ø¯ÙŠØ¯ ',0),(172912,4804,'tr','Reprint yeni ya da',0),(172913,4804,'pl','Przedruk lub nowe',0),(172914,4804,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð¸Ð»Ð¸ Ð½Ð¾Ð²Ð¸',0),(172915,4804,'ur','Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ ÛŒØ§ Ù†ÛŒØ§',0),(172916,4804,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¸Ð»Ð¸ Ð½Ð¾Ð²Ð¾',0),(172917,4804,'vi','In láº¡i hay má»›i',0),(172918,4804,'af','Herdruk of Nuwe',0),(172919,4804,'ro','ImprimaÅ£i sau noi',0),(172920,4804,'et','KordustrÃ¼kk erahuvides',0),(172921,4804,'si','Ponatis ali nova',0),(172922,4804,'ba','Cetak ulang atau baru',0),(172923,4804,'nl','Herdruk of nieuwe',0),(172924,4804,'fi','Uusintapainos tai uusi',0),(172925,4804,'no','Opptrykk eller ny',0),(172926,4804,'da','Genoptryk eller nye',0),(172927,4804,'ko','ë¬´ë‹¨ ì „ìž¬ ë˜ëŠ” ìƒˆë¡œìš´',0),(172928,4804,'he','×”×“×¤×¡×” ×ž×—×“×© ××• ×—×“×©',0),(172929,4804,'el','Î‘Î½Î±Ï„ÏÏ€Ï‰ÏƒÎ· Î® Î½Î­Î±',0),(172930,4804,'zh','é‡å°æˆ–æ–°\r\n',0),(172931,4804,'sv','Nytryck eller nya',0),(172932,4804,'it','Ristampa o nuova',0),(172933,4804,'tl','',0),(172934,4804,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;&#3627;&#3619;&#3639;&#3629;&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3627;&#3617;&#3656;',0),(172935,4804,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤¯à¤¾ à¤¨à¤¯à¤¾',0),(172936,4804,'ms','Pencetakan semula atau baru',0),(172937,4804,'ar','Ø·Ø¨Ø¹ Ø£Ùˆ Ø¬Ø¯ÙŠØ¯Ø©',0),(172938,4804,'fr','RÃ©impression ou nouveau',0),(172939,4804,'jp','å†?å?°åˆ·ã?‹æ–°è¦?å?°åˆ·',0),(172940,4804,'pt','ReimpressÃ£o ou nova',0),(172941,4804,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¸Ð»Ð¸ ÐÐ¾Ð²Ð¾Ðµ',0),(172942,4804,'es','Reimprimir o nuevo',0),(172943,4804,'de','Nachdruck oder neue',0),(172944,4804,'en','Reprint or New',0),(172945,4805,'is','',0),(172946,4805,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø¨Ø§ ØªØºÙŠÙŠØ±Ø§Øª ',0),(172947,4805,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø¨Ø§ ØªØºÙŠÙŠØ±Ø§Øª ',0),(172948,4805,'tr','DeÄŸiÅŸikliklerle yeniden yazdÄ±rÄ±n',0),(172949,4805,'pl','Przedruk z zmiany',0),(172950,4805,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ñ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(172951,4805,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾ Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹',0),(172952,4805,'sr','ÐˆÐ°Ð²Ð¸Ð¾ ÑÐ° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°Ð¼Ð°',0),(172953,4805,'vi','In láº¡i vá»›i thay Ä‘á»•i',0),(172954,4805,'af','Herdruk met Veranderinge',0),(172955,4805,'ro','RetipÄƒrire cu modificÄƒri',0),(172956,4805,'et','KordustrÃ¼kk muutustega',0),(172957,4805,'si','Ponatis s spremembami',0),(172958,4805,'ba','Reprint dengan perubahan',0),(172959,4805,'nl','Herdruk met wijzigingen',0),(172960,4805,'fi','Tulostaa muutokset',0),(172961,4805,'no','Skrive ut med endringer',0),(172962,4805,'da','Genoptrykke med Ã¦ndringer',0),(172963,4805,'ko','ë³€ê²½ ë‚´ìš©ì„ í•¨ê»˜í•©ë‹ˆë‹¤',0),(172964,4805,'he','×œ×”×“×¤×™×¡ ×ž×—×“×© ×¢× ×©×™× ×•×™×™×',0),(172965,4805,'el','Î‘Î½Î±Ï„ÏÏ€Ï‰ÏƒÎ· Î¼Îµ Î±Î»Î»Î±Î³Î­Ï‚',0),(172966,4805,'zh','æœ‰å˜åŒ–åœ°é‡å°\r\n',0),(172967,4805,'sv','Nytryck med Ã¤ndringar',0),(172968,4805,'it','Ristampa con modifiche',0),(172969,4805,'tl','',0),(172970,4805,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(172971,4805,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£',0),(172972,4805,'ms','Juga boleh dicetak semula dengan pindaan',0),(172973,4805,'ar','Ø·Ø¨Ø¹ Ù…Ø¹ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(172974,4805,'fr','RÃ©impression avec modifications',0),(172975,4805,'jp','å¤‰æ›´ã‚’å?«ã‚?ã?¦å†?å?°åˆ·',0),(172976,4805,'pt','ReimpressÃ£o com alteraÃ§Ãµes',0),(172977,4805,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸ÑÐ¼Ð¸',0),(172978,4805,'es','Reimprimir con Cargos',0),(172979,4805,'de','Nachdruck mit Ã„nderungen',0),(172980,4805,'en','Reprint with Changes',0),(172981,4806,'is','',0),(172982,4806,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø§ÙŠ Ù…Ø¯Ø±Ùƒ ',0),(172983,4806,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø§ÙŠ Ù…Ø¯Ø±Ùƒ ',0),(172984,4806,'tr','KanÄ±t iÃ§in istek',0),(172985,4806,'pl','Wniosek o dowÃ³d',0),(172986,4806,'bg','Ð˜ÑÐºÐ°Ð½Ðµ Ð·Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(172987,4806,'ur','Ø«Ø¨ÙˆØª Ú©Û’ Ù„Ø¦Û’ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(172988,4806,'sr','Ð—Ð°Ñ…Ñ‚Ñ˜ÐµÐ² Ð·Ð° Ð´Ð¾ÐºÐ°Ð·',0),(172989,4806,'vi','YÃªu cáº§u báº£n in thá»­',0),(172990,4806,'af','Versoek vir Proef',0),(172991,4806,'ro','Cerere pentru dovada',0),(172992,4806,'et','Taotlus tÃµendi',0),(172993,4806,'si','Zahteva za dokaz',0),(172994,4806,'ba','Permintaan untuk bukti',0),(172995,4806,'nl','Verzoek om bewijs',0),(172996,4806,'fi','PyyntÃ¶Ã¤',0),(172997,4806,'no','ForespÃ¸rsel om bevis',0),(172998,4806,'da','Anmodning om bevis',0),(172999,4806,'ko','ì¦ê±°ì— ëŒ€ í•œ ìš”ì²­',0),(173000,4806,'he','×‘×§×©×” ×œ×§×‘×œ×ª ×”×•×›×—×”',0),(173001,4806,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î³Î¹Î± Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î·',0),(173002,4806,'zh','è¦æ±‚æä¾›è¯æ˜Ž\r\n',0),(173003,4806,'sv','BegÃ¤ran om bevis',0),(173004,4806,'it','Richiesta di prova',0),(173005,4806,'tl','',0),(173006,4806,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(173007,4806,'hi','à¤¸à¤¬à¥‚à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(173008,4806,'ms','Permohonan untuk bukti',0),(173009,4806,'ar','Ø·Ù„Ø¨ Ù„Ù„Ø¥Ø«Ø¨Ø§Øª',0),(173010,4806,'fr','Demande d\'avis',0),(173011,4806,'jp','æ ¡æ­£ã?®è¦?æ±‚',0),(173012,4806,'pt','Pedido de prova',0),(173013,4806,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(173014,4806,'es','PeticiÃ³n para Prueba de ImpresiÃ³n',0),(173015,4806,'de','Anforderung fÃ¼r den Nachweis',0),(173016,4806,'en','Request for Proof',0),(173017,4807,'is','',0),(173018,4807,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(173019,4807,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(173020,4807,'tr','Teklif talebi',0),(173021,4807,'pl','ProÅ›ba o wycenÄ™',0),(173022,4807,'bg','Ð—Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð·Ð°',0),(173023,4807,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(173024,4807,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(173025,4807,'vi','YÃªu cáº§u báº£ng giÃ¡',0),(173026,4807,'af','Versoek vir Kwotasie',0),(173027,4807,'ro','Cerere de ofertÄƒ',0),(173028,4807,'et','Taotlus Quote',0),(173029,4807,'si','Zahtevo za ponudbo',0),(173030,4807,'ba','Permintaan Penawaran',0),(173031,4807,'nl','Aanvraag voor offerte',0),(173032,4807,'fi','TarjouspyyntÃ¶',0),(173033,4807,'no','ForespÃ¸rsel om tilbud',0),(173034,4807,'da','Anmodningen om tilbud',0),(173035,4807,'ko','ê²¬ì  ìš”ì²­',0),(173036,4807,'he','×‘×§×©×” ×œ×”×¦×¢×ª ×ž×—×™×¨',0),(173037,4807,'el','Î‘Î¯Ï„Î·ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(173038,4807,'zh','è¦æ±‚æŠ¥ä»·\r\n',0),(173039,4807,'sv','AnbudsfÃ¶rfrÃ¥gan',0),(173040,4807,'it','Richiesta di preventivo',0),(173041,4807,'tl','',0),(173042,4807,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(173043,4807,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(173044,4807,'ms','Memohon sebut harga',0),(173045,4807,'ar','Ø·Ù„Ø¨ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(173046,4807,'fr','Demande de devis',0),(173047,4807,'jp','è¦‹ç©?ã‚‚ã‚Šã?®è¦?æ±‚',0),(173048,4807,'pt','Pedido de cotaÃ§Ã£o',0),(173049,4807,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(173050,4807,'es','SolicitaciÃ³n para CotizaciÃ³n',0),(173051,4807,'de','Anfrage',0),(173052,4807,'en','Request for Quote',0),(173053,4808,'is','',0),(173054,4808,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(173055,4808,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(173056,4808,'tr','GÃ¶zden geÃ§irme',0),(173057,4808,'pl','PrzeglÄ…d',0),(173058,4808,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´',0),(173059,4808,'ur','Ù†Ø¸Ø± Ø«Ø§Ù†ÛŒ',0),(173060,4808,'sr','Ð ÐµÐ´Ð¸Ð³Ð¾Ð²Ð°ÑšÐµ',0),(173061,4808,'vi','ÄÃ¡nh giÃ¡',0),(173062,4808,'af','Hersien',0),(173063,4808,'ro','Revizuirea',0),(173064,4808,'et','LÃ¤bivaatamine',0),(173065,4808,'si','Pregledovanje',0),(173066,4808,'ba','Meninjau',0),(173067,4808,'nl','Herziening',0),(173068,4808,'fi','Tarkistaminen',0),(173069,4808,'no','Gjennomgang',0),(173070,4808,'da','GennemgÃ¥',0),(173071,4808,'ko','ê²€í† ',0),(173072,4808,'he','×¡×§×™×¨×ª',0),(173073,4808,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(173074,4808,'zh','å¤å®¡\r\n',0),(173075,4808,'sv','Granska',0),(173076,4808,'it','Revisione',0),(173077,4808,'tl','',0),(173078,4808,'th','&#3585;&#3634;&#3619;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;',0),(173079,4808,'hi','à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(173080,4808,'ms','Mengkaji semula',0),(173081,4808,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶',0),(173082,4808,'fr','Examen',0),(173083,4808,'jp','è¦‹ç›´ã?™',0),(173084,4808,'pt','Revendo',0),(173085,4808,'ru','ÐžÐ±Ð·Ð¾Ñ€',0),(173086,4808,'es','Revisando',0),(173087,4808,'de','ÃœberprÃ¼fung',0),(173088,4808,'en','Reviewing',0),(173089,4809,'is','',0),(173090,4809,'dr','Ø§ØµÙ„Ø§Ø­',0),(173091,4809,'pr','Ø§ØµÙ„Ø§Ø­',0),(173092,4809,'tr','GÃ¶zden geÃ§irilmesi',0),(173093,4809,'pl','Rewizji',0),(173094,4809,'bg','ÐŸÑ€ÐµÑ€Ð°Ð·Ð³Ð»ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð°',0),(173095,4809,'ur','Ø«Ø§Ù†ÛŒ',0),(173096,4809,'sr','Ð ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ð°',0),(173097,4809,'vi','Chá»‰nh sá»­a',0),(173098,4809,'af','Hersiening',0),(173099,4809,'ro','Revizuirea',0),(173100,4809,'et','LÃ¤bivaatamisel',0),(173101,4809,'si','Revizija',0),(173102,4809,'ba','Merevisi',0),(173103,4809,'nl','Herziening',0),(173104,4809,'fi','Tarkistaminen',0),(173105,4809,'no','Revidere',0),(173106,4809,'da','Revision',0),(173107,4809,'ko','ê°œì •',0),(173108,4809,'he','×ª×™×§×•×Ÿ',0),(173109,4809,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(173110,4809,'zh','ä¿®æ”¹\r\n',0),(173111,4809,'sv','Revidera',0),(173112,4809,'it','Revisione',0),(173113,4809,'tl','',0),(173114,4809,'th','&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(173115,4809,'hi','à¤®à¥‡à¤‚ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨',0),(173116,4809,'ms','Mengkaji',0),(173117,4809,'ar','ØªÙ†Ù‚ÙŠØ­',0),(173118,4809,'fr','RÃ©vision',0),(173119,4809,'jp','ä¿®æ­£ä¸­',0),(173120,4809,'pt','RevisÃ£o',0),(173121,4809,'ru','ÐŸÐµÑ€ÐµÑÐ¼Ð¾Ñ‚Ñ€',0),(173122,4809,'es','Revisando',0),(173123,4809,'de','Ãœberarbeitung',0),(173124,4809,'en','Revising',0),(173125,4810,'is','',0),(173126,4810,'dr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¨Ø¯ÙˆÙ† Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬Ø¯Ø¯',0),(173127,4810,'pr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¨Ø¯ÙˆÙ† Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬Ø¯Ø¯',0),(173128,4810,'tr','DÃ¼zen deÄŸiÅŸiklikleri kaydetmek yok yeniden hesapla',0),(173129,4810,'pl','Zapisz zmiany w zamÃ³wieniu nie Oblicz ponownie',0),(173130,4810,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð² Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð½Ðµ ÐŸÑ€ÐµÐ¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð¹',0),(173131,4810,'ur','Ú©Ø³ÛŒ Ú©Ø§ Ù¾Ú¾Ø± Ø­Ø³Ø§Ø¨ Ù„Ú¯Ø§Ø¦ÛŒÚº ØªØ±ØªÛŒØ¨ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(173132,4810,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð½ÐµÐ¼Ð° Ð¿Ð¾Ð½Ð¾Ð²Ð½Ð¾ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ',0),(173133,4810,'vi','Sao lÆ°u thay Ä‘á»•i trong Ä‘Æ¡n hÃ ng khÃ´ng tÃ­nh láº¡i',0),(173134,4810,'af','Stoor Bestelling Veranderinge GEEN Herberekening',0),(173135,4810,'ro','SalvaÅ£i modificÄƒrile comanda recalculare nu',0),(173136,4810,'et','Salvesta muutumisel ei Arvuta',0),(173137,4810,'si','Shranite spremembe nalog ni PreraÄunaj',0),(173138,4810,'ba','Simpan perubahan agar tidak menghitung ulang',0),(173139,4810,'nl','Opslaan Bestelwijzigingen geen herberekenen',0),(173140,4810,'fi','Tallenna muuttuu ei laske',0),(173141,4810,'no','Lagre endres ikke beregne',0),(173142,4810,'da','Gemme Ã¦ndringer ingen Genberegn',0),(173143,4810,'ko','ì•„ë‹ˆ ë‹¤ì‹œ ê³„ì‚° ìˆœì„œ ë³€ê²½ ì €ìž¥',0),(173144,4810,'he','×œ×©×ž×•×¨ ×©×™× ×•×™×™× ×¡×“×¨ ×œ× ×—×©×‘ ×ž×—×“×©',0),(173145,4810,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÏ„Îµ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚ ÎµÎ½Ï„Î¿Î»Î® Î½Î­Î¿Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Î´ÎµÎ½',0),(173146,4810,'zh','ä¿å­˜è®¢å•å˜åŒ–æ²¡æœ‰ä»»ä½•é‡æ–°è®¡ç®—\r\n',0),(173147,4810,'sv','Spara Order Ã¤ndringar inte rÃ¤kna',0),(173148,4810,'it','Non salvare le modifiche di ordine Ricalcola',0),(173149,4810,'tl','',0),(173150,4810,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3609;&#3633;&#3610;',0),(173151,4810,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤¨à¤°à¥à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤•à¤°à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(173152,4810,'ms','Menyimpan perubahan perintah Recalculate tiada',0),(173153,4810,'ar','Ø­ÙØ¸ ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù… Ù„Ø§ Ø¥Ø¹Ø§Ø¯Ø© Ø­Ø³Ø§Ø¨',0),(173154,4810,'fr','Enregistrer les modifications de l\'ordre sans recalculer',0),(173155,4810,'jp','å†?è¨ˆç®—ã?ªã?—ã?§æ³¨æ–‡ã?®å¤‰æ›´ã‚’ä¿?å­˜ã?™ã‚‹',0),(173156,4810,'pt','Salvar as alteraÃ§Ãµes de ordem nÃ£o recalcular',0),(173157,4810,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð½Ðµ Ð¿ÐµÑ€ÐµÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ',0),(173158,4810,'es','Guardar Cambios de Pedidos NO Recalcular',0),(173159,4810,'de','Speichern von AuftragsÃ¤nderungen keine neu berechnen',0),(173160,4810,'en','Save Order Changes NO Recalculate',0),(173161,4811,'is','',0),(173162,4811,'dr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬Ø¯Ø¯',0),(173163,4811,'pr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬Ø¯Ø¯',0),(173164,4811,'tr','DÃ¼zen deÄŸiÅŸiklikleri kaydetmek ile yeniden hesapla',0),(173165,4811,'pl','Zapisz zmiany w zamÃ³wieniu z Oblicz ponownie',0),(173166,4811,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ñ€ÐµÐ´ Ñ ÐŸÑ€ÐµÐ¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð¹',0),(173167,4811,'ur','Ú©Ø§ Ù¾Ú¾Ø± Ø­Ø³Ø§Ø¨ Ù„Ú¯Ø§Ø¦ÛŒÚº Ú©Û’ Ø³Ø§ØªÚ¾ ØªØ±ØªÛŒØ¨ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(173168,4811,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð° Ð½Ð°Ð»Ð¾Ð³Ð° ÑÐ° Ð¿Ð¾Ð½Ð¾Ð²Ð½Ð¾ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ',0),(173169,4811,'vi','Sao lÆ°u thay Ä‘á»•i trong Ä‘Æ¡n hÃ ng & tÃ­nh láº¡i',0),(173170,4811,'af','Stoor Bestelling Veranderinge MET Herberekening',0),(173171,4811,'ro','SalvaÅ£i modificÄƒrile de ordin cu recalculare',0),(173172,4811,'et','Salvesta korralduse muutused Arvuta',0),(173173,4811,'si','Naloga spremembe shranite z PreraÄunaj',0),(173174,4811,'ba','Simpan perubahan Order dengan menghitung ulang',0),(173175,4811,'nl','Bestelwijzigingen opslaan met herberekenen',0),(173176,4811,'fi','Tallentaa tilauksen muutokset uudelleen',0),(173177,4811,'no','Lagre endres med Omberegn',0),(173178,4811,'da','Gemme Ã¦ndringer med Genberegn',0),(173179,4811,'ko','ë‹¤ì‹œ ê³„ì‚° ìˆœì„œ ë³€ê²½ ì €ìž¥',0),(173180,4811,'he','×œ×©×ž×•×¨ ××ª ×”×©×™× ×•×™×™× ×”×¡×“×¨ ×¢× ×—×©×‘ ×ž×—×“×©',0),(173181,4811,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚ ÎµÎ½Ï„Î¿Î»Î® Î¼Îµ Î½Î­Î¿Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚',0),(173182,4811,'zh','ä¿å­˜é‡æ–°è®¡ç®—è®¢å•å˜æ›´\r\n',0),(173183,4811,'sv','Spara Ã¤ndringar av ordningen med berÃ¤kna',0),(173184,4811,'it','Salvare le modifiche di ordine con Ricalcola',0),(173185,4811,'tl','',0),(173186,4811,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3595;&#3638;&#3591;&#3652;&#3617;&#3656;&#3609;&#3633;&#3610;',0),(173187,4811,'hi','à¤¸à¤¾à¤¥ à¤ªà¥à¤¨à¤°à¥à¤ªà¤°à¤¿à¤•à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(173188,4811,'ms','Menyimpan perubahan perintah dengan Recalculate',0),(173189,4811,'ar','Ø­ÙØ¸ ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù… Ù…Ø¹ Ø¥Ø¹Ø§Ø¯Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(173190,4811,'fr','Enregistrer les modifications de l\'ordre Ã  recalculer',0),(173191,4811,'jp','å†?è¨ˆç®—ã?—ã?¦æ³¨æ–‡ã?®å¤‰æ›´ã‚’ä¿?å­˜ã?™ã‚‹',0),(173192,4811,'pt','Salvar as alteraÃ§Ãµes de ordem com recalcular',0),(173193,4811,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ñ Ð¿ÐµÑ€ÐµÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ',0),(173194,4811,'es','Guardar Cambios de Pedidos CON Recalcular',0),(173195,4811,'de','Speichern von AuftragsÃ¤nderungen mit neu berechnen',0),(173196,4811,'en','Save Order Changes WITH Recalculate',0),(173197,4812,'is','',0),(173198,4812,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø¨Ø¹Ø¯ÙŠ',0),(173199,4812,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø¨Ø¹Ø¯ÙŠ',0),(173200,4812,'tr','Daha sonra gÃ¶zden geÃ§irmek iÃ§in dÃ¼zeni Kaydet',0),(173201,4812,'pl','Zapisz zamÃ³wienie dla pÃ³Åºniejszego przejrzenia',0),(173202,4812,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð²Ð°Ñ‰ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(173203,4812,'ur','Ø¨Ø¹Ø¯ Ø§Ø²Ø§Úº Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©Û’ Ù„ÛŒÛ’ ØªØ±ØªÛŒØ¨ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(173204,4812,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð·Ð° Ð½Ð¾Ð²Ð¸Ñ˜Ð¸ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(173205,4812,'vi','Sao lÆ°u Ä‘Æ¡n hÃ ng Ä‘á»ƒ bÃ¬nh duyá»‡t sau',0),(173206,4812,'af','Stoor Bestelling vir Latere Nasiening',0),(173207,4812,'ro','SalvaÅ£i pentru ca mai tÃ¢rziu de revizuire',0),(173208,4812,'et','Salvesta jÃ¤rjestus hilisemaks lÃ¤bivaatamiseks',0),(173209,4812,'si','Shrani za kasnejÅ¡i pregled nalog',0),(173210,4812,'ba','Hemat untuk meninjau',0),(173211,4812,'nl','Opslaan om Later kunt bekijken',0),(173212,4812,'fi','Tallenna tilaus myÃ¶hempÃ¤Ã¤ tarkastelua varten',0),(173213,4812,'no','Lagre rekkefÃ¸lgen for senere vurdering',0),(173214,4812,'da','Gemme rÃ¦kkefÃ¸lge til senere gennemsyn',0),(173215,4812,'ko','ë‚˜ì¤‘ì— ê²€í†  ìˆœì„œ ì €ìž¥',0),(173216,4812,'he','×©×ž×™×¨×ª ×”×¡×“×¨ ×œ×¡×§×™×¨×” ×ž××•×—×¨×ª ×™×•×ª×¨',0),(173217,4812,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Î³Î¹Î± Î±ÏÎ³ÏŒÏ„ÎµÏÎ± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(173218,4812,'zh','ä¿å­˜è®¢è´­ä»¥åŽæŸ¥çœ‹\r\n',0),(173219,4812,'sv','Spara fÃ¶r senare granskning',0),(173220,4812,'it','Salvare l\'ordine per la successiva revisione',0),(173221,4812,'tl','',0),(173222,4812,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3616;&#3634;&#3618;&#3627;&#3621;&#3633;&#3591;',0),(173223,4812,'hi','à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤°à¤® à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(173224,4812,'ms','Simpan untuk kajian semula kemudian',0),(173225,4812,'ar','Ø­ÙØ¸ Ø§Ù„Ù†Ø¸Ø§Ù… Ù„Ù…Ø±Ø§Ø¬Ø¹Ø© Ù„Ø§Ø­Ù‚Ø©',0),(173226,4812,'fr','Enregistrer ordre pour examen ultÃ©rieur',0),(173227,4812,'jp','ã?‚ã?¨ã?§è¦‹ç›´ã?™ã?Ÿã‚?ã?«æ³¨æ–‡ã‚’ä¿?å­˜ã?™ã‚‹',0),(173228,4812,'pt','Salvar a ordem para revisÃ£o posterior',0),(173229,4812,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð´Ð»Ñ Ð¿Ð¾ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ³Ð¾ Ñ€Ð°ÑÑÐ¼Ð¾Ñ‚Ñ€ÐµÐ½Ð¸Ñ',0),(173230,4812,'es','Guardar Pedido para RevisiÃ³n MÃ¡s Tarde',0),(173231,4812,'de','Auftrag zur spÃ¤teren ÃœberprÃ¼fung speichern',0),(173232,4812,'en','Save Order for Later Review',0),(173233,4813,'is','',0),(173234,4813,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¯Ø± ÙØ§ÙŠÙ„ Ø³ÙØ§Ø±Ø´ ÙØ¹Ø§Ù„',0),(173235,4813,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¯Ø± ÙØ§ÙŠÙ„ Ø³ÙØ§Ø±Ø´ ÙØ¹Ø§Ù„',0),(173236,4813,'tr','SipariÅŸ etkin sipariÅŸ dosyasÄ±na kaydetmek',0),(173237,4813,'pl','Zapisz kolejnoÅ›Ä‡ w pliku aktywne zlecenie',0),(173238,4813,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ñ€ÐµÐ´Ð° Ð²ÑŠÐ² Ñ„Ð°Ð¹Ð»Ð° Ð·Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(173239,4813,'ur','ØªØ±ØªÛŒØ¨ Ø²ÛŒØ± Ø¹Ù…Ù„ ØªØ±ØªÛŒØ¨ Ù…Ø³Ù„ Ù…ÛŒÚº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(173240,4813,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°',0),(173241,4813,'vi','Sao lÆ°u Ä‘Æ¡n hÃ ng trong há»“ sÆ¡ Ä‘ang lÃ m',0),(173242,4813,'af','Stoor Bestelling in Aktiewe BestellinglÃªer',0),(173243,4813,'ro','Salva ordinea Ã®n activÄƒ comanda fiÅŸier',0),(173244,4813,'et','Salvesta jÃ¤rjestus Aktiivne tellimus faili',0),(173245,4813,'si','ReÅ¡iti naloga v aktivni nalog datoteke',0),(173246,4813,'ba','Menyimpan perintah dalam File Order aktif',0),(173247,4813,'nl','Volgorde in actieve Order bestand opslaan',0),(173248,4813,'fi','Tallenna tilaus aktiivinen tilaus tiedostoon',0),(173249,4813,'no','Lagre ordren i aktive ordrefil',0),(173250,4813,'da','Gemme rÃ¦kkefÃ¸lge i aktive ordre fil',0),(173251,4813,'ko','í™œì„± ìˆœì„œ íŒŒì¼ì—ì„œ ìˆœì„œë¥¼ ì €ìž¥',0),(173252,4813,'he','×œ×©×ž×•×¨ ××ª ×”×”×–×ž× ×” ×‘×§×•×‘×¥ ×”×–×ž× ×” ×¤×¢×™×œ×”',0),(173253,4813,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÎ¹ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÏ„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ ÎµÎ½ÎµÏÎ³Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(173254,4813,'zh','ä¿å­˜è®¢å•åœ¨æ´»è·ƒè®¢å•æ–‡ä»¶ä¸­\r\n',0),(173255,4813,'sv','Spara Order i aktiva orderfil',0),(173256,4813,'it','Salvare l\'ordine nel File ordine attivo',0),(173257,4813,'tl','',0),(173258,4813,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3652;&#3615;&#3621;&#3660;&#3607;&#3637;&#3656;&#3648;&#3611;&#3636;&#3604;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(173259,4813,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤†à¤¦à¥‡à¤¶ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(173260,4813,'ms','Menyimpan pesanan dalam fail aktif perintah',0),(173261,4813,'ar','Ø­ÙØ¸ Ø§Ù„Ù†Ø¸Ø§Ù… ÙÙŠ Ù…Ù„Ù Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ù†Ø´Ø·',0),(173262,4813,'fr','Enregistrer l\'ordre dans le fichier de commande Active',0);
INSERT INTO `langdef` VALUES (173263,4813,'jp','æœ‰åŠ¹ã?ªæ³¨æ–‡ãƒ•ã‚¡ã‚¤ãƒ«ã?«æ³¨æ–‡ã‚’ä¿?å­˜ã?™ã‚‹',0),(173264,4813,'pt','Salvar a ordem no arquivo ativo da ordem',0),(173265,4813,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð· Ð² Ð¤Ð°Ð¹Ð»Ðµ ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(173266,4813,'es','Guardar Pedido en Archivo de Pedidos Activos',0),(173267,4813,'de','Auftrag in aktive Bestellung-Datei speichern',0),(173268,4813,'en','Save Order in Active Order File',0),(173269,4814,'is','',0),(173270,4814,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(173271,4814,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(173272,4814,'tr','Setleri',0),(173273,4814,'pl','ZESTAWY',0),(173274,4814,'bg','ÐšÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¸',0),(173275,4814,'ur','Ø³ÛŒÙ¹ Ú©Ø±ØªØ§ ÛÛ’',0),(173276,4814,'sr','Ð¡ÐºÑƒÐ¿Ð¾Ð²Ð¸',0),(173277,4814,'vi','Äáº·t',0),(173278,4814,'af','Stelle',0),(173279,4814,'ro','Seturi',0),(173280,4814,'et','Komplektid',0),(173281,4814,'si','Kompleti',0),(173282,4814,'ba','Set',0),(173283,4814,'nl','Sets',0),(173284,4814,'fi','Setit',0),(173285,4814,'no','Sett',0),(173286,4814,'da','SÃ¦t',0),(173287,4814,'ko','ì„¸íŠ¸',0),(173288,4814,'he','×¡×˜×™×',0),(173289,4814,'el','Î£ÏÎ½Î¿Î»Î±',0),(173290,4814,'zh','é›†\r\n',0),(173291,4814,'sv','UppsÃ¤ttningar',0),(173292,4814,'it','Set',0),(173293,4814,'tl','',0),(173294,4814,'th','&#3585;&#3635;&#3627;&#3609;&#3604;',0),(173295,4814,'hi','à¤¸à¥‡à¤Ÿ',0),(173296,4814,'ms','Set',0),(173297,4814,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª',0),(173298,4814,'fr','Ensembles',0),(173299,4814,'jp','ã‚»ãƒƒãƒˆ',0),(173300,4814,'pt','Moda',0),(173301,4814,'ru','ÐÐ°Ð±Ð¾Ñ€Ñ‹',0),(173302,4814,'es','Juegos',0),(173303,4814,'de','Sets',0),(173304,4814,'en','Sets',0),(173305,4815,'is','',0),(173306,4815,'dr','/ Ø«Ø¨Øª / Ø¯ÙØªØ±Ú†Ù‡ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(173307,4815,'pr','ØªÙ†Ø¸ÙŠÙ… / Ø«Ø¨Øª / Ø¯ÙØªØ±Ú†Ù‡ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(173308,4815,'tr','Kitap-set-Pad',0),(173309,4815,'pl','Zestaw/ksiÄ…Å¼ki/Pad',0),(173310,4815,'bg','ÐšÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚/ÐºÐ½Ð¸Ð³Ð°/ÐÐºÑ‚ÑƒÐ°Ð»Ð½Ð¾',0),(173311,4815,'ur','Ø³ÛŒÙ¹/Ú©ØªØ§Ø¨/Ù¾ÛŒÚˆ',0),(173312,4815,'sr','Ð¡ÐºÑƒÐ¿ /ÐºÑšÐ¸Ð³Ñƒ /Ð¿Ð¾Ð´Ð»Ð¾Ð³Ð° Ð·Ð°',0),(173313,4815,'vi','Äáº·t/SÃ¡ch/Äá»‡m',0),(173314,4815,'af','Stel/boek/Pad',0),(173315,4815,'ro','Set/carte/Pad',0),(173316,4815,'et','Set/raamat/padi',0),(173317,4815,'si','Knjige/niz/Pad',0),(173318,4815,'ba','Set/buku/Pad',0),(173319,4815,'nl','Set/boek/Pad',0),(173320,4815,'fi','Set/kirja/Pad',0),(173321,4815,'no','Sett/bok/pute',0),(173322,4815,'da','SÃ¦t/bog/Pad',0),(173323,4815,'ko','ì„¸íŠ¸/ì±…/íŒ¨ë“œ',0),(173324,4815,'he','×¡×˜/×¡×¤×¨/×›×¨×™×ª',0),(173325,4815,'el','Î£ÏÎ½Î¿Î»Î¿/Î²Î¹Î²Î»Î¯Î¿/Î¼Î±Î¾Î¹Î»Î¬ÏÎ¹',0),(173326,4815,'zh','è®¾ç½®/å›¾ä¹¦/åž«\r\n',0),(173327,4815,'sv','Set/bok/Pad',0),(173328,4815,'it','Set/libro/Pad',0),(173329,4815,'tl','',0),(173330,4815,'th','Set/Book/Pad',0),(173331,4815,'hi','à¤¸à¥‡à¤Ÿ/à¤ªà¥à¤¸à¥à¤¤à¤•/à¤ªà¥ˆà¤¡',0),(173332,4815,'ms','Set/buku/Pad',0),(173333,4815,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø©/ÙƒØªØ§Ø¨/Pad',0),(173334,4815,'fr','Ensemble/livre/Pad',0),(173335,4815,'jp','ã‚»ãƒƒãƒˆ/å†Šå­?/ãƒ‘ãƒƒãƒ‰',0),(173336,4815,'pt','Conjunto/livro/Pad',0),(173337,4815,'ru','ÐÐ°Ð±Ð¾Ñ€/ÐºÐ½Ð¸Ð³Ð¸/Pad',0),(173338,4815,'es','Configurar/Libro/Pad',0),(173339,4815,'de','Satz/Buch/Pad',0),(173340,4815,'en','Set/Book/Pad',0),(173341,4816,'is','',0),(173342,4816,'dr','(ÙˆØ±Ù‚) Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(173343,4816,'pr','Ø¨Ø±Ú¯Ù‡ (ÙˆØ±Ù‚) Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(173344,4816,'tr','Yaprak/adet',0),(173345,4816,'pl','Arkuszy/szt',0),(173346,4816,'bg','Ð›Ð¸ÑÑ‚Ð¾Ð²Ðµ/ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(173347,4816,'ur','Ø§ÙˆØ±Ø§Ù‚/ÛŒÙˆÙ†Ù¹',0),(173348,4816,'sr','Ð›Ð¸ÑÑ‚Ð¾Ð²Ð¸/Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(173349,4816,'vi','Trang/ÄÆ¡n vá»‹',0),(173350,4816,'af','Velle/Eenheid',0),(173351,4816,'ro','Foi/unitate',0),(173352,4816,'et','Lehed/Ã¼hik',0),(173353,4816,'si','Listi/enoto',0),(173354,4816,'ba','Lembar/Unit',0),(173355,4816,'nl','Bladen/eenheid',0),(173356,4816,'fi','Lakanat/yksikkÃ¶',0),(173357,4816,'no','Ark/enhet',0),(173358,4816,'da','Ark/enhed',0),(173359,4816,'ko','ì‹œíŠ¸/ë‹¨ìœ„',0),(173360,4816,'he','×’×™×œ×™×•× ×•×ª/×™×—×™×“×”',0),(173361,4816,'el','Î¦ÏÎ»Î»Î± Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î±',0),(173362,4816,'zh','å•/å•ä½\r\n',0),(173363,4816,'sv','Ark/enhet',0),(173364,4816,'it','Fogli per unitÃ ',0),(173365,4816,'tl','',0),(173366,4816,'th','&#3649;&#3612;&#3656;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;/&#3627;&#3609;&#3656;&#3623;&#3618;',0),(173367,4816,'hi','à¤šà¤¾à¤¦à¤°à¥‡à¤‚/à¤‡à¤•à¤¾à¤ˆ',0),(173368,4816,'ms','Cadar/Unit',0),(173369,4816,'ar','Ø£ÙˆØ±Ø§Ù‚/Ø§Ù„ÙˆØ­Ø¯Ø©',0),(173370,4816,'fr','Feuilles/unitÃ©',0),(173371,4816,'jp','ã‚·ãƒ¼ãƒˆ/å?˜ä½?',0),(173372,4816,'pt','Folhas/unidade',0),(173373,4816,'ru','Ð›Ð¸ÑÑ‚Ñ‹/Ð±Ð»Ð¾Ðº',0),(173374,4816,'es','Hojas/Unidad',0),(173375,4816,'de','BlÃ¤tter/Einheit',0),(173376,4816,'en','Sheets/Unit',0),(173377,4817,'is','',0),(173378,4817,'dr','(Ø¨Ø±Ú¯Ù‡',0),(173379,4817,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙˆØ±Ù‚(Ø¨Ø±Ú¯Ù‡',0),(173380,4817,'tr','Yaprak boyutu',0),(173381,4817,'pl','Rozmiar arkusza',0),(173382,4817,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð»Ð¸ÑÑ‚',0),(173383,4817,'ur','Ø³Ø§Ø¦Ø² ÙˆØ±Ù‚',0),(173384,4817,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð»Ð¸ÑÑ‚Ð°',0),(173385,4817,'vi','Cá»¡ Trang',0),(173386,4817,'af','Velgrootte',0),(173387,4817,'ro','Dimensiune foaie',0),(173388,4817,'et','Lehe suurus',0),(173389,4817,'si','Velikost lista',0),(173390,4817,'ba','Lembar ukuran',0),(173391,4817,'nl','Papierformaat',0),(173392,4817,'fi','Arkin koko',0),(173393,4817,'no','ArkstÃ¸rrelsen',0),(173394,4817,'da','ArkstÃ¸rrelse',0),(173395,4817,'ko','ì‹œíŠ¸ í¬ê¸°',0),(173396,4817,'he','×’×•×“×œ ×’×™×œ×™×•×Ÿ',0),(173397,4817,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Ï†ÏÎ»Î»Î¿Ï…',0),(173398,4817,'zh','çº¸å¼ å°ºå¯¸\r\n',0),(173399,4817,'sv','Arkstorlek',0),(173400,4817,'it','Formato del foglio',0),(173401,4817,'tl','',0),(173402,4817,'th','&#3586;&#3609;&#3634;&#3604;&#3649;&#3612;&#3656;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(173403,4817,'hi','à¤ªà¤¤à¥à¤°à¤• à¤†à¤•à¤¾à¤°',0),(173404,4817,'ms','Saiz kira-kira',0),(173405,4817,'ar','Ø­Ø¬Ù… Ø§Ù„ÙˆØ±Ù‚Ø©',0),(173406,4817,'fr','Taille de la feuille',0),(173407,4817,'jp','ã‚·ãƒ¼ãƒˆã‚µã‚¤ã‚º',0),(173408,4817,'pt','Tamanho da folha',0),(173409,4817,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð»Ð¸ÑÑ‚Ð°',0),(173410,4817,'es','TamaÃ±o de Hoja',0),(173411,4817,'de','BlattgrÃ¶ÃŸe',0),(173412,4817,'en','Sheet Size',0),(173413,4818,'is','',0),(173414,4818,'dr','Ø¨Ø®Ø´ Ø³ÙØ§Ø±Ø´ ÙˆÙŠÚ˜Ù‡',0),(173415,4818,'pr','Ø¨Ø®Ø´ Ø³ÙØ§Ø±Ø´ ÙˆÙŠÚ˜Ù‡',0),(173416,4818,'tr','Ã–zel sipariÅŸ bÃ¶lÃ¼mÃ¼',0),(173417,4818,'pl','Specjalne zamÃ³wienie sekcji',0),(173418,4818,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ€Ð°Ð·Ð´ÐµÐ»',0),(173419,4818,'ur','Ø®ØµÙˆØµÛŒ Ø­Ú©Ù… Ø³ÛŒÚ©Ø´Ù†',0),(173420,4818,'sr','ÐŸÐ¾ÑÐµÐ±Ð½Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° ÑÐµÐºÑ†Ð¸Ñ˜Ð°',0),(173421,4818,'vi','Má»¥c Ä‘Æ¡n hÃ ng Ä‘áº·c biá»‡t',0),(173422,4818,'af','Spesiale Bestellings-Afdeling',0),(173423,4818,'ro','Speciale pentru secÅ£iunea',0),(173424,4818,'et','Eritellimisel jagu',0),(173425,4818,'si','Posebni nalog oddelka',0),(173426,4818,'ba','Bagian pesanan khusus',0),(173427,4818,'nl','Speciale bestelling sectie',0),(173428,4818,'fi','Erityinen jÃ¤rjestys-osassa',0),(173429,4818,'no','Spesialbestilling delen',0),(173430,4818,'da','Specialordre afsnit',0),(173431,4818,'ko','íŠ¹ë³„ ì£¼ë¬¸ ì„¹ì…˜',0),(173432,4818,'he','×¡×¢×™×£ ×‘×”×–×ž× ×” ×ž×™×•×—×“×ª',0),(173433,4818,'el','\"Î•Î¹Î´Î¹ÎºÎ® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±\" Ï„Î¼Î®Î¼Î±',0),(173434,4818,'zh','ç‰¹åˆ«è®¢è´­éƒ¨åˆ†\r\n',0),(173435,4818,'sv','SÃ¤rskild bestÃ¤llning',0),(173436,4818,'it','Ordine speciale sezione',0),(173437,4818,'tl','',0),(173438,4818,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(173439,4818,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤†à¤¦à¥‡à¤¶ à¤…à¤¨à¥à¤­à¤¾à¤—',0),(173440,4818,'ms','Tempahan Khas Seksyen',0),(173441,4818,'ar','Ù‚Ø³Ù… Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø®Ø§Øµ',0),(173442,4818,'fr','Section de commande spÃ©ciale',0),(173443,4818,'jp','ç‰¹åˆ¥æ³¨æ–‡é?¸æŠžè‚¢',0),(173444,4818,'pt','SeÃ§Ã£o especial de ordem',0),(173445,4818,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð·Ð´ÐµÐ»Ð°',0),(173446,4818,'es','SecciÃ³n de Orden Especial',0),(173447,4818,'de','Sonderauftrag Abschnitt',0),(173448,4818,'en','Special Order Section',0),(173449,4819,'is','',0),(173450,4819,'dr','Ù‚Ø³Ù…Øª Ù…ÙØ§Ø¯  Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(173451,4819,'pr','Ù‚Ø³Ù…Øª Ù…ÙØ§Ø¯  Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(173452,4819,'tr','Hisse senedi amaÃ§ bÃ¶lÃ¼mÃ¼',0),(173453,4819,'pl','CzÄ™Å›Ä‡ zapasÃ³w celem',0),(173454,4819,'bg','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ð° Ñ†ÐµÐ» Ñ‡Ð°ÑÑ‚',0),(173455,4819,'ur','Ø§Ø³Ù¹Ø§Ú© Ù…Ù‚ØµØ¯ Ø­ØµÛ',0),(173456,4819,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ ÑÐ²Ñ€Ñ…Ñƒ Ð´ÐµÐ¾',0),(173457,4819,'vi','Phá»¥ tÃ¹ng Má»¥c Ä‘Ã­ch HÃ ng tá»“n',0),(173458,4819,'af','Voorraad doel deel',0),(173459,4819,'ro','Stoc scop parte',0),(173460,4819,'et','Varude eesmÃ¤rgi osas',0),(173461,4819,'si','Del zalog namen',0),(173462,4819,'ba','Bagian tujuan saham',0),(173463,4819,'nl','Voorraad doel deel',0),(173464,4819,'fi','Varastossa tarkoitus osa',0),(173465,4819,'no','Lager formÃ¥l del',0),(173466,4819,'da','Stock formÃ¥l del',0),(173467,4819,'ko','ìž¬ê³  ëª©ì  ë¶€ë¶„',0),(173468,4819,'he','×ª×›×œ×™×ª ×ž× ×™×•×ª ×—×œ×§',0),(173469,4819,'el','ÎœÎ­ÏÎ¿Ï‚ Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÏƒÎºÎ¿Ï€ÏŒ',0),(173470,4819,'zh','åº“å­˜ç›®çš„éƒ¨åˆ†\r\n',0),(173471,4819,'sv','Stock syfte del',0),(173472,4819,'it','Dipinga scopo parte',0),(173473,4819,'tl','',0),(173474,4819,'th','&#3626;&#3656;&#3623;&#3609;&#3623;&#3633;&#3605;&#3606;&#3640;&#3611;&#3619;&#3632;&#3626;&#3591;&#3588;&#3660;&#3586;&#3629;&#3591;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(173475,4819,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤ªà¥à¤°à¤¯à¥‹à¤œà¤¨ à¤­à¤¾à¤—',0),(173476,4819,'ms','Bahagian saham tujuan',0),(173477,4819,'ar','Ø§Ù„Ø¬Ø²Ø¡ Ø§Ù„ØºØ±Ø¶ Ø§Ù„Ø£Ø³Ù‡Ù…',0),(173478,4819,'fr','Stock de fin partie',0),(173479,4819,'jp','Stock Purpose Part',0),(173480,4819,'pt','Parte do propÃ³sito das aÃ§Ãµes',0),(173481,4819,'ru','Ð§Ð°ÑÑ‚ÑŒ Ð°ÐºÑ†Ð¸Ð¹ Ñ†ÐµÐ»ÑŒ',0),(173482,4819,'es','Parte de PropÃ³sito de Stock',0),(173483,4819,'de','Hat Zweck Teil',0),(173484,4819,'en','Stock Purpose Part',0),(173485,4820,'is','',0),(173486,4820,'dr','(Ø·Ù„Ø¨',0),(173487,4820,'pr','Ø²Ù…Ø§Ù† Ø³Ø±Ø±Ø³ÙŠØ¯ (Ø·Ù„Ø¨',0),(173488,4820,'tr','Zaman nedeniyle',0),(173489,4820,'pl','Czasu z powodu',0),(173490,4820,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð¿Ð¾Ñ€Ð°Ð´Ð¸',0),(173491,4820,'ur','ÙˆÙ‚Øª Ú©ÛŒ ÙˆØ¬Û Ø³Û’',0),(173492,4820,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð´Ð¾ÑÐ¿ÐµÑ›Ð°',0),(173493,4820,'vi','Thá»i gian Ä‘áº¿n háº¡n',0),(173494,4820,'af','Tyd Verskuldig',0),(173495,4820,'ro','Timp datorate',0),(173496,4820,'et','Kellaaeg tasumisele',0),(173497,4820,'si','ÄŒas zaradi',0),(173498,4820,'ba','Waktu jatuh tempo',0),(173499,4820,'nl','Tijd verschuldigde',0),(173500,4820,'fi','Kertaa',0),(173501,4820,'no','Tid grunn',0),(173502,4820,'da','Tid grund',0),(173503,4820,'ko','ì¸í•´ ì‹œê°„',0),(173504,4820,'he','×–×ž×Ÿ ×‘×©×œ',0),(173505,4820,'el','Î¤Î· Ï†Î¿ÏÎ¬',0),(173506,4820,'zh','æ—¶é—´åˆ°',0),(173507,4820,'sv','Tid pÃ¥ grund',0),(173508,4820,'it','Tempo dovuto',0),(173509,4820,'tl','',0),(173510,4820,'th','&#3648;&#3623;&#3621;&#3634;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(173511,4820,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¸à¤®à¤¯',0),(173512,4820,'ms','Masa kerana',0),(173513,4820,'ar','Ø§Ù„ÙˆÙ‚Øª Ø§Ù„ÙˆØ§Ø¬Ø¨',0),(173514,4820,'fr','Temps Due',0),(173515,4820,'jp','æœŸé™?æ™‚é–“',0),(173516,4820,'pt','Tempo devido',0),(173517,4820,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð¸Ð·-Ð·Ð°',0),(173518,4820,'es','Tiempo Debido',0),(173519,4820,'de','Aufgrund',0),(173520,4820,'en','Time Due',0),(173521,4821,'is','',0),(173522,4821,'dr','Ù†ÙˆØ¹ Ø³ÙØ§Ø±Ø´',0),(173523,4821,'pr','Ù†ÙˆØ¹ Ø³ÙØ§Ø±Ø´',0),(173524,4821,'tr','SipariÅŸin tÃ¼rÃ¼',0),(173525,4821,'pl','Typ zlecenia',0),(173526,4821,'bg','Ð’Ð¸Ð´ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(173527,4821,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ù‚Ø³Ù…',0),(173528,4821,'sr','Ð’Ñ€ÑÑ‚Ñƒ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(173529,4821,'vi','Loáº¡i Ä‘Æ¡n hÃ ng',0),(173530,4821,'af','Tipe Bestelling',0),(173531,4821,'ro','Ordinul',0),(173532,4821,'et','Tellimuse tÃ¼Ã¼p',0),(173533,4821,'si','Vrsto naloga',0),(173534,4821,'ba','Jenis Order',0),(173535,4821,'nl','Soort Order',0),(173536,4821,'fi','Tilauksen tyyppi',0),(173537,4821,'no','Ordretype',0),(173538,4821,'da','Ordretype',0),(173539,4821,'ko','ìˆœì„œì˜ ìœ í˜•',0),(173540,4821,'he','×¡×•×’ ×”×”×–×ž× ×”',0),(173541,4821,'el','Î¤ÏÏ€Î¿Ï… ÎµÎ½Ï„Î¿Î»Î®Ï‚',0),(173542,4821,'zh','è®¢å•ç±»åž‹\r\n',0),(173543,4821,'sv','Typ av Order',0),(173544,4821,'it','Tipo di ordine',0),(173545,4821,'tl','',0),(173546,4821,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(173547,4821,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(173548,4821,'ms','Jenis perintah',0),(173549,4821,'ar','Ù†ÙˆØ¹ Ù…Ù† Ø§Ù„ØªØ±ØªÙŠØ¨',0),(173550,4821,'fr','Type de commande',0),(173551,4821,'jp','æ³¨æ–‡ã‚¿ã‚¤ãƒ—',0),(173552,4821,'pt','Tipo de ordem',0),(173553,4821,'ru','Ð¢Ð¸Ð¿ Ð—Ð°ÐºÐ°Ð·Ð°',0),(173554,4821,'es','Tipo del Orden',0),(173555,4821,'de','Art des Auftrages',0),(173556,4821,'en','Type of Order',0),(173557,4822,'is','',0),(173558,4822,'dr','(Ù†Ù…ÙˆÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±) Ù†ÙŠØ³Øª ',0),(173559,4822,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø´Ù…Ø§Ø±Ø´ Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø±(Ù†Ù…ÙˆÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±) Ù†ÙŠØ³Øª ',0),(173560,4822,'tr','Worktypes efendisi alÄ±namÄ±yor',0),(173561,4822,'pl','Nie liczy siÄ™ z worktypes',0),(173562,4822,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸ Ð±Ñ€Ð¾Ñ Ð½Ð° worktypes',0),(173563,4822,'ur','ÙˆÙˆØ±Ú©ØªÛŒÙ¾Ø§Ø³ Ú©Ø§ Ø´Ù…Ø§Ø± Ø­Ø§ØµÙ„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(173564,4822,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¸Ð±Ð°Ð²Ð¸Ñ‚Ð¸ Ñ‚Ð°Ñ‡Ð°ÐºÐ° Ð·Ð° wÐ¾Ñ€ÐºÑ‚yÐ¿ÐµÑ',0),(173565,4822,'vi','KhÃ´ng tháº¥y bá»™ Ä‘áº¿m cá»§a loáº¡i cÃ´ng viá»‡c',0),(173566,4822,'af','Kan nie kry tel van worktypes',0),(173567,4822,'ro','Imposibilitatea de a obÅ£ine numÄƒrul de worktypes',0),(173568,4822,'et','Ei saa tuua loeb worktypes',0),(173569,4822,'si','Ni mogoÄe dobiti grofje worktypes',0),(173570,4822,'ba','Mampu mendapatkan hitungan worktypes',0),(173571,4822,'nl','Niet in staat om graven van worktypes',0),(173572,4822,'fi','Ei saada laskee worktypes',0),(173573,4822,'no','Kan ikke hente antall worktypes',0),(173574,4822,'da','Der kan ikke hentes tÃ¦llinger af worktypes',0),(173575,4822,'ko','Worktypesì˜ ì¡°ì‚¬ë¥¼ ë°›ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(173576,4822,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×§×‘×œ ××ª ×¡×¢×™×¤×™ worktypes',0),(173577,4822,'el','Î£Îµ Î¸Î­ÏƒÎ· Î½Î± Ï€Î¬ÏÎµÎ¹ Î±ÏÎ¹Î¸Î¼Î®ÏƒÎµÎ¹Ï‚ Ï„Î·Ï‚ worktypes',0),(173578,4822,'zh','æ— æ³•å–å¾—å·¥ç§è®¡æ•°\r\n',0),(173579,4822,'sv','Det gÃ¥r inte att fÃ¥ rÃ¤knas i worktypes',0),(173580,4822,'it','Impossibile ottenere i conti di worktypes',0),(173581,4822,'tl','',0),(173582,4822,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3609;&#3633;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;',0),(173583,4822,'hi','Worktypes à¤•à¥€ à¤—à¤¿à¤¨à¤¤à¥€ à¤®à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(173584,4822,'ms','Tidak boleh mendapatkan kiraan worktypes',0),(173585,4822,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„ØªÙ‡Ù… Ø§Ù„Ù…ÙˆØ¬Ù‡Ø© Ø¥Ù„ÙŠÙ‡ ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠØ³',0),(173586,4822,'fr','Impossible d\'obtenir des comtes de worktypes',0),(173587,4822,'jp','ä½œæ¥­å†…å®¹ã‚’æ•°ã?ˆã‚‰ã‚Œã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(173588,4822,'pt','NÃ£o Ã© possÃ­vel obter a contagem de worktypes',0),(173589,4822,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ worktypes',0),(173590,4822,'es','No se Puede conseguir conteos de tipos de trabajo',0),(173591,4822,'de','Nicht in der Lage, Grafen von Worktypes erhalten',0),(173592,4822,'en','Unable to get counts of worktypes',0),(173593,4823,'is','',0),(173594,4823,'dr','Ø¯Ø± Ø®Ø§Ø±Ø¬ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(173595,4823,'pr','Ø¯Ø± Ø®Ø§Ø±Ø¬ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ ',0),(173596,4823,'tr','DÄ±ÅŸarÄ±da vended',0),(173597,4823,'pl','Nabyci przez opiekuna nr poza',0),(173598,4823,'bg','Vended Ð¸Ð·Ð²ÑŠÐ½',0),(173599,4823,'ur','Ø¨Ø§ÛØ± ÙˆØ§Ù†ÚˆÛŒØ¯',0),(173600,4823,'sr','ÐÐ°Ñ†Ñ€Ñ‚Ð°Ð½Ð¾ Ð½Ð°Ð¿Ð¾Ñ™Ñƒ',0),(173601,4823,'vi','BÃ¡n ngoÃ i',0),(173602,4823,'af','Vended buite',0),(173603,4823,'ro','Vended Ã®n afara',0),(173604,4823,'et','VÃ¤ljaspool vended',0),(173605,4823,'si','Vended zunaj',0),(173606,4823,'ba','Vended luar',0),(173607,4823,'nl','Vended buiten',0),(173608,4823,'fi','Vended ulkopuolella',0),(173609,4823,'no','Vended utenfor',0),(173610,4823,'da','Vended uden for',0),(173611,4823,'ko','ë°–ì— ì„œ vended',0),(173612,4823,'he','Vended ×‘×—×•×¥',0),(173613,4823,'el','Vended, ÎµÎºÏ„ÏŒÏ‚',0),(173614,4823,'zh','å¤–å‡ºå”®\r\n',0),(173615,4823,'sv','Vended utanfÃ¶r',0),(173616,4823,'it','Vended fuori',0),(173617,4823,'tl','',0),(173618,4823,'th','&#3606;&#3641;&#3585;&#3586;&#3634;&#3618;&#3604;&#3657;&#3634;&#3609;&#3609;&#3629;&#3585;',0),(173619,4823,'hi','à¤¬à¤¾à¤¹à¤° vended',0),(173620,4823,'ms','Vended di luar',0),(173621,4823,'ar','ÙÙŠÙ†Ø¯ÙŠØ¯ Ø®Ø§Ø±Ø¬',0),(173622,4823,'fr','Vendue Ã  l\'extÃ©rieur',0),(173623,4823,'jp','å¤–éƒ¨ã?§å£²ã‚Œã?Ÿ',0),(173624,4823,'pt','Vended fora',0),(173625,4823,'ru','Vended Ð²Ð½Ðµ',0),(173626,4823,'es','Vendido Afuera',0),(173627,4823,'de','Vended auÃŸerhalb',0),(173628,4823,'en','Vended Outside',0),(173629,4824,'is','',0),(173630,4824,'dr','Ø´Ø±Ø­ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(173631,4824,'pr','Ø´Ø±Ø­ Ù†ÙˆØ¹ ÙƒØ§Ø± ',0),(173632,4824,'tr','Ä°ÅŸ tÃ¼rÃ¼ aÃ§Ä±klamasÄ±',0),(173633,4824,'pl','Opis typu pracy',0),(173634,4824,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð²Ð¸Ð´Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(173635,4824,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(173636,4824,'sr','ÐžÐ¿Ð¸Ñ Ð²Ñ€ÑÑ‚Ðµ Ñ€Ð°Ð´Ð°',0),(173637,4824,'vi','Diá»…n giáº£i loáº¡i cÃ´ng viá»‡c',0),(173638,4824,'af','Werktipe Beskrywing',0),(173639,4824,'ro','Descriere tip de munca',0),(173640,4824,'et','TÃ¶Ã¶ liigi kirjeldus',0),(173641,4824,'si','Opis vrste dela',0),(173642,4824,'ba','Deskripsi tipe pekerjaan',0),(173643,4824,'nl','Werk Type Beschrijving',0),(173644,4824,'fi','TyÃ¶tyypin kuvaus',0),(173645,4824,'no','Arbeid Type beskrivelse',0),(173646,4824,'da','Arbejdet Type beskrivelse',0),(173647,4824,'ko','ìž‘ì—… ìœ í˜• ì„¤ëª…',0),(173648,4824,'he','×ª×™××•×¨ ×©×œ ×¡×•×’ ×¢×‘×•×“×”',0),(173649,4824,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„ÏÏ€Î¿Ï…',0),(173650,4824,'zh','å·¥ä½œç±»åž‹è¯´æ˜Ž\r\n',0),(173651,4824,'sv','Arbete typ Beskrivning',0),(173652,4824,'it','Descrizione del tipo di lavoro',0),(173653,4824,'tl','',0),(173654,4824,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(173655,4824,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤µà¤¿à¤µà¤°à¤£',0),(173656,4824,'ms','Huraian jenis kerja',0),(173657,4824,'ar','ÙˆØµÙ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(173658,4824,'fr','Description de Type de travail',0),(173659,4824,'jp','ä»•äº‹å†…å®¹è§£èª¬',0),(173660,4824,'pt','DescriÃ§Ã£o do tipo de trabalho',0),(173661,4824,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¢Ð¸Ð¿Ð° Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(173662,4824,'es','DescripciÃ³n de Tipo de Trabajo',0),(173663,4824,'de','Typ Arbeitsbeschreibung',0),(173664,4824,'en','Work Type Description',0),(173665,4825,'is','',0),(173666,4825,'dr','Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø¯Ø± Ø­Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø§Ø³Øª ',0),(173667,4825,'pr','Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø¯Ø± Ø­Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø§Ø³Øª ',0),(173668,4825,'tr','SipariÅŸ olarak iÅŸlenmiÅŸ olduÄŸunu',0),(173669,4825,'pl','Twoje zamÃ³wienie jest przetwarzane',0),(173670,4825,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ðµ ÑÐµ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð²Ð°Ñ‚',0),(173671,4825,'ur','Ø¢Ù¾ Ú©Û’ Ø­Ú©Ù… Ù¾Ø± Ø¹Ù…Ù„Ø¯Ø±Ø¢Ù…Ø¯ Ú©ÛŒØ§ Ø¬Ø§ Ø±ÛØ§ ÛÛ’',0),(173672,4825,'sr','Ð¢Ð²Ð¾Ñ˜ Ñ€ÐµÐ´ Ñ˜Ðµ Ð´Ð° ÑÐµ Ð¾Ð±Ñ€Ð°Ñ’ÑƒÑ˜Ðµ',0),(173673,4825,'vi','ÄÆ¡n hÃ ng cá»§a báº¡n Ä‘Ã£ xá»­ lÃ½',0),(173674,4825,'af','U BESTELLING word verwerk.',0),(173675,4825,'ro','Comanda dumneavoastra este in curs de procesare',0),(173676,4825,'et','Teie tellimust kÃ¤sitletakse',0),(173677,4825,'si','VaÅ¡e naroÄilo je v obdelavi',0),(173678,4825,'ba','Pesanan Anda adalah sedang diproses',0),(173679,4825,'nl','Uw bestelling wordt verwerkt',0),(173680,4825,'fi','Tilauksesi on kÃ¤sitelty',0),(173681,4825,'no','Bestillingen er behandlet',0),(173682,4825,'da','Din ordre er behandlet',0),(173683,4825,'ko','ì£¼ë¬¸ì´ ì²˜ë¦¬ ë˜ëŠ”',0),(173684,4825,'he','×”×”×–×ž× ×” ×©×œ×š ×”×•× ×¢×™×‘×•×“',0),(173685,4825,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÎ±Ï‚ ÎµÎ¯Î½Î±Î¹ Ï…Ï€ÏŒ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(173686,4825,'zh','æ‚¨çš„è®¢å•æ­£åœ¨å¤„ç†ä¸­\r\n',0),(173687,4825,'sv','Din bestÃ¤llning Ã¤r bearbetas',0),(173688,4825,'it','Il vostro ordine Ã¨ in fase di elaborazione',0),(173689,4825,'tl','',0),(173690,4825,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3585;&#3635;&#3621;&#3633;&#3591;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3629;&#3618;&#3641;&#3656;',0),(173691,4825,'hi','à¤…à¤ªà¤¨à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(173692,4825,'ms','Pesanan anda adalah sedang diproses',0),(173693,4825,'ar','Ø·Ù„Ø¨Ùƒ Ù‡Ùˆ \"Ù‚ÙŠØ¯ Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬Ø©\"',0),(173694,4825,'fr','Votre commande est en cours de traitement',0),(173695,4825,'jp','æ³¨æ–‡ã?Œå‡¦ç?†ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(173696,4825,'pt','Seu pedido estÃ¡ sendo processado',0),(173697,4825,'ru','Ð’Ð°Ñˆ Ð·Ð°ÐºÐ°Ð· Ð¾Ð±Ñ€Ð°Ð±Ð°Ñ‚Ñ‹Ð²Ð°ÐµÑ‚ÑÑ',0),(173698,4825,'es','Su pedido estÃ¡ siendo procesada',0),(173699,4825,'de','Ihre Bestellung wird verarbeitet',0),(173700,4825,'en','Your Order is Being Processed',0),(173701,4826,'is','',0),(173702,4826,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(173703,4826,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(173704,4826,'tr','Bir worktype seÃ§meniz gerekir',0),(173705,4826,'pl','NaleÅ¼y wybraÄ‡ worktype',0),(173706,4826,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ worktype',0),(173707,4826,'ur','Ø¢Ù¾ Ø§ÛŒÚ© ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(173708,4826,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ñ˜Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½ÐµÐºÐ¸ wÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ',0),(173709,4826,'vi','Báº¡n pháº£i chá»n 1 loáº¡i cÃ´ng viá»‡c',0),(173710,4826,'af','U moet \'n WERKTIPE kies.',0),(173711,4826,'ro','Trebuie sÄƒ selectaÅ£i o worktype',0),(173712,4826,'et','Te peate valima tÃ¶Ã¶tÃ¼Ã¼bi',0),(173713,4826,'si','Morate izbrati a worktype',0),(173714,4826,'ba','Anda harus memilih worktype',0),(173715,4826,'nl','U moet een worktype selecteren',0),(173716,4826,'fi','Sinun on valittava worktype',0),(173717,4826,'no','Du mÃ¥ velge en worktype',0),(173718,4826,'da','Du skal vÃ¦lge en worktype',0),(173719,4826,'ko','worktypeì„ ì„ íƒ í•´ì•¼',0),(173720,4826,'he','×¢×œ×™×š ×œ×‘×—×•×¨ worktype',0),(173721,4826,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± worktype',0),(173722,4826,'zh','æ‚¨éœ€è¦é€‰æ‹©ä¸€ä¸ªå·¥ä½œç§ç±»\r\n',0),(173723,4826,'sv','Du mÃ¥ste vÃ¤lja en worktype',0),(173724,4826,'it','E\' necessario selezionare un tipo di lavoro',0),(173725,4826,'tl','',0),(173726,4826,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;',0),(173727,4826,'hi','à¤†à¤ª à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥ˆ à¤à¤• worktype à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(173728,4826,'ms','Anda perlu memilih worktype yang',0),(173729,4826,'ar','ÙƒÙ†Øª Ø¨Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰ ØªØ­Ø¯ÙŠØ¯ ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ',0),(173730,4826,'fr','Vous devez sÃ©lectionner un modÃ¨le',0),(173731,4826,'jp','ä»•äº‹å†…å®¹ã‚’é?¸æŠžã?—ã?¦ã??ã? ã?•ã?„',0),(173732,4826,'pt','VocÃª precisa selecionar um worktype',0),(173733,4826,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(173734,4826,'es','Necesita seleccionar un tipo de trabajo',0),(173735,4826,'de','Sie mÃ¼ssen eine Worktype auswÃ¤hlen',0),(173736,4826,'en','You need to select a worktype',0),(173737,4827,'is','',0),(173738,4827,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(173739,4827,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(173740,4827,'tr','Bir worktype seÃ§meniz gerekir',0),(173741,4827,'pl','NaleÅ¼y wybraÄ‡ worktype',0),(173742,4827,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ worktype',0),(173743,4827,'ur','Ø¢Ù¾ Ø§ÛŒÚ© ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(173744,4827,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ñ˜Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½ÐµÐºÐ¸ wÐ¾Ñ€ÐºÑ‚yÐ¿Ðµ',0),(173745,4827,'vi','Báº¡n pháº£i chá»n 1 loáº¡i cÃ´ng viá»‡c',0),(173746,4827,'af','U nodig om \'n werkstipe te kies.',0),(173747,4827,'ro','Trebuie sÄƒ selectaÅ£i o worktype',0),(173748,4827,'et','Te peate valima tÃ¶Ã¶ tÃ¼Ã¼bi',0),(173749,4827,'si','Morate izbrati a worktype',0),(173750,4827,'ba','Anda harus memilih worktype',0),(173751,4827,'nl','U moet een worktype selecteren',0),(173752,4827,'fi','Sinun on valittava worktype',0),(173753,4827,'no','Du mÃ¥ velge en worktype',0),(173754,4827,'da','Du skal vÃ¦lge en worktype',0),(173755,4827,'ko','worktypeì„ ì„ íƒ í•´ì•¼',0),(173756,4827,'he','×¢×œ×™×š ×œ×‘×—×•×¨ worktype',0),(173757,4827,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± worktype',0),(173758,4827,'zh','æ‚¨éœ€è¦é€‰æ‹©ä¸€ä¸ªå·¥ä½œç§ç±»\r\n',0),(173759,4827,'sv','Du mÃ¥ste vÃ¤lja en worktype',0),(173760,4827,'it','E\' necessario selezionare un tipo di lavoro',0),(173761,4827,'tl','',0),(173762,4827,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;',0),(173763,4827,'hi','à¤†à¤ª à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥ˆ à¤à¤• worktype à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(173764,4827,'ms','Anda perlu memilih worktype yang',0),(173765,4827,'ar','ÙƒÙ†Øª Ø¨Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰ ØªØ­Ø¯ÙŠØ¯ ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ',0),(173766,4827,'fr','Vous devez sÃ©lectionner un type de travail',0),(173767,4827,'jp','ä»•äº‹å†…å®¹ã‚’é?¸æŠžã?—ã?¦ã??ã? ã?•ã?„',0),(173768,4827,'pt','VocÃª precisa selecionar um worktype',0),(173769,4827,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(173770,4827,'es','Necesita seleccionar un tipo de trabajo',0),(173771,4827,'de','Sie mÃ¼ssen eine Worktype auswÃ¤hlen',0),(173772,4827,'en','You need to select a worktype',0),(173773,4828,'is','',0),(173774,4828,'dr','Ù…Ù‚Ø§Ø¯ÙŠØ± Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(173775,4828,'pr','Ù…Ù‚Ø§Ø¯ÙŠØ± Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(173776,4828,'tr','Ek teklif miktarlarÄ±nÄ±',0),(173777,4828,'pl','Dodatkowe iloÅ›ci dla oferty',0),(173778,4828,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð·Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(173779,4828,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Û’ Ù„Ø¦Û’ Ø§Ø¶Ø§ÙÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(173780,4828,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ Ð·Ð° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(173781,4828,'vi','Sá»‘ LÆ°á»£ng ThÃªm Cho BÃ¡o GiÃ¡ ',0),(173782,4828,'af','Adisionele Hoeveelhede vir Kwotasie',0),(173783,4828,'ro','Cantitati suplimentare pentru cotatie',0),(173784,4828,'et','Hinnapakkumise lisakoguseid',0),(173785,4828,'si','Dodatne koliÄine za ponudbo',0),(173786,4828,'ba','Penambahan Jumlah Penawaran',0),(173787,4828,'nl','Bijkomende hoeveelheden voor offerte',0),(173788,4828,'fi','LisÃ¤mÃ¤Ã¤rien lainaus',0),(173789,4828,'no','Tilleggsantall for tilbud',0),(173790,4828,'da','Yderligere mÃ¦ngder for tilbud',0),(173791,4828,'ko','ê²¬ì ì— ëŒ€ í•œ ì¶”ê°€ ìˆ˜ëŸ‰',0),(173792,4828,'he','×›×ž×•×™×•×ª × ×•×¡×¤×•×ª ×œ×§×‘×œ×ª ×”×¦×¢×ª ×ž×—×™×¨',0),(173793,4828,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚ Î³Î¹Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(173794,4828,'zh','å¢žåŠ æ•°é‡çš„å ±åƒ¹\r\n',0),(173795,4828,'sv','Ytterligare mÃ¤ngder fÃ¶r offert',0),(173796,4828,'it','Ulteriori quantitativi di preventivo',0),(173797,4828,'tl','',0),(173798,4828,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(173799,4828,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(173800,4828,'ms','Tambahan kuantiti tarif',0),(173801,4828,'ar','ÙƒÙ…Ù‘ÙŠØ§Øª Ø¥Ø¶Ø§ÙÙŠØ© Ù„Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(173802,4828,'fr','QuantitÃ© Additionelle pour Soumission',0),(173803,4828,'jp','è¦‹ç©?ã‚Šç”¨è¿½åŠ æ•°é‡?',0),(173804,4828,'pt','Quantidades adicionais para citaÃ§Ã£o',0),(173805,4828,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¾Ð±ÑŠÐµÐ¼Ñ‹ Ð´Ð»Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(173806,4828,'es','Cantidades Adicionales para CotizaciÃ³n',0),(173807,4828,'de','ZusÃ¤tzliche Mengen fÃ¼r Angebot',0),(173808,4828,'en','Additional Quantities for Quote',0),(173809,4829,'is','',0),(173810,4829,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø±Ù†Ú¯ ',0),(173811,4829,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø±Ù†Ú¯ ',0),(173812,4829,'tr','Renk ekleme',0),(173813,4829,'pl','Dodaj kolor',0),(173814,4829,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ†Ð²ÑÑ‚',0),(173815,4829,'ur','Ø±Ù†Ú¯ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(173816,4829,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð±Ð¾Ñ˜Ðµ',0),(173817,4829,'vi','ThÃªm Máº§u',0),(173818,4829,'af','Voeg \'n Kleur by',0),(173819,4829,'ro','Adauga Culoare',0),(173820,4829,'et','Lisamine vÃ¤rvi',0),(173821,4829,'si','Dodajte barvo',0),(173822,4829,'ba','Menambahkan warna',0),(173823,4829,'nl','Kleur toevoegen',0),(173824,4829,'fi','LisÃ¤Ã¤ vÃ¤ri',0),(173825,4829,'no','Legge til farge',0),(173826,4829,'da','TilfÃ¸je farve',0),(173827,4829,'ko','ìƒ‰ìƒ ì¶”ê°€',0),(173828,4829,'he','×”×•×¡×£ ×¦×‘×¢',0),(173829,4829,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï‡ÏÏŽÎ¼Î±',0),(173830,4829,'zh','å¢žåŠ é¢œè‰²\r\n',0),(173831,4829,'sv','LÃ¤gga till fÃ¤rg',0),(173832,4829,'it','Aggiungi colore',0),(173833,4829,'tl','',0),(173834,4829,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3637;',0),(173835,4829,'hi','à¤°à¤‚à¤— à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(173836,4829,'ms','Tambah warna',0),(173837,4829,'ar','Ø£Ø¶Ù Ù„ÙˆÙ†',0),(173838,4829,'fr','Ajouter Couleur',0),(173839,4829,'jp','è‰²ã‚’è¿½åŠ ã?™ã‚‹',0),(173840,4829,'pt','Adicionar a cor',0),(173841,4829,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¦Ð²ÐµÑ‚',0),(173842,4829,'es','Agregar Color',0),(173843,4829,'de','HinzufÃ¼gen von Farbe',0),(173844,4829,'en','Add Color',0),(173845,4830,'is','',0),(173846,4830,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚Ø³Ù…Øª Ø¬Ø¯ÙŠØ¯  ',0),(173847,4830,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚Ø³Ù…Øª Ø¬Ø¯ÙŠØ¯  ',0),(173848,4830,'tr','Yeni bÃ¶lÃ¼m ekle',0),(173849,4830,'pl','Dodaj nowÄ… czÄ™Å›Ä‡',0),(173850,4830,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ‡Ð°ÑÑ‚',0),(173851,4830,'ur','Ù†Ø¦Û’ Ø­ØµÛ’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(173852,4830,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ ÑÐµÐ³Ð¼ÐµÐ½Ñ‚Ð°',0),(173853,4830,'vi','ThÃªm Pháº§n Má»›i',0),(173854,4830,'af','Nuwe Onderdeel Byvoeg',0),(173855,4830,'ro','Adauga parte noua',0),(173856,4830,'et','Lisa uus osa',0),(173857,4830,'si','Dodajanje novih del',0),(173858,4830,'ba','Menambahkan bagian baru',0),(173859,4830,'nl','Voeg nieuwe deel',0),(173860,4830,'fi','LisÃ¤Ã¤ uusi osa',0),(173861,4830,'no','Legg til ny del',0),(173862,4830,'da','TilfÃ¸je nye del',0),(173863,4830,'ko','ìƒˆë¡œìš´ ë¶€í’ˆ ì¶”ê°€',0),(173864,4830,'he','×”×•×¡×£ ×—×œ×§ ×—×“×©',0),(173865,4830,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Ï„Î¼Î®Î¼Î±Ï„Î¿Ï‚',0),(173866,4830,'zh','å¢žåŠ æ–°éƒ¨ä»¶\r\n',0),(173867,4830,'sv','LÃ¤gg till nya delen',0),(173868,4830,'it','Aggiungi nuova parte',0),(173869,4830,'tl','',0),(173870,4830,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3656;&#3623;&#3609;&#3591;&#3634;&#3609;',0),(173871,4830,'hi','à¤¨à¤ à¤­à¤¾à¤— à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(173872,4830,'ms','Menambah bahagian baru',0),(173873,4830,'ar','Ø¥Ø¶Ø§ÙØ© Ø¬Ø²Ø¡ Ø¬Ø¯ÙŠØ¯',0),(173874,4830,'fr','Ajouter nouvelle partie',0),(173875,4830,'jp','æ–°è¦?éƒ¨åˆ†ã‚’è¿½åŠ ã?™ã‚‹',0),(173876,4830,'pt','Adicionar nova parte',0),(173877,4830,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ñ‡Ð°ÑÑ‚ÑŒ',0),(173878,4830,'es','Agregar Nueva Parte',0),(173879,4830,'de','FÃ¼gen Sie neues Teil',0),(173880,4830,'en','Add New Part',0),(173881,4831,'is','',0),(173882,4831,'dr','ØªØºÙŠÙŠØ± Ø¨Ø±Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ÙƒØ±Ø¯Ù† ÙˆÙ‚ØªÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§ ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(173883,4831,'pr','ØªØºÙŠÙŠØ± Ø¨Ø±Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ÙƒØ±Ø¯Ù† ÙˆÙ‚ØªÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§ ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(173884,4831,'tr','Yeni Ã¶ÄŸe sipariÅŸ olarak deÄŸiÅŸen bulunamadÄ±',0),(173885,4831,'pl','Zmiana na nowy jako przedmiot zamÃ³wienia nie znaleziono',0),(173886,4831,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° ÐºÑŠÐ¼ Ð½Ð¾Ð² ÐºÐ°Ñ‚Ð¾ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ€ÐµÐ´ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(173887,4831,'ur','Ù†Ø¦ÛŒ Ø´Û’ Ú©Û’ Ø­Ú©Ù… Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø¯ÛŒÚ©Ú¾ Ú©Ø± Ø¨Ø¯Ù„ØªØ§ Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(173888,4831,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð½Ð° ÑšÑƒ ÐºÐ°Ð¾ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(173889,4831,'vi','Äá»•i sang nháº­p má»›i vÃ¬ khÃ´ng tÃ¬m tháº¥y danh má»¥c Ä‘áº·t hÃ ng',0),(173890,4831,'af','Verander na Nuwe aangesien Item Bestelling nie Gevind is nie',0),(173891,4831,'ro','Schimbarea la noua ca element de comandÄƒ nu a fost gÄƒsit',0),(173892,4831,'et','Uus on kauba tellimus muutuvas leitud',0),(173893,4831,'si','Spreminjanje na novo kot nalog artikla ni mogoÄe najti',0),(173894,4831,'ba','Mengubah baru sebagai Item pesanan tidak ditemukan',0),(173895,4831,'nl','Omzetten in New als artikelorder niet gevonden',0),(173896,4831,'fi','Uusi nimikkeen tilauksen muuttaminen ei lÃ¶ydy',0),(173897,4831,'no','Endre ny som ElementrekkefÃ¸lgen ikke funnet',0),(173898,4831,'da','Ã†ndre pÃ¥ ny som vareordre ikke fundet',0),(173899,4831,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” í•­ëª© ìˆœì„œì™€ ìƒˆë¡œ ë³€ê²½',0),(173900,4831,'he','×©×™× ×•×™ ×¢×œ ×—×“×© ×›×¡×“×¨ ×¤×¨×™×˜ ×œ× × ×ž×¦×',0),(173901,4831,'el','Î‘Î»Î»Î±Î³Î® ÏƒÎµ Î½Î­Î± Ï‰Ï‚ Ï… Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(173902,4831,'zh','æ‰¾ä¸åˆ°é¡¹ç›®é¡ºåºæ›´æ”¹ä¸ºæ–°å»º\r\n',0),(173903,4831,'sv','Byta till nya som fÃ¶r element hittades inte',0),(173904,4831,'it','Cambiando nuovo come elemento di ordine non trovato',0),(173905,4831,'tl','',0),(173906,4831,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3651;&#3627;&#3617;&#3656;&#3652;&#3611;&#3626;&#3641;&#3656;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3',0),(173907,4831,'hi','à¤¨à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤® à¤•à¥à¤°à¤® à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¦à¤² à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(173908,4831,'ms','Menukar ke baru dinamakan Item tidak dijumpai',0),(173909,4831,'ar','ØªØºÙŠÙŠØ± Ø¥Ù„Ù‰ Ø¬Ø¯ÙŠØ¯ \"ØªØ±ØªÙŠØ¨ Ø¹Ù†ØµØ±\" Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(173910,4831,'fr','Changeant Ã  nouveau comme l\'ordre des introuvable',0),(173911,4831,'jp','å“?ç›®æ³¨æ–‡ã?Œè¦‹ã?¤ã?‹ã‚‰ã?ªã?„ã?®ã?§æ–°è¦?ã?¸å¤‰æ›´ã?™ã‚‹',0),(173912,4831,'pt','Mudando para Nova como ordem de Item nÃ£o encontrado',0),(173913,4831,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ ÐºÐ°Ðº Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(173914,4831,'es','Cambiando a Nuevo dado que el Item Pedido no se Encuentra',0),(173915,4831,'de','Ã„ndern auf neu als Elementreihenfolge wurde nicht gefunden.',0),(173916,4831,'en','Changing to New as Item Order not Found',0),(173917,4832,'is','',0),(173918,4832,'dr','ØªØºÙŠÙŠØ± Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø¨Ø§ ØªØºÙŠÙŠØ±Ø§Øª ÙˆÙ‚ØªÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§ Ø¯Ø±Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(173919,4832,'pr','ØªØºÙŠÙŠØ± Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø¨Ø§ ØªØºÙŠÙŠØ±Ø§Øª ÙˆÙ‚ØªÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§ Ø¯Ø±Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(173920,4832,'tr','Zaten reprint iÃ§in deÄŸiÅŸiklikleri ile madde sipariÅŸi olarak deÄŸiÅŸtirme.',0),(173921,4832,'pl','Zmiana do przedruku zmiany jako element zamÃ³wienia juÅ¼ istnieje',0),(173922,4832,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° ÐºÑŠÐ¼ Ð¿Ñ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ Ñ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(173923,4832,'ur','Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ Ú©Û’ Ù„Ø¦Û’ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾ Ø´Û’ Ø¢Ø±ÚˆØ± Ú©Û’ Ø·ÙˆØ± Ù¾Ø± ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(173924,4832,'sr','ÐœÐµÑšÐ°Ð»Ð° , Ð´Ð° Ð¿Ð¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ ÑÐ° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°Ð¼Ð° Ð½Ð°Ð»Ð¾Ð³Ñƒ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(173925,4832,'vi','Äá»•i sang In láº¡i vá»›i thay Ä‘á»•i vÃ¬ Danh Má»¥c Äáº·t HÃ ng Ä‘Ã£ tá»“n táº¡i',0),(173926,4832,'af','Verander na Heruitdruk met Veranderinge aangesien Item Bestelling Alreeds Bestaan',0),(173927,4832,'ro','Schimbarea sÄƒ imprimaÅ£i din nou cu modificÄƒri ca element de comandÄƒ existÄƒ deja',0),(173928,4832,'et','Lendama kordustrÃ¼kk muutustega nagu kauba tellimus on juba olemas',0),(173929,4832,'si','Spreminjanje ponatis s spremembami kot nalog artikla Å¾e obstaja',0),(173930,4832,'ba','Mengubah Reprint dengan perubahan sebagai Item pesanan sudah ada',0),(173931,4832,'nl','Omzetten in herdruk met wijzigingen als artikelorder bestaat al',0),(173932,4832,'fi','Ailahteleminen jotta uusintapainos muutoksia kohteiden jÃ¤rjestystÃ¤ on jo olemassa',0),(173933,4832,'no','Endre til opptrykk med endringer som varen finnes allerede',0),(173934,4832,'da','Ã†ndre til genoptryk med Ã¦ndringer som vareordre findes allerede',0),(173935,4832,'ko','ì´ë¯¸ ìžˆëŠ” í•­ëª© ìˆœì„œ ë³€ê²½ ê¸°ìž…ì„ ë³€ê²½',0),(173936,4832,'he','×©×™× ×•×™ ×”×“×¤×¡×” ×ž×—×“×© ×¢× ×©×™× ×•×™×™× ×›×¡×“×¨ ×¤×¨×™×˜ ×§×™×™× ×›×‘×¨',0),(173937,4832,'el','Î‘Î»Î»Î±Î³Î® ÏƒÎµ Î±Î½Î±Ï„ÏÏ€Ï‰ÏƒÎ· Î¼Îµ Î±Î»Î»Î±Î³Î­Ï‚ Ï‰Ï‚ Ï… Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(173938,4832,'zh','é¡¹ç›®é¡ºåºå·²ç»å­˜åœ¨ï¼Œæ›´æ”¹åˆ°æ›´æ”¹é‡æ–°æ‰“å°',0),(173939,4832,'sv','Ã„ndra till nytryck med Ã¤ndringar som objektordningen finns redan',0),(173940,4832,'it','Cambia ristampa con modifiche come elemento ordine esiste giÃ ',0),(173941,4832,'tl','',0),(173942,4832,'th','Changing to Reprint with Changes as Item Order Exists Already',0),(173943,4832,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¤°à¤¨à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤†à¤‡à¤Ÿà¤® à¤•à¥à¤°à¤® à¤¬à¤¦à¤²à¤¨à¥‡ à¤•à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(173944,4832,'ms','Perubahan kepada pencetakan semula dengan perubahan sebagai perintah Item wujud sudah',0),(173945,4832,'ar','ØªØºÙŠÙŠØ± Ø¥Ù„Ù‰ Ø·Ø¨Ø¹ Ù…Ø¹ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª ÙƒØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù†ØµØ± Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„',0),(173946,4832,'fr','Changeant Ã  la rÃ©impression avec modifications comme l\'ordre des chiffres existe dÃ©jÃ ',0),(173947,4832,'jp','Changing to Reprint with Changes as Item Order Exists Already',0),(173948,4832,'pt','Mudando para reimpressÃ£o com alteraÃ§Ãµes como Item ordem jÃ¡ existente',0),(173949,4832,'ru','Ð—Ð°Ð¼ÐµÐ½Ð° Ð¿ÐµÑ€ÐµÐ¸Ð·Ð´Ð°Ð½Ð¸Ðµ Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸ÑÐ¼Ð¸ ÐºÐ°Ðº Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(173950,4832,'es','Cambiando a Reimprimir con Cambios porque Ya Exite el Item Pedido',0),(173951,4832,'de','Wechsel zu Reprint mit Ã„nderungen als Elementreihenfolge ist bereits vorhanden',0),(173952,4832,'en','Changing to Reprint with Changes as Item Order Exists Already',0),(173953,4833,'is','',0),(173954,4833,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ù…Ø·Ø§Ø¨Ù‚ Ø«Ø¨Øª â€“ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(173955,4833,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ù…Ø·Ø§Ø¨Ù‚ Ø«Ø¨Øª â€“ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(173956,4833,'tr','mÃ¼ÅŸteriler eÅŸleÅŸen giriÅŸ - tekrar deneyin',0),(173957,4833,'pl','Klienci dopasowane wpis - sprÃ³buj ponownie',0),(173958,4833,'bg','Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸ ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ Ð·Ð°Ð¿Ð¸Ñ - Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(173959,4833,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú¯Ø§ÛÚ©ÙˆÚº Ø³Û’ Ù…Ø´Ø§Ø¨Û - Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº',0),(173960,4833,'sr','ÐšÑƒÐ¿Ñ†Ð¸ Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð° ÑÑ‚Ð°Ð²Ñ†Ð¸ - ÐŸÑ€Ð¾Ð±Ð°Ñ˜ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(173961,4833,'vi','khÃ¡ch hÃ ng phÃ¹ há»£p vá»›i Entry - Thá»­ Láº¡i',0),(173962,4833,'af','Klante/KliÃ«nte harmonieer inskrywig  - Probeer weer',0),(173963,4833,'ro','ClienÅ£ii potrivire intrare - Ã®ncercaÅ£i din nou',0),(173964,4833,'et','Hotelli tasakaalustatud kanne - proovige uuesti',0),(173965,4833,'si','stranke ujema vstop - poskusite znova',0),(173966,4833,'ba','Pelanggan cocok entri - coba lagi',0),(173967,4833,'nl','klanten gematched post - probeer het opnieuw',0),(173968,4833,'fi','Asiakkaat hyvÃ¤ksytty merkintÃ¤ - yritÃ¤ uudelleen',0),(173969,4833,'no','kundene matchet oppfÃ¸ring - prÃ¸v igjen',0),(173970,4833,'da','kunder matchede post - prÃ¸v igen',0),(173971,4833,'ko','ê³ ê° ì¼ì¹˜ í•­ëª©-ë‹¤ì‹œ ì‹œë„',0),(173972,4833,'he','×œ×§×•×—×•×ª ×ž×ª××™×ž×™× ×”×¤×•×¡×˜ - × ×¡×” ×©×•×‘',0),(173973,4833,'el','Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÏƒÏ…Î¼Ï†Ï‰Î½Î·Î¼Î­Î½Î± ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… - Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(173974,4833,'zh','å®¢æˆ·åŒ¹é…æ¡ç›®-å†è¯•ä¸€æ¬¡\r\n',0),(173975,4833,'sv','Kunder matchade post - fÃ¶rsÃ¶k igen',0),(173976,4833,'it','clienti abbinato voce - riprovare',0),(173977,4833,'tl','',0),(173978,4833,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3609;&#3637;&#3657;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623; &#3621;&#3629;&#3591;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(173979,4833,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤®à¤¿à¤²à¤¾à¤¨ - à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚',0),(173980,4833,'ms','pelanggan dipadankan kemasukan - cuba lagi',0),(173981,4833,'ar','ÙŠÙ‚Ø§Ø¨Ù„ Ø§Ù„Ø²Ø¨Ø§Ø¦Ù† Ø¯Ø®ÙˆÙ„--Ø­Ø§ÙˆÙ„ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(173982,4833,'fr','clients mis en correspondance entrÃ©e - essayez Ã  nouveau',0),(173983,4833,'jp','é¡§å®¢ã?Œå…¥åŠ›ã?¨ä¸€è‡´ã?—ã?¾ã?—ã?Ÿãƒ¼ã‚‚ã?†ä¸€åº¦ãƒˆãƒ©ã‚¤ã?—ã?¦ä¸‹ã?•ã?„',0),(173984,4833,'pt','clientes correspondem entrada - tente outra vez',0),(173985,4833,'ru','ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð·Ð°Ð¿Ð¸ÑÑŒ - Ð¿Ð¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÐµÑ‰Ðµ Ñ€Ð°Ð·',0),(173986,4833,'es','Clientes parearse con entrada - Intenta otra vez',0),(173987,4833,'de','Kunden abgestimmt Eintrag - versuchen Sie es erneut',0),(173988,4833,'en','customers matched entry - Try again',0),(173989,4834,'is','',0),(173990,4834,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ ØªØ­ÙˆÙŠÙ„ ',0),(173991,4834,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ ØªØ­ÙˆÙŠÙ„ ',0),(173992,4834,'tr','Bu teslimat adresini Sil',0),(173993,4834,'pl','UsuÅ„ ten adres dostawy',0),(173994,4834,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð°Ð´Ñ€ÐµÑ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(173995,4834,'ur','Ø§Ø³ Ú©ÛŒ Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú©Ø§ Ù¾ØªÛ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(173996,4834,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð°Ð´Ñ€ÐµÑÑƒ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(173997,4834,'vi','XÃ³a Ä‘á»‹a chá»‰ giao hÃ ng nÃ y',0),(173998,4834,'af','Skrap hierdie Afleweringsadres',0),(173999,4834,'ro','ÅžtergeÅ£i aceastÄƒ adresÄƒ de livrare',0),(174000,4834,'et','Kustuta see tarneaadress',0),(174001,4834,'si','IzbriÅ¡ite ta naslov za dostavo',0),(174002,4834,'ba','Menghapus alamat pengiriman ini',0),(174003,4834,'nl','Dit afleveradres verwijderen',0),(174004,4834,'fi','Poista tÃ¤mÃ¤ osoite',0),(174005,4834,'no','Slette denne adressen',0),(174006,4834,'da','Slet denne leveringsadresse',0),(174007,4834,'ko','ì´ ë°°ë‹¬ ì£¼ì†Œ ì‚­ì œ',0),(174008,4834,'he','×œ×ž×—×•×§ ×›×ª×•×‘×ª ×”×ž×©×œ×•×— ×”×–×”',0),(174009,4834,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î® Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(174010,4834,'zh','åˆ é™¤æ­¤é€è´§åœ°å€\r\n',0),(174011,4834,'sv','Ta bort denna leveransadress',0),(174012,4834,'it','Eliminare l\'indirizzo di consegna',0),(174013,4834,'tl','',0),(174014,4834,'th','&#3621;&#3610;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3609;&#3637;&#3657;',0),(174015,4834,'hi','à¤‡à¤¸ à¤¡à¤¿à¤²à¥€à¤µà¤°à¥€ à¤ªà¤¤à¥‡ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(174016,4834,'ms','Menghapuskan ini alamat penghantaran',0),(174017,4834,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ \"Ø¹Ù†ÙˆØ§Ù† Ø§Ù„ØªØ³Ù„ÙŠÙ…\"',0),(174018,4834,'fr','Supprimer cette adresse de livraison',0),(174019,4834,'jp','ã?“ã?®é…?é€?å…ˆä½?æ‰€ã‚’æ¶ˆåŽ»ã?™ã‚‹',0),(174020,4834,'pt','Excluir este endereÃ§o de entrega',0),(174021,4834,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð°Ð´Ñ€ÐµÑ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(174022,4834,'es','Eliminar esta DirecciÃ³n de EnvÃ­o',0),(174023,4834,'de','LÃ¶schen Sie diese Lieferadresse',0),(174024,4834,'en','Delete this Delivery Address',0),(174025,4835,'is','',0),(174026,4835,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªÙˆØ³Ø·',0),(174027,4835,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªÙˆØ³Ø·',0),(174028,4835,'tr','TarafÄ±ndan dÃ¼zenlendi',0),(174029,4835,'pl','Edytowane przez',0),(174030,4835,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½ Ð¾Ñ‚',0),(174031,4835,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø³ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ†',0),(174032,4835,'sr','Ð£Ñ€ÐµÑ’ÑƒÑ˜Ðµ',0),(174033,4835,'vi','Chá»‰nh Sá»­a Do',0),(174034,4835,'af','Geredigeer Deur',0),(174035,4835,'ro','Editat de',0),(174036,4835,'et','Muudetud:',0),(174037,4835,'si','Urejal',0),(174038,4835,'ba','Diedit oleh',0),(174039,4835,'nl','Bewerkt door',0),(174040,4835,'fi','Muokannut',0),(174041,4835,'no','Endret av',0),(174042,4835,'da','Redigeret af',0),(174043,4835,'ko','ì— ì˜í•´ íŽ¸ì§‘',0),(174044,4835,'he','× ×¢×¨×š ×¢\"×™',0),(174045,4835,'el','Î•Ï€Î¹Î¼Î­Î»ÎµÎ¹Î±',0),(174046,4835,'zh','ç¼–è¾‘äºº\r\n',0),(174047,4835,'sv','Redigerad av',0),(174048,4835,'it','A cura di',0),(174049,4835,'tl','',0),(174050,4835,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3650;&#3604;&#3618;',0),(174051,4835,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤',0),(174052,4835,'ms','Disunting oleh',0),(174053,4835,'ar','Ø­Ø±Ø±Ù‡',0),(174054,4835,'fr','Sous la direction de',0),(174055,4835,'jp','ç·¨é›†è€…',0),(174056,4835,'pt','Editado por',0),(174057,4835,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¾',0),(174058,4835,'es','Editado Por',0),(174059,4835,'de','Herausgegeben von',0),(174060,4835,'en','Edited By',0),(174061,4836,'is','',0),(174062,4836,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¯Ø± Ù…Ø±Ø­Ù„Ù‡ ',0),(174063,4836,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¯Ø± Ù…Ø±Ø­Ù„Ù‡ ',0),(174064,4836,'tr','AdÄ±m gÃ¼ncelleÅŸtirme sÄ±rasÄ±nda hata oluÅŸtu',0),(174065,4836,'pl','BÅ‚Ä…d podczas aktualizacji w kroku',0),(174066,4836,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð² ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(174067,4836,'ur','Ù…Ø±Ø­Ù„Û Ù…ÛŒÚº ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ',0),(174068,4836,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñƒ ÐºÐ¾Ñ€Ð°ÐºÑƒ',0),(174069,4836,'vi','CÃ¡c bÆ°á»›c cáº­p nháº­t bá»‹ lá»—i',0),(174070,4836,'af','Fout het ingesluip gedurende Opdatering in die Stap.',0),(174071,4836,'ro','Eroare Ã®n timpul actualizÄƒrii Ã®n pas',0),(174072,4836,'et','TÃµrge vÃ¤rskendamisel samm',0),(174073,4836,'si','Napaka pri posodabljanju v korak',0),(174074,4836,'ba','Error selama update dalam langkah',0),(174075,4836,'nl','Fout tijdens bijwerken in stap',0),(174076,4836,'fi','Virhe pÃ¤ivityksen vaiheessa',0),(174077,4836,'no','Feil under oppdatering i trinn',0),(174078,4836,'da','Fejl under opdatering i trin',0),(174079,4836,'ko','ë‹¨ê³„ì—ì„œ ì—…ë°ì´íŠ¸ ì¤‘ ì˜¤ë¥˜ ë°œìƒ',0),(174080,4836,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×‘×©×œ×‘',0),(174081,4836,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÏ„Î¿ Î²Î®Î¼Î±',0),(174082,4836,'zh','åœ¨æ­¥éª¤æ›´æ–°è¿‡ç¨‹ä¸­å‡ºé”™',0),(174083,4836,'sv','Fel vid uppdatering i steg',0),(174084,4836,'it','Errore durante l\'aggiornamento nel passaggio',0),(174085,4836,'tl','',0),(174086,4836,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3609;&#3586;&#3633;&#3657;&#3609;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(174087,4836,'hi','à¤šà¤°à¤£ à¤®à¥‡à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(174088,4836,'ms','Ralat semasa dalam langkah',0),(174089,4836,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« ÙÙŠ Ø®Ø·ÙˆØ©',0),(174090,4836,'fr','Erreur lors de la mise Ã  jour Ã  l\'Ã©tape',0),(174091,4836,'jp','æ›´æ–°å‡¦ç?†ä¸­ã?®ã‚¨ãƒ©ãƒ¼',0),(174092,4836,'pt','Erro durante a atualizaÃ§Ã£o na etapa',0),(174093,4836,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð² Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¸',0),(174094,4836,'es','Error durante actualizar en escala',0),(174095,4836,'de','Fehler beim Update im Schritt',0),(174096,4836,'en','Error during update in step',0),(174097,4837,'is','',0),(174098,4837,'dr','Ø§ÙˆÙ„ ÙŠÙƒ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø±Ø§ Ø§Ø² Ù„ÙŠØ³Øª ÙƒØ´ÙˆÙŠÙŠ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(174099,4837,'pr','Ø§ÙˆÙ„ ÙŠÙƒ Ù†ÙˆØ¹ ÙƒØ§Ø± Ø±Ø§ Ø§Ø² Ù„ÙŠØ³Øª ÙƒØ´ÙˆÙŠÙŠ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(174100,4837,'tr','Ã–nce bir iÅŸ tÃ¼rÃ¼ aÃ§Ä±lan listeden seÃ§in.',0),(174101,4837,'pl','Najpierw wybierz typ pracy z spadaÃ¦-w dÃ³Â³',0),(174102,4837,'bg','ÐŸÑŠÑ€Ð²Ð¾ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð²Ð¸Ð´Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¾Ñ‚ Ð¿Ð°Ð´Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð¼ÐµÐ½ÑŽ',0),(174103,4837,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ ÚˆØ±Ø§Ù¾-ÚˆØ§Ø¤Ù† Ø³Û’ Ú©Ø§Ù… Ú©ÛŒ Ø§ÛŒÚ© Ù‚Ø³Ù… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(174104,4837,'sr','ÐŸÑ€Ð²Ð¾ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð²Ñ€ÑÑ‚Ñƒ Ñ€Ð°Ð´Ð° ÑÐ° Ð½Ð° Ð¿Ð°Ð´Ð°Ñ˜ÑƒÑ›Ð¸',0),(174105,4837,'vi','TrÆ°á»›c tiÃªn chá»n má»™t loáº¡i cÃ´ng viá»‡c tá»« há»™p bá» xuá»‘ng',0),(174106,4837,'af','Selekteer eers \'n werktipe vanuit die \"drop-down\"',0),(174107,4837,'ro','Mai Ã®ntÃ¢i selectaÅ£i un tip de munca la verticalÄƒ',0),(174108,4837,'et','Valige esmalt tÃ¶Ã¶ tÃ¼Ã¼p rippmenÃ¼Ã¼st',0),(174109,4837,'si','Najprej izberite vrsto dela iz spustnega',0),(174110,4837,'ba','Pertama Pilih jenis pekerjaan dari drop-down',0),(174111,4837,'nl','Selecteer eerst een werksoort uit het drop-down',0),(174112,4837,'fi','Valitse ensin avattavasta luettelosta tyÃ¶n tyyppi',0),(174113,4837,'no','Velg fÃ¸rst en arbeidstype fra rullegardinlisten',0),(174114,4837,'da','VÃ¦lg fÃ¸rst en arbejdstype fra drop-down',0),(174115,4837,'ko','ë¨¼ì € ìž‘ì—… í˜•ì‹ ë“œë¡­ ë‹¤ìš´ì—ì„œ ì„ íƒ',0),(174116,4837,'he','×ª×—×™×œ×” ×‘×—×¨ ×¡×•×’ ×¢×‘×•×“×” ×ž×Ÿ ×”× ×¤×ª×—×ª',0),(174117,4837,'el','Î ÏÏŽÏ„Î±, ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î±Î½ Ï„ÏÏ€Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î±Ï€ÏŒ Ï„Î¿ drop-down',0),(174118,4837,'zh','é¦–å…ˆä»Žä¸‹æ‹‰æ¡†ä¸­é€‰æ‹©ä¸€ä¸ªå·¥ä½œç±»åˆ«\r\n',0),(174119,4837,'sv','VÃ¤lj fÃ¶rst en arbetstyp frÃ¥n drop-down',0),(174120,4837,'it','Prima di selezionare un tipo di lavoro dal menu a discesa',0),(174121,4837,'tl','',0),(174122,4837,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;&#3649;&#3619;&#3585;&#3592;&#3634;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3610;&#3610;&#3648;&#3621;&#3',0),(174123,4837,'hi','à¤ªà¤¹à¤²à¥‡ à¤¡à¥à¤°à¥‰à¤ª-à¤¡à¤¾à¤‰à¤¨ à¤¸à¥‡ à¤à¤• à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(174124,4837,'ms','Mula-mula Pilih jenis kerja daripada drop-down',0),(174125,4837,'ar','Ø£ÙˆÙ„Ø§Ù‹ Ø­Ø¯Ø¯ Ù†ÙˆØ¹ Ø¹Ù…Ù„ Ù…Ù† Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ù†Ø³Ø¯Ù„Ø©',0),(174126,4837,'fr','Commencez par sÃ©lectionner un type de travail dans le menu dÃ©roulant',0),(174127,4837,'jp','ãƒ‰ãƒ­ãƒƒãƒ—ãƒ€ã‚¦ãƒ³ã?‹ã‚‰ä½œæ¥­ã‚¿ã‚¤ãƒ—ã‚’ã?¾ã?šé?¸æŠžã?—ã?¦ã??ã? ã?•ã?„',0),(174128,4837,'pt','Primeiro, selecione um tipo de trabalho no menu drop-down',0),(174129,4837,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¸Ð· Ñ€Ð°ÑÐºÑ€Ñ‹Ð²Ð°ÑŽÑ‰ÐµÐ³Ð¾ÑÑ ÑÐ¿Ð¸ÑÐºÐ° Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‡ÐµÐ³Ð¾',0),(174130,4837,'es','Primero Seleccionar un tipo de trabajo del menÃº drop-down',0),(174131,4837,'de','WÃ¤hlen Sie zunÃ¤chst ein Arbeitstyp aus der Dropdown-Liste',0),(174132,4837,'en','First select a work type from the drop-down',0),(174133,4838,'is','',0),(174134,4838,'dr','( Ù…Ø¬ÙˆØ²- Ø¢Ú¯Ù‡ÙŠ) ÙØ±Ù…Ø§ÛŒØ´ ',0),(174135,4838,'pr','Ø¨Ø±Ø§ÙŠ Ø¨Ù„ÙŠØ· ( Ù…Ø¬ÙˆØ²- Ø¢Ú¯Ù‡ÙŠ) Ø³ÙØ§Ø±Ø´ ',0),(174136,4838,'tr','SipariÅŸ bilet iÃ§in',0),(174137,4838,'pl','ZamÃ³wienia biletu',0),(174138,4838,'bg','Ð—Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð±Ð¸Ð»ÐµÑ‚',0),(174139,4838,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ù¹Ú©Ù¹ Ú©Û’ Ù„Ø¦Û’',0),(174140,4838,'sr','Ð—Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(174141,4838,'vi','Cho vÃ© Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(174142,4838,'af','Vir bestelling kaartjie',0),(174143,4838,'ro','Pentru un bilet de ordine',0),(174144,4838,'et','Korra pilet',0),(174145,4838,'si','Za naroÄilo vstopnic',0),(174146,4838,'ba','Untuk memesan tiket',0),(174147,4838,'nl','Voor volgorde Ticket',0),(174148,4838,'fi','Tilaa lippu',0),(174149,4838,'no','Bestill billett',0),(174150,4838,'da','Bestil billet',0),(174151,4838,'ko','ì£¼ë¬¸ í‹°ì¼“ì— ëŒ€ í•œ',0),(174152,4838,'he','×¢×‘×•×¨ ×”×–×ž× ×ª ×”×›×¨×˜×™×¡',0),(174153,4838,'el','Î“Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÎ¹ÏƒÎ¹Ï„Î·ÏÎ¯Ï‰Î½',0),(174154,4838,'zh','å¯¹äºŽè®¢è´­æœºç¥¨\r\n',0),(174155,4838,'sv','BestÃ¤lla biljett',0),(174156,4838,'it','Per biglietto di ordine',0),(174157,4838,'tl','',0),(174158,4838,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3633;&#3659;&#3623;',0),(174159,4838,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤Ÿà¤¿à¤•à¤Ÿ',0),(174160,4838,'ms','Untuk Tempahan Tiket.',0),(174161,4838,'ar','Ù„ØªØ±ØªÙŠØ¨ Ø­Ø¬Ø² Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(174162,4838,'fr','Pour le bon billet',0),(174163,4838,'jp','æ³¨æ–‡ãƒ?ã‚±ãƒƒãƒˆã?®',0),(174164,4838,'pt','Por ingresso de ordem',0),(174165,4838,'ru','Ð”Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ð±Ð¸Ð»ÐµÑ‚Ð¾Ð²',0),(174166,4838,'es','Para Boleto de Orden',0),(174167,4838,'de','FÃ¼r Bestellung',0),(174168,4838,'en','For Order Ticket',0),(174169,4839,'is','',0),(174170,4839,'dr','Ù‡ÙŠÚ† Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ÙŠ ',0),(174171,4839,'pr','Ù‡ÙŠÚ† Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ÙŠ ',0),(174172,4839,'tr','SipariÅŸ miktarÄ± yoktur',0),(174173,4839,'pl','Nie iloÅ›Ä‡ zamÃ³wienia',0),(174174,4839,'bg','ÐÐµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(174175,4839,'ur','Ú©ÙˆØ¦ÛŒ Ø¢Ø±ÚˆØ± Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(174176,4839,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(174177,4839,'vi','KhÃ´ng cÃ³ sá»‘ lÆ°á»£ng Ä‘áº·t hÃ ng',0),(174178,4839,'af','Geen Bestelling Hoeveelheid',0),(174179,4839,'ro','Nici o cantitate de comandÄƒ',0),(174180,4839,'et','Tellimuse kogus',0),(174181,4839,'si','Nobena koliÄina naloga',0),(174182,4839,'ba','Tidak ada jumlah pesanan',0),(174183,4839,'nl','Geen orderaantal',0),(174184,4839,'fi','Tilauksen mÃ¤Ã¤rÃ¤',0),(174185,4839,'no','Ingen bestillingsantall',0),(174186,4839,'da','Ingen ordrestÃ¸rrelse',0),(174187,4839,'ko','ì•„ë‹ˆ ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(174188,4839,'he','××™×Ÿ ×›×ž×•×ª ×”×”×–×ž× ×”',0),(174189,4839,'el','ÎšÎ±Î¼Î¯Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(174190,4839,'zh','æ²¡æœ‰è®¢å•æ•°é‡\r\n',0),(174191,4839,'sv','Ingen orderkvantiteten',0),(174192,4839,'it','Nessuna quantitÃ  di ordine',0),(174193,4839,'tl','',0),(174194,4839,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(174195,4839,'hi','à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(174196,4839,'ms','Tiada kuantiti pesanan',0),(174197,4839,'ar','Ù„Ø§ ÙƒÙ…ÙŠØ© Ø£Ù…Ø± Ø§Ù„ØªÙˆØ±ÙŠØ¯',0),(174198,4839,'fr','Aucune quantitÃ© d\'ordre',0),(174199,4839,'jp','æ³¨æ–‡æ•°é‡?ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(174200,4839,'pt','Nenhuma quantidade de ordem',0),(174201,4839,'ru','ÐÐµÑ‚ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð—Ð°ÐºÐ°Ð·Ð°',0),(174202,4839,'es','Ningun Cantidad de Ordenes',0),(174203,4839,'de','Keine Bestellmenge',0),(174204,4839,'en','No Order Quantity',0),(174205,4840,'is','',0),(174206,4840,'dr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚   Ù†ÙˆØ¹ ',0),(174207,4840,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚   Ù†ÙˆØ¹ ',0),(174208,4840,'tr','Order By & tÃ¼rÃ¼',0),(174209,4840,'pl','Zlecenie & typu',0),(174210,4840,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ & Ñ‚Ð¸Ð¿',0),(174211,4840,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¢Ø±ÚˆØ± & Ù‚Ø³Ù…',0),(174212,4840,'sr','ÐžÑ€Ð´ÐµÑ€ Ð‘y & Ñ‚Ð¸Ð¿',0),(174213,4840,'vi','Äáº·t hÃ ng bá»Ÿi & loáº¡i',0),(174214,4840,'af','Bestel Deur & Tipe',0),(174215,4840,'ro','Ordine de & tip',0),(174216,4840,'et','Telli & tÃ¼Ã¼p',0),(174217,4840,'si','Order By & tipa',0),(174218,4840,'ba','Order By & jenis',0),(174219,4840,'nl','Order By & Type',0),(174220,4840,'fi','JÃ¤rjestÃ¤ & tyyppi',0),(174221,4840,'no','Bestill ved & Type',0),(174222,4840,'da','Order By & Type',0),(174223,4840,'ko','ì£¼ë¬¸ì— ì˜í•´ & í˜•ì‹',0),(174224,4840,'he','×¡×“×¨ ×œ×¤×™ & ×¡×•×’',0),(174225,4840,'el','Î£ÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ & Ï„ÏÏ€Î¿Ï…',0),(174226,4840,'zh','æŒ‰ç±»åž‹æŽ’åº\r\n',0),(174227,4840,'sv','BestÃ¤llning av & typ',0),(174228,4840,'it','Ordine di & tipo',0),(174229,4840,'tl','',0),(174230,4840,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3650;&#3604;&#3618;&#3649;&#3621;&#3632;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(174231,4840,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¥à¤°à¤® & à¤ªà¥à¤°à¤•à¤¾à¤°',0),(174232,4840,'ms','Perintah oleh & jenis',0),(174233,4840,'ar','ØªØ±ØªÙŠØ¨ Ø­Ø³Ø¨ Ø¢Ù†Ø¯ Ù†ÙˆØ¹',0),(174234,4840,'fr','Ordre de & de Type',0),(174235,4840,'jp','æ³¨æ–‡è€…ã?¨ã‚¿ã‚¤ãƒ—',0),(174236,4840,'pt','Ordem por & tipo',0),(174237,4840,'ru','Ð—Ð°ÐºÐ°Ð· ÐŸÐ¾ & Ð¢Ð¸Ð¿',0),(174238,4840,'es','Ordenar Por & Tipo',0),(174239,4840,'de','Order By & Typ',0),(174240,4840,'en','Order By & Type',0),(174241,4841,'is','',0),(174242,4841,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(174243,4841,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(174244,4841,'tr','KayÄ±tlÄ± sipariÅŸ bilgileri',0),(174245,4841,'pl','Zapisane informacje o kolejnoÅ›ci',0),(174246,4841,'bg','Ð—Ð°Ð¿Ð¸ÑÐ°Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(174247,4841,'ur','ØªØ±ØªÛŒØ¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº',0),(174248,4841,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð¸ ÑÐ¿Ð°ÑÐ¸Ð¾',0),(174249,4841,'vi','Sao lÆ°u thÃ´ng tin Ä‘Æ¡n hÃ ng',0),(174250,4841,'af','Bestelling Informasie Gestoor',0),(174251,4841,'ro','Informatie comanda salvata',0),(174252,4841,'et','Salvestatud teabe',0),(174253,4841,'si','Informacije o naroÄilu, shranjene',0),(174254,4841,'ba','Informasi permintaan yang disimpan',0),(174255,4841,'nl','Bestelgegevens opgeslagen',0),(174256,4841,'fi','Tilauksen tiedot',0),(174257,4841,'no','Informasjon lagret',0),(174258,4841,'da','Bestil Information gemt',0),(174259,4841,'ko','ì£¼ë¬¸ ì •ë³´ ì €ìž¥',0),(174260,4841,'he','×ž×™×“×¢ ××•×“×•×ª ×”×–×ž× ×•×ª ×”×¦×™×œ',0),(174261,4841,'el','Î£ÎµÎ¹ÏÎ¬ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯',0),(174262,4841,'zh','è®¢å•ä¿¡æ¯ä¿å­˜\r\n',0),(174263,4841,'sv','BestÃ¤llningsinformation sparas',0),(174264,4841,'it','Ordine informazioni salvate',0),(174265,4841,'tl','',0),(174266,4841,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3649;&#3621;&#3657;&#3623;',0),(174267,4841,'hi','à¤†à¤¦à¥‡à¤¶ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤¹à¥‡à¤œà¥‡',0),(174268,4841,'ms','Maklumat pesanan yang disimpan',0),(174269,4841,'ar','Ø­ÙØ¸Øª Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(174270,4841,'fr','Informations de la commande enregistrÃ©es',0),(174271,4841,'jp','æ³¨æ–‡æƒ…å ±ã?Œä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(174272,4841,'pt','Ordem informaÃ§Ãµes salvas',0),(174273,4841,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð—Ð°ÐºÐ°Ð·Ð° Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð°',0),(174274,4841,'es','InformaciÃ³n de Pedido Guardado',0),(174275,4841,'de','Informationen zur Bestellung gespeichert',0),(174276,4841,'en','Order Information Saved',0),(174277,4842,'is','',0),(174278,4842,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ ',0),(174279,4842,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ ',0),(174280,4842,'tr','SipariÅŸ arama',0),(174281,4842,'pl','KolejnoÅ›Ä‡ wyszukiwania',0),(174282,4842,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(174283,4842,'ur','Ø¢Ø±ÚˆØ± Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(174284,4842,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(174285,4842,'vi','TÃ¬m Ä‘Æ¡n hÃ ng',0),(174286,4842,'af','Bestelling Opsoek',0),(174287,4842,'ro','Ordinul Lookup',0),(174288,4842,'et','Tellimuse otsing',0),(174289,4842,'si','Nalog za iskanje',0),(174290,4842,'ba','Urutan pencarian',0),(174291,4842,'nl','Volgorde Lookup',0),(174292,4842,'fi','Jotta haku',0),(174293,4842,'no','For oppslag',0),(174294,4842,'da','Bestil opslag',0),(174295,4842,'ko','ì£¼ë¬¸ ì¡°íšŒ',0),(174296,4842,'he','×‘×“×™×§×ª ×¡×“×¨',0),(174297,4842,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(174298,4842,'zh','æŸ¥æ‰¾è®¢å•\r\n',0),(174299,4842,'sv','BestÃ¤llning sÃ¶kning',0),(174300,4842,'it','Ricerca di ordine',0),(174301,4842,'tl','',0),(174302,4842,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(174303,4842,'hi','à¤‘à¤°à¥à¤¡à¤° à¤²à¥à¤•à¤…à¤ª',0),(174304,4842,'ms','Carian pesanan',0),(174305,4842,'ar','Ø£Ù…Ø± Ø§Ù„Ø¨Ø­Ø«',0),(174306,4842,'fr','Recherche de commande',0),(174307,4842,'jp','æ³¨æ–‡å?‚ç…§',0),(174308,4842,'pt','Pesquisa de ordem',0),(174309,4842,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾Ð¸ÑÐºÐ°',0),(174310,4842,'es','Buscar Orden ',0),(174311,4842,'de','Bestellung nachschlagen',0),(174312,4842,'en','Order Lookup',0),(174313,4843,'is','',0),(174314,4843,'dr','1',0),(174315,4843,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´   1',0),(174316,4843,'tr','Order_Quantity #1',0),(174317,4843,'pl','Order_Quantity #1',0),(174318,4843,'bg','Order_Quantity #1',0),(174319,4843,'ur','Order_Quantity #1',0),(174320,4843,'sr','ÐžÑ€Ð´ÐµÑ€_QÑƒÐ°Ð½Ñ‚Ð¸Ñ‚y #1',0),(174321,4843,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n hÃ ng sá»‘ 1',0),(174322,4843,'af','Bestellingseenheid #1',0),(174323,4843,'ro','Order_Quantity #1',0),(174324,4843,'et','Order_Quantity #1',0),(174325,4843,'si','Order_Quantity #1',0),(174326,4843,'ba','Order_Quantity #1',0),(174327,4843,'nl','Order_Quantity #1',0),(174328,4843,'fi','Order_Quantity #1',0),(174329,4843,'no','Order_Quantity #1',0),(174330,4843,'da','Order_Quantity #1',0),(174331,4843,'ko','Order_Quantity # 1',0),(174332,4843,'he','Order_Quantity #1',0),(174333,4843,'el','Order_Quantity #1',0),(174334,4843,'zh','è®¢è´­æ•°é‡ï¼ƒ1\r\n',0),(174335,4843,'sv','Order_Quantity #1',0),(174336,4843,'it','Order_Quantity #1',0),(174337,4843,'tl','',0),(174338,4843,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3591;&#3634;&#3609;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586; 1',0),(174339,4843,'hi','Order_Quantity #1',0),(174340,4843,'ms','Order_Quantity #1',0),(174341,4843,'ar','Order_Quantity #1',0),(174342,4843,'fr','Order_Quantity #1',0),(174343,4843,'jp','æ³¨æ–‡æ•°é‡?ï¼‘ç•ª',0),(174344,4843,'pt','Order_Quantity #1',0),(174345,4843,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾_Ð—Ð°ÐºÐ°Ð·Ð° #1',0),(174346,4843,'es','Cantidad de Ordenes #1',0),(174347,4843,'de','Order_Quantity #1',0),(174348,4843,'en','Order_Quantity #1',0),(174349,4844,'is','',0),(174350,4844,'dr','POD Ø´Ù…Ø§Ø±Ù‡ ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÙŠØ¯ ',0),(174351,4844,'pr','POD Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(174352,4844,'tr','POD numarasÄ±',0),(174353,4844,'pl','POD numer',0),(174354,4844,'bg','ÐŸÐžÐ” Ð½Ð¾Ð¼ÐµÑ€',0),(174355,4844,'ur','Ù¾Ú¾Ù„ÛŒ Ù†Ù…Ø¨Ø±',0),(174356,4844,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÐ°Ð¿ÑÑƒÐ»Ð°',0),(174357,4844,'vi','Chá»©ng nháº­n giao hÃ ng sá»‘',0),(174358,4844,'af','POA Nommer',0),(174359,4844,'ro','NumÄƒrul de POD',0),(174360,4844,'et','POD Number',0),(174361,4844,'si','POD Å¡tevilko',0),(174362,4844,'ba','POD nomor',0),(174363,4844,'nl','POD nummer',0),(174364,4844,'fi','POD numero',0),(174365,4844,'no','POD nummer',0),(174366,4844,'da','POD antallet',0),(174367,4844,'ko','í¬ë“œ ë²ˆí˜¸',0),(174368,4844,'he','×ž×¡×¤×¨ ×ª×',0),(174369,4844,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ POD',0),(174370,4844,'zh','è´§åˆ°ä»˜æ¬¾å·ç \r\n',0),(174371,4844,'sv','POD nummer',0),(174372,4844,'it','Numero POD',0),(174373,4844,'tl','',0),(174374,4844,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586; POD',0),(174375,4844,'hi','à¤«à¤²à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(174376,4844,'ms','Nombor POD',0),(174377,4844,'ar','Ø¹Ø¯Ø¯ Ø¬Ø±Ø§Ø¨',0),(174378,4844,'fr','Nombre POD',0),(174379,4844,'jp','PODç•ªå?·',0),(174380,4844,'pt','NÃºmero de vagem',0),(174381,4844,'ru','ÐŸÐžÐ” Ð½Ð¾Ð¼ÐµÑ€',0),(174382,4844,'es','POD NÃºmero',0),(174383,4844,'de','HÃœLSE Anzahl',0),(174384,4844,'en','POD Number',0),(174385,4845,'is','',0),(174386,4845,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(174387,4845,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(174388,4845,'tr','Yeni baskÄ± sipariÅŸ numarasÄ±',0),(174389,4845,'pl','Przedruk numer zamÃ³wienia',0),(174390,4845,'bg','ÐŸÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(174391,4845,'ur','Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø±',0),(174392,4845,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(174393,4845,'vi','In láº¡i sá»‘ ÄÆ¡n hÃ ng ',0),(174394,4845,'af','Herdruk Bestellingnommer',0),(174395,4845,'ro','NumÄƒrul de ordine retipÄƒrire',0),(174396,4845,'et','KordustrÃ¼kk jÃ¤rjekorranumber',0),(174397,4845,'si','Ponatis zaporedno Å¡tevilko',0),(174398,4845,'ba','Nomor pesanan cetak ulang',0),(174399,4845,'nl','Herdruk ordernummer',0),(174400,4845,'fi','Uusintapainos tilausnumero',0),(174401,4845,'no','Nytt nummer',0),(174402,4845,'da','Genoptryk ordrenummer',0),(174403,4845,'ko','ë¬´ë‹¨ ì „ìž¬ ì£¼ë¬¸ ë²ˆí˜¸',0),(174404,4845,'he','×ž×¡×¤×¨ ×”×–×ž× ×ª ×”×“×¤×¡×” ×ž×—×“×©',0),(174405,4845,'el','Î‘Î½Î¬Ï„Ï…Ï€Î¿ Î±ÏÎ¾Ï‰Î½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(174406,4845,'zh','é‡å°è®¢å•å·\r\n',0),(174407,4845,'sv','Nytryck ordernummer',0),(174408,4845,'it','Numero di ordinazione ristampa',0),(174409,4845,'tl','',0),(174410,4845,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(174411,4845,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(174412,4845,'ms','Nombor pesanan pencetakan semula',0),(174413,4845,'ar','Ø±Ù‚Ù… Ø£Ù…Ø± Ø·Ø¨Ø¹',0),(174414,4845,'fr','NumÃ©ro de commande de rÃ©impression',0),(174415,4845,'jp','æ³¨æ–‡ç•ªå?·ã?®å†?å?°åˆ·',0),(174416,4845,'pt','NÃºmero de ordem de reimpressÃ£o',0),(174417,4845,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·Ð° ÐÐ¾Ð¼ÐµÑ€',0),(174418,4845,'es','NÃºmero de Orden de Reimprimir',0),(174419,4845,'de','Reprint-Bestellnummer',0),(174420,4845,'en','Reprint Order Number',0),(174421,4846,'is','',0),(174422,4846,'dr','Ø³Ù¾Ø³ ÙŠÙƒ Ù†ÙˆØ¹ Ø¬Ù†Ø³ Ø±Ø§ Ø§Ø² Ù„ÙŠØ³Øª Ø§Ø¬Ù†Ø§Ø³ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(174423,4846,'pr','Ø³Ù¾Ø³ ÙŠÙƒ Ù†ÙˆØ¹ Ø¬Ù†Ø³ Ø±Ø§ Ø§Ø² Ù„ÙŠØ³Øª Ø§Ø¬Ù†Ø§Ø³ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(174424,4846,'tr','AyrÄ±ntÄ± listesinde bir ayrÄ±ntÄ± tÃ¼rÃ¼ seÃ§in',0),(174425,4846,'pl','NastÄ™pnie wybierz typ szczegÃ³Å‚Ã³w z listy detal',0),(174426,4846,'bg','Ð¡Ð»ÐµÐ´ Ñ‚Ð¾Ð²Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿ Ð´ÐµÑ‚Ð°Ð¹Ð» Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð¿Ð¾-Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(174427,4846,'ur','Ù¾Ú¾Ø± ØªÙØµÛŒÙ„ Ú©ÛŒ Ø§ÛŒÚ© Ù‚Ø³Ù… Ú©ÛŒ ØªÙØµÛŒÙ„ÛŒ ÙÛØ±Ø³Øª Ø³Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(174428,4846,'sr','Ð—Ð°Ñ‚Ð¸Ð¼ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿ Ð´ÐµÑ‚Ð°Ñ™ ÑÐ° Ð´ÐµÑ‚Ð°Ñ™Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(174429,4846,'vi','Sau Ä‘Ã³ chá»n loáº¡i chi tiáº¿t tá»« danh sÃ¡ch chi tiáº¿t',0),(174430,4846,'af','Kies dan \'n detail-tipe uit die lys van detail',0),(174431,4846,'ro','Apoi selectaÅ£i un tip de detaliu din lista de detaliu',0),(174432,4846,'et','Valige nimekirjast detail Ã¼ksikasjad',0),(174433,4846,'si','Seznamu podrobnosti izberite vrsto podrobnosti',0),(174434,4846,'ba','Kemudian pilih jenis detail dari daftar rinci',0),(174435,4846,'nl','Selecteer vervolgens een detail-type in de lijst detail',0),(174436,4846,'fi','Valitse tiedot-luettelosta yksityiskohta type',0),(174437,4846,'no','Velg en detalj fra detaljomrÃ¥det',0),(174438,4846,'da','Derefter vÃ¦lge typen detaljer listen detalje',0),(174439,4846,'ko','ìžì„¸ížˆ ëª©ë¡ì—ì„œ ì„¸ë¶€ ì¢…ë¥˜ë¥¼ ì„ íƒ í•©ë‹ˆë‹¤',0),(174440,4846,'he','×œ××—×¨ ×ž×›×Ÿ ×‘×—×¨ ×¡×•×’ ×¤×¨×˜ ×ž×”×¨×©×™×ž×” ×¤×™×¨×•×˜',0),(174441,4846,'el','Î£Ï„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î±, ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î±Î½ Ï„ÏÏ€Î¿ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î±Ï€ÏŒ Ï„Î· Î»Î¯ÏƒÏ„Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(174442,4846,'zh','ç„¶åŽä»Žè¯¦ç»†æ¸…å•ä¸­é€‰æ‹©ä¸€ä¸ªç»†èŠ‚ç±»åž‹\r\n',0),(174443,4846,'sv','Markera sedan en detalj frÃ¥n detaljomrÃ¥det',0),(174444,4846,'it','Quindi selezionare un tipo di dettaglio nell\'elenco dettaglio',0),(174445,4846,'tl','',0),(174446,4846,'th','&#3605;&#3656;&#3629;&#3652;&#3611;&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3592;&#3634;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3',0),(174447,4846,'hi','à¤¤à¤¬ à¤à¤• à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤µà¤¿à¤µà¤°à¤£ à¤¸à¥‚à¤šà¥€ à¤¸à¥‡ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(174448,4846,'ms','Kemudian pilih jenis butiran daripada senarai terperinci',0),(174449,4846,'ar','Ø«Ù… Ø­Ø¯Ø¯ Ù†ÙˆØ¹ ØªÙØ§ØµÙŠÙ„ Ù…Ù† Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© ØªÙØ§ØµÙŠÙ„',0),(174450,4846,'fr','Puis sÃ©lectionnez un type de dÃ©tail dans la liste en dÃ©tail',0),(174451,4846,'jp','ã??ã?—ã?¦è©³ç´°ãƒªã‚¹ãƒˆã?‹ã‚‰è©³ç´°ã‚¿ã‚¤ãƒ—ã‚’é?¸æŠžã?—ã?¦ã??ã? ã?•ã?„',0),(174452,4846,'pt','Em seguida, selecione um tipo de detalhe da lista de detalhe',0),(174453,4846,'ru','Ð¢Ð¾Ð³Ð´Ð° Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”ÐµÑ‚Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ñ‚Ð¸Ð¿ Ð¸Ð· Ð´ÐµÑ‚Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ ÑÐ¿Ð¸ÑÐºÐ°',0),(174454,4846,'es','Entonces seleccionar un tipo de detalle de la lista de detalles',0),(174455,4846,'de','WÃ¤hlen Sie dann einen Detailtyp aus der Detailliste',0),(174456,4846,'en','Then select a detail type from the detail list',0),(174457,4847,'is','',0),(174458,4847,'dr','Ø§ÙŠÙ† Ø¬Ø¹Ø¨Ù‡ Ù‡Ù…ÙŠØ´Ù‡ Ø­Ø§ÙˆÙŠ  ÙŠÙƒ ØªÙˆØ¶ÙŠØ­ ÙƒØ§Ù…Ù„ Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ÙŠ ÙƒÙ‡ Ø´Ù…Ø§ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ Ø§Ø³Øª ',0),(174459,4847,'pr','Ø§ÙŠÙ† Ø¬Ø¹Ø¨Ù‡ Ù‡Ù…ÙŠØ´Ù‡ Ø­Ø§ÙˆÙŠ  ÙŠÙƒ ØªÙˆØ¶ÙŠØ­ ÙƒØ§Ù…Ù„ Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ÙŠ ÙƒÙ‡ Ø´Ù…Ø§ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ Ø§Ø³Øª ',0),(174460,4847,'tr','Bu kutusu her zaman yaptÄ±ÄŸÄ±nÄ±z seÃ§im tam aÃ§Ä±klamasÄ±nÄ± iÃ§erir.',0),(174461,4847,'pl','To pole bÄ™dzie zawsze zawiera peÅ‚ny opis wyboru, ktÃ³re siÄ™',0),(174462,4847,'bg','Ð¢Ð¾Ð²Ð° Ð¿Ð¾Ð»Ðµ Ð²Ð¸Ð½Ð°Ð³Ð¸ Ñ‰Ðµ ÑÑŠÐ´ÑŠÑ€Ð¶Ð° Ð¿ÑŠÐ»Ð½Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð¸Ð·Ð±Ð¾Ñ€, ÐºÐ¾Ð¸Ñ‚Ð¾ ÑÑ‚Ðµ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð¸',0),(174463,4847,'ur','ÛŒÛ Ø®Ø§Ù†Û ÛÙ…ÛŒØ´Û Ø§ÛŒÚ© Ù…Ú©Ù…Ù„ ØªÙØµÛŒÙ„ Ø¢Ù¾ Ù†Û’ Ú©ÛŒØ§ Ù¾Ø³Ù†Ø¯ Ú©ÛŒ Ø­Ø§Ù…Ù„ ÛÙˆ Ú¯ÛŒ',0),(174464,4847,'sr','ÐžÐ²Ð°Ñ˜ Ð¾ÐºÐ²Ð¸Ñ€ Ñ›Ðµ ÑƒÐ²ÐµÐº ÑÐ°Ð´Ñ€Ð¶Ð¸ Ð¿ÑƒÐ½ Ð¾Ð¿Ð¸Ñ Ð¸Ð·Ð±Ð¾Ñ€Ð° ÐºÐ¾Ñ˜Ð¸ ÑÑ‚Ðµ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð¸',0),(174465,4847,'vi','Há»™p nÃ y luÃ´n chá»©a toÃ n bá»™ diá»…n giáº£i cá»§a nhá»¯ng lá»±a chá»n cá»§a báº¡n',0),(174466,4847,'af','Die boks sal altyd bestaan uit \'n volledige beskrywing van u keuse',0),(174467,4847,'ro','AceastÄƒ rubricÄƒ va conÅ£ine Ã®ntotdeauna o descriere completÄƒ a alegere ai facut',0),(174468,4847,'et','Ruudu alati sisaldama tÃ¤ielikku kirjeldust tehtud valik',0),(174469,4847,'si','To polje bo vedno vsebovati popoln opis izbira, ki ste jih naredili',0),(174470,4847,'ba','Kotak ini akan selalu berisi keterangan lengkap tentang pilihan yang Anda buat',0),(174471,4847,'nl','Dit vak bevat altijd een volledige beschrijving van de keuze die u hebt gemaakt',0),(174472,4847,'fi','TÃ¤mÃ¤ ruutu sisÃ¤ltÃ¤Ã¤ aina tÃ¤ydellisen kuvauksen on valinnan',0),(174473,4847,'no','Denne boksen vil alltid inneholde en fullstendig beskrivelse av valget du har gjort',0),(174474,4847,'da','Denne boks vil altid indeholde en komplet beskrivelse af det valg du har foretaget',0),(174475,4847,'ko','ì´ ìƒìžëŠ” ì„ íƒì˜ ì „ì²´ ì„¤ëª…ì„ í¬í•¨ í•­ìƒ ë©ë‹ˆë‹¤.',0),(174476,4847,'he','×ª×™×‘×” ×–×• ×ª×ž×™×“ ×™×›×™×œ ×ª×™××•×¨ ×ž×œ× ×©×œ ×”×‘×—×™×¨×” ×©×‘×™×¦×¢×ª',0),(174477,4847,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ Î¸Î± Ï€Î¬Î½Ï„Î± Î½Î± Ï€ÎµÏÎ¹Î­Ï‡ÎµÎ¹ Î¼Î¹Î± Ï€Î»Î®ÏÎ· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚ Ï€Î¿Ï… ÎºÎ¬Î½Î±Ï„Îµ',0),(174478,4847,'zh','æ­¤æ¡†å°†å§‹ç»ˆåŒ…å«ä¸€ä¸ªä½ æ‰€ä½œå‡ºé€‰æ‹©çš„å®Œæ•´æè¿°\r\n',0),(174479,4847,'sv','Denna ruta kommer alltid att innehÃ¥lla en fullstÃ¤ndig beskrivning av de val du har gjort',0),(174480,4847,'it','Questa scatola conterrÃ  sempre una descrizione completa della scelta che avete fatto',0),(174481,4847,'tl','',0),(174482,4847,'th','&#3594;&#3656;&#3629;&#3591;&#3609;&#3637;&#3657;&#3588;&#3640;&#3603;&#3592;&#3632;&#3617;&#3637;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3588;&#3640;&#3603;&#3648;&#3',0),(174483,4847,'hi','à¤‡à¤¸ à¤¬à¥‰à¤•à¥à¤¸ à¤®à¥‡à¤‚ à¤¹à¤®à¥‡à¤¶à¤¾ à¤ªà¤¸à¤‚à¤¦ à¤¤à¥à¤®à¥à¤¹à¥‡à¤‚ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤¹à¥ˆ à¤•à¥€ à¤à¤• à¤ªà¥‚à¤°à¥à¤£ à¤µà¤¿à¤µà¤°à¤£ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥‹à¤‚à¤—à¥‡',0),(174484,4847,'ms','Kotak ini akan sentiasa mengandungi huraian penuh pilihan yang telah dibuat',0),(174485,4847,'ar','Ø³ÙŠØ­ØªÙˆÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù…Ø±Ø¨Ø¹ Ø¯Ø§Ø¦Ù…Ø§Ù‹ Ø¥Ù„Ù‰ ÙˆØµÙ ÙƒØ§Ù…Ù„ Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ØªÙŠ Ø£Ø¬Ø±ÙŠØªÙ‡Ø§',0),(174486,4847,'fr','Cette boÃ®te contient toujours une description complÃ¨te du choix que vous avez fait',0),(174487,4847,'jp','ã?“ã?®ãƒœãƒƒã‚¯ã‚¹ã?¯å¸¸ã?«ã?‚ã?ªã?Ÿã?Œé?¸æŠžã?—ã?Ÿå…¨ã?¦ã?®è§£èª¬ã‚’å?«ã?¿ã?¾ã?™',0),(174488,4847,'pt','Esta caixa sempre conterÃ¡ uma descriÃ§Ã£o completa da escolha que vocÃª fez',0),(174489,4847,'ru','Ð­Ñ‚Ð¾ Ð¿Ð¾Ð»Ðµ Ð²ÑÐµÐ³Ð´Ð° Ð±ÑƒÐ´ÐµÑ‚ ÑÐ¾Ð´ÐµÑ€Ð¶Ð°Ñ‚ÑŒ Ð¿Ð¾Ð»Ð½Ð¾Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð²Ñ‹Ð±Ð¾Ñ€ Ð²Ñ‹ ÑÐ´ÐµÐ»Ð°Ð»Ð¸',0),(174490,4847,'es','Esta Caja siempre contenerÃ¡ una descripciÃ³n completa de la selecciÃ³n que ha hecho',0),(174491,4847,'de','Dieses Feld enthÃ¤lt immer eine vollstÃ¤ndige Beschreibung der Wahl von Ihnen vorgenommenen',0),(174492,4847,'en','This box will always contain a full description of the choice you have made',0),(174493,4848,'is','',0),(174494,4848,'dr','Ø¨Ø±Ø§ÙŠ Ø¯ÙŠØ¯Ù† Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§ÙŠÙ† Ø±Ø§Ù‡Ù†Ù…Ø§ â€“ Ú¯Ø²ÙŠÙ†Ù‡ Ø¨Ø§Ù„Ø§ Ø²ÙŠØ± Ù†ÙˆØ¹ ÙƒØ§Ø± Ø±Ø§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(174495,4848,'pr','Ø¨Ø±Ø§ÙŠ Ø¯ÙŠØ¯Ù† Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§ÙŠÙ† Ø±Ø§Ù‡Ù†Ù…Ø§ â€“ Ú¯Ø²ÙŠÙ†Ù‡ Ø¨Ø§Ù„Ø§ Ø²ÙŠØ± Ù†ÙˆØ¹ ÙƒØ§Ø± Ø±Ø§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(174496,4848,'tr','Bu yardÄ±m yeniden gÃ¶rmek iÃ§in iÅŸ tÃ¼rÃ¼ altÄ±nda Ã¼st seÃ§eneÄŸini yeniden seÃ§in.',0),(174497,4848,'pl','Aby zobaczyÄ‡ pomoc ponownie, ponownie szczyt moÅ¼liwoÅ›ci w pracy typu',0),(174498,4848,'bg','Ð—Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾, Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾ Ð³Ð¾Ñ€Ð½Ð°Ñ‚Ð° Ð¾Ð¿Ñ†Ð¸Ñ Ð¿Ð¾Ð´ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(174499,4848,'ur','Ø§Ø³ Ù…Ø¯Ø¯ Ú©Ùˆ Ø¯ÙˆØ¨Ø§Ø±Û Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ØŒ Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± Ú©Û’ Ø§Ø®ØªÛŒØ§Ø± Ú©Û’ ØªØ­Øª Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Û”',0),(174500,4848,'sr','Ð”Ð° Ð²Ð¸Ð´Ð¸Ð¼ Ð¾Ð²Ñƒ Ð¿Ð¾Ð¼Ð¾Ñ›, Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð³Ð¾Ñ€ÑšÑƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ Ð¿Ð¾Ð´ Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(174501,4848,'vi','Äá»ƒ vÃ o láº¡i trá»£ giÃºp chá»n lá»±a chá»n Ä‘áº§u tiÃªn dÆ°á»›i loáº¡i cÃ´ng viá»‡c',0),(174502,4848,'af','Om hierdie hulp weer te sien, herselekteer die boonste opsie onder Werk Tipe',0),(174503,4848,'ro','Pentru a vedea din nou acest ajutor, selectaÅ£i din nou opÅ£iunea de top Ã®n conformitate cu tipul de munca',0),(174504,4848,'et','See aitab jÃ¤lle nÃ¤ha â¿mber top valik vastavalt tÃ¶Ã¶ liigile',0),(174505,4848,'si','Da spet vidim ta pomoÄ, znova izberite top moÅ¾nosti pod vrsto dela',0),(174506,4848,'ba','Untuk melihat bantuan ini lagi, memilih ulang pilihan atas di bawah jenis pekerjaan',0),(174507,4848,'nl','Om te zien deze Help-informatie weer, opnieuw de bovenste optie onder werksoort',0),(174508,4848,'fi','TÃ¤ssÃ¤ ohjeessa uudelleen, uudelleen alkuun TyÃ¶tyyppi-kohdasta',0),(174509,4848,'no','Ã… se dette hjelpe igjen, Velg den Ã¸verste valget under arbeidstype',0),(174510,4848,'da','Hvis du vil se denne hjÃ¦lp igen, genvÃ¦lge den Ã¸verste valgmulighed under arbejdstype',0),(174511,4848,'ko','ì´ ë„ì›€ë§ì„ ë‹¤ì‹œ ë³´ë ¤ë©´, ìž‘ì—… ìœ í˜• ì•„ëž˜ì—ì„œ ìœ„ìª½ ì˜µì…˜ì„ ë‹¤ì‹œ ì„ íƒ',0),(174512,4848,'he','×›×“×™ ×œ×¨××•×ª ××ª ×–×” ×©×•×‘, ×•××– ×œ×‘×—×•×¨ ×ž×—×“×© ×‘××¤×©×¨×•×ª ×”×¢×œ×™×•× ×” ×ª×—×ª ×¡×•×’ ×¢×‘×•×“×”',0),(174513,4848,'el','ÎÎ± Î¾Î±Î½Î±Î´ÏŽ Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ Î²Î¿Î®Î¸ÎµÎ¹Î±Ï‚, ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î¾Î±Î½Î¬ Î· ÎºÎ¿ÏÏ…Ï†Î±Î¯Î± ÎµÏ€Î¹Î»Î¿Î³Î® ÏƒÏ„Î·Î½ Ï€ÎµÏÎ¹Î¿Ï‡Î® Î¤ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(174514,4848,'zh','è¦å†æŸ¥çœ‹æ­¤å¸®åŠ©ï¼Œæ ¹æ®å·¥ä½œç±»åž‹é‡æ–°é€‰æ‹©æœ€ä¸Šé¢çš„é€‰é¡¹',0),(174515,4848,'sv','FÃ¶r att se denna hjÃ¤lp igen, VÃ¤lj det Ã¶versta alternativet under arbetstyp',0),(174516,4848,'it','Per visualizzare nuovamente questo aiuto, riselezionare l\'opzione superiore sotto il tipo di lavoro',0),(174517,4848,'tl','',0),(174518,4848,'th','&#3604;&#3641;&#3585;&#3634;&#3619;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3609;&#3637;&#3657;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591; &#3585;&#3621;&#3633;&#3610;&#3652;&#3611;&#3648;&#3621;&#3639;&#3629;&#3585;&#',0),(174519,4848,'hi','à¤‡à¤¸ à¤®à¤¦à¤¦ à¤•à¥‡ à¤«à¤¿à¤° à¤¸à¥‡ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥€à¤°à¥à¤· à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¥‡ à¤¤à¤¹à¤¤ à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¥à¤¨à¤ƒ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(174520,4848,'ms','Untuk melihat bantuan ini sekali lagi, pilih semula opsyen atas di bawah jenis kerja',0),(174521,4848,'ar','Ù„Ù…Ø´Ø§Ù‡Ø¯Ø© Ù‡Ø°Ù‡ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ØŒ Ø£Ø¹Ø¯ ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø®ÙŠØ§Ø± Ø§Ù„Ø£Ø¹Ù„Ù‰ ØªØ­Øª \"Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„\"',0),(174522,4848,'fr','Pour revoir cette aide, sÃ©lectionnez Ã  nouveau la haut de la page option sous Type de travail',0),(174523,4848,'jp','ã?“ã?®ãƒ˜ãƒ«ãƒ—ã‚’å†?åº¦è¦‹ã‚‹ã?Ÿã‚?ã?«ã?¯ã€?ä½œæ¥­ã‚¿ã‚¤ãƒ—ä¸‹ã?®æœ€åˆ?ã?®é?¸æŠžè‚¢ã‚’å†?åº¦é?¸ã‚“ã?§ã??ã? ã?•ã?„ã€‚',0),(174524,4848,'pt','Para ver esta ajuda novamente, selecione novamente a opÃ§Ã£o superior sob o tipo de trabalho',0),(174525,4848,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ ÑÐ½Ð¾Ð²Ð° ÑƒÐ²Ð¸Ð´ÐµÑ‚ÑŒ ÑÑ‚Ñƒ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒ, Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿Ñ†Ð¸ÑŽ Ð¢Ð¾Ð¿ Ð¿Ð¾Ð´ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‡ÐµÐ³Ð¾',0),(174526,4848,'es','Para ver esta ayuda otra vez, reseleccionar la opciÃ³n cima bajo Tipo de Trabajo',0),(174527,4848,'de','Um diese Hilfe wieder anzuzeigen, wÃ¤hlen Sie erneut die erste Option unter Arbeitstyp',0),(174528,4848,'en','To see this help again, reselect the top option under Work Type',0),(174529,4849,'is','',0),(174530,4849,'dr','(Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡',0),(174531,4849,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ (Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡',0),(174532,4849,'tr','Eksik vade tarihi',0),(174533,4849,'pl','Brak naleÅ¼ytej Data',0),(174534,4849,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(174535,4849,'ur','ØºØ§Ø¦Ø¨ Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(174536,4849,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(174537,4849,'vi','Thiáº¿u ngÃ y háº¿t háº¡n',0),(174538,4849,'af','Vermisde Verskuldigde Datum',0),(174539,4849,'ro','Lipsesc datoritÄƒ data',0),(174540,4849,'et','Kadunud Due Date',0),(174541,4849,'si','Manjka zaradi datuma',0),(174542,4849,'ba','Hilang karena tanggal',0),(174543,4849,'nl','Ontbrekende Due datum',0),(174544,4849,'fi','Puuttuu asianmukaista pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(174545,4849,'no','Manglende forfallsdato dato',0),(174546,4849,'da','Manglende behÃ¸rig dato',0),(174547,4849,'ko','ê¸°í•œ ì—†ëŠ” ë‚ ì§œ',0),(174548,4849,'he','×—×¡×¨ ×ª××¨×™×š ×¤×¨×¢×•×Ÿ',0),(174549,4849,'el','Î›ÎµÎ¯Ï€ÎµÎ¹ Î»ÏŒÎ³Ï‰ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(174550,4849,'zh','ç¼ºå°‘æˆªæ­¢æ—¥æœŸ\r\n',0),(174551,4849,'sv','Saknas vederbÃ¶rlig datum',0),(174552,4849,'it','Manca la scadenza Data',0),(174553,4849,'tl','',0),(174554,4849,'th','&#3623;&#3633;&#3609;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(174555,4849,'hi','à¤²à¤¾à¤ªà¤¤à¤¾ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(174556,4849,'ms','Hilang habis tempoh tarikh',0),(174557,4849,'ar','Ø§Ù„ÙˆØ§Ø¬Ø¨ ÙÙŠ Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙÙ‚ÙˆØ¯ÙŠÙ† Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(174558,4849,'fr','Manque de Due Date',0),(174559,4849,'jp','æœŸæ—¥ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(174560,4849,'pt','Faltando Due Date',0),(174561,4849,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ðµ Ð”Ð°Ñ‚Ð°',0),(174562,4849,'es','Falta Fecha de Vencimiento',0),(174563,4849,'de','Fehlende Due Date',0),(174564,4849,'en','Missing Due Date',0),(174565,4850,'is','',0),(174566,4850,'dr','Ø³ÙØ§Ø±Ø´ Ø­Ø°Ù Ø´Ø¯ ',0),(174567,4850,'pr','Ø³ÙØ§Ø±Ø´ Ø­Ø°Ù Ø´Ø¯ ',0),(174568,4850,'tr','SipariÅŸi silindi',0),(174569,4850,'pl','Aby usunÄ…Ä‡',0),(174570,4850,'bg','Ð ÐµÐ´ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚',0),(174571,4850,'ur','Ø­Ø°Ù Ø´Ø¯Û ØªØ±ØªÛŒØ¨',0),(174572,4850,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½',0),(174573,4850,'vi','XÃ³a Ä‘Æ¡n hÃ ng',0),(174574,4850,'af','Bestelling Geskrap',0),(174575,4850,'ro','Ordinul ÅŸters',0),(174576,4850,'et','Et kustutada',0),(174577,4850,'si','Naloga izbrisana',0),(174578,4850,'ba','Order yang dihapus',0),(174579,4850,'nl','Volgorde verwijderd',0),(174580,4850,'fi','Tilaus poistettiin',0),(174581,4850,'no','Ordren slettes',0),(174582,4850,'da','Ordre slettes',0),(174583,4850,'ko','ì£¼ë¬¸ ì‚­ì œ',0),(174584,4850,'he','×”×–×ž× ×” × ×ž×—×§×”',0),(174585,4850,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯',0),(174586,4850,'zh','åˆ é™¤è®¢å•\r\n',0),(174587,4850,'sv','Ordning tas bort',0),(174588,4850,'it','Ordine cancellato',0),(174589,4850,'tl','',0),(174590,4850,'th','&#3621;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3649;&#3621;&#3657;&#3623;',0),(174591,4850,'hi','à¤•à¥à¤°à¤® à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(174592,4850,'ms','Perintah yang dihapuskan',0),(174593,4850,'ar','Ø­Ø°ÙÙ€Øª Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(174594,4850,'fr','Ordre supprimÃ©',0),(174595,4850,'jp','æ¶ˆåŽ»æ¸ˆæ³¨æ–‡',0),(174596,4850,'pt','Ordem eliminado',0),(174597,4850,'ru','Ð—Ð°ÐºÐ°Ð· Ð£Ð´Ð°Ð»ÐµÐ½',0),(174598,4850,'es','Pedido Eliminado',0),(174599,4850,'de','Bestellung gelÃ¶scht',0),(174600,4850,'en','Order Deleted',0),(174601,4851,'is','',0),(174602,4851,'dr','Ù…Ù†ØªØ¸Ø± Ø¨Ø±Ø±Ø³ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(174603,4851,'pr','Ù…Ù†ØªØ¸Ø± Ø¨Ø±Ø±Ø³ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(174604,4851,'tr','MÃ¼ÅŸteri inceleme bekliyor',0),(174605,4851,'pl','Oczekiwania klientÃ³w PrzeglÄ…d',0),(174606,4851,'bg','ÐžÑ‡Ð°ÐºÐ²Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(174607,4851,'ur','Ú¯Ø§ÛÚ© Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©ÛŒ Ù…Ù†ØªØ¸Ø±',0),(174608,4851,'sr','Ð§ÐµÐºÐ°Ñ˜ÑƒÑ›Ð¸ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(174609,4851,'vi','Äang Chá» KhÃ¡ch HÃ ng ÄÃ¡nh GiÃ¡',0),(174610,4851,'af','Wag kliÃ«nt hersiening',0),(174611,4851,'ro','ÃŽn aÅŸteptarea client de revizuire',0),(174612,4851,'et','Kliendi Ã¼levaate ootel',0),(174613,4851,'si','ÄŒaka na pregled kupca',0),(174614,4851,'ba','Menunggu pelanggan Review',0),(174615,4851,'nl','In afwachting van Customer Review',0),(174616,4851,'fi','Odottaa asiakkaan arvio',0),(174617,4851,'no','Venter pÃ¥ Kundevurdering',0),(174618,4851,'da','Afventer kunde anmeldelse',0),(174619,4851,'ko','ê³ ê° ê²€í† ë¥¼ ê¸°ë‹¤ë¦¬ê³  ìžˆë‹¤',0),(174620,4851,'he','×ž×—×›×” ×œ×œ×§×•×— ×¡×§×™×¨×”',0),(174621,4851,'el','Î•Î½ Î±Î½Î±Î¼Î¿Î½Î® Ï€ÎµÎ»Î¬Ï„Î· Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(174622,4851,'zh','ç­‰å¾…é¡¾å®¢æ„è§\r\n',0),(174623,4851,'sv','VÃ¤ntar pÃ¥ kund recension',0),(174624,4851,'it','In attesa di revisione del cliente',0),(174625,4851,'tl','',0),(174626,4851,'th','&#3607;&#3610;&#3607;&#3623;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3619;&#3629;&#3588;&#3629;&#3618;&#3629;&#3618;&#3641;&#3656;',0),(174627,4851,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¤¾ à¤‡à¤‚à¤¤à¤œà¤¾à¤°',0),(174628,4851,'ms','Menunggu kajian pelanggan',0),(174629,4851,'ar','ÙÙŠ Ø§Ù†ØªØ¸Ø§Ø± Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(174630,4851,'fr','En attente d\'examen client',0),(174631,4851,'jp','é¡§å®¢ãƒ¬ãƒ“ãƒ¥ãƒ¼å¾…ã?¡',0),(174632,4851,'pt','Aguardando revisÃ£o do cliente',0),(174633,4851,'ru','ÐžÐ¶Ð¸Ð´Ð°ÐµÑ‚ Ð¾Ð±Ð·Ð¾Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(174634,4851,'es','Esperando RevisiÃ³n de Cliente',0),(174635,4851,'de','Erwartung Kundenbewertung',0),(174636,4851,'en','Awaiting Customer Review',0),(174637,4852,'is','',0),(174638,4852,'dr','Ù…Ù†ØªØ¸Ø± Ø¨Ø±Ø±Ø³ÙŠ Ø¯Ø§Ø®Ù„ÙŠ ',0),(174639,4852,'pr','Ù…Ù†ØªØ¸Ø± Ø¨Ø±Ø±Ø³ÙŠ Ø¯Ø§Ø®Ù„ÙŠ ',0),(174640,4852,'tr','Ä°Ã§ gÃ¶zden geÃ§irme bekliyor',0),(174641,4852,'pl','OczekujÄ…cych na kontroli wewnÄ™trznej',0),(174642,4852,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐµÐ½ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð² Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ',0),(174643,4852,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ø¬Ø§Ø¦Ø²Û Ú©ÛŒ Ù…Ù†ØªØ¸Ø±',0),(174644,4852,'sr','Ð§ÐµÐºÐ°Ñ˜ÑƒÑ›Ð¸ Ð¸Ð½Ñ‚ÐµÑ€Ð½Ð° Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ð°',0),(174645,4852,'vi','Äang Chá» ÄÃ¡nh GiÃ¡ Ná»™i Bá»™',0),(174646,4852,'af','Afwagtende Interne Oorsig',0),(174647,4852,'ro','ÃŽn aÅŸteptarea intern de revizuire',0),(174648,4852,'et','Nad ootavad vaide',0),(174649,4852,'si','ÄŒakajo na notranji pregled',0),(174650,4852,'ba','Menunggu Internal Review',0),(174651,4852,'nl','In afwachting van interne herziening',0),(174652,4852,'fi','Odotetaan sisÃ¤istÃ¤ uudelleentarkastelua',0),(174653,4852,'no','Venter pÃ¥ intern gjennomgang',0),(174654,4852,'da','Afventer intern prÃ¸velse',0),(174655,4852,'ko','ë‚´ë¶€ ê²€í† ë¥¼ ê¸°ë‹¤ë¦¬ê³  ìžˆë‹¤',0),(174656,4852,'he','×ž×ž×ª×™×Ÿ ×‘×™×§×•×¨×ª ×¤× ×™×ž×™×ª',0),(174657,4852,'el','Î•Î½ Î±Î½Î±Î¼Î¿Î½Î® Ï„Î¿Ï… ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ¿Ï ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(174658,4852,'zh','ç­‰å¾…å†…éƒ¨å¤å®¡\r\n',0),(174659,4852,'sv','VÃ¤ntar pÃ¥ intern granskning',0),(174660,4852,'it','In attesa di revisione interna',0),(174661,4852,'tl','',0),(174662,4852,'th','&#3607;&#3610;&#3607;&#3623;&#3609;&#3585;&#3634;&#3619;&#3619;&#3629;&#3588;&#3629;&#3618;&#3616;&#3634;&#3618;&#3651;&#3609;',0),(174663,4852,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¤¾ à¤‡à¤‚à¤¤à¤œà¤¾à¤°',0),(174664,4852,'ms','Menunggu Ulasan dalaman',0),(174665,4852,'ar','ÙÙŠ Ø§Ù†ØªØ¸Ø§Ø± Ø§Ù„Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(174666,4852,'fr','En attente de rÃ©vision interne',0),(174667,4852,'jp','å†…éƒ¨ãƒ¬ãƒ“ãƒ¥ãƒ¼å¾…ã?¡',0),(174668,4852,'pt','Aguardando revisÃ£o interna',0),(174669,4852,'ru','Ð’ Ð¾Ð¶Ð¸Ð´Ð°Ð½Ð¸Ð¸ Ð²Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÐµÐ³Ð¾ Ð¾Ð±Ð·Ð¾Ñ€Ð°',0),(174670,4852,'es','Esperando RevisiÃ³n Internal',0),(174671,4852,'de','Warten auf interne ÃœberprÃ¼fung',0),(174672,4852,'en','Awaiting Internal Review',0),(174673,4853,'is','',0),(174674,4853,'dr','Ø¢Ø®Ø±ÙŠÙ† Ø­Ù…Ù„ Ø´Ø¯Ù‡',0),(174675,4853,'pr','Ø¢Ø®Ø±ÙŠÙ† Ø­Ù…Ù„ Ø´Ø¯Ù‡',0),(174676,4853,'tr','Sevk final',0),(174677,4853,'pl','FinaÅ‚ wysÅ‚ane',0),(174678,4853,'bg','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¾ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(174679,4853,'ur','ÙØ§Ø¦Ù†Ù„ Ù…ÛŒÚº Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(174680,4853,'sr','Ð¤Ð¸Ð½Ð°Ð»Ðµ Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð°',0),(174681,4853,'vi','Chuyáº¿n hÃ ng cuá»‘i',0),(174682,4853,'af','Finale Sending',0),(174683,4853,'ro','Finala expediate',0),(174684,4853,'et','LÃ¤hetatud lÃµplik',0),(174685,4853,'si','KonÄno, poÅ¡iljajo',0),(174686,4853,'ba','Final dikirim',0),(174687,4853,'nl','Finale verzonden',0),(174688,4853,'fi','Lopullinen toimitettu',0),(174689,4853,'no','Endelig sendt',0),(174690,4853,'da','Endelig leveret',0),(174691,4853,'ko','ìµœì¢… ì¶œí•˜',0),(174692,4853,'he','×’×ž×¨ ×©× ×©×œ×—×•',0),(174693,4853,'el','Î¤ÎµÎ»Î¹ÎºÏŒ Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(174694,4853,'zh','æœ€ç»ˆçš„å‘è´§\r\n',0),(174695,4853,'sv','Finalen levereras',0),(174696,4853,'it','Finale spedito',0),(174697,4853,'tl','',0),(174698,4853,'th','&#3626;&#3656;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3619;&#3633;&#3657;&#3591;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(174699,4853,'hi','à¤«à¤¾à¤‡à¤¨à¤² à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(174700,4853,'ms','Akhir dihantar',0),(174701,4853,'ar','Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ Ø§Ù„ØªÙŠ ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(174702,4853,'fr','Final expÃ©diÃ©',0),(174703,4853,'jp','æœ€çµ‚é…?é€?',0),(174704,4853,'pt','Final enviado',0),(174705,4853,'ru','Ð¤Ð¸Ð½Ð°Ð» Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(174706,4853,'es','Final Enviado',0),(174707,4853,'de','Finale ausgeliefert',0),(174708,4853,'en','Final Shipped',0),(174709,4854,'is','',0),(174710,4854,'dr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(174711,4854,'pr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(174712,4854,'tr','Tam fiyat',0),(174713,4854,'pl','Cena kompletna',0),(174714,4854,'bg','ÐŸÑŠÐ»Ð½Ð° Ñ Ñ†ÐµÐ½Ð¸',0),(174715,4854,'ur','Ù…Ú©Ù…Ù„ Ù‚ÛŒÙ…Øª',0),(174716,4854,'sr','Ð Ð°Ð·ÑƒÐ¼Ð½Ðµ Ñ†ÐµÐ½Ðµ ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½',0),(174717,4854,'vi','HoÃ n táº¥t giÃ¡',0),(174718,4854,'af','Prysing Voltooi',0),(174719,4854,'ro','PreÅ£ complet',0),(174720,4854,'et','Hinnaga tÃ¤ielik',0),(174721,4854,'si','Cenah, popolne',0),(174722,4854,'ba','Harga lengkap',0),(174723,4854,'nl','Volledige geprijsd',0),(174724,4854,'fi','Hinnoiteltu tÃ¤ydellinen',0),(174725,4854,'no','Priset fullfÃ¸rt',0),(174726,4854,'da','Pris komplet',0),(174727,4854,'ko','ì™„ë²½ í•œ ê°€ê²©',0),(174728,4854,'he','×‘×ž×—×™×¨ ×ž×œ×',0),(174729,4854,'el','Î¤Î¹Î¼Î­Ï‚ Ï€Î»Î®ÏÎ·',0),(174730,4854,'zh','å®šä»·å®Œæˆ\r\n',0),(174731,4854,'sv','Pris komplett',0),(174732,4854,'it','Prezzo completo',0),(174733,4854,'tl','',0),(174734,4854,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3639;',0),(174735,4854,'hi','à¤ªà¥‚à¤°à¥€ à¤•à¥€à¤®à¤¤',0),(174736,4854,'ms','Harga lengkap',0),(174737,4854,'ar','Ø³Ø¹Ø±Ù‡Ø§ ÙƒØ§Ù…Ù„Ø©',0),(174738,4854,'fr','Prix complet',0),(174739,4854,'jp','ä¾¡æ ¼è¨­å®šå®Œäº†',0),(174740,4854,'pt','PreÃ§o completo',0),(174741,4854,'ru','Ð¦ÐµÐ½Ñ‹ Ð¿Ð¾Ð»Ð½Ñ‹Ð¹',0),(174742,4854,'es','Tener Precio Completo',0),(174743,4854,'de','Preis komplett',0),(174744,4854,'en','Priced Complete',0),(174745,4855,'is','',0),(174746,4855,'dr','Ø¬Ù…Ø¹ ÙƒÙ†Ù†Ø¯Ù‡ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(174747,4855,'pr','Ø¬Ù…Ø¹ ÙƒÙ†Ù†Ø¯Ù‡ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(174748,4855,'tr','YazdÄ±rma dÃ¼zeni SeÃ§icisi',0),(174749,4855,'pl','Wydruku do kompletacji',0),(174750,4855,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(174751,4855,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú†Ù†Ù†Ø¯Û',0),(174752,4855,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð±Ð¸Ñ€Ð°Ñ‡',0),(174753,4855,'vi','ÄÆ¡n hÃ ng in chá»n',0),(174754,4855,'af','Druk orde kieser',0),(174755,4855,'ro','Selector de ordine de imprimare',0),(174756,4855,'et','Printida tellimuse valija',0),(174757,4855,'si','Vrstni red tiskanja izbirnik',0),(174758,4855,'ba','Pesanan cetakan Picker',0),(174759,4855,'nl','Print Order pickster',0),(174760,4855,'fi','Tulostaa tilausten poimija',0),(174761,4855,'no','UtskriftsrekkefÃ¸lge Picker',0),(174762,4855,'da','Udskrive ordre Picker',0),(174763,4855,'ko','ì¸ì‡„ ìˆœì„œ ì„ íƒ',0),(174764,4855,'he','×“×•×’× ×¡×“×¨ ×”×”×“×¤×¡×”',0),(174765,4855,'el','Î•Ï€Î¹Î»Î¿Î³Î­Î±Ï‚ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(174766,4855,'zh','æ‰“å°è®¢å•é€‰æ‹©\r\n',0),(174767,4855,'sv','Utskriftsordning Picker',0),(174768,4855,'it','Commissionatore a stampa',0),(174769,4855,'tl','',0),(174770,4855,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;&#3648;&#3585;&#3655;&#3610;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(174771,4855,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤ªà¤¿à¤•à¤°',0),(174772,4855,'ms','Cetak Picker',0),(174773,4855,'ar','Ù…Ù†ØªÙ‚ÙŠ Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(174774,4855,'fr','Impression de conduite Ã©levable',0),(174775,4855,'jp','æ³¨æ–‡é?¸æŠžã‚’å?°åˆ·',0),(174776,4855,'pt','Seletor de ordem de impressÃ£o',0),(174777,4855,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¾Ð²Ñ‰Ð¸Ðº',0),(174778,4855,'es','Seleccionador de Orden de Orden de Imprimir',0),(174779,4855,'de','Print Order Picker',0),(174780,4855,'en','Print Order Picker',0),(174781,4856,'is','',0),(174782,4856,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ Ø´Ø¯Ù‡',0),(174783,4856,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ Ø´Ø¯Ù‡',0),(174784,4856,'tr','AlÄ±ntÄ±',0),(174785,4856,'pl','Cytowany',0),(174786,4856,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°',0),(174787,4856,'ur','Ú©Û’ Ø­ÙˆØ§Ù„Û’ Ø³Û’',0),(174788,4856,'sr','Ð Ð¿Ñ€ÐµÐ½Ð¾ÑÐ¸',0),(174789,4856,'vi','ÄÃ£ bÃ¡o giÃ¡',0),(174790,4856,'af','Gekwoteer',0),(174791,4856,'ro','Citat',0),(174792,4856,'et','Kommenteeritud',0),(174793,4856,'si','Citirane',0),(174794,4856,'ba','Dikutip',0),(174795,4856,'nl','Geciteerd',0),(174796,4856,'fi','Lainasi',0),(174797,4856,'no','Sitert',0),(174798,4856,'da','Citerede',0),(174799,4856,'ko','ì¸ìš©',0),(174800,4856,'he','×ž×¦×•×˜×˜',0),(174801,4856,'el','Î•Î¹ÏƒÎ·Î³Î¼Î­Î½ÎµÏ‚',0),(174802,4856,'zh','å¼•\r\n',0),(174803,4856,'sv','Citerade',0),(174804,4856,'it','Citato',0),(174805,4856,'tl','',0),(174806,4856,'th','&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3649;&#3621;&#3657;&#3623;',0),(174807,4856,'hi','à¤®à¥‡à¤‚ à¤‰à¤¦à¥à¤§à¥ƒà¤¤',0),(174808,4856,'ms','Disebut harga',0),(174809,4856,'ar','ÙˆÙ†Ù‚Ù„Øª Ø¹Ù†',0),(174810,4856,'fr','CitÃ©',0),(174811,4856,'jp','è¦‹ç©?ã‚‚ã‚Š',0),(174812,4856,'pt','Citado',0),(174813,4856,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€ÑƒÐµÑ‚ÑÑ',0),(174814,4856,'es','Cotizado',0),(174815,4856,'de','Zitiert',0),(174816,4856,'en','Quoted',0),(174817,4857,'is','',0),(174818,4857,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ Ø´Ø¯Ù‡',0),(174819,4857,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ Ø´Ø¯Ù‡',0),(174820,4857,'tr','TÄ±rnak iÅŸaretleri',0),(174821,4857,'pl','Cytaty',0),(174822,4857,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð¸',0),(174823,4857,'ur','ÙˆØ§ÙˆÛŒÙ†',0),(174824,4857,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ðµ',0),(174825,4857,'vi','BÃ¡o giÃ¡',0),(174826,4857,'af','Kwotasies',0),(174827,4857,'ro','Citate',0),(174828,4857,'et','Tsitaadid',0),(174829,4857,'si','Ponudbe',0),(174830,4857,'ba','Kutipan',0),(174831,4857,'nl','Citaten',0),(174832,4857,'fi','Lainauksia',0),(174833,4857,'no','Sitater',0),(174834,4857,'da','Citater',0),(174835,4857,'ko','ë”°ì˜´í‘œ',0),(174836,4857,'he','×”×¦×¢×•×ª ×ž×—×™×¨',0),(174837,4857,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(174838,4857,'zh','è¡Œæƒ…\r\n',0),(174839,4857,'sv','Citat',0),(174840,4857,'it','Citazioni',0),(174841,4857,'tl','',0),(174842,4857,'th','&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(174843,4857,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£',0),(174844,4857,'ms','Sebut harga',0),(174845,4857,'ar','Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(174846,4857,'fr','Citations',0),(174847,4857,'jp','è¦‹ç©?ã‚‚ã‚Š',0),(174848,4857,'pt','CotaÃ§Ãµes',0),(174849,4857,'ru','ÐšÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(174850,4857,'es','Cotizaciones',0),(174851,4857,'de','Zitate',0),(174852,4857,'en','Quotes',0),(174853,4858,'is','',0),(174854,4858,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø´Ø®ØµØ§Øª Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(174855,4858,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø´Ø®ØµØ§Øª Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(174856,4858,'tr','YazdÄ±rma sÄ±rasÄ±nÄ± arama Ã¶zellikleri seÃ§in',0),(174857,4858,'pl','Wybierz szczegÃ³Å‚y zlecenia druku Search',0),(174858,4858,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(174859,4858,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ ØªÙ„Ø§Ø´ Ú©Û’ Ù„Ø¦Û’ ÙˆØµÛŒØªÛŒÚº Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(174860,4858,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(174861,4858,'vi','Chá»n tÃ¬m Ä‘Æ¡n hÃ ng in',0),(174862,4858,'af','Kies spesifieke vir druk orde soek',0),(174863,4858,'ro','SelectaÅ£i specifice pentru comanda imprimare cÄƒutare',0),(174864,4858,'et','Valige spetsiifikast printimise jÃ¤rjekorras otsing',0),(174865,4858,'si','Izberite posebnosti za iskanje vrstni red tiskanja',0),(174866,4858,'ba','Pilih spesifik untuk Order cetak Cari',0),(174867,4858,'nl','Selecteer specificaties voor afdrukvolgorde zoeken',0),(174868,4858,'fi','Valitse yksityiskohtia tulostusjÃ¤rjestystÃ¤ haku',0),(174869,4858,'no','Velg detaljer for rekkefÃ¸lge sÃ¸k',0),(174870,4858,'da','VÃ¦lg detaljerne for udskriftsrÃ¦kkefÃ¸lgen sÃ¸gning',0),(174871,4858,'ko','ì¸ì‡„ ìˆœì„œ ê²€ìƒ‰ì— ëŒ€ í•œ êµ¬ì²´ì ì¸ ì„ íƒ',0),(174872,4858,'he','×‘×—×¨ ××ª ×”×¤×¨×˜×™× ×¢×‘×•×¨ ×—×™×¤×•×© ×¡×“×¨ ×”×”×“×¤×¡×”',0),(174873,4858,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(174874,4858,'zh','é€‰æ‹©ç‰¹å®šæ‰“å°è®¢å•æŸ¥è¯¢\r\n',0),(174875,4858,'sv','VÃ¤lj specifikt fÃ¶r utskriftsordning SÃ¶k',0),(174876,4858,'it','Selezionare specifiche per ordine di stampa ricerca',0),(174877,4858,'tl','',0),(174878,4858,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3632;&#3610;&#3640;&#3648;&#3614;&#3639;&#3656;&#3629;&#3588;&#3657;&#3609;&#3627;&#3634;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3',0),(174879,4858,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤–à¥‹à¤œ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(174880,4858,'ms','Pilih khusus untuk carian cetak',0),(174881,4858,'ar','Ø­Ø¯Ø¯ Ù…ÙˆØ§ØµÙØ§Øª Ù„Ø¨Ø­Ø« Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(174882,4858,'fr','SÃ©lectionnez les dÃ©tails pour la recherche de l\'ordre d\'impression',0),(174883,4858,'jp','å?°åˆ·æ³¨æ–‡æ¤œç´¢ã?®è©³ç´°é?¸æŠž',0),(174884,4858,'pt','Selecione detalhes para a pesquisa de ordem de impressÃ£o',0),(174885,4858,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾ÑÐ¾Ð±ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð»Ñ Ð¿Ð¾Ð¸ÑÐºÐ° Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(174886,4858,'es','Seleccionar EspecÃ­ficos para la Busqueda de Orden de ImpresiÃ³n',0),(174887,4858,'de','WÃ¤hlen Sie Besonderheiten fÃ¼r die Druckreihenfolge Suche',0),(174888,4858,'en','Select Specifics for Print Order Search',0),(174889,4859,'is','',0),(174890,4859,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ØªÙˆÙ„ÙŠØ¯ Ù…Ø¹Ø§Ø¯Ù„  ÙŠØ§ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø³Øª ',0),(174891,4859,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ØªÙˆÙ„ÙŠØ¯ Ù…Ø¹Ø§Ø¯Ù„  ÙŠØ§ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø³Øª ',0),(174892,4859,'tr','EÅŸit veya daha sonra daha bitiÅŸ tarihinden baÅŸlayarak oluÅŸturma tarihi olduÄŸunu',0),(174893,4859,'pl','Data utworzenia wyjÅ›cia jest rÃ³wna lub pÃ³Åºniej niÅ¼ data koÅ„cowa',0),(174894,4859,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ðµ Ñ€Ð°Ð²Ð½Ð° Ð½Ð° Ð¸Ð»Ð¸ Ð¿Ð¾-ÐºÑŠÑÐ½Ð¾ Ð¾Ñ‚ ÐºÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(174895,4859,'ur','Ø´Ø±ÙˆØ¹ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚ ØªØ§Ø±ÛŒØ® Ø¨Ø±Ø§Ø¨Ø± Ú©Ø±Ù†Ø§ ÛŒØ§ Ø¨Ø¹Ø¯ Ø§Ø²Ø§Úº Ù…Ù‚Ø§Ø¨Ù„Û’ Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® ÛÛ’ Û”',0),(174896,4859,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð°ÑÑ‚Ð°Ð½ÐºÐ° Ñ˜Ðµ Ñ˜ÐµÐ´Ð½Ð°Ðº Ð¸Ð»Ð¸ ÐºÐ°ÑÐ½Ð¸Ñ˜Ðµ Ð¾Ð´ Ñ‚Ñ…Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(174897,4859,'vi','NgÃ y báº¯t Ä‘áº§u táº¡o báº±ng hoáº·c muá»™n hÆ¡n ngÃ y káº¿t thÃºc',0),(174898,4859,'af','Die datum begin skepping is gelyk aan of Later as die eindig datum',0),(174899,4859,'ro','ÃŽncepÃ¢nd cu data creÄƒrii este egalÄƒ cu sau mai tÃ¢rziu decÃ¢t data de sfÃ¢rÅŸit',0),(174900,4859,'et','Loomise alguskuupÃ¤ev on vÃµrdne vÃµi hiljem kui the lÃµppkuupÃ¤ev',0),(174901,4859,'si','ZaÄetni datum nastanka je enaka ali kasneje kot the konÄni datum',0),(174902,4859,'ba','Mulai tanggal penciptaan adalah setara atau kemudian daripada the berakhir tanggal',0),(174903,4859,'nl','De aanmaakdatum beginnen is gelijk aan of hoger dan de einddatum',0),(174904,4859,'fi','Luominen Aloituspvm on tai myÃ¶hemmin kuin Lopetuspvm',0),(174905,4859,'no','Startdatoen for opprettelse er lik eller senere enn the sluttdatoen',0),(174906,4859,'da','Oprettelsesdato starter er lig med eller senere end den slutdato',0),(174907,4859,'ko','ì‹œìž‘ ìž‘ì„± ë‚ ì§œëŠ” ê°™ê±°ë‚˜ ë‚˜ì¤‘ ë³´ë‹¤ëŠ” ì¢…ë£Œ ë‚ ì§œ',0),(174908,4859,'he','×ª××¨×™×š ×™×¦×™×¨×” ×ž×ª×—×™×œ ×”×•× ×©×•×•×” ×œ××• ×ž××•×—×¨ ×™×•×ª×¨ ×ž××©×¨ ×”×¡×•×£ Date',0),(174909,4859,'el','Î— Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î—Î¼/Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ ÎµÎ¯Î½Î±Î¹ Î¯ÏƒÎ· Î® Î±ÏÎ³ÏŒÏ„ÎµÏÎ± Î±Ï€ÏŒ Ï„Î·Î½ Î—Î¼/Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(174910,4859,'zh','å¯åŠ¨åˆ›å»ºæ—¥æœŸç­‰äºŽæˆ–æ™šäºŽç»“æŸæ—¥æœŸ\r\n',0),(174911,4859,'sv','Startdatum fÃ¶r skapande Ã¤r lika med eller senare Ã¤n det slutdatum',0),(174912,4859,'it','La data di creazione di partenza Ã¨ uguale a o piÃ¹ tardi che la data finale',0),(174913,4859,'tl','',0),(174914,4859,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3619;&#3657;&#3634;&#3591;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3648;&#3607;&#3656;&#3634;&#3585;&#3633;&#3610;&#3627;&#3619;&#3639;&#3629;&#3627;&#3621;&#3633;&#3591;&#3592;&#3634;&#3',0),(174915,4859,'hi','à¤¬à¤°à¤¾à¤¬à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¾ à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚ à¤¸à¥‡ à¤­à¥€ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¨à¥‡ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¶à¥à¤°à¥‚ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¹à¥ˆ',0),(174916,4859,'ms','Bermula dari tarikh penciptaan adalah sama dengan atau kemudian daripada ini berakhir pada tarikh',0),(174917,4859,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡ Ù‡Ùˆ ÙŠØ³Ø§ÙˆÙŠ Ø£Ùˆ Ø¨Ø¹Ø¯ Ø°Ù„Ùƒ Ù…Ù† Ø¥Ù†Ù‡Ø§Ø¡ ØªØ§Ø±ÙŠØ®',0),(174918,4859,'fr','La Date de crÃ©ation de dÃ©but est Ã©gale ou plus tard que la Date fin',0),(174919,4859,'jp','ä½œæˆ?é–‹å§‹æ—¥ã?Œçµ‚äº†æ—¥ã?¨å?Œã?˜ã?‹ã??ã‚Œã‚ˆã‚Šå¾Œã?§ã?™ã€‚',0),(174920,4859,'pt','A data de criaÃ§Ã£o inicial Ã© igual ou mais tarde do que a \' data final \'',0),(174921,4859,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ñ€Ð°Ð²Ð½Ñ‹Ð¼ Ð¸Ð»Ð¸ Ð¿Ð¾Ð·Ð¶Ðµ Ñ‡ÐµÐ¼ Ð´Ð°Ñ‚Ð° ÐºÐ¾Ð½Ñ†Ð°',0),(174922,4859,'es','La Fecha de Inicio de la CreaciÃ³n es Igual a o MÃ¡s Tarde que la Fecha de TerminaciÃ³n',0),(174923,4859,'de','Das Erstellungsdatum beginnend ist gleich oder hÃ¶her als das Enddatum',0),(174924,4859,'en','The Starting Creation Date is Equal to or Later Than the Ending Date',0),(174925,4860,'is','',0),(174926,4860,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø³Ø±Ø±Ø³ÙŠØ¯ Ù…Ø¹Ø§Ø¯Ù„ ÙŠØ§ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø³Øª ',0),(174927,4860,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø³Ø±Ø±Ø³ÙŠØ¯ Ù…Ø¹Ø§Ø¯Ù„ ÙŠØ§ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø³Øª ',0),(174928,4860,'tr','EÅŸit veya daha sonra daha bitiÅŸ tarihi vade baÅŸlangÄ±Ã§ olduÄŸunu',0),(174929,4860,'pl','PoczÄ…wszy od terminu wymagalnoÅ›ci jest rÃ³wna lub pÃ³Åºniej niÅ¼ data koÅ„cowa',0),(174930,4860,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶ Ðµ Ñ€Ð°Ð²ÐµÐ½ Ð½Ð° Ð¸Ð»Ð¸ Ð¿Ð¾-ÐºÑŠÑÐ½Ð¾ Ð¾Ñ‚ ÐºÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(174931,4860,'ur','Ø´Ø±ÙˆØ¹ Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ ØªØ§Ø±ÛŒØ® Ú©Û’ Ù…Ø³Ø§ÙˆÛŒ ÛŒØ§ Ø¨Ø¹Ø¯ Ø§Ø²Ø§Úº Ù…Ù‚Ø§Ø¨Ù„Û’ Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® ÛÛ’ Û”',0),(174932,4860,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ Ñ˜ÐµÐ´Ð½Ð°Ðº Ð¸Ð»Ð¸ ÐºÐ°ÑÐ½Ð¸Ñ˜Ðµ Ð¾Ð´ Ñ‚Ñ…Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(174933,4860,'vi','NgÃ y báº¯t Ä‘áº§u Ä‘áº¿n háº¡n báº±ng hoáº·c muá»™n hÆ¡n ngÃ y káº¿t thÃºc',0),(174934,4860,'af','Die begin sperdatum is gelyk aan of Later as die eindig datum',0),(174935,4860,'ro','ÃŽncepÃ¢nd cu data scadenÅ£ei este egalÄƒ cu sau mai tÃ¢rziu decÃ¢t data de sfÃ¢rÅŸit',0),(174936,4860,'et','Algab tÃ¤htaeg on vÃµrdne vÃµi hiljem kui the lÃµppkuupÃ¤ev',0),(174937,4860,'si','ZaÄetni datum zapadlosti je enak ali kasneje kot the konÄni datum',0),(174938,4860,'ba','Mulai tanggal jatuh tempo adalah setara atau kemudian daripada the berakhir tanggal',0),(174939,4860,'nl','De beginnen vervaldatum is gelijk aan of hoger dan de einddatum',0),(174940,4860,'fi','Alkaen erÃ¤pÃ¤ivÃ¤ on myÃ¶hemmin kuin Lopetuspvm tai',0),(174941,4860,'no','Starter forfallsdatoen er lik eller senere enn the sluttdatoen',0),(174942,4860,'da','Due startdato er lig med eller senere end den slutdato',0),(174943,4860,'ko','ì‹œìž‘ ì˜ˆì • ë‚ ì§œëŠ” ê°™ê±°ë‚˜ ë‚˜ì¤‘ ë³´ë‹¤ëŠ” ì¢…ë£Œ ë‚ ì§œ',0),(174944,4860,'he','×ª××¨×™×š ×”×™×¢×“ ×”×—×œ ×”×•× ×©×•×•×” ×œ××• ×ž××•×—×¨ ×™×•×ª×¨ ×ž××©×¨ ×”×¡×•×£ Date',0),(174945,4860,'el','Î— Î¿Ï†ÎµÎ¹Î»ÏŒÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ ÎµÎ¯Î½Î±Î¹ Î¯ÏƒÎ· Î® Î±ÏÎ³ÏŒÏ„ÎµÏÎ± Î±Ï€ÏŒ Ï„Î·Î½ Î—Î¼/Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(174946,4860,'zh','å¯åŠ¨æˆªæ­¢æ—¥æœŸç­‰äºŽæˆ–æ™šäºŽç»“æŸæ—¥æœŸ\r\n',0),(174947,4860,'sv','Start fÃ¶rfallodatum Ã¤r lika med eller senare Ã¤n det slutdatum',0),(174948,4860,'it','La data di partenza Ã¨ uguale a o piÃ¹ tardi che la data finale',0),(174949,4860,'tl','',0),(174950,4860,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3623;&#3633;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3588;&#3639;&#3629; &#3648;&#3607;&#3656;&#3634;&#3585;&#3633;&#3610;&#3627;&#3619;&#3639;&#3629;&#3627;&#3621;&#3633;&#3591;&#3592;&#3634;&#',0),(174951,4860,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤‰à¤¸ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤¬à¤°à¤¾à¤¬à¤° à¤¯à¤¾ à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚ à¤¸à¥‡ à¤­à¥€ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¨à¥‡ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¹à¥ˆ',0),(174952,4860,'ms','Bermula tarikh adalah sama dengan atau kemudian daripada ini berakhir pada tarikh',0),(174953,4860,'ar','Ø§Ø¨ØªØ¯Ø§Ø¡ Ù…Ù† ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ù‡Ùˆ ÙŠØ³Ø§ÙˆÙŠ Ø£Ùˆ Ø¨Ø¹Ø¯ Ø°Ù„Ùƒ Ù…Ù† Ø¥Ù†Ù‡Ø§Ø¡ ØªØ§Ø±ÙŠØ®',0),(174954,4860,'fr','La Date limite de dÃ©part est Ã©gal ou plus tard que la Date fin',0),(174955,4860,'jp','æœŸé™?é–‹å§‹æ—¥ã?Œçµ‚äº†æ—¥ã?¨å?Œã?˜ã?‹ã??ã‚Œã‚ˆã‚Šå¾Œã?§ã?™ã€‚',0),(174956,4860,'pt','A data de vencimento comeÃ§ando Ã© igual ou mais tarde do que a \' data final \'',0),(174957,4860,'ru','Ð”Ð°Ñ‚Ð¾Ð¹ Ð½Ð°Ñ‡Ð°Ð»Ð° ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ñ€Ð°Ð²Ð½Ñ‹Ð¼ Ð¸Ð»Ð¸ Ð¿Ð¾Ð·Ð¶Ðµ Ñ‡ÐµÐ¼ Ð´Ð°Ñ‚Ð° ÐºÐ¾Ð½Ñ†Ð°',0),(174958,4860,'es','La Fecha de Inicio de Deuda es Igual a o MÃ¡s Tarde que la Fecha de TerminaciÃ³n',0),(174959,4860,'de','Start Termin ist gleich oder hÃ¶her als das Enddatum',0),(174960,4860,'en','The Starting Due Date is Equal to or Later Than the Ending Date',0),(174961,4861,'is','',0),(174962,4861,'dr','ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(174963,4861,'pr','ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(174964,4861,'tr','Teyit edilmemiÅŸ',0),(174965,4861,'pl','Niepotwierdzone',0),(174966,4861,'bg','ÐÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð°',0),(174967,4861,'ur','ØºÛŒØ± Ù…ØµØ¯Ù‚Û',0),(174968,4861,'sr','ÐÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ðµ',0),(174969,4861,'vi','KhÃ´ng xÃ¡c nháº­n',0),(174970,4861,'af','Onbevestigend',0),(174971,4861,'ro','Neconfirmate',0),(174972,4861,'et','Kinnitamata',0),(174973,4861,'si','Nepotrjena',0),(174974,4861,'ba','Belum dikonfirmasi',0),(174975,4861,'nl','Onbevestigde',0),(174976,4861,'fi','Vahvistamaton',0),(174977,4861,'no','Ubekreftet',0),(174978,4861,'da','UbekrÃ¦ftet',0),(174979,4861,'ko','ë¯¸í™•ì¸',0),(174980,4861,'he','×œ× ×ž××•×©×¨',0),(174981,4861,'el','Î‘Î½ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰Ï„ÎµÏ‚',0),(174982,4861,'zh','æœªç¡®è®¤\r\n',0),(174983,4861,'sv','ObekrÃ¤ftade',0),(174984,4861,'it','Non confermato',0),(174985,4861,'tl','',0),(174986,4861,'th','&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(174987,4861,'hi','à¤…à¤ªà¥à¤·à¥à¤Ÿ',0),(174988,4861,'ms','Belum disahkan',0),(174989,4861,'ar','ØºÙŠØ± Ù…Ø¤ÙƒÙ‘Ø¯',0),(174990,4861,'fr','Non confirmÃ©es',0),(174991,4861,'jp','æœªç¢ºèª?',0),(174992,4861,'pt','NÃ£o confirmados',0),(174993,4861,'ru','ÐÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ð¹',0),(174994,4861,'es','No Confirmado',0),(174995,4861,'de','UnbestÃ¤tigte',0),(174996,4861,'en','Unconfirmed',0),(174997,4862,'is','',0),(174998,4862,'dr','ÙƒØ§Ù„Ø§ Ø§ØµÙ„Ø§Ø­ Ø´Ø¯ ',0),(174999,4862,'pr','ÙƒØ§Ù„Ø§ Ø§ØµÙ„Ø§Ø­ Ø´Ø¯ ',0),(175000,4862,'tr','Maddesi dÃ¼zeltilmiÅŸ',0),(175001,4862,'pl','Element dostosowane',0),(175002,4862,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ»Ð° ÐºÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ð¾',0),(175003,4862,'ur','Ø´Û’ Ú©Ùˆ Ø§ÛŒÚˆØ¬Ø³Ù¹',0),(175004,4862,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ»Ð° ÐºÐ¾Ñ€Ð¸Ð³Ð¾Ð²Ð°Ð½.',0),(175005,4862,'vi','Chá»‰nh hÃ ng',0),(175006,4862,'af','Item Aangepas',0),(175007,4862,'ro','Elementul ajustat',0),(175008,4862,'et','Tode kohandatud',0),(175009,4862,'si','Prilagojeni element',0),(175010,4862,'ba','Item disesuaikan',0),(175011,4862,'nl','Item aangepast',0),(175012,4862,'fi','Kohdetta muutetaan',0),(175013,4862,'no','Elementet justert',0),(175014,4862,'da','Element justeret',0),(175015,4862,'ko','í•­ëª© ì¡°ì •',0),(175016,4862,'he','×¤×¨×™×˜ ×ž×•×ª××',0),(175017,4862,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(175018,4862,'zh','é¡¹ç›®è°ƒæ•´\r\n',0),(175019,4862,'sv','Objektet justeras',0),(175020,4862,'it','Elemento regolato',0),(175021,4862,'tl','',0),(175022,4862,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3621;&#3657;&#3623;',0),(175023,4862,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤',0),(175024,4862,'ms','Item yang diselaraskan',0),(175025,4862,'ar','ÙŠØ¹Ø¯Ù„ Ø§Ù„Ø¨Ù†Ø¯',0),(175026,4862,'fr','Point ajustÃ©',0),(175027,4862,'jp','èª¿æ•´æ¸ˆå“?ç›®',0),(175028,4862,'pt','Item ajustado',0),(175029,4862,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÑÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½',0),(175030,4862,'es','Item ajustado',0),(175031,4862,'de','Element angepasst',0),(175032,4862,'en','Item Adjusted',0),(175033,4863,'is','',0),(175034,4863,'dr','Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(175035,4863,'pr','Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(175036,4863,'tr','Stok sipariÅŸi seÃ§im listesi',0),(175037,4863,'pl','Spis kolejnoÅ›ci wyboru',0),(175038,4863,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€ Ð½Ð° Ñ€ÐµÐ´ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(175039,4863,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¢Ø±ÚˆØ± Ù¾Ø§Ú©Ù„Ø§Ø³Ù¹',0),(175040,4863,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¸Ð·Ð±Ð¾Ñ€Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(175041,4863,'vi','Danh SÃ¡ch HÃ ng Chá»n Theo ÄÆ¡n HÃ ng',0),(175042,4863,'af','Voorraad bestelling Picklist',0),(175043,4863,'ro','Inventarul ordine listÄƒ verticalÄƒ',0),(175044,4863,'et','Varude tootmisjÃ¤rjekorra',0),(175045,4863,'si','Seznam aktualnih podatkov za popis nalog',0),(175046,4863,'ba','Persediaan urutan Picklist',0),(175047,4863,'nl','Inventaris volgorde selectielijst',0),(175048,4863,'fi','Luettelo valmistustilauksen kerÃ¤ilyluettelossa',0),(175049,4863,'no','Lager ordren valglisten',0),(175050,4863,'da','Lageret ordre valgliste',0),(175051,4863,'ko','ìž¬ê³  ìˆœì„œ ì„ íƒ ëª©ë¡',0),(175052,4863,'he','×ž×œ××™ ×¡×“×¨ ×¨×©×™×ž×ª ×‘×—×™×¨×”',0),(175053,4863,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® ÏƒÎµÎ¹ÏÎ¬ Î»Î¯ÏƒÏ„Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(175054,4863,'zh','åº“å­˜è®¢å•é€‰å–åˆ—è¡¨\r\n',0),(175055,4863,'sv','Inventering fÃ¶r urvalslista',0),(175056,4863,'it','Inventario ordine dell\'elenco a discesa',0),(175057,4863,'tl','',0),(175058,4863,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(175059,4863,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤¦à¥‡à¤¶ à¤šà¤¯à¤¨à¤¸à¥‚à¤šà¥€',0),(175060,4863,'ms','Picklist perintah inventori',0),(175061,4863,'ar','Ø§Ù†ØªÙ‚Ø§Ø¡ Ø£Ù…Ø± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(175062,4863,'fr','L\'inventaire ordre liste de choix',0),(175063,4863,'jp','åœ¨åº«æ³¨æ–‡å€™ãƒªã‚¹ãƒˆ',0),(175064,4863,'pt','Lista de seleÃ§Ã£o ordem de inventÃ¡rio',0),(175065,4863,'ru','ÐŸÐ¾Ð»Ðµ Ð²Ñ‹Ð±Ð¾Ñ€Ð° Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(175066,4863,'es','Orden de Inventario Lista de SelecciÃ³n',0),(175067,4863,'de','Inventar-Bestellung-Auswahlliste',0),(175068,4863,'en','Inventory Order Pick List',0),(175069,4864,'is','',0),(175070,4864,'dr','NrØ´Ù…Ø§Ø±Ù‡  ',0),(175071,4864,'pr','NrØ´Ù…Ø§Ø±Ù‡  ',0),(175072,4864,'tr','Nr',0),(175073,4864,'pl','Nr',0),(175074,4864,'bg','ÐÐŸ',0),(175075,4864,'ur','Ø§ÛŒÙ† Ø¢Ø±',0),(175076,4864,'sr','ÐÐ ',0),(175077,4864,'vi','Sá»‘',0),(175078,4864,'af','Nr',0),(175079,4864,'ro','Nr',0),(175080,4864,'et','Nr',0),(175081,4864,'si','Nr',0),(175082,4864,'ba','Nr',0),(175083,4864,'nl','Nr',0),(175084,4864,'fi','Nr',0),(175085,4864,'no','Nr',0),(175086,4864,'da','NN',0),(175087,4864,'ko','Nr',0),(175088,4864,'he','×¢ × ',0),(175089,4864,'el','NR',0),(175090,4864,'zh','ä¸Šåˆåæ—¶åäº”åˆ†\r\n',0),(175091,4864,'sv','Nr',0),(175092,4864,'it','Nr',0),(175093,4864,'tl','',0),(175094,4864,'th','&#3592;&#3635;&#3609;&#3623;&#3609;',0),(175095,4864,'hi','à¤à¤¨. à¤†à¤°.',0),(175096,4864,'ms','NR',0),(175097,4864,'ar','Nr',0),(175098,4864,'fr','Nr',0),(175099,4864,'jp','Nr',0),(175100,4864,'pt','NR',0),(175101,4864,'ru','Nr',0),(175102,4864,'es','Nmro.',0),(175103,4864,'de','Nr.',0),(175104,4864,'en','Nr',0),(175105,4865,'is','',0),(175106,4865,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(175107,4865,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(175108,4865,'tr','SipariÅŸ notlarÄ±',0),(175109,4865,'pl','ZamÃ³wienie notatki',0),(175110,4865,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(175111,4865,'ur','Ø¢Ø±ÚˆØ± Ù†ÙˆÙ¹',0),(175112,4865,'sr','Ð ÐµÐ´ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(175113,4865,'vi','Ghi chÃº Ä‘Æ¡n hÃ ng',0),(175114,4865,'af','Bestellingsnota\'s',0),(175115,4865,'ro','Note de comandÄƒ',0),(175116,4865,'et','Tellimuse mÃ¤rkused',0),(175117,4865,'si','Naloga ugotavlja',0),(175118,4865,'ba','Urutan catatan',0),(175119,4865,'nl','Volgorde notities',0),(175120,4865,'fi','Tilaa Notes',0),(175121,4865,'no','For notater',0),(175122,4865,'da','Bestil noter',0),(175123,4865,'ko','ì£¼ë¬¸ ë©”ëª¨',0),(175124,4865,'he','×”×¢×¨×•×ª',0),(175125,4865,'el','Î£ÎµÎ¹ÏÎ¬ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(175126,4865,'zh','è®¢è´­è¯´æ˜Ž\r\n',0),(175127,4865,'sv','BestÃ¤ll Noter',0),(175128,4865,'it','Note di ordine',0),(175129,4865,'tl','',0),(175130,4865,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(175131,4865,'hi','à¤†à¤¦à¥‡à¤¶ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(175132,4865,'ms','Nota-Nota pesanan',0),(175133,4865,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(175134,4865,'fr','Informations sur la commande',0),(175135,4865,'jp','æ³¨æ–‡ãƒ¡ãƒ¢',0),(175136,4865,'pt','Notas de fim',0),(175137,4865,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸ Ð—Ð°ÐºÐ°Ð·Ð°',0),(175138,4865,'es','Notas de Ordenes',0),(175139,4865,'de','Bestellung-Notes',0),(175140,4865,'en','Order Notes',0),(175141,4866,'is','',0),(175142,4866,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø³Ø·Ø± ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(175143,4866,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³Ø·Ø± ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(175144,4866,'tr','Toplam satÄ±r Ã¶ÄŸeleri Ã¼zerinde sipariÅŸ numarasÄ±',0),(175145,4866,'pl','CaÅ‚kowita pozycje na numer zamÃ³wienia',0),(175146,4866,'bg','ÐžÐ±Ñ‰Ð¸Ñ‚Ðµ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ð½Ð° Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(175147,4866,'ur','Ú©Ù„ Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§Ø¡ Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ù¾Ø±',0),(175148,4866,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð½Ð° Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(175149,4866,'vi','Táº¥t cáº£ cÃ¡c danh má»¥c trÃªn Ä‘Æ¡n hÃ ng nÃ y',0),(175150,4866,'af','Totale Lynitems vir \'n Bestellingnommer',0),(175151,4866,'ro','Total elemente pe numÄƒrul de ordine',0),(175152,4866,'et','Kokku kirjeid jÃ¤rjekorranumber',0),(175153,4866,'si','Skupne postavke na zaporedno Å¡tevilko',0),(175154,4866,'ba','Total item baris pada nomor pesanan',0),(175155,4866,'nl','Totale regelitems op bestelnummer',0),(175156,4866,'fi','YhteensÃ¤ eriÃ¤ on tilausnumero',0),(175157,4866,'no','Totalt linjeelementene pÃ¥ nummeret',0),(175158,4866,'da','Samlede linjeelementer pÃ¥ ordrenummeret',0),(175159,4866,'ko','ì£¼ë¬¸ ë²ˆí˜¸ì— ì´ í’ˆëª©',0),(175160,4866,'he','×¡×” ×› ×¤×¨×™×˜×™× ×§×• ×¢×œ ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(175161,4866,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î· Î±ÏÎ¹Î¸Î¼Î¿Ï',0),(175162,4866,'zh','æ€»è®¡è®¢å•å·ä¸Šçš„è¡Œé¡¹ç›®\r\n',0),(175163,4866,'sv','Totala poster pÃ¥ ordernummer',0),(175164,4866,'it','Totale elementi pubblicitari sul numero d\'ordine',0),(175165,4866,'tl','',0),(175166,4866,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3',0),(175167,4866,'hi','à¤•à¥à¤² à¤°à¥‡à¤–à¤¾ à¤†à¤‡à¤Ÿà¤® à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤°',0),(175168,4866,'ms','Jumlah talian item pada nombor pesanan',0),(175169,4866,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø³Ø·Ø± ÙÙŠ Ø±Ù‚Ù… Ø§Ù„ØªØ±ØªÙŠØ¨',0),(175170,4866,'fr','Total des rubriques sur le numÃ©ro de commande',0),(175171,4866,'jp','æ³¨æ–‡ç•ªå?·ä¸Šã?®å“?ç›®å??å?ˆè¨ˆ',0),(175172,4866,'pt','Total de itens de linha na ordem nÃºmero',0),(175173,4866,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¹ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(175174,4866,'es','Total Items de linea en el NÃºmero de Orden',0),(175175,4866,'de','Summe Einzelposten auf Bestellnummer',0),(175176,4866,'en','Total Line Items on Order Number',0),(175177,4867,'is','',0),(175178,4867,'dr','(Ø§Ø±Ø³Ø§Ù„',0),(175179,4867,'pr','Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ (Ø§Ø±Ø³Ø§Ù„',0),(175180,4867,'tr','Gemi iÃ§in',0),(175181,4867,'pl','Na statku',0),(175182,4867,'bg','Ð—Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(175183,4867,'ur','Ú©Ø´ØªÛŒ Ù¾Ø±',0),(175184,4867,'sr','ÐÐ° Ð±Ñ€Ð¾Ð´',0),(175185,4867,'vi','Chuyá»ƒn Ä‘áº¿n',0),(175186,4867,'af','Om te Versend',0),(175187,4867,'ro','A navei',0),(175188,4867,'et','Laevale',0),(175189,4867,'si','Za ladje',0),(175190,4867,'ba','Untuk kapal',0),(175191,4867,'nl','Om het schip',0),(175192,4867,'fi','Aluksen',0),(175193,4867,'no','Sende',0),(175194,4867,'da','Til skib',0),(175195,4867,'ko','ë°°ë¥¼',0),(175196,4867,'he','×œ×¡×¤×™× ×”',0),(175197,4867,'el','Î Î»Î¿Î¯Î¿',0),(175198,4867,'zh','å‘è¿\r\n',0),(175199,4867,'sv','Att fartyget',0),(175200,4867,'it','A nave',0),(175201,4867,'tl','',0),(175202,4867,'th','&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(175203,4867,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(175204,4867,'ms','Ke kapal',0),(175205,4867,'ar','Ù„Ù„Ø³ÙÙŠÙ†Ø©',0),(175206,4867,'fr','Pour expÃ©dier',0),(175207,4867,'jp','ç™ºé€?',0),(175208,4867,'pt','A nave',0),(175209,4867,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(175210,4867,'es','Para Enviar',0),(175211,4867,'de','Schiff',0),(175212,4867,'en','To Ship',0),(175213,4868,'is','',0),(175214,4868,'dr','1',0),(175215,4868,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´   1',0),(175216,4868,'tr','SipariÅŸ miktarÄ± #1',0),(175217,4868,'pl','IloÅ›Ä‡ zamÃ³wienia #1',0),(175218,4868,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° #1',0),(175219,4868,'ur','#1 Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©Ø§ Ø¢Ø±ÚˆØ±',0),(175220,4868,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ð° #1',0),(175221,4868,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n hÃ ng sá»‘ 1',0),(175222,4868,'af','Bestellingseenheid #1',0),(175223,4868,'ro','Cantitate comandÄƒ #1',0),(175224,4868,'et','Tellimuse kogus #1',0),(175225,4868,'si','KoliÄina naloga #1',0),(175226,4868,'ba','Kuantitas order #1',0),(175227,4868,'nl','Orderaantal #1',0),(175228,4868,'fi','MÃ¤Ã¤rÃ¤ #1',0),(175229,4868,'no','Antallet #1',0),(175230,4868,'da','Ordreantallet #1',0),(175231,4868,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰ #1',0),(175232,4868,'he','×›×ž×•×ª ×”×–×ž× ×” #1',0),(175233,4868,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ #1',0),(175234,4868,'zh','è®¢è´­æ•°é‡ï¼ƒ1\r\n',0),(175235,4868,'sv','Orderkvantiteten #1',0),(175236,4868,'it','QuantitÃ  di ordine #1',0),(175237,4868,'tl','',0),(175238,4868,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3591;&#3634;&#3609;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586; 1',0),(175239,4868,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾ #1',0),(175240,4868,'ms','Kuantiti pesanan #1',0),(175241,4868,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ø£Ù…Ø± #1',0),(175242,4868,'fr','QuantitÃ© d\'ordre #1',0),(175243,4868,'jp','æ³¨æ–‡æ•°é‡?ï¼‘ç•ª',0),(175244,4868,'pt','Quantidade de ordem #1',0),(175245,4868,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð—Ð°ÐºÐ°Ð·Ð° #1',0),(175246,4868,'es','Cantidad de Ordenes #1',0),(175247,4868,'de','Bestellmenge #1',0),(175248,4868,'en','Order Quantity #1',0),(175249,4869,'is','',0),(175250,4869,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ  Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(175251,4869,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ  Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(175252,4869,'tr','Yeni teklifler',0),(175253,4869,'pl','Nowe Cytaty',0),(175254,4869,'bg','ÐÐ¾Ð²Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(175255,4869,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª',0),(175256,4869,'sr','ÐÐ¾Ð²Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(175257,4869,'vi','BÃ¡o giÃ¡ má»›i',0),(175258,4869,'af','Nuwe Kwotasies',0),(175259,4869,'ro','Noua citate',0),(175260,4869,'et','Uued tsitaadid',0),(175261,4869,'si','Nove ponudbe',0),(175262,4869,'ba','Tanda kutip baru',0),(175263,4869,'nl','Nieuwe Quotes',0),(175264,4869,'fi','Uusia lainauksia',0),(175265,4869,'no','Nye tilbud',0),(175266,4869,'da','Nye citater',0),(175267,4869,'ko','ìƒˆë¡œìš´ ë”°ì˜´í‘œ',0),(175268,4869,'he','×”×¦×¢×•×ª ×ž×—×™×¨ ×—×“×©×•×ª',0),(175269,4869,'el','ÎÎ­ÎµÏ‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ­Ï‚',0),(175270,4869,'zh','æ–°æŠ¥ä»·\r\n',0),(175271,4869,'sv','Nya citat',0),(175272,4869,'it','Nuove citazioni',0),(175273,4869,'tl','',0),(175274,4869,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(175275,4869,'hi','à¤¨à¤ˆ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(175276,4869,'ms','Sebut harga yang baru',0),(175277,4869,'ar','Ø¹Ø±ÙˆØ¶ Ù…Ø¨Ø¯Ø¦ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(175278,4869,'fr','Nouvelles citations',0),(175279,4869,'jp','æ–°è¦?è¦‹ç©?ã‚‚ã‚Š',0),(175280,4869,'pt','Novas citaÃ§Ãµes',0),(175281,4869,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(175282,4869,'es','Nuevos Cotizaciones',0),(175283,4869,'de','Neue Zitate',0),(175284,4869,'en','New Quotes',0),(175285,4870,'is','',0),(175286,4870,'dr','ÙƒÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ Ùˆ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(175287,4870,'pr','ÙƒÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ Ùˆ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(175288,4870,'tr','DoÄŸrulanmamÄ±ÅŸ toplam<br>ve Hold On emir',0),(175289,4870,'pl','Sumie niepotwierdzone<br>i zamÃ³wieÅ„ wstrzymane',0),(175290,4870,'bg','ÐžÐ±Ñ‰Ð¾ Ð½ÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¸<br>Ð¸ Ð¿Ð¾ Ð½Ð¸ÑÐºÐ° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(175291,4870,'ur','ØºÛŒØ± Ù…ØµØ¯Ù‚Û Ú©Ù„<br>Ø§ÙˆØ± Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± ÛÙˆÙ„Úˆ',0),(175292,4870,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð½ÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ðµ<br>Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(175293,4870,'vi','Táº¥t cáº£ cÃ¡c Ä‘Æ¡n hÃ ng chÆ°a xÃ¡c nháº­n vÃ  táº¡m ngÆ°ng',0),(175294,4870,'af','Totale Nie-Bevestigde<br> en On-Hold Bestellings',0),(175295,4870,'ro','Total neconfirmate<br>ÅŸi pe-Hold comenzi',0),(175296,4870,'et','Kinnitamata kokku<br>ja ootel tellimused',0),(175297,4870,'si','Skupno nepotrjeno<br>in oddana naroÄila',0),(175298,4870,'ba','Total yang belum dikonfirmasi<br>dan perintah tahan',0),(175299,4870,'nl','Totaal onbevestigde<br>en On-Hold Orders',0),(175300,4870,'fi','YhteensÃ¤ vahvistamaton<br>PidÃ¤ tilaukset',0),(175301,4870,'no','Totalt ubekreftet<br>og pÃ¥ Hold ordrer',0),(175302,4870,'da','Total ubekrÃ¦ftet<br>og pÃ¥ Hold ordrer',0),(175303,4870,'ko','ì´ ë¯¸í™•ì¸<br>ê·¸ë¦¬ê³  ëŒ€ê¸° ì£¼ë¬¸',0),(175304,4870,'he','×¡×” ×› ×œ× ×ž××•×©×¨×™×.<br>×•×”×—×–×§ ×¢×œ-×”×–×ž× ×•×ª',0),(175305,4870,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î±Î½ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰Ï„ÎµÏ‚<br>ÎºÎ±Î¹ On-Hold Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(175306,4870,'zh','å…±æœ‰æœªç¡®è®¤çš„å’ŒæŒåº“è®¢å•\r\n',0),(175307,4870,'sv','Totalt obekrÃ¤ftade<br>och spÃ¤rrade order',0),(175308,4870,'it','Totale non confermato<br>e gli ordini in sospeso',0),(175309,4870,'tl','',0),(175310,4870,'th','&#3607;&#3633;&#3657;&#3591;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;<br>&#3649;&#3621;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3648;&#3592;&#3657;&#3634',0),(175311,4870,'hi','à¤•à¥à¤² à¤…à¤ªà¥à¤·à¥à¤Ÿ<br>à¤”à¤° à¤ªà¤•à¤¡à¤¼ à¤ªà¤° à¤†à¤¦à¥‡à¤¶',0),(175312,4870,'ms','Jumlah yang belum disahkan<br>dan arahan pada mengadakan',0),(175313,4870,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ ØºÙŠØ± Ù…Ø¤ÙƒØ¯Ø©<br>ÙˆØ£ÙˆØ§Ù…Ø± ÙÙŠ Ø§Ù„Ø§Ù†ØªØ¸Ø§Ø±',0),(175314,4870,'fr','Total non confirmÃ©<br>et les commandes en attente',0),(175315,4870,'jp','æœªç¢ºèª?ã?®å?ˆè¨ˆ<br>ã?¨ä¿?ç•™æ³¨æ–‡',0),(175316,4870,'pt','Total confirmado<br>e as ordens em espera',0),(175317,4870,'ru','Ð’ÑÐµÐ³Ð¾ Ð½ÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ<br>Ð¸ Ð½Ð° Ð”ÐµÑ€Ð¶Ð¸Ñ‚Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(175318,4870,'es','Total No Confirmado<br> y Ordenes En-Reserva',0),(175319,4870,'de','Insgesamt unbestÃ¤tigt<br>und On-Hold-AuftrÃ¤ge',0),(175320,4870,'en','Total Unconfirmed<br> and On-Hold Orders',0),(175321,4871,'is','',0),(175322,4871,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(175323,4871,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(175324,4871,'tr','Bunu silmek istediÄŸinizden emin misiniz?',0),(175325,4871,'pl','Czy na pewno chcesz usunÄ…Ä‡?',0),(175326,4871,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ‚Ð¾Ð²Ð°?',0),(175327,4871,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ÛŒÛ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(175328,4871,'sr','Ð”Ð° Ð»Ð¸ ÑÑ‚Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ð¾Ð²Ð¾?',0),(175329,4871,'vi','Muá»‘n xÃ³a?',0),(175330,4871,'af','Is u seker u wil hierdie skrap?',0),(175331,4871,'ro','Sunteti sigur ca vreti sa stergeti?',0),(175332,4871,'et','Oled kindel, et soovid seda kustutada?',0),(175333,4871,'si','Ali ste prepriÄani, da Å¾elite izbrisati to?',0),(175334,4871,'ba','Apakah Anda yakin Anda ingin menghapus ini?',0),(175335,4871,'nl','Weet u zeker dat u wilt verwijderen van dit?',0),(175336,4871,'fi','Haluatko varmasti poistaa tÃ¤mÃ¤n?',0),(175337,4871,'no','Er du sikker pÃ¥ at du vil slette denne?',0),(175338,4871,'da','Er du sikker pÃ¥ du vil slette denne?',0),(175339,4871,'ko','ë‹¹ì‹ ì€ ì´ê²ƒì„ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(175340,4871,'he','?×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ××ª ×–×”',0),(175341,4871,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒ;',0),(175342,4871,'zh','ä½ ç¡®å®šè¦åˆ é™¤å®ƒï¼Ÿ\r\n',0),(175343,4871,'sv','Ã„r du sÃ¤ker du vill ta bort detta?',0),(175344,4871,'it','Sei sicuro di che voler cancellare questo?',0),(175345,4871,'tl','',0),(175346,4871,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(175347,4871,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(175348,4871,'ms','Adakah anda pasti hendak menghapuskan ini?',0),(175349,4871,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ø£Ù†Ùƒ ØªØ±Ø¨Ø¯ Ø­Ø°Ù Ù‡Ø°Ø§ ØŸ',0),(175350,4871,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer cet Ã©lÃ©ment ?',0),(175351,4871,'jp','ã?“ã‚Œã‚’æ¶ˆåŽ»ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(175352,4871,'pt','Tem certeza que deseja excluir este?',0),(175353,4871,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹ Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑÑ‚Ð¾ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ?',0),(175354,4871,'es','Â¿Esta seguro que quiere eliminar Ã©ste?',0),(175355,4871,'de','Bist du sicher, dass Sie diese lÃ¶schen mÃ¶chten?',0),(175356,4871,'en','Are you sure you want to delete this?',0),(175357,4872,'is','',0),(175358,4872,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹ÙˆÙ‚ ',0),(175359,4872,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹ÙˆÙ‚ ',0),(175360,4872,'tr','Bekleyen emir rapor',0),(175361,4872,'pl','Raport zleceÅ„ oczekujÄ…cych',0),(175362,4872,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð·Ð° Ð¾Ñ‚Ð»Ð¾Ð¶ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(175363,4872,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(175364,4872,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(175365,4872,'vi','BÃ¡o cÃ¡o Ä‘Æ¡n hÃ ng chÆ°a lÃ m',0),(175366,4872,'af','Afwagtende Bestellingsverslag',0),(175367,4872,'ro','Raport de ordinele Ã®n aÈ™teptare',0),(175368,4872,'et','Ootel arvete aruanne',0),(175369,4872,'si','ÄŒakajoÄa naroÄila poroÄilo',0),(175370,4872,'ba','Laporan pending order',0),(175371,4872,'nl','Onverwerkte bestellingen verslag',0),(175372,4872,'fi','Odottavat Tilaukset-raportti',0),(175373,4872,'no','Ventende ordrer rapport',0),(175374,4872,'da','Afventende ordrer rapport',0),(175375,4872,'ko','ë³´ë¥˜ ì¤‘ì¸ ì£¼ë¬¸ ë³´ê³ ì„œ',0),(175376,4872,'he','×”×”×•×¨××•×ª ×”×ž×ž×ª×™× ×•×ª ×—',0),(175377,4872,'el','ÎˆÎºÎ¸ÎµÏƒÎ· ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(175378,4872,'zh','å¾…å¤„ç†è®¢å•æŠ¥è¡¨\r\n',0),(175379,4872,'sv','Avvaktande ordrar rapport',0),(175380,4872,'it','Report ordini in sospeso',0),(175381,4872,'tl','',0),(175382,4872,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(175383,4872,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(175384,4872,'ms','Pesanan-pesanan bergantung Laporan',0),(175385,4872,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(175386,4872,'fr','Rapport de commandes en attente',0),(175387,4872,'jp','ä¿?ç•™ä¸­æ³¨æ–‡ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(175388,4872,'pt','RelatÃ³rio de ordens pendentes',0),(175389,4872,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ðž Ð—Ð°ÐºÐ°Ð·Ð°Ñ… Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(175390,4872,'es','Informe de Ordenes Pendientes',0),(175391,4872,'de','Ausstehende Bestellbericht',0),(175392,4872,'en','Pending Orders Report',0),(175393,4873,'is','',0),(175394,4873,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¨Ø§Ø² ',0),(175395,4873,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¨Ø§Ø² ',0),(175396,4873,'tr','AÃ§Ä±k sipariÅŸ YazdÄ±r',0),(175397,4873,'pl','Otwartych zamÃ³wieÅ„ druku',0),(175398,4873,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(175399,4873,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ú©Ú¾Ù„Û’ Ø¢Ø±ÚˆØ±Ø²',0),(175400,4873,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(175401,4873,'vi','Má»Ÿ Ä‘Æ¡n hÃ ng in',0),(175402,4873,'af','Oop Gedrukte Bestellings',0),(175403,4873,'ro','Ordinele deschise de imprimare',0),(175404,4873,'et','Avatud trÃ¼kitÃ¶Ã¶de tellimused',0),(175405,4873,'si','Odprte naloge tiskanja',0),(175406,4873,'ba','Perintah cetak yang terbuka',0),(175407,4873,'nl','Open afdrukken bestellingen',0),(175408,4873,'fi','Avaa Tulosta tilaukset',0),(175409,4873,'no','Ã…pne bestilling',0),(175410,4873,'da','Ã…ben aftryksbestillinger',0),(175411,4873,'ko','ì—´ë¦° ì¸ì‡„ ì£¼ë¬¸',0),(175412,4873,'he','×”×“×¤×¡ ×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª',0),(175413,4873,'el','Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(175414,4873,'zh','æœªç»“æ‰“å°è®¢å•\r\n',0),(175415,4873,'sv','Ã–ppna Print Order',0),(175416,4873,'it','Aperti gli ordini di stampa',0),(175417,4873,'tl','',0),(175418,4873,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3611;&#3636;&#3604;',0),(175419,4873,'hi','à¤–à¥à¤²à¤¾ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶',0),(175420,4873,'ms','Pesanan cetakan yang terbuka',0),(175421,4873,'ar','ÙØªØ­ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(175422,4873,'fr','Commandes ouvertes',0),(175423,4873,'jp','ã‚ªãƒ¼ãƒ—ãƒ³å?°åˆ·æ³¨æ–‡',0),(175424,4873,'pt','ImpressÃ£o de pedidos abertos',0),(175425,4873,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(175426,4873,'es','Lista de Ordenes de Impresion Abiertos',0),(175427,4873,'de','Offenen DruckauftrÃ¤ge',0),(175428,4873,'en','Open Print Orders',0),(175429,4874,'is','',0),(175430,4874,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹ÙˆÙ‚ ',0),(175431,4874,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹ÙˆÙ‚ ',0),(175432,4874,'tr','Bekleyen sipariÅŸler',0),(175433,4874,'pl','Zlecenia oczekujÄ…ce',0),(175434,4874,'bg','ÐžÑ‚Ð»Ð¾Ð¶ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(175435,4874,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(175436,4874,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(175437,4874,'vi','ÄÆ¡n hÃ ng chÆ°a lÃ m',0),(175438,4874,'af','Afwagtende Bestellings',0),(175439,4874,'ro','Ordinele Ã®n aÈ™teptare',0),(175440,4874,'et','Ootel arved',0),(175441,4874,'si','ÄŒakajoÄa naroÄila',0),(175442,4874,'ba','Pending order',0),(175443,4874,'nl','Onverwerkte bestellingen',0),(175444,4874,'fi','Odottavat toimeksiannot',0),(175445,4874,'no','Ventende bestillinger',0),(175446,4874,'da','Afventende ordrer',0),(175447,4874,'ko','ë³´ë¥˜ ì¤‘ì¸ ì£¼ë¬¸',0),(175448,4874,'he','×”×”×•×¨××•×ª ×”×ž×ž×ª×™× ×•×ª',0),(175449,4874,'el','Î•ÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(175450,4874,'zh','å¾…å¤„ç†è®¢å•\r\n',0),(175451,4874,'sv','Avvaktande ordrar',0),(175452,4874,'it','Ordini pendenti',0),(175453,4874,'tl','',0),(175454,4874,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(175455,4874,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶',0),(175456,4874,'ms','Pesanan-pesanan bergantung',0),(175457,4874,'ar','Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…Ø¹Ù„Ù‘Ù‚Ø©',0),(175458,4874,'fr','Commandes en attente',0),(175459,4874,'jp','ä¿?ç•™ä¸­æ³¨æ–‡',0),(175460,4874,'pt','Ordens pendentes',0),(175461,4874,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(175462,4874,'es','Ordenes Estan Pendientes',0),(175463,4874,'de','Offene Bestellungen',0),(175464,4874,'en','Pending Orders',0),(175465,4875,'is','',0),(175466,4875,'dr','(Ø³Ù‡Ø§Ù…) Ø¯Ø± Ù„ÙŠØ³Øª ',0),(175467,4875,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± (Ø³Ù‡Ø§Ù…) Ø¯Ø± Ù„ÙŠØ³Øª ',0),(175468,4875,'tr','Stok listesi',0),(175469,4875,'pl','Zapasy na liÅ›cie',0),(175470,4875,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð² ÑÐ¿Ð¸ÑÑŠÐº',0),(175471,4875,'ur','ÙÛØ±Ø³Øª Ù¾Ø± Ø§Ø³Ù¹Ø§Ú©',0),(175472,4875,'sr','Ð”Ð¸Ð¾Ð½Ð¸Ñ†Ðµ Ð½Ð° Ð»Ð¸ÑÑ‚Ð¸',0),(175473,4875,'vi','HÃ ng tá»“n trong danh sÃ¡ch',0),(175474,4875,'af','Aandele op lys',0),(175475,4875,'ro','Stocurile de pe lista',0),(175476,4875,'et','Varude loend',0),(175477,4875,'si','Zaloge na seznam',0),(175478,4875,'ba','Saham pada daftar',0),(175479,4875,'nl','Voorraden op lijst',0),(175480,4875,'fi','Varastojen luettelo',0),(175481,4875,'no','Aksjer pÃ¥ listen',0),(175482,4875,'da','Bestande pÃ¥ listen',0),(175483,4875,'ko','ì£¼ì‹ ëª©ë¡ì—',0),(175484,4875,'he','×ž× ×™×•×ª ×‘×¨×©×™×ž×”',0),(175485,4875,'el','Î‘Ï€Î¿Î¸Î­Î¼Î±Ï„Î±ÏƒÏ„Î¹Ï‚ Î»Î¯ÏƒÏ„Î±',0),(175486,4875,'zh','åº“å­˜åå•\r\n',0),(175487,4875,'sv','BestÃ¥nd pÃ¥ listan',0),(175488,4875,'it','Stock sulla lista',0),(175489,4875,'tl','',0),(175490,4875,'th','&#3626;&#3605;&#3658;&#3629;&#3588;&#3651;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(175491,4875,'hi','à¤¶à¥‡à¤¯à¤°à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤ªà¤°',0),(175492,4875,'ms','Stok senarai',0),(175493,4875,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… ÙÙŠ Ù‚Ø§Ø¦Ù…Ø©',0),(175494,4875,'fr','Se trouvant sur la liste',0),(175495,4875,'jp','ãƒªã‚¹ãƒˆä¸Šåœ¨åº«',0),(175496,4875,'pt','Estoques na lista',0),(175497,4875,'ru','Ð—Ð°Ð¿Ð°ÑÑ‹ Ð½Ð° ÑÐ¿Ð¸ÑÐ¾Ðº',0),(175498,4875,'es','Stocks en la Lista',0),(175499,4875,'de','BestÃ¤nde auf Liste',0),(175500,4875,'en','Stocks on List',0),(175501,4876,'is','',0),(175502,4876,'dr','ÙŠÙƒ Ù…Ø§Ù‡ ',0),(175503,4876,'pr','ÙŠÙƒ Ù…Ø§Ù‡ ',0),(175504,4876,'tr','Bir ay',0),(175505,4876,'pl','Jeden miesiÄ…c',0),(175506,4876,'bg','Ð•Ð´Ð¸Ð½ Ð¼ÐµÑÐµÑ†',0),(175507,4876,'ur','Ø§ÛŒÚ© Ù…Ø§Û',0),(175508,4876,'sr','ÐˆÐµÐ´Ð°Ð½ Ð¼ÐµÑÐµÑ†',0),(175509,4876,'vi','Má»™t thÃ¡ng',0),(175510,4876,'af','Een Maand',0),(175511,4876,'ro','O lunÄƒ',0),(175512,4876,'et','Ãœks kuu',0),(175513,4876,'si','En mesec',0),(175514,4876,'ba','Satu bulan',0),(175515,4876,'nl','Ã‰Ã©n maand',0),(175516,4876,'fi','Kuukausi',0),(175517,4876,'no','En mÃ¥ned',0),(175518,4876,'da','En mÃ¥ned',0),(175519,4876,'ko','í•œ ë‹¬',0),(175520,4876,'he','×—×•×“×© ××—×“',0),(175521,4876,'el','ÎˆÎ½Î± Î¼Î®Î½Î±',0),(175522,4876,'zh','ä¸€ä¸ªæœˆ\r\n',0),(175523,4876,'sv','En mÃ¥nad',0),(175524,4876,'it','Un mese',0),(175525,4876,'tl','',0),(175526,4876,'th','&#3627;&#3609;&#3638;&#3656;&#3591;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(175527,4876,'hi','à¤à¤• à¤®à¤¹à¥€à¤¨à¤¾',0),(175528,4876,'ms','Satu bulan',0),(175529,4876,'ar','Ø´Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(175530,4876,'fr','Un mois',0),(175531,4876,'jp','1ãƒ¶æœˆ',0),(175532,4876,'pt','Um mÃªs',0),(175533,4876,'ru','ÐžÐ´Ð¸Ð½ ÐœÐµÑÑÑ†',0),(175534,4876,'es','Un Mes',0),(175535,4876,'de','Einen Monat',0),(175536,4876,'en','One Month',0),(175537,4877,'is','',0),(175538,4877,'dr','ØªØ§Ø±ÙŠØ® Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(175539,4877,'pr','ØªØ§Ø±ÙŠØ® Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(175540,4877,'tr','Teklif tarihi',0),(175541,4877,'pl','Cytat dnia',0),(175542,4877,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð°',0),(175543,4877,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(175544,4877,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð´Ð°Ñ‚ÑƒÐ¼',0),(175545,4877,'vi','NgÃ y bÃ¡o giÃ¡',0),(175546,4877,'af','Kwotasie Datum',0),(175547,4877,'ro','Citat data',0),(175548,4877,'et','Pakkumise kuupÃ¤ev',0),(175549,4877,'si','Datum ponudbe',0),(175550,4877,'ba','Mengutip tanggal',0),(175551,4877,'nl','Datum van de offerte',0),(175552,4877,'fi','Tarjouksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(175553,4877,'no','Oppgi dato',0),(175554,4877,'da','Citat dato',0),(175555,4877,'ko','ê²¬ì  ë‚ ì§œ',0),(175556,4877,'he','×ª××¨×™×š ×”×¦×¢×ª ×ž×—×™×¨',0),(175557,4877,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(175558,4877,'zh','æŠ¥ä»·æ—¥æœŸ\r\n',0),(175559,4877,'sv','Citera datum',0),(175560,4877,'it','Data di citazione',0),(175561,4877,'tl','',0),(175562,4877,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(175563,4877,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(175564,4877,'ms','Tarikh sebut harga',0),(175565,4877,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(175566,4877,'fr','Date de la citation',0),(175567,4877,'jp','è¦‹ç©?ã‚Šæ—¥',0),(175568,4877,'pt','Data de citaÃ§Ã£o',0),(175569,4877,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð”Ð°Ñ‚Ð°',0),(175570,4877,'es','Fecha de CotizaciÃ³n',0),(175571,4877,'de','Zitat Datum',0),(175572,4877,'en','Quote Date',0),(175573,4878,'is','',0),(175574,4878,'dr','ÙƒÙ„ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø·ÙˆÙ„ ÙƒØ´ÙŠØ¯Ù‡ Ø§Ø³Øª Ø¨Ø±Ø§ÙŠ  ÙŠÙƒ Ù…Ø§Ù‡ ',0),(175575,4878,'pr','ÙƒÙ„ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø·ÙˆÙ„ ÙƒØ´ÙŠØ¯Ù‡ Ø§Ø³Øª Ø¨Ø±Ø§ÙŠ  ÙŠÙƒ Ù…Ø§Ù‡ ',0),(175576,4878,'tr','Toplam alÄ±nan son bir ay',0),(175577,4878,'pl','Sumie Cytaty ostatni miesiÄ…c',0),(175578,4878,'bg','ÐžÐ±Ñ‰Ð¾ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸ Ð·Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ ÐµÐ´Ð¸Ð½ Ð¼ÐµÑÐµÑ†',0),(175579,4878,'ur','Ú©Ù„ Ù‚ÛŒÙ…Øª Ù¾Ú†Ú¾Ù„Û’ Ø§ÛŒÚ© Ù…Ø§Û',0),(175580,4878,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð·Ð°Ð´ÑšÐ¸ Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(175581,4878,'vi','Tá»•ng cá»™ng bÃ¡o giÃ¡ trong thÃ¡ng cuá»‘i',0),(175582,4878,'af','Totale Kwotasie is Geldig vir Een Maand',0),(175583,4878,'ro','Total citate ultima o lunÄƒ',0),(175584,4878,'et','Kokku Quotes viimase Ã¼he kuu',0),(175585,4878,'si','Skupaj ponudb zadnji en mesec',0),(175586,4878,'ba','Total harga satu bulan terakhir',0),(175587,4878,'nl','Totaal citeert laatste Ã©Ã©n maand',0),(175588,4878,'fi','YhteensÃ¤ lainaa kestÃ¤Ã¤ enintÃ¤Ã¤n yhden kuukauden',0),(175589,4878,'no','Totalt siterer siste mÃ¥ned',0),(175590,4878,'da','Total citater sidste mÃ¥neds',0),(175591,4878,'ko','ì´ ë§¤ìˆ˜ ë§ˆì§€ë§‰ í•œ ë‹¬',0),(175592,4878,'he','×¡×” ×› ×”×¦×¢×•×ª ×ž×—×™×¨ ×œ×¤× ×™ ×—×•×“×© ××—×“',0),(175593,4878,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬ Î´Î¹Î±ÏÎºÎ¿ÏÎ½ Î­Î½Î±Î½ Î¼Î®Î½Î±',0),(175594,4878,'zh','æœ€åŽä¸€ä¸ªæœˆæŠ¥ä»·æ€»é¢\r\n',0),(175595,4878,'sv','Totalt citat senast en mÃ¥nad',0),(175596,4878,'it','Totale quotazioni ultima un mese',0),(175597,4878,'tl','',0),(175598,4878,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;&#3651;&#3609; 1 &#3648;&#3604;&#3639;&#3629;&#3609;',0),(175599,4878,'hi','à¤•à¥à¤² à¤à¤• à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤…à¤‚à¤¤à¤¿à¤® à¤‰à¤¦à¥à¤§à¤°à¤£',0),(175600,4878,'ms','Jumlah petikan satu bulan',0),(175601,4878,'ar','Ù…Ø¬Ù…ÙˆØ¹ ÙŠÙ‚ØªØ¨Ø³ Ø§Ù„Ø´Ù‡Ø± Ø§Ù„Ù…Ø§Ø¶ÙŠ',0),(175602,4878,'fr','Total cite dernier dÃ©lai d\'un mois',0),(175603,4878,'jp','é?ŽåŽ»ï¼‘ãƒ¶æœˆã?®è¦‹ç©?ã‚‚ã‚Šå?ˆè¨ˆ',0),(175604,4878,'pt','Total cita um Ãºltimo mÃªs',0),(175605,4878,'ru','Ð’ÑÐµÐ³Ð¾ Ð¾Ð´Ð¸Ð½ Ð¼ÐµÑÑÑ† ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(175606,4878,'es','Cotizaciones Totales Ultimo Mes',0),(175607,4878,'de','Insgesamt Angebote letztes eines Monats',0),(175608,4878,'en','Total Quotes Last One Month',0),(175609,4879,'is','',0),(175610,4879,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„  Ø´Ø¯Ù‡ Ù‡ÙØª Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡ ',0),(175611,4879,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø­Ù…Ù„  Ø´Ø¯Ù‡ Ù‡ÙØª Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡ ',0),(175612,4879,'tr','Son 7 gÃ¼n sevk edilen sipariÅŸler',0),(175613,4879,'pl','ZamÃ³wienia wysÅ‚ane ostatnich 7 dni',0),(175614,4879,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ 7 Ð´Ð½Ð¸',0),(175615,4879,'ur','Ø¢Ø®Ø±ÛŒ 7 Ø¯Ù†ÙˆÚº Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(175616,4879,'sr','ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ðµ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐ¸Ñ… 7 Ð´Ð°Ð½Ð°',0),(175617,4879,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ chuyá»ƒn 7 ngÃ y vá»«a qua',0),(175618,4879,'af','Bestellings Versend Lasste 7 Dae',0),(175619,4879,'ro','Comenzile expediate ultimele 7 zile',0),(175620,4879,'et','Tellimused tarnitakse viimase 7 pÃ¤eva jooksul',0),(175621,4879,'si','Nalogi dobavljeni zadnjih 7 dni',0),(175622,4879,'ba','Pesanan dikirim 7 hari terakhir',0),(175623,4879,'nl','Bestellingen die zijn verzonden laatste 7 dagen',0),(175624,4879,'fi','Viimeisen 7 pÃ¤ivÃ¤n kuluessa toimitetut tilaukset',0),(175625,4879,'no','Ordrer sendt siste 7 dager',0),(175626,4879,'da','Ordrer afsendt sidste 7 dage',0),(175627,4879,'ko','ì§€ë‚œ 7 ì¼ ì„ ì  ëœ ì£¼ë¬¸ì„',0),(175628,4879,'he','×”×–×ž× ×•×ª ×©× ×©×œ×—×• ×‘ 7 ×™×ž×™× ××—×¨×•× ×™×',0),(175629,4879,'el','ÎŸÎ¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Ï€ÏÎ¿Î¿ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯ÎµÏ‚ 7 Î·Î¼Î­ÏÎµÏ‚',0),(175630,4879,'zh','è®¢å•å‘è´§æœ€åŽ7å¤©\r\n',0),(175631,4879,'sv','Order som har levererats senaste 7 dagarna',0),(175632,4879,'it','Gli ordini spediti ultimi 7 giorni',0),(175633,4879,'tl','',0),(175634,4879,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623; 7 &#3623;&#3633;&#3609;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(175635,4879,'hi','à¤ªà¤¿à¤›à¤²à¥‡ 7 à¤¦à¤¿à¤¨ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(175636,4879,'ms','Pesanan dihantar 7 hari lepas',0),(175637,4879,'ar','Ø§Ù„Ø·Ù„Ø¨ÙŠØ§Øª Ø§Ù„ØªÙŠ ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§ ÙÙŠ Ø¢Ø®Ø± 7 Ø£ÙŠØ§Ù…',0),(175638,4879,'fr','Les commandes expÃ©diÃ©es des 7 derniers jours',0),(175639,4879,'jp','é?ŽåŽ»ï¼—æ—¥é–“ã?®ç™ºé€?æ¸ˆæ³¨æ–‡',0),(175640,4879,'pt','As ordens enviadas Ãºltimos 7 dias',0),(175641,4879,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð° ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ 7 Ð”Ð½ÐµÐ¹',0),(175642,4879,'es','Ordenes Enviados en los Ultimos 7 DÃ­as',0),(175643,4879,'de','Bestellungen versandt letzten 7 Tage',0),(175644,4879,'en','Orders Shipped Last 7 Days',0),(175645,4880,'is','',0),(175646,4880,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡',0),(175647,4880,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡',0),(175648,4880,'tr','KayÄ±p alÄ±ntÄ±',0),(175649,4880,'pl','StraciÅ‚ cytat',0),(175650,4880,'bg','Ð—Ð°Ð³ÑƒÐ±ÐµÐ½Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(175651,4880,'ur','Ú¯Ù… Ø´Ø¯Û Ø§Ù‚ØªØ¨Ø§Ø³',0),(175652,4880,'sr','Ð˜Ð·Ð³ÑƒÐ±Ñ™ÐµÐ½Ð¸ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(175653,4880,'vi','Máº¥t bÃ¡o giÃ¡',0),(175654,4880,'af','Verlore Kwotasie',0),(175655,4880,'ro','Citat de pierdut',0),(175656,4880,'et','Kaotatud Quote',0),(175657,4880,'si','Izgubljeni citat',0),(175658,4880,'ba','Kehilangan kutipan',0),(175659,4880,'nl','Verloren offerte',0),(175660,4880,'fi','Lost lainaus',0),(175661,4880,'no','Tapt tilbud',0),(175662,4880,'da','Tabt citat',0),(175663,4880,'ko','ì†ì‹¤ëœ ê²¬ì ',0),(175664,4880,'he','×”×¦×¢×ª ×ž×—×™×¨ ××‘×•×“',0),(175665,4880,'el','Î§Î±Î¼Î­Î½Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(175666,4880,'zh','ä¸¢å¤±æŠ¥ä»·\r\n',0),(175667,4880,'sv','FÃ¶rlorade citat',0),(175668,4880,'it','Citazione perduto',0),(175669,4880,'tl','',0),(175670,4880,'th','&#3649;&#3592;&#3657;&#3591;&#3588;&#3623;&#3634;&#3617;&#3648;&#3626;&#3637;&#3618;&#3627;&#3634;&#3618;',0),(175671,4880,'hi','à¤¬à¥‹à¤²à¥€ à¤–à¥‹ à¤¦à¤¿à¤¯à¤¾',0),(175672,4880,'ms','Quote hilang',0),(175673,4880,'ar','ÙÙ‚Ø¯ Ø§Ù‚ØªØ¨Ø³',0),(175674,4880,'fr','Citation perdue',0),(175675,4880,'jp','è² ã?‘ã?Ÿè¦‹ç©?ã‚Š',0),(175676,4880,'pt','CitaÃ§Ã£o perdida',0),(175677,4880,'ru','ÐŸÐ¾Ñ‚ÐµÑ€ÑÐ½Ð½Ñ‹Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(175678,4880,'es','CotizaciÃ³n Perdida',0),(175679,4880,'de','Zitat verloren',0),(175680,4880,'en','Lost Quote',0),(175681,4881,'is','',0),(175682,4881,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(175683,4881,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(175684,4881,'tr','KayÄ±p alÄ±ntÄ±',0),(175685,4881,'pl','Cytat utracone',0),(175686,4881,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð·Ð°Ð³ÑƒÐ±ÐµÐ½Ð¸',0),(175687,4881,'ur','Ú¯Ù… Ø´Ø¯Û Ø§Ù‚ØªØ¨Ø§Ø³',0),(175688,4881,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð¸Ð·Ð³ÑƒÐ±Ñ™ÐµÐ½Ðµ',0),(175689,4881,'vi','Máº¥t BÃ¡o giÃ¡',0),(175690,4881,'af','Kwotasie Verloor',0),(175691,4881,'ro','Cita pierdut',0),(175692,4881,'et','Tsitaat kaotatud',0),(175693,4881,'si','Citiram izgubljen',0),(175694,4881,'ba','Mengutip hilang',0),(175695,4881,'nl','Citeer verloren',0),(175696,4881,'fi','Lainaus menetetty',0),(175697,4881,'no','Tilbud tapt',0),(175698,4881,'da','Citere tabt',0),(175699,4881,'ko','ì†ì‹¤ ê²¬ì ',0),(175700,4881,'he','×œ×¦×˜×˜ ××‘×•×“',0),(175701,4881,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï‡Î±Î¸ÎµÎ¯',0),(175702,4881,'zh','æŠ¥ä»·ä¸¢å¤±\r\n',0),(175703,4881,'sv','Citera fÃ¶rlorade',0),(175704,4881,'it','Citare perduto',0),(175705,4881,'tl','',0),(175706,4881,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3626;&#3641;&#3597;&#3627;&#3634;&#3618;',0),(175707,4881,'hi','à¤–à¥‹ à¤¬à¥‹à¤²à¥€',0),(175708,4881,'ms','Quote hilang',0),(175709,4881,'ar','Ø§Ù‚ØªØ¨Ø³ Ø§Ù„Ù…ÙÙ‚ÙˆØ¯Ø©',0),(175710,4881,'fr','Cite perdu',0),(175711,4881,'jp','è¦‹ç©?ã‚Šã?Œè² ã?‘ã?¾ã?—ã?Ÿ',0),(175712,4881,'pt','Citar perdido',0),(175713,4881,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð¿Ð¾Ñ‚ÐµÑ€ÑÐ½Ð½Ñ‹Ðµ',0),(175714,4881,'es','CotizaciÃ³n Perdida',0),(175715,4881,'de','Zitiere verloren',0),(175716,4881,'en','Quote Lost',0),(175717,4882,'is','',0),(175718,4882,'dr','(Ø¶Ø±Ø± Ø¯ÙŠØ¯Ù‡',0),(175719,4882,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ú¯Ù… Ø´Ø¯Ù‡ (Ø²ÙŠØ§Ù† Ø¯ÙŠØ¯Ù‡',0),(175720,4882,'tr','KayÄ±p olarak iÅŸaretlenen alÄ±ntÄ±',0),(175721,4882,'pl','Cytat oznaczony jako utracone',0),(175722,4882,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ð° ÐºÐ°Ñ‚Ð¾ Ð¸Ð·Ð³ÑƒÐ±ÐµÐ½Ð¸',0),(175723,4882,'ur','Ú©Ú¾Ùˆ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†Ø´Ø§Ù† Ø²Ø¯ Ø§Ù‚ØªØ¨Ø§Ø³',0),(175724,4882,'sr','Ð¦Ð¸Ñ‚Ð°Ñ‚ Ñ˜Ðµ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½ ÐºÐ°Ð¾ Ð¸Ð·Ð³ÑƒÐ±Ñ™ÐµÐ½Ð¾',0),(175725,4882,'vi','BÃ¡o giÃ¡ Ä‘Ã¡nh dáº¥u lÃ  máº¥t',0),(175726,4882,'af','Aanhaling gemerk as verlore',0),(175727,4882,'ro','Citat marcate ca pierdut',0),(175728,4882,'et','Hinnapakkumise mÎ£rgitud, kaotas',0),(175729,4882,'si','Ponudba, oznaÄena kot izgubljen',0),(175730,4882,'ba','Kutipan yang ditandai sebagai hilang',0),(175731,4882,'nl','Offerte gemarkeerd als verloren',0),(175732,4882,'fi','Lainaus merkitty menettÃ¤nyt',0),(175733,4882,'no','Tilbud merket som mistet',0),(175734,4882,'da','Citere markeret som mistede',0),(175735,4882,'ko','ë¶„ì‹¤ ëœ ê²ƒìœ¼ë¡œ í‘œì‹œ í•˜ëŠ” ì¸ìš©',0),(175736,4882,'he','×”×¦×¢×ª ×ž×—×™×¨ ×©×¡×•×ž× ×• ××™×‘×“',0),(175737,4882,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ ÏƒÎ·Î¼ÎµÎ¹Ï‰Î¼Î­Î½Î· Ï‰Ï‚ Î­Ï‡Î±ÏƒÎµ',0),(175738,4882,'zh','æŠ¥ä»·æ ‡è®°ä¸ºä¸¢å¤±\r\n',0),(175739,4882,'sv','Citat markeras som fÃ¶rlorat',0),(175740,4882,'it','Citazione contrassegnato come perso',0),(175741,4882,'tl','',0),(175742,4882,'th','&#3607;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3626;&#3641;&#3597;&#3627;&#3634;&#3618;',0),(175743,4882,'hi','à¤¬à¥‹à¤²à¥€ à¤–à¥‹ à¤¦à¤¿à¤¯à¤¾ à¤¹à¥ˆ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤',0),(175744,4882,'ms','Quote yang ditandakan sebagai hilang',0),(175745,4882,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„ØªÙŠ ØªÙ… ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© ÙƒÙ…Ø§ ÙÙ‚Ø¯Øª',0),(175746,4882,'fr','Citation marquÃ©e comme perdu',0),(175747,4882,'jp','è² ã?‘ã?¨è¨˜ã?•ã‚Œã?Ÿè¦‹ç©?ã‚Š',0),(175748,4882,'pt','CitaÃ§Ã£o marcada como perdido',0),(175749,4882,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð°, Ð¿Ð¾Ð¼ÐµÑ‡ÐµÐ½Ð½Ñ‹Ðµ ÐºÐ°Ðº Ð¿Ð¾Ñ‚ÐµÑ€ÑÐ»',0),(175750,4882,'es','CotizaciÃ³n Marcada como Perdida',0),(175751,4882,'de','Zitat als verloren markiert',0),(175752,4882,'en','Quote Marked as Lost',0),(175753,4883,'is','',0),(175754,4883,'dr','Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø§Ø² Ø¯Ø³Øª Ø¯Ø§Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(175755,4883,'pr','Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø§Ø² Ø¯Ø³Øª Ø¯Ø§Ø¯Ù† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(175756,4883,'tr','AlÄ±ntÄ± kaybetme nedeni',0),(175757,4883,'pl','Powodem utraty cytat',0),(175758,4883,'bg','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð·Ð°Ð³ÑƒÐ±Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(175759,4883,'ur','ÙˆØ¬Û Ø³Û’ Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Ùˆ Ú©Ú¾ÙˆÙ†Û’ Ú©Û’ Ù„Ø¦Û’',0),(175760,4883,'sr','Ð Ð°Ð·Ð»Ð¾Ð³ Ð·Ð±Ð¾Ð³ Ð³ÑƒÐ±Ð¸Ñ‚ÐºÐ° Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(175761,4883,'vi','LÃ½ do máº¥t bÃ¡o giÃ¡',0),(175762,4883,'af','Rede waarom Kwotasie verloor het',0),(175763,4883,'ro','Motiv pentru a pierde citat',0),(175764,4883,'et','PÃµhjusel kaotada Quote',0),(175765,4883,'si','Razlog za izgubo citat',0),(175766,4883,'ba','Alasan untuk kehilangan kutipan',0),(175767,4883,'nl','Reden voor het verliezen van Quote',0),(175768,4883,'fi','Syy menettÃ¤Ã¤ tarjous',0),(175769,4883,'no','Grunn for Ã¥ miste tilbud',0),(175770,4883,'da','Ã…rsagen til at miste citat',0),(175771,4883,'ko','ì†ì‹¤ ê²¬ì ì— ëŒ€ í•œ ì´ìœ ',0),(175772,4883,'he','×¡×™×‘×” ×œ××‘×“ ××ª ×”×¦×¢×ª ×”×ž×—×™×¨',0),(175773,4883,'el','Î›ÏŒÎ³Î¿Ï‚ Î³Î¹Î± Ï„Î·Î½ Î±Ï€ÏŽÎ»ÎµÎ¹Î± Ï„Ï‰Î½ Ï€Î±ÏÎ¬Î¸ÎµÏƒÎ·',0),(175774,4883,'zh','å¤±åŽ»æŠ¥ä»·çš„åŽŸå› \r\n',0),(175775,4883,'sv','Anledningen till att fÃ¶rlora citat',0),(175776,4883,'it','Motivo per perdere la citazione',0),(175777,4883,'tl','',0),(175778,4883,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3629;&#3657;&#3634;&#3591;&#3629;&#3636;&#3591;&#3627;&#3634;&#3618;&#3652;&#3611;',0),(175779,4883,'hi','à¤¬à¥‹à¤²à¥€ à¤–à¥‹à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾à¤°à¤£',0),(175780,4883,'ms','Sebab bagi kehilangan Quote',0),(175781,4883,'ar','Ø§Ù„Ø³Ø¨Ø¨ ÙÙŠ ÙÙ‚Ø¯Ø§Ù† Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(175782,4883,'fr','Raison pour perdre la citation',0),(175783,4883,'jp','è¦‹ç©?ã‚Šã?Œè² ã?‘ã?Ÿç?†ç”±',0),(175784,4883,'pt','RazÃ£o para perder a citaÃ§Ã£o',0),(175785,4883,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ð¾Ñ‚ÐµÑ€Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(175786,4883,'es','RazÃ³n para Perder la CotizaciÃ³n',0),(175787,4883,'de','Grund fÃ¼r die Quote zu verlieren',0),(175788,4883,'en','Reason for Losing Quote',0),(175789,4884,'is','',0),(175790,4884,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(175791,4884,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(175792,4884,'tr','DoÄŸrulanmayan sipariÅŸleri',0),(175793,4884,'pl','Niepotwierdzone zamÃ³wienia',0),(175794,4884,'bg','ÐÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(175795,4884,'ur','ØºÛŒØ± Ù…ØµØ¯Ù‚Û Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(175796,4884,'sr','ÐÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ€ÐµÐ½Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(175797,4884,'vi','ÄÆ¡n HÃ ng chÆ°a xÃ¡c nháº­n',0),(175798,4884,'af','Onbevestigende Bestellings',0),(175799,4884,'ro','Comenzi neconfirmate',0),(175800,4884,'et','Kinnitamata tellimused',0),(175801,4884,'si','Nepotrjenih naroÄil',0),(175802,4884,'ba','Order belum dikonfirmasi',0),(175803,4884,'nl','Onbevestigde bestellingen',0),(175804,4884,'fi','Vahvistamattomat tilaukset',0),(175805,4884,'no','Ubekreftede ordrer',0),(175806,4884,'da','UbekrÃ¦ftede ordrer',0),(175807,4884,'ko','ë¯¸í™•ì¸ëœ ì£¼ë¬¸',0),(175808,4884,'he','×”×–×ž× ×•×ª ×©×œ× ××•×©×¨×•',0),(175809,4884,'el','ÎœÎ· ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹Ï‰Î¼Î­Î½ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(175810,4884,'zh','æœªç¡®è®¤çš„è®¢å•\r\n',0),(175811,4884,'sv','ObekrÃ¤ftade order',0),(175812,4884,'it','Ordini non confermati',0),(175813,4884,'tl','',0),(175814,4884,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3637;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(175815,4884,'hi','à¤…à¤ªà¥à¤·à¥à¤Ÿ à¤†à¤¦à¥‡à¤¶',0),(175816,4884,'ms','Perintah-perintah yang belum disahkan',0),(175817,4884,'ar','Ø§Ù„Ø·Ù„Ø¨ÙŠØ§Øª Ø§Ù„ØºÙŠØ± Ù…Ø¤ÙƒÙ‘Ø¯Ø©',0),(175818,4884,'fr','Commandes non-confirme',0),(175819,4884,'jp','æœªç¢ºèª?æ³¨æ–‡',0),(175820,4884,'pt','Pedidos nÃ£o confirmados',0),(175821,4884,'ru','ÐÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(175822,4884,'es','Ordenes No Confirmados',0),(175823,4884,'de','Nicht bestÃ¤tigte Bestellungen',0),(175824,4884,'en','Unconfirmed Orders',0),(175825,4885,'is','',0),(175826,4885,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(175827,4885,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(175828,4885,'tr','DoÄŸrulanmayan sipariÅŸleri raporu',0),(175829,4885,'pl','Niepotwierdzone zamÃ³wienia raportu',0),(175830,4885,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð½ÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(175831,4885,'ur','ØºÛŒØ± Ù…ØµØ¯Ù‚Û Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(175832,4885,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð½ÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð¸Ð¼ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(175833,4885,'vi','BÃ¡o cÃ¡o ÄÆ¡n HÃ ng chÆ°a xÃ¡c nháº­n',0),(175834,4885,'af','Onbevestigde Bestellingsverslag',0),(175835,4885,'ro','Comenzi neconfirmate raport',0),(175836,4885,'et','Kinnitamata korralduste aruanne',0),(175837,4885,'si','Nepotrjenih naroÄil poroÄilo',0),(175838,4885,'ba','Laporan pesanan belum dikonfirmasi',0),(175839,4885,'nl','Onbevestigde bestellingen verslag',0),(175840,4885,'fi','Vahvistamattomat Tilaukset-raportti',0),(175841,4885,'no','Ubekreftede ordrer rapport',0),(175842,4885,'da','UbekrÃ¦ftede ordrer rapport',0),(175843,4885,'ko','ë¯¸í™•ì¸ëœ ì£¼ë¬¸ ë³´ê³ ì„œ',0),(175844,4885,'he','×“×•×— ×”×–×ž× ×•×ª ×œ× ×ž××•×©×¨×•×ª',0),(175845,4885,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î¼Î· ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹Ï‰Î¼Î­Î½ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(175846,4885,'zh','æœªç¡®è®¤çš„è®¢å•æŠ¥è¡¨\r\n',0),(175847,4885,'sv','ObekrÃ¤ftade rapport',0),(175848,4885,'it','Report ordini non confermati',0),(175849,4885,'tl','',0),(175850,4885,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3637;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(175851,4885,'hi','à¤…à¤ªà¥à¤·à¥à¤Ÿ à¤†à¤¦à¥‡à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(175852,4885,'ms','Laporan pesanan yang belum disahkan',0),(175853,4885,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø·Ù„Ø¨ÙŠØ§Øª Ø§Ù„ØºÙŠØ± Ù…Ø¤ÙƒÙ‘Ø¯Ø©',0),(175854,4885,'fr','Rapport de commandes non confirmÃ©es',0),(175855,4885,'jp','æœªç¢ºèª?æ³¨æ–‡ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(175856,4885,'pt','RelatÃ³rio de pedidos nÃ£o confirmados',0),(175857,4885,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ðž ÐÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð°Ñ…',0),(175858,4885,'es','Informe de Ordenes No Confirmados',0),(175859,4885,'de','UnbestÃ¤tigte Bestellbericht',0),(175860,4885,'en','Unconfirmed Orders Report',0),(175861,4886,'is','',0),(175862,4886,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…Ø¹ÙˆÙ‚ ',0),(175863,4886,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…Ø¹ÙˆÙ‚ ',0),(175864,4886,'tr','Bekleyen Teklifler',0),(175865,4886,'pl','OczekujÄ…ce oferty',0),(175866,4886,'bg','Ð§Ð°ÐºÐ°Ñ‰Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(175867,4886,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ ÙˆØ§ÙˆÛŒÙ†',0),(175868,4886,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(175869,4886,'vi','BÃ¡o giÃ¡ Ä‘ang treo',0),(175870,4886,'af','Afwagtende Kwotasies',0),(175871,4886,'ro','Citate Ã®n aÅŸteptare',0),(175872,4886,'et','Ootel ',0),(175873,4886,'si','NereÅ¡ene ponudbe',0),(175874,4886,'ba','Ditunda Penawaran',0),(175875,4886,'nl','Hangende aanhalingstekens',0),(175876,4886,'fi','Odottavat tarjoukset',0),(175877,4886,'no','Uavsluttet anfÃ¸rselstegn',0),(175878,4886,'da','Ventende citater',0),(175879,4886,'ko','ë³´ë¥˜ ì¤‘ì¸ ë”°ì˜´í‘œ',0),(175880,4886,'he','×ž×ž×ª×™×Ÿ ×œ×”×¦×¢×•×ª ×ž×—×™×¨',0),(175881,4886,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬ ÎµÎºÎºÏÎµÎ¼Î®',0),(175882,4886,'zh','å¾…åŠžæŠ¥ä»·\r\n',0),(175883,4886,'sv','VÃ¤ntande citat',0),(175884,4886,'it','Citazioni in sospeso',0),(175885,4886,'tl','',0),(175886,4886,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(175887,4886,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(175888,4886,'ms','Petikan-petikan yang belum selesai',0),(175889,4886,'ar','Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³ Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(175890,4886,'fr','Citations en attente',0),(175891,4886,'jp','ä¿?ç•™ä¸­è¦‹ç©?ã‚Š',0),(175892,4886,'pt','CotaÃ§Ãµes pendentes',0),(175893,4886,'ru','ÐžÐ¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(175894,4886,'es','Cotizaciones Pendientes',0),(175895,4886,'de','Ausstehende Zitate',0),(175896,4886,'en','Pending Quotes',0),(175897,4887,'is','',0),(175898,4887,'dr','ÙƒÙ„ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(175899,4887,'pr','ÙƒÙ„ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(175900,4887,'tr','Toplam tÄ±rnak',0),(175901,4887,'pl','CaÅ‚kowita Cytaty',0),(175902,4887,'bg','ÐžÐ±Ñ‰Ð¾ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(175903,4887,'ur','Ú©Ù„ Ù‚ÛŒÙ…Øª',0),(175904,4887,'sr','Ð£ÐºÑƒÐ¿Ð½Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(175905,4887,'vi','Tá»•ng cá»™ng bÃ¡o giÃ¡',0),(175906,4887,'af','Totale Kwotasie',0),(175907,4887,'ro','Total citate',0),(175908,4887,'et','Kokku hinnapakkumisi',0),(175909,4887,'si','Skupne ponudbe',0),(175910,4887,'ba','Total harga',0),(175911,4887,'nl','Totale Quotes',0),(175912,4887,'fi','YhteensÃ¤ lainausmerkit',0),(175913,4887,'no','Totalt sitater',0),(175914,4887,'da','Samlede citater',0),(175915,4887,'ko','ì´ ê²¬ì ',0),(175916,4887,'he','×¡×” ×› ×”×¦×¢×•×ª ×ž×—×™×¨',0),(175917,4887,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(175918,4887,'zh','æ€»å…±æŠ¥ä»·\r\n',0),(175919,4887,'sv','Totala citat',0),(175920,4887,'it','Totale citazioni',0),(175921,4887,'tl','',0),(175922,4887,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(175923,4887,'hi','à¤•à¥à¤² à¤‰à¤¦à¥à¤§à¤°à¤£',0),(175924,4887,'ms','Jumlah petikan',0),(175925,4887,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³',0),(175926,4887,'fr','Total des citations',0),(175927,4887,'jp','è¦‹ç©?ã‚‚ã‚Šå?ˆè¨ˆ',0),(175928,4887,'pt','Total de citaÃ§Ãµes',0),(175929,4887,'ru','Ð’ÑÐµÐ³Ð¾ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(175930,4887,'es','Cotizaciones Totales',0),(175931,4887,'de','Total Zitate',0),(175932,4887,'en','Total Quotes',0),(175933,4888,'is','',0),(175934,4888,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ÙŠÙƒ Ù…Ø§Ù‡ Ø§Ø®ÙŠØ±   ',0),(175935,4888,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ÙŠÙƒ Ù…Ø§Ù‡ Ø§Ø®ÙŠØ±   ',0),(175936,4888,'tr','Son alÄ±nan bir ay',0),(175937,4888,'pl','Najnowsze Cytaty miesiÄ…ca',0),(175938,4888,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸ Ð·Ð° ÐµÐ´Ð¸Ð½ Ð¼ÐµÑÐµÑ†',0),(175939,4888,'ur','Ø­Ø§Ù„ÛŒÛ Ø§ÛŒÚ© Ù…Ø§Û Ù‚ÛŒÙ…Øª',0),(175940,4888,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(175941,4888,'vi','BÃ¡o giÃ¡ gáº§n Ä‘Ã¢y Má»™t thÃ¡ng',0),(175942,4888,'af','Onlangse Kwotasies Een Maand',0),(175943,4888,'ro','Ultimele citate o lunÄƒ',0),(175944,4888,'et','Tehtud hinnapakkumisi Ã¼he kuu',0),(175945,4888,'si','Nedavni Quotes en mesec',0),(175946,4888,'ba','Hari mengutip satu bulan',0),(175947,4888,'nl','Recente citeert Ã©Ã©n maand',0),(175948,4888,'fi','Hotelliin lainaa kuukaudessa',0),(175949,4888,'no','Siste siterer en mÃ¥ned',0),(175950,4888,'da','Seneste citerer en mÃ¥ned',0),(175951,4888,'ko','ìµœê·¼ í•œ ë‹¬ ì¸ìš©',0),(175952,4888,'he','×”××—×¨×•× ×•×ª ×”×¦×¢×•×ª ×ž×—×™×¨ ×—×•×“×© ××—×“',0),(175953,4888,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ­Ï‚ Î¼Î·Î½ÏŒÏ‚',0),(175954,4888,'zh','æœ€è¿‘ä¸€ä¸ªæœˆæŠ¥ä»·\r\n',0),(175955,4888,'sv','Senaste citat en mÃ¥nad',0),(175956,4888,'it','Recenti cita un mese',0),(175957,4888,'tl','',0),(175958,4888,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3648;&#3617;&#3639;&#3656;&#3629; 1 &#3648;&#3604;&#3639;&#3629;&#3609;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634;',0),(175959,4888,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤à¤• à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(175960,4888,'ms','Semalam memetik satu bulan',0),(175961,4888,'ar','Ø§Ù„Ø£Ø®ÙŠØ±Ø© Ù†Ù‚Ù„Øª Ø´Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(175962,4888,'fr','Ces derniÃ¨res cite un mois',0),(175963,4888,'jp','æœ€è¿‘ä¸€ãƒ¶æœˆã?®è¦‹ç©?ã‚‚ã‚Š',0),(175964,4888,'pt','Recente cita um mÃªs',0),(175965,4888,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð¾Ð´Ð¸Ð½ Ð¼ÐµÑÑÑ†',0),(175966,4888,'es','Cotizaciones Recientes Un Mes',0),(175967,4888,'de','Aktuelle Angebote von einem Monat',0),(175968,4888,'en','Recent Quotes One Month',0),(175969,4889,'is','',0),(175970,4889,'dr','Ø´Ø±Ø­ ',0),(175971,4889,'pr','Ø´Ø±Ø­ ',0),(175972,4889,'tr','DESC.',0),(175973,4889,'pl','DESC.',0),(175974,4889,'bg','ÐÐ¸Ð·Ñ….',0),(175975,4889,'ur','Ø¯ÛŒØ³Ú© Û”',0),(175976,4889,'sr','Ð”Ð•Ð¡Ð¦.',0),(175977,4889,'vi','MÃ´ táº£',0),(175978,4889,'af','Beskr.',0),(175979,4889,'ro','Desc.',0),(175980,4889,'et','Desc.',0),(175981,4889,'si','DESC.',0),(175982,4889,'ba','Desc.',0),(175983,4889,'nl','Desc.',0),(175984,4889,'fi','Kuvaus.',0),(175985,4889,'no','DESC.',0),(175986,4889,'da','/ / Beskr.',0),(175987,4889,'ko','Descìž…ë‹ˆë‹¤.',0),(175988,4889,'he','Desc.',0),(175989,4889,'el','DESC.',0),(175990,4889,'zh','å›¾ç¤ºã€‚\r\n',0),(175991,4889,'sv','Desc.',0),(175992,4889,'it','DESC.',0),(175993,4889,'tl','',0),(175994,4889,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(175995,4889,'hi','Desc.',0),(175996,4889,'ms','Desc.',0),(175997,4889,'ar','Desc.',0),(175998,4889,'fr','DESC.',0),(175999,4889,'jp','è§£èª¬',0),(176000,4889,'pt','Desc.',0),(176001,4889,'ru','ÐžÐ¿Ð¸Ñ.',0),(176002,4889,'es','Desc.',0),(176003,4889,'de','DESC.',0),(176004,4889,'en','Desc.',0),(176005,4890,'is','',0),(176006,4890,'dr','Ø§Ø³Ù†Ø§Ø¯ Ù…Ø¹ÙˆÙ‚',0),(176007,4890,'pr','Ø§Ø³Ù†Ø§Ø¯ Ù…Ø¹ÙˆÙ‚',0),(176008,4890,'tr','Bekleyen provalarÄ±',0),(176009,4890,'pl','OczekujÄ…ce dowody',0),(176010,4890,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð°',0),(176011,4890,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø¯Ù„Ø§Ø¦Ù„',0),(176012,4890,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð´Ð¾ÐºÐ°Ð·Ðµ',0),(176013,4890,'vi','Báº£n in thá»­ Ä‘ang treo',0),(176014,4890,'af','Afwagtende Proewe',0),(176015,4890,'ro','Dovezile Ã®n aÅŸteptare',0),(176016,4890,'et','Menetluses olevad tÃµendid',0),(176017,4890,'si','ÄŒakajoÄe dokazila',0),(176018,4890,'ba','Bukti-bukti yang tertunda',0),(176019,4890,'nl','In behandeling bewijzen',0),(176020,4890,'fi','Odottava todisteita',0),(176021,4890,'no','Ventende bevis',0),(176022,4890,'da','Ventende beviser',0),(176023,4890,'ko','ë³´ë¥˜ ì¤‘ì¸ êµì •',0),(176024,4890,'he','×”×’×”×•×ª ×ž×ž×ª×™× ×”',0),(176025,4890,'el','Î‘Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î±',0),(176026,4890,'zh','å¾…è¯æ˜Ž\r\n',0),(176027,4890,'sv','VÃ¤ntande preparerar',0),(176028,4890,'it','Bozze in sospeso',0),(176029,4890,'tl','',0),(176030,4890,'th','&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3649;&#3610;&#3610;&#3619;&#3656;&#3634;&#3591;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(176031,4890,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¸à¤¬à¥‚à¤¤',0),(176032,4890,'ms','Bukti-bukti yang belum selesai',0),(176033,4890,'ar','Ø¨Ø±ÙˆÙØ§Øª Ù…Ø¹Ù„Ù‚Ø©',0),(176034,4890,'fr','Preuves en attente',0),(176035,4890,'jp','ä¿?ç•™ä¸­æ ¡æ­£',0),(176036,4890,'pt','Provas pendentes',0),(176037,4890,'ru','ÐžÐ¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(176038,4890,'es','Pruebas de ImpresiÃ³n Pendientes',0),(176039,4890,'de','Ausstehende Proofs',0),(176040,4890,'en','Pending Proofs',0),(176041,4891,'is','',0),(176042,4891,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ø¯Ù‡ÙŠ',0),(176043,4891,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ø¯Ù‡ÙŠ',0),(176044,4891,'tr','Geri gelecek',0),(176045,4891,'pl','ZwrÃ³cone',0),(176046,4891,'bg','Ð”ÑŠÐ»Ð¶Ð°Ñ‚ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾',0),(176047,4891,'ur','Ú©ÛŒ ÙˆØ¬Û Ø³Û’ ÙˆØ§Ù¾Ø³',0),(176048,4891,'sr','Ð¢Ñ€ÐµÐ±Ð°Ð»Ð¾ Ð´Ð° ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸',0),(176049,4891,'vi','Quay láº¡i',0),(176050,4891,'af','Terug Verskuldig',0),(176051,4891,'ro','Datorate Ã®napoi',0),(176052,4891,'et','Tagastamise',0),(176053,4891,'si','Naravnost nazaj',0),(176054,4891,'ba','Kembali',0),(176055,4891,'nl','Wijten terug',0),(176056,4891,'fi','Johtuu takaisin',0),(176057,4891,'no','Forfaller tilbake',0),(176058,4891,'da','Due tilbage',0),(176059,4891,'ko','ë°˜ë‚©í• ',0),(176060,4891,'he','××ž×•×¨×” ×œ×—×–×•×¨',0),(176061,4891,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ±Ï†ÎµÎ¯',0),(176062,4891,'zh','ç”±äºŽè¿”å›ž\r\n',0),(176063,4891,'sv','PÃ¥ grund av rygg',0),(176064,4891,'it','Dovuto tornare',0),(176065,4891,'tl','',0),(176066,4891,'th','&#3627;&#3621;&#3633;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(176067,4891,'hi','à¤•à¤¾à¤°à¤£ à¤ªà¥€à¤ ',0),(176068,4891,'ms','Sewajarnya kembali',0),(176069,4891,'ar','Ø§Ù„ÙˆØ§Ø¬Ø¨ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(176070,4891,'fr','Dus dos',0),(176071,4891,'jp','è¿”ç´?æœŸæ—¥',0),(176072,4891,'pt','Deve estar de volta',0),(176073,4891,'ru','Ð˜Ð·-Ð·Ð° ÑÐ¿Ð¸Ð½Ñ‹',0),(176074,4891,'es','Debido Atras',0),(176075,4891,'de','ZurÃ¼ck',0),(176076,4891,'en','Due Back',0),(176077,4892,'is','',0),(176078,4892,'dr','Ù‡ÙŠÚ† Ù…Ø¯Ø±ÙƒÙŠ Ø®Ø§Ø±Ø¬ Ù†Ø´Ø¯Ù‡ ',0),(176079,4892,'pr','Ù‡ÙŠÚ† Ù…Ø¯Ø±ÙƒÙŠ Ø®Ø§Ø±Ø¬ Ù†Ø´Ø¯Ù‡ ',0),(176080,4892,'tr','HiÃ§ kanÄ±tlarÄ± dÄ±ÅŸarÄ±',0),(176081,4892,'pl','Nie ma dowodÃ³w na',0),(176082,4892,'bg','ÐÑÐ¼Ð° Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð°',0),(176083,4892,'ur','Ø¨Ø§ÛØ± Ú©ÙˆØ¦ÛŒ Ø«Ø¨ÙˆØª',0),(176084,4892,'sr','ÐÐµÐ¼Ð° Ð´Ð¾ÐºÐ°Ð·Ð°.',0),(176085,4892,'vi','Báº£n in thá»­ chÆ°a ra',0),(176086,4892,'af','Geen proewe uit',0),(176087,4892,'ro','Nici dovezi afarÄƒ',0),(176088,4892,'et','Ãœkski tÃµestus lÃ¤bi',0),(176089,4892,'si','Brez dokazila',0),(176090,4892,'ba','Tidak ada bukti keluar',0),(176091,4892,'nl','Geen bewijzen uit',0),(176092,4892,'fi','MitÃ¤Ã¤n todisteita',0),(176093,4892,'no','Ingen bevis ut',0),(176094,4892,'da','Ingen beviser ud',0),(176095,4892,'ko','ë°–ìœ¼ë¡œ ì•„ë¬´ ì¦ê±°',0),(176096,4892,'he','××™×Ÿ ×”×•×›×—×•×ª.',0),(176097,4892,'el','ÎšÎ±Î¼Î¯Î± Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î­Î¾Ï‰',0),(176098,4892,'zh','æ²¡æœ‰è¯æ˜Žå‡º\r\n',0),(176099,4892,'sv','Inget preparerar ut',0),(176100,4892,'it','Prove fuori',0),(176101,4892,'tl','',0),(176102,4892,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3626;&#3641;&#3592;&#3609;&#3660;&#3629;&#3633;&#3585;&#3625;&#3619;',0),(176103,4892,'hi','à¤¬à¤¾à¤¹à¤° à¤•à¥‹à¤ˆ à¤¸à¤¬à¥‚à¤¤',0),(176104,4892,'ms','Bukti-bukti tidak keluar',0),(176105,4892,'ar','Ù„Ø§ Ø¨Ø±ÙˆÙØ§Øª Ø¹Ù„ÙŠÙ‡Ø§',0),(176106,4892,'fr','Pas de preuves sur',0),(176107,4892,'jp','No Proofs Out',0),(176108,4892,'pt','NÃ£o hÃ¡ provas para fora',0),(176109,4892,'ru','ÐÐµÑ‚ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²',0),(176110,4892,'es','No Hay Pruebas de ImpresiÃ³n Afuera',0),(176111,4892,'de','Keine Beweise',0),(176112,4892,'en','No Proofs Out',0),(176113,4893,'is','',0),(176114,4893,'dr','Ù…Ø¯Ø§Ø±Ùƒ Ø®Ø±ÙˆØ¬ ',0),(176115,4893,'pr','Ù…Ø¯Ø§Ø±Ùƒ Ø®Ø±ÙˆØ¬ ',0),(176116,4893,'tr','ProvalarÄ± dÄ±ÅŸarÄ±',0),(176117,4893,'pl','Dowody na',0),(176118,4893,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð°',0),(176119,4893,'ur','Ø¨Ø§ÛØ± Ú©Û’ Ø¯Ù„Ø§Ø¦Ù„',0),(176120,4893,'sr','ÐšÐ°ÐºÐ¾ Ð¸Ñ… Ð·Ð¾Ð²ÐµÑ‚Ðµ.',0),(176121,4893,'vi','Ra Báº£n in thá»­',0),(176122,4893,'af','Proewe uit',0),(176123,4893,'ro','Dovezile afarÄƒ',0),(176124,4893,'et','TÃµendid lÃ¤bi',0),(176125,4893,'si','Dokazila',0),(176126,4893,'ba','Bukti-bukti keluar',0),(176127,4893,'nl','Bewijzen uit',0),(176128,4893,'fi','Todisteet',0),(176129,4893,'no','Bevis ut',0),(176130,4893,'da','Beviser ud',0),(176131,4893,'ko','ë°–ìœ¼ë¡œ êµì •',0),(176132,4893,'he','×”×’×”×•×ª.',0),(176133,4893,'el','Î‘Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ Î­Î¾Ï‰',0),(176134,4893,'zh','è¯æ˜Žå‡º\r\n',0),(176135,4893,'sv','Preparerar ut',0),(176136,4893,'it','Prove fuori',0),(176137,4893,'tl','',0),(176138,4893,'th','&#3629;&#3629;&#3585;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;',0),(176139,4893,'hi','à¤¬à¤¾à¤¹à¤° à¤¸à¤¬à¥‚à¤¤',0),(176140,4893,'ms','Bukti-bukti Keluar',0),(176141,4893,'ar','Ø§Ù„Ø¨Ø±Ø§Ù‡ÙŠÙ† Ø¹Ù„Ù‰',0),(176142,4893,'fr','Preuves sur',0),(176143,4893,'jp','Proofs Out',0),(176144,4893,'pt','Provas para fora',0),(176145,4893,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(176146,4893,'es','Pruebas de ImpresiÃ³n Fuera',0),(176147,4893,'de','Beweise aus',0),(176148,4893,'en','Proofs Out',0),(176149,4894,'is','',0),(176150,4894,'dr','(Ù…Ù†ØªØ¸Ø±',0),(176151,4894,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø¯Ø§Ø±Ùƒ Ù…Ø¹ÙˆÙ‚(Ù…Ù†ØªØ¸Ø±',0),(176152,4894,'tr','ProvalarÄ± bekleyen raporu',0),(176153,4894,'pl','Dowody w oczekiwaniu na sprawozdanie',0),(176154,4894,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð° Ð² Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÐ»Ð°Ð´Ð°',0),(176155,4894,'ur','Ø¯Ù„Ø§Ø¦Ù„ Ø±Ù¾ÙˆØ±Ù¹ Ù…Ù„ØªÙˆÛŒ',0),(176156,4894,'sr','Ð”Ð¾ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(176157,4894,'vi','BÃ¡o cÃ¡o báº£n in thá»­ chÆ°a hoÃ n táº¥t',0),(176158,4894,'af','Proewe Afwagtende Verslag',0),(176159,4894,'ro','Dovezile Ã®n aÅŸteptarea raportului',0),(176160,4894,'et','TÃµestus kuni aruande',0),(176161,4894,'si','Dokazila do poroÄila',0),(176162,4894,'ba','Bukti-bukti yang tertunda laporan',0),(176163,4894,'nl','Bewijzen in afwachting van rapport',0),(176164,4894,'fi','Todisteet ennen raportin',0),(176165,4894,'no','Bevis venter rapport',0),(176166,4894,'da','Oprindelsesbeviser indtil rapport',0),(176167,4894,'ko','êµì • ë³´ê³ ì„œ ë³´ë¥˜',0),(176168,4894,'he','×”×’×”×•×ª ×ž×ž×ª×™× ×™× ×—',0),(176169,4894,'el','Î‘Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ Ï„Î·Ï‚ ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î® Î­ÎºÎ¸ÎµÏƒÎ·Ï‚',0),(176170,4894,'zh','å¾…è¯æ˜Žçš„æŠ¥å‘Š\r\n',0),(176171,4894,'sv','Preparerar i avvaktan pÃ¥ rapporten',0),(176172,4894,'it','Prove in attesa della relazione',0),(176173,4894,'tl','',0),(176174,4894,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(176175,4894,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤²à¤‚à¤¬à¤¿à¤¤ à¤¸à¤¬à¥‚à¤¤',0),(176176,4894,'ms','Bukti-bukti sementara menunggu Laporan',0),(176177,4894,'ar','Ø¨Ø±ÙˆÙØ§Øª Ø§Ù†ØªØ¸Ø§Ø±Ø§ Ù„ØªÙ‚Ø±ÙŠØ±',0),(176178,4894,'fr','Preuves dans l\'attente de rapport',0),(176179,4894,'jp','æ ¡æ­£ä¿?ç•™ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(176180,4894,'pt','Provas pendentes relatÃ³rio',0),(176181,4894,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð° Ð´Ð¾ Ð´Ð¾ÐºÐ»Ð°Ð´Ð°',0),(176182,4894,'es','Prueba de ImpresiÃ³n Pendientes hasta Informe',0),(176183,4894,'de','Beweise ausstehende Bericht',0),(176184,4894,'en','Proofs Pending Report',0),(176185,4895,'is','',0),(176186,4895,'dr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ Ù‡ÙØªÙ‡ ',0),(176187,4895,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ Ù‡ÙØªÙ‡ ',0),(176188,4895,'tr','Hafta boyunca hiÃ§ bir etkinlik',0),(176189,4895,'pl','Brak aktywnoÅ›ci na tydzieÅ„',0),(176190,4895,'bg','ÐÑÐ¼Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(176191,4895,'ur','Ú©ÙˆØ¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ ÛÙØªÛ Ú©Û’ Ù„Ø¦Û’',0),(176192,4895,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð½ÐµÐ´ÐµÑ™Ñƒ Ð´Ð°Ð½Ð°',0),(176193,4895,'vi','KhÃ´ng hoáº¡t Ä‘á»™ng cho tuáº§n',0),(176194,4895,'af','Geen Aktiwiteit vir Week',0),(176195,4895,'ro','Nici o activitate pentru sÄƒptÄƒmÃ¢na',0),(176196,4895,'et','NÃ¤dala jooksul tegevusi pole',0),(176197,4895,'si','No dejavnost za teden',0),(176198,4895,'ba','Tidak ada kegiatan untuk minggu',0),(176199,4895,'nl','Geen activiteit voor Week',0),(176200,4895,'fi','Ei toimintaa viikon',0),(176201,4895,'no','Ingen aktivitet for uke',0),(176202,4895,'da','Ingen aktivitet i uge',0),(176203,4895,'ko','ì£¼ì— ëŒ€ í•œ í™œë™ì´ ì—†ìŠµë‹ˆë‹¤',0),(176204,4895,'he','××™×Ÿ ×¤×¢×™×œ×•×ª ×‘×©×‘×•×¢',0),(176205,4895,'el','ÎšÎ±Î¼Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î³Î¹Î± Ï„Î·Î½ ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(176206,4895,'zh','æ²¡æœ‰å‘¨æ´»åŠ¨\r\n',0),(176207,4895,'sv','Ingen aktivitet i vecka',0),(176208,4895,'it','Nessuna attivitÃ  per settimana',0),(176209,4895,'tl','',0),(176210,4895,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(176211,4895,'hi','à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(176212,4895,'ms','Tiada aktiviti untuk minggu',0),(176213,4895,'ar','Ù„Ø§ Ù†Ø´Ø§Ø· Ù„Ù…Ø¯Ø© Ø£Ø³Ø¨ÙˆØ¹',0),(176214,4895,'fr','Aucune activitÃ© pour la semaine',0),(176215,4895,'jp','é€±ã?®æ´»å‹•ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(176216,4895,'pt','Nenhuma atividade por semana',0),(176217,4895,'ru','ÐÐµÑ‚ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° ÐÐµÐ´ÐµÐºÐ»ÑŽ',0),(176218,4895,'es','No Hay Actividad por una Semana',0),(176219,4895,'de','Keine Ereignisse fÃ¼r die Woche',0),(176220,4895,'en','No Activity for Week',0),(176221,4896,'is','',0),(176222,4896,'dr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´',0),(176223,4896,'pr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´',0),(176224,4896,'tr','SipariÅŸ birimi raporu yazdÄ±rma',0),(176225,4896,'pl','Drukuj raport wielkoÅ›ci zamÃ³wienia',0),(176226,4896,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(176227,4896,'ur','ØªØ±ØªÛŒØ¨ ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(176228,4896,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(176229,4896,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng in',0),(176230,4896,'af','Druk Bestel Volume Verslag',0),(176231,4896,'ro','Raport de volum ordine de imprimare',0),(176232,4896,'et','Tellimuse mahu aruande printimine',0),(176233,4896,'si','Natisni poroÄilo obsega nalog',0),(176234,4896,'ba','Mencetak Laporan Volume pesanan',0),(176235,4896,'nl','Volgorde Volume rapport afdrukken',0),(176236,4896,'fi','Tilausten mÃ¤Ã¤rÃ¤-raportin tulostaminen',0),(176237,4896,'no','Skrive ut volum rapport',0),(176238,4896,'da','Udskrive ordre volumen rapport',0),(176239,4896,'ko','ì£¼ë¬¸ ë³¼ë¥¨ ë³´ê³ ì„œ ì¸ì‡„',0),(176240,4896,'he','×”×“×¤×¡ ×“×•×— × ×¤×— ×¡×“×¨',0),(176241,4896,'el','ÎŒÎ³ÎºÎ¿Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(176242,4896,'zh','æ‰“å°è®¢å•é‡æŠ¥å‘Š\r\n',0),(176243,4896,'sv','Skriva ut rapporten Order volym',0),(176244,4896,'it','Stampare Report Volume Order',0),(176245,4896,'tl','',0),(176246,4896,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3593;&#3610;&#3633;&#3610;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(176247,4896,'hi','à¤†à¤¦à¥‡à¤¶ à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(176248,4896,'ms','Mencetak laporan jumlah pesanan',0),(176249,4896,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªÙ‚Ø±ÙŠØ± ÙˆØ­Ø¯Ø© ØªØ®Ø²ÙŠÙ† Ø§Ù„Ù†Ø¸Ø§Ù…',0),(176250,4896,'fr','Imprimer le rapport de Volume de commande',0),(176251,4896,'jp','æ³¨æ–‡é‡?ãƒ¬ãƒ?ãƒ¼ãƒˆã?®å?°åˆ·',0),(176252,4896,'pt','Imprimir relatÃ³rio de Volume de ordem',0),(176253,4896,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° Ð¾Ð±ÑŠÐµÐ¼ Ð·Ð°ÐºÐ°Ð·Ð°',0),(176254,4896,'es','Orden de Imprimir Informe de VolÃºmen',0),(176255,4896,'de','Drucken von Volume-Bericht bestellen',0),(176256,4896,'en','Print Order Volume Report',0),(176257,4897,'is','',0),(176258,4897,'dr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… ',0),(176259,4897,'pr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… ',0),(176260,4897,'tr','Birim raporu yazdÄ±rma',0),(176261,4897,'pl','Drukowanie raportu',0),(176262,4897,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼',0),(176263,4897,'ur','ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(176264,4897,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð° Ð·Ð° Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½',0),(176265,4897,'vi','In bÃ¡o cÃ¡o khá»‘i lÆ°á»£ng',0),(176266,4897,'af','Druk Volume Verslag',0),(176267,4897,'ro','Volum de imprimare raport',0),(176268,4897,'et','KÃ¶itega aruanne',0),(176269,4897,'si','Natisni poroÄilo obsega',0),(176270,4897,'ba','Mencetak Laporan Volume',0),(176271,4897,'nl','Volume rapport afdrukken',0),(176272,4897,'fi','MÃ¤Ã¤rÃ¤-raportin tulostaminen',0),(176273,4897,'no','Skrive ut volum',0),(176274,4897,'da','Udskrive volumen rapport',0),(176275,4897,'ko','ë³¼ë¥¨ ë³´ê³ ì„œ ì¸ì‡„',0),(176276,4897,'he','×”×“×¤×¡ ×“×•×— × ×¤×—',0),(176277,4897,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„Î¿Ï… ÏŒÎ³ÎºÎ¿Ï…',0),(176278,4897,'zh','æ‰“å°é‡æŠ¥å‘Š\r\n',0),(176279,4897,'sv','Skriva ut rapporten volym',0),(176280,4897,'it','Stampare Report Volume',0),(176281,4897,'tl','',0),(176282,4897,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3593;&#3610;&#3633;&#3610;',0),(176283,4897,'hi','à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(176284,4897,'ms','Mencetak laporan jumlah',0),(176285,4897,'ar','ØªÙ‚Ø±ÙŠØ± Ø­Ø¬Ù… Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(176286,4897,'fr','Rapport Volume d\'impression',0),(176287,4897,'jp','å‡ºæ?¥é«˜ãƒ¬ãƒ?ãƒ¼ãƒˆã?®å?°åˆ·',0),(176288,4897,'pt','RelatÃ³rio de Volume de impressÃ£o',0),(176289,4897,'ru','ÐžÐ±ÑŠÐµÐ¼ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(176290,4897,'es','Informe de VolÃºmen de ImpresiÃ³n',0),(176291,4897,'de','Druckvolumen Bericht',0),(176292,4897,'en','Print Volume Report',0),(176293,4898,'is','',0),(176294,4898,'dr',': ÙŠÙƒ Ù‡ÙØªÙ‡ ',0),(176295,4898,'pr','Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´  : ÙŠÙƒ Ù‡ÙØªÙ‡ ',0),(176296,4898,'tr','Hacim: bir hafta sipariÅŸ',0),(176297,4898,'pl','ZamÃ³w Tom - tydzieÅ„',0),(176298,4898,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð¾Ð±ÐµÐ¼ - ÐµÐ´Ð½Ð° ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(176299,4898,'ur','ØµÙˆØª - Ø§ÛŒÚ© ÛÙØªÛ’ Ú©Ø§ Ø­Ú©Ù…',0),(176300,4898,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - Ñ˜ÐµÐ´Ð½Ñƒ ÑÐµÐ´Ð¼Ð¸Ñ†Ñƒ',0),(176301,4898,'vi','Khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng - 1 tuáº§n',0),(176302,4898,'af','Bestelling Volume:  Een Week',0),(176303,4898,'ro','Comanda volum - o sÄƒptÄƒmÃ¢nÄƒ',0),(176304,4898,'et','Tellimuse maht - Ã¼ks nÃ¤dal',0),(176305,4898,'si','NaroÄite nosilca - en teden',0),(176306,4898,'ba','Memesan Volume - satu minggu',0),(176307,4898,'nl','Bestel Volume - Ã©Ã©n Week',0),(176308,4898,'fi','Tilaa Volume - viikko',0),(176309,4898,'no','Bestille volum - en uke',0),(176310,4898,'da','Bestil volumen - en uge',0),(176311,4898,'ko','ì£¼ë¬¸ ì–‘-1 ì£¼ì¼',0),(176312,4898,'he','×”×–×ž× ×ª ××—×¡×•×Ÿ - ×©×‘×•×¢ ××—×“',0),(176313,4898,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Ï„ÏŒÎ¼Î¿Ï‚ - Î¼Î¯Î± ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(176314,4898,'zh','è®¢å•é‡-ä¸€å‘¨\r\n',0),(176315,4898,'sv','BestÃ¤ll volym - en vecka',0),(176316,4898,'it','Ordinare il Volume - una settimana',0),(176317,4898,'tl','',0),(176318,4898,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; - 1 &#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(176319,4898,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ - à¤à¤• à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(176320,4898,'ms','Perintah Volume - satu minggu',0),(176321,4898,'ar','ØªØ±ØªÙŠØ¨ ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†--Ø£Ø³Ø¨ÙˆØ¹ ÙˆØ§Ø­Ø¯',0),(176322,4898,'fr','Commander le Volume - une semaine',0),(176323,4898,'jp','æ³¨æ–‡é‡?ãƒ¼ï¼‘é€±é–“',0),(176324,4898,'pt','Ordem Volume - uma semana',0),(176325,4898,'ru','ÐžÐ±ÑŠÐµÐ¼ - Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ð¾Ð´Ð½Ð¾Ð¹ Ð½ÐµÐ´ÐµÐ»Ð¸',0),(176326,4898,'es','VolÃºmen de Ordenes: Una Semana',0),(176327,4898,'de','Auftragsvolumen Sie - eine Woche',0),(176328,4898,'en','Order Volume - One Week',0),(176329,4899,'is','',0),(176330,4899,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§  Ù†ÙŠØ³Øª',0),(176331,4899,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§  Ù†ÙŠØ³Øª',0),(176332,4899,'tr','Maddeyi oluÅŸturan bakamadÄ±m',0),(176333,4899,'pl','Nie moÅ¼na wyszukaÄ‡ element',0),(176334,4899,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ñ‚ÑŠÑ€ÑÐ¸Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(176335,4899,'ur','Ø´Û’ Ú©Ùˆ Ù†Û Ø¯ÛŒÚ©Ú¾ Ø³Ú©ÛŒÚº',0),(176336,4899,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð¿Ð¾Ñ‚Ñ€Ð°Ð·Ð¸Ñ‚Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(176337,4899,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ ng',0),(176338,4899,'af','Was nie instaat om \'n Item op te soek nie',0),(176339,4899,'ro','Nu ar putea cÄƒuta elementul',0),(176340,4899,'et','VÃµiks otsida kauba',0),(176341,4899,'si','Ne bi si artikel',0),(176342,4899,'ba','Tidak bisa mencari Item',0),(176343,4899,'nl','Kan niet opzoeken Item',0),(176344,4899,'fi','Ei voitu hakea kohdetta',0),(176345,4899,'no','Kan ikke slÃ¥ opp varen',0),(176346,4899,'da','Kunne ikke finde varen',0),(176347,4899,'ko','í•­ëª©ì„ ë³´ì§€ ëª»',0),(176348,4899,'he','×œ× ×™×›×•×œ ×œ×—×¤×© ×¤×¨×™×˜',0),(176349,4899,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÏƒÎ± Î½Î± Î´Ï‰ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(176350,4899,'zh','æ— æ³•æŸ¥æ‰¾ç‰©å“\r\n',0),(176351,4899,'sv','Kunde inte se upp objekt',0),(176352,4899,'it','Impossibile non cercare la voce',0),(176353,4899,'tl','',0),(176354,4899,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3604;&#3641;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3604;&#3657;',0),(176355,4899,'hi','à¤Šà¤ªà¤° à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤²à¤— à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(176356,4899,'ms','Tidak dapat melihat perkara',0),(176357,4899,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø¹Ù†ØµØ±',0),(176358,4899,'fr','Ne pouvait pas regarder le point',0),(176359,4899,'jp','å“?ç›®ã‚’èª¿ã?¹ã‚‰ã‚Œã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(176360,4899,'pt','NÃ£o podemos ver Item',0),(176361,4899,'ru','ÐÐµ Ð¼Ð¾Ð³ ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð¿ÑƒÐ½ÐºÑ‚',0),(176362,4899,'es','No se puede Buscar el Item',0),(176363,4899,'de','Element konnte nicht nachgeschlagen werden',0),(176364,4899,'en','Could Not Look Up Item',0),(176365,4900,'is','',0),(176366,4900,'dr','Ù…Ø­Ù„ Ø¯Ø±ÙŠØ§ÙØª ',0),(176367,4900,'pr','Ù…Ø­Ù„ Ø¯Ø±ÙŠØ§ÙØª ',0),(176368,4900,'tr','Alma konumu',0),(176369,4900,'pl','Odbierania lokalizacji',0),(176370,4900,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¼ÑÑÑ‚Ð¾',0),(176371,4900,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(176372,4900,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð¸ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(176373,4900,'vi','Vá»‹ trÃ­ nháº­n',0),(176374,4900,'af','Ontvangs Ligging',0),(176375,4900,'ro','Primi locaÅ£ie',0),(176376,4900,'et','Asukohateabe',0),(176377,4900,'si','PrikaÅ¾e lokacijo',0),(176378,4900,'ba','Menerima lokasi',0),(176379,4900,'nl','Ontvangen van locatie',0),(176380,4900,'fi','Vastaanottaa sijainti',0),(176381,4900,'no','Motta plasseringen',0),(176382,4900,'da','Modtage placering',0),(176383,4900,'ko','ìˆ˜ì‹  ìœ„ì¹˜',0),(176384,4900,'he','×§×‘×œ×ª ×ž×™×§×•×',0),(176385,4900,'el','Î›Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î¸Î­ÏƒÎ·',0),(176386,4900,'zh','æŽ¥æ”¶ä½ç½®\r\n',0),(176387,4900,'sv','FÃ¥r plats',0),(176388,4900,'it','Indirizzo di ricezione',0),(176389,4900,'tl','',0),(176390,4900,'th','&#3619;&#3633;&#3610;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(176391,4900,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¥‡à¤‚',0),(176392,4900,'ms','Menerima lokasi',0),(176393,4900,'ar','Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø¥Ø³ØªÙ„Ø§Ù…',0),(176394,4900,'fr','Emplacement de rÃ©ception',0),(176395,4900,'jp','ä½?ç½®ã‚’å?—é ˜',0),(176396,4900,'pt','Local de recebimento',0),(176397,4900,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(176398,4900,'es','UbicaciÃ³n de Recibir',0),(176399,4900,'de','Empfangsspeicherort',0),(176400,4900,'en','Receive Location',0),(176401,4901,'is','',0),(176402,4901,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ\r\n (BOL or Other)',0),(176403,4901,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ\r\n (BOL or Other)',0),(176404,4901,'tr','Ä°zleme numarasÄ± (BOL ya da diÄŸer)',0),(176405,4901,'pl','Numer identyfikacyjny (BOL lub inne)',0),(176406,4901,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ (Ð‘Ð¾Ð» Ð¸Ð»Ð¸ Ð´Ñ€ÑƒÐ³Ð¸)',0),(176407,4901,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ù†Ù…Ø¨Ø± (Ø¨ÙˆÙ„ ÛŒØ§ Ø¯ÙˆØ³Ø±Û’)',0),(176408,4901,'sr','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜ (Ð‘ÐžÐ› Ð¸Ð»Ð¸ Ð½ÐµÐºÐ¸Ð¼ Ð´Ñ€ÑƒÐ³Ð¸Ð¼)',0),(176409,4901,'vi','DÃ² tÃ¬m sá»‘ (BOL hay khÃ¡c)',0),(176410,4901,'af','Tracking nommer (BOL of ander)',0),(176411,4901,'ro','NumÄƒr de urmÄƒrire (BOL sau alte)',0),(176412,4901,'et','JÃ¤lgimise numbri (BOL vÃµi muu)',0),(176413,4901,'si','Å tevilka sledenja (BOL ali drugo)',0),(176414,4901,'ba','Nomor pelacakan (BOL atau lainnya)',0),(176415,4901,'nl','Tracking-nummer (BOL of andere)',0),(176416,4901,'fi','Seurantanumeron (BOL tai muu)',0),(176417,4901,'no','Sporingsnummeret (BOL eller andre)',0),(176418,4901,'da','Sporingsnummer (BOL eller andet)',0),(176419,4901,'ko','ì¶”ì  ë²ˆí˜¸ (BOL ë˜ëŠ” ê¸°íƒ€)',0),(176420,4901,'he','×ž×¡×¤×¨ ×ž×¢×§×‘ (×‘×•×œ ××• ×”×©× ×™)',0),(176421,4901,'el','Î Î±ÏÏ„Î¯Î´Î±Ï‚ (BOL Î® Î¬Î»Î»Î¿)',0),(176422,4901,'zh','è¿½è¸ªå·ç ï¼ˆæè´§å•æˆ–å…¶å®ƒï¼‰\r\n',0),(176423,4901,'sv','SpÃ¥rningsnummer (BOL eller annan)',0),(176424,4901,'it','Numero di tracking (BOL o altro)',0),(176425,4901,'tl','',0),(176426,4901,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;(BOL or Other)',0),(176427,4901,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤¨à¤‚à¤¬à¤° (à¤¬à¥‹à¤² à¤¯à¤¾ à¤…à¤¨à¥à¤¯)',0),(176428,4901,'ms','Nombor Penjejakan (BOL atau lain-lain)',0),(176429,4901,'ar','Ø±Ù‚Ù… ØªØªØ¨Ø¹ (BOL Ø£Ùˆ ØºÙŠØ±Ù‡Ø§)',0),(176430,4901,'fr','NumÃ©ro de suivi (BOL ou autre)',0),(176431,4901,'jp','ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°ç•ªå?·ï¼ˆBOLå?ˆã?¯ã??ã?®ä»–ï¼‰',0),(176432,4901,'pt','NÃºmero de rastreamento (BOL ou outro)',0),(176433,4901,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð´Ð»Ñ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ (Ð‘Ð¾Ð» Ð¸Ð»Ð¸ Ð´Ñ€.)',0),(176434,4901,'es','NÃºmero de Rastreo (BOL u Otro)',0),(176435,4901,'de','Tracking-Nummer (BOL oder andere)',0),(176436,4901,'en','Tracking Number (BOL&nbsp;or&nbsp;Other)',0),(176437,4902,'is','',0),(176438,4902,'dr',': ÙŠÙƒ Ù…Ø§Ù‡',0),(176439,4902,'pr','Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´  : ÙŠÙƒ Ù…Ø§Ù‡',0),(176440,4902,'tr','Hacim: bir ay sipariÅŸ',0),(176441,4902,'pl','ZamÃ³w Tom - miesiÄ…c',0),(176442,4902,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð¾Ð±ÐµÐ¼ - ÐµÐ´Ð¸Ð½ Ð¼ÐµÑÐµÑ†',0),(176443,4902,'ur','ØµÙˆØª - Ø§ÛŒÚ© Ù…Ø§Û Ú©Ø§ Ø­Ú©Ù…',0),(176444,4902,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(176445,4902,'vi','Khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng - 1 thÃ¡ng',0),(176446,4902,'af','Bestelling Volume:  Een Maand',0),(176447,4902,'ro','Comanda volum - o lunÄƒ',0),(176448,4902,'et','Tellimuse maht - kuu aega',0),(176449,4902,'si','Naloga obsega - en mesec',0),(176450,4902,'ba','Memesan Volume - satu bulan',0),(176451,4902,'nl','Bestel Volume - Ã©Ã©n maand',0),(176452,4902,'fi','Tilaa Volume - kuukauden',0),(176453,4902,'no','Bestille volum - en mÃ¥ned',0),(176454,4902,'da','Bestil volumen - en mÃ¥ned',0),(176455,4902,'ko','ì£¼ë¬¸ ì–‘-í•œ ë‹¬',0),(176456,4902,'he','×”×–×ž× ×ª ××—×¡×•×Ÿ - ×—×•×“×© ××—×“',0),(176457,4902,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Ï„ÏŒÎ¼Î¿Ï‚ - Î­Î½Î± Î¼Î®Î½Î±',0),(176458,4902,'zh','è®¢å•é‡-ä¸€ä¸ªæœˆ\r\n',0),(176459,4902,'sv','BestÃ¤ll volym - en mÃ¥nad',0),(176460,4902,'it','Ordinare il Volume - un mese',0),(176461,4902,'tl','',0),(176462,4902,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; - 1 &#3648;&#3604;&#3639;&#3629;&#3609;',0),(176463,4902,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ - à¤à¤• à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(176464,4902,'ms','Perintah Volume - satu bulan',0),(176465,4902,'ar','ØªØ±ØªÙŠØ¨ ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†--Ø´Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(176466,4902,'fr','Commander le Volume - un mois',0),(176467,4902,'jp','æ³¨æ–‡é‡?ãƒ¼ï¼‘ãƒ¶æœˆ',0),(176468,4902,'pt','Ordem Volume - um mÃªs',0),(176469,4902,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾Ð±ÑŠÐµÐ¼ - Ð¾Ð´Ð¸Ð½ Ð¼ÐµÑÑÑ†',0),(176470,4902,'es','VolÃºmen de Ordenes: Un Mes',0),(176471,4902,'de','Auftragsvolumen Sie - einen Monat',0),(176472,4902,'en','Order Volume - One Month',0),(176473,4903,'is','',0),(176474,4903,'dr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù‡ ',0),(176475,4903,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù‡ ',0),(176476,4903,'tr','Ay boyunca hiÃ§ bir etkinlik',0),(176477,4903,'pl','Brak aktywnoÅ›ci na miesiÄ…c',0),(176478,4903,'bg','ÐÑÐ¼Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° Ð¼ÐµÑÐµÑ†',0),(176479,4903,'ur','Ù…ÛÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ Ú©ÙˆØ¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(176480,4903,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(176481,4903,'vi','KhÃ´ng hoáº¡t Ä‘á»™ng cho thÃ¡ng',0),(176482,4903,'af','Geen Aktiwiteit vir Maand',0),(176483,4903,'ro','Nici o activitate pentru luna',0),(176484,4903,'et','Kuu aja jooksul tegevusi pole',0),(176485,4903,'si','No dejavnost za mesec',0),(176486,4903,'ba','Tidak ada kegiatan bulan',0),(176487,4903,'nl','Geen activiteit voor maand',0),(176488,4903,'fi','Passiiviset kuukauden',0),(176489,4903,'no','Ingen aktivitet for mÃ¥ned',0),(176490,4903,'da','Ingen aktivitet for mÃ¥ned',0),(176491,4903,'ko','ë‹¬ì— ëŒ€ í•œ í™œë™ì´ ì—†ìŠµë‹ˆë‹¤',0),(176492,4903,'he','××™×Ÿ ×¤×¢×™×œ×•×ª ×œ×—×•×“×©',0),(176493,4903,'el','ÎšÎ±Î¼Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î³Î¹Î± Ï„Î¿ Î¼Î®Î½Î±',0),(176494,4903,'zh','æ²¡æœ‰æœˆæ´»åŠ¨\r\n',0),(176495,4903,'sv','Ingen aktivitet fÃ¶r mÃ¥nad',0),(176496,4903,'it','Nessuna attivitÃ  per mese',0),(176497,4903,'tl','',0),(176498,4903,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(176499,4903,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(176500,4903,'ms','Tiada aktiviti pada bulan',0),(176501,4903,'ar','Ù„Ø§ Ù†Ø´Ø§Ø· Ù„Ù…Ø¯Ø© Ø´Ù‡Ø±',0),(176502,4903,'fr','Aucune activitÃ© pour le mois',0),(176503,4903,'jp','æœˆã?®æ´»å‹•ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(176504,4903,'pt','Nenhuma atividade por mÃªs',0),(176505,4903,'ru','ÐÐµÑ‚ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° ÐœÐµÑÑÑ†',0),(176506,4903,'es','No Hay Actividad para el Mes',0),(176507,4903,'de','Keine Ereignisse fÃ¼r Monat',0),(176508,4903,'en','No Activity for Month',0),(176509,4904,'is','',0),(176510,4904,'dr','- ÙŠÙƒ Ù…Ø§Ù‡ ',0),(176511,4904,'pr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ - ÙŠÙƒ Ù…Ø§Ù‡ ',0),(176512,4904,'tr','SipariÅŸ birimi raporu - bir ay YazdÄ±r',0),(176513,4904,'pl','Drukuj raport wielkoÅ›Ä‡ zamÃ³wienia - miesiÄ…c',0),(176514,4904,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° - ÐµÐ´Ð¸Ð½ Ð¼ÐµÑÐµÑ†',0),(176515,4904,'ur','ØªØ±ØªÛŒØ¨ ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹ - Ø§ÛŒÚ© Ù…Ø§Û Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(176516,4904,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸ - Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(176517,4904,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng in - má»™t thÃ¡ng',0),(176518,4904,'af','Druk Bestel Volume Verslag - Een Maand',0),(176519,4904,'ro','Imprima ordinea volumului raport - o lunÄƒ',0),(176520,4904,'et','Printida tellimuse mahu aruande - kuu aega',0),(176521,4904,'si','Tiskanje nalog obsega poroÄilo - en mesec',0),(176522,4904,'ba','Mencetak Laporan Volume pesanan - satu bulan',0),(176523,4904,'nl','Volgorde Volume rapport - Ã©Ã©n maand afdrukken',0),(176524,4904,'fi','Tulosta tilavuus raportti - kuukauden',0),(176525,4904,'no','Skrive ut volum rapport - en mÃ¥ned',0),(176526,4904,'da','Udskrive ordre volumen rapport - en mÃ¥ned',0),(176527,4904,'ko','ì¸ì‡„ ì£¼ë¬¸ ë³¼ë¥¨ ë³´ê³ ì„œ-1 ê°œì›”',0),(176528,4904,'he','×”×“×¤×¡ ×“×•×— × ×¤×— ×¡×“×¨ - ×—×•×“×© ××—×“',0),(176529,4904,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏŒÎ³ÎºÎ¿Ï… - Î¼Î·Î½ÏŒÏ‚',0),(176530,4904,'zh','æ‰“å°è®¢å•é‡æŠ¥å‘Š -ä¸€ä¸ªæœˆ\r\n',0),(176531,4904,'sv','Skriva ut rapporten Order volym - en mÃ¥nad',0),(176532,4904,'it','Stampare Report Volume di ordine - un mese',0),(176533,4904,'tl','',0),(176534,4904,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3593;&#3610;&#3633;&#3610;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; - &#3627;&#3609;&#3638;&#3656;&#3591;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(176535,4904,'hi','à¤†à¤¦à¥‡à¤¶ à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ - à¤à¤• à¤®à¤¾à¤¹ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(176536,4904,'ms','Mencetak laporan jumlah pesanan - satu bulan',0),(176537,4904,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªÙ‚Ø±ÙŠØ± Ø­Ø¬Ù… Ø£Ù…Ø±-Ø´Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(176538,4904,'fr','Imprimer l\'Ã©tat du Volume de commande - un mois',0),(176539,4904,'jp','æ³¨æ–‡é‡?ãƒ¬ãƒ?ãƒ¼ãƒˆã?®å?°åˆ·ãƒ¼ï¼‘ãƒ¶æœˆ',0),(176540,4904,'pt','Imprimir relatÃ³rio de Volume de ordem - um mÃªs',0),(176541,4904,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð° Ð¾Ð±ÑŠÐµÐ¼ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° - Ð¾Ð´Ð¸Ð½ Ð¼ÐµÑÑÑ†',0),(176542,4904,'es','Orden de Imprimir Informe de VolÃºmen - Un Mes',0),(176543,4904,'de','Drucken Sie Auftrag Band Berichts - einen Monat',0),(176544,4904,'en','Print Order Volume Report - One Month',0),(176545,4905,'is','',0),(176546,4905,'dr','Ù‡ÙØªÙ‡ Ø§Ø² ',0),(176547,4905,'pr','Ù‡ÙØªÙ‡ Ø§Ø² ',0),(176548,4905,'tr','Hafta',0),(176549,4905,'pl','TydzieÅ„',0),(176550,4905,'bg','Ð¡ÐµÐ´Ð¼Ð¸Ñ†Ð° Ð½Ð°',0),(176551,4905,'ur','ÛÙØªÛ',0),(176552,4905,'sr','Ð¡ÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(176553,4905,'vi','Tuáº§n cá»§a',0),(176554,4905,'af','Week van',0),(176555,4905,'ro','SÄƒptÄƒmÃ¢na de',0),(176556,4905,'et','NÃ¤dal',0),(176557,4905,'si','Teden',0),(176558,4905,'ba','Minggu',0),(176559,4905,'nl','Week van',0),(176560,4905,'fi','Viikon',0),(176561,4905,'no','Uke',0),(176562,4905,'da','Uge af',0),(176563,4905,'ko','ì£¼',0),(176564,4905,'he','×©×‘×•×¢ ×©×œ',0),(176565,4905,'el','Î•Î²Î´Î¿Î¼Î¬Î´Î± Ï„Î·Ï‚',0),(176566,4905,'zh','å‘¨\r\n',0),(176567,4905,'sv','Veckan i',0),(176568,4905,'it','Settimana di',0),(176569,4905,'tl','',0),(176570,4905,'th','&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;&#3586;&#3629;&#3591;',0),(176571,4905,'hi','à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤•à¥‡',0),(176572,4905,'ms','Minggu',0),(176573,4905,'ar','Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ Ù…Ù†',0),(176574,4905,'fr','Semaine de',0),(176575,4905,'jp','ï½žã?®é€±',0),(176576,4905,'pt','Semana de',0),(176577,4905,'ru','ÐšÐ¾Ð½ÐµÑ† ÐÐµÐ´ÐµÐ»Ð¸',0),(176578,4905,'es','Semana De',0),(176579,4905,'de','Woche der',0),(176580,4905,'en','Week Of',0),(176581,4906,'is','',0),(176582,4906,'dr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(176583,4906,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(176584,4906,'tr','YÄ±l boyunca hiÃ§ bir etkinlik',0),(176585,4906,'pl','Brak aktywnoÅ›ci na rok',0),(176586,4906,'bg','ÐÑÐ¼Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(176587,4906,'ur','Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ Ú©ÙˆØ¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(176588,4906,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(176589,4906,'vi','KhÃ´ng hoáº¡t Ä‘á»™ng cho NÄƒm',0),(176590,4906,'af','Geen Aktiwiteit vir Jaar',0),(176591,4906,'ro','Nici o activitate pentru anul',0),(176592,4906,'et','Aasta jooksul tegevusi pole',0),(176593,4906,'si','No dejavnost za leto',0),(176594,4906,'ba','Tidak ada kegiatan untuk tahun',0),(176595,4906,'nl','Geen enkele activiteit plaatsvindt jaar',0),(176596,4906,'fi','Ei toimintaa vuoden',0),(176597,4906,'no','Ingen aktivitet for Ã¥r',0),(176598,4906,'da','Ingen aktivitet for Ã¥ret',0),(176599,4906,'ko','1 ë…„ ë™ì•ˆ ì•„ë¬´ í™œë™',0),(176600,4906,'he','××™×Ÿ ×¤×¢×™×œ×•×ª ×‘×©× ×”',0),(176601,4906,'el','ÎšÎ±Î¼Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚',0),(176602,4906,'zh','æ²¡æœ‰ä¸Žå¹´æ´»åŠ¨\r\n',0),(176603,4906,'sv','Ingen aktivitet fÃ¶r Ã¥ret',0),(176604,4906,'it','Nessuna attivitÃ  per anno',0),(176605,4906,'tl','',0),(176606,4906,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3637;',0),(176607,4906,'hi','à¤¸à¤¾à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(176608,4906,'ms','Tiada aktiviti bagi tahun',0),(176609,4906,'ar','Ù„Ø§ Ù†Ø´Ø§Ø· Ù„Ù„Ø³Ù†Ø©',0),(176610,4906,'fr','Aucune activitÃ© pour l\'annÃ©e',0),(176611,4906,'jp','ä»Šå¹´ã?®æ´»å‹•ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(176612,4906,'pt','Nenhuma atividade por ano',0),(176613,4906,'ru','ÐÐµÑ‚ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð“Ð¾Ð´',0),(176614,4906,'es','No Hay Actividad por un AÃ±o',0),(176615,4906,'de','Keine Ereignisse fÃ¼r das Jahr',0),(176616,4906,'en','No Activity for Year',0),(176617,4907,'is','',0),(176618,4907,'dr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ â€“ ÙŠÙƒ Ø³Ø§Ù„ ',0),(176619,4907,'pr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ â€“ ÙŠÙƒ Ø³Ø§Ù„ ',0),(176620,4907,'tr','SipariÅŸ birimi raporu - bir yÄ±l YazdÄ±r',0),(176621,4907,'pl','Drukuj raport wielkoÅ›Ä‡ zamÃ³wienia - jeden rok',0),(176622,4907,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° - ÐµÐ´Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(176623,4907,'ur','ØªØ±ØªÛŒØ¨ ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹ - Ø§ÛŒÚ© Ø³Ø§Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(176624,4907,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸ - Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(176625,4907,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng in - má»™t nÄƒm',0),(176626,4907,'af','Druk Bestel Volume Verslag - Een Jaar',0),(176627,4907,'ro','Imprima ordinea volumului raport - un an',0),(176628,4907,'et','Printida tellimuse mahu aruande - aasta',0),(176629,4907,'si','Tiskanje nalog obsega poroÄilo - eno leto',0),(176630,4907,'ba','Mencetak Laporan Volume pesanan - satu tahun',0),(176631,4907,'nl','Volgorde Volume rapport afdrukken - Ã©Ã©n jaar',0),(176632,4907,'fi','Tulosta tilavuus raportti - vuosi',0),(176633,4907,'no','Skrive ut volum rapport - ett Ã¥r',0),(176634,4907,'da','Udskrive ordre volumen rapport - et Ã¥r',0),(176635,4907,'ko','ì¸ì‡„ ì£¼ë¬¸ ë³¼ë¥¨ ë³´ê³ ì„œ-1 ë…„',0),(176636,4907,'he','×”×“×¤×¡ ×“×•×— × ×¤×— ×¡×“×¨ - ×©× ×” ××—×ª',0),(176637,4907,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï„ÏŒÎ¼Î¿Ï‚ - Î­Î½Î± Î­Ï„Î¿Ï‚',0),(176638,4907,'zh','æ‰“å°è®¢å•é‡æŠ¥å‘Š -ä¸€å¹´\r\n',0),(176639,4907,'sv','Skriva ut rapporten Order volym - ett Ã¥r',0),(176640,4907,'it','Stampare Report Volume di ordine - un anno',0),(176641,4907,'tl','',0),(176642,4907,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3593;&#3610;&#3633;&#3610;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; - &#3627;&#3609;&#3638;&#3656;&#3591;&#3611;&#3637;',0),(176643,4907,'hi','à¤†à¤¦à¥‡à¤¶ - à¤à¤• à¤µà¤°à¥à¤· à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(176644,4907,'ms','Mencetak laporan jumlah pesanan - satu tahun',0),(176645,4907,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªÙ‚Ø±ÙŠØ± Ø­Ø¬Ù… Ø£Ù…Ø±-Ø³Ù†Ø© ÙˆØ§Ø­Ø¯Ø©',0),(176646,4907,'fr','Imprimer l\'Ã©tat du Volume de commande - un an',0),(176647,4907,'jp','æ³¨æ–‡é‡?ãƒ¬ãƒ?ãƒ¼ãƒˆã?®å?°åˆ·ãƒ¼ï¼‘å¹´',0),(176648,4907,'pt','Imprimir relatÃ³rio de Volume de ordem - um ano',0),(176649,4907,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð° Ð¾Ð±ÑŠÐµÐ¼ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° - Ð¾Ð´Ð¸Ð½ Ð³Ð¾Ð´',0),(176650,4907,'es','Orden de Imprimir Informe de VolÃºmen - Un AÃ±o',0),(176651,4907,'de','Drucken Sie Auftrag Band Berichts - ein Jahr',0),(176652,4907,'en','Print Order Volume Report - One Year',0),(176653,4908,'is','',0),(176654,4908,'dr',': ÙŠÙƒ Ø³Ø§Ù„',0),(176655,4908,'pr','Ø¬Ø­Ù… Ø³ÙØ§Ø±Ø´  : ÙŠÙƒ Ø³Ø§Ù„',0),(176656,4908,'tr','Bir yÄ±llÄ±k hacmi - sipariÅŸ',0),(176657,4908,'pl','ZamÃ³w Tom - jeden rok',0),(176658,4908,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð¾Ð±ÐµÐ¼ - ÐµÐ´Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(176659,4908,'ur','ØµÙˆØª - Ø§ÛŒÚ© Ø³Ø§Ù„ Ú©Ø§ Ø­Ú©Ù…',0),(176660,4908,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(176661,4908,'vi','Khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng - 1 nÄƒm',0),(176662,4908,'af','Bestelling Volume - Een Jaar',0),(176663,4908,'ro','Comanda volum - un an',0),(176664,4908,'et','Tellimuse maht - Ã¼ks aasta',0),(176665,4908,'si','Naloga obsega - eno leto',0),(176666,4908,'ba','Memesan Volume - satu tahun',0),(176667,4908,'nl','Bestel Volume - Ã©Ã©n jaar',0),(176668,4908,'fi','Tilaa Volume - vuosi',0),(176669,4908,'no','Bestille volum - ett Ã¥r',0),(176670,4908,'da','Bestil volumen - et Ã¥r',0),(176671,4908,'ko','ì£¼ë¬¸ ì–‘-1 ë…„',0),(176672,4908,'he','×”×–×ž× ×ª ××—×¡×•×Ÿ - ×©× ×” ××—×ª',0),(176673,4908,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Ï„ÏŒÎ¼Î¿Ï‚ - Î­Î½Î± Î­Ï„Î¿Ï‚',0),(176674,4908,'zh','è®¢å•é‡- ä¸€å¹´\r\n',0),(176675,4908,'sv','BestÃ¤ll volym - ett Ã¥r',0),(176676,4908,'it','Ordinare il Volume - un anno',0),(176677,4908,'tl','',0),(176678,4908,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; - 1 &#3611;&#3637;',0),(176679,4908,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ - à¤à¤• à¤µà¤°à¥à¤· à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(176680,4908,'ms','Perintah Volume - satu tahun',0),(176681,4908,'ar','ØªØ±ØªÙŠØ¨ ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†--Ø³Ù†Ø© ÙˆØ§Ø­Ø¯Ø©',0),(176682,4908,'fr','Commander le Volume - un an',0),(176683,4908,'jp','æ³¨æ–‡é‡?ãƒ¼ï¼‘å¹´',0),(176684,4908,'pt','Ordem Volume - um ano',0),(176685,4908,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾Ð±ÑŠÐµÐ¼ - Ð¾Ð´Ð¸Ð½ Ð³Ð¾Ð´',0),(176686,4908,'es','VolÃºmen de Ordenes: Un AÃ±o',0),(176687,4908,'de','Auftragsvolumen Sie - ein Jahr',0),(176688,4908,'en','Order Volume - One Year',0),(176689,4909,'is','',0),(176690,4909,'dr','30  Ø±ÙˆØ² ',0),(176691,4909,'pr','Ø«Ø±ÙˆØªÙ…Ù†Ø¯ ØªØ±ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† â€“ Ø³ÙŠ  30  Ø±ÙˆØ² ',0),(176692,4909,'tr','Ãœst dolar mÃ¼ÅŸteriler - 30 gÃ¼n',0),(176693,4909,'pl','Szczyt Dolar klientÃ³w - 30 dni',0),(176694,4909,'bg','Ð¢Ð¾Ð¿ Ð´Ð¾Ð»Ð°Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ - 30 Ð´Ð½Ð¸',0),(176695,4909,'ur','Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± ÚˆØ§Ù„Ø± Ú¯Ø§ÛÚ©ÙˆÚº - 30 Ø¯Ù†',0),(176696,4909,'sr','ÐÐ°Ñ˜Ð±Ð¾Ñ™Ð¸ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸ Ð´Ð¾Ð»Ð°Ñ€ - 30 Ð´Ð°Ð½Ð°',0),(176697,4909,'vi','KhÃ¡ch hÃ ng Dolla cao nháº¥t - 30 ngÃ y',0),(176698,4909,'af','Top Dollar Klante/KliÃ«nte - 30 Dae',0),(176699,4909,'ro','Top Dolar clienÅ£ii - 30 de zile',0),(176700,4909,'et','Top Dollar kÃ¼lastajad - 30 pÃ¤eva',0),(176701,4909,'si','Top dolar stranke - 30 dni',0),(176702,4909,'ba','Atas dolar pelanggan - 30 hari',0),(176703,4909,'nl','Beste Dollar klanten - 30 dagen',0),(176704,4909,'fi','Alkuun dollari asiakkaat - 30 pÃ¤ivÃ¤Ã¤',0),(176705,4909,'no','Topp Dollar kunder - 30 dager',0),(176706,4909,'da','Top Dollar kunder - 30 dage',0),(176707,4909,'ko','ìµœê³  ë‹¬ëŸ¬ ê³ ê°-30 ì¼',0),(176708,4909,'he','×œ×§×•×—×•×ª ×ž×•×‘×™×œ×™× ×“×•×œ×¨ - 30 ×™×ž×™×',0),(176709,4909,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î± Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î”Î¿Î»Î¬ÏÎ¹Î¿ - 30 Î·Î¼Î­ÏÎµÏ‚',0),(176710,4909,'zh','é¡¶å…ƒå®¢æˆ· -30å¤©\r\n',0),(176711,4909,'sv','Top Dollar kunder - 30 dagar',0),(176712,4909,'it','Migliori clienti dollaro - 30 giorni',0),(176713,4909,'tl','',0),(176714,4909,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3648;&#3591;&#3636;&#3609;&#3604;&#3629;&#3621;&#3621;&#3656;&#3634;&#3619;&#3660;&#3618;&#3629;&#3604;&#3648;&#3618;&#3637;&#3656;&#3618;&#3617; - 30&#3623;&#3633;&#3609;',0),(176715,4909,'hi','à¤¶à¥€à¤°à¥à¤· à¤¡à¥‰à¤²à¤° à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ - 30 à¤¦à¤¿à¤¨',0),(176716,4909,'ms','Atas dolar pelanggan - 30 hari',0),(176717,4909,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø§Ø± ÙƒØ¨Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡--30 ÙŠÙˆÙ…Ø§',0),(176718,4909,'fr','Top Dollar clients - 30 jours',0),(176719,4909,'jp','æœ€é«˜é¡?é¡§å®¢ãƒ¼ï¼“ï¼?æ—¥é–“',0),(176720,4909,'pt','Principais clientes de dÃ³lar - 30 dias',0),(176721,4909,'ru','Ð¢Ð¾Ð¿ Ð´Ð¾Ð»Ð»Ð°Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² - 30 Ð´Ð½ÐµÐ¹',0),(176722,4909,'es','Cientes Principales en DÃ³lares - 30 DÃ­as',0),(176723,4909,'de','Top Dollar-Kunden - 30 Tage',0),(176724,4909,'en','Top Dollar Customers - 30 Days',0),(176725,4910,'is','',0),(176726,4910,'dr','Ø«Ø±ÙˆØªÙ…Ù†Ø¯ ØªØ±ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† â€“ ÙŠÙƒ Ø³Ø§Ù„',0),(176727,4910,'pr','Ø«Ø±ÙˆØªÙ…Ù†Ø¯ ØªØ±ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† â€“ ÙŠÙƒ Ø³Ø§Ù„',0),(176728,4910,'tr','Ãœst dolar mÃ¼ÅŸteriler - yÄ±l',0),(176729,4910,'pl','Szczyt Dolar klientÃ³w - rok',0),(176730,4910,'bg','Ð¢Ð¾Ð¿ Ð´Ð¾Ð»Ð°Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ - Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(176731,4910,'ur','Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± ÚˆØ§Ù„Ø± Ú¯Ø§ÛÚ©ÙˆÚº - Ø³Ø§Ù„',0),(176732,4910,'sr','ÐÐ°Ñ˜Ð±Ð¾Ñ™Ð¸ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸ Ð´Ð¾Ð»Ð°Ñ€ - Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(176733,4910,'vi','KhÃ¡ch hÃ ng Dolla cao nháº¥t - NÄƒm',0),(176734,4910,'af','Top Dollar Klante/KliÃ«nte - Jaar',0),(176735,4910,'ro','Top Dolar clienÅ£ii - an',0),(176736,4910,'et','Top Dollar kÃ¼lastajad - aasta',0),(176737,4910,'si','Top dolar stranke - leto',0),(176738,4910,'ba','Atas dolar pelanggan - tahun',0),(176739,4910,'nl','Beste Dollar klanten - jaar',0),(176740,4910,'fi','Alkuun dollari asiakkaat - vuoden',0),(176741,4910,'no','Topp Dollar kunder - Ã¥r',0),(176742,4910,'da','Top Dollar kunder - Ã¥r',0),(176743,4910,'ko','ìµœê³  ë‹¬ëŸ¬ ê³ ê°-1 ë…„',0),(176744,4910,'he','×œ×§×•×—×•×ª ×ž×•×‘×™×œ×™× ×“×•×œ×¨ - ×©× ×”',0),(176745,4910,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î± Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î”Î¿Î»Î¬ÏÎ¹Î¿ - Î­Ï„Î¿Ï‚',0),(176746,4910,'zh','é¡¶å…ƒå®¢æˆ· -æ–°å¹´\r\n',0),(176747,4910,'sv','Top Dollar kunder - Ã¥r',0),(176748,4910,'it','Migliori clienti dollaro - anno',0),(176749,4910,'tl','',0),(176750,4910,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3648;&#3591;&#3636;&#3609;&#3604;&#3629;&#3621;&#3621;&#3656;&#3634;&#3619;&#3660;&#3618;&#3629;&#3604;&#3618;&#3637;&#3656;&#3618;&#3617;/&#3611;&#3637;',0),(176751,4910,'hi','à¤¶à¥€à¤°à¥à¤· à¤¡à¥‰à¤²à¤° à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ - à¤µà¤°à¥à¤·',0),(176752,4910,'ms','Atas dolar pelanggan - tahun',0),(176753,4910,'ar','ÙƒØ¨Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø¯ÙˆÙ„Ø§Ø±-Ø§Ù„Ø³Ù†Ø©',0),(176754,4910,'fr','Top Dollar clients - annÃ©e',0),(176755,4910,'jp','æœ€é«˜é¡?é¡§å®¢ãƒ¼å¹´é–“',0),(176756,4910,'pt','Principais clientes de dÃ³lar - ano',0),(176757,4910,'ru','Ð¢Ð¾Ð¿ Ð´Ð¾Ð»Ð»Ð°Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² - Ð³Ð¾Ð´',0),(176758,4910,'es','Cientes Principales en DÃ³lares - AÃ±o',0),(176759,4910,'de','Top Dollar-Kunden - Jahr',0),(176760,4910,'en','Top Dollar Customers - Year',0),(176761,4911,'is','',0),(176762,4911,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(176763,4911,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(176764,4911,'tr','KapalÄ± sipariÅŸler raporu gÃ¶rÃ¼ntÃ¼leyin',0),(176765,4911,'pl','Zobacz raport zamkniÄ™te zamÃ³wienia',0),(176766,4911,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(176767,4911,'ur','Ø¨Ù†Ø¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(176768,4911,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð° Ð¾ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸Ð¼ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°Ð¼Ð°',0),(176769,4911,'vi','Xem bÃ¡o cÃ¡o Ä‘Æ¡n hÃ ng Ä‘Ã£ Ä‘Ã³ng',0),(176770,4911,'af','Besigtig Afgesluite Bestellingsverslag',0),(176771,4911,'ro','Vezi raport Ã®nchisÄƒ comenzi',0),(176772,4911,'et','Vaata suletud tellimuste aruannet',0),(176773,4911,'si','Ogled poroÄila zaprtimi nalogi',0),(176774,4911,'ba','Lihat laporan order ditutup',0),(176775,4911,'nl','Gesloten Orders rapport weergeven',0),(176776,4911,'fi','Suljettuja tilauksia raportin tarkasteleminen',0),(176777,4911,'no','Vise lukkede ordrer rapport',0),(176778,4911,'da','Se lukkede ordrer rapport',0),(176779,4911,'ko','ë‹«ížŒëœ ì£¼ë¬¸ ë³´ê³ ì„œ ë³´ê¸°',0),(176780,4911,'he','×”×¦×’ ××ª ×”×“×•×— ×œ×”×–×ž× ×•×ª ×¡×’×•×¨×•×ª',0),(176781,4911,'el','Î”ÎµÎ¯Ï„Îµ Ï„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ· Ï„Ï‰Î½ ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŽÎ½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(176782,4911,'zh','æŸ¥çœ‹å°é—­è®¢å•æŠ¥è¡¨\r\n',0),(176783,4911,'sv','Visa stÃ¤ngda order rapport',0),(176784,4911,'it','Visualizza Report ordini chiusi',0),(176785,4911,'tl','',0),(176786,4911,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(176787,4911,'hi','à¤¬à¤‚à¤¦ à¤†à¤¦à¥‡à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(176788,4911,'ms','Lihat laporan tutup',0),(176789,4911,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ± Ø£ÙˆØ§Ù…Ø± Ù…ØºÙ„Ù‚Ø©',0),(176790,4911,'fr','Afficher rapport commandes fermÃ©es',0),(176791,4911,'jp','çµ‚äº†æ¸ˆæ³¨æ–‡ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(176792,4911,'pt','Ver relatÃ³rio de ordens fechadas',0),(176793,4911,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐžÑ‚Ñ‡ÐµÑ‚Ð° ÐŸÐ¾ Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ñ‹Ð¼ Ð—Ð°ÐºÐ°Ð·Ð°Ð¼',0),(176794,4911,'es','Visionar Informe de Ordenes Cerrados',0),(176795,4911,'de','Geschlossene Orders-Bericht anzeigen',0),(176796,4911,'en','View Closed Orders Report',0),(176797,4912,'is','',0),(176798,4912,'dr','Ú†Ø§Ù¾ Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(176799,4912,'pr','Ú†Ø§Ù¾ Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(176800,4912,'tr','En iyi 10 baskÄ± mÃ¼ÅŸteriler',0),(176801,4912,'pl','Top 10 klientÃ³w wydruku',0),(176802,4912,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(176803,4912,'ur','Ù¹Ø§Ù¾ 10 Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú¯Ø§ÛÚ©',0),(176804,4912,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐºÑƒÐ¿Ñ†Ð¸ Ð¿Ñ€Ð²Ð¸Ñ… 10',0),(176805,4912,'vi','MÆ°á»i khÃ¡ch hÃ ng in cao nháº¥t ',0),(176806,4912,'af','Top 10 Druk Klante/KliÃ«nte',0),(176807,4912,'ro','Top 10 imprimare clienÅ£ii',0),(176808,4912,'et','Top 10 Prindi kÃ¼lastajad',0),(176809,4912,'si','Top 10 Print kupci',0),(176810,4912,'ba','Top 10 cetak pelanggan',0),(176811,4912,'nl','Top 10 afdrukken klanten',0),(176812,4912,'fi','Top 10 tulosta asiakkaat',0),(176813,4912,'no','Topp 10 Print kunder',0),(176814,4912,'da','Top 10 udskrive kunderne',0),(176815,4912,'ko','í†± 10 ì¸ì‡„ ê³ ê°',0),(176816,4912,'he','×”×¢×œ×™×•×Ÿ 10 ×”×œ×§×•×—×•×ª ×”×“×¤×¡×”',0),(176817,4912,'el','Top 10 ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(176818,4912,'zh','å‰10åæ‰“å°é¡¾å®¢\r\n',0),(176819,4912,'sv','Topp 10 skriva ut kunder',0),(176820,4912,'it','Top 10 stampa clienti',0),(176821,4912,'tl','',0),(176822,4912,'th','&#3614;&#3636;&#3617;&#3614;&#3660; 10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(176823,4912,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(176824,4912,'ms','Top 10 pelanggan cetakan',0),(176825,4912,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(176826,4912,'fr','Top 10 des clients impression',0),(176827,4912,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?å?°åˆ·é¡§å®¢',0),(176828,4912,'pt','Top 10 clientes de impressÃ£o',0),(176829,4912,'ru','Ð¢Ð¾Ð¿ 10 ÐŸÐµÑ‡Ð°Ñ‚Ð¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(176830,4912,'es','Los 10 Clientes Principales de Imprenta',0),(176831,4912,'de','Top 10-Print-Kunden',0),(176832,4912,'en','Top 10 Print Customers',0),(176833,4913,'is','',0),(176834,4913,'dr','(Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† â€“ Ø³Ø§Ù„',0),(176835,4913,'pr','Ú†Ø§Ù¾ Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† (Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† â€“ Ø³Ø§Ù„',0),(176836,4913,'tr','En iyi 10 baskÄ± mÃ¼ÅŸteri - yÄ±l',0),(176837,4913,'pl','10 najlepszych klientÃ³w wydruku - rok',0),(176838,4913,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚ - Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(176839,4913,'ur','Ù¹Ø§Ù¾ 10 Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú¯Ø§ÛÚ© - Ø³Ø§Ù„',0),(176840,4913,'sr','Ð¢Ð¾Ð¿ 10 \"ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ°\" ÐšÑƒÐ¿Ð°Ñ† \"-Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(176841,4913,'vi','MÆ°á»i khÃ¡ch hÃ ng in cao nháº¥t - NÄƒm ',0),(176842,4913,'af','Top 10 Druk Klante/KliÃ«nte - 1 Jaar',0),(176843,4913,'ro','Top 10 imprimare client - an',0),(176844,4913,'et','Top 10 Prindi kliendi - aasta',0),(176845,4913,'si','Kupec tiskanih top 10 - leto',0),(176846,4913,'ba','Top 10 cetak pelanggan - tahun',0),(176847,4913,'nl','Top 10 afdrukken klant - jaar',0),(176848,4913,'fi','Top 10 Tulosta asiakkaan - vuoden',0),(176849,4913,'no','Topp 10 ut kunde - Ã¥r',0),(176850,4913,'da','Top 10 Print kunde - Ã¥r',0),(176851,4913,'ko','í†± 10 ì¸ì‡„ ê³ ê°-1 ë…„',0),(176852,4913,'he','×œ×§×•×— ×”×“×¤×¡×” ×”×¢×œ×™×•×Ÿ 10 - ×©× ×”',0),(176853,4913,'el','Top 10 ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Î Î•Î›Î‘Î¤Î—Î£ - Î•Î¤ÎŸÎ£',0),(176854,4913,'zh','å‰ååæ‰“å°å®¢æˆ· -å¹´\r\n',0),(176855,4913,'sv','Topp 10 skriva ut kund - Ã¥r',0),(176856,4913,'it','Top 10 cliente stampa - anno',0),(176857,4913,'tl','',0),(176858,4913,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3614;&#3636;&#3617;&#3614;&#3660; - &#3611;&#3637;',0),(176859,4913,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤—à¥à¤°à¤¾à¤¹à¤• - à¤µà¤°à¥à¤·',0),(176860,4913,'ms','Top 10 cetakan pelanggan - tahun',0),(176861,4913,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©-Ø§Ù„Ø³Ù†Ø©',0),(176862,4913,'fr','Top 10 impression client - annÃ©e',0),(176863,4913,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?å?°åˆ·é¡§å®¢ãƒ¼å¹´é–“',0),(176864,4913,'pt','Top 10 do cliente da cÃ³pia - ano',0),(176865,4913,'ru','Ð¢Ð¾Ð¿ 10 ÐŸÐµÑ‡Ð°Ñ‚Ð¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² - Ð“Ð¾Ð´',0),(176866,4913,'es','Los 10 Clientes de Imprenta Principales: 1 AÃ±o',0),(176867,4913,'de','Top 10 drucken Kunde - Jahr',0),(176868,4913,'en','Top 10 Print Customer - Year',0),(176869,4914,'is','',0),(176870,4914,'dr',': Ø³ÙŠ 30 Ø±ÙˆØ²',0),(176871,4914,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª  Ø³ÙˆØ¯ Ø¢ÙˆØ± : Ø³ÙŠ 30 Ø±ÙˆØ²',0),(176872,4914,'tr','En iyi 10 emir - 30 gÃ¼n kar.',0),(176873,4914,'pl','Top 10 zysk zamÃ³wienia - 30 dni',0),(176874,4914,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ - 30 Ð´Ð½Ð¸',0),(176875,4914,'ur','Ø§ÙˆÙ¾Ø± 10 Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª - 30 Ø¯Ù† Ù†ÙØ¹ Û”',0),(176876,4914,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð¸Ñ€Ð°Ñ˜Ñƒ Ð½Ð°Ð»Ð¾Ð·Ð¸ - 30 Ð´Ð°Ð½Ð°',0),(176877,4914,'vi','10 Ä‘Æ¡n hÃ ng lÃ£i suáº¥t cao nháº¥t - 30 ngÃ y',0),(176878,4914,'af','Top 10 Winsgewende Bestellings - 30 Dae',0),(176879,4914,'ro','Top 10 de Profit comenzi - 30 de zile',0),(176880,4914,'et','Top 10 kasum jÃ¤tta - 30 pÃ¤eva',0),(176881,4914,'si','Top 10 dobiÄek naroÄila - 30 dni',0),(176882,4914,'ba','Atas 10 keuntungan pesanan - 30 hari',0),(176883,4914,'nl','Top 10 winst Orders - 30 dagen',0),(176884,4914,'fi','Top 10 voittoa tilaukset - 30 pÃ¤ivÃ¤Ã¤',0),(176885,4914,'no','Topp 10 profitt ordre - 30 dager',0),(176886,4914,'da','Top 10 Profit ordrer - 30 dage',0),(176887,4914,'ko','í†± 10 ì´ìµ ì£¼ë¬¸-30 ì¼',0),(176888,4914,'he','×¨××© 10 ×¨×•×•×— ×”×–×ž× ×•×ª - 30 ×™×ž×™×',0),(176889,4914,'el','Top 10 ÎºÎ­ÏÎ´Î¿Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ - 30 Î·Î¼Î­ÏÎµÏ‚',0),(176890,4914,'zh','åˆ©æ¶¦å‰10åçš„è®¢å•- 30å¤©\r\n',0),(176891,4914,'sv','Topp 10 resultat order - 30 dagar',0),(176892,4914,'it','Top 10 profitto ordini - 30 giorni',0),(176893,4914,'tl','',0),(176894,4914,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3636;&#3629;&#3607;&#3637;&#3656;&#3585;&#3635;&#3652;&#3619; : 30&#3623;&#3633;&#3609;',0),(176895,4914,'hi','30 à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ - à¤¶à¥€à¤°à¥à¤· 10 à¤²à¤¾à¤­',0),(176896,4914,'ms','Top 10 keuntungan pesanan - 30 hari',0),(176897,4914,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø§Ù„Ø±Ø¨Ø­ Ø£ÙˆØ§Ù…Ø±-30 ÙŠÙˆÙ…Ø§',0),(176898,4914,'fr','Top 10 profitent des ordres - 30 jours',0),(176899,4914,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?å?Žç›Šæ³¨æ–‡ãƒ¼30æ—¥é–“',0),(176900,4914,'pt','Top 10 lucro ordens - 30 dias',0),(176901,4914,'ru','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹ - 30 Ð´Ð½ÐµÐ¹',0),(176902,4914,'es','Los 10 Ordenes Principales de MÃ¡s Utilidad: 30 DÃ­as',0),(176903,4914,'de','Top 10 Ergebnis Bestellungen - 30 Tage',0),(176904,4914,'en','Top 10 Profit Orders - 30 Days',0),(176905,4915,'is','',0),(176906,4915,'dr','Ø¨Ø¯ÙˆÙ† Ø¯Ø§Ø¯Ù‡ ',0),(176907,4915,'pr','Ø¨Ø¯ÙˆÙ† Ø¯Ø§Ø¯Ù‡ ',0),(176908,4915,'tr','Veri yok',0),(176909,4915,'pl','Brak danych',0),(176910,4915,'bg','ÐÑÐ¼Ð° Ð´Ð°Ð½Ð½Ð¸',0),(176911,4915,'ur','Ú©ÙˆØ¦ÛŒ ÚˆÛŒÙ¹Ø§',0),(176912,4915,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(176913,4915,'vi','KhÃ´ng dá»¯ liá»‡u',0),(176914,4915,'af','Geen Data',0),(176915,4915,'ro','Nu existÄƒ date',0),(176916,4915,'et','Andmed puuduvad',0),(176917,4915,'si','Ni podatkov',0),(176918,4915,'ba','Tidak ada Data',0),(176919,4915,'nl','Geen gegevens',0),(176920,4915,'fi','Ei tietoja',0),(176921,4915,'no','Ingen Data',0),(176922,4915,'da','Ingen Data',0),(176923,4915,'ko','ë°ì´í„° ì—†ìŒ',0),(176924,4915,'he','××™×Ÿ × ×ª×•× ×™×',0),(176925,4915,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(176926,4915,'zh','æ— æ•°æ®\r\n',0),(176927,4915,'sv','Inga Data',0),(176928,4915,'it','Nessun dato',0),(176929,4915,'tl','',0),(176930,4915,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(176931,4915,'hi','à¤•à¥‹à¤ˆ à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚',0),(176932,4915,'ms','Tiada Data',0),(176933,4915,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¨ÙŠØ§Ù†Ø§Øª',0),(176934,4915,'fr','Aucune donnÃ©e',0),(176935,4915,'jp','ãƒ‡ãƒ¼ã‚¿ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(176936,4915,'pt','NÃ£o hÃ¡ dados',0),(176937,4915,'ru','ÐÐµÑ‚ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(176938,4915,'es','No Datos',0),(176939,4915,'de','Keine Daten',0),(176940,4915,'en','No Data',0),(176941,4916,'is','',0),(176942,4916,'dr','( Ø®Ø±ÙŠØ¯ ÙØ±ÙˆØ´Ú¯Ø§Ù‡- ÙƒØ§Ø±Ø®Ø§Ù†Ù‡',0),(176943,4916,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø§Ø±Ú¯ÙŠØ±ÙŠ( Ø®Ø±ÙŠØ¯ ÙØ±ÙˆØ´Ú¯Ø§Ù‡- ÙƒØ§Ø±Ø®Ø§Ù†Ù‡',0),(176944,4916,'tr','DÃ¼kkanÄ± rapor yÃ¼kleme',0),(176945,4916,'pl','Sklep Å‚adowanie raportu',0),(176946,4916,'bg','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Ð·Ð° Ð·Ð°Ñ€ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(176947,4916,'ur','Ø¯Ú©Ø§Ù† Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ù„ÙˆÚˆ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(176948,4916,'sr','Ð Ð°Ð´ÑšÐ° ÑƒÑ‡Ð¸Ñ‚Ð°Ð²Ð°ÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(176949,4916,'vi','BÃ¡o cÃ¡o táº£i',0),(176950,4916,'af','Werkswinkel Vrag Verslag',0),(176951,4916,'ro','Magazin raportul de Ã®ncÄƒrcare',0),(176952,4916,'et','Peale aruande kauplus',0),(176953,4916,'si','Shop, nakladanje poroÄilo',0),(176954,4916,'ba','Toko yang memuat laporan',0),(176955,4916,'nl','Productieverdeling verslag',0),(176956,4916,'fi','Shop lastaus raportti',0),(176957,4916,'no','Shop lasting rapport',0),(176958,4916,'da','Produktionsbelastning rapport',0),(176959,4916,'ko','ë³´ê³ ì„œë¥¼ ë¡œë“œ í•˜ëŠ” ê²Œ',0),(176960,4916,'he','×—× ×•×ª ×˜×•×¢×Ÿ ×”×“×• ×—',0),(176961,4916,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± Ï†ÏŒÏÏ„Ï‰ÏƒÎ· Î­ÎºÎ¸ÎµÏƒÎ·',0),(176962,4916,'zh','åº—è½½å…¥æŠ¥å‘Š\r\n',0),(176963,4916,'sv','Butiken laddar rapport',0),(176964,4916,'it','Negozio caricamento Report',0),(176965,4916,'tl','',0),(176966,4916,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3650;&#3627;&#3621;&#3604;&#3619;&#3657;&#3634;&#3609;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;',0),(176967,4916,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤²à¥‹à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨',0),(176968,4916,'ms','Kedai yang memuatkan Laporan',0),(176969,4916,'ar','Ù…ØªØ¬Ø± ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(176970,4916,'fr','Boutique rapport de chargement',0),(176971,4916,'jp','Shop Loading Report',0),(176972,4916,'pt','RelatÃ³rio de carregamento de loja',0),(176973,4916,'ru','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½, Ð—Ð°Ð³Ñ€ÑƒÐ·ÐºÐ° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(176974,4916,'es','Informe de Cargos',0),(176975,4916,'de','Shop laden Bericht',0),(176976,4916,'en','Shop Loading Report',0),(176977,4917,'is','',0),(176978,4917,'dr','ØªØ¹Ø¯Ø§Ø¯  Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(176979,4917,'pr','ØªØ¹Ø¯Ø§Ø¯  Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(176980,4917,'tr','#Orders',0),(176981,4917,'pl','#Orders',0),(176982,4917,'bg','#Orders',0),(176983,4917,'ur','#Orders',0),(176984,4917,'sr','#ÐžÑ€Ð´ÐµÑ€Ñ',0),(176985,4917,'vi','Sá»‘ ÄÆ¡n Äáº·t HÃ ng',0),(176986,4917,'af','#Bestellings',0),(176987,4917,'ro','#Orders',0),(176988,4917,'et','#Orders',0),(176989,4917,'si','#Orders',0),(176990,4917,'ba','#Orders',0),(176991,4917,'nl','#Orders',0),(176992,4917,'fi','#Orders',0),(176993,4917,'no','#Orders',0),(176994,4917,'da','#Orders',0),(176995,4917,'ko','#Orders',0),(176996,4917,'he','#Orders',0),(176997,4917,'el','#Orders',0),(176998,4917,'zh','ï¼ƒè®¢å•\r\n',0),(176999,4917,'sv','#Orders',0),(177000,4917,'it','#Orders',0),(177001,4917,'tl','',0),(177002,4917,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(177003,4917,'hi','#Orders',0),(177004,4917,'ms','#Orders',0),(177005,4917,'ar','#Orders',0),(177006,4917,'fr','#Orders',0),(177007,4917,'jp','æ³¨æ–‡æ•°',0),(177008,4917,'pt','#Orders',0),(177009,4917,'ru','#Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(177010,4917,'es','#Ordenes',0),(177011,4917,'de','#Orders',0),(177012,4917,'en','#Orders',0),(177013,4918,'is','',0),(177014,4918,'dr','Ø¨Ø±Ø¯  Ø¨Ø§Ø®Øª Ù†Ø±Ø® Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(177015,4918,'pr','Ø¨Ø±Ø¯  Ø¨Ø§Ø®Øª Ù†Ø±Ø® Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(177016,4918,'tr','KazanÄ±lan teklif oranÄ± kaybetti',0),(177017,4918,'pl','WygraÅ‚ utracone cytat stosunek',0),(177018,4918,'bg','Ð¡Ð¿ÐµÑ‡ÐµÐ»ÐµÐ½Ð¸ Ð·Ð°Ð³ÑƒÐ±ÐµÐ½Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð° ÑÑŠÐ¾Ñ‚Ð½Ð¾ÑˆÐµÐ½Ð¸Ðµ',0),(177019,4918,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: ÙØªØ­ Ú©Ø§ ØªÙ†Ø§Ø³Ø¨ Ú©Ú¾Ùˆ Ø¯ÛŒØ§',0),(177020,4918,'sr','Ð’Ð¾Ð½ Ð¸Ð·Ð³ÑƒÐ±Ð¸Ð¾ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° Ð¾Ð´Ð½Ð¾Ñ',0),(177021,4918,'vi','Tá»· lá»‡ bÃ¡o giÃ¡ khÃ´ng thÃ nh cÃ´ng',0),(177022,4918,'af','Gewen verloor aanhaling verhouding',0),(177023,4918,'ro','CÃ¢ÅŸtigat pierdut citat raport',0),(177024,4918,'et','*Won Lost Quote Ratio',0),(177025,4918,'si','Won izgubil ponudbo razmerje',0),(177026,4918,'ba','Won kehilangan kutipan rasio',0),(177027,4918,'nl','Gewonnen verloren citaat verhouding',0),(177028,4918,'fi','Won Lost lainaus suhde',0),(177029,4918,'no','Vunnet tapt sitat forholdet',0),(177030,4918,'da','Vundne tabte citat forholdet',0),(177031,4918,'ko','ì› íŒ¨ ì¸ìš© ë¹„ìœ¨',0),(177032,4918,'he','× ×™×¦×— ××™×‘×“ ×¦×™×˜×•×˜ ×™×—×¡',0),(177033,4918,'el','Won Î­Ï‡Î±ÏƒÎµ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î±Î½Î±Î»Î¿Î³Î¯Î±',0),(177034,4918,'zh','èµ¢å¾—å¤±åŽ»çš„æŠ¥ä»·æ¯”\r\n',0),(177035,4918,'sv','Vann fÃ¶rlorade citat fÃ¶rhÃ¥llandet',0),(177036,4918,'it','Vince perde quota rapporto',0),(177037,4918,'tl','',0),(177038,4918,'th','&#3629;&#3633;&#3605;&#3619;&#3626;&#3656;&#3623;&#3609;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3594;&#3609;&#3632;&#3649;&#3621;&#3632;&#3649;&#3614;&#3',0),(177039,4918,'hi','à¤µà¥‹à¤¨ à¤¬à¥‹à¤²à¥€ à¤…à¤¨à¥à¤ªà¤¾à¤¤ à¤–à¥‹ à¤¦à¤¿à¤¯à¤¾',0),(177040,4918,'ms','Menang kalah petikan nisbah',0),(177041,4918,'ar','ÙÙ‚Ø¯ ÙØ§Ø² Ø§Ù‚ØªØ¨Ø³ Ù†Ø³Ø¨Ø©',0),(177042,4918,'fr','Won a perdu citation Ratio',0),(177043,4918,'jp','è¦‹ç©?ã‚Šå‹?æ•—çŽ‡',0),(177044,4918,'pt','Ganhou citaÃ§Ã£o perdeu Ratio',0),(177045,4918,'ru','Ð’Ð¾Ð½ Ð¿Ð¾Ñ‚ÐµÑ€ÑÐ» Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÑÐ¾Ð¾Ñ‚Ð½Ð¾ÑˆÐµÐ½Ð¸Ðµ',0),(177046,4918,'es','ProporciÃ³n CotizaciÃ³n Ganado Perdido',0),(177047,4918,'de','Won verlor Zitat VerhÃ¤ltnis',0),(177048,4918,'en','Won Lost Quote Ratio',0),(177049,4919,'is','',0),(177050,4919,'dr','(Ù†Ø³Ø¨Øª) Ø¨Ø±Ø¯  Ø¨Ø§Ø®Øª',0),(177051,4919,'pr','Ù†Ø±Ø®(Ù†Ø³Ø¨Øª) Ø¨Ø±Ø¯  Ø¨Ø§Ø®Øª',0),(177052,4919,'tr','OranÄ± kaybetti kazandÄ±',0),(177053,4919,'pl','WygraÅ‚ utracone stosunek',0),(177054,4919,'bg','ÐŸÐµÑ‡ÐµÐ»Ð¸ Ð·Ð°Ð³ÑƒÐ±ÐµÐ½ ÑÑŠÐ¾Ñ‚Ð½Ð¾ÑˆÐµÐ½Ð¸Ðµ',0),(177055,4919,'ur','ÙØªØ­ Ú©Ø§ ØªÙ†Ø§Ø³Ø¨ Ú©Ú¾Ùˆ Ø¯ÛŒØ§',0),(177056,4919,'sr','Ð’Ð¾Ð½ Ð¸Ð·Ð³ÑƒÐ±Ð¸Ð»Ð¸ Ð¾Ð´Ð½Ð¾Ñ',0),(177057,4919,'vi','Tá»· suáº¥t tháº¯ng thua',0),(177058,4919,'af','Gewen verlore verhouding',0),(177059,4919,'ro','CÃ¢ÅŸtigat pierdut raportul',0),(177060,4919,'et','*Won Lost Ratio',0),(177061,4919,'si','Zmagal, izgubil razmerje',0),(177062,4919,'ba','Won kehilangan rasio',0),(177063,4919,'nl','Gewonnen verloren verhouding',0),(177064,4919,'fi','Oli menettÃ¤nyt suhde',0),(177065,4919,'no','Vant mistet Ratio',0),(177066,4919,'da','Vandt mistet forholdet',0),(177067,4919,'ko','ì› ì†ì‹¤ ë¹„ìœ¨',0),(177068,4919,'he','× ×™×¦×— ××™×‘×“ ×™×—×¡',0),(177069,4919,'el','ÎšÎ­ÏÎ´Î¹ÏƒÎµ, Î­Ï‡Î±ÏƒÎµ Ï„Î·Î½ Î±Î½Î±Î»Î¿Î³Î¯Î±',0),(177070,4919,'zh','èµ¢å¾—ä¸¢å¤±çŽ‡\r\n',0),(177071,4919,'sv','Vann fÃ¶rlorade fÃ¶rhÃ¥llandet',0),(177072,4919,'it','Ha vinto, perduto il rapporto',0),(177073,4919,'tl','',0),(177074,4919,'th','&#3629;&#3633;&#3605;&#3619;&#3626;&#3656;&#3623;&#3609;&#3607;&#3637;&#3656;&#3594;&#3609;&#3632;&#3649;&#3621;&#3632;&#3649;&#3614;&#3657;',0),(177075,4919,'hi','à¤µà¥‹à¤¨ à¤…à¤¨à¥à¤ªà¤¾à¤¤ à¤–à¥‹ à¤¦à¤¿à¤¯à¤¾',0),(177076,4919,'ms','Menang kalah nisbah',0),(177077,4919,'ar','ÙØ§Ø² Ø®Ø³Ø± Ù†Ø³Ø¨Ø©',0),(177078,4919,'fr','Won perdu Ratio',0),(177079,4919,'jp','å‹?æ•—çŽ‡',0),(177080,4919,'pt','Ganhou perdida a relaÃ§Ã£o',0),(177081,4919,'ru','Ð’Ð¾Ð½ Ð¿Ð¾Ñ‚ÐµÑ€ÑÐ» ÐºÐ¾ÑÑ„Ñ„Ð¸Ñ†Ð¸ÐµÐ½Ñ‚',0),(177082,4919,'es','ProporciÃ³n Ganado Perdido',0),(177083,4919,'de','Won verlor VerhÃ¤ltnis',0),(177084,4919,'en','Won Lost Ratio',0),(177085,4920,'is','',0),(177086,4920,'dr','(Ù‡Ø²ÙŠÙ†Ù‡ Ø³Ø±Ø¨Ø§Ø±) ÙØ±ÙˆØ´Ú¯Ø§Ù‡ ',0),(177087,4920,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø§Ø±Ú¯ÙŠØ±ÙŠ(Ù‡Ø²ÙŠÙ†Ù‡ Ø³Ø±Ø¨Ø§Ø±) ÙØ±ÙˆØ´Ú¯Ø§Ù‡ ',0),(177088,4920,'tr','GÃ¶rÃ¼nÃ¼m DÃ¼kkanÄ± rapor yÃ¼kleme',0),(177089,4920,'pl','Zobacz sklep Å‚adowanie raportu',0),(177090,4920,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Ð·Ð° Ð·Ð°Ñ€ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(177091,4920,'ur','Ù…Ù†Ø¸Ø± Ú©ÛŒ Ø¯Ú©Ø§Ù† Ø±Ù¾ÙˆØ±Ù¹ Ù„ÙˆÚˆ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(177092,4920,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ð¾Ð³Ð¾Ð½Ð° ÑƒÑ‡Ð¸Ñ‚Ð°Ð²Ð°ÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(177093,4920,'vi','Xem bÃ¡o cÃ¡o táº£i ',0),(177094,4920,'af','Besigtig Werkswinkel Ladingsverslag',0),(177095,4920,'ro','Vezi magazinul raportul de Ã®ncÄƒrcare',0),(177096,4920,'et','Vaata poe tÃ¤ituvuse aruannet',0),(177097,4920,'si','Pogled Shop nakladanje poroÄilo',0),(177098,4920,'ba','Lihat toko memuat laporan',0),(177099,4920,'nl','Weergave productieverdeling verslag',0),(177100,4920,'fi','Katso Shop lastaus raportti',0),(177101,4920,'no','Vis Shop lasting rapport',0),(177102,4920,'da','Se produktionsbelastning rapport',0),(177103,4920,'ko','ë³´ê³ ì„œ ë¡œë“œ ë·° ì‡¼í•‘',0),(177104,4920,'he','×—× ×•×ª ×ª×¦×•×’×” ×˜×•×¢×Ÿ ×”×“×• ×—',0),(177105,4920,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± Ï†ÏŒÏÏ„Ï‰ÏƒÎ· Î­ÎºÎ¸ÎµÏƒÎ·',0),(177106,4920,'zh','æŸ¥çœ‹åº—è½½å…¥æŠ¥å‘Š\r\n',0),(177107,4920,'sv','Visa Shop laddar rapport',0),(177108,4920,'it','Vista negozio caricamento Report',0),(177109,4920,'tl','',0),(177110,4920,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3650;&#3627;&#3621;&#3604;&#3619;&#3657;&#3634;&#3609;&#3588;&#3657;&#3634;',0),(177111,4920,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤²à¥‹à¤¡ à¤¹à¥‹ à¤°à¤¹à¤¾ à¤¹à¥ˆ à¤¦à¥ƒà¤¶à¥à¤¯ à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨',0),(177112,4920,'ms','Kedai View yang memuatkan Laporan',0),(177113,4920,'ar','Ø¹Ø±Ø¶ Ù…ØªØ¬Ø± ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(177114,4920,'fr','Boutique de vue rapport de chargement',0),(177115,4920,'jp','View Shop Loading Report',0),(177116,4920,'pt','Loja de Exibir relatÃ³rio de carregamento',0),(177117,4920,'ru','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€, Ð—Ð°Ð³Ñ€ÑƒÐ·ÐºÐ° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(177118,4920,'es','Visionar Informe de Cargos en Taller',0),(177119,4920,'de','View Shop laden Bericht',0),(177120,4920,'en','View Shop Loading Report',0),(177121,4921,'is','',0),(177122,4921,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ø¬ÙˆØ§Ø¨ Ø¹Ø¯Ø¯ÙŠ ØªÙ‚Ø³ÙŠÙ… Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(177123,4921,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ø¬ÙˆØ§Ø¨ Ø¹Ø¯Ø¯ÙŠ ØªÙ‚Ø³ÙŠÙ… Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(177124,4921,'tr','Cevap-sayÄ±sal bÃ¶lÃ¼nmÃ¼ÅŸ sipariÅŸ miktarÄ±',0),(177125,4921,'pl','IloÅ›Ä‡ zamÃ³wienia podzielone przez liczbowe odpowiedzi',0),(177126,4921,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°, Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸ Ð¾Ñ‚ Ñ‡Ð¸ÑÐ»Ð¾Ð²Ð¸ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(177127,4921,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ù†Ù…Ø¨Ø±ÛŒ Ø¬ÙˆØ§Ø¨ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªÙ‚Ø³ÛŒÙ… Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(177128,4921,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ð¾Ð´ÐµÑ™ÐµÐ½Ð¾ ÑÐ° Ð½ÑƒÐ¼ÐµÑ€Ð¸Ñ‡ÐºÐ¸Ð¼ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€',0),(177129,4921,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n hÃ ng chia thÃ nh con sá»‘ tráº£ lá»i',0),(177130,4921,'af','Bestel Hoeveelheid verdeel deur Numeriese Antwoord',0),(177131,4921,'ro','Pentru cantitatea de raspuns Numeric',0),(177132,4921,'et','Tellimuse kogus jagatud arvuline vastus',0),(177133,4921,'si','KoliÄino naloga, deljeno s Å¡tevilsko odgovor',0),(177134,4921,'ba','Kuantitas order yang dibagi oleh jawaban numerik',0),(177135,4921,'nl','Orderaantal gedeeld door numeriek antwoord',0),(177136,4921,'fi','Tilauksen mÃ¤Ã¤rÃ¤ jaettuna numeerinen vastaus',0),(177137,4921,'no','Antallet delt pÃ¥ numeriske svar',0),(177138,4921,'da','Ordreantallet divideret med numeriske svar',0),(177139,4921,'ko','ìˆ«ìž ëŒ€ë‹µì„ ë‚˜ëˆˆ ì£¼ë¬¸ëŸ‰',0),(177140,4921,'he','×›×ž×•×ª ×”×–×ž× ×” ×ž×—×•×œ×§ ×ª×©×•×‘×” ×ž×¡×¤×¨×™×ª',0),(177141,4921,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î´Î¹Î± Î±ÏÎ¹Î¸Î¼Î·Ï„Î¹ÎºÎ® Î±Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(177142,4921,'zh','è®¢è´­æ•°é‡é™¤ä»¥æ•°å€¼ç­”æ¡ˆ\r\n',0),(177143,4921,'sv','Orderkvantiteten dividerat med numeriska svar',0),(177144,4921,'it','QuantitÃ  di ordine diviso dalla risposta numerica',0),(177145,4921,'tl','',0),(177146,4921,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3649;&#3610;&#3656;&#3591;&#3648;&#3611;&#3655;&#3609;&#3588;&#3635;&#3605;&#3629;&#3610;&#3648;&#3611;&#3655;&#3609;&#3605;&#3633;&#3',0),(177147,4921,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤• à¤‰à¤¤à¥à¤¤à¤° à¤µà¤¿à¤­à¤¾à¤œà¤¿à¤¤',0),(177148,4921,'ms','Kuantiti pesanan yang dibahagikan dengan angka jawapan',0),(177149,4921,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ø£Ù…Ø± Ù…Ù‚Ø³ÙˆÙ…Ø§Ù‹ Ø¹Ù„Ù‰ \"Ø¬ÙˆØ§Ø¨ Ø±Ù‚Ù…ÙŠ\"',0),(177150,4921,'fr','QuantitÃ© d\'ordre divisÃ©e par rÃ©ponse numÃ©rique',0),(177151,4921,'jp','æ³¨æ–‡æ•°é‡?ã‚’æ•°å­—è§£ç­”ã?§å‰²ã‚‹',0),(177152,4921,'pt','Quantidade de ordem dividida pela resposta numÃ©rica',0),(177153,4921,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð—Ð°ÐºÐ°Ð·Ð° Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¾ Ð½Ð° Ð§Ð¸ÑÐ»Ð¾Ð²Ð¾Ð¹ ÐžÑ‚Ð²ÐµÑ‚',0),(177154,4921,'es','Cantidad de Ordenes dividido por Respuesta Numerica',0),(177155,4921,'de','Bestellmenge geteilt durch numerische Antwort',0),(177156,4921,'en','Order Quantity divided by Numeric Answer',0),(177157,4922,'is','',0),(177158,4922,'dr','Ù…Ù‚Ø¯Ø§Ø± Ú†Ø§Ù¾ ØªÙ‚Ø³ÙŠÙ… Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ø¬ÙˆØ§Ø¨ Ø¹Ø¯Ø¯ÙŠ',0),(177159,4922,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú†Ø§Ù¾ ØªÙ‚Ø³ÙŠÙ… Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ø¬ÙˆØ§Ø¨ Ø¹Ø¯Ø¯ÙŠ',0),(177160,4922,'tr','Cevap-sayÄ±sal bÃ¶lÃ¼nmÃ¼ÅŸ miktarÄ± basÄ±n',0),(177161,4922,'pl','NaciÅ›nij iloÅ›ci podzielonej przez liczbowe odpowiedzi',0),(177162,4922,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸ Ð¾Ñ‚ Ñ‡Ð¸ÑÐ»Ð¾Ð²Ð¸ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(177163,4922,'ur','ØªØ¹Ø¯Ø§Ø¯ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¹Ø¯Ø¯ÛŒ Ø¬ÙˆØ§Ø¨ ØªÙ‚Ø³ÛŒÙ… Ø¯Ø¨Ø§Ø¦ÛŒÚº',0),(177164,4922,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ð¾Ð´ÐµÑ™ÐµÐ½Ð¾ ÑÐ° Ð½ÑƒÐ¼ÐµÑ€Ð¸Ñ‡ÐºÐ¸Ð¼ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€',0),(177165,4922,'vi','Sá»‘ lÆ°á»£ng bÃ¡o chia theo cÃ¢u tráº£ lá»i Ä‘Ã¡nh sá»‘',0),(177166,4922,'af','\"Press\" Hoeveelheid verdeel deur Numeriese Antwoord',0),(177167,4922,'ro','ApÄƒsaÅ£i cantitatea de raspuns Numeric',0),(177168,4922,'et','Vajutage kogus jagatud arvuline vastus',0),(177169,4922,'si','Pritisnite koliÄina deljeno s Å¡tevilsko odgovor',0),(177170,4922,'ba','Tekan kuantitas dibagi oleh jawaban numerik',0),(177171,4922,'nl','Druk op hoeveelheid gedeeld door numeriek antwoord',0),(177172,4922,'fi','Paina mÃ¤Ã¤rÃ¤ jaettuna numeerinen vastaus',0),(177173,4922,'no','Trykk antallet dividert med numerisk svar',0),(177174,4922,'da','Tryk pÃ¥ antal divideret med numeriske svar',0),(177175,4922,'ko','ìˆ«ìž ëŒ€ë‹µì„ ë‚˜ëˆˆ ìˆ˜ëŸ‰ì„ ëˆ„ë¦…ë‹ˆë‹¤',0),(177176,4922,'he','×”×§×© ×¢×œ ×›×ž×•×ª ×ž×—×•×œ×§ ×ª×©×•×‘×” ×ž×¡×¤×¨×™×ª',0),(177177,4922,'el','Î Î±Ï„Î®ÏƒÏ„Îµ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î´Î¹Î± Î±ÏÎ¹Î¸Î¼Î·Ï„Î¹ÎºÎ® Î±Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(177178,4922,'zh','å°åˆ·æ•°é‡é™¤ä»¥æ•°å€¼ç­”æ¡ˆ\r\n',0),(177179,4922,'sv','Tryck pÃ¥ kvantiteten delat med numeriska svar',0),(177180,4922,'it','QuantitÃ  di stampa divisa per risposta numerica',0),(177181,4922,'tl','',0),(177182,4922,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3585;&#3604;&#3627;&#3634;&#3619;&#3604;&#3657;&#3623;&#3618;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3588;&#3635;&#3605;&#3629;&#3610;',0),(177183,4922,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤• à¤‰à¤¤à¥à¤¤à¤° à¤µà¤¿à¤­à¤¾à¤œà¤¿à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(177184,4922,'ms','Tekan kuantiti dibahagikan dengan angka jawapan',0),(177185,4922,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ Ù…Ù‚Ø³Ù…Ø© Ø¹Ù„Ù‰ \"Ø¬ÙˆØ§Ø¨ Ø±Ù‚Ù…ÙŠ\"',0),(177186,4922,'fr','QuantitÃ© de presse divisÃ©e par rÃ©ponse numÃ©rique',0),(177187,4922,'jp','ãƒ—ãƒ¬ã‚¹æ•°é‡?ã‚’æ•°å­—è§£ç­”ã?§å‰²ã‚‹',0),(177188,4922,'pt','Imprensa quantidade dividida pela resposta numÃ©rica',0),(177189,4922,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€ÐµÑÑ, Ð´ÐµÐ»ÐµÐ½Ð½Ð¾Ðµ Ð½Ð° Ñ‡Ð¸ÑÐ»Ð¾Ð²Ð¾Ð¹ Ð¾Ñ‚Ð²ÐµÑ‚',0),(177190,4922,'es','Prensa Cant entre por la Respueta Numerica',0),(177191,4922,'de','DrÃ¼cken Sie Menge dividiert durch numerische Antwort',0),(177192,4922,'en','Press Quantity divided by Numeric Answer',0),(177193,4923,'is','',0),(177194,4923,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú†Ø§Ù¾ ',0),(177195,4923,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú†Ø§Ù¾ ',0),(177196,4923,'tr','BasÄ±n boyutu',0),(177197,4923,'pl','NaciÅ›nij przycisk rozmiar',0),(177198,4923,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð¿Ñ€ÐµÑÐ°Ñ‚Ð°',0),(177199,4923,'ur','Ù¾Ø±ÛŒØ³ Ø³Ø§Ø¦Ø²',0),(177200,4923,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(177201,4923,'vi','KÃ­ch cá»¡ bÃ¡o ',0),(177202,4923,'af','Druk grootte',0),(177203,4923,'ro','ApÄƒsaÅ£i dimensiunea',0),(177204,4923,'et','Vajutage suurus',0),(177205,4923,'si','Velikost tiska',0),(177206,4923,'ba','Ukuran celana',0),(177207,4923,'nl','Druk op grootte',0),(177208,4923,'fi','Paina kokoa',0),(177209,4923,'no','Trykk stÃ¸rrelse',0),(177210,4923,'da','Tryk pÃ¥ stÃ¸rrelse',0),(177211,4923,'ko','ë³´ë„ í¬ê¸°',0),(177212,4923,'he','×”×§×© ×‘×’×•×“×œ',0),(177213,4923,'el','Î Î±Ï„Î®ÏƒÏ„Îµ Ï„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚',0),(177214,4923,'zh','æ‰“å°å°ºå¯¸\r\n',0),(177215,4923,'sv','Tryck pÃ¥ storlek',0),(177216,4923,'it','Dimensione di stampa',0),(177217,4923,'tl','',0),(177218,4923,'th','&#3585;&#3604;&#3586;&#3609;&#3634;&#3604;',0),(177219,4923,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(177220,4923,'ms','Saiz Seluar',0),(177221,4923,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø­Ø¬Ù…',0),(177222,4923,'fr','Taille de presse',0),(177223,4923,'jp','ãƒ—ãƒ¬ã‚¹ã‚µã‚¤ã‚º',0),(177224,4923,'pt','Tamanho de imprensa',0),(177225,4923,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¿Ñ€ÐµÑÑ',0),(177226,4923,'es','Prensa TamaÃ±o',0),(177227,4923,'de','Presse-GrÃ¶ÃŸe',0),(177228,4923,'en','Press Size',0),(177229,4924,'is','',0),(177230,4924,'dr','Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ù‡Ø§ÙŠ  Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(177231,4924,'pr','Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ù‡Ø§ÙŠ  Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(177232,4924,'tr','Yeni iade faturalarÄ±',0),(177233,4924,'pl','Nowych faktur korygujÄ…cych',0),(177234,4924,'bg','ÐÐ¾Ð²Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ñ',0),(177235,4924,'ur','Ù†Ø¦Û’ Ú©Ø±ÛŒÚˆÙ¹ ÛŒØ§Ø¯Ø¯Ø§Ø´ØªÛŒÚº',0),(177236,4924,'sr','ÐÐ¾Ð²Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐ°',0),(177237,4924,'vi','Báº£ng Ghi Nhá»› TÃ­n Dá»¥ng Má»›i',0),(177238,4924,'af','Nuwe Krediet Memo\'s',0),(177239,4924,'ro','Nou note de Credit',0),(177240,4924,'et','Uutele kreeditarvetele',0),(177241,4924,'si','Nov dobropisov',0),(177242,4924,'ba','Memo kredit baru',0),(177243,4924,'nl','Nieuwe creditnota \'s',0),(177244,4924,'fi','Uusia hyvityslaskuja',0),(177245,4924,'no','Nye kreditnotaer',0),(177246,4924,'da','Nye kreditnotaer',0),(177247,4924,'ko','ìƒˆ ì‹ ìš© ë©”ëª¨',0),(177248,4924,'he','×ª×–×›×™×¨×™× ××©×¨××™ ×—×“×©',0),(177249,4924,'el','ÎÎ­Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ¬ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(177250,4924,'zh','æ–°çš„ä¿¡è´·å¤‡å¿˜å½•\r\n',0),(177251,4924,'sv','Nya kreditnotor',0),(177252,4924,'it','Nuove note di credito',0),(177253,4924,'tl','',0),(177254,4924,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3648;&#3617;&#3617;&#3650;&#3629;&#3626;',0),(177255,4924,'hi','à¤¨à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹',0),(177256,4924,'ms','Baru kredit memo',0),(177257,4924,'ar','Memos Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(177258,4924,'fr','Nouvelles notes de crÃ©dit',0),(177259,4924,'jp','æ–°è¦?è²¸æ–¹è¦šæ›¸',0),(177260,4924,'pt','Novas notas de crÃ©dito',0),(177261,4924,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚',0),(177262,4924,'es','Nuevo Memos de CrÃ©dito',0),(177263,4924,'de','Neue Gutschriften',0),(177264,4924,'en','New Credit Memos',0),(177265,4925,'is','',0),(177266,4925,'dr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(177267,4925,'pr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(177268,4925,'tr','Yeni fatura',0),(177269,4925,'pl','Nowej faktury',0),(177270,4925,'bg','ÐÐ¾Ð²Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(177271,4925,'ur','Ù†Ø¦Û’ ÙˆØ¨Ø¬Ù„ÛŒ',0),(177272,4925,'sr','ÐÐ¾Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(177273,4925,'vi','HÃ³a Ä‘Æ¡n má»›i',0),(177274,4925,'af','Nuwe Fakture',0),(177275,4925,'ro','Noile facturi',0),(177276,4925,'et','Uued Arved',0),(177277,4925,'si','Novi raÄuni',0),(177278,4925,'ba','Tagihan baru',0),(177279,4925,'nl','Nieuwe facturen',0),(177280,4925,'fi','Uusia laskuja',0),(177281,4925,'no','Nye fakturaer',0),(177282,4925,'da','Nye fakturaer',0),(177283,4925,'ko','ìƒˆ ì†¡ìž¥',0),(177284,4925,'he','×—×©×‘×•× ×™×•×ª ×—×“×©×•×ª',0),(177285,4925,'el','ÎÎ­Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(177286,4925,'zh','æ–°å‘ç¥¨\r\n',0),(177287,4925,'sv','Nya fakturor',0),(177288,4925,'it','Nuove fatture',0),(177289,4925,'tl','',0),(177290,4925,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(177291,4925,'hi','à¤¨à¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(177292,4925,'ms','Invois yang baru',0),(177293,4925,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯Ø©',0),(177294,4925,'fr','Nouvelles factures',0),(177295,4925,'jp','æ–°è¦?è«‹æ±‚æ›¸',0),(177296,4925,'pt','Novas facturas',0),(177297,4925,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð¡Ñ‡ÐµÑ‚Ð°',0),(177298,4925,'es','Nuevas Facturas',0),(177299,4925,'de','Neue Rechnungen',0),(177300,4925,'en','New Invoices',0),(177301,4926,'is','',0),(177302,4926,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(177303,4926,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(177304,4926,'tr','Yeni Ã¶demeler',0),(177305,4926,'pl','Nowe pÅ‚atnoÅ›ci',0),(177306,4926,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(177307,4926,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Ø§ Ù†ÛŒØ§',0),(177308,4926,'sr','ÐÐ¾Ð²Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(177309,4926,'vi','Thanh toÃ¡n má»›i',0),(177310,4926,'af','Nuwe Betalings',0),(177311,4926,'ro','Noi plÄƒÅ£i',0),(177312,4926,'et','Uued maksed',0),(177313,4926,'si','Nova plaÄila',0),(177314,4926,'ba','Baru pembayaran',0),(177315,4926,'nl','Nieuwe betalingen',0),(177316,4926,'fi','Uudet tuet',0),(177317,4926,'no','Nye betalinger',0),(177318,4926,'da','Nye betalinger',0),(177319,4926,'ko','ìƒˆë¡œìš´ ì§€ë¶ˆ',0),(177320,4926,'he','×ª×©×œ×•×ž×™× ×—×“×©×™×',0),(177321,4926,'el','ÎÎ­ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(177322,4926,'zh','æ–°çš„æ”¯ä»˜\r\n',0),(177323,4926,'sv','Nya betalningar',0),(177324,4926,'it','Nuovi pagamenti',0),(177325,4926,'tl','',0),(177326,4926,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(177327,4926,'hi','à¤¨à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(177328,4926,'ms','Pembayaran yang baru',0),(177329,4926,'ar','Ø¯ÙØ¹Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(177330,4926,'fr','Nouveaux paiements',0),(177331,4926,'jp','æ–°è¦?æ”¯æ‰•ã?„',0),(177332,4926,'pt','Novos pagamentos',0),(177333,4926,'ru','ÐÐ¾Ð²Ñ‹Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸',0),(177334,4926,'es','Nuevos Pagos',0),(177335,4926,'de','Neue Zahlungen',0),(177336,4926,'en','New Payments',0),(177337,4927,'is','',0),(177338,4927,'dr','ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø­Ø±Ø§Ø¬ Ø¬Ø¯ÙŠØ¯ ',0),(177339,4927,'pr','ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø­Ø±Ø§Ø¬ Ø¬Ø¯ÙŠØ¯ ',0),(177340,4927,'tr','Yeni satÄ±ÅŸ iÅŸlemleri',0),(177341,4927,'pl','Nowe akcje sprzedaÅ¼y',0),(177342,4927,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(177343,4927,'ur','Ù†Ø¦ÛŒ ÙØ±ÙˆØ®Øª Ú©Û’ Ø§Ø¹Ù…Ø§Ù„',0),(177344,4927,'sr','ÐÐ¾Ð²Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ñ€Ð°Ð´ÑšÐµ',0),(177345,4927,'vi','HÃ nh Ä‘á»™ng sale má»›i',0),(177346,4927,'af','Nuwe Verkoopsaksies',0),(177347,4927,'ro','Noi vÃ¢nzÄƒri de acÅ£iuni',0),(177348,4927,'et','Uued mÃ¼Ã¼gitegevused',0),(177349,4927,'si','Nove prodajne dejavnosti',0),(177350,4927,'ba','Tindakan penjualan baru',0),(177351,4927,'nl','Nieuwe verkoop acties',0),(177352,4927,'fi','Uusia myynnin toimia',0),(177353,4927,'no','Nye salg handlinger',0),(177354,4927,'da','Nye salg handlinger',0),(177355,4927,'ko','ìƒˆë¡œìš´ íŒë§¤ ìž‘ì—…',0),(177356,4927,'he','×¤×¢×•×œ×•×ª ×”×ž×›×™×¨×•×ª ×”×—×“×©',0),(177357,4927,'el','ÎÎ­ÎµÏ‚ Î´ÏÎ¬ÏƒÎµÎ¹Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(177358,4927,'zh','æ–°çš„é”€å”®è¡Œä¸º\r\n',0),(177359,4927,'sv','Nya Ã¥tgÃ¤rder fÃ¶r fÃ¶rsÃ¤ljning',0),(177360,4927,'it','Nuove azioni di vendita',0),(177361,4927,'tl','',0),(177362,4927,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3651;&#3627;&#3617;&#3656;',0),(177363,4927,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾à¤à¤',0),(177364,4927,'ms','Tindakan jualan baru',0),(177365,4927,'ar','Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(177366,4927,'fr','Nouvelles Actions de vente',0),(177367,4927,'jp','æ–°è¦?ã‚»ãƒ¼ãƒ«ã‚¹ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(177368,4927,'pt','Novas aÃ§Ãµes de vendas',0),(177369,4927,'ru','ÐÐ¾Ð²Ð¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(177370,4927,'es','Nuevas Acciones de Ventas',0),(177371,4927,'de','Neue Verkaufsaktionen',0),(177372,4927,'en','New Sales Actions',0),(177373,4928,'is','',0),(177374,4928,'dr','(ÙŠÙƒ Ù…Ø§Ù‡',0),(177375,4928,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± (ÙŠÙƒ Ù…Ø§Ù‡',0),(177376,4928,'tr','Son Ã¶deme: 1 ay',0),(177377,4928,'pl','Ostatnie pÅ‚atnoÅ›ci: 1 miesiÄ…c',0),(177378,4928,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ: 1 Ð¼ÐµÑÐµÑ†',0),(177379,4928,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ: 1 Ù…ÛÛŒÙ†Û',0),(177380,4928,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ: 1 Ð¼ÐµÑÐµÑ†',0),(177381,4928,'vi','Thanh toÃ¡n gáº§n Ä‘Ã¢y (1 thÃ¡ng)',0),(177382,4928,'af','Onlangse Betalings (Een Maand)',0),(177383,4928,'ro','PlÄƒÅ£i recentÄƒ: 1 lunÄƒ',0),(177384,4928,'et','Hiljutised maksed (Ãœks kuu)',0),(177385,4928,'si','Nedavni plaÄil: 1 mesec',0),(177386,4928,'ba','Tanggal pembayaran: 1 bulan',0),(177387,4928,'nl','Recente betalingen: 1 maand',0),(177388,4928,'fi','Hotelliin maksut: 1 kuukausi',0),(177389,4928,'no','Siste betaling: 1 mÃ¥ned',0),(177390,4928,'da','Seneste betalinger: 1 mÃ¥ned',0),(177391,4928,'ko','ìµœê·¼ ê²°ì œ: 1 ê°œì›”',0),(177392,4928,'he','(×ª×©×œ×•×ž×™× ××—×¨×•× ×™× (×—×•×“×© ××—×“',0),(177393,4928,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚: 1 Î¼Î®Î½Î±Ï‚',0),(177394,4928,'zh','ï¼ˆä¸€ä¸ªæœˆï¼‰æœ€è¿‘ä»˜æ¬¾\r\n',0),(177395,4928,'sv','Senaste betalningar: 1 mÃ¥nad',0),(177396,4928,'it','Pagamenti recenti: 1 mese',0),(177397,4928,'tl','',0),(177398,4928,'th','&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3649;&#3621;&#3657;&#3623; (&#3627;&#3609;&#3638;&#3656;&#3591;&#3648;&#3604;&#3639;&#3629;&#3609;)',0),(177399,4928,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤­à¥à¤—à¤¤à¤¾à¤¨: 1 à¤®à¤¹à¥€à¤¨à¤¾',0),(177400,4928,'ms','Hari bayaran: 1 bulan',0),(177401,4928,'ar','Ø§Ù„Ø¯ÙØ¹Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø©: 1 Ø´Ù‡Ø±',0),(177402,4928,'fr','Paiements rÃ©cents: 1 mois',0),(177403,4928,'jp','æœ€è¿‘ã?®æ”¯æ‰•ã?„ï¼ˆï¼‘ãƒ¶æœˆï¼‰',0),(177404,4928,'pt','Pagamentos recentes: 1 mÃªs',0),(177405,4928,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¸Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ (ÐžÐ´Ð¸Ð½ ÐœÐµÑÑÑ†)',0),(177406,4928,'es','Pagos Recientes (Un Mes)',0),(177407,4928,'de','Den letzten Zahlungen: 1 Monat',0),(177408,4928,'en','Recent Payments: 1 Month',0),(177409,4929,'is','',0),(177410,4929,'dr','(Ø§Ù‚Ø³Ø§Ø·) 7 Ø±ÙˆØ² Ø§Ø®ÙŠØ±',0),(177411,4929,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ(Ø§Ù‚Ø³Ø§Ø·) 7 Ø±ÙˆØ² Ø§Ø®ÙŠØ±',0),(177412,4929,'tr','Son Ã¶deme: 7 gÃ¼n',0),(177413,4929,'pl','Ostatnich pÅ‚atnoÅ›ci: 7 dni',0),(177414,4929,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ: 7 Ð´Ð½Ð¸',0),(177415,4929,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ: 7 Ø¯Ù†',0),(177416,4929,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ: 7 Ð´Ð°Ð½Ð°',0),(177417,4929,'vi','Thanh toÃ¡n gáº§n Ä‘Ã¢y (7 ngÃ y)',0),(177418,4929,'af','Onlangse Betalings (7 Dae)',0),(177419,4929,'ro','PlÄƒÅ£i recenta: 7 zile',0),(177420,4929,'et','Hiljutised maksed (7 pÃ¤eva)',0),(177421,4929,'si','Nedavni plaÄila: 7 dni',0),(177422,4929,'ba','Tanggal pembayaran: 7 hari',0),(177423,4929,'nl','Recente betalingen: 7 dagen',0),(177424,4929,'fi','Hotelliin maksut: 7 pÃ¤ivÃ¤Ã¤',0),(177425,4929,'no','Siste betaling: 7 dager',0),(177426,4929,'da','Seneste betalinger: 7 dage',0),(177427,4929,'ko','ìµœê·¼ ê²°ì œ: 7 ì¼',0),(177428,4929,'he','(×ª×©×œ×•×ž×™× ××—×¨×•× ×™× (×©×‘×¢×” ×™×ž×™×',0),(177429,4929,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚: 7 Î·Î¼Î­ÏÎµÏ‚',0),(177430,4929,'zh','ï¼ˆ7å¤©ï¼‰æœ€è¿‘ä»˜æ¬¾\r\n',0),(177431,4929,'sv','Senaste betalningar: 7 dagar',0),(177432,4929,'it','Pagamenti recenti: 7 giorni',0),(177433,4929,'tl','',0),(177434,4929,'th','&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3649;&#3621;&#3657;&#3623; (7 &#3623;&#3633;&#3609;)',0),(177435,4929,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤­à¥à¤—à¤¤à¤¾à¤¨: 7 à¤¦à¤¿à¤¨',0),(177436,4929,'ms','Hari pembayaran: 7 hari',0),(177437,4929,'ar','Ø§Ù„Ø¯ÙØ¹Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø©: 7 Ø£ÙŠØ§Ù…',0),(177438,4929,'fr','Paiements rÃ©cents: 7 jours',0),(177439,4929,'jp','æœ€è¿‘ã?®æ”¯æ‰•ã?„ï¼ˆï¼—æ—¥é–“ï¼‰',0),(177440,4929,'pt','Pagamentos recentes: 7 dias',0),(177441,4929,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¸Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ (7 Ð”Ð½ÐµÐ¹)',0),(177442,4929,'es','Pagos Recientes (7 DÃ­as)',0),(177443,4929,'de','Den letzten Zahlungen: 7 Tage',0),(177444,4929,'en','Recent Payments: 7 Days',0),(177445,4930,'is','',0),(177446,4930,'dr','ÙŠÙƒ Ù‡ÙØªÙ‡ ',0),(177447,4930,'pr','ÙŠÙƒ Ù‡ÙØªÙ‡ ',0),(177448,4930,'tr','Bir hafta',0),(177449,4930,'pl','TydzieÅ„',0),(177450,4930,'bg','Ð•Ð´Ð½Ð° ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(177451,4930,'ur','Ø§ÛŒÚ© ÛÙØªÛ',0),(177452,4930,'sr','ÐÐµÐ´ÐµÑ™Ñƒ Ð´Ð°Ð½Ð°',0),(177453,4930,'vi','Má»™t tuáº§n',0),(177454,4930,'af','Een Week',0),(177455,4930,'ro','O sÄƒptÄƒmÃ¢nÄƒ',0),(177456,4930,'et','Ãœks nÃ¤dal',0),(177457,4930,'si','En teden',0),(177458,4930,'ba','Satu minggu',0),(177459,4930,'nl','Ã‰Ã©n Week',0),(177460,4930,'fi','Viikon',0),(177461,4930,'no','En uke',0),(177462,4930,'da','En uge',0),(177463,4930,'ko','1 ì£¼',0),(177464,4930,'he','×©×‘×•×¢ ××—×“',0),(177465,4930,'el','ÎœÎ¯Î± ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(177466,4930,'zh','ä¸€å‘¨\r\n',0),(177467,4930,'sv','En vecka',0),(177468,4930,'it','Una settimana',0),(177469,4930,'tl','',0),(177470,4930,'th','&#3627;&#3609;&#3638;&#3656;&#3591;&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(177471,4930,'hi','à¤à¤• à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(177472,4930,'ms','Satu minggu',0),(177473,4930,'ar','Ø£Ø³Ø¨ÙˆØ¹ ÙˆØ§Ø­Ø¯',0),(177474,4930,'fr','Une semaine',0),(177475,4930,'jp','1é€±é–“',0),(177476,4930,'pt','Uma semana',0),(177477,4930,'ru','ÐžÐ´Ð½Ð° ÐÐµÐ´ÐµÐ»Ñ',0),(177478,4930,'es','Una Semana',0),(177479,4930,'de','Eine Woche',0),(177480,4930,'en','One Week',0),(177481,4931,'is','',0),(177482,4931,'dr','Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø§Ù…Ø±ÙˆØ²',0),(177483,4931,'pr','Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø§Ù…Ø±ÙˆØ²',0),(177484,4931,'tr','SatÄ±ÅŸ iÅŸlemleri bugÃ¼n ihtiyacÄ±m vardÄ±.',0),(177485,4931,'pl','SprzedaÅ¼y czynnoÅ›ci potrzebne dzisiaj',0),(177486,4931,'bg','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð´Ð½ÐµÑ',0),(177487,4931,'ur','Ø¢Ø¬ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Ø³ÛŒÙ„Ø² Ø§Ø¹Ù…Ø§Ù„',0),(177488,4931,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ñ€Ð°Ð´ÑšÐµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ Ð´Ð°Ð½Ð°Ñ',0),(177489,4931,'vi','Hoáº¡t Ä‘á»™ng bÃ¡n hÃ ng cáº§n ngÃ y hÃ´m nay',0),(177490,4931,'af','Verkoopsaksies Vandag Nodig',0),(177491,4931,'ro','VÃ¢nzÄƒri de acÅ£iuni necesare astÄƒzi',0),(177492,4931,'et','MÃ¼Ã¼gi meetmed vajalikud tÃ¤na',0),(177493,4931,'si','Prodajne dejavnosti potrebno danes',0),(177494,4931,'ba','Penjualan tindakan yang dibutuhkan sekarang',0),(177495,4931,'nl','Verkoop acties nodig vandaag',0),(177496,4931,'fi','Myynti toimia tarvitaan tÃ¤nÃ¤Ã¤n',0),(177497,4931,'no','Salg handlinger behov i dag',0),(177498,4931,'da','Salg tiltag er nÃ¸dvendige i dag',0),(177499,4931,'ko','ì˜¤ëŠ˜ í•„ìš”í•œ íŒë§¤ ìž‘ì—…',0),(177500,4931,'he','×¤×¢×•×œ×•×ª ×ž×›×™×¨×” × ×“×¨×©×•×ª ×”×™×•×',0),(177501,4931,'el','Î•Î½Î­ÏÎ³ÎµÎ¹ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ ÏƒÎ®Î¼ÎµÏÎ±',0),(177502,4931,'zh','ä»Šå¤©éœ€è¦çš„é”€å”®è¡Œä¸º\r\n',0),(177503,4931,'sv','FÃ¶rsÃ¤ljning Ã¥tgÃ¤rder behÃ¶vs idag',0),(177504,4931,'it','Vendita azioni necessarie oggi',0),(177505,4931,'tl','',0),(177506,4931,'th','&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3623;&#3633;&#3609;&#3609;&#3637;&#3657;',0),(177507,4931,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾à¤à¤ à¤†à¤œ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(177508,4931,'ms','Tindakan-tindakan jualan yang diperlukan hari',0),(177509,4931,'ar','ÙˆÙŠÙ„Ø²Ù… Ø§ØªØ®Ø§Ø° Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„ÙŠÙˆÙ…',0),(177510,4931,'fr','Ventes Actions nÃ©cessaires aujourd\'hui',0),(177511,4931,'jp','æœ¬æ—¥å¿…è¦?ã?ªã‚»ãƒ¼ãƒ«ã‚¹ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(177512,4931,'pt','Vendas aÃ§Ãµes necessÃ¡rias hoje',0),(177513,4931,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐŸÑ€Ð¾Ð´Ð°Ð¶ ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ñ‹Ðµ Ð¡ÐµÐ³Ð¾Ð´Ð½Ñ',0),(177514,4931,'es','Acciones de Ventas que se Necesita Hoy',0),(177515,4931,'de','Verkaufsaktionen brauchte heute',0),(177516,4931,'en','Sales Actions Needed Today',0),(177517,4932,'is','',0),(177518,4932,'dr','Ø²Ù…Ø§Ù† ÙØ¹Ø§Ù„ÙŠØª ',0),(177519,4932,'pr','Ø²Ù…Ø§Ù† ÙØ¹Ø§Ù„ÙŠØª ',0),(177520,4932,'tr','Eylem zamanÄ±',0),(177521,4932,'pl','Czas dziaÅ‚ania',0),(177522,4932,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(177523,4932,'ur','Ø¹Ù…Ù„ Ú©Û’ ÙˆÙ‚Øª',0),(177524,4932,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð°ÐºÑ†Ð¸Ñ˜Ñƒ',0),(177525,4932,'vi','Thá»i Gian HÃ nh Äá»™ng',0),(177526,4932,'af','Aksietyd',0),(177527,4932,'ro','Data actiunii',0),(177528,4932,'et','Toimingu aeg',0),(177529,4932,'si','Akcijski Äas',0),(177530,4932,'ba','Waktu Tindakan',0),(177531,4932,'nl','Actie tijd',0),(177532,4932,'fi','Toimen aika',0),(177533,4932,'no','Action Time',0),(177534,4932,'da','Handling tid',0),(177535,4932,'ko','ìž‘ì—… ì‹œê°„',0),(177536,4932,'he','×–×ž×Ÿ ×¤×¢×•×œ×”',0),(177537,4932,'el','Î§ÏÏŒÎ½Î¿Ï‚ Î´ÏÎ¬ÏƒÎ·Ï‚',0),(177538,4932,'zh','åŠ¨ä½œæ—¶é—´\r\n',0),(177539,4932,'sv','Ã…tgÃ¤rd tid',0),(177540,4932,'it','Tempo dell\'azione',0),(177541,4932,'tl','',0),(177542,4932,'th','&#3648;&#3623;&#3621;&#3634;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(177543,4932,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤¸à¤®à¤¯',0),(177544,4932,'ms','Masa tindakan',0),(177545,4932,'ar','ÙˆÙ‚Øª Ø§Ù„Ø¹Ù…Ù„',0),(177546,4932,'fr','DurÃ©e de l\'Action',0),(177547,4932,'jp','æ´»å‹•æ™‚é–“',0),(177548,4932,'pt','Tempo de aÃ§Ã£o',0),(177549,4932,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(177550,4932,'es','Tiempo AcciÃ³n',0),(177551,4932,'de','Aktionszeit',0),(177552,4932,'en','Action Time',0),(177553,4933,'is','',0),(177554,4933,'dr','Nr.ØªØ¹Ø¯Ø§Ø¯ Ø¨ÛŒØ¬Ú©Ù‡Ø§ ',0),(177555,4933,'pr','Nr.ØªØ¹Ø¯Ø§Ø¯ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(177556,4933,'tr','Nr.Invoices',0),(177557,4933,'pl','Nr.Invoices',0),(177558,4933,'bg','Nr.Invoices',0),(177559,4933,'ur','Nr.Invoices',0),(177560,4933,'sr','ÐÑ€.Ð˜Ð½Ð²Ð¾Ð¸Ñ†ÐµÑ',0),(177561,4933,'vi','Sá»‘ HÃ³a Ä‘Æ¡n',0),(177562,4933,'af','No. Fakture',0),(177563,4933,'ro','Nr.Invoices',0),(177564,4933,'et','Arvete Number',0),(177565,4933,'si','Nr.Invoices',0),(177566,4933,'ba','Nr.Invoices',0),(177567,4933,'nl','Nr.Invoices',0),(177568,4933,'fi','Nr.Invoices',0),(177569,4933,'no','Nr.Invoices',0),(177570,4933,'da','Nr.Invoices',0),(177571,4933,'ko','Nr.Invoices',0),(177572,4933,'he','Nr.Invoices',0),(177573,4933,'el','Nr.Invoices',0),(177574,4933,'zh','ä¸Šåˆåæ—¶åäº”åˆ†å‘ç¥¨\r\n',0),(177575,4933,'sv','Nr.Invoices',0),(177576,4933,'it','Nr.Invoices',0),(177577,4933,'tl','',0),(177578,4933,'th','&#3609;&#3633;&#3610;&#3592;&#3635;&#3609;&#3623;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(177579,4933,'hi','Nr.Invoices',0),(177580,4933,'ms','Nr.Invoices',0),(177581,4933,'ar','Ø¹Ø¯Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(177582,4933,'fr','Nr.Invoices',0),(177583,4933,'jp','è«‹æ±‚æ›¸æ•°',0),(177584,4933,'pt','Nr.Invoices',0),(177585,4933,'ru','Nr.Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(177586,4933,'es','Nmro. de Facturas',0),(177587,4933,'de','Nr.Invoices',0),(177588,4933,'en','Nr.Invoices',0),(177589,4934,'is','',0),(177590,4934,'dr','ÙŠÙƒ Ø³Ø§Ù„ ',0),(177591,4934,'pr','ÙŠÙƒ Ø³Ø§Ù„ ',0),(177592,4934,'tr','Bir yÄ±l',0),(177593,4934,'pl','Jeden rok',0),(177594,4934,'bg','Ð•Ð´Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(177595,4934,'ur','Ø§ÛŒÚ© Ø³Ø§Ù„',0),(177596,4934,'sr','ÐˆÐµÐ´Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(177597,4934,'vi','Má»™t NÄƒm',0),(177598,4934,'af','Een Jaar',0),(177599,4934,'ro','De un an',0),(177600,4934,'et','Ãœks aasta',0),(177601,4934,'si','Eno leto',0),(177602,4934,'ba','Satu tahun',0),(177603,4934,'nl','Ã‰Ã©n jaar',0),(177604,4934,'fi','Vuosi',0),(177605,4934,'no','Ett Ã¥r',0),(177606,4934,'da','Et Ã¥r',0),(177607,4934,'ko','1 ë…„',0),(177608,4934,'he','×©× ×” ××—×ª',0),(177609,4934,'el','ÎˆÎ½Î± Î­Ï„Î¿Ï‚',0),(177610,4934,'zh','ä¸€å¹´\r\n',0),(177611,4934,'sv','Ett Ã¥r',0),(177612,4934,'it','Un anno',0),(177613,4934,'tl','',0),(177614,4934,'th','&#3627;&#3609;&#3638;&#3656;&#3591;&#3611;&#3637;',0),(177615,4934,'hi','à¤à¤• à¤µà¤°à¥à¤·',0),(177616,4934,'ms','Satu tahun',0),(177617,4934,'ar','Ø³Ù†Ø© ÙˆØ§Ø­Ø¯Ø©',0),(177618,4934,'fr','Un an',0),(177619,4934,'jp','1å¹´',0),(177620,4934,'pt','Um ano',0),(177621,4934,'ru','ÐžÐ´Ð¸Ð½ Ð“Ð¾Ð´',0),(177622,4934,'es','Un AÃ±o',0),(177623,4934,'de','Ein Jahr',0),(177624,4934,'en','One Year',0),(177625,4935,'is','',0),(177626,4935,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§Ù„Ø§ØªØ± Ø§Ø² Ø³Ù‚Ù Ø§Ø¹ØªØ¨Ø§Ø± ',0),(177627,4935,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§Ù„Ø§ØªØ± Ø§Ø² Ø³Ù‚Ù Ø§Ø¹ØªØ¨Ø§Ø± ',0),(177628,4935,'tr','MÃ¼ÅŸterilerin kredi limiti iÃ§inde',0),(177629,4935,'pl','Klienci ponad Limit kredytowy',0),(177630,4935,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð½Ð°Ð´ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸Ñ Ð»Ð¸Ð¼Ð¸Ñ‚',0),(177631,4935,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ø­Ø¯ Ú©Ùˆ Ù¾Ø§Ø±',0),(177632,4935,'sr','ÐšÑƒÐ¿Ñ†Ð¸Ð¼Ð° Ð´Ð¸Ñ™ÐµÐ¼ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð³ Ð»Ð¸Ð¼Ð¸Ñ‚Ð°',0),(177633,4935,'vi','KhÃ¡ch hÃ ng vÆ°á»£t quÃ¡ má»©c tÃ­n dá»¥ng',0),(177634,4935,'af','Klante/KliÃ«nte Oorskry Kredietlimiet',0),(177635,4935,'ro','ClienÅ£ii peste limita de Credit',0),(177636,4935,'et','Krediidilimiidi Ã¼letanud kiendid',0),(177637,4935,'si','Stranke nad limita',0),(177638,4935,'ba','Pelanggan atas batas kredit',0),(177639,4935,'nl','Klanten Over kredietlimiet',0),(177640,4935,'fi','Asiakkaat yli luottoraja',0),(177641,4935,'no','Kunder Over kredittgrensen',0),(177642,4935,'da','Kunder Over kreditmaksimum',0),(177643,4935,'ko','ì‹ ìš© í•œë„ ì´ˆê³¼ ê³ ê°',0),(177644,4935,'he','×”×œ×§×•×—×•×ª ×ž×ž×’×‘×œ×ª ×”××©×¨××™',0),(177645,4935,'el','Î¤Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Ï„Î¿ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ ÏŒÏÎ¹Î¿',0),(177646,4935,'zh','å®¢æˆ·è¶…è¿‡ä¿¡ç”¨é¢åº¦\r\n',0),(177647,4935,'sv','Kunder Ã¶ver kreditgrÃ¤ns',0),(177648,4935,'it','Clienti oltre il limite di credito',0),(177649,4935,'tl','',0),(177650,4935,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3623;&#3591;&#3648;&#3591;&#3636;&#3609;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(177651,4935,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¸à¥€à¤®à¤¾ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(177652,4935,'ms','Pelanggan melebihi had kredit',0),(177653,4935,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¹Ù„Ù‰ Ø­Ø¯ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(177654,4935,'fr','Clients plus de limite de crÃ©dit',0),(177655,4935,'jp','è²¸ä»˜é™?åº¦è¶…é?Žé¡§å®¢',0),(177656,4935,'pt','Clientes sobre limite de crÃ©dito',0),(177657,4935,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹ ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐ°ÑŽÑ‰Ð¸Ðµ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¹ Ð›Ð¸Ð¼Ð¸Ñ‚',0),(177658,4935,'es','Clientes Exceden el LÃ­mite de CrÃ©dito',0),(177659,4935,'de','Kunden Ã¼ber Kreditlimit',0),(177660,4935,'en','Customers Over Credit Limit',0),(177661,4936,'is','',0),(177662,4936,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ ÙƒÙ„ ',0),(177663,4936,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ ÙƒÙ„ ',0),(177664,4936,'tr','Grup toplamÄ±',0),(177665,4936,'pl','Grupa Å‚Ä…cznie',0),(177666,4936,'bg','ÐžÐ±Ñ‰ ÑÐ±Ð¾Ñ€ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(177667,4936,'ur','Ú¯Ø±ÙˆÙ¾ Ú©ÛŒ Ú©Ù„',0),(177668,4936,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ñƒ',0),(177669,4936,'vi','Tá»•ng cÃ´ng nhÃ³m',0),(177670,4936,'af','Groep Totaal',0),(177671,4936,'ro','Grupul Total',0),(177672,4936,'et','RÃ¼hm kokku',0),(177673,4936,'si','Skupine skupaj',0),(177674,4936,'ba','Kelompok Total',0),(177675,4936,'nl','Groepstotaal',0),(177676,4936,'fi','Konserni yhteensÃ¤',0),(177677,4936,'no','Totalsum',0),(177678,4936,'da','Gruppetotal',0),(177679,4936,'ko','ê·¸ë£¹ í•©ê³„',0),(177680,4936,'he','×§×‘×•×¦×” ×•×¡×›×•×',0),(177681,4936,'el','Î£ÏÎ½Î¿Î»Î¿ Î¿Î¼Î¬Î´Î±Ï‚',0),(177682,4936,'zh','ç»„æ€»é¢\r\n',0),(177683,4936,'sv','Koncernen totalt',0),(177684,4936,'it','Totale gruppo',0),(177685,4936,'tl','',0),(177686,4936,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3619;&#3623;&#3617;',0),(177687,4936,'hi','à¤•à¥à¤² à¤¸à¤®à¥‚à¤¹',0),(177688,4936,'ms','Jumlah keseluruhan Kumpulan',0),(177689,4936,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(177690,4936,'fr','Total Groupe',0),(177691,4936,'jp','ã‚°ãƒ«ãƒ¼ãƒ—å?ˆè¨ˆ',0),(177692,4936,'pt','Grupo Total',0),(177693,4936,'ru','Ð’ÑÐµÐ³Ð¾ Ð“Ñ€ÑƒÐ¿Ð¿Ð°',0),(177694,4936,'es','Grupo Total',0),(177695,4936,'de','Konzern Gesamt',0),(177696,4936,'en','Group Total',0),(177697,4937,'is','',0),(177698,4937,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ§ÙƒØªÙˆØ±',0),(177699,4937,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ§ÙƒØªÙˆØ±',0),(177700,4937,'tr','Fatura toplamlarÄ±',0),(177701,4937,'pl','Sumy faktury',0),(177702,4937,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° ÑÑƒÐ¼Ð¸',0),(177703,4937,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…ÛŒØ²Ø§Ù†',0),(177704,4937,'sr','Ð£ÐºÑƒÐ¿Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(177705,4937,'vi','Tá»•ng cá»™ng hÃ³a Ä‘Æ¡n ',0),(177706,4937,'af','Faktuur Totale',0),(177707,4937,'ro','FacturÄƒ totaluri',0),(177708,4937,'et','Arve kogusumma',0),(177709,4937,'si','Vsote raÄuna',0),(177710,4937,'ba','Faktur jumlah',0),(177711,4937,'nl','Factuurtotalen',0),(177712,4937,'fi','Laskun summa',0),(177713,4937,'no','Fakturatotaler',0),(177714,4937,'da','Fakturatotaler',0),(177715,4937,'ko','ì²­êµ¬ì„œ í•©ê³„',0),(177716,4937,'he','×¡×›×•×ž×™ ×—×©×‘×•× ×™×•×ª',0),(177717,4937,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÏÎ½Î¿Î»Î±',0),(177718,4937,'zh','å‘ç¥¨æ±‡æ€»\r\n',0),(177719,4937,'sv','Fakturasummor',0),(177720,4937,'it','Totali delle fatture',0),(177721,4937,'tl','',0),(177722,4937,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(177723,4937,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¯à¥‹à¤—',0),(177724,4937,'ms','Invois jumlah',0),(177725,4937,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(177726,4937,'fr','Totaux de la facture',0),(177727,4937,'jp','$$ Invoices',0),(177728,4937,'pt','Totais de factura',0),(177729,4937,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ ÑÑ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(177730,4937,'es','Facturas Totales',0),(177731,4937,'de','Rechnungssummen',0),(177732,4937,'en','Invoice Totals',0),(177733,4938,'is','',0),(177734,4938,'dr','Ø®Ù„Ø§ØµÙ‡ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(177735,4938,'pr','Ø®Ù„Ø§ØµÙ‡ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(177736,4938,'tr','YaÅŸlanma Ã–zeti',0),(177737,4938,'pl','Starzenie streszczenie',0),(177738,4938,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(177739,4938,'ur','Ø®Ø³ØªÛ Ø®Ù„Ø§ØµÛ',0),(177740,4938,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð´Ð¾ÑÐ¿ÐµÐ²Ð°ÑšÐ°',0),(177741,4938,'vi','Tá»•ng Há»£p Tuá»•i Ná»£',0),(177742,4938,'af','Ouderdoms Opsomming',0),(177743,4938,'ro','Aging Rezumat',0),(177744,4938,'et','Aging KokkuvÃµte',0),(177745,4938,'si','Aging Povzetek',0),(177746,4938,'ba','Ringkasan penuaan',0),(177747,4938,'nl','Veroudering samenvatting',0),(177748,4938,'fi','IkÃ¤Ã¤ntyminen Yhteenveto',0),(177749,4938,'no','Aldring Sammendrag',0),(177750,4938,'da','Aging ResumÃ©',0),(177751,4938,'ko','ì—ì´ì§• ìš”ì•½',0),(177752,4938,'he','×¡×™×›×•× ×”×–×“×§× ×•×ª',0),(177753,4938,'el','Î“Î®ÏÎ±Î½ÏƒÎ· Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(177754,4938,'zh','æ¬ æ•°åˆ†æžæ€»ç»“\r\n',0),(177755,4938,'sv','Ã…ldrande Sammanfattning',0),(177756,4938,'it','Riepilogo di invecchiamento',0),(177757,4938,'tl','',0),(177758,4938,'th','&#3626;&#3619;&#3640;&#3611;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(177759,4938,'hi','à¤à¤œà¤¿à¤‚à¤— à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(177760,4938,'ms','Ringkasan penuaan',0),(177761,4938,'ar','Ù…Ù„Ø®Ù‘Øµ Ø§Ù„ØªÙ‚Ø§Ø¯Ù…',0),(177762,4938,'fr','RÃ©sumÃ© de vieillissement',0),(177763,4938,'jp','ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°ã‚µãƒžãƒªãƒ¼',0),(177764,4938,'pt','Resumo de envelhecimento',0),(177765,4938,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(177766,4938,'es','AntigÃ¼edad Resumen',0),(177767,4938,'de','Alternde Zusammenfassung',0),(177768,4938,'en','Aging Summary',0),(177769,4939,'is','',0),(177770,4939,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(177771,4939,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(177772,4939,'tr','YaÅŸlandÄ±rma raporunu gÃ¶rÃ¼ntÃ¼le',0),(177773,4939,'pl','Zobacz Raport wiekowania',0),(177774,4939,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(177775,4939,'ur','Ù…Ù†Ø¸Ø± Ø±Ù¾ÙˆØ±Ù¹ Ø®Ø³ØªÛ',0),(177776,4939,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÑÑ‚Ð°Ñ€ÐµÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(177777,4939,'vi','Xem BÃ¡o CÃ¡o Tuá»•i Ná»£',0),(177778,4939,'af','Besigtig Ouderdomsontledings Verslag',0),(177779,4939,'ro','Vezi raportul de imbatranire',0),(177780,4939,'et','Aegumisaruande vaade',0),(177781,4939,'si','Pogled Aging poroÄilo',0),(177782,4939,'ba','Lihat penuaan laporan',0),(177783,4939,'nl','Weergave veroudering verslag',0),(177784,4939,'fi','NÃ¤ytÃ¤ erÃ¤Ã¤ntymiskauden raportti',0),(177785,4939,'no','Vis aldersfordelt saldoliste',0),(177786,4939,'da','Se Aging rapport',0),(177787,4939,'ko','ì—ì´ì§• ë³´ê³ ì„œ ë³´ê¸°',0),(177788,4939,'he','×ª×¦×•×’×ª ×“×•×— ×’×™×•×œ',0),(177789,4939,'el','Î ÏÎ¿Î²Î¿Î»Î® Î•Î½Î·Î»Î¹ÎºÎ¯Ï‰ÏƒÎ·Ï‚ Î¥Ï€Î¿Î»',0),(177790,4939,'zh','æŸ¥çœ‹è€åŒ–æŠ¥å‘Š\r\n',0),(177791,4939,'sv','Visa Ã…ldersrapport',0),(177792,4939,'it','Vista la relazione di invecchiamento',0),(177793,4939,'tl','',0),(177794,4939,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(177795,4939,'hi','à¤à¤œà¤¿à¤‚à¤— à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(177796,4939,'ms','Lihat penuaan Laporan',0),(177797,4939,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©',0),(177798,4939,'fr','Voir rapport d\'ANTERIORITE',0),(177799,4939,'jp','ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(177800,4939,'pt','Ver relatÃ³rio do envelhecimento',0),(177801,4939,'ru','Ð’Ð¸Ð´ ÑÑ‚Ð°Ñ€ÐµÐ½Ð¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(177802,4939,'es','Visionar Informe de AntigÃ¼edad',0),(177803,4939,'de','Alterung Bericht anzeigen',0),(177804,4939,'en','View Aging Report',0),(177805,4940,'is','',0),(177806,4940,'dr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§',0),(177807,4940,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§',0),(177808,4940,'tr','Faturalar',0),(177809,4940,'pl','Faktury',0),(177810,4940,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(177811,4940,'ur','ÙˆØ¨Ø¬Ù„ÛŒ',0),(177812,4940,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(177813,4940,'vi','HÃ³a Ä‘Æ¡n',0),(177814,4940,'af','Fakture',0),(177815,4940,'ro','Facturi',0),(177816,4940,'et','Arved',0),(177817,4940,'si','RaÄuni',0),(177818,4940,'ba','Faktur',0),(177819,4940,'nl','Facturen',0),(177820,4940,'fi','Laskut',0),(177821,4940,'no','Fakturaer',0),(177822,4940,'da','Fakturaer',0),(177823,4940,'ko','ì†¡ìž¥',0),(177824,4940,'he','×—×©×‘×•× ×™×•×ª',0),(177825,4940,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(177826,4940,'zh','å‘ç¥¨\r\n',0),(177827,4940,'sv','Fakturor',0),(177828,4940,'it','Fatture',0),(177829,4940,'tl','',0),(177830,4940,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;',0),(177831,4940,'hi','à¤šà¤¾à¤²à¤¾à¤¨',0),(177832,4940,'ms','Invois',0),(177833,4940,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(177834,4940,'fr','Factures',0),(177835,4940,'jp','è«‹æ±‚æ›¸',0),(177836,4940,'pt','Facturas',0),(177837,4940,'ru','Ð¡Ñ‡ÐµÑ‚Ð°',0),(177838,4940,'es','Facturas',0),(177839,4940,'de','Rechnungen',0),(177840,4940,'en','Invoices',0),(177841,4941,'is','',0),(177842,4941,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… ÙØ§ÙƒØªÙˆØ±',0),(177843,4941,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… ÙØ§ÙƒØªÙˆØ±',0),(177844,4941,'tr','Fatura hacmi raporu',0),(177845,4941,'pl','WielkoÅ›Ä‡ raportu \"faktura\"',0),(177846,4941,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(177847,4941,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø­Ø¬Ù… Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(177848,4941,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(177849,4941,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng hÃ³a Ä‘Æ¡n',0),(177850,4941,'af','Faktuur Volume Verslag',0),(177851,4941,'ro','Raportul de volum factura',0),(177852,4941,'et','Arve mahu aruande',0),(177853,4941,'si','RaÄunu obsega poroÄila',0),(177854,4941,'ba','Laporan Volume faktur',0),(177855,4941,'nl','Factuurrapport Volume',0),(177856,4941,'fi','Laskun mÃ¤Ã¤rÃ¤-raportin',0),(177857,4941,'no','Volum fakturarapporten',0),(177858,4941,'da','Volumen fakturarapport',0),(177859,4941,'ko','ì†¡ìž¥ ë³¼ë¥¨ ë³´ê³ ì„œ',0),(177860,4941,'he','×—×©×‘×•× ×™×ª ×›×¨×š ×—',0),(177861,4941,'el','ÎŒÎ³ÎºÎ¿Ï‚ Î­ÎºÎ¸ÎµÏƒÎ· \"Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿\"',0),(177862,4941,'zh','å‘ç¥¨æ•°é‡æŠ¥å‘Š\r\n',0),(177863,4941,'sv','Volym fakturarapport',0),(177864,4941,'it','Report Volume fattura',0),(177865,4941,'tl','',0),(177866,4941,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(177867,4941,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(177868,4941,'ms','Laporan jumlah invois',0),(177869,4941,'ar','ØªÙ‚Ø±ÙŠØ± Ø­Ø¬Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(177870,4941,'fr','Rapport Volume de facture',0),(177871,4941,'jp','è«‹æ±‚æ›¸é‡?ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(177872,4941,'pt','RelatÃ³rio de Volume de factura',0),(177873,4941,'ru','ÐžÐ±ÑŠÐµÐ¼ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° ÑÑ‡ÐµÑ‚Ð°',0),(177874,4941,'es','Informe de VolÃºmen de Factura ',0),(177875,4941,'de','Rechnungsbericht Volume',0),(177876,4941,'en','Invoice Volume Report',0),(177877,4942,'is','',0),(177878,4942,'dr','(Ø§Ù‚Ø³Ø§Ø·',0),(177879,4942,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§(Ø§Ù‚Ø³Ø§Ø·',0),(177880,4942,'tr','# Ã–demeleri',0),(177881,4942,'pl','# PÅ‚atnoÅ›ci',0),(177882,4942,'bg','# ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(177883,4942,'ur','# Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(177884,4942,'sr','* Ð£Ð¿Ð»Ð°Ñ‚Ðµ',0),(177885,4942,'vi','Sá»‘ thanh toÃ¡n',0),(177886,4942,'af','# Betalings',0),(177887,4942,'ro','# Plata',0),(177888,4942,'et','# Maksed',0),(177889,4942,'si','# PlaÄila',0),(177890,4942,'ba','# Pembayaran',0),(177891,4942,'nl','# Betalingen',0),(177892,4942,'fi','# Maksut',0),(177893,4942,'no','# Betalinger',0),(177894,4942,'da','# Betalinger',0),(177895,4942,'ko','# ê²°ì œ',0),(177896,4942,'he','# ×ª×©×œ×•×ž×™×',0),(177897,4942,'el','# Î Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(177898,4942,'zh','ï¼ƒä»˜æ¬¾\r\n',0),(177899,4942,'sv','# Betalningar',0),(177900,4942,'it','# Pagamenti',0),(177901,4942,'tl','',0),(177902,4942,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(177903,4942,'hi','# à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(177904,4942,'ms','# Bayaran',0),(177905,4942,'ar','# Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(177906,4942,'fr','# Paiements',0),(177907,4942,'jp','æ”¯æ‰•ã?„æ•°',0),(177908,4942,'pt','# Pagamentos',0),(177909,4942,'ru','# ÐŸÐ»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(177910,4942,'es','# Pagos',0),(177911,4942,'de','-Zahlungen',0),(177912,4942,'en','# Payments',0),(177913,4943,'is','',0),(177914,4943,'dr','Ù†Ù…Ø§ÙŠØ´ Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ± ',0),(177915,4943,'pr','Ù†Ù…Ø§ÙŠØ´ Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ± ',0),(177916,4943,'tr','Fatura Ã¶zetini gÃ¶rÃ¼ntÃ¼le',0),(177917,4943,'pl','Zobacz Podsumowanie faktury',0),(177918,4943,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(177919,4943,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø®Ù„Ø§ØµÛ Ú©Ø§ Ù…Ù†Ø¸Ø± Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(177920,4943,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(177921,4943,'vi','Xem hÃ³a Ä‘Æ¡n tá»•ng há»£p',0),(177922,4943,'af','Besigtig Faktuur Opsomming',0),(177923,4943,'ro','Vezi Rezumat facturÄƒ',0),(177924,4943,'et','Kuva arve KokkuvÃµte',0),(177925,4943,'si','Pogled povzetek raÄuna',0),(177926,4943,'ba','Lihat faktur ringkasan',0),(177927,4943,'nl','Weergave Factuuroverzicht',0),(177928,4943,'fi','NÃ¤ytÃ¤ laskun Yhteenveto',0),(177929,4943,'no','Vis Fakturasammendrag',0),(177930,4943,'da','Se Fakturaoversigt',0),(177931,4943,'ko','ì†¡ìž¥ ìš”ì•½ ë³´ê¸°',0),(177932,4943,'he','×”×¦×’×ª ×—×©×‘×•× ×™×ª ×¡×™×›×•×',0),(177933,4943,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€ÎµÏÎ¯Î»Î·ÏˆÎ· Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(177934,4943,'zh','æŸ¥çœ‹å‘ç¥¨æ‘˜è¦\r\n',0),(177935,4943,'sv','Visa faktura Sammanfattning',0),(177936,4943,'it','Visualizzazione Riepilogo fatture',0),(177937,4943,'tl','',0),(177938,4943,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(177939,4943,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¦à¥‡à¤–à¥‡à¤‚',0),(177940,4943,'ms','Lihat invois ringkasan',0),(177941,4943,'ar','Ø¹Ø±Ø¶ Ù…Ù„Ø®Ù‘Øµ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(177942,4943,'fr','Afficher le rÃ©capitulatif des factures',0),(177943,4943,'jp','è«‹æ±‚æ›¸ã‚µãƒžãƒªãƒ¼ã?®è¡¨ç¤º',0),(177944,4943,'pt','Exibir nota fiscal Resumo',0),(177945,4943,'ru','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¡Ð²Ð¾Ð´ÐºÐ° ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(177946,4943,'es','Visionar ResÃºmen de Facturas',0),(177947,4943,'de','Rechnung-Zusammenfassung anzeigen',0),(177948,4943,'en','View Invoice Summary',0),(177949,4944,'is','',0),(177950,4944,'dr','1 Ù‡ÙØªÙ‡ ',0),(177951,4944,'pr','Ø­Ø¬Ù… ÙØ§ÙƒØªÙˆØ± â€“ 1 Ù‡ÙØªÙ‡ ',0),(177952,4944,'tr','Fatura hacmi - bir hafta',0),(177953,4944,'pl','Faktura Tom - tydzieÅ„',0),(177954,4944,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¾Ð±ÐµÐ¼ - ÐµÐ´Ð½Ð° ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(177955,4944,'ur','ØµÙˆØª - Ø§ÛŒÚ© ÛÙØªÛ’ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(177956,4944,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - Ñ˜ÐµÐ´Ð½Ñƒ ÑÐµÐ´Ð¼Ð¸Ñ†Ñƒ',0),(177957,4944,'vi','Sá»‘ lÆ°á»£ng hÃ³a Ä‘Æ¡n - 1 tuáº§n',0),(177958,4944,'af','Faktuur Volume - Een Week',0),(177959,4944,'ro','Factura de volum - o sÄƒptÄƒmÃ¢nÄƒ',0),(177960,4944,'et','Arve maht - Ã¼ks nÃ¤dal',0),(177961,4944,'si','RaÄunu obsega - en teden',0),(177962,4944,'ba','Faktur Volume - satu minggu',0),(177963,4944,'nl','Factuur Volume - Ã©Ã©n Week',0),(177964,4944,'fi','Laskun Volume - viikko',0),(177965,4944,'no','Faktura volum - en uke',0),(177966,4944,'da','Faktura volumen - en uge',0),(177967,4944,'ko','ì†¡ìž¥ ë³¼ë¥¨-1 ì£¼ì¼',0),(177968,4944,'he','×—×©×‘×•× ×™×ª × ×¤×— - ×©×‘×•×¢ ××—×“',0),(177969,4944,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„ÏŒÎ¼Î¿Ï‚ - Î¼Î¯Î± ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(177970,4944,'zh','å‘ç¥¨æ•°é‡ -1å‘¨\r\n',0),(177971,4944,'sv','Faktura volym - en vecka',0),(177972,4944,'it','Fattura Volume - una settimana',0),(177973,4944,'tl','',0),(177974,4944,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657; - 1 &#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(177975,4944,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ - à¤à¤• à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(177976,4944,'ms','Jumlah invois - satu minggu',0),(177977,4944,'ar','Ø­Ø¬Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©-Ø£Ø³Ø¨ÙˆØ¹ ÙˆØ§Ø­Ø¯',0),(177978,4944,'fr','Facture Volume - une semaine',0),(177979,4944,'jp','è«‹æ±‚æ›¸é‡?ãƒ¼ï¼‘é€±é–“',0),(177980,4944,'pt','Volume de factura - uma semana',0),(177981,4944,'ru','ÐžÐ±ÑŠÐµÐ¼ ÑÑ‡ÐµÑ‚Ð° - Ð¾Ð´Ð½Ð° Ð½ÐµÐ´ÐµÐ»Ñ',0),(177982,4944,'es','Factura VolÃºmen - Una Semana',0),(177983,4944,'de','Rechnung Volume - eine Woche',0),(177984,4944,'en','Invoice Volume - One Week',0),(177985,4945,'is','',0),(177986,4945,'dr','12- Ù…Ø§Ù‡Ù‡Ø§',0),(177987,4945,'pr','12- Ù…Ø§Ù‡Ù‡Ø§',0),(177988,4945,'tr','12-ay',0),(177989,4945,'pl','12-miesiÄ™cy',0),(177990,4945,'bg','12 Ð¼ÐµÑÐµÑ†Ð°',0),(177991,4945,'ur','Ø³Ø§Ù„',0),(177992,4945,'sr','12 Ð¼ÐµÑÐµÑ†Ð¸',0),(177993,4945,'vi','12-ThÃ¡ng',0),(177994,4945,'af','12-Maande',0),(177995,4945,'ro','12 Luni',0),(177996,4945,'et','12 kuud',0),(177997,4945,'si','12-mesecev',0),(177998,4945,'ba','12-Bulan',0),(177999,4945,'nl','12-maanden',0),(178000,4945,'fi','12 kuukauden',0),(178001,4945,'no','12 mÃ¥nder',0),(178002,4945,'da','12 mÃ¥neder',0),(178003,4945,'ko','12 ê°œì›”',0),(178004,4945,'he','12 ×—×•×“×©×™×',0),(178005,4945,'el','12-ÎœÎ®Î½ÎµÏ‚',0),(178006,4945,'zh','12-æœˆ',0),(178007,4945,'sv','12-MÃ¥nader',0),(178008,4945,'it','12 Mesi',0),(178009,4945,'tl','labingdalawang buwan',0),(178010,4945,'th','12 à¹€à¸”à¸·à¸­à¸™',0),(178011,4945,'hi','12 à¤®à¤¹à¥€à¤¨à¥‹à¤‚',0),(178012,4945,'ms','12-bulan',0),(178013,4945,'ar','12 Ø´Ù‡Ø±Ø§',0),(178014,4945,'fr','12 Mois',0),(178015,4945,'jp','12ãƒ¶æœˆ',0),(178016,4945,'pt','12 meses',0),(178017,4945,'ru','12-ÐœÐµÑÑÑ†ÐµÐ²',0),(178018,4945,'es','12-Meses',0),(178019,4945,'de','12 Monate',0),(178020,4945,'en','12-Months',0),(178021,4946,'is','',0),(178022,4946,'dr','8 Ù‡ÙØªÙ‡',0),(178023,4946,'pr','8 Ù‡ÙØªÙ‡',0),(178024,4946,'tr','8 hafta',0),(178025,4946,'pl','8 tygodni',0),(178026,4946,'bg','8 ÑÐµÐ´Ð¼Ð¸Ñ†Ð¸',0),(178027,4946,'ur','8 Ú¾ÙØªÛ’',0),(178028,4946,'sr','8 Ð½ÐµÐ´ÐµÑ™Ð°',0),(178029,4946,'vi','8-Tuáº§n',0),(178030,4946,'af','8-Weke',0),(178031,4946,'ro','8 Saptamani',0),(178032,4946,'et','8-NÃ¤dalat',0),(178033,4946,'si','8-tednov',0),(178034,4946,'ba','8 Minggu',0),(178035,4946,'nl','weken',0),(178036,4946,'fi','8 viikkoa',0),(178037,4946,'no','8 uker',0),(178038,4946,'da','8-uger',0),(178039,4946,'ko','8 ì£¼',0),(178040,4946,'he','8-×©×‘×•×¢×•×ª',0),(178041,4946,'el','8-Î•Î²Î´Î¿Î¼Î¬Î´ÎµÏ‚',0),(178042,4946,'zh','8 å‘¨',0),(178043,4946,'sv','8 veckors',0),(178044,4946,'it','8 settimane',0),(178045,4946,'tl','',0),(178046,4946,'th','8 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(178047,4946,'hi','8-à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(178048,4946,'ms','8-minggu',0),(178049,4946,'ar','8-Ø£Ø³Ø§Ø¨ÙŠØ¹',0),(178050,4946,'fr','8-Semaines',0),(178051,4946,'jp','8é€±é–“',0),(178052,4946,'pt','8 semanas',0),(178053,4946,'ru','8-ÐÐµÐ´ÐµÐ»ÑŒ',0),(178054,4946,'es','8-Semanas',0),(178055,4946,'de','8 Wochen',0),(178056,4946,'en','8-Weeks',0),(178057,4947,'is','',0),(178058,4947,'dr','12 Ù…Ø§Ù‡ ',0),(178059,4947,'pr','Ø­Ø¬Ù… ÙØ§ÙƒØªÙˆØ± â€“ 12 Ù…Ø§Ù‡ ',0),(178060,4947,'tr','Fatura hacmi - 12 ay',0),(178061,4947,'pl','Faktura Tom - 12 miesiÄ™cy',0),(178062,4947,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¾Ð±ÐµÐ¼ - 12 Ð¼ÐµÑÐµÑ†Ð°',0),(178063,4947,'ur','ØµÙˆØª - 12 Ù…Ø§Û Ø§Ù†ÙˆØ§Ø¦Ø³',0),(178064,4947,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - 12 Ð¼Ñ˜ÐµÑÐµÑ†Ð¸',0),(178065,4947,'vi','Sá»‘ lÆ°á»£ng hÃ³a Ä‘Æ¡n - 12 thÃ¡ng',0),(178066,4947,'af','Faktuur Volume - 12 Maande',0),(178067,4947,'ro','Factura de volum - 12 luni',0),(178068,4947,'et','Arve maht - 12 kuud',0),(178069,4947,'si','RaÄunu obsega - 12 mesecev',0),(178070,4947,'ba','Faktur Volume - 12 bulan',0),(178071,4947,'nl','Factuur Volume - 12 maanden',0),(178072,4947,'fi','Laskun Volume - 12 kuukauden',0),(178073,4947,'no','Faktura volum - 12 mÃ¥neder',0),(178074,4947,'da','Faktura volumen - 12 mÃ¥neder',0),(178075,4947,'ko','ì†¡ìž¥ ë³¼ë¥¨-12 ê°œì›”',0),(178076,4947,'he','×—×©×‘×•× ×™×ª × ×¤×— - 12 ×—×•×“×©×™×',0),(178077,4947,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„ÏŒÎ¼Î¿Ï‚ - 12 Î¼Î®Î½ÎµÏ‚',0),(178078,4947,'zh','å‘ç¥¨æ•°é‡ -12ä¸ªæœˆ\r\n',0),(178079,4947,'sv','Faktura volym - 12 mÃ¥nader',0),(178080,4947,'it','Volume di fattura - 12 mesi',0),(178081,4947,'tl','',0),(178082,4947,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657; - 12 &#3648;&#3604;&#3639;&#3629;&#3609;',0),(178083,4947,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ - 12 à¤®à¤¹à¥€à¤¨à¥‡',0),(178084,4947,'ms','Jumlah invois - 12 bulan',0),(178085,4947,'ar','Ø­Ø¬Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©-12 Ø´Ù‡Ø±Ø§',0),(178086,4947,'fr','Facture Volume - 12 mois',0),(178087,4947,'jp','è«‹æ±‚æ›¸é‡?ãƒ¼ï¼‘ï¼’ãƒ¶æœˆ',0),(178088,4947,'pt','Volume de factura - 12 meses',0),(178089,4947,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¾Ð±ÑŠÐµÐ¼ - 12 Ð¼ÐµÑÑÑ†ÐµÐ²',0),(178090,4947,'es','Factura VolÃºmen - 12 Meses',0),(178091,4947,'de','Rechnung Volume - 12 Monate',0),(178092,4947,'en','Invoice Volume - 12 Months',0),(178093,4948,'is','',0),(178094,4948,'dr','8 Ù‡ÙØªÙ‡ ',0),(178095,4948,'pr','Ø­Ø¬Ù… ÙØ§ÙƒØªÙˆØ± â€“ 8 Ù‡ÙØªÙ‡ ',0),(178096,4948,'tr','Fatura hacmi - 8 hafta',0),(178097,4948,'pl','Faktura Tom - 8 tygodni',0),(178098,4948,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¾Ð±ÐµÐ¼ - 8 ÑÐµÐ´Ð¼Ð¸Ñ†Ð¸',0),(178099,4948,'ur','ØµÙˆØª - 8 ÛÙØªÙˆÚº Ø§Ù†ÙˆØ§Ø¦Ø³',0),(178100,4948,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - 8 Ð½ÐµÐ´ÐµÑ™Ð°',0),(178101,4948,'vi','Sá»‘ lÆ°á»£ng hÃ³a Ä‘Æ¡n - 8 tuáº§n',0),(178102,4948,'af','Faktuur Volume - 8 Weke',0),(178103,4948,'ro','Factura de volum - 8 sÄƒptÄƒmÃ¢ni',0),(178104,4948,'et','Arve maht - 8 nÃ¤dalat',0),(178105,4948,'si','RaÄunu obsega - 8 tednov',0),(178106,4948,'ba','Faktur Volume - 8 minggu',0),(178107,4948,'nl','Factuur Volume - 8 weken',0),(178108,4948,'fi','Laskun mÃ¤Ã¤rÃ¤ - 8 viikkoa',0),(178109,4948,'no','Faktura volum - 8 uker',0),(178110,4948,'da','Faktura volumen - 8 uger',0),(178111,4948,'ko','ì†¡ìž¥ ë³¼ë¥¨-8 ì£¼',0),(178112,4948,'he','×—×©×‘×•× ×™×ª × ×¤×— - 8 ×©×‘×•×¢×•×ª',0),(178113,4948,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¤ÏŒÎ¼Î¿Ï‚ - 8 ÎµÎ²Î´Î¿Î¼Î¬Î´ÎµÏ‚',0),(178114,4948,'zh','å‘ç¥¨æ•°é‡ -8å‘¨\r\n',0),(178115,4948,'sv','Faktura volym - 8 veckor',0),(178116,4948,'it','Volume di fattura - 8 settimane',0),(178117,4948,'tl','',0),(178118,4948,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657; - 8 &#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(178119,4948,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ - 8 à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(178120,4948,'ms','Jumlah invois - 8 minggu',0),(178121,4948,'ar','Ø­Ø¬Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©-8 Ø£Ø³Ø§Ø¨ÙŠØ¹',0),(178122,4948,'fr','Facture Volume - 8 semaines',0),(178123,4948,'jp','è«‹æ±‚æ›¸é‡?ãƒ¼ï¼˜é€±é–“',0),(178124,4948,'pt','Volume de factura - 8 semanas',0),(178125,4948,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¾Ð±ÑŠÐµÐ¼ - 8 Ð½ÐµÐ´ÐµÐ»ÑŒ',0),(178126,4948,'es','Factura VolÃºmen - 8 Semanas',0),(178127,4948,'de','Rechnung Volume - 8 Wochen',0),(178128,4948,'en','Invoice Volume - 8 Weeks',0),(178129,4949,'is','',0),(178130,4949,'dr','Ø¨ÙŠØ´ØªØ± Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± ',0),(178131,4949,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± ',0),(178132,4949,'tr','10 en gecikmiÅŸ hesaplarÄ±',0),(178133,4949,'pl','10 najbardziej zalegÅ‚ych rachunkÃ³w',0),(178134,4949,'bg','10 Ð½Ð°Ð¹-Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(178135,4949,'ur','10 Ù…ÙˆØ®Ø± Ø³Ø¨ Ø³Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(178136,4949,'sr','10 Ð½Ð°Ñ˜Ð²Ð¸ÑˆÐµ Ð´Ð¾ÑÐ¿ÐµÐ»Ð¸Ð¼ Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(178137,4949,'vi','10 khÃ¡ch hÃ ng quÃ¡ háº¡n lÃ¢u nháº¥t',0),(178138,4949,'af','10 Mees Agterstallige Rekeninge',0),(178139,4949,'ro','10 cele mai restante conturi',0),(178140,4949,'et','10 kÃµige tÃ¤htaja Ã¼letanud arvetega',0),(178141,4949,'si','10 najbolj zapadlih raÄunov',0),(178142,4949,'ba','10 paling terlambat account',0),(178143,4949,'nl','10 meest achterstallige rekeningen',0),(178144,4949,'fi','10 Useimmat myÃ¶hÃ¤ssÃ¤ tilejÃ¤',0),(178145,4949,'no','10 mest forfalte kontoer',0),(178146,4949,'da','10 mest forfaldne konti',0),(178147,4949,'ko','10 ê°€ìž¥ ì—°ì²´ ê³„ì •',0),(178148,4949,'he','10 ×—×©×‘×•× ×•×ª ×‘×™×•×ª×¨ ×©×¤×¨×¢×•× ×Ÿ ×—×œ×£',0),(178149,4949,'el','10 Ï€Î¹Î¿ ÎºÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ·Î¼Î­Î½Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(178150,4949,'zh','10æœ€å¤§é€¾æœŸå¸æ¬¾\r\n',0),(178151,4949,'sv','10 mest fÃ¶rfallna konton',0),(178152,4949,'it','10 conti piÃ¹ in ritardo',0),(178153,4949,'tl','',0),(178154,4949,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;&#3617;&#3634;&#3585;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604; 10 &#3610;&#3633;&#3597;&#3594;&#3637;',0),(178155,4949,'hi','10 à¤¸à¤¬à¤¸à¥‡ à¤…à¤¤à¤¿à¤¦à¥‡à¤¯ à¤–à¤¾à¤¤à¥‹à¤‚',0),(178156,4949,'ms','10 akaun lampau tempoh Tempahan',0),(178157,4949,'ar','10 Ø­Ø³Ø§Ø¨Ø§Øª ØªØ£Ø®Ø±Øª Ø§Ù„Ø£ÙƒØ«Ø±',0),(178158,4949,'fr','10 comptes plus en retard',0),(178159,4949,'jp','æœŸé™?çµŒé?Žã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒˆãƒƒãƒ—ï¼‘ï¼?',0),(178160,4949,'pt','10 mais atrasadas contas',0),(178161,4949,'ru','10 ÑÐ°Ð¼Ñ‹Ñ… Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(178162,4949,'es','Las 10 Cuentas MÃ¡s Vencidas',0),(178163,4949,'de','10 most Ã¼berfÃ¤llige Konten',0),(178164,4949,'en','10 Most Overdue Accounts',0),(178165,4950,'is','',0),(178166,4950,'dr','Ø±ÙˆØ²Ù‡Ø§ Ø§Ø² Ø±ÙˆÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(178167,4950,'pr','Ø±ÙˆØ²Ù‡Ø§ Ø§Ø² Ø±ÙˆÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(178168,4950,'tr','GÃ¼n faturasÄ±ndan',0),(178169,4950,'pl','Dni od faktury',0),(178170,4950,'bg','Ð”Ð½Ð¸ Ð¾Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(178171,4950,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø³Û’ Ø¯Ù†ÙˆÚº',0),(178172,4950,'sr','Ð”Ð°Ð½Ð° Ð¸Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(178173,4950,'vi','NgÃ y tá»« hÃ³a Ä‘Æ¡n',0),(178174,4950,'af','Dae Vanaf Faktuur',0),(178175,4950,'ro','De zile de la factura',0),(178176,4950,'et','PÃ¤eva jooksul alates arve',0),(178177,4950,'si','Dni od raÄuna',0),(178178,4950,'ba','Hari dari faktur',0),(178179,4950,'nl','Dagen van factuur',0),(178180,4950,'fi','PÃ¤ivÃ¤n lasku',0),(178181,4950,'no','Dager fra fakturaen',0),(178182,4950,'da','Dage fra faktura',0),(178183,4950,'ko','ì†¡ìž¥ì—ì„œ ì¼',0),(178184,4950,'he','×™×ž×™× ×©×œ ×—×©×‘×•× ×™×ª',0),(178185,4950,'el','Î—Î¼Î­ÏÎµÏ‚ Î±Ï€ÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(178186,4950,'zh','å¤©æ•°ä»Žå‘ç¥¨\r\n',0),(178187,4950,'sv','Dagar frÃ¥n faktura',0),(178188,4950,'it','Giorni dalla fattura',0),(178189,4950,'tl','',0),(178190,4950,'th','&#3623;&#3633;&#3609;&#3592;&#3634;&#3585;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(178191,4950,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¥‡ à¤¦à¤¿à¤¨',0),(178192,4950,'ms','Hari dari invois',0),(178193,4950,'ar','Ø£ÙŠØ§Ù… Ù…Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(178194,4950,'fr','Jours de la facture',0),(178195,4950,'jp','è«‹æ±‚å¾Œæ—¥æ•°',0),(178196,4950,'pt','Dias da fatura',0),(178197,4950,'ru','Ð”Ð½ÐµÐ¹ ÑÐ¾ ÑÑ‡ÐµÑ‚Ð°',0),(178198,4950,'es','DÃ­as de la Factura',0),(178199,4950,'de','Tagen nach Rechnung',0),(178200,4950,'en','Days From Invoice',0),(178201,4951,'is','',0),(178202,4951,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(178203,4951,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(178204,4951,'tr','Yeni faturalarÄ±',0),(178205,4951,'pl','Nowe rachunki',0),(178206,4951,'bg','ÐÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(178207,4951,'ur','Ù†Ø¦Û’ Ø¨Ù„',0),(178208,4951,'sr','ÐÐ¾Ð²Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(178209,4951,'vi','HÃ³a ÄÆ¡n Má»›i',0),(178210,4951,'af','Nuwe Rekeninge',0),(178211,4951,'ro','Facturile de noi',0),(178212,4951,'et','Uued arved',0),(178213,4951,'si','Nove raÄune',0),(178214,4951,'ba','Tagihan baru',0),(178215,4951,'nl','Nieuwe rekeningen',0),(178216,4951,'fi','Uusia laskuja',0),(178217,4951,'no','Nye regninger',0),(178218,4951,'da','Nye regninger',0),(178219,4951,'ko','ìƒˆë¡œìš´ ì§€í',0),(178220,4951,'he','×©×˜×¨×•×ª ×—×“×©×™×',0),(178221,4951,'el','ÎÎ­Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(178222,4951,'zh','æ–°å¸å•\r\n',0),(178223,4951,'sv','Nya rÃ¤kningar',0),(178224,4951,'it','Nuove fatture',0),(178225,4951,'tl','',0),(178226,4951,'th','&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(178227,4951,'hi','à¤¨à¤¯à¤¾ à¤¬à¤¿à¤²',0),(178228,4951,'ms','Rang undang-undang baru',0),(178229,4951,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ù…ÙˆØ±Ø¯ Ø¬Ø¯ÙŠØ¯Ø©',0),(178230,4951,'fr','Nouveaux projets de loi',0),(178231,4951,'jp','æ–°è¦?è«‹æ±‚æ›¸',0),(178232,4951,'pt','Notas novas',0),(178233,4951,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ñ‹',0),(178234,4951,'es','Nuevos Recibos',0),(178235,4951,'de','Neue Scheine',0),(178236,4951,'en','New Bills',0),(178237,4952,'is','',0),(178238,4952,'dr','Ú†Ùƒ Ù‡Ø§ÙŠ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(178239,4952,'pr','Ú†Ùƒ Ù‡Ø§ÙŠ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(178240,4952,'tr','Yeni kontroller yazÄ±lÄ±',0),(178241,4952,'pl','Nowe kontrole napisaÅ‚',0),(178242,4952,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¿Ð¸ÑÐ¼ÐµÐ½Ð¾',0),(178243,4952,'ur','Ù†Ø¦Û’ Ú†ÛŒÚ© Ù„Ú©Ú¾Ø§',0),(178244,4952,'sr','ÐÐ¾Ð²Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(178245,4952,'vi','ÄÃ£ viáº¿t SÃ©c má»›i',0),(178246,4952,'af','Nuwe Tjeks Uitgeskryf',0),(178247,4952,'ro','Noi controale scris',0),(178248,4952,'et','Uue kontrolli kirjutada',0),(178249,4952,'si','Nova preverjanja koncu',0),(178250,4952,'ba','Pemeriksaan baru ditulis',0),(178251,4952,'nl','Nieuwe controles geschreven',0),(178252,4952,'fi','Uusi tarkastuksia kirjoitettu',0),(178253,4952,'no','Nye sjekker skrevet',0),(178254,4952,'da','Ny kontrol skrevet',0),(178255,4952,'ko','ìƒˆ ìˆ˜ í‘œ ìž‘ì„±',0),(178256,4952,'he','×‘×“×™×§×•×ª ×—×“×© × ×›×ª×‘',0),(178257,4952,'el','ÎÎ­Î± Ï„Î¿Ï…Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Î³ÏÎ±Ï€Ï„Î®',0),(178258,4952,'zh','æ–°çš„ä¹¦å†™æ”¯ç¥¨\r\n',0),(178259,4952,'sv','Nya kontroller skrivna',0),(178260,4952,'it','Nuovi controlli scritti',0),(178261,4952,'tl','',0),(178262,4952,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;',0),(178263,4952,'hi','à¤¨à¤¯à¤¾ à¤²à¤¿à¤–à¤¾ à¤šà¥‡à¤•',0),(178264,4952,'ms','Baru cek yang ditulis',0),(178265,4952,'ar','ÙƒØªØ¨ Ø´ÙŠÙƒØ§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(178266,4952,'fr','Nouveau chÃ¨ques Ã©mis',0),(178267,4952,'jp','New Checks Written',0),(178268,4952,'pt','Novos cheques escritos',0),(178269,4952,'ru','ÐÐ¾Ð²Ñ‹Ñ… Ñ‡ÐµÐºÐ¾Ð²',0),(178270,4952,'es','Nuevos Cheques Elaborados',0),(178271,4952,'de','Neue PrÃ¼fungen geschrieben',0),(178272,4952,'en','New Checks Written',0),(178273,4953,'is','',0),(178274,4953,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(178275,4953,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(178276,4953,'tr','Yeni POs',0),(178277,4953,'pl','Nowe POs',0),(178278,4953,'bg','ÐÐ¾Ð²Ð¸ POs',0),(178279,4953,'ur','Ù†Ø¦Û’ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù†',0),(178280,4953,'sr','ÐÐ¾Ð²Ð¸ ÐŸÐžÑ',0),(178281,4953,'vi','ÄÆ¡n mua hÃ ng má»›i',0),(178282,4953,'af','Nuwe ABs',0),(178283,4953,'ro','Noi POs',0),(178284,4953,'et','Uus POs',0),(178285,4953,'si','Novi POs',0),(178286,4953,'ba','POs baru',0),(178287,4953,'nl','Nieuwe POs',0),(178288,4953,'fi','Uusi POs',0),(178289,4953,'no','Nye POs',0),(178290,4953,'da','Nye POs',0),(178291,4953,'ko','ìƒˆë¡œìš´ POs',0),(178292,4953,'he','×§×•×¤×” ×—×“×©×”',0),(178293,4953,'el','ÎÎ­Î± Î Î©Î£',0),(178294,4953,'zh','æ–°çš„é‡‡è´­è®¢å•\r\n',0),(178295,4953,'sv','Nya POs',0),(178296,4953,'it','Nuovo POs',0),(178297,4953,'tl','',0),(178298,4953,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(178299,4953,'hi','à¤¨à¤ˆ POs',0),(178300,4953,'ms','POs baru',0),(178301,4953,'ar','Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(178302,4953,'fr','Nouveau point de vente',0),(178303,4953,'jp','æ–°è¦?æ³¨æ–‡è¡¨',0),(178304,4953,'pt','Novo POs',0),(178305,4953,'ru','ÐÐ¾Ð²Ñ‹Ð¹ POs',0),(178306,4953,'es','Nuevos OCs',0),(178307,4953,'de','Neue POs',0),(178308,4953,'en','New POs',0),(178309,4954,'is','',0),(178310,4954,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¬Ø¯ÙŠØ¯ ',0),(178311,4954,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¬Ø¯ÙŠØ¯ ',0),(178312,4954,'tr','Yeni satÄ±cÄ±lar',0),(178313,4954,'pl','Nowych dostawcÃ³w',0),(178314,4954,'bg','ÐÐ¾Ð²Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(178315,4954,'ur','Ù†Ø¦Û’ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº',0),(178316,4954,'sr','ÐÐ¾Ð²Ð¸Ð¼ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸Ð¼Ð°',0),(178317,4954,'vi','NgÆ°á»i bÃ¡n má»›i',0),(178318,4954,'af','Nuwe Verskaffers',0),(178319,4954,'ro','Noi furnizori',0),(178320,4954,'et','Uued hankijad',0),(178321,4954,'si','Nove dobavitelje',0),(178322,4954,'ba','Vendor baru',0),(178323,4954,'nl','Nieuwe leveranciers',0),(178324,4954,'fi','Uudet toimittajat',0),(178325,4954,'no','Nye leverandÃ¸rer',0),(178326,4954,'da','Nye leverandÃ¸rer',0),(178327,4954,'ko','ìƒˆë¡œìš´ ê³µê¸‰ ì—…ì²´',0),(178328,4954,'he','×¡×¤×§×™× ×—×“×©×™×',0),(178329,4954,'el','ÎÎ­Î¿Î¹ Ï€Ï‰Î»Î·Ï„Î­Ï‚',0),(178330,4954,'zh','æ–°çš„ä¾›åº”å•†\r\n',0),(178331,4954,'sv','Nya leverantÃ¶rer',0),(178332,4954,'it','Nuovi fornitori',0),(178333,4954,'tl','',0),(178334,4954,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3651;&#3627;&#3617;&#3656;',0),(178335,4954,'hi','à¤¨à¤¯à¥‡ à¤µà¥‡à¤‚à¤¡à¤°',0),(178336,4954,'ms','Vendor yang baru',0),(178337,4954,'ar','Ù…ÙˆØ±Ø¯ÙˆÙ† Ø¬Ø¯Ø¯',0),(178338,4954,'fr','Nouveaux fournisseurs',0),(178339,4954,'jp','æ–°è¦?æ¥­è€…',0),(178340,4954,'pt','Novos fornecedores',0),(178341,4954,'ru','ÐÐ¾Ð²Ñ‹Ðµ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸',0),(178342,4954,'es','Nuevos Proveedores',0),(178343,4954,'de','Neue Anbieter',0),(178344,4954,'en','New Vendors',0),(178345,4955,'is','',0),(178346,4955,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ  Ø³Ø±Ø±Ø³ÙŠØ¯ Ø¢Ø®Ø±ÙŠ',0),(178347,4955,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ  Ø³Ø±Ø±Ø³ÙŠØ¯ Ø¢Ø®Ø±ÙŠ',0),(178348,4955,'tr','Daha sonra Ã¶denecek faturalar',0),(178349,4955,'pl','Rachunki na pÃ³Åºniej',0),(178350,4955,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸, Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸ Ð¿Ð¾-ÐºÑŠÑÐ½Ð¾',0),(178351,4955,'ur','Ø¨Ø¹Ø¯ Ø§Ø²Ø§Úº ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ø¨Ù„',0),(178352,4955,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸Ñ†Ðµ Ð´Ð¾ÑÐ¿ÐµÑ›Ð° ÐºÐ°ÑÐ½Ð¸Ñ˜Ðµ',0),(178353,4955,'vi','Thá»i Háº¡n HÃ³a ÄÆ¡n Muá»™n',0),(178354,4955,'af','Rekeninge Vorentoe Verskuldig',0),(178355,4955,'ro','Facturile datorate mai tÃ¢rziu',0),(178356,4955,'et','Arveid tasuda hiljem',0),(178357,4955,'si','Menice kasneje zaradi',0),(178358,4955,'ba','Tagihan karena kemudian',0),(178359,4955,'nl','Facturen verschuldigd Later',0),(178360,4955,'fi','Laskut maksettava myÃ¶hemmin',0),(178361,4955,'no','Regninger forfaller senere',0),(178362,4955,'da','Regninger forfalder senere',0),(178363,4955,'ko','ì¸í•´ ë‚˜ì¤‘ì— ì²­êµ¬ì„œ',0),(178364,4955,'he','×©×˜×¨×•×ª ×‘×©×œ ×ž××•×—×¨ ×™×•×ª×¨',0),(178365,4955,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î±ÏÎ³ÏŒÏ„ÎµÏÎ±',0),(178366,4955,'zh','å¸å•åŽæ¥åˆ°æœŸ\r\n',0),(178367,4955,'sv','RÃ¤kningar fÃ¶rfaller senare',0),(178368,4955,'it','Bollette dovuto piÃ¹ tardi',0),(178369,4955,'tl','',0),(178370,4955,'th','&#3623;&#3634;&#3591;&#3610;&#3636;&#3621;&#3627;&#3621;&#3633;&#3591;&#3623;&#3633;&#3609;&#3588;&#3619;&#3610;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(178371,4955,'hi','à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚ à¤¦à¥‡à¤¯ à¤¬à¤¿à¤²',0),(178372,4955,'ms','Bil perlu dibayar kemudian',0),(178373,4955,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© ÙÙŠ ÙˆÙ‚Øª Ù„Ø§Ø­Ù‚',0),(178374,4955,'fr','Factures Ã  Ã©chÃ©ance plus tard',0),(178375,4955,'jp','Bills Due Later',0),(178376,4955,'pt','Contas devido mais tarde',0),(178377,4955,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð·Ð° Ð¿Ð¾Ð·Ð´Ð½ÐµÐµ',0),(178378,4955,'es','Facturas Vencidas mÃ¡s Tarde',0),(178379,4955,'de','SpÃ¤ter Rechnungen fÃ¤llige',0),(178380,4955,'en','Bills Due Later',0),(178381,4956,'is','',0),(178382,4956,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ  Ø³Ø±Ø±Ø³ÙŠØ¯ Ø§ÙƒÙ†ÙˆÙ†',0),(178383,4956,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ  Ø³Ø±Ø±Ø³ÙŠØ¯ Ø§ÙƒÙ†ÙˆÙ†',0),(178384,4956,'tr','YakÄ±nda Ã¶denecek faturalar',0),(178385,4956,'pl','Rachunki na szybko',0),(178386,4956,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸, Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸ ÑÐºÐ¾Ñ€Ð¾',0),(178387,4956,'ur','Ø¬Ù„Ø¯ ÛÛŒ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ø¨Ù„',0),(178388,4956,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸Ñ†Ðµ Ð´Ð¾ÑÐ¿ÐµÑ›Ð° ÑƒÑÐºÐ¾Ñ€Ð¾',0),(178389,4956,'vi','Thá»i Háº¡n HÃ³a ÄÆ¡n Sá»›m',0),(178390,4956,'af','Rekeninge Binnekort Verskuldig',0),(178391,4956,'ro','Facturile datorate Ã®n curÃ¢nd',0),(178392,4956,'et','Arved otse kiiresti',0),(178393,4956,'si','Menice zaradi kmalu',0),(178394,4956,'ba','Tagihan karena segera',0),(178395,4956,'nl','Facturen verschuldigd snel',0),(178396,4956,'fi','Laskut maksettava pian',0),(178397,4956,'no','Regninger forfaller snart',0),(178398,4956,'da','Regninger forfalder snart',0),(178399,4956,'ko','ê³§ ì˜ˆì • ë²•ì•ˆ',0),(178400,4956,'he','×©×˜×¨×•×ª ×œ×”×’×™×© ×‘×§×¨×•×‘',0),(178401,4956,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î±Î½Î±Î¼Î­Î½ÎµÏ„Î±Î¹ ÏƒÏÎ½Ï„Î¿Î¼Î±',0),(178402,4956,'zh','å¸å•å³å°†æˆªæ­¢\r\n',0),(178403,4956,'sv','RÃ¤kningar fÃ¶rfaller snart',0),(178404,4956,'it','Bollette dovuto presto',0),(178405,4956,'tl','',0),(178406,4956,'th','&#3651;&#3585;&#3621;&#3657;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3623;&#3634;&#3591;&#3610;&#3636;&#3621;',0),(178407,4956,'hi','à¤œà¤²à¥à¤¦ à¤¹à¥€ à¤¨à¤¿à¤¯à¤¤ à¤¬à¤¿à¤²',0),(178408,4956,'ms','Bil perlu dibayar tidak lama lagi',0),(178409,4956,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ù‚Ø±ÙŠØ¨Ø§',0),(178410,4956,'fr','BientÃ´t des factures dues',0),(178411,4956,'jp','Bills Due Soon',0),(178412,4956,'pt','Contas devidas em breve',0),(178413,4956,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð´Ð¾Ð»Ð¶ÐµÐ½ ÑÐºÐ¾Ñ€Ð¾',0),(178414,4956,'es','Facturas Vencidas Pronto',0),(178415,4956,'de','Bald Rechnungen fÃ¤lligen',0),(178416,4956,'en','Bills Due Soon',0),(178417,4957,'is','',0),(178418,4957,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¨Ø¯Ù‡ÙŠ Ù‚Ø¨Ù„ÙŠ',0),(178419,4957,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¨Ø¯Ù‡ÙŠ Ù‚Ø¨Ù„ÙŠ',0),(178420,4957,'tr','Vadesi gelen Kambiyo senetlerinin geÃ§miÅŸ',0),(178421,4957,'pl','Odpowiednim rachunkÃ³w',0),(178422,4957,'bg','ÐœÐ¸Ð½Ð°Ð»Ð¸ Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(178423,4957,'ur','Ù…Ø§Ø¶ÛŒ Ú©Û’ Ø­Ù‚ Ú©Û’ Ø¨Ù„',0),(178424,4957,'sr','ÐŸÐ¾Ñ€ÐµÐ´ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(178425,4957,'vi','HÃ³a ÄÆ¡n Äáº¿n Háº¡n Trong QuÃ¡ Khá»©',0),(178426,4957,'af','Vorige Verskuldige Rekeninge',0),(178427,4957,'ro','Trecut util. facturile',0),(178428,4957,'et','TÃ¤htaja Ã¼letanud arved',0),(178429,4957,'si','Mimo zapadlosti menice',0),(178430,4957,'ba','Masa lalu karena tagihan',0),(178431,4957,'nl','Verleden Due rekeningen',0),(178432,4957,'fi','ErÃ¤Ã¤ntyneistÃ¤ laskuista',0),(178433,4957,'no','Siste forfallsdato regninger',0),(178434,4957,'da','Forbi Due regninger',0),(178435,4957,'ko','ì¸í•´ ì²­êµ¬ì„œ ê³¼ê±°',0),(178436,4957,'he','×‘×¢×‘×¨ ×™×¢×“ ×—×©×‘×•× ×•×ª',0),(178437,4957,'el','Î Î±ÏÎµÎ»Î¸ÏŒÎ½ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(178438,4957,'zh','é€¾æœŸå¸å•\r\n',0),(178439,4957,'sv','FÃ¶rbi Due rÃ¤kningar',0),(178440,4957,'it','Passato Due bollette',0),(178441,4957,'tl','',0),(178442,4957,'th','&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3',0),(178443,4957,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¬à¤¿à¤² à¤…à¤¤à¥€à¤¤',0),(178444,4957,'ms','Lepas habis tempoh bil',0),(178445,4957,'ar','ÙÙŠ Ø§Ù„Ù…Ø§Ø¶ÙŠ ÙÙˆØ§ØªÙŠØ± Ø§Ù„ÙˆØ§Ø¬Ø¨',0),(178446,4957,'fr','DerniÃ¨res factures dÃ»ment',0),(178447,4957,'jp','Past Due Bills',0),(178448,4957,'pt','Passado devido as contas',0),(178449,4957,'ru','Ð’ Ð¿Ñ€Ð¾ÑˆÐ»Ð¾Ð¼ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(178450,4957,'es','Recibos Atrasados',0),(178451,4957,'de','Vorbei an fÃ¤lligen Rechnungen',0),(178452,4957,'en','Past Due Bills',0),(178453,4958,'is','',0),(178454,4958,'dr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨â€ŒÙ‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(178455,4958,'pr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨â€ŒÙ‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(178456,4958,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ BorÃ§lar listesi',0),(178457,4958,'pl','Widok listy zobowiÄ…zaÅ„',0),(178458,4958,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð·Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(178459,4958,'ur','Ù…Ù†Ø¸Ø± Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ ÙÛØ±Ø³Øª',0),(178460,4958,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð»Ð¸ÑÑ‚Ðµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(178461,4958,'vi','Xem Danh SÃ¡ch Pháº£i Tráº£',0),(178462,4958,'af','Besigtig Betaalbare Lys',0),(178463,4958,'ro','Vezi lista de datorii',0),(178464,4958,'et','VÃµlad loend',0),(178465,4958,'si','Oglejte si seznam obveznosti',0),(178466,4958,'ba','Lihat daftar hutang',0),(178467,4958,'nl','Bekijk de lijst van de schulden',0),(178468,4958,'fi','NÃ¤ytÃ¤ ostojen luettelo',0),(178469,4958,'no','Vis leverandÃ¸rgjeld liste',0),(178470,4958,'da','Se kreditorstyring liste',0),(178471,4958,'ko','ë¯¸ì§€ê¸‰ê¸ˆ ëª©ë¡ ë³´ê¸°',0),(178472,4958,'he','×ª×¦×•×’×ª ×¨×©×™×ž×ª ×–×›××™×',0),(178473,4958,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»Î¯ÏƒÏ„Î±Ï‚ Ï…Ï€Î¿Ï‡ÏÎµÏŽÏƒÎµÏ‰Î½',0),(178474,4958,'zh','æŸ¥çœ‹åº”ä»˜åå•\r\n',0),(178475,4958,'sv','Visa LeverantÃ¶rsskulder lista',0),(178476,4958,'it','Vedi la lista dei debiti',0),(178477,4958,'tl','',0),(178478,4958,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(178479,4958,'hi','Payables à¤¸à¥‚à¤šà¥€ à¤¦à¥‡à¤–à¥‡à¤‚',0),(178480,4958,'ms','Lihat senarai pemiutang',0),(178481,4958,'ar','Ø¹Ø±Ø¶ Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹',0),(178482,4958,'fr','Afficher la liste des comptes fournisseurs',0),(178483,4958,'jp','æ”¯æ‰•ã?„ãƒªã‚¹ãƒˆã?®è¡¨ç¤º',0),(178484,4958,'pt','Ver lista de contas a pagar',0),(178485,4958,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(178486,4958,'es','Visionar Lista de Cuentas por Pagar',0),(178487,4958,'de','Verbindlichkeiten-Liste anzeigen',0),(178488,4958,'en','View Payables List',0),(178489,4959,'is','',0),(178490,4959,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§',0),(178491,4959,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§',0),(178492,4959,'tr','FaturalarÄ± birimi raporu',0),(178493,4959,'pl','Rachunki raportu',0),(178494,4959,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(178495,4959,'ur','Ø¨Ù„ Ú©Û’ Ø­Ø¬Ù… Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(178496,4959,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(178497,4959,'vi','BÃ¡o CÃ¡o Pháº¡m Vi HÃ³a ÄÆ¡n',0),(178498,4959,'af','Rekeninge Volume Verslag',0),(178499,4959,'ro','Raport de volum facturile',0),(178500,4959,'et','Arved mahu aruande',0),(178501,4959,'si','PoroÄilo obsega menice',0),(178502,4959,'ba','Tagihan Volume laporan',0),(178503,4959,'nl','Rekeningen Volume verslag',0),(178504,4959,'fi','Laskujen mÃ¤Ã¤rÃ¤ raportti',0),(178505,4959,'no','Regninger volum',0),(178506,4959,'da','Regninger volumen rapport',0),(178507,4959,'ko','ì§€í ëŸ‰ ë³´ê³ ì„œ',0),(178508,4959,'he','×”×—×©×‘×•× ×•×ª ×›×¨×š ×—',0),(178509,4959,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î¿ ÏŒÎ³ÎºÎ¿Ï‚ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ·',0),(178510,4959,'zh','ç¥¨æ®é‡æŠ¥å‘Š\r\n',0),(178511,4959,'sv','RÃ¤kningar rapporten volym',0),(178512,4959,'it','Relazione Volume bollette',0),(178513,4959,'tl','',0),(178514,4959,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3592;&#3635;&#3609;&#3623;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(178515,4959,'hi','à¤¬à¤¿à¤² à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(178516,4959,'ms','Laporan jumlah bil-bil',0),(178517,4959,'ar','ØªÙ‚Ø±ÙŠØ± Ø­Ø¬Ù… Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(178518,4959,'fr','Rapport Volume de factures',0),(178519,4959,'jp','è«‹æ±‚æ›¸é‡?ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(178520,4959,'pt','RelatÃ³rio de Volume de contas',0),(178521,4959,'ru','ÐžÐ±ÑŠÐµÐ¼ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° ÑÑ‡ÐµÑ‚Ð°',0),(178522,4959,'es','Facturas Informe de Volumen',0),(178523,4959,'de','Rechnungen-Volume-Bericht',0),(178524,4959,'en','Bills Volume Report',0),(178525,4960,'is','',0),(178526,4960,'dr',': Ù…Ø§Ù‡',0),(178527,4960,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø«Ø±ÙˆØªÙ…Ù†Ø¯ ØªØ±ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† : Ù…Ø§Ù‡',0),(178528,4960,'tr','Top 10 dolar SatÄ±cÄ±lar: ay',0),(178529,4960,'pl','Top 10 Dolar dostawcÃ³w: miesiÄ…c',0),(178530,4960,'bg','Ð¢Ð¾Ð¿ 10 Ð´Ð¾Ð»Ð°Ñ€Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸: Ð¼ÐµÑÐµÑ†',0),(178531,4960,'ur','Ø§ÙˆÙ¾Ø± 10 ÚˆØ§Ù„Ø± ÙˆÛŒÙ†ÚˆØ±Ø²: Ù…Ø§Û',0),(178532,4960,'sr','Ð¢Ð¾Ð¿ 10 Ð´Ð¾Ð»Ð°Ñ€ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ: Ð¼ÐµÑÐµÑ†',0),(178533,4960,'vi',' MÆ°á»i ngÆ°á»i bÃ¡n Dolla cao nháº¥t - thÃ¡ng',0),(178534,4960,'af','Top 10 Dollar Verskaffers:  Maand',0),(178535,4960,'ro','Top 10 dolari furnizori: luna',0),(178536,4960,'et','Top 10 kÃ¤ibega tarnijat: kuu lÃµikes',0),(178537,4960,'si','Top 10 dolar prodajalci: mesec',0),(178538,4960,'ba','Top 10 Dollar vendor: bulan',0),(178539,4960,'nl','Top 10 Dollar leveranciers: maand',0),(178540,4960,'fi','Top 10 dollaria toimittajat: kuukauden',0),(178541,4960,'no','Topp 10 Dollar leverandÃ¸rer: mÃ¥ned',0),(178542,4960,'da','Top 10 Dollar leverandÃ¸rer: mÃ¥ned',0),(178543,4960,'ko','í†± 10 ë‹¬ëŸ¬ ê³µê¸‰ ì—…ì²´: ë‹¬',0),(178544,4960,'he','×˜×•×¤ 10 ×“×•×œ×¨ ×¡×¤×§×™×: ×—×•×“×©',0),(178545,4960,'el','Top 10 Î´Î¿Î»Î¬ÏÎ¹Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚: ÎœÎ®Î½Î±Ï‚',0),(178546,4960,'zh','å‰10 åçš„ç¾Žå…ƒå–æ–¹ï¼šæœˆ\r\n',0),(178547,4960,'sv','Topp 10 Dollar leverantÃ¶rer: mÃ¥nad',0),(178548,4960,'it','Top 10 dollaro fornitori: mese',0),(178549,4960,'tl','',0),(178550,4960,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3604;&#3629;&#3621;&#3621;&#3656;&#3634;&#3619;&#3660;/&#3648;&#3604;&#3636;&#3629;&#3609;',0),(178551,4960,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤¡à¥‰à¤²à¤° à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚: à¤®à¤¹à¥€à¤¨à¥‡',0),(178552,4960,'ms','Top 10 dolar vendor: bulan',0),(178553,4960,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¯ÙˆÙ„Ø§Ø± Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ†: Ø§Ù„Ø´Ù‡Ø±',0),(178554,4960,'fr','Top 10 Dollar vendeursÂ : mois',0),(178555,4960,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?æ¥­è€…ï¼šæœˆ',0),(178556,4960,'pt','Top 10 dÃ³lar fornecedores: mÃªs',0),(178557,4960,'ru','Ð¢Ð¾Ð¿ 10 Ð´Ð¾Ð»Ð»Ð°Ñ€ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²: Ð¼ÐµÑÑÑ†',0),(178558,4960,'es','Los 10 Proveedores Principales en DÃ³lares: Mes',0),(178559,4960,'de','Top 10-Dollar-Anbieter: Monat',0),(178560,4960,'en','Top 10 Dollar Vendors: Month',0),(178561,4961,'is','',0),(178562,4961,'dr',': Ø³Ø§Ù„',0),(178563,4961,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø«Ø±ÙˆØªÙ…Ù†Ø¯ ØªØ±ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† : Ø³Ø§Ù„',0),(178564,4961,'tr','Top 10 dolar SatÄ±cÄ±lar: yÄ±l',0),(178565,4961,'pl','Top 10 Dolar dostawcÃ³w: rok',0),(178566,4961,'bg','Ð¢Ð¾Ð¿ 10 Ð´Ð¾Ð»Ð°Ñ€Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸: Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(178567,4961,'ur','Ø§ÙˆÙ¾Ø± 10 ÚˆØ§Ù„Ø± ÙˆÛŒÙ†ÚˆØ±Ø²: Ø³Ø§Ù„',0),(178568,4961,'sr','Ð¢Ð¾Ð¿ 10 Ð´Ð¾Ð»Ð°Ñ€ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ: Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(178569,4961,'vi','MÆ°á»i ngÆ°á»i bÃ¡n Dolla cao nháº¥t - NÄƒm',0),(178570,4961,'af','Top 10 Dollar Verskaffers:  Jaar',0),(178571,4961,'ro','Top 10 dolari furnizori: an',0),(178572,4961,'et','Top 10 kÃ¤ibega tarnijat: kuu lÃµikes',0),(178573,4961,'si','Top 10 dolar prodajalci: leto',0),(178574,4961,'ba','Top 10 Dollar vendor: tahun',0),(178575,4961,'nl','Top 10 Dollar leveranciers: jaar',0),(178576,4961,'fi','Top 10 dollaria toimittajat: vuoden',0),(178577,4961,'no','Topp 10 Dollar leverandÃ¸rer: Ã¥r',0),(178578,4961,'da','Top 10 Dollar leverandÃ¸rer: Ã¥r',0),(178579,4961,'ko','í†± 10 ë‹¬ëŸ¬ ê³µê¸‰ ì—…ì²´: 1 ë…„',0),(178580,4961,'he','×˜×•×¤ 10 ×“×•×œ×¨ ×¡×¤×§×™×: ×©× ×”',0),(178581,4961,'el','Top 10 Î´Î¿Î»Î¬ÏÎ¹Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚: Î­Ï„Î¿Ï‚',0),(178582,4961,'zh','å‰10 åçš„ä¾›åº”å•†ï¼šå¹´\r\n',0),(178583,4961,'sv','Topp 10 Dollar leverantÃ¶rer: Ã¥r',0),(178584,4961,'it','Top 10 dollaro fornitori: anno',0),(178585,4961,'tl','',0),(178586,4961,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3604;&#3629;&#3621;&#3621;&#3656;&#3634;&#3619;&#3660;/&#3611;&#3637;',0),(178587,4961,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤¡à¥‰à¤²à¤° à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚: à¤µà¤°à¥à¤·',0),(178588,4961,'ms','Top 10 dolar vendor: tahun',0),(178589,4961,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¯ÙˆÙ„Ø§Ø± Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ†: Ø§Ù„Ø³Ù†Ø©',0),(178590,4961,'fr','Top 10 Dollar vendeursÂ : an',0),(178591,4961,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?æ¥­è€…ï¼šå¹´',0),(178592,4961,'pt','Top 10 dÃ³lar fornecedores: ano',0),(178593,4961,'ru','Ð¢Ð¾Ð¿ 10 Ð´Ð¾Ð»Ð»Ð°Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð¾Ð²: Ð³Ð¾Ð´',0),(178594,4961,'es','Los 10 Proveedores Principales en DÃ³lares: AÃ±o',0),(178595,4961,'de','Top 10-Dollar-Anbieter: Jahr',0),(178596,4961,'en','Top 10 Dollar Vendors: Year',0),(178597,4962,'is','',0),(178598,4962,'dr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†',0),(178599,4962,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†',0),(178600,4962,'tr','En iyi 10 satÄ±cÄ±lar',0),(178601,4962,'pl','10 najlepszych dostawcÃ³w',0),(178602,4962,'bg','Ð¢Ð¾Ð¿ 10 Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(178603,4962,'ur','Ø§ÙˆÙ¾Ø± 10 Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº',0),(178604,4962,'sr','Ð¢Ð¾Ð¿ 10 Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸Ð¼Ð°',0),(178605,4962,'vi','MÆ°á»i NgÆ°á»i bÃ¡n cao nháº¥t ',0),(178606,4962,'af','Top 10 Verskaffers',0),(178607,4962,'ro','Top 10 furnizori',0),(178608,4962,'et','Top 10 tarnijat',0),(178609,4962,'si','Top 10 prodajalci',0),(178610,4962,'ba','Top 10 vendor',0),(178611,4962,'nl','Top 10 leveranciers',0),(178612,4962,'fi','10 suurinta toimittajaa',0),(178613,4962,'no','Topp 10 leverandÃ¸rer',0),(178614,4962,'da','Top 10 leverandÃ¸rer',0),(178615,4962,'ko','í†± 10 ì—…ì²´',0),(178616,4962,'he','×”×¢×œ×™×•×Ÿ 10 ×¡×¤×§×™×',0),(178617,4962,'el','Top 10 Ï€Ï‰Î»Î·Ï„Î­Ï‚',0),(178618,4962,'zh','å‰ååä¾›åº”å•†\r\n',0),(178619,4962,'sv','Topp 10 leverantÃ¶rer',0),(178620,4962,'it','10 migliori fornitori',0),(178621,4962,'tl','',0),(178622,4962,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(178623,4962,'hi','10 à¤¶à¥€à¤°à¥à¤· à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(178624,4962,'ms','Pembekal Top 10',0),(178625,4962,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ†',0),(178626,4962,'fr','Top 10 vendeurs',0),(178627,4962,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?æ¥­è€…',0),(178628,4962,'pt','Top 10 fornecedores',0),(178629,4962,'ru','Ð¢Ð¾Ð¿ 10 ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(178630,4962,'es','Los 10 Proveedores Principales ',0),(178631,4962,'de','Top 10 Anbieter',0),(178632,4962,'en','Top 10 Vendors',0),(178633,4963,'is','',0),(178634,4963,'dr','1 Ø³Ø§Ù„',0),(178635,4963,'pr','1 Ø³Ø§Ù„',0),(178636,4963,'tr','1 yÄ±l',0),(178637,4963,'pl','1 rok',0),(178638,4963,'bg','1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(178639,4963,'ur','Ø³Ø§Ù„',0),(178640,4963,'sr','1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(178641,4963,'vi','1 NÄƒm',0),(178642,4963,'af','1 Jaar',0),(178643,4963,'ro','Un an',0),(178644,4963,'et','1 Aasta',0),(178645,4963,'si','1 leto',0),(178646,4963,'ba','1 Tahun',0),(178647,4963,'nl','1 jaar',0),(178648,4963,'fi','1 vuosi',0),(178649,4963,'no','ett Ã¥r',0),(178650,4963,'da','1 Ã¥r',0),(178651,4963,'ko','1 ë…„',0),(178652,4963,'he','1 ×©× ×”',0),(178653,4963,'el','ÎˆÎ½Î± ÎˆÏ„Î¿Ï‚',0),(178654,4963,'zh','ä¸€å¹´',0),(178655,4963,'sv','1 Ã…r',0),(178656,4963,'it','Un Anno',0),(178657,4963,'tl','',0),(178658,4963,'th','1 à¸›à¸µ',0),(178659,4963,'hi','1 à¤µà¤°à¥à¤·',0),(178660,4963,'ms','1 tahun',0),(178661,4963,'ar','Ø³Ù†Ø© ÙˆØ§Ø­Ø¯Ø©',0),(178662,4963,'fr','1 An',0),(178663,4963,'jp','1å¹´',0),(178664,4963,'pt','1 ano',0),(178665,4963,'ru','1 Ð“Ð¾Ð´',0),(178666,4963,'es','1 AÃ±o',0),(178667,4963,'de','Ein Jahr',0),(178668,4963,'en','1 Year',0),(178669,4964,'is','',0),(178670,4964,'dr',':  12 Ù…Ø§Ù‡',0),(178671,4964,'pr','Ø­Ø¬Ù… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§:  12 Ù…Ø§Ù‡',0),(178672,4964,'tr','FaturalarÄ± Cilt: 12 ay',0),(178673,4964,'pl','Rachunki objÄ™toÅ›Ä‡: 12 miesiÄ™cy',0),(178674,4964,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð¾Ð±ÐµÐ¼: 12 Ð¼ÐµÑÐµÑ†Ð°',0),(178675,4964,'ur','Ø¨Ù„ ØµÙˆØª: 12 Ù…Ø§Û Ú©Û’',0),(178676,4964,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½: 12 Ð¼ÐµÑÐµÑ†Ð¸',0),(178677,4964,'vi','Pháº¡m Vi HÃ³a ÄÆ¡n: 12 thÃ¡ng',0),(178678,4964,'af','Rekeninge Volume:  12 Maande',0),(178679,4964,'ro','Facturile de volum: 12 luni',0),(178680,4964,'et','Arved maht: 12 kuud',0),(178681,4964,'si','Menice volumen: 12 mesecev',0),(178682,4964,'ba','Tagihan Volume: 12 bulan',0),(178683,4964,'nl','Rekeningen Volume: 12 maanden',0),(178684,4964,'fi','Laskujen mÃ¤Ã¤rÃ¤: 12 kuukautta',0),(178685,4964,'no','Regninger volum: 12 mÃ¥neder',0),(178686,4964,'da','Regninger volumen: 12 mÃ¥neder',0),(178687,4964,'ko','ì§€í ë³¼ë¥¨: 12 ê°œì›”',0),(178688,4964,'he','×”×—×©×‘×•× ×•×ª × ×¤×—: 12 ×—×•×“×©×™×',0),(178689,4964,'el','Î¤ÏŒÎ¼Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚: 12 Î¼Î®Î½ÎµÏ‚',0),(178690,4964,'zh','ç¥¨æ®é‡ï¼š12ä¸ªæœˆ\r\n',0),(178691,4964,'sv','RÃ¤kningar volym: 12 mÃ¥nader',0),(178692,4964,'it','Volume di fatture: 12 mesi',0),(178693,4964,'tl','',0),(178694,4964,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3610;&#3636;&#3621; 12 &#3648;&#3604;&#3639;&#3629;&#3609;',0),(178695,4964,'hi','à¤¬à¤¿à¤² à¤µà¥‰à¤²à¥à¤¯à¥‚à¤®: 12 à¤®à¤¹à¥€à¤¨à¥‹à¤‚',0),(178696,4964,'ms','Jumlah bil: 12 bulan',0),(178697,4964,'ar','Ø­Ø¬Ù… Ø§Ù„ÙÙˆØ§ØªÙŠØ±: 12 Ø´Ù‡Ø±Ø§',0),(178698,4964,'fr','Volume de factures : 12 mois',0),(178699,4964,'jp','è«‹æ±‚æ›¸é‡?ï¼šï¼‘ï¼’ãƒ¶æœˆ',0),(178700,4964,'pt','Volume de contas: 12 meses',0),(178701,4964,'ru','ÐžÐ±ÑŠÐµÐ¼ Ð²ÐµÐºÑÐµÐ»ÐµÐ¹: 12 Ð¼ÐµÑÑÑ†ÐµÐ²',0),(178702,4964,'es','Volumen de Facturas: 12 Meses',0),(178703,4964,'de','Rechnungen-Volumen: 12 Monate',0),(178704,4964,'en','Bills Volume: 12 Months',0),(178705,4965,'is','',0),(178706,4965,'dr',':  7 Ø±ÙˆØ²',0),(178707,4965,'pr','Ø­Ø¬Ù… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§:  7 Ø±ÙˆØ²',0),(178708,4965,'tr','FaturalarÄ± Cilt: 7 gÃ¼n',0),(178709,4965,'pl','Rachunki wielkoÅ›ci: 7 dni',0),(178710,4965,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸, Ñ‚Ð¾Ð¼: 7 Ð´Ð½Ð¸',0),(178711,4965,'ur','Ø¨Ù„ ØµÙˆØª: 7 Ø¯Ù†',0),(178712,4965,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½: 7 Ð´Ð°Ð½Ð°',0),(178713,4965,'vi','Pháº¡m Vi HÃ³a ÄÆ¡n: 7 ngÃ y',0),(178714,4965,'af','Rekeninge Volume:  7 Dae',0),(178715,4965,'ro','Facturile de volum: 7 zile',0),(178716,4965,'et','Arved maht: 7 pÃ¤eva',0),(178717,4965,'si','Menice prostornina: 7 dni',0),(178718,4965,'ba','Tagihan Volume: 7 hari',0),(178719,4965,'nl','Rekeningen Volume: 7 dagen',0),(178720,4965,'fi','Laskujen mÃ¤Ã¤rÃ¤: 7 pÃ¤ivÃ¤Ã¤',0),(178721,4965,'no','Regninger volum: 7 dager',0),(178722,4965,'da','Regninger volumen: 7 dage',0),(178723,4965,'ko','ì§€í ë³¼ë¥¨: 7 ì¼',0),(178724,4965,'he','×”×—×©×‘×•× ×•×ª × ×¤×—: 7 ×™×ž×™×',0),(178725,4965,'el','Î¤ÏŒÎ¼Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚: 7 Î·Î¼Î­ÏÎµÏ‚',0),(178726,4965,'zh','ç¥¨æ®é‡ï¼š7å¤©\r\n',0),(178727,4965,'sv','RÃ¤kningar volym: 7 dagar',0),(178728,4965,'it','Volume di fatture: 7 giorni',0),(178729,4965,'tl','',0),(178730,4965,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3610;&#3636;&#3621; 7 &#3623;&#3633;&#3609;',0),(178731,4965,'hi','à¤¬à¤¿à¤² à¤µà¥‰à¤²à¥à¤¯à¥‚à¤®: 7 à¤¦à¤¿à¤¨',0),(178732,4965,'ms','Jumlah bil: 7 hari',0),(178733,4965,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªØ®Ø²ÙŠÙ†: 7 Ø£ÙŠØ§Ù…',0),(178734,4965,'fr','Volume de factures: 7 jours',0),(178735,4965,'jp','è«‹æ±‚æ›¸é‡?ï¼šï¼—æ—¥é–“',0),(178736,4965,'pt','Volume de contas: 7 dias',0),(178737,4965,'ru','ÐžÐ±ÑŠÐµÐ¼ ÑÑ‡ÐµÑ‚Ð°: 7 Ð´Ð½ÐµÐ¹',0),(178738,4965,'es','Volumen de Facturas: 7 DÃ­as',0),(178739,4965,'de','Rechnungen-Volumen: 7 Tage',0),(178740,4965,'en','Bills Volume: 7 Days',0),(178741,4966,'is','',0),(178742,4966,'dr',':  8 Ù‡ÙØªÙ‡',0),(178743,4966,'pr','Ø­Ø¬Ù… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§:  8 Ù‡ÙØªÙ‡',0),(178744,4966,'tr','FaturalarÄ± Cilt: 8 hafta',0),(178745,4966,'pl','Rachunki objÄ™toÅ›Ä‡: 8 tygodni',0),(178746,4966,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð¾Ð±ÐµÐ¼: 8 ÑÐµÐ´Ð¼Ð¸Ñ†Ð¸',0),(178747,4966,'ur','Ø¨Ù„ ØµÙˆØª: 8 ÛÙØªÙˆÚº Ú©Û’',0),(178748,4966,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½Ð°: 8 Ð½ÐµÐ´ÐµÑ™Ð°',0),(178749,4966,'vi','Pháº¡m Vi HÃ³a ÄÆ¡n: 8 Tuáº§n',0),(178750,4966,'af','Rekeninge Volume:  8 Weke',0),(178751,4966,'ro','Facturile Volumul: 8 saptamani',0),(178752,4966,'et','Arved maht: 8 nÃ¤dalat',0),(178753,4966,'si','Menice obsega: 8 tednov',0),(178754,4966,'ba','Tagihan Volume: 8 minggu',0),(178755,4966,'nl','Rekeningen Volume: 8 weken',0),(178756,4966,'fi','Laskujen mÃ¤Ã¤rÃ¤: 8 viikkoa',0),(178757,4966,'no','Regninger volum: 8 uker',0),(178758,4966,'da','Regninger volumen: 8 uger',0),(178759,4966,'ko','ì§€í ì–‘: 8 ì£¼',0),(178760,4966,'he','×”×—×©×‘×•× ×•×ª × ×¤×—: 8 ×©×‘×•×¢×•×ª',0),(178761,4966,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ ÏŒÎ³ÎºÎ¿Ï…: 8 ÎµÎ²Î´Î¿Î¼Î¬Î´ÎµÏ‚',0),(178762,4966,'zh','ç¥¨æ®é‡ï¼š8å‘¨\r\n',0),(178763,4966,'sv','RÃ¤kningar volym: 8 veckor',0),(178764,4966,'it','Volume di fatture: 8 settimane',0),(178765,4966,'tl','',0),(178766,4966,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3610;&#3636;&#3621; 8 &#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(178767,4966,'hi','à¤¬à¤¿à¤² à¤µà¥‰à¤²à¥à¤¯à¥‚à¤®: 8 à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(178768,4966,'ms','Jumlah bil: 8 minggu',0),(178769,4966,'ar','Ø­Ø¬Ù… Ø§Ù„ÙÙˆØ§ØªÙŠØ±: 8 Ø£Ø³Ø§Ø¨ÙŠØ¹',0),(178770,4966,'fr','Volume de factures: 8 semaines',0),(178771,4966,'jp','è«‹æ±‚æ›¸é‡?ï¼šï¼˜é€±é–“',0),(178772,4966,'pt','Volume de contas: 8 semanas',0),(178773,4966,'ru','ÐžÐ±ÑŠÐµÐ¼ Ð²ÐµÐºÑÐµÐ»ÐµÐ¹: 8 Ð½ÐµÐ´ÐµÐ»ÑŒ',0),(178774,4966,'es','Volumen de Facturas: 8 Semanas',0),(178775,4966,'de','Rechnungen Volumen: 8 Wochen',0),(178776,4966,'en','Bills Volume: 8 Weeks',0),(178777,4967,'is','',0),(178778,4967,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(178779,4967,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(178780,4967,'tr','AlÄ±nan son faturalarÄ±',0),(178781,4967,'pl','Ostatnie rachunki otrzymaÅ‚',0),(178782,4967,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸',0),(178783,4967,'ur','Ø­Ø§Ù„ÛŒÛ Ø¨Ù„ Ù…ÙˆØµÙˆÙ„',0),(178784,4967,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾',0),(178785,4967,'vi','HÃ³a Ä‘Æ¡n má»›i nháº­n gáº§n Ä‘Ã¢y',0),(178786,4967,'af','Onlangse Rekeninge Ontvang',0),(178787,4967,'ro','Recente facturile primite',0),(178788,4967,'et','Sai tehtud arveid',0),(178789,4967,'si','Nedavni menice, prejete',0),(178790,4967,'ba','Tanggal tagihan yang diterima',0),(178791,4967,'nl','Recente facturen ontvangen',0),(178792,4967,'fi','Hotelliin laskuja saanut',0),(178793,4967,'no','Siste regninger mottatt',0),(178794,4967,'da','Seneste regninger modtaget',0),(178795,4967,'ko','ìµœê·¼ ì²­êµ¬ì„œ ì ‘ìˆ˜',0),(178796,4967,'he','×—×©×‘×•× ×•×ª ××—×¨×•× ×™× ×©×”×ª×§×‘×œ×•',0),(178797,4967,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î­Î»Î±Î²Îµ',0),(178798,4967,'zh','æœ€è¿‘æ”¶åˆ°çš„å¸å•\r\n',0),(178799,4967,'sv','Senaste rÃ¤kningar fick',0),(178800,4967,'it','Recenti fatture ricevute',0),(178801,4967,'tl','',0),(178802,4967,'th','&#3619;&#3633;&#3610;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(178803,4967,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤¬à¤¿à¤² à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(178804,4967,'ms','Bil hari diterima',0),(178805,4967,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø£Ø®ÙŠØ±Ø© ØªÙ„Ù‚Øª',0),(178806,4967,'fr','Ces derniÃ¨res factures reÃ§ues',0),(178807,4967,'jp','æœ€è¿‘å?—é ˜ã?—ã?Ÿè«‹æ±‚æ›¸',0),(178808,4967,'pt','Recentes notas recebidas',0),(178809,4967,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(178810,4967,'es','Recibos Recibidos Recientemente',0),(178811,4967,'de','Den letzten Rechnungen empfangen',0),(178812,4967,'en','Recent Bills Received',0),(178813,4968,'is','',0),(178814,4968,'dr',': 1 Ù…Ø§Ù‡',0),(178815,4968,'pr','Ú†Ùƒ Ù‡Ø§ÙŠ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡: 1 Ù…Ø§Ù‡',0),(178816,4968,'tr','YazÄ±lÄ± denetler: 1 ay',0),(178817,4968,'pl','Sprawdza napisaÅ‚: 1 miesiÄ…c',0),(178818,4968,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐ²Ð° Ð¿Ð¸ÑÐ¼ÐµÐ½Ð¸: 1 Ð¼ÐµÑÐµÑ†',0),(178819,4968,'ur','ØªØ­Ø±ÛŒØ±ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’: 1 Ù…ÛÛŒÙ†Û’',0),(178820,4968,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð° Ð¿Ð¸ÑÐ°Ð½Ð¸: 1 Ð¼ÐµÑÐµÑ†',0),(178821,4968,'vi','SÃ©c Ä‘Ã£ viáº¿t: 1 thÃ¡ng',0),(178822,4968,'af','Tjeks Uitgeskryf:  1 Maand',0),(178823,4968,'ro','VerificÄƒ scris: 1 lunÄƒ',0),(178824,4968,'et','Kontrolli kirjalik: 1 kuu',0),(178825,4968,'si','Pregledi, pisno: 1 mesec',0),(178826,4968,'ba','Cek tertulis: 1 bulan',0),(178827,4968,'nl','Controleert schriftelijke: 1 maand',0),(178828,4968,'fi','Tarkistaa kirjallisia: 1 kuukausi',0),(178829,4968,'no','Sjekker skrevet: 1 mÃ¥ned',0),(178830,4968,'da','Kontrollerer skriftlig: 1 mÃ¥ned',0),(178831,4968,'ko','ì„œ ë©´ ê²€ì‚¬: 1 ê°œì›”',0),(178832,4968,'he','×‘×•×“×§ ×‘×›×ª×‘: 1 ×—×•×“×©',0),(178833,4968,'el','Î•Î»Î­Î³Ï‡ÎµÎ¹ Î³ÏÎ±Ï€Ï„Î®: 1 Î¼Î®Î½Î±Ï‚',0),(178834,4968,'zh','ä¹¦é¢æ£€æŸ¥ï¼š1ä¸ªæœˆ\r\n',0),(178835,4968,'sv','Kontrollerar skriftlig: 1 mÃ¥nad',0),(178836,4968,'it','Verifica scritta: 1 mese',0),(178837,4968,'tl','',0),(178838,4968,'th','&#3648;&#3594;&#3655;&#3588;&#3621;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3621;&#3656;&#3623;&#3591;&#3627;&#3609;&#3657;&#3634; 1 &#3648;&#3604;&#3639;&#3629;&#3609;',0),(178839,4968,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨ à¤•à¥‡ à¤²à¤¿à¤–à¤¿à¤¤ à¤œà¤¾à¤à¤š à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ: 1 à¤®à¤¹à¥€à¤¨à¥‡',0),(178840,4968,'ms','Menyemak bertulis: 1 bulan',0),(178841,4968,'ar','Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø®Ø·ÙŠØ©: 1 Ø´Ù‡Ø±',0),(178842,4968,'fr','VÃ©rifie Ã©crit: 1 mois',0),(178843,4968,'jp','Checks Written: 1 Month',0),(178844,4968,'pt','Verifica a escrita: 1 mÃªs',0),(178845,4968,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚ Ð¿Ð¸ÑÑŒÐ¼ÐµÐ½Ð½Ñ‹Ðµ: 1 Ð¼ÐµÑÑÑ†',0),(178846,4968,'es','Cheques Escritos: 1 Mes',0),(178847,4968,'de','Schriftliche Ã¼berprÃ¼ft: 1 Monat',0),(178848,4968,'en','Checks Written: 1 Month',0),(178849,4969,'is','',0),(178850,4969,'dr',': 7 Ø±ÙˆØ²',0),(178851,4969,'pr','Ú†Ùƒ Ù‡Ø§ÙŠ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡: 7 Ø±ÙˆØ²',0),(178852,4969,'tr','YazÄ±lÄ± denetler: 7 gÃ¼n',0),(178853,4969,'pl','Sprawdza napisaÅ‚: 7 dni',0),(178854,4969,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐ²Ð° Ð¿Ð¸ÑÐ¼ÐµÐ½Ð¸: 7 Ð´Ð½Ð¸',0),(178855,4969,'ur','ØªØ­Ø±ÛŒØ±ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’: 7 Ø¯Ù†',0),(178856,4969,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð° Ð¿Ð¸ÑÐ°Ð½Ð¸: 7 Ð´Ð°Ð½Ð°',0),(178857,4969,'vi','SÃ©c Ä‘Ã£ viáº¿t: 7 ngÃ y',0),(178858,4969,'af','Tjeks Uitgeskryf:  7 Dae',0),(178859,4969,'ro','VerificÄƒ scris: 7 zile',0),(178860,4969,'et','Kontrolli kirjalik: 7 pÃ¤eva',0),(178861,4969,'si','Pregledi, pisno: 7 dni',0),(178862,4969,'ba','Cek tertulis: 7 hari',0),(178863,4969,'nl','Controleert schriftelijke: 7 dagen',0),(178864,4969,'fi','Tarkistaa kirjallisia: 7 pÃ¤ivÃ¤Ã¤',0),(178865,4969,'no','Sjekker skrevet: 7 dager',0),(178866,4969,'da','Kontrollerer skriftlig: 7 dage',0),(178867,4969,'ko','ì„œ ë©´ ê²€ì‚¬: 7 ì¼',0),(178868,4969,'he','×‘×•×“×§ ×‘×›×ª×‘: 7 ×™×ž×™×',0),(178869,4969,'el','Î•Î»Î­Î³Ï‡ÎµÎ¹ Î³ÏÎ±Ï€Ï„Î®: 7 Î·Î¼Î­ÏÎµÏ‚',0),(178870,4969,'zh','ä¹¦é¢æ£€æŸ¥ï¼š7å¤©\r\n',0),(178871,4969,'sv','Kontrollerar skrivet: 7 dagar',0),(178872,4969,'it','Verifica scritta: 7 giorni',0),(178873,4969,'tl','',0),(178874,4969,'th','&#3648;&#3594;&#3655;&#3588;&#3621;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3621;&#3656;&#3623;&#3591;&#3627;&#3609;&#3657;&#3634; 7 &#3623;&#3633;&#3609;',0),(178875,4969,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨ à¤•à¥‡ à¤²à¤¿à¤–à¤¿à¤¤ à¤œà¤¾à¤à¤š à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ: 7 à¤¦à¤¿à¤¨à¥‹à¤‚',0),(178876,4969,'ms','Menyemak bertulis: 7 hari',0),(178877,4969,'ar','Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø®Ø·ÙŠØ©: 7 Ø£ÙŠØ§Ù…',0),(178878,4969,'fr','VÃ©rifie Ã©crit: 7 jours',0),(178879,4969,'jp','Checks Written: 7 Days',0),(178880,4969,'pt','Verifica-se escrito: 7 dias',0),(178881,4969,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚ Ð¿Ð¸ÑÑŒÐ¼ÐµÐ½Ð½Ñ‹Ðµ: 7 Ð´Ð½ÐµÐ¹',0),(178882,4969,'es','Cheques Escritos: 7 DÃ­as',0),(178883,4969,'de','Schriftliche Ã¼berprÃ¼ft: 7 Tage',0),(178884,4969,'en','Checks Written: 7 Days',0),(178885,4970,'is','',0),(178886,4970,'dr','ÛŒÚ© Ù…Ø§Ù‡',0),(178887,4970,'pr','ÛŒÚ© Ù…Ø§Ù‡',0),(178888,4970,'tr','Bir ay',0),(178889,4970,'pl','Jeden miesiÄ…c',0),(178890,4970,'bg','Ð•Ð´Ð¸Ð½ Ð¼ÐµÑÐµÑ†',0),(178891,4970,'ur','Ø§ÛŒÚ© Ù…Ø§Ú¾',0),(178892,4970,'sr','ÐˆÐµÐ´Ð°Ð½ Ð¼ÐµÑÐµÑ†',0),(178893,4970,'vi','Má»™t ThÃ¡ng',0),(178894,4970,'af','Een Maand',0),(178895,4970,'ro','O luna',0),(178896,4970,'et','Ãœks kuu',0),(178897,4970,'si','En mesec',0),(178898,4970,'ba','Satu Bulan',0),(178899,4970,'nl','1 maand',0),(178900,4970,'fi','Kuukausi',0),(178901,4970,'no','en mÃ¥ned',0),(178902,4970,'da','En mÃ¥ned',0),(178903,4970,'ko','í•œ ë‹¬',0),(178904,4970,'he','×—×•×“×© ××—×“',0),(178905,4970,'el','ÎˆÎ½Î±Ï‚ ÎœÎ®Î½Î±Ï‚',0),(178906,4970,'zh','ä¸€ä¸ªæœˆ',0),(178907,4970,'sv','En MÃ¥nad',0),(178908,4970,'it','Un Mese',0),(178909,4970,'tl','',0),(178910,4970,'th','1 à¹€à¸”à¸·à¸­à¸™',0),(178911,4970,'hi','à¤à¤• à¤®à¤¹à¥€à¤¨à¤¾',0),(178912,4970,'ms','Satu bulan',0),(178913,4970,'ar','Ø´Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(178914,4970,'fr','Un Mois',0),(178915,4970,'jp','1ãƒ¶æœˆ',0),(178916,4970,'pt','Um mÃªs',0),(178917,4970,'ru','ÐžÐ´Ð¸Ð½ ÐœÐµÑÑÑ†',0),(178918,4970,'es','Un Mes',0),(178919,4970,'de','Ein Monat',0),(178920,4970,'en','One Month',0),(178921,4971,'is','',0),(178922,4971,'dr','Ú†Ùƒ Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ ',0),(178923,4971,'pr','Ú†Ùƒ Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ ',0),(178924,4971,'tr','Son kontroller yazÄ±lÄ±',0),(178925,4971,'pl','Ostatnie kontrole napisaÅ‚',0),(178926,4971,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¿Ð¸ÑÐ¼ÐµÐ½Ð¾',0),(178927,4971,'ur','Ø­Ø§Ù„ÛŒÛ Ú†ÛŒÚ© Ù„Ú©Ú¾Ø§',0),(178928,4971,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(178929,4971,'vi','SÃ©c má»›i viáº¿t',0),(178930,4971,'af','Onlangse Tjeks Uitgeskryf',0),(178931,4971,'ro','Controale recente scris',0),(178932,4971,'et','Tehtud kontrollide kirjutada',0),(178933,4971,'si','Nedavni pregledi koncu',0),(178934,4971,'ba','Tanggal cek ditulis',0),(178935,4971,'nl','Recente controles geschreven',0),(178936,4971,'fi','Hotelliin tarkastuksia kirjoitettu',0),(178937,4971,'no','Siste sjekker skrevet',0),(178938,4971,'da','Seneste kontrol skrevet',0),(178939,4971,'ko','ìµœê·¼ ê²€ì‚¬ ìž‘ì„±',0),(178940,4971,'he','×”×ž×—××•×ª ×”××—×¨×•× ×•×ª × ×›×ª×‘',0),(178941,4971,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Ï„Î¿Ï…Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Î³ÏÎ±Ï€Ï„Î®',0),(178942,4971,'zh','æœ€è¿‘çš„ä¹¦é¢æ”¯ç¥¨\r\n',0),(178943,4971,'sv','Senaste kontroller skrivna',0),(178944,4971,'it','Verifiche recenti scritti',0),(178945,4971,'tl','',0),(178946,4971,'th','&#3648;&#3594;&#3655;&#3588;&#3607;&#3637;&#3656;&#3648;&#3586;&#3637;&#3618;&#3609;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(178947,4971,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤²à¤¿à¤–à¤¾ à¤šà¥‡à¤•',0),(178948,4971,'ms','Semalam cek yang ditulis',0),(178949,4971,'ar','ØµÙƒÙˆÙƒ Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø­Ø¯ÙŠØ«Ø©',0),(178950,4971,'fr','Ces derniers chÃ¨ques Ã©mis',0),(178951,4971,'jp','Recent Checks Written',0),(178952,4971,'pt','Ãšltimos cheques escritos',0),(178953,4971,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ñ‡ÐµÐºÐ¾Ð²',0),(178954,4971,'es','Cheques Elaborados Recientemente',0),(178955,4971,'de','Den letzten PrÃ¼fungen geschrieben',0),(178956,4971,'en','Recent Checks Written',0),(178957,4972,'is','',0),(178958,4972,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ú†Ùƒ Ù‡Ø§',0),(178959,4972,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ú†Ùƒ Ù‡Ø§',0),(178960,4972,'tr','Toplam kontrol',0),(178961,4972,'pl','CaÅ‚kowitej kontroli',0),(178962,4972,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(178963,4972,'ur','Ú©Ù„ Ú†ÛŒÚ©',0),(178964,4972,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(178965,4972,'vi','Táº¥t cáº£ SÃ©c',0),(178966,4972,'af','Totale Tjeks',0),(178967,4972,'ro','Total controale',0),(178968,4972,'et','Kokku kontrolli',0),(178969,4972,'si','Skupni pregledi',0),(178970,4972,'ba','Total cek',0),(178971,4972,'nl','Totale controle',0),(178972,4972,'fi','YhteensÃ¤ tarkastukset',0),(178973,4972,'no','Totalt sjekker',0),(178974,4972,'da','Total kontrol',0),(178975,4972,'ko','ì´ ê²€ì‚¬',0),(178976,4972,'he','×‘×“×™×§×•×ª ×¡×”',0),(178977,4972,'el','Î£ÏÎ½Î¿Î»Î¿ ÎµÎ»Î­Î³Ï‡Ï‰Î½',0),(178978,4972,'zh','æ€»è®¡æ”¯ç¥¨\r\n',0),(178979,4972,'sv','Totala kontroller',0),(178980,4972,'it','Totali controlli',0),(178981,4972,'tl','',0),(178982,4972,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3648;&#3594;&#3655;&#3588;',0),(178983,4972,'hi','à¤•à¥à¤² à¤•à¥€ à¤œà¤¾à¤‚à¤š',0),(178984,4972,'ms','Jumlah cek',0),(178985,4972,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø´ÙŠÙƒØ§Øª',0),(178986,4972,'fr','ContrÃ´le total',0),(178987,4972,'jp','å°?åˆ‡æ‰‹å?ˆè¨ˆ',0),(178988,4972,'pt','Controlo total',0),(178989,4972,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¾Ðº',0),(178990,4972,'es','Total de Cheques',0),(178991,4972,'de','Gesamt-PrÃ¼fungen',0),(178992,4972,'en','Total Checks',0),(178993,4973,'is','',0),(178994,4973,'dr','Ø±ÙˆØ²Ù‡Ø§',0),(178995,4973,'pr','Ø±ÙˆØ²Ù‡Ø§',0),(178996,4973,'tr','GÃ¼n',0),(178997,4973,'pl','Dni',0),(178998,4973,'bg','Ð”Ð½Ð¸',0),(178999,4973,'ur','Ø§ÛŒØ§Ù…',0),(179000,4973,'sr','Ð”Ð°Ð½Ð°',0),(179001,4973,'vi','NgÃ y',0),(179002,4973,'af','Dae',0),(179003,4973,'ro','Zile',0),(179004,4973,'et','PÃ¤eva',0),(179005,4973,'si','Dni',0),(179006,4973,'ba','Hari',0),(179007,4973,'nl','Dagen',0),(179008,4973,'fi','PÃ¤ivÃ¤Ã¤',0),(179009,4973,'no','Dager',0),(179010,4973,'da','Dage',0),(179011,4973,'ko','ì¼',0),(179012,4973,'he','×™×ž×™×',0),(179013,4973,'el','Î—Î¼Î­ÏÎµÏ‚',0),(179014,4973,'zh','å¤©\r\n',0),(179015,4973,'sv','Dagar',0),(179016,4973,'it','Giorni',0),(179017,4973,'tl','',0),(179018,4973,'th','&#3623;&#3633;&#3609;',0),(179019,4973,'hi','à¤¦à¤¿à¤¨à¥‹à¤‚',0),(179020,4973,'ms','Hari',0),(179021,4973,'ar','Ø§Ù„Ø£ÙŠØ§Ù…',0),(179022,4973,'fr','Jours',0),(179023,4973,'jp','æ—¥æ•°',0),(179024,4973,'pt','Dias',0),(179025,4973,'ru','Ð”Ð½Ð¸',0),(179026,4973,'es','DÃ­as',0),(179027,4973,'de','Tage',0),(179028,4973,'en','Days',0),(179029,4974,'is','',0),(179030,4974,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ§ÙƒØªÙˆØ±Ø´Ø¯Ù‡ ',0),(179031,4974,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ§ÙƒØªÙˆØ±Ø´Ø¯Ù‡ ',0),(179032,4974,'tr','Toplam fatura',0),(179033,4974,'pl','CaÅ‚kowita faktur',0),(179034,4974,'bg','ÐžÐ±Ñ‰Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(179035,4974,'ur','Ú©Ù„ ÙˆØ¨Ø¬Ù„ÛŒ',0),(179036,4974,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(179037,4974,'vi','Tá»•ng cá»™ng hÃ³a Ä‘Æ¡n',0),(179038,4974,'af','Totale Fakture',0),(179039,4974,'ro','Totalul facturilor',0),(179040,4974,'et','Arveid Kokku',0),(179041,4974,'si','Skupni raÄuni',0),(179042,4974,'ba','Total tagihan',0),(179043,4974,'nl','Totale facturen',0),(179044,4974,'fi','YhteensÃ¤ laskuja',0),(179045,4974,'no','Totalt antall fakturaer',0),(179046,4974,'da','Samlede fakturaer',0),(179047,4974,'ko','ì´ ì²­êµ¬ì„œ',0),(179048,4974,'he','×¡×” ×› ×—×©×‘×•× ×™×•×ª',0),(179049,4974,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(179050,4974,'zh','æ€»è®¡å‘ç¥¨\r\n',0),(179051,4974,'sv','Totala fakturor',0),(179052,4974,'it','Totale fatture',0),(179053,4974,'tl','',0),(179054,4974,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(179055,4974,'hi','à¤•à¥à¤² à¤šà¤¾à¤²à¤¾à¤¨',0),(179056,4974,'ms','Invois jumlah',0),(179057,4974,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(179058,4974,'fr','Total des factures',0),(179059,4974,'jp','è«‹æ±‚æ›¸å?ˆè¨ˆ',0),(179060,4974,'pt','Total de faturas',0),(179061,4974,'ru','Ð’ÑÐµÐ³Ð¾ Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(179062,4974,'es','Total Facturas',0),(179063,4974,'de','Total Rechnungen',0),(179064,4974,'en','Total Invoices',0),(179065,4975,'is','',0),(179066,4975,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ§ÙŠÙ„ Ø¨Ø§  Ù„ÙˆÚ¯ÙˆÙ‡Ø§ÙŠ Ø¨Ø²Ø±Ú¯',0),(179067,4975,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ§ÙŠÙ„ Ø¨Ø§  Ù„ÙˆÚ¯ÙˆÙ‡Ø§ÙŠ Ø¨Ø²Ø±Ú¯',0),(179068,4975,'tr','BÃ¼yÃ¼k grafik Logo',0),(179069,4975,'pl','DuÅ¼e Logo graficzne',0),(179070,4975,'bg','Ð“Ð¾Ð»ÑÐ¼ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÐ½ Ð»Ð¾Ð³Ð¾',0),(179071,4975,'ur','Ø¨Ú‘Û’ Ú¯Ø±Ø§ÙÚ© Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ)',0),(179072,4975,'sr','Ð’ÐµÐ»Ð¸ÐºÐ¸ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐºÐ¸ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿',0),(179073,4975,'vi','Há»“ sÆ¡ Logo vá»›i Ä‘á»“ há»a lá»›n',0),(179074,4975,'af','Groot Grafiese Embleem LÃªernaam',0),(179075,4975,'ro','Logo-ul grafic mare',0),(179076,4975,'et','Suur graafiline Logo',0),(179077,4975,'si','Velik grafiÄni Logo',0),(179078,4975,'ba','Logo grafis besar',0),(179079,4975,'nl','Grote grafische Logo',0),(179080,4975,'fi','Suuri graafinen Logo',0),(179081,4975,'no','Stor grafisk Logo',0),(179082,4975,'da','Stor grafisk Logo',0),(179083,4975,'ko','í° ê·¸ëž˜í”½ ë¡œê³ ',0),(179084,4975,'he','×¡×ž×œ ×’×¨×¤×™ ×’×“×•×œ',0),(179085,4975,'el','ÎœÎµÎ³Î¬Î»Î¿ Î³ÏÎ±Ï†Î¹ÎºÏŒ Î»Î¿Î³ÏŒÏ„Ï…Ï€Î¿',0),(179086,4975,'zh','è¾ƒå¤§çš„å›¾å½¢æ ‡å¿—\r\n',0),(179087,4975,'sv','Stor grafisk logotyp',0),(179088,4975,'it','Grande Logo grafico',0),(179089,4975,'tl','',0),(179090,4975,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3652;&#3615;&#3621;&#3660;&#3639;&#3650;&#3621;&#3650;&#3585;&#3657;&#3651;&#3627;&#3597;&#3656;',0),(179091,4975,'hi','à¤¬à¤¡à¤¼à¥€ à¤—à¥à¤°à¤¾à¤«à¤¿à¤• à¤²à¥‹à¤—à¥‹',0),(179092,4975,'ms','Logo grafik yang besar',0),(179093,4975,'ar','Ø¥Ø³Ù… Ù…Ù„Ù Ø§Ù„Ø´Ø¹Ø§Ø± Ø§Ù„ÙƒØ¨ÙŠØ±',0),(179094,4975,'fr','Grand Logo graphique',0),(179095,4975,'jp','å¤§ç”»åƒ?ãƒ­ã‚´ãƒ•ã‚¡ã‚¤ãƒ«',0),(179096,4975,'pt','Grande logotipo grÃ¡fico',0),(179097,4975,'ru','Ð‘Ð¾Ð»ÑŒÑˆÐ¾Ð¹ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿',0),(179098,4975,'es','Nombre de Archivo de GrÃ¡fica de Logo Grande',0),(179099,4975,'de','GroÃŸe Grafik-Logo',0),(179100,4975,'en','Large Graphic Logo',0),(179101,4976,'is','',0),(179102,4976,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ§ÙŠÙ„ Ø¨Ø§ Ù„ÙˆÚ¯ÙˆÙŠ ÙƒÙˆÚ†Ùƒ',0),(179103,4976,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ§ÙŠÙ„ Ø¨Ø§ Ù„ÙˆÚ¯ÙˆÙŠ ÙƒÙˆÚ†Ùƒ',0),(179104,4976,'tr','KÃ¼Ã§Ã¼k grafik Logo',0),(179105,4976,'pl','MaÅ‚e Logo graficzne',0),(179106,4976,'bg','ÐœÐ°Ð»ÑŠÐº Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÐ½ Ð»Ð¾Ð³Ð¾',0),(179107,4976,'ur','Ú†Ú¾ÙˆÙ¹Û’ Ú¯Ø±Ø§ÙÚ© Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ)',0),(179108,4976,'sr','ÐœÐ°Ð»Ð¸ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐºÐ¸ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿',0),(179109,4976,'vi','Há»“ sÆ¡ Logo vá»›i Ä‘á»“ há»a nhá»',0),(179110,4976,'af','Klein Grafiese Embleem LÃªernaam',0),(179111,4976,'ro','Logo-ul grafic mic',0),(179112,4976,'et','VÃ¤ike graafiline Logo',0),(179113,4976,'si','Mala grafiÄni Logo',0),(179114,4976,'ba','Logo grafis kecil',0),(179115,4976,'nl','Kleine grafische Logo',0),(179116,4976,'fi','Pieni graafinen Logo',0),(179117,4976,'no','Liten grafisk Logo',0),(179118,4976,'da','Lille grafisk Logo',0),(179119,4976,'ko','ìž‘ì€ ê·¸ëž˜í”½ ë¡œê³ ',0),(179120,4976,'he','×¡×ž×œ ×’×¨×¤×™ ×§×˜×Ÿ',0),(179121,4976,'el','ÎœÎ¹ÎºÏÏŒ Î³ÏÎ±Ï†Î¹ÎºÏŒ Î»Î¿Î³ÏŒÏ„Ï…Ï€Î¿',0),(179122,4976,'zh','å°å›¾å½¢æ ‡å¿—\r\n',0),(179123,4976,'sv','Liten grafisk logotyp',0),(179124,4976,'it','Piccolo Logo grafico',0),(179125,4976,'tl','',0),(179126,4976,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3652;&#3615;&#3621;&#3660;&#3639;&#3650;&#3621;&#3650;&#3585;&#3657;&#3648;&#3621;&#3655;&#3585;',0),(179127,4976,'hi','à¤›à¥‹à¤Ÿà¥‡ à¤—à¥à¤°à¤¾à¤«à¤¿à¤• à¤²à¥‹à¤—à¥‹',0),(179128,4976,'ms','Logo grafik yang kecil',0),(179129,4976,'ar','Ø¥Ø³Ù… Ù…Ù„Ù Ø§Ù„Ø´Ø¹Ø§Ø± Ø§Ù„ØµØºÙŠØ±',0),(179130,4976,'fr','Petit Logo graphique',0),(179131,4976,'jp','å°?ç”»åƒ?ãƒ­ã‚´ãƒ•ã‚¡ã‚¤ãƒ«',0),(179132,4976,'pt','Pequeno logotipo grÃ¡fico',0),(179133,4976,'ru','ÐÐµÐ±Ð¾Ð»ÑŒÑˆÐ¾Ð¹ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿',0),(179134,4976,'es','Nombre de File de GrÃ¡fica de Logo Chico',0),(179135,4976,'de','Kleine Grafik Logo',0),(179136,4976,'en','Small Graphic Logo',0),(179137,4977,'is','',0),(179138,4977,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡',0),(179139,4977,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡',0),(179140,4977,'tr','Bulunan hiÃ§bir PO',0),(179141,4977,'pl','Nie PO Znalezione',0),(179142,4977,'bg','ÐÑÐ¼Ð° PO Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(179143,4977,'ur','Ù¾Ø§ÛŒØ§ Ù†Û Ù¾Ùˆ',0),(179144,4977,'sr','ÐÐµÐ¼Ð° ÐŸÐž Ð½Ð°ÑˆÐ°Ð¾',0),(179145,4977,'vi','ChÆ°a tháº¥y Ä‘Æ¡n mua hÃ ng',0),(179146,4977,'af','Geen AB Gevind',0),(179147,4977,'ro','Nu PO gÄƒsit',0),(179148,4977,'et','Ei leidnud PO',0),(179149,4977,'si','Ne PO naÅ¡el',0),(179150,4977,'ba','PO tidak ditemukan',0),(179151,4977,'nl','Geen PO gevonden',0),(179152,4977,'fi','No PO lÃ¶ytyi',0),(179153,4977,'no','Ingen PO funnet',0),(179154,4977,'da','Ingen PO fundet',0),(179155,4977,'ko','ì•„ë‹ˆ í¬ ë°œê²¬',0),(179156,4977,'he','××™×Ÿ ×¤×• ×ž×¦×',0),(179157,4977,'el','Î”ÎµÎ½ PO Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(179158,4977,'zh','æ²¡æœ‰å‘çŽ°é‡‡è´­è®¢å•\r\n',0),(179159,4977,'sv','Inga PO hittade',0),(179160,4977,'it','No PO trovato',0),(179161,4977,'tl','',0),(179162,4977,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(179163,4977,'hi','à¤•à¥‹à¤ˆ à¤ªà¥‹ à¤ªà¤¾à¤¯à¤¾',0),(179164,4977,'ms','PO tidak ditemui',0),(179165,4977,'ar','Ø¨Ùˆ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(179166,4977,'fr','Aucun PO trouvÃ©',0),(179167,4977,'jp','æ³¨æ–‡æ›¸ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(179168,4977,'pt','NÃ£o PO encontrado',0),(179169,4977,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾ PO',0),(179170,4977,'es','No se EncontrÃ³ OC',0),(179171,4977,'de','Keine PO gefunden',0),(179172,4977,'en','No PO Found',0),(179173,4978,'is','',0),(179174,4978,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…Ø¹ÙˆÙ‚ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(179175,4978,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…Ø¹ÙˆÙ‚ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(179176,4978,'tr','Beklemedeki Ã¶ÄŸeler Ã¼zerinde PO',0),(179177,4978,'pl','Przedmioty oczekujÄ…ce na PO',0),(179178,4978,'bg','Ð’Ð¸ÑÑÑ‰Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð½Ð° PO',0),(179179,4978,'ur','Ù¾ÙˆØ³Ù¹ Ù¾Ø± Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø§Ø´ÛŒØ§',0),(179180,4978,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð° Ð¿Ð¾-Ð°',0),(179181,4978,'vi','HÃ ng táº¡m treo trÃªn Ä‘Æ¡n mua hÃ ng',0),(179182,4978,'af','Afwagtende Items Op AB',0),(179183,4978,'ro','Elementele Ã®n aÅŸteptare pe PO',0),(179184,4978,'et','Ootel Ã¼ksusi PO',0),(179185,4978,'si','ÄŒakajoÄi elementi na PO',0),(179186,4978,'ba','Item yang tertunda pada PO',0),(179187,4978,'nl','Wachtende Items op PO',0),(179188,4978,'fi','Odottavat alkiot PO',0),(179189,4978,'no','Ventende elementer pÃ¥ PO',0),(179190,4978,'da','Ventende elementer pÃ¥ PO',0),(179191,4978,'ko','í¬ì— ë³´ë¥˜ ì¤‘ì¸ í•­ëª©',0),(179192,4978,'he','×¤×¨×™×˜×™× ×ž×ž×ª×™× ×™× ×¢×œ ×¤×•',0),(179193,4978,'el','Î•ÎºÎºÏÎµÎ¼Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏ„Î·Î½ PO',0),(179194,4978,'zh','é‡‡è´­è®¢å•çš„å¾…åŠžé¡¹ç›®\r\n',0),(179195,4978,'sv','Avvaktande objekt pÃ¥ PO',0),(179196,4978,'it','Elementi in sospeso sul PO',0),(179197,4978,'tl','',0),(179198,4978,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3629;&#3',0),(179199,4978,'hi','PO à¤ªà¤° à¤²à¤‚à¤¬à¤¿à¤¤ à¤†à¤‡à¤Ÿà¤®',0),(179200,4978,'ms','Barang-barang yang belum selesai pada PO',0),(179201,4978,'ar','Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„Ù…Ø¹Ù„Ù‚Ø© Ø¹Ù„Ù‰ Ø¨Ùˆ',0),(179202,4978,'fr','Ã‰lÃ©ments en attente sur la PO',0),(179203,4978,'jp','æ³¨æ–‡æ›¸ã?®ä¿?ç•™ä¸­å“?ç›®',0),(179204,4978,'pt','Itens pendentes na PO',0),(179205,4978,'ru','ÐžÑÑ‚Ð°Ð²ÑˆÐ¸ÐµÑÑ Ð¿ÑƒÐ½ÐºÑ‚Ñ‹ Ð½Ð° PO',0),(179206,4978,'es','Pendientes Items en OC',0),(179207,4978,'de','Ausstehende Elemente am PO',0),(179208,4978,'en','Pending Items On PO',0),(179209,4979,'is','',0),(179210,4979,'dr','ØªØ§Ø±ÙŠØ® Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(179211,4979,'pr','ØªØ§Ø±ÙŠØ® Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(179212,4979,'tr','PO tarihi',0),(179213,4979,'pl','PO dacie',0),(179214,4979,'bg','ÐŸÐž Ð´Ð°Ñ‚Ð°',0),(179215,4979,'ur','Ù¾ÙˆØ³Ù¹ ØªØ§Ø±ÛŒØ®',0),(179216,4979,'sr','ÐŸÐž Ð´Ð°Ñ‚ÑƒÐ¼Ñƒ',0),(179217,4979,'vi','NgÃ y Ä‘Æ¡n mua hÃ ng',0),(179218,4979,'af','AB Datum',0),(179219,4979,'ro','Data de PO',0),(179220,4979,'et','PO kuupÃ¤ev',0),(179221,4979,'si','PO datumu',0),(179222,4979,'ba','Tanggal PO',0),(179223,4979,'nl','PO datum',0),(179224,4979,'fi','PO pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(179225,4979,'no','PO dato',0),(179226,4979,'da','PO dato',0),(179227,4979,'ko','í¬ ì¼',0),(179228,4979,'he','×ª××¨×™×š ×¤×•',0),(179229,4979,'el','Î‘ÎÎ† Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(179230,4979,'zh','è®¢å•æ—¥æœŸ\r\n',0),(179231,4979,'sv','PO datum',0),(179232,4979,'it','Data di PO',0),(179233,4979,'tl','',0),(179234,4979,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(179235,4979,'hi','à¤ªà¥‹ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(179236,4979,'ms','Tarikh PO',0),(179237,4979,'ar','Øµ. Ø¨ ØªØ§Ø±ÙŠØ®',0),(179238,4979,'fr','Date de la PO',0),(179239,4979,'jp','ç™ºæ³¨æ›¸ä½œæˆ?æ—¥',0),(179240,4979,'pt','Data de PO',0),(179241,4979,'ru','Ð”Ð°Ñ‚Ð° PO',0),(179242,4979,'es','OC Fecha',0),(179243,4979,'de','PO-Datum',0),(179244,4979,'en','PO Date',0),(179245,4980,'is','',0),(179246,4980,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(179247,4980,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(179248,4980,'tr','Req #',0),(179249,4980,'pl','REQ #',0),(179250,4980,'bg','REQ #',0),(179251,4980,'ur','Ø±Ù‚ #',0),(179252,4980,'sr','Ð›Ð¸ÑÑ‚ Ñ‚Ñ€ÐµÐ±. #',0),(179253,4980,'vi','YÃªu cáº§u sá»‘',0),(179254,4980,'af','Req #',0),(179255,4980,'ro','Req #',0),(179256,4980,'et','Req #',0),(179257,4980,'si','Req #',0),(179258,4980,'ba','Req #',0),(179259,4980,'nl','REQ #',0),(179260,4980,'fi','REQ #',0),(179261,4980,'no','Req #',0),(179262,4980,'da','REQ #',0),(179263,4980,'ko','Req #',0),(179264,4980,'he','× ×“×¨×© #',0),(179265,4980,'el','Req #',0),(179266,4980,'zh','è¦æ±‚çš„ï¼ƒ\r\n',0),(179267,4980,'sv','Req #',0),(179268,4980,'it','Req #',0),(179269,4980,'tl','',0),(179270,4980,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3585;&#3634;&#3619;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;',0),(179271,4980,'hi','à¤…à¤¨à¥à¤°à¥‹à¤§ #',0),(179272,4980,'ms','Req #',0),(179273,4980,'ar','Ù…Ø³Ø§ #',0),(179274,4980,'fr','Req #',0),(179275,4980,'jp','ãƒªã‚¯ã‚¨ã‚¹ãƒˆç•ªå?·',0),(179276,4980,'pt','Req #',0),(179277,4980,'ru','REQ #',0),(179278,4980,'es','Req.#',0),(179279,4980,'de','Req-',0),(179280,4980,'en','Req#',0),(179281,4981,'is','',0),(179282,4981,'dr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(179283,4981,'pr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(179284,4981,'tr','Listeyi gÃ¶rÃ¼ntÃ¼le PO',0),(179285,4981,'pl','Lista widok PO',0),(179286,4981,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¿Ð¾ ÑÐ¿Ð¸ÑÑŠÐº',0),(179287,4981,'ur','ÙÛØ±Ø³Øª Ø¯ÛŒÚ©Ú¾Ù†Ø§ Ù¾Ùˆ',0),(179288,4981,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐŸÐž Ð»Ð¸ÑÑ‚Ð¸',0),(179289,4981,'vi','Xem danh sÃ¡ch Ä‘Æ¡n mua hÃ ng',0),(179290,4981,'af','Besigtig AB Lys',0),(179291,4981,'ro','Vezi PO lista',0),(179292,4981,'et','PO loend',0),(179293,4981,'si','Pogled PO seznamu',0),(179294,4981,'ba','Lihat PO daftar',0),(179295,4981,'nl','Lijst weergave PO',0),(179296,4981,'fi','PO luettelo',0),(179297,4981,'no','Vis PO liste',0),(179298,4981,'da','Se PO liste',0),(179299,4981,'ko','ëª©ë¡ ë³´ê¸° í¬',0),(179300,4981,'he','×‘×¨×©×™×ž×” ×ª×¦×•×’×” ×¤×•',0),(179301,4981,'el','Î›Î¯ÏƒÏ„Î± Î ÏÎ¿Î²Î¿Î»Î® PO',0),(179302,4981,'zh','æŸ¥çœ‹è®¢å•åˆ—è¡¨\r\n',0),(179303,4981,'sv','Visa PO lista',0),(179304,4981,'it','Elenco vista PO',0),(179305,4981,'tl','',0),(179306,4981,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(179307,4981,'hi','à¤¸à¥‚à¤šà¥€ à¤¦à¥‡à¤–à¥‡à¤‚ à¤ªà¥‹',0),(179308,4981,'ms','Lihat PO senarai',0),(179309,4981,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¹Ø±Ø¶ Ø¨Ùˆ',0),(179310,4981,'fr','Liste d\'affichage PO',0),(179311,4981,'jp','ç™ºæ³¨æ›¸ãƒªã‚¹ãƒˆã?®è¡¨ç¤º',0),(179312,4981,'pt','Lista de exibiÃ§Ã£o PO',0),(179313,4981,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº PO',0),(179314,4981,'es','Visionar Lista de OC',0),(179315,4981,'de','Ansichtsliste PO',0),(179316,4981,'en','View PO List',0),(179317,4982,'is','',0),(179318,4982,'dr','Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(179319,4982,'pr','Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(179320,4982,'tr','PO',0),(179321,4982,'pl','Z PO',0),(179322,4982,'bg','ÐžÑ‚ PO',0),(179323,4982,'ur','Ø³Û’ Ù¾Ùˆ',0),(179324,4982,'sr','Ð˜Ð· ÐŸÐž',0),(179325,4982,'vi','Tá»« ÄÆ¡n mua hÃ ng',0),(179326,4982,'af','Vanaf AB',0),(179327,4982,'ro','Din PO',0),(179328,4982,'et','Alates PO',0),(179329,4982,'si','Od pad',0),(179330,4982,'ba','Dari PO',0),(179331,4982,'nl','Van PO',0),(179332,4982,'fi','PO',0),(179333,4982,'no','Fra PO',0),(179334,4982,'da','Fra PO',0),(179335,4982,'ko','í¬ì—ì„œ',0),(179336,4982,'he','×ž×¤×•',0),(179337,4982,'el','Î‘Ï€ÏŒ PO',0),(179338,4982,'zh','ä»Žé‡‡è´­è®¢å•\r\n',0),(179339,4982,'sv','FrÃ¥n PO',0),(179340,4982,'it','Da PO',0),(179341,4982,'tl','',0),(179342,4982,'th','&#3592;&#3634;&#3585;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(179343,4982,'hi','à¤ªà¥€à¤“ à¤¸à¥‡',0),(179344,4982,'ms','Dari PO',0),(179345,4982,'ar','Ù…Ù† Ø¨Ùˆ',0),(179346,4982,'fr','De PO',0),(179347,4982,'jp','ç™ºæ³¨æ›¸ã?‹ã‚‰',0),(179348,4982,'pt','De PO',0),(179349,4982,'ru','ÐžÑ‚ PO',0),(179350,4982,'es','De OC',0),(179351,4982,'de','Von PO',0),(179352,4982,'en','From PO',0),(179353,4983,'is','',0),(179354,4983,'dr',':  7  Ø±ÙˆØ²',0),(179355,4983,'pr','Ø¯Ø±ÙŠØ§ÙØª Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§:  7  Ø±ÙˆØ²',0),(179356,4983,'tr','Stok alÄ±rsÄ±nÄ±z: 7 gÃ¼n',0),(179357,4983,'pl','OtrzymaÄ‡ w magazynie: 7 dni',0),(179358,4983,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð² ÑÐºÐ»Ð°Ð´: 7 Ð´Ð½Ð¸',0),(179359,4983,'ur','Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…ÛŒÚº Ù…ÙˆØµÙˆÙ„: 7 Ø¯Ù†',0),(179360,4983,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð¸ Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ðµ: 7 Ð´Ð°Ð½Ð°',0),(179361,4983,'vi','Nháº­n VÃ o Danh Má»¥c HÃ ng Trong Kho: 7 ngÃ y',0),(179362,4983,'af','Ontvang binne Voorraad:  7 Dae',0),(179363,4983,'ro','Primi Ã®n inventar: 7 zile',0),(179364,4983,'et','Saada varudesse: 7 pÃ¤eva',0),(179365,4983,'si','Prejeli v zalogo: 7 dni',0),(179366,4983,'ba','Menerima ke persediaan: 7 hari',0),(179367,4983,'nl','Ontvangen in de voorraad: 7 dagen',0),(179368,4983,'fi','Tulee varastoon: 7 pÃ¤ivÃ¤Ã¤',0),(179369,4983,'no','FÃ¥ pÃ¥ lager: 7 dager',0),(179370,4983,'da','Modtager pÃ¥ lageret: 7 dage',0),(179371,4983,'ko','7 ì¼ ëª©ë¡ì— ë‚˜íƒ€ë‚©ë‹ˆë‹¤.',0),(179372,4983,'he','×œ×§×‘×œ ×œ×ª×•×š ×”×ž×œ××™: 7 ×™×ž×™×',0),(179373,4983,'el','Î›Î¬Î²ÎµÏ„Îµ ÏƒÎµ Î±Ï€Î¿Î³ÏÎ±Ï†Î®: 7 Î·Î¼Î­ÏÎµÏ‚',0),(179374,4983,'zh','æŽ¥æ”¶åˆ°åº“å­˜ï¼š7å¤©\r\n',0),(179375,4983,'sv','Ta emot i lagret: 7 dagar',0),(179376,4983,'it','Ricevere in magazzino: 7 giorni',0),(179377,4983,'tl','',0),(179378,4983,'th','&#3619;&#3633;&#3610;&#3652;&#3611;&#3626;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629; : 7 &#3623;&#3633;&#3609;',0),(179379,4983,'hi','à¤®à¥‡à¤‚ à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ: 7 à¤¦à¤¿à¤¨à¥‹à¤‚',0),(179380,4983,'ms','Menerima ke dalam inventori: 7 hari',0),(179381,4983,'ar','ØªÙ„Ù‚ÙŠ ÙÙŠ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†: 7 Ø£ÙŠØ§Ù…',0),(179382,4983,'fr','Recevez dans l\'inventaire: 7 jours',0),(179383,4983,'jp','åœ¨åº«ã?¸ã?®å?—é ˜ï¼šï¼—æ—¥é–“',0),(179384,4983,'pt','Receber em inventÃ¡rio: 7 dias',0),(179385,4983,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€ÑŒ: 7 Ð´Ð½ÐµÐ¹',0),(179386,4983,'es','Recibido Al Inventario: 7 DÃ­as',0),(179387,4983,'de','Erhalten in den Bestand: 7 Tage',0),(179388,4983,'en','Receive Into Inventory: 7 Days',0),(179389,4984,'is','',0),(179390,4984,'dr','Ø®Ù„Ø§ØµÙ‡ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(179391,4984,'pr','Ø®Ù„Ø§ØµÙ‡ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(179392,4984,'tr','YaÅŸlanma - Ã–zet (BorÃ§lar)',0),(179393,4984,'pl','Starzenie siÄ™ - podsumowanie (zobowiÄ…zania)',0),(179394,4984,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ - Ð ÐµÐ·ÑŽÐ¼Ðµ (Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ)',0),(179395,4984,'ur','Ø®Ø³ØªÛ - Ø®Ù„Ø§ØµÛ (Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³)',0),(179396,4984,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ - Ñ€ÐµÐ·Ð¸Ð¼Ðµ (Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°)',0),(179397,4984,'vi','Tá»•ng Há»£p TÃ i Khoáº£n Pháº£i Tráº£ Theo Tuá»•i Ná»£',0),(179398,4984,'af','Uitgawes (RB) Ouderdomsopsomming',0),(179399,4984,'ro','Imbatranirea - Rezumat (cumpÄƒrÄƒri ÅŸi datorii)',0),(179400,4984,'et','Vananemine - KokkuvÃµte (vÃµlad)',0),(179401,4984,'si','Staranje - Povzetek (obveznosti)',0),(179402,4984,'ba','Penuaan - ringkasan (kewajiban)',0),(179403,4984,'nl','Veroudering - samenvatting (schulden)',0),(179404,4984,'fi','IkÃ¤Ã¤ntyminen - Yhteenveto (velat)',0),(179405,4984,'no','Aldring - Sammendrag (leverandÃ¸rgjeld)',0),(179406,4984,'da','Aldring - ResumÃ© (gÃ¦ld)',0),(179407,4984,'ko','ë…¸í™”-ìš”ì•½ (ë¯¸ì§€ê¸‰ê¸ˆ)',0),(179408,4984,'he','×”×–×“×§× ×•×ª - ×¡×™×›×•× (×–×›××™×)',0),(179409,4984,'el','Î“Î®ÏÎ±Î½ÏƒÎ· - Î ÎµÏÎ¯Î»Î·ÏˆÎ· (Ï€Î»Î·ÏÏ‰Ï„Î­Î±)',0),(179410,4984,'zh','åº”ä»˜æ¬¾é¡¹çš„è´¦é¾„æ‘˜è¦\r\n',0),(179411,4984,'sv','Ã…ldrande - Sammanfattning (LeverantÃ¶rsskulder)',0),(179412,4984,'it','Invecchiamento - Riepilogo (debiti)',0),(179413,4984,'tl','',0),(179414,4984,'th','&#3626;&#3619;&#3640;&#3611;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3629;&#3634;&#3618;&#3640;&#3627;&#3609;&#3637;&#3657;&#3626;&#3636;&#3609;',0),(179415,4984,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ - à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ (Payables)',0),(179416,4984,'ms','Penuaan - ringkasan (pemiutang)',0),(179417,4984,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©-Ù…Ù„Ø®Øµ (Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹)',0),(179418,4984,'fr','Vieillissement - RÃ©sumÃ© (comptes fournisseurs)',0),(179419,4984,'jp','æ”¯æ‰•ã?„ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°ã‚µãƒžãƒªãƒ¼',0),(179420,4984,'pt','Envelhecimento - Resumo (contas a pagar)',0),(179421,4984,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ - Ñ€ÐµÐ·ÑŽÐ¼Ðµ (ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ)',0),(179422,4984,'es','Cuentas por Pagar Sumario de Antiguedad',0),(179423,4984,'de','Altern - Zusammenfassung (Verbindlichkeiten)',0),(179424,4984,'en','Aging - Summary (Payables)',0),(179425,4985,'is','',0),(179426,4985,'dr','Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡ â€“  Ù…ÙˆØ¹Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ø²ÙˆØ¯ÙŠ â€“Ù…ÙˆØ¹Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¹Ø¯Ø§',0),(179427,4985,'pr','Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡ â€“  Ù…ÙˆØ¹Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ø²ÙˆØ¯ÙŠ â€“Ù…ÙˆØ¹Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¹Ø¯Ø§',0),(179428,4985,'tr','Vadesi geÃ§miÅŸ, yakÄ±nda nedeniyle nedeniyle daha sonra',0),(179429,4985,'pl','ZalegÅ‚e, spowodowane szybko, ze wzglÄ™du pÃ³Åºniej',0),(179430,4985,'bg','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸, Ð¿Ð¾Ñ€Ð°Ð´Ð¸ ÑÐºÐ¾Ñ€Ð¾, Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð¿Ð¾-ÐºÑŠÑÐ½Ð¾',0),(179431,4985,'ur','Ù…ÙˆØ®Ø±ØŒ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ø¬Ù„Ø¯ ÛÛŒ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ø¨Ø¹Ø¯ Ù…ÛŒÚº',0),(179432,4985,'sr','Ð—Ð°ÐºÐ°ÑÐ½Ð¸Ð»Ð¸ ÑÐ¼Ð¾, Ð·Ð±Ð¾Ð³ ÑƒÑÐºÐ¾Ñ€Ð¾, Ñ‚ÐµÑ€Ð¼Ð¸Ð½ ÐºÐ°ÑÐ½Ð¸Ñ˜Ðµ',0),(179433,4985,'vi','QuÃ¡ háº¡n, sáº¯p Ä‘áº¿n háº¡n, Ä‘áº¿n háº¡n sau',0),(179434,4985,'af','Agterstallig, Binnekort Verskuldig, Later Verskuldig',0),(179435,4985,'ro','Restante, datorate Ã®n curÃ¢nd, din cauza mai tÃ¢rziu',0),(179436,4985,'et','TÃ¤htaja Ã¼letanud kiiresti, kuna tÃµttu hiljem',0),(179437,4985,'si','Zamuja zaradi kmalu, zaradi kasneje',0),(179438,4985,'ba','Tertunda, karena segera, karena kemudian',0),(179439,4985,'nl','Verschuldigde achterstallige spoedig, verschuldigde Later',0),(179440,4985,'fi','MyÃ¶hÃ¤ssÃ¤, koska pian, koska myÃ¶hemmin',0),(179441,4985,'no','Forsinket, skyldes snart grunn senere',0),(179442,4985,'da','Forfaldne, grund snart, skyldes senere',0),(179443,4985,'ko','ì¸í•´ ê³§, ê¸°í•œ, ê¸°í•œ ì´ˆê³¼ í›„',0),(179444,4985,'he','×‘××™×—×•×¨, ×‘×©×œ ×‘×§×¨×•×‘, ×‘×©×œ ×ž××•×—×¨ ×™×•×ª×¨',0),(179445,4985,'el','ÎšÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ®ÏƒÎµÎ¹, Î»ÏŒÎ³Ï‰ ÏƒÏÎ½Ï„Î¿Î¼Î±, Î»ÏŒÎ³Ï‰ Î±ÏÎ³ÏŒÏ„ÎµÏÎ±',0),(179446,4985,'zh','é€¾æœŸï¼Œç”±äºŽä¸ä¹…ï¼Œå› åŽæ¥\r\n',0),(179447,4985,'sv','FÃ¶rfallna, pÃ¥ grund av snart, pÃ¥ grund av senare',0),(179448,4985,'it','In ritardo, causa presto, causa successivamente',0),(179449,4985,'tl','',0),(179450,4985,'th','&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;,&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;&#3648;&#3619;&#3655;&#3623; &#3654; &#3609;&#3637;&#3657;,&#3585;&#3635;&#3627',0),(179451,4985,'hi','à¤…à¤¤à¤¿à¤¦à¥‡à¤¯, à¤œà¤²à¥à¤¦ à¤¹à¥€, à¤•à¤¾à¤°à¤£ à¤•à¤¾à¤°à¤£ à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚',0),(179452,4985,'ms','Tertunggak, kerana tidak lama lagi, kena dibayar kemudiannya',0),(179453,4985,'ar','Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©ØŒ Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ù‚Ø±ÙŠØ¨Ø§ØŒ Ø§Ù„Ù…Ù‚Ø±Ø± ÙÙŠ ÙˆÙ‚Øª Ù„Ø§Ø­Ù‚',0),(179454,4985,'fr','En retard, dÃ» bientÃ´t, Due plus tard',0),(179455,4985,'jp','æœŸé™?çµŒé?Žã€?æœŸé™?é–“è¿‘ã€?æœŸé™?å‰?',0),(179456,4985,'pt','Em atraso, devido em breve, devido mais tarde',0),(179457,4985,'ru','ÐÐ°Ð·Ñ€ÐµÐ»Ð¾, Ð²ÑÐºÐ¾Ñ€Ðµ, Ð¸Ð·-Ð·Ð° Ð¿Ð¾Ð·Ð´Ð½ÐµÐµ',0),(179458,4985,'es','Demoroso, Debido Pronto, Debido MÃ¡s Tarde',0),(179459,4985,'de','ÃœberfÃ¤llig, da bald wegen spÃ¤ter',0),(179460,4985,'en','Overdue, Due Soon, Due Later',0),(179461,4986,'is','',0),(179462,4986,'dr','Ø¯Ø±ÙŠØ§ÙØª Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(179463,4986,'pr','Ø¯Ø±ÙŠØ§ÙØª Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(179464,4986,'tr','Stok almak',0),(179465,4986,'pl','OtrzymaÄ‡ do magazynu',0),(179466,4986,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð² ÑÐºÐ»Ð°Ð´',0),(179467,4986,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…ÛŒÚº Ù…ÙˆØµÙˆÙ„',0),(179468,4986,'sr','ÐŸÑ€Ð¸Ð¼Ð¸ Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(179469,4986,'vi','Nháº­n VÃ o Danh Má»¥c HÃ ng Trong Kho',0),(179470,4986,'af','Ontvang binne Inventaris',0),(179471,4986,'ro','Primi Ã®n inventar',0),(179472,4986,'et','Varudesse vastuvÃµtmiseks',0),(179473,4986,'si','Prejeli v zalogo',0),(179474,4986,'ba','Menerima ke dalam persediaan',0),(179475,4986,'nl','Ontvangen in de voorraad',0),(179476,4986,'fi','Vastaanottaa varastoon',0),(179477,4986,'no','FÃ¥ pÃ¥ lager',0),(179478,4986,'da','Modtag pÃ¥ lageret',0),(179479,4986,'ko','ìž¬ê³ ì— ë‚˜íƒ€ë‚©ë‹ˆë‹¤',0),(179480,4986,'he','×œ×§×‘×œ ×œ×ª×•×š ×”×ž×œ××™',0),(179481,4986,'el','Î›Î¬Î²ÎµÏ„Îµ ÏƒÏ„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(179482,4986,'zh','æŽ¥æ”¶åˆ°åº“å­˜\r\n',0),(179483,4986,'sv','Ta emot i lagret',0),(179484,4986,'it','Ricevere in inventario',0),(179485,4986,'tl','',0),(179486,4986,'th','&#3619;&#3633;&#3610;&#3652;&#3611;&#3626;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(179487,4986,'hi','à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(179488,4986,'ms','Menerima ke dalam inventori',0),(179489,4986,'ar','ØªÙ„Ù‚ÙŠ ÙÙŠ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(179490,4986,'fr','Recevez dans l\'inventaire',0),(179491,4986,'jp','åœ¨åº«ã?¸ã?®å?—é ˜',0),(179492,4986,'pt','Receber em estoque',0),(179493,4986,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€ÑŒ',0),(179494,4986,'es','Recibido al Inventario',0),(179495,4986,'de','In den Bestand zu erhalten',0),(179496,4986,'en','Receive into Inventory',0),(179497,4987,'is','',0),(179498,4987,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚ ',0),(179499,4987,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚ ',0),(179500,4987,'tr','Bekleyen PO',0),(179501,4987,'pl','Czasu PO',0),(179502,4987,'bg','Ð§Ð°ÐºÐ°Ñ‰ PO',0),(179503,4987,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ù¾Ùˆ',0),(179504,4987,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ ÐŸÐž',0),(179505,4987,'vi','ÄÆ¡n mua hÃ ng Ä‘ang treo',0),(179506,4987,'af','Afwagtend AB',0),(179507,4987,'ro','ÃŽn aÅŸteptarea PO',0),(179508,4987,'et','Ootel PO',0),(179509,4987,'si','Teku PO',0),(179510,4987,'ba','Tertunda PO',0),(179511,4987,'nl','In behandeling PO',0),(179512,4987,'fi','Odottava PO',0),(179513,4987,'no','Ventende PO',0),(179514,4987,'da','Ventende PO',0),(179515,4987,'ko','ë³´ë¥˜ ì¤‘ì¸ í¬',0),(179516,4987,'he','×¤×• ×ž×ž×ª×™× ×”',0),(179517,4987,'el','Î£Îµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± PO',0),(179518,4987,'zh','å¾…å¤„ç†è®¢å•\r\n',0),(179519,4987,'sv','VÃ¤ntande PO',0),(179520,4987,'it','PO in sospeso',0),(179521,4987,'tl','',0),(179522,4987,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(179523,4987,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤ªà¥‹',0),(179524,4987,'ms','PO belum selesai',0),(179525,4987,'ar','Ø¨Ùˆ Ù…Ø¹Ù„Ù‚Ø©',0),(179526,4987,'fr','PO en attente',0),(179527,4987,'jp','ä¿?ç•™ä¸­æ³¨æ–‡æ›¸',0),(179528,4987,'pt','PO pendente',0),(179529,4987,'ru','Ð”Ð¾ PO',0),(179530,4987,'es','OC Pendiente',0),(179531,4987,'de','Ausstehenden PO',0),(179532,4987,'en','Pending PO',0),(179533,4988,'is','',0),(179534,4988,'dr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯Ù‡Ø§ Ø¯Ø± Ù…Ø§Ù‡ Ø¢ÙŠÙ†Ø¯Ù‡',0),(179535,4988,'pr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯Ù‡Ø§ Ø¯Ø± Ù…Ø§Ù‡ Ø¢ÙŠÙ†Ø¯Ù‡',0),(179536,4988,'tr','Ã–nÃ¼mÃ¼zdeki ay doÄŸum gÃ¼nÃ¼',0),(179537,4988,'pl','Urodziny w przyszÅ‚ym miesiÄ…cu',0),(179538,4988,'bg','Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸ Ð´Ð½Ð¸ Ð¿Ñ€ÐµÐ· ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ Ð¼ÐµÑÐµÑ†',0),(179539,4988,'ur','Ø§Ú¯Ù„Û’ Ù…ÛÛŒÙ†Û’ Ù…ÛŒÚº Ø³Ø§Ù„Ú¯Ø±Û',0),(179540,4988,'sr','Ð Ð¾Ñ’ÐµÐ½Ð´Ð°Ð½Ð¸ Ñƒ Ð½Ð°Ñ€ÐµÐ´Ð½Ð¸Ñ… Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(179541,4988,'vi','NgÃ y sinh vÃ o thÃ¡ng tá»›i',0),(179542,4988,'af','Verjaarsdae in Volgende Maand',0),(179543,4988,'ro','Ziua de naÅŸtere Ã®n luna viitoare',0),(179544,4988,'et','SÃ¼nnipÃ¤evad jÃ¤rgmisel kuul',0),(179545,4988,'si','Rojstni dan v naslednjem mesecu',0),(179546,4988,'ba','Ulang tahun bulan depan',0),(179547,4988,'nl','Verjaardagen in volgende maand',0),(179548,4988,'fi','SynttÃ¤rit ensi kuussa',0),(179549,4988,'no','FÃ¸dselsdagene i neste mÃ¥ned',0),(179550,4988,'da','FÃ¸dselsdage i nÃ¦ste mÃ¥ned',0),(179551,4988,'ko','ë‹¤ìŒ ë‹¬ì— ìƒì¼',0),(179552,4988,'he','×™×ž×™ ×”×•×œ×“×ª ×‘×—×•×“×© ×”×‘×',0),(179553,4988,'el','Î“ÎµÎ½Î­Î¸Î»Î¹Î± ÏƒÏ„Î¿ ÎµÏ€ÏŒÎ¼ÎµÎ½Î¿ Î¼Î®Î½Î±',0),(179554,4988,'zh','åœ¨ä¸‹ä¸ªæœˆç”Ÿæ—¥\r\n',0),(179555,4988,'sv','FÃ¶delsedagar i nÃ¤sta mÃ¥nad',0),(179556,4988,'it','Compleanni nel prossimo mese',0),(179557,4988,'tl','',0),(179558,4988,'th','&#3623;&#3633;&#3609;&#3648;&#3585;&#3636;&#3604;&#3651;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3605;&#3656;&#3629;&#3652;&#3611;',0),(179559,4988,'hi','à¤…à¤—à¤²à¥‡ à¤®à¤¹à¥€à¤¨à¥‡ à¤®à¥‡à¤‚ à¤œà¤¨à¥à¤®à¤¦à¤¿à¤¨',0),(179560,4988,'ms','Hari lahir dalam bulan depan',0),(179561,4988,'ar','Ø£Ø¹ÙŠØ§Ø¯ Ø§Ù„Ù…ÙŠÙ„Ø§Ø¯ ÙÙŠ Ø§Ù„Ø´Ù‡Ø± Ø§Ù„Ù‚Ø§Ø¯Ù…',0),(179562,4988,'fr','Anniversaires dans le mois prochain',0),(179563,4988,'jp','æ?¥æœˆã?®èª•ç”Ÿæ—¥',0),(179564,4988,'pt','AniversÃ¡rios no mÃªs que vem',0),(179565,4988,'ru','Ð”Ð½Ð¸ Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ Ð’ Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ¼ ÐœÐµÑÑÑ†Ðµ',0),(179566,4988,'es','CumpleaÃ±os en el PrÃ³ximo Mes',0),(179567,4988,'de','Geburtstage im nÃ¤chsten Monat',0),(179568,4988,'en','Birthdays in Next Month',0),(179569,4989,'is','',0),(179570,4989,'dr','Ù‡ÙŠÚ† ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(179571,4989,'pr','Ù‡ÙŠÚ† ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(179572,4989,'tr','HiÃ§bir doÄŸum gÃ¼nÃ¼ bulundu',0),(179573,4989,'pl','Nie urodziny, znaleziono',0),(179574,4989,'bg','ÐÑÐ¼Ð° Ñ€Ð¾Ð¶Ð´ÐµÐ½Ð¸ Ð´Ð½Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(179575,4989,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ø³Ø§Ù„Ú¯Ø±Û',0),(179576,4989,'sr','ÐÐµÐ¼Ð° Ñ€Ð¾Ñ’ÐµÐ½Ð´Ð°Ð½Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(179577,4989,'vi','KhÃ´ng tÃ¬m tháº¥y ngÃ y sinh',0),(179578,4989,'af','Geen Verjaarsdae Gevind',0),(179579,4989,'ro','Nici aniversari gÄƒsit',0),(179580,4989,'et','SÃ¼nnipÃ¤evi ei leitud',0),(179581,4989,'si','Brez rojstnih dni, naÅ¡el',0),(179582,4989,'ba','Ulang tahun tidak ditemukan',0),(179583,4989,'nl','Geen verjaardagen gevonden',0),(179584,4989,'fi','Ei syntymÃ¤pÃ¤iviÃ¤ lÃ¶ytyi',0),(179585,4989,'no','Ingen bursdager funnet',0),(179586,4989,'da','Ingen fÃ¸dselsdage fundet',0),(179587,4989,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” ìƒì¼',0),(179588,4989,'he','×œ× × ×ž×¦××• ×™×ž×™ ×”×•×œ×“×ª',0),(179589,4989,'el','ÎšÎ±Î½Î­Î½Î± Î³ÎµÎ½Î­Î¸Î»Î¹Î¿ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(179590,4989,'zh','æ²¡æœ‰æ‰¾åˆ°ç”Ÿæ—¥\r\n',0),(179591,4989,'sv','Inga fÃ¶delsedagar hittade',0),(179592,4989,'it','No compleanni trovati',0),(179593,4989,'tl','',0),(179594,4989,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3623;&#3633;&#3609;&#3648;&#3585;&#3636;&#3604;',0),(179595,4989,'hi','à¤•à¥‹à¤ˆ à¤œà¤¨à¥à¤®à¤¦à¤¿à¤¨ à¤ªà¤¾à¤¯à¤¾',0),(179596,4989,'ms','Hari lahir tidak ditemui',0),(179597,4989,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£Ø¹ÙŠØ§Ø¯ Ù…ÙŠÙ„Ø§Ø¯',0),(179598,4989,'fr','Aucun anniversaire trouvÃ©s',0),(179599,4989,'jp','èª•ç”Ÿæ—¥ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(179600,4989,'pt','Sem aniversÃ¡rios encontrados',0),(179601,4989,'ru','Ð”Ð½Ð¸ Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(179602,4989,'es','No Se Encontro CumpleaÃ±os',0),(179603,4989,'de','Keine Geburtstage gefunden',0),(179604,4989,'en','No Birthdays Found',0),(179605,4990,'is','',0),(179606,4990,'dr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª ØªÙˆÙ„Ø¯ Ù‡Ø§ ',0),(179607,4990,'pr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª ØªÙˆÙ„Ø¯ Ù‡Ø§ ',0),(179608,4990,'tr','DoÄŸum gÃ¼nÃ¼ listesini gÃ¶rÃ¼ntÃ¼le',0),(179609,4990,'pl','Widok listy urodziny',0),(179610,4990,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð·Ð° Ñ€Ð¾Ð¶Ð´ÐµÐ½Ð¸ Ð´Ð½Ð¸',0),(179611,4990,'ur','ÙÛØ±Ø³Øª Ø¯ÛŒÚ©Ú¾Ù†Ø§ Ø³Ø§Ù„Ú¯Ø±Û',0),(179612,4990,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð»Ð¸ÑÑ‚Ðµ Ð·Ð° Ñ€Ð¾Ñ’ÐµÐ½Ð´Ð°Ð½Ðµ',0),(179613,4990,'vi','Xem danh sÃ¡ch ngÃ y sinh',0),(179614,4990,'af','Besigtig Verjaarsdaglys',0),(179615,4990,'ro','ListÄƒ de zile onomastice Vezi',0),(179616,4990,'et','Vaata sÃ¼nnipÃ¤evade nimekirja',0),(179617,4990,'si','Ogled rojstne dneve seznama',0),(179618,4990,'ba','Lihat daftar ulang tahun',0),(179619,4990,'nl','Bekijk de lijst van verjaardagen',0),(179620,4990,'fi','SyntymÃ¤pÃ¤ivien luettelo',0),(179621,4990,'no','Vis bursdager liste',0),(179622,4990,'da','Se fÃ¸dselsdag liste',0),(179623,4990,'ko','ìƒì¼ ëª©ë¡ ë³´ê¸°',0),(179624,4990,'he','×ª×¦×•×’×ª ×¨×©×™×ž×ª ×™×ž×™ ×”×•×œ×“×ª',0),(179625,4990,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»Î¯ÏƒÏ„Î±Ï‚ Î³ÎµÎ½Î­Î¸Î»Î¹Î±',0),(179626,4990,'zh','æŸ¥çœ‹ç”Ÿæ—¥åå•\r\n',0),(179627,4990,'sv','Visa lista med fÃ¶delsedagar',0),(179628,4990,'it','Vedi la lista dei compleanni',0),(179629,4990,'tl','',0),(179630,4990,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(179631,4990,'hi','à¤œà¤¨à¥à¤®à¤¦à¤¿à¤¨ à¤¸à¥‚à¤šà¥€ à¤¦à¥‡à¤–à¥‡à¤‚',0),(179632,4990,'ms','Lihat senarai hari lahir',0),(179633,4990,'ar','Ø¹Ø±Ø¶ Ù‚Ø§Ø¦Ù…Ø© Ø£Ø¹ÙŠØ§Ø¯ Ø§Ù„Ù…ÙŠÙ„Ø§Ø¯',0),(179634,4990,'fr','Liste d\'affichage d\'anniversaires',0),(179635,4990,'jp','èª•ç”Ÿæ—¥ãƒªã‚¹ãƒˆã?®è¡¨ç¤º',0),(179636,4990,'pt','Ver lista de aniversÃ¡rios',0),(179637,4990,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¡Ð¿Ð¸ÑÐºÐ° Ð”Ð½ÐµÐ¹ Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(179638,4990,'es','Visionar Lista de CumpleaÃ±os',0),(179639,4990,'de','Geburtstage-Anzeigeliste',0),(179640,4990,'en','View Birthdays List',0),(179641,4991,'is','',0),(179642,4991,'dr','Ø§Ø®Ø±Ø§Ø¬ Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ±',0),(179643,4991,'pr','Ø§Ø®Ø±Ø§Ø¬ Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ±',0),(179644,4991,'tr','Son iÅŸten Ã§Ä±karmalar',0),(179645,4991,'pl','Ostatnich zwolnieÅ„',0),(179646,4991,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÑŠÐºÑ€Ð°Ñ‰ÐµÐ½Ð¸Ñ',0),(179647,4991,'ur','Ø­Ø§Ù„ÛŒÛ Ù…Ù„Ø§Ø²Ù…ØªÙˆÚº Ø³Û’ Ø³Ø¨Ú©Ø¯ÙˆØ´ÛŒ',0),(179648,4991,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ð¾Ñ‚Ð¿ÑƒÑˆÑ‚Ð°ÑšÐ°',0),(179649,4991,'vi','Sa tháº£i gáº§n Ä‘Ã¢y',0),(179650,4991,'af','Onlangs Ontslaan',0),(179651,4991,'ro','Ultimele disponibilizÄƒri',0),(179652,4991,'et','Tehtud vallandamisi',0),(179653,4991,'si','Nedavne odpuÅ¡Äanja',0),(179654,4991,'ba','PHK hari',0),(179655,4991,'nl','Recente ontslagen',0),(179656,4991,'fi','Hotelliin irtisanomiset',0),(179657,4991,'no','Siste Layoffs',0),(179658,4991,'da','Seneste fyringer',0),(179659,4991,'ko','ìµœê·¼ ì •ë¦¬ í•´ ê³ ',0),(179660,4991,'he','×¤×™×˜×•×¨×™× ×”××—×¨×•× ×•×ª',0),(179661,4991,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Î±Ï€Î¿Î»ÏÏƒÎµÎ¹Ï‚',0),(179662,4991,'zh','æœ€è¿‘çš„è£å‘˜\r\n',0),(179663,4991,'sv','Senaste uppsÃ¤gningar',0),(179664,4991,'it','Recenti licenziamenti',0),(179665,4991,'tl','',0),(179666,4991,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3636;&#3585;&#3592;&#3657;&#3634;&#3591;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634;&#3649;&#3621;&#3657;&#3623;',0),(179667,4991,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤›à¤‚à¤Ÿà¤¨à¥€',0),(179668,4991,'ms','Pemberhentian hari',0),(179669,4991,'ar','Ø§Ù„ØªØ³Ø±ÙŠØ­Ø§Øª Ø§Ù„Ø­Ø¯ÙŠØ«Ø©',0),(179670,4991,'fr','RÃ©centes mises Ã  pied',0),(179671,4991,'jp','æœ€è¿‘ã?®è§£é›‡',0),(179672,4991,'pt','Recentes demissÃµes',0),(179673,4991,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¸Ðµ Ð£Ð²Ð¾Ð»ÑŒÐ½ÐµÐ½Ð¸Ñ',0),(179674,4991,'es','Despedidos Recientes',0),(179675,4991,'de','Den letzten Entlassungen',0),(179676,4991,'en','Recent Layoffs',0),(179677,4992,'is','',0),(179678,4992,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ø§Ø®ÙŠØ± Ù†Ø±Ø® Ø­Ù‚ÙˆÙ‚ ',0),(179679,4992,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ø§Ø®ÙŠØ± Ù†Ø±Ø® Ø­Ù‚ÙˆÙ‚ ',0),(179680,4992,'tr','Son Ã¶deme oran deÄŸiÅŸiklikleri',0),(179681,4992,'pl','Ostatnie zmiany stawki wynagrodzenia',0),(179682,4992,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(179683,4992,'ur','ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ Ø´Ø±Ø­ Ú©Û’ Ø­Ø§Ù„ÛŒÛ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(179684,4992,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ ÑÑ‚Ð¾Ð¿Ð° Ð¿Ð»Ð°Ñ‚Ð°',0),(179685,4992,'vi','Thay Ä‘á»•i GiÃ¡ tráº£ gáº§n Ä‘Ã¢y',0),(179686,4992,'af','Onlangse Besoldigingtarief Veranderinge',0),(179687,4992,'ro','Plata rata schimbÄƒri recente',0),(179688,4992,'et','Tehtud makse mÃ¤Ã¤ra muutused',0),(179689,4992,'si','Nedavne spremembe teÄaja plaÄa',0),(179690,4992,'ba','Hari membayar laju perubahan',0),(179691,4992,'nl','Recente Pay tariefwijzigingen',0),(179692,4992,'fi','Hotelliin maksu muuttuu',0),(179693,4992,'no','Nylige endringer i lÃ¸nnssatser',0),(179694,4992,'da','De seneste RenteÃ¦ndringer er lÃ¸n',0),(179695,4992,'ko','ìµœê·¼ ê¸‰ì—¬ ë¹„ìœ¨ ë³€í™”',0),(179696,4992,'he','×”×©×™× ×•×™×™× ×”××—×¨×•× ×™× ×©×œ ×©×™×¢×•×¨ ×”×©×›×¨',0),(179697,4992,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Î±Î»Î»Î±Î³Î­Ï‚ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î±Î¼Î¿Î¹Î²Î®Ï‚',0),(179698,4992,'zh','æœ€è¿‘çš„å·¥èµ„çŽ‡å˜åŒ–\r\n',0),(179699,4992,'sv','Senaste lÃ¶n rÃ¤ntefÃ¶rÃ¤ndringar',0),(179700,4992,'it','Recenti variazioni dei tassi di paga',0),(179701,4992,'tl','',0),(179702,4992,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3629;&#3633;&#3605;&#3619;&#3634;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(179703,4992,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤µà¥‡à¤¤à¤¨ à¤¦à¤° à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(179704,4992,'ms','Perubahan kadar gaji yang',0),(179705,4992,'ar','Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø© ÙÙŠ Ù…Ø¹Ø¯Ù„ Ø§Ù„Ø£Ø¬ÙˆØ±',0),(179706,4992,'fr','RÃ©cents changements de taux de rÃ©munÃ©ration',0),(179707,4992,'jp','æœ€è¿‘ã?®è³ƒé‡‘å¤‰æ›´',0),(179708,4992,'pt','Recentes alteraÃ§Ãµes de taxa de pagamento',0),(179709,4992,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(179710,4992,'es','Cambios Recientes en la Tasa de Pagos',0),(179711,4992,'de','Neuen Ã„nderungen in Zahlen',0),(179712,4992,'en','Recent Pay Rate Changes',0),(179713,4993,'is','',0),(179714,4993,'dr','ØªØ§Ø±ÙŠØ® ØªØºÙŠÙŠØ± ',0),(179715,4993,'pr','ØªØ§Ø±ÙŠØ® ØªØºÙŠÙŠØ± ',0),(179716,4993,'tr','DeÄŸiÅŸiklik tarihi',0),(179717,4993,'pl','Data zmiany',0),(179718,4993,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(179719,4993,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(179720,4993,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(179721,4993,'vi','NgÃ y Thay Ä‘á»•i ',0),(179722,4993,'af','Datum van Verandering',0),(179723,4993,'ro','Data de schimbare',0),(179724,4993,'et','Muutmise kuupÃ¤ev',0),(179725,4993,'si','Datum spremembe',0),(179726,4993,'ba','Tanggal perubahan',0),(179727,4993,'nl','Datum van wijziging',0),(179728,4993,'fi','Muutoksen pvm',0),(179729,4993,'no','Datoen endret',0),(179730,4993,'da','Dato for Ã¦ndring',0),(179731,4993,'ko','ë³€ê²½ ë‚ ì§œ',0),(179732,4993,'he','×ª××¨×™×š ×©×™× ×•×™',0),(179733,4993,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î·Ï‚ Î±Î»Î»Î±Î³Î®Ï‚',0),(179734,4993,'zh','æ—¥æœŸå˜æ›´\r\n',0),(179735,4993,'sv','Datum fÃ¶r Ã¤ndringen',0),(179736,4993,'it','Data di modifica',0),(179737,4993,'tl','',0),(179738,4993,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(179739,4993,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(179740,4993,'ms','Tarikh perubahan',0),(179741,4993,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØºÙŠÙŠØ±',0),(179742,4993,'fr','Date de modification',0),(179743,4993,'jp','å¤‰æ›´æ—¥',0),(179744,4993,'pt','Data da mudanÃ§a',0),(179745,4993,'ru','Ð”Ð°Ñ‚Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(179746,4993,'es','Fecha de Cambio',0),(179747,4993,'de','Datum der Ã„nderung',0),(179748,4993,'en','Date of Change',0),(179749,4994,'is','',0),(179750,4994,'dr','Ù†Ø±Ø® Ø¬Ø¯ÙŠØ¯ ',0),(179751,4994,'pr','Ù†Ø±Ø® Ø¬Ø¯ÙŠØ¯ ',0),(179752,4994,'tr','Yeni oran',0),(179753,4994,'pl','Nowy kurs',0),(179754,4994,'bg','ÐÐ¾Ð² ÐºÑƒÑ€Ñ',0),(179755,4994,'ur','Ù†Û“ Ø±ÛŒÙ¹',0),(179756,4994,'sr','ÐÐ¾Ð²Ð° ÑÑ‚Ð¾Ð¿Ð°',0),(179757,4994,'vi','GiÃ¡ má»›i',0),(179758,4994,'af','Nuwe Tarief',0),(179759,4994,'ro','Noi Rate',0),(179760,4994,'et','Uus kurss',0),(179761,4994,'si','Nove stopnje',0),(179762,4994,'ba','Tingkat baru',0),(179763,4994,'nl','Nieuwe tarief',0),(179764,4994,'fi','Uusi kurssi',0),(179765,4994,'no','Nye hastigheten',0),(179766,4994,'da','Ny sats',0),(179767,4994,'ko','ìƒˆë¡œìš´ ì†ë„',0),(179768,4994,'he','×ª×¢×¨×™×£ ×—×“×©',0),(179769,4994,'el','ÎÎ­Î¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(179770,4994,'zh','æ–°åˆ©çŽ‡\r\n',0),(179771,4994,'sv','Ny kurs',0),(179772,4994,'it','Nuovo tasso',0),(179773,4994,'tl','',0),(179774,4994,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(179775,4994,'hi','à¤¨à¤ˆ à¤¦à¤°',0),(179776,4994,'ms','Kadar baru',0),(179777,4994,'ar','Ù…Ø¹Ø¯Ù„ Ø¬Ø¯ÙŠØ¯',0),(179778,4994,'fr','Nouveau taux',0),(179779,4994,'jp','æ–°è¦?æ–™é‡‘',0),(179780,4994,'pt','Nova taxa',0),(179781,4994,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐºÑƒÑ€Ñ',0),(179782,4994,'es','Nueva Tasa',0),(179783,4994,'de','Neuer Satz',0),(179784,4994,'en','New Rate',0),(179785,4995,'is','',0),(179786,4995,'dr','Ù‡ÙŠÚ† ØªØºÙŠÙŠØ±Ø§ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(179787,4995,'pr','Ù‡ÙŠÚ† ØªØºÙŠÙŠØ±Ø§ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(179788,4995,'tr','HiÃ§bir deÄŸiÅŸiklik bulunamadÄ±',0),(179789,4995,'pl','Å»adne zmiany nie znaleziono',0),(179790,4995,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(179791,4995,'ur','Ù…ÛŒÚº Ú©ÙˆØ¦ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ù†ÛÛŒÚº Ù…Ù„ÛŒ',0),(179792,4995,'sr','ÐÐ¸ÑÑƒ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ðµ Ð¸Ð·Ð¼Ñ˜ÐµÐ½Ðµ',0),(179793,4995,'vi','KhÃ´ng tÃ¬m tháº¥y thay Ä‘á»•i',0),(179794,4995,'af','Geen Veranderinge Gevind',0),(179795,4995,'ro','Nici o modificare a constatat',0),(179796,4995,'et','Ãœhtki muutust ei leitud',0),(179797,4995,'si','Brez sprememb, najti',0),(179798,4995,'ba','Tidak ada perubahan yang ditemukan',0),(179799,4995,'nl','Geen wijzigingen gevonden',0),(179800,4995,'fi','Muutoksia ei lÃ¶ytynyt.',0),(179801,4995,'no','Ingen endringer funnet',0),(179802,4995,'da','Ingen Ã¦ndringer fundet',0),(179803,4995,'ko','ì°¾ì„ ë³€ê²½',0),(179804,4995,'he','×œ× × ×ž×¦××• ×©×™× ×•×™×™×',0),(179805,4995,'el','ÎšÎ±Î¼Î¯Î± Î±Î»Î»Î±Î³Î® Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(179806,4995,'zh','æœªå‘çŽ°å˜æ›´\r\n',0),(179807,4995,'sv','Inga Ã¤ndringar som hittade',0),(179808,4995,'it','Nessun cambiamenti trovati',0),(179809,4995,'tl','',0),(179810,4995,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(179811,4995,'hi','à¤•à¥‹à¤ˆ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(179812,4995,'ms','Tiada perubahan yang ditemui',0),(179813,4995,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ ØªØºÙŠÙŠØ±Ø§Øª',0),(179814,4995,'fr','Aucun changement constatÃ©',0),(179815,4995,'jp','å¤‰æ›´ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(179816,4995,'pt','NÃ£o hÃ¡ alteraÃ§Ãµes encontradas',0),(179817,4995,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(179818,4995,'es','No se EncontrÃ³ Cambios',0),(179819,4995,'de','Keine Ã„nderungen gefunden',0),(179820,4995,'en','No Changes Found',0),(179821,4996,'is','',0),(179822,4996,'dr',':7 Ø±ÙˆØ²',0),(179823,4996,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ù†Ø±Ø® Ø­Ù‚ÙˆÙ‚:7 Ø±ÙˆØ²',0),(179824,4996,'tr','Kurundaki - 7 gÃ¼n Ã¶deme',0),(179825,4996,'pl','PÅ‚aciÄ‡ stawki zmiany - 7 dni',0),(179826,4996,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ - 7 Ð´Ð½Ð¸',0),(179827,4996,'ur','Ø´Ø±Ø­ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº - 7 Ø¯Ù† Ø§Ø¯Ø§',0),(179828,4996,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ ÑÑ‚Ð¾Ð¿Ð° Ð¿Ñ€Ð¾Ð¼Ñ˜ÐµÐ½Ðµ - 7 Ð´Ð°Ð½Ð°',0),(179829,4996,'vi','Thay Ä‘á»•i GiÃ¡ thanh toÃ¡n: 7 ngÃ y',0),(179830,4996,'af','Besoldigingskaal Veranderinge: 7 Dae',0),(179831,4996,'ro','PlÄƒteascÄƒ rata schimbÄƒri - 7 zile',0),(179832,4996,'et','Maksma mÃ¤Ã¤r muutused - 7 pÃ¤eva',0),(179833,4996,'si','PlaÄati stopnja spremembe - 7 dni',0),(179834,4996,'ba','Membayar laju perubahan - 7 hari',0),(179835,4996,'nl','Betaal tariefwijzigingen - 7 dagen',0),(179836,4996,'fi','Maksu muuttuu - 7 pÃ¤ivÃ¤Ã¤',0),(179837,4996,'no','Betale endringer - 7 dager',0),(179838,4996,'da','Betale renteÃ¦ndringer - 7 dage',0),(179839,4996,'ko','ì§€ë¶ˆ ë³€ë™-7 ì¼',0),(179840,4996,'he','×œ×©×œ× ××ª ×”×ª×¢×¨×™×£ ×ž×©×ª× ×” - 7 ×™×ž×™×',0),(179841,4996,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Ï„Î¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î±Î»Î»Î±Î³Î­Ï‚ - 7 Î·Î¼Î­ÏÎµÏ‚',0),(179842,4996,'zh','å·¥èµ„çŽ‡çš„å˜åŒ–ï¼š7å¤©\r\n',0),(179843,4996,'sv','Betala rÃ¤ntefÃ¶rÃ¤ndringar - 7 dagar',0),(179844,4996,'it','Pagare il tasso cambia - 7 giorni',0),(179845,4996,'tl','',0),(179846,4996,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3629;&#3633;&#3605;&#3619;&#3634;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;: 7 &#3623;&#3633;&#3609;',0),(179847,4996,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤° à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ - 7 à¤¦à¤¿à¤¨',0),(179848,4996,'ms','Membayar kadar perubahan - 7 hari',0),(179849,4996,'ar','Ø¯ÙØ¹ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ù…Ø¹Ø¯Ù„-7 Ø£ÙŠØ§Ù…',0),(179850,4996,'fr','Payer les modifications tarifaires - 7 jours',0),(179851,4996,'jp','è³ƒé‡‘å¤‰æ›´ï¼šï¼—æ—¥é–“',0),(179852,4996,'pt','Pagar a taxa muda - 7 dias',0),(179853,4996,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ - 7 Ð´Ð½ÐµÐ¹',0),(179854,4996,'es','Cambios de Tasas de Pago: 7 DÃ­as',0),(179855,4996,'de','TarifÃ¤nderungen - 7 Tage bezahlen',0),(179856,4996,'en','Pay Rate Changes - 7 Days',0),(179857,4997,'is','',0),(179858,4997,'dr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(179859,4997,'pr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(179860,4997,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ Ã§alÄ±ÅŸan listeleri',0),(179861,4997,'pl','Widok listy pracownikÃ³w',0),(179862,4997,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» ÑÐ¿Ð¸ÑÑŠÑ†Ð¸',0),(179863,4997,'ur','Ù…Ù†Ø¸Ø± Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(179864,4997,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð»Ð¸ÑÑ‚Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(179865,4997,'vi','Xem danh sÃ¡ch nhÃ¢n viÃªn',0),(179866,4997,'af','Besigting Werknemer Lyste',0),(179867,4997,'ro','Vezi listele de angajat',0),(179868,4997,'et','Vaata tÃ¶Ã¶tajate nimekirju',0),(179869,4997,'si','Mnenju zaposlenega sezname',0),(179870,4997,'ba','Lihat daftar karyawan',0),(179871,4997,'nl','Lijsten van de werknemer weergeven',0),(179872,4997,'fi','TyÃ¶ntekijÃ¤n luetteloiden',0),(179873,4997,'no','Vis ansatt lister',0),(179874,4997,'da','FÃ¥ vist medarbejder lister',0),(179875,4997,'ko','ë³´ê¸° ì§ì› ëª©ë¡',0),(179876,4997,'he','×ª×¦×•×’×ª ×”×¢×•×‘×“ ×¨×©×™×ž×•×ª',0),(179877,4997,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»Î¯ÏƒÏ„ÎµÏ‚ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(179878,4997,'zh','æŸ¥çœ‹é›‡å‘˜åå•\r\n',0),(179879,4997,'sv','Visa anstÃ¤lld listor',0),(179880,4997,'it','Vista dipendente elenchi',0),(179881,4997,'tl','',0),(179882,4997,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(179883,4997,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤ à¤¦à¥‡à¤–à¥‡à¤‚',0),(179884,4997,'ms','Lihat senarai pekerja',0),(179885,4997,'ar','Ø¹Ø±Ø¶ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(179886,4997,'fr','Voir listes d\'employÃ©s',0),(179887,4997,'jp','å¾“æ¥­å“¡ãƒªã‚¹ãƒˆã?®è¡¨ç¤º',0),(179888,4997,'pt','Exibir listas de empregado',0),(179889,4997,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¡Ð¿Ð¸ÑÐºÐ° Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(179890,4997,'es','Visionar Listas de Empleados',0),(179891,4997,'de','Ansicht Mitarbeiter Listen',0),(179892,4997,'en','View Employee Lists',0),(179893,4998,'is','',0),(179894,4998,'dr','Ù‡ÙŠÚ† Ø­Ù‚ÙˆÙ‚ÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(179895,4998,'pr','Ù‡ÙŠÚ† Ø­Ù‚ÙˆÙ‚ÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(179896,4998,'tr','Bulunan herhangi bir Ã¶deme',0),(179897,4998,'pl','PÅ‚aca nie znaleziono',0),(179898,4998,'bg','ÐÐ¸ÐºÐ°ÐºÐ²Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(179899,4998,'ur','Ú©ÙˆØ¦ÛŒ ØªÙ†Ø®ÙˆØ§Û Ù…Ù„ÛŒ',0),(179900,4998,'sr','ÐÐµÐ¼Ð° Ð¿Ð»Ð°Ñ‚Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(179901,4998,'vi','ChÆ°a tÃ¬m tháº¥y thanh toÃ¡n',0),(179902,4998,'af','Geen Besoldiging Gevind',0),(179903,4998,'ro','Nu plÄƒtesc gÄƒsit',0),(179904,4998,'et','Ei maksa leida',0),(179905,4998,'si','Ne plaÄa, najti',0),(179906,4998,'ba','Tanpa membayar yang ditemukan',0),(179907,4998,'nl','No Pay gevonden',0),(179908,4998,'fi','Ilman palkkaa lÃ¶ytyi',0),(179909,4998,'no','Ingen lÃ¸nn funnet',0),(179910,4998,'da','Ingen lÃ¸n fundet',0),(179911,4998,'ko','ë°œê²¬ ì§€ë¶ˆ',0),(179912,4998,'he','. ×œ× ×©×™×œ×ž×ª × ×ž×¦××•',0),(179913,4998,'el','Î”ÎµÎ½ Ï€Î»Î·ÏÏŽÎ½Ï‰ Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(179914,4998,'zh','æ²¡æœ‰æ‰¾åˆ°å·¥èµ„\r\n',0),(179915,4998,'sv','Ingen lÃ¶n hittade',0),(179916,4998,'it','Nessuna paga trovata',0),(179917,4998,'tl','',0),(179918,4998,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(179919,4998,'hi','à¤•à¥‹à¤ˆ à¤µà¥‡à¤¤à¤¨ à¤®à¤¿à¤²à¤¾',0),(179920,4998,'ms','Tiada gaji yang didapati',0),(179921,4998,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(179922,4998,'fr','Pas trouvÃ© de salaire',0),(179923,4998,'jp','çµ¦æ–™ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(179924,4998,'pt','NÃ£o hÃ¡ pagamento encontrado',0),(179925,4998,'ru','ÐÐµ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(179926,4998,'es','No se EncontrÃ³ el Pago',0),(179927,4998,'de','Keine Bezahlung gefunden',0),(179928,4998,'en','No Pay Found',0),(179929,4999,'is','',0),(179930,4999,'dr','ØªØ§Ø±ÙŠØ® Ø¹Ø¯Ù… ÙØ¹Ø§Ù„ÙŠØª ',0),(179931,4999,'pr','ØªØ§Ø±ÙŠØ® Ø¹Ø¯Ù… ÙØ¹Ø§Ù„ÙŠØª ',0),(179932,4999,'tr','Ä°ÅŸten Ã§Ä±karÄ±lma tarihi',0),(179933,4999,'pl','Dnia Layoff',0),(179934,4999,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÑÑŠÐºÑ€Ð°Ñ‰Ð°Ð²Ð°Ð½Ðµ',0),(179935,4999,'ur','Ù„Ø§ÛŒÙˆÙÙ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(179936,4999,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð° Ð¾Ñ‚ÐºÐ°Ð·',0),(179937,4999,'vi','NgÃ y cho nghá»‰ viá»‡c',0),(179938,4999,'af','Datum van Aflegging',0),(179939,4999,'ro','Data de disponibilizari',0),(179940,4999,'et','KuupÃ¤eva peatamine',0),(179941,4999,'si','Datum izloÄanje',0),(179942,4999,'ba','Tanggal PHK',0),(179943,4999,'nl','Datum van het Layoff',0),(179944,4999,'fi','Lomautuksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(179945,4999,'no','Dato layoff',0),(179946,4999,'da','Datoen for fritstille',0),(179947,4999,'ko','í•´ ê³ ì˜ ë‚ ì§œ',0),(179948,4999,'he','×ª××¨×™×š ×¤×™×˜×•×¨×™×Ÿ',0),(179949,4999,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿Î»ÏÏƒÎµÎ¹Ï‚',0),(179950,4999,'zh','è£å‘˜çš„æ—¥æœŸ\r\n',0),(179951,4999,'sv','Datum fÃ¶r uppsÃ¤gningar',0),(179952,4999,'it','Data di licenziamento',0),(179953,4999,'tl','',0),(179954,4999,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3621;&#3636;&#3585;&#3592;&#3657;&#3634;&#3591;',0),(179955,4999,'hi','Layoff à¤•à¥‡ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(179956,4999,'ms','Tarikh Layoff',0),(179957,4999,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ³Ø±ÙŠØ­',0),(179958,4999,'fr','Date de mise Ã  pied',0),(179959,4999,'jp','è§£é›‡æ—¥',0),(179960,4999,'pt','Data de demissÃ£o',0),(179961,4999,'ru','Ð”Ð°Ñ‚Ð° Ð£Ð²Ð¾Ð»ÑŒÐ½ÐµÐ½Ð¸Ñ',0),(179962,4999,'es','Fecha de Despido',0),(179963,4999,'de','Datum der Entlassung',0),(179964,4999,'en','Date of Layoff',0),(179965,5000,'is','',0),(179966,5000,'dr','Ù‡ÙŠÚ† Ø§Ø®Ø±Ø§Ø¬ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(179967,5000,'pr','Ù‡ÙŠÚ† Ø§Ø®Ø±Ø§Ø¬ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(179968,5000,'tr','HiÃ§bir iÅŸten Ã§Ä±karmalar bulundu',0),(179969,5000,'pl','Nie zwolnienia Znalezione',0),(179970,5000,'bg','ÐÐµ ÑÑŠÐºÑ€Ð°Ñ‰ÐµÐ½Ð¸Ñ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(179971,5000,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ù„Û’',0),(179972,5000,'sr','ÐÐµÐ¼Ð° Ð¾Ñ‚Ð¿ÑƒÑˆÑ‚Ð°ÑšÐ° Ð½Ð°ÑˆÐ°Ð¾',0),(179973,5000,'vi','KhÃ´ng tÃ¬m tháº¥y sa tháº£i',0),(179974,5000,'af','Geen Ontslaaning Gevind',0),(179975,5000,'ro','Nici disponibilizÄƒri gÄƒsit',0),(179976,5000,'et','Ei leidnud vallandamisi',0),(179977,5000,'si','Nobenega odpuÅ¡Äanja, najti',0),(179978,5000,'ba','PHK tidak ditemukan',0),(179979,5000,'nl','Geen ontslagen gevonden',0),(179980,5000,'fi','Ei lomautuksia lÃ¶ytyi',0),(179981,5000,'no','Ingen oppsigelser funnet',0),(179982,5000,'da','Ingen fyringer fundet',0),(179983,5000,'ko','ì•„ë‹ˆ ì •ë¦¬ í•´ ê³  ë°œê²¬',0),(179984,5000,'he','×¤×™×˜×•×¨×™× ×œ× × ×ž×¦××•',0),(179985,5000,'el','Î”ÎµÎ½ Î±Ï€Î¿Î»ÏÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(179986,5000,'zh','æ²¡æœ‰å‘çŽ°è£å‘˜\r\n',0),(179987,5000,'sv','Inga uppsÃ¤gningar hittade',0),(179988,5000,'it','No licenziamenti trovati',0),(179989,5000,'tl','',0),(179990,5000,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3648;&#3621;&#3636;&#3585;&#3592;&#3657;&#3634;&#3591;&#3591;&#3634;&#3609;',0),(179991,5000,'hi','à¤•à¥‹à¤ˆ à¤›à¤‚à¤Ÿà¤¨à¥€ à¤ªà¤¾à¤¯à¤¾',0),(179992,5000,'ms','Tiada pemberhentian yang ditemui',0),(179993,5000,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªØ³Ø±ÙŠØ­ Ø¬Ø¯ÙŠØ¯',0),(179994,5000,'fr','Aucune mise Ã  pied trouvÃ©',0),(179995,5000,'jp','è§£é›‡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(179996,5000,'pt','Sem demissÃµes encontradas',0),(179997,5000,'ru','Ð£Ð²Ð¾Ð»ÑŒÐ½ÐµÐ½Ð¸Ñ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(179998,5000,'es','No se Encontraron Despedidos',0),(179999,5000,'de','Keine Entlassungen gefunden',0),(180000,5000,'en','No Layoffs Found',0),(180001,5001,'is','',0),(180002,5001,'dr','Ø§Ø®Ø±Ø§Ø¬ Ø´Ø¯Ù‡ ',0),(180003,5001,'pr','Ø§Ø®Ø±Ø§Ø¬ Ø´Ø¯Ù‡ ',0),(180004,5001,'tr','Ä°ÅŸten',0),(180005,5001,'pl','Zwolnieni',0),(180006,5001,'bg','Ð£Ð²Ð¾Ð»Ð½ÐµÐ½Ð¸',0),(180007,5001,'ur','Ù†Û’ Ø±Ú©Ú¾ÛŒ',0),(180008,5001,'sr','ÐžÑ‚Ð¿ÑƒÑˆÑ‚ÐµÐ½Ð°',0),(180009,5001,'vi','Sa tháº£i',0),(180010,5001,'af','Ontslaan',0),(180011,5001,'ro','Stabilite Ã®n afara',0),(180012,5001,'et','Koondatud',0),(180013,5001,'si','OdpuÅ¡Äeni',0),(180014,5001,'ba','Diberhentikan',0),(180015,5001,'nl','Ontslagen',0),(180016,5001,'fi','Lomautettu',0),(180017,5001,'no','Permitterte',0),(180018,5001,'da','Afskediget',0),(180019,5001,'ko','ì •ë¦¬ í•´ ê³ ',0),(180020,5001,'he','×¤×•×˜×¨×•',0),(180021,5001,'el','Î‘Ï€Î¿Î»ÏÎ¸Î·ÎºÎ±Î½',0),(180022,5001,'zh','ä¸‹å²—\r\n',0),(180023,5001,'sv','Uppsagd',0),(180024,5001,'it','Congedati',0),(180025,5001,'tl','',0),(180026,5001,'th','&#3648;&#3621;&#3636;&#3585;&#3592;&#3657;&#3634;&#3591;&#3591;&#3634;&#3609;',0),(180027,5001,'hi','à¤¬à¤‚à¤¦ à¤°à¤–à¤¾',0),(180028,5001,'ms','Diberhentikan',0),(180029,5001,'ar','Ø§Ù„Ù…Ø³Ø±Ø­ÙŠÙ†',0),(180030,5001,'fr','Mis Ã  pied',0),(180031,5001,'jp','è§£é›‡ã?•ã‚Œã?Ÿ',0),(180032,5001,'pt','Demitidos',0),(180033,5001,'ru','Ð£Ð²Ð¾Ð»ÐµÐ½Ñ‹',0),(180034,5001,'es','Despedido',0),(180035,5001,'de','Entlassen',0),(180036,5001,'en','Laid Off',0),(180037,5002,'is','',0),(180038,5002,'dr','(Ø§Ø¬Ø±Øª ) Ø¬Ø¯ÙŠØ¯ ',0),(180039,5002,'pr','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù‡Ø§ÙŠ (Ø§Ø¬Ø±Øª ) Ø¬Ø¯ÙŠØ¯ ',0),(180040,5002,'tr','Yeni Hires',0),(180041,5002,'pl','Nowych pracownikÃ³w',0),(180042,5002,'bg','ÐÐ¾Ð²Ð° Ð½Ð°ÐµÐ¼Ð°',0),(180043,5002,'ur','Ù†Ø¦ÛŒ Ø¨Ú¾Ø±ØªÛŒ Ú©Ø±Ù„ÛŒÛ’',0),(180044,5002,'sr','ÐÐ¾Ð²Ð¸Ð¼ Ñ€Ð°Ð´Ð½Ð¸Ñ†Ð¸Ð¼Ð°',0),(180045,5002,'vi','Má»›i thuÃª',0),(180046,5002,'af','Nuwe Aanstellings',0),(180047,5002,'ro','Noii veniti',0),(180048,5002,'et','Uued palkamised',0),(180049,5002,'si','Nova oddaja',0),(180050,5002,'ba','Karyawan baru',0),(180051,5002,'nl','Nieuwe aanwervingen',0),(180052,5002,'fi','Uudet tyÃ¶ntekijÃ¤t',0),(180053,5002,'no','Nyansatte',0),(180054,5002,'da','NyansÃ¦ttelser',0),(180055,5002,'ko','ì‹ ê·œ ì±„ìš©',0),(180056,5002,'he','××™×©×“×— ××™×“×‘×•×¢ ×¨×•×‘×¢',0),(180057,5002,'el','ÎÎ­ÎµÏ‚ Ï€ÏÎ¿ÏƒÎ»Î®ÏˆÎµÎ¹Ï‚',0),(180058,5002,'zh','æ–°å‘˜å·¥\r\n',0),(180059,5002,'sv','NyanstÃ¤llda',0),(180060,5002,'it','Nuove assunzioni',0),(180061,5002,'tl','',0),(180062,5002,'th','&#3585;&#3634;&#3619;&#3592;&#3657;&#3634;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(180063,5002,'hi','à¤¨à¤¯à¤¾ à¤•à¤¾à¤® à¤¦à¥‡à¤¤à¤¾',0),(180064,5002,'ms','Baharu',0),(180065,5002,'ar','Ù…ÙˆØ¸ÙÙˆÙ† Ø¬Ø¯Ø¯',0),(180066,5002,'fr','Nouvelles recrues',0),(180067,5002,'jp','æ–°è¦?é›‡ç”¨',0),(180068,5002,'pt','Novas contrataÃ§Ãµes',0),(180069,5002,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð½Ð°Ð½Ð¸Ð¼Ð°ÐµÑ‚',0),(180070,5002,'es','Nuevos Empleados',0),(180071,5002,'de','Neueinstellungen',0),(180072,5002,'en','New Hires',0),(180073,5003,'is','',0),(180074,5003,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ù†Ø±Ø® Ø­Ù‚ÙˆÙ‚',0),(180075,5003,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ù†Ø±Ø® Ø­Ù‚ÙˆÙ‚',0),(180076,5003,'tr','Kurundaki Ã¶demek',0),(180077,5003,'pl','PÅ‚aciÄ‡ stawki zmiany',0),(180078,5003,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(180079,5003,'ur','Ø´Ø±Ø­ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ø§Ø¯Ø§',0),(180080,5003,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ ÑÑ‚Ð¾Ð¿Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(180081,5003,'vi','Thay Ä‘á»•i GiÃ¡ thanh toÃ¡n',0),(180082,5003,'af','Besoldiging Veranderinge',0),(180083,5003,'ro','PlÄƒteascÄƒ modificÄƒrii ratei',0),(180084,5003,'et','Maksma mÃ¤Ã¤r muutused',0),(180085,5003,'si','PlaÄati stopnja spremembe',0),(180086,5003,'ba','Membayar laju perubahan',0),(180087,5003,'nl','Betalen tariefwijzigingen',0),(180088,5003,'fi','Maksu muuttuu',0),(180089,5003,'no','Betale endringer',0),(180090,5003,'da','Betale renteÃ¦ndringer',0),(180091,5003,'ko','ì†ë„ ë³€í™”ë¥¼ ì§€ë¶ˆ',0),(180092,5003,'he','×œ×©×œ× ××ª ×”×ª×¢×¨×™×£ ×ž×©×ª× ×”',0),(180093,5003,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Ï„Î¹Ï‚ Î¼ÎµÏ„Î±Î²Î¿Î»Î­Ï‚ Ï„Ï‰Î½ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î¼Î±Ï„Î¹ÎºÏŽÎ½',0),(180094,5003,'zh','å·¥èµ„çŽ‡çš„å˜åŒ–\r\n',0),(180095,5003,'sv','Betala rÃ¤ntefÃ¶rÃ¤ndringar',0),(180096,5003,'it','Pagare il tasso cambia',0),(180097,5003,'tl','',0),(180098,5003,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3629;&#3633;&#3605;&#3619;&#3634;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(180099,5003,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤° à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(180100,5003,'ms','Membayar kadar perubahan',0),(180101,5003,'ar','Ø¯ÙØ¹ Ù…Ø¹Ø¯Ù„ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(180102,5003,'fr','Payer des modifications tarifaires',0),(180103,5003,'jp','è³ƒé‡‘å¤‰æ›´',0),(180104,5003,'pt','Pagar a taxa de alteraÃ§Ãµes',0),(180105,5003,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(180106,5003,'es','Cambios de Tasas de Pago',0),(180107,5003,'de','ZinsÃ¤nderungen zu zahlen',0),(180108,5003,'en','Pay Rate Changes',0),(180109,5004,'is','',0),(180110,5004,'dr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø·Ø¨Ù‚ Ù…Ø§Ù‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(180111,5004,'pr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø·Ø¨Ù‚ Ù…Ø§Ù‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(180112,5004,'tr','YÄ±l iÃ§in aylÄ±k bordro',0),(180113,5004,'pl','WynagrodzeÅ„ za miesiÄ…c rok',0),(180114,5004,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¾Ñ‚ Ð¼ÐµÑÐµÑ† Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(180115,5004,'ur','Ø¨Ù…Ø·Ø§Ø¨Ù‚ Ù…Ø§Û Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ Ù¾Û’ Ø±ÙˆÙ„',0),(180116,5004,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð¿Ð¾ Ð¼ÐµÑÐµÑ†Ñƒ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(180117,5004,'vi','Báº£ng lÆ°Æ¡ng thÃ¡ng cá»§a nÄƒm',0),(180118,5004,'af','Loonrol per Maand vir Jaar',0),(180119,5004,'ro','Salarizare lunar pentru anul',0),(180120,5004,'et','Aasta palk kuude lÃµikes',0),(180121,5004,'si','IzplaÄane plaÄe na mesec za leto',0),(180122,5004,'ba','Penggajian oleh bulan selama tahun',0),(180123,5004,'nl','Payroll per maand voor een jaar',0),(180124,5004,'fi','Palkanlaskennan kuukausittain vuoden',0),(180125,5004,'no','LÃ¸nn per mÃ¥ned for Ã¥r',0),(180126,5004,'da','LÃ¸n pr. mÃ¥ned i Ã¥r',0),(180127,5004,'ko','ë…„ ì›”ë³„ ê¸‰ì—¬',0),(180128,5004,'he','×©×›×¨ ×œ×¤×™ ×—×•×“×© ×œ×©× ×”',0),(180129,5004,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Î±Î½Î¬ Î¼Î®Î½Î± Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚',0),(180130,5004,'zh','è–ªé‡‘æŒ‰æœˆ\r\n',0),(180131,5004,'sv','LÃ¶n per mÃ¥nad fÃ¶r Ã¥r',0),(180132,5004,'it','Libro paga di mese per anno',0),(180133,5004,'tl','',0),(180134,5004,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3619;&#3634;&#3618;&#3648;&#3604;&#3639;&#3629;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3637;',0),(180135,5004,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥‡à¤°à¥‹à¤²',0),(180136,5004,'ms','Gaji mengikut bulan bagi tahun',0),(180137,5004,'ar','ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª Ø´Ù‡Ø±ÙŠØ§ Ù„Ù…Ø¯Ø© Ø³Ù†Ø©',0),(180138,5004,'fr','Paie par mois pour l\'annÃ©e',0),(180139,5004,'jp','æœˆã?”ã?¨ã?®äººä»¶è²»',0),(180140,5004,'pt','Folha de pagamento por mÃªs por ano',0),(180141,5004,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ðµ Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸ ÐŸÐ¾ ÐœÐµÑÑÑ†Ð°Ð¼ Ð·Ð° Ð“Ð¾Ð´',0),(180142,5004,'es','NÃ³mina por Mes y AÃ±o',0),(180143,5004,'de','Abrechnung nach Monat Jahr',0),(180144,5004,'en','Payroll by Month for Year',0),(180145,5005,'is','',0),(180146,5005,'dr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø·Ø¨Ù‚ Ø³Ù‡ Ù…Ø§Ù‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(180147,5005,'pr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø·Ø¨Ù‚ Ø³Ù‡ Ù…Ø§Ù‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(180148,5005,'tr','Bordro yÄ±l iÃ§in Ã¼Ã§ aylÄ±k dÃ¶nemlere gÃ¶re',0),(180149,5005,'pl','PÅ‚ac wedÅ‚ug kwartaÅ‚Ã³w roku',0),(180150,5005,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ð¾ Ñ‚Ñ€Ð¸Ð¼ÐµÑÐµÑ‡Ð¸Ñ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(180151,5005,'ur','Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ Ú©ÙˆØ§Ø±Ù¹Ø± Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾Û’ Ø±ÙˆÙ„',0),(180152,5005,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð¿Ð¾ ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð¸Ð¼Ð° Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(180153,5005,'vi','Báº£ng lÆ°Æ¡ng quÃ½ cá»§a nÄƒm',0),(180154,5005,'af','Loonrol per Kwartaal vir Jaar',0),(180155,5005,'ro','Salarizare sfert de an',0),(180156,5005,'et','Aasta palk kvartalite lÃµikes',0),(180157,5005,'si','IzplaÄane plaÄe za Äetrtino za leto',0),(180158,5005,'ba','Penggajian kuartal tahun',0),(180159,5005,'nl','Payroll per kwartaal voor jaar',0),(180160,5005,'fi','Palkkahallinnon vuosi NELJÃ„NNEKSITTÃ„IN',0),(180161,5005,'no','LÃ¸nn etter kvartal i Ã¥r',0),(180162,5005,'da','LÃ¸n efter kvartal i Ã¥r',0),(180163,5005,'ko','ê¸‰ì—¬ ë…„ê°„ ë¶„ê¸°ë³„ë¡œ',0),(180164,5005,'he','×©×›×¨ ×œ×¤×™ ×¨×‘×¢×•×Ÿ ×œ×©× ×”',0),(180165,5005,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Î±Ï€ÏŒ Ï„Î¿ Ï„ÏÎ¯Î¼Î·Î½Î¿ Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚',0),(180166,5005,'zh','è–ªé‡‘æŒ‰å­£åº¦\r\n',0),(180167,5005,'sv','LÃ¶ner kvartal fÃ¶r Ã¥ret',0),(180168,5005,'it','Libro paga di quarto per anno',0),(180169,5005,'tl','',0),(180170,5005,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3619;&#3634;&#3618;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3637;',0),(180171,5005,'hi','à¤¸à¤¾à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¤¿à¤®à¤¾à¤¹à¥€ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥‡à¤°à¥‹à¤²',0),(180172,5005,'ms','Gaji pada suku tahun',0),(180173,5005,'ar','Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø­Ø³Ø¨ Ø±Ø¨Ø¹ Ø§Ù„Ø³Ù†Ø©',0),(180174,5005,'fr','Paie par trimestre pour l\'annÃ©e',0),(180175,5005,'jp','å››å?ŠæœŸã?”ã?¨ã?®äººä»¶è²»',0),(180176,5005,'pt','Folha de pagamento por trimestre por ano',0),(180177,5005,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ðµ Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸ ÐŸÐ¾ ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð°Ð¼ Ð·Ð° Ð“Ð¾Ð´',0),(180178,5005,'es','NÃ³mina por Trimentre por AÃ±o',0),(180179,5005,'de','Abrechnung pro Quartal fÃ¼r das Jahr',0),(180180,5005,'en','Payroll by Quarter for Year',0),(180181,5006,'is','',0),(180182,5006,'dr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§ÙŠÙ† Ù…Ø§Ù‡ ',0),(180183,5006,'pr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§ÙŠÙ† Ù…Ø§Ù‡ ',0),(180184,5006,'tr','Bordro bu ay',0),(180185,5006,'pl','PÅ‚ace w tym miesiÄ…cu',0),(180186,5006,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ñ‚Ð¾Ð·Ð¸ Ð¼ÐµÑÐµÑ†',0),(180187,5006,'ur','Ø§Ø³ Ù…Ø§Û Ú©Û’ Ù¾Û’ Ø±ÙˆÙ„',0),(180188,5006,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð¾Ð²Ð¾Ð³ Ð¼ÐµÑÐµÑ†Ð°',0),(180189,5006,'vi','Báº£ng LÆ°Æ¡ng ThÃ¡ng NÃ y',0),(180190,5006,'af','Loonrol Hierdie Maand',0),(180191,5006,'ro','Salarizare Ã®n aceastÄƒ lunÄƒ',0),(180192,5006,'et','Palgaarvestuse sel kuul',0),(180193,5006,'si','IzplaÄane plaÄe tega meseca',0),(180194,5006,'ba','Penggajian bulan ini',0),(180195,5006,'nl','Deze maand loonlijst',0),(180196,5006,'fi','Palkanlaskennan tÃ¤ssÃ¤ kuussa',0),(180197,5006,'no','LÃ¸nn denne mÃ¥neden',0),(180198,5006,'da','LÃ¸n denne mÃ¥ned',0),(180199,5006,'ko','ì´ë²ˆ ë‹¬ ê¸‰ì—¬',0),(180200,5006,'he','×ž×©×›×•×¨×•×ª ×”×—×•×“×©',0),(180201,5006,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î®Î½Î±',0),(180202,5006,'zh','æœ¬æœˆè–ªèµ„\r\n',0),(180203,5006,'sv','LÃ¶n denna mÃ¥nad',0),(180204,5006,'it','Libro paga di questo mese',0),(180205,5006,'tl','',0),(180206,5006,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(180207,5006,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤‡à¤¸ à¤®à¤¹à¥€à¤¨à¥‡',0),(180208,5006,'ms','Gaji bulan ini',0),(180209,5006,'ar','Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ù‡Ø°Ø§ Ø§Ù„Ø´Ù‡Ø±',0),(180210,5006,'fr','Paie ce mois-ci',0),(180211,5006,'jp','ä»Šæœˆã?®äººä»¶è²»',0),(180212,5006,'pt','Folha de pagamento deste mÃªs',0),(180213,5006,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð°Ñ Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚ÑŒ Ð—Ð° Ð”Ð°Ð½Ð½Ñ‹Ð¹ ÐœÐµÑÑÑ†',0),(180214,5006,'es','NÃ³mina Est Mes',0),(180215,5006,'de','Abrechnung in diesem Monat',0),(180216,5006,'en','Payroll This Month',0),(180217,5007,'is','',0),(180218,5007,'dr','(Ø´Ù…Ø§Ø±Ø´) ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ÙØ¹Ø§Ù„',0),(180219,5007,'pr','ØªØ¹Ø¯Ø§Ø¯(Ø´Ù…Ø§Ø±Ø´) ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ÙØ¹Ø§Ù„',0),(180220,5007,'tr','Aktif Ã§alÄ±ÅŸan sayÄ±larÄ±',0),(180221,5007,'pl','Liczby aktywnych pracownikÃ³w',0),(180222,5007,'bg','Ð‘Ñ€Ð¾Ñ Ð½Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸Ñ‚Ðµ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(180223,5007,'ur','Ø²ÛŒØ± Ø¹Ù…Ù„ Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©Ø§ Ø´Ù…Ø§Ø±',0),(180224,5007,'sr','Ð¢Ð°Ñ‡Ð°ÐºÐ° Ð·Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(180225,5007,'vi','Äáº¿m nhÃ¢n viÃªn Ä‘ang hoáº¡t Ä‘á»™ng',0),(180226,5007,'af','Berekening van Aktiewe Werknemers',0),(180227,5007,'ro','Capete de acuzare de angajatii activi',0),(180228,5007,'et','Aktiivsete tÃ¶Ã¶tajate arv',0),(180229,5007,'si','Grofje aktivno zaposlenih',0),(180230,5007,'ba','Hitungan karyawan aktif',0),(180231,5007,'nl','Lijst van graven van actieve medewerkers',0),(180232,5007,'fi','Laskee aktiivisimpia tyÃ¶ntekijÃ¶itÃ¤',0),(180233,5007,'no','Antall aktive ansatte',0),(180234,5007,'da','Greverne af aktive medarbejdere',0),(180235,5007,'ko','í™œì„± ì§ì›ì˜ ê±´ì˜',0),(180236,5007,'he','×¡×¢×™×¤×™× ×©×œ ×¢×•×‘×“×™× ×¤×¢×™×œ×™×',0),(180237,5007,'el','ÎœÎµÏ„ÏÎ¬ÎµÎ¹ Ï„Ï‰Î½ ÎµÎ½ÎµÏÎ³ÏŽÎ½ Ï…Ï€Î±Î»Î»Î®Î»Ï‰Î½',0),(180238,5007,'zh','åœ¨èŒèŒå·¥è®¡æ•°\r\n',0),(180239,5007,'sv','RÃ¤kningarna av aktiva anstÃ¤llda',0),(180240,5007,'it','Conti di collaboratori attivi',0),(180241,5007,'tl','',0),(180242,5007,'th','&#3609;&#3633;&#3610;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3591;&#3634;&#3609;',0),(180243,5007,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤—à¤¿à¤¨à¤¤à¥€',0),(180244,5007,'ms','Jumlah kakitangan',0),(180245,5007,'ar','Ø§Ù„ØªÙ‡Ù… Ù„Ù„Ù…ÙˆØ¸ÙÙŠÙ† Ø§Ù„Ø¹Ø§Ù…Ù„ÙŠÙ†',0),(180246,5007,'fr','Nombre d\'employÃ©s actifs',0),(180247,5007,'jp','ç?¾å½¹å¾“æ¥­å“¡ã?®ç·?æ•°',0),(180248,5007,'pt','Contagens de empregados ativos',0),(180249,5007,'ru','Ð§Ð¸ÑÐ»Ð¾ ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ñ… Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(180250,5007,'es','Conteos de Empleados Activos',0),(180251,5007,'de','Grafen von aktiven Mitarbeiter',0),(180252,5007,'en','Counts of Active Employees',0),(180253,5008,'is','',0),(180254,5008,'dr','( ÙƒØ§Ø±Ù…Ù†Ø¯ Ù…Ø¹Ø§Ø´ Ø¨Ú¯ÙŠØ±',0),(180255,5008,'pr','Ø¯Ø§Ø±Ø§Ù‰ Ø­Ù‚ÙˆÙ‚ ( ÙƒØ§Ø±Ù…Ù†Ø¯ Ø­Ù‚ÙˆÙ‚â€Œ Ø¨Ú¯ÙŠØ±',0),(180256,5008,'tr','MaaÅŸlÄ±',0),(180257,5008,'pl','Jako pracownik najemny',0),(180258,5008,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð°',0),(180259,5008,'ur','ØªÙ†Ø®ÙˆØ§Û',0),(180260,5008,'sr','Ð¡Ð° Ð¿Ð»Ð°Ñ‚Ð¾Ð¼',0),(180261,5008,'vi','LÆ°Æ¡ng',0),(180262,5008,'af','Drie',0),(180263,5008,'ro','SalariaÅ£i',0),(180264,5008,'et','Palgaline',0),(180265,5008,'si','Redno zaposleni',0),(180266,5008,'ba','Gaji',0),(180267,5008,'nl','Loondienst',0),(180268,5008,'fi','ToimihenkilÃ¶iden',0),(180269,5008,'no','AvlÃ¸nnet',0),(180270,5008,'da','LÃ¸nnede',0),(180271,5008,'ko','ê¸‰ì—¬',0),(180272,5008,'he','×©×›×™×¨×™×',0),(180273,5008,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î¿Î¯',0),(180274,5008,'zh','å·¥è–ª\r\n',0),(180275,5008,'sv','AvlÃ¶nade',0),(180276,5008,'it','Stipendiati',0),(180277,5008,'tl','',0),(180278,5008,'th','&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(180279,5008,'hi','à¤µà¥‡à¤¤à¤¨à¤­à¥‹à¤—à¥€',0),(180280,5008,'ms','Bergaji',0),(180281,5008,'ar','Ø£Ø¬Ø±',0),(180282,5008,'fr','SalariÃ©s',0),(180283,5008,'jp','çµ¦æ–™åˆ¶ã?®',0),(180284,5008,'pt','Assalariados',0),(180285,5008,'ru','ÐÐ°ÐµÐ¼Ð½Ñ‹Ðµ',0),(180286,5008,'es','Salariado',0),(180287,5008,'de','Angestellte',0),(180288,5008,'en','Salaried',0),(180289,5009,'is','',0),(180290,5009,'dr','( ØªØ¹Ø¯Ø§Ø¯) ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(180291,5009,'pr','Ø´Ù…Ø§Ø±Ø´ ( ØªØ¹Ø¯Ø§Ø¯) ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(180292,5009,'tr','Ã‡alÄ±ÅŸan sayÄ±sÄ±',0),(180293,5009,'pl','Liczy siÄ™ pracownika',0),(180294,5009,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¾Ñ‚ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(180295,5009,'ur','Ù…Ù„Ø§Ø²Ù… Ø´Ù…Ø§Ø±',0),(180296,5009,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ñ‚Ð°Ñ‡Ð°ÐºÐ°',0),(180297,5009,'vi','Äáº¿m nhÃ¢n viÃªn',0),(180298,5009,'af','Werknemer Telling',0),(180299,5009,'ro','Angajat conteazÄƒ',0),(180300,5009,'et','TÃ¶Ã¶tajate arv',0),(180301,5009,'si','Å tevilo zaposlenih',0),(180302,5009,'ba','Jumlah karyawan',0),(180303,5009,'nl','Werknemer graven',0),(180304,5009,'fi','TyÃ¶ntekijÃ¶iden mÃ¤Ã¤rÃ¤',0),(180305,5009,'no','Ansatt teller',0),(180306,5009,'da','Medarbejder tÃ¦ller',0),(180307,5009,'ko','ì§ì› ìˆ˜',0),(180308,5009,'he','×”×¢×•×‘×“ ×¡×¤×™×¨×•×ª',0),(180309,5009,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î¼ÎµÏ„ÏÎ¬ÎµÎ¹',0),(180310,5009,'zh','å‘˜å·¥è®¡æ•°\r\n',0),(180311,5009,'sv','AnstÃ¤lld rÃ¤knas',0),(180312,5009,'it','Dipendente conteggi',0),(180313,5009,'tl','',0),(180314,5009,'th','&#3609;&#3633;&#3610;&#3592;&#3635;&#3609;&#3623;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(180315,5009,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¤¾à¤‰à¤‚à¤Ÿà¥à¤¸',0),(180316,5009,'ms','Jumlah pekerja',0),(180317,5009,'ar','ØªÙ‡Ù… Ø§Ù„Ù…ÙˆØ¸Ù',0),(180318,5009,'fr','Comtes de l\'employÃ©',0),(180319,5009,'jp','å¾“æ¥­å“¡è¨ˆç®—',0),(180320,5009,'pt','Contagens de empregado',0),(180321,5009,'ru','Ð§Ð¸ÑÐ»Ð¾ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(180322,5009,'es','Empleado Conteos',0),(180323,5009,'de','Mitarbeiter zÃ¤hlt',0),(180324,5009,'en','Employee Counts',0),(180325,5010,'is','',0),(180326,5010,'dr','Ù†Ø±Ø® Ù‚Ø¨Ù„ÙŠ',0),(180327,5010,'pr','Ù†Ø±Ø® Ù‚Ø¨Ù„ÙŠ',0),(180328,5010,'tr','Eski oranÄ±',0),(180329,5010,'pl','Stare stawki',0),(180330,5010,'bg','Ð¡Ñ‚Ð°Ñ€ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(180331,5010,'ur','Ù¾Ø±Ø§Ù†Û’ Ø´Ø±Ø­',0),(180332,5010,'sr','Ð¡Ñ‚Ð°Ñ€Ð° ÑÑ‚Ð¾Ð¿Ð°',0),(180333,5010,'vi','GiÃ¡ cÅ©',0),(180334,5010,'af','Ou Tarief',0),(180335,5010,'ro','Rata de vechi',0),(180336,5010,'et','Vana kurss',0),(180337,5010,'si','Stara mera',0),(180338,5010,'ba','Lama rata',0),(180339,5010,'nl','Oude tarief',0),(180340,5010,'fi','Vanha mÃ¤Ã¤rÃ¤',0),(180341,5010,'no','Gamle Rate',0),(180342,5010,'da','Gamle sats',0),(180343,5010,'ko','ì˜¤ëž˜ ëœ ì†ë„',0),(180344,5010,'he','×ª×¢×¨×™×£ ×™×©×Ÿ',0),(180345,5010,'el','Î Î±Î»Î¹ÏŒ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(180346,5010,'zh','æ—§æ¯”çŽ‡\r\n',0),(180347,5010,'sv','Gamla kurs',0),(180348,5010,'it','Vecchio tasso',0),(180349,5010,'tl','',0),(180350,5010,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3648;&#3585;&#3656;&#3634;',0),(180351,5010,'hi','à¤ªà¥à¤°à¤¾à¤¨à¥€ à¤¦à¤°',0),(180352,5010,'ms','Kadar lama',0),(180353,5010,'ar','Ù…Ø¹Ø¯Ù„ Ø§Ù„Ø¹Ù…Ø±',0),(180354,5010,'fr','Ancien taux',0),(180355,5010,'jp','æ—§æ–™é‡‘',0),(180356,5010,'pt','Taxa de velha',0),(180357,5010,'ru','Ð¡Ñ‚Ð°Ñ€Ñ‹Ð¹ ÐºÑƒÑ€Ñ',0),(180358,5010,'es','Tasa Vieja',0),(180359,5010,'de','Alte Rate',0),(180360,5010,'en','Old Rate',0),(180361,5011,'is','',0),(180362,5011,'dr','ØªØ§Ø±ÙŠØ® ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± ',0),(180363,5011,'pr','ØªØ§Ø±ÙŠØ® ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± ',0),(180364,5011,'tr','Ä°nceleme tarihi',0),(180365,5011,'pl','Data przeglÄ…du',0),(180366,5011,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°',0),(180367,5011,'ur','ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(180368,5011,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ðµ',0),(180369,5011,'vi','NgÃ y Ä‘Ã¡nh giÃ¡',0),(180370,5011,'af','Datum van Hersiening',0),(180371,5011,'ro','Data de revizuire',0),(180372,5011,'et','LÃ¤bivaatuse kuupÃ¤ev',0),(180373,5011,'si','Datum pregleda',0),(180374,5011,'ba','Tanggal ulasan',0),(180375,5011,'nl','Datum van herziening',0),(180376,5011,'fi','TarkastelupÃ¤ivÃ¤Ã¤',0),(180377,5011,'no','Datoen for gjennomgang',0),(180378,5011,'da','Datoen for anmeldelse',0),(180379,5011,'ko','ê²€í†  ë‚ ì§œ',0),(180380,5011,'he','×ž×•×¢×“ ×¡×§×™×¨×”',0),(180381,5011,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·Ï‚',0),(180382,5011,'zh','å®¡æŸ¥æ—¥æœŸ\r\n',0),(180383,5011,'sv','Datum fÃ¶r Ã¶versyn',0),(180384,5011,'it','Data di revisione',0),(180385,5011,'tl','',0),(180386,5011,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3605;&#3619;&#3623;&#3592;&#3604;&#3641;',0),(180387,5011,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¥‡ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(180388,5011,'ms','Tarikh semakan',0),(180389,5011,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙ‚ÙŠÙŠÙ…',0),(180390,5011,'fr','Date de rÃ©vision',0),(180391,5011,'jp','è¦‹ç›´ã?—æ—¥',0),(180392,5011,'pt','Data de revisÃ£o',0),(180393,5011,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ð±Ð·Ð¾Ñ€Ð°',0),(180394,5011,'es','Fecha de RevisiÃ³n',0),(180395,5011,'de','Datum der ÃœberprÃ¼fung',0),(180396,5011,'en','Date of Review',0),(180397,5012,'is','',0),(180398,5012,'dr','Ù‡ÙŠÚ† Ø¨Ø±Ú¯Ø´ØªÙŠ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(180399,5012,'pr','Ù‡ÙŠÚ† Ø¨Ø±Ú¯Ø´ØªÙŠ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(180400,5012,'tr','HiÃ§bir deÄŸerlendirmeleri bulundu',0),(180401,5012,'pl','Nie znaleziono opinii',0),(180402,5012,'bg','ÐÐµ Ñ€ÐµÐ²ÑŽÑ‚Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(180403,5012,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ø¬Ø§Ø¦Ø²Û',0),(180404,5012,'sr','ÐÐµÐ¼Ð° ÐºÑ€Ð¸Ñ‚Ð¸ÐºÐµ Ð½Ð°ÑˆÐ°Ð¾',0),(180405,5012,'vi','KhÃ´ng tháº¥y Ä‘Ã¡nh giÃ¡',0),(180406,5012,'af','Geen resensies gevind',0),(180407,5012,'ro','Nici clienÅ£i gÄƒsit',0),(180408,5012,'et','Leida Ã¼levaateid',0),(180409,5012,'si','Ni ocen',0),(180410,5012,'ba','Tidak ada ulasan yang ditemukan',0),(180411,5012,'nl','Geen beoordelingen gevonden',0),(180412,5012,'fi','Arvosteluja ei lÃ¶ytynyt',0),(180413,5012,'no','Ingen anmeldelser funnet',0),(180414,5012,'da','Ingen anmeldelser fundet',0),(180415,5012,'ko','ê²€í† ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŒ',0),(180416,5012,'he','×œ× × ×ž×¦××• ×—×•×•×ª ×“×¢×ª',0),(180417,5012,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î±Î¾Î¹Î¿Î»Î¿Î³Î®ÏƒÎµÎ¹Ï‚',0),(180418,5012,'zh','æ²¡æœ‰å‘çŽ°å¤æ ¸\r\n',0),(180419,5012,'sv','Inga recensioner som hittade',0),(180420,5012,'it','Nessuna recensione trovata',0),(180421,5012,'tl','',0),(180422,5012,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3607;&#3610;&#3607;&#3623;&#3609;',0),(180423,5012,'hi','à¤•à¥‹à¤ˆ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤ªà¤¾à¤¯à¤¾',0),(180424,5012,'ms','Tiada Ulasan dijumpai',0),(180425,5012,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(180426,5012,'fr','Aucun avis trouvÃ©s',0),(180427,5012,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(180428,5012,'pt','Sem comentÃ¡rios encontrados',0),(180429,5012,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð½Ñ‹Ðµ ÐžÑ‚Ð·Ñ‹Ð²Ñ‹',0),(180430,5012,'es','No se Encontraron Revisiones',0),(180431,5012,'de','Keine Bewertungen gefunden',0),(180432,5012,'en','No Reviews Found',0),(180433,5013,'is','',0),(180434,5013,'dr','(Ù…Ù†ØªÙ‚Ø¯ Ø§Ø¯Ø¨ÙŠ',0),(180435,5013,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ† (Ù…Ù†ØªÙ‚Ø¯ Ø§Ø¯Ø¨ÙŠ',0),(180436,5013,'tr','GÃ¶zden geÃ§irici',0),(180437,5013,'pl','Recenzent',0),(180438,5013,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐ²Ð°Ñ‰',0),(180439,5013,'ur','Ù…Ø¨ØµØ±',0),(180440,5013,'sr','Ð£Ñ€ÐµÐ´Ð½Ð¸Ðº',0),(180441,5013,'vi','NgÆ°á»i ÄÃ¡nh giÃ¡',0),(180442,5013,'af','Resensent',0),(180443,5013,'ro','Recenzent',0),(180444,5013,'et','Retsensent',0),(180445,5013,'si','Pregledovalec',0),(180446,5013,'ba','Resensi',0),(180447,5013,'nl','Revisor',0),(180448,5013,'fi','Tarkistaja',0),(180449,5013,'no','Korrekturleser',0),(180450,5013,'da','KorrekturlÃ¦ser',0),(180451,5013,'ko','ê²€í† ìž',0),(180452,5013,'he','×ž×‘×§×¨',0),(180453,5013,'el','ÎšÏÎ¹Ï„Î®Ï‚',0),(180454,5013,'zh','å¤å®¡äºº\r\n',0),(180455,5013,'sv','Granskare',0),(180456,5013,'it','Recensore',0),(180457,5013,'tl','',0),(180458,5013,'th','&#3612;&#3641;&#3657;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;',0),(180459,5013,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤•',0),(180460,5013,'ms','Pengulas',0),(180461,5013,'ar','Ø§Ù„Ù…Ø±Ø§Ø¬Ø¹',0),(180462,5013,'fr','Relecteur',0),(180463,5013,'jp','ç¢ºèª?è€…',0),(180464,5013,'pt','Revisor',0),(180465,5013,'ru','Ð ÐµÑ†ÐµÐ½Ð·ÐµÐ½Ñ‚',0),(180466,5013,'es','Revisor',0),(180467,5013,'de','Rezensent',0),(180468,5013,'en','Reviewer',0),(180469,5014,'is','',0),(180470,5014,'dr','7 Ø±ÙˆØ² Ø§Ø®ÙŠØ±',0),(180471,5014,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ù‡Ø§ÙŠ 7 Ø±ÙˆØ² Ø§Ø®ÙŠØ±',0),(180472,5014,'tr','Son Ä°ncelemeler: 7 gÃ¼n',0),(180473,5014,'pl','Najnowsze Recenzje: 7 dni',0),(180474,5014,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ð¾Ñ‚Ð·Ð¸Ð²Ð¸: 7 Ð´Ð½Ð¸',0),(180475,5014,'ur','Ø­Ø§Ù„ÛŒÛ Ø¬Ø§Ø¦Ø²Û: 7 Ø¯Ù†',0),(180476,5014,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ñ€ÐµÑ†ÐµÐ½Ð·Ð¸Ñ˜Ðµ: 7 Ð´Ð°Ð½Ð°',0),(180477,5014,'vi','BÃ¡o giÃ¡ gáº§n Ä‘Ã¢y: 7 ngÃ y',0),(180478,5014,'af','Onlangse Oorsig:  7 Dae',0),(180479,5014,'ro','Comentarii recente: 7 zile',0),(180480,5014,'et','Viimased kommentaarid: 7 pÃ¤eva',0),(180481,5014,'si','Nedavni gostov: 7 dni',0),(180482,5014,'ba','Recent ulasan: 7 hari',0),(180483,5014,'nl','Recente Reviews: 7 dagen',0),(180484,5014,'fi','Uusimmat arvostelut: 7 pÃ¤ivÃ¤Ã¤',0),(180485,5014,'no','Siste omtaler: 7 dager',0),(180486,5014,'da','De seneste anmeldelser: 7 dage',0),(180487,5014,'ko','ìµœê·¼ ë¦¬ë·°: 7 ì¼',0),(180488,5014,'he','×‘×™×§×•×¨×•×ª ××—×¨×•× ×•×ª: 7 ×™×ž×™×',0),(180489,5014,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ ÏƒÏ‡ÏŒÎ»Î¹Î±: 7 Î·Î¼Î­ÏÎµÏ‚',0),(180490,5014,'zh','æœ€è¿‘çš„å¤å®¡ï¼š7å¤©\r\n',0),(180491,5014,'sv','Senaste recensioner: 7 dagar',0),(180492,5014,'it','Recensioni recenti: 7 giorni',0),(180493,5014,'tl','',0),(180494,5014,'th','&#3618;&#3657;&#3629;&#3609;&#3627;&#3621;&#3633;&#3591;&#3652;&#3611;: 7 &#3623;&#3633;&#3609;',0),(180495,5014,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾: 7 à¤¦à¤¿à¤¨',0),(180496,5014,'ms','Hari Ulasan: 7 hari',0),(180497,5014,'ar','Ø§Ù„Ø§Ø³ØªØ¹Ø±Ø§Ø¶Ø§Øª Ø§Ù„ØªÙŠ Ø¬Ø±Øª Ù…Ø¤Ø®Ø±Ø§: 7 Ø£ÙŠØ§Ù…',0),(180498,5014,'fr','Commentaires rÃ©cents: 7 jours',0),(180499,5014,'jp','æœ€è¿‘ã?®ãƒ¬ãƒ“ãƒ¥ãƒ¼ï¼šï¼—æ—¥é–“',0),(180500,5014,'pt','ComentÃ¡rios recentes: 7 dias',0),(180501,5014,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¾Ñ‚Ð·Ñ‹Ð²Ñ‹: 7 Ð´Ð½ÐµÐ¹',0),(180502,5014,'es','Revisiones Recientes: 7 DÃ­as',0),(180503,5014,'de','Aktuelle Bewertungen: 7 Tage',0),(180504,5014,'en','Recent Reviews: 7 Days',0),(180505,5015,'is','',0),(180506,5015,'dr','Ù‡Ù…Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(180507,5015,'pr','Ù‡Ù…Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(180508,5015,'tr','TÃ¼m mÃ¼ÅŸteriler',0),(180509,5015,'pl','Wszyscy klienci',0),(180510,5015,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(180511,5015,'ur','ØªÙ…Ø§Ù… ØµØ§Ø±ÙÛŒÙ†',0),(180512,5015,'sr','Ð¡Ð²Ð¸ ÐºÑƒÐ¿Ñ†Ð¸',0),(180513,5015,'vi','Táº¥t Cáº£ KhÃ¡ch HÃ ng',0),(180514,5015,'af','Alle Klante/KliÃ«nte',0),(180515,5015,'ro','ToÅ£i clienÅ£ii',0),(180516,5015,'et','KÃµik kliendid',0),(180517,5015,'si','Vse stranke',0),(180518,5015,'ba','Semua pelanggan',0),(180519,5015,'nl','Alle klanten',0),(180520,5015,'fi','Kaikki asiakkaat',0),(180521,5015,'no','Alle kunder',0),(180522,5015,'da','Alle kunder',0),(180523,5015,'ko','ëª¨ë“  ê³ ê°',0),(180524,5015,'he','×›×œ ×”×œ×§×•×—×•×ª',0),(180525,5015,'el','ÎŒÎ»Î¿Î¹ Î¿Î¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(180526,5015,'zh','æ‰€æœ‰å®¢æˆ·\r\n',0),(180527,5015,'sv','Alla kunder',0),(180528,5015,'it','Tutti i clienti',0),(180529,5015,'tl','',0),(180530,5015,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(180531,5015,'hi','à¤¸à¤­à¥€ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(180532,5015,'ms','Semua pelanggan',0),(180533,5015,'ar','ÙƒØ§ÙØ© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(180534,5015,'fr','Tous les clients',0),(180535,5015,'jp','å…¨é¡§å®¢',0),(180536,5015,'pt','Todos os clientes',0),(180537,5015,'ru','Ð’ÑÐµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹',0),(180538,5015,'es','Todos los Clientes',0),(180539,5015,'de','Alle Kunden',0),(180540,5015,'en','All Customers',0),(180541,5016,'is','',0),(180542,5016,'dr','ØªØµÙˆÙŠØ± Ø¬Ø§Ø±ÙŠ',0),(180543,5016,'pr','ØªØµÙˆÙŠØ± Ø¬Ø§Ø±ÙŠ',0),(180544,5016,'tr','GeÃ§erli gÃ¶rÃ¼ntÃ¼',0),(180545,5016,'pl','BieÅ¼Ä…cy obraz',0),(180546,5016,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¾Ñ‚Ð¾ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(180547,5016,'ur','Ø­Ø§Ù„ÛŒÛ ØªØµÙˆÛŒØ±',0),(180548,5016,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ñƒ ÑÐ»Ð¸ÐºÑƒ',0),(180549,5016,'vi','HÃ¬nh áº£nh hiá»‡n thá»i ',0),(180550,5016,'af','Huidige beeld',0),(180551,5016,'ro','Imaginea curentÄƒ',0),(180552,5016,'et','Praegune pilt',0),(180553,5016,'si','Trenutna podoba',0),(180554,5016,'ba','Gambar saat ini',0),(180555,5016,'nl','Huidige afbeelding',0),(180556,5016,'fi','Nykyinen kuva',0),(180557,5016,'no','Gjeldende bilde',0),(180558,5016,'da','Aktuelle billede',0),(180559,5016,'ko','í˜„ìž¬ ì´ë¯¸ì§€',0),(180560,5016,'he','×”×ª×ž×•× ×” ×”× ×•×›×—×™×ª',0),(180561,5016,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎµÎ¹ÎºÏŒÎ½Î±',0),(180562,5016,'zh','å½“å‰å›¾åƒ\r\n',0),(180563,5016,'sv','Aktuell bild',0),(180564,5016,'it','Immagine corrente',0),(180565,5016,'tl','',0),(180566,5016,'th','&#3619;&#3641;&#3611;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(180567,5016,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤›à¤µà¤¿',0),(180568,5016,'ms','Imej semasa',0),(180569,5016,'ar','Ø§Ù„ØµÙˆØ±Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(180570,5016,'fr','Image courante',0),(180571,5016,'jp','ç?¾åœ¨ã?®ã‚¤ãƒ¡ãƒ¼ã‚¸',0),(180572,5016,'pt','Imagem atual',0),(180573,5016,'ru','Ð¢ÐµÐºÑƒÑ‰ÐµÐµ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(180574,5016,'es','Imagen Actual',0),(180575,5016,'de','Aktuelles Bild',0),(180576,5016,'en','Current Image',0),(180577,5017,'is','',0),(180578,5017,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ÙÙ‚Ø· Ø§Ú¯Ø± ØªØµÙˆÙŠØ± ØªØºÙŠÙŠØ± ÙƒØ±Ø¯',0),(180579,5017,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ÙÙ‚Ø· Ø§Ú¯Ø± ØªØµÙˆÙŠØ± ØªØºÙŠÙŠØ± ÙƒØ±Ø¯',0),(180580,5017,'tr','Sadece gÃ¶rÃ¼ntÃ¼de deÄŸiÅŸiklik seÃ§in',0),(180581,5017,'pl','NaleÅ¼y wybraÄ‡ tylko, jeÅ›li zmiana obrazu',0),(180582,5017,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÐŸÐ ÐžÐœÐ•ÐÐ˜Ð¢Ð• Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(180583,5017,'ur','Ø§Ú¯Ø± ØªØµÙˆÛŒØ± Ù…ÛŒÚº ØªØ¨Ø¯ÛŒÙ„ÛŒ ØµØ±Ù Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(180584,5017,'sr','Ð˜Ð·Ð°Ð±Ñ€Ð°Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÑÐµ Ð¼ÐµÑšÐ° ÑÐ»Ð¸ÐºÑƒ',0),(180585,5017,'vi','Chá»‰ Chá»n náº¿u thay Ä‘á»•i áº¥n tÆ°á»£ng',0),(180586,5017,'af','Kies slegs as beeld verander',0),(180587,5017,'ro','SelectaÅ£i numai dacÄƒ schimbarea imaginii',0),(180588,5017,'et','Valige ainult kui pildi muutmine',0),(180589,5017,'si','Samo izberite Äe spreminja podobo',0),(180590,5017,'ba','Hanya memilih jika mengubah gambar',0),(180591,5017,'nl','Alleen selecteren als afbeelding wijzigen',0),(180592,5017,'fi','Valitse vain, jos kuvan muuttaminen',0),(180593,5017,'no','Bare Velg hvis endre bilde',0),(180594,5017,'da','VÃ¦lg kun hvis Ã¦ndre billedet',0),(180595,5017,'ko','ì´ë¯¸ì§€ë¥¼ ë³€ê²½ í•˜ëŠ” ê²½ìš°ì— ì„ íƒ',0),(180596,5017,'he','×œ×‘×—×•×¨ ×¨×§ ×× ×©×™× ×•×™ ×ª×ž×•× ×”',0),(180597,5017,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼ÏŒÎ½Î¿ Î±Î½ Î‘Î›Î›Î†Î–Î•Î™ ÎµÎ¹ÎºÏŒÎ½Î±',0),(180598,5017,'zh','å¦‚æžœå½¢è±¡çš„å˜åŒ–ï¼Œåªæœ‰é€‰æ‹©\r\n',0),(180599,5017,'sv','VÃ¤lj endast om Ã¤ndra bilden',0),(180600,5017,'it','Selezionare solo se la modifica immagine',0),(180601,5017,'tl','',0),(180602,5017,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3619;&#3641;&#3611;&#3616;&#3634;&#3614;',0),(180603,5017,'hi','à¤•à¥‡à¤µà¤² à¤¯à¤¦à¤¿ à¤›à¤µà¤¿ à¤¬à¤¦à¤²à¤¨à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(180604,5017,'ms','Hanya Pilih jika menukar imej',0),(180605,5017,'ar','Ø­Ø¯Ø¯ ÙÙ‚Ø· ÙÙŠ Ø­Ø§Ù„Ø© ØªØºÙŠÙŠØ± Ø§Ù„ØµÙˆØ±Ø©',0),(180606,5017,'fr','SÃ©lectionnez uniquement si vous modifiez l\'Image',0),(180607,5017,'jp','ç”»åƒ?ã‚’å¤‰æ›´ã?™ã‚‹æ™‚ã?®ã?¿é?¸æŠž',0),(180608,5017,'pt','Selecione somente se mudar imagem',0),(180609,5017,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(180610,5017,'es','Solo Seleccionado si CAMBIANDO el Imagen',0),(180611,5017,'de','Nur wÃ¤hlen Sie aus, wenn Bild Ã¤ndern',0),(180612,5017,'en','Only Select If CHANGING Image',0),(180613,5018,'is','',0),(180614,5018,'dr','/ Ø§ØµÙ„Ø§Ø­  ÙŠÙƒ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(180615,5018,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / ÙˆÙŠØ±Ø§ÙŠØ´ ÙŠÙƒ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(180616,5018,'tr','Yeni oluÅŸturduÄŸunuz veya dÃ¼zenlediÄŸiniz taÅŸÄ±yÄ±cÄ± nakliye',0),(180617,5018,'pl','UtworzyÄ‡ lub edytowaÄ‡, przewoÅºnik',0),(180618,5018,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ Ð¸Ð»Ð¸ Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(180619,5018,'ur','Ù†ÛŒØ§ Ø¨Ù†Ø§Ø¦ÛŒÚº ÛŒØ§ ØªØ¯ÙˆÛŒÙ† Ú©ÛŒØ±ÛŒØ¦Ø± Ø´Ù¾Ù†Ú¯',0),(180620,5018,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ðµ Ð¸Ð»Ð¸ ÑƒÑ€ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾ÑÐ°Ñ‡ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(180621,5018,'vi','ThÃªm/Sá»­a Má»™t HÃ£ng TÃ u/MÃ¡y Bay',0),(180622,5018,'af','\'n Karweier Byvoeg/Redigeer ',0),(180623,5018,'ro','Adauga/Modifica un transportator',0),(180624,5018,'et','Lisa/muuda vedajat',0),(180625,5018,'si','Ustvari novo ali uredite ladijskega prevoznika',0),(180626,5018,'ba','Membuat baru atau mengedit pengiriman Carrier',0),(180627,5018,'nl','Nieuwe maken of bewerken verzending van vervoerder',0),(180628,5018,'fi','Luoda uusia tai muokata lÃ¤hetyksen rahdinkuljettaja',0),(180629,5018,'no','Opprette nye eller redigere frakt Carrier',0),(180630,5018,'da','Opret ny eller redigere Shipping transportvirksomhed',0),(180631,5018,'ko','ìƒˆë¡œ ë§Œë“¤ê¸° ë˜ëŠ” íŽ¸ì§‘ ìºë¦¬ì–´ í•´ìš´',0),(180632,5018,'he','×”×•×¡×£/×¢×¨×•×š ×—×‘×¨×ª ×©×œ×™×—×•×™×•×ª',0),(180633,5018,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î® ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î½Î±Ï…Ï„Î¹Î»Î¯Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(180634,5018,'zh','å¢žåŠ /ç¼–è¾‘è½½ä½“\r\n',0),(180635,5018,'sv','Skapa nya eller redigera frakt bÃ¤rare',0),(180636,5018,'it','Crea nuovo o modificare il vettore di spedizione',0),(180637,5018,'tl','',0),(180638,5018,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(180639,5018,'hi','à¤¨à¤¯à¤¾ à¤¬à¤¨à¤¾à¤à¤ à¤¯à¤¾ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¥ˆà¤°à¤¿à¤¯à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(180640,5018,'ms','Buat baru atau Edit penghantaran pembawa',0),(180641,5018,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¬Ø¯ÙŠØ¯ Ø£Ùˆ ØªØ­Ø±ÙŠØ± Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ Ø§Ù„Ù†Ø§Ù‚Ù„',0),(180642,5018,'fr','Ajouter/Modifier Transporteur',0),(180643,5018,'jp','é…?é€?æ¥­è€…ã?®è¿½åŠ /æ›´æ–°',0),(180644,5018,'pt','Criar novo ou editar transporte transportadora',0),(180645,5018,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐšÑƒÑ€ÑŒÐµÑ€Ð°',0),(180646,5018,'es','Agregar/Editar un Transportista',0),(180647,5018,'de','Neu erstellen Sie oder bearbeiten Sie, Versand',0),(180648,5018,'en','Create New or Edit Shipping Carrier',0),(180649,5019,'is','',0),(180650,5019,'dr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø§Ø±ÙŠ Ø¨Ù‡ ÙŠÙƒ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(180651,5019,'pr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø§Ø±ÙŠ Ø¨Ù‡ ÙŠÙƒ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(180652,5019,'tr','Bir taÅŸÄ±yÄ±cÄ± geÃ§erli satÄ±cÄ± yapmak',0),(180653,5019,'pl','ZrobiÄ‡ bieÅ¼Ä…cego dostawcy przewoÅºnika',0),(180654,5019,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ñ‚ÐµÐºÑƒÑ‰Ð¸Ñ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(180655,5019,'ur','Ø­Ø§Ù„ÛŒÛ ÙˆÛŒÙ†ÚˆØ± Ø§ÛŒÚ© Ú©ÛŒØ±ÛŒØ¦Ø± Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(180656,5019,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð½Ð¾ÑÐ¸Ð»Ð°Ñ†',0),(180657,5019,'vi','Chuyá»ƒn ngÆ°á»i bÃ¡n hiá»‡n thá»i thÃ nh hÃ£ng váº­n chuyá»ƒn',0),(180658,5019,'af','Maak Huidige Verskaffer \'n Karweier',0),(180659,5019,'ro','Face curent furnizor un operator de transport',0),(180660,5019,'et','Vormista kÃ¤esolev tanija vedajaks',0),(180661,5019,'si','Bi trenutni dobavitelj prevoznik',0),(180662,5019,'ba','Membuat saat ini Vendor pembawa',0),(180663,5019,'nl','Maken van huidige leverancier een vervoerder',0),(180664,5019,'fi','Tee DHCP harjoittaja',0),(180665,5019,'no','GjÃ¸re gjeldende tilbyder en operatÃ¸r',0),(180666,5019,'da','GÃ¸re aktuel kreditor en transportÃ¸r',0),(180667,5019,'ko','í™•ì¸ í˜„ìž¬ ê³µê¸‰ ì—…ì²´ëŠ” ì´ë™ í†µì‹ ì‚¬',0),(180668,5019,'he','×œ×”×¤×•×š ××ª ×”×¡×¤×§ ×”× ×•×›×—×™ × ×©××™×ª',0),(180669,5019,'el','ÎšÎ¬Î½Î¿Ï…Î½ Ï„ÏÎ­Ï‡Î¿Î½Ï„Î¿Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÎµÎ½ÏŒÏ‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(180670,5019,'zh','ä½¿å½“å‰ä¾›åº”å•†ä¸€ä¸ªæ‰¿è¿å•†\r\n',0),(180671,5019,'sv','GÃ¶r aktuell leverantÃ¶r en Carrier',0),(180672,5019,'it','Rendere corrente fornitore un vettore',0),(180673,5019,'tl','',0),(180674,5019,'th','&#3607;&#3635;&#3651;&#3627;&#3657;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3651;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3648;&#3611;&#3655;&#3609;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(180675,5019,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤à¤• à¤µà¤¾à¤¹à¤• à¤¬à¤¨à¤¾à¤¨à¥‡',0),(180676,5019,'ms','Membuat penjual semasa sebuah pesawat',0),(180677,5019,'ar','Ø¬Ø¹Ù„ Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„Ø­Ø§Ù„ÙŠ Ø§Ù„Ù†Ø§Ù‚Ù„',0),(180678,5019,'fr','Faire vendeur actuel un transporteur',0),(180679,5019,'jp','ç?¾åœ¨ã?®æ¥­è€…ã‚’é…?é€?æ¥­è€…ã?«ã?™ã‚‹',0),(180680,5019,'pt','Fazer o fornecedor atual um portador',0),(180681,5019,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð¢ÐµÐºÑƒÑ‰ÐµÐ³Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° ÐšÑƒÑ€ÑŒÐµÑ€Ð¾Ð¼',0),(180682,5019,'es','Hacer el Proveedor Actual a un Transportador',0),(180683,5019,'de','Machen Sie aktuelle Anbieter TrÃ¤ger',0),(180684,5019,'en','Make Current Vendor a Carrier',0),(180685,5020,'is','',0),(180686,5020,'dr',': 7 Ø±ÙˆØ²Ù‡ ',0),(180687,5020,'pr','ÙØ±ÙˆØ´ : 7 Ø±ÙˆØ²Ù‡ ',0),(180688,5020,'tr','SatÄ±ÅŸ: 7 gÃ¼n',0),(180689,5020,'pl','SprzedaÅ¼: 7 dni',0),(180690,5020,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸: 7 Ð´Ð½Ð¸',0),(180691,5020,'ur','Ø³ÛŒÙ„Ø²: 7 Ø¯Ù†',0),(180692,5020,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° : 7 Ð´Ð°Ð½Ð°',0),(180693,5020,'vi','Doanh sá»‘: 7 ngÃ y ',0),(180694,5020,'af','Verkope:  7 Dae',0),(180695,5020,'ro','VÃ¢nzÄƒri: 7 zile',0),(180696,5020,'et','MÃ¼Ã¼k: 7 pÃ¤eva',0),(180697,5020,'si','Prodaja: 7 dni',0),(180698,5020,'ba','Penjualan: 7 hari',0),(180699,5020,'nl','Verkoop: 7 dagen',0),(180700,5020,'fi','Myynti: 7 pÃ¤ivÃ¤Ã¤',0),(180701,5020,'no','Salg: 7 dager',0),(180702,5020,'da','Salg: 7 dage',0),(180703,5020,'ko','íŒë§¤: 7 ì¼',0),(180704,5020,'he','×ž×›×™×¨×•×ª: 7 ×™×ž×™×',0),(180705,5020,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚: 7 Î·Î¼Î­ÏÎµÏ‚',0),(180706,5020,'zh','é”€å”®ï¼š7å¤©\r\n',0),(180707,5020,'sv','FÃ¶rsÃ¤ljning: 7 dagar',0),(180708,5020,'it','Vendite: 7 giorni',0),(180709,5020,'tl','',0),(180710,5020,'th','&#3585;&#3634;&#3619;&#3586;&#3634;&#3618; : 7 &#3623;&#3633;&#3609;',0),(180711,5020,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€: 7 à¤¦à¤¿à¤¨',0),(180712,5020,'ms','Jualan: 7 hari',0),(180713,5020,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª: 7 Ø£ÙŠØ§Ù…',0),(180714,5020,'fr','Ventes: 7 jours',0),(180715,5020,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ï¼šï¼—æ—¥é–“',0),(180716,5020,'pt','Vendas: 7 dias',0),(180717,5020,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸: 7 Ð”Ð½ÐµÐ¹',0),(180718,5020,'es','Ventas: 7 DÃ­as',0),(180719,5020,'de','Umsatz: 7 Tage',0),(180720,5020,'en','Sales: 7 Days',0),(180721,5021,'is','',0),(180722,5021,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(180723,5021,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(180724,5021,'tr','Son gÃ¼nlÃ¼k giriÅŸleri',0),(180725,5021,'pl','Ostatnie wpisy do dziennika',0),(180726,5021,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ð²Ð»Ð¸Ð·Ð°Ð½Ð¸Ñ Ð²ÐµÑÑ‚Ð½Ð¸Ðº',0),(180727,5021,'ur','Ø­Ø§Ù„ÛŒÛ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(180728,5021,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ',0),(180729,5021,'vi','BÃºt toÃ¡n Ä‘á»‹nh ká»³ gáº§n Ä‘Ã¢y',0),(180730,5021,'af','Onlangse Joernaalinskrywings',0),(180731,5021,'ro','Recente intrÄƒri Ã®n jurnal',0),(180732,5021,'et','Viimased pÃ¤evikukirje',0),(180733,5021,'si','Nedavne postavk temeljnice',0),(180734,5021,'ba','Tanggal entri jurnal',0),(180735,5021,'nl','Recente logboekitems',0),(180736,5021,'fi','Viimeaikaiset pÃ¤ivÃ¤kirjamerkinnÃ¤t',0),(180737,5021,'no','Siste loggoppfÃ¸ringer',0),(180738,5021,'da','Seneste journaloptegnelser',0),(180739,5021,'ko','ìµœê·¼ ì—…ë¬´ ì¼ì§€ í•­ëª©',0),(180740,5021,'he','×¢×¨×›×™ ×™×•×ž×Ÿ ××—×¨×•× ×™×',0),(180741,5021,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ ÎµÏ†Î·Î¼ÎµÏÎ¯Î´Î±',0),(180742,5021,'zh','æœ€è¿‘çš„æ—¥å¿—æ¡ç›®\r\n',0),(180743,5021,'sv','Senaste journalposter',0),(180744,5021,'it','Recenti voci di diario',0),(180745,5021,'tl','',0),(180746,5021,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634;',0),(180747,5021,'hi','à¤¹à¤¾à¤² à¤•à¥‡ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤‚',0),(180748,5021,'ms','Hari catatan jurnal',0),(180749,5021,'ar','Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ© Ø§Ù„Ø­Ø¯ÙŠØ«Ø©',0),(180750,5021,'fr','DerniÃ¨res entrÃ©es du Journal',0),(180751,5021,'jp','æœ€è¿‘ã?®ã‚¸ãƒ£ãƒ¼ãƒŠãƒ«å…¥åŠ›',0),(180752,5021,'pt','Recentes entradas de diÃ¡rio',0),(180753,5021,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ',0),(180754,5021,'es','Entradas de Diario Reciente',0),(180755,5021,'de','Aktuelle JournaleintrÃ¤ge',0),(180756,5021,'en','Recent Journal Entries',0),(180757,5022,'is','',0),(180758,5022,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(180759,5022,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(180760,5022,'tr','GÃ¶rÃ¼ntÃ¼leme gÃ¼nlÃ¼kleri',0),(180761,5022,'pl','Zobacz arkusze',0),(180762,5022,'bg','Ð”Ð½ÐµÐ²Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ð¸Ð·Ð³Ð»ÐµÐ´',0),(180763,5022,'ur','Ù…Ù†Ø¸Ø± Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û’',0),(180764,5022,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð½Ð°Ð»Ð¾Ð³Ð°',0),(180765,5022,'vi','Xem Ä‘á»‹nh ká»³',0),(180766,5022,'af','Besigtig Joernale',0),(180767,5022,'ro','Vezi reviste',0),(180768,5022,'et','Vaadata tÃ¶Ã¶lehti',0),(180769,5022,'si','Ogled revije',0),(180770,5022,'ba','Lihat jurnal',0),(180771,5022,'nl','Weergave tijdschriften',0),(180772,5022,'fi','NÃ¤ytÃ¤ kirjauskansiot',0),(180773,5022,'no','Vis journaler',0),(180774,5022,'da','Se kladder',0),(180775,5022,'ko','ë³´ê¸° ì €ë„',0),(180776,5022,'he','×”×¦×’ ×™×•×ž× ×™×',0),(180777,5022,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€ÎµÏÎ¹Î¿Î´Î¹ÎºÎ¬',0),(180778,5022,'zh','æŸ¥çœ‹æ—¥å¿—\r\n',0),(180779,5022,'sv','Visa journaler',0),(180780,5022,'it','Vista riviste',0),(180781,5022,'tl','',0),(180782,5022,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(180783,5022,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤ªà¤¤à¥à¤°à¤¿à¤•à¤¾à¤“à¤‚',0),(180784,5022,'ms','Jurnal View',0),(180785,5022,'ar','Ø¹Ø±Ø¶ Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(180786,5022,'fr','Vue revues',0),(180787,5022,'jp','ã‚¸ãƒ£ãƒ¼ãƒŠãƒ«ã?®è¡¨ç¤º',0),(180788,5022,'pt','Ver revistas',0),(180789,5022,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð–ÑƒÑ€Ð½Ð°Ð»Ð¾Ð²',0),(180790,5022,'es','Visionar Diarios',0),(180791,5022,'de','Anzeigen Zeitschriften',0),(180792,5022,'en','View Journals',0),(180793,5023,'is','',0),(180794,5023,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙØ±ÙˆØ´ ',0),(180795,5023,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙØ±ÙˆØ´ ',0),(180796,5023,'tr','SatÄ±ÅŸ raporu',0),(180797,5023,'pl','Raport sprzedaÅ¼y',0),(180798,5023,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(180799,5023,'ur','Ø³ÛŒÙ„Ø² Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(180800,5023,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¸',0),(180801,5023,'vi','BÃ¡o cÃ¡o bÃ¡n hÃ ng',0),(180802,5023,'af','Verkoopsverslag',0),(180803,5023,'ro','Raport de vÃ¢nzÄƒri',0),(180804,5023,'et','MÃ¼Ã¼giraport',0),(180805,5023,'si','PoroÄilo o prodaji',0),(180806,5023,'ba','Laporan penjualan',0),(180807,5023,'nl','Omzetrapport',0),(180808,5023,'fi','Myyntiraportti',0),(180809,5023,'no','Salgsrapport',0),(180810,5023,'da','Salgsrapport',0),(180811,5023,'ko','íŒë§¤ ë³´ê³ ì„œ',0),(180812,5023,'he','×“×• ×— ×ž×›×™×¨×•×ª',0),(180813,5023,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(180814,5023,'zh','é”€å”®æŠ¥å‘Š\r\n',0),(180815,5023,'sv','FÃ¶rsÃ¤ljningsrapport',0),(180816,5023,'it','Report delle vendite',0),(180817,5023,'tl','',0),(180818,5023,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(180819,5023,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(180820,5023,'ms','Laporan jualan',0),(180821,5023,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(180822,5023,'fr','Rapport des ventes',0),(180823,5023,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(180824,5023,'pt','RelatÃ³rio de vendas',0),(180825,5023,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ðž ÐŸÑ€Ð¾Ð´Ð°Ð¶Ðµ',0),(180826,5023,'es','Informe de Ventas',0),(180827,5023,'de','Umsatzbericht',0),(180828,5023,'en','Sales Report',0),(180829,5024,'is','',0),(180830,5024,'dr','Ù†Ù…Ø§ÙŠØ´ ÙØ¹Ø§Ù„ÙŠØª Ø­Ø³Ø§Ø¨ ',0),(180831,5024,'pr','Ù†Ù…Ø§ÙŠØ´ ÙØ¹Ø§Ù„ÙŠØª Ø­Ø³Ø§Ø¨ ',0),(180832,5024,'tr','Hesap etkinliÄŸi gÃ¶rÃ¼ntÃ¼le',0),(180833,5024,'pl','Zobacz aktywnoÅ›Ä‡ konta',0),(180834,5024,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ ÑÐ¼ÐµÑ‚ÐºÐ° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(180835,5024,'ur','Ù…Ù†Ø¸Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(180836,5024,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(180837,5024,'vi','Xem Hoáº¡t Äá»™ng TK',0),(180838,5024,'af','Besigtig Rekening Aktiwiteit',0),(180839,5024,'ro','Activitate de cont Vezi',0),(180840,5024,'et','Vaata konto tegevusi',0),(180841,5024,'si','Ogled raÄun dejavnosti',0),(180842,5024,'ba','Lihat aktivitas akun',0),(180843,5024,'nl','Bekijk accountactiviteit',0),(180844,5024,'fi','Katsella tili aktiivisuus',0),(180845,5024,'no','Vis kontoaktivitet',0),(180846,5024,'da','Se kontoaktivitet',0),(180847,5024,'ko','ê³„ì • í™œë™ ë³´ê¸°',0),(180848,5024,'he','×¤×¢×™×œ×•×ª ×”×—×©×‘×•×Ÿ ×ª×¦×•×’×”',0),(180849,5024,'el','Î ÏÎ¿Î²Î¿Î»Î® Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(180850,5024,'zh','æŸ¥çœ‹å¸æˆ·æ´»åŠ¨\r\n',0),(180851,5024,'sv','Visa kontoaktivitet',0),(180852,5024,'it','Visualizza conto attivitÃ ',0),(180853,5024,'tl','',0),(180854,5024,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(180855,5024,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(180856,5024,'ms','Lihat akaun aktiviti',0),(180857,5024,'ar','Ø¹Ø±Ø¶ Ø­Ø±ÙƒØ© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(180858,5024,'fr','Voir les activitÃ©s des comptes',0),(180859,5024,'jp','å?£åº§å…¥å‡ºé‡‘ã‚’è¦‹ã‚‹',0),(180860,5024,'pt','Exibir conta atividade',0),(180861,5024,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ ÐŸÑ€Ð¾Ñ„Ð¸Ð»Ñ',0),(180862,5024,'es','Visionar Actividad de Cuenta',0),(180863,5024,'de','KontoaktivitÃ¤ten anzeigen',0),(180864,5024,'en','View Account Activity',0),(180865,5025,'is','',0),(180866,5025,'dr',': 7 Ø±ÙˆØ² ',0),(180867,5025,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ : 7 Ø±ÙˆØ² ',0),(180868,5025,'tr','GÃ¼nlÃ¼k giriÅŸleri: 7 gÃ¼n',0),(180869,5025,'pl','Wpisy do dziennika: 7 dni',0),(180870,5025,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°: 7 Ð´Ð½Ð¸',0),(180871,5025,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª: 7 Ø¯Ù†',0),(180872,5025,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ: 7 Ð´Ð°Ð½Ð°',0),(180873,5025,'vi','BÃºt toÃ¡n: 7 ngÃ y',0),(180874,5025,'af','Joernaalinskrywings:  7 Dae',0),(180875,5025,'ro','IntrÄƒri Ã®n jurnal: 7 zile',0),(180876,5025,'et','TÃ¶Ã¶lehe kanded: 7 pÃ¤eva',0),(180877,5025,'si','Dnevnik: 7 dni',0),(180878,5025,'ba','Entri jurnal: 7 hari',0),(180879,5025,'nl','Logboekitems: 7 dagen',0),(180880,5025,'fi','PÃ¤ivyrimerkintÃ¶jen: 7 pÃ¤ivÃ¤Ã¤',0),(180881,5025,'no','LoggoppfÃ¸ringer: 7 dager',0),(180882,5025,'da','Journaloptegnelser: 7 dage',0),(180883,5025,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª©: 7 ì¼',0),(180884,5025,'he','×¤×§×•×“×•×ª ×™×•×ž×Ÿ: 7 ×™×ž×™×',0),(180885,5025,'el','Î—Î¼ÎµÏÎ¿Î»Î¿Î³Î¹Î±ÎºÎ­Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚: 7 Î·Î¼Î­ÏÎµÏ‚',0),(180886,5025,'zh','æ—¥è®°å¸åˆ†å½•ï¼š7å¤©\r\n',0),(180887,5025,'sv','Journalposter: 7 dagar',0),(180888,5025,'it','Le voci del diario: 7 giorni',0),(180889,5025,'tl','',0),(180890,5025,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;: 7 &#3623;&#3633;&#3609;',0),(180891,5025,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤: 7 à¤¦à¤¿à¤¨',0),(180892,5025,'ms','Catatan jurnal: 7 hari',0),(180893,5025,'ar','Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ© : 7 Ø£ÙŠØ§Ù…',0),(180894,5025,'fr','Les entrÃ©es de journal: 7 jours',0),(180895,5025,'jp','ã‚¸ãƒ£ãƒ¼ãƒŠãƒ«å…¥åŠ›ï¼šï¼—æ—¥é–“',0),(180896,5025,'pt','Entradas de diÃ¡rio: 7 dias',0),(180897,5025,'ru','Ð—Ð°Ð¿Ð¸ÑÐµÐ¹ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ: 7 Ð´Ð½ÐµÐ¹',0),(180898,5025,'es','Entradas al Diario: 7 DÃ­as',0),(180899,5025,'de','Tagebuch-EintrÃ¤ge: 7 Tage',0),(180900,5025,'en','Journal Entries: 7 Days',0),(180901,5026,'is','',0),(180902,5026,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø­Ø³Ø§Ø¨Ù‡Ø§',0),(180903,5026,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø­Ø³Ø§Ø¨Ù‡Ø§',0),(180904,5026,'tr','Toplam hesaplarÄ±',0),(180905,5026,'pl','Konta sumy',0),(180906,5026,'bg','ÐžÐ±Ñ‰Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(180907,5026,'ur','Ú©Ù„ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(180908,5026,'sr','Ð—Ð±Ð¸Ñ€Ð½Ð° ÐºÐ¾Ð½Ñ‚Ð°',0),(180909,5026,'vi','Táº¥t Cáº£ TK',0),(180910,5026,'af','Totale Rekeninge',0),(180911,5026,'ro','Total conturi',0),(180912,5026,'et','Kontod',0),(180913,5026,'si','Kontov',0),(180914,5026,'ba','Total account',0),(180915,5026,'nl','Totale Accounts',0),(180916,5026,'fi','Yhteissumma',0),(180917,5026,'no','Totalkontoer',0),(180918,5026,'da','Samlede konti',0),(180919,5026,'ko','ì´ ê³„ì •',0),(180920,5026,'he','×¡×” ×› ×—×©×‘×•× ×•×ª',0),(180921,5026,'el','Î›Î¿Î³. ÏƒÏ…Î½ÏŒÎ»Ï‰Î½',0),(180922,5026,'zh','æ€»å¸ç›®\r\n',0),(180923,5026,'sv','Totala konton',0),(180924,5026,'it','Totale conti',0),(180925,5026,'tl','',0),(180926,5026,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(180927,5026,'hi','à¤•à¥à¤² à¤–à¤¾à¤¤à¥‡',0),(180928,5026,'ms','Jumlah akaun',0),(180929,5026,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø­Ø³Ø§Ø¨Ø§Øª',0),(180930,5026,'fr','Total des comptes',0),(180931,5026,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆå?ˆè¨ˆ',0),(180932,5026,'pt','Total de contas',0),(180933,5026,'ru','Ð’ÑÐµÐ³Ð¾ Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ð¾Ð²',0),(180934,5026,'es','Cuentas Totales ',0),(180935,5026,'de','Summenkonten',0),(180936,5026,'en','Total Accounts',0),(180937,5027,'is','',0),(180938,5027,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙˆØ¯',0),(180939,5027,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙˆØ¯',0),(180940,5027,'tr','Kar raporu',0),(180941,5027,'pl','Raport zysk',0),(180942,5027,'bg','Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ°Ñ‚Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(180943,5027,'ur','Ù…Ù†Ø§ÙØ¹ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(180944,5027,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð° Ð”Ð¾Ð±Ð¸Ñ‚',0),(180945,5027,'vi','BÃ¡o cÃ¡o lá»£i nhuáº­n',0),(180946,5027,'af','Wins Verslag',0),(180947,5027,'ro','Raportul de profit',0),(180948,5027,'et','Kasumi aruanne',0),(180949,5027,'si','DobiÄek poroÄilo',0),(180950,5027,'ba','Laporan laba',0),(180951,5027,'nl','Winst verslag',0),(180952,5027,'fi','Voitto raportti',0),(180953,5027,'no','Resultat rapport',0),(180954,5027,'da','Profit rapport',0),(180955,5027,'ko','ìˆ˜ìµ ë³´ê³ ì„œ',0),(180956,5027,'he','×“×•×— ×¨×•×•×—',0),(180957,5027,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î¿Ï… ÎºÎ­ÏÎ´Î¿Ï…Ï‚',0),(180958,5027,'zh','ç›ˆåˆ©æŠ¥å‘Š\r\n',0),(180959,5027,'sv','Vinst rapport',0),(180960,5027,'it','Relazione di profitto',0),(180961,5027,'tl','',0),(180962,5027,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3635;&#3652;&#3619;',0),(180963,5027,'hi','à¤²à¤¾à¤­ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(180964,5027,'ms','Laporan keuntungan',0),(180965,5027,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø£Ø±Ø¨Ø§Ø­',0),(180966,5027,'fr','Rapport de profit',0),(180967,5027,'jp','å?Žç›Šãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(180968,5027,'pt','RelatÃ³rio de lucro',0),(180969,5027,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(180970,5027,'es','Informe de utilidad',0),(180971,5027,'de','Gewinnbericht',0),(180972,5027,'en','Profit Report',0),(180973,5028,'is','',0),(180974,5028,'dr','Ù‡Ø²Ø§Ø±Ø§Ù† Ø¯Ù„Ø§Ø± ',0),(180975,5028,'pr','Ù‡Ø²Ø§Ø±Ø§Ù† Ø¯Ù„Ø§Ø± ',0),(180976,5028,'tr','Thousandes dolar',0),(180977,5028,'pl','DolarÃ³w w Thousandes',0),(180978,5028,'bg','Ð”Ð¾Ð»Ð°Ñ€Ð° Ð² Thousandes',0),(180979,5028,'ur','ØªÙˆÙˆØ³Ø§Ù†ÚˆØ³ Ù…ÛŒÚº ÚˆØ§Ù„Ø±',0),(180980,5028,'sr','Ð”Ð¾Ð»Ð°Ñ€Ð° Ñƒ Ð¢Ñ…Ð¾ÑƒÑÐ°Ð½Ð´ÐµÑ',0),(180981,5028,'vi','Dolla hÃ ng ngÃ n',0),(180982,5028,'af','Dollers in Duisende',0),(180983,5028,'ro','Dolari Ã®n Thousandes',0),(180984,5028,'et','Dollarit Thousandes',0),(180985,5028,'si','Dolarjev v Thousandes',0),(180986,5028,'ba','Dolar Thousandes',0),(180987,5028,'nl','Dollars in Thousandes',0),(180988,5028,'fi','Dollarin Thousandes',0),(180989,5028,'no','Dollar i Thousandes',0),(180990,5028,'da','Dollars i Thousandes',0),(180991,5028,'ko','Thousandes ë‹¬ëŸ¬',0),(180992,5028,'he','×“×•×œ×¨ Thousandes',0),(180993,5028,'el','Î”Î¿Î»Î¬ÏÎ¹Î± ÏƒÎµ Thousandes',0),(180994,5028,'zh','åƒç¾Žå…ƒ\r\n',0),(180995,5028,'sv','Dollar i Thousandes',0),(180996,5028,'it','Dollari in Thousandes',0),(180997,5028,'tl','',0),(180998,5028,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3651;&#3609;&#3614;&#3633;&#3609;',0),(180999,5028,'hi','Thousandes à¤®à¥‡à¤‚ à¤¡à¥‰à¤²à¤°',0),(181000,5028,'ms','Dolar dalam Thousandes',0),(181001,5028,'ar','Ø¯ÙˆÙ„Ø§Ø± Ø£Ù…Ø±ÙŠÙƒÙŠ ÙÙŠ Ø«ÙˆØ³Ø§Ù†Ø¯ÙŠØ³',0),(181002,5028,'fr','En milliers de dollars',0),(181003,5028,'jp','ãƒ‰ãƒ«ï¼ˆå?ƒå?˜ä½?ï¼‰',0),(181004,5028,'pt','DÃ³lares em Thousandes',0),(181005,5028,'ru','Ð”Ð¾Ð»Ð»Ð°Ñ€Ð¾Ð² Ð² Thousandes',0),(181006,5028,'es','DÃ³lares en Miles',0),(181007,5028,'de','US-Dollar in Thousandes',0),(181008,5028,'en','Dollars in Thousandes',0),(181009,5029,'is','',0),(181010,5029,'dr',': 12 Ù…Ø§Ù‡Ù‡',0),(181011,5029,'pr','ÙØ±ÙˆØ´ : 12 Ù…Ø§Ù‡Ù‡',0),(181012,5029,'tr','SatÄ±ÅŸ: 12 ay',0),(181013,5029,'pl','SprzedaÅ¼y: 12 miesiÄ™cy',0),(181014,5029,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸: 12 Ð¼ÐµÑÐµÑ†Ð°',0),(181015,5029,'ur','Ø³ÛŒÙ„Ø²: 12 Ù…Ø§Û',0),(181016,5029,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° : 12 Ð¼ÐµÑÐµÑ†Ð¸',0),(181017,5029,'vi','Doanh sá»‘: 12 thÃ¡ng',0),(181018,5029,'af','Verkope:  12 Maande',0),(181019,5029,'ro','VÃ¢nzÄƒri: 12 luni',0),(181020,5029,'et','MÃ¼Ã¼k: 12 kuu',0),(181021,5029,'si','Prodaja: 12 mesecev',0),(181022,5029,'ba','Penjualan: 12 bulan',0),(181023,5029,'nl','Verkoop: 12 maanden',0),(181024,5029,'fi','Myynti: 12 kuukautta',0),(181025,5029,'no','Salg: 12 mÃ¥neder',0),(181026,5029,'da','Salg: 12 mÃ¥neder',0),(181027,5029,'ko','íŒë§¤: 12 ê°œì›”',0),(181028,5029,'he','×ž×›×™×¨×•×ª: 12 ×—×•×“×©',0),(181029,5029,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚: 12 Î¼Î·Î½ÏŽÎ½',0),(181030,5029,'zh','é”€å”®ï¼š12ä¸ªæœˆ\r\n',0),(181031,5029,'sv','FÃ¶rsÃ¤ljning: 12 mÃ¥nader',0),(181032,5029,'it','Vendite: 12 mesi',0),(181033,5029,'tl','',0),(181034,5029,'th','&#3585;&#3634;&#3619;&#3586;&#3634;&#3618; : 12 &#3648;&#3604;&#3639;&#3629;&#3609;',0),(181035,5029,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€: 12 à¤®à¤¹à¥€à¤¨à¥‡',0),(181036,5029,'ms','Jualan: bulan 12',0),(181037,5029,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª: 12 Ø´Ù‡Ø±',0),(181038,5029,'fr','Chiffre d\'affaires : 12 mois',0),(181039,5029,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ï¼šï¼‘ï¼’ãƒ¶æœˆ',0),(181040,5029,'pt','Vendas: 12 meses',0),(181041,5029,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸: 12 ÐœÐµÑÑÑ†ÐµÐ²',0),(181042,5029,'es','Ventas: 12 Meses',0),(181043,5029,'de','Umsatz: 12 Monate',0),(181044,5029,'en','Sales: 12 Month',0),(181045,5030,'is','',0),(181046,5030,'dr',': 8 Ù‡ÙØªÙ‡',0),(181047,5030,'pr','ÙØ±ÙˆØ´ : 8 Ù‡ÙØªÙ‡',0),(181048,5030,'tr','SatÄ±ÅŸ: 8 hafta',0),(181049,5030,'pl','SprzedaÅ¼y: 8 tygodni',0),(181050,5030,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸: 8 ÑÐµÐ´Ð¼Ð¸Ñ†Ð¸',0),(181051,5030,'ur','Ø³ÛŒÙ„Ø²: 8 ÛÙØªÙˆÚº',0),(181052,5030,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° : 8 Ð½ÐµÐ´ÐµÑ™Ð°',0),(181053,5030,'vi','Doanh sá»‘: 8 Tuáº§n',0),(181054,5030,'af','Verkope:  8 Weke',0),(181055,5030,'ro','VÃ¢nzÄƒri: 8 saptamani',0),(181056,5030,'et','MÃ¼Ã¼k: 8 nÃ¤dalat',0),(181057,5030,'si','Prodaja: 8 tednov',0),(181058,5030,'ba','Penjualan: 8 minggu',0),(181059,5030,'nl','Verkoop: 8 weken',0),(181060,5030,'fi','Myynti: 8 viikkoa',0),(181061,5030,'no','Salg: 8 uker',0),(181062,5030,'da','Salg: 8 uger',0),(181063,5030,'ko','íŒë§¤: 8 ì£¼',0),(181064,5030,'he','×ž×›×™×¨×•×ª: 8 ×©×‘×•×¢×•×ª',0),(181065,5030,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚: 8 ÎµÎ²Î´Î¿Î¼Î¬Î´ÎµÏ‚',0),(181066,5030,'zh','é”€å”®ï¼š8å‘¨\r\n',0),(181067,5030,'sv','FÃ¶rsÃ¤ljning: 8 veckor',0),(181068,5030,'it','Vendite: 8 settimane',0),(181069,5030,'tl','',0),(181070,5030,'th','&#3585;&#3634;&#3619;&#3586;&#3634;&#3618; : 8 &#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(181071,5030,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€: 8 à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(181072,5030,'ms','Jualan: 8 minggu',0),(181073,5030,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª: 8 Ø£Ø³Ø§Ø¨ÙŠØ¹',0),(181074,5030,'fr','Ventes: 8 semaines',0),(181075,5030,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ï¼šï¼˜ã‚±æœˆ',0),(181076,5030,'pt','Vendas: 8 semanas',0),(181077,5030,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸: 8 ÐÐµÐ´ÐµÐ»ÑŒ',0),(181078,5030,'es','Ventas: 8 Semanas',0),(181079,5030,'de','Umsatz: 8 Wochen',0),(181080,5030,'en','Sales: 8 Weeks',0),(181081,5031,'is','',0),(181082,5031,'dr','/ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§  : 12 Ù…Ø§Ù‡Ù‡',0),(181083,5031,'pr','ÙØ±ÙˆØ´ Ù‡Ø§/ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§  : 12 Ù…Ø§Ù‡Ù‡',0),(181084,5031,'tr','SatÄ±ÅŸ/giderleri: 12 ay',0),(181085,5031,'pl','SprzedaÅ¼y/koszty: 12 miesiÄ™cy',0),(181086,5031,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸/Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸: 12 Ð¼ÐµÑÐµÑ†Ð°',0),(181087,5031,'ur','Ø³ÛŒÙ„Ø² Ø§Ø®Ø±Ø§Ø¬Ø§Øª: 12 Ù…Ø§Û',0),(181088,5031,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° /Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ : 12 Ð¼ÐµÑÐµÑ†Ð¸',0),(181089,5031,'vi','Doanh thu/chi phÃ­: 12 thÃ¡ng',0),(181090,5031,'af','Verkope/Uitgawes:  12 Maande',0),(181091,5031,'ro','VÃ¢nzÄƒri/cheltuieli: 12 luni',0),(181092,5031,'et','MÃ¼Ã¼k/kulud: 12 kuu',0),(181093,5031,'si','Prodaja/stroÅ¡ki: 12 mesecev',0),(181094,5031,'ba','Penjualan/biaya: 12 bulan',0),(181095,5031,'nl','Verkoop/kosten: 12 maanden',0),(181096,5031,'fi','Myynti/kulut: 12 kuukautta',0),(181097,5031,'no','Salg/utgifter: 12 mÃ¥neder',0),(181098,5031,'da','Salg/omkostninger: 12 mÃ¥neder',0),(181099,5031,'ko','ë§¤ì¶œ/ë¹„ìš©: 12 ê°œì›”',0),(181100,5031,'he','×ž×›×™×¨×•×ª/×”×•×¦××•×ª: 12 ×—×•×“×©×™×',0),(181101,5031,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚/Î­Î¾Î¿Î´Î±: 12 Î¼Î·Î½ÏŽÎ½',0),(181102,5031,'zh','é”€å”®/è´¹ç”¨ï¼š12ä¸ªæœˆ\r\n',0),(181103,5031,'sv','FÃ¶rsÃ¤ljning/kostnader: 12 mÃ¥nader',0),(181104,5031,'it','Vendite/spese: 12 mesi',0),(181105,5031,'tl','',0),(181106,5031,'th','&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;/&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618; : 12 &#3648;&#3604;&#3639;&#3629;&#3609;',0),(181107,5031,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€/à¤µà¥à¤¯à¤¯: 12 à¤®à¤¹à¥€à¤¨à¥‡',0),(181108,5031,'ms','Jualan/perbelanjaan: 12 bulan',0),(181109,5031,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª/Ø§Ù„Ù†ÙÙ‚Ø§Øª: 12 Ø´Ù‡Ø±',0),(181110,5031,'fr','Ventes/dÃ©penses : 12 mois',0),(181111,5031,'jp','ã‚»ãƒ¼ãƒ«ã‚¹/è²»ç”¨ï¼šï¼‘ï¼’ãƒ¶æœˆ',0),(181112,5031,'pt','Vendas/despesas: 12 meses',0),(181113,5031,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶/Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹: 12 Ð¼ÐµÑÑÑ†ÐµÐ²',0),(181114,5031,'es','Ventas/Gastos: 12 Meses',0),(181115,5031,'de','Vertrieb/Aufwendungen: 12 Monate',0),(181116,5031,'en','Sales/Expenses: 12 Month',0),(181117,5032,'is','',0),(181118,5032,'dr','Ø¯Ù„Ø§Ø± Ø¯Ø±  Ù‡Ø²Ø§Ø±',0),(181119,5032,'pr','Ø¯Ù„Ø§Ø± Ø¯Ø±  Ù‡Ø²Ø§Ø±',0),(181120,5032,'tr','Binlerce dolar',0),(181121,5032,'pl','DolarÃ³w w tysiÄ…cach',0),(181122,5032,'bg','Ð”Ð¾Ð»Ð°Ñ€Ð° Ð² Ñ…Ð¸Ð»ÑÐ´Ð¸',0),(181123,5032,'ur','ÛØ²Ø§Ø±ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù…ÛŒÚº ÚˆØ§Ù„Ø±',0),(181124,5032,'sr','Ð”Ð¾Ð»Ð°Ñ€Ð° Ñƒ Ñ…Ð¸Ñ™Ð°Ð´Ð°Ð¼Ð°',0),(181125,5032,'vi','Dola tá»« hÃ ng ngÃ n',0),(181126,5032,'af','Dollars in duisende',0),(181127,5032,'ro','Mii de dolari',0),(181128,5032,'et','Tuhandet Eurot',0),(181129,5032,'si','Dolarjev v tisoÄ',0),(181130,5032,'ba','Dolar dalam ribuan',0),(181131,5032,'nl','Dollar in duizenden',0),(181132,5032,'fi','Tuhansia dollareita',0),(181133,5032,'no','Dollar i tusenvis',0),(181134,5032,'da','Dollars i tusindvis',0),(181135,5032,'ko','ìˆ˜ì²œ ë‹¬ëŸ¬',0),(181136,5032,'he','××œ×¤×™ ×“×•×œ×¨×™×',0),(181137,5032,'el','Î”Î¿Î»Î¬ÏÎ¹Î± ÏƒÎµ Ï‡Î¹Î»Î¹Î¬Î´ÎµÏ‚',0),(181138,5032,'zh','åƒç¾Žå…ƒ\r\n',0),(181139,5032,'sv','Dollar i tusentals',0),(181140,5032,'it','Dollari in migliaia',0),(181141,5032,'tl','',0),(181142,5032,'th','&#3648;&#3591;&#3636;&#3609;&#3604;&#3629;&#3621;&#3621;&#3656;&#3634;&#3619;&#3660;',0),(181143,5032,'hi','à¤¹à¤œà¤¾à¤°à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¡à¥‰à¤²à¤°',0),(181144,5032,'ms','Dolar dalam beribu-ribu',0),(181145,5032,'ar','Ø¨Ø¢Ù„Ø§Ù Ø¯ÙˆÙ„Ø§Ø±',0),(181146,5032,'fr','Dollars en milliers',0),(181147,5032,'jp','ãƒ‰ãƒ«ï¼ˆå?ƒå?˜ä½?ï¼‰',0),(181148,5032,'pt','DÃ³lares em milhares',0),(181149,5032,'ru','Ð’ Ñ‚Ñ‹ÑÑÑ‡Ð¸ Ð´Ð¾Ð»Ð»Ð°Ñ€Ð¾Ð²',0),(181150,5032,'es','DÃ³lares en Miles',0),(181151,5032,'de','Dollar in tausend',0),(181152,5032,'en','Dollars in Thousands',0),(181153,5033,'is','',0),(181154,5033,'dr','Ù†Ù…Ø§ÙŠØ´ ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÛŒØ§Ù†',0),(181155,5033,'pr','Ù†Ù…Ø§ÙŠØ´ ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÛŒØ§Ù†',0),(181156,5033,'tr','GÃ¶rÃ¼nÃ¼m kar & kÃ¢r-zarar tablosu',0),(181157,5033,'pl','Widok zysk & strat',0),(181158,5033,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° & Ð·Ð°Ð³ÑƒÐ±Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(181159,5033,'ur','Ù…Ù†Ø¸Ø± Ù…Ù†Ø§ÙØ¹ & Ù†Ù‚ØµØ§Ù† Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(181160,5033,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚ Ð¸ Ð³ÑƒÐ±Ð¸Ñ‚Ð°Ðº Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(181161,5033,'vi','Xem BÃ¡o cÃ¡o lá»i lá»—',0),(181162,5033,'af','Besigtig Wins-en-Verliesstaat',0),(181163,5033,'ro','Vezi Profit & declaraÅ£ie de pierdere',0),(181164,5033,'et','Vaade kasumi & kahjumivÃ¤ljavÃµte',0),(181165,5033,'si','Poglej dobiÄek & uspeha',0),(181166,5033,'ba','Lihat keuntungan & rugi',0),(181167,5033,'nl','Weergave winst & verliesrekening',0),(181168,5033,'fi','NÃ¤ytÃ¤ voitto & tappio ilmoitus',0),(181169,5033,'no','Vis profitt & tap uttalelse',0),(181170,5033,'da','Se Profit & tab erklÃ¦ring',0),(181171,5033,'ko','ë³´ê¸° ì´ìµ & ê³„ì‚° ì„œ',0),(181172,5033,'he','×¨×•×•×— × ×•×£ & ×•×”×¤×¡×“',0),(181173,5033,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎºÎ­ÏÎ´Î¿Ï…Ï‚ & ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î±Ï€Î¿Ï„ÎµÎ»ÎµÏƒÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎµÏ‰Ï‚',0),(181174,5033,'zh','æŸ¥çœ‹æŸç›Šè¡¨\r\n',0),(181175,5033,'sv','Visa vinst & resultatrÃ¤kning',0),(181176,5033,'it','Vista profitto & economico',0),(181177,5033,'tl','',0),(181178,5033,'th','&#3649;&#3626;&#3604;&#3591;&#3591;&#3610;&#3585;&#3635;&#3652;&#3619;&#3586;&#3634;&#3604;&#3607;&#3640;&#3609;',0),(181179,5033,'hi','à¤¦à¥ƒà¤¶à¥ à¤¯ à¤²à¤¾à¤­ & à¤¹à¤¾à¤¨à¤¿ à¤¬à¤¯à¤¾à¤¨',0),(181180,5033,'ms','Lihat keuntungan & kenyataan kehilangan',0),(181181,5033,'ar','Ø¹Ø±Ø¶ ÙƒØ´Ù Ø§Ù„Ø£Ø±Ø¨Ø§Ø­ ÙˆØ§Ù„Ø®Ø³Ø§Ø¦Ø±',0),(181182,5033,'fr','Vue Profit & dÃ©claration de perte',0),(181183,5033,'jp','ï¼°ï¼¬æ˜Žç´°ã?®è¡¨ç¤º',0),(181184,5033,'pt','Vista lucro & declaraÃ§Ã£o de perda',0),(181185,5033,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸ ÐŸÑ€Ð¸Ð±Ñ‹Ð»Ð¸ Ð¸ Ð£Ð±Ñ‹Ñ‚ÐºÐ¾Ð²',0),(181186,5033,'es','Visionar Estado de Resultados',0),(181187,5033,'de','Ansicht Gewinn & Verlustrechnung',0),(181188,5033,'en','View Profit & Loss Statement',0),(181189,5034,'is','',0),(181190,5034,'dr','Ø¢Ù…Ø§Ø± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(181191,5034,'pr','Ø¢Ù…Ø§Ø± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(181192,5034,'tr','VeritabanÄ± istatistikleri',0),(181193,5034,'pl','Statystyki bazy danych',0),(181194,5034,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸',0),(181195,5034,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ÙˆØ´Ù…Ø§Ø±',0),(181196,5034,'sr','Ð‘Ð°Ð·Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐµ',0),(181197,5034,'vi','Sá»‘ liá»‡u thá»‘ng kÃª cá»§a dá»¯ liá»‡u',0),(181198,5034,'af','Databasis Stats',0),(181199,5034,'ro','Statistici de bazÄƒ de date',0),(181200,5034,'et','Andmebaasi statistika',0),(181201,5034,'si','Statistike zbirke podatkov',0),(181202,5034,'ba','Database Statistik',0),(181203,5034,'nl','Database statistieken',0),(181204,5034,'fi','Tietokannan tilastot',0),(181205,5034,'no','Databasen statistikk',0),(181206,5034,'da','Database statistik',0),(181207,5034,'ko','ë°ì´í„°ë² ì´ìŠ¤ í†µê³„',0),(181208,5034,'he','×ž×¡×“ ×”× ×ª×•× ×™× ×”×¡×˜×˜×™×¡×˜×™×™×',0),(181209,5034,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(181210,5034,'zh','æ•°æ®åº“ç»Ÿè®¡\r\n',0),(181211,5034,'sv','Databasen statistik',0),(181212,5034,'it','Statistiche di database',0),(181213,5034,'tl','',0),(181214,5034,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(181215,5034,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤†à¤à¤•à¤¡à¤¼à¥‡',0),(181216,5034,'ms','Pangkalan data statistik',0),(181217,5034,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(181218,5034,'fr','Statistiques de la base de donnÃ©es',0),(181219,5034,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹çŠ¶æ³?',0),(181220,5034,'pt','EstatÃ­sticas de banco de dados',0),(181221,5034,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(181222,5034,'es','Estadisticas de Base de Datos',0),(181223,5034,'de','Datenbank-Statistik',0),(181224,5034,'en','Database Stats',0),(181225,5035,'is','',0),(181226,5035,'dr','. Ø¨Ø§ Ø§Ø­ØªÙŠØ§Ø· Ø¹Ù…Ù„ ÙƒÙ†ÙŠØ¯',0),(181227,5035,'pr','ØªØºÙŠÙŠØ± Ø§ÙŠÙ† ÙÙŠÙ„Ø¯ Ø¨Ø§Ø¹Ø« Ø§Ø² Ø¨ÙŠÙ† Ø±ÙØªÙ† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ . Ø¨Ø§ Ø§Ø­ØªÙŠØ§Ø· Ø¹Ù…Ù„ ÙƒÙ†ÙŠØ¯',0),(181228,5035,'tr','BU ALAN DEÄžÄ°ÅžTÄ°RME VERÄ° KAYBINA NEDEN OLABÄ°LÄ°R. Dikkatli olun.',0),(181229,5035,'pl','ZMIANA TEJ DZIEDZINIE MOÅ»E DOPROWADZIÄ† DO UTRATY DANYCH! PostÄ™powaÄ‡ ostroÅ¼nie.',0),(181230,5035,'bg','ÐŸÐ ÐžÐœÐ¯ÐÐ ÐÐ Ð¢ÐžÐ’Ð ÐŸÐžÐ›Ð• ÐœÐžÐ–Ð• Ð”Ð Ð”ÐžÐ’Ð•Ð”Ð• Ð”Ðž Ð—ÐÐ“Ð£Ð‘Ð ÐÐ Ð”ÐÐÐÐ˜! ÐŸÑ€Ð¾Ð´ÑŠÐ»Ð¶ÐµÑ‚Ðµ Ñ Ð¿Ð¾Ð²Ð¸ÑˆÐµÐ½Ð¾ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ.',0),(181231,5035,'ur','Ø§Ø³ Ù‚Ø·Ø¹Û Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ú©ÙˆØ§Ø¦Ù Ú©Ø§ Ù†Ù‚ØµØ§Ù† Ù†ØªÛŒØ¬Û’ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº! Ø§Ø­ØªÛŒØ§Ø· Ú©Û’ Ø³Ø§ØªÚ¾ Ø¢Ú¯Û’ Ø¨Ú‘Ú¾Ù†Ø§ ÛÛ’ Û”',0),(181232,5035,'sr','ÐŸÐ ÐžÐœÐ•ÐÐ˜ ÐžÐ’Ðž ÐŸÐžÐ‰Ð• ÐœÐžÐ–Ð• Ð”ÐžÐ’Ð•Ð¡Ð¢Ð˜ Ð”Ðž Ð“Ð£Ð‘Ð˜Ð¢ÐšÐ ÐŸÐžÐ”ÐÐ¢ÐÐšÐ! ÐÐ°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ ÑÐ° Ð¾Ð¿Ñ€ÐµÐ·Ð¾Ð¼.',0),(181233,5035,'vi','THAY Äá»”I TRÆ¯á»œNG NÃ€Y CÃ“ THá»‚ LÃ€M Máº¬T Dá»® LIá»†U! Tháº­n trá»ng',0),(181234,5035,'af','VERANDER HIERDIE VELD KAN LEI TOT VERLIES VAN DATA! Voortgaan met omsigtigheid.',0),(181235,5035,'ro','SCHIMBAREA ACEST DOMENIU POATE DUCE LA PIERDEREA DATELOR! ContinuaÅ£i cu prudenÅ£Äƒ.',0),(181236,5035,'et','MUUTUVAD SELLES VALDKONNAS VÃ•IB PÃ•HJUSTADA ANDMETE KAOTSIMINEKU! Tegutsema ettevaatlikult.',0),(181237,5035,'si','SPREMINJANJE POLJU LAHKO POVZROÄŒI IZGUBO PODATKOV! Nadaljujte previdno.',0),(181238,5035,'ba','MENGUBAH BIDANG INI DAPAT MENGAKIBATKAN KEHILANGAN DATA! Lanjutkan dengan hati-hati.',0),(181239,5035,'nl','DIT VELD WIJZIGEN KAN RESULTEREN IN VERLIES VAN GEGEVENS! Ga verder met de nodige voorzichtigheid.',0),(181240,5035,'fi','MUUTTAMINEN TÃ„SSÃ„ KENTÃ„SSÃ„ VOI JOHTAA TIETOJEN MENETTÃ„MISEEN! EdetÃ¤ varovaisesti.',0),(181241,5035,'no','ENDRE DETTE FELTET KAN RESULTERE I TAP AV DATA! Fortsett med forsiktighet.',0),(181242,5035,'da','Ã†NDRE FELTET KAN RESULTERE I TAB AF DATA! GÃ¥ videre med forsigtighed.',0),(181243,5035,'ko','ì´ í•„ë“œë¥¼ ë³€ê²½ í•˜ëŠ” ê²ƒì€ ë°ì´í„°ì˜ ì†ì‹¤ ê·€ ì°©ë  ìˆ˜ ìžˆë‹¤! ì‹ ì¤‘ í•˜ ê²Œ ì§„í–‰.',0),(181244,5035,'he','×©×™× ×•×™ ×©×“×” ×–×” ×™×›×•×œ ×œ×’×¨×•× ×œ××•×‘×“×Ÿ × ×ª×•× ×™×! . ×‘×–×”×™×¨×•×ª.',0),(181245,5035,'el','Î‘Î›Î›Î†Î–Î•Î™ Î¤ÎŸ Î Î•Î”ÎŠÎŸ Î‘Î¥Î¤ÎŒ ÎœÎ ÎŸÎ¡Î•ÎŠ ÎÎ‘ ÎŸÎ”Î—Î“Î‰Î£Î•Î™ Î£Î• Î‘Î ÎÎ›Î•Î™Î‘ Î”Î•Î”ÎŸÎœÎˆÎÎ©Î! Î ÏÎ¿Ï‡Ï‰ÏÎ®ÏƒÏ„Îµ Î¼Îµ Ï€ÏÎ¿ÏƒÎ¿Ï‡Î®.',0),(181246,5035,'zh','æ”¹å˜è¿™ä¸€é¢†åŸŸå¯ä»¥å¯¼è‡´æ•°æ®çš„æŸå¤±ï¼è°¨æ…Žè¡Œäº‹\r\n',0),(181247,5035,'sv','Ã„NDRA FÃ„LTET KAN RESULTERA I FÃ–RLUST AV DATA! FortsÃ¤tt med fÃ¶rsiktighet.',0),(181248,5035,'it','MODIFICA QUESTO CAMPO PUÃ’ CAUSARE PERDITA DI DATI! Procedere con cautela.',0),(181249,5035,'tl','',0),(181250,5035,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3609;&#3637;&#3657;&#3617;&#3633;&#3609;&#3626;&#3656;&#3591;&#3612;&#3621;&#3',0),(181251,5035,'hi','à¤‡à¤¸ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤•à¥‹ à¤¬à¤¦à¤²à¤¨à¥‡ à¤¡à¥‡à¤Ÿà¤¾ à¤•à¥€ à¤¹à¤¾à¤¨à¤¿ à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤£à¤¾à¤® à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚! à¤¸à¤¾à¤µà¤§à¤¾à¤¨à¥€ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤—à¥‡ à¤¬à¤¢à¤¼à¤¨à¤¾à¥¤',0),(181252,5035,'ms','MENUKAR BIDANG INI BOLEH MENYEBABKAN KEHILANGAN DATA! Teruskan dengan berhati-hati.',0),(181253,5035,'ar','ØªØºÙŠÙŠØ± Ù‡Ø°Ø§ Ø§Ù„Ø­Ù‚Ù„ Ù‚Ø¯ ÙŠØ¤Ø¯Ù‘ Ø¥Ù„Ù‰ ÙÙ‚Ø¯Ø§Ù† Ø¨ÙŠØ§Ù†Ø§Øª !! ÙˆØ§ØµÙ„ Ø¨Ø­Ø°Ø±',0),(181254,5035,'fr','MODIFIER CE CHAMP PEUT ENTRAÃŽNER LA PERTE DE DONNÃ‰ES ! ProcÃ©der avec prudence.',0),(181255,5035,'jp','ã?“ã?®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’å¤‰æ›´ã?™ã‚‹ã?“ã?¨ã?«ã‚ˆã‚Šãƒ‡ãƒ¼ã‚¿ã?Œå¤±ã‚?ã‚Œã‚‹ã?“ã?¨ã?Œã?‚ã‚Šã?¾ã?™ã€‚æ°—ã‚’ã?¤ã?‘ã?¦é€²ã‚?ã?¦ä¸‹ã?•ã?„ã€‚',0),(181256,5035,'pt','ALTERANDO ESTE CAMPO PODE RESULTAR EM PERDA DE DADOS! Proceda com cautela.',0),(181257,5035,'ru','Ð˜Ð—ÐœÐ•ÐÐ•ÐÐ˜Ð• Ð­Ð¢ÐžÐ“Ðž ÐŸÐžÐ›Ð¯ ÐœÐžÐ–Ð•Ð¢ ÐŸÐ Ð˜Ð’Ð•Ð¡Ð¢Ð˜ Ðš ÐŸÐžÐ¢Ð•Ð Ð• Ð”ÐÐÐÐ«Ð¥! ÐŸÑ€Ð¾Ð´Ð¾Ð»Ð¶Ð°Ð¹Ñ‚Ðµ Ñ Ð¾ÑÑ‚Ð¾Ñ€Ð¾Ð¶Ð½Ð¾ÑÑ‚ÑŒÑŽ.',0),(181258,5035,'es','CAMBIANDO ESTE CAMPO PUEDE RESULTAR EN LA PÃ‰RDIDA DE DATOS! Procede con CauciÃ³n',0),(181259,5035,'de','Ã„NDERN DIESES FELD KANN DATENVERLUST FÃœHREN! Gehen Sie mit Vorsicht.',0),(181260,5035,'en','CHANGING THIS FIELD CAN RESULT IN LOSS OF DATA! Proceed with Caution.',0),(181261,5036,'is','',0),(181262,5036,'dr','Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø± Ø¨Ø²Ø±Ú¯',0),(181263,5036,'pr','Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø± Ø¨Ø²Ø±Ú¯',0),(181264,5036,'tr','GeniÅŸ grafik silme',0),(181265,5036,'pl','UsuÅ„ duÅ¼e grafiki',0),(181266,5036,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð³Ð¾Ð»ÑÐ¼Ð° Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(181267,5036,'ur','Ø¨Ú‘Û’ Ú¯Ø±Ø§ÙÛŒ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(181268,5036,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð²ÐµÐ»Ð¸ÐºÐµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(181269,5036,'vi','XÃ³a Ä‘á»“ há»a lá»›n',0),(181270,5036,'af','Skrap Groot Grafika',0),(181271,5036,'ro','ÅžtergeÅ£i mare grafic',0),(181272,5036,'et','Kustuta suur graafika',0),(181273,5036,'si','Izbrisati veliko grafike',0),(181274,5036,'ba','Menghapus grafis besar',0),(181275,5036,'nl','Grote afbeelding verwijderen',0),(181276,5036,'fi','Poista suureksi grafiikkaobjektiksi',0),(181277,5036,'no','Slette store grafikkelementer',0),(181278,5036,'da','Slette store grafik',0),(181279,5036,'ko','í° ê·¸ëž˜í”½ ì‚­ì œ',0),(181280,5036,'he','×ž×—×™×§×ª ×’×¨×¤×™×§×” ×’×“×•×œ×”',0),(181281,5036,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î¼ÎµÎ³Î¬Î»Î¿ Î³ÏÎ±Ï†Î¹ÎºÏŒ',0),(181282,5036,'zh','åˆ é™¤å¤§å›¾\r\n',0),(181283,5036,'sv','Ta bort stor bild',0),(181284,5036,'it','Eliminare la grande grafica',0),(181285,5036,'tl','',0),(181286,5036,'th','&#3621;&#3610;&#3619;&#3641;&#3611;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3585;&#3651;&#3627;&#3597;&#3656;',0),(181287,5036,'hi','à¤¬à¤¡à¤¼à¥‡ à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤• à¤¹à¤Ÿà¤¾à¤à¤',0),(181288,5036,'ms','Menghapuskan grafik yang besar',0),(181289,5036,'ar','Ø­Ø°Ù Ø§Ù„Ø±Ø³Ù… ÙƒØ¨ÙŠØ±',0),(181290,5036,'fr','Supprimer l\'Ã©lÃ©ment graphique important',0),(181291,5036,'jp','å¤§ã??ã?„æŒ¿çµµã‚’æ¶ˆåŽ»',0),(181292,5036,'pt','Excluir grande grÃ¡fico',0),(181293,5036,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð±Ð¾Ð»ÑŒÑˆÐ¾Ð¹ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹',0),(181294,5036,'es','Eliminar GrÃ¡fica Grande',0),(181295,5036,'de','GroÃŸe Grafik lÃ¶schen',0),(181296,5036,'en','Delete Large Graphic',0),(181297,5037,'is','',0),(181298,5037,'dr','Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙˆÚ†Ùƒ ',0),(181299,5037,'pr','Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø± ÙƒÙˆÚ†Ùƒ ',0),(181300,5037,'tr','KÃ¼Ã§Ã¼k grafik silme',0),(181301,5037,'pl','UsuÅ„ maÅ‚a grafika',0),(181302,5037,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¼Ð°Ð»ÐºÐ° Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(181303,5037,'ur','Ú†Ú¾ÙˆÙ¹Û’ Ú¯Ø±Ø§ÙÛŒ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(181304,5037,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¼Ð°Ð»Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(181305,5037,'vi','XÃ³a Ä‘á»“ há»a nhá»',0),(181306,5037,'af','Skrap Klein Grafika',0),(181307,5037,'ro','ÅžtergeÅ£i mici grafic',0),(181308,5037,'et','Kustuta vÃ¤ike graafika',0),(181309,5037,'si','Izbrisati mala grafika',0),(181310,5037,'ba','Menghapus kecil grafis',0),(181311,5037,'nl','Kleine afbeelding verwijderen',0),(181312,5037,'fi','Poista kuva',0),(181313,5037,'no','Slette grafikk',0),(181314,5037,'da','Slette lille grafisk',0),(181315,5037,'ko','ìž‘ì€ ê·¸ëž˜í”½ ì‚­ì œ',0),(181316,5037,'he','×ž×—×™×§×ª ×’×¨×¤×™×§×” ×§×˜×Ÿ',0),(181317,5037,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ Î¼Î¹ÎºÏÏŒ Î³ÏÎ±Ï†Î¹ÎºÏŒ',0),(181318,5037,'zh','åˆ é™¤å°å›¾å½¢\r\n',0),(181319,5037,'sv','Ta bort lilla grafiska',0),(181320,5037,'it','Eliminare il piccolo grafico',0),(181321,5037,'tl','',0),(181322,5037,'th','&#3621;&#3610;&#3619;&#3641;&#3611;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3585;&#3648;&#3621;&#3655;&#3585;',0),(181323,5037,'hi','à¤›à¥‹à¤Ÿà¥‡ à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤• à¤¹à¤Ÿà¤¾à¤à¤',0),(181324,5037,'ms','Menghapuskan grafik kecil',0),(181325,5037,'ar','Ø­Ø°Ù Ø§Ù„Ø±Ø³Ù… Ø§Ù„ØµØºÙŠØ±Ø©',0),(181326,5037,'fr','Supprimer le petit graphique',0),(181327,5037,'jp','å°?ã?•ã?„æŒ¿çµµã‚’æ¶ˆåŽ»',0),(181328,5037,'pt','Excluir grÃ¡fico pequeno',0),(181329,5037,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð½ÐµÐ±Ð¾Ð»ÑŒÑˆÐ¸Ñ… Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ñ…',0),(181330,5037,'es','Eliminar GrÃ¡fica PequeÃ±a',0),(181331,5037,'de','Kleine Grafik lÃ¶schen',0),(181332,5037,'en','Delete Small Graphic',0),(181333,5038,'is','',0),(181334,5038,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(181335,5038,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(181336,5038,'tr','Fatura sipariÅŸler',0),(181337,5038,'pl','Rozliczane zlecenia',0),(181338,5038,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(181339,5038,'ur','Ø¨Ø§Ù„Ù„Ø§Ø¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(181340,5038,'sr','ÐšÑƒÐ¿Ð¾Ð²Ð¸Ð½Ð° Ñ‚ÐµÑ€ÐµÑ‚Ð¸Ñ›Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(181341,5038,'vi','ÄÆ¡n Äáº·t HÃ ng ÄÃ£ Láº­p HÃ³a ÄÆ¡n',0),(181342,5038,'af','Gefaktuureerde Bestellings',0),(181343,5038,'ro','Comenzi facturate',0),(181344,5038,'et','Ostu kohta arveldus tellimused',0),(181345,5038,'si','Bremenjene naroÄila',0),(181346,5038,'ba','Tagihan Pesanan',0),(181347,5038,'nl','Gefactureerde Orders',0),(181348,5038,'fi','Laskutetut tilaukset',0),(181349,5038,'no','Fakturerte ordrer',0),(181350,5038,'da','Faktureret ordrer',0),(181351,5038,'ko','ì²­êµ¬ ì£¼ë¬¸',0),(181352,5038,'he','×”×–×ž× ×•×ª ×©×—×•×™×‘',0),(181353,5038,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(181354,5038,'zh','å˜´è®¢å•\r\n',0),(181355,5038,'sv','Fakturerade order',0),(181356,5038,'it','Ordini Fatturati',0),(181357,5038,'tl','',0),(181358,5038,'th','&#3610;&#3636;&#3621;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(181359,5038,'hi','à¤–à¤¼à¤°à¥€à¤¦ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(181360,5038,'ms','Perintah-perintah yang dibilkan sebanyak',0),(181361,5038,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(181362,5038,'fr','Commandes facture',0),(181363,5038,'jp','è«‹æ±‚æ¸ˆæ³¨æ–‡',0),(181364,5038,'pt','Pedidos faturados',0),(181365,5038,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(181366,5038,'es','Pedidos Facturados',0),(181367,5038,'de','-Abrechnung Bestellungen',0),(181368,5038,'en','Billed Orders',0),(181369,5039,'is','',0),(181370,5039,'dr','Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(181371,5039,'pr','Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(181372,5039,'tr','Cari ay',0),(181373,5039,'pl','BieÅ¼Ä…cy miesiÄ…c',0),(181374,5039,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸Ñ Ð¼ÐµÑÐµÑ†',0),(181375,5039,'ur','Ø±ÙˆØ§Úº Ù…Ø§Û',0),(181376,5039,'sr','Ð¢ÐµÐºÑƒÑ›Ð¸ Ð¼ÐµÑÐµÑ†',0),(181377,5039,'vi','ThÃ¡ng hiá»‡n thá»i ',0),(181378,5039,'af','Huidige Maand',0),(181379,5039,'ro','Luna curentÄƒ',0),(181380,5039,'et','KÃ¤esolev kuu',0),(181381,5039,'si','TekoÄi mesec',0),(181382,5039,'ba','Bulan ini',0),(181383,5039,'nl','Huidige maand',0),(181384,5039,'fi','Nykyinen kuukausi',0),(181385,5039,'no','Gjeldende mÃ¥ned',0),(181386,5039,'da','NuvÃ¦rende mÃ¥ned',0),(181387,5039,'ko','í˜„ìž¬ ë‹¬',0),(181388,5039,'he','×—×•×“×© × ×•×›×—×™',0),(181389,5039,'el','Î¤ÏÎ­Ï‡Î¿Î½Ï„Î± Î¼Î®Î½Î±',0),(181390,5039,'zh','æœ¬æœˆ\r\n',0),(181391,5039,'sv','Aktuell mÃ¥nad',0),(181392,5039,'it','Mese corrente',0),(181393,5039,'tl','',0),(181394,5039,'th','&#3648;&#3604;&#3639;&#3629;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(181395,5039,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¤¾à¤¹',0),(181396,5039,'ms','Bulan semasa',0),(181397,5039,'ar','Ø§Ù„Ø´Ù‡Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(181398,5039,'fr','Mois en cours',0),(181399,5039,'jp','ä»Šæœˆ',0),(181400,5039,'pt','MÃªs atual',0),(181401,5039,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ ÐœÐµÑÑÑ†',0),(181402,5039,'es','Mes Actual',0),(181403,5039,'de','Aktueller Monat',0),(181404,5039,'en','Current Month',0),(181405,5040,'is','',0),(181406,5040,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø±ÙˆØ²Ø§Ù†Ù‡ ',0),(181407,5040,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø±ÙˆØ²Ø§Ù†Ù‡ ',0),(181408,5040,'tr','GÃ¼nlÃ¼k hacim raporu',0),(181409,5040,'pl','Dzienny raport wielkoÅ›ci',0),(181410,5040,'bg','Ð”Ð½ÐµÐ²ÐµÐ½ Ð¾Ð±ÐµÐ¼ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(181411,5040,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Û ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹',0),(181412,5040,'sr','Ð”Ð½ÐµÐ²Ð½Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(181413,5040,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng ngÃ y',0),(181414,5040,'af','Daaglikse Volume Verslag',0),(181415,5040,'ro','Raport zilnic de volum',0),(181416,5040,'et','IgapÃ¤evane mahu aruande',0),(181417,5040,'si','Dnevni obseg poroÄila',0),(181418,5040,'ba','Laporan harian Volume',0),(181419,5040,'nl','Dagelijkse Volume verslag',0),(181420,5040,'fi','PÃ¤ivittÃ¤inen mÃ¤Ã¤rÃ¤ raportti',0),(181421,5040,'no','Daglig volum rapport',0),(181422,5040,'da','Daglig volumen rapport',0),(181423,5040,'ko','ì¼ì¼ ë³¼ë¥¨ ë³´ê³ ì„œ',0),(181424,5040,'he','×“×•×— × ×¤×— ×™×•×ž×™',0),(181425,5040,'el','Î—Î¼ÎµÏÎ®ÏƒÎ¹Î± Î±Î½Î±Ï†Î¿ÏÎ¬ ÏŒÎ³ÎºÎ¿Ï…',0),(181426,5040,'zh','æ—¥äº¤æ˜“é‡æŠ¥å‘Š\r\n',0),(181427,5040,'sv','Daglig volym rapport',0),(181428,5040,'it','Rapporto Volume giornaliero',0),(181429,5040,'tl','',0),(181430,5040,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;',0),(181431,5040,'hi','à¤¦à¥ˆà¤¨à¤¿à¤• à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(181432,5040,'ms','Laporan jumlah harian',0),(181433,5040,'ar','Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„ÙŠÙˆÙ…ÙŠ Ù„Ø­Ø¬Ù…',0),(181434,5040,'fr','Rapport Volume quotidien',0),(181435,5040,'jp','æ—¥æ¯Žå‡ºæ?¥é«˜ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(181436,5040,'pt','RelatÃ³rio diÃ¡rio de Volume',0),(181437,5040,'ru','Ð•Ð¶ÐµÐ´Ð½ÐµÐ²Ð½Ñ‹Ð¹ Ð¾Ð±ÑŠÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð°',0),(181438,5040,'es','Informe Diario de VolÃºmen',0),(181439,5040,'de','Volume-Tagesbericht',0),(181440,5040,'en','Daily Volume Report',0),(181441,5041,'is','',0),(181442,5041,'dr','Ø¯Ù„Ø§Ø± ÙØ§ÙƒØªÙˆØ± Ø´Ø¯ ',0),(181443,5041,'pr','Ø¯Ù„Ø§Ø± ÙØ§ÙƒØªÙˆØ± Ø´Ø¯ ',0),(181444,5041,'tr','FaturalanmÄ±ÅŸ dolar',0),(181445,5041,'pl','DolarÃ³w zafakturowane',0),(181446,5041,'bg','Ð”Ð¾Ð»Ð°Ñ€Ð° Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¾',0),(181447,5041,'ur','Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ ÚˆØ§Ù„Ø±',0),(181448,5041,'sr','Ð”Ð¾Ð»Ð°Ñ€Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð¸',0),(181449,5041,'vi','Dola trong hÃ³a Ä‘Æ¡n',0),(181450,5041,'af','Dollar Invoiced',0),(181451,5041,'ro','Dolari facturate',0),(181452,5041,'et','Eurot arveteks',0),(181453,5041,'si','Dolarjev, fakturirano',0),(181454,5041,'ba','Dolar tagihan',0),(181455,5041,'nl','Dollars gefactureerd',0),(181456,5041,'fi','Dollaria laskutettu',0),(181457,5041,'no','Dollar fakturert',0),(181458,5041,'da','Dollars faktureret',0),(181459,5041,'ko','ë‹¬ëŸ¬ ì²­êµ¬',0),(181460,5041,'he','×“×•×œ×¨ ×—×•×™×‘×•',0),(181461,5041,'el','Î”Î¿Î»Î¬ÏÎ¹Î± Ï€Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î®Î¸Î·ÎºÎµ',0),(181462,5041,'zh','ç¾Žå…ƒå¼€ç¥¨\r\n',0),(181463,5041,'sv','Dollar fakturerade',0),(181464,5041,'it','Dollari fatturati',0),(181465,5041,'tl','',0),(181466,5041,'th','&#3651;&#3610;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3648;&#3611;&#3655;&#3609;&#3648;&#3591;&#3636;&#3609;&#3604;&#3629;&#3621;&#3621;&#3656;&#3634;&#3619;&#3660; ',0),(181467,5041,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤¡à¥‰à¤²à¤°',0),(181468,5041,'ms','Dolar invois',0),(181469,5041,'ar','Ø¯ÙˆÙ„Ø§Ø± Ù…ÙÙˆØªØ±',0),(181470,5041,'fr','Dollars facturÃ©s',0),(181471,5041,'jp','$$ Invoiced',0),(181472,5041,'pt','DÃ³lares faturados',0),(181473,5041,'ru','Ð”Ð¾Ð»Ð»Ð°Ñ€Ð¾Ð² Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚',0),(181474,5041,'es','DÃ³lares Facturados',0),(181475,5041,'de','Dollar fakturiert',0),(181476,5041,'en','Dollars Invoiced',0),(181477,5042,'is','',0),(181478,5042,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙƒÙ¾ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ø¨Ø²Ø±Ú¯ Ø¯Ø± ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÙŠ ',0),(181479,5042,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙƒÙ¾ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ø¨Ø²Ø±Ú¯ Ø¯Ø± ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÙŠ ',0),(181480,5042,'tr','Dosya kopyalama bÃ¼yÃ¼k istemci sayfasÄ± hatasÄ±',0),(181481,5042,'pl','BÅ‚Ä…d podczas kopiowania duÅ¼ych plikÃ³w do strony klienta',0),(181482,5042,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð³Ð¾Ð»ÑÐ¼ Ð¿Ð¸Ð»Ð° ÐºÑŠÐ¼ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(181483,5042,'ur','Ú©ÙˆÙ¾ÛŒØ§Ù†Ú¯ Ø¨Ú‘ÛŒ ÙØ§Ø¦Ù„ Ø¬Ø¨ ÙˆØµÙˆÙ„ Ú©Ø§Ø± ØµÙØ­Û Ù¾Ø± Ù†Ù‚Øµ',0),(181484,5042,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¦Ð¾Ð¿yÐ¸Ð½Ð³ Ð²ÐµÐ»Ð¸ÐºÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(181485,5042,'vi','Lá»—i khi sao chÃ©p há»“ sÆ¡ lá»›n sang trang khÃ¡ch hÃ ng',0),(181486,5042,'af','Fout begaan met Kopiering van Groot LÃªer na KliÃªnt/Klant Bladsy',0),(181487,5042,'ro','Eroare la copierea mare dosar la pagina de Client',0),(181488,5042,'et','Viga, kui kopeerimine suure faili klient lehele',0),(181489,5042,'si','Napaka pri Big kopiranje datoteke na strani odjemalca',0),(181490,5042,'ba','Kesalahan saat menyalin besar File untuk Client Page',0),(181491,5042,'nl','Fout bij het kopiÃ«ren Big bestand naar de Client pagina',0),(181492,5042,'fi','Virhe kopiointi ISO tiedoston asiakas-sivua',0),(181493,5042,'no','Feil ved kopiering stor fil til klienten-side',0),(181494,5042,'da','Fejl, nÃ¥r du kopierer store fil til klient side',0),(181495,5042,'ko','í´ë¼ì´ì–¸íŠ¸ íŽ˜ì´ì§€ë¡œ ë³µì‚¬ í° íŒŒì¼ ì˜¤ë¥˜',0),(181496,5042,'he','×©×’×™××” ×‘×¢×ª ×”×¢×ª×§×” ×’×“×•×œ ×§×•×‘×¥ ×œ×“×£ ×œ×§×•×—',0),(181497,5042,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Ï„Î¹Î³ÏÎ±Ï†Î® Î¼ÎµÎ³Î¬Î»Ï‰Î½ Î±ÏÏ‡ÎµÎ¯Ï‰Î½ ÏƒÎµ ÏƒÎµÎ»Î¯Î´Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(181498,5042,'zh','å¤åˆ¶å¤§æ–‡ä»¶æ—¶å‡ºçŽ°é”™è¯¯åˆ°å®¢æˆ·ç«¯é¡µé¢\r\n',0),(181499,5042,'sv','Fel vid kopiering Big filen till klienten',0),(181500,5042,'it','Errore quando Copying Big File al Client Page',0),(181501,5042,'tl','',0),(181502,5042,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3586;&#3603;&#3632;&#3585;&#3635;&#3621;&#3633;&#3591;&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3652;&#3615;&#3621;&#3660;&#3586;&#3609;&#3634;&#3604;&#3651;&#3627;&#3597;&#3656;&#3652;&#3611;&#3607;&#3',0),(181503,5042,'hi','Copying à¤¬à¤¿à¤— à¤«à¤¼à¤¾à¤‡à¤² à¤œà¤¬ à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ à¤ªà¥ƒà¤·à¥à¤  à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(181504,5042,'ms','Ralat apabila besar salinan fail ke Laman pelanggan',0),(181505,5042,'ar','Ø®Ø·Ø£ Ø¹Ù†Ø¯ Ø§Ù„ÙƒØ¨ÙŠØ± Ù†Ø³Ø® Ø§Ù„Ù…Ù„Ù Ø¥Ù„Ù‰ \"ØµÙØ­Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„\"',0),(181506,5042,'fr','Erreur lors de copie Big fichier Client page',0),(181507,5042,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆãƒšãƒ¼ã‚¸ã?¸å¤§ã??ã?„ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚³ãƒ”ãƒ¼ä¸­ã?«ã‚¨ãƒ©ãƒ¼',0),(181508,5042,'pt','Erro ao copiar grandes arquivos para pÃ¡gina de cliente',0),(181509,5042,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ð‘Ð¾Ð»ÑŒÑˆÐ¾Ð³Ð¾ Ð¤Ð°Ð¹Ð»Ð° Ð½Ð° Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(181510,5042,'es','Error cuando Copiar Archivo Grande a la PÃ¡gina de Cliente',0),(181511,5042,'de','Fehler beim Kopieren von groÃŸen Datei auf Client-Seite',0),(181512,5042,'en','Error when Copying Big File to Client Page',0),(181513,5043,'is','',0),(181514,5043,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ÙØ¹Ø§Ù„ÙŠØª',0),(181515,5043,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ÙØ¹Ø§Ù„ÙŠØª',0),(181516,5043,'tr','Eylem tarihinden baÅŸlamak',0),(181517,5043,'pl','Data rozpoczÄ™cia dziaÅ‚ania',0),(181518,5043,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(181519,5043,'ur','Ø¹Ù…Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¢ØºØ§Ø²',0),(181520,5043,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(181521,5043,'vi','NgÃ y báº¯t Ä‘áº§u hÃ nh Ä‘á»™ng',0),(181522,5043,'af','Begin Aksie Datum',0),(181523,5043,'ro','ÃŽncepe de acÅ£iune data',0),(181524,5043,'et','Toimingu alguskuupÃ¤ev',0),(181525,5043,'si','ZaÄetni datum dejanja',0),(181526,5043,'ba','Mulai tanggal aksi',0),(181527,5043,'nl','Actie begindatum',0),(181528,5043,'fi','Toimen aloituspÃ¤ivÃ¤',0),(181529,5043,'no','Starte handlingsdato',0),(181530,5043,'da','Begynde aktionsdato',0),(181531,5043,'ko','ìž‘ì—… ë‚ ì§œë¥¼ ì‹œìž‘',0),(181532,5043,'he','×œ×”×ª×—×™×œ ×ª××¨×™×š ×”×¤×¢×•×œ×”',0),(181533,5043,'el','ÎˆÎ½Î±ÏÎ¾Î· Î—Î¼.',0),(181534,5043,'zh','å¼€å§‹è¡ŒåŠ¨æ—¥æœŸ\r\n',0),(181535,5043,'sv','BÃ¶rja Ã¥tgÃ¤rdsdatum',0),(181536,5043,'it','Iniziare l\'azione Data',0),(181537,5043,'tl','',0),(181538,5043,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(181539,5043,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¶à¥à¤°à¥‚ à¤¹à¥‹',0),(181540,5043,'ms','Mula tarikh tindakan',0),(181541,5043,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„Ø¹Ù…Ù„',0),(181542,5043,'fr','Date dÃ©but de l\'Action',0),(181543,5043,'jp','å®Ÿè¡Œæ—¥ç¨‹ã?®é–‹å§‹',0),(181544,5043,'pt','Iniciar aÃ§Ã£o data de',0),(181545,5043,'ru','Ð”Ð°Ñ‚Ð° ÐÐ°Ñ‡Ð°Ð»Ð° Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(181546,5043,'es','Fecha de Inicio de la AcciÃ³n',0),(181547,5043,'de','Anfangsdatum Aktion',0),(181548,5043,'en','Begin Action Date',0),(181549,5044,'is','',0),(181550,5044,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ÙØ¹Ø§Ù„ÙŠØª',0),(181551,5044,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ÙØ¹Ø§Ù„ÙŠØª',0),(181552,5044,'tr','Son iÅŸlem tarihi',0),(181553,5044,'pl','Data zakoÅ„czenia dziaÅ‚ania',0),(181554,5044,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(181555,5044,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø¹Ù…Ù„',0),(181556,5044,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(181557,5044,'vi','NgÃ y káº¿t thÃºc hÃ nh Ä‘á»™ng',0),(181558,5044,'af','Eindig Aksiedatum',0),(181559,5044,'ro','SfÃ¢rÅŸitul de acÅ£iune data',0),(181560,5044,'et','Toimingu lÃµppkuupÃ¤ev',0),(181561,5044,'si','Datum konca ukrepa',0),(181562,5044,'ba','Tanggal akhir tindakan',0),(181563,5044,'nl','Einddatum van de actie',0),(181564,5044,'fi','Toimen pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(181565,5044,'no','Handlingen sluttdatoen',0),(181566,5044,'da','Slutdato for handling',0),(181567,5044,'ko','ë§ˆì§€ë§‰ ì•¡ì…˜ ë‚ ì§œ',0),(181568,5044,'he','×ª××¨×™×š ×¡×™×•× ×¤×¢×•×œ×”',0),(181569,5044,'el','Î”ÏÎ¬ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(181570,5044,'zh','ç»“æŸåŠ¨ä½œæ—¥æœŸ',0),(181571,5044,'sv','Slutet Ã¥tgÃ¤rdsdatum',0),(181572,5044,'it','Azione data di fine',0),(181573,5044,'tl','',0),(181574,5044,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(181575,5044,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(181576,5044,'ms','Tamat tindakan',0),(181577,5044,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„Ø¹Ù…Ù„',0),(181578,5044,'fr','Date fin de l\'Action',0),(181579,5044,'jp','å®Ÿè¡Œæ—¥ç¨‹ã?®çµ‚äº†',0),(181580,5044,'pt','AÃ§Ã£o Data de fim',0),(181581,5044,'ru','Ð”Ð°Ñ‚Ð° ÐžÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(181582,5044,'es','Fecha de AcciÃ³n Final',0),(181583,5044,'de','Aktion Enddatum',0),(181584,5044,'en','End Action Date',0),(181585,5045,'is','',0),(181586,5045,'dr','Ù…Ø­ØµÙˆÙ„Ø§Øª Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø´Ø¯ ',0),(181587,5045,'pr','Ù…Ø­ØµÙˆÙ„Ø§Øª Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø´Ø¯ ',0),(181588,5045,'tr','BakÄ±nlan Ã¼rÃ¼nleri',0),(181589,5045,'pl','PrzeglÄ…dane produkty',0),(181590,5045,'bg','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚Ð¸Ñ‚Ðµ ÑÐ° Ñ€Ð°Ð·Ð³Ð»ÐµÐ´Ð°Ð»Ð¸',0),(181591,5045,'ur','Ù…ØµÙ†ÙˆØ¹Ø§Øª Ø³Û’ Ø¯ÛŒÚ©Ú¾Ø§',0),(181592,5045,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‚Ð¸',0),(181593,5045,'vi','ÄÃ£ xem Sáº£n pháº©m',0),(181594,5045,'af','Produkte Besigtig',0),(181595,5045,'ro','Produsele au vÄƒzut',0),(181596,5045,'et','Vaatasid tooted',0),(181597,5045,'si','Izdelki, ki so si ogledali',0),(181598,5045,'ba','Produk dilihat',0),(181599,5045,'nl','Producten bekeken',0),(181600,5045,'fi','Tuotteet ovat katsoneet',0),(181601,5045,'no','Produkter sett',0),(181602,5045,'da','Produkter, der har set pÃ¥',0),(181603,5045,'ko','ë³¸ ì œí’ˆ',0),(181604,5045,'he','×ž×•×¦×¨×™× ×¦×¤×•',0),(181605,5045,'el','Î ÏÎ¿ÏŠÏŒÎ½Ï„Î± Ï€Î¿Ï… ÎµÎ¯Î´Î±Î½',0),(181606,5045,'zh','æŸ¥çœ‹äº§å“\r\n',0),(181607,5045,'sv','Produkter tittade pÃ¥',0),(181608,5045,'it','Prodotti visualizzati',0),(181609,5045,'tl','',0),(181610,5045,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(181611,5045,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¥‹à¤‚ à¤¦à¥‡à¤–à¤¾ à¤—à¤¯à¤¾',0),(181612,5045,'ms','Produk-produk yang telah melihat',0),(181613,5045,'ar','ÙŠÙ†Ø¸Ø± Ø¥Ù„Ù‰ Ø§Ù„Ù…Ù†ØªØ¬Ø§Øª',0),(181614,5045,'fr','Produits considÃ©rÃ©s',0),(181615,5045,'jp','è¡¨ç¤ºã?•ã‚Œã?Ÿè£½å“?',0),(181616,5045,'pt','Produtos vistos',0),(181617,5045,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÐ»Ð¸ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ñ‹',0),(181618,5045,'es','Productos Visionados',0),(181619,5045,'de','Produkte angesehen',0),(181620,5045,'en','Products Viewed',0),(181621,5046,'is','',0),(181622,5046,'dr','(Ø²Ù…Ø§Ù†Ù‡Ø§ÙŠ) Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(181623,5046,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª (Ø²Ù…Ø§Ù†Ù‡Ø§ÙŠ) Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(181624,5046,'tr','# Kez izlendi',0),(181625,5046,'pl','# Razy obejrzeli',0),(181626,5046,'bg','# ÐŸÑŠÑ‚Ð¸ Ð³Ð»ÐµÐ´Ð°Ð½Ð¸',0),(181627,5046,'ur','# Ø¨Ø§Ø± Ø¯ÛŒÚ©Ú¾Ø§',0),(181628,5046,'sr','# ÐŸÑƒÑ‚Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‚Ð¸',0),(181629,5046,'vi','Sá»‘ láº§n xem',0),(181630,5046,'af','# Kere Besigtig',0),(181631,5046,'ro','# Ori au vÄƒzut',0),(181632,5046,'et','# Vaatasid korda',0),(181633,5046,'si','# Krat, ki so si ogledali',0),(181634,5046,'ba','# Kali melihat',0),(181635,5046,'nl','# Keer bekeken',0),(181636,5046,'fi','# Silloin tÃ¤llÃ¶in, katselija',0),(181637,5046,'no','# Ganger sett',0),(181638,5046,'da','# Gange set pÃ¥',0),(181639,5046,'ko','# ë²ˆ ë³¸',0),(181640,5046,'he','# ×¤×¢×ž×™× ×¦×¤×•',0),(181641,5046,'el','# Î¦Î¿ÏÎ­Ï‚ ÎµÎ¼Ï†Î±Î½Î¯ÏƒÎµÎ¹Ï‚',0),(181642,5046,'zh','ï¼ƒæµè§ˆæ¬¡æ•°\r\n',0),(181643,5046,'sv','# GÃ¥nger tittade pÃ¥',0),(181644,5046,'it','# Volte gli utenti',0),(181645,5046,'tl','',0),(181646,5046,'th','&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3604;&#3641;',0),(181647,5046,'hi','# à¤¬à¤¾à¤° à¤¦à¥‡à¤–à¤¾ à¤—à¤¯à¤¾',0),(181648,5046,'ms','# Times telah melihat',0),(181649,5046,'ar','# Ù…Ø±Ø§Øª Ù…Ø´Ø§Ù‡Ø¯Ø©',0),(181650,5046,'fr','# Fois vu',0),(181651,5046,'jp','è¡¨ç¤ºã?•ã‚Œã?Ÿå›žæ•°',0),(181652,5046,'pt','# Vezes vistos',0),(181653,5046,'ru','# Ð Ð°Ð· ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÐ½Ð¾',0),(181654,5046,'es','# de Veces Visionados',0),(181655,5046,'de','# Mal gesehen',0),(181656,5046,'en','# Times Viewed',0),(181657,5047,'is','',0),(181658,5047,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø­ØµÙˆÙ„Ø§Øª Ú¯Ø²Ø§Ø±Ø´ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(181659,5047,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø­ØµÙˆÙ„Ø§Øª Ú¯Ø²Ø§Ø±Ø´ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(181660,5047,'tr','Rapor GÃ¶rÃ¼nÃ¼mÃ¼ Ã¼rÃ¼nler incelendi',0),(181661,5047,'pl','Zobacz produkty obejrzeli raportu',0),(181662,5047,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸ ÑÐ° Ñ€Ð°Ð·Ð³Ð»ÐµÐ´Ð°Ð»Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(181663,5047,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ù…Ù†Ø¸Ø± Ù…ØµÙ†ÙˆØ¹Ø§Øª Ø¯ÛŒÚ©Ú¾Ø§',0),(181664,5047,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(181665,5047,'vi','Xem bÃ¡o cÃ¡o thÃ nh pháº©m Ä‘Ã£ xem',0),(181666,5047,'af','Besigtig Produkte \"Viewed\" Verslag',0),(181667,5047,'ro','Vezi produsele au vÄƒzut raport',0),(181668,5047,'et','Vaata tooteid vaatasid aruanne',0),(181669,5047,'si','Oglejte si izdelke, so si ogledali poroÄilo',0),(181670,5047,'ba','Lihat produk melihat laporan',0),(181671,5047,'nl','Bekijk de producten bekeken verslag',0),(181672,5047,'fi','NÃ¤ytÃ¤ tuotteet ovat katsoneet mietintÃ¶Ã¤',0),(181673,5047,'no','Vis produkter vises rapporten',0),(181674,5047,'da','Se produkter set pÃ¥ betÃ¦nkningen',0),(181675,5047,'ko','ì œí’ˆ ë³´ê¸° ì „ë§ ë³´ê³ ì„œ',0),(181676,5047,'he','×ª×¦×•×’×ª ×ž×•×¦×¨×™× ×¦×¤×• ×‘ ×—',0),(181677,5047,'el','Î”ÎµÎ¯Ï„Îµ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î± ÎµÎ¯Î´Î±Î½ Ï„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ·',0),(181678,5047,'zh','æŸ¥çœ‹äº§å“æŠ¥å‘Š\r\n',0),(181679,5047,'sv','Visa produkter tittade pÃ¥ rapport',0),(181680,5047,'it','Visualizza i prodotti hanno guardato Report',0),(181681,5047,'tl','',0),(181682,5047,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(181683,5047,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥ƒà¤¶à¥à¤¯ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¥‹à¤‚ à¤¦à¥‡à¤–à¤¾ à¤—à¤¯à¤¾',0),(181684,5047,'ms','View produk melihat Laporan',0),(181685,5047,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ù†ØªØ¬Ø§Øª ÙŠÙ†Ø¸Ø± Ø¥Ù„Ù‰ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(181686,5047,'fr','Produits vue lus rapport',0),(181687,5047,'jp','è¡¨ç¤ºæ¸ˆè£½å“?ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(181688,5047,'pt','Ver os produtos vistos relatÃ³rio',0),(181689,5047,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð² ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÐ»Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(181690,5047,'es','Visionar Informe de Productos Vistos',0),(181691,5047,'de','Produkte anzeigen gesehen Bericht',0),(181692,5047,'en','View Products Viewed Report',0),(181693,5048,'is','',0),(181694,5048,'dr',': Ø³ÙŠ 30 Ø±ÙˆØ²',0),(181695,5048,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø§Ø³ØªØ§Ù† Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ : Ø³ÙŠ 30 Ø±ÙˆØ²',0),(181696,5048,'tr','En iyi 10 satÄ±ÅŸ devletler - 30 gÃ¼n',0),(181697,5048,'pl','Top 10 sprzedaÅ¼y PaÅ„stwa - 30 dni',0),(181698,5048,'bg','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð¸ - 30 Ð´Ð½Ð¸',0),(181699,5048,'ur','Ù¹Ø§Ù¾ 10 Ø³ÛŒÙ„Ø² ÛØ§Ø¦Û’ - ØªÛŒØ³ Ø¯Ù†',0),(181700,5048,'sr','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð´Ñ€Ð¶Ð°Ð²Ð° - 30 Ð´Ð°Ð½Ð°',0),(181701,5048,'vi','MÆ°á»i tiá»ƒu bang bÃ¡n tá»‘t nháº¥t: 30 ngÃ y ',0),(181702,5048,'af','Top 10 Verkoopstate: 30 Dae',0),(181703,5048,'ro','Top 10 vÃ¢nzÄƒri Statele - 30 de zile',0),(181704,5048,'et','Top 10 Sales riike - 30 pÃ¤eva',0),(181705,5048,'si','Top 10 prodaja drÅ¾ave - 30 dni',0),(181706,5048,'ba','Top 10 penjualan negara - 30 hari',0),(181707,5048,'nl','Top 10 verkoop Staten - 30 dagen',0),(181708,5048,'fi','Top 10 Sales toteaa - 30 pÃ¤ivÃ¤Ã¤',0),(181709,5048,'no','Topp 10 salg stater - 30 dager',0),(181710,5048,'da','Top 10 salg stater - 30 dage',0),(181711,5048,'ko','í†± 10 íŒë§¤ ìƒíƒœ-30 ì¼',0),(181712,5048,'he','Top 10 ×ž×“×™× ×•×ª ×”×ž×›×™×¨×•×ª - 30 ×™×ž×™×',0),(181713,5048,'el','Top 10 Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î¼Î­Î»Î· - 30 Î·Î¼Î­ÏÎµÏ‚',0),(181714,5048,'zh','é”€å”®å‰10åçš„å›½å®¶ï¼š30å¤©\r\n',0),(181715,5048,'sv','Top 10 fÃ¶rsÃ¤ljning stater - 30 dagar',0),(181716,5048,'it','Top 10 vendite stati - 30 giorni',0),(181717,5048,'tl','',0),(181718,5048,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618; : 30&#3623;&#3633;&#3609;',0),(181719,5048,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤¬à¤¿à¤•à¥à¤°à¥€ à¤°à¤¾à¤œà¥à¤¯à¥‹à¤‚ - 30 à¤¦à¤¿à¤¨',0),(181720,5048,'ms','Top 10 jualan syarikat - 30 hari',0),(181721,5048,'ar','Ø£Ø¹Ù„Ù‰ 10 Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø¯ÙˆÙ„--30 ÙŠÙˆÙ…Ø§',0),(181722,5048,'fr','Top 10 ventes Ã‰tats - 30 jours',0),(181723,5048,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?ã‚»ãƒ¼ãƒ«ã‚¹å·žï¼šï¼“ï¼?æ—¥é–“',0),(181724,5048,'pt','Top 10 vendas Estados - 30 dias',0),(181725,5048,'ru','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð° - 30 Ð´Ð½ÐµÐ¹',0),(181726,5048,'es','Los 10 Estados Principales de Ventas: 30 DÃ­as',0),(181727,5048,'de','Top 10 Sales Staaten - 30 Tage',0),(181728,5048,'en','Top 10 Sales States - 30 Days',0),(181729,5049,'is','',0),(181730,5049,'dr',': ÙŠÙƒ Ø³Ø§Ù„',0),(181731,5049,'pr','Ø¯Ù‡ ØªØ§ Ø§Ø² Ø§Ø³ØªØ§Ù† Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ : ÙŠÙƒ Ø³Ø§Ù„',0),(181732,5049,'tr','En iyi 10 satÄ±ÅŸ devletler - 1 yÄ±l',0),(181733,5049,'pl','Top 10 sprzedaÅ¼y PaÅ„stwa - 1 rok',0),(181734,5049,'bg','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(181735,5049,'ur','1 Ø³Ø§Ù„ Ù¾ÛÙ„Û’ 10 Ø³ÛŒÙ„Ø² Ø§Ù…Ø±ÛŒÚ©Û-',0),(181736,5049,'sr','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð° Ð´Ñ€Ð¶Ð°Ð²Ðµ - 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(181737,5049,'vi','MÆ°á»i tiá»ƒu bang bÃ¡n tá»‘t nháº¥t: 1 nÄƒm',0),(181738,5049,'af','Top 10 Verkoopstate: 1 Jaar',0),(181739,5049,'ro','Top 10 vÃ¢nzÄƒri Statele - 1 an',0),(181740,5049,'et','Top 10 Sales riike - 1 aasta',0),(181741,5049,'si','Top 10 prodaja drÅ¾ave - 1 leto',0),(181742,5049,'ba','Top 10 penjualan Serikat - 1 tahun',0),(181743,5049,'nl','Top 10 verkoop Staten - 1 jaar',0),(181744,5049,'fi','Top 10 Sales toteaa - 1 vuosi',0),(181745,5049,'no','Topp 10 salg stater - 1 Ã¥r',0),(181746,5049,'da','Top 10 salg stater - 1 Ã¥r',0),(181747,5049,'ko','í†± 10 íŒë§¤ ìƒíƒœ-1 ë…„',0),(181748,5049,'he','Top 10 ×ž×“×™× ×•×ª ×”×ž×›×™×¨×•×ª - 1 ×©× ×”',0),(181749,5049,'el','Top 10 Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î¼Î­Î»Î· - 1 Î­Ï„Î¿Ï‚',0),(181750,5049,'zh','é”€å”®å‰10åçš„å›½å®¶ï¼š1å¹´\r\n',0),(181751,5049,'sv','Top 10 fÃ¶rsÃ¤ljning stater - 1 Ã¥r',0),(181752,5049,'it','Top 10 vendite stati - 1 anno',0),(181753,5049,'tl','',0),(181754,5049,'th','10 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618; : 1&#3611;&#3637;',0),(181755,5049,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤¬à¤¿à¤•à¥à¤°à¥€ à¤°à¤¾à¤œà¥à¤¯à¥‹à¤‚ - 1 à¤¸à¤¾à¤²',0),(181756,5049,'ms','Top 10 jualan syarikat - 1 tahun',0),(181757,5049,'ar','Ø£Ø¹Ù„Ù‰ 10 Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø¯ÙˆÙ„-Ø³Ù†Ø© 1',0),(181758,5049,'fr','Top 10 ventes Ã‰tats - 1 an',0),(181759,5049,'jp','ãƒˆãƒƒãƒ—ï¼‘ï¼?ã‚»ãƒ¼ãƒ«ã‚¹å·žï¼šï¼‘å¹´',0),(181760,5049,'pt','Top 10 vendas Estados - 1 ano',0),(181761,5049,'ru','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð° - 1 Ð³Ð¾Ð´',0),(181762,5049,'es','Los 10 Estados Principales de Ventas: 1 AÃ±o',0),(181763,5049,'de','Top 10 Sales Staaten - 1 Jahr',0),(181764,5049,'en','Top 10 Sales States - 1 Year',0),(181765,5050,'is','',0),(181766,5050,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ ',0),(181767,5050,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ ',0),(181768,5050,'tr','SipariÅŸ birimi raporu gÃ¶rÃ¼ntÃ¼le',0),(181769,5050,'pl','WyÅ›wietl raport wielkoÅ›ci zamÃ³wienia',0),(181770,5050,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(181771,5050,'ur','Ù…Ù†Ø¸Ø± ØªØ±ØªÛŒØ¨ ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹',0),(181772,5050,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(181773,5050,'vi','Xem bÃ¡o cÃ¡o khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng',0),(181774,5050,'af','Besigtig Bestellingsvolume Verslag',0),(181775,5050,'ro','Vizualizare comanda volum raport',0),(181776,5050,'et','Kuva tellimuse mahu aruanne',0),(181777,5050,'si','Ogled nalog obsega poroÄila',0),(181778,5050,'ba','Lihat urutan Volume laporan',0),(181779,5050,'nl','Volgorde Volume-rapport weergeven',0),(181780,5050,'fi','NÃ¤ytÃ¤ tilauksen mÃ¤Ã¤rÃ¤ raportti',0),(181781,5050,'no','Vis volum rapport',0),(181782,5050,'da','Vis ordre volumen rapport',0),(181783,5050,'ko','ì£¼ë¬¸ ë³¼ë¥¨ ë³´ê³ ì„œ ë³´ê¸°',0),(181784,5050,'he','×”×¦×’ ×¡×“×¨ × ×¤×— ×“×•×—',0),(181785,5050,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏŒÎ³ÎºÎ¿Ï… Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(181786,5050,'zh','æŸ¥çœ‹è®¢å•é‡ç”³æŠ¥è¡¨\r\n',0),(181787,5050,'sv','Visa Order volym rapport',0),(181788,5050,'it','Visualizza ordine Volume rapporto',0),(181789,5050,'tl','',0),(181790,5050,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(181791,5050,'hi','à¤†à¤¦à¥‡à¤¶ à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(181792,5050,'ms','Laporan jumlah pesanan View',0),(181793,5050,'ar','Ø¹Ø±Ø¶ ØªØ±ØªÙŠØ¨ Ø­Ø¬Ù… Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(181794,5050,'fr','Vue Ã‰tat de commande Volume',0),(181795,5050,'jp','æ³¨æ–‡å‡ºæ?¥é«˜ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(181796,5050,'pt','Exibir relatÃ³rio de Volume de ordem',0),(181797,5050,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð¾Ð±ÑŠÐµÐ¼ Ð·Ð°ÐºÐ°Ð·Ð°',0),(181798,5050,'es','Visionar Informe de VolÃºmen de Ordenes',0),(181799,5050,'de','Bestellung-Volume-Bericht anzeigen',0),(181800,5050,'en','View Order Volume Report',0),(181801,5051,'is','',0),(181802,5051,'dr','Ø¨Ø±Ø±Ø³ÙŠ ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù†',0),(181803,5051,'pr','Ø¨Ø±Ø±Ø³ÙŠ ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù†',0),(181804,5051,'tr','Fatura edilecek tÃ¼m sipariÅŸlerini denetleme',0),(181805,5051,'pl','SprawdÅº wszystkie zamÃ³wienia do zafakturowania',0),(181806,5051,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(181807,5051,'ur','Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ø¬Ø§ Ù„ÛŒÛ’ Ú©Û’ ØªÙ…Ø§Ù… Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(181808,5051,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ²Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(181809,5051,'vi','Kiá»ƒm tra táº¥t cáº£ Ä‘Æ¡n Ä‘áº·t hÃ ng sáº½ xuáº¥t hÃ³a Ä‘Æ¡n',0),(181810,5051,'af','Nasien van Alle Bestellings om Gefaktureer te word',0),(181811,5051,'ro','Verifica toate comenzile sÄƒ fie facturate',0),(181812,5051,'et','MÃ¤rgi kÃµik tellimused arvete vormistamiseks',0),(181813,5051,'si','Preverite vsa naroÄila za fakturiranje',0),(181814,5051,'ba','Periksa Semua Penanan yang akan di buatkan Faktur',0),(181815,5051,'nl','Alle bestellingen worden gefactureerd bekijken',0),(181816,5051,'fi','Tarkista kaikkien tilausten laskutettavaksi',0),(181817,5051,'no','Sjekk alle bestillinger som skal faktureres',0),(181818,5051,'da','Kontroller alle ordrer skal faktureres',0),(181819,5051,'ko','ëª¨ë“  ì£¼ë¬¸ ì²­êµ¬ í™•ì¸',0),(181820,5051,'he','×œ×‘×“×•×§ ××ª ×›×œ ×”×”×–×ž× ×•×ª ×œ×”× ×¤×§×ª ×—×©×‘×•× ×™×ª',0),(181821,5051,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î¸Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î·Î¸Î¿ÏÎ½',0),(181822,5051,'zh','æ£€æŸ¥æ‰€æœ‰è®¢å•å¼€å‘ç¥¨\r\n',0),(181823,5051,'sv','Kontrollera alla order som ska faktureras',0),(181824,5051,'it','Controllare tutti gli ordini da fatturare',0),(181825,5051,'tl','',0),(181826,5051,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3649;&#3621;&#3657;&#3623;&#3629;&#3629;&#3585;&#3651;&#3610;&#3649;&#3592;&#3657;&#3',0),(181827,5051,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(181828,5051,'ms','Semak semua pesanan untuk dapat invois',0),(181829,5051,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† ÙƒØ§ÙØ© Ø£ÙˆØ§Ù…Ø± Ù„Ù„ÙÙˆØªØ±Ø©',0),(181830,5051,'fr','VÃ©rifier toutes les commandes Ã  facturer',0),(181831,5051,'jp','è«‹æ±‚ã?™ã‚‹å…¨ã?¦ã?®æ³¨æ–‡ã‚’ç¢ºèª?',0),(181832,5051,'pt','Verifique todas as ordens para ser faturado',0),(181833,5051,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ðº Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐµ',0),(181834,5051,'es','Chequear Todos los Pedidos que serÃ¡n Facturados',0),(181835,5051,'de','ÃœberprÃ¼fen Sie alle Bestellungen zu fakturierende',0),(181836,5051,'en','Check All Orders to Be Invoiced',0),(181837,5052,'is','',0),(181838,5052,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù† ',0),(181839,5052,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù† ',0),(181840,5052,'tr','Fatura miktarÄ±',0),(181841,5052,'pl','IloÅ›Ä‡ do rachunku',0),(181842,5052,'bg','ÐšÐ¾Ð»-Ð²Ð¾ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(181843,5052,'ur','Ø¨Ù„ Ú©ÛŒ Ù‚ÛŒ',0),(181844,5052,'sr','ÐšÐ¾Ð» Ð‘Ð¸Ð»Ñƒ',0),(181845,5052,'vi','Sá»‘ lÆ°á»£ng Ä‘á»ƒ ra hÃ³a Ä‘Æ¡n',0),(181846,5052,'af','Hoev. te Faktureer ',0),(181847,5052,'ro','Cantit la factura',0),(181848,5052,'et','Tk arve',0),(181849,5052,'si','KoliÄina za Bill',0),(181850,5052,'ba','Qty tagihan',0),(181851,5052,'nl','Aantal Bill',0),(181852,5052,'fi','Kpl lasku',0),(181853,5052,'no','Antall Bill',0),(181854,5052,'da','Antal til Bill',0),(181855,5052,'ko','ë¹Œ í•˜ ìˆ˜ëŸ‰',0),(181856,5052,'he','×›×ž×•×ª ×©×œ ×‘×™×œ',0),(181857,5052,'el','Qty Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(181858,5052,'zh','å…¥è´¦çš„æ•°é‡\r\n',0),(181859,5052,'sv','Kvt att Bill',0),(181860,5052,'it','Qty per Bill',0),(181861,5052,'tl','',0),(181862,5052,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3648;&#3614;&#3639;&#3656;&#3629;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(181863,5052,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(181864,5052,'ms','Qty kepada Rang undang-undang',0),(181865,5052,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø¥Ù„Ù‰ Ø¨ÙŠÙ„',0),(181866,5052,'fr','QtÃ© Ã  Bill',0),(181867,5052,'jp','è«‹æ±‚æ•°é‡?',0),(181868,5052,'pt','Qtde de Bill',0),(181869,5052,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð´Ð»Ñ Ð‘Ð¸Ð»Ð»Ð°',0),(181870,5052,'es','Cant. para Facturar',0),(181871,5052,'de','Qty, Bill',0),(181872,5052,'en','Qty to Bill',0),(181873,5053,'is','',0),(181874,5053,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡  Ø±ÙˆÙŠ ',0),(181875,5053,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡  Ø±ÙˆÙŠ ',0),(181876,5053,'tr','TamamlanmÄ±ÅŸ sipariÅŸleri',0),(181877,5053,'pl','ZakoÅ„czonych zleceÅ„ na',0),(181878,5053,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð°',0),(181879,5053,'ur','Ù…Ú©Ù…Ù„ Ø´Ø¯Û Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø±',0),(181880,5053,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸ Ð·Ð°Ð´Ð°Ñ‚Ð°Ðº Ñƒ',0),(181881,5053,'vi','HoÃ n ThÃ nh ÄÆ¡n Äáº·t HÃ ng trÃªn',0),(181882,5053,'af','Voltooide Bestellings Op',0),(181883,5053,'ro','Comenzi finalizate pe',0),(181884,5053,'et','TÃ¤idetud korralduste kohta',0),(181885,5053,'si','Dopolnil naroÄila na',0),(181886,5053,'ba','Pesanan Terpenuhi Pada',0),(181887,5053,'nl','Voltooide bestellingen op',0),(181888,5053,'fi','Valmiit tilaukset',0),(181889,5053,'no','FullfÃ¸rt ordre pÃ¥',0),(181890,5053,'da','FÃ¦rdige ordrer pÃ¥',0),(181891,5053,'ko','ì™„ë£Œ ëœ ì£¼ë¬¸ì—',0),(181892,5053,'he','×”×–×ž× ×•×ª ×”×•×©×œ×ž×”-',0),(181893,5053,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÏƒÏ…Î¼Ï€Î»Î·ÏÏ‰Î¸ÎµÎ¯ Î³Î¹Î±',0),(181894,5053,'zh','å¯¹å·²å®Œæˆè®¢å•\r\n',0),(181895,5053,'sv','Avslutade bestÃ¤llningar pÃ¥',0),(181896,5053,'it','Ordini Completati il',0),(181897,5053,'tl','',0),(181898,5053,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;&#3586;&#3629;&#3591;',0),(181899,5053,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°',0),(181900,5053,'ms','Perintah-perintah yang siap dibina pada',0),(181901,5053,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø© ÙÙŠ',0),(181902,5053,'fr','Commandes exÃ©cutÃ©es sur',0),(181903,5053,'jp','ï½žã?®æ³¨æ–‡ã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(181904,5053,'pt','Ordens concluÃ­das no',0),(181905,5053,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(181906,5053,'es','Pedidos Completados en',0),(181907,5053,'de','Abgeschlossene AuftrÃ¤ge auf',0),(181908,5053,'en','Completed Orders On',0),(181909,5054,'is','',0),(181910,5054,'dr','ØªØ§Ø±ÙŠØ® ÙƒØ§Ù…Ù„ Ø´Ø¯Ù† ',0),(181911,5054,'pr','ØªØ§Ø±ÙŠØ® ÙƒØ§Ù…Ù„ Ø´Ø¯Ù† ',0),(181912,5054,'tr','Tam tarihi',0),(181913,5054,'pl','Data kompletny',0),(181914,5054,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿ÑŠÐ»Ð½Ð¾',0),(181915,5054,'ur','ØªØ§Ø±ÛŒØ® Ù…Ú©Ù…Ù„',0),(181916,5054,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾',0),(181917,5054,'vi','NgÃ y hoÃ n táº¥t',0),(181918,5054,'af','Datum Voltooi',0),(181919,5054,'ro','Data complet',0),(181920,5054,'et','KuupÃ¤eva tÃ¤ieliku',0),(181921,5054,'si','Datum popolne',0),(181922,5054,'ba','Tanggal selesai',0),(181923,5054,'nl','Datum voltooid',0),(181924,5054,'fi','TÃ¤ydellinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(181925,5054,'no','Dato fullfÃ¸rt',0),(181926,5054,'da','Dato fuldfÃ¸rt',0),(181927,5054,'ko','ì™„ë£Œ ë‚ ì§œ',0),(181928,5054,'he','×ª××¨×™×š ×ž×œ×',0),(181929,5054,'el','Î Î»Î®ÏÎ·Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(181930,5054,'zh','å®Œæˆæ—¥æœŸ\r\n',0),(181931,5054,'sv','Datum komplett',0),(181932,5054,'it','Data completa',0),(181933,5054,'tl','',0),(181934,5054,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(181935,5054,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(181936,5054,'ms','Tarikh selesai',0),(181937,5054,'ar','ØªØ§Ø±ÙŠØ® ÙƒØ§Ù…Ù„Ø©',0),(181938,5054,'fr','Date complÃ¨te',0),(181939,5054,'jp','å®Œäº†æ—¥',0),(181940,5054,'pt','Data completa',0),(181941,5054,'ru','Ð”Ð°Ñ‚Ð° Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ',0),(181942,5054,'es','Fecha Completa',0),(181943,5054,'de','Datum abgeschlossen',0),(181944,5054,'en','Date Complete',0),(181945,5055,'is','',0),(181946,5055,'dr','ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù† ',0),(181947,5055,'pr','ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù† ',0),(181948,5055,'tr','Fatura tarihi',0),(181949,5055,'pl','Data zafakturowania',0),(181950,5055,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(181951,5055,'ur','Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(181952,5055,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð¸',0),(181953,5055,'vi','NgÃ y ra hÃ³a Ä‘Æ¡n',0),(181954,5055,'af','Datum Gefaktureer',0),(181955,5055,'ro','Data facturate',0),(181956,5055,'et','Arve kuupÃ¤ev',0),(181957,5055,'si','Datum fakture',0),(181958,5055,'ba','Tanggal yang ditagih',0),(181959,5055,'nl','Datum gefactureerd',0),(181960,5055,'fi','Laskutettu pvm',0),(181961,5055,'no','Dato fakturert',0),(181962,5055,'da','Dato faktureret',0),(181963,5055,'ko','ì²­êµ¬ ë‚ ì§œ',0),(181964,5055,'he','×ª××¨×™×š ×—×©×‘×•× ×™×ª',0),(181965,5055,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î®Î¸Î·ÎºÎµ',0),(181966,5055,'zh','å¼€ç¥¨æ—¥æœŸ\r\n',0),(181967,5055,'sv','Datum som fakturerats',0),(181968,5055,'it','Data fatturata',0),(181969,5055,'tl','',0),(181970,5055,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(181971,5055,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(181972,5055,'ms','Tarikh invois',0),(181973,5055,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(181974,5055,'fr','Date de facture',0),(181975,5055,'jp','è«‹æ±‚æ—¥',0),(181976,5055,'pt','Data facturada',0),(181977,5055,'ru','Ð”Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð°',0),(181978,5055,'es','Fecha Facturada',0),(181979,5055,'de','Datum Rechnung',0),(181980,5055,'en','Date Invoiced',0),(181981,5056,'is','',0),(181982,5056,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù‡ Ø¯Ø±',0),(181983,5056,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù‡ Ø¯Ø±',0),(181984,5056,'tr','Faturalanan sipariÅŸ',0),(181985,5056,'pl','Zafakturowane zamÃ³wienia na',0),(181986,5056,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°',0),(181987,5056,'ur','Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ú©Û’ Ø­Ú©Ù… Ù¾Ø±',0),(181988,5056,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð½Ð°',0),(181989,5056,'vi','ÄÆ¡n Ä‘áº·t hÃ ng Ä‘Ã£ ra hÃ³a Ä‘on cho',0),(181990,5056,'af','Gefaktureerde Bestellings Op',0),(181991,5056,'ro','Comenzi de facturat',0),(181992,5056,'et','Arveldatud tellimuste kohta',0),(181993,5056,'si','KnjiÅ¾ene naloge na',0),(181994,5056,'ba','Pesanan dibuatkan Faktur Pada',0),(181995,5056,'nl','Gefactureerde Orders op',0),(181996,5056,'fi','Laskutetut tilaukset',0),(181997,5056,'no','Fakturerte bestillinger pÃ¥',0),(181998,5056,'da','Fakturerede ordrer pÃ¥',0),(181999,5056,'ko','ë°œë¶€ ì£¼ë¬¸ì—',0),(182000,5056,'he','×”×–×ž× ×•×ª ×¢× ×—×©×‘×•× ×™×ª ×¢×œ',0),(182001,5056,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½ÎµÏ‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ ÏƒÏ„Î¹Ï‚',0),(182002,5056,'zh','åœ¨å¼€å…·å‘ç¥¨çš„è®¢å•ä¸Š\r\n',0),(182003,5056,'sv','Fakturerade order pÃ¥',0),(182004,5056,'it','Ordini fatturati su',0),(182005,5056,'tl','',0),(182006,5056,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;',0),(182007,5056,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¤¿à¤ à¤—à¤ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°',0),(182008,5056,'ms','Invois pesanan terakhir',0),(182009,5056,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…ÙÙˆØªØ±Ø© Ø¹Ù„Ù‰',0),(182010,5056,'fr','Commandes facturÃ©es sur',0),(182011,5056,'jp','ï½žã?®æ³¨æ–‡ã?Œè«‹æ±‚ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(182012,5056,'pt','Facturado ordens na',0),(182013,5056,'ru','Ð ÐµÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð°',0),(182014,5056,'es','Ordenes Facturados En',0),(182015,5056,'de','Fakturierten AuftrÃ¤ge auf',0),(182016,5056,'en','Invoiced Orders On',0),(182017,5057,'is','',0),(182018,5057,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(182019,5057,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(182020,5057,'tr','AlÄ±nan sipariÅŸler',0),(182021,5057,'pl','OtrzymaÅ‚ zamÃ³wienia na',0),(182022,5057,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°',0),(182023,5057,'ur','Ù…ÙˆØµÙˆÙ„Û Ú©Û’ Ø­Ú©Ù… Ù¾Ø±',0),(182024,5057,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð½Ð°',0),(182025,5057,'vi','ÄÃ£ nháº­n Ä‘Æ¡n hÃ ng cho',0),(182026,5057,'af','Ontvangde Bestellings Op',0),(182027,5057,'ro','Comenzile primite pe',0),(182028,5057,'et','Saadud korralduste kohta',0),(182029,5057,'si','Prejemalo naroÄila na',0),(182030,5057,'ba','Menerima pesanan pada',0),(182031,5057,'nl','Ontvangen Orders op',0),(182032,5057,'fi','Vastaanotetut tilaukset',0),(182033,5057,'no','Mottatte ordrer pÃ¥',0),(182034,5057,'da','Modtaget ordrer pÃ¥',0),(182035,5057,'ko','ë°›ì€ ì£¼ë¬¸ì—',0),(182036,5057,'he','×”×–×ž× ×•×ª ×©×”×ª×§×‘×œ×• ×¢×œ',0),(182037,5057,'el','Î›Î¬Î²ÎµÎ¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î³Î¹Î±',0),(182038,5057,'zh','æ”¶åˆ°çš„è®¢å•åœ¨\r\n',0),(182039,5057,'sv','Mottagna order pÃ¥',0),(182040,5057,'it','Ordini ricevuti sul',0),(182041,5057,'tl','',0),(182042,5057,'th','&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3617;&#3639;&#3656;&#3629;',0),(182043,5057,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°',0),(182044,5057,'ms','Tempahan yang diterima pada',0),(182045,5057,'ar','ØªÙ„Ù‚ÙŠ Ø£ÙˆØ§Ù…Ø± ÙÙŠ',0),(182046,5057,'fr','Commandes reÃ§ues sur',0),(182047,5057,'jp','ï½žã?®æ³¨æ–‡ã‚’å?—é ˜ã?—ã?¾ã?—ã?Ÿ',0),(182048,5057,'pt','Ordens recebidas na',0),(182049,5057,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð½Ð°',0),(182050,5057,'es','Ordenes Recibidos En',0),(182051,5057,'de','Erhaltene Bestellungen',0),(182052,5057,'en','Received Orders On',0),(182053,5058,'is','',0),(182054,5058,'dr','(Ø§Ø®ÙŠØ±',0),(182055,5058,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ú¯Ø°Ø´ØªÙ‡ (Ø§Ø®ÙŠØ±',0),(182056,5058,'tr','GeÃ§ sipariÅŸlerini yazdÄ±rÄ±n',0),(182057,5058,'pl','Pod koniec druku zamÃ³wienia',0),(182058,5058,'bg','ÐšÑŠÑÐ½Ð¾ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(182059,5058,'ur','Ù…Ø±Ø­ÙˆÙ… Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº',0),(182060,5058,'sr','ÐšÐ°ÑÐ½Ð¾ Ð´Ð° Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(182061,5058,'vi','ÄÆ¡n Ä‘áº·t hÃ ng in muá»™n',0),(182062,5058,'af','Laat Gedrukte Bestellings ',0),(182063,5058,'ro','TÃ¢rziu imprimaÅ£i comenzi',0),(182064,5058,'et','Hilja printimiseks',0),(182065,5058,'si','Pozno tiskanje nalogov',0),(182066,5058,'ba','Cetak Pesanan Terlambat',0),(182067,5058,'nl','Laat afdrukken bestellingen',0),(182068,5058,'fi','MyÃ¶hÃ¤Ã¤n tulostaa tilaukset',0),(182069,5058,'no','Skrive sent ut',0),(182070,5058,'da','Sent Udskriv ordrer',0),(182071,5058,'ko','ëŠ¦ê²Œ ì£¼ë¬¸ ì¸ì‡„',0),(182072,5058,'he','×ž××—×¨ ×œ×”×“×¤×™×¡ ×”×–×ž× ×•×ª',0),(182073,5058,'el','Î‘ÏÎ³Î¬ Î½Î± ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(182074,5058,'zh','é€¾æœŸæ‰“å°è®¢å•\r\n',0),(182075,5058,'sv','Sen skriva ut order',0),(182076,5058,'it','Tardi stampare gli ordini',0),(182077,5058,'tl','',0),(182078,5058,'th','&#3626;&#3633;&#3656;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;&#3621;&#3656;&#3634;&#3594;&#3657;&#3634;',0),(182079,5058,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶',0),(182080,5058,'ms','Lewat mencetak pesanan',0),(182081,5058,'ar','ØªØ£Ø®Ø± Ø·Ø¨Ø§Ø¹Ø© Ø£ÙˆØ§Ù…Ø±',0),(182082,5058,'fr','Imprimer vers la fin des commandes',0),(182083,5058,'jp','é?…å»¶å?°åˆ·æ³¨æ–‡',0),(182084,5058,'pt','Tarde imprimir ordens',0),(182085,5058,'ru','ÐŸÐ¾Ð·Ð´Ð½Ð¾ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(182086,5058,'es','Ordenes de ImpresiÃ³n Tardes',0),(182087,5058,'de','SpÃ¤t Drucken AuftrÃ¤ge',0),(182088,5058,'en','Late Print Orders',0),(182089,5059,'is','',0),(182090,5059,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(182091,5059,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(182092,5059,'tr','Bir sÃ¼re sonu seÃ§in Tarih kesme',0),(182093,5059,'pl','Wybierz powodu daty granicznej',0),(182094,5059,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð°Ð´ÐµÐ¶ Ð´Ð°Ñ‚Ð° Ð¸Ð·ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ÐµÐ»',0),(182095,5059,'ur','Ø§ÛŒÚ© Ù…Ù‚Ø±Ø±Û Ù…Ù†ØªØ®Ø¨ ÙØ±ÛŒÙ… Cutoff Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(182096,5059,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½ÐµÐºÐ¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð³Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(182097,5059,'vi','Lá»±a chá»n ngÃ y Ä‘áº¿n háº¡n',0),(182098,5059,'af','Selekteer \'n Verskuldigde Afsnydatums',0),(182099,5059,'ro','SelectaÅ£i un util data Cutoff',0),(182100,5059,'et','Valige Due Date tarneseisak',0),(182101,5059,'si','Izberite ustrezno datum prekinitve',0),(182102,5059,'ba','Pilih Due tanggal Cutoff',0),(182103,5059,'nl','Selecteer een Due datum Cutoff',0),(182104,5059,'fi','Valitse mÃ¤Ã¤rÃ¤pÃ¤ivÃ¤ mennessÃ¤ sulku',0),(182105,5059,'no','Velg en Due Date Cutoff',0),(182106,5059,'da','VÃ¦lg en behÃ¸rig dato Cutoff',0),(182107,5059,'ko','ì„ íƒ í•˜ëŠ” ê¸°í•œ ë‚ ì§œ êµ¬ë¶„',0),(182108,5059,'he','×‘×—×¨ ×¤×™×¨×¢×•×Ÿ ×ª××¨×™×š ×”×¤×¡×§×ª',0),(182109,5059,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± ÎµÏÎ¸ÎµÏ„Î¿ Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÎºÎ¿Ï€Î®Ï‚',0),(182110,5059,'zh','é€‰æ‹©ä¸€ä¸ªæˆªæ­¢æ—¥æœŸæˆªæ­¢\r\n',0),(182111,5059,'sv','VÃ¤lj en Due Date Cutoff',0),(182112,5059,'it','Selezionare una dovuta data Cutoff',0),(182113,5059,'tl','',0),(182114,5059,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;&#3605;&#3633;&#3604;&#3629;&#3629;&#3585;',0),(182115,5059,'hi','à¤šà¥à¤¨à¥‡à¤‚ à¤à¤• à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¾à¤°à¥€à¤– Cutoff',0),(182116,5059,'ms','Pilih akhir tarikh potong',0),(182117,5059,'ar','Ø­Ø¯Ø¯ Ø§Ù„ÙˆØ§Ø¬Ø¨Ø© Ø­ØªÙ‰ Ø§Ù„Ø¢Ù† Ù‚Ø·Ø¹',0),(182118,5059,'fr','SÃ©lectionnez une Date de coupure',0),(182119,5059,'jp','æœŸæ—¥æ‰“åˆ‡ã‚Šæ—¥ã?®é?¸æŠž',0),(182120,5059,'pt','Selecione uma data de corte',0),(182121,5059,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ Ð½Ð°Ð´Ð»ÐµÐ¶Ð°Ñ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹ Ð¾Ñ‚ÑÐµÑ‡ÐºÐ¸',0),(182122,5059,'es','Seleccionar una Fecha de Vencimiento',0),(182123,5059,'de','WÃ¤hlen Sie eine Due Date Cutoff',0),(182124,5059,'en','Select a Due Date Cutoff',0),(182125,5060,'is','',0),(182126,5060,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ ',0),(182127,5060,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ ',0),(182128,5060,'tr','SipariÅŸi gir',0),(182129,5060,'pl','Edycja zamÃ³wienia',0),(182130,5060,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´',0),(182131,5060,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(182132,5060,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(182133,5060,'vi','Sá»­a ÄÆ¡n Äáº·t HÃ ng',0),(182134,5060,'af','Redigeer Bestelling',0),(182135,5060,'ro','Editarea comenzii',0),(182136,5060,'et','Muuda tellimust',0),(182137,5060,'si','Uredite vrstni red',0),(182138,5060,'ba','Mengedit perintah',0),(182139,5060,'nl','Bestelling bewerken',0),(182140,5060,'fi','Muokkaa tilausta',0),(182141,5060,'no','Redigere rekkefÃ¸lge',0),(182142,5060,'da','Rediger rÃ¦kkefÃ¸lge',0),(182143,5060,'ko','íŽ¸ì§‘ ìˆœì„œ',0),(182144,5060,'he','×¢×¨×•×š ×”×–×ž× ×”',0),(182145,5060,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(182146,5060,'zh','ç¼–è¾‘è®¢å•\r\n',0),(182147,5060,'sv','Redigera Order',0),(182148,5060,'it','Modifica ordine',0),(182149,5060,'tl','',0),(182150,5060,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(182151,5060,'hi','à¤•à¥à¤°à¤® à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(182152,5060,'ms','Edit perintah',0),(182153,5060,'ar','ØªØ­Ø±ÙŠØ± Ø·Ù„Ø¨ÙŠØ©',0),(182154,5060,'fr','Modifier une commande',0),(182155,5060,'jp','æ³¨æ–‡ã?®ç·¨é›†',0),(182156,5060,'pt','Editar a ordem',0),(182157,5060,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·',0),(182158,5060,'es','Editar Pedido',0),(182159,5060,'de','Bestellung bearbeiten',0),(182160,5060,'en','Edit Order',0),(182161,5061,'is','',0),(182162,5061,'dr','Ù†ÙˆØ¹ Ø´ØºÙ„',0),(182163,5061,'pr','Ù†ÙˆØ¹ Ø´ØºÙ„',0),(182164,5061,'tr','Ä°ÅŸ tÃ¼rÃ¼',0),(182165,5061,'pl','Typ pracy',0),(182166,5061,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿',0),(182167,5061,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ Ù‚Ø³Ù…',0),(182168,5061,'sr','Ð’Ñ€ÑÑ‚Ð° Ð¿Ð¾ÑÐ»Ð°',0),(182169,5061,'vi','Loáº¡i Job',0),(182170,5061,'af','Kontrakwerk Tipe',0),(182171,5061,'ro','Tip de muncÄƒ',0),(182172,5061,'et','TÃ¶Ã¶ liik',0),(182173,5061,'si','Job Type',0),(182174,5061,'ba','Jenis pekerjaan',0),(182175,5061,'nl','Taaktype',0),(182176,5061,'fi','TyÃ¶n tyyppi',0),(182177,5061,'no','Jobbtype',0),(182178,5061,'da','Jobtype',0),(182179,5061,'ko','ìž‘ì—… ìœ í˜•',0),(182180,5061,'he','×¡×•×’ ×ž×©×™×ž×”',0),(182181,5061,'el','Î¤ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(182182,5061,'zh','å·¥ä½œç±»åž‹\r\n',0),(182183,5061,'sv','Typ av arbete',0),(182184,5061,'it','Tipo di lavoro',0),(182185,5061,'tl','',0),(182186,5061,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(182187,5061,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(182188,5061,'ms','Jenis pekerjaan',0),(182189,5061,'ar','Ù†ÙˆØ¹ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(182190,5061,'fr','Type d\'emploi',0),(182191,5061,'jp','ä½œæ¥­ã‚¿ã‚¤ãƒ—',0),(182192,5061,'pt','Tipo de trabalho',0),(182193,5061,'ru','Ð¢Ð¸Ð¿ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(182194,5061,'es','Tipo de Trabajo',0),(182195,5061,'de','Auftragstyp',0),(182196,5061,'en','Job Type',0),(182197,5062,'is','',0),(182198,5062,'dr','Ù‡Ù…Ù‡ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø±Ø¨Ù‡  Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(182199,5062,'pr','Ù‡Ù…Ù‡ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø±Ø¨Ù‡  Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(182200,5062,'tr','Tek kalan miktar eklemek iÃ§in tÄ±klatÄ±n',0),(182201,5062,'pl','Kliknij pozycjÄ™ Wszystkie, aby dodaÄ‡ pozostaÅ‚Ä… iloÅ›Ä‡',0),(182202,5062,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð¾ÑÑ‚Ð°Ð½Ð°Ð»Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(182203,5062,'ur','ØªÙ…Ø§Ù… Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Û Ù…Ù‚Ø¯Ø§Ø± Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(182204,5062,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ²Ðµ Ð´Ð° Ð´Ð¾Ð´Ð° ÐŸÑ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(182205,5062,'vi','Nháº¥n Táº¥t cáº£ Ä‘á»ƒ thÃªm sá»‘ lÆ°á»£ng cÃ²n láº¡i',0),(182206,5062,'af','Kliek ALLE om oorblywende hoeveelheid te skep',0),(182207,5062,'ro','FaceÅ£i clic pe toate pentru a adÄƒuga cantitatea rÄƒmasÄƒ',0),(182208,5062,'et','KlÃµpsake kÃµigi Ã¼lejÃ¤Ã¤nud kogus',0),(182209,5062,'si','Kliknite vse dodamo preostalo koliÄino',0),(182210,5062,'ba','Klik semua menambah jumlah sisa',0),(182211,5062,'nl','Klik op alles als u wilt toevoegen van de resterende hoeveelheid',0),(182212,5062,'fi','Valitse kaikki lisÃ¤tÃ¤ jÃ¤ljellÃ¤ oleva mÃ¤Ã¤rÃ¤',0),(182213,5062,'no','Klikk alle for Ã¥ legge til restantallet',0),(182214,5062,'da','Klik pÃ¥ alt for at tilfÃ¸je Restantal',0),(182215,5062,'ko','ë‚¨ì€ ìˆ˜ëŸ‰ì„ ì¶”ê°€ í•˜ë ¤ë©´ ëª¨ë‘ë¥¼ í´ë¦­í•©ë‹ˆë‹¤',0),(182216,5062,'he','×œ×—×¥ ×¢×œ ×”×›×œ ×›×“×™ ×œ×”×•×¡×™×£ ×›×ž×•×ª × ×•×ª×¨×ª',0),(182217,5062,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® ÏŒÎ»Î¿Î¹ Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï„Î·Î½ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(182218,5062,'zh','å•å‡»æ‰€æœ‰ä»¥å¢žåŠ å‰©ä½™æ•°é‡\r\n',0),(182219,5062,'sv','Klicka pÃ¥ alla om du vill lÃ¤gga till resterande kvantitet',0),(182220,5062,'it','Fare clic su tutti per aggiungere quantitÃ  residua',0),(182221,5062,'tl','',0),(182222,5062,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(182223,5062,'hi','à¤¸à¤­à¥€ à¤¶à¥‡à¤· à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(182224,5062,'ms','Klik untuk menambah kuantiti baki semua',0),(182225,5062,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„ÙƒÙ„ Ù„Ø¥Ø¶Ø§ÙØ© Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(182226,5062,'fr','Cliquez sur toutes pour ajouter la quantitÃ© restante',0),(182227,5062,'jp','æ®‹ã‚Šã?®æ•°é‡?ã‚’è¿½åŠ ã?™ã‚‹ã?«ã?¯å…¨ã?¦ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(182228,5062,'pt','Clique em ALL para adicionar a quantidade restante',0),(182229,5062,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð²ÑÐµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾ÑÑ‚Ð°Ð²ÑˆÐµÐµÑÑ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(182230,5062,'es','Click TODO para agregar la Cantidad que sobra',0),(182231,5062,'de','Klicken Sie auf alle hinzufÃ¼gen Restmenge',0),(182232,5062,'en','Click ALL to add remaining quantity',0),(182233,5063,'is','',0),(182234,5063,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(182235,5063,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(182236,5063,'tr','Yeni sevkiyatÄ±n sipariÅŸ iÃ§in',0),(182237,5063,'pl','Nowe dostawy dla zamÃ³wienia',0),(182238,5063,'bg','ÐÐ¾Ð²Ð° Ð¿Ñ€Ð°Ñ‚ÐºÐ° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(182239,5063,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ù†Ø¦ÛŒ Ú©Ú¾ÛŒÙ¾',0),(182240,5063,'sr','ÐÐ¾Ð²Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(182241,5063,'vi','Chuyáº¿n hÃ ng má»›i cho ÄÆ¡n Ä‘áº·t hÃ ng',0),(182242,5063,'af','Nuwe Versending vir Bestelling',0),(182243,5063,'ro','Nou de livrare pentru comanda',0),(182244,5063,'et','Uus tarne tellimusele',0),(182245,5063,'si','Nova poÅ¡iljka za nalog',0),(182246,5063,'ba','Baru pengiriman untuk Order',0),(182247,5063,'nl','Nieuwe verzending voor bestelling',0),(182248,5063,'fi','Uusi lÃ¤hetys tilauksen',0),(182249,5063,'no','Ny forsendelse for ordre',0),(182250,5063,'da','Ny leverance til ordre',0),(182251,5063,'ko','ìˆœì„œë¥¼ ìœ„í•œ ìƒˆë¡œìš´ ì„ ì ',0),(182252,5063,'he','×ž×©×œ×•×— ×—×“×© ×¢×‘×•×¨ ×”×–×ž× ×”',0),(182253,5063,'el','ÎÎ­Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(182254,5063,'zh','æ–°è´§çš„è®¢å•\r\n',0),(182255,5063,'sv','Ny leverans fÃ¶r bestÃ¤llning',0),(182256,5063,'it','Nuova spedizione per ordine',0),(182257,5063,'tl','',0),(182258,5063,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3651;&#3627;&#3617;&#3656;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(182259,5063,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤ˆ à¤–à¥‡à¤ª',0),(182260,5063,'ms','Baru penghantaran untuk pesanan',0),(182261,5063,'ar','Ø´Ø­Ù†Ø© Ø¬Ø¯ÙŠØ¯Ø© Ù„Ù„Ù†Ø¸Ø§Ù…',0),(182262,5063,'fr','Nouvel arrivage pour commander',0),(182263,5063,'jp','æ³¨æ–‡ã?®ç™ºé€?æ³¨æ–‡',0),(182264,5063,'pt','Novo carregamento para a ordem',0),(182265,5063,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(182266,5063,'es','Nuevo EnvÃ­o para el Pedido',0),(182267,5063,'de','Neue Lieferung fÃ¼r Bestellung',0),(182268,5063,'en','New Shipment for Order',0),(182269,5064,'is','',0),(182270,5064,'dr','Ø¯ÙƒÙ…Ù‡ Ù‚Ø¨ÙˆÙ„ Ø±Ø§ Ø¬Ù‡Øª ØªØ§ÙŠÙŠØ¯ ØµØ­ÙŠØ­ Ø¨ÙˆØ¯Ù† Ø§ÙŠÙ† Ú†Ø§Ù¾ Ø¯Ù‡ÙŠØ¯ ',0),(182271,5064,'pr','Ø¯ÙƒÙ…Ù‡ Ù‚Ø¨ÙˆÙ„ Ø±Ø§ Ø¬Ù‡Øª ØªØ§ÙŠÙŠØ¯ ØµØ­ÙŠØ­ Ø¨ÙˆØ¯Ù† Ø§ÙŠÙ† Ú†Ø§Ù¾ Ø¯Ù‡ÙŠØ¯ ',0),(182272,5064,'tr','Bunun doÄŸru olduÄŸunu onaylama iÃ§in OK',0),(182273,5064,'pl','NaciÅ›nij przycisk OK na potwierdzenie, Å¼e to jest prawidÅ‚owe',0),(182274,5064,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ OK, Ð·Ð° Ð´Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´Ð¸, Ñ‡Ðµ Ñ‚Ð¾Ð²Ð° Ðµ Ð¿Ñ€Ð°Ð²Ð¸Ð»ÐµÐ½',0),(182275,5064,'ur','ÛŒÛ Ú©ÙˆØ±Ø±ÛŒÚ©Ù¹ ÛÛ’ Ú©Û ØªØµØ¯ÛŒÙ‚ Ú©Û’ Ù„ÛŒÛ’ Ù¹Ú¾ÛŒÚ© ÛÛ’ Ø¯Ø¨Ø§Ø¦ÛŒÚº',0),(182276,5064,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ ÐžÐš Ð´Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸ Ð´Ð° Ñ˜Ðµ Ñ‚Ð¾ Ð¸ÑÐ¿Ñ€Ð°Ð²Ð¸',0),(182277,5064,'vi','Nháº¥n OK Ä‘á»ƒ xÃ¡c nháº­n náº¿u Ä‘Ãºng',0),(182278,5064,'af','Druk OK om te Bevestig dat dit Korrek is',0),(182279,5064,'ro','ApÄƒsaÅ£i OK pentru a confirma cÄƒ acest lucru este corect',0),(182280,5064,'et','Vajutage OK kinnitate, et see on Ãµige',0),(182281,5064,'si','Pritisnite OK, da potrdi, da je pravilno',0),(182282,5064,'ba','Tekan OK untuk konfirmasi bahwa ini adalah benar',0),(182283,5064,'nl','Druk op OK om te bevestigen dat dit Correct is',0),(182284,5064,'fi','Painamalla OK Vahvista, ettÃ¤ tÃ¤mÃ¤ on oikea',0),(182285,5064,'no','Trykk OK for Ã¥ Bekreft at dette er korrekt',0),(182286,5064,'da','Tryk OK for at BekrÃ¦ft at dette er korrekt',0),(182287,5064,'ko','ì´ê²ƒì´ ì •ë‹µ í™•ì¸ì„ ëˆŒëŸ¬ í™•ì¸',0),(182288,5064,'he','×œ×—×¥ ×¢×œ ××™×©×•×¨ ×›×“×™ ××™×©×•×¨ ×›×™ ×–×” ×¦×•×“×§',0),(182289,5064,'el','Î Î±Ï„Î®ÏƒÏ„Îµ OK Î³Î¹Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· ÏŒÏ„Î¹ Î±Ï…Ï„ÏŒ ÎµÎ¯Î½Î±Î¹ ÏƒÏ‰ÏƒÏ„ÏŒ',0),(182290,5064,'zh','æŒ‰OKç¡®è®¤è¿™æ˜¯æ­£ç¡®çš„\r\n',0),(182291,5064,'sv','Tryck OK fÃ¶r att bekrÃ¤fta att detta Ã¤r korrekt',0),(182292,5064,'it','Premere OK per confermare che questo Ã¨ corretto',0),(182293,5064,'tl','',0),(182294,5064,'th','&#3585;&#3604; OK &#3648;&#3614;&#3639;&#3656;&#3629;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3623;&#3656;&#3634;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(182295,5064,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤ à¥€à¤• à¤¹à¥ˆ à¤•à¤¿ à¤¯à¤¹ à¤¸à¤¹à¥€ à¤¹à¥ˆ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(182296,5064,'ms','Tekan OK untuk mengesahkan bahawa ini adalah membetulkan',0),(182297,5064,'ar','Ø§Ø¶ØºØ· \"Ù…ÙˆØ§ÙÙ‚\" Ù„ØªØ£ÙƒÙŠØ¯ Ø£Ù† Ù‡Ø°Ø§ Ù‡Ùˆ ØªØµØ­ÙŠØ­',0),(182298,5064,'fr','Appuyez sur OK pour confirmer que c\'est Correct',0),(182299,5064,'jp','ã?“ã‚Œã?Œæ­£ã?—ã?‘ã‚Œã?°ç¢ºèª?ã?®ã?Ÿã‚?ã?«ï¼¯ï¼«ã‚’æŠ¼ã?—ã?¦ã??ã? ã?•ã?„',0),(182300,5064,'pt','Pressione OK para confirmar que se trata de corrigir',0),(182301,5064,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ OK, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ, Ñ‡Ñ‚Ð¾ ÑÑ‚Ð¾ Ð¿Ñ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ð¾',0),(182302,5064,'es','Oprimir OK para Confirmar si esto  es correcto',0),(182303,5064,'de','DrÃ¼cken Sie auf OK zu bestÃ¤tigen, dass dies richtig ist',0),(182304,5064,'en','Press OK to Confirm that this is Correct',0),(182305,5065,'is','',0),(182306,5065,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ÙØ±Ø³ØªØ§Ø¯Ù† ',0),(182307,5065,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ÙØ±Ø³ØªØ§Ø¯Ù† ',0),(182308,5065,'tr','MiktarÄ± gÃ¶ndermek iÃ§in',0),(182309,5065,'pl','IloÅ›Ä‡ do wysyÅ‚ania',0),(182310,5065,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ',0),(182311,5065,'ur','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ú¾ÛŒØ¬Ù†Û’ Ú©Ùˆ',0),(182312,5065,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° ÑÐ»Ð°ÑšÐµ',0),(182313,5065,'vi','Sá»‘ lÆ°á»£ng Ä‘á»ƒ gá»­i láº¡i',0),(182314,5065,'af','Hoeveelheid te stuur',0),(182315,5065,'ro','Cantitatea de trimitere',0),(182316,5065,'et','Kogus saada',0),(182317,5065,'si','KoliÄino, poÅ¡iljati',0),(182318,5065,'ba','Kuantitas untuk mengirim',0),(182319,5065,'nl','Te verzenden aantal',0),(182320,5065,'fi','MÃ¤Ã¤rÃ¤ lÃ¤hettÃ¤Ã¤',0),(182321,5065,'no','Antall Send',0),(182322,5065,'da','Antal, der skal sende',0),(182323,5065,'ko','ì†¡ì‹  í•˜ëŠ” ìˆ˜ëŸ‰',0),(182324,5065,'he','×›×ž×•×ª ×œ×©×œ×•×—',0),(182325,5065,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î³Î¹Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(182326,5065,'zh','å‘é€æ•°é‡\r\n',0),(182327,5065,'sv','Kvantitet till skicka',0),(182328,5065,'it','QuantitÃ  da inviare',0),(182329,5065,'tl','',0),(182330,5065,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(182331,5065,'hi','à¤­à¥‡à¤œà¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(182332,5065,'ms','Kuantiti untuk hantar',0),(182333,5065,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø¥Ù„Ù‰ Ø¥Ø±Ø³Ø§Ù„',0),(182334,5065,'fr','QuantitÃ© Ã  envoyer',0),(182335,5065,'jp','ç™ºé€?æ•°é‡?',0),(182336,5065,'pt','Quantidade para enviar',0),(182337,5065,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð»Ñ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(182338,5065,'es','Cantidad para Enviar',0),(182339,5065,'de','Menge zu senden',0),(182340,5065,'en','Quantity to Send',0),(182341,5066,'is','',0),(182342,5066,'dr','Ù…Ø§Ù†Ø¯Ù‡ ',0),(182343,5066,'pr','Ù…Ø§Ù†Ø¯Ù‡ ',0),(182344,5066,'tr','KalÄ±r',0),(182345,5066,'pl','PozostajÄ…',0),(182346,5066,'bg','ÐžÑÑ‚Ð°Ð²Ð°Ñ‚',0),(182347,5066,'ur','Ø±ÛØªÛ’ ÛÛŒÚº',0),(182348,5066,'sr','ÐžÑÑ‚Ð°Ñ˜Ñƒ',0),(182349,5066,'vi','CÃ²n láº¡i',0),(182350,5066,'af','Behou',0),(182351,5066,'ro','RÄƒmÃ¢n',0),(182352,5066,'et','JÃ¤Ã¤vad',0),(182353,5066,'si','Ostajajo',0),(182354,5066,'ba','Tetap',0),(182355,5066,'nl','Blijven',0),(182356,5066,'fi','Edelleen',0),(182357,5066,'no','Forbli',0),(182358,5066,'da','Forblive',0),(182359,5066,'ko','ë‚¨ì•„',0),(182360,5066,'he','×œ×”×™×©××¨',0),(182361,5066,'el','Î Î±ÏÎ±Î¼Î­Î½Î¿Ï…Î½',0),(182362,5066,'zh','ä¿ç•™\r\n',0),(182363,5066,'sv','FÃ¶rbli',0),(182364,5066,'it','Rimangono',0),(182365,5066,'tl','',0),(182366,5066,'th','&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(182367,5066,'hi','à¤°à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(182368,5066,'ms','Kekal',0),(182369,5066,'ar','ØªØ¸Ù„',0),(182370,5066,'fr','Rester',0),(182371,5066,'jp','æ®‹ã‚Š',0),(182372,5066,'pt','Permanecem',0),(182373,5066,'ru','ÐžÑÑ‚Ð°ÑŽÑ‚ÑÑ',0),(182374,5066,'es','Quedar',0),(182375,5066,'de','Bleiben',0),(182376,5066,'en','Remain',0),(182377,5067,'is','',0),(182378,5067,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù…Ù‚ØµØ¯ Ø§Ø±Ø³Ø§Ù„',0),(182379,5067,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù…Ù‚ØµØ¯ Ø§Ø±Ø³Ø§Ù„',0),(182380,5067,'tr','Sevkiyat hedef SeÃ§',0),(182381,5067,'pl','Wybierz miejsce docelowe wysyÅ‚ki',0),(182382,5067,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ Ð¼ÐµÑÑ‚Ð¾Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(182383,5067,'ur','Ø§ÛŒÚ© Ø¬ÛØ§Ø² Ø±Ø§Ù†ÛŒ Ù…Ù‚ØµÙˆØ¯ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(182384,5067,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð´Ñ€ÐµÐ´Ð¸ÑˆÑ‚Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(182385,5067,'vi','Chá»n Ä‘iá»ƒm Ä‘áº¿n',0),(182386,5067,'af','Kies \'n Versending Bestemming',0),(182387,5067,'ro','SelectaÅ£i o destinaÅ£ie de transport maritim',0),(182388,5067,'et','Valige laevandus sihtkoht',0),(182389,5067,'si','Izberite destinacijo dostava',0),(182390,5067,'ba','Pilih tujuan pengiriman',0),(182391,5067,'nl','Selecteer een bestemming verzending',0),(182392,5067,'fi','Valitse postitus kohde',0),(182393,5067,'no','Velg en Shipping destinasjon',0),(182394,5067,'da','VÃ¦lg en Destination, Shipping',0),(182395,5067,'ko','ë°°ì†¡ ë„ì°©ì§€ ì„ íƒ',0),(182396,5067,'he','×‘×—×¨ ×™×¢×“ ×œ×ž×©×œ×•×—',0),(182397,5067,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î±Î½ Ï€ÏÎ¿Î¿ÏÎ¹ÏƒÎ¼ÏŒ Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(182398,5067,'zh','é€‰æ‹©é€è´§ç›®çš„åœ°\r\n',0),(182399,5067,'sv','VÃ¤lj frakt Destination',0),(182400,5067,'it','Selezionare una destinazione di spedizione',0),(182401,5067,'tl','',0),(182402,5067,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3621;&#3634;&#3618;&#3607;&#3634;&#3591;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(182403,5067,'hi','à¤à¤• à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤—à¤‚à¤¤à¤µà¥à¤¯ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(182404,5067,'ms','Pilih destinasi penghantaran',0),(182405,5067,'ar','Ø­Ø¯Ø¯ ÙˆØ¬Ù‡Ø© Ø§Ù„Ø´Ø­Ù†',0),(182406,5067,'fr','SÃ©lectionnez une Destination d\'envoi',0),(182407,5067,'jp','ç™ºé€?å…ˆã‚’é?¸æŠžã?™ã‚‹',0),(182408,5067,'pt','Selecione um destino de envio',0),(182409,5067,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼ÐµÑÑ‚Ð¾ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(182410,5067,'es','Seleccionar un DestÃ­no para Enviar',0),(182411,5067,'de','WÃ¤hlen Sie ein Ziel Versand',0),(182412,5067,'en','Select a Shipping Destination',0),(182413,5068,'is','',0),(182414,5068,'dr','(Ø´Ø±ÙˆØ¹',0),(182415,5068,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²Ù‰(Ø´Ø±ÙˆØ¹',0),(182416,5068,'tr','BaÅŸlangÄ±Ã§',0),(182417,5068,'pl','PoczÄ…wszy od',0),(182418,5068,'bg','Ð¡Ñ‚Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(182419,5068,'ur','Ø´Ø±ÙˆØ¹ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(182420,5068,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸',0),(182421,5068,'vi','Báº¯t Äáº§u',0),(182422,5068,'af','Begin',0),(182423,5068,'ro','Incepand de',0),(182424,5068,'et','Alustades',0),(182425,5068,'si','Odhod',0),(182426,5068,'ba','Mulai',0),(182427,5068,'nl','Starten',0),(182428,5068,'fi','Alkaen',0),(182429,5068,'no','Starter',0),(182430,5068,'da','Start',0),(182431,5068,'ko','ì‹œìž‘',0),(182432,5068,'he','×ž×ª×—×™×œ',0),(182433,5068,'el','ÎžÎµÎºÎ¹Î½ÏŽÎ½Ï„Î±Ï‚',0),(182434,5068,'zh','å¯åŠ¨\r\n',0),(182435,5068,'sv','Start',0),(182436,5068,'it','A partire da',0),(182437,5068,'tl','',0),(182438,5068,'th','&#3585;&#3634;&#3619;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(182439,5068,'hi','à¤¶à¥à¤°à¥‚',0),(182440,5068,'ms','Bermula',0),(182441,5068,'ar','Ø§Ø¨ØªØ¯Ø§Ø¡',0),(182442,5068,'fr','Ã€ partir',0),(182443,5068,'jp','é–‹å§‹',0),(182444,5068,'pt','ComeÃ§ando',0),(182445,5068,'ru','ÐÐ°Ñ‡Ð¸Ð½Ð°Ñ',0),(182446,5068,'es','Inicio',0),(182447,5068,'de','Starten',0),(182448,5068,'en','Starting',0),(182449,5069,'is','',0),(182450,5069,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ ØªØ¹ÙŠÙŠÙ†  Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(182451,5069,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ ØªØ¹ÙŠÙŠÙ†  Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(182452,5069,'tr','GÃ¶ndermek iÃ§in miktarÄ± kalan miktar iÃ§in ayarlanmÄ±ÅŸ',0),(182453,5069,'pl','IloÅ›Ä‡ do wysyÅ‚ania zostaÅ‚a ustawiona na pozostaÅ‚Ä… iloÅ›Ä‡',0),(182454,5069,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð·Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ðµ Ð±Ð¸Ð»Ð° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐµÐ½Ð° Ð½Ð° Ð¾ÑÑ‚Ð°Ð²Ð°Ñ‰Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(182455,5069,'ur','Ø¨Ø§Ù‚ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ú©Ùˆ Ø¨Ú¾ÛŒØ¬Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ØªØ¹Ø¯Ø§Ø¯ Ø³ÛŒÙ¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(182456,5069,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° ÑÐ»Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð° Ñ˜Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(182457,5069,'vi','Sá»‘ lÆ°á»£ng Ä‘á»ƒ gá»­i Ä‘Ã£ Ä‘áº·t Ä‘áº¿n sá»‘ lÆ°á»£ng cÃ²n láº¡i',0),(182458,5069,'af','Die hoeveelheid te stuur is opgestel om die oorblywende hoeveelheid',0),(182459,5069,'ro','Cantitatea de trimite a fost setat la cantitatea rÄƒmasÄƒ',0),(182460,5069,'et','AllesjÃ¤Ã¤nud kogusele mÃ¤Ã¤ratud kogus saata',0),(182461,5069,'si','KoliÄino, poÅ¡iljati nastavljena na preostalo koliÄino',0),(182462,5069,'ba','Kuantitas untuk mengirim telah ditetapkan dengan jumlah sisa',0),(182463,5069,'nl','Het te verzenden aantal is ingesteld op het resterende aantal',0),(182464,5069,'fi','MÃ¤Ã¤ritetty mÃ¤Ã¤rÃ¤Ã¤ lÃ¤hettÃ¤Ã¤ jÃ¤ljelle jÃ¤Ã¤vÃ¤Ã¤',0),(182465,5069,'no','Antallet som skal sende er satt til restantallet',0),(182466,5069,'da','MÃ¦ngden til at sende er blevet angivet til den resterende mÃ¦ngde',0),(182467,5069,'ko','ë‚¨ì€ ìˆ˜ëŸ‰ ë³´ë‚´ë ¤ê³  ìˆ˜ëŸ‰ ì„¤ì • ë˜ì–´',0),(182468,5069,'he','×”×›×ž×•×ª ×œ×©×œ×•×— ×”×’×“×™×¨ ××ª ×”×›×ž×•×ª ×”× ×•×ª×¨×ª',0),(182469,5069,'el','Î— Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€ÏÎ¿Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Î³Î¹Î± Ï„Î·Î½ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(182470,5069,'zh','è¦å‘é€çš„æ•°é‡å·²è¢«è®¾ç½®åˆ°å‰©ä½™æ•°é‡\r\n',0),(182471,5069,'sv','Kvantiteten som skall skicka har angetts till den Ã¥terstÃ¥ende kvantiteten',0),(182472,5069,'it','La quantitÃ  da inviare Ã¨ stata impostata la quantitÃ  rimanente',0),(182473,5069,'tl','',0),(182474,5069,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3648;&#3',0),(182475,5069,'hi','à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¶à¥‡à¤· à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(182476,5069,'ms','Kuantiti untuk menghantar telah disetkan untuk kuantiti baki',0),(182477,5069,'ar','ØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø±Ø§Ø¯ Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(182478,5069,'fr','La quantitÃ© d\'envoyer a Ã©tÃ© fixÃ©e Ã  la quantitÃ© restante',0),(182479,5069,'jp','ç™ºé€?ã?™ã‚‹æ•°é‡?ã?Œæ®‹é‡?ã?«è¨­å®šã?•ã‚Œã?¾ã?—ã?Ÿ',0),(182480,5069,'pt','A quantidade a enviar foi definida como a quantidade restante',0),(182481,5069,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð»Ñ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ ÐµÐ¼Ñƒ Ð±Ñ‹Ð»Ð¾ Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½Ð¾ Ð¾ÑÑ‚Ð°Ð²ÑˆÐµÐµÑÑ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(182482,5069,'es','La Cantidad para enviar se fijÃ³ a la cantidad restante',0),(182483,5069,'de','Die Menge senden auf die verbleibende Menge eingestellt',0),(182484,5069,'en','The Quantity to send has been set to the remaining quantity',0),(182485,5070,'is','',0),(182486,5070,'dr','Ø§Ø®Ø·Ø§Ø± ',0),(182487,5070,'pr','Ø§Ø®Ø·Ø§Ø± ',0),(182488,5070,'tr','UyarÄ±',0),(182489,5070,'pl','OstrzeÅ¼enie',0),(182490,5070,'bg','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ',0),(182491,5070,'ur','ØªÙ†Ø¨ÛŒÛ',0),(182492,5070,'sr','Ð£Ð¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ',0),(182493,5070,'vi','Cáº£nh bÃ¡o',0),(182494,5070,'af','Waarskuwing',0),(182495,5070,'ro','Avertisment',0),(182496,5070,'et','Hoiatus',0),(182497,5070,'si','Opozorilo',0),(182498,5070,'ba','Peringatan',0),(182499,5070,'nl','Waarschuwing',0),(182500,5070,'fi','Varoitus',0),(182501,5070,'no','Advarsel',0),(182502,5070,'da','Advarsel',0),(182503,5070,'ko','ê²½ê³ ',0),(182504,5070,'he','××–×”×¨×”',0),(182505,5070,'el','Î ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(182506,5070,'zh','è­¦å‘Š\r\n',0),(182507,5070,'sv','Varning',0),(182508,5070,'it','Avviso',0),(182509,5070,'tl','',0),(182510,5070,'th','&#3588;&#3635;&#3648;&#3605;&#3639;&#3629;&#3609;',0),(182511,5070,'hi','à¤šà¥‡à¤¤à¤¾à¤µà¤¨à¥€',0),(182512,5070,'ms','Amaran',0),(182513,5070,'ar','ØªØ­Ø°ÙŠØ±',0),(182514,5070,'fr','Mise en garde',0),(182515,5070,'jp','è­¦å‘Š',0),(182516,5070,'pt','Aviso',0),(182517,5070,'ru','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ',0),(182518,5070,'es','Aviso',0),(182519,5070,'de','Warnung',0),(182520,5070,'en','Warning',0),(182521,5071,'is','',0),(182522,5071,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙƒÙ¾ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ Ø¯Ø± ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÙŠ ',0),(182523,5071,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙƒÙ¾ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ Ø¯Ø± ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÙŠ ',0),(182524,5071,'tr','Ä°stemci sayfasÄ± dosya kopyalama hatasÄ±',0),(182525,5071,'pl','BÅ‚Ä…d podczas kopiowania pliku na stronÄ™ klienta',0),(182526,5071,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð» Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(182527,5071,'ur','Ù…Ø³Ù„ ÙˆØµÙˆÙ„ Ú©Ø§Ø± ØµÙØ­Û Ù¾Ø± Ù†Ù‚Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(182528,5071,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÐºÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(182529,5071,'vi','Lá»—i khi sao chÃ©p há»“ sÆ¡ sang trang khÃ¡ch hÃ ng',0),(182530,5071,'af','Fout begaan met Kopiering van lÃªer na KliÃªnt/Klant Bladsy',0),(182531,5071,'ro','Eroare la copierea fiÅŸierului la pagina de Client',0),(182532,5071,'et','TÃµrge faili kopeerimisel klienti lehel',0),(182533,5071,'si','Napaka pri kopiranju datotek na strani odjemalca',0),(182534,5071,'ba','Kesalahan saat menyalin file ke halaman klien',0),(182535,5071,'nl','Fout bij het kopiÃ«ren van bestand naar de Client pagina',0),(182536,5071,'fi','Virhe kopioitaessa tiedostoa asiakas-sivua',0),(182537,5071,'no','Feilmelding nÃ¥r du kopierer filen til klient',0),(182538,5071,'da','Der opstod fejl under kopiering af fil til klient side',0),(182539,5071,'ko','í´ë¼ì´ì–¸íŠ¸ íŽ˜ì´ì§€ì— íŒŒì¼ì„ ë³µì‚¬í•  ë•Œ ì˜¤ë¥˜',0),(182540,5071,'he','×©×’×™××” ×‘×¢×ª ×”×¢×ª×§×ª ×”×§×•×‘×¥ ×œ×“×£ ×œ×§×•×—',0),(182541,5071,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Ï„Î¹Î³ÏÎ±Ï†Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï… ÏƒÏ„Î· ÏƒÎµÎ»Î¯Î´Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(182542,5071,'zh','å¤åˆ¶æ–‡ä»¶æ—¶å‡ºçŽ°é”™è¯¯å®¢æˆ·ç«¯é¡µé¢\r\n',0),(182543,5071,'sv','Fel nÃ¤r du kopierar filen till klienten',0),(182544,5071,'it','Errore durante la copia dei file al Client Page',0),(182545,5071,'tl','',0),(182546,5071,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3586;&#3603;&#3632;&#3585;&#3635;&#3621;&#3633;&#3591;&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3652;&#3615;&#3621;&#3660;&#3652;&#3611;&#3607;&#3637;&#3627;&#3609;&#3657;&#3634;&#3612;&#3641;&#3657;&#3',0),(182547,5071,'hi','à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ à¤ªà¥ƒà¤·à¥à¤  à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤¤à¥‡ à¤¸à¤®à¤¯ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(182548,5071,'ms','Ralat semasa menyalin fail ke Laman pelanggan',0),(182549,5071,'ar','Ø®Ø·Ø£ Ø¹Ù†Ø¯ Ù†Ø³Ø® Ø§Ù„Ù…Ù„Ù Ø¥Ù„Ù‰ \"ØµÙØ­Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„\"',0),(182550,5071,'fr','Erreur lors de la copie de fichier de Page Client',0),(182551,5071,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆãƒšãƒ¼ã‚¸ã?¸ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚³ãƒ”ãƒ¼ä¸­ã?«ã‚¨ãƒ©ãƒ¼',0),(182552,5071,'pt','Erro ao copiar o arquivo de pÃ¡gina de cliente',0),(182553,5071,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ñ„Ð°Ð¹Ð»Ð° Ð½Ð° Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(182554,5071,'es','Error cuando Copiar Archivo a la PÃ¡gina de Cliente',0),(182555,5071,'de','Fehler beim Kopieren der Datei auf Client-Seite',0),(182556,5071,'en','Error when Copying file to Client Page',0),(182557,5072,'is','',0),(182558,5072,'dr','ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡ Ù‡Ø§',0),(182559,5072,'pr','ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡ Ù‡Ø§',0),(182560,5072,'tr','Ek Ã¶zellikler',0),(182561,5072,'pl','Dodatki',0),(182562,5072,'bg','Ð•ÐºÑÑ‚Ñ€Ð¸',0),(182563,5072,'ur','Ù…Ø¹ Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª',0),(182564,5072,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸',0),(182565,5072,'vi','ThÃªm ',0),(182566,5072,'af','Bykomstighede',0),(182567,5072,'ro','Extra',0),(182568,5072,'et','Lisad',0),(182569,5072,'si','Dodatki',0),(182570,5072,'ba','Ekstra',0),(182571,5072,'nl','Extra \'s',0),(182572,5072,'fi','Ekstrat',0),(182573,5072,'no','Ekstra',0),(182574,5072,'da','Extras',0),(182575,5072,'ko','ì—‘ìŠ¤íŠ¸ë¼',0),(182576,5072,'he','×ª×•×¡×¤×•×ª',0),(182577,5072,'el','ÎˆÎ¾Ï„ÏÎ±',0),(182578,5072,'zh','é™„åŠ åŠŸèƒ½\r\n',0),(182579,5072,'sv','Extras',0),(182580,5072,'it','Extra',0),(182581,5072,'tl','',0),(182582,5072,'th','&#3614;&#3636;&#3648;&#3624;&#3625;',0),(182583,5072,'hi','à¤à¤•à¥à¤¸à¥à¤Ÿà¥à¤°à¤¾ à¤•à¤²à¤¾à¤•à¤¾à¤°',0),(182584,5072,'ms','Tambahan',0),(182585,5072,'ar','Ø¥Ø¶Ø§ÙØ§Øª',0),(182586,5072,'fr','Extras',0),(182587,5072,'jp','ã‚¨ã‚­ã‚¹ãƒˆãƒ©',0),(182588,5072,'pt','Extras',0),(182589,5072,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾',0),(182590,5072,'es','Extras',0),(182591,5072,'de','Extras',0),(182592,5072,'en','Extras',0),(182593,5073,'is','',0),(182594,5073,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§ÙˆÙ„ÙŠÙ‡ Ø´Ø±ÙƒØª ',0),(182595,5073,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§ÙˆÙ„ÙŠÙ‡ Ø´Ø±ÙƒØª ',0),(182596,5073,'tr','Ä°lk ÅŸirket kurulumu',0),(182597,5073,'pl','Firma wstÄ™pne ustawienie',0),(182598,5073,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(182599,5073,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ø³ÛŒÙ¹ Ø§Ù¾',0),(182600,5073,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¿Ð¾Ñ‡ÐµÑ‚Ð½Ð¾ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(182601,5073,'vi','Setup cty lÃºc Ä‘áº§u',0),(182602,5073,'af','Aanvanklike Onderneming Opstelling',0),(182603,5073,'ro','Initial compania Setup',0),(182604,5073,'et','Algne ettevÃµtte seadistamine',0),(182605,5073,'si','ZaÄetno podjetje Setup',0),(182606,5073,'ba','Perusahaan awal Setup',0),(182607,5073,'nl','Eerste bedrijf Setup',0),(182608,5073,'fi','AlkuperÃ¤isen yrityksen asetukset',0),(182609,5073,'no','FÃ¸rste firmaoppsettet',0),(182610,5073,'da','Indledende firmaopsÃ¦tningen',0),(182611,5073,'ko','ì´ˆê¸° íšŒì‚¬ ì„¤ì¹˜',0),(182612,5073,'he','×”×”×ª×§× ×” ×”×¨××©×•× ×™×ª ×”×—×‘×¨×”',0),(182613,5073,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(182614,5073,'zh','åˆå§‹å…¬å¸å®‰è£…\r\n',0),(182615,5073,'sv','FÃ¶rsta fÃ¶retaget Setup',0),(182616,5073,'it','Setup iniziale azienda',0),(182617,5073,'tl','',0),(182618,5073,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3648;&#3619;&#3636;&#3656;&#3617;&#3649;&#3619;&#3585;',0),(182619,5073,'hi','à¤†à¤¦à¥à¤¯à¤¾à¤•à¥à¤·à¤° à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(182620,5073,'ms','Persediaan awal Syarikat',0),(182621,5073,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(182622,5073,'fr','StÃ© initial',0),(182623,5073,'jp','ä¼šç¤¾åˆ?æœŸè¨­å®š',0),(182624,5073,'pt','ConfiguraÃ§Ã£o inicial de empresa',0),(182625,5073,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ð°Ñ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(182626,5073,'es','ConfiguraciÃ³n Inicial de la Empresa',0),(182627,5073,'de','Erste FirmengrÃ¼ndung',0),(182628,5073,'en','Initial Company Setup',0),(182629,5074,'is','',0),(182630,5074,'dr','(Ù‚Ù„Ù… Ø®ÙˆØ±Ø¯Ù‡)',0),(182631,5074,'pr','Ù„ØºÙˆ Ø´Ø¯Ù‡(Ù‚Ù„Ù… Ø®ÙˆØ±Ø¯Ù‡)',0),(182632,5074,'tr','Ä°ptal',0),(182633,5074,'pl','OdwoÅ‚any',0),(182634,5074,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ',0),(182635,5074,'ur','Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(182636,5074,'sr','ÐžÑ‚ÐºÐ°Ð·Ð°Ð½Ð°',0),(182637,5074,'vi','ÄÃ£ xÃ³a',0),(182638,5074,'af','Gekanselleer',0),(182639,5074,'ro','Anulat',0),(182640,5074,'et','TÃ¼histatud',0),(182641,5074,'si','Odpovedan',0),(182642,5074,'ba','Dibatalkan',0),(182643,5074,'nl','Geannuleerd',0),(182644,5074,'fi','Peruutetaan',0),(182645,5074,'no','Kansellert',0),(182646,5074,'da','Aflyst',0),(182647,5074,'ko','ì·¨ì†Œ',0),(182648,5074,'he','×‘×•×˜×œ',0),(182649,5074,'el','Î‘ÎºÏ…ÏÏ‰Î¸ÎµÎ¯',0),(182650,5074,'zh','å–æ¶ˆ\r\n',0),(182651,5074,'sv','InstÃ¤lld',0),(182652,5074,'it','Annullato',0),(182653,5074,'tl','',0),(182654,5074,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3649;&#3621;&#3657;&#3623;',0),(182655,5074,'hi','à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(182656,5074,'ms','Dibatalkan',0),(182657,5074,'ar','Ø£Ù„ØºÙ‰',0),(182658,5074,'fr','AnnulÃ©',0),(182659,5074,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«æ¸ˆã?¿',0),(182660,5074,'pt','Cancelado',0),(182661,5074,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¾Ðµ',0),(182662,5074,'es','Cancelado',0),(182663,5074,'de','Abgesagt',0),(182664,5074,'en','Cancelled',0),(182665,5075,'is','',0),(182666,5075,'dr','Ø´Ø±ÙˆØ¹ Ø³Ø± Ø±Ø³ÙŠØ¯ Ø³ÙØ§Ø±Ø´',0),(182667,5075,'pr','Ø´Ø±ÙˆØ¹ Ø³Ø± Ø±Ø³ÙŠØ¯ Ø³ÙØ§Ø±Ø´',0),(182668,5075,'tr','BaÅŸlamak sipariÅŸ vade tarihi',0),(182669,5075,'pl','RozpoczÄ…Ä‡ zamÃ³wienia termin',0),(182670,5075,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ñ€ÐµÐ´ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶',0),(182671,5075,'ur','Ù†Ø¸Ù… Ú©Ø§ Ø¢ØºØ§Ø² ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ ØªØ§Ø±ÛŒØ®',0),(182672,5075,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(182673,5075,'vi','Báº¯t Äáº§u Äáº¿n Háº¡n ÄÆ¡n Äáº·t HÃ ng',0),(182674,5075,'af','Begin Bestelling Verskuldigde Datum',0),(182675,5075,'ro','ÃŽncepe comanda data scadenÅ£ei',0),(182676,5075,'et','Algab tellimuse tÃ¤htaeg',0),(182677,5075,'si','ZaÄne naloga datum zapadlosti',0),(182678,5075,'ba','Mulai urutan tanggal jatuh tempo',0),(182679,5075,'nl','Beginnen volgorde vervaldatum',0),(182680,5075,'fi','Alkaa tilauksen erÃ¤pÃ¤ivÃ¤',0),(182681,5075,'no','Starte for forfallsdato',0),(182682,5075,'da','Begynde ordre forfaldsdato',0),(182683,5075,'ko','ì£¼ë¬¸ ì‹œìž‘ ì˜ˆì • ë‚ ì§œ',0),(182684,5075,'he','×œ×”×ª×—×™×œ ×¡×“×¨ ×ª××¨×™×š ×™×¢×“',0),(182685,5075,'el','ÎžÎµÎºÎ¹Î½Î®ÏƒÎµÎ¹ ÏƒÎµÎ¹ÏÎ¬ Î—Î¼/Î½Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(182686,5075,'zh','åˆ°æœŸæ—¥å¼€å§‹è®¢è´­\r\n',0),(182687,5075,'sv','BÃ¶rja bestÃ¤lla fÃ¶rfallodatum',0),(182688,5075,'it','Iniziare l\'ordine Data scadenza',0),(182689,5075,'tl','',0),(182690,5075,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3605;&#3634;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(182691,5075,'hi','à¤•à¥à¤°à¤® à¤¶à¥à¤°à¥‚ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(182692,5075,'ms','Memulakan pesanan tarikh matang',0),(182693,5075,'ar','ÙŠØ¨Ø¯Ø£ ØªØ±ØªÙŠØ¨ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(182694,5075,'fr','Commencer la commande Date d\'Ã©chÃ©ance',0),(182695,5075,'jp','æ³¨æ–‡æœŸæ—¥ã?®é–‹å§‹',0),(182696,5075,'pt','ComeÃ§ar a ordem data de vencimento',0),(182697,5075,'ru','ÐÐ°Ñ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð· ÑÑ€Ð¾Ðº',0),(182698,5075,'es','Iniciar Fecha de Vencimiento de Pedido',0),(182699,5075,'de','Bestellung beginnen FÃ¤lligkeitsdatum',0),(182700,5075,'en','Begin Order Due Date',0),(182701,5076,'is','',0),(182702,5076,'dr','(Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® Ø«Ø¨Øª',0),(182703,5076,'pr','ØªØ§Ø±ÙŠØ® Ø«Ø¨Øª Ø§ÙˆÙ„(Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® Ø«Ø¨Øª',0),(182704,5076,'tr','GiriÅŸ tarihinden baÅŸlamak',0),(182705,5076,'pl','Data wpisu rozp.',0),(182706,5076,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(182707,5076,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¢ØºØ§Ø²',0),(182708,5076,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° ÑÑ‚Ð°Ð²ÐºÐµ',0),(182709,5076,'vi','NgÃ y Báº¯t Äáº§u Nháº­p',0),(182710,5076,'af','Begin Inskrywingsdatum',0),(182711,5076,'ro','ÃŽncepe data intrÄƒrii',0),(182712,5076,'et','Kande alguskuupÃ¤ev',0),(182713,5076,'si','ZaÄetni datum vstopa',0),(182714,5076,'ba','Mulai tanggal entri',0),(182715,5076,'nl','Datum van de Entry beginnen',0),(182716,5076,'fi','Tapahtuman alkamispÃ¤ivÃ¤',0),(182717,5076,'no','Starte oppfÃ¸ringsdatoen',0),(182718,5076,'da','Begynde tilmeldningsfrist',0),(182719,5076,'ko','ìž…êµ­ ë‚ ì§œë¥¼ ì‹œìž‘',0),(182720,5076,'he','×ª××¨×™×š ×›× ×™×¡×” ×‘×’×™×Ÿ',0),(182721,5076,'el','Î‘ÏÏ‡Î¯ÏƒÎµÎ¹ Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(182722,5076,'zh','å¼€å§‹è¾“å…¥æ—¥æœŸ\r\n',0),(182723,5076,'sv','BÃ¶rja bloggpostens datum',0),(182724,5076,'it','Iniziare la data di entrata',0),(182725,5076,'tl','',0),(182726,5076,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(182727,5076,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¶à¥à¤°à¥‚ à¤¹à¥‹',0),(182728,5076,'ms','Mula tarikh kemasukan',0),(182729,5076,'ar','ØªØ¨Ø¯Ø£ Ù…Ù† ØªØ§Ø±ÙŠØ® Ø¯Ø®ÙˆÙ„',0),(182730,5076,'fr','Date d\'entrÃ©e de Begin',0),(182731,5076,'jp','å…¥åŠ›æ—¥ã?®é–‹å§‹',0),(182732,5076,'pt','Data de entrada do Begin',0),(182733,5076,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð”Ð°Ñ‚Ð° Ð²ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ',0),(182734,5076,'es','Iniciar Fecha de Entrada',0),(182735,5076,'de','Eintrag vom beginnen',0),(182736,5076,'en','Begin Entry Date',0),(182737,5077,'is','',0),(182738,5077,'dr','Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(182739,5077,'pr','Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(182740,5077,'tr','Teklifi yazdÄ±rmak iÃ§in tÄ±klatÄ±n',0),(182741,5077,'pl','Kliknij, aby wydrukowaÄ‡ ofertÄ™',0),(182742,5077,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð°',0),(182743,5077,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú†Ú¾Ø§Ù¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(182744,5077,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð»Ð¸ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(182745,5077,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ in bÃ¡o giÃ¡',0),(182746,5077,'af','Kliek om te Kwotasie te Druk',0),(182747,5077,'ro','FaceÅ£i clic pentru a imprima citat',0),(182748,5077,'et','KlÃµpsake Prindi pakkumine',0),(182749,5077,'si','Kliknite, Äe Å¾elite natisniti, citat',0),(182750,5077,'ba','Klik untuk mencetak kutipan',0),(182751,5077,'nl','Klik op offerte afdrukt',0),(182752,5077,'fi','Klikkaa Tulosta tarjous',0),(182753,5077,'no','Klikk for Ã¥ skrive ut tilbud',0),(182754,5077,'da','Klik her for at udskrive tilbud',0),(182755,5077,'ko','ê²¬ì ì„ ì¸ì‡„ í•˜ë ¤ë©´ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(182756,5077,'he','×œ×—×¥ ×›×“×™ ×œ×”×“×¤×™×¡ ×”×¦×¢×ª ×ž×—×™×¨',0),(182757,5077,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(182758,5077,'zh','ç‚¹å‡»æ‰“å°æŠ¥ä»·\r\n',0),(182759,5077,'sv','Klicka fÃ¶r att skriva ut offerten',0),(182760,5077,'it','Clicca per stampare il preventivo',0),(182761,5077,'tl','',0),(182762,5077,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3626;&#3633;&#3656;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(182763,5077,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‹ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(182764,5077,'ms','Klik untuk cetak Quote',0),(182765,5077,'ar','Ø£Ù†Ù‚Ø± Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(182766,5077,'fr','Cliquez ici pour imprimer le devis',0),(182767,5077,'jp','è¦‹ç©?ã‚Šã?®å?°åˆ·ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(182768,5077,'pt','Clique para imprimir cotaÃ§Ã£o',0),(182769,5077,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ñ€Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(182770,5077,'es','Click para Imprimir CotizaciÃ³n',0),(182771,5077,'de','Klicken Sie auf das Angebot drucken',0),(182772,5077,'en','Click to Print Quote',0),(182773,5078,'is','',0),(182774,5078,'dr','(ØªÚ©Øª) Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(182775,5078,'pr','Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ù…Ø¬ÙˆØ² Ø¹Ø¨ÙˆØ±(Ø¨Ù„ÙŠØ·) ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(182776,5078,'tr','Bilet yazdÄ±rmak iÃ§in tÄ±klatÄ±n',0),(182777,5078,'pl','Kliknij, aby wydrukowaÄ‡ bilet',0),(182778,5078,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð±Ð¸Ð»ÐµÑ‚Ð¸',0),(182779,5078,'ur','Ù¹Ú©Ù¹ Ú†Ú¾Ø§Ù¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(182780,5078,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð»Ð¸ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(182781,5078,'vi','Nháº¥n Ä‘á»ƒ In VÃ©',0),(182782,5078,'af','Klik om die kaartjie druk',0),(182783,5078,'ro','FaceÅ£i clic pentru a imprima bilet',0),(182784,5078,'et','Piletite Printimine nuppu',0),(182785,5078,'si','Kliknite, Äe Å¾elite natisniti vozovnice',0),(182786,5078,'ba','Klik untuk mencetak tiket',0),(182787,5078,'nl','Klik om te drukken Ticket',0),(182788,5078,'fi','Valitsemalla tÃ¤mÃ¤n voit tulostaa lippu',0),(182789,5078,'no','Klikk for Ã¥ skrive ut billetten',0),(182790,5078,'da','Klik her for at udskrive billet',0),(182791,5078,'ko','í‹°ì¼“ì„ ì¸ì‡„ í•˜ë ¤ë©´ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(182792,5078,'he','×œ×—×¥ ×‘×›×“×™ ×œ×”×“×¤×™×¡ ×›×¨×˜×™×¡',0),(182793,5078,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„Î¿Ï… ÎµÎ¹ÏƒÎ¹Ï„Î·ÏÎ¯Î¿Ï…',0),(182794,5078,'zh','ç‚¹å‡»æ‰“å°é—¨ç¥¨\r\n',0),(182795,5078,'sv','Klicka fÃ¶r att skriva ut biljetten',0),(182796,5078,'it','Clicca per stampare nota',0),(182797,5078,'tl','',0),(182798,5078,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3633;&#3659;&#3623;',0),(182799,5078,'hi','à¤Ÿà¤¿à¤•à¤Ÿ à¤•à¥‹ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(182800,5078,'ms','Klik untuk mencetak Tiket',0),(182801,5078,'ar','Ø§Ù†Ù‚Ø± Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(182802,5078,'fr','Cliquez ici pour imprimer le billet',0),(182803,5078,'jp','ãƒ?ã‚±ãƒƒãƒˆã?®å?°åˆ·ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(182804,5078,'pt','Clique para imprimir o bilhete',0),(182805,5078,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ñ€Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚',0),(182806,5078,'es','Click para Imprimir Boleto',0),(182807,5078,'de','Klicken Sie auf das Ticket drucken',0),(182808,5078,'en','Click to Print Ticket',0),(182809,5079,'is','',0),(182810,5079,'dr','Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø³ÙØ§Ø±Ø´ ',0),(182811,5079,'pr','Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø³ÙØ§Ø±Ø´ ',0),(182812,5079,'tr','Son sipariÅŸ vade tarihi',0),(182813,5079,'pl','Koniec zamÃ³wienia termin',0),(182814,5079,'bg','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‚Ð¸ Ñ€ÐµÐ´ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶',0),(182815,5079,'ur','Ø®ØªÙ… ØªØ±ØªÛŒØ¨ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ ØªØ§Ø±ÛŒØ®',0),(182816,5079,'sr','ÐšÑ€Ð°Ñ˜ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(182817,5079,'vi','Gá»­i Email ngÃ y Ä‘áº¿n háº¡n Ä‘áº·t hÃ ng ',0),(182818,5079,'af','End Bestelling Verskuldigde Datum',0),(182819,5079,'ro','Termina comanda data scadenÅ£ei',0),(182820,5079,'et','LÃµpeta tellimuse tÃ¤htaeg',0),(182821,5079,'si','Na koncu nalog datum zapadlosti',0),(182822,5079,'ba','Mengakhiri urutan tanggal jatuh tempo',0),(182823,5079,'nl','Einde volgorde vervaldatum',0),(182824,5079,'fi','Lopettaa tilauksen erÃ¤pÃ¤ivÃ¤',0),(182825,5079,'no','Avslutte for forfallsdato',0),(182826,5079,'da','Ende ordre forfaldsdato',0),(182827,5079,'ko','ì£¼ë¬¸ ìµœì¢… ê¸°í•œ',0),(182828,5079,'he','×‘×¡×•×£ ×¡×“×¨ ×ª××¨×™×š ×™×¢×“',0),(182829,5079,'el','Î¤Î­Î»Î¿Ï‚ ÏƒÎµÎ¹ÏÎ¬ Î—Î¼/Î½Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(182830,5079,'zh','ç»“æŸè®¢è´­æˆªæ­¢æ—¥æœŸ',0),(182831,5079,'sv','Avsluta Order fÃ¶rfallodatum',0),(182832,5079,'it','Fine ordine Data scadenza',0),(182833,5079,'tl','',0),(182834,5079,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;&#3607;&#3637;&#3656;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(182835,5079,'hi','à¤…à¤‚à¤¤ à¤†à¤¦à¥‡à¤¶ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(182836,5079,'ms','Akhir pesanan tarikh matang',0),(182837,5079,'ar','ÙÙŠ Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø£Ù…Ø± ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(182838,5079,'fr','Terminer la commande Date d\'Ã©chÃ©ance',0),(182839,5079,'jp','æ³¨æ–‡æœŸæ—¥ã?®çµ‚äº†',0),(182840,5079,'pt','Acabar com ordem de data de vencimento',0),(182841,5079,'ru','ÐšÐ¾Ð½ÐµÑ† Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° ÑÑ€Ð¾Ðº',0),(182842,5079,'es','Fecha Final de Vencimiento de Orden',0),(182843,5079,'de','Am Ende der Bestellung fÃ¤llig am',0),(182844,5079,'en','End Order Due Date',0),(182845,5080,'is','',0),(182846,5080,'dr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø«Ø¨Øª ',0),(182847,5080,'pr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø«Ø¨Øª ',0),(182848,5080,'tr','Son giriÅŸ tarihi',0),(182849,5080,'pl','Data zakoÅ„czenia wpisu',0),(182850,5080,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(182851,5080,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(182852,5080,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° ÑÑ‚Ð°Ð²ÐºÐµ',0),(182853,5080,'vi','NgÃ y Káº¿t ThÃºc Nháº­p',0),(182854,5080,'af','End Inskrywingsdatum',0),(182855,5080,'ro','Data de intrare sfÃ¢rÅŸitul',0),(182856,5080,'et','Kande lÃµppkuupÃ¤ev',0),(182857,5080,'si','Vnos konÄnega datuma',0),(182858,5080,'ba','Akhir tanggal entri',0),(182859,5080,'nl','Einddatum voor de vermelding',0),(182860,5080,'fi','Tapahtuman pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(182861,5080,'no','OppfÃ¸ringen sluttdatoen',0),(182862,5080,'da','Ende tilmeldningsfrist',0),(182863,5080,'ko','ì¢…ë£Œì¼ ìž…ë ¥',0),(182864,5080,'he','×ª××¨×™×š ×¡×™×•× ×”×–× ×ª',0),(182865,5080,'el','Î¤Î­Î»Î¿Ï‚ Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(182866,5080,'zh','ç»“æŸæ¡ç›®æ—¥æœŸ',0),(182867,5080,'sv','Posten slutdatum',0),(182868,5080,'it','Data di fine iscrizione',0),(182869,5080,'tl','',0),(182870,5080,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;&#3607;&#3637;&#3656;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(182871,5080,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(182872,5080,'ms','Tarikh akhir kemasukan',0),(182873,5080,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(182874,5080,'fr','Date d\'entrÃ©e de fin',0),(182875,5080,'jp','å…¥åŠ›æ—¥ã?®çµ‚äº†',0),(182876,5080,'pt','Data de entrada do final',0),(182877,5080,'ru','Ð”Ð°Ñ‚Ð° Ð²ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ',0),(182878,5080,'es','Fecha Final de Entrada',0),(182879,5080,'de','Eintrag vom Ende',0),(182880,5080,'en','End Entry Date',0),(182881,5081,'is','',0),(182882,5081,'dr','Ø´ØºÙ„ ',0),(182883,5081,'pr','Ø´ØºÙ„ ',0),(182884,5081,'tr','Ä°ÅŸ',0),(182885,5081,'pl','Praca',0),(182886,5081,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð°',0),(182887,5081,'ur','Ù…Ù„Ø§Ø²Ù…Øª',0),(182888,5081,'sr','ÐŸÐ¾ÑÐ°Ð¾',0),(182889,5081,'vi','Job',0),(182890,5081,'af','Werkstuk',0),(182891,5081,'ro','Job',0),(182892,5081,'et','TÃ¶Ã¶',0),(182893,5081,'si','Delo',0),(182894,5081,'ba','Pekerjaan',0),(182895,5081,'nl','Baan',0),(182896,5081,'fi','TyÃ¶',0),(182897,5081,'no','Jobb',0),(182898,5081,'da','Job',0),(182899,5081,'ko','ìž‘ì—…',0),(182900,5081,'he','×¢×‘×•×“×”',0),(182901,5081,'el','Î•ÏÎ³Î±ÏƒÎ¯Î±',0),(182902,5081,'zh','å·¥ä½œ\r\n',0),(182903,5081,'sv','Jobb',0),(182904,5081,'it','Lavoro',0),(182905,5081,'tl','',0),(182906,5081,'th','&#3591;&#3634;&#3609;',0),(182907,5081,'hi','à¤¨à¥Œà¤•à¤°à¥€',0),(182908,5081,'ms','Kerja',0),(182909,5081,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(182910,5081,'fr','Emploi',0),(182911,5081,'jp','ä½œæ¥­',0),(182912,5081,'pt','Emprego',0),(182913,5081,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð°',0),(182914,5081,'es','Trabajo',0),(182915,5081,'de','Job',0),(182916,5081,'en','Job',0),(182917,5082,'is','',0),(182918,5082,'dr','/ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(182919,5082,'pr','Ø¬Ø³ØªØ¬Ùˆ  Ø´ØºÙ„  / Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(182920,5082,'tr','Ä°ÅŸ/teklif arama',0),(182921,5082,'pl','Szukaj pracy/oferty',0),(182922,5082,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°/Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(182923,5082,'ur','Ø¬Ø§Ø¨/Ø§Ù‚ØªØ¨Ø§Ø³ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(182924,5082,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð³Ð° Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾/Ð¿Ð¾Ð½ÑƒÐ´Ð°',0),(182925,5082,'vi','TÃ¬m Job/BÃ¡o GiÃ¡',0),(182926,5082,'af','Kontrakwerk/Kwotasie Soek',0),(182927,5082,'ro','CÄƒutaÅ£i Job/Quote',0),(182928,5082,'et','TÃ¶Ã¶/Quote otsing',0),(182929,5082,'si','IÅ¡Äi zaposlitev/Quote',0),(182930,5082,'ba','Cari pekerjaan kutipan',0),(182931,5082,'nl','Baan/offerte zoeken',0),(182932,5082,'fi','TyÃ¶/Quote Etsi',0),(182933,5082,'no','Jobb/tilbud sÃ¸k',0),(182934,5082,'da','SÃ¸g pÃ¥ job/Quote',0),(182935,5082,'ko','ì§ì—…/ê²¬ì  ê²€ìƒ‰',0),(182936,5082,'he','×—×™×¤×•×© ×¢×‘×•×“×”/×”×¦×¢×ª ×ž×—×™×¨',0),(182937,5082,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚/Ï€ÏÎ¿ÏƒÏ†Î¿ÏÏŽÎ½',0),(182938,5082,'zh','å·¥ä½œ/æŠ¥ä»·æœç´¢\r\n',0),(182939,5082,'sv','SÃ¶ka jobb/offert',0),(182940,5082,'it','Ricerca lavoro/citazione',0),(182941,5082,'tl','',0),(182942,5082,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3591;&#3634;&#3609;/&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(182943,5082,'hi','à¤¨à¥Œà¤•à¤°à¥€/à¤‰à¤¦à¥à¤§à¤°à¤£ à¤–à¥‹à¤œ',0),(182944,5082,'ms','Cari kerja/sebut harga',0),(182945,5082,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† ÙˆØ¸ÙŠÙØ©/Ø§Ù‚ØªØ¨Ø§Ø³',0),(182946,5082,'fr','Recherche d\'emploi/Devis',0),(182947,5082,'jp','ä½œæ¥­/è¦‹ç©?ã‚Šæ¤œç´¢',0),(182948,5082,'pt','Pesquisa de emprego/citaÃ§Ã£o',0),(182949,5082,'ru','ÐŸÐ¾Ð¸ÑÐº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹/Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(182950,5082,'es','Trabajo/CotizaciÃ³n Buscar',0),(182951,5082,'de','Auftrag/Angebot suchen',0),(182952,5082,'en','Job/Quote Search',0),(182953,5083,'is','',0),(182954,5083,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ÙŠØ§ Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(182955,5083,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ÙŠØ§ Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(182956,5083,'tr','HiÃ§bir eÅŸleÅŸen teklifleri veya sipariÅŸleri bulundu',0),(182957,5083,'pl','Nie dopasowania oferty lub zamÃ³wienia Znalezione',0),(182958,5083,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸Ñ‚Ðµ Ð¸Ð»Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸Ñ‚Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(182959,5083,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û ÙˆØ§ÙˆÛŒÙ† ÛŒØ§ Ù¾Ø§Ø¦Û’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(182960,5083,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð¸Ð»Ð¸ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(182961,5083,'vi','KhÃ´ng tÃ¬m tháº¥y bÃ¡o giÃ¡ hay Ä‘Æ¡n hÃ ng phÃ¹ há»£p',0),(182962,5083,'af','Geen \"matching\" kwotasies of bestellings gevind',0),(182963,5083,'ro','Nicio potrivire citate sau comenzi gÄƒsit',0),(182964,5083,'et','Ole vastavaid hinnapakkumisi vÃµi tellimuste leitud',0),(182965,5083,'si','Brez ujemanja ponudbe ali naroÄila naÅ¡el',0),(182966,5083,'ba','Tanda kutip atau perintah yang ditemukan tidak cocok',0),(182967,5083,'nl','Geen overeenkomende offertes of orders gevonden',0),(182968,5083,'fi','Ei vastaavia lainauksia tai tilauksista',0),(182969,5083,'no','Ingen samsvarende tilbud eller ordrer funnet',0),(182970,5083,'da','Ingen tilsvarende tilbud eller ordrer fundet',0),(182971,5083,'ko','ì•„ë‹ˆ ì¼ì¹˜ ë”°ì˜´í‘œ ë˜ëŠ” ì£¼ë¬¸ ë°œê²¬',0),(182972,5083,'he','×œ× × ×ž×¦××• ×”×¦×¢×•×ª ×ž×—×™×¨ ××• ×”×–×ž× ×•×ª ×ª×•××ž×•×ª',0),(182973,5083,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ­Ï‚ Î® Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(182974,5083,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„æŠ¥ä»·æˆ–è®¢å•\r\n',0),(182975,5083,'sv','Inga matchande citationstecken eller bestÃ¤llningar Funna',0),(182976,5083,'it','Senza citazioni o ordini trovati corrispondente',0),(182977,5083,'tl','',0),(182978,5083,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3627;&#3619;&#3639;&#3629;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(182979,5083,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶ à¤ªà¤¾à¤¯à¤¾',0),(182980,5083,'ms','Tiada sebut harga atau perintah-perintah yang ditemui yang padan',0),(182981,5083,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¹Ø±ÙˆØ¶ Ù…Ø¨Ø¯Ø¦ÙŠØ© Ø£Ùˆ Ø·Ù„Ø¨ÙŠØ§Øª Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(182982,5083,'fr','Aucun devis ou commandes trouvÃ©s correspondant',0),(182983,5083,'jp','ä¸€è‡´ã?™ã‚‹è¦‹ç©?ã‚Šã?‹æ³¨æ–‡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(182984,5083,'pt','Nenhuma correspondÃªncia citaÃ§Ãµes ou ordens encontradas',0),(182985,5083,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð¸Ð»Ð¸ Ð½Ð°Ð¹Ñ‚Ð¸ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(182986,5083,'es','No se encontraron cotizaciones ni pedidos emparejados',0),(182987,5083,'de','Keine passenden Angebote oder AuftrÃ¤ge gefunden',0),(182988,5083,'en','No matching quotes or orders found',0),(182989,5084,'is','',0),(182990,5084,'dr','Ù„ÙŠØ³Øª Ø¬Ø³ØªØ¬ÙˆÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ   Ø´ØºÙ„',0),(182991,5084,'pr','Ù„ÙŠØ³Øª Ø¬Ø³ØªØ¬ÙˆÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ   Ø´ØºÙ„',0),(182992,5084,'tr','Teklif/iÅŸ arama listesi',0),(182993,5084,'pl','Oferta/zadanie lista wyszukiwania',0),(182994,5084,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð°/Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ ÑÐ¿Ð¸ÑÑŠÐº',0),(182995,5084,'ur','Ø§Ù‚ØªØ¨Ø§Ø³/Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ ÙÛØ±Ø³Øª ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(182996,5084,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° Ð¿Ð¾Ð½ÑƒÐ´Ðµ/Ð¿Ð¾ÑÐ°Ð¾',0),(182997,5084,'vi','Danh SÃ¡ch BÃ¡o GiÃ¡/Job',0),(182998,5084,'af','Aanhaling/werk soek lys',0),(182999,5084,'ro','Lista de cÄƒutare citat/Job',0),(183000,5084,'et','Hinnapakkumise/tÃ¶Ã¶ Otsi nimekirja',0),(183001,5084,'si','IÅ¡Äi seznam ponudbe/zaposlitev',0),(183002,5084,'ba','Daftar pencarian kutipan pekerjaan',0),(183003,5084,'nl','Offerte/Job zoeklijst',0),(183004,5084,'fi','Tarjous tai tyÃ¶n etsinnÃ¤n',0),(183005,5084,'no','Tilbud/jobb sÃ¸k-listen',0),(183006,5084,'da','Tilbud/Job Search List',0),(183007,5084,'ko','ê²¬ì /ì§ì—… ê²€ìƒ‰ ëª©ë¡',0),(183008,5084,'he','×¨×©×™×ž×ª ×—×™×¤×•×© ×¢×‘×•×“×”/×”×¦×¢×ª ×ž×—×™×¨',0),(183009,5084,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±/Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î»Î¯ÏƒÏ„Î± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(183010,5084,'zh','æŠ¥ä»·/å·¥ä½œæœç´¢åˆ—è¡¨\r\n',0),(183011,5084,'sv','SÃ¶klistan fÃ¶r offert/jobb',0),(183012,5084,'it','Citazione/lavoro ricerca elenco',0),(183013,5084,'tl','',0),(183014,5084,'th','&#3649;&#3592;&#3657;&#3591;/&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;&#3591;&#3634;&#3609;',0),(183015,5084,'hi','à¤¬à¥‹à¤²à¥€/à¤¨à¥Œà¤•à¤°à¥€ à¤–à¥‹à¤œ à¤¸à¥‚à¤šà¥€',0),(183016,5084,'ms','Sebut harga/kerja Cari senarai',0),(183017,5084,'ar','Ø§Ù‚ØªØ¨Ø§Ø³/Ø§Ù„ÙˆØ¸ÙŠÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¨Ø­Ø«',0),(183018,5084,'fr','Liste de recherche de devis/Job',0),(183019,5084,'jp','è¦‹ç©?ã‚Š/ä½œæ¥­æ¤œç´¢ãƒªã‚¹ãƒˆ',0),(183020,5084,'pt','Lista de pesquisa de emprego/citaÃ§Ã£o',0),(183021,5084,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð°/Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ð¿Ð¾Ð¸ÑÐºÐ°',0),(183022,5084,'es','CotizaciÃ³n/Trabajo Lista de Busqueda',0),(183023,5084,'de','Zitat/Job-Search-Liste',0),(183024,5084,'en','Quote/Job Search List',0),(183025,5085,'is','',0),(183026,5085,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(183027,5085,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª ',0),(183028,5085,'tr','Fiyat listesi',0),(183029,5085,'pl','Cennik',0),(183030,5085,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(183031,5085,'ur','Ù¾Ø±Ø§Ú©Ø§Ù„Ø§Ø³Ù¹',0),(183032,5085,'sr','Ð¦Ñ˜ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(183033,5085,'vi','Báº£ng giÃ¡',0),(183034,5085,'af','Pryslys',0),(183035,5085,'ro','Lista de preÅ£uri',0),(183036,5085,'et','Hinnakiri',0),(183037,5085,'si','Cenik',0),(183038,5085,'ba','Pricelist',0),(183039,5085,'nl','Prijslijst',0),(183040,5085,'fi','Hinnasto',0),(183041,5085,'no','Prisliste',0),(183042,5085,'da','Prisliste',0),(183043,5085,'ko','ê°€ê²©í‘œ',0),(183044,5085,'he','×ž×—×™×¨×•×Ÿ',0),(183045,5085,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚',0),(183046,5085,'zh','ä»·æ ¼è¡¨\r\n',0),(183047,5085,'sv','Prislista',0),(183048,5085,'it','Listino prezzi',0),(183049,5085,'tl','',0),(183050,5085,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(183051,5085,'hi','Pricelist à¤•à¥‡ à¤²à¤¿à¤',0),(183052,5085,'ms','Senarai',0),(183053,5085,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(183054,5085,'fr','Liste de prix',0),(183055,5085,'jp','ä¾¡æ ¼è¡¨',0),(183056,5085,'pt','Lista de preÃ§os',0),(183057,5085,'ru','ÐŸÑ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(183058,5085,'es','Lista de Precios',0),(183059,5085,'de','Preisliste',0),(183060,5085,'en','Pricelist',0),(183061,5086,'is','',0),(183062,5086,'dr','Ú©Ø§Ø¯Ø±',0),(183063,5086,'pr','Ú©Ø§Ø¯Ø±',0),(183064,5086,'tr','Kutu',0),(183065,5086,'pl','Pole',0),(183066,5086,'bg','ÐšÑƒÑ‚Ð¸Ñ',0),(183067,5086,'ur','Ø®Ø§Ù†Û',0),(183068,5086,'sr','ÐšÑƒÑ‚Ð¸Ñ˜Ð°',0),(183069,5086,'vi','Há»™p',0),(183070,5086,'af','Boks',0),(183071,5086,'ro','Cutie',0),(183072,5086,'et','Kasti',0),(183073,5086,'si','Polje',0),(183074,5086,'ba','Kotak',0),(183075,5086,'nl','Vak',0),(183076,5086,'fi','Laatikko',0),(183077,5086,'no','Boksen',0),(183078,5086,'da','Boks',0),(183079,5086,'ko','ìƒìž',0),(183080,5086,'he','×ª×™×‘×ª',0),(183081,5086,'el','ÎšÎ¿Ï…Ï„Î¯',0),(183082,5086,'zh','ç›’\r\n',0),(183083,5086,'sv','Box',0),(183084,5086,'it','Casella',0),(183085,5086,'tl','',0),(183086,5086,'th','&#3585;&#3621;&#3656;&#3629;&#3591;',0),(183087,5086,'hi','à¤¬à¥‰à¤•à¥à¤¸',0),(183088,5086,'ms','Peti',0),(183089,5086,'ar','Ù…Ø±Ø¨Ø¹',0),(183090,5086,'fr','BoÃ®te',0),(183091,5086,'jp','ãƒœãƒƒã‚¯ã‚¹',0),(183092,5086,'pt','Caixa',0),(183093,5086,'ru','ÐšÐ¾Ñ€Ð¾Ð±ÐºÐ°',0),(183094,5086,'es','Caja',0),(183095,5086,'de','Box',0),(183096,5086,'en','Box',0),(183097,5087,'is','',0),(183098,5087,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ø¬Ø¹Ø¨Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(183099,5087,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ø¬Ø¹Ø¨Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(183100,5087,'tr','GÃ¶rÃ¼nÃ¼m kutusunda etiket iÃ§in tÄ±klayÄ±n',0),(183101,5087,'pl','Kliknij, aby etykiety pola widzenia',0),(183102,5087,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð˜Ð·Ð³Ð»ÐµÐ´ ÐºÑƒÑ‚Ð¸Ñ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(183103,5087,'ur','Ù…Ù†Ø¸Ø± Ø®Ø§Ù†Û Ù„ÛŒØ¨Ù„ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(183104,5087,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð·Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ðµ',0),(183105,5087,'vi','Nháº¥n Ä‘á»ƒ xem nhÃ£n há»™p',0),(183106,5087,'af','Kliek om Boks Ettikette te Besigtig',0),(183107,5087,'ro','Click sÄƒ Vezi caseta de etichete',0),(183108,5087,'et','Vaade kasti sildid nuppu',0),(183109,5087,'si','Kliknite za ogled polje oznake',0),(183110,5087,'ba','Klik untuk lihat kotak label',0),(183111,5087,'nl','Klik op weergave vak etiketten',0),(183112,5087,'fi','Valitsemalla tÃ¤mÃ¤n voit tarkastella laatikko tarroja',0),(183113,5087,'no','Klikk for Ã¥ vise boks etiketter',0),(183114,5087,'da','Klik for at se boks etiketter',0),(183115,5087,'ko','ë³´ê¸° ìƒìž ë ˆì´ë¸”ì„ í´ë¦­ í•©ë‹ˆë‹¤',0),(183116,5087,'he','×œ×—×¥ ×¢×œ ×ª×•×•×™×•×ª ×ª×™×‘×ª ×ª×¦×•×’×”',0),(183117,5087,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® Î ÏÎ¿Î²Î¿Î»Î® ÏƒÏ„Î¹Ï‚ ÎµÏ„Î¹ÎºÎ­Ï„ÎµÏ‚ Ï€Î»Î±Î¯ÏƒÎ¹Î¿',0),(183118,5087,'zh','ç‚¹å‡»æŸ¥çœ‹æ¡†æ ‡ç­¾\r\n',0),(183119,5087,'sv','Klicka fÃ¶r att Visa rutan etiketter',0),(183120,5087,'it','Mostra etichette scatole',0),(183121,5087,'tl','',0),(183122,5087,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3593;&#3621;&#3634;&#3585;',0),(183123,5087,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¬à¥‰à¤•à¥à¤¸ à¤²à¥‡à¤¬à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(183124,5087,'ms','Klik untuk paparan Peti label',0),(183125,5087,'ar','Ø§Ù†Ù‚Ø± Ù„Ø¹Ø±Ø¶ Ù…Ø±Ø¨Ø¹ Ø§Ù„ØªØ³Ù…ÙŠØ§Øª',0),(183126,5087,'fr','Cliquer pour les Ã©tiquettes de zone de vue',0),(183127,5087,'jp','ãƒœãƒƒã‚¯ã‚¹ãƒ©ãƒ™ãƒ«ã?®è¡¨ç¤ºã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(183128,5087,'pt','Clique para exibir rÃ³tulos de caixa',0),(183129,5087,'ru','Ð©ÐµÐ»ÐºÐ½Ð¸Ñ‚Ðµ Ð² Ð¿Ð¾Ð»Ðµ Ð¼ÐµÑ‚ÐºÐ¸ Ð²Ð¸Ð´Ð°',0),(183130,5087,'es','Click para Ver Etiquetas de Cajas',0),(183131,5087,'de','Klicken Sie auf Ansicht Etiketten',0),(183132,5087,'en','Click to View Box Labels',0),(183133,5088,'is','',0),(183134,5088,'dr','Ú†Ø§Ù¾ Ø¬Ø§ÙŠ ÙˆÙŠÚ˜Ù‡ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(183135,5088,'pr','Ú†Ø§Ù¾ Ø¬Ø§ÙŠ ÙˆÙŠÚ˜Ù‡ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(183136,5088,'tr','SipariÅŸ iÃ§in kutu etiketleri yazdÄ±rma',0),(183137,5088,'pl','Drukowanie etykiety pÃ³l na zamÃ³wienie',0),(183138,5088,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸ Ð½Ð° ÐºÑƒÑ‚Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(183139,5088,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ø®Ø§Ù†Û Ù„ÛŒØ¨Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(183140,5088,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¾Ð·Ð½Ð°ÐºÐ° ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(183141,5088,'vi','In nhÃ£n há»™p cho Ä‘Æ¡n hÃ ng',0),(183142,5088,'af','Druk Karton Etikette vir Bestelling',0),(183143,5088,'ro','ImprimaÅ£i etichete cutie pentru comanda',0),(183144,5088,'et','Prindi kasti sildid tellimuse',0),(183145,5088,'si','Tiskanje nalepk polje za nalog',0),(183146,5088,'ba','Cetak label kotak untuk Order',0),(183147,5088,'nl','Vak etiketten afdrukken voor Order',0),(183148,5088,'fi','Box tarrat tulostaa tilauksen',0),(183149,5088,'no','Skrive ut boksen etiketter for ordre',0),(183150,5088,'da','Udskrive emballageetiketter for ordre',0),(183151,5088,'ko','ì£¼ë¬¸ ìƒìž ë ˆì´ë¸” ì¸ì‡„',0),(183152,5088,'he','×”×“×¤×¡ ×ª×•×•×™×•×ª ×ª×™×‘×ª ×¢×‘×•×¨ ×”×–×ž× ×”',0),(183153,5088,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ ÎµÏ„Î¹ÎºÎ­Ï„ÎµÏ‚ ÎºÎ¿Ï…Ï„Î¯ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(183154,5088,'zh','æ‰“å°è®¢å•æ ‡ç­¾æ¡†\r\n',0),(183155,5088,'sv','Skriva ut rutan etiketter fÃ¶r bestÃ¤llning',0),(183156,5088,'it','Stampare etichette di Box per ordine',0),(183157,5088,'tl','',0),(183158,5088,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3593;&#3621;&#3634;&#3585;&#3585;&#3621;&#3656;&#3629;&#3591;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(183159,5088,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥‰à¤•à¥à¤¸ à¤²à¥‡à¤¬à¤²à¥à¤¸ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(183160,5088,'ms','Mencetak label kotak untuk pesanan',0),(183161,5088,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªØ³Ù…ÙŠØ§Øª Ù…Ø±Ø¨Ø¹ Ù„Ù„Ù†Ø¸Ø§Ù…',0),(183162,5088,'fr','Imprimer des Ã©tiquettes de boÃ®te de commande',0),(183163,5088,'jp','ãƒœãƒƒã‚¯ã‚¹ãƒ©ãƒ™ãƒ«ã?®è¡¨ç¤ºã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(183164,5088,'pt','Imprimir rÃ³tulos de caixa para a ordem',0),(183165,5088,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð½Ð°ÐºÐ»ÐµÐµÐº Ð¿Ð¾Ð»Ðµ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(183166,5088,'es','Imprimir Etiquetas de Caja para el Orden',0),(183167,5088,'de','Drucken von Etiketten fÃ¼r Bestellung',0),(183168,5088,'en','Print Box Labels for Order',0),(183169,5089,'is','',0),(183170,5089,'dr','Ø¨Ø±Ú†Ø³Ø¨ Ú©Ø§Ø¯Ø±',0),(183171,5089,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ú©Ø§Ø¯Ø±',0),(183172,5089,'tr','Kutusu etiketi',0),(183173,5089,'pl','Etykieta pola',0),(183174,5089,'bg','Ð•Ñ‚Ð¸ÐºÐµÑ‚ Ð½Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð¾',0),(183175,5089,'ur','Ø®Ø§Ù†Û Ù„ÛŒØ¨Ù„',0),(183176,5089,'sr','ÐŸÐ¾Ñ™Ðµ Ð·Ð° Ð¾Ð·Ð½Ð°ÐºÑƒ',0),(183177,5089,'vi','NhÃ£n Há»™p',0),(183178,5089,'af','Boks Etiket',0),(183179,5089,'ro','Eticheta casetei',0),(183180,5089,'et','Box Label',0),(183181,5089,'si','Oznako polja',0),(183182,5089,'ba','Kotak Label',0),(183183,5089,'nl','Vak Label',0),(183184,5089,'fi','Hakuruudun otsikko',0),(183185,5089,'no','Etikett',0),(183186,5089,'da','Etiket til sÃ¸gefeltet',0),(183187,5089,'ko','ìƒìž ë ˆì´ë¸”',0),(183188,5089,'he','×‘×ª×™×‘×” ×ª×•×•×™×ª',0),(183189,5089,'el','Î•Ï„Î¹ÎºÎ­Ï„Î± Ï€Î»Î±Î¹ÏƒÎ¯Î¿Ï…',0),(183190,5089,'zh','æ¡†æ ‡ç­¾\r\n',0),(183191,5089,'sv','Etikett',0),(183192,5089,'it','Etichetta della scatola',0),(183193,5089,'tl','',0),(183194,5089,'th','&#3593;&#3621;&#3634;&#3585;&#3586;&#3629;&#3591;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(183195,5089,'hi','à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥‡ à¤²à¥‡à¤¬à¤²',0),(183196,5089,'ms','Label kotak',0),(183197,5089,'ar','ØªØ³Ù…ÙŠØ© Ù…Ø±Ø¨Ø¹',0),(183198,5089,'fr','Ã‰tiquette de la zone',0),(183199,5089,'jp','ãƒœãƒƒã‚¯ã‚¹ãƒ©ãƒ™ãƒ«',0),(183200,5089,'pt','Etiqueta da caixa',0),(183201,5089,'ru','ÐœÐµÑ‚ÐºÐ°',0),(183202,5089,'es','Caja Etiqueta',0),(183203,5089,'de','Feld Etikett',0),(183204,5089,'en','Box Label',0),(183205,5090,'is','',0),(183206,5090,'dr',' Ø´Ù…Ø§Ø±Ù‡ ÙˆØ§Ù…',0),(183207,5090,'pr',' Ø´Ù…Ø§Ø±Ù‡ ÙˆØ§Ù…',0),(183208,5090,'tr','LN #',0),(183209,5090,'pl','Ln #',0),(183210,5090,'bg','LN #',0),(183211,5090,'ur','Ù„Ù† #',0),(183212,5090,'sr','Ð£ #',0),(183213,5090,'vi','Sá»‘ Ln',0),(183214,5090,'af','Ln #',0),(183215,5090,'ro','Ln #',0),(183216,5090,'et','Nr:',0),(183217,5090,'si','Ln #',0),(183218,5090,'ba','LN #',0),(183219,5090,'nl','LN #',0),(183220,5090,'fi','LN #',0),(183221,5090,'no','Ln #',0),(183222,5090,'da','LN #',0),(183223,5090,'ko','Ln #',0),(183224,5090,'he','Ln #',0),(183225,5090,'el','LN #',0),(183226,5090,'zh','è´Ÿè½½æ•°ï¼ƒ\r\n',0),(183227,5090,'sv','Ln #',0),(183228,5090,'it','Ln #',0),(183229,5090,'tl','',0),(183230,5090,'th','Ln#',0),(183231,5090,'hi','Ln #',0),(183232,5090,'ms','Ln #',0),(183233,5090,'ar','Ln #',0),(183234,5090,'fr','Ln #',0),(183235,5090,'jp','ãƒ©ã‚¤ãƒ³ç•ªå?·',0),(183236,5090,'pt','Ln #',0),(183237,5090,'ru','LN #',0),(183238,5090,'es','Ln#',0),(183239,5090,'de','Ln #',0),(183240,5090,'en','Ln#',0),(183241,5091,'is','',0),(183242,5091,'dr','( Ù…Ù†Ø¯Ø±Ø¬Ø§Øª ',0),(183243,5091,'pr','Ù…Ø­ØªÙˆÙ‰ ( Ù…Ù†Ø¯Ø±Ø¬Ø§Øª ',0),(183244,5091,'tr','Ä°Ã§indekiler',0),(183245,5091,'pl','ZawartoÅ›Ä‡',0),(183246,5091,'bg','Ð¡ÑŠÐ´ÑŠÑ€Ð¶Ð°Ð½Ð¸ÐµÑ‚Ð¾',0),(183247,5091,'ur','ÙÛØ±Ø³Øª Ù…Ø´Ù…ÙˆÙ„Ø§Øª',0),(183248,5091,'sr','Ð¡Ð°Ð´Ñ€Ð¶Ð°Ñ˜',0),(183249,5091,'vi','Ná»™i dung',0),(183250,5091,'af','Inhoud',0),(183251,5091,'ro','ConÅ£inutul',0),(183252,5091,'et','Sisu',0),(183253,5091,'si','Vsebina',0),(183254,5091,'ba','Isi',0),(183255,5091,'nl','Inhoud',0),(183256,5091,'fi','SisÃ¤ltÃ¶',0),(183257,5091,'no','Innholdet',0),(183258,5091,'da','Indhold',0),(183259,5091,'ko','ë‚´ìš©',0),(183260,5091,'he','×ª×•×›×Ÿ',0),(183261,5091,'el','Î ÎµÏÎ¹ÎµÏ‡ÏŒÎ¼ÎµÎ½Î±',0),(183262,5091,'zh','å†…å®¹\r\n',0),(183263,5091,'sv','InnehÃ¥llet',0),(183264,5091,'it','Contenuto',0),(183265,5091,'tl','',0),(183266,5091,'th','&#3648;&#3609;&#3639;&#3657;&#3629;&#3627;&#3634;',0),(183267,5091,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€',0),(183268,5091,'ms','Kandungan',0),(183269,5091,'ar','Ù…Ø­ØªÙˆÙŠØ§Øª',0),(183270,5091,'fr','Contenu',0),(183271,5091,'jp','å†…å®¹',0),(183272,5091,'pt','ConteÃºdo',0),(183273,5091,'ru','Ð¡Ð¾Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ðµ',0),(183274,5091,'es','Contenidos',0),(183275,5091,'de','Inhalt',0),(183276,5091,'en','Contents',0),(183277,5092,'is','',0),(183278,5092,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ ',0),(183279,5092,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ ',0),(183280,5092,'tr','Etiket yazdÄ±r',0),(183281,5092,'pl','Liczba etykiet do wydruku',0),(183282,5092,'bg','Ð‘Ñ€Ð¾ÑÑ‚ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸Ñ‚Ðµ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(183283,5092,'ur','Ù„ÛŒØ¨Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº Ú©Ø±Ù†Û’ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(183284,5092,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½Ð°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ð° Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(183285,5092,'vi','Sá»‘ nhÃ£n Ä‘á»ƒ in',0),(183286,5092,'af','Aantal Etikette om te Druk',0),(183287,5092,'ro','NumÄƒrul de etichete pentru imprimare',0),(183288,5092,'et','Siltide printimine arvu',0),(183289,5092,'si','Å tevilo nalepk, tisk',0),(183290,5092,'ba','Jumlah label untuk cetak',0),(183291,5092,'nl','Aantal etiketten af te drukken',0),(183292,5092,'fi','Tarrojen tulostaminen mÃ¤Ã¤rÃ¤Ã¤',0),(183293,5092,'no','Antall etiketter til ut',0),(183294,5092,'da','Antal etiketter til Print',0),(183295,5092,'ko','ì¸ì‡„ í•˜ë ¤ë©´ ë ˆì´ë¸” ìˆ˜',0),(183296,5092,'he','×ž×¡×¤×¨ ×ª×•×•×™×•×ª ×œ×”×“×¤×¡×”',0),(183297,5092,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ ÎµÏ„Î¹ÎºÎµÏ„ÏŽÎ½ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(183298,5092,'zh','æ‰“å°çš„æ ‡ç­¾æ•°é‡\r\n',0),(183299,5092,'sv','Antalet etiketter fÃ¶r utskrift',0),(183300,5092,'it','Numero di etichette per la stampa',0),(183301,5092,'tl','',0),(183302,5092,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3593;&#3621;&#3634;&#3585;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(183303,5092,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥‡à¤¬à¤²à¥à¤¸ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(183304,5092,'ms','Bilangan label untuk cetak',0),(183305,5092,'ar','Ø¹Ø¯Ø¯ Ù…Ù† Ø§Ù„ØªØ³Ù…ÙŠØ§Øª Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(183306,5092,'fr','Nombre d\'Ã©tiquettes Ã  imprimer',0),(183307,5092,'jp','å?°åˆ·ã?™ã‚‹ãƒ©ãƒ™ãƒ«æ•°',0),(183308,5092,'pt','NÃºmero de etiquetas para impressÃ£o',0),(183309,5092,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¼ÐµÑ‚Ð¾Ðº Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(183310,5092,'es','NÃºmero d Etiquetas para Imprimir',0),(183311,5092,'de','Anzahl der Etiketten drucken',0),(183312,5092,'en','Number of Labels to Print',0),(183313,5093,'is','',0),(183314,5093,'dr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø¢Ø¯Ø±Ø³ Ø¨Ø±Ø§ÙŠ ',0),(183315,5093,'pr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø¢Ø¯Ø±Ø³ Ø¨Ø±Ø§ÙŠ ',0),(183316,5093,'tr','Adres iÃ§in gÃ¶rÃ¼ntÃ¼den',0),(183317,5093,'pl','WyÅ›wietlacz z adresu',0),(183318,5093,'bg','Ð”Ð¸ÑÐ¿Ð»ÐµÑ Ð¾Ñ‚ Ð°Ð´Ñ€ÐµÑ Ð·Ð°',0),(183319,5093,'ur','ÚˆØ³Ù¾Ù„Û’ Ú©Û’ Ø¹Ù†ÙˆØ§Ù† Ø³Û’',0),(183320,5093,'sr','Ð•ÐºÑ€Ð°Ð½ ÑÐ° Ð°Ð´Ñ€ÐµÑÐµ Ð·Ð°',0),(183321,5093,'vi','Hiá»ƒn thá»‹ tá»« Ä‘á»‹a chá»‰ cho',0),(183322,5093,'af','Vertoon van adres vir',0),(183323,5093,'ro','AfiÅŸare la adresa pentru',0),(183324,5093,'et','Kuvatav aadress:',0),(183325,5093,'si','Prikaz naslova za',0),(183326,5093,'ba','Tampilan dari alamat',0),(183327,5093,'nl','Weergave van adres voor',0),(183328,5093,'fi','NÃ¤ytÃ¤ osoite',0),(183329,5093,'no','Skjermen fra adressen',0),(183330,5093,'da','Display fra adresse For',0),(183331,5093,'ko','ì£¼ì†Œì—ì„œ í‘œì‹œ',0),(183332,5093,'he','×ª×¦×•×’×” ×©×œ ×›×ª×•×‘×ª',0),(183333,5093,'el','ÎŸÎ¸ÏŒÎ½Î· Î±Ï€ÏŒ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î³Î¹Î±',0),(183334,5093,'zh','æ˜¾ç¤ºä»Žåœ°å€ä¸º\r\n',0),(183335,5093,'sv','Visning frÃ¥n adress fÃ¶r',0),(183336,5093,'it','Visualizzazione da indirizzo per',0),(183337,5093,'tl','',0),(183338,5093,'th','&#3649;&#3626;&#3604;&#3591;&#3592;&#3634;&#3585;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(183339,5093,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¤à¥‡ à¤¸à¥‡',0),(183340,5093,'ms','Paparan dari alamat bagi',0),(183341,5093,'ar','Ø¹Ø±Ø¶ Ù…Ù† Ø¹Ù†ÙˆØ§Ù†',0),(183342,5093,'fr','Affichage de l\'adresse pour',0),(183343,5093,'jp','ï½žã?®ç™ºé€?å…ƒä½?æ‰€ã‚’è¡¨ç¤º',0),(183344,5093,'pt','ExibiÃ§Ã£o do endereÃ§o para',0),(183345,5093,'ru','Ð”Ð¸ÑÐ¿Ð»ÐµÐ¹ Ñ Ð°Ð´Ñ€ÐµÑÐ° Ð´Ð»Ñ',0),(183346,5093,'es','Desplegar DirecciÃ³n de OrÃ­gen Para',0),(183347,5093,'de','Anzeige Absenderadresse fÃ¼r',0),(183348,5093,'en','Display From Address For',0),(183349,5094,'is','',0),(183350,5094,'dr','Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§',0),(183351,5094,'pr','Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§',0),(183352,5094,'tr','SipariÅŸ',0),(183353,5094,'pl','Twoje zamÃ³wienie',0),(183354,5094,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(183355,5094,'ur','Ø¢Ù¾ Ú©Ø§ Ø¢Ø±ÚˆØ±',0),(183356,5094,'sr','Ð¢Ð²Ð¾Ñ˜ Ñ€ÐµÐ´.',0),(183357,5094,'vi','ÄÆ¡n hÃ ng cá»§a báº¡n',0),(183358,5094,'af','U Bestelling',0),(183359,5094,'ro','Comanda dumneavoastra',0),(183360,5094,'et','Teie tellimus',0),(183361,5094,'si','VaÅ¡e naroÄilo',0),(183362,5094,'ba','Pesanan Anda',0),(183363,5094,'nl','Uw bestelling',0),(183364,5094,'fi','Tilauksesi',0),(183365,5094,'no','Bestillingen',0),(183366,5094,'da','Din ordre',0),(183367,5094,'ko','ê·€í•˜ì˜ ì£¼ë¬¸',0),(183368,5094,'he','×”×”×–×ž× ×” ×©×œ×š',0),(183369,5094,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÎ±Ï‚',0),(183370,5094,'zh','æ‚¨çš„è®¢å•\r\n',0),(183371,5094,'sv','Din bestÃ¤llning',0),(183372,5094,'it','Vostro ordine',0),(183373,5094,'tl','',0),(183374,5094,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(183375,5094,'hi','à¤…à¤ªà¤¨à¥‡ à¤†à¤¦à¥‡à¤¶',0),(183376,5094,'ms','Pesanan anda',0),(183377,5094,'ar','Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(183378,5094,'fr','Votre commande',0),(183379,5094,'jp','ã?‚ã?ªã?Ÿã?®æ³¨æ–‡',0),(183380,5094,'pt','Sua ordem',0),(183381,5094,'ru','Ð’Ð°Ñˆ Ð—Ð°ÐºÐ°Ð·',0),(183382,5094,'es','Su Pedido',0),(183383,5094,'de','Ihre Bestellung',0),(183384,5094,'en','Your Order',0),(183385,5095,'is','',0),(183386,5095,'dr','ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(183387,5095,'pr','ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(183388,5095,'tr','OnaylÄ±',0),(183389,5095,'pl','Zatwierdzone',0),(183390,5095,'bg','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¸',0),(183391,5095,'ur','Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(183392,5095,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½',0),(183393,5095,'vi','Cháº¥p Thuáº­n',0),(183394,5095,'af','Goedgekeur',0),(183395,5095,'ro','Aprobat',0),(183396,5095,'et','Heaks',0),(183397,5095,'si','Odobril',0),(183398,5095,'ba','Disetujui',0),(183399,5095,'nl','Goedgekeurd',0),(183400,5095,'fi','HyvÃ¤ksytty',0),(183401,5095,'no','Godkjent',0),(183402,5095,'da','Godkendt',0),(183403,5095,'ko','ìŠ¹ì¸',0),(183404,5095,'he','××•×©×¨×”',0),(183405,5095,'el','Î•Î³ÎºÏÎ¹Î¸ÎµÎ¯',0),(183406,5095,'zh','æ ¸å‡†\r\n',0),(183407,5095,'sv','GodkÃ¤nd',0),(183408,5095,'it','Approvato',0),(183409,5095,'tl','',0),(183410,5095,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(183411,5095,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤',0),(183412,5095,'ms','Diluluskan',0),(183413,5095,'ar','ÙˆØ§ÙÙ‚',0),(183414,5095,'fr','ApprouvÃ©',0),(183415,5095,'jp','æ‰¿èª?æ¸ˆ',0),(183416,5095,'pt','Aprovado',0),(183417,5095,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½',0),(183418,5095,'es','Aprobado',0),(183419,5095,'de','Genehmigt',0),(183420,5095,'en','Approved',0),(183421,5096,'is','',0),(183422,5096,'dr','Ø¨Ø®Ø´ ØµÙ†Ø¹ØªÙŠ',0),(183423,5096,'pr','Ø¨Ø®Ø´ ØµÙ†Ø¹ØªÙŠ',0),(183424,5096,'tr','Sanat departmanÄ±',0),(183425,5096,'pl','WydziaÅ‚ sztuki',0),(183426,5096,'bg','Ð˜Ð·ÐºÑƒÑÑ‚Ð²Ð¾ Ð¾Ñ‚Ð´ÐµÐ»',0),(183427,5096,'ur','Ø¢Ø±Ù¹ Ù…Ø­Ú©Ù…Û',0),(183428,5096,'sr','ÐÑ€Ñ‚ Ð”ÐµÐ¿Ð°Ñ€Ñ‚Ð¼ÐµÐ½Ñ‚',0),(183429,5096,'vi','PhÃ²ng Thiáº¿t Káº¿',0),(183430,5096,'af','Kuns Departement',0),(183431,5096,'ro','Departamentul de arta',0),(183432,5096,'et','Art osakond',0),(183433,5096,'si','Oddelek za umetnost',0),(183434,5096,'ba','Departemen seni',0),(183435,5096,'nl','Art Department',0),(183436,5096,'fi','Art osasto',0),(183437,5096,'no','Kunstavdelingen',0),(183438,5096,'da','Kunst afdeling',0),(183439,5096,'ko','ë¯¸ìˆ í•™ê³¼',0),(183440,5096,'he','×ž×—×œ×§×ª ×”××ž× ×•×ª.',0),(183441,5096,'el','Î•Ï†Î¿ÏÎµÎ¯Î± ÎºÎ±Î»Î»Î¹Ï„ÎµÏ‡Î½Î¹ÎºÎ¿Ï',0),(183442,5096,'zh','è‰ºæœ¯éƒ¨é—¨\r\n',0),(183443,5096,'sv','Art Department',0),(183444,5096,'it','Dipartimento di arte',0),(183445,5096,'tl','',0),(183446,5096,'th','&#3649;&#3612;&#3609;&#3585;&#3624;&#3636;&#3621;&#3611;&#3632;',0),(183447,5096,'hi','à¤•à¤²à¤¾ à¤µà¤¿à¤­à¤¾à¤—',0),(183448,5096,'ms','Jabatan Seni',0),(183449,5096,'ar','Ù‚Ø³Ù… Ø§Ù„ÙÙ†',0),(183450,5096,'fr','DÃ©partement d\'art',0),(183451,5096,'jp','ã‚¤ãƒ©ã‚¹ãƒˆéƒ¨é–€',0),(183452,5096,'pt','Departamento de arte',0),(183453,5096,'ru','Ð¥ÑƒÐ´Ð¾Ð¶ÐµÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ ÐžÑ‚Ð´ÐµÐ»',0),(183454,5096,'es','Departamento de Arte',0),(183455,5096,'de','Kunstabteilung',0),(183456,5096,'en','Art Department',0),(183457,5097,'is','',0),(183458,5097,'dr','ØµÙ†Ø¹Øª Ø¹Ø±Ø¶Ù‡ Ø´Ø¯Ù‡',0),(183459,5097,'pr','ØµÙ†Ø¹Øª Ø¹Ø±Ø¶Ù‡ Ø´Ø¯Ù‡',0),(183460,5097,'tr','Sanat tarafÄ±ndan saÄŸlanan',0),(183461,5097,'pl','Sztuka dostarczane',0),(183462,5097,'bg','ÐÑ€Ñ‚ Ð´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð¸',0),(183463,5097,'ur','Ø¢Ø±Ù¹ ÙØ±Ø§ÛÙ…',0),(183464,5097,'sr','ÐÑ€Ñ‚ Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð¾.',0),(183465,5097,'vi','Váº­t Liá»‡u Cho Thiáº¿t Káº¿',0),(183466,5097,'af','Kuns Voorsien',0),(183467,5097,'ro','Arta furnizate',0),(183468,5097,'et','Art tarnitud',0),(183469,5097,'si','Umetnosti, ki',0),(183470,5097,'ba','Seni disediakan',0),(183471,5097,'nl','Kunst kopen',0),(183472,5097,'fi','Art myy',0),(183473,5097,'no','Kunst leveres',0),(183474,5097,'da','Kunst leveres',0),(183475,5097,'ko','ì˜ˆìˆ  ê³µê¸‰',0),(183476,5097,'he','××ž× ×•×ª ×©×¡×•×¤×§×•',0),(183477,5097,'el','Î¤Î­Ï‡Î½Î· Ï€Î¿Ï… Ï€Î±ÏÎ­Ï‡Î¿Î½Ï„Î±Î¹',0),(183478,5097,'zh','è‰ºæœ¯æä¾›\r\n',0),(183479,5097,'sv','Konst levereras',0),(183480,5097,'it','Arte in dotazione',0),(183481,5097,'tl','',0),(183482,5097,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3591;&#3634;&#3609;&#3624;&#3636;&#3621;&#3611;&#3632;',0),(183483,5097,'hi','à¤•à¤²à¤¾ à¤•à¥€ à¤†à¤ªà¥‚à¤°à¥à¤¤à¤¿',0),(183484,5097,'ms','Seni dibekalkan',0),(183485,5097,'ar','Ø²ÙˆØ¯Øª Ø§Ù„ÙÙ†',0),(183486,5097,'fr','Art fourni',0),(183487,5097,'jp','æ??ä¾›ã?•ã‚Œã?Ÿã‚¤ãƒ©ã‚¹ãƒˆ',0),(183488,5097,'pt','Arte fornecida',0),(183489,5097,'ru','Ð˜ÑÐºÑƒÑÑÑ‚Ð²Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÑÐµÑ‚ÑÑ',0),(183490,5097,'es','Arte Suministrado',0),(183491,5097,'de','Kunst geliefert',0),(183492,5097,'en','Art Supplied',0),(183493,5098,'is','',0),(183494,5098,'dr','/ Ù…Ø´Ù…Ø¬Ù…ÙˆØ¹Ø§Øª/ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(183495,5098,'pr','ØªØºÙŠÙŠØ±Ø§Øª/ Ù…Ø´ÙƒÙ„Ø§Øª/ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(183496,5098,'tr','DeÄŸiÅŸiklikler/sorun/notlar',0),(183497,5098,'pl','Zmiany era problemy',0),(183498,5098,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸/Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð¸/Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(183499,5098,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº/Ù…Ø³Ø§Ø¦Ù„/Ù†ÙˆÙ¹',0),(183500,5098,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð°/Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð¸/Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(183501,5098,'vi','Thay Ä‘á»•i/Trá»¥c tráº·c/Ghi chÃº',0),(183502,5098,'af','Verander/Probleme/Notas',0),(183503,5098,'ro','ModificÄƒri/probleme/note',0),(183504,5098,'et','Muutused/probleeme/mÃ¤rkused',0),(183505,5098,'si','Spremembe/teÅ¾ave/opombe',0),(183506,5098,'ba','Perubahan/masalah/catatan',0),(183507,5098,'nl','Wijzigingen/problemen/Notes',0),(183508,5098,'fi','Muutokset/ongelmat/muistiinpanoja',0),(183509,5098,'no','Endringer/problemer/notater',0),(183510,5098,'da','Ã†ndringer/problemer/noter',0),(183511,5098,'ko','ë³€ê²½/ë¬¸ì œ/ë…¸íŠ¸',0),(183512,5098,'he','×©×™× ×•×™×™×/×‘×¢×™×•×ª/×”×¢×¨×•×ª',0),(183513,5098,'el','Î‘Î»Î»Î±Î³Î­Ï‚/Ï€ÏÎ¿Î²Î»Î®Î¼Î±Ï„Î±/ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(183514,5098,'zh','å˜æ›´/é—®é¢˜/å¤‡æ³¨\r\n',0),(183515,5098,'sv','Ã„ndringar/problem/noterar',0),(183516,5098,'it','Modifiche/problemi/note',0),(183517,5098,'tl','',0),(183518,5098,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;/&#3611;&#3633;&#3597;&#3627;&#3634;/&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(183519,5098,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨/à¤¸à¤®à¤¸à¥à¤¯à¤¾à¤“à¤‚/à¤¨à¥‹à¤Ÿà¥à¤¸',0),(183520,5098,'ms','Perubahan/masalah/Nota-Nota',0),(183521,5098,'ar','Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª/Ø§Ù„Ù…Ø´Ø§ÙƒÙ„/Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(183522,5098,'fr','Remarques/problÃ¨mes/modifications',0),(183523,5098,'jp','å¤‰æ›´/å•?é¡Œ/ãƒ¡ãƒ¢',0),(183524,5098,'pt','AlteraÃ§Ãµes/problemas/Notes',0),(183525,5098,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ/ÐŸÑ€Ð¾Ð±Ð»ÐµÐ¼Ñ‹/Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(183526,5098,'es','Cambios/Problemas/Notas',0),(183527,5098,'de','Ã„nderungen/Probleme/Hinweise',0),(183528,5098,'en','Changes/Problems/Notes',0),(183529,5099,'is','',0),(183530,5099,'dr','ÙƒÙ¾ÙŠ Ø±Ù†Ú¯ ',0),(183531,5099,'pr','ÙƒÙ¾ÙŠ Ø±Ù†Ú¯ ',0),(183532,5099,'tr','Renkli kopyalama',0),(183533,5099,'pl','Kolor kopia',0),(183534,5099,'bg','Ð¦Ð²ÐµÑ‚Ð½Ð¾ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ',0),(183535,5099,'ur','Ø±Ù†Ú¯ Ù†Ù‚Ù„',0),(183536,5099,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ˜ Ð±Ð¾Ñ˜Ðµ',0),(183537,5099,'vi','Báº£n sao máº§u',0),(183538,5099,'af','Kleur KopiÃ«',0),(183539,5099,'ro','Culoare copie',0),(183540,5099,'et','VÃ¤rvi kopeerimine',0),(183541,5099,'si','Barva ulitek',0),(183542,5099,'ba','Salinan warna',0),(183543,5099,'nl','Kleur kopiÃ«ren',0),(183544,5099,'fi','VÃ¤rikopio',0),(183545,5099,'no','Fargekopi',0),(183546,5099,'da','Farvekopi',0),(183547,5099,'ko','ì»¬ëŸ¬ ë³µì‚¬',0),(183548,5099,'he','×¢×•×ª×§ ×¦×‘×¢×•× ×™',0),(183549,5099,'el','ÎˆÎ³Ï‡ÏÏ‰Î¼Î¿ Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿',0),(183550,5099,'zh','å½©è‰²å¤å°\r\n',0),(183551,5099,'sv','FÃ¤rgkopiering',0),(183552,5099,'it','Copia colore',0),(183553,5099,'tl','',0),(183554,5099,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3626;&#3637;',0),(183555,5099,'hi','à¤°à¤‚à¤— à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿',0),(183556,5099,'ms','Salinan warna',0),(183557,5099,'ar','Ù†Ø³Ø® Ø§Ù„Ù„ÙˆÙ†',0),(183558,5099,'fr','Copie couleur',0),(183559,5099,'jp','è‰²ã?®ã‚³ãƒ”ãƒ¼',0),(183560,5099,'pt','CÃ³pia colorida',0),(183561,5099,'ru','Ð¦Ð²ÐµÑ‚ ÐºÐ¾Ð¿Ð¸Ð¸',0),(183562,5099,'es','Color Copia',0),(183563,5099,'de','Farbkopie',0),(183564,5099,'en','Color Copy',0),(183565,5100,'is','',0),(183566,5100,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(183567,5100,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(183568,5100,'tr','MÃ¼ÅŸteri sipariÅŸi',0),(183569,5100,'pl','ZamÃ³wienie klienta',0),(183570,5100,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(183571,5100,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(183572,5100,'sr','ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(183573,5100,'vi','ÄÆ¡n Ä‘áº·t hÃ ng cá»§a khÃ¡ch hÃ ng',0),(183574,5100,'af','Klant / KliÃ«nt Bestelling',0),(183575,5100,'ro','Comanda clientului',0),(183576,5100,'et','Klienditellimuse kood',0),(183577,5100,'si','NaroÄilo kupca',0),(183578,5100,'ba','Customer Order',0),(183579,5100,'nl','Bestelling van de klant',0),(183580,5100,'fi','Asiakastilaus',0),(183581,5100,'no','Kundeordre',0),(183582,5100,'da','Kundeordre',0),(183583,5100,'ko','ê³ ê° ì£¼ë¬¸',0),(183584,5100,'he','×”×–×ž× ×ª ×œ×§×•×—',0),(183585,5100,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(183586,5100,'zh','å®¢æˆ·å®šå•',0),(183587,5100,'sv','Kundordern',0),(183588,5100,'it','Ordine cliente',0),(183589,5100,'tl','',0),(183590,5100,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(183591,5100,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(183592,5100,'ms','Pesanan pelanggan',0),(183593,5100,'ar','Ø·Ù„Ø¨ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(183594,5100,'fr','Commande client',0),(183595,5100,'jp','é¡§å®¢æ³¨æ–‡',0),(183596,5100,'pt','Ordem do cliente',0),(183597,5100,'ru','Ð—Ð°ÐºÐ°Ð· ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(183598,5100,'es','Cliente Pedido',0),(183599,5100,'de','Kundenauftrag',0),(183600,5100,'en','Customer Order',0),(183601,5101,'is','',0),(183602,5101,'dr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(183603,5101,'pr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(183604,5101,'tr','Sevk tarihi',0),(183605,5101,'pl','Daty wysÅ‚ane',0),(183606,5101,'bg','Ð”Ð°Ñ‚Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸',0),(183607,5101,'ur','ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(183608,5101,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½',0),(183609,5101,'vi','NgÃ y chuyá»ƒn',0),(183610,5101,'af','Datum Versend',0),(183611,5101,'ro','Data expediate',0),(183612,5101,'et','Tarneaeg',0),(183613,5101,'si','Datum poÅ¡iljke',0),(183614,5101,'ba','Tanggal yang dikirim',0),(183615,5101,'nl','Verzenddatum',0),(183616,5101,'fi','ToimituspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n',0),(183617,5101,'no','Dato sendt',0),(183618,5101,'da','Dato afsendt',0),(183619,5101,'ko','ë°°ì†¡ ë‚ ì§œ',0),(183620,5101,'he','×ª××¨×™×š ×ž×©×œ×•×—',0),(183621,5101,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(183622,5101,'zh','å‘è´§æ—¥æœŸ\r\n',0),(183623,5101,'sv','Datum levereras',0),(183624,5101,'it','Data spedita',0),(183625,5101,'tl','',0),(183626,5101,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(183627,5101,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(183628,5101,'ms','Tarikh dihantar',0),(183629,5101,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø´Ø­Ù†',0),(183630,5101,'fr','Date d\'expÃ©dition',0),(183631,5101,'jp','ç™ºé€?æ—¥',0),(183632,5101,'pt','Data enviada',0),(183633,5101,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(183634,5101,'es','Fecha Enviada',0),(183635,5101,'de','Dem Versanddatum',0),(183636,5101,'en','Date Shipped',0),(183637,5102,'is','',0),(183638,5102,'dr','Insp  Ø¨Ø§Ø²Ø±Ø³',0),(183639,5102,'pr','Insp  Ø¨Ø§Ø²Ø±Ø³',0),(183640,5102,'tr','Insp',0),(183641,5102,'pl','Insp',0),(183642,5102,'bg','INSP',0),(183643,5102,'ur','Ø§Ù†Ø³Ù¾',0),(183644,5102,'sr','Ð˜Ð½ÑÐ¿',0),(183645,5102,'vi','Insp',0),(183646,5102,'af','Insp',0),(183647,5102,'ro','Insp',0),(183648,5102,'et','Insp',0),(183649,5102,'si','Insp',0),(183650,5102,'ba','Insp',0),(183651,5102,'nl','INSP',0),(183652,5102,'fi','Innoittamana outo',0),(183653,5102,'no','Insp',0),(183654,5102,'da','Insp',0),(183655,5102,'ko','Insp',0),(183656,5102,'he','×‘×”×©×¨××ª ×”×¢×•×œ× ×”×¤× ',0),(183657,5102,'el','INSP',0),(183658,5102,'zh','ç›‘ç£\r\n',0),(183659,5102,'sv','Insp',0),(183660,5102,'it','INSP',0),(183661,5102,'tl','',0),(183662,5102,'th','Insp',0),(183663,5102,'hi','Insp',0),(183664,5102,'ms','Ya',0),(183665,5102,'ar','Ø§Ù„ÙØ­Øµ',0),(183666,5102,'fr','INSP',0),(183667,5102,'jp','ç‚¹æ¤œ',0),(183668,5102,'pt','Insp',0),(183669,5102,'ru','ÐÐ¸Ð·',0),(183670,5102,'es','Insp',0),(183671,5102,'de','Insp',0),(183672,5102,'en','Insp',0),(183673,5103,'is','',0),(183674,5103,'dr','Ø´ØºÙ„ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(183675,5103,'pr','Ø´ØºÙ„ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(183676,5103,'tr','AlÄ±nan iÅŸ',0),(183677,5103,'pl','Praca otrzymaÅ‚a',0),(183678,5103,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸',0),(183679,5103,'ur','Ø¬Ø§Ø¨ Ù…Ù„ÛŒ',0),(183680,5103,'sr','Ð”Ð¾Ð±Ð¸Ð¾ Ñ˜Ðµ Ð¿Ð¾ÑÐ°Ð¾',0),(183681,5103,'vi','ÄÃ£ nháº­n Job',0),(183682,5103,'af','Kontrakwerk Ontvang',0),(183683,5103,'ro','Job primite',0),(183684,5103,'et','Laekunud tÃ¶Ã¶d',0),(183685,5103,'si','Delo prejel',0),(183686,5103,'ba','Pekerjaan yang diterima',0),(183687,5103,'nl','Baan ontvangen',0),(183688,5103,'fi','TyÃ¶ sai',0),(183689,5103,'no','Mottatt',0),(183690,5103,'da','Modtages',0),(183691,5103,'ko','ì ‘ìˆ˜ ì¼',0),(183692,5103,'he','×§×™×‘×œ ××ª ×”×¢×‘×•×“×”',0),(183693,5103,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï€Î¿Ï… Î­Î»Î±Î²Îµ',0),(183694,5103,'zh','æŽ¥å—åœ¨èŒ\r\n',0),(183695,5103,'sv','Jobb fick',0),(183696,5103,'it','Lavoro ricevuto',0),(183697,5103,'tl','',0),(183698,5103,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3591;&#3634;&#3609;',0),(183699,5103,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(183700,5103,'ms','Kerja yang diterima',0),(183701,5103,'ar','ÙˆØªÙ„Ù‚Ù‰ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(183702,5103,'fr','Emploi a reÃ§u',0),(183703,5103,'jp','å?—é ˜ã?—ã?Ÿä½œæ¥­',0),(183704,5103,'pt','Trabalho recebido',0),(183705,5103,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»Ð°',0),(183706,5103,'es','Trabajo Recibido',0),(183707,5103,'de','Job empfangen',0),(183708,5103,'en','Job Received',0),(183709,5104,'is','',0),(183710,5104,'dr','Master Sheet Size',0),(183711,5104,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠMaster Sheet Size',0),(183712,5104,'tr','Ana sayfa boyutu',0),(183713,5104,'pl','Rozmiar arkusza Master',0),(183714,5104,'bg','ÐžÐ±Ñ€Ð°Ð·ÐµÑ† Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(183715,5104,'ur','Ù…Ø§Ø³Ù¹Ø± Ú©Û’ Ø³Ø§Ø¦Ø² ÙˆØ±Ù‚',0),(183716,5104,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð»Ð¸ÑÑ‚Ð° Ð¼Ð°ÑÑ‚ÐµÑ€',0),(183717,5104,'vi','Cá»¡ trang chá»§',0),(183718,5104,'af','Meester vel grootte',0),(183719,5104,'ro','Dimensiune foaie Master',0),(183720,5104,'et','Kapten lehe suurus',0),(183721,5104,'si','Velikost lista Master',0),(183722,5104,'ba','Master lembar ukuran',0),(183723,5104,'nl','Master papierformaat',0),(183724,5104,'fi','Master arkkikoko',0),(183725,5104,'no','Master arkstÃ¸rrelse',0),(183726,5104,'da','Master ark stÃ¸rrelse',0),(183727,5104,'ko','ë§ˆìŠ¤í„° ì‹œíŠ¸ í¬ê¸°',0),(183728,5104,'he','×’×•×“×œ ×’×™×œ×™×•×Ÿ ×ž××¡×˜×¨',0),(183729,5104,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Ï†ÏÎ»Î»Î¿Ï… Master',0),(183730,5104,'zh','æŽŒæ¡çº¸å¼ å°ºå¯¸\r\n',0),(183731,5104,'sv','Master arkstorlek',0),(183732,5104,'it','Dimensione foglio Master',0),(183733,5104,'tl','',0),(183734,5104,'th','&#3586;&#3609;&#3634;&#3604;&#3649;&#3612;&#3656;&#3609;&#3591;&#3634;&#3609;&#3627;&#3621;&#3633;&#3585;',0),(183735,5104,'hi','à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤ªà¤¤à¥à¤°à¤• à¤†à¤•à¤¾à¤°',0),(183736,5104,'ms','Saiz lembaran Master',0),(183737,5104,'ar','Ø­Ø¬Ù… Ø§Ù„ÙˆØ±Ù‚Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(183738,5104,'fr','Taille de feuille de Master',0),(183739,5104,'jp','ãƒžã‚¹ã‚¿ãƒ¼ã‚·ãƒ¼ãƒˆã‚µã‚¤ã‚º',0),(183740,5104,'pt','Tamanho da folha mestre',0),(183741,5104,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð»Ð¸ÑÑ‚Ð° Ð¼Ð°ÑÑ‚ÐµÑ€',0),(183742,5104,'es','Hoja Maestra TamaÃ±o',0),(183743,5104,'de','Master-BlattgrÃ¶ÃŸe',0),(183744,5104,'en','Master Sheet Size',0),(183745,5105,'is','',0),(183746,5105,'dr','ØªÙˆØ±ÙŠ',0),(183747,5105,'pr','ØªÙˆØ±ÙŠ',0),(183748,5105,'tr','Kafes',0),(183749,5105,'pl','Siatki',0),(183750,5105,'bg','ÐžÐºÐ¾Ñ‚Ð¾',0),(183751,5105,'ur','Ù…ÛŒØ´',0),(183752,5105,'sr','ÐÑ€Ð¼Ð°Ñ‚ÑƒÑ€Ð½Ð° Ð¼Ñ€ÐµÐ¶Ð°',0),(183753,5105,'vi','LÆ°á»›i',0),(183754,5105,'af','Maas',0),(183755,5105,'ro','Ochiurilor de plasÄƒ',0),(183756,5105,'et','VÃµrgusilma',0),(183757,5105,'si','OÄesa',0),(183758,5105,'ba','Mesh',0),(183759,5105,'nl','Mesh',0),(183760,5105,'fi','Mesh',0),(183761,5105,'no','Mesh',0),(183762,5105,'da','Mesh',0),(183763,5105,'ko','ë©”ì‰¬',0),(183764,5105,'he','×¨×©×ª',0),(183765,5105,'el','ÎœÎ±Ï„Î¹ÏŽÎ½',0),(183766,5105,'zh','ç½‘çŠ¶\r\n',0),(183767,5105,'sv','Mesh',0),(183768,5105,'it','Maglia',0),(183769,5105,'tl','',0),(183770,5105,'th','&#3585;&#3633;&#3610;&#3604;&#3633;&#3585;',0),(183771,5105,'hi','à¤®à¥‡à¤·',0),(183772,5105,'ms','MeSH',0),(183773,5105,'ar','Ù…Ø´',0),(183774,5105,'fr','Maille',0),(183775,5105,'jp','ãƒ¡ãƒƒã‚·ãƒ¥',0),(183776,5105,'pt','Malha',0),(183777,5105,'ru','Ð¡ÐµÑ‚ÐºÐ°',0),(183778,5105,'es','Engranar',0),(183779,5105,'de','Mesh',0),(183780,5105,'en','Mesh',0),(183781,5106,'is','',0),(183782,5106,'dr','(Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù…',0),(183783,5106,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù‚Ø³Ù…Øª Ù‡Ø§ Ø¯Ø± Ø³Ù‡Ø§Ù… (Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(183784,5106,'tr','# Stok parÃ§alarÄ±n',0),(183785,5106,'pl','# czÄ™Å›ci w magazynie',0),(183786,5106,'bg','# Ð½Ð° Ñ‡Ð°ÑÑ‚Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(183787,5106,'ur','# Ø§Ø³Ù¹Ø§Ú© Ù…ÛŒÚº Ø­ØµÙˆÚº Ú©ÛŒ',0),(183788,5106,'sr','# Ð´ÐµÐ»Ð¾Ð²Ð° Ð½Ð° Ð»Ð°Ð³ÐµÑ€Ñƒ',0),(183789,5106,'vi','sá»‘ phá»¥ tÃ¹ng trong hÃ ng',0),(183790,5106,'af','# Onderdele in Voorraad',0),(183791,5106,'ro','# de piese in stoc',0),(183792,5106,'et','# varuosade laos',0),(183793,5106,'si','# delov na zalogi',0),(183794,5106,'ba','# Bagian dalam saham',0),(183795,5106,'nl','# van onderdelen in voorraad',0),(183796,5106,'fi','# Osat varastosta',0),(183797,5106,'no','antall deler pÃ¥ lager',0),(183798,5106,'da','# af dele pÃ¥ lager',0),(183799,5106,'ko','ìž¬ê³  ë¶€í’ˆì˜ #',0),(183800,5106,'he','# ×©×œ ×—×œ×§×™ ×—×™×œ×•×£',0),(183801,5106,'el','# Ï„Ï‰Î½ Ï„Î¼Î®Î¼Î±Ï„Î± ÏƒÎµ Î±Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(183802,5106,'zh','åº“å­˜çš„é›¶ä»¶æ•°\r\n',0),(183803,5106,'sv','# av delar i lager',0),(183804,5106,'it','n. di pezzi a magazzino',0),(183805,5106,'tl','',0),(183806,5106,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3594;&#3636;&#3657;&#3609;&#3626;&#3656;&#3623;&#3609;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3626;&#3605;&#3655;&#3629;&#3585;',0),(183807,5106,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤®à¥‡à¤‚ à¤­à¤¾à¤—à¥‹à¤‚ à¤•à¥€ #',0),(183808,5106,'ms','# Bahagian-bahagian dalam stok',0),(183809,5106,'ar','# Ø£Ø¬Ø²Ø§Ø¡ ÙÙŠ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(183810,5106,'fr','Nbre de piÃ¨ces en Stock',0),(183811,5106,'jp','åœ¨åº«å†…ã?®éƒ¨å“?æ•°',0),(183812,5106,'pt','n Âº de peÃ§as em estoque',0),(183813,5106,'ru','ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´ÐµÑ‚Ð°Ð»ÐµÐ¹ Ð½Ð° ÑÐºÐ»Ð°Ð´Ðµ',0),(183814,5106,'es','# de Partes en Stock',0),(183815,5106,'de','Anzahl der Teile auf Lager',0),(183816,5106,'en','# of Parts in Stock',0),(183817,5107,'is','',0),(183818,5107,'dr','ØªØ¹Ø¯Ø§Ø¯  ØµÙØ­Ø§Øª Ù¾Ø±Ø³',0),(183819,5107,'pr','ØªØ¹Ø¯Ø§Ø¯  ØµÙØ­Ø§Øª Ù¾Ø±Ø³',0),(183820,5107,'tr','# BasÄ±n sayfa',0),(183821,5107,'pl','# Prasy arkuszy',0),(183822,5107,'bg','# Ð½Ð° Ð¿Ñ€ÐµÑÐ°Ñ‚Ð° Ð»Ð¸ÑÑ‚Ð¾Ð²Ðµ',0),(183823,5107,'ur','# Ù¾Ø±ÛŒØ³ Ú©ÛŒ Ú†Ø§Ø¯Ø±ÛŒÚº',0),(183824,5107,'sr','# ÐÐ¾Ð²Ð¸Ð½Ð°Ñ€Ðµ Ð»Ð¸ÑÑ‚Ð¾Ð²Ð°',0),(183825,5107,'vi','sá»‘ trang bÃ¡o',0),(183826,5107,'af','# van Press blaaie',0),(183827,5107,'ro','# de presÄƒ foi',0),(183828,5107,'et','# Vajuta lehed',0),(183829,5107,'si','# Tisk listov',0),(183830,5107,'ba','# lembar pers',0),(183831,5107,'nl','# van pers vellen',0),(183832,5107,'fi','# painoarkit',0),(183833,5107,'no','# Trykk ark',0),(183834,5107,'da','# Tryk plader',0),(183835,5107,'ko','# ê¸°ìž ì‹œíŠ¸',0),(183836,5107,'he','# ×©×œ ×”×¢×™×ª×•× ×•×ª ×’×™×œ×™×•× ×•×ª',0),(183837,5107,'el','# Î´ÎµÎ»Ï„Î¯Ï‰Î½ Ï„ÏÏ€Î¿Ï…',0),(183838,5107,'zh','ï¼ƒå°åˆ·è¡¨\r\n',0),(183839,5107,'sv','# Tryck pÃ¥ ark',0),(183840,5107,'it','# Stampa fogli',0),(183841,5107,'tl','',0),(183842,5107,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3610;&#3609;&#3649;&#3612;&#3656;&#3609;&#3585;&#3604;',0),(183843,5107,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤šà¤¾à¤¦à¤°à¥‹à¤‚ à¤•à¥€ #',0),(183844,5107,'ms','# dalam helaian akhbar',0),(183845,5107,'ar','# Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„ØµØ­Ù',0),(183846,5107,'fr','nombre de fiches de presse',0),(183847,5107,'jp','ãƒ—ãƒ¬ã‚¹ã‚·ãƒ¼ãƒˆæ•°',0),(183848,5107,'pt','n Âº de folhas de imprensa',0),(183849,5107,'ru','# ÐŸÐµÑ‡Ð°Ñ‚Ð¸ Ð»Ð¸ÑÑ‚Ð¾Ð²',0),(183850,5107,'es','# Hojas de ImpresiÃ³n',0),(183851,5107,'de','# der Presse BlÃ¤tter',0),(183852,5107,'en','# of Press Sheets',0),(183853,5108,'is','',0),(183854,5108,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§ ',0),(183855,5108,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§ ',0),(183856,5108,'tr','# Up',0),(183857,5108,'pl','#up',0),(183858,5108,'bg','# ÐÐ°Ð³Ð¾Ñ€Ðµ',0),(183859,5108,'ur','# Ø§Ù¾',0),(183860,5108,'sr','# Ð£Ð¿',0),(183861,5108,'vi','Sá»‘ lÃªn',0),(183862,5108,'af','# Up',0),(183863,5108,'ro','# Up',0),(183864,5108,'et','# Up',0),(183865,5108,'si','# Up',0),(183866,5108,'ba','# Up',0),(183867,5108,'nl','# Up',0),(183868,5108,'fi','# Up',0),(183869,5108,'no','# Up',0),(183870,5108,'da','# Up',0),(183871,5108,'ko','# ìµœëŒ€',0),(183872,5108,'he','? ×‘×ž×¢×œ×”',0),(183873,5108,'el','# Up',0),(183874,5108,'zh','ï¼ƒæˆªè‡³\r\n',0),(183875,5108,'sv','# Upp',0),(183876,5108,'it','# Up',0),(183877,5108,'tl','',0),(183878,5108,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(183879,5108,'hi','# à¤…à¤ª',0),(183880,5108,'ms','# Sehingga',0),(183881,5108,'ar','# ÙŠØµÙ„',0),(183882,5108,'fr','# Up',0),(183883,5108,'jp','å¢—å¤§',0),(183884,5108,'pt','# Up',0),(183885,5108,'ru','# Up',0),(183886,5108,'es','3 Mostrado',0),(183887,5108,'de','# Up',0),(183888,5108,'en','# Up',0),(183889,5109,'is','',0),(183890,5109,'dr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§',0),(183891,5109,'pr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§',0),(183892,5109,'tr','SipariÅŸ Die #',0),(183893,5109,'pl','Aby umrzeÄ‡ # siÄ™',0),(183894,5109,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° ÑƒÐ¼Ð¸Ñ€Ð°Ñ‚ # Ð½Ð°Ð³Ð¾Ñ€Ðµ',0),(183895,5109,'ur','ØªØ±ØªÛŒØ¨ Ù…Ø± # Ø§Ù¾',0),(183896,5109,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð”Ð¸Ðµ # Ð³Ð¾Ñ€Ðµ',0),(183897,5109,'vi','ÄÆ¡n hÃ ng Die # Up',0),(183898,5109,'af','Orde # sterf op',0),(183899,5109,'ro','Ordinul mor # pÃ¢nÄƒ',0),(183900,5109,'et','Tellimuse Die # Up',0),(183901,5109,'si','Reda Die # gor',0),(183902,5109,'ba','Urutan mati # Up',0),(183903,5109,'nl','Bestelling # sterven omhoog',0),(183904,5109,'fi','Jotta Die #',0),(183905,5109,'no','Bestill dÃ¸ # opp',0),(183906,5109,'da','Bestil dÃ¸r # op',0),(183907,5109,'ko','ìˆœì„œ #ì„ ì£½ì„',0),(183908,5109,'he','×¡×“×¨ ×œ×ž×•×ª #',0),(183909,5109,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€ÎµÎ¸Î±Î¯Î½Î¿Ï…Î½ # ÎµÏ€Î¬Î½Ï‰',0),(183910,5109,'zh','è®¢è´­æ¨¡å…·ï¼ƒæˆªè‡³\r\n',0),(183911,5109,'sv','Ordning dÃ¶ # upp',0),(183912,5109,'it','Ordine Die # fino',0),(183913,5109,'tl','',0),(183914,5109,'th','Order Die # Up',0),(183915,5109,'hi','à¤•à¥à¤°à¤® à¤®à¤°à¥‹ # à¤…à¤ª',0),(183916,5109,'ms','Perintah mati # sehingga',0),(183917,5109,'ar','ØªØ±ØªÙŠØ¨ ÙŠÙ…ÙˆØª # Ø­ØªÙ‰',0),(183918,5109,'fr','Ordre mourir # vers le haut',0),(183919,5109,'jp','Order Die # Up',0),(183920,5109,'pt','Ordem morrer #',0),(183921,5109,'ru','ÐŸÑ€Ð¸ÐºÐ°Ð· ÑƒÐ¼ÐµÑ€ÐµÑ‚ÑŒ # Ð²Ð²ÐµÑ€Ñ…',0),(183922,5109,'es','Pedido Estampa # para Seleccionar',0),(183923,5109,'de','Bestellung # bis zu sterben',0),(183924,5109,'en','Order Die # Up',0),(183925,5110,'is','',0),(183926,5110,'dr','Ø³ÙØ§Ø±Ø´ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(183927,5110,'pr','Ø³ÙØ§Ø±Ø´ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(183928,5110,'tr','AlÄ±nan sipariÅŸ',0),(183929,5110,'pl','KolejnoÅ›ci',0),(183930,5110,'bg','Ð ÐµÐ´Ð°, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸',0),(183931,5110,'ur','Ø¢Ø±ÚˆØ± Ù…Ù„Ø§',0),(183932,5110,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½',0),(183933,5110,'vi','Nháº­n Ä‘Æ¡n hÃ ng',0),(183934,5110,'af','Bestelling Ontvang',0),(183935,5110,'ro','Ordinul primit',0),(183936,5110,'et','Saadud',0),(183937,5110,'si','Vrstnem',0),(183938,5110,'ba','Urutan diterima',0),(183939,5110,'nl','Bestelling ontvangen',0),(183940,5110,'fi','SaapumisjÃ¤rjestyksessÃ¤',0),(183941,5110,'no','RekkefÃ¸lgen mottatt',0),(183942,5110,'da','Ordre modtaget',0),(183943,5110,'ko','ë°›ì€ ìˆœì„œ',0),(183944,5110,'he','×”×”×–×ž× ×” ×”×ª×§×‘×œ×”',0),(183945,5110,'el','Î£ÎµÎ¹ÏÎ¬',0),(183946,5110,'zh','è®¢å•å·²æ”¶åˆ°\r\n',0),(183947,5110,'sv','Ordning emot',0),(183948,5110,'it','Ordine ricevuto',0),(183949,5110,'tl','',0),(183950,5110,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(183951,5110,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(183952,5110,'ms','Pesanan diterima',0),(183953,5110,'ar','Ø£Ù…Ø± ÙˆØªÙ„Ù‚Ù‰',0),(183954,5110,'fr','Commande reÃ§ue',0),(183955,5110,'jp','å?—é ˜æ³¨æ–‡',0),(183956,5110,'pt','Ordem recebida',0),(183957,5110,'ru','Ð—Ð°ÐºÐ°Ð· Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»',0),(183958,5110,'es','Orden Recibido',0),(183959,5110,'de','Bestellung',0),(183960,5110,'en','Order Received',0),(183961,5111,'is','',0),(183962,5111,'dr','ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ ',0),(183963,5111,'pr','ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ ',0),(183964,5111,'tr','SipariÅŸ durumu',0),(183965,5111,'pl','Stan zamÃ³wienia',0),(183966,5111,'bg','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(183967,5111,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(183968,5111,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(183969,5111,'vi','TÃ¬nh tráº¡ng Ä‘Æ¡n hÃ ng',0),(183970,5111,'af','Bestelling Status',0),(183971,5111,'ro','Statusul comenzii',0),(183972,5111,'et','Tellimuse staatus',0),(183973,5111,'si','Stanje naloga',0),(183974,5111,'ba','Status pesanan',0),(183975,5111,'nl','Status van bestelling',0),(183976,5111,'fi','Tilauksen tila',0),(183977,5111,'no','Bestillingsstatus',0),(183978,5111,'da','Ordrestatus',0),(183979,5111,'ko','ì£¼ë¬¸ ìƒíƒœ',0),(183980,5111,'he','×ž×¦×‘ ×”×–×ž× ×”',0),(183981,5111,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(183982,5111,'zh','è®¢å•çŠ¶æ€\r\n',0),(183983,5111,'sv','Orderstatus',0),(183984,5111,'it','Stato dell\'ordine',0),(183985,5111,'tl','',0),(183986,5111,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(183987,5111,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(183988,5111,'ms','Status pesanan',0),(183989,5111,'ar','Ø­Ø§Ù„Ø© Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(183990,5111,'fr','Statut des commandes',0),(183991,5111,'jp','æ³¨æ–‡çŠ¶æ³?',0),(183992,5111,'pt','Status do pedido',0),(183993,5111,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð—Ð°ÐºÐ°Ð·Ð°',0),(183994,5111,'es','Staus de Orden',0),(183995,5111,'de','Bestellstatus',0),(183996,5111,'en','Order Status',0),(183997,5112,'is','',0),(183998,5112,'dr','(Ø¬Ù‡Øª Ú¯ÙŠØ±ÙŠ',0),(183999,5112,'pr','ØªØ¹ÙŠÙŠÙ† Ø¬Ù‡Øª (Ø¬Ù‡Øª Ú¯ÙŠØ±ÙŠ',0),(184000,5112,'tr','Oryantasyon',0),(184001,5112,'pl','Orientacja',0),(184002,5112,'bg','ÐžÑ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ',0),(184003,5112,'ur','Ø³Ù…Øª Ø¨Ù†Ø¯ÛŒ',0),(184004,5112,'sr','ÐŸÐ¾Ð»Ð¾Ð¶Ð°Ñ˜',0),(184005,5112,'vi','PhÆ°Æ¡ng Ä‘Ã´ng',0),(184006,5112,'af','OriÃ«ntasie',0),(184007,5112,'ro','Orientarea',0),(184008,5112,'et','Suund',0),(184009,5112,'si','Usmerjenost',0),(184010,5112,'ba','Orientasi',0),(184011,5112,'nl','Afdrukstand',0),(184012,5112,'fi','Suunta',0),(184013,5112,'no','Retning',0),(184014,5112,'da','Orientering',0),(184015,5112,'ko','ë°©í–¥',0),(184016,5112,'he','×”×ª×ž×¦××•×ª',0),(184017,5112,'el','Î ÏÎ¿ÏƒÎ±Î½Î±Ï„Î¿Î»Î¹ÏƒÎ¼ÏŒÏ‚',0),(184018,5112,'zh','å®šä½\r\n',0),(184019,5112,'sv','Orientering',0),(184020,5112,'it','Orientamento',0),(184021,5112,'tl','',0),(184022,5112,'th','&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;',0),(184023,5112,'hi','à¤…à¤­à¤¿à¤µà¤¿à¤¨à¥à¤¯à¤¾à¤¸',0),(184024,5112,'ms','Orientasi',0),(184025,5112,'ar','Ø§Ù„ØªÙˆØ¬Ù‡',0),(184026,5112,'fr','Orientation',0),(184027,5112,'jp','ã‚ªãƒªã‚¨ãƒ³ãƒ†ãƒ¼ã‚·ãƒ§ãƒ³',0),(184028,5112,'pt','OrientaÃ§Ã£o',0),(184029,5112,'ru','ÐžÑ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ',0),(184030,5112,'es','OrientaciÃ³n',0),(184031,5112,'de','Orientierung',0),(184032,5112,'en','Orientation',0),(184033,5113,'is','',0),(184034,5113,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù„ÙŠØ³Øª Ø¨Ø³ØªÙ‡ ',0),(184035,5113,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù„ÙŠØ³Øª Ø¨Ø³ØªÙ‡ ',0),(184036,5113,'tr','Paket listesi #',0),(184037,5113,'pl','Pakiet List #',0),(184038,5113,'bg','ÐžÐ¿Ð°ÐºÐ¾Ð²ÐºÐ° ÑÐ¿Ð¸ÑÑŠÐº #',0),(184039,5113,'ur','Ù¾ÛŒÚ© ÙÛØ±Ø³Øª #',0),(184040,5113,'sr','ÐŸÐ°ÐºÐµÑ‚ Ð»Ð¸ÑÑ‚Ðµ #',0),(184041,5113,'vi','Danh sÃ¡ch Ä‘Ã³ng hÃ ng sá»‘',0),(184042,5113,'af','Pak lys #',0),(184043,5113,'ro','Pachet listÄƒ #',0),(184044,5113,'et','Pack loend #',0),(184045,5113,'si','Paket seznam #',0),(184046,5113,'ba','Daftar paket #',0),(184047,5113,'nl','Pack lijst #',0),(184048,5113,'fi','Pack luettelon #',0),(184049,5113,'no','Pack listen #',0),(184050,5113,'da','Pack liste #',0),(184051,5113,'ko','íŒ© ëª©ë¡ #',0),(184052,5113,'he','×—×‘×™×œ×ª ×¨×©×™×ž×ª #',0),(184053,5113,'el','Î›Î¯ÏƒÏ„Î± Ï€Î±ÎºÎ­Ï„Î¿ #',0),(184054,5113,'zh','åŒ…åˆ—è¡¨ï¼ƒ\r\n',0),(184055,5113,'sv','Pack lista #',0),(184056,5113,'it','Pack List #',0),(184057,5113,'tl','',0),(184058,5113,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3649;&#3614;&#3655;&#3588;',0),(184059,5113,'hi','à¤ªà¥ˆà¤• à¤¸à¥‚à¤šà¥€ #',0),(184060,5113,'ms','Senarai pakej #',0),(184061,5113,'ar','Ø­Ø²Ù…Ø© Ù‚Ø§Ø¦Ù…Ø© #',0),(184062,5113,'fr','Pack liste #',0),(184063,5113,'jp','ãƒ‘ãƒƒã‚¯ãƒªã‚¹ãƒˆç•ªå?·',0),(184064,5113,'pt','Pack lista #',0),(184065,5113,'ru','ÐŸÐ°ÐºÐµÑ‚ ÑÐ¿Ð¸ÑÐ¾Ðº #',0),(184066,5113,'es','Lista de Empaque #',0),(184067,5113,'de','Pack-Liste #',0),(184068,5113,'en','Pack List#',0),(184069,5114,'is','',0),(184070,5114,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙƒØ§ØºØ°Ú†Ø§Ù¾',0),(184071,5114,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙƒØ§ØºØ°Ú†Ø§Ù¾',0),(184072,5114,'tr','BasÄ±n sayfasÄ± boyutu',0),(184073,5114,'pl','NaciÅ›nij przycisk Rozmiar arkusza',0),(184074,5114,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð»Ð¸ÑÑ‚ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(184075,5114,'ur','Ù¾Ø±ÛŒØ³ ÙˆØ±Ù‚ Ø³Ø§Ø¦Ø²',0),(184076,5114,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð»Ð¸ÑÑ‚Ð° Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ',0),(184077,5114,'vi','KÃ­ch cá»¡ trang bÃ¡o',0),(184078,5114,'af','Press vel grootte',0),(184079,5114,'ro','Dimensiune foaie de presÄƒ',0),(184080,5114,'et','Vajuta lehe suurus',0),(184081,5114,'si','Velikost lista pritisnite',0),(184082,5114,'ba','Ukuran lembar pers',0),(184083,5114,'nl','Druk op papierformaat',0),(184084,5114,'fi','Paina arkkikoko',0),(184085,5114,'no','Trykk arkstÃ¸rrelse',0),(184086,5114,'da','Tryk pÃ¥ arkstÃ¸rrelse',0),(184087,5114,'ko','í”„ë ˆìŠ¤ ìš©ì§€ í¬ê¸°',0),(184088,5114,'he','×’×•×“×œ ×’×™×œ×™×•×Ÿ ×”×¢×™×ª×•× ×•×ª',0),(184089,5114,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Ï†ÏÎ»Î»Î¿Ï… Ï„ÏÏ€Î¿Ï…',0),(184090,5114,'zh','å°åˆ·çº¸å¼ å°ºå¯¸\r\n',0),(184091,5114,'sv','Tryck pÃ¥ arkstorlek',0),(184092,5114,'it','Formato del foglio di stampa',0),(184093,5114,'tl','',0),(184094,5114,'th','&#3585;&#3604;&#3586;&#3609;&#3634;&#3604;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(184095,5114,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤ªà¤¤à¥à¤°à¤• à¤†à¤•à¤¾à¤°',0),(184096,5114,'ms','Saiz lembaran akhbar',0),(184097,5114,'ar','Ø­Ø¬Ù… Ø§Ù„ÙˆØ±Ù‚Ø© Ø§Ù„ØµØ­Ø§ÙØ©',0),(184098,5114,'fr','Taille de feuille de presse',0),(184099,5114,'jp','ãƒ—ãƒ¬ã‚¹ã‚·ãƒ¼ãƒˆã‚µã‚¤ã‚º',0),(184100,5114,'pt','Tamanho de folha da imprensa',0),(184101,5114,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð»Ð¸ÑÑ‚Ð° Ð¿Ñ€ÐµÑÑ',0),(184102,5114,'es','Prensa TamaÃ±o de Hoja',0),(184103,5114,'de','Presse-BlattgrÃ¶ÃŸe',0),(184104,5114,'en','Press Sheet Size',0),(184105,5115,'is','',0),(184106,5115,'dr','Ù†ÙˆØ¹ Ú†Ø§Ù¾',0),(184107,5115,'pr','Ù†ÙˆØ¹ Ú†Ø§Ù¾',0),(184108,5115,'tr','YazdÄ±rma tÃ¼rÃ¼',0),(184109,5115,'pl','Typ druku',0),(184110,5115,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ñ‚Ð¸Ð¿',0),(184111,5115,'ur','Ø·Ø¨Ø§Ø¹Øª Ú©ÛŒ Ù‚Ø³Ù…',0),(184112,5115,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñ‚Ð¸Ð¿',0),(184113,5115,'vi','Loáº¡i in',0),(184114,5115,'af','Druk tipe',0),(184115,5115,'ro','Tipul de imprimare',0),(184116,5115,'et','TrÃ¼ki tÃ¼Ã¼p',0),(184117,5115,'si','Tisk vrsto',0),(184118,5115,'ba','Jenis percetakan',0),(184119,5115,'nl','Afdrukken Type',0),(184120,5115,'fi','Tulostuksen tyyppi',0),(184121,5115,'no','Utskrift Type',0),(184122,5115,'da','Udskrivning Type',0),(184123,5115,'ko','ì¸ì‡„ í˜•ì‹',0),(184124,5115,'he','×¡×•×’ ×”×“×¤×¡×”',0),(184125,5115,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„ÏÏ€Î¿Ï…',0),(184126,5115,'zh','æ‰“å°ç±»åž‹\r\n',0),(184127,5115,'sv','Utskrift typ',0),(184128,5115,'it','Tipo di stampa',0),(184129,5115,'tl','',0),(184130,5115,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(184131,5115,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(184132,5115,'ms','Jenis percetakan',0),(184133,5115,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(184134,5115,'fr','Type d\'impression',0),(184135,5115,'jp','å?°åˆ·ã‚¿ã‚¤ãƒ—',0),(184136,5115,'pt','Tipo de impressÃ£o',0),(184137,5115,'ru','Ð¢Ð¸Ð¿ ÐŸÐµÑ‡Ð°Ñ‚Ð¸',0),(184138,5115,'es','Tipo de Imprenta',0),(184139,5115,'de','Druck-Typ',0),(184140,5115,'en','Printing Type',0),(184141,5116,'is','',0),(184142,5116,'dr','ØªÙ‡ÙŠÙ‡ Ø¬Ø¯ÙˆÙ„ Ø²Ù…Ø§Ù†ÙŠ ØªÙˆÙ„ÙŠØ¯',0),(184143,5116,'pr','ØªÙ‡ÙŠÙ‡ Ø¬Ø¯ÙˆÙ„ Ø²Ù…Ø§Ù†ÙŠ ØªÙˆÙ„ÙŠØ¯',0),(184144,5116,'tr','Ãœretim planlama',0),(184145,5116,'pl','Planowanie produkcji',0),(184146,5116,'bg','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(184147,5116,'ur','Ù¾ÛŒØ¯Ø§ÙˆØ§Ø± Ø¬Ø¯ÙˆÙ„ Ù…Ù‚Ø±Ø± Ú©Ø±Ù†Û’ ÙˆØ§Ù„Ø§',0),(184148,5116,'sr','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑšÐµ',0),(184149,5116,'vi','Káº¿ hoáº¡ch sáº£n xuáº¥t',0),(184150,5116,'af','Produksie besig',0),(184151,5116,'ro','ProducÅ£ie planificare',0),(184152,5116,'et','Tootmise planeerimine',0),(184153,5116,'si','Razporejanje proizvodnje',0),(184154,5116,'ba','Penjadwalan produksi',0),(184155,5116,'nl','Productie planning',0),(184156,5116,'fi','Tuotannon ajoituksessa',0),(184157,5116,'no','Produksjonsplanlegging',0),(184158,5116,'da','ProduktionsplanlÃ¦gning',0),(184159,5116,'ko','ìƒì‚° ì¼ì •',0),(184160,5116,'he','×ª×–×ž×•×Ÿ ×”×™×™×¦×•×¨',0),(184161,5116,'el','ÎŸ Ï€ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÎ¼ÏŒÏ‚ Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Ï‰Î³Î®Ï‚',0),(184162,5116,'zh','ç”Ÿäº§è°ƒåº¦\r\n',0),(184163,5116,'sv','Produktionsplanering',0),(184164,5116,'it','Programmazione di produzione',0),(184165,5116,'tl','',0),(184166,5116,'th','&#3627;&#3617;&#3634;&#3618;&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;',0),(184167,5116,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¨ à¤…à¤¨à¥à¤¸à¥‚à¤šà¤¨',0),(184168,5116,'ms','Penjadualan pengeluaran',0),(184169,5116,'ar','Ø¬Ø¯ÙˆÙ„Ø© Ø§Ù„Ø¥Ù†ØªØ§Ø¬',0),(184170,5116,'fr','Planification de la production',0),(184171,5116,'jp','è£½é€ æ—¥ç¨‹è¨ˆç”»',0),(184172,5116,'pt','ProgramaÃ§Ã£o da produÃ§Ã£o',0),(184173,5116,'ru','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð°',0),(184174,5116,'es','ProgramaciÃ³n de ProducciÃ³n',0),(184175,5116,'de','Arbeitsvorbereitung',0),(184176,5116,'en','Production Scheduling',0),(184177,5117,'is','',0),(184178,5117,'dr','Ù…Ø±Ø§Ø­Ù„ ØªÙˆÙ„ÙŠØ¯ Ø¯Ø± Ø³ÙØ§Ø±Ø´ ',0),(184179,5117,'pr','Ù…Ø±Ø§Ø­Ù„ ØªÙˆÙ„ÙŠØ¯ Ø¯Ø± Ø³ÙØ§Ø±Ø´ ',0),(184180,5117,'tr','Ãœretim adÄ±mlarÄ± sÄ±rayla',0),(184181,5117,'pl','EtapÃ³w produkcji w celu',0),(184182,5117,'bg','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²ÐµÐ½Ð¸ ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ð² Ñ€ÐµÐ´',0),(184183,5117,'ur','Ù¾ÛŒØ¯Ø§ÙˆØ§Ø± Ú©Û’ Ù…Ø±Ø§Ø­Ù„ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ù…ÛŒÚº',0),(184184,5117,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑšÐ° ÐºÐ¾Ñ€Ð°ÐºÐµ Ð¿Ð¾ Ñ€ÐµÐ´Ñƒ',0),(184185,5117,'vi','CÃ¡c bÆ°á»›c sáº£n xuáº¥t trong Ä‘Æ¡n hÃ ng',0),(184186,5117,'af','Produksiestappe in Bestelling',0),(184187,5117,'ro','ProducÅ£ie paÅŸii Ã®n ordinea',0),(184188,5117,'et','Tootmisprotsesse kasutades selleks',0),(184189,5117,'si','Proizvodnja koraki, da bi',0),(184190,5117,'ba','Langkah-langkah produksi dalam rangka',0),(184191,5117,'nl','Productiestappen in volgorde',0),(184192,5117,'fi','Tuotantovaiheet, jotta',0),(184193,5117,'no','Produksjonen steg for',0),(184194,5117,'da','Produktionen trin i rÃ¦kkefÃ¸lge',0),(184195,5117,'ko','ìƒì‚° ë‹¨ê³„ë¥¼ ìˆœì„œ ëŒ€ë¡œ',0),(184196,5117,'he','×©×œ×‘×™ ×™×™×¦×•×¨ ×¡×“×¨',0),(184197,5117,'el','Î Î±ÏÎ±Î³Ï‰Î³Î® Î²Î®Î¼Î±Ï„Î±, Ï€ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï…',0),(184198,5117,'zh','ç”Ÿäº§æ­¥éª¤é¡ºåº\r\n',0),(184199,5117,'sv','Produktionen steg fÃ¶r',0),(184200,5117,'it','Fasi di produzione in ordine',0),(184201,5117,'tl','',0),(184202,5117,'th','&#3586;&#3633;&#3657;&#3609;&#3605;&#3629;&#3609;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3651;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(184203,5117,'hi','à¤•à¥à¤°à¤® à¤®à¥‡à¤‚ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¨ à¤šà¤°à¤£à¥‹à¤‚',0),(184204,5117,'ms','Langkah-langkah pengeluaran dalam perintah',0),(184205,5117,'ar','Ø®Ø·ÙˆØ§Øª Ø§Ù„Ø¥Ù†ØªØ§Ø¬ ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(184206,5117,'fr','Ã‰tapes de la production dans l\'ordre',0),(184207,5117,'jp','æ³¨æ–‡ã?®è£½é€ æ‰‹é †',0),(184208,5117,'pt','Etapas de produÃ§Ã£o na ordem',0),(184209,5117,'ru','Ð¨Ð°Ð³Ð¸ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð° Ð² Ð¿Ð¾Ñ€ÑÐ´ÐºÐµ',0),(184210,5117,'es','Pasos de ProducciÃ³n en Regla',0),(184211,5117,'de','Arbeitsschritte in der Reihenfolge',0),(184212,5117,'en','Production Steps in Order',0),(184213,5118,'is','',0),(184214,5118,'dr','Ø³Ù†Ø¯ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(184215,5118,'pr','Ø³Ù†Ø¯ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(184216,5118,'tr','MÃ¼ÅŸteri kanÄ±tÄ±',0),(184217,5118,'pl','DowÃ³d do klienta',0),(184218,5118,'bg','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(184219,5118,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù„ÛŒÛ’ Ø«Ø¨ÙˆØª',0),(184220,5118,'sr','Ð”Ð¾ÐºÐ°Ð· Ð´Ð° ÐºÑƒÐ¿Ð°Ñ†',0),(184221,5118,'vi','Báº£n in thá»­ tá»›i khÃ¡ch hÃ ng ',0),(184222,5118,'af','Proef aan Klante/KliÃ«nte',0),(184223,5118,'ro','Dovada client',0),(184224,5118,'et','TÃµend kliendile',0),(184225,5118,'si','Dokaz za kupca',0),(184226,5118,'ba','Bukti untuk pelanggan',0),(184227,5118,'nl','Bewijs aan klant',0),(184228,5118,'fi','Todiste asiakkaalle',0),(184229,5118,'no','Bevis til kunde',0),(184230,5118,'da','Bevis for, at kunden',0),(184231,5118,'ko','ê³ ê°ì— ê²Œ ì¦ëª…',0),(184232,5118,'he','×”×•×›×—×” ×œ×œ×§×•×—',0),(184233,5118,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Ï€ÎµÎ»Î¬Ï„Î·',0),(184234,5118,'zh','å‘å®¢æˆ·è¯æ˜Ž\r\n',0),(184235,5118,'sv','Bevis till kund',0),(184236,5118,'it','Prova al cliente',0),(184237,5118,'tl','',0),(184238,5118,'th','&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(184239,5118,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¬à¥‚à¤¤',0),(184240,5118,'ms','Bukti kepada pelanggan',0),(184241,5118,'ar','Ø¯Ù„ÙŠÙ„ Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(184242,5118,'fr','Preuve au client',0),(184243,5118,'jp','Proof to Customer',0),(184244,5118,'pt','Prova ao cliente',0),(184245,5118,'ru','Ð”Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð´Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(184246,5118,'es','Prueba de ImpresiÃ³n al Cliente',0),(184247,5118,'de','Nachweis gegenÃ¼ber Kunden',0),(184248,5118,'en','Proof to Customer',0),(184249,5119,'is','',0),(184250,5119,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(184251,5119,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(184252,5119,'tr','SipariÅŸ edilen miktar',0),(184253,5119,'pl','IloÅ›Ä‡ zamÃ³wionych',0),(184254,5119,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸',0),(184255,5119,'ur','Ù‚ÛŒ Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(184256,5119,'sr','ÐšÐ¾Ð» Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾',0),(184257,5119,'vi','Sá»‘ lÆ°á»£ng Ä‘áº·t hÃ ng',0),(184258,5119,'af','Hoev. Bestel',0),(184259,5119,'ro','Cantit ordonat',0),(184260,5119,'et','Tellitud kogus',0),(184261,5119,'si','KoliÄina naroÄila',0),(184262,5119,'ba','Qty memerintahkan',0),(184263,5119,'nl','Aantal besteld',0),(184264,5119,'fi','Tilattu mÃ¤Ã¤rÃ¤',0),(184265,5119,'no','Antall bestilt',0),(184266,5119,'da','Antal bestilte',0),(184267,5119,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(184268,5119,'he','×›×ž×•×ª ×©×œ ×”×•×¨×”',0),(184269,5119,'el','Qty Î´Î¹Î­Ï„Î±Î¾Îµ',0),(184270,5119,'zh','æ•°é‡æŽ’åº\r\n',0),(184271,5119,'sv','Antal bestÃ¤llda',0),(184272,5119,'it','Q. tÃ  ordinata',0),(184273,5119,'tl','',0),(184274,5119,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(184275,5119,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶',0),(184276,5119,'ms','Qty yang diperintahkan',0),(184277,5119,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ Ø£Ù…Ø±Øª',0),(184278,5119,'fr','QtÃ© commandÃ©e',0),(184279,5119,'jp','æ³¨æ–‡æ¸ˆæ•°é‡?',0),(184280,5119,'pt','Qty ordenada',0),(184281,5119,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð½Ð¾Ðµ ÐšÐ¾Ð»-Ð²Ð¾',0),(184282,5119,'es','Cant. Ordenada',0),(184283,5119,'de','Qty bestellt',0),(184284,5119,'en','Qty Ordered',0),(184285,5120,'is','',0),(184286,5120,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(184287,5120,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(184288,5120,'tr','Sevk edilen miktar',0),(184289,5120,'pl','IloÅ›Ä‡ wysÅ‚anych',0),(184290,5120,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(184291,5120,'ur','Ù‚ÛŒ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(184292,5120,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð° ÐºÐ¾Ð».',0),(184293,5120,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ chuyá»ƒn',0),(184294,5120,'af','Hoev. Versend',0),(184295,5120,'ro','Cantitate livratÄƒ',0),(184296,5120,'et','LÃ¤hetatud kogus',0),(184297,5120,'si','Dobavljena koliÄina',0),(184298,5120,'ba','Qty dikirim',0),(184299,5120,'nl','Aantal verzonden',0),(184300,5120,'fi','MÃ¤Ã¤rÃ¤ toimitettu',0),(184301,5120,'no','Antall levert',0),(184302,5120,'da','Antal afsendt',0),(184303,5120,'ko','ì¶œí•˜ ìˆ˜ëŸ‰',0),(184304,5120,'he','×›×ž×•×ª ×©× ×©×œ×—×•',0),(184305,5120,'el','Qty Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(184306,5120,'zh','å‘è´§æ•°é‡\r\n',0),(184307,5120,'sv','Antal levererade',0),(184308,5120,'it','Qty spedito',0),(184309,5120,'tl','',0),(184310,5120,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(184311,5120,'hi','à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(184312,5120,'ms','Qty yang dihantar',0),(184313,5120,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(184314,5120,'fr','QuantitÃ© expÃ©diÃ©e',0),(184315,5120,'jp','ç™ºé€?æ¸ˆæ•°é‡?',0),(184316,5120,'pt','Qty enviado',0),(184317,5120,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(184318,5120,'es','Cant. Enviada',0),(184319,5120,'de','Qty ausgeliefert',0),(184320,5120,'en','Qty Shipped',0),(184321,5121,'is','',0),(184322,5121,'dr','Ø­Ù…Ù„ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ',0),(184323,5121,'pr','Ø­Ù…Ù„ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ',0),(184324,5121,'tr','TarafÄ±ndan sevk',0),(184325,5121,'pl','Statek przez',0),(184326,5121,'bg','ÐšÐ¾Ñ€Ð°Ð±Ð° Ð¾Ñ‚',0),(184327,5121,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²',0),(184328,5121,'sr','ÐžÑ‚Ð¿Ð»Ð¾Ð²Ð¸Ð¼Ð¾ Ñƒ',0),(184329,5121,'vi','Chuyá»ƒn bá»Ÿi',0),(184330,5121,'af','Versend Per',0),(184331,5121,'ro','NavÄƒ de',0),(184332,5121,'et','Laeva poolt',0),(184333,5121,'si','Ladja z',0),(184334,5121,'ba','Kapal oleh',0),(184335,5121,'nl','Schip door',0),(184336,5121,'fi','Aluksen',0),(184337,5121,'no','Leveres av',0),(184338,5121,'da','Skibet ved',0),(184339,5121,'ko','ì— ì˜í•´ ì œê³µ',0),(184340,5121,'he','×¢×œ ×™×“×™ ×¡×¤×™× ×ª',0),(184341,5121,'el','Î Î»Î¿Î¯Î¿ Î±Ï€ÏŒ',0),(184342,5121,'zh','å‡ºè´§æ–¹å¼\r\n',0),(184343,5121,'sv','Fartyg av',0),(184344,5121,'it','Nave di',0),(184345,5121,'tl','',0),(184346,5121,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3650;&#3604;&#3618;',0),(184347,5121,'hi','à¤œà¤¹à¤¾à¤œ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(184348,5121,'ms','Kapal oleh',0),(184349,5121,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„ØªÙŠ',0),(184350,5121,'fr','ExpÃ©dier par',0),(184351,5121,'jp','ç™ºé€?è€…',0),(184352,5121,'pt','Enviar por',0),(184353,5121,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(184354,5121,'es','Enviar Por',0),(184355,5121,'de','Versenden per',0),(184356,5121,'en','Ship By',0),(184357,5122,'is','',0),(184358,5122,'dr','Ù…Ø±Ø­Ù„Ù‡ ',0),(184359,5122,'pr','Ù…Ø±Ø­Ù„Ù‡ ',0),(184360,5122,'tr','AdÄ±m',0),(184361,5122,'pl','Krok',0),(184362,5122,'bg','Ð¡Ñ‚ÑŠÐ¿ÐºÐ°',0),(184363,5122,'ur','Ù…Ø±Ø­Ù„Û',0),(184364,5122,'sr','ÐšÐ¾Ñ€Ð°Ðº',0),(184365,5122,'vi','BÆ°á»›c',0),(184366,5122,'af','Stap',0),(184367,5122,'ro','Pas',0),(184368,5122,'et','Samm',0),(184369,5122,'si','Korak',0),(184370,5122,'ba','Langkah',0),(184371,5122,'nl','Stap',0),(184372,5122,'fi','Askel',0),(184373,5122,'no','Trinn',0),(184374,5122,'da','Trin',0),(184375,5122,'ko','ë‹¨ê³„',0),(184376,5122,'he','×©×œ×‘',0),(184377,5122,'el','Î’Î®Î¼Î±',0),(184378,5122,'zh','æ­¥éª¤\r\n',0),(184379,5122,'sv','Steg',0),(184380,5122,'it','Passo',0),(184381,5122,'tl','',0),(184382,5122,'th','&#3586;&#3633;&#3657;&#3609;&#3605;&#3629;&#3609;',0),(184383,5122,'hi','à¤•à¤¦à¤®',0),(184384,5122,'ms','Langkah',0),(184385,5122,'ar','Ø§Ù„Ø®Ø·ÙˆØ©',0),(184386,5122,'fr','Ã‰tape',0),(184387,5122,'jp','æ‰‹é †',0),(184388,5122,'pt','Passo',0),(184389,5122,'ru','Ð¨Ð°Ð³',0),(184390,5122,'es','Paso',0),(184391,5122,'de','Schritt',0),(184392,5122,'en','Step',0),(184393,5123,'is','',0),(184394,5123,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø§ÙŠÙ†Ø¬Ø§',0),(184395,5123,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø§ÙŠÙ†Ø¬Ø§',0),(184396,5123,'tr','Burada stok',0),(184397,5123,'pl','Czas tutaj',0),(184398,5123,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ Ñ‚ÑƒÐº',0),(184399,5123,'ur','ÛŒÛØ§Úº Ø§Ø³Ù¹Ø§Ú©',0),(184400,5123,'sr','ÐÐºÑ†Ð¸Ñ˜Ðµ Ð¾Ð²Ð´Ðµ',0),(184401,5123,'vi','HÃ ng tá»“n á»Ÿ Ä‘Ã¢y',0),(184402,5123,'af','Voorraad hier',0),(184403,5123,'ro','Stoc aici',0),(184404,5123,'et','Stock siin',0),(184405,5123,'si','Zalog tukaj',0),(184406,5123,'ba','Saham di sini',0),(184407,5123,'nl','Voorraad hier',0),(184408,5123,'fi','Kannan tÃ¤Ã¤llÃ¤',0),(184409,5123,'no','Lager her',0),(184410,5123,'da','Stock her',0),(184411,5123,'ko','ì—¬ê¸° ì£¼ì‹',0),(184412,5123,'he','×ž× ×™×•×ª ×›××Ÿ',0),(184413,5123,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± ÎµÎ´ÏŽ',0),(184414,5123,'zh','å‚¨å­˜åœ¨è¿™é‡Œ\r\n',0),(184415,5123,'sv','Lager hÃ¤r',0),(184416,5123,'it','Stock qui',0),(184417,5123,'tl','',0),(184418,5123,'th','&#3626;&#3605;&#3658;&#3629;&#3588;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;\n',0),(184419,5123,'hi','à¤¯à¤¹à¤¾à¤ à¤¶à¥‡à¤¯à¤°',0),(184420,5123,'ms','Stok di sini',0),(184421,5123,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… Ù‡Ù†Ø§',0),(184422,5123,'fr','Stock ici',0),(184423,5123,'jp','ã?“ã?“ã?«è£œå……ã?™ã‚‹',0),(184424,5123,'pt','Estoque aqui',0),(184425,5123,'ru','Ð—Ð°Ð¿Ð°ÑÐ¾Ð² Ð·Ð´ÐµÑÑŒ',0),(184426,5123,'es','Stock Aqui',0),(184427,5123,'de','Lager hier',0),(184428,5123,'en','Stock Here',0),(184429,5124,'is','',0),(184430,5124,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(184431,5124,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(184432,5124,'tr','Stok sipariÅŸ',0),(184433,5124,'pl','Czas zamÃ³wiÄ‡',0),(184434,5124,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð½Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(184435,5124,'ur','Ø§Ø³Ù¹Ø§Ú© Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(184436,5124,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾',0),(184437,5124,'vi','Äáº·t nguyÃªn liá»‡u',0),(184438,5124,'af','Voorraad Bestel',0),(184439,5124,'ro','Stoc ordonat',0),(184440,5124,'et','Tellitud varud',0),(184441,5124,'si','Stock naroÄila',0),(184442,5124,'ba','Saham memerintahkan',0),(184443,5124,'nl','Voorraad besteld',0),(184444,5124,'fi','Kaluston tilattu',0),(184445,5124,'no','Lager bestilt',0),(184446,5124,'da','Stock bestilt',0),(184447,5124,'ko','ì£¼ì‹ ì£¼ë¬¸',0),(184448,5124,'he','×ž× ×™×•×ª ×”×•×¨×”',0),(184449,5124,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Î´Î¹Î­Ï„Î±Î¾Îµ',0),(184450,5124,'zh','åº“å­˜æŽ’åº\r\n',0),(184451,5124,'sv','Lager bestÃ¤llde',0),(184452,5124,'it','Magazzino ordinato',0),(184453,5124,'tl','',0),(184454,5124,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(184455,5124,'hi','à¤¶à¥‡à¤¯à¤° à¤•à¤¾ à¤†à¤¦à¥‡à¤¶',0),(184456,5124,'ms','Stok yang dipesan',0),(184457,5124,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… Ø£Ù…Ø±',0),(184458,5124,'fr','Stock commandÃ©',0),(184459,5124,'jp','æ³¨æ–‡æ¸ˆåœ¨åº«å“?',0),(184460,5124,'pt','Estoque ordenada',0),(184461,5124,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ð°Ñ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»',0),(184462,5124,'es','Stock Ordenado',0),(184463,5124,'de','Lager bestellt',0),(184464,5124,'en','Stock Ordered',0),(184465,5125,'is','',0),(184466,5125,'dr','(Ø´Ú©Ù„ ÙØ±Ø¹Ù‰',0),(184467,5125,'pr','Ø²ÙŠØ± Ù„Ø§ÙŠÙ‡(Ø´Ú©Ù„ ÙØ±Ø¹Ù‰',0),(184468,5125,'tr','Alt katman',0),(184469,5125,'pl','PodÅ‚oÅ¼a',0),(184470,5125,'bg','Ð¡ÑƒÐ±ÑÑ‚Ñ€Ð°Ñ‚',0),(184471,5125,'ur','Ø³Ø¨Ø³Ù¹Ø±Ø§Ù¹ÛŒ',0),(184472,5125,'sr','Ð¡ÑƒÐ¿ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ð¼',0),(184473,5125,'vi','GiÃ¡ phá»¥',0),(184474,5125,'af','Onderlaag',0),(184475,5125,'ro','Substrat',0),(184476,5125,'et','Alusmaterjal',0),(184477,5125,'si','Substrata',0),(184478,5125,'ba','Substrat',0),(184479,5125,'nl','Substraat',0),(184480,5125,'fi','Painatusmateriaali',0),(184481,5125,'no','Substrat',0),(184482,5125,'da','Substrat',0),(184483,5125,'ko','ê¸°íŒ',0),(184484,5125,'he','×”×ž×¦×¢',0),(184485,5125,'el','Î¥Ï€ÏŒÏƒÏ„ÏÏ‰Î¼Î±',0),(184486,5125,'zh','åŸºå±‚\r\n',0),(184487,5125,'sv','Substrat',0),(184488,5125,'it','Substrato',0),(184489,5125,'tl','',0),(184490,5125,'th','&#3585;&#3621;&#3618;&#3640;&#3607;&#3608;&#3660;&#3618;&#3656;&#3629;&#3618;',0),(184491,5125,'hi','à¤¸à¤¬à¥à¤¸à¤Ÿà¥à¤°à¥‡à¤Ÿ',0),(184492,5125,'ms','Substrat',0),(184493,5125,'ar','Ø§Ù„Ø±ÙƒÙŠØ²Ø©',0),(184494,5125,'fr','Substrat',0),(184495,5125,'jp','åŸºè³ª',0),(184496,5125,'pt','Substrato',0),(184497,5125,'ru','Ð¡ÑƒÐ±ÑÑ‚Ñ€Ð°Ñ‚',0),(184498,5125,'es','Substrato',0),(184499,5125,'de','Substrat',0),(184500,5125,'en','Substrate',0),(184501,5126,'is','',0),(184502,5126,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯  ÙŠØ§ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ ',0),(184503,5126,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯  ÙŠØ§ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ ',0),(184504,5126,'tr','Yeni PO ekleyin veya varolan bir PO GÃ¼ncelleÅŸtir',0),(184505,5126,'pl','DodaÄ‡ PO nowÄ… lub zaktualizowaÄ‡ istniejÄ…ce PO',0),(184506,5126,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ PO Ð¸Ð»Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð° PO',0),(184507,5126,'ur','Ù†Ø¦ÛŒ Ù¾ÙˆØ³Ù¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº ÛŒØ§ Ø§ÛŒÚ© Ù…ÙˆØ¬ÙˆØ¯Û Ù¾Ùˆ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(184508,5126,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ ÐŸÐž Ð¸Ð»Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð·Ð° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ ÐŸÐž',0),(184509,5126,'vi','ThÃªm ÄÆ¡n Mua HÃ ng Má»›i Hoáº·c Cáº­p Nháº­t ÄÆ¡n Mua HÃ ng Hiá»‡n Táº¡i',0),(184510,5126,'af','Nuwe AB of Opdateer \'n Bestaande AB Byvoeg',0),(184511,5126,'ro','Adauga comanda furnizor noua sau actualizeaza comanda furnizor existenta',0),(184512,5126,'et','Lisa uus ostutellimus vÃµi uuenda olemasolevat',0),(184513,5126,'si','Dodaj nov PO ali posodobitev obstojeÄe PO',0),(184514,5126,'ba','Buat/Koreksi Pesanan Pembelian',0),(184515,5126,'nl','Nieuwe PO toevoegen of bijwerken van een bestaande PO',0),(184516,5126,'fi','LisÃ¤Ã¤ uuden PO tai PÃ¤ivitÃ¤ olemassa PO',0),(184517,5126,'no','Legge til nye PO eller oppdatere en eksisterende PO',0),(184518,5126,'da','TilfÃ¸je nye PO eller opdatere en eksisterende PO',0),(184519,5126,'ko','ìƒˆ ì‚¬ì„œí•¨ì„ ì¶”ê°€ í•˜ê±°ë‚˜ ê¸°ì¡´ í¬ ì—…ë°ì´íŠ¸',0),(184520,5126,'he','×œ×”×•×¡×™×£ ×¤×• ×—×“×© ××• ×¢×“×›×•×Ÿ ×©×œ ×¤×• ×”×§×™×™×',0),(184521,5126,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î½Î­Î± PO Î® Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Î¼Î¹Î± Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎ± PO',0),(184522,5126,'zh','å¢žåŠ æ–°çš„é‡‡è´­è®¢å•\r\næˆ–æ›´æ–°çŽ°æœ‰çš„é‡‡è´­è®¢å•\r\n',0),(184523,5126,'sv','LÃ¤gga till nya PO eller uppdatera en befintlig PO',0),(184524,5126,'it','Aggiungi nuovo PO o aggiornare un PO esistente',0),(184525,5126,'tl','',0),(184526,5126,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(184527,5126,'hi','à¤¨à¤ˆ à¤ªà¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤¯à¤¾ à¤à¤• à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤ªà¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(184528,5126,'ms','Tambah PO baru atau mengemaskini PO yang sedia ada',0),(184529,5126,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ Ø£Ùˆ ØªØ­Ø¯ÙŠØ« Ø¨Ùˆ Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(184530,5126,'fr','Ajouter nouveau PO ou mettre Ã  jour une commande d\'achat existant',0),(184531,5126,'jp','æ–°è¦?æ³¨æ–‡æ›¸ã?®è¿½åŠ ã?‹æ›´æ–°ã?¨æ—¢å­˜ã?®æ³¨æ–‡æ›¸',0),(184532,5126,'pt','Adicionar novo PO ou atualizar um existente PO',0),(184533,5126,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ PO Ð¸Ð»Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ PO',0),(184534,5126,'es','Agregar Nueva OC o actualizar una OC Existente',0),(184535,5126,'de','FÃ¼gen Sie neue PO hinzu oder aktualisieren Sie eines vorhandenen PO',0),(184536,5126,'en','Add New PO or Update an Existing PO',0),(184537,5127,'is','',0),(184538,5127,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§',0),(184539,5127,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§',0),(184540,5127,'tr','FaturalarÄ± ekleyin/gÃ¼ncelleyin',0),(184541,5127,'pl','Rachunki Dodaj/Aktualizuj',0),(184542,5127,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(184543,5127,'ur','Ø¨Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(184544,5127,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(184545,5127,'vi','ThÃªm/Cáº­p Nháº­t HÃ³a ÄÆ¡n ',0),(184546,5127,'af','Rekeninge Byvoeg/Opdateer',0),(184547,5127,'ro','Facturi Adauga/Actualizeaza',0),(184548,5127,'et','Arved lisamine/uuendamine',0),(184549,5127,'si','RaÄuni Dodaj/posodobi',0),(184550,5127,'ba','Tambah/Ganti Tagihan',0),(184551,5127,'nl','Facturen toevoegen/bijwerken',0),(184552,5127,'fi','Laskut lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(184553,5127,'no','Regninger/Oppdater',0),(184554,5127,'da','Regninger TilfÃ¸j/opdater',0),(184555,5127,'ko','ì²­êµ¬ì„œ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(184556,5127,'he','×—×©×‘×•× ×•×ª ×”×•×¡×¤×”/×¢×“×›×•×Ÿ',0),(184557,5127,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(184558,5127,'zh','è³¬å–®å¢žåŠ /æ›´æ–°\r\n',0),(184559,5127,'sv','RÃ¤kningar LÃ¤gg till/uppdatera',0),(184560,5127,'it','Aggiungere o aggiornare le bollette',0),(184561,5127,'tl','',0),(184562,5127,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(184563,5127,'hi','à¤¬à¤¿à¤²à¥‹à¤‚ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(184564,5127,'ms','Bil Tambah/Kemaskini',0),(184565,5127,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(184566,5127,'fr','Factures ajouter/mettre Ã  jour',0),(184567,5127,'jp','è«‹æ±‚æ›¸ã€€è¿½åŠ /æ›´æ–°',0),(184568,5127,'pt','Contas adicionar/atualizar',0),(184569,5127,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(184570,5127,'es','Recibos Agregar/Actualizar',0),(184571,5127,'de','Rechnungen hinzufÃ¼gen/aktualisieren',0),(184572,5127,'en','Bills Add/Update',0),(184573,5128,'is','',0),(184574,5128,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÙŠØ¯',0),(184575,5128,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(184576,5128,'tr','PO ekleyin/gÃ¼ncelleyin',0),(184577,5128,'pl','Dodaj/Aktualizuj PO',0),(184578,5128,'bg','PO Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(184579,5128,'ur','Ù¾Ùˆ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(184580,5128,'sr','ÐŸÐž/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(184581,5128,'vi','ThÃªm/Cáº­p Nháº­t ÄÆ¡n Mua HÃ ng',0),(184582,5128,'af','AB Byvoeg/Opdateer',0),(184583,5128,'ro','Adauga/Actualizeaza comanda achizitie',0),(184584,5128,'et','PO lisamine/uuendamine',0),(184585,5128,'si','PO Dodaj/posodobi',0),(184586,5128,'ba','PO Tambahkan/Perbarui',0),(184587,5128,'nl','PO toevoegen/bijwerken',0),(184588,5128,'fi','PO lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(184589,5128,'no','PO/Oppdater',0),(184590,5128,'da','PO TilfÃ¸j/opdater',0),(184591,5128,'ko','í¬ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(184592,5128,'he','×¤×• ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(184593,5128,'el','PO Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(184594,5128,'zh','å¢žåŠ /æ›´æ–°é‡‡è´­è®¢å•\r\n',0),(184595,5128,'sv','PO LÃ¤gg till/uppdatera',0),(184596,5128,'it','Aggiungere/aggiornare un PO',0),(184597,5128,'tl','',0),(184598,5128,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(184599,5128,'hi','PO à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(184600,5128,'ms','PO Tambah/Kemaskini',0),(184601,5128,'ar','Øµ. Ø¨. Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(184602,5128,'fr','PO ajouter/mettre Ã  jour',0),(184603,5128,'jp','POã€€è¿½åŠ /æ›´æ–°',0),(184604,5128,'pt','PO adicionar/atualizar',0),(184605,5128,'ru','PO Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(184606,5128,'es','OC Agregar/Actualizar',0),(184607,5128,'de','PO-hinzufÃ¼gen/aktualisieren',0),(184608,5128,'en','PO Add/Update',0),(184609,5129,'is','',0),(184610,5129,'dr','Ø«Ø¨Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¬Ø¯ÙŠØ¯ ÙŠØ§ Ù…ÙˆØ¬ÙˆØ¯ ',0),(184611,5129,'pr','Ø«Ø¨Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¬Ø¯ÙŠØ¯ ÙŠØ§ Ù…ÙˆØ¬ÙˆØ¯ ',0),(184612,5129,'tr','Yeni girin ya da gÃ¼ncelleÅŸtirmek ve BorÃ§lar faturasÄ± mevcut',0),(184613,5129,'pl','WprowadÅº nowÄ… lub zaktualizowaÄ‡ i istniejÄ…cych zobowiÄ…zaÅ„ Bill',0),(184614,5129,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð¸Ð»Ð¸ Ð¾Ð±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð¸ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ Ð±Ð¸Ð»',0),(184615,5129,'ur','Ù†Ø¦ÛŒ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº ÛŒØ§ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø¨Ù„ Ù…ÙˆØ¬ÙˆØ¯Û',0),(184616,5129,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð¸Ð»Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ðµ Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸Ñ… Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð‘Ð¸Ð»',0),(184617,5129,'vi','Nháº­p Má»›i hay Cáº­p Nháº­t 1 HÃ³a ÄÆ¡n Pháº£i Tráº£ Hiá»‡n Táº¡i',0),(184618,5129,'af','Nuwe tik of bywerk en bestaande Waardedalingstoetse Wetsontwerp',0),(184619,5129,'ro','Intre noi sau actualiza ÅŸi existente ÅŸi datorii Bill',0),(184620,5129,'et','Sisestage uus vÃµi uuendatud ja on olemas vÃµlad Bill',0),(184621,5129,'si','Vnesite nov ali modernizirati ter obstojeÄih obveznosti zakona',0),(184622,5129,'ba','Masukkan baru atau Update dan tagihan hutang yang ada',0),(184623,5129,'nl','Nieuw invoeren of bijwerken en bestaande schulden Bill',0),(184624,5129,'fi','Kirjoita uusi tai PÃ¤ivitÃ¤ ja nykyiset velat Bill',0),(184625,5129,'no','Nye eller oppdatere eksisterende gjeld Bill',0),(184626,5129,'da','Angiv nye eller opdatere og eksisterende gÃ¦ld Bill',0),(184627,5129,'ko','ìƒˆë¡œìš´ ìž…ë ¥ ë˜ëŠ” ì—…ë°ì´íŠ¸ í•˜ ê³  ê¸°ì¡´ì˜ ë¯¸ì§€ê¸‰ê¸ˆ ë¹Œ',0),(184628,5129,'he','×”×–×Ÿ ×—×“×© ××• ×¢×“×›×•×Ÿ ×•×§×™×™×ž×™× ×–×›××™× ×‘×™×œ',0),(184629,5129,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î½Î­Î± Î® ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· ÎºÎ±Î¹ Ï„Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(184630,5129,'zh','è¾“å…¥æ–°çš„æˆ–æ›´æ–°çŽ°æœ‰çš„åº”ä»˜è´¦æ¬¾å¸å•',0),(184631,5129,'sv','Ange nytt eller uppdatera och befintliga skulder Bill',0),(184632,5129,'it','Inserire o aggiornare ed esistenti debiti Bill',0),(184633,5129,'tl','',0),(184634,5129,'th','&#3611;&#3657;&#3629;&#3609;&#3627;&#3619;&#3639;&#3629;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3617;&#3637;&#3',0),(184635,5129,'hi','à¤¨à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤”à¤° Payables à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤®à¥Œà¤œà¥‚à¤¦à¤¾',0),(184636,5129,'ms','Masukkan baru atau mengemaskini dan pemiutang Rang undang-undang yang sedia ada',0),(184637,5129,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø¬Ø¯ÙŠØ¯ Ø£Ùˆ ØªØ­Ø¯ÙŠØ« ÙˆØ§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ù‚Ø¨ÙˆØ¶Ø§Øª Ø¨ÙŠÙ„',0),(184638,5129,'fr','Entrez de nouveau ou mettre Ã  jour et existant Bill des comptes fournisseurs',0),(184639,5129,'jp','æ–°è¦?å…¥åŠ›ã?‹æ—¢å­˜ã?®æ”¯æ‰•ã?„è«‹æ±‚æ›¸ã?®æ›´æ–°',0),(184640,5129,'pt','Inserir novo ou atualizar e existente conta contas a pagar',0),(184641,5129,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¾Ðµ Ð¸Ð»Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¸ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(184642,5129,'es','Introducir Nuevo o Actualizar Recibo de Proveedor Existente',0),(184643,5129,'de','Neu eingeben oder aktualisieren und bestehende Verbindlichkeiten Bill',0),(184644,5129,'en','Enter New or Update and Existing Payables Bill',0),(184645,5130,'is','',0),(184646,5130,'dr','Ø´Ù…Ø§ Ù…Ø¬Ø§Ø² Ø¨Ù‡ Ø¨ÙˆØ¯Ù† Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§  Ù†ÙŠØ³ØªÙŠØ¯ ',0),(184647,5130,'pr','Ø´Ù…Ø§ Ù…Ø¬Ø§Ø² Ø¨Ù‡ Ø¨ÙˆØ¯Ù† Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§  Ù†ÙŠØ³ØªÙŠØ¯ ',0),(184648,5130,'tr','Burada yetkili olan',0),(184649,5130,'pl','JesteÅ› nie upowaÅ¼nione do tutaj',0),(184650,5130,'bg','Ð’Ð¸Ðµ ÑÑ‚Ðµ, Ð½ÑÐ¼Ð° Ð¿Ñ€Ð°Ð²Ð¾ Ð´Ð° Ð±ÑŠÐ´Ðµ Ñ‚ÑƒÐº',0),(184651,5130,'ur','Ø¢Ù¾ Ú©Ùˆ Ù†ÛÛŒÚº ÛŒÛØ§Úº Ø¬Ø§ Ú©Ø±Ù†Û’ Ú©Û’ Ù…Ø¬Ø§Ø² ÛÛŒÚº',0),(184652,5130,'sr','Ð’Ð¸ ÑÑ‚Ðµ Ð½Ð¸ÑÑ‚Ðµ Ð°ÑƒÑ‚Ð¾Ñ€Ð¸Ð·Ð¾Ð²Ð°Ð½Ð¸ Ð´Ð° Ð±ÑƒÐ´ÐµÑ‚Ðµ Ð¾Ð²Ð´Ðµ',0),(184653,5130,'vi','Báº¡n khÃ´ng Ä‘Æ°á»£c cáº¥p quyá»n táº¡i Ä‘Ã¢y',0),(184654,5130,'af','U is nie gemagtig om hier toegang te verkry.',0),(184655,5130,'ro','Nu sunteti autorizati sa fiti aici',0),(184656,5130,'et','Teil ei ole Ãµigusi sellel lehel olla',0),(184657,5130,'si','Vi ste dovoljeno biti tu.',0),(184658,5130,'ba','Anda tidak diizinkan untuk berada di sini',0),(184659,5130,'nl','U bent niet gemachtigd om te worden hier',0),(184660,5130,'fi','Te aari ei hyvÃ¤ksytty tÃ¤Ã¤llÃ¤',0),(184661,5130,'no','Du er ikke autorisert til Ã¥ vÃ¦re her',0),(184662,5130,'da','Du er ikke autoriseret til at vÃ¦re her',0),(184663,5130,'ko','ìžˆìŠµë‹ˆë‹¤ ì—¬ê¸°ì— ìžˆì„ ìˆ˜ ìžˆëŠ” ê¶Œí•œì´ ì—†ìŠµë‹ˆë‹¤.',0),(184664,5130,'he','. ××ª×” ×œ× ×ž×•×¨×©×”. ×œ×”×™×•×ª ×›××Ÿ',0),(184665,5130,'el','Î•Î¯ÏƒÏ„Îµ Î´ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎµÎ´ÏŽ',0),(184666,5130,'zh','æ‚¨æ²¡æœ‰æƒé™æ¥è¿™é‡Œ\r\n',0),(184667,5130,'sv','Du Ã¤r inte behÃ¶rig att vara hÃ¤r',0),(184668,5130,'it','Non sei autorizzati ad essere qui',0),(184669,5130,'tl','',0),(184670,5130,'th','&#3588;&#3640;&#3603;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3617;&#3629;&#3610;&#3629;&#3635;&#3609;&#3634;&#3592;&#3651;&#3627;&#3657;&#3629;&#3618;&#3641;&#3656;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;',0),(184671,5130,'hi','à¤†à¤ª à¤¯à¤¹à¤¾à¤ à¤¹à¥‹à¤¨à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤§à¤¿à¤•à¥ƒà¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¤‚',0),(184672,5130,'ms','Anda adalah tidak dibenarkan untuk berada di sini',0),(184673,5130,'ar','ØºÙŠØ± Ù…Ø³Ù…ÙˆØ­ Ù„Ùƒ Ø¨Ø£Ù† ØªÙƒÙˆÙ† Ù‡Ù†Ø§',0),(184674,5130,'fr','Vous Ãªtes pas autorisÃ© Ã  Ãªtre ici',0),(184675,5130,'jp','ã?“ã?“ã?«ã?„ã‚‹æ¨©åˆ©ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(184676,5130,'pt','VocÃª estÃ¡ autorizado nÃ£o estar aqui',0),(184677,5130,'ru','Ð’Ð°Ð¼ ÐÐµ Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ð—Ð´ÐµÑÑŒ',0),(184678,5130,'es','No estÃ¡ autorizado para estar aquÃ­',0),(184679,5130,'de','Sie sind nicht berechtigt, hier zu sein',0),(184680,5130,'en','You are Not Authorized to be Here',0),(184681,5131,'is','',0),(184682,5131,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¨ÛŒØ¬Ú©',0),(184683,5131,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(184684,5131,'tr','Fatura ekleme/gÃ¼ncelleme',0),(184685,5131,'pl','DodaÄ‡/aktualizacji faktury',0),(184686,5131,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(184687,5131,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(184688,5131,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(184689,5131,'vi','ThÃªm/Cáº­p Nháº­t HÃ³a ÄÆ¡n',0),(184690,5131,'af','Faktuur Byvoeg/Opdateer',0),(184691,5131,'ro','Adauga/Actualizeaza Factura',0),(184692,5131,'et','Lisa/Uuenda arveid',0),(184693,5131,'si','RaÄun Dodaj/posodobi',0),(184694,5131,'ba','Tambah/Ganti Faktur',0),(184695,5131,'nl','Factuur toevoegen/bijwerken',0),(184696,5131,'fi','LisÃ¤Ã¤ laskun pÃ¤ivitys',0),(184697,5131,'no','Faktura/Oppdater',0),(184698,5131,'da','Faktura TilfÃ¸j/opdater',0),(184699,5131,'ko','ì†¡ìž¥ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(184700,5131,'he','×”×•×¡×£/×¢×“×›×Ÿ ×—×©×‘×•× ×™×ª',0),(184701,5131,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(184702,5131,'zh','å¢žåŠ /æ›´æ–°å‘ç¥¨\r\n',0),(184703,5131,'sv','Faktura LÃ¤gg till/uppdatera',0),(184704,5131,'it','Fattura aggiungere/aggiornare',0),(184705,5131,'tl','',0),(184706,5131,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(184707,5131,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(184708,5131,'ms','Invois Tambah/Kemaskini',0),(184709,5131,'ar','ØªØ­Ø¯ÙŠØ«/Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(184710,5131,'fr','Facture ajouter/mettre Ã  jour',0),(184711,5131,'jp','è«‹æ±‚æ›¸ã€€è¿½åŠ /æ›´æ–°',0),(184712,5131,'pt','Factura adicionar/atualizar',0),(184713,5131,'ru','Ð¡Ñ‡ÐµÑ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(184714,5131,'es','Factura Agregar/Actualizar',0),(184715,5131,'de','Rechnung hinzufÃ¼gen/aktualisieren',0),(184716,5131,'en','Invoice Add/Update',0),(184717,5132,'is','',0),(184718,5132,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ±Ù…Ø§ÛŒØ´ ',0),(184719,5132,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(184720,5132,'tr','SipariÅŸ Ekle/GÃ¼ncelle',0),(184721,5132,'pl','Aby dodaÄ‡/aktualizacja',0),(184722,5132,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(184723,5132,'ur','Ø­Ú©Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(184724,5132,'sr','Ð ÐµÐ´/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(184725,5132,'vi','ThÃªm/Cáº­p Nháº­t ÄÆ¡n Äáº·t HÃ ng ',0),(184726,5132,'af','Bestelling Byvoeg/Opdateer',0),(184727,5132,'ro','Ordinul AdÄƒugaÅ£i/actualizaÅ£i',0),(184728,5132,'et','Tellimuse lisamine/uuendamine',0),(184729,5132,'si','Naloga Dodaj/posodobi',0),(184730,5132,'ba','Urutan Tambahkan/Perbarui',0),(184731,5132,'nl','Bestelling toevoegen/bijwerken',0),(184732,5132,'fi','Tilaa lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(184733,5132,'no','Bestilling/Oppdater',0),(184734,5132,'da','RÃ¦kkefÃ¸lge TilfÃ¸j/opdater',0),(184735,5132,'ko','ì£¼ë¬¸ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(184736,5132,'he','×”×•×¡×£/×¢×“×›×Ÿ ×”×–×ž× ×”',0),(184737,5132,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(184738,5132,'zh','å¢žåŠ /æ›´æ–°è®¢è´­',0),(184739,5132,'sv','FÃ¶r LÃ¤gg till/uppdatera',0),(184740,5132,'it','Ordine aggiungere/aggiornare',0),(184741,5132,'tl','',0),(184742,5132,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(184743,5132,'hi','à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(184744,5132,'ms','Perintah Tambah/Kemaskini',0),(184745,5132,'ar','Ø£Ù…Ø± Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(184746,5132,'fr','Ordre ajouter/mettre Ã  jour',0),(184747,5132,'jp','æ³¨æ–‡ã?®è¿½åŠ /æ›´æ–°',0),(184748,5132,'pt','Adicionar/atualizar a ordem',0),(184749,5132,'ru','Ð—Ð°ÐºÐ°Ð· Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(184750,5132,'es','Agregar/Actualizar Pedido',0),(184751,5132,'de','Bestellung hinzufÃ¼gen/aktualisieren',0),(184752,5132,'en','Order Add/Update',0),(184753,5133,'is','',0),(184754,5133,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(184755,5133,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(184756,5133,'tr','GÃ¼ncelleÅŸtirme sipariÅŸler',0),(184757,5133,'pl','Aktualizacja zamÃ³wienia',0),(184758,5133,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(184759,5133,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(184760,5133,'sr','Ð˜ÑÐ¿Ñ€Ð°Ð²ÐºÐ° Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(184761,5133,'vi','Cáº­p Nháº­t ÄÆ¡n HÃ ng',0),(184762,5133,'af','Bestellings Opdateer',0),(184763,5133,'ro','Actualizare comenzi',0),(184764,5133,'et','Uuenda tellimusi',0),(184765,5133,'si','Posodobitev naroÄila',0),(184766,5133,'ba','Update pesanan',0),(184767,5133,'nl','Update Orders',0),(184768,5133,'fi','Tilausten',0),(184769,5133,'no','Oppdater bestillinger',0),(184770,5133,'da','Opdatering ordrer',0),(184771,5133,'ko','ì—…ë°ì´íŠ¸ ìˆœì„œ',0),(184772,5133,'he','×¢×“×›×•×Ÿ ×”×–×ž× ×•×ª',0),(184773,5133,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(184774,5133,'zh','æ›´æ–°è®¢å•\r\n',0),(184775,5133,'sv','Uppdatera order',0),(184776,5133,'it','Aggiornamento ordini',0),(184777,5133,'tl','',0),(184778,5133,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(184779,5133,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤†à¤¦à¥‡à¤¶',0),(184780,5133,'ms','Arahan Kemaskini',0),(184781,5133,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø·Ù„Ø¨ÙŠØ§Øª',0),(184782,5133,'fr','Commandes mise a jour',0),(184783,5133,'jp','æ³¨æ–‡ã?®æ›´æ–°',0),(184784,5133,'pt','AtualizaÃ§Ã£o de ordens',0),(184785,5133,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(184786,5133,'es','Actualizar Ordenes',0),(184787,5133,'de','Update-AuftrÃ¤ge',0),(184788,5133,'en','Update Orders',0),(184789,5134,'is','',0),(184790,5134,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø«Ø¨Øª Ù‡Ø§ÙŠ Ú˜ÙˆØ±Ù†Ø§Ù„ ',0),(184791,5134,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(184792,5134,'tr','GÃ¼nlÃ¼k girdilerini Ekle/GÃ¼ncelle',0),(184793,5134,'pl','Wpisy dziennika dodaÄ‡/aktualizacja',0),(184794,5134,'bg','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(184795,5134,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(184796,5134,'sr','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº ÑÑ‚Ð°Ð²ÐºÐµ Ð”Ð¾Ð´Ð°Ñ˜/ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜',0),(184797,5134,'vi','ThÃªm/Cáº­p Nháº­t BÃºt ToÃ¡n',0),(184798,5134,'af','Joernaalinskrywings Byvoeg/Opdateer',0),(184799,5134,'ro','Adauga/Actualizeaza intrari jurnal',0),(184800,5134,'et','TÃ¶Ã¶lehe kandeid lisada vÃµi uuendada',0),(184801,5134,'si','Temeljnice postavke Dodaj/posodobi',0),(184802,5134,'ba','Jurnal entri Tambahkan/Perbarui',0),(184803,5134,'nl','Dagboek posten toevoegen/bijwerken',0),(184804,5134,'fi','Kirjauskansion merkinnÃ¤t lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(184805,5134,'no','Journal oppfÃ¸ringer Legg til/Oppdater',0),(184806,5134,'da','Journal indgange TilfÃ¸j/opdater',0),(184807,5134,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª© ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(184808,5134,'he','×¢×¨×›×™ ×™×•×ž×Ÿ ×”×•×¡×£/×¢×“×›×Ÿ',0),(184809,5134,'el','Î•Ï†Î·Î¼ÎµÏÎ¯Î´Î± ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(184810,5134,'zh','å¢žåŠ /æ›´æ–°æ—¥è®°è´¦åˆ†å½•\r\n',0),(184811,5134,'sv','Journal poster LÃ¤gg till/uppdatera',0),(184812,5134,'it','Gazzetta voci aggiungere/aggiornare',0),(184813,5134,'tl','',0),(184814,5134,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3610;&#3633;&#3597;&#3594;&#3637;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;',0),(184815,5134,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(184816,5134,'ms','Jurnal catatan Tambah/Kemaskini',0),(184817,5134,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(184818,5134,'fr','Journal entrÃ©es ajouter/mettre Ã  jour',0),(184819,5134,'jp','ä»•è¨³å¸³è¨˜å…¥ã€€è¿½åŠ /æ›´æ–°',0),(184820,5134,'pt','Jornal entradas adicionar/atualizar',0),(184821,5134,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¶ÑƒÑ€Ð½Ð°Ð»Ð°/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(184822,5134,'es','Ingresos al Diario Agregar/Actualizar',0),(184823,5134,'de','Journal-EintrÃ¤ge hinzufÃ¼gen/aktualisieren',0),(184824,5134,'en','Journal Entries Add/Update',0),(184825,5135,'is','',0),(184826,5135,'dr','Ù‚ÙŠÙ…Øª Ø§ØµÙ„ÙŠ',0),(184827,5135,'pr','Ù‚ÙŠÙ…Øª Ø§ØµÙ„ÙŠ',0),(184828,5135,'tr','Orig. fiyatÄ±',0),(184829,5135,'pl','Cena orig.',0),(184830,5135,'bg','Ð¦ÐµÐ½Ð° Ñ‚Ñ€ÑŠÐ±.',0),(184831,5135,'ur','Ù‚ÛŒÙ…Øª orig.',0),(184832,5135,'sr','ÐžÑ€Ð¸Ð³ . Ñ†ÐµÐ½Ð°',0),(184833,5135,'vi','GiÃ¡ gá»‘c',0),(184834,5135,'af','Oorsp.Prys',0),(184835,5135,'ro','Pret orig.',0),(184836,5135,'et','Orig. hind',0),(184837,5135,'si','Cena orig.',0),(184838,5135,'ba','Harga chines',0),(184839,5135,'nl','Orig. prijs',0),(184840,5135,'fi','Orig. hinta',0),(184841,5135,'no','Orig. pris',0),(184842,5135,'da','Orig. pris',0),(184843,5135,'ko','Orig. ê°€ê²©',0),(184844,5135,'he','×ž×—×™×¨ orig.',0),(184845,5135,'el','Orig. Ï„Î¹Î¼Î®',0),(184846,5135,'zh','åŽŸå§‹ã€‚ä»·æ ¼\r\n',0),(184847,5135,'sv','Orig. pris',0),(184848,5135,'it','Prezzo orig.',0),(184849,5135,'tl','',0),(184850,5135,'th','&#3619;&#3634;&#3588;&#3634;&#3604;&#3633;&#3657;&#3591;&#3648;&#3604;&#3636;&#3617;',0),(184851,5135,'hi','à¥¤ à¤•à¥€à¤®à¤¤',0),(184852,5135,'ms','Harga orig.',0),(184853,5135,'ar','Ø§Ù„Ø³Ø¹Ø± [Ø£Ø±ÙŠØº].',0),(184854,5135,'fr','Prix de l\'orig.',0),(184855,5135,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«ä¾¡æ ¼',0),(184856,5135,'pt','PreÃ§o orig.',0),(184857,5135,'ru','Ð¦ÐµÐ½Ð° Ð¾Ñ€Ð¸Ð³.',0),(184858,5135,'es','Orig. Precio',0),(184859,5135,'de','Orig.-Preis',0),(184860,5135,'en','Orig. Price',0),(184861,5136,'is','',0),(184862,5136,'dr','(Ø­Ø±Ø§Ø¬ÙŠ',0),(184863,5136,'pr','Ù…Ø­ØµÙˆÙ„Ø§Øª ÙØ±ÙˆØ´ÙŠ (Ø­Ø±Ø§Ø¬ÙŠ',0),(184864,5136,'tr','SatÄ±lÄ±k Ã¼rÃ¼nler',0),(184865,5136,'pl','Produkty na sprzedaÅ¼',0),(184866,5136,'bg','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(184867,5136,'ur','Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ ÙØ±ÙˆØ®Øª Ù¾Ø±',0),(184868,5136,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸ Ð½Ð° Ñ€Ð°ÑÐ¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¸',0),(184869,5136,'vi','Sáº£n pháº©m khuyáº¿n máº¡i',0),(184870,5136,'af','Produkte te Koop',0),(184871,5136,'ro','Vanzare produse',0),(184872,5136,'et','Tooted mÃ¼Ã¼gil',0),(184873,5136,'si','Proizvodi za prodajo',0),(184874,5136,'ba','Produk dijual',0),(184875,5136,'nl','Verkoop van producten',0),(184876,5136,'fi','Tuotteiden myynti',0),(184877,5136,'no','Produkter i salg',0),(184878,5136,'da','Tilbudsvarer',0),(184879,5136,'ko','ì œí’ˆ íŒë§¤',0),(184880,5136,'he','×ž×•×¦×¨×™× ×‘×ž×‘×¦×¢',0),(184881,5136,'el','Î ÏÎ¿ÏŠÏŒÎ½Ï„Î± Î³Î¹Î± Ï„Î·Î½ Ï€ÏŽÎ»Î·ÏƒÎ·',0),(184882,5136,'zh','äº§å“å‘å”®\r\n',0),(184883,5136,'sv','Produkter till fÃ¶rsÃ¤ljning',0),(184884,5136,'it','Prodotti in vendita',0),(184885,5136,'tl','',0),(184886,5136,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3586;&#3634;&#3618;',0),(184887,5136,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¥‹à¤‚ à¤ªà¤° à¤¬à¤¿à¤•à¥à¤°à¥€',0),(184888,5136,'ms','Produk jualan',0),(184889,5136,'ar','Ø§Ù„Ù…Ù†ØªØ¬Ø§Øª Ù„Ù„Ø¨ÙŠØ¹',0),(184890,5136,'fr','Produits en vente',0),(184891,5136,'jp','è²©å£²ä¸­è£½å“?',0),(184892,5136,'pt','Produtos Ã  venda',0),(184893,5136,'ru','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚Ñ‹ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ñƒ',0),(184894,5136,'es','Productos en Oferta',0),(184895,5136,'de','Produkte zum Verkauf',0),(184896,5136,'en','Products on Sale',0),(184897,5137,'is','',0),(184898,5137,'dr','Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ ',0),(184899,5137,'pr','Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ ',0),(184900,5137,'tr','SatÄ±ÅŸ FiyatÄ±',0),(184901,5137,'pl','Cena sprzedaÅ¼y',0),(184902,5137,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð½Ð° Ñ†ÐµÐ½Ð°',0),(184903,5137,'ur','ÙØ±ÙˆØ®Øª Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(184904,5137,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ð° Ñ†ÐµÐ½Ð°',0),(184905,5137,'vi','GiÃ¡ bÃ¡n hÃ ng',0),(184906,5137,'af','Verkoopsprys',0),(184907,5137,'ro','PreÅ£ul de vÃ¢nzare',0),(184908,5137,'et','MÃ¼Ã¼gihind',0),(184909,5137,'si','Prodajno ceno',0),(184910,5137,'ba','Harga Jual',0),(184911,5137,'nl','Verkoopprijs',0),(184912,5137,'fi','Myyntihinta',0),(184913,5137,'no','Salgspris',0),(184914,5137,'da','Salgsprisen',0),(184915,5137,'ko','íŒë§¤ ê°€ê²©',0),(184916,5137,'he','×ž×—×™×¨ ×ž×›×™×¨×”',0),(184917,5137,'el','Î¤Î¹Î¼Î® Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(184918,5137,'zh','é”€å”®ä»·æ ¼\r\n',0),(184919,5137,'sv','FÃ¶rsÃ¤ljningspriset',0),(184920,5137,'it','Prezzo di vendita',0),(184921,5137,'tl','',0),(184922,5137,'th','&#3619;&#3634;&#3588;&#3634;&#3586;&#3634;&#3618;',0),(184923,5137,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤®à¥‚à¤²à¥à¤¯',0),(184924,5137,'ms','Harga jualan',0),(184925,5137,'ar','Ø³Ø¹Ø± Ø§Ù„Ø¨ÙŠØ¹',0),(184926,5137,'fr','Prix de vente',0),(184927,5137,'jp','è²©å£²ä¾¡æ ¼',0),(184928,5137,'pt','PreÃ§o de venda',0),(184929,5137,'ru','Ð¦ÐµÐ½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(184930,5137,'es','Precio de Venta',0),(184931,5137,'de','Verkaufspreis',0),(184932,5137,'en','Sale Price',0),(184933,5138,'is','',0),(184934,5138,'dr','(Ø­Ø±Ø§Ø¬',0),(184935,5138,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø­ØµÙˆÙ„Ø§Øª ÙØ±ÙˆØ´ÙŠ (Ø­Ø±Ø§Ø¬',0),(184936,5138,'tr','SatÄ±lÄ±k Ã¼rÃ¼nleri gÃ¶rÃ¼ntÃ¼le',0),(184937,5138,'pl','Zobacz produkty na sprzedaÅ¼',0),(184938,5138,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸ Ð² Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(184939,5138,'ur','ÙØ±ÙˆØ®Øª Ù¾Ø± Ù…Ù†Ø¸Ø± Ú©ÛŒ Ù…ØµÙ†ÙˆØ¹Ø§Øª',0),(184940,5138,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ðµ Ð½Ð° Ñ€Ð°ÑÐ¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¸',0),(184941,5138,'vi','Xem sáº£n pháº©m khuyáº¿n máº¡i',0),(184942,5138,'af','Besigtig Produkte Te Koop',0),(184943,5138,'ro','Vezi produse la vanzare',0),(184944,5138,'et','Kuva tooted mÃ¼Ã¼gil',0),(184945,5138,'si','Oglejte si izdelke na prodaj',0),(184946,5138,'ba','Lihat produk dijual',0),(184947,5138,'nl','Bekijk de producten te koop',0),(184948,5138,'fi','NÃ¤ytÃ¤ tuotteet myynnissÃ¤',0),(184949,5138,'no','Vis produkter i salg',0),(184950,5138,'da','Se produkter til salg',0),(184951,5138,'ko','íŒë§¤ ì œí’ˆ ë³´ê¸°',0),(184952,5138,'he','×ª×¦×•×’×ª ×ž×•×¦×¨×™× ×‘×ž×‘×¦×¢',0),(184953,5138,'el','Î”ÎµÎ¯Ï„Îµ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î± Î³Î¹Î± Ï„Î·Î½ Ï€ÏŽÎ»Î·ÏƒÎ·',0),(184954,5138,'zh','æŸ¥çœ‹äº§å“å‘å”®\r\n',0),(184955,5138,'sv','Visa produkter till fÃ¶rsÃ¤ljning',0),(184956,5138,'it','Visualizza i prodotti in vendita',0),(184957,5138,'tl','',0),(184958,5138,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(184959,5138,'hi','à¤‰à¤¨ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¥‹à¤‚ à¤ªà¤° à¤¬à¤¿à¤•à¥à¤°à¥€',0),(184960,5138,'ms','Lihat produk-produk jualan',0),(184961,5138,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ù†ØªØ¬Ø§Øª Ù„Ù„Ø¨ÙŠØ¹',0),(184962,5138,'fr','Affichage des produits en vente',0),(184963,5138,'jp','è²©å£²ä¸­è£½å“?ã‚’è¡¨ç¤º',0),(184964,5138,'pt','Ver produtos Ã  venda',0),(184965,5138,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð² Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ñƒ',0),(184966,5138,'es','Visionar Productos en Oferta',0),(184967,5138,'de','Sale-Produkte anzeigen',0),(184968,5138,'en','View Products On Sale',0),(184969,5139,'is','',0),(184970,5139,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ  Ø¯ÙØªØ± ÙƒÙ„ ',0),(184971,5139,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ  Ø¯ÙØªØ± ÙƒÙ„ ',0),(184972,5139,'tr','Hata ekleme GL Transvoucher',0),(184973,5139,'pl','BÅ‚Ä…d dodawania GL Transvoucher',0),(184974,5139,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° GL Transvoucher',0),(184975,5139,'ur','Ù†Ù‚Øµ Ø¬ÛŒØ¬Û’ Ù¹Ø±Ø§Ù†Ø³ÙˆØ§Ú†Ø± Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(184976,5139,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð“Ð› Ð¢Ñ€Ð°Ð½ÑÐ²Ð¾ÑƒÑ†Ñ…ÐµÑ€',0),(184977,5139,'vi','ThÃªm phiáº¿u chuyá»ƒn sá»• cÃ¡i bá»‹ lá»—i',0),(184978,5139,'af','Fout met skepping van AG Transbewysstuk',0),(184979,5139,'ro','Eroare adÄƒugarea GL Transvoucher',0),(184980,5139,'et','Viga lisades GL Transvoucher',0),(184981,5139,'si','Napaka pri dodajanju GL Transvoucher',0),(184982,5139,'ba','Kesalahan menambahkan GL Transvoucher',0),(184983,5139,'nl','Fout toe te voegen GL Transvoucher',0),(184984,5139,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ GL Transvoucher',0),(184985,5139,'no','Feil Ã¥ legge GL Transvoucher',0),(184986,5139,'da','Fejl tilfÃ¸je GL Transvoucher',0),(184987,5139,'ko','ì˜¤ë¥˜ ì¶”ê°€ GL Transvoucher',0),(184988,5139,'he','×©×’×™××” ×”×•×¡×¤×ª GL Transvoucher',0),(184989,5139,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· GL Transvoucher',0),(184990,5139,'zh','é”™è¯¯ï¼šæ–°å¢žæ€»å¸ç›¸äº’ä»˜æ¬¾å‡­è¯',0),(184991,5139,'sv','Fel att lÃ¤gga till GL Transvoucher',0),(184992,5139,'it','Errore aggiungendo GL Transvoucher',0),(184993,5139,'tl','',0),(184994,5139,'th','Error Adding GL Transvoucher',0),(184995,5139,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ GL Transvoucher',0),(184996,5139,'ms','Ralat menambah GL Transvoucher',0),(184997,5139,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© GL ØªØ±Ø§Ù†Ø³ÙÙˆØªØ´ÙŠØ±',0),(184998,5139,'fr','Erreur ajout GL Transvoucher',0),(184999,5139,'jp','ï¼§ï¼¬å‡¦ç?†ä¼?ç¥¨ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(185000,5139,'pt','Erro adicionando GL Transvoucher',0),(185001,5139,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ GL Transvoucher',0),(185002,5139,'es','Error agregando LM Transvoucher',0),(185003,5139,'de','Fehler hinzufÃ¼gen GL Transvoucher',0),(185004,5139,'en','Error Adding GL Transvoucher',0),(185005,5140,'is','',0),(185006,5140,'dr','Ø¨Ø±Ø§ÙŠ Ú†Ùƒ',0),(185007,5140,'pr','Ø¨Ø±Ø§ÙŠ Ú†Ùƒ',0),(185008,5140,'tr','Kontrol iÃ§in',0),(185009,5140,'pl','Do wyboru',0),(185010,5140,'bg','Ð—Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(185011,5140,'ur','Ù¾Ú‘ØªØ§Ù„ Ø¨Ø±Ø§Ø¦Û’',0),(185012,5140,'sr','Ð—Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(185013,5140,'vi','DÃ nh cho SÃ©c',0),(185014,5140,'af','Vir kontrole',0),(185015,5140,'ro','Pentru a verifica',0),(185016,5140,'et','Kontrolliks',0),(185017,5140,'si','Za preverjanje',0),(185018,5140,'ba','Untuk memeriksa',0),(185019,5140,'nl','Voor Check',0),(185020,5140,'fi','Tarkistaa',0),(185021,5140,'no','For sjekk',0),(185022,5140,'da','For Check',0),(185023,5140,'ko','í™•ì¸ì„ ìœ„í•´',0),(185024,5140,'he','×¢×‘×•×¨ ×‘×“×™×§×”',0),(185025,5140,'el','Î“Î¹Î± Î­Î»ÎµÎ³Ï‡Î¿',0),(185026,5140,'zh','å¯¹äºŽæ”¯ç¥¨\r\n',0),(185027,5140,'sv','FÃ¶r Check',0),(185028,5140,'it','Per controllo',0),(185029,5140,'tl','',0),(185030,5140,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3648;&#3594;&#3655;&#3588;',0),(185031,5140,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(185032,5140,'ms','Untuk semak',0),(185033,5140,'ar','Ù„Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(185034,5140,'fr','Pour cocher',0),(185035,5140,'jp','ç¢ºèª?ã?®ã?Ÿã‚?',0),(185036,5140,'pt','Para seleÃ§Ã£o',0),(185037,5140,'ru','Ð”Ð»Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(185038,5140,'es','Para Cheque',0),(185039,5140,'de','FÃ¼r Check',0),(185040,5140,'en','For Check',0),(185041,5141,'is','',0),(185042,5141,'dr','(Ø«Ø¨Øª ',0),(185043,5141,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§Ø¨Ù‚Ù‡ (Ø«Ø¨Øª ',0),(185044,5141,'tr','Hata kaydÄ± ekleme',0),(185045,5141,'pl','BÅ‚Ä…d dodawania rekordu',0),(185046,5141,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(185047,5141,'ur','Ù†Ù‚Øµ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(185048,5141,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° Ð·Ð°Ð¿Ð¸ÑÐ°',0),(185049,5141,'vi','ThÃªm há»“ sÆ¡ bá»‹ lá»—i',0),(185050,5141,'af','Fout voeg rekord',0),(185051,5141,'ro','Eroare de adÄƒugare Ã®nregistrare',0),(185052,5141,'et','Viga lisades kirje',0),(185053,5141,'si','Dodajanje zapisa o napaki',0),(185054,5141,'ba','Kesalahan menambahkan catatan',0),(185055,5141,'nl','Fout toe te voegen Record',0),(185056,5141,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ tietue',0),(185057,5141,'no','Legge feilpost',0),(185058,5141,'da','TilfÃ¸jelse af fejlposten',0),(185059,5141,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê¸°ë¡',0),(185060,5141,'he','×”×•×¡×¤×ª ×¨×©×•×ž×ª ×”×©×’×™××”',0),(185061,5141,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÎ³Î³ÏÎ±Ï†Î®',0),(185062,5141,'zh','é”™è¯¯ï¼šæ–°å¢žè®°å½•',0),(185063,5141,'sv','Fel att lÃ¤gga post',0),(185064,5141,'it','Errore aggiunta di Record',0),(185065,5141,'tl','',0),(185066,5141,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;',0),(185067,5141,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(185068,5141,'ms','Ralat menambah rekod',0),(185069,5141,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø³Ø¬Ù„',0),(185070,5141,'fr','Erreur ajout d\'enregistrement',0),(185071,5141,'jp','è¨˜éŒ²ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(185072,5141,'pt','Registro de erro adicionando',0),(185073,5141,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¾Ð± Ð¾ÑˆÐ¸Ð±ÐºÐµ',0),(185074,5141,'es','Error Agregando Record',0),(185075,5141,'de','HinzufÃ¼gen von Fehlerdatensatz',0),(185076,5141,'en','Error Adding Record',0),(185077,5142,'is','',0),(185078,5142,'dr','( Ø¯ÙØªØ± )( Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ ',0),(185079,5142,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø³Ø§Ø¨Ù‚Ù‡ ( Ø¯ÙØªØ± )( Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ ',0),(185080,5142,'tr','KayÄ±t gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(185081,5142,'pl','BÅ‚Ä…d podczas aktualizowania rekordu',0),(185082,5142,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(185083,5142,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(185084,5142,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð·Ð°Ð¿Ð¸ÑÐ°',0),(185085,5142,'vi','Lá»—i cáº­p nháº­t há»“ sÆ¡',0),(185086,5142,'af','Fout bywerking rekord',0),(185087,5142,'ro','Eroare la actualizarea Record',0),(185088,5142,'et','Kirje vÃ¤rskendamise tÃµrge',0),(185089,5142,'si','Napaka pri posodabljanju zapisa',0),(185090,5142,'ba','Kesalahan mengupdate Record',0),(185091,5142,'nl','Fout bij het bijwerken van de Record',0),(185092,5142,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tietueen',0),(185093,5142,'no','Feil under oppdatering av post',0),(185094,5142,'da','Fejl under opdatering af post',0),(185095,5142,'ko','ë ˆì½”ë“œë¥¼ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì˜¤ë¥˜',0),(185096,5142,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¨×©×•×ž×”',0),(185097,5142,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ ÏÎµÎºÏŒÏ',0),(185098,5142,'zh','é”™è¯¯æ›´æ–°è®°å½•\r\n',0),(185099,5142,'sv','Gick inte att uppdatera posten',0),(185100,5142,'it','Errore di aggiornamento Record',0),(185101,5142,'tl','',0),(185102,5142,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;',0),(185103,5142,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(185104,5142,'ms','Ralat dalam mengemas kini rekod',0),(185105,5142,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø³Ø¬Ù„',0),(185106,5142,'fr','Erreur mise Ã  jour d\'enregistrement',0),(185107,5142,'jp','è¨˜éŒ²ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(185108,5142,'pt','Erro ao atualizar o registro',0),(185109,5142,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(185110,5142,'es','Error Actualizando Record',0),(185111,5142,'de','Fehler beim Aktualisieren des Datensatzes',0),(185112,5142,'en','Error Updating Record',0),(185113,5143,'is','',0),(185114,5143,'dr','( ØªÙ†Ø²ÙŠÙ„) Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(185115,5143,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨Ù‡Ø±Ù‡ ( ØªÙ†Ø²ÙŠÙ„) Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(185116,5143,'tr','Faiz gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu',0),(185117,5143,'pl','Zainteresowanie aktualizacji nie powiodÅ‚o siÄ™',0),(185118,5143,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(185119,5143,'ur','Ø³ÙˆØ¯ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(185120,5143,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(185121,5143,'vi','Cáº­p Nháº­t LÃ£i Suáº¥t tháº¥t báº¡i',0),(185122,5143,'af','Rente Opdatering Gefaal',0),(185123,5143,'ro','Interes Update nu a reuÈ™it',0),(185124,5143,'et','Huvi vÃ¤rskendamine nurjus',0),(185125,5143,'si','Interesa ni mogoÄe posodobiti',0),(185126,5143,'ba','Gagal Update bunga',0),(185127,5143,'nl','Belang-Update mislukt',0),(185128,5143,'fi','Edun pÃ¤ivitys epÃ¤onnistui',0),(185129,5143,'no','Interesse oppdatering mislyktes',0),(185130,5143,'da','Interesse opdatering mislykkedes',0),(185131,5143,'ko','ê´€ì‹¬ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(185132,5143,'he','×¢×“×›×•×Ÿ ×”×¨×™×‘×™×ª × ×›×©×œ',0),(185133,5143,'el','Î•Î½Î´Î¹Î±Ï†Î­ÏÎ¿Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(185134,5143,'zh','åˆ©æ¯æ›´æ–°å¤±è´¥\r\n',0),(185135,5143,'sv','Intresse uppdateringen misslyckades',0),(185136,5143,'it','Interesse aggiornamento non riuscito',0),(185137,5143,'tl','',0),(185138,5143,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(185139,5143,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²',0),(185140,5143,'ms','Kemaskini faedah yang gagal',0),(185141,5143,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(185142,5143,'fr','IntÃ©rÃªt mise Ã  jour a Ã©chouÃ©',0),(185143,5143,'jp','åˆ©å­?ã?®æ›´æ–°ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(185144,5143,'pt','Interesse atualizaÃ§Ã£o falhada',0),(185145,5143,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(185146,5143,'es','InterÃ©ses actualizar fallÃ³',0),(185147,5143,'de','Interesse-Update fehlgeschlagen',0),(185148,5143,'en','Interest Update Failed',0),(185149,5144,'is','',0),(185150,5144,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§ÙƒØªÙˆØ± ØµÙ†Ø¹Øª Ø¯Ø± Ù‡Ù…Ù‡ Ø²Ø¨Ø§Ù†Ù‡Ø§ Ù…Ø´Ø§Ø¨Ù‡ Ø§Ø³Øª ',0),(185151,5144,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§ÙƒØªÙˆØ± ØµÙ†Ø¹Øª Ø¯Ø± Ù‡Ù…Ù‡ Ø²Ø¨Ø§Ù†Ù‡Ø§ Ù…Ø´Ø§Ø¨Ù‡ Ø§Ø³Øª ',0),(185152,5144,'tr','AR fatura Ã¶deme',0),(185153,5144,'pl','PÅ‚atnoÅ›ci faktury AR',0),(185154,5144,'bg','AR Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(185155,5144,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(185156,5144,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ ÐÐ ',0),(185157,5144,'vi','Thanh ToÃ¡n HÃ³a ÄÆ¡n AR',0),(185158,5144,'af','RO Faktuur Betaling',0),(185159,5144,'ro','Plata de facturi AR',0),(185160,5144,'et','AR arve tasumine',0),(185161,5144,'si','PlaÄilo raÄuna AR',0),(185162,5144,'ba','Pembayaran tagihan AR',0),(185163,5144,'nl','AR factuur betaling',0),(185164,5144,'fi','AR laskun maksu',0),(185165,5144,'no','AR fakturabetalingen',0),(185166,5144,'da','AR fakturabetaling',0),(185167,5144,'ko','AR ì†¡ìž¥ ì§€ë¶ˆ',0),(185168,5144,'he','AR ×—×©×‘×•× ×™×ª ×ª×©×œ×•×',0),(185169,5144,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… AR',0),(185170,5144,'zh','åº”æ”¶è´¦æ¬¾å‘ç¥¨ä»˜æ¬¾\r\n',0),(185171,5144,'sv','AR fakturabetalning',0),(185172,5144,'it','Pagamento fattura AR',0),(185173,5144,'tl','',0),(185174,5144,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(185175,5144,'hi','à¤. à¤†à¤°. à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(185176,5144,'ms','Pembayaran invois AR',0),(185177,5144,'ar','Ø¯ÙØ¹ ÙØ§ØªÙˆØ±Ø© AR',0),(185178,5144,'fr','Facturation CR de paiement',0),(185179,5144,'jp','ï¼¡ï¼²è«‹æ±‚æ›¸æ”¯æ‰•ã?„',0),(185180,5144,'pt','Pagamento de fatura de AR',0),(185181,5144,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð° AR',0),(185182,5144,'es','CC Pago de Factura',0),(185183,5144,'de','AR Rechnung Zahlung',0),(185184,5144,'en','AR Invoice Payment',0),(185185,5145,'is','',0),(185186,5145,'dr','ÙØ§ÙƒØªÙˆØ± ØµÙ†Ø¹ØªÙŠ',0),(185187,5145,'pr','ÙØ§ÙƒØªÙˆØ± ØµÙ†Ø¹ØªÙŠ',0),(185188,5145,'tr','AR fatura',0),(185189,5145,'pl','AR faktury',0),(185190,5145,'bg','AR Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(185191,5145,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(185192,5145,'sr','ÐÐ  Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(185193,5145,'vi','HÃ³a ÄÆ¡n AR',0),(185194,5145,'af','RO Faktuur',0),(185195,5145,'ro','FacturÄƒ AR',0),(185196,5145,'et','AR arve',0),(185197,5145,'si','AR raÄuna',0),(185198,5145,'ba','AR faktur',0),(185199,5145,'nl','AR factuur',0),(185200,5145,'fi','AR laskun',0),(185201,5145,'no','AR faktura',0),(185202,5145,'da','AR faktura',0),(185203,5145,'ko','AR ì†¡ìž¥',0),(185204,5145,'he','AR ×—×©×‘×•× ×™×ª',0),(185205,5145,'el','AR Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(185206,5145,'zh','åº”æ”¶è´¦æ¬¾å‘ç¥¨\r\n',0),(185207,5145,'sv','AR faktura',0),(185208,5145,'it','Fattura AR',0),(185209,5145,'tl','',0),(185210,5145,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(185211,5145,'hi','à¤. à¤†à¤°. à¤šà¤¾à¤²à¤¾à¤¨',0),(185212,5145,'ms','Invois AR',0),(185213,5145,'ar','Ø¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(185214,5145,'fr','Facturation CR',0),(185215,5145,'jp','ï¼¡ï¼°è«‹æ±‚æ›¸',0),(185216,5145,'pt','Factura de AR',0),(185217,5145,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° AR',0),(185218,5145,'es','CC Factura',0),(185219,5145,'de','AR-Rechnung',0),(185220,5145,'en','AR Invoice',0),(185221,5146,'is','',0),(185222,5146,'dr','Ù…Ø¹ÙƒÙˆØ³ Ø³Ø§Ø²ÙŠ ÙØ§ÙƒØªÙˆØ± ØµÙ†Ø¹Øª Ø¯Ø± Ù‡Ù…Ù‡ Ø²Ø¨Ø§Ù†Ù‡Ø§ Ù…Ø´Ø§Ø¨Ù‡ Ø§Ø³Øª ',0),(185223,5146,'pr','Ù…Ø¹ÙƒÙˆØ³ Ø³Ø§Ø²ÙŠ ÙØ§ÙƒØªÙˆØ± ØµÙ†Ø¹Øª Ø¯Ø± Ù‡Ù…Ù‡ Ø²Ø¨Ø§Ù†Ù‡Ø§ Ù…Ø´Ø§Ø¨Ù‡ Ø§Ø³Øª ',0),(185224,5146,'tr','AR fatura tersine Ã§evirme',0),(185225,5146,'pl','Wycofanie faktury AR',0),(185226,5146,'bg','AR Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¾Ð±Ñ€ÑŠÑ‰Ð°Ð½Ðµ',0),(185227,5146,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ù„Ù¹',0),(185228,5146,'sr','ÐÐ  ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(185229,5146,'vi','Äáº£o NgÆ°á»£c HÃ³a ÄÆ¡n AR',0),(185230,5146,'af','RO Faktuur Ommeswaai',0),(185231,5146,'ro','Inversare de facturÄƒ AR',0),(185232,5146,'et','AR arve tÃ¼histamine',0),(185233,5146,'si','AR raÄuna preobrat',0),(185234,5146,'ba','AR faktur pembalikan',0),(185235,5146,'nl','AR factuur omkering',0),(185236,5146,'fi','AR peruutus',0),(185237,5146,'no','AR faktura reversering',0),(185238,5146,'da','AR faktura tilbagefÃ¸rsel',0),(185239,5146,'ko','AR ì†¡ìž¥ ë°˜ì „',0),(185240,5146,'he','×”×™×¤×•×š ×—×©×‘×•× ×™×ª AR',0),(185241,5146,'el','AR Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±Î½Ï„Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(185242,5146,'zh','åº”æ”¶è´¦æ¬¾å‘ç¥¨å†²é”€\r\n',0),(185243,5146,'sv','AR faktura Ã¥terfÃ¶ring',0),(185244,5146,'it','AR fattura inversione',0),(185245,5146,'tl','',0),(185246,5146,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3618;&#3657;&#3629;&#3609;&#3627;&#3621;&#3633;&#3591;',0),(185247,5146,'hi','à¤. à¤†à¤°. à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤‰à¤¤à¥à¤•à¥à¤°à¤®à¤£',0),(185248,5146,'ms','Pembalikan invois AR',0),(185249,5146,'ar','Ø¹ Ø¹ÙƒØ³ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(185250,5146,'fr','Renverser la facturation CR',0),(185251,5146,'jp','ï¼¡ï¼°è«‹æ±‚æ›¸ç ´æ£„',0),(185252,5146,'pt','ReversÃ£o de factura de AR',0),(185253,5146,'ru','AR ÑÑ‡ÐµÑ‚ Ñ€Ð°Ð·Ð²Ð¾Ñ€Ð¾Ñ‚Ð°',0),(185254,5146,'es','CC ReversiÃ³n de Factura',0),(185255,5146,'de','AR Rechnung Umkehr',0),(185256,5146,'en','AR Invoice Reversal',0),(185257,5147,'is','',0),(185258,5147,'dr','Ø¨Ø§ Ø¨Ø±Ø±Ø³ÙŠ Ú©Ø§Ø¯Ø± Ù…Ù† ØªØµØ¯ÙŠÙ‚ Ù…ÙŠ ÙƒÙ†Ù… ÙƒÙ‡',0),(185259,5147,'pr','Ø¨Ø§ Ø¨Ø±Ø±Ø³ÙŠ Ú©Ø§Ø¯Ø± Ù…Ù† ØªØµØ¯ÙŠÙ‚ Ù…ÙŠ ÙƒÙ†Ù… ÙƒÙ‡',0),(185260,5147,'tr','Bu kutuyu iÅŸaretleyerek bu tasdik',0),(185261,5147,'pl','ZaznaczajÄ…c to pole poÅ›wiadczam, Å¼e',0),(185262,5147,'bg','Ð§Ñ€ÐµÐ· Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ñ‚Ð¾Ð²Ð° Ð¿Ð¾Ð»Ðµ, Ð°Ð· ÑƒÐ´Ð¾ÑÑ‚Ð¾Ð²ÐµÑ€ÑÐ²Ð°Ð¼, Ñ‡Ðµ',0),(185263,5147,'ur','ÛŒÛ Ø®Ø§Ù†Û Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ø¬Ú¾Û’ Ø¬Ùˆ ØªØµØ¯ÛŒÙ‚',0),(185264,5147,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð°ÑšÐµÐ¼ Ð¾Ð²Ñƒ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ð¼ Ñ‚Ð¾',0),(185265,5147,'vi','Khi Ä‘Ã¡nh dáº¥u há»™p nÃ y tÃ´i xÃ¡c nháº­n ráº±ng',0),(185266,5147,'af','Deur hierdie boksie te merk sertifiseer ek dat',0),(185267,5147,'ro','BifÃ¢nd aceastÄƒ casetÄƒ certific cÄƒ',0),(185268,5147,'et','Selle kasti kinnitan, et',0),(185269,5147,'si','Z izbiro tega polja potrjujem, da',0),(185270,5147,'ba','Dengan mencentang kotak ini saya menyatakan bahwa',0),(185271,5147,'nl','Door dit vakje aan te vinken verklaart dat',0),(185272,5147,'fi','TÃ¤mÃ¤n ruudun minÃ¤ todistan, ettÃ¤',0),(185273,5147,'no','Ved Ã¥ merke denne boksen bekrefter jeg at',0),(185274,5147,'da','Ved at markere feltet, hvis bekrÃ¦fter jeg, at',0),(185275,5147,'ko','ì´ í™•ì¸ëž€ì„ ì„ íƒ í•˜ ì—¬ ê·¸ ì¦ëª…',0),(185276,5147,'he','×¢×œ ×™×“×™ ×¡×™×ž×•×Ÿ ×ª×™×‘×” ×–×• ×©××§×‘×¢ ××ª ×–×”',0),(185277,5147,'el','Î•Ï€Î¹Î»Î­Î³Î¿Î½Ï„Î±Ï‚ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ Ï€Î¿Ï… Î½Î± Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹ÎµÎ¯ ÏŒÏ„Î¹',0),(185278,5147,'zh','å‹¾é€‰æ­¤æ¡†æˆ‘ä¿è¯\r\n',0),(185279,5147,'sv','Genom att kontrollera rutan intygar jag att',0),(185280,5147,'it','Spuntando questa casella dichiaro che',0),(185281,5147,'tl','',0),(185282,5147,'th','&#3650;&#3604;&#3618;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3585;&#3621;&#3656;&#3629;&#3591;&#3609;&#3637;&#3657;&#3593;&#3633;&#3609;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;&#3623;&#3656;&#3634;',0),(185283,5147,'hi','à¤‡à¤¸ à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¤•à¥‡ à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤®à¤¾à¤£à¤¿à¤¤ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤•à¤¿',0),(185284,5147,'ms','Dengan menanda kotak ini, saya mengesahkan bahawa',0),(185285,5147,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…Ø±Ø¨Ø¹ ÙˆØ£Ø´Ù‡Ø¯ Ø£Ù†',0),(185286,5147,'fr','En cochant cette case, je certifie que',0),(185287,5147,'jp','ã?“ã?®ãƒœãƒƒã‚¯ã‚¹ã‚’ãƒ?ã‚§ãƒƒã‚¯ã?™ã‚‹äº‹ã?«ã‚ˆã‚Šä¿?è¨¼ã?—ã?¾ã?™',0),(185288,5147,'pt','Marcando esta caixa certifica que',0),(185289,5147,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ð² ÑÑ‚Ð¾Ñ‚ Ñ„Ð»Ð°Ð¶Ð¾Ðº, Ñ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´Ð°ÑŽ, Ñ‡Ñ‚Ð¾',0),(185290,5147,'es','Cuando marco esta caja certifico que',0),(185291,5147,'de','Durch Ankreuzen dieses Feldes bestÃ¤tige ich, dass',0),(185292,5147,'en','By checking this box I certify that',0),(185293,5148,'is','',0),(185294,5148,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ®',0),(185295,5148,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ®',0),(185296,5148,'tr','Hata gÃ¼ncelleme tarihi deÄŸiÅŸikliÄŸi',0),(185297,5148,'pl','BÅ‚Ä…d aktualizacji zmieniÄ‡ datÄ™',0),(185298,5148,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð´Ð°Ñ‚Ð°',0),(185299,5148,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® ØªØ¨Ø¯ÛŒÙ„',0),(185300,5148,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(185301,5148,'vi','Lá»—i cáº­p nháº­t thay Ä‘á»•i ngÃ y',0),(185302,5148,'af','Fout met Opdatering van Datum Verandering',0),(185303,5148,'ro','Eroare de actualizare a modifica data',0),(185304,5148,'et','Viga ajakohastamine kuupÃ¤eva muutmine',0),(185305,5148,'si','Napaka pri posodabljanju datum spremembe',0),(185306,5148,'ba','Kesalahan update tanggal perubahan',0),(185307,5148,'nl','Fout bijwerken datumwijziging',0),(185308,5148,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n muutos',0),(185309,5148,'no','Feil oppdatering endring',0),(185310,5148,'da','Fejl opdatering dato forandring',0),(185311,5148,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë‚ ì§œ ë³€ê²½',0),(185312,5148,'he','×©×™× ×•×™ ×ª××¨×™×š ×¢×“×›×•×Ÿ ×©×’×™××”',0),(185313,5148,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î»Î»Î±Î³Î® Î»Î¬Î¸Î¿Ï‚',0),(185314,5148,'zh','é”™è¯¯æ›´æ–°æ—¥æœŸå˜æ›´\r\n',0),(185315,5148,'sv','Fel uppdatera datum Ã¤ndra',0),(185316,5148,'it','Errore aggiornamento data modifica',0),(185317,5148,'tl','',0),(185318,5148,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;',0),(185319,5148,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¬à¤¦à¤²à¥‡à¤‚',0),(185320,5148,'ms','Ralat pengemaskinian tarikh perubahan',0),(185321,5148,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØºÙŠÙŠØ±',0),(185322,5148,'fr','Erreur mise Ã  jour Date changement',0),(185323,5148,'jp','æ—¥ã?«ã?¡å¤‰æ›´ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(185324,5148,'pt','MudanÃ§a de data atualizaÃ§Ã£o erro',0),(185325,5148,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð”Ð°Ñ‚Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(185326,5148,'es','Error Actualizando el Cambio de la Fecha',0),(185327,5148,'de','Fehler Update Datum Ã¤ndern',0),(185328,5148,'en','Error Updating Date Change',0),(185329,5149,'is','',0),(185330,5149,'dr','Ø®Ø·Ø§ ÙŠ ØªØ§ÙŠÙŠØ¯  Ø§Ø¹ØªØ¨Ø§Ø± ÙƒØ§Ø±Ø¨Ø±',0),(185331,5149,'pr','Ø®Ø·Ø§ ÙŠ ØªØ§ÙŠÙŠØ¯  Ø§Ø¹ØªØ¨Ø§Ø± ÙƒØ§Ø±Ø¨Ø±',0),(185332,5149,'tr','Hata doÄŸrulama kullanÄ±cÄ±',0),(185333,5149,'pl','BÅ‚Ä…d sprawdzania poprawnoÅ›ci uÅ¼ytkownika',0),(185334,5149,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð°Ð»Ð¸Ð´Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(185335,5149,'ur','Ù†Ù‚Øµ ØµØ§Ø±Ù Ú©ÛŒ Ø¬ÙˆØ§Ø² Ø¯ÛÛŒ',0),(185336,5149,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸ Ð²Ð°Ñ™Ð°Ð½Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(185337,5149,'vi','Hiá»‡u Lá»±c HÃ³a NgÆ°á»i Sá»­ Dá»¥ng Bá»‹ Lá»—i',0),(185338,5149,'af','Fout met Bevestiging van gebruiker',0),(185339,5149,'ro','Eroare validarea utilizatorului',0),(185340,5149,'et','TÃµrge sisseseatud kasutaja',0),(185341,5149,'si','Napaka pri potrjevanju uporabnik',0),(185342,5149,'ba','Kesalahan memvalidasi pengguna',0),(185343,5149,'nl','Fout valideren gebruiker',0),(185344,5149,'fi','Virhe validointi kÃ¤yttÃ¤jÃ¤',0),(185345,5149,'no','Feil validere brukeren',0),(185346,5149,'da','Fejl validering bruger',0),(185347,5149,'ko','ìœ íš¨ì„± ê²€ì‚¬ ì‚¬ìš©ìž ì˜¤ë¥˜',0),(185348,5149,'he','×©×’×™××” ×‘××™×ž×•×ª ×ž×©×ª×ž×©',0),(185349,5149,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÏ€Î¹ÎºÏÏÏ‰ÏƒÎ·Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·',0),(185350,5149,'zh','é”™è¯¯éªŒè¯ç”¨æˆ·\r\n',0),(185351,5149,'sv','Fel validera anvÃ¤ndaren',0),(185352,5149,'it','Errore convalida utente',0),(185353,5149,'tl','',0),(185354,5149,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3607;&#3635;&#3651;&#3627;&#3657;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(185355,5149,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤®à¤¾à¤¨à¥à¤¯ à¤•à¥‹ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(185356,5149,'ms','Ralat mengesahkan pengguna',0),(185357,5149,'ar','Ø®Ø·Ø£ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† ØµØ­Ø© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(185358,5149,'fr','Erreur de validation utilisateur',0),(185359,5149,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®æœ‰åŠ¹åŒ–ã‚¨ãƒ©ãƒ¼',0),(185360,5149,'pt','Validando usuÃ¡rio erro',0),(185361,5149,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(185362,5149,'es','Error Validando Usuario',0),(185363,5149,'de','Fehler Ã¼berprÃ¼fen von',0),(185364,5149,'en','Error Validating User',0),(185365,5150,'is','',0),(185366,5150,'dr','- Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ù†Ø§Ù… ÛŒÙˆØ²Ø±ÙŠ Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ Ùˆ Ø¬Ø¹Ø¨Ù‡ Ø²ÙŠØ± Ø±Ø§ Ú†Ùƒ ÙƒÙ†ÙŠØ¯ ',0),(185367,5150,'pr','Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯  - Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ Ùˆ Ø¬Ø¹Ø¨Ù‡ Ø²ÙŠØ± Ø±Ø§ Ú†Ùƒ ÙƒÙ†ÙŠØ¯ ',0),(185368,5150,'tr','Son tarihini deÄŸiÅŸtirmek iÃ§in kullanÄ±cÄ± adÄ±nÄ±zÄ± ve ÅŸifrenizi girin ve aÅŸaÄŸÄ±daki kutuyu iÅŸaretleyin',0),(185369,5150,'pl','Aby zmieniÄ‡ datÄ™ ukoÅ„czenia naleÅ¼y wprowadziÄ‡ nazwÄ™ uÅ¼ytkownika i hasÅ‚o i zaznacz pole poniÅ¼ej',0),(185370,5150,'bg','Ð—Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð°ÑˆÐµÑ‚Ð¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¾Ñ‚Ð¼ÐµÑ‚ÐºÐ° Ð² ÐºÐ²Ð°Ð´Ñ€Ð°Ñ‚Ñ‡ÐµÑ‚Ð¾ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ',0),(185371,5150,'ur','ÙˆØ§Ø¬Ø¨ ØªØ§Ø±ÛŒØ® ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ØªÙ…Ú¾ÛŒÚº Ø§Ù¾Ù†Ø§ ØµØ§Ø±Ù Ù†Ø§Ù… Ø§ÙˆØ± Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù†ÛŒÚ†Û’ Ø®Ø§Ù†Û Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(185372,5150,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð»Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑÐ²Ð¾Ñ˜Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ Ð¸ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð¾Ð²Ð¾ Ð¿Ð¾Ñ™Ðµ',0),(185373,5150,'vi','Äá»ƒ thay Ä‘á»•i thá»i háº¡n báº¡n pháº£i gÃµ TÃªn NgÆ°á»i Sá»­ Dá»¥ng, Máº­t MÃ£ vÃ  Ä‘Ã¡nh dáº¥u vÃ o há»™p dÆ°á»›i Ä‘Ã¢y',0),(185374,5150,'af','Ten einde die Verskuldige Datum te verander moet u, u Aantekennaam en Wagwoord invoer en die boksies onderaan merk',0),(185375,5150,'ro','Pentru a modifica data scadenÅ£ei trebuie sÄƒ introduceÅ£i numele de utilizator ÅŸi parola ÅŸi bifaÅ£i caseta de mai jos',0),(185376,5150,'et','Muuta, peate sisestama oma kasutajanimi ja parool ja mÃ¤rkige ruut',0),(185377,5150,'si','Da bi spremenili datum zapadlosti mora vpiÅ¡ite svoje uporabniÅ¡ko ime in geslo in potrdite polje spodaj',0),(185378,5150,'ba','Untuk mengubah tanggal jatuh tempo Anda harus memasukkan Username dan Password dan centang kotak di bawah ini',0),(185379,5150,'nl','Om de einddatum wijzigen moet u uw gebruikersnaam en wachtwoord en onderstaand selectievakje in',0),(185380,5150,'fi','Jotta muuttaa kÃ¤yttÃ¤jÃ¤tunnusta ja salasanaa ja tarkista alla',0),(185381,5150,'no','For Ã¥ endre forfallsdatoen mÃ¥ du angi brukernavn og passord og Merk boksen nedenfor',0),(185382,5150,'da','For at Ã¦ndre forfaldsdatoen skal du indtaste dit Brugernavn og adgangskode og Marker afkrydsningsfeltet nedenfor',0),(185383,5150,'ko','ê¸°í•œ ì¼ìžë¥¼ ë³€ê²½ í•˜ë ¤ë©´ ì‚¬ìš©ìž ì´ë¦„ ë° ì•”í˜¸ë¥¼ ìž…ë ¥ í•˜ ê³  ì•„ëž˜ ìƒìžë¥¼ í™•ì¸ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(185384,5150,'he','×›×“×™ ×œ×©× ×•×ª ××ª ×ª××¨×™×š ×”×™×¢×“ ×¢×œ×™×š ×œ×”×–×™×Ÿ ××ª ×©× ×”×ž×©×ª×ž×© ×•×”×¡×™×¡×ž×” ×•×œ××—×¨ ×¡×ž×Ÿ ××ª ×”×ª×™×‘×” ×©×œ×”×œ×Ÿ',0),(185385,5150,'el','Î“Î¹Î± Î½Î± Î±Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· ÎºÎ±Î¹ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÎºÎ±Î¹ Ï„Î¿ ÎºÎ¿Ï…Ï„Î¬ÎºÎ¹ ÎºÎ¬Ï„Ï‰',0),(185386,5150,'zh','ä¸ºäº†æ”¹å˜åœ¨åˆ°æœŸæ—¥ï¼Œä½ å¿…é¡»è¾“å…¥ä½ çš„ç”¨æˆ·åå’Œå¯†ç ï¼Œå‹¾é€‰ä¸‹é¢\r\n',0),(185387,5150,'sv','FÃ¶r att Ã¤ndra fÃ¶rfallodatumet mÃ¥ste du ange ditt anvÃ¤ndarnamn och lÃ¶senord och markera rutan nedan',0),(185388,5150,'it','Al fine di modificare la data di scadenza Ã¨ necessario inserire Username e Password e selezionare la casella qui sotto',0),(185389,5150,'tl','',0),(185390,5150,'th','In order to change the due date you must enter your Username and Password and check the box below',0),(185391,5150,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤ªà¤•à¥‹ à¤…à¤ªà¤¨à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤”à¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ à¤¬à¥‰',0),(185392,5150,'ms','Untuk menukar tarikh matang, anda mesti masukkan nama pengguna dan kata laluan dan semak kotak di bawah',0),(185393,5150,'ar','Ù„ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… ÙˆÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ ÙˆØ§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ù…Ø±Ø¨Ø¹ Ø£Ø¯Ù†Ø§Ù‡',0),(185394,5150,'fr','Afin de changer la date dâ€™Ã©chÃ©ance, vous devez entrer votre nom dâ€™utilisateur et mot de passe et cocher la case ci-dessous',0),(185395,5150,'jp','æœŸæ—¥ã‚’å¤‰æ›´ã?™ã‚‹ã?Ÿã‚?ã?«ã?¯ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?¨ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã?—ã?¦ä¸‹ã?®ãƒœãƒƒã‚¯ã‚¹ã‚’ãƒ?ã‚§ãƒƒã‚¯ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(185396,5150,'pt','Para alterar a data de vencimento deverÃ¡ digitar seu nome de usuÃ¡rio e senha e marque a caixa abaixo',0),(185397,5150,'ru','Ð”Ð»Ñ Ñ‚Ð¾Ð³Ð¾ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑ€Ð¾Ðº Ð²Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð²Ð°ÑˆÐµ Ð¸Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð¸ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ñ„Ð»Ð°Ð¶Ð¾Ðº Ð½Ð¸Ð¶Ðµ',0),(185398,5150,'es','Para cambiar la fecha de vencimiento, debe ingresar su nombre de usuario y clave y tachar el cajoncito abajo',0),(185399,5150,'de','Um das FÃ¤lligkeitsdatum Ã¤ndern mÃ¼ssen Sie geben Sie Ihren Benutzernamen und Ihr Kennwort, und aktivieren Sie das KontrollkÃ¤stchen',0),(185400,5150,'en','In order to change the due date you must enter your Username and Password and check the box below',0),(185401,5151,'is','',0),(185402,5151,'dr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(185403,5151,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(185404,5151,'tr','Orijinal son tarih',0),(185405,5151,'pl','Pierwotny termin',0),(185406,5151,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÐµÐ½ ÑÑ€Ð¾Ðº',0),(185407,5151,'ur','Ø§ØµÙ„ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ ØªØ§Ø±ÛŒØ®',0),(185408,5151,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(185409,5151,'vi','NgÃ y Ä‘áº¿n háº¡n gá»‘c',0),(185410,5151,'af','Oorspronklike Verskuldige Datum',0),(185411,5151,'ro','Data scadenÅ£ei original',0),(185412,5151,'et','Algne tÃ¤htaeg',0),(185413,5151,'si','Prvotni rok',0),(185414,5151,'ba','Asli tempo',0),(185415,5151,'nl','Oorspronkelijke vervaldatum',0),(185416,5151,'fi','AlkuperÃ¤inen erÃ¤pÃ¤ivÃ¤',0),(185417,5151,'no','Opprinnelig forfallsdato',0),(185418,5151,'da','Oprindelige forfaldsdato',0),(185419,5151,'ko','ì›ëž˜ ê¸°í•œ',0),(185420,5151,'he','×ª××¨×™×š ×”×™×¢×“ ×”×ž×§×•×¨×™',0),(185421,5151,'el','Î‘ÏÏ‡Î¹ÎºÎ® Î—Î¼/Î½Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(185422,5151,'zh','åŽŸåˆ°æœŸæ—¥\r\n',0),(185423,5151,'sv','Ursprungliga fÃ¶rfallodatum',0),(185424,5151,'it','Data di scadenza originale',0),(185425,5151,'tl','',0),(185426,5151,'th','&#3623;&#3633;&#3609;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;&#3604;&#3633;&#3657;&#3591;&#3648;&#3604;&#3636;&#3617;',0),(185427,5151,'hi','à¤®à¥‚à¤² à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(185428,5151,'ms','Tarikh asal',0),(185429,5151,'ar','ØªØ§Ø±ÙŠØ® \"Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø§Ù„Ø£ØµÙ„ÙŠ\"',0),(185430,5151,'fr','Date d\'Ã©chÃ©ance originale',0),(185431,5151,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«æœŸæ—¥',0),(185432,5151,'pt','Data de vencimento original',0),(185433,5151,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð”Ð°Ñ‚Ð°',0),(185434,5151,'es','Fecha de Vencimiento Original',0),(185435,5151,'de','UrsprÃ¼nglichen FÃ¤lligkeitsdatum',0),(185436,5151,'en','Original Due date',0),(185437,5152,'is','',0),(185438,5152,'dr','Ø¨Ø§ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§Ø¨Øª Ø§ÙŠÙ† ØªØºÙŠÙŠØ± ØªÙ…Ø§Ø³ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(185439,5152,'pr','Ø¨Ø§ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§Ø¨Øª Ø§ÙŠÙ† ØªØºÙŠÙŠØ± ØªÙ…Ø§Ø³ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(185440,5152,'tr','MÃ¼ÅŸteri bu deÄŸiÅŸiklik hakkÄ±nda temasa geÃ§ti',0),(185441,5152,'pl','klient zostaÅ‚ nawiÄ…zany o tej zmianie',0),(185442,5152,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑŠÑ‚ Ðµ Ð±Ð¸Ð» Ñ‚ÑŠÑ€ÑÐµÐ½ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(185443,5152,'ur','Ú¯Ø§ÛÚ© Ø§Ø³ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Û’ Ø¨Ø§Ø±Û’ Ù…ÛŒÚº Ø±Ø§Ø¨Ø·Û Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(185444,5152,'sr','ÐšÑƒÐ¿Ð°Ñ† Ñ˜Ðµ Ð±Ð¸Ð¾ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð¾ Ð¾ Ð¾Ð²Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(185445,5152,'vi','khÃ¡ch hÃ ng Ä‘Ã£ Ä‘Æ°á»£c thÃ´ng bÃ¡o vá» thay Ä‘á»•i nÃ y',0),(185446,5152,'af','die klant/kliÃ«nt is gekontak omtrent die veranderinge',0),(185447,5152,'ro','Clientul a fost contactat despre aceastÄƒ schimbare',0),(185448,5152,'et','klient on Ã¼hendust sÃµnagi see muutus',0),(185449,5152,'si','stranka ima stik o tej spremembi',0),(185450,5152,'ba','Pelanggan telah dihubungi mengenai perubahan ini',0),(185451,5152,'nl','de klant is benaderd over deze wijziging',0),(185452,5152,'fi','asiakas on ottanut yhteyttÃ¤ tÃ¤stÃ¤ muutoksesta',0),(185453,5152,'no','kunden har blitt kontaktet om denne endringen',0),(185454,5152,'da','kunden har kontaktet om denne Ã¦ndring',0),(185455,5152,'ko','ê³ ê°ì—ì´ ë³€í™”ì— ëŒ€ í•œ ë¬¸ì˜',0),(185456,5152,'he','× ×•×¦×¨ ×§×©×¨ ×¢× ×”×œ×§×•×— ×¢×œ ×”×©×™× ×•×™ ×”×–×”',0),(185457,5152,'el','Î¿ Ï€ÎµÎ»Î¬Ï„Î·Ï‚ Î­Ï‡ÎµÎ¹ Î­ÏÎ¸ÎµÎ¹ ÏƒÎµ ÎµÏ€Î±Ï†Î® Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î·Î½ Î±Î»Î»Î±Î³Î®',0),(185458,5152,'zh','å…³äºŽè¿™ä¸ªå˜åŒ–å·²è”ç³»å®¢æˆ·\r\n',0),(185459,5152,'sv','kunden har kontaktats om denna fÃ¶rÃ¤ndring',0),(185460,5152,'it','il cliente Ã¨ stato contattato circa questo cambiamento',0),(185461,5152,'tl','',0),(185462,5152,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3609;&#3637;&#3657;',0),(185463,5152,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤‡à¤¸ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥‡ à¤¬à¤¾à¤°à¥‡ à¤®à¥‡à¤‚ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(185464,5152,'ms','Pelanggan telah dihubungi mengenai perubahan ini',0),(185465,5152,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø§Ù„Ø§ØªØµØ§Ù„ Ø¨Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø­ÙˆÙ„ Ù‡Ø°Ø§ Ø§Ù„ØªØºÙŠÙŠØ±',0),(185466,5152,'fr','le client a Ã©tÃ© contactÃ© sur cette modification',0),(185467,5152,'jp','ã?“ã?®å¤‰æ›´ã?«ã?¤ã?„ã?¦ã?Šå®¢æ§˜ã?¸é€£çµ¡ã‚’ã?¨ã?£ã?¦ã?„ã?¾ã?™',0),(185468,5152,'pt','o cliente foi contactado sobre esta mudanÃ§a',0),(185469,5152,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÑÐ²ÑÐ·Ð°Ð»ÑÑ Ð¾Ð± ÑÑ‚Ð¾Ð¼ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¸',0),(185470,5152,'es','Se contactÃ³ el cliente sobre este cambio',0),(185471,5152,'de','der Kunde hat diese Ã„nderung kontaktiert worden',0),(185472,5152,'en','the customer has been contacted about this change',0),(185473,5153,'is','',0),(185474,5153,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ù‡Ø§ â€“ Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯Ù‡ ',0),(185475,5153,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ù‚ÙŠÙ…Øª Ù‡Ø§ â€“ Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯Ù‡ ',0),(185476,5153,'tr','FiyatlarÄ± - gÃ¼ncelleÅŸtirmede hata hiÃ§bir eylem',0),(185477,5153,'pl','BÅ‚Ä…d podczas aktualizowania ceny - Å¼adne z dziaÅ‚aÅ„ podejmowanych',0),(185478,5153,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¸ - Ð½Ðµ Ðµ Ð¿Ñ€ÐµÐ´Ð¿Ñ€Ð¸ÐµÑ‚Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(185479,5153,'ur','Ù‚ÛŒÙ…ØªÛŒÚº - ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ Ú©ÙˆØ¦ÛŒ Ø§ÛŒÚ©Ø´Ù† Ù„Û’ Ù„ÛŒØ§',0),(185480,5153,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ†ÐµÐ½Ðµ - Ð½Ð¸ÐºÐ°ÐºÐ²Ð¸Ñ… Ð°ÐºÑ†Ð¸Ñ˜Ð°',0),(185481,5153,'vi','Lá»—i cáº­p nháº­t giÃ¡ - khÃ´ng hÃ nh Ä‘á»™ng',0),(185482,5153,'af','Fout bywerking pryse - geen aksie geneem',0),(185483,5153,'ro','Eroare la actualizarea preÅ£urilor - nu mÄƒsurile luate',0),(185484,5153,'et','Viga ajakohastamine hindadega - midagi ei tehtud',0),(185485,5153,'si','Napaka pri posodabljanju cene - noben ukrep',0),(185486,5153,'ba','Kesalahan memperbarui harga - tidak ada tindakan yang diambil',0),(185487,5153,'nl','Fout bij het bijwerken van de prijzen - geen maatregelen',0),(185488,5153,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ hinnat - toteutetut',0),(185489,5153,'no','Feil under oppdatering priser - ingen tiltak',0),(185490,5153,'da','Fejl under opdatering af priser - ingen tiltag',0),(185491,5153,'ko','ê°€ê²©-ì—…ë°ì´íŠ¸ ì˜¤ë¥˜ ì¡°ì¹˜ê°€ ì·¨í•´ ì§€ì§€ ì•Šì€',0),(185492,5153,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×ž×—×™×¨×™× - ×œ×œ× × ×§×™×˜×ª',0),(185493,5153,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Ï„Î¹Î¼ÏŽÎ½ - ÎºÎ±Î¼Î¯Î± ÎµÎ½Î­ÏÎ³ÎµÎ¹Î±',0),(185494,5153,'zh','é”™è¯¯æ›´æ–°ä»·æ ¼ -ä¸é‡‡å–ä»»ä½•æ“ä½œ\r\n',0),(185495,5153,'sv','Gick inte att uppdatera priser - inga Ã¥tgÃ¤rder som vidtas',0),(185496,5153,'it','Errore di aggiornamento prezzi - nessuna azione intrapresa',0),(185497,5153,'tl','',0),(185498,5153,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3588;&#3634; - &#3652;&#3617;&#3656;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(185499,5153,'hi','à¤•à¥€à¤®à¤¤à¥‡à¤‚ - à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹à¤ˆ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¨à¤¹à¥€à¤‚ à¤²à¤¿à¤¯à¤¾',0),(185500,5153,'ms','Ralat dalam mengemas kini harga - tiada tindakan yang diambil',0),(185501,5153,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£Ø³Ø¹Ø§Ø±-ÙŠØªØ®Ø° Ø£ÙŠ Ø¥Ø¬Ø±Ø§Ø¡',0),(185502,5153,'fr','Erreur mise Ã  jour prix - aucune Action entreprise',0),(185503,5153,'jp','ä¾¡æ ¼ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼ãƒ¼ä½•ã‚‚å®Ÿè¡Œã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(185504,5153,'pt','Erro na atualizaÃ§Ã£o de preÃ§os - nÃ£o acÃ§Ã£o',0),(185505,5153,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½ - Ð½Ðµ Ð¿Ñ€Ð¸Ð½ÑÑ‚Ñ‹Ðµ',0),(185506,5153,'es','Error actualizando precios - No se tomÃ³ ninguna acciÃ³n',0),(185507,5153,'de','Fehler beim Aktualisieren der Preise - keine Aktion ausgefÃ¼hrt',0),(185508,5153,'en','Error Updating Prices - No Action Taken',0),(185509,5154,'is','',0),(185510,5154,'dr','(Ù‚Ù„Ù… Ø®ÙˆØ±Ø¯Ù‡) ØªÙˆØ³Ø·',0),(185511,5154,'pr','Ù„ØºÙˆ Ø´Ø¯Ù‡(Ù‚Ù„Ù… Ø®ÙˆØ±Ø¯Ù‡) ØªÙˆØ³Ø·',0),(185512,5154,'tr','TarafÄ±ndan iptal edildi',0),(185513,5154,'pl','Anulowane przez',0),(185514,5154,'bg','ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ð° Ð¾Ñ‚',0),(185515,5154,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(185516,5154,'sr','ÐžÑ‚ÐºÐ°Ð·Ð°Ð¾',0),(185517,5154,'vi','XÃ³a bá»Ÿi',0),(185518,5154,'af','Gekanseleer deur',0),(185519,5154,'ro','Anulat de',0),(185520,5154,'et','Vaikimisi',0),(185521,5154,'si','Preklical',0),(185522,5154,'ba','Dibatalkan oleh',0),(185523,5154,'nl','Geannuleerd door',0),(185524,5154,'fi','Peruuttaa',0),(185525,5154,'no','Avbrutt av',0),(185526,5154,'da','Annulleret af',0),(185527,5154,'ko','ì˜í•´ ì·¨ì†Œ',0),(185528,5154,'he','×‘×•×˜×œ×” ×¢×œ-×™×“×™',0),(185529,5154,'el','Î‘ÎºÏ…ÏÏ‰Î¸ÎµÎ¯ Î±Ï€ÏŒ',0),(185530,5154,'zh','å–æ¶ˆäº†\r\n',0),(185531,5154,'sv','Ã…terkallas av',0),(185532,5154,'it','Annullato da',0),(185533,5154,'tl','',0),(185534,5154,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3650;&#3604;&#3618;',0),(185535,5154,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(185536,5154,'ms','Dibatalkan oleh',0),(185537,5154,'ar','Ø¥Ù„ØºØ§Ø¡ Ù…Ù† Ù‚Ø¨Ù„',0),(185538,5154,'fr','AnnulÃ© par',0),(185539,5154,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«è€…',0),(185540,5154,'pt','Cancelada pelo',0),(185541,5154,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¾',0),(185542,5154,'es','Cancelado por',0),(185543,5154,'de','Vom abgebrochen',0),(185544,5154,'en','Cancelled by',0),(185545,5155,'is','',0),(185546,5155,'dr','Ø´Ù…Ø§ Ø§Ø¬Ø§Ø²Ù‡  ÙˆÙŠØ±Ø§ÙŠØ´ Ù‚Ø³Ù…Øª  Ø±Ø§Ù‡Ù†Ù…Ø§ Ø±Ø§ Ù†Ø¯Ø§Ø±ÙŠØ¯',0),(185547,5155,'pr','Ø´Ù…Ø§ Ø§Ø¬Ø§Ø²Ù‡  ÙˆÙŠØ±Ø§ÙŠØ´ Ù‚Ø³Ù…Øª  Ø±Ø§Ù‡Ù†Ù…Ø§ Ø±Ø§ Ù†Ø¯Ø§Ø±ÙŠØ¯',0),(185548,5155,'tr','YardÄ±m dÃ¼zenlemek iÃ§in izniniz yok',0),(185549,5155,'pl','Nie masz uprawnieÅ„ do edytowania pomoc',0),(185550,5155,'bg','ÐÑÐ¼Ð°Ñ‚Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(185551,5155,'ur','Ø¢Ù¾ Ú©Ùˆ Ù…Ø¯Ø¯ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº',0),(185552,5155,'sr','ÐÐµÐ¼Ð°Ñ‚Ðµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ñƒ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾Ð¼Ð¾Ñ›',0),(185553,5155,'vi','Báº¡n khÃ´ng Ä‘Æ°á»£c cáº¥p quyá»n chá»‰nh sá»­a trá»£ giÃºp',0),(185554,5155,'af','U het nie TOESTEMMING om die HULP te redigeer nie.',0),(185555,5155,'ro','Nu aveÅ£i permisiunea de a edita HELP',0),(185556,5155,'et','Teil ei ole Ãµigusi abifailide muutmiseks',0),(185557,5155,'si','Nimate dovoljenja za urejanje pomoÄ',0),(185558,5155,'ba','Anda tidak memiliki izin untuk mengedit bantuan',0),(185559,5155,'nl','U bent niet gemachtigd voor het bewerken van help',0),(185560,5155,'fi','Sinulla ei ole oikeuksia muokata ohje',0),(185561,5155,'no','Du har ikke tillatelse til Ã¥ redigere hjelp',0),(185562,5155,'da','Du har ikke tilladelse til at redigere hjÃ¦lp',0),(185563,5155,'ko','ë‹¹ì‹ ì€ ê¶Œí•œì´ ì—†ëŠ” ë„ì›€ë§ì„ íŽ¸ì§‘ í•˜ë ¤ë©´',0),(185564,5155,'he','××™×Ÿ ×œ×š ×”×¨×©××•×ª ×œ×¢×¨×•×š ××ª ×”×¢×–×¨×”',0),(185565,5155,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î²Î¿Î®Î¸ÎµÎ¹Î±',0),(185566,5155,'zh','æ‚¨æ²¡æœ‰æƒé™ç¼–è¾‘å¸®åŠ©\r\n',0),(185567,5155,'sv','Du har inte behÃ¶righet att redigera hjÃ¤lp',0),(185568,5155,'it','Non hai il permesso di modificare la guida',0),(185569,5155,'tl','',0),(185570,5155,'th','&#3588;&#3640;&#3603;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3618;&#3636;&#3609;&#3618;&#3629;&#3617;&#3651;&#3627;&#3657;&#3649;&#3585;&#3657;&#3652;&#3586;&#3605;&#3633;&#3623;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3',0),(185571,5155,'hi','à¤†à¤ª à¤®à¤¦à¤¦ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(185572,5155,'ms','Anda tidak mempunyai keizinan untuk mengedit bantuan',0),(185573,5155,'ar','Ù„ÙŠØ³ Ù„Ø¯ÙŠÙƒ Ø§Ù„Ø¥Ø°Ù† Ø¨ØªØ­Ø±ÙŠØ± ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(185574,5155,'fr','Vous n\'Ãªtes pas autorisÃ© Ã  modifier l\'aide',0),(185575,5155,'jp','ãƒ˜ãƒ«ãƒ—ã‚’ç·¨é›†ã?™ã‚‹è¨±å?¯ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(185576,5155,'pt','VocÃª nÃ£o tem permissÃ£o para editar ajuda',0),(185577,5155,'ru','Ð’Ñ‹ Ð½Ðµ Ð¸Ð¼ÐµÑŽÑ‚ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð½Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸',0),(185578,5155,'es','No tiene permiso para editar la ayuda',0),(185579,5155,'de','Sie haben keine Berechtigung um Hilfe zu bearbeiten',0),(185580,5155,'en','You do not have permission to edit help',0),(185581,5156,'is','',0),(185582,5156,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ØµÙØ­Ø§Øª Ø±Ø§Ù‡Ù†Ù…Ø§ ',0),(185583,5156,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ØµÙØ­Ø§Øª Ø±Ø§Ù‡Ù†Ù…Ø§ ',0),(185584,5156,'tr','YardÄ±m SayfalarÄ± DÃ¼zenle',0),(185585,5156,'pl','Edycja stron pomocy',0),(185586,5156,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰Ð½Ð¸Ñ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(185587,5156,'ur','Ù…Ø¯Ø¯ ØµÙØ­Ø§Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(185588,5156,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð·Ð° Ð¿Ð¾Ð¼Ð¾Ñ›',0),(185589,5156,'vi','Sá»­a Trang Trá»£ GiÃºp',0),(185590,5156,'af','Redigeer Hulp Bladsye',0),(185591,5156,'ro','Editeaza paginile de ajutor',0),(185592,5156,'et','Muuda Abilehti',0),(185593,5156,'si','Urejanje strani pomoÄi',0),(185594,5156,'ba','Mengedit halaman bantuan',0),(185595,5156,'nl','Help pagina\'s bewerken',0),(185596,5156,'fi','Muokkaa ohjesivut',0),(185597,5156,'no','Redigere hjelpesider',0),(185598,5156,'da','Redigere hjÃ¦lpesider',0),(185599,5156,'ko','ë„ì›€ë§ íŽ˜ì´ì§€ë¥¼ íŽ¸ì§‘',0),(185600,5156,'he','×¢×¨×•×š ×“×¤×™ ×¢×–×¨×”',0),(185601,5156,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ ÏƒÎµÎ»Î¯Î´ÎµÏ‚ Î²Î¿Î®Î¸ÎµÎ¹Î±Ï‚',0),(185602,5156,'zh','ç¼–è¾‘å¸®åŠ©é¡µé¢\r\n',0),(185603,5156,'sv','Redigera hjÃ¤lpsidor',0),(185604,5156,'it','Modificare le pagine di aiuto',0),(185605,5156,'tl','',0),(185606,5156,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3627;&#3609;&#3657;&#3634;&#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(185607,5156,'hi','à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(185608,5156,'ms','Menyunting laman bantuan',0),(185609,5156,'ar','ØªØ­Ø±ÙŠØ± ØµÙØ­Ø§Øª Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(185610,5156,'fr','Modifier les Pages d\'aide',0),(185611,5156,'jp','ãƒ˜ãƒ«ãƒ—ãƒšãƒ¼ã‚¸ã?®ç·¨é›†',0),(185612,5156,'pt','Editar pÃ¡ginas de ajuda',0),(185613,5156,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ ÐŸÐ¾Ð¼Ð¾Ñ‰Ð¸',0),(185614,5156,'es','Editar PÃ¡ginas de Ayudo',0),(185615,5156,'de','Hilfeseiten bearbeiten',0),(185616,5156,'en','Edit Help Pages',0),(185617,5157,'is','',0),(185618,5157,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†',0),(185619,5157,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ',0),(185620,5157,'tr','YardÄ±mcÄ± Ekle/GÃ¼ncelle',0),(185621,5157,'pl','Pomoc Dodaj/Aktualizuj',0),(185622,5157,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰Ñ‚Ð°',0),(185623,5157,'ur','Ù…Ø¯Ø¯ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(185624,5157,'sr','ÐŸÐ¾Ð¼Ð¾Ñ›/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(185625,5157,'vi','ThÃªm/Cáº­p Nháº­t Trá»£ GiÃºp',0),(185626,5157,'af','Hulp Byvoeg/Opdateer',0),(185627,5157,'ro','Ajutor Adauga/Actualizeaza',0),(185628,5157,'et','Abi lisamine/uuendamine',0),(185629,5157,'si','PomoÄjo Dodaj/posodobi',0),(185630,5157,'ba','Bantuan Tambahkan/Perbarui',0),(185631,5157,'nl','Help toevoegen/bijwerken',0),(185632,5157,'fi','Apua lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(185633,5157,'no','Hjelp/Oppdater',0),(185634,5157,'da','HjÃ¦lp TilfÃ¸j/opdater',0),(185635,5157,'ko','ë„ì›€ë§ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(185636,5157,'he','×”×•×¡×¤×”/×¢×“×›×•×Ÿ ×©×œ ×”×¢×–×¨×”',0),(185637,5157,'el','Î’Î¿Î®Î¸ÎµÎ¹Î±-Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(185638,5157,'zh','å¸®åŠ©æ–°å¢ž/æ›´æ–°\r\n',0),(185639,5157,'sv','HjÃ¤lp LÃ¤gg till/uppdatera',0),(185640,5157,'it','Aiuto aggiungere/aggiornare',0),(185641,5157,'tl','',0),(185642,5157,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(185643,5157,'hi','à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(185644,5157,'ms','Bantuan Tambah/Kemaskini',0),(185645,5157,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø©',0),(185646,5157,'fr','Aide ajouter/mettre Ã  jour',0),(185647,5157,'jp','ãƒ˜ãƒ«ãƒ—ã€€è¿½åŠ /æ›´æ–°',0),(185648,5157,'pt','Ajuda adicionar/atualizar',0),(185649,5157,'ru','ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(185650,5157,'es','Ayuda Agregar/Actualizar',0),(185651,5157,'de','Hilfe hinzufÃ¼gen/aktualisieren',0),(185652,5157,'en','Help Add/Update',0),(185653,5158,'is','',0),(185654,5158,'dr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¬Ù‡Øª Ù†Ù…Ø§ÙŠØ´ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(185655,5158,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¬Ù‡Øª Ù†Ù…Ø§ÙŠØ´ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(185656,5158,'tr','GÃ¶rÃ¼ntÃ¼lenecek bir hareket',0),(185657,5158,'pl','Tam jest brak aktywnoÅ›ci do wyÅ›wietlania',0),(185658,5158,'bg','ÐÑÐ¼Ð° Ð½Ð¸ÐºÐ°ÐºÐ²Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð·Ð°',0),(185659,5158,'ur','Ú©Û’ Ù„Ø¦Û’ Ø¯Ú©Ú¾Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ ÛÛ’ Û”',0),(185660,5158,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð·Ð°',0),(185661,5158,'vi','KhÃ´ng cÃ³ hoáº¡t Ä‘á»™ng Ä‘á»ƒ hiá»‡n thá»‹ cho',0),(185662,5158,'af','Daar is geen aktiwiteit om aan te toon vir',0),(185663,5158,'ro','Nu existÄƒ nici o activitate pentru a afiÅŸa pentru',0),(185664,5158,'et','Pole tegevust, mida kuvada:',0),(185665,5158,'si','Ni dejavnost za prikaz za',0),(185666,5158,'ba','Ada tidak ada kegiatan untuk menampilkan untuk',0),(185667,5158,'nl','Er is geen activiteit weer te geven voor',0),(185668,5158,'fi','Ei toimintaa nÃ¤yttÃ¤Ã¤',0),(185669,5158,'no','Er Ã¥ vise for',0),(185670,5158,'da','Der er ingen aktivitet skal vises for',0),(185671,5158,'ko','ëŒ€ í•œ ì•„ë¬´ëŸ° í™œë™ì´',0),(185672,5158,'he','××™×Ÿ ×¤×¢×™×œ×•×ª ×©×™×•×¦×’×• ×¢×‘×•×¨',0),(185673,5158,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÎºÎ±Î¼Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± ÎµÎ¼Ï†Î±Î½Î¯Î¶Ï‰ Î³Î¹Î±',0),(185674,5158,'zh','æ²¡æœ‰ä»»ä½•æ´»åŠ¨ä»¥æ˜¾ç¤º\r\n',0),(185675,5158,'sv','Det finns ingen aktivitet ska visas fÃ¶r',0),(185676,5158,'it','Non non c\'Ã¨ nessuna attivitÃ  per visualizzare per',0),(185677,5158,'tl','',0),(185678,5158,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3649;&#3626;&#3604;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(185679,5158,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(185680,5158,'ms','Terdapat tiada aktiviti untuk memaparkan bagi',0),(185681,5158,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø£ÙŠ Ù†Ø´Ø§Ø· Ù„Ø¹Ø±Ø¶',0),(185682,5158,'fr','Il n\'y a aucune activitÃ© Ã  afficher pour',0),(185683,5158,'jp','ï½žã?®è¡¨ç¤ºã?™ã‚‹æ´»å‹•ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(185684,5158,'pt','NÃ£o hÃ¡ nenhuma atividade para exibir',0),(185685,5158,'ru','ÐÐµÑ‚ Ð½Ð¸ÐºÐ°ÐºÐ¸Ñ… Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹ Ð´Ð»Ñ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(185686,5158,'es','No hay actividad para desplegar para',0),(185687,5158,'de','Es gibt keine AktivitÃ¤t fÃ¼r anzeigen',0),(185688,5158,'en','There is no activity to display for',0),(185689,5159,'is','',0),(185690,5159,'dr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØª Ø³ÙØ§Ø±Ø´ÙŠ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(185691,5159,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØª Ø³ÙØ§Ø±Ø´ÙŠ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù‡ Ø¬Ø§Ø±ÙŠ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(185692,5159,'tr','GeÃ§erli ay iÃ§in hiÃ§bir sipariÅŸ etkinlik vardÄ±r.',0),(185693,5159,'pl','Tam jest brak aktywnoÅ›ci zamÃ³wienia dla bieÅ¼Ä…cego miesiÄ…ca.',0),(185694,5159,'bg','ÐÑÐ¼Ð° Ð½Ð¸ÐºÐ°ÐºÐ²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° Ñ‚ÐµÐºÑƒÑ‰Ð¸Ñ Ð¼ÐµÑÐµÑ†.',0),(185695,5159,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ù…ÛÛŒÙ†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ø­Ú©Ù… Ø³Ø±Ú¯Ø±Ù…ÛŒ ÛÛ’ Û”',0),(185696,5159,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð±ÐµÐ· Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ñ‚ÐµÐºÑƒÑ›Ð¸ Ð¼ÐµÑÐµÑ†.',0),(185697,5159,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n hÃ ng trong thÃ¡ng nÃ y',0),(185698,5159,'af','Daar is geen bestellingsaktiwiteit vir die huidige maand.',0),(185699,5159,'ro','Nu existÄƒ nici o activitate de ordine pentru luna curentÄƒ.',0),(185700,5159,'et','Jooksva kuu on selleks tegevuseks.',0),(185701,5159,'si','Ni nobene dejavnosti nalog za tekoÄi mesec.',0),(185702,5159,'ba','Ada tidak ada urutan kegiatan untuk bulan ini.',0),(185703,5159,'nl','Er is geen volgorde activiteit voor de huidige maand.',0),(185704,5159,'fi','Nykyinen kuukausi ei ole jÃ¤rjestyksessÃ¤ toimintaa.',0),(185705,5159,'no','Det er ingen rekkefÃ¸lge aktivitet for gjeldende mÃ¥ned.',0),(185706,5159,'da','Der er ingen orden aktivitet for den aktuelle mÃ¥ned.',0),(185707,5159,'ko','í˜„ìž¬ ë‹¬ì— ëŒ€ í•œ ì•„ë¬´ ì£¼ë¬¸ í™œë™ì´ìž…ë‹ˆë‹¤.',0),(185708,5159,'he','×™×© ××™×Ÿ ×¤×¢×™×œ×•×ª ×”×–×ž× ×” ×¢×‘×•×¨ ×”×—×•×“×© ×”× ×•×›×—×™.',0),(185709,5159,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÎºÎ±Î¼Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î³Î¹Î± Ï„Î¿Î½ Ï„ÏÎ­Ï‡Î¿Î½Ï„Î± Î¼Î®Î½Î±.',0),(185710,5159,'zh','æ²¡æœ‰å½“æœˆè®¢å•æ´»åŠ¨ã€‚\r\n',0),(185711,5159,'sv','Det finns ingen ordning aktivitet fÃ¶r den aktuella mÃ¥naden.',0),(185712,5159,'it','Non non c\'Ã¨ nessuna attivitÃ  di ordine per il mese corrente.',0),(185713,5159,'tl','',0),(185714,5159,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3648;&#3604;&#3639;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(185715,5159,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(185716,5159,'ms','Terdapat tiada aktiviti perintah untuk bulan semasa.',0),(185717,5159,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø£ÙŠ Ù†Ø´Ø§Ø· Ø§Ù„Ù†Ø¸Ø§Ù… ÙÙŠ Ø§Ù„Ø´Ù‡Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ.',0),(185718,5159,'fr','Il n\'y a aucune activitÃ© d\'ordre pour le mois en cours.',0),(185719,5159,'jp','ä»Šæœˆã?¯æ³¨æ–‡æ´»å‹•ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(185720,5159,'pt','NÃ£o hÃ¡ nenhuma atividade de ordem para o mÃªs atual.',0),(185721,5159,'ru','ÐÐµÑ‚ Ð½Ðµ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ñ‚ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð¼ÐµÑÑÑ†.',0),(185722,5159,'es','No hay actividad de ordenes para el mes actual',0),(185723,5159,'de','Es gibt keine Reihenfolge-AktivitÃ¤t fÃ¼r den aktuellen Monat.',0),(185724,5159,'en','There is no order activity for the current month.',0),(185725,5160,'is','',0),(185726,5160,'dr','(Ø¨Ø±Ø±Ø³ÙŠ ) Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(185727,5160,'pr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ØªØµÙÙŠÙ‡ (Ø¨Ø±Ø±Ø³ÙŠ ) Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(185728,5160,'tr','Bu sÄ±rada kontrol',0),(185729,5160,'pl','Ten porzÄ…dek zostaÅ‚ wyewidencjonowany',0),(185730,5160,'bg','Ð¢Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ðµ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(185731,5160,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ø®Ø§Ø±Ø¬ Ú©Ø± Ø¯ÛŒ ÛÛ’',0),(185732,5160,'sr','ÐžÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ð° Ñ˜Ðµ Ð¾Ð´Ñ˜Ð°Ð²Ñ™ÐµÐ½',0),(185733,5160,'vi','ÄÆ¡n hÃ ng nÃ y Ä‘Ã£ bá»‹ bá» ra',0),(185734,5160,'af','Hierdie orde het gekontroleer is',0),(185735,5160,'ro','Acest ordin a fost verificat',0),(185736,5160,'et','Selles jÃ¤rjekorras vÃ¤lja mÃ¶llitud',0),(185737,5160,'si','Ta naloga je bila rezervirana',0),(185738,5160,'ba','Urutan ini telah memeriksa',0),(185739,5160,'nl','Deze bestelling is uitgecheckt',0),(185740,5160,'fi','TÃ¤mÃ¤ tilaus on kuitattu ulos',0),(185741,5160,'no','Denne rekkefÃ¸lgen er sjekket ut',0),(185742,5160,'da','Denne ordre er blevet tjekket ud',0),(185743,5160,'ko','ì´ ìˆœì„œëŠ” ì²´í¬ ì•„ì›ƒ',0),(185744,5160,'he','×¦×• ×–×” ×”×•×¦×',0),(185745,5160,'el','Î‘Ï…Ï„Î® Î· ÏƒÎµÎ¹ÏÎ¬ Î­Ï‡ÎµÎ¹ ÎµÎ»ÎµÎ³Ï‡Î¸ÎµÎ¯',0),(185746,5160,'zh','æ­¤è®¢å•å·²ç­¾å‡º\r\n',0),(185747,5160,'sv','Denna ordning har checkats ut',0),(185748,5160,'it','Questo ordine Ã¨ stato controllato',0),(185749,5160,'tl','',0),(185750,5160,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;&#3649;&#3592;&#3657;&#3591;&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3621;&#3657;&#3623;',0),(185751,5160,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤œà¤¾à¤à¤š à¤²à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(185752,5160,'ms','Perintah ini telah menyemak',0),(185753,5160,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø³Ø­Ø¨ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(185754,5160,'fr','Cette ordonnance a Ã©tÃ© extrait',0),(185755,5160,'jp','ã?“ã?®æ³¨æ–‡ã?¯ãƒ?ã‚§ãƒƒã‚¯ã‚¢ã‚¦ãƒˆã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(185756,5160,'pt','Esta ordem tem sido Check-Out',0),(185757,5160,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð±Ñ‹Ð» Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(185758,5160,'es','Este Orden se SacÃ³ en PrÃ©stamo',0),(185759,5160,'de','Dieser Auftrag hat ausgecheckt',0),(185760,5160,'en','This Order Has Been Checked Out',0),(185761,5161,'is','',0),(185762,5161,'dr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ù¾Ø± Ù…ÙŠ Ø´ÙˆØ¯',0),(185763,5161,'pr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ù¾Ø± Ù…ÙŠ Ø´ÙˆØ¯',0),(185764,5161,'tr','Bu emir icra edilir',0),(185765,5161,'pl','Ta kolejnoÅ›Ä‡ jest sÄ… wypeÅ‚nione',0),(185766,5161,'bg','Ð¢Ð¾Ð·Ð¸ Ñ€ÐµÐ´ ÑÐµ Ð¿Ð¾Ð¿ÑŠÐ»Ð²Ð°',0),(185767,5161,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ù…ÛŒÚº Ø¨Ú¾Ø±ÛŒ ÛÙˆØ¦ÛŒ Ø¬Ø§ Ø±ÛÛŒ ÛÛ’',0),(185768,5161,'sr','ÐžÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ð° Ñ˜Ðµ Ð´Ð° ÑÐµ Ð¿Ð¾Ð¿ÑƒÐ½Ð¸',0),(185769,5161,'vi','ÄÆ¡n hÃ ng nÃ y Ä‘Ã£ Ä‘iá»n vÃ o',0),(185770,5161,'af','Hierdie orde Is gevul word',0),(185771,5161,'ro','Acest ordin este fiind umplut',0),(185772,5161,'et','Tellimus tÃ¤idetakse',0),(185773,5161,'si','Ta naloga se izpolni',0),(185774,5161,'ba','Urutan ini sedang diisi',0),(185775,5161,'nl','Deze volgorde wordt gevuld',0),(185776,5161,'fi','TÃ¤mÃ¤ tilaus on tÃ¤ytetty',0),(185777,5161,'no','Denne rekkefÃ¸lgen fylles',0),(185778,5161,'da','Denne orden er at vÃ¦re fyldt',0),(185779,5161,'ko','ì´ ìˆœì„œëŠ” ì¶©ë§Œ',0),(185780,5161,'he','×¦×• ×–×” ×œ×”×™×•×ª ×ž×œ×',0),(185781,5161,'el','Î‘Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬ ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÎ½ÎµÏ„Î±Î¹',0),(185782,5161,'zh','è¿™ç§è®¢å•æ­£å¡«å……\r\n',0),(185783,5161,'sv','Denna ordning Ã¤r fylld',0),(185784,5161,'it','Questo ordine viene riempito',0),(185785,5161,'tl','',0),(185786,5161,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3636;&#3657;&#3629;&#3609;&#3637;&#3657;&#3585;&#3619;&#3629;&#3585;&#3649;&#3621;&#3657;&#3623;',0),(185787,5161,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤¸à¥‡ à¤­à¤°à¤¾ à¤œà¤¾ à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(185788,5161,'ms','Perintah ini telah dipenuhi',0),(185789,5161,'ar','ÙŠØ´ØºÙ„ Ù‡Ø°Ø§ Ø§Ù„Ø£Ù…Ø±',0),(185790,5161,'fr','Cet ordre est pourvoir',0),(185791,5161,'jp','ã?“ã?®æ³¨æ–‡ã?¯è¨˜å…¥ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(185792,5161,'pt','Esta ordem estÃ¡ sendo preenchida.',0),(185793,5161,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¾Ñ€Ð´ÐµÑ€',0),(185794,5161,'es','Este Orden se Cumple',0),(185795,5161,'de','Diese Reihenfolge wird abgefÃ¼llt',0),(185796,5161,'en','This Order Is Being Filled',0),(185797,5162,'is','',0),(185798,5162,'dr','Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(185799,5162,'pr','Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(185800,5162,'tr','MÃ¼ÅŸteri teklif',0),(185801,5162,'pl','Cytat klienta',0),(185802,5162,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(185803,5162,'ur','Ú©Ø³Ù¹Ù…Ø± Ø§Ù‚ØªØ¨Ø§Ø³',0),(185804,5162,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ðµ Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(185805,5162,'vi','BÃ¡o giÃ¡ khÃ¡ch hÃ ng',0),(185806,5162,'af','KliÃ«nt/Klant Kwotasie',0),(185807,5162,'ro','Citat de client',0),(185808,5162,'et','Kliendi Quote',0),(185809,5162,'si','Ponudba kupcu',0),(185810,5162,'ba','Pelanggan Quote',0),(185811,5162,'nl','Klant offerte',0),(185812,5162,'fi','Asiakkaalta kuultua',0),(185813,5162,'no','Kunden tilbud',0),(185814,5162,'da','Kunde tilbud',0),(185815,5162,'ko','ê³ ê° ê²¬ì ',0),(185816,5162,'he','×”×¦×¢×ª ×ž×—×™×¨ ×œ×œ×§×•×—',0),(185817,5162,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(185818,5162,'zh','å®¢æˆ·æŠ¥ä»·\r\n',0),(185819,5162,'sv','Kunden offert',0),(185820,5162,'it','Preventivo cliente',0),(185821,5162,'tl','',0),(185822,5162,'th','&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3651;&#3627;&#3657;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(185823,5162,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¬à¥‹à¤²à¥€',0),(185824,5162,'ms','Baca petikan',0),(185825,5162,'ar','Ø§Ù‚ØªØ¨Ø§Ø³ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(185826,5162,'fr','Devis client',0),(185827,5162,'jp','é¡§å®¢è¦‹ç©?ã‚Š',0),(185828,5162,'pt','CitaÃ§Ã£o de cliente',0),(185829,5162,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð·Ð°ÐºÐ°Ð·Ñ‡Ð¸ÐºÐ°',0),(185830,5162,'es','Cliente CotizaciÃ³n',0),(185831,5162,'de','Kundenzitat',0),(185832,5162,'en','Customer Quote',0),(185833,5163,'is','',0),(185834,5163,'dr','Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ÙŠ ØªØ®Ù…ÙŠÙ†ÙŠ Ø¨Ù‡ ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(185835,5163,'pr','Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ÙŠ ØªØ®Ù…ÙŠÙ†ÙŠ Ø¨Ù‡ ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(185836,5163,'tr','Sevkiyat kodu Zip iÃ§in tahmini',0),(185837,5163,'pl','Szacuje, wysyÅ‚ka do kod pocztowy',0),(185838,5163,'bg','ÐžÑ†ÐµÐ½ÑÐ²Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð¾ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(185839,5163,'ur','Ø²Ù¾ Ú©ÙˆÚˆ Ú©Û’ Ø´Ù¾Ù†Ú¯ Ú©Ø§ ØªØ®Ù…ÛŒÙ†Û',0),(185840,5163,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÑƒÑ˜Ðµ ÑÐµ Ð´Ð° Ð—Ð¸Ð¿ ÐºÐ¾Ð´Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(185841,5163,'vi','Dá»± trÃ¹ váº­n chuyá»ƒn Ä‘áº¿n mÃ£ Zip',0),(185842,5163,'af','Geskatte Versending na Zip Kode',0),(185843,5163,'ro','Estimat de transport maritim pentru a Zip Code',0),(185844,5163,'et','Hinnanguliselt komplekteerimisel Zip Code',0),(185845,5163,'si','Ocenjena dostava ZIP kodo',0),(185846,5163,'ba','Diperkirakan pengiriman ke kode pos',0),(185847,5163,'nl','Geschatte verzending om Zip Code',0),(185848,5163,'fi','Arvioitu toimitus postinumero',0),(185849,5163,'no','AnslÃ¥tt frakt til Zip kode',0),(185850,5163,'da','AnslÃ¥et Shipping til Zip-kode',0),(185851,5163,'ko','Zip ì½”ë“œ ë°°ì†¡ ì˜ˆìƒ',0),(185852,5163,'he','××•×ž×“×Ÿ ×ž×©×œ×•×— ×ž×™×§×•×“',0),(185853,5163,'el','Î•ÎºÏ„Î¹Î¼Î¬Ï„Î±Î¹ ÏŒÏ„Î¹ Î· Î½Î±Ï…Ï„Î¹Î»Î¯Î± Î½Î± Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(185854,5163,'zh','ä¼°è®¡è¿é€é‚®ç¼–\r\n',0),(185855,5163,'sv','BerÃ¤knad frakt om du vill postnummer',0),(185856,5163,'it','Stima spedizione per Zip codice',0),(185857,5163,'tl','',0),(185858,5163,'th','&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3605;&#3634;&#3617;&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3',0),(185859,5163,'hi','à¤œà¤¼à¤¿à¤ª à¤•à¥‹à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¤¾ à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(185860,5163,'ms','Dianggarkan penghantaran untuk Zip kod',0),(185861,5163,'ar','ØªÙ‚Ø¯ÙŠØ± Ø§Ù„Ø´Ø­Ù† Ø¥Ù„Ù‰ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(185862,5163,'fr','EstimÃ© d\'expÃ©dition pour Code postal',0),(185863,5163,'jp','éƒµä¾¿ç•ªå?·ã?¾ã?§ã?®ç™ºé€?è²»è¦‹ç©?ã‚Š',0),(185864,5163,'pt','Estimado de envio para CEP',0),(185865,5163,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ð°Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð² Zip ÐºÐ¾Ð´',0),(185866,5163,'es','Estimado Enviar a CÃ³digo Postal',0),(185867,5163,'de','GeschÃ¤tzt, um Zip-Code Versand',0),(185868,5163,'en','Estimated Shipping to Zip Code',0),(185869,5164,'is','',0),(185870,5164,'dr','Ø¬Ù‡Øª ',0),(185871,5164,'pr','Ø¬Ù‡Øª ',0),(185872,5164,'tr','Yan',0),(185873,5164,'pl','Po stronie',0),(185874,5164,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð°',0),(185875,5164,'ur','Ø·Ø±Ù',0),(185876,5164,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸',0),(185877,5164,'vi','Máº·t',0),(185878,5164,'af','Kant',0),(185879,5164,'ro','Partea',0),(185880,5164,'et','Side',0),(185881,5164,'si','Strani',0),(185882,5164,'ba','Sisi',0),(185883,5164,'nl','Kant',0),(185884,5164,'fi','Puolella',0),(185885,5164,'no','Siden',0),(185886,5164,'da','Side',0),(185887,5164,'ko','ì‚¬ì´ë“œ',0),(185888,5164,'he','×¦×“',0),(185889,5164,'el','Î Î»ÎµÏ…ÏÎ¬',0),(185890,5164,'zh','ä¾§\r\n',0),(185891,5164,'sv','Sida',0),(185892,5164,'it','Lato',0),(185893,5164,'tl','',0),(185894,5164,'th','&#3604;&#3657;&#3634;&#3609;',0),(185895,5164,'hi','à¤•à¥€ à¤“à¤°',0),(185896,5164,'ms','Sampingan',0),(185897,5164,'ar','Ø§Ù„Ø¬Ø§Ù†Ø¨',0),(185898,5164,'fr','CÃ´tÃ©',0),(185899,5164,'jp','å?´é?¢',0),(185900,5164,'pt','Lado',0),(185901,5164,'ru','Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð°',0),(185902,5164,'es','Lado',0),(185903,5164,'de','Seite',0),(185904,5164,'en','Side',0),(185905,5165,'is','',0),(185906,5165,'dr','Ø§ÙŠÙ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ØªÙ‡ÙŠÙ‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ØªÙˆØ³Ø·',0),(185907,5165,'pr','Ø§ÙŠÙ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ØªÙ‡ÙŠÙ‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ØªÙˆØ³Ø·',0),(185908,5165,'tr','TarafÄ±ndan saÄŸlanan bu teklif',0),(185909,5165,'pl','Ten cytat, Å›wiadczone przez',0),(185910,5165,'bg','Ð¢Ð¾Ð·Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚, Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð° Ð¾Ñ‚',0),(185911,5165,'ur','Ø§Ø³ Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ÙØ±Ø§ÛÙ… Ú©ÛŒ',0),(185912,5165,'sr','ÐžÐ²Ð°Ñ˜ Ñ†Ð¸Ñ‚Ð°Ñ‚ ÐºÐ¾Ñ˜Ð¸ ÑÑ‚Ðµ Ð´Ð¾Ð±Ð¸Ð»Ð¸ Ð¾Ð´',0),(185913,5165,'vi','BÃ¡o giÃ¡ nÃ y do',0),(185914,5165,'af','Hierdie kwotasie verskaf deur',0),(185915,5165,'ro','Acest citat de',0),(185916,5165,'et','See tsitaat, mida',0),(185917,5165,'si','Ta citat, ki jih',0),(185918,5165,'ba','Kutipan ini disediakan oleh',0),(185919,5165,'nl','Dit citaat geboden door',0),(185920,5165,'fi','TÃ¤mÃ¤ lainaus esittÃ¤nyt',0),(185921,5165,'no','Dette sitatet fra',0),(185922,5165,'da','Dette citat fra',0),(185923,5165,'ko','ì´ ê²¬ì ì— ì˜í•´ ì œê³µ',0),(185924,5165,'he','×”×¦×¢×ª ×ž×—×™×¨ ×–×• ×©×¡×•×¤×§×• ×¢×œ-×™×“×™',0),(185925,5165,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Ï€Î¿Ï… Ï€Î±ÏÎ­Ï‡Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ',0),(185926,5165,'zh','æ­¤æŠ¥ä»·æä¾›è€…\r\n',0),(185927,5165,'sv','Detta citat som tillhandahÃ¥lls av',0),(185928,5165,'it','Questa citazione fornita da',0),(185929,5165,'tl','',0),(185930,5165,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3609;&#3637;&#3657;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3650;&#3604;&#3618;',0),(185931,5165,'hi','à¤‡à¤¸ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥à¤°à¤¦à¤¾à¤¨ à¤•à¥€',0),(185932,5165,'ms','Petikan ini disediakan oleh',0),(185933,5165,'ar','Ù‡Ø°Ù‡ Ø§Ù„Ù…Ù‚ÙˆÙ„Ø© Ø§Ù„ØªÙŠ ØªÙ‚Ø¯Ù…Ù‡Ø§',0),(185934,5165,'fr','Cette citation fournie par',0),(185935,5165,'jp','ã?“ã?®è¦‹ç©?ã‚Šã?¯ã?“ã?“ã?‹ã‚‰æº–å‚™ã?•ã‚Œã?Ÿ',0),(185936,5165,'pt','Esta citaÃ§Ã£o fornecida pelo',0),(185937,5165,'ru','Ð­Ñ‚Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°, Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÑÐµÐ¼Ñ‹Ðµ',0),(185938,5165,'es','Esta cotizaciÃ³n proprcionada por',0),(185939,5165,'de','Dieses Zitat von bereitgestellten',0),(185940,5165,'en','This quote provided by',0),(185941,5166,'is','',0),(185942,5166,'dr','(Ø²Ù…Ø§Ù† Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª Ø¬Ù†Ø³ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ø¢Ù†',0),(185943,5166,'pr','Ø¨Ø§ ÙŠÙƒ Ø¨Ø±Ú¯Ø´Øª Ø§Ø²(Ø²Ù…Ø§Ù† Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ø¢Ù†',0),(185944,5166,'tr','bir dÃ¶nÃ¼ÅŸ ile',0),(185945,5166,'pl','z realizacji z',0),(185946,5166,'bg','Ñ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð½Ð°',0),(185947,5166,'ur','Ú©Û’ Ø§ÛŒÚ© Ù¾ÛŒØ´ Ú©Û’ Ø³Ø§ØªÚ¾',0),(185948,5166,'sr','ÑÐ° Ñ˜Ðµ Ð¿Ñ€ÐµÐ¾ÐºÑ€ÐµÑ‚ Ð¾Ð´',0),(185949,5166,'vi','vá»›i 1 vÃ²ng quay cá»§a',0),(185950,5166,'af','met \'n ommeswaai van',0),(185951,5166,'ro','cu un rÄƒspuns de',0),(185952,5166,'et','*with a turnaround of',0),(185953,5166,'si','z preobrat od',0),(185954,5166,'ba','dengan waktu penyelesaian',0),(185955,5166,'nl','met een ommekeer van',0),(185956,5166,'fi','jossa lÃ¤pimenoaika',0),(185957,5166,'no','med en behandlingstid pÃ¥',0),(185958,5166,'da','med en turnaround af',0),(185959,5166,'ko','ì²˜ë¦¬ì™€',0),(185960,5166,'he','×¢× ×”×—×•×–×¨×ª ×©×œ',0),(185961,5166,'el','Î¼Îµ Î¼Î¹Î± Î¼ÎµÏ„Î±ÏƒÏ„ÏÎ¿Ï†Î® Ï„Î¿Ï…',0),(185962,5166,'zh','ä¸Žå‘¨è½¬çš„èƒ½åŠ›\r\n',0),(185963,5166,'sv','med en vÃ¤ndning av',0),(185964,5166,'it','con un\'inversione di tendenza del',0),(185965,5166,'tl','',0),(185966,5166,'th','&#3604;&#3657;&#3623;&#3618;&#3585;&#3634;&#3619;&#3627;&#3617;&#3640;&#3609;&#3652;&#3611;&#3619;&#3629;&#3610; &#3654; &#3586;&#3629;&#3591;',0),(185967,5166,'hi','à¤à¤• à¤¬à¤¦à¤²à¤¾à¤µ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(185968,5166,'ms','dengan pemulihan',0),(185969,5166,'ar','Ù…Ø¹ ØªØ­ÙˆÙ„ Ù…Ù†',0),(185970,5166,'fr','avec un revirement de',0),(185971,5166,'jp','ï½žã?®å¿…è¦?æ—¥æ•°ã?¯',0),(185972,5166,'pt','com uma reviravolta de',0),(185973,5166,'ru','Ñ Ñ€Ð°Ð·Ð²Ð¾Ñ€Ð¾Ñ‚Ð°',0),(185974,5166,'es','con un cambio de',0),(185975,5166,'de','mit eine Kehrtwende',0),(185976,5166,'en','with a turnaround of',0),(185977,5167,'is','',0),(185978,5167,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(185979,5167,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(185980,5167,'tr','Faturalanan Miktar',0),(185981,5167,'pl','IloÅ›Ä‡ zapowiadane',0),(185982,5167,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(185983,5167,'ur','Ø¨Ø§Ù„Ù„Ø§Ø¯ Ù‚ÛŒ',0),(185984,5167,'sr','ÐšÐ¾Ð» Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(185985,5167,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ ra hÃ³a Ä‘Æ¡n',0),(185986,5167,'af','Hoev. Gefaktureer',0),(185987,5167,'ro','Cantitate facturata',0),(185988,5167,'et','Arve kogus',0),(185989,5167,'si','ZaraÄunana koliÄina',0),(185990,5167,'ba','Qty ditagih',0),(185991,5167,'nl','Gefactureerd aantal',0),(185992,5167,'fi','Laskutettu mÃ¤Ã¤rÃ¤',0),(185993,5167,'no','Antall fakturert',0),(185994,5167,'da','Antal faktureret',0),(185995,5167,'ko','ì²­êµ¬ ìˆ˜ëŸ‰',0),(185996,5167,'he','×›×ž×•×ª ×”×—×™×•×‘',0),(185997,5167,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î®Î¸Î·ÎºÎµ',0),(185998,5167,'zh','æ•°é‡å·²å…¥è´¦\r\n',0),(185999,5167,'sv','Antal faktureras',0),(186000,5167,'it','QtÃ  fatturata',0),(186001,5167,'tl','',0),(186002,5167,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(186003,5167,'hi','à¤¬à¤¿à¤² à¤•à¥€ à¤—à¤ˆ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(186004,5167,'ms','Qty yang dibilkan',0),(186005,5167,'ar','Qty ÙÙˆØ§ØªÙŠØ±',0),(186006,5167,'fr','QuantitÃ© facturÃ©e',0),(186007,5167,'jp','è«‹æ±‚æ¸ˆæ•°é‡?',0),(186008,5167,'pt','Qtde de bico',0),(186009,5167,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚',0),(186010,5167,'es','Cant. Facturada',0),(186011,5167,'de','Menge in Rechnung gestellt',0),(186012,5167,'en','Qty Billed',0),(186013,5168,'is','',0),(186014,5168,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø²ÙŠØ± ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø¨ÙˆØ¯Ù†Ø¯ Ø¨ÙŠÙ† ',0),(186015,5168,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø²ÙŠØ± ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø¨ÙˆØ¯Ù†Ø¯ Ø¨ÙŠÙ† ',0),(186016,5168,'tr','AÅŸaÄŸÄ±daki sipariÅŸleri arasÄ±nda tamamlanmÄ±ÅŸtÄ±r',0),(186017,5168,'pl','NastÄ™pujÄ…ce zamÃ³wienia zostaÅ‚y zakoÅ„czone miÄ™dzy',0),(186018,5168,'bg','Ð¡Ð»ÐµÐ´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐ° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ð¼ÐµÐ¶Ð´Ñƒ',0),(186019,5168,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§ Ú¯ÛŒØ§',0),(186020,5168,'sr','ÐžÐ²Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ ÑÑƒ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸ Ð¸Ð·Ð¼ÐµÑ’Ñƒ',0),(186021,5168,'vi','Nhá»¯ng Ä‘Æ¡n hÃ ng sau Ä‘Ã£ hoÃ n thÃ nh giá»¯a',0),(186022,5168,'af','Die volgende bestellings is voltooi tussen',0),(186023,5168,'ro','Comenzile urmÄƒtoare au fost realizate Ã®ntre',0),(186024,5168,'et','JÃ¤rgmised korraldused olid tÃ¤itunud',0),(186025,5168,'si','Naslednje naloge so bile dokonÄane med',0),(186026,5168,'ba','Perintah berikut diselesaikan antara',0),(186027,5168,'nl','De volgende bevelen werden voltooid tussen',0),(186028,5168,'fi','Seuraavat tilaukset saatiin vÃ¤lillÃ¤',0),(186029,5168,'no','FÃ¸lgende bestillinger fullfÃ¸rt mellom',0),(186030,5168,'da','De fÃ¸lgende ordrer var afsluttet mellem',0),(186031,5168,'ko','ë‹¤ìŒ ì£¼ë¬¸ ì‚¬ì´ ì™„ë£Œ í–ˆë‹¤',0),(186032,5168,'he','×”×¦×•×•×™× ×”×‘××™× ×”×•×©×œ×ž×• ×‘×™×Ÿ',0),(186033,5168,'el','ÎŸÎ¹ Î±ÎºÏŒÎ»Î¿Ï…Î¸ÎµÏ‚ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ¸Î·ÎºÎ±Î½ Î¼ÎµÏ„Î±Î¾Ï',0),(186034,5168,'zh','ä»¥ä¸‹è®¢å•å·²å®Œæˆä»‹äºŽ\r\n',0),(186035,5168,'sv','Om fÃ¶ljande slutfÃ¶rdes mellan',0),(186036,5168,'it','I seguenti ordini sono stati completati tra',0),(186037,5168,'tl','',0),(186038,5168,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3656;&#3629;&#3652;&#3611;&#3609;&#3637;&#3657;&#3649;&#3621;&#3657;&#3623;&#3648;&#3626;&#3619;&#3655;&#3592;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;',0),(186039,5168,'hi','à¤¨à¤¿à¤®à¥à¤¨ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤¬à¥€à¤š à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤°à¤¹à¥‡ à¤¥à¥‡',0),(186040,5168,'ms','Perintah-perintah berikut telah siap dibina antara',0),(186041,5168,'ar','ÙˆØ§Ø³ØªÙƒÙ…Ù„Øª Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø± Ø§Ù„ØªØ§Ù„ÙŠØ© Ø¨ÙŠÙ†',0),(186042,5168,'fr','Les commandes suivantes ont Ã©tÃ© effectuÃ©es entre',0),(186043,5168,'jp','æ¬¡ã?®æ³¨æ–‡ã?¯ï½žã?®é–“ã?«å®Œäº†ã?—ã?¦ã?„ã?¾ã?™',0),(186044,5168,'pt','As seguintes ordens foram concluÃ­das entre',0),(186045,5168,'ru','Ð‘Ñ‹Ð»Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð¼ÐµÐ¶Ð´Ñƒ',0),(186046,5168,'es','Los siguentes ordenes se completaron entre',0),(186047,5168,'de','Folgende AuftrÃ¤ge wurden zwischen fertiggestellt.',0),(186048,5168,'en','The following orders were completed between',0),(186049,5169,'is','',0),(186050,5169,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§',0),(186051,5169,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§',0),(186052,5169,'tr','GÃ¶rÃ¼nÃ¼m gÃ¶nderiler',0),(186053,5169,'pl','Widok przesyÅ‚ek',0),(186054,5169,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(186055,5169,'ur','Ù†Ù‚Ø·Û Ù†Ø¸Ø± Ú©ÛŒ ØªØ±Ø³ÛŒÙ„',0),(186056,5169,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(186057,5169,'vi','Xem chuyáº¿n hÃ ng',0),(186058,5169,'af','Besigtig Besendings',0),(186059,5169,'ro','Vezi transporturile',0),(186060,5169,'et','Vaata tarneid',0),(186061,5169,'si','Pogled poÅ¡iljk',0),(186062,5169,'ba','Tampilan pengiriman',0),(186063,5169,'nl','Weergave zendingen',0),(186064,5169,'fi','NÃ¤ytÃ¤ lÃ¤hetykset',0),(186065,5169,'no','Vis forsendelser',0),(186066,5169,'da','Se forsendelser',0),(186067,5169,'ko','ë³´ê¸° ì¶œí•˜',0),(186068,5169,'he','× ×•×£ ×ž×©×œ×•×—×™×',0),(186069,5169,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Ï€Î¿ÏƒÏ„Î¿Î»ÏŽÎ½',0),(186070,5169,'zh','æŸ¥çœ‹å‡ºè´§é‡\r\n',0),(186071,5169,'sv','Visa utleveranser',0),(186072,5169,'it','Vista spedizioni',0),(186073,5169,'tl','',0),(186074,5169,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(186075,5169,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤²à¤¦à¤¾à¤¨',0),(186076,5169,'ms','Penghantaran View',0),(186077,5169,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø´Ø­Ù†Ø§Øª',0),(186078,5169,'fr','Vue expÃ©ditions',0),(186079,5169,'jp','ç™ºé€?å“?ã?®è¡¨ç¤º',0),(186080,5169,'pt','Carregamentos de exibiÃ§Ã£o',0),(186081,5169,'ru','Ð’Ð¸Ð´ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(186082,5169,'es','Visionar EnvÃ­os',0),(186083,5169,'de','Ansicht-Sendungen',0),(186084,5169,'en','View Shipments',0),(186085,5170,'is','',0),(186086,5170,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(186087,5170,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(186088,5170,'tr','FiÅŸi gÃ¼ncelleme baÅŸarÄ±sÄ±z',0),(186089,5170,'pl','Kupon aktualizacji nie powiodÅ‚o siÄ™',0),(186090,5170,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(186091,5170,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(186092,5170,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(186093,5170,'vi','Cáº­p Nháº­t Phiáº¿u tháº¥t báº¡i',0),(186094,5170,'af','Bewysstuk Opdatering gefaal.',0),(186095,5170,'ro','Voucher Update nu a reuÈ™it',0),(186096,5170,'et','VautÅ¡eri uuendamine ebaÃµnnestus!',0),(186097,5170,'si','Kupona ni mogoÄe posodobiti',0),(186098,5170,'ba','Gagal Update voucher',0),(186099,5170,'nl','Bon-Update mislukt',0),(186100,5170,'fi','Tositteen pÃ¤ivitys epÃ¤onnistui',0),(186101,5170,'no','Bilag oppdatering mislyktes',0),(186102,5170,'da','Voucher opdatering mislykkedes',0),(186103,5170,'ko','ë°”ìš°ì²˜ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(186104,5170,'he','×©×•×‘×¨ ×”×¢×“×›×•×Ÿ × ×›×©×œ',0),(186105,5170,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(186106,5170,'zh','å‡­å•æ›´æ–°å¤±è´¥\r\n',0),(186107,5170,'sv','Verifikationen uppdateringen misslyckades',0),(186108,5170,'it','Voucher aggiornamento non riuscito',0),(186109,5170,'tl','',0),(186110,5170,'th','&#3629;&#3633;&#3614;&#3648;&#3604;&#3607;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(186111,5170,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²',0),(186112,5170,'ms','Update baucar yang gagal',0),(186113,5170,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(186114,5170,'fr','Bon mise Ã  jour a Ã©chouÃ©',0),(186115,5170,'jp','ä¼?ç¥¨ã?Œæ›´æ–°ã?§ã??ã?¾ã?›ã‚“',0),(186116,5170,'pt','Falhado na atualizaÃ§Ã£o voucher',0),(186117,5170,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(186118,5170,'es','Voucher ActualizaciÃ³n FallÃ³',0),(186119,5170,'de','Gutschein-Update fehlgeschlagen',0),(186120,5170,'en','Voucher Update Failed',0),(186121,5171,'is','',0),(186122,5171,'dr','Ø§ØµÙ„Ø§Ø­Ø§Øª ÙƒØ§Ù„Ø§  Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(186123,5171,'pr','Ø§ØµÙ„Ø§Ø­Ø§Øª ÙƒØ§Ù„Ø§  Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(186124,5171,'tr','Ã–ÄŸe ayarlama baÅŸarÄ±sÄ±z',0),(186125,5171,'pl','Przedmiot regulacji nie powiodÅ‚o siÄ™',0),(186126,5171,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ Ð½Ðµ Ðµ',0),(186127,5171,'ur','Ø´Û’ Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ù†Ø§Ú©Ø§Ù…',0),(186128,5171,'sr','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(186129,5171,'vi','Chá»‰nh hÃ ng tháº¥t báº¡i',0),(186130,5171,'af','Item Aanpassings Gefaal',0),(186131,5171,'ro','Element reglare Failed',0),(186132,5171,'et','Toote kohandamine ebaÃµnnestus',0),(186133,5171,'si','Element prilagoditev ni uspelo',0),(186134,5171,'ba','Penyesuaian item gagal',0),(186135,5171,'nl','Punt aanpassing mislukt',0),(186136,5171,'fi','Kohteen mukauttaminen epÃ¤onnistui',0),(186137,5171,'no','Elementet justering mislyktes',0),(186138,5171,'da','Vare justering mislykkedes',0),(186139,5171,'ko','í•­ëª© ì¡°ì • ì‹¤íŒ¨',0),(186140,5171,'he','×¤×¨×™×˜ ×”×ª××ž×” × ×›×©×œ×”',0),(186141,5171,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Ï„Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(186142,5171,'zh','é¡¹ç›®è°ƒæ•´å¤±è´¥\r\n',0),(186143,5171,'sv','Objektet anpassning misslyckades',0),(186144,5171,'it','Elemento di regolazione non superato',0),(186145,5171,'tl','',0),(186146,5171,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(186147,5171,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤µà¤¿à¤«à¤²',0),(186148,5171,'ms','Pelarasan item gagal',0),(186149,5171,'ar','ØªØ¹Ø¯ÙŠÙ„ Ø§Ù„Ø¨Ù†Ø¯ ÙØ´Ù„',0),(186150,5171,'fr','Ajustement des article Failed',0),(186151,5171,'jp','å“?ç›®èª¿æ•´ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(186152,5171,'pt','Item ajuste falha',0),(186153,5171,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(186154,5171,'es','Ajuste del Item FallÃ³',0),(186155,5171,'de','Element Einstellung fehlgeschlagen',0),(186156,5171,'en','Item adjustment Failed',0),(186157,5172,'is','',0),(186158,5172,'dr','(Ø¨Ù‡Ø§ÙŠ) ØºÙŠØ± Ø®Ø§Ù„ÙŠ ',0),(186159,5172,'pr','ØªØ¹ÙŠÙŠÙ† ÙƒØ±Ø¯Ù† ÙŠÙƒ Ø§Ø±Ø²Ø´ (Ø¨Ù‡Ø§ÙŠ) ØºÙŠØ± Ø®Ø§Ù„ÙŠ ',0),(186160,5172,'tr','BoÅŸ olmayan bir deÄŸer belirtmeniz',0),(186161,5172,'pl','OkreÅ›l wartoÅ›Ä‡ innego niÅ¼ puste',0),(186162,5172,'bg','Ð£ÐºÐ°Ð¶ÐµÑ‚Ðµ Ð½ÐµÐ¿Ñ€Ð°Ð·Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(186163,5172,'ur','Ø§ÛŒÚ© ØºÛŒØ± Ø®Ø§Ù„ÛŒ Ù‚Ø¯Ø± Ú©Ø§ Ø§Ø®ØªØµØ§Øµ Ú©Ø±ÛŒÚº',0),(186164,5172,'sr','ÐŸÑ€ÐµÑ†Ð¸Ð·Ð¸Ñ€Ð°ÑšÐµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ñ˜Ðµ Ð½Ð¸ÑÑƒ Ð¿Ñ€Ð°Ð·Ð½Ðµ',0),(186165,5172,'vi','Chá»‰ Ä‘á»‹nh 1 giÃ¡ trá»‹ khÃ´ng trá»‘ng',0),(186166,5172,'af','Spesifeseer \'n nie-ongevulde waarde',0),(186167,5172,'ro','SpecificaÈ›i o valoare nevidÄƒ',0),(186168,5172,'et','MittetÃ¼hja vÃ¤Ã¤rtuse mÃ¤Ã¤ramine',0),(186169,5172,'si','DoloÄiti vrednost, ki ni prazna',0),(186170,5172,'ba','Menetapkan nilai non-kosong',0),(186171,5172,'nl','Een niet-lege waarde opgeven',0),(186172,5172,'fi','MÃ¤Ã¤ritÃ¤ muu kuin tyhjÃ¤ arvo',0),(186173,5172,'no','Angi en ikke-tom verdi',0),(186174,5172,'da','Angive en ikke-tom vÃ¦rdi',0),(186175,5172,'ko','ë¹„ì–´ ìžˆì§€ ì•Šì€ ê°’ì„ ì§€ì •',0),(186176,5172,'he','×œ×¦×™×™×Ÿ ×¢×¨×š ×©××™× ×• ×¨×™×§',0),(186177,5172,'el','ÎšÎ±Î¸Î¿ÏÎ¯ÏƒÎµÏ„Îµ Î¼Î¹Î± Î¼Î· ÎºÎµÎ½Î® Ï„Î¹Î¼Î®',0),(186178,5172,'zh','æŒ‡å®šä¸€ä¸ªéžç©ºå€¼\r\n',0),(186179,5172,'sv','Ange ett icke-tomt',0),(186180,5172,'it','Specificare un valore non vuoto',0),(186181,5172,'tl','',0),(186182,5172,'th','&#3619;&#3632;&#3610;&#3640;&#3588;&#3656;&#3634;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3623;&#3656;&#3634;&#3591;',0),(186183,5172,'hi','à¤à¤• à¤—à¥ˆà¤° à¤°à¤¿à¤•à¥à¤¤ à¤®à¤¾à¤¨ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(186184,5172,'ms','Menentukan nilai tidak kosong',0),(186185,5172,'ar','ØªØ¹ÙŠÙŠÙ† Ù‚ÙŠÙ…Ø© ØºÙŠØ± ÙØ§Ø±ØºØ©',0),(186186,5172,'fr','SpÃ©cifiez une valeur non vide',0),(186187,5172,'jp','ç©ºæ¬„ã?§ã?ªã?„ä¾¡å€¤ã?®ç‰¹å®š',0),(186188,5172,'pt','Especifique um valor de nÃ£o-vazios',0),(186189,5172,'ru','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð½ÐµÐ¿ÑƒÑÑ‚Ð¾Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(186190,5172,'es','Especificar un valor que no es blanco',0),(186191,5172,'de','Geben Sie den Wert nicht leer',0),(186192,5172,'en','Specify a non-blank value',0),(186193,5173,'is','',0),(186194,5173,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾ÙŠØ¯Ø§ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§ Ø¨Ø§ Ø´Ù†Ø§Ø³Ù‡  Ù†ÙŠØ³Øª',0),(186195,5173,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾ÙŠØ¯Ø§ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§ Ø¨Ø§ Ø´Ù†Ø§Ø³Ù‡  Ù†ÙŠØ³Øª',0),(186196,5173,'tr','KimliÄŸine sahip Ã¶ÄŸe bulunamadÄ±',0),(186197,5173,'pl','Nie moÅ¼na odnaleÅºÄ‡ elementu z ID',0),(186198,5173,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð½Ð°Ð¼ÐµÑ€Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ Ð˜Ð”',0),(186199,5173,'ur','Ø´Ù†Ø§Ø®Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ø´Û’ Ù†ÛÛŒÚº Ù…Ù„ Ø³Ú©Ø§',0),(186200,5173,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ ÑÑ‚Ð°Ð²ÐºÑƒ ÑÐ° Ð˜Ð”-Ð¾Ð¼',0),(186201,5173,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ ng vá»›i ID',0),(186202,5173,'af','Nie instaat om items met die ID te vind',0),(186203,5173,'ro','Imposibil de gÄƒsit elementul cu ID-ul',0),(186204,5173,'et','Ei leia Ã¼ksuse ID',0),(186205,5173,'si','Ni bilo mogoÄe najti elementa z ID-jem',0),(186206,5173,'ba','Tidak dapat menemukan item dengan ID',0),(186207,5173,'nl','Niet in staat om item met ID te vinden',0),(186208,5173,'fi','Ei lÃ¶ydy kohdetta, jonka tunnus',0),(186209,5173,'no','Finner ikke objekt med ID',0),(186210,5173,'da','Stand til at finde varen med ID',0),(186211,5173,'ko','ID ê°€ì§„ í•­ëª©ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(186212,5173,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×¦×•× ×¤×¨×™×˜ ×¢× ×ž×–×”×”',0),(186213,5173,'el','Î£Îµ Î¸Î­ÏƒÎ· Î½Î± Î²ÏÎµÎ¯Ï„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¼Îµ ID',0),(186214,5173,'zh','æ— æ³•æ‰¾åˆ°æœ‰å¸å·çš„é¡¹ç›®\r\n',0),(186215,5173,'sv','Det gick inte att hitta objektet med ID',0),(186216,5173,'it','Impossibile trovare l\'elemento con ID',0),(186217,5173,'tl','',0),(186218,5173,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3605;&#3619;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;',0),(186219,5173,'hi','à¤†à¤ˆà¤¡à¥€ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤‡à¤Ÿà¤® à¤¢à¥‚à¤à¤¢à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(186220,5173,'ms','Tidak dapat mencari item dengan ID',0),(186221,5173,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ù†ØµØ± Ù…Ø¹ Ù…Ø¹Ø±Ù',0),(186222,5173,'fr','Impossible de trouver l\'Ã©lÃ©ment dont l\'ID',0),(186223,5173,'jp','ã?“ã?®ï¼©ï¼¤ã?§ã?¯å“?ç›®ã‚’è¦‹ã?¤ã?‘ã‚‹ã?“ã?¨ã?Œã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(186224,5173,'pt','NÃ£o Ã© possÃ­vel localizar o item com o ID',0),(186225,5173,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð½Ð°Ð¹Ñ‚Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€ Ð¿Ð¾ ID',0),(186226,5173,'es','No se Puede encontrar item con ID',0),(186227,5173,'de','Element mit der ID gefunden',0),(186228,5173,'en','Unable to find item with ID',0),(186229,5174,'is','',0),(186230,5174,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ú¯Ø±ÙˆÙ‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ù†Ø¯',0),(186231,5174,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ú¯Ø±ÙˆÙ‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ù†Ø¯',0),(186232,5174,'tr','Ã–ÄŸelerin Kategori olmalÄ±dÄ±r',0),(186233,5174,'pl','Elementy muszÄ… mieÄ‡ kategoriÄ™',0),(186234,5174,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð°Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(186235,5174,'ur','Ø§Ø´ÛŒØ§Ø¡ Ø§ÛŒÚ© Ø²Ù…Ø±Û ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(186236,5174,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ»Ð¸ Ð¼Ð¾Ñ€Ð°Ñ˜Ñƒ Ð¸Ð¼Ð°Ñ‚Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(186237,5174,'vi','HÃ ng pháº£i cÃ³ thá»ƒ loáº¡i',0),(186238,5174,'af','Items moet \'n Kategorie hÃª',0),(186239,5174,'ro','Elementele trebuie sÄƒ aibÄƒ o categorie',0),(186240,5174,'et','Tooted peavad kuuluma kategooriasse',0),(186241,5174,'si','Elementi morajo imeti kategorijo',0),(186242,5174,'ba','Item harus memiliki kategori',0),(186243,5174,'nl','Items moeten hebben een categorie',0),(186244,5174,'fi','Alkioiden on oltava luokka',0),(186245,5174,'no','Elementer mÃ¥ ha en kategori',0),(186246,5174,'da','Varer skal have en kategori',0),(186247,5174,'ko','í•­ëª© ë²”ì£¼ê°€ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(186248,5174,'he','×¤×¨×™×˜×™× ×™×© ×§×˜×’×•×¨×™×”',0),(186249,5174,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡Î¿Ï…Î½ Î¼Î¹Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(186250,5174,'zh','é¡¹ç›®å¿…é¡»æœ‰ä¸€ä¸ªåˆ†ç±»\r\n',0),(186251,5174,'sv','Objekt mÃ¥ste ha en kategori',0),(186252,5174,'it','Gli elementi devono avere una categoria',0),(186253,5174,'tl','',0),(186254,5174,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(186255,5174,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¹à¥‹à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(186256,5174,'ms','Item-item mesti mempunyai kategori',0),(186257,5174,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† ÙˆØ¬ÙˆØ¯ ØªØµÙ†ÙŠÙ Ù„Ù„ØµÙ†Ù',0),(186258,5174,'fr','Les Ã©lÃ©ments doivent avoir une catÃ©gorie',0),(186259,5174,'jp','å“?ç›®ã?«ã?¯ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?Œã?ªã??ã?¦ã?¯ã?ªã‚Šã?¾ã?›ã‚“',0),(186260,5174,'pt','Itens devem ter uma categoria',0),(186261,5174,'ru','Ð¢Ð¾Ð²Ð°Ñ€ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð¼ÐµÑ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(186262,5174,'es','Items debe tener una CategorÃ­a',0),(186263,5174,'de','Elemente mÃ¼ssen eine Kategorie',0),(186264,5174,'en','Items must have a Category',0),(186265,5175,'is','',0),(186266,5175,'dr','Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(186267,5175,'pr','Ù…Ø­Ù„ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(186268,5175,'tr','Ã–ÄŸe konumu baÅŸarÄ±yla eklendi',0),(186269,5175,'pl','Lokalizacja przedmiotu dodano pomyÅ›lnie',0),(186270,5175,'bg','ÐœÐµÑÑ‚Ð¾Ð½Ð°Ñ…Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(186271,5175,'ur','Ø´Û’ Ú©Ø§ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(186272,5175,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(186273,5175,'vi','ThÃªm vá»‹ trÃ­ hÃ ng thÃ nh cÃ´ng',0),(186274,5175,'af','Item Ligging suksesvol Geskep',0),(186275,5175,'ro','LocaÅ£ie elementul adÄƒugat cu succes',0),(186276,5175,'et','Toote asukoht lisati edukalt',0),(186277,5175,'si','Mesto elementa uspeÅ¡no dodani',0),(186278,5175,'ba','Lokasi ditambahkan berhasil',0),(186279,5175,'nl','Locatie van het item succesvol toegevoegd',0),(186280,5175,'fi','Nimikkeen sijainnin lisÃ¤Ã¤minen onnistui',0),(186281,5175,'no','Elementplasseringen lagt',0),(186282,5175,'da','Emnets placering tilfÃ¸jet',0),(186283,5175,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•­ëª© ìœ„ì¹˜',0),(186284,5175,'he','×ž×™×§×•× ×¤×¨×™×˜ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(186285,5175,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¸Î­ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(186286,5175,'zh','é¡¹ç›®ä½ç½®æ·»åŠ æˆåŠŸ\r\n',0),(186287,5175,'sv','Artikelplats lagts',0),(186288,5175,'it','Percorso di elemento aggiunto con successo',0),(186289,5175,'tl','',0),(186290,5175,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(186291,5175,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨',0),(186292,5175,'ms','Lokasi item yang berjaya menambah',0),(186293,5175,'ar','Ø£Ø¶ÙŠÙ Ù…ÙˆÙ‚Ø¹ Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(186294,5175,'fr','Emplacement d\'Ã©lÃ©ment ajoutÃ© avec succÃ¨s',0),(186295,5175,'jp','å“?ç›®ã?®é…?ç½®ã‚’è¿½åŠ ã?—ã?¾ã?—ã?Ÿ',0),(186296,5175,'pt','LocalizaÃ§Ã£o do item adicionada com sucesso',0),(186297,5175,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾',0),(186298,5175,'es','Item UbicaciÃ³n Agregada Exitosamente',0),(186299,5175,'de','Artikelstandort erfolgreich hinzugefÃ¼gt',0),(186300,5175,'en','Item Location Added Successfully',0),(186301,5176,'is','',0),(186302,5176,'dr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¯Ø± Ø¯ÙØªØ± ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø«Ø¨Øª Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ø§Ù†Ø¬Ø§Ù… Ø¯Ù‡Ø¯',0),(186303,5176,'pr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¯Ø± Ø¯ÙØªØ± ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø«Ø¨Øª Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ø§Ù†Ø¬Ø§Ù… Ø¯Ù‡Ø¯',0),(186304,5176,'tr','SeÃ§ilen - hiÃ§bir varsayÄ±lan GL hesabÄ± GL giriÅŸlerini yapmak deÄŸil',0),(186305,5176,'pl','Nie ma domyÅ›lnego konta GL wybrane - nie mÃ³gÅ‚by GL wpisy',0),(186306,5176,'bg','ÐÑÐ¼Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ GL Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ - Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ GL Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(186307,5176,'ur','Ú©ÙˆØ¦ÛŒ Ø·Û’ Ø´Ø¯Û Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ù†ØªØ®Ø¨ - Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Ùˆ Ø¯Û’ Ù†Û Ø³Ú©Ø§',0),(186308,5176,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð“Ð› Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸ - Ð½Ð¸Ñ˜Ðµ Ð¼Ð¾Ð³Ð°Ð¾ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ð¸ Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐµ',0),(186309,5176,'vi','ChÆ°a Chá»n TK Sá»• CÃ¡i Tá»•ng Há»£p Máº·c Äá»‹nh - KhÃ´ng thá»ƒ nháº­p Sá»• Cai',0),(186310,5176,'af','Geen verstekte AG rekening is gekies - was nie instaat om AG inskrywings te maak nie',0),(186311,5176,'ro','Nici un cont de GL implicit selectat - nu ar putea face GL intrÄƒri',0),(186312,5176,'et','Pole valitud - GL vaikekonto vÃµiks teha GL kanded',0),(186313,5176,'si','Noben privzeti GL raÄun izbrana - ne bi GL postavke',0),(186314,5176,'ba','Tidak ada account GL default dipilih - tidak bisa membuat entri GL',0),(186315,5176,'nl','Geen standaardaccount GL geselecteerd - kon GL posten niet maken',0),(186316,5176,'fi','Valittu - missÃ¤Ã¤n laiminlyÃ¶minen GL ei voitu tehdÃ¤ GL merkinnÃ¤t',0),(186317,5176,'no','Ingen standardkontoen for GL valgt - kunne ikke gjÃ¸re GL oppfÃ¸ringer',0),(186318,5176,'da','Ingen standard GL konto valgt - kunne ikke gÃ¸re GL poster',0),(186319,5176,'ko','ì„ ì • ëœ-ì•„ë‹ˆ ê¸°ë³¸ GL ê³„ì •ì„ GL í•­ëª©ì„ ë§Œë“¤ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(186320,5176,'he','××™×Ÿ ×—×©×‘×•×Ÿ GL ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©× ×‘×—×¨×• - ×œ× ×™×›×•×œ ×œ×¢×©×•×ª ××ª ×”×¢×¨×›×™× GL',0),(186321,5176,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î´ÎµÎ½ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹ - Î´ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± ÎºÎ¬Î½ÎµÎ¹ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ GL',0),(186322,5176,'zh','æ²¡æœ‰å·²é€‰çš„é»˜è®¤æ€»å¸ç§‘ç›®- æ— æ³•å½¢æˆæ€»å¸æ¡ç›®\r\n',0),(186323,5176,'sv','Ingen standard GL-konto som valts - kunde inte gÃ¶ra GL poster',0),(186324,5176,'it','Nessun conto GL predefinito selezionato - potrebbe rendere le voci GL',0),(186325,5176,'tl','',0),(186326,5176,'th','No default GL account selected - could not make GL entries',0),(186327,5176,'hi','à¤•à¥‹à¤ˆ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ GL à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ - GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¨à¤¹à¥€à¤‚ à¤¬à¤¨à¤¾ à¤¸à¤•à¤¤à¤¾',0),(186328,5176,'ms','Tiada akaun GL lalai yang dipilih - boleh membuat catatan GL',0),(186329,5176,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø­Ø³Ø§Ø¨ GL Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø§Ù„Ù…Ø­Ø¯Ø¯-Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªØ¬Ø¹Ù„ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª GL',0),(186330,5176,'fr','Aucun compte GL par dÃ©faut sÃ©lectionnÃ© - ne pouvaient pas faire les entrÃ©es GL',0),(186331,5176,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆGL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?Œé?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“ãƒ¼GLè¨˜å¸³ã?Œã?§ã??ã?¾ã?›ã‚“',0),(186332,5176,'pt','Nenhuma conta GL padrÃ£o selecionada - nÃ£o poderia fazer entradas GL',0),(186333,5176,'ru','ÐÐµ GL Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸, Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð¹ - Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÐ¸ GL',0),(186334,5176,'es','No se seleccionÃ³ ninguna cuenta LM por defecto - no podÃ­a hacer entradas de LM',0),(186335,5176,'de','Kein Standard-Hauptbuchkonto ausgewÃ¤hlt - kÃ¶nnte nicht GL EintrÃ¤ge machen',0),(186336,5176,'en','No default GL account selected - could not make GL entries',0),(186337,5177,'is','',0),(186338,5177,'dr','Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(186339,5177,'pr','Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(186340,5177,'tr','ÃœrÃ¼n stok almak',0),(186341,5177,'pl','OtrzymujÄ… elementy do magazynu',0),(186342,5177,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð² ÑÐºÐ»Ð°Ð´',0),(186343,5177,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…ÛŒÚº Ù…ÙˆØµÙˆÙ„',0),(186344,5177,'sr','ÐŸÑ€Ð¸Ð¼Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(186345,5177,'vi','Nháº­n VÃ o Danh Má»¥c HÃ ng Trong Kho',0),(186346,5177,'af','Ontvang Items in Inventaris',0),(186347,5177,'ro','Primi elemente Ã®n inventar',0),(186348,5177,'et','Saada kirjed sisestanud',0),(186349,5177,'si','Prevzemati artikle v zalogi',0),(186350,5177,'ba','Menerima item dalam persediaan',0),(186351,5177,'nl','Artikelen in de voorraad ontvangen',0),(186352,5177,'fi','NimikkeitÃ¤ vastaanotetaan varastoon',0),(186353,5177,'no','Motta varer pÃ¥ lageret',0),(186354,5177,'da','Modtage varer pÃ¥ lageret',0),(186355,5177,'ko','ëª©ë¡ì— í•­ëª©ì„ ë°›ì„',0),(186356,5177,'he','×§×‘×œ×ª ×¤×¨×™×˜×™× ×œ×ª×•×š ×”×ž×œ××™',0),(186357,5177,'el','Î›Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏ„Î·Î½ Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(186358,5177,'zh','æŽ¥æ”¶åˆ°åº“å­˜é¡¹ç›®\r\n',0),(186359,5177,'sv','Ta emot objekt i lagret',0),(186360,5177,'it','Ricevere articoli in magazzino',0),(186361,5177,'tl','',0),(186362,5177,'th','&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3611;&#3626;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(186363,5177,'hi','à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(186364,5177,'ms','Menerima barang ke dalam inventori',0),(186365,5177,'ar','ØªÙ„Ù‚ÙŠ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø© ÙÙŠ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(186366,5177,'fr','RÃ©ception des articles en stock, en',0),(186367,5177,'jp','å“?ç›®ã‚’å?—é ˜',0),(186368,5177,'pt','Receber itens em estoque',0),(186369,5177,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ñ‹ Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€ÑŒ',0),(186370,5177,'es','Recibir Items en Inventario',0),(186371,5177,'de','Artikel in den Bestand zu erhalten',0),(186372,5177,'en','Receive Items into Inventory',0),(186373,5178,'is','',0),(186374,5178,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(186375,5178,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(186376,5178,'tr','Tam PO',0),(186377,5178,'pl','PO kompletne',0),(186378,5178,'bg','PO Ð¿ÑŠÐ»Ð½Ð°',0),(186379,5178,'ur','Ù¾Ùˆ Ù…Ú©Ù…Ù„',0),(186380,5178,'sr','ÐŸÐž ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½',0),(186381,5178,'vi','HoÃ n táº¥t Ä‘Æ¡n mua hÃ ng',0),(186382,5178,'af','AB Voltooi',0),(186383,5178,'ro','PO complet',0),(186384,5178,'et','PO tÃ¤ielik',0),(186385,5178,'si','PO popolni',0),(186386,5178,'ba','PO lengkap',0),(186387,5178,'nl','PO volledige',0),(186388,5178,'fi','PO tÃ¤ydellinen',0),(186389,5178,'no','PO fullfÃ¸rt',0),(186390,5178,'da','PO komplet',0),(186391,5178,'ko','ì™„ì „ í•œ í¬',0),(186392,5178,'he','×¤×• ×”×©×œ×',0),(186393,5178,'el','PO Ï€Î»Î®ÏÎ·',0),(186394,5178,'zh','è®¢å•å®Œæˆ\r\n',0),(186395,5178,'sv','PO komplett',0),(186396,5178,'it','PO completa',0),(186397,5178,'tl','',0),(186398,5178,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(186399,5178,'hi','à¤ªà¥‹ à¤ªà¥‚à¤°à¤¾',0),(186400,5178,'ms','PO yang lengkap',0),(186401,5178,'ar','Øµ. Ø¨ ÙƒØ§Ù…Ù„Ø©',0),(186402,5178,'fr','PO complet',0),(186403,5178,'jp','POå®Œäº†',0),(186404,5178,'pt','PO completa',0),(186405,5178,'ru','ÐŸÐž Ð¿Ð¾Ð»Ð½Ð¾Ð¹',0),(186406,5178,'es','OC Completo',0),(186407,5178,'de','PO komplett',0),(186408,5178,'en','PO Complete',0),(186409,5179,'is','',0),(186410,5179,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ',0),(186411,5179,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ',0),(186412,5179,'tr','Ä°zleme',0),(186413,5179,'pl','Åšledzenie',0),(186414,5179,'bg','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(186415,5179,'ur','Ø³Ø±Ø§Øº Ú©Ø§Ø±ÛŒ',0),(186416,5179,'sr','Ð—Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ',0),(186417,5179,'vi','DÃ² tÃ¬m',0),(186418,5179,'af','Sporing',0),(186419,5179,'ro','UrmÄƒrire',0),(186420,5179,'et','JÃ¤lgimine',0),(186421,5179,'si','Sledenje',0),(186422,5179,'ba','Pelacakan',0),(186423,5179,'nl','Bijhouden',0),(186424,5179,'fi','Seuranta',0),(186425,5179,'no','Sporing',0),(186426,5179,'da','Sporing',0),(186427,5179,'ko','ì¶”ì ',0),(186428,5179,'he','×ž×¢×§×‘',0),(186429,5179,'el','Î Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·',0),(186430,5179,'zh','è¿½è¸ª\r\n',0),(186431,5179,'sv','SpÃ¥rning',0),(186432,5179,'it','Rilevamento',0),(186433,5179,'tl','',0),(186434,5179,'th','&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(186435,5179,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤—',0),(186436,5179,'ms','Penjejakan',0),(186437,5179,'ar','ØªØªØ¨Ø¹',0),(186438,5179,'fr','Suivi',0),(186439,5179,'jp','ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°',0),(186440,5179,'pt','Rastreamento',0),(186441,5179,'ru','ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(186442,5179,'es','Rastreo',0),(186443,5179,'de','Tracking',0),(186444,5179,'en','Tracking',0),(186445,5180,'is','',0),(186446,5180,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(186447,5180,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(186448,5180,'tr','Liste Ã¶ÄŸeleri',0),(186449,5180,'pl','Elementy listy',0),(186450,5180,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐºÐ°',0),(186451,5180,'ur','ÙÛØ±Ø³Øª Ø§Ø´ÛŒØ§',0),(186452,5180,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ ÑÐ° Ð»Ð¸ÑÑ‚Ðµ',0),(186453,5180,'vi','Danh sÃ¡ch ',0),(186454,5180,'af','Lys Items',0),(186455,5180,'ro','Elemente de listÄƒ',0),(186456,5180,'et','LoendiÃ¼ksuste',0),(186457,5180,'si','Seznam elementov',0),(186458,5180,'ba','Daftar item',0),(186459,5180,'nl','Lijstitems',0),(186460,5180,'fi','Luettelokohteet',0),(186461,5180,'no','Listeelementer',0),(186462,5180,'da','Listeelementer',0),(186463,5180,'ko','ëª©ë¡ í•­ëª©',0),(186464,5180,'he','×¤×¨×™×˜×™ ×¨×©×™×ž×”',0),(186465,5180,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î»Î¯ÏƒÏ„Î±Ï‚',0),(186466,5180,'zh','åˆ—å‡ºé¡¹ç›®\r\n',0),(186467,5180,'sv','Listobjekt',0),(186468,5180,'it','Voci di elenco',0),(186469,5180,'tl','',0),(186470,5180,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(186471,5180,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤®',0),(186472,5180,'ms','Senarai item',0),(186473,5180,'ar','Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(186474,5180,'fr','Ã‰lÃ©ments de liste',0),(186475,5180,'jp','å“?ç›®ã‚’ãƒªã‚¹ãƒˆã?«ã?™ã‚‹',0),(186476,5180,'pt','Itens de lista',0),(186477,5180,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(186478,5180,'es','Listar Items',0),(186479,5180,'de','Listenelemente',0),(186480,5180,'en','List Items',0),(186481,5181,'is','',0),(186482,5181,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(186483,5181,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(186484,5181,'tr','DeÄŸiÅŸiklikler baÅŸarÄ±lÄ± oldu.',0),(186485,5181,'pl','Zmiany byÅ‚y udane.',0),(186486,5181,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÑÐ° Ð±Ð¸Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¸.',0),(186487,5181,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ú©Ø§Ù…ÛŒØ§Ø¨ ØªÚ¾Û’ Û”',0),(186488,5181,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ðµ ÑÑƒ Ð±Ð¸Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¸.',0),(186489,5181,'vi','Thay Ä‘á»•i thÃ nh cÃ´ng',0),(186490,5181,'af','Veranderinge was suksesvol.',0),(186491,5181,'ro','ModificÄƒrile au fost de succes.',0),(186492,5181,'et','Muudatused kulgesid edukalt.',0),(186493,5181,'si','Spremembe so bile uspeÅ¡no.',0),(186494,5181,'ba','Perubahan itu berhasil.',0),(186495,5181,'nl','Wijzigingen waren succesvol.',0),(186496,5181,'fi','Muutokset onnistuivat.',0),(186497,5181,'no','Endringene var vellykket.',0),(186498,5181,'da','Ã†ndringer blev en succes.',0),(186499,5181,'ko','ë³€í™”ëŠ” ì„±ê³µì  ì´ì—ˆë‹¤.',0),(186500,5181,'he','×”×©×™× ×•×™×™× ×”×™×• ×ž×•×¦×œ×—×™×.',0),(186501,5181,'el','Î‘Î»Î»Î±Î³Î­Ï‚ Î®Ï„Î±Î½ ÎµÏ€Î¹Ï„Ï…Ï‡ÎµÎ¯Ï‚.',0),(186502,5181,'zh','å˜æ›´æˆåŠŸã€‚\r\n',0),(186503,5181,'sv','FÃ¶rÃ¤ndringar var framgÃ¥ngsrik.',0),(186504,5181,'it','Le modifiche hanno avuto successo.',0),(186505,5181,'tl','',0),(186506,5181,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3652;&#3604;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;&#3649;&#3621;&#3657;&#3623;',0),(186507,5181,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤«à¤² à¤°à¤¹à¥‡ à¤¥à¥‡à¥¤',0),(186508,5181,'ms','Perubahan yang telah berjaya.',0),(186509,5181,'ar','Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª ÙƒØ§Ù†Øª Ù†Ø§Ø¬Ø­Ø©.',0),(186510,5181,'fr','Changements ont rÃ©ussi.',0),(186511,5181,'jp','å¤‰æ›´ã?«æˆ?åŠŸã?—ã?¾ã?—ã?Ÿ',0),(186512,5181,'pt','As alteraÃ§Ãµes foram bem sucedidas.',0),(186513,5181,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ñ‹Ð¼Ð¸.',0),(186514,5181,'es','Cambios Fueron Exitoso',0),(186515,5181,'de','Ã„nderungen waren erfolgreich.',0),(186516,5181,'en','Changes were successful.',0),(186517,5182,'is','',0),(186518,5182,'dr','(Ø³Ø±ÙˆØ±- Ù†Ø§Ù… ÛŒÙˆØ²Ø±ÙŠ â€“ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ) ÙØ§ÙŠÙ„ÙŠ Ø±Ø§ ÙƒÙ‡ Ø¨Ù‡ Ù†Ø§Ù…   Ø§Ø³Øª Ø±Ø§ Ø¯Ø± ÙÙˆÙ„Ø¯Ø± Ù…Ø±Ø¨ÙˆØ·Ù‡ Ø§ØµÙ„Ø§Ø­  ÙƒÙ†ÙŠØ¯ my_defines.php',0),(186519,5182,'pr','Ø¬Ù‡Øª ØªØºÙŠÙŠØ± Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§ØªØµØ§Ù„ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§(Ø³Ø±ÙˆØ±- Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ â€“ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ) ÙØ§ÙŠÙ„ÙŠ Ø±Ø§ ÙƒÙ‡ Ø¨Ù‡ Ù†Ø§Ù…   Ø§Ø³Øª Ø±Ø§ Ø¯Ø± ÙÙˆÙ„Ø¯Ø± Ù…Ø±Ø¨ÙˆØ·Ù‡ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ†ÙŠØ¯ my_defines.php',0),(186520,5182,'tr','VeritabanÄ± baÄŸlantÄ±sÄ± bilgileri (sunucu, kullanÄ±cÄ± adÄ±, ÅŸifre) deÄŸiÅŸtirmek iÃ§in<br>my_defines.php adlÄ± dosyayÄ± dÃ¼zenleme klasÃ¶rÃ¼ iÃ§erir.',0),(186521,5182,'pl','Aby zmieniÄ‡ informacje poÅ‚Ä…czenia bazy danych (serwer, nazwa uÅ¼ytkownika, hasÅ‚o)<br>Edytuj plik o nazwie my_defines.php zawiera folder.',0),(186522,5182,'bg','Ð—Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑÑ‚Ð° Ð·Ð° Ð²Ñ€ÑŠÐ·ÐºÐ°Ñ‚Ð° Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ (ÑÑŠÑ€Ð²ÑŠÑ€Ð°, Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ, Ð¿Ð°Ñ€Ð¾Ð»Ð°)<br>Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð», Ð½Ð°Ñ€ÐµÑ‡ÐµÐ½ my_defines.php Ð² Ð²ÐºÐ»ÑŽÑ‡',0),(186523,5182,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ú©Ù†Ú©Ø´Ù† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª (Ø³Ø±ÙˆØ±ØŒ ØµØ§Ø±Ù Ù†Ø§Ù…ØŒ Ù¾Ø§Ø³ ÙˆØ±Úˆ) Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’<br>my_defines.php Ú©ÛØ§ Ø¬Ø§ØªØ§ ÛÛ’ Ù…Ø³Ù„ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº Ù¾ÙˆØ´Û Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”',0),(186524,5182,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð»Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ð¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐµ Ð±Ð°Ð·Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° (ÑÐµÑ€Ð²ÐµÑ€Ð°, ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ, Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ)<br>ÑƒÑ€ÐµÐ´Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð½Ð°Ð·Ð¸Ð²Ð° Ð¼y_Ð´ÐµÑ„Ð¸Ð½ÐµÑ.Ð¿Ñ…Ð¿ Ñƒ ÑƒÐºÑ™',0),(186525,5182,'vi','Äá»ƒ thay Ä‘á»•i thÃ´ng tin káº¿t ná»‘i dá»¯ liá»‡u (mÃ¡y chá»§, tÃªn ngÆ°á»i sá»­ dá»¥ng, máº­t kháº©u))<br>sá»­a há»“ sÆ¡ tÃªn my_defines.php trong táº­p há»“ sÆ¡ kÃ¨m theo.',0),(186526,5182,'af','Om die databasis konneksie inligting te verander (bediener, gebruikernaam, wagwoord)<br>redigeer die lÃªer genaamd my_defines.php in die includes vouer.',0),(186527,5182,'ro','Pentru a schimba informaÅ£iile de conexiune de date (server, nume utilizator, parola)<br>editaÅ£i fiÅŸierul numit my_defines.php include folder.',0),(186528,5182,'et','Muuta andmebaasiÃ¼henduse teavet (server, kasutajanimi, parool)<br>redigeerida faili nimega my_defines.php ning sisaldab kaust.',0),(186529,5182,'si','ÄŒe Å¾elite spremeniti povezavo informacije o zbirki podatkov (streÅ¾nika, uporabniÅ¡ko ime, geslo)<br>Uredite datoteko, imenovano my_defines.php v v vraÄunati mape.',0),(186530,5182,'ba','Untuk mengubah informasi koneksi database (server, nama pengguna, sandi)<br>mengedit file yang disebut my_defines.php di termasuk folder.',0),(186531,5182,'nl','Verbindingsgegevens database (server, gebruikersnaam, wachtwoord) wijzigen<br>bewerken van het bestand met de naam my_defines.php in de map bevat.',0),(186532,5182,'fi','Voit muuttaa tietokannan yhteystiedot (palvelimen, kÃ¤yttÃ¤jÃ¤tunnus, salasana)<br>Muokkaa tiedostoa nimeltÃ¤ my_defines.php sisÃ¤ltÃ¤Ã¤ kansion.',0),(186533,5182,'no','Endre informasjonen for databasetilkobling (server, brukernavn, passord)<br>Rediger filen kalt my_defines.php i den inkluderer mappe.',0),(186534,5182,'da','Ã†ndre oplysningerne om databaseforbindelsen (server, Brugernavn, adgangskode)<br>redigere den fil kaldet my_defines.php den inkluderer mappe.',0),(186535,5182,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì—°ê²° ì •ë³´ (ì„œë²„, ì‚¬ìš©ìž ì´ë¦„, ë¹„ë°€ ë²ˆí˜¸)ë¥¼ ë³€ê²½ í•˜ë ¤ë©´<br>my_defines.php ë¼ëŠ” íŒŒì¼ì„ íŽ¸ì§‘ í•˜ëŠ” í¬í•¨ í•˜ëŠ” í´ë”.',0),(186536,5182,'he','×›×“×™ ×œ×©× ×•×ª ××ª ×ž×™×“×¢ ×—×™×‘×•×¨ ×ž×¡×“ × ×ª×•× ×™× (server, ×©× ×”×ž×©×ª×ž×©, ×”×¡×™×¡×ž×”)<br>×œ×¢×¨×•×š ××ª ×”×§×•×‘×¥ ×‘×©× my_defines.php ×›×•×œ×œ ×”×ª×™×§×™×”.',0),(186537,5182,'el','Î“Î¹Î± Î½Î± Î±Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ (Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î®, ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î·, ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚)<br>ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï€Î¿Ï… Î¿Î½Î¿Î¼Î',0),(186538,5182,'zh','è‹¥è¦æ›´æ”¹æ•°æ®åº“è¿žæŽ¥ä¿¡æ¯ï¼ˆæœåŠ¡å™¨ï¼Œç”¨æˆ·åï¼Œå¯†ç ï¼‰<br>ç‰©ç†åŒ–å­¦å­¦æŠ¥ç¼–è¾‘çš„æ–‡ä»¶å«æˆ‘defines.phpåœ¨åŒ…æ‹¬æ–‡ä»¶å¤¹ä¸­ã€‚\r\n\r\n',0),(186539,5182,'sv','Ã„ndra databas anslutningsinformation (server, anvÃ¤ndarnamn, lÃ¶senord)<br>Redigera filen heter my_defines.php den innehÃ¥ller mappen.',0),(186540,5182,'it','Per modificare le informazioni di connessione del database (server, nome utente, password)<br>modificare il file my_defines.php nella include la cartella.',0),(186541,5182,'tl','',0),(186542,5182,'th','To change database connection information (server, user name, password)<br>edit the file called my_defines.php in the includes folder.',0),(186543,5182,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¤¨à¥‡à¤•à¥à¤¶à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ (à¤¸à¤°à¥à¤µà¤°, à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤®, à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡) à¤¬à¤¦à¤²à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤<br>my_defines.php à¤¬à¥à¤²à¤¾à¤¯à¤¾ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à',0),(186544,5182,'ms','Untuk menukar maklumat sambungan pangkalan data (pelayan, nama pengguna, kata laluan)<br>Edit fail yang dipanggil my_defines.php pihak termasuk folder.',0),(186545,5182,'ar','Ù„ØªØºÙŠÙŠØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§ØªØµØ§Ù„ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª (Ø§Ù„Ø®Ø§Ø¯Ù…ØŒ Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ØŒ ÙˆÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ±)<br>ØªØ­Ø±ÙŠØ± Ù…Ù„Ù ÙŠØ³Ù…Ù‰ my_defines.php ÙŠØªØ¶Ù…Ù† Ø§Ù„Ù…Ø¬Ù„Ø¯.',0),(186546,5182,'fr','Pour modifier les informations de connexion de base de donnÃ©es (serveur, nom d\'utilisateur, mot de passe)<br>Modifiez le fichier appelÃ© my_defines.php l\'inclut le dossier.',0),(186547,5182,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹æŽ¥ç¶šæƒ…å ±ï¼ˆã‚µãƒ¼ãƒ?ãƒ¼ã€?ãƒ¦ãƒ¼ã‚¶ãƒ¼å??ã€?ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ï¼‰ã‚’å¤‰æ›´ã?™ã‚‹ã?«ã?¯<br>â€œå?«ã‚?ã‚‹â€?ãƒ•ã‚¡ã‚¤ãƒ«ã?®ä¸­ã?®my_defines.phpã?¨ã?„ã?†ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ç·¨é›†ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(186548,5182,'pt','Para alterar informaÃ§Ãµes de conexÃ£o de banco de dados (servidor, nome de usuÃ¡rio, senha)<br>Edite o arquivo chamado my_defines.php inclui a pasta.',0),(186549,5182,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾ ÑÐ¾ÐµÐ´Ð¸Ð½ÐµÐ½Ð¸Ð¸ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… (ÑÐµÑ€Ð²ÐµÑ€, Ð¸Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ, Ð¿Ð°Ñ€Ð¾Ð»ÑŒ)<br>ÐžÑ‚Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€ÑƒÐ¹Ñ‚Ðµ Ñ„Ð°Ð¹Ð» Ð¿Ð¾Ð´ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸ÐµÐ¼ my_defines.php Ð² Ð²ÐºÐ»ÑŽÑ‡Ð°ÐµÑ‚ ',0),(186550,5182,'es','Para cambiar informaciÃ³n de conexiÃ³n de base de datos (servidor, nombre de usuario, contraseÃ±a)<br>edit el file que se llama my_defines.php en el folder de incluir',0),(186551,5182,'de','Ã„ndern Sie die Datenbank-Verbindungsinformationen (Server, Benutzername, Passwort)<br>Bearbeiten Sie die Datei mit dem Namen my_defines.php in den Ordner enthÃ¤lt.',0),(186552,5182,'en','To change database connection information (server, user name, password)<br>edit the file called my_defines.php in the includes folder.',0),(186553,5183,'is','',0),(186554,5183,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¨Ø²Ø±Ú¯ ',0),(186555,5183,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¨Ø²Ø±Ú¯ ',0),(186556,5183,'tr','En bÃ¼yÃ¼k boyutu',0),(186557,5183,'pl','Max rozmiar duÅ¼y',0),(186558,5183,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð³Ð¾Ð»ÑÐ¼',0),(186559,5183,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Ø§Ø¦Ø² Ø¨ÛØª Ø¨Ú‘Ø§',0),(186560,5183,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð²ÐµÐ»Ð¸ÐºÐ¸',0),(186561,5183,'vi','Cá»¡ lá»›n tá»‘i Ä‘a',0),(186562,5183,'af','Maksimum grootte groot',0),(186563,5183,'ro','Max dimensiune mare',0),(186564,5183,'et','Max suurus suur',0),(186565,5183,'si','Max velikost velik',0),(186566,5183,'ba','Max ukuran besar',0),(186567,5183,'nl','Max grootte groot',0),(186568,5183,'fi','Max koko Iso',0),(186569,5183,'no','Max stÃ¸rrelse stor',0),(186570,5183,'da','Max stÃ¸rrelse stor',0),(186571,5183,'ko','í° ìµœëŒ€ í¬ê¸°',0),(186572,5183,'he','×’×•×“×œ ×ž×™×¨×‘×™ ×’×“×•×œ',0),(186573,5183,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î¼ÎµÎ³Î¬Î»Î¿',0),(186574,5183,'zh','æœ€å¤§å°ºå¯¸å¤§\r\n',0),(186575,5183,'sv','Max storlek stor',0),(186576,5183,'it','Max dimensione grande',0),(186577,5183,'tl','',0),(186578,5183,'th','&#3586;&#3609;&#3634;&#3604;&#3651;&#3627;&#3597;&#3656;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;',0),(186579,5183,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤†à¤•à¤¾à¤° à¤¬à¤¡à¤¼à¤¾',0),(186580,5183,'ms','Maksimum saiz besar',0),(186581,5183,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ø­Ø¬Ù… ÙƒØ¨ÙŠØ±',0),(186582,5183,'fr','Max taille grand',0),(186583,5183,'jp','æœ€å¤§ã‚µã‚¤ã‚º',0),(186584,5183,'pt','Max tamanho grande',0),(186585,5183,'ru','ÐœÐ°ÐºÑ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð±Ð¾Ð»ÑŒÑˆÐ¾Ð¹',0),(186586,5183,'es','Max TamaÃ±o Grande',0),(186587,5183,'de','Max groÃŸ',0),(186588,5183,'en','Max Size Big',0),(186589,5184,'is','',0),(186590,5184,'dr',':  180x200 - PNG/JPG Only',0),(186591,5184,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø§Ù†Ø¯Ø§Ø²Ù‡ :  180x200 - PNG/JPG Only',0),(186592,5184,'tr','En bÃ¼yÃ¼k boyutu: 180 x 200 - PNG/JPG',0),(186593,5184,'pl','Max rozmiar: 180 x 200 - PNG/JPG',0),(186594,5184,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€: 180 x 200 - PNG/JPG',0),(186595,5184,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Ø§Ø¦Ø²: 180 x 200 - PNG/JPG',0),(186596,5184,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð°: 180 x 200 - ÐŸÐÐ“ Ñƒ ÐˆÐŸÐ“',0),(186597,5184,'vi','Cá»¡ tá»‘i Ä‘a: 200x200 - chá»‰ PNG/JPG',0),(186598,5184,'af','Maks. Grootte:  180x200 - PNG/JPG Alleenlik',0),(186599,5184,'ro','Max dimensiune: 180 x 200 - PNG/JPG',0),(186600,5184,'et','Max suurus: 180 x 200 - PNG/JPG',0),(186601,5184,'si','Max velikost: 180 x 200 - PNG/JPG',0),(186602,5184,'ba','Max ukuran: 180 x 200 - PNG/JPG',0),(186603,5184,'nl','Max grootte: 180 x 200 - PNG/JPG',0),(186604,5184,'fi','Max koko: 180 x 200 - PNG/JPG',0),(186605,5184,'no','Max stÃ¸rrelse: 180 x 200 - PNG/JPG',0),(186606,5184,'da','Max stÃ¸rrelse: 180 x 200 - PNG/JPG',0),(186607,5184,'ko','ìµœëŒ€ í¬ê¸°: 180 x 200-PNG ë˜ëŠ” JPG',0),(186608,5184,'he','×’×•×“×œ ×ž×™×¨×‘×™: 180 x 200 - PNG/JPG...',0),(186609,5184,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚: 180 x 200 - PNG/JPG',0),(186610,5184,'zh','æœ€å¤§è§„æ ¼ï¼šä»…180x200-PNG/ JPGæ ¼å¼\r\n',0),(186611,5184,'sv','Max storlek: 180 x 200 - PNG/JPG',0),(186612,5184,'it','Max dimensioni: 180 x 200 - PNG/JPG',0),(186613,5184,'tl','',0),(186614,5184,'th','&#3586;&#3609;&#3634;&#3604;&#3652;&#3617;&#3656;&#3648;&#3585;&#3636;&#3609; : 200x200 - PNG/JPG &#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(186615,5184,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤†à¤•à¤¾à¤°: 180 x 200 - PNG/JPG',0),(186616,5184,'ms','Maksimum saiz: 180 x 200 - PNG/JPG',0),(186617,5184,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ø­Ø¬Ù…: 180 Ã— 200-Ø¨Ø§Ø¨ÙˆØ§ Ù†ÙŠÙˆ ØºÙŠÙ†ÙŠØ§/JPG',0),(186618,5184,'fr','Max Dimensions : 180 x 200 - PNG/JPG',0),(186619,5184,'jp','æœ€å¤§ã‚µã‚¤ã‚º: 200x200 - PNG/JPG ã?®ã?¿',0),(186620,5184,'pt','Tamanho mÃ¡ximo: 180 x 200 - PNG/JPG',0),(186621,5184,'ru','ÐœÐ°ÐºÑ Ñ€Ð°Ð·Ð¼ÐµÑ€: 180 x 200 - PNG/JPG',0),(186622,5184,'es','Max TamaÃ±o 200x200 - PNG/JPG Solo',0),(186623,5184,'de','Max. GrÃ¶ÃŸe: 180 x 200 - PNG/JPG',0),(186624,5184,'en','Max Size: 180x200 - PNG/JPG',0),(186625,5185,'is','',0),(186626,5185,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø§Ù†Ø¯Ø§Ø²Ù‡\r\n: 50X100 - PNG/JPG/GIF',0),(186627,5185,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø§Ù†Ø¯Ø§Ø²Ù‡\r\n: 50X100 - PNG/JPG/GIF',0),(186628,5185,'tr','En bÃ¼yÃ¼k boyutu: 50 x 100 - PNG/JPG',0),(186629,5185,'pl','Max rozmiar: 50 x 100 - PNG/JPG',0),(186630,5185,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€: 50 x 100 - PNG/JPG',0),(186631,5185,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Ø§Ø¦Ø²: 50 x 100 - PNG/JPG',0),(186632,5185,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð°: 50 x 100 - ÐŸÐÐ“ Ñƒ ÐˆÐŸÐ“',0),(186633,5185,'vi','Cá»¡ tá»‘i Ä‘a: 50x100 - PNG/JPG/GIF',0),(186634,5185,'af','Maks. Grootte:  50X100 - PNG/JPG/GIF',0),(186635,5185,'ro','Max dimensiuni: 50 x 100 - PNG/JPG',0),(186636,5185,'et','Max suurus: 50 x 100 - PNG/JPG',0),(186637,5185,'si','Max velikost: 50 x 100 - PNG/JPG',0),(186638,5185,'ba','Max ukuran: 50 x 100 - PNG/JPG',0),(186639,5185,'nl','Max grootte: 50 x 100 - PNG/JPG',0),(186640,5185,'fi','Max koko: 50 x 100 - PNG/JPG',0),(186641,5185,'no','Max stÃ¸rrelse: 50 x 100 - PNG/JPG',0),(186642,5185,'da','Max stÃ¸rrelse: 50 x 100 - PNG/JPG',0),(186643,5185,'ko','ìµœëŒ€ í¬ê¸°: 50 x 100-PNG ë˜ëŠ” JPG',0),(186644,5185,'he','×’×•×“×œ ×ž×™×¨×‘×™: 50 x 100 - PNG/JPG...',0),(186645,5185,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚: 50 x 100 - PNG/JPG',0),(186646,5185,'zh','æœ€å¤§è§„æ ¼ï¼š50X100-PNG/ JPG/GIFæ ¼å¼\r\n',0),(186647,5185,'sv','Max storlek: 50 x 100 - PNG/JPG',0),(186648,5185,'it','Max dimensioni: 50 x 100 - PNG/JPG',0),(186649,5185,'tl','',0),(186650,5185,'th','&#3586;&#3609;&#3634;&#3604;&#3652;&#3617;&#3656;&#3648;&#3585;&#3636;&#3609; : 50x100 - PNG/JPG/GIF',0),(186651,5185,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤†à¤•à¤¾à¤°: 50 x 100 - PNG/JPG',0),(186652,5185,'ms','Saiz maksimum: 50 x 100 - PNG/JPG',0),(186653,5185,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ø­Ø¬Ù…: 50 Ã— 100-Ø¨Ø§Ø¨ÙˆØ§ Ù†ÙŠÙˆ ØºÙŠÙ†ÙŠØ§/JPG',0),(186654,5185,'fr','Taille max : 50 x 100 - PNG/JPG',0),(186655,5185,'jp','æœ€å¤§ã‚µã‚¤ã‚º: 50X100 - PNG/JPG/GIF',0),(186656,5185,'pt','Tamanho mÃ¡ximo: 50 x 100 - PNG/JPG',0),(186657,5185,'ru','ÐœÐ°ÐºÑ Ñ€Ð°Ð·Ð¼ÐµÑ€: 50 x 100 - PNG/JPG',0),(186658,5185,'es','Max TamaÃ±o 50X100 - PNG/JPG/GIF',0),(186659,5185,'de','Max. GrÃ¶ÃŸe: 50 x 100 - PNG/JPG',0),(186660,5185,'en','Max Size: 50x100 - PNG/JPG',0),(186661,5186,'is','',0),(186662,5186,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙƒÙˆÚ†Ùƒ ',0),(186663,5186,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙƒÙˆÚ†Ùƒ ',0),(186664,5186,'tr','En bÃ¼yÃ¼k boyutu kÃ¼Ã§Ã¼k',0),(186665,5186,'pl','Max rozmiar maÅ‚ych',0),(186666,5186,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð¼Ð°Ð»ÐºÐ¸',0),(186667,5186,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Ø§Ø¦Ø² Ú†Ú¾ÙˆÙ¹Û’',0),(186668,5186,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð¼Ð°Ð»Ð¸Ñ…',0),(186669,5186,'vi','Cá»¡ nhá» tá»‘i Ä‘a',0),(186670,5186,'af','Maksimum grootte klein',0),(186671,5186,'ro','Max dimensiuni mici',0),(186672,5186,'et','Max suurus vÃ¤ike',0),(186673,5186,'si','Max velikost malega',0),(186674,5186,'ba','Max ukuran kecil',0),(186675,5186,'nl','Max grootte kleine',0),(186676,5186,'fi','Max koko pieni',0),(186677,5186,'no','Max stÃ¸rrelse Small',0),(186678,5186,'da','Max stÃ¸rrelse lille',0),(186679,5186,'ko','ìµœëŒ€ í¬ê¸° ìž‘ì€',0),(186680,5186,'he','×’×•×“×œ ×ž×¨×‘×™ ×§×˜×Ÿ',0),(186681,5186,'el','Max Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î¼Î¹ÎºÏÏŒ',0),(186682,5186,'zh','æœ€å¤§å°ºå¯¸å°\r\n',0),(186683,5186,'sv','Max storlek Small',0),(186684,5186,'it','Max dimensioni piccole',0),(186685,5186,'tl','',0),(186686,5186,'th','&#3586;&#3609;&#3634;&#3604;&#3607;&#3637;&#3656;&#3651;&#3627;&#3597;&#3656;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3586;&#3629;&#3591;&#3586;&#3609;&#3634;&#3604;&#3648;&#3621;&#3655;&#3585;',0),(186687,5186,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤†à¤•à¤¾à¤° à¤›à¥‹à¤Ÿà¤¾',0),(186688,5186,'ms','Maksimum saiz kecil',0),(186689,5186,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ø­Ø¬Ù… Ø§Ù„ØµØºÙŠØ±Ø©',0),(186690,5186,'fr','Max taille petit',0),(186691,5186,'jp','æœ€å°?ã‚µã‚¤ã‚º',0),(186692,5186,'pt','Max tamanho pequeno',0),(186693,5186,'ru','ÐœÐ°ÐºÑ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð¼Ð°Ð»Ñ‹Ñ…',0),(186694,5186,'es','Max TamaÃ±o Chico',0),(186695,5186,'de','Max GrÃ¶ÃŸe Small',0),(186696,5186,'en','Max Size Small',0),(186697,5187,'is','',0),(186698,5187,'dr','Ø­Ù…Ù„ Ø§ÙˆÙ„ÙŠÙ‡ Ø§Ø² ',0),(186699,5187,'pr','Ø­Ù…Ù„ Ø§ÙˆÙ„ÙŠÙ‡ Ø§Ø² ',0),(186700,5187,'tr','Orijinal gemi',0),(186701,5187,'pl','Oryginalny statek z',0),(186702,5187,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸Ñ ÐºÐ¾Ñ€Ð°Ð± Ð¾Ñ‚',0),(186703,5187,'ur','Ø§ØµÙ„ Ø¬ÛØ§Ø² Ø³Û’',0),(186704,5187,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ Ð±Ñ€Ð¾Ð´ Ð¾Ð´',0),(186705,5187,'vi','Chuyáº¿n hÃ ng tá»«',0),(186706,5187,'af','Oorspronklik Versend Vanaf',0),(186707,5187,'ro','Navei originale din',0),(186708,5187,'et','Algne laeva',0),(186709,5187,'si','Original ladje iz',0),(186710,5187,'ba','Kapal asli dari',0),(186711,5187,'nl','Oorspronkelijke schip uit',0),(186712,5187,'fi','AlkuperÃ¤inen alus',0),(186713,5187,'no','Opprinnelige skipet fra',0),(186714,5187,'da','Oprindelige skib fra',0),(186715,5187,'ko','ì›ëž˜ ë°°',0),(186716,5187,'he','×”×¡×¤×™× ×” ×”×ž×§×•×¨×™×ª ×©×œ',0),(186717,5187,'el','Î‘ÏÏ‡Î¹ÎºÏŒ Ï€Î»Î¿Î¯Î¿ Î±Ï€ÏŒ',0),(186718,5187,'zh','åŽŸå‘è´§åœ°\r\n',0),(186719,5187,'sv','Ursprungliga fartyget frÃ¥n',0),(186720,5187,'it','Nave originale da',0),(186721,5187,'tl','',0),(186722,5187,'th','&#3604;&#3633;&#3657;&#3591;&#3648;&#3604;&#3636;&#3617;&#3586;&#3609;&#3626;&#3656;&#3591;&#3592;&#3634;&#3585;',0),(186723,5187,'hi','à¤®à¥‚à¤² à¤œà¤¹à¤¾à¤œ à¤¸à¥‡',0),(186724,5187,'ms','Asal kapal dari',0),(186725,5187,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„Ø£ØµÙ„ÙŠ Ù…Ù†',0),(186726,5187,'fr','Navire original de',0),(186727,5187,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«ç™ºé€?ãƒ•ã‚©ãƒ¼ãƒ ',0),(186728,5187,'pt','Navio original de',0),(186729,5187,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¾Ñ‚',0),(186730,5187,'es','Original Enviar De',0),(186731,5187,'de','UrsprÃ¼ngliche Schiff aus',0),(186732,5187,'en','Original Ship From',0),(186733,5188,'is','',0),(186734,5188,'dr','(Ù…Ø§Ù†Ù†Ø¯',0),(186735,5188,'pr','Ø¨Ù‡ Ù‡Ù…Ø§Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ (Ù…Ø§Ù†Ù†Ø¯',0),(186736,5188,'tr','AynÄ±',0),(186737,5188,'pl','Sam',0),(186738,5188,'bg','Ð¡ÑŠÑ‰Ð¸Ñ‚Ðµ',0),(186739,5188,'ur','Ø§Ø³ÛŒ',0),(186740,5188,'sr','Ð˜ÑÑ‚Ð¸',0),(186741,5188,'vi','Giá»‘ng nhau',0),(186742,5188,'af','Dieselfde',0),(186743,5188,'ro','AcelaÅŸi',0),(186744,5188,'et','Sama',0),(186745,5188,'si','Isti',0),(186746,5188,'ba','Sama',0),(186747,5188,'nl','Dezelfde',0),(186748,5188,'fi','Samalla',0),(186749,5188,'no','Samme',0),(186750,5188,'da','Samme',0),(186751,5188,'ko','ê°™ì€',0),(186752,5188,'he','××•×ª×•',0),(186753,5188,'el','ÎŠÎ´Î¹Î±',0),(186754,5188,'zh','åŒæ ·\r\n',0),(186755,5188,'sv','Samma',0),(186756,5188,'it','Stesso',0),(186757,5188,'tl','',0),(186758,5188,'th','&#3648;&#3627;&#3617;&#3639;&#3629;&#3609;&#3585;&#3633;&#3609;',0),(186759,5188,'hi','à¤à¤• à¤¹à¥€',0),(186760,5188,'ms','Sama',0),(186761,5188,'ar','Ù†ÙØ³',0),(186762,5188,'fr','MÃªme',0),(186763,5188,'jp','å?Œã?˜',0),(186764,5188,'pt','Mesmo',0),(186765,5188,'ru','Ð–Ðµ',0),(186766,5188,'es','Mismo',0),(186767,5188,'de','Gleichen',0),(186768,5188,'en','Same',0),(186769,5189,'is','',0),(186770,5189,'dr','(Ú†Ùƒ) Ù†Ø§Ù…ÙˆÙÙ‚ Ø¯Ø± Ø¨Ø§Ø·Ù„ Ú©Ø±Ø¯Ù†',0),(186771,5189,'pr','Ø¨Ø±Ø±Ø³ÙŠ(Ú†Ùƒ) Ù†Ø§Ù…ÙˆÙÙ‚ Ø¯Ø± Ø¨Ø§Ø·Ù„ Ú©Ø±Ø¯Ù†',0),(186772,5189,'tr','GeÃ§ersiz baÅŸarÄ±sÄ±z onay',0),(186773,5189,'pl','Wyboru nie powiodÅ‚o siÄ™ w otchÅ‚ani',0),(186774,5189,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð° Ð½Ð° Void Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(186775,5189,'ur','Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©Û’ Ø®Ù„Ø§ Ù¾Ø± Ù†Ø§Ú©Ø§Ù…',0),(186776,5189,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´Ð° Ð½Ð¸ÑÐ¸ Ð¸ÑÐ¿ÑƒÐ½Ð¸Ð¾ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ñƒ',0),(186777,5189,'vi','Kiá»ƒm tra tháº¥t báº¡i',0),(186778,5189,'af','Kontroleer op leemte het misluk',0),(186779,5189,'ro','Selectare a eÅŸuat pe gol',0),(186780,5189,'et','Kontroll ebaÃµnnestus Void',0),(186781,5189,'si','ÄŒek ne zadostovati na praznino',0),(186782,5189,'ba','Cek gagal pada kekosongan',0),(186783,5189,'nl','Controle mislukt op Void',0),(186784,5189,'fi','Tarkistus epÃ¤onnistui Void',0),(186785,5189,'no','Sjekk mislykkes pÃ¥ Void',0),(186786,5189,'da','Check mislykkedes pÃ¥ tomrum',0),(186787,5189,'ko','ê²€ì‚¬ ë¬´íš¨ì— ì‹¤íŒ¨',0),(186788,5189,'he','×”×¡×™×ž×•×Ÿ × ×›×©×œ×” ×‘- Void',0),(186789,5189,'el','Î•Î»Î­Î³Ï‡Î¿Ï… Î±Ï€Î­Ï„Ï…Ï‡Îµ ÏƒÏ„Î¿ ÎºÎµÎ½ÏŒ',0),(186790,5189,'zh','æ£€æŸ¥å¤±è´¥çš„ç©º\r\n',0),(186791,5189,'sv','Kontroll misslyckades pÃ¥ Void',0),(186792,5189,'it','Controllo fallito il vuoto',0),(186793,5189,'tl','',0),(186794,5189,'th','&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3594;&#3655;&#3588;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(186795,5189,'hi','à¤šà¥‡à¤• à¤ªà¤° à¤¶à¥‚à¤¨à¥à¤¯ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(186796,5189,'ms','Memeriksa gagal pada kekosongan',0),(186797,5189,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ÙØ´Ù„ ÙÙŠ Ø§Ù„ÙØ±Ø§Øº',0),(186798,5189,'fr','VÃ©rification a Ã©chouÃ© sur le vide',0),(186799,5189,'jp','å°?åˆ‡æ‰‹ã?®ç ´æ£„ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(186800,5189,'pt','VerificaÃ§Ã£o falhada em vazio',0),(186801,5189,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð° Void',0),(186802,5189,'es','Cheque FallÃ³ en Nulo',0),(186803,5189,'de','Check fehlgeschlagen auf Void',0),(186804,5189,'en','Check Failed on Void',0),(186805,5190,'is','',0),(186806,5190,'dr','ØªØºÙŠÙŠØ± Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(186807,5190,'pr','ØªØºÙŠÙŠØ± Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(186808,5190,'tr','Onay numarasÄ± deÄŸiÅŸikliÄŸi baÅŸarÄ±sÄ±z',0),(186809,5190,'pl','SprawdÅº numer zmiany nie powiodÅ‚o siÄ™',0),(186810,5190,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð³Ñ€ÐµÑˆÐºÐ°',0),(186811,5190,'ur','Ú†ÛŒÚ© Ù†Ù…Ø¨Ø± ØªØ¨Ø¯ÛŒÙ„ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(186812,5190,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° Ð±Ñ€Ð¾Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(186813,5190,'vi','Thay sá»‘ SÃ©c tháº¥t báº¡i',0),(186814,5190,'af','Tjeknommer verandering het gefaal',0),(186815,5190,'ro','Schimbare numÄƒr Failed',0),(186816,5190,'et','Kontrollige numbri muutmine nurjus',0),(186817,5190,'si','Preverite Å¡tevilo sprememb ni uspelo',0),(186818,5190,'ba','Memeriksa nomor perubahan gagal',0),(186819,5190,'nl','Selectievakje nummer wijzigen mislukt',0),(186820,5190,'fi','Tarkista muutoksesta epÃ¤onnistui',0),(186821,5190,'no','Kontroller nummeret endring mislyktes',0),(186822,5190,'da','Check nummer Skift mislykkedes',0),(186823,5190,'ko','í™•ì¸ ë²ˆí˜¸ ë³€ê²½ ì‹¤íŒ¨',0),(186824,5190,'he','×©×™× ×•×™ ×ž×¡×¤×¨ ×”×¡×™×ž×•×Ÿ × ×›×©×œ×”',0),(186825,5190,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Î»Î»Î±Î³Î®Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(186826,5190,'zh','æ”¯ç¥¨å·ç æ›´æ”¹å¤±è´¥\r\n',0),(186827,5190,'sv','Kontrollera antalet fÃ¶rÃ¤ndring misslyckades',0),(186828,5190,'it','Verifica numero modifica non riuscita',0),(186829,5190,'tl','',0),(186830,5190,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&#3588;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(186831,5190,'hi','à¤šà¥‡à¤• à¤•à¥à¤°à¤®à¤¾à¤‚à¤• à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤µà¤¿à¤«à¤²',0),(186832,5190,'ms','Penukaran nombor Daftar gagal',0),(186833,5190,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† ØªØºÙŠÙŠØ± Ø±Ù‚Ù… ÙØ´Ù„',0),(186834,5190,'fr','Changement de numÃ©ro Check Failed',0),(186835,5190,'jp','å°?åˆ‡æ‰‹ç•ªå?·ã?®å¤‰æ›´ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(186836,5190,'pt','MudanÃ§a de nÃºmero de verificaÃ§Ã£o falha',0),(186837,5190,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(186838,5190,'es','FallÃ³ el cambio de nÃºmero de cheque ',0),(186839,5190,'de','Ã„nderung der Anzahl Fehler Ã¼berprÃ¼fen',0),(186840,5190,'en','Check number change Failed',0),(186841,5191,'is','',0),(186842,5191,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(186843,5191,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(186844,5191,'tr','BaÅŸarÄ±sÄ±z onay yazma',0),(186845,5191,'pl','Wyboru pisanie nie powiodÅ‚o siÄ™',0),(186846,5191,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¿Ð¸ÑÐ°Ð½Ðµ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(186847,5191,'ur','Ù†Ø§Ú©Ø§Ù… Ù„Ú©Ú¾Ù†Û’ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(186848,5191,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¿Ð¸ÑÐ°ÑšÐ° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð°.',0),(186849,5191,'vi','Viáº¿t SÃ©c tháº¥t báº¡i',0),(186850,5191,'af','Uitskrywe van Tjek het gefaal',0),(186851,5191,'ro','Scris de verificare nu a reuÅŸit',0),(186852,5191,'et','Sisse kirjutamine nurjus',0),(186853,5191,'si','Pisno preverjanje ni uspelo',0),(186854,5191,'ba','Periksa menulis gagal',0),(186855,5191,'nl','Selectievakje schrijven mislukt',0),(186856,5191,'fi','Uloskirjautuminen kirjoittaminen epÃ¤onnistui',0),(186857,5191,'no','Sjekk skriving mislyktes',0),(186858,5191,'da','Check skrivning mislykkedes',0),(186859,5191,'ko','ê¸€ì„ í™•ì¸ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(186860,5191,'he','×”×¡×™×ž×•×Ÿ ×›×ª×™×‘×” × ×›×©×œ×”',0),(186861,5191,'el','Î“ÏÎ±Ï†Î®Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(186862,5191,'zh','æ£€æŸ¥ä¹¦å†™å¤±è´¥\r\n',0),(186863,5191,'sv','Det gick inte att kontrollera skrift',0),(186864,5191,'it','Verifica scrittura fallita',0),(186865,5191,'tl','',0),(186866,5191,'th','&#3585;&#3634;&#3619;&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(186867,5191,'hi','à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤²',0),(186868,5191,'ms','Semak menulis gagal',0),(186869,5191,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† ÙƒØªØ§Ø¨Ø© Ø§Ù„ÙØ§Ø´Ù„Ø©',0),(186870,5191,'fr','Cocher Ã©criture a Ã©chouÃ©',0),(186871,5191,'jp','å°?åˆ‡æ‰‹ã?®æ›¸ã??è¾¼ã?¿ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(186872,5191,'pt','VerificaÃ§Ã£o escrita falhou',0),(186873,5191,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(186874,5191,'es','Escribir Cheque FallÃ³',0),(186875,5191,'de','KontrollkÃ¤stchen Schreiben fehlgeschlagen',0),(186876,5191,'en','Check writing failed',0),(186877,5192,'is','',0),(186878,5192,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† Ø¬Ø¯ÙŠØ¯',0),(186879,5192,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ† Ø¬Ø¯ÙŠØ¯',0),(186880,5192,'tr','Yeni bir makine aile eklemek',0),(186881,5192,'pl','Dodaj nowÄ… rodzinÄ™ maszyny',0),(186882,5192,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(186883,5192,'ur','Ø§ÛŒÚ© Ù†Ø¦ÛŒ Ù…Ø´ÛŒÙ† Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(186884,5192,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ñƒ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(186885,5192,'vi','ThÃªm 1 DÃ²ng MÃ¡y Gia ÄÃ¬nh Má»›i',0),(186886,5192,'af','Voeg \'n Nuwe Familie Masjien by',0),(186887,5192,'ro','Adauga un grup nou',0),(186888,5192,'et','Lisa uus masin pere',0),(186889,5192,'si','Dodaj novo druÅ¾ino stroj',0),(186890,5192,'ba','Tambahkan keluarga mesin baru',0),(186891,5192,'nl','Toevoegen van een nieuwe Machine-familie',0),(186892,5192,'fi','Luoda uuden koneen perheen',0),(186893,5192,'no','Legge til en ny maskin familie',0),(186894,5192,'da','TilfÃ¸je en ny maskine familie',0),(186895,5192,'ko','ìƒˆë¡œìš´ ê¸°ê³„ ê°€ì¡± ì¶”ê°€',0),(186896,5192,'he','×”×•×¡×£ ×ž×©×¤×—×ª ×ž×›×©×™×¨×™× ×—×“×©×”',0),(186897,5192,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î½Î­Î± Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Î¼Î·Ï‡Î±Î½ÏŽÎ½',0),(186898,5192,'zh','å¢žåŠ ä¸€å€‹æ–°æ©Ÿå™¨ç³»åˆ—\r\n',0),(186899,5192,'sv','LÃ¤gga till en ny maskinfamilj',0),(186900,5192,'it','Aggiungere una nuova famiglia di macchina',0),(186901,5192,'tl','',0),(186902,5192,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;&#3594;&#3640;&#3604;',0),(186903,5192,'hi','à¤à¤• à¤¨à¤ˆ à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(186904,5192,'ms','Tambah keluarga Mesin baru',0),(186905,5192,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ø§Ø¦Ù„Ø© Ø¢Ù„Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(186906,5192,'fr','Ajouter une Nouvelle machine familiale\r\n',0),(186907,5192,'jp','æ–°è¦?æ©Ÿæ¢°ç³»çµ±ã?®è¿½åŠ ',0),(186908,5192,'pt','Adicionar uma nova famÃ­lia de mÃ¡quina',0),(186909,5192,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð³Ð¾ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð° Ð¼Ð°ÑˆÐ¸Ð½',0),(186910,5192,'es','Agregar una Nueva Familia de MÃ¡quinas',0),(186911,5192,'de','FÃ¼gen Sie eine neue Maschine-Familie',0),(186912,5192,'en','Add a New Machine Family',0),(186913,5193,'is','',0),(186914,5193,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(186915,5193,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(186916,5193,'tr','Makine aile ayrÄ±ntÄ±larÄ± ekleme',0),(186917,5193,'pl','Dodawanie szczegÃ³Å‚Ã³w rodziny maszyny',0),(186918,5193,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÑ‚Ðµ Ð¼Ð°ÑˆÐ¸Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸',0),(186919,5193,'ur','Ù…Ø´ÛŒÙ† Ú©ÛŒ Ø®Ø§Ù†Ø¯Ø§Ù†ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(186920,5193,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¼Ð°ÑˆÐ¸Ð½Ð° Ð´ÐµÑ‚Ð°Ñ™Ð¸ Ð¾ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð¸',0),(186921,5193,'vi','ThÃªm Chi Tiáº¿t DÃ²ng MÃ¡y Gia ÄÃ¬nh ',0),(186922,5193,'af','Masjien Familiebesonderhede Byvoeg',0),(186923,5193,'ro','Adauga detalii despre familia de produse',0),(186924,5193,'et','Lisa masin pere andmed',0),(186925,5193,'si','Dodaj stroj druÅ¾ine podrobnosti',0),(186926,5193,'ba','Menambahkan rincian keluarga mesin',0),(186927,5193,'nl','Machine familie Details toevoegen',0),(186928,5193,'fi','LisÃ¤Ã¤ koneen perheen tietoja',0),(186929,5193,'no','Legge til maskinen familie detaljer',0),(186930,5193,'da','TilfÃ¸je maskine familie detaljer',0),(186931,5193,'ko','ì»´í“¨í„° ê°€ì¡± ì„¸ë¶€ ì •ë³´ ì¶”ê°€',0),(186932,5193,'he','×”×•×¡×£ ×¤×¨×˜×™ ×ž×©×¤×—×ª ×ž×›×©×™×¨×™×',0),(186933,5193,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î¼Î·Ï‡Î±Î½Î®Î¼Î±Ï„Î¿Ï‚',0),(186934,5193,'zh','å¢žåŠ æœºå™¨ç³»åˆ—è¯¦æƒ…\r\n',0),(186935,5193,'sv','LÃ¤gga till familjen information om automaten',0),(186936,5193,'it','Aggiungere dettagli di famiglia macchina',0),(186937,5193,'tl','',0),(186938,5193,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(186939,5193,'hi','à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(186940,5193,'ms','Tambah butiran keluarga Mesin',0),(186941,5193,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø£Ø³Ø±Ø© Ø¢Ù„Ø©',0),(186942,5193,'fr','Ajouter Details de Type de Machine',0),(186943,5193,'jp','æ©Ÿæ¢°ç³»çµ±è©³ç´°ã?®è¿½åŠ ',0),(186944,5193,'pt','Adicionar detalhes de famÃ­lia de mÃ¡quina',0),(186945,5193,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡ÐµÐ¼ÐµÐ¹Ð½Ñ‹Ðµ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹',0),(186946,5193,'es','Agregar Detalles de Familia de MÃ¡quinas',0),(186947,5193,'de','Maschine Familie Details hinzufÃ¼gen',0),(186948,5193,'en','Add Machine Family Details',0),(186949,5194,'is','',0),(186950,5194,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(186951,5194,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(186952,5194,'tr','Makine aile ayrÄ±ntÄ± GÃ¼ncelleÅŸtir',0),(186953,5194,'pl','Aktualizacja rodziny szczegÃ³Å‚Ã³w maszyny',0),(186954,5194,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(186955,5194,'ur','Ù…Ø´ÛŒÙ† Ú©Û’ Ø®Ø§Ù†Ø¯Ø§Ù† Ú©ÛŒ ØªÙØµÛŒÙ„ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(186956,5194,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ðµ Ð´ÐµÑ‚Ð°Ñ™ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(186957,5194,'vi','Cáº­p Nháº­t Chi Tiáº¿t DÃ²ng MÃ¡y',0),(186958,5194,'af','Werk masjien familie besonderhede',0),(186959,5194,'ro','Actualizare masina de familie detaliu',0),(186960,5194,'et','Uuenda kohapeal pere Detail',0),(186961,5194,'si','Posodobitev stroj druÅ¾inskega natanÄno',0),(186962,5194,'ba','Memperbarui mesin keluarga Detail',0),(186963,5194,'nl','Machine familie Detail bijwerken',0),(186964,5194,'fi','PÃ¤ivitÃ¤ kone perheen tiedot',0),(186965,5194,'no','Oppdatere maskinen familie detaljer',0),(186966,5194,'da','Opdatere maskine familie detaljer',0),(186967,5194,'ko','ê¸°ê³„ ê°€ì¡± ì„¸ë¶€ ì •ë³´ ì—…ë°ì´íŠ¸',0),(186968,5194,'he','×œ×¢×“×›×Ÿ ×¤×¨×˜×™× ×ž×©×¤×—×” ×ž×›×•× ×ª',0),(186969,5194,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î·Ï‡Î±Î½Î® Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(186970,5194,'zh','æ›´æ–°æœºç³»åˆ—æ˜Žç»†\r\n',0),(186971,5194,'sv','Uppdatera maskin familj detalj',0),(186972,5194,'it','Aggiornare la macchina familiare dettaglio',0),(186973,5194,'tl','',0),(186974,5194,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(186975,5194,'hi','à¤®à¤¶à¥€à¤¨ à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(186976,5194,'ms','Kemaskini Terakhir Mesin butiran keluarga',0),(186977,5194,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¬Ù‡Ø§Ø² Ø§Ù„ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø£Ø³Ø±ÙŠØ©',0),(186978,5194,'fr','Mise Ã  jour de la Machine familiale dÃ©tail',0),(186979,5194,'jp','æ©Ÿæ¢°ç³»è©³ç´°ã?®æ›´æ–°',0),(186980,5194,'pt','Atualizar a mÃ¡quina familiar detalhe',0),(186981,5194,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐµÐ¼ÑŒÐ¸ Ð´ÐµÑ‚Ð°Ð»ÑŒ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹',0),(186982,5194,'es','Actualizar Detalle de Familia de MÃ¡quinas',0),(186983,5194,'de','Maschine Familie Detail zu aktualisieren',0),(186984,5194,'en','Update Machine Family Detail',0),(186985,5195,'is','',0),(186986,5195,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(186987,5195,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ù…Ø§Ø´ÙŠÙ†',0),(186988,5195,'tr','Makine aile bilgileri gÃ¼ncelleme',0),(186989,5195,'pl','Aktualizacja maszyny rodziny informacje',0),(186990,5195,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(186991,5195,'ur','Ù…Ø´ÛŒÙ† Ú©Û’ Ø®Ø§Ù†Ø¯Ø§Ù† Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(186992,5195,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð¸ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(186993,5195,'vi','Cáº­p Nháº­t ThÃ´ng Tin Chi Tiáº¿t DÃ²ng MÃ¡y',0),(186994,5195,'af','Opdateer Masjien Familie Inligting',0),(186995,5195,'ro','ActualizaÅ£i informaÅ£iile de maÅŸinÄƒ de familie',0),(186996,5195,'et','Kohapeal pere teabe vÃ¤rskendamine',0),(186997,5195,'si','Posodobitev stroj druÅ¾inske podatke',0),(186998,5195,'ba','Memperbarui informasi keluarga mesin',0),(186999,5195,'nl','Machine familie informatie bijwerken',0),(187000,5195,'fi','PÃ¤ivitÃ¤ kone perheen tiedot',0),(187001,5195,'no','Maskinen familie oppdateringsinformasjon',0),(187002,5195,'da','Opdatere maskine familiemÃ¦ssige oplysninger',0),(187003,5195,'ko','ê¸°ê³„ ê°€ì¡± ì •ë³´ ì—…ë°ì´íŠ¸',0),(187004,5195,'he','×¢×“×›×•×Ÿ ×¤×¨×˜×™ ×”×ž×©×¤×—×” ×ž×›×•× ×”',0),(187005,5195,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î·Ï‡Î±Î½Î® Î¿Î¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(187006,5195,'zh','æ›´æ–°æœºç³»åˆ—ä¿¡æ¯\r\n',0),(187007,5195,'sv','Uppdatera familj maskininformation',0),(187008,5195,'it','Aggiornare informazioni famiglia macchina',0),(187009,5195,'tl','',0),(187010,5195,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3594;&#3640;&#3604;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3592;&#3633;&#3585;&#3619;',0),(187011,5195,'hi','à¤®à¤¶à¥€à¤¨ à¤ªà¤¾à¤°à¤¿à¤µà¤¾à¤°à¤¿à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(187012,5195,'ms','Mengemaskini maklumat keluarga Mesin',0),(187013,5195,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¬Ù‡Ø§Ø² Ø§Ù„Ø£Ø³Ø±Ø©',0),(187014,5195,'fr','Mise Ã  jour de la Machine sur la famille',0),(187015,5195,'jp','æ©Ÿæ¢°ç³»çµ±æƒ…å ±ã?®æ›´æ–°',0),(187016,5195,'pt','Atualizar informaÃ§Ãµes de familiares de mÃ¡quina',0),(187017,5195,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ ÑÐµÐ¼ÐµÐ¹Ð½Ð¾Ð¹ Ð¼Ð°ÑˆÐ¸Ð½Ñ‹',0),(187018,5195,'es','Actualizar InformaciÃ³n de Familia de MÃ¡quinas',0),(187019,5195,'de','Familie-Informationen zu aktualisieren',0),(187020,5195,'en','Update Machine Family Information',0),(187021,5196,'is','',0),(187022,5196,'dr','Ø¨Ø±Ø§ÙŠ Ø­Ø°Ù ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(187023,5196,'pr','Ø¨Ø±Ø§ÙŠ Ø­Ø°Ù ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(187024,5196,'tr','Silmek iÃ§in tÄ±klatÄ±n',0),(187025,5196,'pl','Kliknij, aby usunÄ…Ä‡',0),(187026,5196,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(187027,5196,'ur','Ú©Û’ Ø­Ø°Ù Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(187028,5196,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð·Ð° Ð±Ñ€Ð¸ÑÐ°ÑšÐµ',0),(187029,5196,'vi','Nháº¥n Ä‘á»ƒ XÃ³a',0),(187030,5196,'af','Kliek om te Skrap',0),(187031,5196,'ro','FaceÅ£i clic pe Åžtergere',0),(187032,5196,'et','Kustutamiseks klÃµpsa',0),(187033,5196,'si','Kliknite IzbriÅ¡i',0),(187034,5196,'ba','Klik untuk menghapus',0),(187035,5196,'nl','Klik op verwijderen',0),(187036,5196,'fi','Klikkaa Poista',0),(187037,5196,'no','Klikk Slett',0),(187038,5196,'da','Klik for at slette',0),(187039,5196,'ko','ì‚­ì œë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(187040,5196,'he','×œ×—×¥ ×¢×œ ×ž×—×§',0),(187041,5196,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ',0),(187042,5196,'zh','ç‚¹å‡»åˆ é™¤\r\n',0),(187043,5196,'sv','Klicka pÃ¥ ta bort',0),(187044,5196,'it','Fare clic su Elimina',0),(187045,5196,'tl','',0),(187046,5196,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3621;&#3610;',0),(187047,5196,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¤Ÿà¤¾à¤à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(187048,5196,'ms','Klik untuk Hapus',0),(187049,5196,'ar','Ø£Ù†Ù‚Ø± Ù„Ù„Ø­Ø°Ù',0),(187050,5196,'fr','Cliquez sur Delete',0),(187051,5196,'jp','æ¶ˆåŽ»ã?™ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(187052,5196,'pt','Clique para excluir',0),(187053,5196,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð´Ð»Ñ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ñ',0),(187054,5196,'es','Click para Eliminar',0),(187055,5196,'de','Klicken Sie auf LÃ¶schen',0),(187056,5196,'en','Click to Delete',0),(187057,5197,'is','',0),(187058,5197,'dr','(Ø§Ø®ÙŠØ±',0),(187059,5197,'pr','Ø¯Ù„Ø§ÙŠÙ„ Ú¯Ø°Ø´ØªÙ‡ (Ø§Ø®ÙŠØ±',0),(187060,5197,'tr','GeÃ§ nedenleri',0),(187061,5197,'pl','Koniec powodÃ³w',0),(187062,5197,'bg','ÐšÑŠÑÐ½Ð¾ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð¸',0),(187063,5197,'ur','ØªØ§Ø®ÛŒØ± Ú©ÛŒ ÙˆØ¬ÙˆÛØ§Øª',0),(187064,5197,'sr','ÐŸÐ¾ÐºÐ¾Ñ˜Ð½Ð¸ Ñ€Ð°Ð·Ð»Ð¾Ð³Ðµ',0),(187065,5197,'vi','NguyÃªn nhÃ¢n muá»™n',0),(187066,5197,'af','Laat redes',0),(187067,5197,'ro','Motive de Ã®ntÃ¢rziere',0),(187068,5197,'et','Hilinenud pÃµhjustel',0),(187069,5197,'si','Pozno razlogov',0),(187070,5197,'ba','Alasan akhir',0),(187071,5197,'nl','Laat redenen',0),(187072,5197,'fi','MyÃ¶hÃ¤ssÃ¤ syitÃ¤',0),(187073,5197,'no','Sen grunner',0),(187074,5197,'da','Sen grunde',0),(187075,5197,'ko','ëŠ¦ì€ ì´ìœ ',0),(187076,5197,'he','×¡×™×‘×•×ª ×ž××•×—×¨',0),(187077,5197,'el','Î¤Î­Î»Î· Î»ÏŒÎ³Î¿Ï…Ï‚',0),(187078,5197,'zh','é€¾æœŸåŽŸå› \r\n',0),(187079,5197,'sv','Sen skÃ¤l',0),(187080,5197,'it','Motivi tardi',0),(187081,5197,'tl','',0),(187082,5197,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3621;&#3656;&#3634;&#3594;&#3657;&#3634;',0),(187083,5197,'hi','à¤•à¤¾à¤°à¤£à¥‹à¤‚ à¤¸à¥‡ à¤¦à¥‡à¤° à¤¹à¥‹ à¤—à¤ˆ',0),(187084,5197,'ms','Sebab-sebab yang lewat',0),(187085,5197,'ar','Ø£Ø³Ø¨Ø§Ø¨ Ø§Ù„ØªØ£Ø®Ø±',0),(187086,5197,'fr','Raisons de la fin',0),(187087,5197,'jp','é?…å»¶ç?†ç”±',0),(187088,5197,'pt','RazÃµes finais',0),(187089,5197,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ñ‹ Ð—Ð°Ð´ÐµÑ€Ð¶ÐºÐ¸',0),(187090,5197,'es','Explicaciones Tardes',0),(187091,5197,'de','SpÃ¤ten GrÃ¼nde',0),(187092,5197,'en','Late Reasons',0),(187093,5198,'is','',0),(187094,5198,'dr','(Ø§Ø®ÙŠØ±) Ø¨Ø§ Ø¢Ù† Ù†Ø§Ù… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(187095,5198,'pr','Ø¯Ù„ÙŠÙ„ Ú¯Ø°Ø´ØªÙ‡ (Ø§Ø®ÙŠØ±) Ø¨Ø§ Ø¢Ù† Ù†Ø§Ù… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(187096,5198,'tr','GeÃ§ sebebi zaten bu adda',0),(187097,5198,'pl','PowÃ³d pÃ³Åºno juÅ¼ z tÄ… nazwÄ…',0),(187098,5198,'bg','ÐšÑŠÑÐ½Ð¾ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð° Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ñ Ñ‚Ð¾Ð²Ð° Ð¸Ð¼Ðµ',0),(187099,5198,'ur','Ù…Ø±Ø­ÙˆÙ… Ú©ÛŒ ÙˆØ¬Û Ø§Ø³ Ú©Û’ Ù†Ø§Ù… Ú©Û’ Ø³Ø§ØªÚ¾ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(187100,5198,'sr','ÐšÐ°ÑÐ½Ð¾ Ñ€Ð°Ð·Ð»Ð¾Ð³ ÑÐ° Ñ‚Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(187101,5198,'vi','NguyÃªn nhÃ¢n muá»™n vá»›i tÃªn nÃ y Ä‘Ã£ tá»“n táº¡i',0),(187102,5198,'af','Laat Rede bestaan alreeds met daardie naam',0),(187103,5198,'ro','TÃ¢rziu motivul pentru care existÄƒ deja cu acest nume',0),(187104,5198,'et','Hilinemise pÃµhjus nimega juba olemas',0),(187105,5198,'si','Pozno razlog s tem imenom Å¾e obstaja',0),(187106,5198,'ba','Alasan akhir sudah ada dengan nama',0),(187107,5198,'nl','Laat reden bestaat al met die naam',0),(187108,5198,'fi','MyÃ¶hÃ¤Ã¤n syy on jo samanniminen',0),(187109,5198,'no','Sen grunn finnes allerede med dette navnet',0),(187110,5198,'da','Sen grund findes allerede med navnet',0),(187111,5198,'ko','ëŠ¦ì€ ì´ìœ ëŠ” ì´ë¯¸ ê·¸ ì´ë¦„ì„ ê°€ì§„ ì¡´ìž¬',0),(187112,5198,'he','×”×¡×™×‘×” ×ž××•×—×¨ ×›×‘×¨ ×§×™×™× ×¢× ×”×©× ×›×–×”',0),(187113,5198,'el','Î¤Î­Î»Î· Î»ÏŒÎ³Î¿ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(187114,5198,'zh','é€¾æœŸåŽŸå› ä¸Žè¯¥åç§°å·²å­˜åœ¨\r\n',0),(187115,5198,'sv','Sen anledning finns redan med det namnet',0),(187116,5198,'it','Motivo fine esiste giÃ  con quel nome',0),(187117,5198,'tl','',0),(187118,5198,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3621;&#3656;&#3634;&#3594;&#3657;&#3634;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;&#3585;&#3633;&#3610;&#3594;&#3639;&#3656;&#3629;',0),(187119,5198,'hi','à¤•à¤¾à¤°à¤£ à¤•à¥‡ à¤¦à¥‡à¤° à¤¸à¥‡ à¤‰à¤¸ à¤¨à¤¾à¤® à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(187120,5198,'ms','Lewat sebab telah wujud dengan nama itu',0),(187121,5198,'ar','Ø³Ø¨Ø¨ Ø§Ù„ØªØ£Ø®Ø± Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹ Ø¨Ù‡Ø°Ø§ Ø§Ù„Ø§Ø³Ù…',0),(187122,5198,'fr','Motif fin existe dÃ©jÃ  avec ce nom',0),(187123,5198,'jp','ã??ã?®å??å‰?ã?§æ—¢ã?«é?…å»¶ç?†ç”±ã?Œå­˜åœ¨ã?—ã?¾ã?™',0),(187124,5198,'pt','RazÃ£o tarde jÃ¡ existe com esse nome',0),(187125,5198,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ð¾Ð·Ð´Ð½ÐµÐ³Ð¾ Ñ Ñ‚Ð°ÐºÐ¸Ð¼ Ð¸Ð¼ÐµÐ½ÐµÐ¼ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(187126,5198,'es','ExplicaciÃ³n Tarde ya existe con ese nombre',0),(187127,5198,'de','SpÃ¤ten Grund mit diesem Namen ist bereits vorhanden.',0),(187128,5198,'en','Late Reason already exists with that name',0),(187129,5199,'is','',0),(187130,5199,'dr','Ø¯Ø±Ø¨Ø§Ø±Ù‡',0),(187131,5199,'pr','Ø¯Ø±Ø¨Ø§Ø±Ù‡',0),(187132,5199,'tr','HakkÄ±nda',0),(187133,5199,'pl','O',0),(187134,5199,'bg','Ð—Ð°',0),(187135,5199,'ur','ØªÙ‚Ø±ÛŒØ¨Ø§Ù‹',0),(187136,5199,'sr','Ðž',0),(187137,5199,'vi','Vá»',0),(187138,5199,'af','Omtrent',0),(187139,5199,'ro','Despre',0),(187140,5199,'et','Umbes',0),(187141,5199,'si','O',0),(187142,5199,'ba','Tentang',0),(187143,5199,'nl','Over',0),(187144,5199,'fi','Tietoja',0),(187145,5199,'no','Om',0),(187146,5199,'da','Om',0),(187147,5199,'ko','ì— ëŒ€ í•œ',0),(187148,5199,'he','××•×“×•×ª',0),(187149,5199,'el','Î£Ï‡ÎµÏ„Î¹ÎºÎ¬',0),(187150,5199,'zh','å…³äºŽ',0),(187151,5199,'sv','Om',0),(187152,5199,'it','Informazioni',0),(187153,5199,'tl','',0),(187154,5199,'th','à¹€à¸à¸µà¹ˆà¸¢à¸§à¸à¸±à¸š',0),(187155,5199,'hi','à¤•à¥‡ à¤¬à¤¾à¤°à¥‡ à¤®à¥‡à¤‚',0),(187156,5199,'ms','Kira-kira',0),(187157,5199,'ar','Ø­ÙˆÙ„',0),(187158,5199,'fr','Ã€ Propos',0),(187159,5199,'jp','ï½žã?«ã?¤ã?„ã?¦',0),(187160,5199,'pt','Sobre',0),(187161,5199,'ru','Ðž',0),(187162,5199,'es','Acerca',0),(187163,5199,'de','Ãœber',0),(187164,5199,'en','About',0),(187165,5200,'is','',0),(187166,5200,'dr','Noguska ØªÙˆØ³Ø· Ø´Ø±ÙƒØª Ø¨Ø§ Ù…Ø³ÙˆÙ„ÙŠØª Ù…Ø­Ø¯ÙˆØ¯ ',0),(187167,5200,'pr',' Noguska ØªÙˆØ³Ø· Ø´Ø±ÙƒØª Ø¨Ø§ Ù…Ø³ÙˆÙ„ÙŠØª Ù…Ø­Ø¯ÙˆØ¯ ',0),(187168,5200,'tr','Noguska LLC tarafÄ±ndan',0),(187169,5200,'pl','przez Noguska LLC',0),(187170,5200,'bg','Ð¾Ñ‚ Noguska LLC',0),(187171,5200,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù†ÙˆÚ¯ÙˆØ³Ú© LLC',0),(187172,5200,'sr','Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ ÐÐ¾Ð³ÑƒÑÐºÐ° Ð›Ð›Ð¦',0),(187173,5200,'vi','Do Noguska LLC',0),(187174,5200,'af','deur Noguska LLC',0),(187175,5200,'ro','Noguska SRL',0),(187176,5200,'et','Noguska OÃœ',0),(187177,5200,'si','Noguska LLC',0),(187178,5200,'ba','oleh Noguska LLC',0),(187179,5200,'nl','door Noguska LLC',0),(187180,5200,'fi','Noguska LLC',0),(187181,5200,'no','av Noguska LLC',0),(187182,5200,'da','af Noguska LLC',0),(187183,5200,'ko','Noguska LLCì˜ì— ì˜í•´',0),(187184,5200,'he','Noguska LLC ×¢\"×™',0),(187185,5200,'el','Î±Ï€ÏŒ Noguska LLC',0),(187186,5200,'zh','ç”±Noguskaæœ‰é™è´£ä»»å…¬å¸\r\n',0),(187187,5200,'sv','av Noguska LLC',0),(187188,5200,'it','di Noguska LLC',0),(187189,5200,'tl','',0),(187190,5200,'th','by Noguska LLC',0),(187191,5200,'hi','Noguska LLC à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(187192,5200,'ms','oleh Noguska LLC',0),(187193,5200,'ar','Ù…Ù† Ø° Ù†ÙˆØ¬ÙˆØ³ÙƒØ§',0),(187194,5200,'fr','par Noguska LLC',0),(187195,5200,'jp','Noguska LLCè£½',0),(187196,5200,'pt','por Noguska LLC',0),(187197,5200,'ru','Noguska ÐžÐžÐž',0),(187198,5200,'es','Por Noguska LLC',0),(187199,5200,'de','NolaPro LLC',0),(187200,5200,'en','by Noguska LLC',0),(187201,5201,'is','',0),(187202,5201,'dr','. Ø§ÙŠÙ† Ø¹Ù…Ù„ÙŠØ§Øª Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ú†Ù†Ø¯ Ø¯Ù‚ÙŠÙ‚Ù‡ Ø·ÙˆÙ„ Ø¨ÙƒØ´Ø¯ ',0),(187203,5201,'pr','Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¯Ø§Ø±Ø¯ . Ø§ÙŠÙ† Ø¹Ù…Ù„ÙŠØ§Øª Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ú†Ù†Ø¯ Ø¯Ù‚ÙŠÙ‚Ù‡ Ø·ÙˆÙ„ Ø¨ÙƒØ´Ø¯ ',0),(187204,5201,'tr','VeritabanÄ±nÄ±n gÃ¼ncelleÅŸtirilmesi gerekir.<br>Bu birkaÃ§ dakika sÃ¼rebilir.<br>Bu iÅŸlem tamamlanana kadar sizin tarayÄ±cÄ±yÄ± kapatmayÄ±n.',0),(187205,5201,'pl','Baza danych musi zostaÄ‡ zaktualizowany.<br>MoÅ¼e to potrwaÄ‡ kilka minut.<br>Nie zamknÄ…Ä‡ przeglÄ…darkÄ™, dopÃ³ki ten proces siÄ™ zakoÅ„czy.',0),(187206,5201,'bg','Ð‘Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸.<br>Ð¢Ð¾Ð²Ð° Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ñ‚Ð½ÐµÐ¼Ðµ Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð¸.<br>ÐÐµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð±Ñ€Ð°ÑƒÐ·ÑŠÑ€Ð° ÑÐ¸, Ð´Ð¾ÐºÐ°Ñ‚Ð¾ Ñ‚Ð¾Ð·Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ðµ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½.',0),(187207,5201,'ur','ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”<br>ÛŒÛ Ú†Ù†Ø¯ Ù…Ù†Ù¹ Ù„Û’ Ø³Ú©ØªØ§ ÛÛ’ Û”<br>ÛŒÛ Ø¹Ù…Ù„ Ù…Ú©Ù…Ù„ ÛÙˆÙ†Û’ ØªÚ© Ø¢Ù¾ Ú©Ø§ Ø¨Ø±Ø§Ø¤Ø²Ø± Ø¨Ù†Ø¯ Ù†ÛÛŒÚº Ú©Ø±ØªÛ’ Û”',0),(187208,5201,'sr','Ð‘Ð°Ð·Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° Ð±ÑƒÐ´Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.<br>ÐžÐ²Ð¾ Ð¼Ð¾Ð¶Ðµ Ð¿Ð¾Ñ‚Ñ€Ð°Ñ˜Ð°Ñ‚Ð¸ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð°.<br>ÐÐµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð²Ð°Ñˆ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‡ Ð´Ð¾Ðº ÑÐµ Ð½Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð¿Ñ€Ð¾Ñ†ÐµÑ.',0),(187209,5201,'vi','Dá»¯ Liá»‡u cáº§n Ä‘Æ°á»£c cáº­p nháº­t. Sáº½ máº¥t vÃ i phÃºt. KhÃ´ng Ä‘Ã³ng trÃ¬nh duyá»‡t cho Ä‘áº¿n khi hoÃ n táº¥t.',0),(187210,5201,'af','Hierdie databasis moet opdateer word <br>Dit mag \'n paar minute duur.<br>Moenie u soekenjin toemaak, alvorens die proses voltooi is nie.',0),(187211,5201,'ro','Baza de date trebuie sÄƒ fie actualizat.<br>Aceasta poate dura cÃ¢teva minute.<br>Nu Ã®nchideÅ£i browser-ul pÃ¢nÄƒ la finalizarea acestui proces.',0),(187212,5201,'et','Andmebaas vajab uuendamist.<br>Selleks vÃµib kuluda mÃµni minut.<br>Sulgete brauseri, kuni see protsess on lÃµpule viidud.',0),(187213,5201,'si','Zbirko podatkov je treba posodobiti.<br>To lahko traja nekaj minut.<br>VaÅ¡ brskalnik ne zaprite, dokler ta postopek konÄan.',0),(187214,5201,'ba','Database yang perlu dimutakhirkan.<br>Ini dapat berlangsung beberapa menit.<br>Jangan Tutup peramban sampai proses ini selesai.',0),(187215,5201,'nl','De database moet worden bijgewerkt.<br>Dit kan een paar minuten duren.<br>Sluit uw browser niet tot dit proces voltooid is.',0),(187216,5201,'fi','Tietokanta on pÃ¤ivitettÃ¤vÃ¤.<br>TÃ¤mÃ¤ voi kestÃ¤Ã¤ muutaman minuutin.<br>Ã„lÃ¤ sulje selaimesi, kunnes tÃ¤mÃ¤ prosessi on valmis.',0),(187217,5201,'no','Databasen mÃ¥ oppdateres.<br>Dette kan ta noen minutter.<br>Ikke lukk din nettleser fÃ¸r denne prosessen er fullfÃ¸rt.',0),(187218,5201,'da','Databasen skal opdateres.<br>Dette kan tage et par minutter.<br>Luk ikke din browser, fÃ¸r denne proces er fuldfÃ¸rt.',0),(187219,5201,'ko','ë°ì´í„°ë² ì´ìŠ¤ë¥¼ ì—…ë°ì´íŠ¸ í•´ì•¼ í•©ë‹ˆë‹¤.<br>ëª‡ ë¶„ ì •ë„ ê±¸ë¦´ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<br>ì´ í”„ë¡œì„¸ìŠ¤ê°€ ì™„ë£Œ ë  ë•Œê¹Œì§€ ë¸Œë¼ìš°ì €ë¥¼ ë‹«ì§€ ë§ˆì‹­ì‹œì˜¤.',0),(187220,5201,'he','×ž×¡×“ ×”× ×ª×•× ×™× ×¦×¨×™×š ×œ×”×™×•×ª ×ž×¢×•×“×›×Ÿ.<br>×¤×¢×•×œ×” ×–×• ×¢×©×•×™×” ×œ×”×™×ž×©×š ×ž×¡×¤×¨ ×“×§×•×ª.<br>×œ× ×œ×¡×’×•×¨ ××ª ×”×“×¤×“×¤×Ÿ ×©×œ×š ×¢×“ ×ª×”×œ×™×š ×–×” ×™×•×©×œ×.',0),(187221,5201,'el','Î— Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹.<br>Î‘Ï…Ï„ÏŒ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î¹Î±ÏÎºÎ­ÏƒÎµÎ¹ Î¼ÎµÏÎ¹ÎºÎ¬ Î»ÎµÏ€Ï„Î¬.<br>ÎšÎ¬Î½Ï‰ ÏŒÏ‡Î¹ ÎºÎ»ÎµÎ¯Î½Ï‰ browser ÏƒÎ±Ï‚ Î¼Î­Ï‡ÏÎ¹ Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ Î±Ï…Ï„Î® Î· Î´Î¹Î±Î´',0),(187222,5201,'zh','æ•°æ®åº“éœ€è¦æ›´æ–°ã€‚è¿™å¯èƒ½éœ€è¦å‡ åˆ†é’Ÿã€‚ ç‰©ç†åŒ–å­¦ï¼Œä¸è¦å…³é—­æµè§ˆå™¨ï¼Œç›´åˆ°è¿™ä¸ªè¿‡ç¨‹ç»“æŸã€‚\r\n',0),(187223,5201,'sv','Databasen mÃ¥ste uppdateras.<br>Detta kan ta nÃ¥gra minuter.<br>StÃ¤ng inte din webblÃ¤sare tills denna process Ã¤r klar.',0),(187224,5201,'it','Il database deve essere aggiornato.<br>L\'operazione potrebbe richiedere alcuni minuti.<br>Non chiudere il browser fino a quando questo processo Ã¨ completo.',0),(187225,5201,'tl','',0),(187226,5201,'th','The database needs to be updated. <br>This may take a few minutes. <br>Do not close your browser until this process is complete.',0),(187227,5201,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥ˆà¥¤<br>à¤‡à¤¸à¤®à¥‡à¤‚ à¤•à¥à¤› à¤®à¤¿à¤¨à¤Ÿ à¤²à¤— à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤<br>à¤‡à¤¸ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‡ à¤ªà¥‚à¤°à¥à¤£ à¤¹à¥‹à¤¨à¥‡ à¤¤à¤• à¤…à¤ªà¤¨à¤¾',0),(187228,5201,'ms','Pangkalan data tersebut perlu dikemaskini.<br>Ini mungkin mengambil beberapa minit.<br>Tutup pelayar anda sehingga proses ini selesai.',0),(187229,5201,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø¨Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰ ØªØ­Ø¯ÙŠØ«. Ù‚Ø¯ ÙŠØ³ØªØºØ±Ù‚ Ø°Ù„Ùƒ Ø¹Ø¯Ø© Ø¯Ù‚Ø§Ø¦Ø§Ù‚. Ù„Ø§ ØªØºÙ„Ù‚ Ù…ØªØµÙØ­ Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª Ù‚Ø¨Ù„ Ø£Ù† ØªÙƒØªÙ…Ù„ Ù‡Ø°Ù‡ Ø§Ù„Ø¹Ù…Ù„ÙŠØ©.',0),(187230,5201,'fr','La base de donnÃ©es doit Ãªtre mis Ã  jour.<br>Cela peut prendre quelques minutes.<br>Ne fermez pas votre navigateur jusqu\'Ã  ce que ce processus est terminÃ©.',0),(187231,5201,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?¯æ›´æ–°ã?Œå¿…è¦?ã?§ã?™<br>ã?“ã‚Œã?«ã?¯ä½•åˆ†ã?‹ã?‹ã‚Šã?¾ã?™<br>ã?“ã?®é?Žç¨‹ã?Œå®Œäº†ã?™ã‚‹ã?¾ã?§ãƒ–ãƒ©ã‚¦ã‚¶ã‚’é–‰ã?˜ã?ªã?„ã?§ä¸‹ã?•ã?„',0),(187232,5201,'pt','O banco de dados precisa ser atualizado.<br>Isto pode levar alguns minutos.<br>NÃ£o feche seu navegador atÃ© que este processo estÃ¡ completo.',0),(187233,5201,'ru','Ð‘Ð°Ð·Ñƒ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ.<br>Ð­Ñ‚Ð¾ Ð¼Ð¾Ð¶ÐµÑ‚ Ð·Ð°Ð½ÑÑ‚ÑŒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚.<br>ÐÐµ Ð·Ð°ÐºÑ€Ñ‹Ð²Ð°Ñ‚ÑŒ Ð²Ð°Ñˆ Ð±Ñ€Ð°ÑƒÐ·ÐµÑ€ Ð´Ð¾ Ñ‚ÐµÑ… Ð¿Ð¾Ñ€, Ð¿Ð¾ÐºÐ° ÑÑ‚Ð¾Ñ‚ Ð¿Ñ€Ð¾Ñ†ÐµÑÑ Ð½Ðµ Ð·Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑÑ.',0),(187234,5201,'es','La base de datos se necesita actualizar.<br>Este puede tomar unos minutos.<br>No cierre su explorador de web.',0),(187235,5201,'de','Die Datenbank muss aktualisiert werden.<br>Dies kann einige Minuten dauern.<br>SchlieÃŸen Sie Ihren Browser nicht, bis dieser Vorgang abgeschlossen ist.',0),(187236,5201,'en','The database needs to be updated. <br>This may take a few minutes. <br>Do not close your browser until this process is complete.',0),(187237,5202,'is','',0),(187238,5202,'dr','Ù‚Ø¨Ù„Ø§ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ ',0),(187239,5202,'pr','Ù‚Ø¨Ù„Ø§ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ ',0),(187240,5202,'tr','Zaten hesaplanmÄ±ÅŸ',0),(187241,5202,'pl','JuÅ¼ obliczone',0),(187242,5202,'bg','Ð’ÐµÑ‡Ðµ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð°',0),(187243,5202,'ur','Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ø­Ø³Ø§Ø¨',0),(187244,5202,'sr','Ð’ÐµÑ› Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚.',0),(187245,5202,'vi','ÄÃ£ TÃ­nh ToÃ¡n',0),(187246,5202,'af','Alreeds Bereken',0),(187247,5202,'ro','Deja calculat',0),(187248,5202,'et','Juba arvutatud',0),(187249,5202,'si','Å½e izraÄunane',0),(187250,5202,'ba','Sudah dihitung',0),(187251,5202,'nl','Al berekend',0),(187252,5202,'fi','Jo laskettu',0),(187253,5202,'no','Allerede',0),(187254,5202,'da','Allerede er beregnet',0),(187255,5202,'ko','ì´ë¯¸ ê³„ì‚°',0),(187256,5202,'he','×›×‘×¨ ×—×™×©×‘',0),(187257,5202,'el','Î‰Î´Î· Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„ÎµÎ¯',0),(187258,5202,'zh','å·²ç»è®¡ç®—\r\n',0),(187259,5202,'sv','Redan berÃ¤knas',0),(187260,5202,'it','GiÃ  calcolato',0),(187261,5202,'tl','',0),(187262,5202,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3648;&#3626;&#3619;&#3655;&#3592;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(187263,5202,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤—à¤£à¤¨à¤¾ à¤•à¥€',0),(187264,5202,'ms','Sudah dikira',0),(187265,5202,'ar','Ø§Ù„ÙØ¹Ù„ Ø§Ù„Ù…Ø­Ø³ÙˆØ¨Ø©',0),(187266,5202,'fr','DÃ©jÃ  calculÃ©',0),(187267,5202,'jp','ã?™ã?§ã?«è¨ˆç®—ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(187268,5202,'pt','JÃ¡ calculado',0),(187269,5202,'ru','Ð£Ð¶Ðµ Ð Ð°ÑÑ‡Ð¸Ñ‚Ð°Ð½Ð¾',0),(187270,5202,'es','Ya Calculado',0),(187271,5202,'de','Bereits berechnet',0),(187272,5202,'en','Already Calculated',0),(187273,5203,'is','',0),(187274,5203,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ†  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(187275,5203,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ†  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(187276,5203,'tr','Bunu silmek istediÄŸinizden emin misiniz?',0),(187277,5203,'pl','Czy na pewno chcesz usunÄ…Ä‡?',0),(187278,5203,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ‚Ð¾Ð²Ð°?',0),(187279,5203,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ÛŒÛ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(187280,5203,'sr','Ð”Ð° Ð»Ð¸ ÑÑ‚Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ð¾Ð²Ð¾?',0),(187281,5203,'vi','XÃ³a?',0),(187282,5203,'af','Is u seker u wil hierdie skrap?',0),(187283,5203,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ ÅŸtergeÅ£i acest lucru?',0),(187284,5203,'et','Oled kindel, et soovid seda kustutada?',0),(187285,5203,'si','Ali ste prepriÄani, da Å¾elite izbrisati to?',0),(187286,5203,'ba','Apakah Anda yakin Anda ingin menghapus ini?',0),(187287,5203,'nl','Weet u zeker dat u wilt verwijderen van dit?',0),(187288,5203,'fi','Haluatko varmasti poistaa tÃ¤mÃ¤n?',0),(187289,5203,'no','Er du sikker pÃ¥ at du vil slette denne?',0),(187290,5203,'da','Er du sikker pÃ¥ du vil slette denne?',0),(187291,5203,'ko','ë‹¹ì‹ ì€ ì´ê²ƒì„ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(187292,5203,'he','?×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ××ª ×–×”',0),(187293,5203,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒ;',0),(187294,5203,'zh','ä½ ç¡®å®šè¦åˆ é™¤å®ƒï¼Ÿ\r\n',0),(187295,5203,'sv','Ã„r du sÃ¤ker du vill ta bort detta?',0),(187296,5203,'it','Sei sicuro che sicuro di voler cancellare questo?',0),(187297,5203,'tl','',0),(187298,5203,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;&#3609;&#3637;&#3657;?',0),(187299,5203,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(187300,5203,'ms','Adakah anda pasti hendak menghapuskan ini?',0),(187301,5203,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¥Ù„ØºØ§Ø¡ Ù‡Ø°Ù‡ ØŸ',0),(187302,5203,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer cet Ã©lÃ©ment ?',0),(187303,5203,'jp','æ¶ˆåŽ»ã?„ã?Ÿã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(187304,5203,'pt','Tem certeza que deseja excluir este?',0),(187305,5203,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹ Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾?',0),(187306,5203,'es','Â¿Esta seguro que quiere eliminar este?',0),(187307,5203,'de','Bist du sicher, dass Sie diese lÃ¶schen mÃ¶chten?',0),(187308,5203,'en','Are you sure you wish to delete this?',0),(187309,5204,'is','',0),(187310,5204,'dr','(Ø§Ø±Ø³Ø§Ù„) ÙƒÙ†ÙŠØ¯ØŸ',0),(187311,5204,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù†Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø±Ø§ Ù¾Ø³Øª(Ø§Ø±Ø³Ø§Ù„) ÙƒÙ†ÙŠØ¯ØŸ',0),(187312,5204,'tr','Bu UNPOST etmek istediÄŸinizden emin misiniz?',0),(187313,5204,'pl','Czy na pewno chcesz to UNPOST?',0),(187314,5204,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° UNPOST Ñ‚Ð¾Ð²Ð°?',0),(187315,5204,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ÛŒÛ Ø§Ù†Ù¾ÙˆØ³Ù¹ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(187316,5204,'sr','ÐˆÐµÑÐ¸ Ð»Ð¸ ÑÐ¸Ð³ÑƒÑ€Ð°Ð½ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñˆ Ð¾Ð²Ð¾ ÐŸÐžÐ’Ð£Ð˜Ð•?',0),(187317,5204,'vi','KHÃ”NG ÄÄ‚NG? ',0),(187318,5204,'af','Is u seker u wil Hierdie ONPOSTEER?',0),(187319,5204,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ UNPOST acest lucru?',0),(187320,5204,'et','Kas kindlasti UNPOST see?',0),(187321,5204,'si','Ali res Å¾elite to UNPOST?',0),(187322,5204,'ba','Apakah Anda yakin Anda ingin UNPOST ini?',0),(187323,5204,'nl','Weet u zeker dat u wenst te UNPOST dit?',0),(187324,5204,'fi','Oletko varmasti UNPOST tÃ¤mÃ¤?',0),(187325,5204,'no','Er du sikker pÃ¥ at du vil UNPOST dette?',0),(187326,5204,'da','Er du sikker pÃ¥ du Ã¸nsker at UNPOST dette?',0),(187327,5204,'ko','ë‹¹ì‹ ì€ì´ UNPOST í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(187328,5204,'he','? ××ª×” ×‘×˜×•×— ×©××ª×” ×¨×•×¦×” UNPOST ××ª ×–×”',0),(187329,5204,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± UNPOST Î±Ï…Ï„ÏŒ;',0),(187330,5204,'zh','ä½ ç¡®å®šè¦å–æ¶ˆé‚®å¯„æ­¤ï¼Ÿ\r\n',0),(187331,5204,'sv','Ã„r du sÃ¤ker pÃ¥ att du vill UNPOST detta?',0),(187332,5204,'it','Sei sicuro che si desidera UNPOST questo?',0),(187333,5204,'tl','',0),(187334,5204,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3652;&#3617;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3',0),(187335,5204,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ UNPOST à¤•à¥€ à¤‡à¤šà¥à¤›à¤¾ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚?',0),(187336,5204,'ms','Adakah anda pasti yang anda ingin UNPOST ini?',0),(187337,5204,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø±ØºØ¨ØªÙƒ ÙÙŠ Ø£ÙˆÙ†Ø¨ÙˆØ³Øª Ù‡Ø°Ø§ØŸ',0),(187338,5204,'fr','ÃŠtes-vous certain de que vouloir UNPOST cela ?',0),(187339,5204,'jp','ã?“ã‚Œã‚’æœªè¨ˆä¸Šã?«ã?—ã?¦ã‚ˆã‚?ã?—ã?„ã?§ã?™ã?‹ï¼Ÿ',0),(187340,5204,'pt','Tem certeza que deseja UNPOST esta?',0),(187341,5204,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ UNPOST ÑÑ‚Ð¾?',0),(187342,5204,'es','Â¿Esta seguro que quiere DESASENTAR este?',0),(187343,5204,'de','Bist du sicher, dass Sie dies UNPOST wollen?',0),(187344,5204,'en','Are you sure you wish to UNPOST This?',0),(187345,5205,'is','',0),(187346,5205,'dr','Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(187347,5205,'pr','Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(187348,5205,'tr','SilinmiÅŸ',0),(187349,5205,'pl','UsuniÄ™te',0),(187350,5205,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸',0),(187351,5205,'ur','Ø­Ø°Ù Ø´Ø¯Û',0),(187352,5205,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(187353,5205,'vi','ÄÃ£ XÃ³a',0),(187354,5205,'af','Geskrap',0),(187355,5205,'ro','EliminÄƒ',0),(187356,5205,'et','Kustutatud',0),(187357,5205,'si','ÄŒrta',0),(187358,5205,'ba','Dihapus',0),(187359,5205,'nl','Verwijderd',0),(187360,5205,'fi','Poistettu',0),(187361,5205,'no','Slettet',0),(187362,5205,'da','Slettet',0),(187363,5205,'ko','ì‚­ì œ',0),(187364,5205,'he','× ×ž×—×§',0),(187365,5205,'el','Î”Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯',0),(187366,5205,'zh','å·²åˆ é™¤',0),(187367,5205,'sv','Bort',0),(187368,5205,'it','Eliminato',0),(187369,5205,'tl','',0),(187370,5205,'th','&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(187371,5205,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤',0),(187372,5205,'ms','Dihapuskan',0),(187373,5205,'ar','Ù…Ø­Ø°ÙˆÙ',0),(187374,5205,'fr','SupprimÃ©',0),(187375,5205,'jp','æ¶ˆåŽ»æ¸ˆ',0),(187376,5205,'pt','Eliminado',0),(187377,5205,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¾',0),(187378,5205,'es','Eliminado',0),(187379,5205,'de','GelÃ¶scht',0),(187380,5205,'en','Deleted',0),(187381,5206,'is','',0),(187382,5206,'dr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† Ø§ÙŠÙ† Ø­Ø³Ø§Ø¨ ',0),(187383,5206,'pr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† Ø§ÙŠÙ† Ø­Ø³Ø§Ø¨ ',0),(187384,5206,'tr','Bu hesap etkinleÅŸtirme',0),(187385,5206,'pl','Aktywacji tego konta',0),(187386,5206,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ð¿Ñ€Ð¾Ñ„Ð¸Ð»',0),(187387,5206,'ur','Ø§Ø³ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ùˆ Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(187388,5206,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½',0),(187389,5206,'vi','KÃ­ch Hoáº¡t TK nÃ y',0),(187390,5206,'af','Aktiveer hierdie Rekening ',0),(187391,5206,'ro','Activeaza acest cont',0),(187392,5206,'et','Selle konto aktiveerida',0),(187393,5206,'si','Aktivirati ta raÄun',0),(187394,5206,'ba','Mengaktifkan akun ini',0),(187395,5206,'nl','Actieveer deze account',0),(187396,5206,'fi','Aktivoi tili',0),(187397,5206,'no','Aktivere denne kontoen',0),(187398,5206,'da','Aktivere denne konto',0),(187399,5206,'ko','ì´ ê³„ì •ì„ í™œì„±í™”í•©ë‹ˆë‹¤',0),(187400,5206,'he','×”×¤×¢×œ ×—×©×‘×•×Ÿ ×–×”',0),(187401,5206,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Ï…Ï„Î¿Ï Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(187402,5206,'zh','å¯ç”¨æ­¤å¸æˆ·\r\n',0),(187403,5206,'sv','Aktivera det hÃ¤r kontot',0),(187404,5206,'it','Attiva questo profilo',0),(187405,5206,'tl','',0),(187406,5206,'th','&#3648;&#3611;&#3636;&#3604;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3609;&#3637;&#3657;',0),(187407,5206,'hi','à¤‡à¤¸ à¤–à¤¾à¤¤à¥‡ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(187408,5206,'ms','Mengaktifkan akaun ini',0),(187409,5206,'ar','ØªÙ†Ø´ÙŠØ· Ù‡Ø°Ø§ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(187410,5206,'fr','Activer ce compte',0),(187411,5206,'jp','ã?“ã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’èµ·å‹•',0),(187412,5206,'pt','Ativar essa conta',0),(187413,5206,'ru','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ñƒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(187414,5206,'es','Activar esta Cuenta',0),(187415,5206,'de','Dieses Konto aktivieren',0),(187416,5206,'en','Activate this Account',0),(187417,5207,'is','',0),(187418,5207,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§ÙŠÙ† Ø±Ø§ ÙØ¹Ø§Ù„ ÙƒÙ†ÙŠØ¯ØŸ',0),(187419,5207,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§ÙŠÙ† Ø±Ø§ ÙØ¹Ø§Ù„ ÙƒÙ†ÙŠØ¯ØŸ',0),(187420,5207,'tr','Bu yeniden etkinleÅŸtirmek istediÄŸinizden emin misiniz?',0),(187421,5207,'pl','Czy na pewno chcesz ponownie UAKTYWNIÄ† to?',0),(187422,5207,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¶ÐµÐ»Ð°ÐµÑ‚Ðµ Ð´Ð° Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾ Ñ‚Ð¾Ð²Ð°?',0),(187423,5207,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ø³ Ú©Ùˆ Ø¯ÙˆØ¨Ø§Ø±Û Ú†Ø§Ù„Ùˆ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(187424,5207,'sr','ÐˆÐµÑÐ¸ Ð»Ð¸ ÑÐ¸Ð³ÑƒÑ€Ð°Ð½ Ð´Ð° Ð»Ð¸ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¿Ð¾Ð½Ð¾Ð²Ð¾ ÐÐšÐ¢Ð˜Ð’Ð˜Ð ÐÐ¢Ð• Ð¾Ð²Ð¾?',0),(187425,5207,'vi','KÃ­ch Hoáº¡t Láº¡i?',0),(187426,5207,'af','Is u seker u wil hierdie HERAKTIVEER?',0),(187427,5207,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ re-activa acest lucru?',0),(187428,5207,'et','Kas kindlasti uuesti aktiveerida seda?',0),(187429,5207,'si','Ali ste prepriÄani, da Å¾elite ponovno aktivirati to?',0),(187430,5207,'ba','Apakah Anda yakin Anda ingin kembali mengaktifkan ini?',0),(187431,5207,'nl','Weet u zeker dat u dit wilt reactiveren',0),(187432,5207,'fi','Oletko varma, ettÃ¤ haluat ELVYTTÃ„Ã„ tÃ¤mÃ¤?',0),(187433,5207,'no','Er du sikker pÃ¥ at du vil aktivere dette?',0),(187434,5207,'da','Er du sikker pÃ¥ du Ã¸nsker at re-aktivere dette?',0),(187435,5207,'ko','ë‹¹ì‹ ì€-ì´ê²ƒì„ í™œì„±í™” í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(187436,5207,'he','? ××ª×” ×‘×˜×•×— ×©××ª×” ×¨×•×¦×” ×œ×”×¤×¢×™×œ ×ž×—×“×© ××ª ×–×”',0),(187437,5207,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î•ÎÎ•Î¡Î“ÎŸÎ ÎŸÎ™Î‰Î£Î•Î¤Î• Î¾Î±Î½Î¬ Î±Ï…Ï„ÏŒ;',0),(187438,5207,'zh','ä½ ç¡®å®šè¦é‡æ–°å¯åŠ¨å—ï¼Ÿ\r\n',0),(187439,5207,'sv','Ã„r du sÃ¤ker du vill Ã…TERAKTIVERA detta?',0),(187440,5207,'it','Sei sicuro che si desidera riattivare questo?',0),(187441,5207,'tl','',0),(187442,5207,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3629;&#3',0),(187443,5207,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤¯à¤¹ à¤ªà¥à¤¨: à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(187444,5207,'ms','Adakah anda pasti anda ingin mengaktifkan semula ini?',0),(187445,5207,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø±ØºØ¨ØªÙƒ ÙÙŠ Ø¥Ø¹Ø§Ø¯Ø© ØªÙ†Ø´ÙŠØ· Ù‡Ø°Ø§ØŸ',0),(187446,5207,'fr','ÃŠtes-vous sÃ»re de que vouloir rÃ©activer ceci ?',0),(187447,5207,'jp','å†?èµ·å‹•ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(187448,5207,'pt','Tem certeza que deseja REATIVAR esta?',0),(187449,5207,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹ Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð”Ð•ÐÐšÐ¢Ð˜Ð’Ð˜Ð ÐžÐ’ÐÐ¢Ð¬ ÑÑ‚Ð¾?',0),(187450,5207,'es','Â¿Esta seguro que quiere REACTIVAR este?',0),(187451,5207,'de','Bist du sicher, dass Sie diese wieder aktivieren wollen?',0),(187452,5207,'en','Are you sure you wish to RE-ACTIVATE this?',0),(187453,5208,'is','',0),(187454,5208,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯',0),(187455,5208,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯',0),(187456,5208,'tr','Yeni bir posta Ekle',0),(187457,5208,'pl','Dodaj nowÄ… P.O.',0),(187458,5208,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸',0),(187459,5208,'ur','Ø§ÛŒÚ© Ù†Ø¦Û’ P.O. Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(187460,5208,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð½Ð°Ð´Ð·Ð¾Ñ€Ð½Ð¸ÐºÐ°',0),(187461,5208,'vi','ThÃªm 1 ÄÆ¡n Mua HÃ ng Má»›i',0),(187462,5208,'af','Voeg \'n Nuwe A.N. by',0),(187463,5208,'ro','Adauga o noua comanda la furnizor',0),(187464,5208,'et','Lisa uus ostutellimus',0),(187465,5208,'si','Dodajte novo P.O.',0),(187466,5208,'ba','Tambahkan P.O. baru',0),(187467,5208,'nl','Toevoegen van een nieuwe postbus',0),(187468,5208,'fi','LisÃ¤Ã¤ uusi P.O.',0),(187469,5208,'no','Legge til en ny postboks',0),(187470,5208,'da','TilfÃ¸je en ny P.O.',0),(187471,5208,'ko','ìƒˆ ì‚¬ì„œí•¨ ì¶”ê°€',0),(187472,5208,'he','×”×•×¡×£ ××ª ×”×§×¦×™×Ÿ ×”×—×“×©',0),(187473,5208,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î½Î­Î± Ï„.Î¸.',0),(187474,5208,'zh','å¢žåŠ ä¸€ä¸ªæ–°çš„é‡‡è´­è®¢å•\r\n',0),(187475,5208,'sv','LÃ¤gga till en ny P.O.',0),(187476,5208,'it','Aggiungere un nuovo P.O.',0),(187477,5208,'tl','',0),(187478,5208,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(187479,5208,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤à¤• à¤¨à¤ˆ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤‘à¤«à¤¼à¤¿à¤¸',0),(187480,5208,'ms','Tambah Surat baru',0),(187481,5208,'ar','Ø£Ø¶Ù Ø¬Ø¯ÙŠØ¯Ø© Øµ. Ø¨.',0),(187482,5208,'fr','Ajouter un Nouveau Bon de Commande',0),(187483,5208,'jp','æ–°è¦?ç™ºæ³¨æ›¸ã?®è¿½åŠ ',0),(187484,5208,'pt','Adicionar um novo postal',0),(187485,5208,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ð¾Ðµ ÐŸ.Ðž.',0),(187486,5208,'es','Agregar una Nueva O.C.',0),(187487,5208,'de','HinzufÃ¼gen einer neuen P.O.',0),(187488,5208,'en','Add a New P.O.',0),(187489,5209,'is','',0),(187490,5209,'dr','(Ù…Ø²Ø§ÙŠØ¯Ù‡',0),(187491,5209,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ Ø§Ø² Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ (Ù…Ø²Ø§ÙŠØ¯Ù‡',0),(187492,5209,'tr','Yeni bir posta Ekle Teklifi',0),(187493,5209,'pl','Dodaj nowÄ… P.O. Z oferty',0),(187494,5209,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² P.O. ÐžÑ‚ Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð°',0),(187495,5209,'ur','Ø§ÛŒÚ© Ù†ÛŒØ§ P.O. Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº Ø³Û’ Ø¨ÙˆÙ„ÛŒ',0),(187496,5209,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð½Ð°Ð´Ð·Ð¾Ñ€Ð½Ð¸ÐºÐ° Ð˜Ð· Ð¿Ð¾Ð½ÑƒÐ´Ð°',0),(187497,5209,'vi','ThÃªm 1 ÄÆ¡n Mua HÃ ng Má»›i Tá»« Äáº¥u Tháº§u',0),(187498,5209,'af','Voeg \'n Nuwe A.N. van *BID* by',0),(187499,5209,'ro','Adauga o noua comanda la furnizor din oferta',0),(187500,5209,'et','Lisada uus P.O. Pakkumine:',0),(187501,5209,'si','Dodaj novo P.O. Iz ponudbe',0),(187502,5209,'ba','Tambahkan P.O. baru Dari tawaran',0),(187503,5209,'nl','Toevoegen van een nieuwe P.O. Uit bod',0),(187504,5209,'fi','LisÃ¤Ã¤ uusi P.O. Alkaen hinta',0),(187505,5209,'no','Legge til en ny postboks Fra bud',0),(187506,5209,'da','TilfÃ¸je en ny P.O. Fra bud',0),(187507,5209,'ko','ìƒˆ ì‚¬ì„œí•¨ ì¶”ê°€ ìž…ì°°ì—ì„œ',0),(187508,5209,'he','×”×•×¡×£ ××ª ×”×§×¦×™×Ÿ ×”×—×“×© ×ž×Ÿ ×”×”×¦×¢×”',0),(187509,5209,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î½Î­Î± Ï„.Î¸. Î‘Ï€ÏŒ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(187510,5209,'zh','å¢žåŠ ä¸€ä¸ªæŠ•æ ‡çš„æ–°é‡‡è´­è®¢å•\r\n',0),(187511,5209,'sv','LÃ¤gga till en ny P.O. FrÃ¥n bud',0),(187512,5209,'it','Aggiungere un nuovo P.O. Dall\'offerta',0),(187513,5209,'tl','',0),(187514,5209,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3627;&#3617;&#3656;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3648;&#3626;&#3609;&#3629;&#3619;&#3634;&#3588;&#3634;',0),(187515,5209,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤à¤• à¤¨à¤ˆ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤‘à¤«à¤¼à¤¿à¤¸ à¤¬à¥‹à¤²à¥€ à¤¸à¥‡',0),(187516,5209,'ms','Tambah Surat yang baru Daripada tawaran',0),(187517,5209,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ Ù…Ù† Ù…Ø­Ø§ÙˆÙ„Ø©',0),(187518,5209,'fr','Ajouter un Nouveau Bon de Commande d\'une soumission',0),(187519,5209,'jp','å…¥æœ­ã?‹ã‚‰æ–°è¦?ç™ºæ³¨æ›¸ã‚’è¿½åŠ ',0),(187520,5209,'pt','Adicionar um novo postal De licitaÃ§Ã£o',0),(187521,5209,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ P.O. ÐžÑ‚ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(187522,5209,'es','Agregar una Nueva O.C. De la CotizaciÃ³n',0),(187523,5209,'de','HinzufÃ¼gen einer neuen P.O. Aus Angebot',0),(187524,5209,'en','Add a New P.O. From Bid',0),(187525,5210,'is','',0),(187526,5210,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(187527,5210,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(187528,5210,'tr','Ã–zel posta ayrÄ±ntÄ±larÄ± ekleme',0),(187529,5210,'pl','DodaÄ‡ niestandardowe P.O. szczegÃ³Å‚y',0),(187530,5210,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ P.O. Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(187531,5210,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ P.O. Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(187532,5210,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ðµ ÐŸ.Ðž. Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(187533,5210,'vi','ThÃªm Chi Tiáº¿t HÃ³a ÄÆ¡n Mua HÃ ng Theo YÃªu Cáº§u',0),(187534,5210,'af','Voeg Aangepasde A.N. Besonderhede by',0),(187535,5210,'ro','Adauga detalii speciale pentru comanda de achizitie la furnizor',0),(187536,5210,'et','Lisa kohandatud P.O. Ã¼ksikasju',0),(187537,5210,'si','Dodajte po meri P.O. podrobnosti',0),(187538,5210,'ba','Menambahkan rincian P.O. kustom',0),(187539,5210,'nl','Aangepaste P.O. Details toevoegen',0),(187540,5210,'fi','LisÃ¤Ã¤ mukautettu P.O. tiedot',0),(187541,5210,'no','Legge til egendefinerte PO detaljer',0),(187542,5210,'da','TilfÃ¸je brugerdefinerede P.O. detaljer',0),(187543,5210,'ko','ì‚¬ìš©ìž ì§€ì • ì‚¬ì„œí•¨ ì„¸ë¶€ ì •ë³´ ì¶”ê°€',0),(187544,5210,'he','×”×•×¡×£ ××ª ×¤×¨×˜×™ ×“×•××¨ ×ž×•×ª××ž×ª ××™×©×™×ª',0),(187545,5210,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¹Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÏƒÏ…Î½Î®Î¸ÎµÎ¹Î±Ï‚ Ï„.Î¸.',0),(187546,5210,'zh','å¢žåŠ è¨‚å–®çš„é—œç¨…æ˜Žç´°\r\n',0),(187547,5210,'sv','LÃ¤gga till anpassade P.O. Detaljer',0),(187548,5210,'it','Aggiungi dettagli personalizzati P.O.',0),(187549,5210,'tl','',0),(187550,5210,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(187551,5210,'hi','à¤•à¤¸à¥à¤Ÿà¤® P.O. à¤µà¤¿à¤µà¤°à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(187552,5210,'ms','Tambah butiran Surat Kastam',0),(187553,5210,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ù…Ø®ØµØµØ© Øµ. Ø¨.',0),(187554,5210,'fr','Ajouter Details de Bon de Commande coutumes',0),(187555,5210,'jp','ã‚«ã‚¹ã‚¿ãƒ ç™ºæ³¨æ›¸è©³ç´°ã?®è¿½åŠ ',0),(187556,5210,'pt','Adicionar detalhes postal personalizado',0),(187557,5210,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ P.O. Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(187558,5210,'es','Agregar Detalles de O.C.',0),(187559,5210,'de','HinzufÃ¼gen von benutzerdefinierten P.O.-Details',0),(187560,5210,'en','Add Custom P.O. Details',0),(187561,5211,'is','',0),(187562,5211,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(187563,5211,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(187564,5211,'tr','Posta ayrÄ±ntÄ±larÄ± ekleme',0),(187565,5211,'pl','DodaÄ‡ szczegÃ³Å‚y P.O.',0),(187566,5211,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ° Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(187567,5211,'ur','P.O. Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(187568,5211,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐŸ.Ðž. Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(187569,5211,'vi','ThÃªm Chi Tiáº¿t ÄÆ¡n Mua HÃ ng',0),(187570,5211,'af','Posbus Besonderhede Byvoeg',0),(187571,5211,'ro','Adauga P.O. detalii',0),(187572,5211,'et','Lisada P.O. Ã¼ksikasjad',0),(187573,5211,'si','Dodajte podrobnosti P.O.',0),(187574,5211,'ba','Menambahkan rincian P.O.',0),(187575,5211,'nl','Postbus Details toevoegen',0),(187576,5211,'fi','LisÃ¤Ã¤ P.O. tiedot',0),(187577,5211,'no','Legge til PO detaljer',0),(187578,5211,'da','TilfÃ¸je P.O. detaljer',0),(187579,5211,'ko','ì‚¬ì„œí•¨ ì„¸ë¶€ ì •ë³´ ì¶”ê°€',0),(187580,5211,'he','×”×•×¡×£ ××ª ×¤×¨×˜×™ ×ª. ×“',0),(187581,5211,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï„.Î¸.',0),(187582,5211,'zh','å¢žåŠ é‡‡è´­è®¢å•è¯¦æƒ…\r\n',0),(187583,5211,'sv','LÃ¤gg till P.O. Detaljer',0),(187584,5211,'it','Aggiungi dettagli P.O.',0),(187585,5211,'tl','',0),(187586,5211,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(187587,5211,'hi','P.O. à¤µà¤¿à¤µà¤°à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(187588,5211,'ms','Tambah butiran Surat',0),(187589,5211,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Øµ. Ø¨.',0),(187590,5211,'fr','Ajouter dÃ©tails P.O.',0),(187591,5211,'jp','ç™ºæ³¨æ›¸è©³ç´°ã?®è¿½åŠ ',0),(187592,5211,'pt','Adicionar detalhes P.O.',0),(187593,5211,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð´ÐµÑ‚Ð°Ð»Ð¸ ÐŸ.Ðž.',0),(187594,5211,'es','Agregar O.C. Detalles',0),(187595,5211,'de','HinzufÃ¼gen von P.O.-Details',0),(187596,5211,'en','Add P.O. Details',0),(187597,5212,'is','',0),(187598,5212,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø´ØªØ±ÙŠ',0),(187599,5212,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø´ØªØ±ÙŠ',0),(187600,5212,'tr','GÃ¼ncelleÅŸtirme Ã¶zel posta ayrÄ±ntÄ±larÄ±',0),(187601,5212,'pl','Aktualizacja szczegÃ³Å‚y niestandardowych P.O.',0),(187602,5212,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ P.O. Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(187603,5212,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ P.O. Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(187604,5212,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ðµ ÐŸ.Ðž.',0),(187605,5212,'vi','Cáº­p Nháº­t Chi Tiáº¿t ÄÆ¡n Mua HÃ ng Tá»± Táº¡o ',0),(187606,5212,'af','Opdateer Aangepasde Poskantoor Besonderhede',0),(187607,5212,'ro','Actualizare personalizat P.O. detalii',0),(187608,5212,'et','Kohandatud P.O. Ã¼ksikasjade uuendamiseks',0),(187609,5212,'si','Posodobite podatke po meri P.O.',0),(187610,5212,'ba','Memperbarui rincian P.O. kustom',0),(187611,5212,'nl','Bijwerken van aangepaste P.O. Details',0),(187612,5212,'fi','PÃ¤ivitÃ¤ mukautettujen P.O. tiedot',0),(187613,5212,'no','Egendefinerte PO Oppdateringsdetaljer',0),(187614,5212,'da','Opdatere brugerdefinerede P.O. detaljer',0),(187615,5212,'ko','ì‚¬ìš©ìž ì§€ì • ì‚¬ì„œí•¨ ì„¸ë¶€ ì •ë³´ ì—…ë°ì´íŠ¸',0),(187616,5212,'he','×¢×“×›×•×Ÿ ×¤×¨×˜×™× P.O. ×ž×•×ª×× ××™×©×™×ª',0),(187617,5212,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÏƒÏ…Î½Î®Î¸ÎµÎ¹Î±Ï‚ Ï„.Î¸.',0),(187618,5212,'zh','æ›´æ–°è‡ªå®šä¹‰é‡‡è´­è®¢å•è¯¦æƒ…\r\n',0),(187619,5212,'sv','Uppdatera anpassade P.O. Detaljer',0),(187620,5212,'it','Aggiornare i dettagli personalizzati P.O.',0),(187621,5212,'tl','',0),(187622,5212,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(187623,5212,'hi','à¤•à¤¸à¥à¤Ÿà¤® P.O. à¤µà¤¿à¤µà¤°à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(187624,5212,'ms','Kemaskini Terakhir butir-butir Surat Kastam',0),(187625,5212,'ar','ØªØ­Ø¯ÙŠØ« ØªÙØ§ØµÙŠÙ„ Ù…Ø®ØµØµØ© Øµ. Ø¨.',0),(187626,5212,'fr','Mettre Ã  jour les coordonnÃ©es postale personnalisÃ©e',0),(187627,5212,'jp','ã‚«ã‚¹ã‚¿ãƒ ç™ºæ³¨æ›¸è©³ç´°ã?®æ›´æ–°',0),(187628,5212,'pt','Atualizar detalhes postal personalizado',0),(187629,5212,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐŸ.Ðž. Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(187630,5212,'es','Actualizar Detalles de OC Personalizado',0),(187631,5212,'de','Aktualisieren von benutzerdefinierten P.O.-Details',0),(187632,5212,'en','Update Custom P.O. Details',0),(187633,5213,'is','',0),(187634,5213,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(187635,5213,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(187636,5213,'tr','Posta bilgilerini gÃ¼ncelleÅŸtirme',0),(187637,5213,'pl','Informacje o aktualizacji P.O.',0),(187638,5213,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸ P.O.',0),(187639,5213,'ur','P.O. Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(187640,5213,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð½Ð°Ð´Ð¾Ð¿ÑƒÐ½Ð¸ ÐŸ.Ðž.',0),(187641,5213,'vi','Cáº­p Nháº­t ThÃ´ng Tin ÄÆ¡n Mua HÃ ng',0),(187642,5213,'af','Opdateer A.B. Inligting',0),(187643,5213,'ro','ActualizaÅ£i informaÅ£iile de P.O.',0),(187644,5213,'et','P.O. teabe vÃ¤rskendamine',0),(187645,5213,'si','Informacije o posodobitvi P.O.',0),(187646,5213,'ba','Informasi pembaruan P.O.',0),(187647,5213,'nl','Postbus informatie bijwerken',0),(187648,5213,'fi','Tietoja tietoturvapÃ¤ivityksestÃ¤ P.O.',0),(187649,5213,'no','Po informasjon',0),(187650,5213,'da','Opdatere P.O. oplysninger',0),(187651,5213,'ko','ì‚¬ì„œí•¨ ì •ë³´ ì—…ë°ì´íŠ¸',0),(187652,5213,'he','×ž×™×“×¢ ×¢×“×›×•×Ÿ ×ª. ×“',0),(187653,5213,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î·Ï‚ Î­ÎºÎ´Î¿ÏƒÎ·Ï‚ Ï„.Î¸.',0),(187654,5213,'zh','æ›´æ–°é‡‡è´­è®¢å•ä¿¡æ¯\r\n',0),(187655,5213,'sv','Uppdatera Information om P.O.',0),(187656,5213,'it','Informazioni sull\'aggiornamento P.O.',0),(187657,5213,'tl','',0),(187658,5213,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;',0),(187659,5213,'hi','P.O. à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(187660,5213,'ms','Mengemaskini maklumat Surat',0),(187661,5213,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Øµ. Ø¨.',0),(187662,5213,'fr','Information mise Ã  jour P.O.',0),(187663,5213,'jp','ç™ºæ³¨æ›¸è©³ç´°ã?®æ›´æ–°',0),(187664,5213,'pt','Atualizar informaÃ§Ãµes de P.O.',0),(187665,5213,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐŸ.Ðž.',0),(187666,5213,'es','Actualizar InformaciÃ³n de oC',0),(187667,5213,'de','Updateinformationen P.O.',0),(187668,5213,'en','Update P.O. Information',0),(187669,5214,'is','',0),(187670,5214,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø­Ø°Ù ÙƒØ±Ø¯Ù† ',0),(187671,5214,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø­Ø°Ù ÙƒØ±Ø¯Ù† ',0),(187672,5214,'tr','Silme sÄ±rasÄ±nda hata oluÅŸtu',0),(187673,5214,'pl','BÅ‚Ä…d podczas usuwania',0),(187674,5214,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(187675,5214,'ur','Ø­Ø°Ù Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ',0),(187676,5214,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ Ð±Ñ€Ð¸ÑÐ°ÑšÐ°',0),(187677,5214,'vi','Lá»—i khi xÃ³a',0),(187678,5214,'af','Fout ontstaan Gedurende Skraping',0),(187679,5214,'ro','Eroare de È™tergere',0),(187680,5214,'et','TÃµrge kustutamisel',0),(187681,5214,'si','Napaka med',0),(187682,5214,'ba','Error selama Hapus',0),(187683,5214,'nl','Fout tijdens verwijderen',0),(187684,5214,'fi','Virhe poistamisen aikana',0),(187685,5214,'no','Feil under sletting',0),(187686,5214,'da','Fejl under sletning',0),(187687,5214,'ko','ì‚­ì œ ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤',0),(187688,5214,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª',0),(187689,5214,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(187690,5214,'zh','åˆ é™¤è¿‡ç¨‹ä¸­å‡ºçŽ°é”™è¯¯',0),(187691,5214,'sv','Fel under ta bort',0),(187692,5214,'it','Errore durante l\'eliminazione',0),(187693,5214,'tl','',0),(187694,5214,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;',0),(187695,5214,'hi','à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(187696,5214,'ms','Ralat semasa Hapus',0),(187697,5214,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù',0),(187698,5214,'fr','Erreur lors de la suppression',0),(187699,5214,'jp','æ¶ˆåŽ»ä¸­ã‚¨ãƒ©ãƒ¼',0),(187700,5214,'pt','Erro durante a exclusÃ£o',0),(187701,5214,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ð¸',0),(187702,5214,'es','Error Durante EliminaciÃ³n',0),(187703,5214,'de','Fehler beim LÃ¶schen',0),(187704,5214,'en','Error During Delete',0),(187705,5215,'is','',0),(187706,5215,'dr','Ø«Ø¨Øª Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ ',0),(187707,5215,'pr','Ø«Ø¨Øª Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ ',0),(187708,5215,'tr','Sevk irsaliyeleri girmek',0),(187709,5215,'pl','WprowadÅº przesyÅ‚ek',0),(187710,5215,'bg','Ð’ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(187711,5215,'ur','ØªØ±Ø³ÛŒÙ„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(187712,5215,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(187713,5215,'vi','Nháº­p chuyáº¿n hÃ ng',0),(187714,5215,'af','Versendings Invoer',0),(187715,5215,'ro','IntroduceÅ£i transporturile',0),(187716,5215,'et','Sisesta tarneid',0),(187717,5215,'si','Dobavnice vnesete',0),(187718,5215,'ba','Masukkan pengiriman',0),(187719,5215,'nl','Verzendingen invoeren',0),(187720,5215,'fi','Toimitustietojen antamiseen',0),(187721,5215,'no','Angi fÃ¸lgesedler',0),(187722,5215,'da','Angive leveringer',0),(187723,5215,'ko','ì¶œí•˜ ëŸ‰ì„ ìž…ë ¥',0),(187724,5215,'he','×”×–×Ÿ ×ž×©×œ×•×—×™×',0),(187725,5215,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¹Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(187726,5215,'zh','è¾“å…¥å‡ºè´§é‡',0),(187727,5215,'sv','Ange fÃ¶rsÃ¤ndelser',0),(187728,5215,'it','Immettere le spedizioni',0),(187729,5215,'tl','',0),(187730,5215,'th','&#3611;&#3657;&#3629;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(187731,5215,'hi','à¤²à¤¦à¤¾à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(187732,5215,'ms','Masukkan penghantaran',0),(187733,5215,'ar','Ù‚Ù… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø´Ø­Ù†Ø§Øª',0),(187734,5215,'fr','Entrez les expÃ©ditions',0),(187735,5215,'jp','ç™ºé€?ã?®å…¥åŠ›',0),(187736,5215,'pt','Insira as transferÃªncias',0),(187737,5215,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(187738,5215,'es','Introducir EnvÃ­os',0),(187739,5215,'de','Geben Sie Sendungen',0),(187740,5215,'en','Enter Shipments',0),(187741,5216,'is','',0),(187742,5216,'dr','Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(187743,5216,'pr','Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(187744,5216,'tr','SipariÅŸ numarasÄ± iÃ§in',0),(187745,5216,'pl','Dla numeru porzÄ…dkowego',0),(187746,5216,'bg','Ð—Ð° Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(187747,5216,'ur','Ú©Û’ Ù„ÛŒÛ’ Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø±',0),(187748,5216,'sr','Ð—Ð° Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(187749,5216,'vi','Cho sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(187750,5216,'af','Vir Bestelnommer',0),(187751,5216,'ro','Pentru numÄƒrul de ordine',0),(187752,5216,'et','JÃ¤rjekorranumbri',0),(187753,5216,'si','Za zaporedno Å¡tevilko',0),(187754,5216,'ba','Untuk nomor pesanan',0),(187755,5216,'nl','Ordernummer',0),(187756,5216,'fi','Tilauksen numero',0),(187757,5216,'no','For bestillingsnummer',0),(187758,5216,'da','For lÃ¸benummer',0),(187759,5216,'ko','ì£¼ë¬¸ ë²ˆí˜¸ì— ëŒ€ í•œ',0),(187760,5216,'he','×¢×‘×•×¨ ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(187761,5216,'el','Î“Î¹Î± Ï„Î¿Î½ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(187762,5216,'zh','å¯¹äºŽè®¢å•å·\r\n',0),(187763,5216,'sv','FÃ¶r ordernummer',0),(187764,5216,'it','Per numero d\'ordine',0),(187765,5216,'tl','',0),(187766,5216,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(187767,5216,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤²à¤¿à¤',0),(187768,5216,'ms','Bagi nombor pesanan',0),(187769,5216,'ar','Ù„Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨',0),(187770,5216,'fr','Le numÃ©ro d\'ordre',0),(187771,5216,'jp','æ³¨æ–‡ç•ªå?·ã?®',0),(187772,5216,'pt','Para o nÃºmero de ordem',0),(187773,5216,'ru','Ð”Ð»Ñ Ð—Ð°ÐºÐ°Ð·Ð° ÐÐ¾Ð¼ÐµÑ€',0),(187774,5216,'es','Para NÃºmero de Orden',0),(187775,5216,'de','Bestellnummer',0),(187776,5216,'en','For Order Number',0),(187777,5217,'is','',0),(187778,5217,'dr','Ø§Ú¯Ø± Ù¾ÙƒÙŠØ¬ Ù‡Ø§ÙŠ Ù…ØªØ¹Ø¯Ø¯ ',0),(187779,5217,'pr','Ø§Ú¯Ø± Ù¾ÙƒÙŠØ¬ Ù‡Ø§ÙŠ Ù…ØªØ¹Ø¯Ø¯ ',0),(187780,5217,'tr','EÄŸer birden fazla Pkgs.',0),(187781,5217,'pl','JeÅ›li wiele Pkgs.',0),(187782,5217,'bg','ÐÐºÐ¾ Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Pkgs.',0),(187783,5217,'ur','Ø§Ú¯Ø± Ø§ÛŒÚ© Ø³Û’ Ø²ÛŒØ§Ø¯Û Pkgs.',0),(187784,5217,'sr','ÐÐºÐ¾ Ð²Ð¸ÑˆÐµ ÐŸÐºÐ³Ñ.',0),(187785,5217,'vi','Náº¿u nhiá»u kiá»‡n',0),(187786,5217,'af','As meervoudige Pkgs.',0),(187787,5217,'ro','DacÄƒ mai multe Pkgs.',0),(187788,5217,'et','Kui mitu Pkgs.',0),(187789,5217,'si','ÄŒe veÄ Pkgs.',0),(187790,5217,'ba','Jika beberapa Pkgs.',0),(187791,5217,'nl','Als meerdere Pkgs.',0),(187792,5217,'fi','Jos useita Pkgs.',0),(187793,5217,'no','Hvis flere Pkgs.',0),(187794,5217,'da','Hvis flere Pkgs.',0),(187795,5217,'ko','ë§Œì•½ ì—¬ëŸ¬ ê°œì˜ Pkgs.',0),(187796,5217,'he','×× Pkgs. ×ž×¨×•×‘×™×',0),(187797,5217,'el','Î‘Î½ Ï€Î¿Î»Î»Î±Ï€Î»Î­Ï‚ Pkgs.',0),(187798,5217,'zh','å¦‚æžœå¤šä¸ªç¨‹åºåŒ…ã€‚\r\n',0),(187799,5217,'sv','Om flera Pkgs.',0),(187800,5217,'it','Se pkgs Multiple.',0),(187801,5217,'tl','',0),(187802,5217,'th','&#3606;&#3657;&#3634;&#3627;&#3621;&#3634;&#3618;&#3649;&#3614;&#3655;&#3588;',0),(187803,5217,'hi','à¤¯à¤¦à¤¿ à¤à¤•à¤¾à¤§à¤¿à¤• Pkgs.',0),(187804,5217,'ms','Jika berbilang Pkgs.',0),(187805,5217,'ar','Ø¥Ø°Ø§ Pkgs. Ù…ØªØ¹Ø¯Ø¯Ø©',0),(187806,5217,'fr','Si plusieurs paquets',0),(187807,5217,'jp','ã‚‚ã?—ã‚‚è¤‡æ•°ã?®ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸ã?®å ´å?ˆ',0),(187808,5217,'pt','Se MÃºltiplo gunzipped',0),(187809,5217,'ru','Ð•ÑÐ»Ð¸ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ ÑƒÐ¿Ð°ÐºÐ¾Ð²ÐºÐ¸',0),(187810,5217,'es','Si Paquetes Multiples',0),(187811,5217,'de','Wenn mehrere Pkgs.',0),(187812,5217,'en','If Multiple Pkgs.',0),(187813,5218,'is','',0),(187814,5218,'dr','( ÙˆØ±ÙˆØ¯ÙŠ) / Ø¬Ø³ØªØ¬Ùˆ ',0),(187815,5218,'pr','Ø¯Ø§Ø¯Ù‡ ( ÙˆØ±ÙˆØ¯ÙŠ) / Ø¬Ø³ØªØ¬Ùˆ ',0),(187816,5218,'tr','GiriÅŸ/arama',0),(187817,5218,'pl','Dane wejÅ›ciowe/Szukaj',0),(187818,5218,'bg','Ð’Ñ…Ð¾Ð´/Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(187819,5218,'ur','Ø§Ù† Ù¾Ù¹/ØªÙ„Ø§Ø´',0),(187820,5218,'sr','Ð˜Ð½Ð¿ÑƒÑ‚/Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ðµ',0),(187821,5218,'vi','Nháº­p/TÃ¬m',0),(187822,5218,'af','Insette/soek',0),(187823,5218,'ro','Intrare/cÄƒutare',0),(187824,5218,'et','Sisend/otsing',0),(187825,5218,'si','Vnos/iskanje',0),(187826,5218,'ba','Masukan/Search',0),(187827,5218,'nl','Input/Search',0),(187828,5218,'fi','Input/haku',0),(187829,5218,'no','Inngang/sÃ¸k',0),(187830,5218,'da','Input/SÃ¸g',0),(187831,5218,'ko','ìž…ë ¥/ê²€ìƒ‰',0),(187832,5218,'he','×”×§×œ×˜/×—×™×¤×•×©',0),(187833,5218,'el','Î•Î¹ÏƒÏŒÎ´Î¿Ï…/Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(187834,5218,'zh','è¾“å…¥/æœç´¢\r\n',0),(187835,5218,'sv','IngÃ¥ng/SÃ¶k',0),(187836,5218,'it','Ingresso/ricerca',0),(187837,5218,'tl','',0),(187838,5218,'th','&#3651;&#3626;&#3656;/&#3588;&#3657;&#3609;&#3627;&#3634;',0),(187839,5218,'hi','à¤‡à¤¨à¤ªà¥à¤Ÿ/à¤–à¥‹à¤œ',0),(187840,5218,'ms','Input/Cari',0),(187841,5218,'ar','Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„/Ø§Ù„Ø¨Ø­Ø«',0),(187842,5218,'fr','EntrÃ©e/recherche',0),(187843,5218,'jp','å…¥åŠ›/æ¤œç´¢',0),(187844,5218,'pt','Entrada/busca',0),(187845,5218,'ru','Ð’Ð²Ð¾Ð´/ÐŸÐ¾Ð¸ÑÐº',0),(187846,5218,'es','Input/Buscar',0),(187847,5218,'de','Eingabe/Suche',0),(187848,5218,'en','Input/Search',0),(187849,5219,'is','',0),(187850,5219,'dr','ØªØ¹Ø¯Ø§Ø¯ \r\n Pkgs',0),(187851,5219,'pr','ØªØ¹Ø¯Ø§Ø¯ \r\n Pkgs',0),(187852,5219,'tr','# Pkgs',0),(187853,5219,'pl','# Pkgs',0),(187854,5219,'bg','# Pkgs',0),(187855,5219,'ur','# Ù¾Ú©Ú¯Ø³',0),(187856,5219,'sr','# ÐŸÐºÐ³Ñ',0),(187857,5219,'vi','Sá»‘ kiá»‡n',0),(187858,5219,'af','# Pkgs',0),(187859,5219,'ro','# Pkgs',0),(187860,5219,'et','# Pkgs',0),(187861,5219,'si','# Pkgs',0),(187862,5219,'ba','# Pkgs',0),(187863,5219,'nl','# Pkgs',0),(187864,5219,'fi','# Pakettien',0),(187865,5219,'no','# Pkgs',0),(187866,5219,'da','# Pkgs',0),(187867,5219,'ko','# Pkgs',0),(187868,5219,'he','# Pkgs',0),(187869,5219,'el','# Pkgs',0),(187870,5219,'zh','è½¯ä»¶åŒ…\r\n',0),(187871,5219,'sv','# Pkgs',0),(187872,5219,'it','# Pkgs',0),(187873,5219,'tl','',0),(187874,5219,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3656;&#3629;&#3585;&#3636;&#3650;&#3621;&#3585;&#3619;&#3633;&#3617;',0),(187875,5219,'hi','# Pkgs',0),(187876,5219,'ms','# Pkgs',0),(187877,5219,'ar','# Ø¨ÙƒØ¬Ø³',0),(187878,5219,'fr','# Pkgs',0),(187879,5219,'jp','ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸ã?®æ•°',0),(187880,5219,'pt','# Pkgs',0),(187881,5219,'ru','# Pkgs',0),(187882,5219,'es','# Paq.',0),(187883,5219,'de','# Pkgs',0),(187884,5219,'en','# Pkgs',0),(187885,5220,'is','',0),(187886,5220,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(187887,5220,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ ',0),(187888,5220,'tr','YazdÄ±rma sÄ±rasÄ±nÄ± arama',0),(187889,5220,'pl','KolejnoÅ›Ä‡ drukowania wyszukiwania',0),(187890,5220,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(187891,5220,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0);
INSERT INTO `langdef` VALUES (187892,5220,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(187893,5220,'vi','TÃ¬m Ä‘Æ¡n hÃ ng in',0),(187894,5220,'af','Druk orde opsoek',0),(187895,5220,'ro','Imprima ordinea Lookup',0),(187896,5220,'et','Printida tellimuse otsing',0),(187897,5220,'si','Vrstni red tiskanja za iskanje',0),(187898,5220,'ba','Pesanan cetakan Lookup',0),(187899,5220,'nl','Afdrukvolgorde Lookup',0),(187900,5220,'fi','TulostusjÃ¤rjestyksen haku',0),(187901,5220,'no','UtskriftsrekkefÃ¸lge oppslag',0),(187902,5220,'da','Udskrive ordre opslag',0),(187903,5220,'ko','ì¸ì‡„ ì£¼ë¬¸ ì¡°íšŒ',0),(187904,5220,'he','×‘×“×™×§×ª ×¡×“×¨ ×”×”×“×¤×¡×”',0),(187905,5220,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ‰Î½',0),(187906,5220,'zh','æ‰“å°è®¢å•æŸ¥æ‰¾\r\n',0),(187907,5220,'sv','Utskriftsordning Lookup',0),(187908,5220,'it','Ordine di stampa Lookup',0),(187909,5220,'tl','',0),(187910,5220,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(187911,5220,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤‘à¤°à¥à¤¡à¤° à¤²à¥à¤•à¤…à¤ª',0),(187912,5220,'ms','Lookup cetak',0),(187913,5220,'ar','Ø¨Ø­Ø« Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(187914,5220,'fr','Recherche de l\'ordre d\'impression',0),(187915,5220,'jp','å?°åˆ·æ³¨æ–‡ã?®æ¤œç´¢',0),(187916,5220,'pt','Pesquisa de ordem de impressÃ£o',0),(187917,5220,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ ÐŸÐ¾Ð¸ÑÐº',0),(187918,5220,'es','Busqueda de Orden de Imprenta',0),(187919,5220,'de','Druckreihenfolge Lookup',0),(187920,5220,'en','Print Order Lookup',0),(187921,5221,'is','',0),(187922,5221,'dr','/ Ø¨Ø³ØªÙ‡ Ø¨Ø± Ø­Ø³Ø¨ ÙƒÙŠÙ„ÙˆÚ¯Ø±Ù…',0),(187923,5221,'pr','Ù…Ù‚Ø¯Ø§Ø± / Ø¨Ø³ØªÙ‡ Ø¨Ø± Ø­Ø³Ø¨ ÙƒÙŠÙ„ÙˆÚ¯Ø±Ù…',0),(187924,5221,'tr','Miktar/Pkg',0),(187925,5221,'pl','IloÅ›Ä‡/Pkg',0),(187926,5221,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾/Pkg',0),(187927,5221,'ur','Ù‚ÛŒ/Ú©Ú¯',0),(187928,5221,'sr','ÐšÐ¾Ð»/ÐŸÐºÐ³',0),(187929,5221,'vi','Sá»‘ lÆ°á»£ng/gÃ³i',0),(187930,5221,'af','Hoev./Per kg',0),(187931,5221,'ro','Cantitate/Pkg',0),(187932,5221,'et','Tk/Pkg',0),(187933,5221,'si','KoliÄina/Pkg',0),(187934,5221,'ba','Qty Pkg',0),(187935,5221,'nl','Aantal/Pkg',0),(187936,5221,'fi','MÃ¤Ã¤rÃ¤/Pkg',0),(187937,5221,'no','Antall/Pkg',0),(187938,5221,'da','Antal/Pkg',0),(187939,5221,'ko','ìˆ˜ëŸ‰/Pkg',0),(187940,5221,'he','×›×ž×•×ª/×‘×“×’×',0),(187941,5221,'el','Qty/Pkg',0),(187942,5221,'zh','æ•°é‡/åŒ…\r\n',0),(187943,5221,'sv','QTY/Pkg',0),(187944,5221,'it','Qty/Pkg',0),(187945,5221,'tl','',0),(187946,5221,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;/&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;',0),(187947,5221,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾/Pkg',0),(187948,5221,'ms','Qty/Pkg',0),(187949,5221,'ar','Ø§Ù„ÙƒÙ…ÙŠØ©/Pkg',0),(187950,5221,'fr','Qty/Pkg',0),(187951,5221,'jp','æ•°é‡?/ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸',0),(187952,5221,'pt','Qty/Pkg',0),(187953,5221,'ru','ÐšÐ¾Ð»-Ð²Ð¾/Pkg',0),(187954,5221,'es','Cant./Paq.',0),(187955,5221,'de','Qty/Pkg',0),(187956,5221,'en','Qty/Pkg',0),(187957,5222,'is','',0),(187958,5222,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(187959,5222,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(187960,5222,'tr','Miktar kalÄ±r',0),(187961,5222,'pl','IloÅ›Ä‡ pozostajÄ…',0),(187962,5222,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾ÑÑ‚Ð°Ð²Ð°Ñ‚',0),(187963,5222,'ur','Ù‚ÛŒ Ø±ÛÛŒÚº',0),(187964,5222,'sr','ÐžÑÑ‚Ð°Ñ˜Ñƒ ÐšÐ¾Ð».',0),(187965,5222,'vi','Sá»‘ lÆ°á»£ng cÃ²n láº¡i',0),(187966,5222,'af','Hoev. Agterbly',0),(187967,5222,'ro','Cantit rÄƒmÃ¢n',0),(187968,5222,'et','Kogus jÃ¤Ã¤b',0),(187969,5222,'si','KoliÄina ostane',0),(187970,5222,'ba','Qty tetap',0),(187971,5222,'nl','Aantal blijven',0),(187972,5222,'fi','MÃ¤Ã¤rÃ¤ pysyy',0),(187973,5222,'no','Antall forblir',0),(187974,5222,'da','Antal forbliver',0),(187975,5222,'ko','ìˆ˜ëŸ‰ ë‚¨ì•„',0),(187976,5222,'he','×›×ž×•×ª ×œ×”×™×©××¨',0),(187977,5222,'el','Qty Ï€Î±ÏÎ±Î¼Î­Î½Î¿Ï…Î½',0),(187978,5222,'zh','æ•°é‡ä¿æŒ\r\n',0),(187979,5222,'sv','Antal kvar',0),(187980,5222,'it','Qty rimangono',0),(187981,5222,'tl','',0),(187982,5222,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(187983,5222,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤°à¤¹à¤¨à¤¾',0),(187984,5222,'ms','Qty kekal',0),(187985,5222,'ar','ØªØ¸Ù„ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(187986,5222,'fr','Qty restent',0),(187987,5222,'jp','æ®‹æ•°é‡?',0),(187988,5222,'pt','Qty permanecem',0),(187989,5222,'ru','Qty Ð¾ÑÑ‚Ð°ÑŽÑ‚ÑÑ',0),(187990,5222,'es','Cant. que Queda',0),(187991,5222,'de','Qty bleiben',0),(187992,5222,'en','Qty Remain',0),(187993,5223,'is','',0),(187994,5223,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ ',0),(187995,5223,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ ',0),(187996,5223,'tr','GÃ¶nderilen miktar',0),(187997,5223,'pl','IloÅ›Ä‡ wysÅ‚anych',0),(187998,5223,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾ ÐºÐ¾Ð»-Ð²Ð¾',0),(187999,5223,'ur','Ù‚ÛŒ Ø¨Ú¾ÛŒØ¬Ø§',0),(188000,5223,'sr','ÐšÐ¾Ð» Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(188001,5223,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ gá»§i',0),(188002,5223,'af','Hoev. Gestuur',0),(188003,5223,'ro','Cantitate trimis',0),(188004,5223,'et','Saadetud kogus',0),(188005,5223,'si','KoliÄina poslal',0),(188006,5223,'ba','Qty dikirim',0),(188007,5223,'nl','Aantal verzonden',0),(188008,5223,'fi','MÃ¤Ã¤rÃ¤ lÃ¤hettÃ¤Ã¤',0),(188009,5223,'no','Antall sendte',0),(188010,5223,'da','Antal sendte',0),(188011,5223,'ko','ë°œì†¡ ìˆ˜ëŸ‰',0),(188012,5223,'he','×›×ž×•×ª ×©×œ×—',0),(188013,5223,'el','Qty Î­ÏƒÏ„ÎµÎ¹Î»Îµ',0),(188014,5223,'zh','å‘é€æ•°é‡\r\n',0),(188015,5223,'sv','Antal skickade',0),(188016,5223,'it','Qty inviati',0),(188017,5223,'tl','',0),(188018,5223,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;&#3652;&#3611;',0),(188019,5223,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤­à¥‡à¤œà¤¾',0),(188020,5223,'ms','Qty yang dihantar',0),(188021,5223,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø±Ø³Ù„Ø©',0),(188022,5223,'fr','QuantitÃ© envoyÃ©e',0),(188023,5223,'jp','ç™ºé€?æ¸ˆæ•°é‡?',0),(188024,5223,'pt','Qty enviada',0),(188025,5223,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð¿Ð¾ÑÐ»Ð°Ð»',0),(188026,5223,'es','Cant. Enviada',0),(188027,5223,'de','Qty gesendet',0),(188028,5223,'en','Qty Sent',0),(188029,5224,'is','',0),(188030,5224,'dr','Ø­Ù…Ù„ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(188031,5224,'pr','Ø­Ù…Ù„ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(188032,5224,'tr','SipariÅŸ numarasÄ± iÃ§in nakliye',0),(188033,5224,'pl','Dla numeru porzÄ…dkowego',0),(188034,5224,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð¾Ð¼ÐµÑ€',0),(188035,5224,'ur','Ú©Û’ Ù„ÛŒÛ’ Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ø´Ù¾Ù†Ú¯',0),(188036,5224,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð·Ð° Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(188037,5224,'vi','Váº­n chuyá»ƒn Ä‘Æ¡n hÃ ng sá»‘',0),(188038,5224,'af','Versending vir Bestelnommer',0),(188039,5224,'ro','Transport pentru numÄƒrul de ordine',0),(188040,5224,'et','Laevanduse jÃ¤rjekorranumbri',0),(188041,5224,'si','Dostava za zaporedno Å¡tevilko',0),(188042,5224,'ba','Pengiriman untuk nomor pesanan',0),(188043,5224,'nl','Verzendkosten voor ordernummer',0),(188044,5224,'fi','Toimitus tilauksen numero',0),(188045,5224,'no','Frakt for bestillingsnummer',0),(188046,5224,'da','Forsendelse for lÃ¸benummer',0),(188047,5224,'ko','ì£¼ë¬¸ ë²ˆí˜¸ì— ëŒ€ í•œ ë°°ì†¡',0),(188048,5224,'he','×ž×©×œ×•×— ×¢×‘×•×¨ ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(188049,5224,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î³Î¹Î± Ï„Î¿Î½ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(188050,5224,'zh','è¿é€è®¢å•ç¼–å·\r\n',0),(188051,5224,'sv','Frakt fÃ¶r ordernummer',0),(188052,5224,'it','Spedizione gratuita per numero di ordine',0),(188053,5224,'tl','',0),(188054,5224,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;',0),(188055,5224,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(188056,5224,'ms','Kos penghantaran untuk nombor pesanan',0),(188057,5224,'ar','Ø§Ù„Ø´Ø­Ù† Ù„Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨',0),(188058,5224,'fr','Le numÃ©ro d\'ordre d\'expÃ©dition',0),(188059,5224,'jp','æ³¨æ–‡ç•ªå?·ï½žã?®ç™ºé€?',0),(188060,5224,'pt','Frete para nÃºmero de ordem',0),(188061,5224,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð»Ñ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(188062,5224,'es','Transporte para NÃºmero de Orden',0),(188063,5224,'de','Versandkosten fÃ¼r Bestellnummer',0),(188064,5224,'en','Shipping for Order Number',0),(188065,5225,'is','',0),(188066,5225,'dr','Ø­Ù…Ù„ Ø¨Ù‡ ',0),(188067,5225,'pr','Ø­Ù…Ù„ Ø¨Ù‡ ',0),(188068,5225,'tr','O gemi',0),(188069,5225,'pl','Statek do',0),(188070,5225,'bg','Ð—Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(188071,5225,'ur','Ø¬ÛØ§Ø² Ú©Ùˆ',0),(188072,5225,'sr','Ð—Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(188073,5225,'vi','Chuyá»ƒn Ä‘áº¿n',0),(188074,5225,'af','Versend Na',0),(188075,5225,'ro','NavÄƒ la',0),(188076,5225,'et','Tarne aadress',0),(188077,5225,'si','Dostava',0),(188078,5225,'ba','Kapal ke',0),(188079,5225,'nl','Verzenden naar',0),(188080,5225,'fi','Aluksen',0),(188081,5225,'no','Leveringsgate',0),(188082,5225,'da','Skib til',0),(188083,5225,'ko','ìš´ì†¡ì§€',0),(188084,5225,'he','×œ×ž×©×œ×•×—',0),(188085,5225,'el','Î Î»Î¿Î¯Î¿',0),(188086,5225,'zh','æ”¶è´§\r\n',0),(188087,5225,'sv','Fartyget till',0),(188088,5225,'it','Spedire a',0),(188089,5225,'tl','',0),(188090,5225,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;',0),(188091,5225,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(188092,5225,'ms','Kapal',0),(188093,5225,'ar','Ø´Ø­Ù† Ø¥Ù„Ù‰',0),(188094,5225,'fr','ExpÃ©dier Ã ',0),(188095,5225,'jp','ç™ºé€?å…ˆ',0),(188096,5225,'pt','Navio para',0),(188097,5225,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(188098,5225,'es','Enviar A',0),(188099,5225,'de','Ship To',0),(188100,5225,'en','Ship To',0),(188101,5226,'is','',0),(188102,5226,'dr','ØªØ§Ø±ÙŠØ® Ø³Ø± Ø±Ø³ÙŠØ¯ ÙØ¹Ù„ÙŠ ',0),(188103,5226,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø± Ø±Ø³ÙŠØ¯ ÙØ¹Ù„ÙŠ ',0),(188104,5226,'tr','GeÃ§erli bitiÅŸ tarihi',0),(188105,5226,'pl','Data ukoÅ„czenia bieÅ¼Ä…cego',0),(188106,5226,'bg','Ð¡Ñ€Ð¾Ðº Ð·Ð° Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð°',0),(188107,5226,'ur','Ø­Ø§Ù„ÛŒÛ Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(188108,5226,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð Ð¾Ðº Ð¸Ð·Ð²Ñ€ÑˆÐµÑšÐ°:',0),(188109,5226,'vi','NgÃ y Ä‘áº¿n háº¡n hiá»‡n thá»i',0),(188110,5226,'af','Huidige Datum Verskuldig',0),(188111,5226,'ro','Data scadentÄƒ curent',0),(188112,5226,'et','Praegune tÃ¤htaeg',0),(188113,5226,'si','Sedanji rok',0),(188114,5226,'ba','Saat ini jatuh tempo',0),(188115,5226,'nl','Huidige vervaldatum',0),(188116,5226,'fi','Nykyinen erÃ¤pÃ¤ivÃ¤',0),(188117,5226,'no','Gjeldende forfallsdato',0),(188118,5226,'da','Aktuelle forfaldsdato',0),(188119,5226,'ko','í˜„ìž¬ ê¸°í•œ ë‚ ì§œ',0),(188120,5226,'he','×ª××¨×™×š ×™×¢×“ ×”× ×•×›×—×™',0),(188121,5226,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï€ÏÎ¿Î¸ÎµÏƒÎ¼Î¯Î±',0),(188122,5226,'zh','ç›®å‰çš„æˆªæ­¢æ—¥æœŸ\r\n',0),(188123,5226,'sv','Nuvarande fÃ¶rfallodatum',0),(188124,5226,'it','Scadenza attuale',0),(188125,5226,'tl','',0),(188126,5226,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(188127,5226,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤¾à¤°à¤£ à¤¤à¤¿à¤¥à¤¿',0),(188128,5226,'ms','Tarikh akhir pembayaran semasa',0),(188129,5226,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(188130,5226,'fr','Ã‰chÃ©ance actuelle',0),(188131,5226,'jp','ç?¾åœ¨ã?®æœŸæ—¥',0),(188132,5226,'pt','Data de vencimento atual',0),(188133,5226,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð½Ð°Ð¼ÐµÑ‡ÐµÐ½Ð½Ð°Ñ Ð´Ð°Ñ‚Ð°',0),(188134,5226,'es','Fecha de Vencimiento Actual',0),(188135,5226,'de','Aktuelle FÃ¤lligkeit',0),(188136,5226,'en','Current Due Date',0),(188137,5227,'is','',0),(188138,5227,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(188139,5227,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(188140,5227,'tr','Hesap baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(188141,5227,'pl','Konto pomyÅ›lnie zaktualizowana',0),(188142,5227,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(188143,5227,'ur','Ø§Ú©Ø§ÙˆÙ†Ù¹ Ù…Ú©Ù…Ù„ ÛÙˆ Ú¯ÛŒØ§ Ú¾Û’',0),(188144,5227,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(188145,5227,'vi','TK Cáº­p Nháº­t ThÃ nh CÃ´ng',0),(188146,5227,'af','Rekening Suksesvol Opdateer',0),(188147,5227,'ro','Cont actualizat cu succes',0),(188148,5227,'et','Konto vÃ¤rskendamine Ãµnnestus',0),(188149,5227,'si','RaÄun uspeÅ¡no posodobljena',0),(188150,5227,'ba','Berhasil Memperbaharui Akun',0),(188151,5227,'nl','Account met success geactiveerd',0),(188152,5227,'fi','Tilin pÃ¤ivittÃ¤minen onnistui',0),(188153,5227,'no','Kontoen oppdatert',0),(188154,5227,'da','Konto opdateret',0),(188155,5227,'ko','ê³„ì • ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(188156,5227,'he','×”×—×©×‘×•×Ÿ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(188157,5227,'el','Î•Î½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(188158,5227,'zh','å¸æˆ·å·²æˆåŠŸæ›´æ–°\r\n',0),(188159,5227,'sv','Konto uppdaterats',0),(188160,5227,'it','Profilo aggiornato con successo',0),(188161,5227,'tl','',0),(188162,5227,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(188163,5227,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(188164,5227,'ms','Akaun yang berjaya dikemas kini',0),(188165,5227,'ar','Ø¥Ø³ØªØ±Ø¬Ø¹ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(188166,5227,'fr','Compte Mise Ã  Jour avec SuccÃ¨s',0),(188167,5227,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(188168,5227,'pt','Conta atualizada com sucesso',0),(188169,5227,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(188170,5227,'es','Cuenta Actualizada Exitosamente',0),(188171,5227,'de','Konten erfolgreich aktualisiert',0),(188172,5227,'en','Account Updated Successfully',0),(188173,5228,'is','',0),(188174,5228,'dr','- ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯',0),(188175,5228,'pr','Ø­Ø³Ø§Ø¨ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯- ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯',0),(188176,5228,'tr','Hesap--yeniden aktive zaten',0),(188177,5228,'pl','Konto juÅ¼ istnieje - ponownym odpaleniu',0),(188178,5228,'bg','Ð’ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚ - Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾Ñ‚Ð¾ Ð¼Ñƒ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ',0),(188179,5228,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾ÛÙ„Û’ ÛÛŒ â€“ Ø¯ÙˆØ¨Ø§Ø±Û Ø§Ú©Ù¹Ø§ÙˆÛŒÙ¹Ø§Ù†Ú¯ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(188180,5228,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸--Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ð¾Ð½Ð¾Ð³',0),(188181,5228,'vi','TK ÄÃ£ Tá»“n Táº¡i -- KÃ­ch Hoáº¡t Láº¡i',0),(188182,5228,'af','Rekening bestaan alreeds --- Heraktiveer',0),(188183,5228,'ro','Cont deja existent - reactivare',0),(188184,5228,'et','Konto juba olemas--uuesti sisselÃ¼litamist',0),(188185,5228,'si','RaÄun Å¾e obstaja--ponovno aktiviranje',0),(188186,5228,'ba','Akun Telah Ada -- Pengaktifan Kembali',0),(188187,5228,'nl','Account bestaat al, heractivering',0),(188188,5228,'fi','On jo luotu tili--uudelleen aktivointi',0),(188189,5228,'no','Konto eksisterer allerede - re-aktivering',0),(188190,5228,'da','Konto eksisterer allerede - re aktiverende',0),(188191,5228,'ko','ê³„ì •ì´ ì´ë¯¸ ì¡´ìž¬-ë‹¤ì‹œ í™œì„±í™”',0),(188192,5228,'he','×›×‘×¨ ×§×™×™× ×—×©×‘×•×Ÿ - ×”×¤×¢×œ×ª ×ž×—×“×©',0),(188193,5228,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚--ÎµÎº Î½Î­Î¿Ï… ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(188194,5228,'zh','å¸æˆ·å·²ç»å­˜åœ¨-é‡æ–°æ¿€æ´»\r\n',0),(188195,5228,'sv','Konto finns redan--Ã¥ter aktivera',0),(188196,5228,'it','Il profilo esiste giÃ  -- Ri-attivazione',0),(188197,5228,'tl','',0),(188198,5228,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618; - &#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;',0),(188199,5228,'hi','à¤–à¤¾à¤¤à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ - à¤ªà¥à¤¨à¤ƒ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(188200,5228,'ms','Akaun telah pun wujud--semula activating',0),(188201,5228,'ar','Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„-Ø¥Ø¹Ø§Ø¯Ø© ØªÙØ¹ÙŠÙ„',0),(188202,5228,'fr','Compte DÃ©jÃ  Existant -- Re-activation',0),(188203,5228,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¾ã?™ãƒ¼å†?ç¨¼å‹•',0),(188204,5228,'pt','Conta jÃ¡ existe..--re-activaÃ§Ã£o',0),(188205,5228,'ru','Ð£Ð¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ--Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ñ',0),(188206,5228,'es','Cuenta ya Existe --\nRe-activando',0),(188207,5228,'de','Konto existiert bereits -- wird reaktiviert',0),(188208,5228,'en','Account Already Exists -- Re-activating',0),(188209,5229,'is','',0),(188210,5229,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ø­Ø³Ø§Ø¨ ',0),(188211,5229,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ø­Ø³Ø§Ø¨ ',0),(188212,5229,'tr','Hesap etkinleÅŸtirme hatasÄ±',0),(188213,5229,'pl','BÅ‚Ä…d aktywacji konta',0),(188214,5229,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(188215,5229,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ ÙØ¹Ø§Ù„ Ú©Ø± Ù†Ù‚Øµ',0),(188216,5229,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°ÑšÑƒ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(188217,5229,'vi','KÃ­ch Hoáº¡t TK Bá»‹ Lá»—i',0),(188218,5229,'af','Fout met die Aktivering van Rekening',0),(188219,5229,'ro','Eroare activa contul',0),(188220,5229,'et','Konto tÃµrge',0),(188221,5229,'si','Napaka pri aktiviranju raÄun',0),(188222,5229,'ba','Kesalahan Aktivasi Account',0),(188223,5229,'nl','Kan account niet activeren',0),(188224,5229,'fi','Virhe aktivoitaessa tili',0),(188225,5229,'no','Feil under aktivering av kontoen',0),(188226,5229,'da','Fejl under aktivering af konto',0),(188227,5229,'ko','ê³„ì •ì„ í™œì„±í™” í•˜ëŠ” ì˜¤ë¥˜',0),(188228,5229,'he','×©×’×™××” ×”×¤×¢×œ×ª ×”×—×©×‘×•×Ÿ',0),(188229,5229,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(188230,5229,'zh','é”™è¯¯æ¿€æ´»å¸æˆ·',0),(188231,5229,'sv','Fel aktivera konto',0),(188232,5229,'it','Errore di attivazione Account',0),(188233,5229,'tl','',0),(188234,5229,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3607;&#3635;&#3651;&#3627;&#3657;&#3610;&#3633;&#3597;&#3594;&#3637;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3652;&#3604;&#3657;',0),(188235,5229,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¤¨à¥‡ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(188236,5229,'ms','Ralat pengaktifan akaun',0),(188237,5229,'ar','Ø®Ø·Ø£ ÙÙŠ ØªÙØ¹ÙŠÙ„ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(188238,5229,'fr','Erreur d\'activation de compte',0),(188239,5229,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?®ç¨¼å‹•ä¸­ã‚¨ãƒ©ãƒ¼',0),(188240,5229,'pt','Erro de ativaÃ§Ã£o de conta',0),(188241,5229,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(188242,5229,'es','Error Activando la Cuenta',0),(188243,5229,'de','Fehler-Konto zu aktivieren',0),(188244,5229,'en','Error Activating Account',0),(188245,5230,'is','',0),(188246,5230,'dr','/ ØªØ³ÙˆÙŠÙ‡ ÙƒØ±Ø¯Ù†',0),(188247,5230,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙˆØ±ÙˆØ¯ / ØªØ³ÙˆÙŠÙ‡ ÙƒØ±Ø¯Ù†',0),(188248,5230,'tr','In/Out kontrol edin',0),(188249,5230,'pl','Zameldowanie/wymeldowanie',0),(188250,5230,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ In/Out',0),(188251,5230,'ur','Ú†ÛŒÚ© Ø¢Ø¤Ù¹:',0),(188252,5230,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð¸Ð·Ð»Ð°Ð·Ð¸Ð¾',0),(188253,5230,'vi','VÃ o/Ra',0),(188254,5230,'af','Kontroleer / uit',0),(188255,5230,'ro','Check In/Out',0),(188256,5230,'et','Vaadata/vÃ¤lja',0),(188257,5230,'si','In preverite',0),(188258,5230,'ba','Check-In/Out',0),(188259,5230,'nl','Check In/Out',0),(188260,5230,'fi','SisÃ¤Ã¤n tai ulos',0),(188261,5230,'no','Sjekk inn/ut',0),(188262,5230,'da','Check In/Out',0),(188263,5230,'ko','ì²´í¬ ì¸/ì•„ì›ƒ',0),(188264,5230,'he','×‘×“×•×§ ×•×¦\'×§ ×××•×˜',0),(188265,5230,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ In/Out',0),(188266,5230,'zh','æ£€æŸ¥è¾“å…¥/è¾“å‡º\r\n',0),(188267,5230,'sv','Kolla In/ut',0),(188268,5230,'it','Check In/Out',0),(188269,5230,'tl','',0),(188270,5230,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3586;&#3657;&#3634;/&#3629;&#3629;&#3585;',0),(188271,5230,'hi','à¤®à¥‡à¤‚/à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(188272,5230,'ms','Daftar Masuk/Keluar',0),(188273,5230,'ar','ØªØ­Ù‚Ù‚ ÙÙŠ Ø§Ù„Ø®Ø§Ø±Ø¬',0),(188274,5230,'fr','Check In/Out',0),(188275,5230,'jp','ãƒ?ã‚§ãƒƒã‚¯ã‚¤ãƒ³/ã‚¢ã‚¦ãƒˆ',0),(188276,5230,'pt','Verifique In/Out',0),(188277,5230,'ru','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ/Ð²Ñ‹ÐµÐ·Ð´',0),(188278,5230,'es','Inscribirse/Despedirse',0),(188279,5230,'de','Check In/Out',0),(188280,5230,'en','Check In/Out',0),(188281,5231,'is','',0),(188282,5231,'dr','/ Ø¢Ù¾Ø¯ÛŒØª  Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(188283,5231,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(188284,5231,'tr','MÃ¼ÅŸteri Ekle/GÃ¼ncelle',0),(188285,5231,'pl','Dodaj/Aktualizuj klienta',0),(188286,5231,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(188287,5231,'ur','Ú¯Ø§ÛÚ© Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(188288,5231,'sr','ÐšÑƒÐ¿Ñ†Ð°/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(188289,5231,'vi','ThÃªm/Cáº­p Nháº­t KhÃ¡ch HÃ ng',0),(188290,5231,'af','Klant/KliÃ«nt Byvoeg/Opdateer',0),(188291,5231,'ro','Client AdÄƒugaÅ£i/actualizaÅ£i',0),(188292,5231,'et','Lisa/Uuenda klienti',0),(188293,5231,'si','Kupec Dodaj/posodobi',0),(188294,5231,'ba','Pelanggan Tambahkan/Perbarui',0),(188295,5231,'nl','Klant toevoegen/bijwerken',0),(188296,5231,'fi','Asiakas lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(188297,5231,'no','Kunde/Oppdater',0),(188298,5231,'da','Kunde TilfÃ¸j/opdater',0),(188299,5231,'ko','ê³ ê° ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(188300,5231,'he','×œ×§×•×—×•×ª ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(188301,5231,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(188302,5231,'zh','å®¢æˆ·æ–°å¢ž/æ›´æ–°\r\n',0),(188303,5231,'sv','Kunden LÃ¤gg till/uppdatera',0),(188304,5231,'it','Aggiungere/aggiornare un cliente',0),(188305,5231,'tl','',0),(188306,5231,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(188307,5231,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(188308,5231,'ms','Baca Tambah/Kemaskini',0),(188309,5231,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø²Ø¨ÙˆÙ†',0),(188310,5231,'fr','Ajout/Mise Ã  Jour d\'un Client',0),(188311,5231,'jp','é¡§å®¢ã?®è¿½åŠ /æ›´æ–°',0),(188312,5231,'pt','Cliente adicionar/atualizar',0),(188313,5231,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(188314,5231,'es','Cliente Agregar/Actualizar',0),(188315,5231,'de','Kunden hinzufÃ¼gen/aktualisieren',0),(188316,5231,'en','Customer Add/Update',0),(188317,5232,'is','',0),(188318,5232,'dr','Ø¯Ø³ØªØ±Ø³ÙŠ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…  Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(188319,5232,'pr','Ø¯Ø³ØªØ±Ø³ÙŠ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…  Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(188320,5232,'tr','MÃ¼ÅŸteri oturum aÃ§ma eriÅŸimi',0),(188321,5232,'pl','Do logowania klienta',0),(188322,5232,'bg','Ð’Ñ…Ð¾Ð´ Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(188323,5232,'ur','Ú©Ø³Ù¹Ù…Ø± Ù„Ø§Ú¯ Ø§Ù† ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ',0),(188324,5232,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð›Ð¾Ð³Ð¸Ð½ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð°',0),(188325,5232,'vi','Quyá»n Ä‘Äƒng nháº­p cá»§a KhÃ¡ch hÃ ng',0),(188326,5232,'af','Klant / KliÃ«nt Aanteken Toegang',0),(188327,5232,'ro','Acces de Login clienti',0),(188328,5232,'et','Kliendi Login juurdepÃ¤Ã¤su',0),(188329,5232,'si','Dostop clane prepriÄevalnost',0),(188330,5232,'ba','Akses Login Pelanggan',0),(188331,5232,'nl','Klant Login toegang',0),(188332,5232,'fi','Asiakkaan kirjautumisongelmista',0),(188333,5232,'no','Kunden pÃ¥loggingstilgang',0),(188334,5232,'da','Kunde Login adgang',0),(188335,5232,'ko','ê³ ê° ë¡œê·¸ì¸ ì•¡ì„¸ìŠ¤',0),(188336,5232,'he','×’×™×©×” ×›× ×™×¡×ª ×œ×§×•×—×•×ª',0),(188337,5232,'el','Î ÎµÎ»Î¬Ï„Î· Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚',0),(188338,5232,'zh','å®¢æˆ·ç™»å½•è®¿é—®\r\n',0),(188339,5232,'sv','Kund inloggning tillgÃ¥ng',0),(188340,5232,'it','Accesso login cliente',0),(188341,5232,'tl','',0),(188342,5232,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3619;&#3632;&#3610;&#3610;',0),(188343,5232,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤²à¥‰à¤—à¤¿à¤¨ à¤ªà¤¹à¥à¤à¤š',0),(188344,5232,'ms','Pelanggan log masuk akses',0),(188345,5232,'ar','Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ ØªØ³Ø¬ÙŠÙ„ Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(188346,5232,'fr','AccÃ¨s de connexion client',0),(188347,5232,'jp','é¡§å®¢ãƒ­ã‚°ã‚¤ãƒ³ã‚¢ã‚¯ã‚»ã‚¹',0),(188348,5232,'pt','Acesso de Login do cliente',0),(188349,5232,'ru','Ð’Ñ…Ð¾Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(188350,5232,'es','Cliente Acceso a Login',0),(188351,5232,'de','Login Kundenzugang',0),(188352,5232,'en','Customer Login Access',0),(188353,5233,'is','',0),(188354,5233,'dr','/ Ù¾Ø§ÙŠØ§Ù† ',0),(188355,5233,'pr','Ù¾Ø± ÙƒØ±Ø¯Ù†  Ø´Ø±ÙˆØ¹  / Ù¾Ø§ÙŠØ§Ù† ',0),(188356,5233,'tr','Start/Stop doldurun',0),(188357,5233,'pl','WypeÅ‚niÄ‡ Start/Stop',0),(188358,5233,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ ÑÑ‚Ð°Ñ€Ñ‚/ÑÑ‚Ð¾Ð¿',0),(188359,5233,'ur','Ø´Ø±ÙˆØ¹/Ø±ÙˆÚ©ÛŒÚº Ø¨Ú¾Ø±ÛŒÚº',0),(188360,5233,'sr','ÐŸÐ¾Ð¿ÑƒÐ½Ð¸ Ð¿Ð¾Ñ‡ÐµÑ‚Ð°Ðº Ð¸ ÐºÑ€Ð°Ñ˜',0),(188361,5233,'vi','Báº¯t Ä‘áº§u/NgÆ°ng Ä‘iá»n',0),(188362,5233,'af','Vul diensbegin/Stop',0),(188363,5233,'ro','Umple pornire/oprire',0),(188364,5233,'et','TÃ¤itmise alustamine ja lÃµpetamine',0),(188365,5233,'si','Izpolnite Start/Stop',0),(188366,5233,'ba','Mengisi Start/Stop',0),(188367,5233,'nl','Vul Start/Stop',0),(188368,5233,'fi','TÃ¤ytÃ¤ Start/Stop',0),(188369,5233,'no','Fylle Start/stopp',0),(188370,5233,'da','Fylde Start/Stop',0),(188371,5233,'ko','ì‹œìž‘/ì¤‘ì§€ë¥¼ ì±„ìš°ê¸°',0),(188372,5233,'he','×ž×™×œ×•×™/×¢×¦×™×¨×”',0),(188373,5233,'el','Î“ÎµÎ¼Î¯ÏƒÏ„Îµ Ï„Î¿ Start/Stop',0),(188374,5233,'zh','å¡«å¼€å§‹åœæ­¢\r\n',0),(188375,5233,'sv','Fyll Start/stopp',0),(188376,5233,'it','Riempire di Start/Stop',0),(188377,5233,'tl','',0),(188378,5233,'th','&#3648;&#3619;&#3636;&#3656;&#3617;/&#3627;&#3618;&#3640;&#3604;&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;',0),(188379,5233,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­/à¤­à¤°à¥‡à¤‚',0),(188380,5233,'ms','Masukkan mula/tamat',0),(188381,5233,'ar','Ù…Ù„Ø¡ Ø§Ù„Ø¨Ø¯Ø¡ ÙˆØ§Ù„ØªÙˆÙ‚Ù',0),(188382,5233,'fr','Remplir le Start/Stop',0),(188383,5233,'jp','è¨˜å…¥é–‹å§‹/å?œæ­¢',0),(188384,5233,'pt','Iniciar/parar de encher',0),(188385,5233,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¡Ñ‚Ð°Ñ€Ñ‚/Ð¡Ñ‚Ð¾Ð¿',0),(188386,5233,'es','Llenar Comenzar/Detener',0),(188387,5233,'de','FÃ¼llen Sie die Start/Stopp',0),(188388,5233,'en','Fill Start/Stop',0),(188389,5234,'is','',0),(188390,5234,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(188391,5234,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(188392,5234,'tr','Yeni gÃ¶nderi',0),(188393,5234,'pl','Nowe wydanie',0),(188394,5234,'bg','ÐÐ¾Ð²Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(188395,5234,'ur','Ù†Ø¦ÛŒ Ú©Ú¾ÛŒÙ¾',0),(188396,5234,'sr','ÐÐ¾Ð²Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(188397,5234,'vi','Chuyáº¿n hÃ ng má»›i',0),(188398,5234,'af','Nuwe Versending',0),(188399,5234,'ro','Noi de expediere',0),(188400,5234,'et','Uus tarne',0),(188401,5234,'si','Novo poÅ¡iljko',0),(188402,5234,'ba','Pengiriman baru',0),(188403,5234,'nl','Nieuwe zending',0),(188404,5234,'fi','Uusi lÃ¤hetys',0),(188405,5234,'no','Ny forsendelse',0),(188406,5234,'da','Ny leverance',0),(188407,5234,'ko','ìƒˆë¡œìš´ ì„ ì ',0),(188408,5234,'he','×ž×©×œ×•×— ×—×“×©',0),(188409,5234,'el','ÎÎ­Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(188410,5234,'zh','æ–°è´§\r\n',0),(188411,5234,'sv','Ny leverans',0),(188412,5234,'it','Nuova spedizione',0),(188413,5234,'tl','',0),(188414,5234,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(188415,5234,'hi','à¤¨à¤ˆ à¤–à¥‡à¤ª',0),(188416,5234,'ms','Penghantaran baru',0),(188417,5234,'ar','Ø´Ø­Ù†Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(188418,5234,'fr','Nouvel arrivage',0),(188419,5234,'jp','æ–°è¦?ç™ºé€?',0),(188420,5234,'pt','Nova remessa',0),(188421,5234,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(188422,5234,'es','Nuevo EnvÃ­o',0),(188423,5234,'de','Neue Lieferung',0),(188424,5234,'en','New Shipment',0),(188425,5235,'is','',0),(188426,5235,'dr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ ',0),(188427,5235,'pr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ ',0),(188428,5235,'tr','SipariÅŸ giriÅŸi',0),(188429,5235,'pl','ZamÃ³wieÅ„.',0),(188430,5235,'bg','Ð’ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(188431,5235,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ Ø§Ù†Ù¹Ø±ÛŒ',0),(188432,5235,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(188433,5235,'vi','Nháº­p ÄÆ¡n HÃ ng',0),(188434,5235,'af','Bestellinginskrywing',0),(188435,5235,'ro','Ordine de intrare',0),(188436,5235,'et','Tellimuse kanne',0),(188437,5235,'si','NaroÄila',0),(188438,5235,'ba','Masuk pesanan',0),(188439,5235,'nl','Order Entry',0),(188440,5235,'fi','Tilauksen syÃ¶ttÃ¶',0),(188441,5235,'no','Bestilling',0),(188442,5235,'da','Ordreindtastning',0),(188443,5235,'ko','ì£¼ë¬¸ ìž…ë ¥',0),(188444,5235,'he','Order Entry',0),(188445,5235,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(188446,5235,'zh','è®¢å•è¾“å…¥\r\n',0),(188447,5235,'sv','OrderlÃ¤ggning',0),(188448,5235,'it','Order Entry',0),(188449,5235,'tl','',0),(188450,5235,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(188451,5235,'hi','à¤•à¥à¤°à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(188452,5235,'ms','Perintah kemasukan',0),(188453,5235,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø£Ù…Ø±',0),(188454,5235,'fr','Saisie des commandes',0),(188455,5235,'jp','æ³¨æ–‡å…¥åŠ›',0),(188456,5235,'pt','Entrada de pedido',0),(188457,5235,'ru','Ð¡Ñ‚Ð°Ñ‚ÑŒÐ¸ Ð—Ð°ÐºÐ°Ð·Ð°',0),(188458,5235,'es','Entrada de Pedido',0),(188459,5235,'de','Auftragserfassung',0),(188460,5235,'en','Order Entry',0),(188461,5236,'is','',0),(188462,5236,'dr','ÙˆØ¶Ø¹ÙŠØª Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(188463,5236,'pr','ÙˆØ¶Ø¹ÙŠØª Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(188464,5236,'tr','Ä°ÅŸlem durumu',0),(188465,5236,'pl','Stan przetwarzania',0),(188466,5236,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(188467,5236,'ur','Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(188468,5236,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¾Ð±Ñ€Ð°Ð´Ðµ',0),(188469,5236,'vi','TÃ¬nh tráº¡ng Xá»­ lÃ½',0),(188470,5236,'af','Prosessering Status',0),(188471,5236,'ro','Statutul de prelucrare',0),(188472,5236,'et','TÃ¶Ã¶tlemise staatus',0),(188473,5236,'si','Stanje obdelave',0),(188474,5236,'ba','Status pengolahan',0),(188475,5236,'nl','Verwerking Status',0),(188476,5236,'fi','KÃ¤sittelyn tila',0),(188477,5236,'no','Behandlingsstatus',0),(188478,5236,'da','Behandlingsstatus',0),(188479,5236,'ko','ì²˜ë¦¬ ìƒíƒœ',0),(188480,5236,'he','×ž×¦×‘ ×¢×™×‘×•×“',0),(188481,5236,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(188482,5236,'zh','å¤„ç†çŠ¶æ€\r\n',0),(188483,5236,'sv','Behandlingsstatus',0),(188484,5236,'it','Stato di elaborazione',0),(188485,5236,'tl','',0),(188486,5236,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;',0),(188487,5236,'hi','à¤¸à¤‚à¤¸à¤¾à¤§à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(188488,5236,'ms','Status pemprosesan',0),(188489,5236,'ar','Ù…Ø±ÙƒØ² Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬Ø©',0),(188490,5236,'fr','Statut de traitement',0),(188491,5236,'jp','å‡¦ç?†çŠ¶æ³?',0),(188492,5236,'pt','Status de processamento',0),(188493,5236,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸',0),(188494,5236,'es','Status de Procedimiento',0),(188495,5236,'de','Bearbeitungsstatus',0),(188496,5236,'en','Processing Status',0),(188497,5237,'is','',0),(188498,5237,'dr','ØºÙŠØ± Ù‚Ø§Ø¨Ù„ Ø¯Ø³ØªØ±Ø³ÙŠ',0),(188499,5237,'pr','ØºÙŠØ± Ù‚Ø§Ø¨Ù„ Ø¯Ø³ØªØ±Ø³ÙŠ',0),(188500,5237,'tr','KullanÄ±m dÄ±ÅŸÄ±',0),(188501,5237,'pl','NiedostÄ™pne',0),(188502,5237,'bg','ÐÐµÐ´Ð¾ÑÑ‚ÑŠÐ¿ÐµÐ½',0),(188503,5237,'ur','Ø¹Ø¯Ù… Ø¯Ø³ØªÛŒØ§Ø¨',0),(188504,5237,'sr','ÐÐ¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð°',0),(188505,5237,'vi','KhÃ´ng cÃ³ sáºµn',0),(188506,5237,'af','Onbeskikbaar',0),(188507,5237,'ro','Indisponibil',0),(188508,5237,'et','Pole saadaval',0),(188509,5237,'si','Ni na voljo',0),(188510,5237,'ba','Tidak tersedia',0),(188511,5237,'nl','Niet beschikbaar',0),(188512,5237,'fi','Ei ole kÃ¤ytettÃ¤vissÃ¤',0),(188513,5237,'no','Utilgjengelig',0),(188514,5237,'da','Ikke tilgÃ¦ngelig',0),(188515,5237,'ko','ì‚¬ìš©í•  ìˆ˜ ì—†ìŒ',0),(188516,5237,'he','×œ× ×–×ž×™×Ÿ',0),(188517,5237,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î·',0),(188518,5237,'zh','ä¸å¯ç”¨\r\n',0),(188519,5237,'sv','OtillgÃ¤nglig',0),(188520,5237,'it','Non disponibile',0),(188521,5237,'tl','',0),(188522,5237,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3652;&#3604;&#3657;',0),(188523,5237,'hi','à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§',0),(188524,5237,'ms','Tiada',0),(188525,5237,'ar','ØºÙŠØ± Ù…ØªÙˆÙØ±',0),(188526,5237,'fr','Indisponible',0),(188527,5237,'jp','ç„¡åŠ¹',0),(188528,5237,'pt','NÃ£o disponÃ­vel',0),(188529,5237,'ru','ÐÐµÐ´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾',0),(188530,5237,'es','No Disponible',0),(188531,5237,'de','Nicht verfÃ¼gbar',0),(188532,5237,'en','Unavailable',0),(188533,5238,'is','',0),(188534,5238,'dr','Ù†Ù…Ø§ÙŠØ´ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(188535,5238,'pr','Ù†Ù…Ø§ÙŠØ´ Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(188536,5238,'tr','Sevk gÃ¶rÃ¼nÃ¼mÃ¼',0),(188537,5238,'pl','Widok wysÅ‚ane',0),(188538,5238,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸',0),(188539,5238,'ur','Ù…Ù†Ø¸Ø± Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(188540,5238,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð°',0),(188541,5238,'vi','Xem hÃ ng Ä‘Ã£ chuyá»ƒn',0),(188542,5238,'af','Besigtig Versending',0),(188543,5238,'ro','Vezi expediate',0),(188544,5238,'et','Vaata tarnitud',0),(188545,5238,'si','Pogled, ki poÅ¡iljajo',0),(188546,5238,'ba','Lihat dikirim',0),(188547,5238,'nl','Weergave verzonden',0),(188548,5238,'fi','NÃ¤ytÃ¤ lÃ¤hetetty',0),(188549,5238,'no','Syn sendt',0),(188550,5238,'da','Se afsendt',0),(188551,5238,'ko','ë°°ì†¡ ë³´ê¸°',0),(188552,5238,'he','×ª×¦×•×’×ª ×©× ×©×œ×—×•',0),(188553,5238,'el','Î†Ï€Î¿ÏˆÎ· Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(188554,5238,'zh','æŸ¥çœ‹å‘è´§\r\n',0),(188555,5238,'sv','Visa levereras',0),(188556,5238,'it','Vista spedito',0),(188557,5238,'tl','',0),(188558,5238,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(188559,5238,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(188560,5238,'ms','Pandangan yang dihantar',0),(188561,5238,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„ØªÙŠ ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(188562,5238,'fr','Avis expÃ©diÃ©',0),(188563,5238,'jp','ç™ºé€?æ¸ˆã?®è¡¨ç¤º',0),(188564,5238,'pt','Vista enviada',0),(188565,5238,'ru','Ð’Ð¸Ð´ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(188566,5238,'es','Visionar Enviados',0),(188567,5238,'de','Ansicht geliefert',0),(188568,5238,'en','View Shipped',0),(188569,5239,'is','',0),(188570,5239,'dr','(Ø¯Ø±Ø¬Ù‡',0),(188571,5239,'pr','Ø±ØªØ¨Ù‡ (Ø¯Ø±Ø¬Ù‡',0),(188572,5239,'tr','SÄ±rasÄ±',0),(188573,5239,'pl','Rangi',0),(188574,5239,'bg','Ð Ð°Ð½Ð³',0),(188575,5239,'ur','Ø¯Ø±Ø¬Û',0),(188576,5239,'sr','Ð Ð°Ð½Ð³',0),(188577,5239,'vi','Cáº¥p báº­c',0),(188578,5239,'af','Staanplek',0),(188579,5239,'ro','Protopopiat',0),(188580,5239,'et','Rank',0),(188581,5239,'si','Rank',0),(188582,5239,'ba','Peringkat',0),(188583,5239,'nl','Rang',0),(188584,5239,'fi','Sijoitus',0),(188585,5239,'no','Rangering',0),(188586,5239,'da','Rang',0),(188587,5239,'ko','ìˆœìœ„',0),(188588,5239,'he','×“×¨×’×”',0),(188589,5239,'el','ÎšÎ±Ï„Î¬Ï„Î±Î¾Î·',0),(188590,5239,'zh','çº§åˆ«\r\n',0),(188591,5239,'sv','Rank',0),(188592,5239,'it','Rango',0),(188593,5239,'tl','',0),(188594,5239,'th','&#3649;&#3606;&#3623;',0),(188595,5239,'hi','à¤°à¥ˆà¤‚à¤•',0),(188596,5239,'ms','Pangkat',0),(188597,5239,'ar','Ø±ØªØ¨Ø©',0),(188598,5239,'fr','Grade',0),(188599,5239,'jp','ãƒ©ãƒ³ã‚¯',0),(188600,5239,'pt','Rank',0),(188601,5239,'ru','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³',0),(188602,5239,'es','Grado',0),(188603,5239,'de','Rang',0),(188604,5239,'en','Rank',0),(188605,5240,'is','',0),(188606,5240,'dr','Ø¨Ù‡ØªØ±ÙŠÙ† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ',0),(188607,5240,'pr','Ø¨Ù‡ØªØ±ÙŠÙ† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ',0),(188608,5240,'tr','En iyi satÄ±ÅŸ Ã¶ÄŸeler',0),(188609,5240,'pl','Najlepsze pozycje sprzedaÅ¼y',0),(188610,5240,'bg','ÐÐ°Ð¹-Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸',0),(188611,5240,'ur','Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± Ø§Ø´ÛŒØ§ Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(188612,5240,'sr','ÐŸÑ€Ð²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(188613,5240,'vi','HÃ ng bÃ¡n cháº¡y nháº¥t',0),(188614,5240,'af','Top Verkoop Items',0),(188615,5240,'ro','Top de vÃ¢nzare de elemente',0),(188616,5240,'et','Top mÃ¼Ã¼gi punkte',0),(188617,5240,'si','Top prodaja artiklov',0),(188618,5240,'ba','Atas menjual item',0),(188619,5240,'nl','Top verkoop Items',0),(188620,5240,'fi','Parasta myydÃ¤ tuotetta',0),(188621,5240,'no','Topp selger elementer',0),(188622,5240,'da','Top sÃ¦lger varer',0),(188623,5240,'ko','ìµœê³ ì˜ íŒë§¤ í•­ëª©',0),(188624,5240,'he','×¤×¨×™×˜×™× ×ž×•×›×¨×™× ×”×¢×œ×™×•×Ÿ',0),(188625,5240,'el','ÎšÎ¿ÏÏ…Ï†Î±Î¯Î± Ï€ÏŽÎ»Î·ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(188626,5240,'zh','æœ€ç•…é”€çš„ç‰©å“\r\n',0),(188627,5240,'sv','Top sÃ¤lja objekt',0),(188628,5240,'it','Primi elementi di vendita',0),(188629,5240,'tl','',0),(188630,5240,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3618;&#3629;&#3604;&#3648;&#3618;&#3637;&#3656;&#3618;&#3617;',0),(188631,5240,'hi','à¤¶à¥€à¤°à¥à¤· à¤¬à¥‡à¤šà¤¨à¤¾ à¤†à¤‡à¤Ÿà¤®',0),(188632,5240,'ms','Item jualan',0),(188633,5240,'ar','Ø£Ø¹Ù„Ù‰ Ø¨ÙŠØ¹ Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(188634,5240,'fr','Haut de la page points de vente',0),(188635,5240,'jp','ãƒˆãƒƒãƒ—è²©å£²å“?ç›®',0),(188636,5240,'pt','Principais itens de venda',0),(188637,5240,'ru','Ð›ÑƒÑ‡ÑˆÐ¸Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(188638,5240,'es','Los Items Principales de Ventas',0),(188639,5240,'de','Kopfelemente verkaufen',0),(188640,5240,'en','Top Selling Items',0),(188641,5241,'is','',0),(188642,5241,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ù„Ø§',0),(188643,5241,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ù„Ø§',0),(188644,5241,'tr','AyrÄ±ntÄ±lÄ± geÃ§miÅŸ rapor madde gÃ¶rÃ¼ntÃ¼lemek',0),(188645,5241,'pl','Zobacz element raport szczegÃ³Å‚owy historia',0),(188646,5241,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð´ÐµÑ‚Ð°Ð¹Ð» Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(188647,5241,'ur','ØªÙØµÛŒÙ„ ØªØ§Ø±ÛŒØ® Ø±Ù¾ÙˆØ±Ù¹ Ù…Ù†Ø¸Ø± Ø´Û’',0),(188648,5241,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÑ‚Ð°Ð²ÐºÑƒ Ð´ÐµÑ‚Ð°Ñ™Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð¸',0),(188649,5241,'vi','Xem bÃ¡o cÃ¡o lá»‹ch sá»­ luÃ¢n chuyá»ƒn hÃ ng hÃ³a',0),(188650,5241,'af','Besigtig Item Gedetaileerde Geskiedkundige Verslag',0),(188651,5241,'ro','Vezi articol detaliu istoria raport',0),(188652,5241,'et','Saate vaadata kauba Ã¼ksikasjalik ajalugu aruanne',0),(188653,5241,'si','Pregledovati poroÄilo podrobno zgodovino',0),(188654,5241,'ba','Melihat Item Detail sejarah laporan',0),(188655,5241,'nl','Item Detail geschiedenis rapport weergeven',0),(188656,5241,'fi','NÃ¤ytÃ¤ nimikkeen tiedot historiaraportti',0),(188657,5241,'no','Vis detaljert historie rapport',0),(188658,5241,'da','Se post detaljer historien rapport',0),(188659,5241,'ko','ì„¸ë¶€ ì—­ì‚¬ ë³´ê³ ì„œ í•­ëª© ë³´ê¸°',0),(188660,5241,'he','×”×¦×’ ×¤×¨×™×˜ ×¤×¨×˜ ×‘×”×™×¡×˜×•×¨×™×”',0),(188661,5241,'el','Î”ÎµÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î­ÎºÎ¸ÎµÏƒÎ· Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(188662,5241,'zh','æŸ¥çœ‹é¡¹ç›®è¯¦ç»†åŽ†å²æŠ¥å‘Š\r\n',0),(188663,5241,'sv','Visa detaljerad historia rapport',0),(188664,5241,'it','Elemento Mostra dettaglio Report cronologia',0),(188665,5241,'tl','',0),(188666,5241,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(188667,5241,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(188668,5241,'ms','Lihat butiran terperinci sejarah laporan',0),(188669,5241,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„ØªÙØµÙŠÙ„ ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(188670,5241,'fr','DÃ©couvre point dÃ©tail histoire rapport',0),(188671,5241,'jp','å“?ç›®è©³ç´°å±¥æ­´ãƒ¬ãƒ?ãƒ¼ãƒˆã?®è¡¨ç¤º',0),(188672,5241,'pt','Ver Item relatÃ³rio de histÃ³rico de detalhe',0),(188673,5241,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸',0),(188674,5241,'es','Visionar Informe de Detalle de la Historia de los Items',0),(188675,5241,'de','Detailbericht Element Geschichte',0),(188676,5241,'en','View Item Detail History Report',0),(188677,5242,'is','',0),(188678,5242,'dr','/ Ø§ÙƒÙ†ÙˆÙ† Ù…ÙˆØ¹Ø¯/ Ø¨Ø¹Ø¯Ø§ Ù…ÙˆØ¹Ø¯',0),(188679,5242,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨  Ù…Ø¹ÙˆÙ‚ / Ø§ÙƒÙ†ÙˆÙ† Ø³Ø±Ø±Ø³ÙŠØ¯/ Ø¨Ø¹Ø¯Ø§ Ø³Ø±Ø±Ø³ÙŠØ¯',0),(188680,5242,'tr','Vadesi geÃ§miÅŸ/nedeniyle yakÄ±nda/vadesi daha sonra Bill',0),(188681,5242,'pl','Bill zalegÅ‚e/Due wkrÃ³tce/Due pÃ³Åºniej',0),(188682,5242,'bg','Ð‘Ð¸Ð» Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸/Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾ ÑÐºÐ¾Ñ€Ð¾ Ð¿Ð¾/Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð¿Ð¾-ÐºÑŠÑÐ½Ð¾',0),(188683,5242,'ur','Ø¨Ø¹Ø¯ Ø§Ø²Ø§Úº Ù…ÙˆØ®Ø±/Ù…Ù‚Ø±Ø±Û Ø¬Ù„Ø¯/Ù…Ù‚Ø±Ø±Û Ø¨Ù„',0),(188684,5242,'sr','Ð‘Ð¸Ð» ÐºÐ°ÑÐ½Ð¸Ñ˜Ðµ ÑÐ° Ð¿Ñ€ÐµÐºÐ¾Ñ€Ð°Ñ‡ÐµÐ½Ð¸Ð¼ Ñ€Ð¾ÐºÐ¾Ð¼ Ð´Ð¾ÑÐ¿ÐµÑ›Ð° ÑƒÑÐºÐ¾Ñ€Ð¾/ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(188685,5242,'vi','HÃ³a ÄÆ¡n QuÃ¡ Háº¡n/Sáº¯p Äáº¿n Háº¡n/Äáº¿n Háº¡n Sau',0),(188686,5242,'af','Rekening Agterstallig/Binnekort Verskuldig/Later Verskuldig',0),(188687,5242,'ro','Bill restante/cuvenit Ã®n curÃ¢nd/Due mai tÃ¢rziu',0),(188688,5242,'et','Arve tÃ¤htajaks tasumata/nÃµuetekohaselt varsti/nÃµuetekohaselt hiljem',0),(188689,5242,'si','Bill zdavnaj/zapadlosti kmalu/zapadlosti kasneje',0),(188690,5242,'ba','Tagihan terlambat/karena segera/Due kemudian',0),(188691,5242,'nl','Bill achterstallige/Due snel/Due Later',0),(188692,5242,'fi','Bill myÃ¶hÃ¤ssÃ¤/erÃ¤Ã¤ntynyt pian/erÃ¤Ã¤ntynyt myÃ¶hemmin',0),(188693,5242,'no','Bill forfalte/forfaller snart/grunn senere',0),(188694,5242,'da','Bill forfaldne/Due snart/Due senere',0),(188695,5242,'ko','ì—°ì²´ë¡œ ì¸í•´ ê³§/ì¸í•´ ë‚˜ì¤‘ì— ë¹Œ',0),(188696,5242,'he','×‘×™×œ ×©×ª××¨×™×š ×”×™×¢×“ ×©×œ×”×Ÿ ×—×œ×£/×™×¢×“ ×‘×§×¨×•×‘/×™×¢×“ ××—×¨ ×›×š',0),(188697,5242,'el','Bill ÎµÎºÏ€ÏÏŒÎ¸ÎµÏƒÎ¼ÎµÏ‚/Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ ÏƒÏÎ½Ï„Î¿Î¼Î±/Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î±ÏÎ³ÏŒÏ„ÎµÏÎ±',0),(188698,5242,'zh','å¸å•é€¾æœŸ/å³å°†æˆªæ­¢/è¿Ÿäº›åˆ°æœŸ\r\n',0),(188699,5242,'sv','Bill fÃ¶rsenade/vederbÃ¶rlig snart/vederbÃ¶rlig senare',0),(188700,5242,'it','Bill in ritardo/scadenza presto/scadenza successivamente',0),(188701,5242,'tl','',0),(188702,5242,'th','&#3610;&#3636;&#3621;&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;/&#3651;&#3585;&#3621;&#3657;&#3585;&#3635;&#3627;&#3609;&#3604;/&#3627;&#3621;&#3633;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(188703,5242,'hi','à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚ à¤…à¤¤à¤¿à¤¦à¥‡à¤¯/à¤¨à¤¿à¤¯à¤¤ à¤œà¤²à¥à¤¦ à¤¹à¥€/à¤¨à¤¿à¤¯à¤¤ à¤¬à¤¿à¤²',0),(188704,5242,'ms','Bil tertunggak/sewajarnya tidak lama lagi/akhir nanti',0),(188705,5242,'ar','Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ø§Ù„ÙˆØ§Ø¬Ø¨ Ø§Ù†ØªØ¸Ø§Ø±Ù‡Ø§/Ù‚Ø±ÙŠØ¨Ø§/Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ ÙÙŠ ÙˆÙ‚Øª Ù„Ø§Ø­Ù‚',0),(188706,5242,'fr','Projet de loi en retard/Ã  bientÃ´t/Ã  plus tard',0),(188707,5242,'jp','æœŸé™?çµŒé?Ž/æœŸé™?é–“è¿‘/æœŸé™?å‰?è«‹æ±‚æ›¸',0),(188708,5242,'pt','Conta em atraso/Due logo/Due mais tarde',0),(188709,5242,'ru','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ/Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾ ÑÐºÐ¾Ñ€Ð¾/Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾ Ð¿Ð¾Ð·Ð¶Ðµ Ð‘Ð¸Ð»Ð»',0),(188710,5242,'es','Factura Vencida/Vencida Pronto/Vencida mÃ¡s Tarde',0),(188711,5242,'de','Bill Ã¼berfÃ¤llig/Due/Due spÃ¤ter',0),(188712,5242,'en','Bill Overdue/Due Soon/Due Later',0),(188713,5243,'is','',0),(188714,5243,'dr','Pg  Ø­Ø³Ø§Ø¨ Ø§Ø¬Ø§Ø±Ù‡ ',0),(188715,5243,'pr','Pg  Ø­Ø³Ø§Ø¨ Ø§Ø¬Ø§Ø±Ù‡ ',0),(188716,5243,'tr','PG',0),(188717,5243,'pl','PG',0),(188718,5243,'bg','PG',0),(188719,5243,'ur','Pg',0),(188720,5243,'sr','ÐŸÐ“',0),(188721,5243,'vi','Pg',0),(188722,5243,'af','PG',0),(188723,5243,'ro','PG',0),(188724,5243,'et','PG',0),(188725,5243,'si','PG',0),(188726,5243,'ba','PG',0),(188727,5243,'nl','PG',0),(188728,5243,'fi','PG',0),(188729,5243,'no','PG',0),(188730,5243,'da','PG',0),(188731,5243,'ko','Pg',0),(188732,5243,'he','Pg',0),(188733,5243,'el','PG',0),(188734,5243,'zh','ç¨‹åºåˆ¶å¯¼\r\n',0),(188735,5243,'sv','PG',0),(188736,5243,'it','PG',0),(188737,5243,'tl','',0),(188738,5243,'th','&#3627;&#3609;&#3657;&#3634;',0),(188739,5243,'hi','à¤¸à¥à¤¨à¤¾à¤¤à¤•à¥‹à¤¤à¥à¤¤à¤°',0),(188740,5243,'ms','Pg',0),(188741,5243,'ar','Pg',0),(188742,5243,'fr','PG',0),(188743,5243,'jp','ãƒšãƒ¼ã‚¸',0),(188744,5243,'pt','PG',0),(188745,5243,'ru','PG',0),(188746,5243,'es','Pg.',0),(188747,5243,'de','PG',0),(188748,5243,'en','Pg',0),(188749,5244,'is','',0),(188750,5244,'dr',' ØªØºÙŠÙŠØ± Ø¯Ø± Ø§ÙƒØ«Ø± Ù…Ø§Ù‡ Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ±',0),(188751,5244,'pr',' ØªØºÙŠÙŠØ± Ø¯Ø± Ø§ÙƒØ«Ø± Ù…Ø§Ù‡ Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ±',0),(188752,5244,'tr','En son aya deÄŸiÅŸiyor.',0),(188753,5244,'pl','Zmiana do ostatniego miesiÄ…ca.',0),(188754,5244,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ Ð¼ÐµÑÐµÑ†.',0),(188755,5244,'ur','ØªØ§Ø²Û ØªØ±ÛŒÙ† Ù…ÛÛŒÙ†Û Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(188756,5244,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð½Ð° Ð½Ð°Ñ˜Ð½Ð¾Ð²Ð¸Ñ˜Ð° Ð¼ÐµÑÐµÑ†Ð°.',0),(188757,5244,'vi','Äá»•i sang thÃ¡ng gáº§n nháº¥t',0),(188758,5244,'af','Verander die mees onlangse maand.',0),(188759,5244,'ro','Schimbarea la cele mai recente luna.',0),(188760,5244,'et','Muutuv viimasel kuul.',0),(188761,5244,'si','Spreminjanje zadnji mesec.',0),(188762,5244,'ba','Berubah untuk pemesanan bulan.',0),(188763,5244,'nl','Meest recente maand veranderen.',0),(188764,5244,'fi','Siirtyminen viimeiseltÃ¤ kuukaudelta.',0),(188765,5244,'no','Endre til siste mÃ¥neden.',0),(188766,5244,'da','Ã†ndre til sidste mÃ¥ned.',0),(188767,5244,'ko','ê°€ìž¥ ìµœê·¼ì˜ ë‹¬ìœ¼ë¡œ ë³€ê²½ í•©ë‹ˆë‹¤.',0),(188768,5244,'he','×©×™× ×•×™ ×‘×—×•×“×© ×”××—×¨×•×Ÿ.',0),(188769,5244,'el','Î‘Î»Î»Î±Î³Î® ÏƒÎµ Ï€Î¹Î¿ Ï€ÏÏŒÏƒÏ†Î±Ï„Î¿ Î¼Î®Î½Î±.',0),(188770,5244,'zh','æ›´æ”¹ä¸ºæœ€è¿‘ä¸€ä¸ªæœˆã€‚\r\n',0),(188771,5244,'sv','Ã„ndra till senaste mÃ¥naden.',0),(188772,5244,'it','Cambiando al mese piÃ¹ recente.',0),(188773,5244,'tl','',0),(188774,5244,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3648;&#3604;&#3639;&#3629;&#3609;&#3607;&#3637;&#3656;&#3648;&#3614;&#3636;&#3656;&#3591;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634;&#3621;&#3',0),(188775,5244,'hi','à¤¸à¤¬à¤¸à¥‡ à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤®à¤¾à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¦à¤² à¤°à¤¹à¤¾ à¤¹à¥ˆà¥¤',0),(188776,5244,'ms','Perubahan kepada bulan yang terkini.',0),(188777,5244,'ar','ØªØºÙŠÙŠØ± Ø¥Ù„Ù‰ Ø¢Ø®Ø± Ø§Ù„Ø´Ù‡Ø±.',0),(188778,5244,'fr','Changer pour le mois le plus rÃ©cent.',0),(188779,5244,'jp','æœ€è¿‘ã?®æœˆã?¸å¤‰æ›´ã?™ã‚‹',0),(188780,5244,'pt','Mudando para o mÃªs mais recente.',0),(188781,5244,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð² Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð¼ÐµÑÑÑ†.',0),(188782,5244,'es','Cambiando a la mes mÃ¡s reciente',0),(188783,5244,'de','Die letzten Monat Ã¤ndern.',0),(188784,5244,'en','Changing to most recent month.',0),(188785,5245,'is','',0),(188786,5245,'dr','ØªØ¹Ø¯Ø§Ø¯ Ú†Ø§Ù¾ Ù‡Ø§ ',0),(188787,5245,'pr','ØªØ¹Ø¯Ø§Ø¯ Ú†Ø§Ù¾ Ù‡Ø§ ',0),(188788,5245,'tr','# GÃ¶sterimler',0),(188789,5245,'pl','# WyÅ›wietleÅ„',0),(188790,5245,'bg','# Ð˜Ð¼Ð¿Ñ€ÐµÑÐ¸Ð¸',0),(188791,5245,'ur','# Ù†Ù‚ÙˆØ´',0),(188792,5245,'sr','# Ð£Ñ‚Ð¸ÑÐºÐµ',0),(188793,5245,'vi','Sá»‘ áº¥n tÆ°á»£ng',0),(188794,5245,'af','# Indrukke',0),(188795,5245,'ro','# Impresii',0),(188796,5245,'et','# Muljed',0),(188797,5245,'si','# Prikazov',0),(188798,5245,'ba','# Tayangan',0),(188799,5245,'nl','# Indrukken',0),(188800,5245,'fi','# NÃ¤yttÃ¶kerrat',0),(188801,5245,'no','# Visninger',0),(188802,5245,'da','# Visninger',0),(188803,5245,'ko','# ë…¸ì¶œ',0),(188804,5245,'he','# ×¨×©×ž×™×',0),(188805,5245,'el','# Î•Î¼Ï†Î±Î½Î¯ÏƒÎµÏ‰Î½',0),(188806,5245,'zh','ï¼ƒå°è±¡\r\n',0),(188807,5245,'sv','# Intryck',0),(188808,5245,'it','# Impressioni',0),(188809,5245,'tl','',0),(188810,5245,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3591;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(188811,5245,'hi','# à¤›à¤¾à¤ªà¥‡à¤‚',0),(188812,5245,'ms','# Jejak',0),(188813,5245,'ar','# Ø§Ù†Ø·Ø¨Ø§Ø¹Ø§Øª',0),(188814,5245,'fr','# Impressions',0),(188815,5245,'jp','åˆ·ã?®æ•°',0),(188816,5245,'pt','# ImpressÃµes',0),(188817,5245,'ru','# Ð’Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸Ñ',0),(188818,5245,'es','# impresiones',0),(188819,5245,'de','-Impressionen',0),(188820,5245,'en','# Impressions',0),(188821,5246,'is','',0),(188822,5246,'dr','Ø¯Ø±ØµØ¯ Ú†Ø§Ù¾',0),(188823,5246,'pr','Ø¯Ø±ØµØ¯ Ú†Ø§Ù¾',0),(188824,5246,'tr','% GÃ¶sterimler',0),(188825,5246,'pl','% WyÅ›wietleÅ„',0),(188826,5246,'bg','% Ð’Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸ÑÑ‚Ð°',0),(188827,5246,'ur','% Ù†Ù‚ÙˆØ´',0),(188828,5246,'sr','% Ð£Ñ‚Ð¸ÑÐºÐµ',0),(188829,5246,'vi','% áº¥n tÆ°á»£ng ',0),(188830,5246,'af','% Indrukke',0),(188831,5246,'ro','Impresii %',0),(188832,5246,'et','% Muljed',0),(188833,5246,'si','% Prikazov',0),(188834,5246,'ba','Tayangan %',0),(188835,5246,'nl','% Indrukken',0),(188836,5246,'fi','% NÃ¤yttÃ¶kerrat',0),(188837,5246,'no','% Visninger',0),(188838,5246,'da','% Visninger',0),(188839,5246,'ko','% ì¸ìƒ',0),(188840,5246,'he','×¨×©×ž×™× %',0),(188841,5246,'el','% Î•Î½Ï„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚',0),(188842,5246,'zh','ï¼…å°è±¡\r\n',0),(188843,5246,'sv','% Intryck',0),(188844,5246,'it','Impressioni %',0),(188845,5246,'tl','',0),(188846,5246,'th','&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3591;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(188847,5246,'hi','% à¤›à¤¾à¤ªà¥‡à¤‚',0),(188848,5246,'ms','% Kesan',0),(188849,5246,'ar','Ø§Ù†Ø·Ø¨Ø§Ø¹Ø§Øª %',0),(188850,5246,'fr','Impressions %',0),(188851,5246,'jp','åˆ·ã?®æ¯”çŽ‡',0),(188852,5246,'pt','% ImpressÃµes',0),(188853,5246,'ru','% Ð’Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸Ñ',0),(188854,5246,'es','% Impresiones',0),(188855,5246,'de','%-Impressionen',0),(188856,5246,'en','% Impressions',0),(188857,5247,'is','',0),(188858,5247,'dr','Ø¯Ø±ØµØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(188859,5247,'pr','Ø¯Ø±ØµØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(188860,5247,'tr','% SipariÅŸler',0),(188861,5247,'pl','% ZamÃ³wieÅ„',0),(188862,5247,'bg','% ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(188863,5247,'ur','ÙÛŒ ØµØ¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(188864,5247,'sr','% ÐÐ°Ñ€ÐµÑ’ÐµÑšÐ°',0),(188865,5247,'vi','% Äáº·t HÃ ng',0),(188866,5247,'af','% Bestellings',0),(188867,5247,'ro','% Comenzi',0),(188868,5247,'et','% Tellimused',0),(188869,5247,'si','% NaroÄil',0),(188870,5247,'ba','Pesanan %',0),(188871,5247,'nl','% Orders',0),(188872,5247,'fi','% Tilaukset',0),(188873,5247,'no','% Ordrer',0),(188874,5247,'da','% Ordrer',0),(188875,5247,'ko','% ì£¼ë¬¸',0),(188876,5247,'he','×”×–×ž× ×•×ª %',0),(188877,5247,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ %',0),(188878,5247,'zh','ï¼…è®¢å•\r\n',0),(188879,5247,'sv','% Order',0),(188880,5247,'it','% Ordini',0),(188881,5247,'tl','',0),(188882,5247,'th','&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(188883,5247,'hi','% à¤†à¤¦à¥‡à¤¶',0),(188884,5247,'ms','Perintah-perintah %',0),(188885,5247,'ar','Ø£ÙˆØ§Ù…Ø± %',0),(188886,5247,'fr','Commandes %',0),(188887,5247,'jp','æ³¨æ–‡ã?®æ¯”çŽ‡',0),(188888,5247,'pt','Ordens %',0),(188889,5247,'ru','% Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(188890,5247,'es','% Ordenes',0),(188891,5247,'de','% AuftrÃ¤ge',0),(188892,5247,'en','% Orders',0),(188893,5248,'is','',0),(188894,5248,'dr','Ø¢Ù…Ø§Ø± Ø¨Ù‡ Ù…ÙˆÙ‚Ø¹ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡',0),(188895,5248,'pr','Ø¢Ù…Ø§Ø± Ø¨Ù‡ Ù…ÙˆÙ‚Ø¹ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡',0),(188896,5248,'tr','BasÄ±mevi-Time istatistik',0),(188897,5248,'pl','Drukarnia na czas statystyki',0),(188898,5248,'bg','ÐŸÐµÑ‡Ð°Ñ‚Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð½Ð° Ð²Ñ€ÐµÐ¼ÐµÑ‚Ð¾ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(188899,5248,'ur','Ù¾Ø±Ø§Ù†Ù¹Ø´ÙˆÙ¾ Ù¾Ø± ÙˆÙ‚Øª Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±',0),(188900,5248,'sr','ÐŸÑ€Ð¸Ð½Ñ‚ÑÑ…Ð¾Ð¿ Ð½Ð° ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÑƒ',0),(188901,5248,'vi','Thá»‘ng kÃª shop in trá»±c tuyáº¿n',0),(188902,5248,'af','Printshop op-tyd statistiek',0),(188903,5248,'ro','Printshop la timp statistici',0),(188904,5248,'et','TrÃ¼kikojale Ãµigeaegne statistika',0),(188905,5248,'si','Tiskarni pravoÄasno statistika',0),(188906,5248,'ba','Printshop On-Time Statistik',0),(188907,5248,'nl','PrintShop On-Time Statistieken',0),(188908,5248,'fi','Painotalon aika tilastot',0),(188909,5248,'no','Trykkeriets tid statistikk',0),(188910,5248,'da','Printshop On-Time statistik',0),(188911,5248,'ko','Printshop ì‹œê°„ í†µê³„',0),(188912,5248,'he','×”×™×™×¢×•×¥ ×¢×œ ×¡×˜×˜×™×¡×˜×™×§×•×ª',0),(188913,5248,'el','Î¤Ï…Ï€Î¿Î³ÏÎ±Ï†ÎµÎ¯Î¿Ï… On-Time ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ­Ï‚',0),(188914,5248,'zh','å°åˆ·æ‰€æŒ‰æ—¶ç»Ÿè®¡\r\n',0),(188915,5248,'sv','Tryckeriet i tid statistik',0),(188916,5248,'it','PrintShop tempo statistiche',0),(188917,5248,'tl','',0),(188918,5248,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3619;&#3657;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;&#3607;&#3637;&#3656;&#3605;&#3619;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(188919,5248,'hi','Printshop à¤ªà¤° à¤¸à¤®à¤¯ à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤•à¥€',0),(188920,5248,'ms','Statistik Printshop tepat pada masa',0),(188921,5248,'ar','Ø¥Ø­ØµØ§Ø¡Ø§Øª Ø§Ù„Ù…Ø·Ø¨Ø¹Ø© ÙÙŠ ÙˆÙ‚Øª',0),(188922,5248,'fr','PrintShop sur temps-statistiques',0),(188923,5248,'jp','å?°åˆ·æ‰€å®šæ™‚çµ±è¨ˆ',0),(188924,5248,'pt','EstatÃ­sticas de tipografia do tempo',0),(188925,5248,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ñ‚Ð¸Ð¿Ð¾Ð³Ñ€Ð°Ñ„Ð¸Ð¸ Ð¿Ð¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(188926,5248,'es','EstadÃ­sticas de en tiempo de Tienda de Imprenta',0),(188927,5248,'de','PrintShop On-Time-Statistik',0),(188928,5248,'en','Printshop On-Time Statistics',0),(188929,5249,'is','',0),(188930,5249,'dr','Ø¢Ù…Ø§Ø± Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(188931,5249,'pr','Ø¢Ù…Ø§Ø± Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(188932,5249,'tr','BasÄ±mevi sipariÅŸi istatistikleri iÃ§in',0),(188933,5249,'pl','Drukarnia Statystyka dla',0),(188934,5249,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð°',0),(188935,5249,'ur','Ù¾Ø±Ø§Ù†Ù¹Ø´ÙˆÙ¾ Ø¢Ø±ÚˆØ± Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± Ú©Û’ Ù„Ø¦Û’',0),(188936,5249,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¸Ð½Ñ‚ÑÑ…Ð¾Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(188937,5249,'vi','Thá»‘ng kÃª Ä‘Æ¡n hÃ ng tiá»‡m in cho',0),(188938,5249,'af','Printshop te orde statistiek vir',0),(188939,5249,'ro','Printshop ordinea statistici pentru',0),(188940,5249,'et','TrÃ¼kikojale statistika jaoks',0),(188941,5249,'si','Statistika tiskarni naloga za',0),(188942,5249,'ba','Statistik Printshop Order',0),(188943,5249,'nl','PrintShop orderstatistiek voor',0),(188944,5249,'fi','Painotalon tilaus tilastot',0),(188945,5249,'no','Trykkeriets ordre statistikk For',0),(188946,5249,'da','Printshop ordre statistik For',0),(188947,5249,'ko','Printshop ìˆœì„œì— ëŒ€ í•œ í†µê³„',0),(188948,5249,'he','×”×–×ž× ×ª ×”×™×™×¢×•×¥ ×¡×˜×˜×™×¡×˜×™×§×” ×¢×‘×•×¨',0),(188949,5249,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ Ï„Î¿Ï… Ï„Ï…Ï€Î¿Î³ÏÎ±Ï†ÎµÎ¯Î¿Ï… Î•Î½Ï„ Î³Î¹Î±',0),(188950,5249,'zh','æ‰“å°æ‰€è®¢å•ç»Ÿè®¡\r\n',0),(188951,5249,'sv','Tryckeriet statistik fÃ¶r',0),(188952,5249,'it','Statistiche di PrintShop ordine per',0),(188953,5249,'tl','',0),(188954,5249,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3619;&#3657;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(188955,5249,'hi','Printshop à¤•à¥à¤°à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤‚à¤–à¥à¤¯à¤¿à¤•à¥€',0),(188956,5249,'ms','Statistik Printshop perintah bagi',0),(188957,5249,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…Ø·Ø¨Ø¹Ø©',0),(188958,5249,'fr','Statistiques de commande de l\'atelier d\'imprimerie pour',0),(188959,5249,'jp','å?°åˆ·æ‰€æ³¨æ–‡çµ±è¨ˆ',0),(188960,5249,'pt','EstatÃ­sticas de ordem grÃ¡fica para',0),(188961,5249,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ñ‚Ð¸Ð¿Ð¾Ð³Ñ€Ð°Ñ„Ð¸Ð¸ Ð´Ð»Ñ',0),(188962,5249,'es','EstadÃ­sticas de Orden de Printshop Para',0),(188963,5249,'de','PrintShop-Statistik fÃ¼r',0),(188964,5249,'en','Printshop Order Statistics For',0),(188965,5250,'is','',0),(188966,5250,'dr','(Ø´Ø±ÙˆØ¹) Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø³Øª ',0),(188967,5250,'pr','ØªØ§Ø±ÙŠØ® Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²Ù‰(Ø´Ø±ÙˆØ¹) Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø³Øª ',0),(188968,5250,'tr','BaÅŸlangÄ±Ã§ tarihi bitiÅŸ tarihinden sonra olduÄŸunu',0),(188969,5250,'pl','Data poczÄ…tkowa jest po daty koÅ„cowej',0),(188970,5250,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð° Ðµ ÑÐ»ÐµÐ´ ÐºÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(188971,5250,'ur','ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ø®ØªÙ… Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ø¹Ø¯ ÛÛ’ ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(188972,5250,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ðµ ÐºÑ€Ð°Ñ˜ÑšÐµÐ³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(188973,5250,'vi','NgÃ y Báº¯t Äáº§u lÃ  sau ngÃ y káº¿t thÃºc',0),(188974,5250,'af','Aavangsdatum na na end datum',0),(188975,5250,'ro','Data de Ã®nceput este dupÄƒ data de sfÃ¢rÅŸit',0),(188976,5250,'et','AlguskuupÃ¤ev on pÃ¤rast lÃµppkuupÃ¤eva',0),(188977,5250,'si','ZaÄetni datum je po konÄni datum',0),(188978,5250,'ba','Tanggal mulai adalah setelah tanggal berakhirnya',0),(188979,5250,'nl','Na de einddatum is begindatum',0),(188980,5250,'fi','Aloituspvm on Lopetuspvm',0),(188981,5250,'no','Startdatoen er etter sluttdato',0),(188982,5250,'da','Startdato er efter slutdato',0),(188983,5250,'ko','ì‹œìž‘ ë‚ ì§œëŠ” ì¢…ë£Œ ë‚ ì§œ í›„',0),(188984,5250,'he','×ª××¨×™×š ×›× ×™×¡×” ×”×•× ×œ××—×¨ ×ª××¨×™×š ×¡×’×™×¨×”',0),(188985,5250,'el','Î—Î¼/Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ ÎµÎ¯Î½Î±Î¹ Î¼ÎµÏ„Î¬ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(188986,5250,'zh','èµ·å§‹æ—¥æœŸåœ¨ç»“æŸæ—¥æœŸåŽ\r\n',0),(188987,5250,'sv','Startdatum Ã¤r efter slutdatum',0),(188988,5250,'it','Data di partenza Ã¨ dopo la data di fine',0),(188989,5250,'tl','',0),(188990,5250,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3627;&#3621;&#3633;&#3591;&#3592;&#3634;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(188991,5250,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‡ à¤¶à¥à¤°à¥‚ à¤¤à¤¿à¤¥à¤¿ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¹à¥ˆ',0),(188992,5250,'ms','Bermula tarikh adalah selepas berakhir pada tarikh',0),(188993,5250,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡ Ø¨Ø¹Ø¯ ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡',0),(188994,5250,'fr','Date de dÃ©but est aprÃ¨s la date de fin',0),(188995,5250,'jp','é–‹å§‹æ—¥ã?Œçµ‚äº†æ—¥ã?®å¾Œã?§ã?™',0),(188996,5250,'pt','Data de inÃ­cio Ã© apÃ³s a data de encerramento',0),(188997,5250,'ru','ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ð°Ñ Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÐ»Ðµ Ð´Ð°Ñ‚Ñ‹ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(188998,5250,'es','Fecha de Inicio es despuÃ©s de fecha de terminaciÃ³n',0),(188999,5250,'de','Kursbeginn ist nach Enddatum',0),(189000,5250,'en','Starting date is after ending date',0),(189001,5251,'is','',0),(189002,5251,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(189003,5251,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(189004,5251,'tr','Madde iÃ§in toplam',0),(189005,5251,'pl','Suma pozycji',0),(189006,5251,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(189007,5251,'ur','Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„',0),(189008,5251,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð° ÑÑ‚Ð°Ð²ÐºÑƒ',0),(189009,5251,'vi','Tá»•ng cá»™ng cho hÃ ng',0),(189010,5251,'af','Totaal vir Item',0),(189011,5251,'ro','Total pentru element',0),(189012,5251,'et','Punkt, kokku',0),(189013,5251,'si','Skupaj za postavko',0),(189014,5251,'ba','Total untuk Item',0),(189015,5251,'nl','Totaal voor object',0),(189016,5251,'fi','YhteensÃ¤ nimikkeen',0),(189017,5251,'no','Totalt for vare',0),(189018,5251,'da','Totalen for varen',0),(189019,5251,'ko','í•­ëª©ì— ëŒ€ í•œ ì´',0),(189020,5251,'he','×¡×” ×¢×‘×•×¨ ×¤×¨×™×˜',0),(189021,5251,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î³Î¹Î± Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(189022,5251,'zh','é¡¹ç›®æ€»è®¡\r\n',0),(189023,5251,'sv','Totalt fÃ¶r artikeln',0),(189024,5251,'it','Totale per voce',0),(189025,5251,'tl','',0),(189026,5251,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(189027,5251,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²',0),(189028,5251,'ms','Jumlah keseluruhan Item',0),(189029,5251,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ØµÙ†Ù',0),(189030,5251,'fr','Total de rubrique',0),(189031,5251,'jp','å“?ç›®ã?®å?ˆè¨ˆ',0),(189032,5251,'pt','Total por Item',0),(189033,5251,'ru','Ð’ÑÐµÐ³Ð¾ Ð´Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(189034,5251,'es','Total para Item',0),(189035,5251,'de','Insgesamt fÃ¼r Artikel',0),(189036,5251,'en','Total for Item',0),(189037,5252,'is','',0),(189038,5252,'dr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ',0),(189039,5252,'pr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ',0),(189040,5252,'tr','Fatura tarihi aralÄ±ÄŸÄ±',0),(189041,5252,'pl','Rozliczane zakres dat.',0),(189042,5252,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(189043,5252,'ur','Ø¨Ø§Ù„Ù„Ø§Ø¯ ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(189044,5252,'sr','ÐšÑƒÐ¿Ð¾Ð²Ð¸Ð½Ð° Ñ‚ÐµÑ€ÐµÑ‚Ð¸Ñ›Ðµ Ð¾Ð¿ÑÐµÐ³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(189045,5252,'vi','Pháº¡m Vi NgÃ y Láº­p HÃ³a ÄÆ¡n',0),(189046,5252,'af','WeerspieÃ«l datumbestek',0),(189047,5252,'ro','Intervalul de Date facturate',0),(189048,5252,'et','Ostu kohta arveldus kuupÃ¤evavahemik',0),(189049,5252,'si','Bremenjene datumski obseg',0),(189050,5252,'ba','Ditagih rentang tanggal',0),(189051,5252,'nl','Gefactureerde datumbereik',0),(189052,5252,'fi','Majoitusten pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤alue',0),(189053,5252,'no','Fakturerte datointervall',0),(189054,5252,'da','Faktureret datointerval',0),(189055,5252,'ko','ì²­êµ¬ ë‚ ì§œ ë²”ìœ„',0),(189056,5252,'he','×˜×•×•×— ×ª××¨×™×›×™× ×©×—×•×™×‘',0),(189057,5252,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î¿ ÎµÏÏÎ¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½',0),(189058,5252,'zh','å¸å•æ—¥æœŸèŒƒå›´\r\n',0),(189059,5252,'sv','Fakturerade datumintervall',0),(189060,5252,'it','Fatturati intervallo di Date',0),(189061,5252,'tl','',0),(189062,5252,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(189063,5252,'hi','à¤–à¤¼à¤°à¥€à¤¦ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€',0),(189064,5252,'ms','Julat tarikh yang dibilkan sebanyak',0),(189065,5252,'ar','Ù†Ø·Ø§Ù‚ Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(189066,5252,'fr','Plage de dates facturÃ©s',0),(189067,5252,'jp','è«‹æ±‚æ—¥ç¯„å›²',0),(189068,5252,'pt','Intervalo de datas faturado',0),(189069,5252,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚',0),(189070,5252,'es','Rango de Datos Facturados',0),(189071,5252,'de','-Abrechnung Datumsbereich',0),(189072,5252,'en','Billed Date Range',0),(189073,5253,'is','',0),(189074,5253,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§  ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(189075,5253,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§  ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(189076,5253,'tr','Sevk irsaliyelerini gÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klatÄ±n',0),(189077,5253,'pl','Kliknij, aby wyÅ›wietliÄ‡ przesyÅ‚ek',0),(189078,5253,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸Ñ‚Ðµ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(189079,5253,'ur','ØªØ±Ø³ÛŒÙ„ Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(189080,5253,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð²Ð¸Ð´ÐµÐ»Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(189081,5253,'vi','Nháº¥n Ä‘á»ƒ xem chuyáº¿n hÃ ng',0),(189082,5253,'af','Kliek om te Versendings te Besigtig',0),(189083,5253,'ro','Click pentru a vizualiza transporturile',0),(189084,5253,'et','Tarnete vaatamiseks klÃµpsa',0),(189085,5253,'si','Kliknite za ogled poÅ¡iljk',0),(189086,5253,'ba','Klik untuk melihat pengiriman',0),(189087,5253,'nl','Klik om te bekijken van zendingen',0),(189088,5253,'fi','Valitsemalla tÃ¤mÃ¤n voit tarkastella toimituksia',0),(189089,5253,'no','Klikk for Ã¥ vise forsendelser',0),(189090,5253,'da','Klik her for at se overfÃ¸rsler',0),(189091,5253,'ko','ì¶œí•˜ë¥¼ ë³´ë ¤ë©´ í´ë¦­',0),(189092,5253,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’ ×ž×©×œ×•×—×™×',0),(189093,5253,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(189094,5253,'zh','ç‚¹å‡»æŸ¥çœ‹å‘è´§\r\n',0),(189095,5253,'sv','Klicka fÃ¶r att Visa transporter',0),(189096,5253,'it','Mostra consegne',0),(189097,5253,'tl','',0),(189098,5253,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(189099,5253,'hi','à¤²à¤¦à¤¾à¤¨ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(189100,5253,'ms','Klik untuk melihat penghantaran',0),(189101,5253,'ar','Ø£Ù†Ù‚Ø± Ù„Ø¹Ø±Ø¶ Ø§Ù„Ø´Ø­Ù†Ø§Øª',0),(189102,5253,'fr','Cliquer ici pour voir les expÃ©ditions',0),(189103,5253,'jp','ç™ºé€?ã‚’è¡¨ç¤ºã?™ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(189104,5253,'pt','Clique para ver os embarques',0),(189105,5253,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð³Ñ€ÑƒÐ·Ð¾Ð²',0),(189106,5253,'es','Click para Ver envÃ­os',0),(189107,5253,'de','Hier klicken, um Sendungen anzeigen',0),(189108,5253,'en','Click to view shipments',0),(189109,5254,'is','',0),(189110,5254,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´ Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(189111,5254,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´ Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(189112,5254,'tr','KapalÄ± sipariÅŸ raporu',0),(189113,5254,'pl','ZamkniÄ™te zamÃ³wienia raportu',0),(189114,5254,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(189115,5254,'ur','Ø¨Ù†Ø¯ Ø¢Ø±ÚˆØ± Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(189116,5254,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(189117,5254,'vi','ÄÃ³ng BÃ¡o CÃ¡o ÄÆ¡n Äáº·t HÃ ng',0),(189118,5254,'af','Afgesluite Bestellings Verslag',0),(189119,5254,'ro','Raport Ã®nchisÄƒ ordine',0),(189120,5254,'et','Suletud aruande',0),(189121,5254,'si','PoroÄilo o zaprtih naroÄil',0),(189122,5254,'ba','Order ditutup laporan',0),(189123,5254,'nl','In het rapport gesloten bestelling',0),(189124,5254,'fi','Suljettu raportti',0),(189125,5254,'no','Lukket rapport',0),(189126,5254,'da','Rapport over lukkede',0),(189127,5254,'ko','ë‹«ížŒëœ ì£¼ë¬¸ ë³´ê³ ì„œ',0),(189128,5254,'he','×“×•×— ×”×¡×“×¨ ×¡×’×•×¨',0),(189129,5254,'el','ÎšÎ»ÎµÎ¹ÏƒÏ„Î® ÏƒÎµÎ¹ÏÎ¬ Î­ÎºÎ¸ÎµÏƒÎ·',0),(189130,5254,'zh','å…³é—­è®¢å•æŠ¥å‘Š\r\n',0),(189131,5254,'sv','Sluten ordning rapport',0),(189132,5254,'it','Report Ordine chiuso',0),(189133,5254,'tl','',0),(189134,5254,'th','&#3611;&#3636;&#3604;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(189135,5254,'hi','à¤¬à¤‚à¤¦ à¤‘à¤°à¥à¤¡à¤° à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(189136,5254,'ms','Laporan pesanan ditutup',0),(189137,5254,'ar','ØªÙ‚Ø±ÙŠØ± Ø£Ù…Ø± Ù…ØºÙ„Ù‚Ø©',0),(189138,5254,'fr','Ã‰tat de commande fermÃ©e',0),(189139,5254,'jp','çµ‚äº†æ¸ˆæ³¨æ–‡ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(189140,5254,'pt','RelatÃ³rio de ordem fechada',0),(189141,5254,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ðž Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð°Ñ…',0),(189142,5254,'es','Pedidos Cerrrados Informe de',0),(189143,5254,'de','Geschlossene Auftragsbericht',0),(189144,5254,'en','Closed Order Report',0),(189145,5255,'is','',0),(189146,5255,'dr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ ',0),(189147,5255,'pr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ ',0),(189148,5255,'tr','BitmiÅŸ tarih aralÄ±ÄŸÄ±',0),(189149,5255,'pl','Gotowych zakres dat.',0),(189150,5255,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐµÐ½ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(189151,5255,'ur','ØªÚ©Ù…ÛŒÙ„ Ø´Ø¯Û ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(189152,5255,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸Ñ… Ð¾Ð¿ÑÐµÐ³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(189153,5255,'vi','Pháº¡m vi ngÃ y cuá»‘i cÃ¹ng',0),(189154,5255,'af','Voltooide Datum Reeks',0),(189155,5255,'ro','Terminat intervalul de Date',0),(189156,5255,'et','LÃµpetanud kuupÃ¤evavahemik',0),(189157,5255,'si','KonÄni datumski obseg',0),(189158,5255,'ba','Rentang tanggal selesai',0),(189159,5255,'nl','Afgewerkte datumbereik',0),(189160,5255,'fi','Valmiin pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤alue',0),(189161,5255,'no','Ferdig datointervall',0),(189162,5255,'da','FÃ¦rdige datointerval',0),(189163,5255,'ko','ì™„ë£Œ ë‚ ì§œ ë²”ìœ„',0),(189164,5255,'he','×¡×™×•× ×˜×•×•×— ×ª××¨×™×›×™×',0),(189165,5255,'el','Î¤ÎµÎ»Î¹ÎºÏŒ ÎµÏÏÎ¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½',0),(189166,5255,'zh','å®Œæˆçš„æ—¥æœŸèŒƒå›´\r\n',0),(189167,5255,'sv','FÃ¤rdiga datumintervall',0),(189168,5255,'it','Intervallo di Date finito',0),(189169,5255,'tl','',0),(189170,5255,'th','&#3594;&#3656;&#3623;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(189171,5255,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€',0),(189172,5255,'ms','Julat tarikh siap',0),(189173,5255,'ar','Ù†Ø·Ø§Ù‚ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(189174,5255,'fr','Fini plage de dates',0),(189175,5255,'jp','å®Œäº†æ—¥ç¯„å›²',0),(189176,5255,'pt','Terminado de intervalo de datas',0),(189177,5255,'ru','Ð“Ð¾Ñ‚Ð¾Ð²Ñ‹Ðµ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚',0),(189178,5255,'es','Terminado Rango de Fechas',0),(189179,5255,'de','Fertige Datumsbereich',0),(189180,5255,'en','Finished Date Range',0),(189181,5256,'is','',0),(189182,5256,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(189183,5256,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(189184,5256,'tr','BitiÅŸ tarihi',0),(189185,5256,'pl','Data zakoÅ„czenia',0),(189186,5256,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ',0),(189187,5256,'ur','ØªØ§Ø±ÛŒØ® ØªÚ©Ù…ÛŒÙ„',0),(189188,5256,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(189189,5256,'vi','Káº¿t thÃºc ngÃ y',0),(189190,5256,'af','Voltooide Datum',0),(189191,5256,'ro','Data de Ã®ncheiere',0),(189192,5256,'et','LÃµppkuupÃ¤ev',0),(189193,5256,'si','KonÄni datum',0),(189194,5256,'ba','Tanggal selesai',0),(189195,5256,'nl','Einddatum',0),(189196,5256,'fi','PÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(189197,5256,'no','Sluttdatoen',0),(189198,5256,'da','Slutdato',0),(189199,5256,'ko','ì™„ë£Œ ë‚ ì§œ',0),(189200,5256,'he','×ª××¨×™×š ×¡×™×•×',0),(189201,5256,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(189202,5256,'zh','å®Œæˆæ—¥æœŸ\r\n',0),(189203,5256,'sv','Slutdatum',0),(189204,5256,'it','Data di fine',0),(189205,5256,'tl','',0),(189206,5256,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3636;&#3657;&#3609;',0),(189207,5256,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(189208,5256,'ms','Tarikh akhir',0),(189209,5256,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(189210,5256,'fr','Date de fin',0),(189211,5256,'jp','çµ‚äº†æ—¥',0),(189212,5256,'pt','Data de tÃ©rmino',0),(189213,5256,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(189214,5256,'es','Terminar Fecha',0),(189215,5256,'de','Endtermin',0),(189216,5256,'en','Finish Date',0),(189217,5257,'is','',0),(189218,5257,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø²ÙŠØ± ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø¨ÙˆØ¯Ù†Ø¯ Ø§Ø²',0),(189219,5257,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø²ÙŠØ± ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø¨ÙˆØ¯Ù†Ø¯ Ø§Ø²',0),(189220,5257,'tr','Gelen aÅŸaÄŸÄ±daki sipariÅŸleri tamamlanmÄ±ÅŸtÄ±r',0),(189221,5257,'pl','NastÄ™pujÄ…ce zamÃ³wienia zostaÅ‚y zakoÅ„czone z',0),(189222,5257,'bg','Ð¡Ð»ÐµÐ´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ð¾Ñ‚',0),(189223,5257,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø³Û’ Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§ Ú¯ÛŒØ§',0),(189224,5257,'sr','ÐžÐ²Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ ÑÑƒ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸ Ð¸Ð·',0),(189225,5257,'vi','Nhá»¯ng Ä‘Æ¡n hÃ ng sau Ä‘Ã£ hoÃ n thÃ nh tá»«',0),(189226,5257,'af','Die volgende bestellings is voltooi vanaf',0),(189227,5257,'ro','Comenzile urmÄƒtoare au fost finalizate la',0),(189228,5257,'et','JÃ¤rgmised korraldused on lÃµpule viidud:',0),(189229,5257,'si','Naslednje naloge zakljuÄene iz',0),(189230,5257,'ba','Perintah berikut diselesaikan dari',0),(189231,5257,'nl','De volgende opdrachten werden afgerond van',0),(189232,5257,'fi','Seuraavat tilaukset saatiin pÃ¤Ã¤tÃ¶kseen',0),(189233,5257,'no','FÃ¸lgende bestillinger fullfÃ¸rt fra',0),(189234,5257,'da','De fÃ¸lgende ordrer blev afsluttet fra',0),(189235,5257,'ko','ë‹¤ìŒ ëª…ë ¹ì—ì„œ ì™„ë£Œ í–ˆë‹¤',0),(189236,5257,'he','×”×¦×•×•×™× ×”×‘××™× ×”×•×©×œ×ž×• ×ž',0),(189237,5257,'el','ÎŸÎ¹ Î±ÎºÏŒÎ»Î¿Ï…Î¸ÎµÏ‚ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ¸Î·ÎºÎ±Î½ Î±Ï€ÏŒ',0),(189238,5257,'zh','ä¸‹é¢çš„è®¢å•å®Œæˆäº†ä»Ž\r\n',0),(189239,5257,'sv','Om fÃ¶ljande slutfÃ¶rdes frÃ¥n',0),(189240,5257,'it','I seguenti ordini sono stati completati da',0),(189241,5257,'tl','',0),(189242,5257,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3656;&#3629;&#3652;&#3611;&#3609;&#3637;&#3657;&#3648;&#3626;&#3619;&#3655;&#3592;&#3592;&#3634;&#3585;',0),(189243,5257,'hi','à¤¨à¤¿à¤®à¥à¤¨ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤¸à¥‡ à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤°à¤¹à¥‡ à¤¥à¥‡',0),(189244,5257,'ms','Perintah-perintah berikut telah siap dibina dari',0),(189245,5257,'ar','ÙˆØ§Ø³ØªÙƒÙ…Ù„Øª Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø± Ù…Ù†',0),(189246,5257,'fr','Les commandes suivantes ont Ã©tÃ© effectuÃ©es de',0),(189247,5257,'jp','æ¬¡ã?®æ³¨æ–‡ã?¯ã?“ã?“ã?‹ã‚‰å®Œäº†',0),(189248,5257,'pt','ConcluÃ­ram-se as seguintes ordens de',0),(189249,5257,'ru','Ð‘Ñ‹Ð»Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð¾Ñ‚',0),(189250,5257,'es','Los siguentes ordenes se completaron de',0),(189251,5257,'de','Folgende AuftrÃ¤ge wurden von abgeschlossen.',0),(189252,5257,'en','The following orders were completed from',0),(189253,5258,'is','',0),(189254,5258,'dr','Ø´Ø±Ø­ Ø³ÙØ§Ø±Ø´ ',0),(189255,5258,'pr','Ø´Ø±Ø­ Ø³ÙØ§Ø±Ø´ ',0),(189256,5258,'tr','SipariÅŸ aÃ§Ä±klamasÄ±',0),(189257,5258,'pl','Opis zamÃ³wienia',0),(189258,5258,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(189259,5258,'ur','Ø­Ú©Ù… Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(189260,5258,'sr','ÐžÐ¿Ð¸Ñ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(189261,5258,'vi','MÃ´ táº£ Ä‘Æ¡n hÃ ng',0),(189262,5258,'af','Bestelling Beskrywing',0),(189263,5258,'ro','Ordine Descriere',0),(189264,5258,'et','Tellimuse kirjeldus',0),(189265,5258,'si','Opis naroÄilnice',0),(189266,5258,'ba','Deskripsi urutan',0),(189267,5258,'nl','Beschrijving van bestelling',0),(189268,5258,'fi','Huoltotilauksen kuvaus',0),(189269,5258,'no','Bestill beskrivelse',0),(189270,5258,'da','Bestil beskrivelse',0),(189271,5258,'ko','ì£¼ë¬¸ ì„¤ëª…',0),(189272,5258,'he','×ª××•×¨ ×”×–×ž× ×”',0),(189273,5258,'el','Î£ÎµÎ¹ÏÎ¬ Î ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(189274,5258,'zh','è®¢è´­è¯´æ˜Ž\r\n',0),(189275,5258,'sv','Ordning Beskrivning',0),(189276,5258,'it','Descrizione di ordine',0),(189277,5258,'tl','',0),(189278,5258,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(189279,5258,'hi','à¤‘à¤°à¥à¤¡à¤° à¤µà¤¿à¤µà¤°à¤£',0),(189280,5258,'ms','Penerangan perintah',0),(189281,5258,'ar','ÙˆØµÙ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(189282,5258,'fr','Description de l\'ordre',0),(189283,5258,'jp','æ³¨æ–‡è§£èª¬',0),(189284,5258,'pt','Ordem descriÃ§Ã£o',0),(189285,5258,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ð°',0),(189286,5258,'es','DescripciÃ³n de Pedido',0),(189287,5258,'de','Bestellbeschreibung',0),(189288,5258,'en','Order Description',0),(189289,5259,'is','',0),(189290,5259,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(189291,5259,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(189292,5259,'tr','DoÄŸrulanmamÄ±ÅŸ basÄ±mevi sipariÅŸler',0),(189293,5259,'pl','Drukarnia niepotwierdzone zamÃ³wienia',0),(189294,5259,'bg','ÐÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð° Printshop Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(189295,5259,'ur','ØºÛŒØ± Ù…ØµØ¯Ù‚Û Ù¾Ø±Ø§Ù†Ù¹Ø´ÙˆÙ¾ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(189296,5259,'sr','ÐÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð¸Ð¼ ÐŸÑ€Ð¸Ð½Ñ‚ÑÑ…Ð¾Ð¿ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(189297,5259,'vi','ÄÆ¡n HÃ ng Printshop chÆ°a xÃ¡c nháº­n',0),(189298,5259,'af','Onbevestigde \"Printshop\" Bestellings',0),(189299,5259,'ro','Comenzi neconfirmate Printshop',0),(189300,5259,'et','Kinnitamata trÃ¼kikojale tellimused',0),(189301,5259,'si','Nepotrjenih tiskarni naroÄila',0),(189302,5259,'ba','Perintah Printshop belum dikonfirmasi',0),(189303,5259,'nl','Onbevestigde Printshop Orders',0),(189304,5259,'fi','Vahvistamattomien painotalon tilaukset',0),(189305,5259,'no','Ubekreftede trykkeriets ordrer',0),(189306,5259,'da','UbekrÃ¦ftede Printshop ordrer',0),(189307,5259,'ko','ë¯¸í™•ì¸ëœ Printshop ì£¼ë¬¸',0),(189308,5259,'he','×”×™×™×¢×•×¥ ×©×œ× ××•×©×¨×• ×”×–×ž× ×•×ª',0),(189309,5259,'el','Î‘Î½ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰Ï„ÎµÏ‚ Ï„Ï…Ï€Î¿Î³ÏÎ±Ï†ÎµÎ¯Î¿Ï… Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(189310,5259,'zh','æœªç¡®è®¤çš„å°åˆ·æ‰€è®¢å•\r\n',0),(189311,5259,'sv','ObekrÃ¤ftade tryckeriavdelningen order',0),(189312,5259,'it','Ordini non confermati Printshop',0),(189313,5259,'tl','',0),(189314,5259,'th','&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3619;&#3657;&#3634;&#3',0),(189315,5259,'hi','à¤…à¤ªà¥à¤·à¥à¤Ÿ Printshop à¤†à¤¦à¥‡à¤¶',0),(189316,5259,'ms','Perintah-perintah Printshop belum disahkan',0),(189317,5259,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø·Ø¨Ø¹Ø© ØºÙŠØ± Ù…Ø¤ÙƒØ¯Ø©',0),(189318,5259,'fr','Commandes non confirmÃ©es Printshop',0),(189319,5259,'jp','æœªç¢ºèª?å?°åˆ·æ‰€æ³¨æ–‡',0),(189320,5259,'pt','Ordens de tipografia nÃ£o confirmados',0),(189321,5259,'ru','Ð¢Ð¸Ð¿Ð¾Ð³Ñ€Ð°Ñ„Ð¸Ð¸ Ð½ÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(189322,5259,'es','Ordenes No Confirmados de Printshop',0),(189323,5259,'de','UnbestÃ¤tigte Printshop-Bestellungen',0),(189324,5259,'en','Unconfirmed Printshop Orders',0),(189325,5260,'is','',0),(189326,5260,'dr','.Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§ ØªØºÙŠÙŠØ± ÙƒÙ†Ø¯',0),(189327,5260,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø­Ø°Ù Ù…Ø­Ù„ Ù¾ÙŠØ´ ÙØ±Ø¶ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù†ÙŠØ³Øª.Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§ ØªØºÙŠÙŠØ± ÙƒÙ†Ø¯',0),(189328,5260,'tr','VarsayÄ±lan stok konumunu silemezsiniz. VarsayÄ±lan Ã¶nce deÄŸiÅŸtirmeniz gerekir.',0),(189329,5260,'pl','Nie moÅ¼na usunÄ…Ä‡ domyÅ›lnÄ… lokalizacjÄ… zapasÃ³w. NaleÅ¼y zmieniÄ‡ domyÅ›lny po raz pierwszy.',0),(189330,5260,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ. Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¿ÑŠÑ€Ð²Ð¾.',0),(189331,5260,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø­Ø°Ù Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§ Û” Ø·Û’ Ø´Ø¯Û Ù¾ÛÙ„Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº Û”',0),(189332,5260,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ ÐŸÐžÐ”Ð ÐÐ—Ð£ÐœÐ•Ð’ÐÐÐ£ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°. ÐŸÑ€Ð²Ð¾ Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ñƒ.',0),(189333,5260,'vi','KhÃ´ng Thá»ƒ XÃ³a Äá»‹a Äiá»ƒm HÃ ng HÃ³a Máº·c Äá»‹nh. Pháº£i Thay Máº·c Äá»‹nh TrÆ°á»›c',0),(189334,5260,'af','Kan nie die VERSTEKTE Voorraadligging skrap.  U moet eers die verstekte verstelling verander.',0),(189335,5260,'ro','Imposibil de È™ters Ã®n locaÅ£ia implicitÄƒ de inventar. Trebuie sÄƒ schimbaÅ£i implicit prima.',0),(189336,5260,'et','Ei saa kustutada varude vaikeasukohta. Peate muutma vaikimisi kÃµigepealt.',0),(189337,5260,'si','Ne morete izbrisati privzeto lokacijo zaloge. Najprej morate spremeniti privzeto.',0),(189338,5260,'ba','Tidak dapat menghapus lokasi persediaan DEFAULT. Harus mengubah default pertama.',0),(189339,5260,'nl','De standaardlocatie van de inventaris verwijderen niet. Eerst moet de standaardinstelling wijzigen.',0),(189340,5260,'fi','OLETUS varaston sijaintia ei voi poistaa. On muuttaa ensin.',0),(189341,5260,'no','Kan ikke slette standard lagerlokasjonen. MÃ¥ endre standard fÃ¸rst.',0),(189342,5260,'da','Kan ikke slette standard lagerlokation. Skal Ã¦ndre standard fÃ¸rst.',0),(189343,5260,'ko','ê¸°ë³¸ ì¸ë²¤í† ë¦¬ ìœ„ì¹˜ë¥¼ ì‚­ì œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤. ë¨¼ì € ê¸°ë³¸ì„ ë³€ê²½ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(189344,5260,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×—×•×§ ××ª ×ž×™×§×•× ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×”×ž×œ××™. ×¢×œ×™×š ×œ×©× ×•×ª ××ª ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×§×•×“×.',0),(189345,5260,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î·Î½ Î Î¡ÎŸÎ•Î Î™Î›Î•Î“ÎœÎˆÎÎ— Î±Ï€Î¿Î¸Î®ÎºÎ·. Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î±Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î·Î½ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï€ÏÏŽÏ„Î±.',0),(189346,5260,'zh','ä¸èƒ½åˆ é™¤é»˜è®¤çš„åº“å­˜ä½ç½®ã€‚å¿…é¡»æ”¹å˜é»˜è®¤çš„ç¬¬ä¸€ä¸ªã€‚\r\n',0),(189347,5260,'sv','Kan inte ta bort lager standardplatsen. MÃ¥ste Ã¤ndra standard fÃ¶rst.',0),(189348,5260,'it','Non Ã¨ possibile eliminare l\'ubicazione di inventario predefinito. Deve innanzitutto modificare l\'impostazione predefinita.',0),(189349,5260,'tl','',0),(189350,5260,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3621;&#3610;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629; &#3605;&#3657;&#3629;&#3591;&#3648;&#',0),(189351,5260,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‹ à¤¹à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤¸à¤•à¤¤à¥‡à¥¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¤¬à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¬à¤¦à¤²à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(189352,5260,'ms','Tidak dapat menghapuskan lokasi inventori lalai. Mesti mengubah lalai itu terlebih dahulu.',0),(189353,5260,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø­Ø°Ù Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠ , Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† ØªØºÙŠÙŠØ±Ù‡ Ø£ÙˆÙ„Ø§',0),(189354,5260,'fr','Impossible de supprimer l\'emplacement de l\'inventaire par dÃ©faut. Devez modifier la valeur par dÃ©faut d\'abord.',0),(189355,5260,'jp','æ—¢å®šã?®åœ¨åº«å ´æ‰€ã‚’æ¶ˆåŽ»ã?§ã??ã?¾ã?›ã‚“ã€‚ã?¾ã?šæ—¢å®šã‚’å¤‰æ›´ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(189356,5260,'pt','NÃ£o Ã© possÃ­vel excluir o local de estoque padrÃ£o. Deve mudar o padrÃ£o primeiro.',0),(189357,5260,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ. Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ.',0),(189358,5260,'es','No se puede eliminar la ubicaciÃ³n de inventaro por defecto. Debe cambiar la ubicaciÃ³n por defecto',0),(189359,5260,'de','Den Standardspeicherort fÃ¼r die Inventur kann nicht gelÃ¶scht werden. MÃ¼ssen zunÃ¤chst die Standardeinstellung Ã¤ndern.',0),(189360,5260,'en','Cannot delete the DEFAULT inventory location. Must change the default first.',0),(189361,5261,'is','',0),(189362,5261,'dr',':15 Ø±ÙˆØ² ',0),(189363,5261,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ :15 Ø±ÙˆØ² ',0),(189364,5261,'tr','Performans istatistikleri: 15 gÃ¼n',0),(189365,5261,'pl','Statystyki skutecznoÅ›ci: 15 dni',0),(189366,5261,'bg','Ð”Ð°Ð½Ð½Ð¸: 15 Ð´Ð½Ð¸',0),(189367,5261,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±: 15 Ø¯Ù†',0),(189368,5261,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð°: 15 Ð´Ð°Ð½Ð°',0),(189369,5261,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c: 15 ngÃ y',0),(189370,5261,'af','Prestasie Statistieke:  15 Dae',0),(189371,5261,'ro','Statistici de performanÅ£Äƒ: 15 zile',0),(189372,5261,'et','Tulemuslikkuse statistika: 15 pÃ¤eva',0),(189373,5261,'si','Statistiko uspeÅ¡nosti: 15 dni',0),(189374,5261,'ba','Statistik kinerja: 15 hari',0),(189375,5261,'nl','Prestatiestatistieken: 15 dagen',0),(189376,5261,'fi','Tehokkuustilastot: 15 pÃ¤ivÃ¤Ã¤',0),(189377,5261,'no','Resultatstatistikk: 15 dager',0),(189378,5261,'da','Effektivitetsstatistikker: 15 dage',0),(189379,5261,'ko','ì‹¤ì  í†µê³„: 15 ì¼',0),(189380,5261,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×: 15 ×™×ž×™×',0),(189381,5261,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½: 15 Î·Î¼Î­ÏÎµÏ‚',0),(189382,5261,'zh','ç»©æ•ˆç»Ÿè®¡ï¼š15å¤©\r\n',0),(189383,5261,'sv','Resultatstatistik: 15 dagar',0),(189384,5261,'it','Le statistiche sulle prestazioni: 15 giorni',0),(189385,5261,'tl','',0),(189386,5261,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636; :15 &#3623;&#3633;&#3609;',0),(189387,5261,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡: 15 à¤¦à¤¿à¤¨à¥‹à¤‚',0),(189388,5261,'ms','Statistik prestasi: 15 hari',0),(189389,5261,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡: 15 ÙŠÙˆÙ…Ø§',0),(189390,5261,'fr','Statistiques de performance : 15 jours',0),(189391,5261,'jp','æ¥­ç¸¾çµ±è¨ˆï¼šï¼‘ï¼•æ—¥é–“',0),(189392,5261,'pt','EstatÃ­sticas de desempenho: 15 dias',0),(189393,5261,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸: 15 Ð”Ð½ÐµÐ¹',0),(189394,5261,'es','EstadÃ­sticas de DesempeÃ±o: 15 DÃ­as',0),(189395,5261,'de','Performance-Statistiken: 15 Tage',0),(189396,5261,'en','Performance Statistics: 15 Days',0),(189397,5262,'is','',0),(189398,5262,'dr',':30   Ø±ÙˆØ²',0),(189399,5262,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯:30   Ø±ÙˆØ²',0),(189400,5262,'tr','Performans istatistikleri: 30 gÃ¼n',0),(189401,5262,'pl','Statystyki skutecznoÅ›ci: 30 dni',0),(189402,5262,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ: 30 Ð´Ð½Ð¸',0),(189403,5262,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±: 30 Ø¯Ù†',0),(189404,5262,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð°: 30 Ð´Ð°Ð½Ð°',0),(189405,5262,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c: 30 ngÃ y',0),(189406,5262,'af','Prestasie Statistieke:  30 Dae',0),(189407,5262,'ro','Statistici de performanÅ£Äƒ: 30 zile',0),(189408,5262,'et','Tulemuslikkuse statistika: 30 pÃ¤eva',0),(189409,5262,'si','Statistiko uspeÅ¡nosti: 30 dni',0),(189410,5262,'ba','Statistik kinerja: 30 hari',0),(189411,5262,'nl','Prestatiestatistieken: 30 dagen',0),(189412,5262,'fi','Tehokkuustilastot: 30 pÃ¤ivÃ¤Ã¤',0),(189413,5262,'no','Resultatstatistikk: 30 dager',0),(189414,5262,'da','Effektivitetsstatistikker: 30 dage',0),(189415,5262,'ko','ì‹¤ì  í†µê³„: 30 ì¼',0),(189416,5262,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×: 30 ×™×ž×™×',0),(189417,5262,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½: 30 Î·Î¼Î­ÏÎµÏ‚',0),(189418,5262,'zh','ç»©æ•ˆç»Ÿè®¡ï¼š30å¤©\r\n',0),(189419,5262,'sv','Resultatstatistik: 30 dagar',0),(189420,5262,'it','Le statistiche sulle prestazioni: 30 giorni',0),(189421,5262,'tl','',0),(189422,5262,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636; :30 &#3623;&#3633;&#3609;',0),(189423,5262,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡: 30 à¤¦à¤¿à¤¨à¥‹à¤‚',0),(189424,5262,'ms','Statistik prestasi: 30 hari',0),(189425,5262,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡: 30 ÙŠÙˆÙ…Ø§',0),(189426,5262,'fr','Statistiques de performance : 30 jours',0),(189427,5262,'jp','æ¥­ç¸¾çµ±è¨ˆï¼šï¼“ï¼?æ—¥é–“',0),(189428,5262,'pt','EstatÃ­sticas de desempenho: 30 dias',0),(189429,5262,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸: 30 Ð”Ð½ÐµÐ¹',0),(189430,5262,'es','EstadÃ­sticas de DesempeÃ±o: 30 DÃ­as',0),(189431,5262,'de','Performance-Statistiken: 30 Tage',0),(189432,5262,'en','Performance Statistics: 30 Days',0),(189433,5263,'is','',0),(189434,5263,'dr',': 60 Ø±ÙˆØ² ',0),(189435,5263,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ : 60 Ø±ÙˆØ² ',0),(189436,5263,'tr','Performans istatistikleri: 60 gÃ¼n',0),(189437,5263,'pl','Statystyki skutecznoÅ›ci: 60 dni',0),(189438,5263,'bg','Ð”Ð°Ð½Ð½Ð¸: 60 Ð´Ð½Ð¸',0),(189439,5263,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±: 60 Ø¯Ù†',0),(189440,5263,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð°: 60 Ð´Ð°Ð½Ð°',0),(189441,5263,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c: 60 ngÃ y',0),(189442,5263,'af','Prestasie Statistieke:  60 Dae',0),(189443,5263,'ro','Statistici de performanÅ£Äƒ: 60 zile',0),(189444,5263,'et','Tulemuslikkuse statistika: 60 pÃ¤eva',0),(189445,5263,'si','Statistiko uspeÅ¡nosti: 60 dni',0),(189446,5263,'ba','Statistik kinerja: 60 hari',0),(189447,5263,'nl','Prestatiestatistieken: 60 dagen',0),(189448,5263,'fi','Tehokkuustilastot: 60 pÃ¤ivÃ¤Ã¤',0),(189449,5263,'no','Resultatstatistikk: 60 dager',0),(189450,5263,'da','Effektivitetsstatistikker: 60 dage',0),(189451,5263,'ko','ì‹¤ì  í†µê³„: 60 ì¼',0),(189452,5263,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×: 60 ×™×ž×™×',0),(189453,5263,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½: 60 Î·Î¼Î­ÏÎµÏ‚',0),(189454,5263,'zh','ç»©æ•ˆç»Ÿè®¡ï¼š60å¤©\r\n',0),(189455,5263,'sv','Resultatstatistik: 60 dagar',0),(189456,5263,'it','Le statistiche sulle prestazioni: 60 giorni',0),(189457,5263,'tl','',0),(189458,5263,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636; :60 &#3623;&#3633;&#3609;',0),(189459,5263,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡: 60 à¤¦à¤¿à¤¨',0),(189460,5263,'ms','Statistik prestasi: 60 hari',0),(189461,5263,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡: 60 ÙŠÙˆÙ…Ø§',0),(189462,5263,'fr','Statistiques de performance : 60 jours',0),(189463,5263,'jp','æ¥­ç¸¾çµ±è¨ˆï¼šï¼–ï¼?æ—¥é–“',0),(189464,5263,'pt','EstatÃ­sticas de desempenho: 60 dias',0),(189465,5263,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸: 60 Ð”Ð½ÐµÐ¹',0),(189466,5263,'es','EstadÃ­sticas de DesempeÃ±o: 60 DÃ­as',0),(189467,5263,'de','Performance-Statistiken: 60 Tage',0),(189468,5263,'en','Performance Statistics: 60 Days',0),(189469,5264,'is','',0),(189470,5264,'dr',': 90 Ø±ÙˆØ²',0),(189471,5264,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„ÙƒØ±Ø¯ : 90 Ø±ÙˆØ²',0),(189472,5264,'tr','Performans istatistikleri: 90 gÃ¼n',0),(189473,5264,'pl','Statystyki skutecznoÅ›ci: 90 dni',0),(189474,5264,'bg','Ð”Ð°Ð½Ð½Ð¸: 90 Ð´Ð½Ð¸',0),(189475,5264,'ur','Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±: 90 Ø¯Ù†',0),(189476,5264,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð°: 90 Ð´Ð°Ð½Ð°',0),(189477,5264,'vi','Thá»‘ng kÃª thá»±c thi cÃ´ng viá»‡c: 90 ngÃ y',0),(189478,5264,'af','Prestasie Statistieke:  90 Dae',0),(189479,5264,'ro','Statistici de performanÅ£Äƒ: 90 de zile',0),(189480,5264,'et','Tulemuslikkuse statistika: 90 pÃ¤eva',0),(189481,5264,'si','Statistiko uspeÅ¡nosti: 90 dni',0),(189482,5264,'ba','Statistik kinerja: 90 hari',0),(189483,5264,'nl','Prestatiestatistieken: 90 dagen',0),(189484,5264,'fi','Tehokkuustilastot: 90 pÃ¤ivÃ¤Ã¤',0),(189485,5264,'no','Resultatstatistikk: 90 dager',0),(189486,5264,'da','Effektivitetsstatistikker: 90 dage',0),(189487,5264,'ko','ì‹¤ì  í†µê³„: 90 ì¼',0),(189488,5264,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™×: 90 ×™×•×',0),(189489,5264,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½: 90 Î·Î¼Î­ÏÎµÏ‚',0),(189490,5264,'zh','ç»©æ•ˆç»Ÿè®¡ï¼š90å¤©\r\n',0),(189491,5264,'sv','Resultatstatistik: 90 dagar',0),(189492,5264,'it','Le statistiche sulle prestazioni: 90 giorni',0),(189493,5264,'tl','',0),(189494,5264,'th','&#3626;&#3606;&#3636;&#3605;&#3636;&#3651;&#3609;&#3607;&#3634;&#3591;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636; :90 &#3623;&#3633;&#3609;',0),(189495,5264,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡: 90 à¤¦à¤¿à¤¨à¥‹à¤‚',0),(189496,5264,'ms','Statistik prestasi: 90 hari',0),(189497,5264,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡: 90 ÙŠÙˆÙ…Ø§',0),(189498,5264,'fr','Statistiques de performances : 90 jours',0),(189499,5264,'jp','æ¥­ç¸¾çµ±è¨ˆï¼šï¼™ï¼?æ—¥é–“',0),(189500,5264,'pt','EstatÃ­sticas de desempenho: 90 dias',0),(189501,5264,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸: 90 Ð”Ð½ÐµÐ¹',0),(189502,5264,'es','EstadÃ­sticas de DesempeÃ±o: 90 DÃ­as',0),(189503,5264,'de','Performance-Statistiken: 90 Tage',0),(189504,5264,'en','Performance Statistics: 90 Days',0),(189505,5265,'is','',0),(189506,5265,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(189507,5265,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(189508,5265,'tr','DoÄŸrudan yatÄ±rma yetkilendirme',0),(189509,5265,'pl','Autoryzacji przelewu',0),(189510,5265,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ',0),(189511,5265,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ Ú©Ø§ Ø§Ø¬Ø§Ø²Øª Ù†Ø§Ù…Û',0),(189512,5265,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð°ÑƒÑ‚Ð¾Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ðµ',0),(189513,5265,'vi','Quyá»n giao dá»‹ch trá»±c tiáº¿p',0),(189514,5265,'af','Direkte Deposito Magtiging.',0),(189515,5265,'ro','Autorizare direct de depozit',0),(189516,5265,'et','Panga Ã¼lekanne loa',0),(189517,5265,'si','Neposredni polog dovoljenje',0),(189518,5265,'ba','Deposit langsung otorisasi',0),(189519,5265,'nl','Directe storting vergunning',0),(189520,5265,'fi','Suora talletus luvan',0),(189521,5265,'no','Direkte innskudd autorisasjon',0),(189522,5265,'da','Direkte depositum tilladelse',0),(189523,5265,'ko','ì§ì ‘ ìž…ê¸ˆ ìŠ¹ì¸',0),(189524,5265,'he','××™×©×•×¨ ×”×¤×§×“×” ×™×©×™×¨×”',0),(189525,5265,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î¬Î´ÎµÎ¹Î±',0),(189526,5265,'zh','ç›´æŽ¥å­˜æ¬¾æŽˆæƒ\r\n',0),(189527,5265,'sv','Direkt insÃ¤ttning tillstÃ¥nd',0),(189528,5265,'it','Autorizzazione deposito diretto',0),(189529,5265,'tl','',0),(189530,5265,'th','&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(189531,5265,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤ªà¥à¤°à¤¾à¤§à¤¿à¤•à¤°à¤£',0),(189532,5265,'ms','Deposit langsung kebenaran',0),(189533,5265,'ar','Ø¥Ø°Ù† Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(189534,5265,'fr','Autorisation de dÃ©pÃ´t direct',0),(189535,5265,'jp','å?£åº§æŒ¯è¾¼æ‰¿èª?',0),(189536,5265,'pt','AutorizaÃ§Ã£o de depÃ³sito direto',0),(189537,5265,'ru','ÐÐ²Ñ‚Ð¾Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÐŸÑ€ÑÐ¼Ð¾Ð³Ð¾ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(189538,5265,'es','DepÃ³sito Directo AutorizaciÃ³n',0),(189539,5265,'de','Direkte Ablagerung Autorisierung',0),(189540,5265,'en','Direct Deposit Authorization',0),(189541,5266,'is','',0),(189542,5266,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(189543,5266,'pr','ÙØ±Ù… Ø§Ø¬Ø§Ø²Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(189544,5266,'tr','DoÄŸrudan yatÄ±rma yetkilendirme formu',0),(189545,5266,'pl','Formularz autoryzacji przelewu',0),(189546,5266,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€ Ð·Ð° Ð¾Ñ‚Ð¾Ñ€Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(189547,5266,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛÙ†Ø¯Ú¯ÛŒ ÙØ§Ø±Ù…',0),(189548,5266,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð°ÑƒÑ‚Ð¾Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾Ð±Ñ€Ð°ÑÑ†Ð°',0),(189549,5266,'vi','Máº«u cáº¥p quyá»n giao dá»‹ch trá»±c tiáº¿p',0),(189550,5266,'af','Direkte Deposito Magtingsvorm',0),(189551,5266,'ro','Formular de autorizaÅ£ie direct de depozit',0),(189552,5266,'et','Panga Ã¼lekanne loa vorm',0),(189553,5266,'si','Obrazec za dovoljenje neposrednega pologa',0),(189554,5266,'ba','Formulir otorisasi Deposit langsung',0),(189555,5266,'nl','Directe storting Authorization formulier',0),(189556,5266,'fi','Suora talletus valtuutuslomake',0),(189557,5266,'no','Direkte innskudd fullmaktsskjema',0),(189558,5266,'da','Direkte depositum godkendelsesformular',0),(189559,5266,'ko','ì§ì ‘ ìž…ê¸ˆ ìŠ¹ì¸ ì–‘ì‹',0),(189560,5266,'he','×˜×•×¤×¡ ××™×©×•×¨ ×”×¤×§×“×” ×™×©×™×¨×”',0),(189561,5266,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î­Î½Ï„Ï…Ï€Î¿ ÎµÎ¾Î¿Ï…ÏƒÎ¹Î¿Î´ÏŒÏ„Î·ÏƒÎ·Ï‚',0),(189562,5266,'zh','ç›´æŽ¥å­˜æ¬¾æŽˆæƒä¹¦\r\n',0),(189563,5266,'sv','Direkt insÃ¤ttning blankett',0),(189564,5266,'it','Modulo di autorizzazione di deposito diretto',0),(189565,5266,'tl','',0),(189566,5266,'th','&#3649;&#3610;&#3610;&#3615;&#3629;&#3619;&#3660;&#3617;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(189567,5266,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤ªà¥à¤°à¤¾à¤§à¤¿à¤•à¤°à¤£ à¤«à¤¾à¤°à¥à¤®',0),(189568,5266,'ms','Borang kebenaran Deposit terus',0),(189569,5266,'ar','Ù†Ù…ÙˆØ°Ø¬ ØªØ®ÙˆÙŠÙ„ Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(189570,5266,'fr','Formulaire d\'autorisation de dÃ©pÃ´t direct',0),(189571,5266,'jp','å?£åº§æŒ¯è¾¼æ‰¿èª?ãƒ•ã‚©ãƒ¼ãƒ ',0),(189572,5266,'pt','FormulÃ¡rio de autorizaÃ§Ã£o de depÃ³sito direto',0),(189573,5266,'ru','Ð¤Ð¾Ñ€Ð¼Ð° Ð°Ð²Ñ‚Ð¾Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(189574,5266,'es','Formulario para la AutorizaciÃ³n de DepÃ³sito Directo',0),(189575,5266,'de','Direkte Ablagerung EinzugsermÃ¤chtigungsformular',0),(189576,5266,'en','Direct Deposit Authorization Form',0),(189577,5267,'is','',0),(189578,5267,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(189579,5267,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(189580,5267,'tr','DoÄŸrudan yatÄ±rma auth',0),(189581,5267,'pl','BezpoÅ›redni depozyt Auth.',0),(189582,5267,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¾Ñ€Ð³Ð°Ð½Ð¸.',0),(189583,5267,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Auth.',0),(189584,5267,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐÑƒÑ‚Ñ….',0),(189585,5267,'vi','Quyá»n giao dá»‹ch trá»±c tiáº¿p',0),(189586,5267,'af','Direkte Deposito Magt.',0),(189587,5267,'ro','Direct de depozit Auth.',0),(189588,5267,'et','Panga Ã¼lekanne Auth.',0),(189589,5267,'si','Neposredni polog Auth.',0),(189590,5267,'ba','Deposit langsung otorisasi',0),(189591,5267,'nl','Directe storting Auth.',0),(189592,5267,'fi','Suora talletus Auth.',0),(189593,5267,'no','Direkte innskudd Auth.',0),(189594,5267,'da','Direkte depositum Auth.',0),(189595,5267,'ko','ì§ì ‘ ìž…ê¸ˆ Auth.',0),(189596,5267,'he','××™×ž×•×ª ×”×¤×§×“×” ×™×©×™×¨×”',0),(189597,5267,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î±.Ï€.Î¸.',0),(189598,5267,'zh','ç›´æŽ¥å­˜æ¬¾æƒå¨æ€§ã€‚\r\n',0),(189599,5267,'sv','Direkt insÃ¤ttning Auth.',0),(189600,5267,'it','Deposito diretto auth.',0),(189601,5267,'tl','',0),(189602,5267,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(189603,5267,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤ªà¥à¤°à¤¾à¤§à¤¿à¤•à¤°à¤£',0),(189604,5267,'ms','Deposit langsung kuasa',0),(189605,5267,'ar','Ø§Ù„Ù…ØµØ§Ø¯Ù‚Ø© Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(189606,5267,'fr','Autorisation de dÃ©pÃ´t direct :',0),(189607,5267,'jp','ç›´æŽ¥å…¥é‡‘æ‰¿èª?',0),(189608,5267,'pt','AutenticaÃ§Ã£o de depÃ³sito direto.',0),(189609,5267,'ru','ÐŸÑ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð°Ð²Ñ‚',0),(189610,5267,'es','AutorizaciÃ³n de DepÃ³sitos Directos',0),(189611,5267,'de','Direkte Ablagerung auth.',0),(189612,5267,'en','Direct Deposit Auth.',0),(189613,5268,'is','',0),(189614,5268,'dr','Ø«Ø¨Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(189615,5268,'pr','Ø«Ø¨Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(189616,5268,'tr','Gerekli giriÅŸ',0),(189617,5268,'pl','Wymagany wpis',0),(189618,5268,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(189619,5268,'ur','Ù…Ø·Ù„ÙˆØ¨Û Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(189620,5268,'sr','ÐžÐ±Ð°Ð²ÐµÐ·Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(189621,5268,'vi','Entry YÃªu Cáº§u',0),(189622,5268,'af','Benodigde Inskrywing',0),(189623,5268,'ro','Intrare necesar',0),(189624,5268,'et','NÃµutud kirjet',0),(189625,5268,'si','Zahteva vnos',0),(189626,5268,'ba','Catatan diperlukan',0),(189627,5268,'nl','Vereiste vermelding',0),(189628,5268,'fi','Pakollinen tieto',0),(189629,5268,'no','NÃ¸dvendige oppfÃ¸ring',0),(189630,5268,'da','PÃ¥krÃ¦vet indtastning',0),(189631,5268,'ko','í•„ìˆ˜ í•­ëª©',0),(189632,5268,'he','×›× ×™×¡×” ×—×•×‘×”',0),(189633,5268,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½Î· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯Î±',0),(189634,5268,'zh','æ‰€éœ€æ¡ç›®\r\n',0),(189635,5268,'sv','KrÃ¤vs intrÃ¤de',0),(189636,5268,'it','Voce richiesta',0),(189637,5268,'tl','',0),(189638,5268,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(189639,5268,'hi','à¤†à¤µà¤¶à¥à¤¯à¤• à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(189640,5268,'ms','Kemasukan diperlukan',0),(189641,5268,'ar','Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(189642,5268,'fr','EntrÃ©e requise',0),(189643,5268,'jp','å¿…è¦?ã?ªå…¥åŠ›',0),(189644,5268,'pt','Entrada obrigatÃ³ria',0),(189645,5268,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð²Ð²Ð¾Ð´ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(189646,5268,'es','Entrada Requerida',0),(189647,5268,'de','Oblig.',0),(189648,5268,'en','Required Entry',0),(189649,5269,'is','',0),(189650,5269,'dr','-  Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(189651,5269,'pr','Ø§ÙŠÙ† Ù…Ø§Ù„ÙŠØ§Øª Ù‚Ø¨Ù„Ø§ Ø«Ø¨Øª Ø´Ø¯Ù‡-  Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(189652,5269,'tr','Bu vergi girmiÅŸ - deÄŸil kaydetme',0),(189653,5269,'pl','Ten podatek wszedÅ‚ juÅ¼ - nie oszczÄ™dnoÅ›ci',0),(189654,5269,'bg','Ð¢Ð¾Ð·Ð¸ Ð´Ð°Ð½ÑŠÐº, Ð²ÑŠÐ²ÐµÐ´ÐµÐ½ Ð²ÐµÑ‡Ðµ - Ð½Ðµ Ð¿ÐµÑÑ‚ÐµÐ»Ð¸Ð²',0),(189655,5269,'ur','Ù…Ø­ÙÙˆØ¸ Ú©Ø± Ø±ÛØ§ ÛÛ’ Ù†Û ÛÛŒ - Ø¯Ø±Ø¬ ÛŒÛ Ù¹ÛŒÚ©Ø³',0),(189656,5269,'sr','ÐžÐ²Ð°Ñ˜ Ð¿Ð¾Ñ€ÐµÐ· ÑƒÐ½ÐµÐ»Ð¸ Ð²ÐµÑ› - ÑÐ¿Ð°ÑÐ¸Ñ‚Ð¸',0),(189657,5269,'vi','Thuáº¿ Ä‘Ã£ nháº­p - KhÃ´ng sao lÆ°u',0),(189658,5269,'af','Hierdie Belasting Alreeds Ingevoer - Nie Gestoor',0),(189659,5269,'ro','Acest impozit intrat deja - nu salvare',0),(189660,5269,'et','See maks kantud juba - ei Salvesta',0),(189661,5269,'si','Ta davek Å¾e - ni varÄevanje',0),(189662,5269,'ba','Pajak ini memasuki sudah - tidak menyimpan',0),(189663,5269,'nl','Deze belasting ingevoerd al - niet op te slaan',0),(189664,5269,'fi','TÃ¤mÃ¤ vero jo - ei tallenna',0),(189665,5269,'no','Denne skatten angitt allerede - ikke lagre',0),(189666,5269,'da','Denne skat angivet allerede - ikke besparelse',0),(189667,5269,'ko','ì´ ì„¸ ì´ë¯¸-ìž…ë ¥ ì €ìž¥',0),(189668,5269,'he','×ž×¡ ×–×” × ×›× ×¡ ×›×‘×¨ - ×œ× ×ž×¦×™×œ',0),(189669,5269,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±Ï…Ï„ÏŒÏ‚ Î¼Ï€Î®ÎºÎµ Î®Î´Î· - Î´ÎµÎ½ ÎµÎ¾Î¿Î¹ÎºÎ¿Î½ÏŒÎ¼Î·ÏƒÎ·',0),(189670,5269,'zh','è¿™ç§ç¨Žæ”¶å·²è¾“å…¥ -ä¸ä¿å­˜\r\n',0),(189671,5269,'sv','Denna skatt angett - inte spara',0),(189672,5269,'it','Questa tassa entrata giÃ  - non salvare',0),(189673,5269,'tl','',0),(189674,5269,'th','&#3611;&#3657;&#3629;&#3609;&#3616;&#3634;&#3625;&#3637;&#3609;&#3637;&#3657;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;-&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;',0),(189675,5269,'hi','à¤‡à¤¸ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ - à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(189676,5269,'ms','Ini masuk telah sedia - tidak penjimatan cukai',0),(189677,5269,'ar','Ù‡Ø°Ø§ Ø¶Ø±ÙŠØ¨Ø© Ø¯Ø®Ù„ Ø§Ù„ÙØ¹Ù„-Ù„Ø§ ØªÙ†Ù‚Ø°',0),(189678,5269,'fr','Cette taxe est entrÃ©e dÃ©jÃ  - ne pas sauver',0),(189679,5269,'jp','ã?“ã?®ç¨Žã?¯ã?™ã?§ã?«å…¥åŠ›ã?•ã‚Œã?¦ã?„ã?¾ã?™ãƒ¼ä¿?å­˜ã?—ã?¾ã?›ã‚“',0),(189680,5269,'pt','Este imposto introduzido jÃ¡ - nÃ£o salvar',0),(189681,5269,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð½Ð°Ð»Ð¾Ð³ Ð²Ð²ÐµÐ´ÐµÐ½ ÑƒÐ¶Ðµ - Ð½Ðµ ÑÐºÐ¾Ð½Ð¾Ð¼Ð¸Ñ‚ÑŒ',0),(189682,5269,'es','Ya se EntrÃ³ Este Impuesto - No se Guarda',0),(189683,5269,'de','Diese Steuerersparnis bereits - nicht',0),(189684,5269,'en','This Tax Entered Already - Not Saving',0),(189685,5270,'is','',0),(189686,5270,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(189687,5270,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(189688,5270,'tr','PO zaten var',0),(189689,5270,'pl','PO juÅ¼ istnieje',0),(189690,5270,'bg','PO Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(189691,5270,'ur','Ù¾Ùˆ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(189692,5270,'sr','ÐŸÐž Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(189693,5270,'vi','Äiá»ƒm bÃ¡n hÃ ng Ä‘Ã£ tá»“n táº¡i',0),(189694,5270,'af','AB Bestaan Alreeds',0),(189695,5270,'ro','PO existÄƒ deja',0),(189696,5270,'et','PO on juba olemas',0),(189697,5270,'si','PO Å¾e obstaja',0),(189698,5270,'ba','PO sudah ada',0),(189699,5270,'nl','PO bestaat al',0),(189700,5270,'fi','PO on jo olemassa',0),(189701,5270,'no','PO finnes allerede',0),(189702,5270,'da','PO findes allerede',0),(189703,5270,'ko','ì´ë¯¸ í¬',0),(189704,5270,'he','×¤×• ×›×‘×¨ ×§×™×™×',0),(189705,5270,'el','PO Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(189706,5270,'zh','è®¢å•å·²å­˜åœ¨\r\n',0),(189707,5270,'sv','PO finns redan',0),(189708,5270,'it','PO esiste giÃ ',0),(189709,5270,'tl','',0),(189710,5270,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(189711,5270,'hi','PO à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(189712,5270,'ms','PO telah wujud',0),(189713,5270,'ar','Øµ. Ø¨. Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„',0),(189714,5270,'fr','PO existe dÃ©jÃ ',0),(189715,5270,'jp','POã?¯æ—¢å­˜ã?—ã?¾ã?™',0),(189716,5270,'pt','PO jÃ¡ existe',0),(189717,5270,'ru','PO ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(189718,5270,'es','OC Ya Existe',0),(189719,5270,'de','PO ist bereits vorhanden.',0),(189720,5270,'en','PO Already Exists',0),(189721,5271,'is','',0),(189722,5271,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(189723,5271,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(189724,5271,'tr','Ä°Ã§e aktarma',0),(189725,5271,'pl','Importu',0),(189726,5271,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(189727,5271,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(189728,5271,'sr','Ð£Ð²Ð¾Ð·',0),(189729,5271,'vi','Nháº­p',0),(189730,5271,'af','Invoer',0),(189731,5271,'ro','Import',0),(189732,5271,'et','Impordi',0),(189733,5271,'si','Uvoz',0),(189734,5271,'ba','Impor',0),(189735,5271,'nl','Importeren',0),(189736,5271,'fi','Tuonti',0),(189737,5271,'no','Import',0),(189738,5271,'da','Import',0),(189739,5271,'ko','ê°€ì ¸ì˜¤ê¸°',0),(189740,5271,'he','×™×‘×',0),(189741,5271,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®',0),(189742,5271,'zh','å¯¼å…¥\r\n',0),(189743,5271,'sv','Import',0),(189744,5271,'it','Importazione',0),(189745,5271,'tl','',0),(189746,5271,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(189747,5271,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(189748,5271,'ms','Import',0),(189749,5271,'ar','Ø§Ù„Ø¥Ø³ØªÙŠØ±Ø§Ø¯',0),(189750,5271,'fr','Importation',0),(189751,5271,'jp','å?–ã‚Šè¾¼ã?¿',0),(189752,5271,'pt','ImportaÃ§Ã£o',0),(189753,5271,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(189754,5271,'es','Importar',0),(189755,5271,'de','Import',0),(189756,5271,'en','Import',0),(189757,5272,'is','',0),(189758,5272,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø´Ø±Ø­ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(189759,5272,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø´Ø±Ø­ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(189760,5272,'tr','VarsayÄ±lan doÄŸrudan yatÄ±rma iÅŸlem aÃ§Ä±klamasÄ±',0),(189761,5272,'pl','DomyÅ›lnie przelewem opis transakcji',0),(189762,5272,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÐ´ÐµÐ»ÐºÐ° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(189763,5272,'ur','Ø·Û’ Ø´Ø¯Û Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(189764,5272,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð¾Ð¿Ð¸Ñ',0),(189765,5272,'vi','MÃ´ táº£ máº·c Ä‘á»‹nh giao dá»‹ch trá»±c tiáº¿p',0),(189766,5272,'af','Verstekte Direkte Deposito Transaksie Beskrywing',0),(189767,5272,'ro','Implicit Direct de depozit tranzacÅ£ii Descriere',0),(189768,5272,'et','Panga Ã¼lekanne tehingu vaikekirjeldus',0),(189769,5272,'si','Opis transakcije neposredno depozit privzeto',0),(189770,5272,'ba','Default Deposit langsung transaksi Deskripsi',0),(189771,5272,'nl','Standaard directe storting transactie beschrijving',0),(189772,5272,'fi','Oletuksena suoraan tallettaa tapahtuman kuvaus',0),(189773,5272,'no','Standard direkte innskudd transaksjonsbeskrivelsen',0),(189774,5272,'da','Standard direkte indbetaling posteringsbeskrivelse',0),(189775,5272,'ko','ê¸°ë³¸ ì§ì ‘ ìž…ê¸ˆ ê±°ëž˜ ì„¤ëª…',0),(189776,5272,'he','×ª××•×¨ ×¢×¡×§×” ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×”×¤×§×“×” ×™×©×™×¨×”',0),(189777,5272,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(189778,5272,'zh','é»˜è®¤ç›´æŽ¥å­˜æ¬¾äº¤æ˜“æè¿°\r\n',0),(189779,5272,'sv','Direkt insÃ¤ttning transaktionen standardbeskrivning',0),(189780,5272,'it','Descrizione transazione predefinita deposito diretto',0),(189781,5272,'tl','',0),(189782,5272,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3',0),(189783,5272,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤µà¤¿à¤µà¤°à¤£',0),(189784,5272,'ms','Penerangan urus niaga Deposit terus lalai',0),(189785,5272,'ar','ÙˆØµÙ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(189786,5272,'fr','Description de Transaction pour le virement automatique par dÃ©faut',0),(189787,5272,'jp','æ—¢å®šå?£åº§æŒ¯è¾¼ã?¿å?–å¼•ã?®è§£èª¬',0),(189788,5272,'pt','DescriÃ§Ã£o da transaÃ§Ã£o padrÃ£o depÃ³sito direto',0),(189789,5272,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(189790,5272,'es','DescripciÃ³n de TransacciÃ³n de DepÃ³sito Directo por Defecto',0),(189791,5272,'de','Direkte Ablagerung Transaktion Standardbeschreibung',0),(189792,5272,'en','Default Direct Deposit Transaction Description',0),(189793,5273,'is','',0),(189794,5273,'dr','(*)( Ø¨Ø·ÙˆØ±ÙŠÙƒÙ‡) Ø¯Ø±Ù¾ÙŠÙˆØ³Øª  Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯  Ø¸Ø§Ù‡Ø± Ù…ÙŠ Ø´ÙˆØ¯',0),(189795,5273,'pr','Ù†Ø´Ø§Ù† Ø³ØªØ§Ø±Ù‡(*)( Ø¨Ø·ÙˆØ±ÙŠÙƒÙ‡) Ø¯Ø±Ù¾ÙŠÙˆØ³Øª  Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯  Ø¸Ø§Ù‡Ø± Ù…ÙŠ Ø´ÙˆØ¯',0),(189796,5273,'tr','ACH sÃ¶zleÅŸme Ã¼zerinde gÃ¶rÃ¼ndÃ¼ÄŸÃ¼ gibi',0),(189797,5273,'pl','Jak wydaje siÄ™ na ACH umowy',0),(189798,5273,'bg','ÐšÐ°ÐºÑ‚Ð¾ ÑÐµ Ð²Ð¸Ð¶Ð´Ð° Ð½Ð° ÐÐšÐš Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(189799,5273,'ur','Ø¬ÛŒØ³Û’ ÛŒÛ Ø§Ú† Ù…Ø¹Ø§ÛØ¯Û’ Ù¾Ø± Ø¸Ø§ÛØ± ÛÙˆØªØ§ ÛÛ’ Û”',0),(189800,5273,'sr','ÐšÐ°Ð¾ ÑˆÑ‚Ð¾ ÑÐµ Ð¿Ð¾Ñ˜Ð°Ð²Ñ™ÑƒÑ˜Ðµ Ð½Ð° ÐÑ… ÑƒÐ³Ð¾Ð²Ð¾Ñ€',0),(189801,5273,'vi','Thá»ƒ Hiá»‡n Giá»‘ng TrÃªn Há»£p Äá»“ng ACH ',0),(189802,5273,'af','Soos dit verskyn op \"ACH\" kontrak',0),(189803,5273,'ro','AÅŸa cum apare pe contract de ACH',0),(189804,5273,'et','ACH lepingu kohta',0),(189805,5273,'si','Kot je prikazano na ACH pogodbe',0),(189806,5273,'ba','Seperti yang muncul pada kontrak ACH',0),(189807,5273,'nl','Zoals deze wordt weergegeven op ACH contract',0),(189808,5273,'fi','Sellaisena kuin se nÃ¤kyy ACH sopimuksen',0),(189809,5273,'no','Som vises pÃ¥ ACH kontrakt',0),(189810,5273,'da','Som det fremgÃ¥r af ACH kontrakt',0),(189811,5273,'ko','ACH ê³„ì•½ì— ë‚˜íƒ€ë‚œ ëŒ€ë¡œ',0),(189812,5273,'he','×›×¤×™ ×©×”×•× ×ž×•×¤×™×¢ ×‘×—×•×–×” ACH',0),(189813,5273,'el','ÎŒÏ€Ï‰Ï‚ Ï†Î±Î¯Î½ÎµÏ„Î±Î¹ ÏƒÏ„Î¿ Î‘Î§ ÏƒÏ…Î¼Î²ÏŒÎ»Î±Î¹ÏŒ',0),(189814,5273,'zh','æ­£å¦‚åˆåŒä¸Šæ˜¾ç¤ºçš„è‡ªåŠ¨åŒ–äº¤æ˜“æ‰€\r\n',0),(189815,5273,'sv','Som det visas pÃ¥ ACH kontrakt',0),(189816,5273,'it','Come appare sul contratto ACH',0),(189817,5273,'tl','',0),(189818,5273,'th','&#3605;&#3634;&#3617;&#3607;&#3637;&#3656;&#3611;&#3619;&#3634;&#3585;&#3599;&#3651;&#3609;&#3626;&#3633;&#3597;&#3597;&#3634; ACH ',0),(189819,5273,'hi','à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤‡à¤¸à¥‡ ACH à¤…à¤¨à¥à¤¬à¤‚à¤§ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤ˆ à¤¦à¥‡à¤¤à¤¾ à¤¹à¥ˆ',0),(189820,5273,'ms','Kerana ia muncul di men kontrak',0),(189821,5273,'ar','ÙƒÙ…Ø§ ÙŠØ¸Ù‡Ø± ÙÙŠ Ø§Ù„Ø¹Ù‚Ø¯ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(189822,5273,'fr','Tel qu\'il figure sur le contrat de l\'ACH',0),(189823,5273,'jp','ï¼¡ï¼£ï¼¨å¥‘ç´„æ›¸ä¸Šã?«ã?‚ã‚‹ã?®ã?§',0),(189824,5273,'pt','Como consta no contrato ACH',0),(189825,5273,'ru','ÐšÐ°Ðº Ð¾Ð½ Ð¿Ð¾ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð½Ð° ÐºÐ¾Ð½Ñ‚Ñ€Ð°ÐºÑ‚ ACH',0),(189826,5273,'es','Como aparece en el contrato de ACH',0),(189827,5273,'de','ACH Vertrag angezeigt wird',0),(189828,5273,'en','As it appears on ACH contract',0),(189829,5274,'is','',0),(189830,5274,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø´Ø±ÙƒØª ',0),(189831,5274,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø´Ø±ÙƒØª ',0),(189832,5274,'tr','Åžirket kimliÄŸi',0),(189833,5274,'pl','Identyfikacja firmy',0),(189834,5274,'bg','Ð”Ð°Ð½ÑŠÑ‡ÐµÐ½ ÐºÐ¾Ð´',0),(189835,5274,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(189836,5274,'sr','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ñ„Ð¸Ñ€Ð¼Ðµ',0),(189837,5274,'vi','Nháº­n dáº¡ng cá»§a cty ',0),(189838,5274,'af','Onderneming Identifikasie',0),(189839,5274,'ro','Identificarea companiei',0),(189840,5274,'et','EttevÃµtte ID.',0),(189841,5274,'si','Identifikacija druÅ¾be',0),(189842,5274,'ba','Identifikasi perusahaan',0),(189843,5274,'nl','Identificatie van het bedrijf',0),(189844,5274,'fi','Yrityksen tunnus',0),(189845,5274,'no','Firmaidentifikasjonen',0),(189846,5274,'da','Firma-id',0),(189847,5274,'ko','íšŒì‚¬ ì‹ë³„',0),(189848,5274,'he','×–×™×”×•×™ ×”×—×‘×¨×”',0),(189849,5274,'el','â€¢ Î•Ï„Î±Î¹ÏÎ¹ÎºÎ® Ï„Î±Ï…Ï„ÏŒÏ„Î·Ï„Î±',0),(189850,5274,'zh','å…¬å¸è¯†åˆ«\r\n',0),(189851,5274,'sv','FÃ¶retagsidentifiering',0),(189852,5274,'it','Identificazione della societÃ ',0),(189853,5274,'tl','',0),(189854,5274,'th','&#3585;&#3634;&#3619;&#3649;&#3626;&#3604;&#3591;&#3605;&#3633;&#3623;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(189855,5274,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥€ à¤ªà¤¹à¤šà¤¾à¤¨',0),(189856,5274,'ms','Pengenalan Syarikat',0),(189857,5274,'ar','ØªØ¹Ø±ÙŠÙ Ø§Ù„Ø´Ø±ÙƒØ©',0),(189858,5274,'fr','Identification de l\'entreprise',0),(189859,5274,'jp','ä¼šç¤¾è¨¼æ˜Žæ›¸',0),(189860,5274,'pt','IdentificaÃ§Ã£o da empresa',0),(189861,5274,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(189862,5274,'es','Empresa IdentificaciÃ³n',0),(189863,5274,'de','Firmenbezeichnung',0),(189864,5274,'en','Company Identification',0),(189865,5275,'is','',0),(189866,5275,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(189867,5275,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(189868,5275,'tr','Direkt mevduat bilgileri',0),(189869,5275,'pl','BezpoÅ›redniego zÅ‚oÅ¼enia informacji',0),(189870,5275,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(189871,5275,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(189872,5275,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(189873,5275,'vi','ThÃ´ng tin thanh toÃ¡n trá»±c tiáº¿p',0),(189874,5275,'af','Direkte Deposito Inligting',0),(189875,5275,'ro','InformaÅ£ii direct de depozit',0),(189876,5275,'et','Otsene Hoiuste info',0),(189877,5275,'si','Neposreden vloga informacij',0),(189878,5275,'ba','Deposit langsung informasi',0),(189879,5275,'nl','Directe storting informatie',0),(189880,5275,'fi','Tilisiirron tiedot',0),(189881,5275,'no','Direkte innskudd informasjon',0),(189882,5275,'da','Direkte depositum oplysninger',0),(189883,5275,'ko','ì§ì ‘ ìž…ê¸ˆ ì •ë³´',0),(189884,5275,'he','×”×¤×§×“×” ×™×©×™×¨×” ×ž×™×“×¢',0),(189885,5275,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(189886,5275,'zh','ç›´æŽ¥å­˜æ¬¾ä¿¡æ¯\r\n',0),(189887,5275,'sv','Direkt insÃ¤ttning Information',0),(189888,5275,'it','Deposito diretto informazioni',0),(189889,5275,'tl','',0),(189890,5275,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(189891,5275,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(189892,5275,'ms','Maklumat Deposit terus',0),(189893,5275,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(189894,5275,'fr','Demande de dÃ©pÃ´t direct',0),(189895,5275,'jp','å?£åº§æŒ¯è¾¼æƒ…å ±',0),(189896,5275,'pt','InformaÃ§Ãµes de depÃ³sito direto',0),(189897,5275,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÐŸÑ€ÑÐ¼Ð¾Ð³Ð¾ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(189898,5275,'es','DepÃ³sito Directo InformaciÃ³n',0),(189899,5275,'de','Direkte Ablagerung Informationen',0),(189900,5275,'en','Direct Deposit Information',0),(189901,5276,'is','',0),(189902,5276,'dr','Ù†Ø§Ù… Ù…Ù‚ØµØ¯ Ø¨Ø¹Ø¯Ù‰',0),(189903,5276,'pr','Ù†Ø§Ù… Ù…Ù‚ØµØ¯ Ø¨Ø¹Ø¯Ù‰',0),(189904,5276,'tr','Hemen hedef adÄ±',0),(189905,5276,'pl','Nazwa bezpoÅ›redni cel podrÃ³Å¼y',0),(189906,5276,'bg','ÐÐµÐ¿Ð¾ÑÑ€ÐµÐ´ÑÑ‚Ð²ÐµÐ½Ð¾Ñ‚Ð¾ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¸Ð¼Ðµ',0),(189907,5276,'ur','ÙÙˆØ±ÛŒ Ø·ÙˆØ± Ù¾Ø± Ù…Ù†Ø²Ù„ Ú©Ø§ Ù†Ø§Ù…',0),(189908,5276,'sr','Ð˜Ð¼Ðµ Ð½ÐµÐ¿Ð¾ÑÑ€ÐµÐ´Ð½Ðµ Ð¾Ð´Ñ€ÐµÐ´Ð¸ÑˆÑ‚Ð°',0),(189909,5276,'vi','TÃªn Ä‘iá»ƒm Ä‘áº¿n ngay',0),(189910,5276,'af','\"Onmiddelike/Naaste\" Bestemmingsnaam',0),(189911,5276,'ro','Imediat destinaÅ£ie numele',0),(189912,5276,'et','Kohe sihtkoha nimi',0),(189913,5276,'si','Neposredni cilj ime',0),(189914,5276,'ba','Nama tujuan langsung',0),(189915,5276,'nl','Onmiddellijke doelnaam',0),(189916,5276,'fi','VÃ¤littÃ¶mÃ¤sti kohteen nimi',0),(189917,5276,'no','Umiddelbar mÃ¥lnavn',0),(189918,5276,'da','Umiddelbare bestemmelsessted navn',0),(189919,5276,'ko','ì¦‰ì‹œ ëŒ€ìƒ ì´ë¦„',0),(189920,5276,'he','×©× ×™×¢×“ ×ž×™×™×“×™×ª',0),(189921,5276,'el','ÎŒÎ½Î¿Î¼Î± Î¬Î¼ÎµÏƒÎ¿Ï‚ Ï€ÏÎ¿Î¿ÏÎ¹ÏƒÎ¼ÏŒÏ‚',0),(189922,5276,'zh','ç›´æŽ¥ç›®çš„åœ°åç§°\r\n',0),(189923,5276,'sv','Omedelbara destinationen namn',0),(189924,5276,'it','Nome di destinazione immediata',0),(189925,5276,'tl','',0),(189926,5276,'th','&#3651;&#3626;&#3656;&#3594;&#3639;&#3656;&#3629;&#3611;&#3621;&#3634;&#3618;&#3607;&#3634;&#3591;&#3607;&#3633;&#3609;&#3607;&#3637;',0),(189927,5276,'hi','à¤¤à¤¤à¥à¤•à¤¾à¤² à¤—à¤‚à¤¤à¤µà¥à¤¯ à¤¨à¤¾à¤®',0),(189928,5276,'ms','Nama destinasi serta-merta',0),(189929,5276,'ar','Ø§Ø³Ù… Ø§Ù„ÙˆØ¬Ù‡Ø© Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø©',0),(189930,5276,'fr','Nom de la Destination immÃ©diate',0),(189931,5276,'jp','æ¬¡ã?®çµŒç”±ç›®çš„åœ°å??',0),(189932,5276,'pt','Nome de destino imediato',0),(189933,5276,'ru','Ð˜Ð¼Ñ Ð½ÐµÐ¿Ð¾ÑÑ€ÐµÐ´ÑÑ‚Ð²ÐµÐ½Ð½Ð¾Ð³Ð¾ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(189934,5276,'es','Nombre de Destino Inmediato',0),(189935,5276,'de','Sofortige Zielname',0),(189936,5276,'en','Immediate Destination Name',0),(189937,5277,'is','',0),(189938,5277,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø±Ù‡Ú¯ÙŠØ±ÙŠ Ù…Ù‚ØµØ¯ Ø¨Ø¹Ø¯ÙŠ ',0),(189939,5277,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø±Ù‡Ú¯ÙŠØ±ÙŠ Ù…Ù‚ØµØ¯ Ø¨Ø¹Ø¯ÙŠ ',0),(189940,5277,'tr','Hemen hedef yÃ¶nlendirme numarasÄ±',0),(189941,5277,'pl','Numer rozliczeniowy bezpoÅ›redni cel podrÃ³Å¼y',0),(189942,5277,'bg','ÐÐµÐ¿Ð¾ÑÑ€ÐµÐ´ÑÑ‚Ð²ÐµÐ½Ð¾Ñ‚Ð¾ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð° Ñ‡Ð¸ÑÐ»Ð¾',0),(189943,5277,'ur','ÙÙˆØ±ÛŒ Ø·ÙˆØ± Ù¾Ø± Ù…Ù‚ØµÙˆØ¯ Ø±ÙˆÙ¹ Ù†Ù…Ø¨Ø±',0),(189944,5277,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¾Ð³ Ð¿Ð¾ÑÑ‚ÑƒÐ¿ÐºÐ° Ð½ÐµÐ¿Ð¾ÑÑ€ÐµÐ´Ð½Ðµ Ð¾Ð´Ñ€ÐµÐ´Ð¸ÑˆÑ‚Ðµ',0),(189945,5277,'vi','TÃªn sá»‘ lá»™ trÃ¬nh Ä‘iá»ƒm Ä‘áº¿n ngay',0),(189946,5277,'af','Onmiddellike Routing bestemmingsnommer',0),(189947,5277,'ro','NumÄƒrul de rutare imediat destinaÅ£ie',0),(189948,5277,'et','Vahetu sihtkohana marsruudi Number',0),(189949,5277,'si','TakojÅ¡njo ciljno usmerjanje Å¡tevilko',0),(189950,5277,'ba','Nomor Routing tujuan langsung',0),(189951,5277,'nl','Onmiddellijke bestemmingsnummer routering',0),(189952,5277,'fi','VÃ¤littÃ¶mÃ¤nÃ¤ mÃ¤Ã¤rÃ¤paikkana reititys numero',0),(189953,5277,'no','NÃ¦rmeste destinasjon-organisasjonsnummer',0),(189954,5277,'da','Umiddelbare bestemmelsessted Routing-nummer',0),(189955,5277,'ko','ì¦‰ì‹œ ëŒ€ìƒ ë¼ìš°íŒ… ë²ˆí˜¸',0),(189956,5277,'he','×ž×¡×¤×¨ × ×™×ª×•×‘ ×”×™×¢×“ ×”×ž×™×™×“×™',0),(189957,5277,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Î¬Î¼ÎµÏƒÎ¿Ï‚ Ï€ÏÎ¿Î¿ÏÎ¹ÏƒÎ¼ÏŒÏ‚',0),(189958,5277,'zh','ç›´æŽ¥ç›®çš„åœ°è·¯å¾„å·ç \r\n',0),(189959,5277,'sv','Omedelbara destinationen Routing Number',0),(189960,5277,'it','Numero di Routing di destinazione immediata',0),(189961,5277,'tl','',0),(189962,5277,'th','Immediate Destination Routing Number',0),(189963,5277,'hi','à¤¤à¤¤à¥à¤•à¤¾à¤² à¤—à¤‚à¤¤à¤µà¥à¤¯ à¤…à¤¨à¥à¤®à¤¾à¤°à¥à¤—à¤£ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(189964,5277,'ms','Nombor Laluan destinasi serta-merta',0),(189965,5277,'ar','Ø±Ù‚Ù… Ø§Ù„ØªÙˆØ¬ÙŠÙ‡ Ø§Ù„ÙˆØ¬Ù‡Ø© Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø©',0),(189966,5277,'fr','NumÃ©ro de routage de Destination immÃ©diate',0),(189967,5277,'jp','æ¬¡ã?®çµŒç”±ç›®çš„åœ°ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå?·',0),(189968,5277,'pt','NÃºmero de roteamento do destino imediato',0),(189969,5277,'ru','ÐÐµÐ¿Ð¾ÑÑ€ÐµÐ´ÑÑ‚Ð²ÐµÐ½Ð½Ð¾Ð³Ð¾ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð½Ð¾Ð¼ÐµÑ€',0),(189970,5277,'es','NÃºmero de Routing de Destino Inmediato',0),(189971,5277,'de','Sofortige Weiterleitung Zielrufnummer',0),(189972,5277,'en','Immediate Destination Routing Number',0),(189973,5278,'is','',0),(189974,5278,'dr','Ù†Ø§Ù… Ù…Ù†Ø¨Ø¹  ÙÙˆØ±ÙŠ ',0),(189975,5278,'pr','Ù†Ø§Ù… Ù…Ù†Ø¨Ø¹  ÙÙˆØ±ÙŠ ',0),(189976,5278,'tr','AdÄ± acil kÃ¶keni',0),(189977,5278,'pl','BezpoÅ›rednie pochodzenie nazwy',0),(189978,5278,'bg','ÐÐµÐ·Ð°Ð±Ð°Ð²Ð½Ð¾ Ð¿Ñ€Ð¾Ð¸Ð·Ñ…Ð¾Ð´ Ð¸Ð¼Ðµ',0),(189979,5278,'ur','ÙÙˆØ±ÛŒ Ø·ÙˆØ± Ù¾Ø± Ø§ØµÙ„ Ù†Ø§Ù…',0),(189980,5278,'sr','Ð˜Ð¼Ðµ Ð½ÐµÐ¿Ð¾ÑÑ€ÐµÐ´Ð½Ðµ Ð¿Ð¾Ñ€ÐµÐºÐ»Ð°',0),(189981,5278,'vi','TÃªn Ä‘iá»ƒm Ä‘i ngay',0),(189982,5278,'af','\"Onmiddelike/Naaste\" Afkomstige Naam',0),(189983,5278,'ro','Numele de origine imediatÄƒ',0),(189984,5278,'et','Kohene pÃ¤ritolu nimi',0),(189985,5278,'si','TakojÅ¡nje izvora imena',0),(189986,5278,'ba','Segera asal nama',0),(189987,5278,'nl','Onmiddellijke oorsprong naam',0),(189988,5278,'fi','VÃ¤littÃ¶mÃ¤sti alkuperÃ¤ nimi',0),(189989,5278,'no','Umiddelbar opprinnelse navn',0),(189990,5278,'da','Ã˜jeblikkelig oprindelse navnet',0),(189991,5278,'ko','ì¦‰ì‹œ ê·¼ì› ì´ë¦„',0),(189992,5278,'he','×©× ×ž×•×¦× ×ž×™×™×“×™×ª',0),(189993,5278,'el','Î†Î¼ÎµÏƒÎ· Ï€ÏÎ¿Î­Î»ÎµÏ…ÏƒÎ·Ï‚ ÏŒÎ½Î¿Î¼Î±',0),(189994,5278,'zh','ç›´æŽ¥åŽŸæ¥åç§°\r\n',0),(189995,5278,'sv','Omedelbara ursprung namn',0),(189996,5278,'it','Nome di origine immediata',0),(189997,5278,'tl','',0),(189998,5278,'th','&#3651;&#3626;&#3656;&#3594;&#3639;&#3656;&#3629;&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;&#3607;&#3633;&#3609;&#3607;&#3637;',0),(189999,5278,'hi','à¤¤à¤¤à¥à¤•à¤¾à¤² à¤®à¥‚à¤² à¤¨à¤¾à¤®',0),(190000,5278,'ms','Nama asal-usul serta-merta',0),(190001,5278,'ar','Ø§Ø³Ù… Ø§Ù„Ø£ØµÙ„ Ø§Ù„ÙÙˆØ±ÙŠ',0),(190002,5278,'fr','Nom d\'origine immÃ©diate',0),(190003,5278,'jp','å‰?ã?®çµŒç”±ç™ºé€?åœ°å??',0),(190004,5278,'pt','Nome de origem imediata',0),(190005,5278,'ru','ÐÐµÐ¼ÐµÐ´Ð»ÐµÐ½Ð½Ð¾Ðµ Ð¿Ñ€Ð¾Ð¸ÑÑ…Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ Ð¸Ð¼ÐµÐ½Ð¸',0),(190006,5278,'es','Nombre de Origen Inmediato',0),(190007,5278,'de','Unmittelbare Herkunft Name',0),(190008,5278,'en','Immediate Origin Name',0),(190009,5279,'is','',0),(190010,5279,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ù…Ù†Ø¨Ø¹ ÙÙˆØ±ÙŠ ',0),(190011,5279,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ù…Ù†Ø¨Ø¹ ÙÙˆØ±ÙŠ ',0),(190012,5279,'tr','Acil kaynak yÃ¶nlendirme numarasÄ±',0),(190013,5279,'pl','Numer rozliczeniowy bezpoÅ›redniego pochodzenia',0),(190014,5279,'bg','ÐÐµÐ·Ð°Ð±Ð°Ð²Ð½Ð¾ Ð¿Ñ€Ð¾Ð¸Ð·Ñ…Ð¾Ð´ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð° Ñ‡Ð¸ÑÐ»Ð¾',0),(190015,5279,'ur','ÙÙˆØ±ÛŒ Ø·ÙˆØ± Ù¾Ø± Ø§ØµÙ„ ØªØ¹Ø¯Ø§Ø¯ Ø±ÙˆÙ¹ Ø¨Ù†Ø¯ÛŒ',0),(190016,5279,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¾Ð³ Ð¿Ð¾ÑÑ‚ÑƒÐ¿ÐºÐ° Ð·Ð° Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð°Ð»Ð½Ñƒ Ð¿Ð¾Ñ€ÐµÐºÐ»Ð°',0),(190017,5279,'vi','TÃªn sá»‘ lá»™ trÃ¬nh Ä‘iá»ƒm Ä‘i ngay',0),(190018,5279,'af','Onmiddellike oorsprong Routing nommer',0),(190019,5279,'ro','NumÄƒrul de rutare origine imediatÄƒ',0),(190020,5279,'et','Kohene pÃ¤ritolu marsruudi Number',0),(190021,5279,'si','TakojÅ¡nje izvora usmerjanje Å¡tevilo',0),(190022,5279,'ba','Nomor Routing segera asal',0),(190023,5279,'nl','Onmiddellijke oorsprong routering nummer',0),(190024,5279,'fi','VÃ¤littÃ¶mÃ¤sti perÃ¤isin reititys numero',0),(190025,5279,'no','Umiddelbar opprinnelse organisasjonsnummer',0),(190026,5279,'da','Ã˜jeblikkelig oprindelse Routing-nummer',0),(190027,5279,'ko','ì¦‰ì‹œ ì›ë³¸ ë¼ìš°íŒ… ë²ˆí˜¸',0),(190028,5279,'he','×ž×¡×¤×¨ × ×™×ª×•×‘ ×ž×§×•×¨ ×ž×™×™×“×™×ª',0),(190029,5279,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Ï€ÏÎ¿Î­Î»ÎµÏ…ÏƒÎ·Ï‚ Î¬Î¼ÎµÏƒÎ·',0),(190030,5279,'zh','ç›´æŽ¥åŽŸæ¥è·¯å¾„å·ç \r\n',0),(190031,5279,'sv','Omedelbara ursprung Routing Number',0),(190032,5279,'it','Numero di Routing di origine immediata',0),(190033,5279,'tl','',0),(190034,5279,'th','Immediate Origin Routing Number',0),(190035,5279,'hi','à¤¤à¤¤à¥à¤•à¤¾à¤² à¤‰à¤¤à¥à¤ªà¤¤à¥à¤¤à¤¿ à¤…à¤¨à¥à¤®à¤¾à¤°à¥à¤—à¤£ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(190036,5279,'ms','Asal-usul serta-merta penghalaan nombor',0),(190037,5279,'ar','Ø±Ù‚Ù… Ø§Ù„ØªÙˆØ¬ÙŠÙ‡ Ø§Ù„Ø£ØµÙ„ Ø§Ù„ÙÙˆØ±ÙŠ',0),(190038,5279,'fr','NumÃ©ro d\'acheminement immÃ©diat d\'origine',0),(190039,5279,'jp','å‰?ã?®çµŒç”±ç™ºé€?åœ°ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå?·',0),(190040,5279,'pt','NÃºmero de roteamento de origem imediata',0),(190041,5279,'ru','ÐÐµÐ¼ÐµÐ´Ð»ÐµÐ½Ð½Ð¾Ðµ Ð¿Ñ€Ð¾Ð¸ÑÑ…Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð½Ð¾Ð¼ÐµÑ€',0),(190042,5279,'es','NÃºmero de Routing de Origen Inmediato',0),(190043,5279,'de','Unmittelbare Herkunft Routing Nummer',0),(190044,5279,'en','Immediate Origin Routing Number',0),(190045,5280,'is','',0),(190046,5280,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù¾ÙŠØ´ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(190047,5280,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù¾ÙŠØ´ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(190048,5280,'tr','Prenotes gÃ¶nder',0),(190049,5280,'pl','WyÅ›lij Prenotes',0),(190050,5280,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Prenotes',0),(190051,5280,'ur','Ù¾Ø±ÛŒÙ†ÙˆÙ¹ÛŒØ³ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(190052,5280,'sr','Ð¡Ð»Ð°ÑšÐµ ÐŸÑ€ÐµÐ½Ð¾Ñ‚ÐµÑ',0),(190053,5280,'vi','Gá»­i ghi chÃº trÆ°á»›c',0),(190054,5280,'af','Stuur Vooraf-notas',0),(190055,5280,'ro','Trimite Prenotes',0),(190056,5280,'et','Saada Prenotes',0),(190057,5280,'si','PoÅ¡lji Prenotes',0),(190058,5280,'ba','Mengirim Prenotes',0),(190059,5280,'nl','Verzenden Prenotes',0),(190060,5280,'fi','LÃ¤hetÃ¤ esilaskut',0),(190061,5280,'no','Sende Prenotes',0),(190062,5280,'da','Send adviseringer',0),(190063,5280,'ko','Prenotes ë³´ë‚´ê¸°',0),(190064,5280,'he','×œ×©×œ×•×— Prenotes',0),(190065,5280,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Prenotes',0),(190066,5280,'zh','å‘é€å‰æ³¨é‡Š\r\n',0),(190067,5280,'sv','Skicka fÃ¶rauktoriseringar',0),(190068,5280,'it','Inviare notifiche anticipate',0),(190069,5280,'tl','',0),(190070,5280,'th','&#3626;&#3656;&#3591;&#3585;&#3656;&#3629;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(190071,5280,'hi','Prenotes à¤­à¥‡à¤œà¥‡à¤‚',0),(190072,5280,'ms','Hantar Prenotes',0),(190073,5280,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¨Ø±ÙŠÙ†ØªÙŠØ³',0),(190074,5280,'fr','Envoyer des notes prÃ©liminaires',0),(190075,5280,'jp','äº‹å‰?ãƒ¡ãƒ¢é€?ä¿¡',0),(190076,5280,'pt','Enviar Prenotes',0),(190077,5280,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Prenotes',0),(190078,5280,'es','Enviar Prenotas',0),(190079,5280,'de','Senden Vorausbenachrichtigungen',0),(190080,5280,'en','Send Prenotes',0),(190081,5281,'is','',0),(190082,5281,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(190083,5281,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(190084,5281,'tr','MÃ¼ÅŸteri iÃ§in satÄ±ÅŸ iÅŸlemi Ekle',0),(190085,5281,'pl','DodaÄ‡ procesu sprzedaÅ¼y dla nabywcy',0),(190086,5281,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(190087,5281,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù„ÛŒÛ’ ÙØ±ÙˆØ®Øª Ú©Û’ Ø¹Ù…Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(190088,5281,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(190089,5281,'vi','ThÃªm Quy TrÃ¬nh BÃ¡n HÃ ng Cho KhÃ¡ch HÃ ng',0),(190090,5281,'af','Voeg verkope proses vir kliÃ«nt',0),(190091,5281,'ro','Adauga procesul de vÃ¢nzare pentru client',0),(190092,5281,'et','Lisada mÃ¼Ã¼giprotsessi kliendi',0),(190093,5281,'si','Dodajanje prodajnega procesa za kupca',0),(190094,5281,'ba','Tambahkan proses penjualan untuk pelanggan',0),(190095,5281,'nl','Verkoopproces toevoegen voor klant',0),(190096,5281,'fi','LisÃ¤Ã¤ myynnin prosessi asiakkaan',0),(190097,5281,'no','Legge til salgsprosessen for kunde',0),(190098,5281,'da','TilfÃ¸je salgsproces for kunde',0),(190099,5281,'ko','ê³ ê°ì„ ìœ„í•œ ì˜ì—… í”„ë¡œì„¸ìŠ¤ë¥¼ ì¶”ê°€',0),(190100,5281,'he','×”×•×¡×£ ××ª ×ª×”×œ×™×š ×”×ž×›×™×¨×•×ª ×¢×‘×•×¨ ×œ×§×•×—',0),(190101,5281,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³Î¹Î± Ï„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(190102,5281,'zh','å¢žåŠ å®¢æˆ·é”€å”®è¿‡ç¨‹\r\n',0),(190103,5281,'sv','LÃ¤gg till fÃ¶rsÃ¤ljningsprocessen fÃ¶r kund',0),(190104,5281,'it','Aggiungere il processo di vendita per cliente',0),(190105,5281,'tl','',0),(190106,5281,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(190107,5281,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(190108,5281,'ms','Menambah proses jualan untuk pelanggan',0),(190109,5281,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(190110,5281,'fr','Ajouter le processus de vente pour le client',0),(190111,5281,'jp','é¡§å®¢ã?®ã‚»ãƒ¼ãƒ«ã‚¹é?Žç¨‹ã‚’è¿½åŠ ',0),(190112,5281,'pt','Adicionar o processo de vendas para o cliente',0),(190113,5281,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÑÑ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(190114,5281,'es','Agregar Proceso de Ventas para Cliente',0),(190115,5281,'de','HinzufÃ¼gen von Vertriebsprozess fÃ¼r Kunden',0),(190116,5281,'en','Add Sales Process for Customer',0),(190117,5282,'is','',0),(190118,5282,'dr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(190119,5282,'pr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(190120,5282,'tr','Fabrika dÃ¼zeni',0),(190121,5282,'pl','Fabryki, kolejnoÅ›ci',0),(190122,5282,'bg','Ð¤Ð°Ð±Ñ€Ð¸ÐºÐ° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(190123,5282,'ur','ÙÛŒÚ©Ù¹Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(190124,5282,'sr','Ð¤Ð°Ð±Ñ€Ð¸ÐºÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(190125,5282,'vi','ÄÆ¡n Ä‘áº·t hÃ ng nhÃ  mÃ¡y',0),(190126,5282,'af','Fabriek Bestelling',0),(190127,5282,'ro','Fabrica de ordine',0),(190128,5282,'et','Tehases jÃ¤rjekorras',0),(190129,5282,'si','Tovarne nalog',0),(190130,5282,'ba','Pesanan pabrik',0),(190131,5282,'nl','Fabrieksbestelling',0),(190132,5282,'fi','Tehdas jotta',0),(190133,5282,'no','Fabrikken for',0),(190134,5282,'da','Fabrikken rÃ¦kkefÃ¸lge',0),(190135,5282,'ko','ê³µìž¥ ì£¼ë¬¸',0),(190136,5282,'he','×ž×¤×¢×œ ×¡×“×¨',0),(190137,5282,'el','Î•ÏÎ³Î¿ÏƒÏ„Î¬ÏƒÎ¹Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(190138,5282,'zh','å·¥åŽ‚è®¢å•\r\n',0),(190139,5282,'sv','Fabriken ordning',0),(190140,5282,'it','Ordine di fabbrica',0),(190141,5282,'tl','',0),(190142,5282,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3650;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(190143,5282,'hi','à¤«à¥ˆà¤•à¥à¤Ÿà¤°à¥€ à¤†à¤¦à¥‡à¤¶',0),(190144,5282,'ms','Perintah kilang',0),(190145,5282,'ar','Ù…ØµÙ†Ø¹ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(190146,5282,'fr','Commande Ã  l\'usine',0),(190147,5282,'jp','å·¥å ´æ³¨æ–‡',0),(190148,5282,'pt','Ordem de fÃ¡brica',0),(190149,5282,'ru','Ð—Ð°Ð²Ð¾Ð´ÑÐºÐ¾Ð¹ Ð—Ð°ÐºÐ°Ð·',0),(190150,5282,'es','Orden de FÃ¡brica',0),(190151,5282,'de','Fabrik-Bestellung',0),(190152,5282,'en','Factory Order',0),(190153,5283,'is','',0),(190154,5283,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¨Ø±Ú¯Ù‡ ',0),(190155,5283,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¨Ø±Ú¯Ù‡ ',0),(190156,5283,'tr','Maksimum sayfa boyutu',0),(190157,5283,'pl','Rozmiar maksymalny arkusza',0),(190158,5283,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(190159,5283,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ÙˆØ±Ù‚ Ø³Ø§Ø¦Ø²',0),(190160,5283,'sr','Ð›Ð¸ÑÑ‚ Ð·Ð° Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ñƒ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(190161,5283,'vi','Cá»¡ trang tá»‘i Ä‘a',0),(190162,5283,'af','Maksimum vel grootte',0),(190163,5283,'ro','Dimensiune maximÄƒ foaie',0),(190164,5283,'et','Maksimaalne lehe suurus',0),(190165,5283,'si','Velikost najveÄje lista',0),(190166,5283,'ba','Ukuran maksimum lembar',0),(190167,5283,'nl','Maximale papierformaat',0),(190168,5283,'fi','Suurin arkkikoko',0),(190169,5283,'no','Maksimalt papirformat',0),(190170,5283,'da','Maksimale arkstÃ¸rrelse',0),(190171,5283,'ko','ìµœëŒ€ ìš©ì§€ í¬ê¸°',0),(190172,5283,'he','×’×•×“×œ ×’×™×œ×™×•×Ÿ ×”×ž×¨×‘×™',0),(190173,5283,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Ï†ÏÎ»Î»Î¿Ï…',0),(190174,5283,'zh','æœ€å¤§çº¸å¼ å°ºå¯¸\r\n',0),(190175,5283,'sv','Maximal arkstorlek',0),(190176,5283,'it','Formato massimo foglio',0),(190177,5283,'tl','',0),(190178,5283,'th','&#3586;&#3609;&#3634;&#3604;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(190179,5283,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤ªà¤¤à¥à¤°à¤• à¤†à¤•à¤¾à¤°',0),(190180,5283,'ms','Saiz kira-kira maksimum',0),(190181,5283,'ar','Ø­Ø¬Ù… ÙˆØ±Ù‚Ø© ÙƒØ­Ø¯ Ø£Ù‚ØµÙ‰',0),(190182,5283,'fr','Taille maximale de la feuille',0),(190183,5283,'jp','æœ€å¤§ã‚·ãƒ¼ãƒˆã‚µã‚¤ã‚º',0),(190184,5283,'pt','Tamanho mÃ¡ximo da folha',0),(190185,5283,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð»Ð¸ÑÑ‚Ð°',0),(190186,5283,'es','MÃ¡ximo TamaÃ±o de Hoja',0),(190187,5283,'de','Maximale BlattgrÃ¶ÃŸe',0),(190188,5283,'en','Maximum Sheet Size',0),(190189,5284,'is','',0),(190190,5284,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¨Ø±Ú¯Ù‡ ',0),(190191,5284,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø¨Ø±Ú¯Ù‡ ',0),(190192,5284,'tr','En az yaprak boyutu',0),(190193,5284,'pl','Rozmiar minimalny arkusza',0),(190194,5284,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(190195,5284,'ur','Ú©Ù… Ø§Ø² Ú©Ù… ÙˆØ±Ù‚ Ø³Ø§Ø¦Ø²',0),(190196,5284,'sr','Ð›Ð¸ÑÑ‚ Ð·Ð° Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ñƒ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(190197,5284,'vi','Cá»¡ trang Tá»‘i thiá»ƒu',0),(190198,5284,'af','Minimum Velgrootte',0),(190199,5284,'ro','Dimensiune minimÄƒ foaie',0),(190200,5284,'et','Minimaalne lehe suurus',0),(190201,5284,'si','Velikost minimalne lista',0),(190202,5284,'ba','Ukuran minimum lembar',0),(190203,5284,'nl','Minimale papierformaat',0),(190204,5284,'fi','VÃ¤hintÃ¤Ã¤n arkkikoko',0),(190205,5284,'no','Minimum arkstÃ¸rrelse',0),(190206,5284,'da','Minimum arkstÃ¸rrelse',0),(190207,5284,'ko','ìµœì†Œ ìš©ì§€ í¬ê¸°',0),(190208,5284,'he','×’×•×“×œ ×’×™×œ×™×•×Ÿ ×ž×™× ×™×ž×œ×™',0),(190209,5284,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚',0),(190210,5284,'zh','æœ€å°çº¸å¼ å°ºå¯¸\r\n',0),(190211,5284,'sv','Minsta arkstorlek',0),(190212,5284,'it','Formato del foglio minimo',0),(190213,5284,'tl','',0),(190214,5284,'th','&#3586;&#3609;&#3634;&#3604;&#3627;&#3609;&#3657;&#3634;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(190215,5284,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤ªà¤¤à¥à¤°à¤• à¤†à¤•à¤¾à¤°',0),(190216,5284,'ms','Saiz minimum lembaran',0),(190217,5284,'ar','Ø­Ø¬Ù… ÙˆØ±Ù‚Ø© Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰',0),(190218,5284,'fr','Taille minimale de la feuille',0),(190219,5284,'jp','æœ€å°?ã‚·ãƒ¼ãƒˆã‚µã‚¤ã‚º',0),(190220,5284,'pt','Tamanho mÃ­nimo da folha',0),(190221,5284,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð»Ð¸ÑÑ‚Ð°',0),(190222,5284,'es','TamaÃ±o de Hoja MÃ­nimo',0),(190223,5284,'de','Minimale Bogenformat',0),(190224,5284,'en','Minimum Sheet Size',0),(190225,5285,'is','',0),(190226,5285,'dr','ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(190227,5285,'pr','ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(190228,5285,'tr','Bordro ana sayfa',0),(190229,5285,'pl','Strona listy pÅ‚ac',0),(190230,5285,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(190231,5285,'ur','Ù¾Û’ Ø±ÙˆÙ„ ÛÙˆÙ… Ù¾ÛŒØ¬',0),(190232,5285,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(190233,5285,'vi','Trang chá»§ báº£ng lÆ°Æ¡ng',0),(190234,5285,'af','Loonrol Tuisblad',0),(190235,5285,'ro','Pagina de pornire de salarizare',0),(190236,5285,'et','Palgaarvestuse kodulehekÃ¼lg',0),(190237,5285,'si','IzplaÄane plaÄe domaÄa stran',0),(190238,5285,'ba','Penggajian Beranda',0),(190239,5285,'nl','Payroll Home Page',0),(190240,5285,'fi','Palkanlaskennan kotisivulle',0),(190241,5285,'no','LÃ¸nn hjemmeside',0),(190242,5285,'da','LÃ¸nningslisten Startside',0),(190243,5285,'ko','ê¸‰ì—¬ í™ˆ íŽ˜ì´ì§€',0),(190244,5285,'he','×“×£ ×”×‘×™×ª ×ž×©×›×•×¨×•×ª',0),(190245,5285,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Î‘ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î±',0),(190246,5285,'zh','è–ªèµ„é¦–é¡µ\r\n',0),(190247,5285,'sv','LÃ¶nelistan hemsida',0),(190248,5285,'it','Pagina iniziale del libro paga',0),(190249,5285,'tl','',0),(190250,5285,'th','&#3650;&#3630;&#3617;&#3648;&#3614;&#3592;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(190251,5285,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤®à¥à¤– à¤ªà¥ƒà¤·à¥à¤ ',0),(190252,5285,'ms','Laman Utama gaji',0),(190253,5285,'ar','Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(190254,5285,'fr','Page d\'accueil de la paie',0),(190255,5285,'jp','äººä»¶è²»ãƒ›ãƒ¼ãƒ ãƒšãƒ¼ã‚¸',0),(190256,5285,'pt','PÃ¡gina inicial da folha de pagamento',0),(190257,5285,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹-Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(190258,5285,'es','PÃ¡gina Hogar de NÃ³mina',0),(190259,5285,'de','Payroll-Homepage',0),(190260,5285,'en','Payroll Home Page',0),(190261,5286,'is','',0),(190262,5286,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(190263,5286,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(190264,5286,'tr','VeritabanÄ± bilgileri',0),(190265,5286,'pl','Informacje o bazie danych',0),(190266,5286,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð‘Ð”',0),(190267,5286,'ur','ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(190268,5286,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð±Ð°Ð·Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(190269,5286,'vi','ThÃ´ng Tin Dá»¯ Liá»‡u',0),(190270,5286,'af','Databasis Inligting',0),(190271,5286,'ro','InformaÅ£ii bazÄƒ de date',0),(190272,5286,'et','Andmebaasi informatsioon',0),(190273,5286,'si','Informacije o zbirki podatkov',0),(190274,5286,'ba','Informasi database',0),(190275,5286,'nl','Database-informatie',0),(190276,5286,'fi','Tietokannan tiedot',0),(190277,5286,'no','Databaseinformasjon',0),(190278,5286,'da','Databaseoplysninger',0),(190279,5286,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì •ë³´',0),(190280,5286,'he','×ž×™×“×¢ ×ž×¡×“ × ×ª×•× ×™×',0),(190281,5286,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(190282,5286,'zh','æ•°æ®åº“ä¿¡æ¯\r\n',0),(190283,5286,'sv','Databasinformation',0),(190284,5286,'it','Informazioni del database',0),(190285,5286,'tl','',0),(190286,5286,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(190287,5286,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥‚à¤šà¤¨à¤¾',0),(190288,5286,'ms','Maklumat pangkalan data',0),(190289,5286,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(190290,5286,'fr','Information sur la base de donnÃ©es',0),(190291,5286,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹æƒ…å ±',0),(190292,5286,'pt','InformaÃ§Ãµes do banco de dados',0),(190293,5286,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð‘Ð°Ð·Ñ‹ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(190294,5286,'es','InformaciÃ³n de Base de Datos',0),(190295,5286,'de','Datenbankinformationen',0),(190296,5286,'en','Database Information',0),(190297,5287,'is','',0),(190298,5287,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†',0),(190299,5287,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§  Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ',0),(190300,5287,'tr','YardÄ±mcÄ± Ekle/GÃ¼ncelle',0),(190301,5287,'pl','Pomoc Dodaj/Aktualizuj',0),(190302,5287,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰Ñ‚Ð°',0),(190303,5287,'ur','Ù…Ø¯Ø¯ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(190304,5287,'sr','ÐŸÐ¾Ð¼Ð¾Ñ›/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(190305,5287,'vi','ThÃªm/Cáº­p Nháº­t Trá»£ GiÃºp',0),(190306,5287,'af','Hulp Skep/Opdateer',0),(190307,5287,'ro','Ajutor Adauga/Actualizeaza',0),(190308,5287,'et','Abi lisamine/uuendamine',0),(190309,5287,'si','PomoÄjo Dodaj/posodobi',0),(190310,5287,'ba','Bantuan Tambahkan/Perbarui',0),(190311,5287,'nl','Help toevoegen/bijwerken',0),(190312,5287,'fi','Apua lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(190313,5287,'no','Hjelp/Oppdater',0),(190314,5287,'da','HjÃ¦lp TilfÃ¸j/opdater',0),(190315,5287,'ko','ë„ì›€ë§ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(190316,5287,'he','×¢×–×¨×” ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(190317,5287,'el','Î’Î¿Î®Î¸ÎµÎ¹Î±-Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(190318,5287,'zh','åŸºäºŽæ–‡æœ¬çš„è¯´æ˜Ž...\r\n',0),(190319,5287,'sv','HjÃ¤lp LÃ¤gg till/uppdatera',0),(190320,5287,'it','Aiuto aggiungere/aggiornare',0),(190321,5287,'tl','',0),(190322,5287,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(190323,5287,'hi','à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(190324,5287,'ms','Bantuan Tambah/Kemaskini',0),(190325,5287,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(190326,5287,'fr','Aide ajouter/mettre Ã  jour',0),(190327,5287,'jp','ãƒ˜ãƒ«ãƒ—ã?®è¿½åŠ /æ›´æ–°',0),(190328,5287,'pt','Ajuda adicionar/atualizar',0),(190329,5287,'ru','ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(190330,5287,'es','Ayuda Agregar/Actualizar',0),(190331,5287,'de','Hilfe hinzufÃ¼gen/aktualisieren',0),(190332,5287,'en','Help Add/Update',0),(190333,5288,'is','',0),(190334,5288,'dr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø±',0),(190335,5288,'pr','Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø±',0),(190336,5288,'tr','KullanÄ±cÄ± haklarÄ±',0),(190337,5288,'pl','Praw uÅ¼ytkownika',0),(190338,5288,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ñ€Ð°Ð²Ð°',0),(190339,5288,'ur','ØµØ§Ø±Ù Ú©Û’ Ø­Ù‚ÙˆÙ‚',0),(190340,5288,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ° Ð¿Ñ€Ð°Ð²Ð°',0),(190341,5288,'vi','Quyá»n Cá»§a NgÆ°á»i Sá»­ Dá»¥ng',0),(190342,5288,'af','Gebruikerregte',0),(190343,5288,'ro','Drepturi Utilizator',0),(190344,5288,'et','Kasutaja Ãµigused',0),(190345,5288,'si','UporabniÅ¡ke pravice',0),(190346,5288,'ba','Hak-hak pengguna',0),(190347,5288,'nl','Gebruikersrechten',0),(190348,5288,'fi','KÃ¤yttÃ¶oikeudet',0),(190349,5288,'no','Brukerrettigheter',0),(190350,5288,'da','Brugerrettigheder',0),(190351,5288,'ko','ì‚¬ìš©ìž ê¶Œí•œ',0),(190352,5288,'he','×”×¨×©××•×ª ×ž×©×ª×ž×©',0),(190353,5288,'el','Î”Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï‡ÏÎ®ÏƒÏ„Î·',0),(190354,5288,'zh','ç”¨æˆ·æç¤º\r\n',0),(190355,5288,'sv','AnvÃ¤ndarrÃ¤ttigheter',0),(190356,5288,'it','Diritti utente',0),(190357,5288,'tl','',0),(190358,5288,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(190359,5288,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(190360,5288,'ms','Hak-hak pengguna',0),(190361,5288,'ar','Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(190362,5288,'fr','Droits de l\'utilisateur',0),(190363,5288,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©é™?',0),(190364,5288,'pt','Direitos de usuÃ¡rio',0),(190365,5288,'ru','ÐŸÑ€Ð°Ð²Ð° ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(190366,5288,'es','Derechos del Usuario ',0),(190367,5288,'de','Benutzerrechte',0),(190368,5288,'en','User Rights',0),(190369,5289,'is','',0),(190370,5289,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ø³Ø®Ù‡',0),(190371,5289,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ø³Ø®Ù‡',0),(190372,5289,'tr','SÃ¼rÃ¼m bilgisi',0),(190373,5289,'pl','Informacje o wersji',0),(190374,5289,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð²ÐµÑ€ÑÐ¸ÑÑ‚Ð°',0),(190375,5289,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ÙˆØ±Ú˜Ù† Ù†ÛÛŒÚº',0),(190376,5289,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð¸',0),(190377,5289,'vi','ThÃ´ng Tin Vá» PhiÃªn Báº£n',0),(190378,5289,'af','Weergawe Inligting',0),(190379,5289,'ro','Info versiune',0),(190380,5289,'et','Versiooni info',0),(190381,5289,'si','Informacije o razliÄici',0),(190382,5289,'ba','Informasi versi',0),(190383,5289,'nl','Versie-informatie',0),(190384,5289,'fi','Versiotiedot',0),(190385,5289,'no','Versjonsinformasjon',0),(190386,5289,'da','Versionsoplysninger',0),(190387,5289,'ko','ë²„ì „ ì •ë³´',0),(190388,5289,'he','×ž×™×“×¢ ××•×“×•×ª ×’×™×¨×¡××•×ª',0),(190389,5289,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î­ÎºÎ´Î¿ÏƒÎ·Ï‚',0),(190390,5289,'zh','ç‰ˆæœ¬ä¿¡æ¯\r\n',0),(190391,5289,'sv','Versionsinformation',0),(190392,5289,'it','Informazioni sulla versione',0),(190393,5289,'tl','',0),(190394,5289,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3623;&#3629;&#3619;&#3660;&#3594;&#3633;&#3656;&#3609;',0),(190395,5289,'hi','à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(190396,5289,'ms','Maklumat versi',0),(190397,5289,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¥ØµØ¯Ø§Ø±',0),(190398,5289,'fr','Informations de version',0),(190399,5289,'jp','ãƒ?ãƒ¼ã‚¸ãƒ§ãƒ³æƒ…å ±',0),(190400,5289,'pt','InformaÃ§Ãµes de versÃ£o',0),(190401,5289,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð’ÐµÑ€ÑÐ¸Ð¸',0),(190402,5289,'es','InformaciÃ³n de VersiÃ³n',0),(190403,5289,'de','Versionsinformationen',0),(190404,5289,'en','Version Information',0),(190405,5290,'is','',0),(190406,5290,'dr','Ù‡ÙŠÚ† Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ â€“ Ø¨Ø±Ø§ÙŠ Ø§ÙØ²ÙˆØ¯Ù† ØªØ¹Ø¯Ø§Ø¯ÙŠ Ù‚Ø³Ù…Øª Ø²ÙŠØ± Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(190407,5290,'pr','Ù‡ÙŠÚ† Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ â€“ Ø¨Ø±Ø§ÙŠ Ø§ÙØ²ÙˆØ¯Ù† ØªØ¹Ø¯Ø§Ø¯ÙŠ Ù‚Ø³Ù…Øª Ø²ÙŠØ± Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(190408,5290,'tr','HiÃ§bir rating(s) buldum.  AÅŸaÄŸÄ±da bazÄ± eklemek iÃ§in tÄ±klatÄ±n.',0),(190409,5290,'pl','Nie znaleziono Kategorie wiekowe.  Kliknij przycisk poniÅ¼ej aby dodaÄ‡ kilka.',0),(190410,5290,'bg','ÐÑÐ¼Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸.  Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ, Ð·Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð½ÑÐºÐ¾Ð¸.',0),(190411,5290,'ur','Ú©ÙˆØ¦ÛŒ rating(s) Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§ Ø¬Ø§ØªØ§ Û”  Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ú©Ú†Ú¾ Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(190412,5290,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ñ‚Ð¸Ð½Ð³(Ñ) Ñ˜Ðµ Ð½Ð°ÑˆÐ°Ð¾.  ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð½ÐµÐºÐ¸.',0),(190413,5290,'vi','KhÃ´ng cÃ³ giÃ¡. Nháº¥n dÆ°á»›i Ä‘Ã¢y Ä‘á»ƒ thÃªm vÃ o',0),(190414,5290,'af','Geen rating(s) gevind nie.  Klik hieronder om te voeg by sommige.',0),(190415,5290,'ro','TotuÈ™i nu a Ã®ntemeia.  Click mai jos pentru a adÄƒuga unele.',0),(190416,5290,'et','Rating(s) ei leitud.  KlÃµpsake, et lisada mÃµned.',0),(190417,5290,'si','Ne rating(-i) naÅ¡el.  Kliknite spodaj, da dodate nekaj.',0),(190418,5290,'ba','Tidak ada batas umur pemain ditemukan.  Klik di bawah untuk menambahkan beberapa.',0),(190419,5290,'nl','Geen rating(s) gevonden.  Klik hieronder om toe te voegen sommige.',0),(190420,5290,'fi','Kelpuutukset ei lÃ¶ytynyt.  Napsauta alla lisÃ¤tÃ¤ joitakin.',0),(190421,5290,'no','Ingen rating(s) funnet.  Klikk nedenfor for Ã¥ legge til noen.',0),(190422,5290,'da','Ingen rettighed(er), der er fundet.  Klik nedenfor for at tilfÃ¸je nogle.',0),(190423,5290,'ko','ì•„ë‹ˆ ë“±ê¸‰ ë°œê²¬ (ì„ ë“¤).  ì•„ëž˜ ì¼ë¶€ ì¶”ê°€ë¥¼ í´ë¦­ í•©ë‹ˆë‹¤.',0),(190424,5290,'he','Rating(s) ×œ× × ×ž×¦××•.  ×œ×—×¥ ×œ×”×œ×Ÿ ×›×“×™ ×œ×”×•×¡×™×£ ×§×¦×ª.',0),(190425,5290,'el','Î”ÎµÎ½ Î²Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± (ÎµÏ‚) Î²ÏÎ­Î¸Î·ÎºÎ±Î½.  ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÎºÎ¬Ï€Î¿Î¹Î±.',0),(190426,5290,'zh','æ— è¯„çº§ï¼ˆsï¼‰æ‰¾åˆ°ã€‚ç‚¹å‡»ä¸‹é¢æ·»åŠ ã€‚\r\n',0),(190427,5290,'sv','Ingen behÃ¶righet (er) hittade.  Klicka nedan fÃ¶r att lÃ¤gga till nÃ¥gra.',0),(190428,5290,'it','Nessun abilitazioni trovato.  Clicca qui sotto per aggiungere alcuni.',0),(190429,5290,'tl','',0),(190430,5290,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3621;&#3635;&#3604;&#3633;&#3610; &#3588;&#3621;&#3636;&#3585;&#3586;&#3657;&#3634;&#3591;&#3621;&#3656;&#3634;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3614;&#3636;&#',0),(190431,5290,'hi','à¤•à¥‹à¤ˆ rating(s) à¤ªà¤¾à¤¯à¤¾à¥¤  à¤¨à¥€à¤šà¥‡ à¤•à¥à¤› à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚à¥¤',0),(190432,5290,'ms','Tiada rating(s) yang ditemui.  Klik di bawah untuk menambah beberapa.',0),(190433,5290,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªØµÙ†ÙŠÙ (Ù‚) ÙˆØ¬Ø¯Øª.  Ø§Ù†Ù‚Ø± Ø£Ø¯Ù†Ø§Ù‡ Ù„Ø¥Ø¶Ø§ÙØ© Ø¨Ø¹Ø¶.',0),(190434,5290,'fr','Aucune qualifications trouvÃ©es.  Cliquez ci-dessous pour ajouter un peu.',0),(190435,5290,'jp','è©•ä¾¡ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã€‚ã?„ã??ã?¤ã?‹è¿½åŠ ã?™ã‚‹ã?Ÿã‚?ã?«ã?¯ä¸‹ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„ã€‚',0),(190436,5290,'pt','Nenhuma avaliaÃ§Ã£o (s) encontrados.  Clique abaixo para adicionar alguns.',0),(190437,5290,'ru','Ð‘ÐµÐ· Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³Ð° (Ð¾Ð²) Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.  ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð¸Ð¶Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½ÐµÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ.',0),(190438,5290,'es','No se EncontrÃ³ una valuaciÃ³n(es). Hace click abajo para agregar unas',0),(190439,5290,'de','Keine Rating(s) gefunden.  Klicken Sie unten einfÃ¼gen.',0),(190440,5290,'en','No rating(s) found.  Click below to add some.',0),(190441,5291,'is','',0),(190442,5291,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ùˆ ÙØ±ÙˆØ´Ù†Ø¯Ù‡   Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(190443,5291,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ùˆ ÙØ±ÙˆØ´Ù†Ø¯Ù‡   Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(190444,5291,'tr','TaÅŸÄ±yÄ±cÄ± ve satÄ±cÄ± bilgileri silmek istediÄŸinizden emin misiniz?',0),(190445,5291,'pl','Czy na pewno chcesz usunÄ…Ä‡ przewoÅºnika i dostawcy informacji?',0),(190446,5291,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡?',0),(190447,5291,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ú©ÛŒØ±ÛŒØ¦Ø± Ø§ÙˆØ± ÙØ±ÙˆØ´Ù†Ø¯Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(190448,5291,'sr','ÐˆÐµÑÐ¸ Ð»Ð¸ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ð½Ð¾ÑÐ°Ñ‡ Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸Ð½Ñ„Ð¾?',0),(190449,5291,'vi','XÃ³a thÃ´ng tin hÃ£ng váº­n chuyá»ƒn vÃ  ngÆ°á»i bÃ¡n?',0),(190450,5291,'af','Is u seker u wil karweier en verskaffer inligting skrap?',0),(190451,5291,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ ÅŸtergeÅ£i transportator ÅŸi furnizor de informaÅ£ii?',0),(190452,5291,'et','Olete kindel, et soovite kustutada vedaja ja tarnija info?',0),(190453,5291,'si','Ali ste prepriÄani, Å¾elite izbrisati prevoznika in prodajalca info?',0),(190454,5291,'ba','Apakah Anda yakin Anda ingin menghapus info pembawa dan vendor?',0),(190455,5291,'nl','Weet u zeker dat u wilt verwijderen van de vervoerder en leverancier info?',0),(190456,5291,'fi','Haluatko varmasti poistaa operaattorin ja toimittajan info?',0),(190457,5291,'no','Er du sikker pÃ¥ at du vil slette operatÃ¸r og leverandÃ¸r?',0),(190458,5291,'da','Er du sikker pÃ¥ du Ã¸nsker at slette carrier og leverandÃ¸ren info?',0),(190459,5291,'ko','ë‹¹ì‹ ì€ ìºë¦¬ì–´ ë° ê³µê¸‰ ì—…ì²´ ì •ë³´ë¥¼ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(190460,5291,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ××ª ×¤×¨×˜×™ ×”×¡×¤×§ ×œ×‘×™×Ÿ ×¡×¤×§?',0),(190461,5291,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï„Î¿Ï… Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î± ÎºÎ±Î¹ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®;',0),(190462,5291,'zh','ä½ ç¡®å®šè¦åˆ é™¤æ‰¿è¿äººå’Œä¾›åº”å•†ä¿¡æ¯ï¼Ÿ\r\n',0),(190463,5291,'sv','Ã„r du sÃ¤ker du vill ta bort bÃ¤rare och leverantÃ¶r information?',0),(190464,5291,'it','Sei sicuro che vuoi cancellare informazioni vettore e fornitore?',0),(190465,5291,'tl','',0),(190466,5291,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610; &#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#',0),(190467,5291,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤µà¤¾à¤¹à¤• à¤”à¤° à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(190468,5291,'ms','Adakah anda pasti anda mahu memadam maklumat pembekal dan Penjual?',0),(190469,5291,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø£Ù† ØªØ­Ø°Ù Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ùˆ Ø§Ù„Ù†Ø§Ù‚Ù„ ØŸ',0),(190470,5291,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer les infos transporteur et vendeur ?',0),(190471,5291,'jp','ç™ºé€?æ¥­è€…ã?¨æ¥­è€…æƒ…å ±ã‚’æ¶ˆåŽ»ã?—ã?¦ã‚‚ã‚ˆã‚?ã?—ã?„ã?§ã?™ã?‹ï¼Ÿ',0),(190472,5291,'pt','Tem certeza que deseja apagar informaÃ§Ã£o transportadora e fornecedor?',0),(190473,5291,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð¾ ÐºÑƒÑ€ÑŒÐµÑ€Ðµ Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐµ?',0),(190474,5291,'es','Â¿Esta seguro que quiere eliminar informaciÃ³n de proveedor y transportador?',0),(190475,5291,'de','Sind Sie sicher, dass Sie TrÃ¤ger und Anbieter Informationen lÃ¶schen mÃ¶chten?',0),(190476,5291,'en','Are you sure you wish to delete carrier and vendor info?',0),(190477,5292,'is','',0),(190478,5292,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ÙÙ‚Ø· Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(190479,5292,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ÙÙ‚Ø· Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(190480,5292,'tr','Sadece taÅŸÄ±yÄ±cÄ± bilgi silmek istediÄŸinizden emin misiniz?',0),(190481,5292,'pl','Czy na pewno chcesz usunÄ…Ä‡ tylko noÅ›nik informacji?',0),(190482,5292,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ ÑÐ°Ð¼Ð¾ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ?',0),(190483,5292,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ØµØ±Ù Ú©ÛŒØ±ÛŒØ¦Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(190484,5292,'sr','ÐˆÐµÑÐ¸ Ð»Ð¸ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð½Ð¾ÑÐ°Ñ‡ Ð¸Ð½Ñ„Ð¾?',0),(190485,5292,'vi','Chá»‰ xÃ³a thÃ´ng tin hÃ£ng váº­n chuyá»ƒn?',0),(190486,5292,'af','Is u seker u wil Net die karweier inligting skrap?',0),(190487,5292,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ ÅŸtergeÅ£i doar informaÅ£ii de transport?',0),(190488,5292,'et','Kas kindlasti kustutada lihtsalt vedaja info?',0),(190489,5292,'si','Ali ste prepriÄani, Å¾elite izbrisati samo prevoznik info?',0),(190490,5292,'ba','Apakah Anda yakin Anda ingin menghapus hanya pembawa info?',0),(190491,5292,'nl','Weet u zeker dat u wilt verwijderen alleen vervoerder info?',0),(190492,5292,'fi','Haluatko varmasti poistaa vain operaattorin info?',0),(190493,5292,'no','Er du sikker pÃ¥ at du vil slette bare carrier informasjon?',0),(190494,5292,'da','Er du sikker pÃ¥ du vil slette bare luftfartsselskab info?',0),(190495,5292,'ko','ë‹¹ì‹ ì€ ê·¸ëƒ¥ ìºë¦¬ì–´ ì •ë³´ë¥¼ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(190496,5292,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ×¨×§ × ×•×©× ×¤×¨×˜×™?',0),(190497,5292,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î¼ÏŒÎ½Î¿ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚;',0),(190498,5292,'zh','ä½ ç¡®å®šåªè¦åˆ é™¤æ‰¿è¿å•†ä¿¡æ¯ï¼Ÿ\r\n',0),(190499,5292,'sv','Ã„r du sÃ¤ker du vill ta bort bara carrier information?',0),(190500,5292,'it','Sei sicuro che si desidera eliminare solo gli informazioni vettore?',0),(190501,5292,'tl','',0),(190502,5292,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610; &#3649;&#3588;&#3656;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#',0),(190503,5292,'hi','à¤•à¥à¤¯à¤¾ à¤†à¤ª à¤¯à¤•à¥€à¤¨ à¤¹à¥ˆ à¤•à¤¿ à¤¤à¥à¤® à¤¸à¤¿à¤°à¥à¤« à¤µà¤¾à¤¹à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(190504,5292,'ms','Adakah anda pasti hendak menghapuskan hanya pembawa maklumat?',0),(190505,5292,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø±ØºØ¨ØªÙƒ ÙÙŠ Ø­Ø°Ù Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù†Ø§Ù‚Ù„ ÙÙ‚Ø·ØŸ',0),(190506,5292,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer juste les infos transporteur ?',0),(190507,5292,'jp','ç™ºé€?æ¥­è€…æƒ…å ±ã?®ã?¿æ¶ˆåŽ»ã?—ã?¦ã‚‚ã‚ˆã‚?ã?—ã?„ã?§ã?™ã?‹ï¼Ÿ',0),(190508,5292,'pt','Tem certeza que deseja excluir apenas informaÃ§Ã£o de portador?',0),(190509,5292,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹ Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¸Ð½Ñ„Ð¾ Ð¾ ÐºÑƒÑ€ÑŒÐµÑ€Ðµ?',0),(190510,5292,'es','Â¿Esta seguro que quiere eliminar esta informaciÃ³n de transportador solamente?',0),(190511,5292,'de','Sind Sie sicher, dass Sie nur TrÃ¤ger Informationen lÃ¶schen mÃ¶chten?',0),(190512,5292,'en','Are you sure you wish to delete just carrier info?',0),(190513,5293,'is','',0),(190514,5293,'dr','Ø­Ø°Ù Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ùˆ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(190515,5293,'pr','Ø­Ø°Ù Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ùˆ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(190516,5293,'tr','TaÅŸÄ±yÄ±cÄ± ve satÄ±cÄ± bilgileri silme',0),(190517,5293,'pl','UsuÅ„ przewoÅºnika i dostawcy',0),(190518,5293,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡Ð° Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°',0),(190519,5293,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ø§ÙˆØ± ÙØ±ÙˆØ´Ù†Ø¯Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(190520,5293,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð½Ð¾ÑÐ°Ñ‡ Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ñƒ',0),(190521,5293,'vi','XÃ³a thÃ´ng tin hÃ£ng váº­n chuyá»ƒn & ngÆ°á»i bÃ¡n',0),(190522,5293,'af','Skrap Karweier en Verskaffer Inligting',0),(190523,5293,'ro','Åžterge transportator ÅŸi furnizor de informaÅ£ii',0),(190524,5293,'et','Kustuta vedaja ja tarnija info',0),(190525,5293,'si','IzbriÅ¡i nosilec in informacij o prodajalcu',0),(190526,5293,'ba','Menghapus pembawa dan Vendor Info',0),(190527,5293,'nl','Vervoerder en Vendor Info verwijderen',0),(190528,5293,'fi','Poista operaattorin ja toimittajan tiedot',0),(190529,5293,'no','Slette operatÃ¸r og leverandÃ¸r Info',0),(190530,5293,'da','Slette Carrier og leverandÃ¸ren Info',0),(190531,5293,'ko','ì´ë™ í†µì‹ ì‚¬ì™€ ê³µê¸‰ ì—…ì²´ ì •ë³´ ì‚­ì œ',0),(190532,5293,'he','×œ×ž×—×•×§ ××ª ×”×¡×¤×§ ×•××ª ×¤×¨×˜×™ ×¡×¤×§',0),(190533,5293,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î± ÎºÎ±Î¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(190534,5293,'zh','è¿è¥å•†å’Œä¾›åº”å•†ä¿¡æ¯åˆ é™¤\r\n',0),(190535,5293,'sv','Ta bort bÃ¤rare och leverantÃ¶r information',0),(190536,5293,'it','Eliminare il vettore e Vendor Info',0),(190537,5293,'tl','',0),(190538,5293,'th','&#3621;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3632;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(190539,5293,'hi','à¤µà¤¾à¤¹à¤• à¤”à¤° à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¹à¤Ÿà¤¾à¤à¤',0),(190540,5293,'ms','Menghapuskan pembawa dan pembekal maklumat',0),(190541,5293,'ar','Ø­Ø°Ù Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù†Ø§Ù‚Ù„ Ùˆ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(190542,5293,'fr','Supprimer le transporteur et vendeur Info',0),(190543,5293,'jp','ç™ºé€?æ¥­è€…ã?¨æ¥­è€…æƒ…å ±ã?®æ¶ˆåŽ»',0),(190544,5293,'pt','Excluir transportadora e informaÃ§Ã£o de fornecedores',0),(190545,5293,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð˜Ð½Ñ„Ð¾ Ð¾ ÐšÑƒÑ€ÑŒÐµÑ€Ðµ Ð¸ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐµ',0),(190546,5293,'es','Eliminar Info de Proveedor y Transportador',0),(190547,5293,'de','TrÃ¤ger und Anbieter Info lÃ¶schen',0),(190548,5293,'en','Delete Carrier and Vendor Info',0),(190549,5294,'is','',0),(190550,5294,'dr','ÙÙ‚Ø· Ø­Ø°Ù Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(190551,5294,'pr','ÙÙ‚Ø· Ø­Ø°Ù Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(190552,5294,'tr','Sadece taÅŸÄ±yÄ±cÄ± bilgi silme',0),(190553,5294,'pl','UsunÄ…Ä‡ noÅ›nik informacji tylko',0),(190554,5294,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÑÐ°Ð¼Ð¾',0),(190555,5294,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØµØ±Ù Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(190556,5294,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ ÑÐ°Ð¼Ð¾ Ð½Ð¾ÑÐ°Ñ‡ Ð˜Ð½Ñ„Ð¾',0),(190557,5294,'vi','Chá»‰ XÃ³a thÃ´ng tin hÃ£ng váº­n chuyá»ƒn',0),(190558,5294,'af','Skrap Slegs Karweier Inligting',0),(190559,5294,'ro','Åžterge Info transport numai',0),(190560,5294,'et','Kustuta ainult vedaja info',0),(190561,5294,'si','IzbriÅ¡i nosilec informacij, le',0),(190562,5294,'ba','Menghapus pembawa Info hanya',0),(190563,5294,'nl','Vervoerder Info alleen verwijderen',0),(190564,5294,'fi','Poista rahdinkuljettajan tiedot',0),(190565,5294,'no','Slette operatÃ¸r-Info',0),(190566,5294,'da','Slette luftfartsselskabet Info kun',0),(190567,5294,'ko','ìºë¦¬ì–´ ì •ë³´ë§Œì„ ì‚­ì œí•©ë‹ˆë‹¤',0),(190568,5294,'he','×ž×—×™×§×ª ×¤×¨×˜×™ ×”×¡×¤×§ ×‘×œ×‘×“',0),(190569,5294,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼ÏŒÎ½Î¿',0),(190570,5294,'zh','åªåˆ é™¤è¿è¥å•†ä¿¡æ¯\r\n',0),(190571,5294,'sv','Ta bort Carrier information endast',0),(190572,5294,'it','Eliminare il vettore Info solo',0),(190573,5294,'tl','',0),(190574,5294,'th','&#3621;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(190575,5294,'hi','à¤•à¥ˆà¤°à¤¿à¤¯à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡à¤µà¤² à¤¹à¤Ÿà¤¾à¤à¤',0),(190576,5294,'ms','Menghapuskan pembawa maklumat sahaja',0),(190577,5294,'ar','Ø­Ø°Ù Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù†Ø§Ù‚Ù„ ÙÙ‚Ø·',0),(190578,5294,'fr','Suppression des infos transporteur uniquement',0),(190579,5294,'jp','ç™ºé€?æ¥­è€…æƒ…å ±ã?®ã?¿ã?®æ¶ˆåŽ»',0),(190580,5294,'pt','Excluir apenas informaÃ§Ãµes de transportadora',0),(190581,5294,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð˜Ð½Ñ„Ð¾ ÐšÑƒÑ€ÑŒÐµÑ€Ð°',0),(190582,5294,'es','Eliminar Transportador Pero Guardar Proveedor',0),(190583,5294,'de','Carrier Info nur lÃ¶schen',0),(190584,5294,'en','Delete Carrier Info Only',0),(190585,5295,'is','',0),(190586,5295,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø±Ø§ Ø¨Ù‡ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ØªØ¨Ø¯ÙŠÙ„  ÙƒÙ†ÙŠØ¯ØŸ',0),(190587,5295,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø±Ø§ Ø¨Ù‡ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ØªØ¨Ø¯ÙŠÙ„  ÙƒÙ†ÙŠØ¯ØŸ',0),(190588,5295,'tr','Bu satÄ±cÄ± bir taÅŸÄ±yÄ±cÄ± yapmak istediÄŸinizden emin misiniz?',0),(190589,5295,'pl','Czy na pewno chcesz dostawcy przewoÅºnika?',0),(190590,5295,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡?',0),(190591,5295,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ÛŒÛ ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒØ±ÛŒØ¦Ø± Ø¨Ù†Ø§Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(190592,5295,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð½Ð¾ÑÐ¸Ð»Ð°Ñ†?',0),(190593,5295,'vi','Äá»•i ngÆ°á»i bÃ¡n thÃ nh hÃ£ng váº­n chuyá»ƒn?',0),(190594,5295,'af','Is u seker u wil hierdie verskaffer \'n karweier maak?',0),(190595,5295,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ faceÅ£i acest furnizor un operator de transport?',0),(190596,5295,'et','Kas olete kindel, et soovite lisada tarnija vedajana?',0),(190597,5295,'si','Ali ste prepriÄani, da Å¾elite narediti to prodajalec prevoznik?',0),(190598,5295,'ba','Apakah Anda yakin Anda ingin membuat vendor ini pembawa?',0),(190599,5295,'nl','Weet u zeker dat u wilt maken van deze leverancier een drager?',0),(190600,5295,'fi','Oletko varma, ettÃ¤ haluat tehdÃ¤ tÃ¤tÃ¤ toimittajaa harjoittaja?',0),(190601,5295,'no','Er du sikker pÃ¥ at du vil gjÃ¸re denne leverandÃ¸ren en operatÃ¸r?',0),(190602,5295,'da','Er du sikker pÃ¥ du vil gÃ¸re denne kreditor en transportÃ¸r?',0),(190603,5295,'ko','ë‹¹ì‹ ì€ ìš´ë°˜ëŒ€ê°€ ê³µê¸‰ì´ ì—…ì²´ë¥¼ í™•ì¸ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(190604,5295,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×”×¤×•×š ×¡×¤×§ ×–×” × ×©××™×ª?',0),(190605,5295,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎºÎ¬Î½ÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÎµÎ½ÏŒÏ‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±;',0),(190606,5295,'zh','ä½ ç¡®å®šä½ æƒ³ä½¿è¿™ä¸ªåŽ‚å•†çš„è¿è¥å•†å—ï¼Ÿ\r\n',0),(190607,5295,'sv','Ã„r du sÃ¤ker du vill gÃ¶ra leverantÃ¶ren en bÃ¤rare?',0),(190608,5295,'it','Sei sicuro di che voler fare questo venditore un vettore?',0),(190609,5295,'tl','',0),(190610,5295,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3651;&#3627;&#3657;&#3612;&#3641;&#3657;&#3612;&#3621;&#3636;&#3605;&#3648;&#3611;&#3655;&#3609;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;&#3627;&#3619;&#3639;&#3629;&#3',0),(190611,5295,'hi','à¤•à¥à¤¯à¤¾ à¤µà¤¾à¤•à¤ˆ à¤†à¤ª à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤à¤• à¤µà¤¾à¤¹à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(190612,5295,'ms','Adakah anda pasti anda mahu untuk membuat penjual ini sebuah pesawat?',0),(190613,5295,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø£Ù† ØªØ¬Ø¹Ù„ Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ù†Ø§Ù‚Ù„Ø§ ØŸ',0),(190614,5295,'fr','ÃŠtes-vous sÃ»r de que vouloir faire ce fournisseur un transporteur ?',0),(190615,5295,'jp','ã?“ã?®æ¥­è€…ã‚’ç™ºé€?æ¥­è€…ã?«ã?—ã?¦ã‚‚ã‚ˆã‚?ã?—ã?„ã?§ã?™ã?‹ï¼Ÿ',0),(190616,5295,'pt','Tem certeza que quer fazer este fornecedor uma transportadora?',0),(190617,5295,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° ÐºÑƒÑ€ÑŒÐµÑ€Ð¾Ð¼?',0),(190618,5295,'es','Â¿Esta seguro que quiere hacer este proveedor a un transportador?',0),(190619,5295,'de','Bist du sicher, dass Sie diesen Kreditor TrÃ¤ger machen wollen?',0),(190620,5295,'en','Are you sure you want to make this vendor a carrier?',0),(190621,5296,'is','',0),(190622,5296,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(190623,5296,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(190624,5296,'tr','Girilen son hesaplarÄ±',0),(190625,5296,'pl','Ostatnie rachunki wprowadzone',0),(190626,5296,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸',0),(190627,5296,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø§Ø®Ù„',0),(190628,5296,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸ ÑƒÑˆÐ°Ð¾',0),(190629,5296,'vi','Nhá»¯ng TK Má»›i Nháº­p Gáº§n Nháº¥t',0),(190630,5296,'af','Onlangse Rekeninge Ingevoer',0),(190631,5296,'ro','Recente conturi au intrat',0),(190632,5296,'et','Tehtud kontodele sisestatud',0),(190633,5296,'si','Nedavni raÄuni, vstopil',0),(190634,5296,'ba','Hari account masuk',0),(190635,5296,'nl','Recente rekeningen ingevoerd',0),(190636,5296,'fi','Hotelliin tilit tuli',0),(190637,5296,'no','Siste kontoer angitt',0),(190638,5296,'da','De seneste regnskaber opfÃ¸rt',0),(190639,5296,'ko','ìµœê·¼ ê³„ì • ìž…ë ¥',0),(190640,5296,'he','×—×©×‘×•× ×•×ª ×”××—×¨×•× ×•×ª × ×›× ×¡×•',0),(190641,5296,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ Ï€Î¿Ï… ÎµÎ³Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹',0),(190642,5296,'zh','æœ€è¿‘è¾“å…¥çš„è´¦æˆ·\r\n',0),(190643,5296,'sv','Senaste konton in',0),(190644,5296,'it','Conti di recente entrati',0),(190645,5296,'tl','',0),(190646,5296,'th','&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3621;&#3657;&#3623;',0),(190647,5296,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤–à¤¾à¤¤à¥‹à¤‚ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(190648,5296,'ms','Hari akaun yang dimasukkan',0),(190649,5296,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø¯Ø®Ù„Ø© Ø­Ø¯ÙŠØ«Ø§',0),(190650,5296,'fr','RÃ©cents tÃ©moignages entrÃ©s',0),(190651,5296,'jp','æœ€è¿‘å…¥åŠ›ã?—ã?Ÿã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(190652,5296,'pt','Contas recentes entradas',0),(190653,5296,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»',0),(190654,5296,'es','Cuentas Entradas Recientemente',0),(190655,5296,'de','Den letzten Konten eingegeben',0),(190656,5296,'en','Recent Accounts Entered',0),(190657,5297,'is','',0),(190658,5297,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(190659,5297,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(190660,5297,'tr','Genel muhasebe hesabÄ± ekleme',0),(190661,5297,'pl','Dodaj konto ksiÄ™gowe ogÃ³lne',0),(190662,5297,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¾Ð±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(190663,5297,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(190664,5297,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(190665,5297,'vi','ThÃªm TK Sá»• CÃ¡i Tá»—ng Há»£p',0),(190666,5297,'af','Algemene Grootboek Rekening Byvoeg',0),(190667,5297,'ro','Adauga cont de contabilitate',0),(190668,5297,'et','Lisa pearaamatu konto',0),(190669,5297,'si','Dodaj General Ledger raÄun',0),(190670,5297,'ba','Menambahkan General Ledger Account',0),(190671,5297,'nl','General Ledger Account toevoegen',0),(190672,5297,'fi','LisÃ¤Ã¤ yleinen kirjanpitotili',0),(190673,5297,'no','Legge til General Ledger konto',0),(190674,5297,'da','TilfÃ¸je generelle finanskonto',0),(190675,5297,'ko','ì¼ë°˜ ë ˆì € ê³„ì •ì„ ì¶”ê°€í•©ë‹ˆë‹¤',0),(190676,5297,'he','×”×•×¡×£ ×—×©×‘×•×Ÿ ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™',0),(190677,5297,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï„Î·Ï‚ Î³ÎµÎ½Î¹ÎºÎ®Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚',0),(190678,5297,'zh','å¢žåŠ æ€»å¸çš„è³¬æˆ¶\r\n',0),(190679,5297,'sv','LÃ¤gga till allmÃ¤nna redovisningskonto',0),(190680,5297,'it','Aggiungi conto di contabilitÃ  generale',0),(190681,5297,'tl','',0),(190682,5297,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(190683,5297,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤–à¤¾à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(190684,5297,'ms','Menambah akaun Lejar Am',0),(190685,5297,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨ Ù„Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(190686,5297,'fr','Ajouter Compte Grand Livre',0),(190687,5297,'jp','ç·?å‹˜å®šå…ƒå¸³ã?®è¿½åŠ ',0),(190688,5297,'pt','Adicione a conta de contabilidade geral',0),(190689,5297,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð±Ñ‰ÐµÐ³Ð¾ Ð±ÑƒÑ…Ð³.',0),(190690,5297,'es','Agregar Cuenta de Libro Mayor General',0),(190691,5297,'de','General Ledger Konto hinzufÃ¼gen',0),(190692,5297,'en','Add General Ledger Account',0),(190693,5298,'is','',0),(190694,5298,'dr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(190695,5298,'pr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(190696,5298,'tr','Ã–zel frekans gÃ¼n',0),(190697,5298,'pl','CzÄ™stotliwoÅ›ci niestandardowe dni',0),(190698,5298,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ñ‡ÐµÑÑ‚Ð¾Ñ‚Ð° Ð´Ð½Ð¸',0),(190699,5298,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ ØªØ¹Ø¯Ø¯ Ø¯Ù†',0),(190700,5298,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ñƒ Ñ„Ñ€ÐµÐºÐ²ÐµÐ½Ñ†Ð¸Ñ˜Ñƒ Ð´Ð°Ð½Ð°',0),(190701,5298,'vi','Táº§n suáº¥t ngÃ y chá»‰nh sá»­a',0),(190702,5298,'af','Aangepasde Verekeningsdae',0),(190703,5298,'ro','Zile particularizatÄƒ frecvenÅ£Äƒ',0),(190704,5298,'et','Vali sagedus pÃ¤evades',0),(190705,5298,'si','Dni po meri pogostost',0),(190706,5298,'ba','Frekuensi kustom hari',0),(190707,5298,'nl','Aangepaste frequentie dagen',0),(190708,5298,'fi','Mukautetun taajuus pÃ¤ivÃ¤Ã¤',0),(190709,5298,'no','Egendefinerte frekvens dager',0),(190710,5298,'da','Brugerdefineret frekvens dage',0),(190711,5298,'ko','ì‚¬ìš©ìž ì§€ì • ì£¼íŒŒìˆ˜ ì¼',0),(190712,5298,'he','×ª×“×™×¨×•×ª ×ž×•×ª×× ××™×©×™×ª ×™×ž×™×',0),(190713,5298,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· ÏƒÏ…Ï‡Î½ÏŒÏ„Î·Ï„Î± Î·Î¼Î­ÏÎµÏ‚',0),(190714,5298,'zh','è‡ªå®šä¹‰é¢‘çŽ‡å¤©æ•°\r\n',0),(190715,5298,'sv','Anpassad frekvens dagar',0),(190716,5298,'it','Giorni di frequenza personalizzata',0),(190717,5298,'tl','',0),(190718,5298,'th','&#3588;&#3623;&#3634;&#3617;&#3606;&#3637;&#3656;&#3586;&#3629;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(190719,5298,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤†à¤µà¥ƒà¤¤à¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¥‹à¤‚',0),(190720,5298,'ms','Kekerapan adat hari',0),(190721,5298,'ar','Ø£ÙŠØ§Ù… ØªØ±Ø¯Ø¯ Ù…Ø®ØµØµ',0),(190722,5298,'fr','Jours de frÃ©quence personnalisÃ©',0),(190723,5298,'jp','é »åº¦ã‚’æ—¥æ•°ã?§ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚º',0),(190724,5298,'pt','Dias de freqÃ¼Ãªncia personalizada',0),(190725,5298,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ñ‡Ð°ÑÑ‚Ð¾Ñ‚Ñ‹ Ð´Ð½ÐµÐ¹',0),(190726,5298,'es','DÃ­as de Frecuencia Personalizados',0),(190727,5298,'de','Benutzerdefinierte Frequenz Tage',0),(190728,5298,'en','Custom Frequency Days',0),(190729,5299,'is','',0),(190730,5299,'dr','Ø±ÙˆØ²Ø§Ù†Ù‡ ',0),(190731,5299,'pr','Ø±ÙˆØ²Ø§Ù†Ù‡ ',0),(190732,5299,'tr','GÃ¼nlÃ¼k',0),(190733,5299,'pl','Codziennie',0),(190734,5299,'bg','Ð•Ð¶ÐµÐ´Ð½ÐµÐ²Ð½Ð¾',0),(190735,5299,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Û',0),(190736,5299,'sr','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº',0),(190737,5299,'vi','HÃ ng ngÃ y',0),(190738,5299,'af','Daagliks',0),(190739,5299,'ro','Zilnic',0),(190740,5299,'et','IgapÃ¤evane',0),(190741,5299,'si','Dnevni',0),(190742,5299,'ba','Harian',0),(190743,5299,'nl','Dagelijkse',0),(190744,5299,'fi','PÃ¤ivittÃ¤in',0),(190745,5299,'no','Daglig',0),(190746,5299,'da','Daglige',0),(190747,5299,'ko','ë§¤ì¼',0),(190748,5299,'he','×™×•×ž×™',0),(190749,5299,'el','ÎšÎ±Î¸Î·Î¼ÎµÏÎ¹Î½Î®',0),(190750,5299,'zh','æ¯æ—¥\r\n',0),(190751,5299,'sv','Dagliga',0),(190752,5299,'it','Giornaliero',0),(190753,5299,'tl','',0),(190754,5299,'th','&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;',0),(190755,5299,'hi','à¤¦à¥ˆà¤¨à¤¿à¤•',0),(190756,5299,'ms','Harian',0),(190757,5299,'ar','ÙŠÙˆÙ…ÙŠØ§',0),(190758,5299,'fr','Tous les jours',0),(190759,5299,'jp','æ¯Žæ—¥',0),(190760,5299,'pt','DiÃ¡rio',0),(190761,5299,'ru','Ð•Ð¶ÐµÐ´Ð½ÐµÐ²Ð½Ð¾',0),(190762,5299,'es','Diario',0),(190763,5299,'de','TÃ¤gliche',0),(190764,5299,'en','Daily',0),(190765,5300,'is','',0),(190766,5300,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(190767,5300,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(190768,5300,'tr','Hata ekleme Ã¶deme planÄ±',0),(190769,5300,'pl','BÅ‚Ä…d wstawiania pÅ‚atnoÅ›ci',0),(190770,5300,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½',0),(190771,5300,'ur','Ù†Ù‚Øµ Ù¾ÛŒÙ…Ù†Ù¹ Ù¾Ù„Ø§Ù† Ø¯Ø§Ø®Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(190772,5300,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµÐ¼ Ñ€Ð°Ñ‚Ðµ Ð³Ñ€ÐµÑˆÐºÐµ',0),(190773,5300,'vi','Lá»—i khi chÃ¨n káº¿ hoáº¡ch thanh toÃ¡n',0),(190774,5300,'af','Fout het ontstaan met die Invoeging van Betalingsplan',0),(190775,5300,'ro','Eroare inserarea Plan de platÄƒ',0),(190776,5300,'et','Viga lisamine maksegraafiku',0),(190777,5300,'si','Napaka Vstavljanje naÄrt plaÄil',0),(190778,5300,'ba','Kesalahan memasukkan rencana pembayaran',0),(190779,5300,'nl','Fout invoegen betalingsplan',0),(190780,5300,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ maksusuunnitelma',0),(190781,5300,'no','Feil sette betalingsplan',0),(190782,5300,'da','Fejl indsÃ¦tte betalingsplan',0),(190783,5300,'ko','ì˜¤ë¥˜ ì‚½ìž… ì§€ë¶ˆ ê³„íš',0),(190784,5300,'he','×©×’×™××” ×”×•×¡×¤×ª ×ª×•×›× ×™×ª ×ª×©×œ×•×ž×™×',0),(190785,5300,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(190786,5300,'zh','é”™è¯¯æ’å…¥ä»˜æ¬¾è®¡åˆ’',0),(190787,5300,'sv','Fel infoga betalningsplan',0),(190788,5300,'it','Errore inserimento piano di pagamento',0),(190789,5300,'tl','',0),(190790,5300,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(190791,5300,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¡à¤¾à¤²à¤¨à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾',0),(190792,5300,'ms','Kesilapan memasukkan bayaran pelan',0),(190793,5300,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¯Ø±Ø§Ø¬ Ø®Ø·Ø© Ø§Ù„Ø¯ÙØ¹',0),(190794,5300,'fr','Erreur insertion Plan de paiement',0),(190795,5300,'jp','æ”¯æ‰•è¨ˆç”»ã?®æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(190796,5300,'pt','Erro inserindo plano de pagamento',0),(190797,5300,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð’Ð²Ð¾Ð´Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð¾Ð³Ð¾ ÐŸÐ»Ð°Ð½Ð°',0),(190798,5300,'es','Error Insertando Plan de Pago',0),(190799,5300,'de','Fehler einfÃ¼gen Zahlungsplan',0),(190800,5300,'en','Error Inserting Payment Plan',0),(190801,5301,'is','',0),(190802,5301,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(190803,5301,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(190804,5301,'tr','Hata gÃ¼ncelleÅŸtirme Ã¶deme planÄ±',0),(190805,5301,'pl','BÅ‚Ä…d aktualizacji planu pÅ‚atnoÅ›ci',0),(190806,5301,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½',0),(190807,5301,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù¾ÛŒÙ…Ù†Ù¹ Ù¾Ù„Ø§Ù†',0),(190808,5301,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ€Ð°Ñ‚Ðµ',0),(190809,5301,'vi','Lá»—i cáº­p nháº­t káº¿ hoáº¡ch thanh toÃ¡n',0),(190810,5301,'af','Fout met Opdatering van Betalingsplan',0),(190811,5301,'ro','Eroare de actualizare Plan de platÄƒ',0),(190812,5301,'et','Viga ajakohastamine maksegraafiku',0),(190813,5301,'si','Napaka posodabljanje naÄrt plaÄil',0),(190814,5301,'ba','Kesalahan update rencana pembayaran',0),(190815,5301,'nl','Fout bijwerken betalingsplan',0),(190816,5301,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ maksusuunnitelma',0),(190817,5301,'no','Feil oppdatering betalingsplan',0),(190818,5301,'da','Fejl opdatering betalingsplan',0),(190819,5301,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì§€ë¶ˆ ê³„íš',0),(190820,5301,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×ª×•×›× ×™×ª ×ª×©×œ×•×ž×™×',0),(190821,5301,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ½Î¿Î½Ï„Î±Ï‚ ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(190822,5301,'zh','é”™è¯¯æ›´æ–°ä»˜æ¬¾è®¡åˆ’\r\n',0),(190823,5301,'sv','Fel uppdatering betalningsplan',0),(190824,5301,'it','Errore aggiornamento piano di pagamento',0),(190825,5301,'tl','',0),(190826,5301,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(190827,5301,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾',0),(190828,5301,'ms','Ralat pengemaskinian bayaran pelan',0),(190829,5301,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø®Ø·Ù‘Ø© Ø§Ù„ØªÙ‚Ø³ÙŠØ·',0),(190830,5301,'fr','Erreur mise Ã  jour Plan de paiement',0),(190831,5301,'jp','æ”¯æ‰•è¨ˆç”»ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(190832,5301,'pt','Plano de pagamento atualizaÃ§Ã£o erro',0),(190833,5301,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð¾Ð³Ð¾ ÐŸÐ»Ð°Ð½Ð°',0),(190834,5301,'es','Error Actualizando Plan de Pago',0),(190835,5301,'de','Fehler Update Zahlungsplan',0),(190836,5301,'en','Error Updating Payment Plan',0),(190837,5302,'is','',0),(190838,5302,'dr','ØªØ§Ø±ÙŠØ® Ø§ÙˆÙ„ÙŠÙ† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(190839,5302,'pr','ØªØ§Ø±ÙŠØ® Ø§ÙˆÙ„ÙŠÙ† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(190840,5302,'tr','Ä°lk Ã¶deme tarihi',0),(190841,5302,'pl','Pierwszy termin pÅ‚atnoÅ›ci',0),(190842,5302,'bg','ÐŸÑŠÑ€Ð²Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(190843,5302,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù¾ÛÙ„ÛŒ ØªØ§Ø±ÛŒØ®',0),(190844,5302,'sr','ÐŸÑ€Ð²Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(190845,5302,'vi','NgÃ y thanh toÃ¡n Äáº§u tiÃªn',0),(190846,5302,'af','Eerste Betaaldatum',0),(190847,5302,'ro','Prima data platii',0),(190848,5302,'et','Esimese osamakse kuupÃ¤ev',0),(190849,5302,'si','Prvi plaÄilni datum',0),(190850,5302,'ba','Pertama tanggal pembayaran',0),(190851,5302,'nl','Eerste betalingsdatum',0),(190852,5302,'fi','EnsimmÃ¤inen maksupÃ¤ivÃ¤',0),(190853,5302,'no','FÃ¸rste betalingsdato',0),(190854,5302,'da','FÃ¸rste betalingsdato',0),(190855,5302,'ko','ì²« ë²ˆì§¸ ì§€ë¶ˆ ë‚ ì§œ',0),(190856,5302,'he','×ª××¨×™×š ×ª×©×œ×•× ×¨××©×•×Ÿ',0),(190857,5302,'el','Î ÏÏŽÏ„Î· Î—Î¼/Î½Î¯Î± ÎµÎ¾ÏŒÏ†Î»Î·ÏƒÎ·Ï‚',0),(190858,5302,'zh','é¦–æ¬¡ä»˜æ¬¾æ—¥æœŸ\r\n',0),(190859,5302,'sv','FÃ¶rsta betalningsdatumet',0),(190860,5302,'it','Prima data di pagamento',0),(190861,5302,'tl','',0),(190862,5302,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;&#3649;&#3619;&#3585;',0),(190863,5302,'hi','à¤ªà¥à¤°à¤¥à¤® à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(190864,5302,'ms','Tarikh pembayaran pertama',0),(190865,5302,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹Ø© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(190866,5302,'fr','Date du premier versement',0),(190867,5302,'jp','æœ€åˆ?ã?®æ”¯æ‰•æ—¥',0),(190868,5302,'pt','Primeira data de pagamento',0),(190869,5302,'ru','Ð”Ð°Ñ‚Ð° ÐŸÐµÑ€Ð²Ð¾Ð³Ð¾ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(190870,5302,'es','Fecha de Primer Pago',0),(190871,5302,'de','Erste Zahlungstermin',0),(190872,5302,'en','First Payment Date',0),(190873,5303,'is','',0),(190874,5303,'dr','ØªÙƒØ±Ø§Ø±',0),(190875,5303,'pr','ØªÙƒØ±Ø§Ø±',0),(190876,5303,'tr','Frekans',0),(190877,5303,'pl','CzÄ™stotliwoÅ›Ä‡',0),(190878,5303,'bg','Ð§ÐµÑÑ‚Ð¾Ñ‚Ð°',0),(190879,5303,'ur','ØªØ¹Ø¯Ø¯',0),(190880,5303,'sr','Ð¤Ñ€ÐµÐºÐ²ÐµÐ½Ñ†Ð¸Ñ˜Ð°',0),(190881,5303,'vi','Táº§n Suáº¥t',0),(190882,5303,'af','Frekwensie',0),(190883,5303,'ro','FrecvenÅ£a',0),(190884,5303,'et','Sagedus',0),(190885,5303,'si','Pogostost',0),(190886,5303,'ba','Frekuensi',0),(190887,5303,'nl','Frequentie',0),(190888,5303,'fi','Taajuus',0),(190889,5303,'no','Frekvens',0),(190890,5303,'da','Frekvens',0),(190891,5303,'ko','ì£¼íŒŒìˆ˜',0),(190892,5303,'he','×ª×“×™×¨×•×ª',0),(190893,5303,'el','Î£Ï…Ï‡Î½ÏŒÏ„Î·Ï„Î±',0),(190894,5303,'zh','é¢‘çŽ‡\r\n',0),(190895,5303,'sv','Frekvens',0),(190896,5303,'it','Frequenza',0),(190897,5303,'tl','',0),(190898,5303,'th','&#3610;&#3656;&#3629;&#3618;',0),(190899,5303,'hi','à¤†à¤µà¥ƒà¤¤à¥à¤¤à¤¿',0),(190900,5303,'ms','Kekerapan',0),(190901,5303,'ar','Ø§Ù„ØªØ±Ø¯Ø¯',0),(190902,5303,'fr','FrÃ©quence',0),(190903,5303,'jp','é »åº¦',0),(190904,5303,'pt','FreqÃ¼Ãªncia',0),(190905,5303,'ru','Ð§Ð°ÑÑ‚Ð¾Ñ‚Ð°',0),(190906,5303,'es','frecuencia',0),(190907,5303,'de','Frequenz',0),(190908,5303,'en','Frequency',0),(190909,5304,'is','',0),(190910,5304,'dr','Ù…Ø§Ù‡Ø§Ù†Ù‡ ',0),(190911,5304,'pr','Ù…Ø§Ù‡Ø§Ù†Ù‡ ',0),(190912,5304,'tr','AylÄ±k',0),(190913,5304,'pl','MiesiÄ™czne',0),(190914,5304,'bg','ÐœÐµÑÐµÑ‡ÐµÐ½',0),(190915,5304,'ur','Ù…Ø§ÛØ§Ù†Û',0),(190916,5304,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¸',0),(190917,5304,'vi','HÃ ng thÃ¡ng',0),(190918,5304,'af','Maandliks',0),(190919,5304,'ro','Lunar',0),(190920,5304,'et','Igakuine',0),(190921,5304,'si','MeseÄno',0),(190922,5304,'ba','Bulanan',0),(190923,5304,'nl','Maandelijkse',0),(190924,5304,'fi','Kuukausittain',0),(190925,5304,'no','MÃ¥nedlig',0),(190926,5304,'da','MÃ¥nedlige',0),(190927,5304,'ko','ì›”ê°„',0),(190928,5304,'he','×—×•×“×©×™',0),(190929,5304,'el','ÎœÎ·Î½Î¹Î±Î¯Î±',0),(190930,5304,'zh','æ¯æœˆ\r\n',0),(190931,5304,'sv','MÃ¥natliga',0),(190932,5304,'it','Mensile',0),(190933,5304,'tl','',0),(190934,5304,'th','&#3619;&#3634;&#3618;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(190935,5304,'hi','à¤®à¤¾à¤¸à¤¿à¤•',0),(190936,5304,'ms','Bulanan',0),(190937,5304,'ar','Ø´Ù‡Ø±ÙŠØ§',0),(190938,5304,'fr','Mensuel',0),(190939,5304,'jp','æ¯Žæœˆ',0),(190940,5304,'pt','Mensal',0),(190941,5304,'ru','Ð•Ð¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ð¾',0),(190942,5304,'es','Mensual',0),(190943,5304,'de','Monatliche',0),(190944,5304,'en','Monthly',0),(190945,5305,'is','',0),(190946,5305,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± ÙƒØ±Ø¯Ù† ',0),(190947,5305,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± ÙƒØ±Ø¯Ù† ',0),(190948,5305,'tr','Fatura iÃ§in kaÃ§ kez',0),(190949,5305,'pl','Kilka razy do faktury',0),(190950,5305,'bg','Ð‘Ñ€Ð¾Ð¹ Ð¿ÑŠÑ‚Ð¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(190951,5305,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„Ø¦Û’ Ø§ÙˆÙ‚Ø§Øª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(190952,5305,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿ÑƒÑ‚Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(190953,5305,'vi','Sá»‘ thá»i gian cá»§a hÃ³a Ä‘Æ¡n',0),(190954,5305,'af','Aantal Kere vir Fakturering',0),(190955,5305,'ro','NumÄƒrul de ori la factura',0),(190956,5305,'et','Arvete esitamise kordade arv',0),(190957,5305,'si','Kolikokrat za fakturiranje',0),(190958,5305,'ba','Jumlah kali untuk faktur',0),(190959,5305,'nl','Aantal keren dat de factuur',0),(190960,5305,'fi','Laskun mÃ¤Ã¤rÃ¤',0),(190961,5305,'no','Antall faktura',0),(190962,5305,'da','Antal gange til faktura',0),(190963,5305,'ko','ì—¬ëŸ¬ ì†¡ìž¥ ë²ˆ',0),(190964,5305,'he','×ž×¡×¤×¨ ×”×¤×¢×ž×™× ×©×™×© ×—×©×‘×•× ×™×ª',0),(190965,5305,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(190966,5305,'zh','å‘ç¥¨æ¬¡æ•°\r\n',0),(190967,5305,'sv','Antal gÃ¥nger till faktura',0),(190968,5305,'it','Numero di volte per fattura',0),(190969,5305,'tl','',0),(190970,5305,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3588;&#3619;&#3633;&#3657;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(190971,5305,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤µà¤¸à¤°à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(190972,5305,'ms','Bilangan invois',0),(190973,5305,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ù…Ø±Ø§Øª Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(190974,5305,'fr','Nombre de fois Ã  facturer',0),(190975,5305,'jp','è«‹æ±‚å›žæ•°',0),(190976,5305,'pt','NÃºmero de vezes que a factura',0),(190977,5305,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ€Ð°Ð· Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð°',0),(190978,5305,'es','NÃºmero de Veces para Facturar',0),(190979,5305,'de','Oft auf Rechnung',0),(190980,5305,'en','Number of Times to Invoice',0),(190981,5306,'is','',0),(190982,5306,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(190983,5306,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(190984,5306,'tr','Ã–deme planÄ± ekleme',0),(190985,5306,'pl','DodaÄ‡ pÅ‚atnoÅ›ci',0),(190986,5306,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÑ…ÐµÐ¼Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(190987,5306,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(190988,5306,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° ÐŸÐ»Ð°Ð½',0),(190989,5306,'vi','ThÃªm Káº¿ hoáº¡ch Thanh ToÃ¡n',0),(190990,5306,'af','Betaling Plan Bygevoeg',0),(190991,5306,'ro','Adauga Plan de platÄƒ',0),(190992,5306,'et','Lisa maksegraafik',0),(190993,5306,'si','Dodaj naÄrt plaÄil',0),(190994,5306,'ba','Menambahkan rencana pembayaran',0),(190995,5306,'nl','Betalingsplan toevoegen',0),(190996,5306,'fi','Maksusuunnitelman lisÃ¤Ã¤',0),(190997,5306,'no','Betalingsplan legge',0),(190998,5306,'da','Betalingsplan tilfÃ¸je',0),(190999,5306,'ko','ì§€ë¶ˆ ê³„íšì„ ì¶”ê°€',0),(191000,5306,'he','×”×•×¡×¤×ª ×ª×•×›× ×™×ª ×ª×©×œ×•×',0),(191001,5306,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(191002,5306,'zh','ä»˜æ¬¾è®¡åˆ’æ–°å¢ž\r\n',0),(191003,5306,'sv','Betalningsplan lÃ¤gga till',0),(191004,5306,'it','Aggiungi piano di pagamento',0),(191005,5306,'tl','',0),(191006,5306,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(191007,5306,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤œà¥‹à¤¡à¤¼',0),(191008,5306,'ms','Pelan bayaran menambah',0),(191009,5306,'ar','Ø¥Ø¶Ø§ÙØ© Ø®Ø·Ø© Ø§Ù„Ø¯ÙØ¹',0),(191010,5306,'fr','Ajouter Plan de paiement',0),(191011,5306,'jp','æ”¯æ‰•è¨ˆç”»ã?®è¿½åŠ ',0),(191012,5306,'pt','Adicionar o plano de pagamento',0),(191013,5306,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½',0),(191014,5306,'es','Plan de Pago Agregar',0),(191015,5306,'de','Zahlungsplan hinzufÃ¼gen',0),(191016,5306,'en','Payment Plan Add',0),(191017,5307,'is','',0),(191018,5307,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø·Ø±Ø­ ',0),(191019,5307,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø·Ø±Ø­ ',0),(191020,5307,'tr','Plan fatura numarasÄ±',0),(191021,5307,'pl','Numer faktury planu',0),(191022,5307,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð° Ð¿Ð»Ð°Ð½',0),(191023,5307,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(191024,5307,'sr','ÐŸÐ»Ð°Ð½ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(191025,5307,'vi','Sá»‘ hÃ³a Ä‘Æ¡n káº¿ hoáº¡ch',0),(191026,5307,'af','Plan Faktuurnommer',0),(191027,5307,'ro','Planul numÄƒrul facturii',0),(191028,5307,'et','Graafiku arve number',0),(191029,5307,'si','Å tevilka raÄuna naÄrt',0),(191030,5307,'ba','Rencana faktur jumlah',0),(191031,5307,'nl','Plan factuurnummer',0),(191032,5307,'fi','Suunnitelma laskunumero',0),(191033,5307,'no','Planlegge fakturanummer',0),(191034,5307,'da','Planen fakturanummer',0),(191035,5307,'ko','ì†¡ìž¥ ë²ˆí˜¸ ê³„íš',0),(191036,5307,'he','×ª×•×›× ×™×ª ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(191037,5307,'el','Î£Ï‡Î­Î´Î¹Î¿ Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(191038,5307,'zh','è®¡åˆ’å‘ç¥¨å·ç \r\n',0),(191039,5307,'sv','Planera fakturanummer',0),(191040,5307,'it','Pianificare il numero di fattura',0),(191041,5307,'tl','',0),(191042,5307,'th','&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3651;&#3626;&#3656;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3656;',0),(191043,5307,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤¯à¥‹à¤œà¤¨à¤¾',0),(191044,5307,'ms','Pelan nombor invois',0),(191045,5307,'ar','Ø®Ø·Ø© Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(191046,5307,'fr','Plan numÃ©ro de facture',0),(191047,5307,'jp','è«‹æ±‚æ›¸ç•ªå?·ã?®è¨ˆç”»',0),(191048,5307,'pt','NÃºmero de fatura do plano',0),(191049,5307,'ru','ÐŸÐ»Ð°Ð½ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(191050,5307,'es','NÃºmero de Factura de Plan',0),(191051,5307,'de','Plan-Rechnungsnummer',0),(191052,5307,'en','Plan Invoice Number',0),(191053,5308,'is','',0),(191054,5308,'dr','Ù‡Ø± Ø³Ù‡ Ù…Ø§Ù‡ ÙŠÚ© Ø¨Ø§Ø±',0),(191055,5308,'pr','Ù‡Ø± Ø³Ù‡ Ù…Ø§Ù‡ ÙŠÚ© Ø¨Ø§Ø±',0),(191056,5308,'tr','ÃœÃ§ aylik',0),(191057,5308,'pl','Kwartalne',0),(191058,5308,'bg','Ð¢Ñ€Ð¸Ð¼ÐµÑÐµÑ‡Ð½Ð¸Ñ‚Ðµ',0),(191059,5308,'ur','Ø³Û Ù…Ø§ÛÛŒ',0),(191060,5308,'sr','ÐžÐ²Ð°Ñ˜ ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(191061,5308,'vi','Theo quÃ½',0),(191062,5308,'af','Kwartaaliks',0),(191063,5308,'ro','Trimestrial',0),(191064,5308,'et','Kvartaalne',0),(191065,5308,'si','ÄŒetrtletno',0),(191066,5308,'ba','Kuartalan',0),(191067,5308,'nl','Per kwartaal',0),(191068,5308,'fi','NeljÃ¤nnesvuosittain',0),(191069,5308,'no','Kvartalsvise',0),(191070,5308,'da','Kvartalsvis',0),(191071,5308,'ko','ë¶„ê¸°ë³„',0),(191072,5308,'he','×¨×‘×¢×•×Ÿ',0),(191073,5308,'el','Î¤ÏÎ¹Î¼Î·Î½Î¹Î±Î¯Î±',0),(191074,5308,'zh','æŒ‰å­£\r\n',0),(191075,5308,'sv','Quarterly',0),(191076,5308,'it','Trimestrale',0),(191077,5308,'tl','',0),(191078,5308,'th','&#3619;&#3634;&#3618;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;',0),(191079,5308,'hi','à¤¤à¥à¤°à¥ˆà¤®à¤¾à¤¸à¤¿à¤•',0),(191080,5308,'ms','Suku tahunan',0),(191081,5308,'ar','Ø±Ø¨Ø¹ Ø³Ù†ÙˆÙŠ',0),(191082,5308,'fr','Trimestriel',0),(191083,5308,'jp','æ¯ŽæœŸ',0),(191084,5308,'pt','PublicaÃ§Ã£o trimestral',0),(191085,5308,'ru','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»ÑŒÐ½Ð¾',0),(191086,5308,'es','Trimestral',0),(191087,5308,'de','VierteljÃ¤hrlich',0),(191088,5308,'en','Quarterly',0),(191089,5309,'is','',0),(191090,5309,'dr','Ù‡ÙØªÚ¯ÙŠ',0),(191091,5309,'pr','Ù‡ÙØªÚ¯ÙŠ',0),(191092,5309,'tr','HaftalÄ±k',0),(191093,5309,'pl','Tygodniowy',0),(191094,5309,'bg','Ð¡ÐµÐ´Ð¼Ð¸Ñ‡ÐµÐ½',0),(191095,5309,'ur','ÛÙØªÛ ÙˆØ§Ø±',0),(191096,5309,'sr','Ð¡ÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð¾',0),(191097,5309,'vi','HÃ ng tuáº§n',0),(191098,5309,'af','Weekliks',0),(191099,5309,'ro','SÄƒptÄƒmÃ¢nal',0),(191100,5309,'et','IganÃ¤dalane',0),(191101,5309,'si','Tedenski',0),(191102,5309,'ba','Mingguan',0),(191103,5309,'nl','Per',0),(191104,5309,'fi','Viikoittain',0),(191105,5309,'no','Ukentlig',0),(191106,5309,'da','Ugentlige',0),(191107,5309,'ko','ì£¼ê°„',0),(191108,5309,'he','×©×‘×•×¢×™',0),(191109,5309,'el','Î•Î²Î´Î¿Î¼Î±Î´Î¹Î±Î¯Î±',0),(191110,5309,'zh','æ¯å‘¨\r\n',0),(191111,5309,'sv','Varje vecka',0),(191112,5309,'it','Settimanale',0),(191113,5309,'tl','',0),(191114,5309,'th','&#3619;&#3634;&#3618;&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(191115,5309,'hi','à¤¸à¤¾à¤ªà¥à¤¤à¤¾à¤¹à¤¿à¤•',0),(191116,5309,'ms','Mingguan',0),(191117,5309,'ar','Ø§Ù„ØªÙ†Ø²ÙŠÙ„Ø§Øª',0),(191118,5309,'fr','Hebdomadaire',0),(191119,5309,'jp','æ¯Žé€±',0),(191120,5309,'pt','Semanal',0),(191121,5309,'ru','ÐÐµÐ´ÐµÐ»ÑŒÐ½Ñ‹Ð¹',0),(191122,5309,'es','Semanalmente',0),(191123,5309,'de','Pro',0),(191124,5309,'en','Weekly',0),(191125,5310,'is','',0),(191126,5310,'dr','Ø³Ø§Ù„Ø§Ù†Ù‡',0),(191127,5310,'pr','Ø³Ø§Ù„Ø§Ù†Ù‡',0),(191128,5310,'tr','YÄ±llÄ±k',0),(191129,5310,'pl','Roczne',0),(191130,5310,'bg','Ð•Ð¶ÐµÐ³Ð¾Ð´Ð½Ð¾',0),(191131,5310,'ur','Ø³Ø§Ù„Ø§Ù†Û',0),(191132,5310,'sr','Ð“Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(191133,5310,'vi','HÃ ng nÄƒm',0),(191134,5310,'af','Jaarliks',0),(191135,5310,'ro','Anual',0),(191136,5310,'et','Iga-aastane',0),(191137,5310,'si','Letno',0),(191138,5310,'ba','Tahunan',0),(191139,5310,'nl','Jaarlijks',0),(191140,5310,'fi','Vuosittain',0),(191141,5310,'no','Ã…rlig',0),(191142,5310,'da','Hvert Ã¥r',0),(191143,5310,'ko','í•´ë§ˆë‹¤',0),(191144,5310,'he','×©× ×ª×™',0),(191145,5310,'el','Î•Ï„Î®ÏƒÎ¹Î¿Ï…',0),(191146,5310,'zh','æ¯å¹´\r\n',0),(191147,5310,'sv','Ã…rligt',0),(191148,5310,'it','Annuale',0),(191149,5310,'tl','',0),(191150,5310,'th','&#3619;&#3634;&#3618;&#3611;&#3637;',0),(191151,5310,'hi','à¤µà¤¾à¤°à¥à¤·à¤¿à¤•',0),(191152,5310,'ms','Tahunan',0),(191153,5310,'ar','Ø³Ù†ÙˆÙŠØ§',0),(191154,5310,'fr','Tous les ans',0),(191155,5310,'jp','æ¯Žå¹´',0),(191156,5310,'pt','Anual',0),(191157,5310,'ru','Ð“Ð¾Ð´Ð¾Ð²Ð¾Ð¹',0),(191158,5310,'es','Anualmente',0),(191159,5310,'de','JÃ¤hrlich',0),(191160,5310,'en','Yearly',0),(191161,5311,'is','',0),(191162,5311,'dr','Ø±ÙˆÙŠ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª  Ø¬Ù‡Øª ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(191163,5311,'pr','Ø±ÙˆÙŠ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª  Ø¬Ù‡Øª ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(191164,5311,'tr','Ã–deme planÄ± dÃ¼zenlemek iÃ§in tÄ±klatÄ±n',0),(191165,5311,'pl','Kliknij na Plan pÅ‚atnoÅ›ci do edycji',0),(191166,5311,'bg','ÐšÐ»Ð¸ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(191167,5311,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(191168,5311,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ñ€Ð°Ñ‚Ðµ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(191169,5311,'vi','Nháº¥n VÃ o Káº¿ Hoáº¡ch Thanh ToÃ¡n Äá»ƒ Sá»­a',0),(191170,5311,'af','Kliek op Betalingsplan om te Redigeer',0),(191171,5311,'ro','FaceÅ£i clic pe Plan de platÄƒ pentru a edita',0),(191172,5311,'et','KlÃµpsa maksegraafikule, et seda muuta',0),(191173,5311,'si','Kliknite na plaÄilni naÄrt za urejanje',0),(191174,5311,'ba','Klik pada rencana pembayaran ke Edit',0),(191175,5311,'nl','Klik op betalingsplan te bewerken',0),(191176,5311,'fi','Klikkaa Muokkaa maksusuunnitelma',0),(191177,5311,'no','Klikk pÃ¥ betalingsplan Ã¥ redigere',0),(191178,5311,'da','Klik pÃ¥ betalingsplan til Rediger',0),(191179,5311,'ko','ì§€ë¶ˆ ê³„íš íŽ¸ì§‘ì„ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(191180,5311,'he','×œ×—×¥ ×¢×œ ×ª×•×›× ×™×ª ×ª×©×œ×•×ž×™× ×›×“×™ ×¢×¨×™×›×”',0),(191181,5311,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ ÏƒÏ„Î¿ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(191182,5311,'zh','ç‚¹å‡»ç¼´æ¬¾è®¡åˆ’ç¼–è¾‘\r\n',0),(191183,5311,'sv','Klicka pÃ¥ avbetalningsplan till redigera',0),(191184,5311,'it','Fare clic su piano di pagamento per modifica',0),(191185,5311,'tl','',0),(191186,5311,'th','&#3588;&#3621;&#3636;&#3585;&#3610;&#3609;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(191187,5311,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(191188,5311,'ms','Klik pada pelan bayaran untuk Edit',0),(191189,5311,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø¹Ù„Ù‰ Ø®Ø·Ø© Ø§Ù„Ø¯ÙØ¹ Ù„ØªØ­Ø±ÙŠØ±',0),(191190,5311,'fr','Cliquez sur le Plan de paiement Ã  modifier',0),(191191,5311,'jp','æ”¯æ‰•è¨ˆç”»ã‚’ç·¨é›†ã?™ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(191192,5311,'pt','Clique no plano de pagamento para editar',0),(191193,5311,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð½Ð° ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½ Ð´Ð»Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(191194,5311,'es','Click sobre Plan de Pago para Editar',0),(191195,5311,'de','Klicken Sie auf Zahlungsplan zu bearbeiten',0),(191196,5311,'en','Click on Payment Plan to Edit',0),(191197,5312,'is','',0),(191198,5312,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(191199,5312,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(191200,5312,'tr','Ã–zel gÃ¼n',0),(191201,5312,'pl','Niestandardowe dni',0),(191202,5312,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð´Ð½Ð¸',0),(191203,5312,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¯Ù†',0),(191204,5312,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¸ Ð´Ð°Ð½Ð°',0),(191205,5312,'vi','NgÃ y tá»± táº¡o',0),(191206,5312,'af','Aangepasde Dae',0),(191207,5312,'ro','Zile particularizatÄƒ',0),(191208,5312,'et','Kohandatud pÃ¤eva',0),(191209,5312,'si','Dni po meri',0),(191210,5312,'ba','Kustom hari',0),(191211,5312,'nl','Aangepaste dagen',0),(191212,5312,'fi','Mukautetun pÃ¤ivÃ¤',0),(191213,5312,'no','Egendefinerte dager',0),(191214,5312,'da','Brugerdefinerede dage',0),(191215,5312,'ko','ì‚¬ìš©ìž ì§€ì • ì¼',0),(191216,5312,'he','×™×ž×™× ×ž×•×ª×× ××™×©×™×ª',0),(191217,5312,'el','ÎˆÎ¸Î¹Î¼Î¿ Î·Î¼Î­ÏÎµÏ‚',0),(191218,5312,'zh','è‡ªå®šä¹‰å¤©æ•°\r\n',0),(191219,5312,'sv','Egna dagar',0),(191220,5312,'it','Giorni personalizzati',0),(191221,5312,'tl','',0),(191222,5312,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(191223,5312,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤¦à¤¿à¤¨à¥‹à¤‚',0),(191224,5312,'ms','Adat hari',0),(191225,5312,'ar','Ø£ÙŠØ§Ù… Ù…Ø®ØµØµØ©',0),(191226,5312,'fr','Jours personnalisÃ©s',0),(191227,5312,'jp','æ—¥æ•°ã?®ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚º',0),(191228,5312,'pt','Dias personalizados',0),(191229,5312,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ð´Ð½ÐµÐ¹',0),(191230,5312,'es','DÃ­as Personalizados',0),(191231,5312,'de','Benutzerdefinierte Tage',0),(191232,5312,'en','Custom Days',0),(191233,5313,'is','',0),(191234,5313,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191235,5313,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191236,5313,'tr','Hata silme Ã¶deme planÄ±',0),(191237,5313,'pl','BÅ‚Ä…d usuwania pÅ‚atnoÅ›ci',0),(191238,5313,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½',0),(191239,5313,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ù¾ÛŒÙ…Ù†Ù¹ Ù¾Ù„Ø§Ù†',0),(191240,5313,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ€Ð°Ñ‚Ðµ',0),(191241,5313,'vi','Lá»—i xÃ³a káº¿ hoáº¡ch thanh toÃ¡n',0),(191242,5313,'af','Fout het ontstaan met die Skraping van Betalingsplan',0),(191243,5313,'ro','Eroare ÅŸtergerea Plan de platÄƒ',0),(191244,5313,'et','TÃµrge kustutamisel maksegraafiku',0),(191245,5313,'si','Napaka brisanja naÄrt plaÄil',0),(191246,5313,'ba','Rencana pembayaran menghapus kesalahan',0),(191247,5313,'nl','Fout verwijderen betalingsplan',0),(191248,5313,'fi','Virhe poistettaessa maksusuunnitelma',0),(191249,5313,'no','Feil slette betalingsplan',0),(191250,5313,'da','Fejl slette betalingsplan',0),(191251,5313,'ko','ì˜¤ë¥˜ ì‚­ì œ ì§€ë¶ˆ ê³„íš',0),(191252,5313,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ª×•×›× ×™×ª ×ª×©×œ×•×ž×™×',0),(191253,5313,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(191254,5313,'zh','é”™è¯¯åˆ é™¤ä»˜æ¬¾è®¡åˆ’',0),(191255,5313,'sv','Misstag utplÃ¥nande betalningsplan',0),(191256,5313,'it','Errore eliminazione piano di pagamento',0),(191257,5313,'tl','',0),(191258,5313,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(191259,5313,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾',0),(191260,5313,'ms','Ralat Menghapuskan bayaran pelan',0),(191261,5313,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø®Ø·Ù‘Ø© Ø§Ù„ØªÙ‚Ø³ÙŠØ·',0),(191262,5313,'fr','Erreur suppression Plan de paiement',0),(191263,5313,'jp','æ”¯æ‰•è¨ˆç”»ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(191264,5313,'pt','Erro excluindo plano de pagamento',0),(191265,5313,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð¾Ð³Ð¾ ÐŸÐ»Ð°Ð½Ð°',0),(191266,5313,'es','Error Eliminando Plan de Pago',0),(191267,5313,'de','Fehler lÃ¶schen Zahlungsplan',0),(191268,5313,'en','Error Deleting Payment Plan',0),(191269,5314,'is','',0),(191270,5314,'dr','ØªØ§Ø±ÙŠØ® Ø§ÙˆÙ„ÙŠÙ† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191271,5314,'pr','ØªØ§Ø±ÙŠØ® Ø§ÙˆÙ„ÙŠÙ† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191272,5314,'tr','Ä°lk Ã¶deme tarihi',0),(191273,5314,'pl','Pierwszy termin pÅ‚atnoÅ›ci',0),(191274,5314,'bg','ÐŸÑŠÑ€Ð²Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(191275,5314,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù¾ÛÙ„ÛŒ ØªØ§Ø±ÛŒØ®',0),(191276,5314,'sr','ÐŸÑ€Ð²Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(191277,5314,'vi','NgÃ y thanh toÃ¡n Äáº§u tiÃªn',0),(191278,5314,'af','Eerste Betaaldatum',0),(191279,5314,'ro','Prima data platii',0),(191280,5314,'et','Esimene maksekuupÃ¤ev',0),(191281,5314,'si','Prvi plaÄilni datum',0),(191282,5314,'ba','Pertama tanggal pembayaran',0),(191283,5314,'nl','Eerste betalingsdatum',0),(191284,5314,'fi','EnsimmÃ¤inen maksupÃ¤ivÃ¤',0),(191285,5314,'no','FÃ¸rste betalingsdato',0),(191286,5314,'da','FÃ¸rste betalingsdato',0),(191287,5314,'ko','ì²« ë²ˆì§¸ ì§€ë¶ˆ ë‚ ì§œ',0),(191288,5314,'he','×ª××¨×™×š ×ª×©×œ×•× ×¨××©×•×Ÿ',0),(191289,5314,'el','Î ÏÏŽÏ„Î· Î—Î¼/Î½Î¯Î± ÎµÎ¾ÏŒÏ†Î»Î·ÏƒÎ·Ï‚',0),(191290,5314,'zh','é¦–æ¬¡ä»˜æ¬¾æ—¥æœŸ\r\n',0),(191291,5314,'sv','FÃ¶rsta betalningsdatumet',0),(191292,5314,'it','Prima data di pagamento',0),(191293,5314,'tl','',0),(191294,5314,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;&#3649;&#3619;&#3585;',0),(191295,5314,'hi','à¤ªà¥à¤°à¤¥à¤® à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(191296,5314,'ms','Tarikh pembayaran pertama',0),(191297,5314,'ar','Ø§Ù„Ø£ÙˆÙ„Ù‰ Ù…Ù† ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹',0),(191298,5314,'fr','Date du premier versement',0),(191299,5314,'jp','æœ€åˆ?ã?®æ”¯æ‰•ã?„æ—¥',0),(191300,5314,'pt','Primeira data de pagamento',0),(191301,5314,'ru','Ð”Ð°Ñ‚Ð° ÐŸÐµÑ€Ð²Ð¾Ð³Ð¾ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(191302,5314,'es','Fecha de Primer Pago',0),(191303,5314,'de','Erste Zahlungstermin',0),(191304,5314,'en','First Payment Date',0),(191305,5315,'is','',0),(191306,5315,'dr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(191307,5315,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(191308,5315,'tr','OluÅŸturulan faturalarÄ±',0),(191309,5315,'pl','Faktury generowane',0),(191310,5315,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¿Ð¾',0),(191311,5315,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ù¾ÛŒØ¯Ø§',0),(191312,5315,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ Ð³ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ð½',0),(191313,5315,'vi','ÄÃ£ táº¡o HÃ³a Ä‘Æ¡n',0),(191314,5315,'af','Fakture Gegenereer',0),(191315,5315,'ro','Facturi generate',0),(191316,5315,'et','Loodud arved',0),(191317,5315,'si','RaÄunov, ustvarjenih',0),(191318,5315,'ba','Faktur yang dihasilkan',0),(191319,5315,'nl','Facturen gegenereerd',0),(191320,5315,'fi','Luotujen laskujen',0),(191321,5315,'no','Fakturaer generert',0),(191322,5315,'da','Fakturaer genereres',0),(191323,5315,'ko','ì†¡ìž¥ ìƒì„±',0),(191324,5315,'he','×—×©×‘×•× ×™×•×ª ×©× ×•×¦×¨×•',0),(191325,5315,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½Ï„Î±Î¹',0),(191326,5315,'zh','å‘ç¥¨ç”Ÿæˆ\r\n',0),(191327,5315,'sv','Fakturor genereras',0),(191328,5315,'it','Fatture generate',0),(191329,5315,'tl','',0),(191330,5315,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3638;&#3657;&#3609;',0),(191331,5315,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨',0),(191332,5315,'ms','Invois-invois yang dihasilkan',0),(191333,5315,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§',0),(191334,5315,'fr','Factures gÃ©nÃ©rÃ©es',0),(191335,5315,'jp','ä½œã‚Šå‡ºã?•ã‚Œã?Ÿè«‹æ±‚æ›¸',0),(191336,5315,'pt','Facturas geradas',0),(191337,5315,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ ÑÐ¾Ð·Ð´Ð°ÑŽÑ‚ÑÑ',0),(191338,5315,'es','Facturas Generadas',0),(191339,5315,'de','Erstellten Rechnungen',0),(191340,5315,'en','Invoices Generated',0),(191341,5316,'is','',0),(191342,5316,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¯Ù‡ÙŠ Ø¨Ø¹Ø¯ÙŠ ',0),(191343,5316,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¯Ù‡ÙŠ Ø¨Ø¹Ø¯ÙŠ ',0),(191344,5316,'tr','Bir sonraki Ã¶deme nedeniyle',0),(191345,5316,'pl','NastÄ™pne pÅ‚atnoÅ›ci',0),(191346,5316,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð¾Ñ€Ð°Ð´Ð¸',0),(191347,5316,'ur','Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ø§Ú¯Ù„Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(191348,5316,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð¿Ñ€Ð¸ÑÐ¿ÐµÑ›Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(191349,5316,'vi','Äáº¿n háº¡n thanh toÃ¡n tiáº¿p',0),(191350,5316,'af','Volgende Betaling Betaalbaar',0),(191351,5316,'ro','Viitoare de plata datorate',0),(191352,5316,'et','JÃ¤rgmine maksetÃ¤htaeg',0),(191353,5316,'si','Naslednji plaÄilo',0),(191354,5316,'ba','Pembayaran berikutnya',0),(191355,5316,'nl','Volgende bedrag verschuldigd zijn op',0),(191356,5316,'fi','Seuraavan maksun erÃ¤pÃ¤ivÃ¤',0),(191357,5316,'no','Neste forfallsdatoen',0),(191358,5316,'da','NÃ¦ste betaling skyldes',0),(191359,5316,'ko','ë‹¤ìŒ ì§€ë¶ˆ ê¸°í•œ',0),(191360,5316,'he','×”×ª×©×œ×•× ×”×‘× ×‘×©×œ',0),(191361,5316,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Ï€Î»Î·ÏÏ‰Î¼Î®',0),(191362,5316,'zh','ä¸‹ä¸€ç¼´æ¬¾æˆªè‡³\r\n',0),(191363,5316,'sv','NÃ¤sta betalning',0),(191364,5316,'it','Successivo pagamento dovuto',0),(191365,5316,'tl','',0),(191366,5316,'th','&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3594;&#3635;&#3619;&#3632;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(191367,5316,'hi','à¤•à¤¾à¤°à¤£ à¤…à¤—à¤²à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(191368,5316,'ms','Pembayaran seterusnya',0),(191369,5316,'ar','Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù‚Ø§Ø¯Ù…Ø©',0),(191370,5316,'fr','Prochaine Ã©chÃ©ance',0),(191371,5316,'jp','æ¬¡ã?®æ”¯æ‰•ã?„æœŸé™?',0),(191372,5316,'pt','PrÃ³ximo pagamento devido',0),(191373,5316,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ³Ð¾ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(191374,5316,'es','PrÃ³ximo Pago Debido',0),(191375,5316,'de','NÃ¤chste FÃ¤lligkeit',0),(191376,5316,'en','Next Payment Due',0),(191377,5317,'is','',0),(191378,5317,'dr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¹Ø¯ÙŠ ',0),(191379,5317,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¹Ø¯ÙŠ ',0),(191380,5317,'tr','Sonraki Ã¶deme vade tarihi',0),(191381,5317,'pl','NastÄ™pne pÅ‚atnoÅ›ci termin',0),(191382,5317,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶',0),(191383,5317,'ur','Ø§Ú¯Ù„Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ ØªØ§Ø±ÛŒØ®',0),(191384,5317,'sr','Ð Ð°Ñ‚Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(191385,5317,'vi','NgÃ y Ä‘áº¿n háº¡n thanh toÃ¡n tiáº¿p',0),(191386,5317,'af','Volgende Verskuldige Betaaldatum',0),(191387,5317,'ro','Viitoare de plata data scadenÅ£ei',0),(191388,5317,'et','JÃ¤rgmine maksetÃ¤htaeg',0),(191389,5317,'si','Naslednji plaÄilni rok',0),(191390,5317,'ba','Pembayaran berikutnya tanggal jatuh tempo',0),(191391,5317,'nl','Volgende betaling vervaldatum',0),(191392,5317,'fi','Seuraavan maksun erÃ¤pÃ¤ivÃ¤',0),(191393,5317,'no','Neste utbetaling forfallsdatoen',0),(191394,5317,'da','NÃ¦ste betaling forfaldsdatoen',0),(191395,5317,'ko','ë‹¤ìŒ ì§€ë¶ˆ ê¸°í•œ',0),(191396,5317,'he','×”×ª×©×œ×•× ×”×‘× ×ª××¨×™×š ×™×¢×“',0),(191397,5317,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Ï€Î»Î·ÏÏ‰Î¼Î® Î—Î¼/Î½Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(191398,5317,'zh','ä¸‹ä¸€æ¬¡çš„ä»˜æ¬¾åˆ°æœŸæ—¥\r\n',0),(191399,5317,'sv','NÃ¤sta betalning fÃ¶rfallodatum',0),(191400,5317,'it','Pagamento di prossima scadenza',0),(191401,5317,'tl','',0),(191402,5317,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(191403,5317,'hi','à¤…à¤—à¤²à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(191404,5317,'ms','Tempoh tarikh akhir',0),(191405,5317,'ar','Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù‚Ø§Ø¯Ù…Ø© ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(191406,5317,'fr','Prochain paiement Date d\'Ã©chÃ©ance',0),(191407,5317,'jp','æ¬¡ã?®æ”¯æ‰•æœŸæ—¥',0),(191408,5317,'pt','Pagamento na prÃ³xima data de vencimento',0),(191409,5317,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ Ð”Ð°Ñ‚Ð°',0),(191410,5317,'es','Fecha de PrÃ³ximo Pago Debido',0),(191411,5317,'de','NÃ¤chste Zahlung fÃ¤llig am',0),(191412,5317,'en','Next Payment Due Date',0),(191413,5318,'is','',0),(191414,5318,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª',0),(191415,5318,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª',0),(191416,5318,'tr','KaÃ§ kez',0),(191417,5318,'pl','Ile razy',0),(191418,5318,'bg','Ð‘Ñ€Ð¾Ð¹ Ð¿ÑŠÑ‚Ð¸',0),(191419,5318,'ur','Ø§ÙˆÙ‚Ø§Øª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(191420,5318,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿ÑƒÑ‚Ð°',0),(191421,5318,'vi','Sá»‘ thá»i gian',0),(191422,5318,'af','Aantal Kere',0),(191423,5318,'ro','NumÄƒrul de ori',0),(191424,5318,'et','Mitu korda',0),(191425,5318,'si','Kolikokrat',0),(191426,5318,'ba','Jumlah kali',0),(191427,5318,'nl','Aantal keren',0),(191428,5318,'fi','Monta kertaa',0),(191429,5318,'no','Antall ganger',0),(191430,5318,'da','Antal gange',0),(191431,5318,'ko','ì—¬ëŸ¬ ë²ˆ',0),(191432,5318,'he','×ž×¡×¤×¨ ×¤×¢×ž×™×',0),(191433,5318,'el','Î ÏŒÏƒÎµÏ‚ Ï†Î¿ÏÎ­Ï‚',0),(191434,5318,'zh','æ¬¡æ•°\r\n',0),(191435,5318,'sv','Antal gÃ¥nger',0),(191436,5318,'it','Numero di volte',0),(191437,5318,'tl','',0),(191438,5318,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(191439,5318,'hi','à¤•à¤ˆ à¤¬à¤¾à¤°',0),(191440,5318,'ms','Bilangan kali',0),(191441,5318,'ar','Ø¹Ø¯Ø¯ Ù…Ø±Ø§Øª',0),(191442,5318,'fr','Nombre de fois',0),(191443,5318,'jp','å›žæ•°',0),(191444,5318,'pt','NÃºmero de vezes',0),(191445,5318,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ€Ð°Ð·',0),(191446,5318,'es','NÃºmero de Veces',0),(191447,5318,'de','Einige Male',0),(191448,5318,'en','Number of Times',0),(191449,5319,'is','',0),(191450,5319,'dr','Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(191451,5319,'pr','Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(191452,5319,'tr','Ã–deme planÄ± baÅŸarÄ±yla silindi',0),(191453,5319,'pl','Plan pÅ‚atnoÅ›ci przesâ”‚anie',0),(191454,5319,'bg','Ð¡Ñ…ÐµÐ¼Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(191455,5319,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø§ Ù¾Ù„Ø§Ù† Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(191456,5319,'sr','Ð Ð°Ñ‚Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(191457,5319,'vi','XÃ³a Káº¿ hoáº¡ch Thanh ToÃ¡n thÃ nh cÃ´ng',0),(191458,5319,'af','Betaling Plan Suksesvol Geskrap',0),(191459,5319,'ro','Plan de platÄƒ eliminÄƒ cu succes',0),(191460,5319,'et','Maksegraafik kustutati edukalt',0),(191461,5319,'si','NaÄrt plaÄil uspeÅ¡no izbrisana',0),(191462,5319,'ba','Rencana pembayaran yang berhasil dihapus',0),(191463,5319,'nl','Betalingsplan met succes verwijderd',0),(191464,5319,'fi','Maksusuunnitelman poistettu',0),(191465,5319,'no','Betalingsplan slettet',0),(191466,5319,'da','Betalingsplan slettet',0),(191467,5319,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ì§€ë¶ˆ ê³„íš',0),(191468,5319,'he','×ª×•×›× ×™×ª ×ª×©×œ×•×ž×™× × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(191469,5319,'el','Î£Ï‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(191470,5319,'zh','ä»˜æ¬¾è®¡åˆ’å·²æˆåŠŸåˆ é™¤\r\n',0),(191471,5319,'sv','Betalningsplan raderades',0),(191472,5319,'it','Piano di pagamento eliminato con successo',0),(191473,5319,'tl','',0),(191474,5319,'th','&#3621;&#3610;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(191475,5319,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(191476,5319,'ms','Pelan pembayaran yang dihapuskan dengan jayanya',0),(191477,5319,'ar','Ø­Ø°ÙØª Ø®Ø·Ù‘Ø© Ø§Ù„ØªÙ‚Ø³ÙŠØ· Ø¨Ù†Ø¬Ø§Ø­',0),(191478,5319,'fr','Plan de paiement supprimÃ© avec succÃ¨s',0),(191479,5319,'jp','æ”¯æ‰•è¨ˆç”»ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(191480,5319,'pt','Plano de pagamento excluÃ­do com sucesso',0),(191481,5319,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿Ð»Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½',0),(191482,5319,'es','Plan de Pago eliminado exitosamente',0),(191483,5319,'de','Zahlungsplan erfolgreich gelÃ¶scht',0),(191484,5319,'en','Payment plan deleted successfully',0),(191485,5320,'is','',0),(191486,5320,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191487,5320,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191488,5320,'tr','Ã–deme planÄ± gÃ¼ncelleme',0),(191489,5320,'pl','Aktualizacja planu pÅ‚atnoÅ›ci',0),(191490,5320,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(191491,5320,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(191492,5320,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð»Ð°Ð½Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(191493,5320,'vi','Cáº­p Nháº­t Káº¿ Hoáº¡ch Thanh ToÃ¡n',0),(191494,5320,'af','Betaling Plan Opdateer',0),(191495,5320,'ro','Actualizare de Plan de platÄƒ',0),(191496,5320,'et','Maksegraafiku uuendamine',0),(191497,5320,'si','PlaÄilo naÄrt posodobitev',0),(191498,5320,'ba','Update rencana pembayaran',0),(191499,5320,'nl','Betaling Plan Update',0),(191500,5320,'fi','Maksu suunnitelman pÃ¤ivitys',0),(191501,5320,'no','Betaling Plan oppdatering',0),(191502,5320,'da','Betalingen planen opdatering',0),(191503,5320,'ko','ì§€ë¶ˆ ê³„íš ì—…ë°ì´íŠ¸',0),(191504,5320,'he','×¢×“×›×•×Ÿ ×ª×•×›× ×™×ª ×ª×©×œ×•×',0),(191505,5320,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(191506,5320,'zh','ä»˜æ¬¾è®¡åˆ’æ›´æ–°\r\n',0),(191507,5320,'sv','Betalning Plan uppdatering',0),(191508,5320,'it','Aggiornamento del piano di pagamento',0),(191509,5320,'tl','',0),(191510,5320,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(191511,5320,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(191512,5320,'ms','Mengemaskini pelan pembayaran',0),(191513,5320,'ar','ØªØ­Ø¯ÙŠØ« Ø®Ø·Ø· Ø§Ù„ØªÙ‚Ø³ÙŠØ·',0),(191514,5320,'fr','Mise Ã  jour du Plan de paiement',0),(191515,5320,'jp','æ”¯æ‰•è¨ˆç”»ã?®æ›´æ–°',0),(191516,5320,'pt','AtualizaÃ§Ã£o de plano de pagamento',0),(191517,5320,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½',0),(191518,5320,'es','Plan de Pago actualizar',0),(191519,5320,'de','Zahlung Plan Update',0),(191520,5320,'en','Payment Plan Update',0),(191521,5321,'is','',0),(191522,5321,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191523,5321,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191524,5321,'tr','Ã–deme planÄ± numarasÄ±',0),(191525,5321,'pl','Numer Plan pÅ‚atnoÅ›ci',0),(191526,5321,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½',0),(191527,5321,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(191528,5321,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐŸÐ»Ð°Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(191529,5321,'vi','Káº¿ hoáº¡ch Thanh ToÃ¡n sá»‘',0),(191530,5321,'af','Betalingsplan Faktuurnommer',0),(191531,5321,'ro','NumÄƒrul de Plan de platÄƒ',0),(191532,5321,'et','Maksegraafiku number',0),(191533,5321,'si','Å tevilka naÄrta plaÄila',0),(191534,5321,'ba','Nomor rencana pembayaran',0),(191535,5321,'nl','Plattegrond, nr. betaling',0),(191536,5321,'fi','Maksun suunnitelman numero',0),(191537,5321,'no','Plan nedbetalingsbelÃ¸pet',0),(191538,5321,'da','Betalingen planen antallet',0),(191539,5321,'ko','ì§€ë¶ˆ ê³„íš ìˆ˜',0),(191540,5321,'he','×ž×¡×¤×¨ ×ª×•×›× ×™×ª ×ª×©×œ×•×',0),(191541,5321,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(191542,5321,'zh','ä»˜æ¬¾è®¡åˆ’ç¼–å·\r\n',0),(191543,5321,'sv','Betalningsnumret Plan',0),(191544,5321,'it','Numero del piano di pagamento',0),(191545,5321,'tl','',0),(191546,5321,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(191547,5321,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(191548,5321,'ms','Nombor pelan pembayaran',0),(191549,5321,'ar','Ø±Ù‚Ù… Ø®Ø·Ø© Ø§Ù„Ø¯ÙØ¹',0),(191550,5321,'fr','NumÃ©ro de Plan de paiement',0),(191551,5321,'jp','æ”¯æ‰•è¨ˆç”»ç•ªå?·',0),(191552,5321,'pt','NÃºmero do plano de pagamento',0),(191553,5321,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð¾Ð³Ð¾ ÐŸÐ»Ð°Ð½Ð°',0),(191554,5321,'es','NÃºmero de Plan de Pagos',0),(191555,5321,'de','Plan Zahlungsnummer',0),(191556,5321,'en','Payment Plan Number',0),(191557,5322,'is','',0),(191558,5322,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191559,5322,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191560,5322,'tr','Ã–deme planÄ± numarasÄ±',0),(191561,5322,'pl','Numer Plan pÅ‚atnoÅ›ci',0),(191562,5322,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½',0),(191563,5322,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(191564,5322,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐŸÐ»Ð°Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(191565,5322,'vi','Káº¿ hoáº¡ch Thanh ToÃ¡n sá»‘',0),(191566,5322,'af','Betalingsplan Nommer',0),(191567,5322,'ro','NumÄƒrul de Plan de platÄƒ',0),(191568,5322,'et','Maksegraafiku number',0),(191569,5322,'si','Å tevilka naÄrta plaÄila',0),(191570,5322,'ba','Nomor rencana pembayaran',0),(191571,5322,'nl','Plattegrond, nr. betaling',0),(191572,5322,'fi','Maksun suunnitelman numero',0),(191573,5322,'no','Plan nedbetalingsbelÃ¸pet',0),(191574,5322,'da','Betalingen planen antallet',0),(191575,5322,'ko','ì§€ë¶ˆ ê³„íš ìˆ˜',0),(191576,5322,'he','×ž×¡×¤×¨ ×ª×•×›× ×™×ª ×ª×©×œ×•×',0),(191577,5322,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(191578,5322,'zh','ä»˜æ¬¾è®¡åˆ’ç¼–å·\r\n',0),(191579,5322,'sv','Betalningsnumret Plan',0),(191580,5322,'it','Numero del piano di pagamento',0),(191581,5322,'tl','',0),(191582,5322,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(191583,5322,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(191584,5322,'ms','Nombor pelan pembayaran',0),(191585,5322,'ar','Ø±Ù‚Ù… Ø®Ø·Ø© Ø§Ù„Ø¯ÙØ¹',0),(191586,5322,'fr','NumÃ©ro de Plan de paiement',0),(191587,5322,'jp','æ”¯æ‰•è¨ˆç”»ç•ªå?·',0),(191588,5322,'pt','NÃºmero do plano de pagamento',0),(191589,5322,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð¾Ð³Ð¾ ÐŸÐ»Ð°Ð½Ð°',0),(191590,5322,'es','NÃºmero de Plan de Pagos',0),(191591,5322,'de','Plan Zahlungsnummer',0),(191592,5322,'en','Payment Plan Number',0),(191593,5323,'is','',0),(191594,5323,'dr','ÙƒÙ„ Ù…Ø¨Ù„Øº Ø·Ø±Ø­ ',0),(191595,5323,'pr','ÙƒÙ„ Ù…Ø¨Ù„Øº Ø·Ø±Ø­ ',0),(191596,5323,'tr','Toplam planÄ± tutarÄ±',0),(191597,5323,'pl','Plan caÅ‚kowitej kwoty',0),(191598,5323,'bg','ÐŸÐ»Ð°Ð½ Ð·Ð° Ð¾Ð±Ñ‰Ð° ÑÑƒÐ¼Ð°',0),(191599,5323,'ur','Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ Ú©Ù„ Ø±Ù‚Ù…',0),(191600,5323,'sr','Ð˜Ð·Ð½Ð¾Ñ ÑƒÐºÑƒÐ¿Ð½Ð¾Ð³ Ð¿Ð»Ð°Ð½Ð°',0),(191601,5323,'vi','Tá»•ng cá»™ng sá»‘ tiá»n káº¿ hoáº¡ch',0),(191602,5323,'af','Totale Planbedrag',0),(191603,5323,'ro','Suma totalÄƒ Plan',0),(191604,5323,'et','Kokku plaani summa',0),(191605,5323,'si','Skupni naÄrt znesek',0),(191606,5323,'ba','Jumlah total rencana',0),(191607,5323,'nl','Totale Plan bedrag',0),(191608,5323,'fi','YhteensÃ¤ suunnitelma mÃ¤Ã¤rÃ¤',0),(191609,5323,'no','Totale planen belÃ¸p',0),(191610,5323,'da','Samlede Plan belÃ¸b',0),(191611,5323,'ko','ì´ ê³„íš ê¸ˆì•¡',0),(191612,5323,'he','×ª×•×›× ×™×ª ×¡×” ×› ×›×ž×•×ª',0),(191613,5323,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î¿ÏƒÏŒ',0),(191614,5323,'zh','è®¡åˆ’æ€»é¢\r\n',0),(191615,5323,'sv','Totala planen belopp',0),(191616,5323,'it','Importo totale del piano',0),(191617,5323,'tl','',0),(191618,5323,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3649;&#3612;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(191619,5323,'hi','à¤•à¥à¤² à¤¯à¥‹à¤œà¤¨à¤¾ à¤°à¤¾à¤¶à¤¿',0),(191620,5323,'ms','Jumlah keseluruhan pelan',0),(191621,5323,'ar','Ø§Ù„Ø®Ø·Ø© Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¨Ù„Øº',0),(191622,5323,'fr','Montant total du rÃ©gime',0),(191623,5323,'jp','è¨ˆç”»é¡?å?ˆè¨ˆ',0),(191624,5323,'pt','Montante total do plano',0),(191625,5323,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¾Ð±Ñ‰ÐµÐ³Ð¾ Ð¿Ð»Ð°Ð½Ð°',0),(191626,5323,'es','Total Monto de Plan',0),(191627,5323,'de','Gesamtplan Betrag',0),(191628,5323,'en','Total Plan Amount',0),(191629,5324,'is','',0),(191630,5324,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(191631,5324,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(191632,5324,'tr','Ã–deme planÄ± Ekle/GÃ¼ncelle',0),(191633,5324,'pl','Plan pÅ‚atnoÅ›ci Dodaj/Aktualizuj',0),(191634,5324,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(191635,5324,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(191636,5324,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° ÐŸÐ»Ð°Ð½ Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(191637,5324,'vi','ThÃªm/Cáº­p Nháº­t Káº¿ Hoáº¡ch Thanh ToÃ¡n',0),(191638,5324,'af','Betalingsplan Byvoeg/Opdateer',0),(191639,5324,'ro','Adauga/Actualizeaza plan de plati',0),(191640,5324,'et','Lisa/Uuenda maksegraafikuid',0),(191641,5324,'si','PlaÄilo naÄrt Dodaj/posodobi',0),(191642,5324,'ba','Pembayaran rencana Tambahkan/Perbarui',0),(191643,5324,'nl','Betaling Plan toevoegen/bijwerken',0),(191644,5324,'fi','Maksu suunnitelma lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(191645,5324,'no','Betaling Plan Legg til/Oppdater',0),(191646,5324,'da','Betalingen planen TilfÃ¸j/opdater',0),(191647,5324,'ko','ì§€ë¶ˆ ê³„íšì„ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(191648,5324,'he','×ª×•×›× ×™×ª ×ª×©×œ×•× ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(191649,5324,'el','Î£Ï‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(191650,5324,'zh','å¢žåŠ /æ›´æ–°ä»˜æ¬¾è®¡åˆ’\r\n',0),(191651,5324,'sv','Betalning Plan LÃ¤gg till/uppdatera',0),(191652,5324,'it','Pagamento piano aggiungere/aggiornare',0),(191653,5324,'tl','',0),(191654,5324,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3627;&#3609;&#3637;&#3657;',0),(191655,5324,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤œà¥‹à¤¡à¤¼/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(191656,5324,'ms','Bayaran pelan Tambah/Kemaskini',0),(191657,5324,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø®Ø·Ù‘Ø© ØªÙ‚Ø³ÙŠØ·',0),(191658,5324,'fr','Paiement Plan ajouter/mettre Ã  jour',0),(191659,5324,'jp','æ”¯æ‰•è¨ˆç”»ã€€è¿½åŠ /æ›´æ–°',0),(191660,5324,'pt','Plano de pagamento adicionar/atualizar',0),(191661,5324,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(191662,5324,'es','Plan de Pago Agregar/Actualizar',0),(191663,5324,'de','Zahlung Plan hinzufÃ¼gen/aktualisieren',0),(191664,5324,'en','Payment Plan Add/Update',0),(191665,5325,'is','',0),(191666,5325,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ø·Ø±Ø­  Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯',0),(191667,5325,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ø·Ø±Ø­  Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯',0),(191668,5325,'tr','Yeni bir Ã¶deme planÄ± oluÅŸturma',0),(191669,5325,'pl','Tworzenie nowego planu pÅ‚atnoÅ›ci',0),(191670,5325,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¿Ð»Ð°Ð½ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(191671,5325,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø§ Ø§ÛŒÚ© Ù†ÛŒØ§ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(191672,5325,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ ÐŸÐ»Ð°Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(191673,5325,'vi','Táº¡o 1 káº¿ hoáº¡ch thanh toÃ¡n má»›i',0),(191674,5325,'af','Skep \'n Nuwe Betalingsplan',0),(191675,5325,'ro','CreaÅ£i un nou Plan de platÄƒ',0),(191676,5325,'et','Loo uus maksegraafik',0),(191677,5325,'si','Ustvarite nov naÄrt plaÄil',0),(191678,5325,'ba','Membuat rencana pembayaran baru',0),(191679,5325,'nl','Maak een nieuwe betalingsplan',0),(191680,5325,'fi','Luo uusi maksusuunnitelma',0),(191681,5325,'no','Opprette en ny betalingsplan',0),(191682,5325,'da','Opret en ny betalingsplan',0),(191683,5325,'ko','ìƒˆë¡œìš´ ì§€ê¸‰ ê³„íšì„ ë§Œë“¤',0),(191684,5325,'he','×™×¦×™×¨×ª ×ª×•×›× ×™×ª ×ª×©×œ×•× ×—×“×©×”',0),(191685,5325,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î­Î½Î± Î½Î­Î¿ ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(191686,5325,'zh','åˆ›å»ºä¸€ä¸ªæ–°çš„ä»˜æ¬¾è®¡åˆ’\r\n',0),(191687,5325,'sv','Skapa en ny betalningsplan',0),(191688,5325,'it','Creare un nuovo piano di pagamento',0),(191689,5325,'tl','',0),(191690,5325,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(191691,5325,'hi','à¤à¤• à¤¨à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(191692,5325,'ms','Cipta pelan pembayaran baru',0),(191693,5325,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø®Ø·Ù‘Ø© ØªÙ‚Ø³ÙŠØ· Ø¬Ø¯ÙŠØ¯Ø©',0),(191694,5325,'fr','CrÃ©er un Plan de paiement',0),(191695,5325,'jp','æ–°è¦?æ”¯æ‰•è¨ˆç”»ã?®ä½œæˆ?',0),(191696,5325,'pt','Criar um novo plano de pagamento',0),(191697,5325,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½',0),(191698,5325,'es','Crear una Nueva Plan de Pago',0),(191699,5325,'de','Erstellen Sie einen neuen Zahlungsplan',0),(191700,5325,'en','Create a New Payment Plan',0),(191701,5326,'is','',0),(191702,5326,'dr','(Ù…Ø³Ø§Ø¹Ø¯Ù‡',0),(191703,5326,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª(Ù…Ø³Ø§Ø¹Ø¯Ù‡',0),(191704,5326,'tr','Bir Ã¶deme planÄ±nÄ± gÃ¼ncelleÅŸtir',0),(191705,5326,'pl','Aktualizacja planu pÅ‚atnoÅ›ci',0),(191706,5326,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½',0),(191707,5326,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(191708,5326,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð° Ñ€Ð°Ñ‚Ðµ',0),(191709,5326,'vi','Cáº­p Nháº­t 1 Káº¿ Hoáº¡ch Thanh ToÃ¡n',0),(191710,5326,'af','Opdateer \'n Betalingsplan',0),(191711,5326,'ro','Actualizare un Plan de platÄƒ',0),(191712,5326,'et','Update maksegraafiku',0),(191713,5326,'si','Posodobiti naÄrt plaÄil',0),(191714,5326,'ba','Memperbarui sebuah rencana pembayaran',0),(191715,5326,'nl','Een betalingsplan bijwerken',0),(191716,5326,'fi','PÃ¤ivitÃ¤ maksusuunnitelma',0),(191717,5326,'no','Oppdatere en betalingsplan',0),(191718,5326,'da','Opdatere en betalingsordning',0),(191719,5326,'ko','ì—…ë°ì´íŠ¸ ì§€ë¶ˆ ê³„íš',0),(191720,5326,'he','×¢×“×›×•×Ÿ ×ª×•×›× ×™×ª ×ª×©×œ×•×',0),(191721,5326,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î­Î½Î± ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(191722,5326,'zh','æ›´æ–°ä»˜æ¬¾è®¡åˆ’\r\n',0),(191723,5326,'sv','Uppdatera en betalningsplan',0),(191724,5326,'it','Aggiornare un piano di pagamento',0),(191725,5326,'tl','',0),(191726,5326,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(191727,5326,'hi','à¤à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(191728,5326,'ms','Kemaskini pembayaran balik',0),(191729,5326,'ar','ØªØ­Ø¯ÙŠØ« Ø®Ø·Ù‘Ø© ØªÙ‚Ø³ÙŠØ·',0),(191730,5326,'fr','Mettre Ã  jour un Plan de paiement',0),(191731,5326,'jp','æ”¯æ‰•è¨ˆç”»ã?®æ›´æ–°',0),(191732,5326,'pt','AtualizaÃ§Ã£o de um plano de pagamento',0),(191733,5326,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½',0),(191734,5326,'es','Actualizar un Plan de Pago',0),(191735,5326,'de','Update einen Zahlungsplan',0),(191736,5326,'en','Update a Payment Plan',0),(191737,5327,'is','',0),(191738,5327,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª  Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191739,5327,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª  Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191740,5327,'tr','Ã–deme planÄ± ayrÄ±ntÄ±larÄ± ekleme hatasÄ±',0),(191741,5327,'pl','BÅ‚Ä…d wstawiania szczegÃ³Å‚y planie pÅ‚atnoÅ›ci',0),(191742,5327,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½',0),(191743,5327,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(191744,5327,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ¼ÐµÑ‚Ð°ÑšÑƒ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð¿Ð»Ð°Ð½Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(191745,5327,'vi','Lá»—i khi chÃ¨n chi tiáº¿t káº¿ hoáº¡ch thanh toÃ¡n',0),(191746,5327,'af','Fout het ontstaan met die Invoeging van Betalingsplan Besonderhede',0),(191747,5327,'ro','Eroare inserarea detalii de Plan de platÄƒ',0),(191748,5327,'et','Otsemaksete kava Ã¼ksikasjad lisamisel tÃµrge',0),(191749,5327,'si','Pri vstavljanju plaÄilni naÄrt podrobnosti',0),(191750,5327,'ba','Kesalahan memasukkan rincian rencana pembayaran',0),(191751,5327,'nl','Error invoegen betaling Plan Details',0),(191752,5327,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ suunnitelma maksutiedot',0),(191753,5327,'no','Feil under innsetting Plan betalingsdetaljer',0),(191754,5327,'da','Fejl indsÃ¦tte betaling Plan detaljer',0),(191755,5327,'ko','ì§€ë¶ˆ ê³„íš ì„¸ë¶€ ì •ë³´ ì‚½ìž… ì˜¤ë¥˜',0),(191756,5327,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×¤×¨×˜×™ ×ª×•×›× ×™×ª ×ª×©×œ×•×',0),(191757,5327,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏ‡Î­Î´Î¹Î¿ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(191758,5327,'zh','é”™è¯¯æ’å…¥ä»˜æ¬¾è®¡åˆ’çš„è¯¦æƒ…\r\n',0),(191759,5327,'sv','Fel att infoga Plan betalningsinformation',0),(191760,5327,'it','Errore di inserimento dati del piano di pagamento',0),(191761,5327,'tl','',0),(191762,5327,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;',0),(191763,5327,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤µà¤¿à¤µà¤°à¤£ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(191764,5327,'ms','Kesilapan memasukkan butir-butir pelan pembayaran',0),(191765,5327,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¯Ø±Ø§Ø¬ ØªÙØ§ØµÙŠÙ„ Ø®Ø·Ø© Ø§Ù„Ø¯ÙØ¹',0),(191766,5327,'fr','Erreur insertion d\'informations de Plan de paiement',0),(191767,5327,'jp','æ”¯æ‰•è¨ˆç”»è©³ç´°ã?®æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(191768,5327,'pt','Erro inserir detalhes do plano de pagamento',0),(191769,5327,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð’Ð²Ð¾Ð´Ðµ Ð”ÐµÑ‚Ð°Ð»ÐµÐ¹ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð¾Ð³Ð¾ ÐŸÐ»Ð°Ð½Ð°',0),(191770,5327,'es','Error Insertando Detalles de Plan de Pago',0),(191771,5327,'de','Fehler, die Zahlungsdetails Plan einfÃ¼gen',0),(191772,5327,'en','Error Inserting Payment Plan Details',0),(191773,5328,'is','',0),(191774,5328,'dr','Ù„ÙŠØ³Øª Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191775,5328,'pr','Ù„ÙŠØ³Øª Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(191776,5328,'tr','Ã–deme planÄ± listesi',0),(191777,5328,'pl','Listy Plan pÅ‚atnoÅ›ci',0),(191778,5328,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½ ÑÐ¿Ð¸ÑÑŠÐº',0),(191779,5328,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(191780,5328,'sr','Ð›Ð¸ÑÑ‚Ð° ÐŸÐ»Ð°Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(191781,5328,'vi','Danh sÃ¡ch Káº¿ hoáº¡ch Thanh ToÃ¡n',0),(191782,5328,'af','Betaling Planlys',0),(191783,5328,'ro','ListÄƒ de Plan de platÄƒ',0),(191784,5328,'et','Maksegraafiku nimekiri',0),(191785,5328,'si','PlaÄilo naÄrt seznama',0),(191786,5328,'ba','Daftar rencana pembayaran',0),(191787,5328,'nl','Betaling Plan lijst',0),(191788,5328,'fi','Maksu suunnitelman luettelo',0),(191789,5328,'no','Betaling Plan liste',0),(191790,5328,'da','Betaling Plan liste',0),(191791,5328,'ko','ì§€ë¶ˆ ê³„íš ëª©ë¡',0),(191792,5328,'he','×¨×©×™×ž×ª ×ª×•×›× ×™×ª ×ª×©×œ×•×',0),(191793,5328,'el','Î›Î¯ÏƒÏ„Î± ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(191794,5328,'zh','ä»˜æ¬¾è®¡åˆ’åˆ—è¡¨\r\n',0),(191795,5328,'sv','Betalning Plan lista',0),(191796,5328,'it','Elenco del piano di pagamento',0),(191797,5328,'tl','',0),(191798,5328,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(191799,5328,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤¸à¥‚à¤šà¥€',0),(191800,5328,'ms','Senarai rancangan pembayaran',0),(191801,5328,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø®Ø·Ø· Ø§Ù„ØªÙ‚Ø³ÙŠØ·',0),(191802,5328,'fr','Liste de Plan de paiement',0),(191803,5328,'jp','æ”¯æ‰•ã?„è¨ˆç”»ãƒªã‚¹ãƒˆ',0),(191804,5328,'pt','Lista de plano de pagamento',0),(191805,5328,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ñ… ÐŸÐ»Ð°Ð½Ð¾Ð²',0),(191806,5328,'es','Lista de Plan de Pago',0),(191807,5328,'de','Auszahlungsliste Plan',0),(191808,5328,'en','Payment Plan List',0),(191809,5329,'is','',0),(191810,5329,'dr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø¨Ø¹Ø¯ÙŠ ',0),(191811,5329,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø¨Ø¹Ø¯ÙŠ ',0),(191812,5329,'tr','Sonraki Son Tarih',0),(191813,5329,'pl','NastÄ™pny termin',0),(191814,5329,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰ ÑÑ€Ð¾Ðº Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(191815,5329,'ur','Ø§Ú¯Ù„ÛŒ Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(191816,5329,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð Ð¾Ðº Ð¸Ð·Ð²Ñ€ÑˆÐµÑšÐ°:',0),(191817,5329,'vi','NgÃ y Ä‘áº¿n háº¡n tiáº¿p theo',0),(191818,5329,'af','Volgende Betalingsdatum',0),(191819,5329,'ro','Data viitoare scadentÄƒ',0),(191820,5329,'et','JÃ¤rgmine tÃ¤htaeg',0),(191821,5329,'si','Naslednji rok',0),(191822,5329,'ba','Berikutnya jatuh tempo',0),(191823,5329,'nl','Volgende vervaldatum',0),(191824,5329,'fi','Seuraava erÃ¤pÃ¤ivÃ¤',0),(191825,5329,'no','Neste forfallsdato',0),(191826,5329,'da','NÃ¦ste forfaldsdato',0),(191827,5329,'ko','ë‹¤ìŒ ê¸°í•œ ë‚ ì§œ',0),(191828,5329,'he','×ª××¨×™×š ×™×¢×“ ×”×‘×',0),(191829,5329,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Ï€ÏÎ¿Î¸ÎµÏƒÎ¼Î¯Î±',0),(191830,5329,'zh','ä¸‹ä¸€ä¸ªåˆ°æœŸæ—¥æœŸ\r\n',0),(191831,5329,'sv','NÃ¤sta fÃ¶rfallodatum',0),(191832,5329,'it','Prossima scadenza',0),(191833,5329,'tl','',0),(191834,5329,'th','&#3623;&#3633;&#3609;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(191835,5329,'hi','à¤…à¤—à¤²à¥‡ à¤•à¤¾à¤°à¤£ à¤¤à¤¿à¤¥à¤¿',0),(191836,5329,'ms','Tarikh akhir berikutnya',0),(191837,5329,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø§Ù„Ù‚Ø§Ø¯Ù…',0),(191838,5329,'fr','Prochaine Ã©chÃ©ance',0),(191839,5329,'jp','æ¬¡ã?®æœŸæ—¥',0),(191840,5329,'pt','Data de vencimento prÃ³xima',0),(191841,5329,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ ÐŸÐ¾ Ð”Ð°Ñ‚Ðµ',0),(191842,5329,'es','PrÃ³xima Fecha de Vencimiento',0),(191843,5329,'de','NÃ¤chste FÃ¤lligkeit',0),(191844,5329,'en','Next Due Date',0),(191845,5330,'is','',0),(191846,5330,'dr','Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(191847,5330,'pr','Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(191848,5330,'tr','EÅŸleÅŸen hiÃ§bir Ã¶deme planÄ± bulundu',0),(191849,5330,'pl','Nie pasujÄ…ce Plan pÅ‚atnoÅ›ci, Znalezione',0),(191850,5330,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(191851,5330,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(191852,5330,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ñ€Ð°Ñ‚Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(191853,5330,'vi','KhÃ´ng tÃ¬m tháº¥y káº¿ hoáº¡ch thanh toÃ¡n phÃ¹ há»£p',0),(191854,5330,'af','Geen ooreenstemmende betaling Plan gevind',0),(191855,5330,'ro','Nici un Plan de platÄƒ potrivire gÄƒsit',0),(191856,5330,'et','Sobivat maksegraafikut ei leitud',0),(191857,5330,'si','Brez ujemanja plaÄilni naÄrt naÅ¡el',0),(191858,5330,'ba','Rencana pembayaran tidak cocok ditemukan',0),(191859,5330,'nl','Geen overeenkomende betalingsplan gevonden',0),(191860,5330,'fi','Ei vastaavia maksusuunnitelman lÃ¶ytyi',0),(191861,5330,'no','Ingen samsvarende betalingsplan finnes',0),(191862,5330,'da','Ingen matchende betalingsplan fundet',0),(191863,5330,'ko','ì°¾ì„ ì¼ì¹˜ í•˜ ì§€ë¶ˆ ê³„íš',0),(191864,5330,'he','××™×Ÿ ×ª×•×›× ×™×ª ×ª×©×œ×•×ž×™× ×ª×•××ž×•×ª × ×ž×¦××•',0),(191865,5330,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(191866,5330,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„ä»˜æ¬¾è®¡åˆ’\r\n',0),(191867,5330,'sv','Inga matchande betalningsplan hittade',0),(191868,5330,'it','Nessun piano di pagamento corrispondente trovato',0),(191869,5330,'tl','',0),(191870,5330,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(191871,5330,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤¹à¥ˆ à¤ªà¤¾à¤¯à¤¾',0),(191872,5330,'ms','Pelan bayaran tiada padanan ditemui',0),(191873,5330,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø®Ø·Ù‘Ø© ØªÙ‚Ø³ÙŠØ· Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(191874,5330,'fr','Aucun Plan de paiement correspondant trouvÃ©',0),(191875,5330,'jp','ä¸€è‡´ã?™ã‚‹æ”¯æ‰•è¨ˆç”»ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(191876,5330,'pt','Nenhum plano de pagamento correspondente encontrado',0),(191877,5330,'ru','ÐÐµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ Ð¿Ð»Ð°Ð½ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(191878,5330,'es','No se encontrÃ³ plan de pagos emparejado',0),(191879,5330,'de','Keine passenden Zahlungsplan gefunden',0),(191880,5330,'en','No Matching Payment Plan Found',0),(191881,5331,'is','',0),(191882,5331,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù‡ ',0),(191883,5331,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù‡ ',0),(191884,5331,'tr','# Kez fatura',0),(191885,5331,'pl','# Czas fakturowany',0),(191886,5331,'bg','# ÐŸÑŠÑ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(191887,5331,'ur','# Ø¨Ø§Ø± Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯',0),(191888,5331,'sr','# ÐŸÑƒÑ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð¸',0),(191889,5331,'vi','Sá»‘ thá»i gian Ä‘Ã£ hÃ³a Ä‘Æ¡n ',0),(191890,5331,'af','# Kere Gefaktureer',0),(191891,5331,'ro','# Ori facturate',0),(191892,5331,'et','# Arveldatud korda',0),(191893,5331,'si','# Krat, fakturirano',0),(191894,5331,'ba','# Kali ditagih',0),(191895,5331,'nl','# Keer gefactureerd',0),(191896,5331,'fi','# Kertaa laskutettu',0),(191897,5331,'no','# Ganger fakturert',0),(191898,5331,'da','# Gange faktureret',0),(191899,5331,'ko','# ë²ˆ ì²­êµ¬',0),(191900,5331,'he','# ×¤×¢×ž×™× ×—×•×™×‘',0),(191901,5331,'el','# ÎŸÎ¹ Ï†Î¿ÏÎ­Ï‚ Ï€Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î®Î¸Î·ÎºÎµ',0),(191902,5331,'zh','ï¼ƒæ¬¡å¼€å…·å‘ç¥¨\r\n',0),(191903,5331,'sv','# GÃ¥nger faktureras',0),(191904,5331,'it','# Volte fatturate',0),(191905,5331,'tl','',0),(191906,5331,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(191907,5331,'hi','# à¤¬à¤¾à¤° à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(191908,5331,'ms','# Times invois',0),(191909,5331,'ar','# Ù…Ø±Ø§Øª Ù…ÙÙˆØªØ±',0),(191910,5331,'fr','# Fois facturÃ©es',0),(191911,5331,'jp','è«‹æ±‚å›žæ•°',0),(191912,5331,'pt','# Vezes facturados',0),(191913,5331,'ru','# Ð Ð°Ð· Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚',0),(191914,5331,'es','# Veces Facturados',0),(191915,5331,'de','# Mal in Rechnung gestellt',0),(191916,5331,'en','# Times Invoiced',0),(191917,5332,'is','',0),(191918,5332,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø·Ø±Ø­ ',0),(191919,5332,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø·Ø±Ø­ ',0),(191920,5332,'tr','PlanÄ± numarasÄ±',0),(191921,5332,'pl','Numer planu',0),(191922,5332,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð»Ð°Ð½',0),(191923,5332,'ur','Ù†Ù…Ø¨Ø± Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(191924,5332,'sr','ÐŸÐ»Ð°Ð½ Ð±Ñ€Ð¾Ñ˜',0),(191925,5332,'vi','Sá»‘ káº¿ hoáº¡ch',0),(191926,5332,'af','Plannommer',0),(191927,5332,'ro','Plan de numÄƒrul',0),(191928,5332,'et','Plaan Number',0),(191929,5332,'si','Å tevilka naÄrta',0),(191930,5332,'ba','Rencana nomor',0),(191931,5332,'nl','Plattegrond, nr.',0),(191932,5332,'fi','Suunnitelman numero',0),(191933,5332,'no','Planlegge nummer',0),(191934,5332,'da','PlanlÃ¦g antallet',0),(191935,5332,'ko','ê³„íš ìˆ˜',0),(191936,5332,'he','×ª×•×›× ×™×ª ×ž×¡×¤×¨',0),(191937,5332,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÏƒÏ‡Î­Î´Î¹Î¿',0),(191938,5332,'zh','è®¡åˆ’æ•°\r\n',0),(191939,5332,'sv','Plannummer',0),(191940,5332,'it','Numero di piano',0),(191941,5332,'tl','',0),(191942,5332,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;',0),(191943,5332,'hi','à¤¯à¥‹à¤œà¤¨à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(191944,5332,'ms','Nombor pelan',0),(191945,5332,'ar','Ø±Ù‚Ù… Ø§Ù„Ø®Ø·Ø©',0),(191946,5332,'fr','NumÃ©ro de plan',0),(191947,5332,'jp','è¨ˆç”»ç•ªå?·',0),(191948,5332,'pt','NÃºmero do plano',0),(191949,5332,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐŸÐ»Ð°Ð½Ð°',0),(191950,5332,'es','NÃºmero de Plan',0),(191951,5332,'de','Plan Anzahl',0),(191952,5332,'en','Plan Number',0),(191953,5333,'is','',0),(191954,5333,'dr','Ù†Ù…Ø§ÙŠØ´ Ø·Ø±Ø­ Ù‡Ø§',0),(191955,5333,'pr','Ù†Ù…Ø§ÙŠØ´ Ø·Ø±Ø­ Ù‡Ø§',0),(191956,5333,'tr','PlanlarÄ± gÃ¶ster',0),(191957,5333,'pl','PokaÅ¼ plany',0),(191958,5333,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(191959,5333,'ur','Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(191960,5333,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(191961,5333,'vi','Hiá»ƒn thá»‹ káº¿ hoáº¡ch',0),(191962,5333,'af','Wys Planne',0),(191963,5333,'ro','AratÄƒ planuri',0),(191964,5333,'et','NÃ¤ita plaanid',0),(191965,5333,'si','PokaÅ¾i naÄrtov',0),(191966,5333,'ba','Rencana Tampilkan',0),(191967,5333,'nl','Toon plannen',0),(191968,5333,'fi','NÃ¤ytÃ¤ suunnitelmat',0),(191969,5333,'no','Vis planer',0),(191970,5333,'da','Vis planer',0),(191971,5333,'ko','ê³µì—° ê³„íš',0),(191972,5333,'he','×”×¦×’ ×ª×•×›× ×™×•×ª',0),(191973,5333,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÏ‡Î­Î´Î¹Î±',0),(191974,5333,'zh','å±•è§ˆè®¡åˆ’\r\n',0),(191975,5333,'sv','Visa planer',0),(191976,5333,'it','Visualizza piani',0),(191977,5333,'tl','',0),(191978,5333,'th','&#3649;&#3626;&#3604;&#3591;&#3649;&#3612;&#3609;',0),(191979,5333,'hi','à¤¶à¥‹ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(191980,5333,'ms','Menunjukkan pelan',0),(191981,5333,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø®Ø·Ø·',0),(191982,5333,'fr','Voir l\'Ã©tablissement de Plans',0),(191983,5333,'jp','è¨ˆç”»ã?®è¡¨ç¤º',0),(191984,5333,'pt','Mostrar planos',0),(191985,5333,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐŸÐ»Ð°Ð½Ñ‹',0),(191986,5333,'es','Mostrar Planes',0),(191987,5333,'de','Karte PlÃ¤ne',0),(191988,5333,'en','Show Plans',0),(191989,5334,'is','',0),(191990,5334,'dr','Ø®Ù„Ø§ØµÙ‡ Ø¬Ù…Ø¹â€Œ ÙƒÙ„ Ø·Ø¨Ù‚ Ø·Ø±Ø­',0),(191991,5334,'pr','Ø®Ù„Ø§ØµÙ‡ Ø¬Ù…Ø¹â€Œ ÙƒÙ„ Ø·Ø¨Ù‚ Ø·Ø±Ø­',0),(191992,5334,'tr','Plana gÃ¶re Ã–zet toplamlarÄ±',0),(191993,5334,'pl','PodsumowaÅ„ wedÅ‚ug planu',0),(191994,5334,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½Ð¸ ÑÑƒÐ¼Ð¸ Ð¿Ð¾ Ð¿Ð»Ð°Ð½',0),(191995,5334,'ur','Ø®Ù„Ø§ØµÛ Ù…ÛŒØ²Ø§Ù† Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ',0),(191996,5334,'sr','Ð—Ð±Ð¸Ñ€Ð¾Ð²Ðµ Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ° Ð¿Ð¾ Ð¿Ð»Ð°Ð½Ñƒ',0),(191997,5334,'vi','Tá»•ng há»£p theo káº¿ hoáº¡ch',0),(191998,5334,'af','Opsommingstotale per Plan',0),(191999,5334,'ro','Totaluri rezumative planul de',0),(192000,5334,'et','KokkuvÃµtted loeteluga',0),(192001,5334,'si','Povzetek vsote z naÄrtom',0),(192002,5334,'ba','Ringkasan Totals oleh rencana',0),(192003,5334,'nl','Samenvattingstotalen door Plan',0),(192004,5334,'fi','Yhteenvetosummia suunnitelma',0),(192005,5334,'no','Sammendragstotaler ved planen',0),(192006,5334,'da','Sammenfattende totaler ved Plan',0),(192007,5334,'ko','ê³„íšì— ì˜í•´ ìš”ì•½ í•©ê³„',0),(192008,5334,'he','×¡×š ×”×›×œ ×œ×¤×™ ×”×ª×•×›× ×™×ª',0),(192009,5334,'el','Î‘Î¸ÏÎ¿Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏÎ½Î¿Î»Î± Î±Ï€ÏŒ Ï„Î¿ ÏƒÏ‡Î­Î´Î¹Î¿',0),(192010,5334,'zh','æŒ‰è®¡åˆ’æ‘˜è¦æ±‡æ€»\r\n',0),(192011,5334,'sv','Sammanfattning summor av planen',0),(192012,5334,'it','Riepilogo totali di piano',0),(192013,5334,'tl','',0),(192014,5334,'th','&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3586;&#3629;&#3591;&#3649;&#3612;&#3609;&#3591;&#3634;&#3609;',0),(192015,5334,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¯à¥‹à¤— à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‹',0),(192016,5334,'ms','Ringkasan jumlah oleh pelan',0),(192017,5334,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹ Ù…ÙˆØ¬Ø² Ø§Ù„Ø®Ø·Ø©',0),(192018,5334,'fr','Totaux rÃ©capitulatifs par Plan',0),(192019,5334,'jp','è¨ˆç”»åˆ¥ã‚µãƒžãƒªãƒ¼å?ˆè¨ˆ',0),(192020,5334,'pt','Totais resumidos pelo plano',0),(192021,5334,'ru','Ð¡Ð²Ð¾Ð´Ð½Ñ‹Ðµ Ð¸Ñ‚Ð¾Ð³Ð¸ Ð¿Ð¾ Ð¿Ð»Ð°Ð½Ñƒ',0),(192022,5334,'es','Totales de ResÃºmen Por Plan',0),(192023,5334,'de','Zusammenfassung Summen von Plan',0),(192024,5334,'en','Summary Totals by Plan',0),(192025,5335,'is','',0),(192026,5335,'dr','Ø²Ù…Ø§Ù† Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(192027,5335,'pr','Ø²Ù…Ø§Ù† Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(192028,5335,'tr','Kalan zaman',0),(192029,5335,'pl','Czas pozostaÅ‚y',0),(192030,5335,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð¾ÑÑ‚Ð°Ð½Ð°Ð»',0),(192031,5335,'ur','Ø§ÙˆÙ‚Ø§Øª Ø¨Ø§Ù‚ÛŒ',0),(192032,5335,'sr','ÐŸÑƒÑ‚Ð° Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾',0),(192033,5335,'vi','Thá»i gian cÃ²n láº¡i',0),(192034,5335,'af','Oorblywende Tye',0),(192035,5335,'ro','Ori rÄƒmase',0),(192036,5335,'et','Korda jÃ¤relejÃ¤Ã¤nud',0),(192037,5335,'si','Krat, preostali',0),(192038,5335,'ba','Waktu tersisa',0),(192039,5335,'nl','Keer resterende',0),(192040,5335,'fi','Kertaa jÃ¤ljellÃ¤',0),(192041,5335,'no','Tid gjenstÃ¥r',0),(192042,5335,'da','Gange resterende',0),(192043,5335,'ko','ë‚¨ì€ ì‹œê°„',0),(192044,5335,'he','×”×–×ž×Ÿ ×”× ×•×ª×¨',0),(192045,5335,'el','Î¦Î¿ÏÎ­Ï‚ Ï€Î±ÏÎ±Î¼Î­Î½Î¿Ï…Î½',0),(192046,5335,'zh','å‰©ä½™æ—¶é—´\r\n',0),(192047,5335,'sv','Tider kvar',0),(192048,5335,'it','Periodi restanti',0),(192049,5335,'tl','',0),(192050,5335,'th','&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(192051,5335,'hi','à¤¸à¤®à¤¯ à¤¶à¥‡à¤·',0),(192052,5335,'ms','Masa tinggal',0),(192053,5335,'ar','Ø§Ù„Ø£ÙˆÙ‚Ø§Øª Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(192054,5335,'fr','Temps restant',0),(192055,5335,'jp','æ®‹ã‚Šå›žæ•°',0),(192056,5335,'pt','O tempo restante',0),(192057,5335,'ru','Ð’Ñ€ÐµÐ¼Ñ ÐÐ°Ð¿Ð¾Ð¼Ð¸Ð½Ð°Ð½Ð¸Ñ',0),(192058,5335,'es','Tiempos Restantes',0),(192059,5335,'de','Verbleibende Zeit',0),(192060,5335,'en','Times Remaining',0),(192061,5336,'is','',0),(192062,5336,'dr','(Ø¯Ø±Ø¢Ù…Ø¯',0),(192063,5336,'pr','ÙƒÙ„ Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª (Ø¯Ø±Ø¢Ù…Ø¯',0),(192064,5336,'tr','Toplam Ã¶deme planlarÄ±',0),(192065,5336,'pl','CaÅ‚kowita kwota pÅ‚atnoÅ›ci plany',0),(192066,5336,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(192067,5336,'ur','Ú©Ù„ Ù¾Û’ Ù…Ù†Ù¹ Ù¾Ù„Ø§Ù†',0),(192068,5336,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¸ÑÐ¿Ð»Ð°Ñ‚Ð° Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(192069,5336,'vi','Tá»•ng cá»™ng káº¿ hoáº¡ch thanh toÃ¡n',0),(192070,5336,'af','Totale Betalingsplanne',0),(192071,5336,'ro','Planurile de platÄƒ total',0),(192072,5336,'et','Kokku maksete plaanid',0),(192073,5336,'si','Skupno plaÄilo naÄrtov',0),(192074,5336,'ba','Rencana pembayaran Total',0),(192075,5336,'nl','Totale betaling plannen',0),(192076,5336,'fi','YhteensÃ¤ Maksusuunnitelmat',0),(192077,5336,'no','Totalt betalingsplaner',0),(192078,5336,'da','Samlede betaling planer',0),(192079,5336,'ko','ì´ ì§€ë¶ˆ ê³„íš',0),(192080,5336,'he','×¡×” ×› ×ª×©×œ×•× ×ª×•×›× ×™×•×ª',0),(192081,5336,'el','Î— ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ® Ï€Î»Î·ÏÏ‰Î¼Î® ÏƒÏ‡Î­Î´Î¹Î±',0),(192082,5336,'zh','æ€»ä»˜æ¬¾è®¡åˆ’\r\n',0),(192083,5336,'sv','Totala betalningsplaner',0),(192084,5336,'it','Piani di pagamento totale',0),(192085,5336,'tl','',0),(192086,5336,'th','&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(192087,5336,'hi','à¤•à¥à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(192088,5336,'ms','Pelan pembayaran jumlah',0),(192089,5336,'ar','Ø®Ø·Ø· Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(192090,5336,'fr','Plans de paiement total',0),(192091,5336,'jp','æ”¯æ‰•è¨ˆç”»å?ˆè¨ˆ',0),(192092,5336,'pt','Planos de pagamento total',0),(192093,5336,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ñ… ÐŸÐ»Ð°Ð½Ð¾Ð²',0),(192094,5336,'es','Total Planes de Pago',0),(192095,5336,'de','Gesamtzahlung PlÃ¤ne',0),(192096,5336,'en','Total Payment Plans',0),(192097,5337,'is','',0),(192098,5337,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø± Ù‡Ø± ÙØ§ÙƒØªÙˆØ± ',0),(192099,5337,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø± Ù‡Ø± ÙØ§ÙƒØªÙˆØ± ',0),(192100,5337,'tr','Fatura baÅŸÄ±na toplam',0),(192101,5337,'pl','OgÃ³Å‚em na fakturze',0),(192102,5337,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(192103,5337,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ ÙÛŒ Ú©Ù„',0),(192104,5337,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¿Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(192105,5337,'vi','Tá»•ng cá»™ng má»—i hÃ³a Ä‘Æ¡n',0),(192106,5337,'af','Totaal per Faktuur',0),(192107,5337,'ro','Total per facturÄƒ',0),(192108,5337,'et','Iga arve kokku',0),(192109,5337,'si','Skupno na raÄun',0),(192110,5337,'ba','Total per faktur',0),(192111,5337,'nl','Totaal per factuur',0),(192112,5337,'fi','Koko laskua kohti',0),(192113,5337,'no','Totalt per faktura',0),(192114,5337,'da','Samlede pr. faktura',0),(192115,5337,'ko','ì†¡ìž¥ ë‹¹ ì´',0),(192116,5337,'he','×¡×›×•× ×”×—×©×‘×•× ×™×ª',0),(192117,5337,'el','Î£ÏÎ½Î¿Î»Î¿ Î±Î½Î¬ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(192118,5337,'zh','æ¯å¼ å‘ç¥¨æ€»é¢\r\n',0),(192119,5337,'sv','Totalt per faktura',0),(192120,5337,'it','Totale per ogni fattura',0),(192121,5337,'tl','',0),(192122,5337,'th','&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3605;&#3656;&#3629;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(192123,5337,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¥à¤°à¤¤à¤¿ à¤•à¥à¤²',0),(192124,5337,'ms','Jumlah satu invois',0),(192125,5337,'ar','Ù…Ø¬Ù…ÙˆØ¹ ÙƒÙ„ ÙØ§ØªÙˆØ±Ø©',0),(192126,5337,'fr','Total par facture',0),(192127,5337,'jp','è«‹æ±‚æ›¸ã?”ã?¨ã?®å?ˆè¨ˆ',0),(192128,5337,'pt','Total por fatura',0),(192129,5337,'ru','Ð’ÑÐµÐ³Ð¾ Ð·Ð° ÑÑ‡ÐµÑ‚',0),(192130,5337,'es','Total por Factura',0),(192131,5337,'de','Summe pro Rechnung',0),(192132,5337,'en','Total per Invoice',0),(192133,5338,'is','',0),(192134,5338,'dr','ÙƒÙ„ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(192135,5338,'pr','ÙƒÙ„ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(192136,5338,'tr','Toplam kalan',0),(192137,5338,'pl','Suma pozostaÅ‚ych',0),(192138,5338,'bg','Ð¡Ð±Ð¾Ñ€Ð° Ð½Ð° Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¸Ñ‚Ðµ',0),(192139,5338,'ur','Ø¨Ø§Ù‚ÛŒ Ú©Ù„',0),(192140,5338,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾',0),(192141,5338,'vi','Tá»•ng cá»™ng cÃ²n láº¡i',0),(192142,5338,'af','Oorblywende Totaal',0),(192143,5338,'ro','Total rÄƒmase',0),(192144,5338,'et','JÃ¤Ã¤k kokku',0),(192145,5338,'si','Vsota preostalih',0),(192146,5338,'ba','Jumlah sisa',0),(192147,5338,'nl','Totaal resterend',0),(192148,5338,'fi','JÃ¤ljellÃ¤ yhteensÃ¤',0),(192149,5338,'no','GjenstÃ¥ende',0),(192150,5338,'da','Samlede resterende',0),(192151,5338,'ko','ì´ ë‚¨ì€',0),(192152,5338,'he','×¡×” ×› ×”× ×•×ª×¨×™×',0),(192153,5338,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬, Î±Ï€Î¿Î¼Î­Î½ÎµÎ¹',0),(192154,5338,'zh','æ€»å‰©ä½™\r\n',0),(192155,5338,'sv','Totalt Ã¥terstÃ¥ende',0),(192156,5338,'it','Totale rimanente',0),(192157,5338,'tl','',0),(192158,5338,'th','&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(192159,5338,'hi','à¤•à¥à¤² à¤¶à¥‡à¤·',0),(192160,5338,'ms','Jumlah baki',0),(192161,5338,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ù…ØªØ¨Ù‚ÙŠ',0),(192162,5338,'fr','Total restant',0),(192163,5338,'jp','æ®‹ã‚Šå?ˆè¨ˆ',0),(192164,5338,'pt','Total restante',0),(192165,5338,'ru','Ð’ÑÐµÐ³Ð¾ Ð¾ÑÑ‚Ð°Ð²ÑˆÐ¸Ñ…ÑÑ',0),(192166,5338,'es','Total Restante',0),(192167,5338,'de','Insgesamt verbleibenden',0),(192168,5338,'en','Total Remaining',0),(192169,5339,'is','',0),(192170,5339,'dr','ÙƒØ¯Ø§Ù…  Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(192171,5339,'pr','ÙƒØ¯Ø§Ù…  Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(192172,5339,'tr','Hangi katmak',0),(192173,5339,'pl','To co',0),(192174,5339,'bg','ÐšÐ¾Ð¸Ñ‚Ð¾ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚',0),(192175,5339,'ur','Ø¬Ù† Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(192176,5339,'sr','ÐšÐ¾Ñ˜Ð¸ ÑƒÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ',0),(192177,5339,'vi','Bao gá»“m cÃ¡i nÃ o',0),(192178,5339,'af','Sluit in',0),(192179,5339,'ro','Care includ',0),(192180,5339,'et','Kaasa milline',0),(192181,5339,'si','Ki vkljuÄujejo',0),(192182,5339,'ba','Termasuk yang',0),(192183,5339,'nl','Omvatten die',0),(192184,5339,'fi','Ovat joka',0),(192185,5339,'no','Inkluder som',0),(192186,5339,'da','Omfatte som',0),(192187,5339,'ko','í¬í•¨',0),(192188,5339,'he','×›×œ×•×œ ×‘×•',0),(192189,5339,'el','Î Î¿Ï… Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½',0),(192190,5339,'zh','åŒ…æ‹¬å“ªäº›\r\n',0),(192191,5339,'sv','Bland annat som',0),(192192,5339,'it','Che includono',0),(192193,5339,'tl','',0),(192194,5339,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3629;&#3633;&#3609;&#3652;&#3627;&#3609;',0),(192195,5339,'hi','à¤œà¥‹ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(192196,5339,'ms','Termasuk yang',0),(192197,5339,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„ØªÙŠ',0),(192198,5339,'fr','Qui comprennent',0),(192199,5339,'jp','ã?©ã‚Œã‚’å?«ã‚€',0),(192200,5339,'pt','Que incluem',0),(192201,5339,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ ÐšÐ°ÐºÐ¸Ðµ',0),(192202,5339,'es','Incluir CuÃ¡l',0),(192203,5339,'de','Enthalten Sie, die',0),(192204,5339,'en','Include Which',0),(192205,5340,'is','',0),(192206,5340,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(192207,5340,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(192208,5340,'tr','Ã–deme numarasÄ±',0),(192209,5340,'pl','Numer pÅ‚atnoÅ›ci',0),(192210,5340,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(192211,5340,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(192212,5340,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(192213,5340,'vi','Sá»‘ Thanh ToÃ¡n',0),(192214,5340,'af','Betalingnommer',0),(192215,5340,'ro','NumÄƒrul de platÄƒ',0),(192216,5340,'et','Makse Number',0),(192217,5340,'si','Å tevilo plaÄil',0),(192218,5340,'ba','Jumlah pembayaran',0),(192219,5340,'nl','Betaling nummer',0),(192220,5340,'fi','Maksun numero',0),(192221,5340,'no','NedbetalingsbelÃ¸pet',0),(192222,5340,'da','Betaling antallet',0),(192223,5340,'ko','ê²°ì œ ë²ˆí˜¸',0),(192224,5340,'he','×ž×¡×¤×¨ ×ª×©×œ×•×',0),(192225,5340,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(192226,5340,'zh','ç¼´è´¹å·ç \r\n',0),(192227,5340,'sv','Betalningsnumret',0),(192228,5340,'it','Numero a pagamento',0),(192229,5340,'tl','',0),(192230,5340,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(192231,5340,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(192232,5340,'ms','Jumlah pembayaran',0),(192233,5340,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¯ÙØ¹',0),(192234,5340,'fr','NumÃ©ro de paiement',0),(192235,5340,'jp','æ”¯æ‰•ç•ªå?·',0),(192236,5340,'pt','NÃºmero do pagamento',0),(192237,5340,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(192238,5340,'es','NÃºmero de Pago',0),(192239,5340,'de','Zahlungsnummer',0),(192240,5340,'en','Payment Number',0),(192241,5341,'is','',0),(192242,5341,'dr','Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(192243,5341,'pr','Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(192244,5341,'tr','Ã–deme planÄ±',0),(192245,5341,'pl','Plan pÅ‚atnoÅ›ci',0),(192246,5341,'bg','Ð¡Ñ…ÐµÐ¼Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(192247,5341,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(192248,5341,'sr','ÐŸÐ»Ð°Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(192249,5341,'vi','Káº¿ hoáº¡ch Thanh ToÃ¡n',0),(192250,5341,'af','Betalingplan ',0),(192251,5341,'ro','Plan de platÄƒ',0),(192252,5341,'et','Maksegraafik',0),(192253,5341,'si','NaÄrt plaÄil',0),(192254,5341,'ba','Rencana pembayaran',0),(192255,5341,'nl','Betalingsplan',0),(192256,5341,'fi','Maksusuunnitelma',0),(192257,5341,'no','Betalingsplan',0),(192258,5341,'da','Betalingsplan',0),(192259,5341,'ko','ì§€ë¶ˆ ê³„íš',0),(192260,5341,'he','×ª×›× ×™×ª ×ª×©×œ×•×',0),(192261,5341,'el','Î£Ï‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(192262,5341,'zh','ä»˜æ¬¾è®¡åˆ’\r\n',0),(192263,5341,'sv','Betalningsplan',0),(192264,5341,'it','Piano di pagamento',0),(192265,5341,'tl','',0),(192266,5341,'th','&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(192267,5341,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾',0),(192268,5341,'ms','Pelan bayaran',0),(192269,5341,'ar','Ø®Ø·Ù‘Ø© Ø§Ù„ØªÙ‚Ø³ÙŠØ·',0),(192270,5341,'fr','Plan de paiement',0),(192271,5341,'jp','æ”¯æ‰•è¨ˆç”»',0),(192272,5341,'pt','Plano de pagamento',0),(192273,5341,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½',0),(192274,5341,'es','Plan de Pago',0),(192275,5341,'de','Zahlungsplan',0),(192276,5341,'en','Payment Plan',0),(192277,5342,'is','',0),(192278,5342,'dr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø´Ø¯Ù† ',0),(192279,5342,'pr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø´Ø¯Ù† ',0),(192280,5342,'tr','Ã–deme planÄ± yazdÄ±rÄ±lacak faturalarÄ±n',0),(192281,5342,'pl','PÅ‚atnoÅ›ci faktury Plan do druku',0),(192282,5342,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(192283,5342,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ù†ÛÛŒÚº Ú†Ú¾Ø§Ù¾ÛŒ Ø¬Ø§ Ú©Û’ Ù„Ø¦Û’ ÙˆØ¨Ø¬Ù„ÛŒ',0),(192284,5342,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐŸÐ»Ð°Ð½ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(192285,5342,'vi','In HÃ³a Ä‘Æ¡n Káº¿ hoáº¡ch Thanh ToÃ¡n',0),(192286,5342,'af','Betalingplanfakture moet Uitgedruk word',0),(192287,5342,'ro','Plata planului facturile sÄƒ fie imprimate',0),(192288,5342,'et','Maksegraafiku arved printimisele',0),(192289,5342,'si','PlaÄilo naÄrt raÄune za tiskanje',0),(192290,5342,'ba','Rencana pembayaran tagihan untuk dicetak',0),(192291,5342,'nl','Betaling Plan facturen moeten worden afgedrukt',0),(192292,5342,'fi','Maksu suunnitelma laskut tulostetaan',0),(192293,5342,'no','Betaling Plan fakturaer skrives',0),(192294,5342,'da','Betaling Plan fakturaer der skal udskrives',0),(192295,5342,'ko','ì§€ë¶ˆ ê³„íš ì†¡ìž¥ ì¸ì‡„',0),(192296,5342,'he','×ª×©×œ×•× ×—×©×‘×•× ×™×•×ª ×œ×ª×›× ×Ÿ ×©×™×•×“×¤×¡',0),(192297,5342,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… Î¸Î± ÎµÎºÏ„Ï…Ï€Ï‰Î¸Î¿ÏÎ½',0),(192298,5342,'zh','ç¼´æ¬¾è®¡åˆ’å‘ç¥¨è¦æ‰“å°\r\n',0),(192299,5342,'sv','Betalning Plan fakturor ska skrivas',0),(192300,5342,'it','Pagamento fatture piano da stampare',0),(192301,5342,'tl','',0),(192302,5342,'th','&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(192303,5342,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤šà¤¾à¤²à¤¾à¤¨ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‹à¤œà¤¨à¤¾',0),(192304,5342,'ms','Invois bayaran pelan untuk dicetak',0),(192305,5342,'ar','Ø¯ÙØ¹ \"Ø®Ø·Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ±\" Ø§Ù„ØªÙŠ Ø³ÙŠØªÙ… Ø·Ø¨Ø§Ø¹ØªÙ‡Ø§',0),(192306,5342,'fr','Factures de paiement Plan Ã  imprimer',0),(192307,5342,'jp','å?°åˆ·ã?•ã‚Œã‚‹æ”¯æ‰•è¨ˆç”»è«‹æ±‚æ›¸',0),(192308,5342,'pt','Faturas de plano de pagamento a ser impresso',0),(192309,5342,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð¿Ð»Ð°Ð½Ð° ÑÑ‡ÐµÑ‚Ð¾Ð² Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(192310,5342,'es','Plan de Pago Facturas se ImprimirÃ¡n',0),(192311,5342,'de','Zahlung Plan Rechnungen gedruckt werden',0),(192312,5342,'en','Payment Plan Invoices to be Printed',0),(192313,5343,'is','',0),(192314,5343,'dr','Ø§Ø±Ø³Ø§Ù„ Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(192315,5343,'pr','Ø§Ø±Ø³Ø§Ù„ Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(192316,5343,'tr','SonrasÄ± Ã¶deme planlarÄ±',0),(192317,5343,'pl','Po planÃ³w pÅ‚atnoÅ›ci',0),(192318,5343,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(192319,5343,'ur','Ù¾ÙˆØ³Ù¹ Ù¾Û’ Ù…Ù†Ù¹ Ù¾Ù„Ø§Ù†',0),(192320,5343,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶Ð¸Ñ‚Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ñƒ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(192321,5343,'vi','Káº¿t chuyá»ƒn káº¿ hoáº¡ch thanh toÃ¡n',0),(192322,5343,'af','Pos Betalingsplanne',0),(192323,5343,'ro','Planurile de platÄƒ post',0),(192324,5343,'et','Post maksete plaanid',0),(192325,5343,'si','Post plaÄilo naÄrtov',0),(192326,5343,'ba','Posting rencana pembayaran',0),(192327,5343,'nl','Post betaling plannen',0),(192328,5343,'fi','Postitse Maksusuunnitelmat',0),(192329,5343,'no','Innlegget betalingsplaner',0),(192330,5343,'da','Post betaling planer',0),(192331,5343,'ko','í¬ìŠ¤íŠ¸ ì§€ë¶ˆ ê³„íš',0),(192332,5343,'he','×¤×•×¡×˜ ×”×¡×“×¨×™ ×ª×©×œ×•×ž×™×',0),(192333,5343,'el','Î˜Î­ÏƒÎ· ÏƒÏ‡Î­Î´Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(192334,5343,'zh','å‘å¸ƒä»˜æ¬¾è®¡åˆ’\r\n\r\n',0),(192335,5343,'sv','Post betalningsplaner',0),(192336,5343,'it','Piani di pagamento postale',0),(192337,5343,'tl','',0),(192338,5343,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(192339,5343,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(192340,5343,'ms','Pelan pembayaran pos',0),(192341,5343,'ar','ØªØ±Ø­ÙŠÙ„ Ø®Ø·Ø· Ø§Ù„ØªÙ‚Ø³ÙŠØ·',0),(192342,5343,'fr','Plans de paiement post',0),(192343,5343,'jp','æ”¯æ‰•ã?„è¨ˆç”»ã‚’è¨˜å¸³',0),(192344,5343,'pt','Planos de pagamento de post',0),(192345,5343,'ru','ÐŸÐ»Ð°Ð½Ñ‹ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚ Ð¿Ð¾ÑÑ‚',0),(192346,5343,'es','Asentar Planes de Pago',0),(192347,5343,'de','Post ZahlungsplÃ¤ne',0),(192348,5343,'en','Post Payment Plans',0),(192349,5344,'is','',0),(192350,5344,'dr','Ø§Ø±Ø³Ø§Ù„ Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯Ø± Ù…Ø¯Øª',0),(192351,5344,'pr','Ø§Ø±Ø³Ø§Ù„ Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯Ø± Ù…Ø¯Øª',0),(192352,5344,'tr','SonrasÄ± planlarÄ± nedeniyle aracÄ±lÄ±ÄŸÄ±yla',0),(192353,5344,'pl','Po plany spowodowane przez',0),(192354,5344,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ñ‚Ðµ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ Ð¿Ð°Ð´ÐµÐ¶ Ð¿Ñ€ÐµÐ·',0),(192355,5344,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ú©ÛŒ ÙˆØ¬Û Ø³Û’',0),(192356,5344,'sr','ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ Ð¿Ñ€Ð¾Ð»Ð°Ð·Ð¸',0),(192357,5344,'vi','Káº¿t chuyá»ƒn káº¿ hoáº¡ch Ä‘áº¿n háº¡n qua',0),(192358,5344,'af','Pos Planne Verskuldig Deur',0),(192359,5344,'ro','Posta planurile datorate prin',0),(192360,5344,'et','PÃ¤rast kavade kaudu otse',0),(192361,5344,'si','Objava naÄrtov naravnost skozi',0),(192362,5344,'ba','Posting rencana jatuh tempo melalui',0),(192363,5344,'nl','Post plannen verschuldigd door middel van',0),(192364,5344,'fi','LÃ¤hetÃ¤ suunnitelmat suoraan lÃ¤pi',0),(192365,5344,'no','Legge planer grunn gjennom',0),(192366,5344,'da','Opstille planer Due gennem',0),(192367,5344,'ko','ê²Œì‹œ ê³„íšì„ í†µí•´ ì˜ˆì •',0),(192368,5344,'he','×œ×›×ª×•×‘ ×ª×•×›× ×™×•×ª ×™×¢×“ ×‘××ž×¦×¢×•×ª',0),(192369,5344,'el','Î”Î·Î¼Î¿ÏƒÎ¯ÎµÏ…ÏƒÎ· ÏƒÏ‡Î­Î´Î¹Î± Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î¼Î­ÏƒÏ‰',0),(192370,5344,'zh','å‘å¸ƒè®¡åˆ’æˆªæ­¢æ—¥æœŸæ‰‹æ®µ\r\n',0),(192371,5344,'sv','BokfÃ¶r planer skall betalas genom',0),(192372,5344,'it','Postare piani dovuti attraverso',0),(192373,5344,'tl','',0),(192374,5344,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3612;&#3609;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3594;&#3635;&#3619;&#3632;&#3607;&#3640;&#3585;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(192375,5344,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾à¤“à¤‚ à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤¦à¥‡à¤¯',0),(192376,5344,'ms','Menyiarkan rancangan perlu dibuat melalui',0),(192377,5344,'ar','Ø¢Ø®Ø± Ø§Ù„Ø®Ø·Ø· Ø§Ù„ÙˆØ§Ø¬Ø¨ Ù…Ù† Ø®Ù„Ø§Ù„',0),(192378,5344,'fr','Poster les Plans Due par',0),(192379,5344,'jp','ï½žã?¾ã?§ã?®ãƒ—ãƒ©ãƒ³ã‚’è¨ˆä¸Š',0),(192380,5344,'pt','Postar planos devido atravÃ©s de',0),(192381,5344,'ru','Ð Ð°Ð·Ð¼ÐµÑ‰Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ð½Ñ‹ Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸',0),(192382,5344,'es','Asentar Planes Vencidos Por',0),(192383,5344,'de','Post PlÃ¤ne durch fÃ¤llig',0),(192384,5344,'en','Post Plans Due Through',0),(192385,5345,'is','',0),(192386,5345,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨Ø§ ÙƒØ§Ø±Ø¨Ø± Ø¯ÙŠÚ¯Ø± Ø¨Ø¹Ø¯ Ø§Ø² Ø§ÙŠÙ†ÙƒÙ‡ Ø´Ù…Ø§ ØªØºÙŠÙŠØ±Ø§Øª Ø±Ø§ Ø´Ø±ÙˆØ¹ ÙƒØ±Ø¯ÙŠØ¯ ',0),(192387,5345,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨Ø§ ÙƒØ§Ø±Ø¨Ø± Ø¯ÙŠÚ¯Ø± Ø¨Ø¹Ø¯ Ø§Ø² Ø§ÙŠÙ†ÙƒÙ‡ Ø´Ù…Ø§ ØªØºÙŠÙŠØ±Ø§Øª Ø±Ø§ Ø´Ø±ÙˆØ¹ ÙƒØ±Ø¯ÙŠØ¯ ',0),(192388,5345,'tr','DeÄŸiÅŸiklikleri baÅŸladÄ±ktan sonra baÅŸka bir kullanÄ±cÄ± tarafÄ±ndan gÃ¼ncelleÅŸtirildi',0),(192389,5345,'pl','Zaktualizowany przez innego uÅ¼ytkownika, po uruchomieniu zmiany',0),(192390,5345,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ Ð¾Ñ‚ Ð´Ñ€ÑƒÐ³ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ», ÑÐ»ÐµÐ´ ÐºÐ°Ñ‚Ð¾ ÑÑ‚Ðµ Ð·Ð°Ð¿Ð¾Ñ‡Ð½Ð°Ð»Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(192391,5345,'ur','Ø¢Ù¾ Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ø´Ø±ÙˆØ¹ Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ø¹Ø¯ Ú©Ø³ÛŒ Ø¯ÙˆØ³Ø±Û’ ØµØ§Ø±Ù Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§',0),(192392,5345,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð° Ð´Ñ€ÑƒÐ³Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº, Ð½Ð°ÐºÐ¾Ð½ ÑˆÑ‚Ð¾ ÑÑ‚Ðµ Ð¿Ð¾Ñ‡ÐµÐ»Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(192393,5345,'vi','NgÆ°á»i sá»­ dá»¥ng khÃ¡c Ä‘Ã£ cáº­p nháº­t sau khi báº¡n thay Ä‘á»•i',0),(192394,5345,'af','Opdateer deur \'n ander gebruiker nadat u begin het met doen van veranderinge',0),(192395,5345,'ro','Actualizat de alt utilizator dupÄƒ ce aÅ£i Ã®nceput modificÄƒri',0),(192396,5345,'et','MÃµni teine kasutaja pÃ¤rast seda, kui sa hakkasid muutused',0),(192397,5345,'si','Posodobil drug uporabnik, ko ste zaÄeli spremembe',0),(192398,5345,'ba','Diperbarui oleh pengguna lain setelah Anda mulai perubahan',0),(192399,5345,'nl','Bijgewerkt door een andere gebruiker nadat u wijzigingen hebt gestart',0),(192400,5345,'fi','PÃ¤ivitetty toisen kÃ¤yttÃ¤jÃ¤n muutokset kÃ¤ynnistyttyÃ¤',0),(192401,5345,'no','Oppdatert av en annen bruker etter at du startet endringer',0),(192402,5345,'da','Opdateret af en anden bruger, nÃ¥r du startede Ã¦ndringer',0),(192403,5345,'ko','ë³€í™”ë¥¼ ì‹œìž‘í•œ í›„ ë‹¤ë¥¸ ì‚¬ìš©ìžê°€ ì—…ë°ì´íŠ¸',0),(192404,5345,'he','×ž×¢×•×“×›×Ÿ ×¢×œ-×™×“×™ ×ž×©×ª×ž×© ××—×¨ ×œ××—×¨ ×”×ª×—×œ×ª ×”×©×™× ×•×™×™×',0),(192405,5345,'el','Î•Î½Î·Î¼ÎµÏÏŽÎ½Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ ÎºÎ¬Ï€Î¿Î¹Î¿Î½ Î¬Î»Î»Î¿ Ï‡ÏÎ®ÏƒÏ„Î·, Î¼ÎµÏ„Î¬ Î±ÏÏ‡Î¯ÏƒÎ±Ï„Îµ Î±Î»Î»Î±Î³Î­Ï‚',0),(192406,5345,'zh','ä½ å¼€å§‹å˜æ›´åŽç”±å…¶ä»–ç”¨æˆ·æ›´æ–°\r\n',0),(192407,5345,'sv','Uppdateras av en annan anvÃ¤ndare efter att du startat fÃ¶rÃ¤ndringar',0),(192408,5345,'it','Aggiornato da un altro utente dopo avviato cambiamenti',0),(192409,5345,'tl','',0),(192410,5345,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3650;&#3604;&#3618;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3629;&#3639;&#3656;&#3609;&#3627;&#3621;&#3633;&#3591;&#3588;&#3640;&#3603;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3',0),(192411,5345,'hi','à¤†à¤ª à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤†à¤°à¤‚à¤­ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾',0),(192412,5345,'ms','Dikemaskini oleh pengguna lain selepas anda memulakan perubahan',0),(192413,5345,'ar','ØªØ­Ø¯ÙŠØ« Ø¨ÙˆØ§Ø³Ø·Ø© Ù…Ø³ØªØ®Ø¯Ù… Ø¢Ø®Ø± Ø¨Ø¹Ø¯ Ø£Ù† ÙƒÙ†Øª Ø¨Ø¯Ø£Øª Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(192414,5345,'fr','Mis Ã  jour par un autre utilisateur aprÃ¨s que vous avez commencÃ© les changements',0),(192415,5345,'jp','å¤‰æ›´ã‚’é–‹å§‹ã?—ã?¦ã?‹ã‚‰ã?®é–“ã?«åˆ¥ã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?Œæ›´æ–°ã?—ã?¾ã?—ã?Ÿ',0),(192416,5345,'pt','Atualizado por outro usuÃ¡rio, depois que vocÃª comeÃ§ou a alteraÃ§Ãµes',0),(192417,5345,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾ Ð´Ñ€ÑƒÐ³Ð¸Ð¼ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¼ Ð¿Ð¾ÑÐ»Ðµ Ñ‚Ð¾Ð³Ð¾, ÐºÐ°Ðº Ð²Ñ‹ Ð½Ð°Ñ‡Ð°Ð»Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(192418,5345,'es','Actualizado por otro usuario despuÃ©s de empezar hacer cambios',0),(192419,5345,'de','Von einem anderen Benutzer aktualisiert, nachdem Sie Ã„nderungen begonnen',0),(192420,5345,'en','Updated by another user after you started changes',0),(192421,5346,'is','',0),(192422,5346,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ùˆ   ÙˆÙŠØ±Ø§ÙŠØ´  Ø«Ø¨Øª Ù‡Ø§ÙŠ  Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„  Ùˆ Ø¯ÙØªØ± Ø±ÙˆØ² Ù†Ø§Ù…Ù‡',0),(192423,5346,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ùˆ   ÙˆÙŠØ±Ø§ÙŠØ´  Ø«Ø¨Øª Ù‡Ø§ÙŠ  Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„  Ùˆ Ø¯ÙØªØ± Ø±ÙˆØ² Ù†Ø§Ù…Ù‡',0),(192424,5346,'tr','OluÅŸturmak ve genel muhasebe gÃ¼nlÃ¼ÄŸÃ¼ girdilerini dÃ¼zenlemek',0),(192425,5346,'pl','TworzyÄ‡ i edytowaÄ‡ wpisy ogÃ³lne arkusza ksiÄ™gi',0),(192426,5346,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² ÐºÐ½Ð¸Ð³Ð° Ð·Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(192427,5346,'ur','ØªØ®Ù„ÛŒÙ‚ Ø§ÙˆØ± Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(192428,5346,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¸ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑšÐ¸Ð³Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐ°',0),(192429,5346,'vi','Táº¡o Má»›i & Sá»­a CÃ¡c Má»¥c Ghi ChÃ©p Trong Sá»• CÃ¡i Tá»•ng Há»£p',0),(192430,5346,'af','Skep en Redigeer Algemene Grootboek Joernaalinskrywings',0),(192431,5346,'ro','CreaÅ£i ÅŸi sÄƒ editaÅ£i jurnalul de contabilitate General intrÄƒri',0),(192432,5346,'et','Loo ja Redigeeri Ã¼ldine pearaamatutÃ¶Ã¶lehe kanded',0),(192433,5346,'si','Ustvarjanje in urejanje General Ledger dnevnik',0),(192434,5346,'ba','Membuat dan mengedit entri General Ledger jurnal',0),(192435,5346,'nl','Maken en bewerken van dagboekposten Ledger',0),(192436,5346,'fi','Luo ja Muokkaa yleiset kirjanpidon kirjauskansion tapahtumat',0),(192437,5346,'no','Opprette og redigere General Ledger loggoppfÃ¸ringer',0),(192438,5346,'da','Oprette og redigere General Ledger journaloptegnelser',0),(192439,5346,'ko','ë§Œë“¤ê¸° ë° ì¼ë°˜ ë ˆì € ì—…ë¬´ ì¼ì§€ í•­ëª© íŽ¸ì§‘',0),(192440,5346,'he','×™×¦×™×¨×” ×•×¢×¨×™×›×” ×©×œ ×¢×¨×›×™ ×™×•×ž×Ÿ ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™',0),(192441,5346,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ ÎºÎ±Î¹ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î³ÎµÎ½Î¹ÎºÎ®Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚',0),(192442,5346,'zh','åˆ›å»ºå’Œç¼–è¾‘æ€»å¸æ—¥è®°å¸åˆ†å½•\r\n',0),(192443,5346,'sv','Skapa och redigera General Ledger journalposter',0),(192444,5346,'it','Creare e modificare le voci del diario di contabilitÃ  generale',0),(192445,5346,'tl','',0),(192446,5346,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3621;&#3632;&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;&#3649;&#3618;&#3585;&#3',0),(192447,5346,'hi','à¤¬à¤¨à¤¾à¤à¤ à¤”à¤° à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾à¤¬à¤¹à¥€ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(192448,5346,'ms','Mencipta dan mengedit catatan jurnal Lejar Am',0),(192449,5346,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙˆØªØ­Ø±ÙŠØ± Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(192450,5346,'fr','CrÃ©er et modifier des entrÃ©es de Journal grand livre gÃ©nÃ©ral',0),(192451,5346,'jp','ç·?å‹˜å®šå…ƒå¸³ã‚¸ãƒ£ãƒ¼ãƒŠãƒ«ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?®ä½œæˆ?ã?¨ç·¨é›†',0),(192452,5346,'pt','Criar e editar entradas de diÃ¡rio-razÃ£o geral',0),(192453,5346,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¸ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð–ÑƒÑ€Ð½Ð°Ð»Ð° Ð“Ð»Ð°Ð²Ð½Ð¾Ð¹ ÐšÐ½Ð¸Ð³Ð¸',0),(192454,5346,'es','Crear y Editar Entrada del Diario',0),(192455,5346,'de','Erstellen und Bearbeiten von General Ledger JournaleintrÃ¤ge',0),(192456,5346,'en','Create and Edit General Ledger Journal Entries',0),(192457,5347,'is','',0),(192458,5347,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ùˆ   ÙˆÙŠØ±Ø§ÙŠØ´  ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ',0),(192459,5347,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ùˆ   ÙˆÙŠØ±Ø§ÙŠØ´  ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ',0),(192460,5347,'tr','OluÅŸturma ve dÃ¼zenleme faturalarÄ±',0),(192461,5347,'pl','Tworzenie i edytowanie faktur',0),(192462,5347,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(192463,5347,'ur','ØªØ®Ù„ÛŒÙ‚ Ø§ÙˆØ± ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(192464,5347,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¸ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(192465,5347,'vi','Táº¡o má»›i & sá»­a HÃ³a ÄÆ¡n',0),(192466,5347,'af','Skep en Redigeer Fakture',0),(192467,5347,'ro','Crea ÅŸi edita facturi',0),(192468,5347,'et','Loo ja muuda arveid',0),(192469,5347,'si','Ustvarjanje in urejanje raÄunov',0),(192470,5347,'ba','Membuat dan mengedit faktur',0),(192471,5347,'nl','Maken en bewerken van facturen',0),(192472,5347,'fi','Luoda ja muokata laskuja',0),(192473,5347,'no','Opprette og redigere fakturaer',0),(192474,5347,'da','Oprette og redigere fakturaer',0),(192475,5347,'ko','ë§Œë“¤ê³  ì†¡ìž¥ì„ íŽ¸ì§‘í•©ë‹ˆë‹¤',0),(192476,5347,'he','×¦×•×¨ ×•×¢×¨×•×š ×—×©×‘×•× ×™×•×ª',0),(192477,5347,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ ÎºÎ±Î¹ ÎµÎºÎ´ÏŽÏƒÏ„Îµ Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(192478,5347,'zh','åˆ›å»ºå’Œç¼–è¾‘å‘ç¥¨\r\n',0),(192479,5347,'sv','Skapa och redigera fakturor',0),(192480,5347,'it','Creare e modificare fatture',0),(192481,5347,'tl','',0),(192482,5347,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3621;&#3632;&#3649;&#3585;&#3657;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(192483,5347,'hi','à¤¬à¤¨à¤¾à¤à¤ à¤”à¤° à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(192484,5347,'ms','Mencipta dan mengedit invois',0),(192485,5347,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙˆØªØ­Ø±ÙŠØ± Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(192486,5347,'fr','CrÃ©er et Ã©diter des factures',0),(192487,5347,'jp','è«‹æ±‚æ›¸ã?®ä½œæˆ?ã?¨ç·¨é›†',0),(192488,5347,'pt','Criar e editar facturas',0),(192489,5347,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¸ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚Ð°',0),(192490,5347,'es','Crear y Editar Facturas',0),(192491,5347,'de','Erstellen und Bearbeiten von Rechnungen',0),(192492,5347,'en','Create and Edit Invoices',0),(192493,5348,'is','',0),(192494,5348,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ùˆ ÙˆÙŠØ±Ø§ÙŠØ´  Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(192495,5348,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ùˆ ÙˆÙŠØ±Ø§ÙŠØ´  Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(192496,5348,'tr','OluÅŸturma ve dÃ¼zenleme sipariÅŸler',0),(192497,5348,'pl','TworzyÄ‡ i edytowaÄ‡ zamÃ³wienia',0),(192498,5348,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(192499,5348,'ur','ØªØ®Ù„ÛŒÙ‚ Ø§ÙˆØ± Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ… Ú©Ø±ÛŒÚº',0),(192500,5348,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¸ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(192501,5348,'vi','Táº¡o má»›i & chá»‰nh sá»­a ÄÆ¡n Ä‘áº·t hÃ ng',0),(192502,5348,'af','Invoer en Opdateer Nuwe Bestellings',0),(192503,5348,'ro','CreaÅ£i ÅŸi sÄƒ editaÅ£i comenzile',0),(192504,5348,'et','Loo ja muuda tellimusi',0),(192505,5348,'si','Ustvarite in urejajte naroÄila',0),(192506,5348,'ba','Buat dan Ganti Pesanan',0),(192507,5348,'nl','Maken en bewerken van Orders',0),(192508,5348,'fi','Luo ja Muokkaa tilauksia',0),(192509,5348,'no','Opprette og redigere ordrer',0),(192510,5348,'da','Oprette og redigere ordrer',0),(192511,5348,'ko','ë§Œë“¤ê¸° ë° íŽ¸ì§‘ ëª…ë ¹',0),(192512,5348,'he','×™×¦×™×¨×ª ×•×¢×¨×™×›×ª ×”×–×ž× ×•×ª',0),(192513,5348,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ ÎºÎ±Î¹ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(192514,5348,'zh','åˆ›å»ºå’Œç¼–è¾‘å‘½ä»¤',0),(192515,5348,'sv','Skapa och redigera order',0),(192516,5348,'it','Creare e modificare gli ordini',0),(192517,5348,'tl','',0),(192518,5348,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3621;&#3632;&#3649;&#3585;&#3657;&#3652;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(192519,5348,'hi','à¤¬à¤¨à¤¾à¤à¤ à¤”à¤° à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(192520,5348,'ms','Mencipta dan mengedit arahan',0),(192521,5348,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙˆØªØ­Ø±ÙŠØ± Ø£ÙˆØ§Ù…Ø±',0),(192522,5348,'fr','Entrer et changer commandes nouvelle',0),(192523,5348,'jp','æ³¨æ–‡ã?®ä½œæˆ?ã?¨ç·¨é›†',0),(192524,5348,'pt','Criar e editar ordens',0),(192525,5348,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¸ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(192526,5348,'es','Crear y Editar Pedidos',0),(192527,5348,'de','Erstellen und Bearbeiten von Bestellungen',0),(192528,5348,'en','Create and Edit Orders',0),(192529,5349,'is','',0),(192530,5349,'dr','Ø®Ù„Ø§ØµÙ‡ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ â€“ Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø²Ø¦ÙŠØ§Øª Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(192531,5349,'pr','Ø®Ù„Ø§ØµÙ‡ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ â€“ Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø²Ø¦ÙŠØ§Øª Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³Ù†ÙŠ',0),(192532,5349,'tr','Faturalar - ayrÄ±ntÄ± raporu Ã–zet listesi',0),(192533,5349,'pl','Podsumowanie listy faktur - szczegÃ³Å‚owy raport wiekowania',0),(192534,5349,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½Ð¸ ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ - ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(192535,5349,'ur','Ø®Ù„Ø§ØµÛ’ Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ø®Ø³ØªÛ-',0),(192536,5349,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð»Ð¸ÑÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° - ÑÑ‚Ð°Ñ€ÐµÑšÐ° Ð´ÐµÑ‚Ð°Ñ™Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(192537,5349,'vi','Tá»•ng Há»£p Danh SÃ¡ch HÃ³a ÄÆ¡n - BÃ¡o CÃ¡o Tuá»•i Ná»£ Chi Tiáº¿t',0),(192538,5349,'af','Opsommingslyste van Fakture - Ouderdoms Gedetailleerde Verslag',0),(192539,5349,'ro','Rezumat liste de facturi - Aging raport de tip detaliu',0),(192540,5349,'et','Ning arvete - vananemist Ã¼ksikasjalik aruanne',0),(192541,5349,'si','Povzetek sezname raÄunov - staranje podrobno poroÄilo',0),(192542,5349,'ba','Daftar ringkasan tagihan - penuaan laporan rinci',0),(192543,5349,'nl','Samenvatting lijsten van facturen - veroudering Detail verslag',0),(192544,5349,'fi','Yhteenveto-luettelot laskujen - ikÃ¤Ã¤ntyminen yksityiskohtainen raportti',0),(192545,5349,'no','Sammendrag lister over fakturaer - aldring detaljert rapport',0),(192546,5349,'da','Sammenfattende lister over fakturaer - Aging detaljeret rapport',0),(192547,5349,'ko','ì†¡ìž¥-ë…¸í™” ì„¸ë¶€ ì •ë³´ ë³´ê³ ì„œì˜ ìš”ì•½ ëª©ë¡',0),(192548,5349,'he','×¨×©×™×ž×•×ª ×¡×™×›×•× ×©×œ ×—×©×‘×•× ×™×•×ª - ×¤×™×¨×•×˜ ×“×•×— ×’×™×•×œ',0),(192549,5349,'el','Î£Ï…Î½Î¿Ï€Ï„Î¹ÎºÎ¿Î¯ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Ï„Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½ - Î³Î®ÏÎ±Î½ÏƒÎ· ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½',0),(192550,5349,'zh','å‘ç¥¨çš„æ‘˜è¦åˆ—è¡¨ -è€åŒ–ç»†èŠ‚æŠ¥å‘Š\r\n',0),(192551,5349,'sv','Sammanfattning listor Ã¶ver fakturor - detalj Ã…ldersrapport',0),(192552,5349,'it','Liste di riepilogo delle fatture - invecchiamento Report dettaglio',0),(192553,5349,'tl','',0),(192554,5349,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657; - &#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;',0),(192555,5349,'hi','à¤šà¤¾à¤²à¤¾à¤¨ - à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ à¤•à¥‡ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(192556,5349,'ms','Ringkasan senarai invois - penuaan laporan terperinci',0),(192557,5349,'ar','Ù‚ÙˆØ§Ø¦Ù… Ù…ÙˆØ¬Ø²Ø© Ù…Ù† Ø§Ù„ÙÙˆØ§ØªÙŠØ±-Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© ØªÙØ§ØµÙŠÙ„ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(192558,5349,'fr','Listes sommaires des factures - rapport dÃ©taillÃ© de vieillissement',0),(192559,5349,'jp','è«‹æ±‚æ›¸ã?®ã‚µãƒžãƒªãƒ¼ãƒªã‚¹ãƒˆãƒ¼ã‚¨ãƒ¼ã‚¸ãƒ³ã‚°è©³ç´°ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(192560,5349,'pt','Resumidas listas de faturas - detalhe relatÃ³rio do envelhecimento',0),(192561,5349,'ru','Ð¡Ð²Ð¾Ð´Ð½Ñ‹Ðµ ÑÐ¿Ð¸ÑÐºÐ¸ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€ - ÑÑ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(192562,5349,'es','Listas de Resumen de Facturas - Informe Detallado de AntigÃ¼edad',0),(192563,5349,'de','Zusammenfassende Liste der Rechnungen - Alterung Detailbericht',0),(192564,5349,'en','Summary Lists of Invoices - Aging Detail Report',0),(192565,5350,'is','',0),(192566,5350,'dr','Ø§ØµÙ„Ø§Ø­ ÙƒØ±Ø¯Ù† Ù…ØªÙ† Ù†Ù…Ø§ÙŠØ´ â€“ ÙˆÙŠØ±Ø§ÙŠØ´ ØªØ±Ø¬Ù…Ù‡ Ù‡Ø§ ',0),(192567,5350,'pr','Ø§ØµÙ„Ø§Ø­ ÙƒØ±Ø¯Ù† Ù…ØªÙ† Ù†Ù…Ø§ÙŠØ´ â€“ ÙˆÙŠØ±Ø§ÙŠØ´ ØªØ±Ø¬Ù…Ù‡ Ù‡Ø§ ',0),(192568,5350,'tr','GÃ¶rÃ¼ntÃ¼ metni - dÃ¼zen Ã§evirileri deÄŸiÅŸtirmek',0),(192569,5350,'pl','ZmieniÄ‡ wyÅ›wietlany tekst - edycja tÅ‚umaczeÅ„',0),(192570,5350,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð´Ð¸ÑÐ¿Ð»ÐµÑ Ñ‚ÐµÐºÑÑ‚ - Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð´Ð¸',0),(192571,5350,'ur','ÚˆØ³Ù¾Ù„Û’ Ù…ØªÙ† - ØªØ¯ÙˆÛŒÙ† ØªØ±Ø¬Ù…Û Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ… Ú©Ø±ÛŒÚº',0),(192572,5350,'sr','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ñ‚ÐµÐºÑÑ‚ Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð· - ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ñ€ÐµÐ²Ð¾Ð´Ðµ',0),(192573,5350,'vi','Chá»‰nh sá»­a hiá»ƒn thá»‹ vÄƒn báº£n - Sá»­a ná»™i dung dá»‹ch',0),(192574,5350,'af','Verander Vertoonde Teks - Redigeer Vertalings',0),(192575,5350,'ro','Modificare Text de afiÅŸat - Editare traducere',0),(192576,5350,'et','Muutke tekst - Edit tÃµlge',0),(192577,5350,'si','Spreminjanje prikaza besedila - urejanje prevodi',0),(192578,5350,'ba','Mengubah tampilan teks - mengedit terjemahan',0),(192579,5350,'nl','Weergavetekst - bewerken vertalingen wijzigen',0),(192580,5350,'fi','Muokata nÃ¤yttÃ¶tekstiÃ¤ - Muokkaa kÃ¤Ã¤nnÃ¶kset',0),(192581,5350,'no','Endre tekst - Rediger oversettelser',0),(192582,5350,'da','Ã†ndre tekst - Rediger oversÃ¦ttelser',0),(192583,5350,'ko','ë””ìŠ¤í”Œë ˆì´ í…ìŠ¤íŠ¸-íŽ¸ì§‘ ë²ˆì—­ ìˆ˜ì •',0),(192584,5350,'he','×œ×©× ×•×ª ××ª ×˜×§×¡×˜ ×”×ª×¦×•×’×” - ×¢×¨×™×›×ª ×ª×¨×’×•×ž×™×',0),(192585,5350,'el','Î¤ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î¿ ÎµÎ¼Ï†Î±Î½Î¹Î¶ÏŒÎ¼ÎµÎ½Î¿ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ - ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼ÎµÏ„Î±Ï†ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(192586,5350,'zh','ä¿®æ”¹æ˜¾ç¤ºæ–‡å­— -ç¼–è¾‘ç¿»è¯‘\r\n',0),(192587,5350,'sv','Ã„ndra visningstexten - redigera Ã¶versÃ¤ttningar',0),(192588,5350,'it','Modificare il testo visualizzato - Modifica traduzioni',0),(192589,5350,'tl','',0),(192590,5350,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3607;&#3637;&#3656;&#3649;&#3626;&#3604;&#3591; - &#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3649;&#3611;&#3621;',0),(192591,5350,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤ªà¤¾à¤  - à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤…à¤¨à¥à¤µà¤¾à¤¦à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(192592,5350,'ms','Mengubahsuai paparan teks - mengedit penterjemahan',0),(192593,5350,'ar','ØªØ¹Ø¯ÙŠÙ„ Ø¹Ø±Ø¶ Ù†Øµ-ØªØ­Ø±ÙŠØ± Ø§Ù„ØªØ±Ø¬Ù…Ø§Øª',0),(192594,5350,'fr','Modifier le texte affichÃ© - traductions de Edit',0),(192595,5350,'jp','è¡¨ç¤ºæ–‡ç« ã?®ä¿®æ­£ãƒ¼ç¿»è¨³ã?®ç·¨é›†',0),(192596,5350,'pt','Modificar o texto de exibiÃ§Ã£o - Editar traduÃ§Ãµes',0),(192597,5350,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°ÐµÐ¼Ñ‹Ð¹ Ñ‚ÐµÐºÑÑ‚ - Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ð¾Ð²',0),(192598,5350,'es','Modificar Testo Desplegado - Editar Traduccciones',0),(192599,5350,'de','Ã„ndern der Anzeigetext - Edit-Ãœbersetzungen',0),(192600,5350,'en','Modify Display Text - Edit Translations',0),(192601,5351,'is','',0),(192602,5351,'dr','(Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ ) Ø¨Ø§Ø·Ù„ Ø§Ø³Øª',0),(192603,5351,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ (Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ ) Ø¨Ø§Ø·Ù„ Ø§Ø³Øª',0),(192604,5351,'tr','Fatura Ã¶deme boÅŸluÄŸu FaturalandÄ±rma',0),(192605,5351,'pl','PÅ‚atnoÅ›ci faktury pÅ‚atnoÅ›ci Void',0),(192606,5351,'bg','Ð‘Ð¸Ð»Ð¸Ð½Ð³ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Void',0),(192607,5351,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¨Û’ Ø¹Ù‚Ù„ Ø­Ø³Ø§Ø¨ Ú©Ø±Ù†Ø§',0),(192608,5351,'sr','ÐÐ°Ð¿Ð»Ð°Ñ‚Ðµ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(192609,5351,'vi','Thanh ToÃ¡n HÃ³a ÄÆ¡n Pháº£i Thu VÃ´ Hiá»‡u',0),(192610,5351,'af','Fakturering faktuur betaling leemte',0),(192611,5351,'ro','Golul de plata facturii de facturare',0),(192612,5351,'et','Arveldus arve tasumise Void',0),(192613,5351,'si','ZaraÄunavanje niÄna plaÄila raÄuna',0),(192614,5351,'ba','Penagihan faktur pembayaran kekosongan',0),(192615,5351,'nl','Facturering factuur betaling Void',0),(192616,5351,'fi','Laskutus laskun maksu Void',0),(192617,5351,'no','Fakturering faktura betaling Void',0),(192618,5351,'da','Fakturering faktura betaling tomrum',0),(192619,5351,'ko','ì†¡ìž¥ ì§€ë¶ˆ ë¬´íš¨ ì²­êµ¬',0),(192620,5351,'he','×—×™×•×‘ ×—×©×‘×•× ×™×ª ×”×ª×©×œ×•× Void',0),(192621,5351,'el','Î§ÏÎ­Ï‰ÏƒÎ·Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ ÎºÎµÎ½ÏŒ',0),(192622,5351,'zh','æ”¶æ¬¾å‘ç¥¨ä»˜æ¬¾æ— æ•ˆ\r\n',0),(192623,5351,'sv','Fakturering faktura betalning Void',0),(192624,5351,'it','Fatturazione fattura pagamento Void',0),(192625,5351,'tl','',0),(192626,5351,'th','&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3594;&#3635;&#3619;&#3632;&#3627;&#3609;&#3637;&#3657;&#3605;&#3634;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3650;&#3617;&#3590;&#3632;',0),(192627,5351,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¥‚à¤¨à¥à¤¯',0),(192628,5351,'ms','Bil invois pembayaran tidak',0),(192629,5351,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ÙØ±Ø§Øº Ø¯ÙØ¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(192630,5351,'fr','Facturation facture paiement vide',0),(192631,5351,'jp','å?—ã?‘å?–ã‚Šè«‹æ±‚æ”¯æ‰•ã?„ã?®ç ´æ£„',0),(192632,5351,'pt','Vazio de pagamento de fatura de cobranÃ§a',0),(192633,5351,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ñ‹ ÑÑ‡ÐµÑ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Void',0),(192634,5351,'es','CC Pago de Factura Nulo',0),(192635,5351,'de','Abrechnung Rechnung Zahlung Void',0),(192636,5351,'en','Billing Invoice Payment Void',0),(192637,5352,'is','',0),(192638,5352,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† Ù†ÙŠØ³Øª ',0),(192639,5352,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† Ù†ÙŠØ³Øª ',0),(192640,5352,'tr','Ä°ptal edilemiyor',0),(192641,5352,'pl','Stanie niewaÅ¼ne',0),(192642,5352,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½ÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸',0),(192643,5352,'ur','Ø¨Ø±Ø¨Ø§Ø¯ Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ø§ÛÙ„',0),(192644,5352,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ñƒ',0),(192645,5352,'vi','KhÃ´ng xÃ³a Ä‘Æ°á»£c',0),(192646,5352,'af','Kon nie leemte',0),(192647,5352,'ro','Imposibil de nul',0),(192648,5352,'et','Suuda tÃ¼hine',0),(192649,5352,'si','More niÄna',0),(192650,5352,'ba','Mampu Batal',0),(192651,5352,'nl','Kan niet nietig',0),(192652,5352,'fi','Ei mitÃ¤tÃ¶n',0),(192653,5352,'no','Kunne void',0),(192654,5352,'da','AfskÃ¥ret fra ugyldige',0),(192655,5352,'ko','Void ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(192656,5352,'he','××¤×©×¨×•×ª ×œ×‘×™×˜×•×œ',0),(192657,5352,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î¬ÎºÏ…ÏÎ·',0),(192658,5352,'zh','æ— æ³•ä½œåºŸ\r\n',0),(192659,5352,'sv','Det gÃ¥r inte att annullera',0),(192660,5352,'it','Grado di vuoto',0),(192661,5352,'tl','',0),(192662,5352,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3611;&#3655;&#3609;&#3650;&#3617;&#3590;&#3632;',0),(192663,5352,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(192664,5352,'ms','Tidak dapat tidak sah',0),(192665,5352,'ar','Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¨Ø§Ø·Ù„',0),(192666,5352,'fr','Incapable d\'uriner',0),(192667,5352,'jp','ç ´æ£„ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(192668,5352,'pt','Incapaz de urinar',0),(192669,5352,'ru','ÐÐµ void',0),(192670,5352,'es','No se Puede anular',0),(192671,5352,'de','Nicht in der Lage auf void',0),(192672,5352,'en','Unable to void',0),(192673,5353,'is','',0),(192674,5353,'dr','Ø§Ø¨Ø·Ø§Ù„ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(192675,5353,'pr','Ø§Ø¨Ø·Ø§Ù„ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(192676,5353,'tr','GeÃ§ersiz seÃ§im',0),(192677,5353,'pl','UniewaÅ¼nienia wyborÃ³w',0),(192678,5353,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð¸Ð·Ð±Ð¾Ñ€',0),(192679,5353,'ur','Ø¨Ø§Ø·Ù„ Ú©Û’ Ø§Ù†ØªØ®Ø§Ø¨Ø§Øª',0),(192680,5353,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ð¾Ð´Ð°Ð±Ð¸Ñ€Ðµ',0),(192681,5353,'vi','Há»§y lá»±a chá»n',0),(192682,5353,'af','Leemte seleksies',0),(192683,5353,'ro','Anula selecÅ£iile',0),(192684,5353,'et','Annulleeri valikud',0),(192685,5353,'si','Neveljavne izborov',0),(192686,5353,'ba','Membatalkan pilihan',0),(192687,5353,'nl','VOID selecties',0),(192688,5353,'fi','MitÃ¤tÃ¶n valinnat',0),(192689,5353,'no','Ugyldig valg',0),(192690,5353,'da','Ugyldigt valg',0),(192691,5353,'ko','ì„ íƒ ì·¨ì†Œ',0),(192692,5353,'he','×‘×—×™×¨×•×ª void',0),(192693,5353,'el','Î†ÎºÏ…ÏÎ· ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(192694,5353,'zh','ä½œåºŸé€‰é¡¹\r\n',0),(192695,5353,'sv','Ogiltigt val',0),(192696,5353,'it','Selezioni nulle',0),(192697,5353,'tl','',0),(192698,5353,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(192699,5353,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤šà¤¯à¤¨à¥‹à¤‚',0),(192700,5353,'ms','Pilihan yang tidak sah',0),(192701,5353,'ar','ØªØ­Ø¯ÙŠØ¯Ø§Øª Ø¨Ø§Ø·Ù„Ø©',0),(192702,5353,'fr','SÃ©lections Sub',0),(192703,5353,'jp','é?¸æŠžè‚¢ã?®ç ´æ£„',0),(192704,5353,'pt','Void seleÃ§Ãµes',0),(192705,5353,'ru','Ð—Ð°Ð¿Ñ€ÐµÑ‰ÐµÐ½Ð½Ñ‹Ð¹ Ð’Ñ‹Ð±Ð¾Ñ€',0),(192706,5353,'es','Anular Selecciones',0),(192707,5353,'de','Void Auswahl',0),(192708,5353,'en','Void Selections',0),(192709,5354,'is','',0),(192710,5354,'dr','Ø¨Ø§ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(192711,5354,'pr','Ø¨Ø§ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(192712,5354,'tr','Fatura numarasÄ± ile',0),(192713,5354,'pl','Przez pÅ‚atnika',0),(192714,5354,'bg','ÐŸÐ¾ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(192715,5354,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(192716,5354,'sr','ÐŸÐ¾ Ð±Ñ€Ð¾Ñ˜Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(192717,5354,'vi','Theo hÃ³a Ä‘Æ¡n sá»‘',0),(192718,5354,'af','Per Faktuur Nommer',0),(192719,5354,'ro','De numÄƒrul facturii',0),(192720,5354,'et','Arvenumbri jÃ¤rgi',0),(192721,5354,'si','Å tevilka raÄuna',0),(192722,5354,'ba','Faktur jumlah',0),(192723,5354,'nl','Door factuurnummer',0),(192724,5354,'fi','Laskun numero',0),(192725,5354,'no','Av fakturanummer',0),(192726,5354,'da','Af fakturanummer',0),(192727,5354,'ko','ì†¡ìž¥ ë²ˆí˜¸',0),(192728,5354,'he','×¢×œ ×™×“×™ ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(192729,5354,'el','Î‘Ï€ÏŒ Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(192730,5354,'zh','æŒ‰å‘ç¥¨å·ç \r\n',0),(192731,5354,'sv','Av fakturanummer',0),(192732,5354,'it','Numero di fattura',0),(192733,5354,'tl','',0),(192734,5354,'th','&#3650;&#3604;&#3618;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(192735,5354,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(192736,5354,'ms','Oleh nombor invois',0),(192737,5354,'ar','Ø­Ø³Ø¨ Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(192738,5354,'fr','Par numÃ©ro de facture',0),(192739,5354,'jp','è«‹æ±‚æ›¸ç•ªå?·åˆ¥',0),(192740,5354,'pt','Pelo nÃºmero da fatura',0),(192741,5354,'ru','ÐŸÐ¾ ÐÐ¾Ð¼ÐµÑ€Ñƒ Ð¡Ñ‡ÐµÑ‚Ð°',0),(192742,5354,'es','Por Numero de Factura',0),(192743,5354,'de','Von Rechnungsnummer',0),(192744,5354,'en','By Invoice Number',0),(192745,5355,'is','',0),(192746,5355,'dr','Ø¨Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(192747,5355,'pr','Ø¨Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(192748,5355,'tr','Ä°le Ã¶deme',0),(192749,5355,'pl','Przez pÅ‚atnoÅ›ci',0),(192750,5355,'bg','Ð§Ñ€ÐµÐ· Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(192751,5355,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(192752,5355,'sr','ÐžÐ´ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(192753,5355,'vi','Do Thanh toÃ¡n',0),(192754,5355,'af','Per Betaling',0),(192755,5355,'ro','De platÄƒ',0),(192756,5355,'et','Makse kaupa',0),(192757,5355,'si','S plaÄilom',0),(192758,5355,'ba','Dengan pembayaran',0),(192759,5355,'nl','Door betaling',0),(192760,5355,'fi','Maksu',0),(192761,5355,'no','Ved betaling',0),(192762,5355,'da','Ved betaling',0),(192763,5355,'ko','ì§€ë¶ˆì— ì˜í•´',0),(192764,5355,'he','×¢×œ ×™×“×™ ×ª×©×œ×•×',0),(192765,5355,'el','ÎœÎµ Ï„Î·Î½ ÎºÎ±Ï„Î±Î²Î¿Î»Î®',0),(192766,5355,'zh','é€šè¿‡ä»˜æ¬¾\r\n',0),(192767,5355,'sv','Genom betalning',0),(192768,5355,'it','Di pagamento',0),(192769,5355,'tl','',0),(192770,5355,'th','&#3650;&#3604;&#3618;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(192771,5355,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(192772,5355,'ms','Dengan bayaran',0),(192773,5355,'ar','Ù‚Ø¨Ù„ Ø§Ù„Ø¯ÙØ¹',0),(192774,5355,'fr','Par paiement',0),(192775,5355,'jp','æ”¯æ‰•åˆ¥',0),(192776,5355,'pt','Por pagamento',0),(192777,5355,'ru','ÐŸÐ¾ Ð¾Ð¿Ð»Ð°Ñ‚Ðµ',0),(192778,5355,'es','Por Pago',0),(192779,5355,'de','Durch Zahlung',0),(192780,5355,'en','By Payment',0),(192781,5356,'is','',0),(192782,5356,'dr','Ø§Ø¨Ø·Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(192783,5356,'pr','Ø§Ø¨Ø·Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(192784,5356,'tr','Void Ã¶demeleri',0),(192785,5356,'pl','UniewaÅ¼niÄ‡ pÅ‚atnoÅ›ci',0),(192786,5356,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(192787,5356,'ur','Ø¨Ø§Ø·Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(192788,5356,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(192789,5356,'vi','Thanh toÃ¡n há»§y',0),(192790,5356,'af','Ongeldige Betalings',0),(192791,5356,'ro','Anula plÄƒÅ£ile',0),(192792,5356,'et','Maksete annulleerimine',0),(192793,5356,'si','NiÄna plaÄila',0),(192794,5356,'ba','Membatalkan pembayaran',0),(192795,5356,'nl','Vervallen betalingen',0),(192796,5356,'fi','MitÃ¤tÃ¶n maksut',0),(192797,5356,'no','Annullere betaling',0),(192798,5356,'da','Ugyldig betalinger',0),(192799,5356,'ko','ë¹„ ì§€ë¶ˆ',0),(192800,5356,'he','×ª×©×œ×•×ž×™× void',0),(192801,5356,'el','Î†ÎºÏ…ÏÎ· Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(192802,5356,'zh','ä»˜æ¬¾ä½œåºŸ\r\n',0),(192803,5356,'sv','Makulera betalningar',0),(192804,5356,'it','Annullare pagamenti',0),(192805,5356,'tl','',0),(192806,5356,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(192807,5356,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(192808,5356,'ms','Pembayaran tidak sah',0),(192809,5356,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¨Ø§Ø·Ù„Ø©',0),(192810,5356,'fr','Paiements Sub',0),(192811,5356,'jp','æ”¯æ‰•ã?„ç„¡åŠ¹',0),(192812,5356,'pt','Void pagamentos',0),(192813,5356,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸',0),(192814,5356,'es','Anular Pagos',0),(192815,5356,'de','Void Zahlungen',0),(192816,5356,'en','Void Payments',0),(192817,5357,'is','',0),(192818,5357,'dr','Ø§Ø¨Ø·Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(192819,5357,'pr','Ø§Ø¨Ø·Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(192820,5357,'tr','Void Ã¶demeler girdi',0),(192821,5357,'pl','UniewaÅ¼niÄ‡ pÅ‚atnoÅ›ci wszedÅ‚',0),(192822,5357,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸',0),(192823,5357,'ur','Ø¨Ø§Ø·Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(192824,5357,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ ÑƒÑˆÐ°Ð¾',0),(192825,5357,'vi','Nháº­p Thanh toÃ¡n há»§y',0),(192826,5357,'af','Ongeldige Betalings Ingevoer',0),(192827,5357,'ro','Anula plÄƒÅ£ile intrat',0),(192828,5357,'et','Annulleeri sisestatud maksed',0),(192829,5357,'si','NiÄna plaÄila, vstopil',0),(192830,5357,'ba','Membatalkan pembayaran yang masuk',0),(192831,5357,'nl','Vervallen betalingen ingevoerd',0),(192832,5357,'fi','MitÃ¤tÃ¶idÃ¤ syÃ¶tetyille maksuille',0),(192833,5357,'no','Ugyldig betalinger som er angitt',0),(192834,5357,'da','Ugyldig betalinger indtastet',0),(192835,5357,'ko','Void ì§€ë¶ˆ ìž…ë ¥',0),(192836,5357,'he','×œ×‘×˜×œ ×ª×©×œ×•× ×©×”×•×–×Ÿ',0),(192837,5357,'el','Î†ÎºÏ…ÏÎ· Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… ÎµÎ³Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹',0),(192838,5357,'zh','ä½œåºŸè¾“å…¥çš„ä»˜æ¬¾\r\n',0),(192839,5357,'sv','Makulera betalningar in',0),(192840,5357,'it','Annullare i pagamenti immessi',0),(192841,5357,'tl','',0),(192842,5357,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(192843,5357,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(192844,5357,'ms','Pembayaran tidak sah yang dimasukkan',0),(192845,5357,'ar','Ø¥ÙØ±Ø§Øº Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„ØªÙŠ Ø¯Ø®Ù„Øª',0),(192846,5357,'fr','Sub paiements inscrits',0),(192847,5357,'jp','å…¥åŠ›ã?•ã‚Œã?Ÿæ”¯æ‰•ã?®ç ´æ£„',0),(192848,5357,'pt','Void pagamentos entrados',0),(192849,5357,'ru','Void Ð·Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð½Ñ‹Ñ… Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(192850,5357,'es','Pagos Anulados Entrados',0),(192851,5357,'de','Void Zahlungen eingegeben',0),(192852,5357,'en','Void Payments Entered',0),(192853,5358,'is','',0),(192854,5358,'dr','Ú†Ùƒ  Ù¾ÙˆÙ„ Ù†Ù‚Ø¯  ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(192855,5358,'pr','Ú†Ùƒ  Ù¾ÙˆÙ„ Ù†Ù‚Ø¯  ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(192856,5358,'tr','Ã‡ek, nakit, kredi kartÄ±',0),(192857,5358,'pl','Czek, gotÃ³wka, karta kredytowa',0),(192858,5358,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ°, Ð² Ð±Ñ€Ð¾Ð¹, ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(192859,5358,'ur','Ú†ÛŒÚ© Ú©ÛŒØ´ØŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ',0),(192860,5358,'sr','Ð§ÐµÐº , Ð½Ð¾Ð²Ð°Ñ†, ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(192861,5358,'vi','SÃ©c, tiá»n máº·t, tháº» tÃ­n dá»¥ng',0),(192862,5358,'af','Tjek, Kontant, Kredietkaart',0),(192863,5358,'ro','Card de Credit check, Cash,',0),(192864,5358,'et','VÃ¤ljaregistreerimine, sularaha, krediitkaardi',0),(192865,5358,'si','ÄŒek, denar, kreditne kartice',0),(192866,5358,'ba','Cek, uang tunai, kartu kredit',0),(192867,5358,'nl','Cheque, Cash, creditcard',0),(192868,5358,'fi','Tarkista, rahaa, luottokortti',0),(192869,5358,'no','Sjekk, kontanter, kredittkort',0),(192870,5358,'da','Check, kontant, kreditkort',0),(192871,5358,'ko','ìˆ˜ í‘œ, í˜„ê¸ˆ, ì‹ ìš© ì¹´ë“œ',0),(192872,5358,'he','×¦\'×§, ×ž×–×•×ž×Ÿ, ×›×¨×˜×™×¡ ××©×¨××™',0),(192873,5358,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚, Î¼ÎµÏ„ÏÎ·Ï„Î¬, Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(192874,5358,'zh','æ”¯ç¥¨ï¼ŒçŽ°é‡‘ï¼Œä¿¡ç”¨å¡\r\n',0),(192875,5358,'sv','Check, kontanter, kreditkort',0),(192876,5358,'it','Assegno, contanti, carta di credito',0),(192877,5358,'tl','',0),(192878,5358,'th','&#3648;&#3594;&#3655;&#3588;,&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;,&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(192879,5358,'hi','à¤šà¥‡à¤•, à¤¨à¤•à¤¦, à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡',0),(192880,5358,'ms','Cek, Wang Tunai, kad kredit',0),(192881,5358,'ar','ØµÙƒÙ‘ , Ù†Ù‚Ø¯ÙŠ ,Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(192882,5358,'fr','ChÃ¨que, argent comptant, carte de crÃ©dit',0),(192883,5358,'jp','å°?åˆ‡æ‰‹ã€?ç?¾é‡‘ã€?ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰',0),(192884,5358,'pt','Cheque, dinheiro, cartÃ£o de crÃ©dito',0),(192885,5358,'ru','Ð§ÐµÐº, Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ðµ, ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(192886,5358,'es','Cheque, Efectivo, Tarjeta de CrÃ©dito',0),(192887,5358,'de','Scheck, Bargeld, Kreditkarte',0),(192888,5358,'en','Check,Cash,Credit Card',0),(192889,5359,'is','',0),(192890,5359,'dr','2,3,5',0),(192891,5359,'pr','2,3,5',0),(192892,5359,'tr','2,3,5',0),(192893,5359,'pl','2,3,5',0),(192894,5359,'bg','2,3,5',0),(192895,5359,'ur','2,3,5',0),(192896,5359,'sr','2,3,5',0),(192897,5359,'vi','2,3,5',0),(192898,5359,'af','2,3,5',0),(192899,5359,'ro','2,3,5',0),(192900,5359,'et','2,3,5',0),(192901,5359,'si','2,3,5',0),(192902,5359,'ba','2,3,5',0),(192903,5359,'nl','2,3,5',0),(192904,5359,'fi','2,3,5',0),(192905,5359,'no','2,3,5',0),(192906,5359,'da','2,3,5',0),(192907,5359,'ko','2,3,5',0),(192908,5359,'he','2,3,5',0),(192909,5359,'el','2,3,5',0),(192910,5359,'zh','çŽ°é‡‘é€‰æ‹©å€¼ï¼š2,3,5\r\n',0),(192911,5359,'sv','2,3,5',0),(192912,5359,'it','2,3,5',0),(192913,5359,'tl','',0),(192914,5359,'th','2,3,5',0),(192915,5359,'hi','2,3,5',0),(192916,5359,'ms','2,3,5',0),(192917,5359,'ar','2,3,5',0),(192918,5359,'fr','2,3,5',0),(192919,5359,'jp','2,3,5',0),(192920,5359,'pt','2,3,5',0),(192921,5359,'ru','2,3,5',0),(192922,5359,'es','2,3,5',0),(192923,5359,'de','2,3,5',0),(192924,5359,'en','2,3,5',0),(192925,5360,'is','',0),(192926,5360,'dr','Ù…Ù‚Ø¯Ø§Ø±  Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(192927,5360,'pr','Ù…Ù‚Ø¯Ø§Ø±  Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(192928,5360,'tr','SMM TutarÄ±',0),(192929,5360,'pl','Kwota KWS',0),(192930,5360,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° ÐžÐ¡ÐŸ',0),(192931,5360,'ur','Ú©Ø§ÙˆÚ¯Ø³ Ù…Ù‚Ø¯Ø§Ø±',0),(192932,5360,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¢ÐŸÐ ',0),(192933,5360,'vi','GiÃ¡ thÃ nh sáº£n pháº©m Ä‘Ã£ bÃ¡n',0),(192934,5360,'af','KVV Bedrag',0),(192935,5360,'ro','SumÄƒ CBV',0),(192936,5360,'et','OMAHINNA summa',0),(192937,5360,'si','Znesek porabe',0),(192938,5360,'ba','Jumlah roda',0),(192939,5360,'nl','KPV-bedrag',0),(192940,5360,'fi','Myytyjen tuotteiden kustannukset',0),(192941,5360,'no','VareforbruksbelÃ¸p',0),(192942,5360,'da','ForbrugsbelÃ¸b',0),(192943,5360,'ko','í†±ë‹ˆ ê¸ˆì•¡',0),(192944,5360,'he','×›×ž×•×ª ×”×—×•×–×™×',0),(192945,5360,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï€Ï‰Î»Î·Î¸Î­Î½Ï„Ï‰Î½',0),(192946,5360,'zh','é”€å”®æˆæœ¬é‡‘é¢\r\n',0),(192947,5360,'sv','KSV-belopp',0),(192948,5360,'it','QuantitÃ  di ingranaggi',0),(192949,5360,'tl','',0),(192950,5360,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3634;&#3618;',0),(192951,5360,'hi','COGS à¤°à¤¾à¤¶à¤¿',0),(192952,5360,'ms','Salah satu alat jumlah',0),(192953,5360,'ar','Ù…Ø¨Ù„Øº ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(192954,5360,'fr','Montant CPV',0),(192955,5360,'jp','ï¼£ï¼¯ï¼§ï¼³ç·?é¡?',0),(192956,5360,'pt','Quantidade de engrenagens',0),(192957,5360,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¡ÐµÐ±ÐµÑÑ‚',0),(192958,5360,'es','Monto de CBV',0),(192959,5360,'de','Lagerverbrauchsbetrag',0),(192960,5360,'en','COGS Amount',0),(192961,5361,'is','',0),(192962,5361,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± ',0),(192963,5361,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± ',0),(192964,5361,'tr','SatÄ±ÅŸ-Fatura ekleme hatasÄ±',0),(192965,5361,'pl','BÅ‚Ä…d wstawiania-faktura sprzedaÅ¼y',0),(192966,5361,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(192967,5361,'ur','ØºÛŒØ± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ÙØ±ÙˆØ®Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(192968,5361,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ¼ÐµÑ‚Ð°ÑšÑƒ ÐºÐ¾Ñ˜Ðµ Ð½Ð¸ÑÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(192969,5361,'vi','Lá»—i khi chÃ¨n giao dá»‹ch bÃ¡n khÃ´ng hÃ³a Ä‘Æ¡n',0),(192970,5361,'af','Fout het ontstaan met die Invoeging van Nie-Faktuur Verkope',0),(192971,5361,'ro','Eroare inserarea Non-facturÄƒ vÃ¢nzÄƒri',0),(192972,5361,'et','Viga paigaldamisel arve mÃ¼Ã¼k',0),(192973,5361,'si','Pri vstavljanju-raÄun prodaje',0),(192974,5361,'ba','Kesalahan memasukkan bebas-faktur penjualan',0),(192975,5361,'nl','Error invoegen niet-factuur Sales',0),(192976,5361,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ ei ole lasku myynti',0),(192977,5361,'no','Feil innsetting av ikke-faktura salg',0),(192978,5361,'da','Fejl indsÃ¦tte ikke-faktura salg',0),(192979,5361,'ko','ì†¡ìž¥ ë¹„ íŒë§¤ ì‚½ìž… ì˜¤ë¥˜',0),(192980,5361,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×ž×›×™×¨×•×ª-×—×©×‘×•× ×™×ª',0),(192981,5361,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î¼Î· Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(192982,5361,'zh','é”™è¯¯æ’å…¥éžå‘ç¥¨é”€å”®',0),(192983,5361,'sv','Fel att infoga icke-faktura fÃ¶rsÃ¤ljning',0),(192984,5361,'it','Errore inserimento Non-fattura vendita',0),(192985,5361,'tl','',0),(192986,5361,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3',0),(192987,5361,'hi','à¤—à¥ˆà¤°-à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(192988,5361,'ms','Kesilapan memasukkan-invois jualan',0),(192989,5361,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¯Ø±Ø§Ø¬ ØºÙŠØ± ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(192990,5361,'fr','Erreur insertion Non-facture vente',0),(192991,5361,'jp','æœªè«‹æ±‚ã‚»ãƒ¼ãƒ«ã‚¹ã?®æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(192992,5361,'pt','Erro de inserÃ§Ã£o nÃ£o-fatura vendas',0),(192993,5361,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²ÑÑ‚Ð°Ð²ÐºÐ¸-ÑÑ‡ÐµÑ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(192994,5361,'es','Error Insertando Ventas No Facturadas',0),(192995,5361,'de','Fehler EinfÃ¼gen von nicht-Invoice-Vertrieb',0),(192996,5361,'en','Error Inserting Non-Invoice Sales',0),(192997,5362,'is','',0),(192998,5362,'dr','( Ø³Ø±Ø¹Øª ',0),(192999,5362,'pr','Ø®Ø·Ø§ Ø¯ Ø± Ù…Ø±Ø­Ù„Ù‡( Ø³Ø±Ø¹Øª ',0),(193000,5362,'tr','AdÄ±mda hata',0),(193001,5362,'pl','BÅ‚Ä…d w kroku',0),(193002,5362,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð² ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(193003,5362,'ur','Ù‚Ø¯Ù… Ù…ÛŒÚº Ù†Ù‚Øµ',0),(193004,5362,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ ÐºÐ¾Ñ€Ð°ÐºÑƒ',0),(193005,5362,'vi','Lá»—i trong quÃ¡ trÃ¬nh',0),(193006,5362,'af','Fout in Stap',0),(193007,5362,'ro','Eroare Ã®n pas',0),(193008,5362,'et','TÃµrge samm',0),(193009,5362,'si','Napaka v korak',0),(193010,5362,'ba','Kesalahan dalam langkah',0),(193011,5362,'nl','Fout in stap',0),(193012,5362,'fi','Virhe vaiheessa',0),(193013,5362,'no','Feil i trinn',0),(193014,5362,'da','Fejl i trin',0),(193015,5362,'ko','ë‹¨ê³„ì—ì„œ ì˜¤ë¥˜',0),(193016,5362,'he','×©×’×™××” ×‘×©×œ×‘',0),(193017,5362,'el','Î£Ï†Î¬Î»Î¼Î± ÏƒÏ„Î¿ Î²Î®Î¼Î±',0),(193018,5362,'zh','é”™è¯¯çš„æ­¥éª¤',0),(193019,5362,'sv','Fel i steg',0),(193020,5362,'it','Errore nel passaggio',0),(193021,5362,'tl','',0),(193022,5362,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3586;&#3633;&#3657;&#3609;&#3605;&#3629;&#3609;',0),(193023,5362,'hi','à¤šà¤°à¤£ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(193024,5362,'ms','Ralat dalam langkah',0),(193025,5362,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø®Ø·ÙˆØ©',0),(193026,5362,'fr','Erreur Ã  l\'Ã©tape',0),(193027,5362,'jp','æ‰‹ç¶šã??ä¸­ã‚¨ãƒ©ãƒ¼',0),(193028,5362,'pt','Erro na etapa',0),(193029,5362,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð² Ð¨Ð°Ð³Ðµ',0),(193030,5362,'es','Error en Paso',0),(193031,5362,'de','Fehler in Schritt',0),(193032,5362,'en','Error in Step',0),(193033,5363,'is','',0),(193034,5363,'dr','Ø¯Ù„ÙŠÙ„ Ù…Ø¹Ø§Ù ÙƒØ±Ø¯Ù† ',0),(193035,5363,'pr','Ø¯Ù„ÙŠÙ„ Ù…Ø¹Ø§Ù ÙƒØ±Ø¯Ù† ',0),(193036,5363,'tr','Muafiyet sebebi',0),(193037,5363,'pl','PowÃ³d zwolnienia',0),(193038,5363,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ñ‚ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(193039,5363,'ur','Ù…Ø³ØªØ«Ù†ÛŒ Ú©ÛŒ ÙˆØ¬Û',0),(193040,5363,'sr','Ð˜Ð·ÑƒÐ·ÐµÑ‚Ð¸ Ñ€Ð°Ð·Ð»Ð¾Ð³',0),(193041,5363,'vi','NguyÃªn nhÃ¢n miá»…n trá»«',0),(193042,5363,'af','Vrystellingsrede',0),(193043,5363,'ro','Motivul scutite',0),(193044,5363,'et','Maksust vabastatud pÃµhjusel',0),(193045,5363,'si','OproÅ¡Äene razlog',0),(193046,5363,'ba','Alasan dibebaskan',0),(193047,5363,'nl','Vrijgesteld reden',0),(193048,5363,'fi','Vapautettu syy',0),(193049,5363,'no','Unntatt grunn',0),(193050,5363,'da','Undtaget grund',0),(193051,5363,'ko','ë©´ì œ ì´ìœ ',0),(193052,5363,'he','×”×¡×™×‘×” ×œ×¤×˜×•×¨',0),(193053,5363,'el','Î‘Ï€Î±Î»Î»Î¬ÏƒÏƒÎ¿Î½Ï„Î±Î¹ Î»ÏŒÎ³Î¿Ï‚',0),(193054,5363,'zh','è±å…çš„åŽŸå› \r\n',0),(193055,5363,'sv','Undanta anledning',0),(193056,5363,'it','Motivo esentato',0),(193057,5363,'tl','',0),(193058,5363,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3607;&#3637;&#3656;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;',0),(193059,5363,'hi','à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤¾à¤°à¤£',0),(193060,5363,'ms','Sebab yang dikecualikan',0),(193061,5363,'ar','Ø³Ø¨Ø¨ Ø§Ù„Ø¥Ø¹ÙØ§Ø¡',0),(193062,5363,'fr','Raison exonÃ©rÃ©',0),(193063,5363,'jp','æŽ§é™¤ç?†ç”±',0),(193064,5363,'pt','RazÃ£o isento',0),(193065,5363,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ñ‹ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(193066,5363,'es','RazÃ³n Exento',0),(193067,5363,'de','Ausgenommen Grund',0),(193068,5363,'en','Exempt Reason',0),(193069,5364,'is','',0),(193070,5364,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(193071,5364,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(193072,5364,'tr','GL SMM hesabÄ±',0),(193073,5364,'pl','GL konto KWS',0),(193074,5364,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° ÐžÐ¡ÐŸ',0),(193075,5364,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ÙˆÚ¯Ø³ Ú©Û’ Ù„ÛŒÛ’',0),(193076,5364,'sr','Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÐÐ’ÐŸÐ ',0),(193077,5364,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Cho GiÃ¡ ThÃ nh HÃ ng BÃ¡n',0),(193078,5364,'af','AG Rekening vir KVV Herverkoop',0),(193079,5364,'ro','GL cont CBV',0),(193080,5364,'et','GL moodustavad HAMMASRATTAD',0),(193081,5364,'si','GL raÄun za porabo',0),(193082,5364,'ba','GL Account untuk roda',0),(193083,5364,'nl','GL Account voor KPV',0),(193084,5364,'fi','Kirjanpitotilin pÃ¤Ã¤tilin hampaat',0),(193085,5364,'no','GL kontoen for VAREFORBRUK',0),(193086,5364,'da','GL konto for VAREFORBRUG',0),(193087,5364,'ko','ì´ ìœ„í•œ GL ê³„ì •',0),(193088,5364,'he','GL ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×ª×•×¨×™×›×ž ×ª×•×œ×¢',0),(193089,5364,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± Ï„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ Î Î©Î›Î—Î˜ÎˆÎÎ¤Î©Î',0),(193090,5364,'zh','æ€»å¸å¸æˆ·çš„é”€å”®æˆæœ¬\r\n',0),(193091,5364,'sv','GL konto fÃ¶r kuggar',0),(193092,5364,'it','GL Account per ingranaggi',0),(193093,5364,'tl','',0),(193094,5364,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(193095,5364,'hi','COGS à¤•à¥‡ à¤²à¤¿à¤ GL à¤–à¤¾à¤¤à¤¾',0),(193096,5364,'ms','GL akaun untuk salah satu alat',0),(193097,5364,'ar','Ø­Ø³Ø§Ø¨ ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(193098,5364,'fr','Compte GL pour CMV',0),(193099,5364,'jp','ï¼£ï¼¯ï¼§ï¼³ã?®ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(193100,5364,'pt','GL conta para engrenagens',0),(193101,5364,'ru','Ð¡Ñ‡ÐµÑ‚ GL Ð´Ð»Ñ Ð·ÑƒÐ±ÑŒÐµÐ²',0),(193102,5364,'es','Cuenta LM para CBV',0),(193103,5364,'de','Sako fÃ¼r ZahnrÃ¤der',0),(193104,5364,'en','GL Account for COGS',0),(193105,5365,'is','',0),(193106,5365,'dr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù† ',0),(193107,5365,'pr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù† ',0),(193108,5365,'tr','NasÄ±l Ã¶deme',0),(193109,5365,'pl','Jak wypÅ‚acane',0),(193110,5365,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ ÐºÐ°Ðº',0),(193111,5365,'ur','Ú©Ø³ Ø·Ø±Ø­ Ø§Ø¯Ø§ Ú©ÛŒØ§',0),(193112,5365,'sr','ÐšÐ°ÐºÐ¾ ÑÑƒ Ñ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ð¸Ð»Ð¸',0),(193113,5365,'vi','Tráº£ tháº¿ nÃ o',0),(193114,5365,'af','Hoe Betaal',0),(193115,5365,'ro','PlÄƒtit cum',0),(193116,5365,'et','Kuidas maksta',0),(193117,5365,'si','Kako plaÄane',0),(193118,5365,'ba','Dibayar bagaimana',0),(193119,5365,'nl','Hoe betaald',0),(193120,5365,'fi','Maksettu miten',0),(193121,5365,'no','Betalt hvordan',0),(193122,5365,'da','Betalt hvordan',0),(193123,5365,'ko','ì–´ë–»ê²Œ ì§€ë¶ˆ',0),(193124,5365,'he','×ž×©×œ×ž×™× ××™×š',0),(193125,5365,'el','Î ÏŽÏ‚ ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹',0),(193126,5365,'zh','å¦‚ä½•æ”¯ä»˜\r\n',0),(193127,5365,'sv','Hur betalas',0),(193128,5365,'it','Pagato come',0),(193129,5365,'tl','',0),(193130,5365,'th','&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3619;',0),(193131,5365,'hi','à¤•à¥ˆà¤¸à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(193132,5365,'ms','Dibayar bagaimana',0),(193133,5365,'ar','ÙƒÙŠÙ ØªØ¯ÙØ¹',0),(193134,5365,'fr','PayÃ© comment',0),(193135,5365,'jp','æ”¯æ‰•æ–¹æ³•',0),(193136,5365,'pt','Pago como',0),(193137,5365,'ru','ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð¾ ÐšÐ°Ðº',0),(193138,5365,'es','Pagado CÃ³mo',0),(193139,5365,'de','Wie bezahlt',0),(193140,5365,'en','Paid How',0),(193141,5366,'is','',0),(193142,5366,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª',0),(193143,5366,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª',0),(193144,5366,'tr','Ã–deme tarihi',0),(193145,5366,'pl','Data pÅ‚atnoÅ›ci',0),(193146,5366,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(193147,5366,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(193148,5366,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(193149,5366,'vi','NgÃ y Thanh ToÃ¡n',0),(193150,5366,'af','Betalingdatum',0),(193151,5366,'ro','Data platii',0),(193152,5366,'et','Makse kuupÃ¤ev',0),(193153,5366,'si','Datum plaÄila',0),(193154,5366,'ba','Tanggal pembayaran',0),(193155,5366,'nl','Betalingsdatum',0),(193156,5366,'fi','MaksupÃ¤ivÃ¤',0),(193157,5366,'no','Betalingsdatoen',0),(193158,5366,'da','Betalingsdato',0),(193159,5366,'ko','ì§€ë¶ˆ ë‚ ì§œ',0),(193160,5366,'he','×ª××¨×™×š ×ª×©×œ×•×',0),(193161,5366,'el','Î—Î¼/Î½Î¯Î± ÎµÎ¾ÏŒÏ†Î»Î·ÏƒÎ·Ï‚',0),(193162,5366,'zh','ä»˜æ¬¾æ—¥æœŸ\r\n',0),(193163,5366,'sv','Betalningsdatum',0),(193164,5366,'it','Data di pagamento',0),(193165,5366,'tl','',0),(193166,5366,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(193167,5366,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(193168,5366,'ms','Tarikh pembayaran',0),(193169,5366,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹',0),(193170,5366,'fr','Date de paiement',0),(193171,5366,'jp','æ”¯æ‰•ã?„æ—¥',0),(193172,5366,'pt','Data de pagamento',0),(193173,5366,'ru','Ð”Ð°Ñ‚Ð° Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹',0),(193174,5366,'es','Fecha de Pago',0),(193175,5366,'de','Zahlungsdatum',0),(193176,5366,'en','Payment Date',0),(193177,5367,'is','',0),(193178,5367,'dr','Ø±Ø³ÙŠØ¯ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ±',0),(193179,5367,'pr','Ø±Ø³ÙŠØ¯ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ±',0),(193180,5367,'tr','Fatura olmadan satÄ±ÅŸ gelirleri',0),(193181,5367,'pl','WpÅ‚ywy sprzedaÅ¼y bez faktur',0),(193182,5367,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ð±ÐµÐ· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(193183,5367,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø¨ØºÛŒØ± Ø³ÛŒÙ„Ø² Ú©ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº',0),(193184,5367,'sr','ÐŸÑ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ñ†Ð°Ð¼Ð° Ð±ÐµÐ· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(193185,5367,'vi','BiÃªn nháº­n bÃ¡n hÃ ng khÃ´ng hÃ³a Ä‘Æ¡n',0),(193186,5367,'af','Verkope kwitansies sonder faktuur',0),(193187,5367,'ro','ÃŽncasÄƒri de vÃ¢nzÄƒri fÄƒrÄƒ facturÄƒ',0),(193188,5367,'et','Ostukviitungid ilma arve',0),(193189,5367,'si','Prodaja prejemki brez raÄuna',0),(193190,5367,'ba','Penjualan penerimaan tanpa faktur',0),(193191,5367,'nl','Verkoop ontvangsten zonder factuur',0),(193192,5367,'fi','Myyntituloja ilman laskua',0),(193193,5367,'no','Avsetning kvitteringer uten faktura',0),(193194,5367,'da','Salg kvitteringer uden faktura',0),(193195,5367,'ko','ì†¡ìž¥ ì—†ì´ íŒë§¤ ì˜ìˆ˜ì¦',0),(193196,5367,'he','×”×—×©×‘×•× ×™×ª ×œ×œ× ×—×©×‘×•× ×™×ª',0),(193197,5367,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î­ÏƒÎ¿Î´Î± Ï‡Ï‰ÏÎ¯Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(193198,5367,'zh','æ²¡æœ‰å‘ç¥¨çš„é”€å”®æ”¶æ®\r\n',0),(193199,5367,'sv','FÃ¶rsÃ¤ljning inleveranser utan faktura',0),(193200,5367,'it','Ricevute di vendita senza fattura',0),(193201,5367,'tl','',0),(193202,5367,'th','&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(193203,5367,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚',0),(193204,5367,'ms','Resit jualan tanpa invois',0),(193205,5367,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¯ÙˆÙ† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(193206,5367,'fr','ReÃ§us de vente sans facture',0),(193207,5367,'jp','è«‹æ±‚æ›¸ã?ªã?—ã?®è²©å£²é ˜å?Žæ›¸',0),(193208,5367,'pt','Recibos de vendas sem nota fiscal',0),(193209,5367,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð±ÐµÐ· ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(193210,5367,'es','Recibos de Ventas Sin Facturas',0),(193211,5367,'de','Belege fÃ¼r Lieferungen ohne Rechnung',0),(193212,5367,'en','Sales Receipts Without Invoice',0),(193213,5368,'is','',0),(193214,5368,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø±Ø³ÙŠØ¯ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ±',0),(193215,5368,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø±Ø³ÙŠØ¯ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ±',0),(193216,5368,'tr','SatÄ±ÅŸ gelirleri olmadan fatura ekleme',0),(193217,5368,'pl','DodaÄ‡ przychody sprzedaÅ¼y bez faktur',0),(193218,5368,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ð±ÐµÐ· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(193219,5368,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø¨ØºÛŒØ± Ø³ÛŒÙ„Ø² Ø±Ø³ÛŒØ¯ÛŒÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(193220,5368,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ñ†Ð°Ð¼Ð° Ð±ÐµÐ· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(193221,5368,'vi','ThÃªm BiÃªn nháº­n bÃ¡n hÃ ng khÃ´ng hÃ³a Ä‘Æ¡n',0),(193222,5368,'af','Voeg verkope kwitansies sonder faktuur',0),(193223,5368,'ro','Adauga Ã®ncasÄƒri vÃ¢nzÄƒri fÄƒrÄƒ facturÄƒ',0),(193224,5368,'et','Lisada ostukviitungid ilma arve',0),(193225,5368,'si','Dodaj prodaje prejemki brez raÄuna',0),(193226,5368,'ba','Tambahkan tanda terima penjualan tanpa faktur',0),(193227,5368,'nl','Verkoop ontvangsten zonder factuur toevoegen',0),(193228,5368,'fi','LisÃ¤Ã¤ myyntituloja ilman laskua',0),(193229,5368,'no','Legge til avsetning kvitteringer uten faktura',0),(193230,5368,'da','TilfÃ¸je salg kvitteringer uden faktura',0),(193231,5368,'ko','ì†¡ìž¥ ì—†ì´ íŒë§¤ ì˜ìˆ˜ì¦ ì¶”ê°€',0),(193232,5368,'he','×”×•×¡×£ ××ª ×”×—×©×‘×•× ×™×ª ×œ×œ× ×—×©×‘×•× ×™×ª',0),(193233,5368,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î»Î±Î²Î­Ï‚ Ï€ÏŽÎ»Î·ÏƒÎµÏ‰Î½ Ï‡Ï‰ÏÎ¯Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(193234,5368,'zh','æ–°å¢žæ²¡æœ‰å‘ç¥¨çš„é”€å”®æ”¶æ®\r\n',0),(193235,5368,'sv','LÃ¤gg till fÃ¶rsÃ¤ljning inleveranser utan faktura',0),(193236,5368,'it','Aggiungi ricevute di vendita senza fattura',0),(193237,5368,'tl','',0),(193238,5368,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3',0),(193239,5368,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(193240,5368,'ms','Tambah resit jualan tanpa invois',0),(193241,5368,'ar','Ø£Ø¶Ù Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¯ÙˆÙ† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(193242,5368,'fr','Ajouter les reÃ§us de vente sans facture',0),(193243,5368,'jp','è«‹æ±‚æ›¸ã?ªã?—è²©å£²é ˜å?Žæ›¸ã?®è¿½åŠ ',0),(193244,5368,'pt','Adicionar recibos de vendas sem nota fiscal',0),(193245,5368,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð±ÐµÐ· ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(193246,5368,'es','Agregar Recibos de Ventas Sin Facturas',0),(193247,5368,'de','FÃ¼gen Sie Belege fÃ¼r Lieferungen ohne Rechnung',0),(193248,5368,'en','Add Sales Receipts Without Invoice',0),(193249,5369,'is','',0),(193250,5369,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(193251,5369,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(193252,5369,'tr','Vergiye tabi satÄ±ÅŸ tutarÄ±',0),(193253,5369,'pl','Kwota podlegajÄ…ca opodatkowaniu sprzedaÅ¼',0),(193254,5369,'bg','ÐžÐ±Ð»Ð°Ð³Ð°ÐµÐ¼Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ ÑÑƒÐ¼Ð°',0),(193255,5369,'ur','Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ ÙØ±ÙˆØ®Øª Ú©ÛŒ Ø±Ù‚Ù…',0),(193256,5369,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° Ð¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(193257,5369,'vi','Doanh sá»‘ chá»‹u thuáº¿',0),(193258,5369,'af','Belasbare Verkoopsbedrag',0),(193259,5369,'ro','Suma impozabilÄƒ vÃ¢nzare',0),(193260,5369,'et','Maksustatava mÃ¼Ã¼gi summa',0),(193261,5369,'si','DavÄni Sale Amount',0),(193262,5369,'ba','Jumlah pajak penjualan',0),(193263,5369,'nl','Belastbare verkoopbedrag',0),(193264,5369,'fi','Verollisen myynnin mÃ¤Ã¤rÃ¤',0),(193265,5369,'no','Skattepliktig salgsbelÃ¸p',0),(193266,5369,'da','Afgiftspligtige salgsbelÃ¸b',0),(193267,5369,'ko','ê³¼ì„¸ íŒë§¤ ê¸ˆì•¡',0),(193268,5369,'he','×¡×›×•× ×—×™×™×‘ ×‘×ž×¡ ×ž×›×™×¨×”',0),(193269,5369,'el','Î ÏŽÎ»Î·ÏƒÎ· Ï†Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­Î¿ Ï€Î¿ÏƒÏŒ',0),(193270,5369,'zh','åº”ç¨Žé”€å”®é¢\r\n',0),(193271,5369,'sv','Skattepliktig fÃ¶rsÃ¤ljningsbelopp',0),(193272,5369,'it','Importo di vendita imponibile',0),(193273,5369,'tl','',0),(193274,5369,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;',0),(193275,5369,'hi','à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤°à¤¾à¤¶à¤¿',0),(193276,5369,'ms','Amaun cukai jualan',0),(193277,5369,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(193278,5369,'fr','Montant imposable de la vente',0),(193279,5369,'jp','èª²ç¨Žå¯¾è±¡è²©å£²é¡?',0),(193280,5369,'pt','Valor de venda tributÃ¡vel',0),(193281,5369,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ñ‹Ñ… Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(193282,5369,'es','Monto de Venta Imponible',0),(193283,5369,'de','Steuerbaren Umsatz',0),(193284,5369,'en','Taxable Sale Amount',0),(193285,5370,'is','',0),(193286,5370,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¹Ø§Ù Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(193287,5370,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¹Ø§Ù Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(193288,5370,'tr','Vergiden muaf satÄ±ÅŸ tutarÄ±',0),(193289,5370,'pl','Kwota zwolniona od podatku sprzedaÅ¼',0),(193290,5370,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÑÑƒÐ¼Ð°',0),(193291,5370,'ur','Ù…Ø³ØªØ´Ù†Ù°ÛŒ ÙØ±ÙˆØ®Øª Ú©ÛŒ Ø±Ù‚Ù…',0),(193292,5370,'sr','Ð¡Ñ‚Ð²Ð¾Ñ€Ð¸Ð»Ð¾ Ð½Ð¾Ð²Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð¸Ð·Ð½Ð¾Ñ',0),(193293,5370,'vi','Doanh sá»‘ Ä‘Æ°á»£c miá»…n thuáº¿',0),(193294,5370,'af','Belasting-vrystelling Verkoopsbedrag',0),(193295,5370,'ro','Valoarea scutitÄƒ de taxe de vÃ¢nzare',0),(193296,5370,'et','Maksuvaba mÃ¼Ã¼gi summa',0),(193297,5370,'si','Znesek davka oproÅ¡Äene prodajo',0),(193298,5370,'ba','Jumlah penjualan bebas pajak',0),(193299,5370,'nl','Belastingvrije verkoopbedrag',0),(193300,5370,'fi','Verovapaa myynti mÃ¤Ã¤rÃ¤',0),(193301,5370,'no','Skattefritatt salgsbelÃ¸p',0),(193302,5370,'da','Skattefri salgsbelÃ¸b',0),(193303,5370,'ko','ì„¸ê¸ˆ ë©´ì œ íŒë§¤ ê¸ˆì•¡',0),(193304,5370,'he','×¡×›×•× ×¤×˜×•×¨ ×ž×ž×¡ ×ž×›×™×¨×”',0),(193305,5370,'el','Î ÏŽÎ»Î·ÏƒÎ· Î±Ï†Î¿ÏÎ¿Î»ÏŒÎ³Î·Ï„Î¿ Ï€Î¿ÏƒÏŒ',0),(193306,5370,'zh','å…ç¨Žé”€å”®é‡‘é¢\r\n',0),(193307,5370,'sv','Skattefri fÃ¶rsÃ¤ljningsbelopp',0),(193308,5370,'it','Importo di vendita esentasse',0),(193309,5370,'tl','',0),(193310,5370,'th','&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(193311,5370,'hi','à¤•à¤° à¤®à¥à¤•à¥à¤¤ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤°à¤¾à¤¶à¤¿',0),(193312,5370,'ms','Amaun dikecualikan cukai jualan',0),(193313,5370,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¨ÙŠØ¹ Ù…Ø¹ÙØ§Ø© Ù…Ù† Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(193314,5370,'fr','Montant des ventes exonÃ©rÃ©es d\'impÃ´t',0),(193315,5370,'jp','ç¨ŽæŽ§é™¤å¯¾è±¡è²©å£²é¡?',0),(193316,5370,'pt','Quantidade de venda isenta de impostos',0),(193317,5370,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð±ÐµÐ·Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(193318,5370,'es','Exento de Impuesto monto de Venta',0),(193319,5370,'de','Steuerfreier Umsatz',0),(193320,5370,'en','Tax-exempt Sale Amount',0),(193321,5371,'is','',0),(193322,5371,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(193323,5371,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(193324,5371,'tr','Kredi kartÄ± satÄ±ÅŸ iÅŸlenmiÅŸ kartÄ± varsayÄ±yorum.',0),(193325,5371,'pl','SprzedaÅ¼ kart kredytowych zaÅ‚oÅ¼yÄ‡ kartÄ™ juÅ¼ przetworzone.',0),(193326,5371,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ñ€Ð¸ÐµÐ¼Ðµ ÐºÐ°Ñ€Ñ‚Ð° Ð²ÐµÑ‡Ðµ ÑÐ° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸.',0),(193327,5371,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ ÙØ±ÙˆØ®Øª Ú©Ø§Ø±Úˆ Ù¾Ø± Ø¹Ù…Ù„Ø¯Ø±Ø¢Ù…Ø¯ Ù¾ÛÙ„Û’ ÛÛŒ ÙØ±Ø¶ ÛÛ’ Û”',0),(193328,5371,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¿Ñ€ÐµÑ‚Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð²ÐµÑ› Ð¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð°.',0),(193329,5371,'vi','Doanh sá»‘ bÃ¡n hÃ ng báº±ng tháº» tÃ­n dá»¥ng dá»±a trÃªn giáº£ Ä‘á»‹nh táº¥t cáº£ cÃ¡c giao dá»‹ch Ä‘Ã£ xá»­ lÃ½',0),(193330,5371,'af','Kredietkaartverkope veronderstel kaart is alreeds geprosesseer.',0),(193331,5371,'ro','Card de credit vÃ¢nzÄƒri presupune carte deja procesate.',0),(193332,5371,'et','Krediitkaardi makse on juba tehtud',0),(193333,5371,'si','Prodaja kreditne kartice prevzeti kartico Å¾e obdelane.',0),(193334,5371,'ba','Penjualan kartu kredit menganggap kartu yang sudah diproses.',0),(193335,5371,'nl','Credit Card verkoop veronderstellen kaart al verwerkt.',0),(193336,5371,'fi','Luottokortin myynti olettaa kortti jo kÃ¤sitelty.',0),(193337,5371,'no','Credit Card salget anta kortet allerede behandlet.',0),(193338,5371,'da','Kreditkort salg antager kortet allerede behandlet.',0),(193339,5371,'ko','ì‹ ìš© ì¹´ë“œ íŒë§¤ ì´ë¯¸ ì²˜ë¦¬ ì¹´ë“œë¥¼ ê°€ì • í•©ë‹ˆë‹¤.',0),(193340,5371,'he','×›×¨×˜×™×¡ ××©×¨××™ ×ž×›×™×¨×•×ª ×œ×”× ×™×— ×§×œ×£ ×›×‘×¨ ×ž×¢×•×‘×“.',0),(193341,5371,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î¼Î­ÏƒÏ‰ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ Î±Î½Î±Î»Î¬Î²ÎµÎ¹ ÎºÎ¬ÏÏ„Î± Î®Î´Î· ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±.',0),(193342,5371,'zh','ä¿¡ç”¨å¡é”€å”®å‡è®¾å¡å·²ç»å¤„ç†ã€‚\r\n',0),(193343,5371,'sv','KreditkortsfÃ¶rsÃ¤ljning antar kort redan bearbetats.',0),(193344,5371,'it','Carta di credito vendite assumere carta giÃ  elaborato.',0),(193345,5371,'tl','',0),(193346,5371,'th','&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;&#3604;&#3657;&#3623;&#3618;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3',0),(193347,5371,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤ªà¤¹à¤²à¥‡ à¤¹à¥€ à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤•à¤¾à¤°à¥à¤¡ à¤²à¤—à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(193348,5371,'ms','Jualan kad kredit menganggap Kad yang sudah diproses.',0),(193349,5371,'ar','Ù…Ø¨ÙŠØ¹Ø§Øª Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ØªØ­Ù…Ù„ Ø¨Ø·Ø§Ù‚Ø© Ù…Ø¹Ø§Ù„Ø¬ØªÙ‡ Ø¨Ø§Ù„ÙØ¹Ù„.',0),(193350,5371,'fr','Ventes de cartes de crÃ©dit suppose carte dÃ©jÃ  traitÃ©.',0),(193351,5371,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰å£²ä¸Šã?¯ã?™ã?§ã?«å‡¦ç?†ã?•ã‚Œã?Ÿã‚‚ã?®ã?¨ã?—ã?¦ä»®å®šã?—ã?¦ã?„ã?¾ã?™ã€‚',0),(193352,5371,'pt','Vendas de cartÃ£o de crÃ©dito que cartÃ£o jÃ¡ processada.',0),(193353,5371,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚ ÑÐµÐ±Ñ ÐºÐ°Ñ€Ñ‚Ñ‹ ÑƒÐ¶Ðµ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½Ñ‹.',0),(193354,5371,'es','Ventas de Tarjetas de CrÃ©dito asumen que la tarjeta ya esta procesada',0),(193355,5371,'de','Kreditkarten-Vertrieb Ã¼bernehmen Karte bereits verarbeitet.',0),(193356,5371,'en','Credit Card Sales assume card already processed.',0),(193357,5372,'is','',0),(193358,5372,'dr','Ø§ÙŠØ¬Ø§Ø¯  ÙŠØ§ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(193359,5372,'pr','Ø§ÙŠØ¬Ø§Ø¯  ÙŠØ§ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(193360,5372,'tr','Bir Ã¶deme planÄ±nÄ± gÃ¼ncelle',0),(193361,5372,'pl','Tworzenie lub aktualizowanie planu pÅ‚atnoÅ›ci',0),(193362,5372,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð¸Ð»Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½',0),(193363,5372,'ur','Ø¨Ù†Ø§Ø¦ÛŒÚº ÛŒØ§ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(193364,5372,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð¸Ð»Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ðµ Ð½Ð° Ñ€Ð°Ñ‚Ðµ',0),(193365,5372,'vi','Táº¡o Má»›i hay cáº­p nháº­t 1 káº¿ hoáº¡ch thanh toÃ¡n',0),(193366,5372,'af','Skep/Redigeer \'n Betalingsplan',0),(193367,5372,'ro','CreaÈ›i sau actualizaÈ›i un Plan de platÄƒ',0),(193368,5372,'et','Loo vÃµi uuenda uut maksegraafikut',0),(193369,5372,'si','Ustvariti ali posodobiti naÄrt plaÄil',0),(193370,5372,'ba','Membuat atau memperbarui sebuah rencana pembayaran',0),(193371,5372,'nl','Maken of bijwerken van een betalingsplan',0),(193372,5372,'fi','Luo tai PÃ¤ivitÃ¤ maksusuunnitelma',0),(193373,5372,'no','Opprett eller oppdater en betalingsplan',0),(193374,5372,'da','Oprette eller opdatere en betalingsordning',0),(193375,5372,'ko','ë§Œë“¤ê¸° ë˜ëŠ” ì§€ë¶ˆ ê³„íš ì—…ë°ì´íŠ¸',0),(193376,5372,'he','×¦×•×¨ ××• ×¢×“×›×Ÿ ×ª×•×›× ×™×ª ×ª×©×œ×•×ž×™×',0),(193377,5372,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î­Î½Î± ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(193378,5372,'zh','åˆ›å»ºæˆ–æ›´æ–°ä»˜æ¬¾è®¡åˆ’\r\n',0),(193379,5372,'sv','Skapa eller uppdatera en betalningsplan',0),(193380,5372,'it','Creare o aggiornare un piano di pagamento',0),(193381,5372,'tl','',0),(193382,5372,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3627;&#3619;&#3639;&#3629;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(193383,5372,'hi','à¤¬à¤¨à¤¾à¤à¤ à¤¯à¤¾ à¤à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(193384,5372,'ms','Mencipta atau mengemaskini pelan pembayaran',0),(193385,5372,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø£Ùˆ ØªØ­Ø¯ÙŠØ« Ø®Ø·Ø© Ø§Ù„Ø¯ÙØ¹',0),(193386,5372,'fr','CrÃ©er ou mettre Ã  jour un Plan de paiement',0),(193387,5372,'jp','æ”¯æ‰•è¨ˆç”»ã?®ä½œæˆ?ã?‹æ›´æ–°',0),(193388,5372,'pt','Criar ou atualizar um plano de pagamento',0),(193389,5372,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¸Ð»Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½',0),(193390,5372,'es','Crear o Actualizar un Plan de Pago',0),(193391,5372,'de','Erstellen Sie oder aktualisieren Sie einen Zahlungsplan',0),(193392,5372,'en','Create or Update a Payment Plan',0),(193393,5373,'is','',0),(193394,5373,'dr','(ÙØ±ÙˆØ´ ) Ù‚Ø¨Ù„Ø§ Ø¯Ø± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(193395,5373,'pr','Ø§ÙŠÙ† Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ  Ø­Ø±Ø§Ø¬ (ÙØ±ÙˆØ´ ) Ù‚Ø¨Ù„Ø§ Ø¯Ø± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(193396,5373,'tr','Bu veritabanÄ±nda zaten satÄ±ÅŸ makbuzu',0),(193397,5373,'pl','To pokwitowanie sprzedaÅ¼y juÅ¼ w bazie danych',0),(193398,5373,'bg','Ð¢Ð°Ð·Ð¸ Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð²ÐµÑ‡Ðµ ÑÐ° Ð² Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸',0),(193399,5373,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù…ÛŒÚº Ù¾ÛÙ„Û’ ÛÛŒ Ø§Ø³ Ú©ÛŒ ÙØ±ÙˆØ®Øª Ú©ÛŒ Ø±Ø³ÛŒØ¯',0),(193400,5373,'sr','ÐžÐ²Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð²ÐµÑ› Ñƒ Ð±Ð°Ð·Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(193401,5373,'vi','BiÃªn nháº­n bÃ¡n hÃ ng nÃ y Ä‘Ã£ cÃ³ trong dá»¯ liá»‡u',0),(193402,5373,'af','Hierdie Verkoopskwitansie is alreeds in Databasis',0),(193403,5373,'ro','AceastÄƒ recepÅ£ie vÃ¢nzÄƒrilor deja Ã®n baza de date',0),(193404,5373,'et','Selle mÃ¼Ã¼gi kviitungi andmebaasis sisalduvatele',0),(193405,5373,'si','To potrdilo prodaje Å¾e v zbirki podatkov',0),(193406,5373,'ba','Terima penjualan ini sudah ada di Database',0),(193407,5373,'nl','Deze verkoop ontvangst al in Database',0),(193408,5373,'fi','Myynti kuitti jo tietokannassa',0),(193409,5373,'no','Salg kvitteringen allerede i databasen',0),(193410,5373,'da','Denne salgs kvittering allerede i databasen',0),(193411,5373,'ko','ë°ì´í„°ë² ì´ìŠ¤ì— ì´ë¯¸ì´ íŒë§¤ ì˜ìˆ˜ì¦',0),(193412,5373,'he','××™×©×•×¨ ×–×” ×ž×›×™×¨×•×ª ×›×‘×¨ ×‘×ž×¡×“',0),(193413,5373,'el','Î‘Ï…Ï„Î® Î· Ï€Î±ÏÎ±Î»Î±Î²Î® Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î®Î´Î· ÏƒÏ„Î· Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(193414,5373,'zh','æ­¤é”€å”®æ”¶æ®å·²ç»åœ¨æ•°æ®åº“ä¸­\r\n',0),(193415,5373,'sv','Denna fÃ¶rsÃ¤ljning kvitto redan i databasen',0),(193416,5373,'it','Questa ricevuta di vendite giÃ  nel Database',0),(193417,5373,'tl','',0),(193418,5373,'th','&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3649;&#3621;&#3657;&#3623;',0),(193419,5373,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤®à¥‡à¤‚ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤¸ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤°à¤¸à¥€à¤¦',0),(193420,5373,'ms','Resit jualan ini sudah ada dalam pangkalan data',0),(193421,5373,'ar','Ø¥ÙŠØµØ§Ù„ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù‡Ø°Ø§ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹ ÙÙŠ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(193422,5373,'fr','Cette facture dÃ©jÃ  dans la base de donnÃ©es',0),(193423,5373,'jp','ã?“ã?®ã‚»ãƒ¼ãƒ«ã‚¹é ˜å?Žæ›¸ã?¯ã?™ã?§ã?«ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(193424,5373,'pt','Este recibo de vendas jÃ¡ no banco de dados',0),(193425,5373,'ru','Ð­Ñ‚Ð¾Ñ‚ Ñ‡ÐµÐº Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ ÑƒÐ¶Ðµ Ð² Ð±Ð°Ð·Ðµ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(193426,5373,'es','Este Recibo de Ventas ya esta en la Base de Datos',0),(193427,5373,'de','Diese Quittung Vertrieb bereits in Datenbank',0),(193428,5373,'en','This Sales Receipt already in Database',0),(193429,5374,'is','',0),(193430,5374,'dr','(ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª)',0),(193431,5374,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø§ÙˆÙ„ÙŠÙ‡(ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª)',0),(193432,5374,'tr','Ã–deme tarihinden baÅŸlamak',0),(193433,5374,'pl','BEGIN data pÅ‚atnoÅ›ci',0),(193434,5374,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(193435,5374,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¢ØºØ§Ø²',0),(193436,5374,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(193437,5374,'vi','NgÃ y báº¯t Ä‘áº§u thanh toÃ¡n',0),(193438,5374,'af','Begin Betalingsdatum',0),(193439,5374,'ro','ÃŽncepe data platii',0),(193440,5374,'et','Makse alustamise kuupÃ¤ev',0),(193441,5374,'si','ZaÄetni datum plaÄila',0),(193442,5374,'ba','Mulai tanggal pembayaran',0),(193443,5374,'nl','Betalingsdatum beginnen',0),(193444,5374,'fi','Alkaa maksupÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(193445,5374,'no','Starte betalingsdatoen',0),(193446,5374,'da','Begynde betalingsdato',0),(193447,5374,'ko','ì§€ë¶ˆ ë‚ ì§œë¥¼ ì‹œìž‘',0),(193448,5374,'he','×ª××¨×™×š ×ª×©×œ×•× ×‘×’×™×Ÿ',0),(193449,5374,'el','ÎˆÎ½Î±ÏÎ¾Î· Î—Î¼/Î½Î¯Î± ÎµÎ¾ÏŒÏ†Î»Î·ÏƒÎ·Ï‚',0),(193450,5374,'zh','å¼€å§‹ä»˜æ¬¾æ—¥æœŸ\r\n',0),(193451,5374,'sv','BÃ¶rja betalningsdatum',0),(193452,5374,'it','Iniziare la data di pagamento',0),(193453,5374,'tl','',0),(193454,5374,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(193455,5374,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿ à¤¶à¥à¤°à¥‚',0),(193456,5374,'ms','Bermula tarikh pembayaran',0),(193457,5374,'ar','ÙŠØ¨Ø¯Ø£ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹',0),(193458,5374,'fr','Date de paiement de Begin',0),(193459,5374,'jp','æ”¯æ‰•æ—¥ã?®é–‹å§‹',0),(193460,5374,'pt','Data de inÃ­cio do pagamento',0),(193461,5374,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹',0),(193462,5374,'es','Iniciar Fecha de Pago',0),(193463,5374,'de','BEGIN Zahlungsdatum',0),(193464,5374,'en','Begin Payment Date',0),(193465,5375,'is','',0),(193466,5375,'dr','Ø±ÙˆÙŠ Ø´Ù†Ø§Ø³Ù‡ Ø±Ø³ÙŠØ¯ ÙØ±ÙˆØ´ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(193467,5375,'pr','Ø±ÙˆÙŠ Ø´Ù†Ø§Ø³Ù‡ Ø±Ø³ÙŠØ¯ ÙØ±ÙˆØ´ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(193468,5375,'tr','SatÄ±ÅŸ AlÄ±ÅŸ irsaliyesi kimliÄŸi Ã¼zerinde dÃ¼zenlemek iÃ§in tÄ±klatÄ±n',0),(193469,5375,'pl','Kliknij na sprzedaÅ¼y identyfikatorÃ³w paragonÃ³w do edycji',0),(193470,5375,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð˜Ð” Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ° Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(193471,5375,'ur','Ø³ÛŒÙ„Ø² Ø±Ø³ÛŒØ¯ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø´Ù†Ø§Ø®Øª Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(193472,5375,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° ÑƒÐ»Ð°Ð·Ð½Ðµ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ñ†Ðµ Ð˜Ð” Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÑ€ÐµÐ´Ð¸Ð»Ð¸',0),(193473,5375,'vi','Nháº¥n VÃ o ID BiÃªn Nháº­n BÃ¡n HÃ ng Äá»ƒ Sá»­a',0),(193474,5375,'af','Kliek om te Verkopekwitansie ID te Redigeer',0),(193475,5375,'ro','FaceÅ£i clic pe vÃ¢nzÄƒri primire ID pentru a edita',0),(193476,5375,'et','MÃ¼Ã¼gi kviitungi ID muutmiseks klÃµpsake',0),(193477,5375,'si','Kliknite na prodajne prejema ID za urejanje',0),(193478,5375,'ba','Klik pada ID Resi penjualan untuk mengedit',0),(193479,5375,'nl','Klik op verkoop ontvangst ID om te bewerken',0),(193480,5375,'fi','Klikkaa myynnin kuitin tunnus muokkaaminen',0),(193481,5375,'no','Klikk pÃ¥ salg bekreftelsen ID Ã¥ redigere',0),(193482,5375,'da','Klik pÃ¥ salg kvitterings-ID til at redigere',0),(193483,5375,'ko','íŒë§¤ ì˜ìˆ˜ì¦ ID íŽ¸ì§‘ í´ë¦­',0),(193484,5375,'he','×œ×—×¥ ×¢×œ ×ž×–×”×” ×”×ž×›×™×¨×•×ª ×§×‘×œ×” ×›×“×™ ×œ×¢×¨×•×š',0),(193485,5375,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ ID Ï€Î±ÏÎ±Î»Î±Î²Î®, Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(193486,5375,'zh','ç‚¹å‡»é”€å”®ç¥¨æ®IDä»¥ç¼–è¾‘\r\n',0),(193487,5375,'sv','Klicka pÃ¥ fÃ¶rsÃ¤ljning kvitto-ID att redigera',0),(193488,5375,'it','Fare clic su vendite ID ricevuta da modificare',0),(193489,5375,'tl','',0),(193490,5375,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3612;&#3641;&#3657;&#3648;&#3626;&#3637;&#3618;&#3616;&#3634;&#3625;&#3637;&#3',0),(193491,5375,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤°à¤¸à¥€à¤¦ ID à¤ªà¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(193492,5375,'ms','Klik pada ID resit jualan untuk mengedit',0),(193493,5375,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù…Ø¹Ø±Ù Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ØªØ­Ø±ÙŠØ±',0),(193494,5375,'fr','Cliquez sur ventes ID de rÃ©ception Ã  modifier',0),(193495,5375,'jp','ã‚»ãƒ¼ãƒ«ã‚¹é ˜å?Žæ›¸ï¼©ï¼¤ã‚’ç·¨é›†ã?™ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯',0),(193496,5375,'pt','Clique em ID de recibo vendas para editar',0),(193497,5375,'ru','Ð©ÐµÐ»ÐºÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°Ð¼ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ðµ ID Ð´Ð»Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(193498,5375,'es','Click sobre el ID del Recibo de Ventas para Editar',0),(193499,5375,'de','Klicken Sie auf Verkauf Erhalt ID bearbeiten',0),(193500,5375,'en','Click on Sales Receipt ID to Edit',0),(193501,5376,'is','',0),(193502,5376,'dr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(193503,5376,'pr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(193504,5376,'tr','Son Ã¶deme tarihi',0),(193505,5376,'pl','Data koÅ„cowa pÅ‚atnoÅ›Ä‡',0),(193506,5376,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(193507,5376,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(193508,5376,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(193509,5376,'vi','NgÃ y Káº¿t thÃºc thanh toÃ¡n',0),(193510,5376,'af','Finale Betalingsdatum',0),(193511,5376,'ro','Termenul de platÄƒ',0),(193512,5376,'et','Maksmise lÃµppkuupÃ¤ev',0),(193513,5376,'si','KonÄni datum plaÄila',0),(193514,5376,'ba','Tanggal pembayaran akhir',0),(193515,5376,'nl','Betaling einddatum',0),(193516,5376,'fi','Maksun pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(193517,5376,'no','Sluttdatoen for betaling',0),(193518,5376,'da','Slutdato for betaling',0),(193519,5376,'ko','ìµœì¢… ì§€ë¶ˆ ë‚ ì§œ',0),(193520,5376,'he','×ª××¨×™×š ×”×ª×©×œ×•× ×§×¦×”',0),(193521,5376,'el','Î¤Î­Î»Î¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(193522,5376,'zh','ç»“æŸä»˜æ¬¾æ—¥æœŸ\r\n',0),(193523,5376,'sv','Slutdatum fÃ¶r betalning',0),(193524,5376,'it','Data di scadenza pagamento',0),(193525,5376,'tl','',0),(193526,5376,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(193527,5376,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(193528,5376,'ms','Tarikh akhir pembayaran',0),(193529,5376,'ar','Ù†Ù‡Ø§ÙŠØ© ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹',0),(193530,5376,'fr','Date de paiement de fin',0),(193531,5376,'jp','æ”¯æ‰•æ—¥ã?®çµ‚äº†',0),(193532,5376,'pt','Data do pagamento final',0),(193533,5376,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹',0),(193534,5376,'es','Fecha Final de Pago',0),(193535,5376,'de','Ende Zahlungsdatum',0),(193536,5376,'en','End Payment Date',0),(193537,5377,'is','',0),(193538,5377,'dr','ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ  ÙØ§ÙƒØªÙˆØ± Ù†Ø´Ø¯Ù‡ ',0),(193539,5377,'pr','ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ  ÙØ§ÙƒØªÙˆØ± Ù†Ø´Ø¯Ù‡ ',0),(193540,5377,'tr','FaturalandÄ±rÄ±lmamÄ±ÅŸ satÄ±ÅŸ',0),(193541,5377,'pl','Niezafakturowanych sprzedaÅ¼y',0),(193542,5377,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(193543,5377,'ur','ØºÛŒØ± Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(193544,5377,'sr','ÐÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(193545,5377,'vi','Doanh sá»‘ khÃ´ng cÃ³ hÃ³a Ä‘Æ¡n',0),(193546,5377,'af','Nie-Invoiced verkope',0),(193547,5377,'ro','Non-facturate de vÃ¢nzÄƒri',0),(193548,5377,'et','Arveldamata mÃ¼Ã¼k',0),(193549,5377,'si','Niso knjiÅ¾ene prodajne',0),(193550,5377,'ba','Bebas tagihan penjualan',0),(193551,5377,'nl','Niet-gefactureerde verkoop',0),(193552,5377,'fi','Laskuttamattomien-myynti',0),(193553,5377,'no','Ikke-fakturerte salg',0),(193554,5377,'da','Ikke-faktureret salg',0),(193555,5377,'ko','ë¹„ ì²­êµ¬ ëœ íŒë§¤',0),(193556,5377,'he','×ž×›×™×¨×•×ª ×œ×œ× ×—×©×‘×•× ×™×ª',0),(193557,5377,'el','ÎœÎ· Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(193558,5377,'zh','ä¸å¼€å…·å‘ç¥¨çš„é”€å”®\r\n',0),(193559,5377,'sv','Icke fakturerade fÃ¶rsÃ¤ljning',0),(193560,5377,'it','Vendite non fatturate',0),(193561,5377,'tl','',0),(193562,5377,'th','&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(193563,5377,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤—à¥ˆà¤° à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(193564,5377,'ms','Invois jualan',0),(193565,5377,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(193566,5377,'fr','Ventes non facturÃ©es',0),(193567,5377,'jp','æœªè«‹æ±‚ã‚»ãƒ¼ãƒ«ã‚¹',0),(193568,5377,'pt','Vendas nÃ£o faturadas',0),(193569,5377,'ru','ÐÐµ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð°Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(193570,5377,'es','Ventas No Facturadas',0),(193571,5377,'de','Nicht fakturierten Umsatz',0),(193572,5377,'en','Non-Invoiced Sales',0),(193573,5378,'is','',0),(193574,5378,'dr','Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ ',0),(193575,5378,'pr','Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ ',0),(193576,5378,'tr','HÃ¼kÃ¼msÃ¼z',0),(193577,5378,'pl','UniewaÅ¼niony',0),(193578,5378,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð½',0),(193579,5378,'ur','ÙˆÙˆØ§ÚˆÛŒØ¯',0),(193580,5378,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½',0),(193581,5378,'vi','ÄÃ£ há»§y',0),(193582,5378,'af','Ontlaste',0),(193583,5378,'ro','Anulat',0),(193584,5378,'et','Annulleeritud',0),(193585,5378,'si','Razveljavljena',0),(193586,5378,'ba','Voided',0),(193587,5378,'nl','Ongeldig',0),(193588,5378,'fi','MitÃ¤tÃ¶ity',0),(193589,5378,'no','Kansellert',0),(193590,5378,'da','Nedlagte',0),(193591,5378,'ko','ë¬´íš¨ ì²˜ë¦¬',0),(193592,5378,'he','×©×ª×•×§×¤×Ÿ ×‘×•×˜×œ',0),(193593,5378,'el','Î‘ÎºÏ…ÏÏŽÎ½ÎµÏ„Î±Î¹',0),(193594,5378,'zh','æ— æ•ˆçš„\r\n',0),(193595,5378,'sv','Annullerad',0),(193596,5378,'it','Annullate',0),(193597,5378,'tl','',0),(193598,5378,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3649;&#3621;&#3657;&#3623;',0),(193599,5378,'hi','Voided',0),(193600,5378,'ms','Voided',0),(193601,5378,'ar','Ù…Ù„ØºØ§Ø©',0),(193602,5378,'fr','AnnulÃ©e',0),(193603,5378,'jp','ç ´æ£„æ¸ˆ',0),(193604,5378,'pt','Anulada',0),(193605,5378,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ',0),(193606,5378,'es','Anulado',0),(193607,5378,'de','Stornierte',0),(193608,5378,'en','Voided',0),(193609,5379,'is','',0),(193610,5379,'dr','ÙŠØ§ ØªÙˆØ³Ø· ÙƒØ§Ø±Ø¨Ø± Ø¯ÙŠÚ¯Ø± Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ ÙˆÙŠØ±Ø§ÙŠØ´ Ù…ÙŠ Ø´Ø¯Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(193611,5379,'pr','ÙŠØ§ ØªÙˆØ³Ø· ÙƒØ§Ø±Ø¨Ø± Ø¯ÙŠÚ¯Ø± Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ ÙˆÙŠØ±Ø§ÙŠØ´ Ù…ÙŠ Ø´Ø¯Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(193612,5379,'tr','veya dÃ¼zenlenmesi iÅŸlemi sÄ±rasÄ±nda baÅŸka bir kullanÄ±cÄ± tarafÄ±ndan gÃ¼ncelleÅŸtirilmiÅŸ',0),(193613,5379,'pl','lub zaktualizowany przez innego uÅ¼ytkownika podczas edycji',0),(193614,5379,'bg','Ð¸Ð»Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ Ð¾Ñ‚ Ð´Ñ€ÑƒÐ³ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ», Ð´Ð¾ÐºÐ°Ñ‚Ð¾ ÑÐµ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°',0),(193615,5379,'ur','ÛŒØ§ Ú©Ø³ÛŒ Ø¯ÙˆØ³Ø±Û’ ØµØ§Ø±Ù Ú©Ùˆ ØªØ¯ÙˆÛŒÙ† Ú©ÛŒ Ø¬Ø§ Ø±ÛÛŒ Ø¬Ø¨Ú©Û ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(193616,5379,'sr','Ð¸Ð»Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð´Ñ€ÑƒÐ³Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¸ÑÑ‚Ð¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¾ ÑƒÑ€ÐµÑ’ÑƒÑ˜Ðµ',0),(193617,5379,'vi','hoáº·c ngÆ°á»i sá»­ dá»¥ng khÃ¡c Ä‘Ã£ cáº­p nháº­t trong khi Ä‘ang chá»‰nh sá»­a',0),(193618,5379,'af','of opdatering deur \'n ander gebruiker terwyl redigeering plaasvind',0),(193619,5379,'ro','sau actualizat de alt utilizator Ã®n timp ce fiind editat',0),(193620,5379,'et','vÃµi mÃµni teine kasutaja redigeerib samas uuendatud',0),(193621,5379,'si','ali modernizirati s strani drugega uporabnika, hkrati pa ureja',0),(193622,5379,'ba','atau diperbarui oleh pengguna lain ketika sedang diedit',0),(193623,5379,'nl','of bijgewerkt door een andere gebruiker terwijl het wordt bewerkt',0),(193624,5379,'fi','tai pÃ¤ivitetty muu muokkauksen aikana',0),(193625,5379,'no','eller oppdatert av en annen bruker mens redigeres',0),(193626,5379,'da','eller opdateret af en anden bruger, mens der redigeres',0),(193627,5379,'ko','ë˜ëŠ” íŽ¸ì§‘ í•˜ëŠ” ë™ì•ˆ ë‹¤ë¥¸ ì‚¬ìš©ìžê°€ ì—…ë°ì´íŠ¸ ëœ',0),(193628,5379,'he','××• ×©×¢×•×“×›×Ÿ ×¢×œ-×™×“×™ ×ž×©×ª×ž×© ××—×¨ ×‘×¢×ª ×¢×¨×™×›×ª×',0),(193629,5379,'el','Î® ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î±Ï€ÏŒ ÎºÎ¬Ï€Î¿Î¹Î¿Î½ Î¬Î»Î»Î¿ Ï‡ÏÎ®ÏƒÏ„Î·, ÎµÎ½ÏŽ Ï„Î¿ Ï…Ï€ÏŒ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(193630,5379,'zh','æˆ–ç¼–è¾‘æ—¶å…¶ä»–ç”¨æˆ·æ­£åœ¨æ›´æ–°\r\n',0),(193631,5379,'sv','eller uppdaterade av en annan anvÃ¤ndare medan redigeras',0),(193632,5379,'it','o aggiornati da un altro utente durante la fase di modifica',0),(193633,5379,'tl','',0),(193634,5379,'th','&#3627;&#3619;&#3639;&#3629;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3650;&#3604;&#3618;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3629;&#3639;&#3656;&#3609;&#3586;&#3603;&#3632;&#3607;&#3637;&#3656;&#3585;&#3635;&#3621;&#3633;&#3591;&#3',0),(193635,5379,'hi','à¤¯à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤°à¤¹à¤¾ à¤¹à¥ˆ à¤œà¤¬à¤•à¤¿ à¤…à¤¨à¥à¤¯ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤…à¤ªà¤¡à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(193636,5379,'ms','atau Dikemaskini oleh pengguna lain semasa sedang diedit',0),(193637,5379,'ar','Ø£Ùˆ Ø§Ù„ØªÙŠ ØªÙ… ØªØ­Ø¯ÙŠØ«Ù‡Ø§ Ù…Ù† Ù‚Ø¨Ù„ Ù…Ø³ØªØ®Ø¯Ù… Ø¢Ø®Ø±ØŒ Ø¨ÙŠÙ†Ù…Ø§ ÙŠØªÙ… ØªØ­Ø±ÙŠØ±Ù‡',0),(193638,5379,'fr','ou mis Ã  jour par un autre utilisateur en cours d\'Ã©dition',0),(193639,5379,'jp','ã‚‚ã?—ã??ã?¯ç·¨é›†ä¸­ã?«ä»–ã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?«ã‚ˆã?£ã?¦æ›´æ–°ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(193640,5379,'pt','ou atualizado por outro usuÃ¡rio enquanto sendo editado',0),(193641,5379,'ru','Ð¸Ð»Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾ Ð´Ñ€ÑƒÐ³Ð¸Ð¼ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¼ Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(193642,5379,'es','o actualizado por otro usuario mientras que editarse',0),(193643,5379,'de','oder von einem anderen Benutzer wÃ¤hrend der Bearbeitung aktualisiert',0),(193644,5379,'en','or updated by another user while being edited',0),(193645,5380,'is','',0),(193646,5380,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ( ÙØ±ÙˆØ´ ) Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ù‡ÙŠÚ† Ø¨ÛŒØ¬Ú©ÙŠ Ù†ÙˆØ´ØªÙ‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(193647,5380,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ( ÙØ±ÙˆØ´ ) Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ±ÙŠ Ù†ÙˆØ´ØªÙ‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(193648,5380,'tr','Girin/gÃ¼ncelleme satÄ±ÅŸ No fatura yazÄ±ldÄ±ÄŸÄ± giriÅŸ',0),(193649,5380,'pl','WprowadÅº/aktualizacja sprzedaÅ¼y wpÅ‚ywy gdzie Nr faktury jest napisane',0),(193650,5380,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ¸, ÐºÑŠÐ´ÐµÑ‚Ð¾ Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° â„–',0),(193651,5380,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø³ÛŒÙ„Ø² Ø±Ø³ÛŒØ¯ÛŒÚº Ù†ÛÛŒÚº Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¬ÛØ§Úº Ù„Ú©Ú¾Ø§ ÛÛ’',0),(193652,5380,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¿Ñ€Ð¸Ð·Ð½Ð°Ð½Ð¸Ñ†Ðµ, Ð³Ð´Ðµ Ñ˜Ðµ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾ Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(193653,5380,'vi','Nháº­p biÃªn nháº­n bÃ¡n hÃ ng khi khÃ´ng cÃ³ hÃ³a Ä‘Æ¡n',0),(193654,5380,'af','Tik/Update verkope kwitansies waar geen faktuur geskryf',0),(193655,5380,'ro','IntroduceÅ£i/actualizare Ã®ncasÄƒri de vÃ¢nzÄƒri Ã®n cazul Ã®n care factura nu este scris',0),(193656,5380,'et','Sisestamine/ajakohastamine mÃ¼Ã¼gi kviitungid kus nr arve kirjutatakse',0),(193657,5380,'si','Vnesite posodobitev prodaja prejemki, kjer je napisano brez raÄuna',0),(193658,5380,'ba','Tanda terima penjualan masukkan Update yang mana faktur tidak tertulis',0),(193659,5380,'nl','Voer/Update verkoop ontvangsten waar geen factuur is geschreven',0),(193660,5380,'fi','PÃ¤ivittÃ¤minen myynti kuitit joissa n lasku on kirjoitettu',0),(193661,5380,'no','Angi/Oppdater salg mottak der ingen fakturaen skrives',0),(193662,5380,'da','Indtaste/opdatere salg kvitteringer hvor ingen faktura er skrevet',0),(193663,5380,'ko','ì•„ë‹ˆ ì²­êµ¬ì„œ ìž‘ì„± ëœ ìž…ë ¥/ì—…ë°ì´íŠ¸ íŒë§¤ ì˜ìˆ˜ì¦',0),(193664,5380,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×ž×›×™×¨×•×ª ×§×‘×œ×•×ª ××™×¤×” ×›×ª×•×‘ ×œ×œ× ×—×©×‘×•× ×™×ª',0),(193665,5380,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÏŒÏ€Î¿Ï… ÏŒÏ‡Î¹ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎµÎ¯Î½Î±Î¹ Î³ÏÎ±Î¼Î¼Î­Î½Î¿',0),(193666,5380,'zh','è¾“å…¥/æ›´æ–°æ²¡æœ‰ä¹¦é¢é”€å”®å‘ç¥¨çš„é”€å”®ç¥¨æ®',0),(193667,5380,'sv','Ange/uppdatera fÃ¶rsÃ¤ljning inleveranser dÃ¤r nr fakturan skrivs',0),(193668,5380,'it','Inserisci/Aggiorna vendite ricevute dove Ã¨ scritto No fattura',0),(193669,5380,'tl','',0),(193670,5380,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3607;&#3637;&#3637;&#3656;&',0),(193671,5380,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿ à¤œà¤¹à¤¾à¤‚ à¤•à¥‹à¤ˆ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤²à¤¿à¤–à¤¾ à¤¹à¥ˆ',0),(193672,5380,'ms','Masukkan/Kemaskini resit jualan di mana No invois ditulis',0),(193673,5380,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« \"Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª\" Ø­ÙŠØ« ÙŠØªÙ… ÙƒØªØ§Ø¨Ø© \"Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©\"',0),(193674,5380,'fr','Inscrire/mettre Ã  jour les ventes recettes oÃ¹ est Ã©crit, pas de facture',0),(193675,5380,'jp','è«‹æ±‚æ›¸ã?Œæ›¸ã??ã?“ã?¾ã‚Œã?¦ã?„ã?ªã?„ã?¨ã?“ã‚?ã?®ã‚»ãƒ¼ãƒ«ã‚¹é ˜å?Žæ›¸å…¥åŠ›/æ›´æ–°',0),(193676,5380,'pt','Inserir/atualizar recibos de vendas onde a fatura nÃ£o Ã© escrita',0),(193677,5380,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸, Ð³Ð´Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾ Ð±ÐµÐ· ÑÑ‡ÐµÑ‚Ð°',0),(193678,5380,'es','Introducir/Actualizar Recibos de Ventas en Donde no esta Elaborada una Factura',0),(193679,5380,'de','Geben Sie/Update VerkÃ¤ufe Einnahmen wo keine Rechnung geschrieben wird',0),(193680,5380,'en','Enter/Update Sales Receipts where No Invoice is written',0),(193681,5381,'is','',0),(193682,5381,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø±Ø³ÙŠØ¯ ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ù†Ø´Ø¯Ù‡',0),(193683,5381,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø±Ø³ÙŠØ¯ ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ù†Ø´Ø¯Ù‡',0),(193684,5381,'tr','SatÄ±ÅŸ gelirleri faturalandÄ±rÄ±lmamÄ±ÅŸ raporu',0),(193685,5381,'pl','Raport niezafakturowanych wpÅ‚ywy sprzedaÅ¼y',0),(193686,5381,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(193687,5381,'ur','ØºÛŒØ± Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ø³ÛŒÙ„Ø² Ø±Ø³ÛŒØ¯ÙˆÚº Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(193688,5381,'sr','ÐÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð¸ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ñ†Ð°Ð¼Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(193689,5381,'vi','BÃ¡o cÃ¡o biÃªn nháº­n bÃ¡n hÃ ng khÃ´ng hÃ³a Ä‘Æ¡n',0),(193690,5381,'af','Nie-Gefaktureerde Verkope Inkomstes Verslag',0),(193691,5381,'ro','Non-facturat Ã®ncasÄƒri de vÃ¢nzÄƒri raportul',0),(193692,5381,'et','Arveldamata ostukviitungid aruanne',0),(193693,5381,'si','Non-fakturirane prodaje prejemki poroÄilo',0),(193694,5381,'ba','Tanda terima penjualan yang ditagih bebas laporan',0),(193695,5381,'nl','Niet-gefactureerde verkoop ontvangsten verslag',0),(193696,5381,'fi','Laskuttamattomat myyntituloja raportti',0),(193697,5381,'no','Ikke-fakturerte avsetning kvitteringer rapport',0),(193698,5381,'da','Ikke-faktureret salg kvitteringer rapport',0),(193699,5381,'ko','íŒë§¤ ì˜ìˆ˜ì¦ ë¹„ ì²­êµ¬ ë³´ê³ ì„œ',0),(193700,5381,'he','×“×•×— ×œ×œ× ×—×©×‘×•× ×™×ª ×”×—×©×‘×•× ×™×ª',0),(193701,5381,'el','ÎœÎ· Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î­ÏƒÎ¿Î´Î± Î­ÎºÎ¸ÎµÏƒÎ·',0),(193702,5381,'zh','ä¸å¼€å…·å‘ç¥¨çš„é”€å”®ç¥¨æ®æŠ¥å‘Š\r\n',0),(193703,5381,'sv','Icke fakturerade fÃ¶rsÃ¤ljning kvitton rapport',0),(193704,5381,'it','Report incassi vendite non fatturate',0),(193705,5381,'tl','',0),(193706,5381,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(193707,5381,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚ à¤—à¥ˆà¤° à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(193708,5381,'ms','Invois jualan resit Laporan',0),(193709,5381,'ar','ØªÙ‚Ø±ÙŠØ± Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(193710,5381,'fr','Rapport de reÃ§us de vente non facturÃ©es',0),(193711,5381,'jp','æœªè«‹æ±‚ã‚»ãƒ¼ãƒ«ã‚¹é ˜å?Žæ›¸ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(193712,5381,'pt','RelatÃ³rio de recibos de vendas nÃ£o faturadas',0),(193713,5381,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð½Ðµ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ñ€Ð°ÑÐ¿Ð¸ÑÐ¾Ðº',0),(193714,5381,'es','Informe de Recibos de Ventas No Facturadas',0),(193715,5381,'de','Nicht fakturierten Umsatz Bericht',0),(193716,5381,'en','Non-Invoiced Sales Receipts Report',0),(193717,5382,'is','',0),(193718,5382,'dr','Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(193719,5382,'pr','Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(193720,5382,'tr','Ä°Ã§in DÃ¼zenle\'yi tÄ±klatÄ±n',0),(193721,5382,'pl','Kliknij, aby edytowaÄ‡',0),(193722,5382,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(193723,5382,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(193724,5382,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÑƒ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(193725,5382,'vi','Nháº¥n VÃ o Äá»ƒ Sá»­a',0),(193726,5382,'af','Kliek om te Redigeer',0),(193727,5382,'ro','FaceÅ£i clic pentru a edita',0),(193728,5382,'et','Muutmiseks klÃµpsa',0),(193729,5382,'si','Kliknite za urejanje',0),(193730,5382,'ba','Klik untuk Edit',0),(193731,5382,'nl','Klik om te bewerken',0),(193732,5382,'fi','Valitse Muokkaa',0),(193733,5382,'no','Klikk for Ã¥ redigere',0),(193734,5382,'da','Klik for at redigere',0),(193735,5382,'ko','íŽ¸ì§‘ì„ í´ë¦­ í•©ë‹ˆë‹¤',0),(193736,5382,'he','×œ×—×¥ ×›×“×™ ×œ×¢×¨×•×š',0),(193737,5382,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(193738,5382,'zh','ç‚¹å‡»ç¼–è¾‘\r\n',0),(193739,5382,'sv','Klicka fÃ¶r att redigera',0),(193740,5382,'it','Fare clic su modifica',0),(193741,5382,'tl','',0),(193742,5382,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(193743,5382,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(193744,5382,'ms','Klik untuk Edit',0),(193745,5382,'ar','Ø£Ù†Ù‚Ø± Ù„Ù„ØªØ­Ø±ÙŠØ±',0),(193746,5382,'fr','Cliquez sur Edit',0),(193747,5382,'jp','ç·¨é›†ã?™ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(193748,5382,'pt','Clique para editar',0),(193749,5382,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð§Ñ‚Ð¾Ð±Ñ‹ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(193750,5382,'es','Click para Editar',0),(193751,5382,'de','Klicken Sie auf Bearbeiten',0),(193752,5382,'en','Click to Edit',0),(193753,5383,'is','',0),(193754,5383,'dr','(ÙØ±ÙˆØ´) Ø¨Ø¯ÙˆÙ† Ø¨ÛŒØ¬Ú©Ù‡Ø§',0),(193755,5383,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ Ø­Ø±Ø§Ø¬(ÙØ±ÙˆØ´) Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(193756,5383,'tr','SatÄ±ÅŸ gelirleri olmadan fatura raporu',0),(193757,5383,'pl','Raport wpÅ‚ywÃ³w sprzedaÅ¼y bez faktur',0),(193758,5383,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð±ÐµÐ· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(193759,5383,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ø¨ØºÛŒØ± Ø³ÛŒÙ„Ø² Ø±Ø³ÛŒØ¯ÙˆÚº Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(193760,5383,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¸ Ð¿Ñ€Ð¸Ð·Ð½Ð°Ð½Ð¸Ñ†Ðµ Ð±ÐµÐ· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(193761,5383,'vi','BÃ¡o cÃ¡o biÃªn nháº­n bÃ¡n hÃ ng khÃ´ng hÃ³a Ä‘Æ¡n',0),(193762,5383,'af','Verslag van Verkoopskwitansie sonder Fakture',0),(193763,5383,'ro','Raport de vÃ¢nzÄƒri Ã®ncasÄƒri fÄƒrÄƒ facturi',0),(193764,5383,'et','Ostukviitungid ilma arvete aruanne',0),(193765,5383,'si','PoroÄilo prodaje prejemkov brez raÄunov',0),(193766,5383,'ba','Laporan Penjualan penerimaan tanpa faktur',0),(193767,5383,'nl','Verslag van verkoop ontvangsten zonder facturen',0),(193768,5383,'fi','Myyntituloja ilman laskujen raportti',0),(193769,5383,'no','Rapporten fra avsetning kvitteringer uten fakturaer',0),(193770,5383,'da','BetÃ¦nkning af salg kvitteringer uden fakturaer',0),(193771,5383,'ko','ì²­êµ¬ì„œ ì—†ì´ íŒë§¤ ì˜ìˆ˜ì¦ì˜ ë³´ê³ ì„œ',0),(193772,5383,'he','×”×“×• ×— ×©×œ ×”×—×©×‘×•× ×™×ª ×œ×œ× ×—×©×‘×•× ×™×•×ª',0),(193773,5383,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€Î±ÏÎ±Î»Î±Î²ÏŽÎ½ Ï‡Ï‰ÏÎ¯Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(193774,5383,'zh','é”€å”®ç¥¨æ®æŠ¥å‘Šæ²¡æœ‰å‘ç¥¨\r\n',0),(193775,5383,'sv','Rapport fÃ¶r fÃ¶rsÃ¤ljning inleveranser utan fakturor',0),(193776,5383,'it','Rapporto delle vendite ricevute senza fatture',0),(193777,5383,'tl','',0),(193778,5383,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(193779,5383,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(193780,5383,'ms','Laporan resit jualan tanpa invois',0),(193781,5383,'ar','ØªÙ‚Ø±ÙŠØ± Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¯ÙˆÙ† ÙÙˆØ§ØªÙŠØ±',0),(193782,5383,'fr','Rapport des recettes de ventes sans factures',0),(193783,5383,'jp','è«‹æ±‚æ›¸ã?ªã?—ã‚»ãƒ¼ãƒ«ã‚¹é ˜å?Žæ›¸ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(193784,5383,'pt','RelatÃ³rio de recibos de vendas sem facturas',0),(193785,5383,'ru','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð±ÐµÐ· ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(193786,5383,'es','Informe de Recibos de Ventas sin Facturas',0),(193787,5383,'de','Bericht der Belege fÃ¼r Lieferungen ohne Rechnungen',0),(193788,5383,'en','Report of Sales Receipts without Invoices',0),(193789,5384,'is','',0),(193790,5384,'dr','Ù‡Ù…Ù‡ Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ ',0),(193791,5384,'pr','Ù‡Ù…Ù‡ Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ ',0),(193792,5384,'tr','TÃ¼m aralÄ±ÄŸÄ±',0),(193793,5384,'pl','Wszystko w zasiÄ™gu',0),(193794,5384,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¾ Ð² Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð°',0),(193795,5384,'ur','Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…ÛŒÚº',0),(193796,5384,'sr','Ð¡Ð²Ðµ Ñƒ Ð¾Ð¿ÑÐµÐ³Ñƒ',0),(193797,5384,'vi','Táº¥t Cáº£ Trong Pháº¡m Vi',0),(193798,5384,'af','Alles in Reeks',0),(193799,5384,'ro','Toate din gama',0),(193800,5384,'et','KÃµigi tÃ¶Ã¶piirkonnas olevate',0),(193801,5384,'si','Vse v obmoÄju',0),(193802,5384,'ba','Semua dalam jangkauan',0),(193803,5384,'nl','All-in aanbod',0),(193804,5384,'fi','Kaikki alueella',0),(193805,5384,'no','I utvalg',0),(193806,5384,'da','Alle i omrÃ¥det',0),(193807,5384,'ko','ë²”ìœ„ì— ìžˆëŠ” ëª¨ë“ ',0),(193808,5384,'he','×”×›×œ ×‘×˜×•×•×—',0),(193809,5384,'el','ÎŒÎ»Î± ÏƒÎµ ÏƒÎµÎ¹ÏÎ¬',0),(193810,5384,'zh','All in RangeDid you mean: Al General Ledger sections have been completed\r\n\r\nType text or a website address or translate a document.\r\nCancel\r\nListenRead phonetically\r\nEnglish to Chinese (Simplified) translation\r\næ‰€æœ‰èŒƒå›´\r\n',0),(193811,5384,'sv','Alla i intervallet',0),(193812,5384,'it','Tutti in gamma',0),(193813,5384,'tl','',0),(193814,5384,'th','&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3594;&#3656;&#3623;&#3591;',0),(193815,5384,'hi','à¤¸à¤¬ à¤•à¥€ à¤¸à¥€à¤®à¤¾ à¤®à¥‡à¤‚',0),(193816,5384,'ms','Semua dalam pelbagai',0),(193817,5384,'ar','ÙƒÙ„ Ø´ÙŠØ¡ ÙÙŠ Ù†Ø·Ø§Ù‚',0),(193818,5384,'fr','Tous dans la gamme',0),(193819,5384,'jp','ç¯„å›²å†…ã?®å…¨ã?¦',0),(193820,5384,'pt','Tudo em escala',0),(193821,5384,'ru','Ð’ÑÐµ Ð² Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ðµ',0),(193822,5384,'es','Todos en el Rango',0),(193823,5384,'de','Alles in Reichweite',0),(193824,5384,'en','All in Range',0),(193825,5385,'is','',0),(193826,5385,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø±Ø³ÙŠØ¯Ù‡Ø§ ',0),(193827,5385,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø±Ø³ÙŠØ¯Ù‡Ø§ ',0),(193828,5385,'tr','Misc.Receipts',0),(193829,5385,'pl','Misc.Receipts',0),(193830,5385,'bg','Misc.Receipts',0),(193831,5385,'ur','Misc.Receipts',0),(193832,5385,'sr','ÐœÐ¸ÑÑ†.Ð ÐµÑ†ÐµÐ¸Ð¿Ñ‚Ñ',0),(193833,5385,'vi','BiÃªn nháº­n chi phÃ­ láº»',0),(193834,5385,'af','Misc.Receipts',0),(193835,5385,'ro','Misc.Receipts',0),(193836,5385,'et','Misc.Receipts',0),(193837,5385,'si','Misc.Receipts',0),(193838,5385,'ba','Misc.Receipts',0),(193839,5385,'nl','Misc.Receipts',0),(193840,5385,'fi','Misc.Receipts',0),(193841,5385,'no','Misc.Receipts',0),(193842,5385,'da','Misc.Receipts',0),(193843,5385,'ko','Misc.Receipts',0),(193844,5385,'he','Misc.Receipts',0),(193845,5385,'el','Misc.Receipts',0),(193846,5385,'zh','æ‚é¡¹ç¥¨æ®\r\n',0),(193847,5385,'sv','Misc.Receipts',0),(193848,5385,'it','Misc.Receipts',0),(193849,5385,'tl','',0),(193850,5385,'th','&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;',0),(193851,5385,'hi','Misc.Receipts',0),(193852,5385,'ms','Misc.Receipts',0),(193853,5385,'ar','Misc.Receipts',0),(193854,5385,'fr','Misc.Receipts',0),(193855,5385,'jp','ã??ã?®ä»–é ˜å?Žæ›¸',0),(193856,5385,'pt','Misc.Receipts',0),(193857,5385,'ru','Misc.Receipts',0),(193858,5385,'es','Recibos Pago Misc.',0),(193859,5385,'de','Misc.Receipts',0),(193860,5385,'en','Misc.Receipts',0),(193861,5386,'is','',0),(193862,5386,'dr','Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„',0),(193863,5386,'pr','Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„',0),(193864,5386,'tr','KÃ¶tÃ¼ borÃ§',0),(193865,5386,'pl','NieÅ›ciÄ…galnych dÅ‚ugÃ³w',0),(193866,5386,'bg','Ð›Ð¾Ñˆ Ð´ÑŠÐ»Ð³',0),(193867,5386,'ur','Ø¨Ø±ÛŒ Ù‚Ø±Ø¶',0),(193868,5386,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°',0),(193869,5386,'vi','Ná»£ xáº¥u',0),(193870,5386,'af','Oninbare Skuld',0),(193871,5386,'ro','Bad credit',0),(193872,5386,'et','Halbade vÃµlgade',0),(193873,5386,'si','Slabih dolgov',0),(193874,5386,'ba','Buruk hutang',0),(193875,5386,'nl','Slechte schulden',0),(193876,5386,'fi','Luottotappiot',0),(193877,5386,'no','DÃ¥rlig gjeld',0),(193878,5386,'da','DÃ¥rlig gÃ¦ld',0),(193879,5386,'ko','ë‚˜ìœ ë¶€ì±„',0),(193880,5386,'he','×—×•×‘ ××‘×•×“',0),(193881,5386,'el','ÎšÎ±ÎºÏŒ Ï‡ÏÎ­Î¿Ï‚',0),(193882,5386,'zh','é”™è¯¯æ¬ è´¦\r\n',0),(193883,5386,'sv','KundfÃ¶rluster',0),(193884,5386,'it','Crediti inesigibili',0),(193885,5386,'tl','',0),(193886,5386,'th','&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;',0),(193887,5386,'hi','à¤¬à¥à¤°à¤¾ à¤‹à¤£',0),(193888,5386,'ms','Hutang lapuk',0),(193889,5386,'ar','Ø§Ù„Ø¯ÙŠÙˆÙ† Ø§Ù„Ù…Ø¹Ø¯ÙˆÙ…Ø©',0),(193890,5386,'fr','CrÃ©ance irrÃ©couvrable',0),(193891,5386,'jp','è²¸å€’é‡‘',0),(193892,5386,'pt','DÃ­vidas incobrÃ¡veis',0),(193893,5386,'ru','Ð‘ÐµÐ·Ð½Ð°Ð´ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð¾Ð»Ð³Ð¾Ð²',0),(193894,5386,'es','Deuda Incobrable',0),(193895,5386,'de','Uneinbringliche Forderungen',0),(193896,5386,'en','Bad Debt',0),(193897,5387,'is','',0),(193898,5387,'dr','Ø³ÙˆØ®Øª Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„',0),(193899,5387,'pr','Ø³ÙˆØ®Øª Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„',0),(193900,5387,'tr','KÃ¶tÃ¼ borÃ§ indirimi',0),(193901,5387,'pl','Odpisanie nieÅ›ciÄ…galnych dÅ‚ugÃ³w',0),(193902,5387,'bg','ÐžÐ¿Ñ€Ð¾Ñ‰Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¾ÑˆÐ¾',0),(193903,5387,'ur','Ø¨Ø±ÛŒ Ù‚Ø±Ø¶Û’Ù…Ø¹Ø§Ù',0),(193904,5387,'sr','ÐžÑ‚Ð¿Ð¸Ñ Ð´ÑƒÐ³Ð° Ð»Ð¾ÑˆÐµ',0),(193905,5387,'vi','XÃ³a ná»£ xáº¥u',0),(193906,5387,'af','Swak Skulde Afgeskryf',0),(193907,5387,'ro','Anularea datoriei Bad',0),(193908,5387,'et','Halbade vÃµlgade mahakandmine',0),(193909,5387,'si','Slabih dolgov odpis',0),(193910,5387,'ba','Menghapusbukukan buruk hutang',0),(193911,5387,'nl','Slechte schulden afschrijving',0),(193912,5387,'fi','Huono velkaa anteeksi',0),(193913,5387,'no','DÃ¥rlig gjeld avskrivning',0),(193914,5387,'da','DÃ¥rlige gÃ¦ldsafskrivning',0),(193915,5387,'ko','ë‚˜ìœ ë¶€ì±„ ì“°ê¸°',0),(193916,5387,'he','×ž×—×™×§×” ×‘×”×ª×× ×—×•×‘ ××‘×•×“',0),(193917,5387,'el','ÎšÎ±ÎºÏŒ Ï‡ÏÎµÏŽÎ½',0),(193918,5387,'zh','åå€ºåŠ¡å†²é”€\r\n',0),(193919,5387,'sv','Avskrivning av osÃ¤kra fordringar',0),(193920,5387,'it','Storno di crediti inesigibili',0),(193921,5387,'tl','',0),(193922,5387,'th','&#3585;&#3634;&#3619;&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3611;&#3655;&#3609;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;',0),(193923,5387,'hi','à¤¬à¥à¤°à¤¾ à¤‹à¤£ à¤²à¤¿à¤–à¤¨à¥‡ à¤¬à¤¨à¤¾à¤¨à¤¾',0),(193924,5387,'ms','Hapuskira hutang lapuk',0),(193925,5387,'ar','Ø´Ø·Ø¨ Ø§Ù„Ø¯ÙŠÙˆÙ† Ø§Ù„Ù…Ø¹Ø¯ÙˆÙ…Ø©',0),(193926,5387,'fr','Radiation de crÃ©ances irrÃ©couvrables',0),(193927,5387,'jp','è²¸å€’é‡‘å‡¦ç?†',0),(193928,5387,'pt','AnulaÃ§Ã£o de dÃ­vidas incobrÃ¡veis',0),(193929,5387,'ru','Ð¡Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð±ÐµÐ·Ð½Ð°Ð´ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð¾Ð»Ð³Ð¾Ð²',0),(193930,5387,'es','Descuento de Deudas Incobrables',0),(193931,5387,'de','Uneinbringliche Forderungen abschreiben',0),(193932,5387,'en','Bad Debt Write-off',0),(193933,5388,'is','',0),(193934,5388,'dr','(- Ù†Ø³ÙŠÙ‡- Ø§Ø¹ØªØ¨Ø§Ø± )Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(193935,5388,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ(- Ù†Ø³ÙŠÙ‡- Ø§Ø¹ØªØ¨Ø§Ø± )Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(193936,5388,'tr','Ä°ade kredi',0),(193937,5388,'pl','Zwrotu kredytu',0),(193938,5388,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÐµÐ½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(193939,5388,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(193940,5388,'sr','Ð’Ñ€Ð°Ñ‚Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(193941,5388,'vi','TÃ­n Dá»¥ng ÄÃ£ HoÃ n Tráº£',0),(193942,5388,'af','Terugbetaal krediet',0),(193943,5388,'ro','Returnata de Credit',0),(193944,5388,'et','Tasutu krediidi',0),(193945,5388,'si','Povrniti kreditne',0),(193946,5388,'ba','Kredit dikembalikan',0),(193947,5388,'nl','Terugbetaald krediet',0),(193948,5388,'fi','Palautetaan luotto',0),(193949,5388,'no','Refunderes kreditt',0),(193950,5388,'da','Refunderet kredit',0),(193951,5388,'ko','í™˜ë¶ˆëœ ì‹ ìš©',0),(193952,5388,'he','×”×—×–×¨ ×”××©×¨××™',0),(193953,5388,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ¿Ï',0),(193954,5388,'zh','é€€æ¬¾ä¿¡ç”¨\r\n',0),(193955,5388,'sv','Ã…terbetalas kredit',0),(193956,5388,'it','Credito rimborsato',0),(193957,5388,'tl','',0),(193958,5388,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;&#3651;&#3627;&#3657;',0),(193959,5388,'hi','à¤µà¤¾à¤ªà¤¸ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(193960,5388,'ms','Kredit balik',0),(193961,5388,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ù…Ø³ØªØ±Ø¯',0),(193962,5388,'fr','CrÃ©dit remboursÃ©',0),(193963,5388,'jp','æ‰•ã?„æˆ»ã?—è²¸æ–¹',0),(193964,5388,'pt','CrÃ©dito reembolsado',0),(193965,5388,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÑ‚ÑÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(193966,5388,'es','CrÃ©dito Reembolsado',0),(193967,5388,'de','ZurÃ¼ckgezahlte Kredite',0),(193968,5388,'en','Refunded Credit',0),(193969,5389,'is','',0),(193970,5389,'dr','Ø´Ø±Ø­ Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§ ',0),(193971,5389,'pr','Ø´Ø±Ø­ Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§ ',0),(193972,5389,'tr','SatÄ±r Ã¶ÄŸesi tanÄ±mÄ±',0),(193973,5389,'pl','Opis pozycji',0),(193974,5389,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(193975,5389,'ur','Ù„Ø§Ø¦Ù† Ø´Û’ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(193976,5389,'sr','ÐžÐ¿Ð¸Ñ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(193977,5389,'vi','MÃ´ táº£ dÃ²ng kÃª hÃ ng',0),(193978,5389,'af','Lynitem Beskrywing',0),(193979,5389,'ro','Descriere element rÃ¢nd',0),(193980,5389,'et','Rea kirjeldus',0),(193981,5389,'si','Opis vrstiÄne postavke',0),(193982,5389,'ba','Deskripsi Item baris',0),(193983,5389,'nl','Lijn objectbeschrijving',0),(193984,5389,'fi','Nimikkeen kuvaus',0),(193985,5389,'no','Linjeelementbeskrivelse',0),(193986,5389,'da','Linjen emnebeskrivelse',0),(193987,5389,'ko','í’ˆëª© ì„¤ëª…',0),(193988,5389,'he','×ª×™××•×¨ ×¤×¨×™×˜ ×©×•×¨×”',0),(193989,5389,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(193990,5389,'zh','è¡Œé¡¹ç›®ä»‹ç»\r\n',0),(193991,5389,'sv','Linje objektbeskrivning',0),(193992,5389,'it','Descrizione dell\'elemento di linea',0),(193993,5389,'tl','',0),(193994,5389,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3626;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(193995,5389,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£',0),(193996,5389,'ms','Keterangan Item talian',0),(193997,5389,'ar','ÙˆØµÙ Ø¨Ù†Ø¯',0),(193998,5389,'fr','Description de la rubrique',0),(193999,5389,'jp','å“?ç›®å??è§£èª¬',0),(194000,5389,'pt','DescriÃ§Ã£o do Item de linha',0),(194001,5389,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸',0),(194002,5389,'es','Item de LÃ­nea DescripciÃ³n',0),(194003,5389,'de','Line Artikelbeschreibung',0),(194004,5389,'en','Line Item Description',0),(194005,5390,'is','',0),(194006,5390,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙŠØ¬Ø§Ø¯ Ú†Ùƒ',0),(194007,5390,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙŠØ¬Ø§Ø¯ Ú†Ùƒ',0),(194008,5390,'tr','Onay oluÅŸturma baÅŸarÄ±sÄ±z oldu',0),(194009,5390,'pl','Wyboru Tworzenie nie powiodÅ‚o siÄ™',0),(194010,5390,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(194011,5390,'ur','Ú†ÛŒÚ© Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†Ø§Ú©Ø§Ù…ÛŒ',0),(194012,5390,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(194013,5390,'vi','Táº¡o SÃ©c tháº¥t báº¡i',0),(194014,5390,'af','Tjek Skepping het Gefaal',0),(194015,5390,'ro','Crearea de verificare nu a reuÅŸit',0),(194016,5390,'et','VÃ¤ljaregistreerimine loomine nurjus',0),(194017,5390,'si','Potrdite ustvarjanje ni uspelo',0),(194018,5390,'ba','Check penciptaan gagal',0),(194019,5390,'nl','Selectievakje creatie is mislukt',0),(194020,5390,'fi','Uloskirjautuminen luominen epÃ¤onnistui',0),(194021,5390,'no','Sjekk oppretting mislyktes',0),(194022,5390,'da','Check oprettelse mislykkedes',0),(194023,5390,'ko','ì²´í¬ ì°½ì¡°ëŠ” ì‹¤íŒ¨ í–ˆë‹¤',0),(194024,5390,'he','×™×¦×™×¨×ª ×”×¡×™×ž×•×Ÿ × ×›×©×œ×”',0),(194025,5390,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(194026,5390,'zh','æ£€æŸ¥åˆ›å»ºå¤±è´¥\r\n',0),(194027,5390,'sv','Kontrollera skapande misslyckades',0),(194028,5390,'it','Creazione del controllo non riuscito',0),(194029,5390,'tl','',0),(194030,5390,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3648;&#3594;&#3655;&#3588;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(194031,5390,'hi','à¤šà¥‡à¤• à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤µà¤¿à¤«à¤² à¤¹à¥à¤†',0),(194032,5390,'ms','Semak penciptaan yang gagal',0),(194033,5390,'ar','ÙØ´Ù„ Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(194034,5390,'fr','CrÃ©ation de cocher a Ã©chouÃ©',0),(194035,5390,'jp','ãƒ?ã‚§ãƒƒã‚¯ä½œæˆ?ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(194036,5390,'pt','CriaÃ§Ã£o de verificaÃ§Ã£o falhada',0),(194037,5390,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(194038,5390,'es','CreaciÃ³n de Cheque FallÃ³',0),(194039,5390,'de','KontrollkÃ¤stchen Erstellung fehlgeschlagen',0),(194040,5390,'en','Check Creation Failed',0),(194041,5391,'is','',0),(194042,5391,'dr','Ù‚Ø¨Ù„ Ø§Ø² ØªØ®ÙÙŠÙ',0),(194043,5391,'pr','Ù‚Ø¨Ù„ Ø§Ø² ØªØ®ÙÙŠÙ',0),(194044,5391,'tr','Ã–nce indirim',0),(194045,5391,'pl','Przed rabatem',0),(194046,5391,'bg','ÐŸÑ€ÐµÐ´Ð¸ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(194047,5391,'ur','Ø±Ø¹Ø§ÛŒØª Ø³Û’ Ù¾ÛÙ„Û’',0),(194048,5391,'sr','ÐŸÑ€Ðµ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(194049,5391,'vi','TrÆ°á»›c khi chiáº¿t kháº¥u',0),(194050,5391,'af','Voor Korting',0),(194051,5391,'ro','ÃŽnainte de reducere',0),(194052,5391,'et','Enne allahindlust',0),(194053,5391,'si','Pred popust',0),(194054,5391,'ba','Sebelum DISKON',0),(194055,5391,'nl','Voor korting',0),(194056,5391,'fi','Ennen alennus',0),(194057,5391,'no','FÃ¸r rabatt',0),(194058,5391,'da','FÃ¸r rabat',0),(194059,5391,'ko','í• ì¸ ì „',0),(194060,5391,'he','×œ×¤× ×™ ×”× ×—×”',0),(194061,5391,'el','Î ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·',0),(194062,5391,'zh','æŠ˜æ‰£å‰\r\n',0),(194063,5391,'sv','FÃ¶re rabatt',0),(194064,5391,'it','Prima sconto',0),(194065,5391,'tl','',0),(194066,5391,'th','&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3585;&#3656;&#3629;&#3609;&#3627;&#3609;&#3657;&#3634;',0),(194067,5391,'hi','à¤›à¥‚à¤Ÿ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡',0),(194068,5391,'ms','Sebelum diskaun',0),(194069,5391,'ar','Ù‚Ø¨Ù„ Ø§Ù„Ø®ØµÙ…',0),(194070,5391,'fr','Avant rÃ©duction',0),(194071,5391,'jp','å‰²å¼•å‰?',0),(194072,5391,'pt','Antes de desconto',0),(194073,5391,'ru','ÐŸÐµÑ€ÐµÐ´ Ð¡ÐºÐ¸Ð´ÐºÐ¾Ð¹',0),(194074,5391,'es','Antes que Descontar',0),(194075,5391,'de','Vor Rabatt',0),(194076,5391,'en','Before Discount',0),(194077,5392,'is','',0),(194078,5392,'dr','Ø«Ø¨Øª Ú†Ùƒ Ø¯Ø³ØªÙŠ ',0),(194079,5392,'pr','Ø«Ø¨Øª Ú†Ùƒ Ø¯Ø³ØªÙŠ ',0),(194080,5392,'tr','El ile denetim girin',0),(194081,5392,'pl','WprowadÅº rÄ™czne sprawdzanie',0),(194082,5392,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ€ÑŠÑ‡Ð½Ð¾ Ð¸Ð·Ð´Ð°Ð´ÐµÐ½ Ñ‡ÐµÐº',0),(194083,5392,'ur','Ø¯Ø³ØªÛŒ Ú†ÛŒÚ© Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(194084,5392,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ñ€ÑƒÑ‡Ð½Ð¾ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(194085,5392,'vi','Nháº­p SÃ©c thá»§ cÃ´ng',0),(194086,5392,'af','Invoer van Handgeskrewe Tjek ',0),(194087,5392,'ro','IntroduceÅ£i Manual a verifica',0),(194088,5392,'et','Sisestage kÃ¤sitsi sisse',0),(194089,5392,'si','Vnesite roÄno, ali',0),(194090,5392,'ba','Masukkan cek Manual',0),(194091,5392,'nl','Voer handmatige Check',0),(194092,5392,'fi','Kirjoita Manuaalinen sekki',0),(194093,5392,'no','Angi Manuell sjekk',0),(194094,5392,'da','Angiv manuel kontrol',0),(194095,5392,'ko','ìˆ˜ë™ ê²€ì‚¬ë¥¼ ìž…ë ¥',0),(194096,5392,'he','×”×–×Ÿ ×¡×™×ž×•×Ÿ ×™×“× ×™',0),(194097,5392,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï‡ÎµÎ¹ÏÎ¿ÎºÎ¯Î½Î·Ï„Î¿ Î­Î»ÎµÎ³Ï‡Î¿',0),(194098,5392,'zh','è¿›å…¥æ‰‹åŠ¨æ£€æŸ¥',0),(194099,5392,'sv','Ange manuell kontroll',0),(194100,5392,'it','Inserire il controllo manuale',0),(194101,5392,'tl','',0),(194102,5392,'th','&#3611;&#3657;&#3629;&#3609;&#3648;&#3594;&#3655;&#3588;&#3607;&#3637;&#3656;&#3648;&#3586;&#3637;&#3618;&#3609;&#3604;&#3657;&#3623;&#3618;&#3617;&#3639;&#3629;',0),(194103,5392,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤œà¤¾à¤à¤š à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(194104,5392,'ms','Masukkan cek Manual',0),(194105,5392,'ar','Ø£Ø¯Ø®Ù„ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ÙŠØ¯ÙˆÙŠ',0),(194106,5392,'fr','Entrez manuel CONTROLE',0),(194107,5392,'jp','ãƒžãƒ‹ãƒ¥ã‚¢ãƒ«å°?åˆ‡æ‰‹ã?®å…¥åŠ›',0),(194108,5392,'pt','Digite a verificaÃ§Ã£o Manual',0),(194109,5392,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ñ€ÑƒÑ‡Ð½Ð¾Ð¹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(194110,5392,'es','Introducir Cheque Manual',0),(194111,5392,'de','Geben Sie manuelle PrÃ¼fung',0),(194112,5392,'en','Enter Manual Check',0),(194113,5393,'is','',0),(194114,5393,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ú†Ùƒ ',0),(194115,5393,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ú†Ùƒ ',0),(194116,5393,'tr','Hata denetimi oluÅŸturma',0),(194117,5393,'pl','BÅ‚Ä…d tworzenia wyboru',0),(194118,5393,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ð¼ÐµÑ‚ÐºÐ°',0),(194119,5393,'ur','Ù†Ù‚Øµ Ù¾Ú‘ØªØ§Ù„ Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’',0),(194120,5393,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(194121,5393,'vi','Táº¡o SÃ©c bá»‹ lá»—i',0),(194122,5393,'af','Fout skep kontroleer',0),(194123,5393,'ro','Verificare eroare de crearea',0),(194124,5393,'et','Veakontroll loomine',0),(194125,5393,'si','Napaka pri ustvarjanju potrdite',0),(194126,5393,'ba','Periksa membuat kesalahan',0),(194127,5393,'nl','Fout maken Check',0),(194128,5393,'fi','Virheentarkistus luominen',0),(194129,5393,'no','Opprette sjekk',0),(194130,5393,'da','Fejlkontrollen oprettelse',0),(194131,5393,'ko','ì˜¤ë¥˜ ë§Œë“¤ê¸° í™•ì¸',0),(194132,5393,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×¡×™×ž×•×Ÿ',0),(194133,5393,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±',0),(194134,5393,'zh','é”™è¯¯åˆ›å»ºæ£€æŸ¥',0),(194135,5393,'sv','Skapa felkontroll',0),(194136,5393,'it','Errore creazione Check',0),(194137,5393,'tl','',0),(194138,5393,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3648;&#3594;&#3655;&#3588;',0),(194139,5393,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤šà¥‡à¤•',0),(194140,5393,'ms','Ralat mencipta semak',0),(194141,5393,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„ØµÙ‘Ùƒ',0),(194142,5393,'fr','VÃ©rification des erreurs de crÃ©ation',0),(194143,5393,'jp','å°?åˆ‡æ‰‹ä½œæˆ?ã‚¨ãƒ©ãƒ¼',0),(194144,5393,'pt','VerificaÃ§Ã£o de erro criando',0),(194145,5393,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(194146,5393,'es','Error Creando Cheque',0),(194147,5393,'de','FehlerÃ¼berprÃ¼fung erstellen',0),(194148,5393,'en','Error Creating Check',0),(194149,5394,'is','',0),(194150,5394,'dr','Ú†Ùƒ Ù‡Ø§ÙŠ Ø¯Ø³ØªÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯',0),(194151,5394,'pr','Ú†Ùƒ Ù‡Ø§ÙŠ Ø¯Ø³ØªÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯',0),(194152,5394,'tr','El ile denetim baÅŸarÄ±yla oluÅŸturuldu',0),(194153,5394,'pl','Czek rÄ™czny utworzona pomyÅ›lnie',0),(194154,5394,'bg','Ð ÑŠÑ‡Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(194155,5394,'ur','Ø¯Ø³ØªÛŒ Ú†ÛŒÚ© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(194156,5394,'sr','Ð ÑƒÑ‡Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°',0),(194157,5394,'vi','Táº¡o SÃ©c thá»§ cÃ´ng thÃ nh cÃ´ng',0),(194158,5394,'af','Handuitgeskrewe Tjeks Suksesvol Geskep',0),(194159,5394,'ro','Verificare manualÄƒ creat cu succes',0),(194160,5394,'et','KÃ¤sitsi koostatud tÅ¡ekk on edukalt loodud',0),(194161,5394,'si','RoÄno preverjanje uspeÅ¡no ustvarjen',0),(194162,5394,'ba','Manual Periksa dibuat dengan sukses',0),(194163,5394,'nl','Handmatige controle met succes gemaakt',0),(194164,5394,'fi','Manuaalinen sekki luonti onnistui',0),(194165,5394,'no','Manuell sjekk opprettet',0),(194166,5394,'da','Manuel Check oprettet',0),(194167,5394,'ko','ì„±ê³µì ìœ¼ë¡œ ìƒì„± í•˜ëŠ” ìˆ˜ë™ ê²€ì‚¬',0),(194168,5394,'he','×¡×™×ž×•×Ÿ ×™×“× ×™ × ×•×¦×¨×• ×‘×”×¦×œ×—×”',0),(194169,5394,'el','Î§ÎµÎ¹ÏÏŒÎ³ÏÎ±Ï†Î· Î•Ï€Î¹Ï„Î±Î³Î® Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(194170,5394,'zh','æ‰‹åŠ¨æ£€æŸ¥åˆ›å»ºæˆåŠŸ\r\n',0),(194171,5394,'sv','Manuell kontroll har skapats',0),(194172,5394,'it','Controllo manuale creato con successo',0),(194173,5394,'tl','',0),(194174,5394,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3648;&#3594;&#3655;&#3588;&#3607;&#3637;&#3656;&#3648;&#3586;&#3637;&#3618;&#3609;&#3604;&#3657;&#3623;&#3618;&#3617;&#3639;&#3629;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(194175,5394,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤šà¥‡à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(194176,5394,'ms','Semak manual yang berjaya dicipta',0),(194177,5394,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ÙŠØ¯ÙˆÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(194178,5394,'fr','Manuel CONTROLE crÃ©Ã© avec succÃ¨s',0),(194179,5394,'jp','ãƒžãƒ‹ãƒ¥ã‚¢ãƒ«å°?åˆ‡æ‰‹ã?Œä½œæˆ?ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(194180,5394,'pt','SeleÃ§Ã£o manual criada com sucesso',0),(194181,5394,'ru','Ð ÑƒÑ‡Ð½Ð¾Ð¹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½',0),(194182,5394,'es','Cheques Manuales Creados Exitosamente',0),(194183,5394,'de','Manuelle ÃœberprÃ¼fung wurde erfolgreich erstellt.',0),(194184,5394,'en','Manual Check Created Successfully',0),(194185,5395,'is','',0),(194186,5395,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ',0),(194187,5395,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ',0),(194188,5395,'tr','Ã‡ek yazmak',0),(194189,5395,'pl','Napisz wyboru',0),(194190,5395,'bg','ÐŸÐ¸ÑˆÐ° Ñ‡ÐµÐº',0),(194191,5395,'ur','Ú†ÛŒÚ© Ù„Ú©Ú¾',0),(194192,5395,'sr','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(194193,5395,'vi','Viáº¿t SÃ©c',0),(194194,5395,'af','Skryf Tjek (NolaPro Stelsel)',0),(194195,5395,'ro','Scrie CEC',0),(194196,5395,'et','Kirjuta tÅ¡ekk',0),(194197,5395,'si','NapiÅ¡ite pregled',0),(194198,5395,'ba','Menulis Check',0),(194199,5395,'nl','Selectievakje schrijven',0),(194200,5395,'fi','Kirjoita tarkistaa',0),(194201,5395,'no','Skriv sjekk',0),(194202,5395,'da','Skriv Check',0),(194203,5395,'ko','ìˆ˜ í‘œë¥¼ ì¨',0),(194204,5395,'he','×œ×¨×©×•× ×¦\'×§',0),(194205,5395,'el','Î“ÏÎ¬ÏˆÏ„Îµ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(194206,5395,'zh','å†™æ£€æŸ¥\r\n',0),(194207,5395,'sv','Skriv Check',0),(194208,5395,'it','Assegno',0),(194209,5395,'tl','',0),(194210,5395,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;',0),(194211,5395,'hi','à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡',0),(194212,5395,'ms','Menulis cek',0),(194213,5395,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(194214,5395,'fr','Faire chÃ¨que',0),(194215,5395,'jp','å°?åˆ‡æ‰‹æ›¸ã??ã?“ã?¿',0),(194216,5395,'pt','Cheque',0),(194217,5395,'ru','Ð’Ñ‹Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ñ‡ÐµÐº',0),(194218,5395,'es','Escribir Cheque',0),(194219,5395,'de','Scheck',0),(194220,5395,'en','Write Check',0),(194221,5396,'is','',0),(194222,5396,'dr','Ú†Ùƒ Ù‡Ø§ÙŠ Ø¯Ø³ØªÙŠ ',0),(194223,5396,'pr','Ú†Ùƒ Ù‡Ø§ÙŠ Ø¯Ø³ØªÙŠ ',0),(194224,5396,'tr','Manuel kontroller',0),(194225,5396,'pl','Instrukcja kontroli',0),(194226,5396,'bg','Ð ÑŠÑ‡Ð½Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(194227,5396,'ur','Ø¯Ø³ØªÛŒ Ú†ÛŒÚ©',0),(194228,5396,'sr','Ð ÑƒÐºÐ¾Ð¼ Ð¿Ð¸ÑÐ°Ð½Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(194229,5396,'vi','SÃ©c thá»§ cÃ´ng',0),(194230,5396,'af','Tjeks (Handgeskrewe)',0),(194231,5396,'ro','VerificÄƒri manuale',0),(194232,5396,'et','KÃ¤sitsi kontrollimine',0),(194233,5396,'si','RoÄno pregledi',0),(194234,5396,'ba','Cek manual',0),(194235,5396,'nl','Handmatige controles',0),(194236,5396,'fi','KÃ¤sin tarkistaa',0),(194237,5396,'no','Manuell sjekker',0),(194238,5396,'da','Manuel kontrol',0),(194239,5396,'ko','ìˆ˜ë™ ê²€ì‚¬',0),(194240,5396,'he','×¦\'×§×™× ×™×“× ×™×™×',0),(194241,5396,'el','Î•Î³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î¿ ÎµÎ»Î­Î³Ï‡Ï‰Î½',0),(194242,5396,'zh','æ‰‹åŠ¨æ£€æŸ¥\r\n',0),(194243,5396,'sv','Manuella kontroller',0),(194244,5396,'it','Controlli manuali',0),(194245,5396,'tl','',0),(194246,5396,'th','&#3648;&#3594;&#3655;&#3588;&#3607;&#3637;&#3656;&#3648;&#3586;&#3637;&#3618;&#3609;&#3604;&#3657;&#3623;&#3618;&#3617;&#3639;&#3629;',0),(194247,5396,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤šà¥‡à¤•',0),(194248,5396,'ms','Pemeriksaan secara manual',0),(194249,5396,'ar','ØµÙƒÙˆÙƒ ÙŠØ¯ÙˆÙŠØ©',0),(194250,5396,'fr','ContrÃ´les manuels',0),(194251,5396,'jp','æ‰‹å‹•å°?åˆ‡æ‰‹',0),(194252,5396,'pt','Controlo manual',0),(194253,5396,'ru','Ð ÑƒÑ‡Ð½Ð¾Ð¹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(194254,5396,'es','Cheques Manuales',0),(194255,5396,'de','Manuelle Kontrollen',0),(194256,5396,'en','Manual Checks',0),(194257,5397,'is','',0),(194258,5397,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø¨Ù‡ ØµÙˆØ±Øª Ø¯Ø³ØªÙŠ Ø¨Ø¯ÙˆÙ† Ø«Ø¨Øª  ÙŠÙƒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(194259,5397,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø¨Ù‡ ØµÙˆØ±Øª Ø¯Ø³ØªÙŠ Ø¨Ø¯ÙˆÙ† Ø«Ø¨Øª  ÙŠÙƒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(194260,5397,'tr','Denetimleri el ile bir Bill girmeden yazmak',0),(194261,5397,'pl','RÄ™cznie napisaÄ‡ kontroli po wprowadzeniu ustawy',0),(194262,5397,'bg','ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ñ€ÑŠÑ‡Ð½Ð¾ Ð±ÐµÐ· Ð¿ÑŠÑ€Ð²Ð¾ Ð²ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(194263,5397,'ur','Ú†ÛŒÚ© Ù¾ÛÙ„Û’ Ø§ÛŒÚ© Ø¨Ù„ Ø¯Ø§Ø®Ù„ Ú©ÛŒÛ’ Ø¨ØºÛŒØ± Ø¯Ø³ØªÛŒ Ø·ÙˆØ± Ù¾Ø± Ù„Ú©Ú¾',0),(194264,5397,'sr','Ð ÑƒÑ‡Ð½Ð¾ Ð¿Ð¸ÑÐ°ÑšÐµ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð±ÐµÐ· Ð¿Ñ€Ð²Ð¾Ð³ ÑƒÐ½Ð¾ÑˆÐµÑšÐ° Ð½Ð°Ñ†Ñ€Ñ‚ Ð·Ð°ÐºÐ¾Ð½Ð°',0),(194265,5397,'vi','Viáº¿t SÃ©c Thá»§ CÃ´ng KhÃ´ng Nháº­p HÃ³a ÄÆ¡n vÃ o trÆ°á»›c',0),(194266,5397,'af','Skryf Handgeskrewe Tjeks Sonder Om Eers \'n Rekening In Te Voer',0),(194267,5397,'ro','Scrie controale manual fÄƒrÄƒ prima intrÄƒ un proiect de lege',0),(194268,5397,'et','*Write Checks Manually Without First Entering a Bill',0),(194269,5397,'si','PiÅ¡ejo pregledov roÄno brez prvega vstopa zakona',0),(194270,5397,'ba','Menulis cek secara manual tanpa pertama memasuki tagihan',0),(194271,5397,'nl','Controles handmatig schrijven zonder eerste het invoeren van een factuur',0),(194272,5397,'fi','Kirjoittaa tarkistaa manuaalisesti syÃ¶ttÃ¤mÃ¤ttÃ¤ Bill',0),(194273,5397,'no','Skrive sjekker manuelt uten Ã¥ fÃ¸rst oppgi en regning',0),(194274,5397,'da','Skrive kontrol manuelt uden fÃ¸rst at indtaste en Bill',0),(194275,5397,'ko','ì²« ë²ˆì§¸ ë²•ì•ˆì„ ìž…ë ¥ í•˜ì§€ ì•Šê³  ê²€ì‚¬ë¥¼ ìˆ˜ë™ìœ¼ë¡œ ìž‘ì„±',0),(194276,5397,'he','×œ×›×ª×•×‘ ×¦\'×§×™× ×‘××•×¤×Ÿ ×™×“× ×™ ×œ×œ× ×”×¨××©×•×Ÿ ×”×–× ×ª ×—×©×‘×•×Ÿ',0),(194277,5397,'el','Î“ÏÎ¬ÏˆÎµÏ„Îµ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Î¼Îµ Î¼Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î¿ Ï„ÏÏŒÏ€Î¿ Ï‡Ï‰ÏÎ¯Ï‚ Ï„Î·Î½ Ï€ÏÏŽÏ„Î· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÎ½ÏŒÏ‚ Î½Î¿Î¼Î¿ÏƒÏ‡ÎµÎ´Î¯Î¿Ï…',0),(194278,5397,'zh','æ‰‹åŠ¨ä¹¦å†™æ”¯ç¥¨ä½†ä¸é¦–å…ˆè¾“å…¥å¸å•\r\n',0),(194279,5397,'sv','Skriva ut checkar manuellt utan fÃ¶rsta ange ett lagfÃ¶rslag',0),(194280,5397,'it','Scrivere controlli manualmente senza prima inserire un disegno di legge',0),(194281,5397,'tl','',0),(194282,5397,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3604;&#3657;&#3623;&#3618;&#3617;&#3639;&#3629;&#3650;&#3604;&#3618;&#3611;&#3619;&#3634;&#3624;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3610;&#3636;&#3621;&#3',0),(194283,5397,'hi','à¤œà¤¾à¤à¤š à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤°à¥‚à¤ª à¤¸à¥‡ à¤²à¤¿à¤–à¤¨à¥‡ à¤•à¥‡ à¤ªà¤¹à¤²à¥‡ à¤à¤• à¤¬à¤¿à¤² à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾',0),(194284,5397,'ms','Menulis cek secara manual tanpa memasukkan pertama Rang undang-undang',0),(194285,5397,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª ÙŠØ¯ÙˆÙŠØ§Ù‹ Ø¯ÙˆÙ† Ø¥Ø¯Ø®Ø§Ù„ Ø£ÙˆÙ„ Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ†',0),(194286,5397,'fr','Ã‰crire des contrÃ´les manuellement sans entrer dâ€™abord dans un projet de loi',0),(194287,5397,'jp','è«‹æ±‚æ›¸ã?®å…¥åŠ›ã?ªã?—ã?«è‡ªå‹•çš„ã?«è«‹æ±‚æ›¸ã‚’æ”¯æ‰•ã?†',0),(194288,5397,'pt','Cheques manualmente sem primeiro entrar em um projeto de lei',0),(194289,5397,'ru','Ð’Ñ‹Ð¿Ð¸ÑÑ‹Ð²Ð°Ñ‚ÑŒ Ñ‡ÐµÐºÐ¸ Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ Ð±ÐµÐ· Ð¿ÐµÑ€Ð²Ð¾Ð³Ð¾ Ð²Ð²Ð¾Ð´Ð° Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(194290,5397,'es','Elaborar Cheques  Manualmente Sin Introducir la Factura Primero',0),(194291,5397,'de','Schreiben Sie Schecks manuell ohne erste Eingabe eine Rechnung',0),(194292,5397,'en','Write Checks Manually Without First Entering a Bill',0),(194293,5398,'is','',0),(194294,5398,'dr','Bad Transaction Code Ú©ÙˆØ¯ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù„Ø§ ÙˆØµÙˆÙ„  ',0),(194295,5398,'pr','Bad Transaction Code ÙƒØ¯ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù„Ø§ ÙˆØµÙˆÙ„  ',0),(194296,5398,'tr','KÃ¶tÃ¼ hareket kodu',0),(194297,5398,'pl','Kod zÅ‚e transakcji',0),(194298,5398,'bg','Ð›Ð¾ÑˆÐ° ÑÐ´ÐµÐ»ÐºÐ° ÐºÐ¾Ð´',0),(194299,5398,'ur','Ø¨Ø±Ø§ Ù…Ø¹Ø§Ù…Ù„Û Ú©ÙˆÚˆ',0),(194300,5398,'sr','Ð”ÐµÐºÐ¸Ð½Ñ‚Ð¸Ñ€Ð°Ð½ Ð¨Ð¸Ñ„Ñ€Ð°',0),(194301,5398,'vi','MÃ£ giao dá»‹ch xáº¥u',0),(194302,5398,'af','Slegte transaksie kode',0),(194303,5398,'ro','Bad tranzacÅ£ie cod',0),(194304,5398,'et','Bad kood',0),(194305,5398,'si','Slab posel kodo',0),(194306,5398,'ba','Kode transaksi yang buruk',0),(194307,5398,'nl','Slechte transactiecode',0),(194308,5398,'fi','Huono tapahtumakoodi',0),(194309,5398,'no','DÃ¥rlig transaksjonskode',0),(194310,5398,'da','DÃ¥rlig transaktionskode',0),(194311,5398,'ko','ë‚˜ìœ íŠ¸ëžœìž­ì…˜ ì½”ë“œ',0),(194312,5398,'he','×§×•×“ ×”×ª× ×•×¢×” ×¨×¢',0),(194313,5398,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚ ÎºÎ±ÎºÏŒ',0),(194314,5398,'zh','åäº¤æ˜“ä»£ç \r\n',0),(194315,5398,'sv','DÃ¥lig transaktionskod',0),(194316,5398,'it','Codice transazione male',0),(194317,5398,'tl','',0),(194318,5398,'th','&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(194319,5398,'hi','à¤¬à¥à¤°à¤¾ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤•à¥‹à¤¡',0),(194320,5398,'ms','Kod urusniaga yang buruk',0),(194321,5398,'ar','Ø±Ù…Ø² Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø© Ø§Ù„Ø³ÙŠØ¦Ø©',0),(194322,5398,'fr','Code Transaction mauvais',0),(194323,5398,'jp','ä¸?é?©åˆ‡å‡¦ç?†ã‚³ãƒ¼ãƒ‰',0),(194324,5398,'pt','CÃ³digo de transaÃ§Ã£o ruim',0),(194325,5398,'ru','ÐšÐ¾Ð´ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð‘Ð°Ð´',0),(194326,5398,'es','Mal CÃ³digo dr TransacciÃ³n',0),(194327,5398,'de','Schlechte Transaktionscode',0),(194328,5398,'en','Bad Transaction Code',0),(194329,5399,'is','',0),(194330,5399,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙØ§ÙŠÙ„ Ù¾ÙŠÙˆØ³Øª',0),(194331,5399,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙØ§ÙŠÙ„ Ù¾ÙŠÙˆØ³Øª',0),(194332,5399,'tr','ACH dosya kimliÄŸi',0),(194333,5399,'pl','ACH plik ID',0),(194334,5399,'bg','ACH Ñ„Ð°Ð¹Ð» ID',0),(194335,5399,'ur','Ø§Ú† Ù…Ø³Ù„ ØªØ´Ø®Øµ',0),(194336,5399,'sr','ÐÑ… Ð˜Ð” Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(194337,5399,'vi','ACH File ID',0),(194338,5399,'af','ACH LÃªer ID',0),(194339,5399,'ro','ACH ID fisier',0),(194340,5399,'et','ACH faili ID',0),(194341,5399,'si','ID datoteke ACH',0),(194342,5399,'ba','Kode File ACH',0),(194343,5399,'nl','ACH bestands-ID',0),(194344,5399,'fi','ACH tiedostotunnus',0),(194345,5399,'no','ACH fil-ID',0),(194346,5399,'da','ACH-fil-ID',0),(194347,5399,'ko','ACH íŒŒì¼ ID',0),(194348,5399,'he','×ž×–×”×” ×§×•×‘×¥ ACH',0),(194349,5399,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Î±ÏÏ‡ÎµÎ¯Î¿Ï… ACH',0),(194350,5399,'zh','è‡ªåŠ¨åŒ–äº¤æ˜“çš„æ–‡ä»¶ID\r\n',0),(194351,5399,'sv','ACH fil-ID',0),(194352,5399,'it','ID File ACH',0),(194353,5399,'tl','',0),(194354,5399,'th','&#3619;&#3627;&#3633;&#3626;&#3652;&#3615;&#3621;&#3660;&#3619;&#3632;&#3610;&#3610; ACH ',0),(194355,5399,'hi','ACH à¤«à¤¼à¤¾à¤‡à¤² ID',0),(194356,5399,'ms','MEN fail ID',0),(194357,5399,'ar','Ù…Ø¹Ø±Ù Ù…Ù„Ù Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(194358,5399,'fr','Identification du Dossier ODC',0),(194359,5399,'jp','ï¼¡ï¼£ï¼¨ãƒ•ã‚¡ã‚¤ãƒ«ï¼©ï¼¤',0),(194360,5399,'pt','ID do arquivo ACH',0),(194361,5399,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ„Ð°Ð¹Ð»Ð° ACH',0),(194362,5399,'es','ID Archivo ACH',0),(194363,5399,'de','ACH-Datei-ID',0),(194364,5399,'en','ACH File ID',0),(194365,5400,'is','',0),(194366,5400,'dr','Ú¯Ø²Ø§Ø±Ø´  Ù¾ÙŠÙˆØ³Øª',0),(194367,5400,'pr','Ú¯Ø²Ø§Ø±Ø´  Ù¾ÙŠÙˆØ³Øª',0),(194368,5400,'tr','ACH raporu',0),(194369,5400,'pl','ACH raportu',0),(194370,5400,'bg','ACH Ð´Ð¾ÐºÐ»Ð°Ð´',0),(194371,5400,'ur','Ø§Ú† Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(194372,5400,'sr','ÐÑ… Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(194373,5400,'vi','BÃ¡o CÃ¡o ACH',0),(194374,5400,'af','ACH Verslag',0),(194375,5400,'ro','ACH Raport',0),(194376,5400,'et','ACH aruanne',0),(194377,5400,'si','ACH poroÄilo',0),(194378,5400,'ba','Laporan ACH',0),(194379,5400,'nl','ACH verslag',0),(194380,5400,'fi','ACH raportti',0),(194381,5400,'no','ACH rapport',0),(194382,5400,'da','ACH rapport',0),(194383,5400,'ko','ACH ë³´ê³ ì„œ',0),(194384,5400,'he','××•×” ×—',0),(194385,5400,'el','ÎˆÎºÎ¸ÎµÏƒÎ· ACH',0),(194386,5400,'zh','è‡ªåŠ¨åŒ–äº¤æ˜“çš„æŠ¥å‘Š\r\n',0),(194387,5400,'sv','ACH rapport',0),(194388,5400,'it','Relazione ACH',0),(194389,5400,'tl','',0),(194390,5400,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3632;&#3610;&#3610; ACH',0),(194391,5400,'hi','ACH à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(194392,5400,'ms','Laporan men',0),(194393,5400,'ar','ØªÙ‚Ø±ÙŠØ± Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(194394,5400,'fr','Rapport ODC',0),(194395,5400,'jp','ï¼¡ï¼£ï¼¨ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(194396,5400,'pt','RelatÃ³rio ACH',0),(194397,5400,'ru','Ð”Ð¾ÐºÐ»Ð°Ð´ ACH',0),(194398,5400,'es','Reporte ACH',0),(194399,5400,'de','ACH-Bericht',0),(194400,5400,'en','ACH Report',0),(194401,5401,'is','',0),(194402,5401,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ ',0),(194403,5401,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ ',0),(194404,5401,'tr','Miktar aralÄ±ÄŸÄ±',0),(194405,5401,'pl','Zakres iloÅ›ci',0),(194406,5401,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ ÐºÑ€ÑŠÐ³',0),(194407,5401,'ur','Ø±Ù‚Ù… Ú©ÛŒ Ø­Ø¯',0),(194408,5401,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¾Ð¿ÑÐµÐ³Ð°',0),(194409,5401,'vi','Sá»‘ Tiá»n Trong Pháº¡m Vi',0),(194410,5401,'af','Bedrag Reeks',0),(194411,5401,'ro','Limita suma',0),(194412,5401,'et','Summa vahemikus',0),(194413,5401,'si','Znesek obseg',0),(194414,5401,'ba','Rentang jumlah',0),(194415,5401,'nl','Bedrag bereik',0),(194416,5401,'fi','Summa-alue',0),(194417,5401,'no','BelÃ¸pet utvalg',0),(194418,5401,'da','MÃ¦ngde rÃ¦kkevidde',0),(194419,5401,'ko','ê¸ˆì•¡ ë²”ìœ„',0),(194420,5401,'he','×˜×•×•×— ×¡×›×•×',0),(194421,5401,'el','Î Î¿ÏƒÏŒ Ï†Î¬ÏƒÎ¼Î±',0),(194422,5401,'zh','ç¨Žé¢å¹…åº¦\r\n',0),(194423,5401,'sv','Beloppet utbud',0),(194424,5401,'it','Gamma di importo',0),(194425,5401,'tl','',0),(194426,5401,'th','&#3594;&#3656;&#3623;&#3591;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(194427,5401,'hi','à¤°à¤¾à¤¶à¤¿ à¤°à¥‡à¤‚à¤œ',0),(194428,5401,'ms','Jumlah julat',0),(194429,5401,'ar','ØªØªØ±Ø§ÙˆØ­ ÙƒÙ…ÙŠØ©',0),(194430,5401,'fr','Gamme de montant',0),(194431,5401,'jp','ç·?é¡?ç¯„å›²',0),(194432,5401,'pt','Intervalo de quantidade',0),(194433,5401,'ru','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¡ÑƒÐ¼Ð¼Ñ‹',0),(194434,5401,'es','Cantidad Rango',0),(194435,5401,'de','Betrag-Bereich',0),(194436,5401,'en','Amount Range',0),(194437,5402,'is','',0),(194438,5402,'dr','Ø¨Ø§Ù†Ùƒ ',0),(194439,5402,'pr','Ø¨Ø§Ù†Ùƒ ',0),(194440,5402,'tr','Banka',0),(194441,5402,'pl','Banku',0),(194442,5402,'bg','Ð‘Ð°Ð½ÐºÐ°',0),(194443,5402,'ur','Ø¨ÛŒÙ†Ú©',0),(194444,5402,'sr','Ð‘Ð°Ð½ÐºÐ°',0),(194445,5402,'vi','NgÃ¢n hÃ ng',0),(194446,5402,'af','Bank',0),(194447,5402,'ro','Banca',0),(194448,5402,'et','Pank',0),(194449,5402,'si','Banka',0),(194450,5402,'ba','Bank',0),(194451,5402,'nl','Bank',0),(194452,5402,'fi','Pankki',0),(194453,5402,'no','Bank',0),(194454,5402,'da','Bank',0),(194455,5402,'ko','ì€í–‰',0),(194456,5402,'he','×‘× ×§',0),(194457,5402,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î±',0),(194458,5402,'zh','é“¶è¡Œ\r\n',0),(194459,5402,'sv','Bank',0),(194460,5402,'it','Banca',0),(194461,5402,'tl','',0),(194462,5402,'th','&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(194463,5402,'hi','à¤¬à¥ˆà¤‚à¤•',0),(194464,5402,'ms','Bank',0),(194465,5402,'ar','Ø§Ù„Ù…ØµØ±Ù',0),(194466,5402,'fr','Banque',0),(194467,5402,'jp','éŠ€è¡Œ',0),(194468,5402,'pt','Banco',0),(194469,5402,'ru','Ð‘Ð°Ð½Ðº',0),(194470,5402,'es','Banco',0),(194471,5402,'de','Bank',0),(194472,5402,'en','Bank',0),(194473,5403,'is','',0),(194474,5403,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ',0),(194475,5403,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ',0),(194476,5403,'tr','TarafÄ±ndan dÃ¼zenlendi',0),(194477,5403,'pl','Stworzony przez',0),(194478,5403,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´ÐµÐ½ Ð¾Ñ‚',0),(194479,5403,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(194480,5403,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ð¾',0),(194481,5403,'vi','Táº¡o bá»Ÿi',0),(194482,5403,'af','Geskep Deur',0),(194483,5403,'ro','Creat de',0),(194484,5403,'et','Loodud',0),(194485,5403,'si','Ustvaril',0),(194486,5403,'ba','Dibuat oleh',0),(194487,5403,'nl','Gemaakt door',0),(194488,5403,'fi','TekijÃ¤',0),(194489,5403,'no','Opprettet av',0),(194490,5403,'da','Lavet af',0),(194491,5403,'ko','ì— ì˜í•´ ë§Œë“¤ì–´ì§„',0),(194492,5403,'he','× ×•×¦×¨ ×¢\"×™',0),(194493,5403,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î±Ï€ÏŒ',0),(194494,5403,'zh','åˆ›å»ºäººï¼š\r\n',0),(194495,5403,'sv','Skapad av',0),(194496,5403,'it','Creato da',0),(194497,5403,'tl','',0),(194498,5403,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3650;&#3604;&#3618;',0),(194499,5403,'hi','à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¬à¤¨à¤¾à¤ˆ à¤—à¤ˆ',0),(194500,5403,'ms','Dicipta oleh',0),(194501,5403,'ar','ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨ÙˆØ§Ø³Ø·Ø©',0),(194502,5403,'fr','CrÃ©Ã© par',0),(194503,5403,'jp','ä½œæˆ?è€…',0),(194504,5403,'pt','Criado por',0),(194505,5403,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½',0),(194506,5403,'es','Creado Por',0),(194507,5403,'de','Erstellt von',0),(194508,5403,'en','Created By',0),(194509,5404,'is','',0),(194510,5404,'dr','ØªØ§Ø±ÙŠØ® Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø´Ø¯Ù‡ ',0),(194511,5404,'pr','ØªØ§Ø±ÙŠØ® Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø´Ø¯Ù‡ ',0),(194512,5404,'tr','Ä°ndirilen tarihi',0),(194513,5404,'pl','Data pobrania',0),(194514,5404,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ñ‚ÐµÐ³Ð»ÐµÐ½Ð¸',0),(194515,5404,'ur','ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(194516,5404,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚',0),(194517,5404,'vi','Táº£i NgÃ y ',0),(194518,5404,'af','Datum Afgelaai',0),(194519,5404,'ro','Data descarcarii',0),(194520,5404,'et','KuupÃ¤ev laadida',0),(194521,5404,'si','Datum prenesli',0),(194522,5404,'ba','Tanggal download',0),(194523,5404,'nl','Datum gedownload',0),(194524,5404,'fi','LatauspÃ¤ivÃ¤',0),(194525,5404,'no','Dato lastet ned',0),(194526,5404,'da','Dato hentede',0),(194527,5404,'ko','ë‹¤ìš´ë¡œë“œ í•œ ë‚ ì§œ',0),(194528,5404,'he','×”×ª××¨×™×š ×”×•×¨×“',0),(194529,5404,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ±Ï„ÎµÎ²Î¬ÏƒÎµÎ¹',0),(194530,5404,'zh','æ—¥æœŸä¸‹è½½\r\n',0),(194531,5404,'sv','Datum hÃ¤mtade',0),(194532,5404,'it','Data scaricato',0),(194533,5404,'tl','',0),(194534,5404,'th','&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(194535,5404,'hi','à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¥€ à¤¤à¤¿à¤¥à¤¿',0),(194536,5404,'ms','Tarikh yang dimuat turun',0),(194537,5404,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ­Ù…ÙŠÙ„',0),(194538,5404,'fr','Date tÃ©lÃ©chargÃ©',0),(194539,5404,'jp','ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰æ—¥',0),(194540,5404,'pt','Data baixada',0),(194541,5404,'ru','Ð”Ð°Ñ‚Ð° Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(194542,5404,'es','Fecha Descargada',0),(194543,5404,'de','Datum heruntergeladen',0),(194544,5404,'en','Date Downloaded',0),(194545,5405,'is','',0),(194546,5405,'dr','ØªØ§Ø±ÙŠØ® Ø¬Ù‡Øª  Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(194547,5405,'pr','ØªØ§Ø±ÙŠØ® Ø¬Ù‡Øª  Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(194548,5405,'tr','KullanÄ±m tarihi',0),(194549,5405,'pl','Data do wykorzystania',0),(194550,5405,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ',0),(194551,5405,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(194552,5405,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ',0),(194553,5405,'vi','NgÃ y dÃ¹ng',0),(194554,5405,'af','Datum om te Gebruik',0),(194555,5405,'ro','Data utilizarii',0),(194556,5405,'et','Kasutamise kuupÃ¤ev',0),(194557,5405,'si','Datum za uporabo',0),(194558,5405,'ba','Tanggal untuk penggunaan',0),(194559,5405,'nl','Datum gebruik',0),(194560,5405,'fi','MennessÃ¤ kÃ¤yttÃ¶Ã¶n',0),(194561,5405,'no','Dato for bruk',0),(194562,5405,'da','Dato til brug',0),(194563,5405,'ko','ì‚¬ìš© ë‚ ì§œ',0),(194564,5405,'he','×ª××¨×™×š ×œ×©×™×ž×•×©',0),(194565,5405,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï‡ÏÎ®ÏƒÎ·Ï‚',0),(194566,5405,'zh','ä½¿ç”¨æ—¥æœŸ\r\n',0),(194567,5405,'sv','Datum fÃ¶r anvÃ¤ndning',0),(194568,5405,'it','Data di utilizzo',0),(194569,5405,'tl','',0),(194570,5405,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;',0),(194571,5405,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤—',0),(194572,5405,'ms','Tarikh penggunaan',0),(194573,5405,'ar','ÙˆØ­ØªÙ‰ Ø§Ù„Ø¢Ù† Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(194574,5405,'fr','Date d\'utilisation',0),(194575,5405,'jp','ä½¿ç”¨æ—¥',0),(194576,5405,'pt','Data de uso',0),(194577,5405,'ru','Ð”Ð°Ñ‚Ð° Ð´Ð»Ñ Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(194578,5405,'es','Fecha para Usar',0),(194579,5405,'de','Datum zu verwenden',0),(194580,5405,'en','Date to Use',0),(194581,5406,'is','',0),(194582,5406,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù† ',0),(194583,5406,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù† ',0),(194584,5406,'tr','GÃ¶rÃ¼ntÃ¼leme',0),(194585,5406,'pl','WyÅ›wietlacz',0),(194586,5406,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ',0),(194587,5406,'ur','Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(194588,5406,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·',0),(194589,5406,'vi','Hiá»ƒn thá»‹',0),(194590,5406,'af','Wys ',0),(194591,5406,'ro','AfiÅŸare',0),(194592,5406,'et','Kuva',0),(194593,5406,'si','Prikaz',0),(194594,5406,'ba','Tampilan',0),(194595,5406,'nl','Weergave',0),(194596,5406,'fi','NÃ¤yttÃ¶',0),(194597,5406,'no','Skjerm',0),(194598,5406,'da','Display',0),(194599,5406,'ko','ë””ìŠ¤í”Œë ˆì´',0),(194600,5406,'he','×”×ª×¦×•×’×”',0),(194601,5406,'el','ÎŸÎ¸ÏŒÎ½Î·',0),(194602,5406,'zh','æ˜¾ç¤º\r\n',0),(194603,5406,'sv','Display',0),(194604,5406,'it','Visualizzazione',0),(194605,5406,'tl','',0),(194606,5406,'th','&#3649;&#3626;&#3604;&#3591;',0),(194607,5406,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨',0),(194608,5406,'ms','Paparan',0),(194609,5406,'ar','Ø¹Ø±Ø¶',0),(194610,5406,'fr','Affichage',0),(194611,5406,'jp','è¡¨ç¤º',0),(194612,5406,'pt','ExposiÃ§Ã£o',0),(194613,5406,'ru','Ð”Ð¸ÑÐ¿Ð»ÐµÐ¹',0),(194614,5406,'es','Desplegar',0),(194615,5406,'de','Display',0),(194616,5406,'en','Display',0),(194617,5407,'is','',0),(194618,5407,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒØ±Ø¯Ù† ',0),(194619,5407,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒØ±Ø¯Ù† ',0),(194620,5407,'tr','Download',0),(194621,5407,'pl','Pobierz za darmo',0),(194622,5407,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ',0),(194623,5407,'ur','ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(194624,5407,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ',0),(194625,5407,'vi','Táº£i',0),(194626,5407,'af','Aflaai',0),(194627,5407,'ro','Descarca',0),(194628,5407,'et','Lae',0),(194629,5407,'si','Download',0),(194630,5407,'ba','Men-download',0),(194631,5407,'nl','Downloaden',0),(194632,5407,'fi','Lataa',0),(194633,5407,'no','Last ned',0),(194634,5407,'da','Download',0),(194635,5407,'ko','ë‹¤ìš´ë¡œë“œ',0),(194636,5407,'he','×”×•×¨×“×”',0),(194637,5407,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÎµÏ„Îµ',0),(194638,5407,'zh','ä¸‹è½½\r\n',0),(194639,5407,'sv','HÃ¤mta',0),(194640,5407,'it','Scarica',0),(194641,5407,'tl','',0),(194642,5407,'th','&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;',0),(194643,5407,'hi','à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(194644,5407,'ms','Muat turun',0),(194645,5407,'ar','ØªØ­Ù…ÙŠÙ„',0),(194646,5407,'fr','TÃ©lÃ©charger',0),(194647,5407,'jp','ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰',0),(194648,5407,'pt','Baixar',0),(194649,5407,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ',0),(194650,5407,'es','Descargar',0),(194651,5407,'de','Download',0),(194652,5407,'en','Download',0),(194653,5408,'is','',0),(194654,5408,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø¯Ø§Ù†Ù„ÙˆØ¯ ',0),(194655,5408,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø¯Ø§Ù†Ù„ÙˆØ¯ ',0),(194656,5408,'tr','Download Tarih',0),(194657,5408,'pl','Historia pobierania',0),(194658,5408,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(194659,5408,'ur','ØªØ§Ø±ÛŒØ® ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(194660,5408,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐ°',0),(194661,5408,'vi','Táº£i lá»‹ch sá»­',0),(194662,5408,'af','Afgelaaide Geskiedenis',0),(194663,5408,'ro','Istoric descarcare',0),(194664,5408,'et','Lae ajalugu',0),(194665,5408,'si','Zgodovina prenosov',0),(194666,5408,'ba','Riwayat unduhan',0),(194667,5408,'nl','Downloadgeschiedenis',0),(194668,5408,'fi','Lataa historia',0),(194669,5408,'no','Nedlastingsloggen',0),(194670,5408,'da','Download historie',0),(194671,5408,'ko','ë‹¤ìš´ë¡œë“œ ì—­ì‚¬',0),(194672,5408,'he','×”×¡×˜×•×¨×™×™×ª ×”×•×¨×“×”',0),(194673,5408,'el','Î›Î®ÏˆÎ· Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(194674,5408,'zh','ä¸‹è½½åŽ†å²è®°å½•\r\n',0),(194675,5408,'sv','HÃ¤mta historia',0),(194676,5408,'it','Scarica storia',0),(194677,5408,'tl','',0),(194678,5408,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;',0),(194679,5408,'hi','à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(194680,5408,'ms','Sejarah muat turun',0),(194681,5408,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ­Ù…ÙŠÙ„',0),(194682,5408,'fr','TÃ©lÃ©charger l\'historique',0),(194683,5408,'jp','ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰å±¥æ­´',0),(194684,5408,'pt','HistÃ³rico de download',0),(194685,5408,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ð˜ÑÑ‚Ð¾Ñ€Ð¸ÑŽ',0),(194686,5408,'es','Descargar Historia',0),(194687,5408,'de','Download-Chronik',0),(194688,5408,'en','Download History',0),(194689,5409,'is','',0),(194690,5409,'dr','ØªØ§Ø±ÙŠØ® Ù…ÙˆØ«Ø±',0),(194691,5409,'pr','ØªØ§Ø±ÙŠØ® Ù…ÙˆØ«Ø±',0),(194692,5409,'tr','GeÃ§erlilik tarihi',0),(194693,5409,'pl','Data wejÅ›cia w Å¼ycie',0),(194694,5409,'bg','Ð•Ñ„ÐµÐºÑ‚Ð¸Ð²Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(194695,5409,'ur','Ù…ÙˆØ«Ø± ØªØ§Ø±ÛŒØ®',0),(194696,5409,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÑÑ‚ÑƒÐ¿Ð°ÑšÐ° Ð½Ð° ÑÐ½Ð°Ð³Ñƒ',0),(194697,5409,'vi','NgÃ y hiá»‡u lá»±c',0),(194698,5409,'af','Effektiewe Datum',0),(194699,5409,'ro','Data efectiva',0),(194700,5409,'et','JÃµustumise kuupÃ¤ev',0),(194701,5409,'si','Datum uveljavitve',0),(194702,5409,'ba','Tanggal efektif',0),(194703,5409,'nl','Ingangsdatum',0),(194704,5409,'fi','Voimaantulo',0),(194705,5409,'no','Ikrafttredelsesdato',0),(194706,5409,'da','IkrafttrÃ¦delsesdato',0),(194707,5409,'ko','ìœ íš¨ ë‚ ì§œ',0),(194708,5409,'he','×ª××¨×™×š ××¤×§×˜×™×‘×™',0),(194709,5409,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Î¹ÏƒÏ‡ÏÎ¿Ï‚',0),(194710,5409,'zh','ç”Ÿæ•ˆæ—¥æœŸ\r\n',0),(194711,5409,'sv','Giltighetsdatum',0),(194712,5409,'it','Data effettiva',0),(194713,5409,'tl','',0),(194714,5409,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3617;&#3637;&#3612;&#3621;',0),(194715,5409,'hi','à¤ªà¥à¤°à¤­à¤¾à¤µà¥€ à¤¤à¤¿à¤¥à¤¿',0),(194716,5409,'ms','Tarikh kuat kuasa',0),(194717,5409,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ¹Ù„ÙŠ',0),(194718,5409,'fr','Date d\'entrÃ©e en',0),(194719,5409,'jp','æœ‰åŠ¹æ—¥',0),(194720,5409,'pt','Data efetiva',0),(194721,5409,'ru','Ð”Ð°Ñ‚Ð° Ð²ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ Ð² ÑÐ¸Ð»Ñƒ',0),(194722,5409,'es','Fecha Efectiva',0),(194723,5409,'de','Datum des Inkrafttretens',0),(194724,5409,'en','Effective Date',0),(194725,5410,'is','',0),(194726,5410,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(194727,5410,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(194728,5410,'tr','Ã‡alÄ±ÅŸan kimliÄŸi',0),(194729,5410,'pl','Identyfikator pracownika',0),(194730,5410,'bg','Ð˜Ð” Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(194731,5410,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(194732,5410,'sr','Ð˜Ð” Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(194733,5410,'vi','ID NhÃ¢n viÃªn ',0),(194734,5410,'af','Werknemer ID',0),(194735,5410,'ro','ID angajat',0),(194736,5410,'et','TÃ¶Ã¶taja ID',0),(194737,5410,'si','ID zaposlenega',0),(194738,5410,'ba','ID karyawan',0),(194739,5410,'nl','Werknemer-ID',0),(194740,5410,'fi','TyÃ¶ntekijÃ¤ nro',0),(194741,5410,'no','Ansatt-ID',0),(194742,5410,'da','Medarbejder-ID',0),(194743,5410,'ko','ì§ì› ID',0),(194744,5410,'he','×ž×–×”×” ×¢×•×‘×“',0),(194745,5410,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï…Ï€Î±Î»Î»Î®Î»Î¿Ï…',0),(194746,5410,'zh','å‘˜å·¥ID',0),(194747,5410,'sv','Medarbetar-ID',0),(194748,5410,'it','ID dipendente',0),(194749,5410,'tl','',0),(194750,5410,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(194751,5410,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ ID',0),(194752,5410,'ms','ID pekerja',0),(194753,5410,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…ÙˆØ¸Ù',0),(194754,5410,'fr','ID de l\'employÃ©',0),(194755,5410,'jp','å¾“æ¥­å“¡ï¼©ï¼¤',0),(194756,5410,'pt','ID de empregado',0),(194757,5410,'ru','ID Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(194758,5410,'es','Empleado ID',0),(194759,5410,'de','Mitarbeiter-ID',0),(194760,5410,'en','Employee ID',0),(194761,5411,'is','',0),(194762,5411,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… Ù¾Ø±Ø¯Ø§Ø²Ø´  ÙƒØ±Ø¯Ù† Ø¹Ù…Ù„ÙŠØ§Øª Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ â€“ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ Ø±Ø§ Ú†Ùƒ ÙƒÙ†ÙŠØ¯ ',0),(194763,5411,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… Ù¾Ø±Ø¯Ø§Ø²Ø´  ÙƒØ±Ø¯Ù† Ø¹Ù…Ù„ÙŠØ§Øª Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ â€“ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ Ø±Ø§ Ú†Ùƒ ÙƒÙ†ÙŠØ¯ ',0),(194764,5411,'tr','Arama sorgu iÅŸlerken hata oluÅŸtu; Arama seÃ§eneklerini denetleyin.',0),(194765,5411,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas przetwarzania zapytania; SprawdÅº opcje wyszukiwania.',0),(194766,5411,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ; ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ð¸Ñ‚Ðµ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ.',0),(194767,5411,'ur','ØªÙ„Ø§Ø´ Ø·Ù„Ø¨ Ú©ÛŒ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ Û” ØªÙ„Ø§Ø´ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº Û”',0),(194768,5411,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¾Ð±Ñ€Ð°Ð´Ðµ ÑƒÐ¿Ð¸Ñ‚Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ðµ; ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°.',0),(194769,5411,'vi','Lá»—i khi xá»­ lÃ½ truy váº¥n; kiá»ƒm tra lá»±a chá»n tÃ¬m kiáº¿m',0),(194770,5411,'af','Fout terwyl verwerk die soeknavraag; Kontroleer die soekopsies.',0),(194771,5411,'ro','Eroare in timpul cautarii; verifica optiunile de cautare',0),(194772,5411,'et','Otsingu pÃ¤ringu tÃ¶Ã¶tlemisel ilmnes tÃµrge Kontrollige otsinguvÃµimalusi.',0),(194773,5411,'si','Napaka med obdelavo iskalno poizvedbo; Preverite moÅ¾nosti iskanja.',0),(194774,5411,'ba','Kesalahan saat memproses kueri penelusurannya; Periksa pilihan pencarian.',0),(194775,5411,'nl','Fout tijdens het verwerken van de zoekopdracht. Controleer de opties voor zoeken.',0),(194776,5411,'fi','Virhe kÃ¤siteltÃ¤essÃ¤ hakulauseke; Tarkista etsinnÃ¤n asetukset.',0),(194777,5411,'no','Feil under behandling av sÃ¸keordet. Sjekk sÃ¸kealternativene.',0),(194778,5411,'da','Fejl under behandling af sÃ¸geforespÃ¸rgslen; Kontroller sÃ¸geindstillingerne.',0),(194779,5411,'ko','ê²€ìƒ‰ ì¿¼ë¦¬ë¥¼ ì²˜ë¦¬ í•˜ëŠ” ë™ì•ˆ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤ ê²€ìƒ‰ ì˜µì…˜ì„ í™•ì¸ í•˜ì‹­ì‹œì˜¤.',0),(194780,5411,'he','××™×¨×¢×” ×©×’×™××” ×‘×¢×ª ×¢×™×‘×•×“ ×©××™×œ×ª×ª ×”×—×™×¤×•×©; ×‘×“×•×§ ××ª ××¤×©×¨×•×™×•×ª ×”×—×™×¤×•×©.',0),(194781,5411,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÏÏ‰Ï„Î®Î¼Î±Ï„Î¿Ï‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚. Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î¹Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚.',0),(194782,5411,'zh','åœ¨å¤„ç†æœç´¢æŸ¥è¯¢ä¸­å‡ºé”™ï¼Œæ£€æŸ¥çš„æœç´¢é€‰é¡¹ã€‚\r\n',0),(194783,5411,'sv','Fel vid bearbetning sÃ¶kfrÃ¥gan; Kontrollera sÃ¶kalternativ.',0),(194784,5411,'it','Errore durante l\'elaborazione della query di ricerca; controllare le opzioni di ricerca.',0),(194785,5411,'tl','',0),(194786,5411,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3586;&#3603;&#3632;&#3607;&#3637;&#3656;&#3585;&#3635;&#3621;&#3633;&#3591;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3585;&#3634;&#3619;&#3588;&#3636;&#3623;&#3619;&#3637; &#3605;&#3619;&#',0),(194787,5411,'hi','à¤–à¥‹à¤œ à¤•à¥à¤µà¥‡à¤°à¥€ à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤•à¤°à¤¤à¥‡ à¤¸à¤®à¤¯ à¤¤à¥à¤°à¥à¤Ÿà¤¿; à¤–à¥‹à¤œ à¤µà¤¿à¤•à¤²à¥à¤ªà¥‹à¤‚ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚à¥¤',0),(194788,5411,'ms','Ralat semasa memproses pertanyaan gelintar; Semak pilihan carian.',0),(194789,5411,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ø§Ø³ØªØ¹Ù„Ø§Ù… Ø§Ù„Ø¨Ø­Ø«Ø› ØªØ­Ù‚Ù‚ Ù…Ù† Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø¨Ø­Ø«.',0),(194790,5411,'fr','Erreur lors du traitement de la requÃªte de recherche ; VÃ©rifiez les options de recherche.',0),(194791,5411,'jp','æ¤œç´¢ä¸­ã?«ã‚¨ãƒ©ãƒ¼ã?Œã?‚ã‚Šã?¾ã?—ã?Ÿã€‚æ¤œç´¢ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’ç¢ºèª?ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(194792,5411,'pt','Erro ao processar a consulta de pesquisa; Verifique as opÃ§Ãµes de busca.',0),(194793,5411,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐµ Ð¿Ð¾Ð¸ÑÐºÐ¾Ð²Ð¾Ð³Ð¾ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°; ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð¿Ð¾Ð¸ÑÐºÐ°.',0),(194794,5411,'es','Error mientras procesar el query de la busqueda; chequear las opciones de busqueda',0),(194795,5411,'de','Fehler beim Verarbeiten der Suchanfrage; ÃœberprÃ¼fen Sie die Suchoptionen.',0),(194796,5411,'en','Error while processing the search query; check the search options.',0),(194797,5412,'is','',0),(194798,5412,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ Ù¾ÙŠØ¯Ø§ Ø´Ø¯Ù†Ø¯ ',0),(194799,5412,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ Ù¾ÙŠØ¯Ø§ Ø´Ø¯Ù†Ø¯ ',0),(194800,5412,'tr','Dosya bulunamadÄ±',0),(194801,5412,'pl','Pliki Znalezione',0),(194802,5412,'bg','ÐÐ°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(194803,5412,'ur','Ù…Ø³Ù„ÛŒÚº Ù…Ù„ÛŒ',0),(194804,5412,'sr','ÐŸÑ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(194805,5412,'vi','Tháº¥y Há»“ sÆ¡',0),(194806,5412,'af','LÃªers Gevind',0),(194807,5412,'ro','Fisiere gasite',0),(194808,5412,'et','Leitud failid',0),(194809,5412,'si','Najdene datoteke',0),(194810,5412,'ba','File yang ditemukan',0),(194811,5412,'nl','Bestanden gevonden',0),(194812,5412,'fi','Tiedostoa lÃ¶ytynyt',0),(194813,5412,'no','Filene',0),(194814,5412,'da','Filer, der findes',0),(194815,5412,'ko','íŒŒì¼ ë°œê²¬',0),(194816,5412,'he','×§×‘×¦×™× × ×ž×¦××•',0),(194817,5412,'el','Î‘ÏÏ‡ÎµÎ¯Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(194818,5412,'zh','æ‰¾åˆ°çš„æ–‡ä»¶\r\n',0),(194819,5412,'sv','Hittade filer',0),(194820,5412,'it','File trovati',0),(194821,5412,'tl','',0),(194822,5412,'th','&#3614;&#3610;&#3652;&#3615;&#3621;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(194823,5412,'hi','à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤®à¤¿à¤²à¥€à¤‚',0),(194824,5412,'ms','Fail dijumpai',0),(194825,5412,'ar','Ø¹Ø«Ø± Ø¹Ù„Ù‰ Ø§Ù„Ù…Ù„ÙØ§Øª',0),(194826,5412,'fr','Fichiers trouvÃ©s',0),(194827,5412,'jp','è¦‹ã?¤ã?‹ã?£ã?Ÿãƒ•ã‚¡ã‚¤ãƒ«',0),(194828,5412,'pt','Arquivos encontrados',0),(194829,5412,'ru','Ð¤Ð°Ð»Ñ‹ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(194830,5412,'es','Files Encontrados',0),(194831,5412,'de','Dateien gefunden',0),(194832,5412,'en','Files Found',0),(194833,5413,'is','',0),(194834,5413,'dr','Ù…Ø­ØªÙˆØ§ ÙŠ ÙØ§ÙŠÙ„ ',0),(194835,5413,'pr','Ù…Ø­ØªÙˆØ§ ÙŠ ÙØ§ÙŠÙ„ ',0),(194836,5413,'tr','Dosya iÃ§eriÄŸi',0),(194837,5413,'pl','ZawartoÅ›Ä‡ pliku',0),(194838,5413,'bg','Ð¡ÑŠÐ´ÑŠÑ€Ð¶Ð°Ð½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð°',0),(194839,5413,'ur','Ù…Ø³Ù„ Ù…Ø´Ù…ÙˆÙ„Ø§Øª',0),(194840,5413,'sr','Ð¡Ð°Ð´Ñ€Ð¶Ð°Ñ˜ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(194841,5413,'vi','Ná»™i dung há»“ sÆ¡',0),(194842,5413,'af','LÃªersinhoud',0),(194843,5413,'ro','Continut fisier',0),(194844,5413,'et','Faili sisu',0),(194845,5413,'si','Vsebina datoteke',0),(194846,5413,'ba','Isi file',0),(194847,5413,'nl','Bestandsinhoud',0),(194848,5413,'fi','Tiedoston sisÃ¤ltÃ¶',0),(194849,5413,'no','Filinnholdet',0),(194850,5413,'da','Filens indhold',0),(194851,5413,'ko','íŒŒì¼ ë‚´ìš©',0),(194852,5413,'he','×ª×•×›×Ÿ ×”×§×•×‘×¥',0),(194853,5413,'el','Î ÎµÏÎ¹ÎµÏ‡ÏŒÎ¼ÎµÎ½Î± Ï„Î¿Ï… Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(194854,5413,'zh','æ–‡ä»¶å†…å®¹\r\n',0),(194855,5413,'sv','FilinnehÃ¥llet',0),(194856,5413,'it','Contenuto del file',0),(194857,5413,'tl','',0),(194858,5413,'th','&#3652;&#3615;&#3621;&#3660;&#3648;&#3609;&#3639;&#3657;&#3629;&#3627;&#3634;',0),(194859,5413,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥€ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€',0),(194860,5413,'ms','Kandungan fail',0),(194861,5413,'ar','Ù…Ø­ØªÙˆÙŠØ§Øª Ø§Ù„Ù…Ù„ÙÙ‘',0),(194862,5413,'fr','Contenu du fichier',0),(194863,5413,'jp','ãƒ•ã‚¡ã‚¤ãƒ«å†…å®¹',0),(194864,5413,'pt','ConteÃºdo do arquivo',0),(194865,5413,'ru','Ð¡Ð¾Ð´ÐµÑ€Ð¶Ð¸Ð¼Ð¾Ðµ Ð¤Ð°Ð¹Ð»Ð°',0),(194866,5413,'es','Contenidos de Files',0),(194867,5413,'de','Inhalt der Datei',0),(194868,5413,'en','File Contents',0),(194869,5414,'is','',0),(194870,5414,'dr','ØªØ§Ø±ÙŠØ® Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙŠÙ„ ',0),(194871,5414,'pr','ØªØ§Ø±ÙŠØ® Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙŠÙ„ ',0),(194872,5414,'tr','Dosya oluÅŸturma tarihi',0),(194873,5414,'pl','Data utworzenia pliku',0),(194874,5414,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð°',0),(194875,5414,'ur','Ù…Ø³Ù„ Ø¨Ù†Ø§Ù†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(194876,5414,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(194877,5414,'vi','NgÃ y táº¡o Há»“ sÆ¡',0),(194878,5414,'af','LÃªer Skeppingsdatum',0),(194879,5414,'ro','Data creare fisier',0),(194880,5414,'et','Faili loomiskuupÃ¤ev',0),(194881,5414,'si','Datum ustvarjanja datoteke',0),(194882,5414,'ba','Tanggal pembuatan file',0),(194883,5414,'nl','Aanmaakdatum van bestand',0),(194884,5414,'fi','Tiedoston luontipÃ¤ivÃ¤',0),(194885,5414,'no','Dato for filopprettelse',0),(194886,5414,'da','Filoprettelsesdato',0),(194887,5414,'ko','íŒŒì¼ ë§Œë“  ë‚ ì§œ',0),(194888,5414,'he','×ª××¨×™×š ×™×¦×™×¨×ª ×”×§×•×‘×¥',0),(194889,5414,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±Ï‚ Ï„Î¿Ï… Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(194890,5414,'zh','æ–‡ä»¶åˆ›å»ºæ—¥æœŸ\r\n',0),(194891,5414,'sv','Filens skapelsedatum',0),(194892,5414,'it','Data di creazione del file.',0),(194893,5414,'tl','',0),(194894,5414,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3619;&#3657;&#3634;&#3591;&#3652;&#3615;&#3621;&#3660;',0),(194895,5414,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(194896,5414,'ms','Tarikh penciptaan fail',0),(194897,5414,'ar','ØªØ§Ø±ÙŠØ® Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ù…Ù„ÙÙ‘',0),(194898,5414,'fr','Date de crÃ©ation de fichier',0),(194899,5414,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ä½œæˆ?æ—¥',0),(194900,5414,'pt','Data de criaÃ§Ã£o do arquivo',0),(194901,5414,'ru','Ð”Ð°Ñ‚Ð° Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ñ Ð¤Ð°Ð¹Ð»Ð°',0),(194902,5414,'es','Fecha de CraciÃ³n de Files',0),(194903,5414,'de','Erstellungsdatum der Datei',0),(194904,5414,'en','File Creation Date',0),(194905,5415,'is','',0),(194906,5415,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø±Ù‡Ú¯ÙŠØ±ÙŠ',0),(194907,5415,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø±Ù‡Ú¯ÙŠØ±ÙŠ',0),(194908,5415,'tr','Rota numarasÄ±',0),(194909,5415,'pl','Numer marszruty',0),(194910,5415,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚',0),(194911,5415,'ur','Ø±ÙˆÙ¹ Ù†Ù…Ø¨Ø±',0),(194912,5415,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¾Ð³ Ð¿Ð¾ÑÑ‚ÑƒÐ¿ÐºÐ°',0),(194913,5415,'vi','Sá»‘ Ä‘á»‹nh tuyáº¿n',0),(194914,5415,'af','Nommer routing',0),(194915,5415,'ro','Numar rutare',0),(194916,5415,'et','Marsruudinumber',0),(194917,5415,'si','Å tevilka proizvodnega postopka',0),(194918,5415,'ba','Nomor routing',0),(194919,5415,'nl','Bewerkingsplannummer',0),(194920,5415,'fi','Reititysnumero',0),(194921,5415,'no','Organisasjonsnummer',0),(194922,5415,'da','Registreringsnummeret',0),(194923,5415,'ko','ë¼ìš°íŒ… ë²ˆí˜¸',0),(194924,5415,'he','×ž×¡×¤×¨ ×”× ×™×ª×•×‘',0),(194925,5415,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(194926,5415,'zh','è·¯å¾„å·ç \r\n',0),(194927,5415,'sv','Routing Number',0),(194928,5415,'it','Numero di percorso',0),(194929,5415,'tl','',0),(194930,5415,'th','Routing Number',0),(194931,5415,'hi','Number à¤…à¤¨à¥à¤®à¤¾à¤°à¥à¤—à¤£',0),(194932,5415,'ms','Penghalaan nombor',0),(194933,5415,'ar','Ø§Ù„ØªÙˆØ¬ÙŠÙ‡ Ø±Ù‚Ù…',0),(194934,5415,'fr','NumÃ©ro d\'acheminement',0),(194935,5415,'jp','ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå?·',0),(194936,5415,'pt','NÃºmero de Roteamento',0),(194937,5415,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð°',0),(194938,5415,'es','NÃºmero de Routing',0),(194939,5415,'de','Bankleitzahl',0),(194940,5415,'en','Routing Number',0),(194941,5416,'is','',0),(194942,5416,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(194943,5416,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(194944,5416,'tr','Arama seÃ§enekleri',0),(194945,5416,'pl','Opcje wyszukiwania',0),(194946,5416,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(194947,5416,'ur','ØªÙ„Ø§Ø´ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(194948,5416,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ðµ',0),(194949,5416,'vi','TÃ¬m kiáº¿m lá»±a chá»n',0),(194950,5416,'af','Soek Opsies',0),(194951,5416,'ro','Optiuni de cautare',0),(194952,5416,'et','Otsingu Valikud',0),(194953,5416,'si','MoÅ¾nosti iskanja',0),(194954,5416,'ba','Pilihan pencarian',0),(194955,5416,'nl','Zoekopties',0),(194956,5416,'fi','EtsinnÃ¤n asetukset',0),(194957,5416,'no','SÃ¸kealternativer',0),(194958,5416,'da','SÃ¸gemuligheder',0),(194959,5416,'ko','ê²€ìƒ‰ ì˜µì…˜',0),(194960,5416,'he','××¤×©×¨×•×™×•×ª ×—×™×¤×•×©',0),(194961,5416,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(194962,5416,'zh','æœç´¢é€‰é¡¹\r\n',0),(194963,5416,'sv','SÃ¶kalternativ',0),(194964,5416,'it','Opzioni di ricerca',0),(194965,5416,'tl','',0),(194966,5416,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(194967,5416,'hi','à¤–à¥‹à¤œ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(194968,5416,'ms','Pilihan carian',0),(194969,5416,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø¨Ø­Ø«',0),(194970,5416,'fr','Options de recherche',0),(194971,5416,'jp','æ¤œç´¢ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(194972,5416,'pt','OpÃ§Ãµes de Pesquisa',0),(194973,5416,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÐŸÐ¾Ð¸ÑÐºÐ°',0),(194974,5416,'es','Buscar Opciones',0),(194975,5416,'de','Suchoptionen',0),(194976,5416,'en','Search Options',0),(194977,5417,'is','',0),(194978,5417,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù†ØªØ§ÙŠØ¬',0),(194979,5417,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù†ØªØ§ÙŠØ¬',0),(194980,5417,'tr','Arama sonuÃ§larÄ±',0),(194981,5417,'pl','Wyniki wyszukiwania',0),(194982,5417,'bg','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸ Ð¾Ñ‚ Ñ‚ÑŠÑ€ÑÐµÐ½ÐµÑ‚Ð¾',0),(194983,5417,'ur','ØªÙ„Ø§Ø´ Ú©Û’ Ù†ØªØ§Ø¦Ø¬',0),(194984,5417,'sr','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ðµ',0),(194985,5417,'vi','TÃ¬m kiáº¿m káº¿t quáº£',0),(194986,5417,'af','Soek Resultate',0),(194987,5417,'ro','Rezultatele cautarii',0),(194988,5417,'et','Otsingu tulemused',0),(194989,5417,'si','Rezultati iskanja',0),(194990,5417,'ba','Hasil pencarian',0),(194991,5417,'nl','Zoekresultaten',0),(194992,5417,'fi','Hakutulokset',0),(194993,5417,'no','SÃ¸keresultater',0),(194994,5417,'da','SÃ¸geresultater',0),(194995,5417,'ko','ê²€ìƒ‰ ê²°ê³¼',0),(194996,5417,'he','×ª×•×¦××•×ª ×—×™×¤×•×©',0),(194997,5417,'el','Î‘Ï€Î¿Ï„ÎµÎ»Î­ÏƒÎ¼Î±Ï„Î± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(194998,5417,'zh','æœç´¢ç»“æžœ\r\n',0),(194999,5417,'sv','SÃ¶kresultat',0),(195000,5417,'it','Risultati della ricerca',0),(195001,5417,'tl','',0),(195002,5417,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3612;&#3621;&#3621;&#3633;&#3614;&#3608;&#3660;',0),(195003,5417,'hi','à¤–à¥‹à¤œ à¤ªà¤°à¤¿à¤£à¤¾à¤®',0),(195004,5417,'ms','Hasil carian',0),(195005,5417,'ar','Ù†ØªØ§Ø¦Ø¬ Ø§Ù„Ø¨Ø­Ø«',0),(195006,5417,'fr','RÃ©sultats de recherche',0),(195007,5417,'jp','æ¤œç´¢çµ?æžœ',0),(195008,5417,'pt','Resultados de Pesquisa',0),(195009,5417,'ru','Ð˜ÑÐºÐ°Ñ‚ÑŒ Ð ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ñ‹',0),(195010,5417,'es','Buscar Resultados',0),(195011,5417,'de','Suchergebnisse',0),(195012,5417,'en','Search Results',0),(195013,5418,'is','',0),(195014,5418,'dr','(Ø·Ù„Ø¨',0),(195015,5418,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ(Ø·Ù„Ø¨',0),(195016,5418,'tr','Toplam kredi',0),(195017,5418,'pl','OgÃ³Å‚em kredyty',0),(195018,5418,'bg','ÐžÐ±Ñ‰Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸',0),(195019,5418,'ur','Ú©Ù„ Ú©Ø±ÛŒÚˆÙ¹',0),(195020,5418,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸',0),(195021,5418,'vi','ToÃ n Bá»™ TÃ­n Dá»¥ng',0),(195022,5418,'af','Totale Krediete',0),(195023,5418,'ro','Total credite',0),(195024,5418,'et','Kokku krediiti',0),(195025,5418,'si','Skupaj krediti',0),(195026,5418,'ba','Total kredit',0),(195027,5418,'nl','Totaal Credits',0),(195028,5418,'fi','Hyvitysten kokonaismÃ¤Ã¤rÃ¤',0),(195029,5418,'no','Totale antall kurspoeng',0),(195030,5418,'da','Samlede Credits',0),(195031,5418,'ko','ì´ í•™ì ',0),(195032,5418,'he','×¡×” ×› × ×§×•×“×•×ª ×–×›×•×ª',0),(195033,5418,'el','Î¤Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï„Ï‰Î½ Ï€Î¹ÏƒÏ„ÏŽÏƒÎµÏ‰Î½',0),(195034,5418,'zh','æ€»è´·æ¬¾\r\n',0),(195035,5418,'sv','Totala poÃ¤ng',0),(195036,5418,'it','Totale crediti',0),(195037,5418,'tl','',0),(195038,5418,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(195039,5418,'hi','à¤•à¥à¤² à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(195040,5418,'ms','Jumlah kredit',0),(195041,5418,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø§Ø¹ØªÙ…Ø§Ø¯Ø§Øª',0),(195042,5418,'fr','Total des crÃ©dits',0),(195043,5418,'jp','ç·?è²¸æ–¹',0),(195044,5418,'pt','Total de CrÃ©ditos',0),(195045,5418,'ru','Ð’ÑÐµÐ³Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ð²',0),(195046,5418,'es','CrÃ©ditos Totales',0),(195047,5418,'de','Total Credits',0),(195048,5418,'en','Total Credits',0),(195049,5419,'is','',0),(195050,5419,'dr','(Ø­Ø³Ø§Ø¨ Ø¯ÛŒÙˆÙ† ',0),(195051,5419,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø¯Ù‡ÙƒØ§Ø±(Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡ÙŠ',0),(195052,5419,'tr','Toplam BorÃ§lar',0),(195053,5419,'pl','CaÅ‚kowitego obciÄ…Å¼enia',0),(195054,5419,'bg','ÐžÐ±Ñ‰Ð¾ Ð´ÐµÐ±Ð¸Ñ‚',0),(195055,5419,'ur','Ú©Ù„ Ø¯ÛŒØ¨ØªØ³',0),(195056,5419,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(195057,5419,'vi','Tá»•ng cá»™ng ná»£',0),(195058,5419,'af','Totale Debiete',0),(195059,5419,'ro','Total debite',0),(195060,5419,'et','Kogu deebetsumma',0),(195061,5419,'si','Skupaj v breme',0),(195062,5419,'ba','Total debet',0),(195063,5419,'nl','Totaal debet',0),(195064,5419,'fi','Veloitusten kokonaismÃ¤Ã¤rÃ¤',0),(195065,5419,'no','Totalt debet',0),(195066,5419,'da','Samlede debet',0),(195067,5419,'ko','ì´ ì°¨ë³€',0),(195068,5419,'he','×¡×” ×› ×—×™×•×‘×™×',0),(195069,5419,'el','Î¤Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï„Ï‰Î½ Ï‡ÏÎµÏŽÏƒÎµÏ‰Î½',0),(195070,5419,'zh','åˆè®¡å€Ÿæ–¹\r\n',0),(195071,5419,'sv','Totala debiteringar',0),(195072,5419,'it','Totali debiti',0),(195073,5419,'tl','',0),(195074,5419,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3648;&#3604;&#3610;&#3636;&#3605;',0),(195075,5419,'hi','à¤•à¥à¤² à¤¨à¤¾à¤®à¥‡',0),(195076,5419,'ms','Jumlah Debit',0),(195077,5419,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø®ØµÙˆÙ…',0),(195078,5419,'fr','Total des retraits',0),(195079,5419,'jp','ç·?å€Ÿæ–¹',0),(195080,5419,'pt','Total de DÃ©bitos',0),(195081,5419,'ru','Ð’ÑÐµÐ³Ð¾ Ð´ÐµÐ±ÐµÑ‚',0),(195082,5419,'es','DÃ©bitos Totales',0),(195083,5419,'de','Total Debits',0),(195084,5419,'en','Total Debits',0),(195085,5420,'is','',0),(195086,5420,'dr','ÙƒÙ„ Ø§Ø³Ù†Ø§Ø¯ ',0),(195087,5420,'pr','ÙƒÙ„ Ø§Ø³Ù†Ø§Ø¯ ',0),(195088,5420,'tr','Toplam kayÄ±t sayÄ±sÄ±',0),(195089,5420,'pl','Liczba rekordÃ³w',0),(195090,5420,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(195091,5420,'ur','Ú©Ù„ Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(195092,5420,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ°',0),(195093,5420,'vi','Tá»•ng cá»™ng há»“ sÆ¡',0),(195094,5420,'af','Totale Rekords',0),(195095,5420,'ro','Total inregistrari',0),(195096,5420,'et','Kirjete koguarv',0),(195097,5420,'si','Skupno Å¡tevilo zapisov',0),(195098,5420,'ba','Total catatan',0),(195099,5420,'nl','Totalen berekenen voor Records',0),(195100,5420,'fi','Tietueita yhteensÃ¤',0),(195101,5420,'no','Totalt antall poster',0),(195102,5420,'da','Total Records',0),(195103,5420,'ko','ì´ ë ˆì½”ë“œ',0),(195104,5420,'he','×¡×š ×”×¨×©×•×ž×•×ª',0),(195105,5420,'el','Î£ÏÎ½Î¿Î»Î¿ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(195106,5420,'zh','æ€»è®°å½•\r\n',0),(195107,5420,'sv','Totalt antal poster',0),(195108,5420,'it','Totale record',0),(195109,5420,'tl','',0),(195110,5420,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3607;&#3637;&#3656;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;',0),(195111,5420,'hi','à¤•à¥à¤² à¤…à¤­à¤¿à¤²à¥‡à¤–',0),(195112,5420,'ms','Jumlah rekod',0),(195113,5420,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø³Ø¬Ù„Ø§Øª',0),(195114,5420,'fr','Total d\'enregistrements',0),(195115,5420,'jp','ç·?è¨˜éŒ²',0),(195116,5420,'pt','Total de Registros',0),(195117,5420,'ru','Ð’ÑÐµÐ³Ð¾ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(195118,5420,'es','Records Totales',0),(195119,5420,'de','Gesamtzahl der DatensÃ¤tze',0),(195120,5420,'en','Total Records',0),(195121,5421,'is','',0),(195122,5421,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(195123,5421,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(195124,5421,'tr','Ä°zleme numarasÄ±',0),(195125,5421,'pl','Numer Å›ledzenia',0),(195126,5421,'bg','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´Ð¸ Ð½Ð¾Ð¼ÐµÑ€',0),(195127,5421,'ur','Ù†Ù…Ø¨Ø± Ú©Ø§ Ø³Ø±Ø§Øº',0),(195128,5421,'sr','ÐŸÑ€Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(195129,5421,'vi','Sá»‘ dÃ² tÃ¬m',0),(195130,5421,'af','Spoor Nommer',0),(195131,5421,'ro','Numar de inregistrare',0),(195132,5421,'et','JÃ¤lgimisnumber',0),(195133,5421,'si','Trace Å¡tevilko',0),(195134,5421,'ba','Trace Nomor',0),(195135,5421,'nl','Traceernummer',0),(195136,5421,'fi','JÃ¤ljitysnumero',0),(195137,5421,'no','Sporingsnummeret',0),(195138,5421,'da','Trace nummer',0),(195139,5421,'ko','ì¶”ì  ë²ˆí˜¸',0),(195140,5421,'he','×ž×¡×¤×¨ ×ž×¢×§×‘',0),(195141,5421,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î¯Ï‡Î½Î¿Ï‚',0),(195142,5421,'zh','è¿½è¸ªå·\r\n',0),(195143,5421,'sv','SpÃ¥rningsnummer',0),(195144,5421,'it','Numero traccia',0),(195145,5421,'tl','',0),(195146,5421,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(195147,5421,'hi','à¤¨à¤‚à¤¬à¤° à¤Ÿà¥à¤°à¥‡à¤¸',0),(195148,5421,'ms','Nombor jejak',0),(195149,5421,'ar','Ø±Ù‚Ù… Ø§Ù„ØªØªØ¨Ø¹',0),(195150,5421,'fr','Nombre de traces',0),(195151,5421,'jp','ãƒˆãƒ¬ãƒ¼ã‚¹ç•ªå?·',0),(195152,5421,'pt','NÃºmero de Procura',0),(195153,5421,'ru','ÐÐ¾Ð¼ÐµÑ€ Ñ‚Ñ€Ð°ÑÑÐ¸Ñ€Ð¾Ð²ÐºÐ¸',0),(195154,5421,'es','NÃºmero de Rastreo',0),(195155,5421,'de','Ablaufverfolgung Nummer',0),(195156,5421,'en','Trace Number',0),(195157,5422,'is','',0),(195158,5422,'dr','Ù†ÙˆØ¹ Ù…Ø¹Ø§Ù…Ù„Ù‡ ',0),(195159,5422,'pr','Ù†ÙˆØ¹ Ù…Ø¹Ø§Ù…Ù„Ù‡ ',0),(195160,5422,'tr','Hareket tÃ¼rÃ¼',0),(195161,5422,'pl','Typ transakcji',0),(195162,5422,'bg','Ð’Ð¸Ð´ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(195163,5422,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ù‚Ø³Ù…',0),(195164,5422,'sr','Ð’Ñ€ÑÑ‚Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(195165,5422,'vi','Loáº¡i Giao dá»‹ch',0),(195166,5422,'af','Transaksie Tipe',0),(195167,5422,'ro','Tip de tranzactie',0),(195168,5422,'et','Tehingu liik',0),(195169,5422,'si','Vrsta transakcije',0),(195170,5422,'ba','Jenis transaksi',0),(195171,5422,'nl','Transactiesoort',0),(195172,5422,'fi','Tapahtumatyyppi',0),(195173,5422,'no','Transaksjonstypen',0),(195174,5422,'da','Posteringstypen',0),(195175,5422,'ko','íŠ¸ëžœìž­ì…˜ ìœ í˜•',0),(195176,5422,'he','×¡×•×’ ×¢×¡×§×”',0),(195177,5422,'el','Î•Î¯Î´Î¿Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(195178,5422,'zh','äº¤æ˜“ç±»åž‹\r\n',0),(195179,5422,'sv','Transaktionstyp',0),(195180,5422,'it','Tipo di transazione',0),(195181,5422,'tl','',0),(195182,5422,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(195183,5422,'hi','à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤•à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(195184,5422,'ms','Jenis urus niaga',0),(195185,5422,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(195186,5422,'fr','Type de transaction',0),(195187,5422,'jp','å?–å¼•ã‚¿ã‚¤ãƒ—',0),(195188,5422,'pt','Tipo de TransaÃ§Ã£o',0),(195189,5422,'ru','Ð¢Ð¸Ð¿ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(195190,5422,'es','tipo de TransacciÃ³n',0),(195191,5422,'de','Transaktionstyp',0),(195192,5422,'en','Transaction Type',0),(195193,5423,'is','',0),(195194,5423,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø­ØªÙˆØ§ÙŠ ÙØ§ÙŠÙ„ ',0),(195195,5423,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø­ØªÙˆØ§ÙŠ ÙØ§ÙŠÙ„ ',0),(195196,5423,'tr','Dosya iÃ§eriÄŸini gÃ¶rÃ¼ntÃ¼le',0),(195197,5423,'pl','ZawartoÅ›Ä‡ pliku widoku',0),(195198,5423,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° ÑÑŠÐ´ÑŠÑ€Ð¶Ð°Ð½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(195199,5423,'ur','Ù…Ø³Ù„ Ù…Ø´Ù…ÙˆÙ„Ø§Øª Ù…Ù†Ø¸Ø± Ú©Ø±ÛŒÚº',0),(195200,5423,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð´Ñ€Ð¶Ð°Ñ˜ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(195201,5423,'vi','Xem ná»™i dung há»“ sÆ¡',0),(195202,5423,'af','Besigtig LÃªerinhoud',0),(195203,5423,'ro','Vezi continutul fisierului',0),(195204,5423,'et','Vaata dokumendi sisu',0),(195205,5423,'si','Vsebina datoteke pogled',0),(195206,5423,'ba','Lihat isi File',0),(195207,5423,'nl','De inhoud van het bestand van de weergave',0),(195208,5423,'fi','NÃ¤ytÃ¤ tiedoston sisÃ¤ltÃ¶',0),(195209,5423,'no','Vis filinnhold',0),(195210,5423,'da','Se filens indhold',0),(195211,5423,'ko','íŒŒì¼ ë‚´ìš© ë³´ê¸°',0),(195212,5423,'he','×”×¦×’ ××ª ×ª×•×›×Ÿ ×”×§×•×‘×¥',0),(195213,5423,'el','Î˜Î­Î± Î±ÏÏ‡ÎµÎ¯Î¿ Ï€ÎµÏÎ¹ÎµÏ‡ÏŒÎ¼ÎµÎ½Î±',0),(195214,5423,'zh','æŸ¥çœ‹æ–‡ä»¶å†…å®¹\r\n',0),(195215,5423,'sv','Visa filinnehÃ¥ll',0),(195216,5423,'it','Contenuto del File di vista',0),(195217,5423,'tl','',0),(195218,5423,'th','&#3649;&#3626;&#3604;&#3591;&#3626;&#3634;&#3619;&#3610;&#3633;&#3597;&#3652;&#3615;&#3621;&#3660;',0),(195219,5423,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥€ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€',0),(195220,5423,'ms','Lihat kandungan fail',0),(195221,5423,'ar','Ø¹Ø±Ø¶ Ù…Ø­ØªÙˆÙŠØ§Øª Ø§Ù„Ù…Ù„ÙÙ‘',0),(195222,5423,'fr','Contenu du fichier vue',0),(195223,5423,'jp','ãƒ•ã‚¡ã‚¤ãƒ«å†…å®¹ã?®è¡¨ç¤º',0),(195224,5423,'pt','Ver ConteÃºdo de Arquivo',0),(195225,5423,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¡Ð¾ÑÑ‚Ð°Ð²Ð»ÑÑŽÑ‰Ð¸Ðµ Ð¤Ð°Ð¹Ð»Ð°',0),(195226,5423,'es','Visionar Contenidos de Files',0),(195227,5423,'de','Datei-Inhalt anzeigen',0),(195228,5423,'en','View File Contents',0),(195229,5424,'is','',0),(195230,5424,'dr','Ù„ØºÙˆØ´Ø¯',0),(195231,5424,'pr','Ù„ØºÙˆØ´Ø¯',0),(195232,5424,'tr','Ä°ptal edildi',0),(195233,5424,'pl','Anulowane',0),(195234,5424,'bg','ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(195235,5424,'ur','Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(195236,5424,'sr','ÐžÑ‚ÐºÐ°Ð·Ð°Ð½Ð°',0),(195237,5424,'vi','ÄÃ£ xÃ³a',0),(195238,5424,'af','Gekanseleer',0),(195239,5424,'ro','Anulat',0),(195240,5424,'et','TÃ¼histatud',0),(195241,5424,'si','Odpovedan',0),(195242,5424,'ba','Dibatalkan',0),(195243,5424,'nl','Geannuleerd',0),(195244,5424,'fi','Peruutettu',0),(195245,5424,'no','Avbrutt',0),(195246,5424,'da','Annulleret',0),(195247,5424,'ko','ì·¨ì†Œ',0),(195248,5424,'he','×‘×•×˜×œ',0),(195249,5424,'el','Î‘ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ',0),(195250,5424,'zh','å–æ¶ˆ\r\n',0),(195251,5424,'sv','Avbryts',0),(195252,5424,'it','Annullato',0),(195253,5424,'tl','',0),(195254,5424,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3649;&#3621;&#3657;&#3623;',0),(195255,5424,'hi','à¤°à¤¦à¥à¤¦ à¤•à¥€ à¤—à¤ˆ',0),(195256,5424,'ms','Dibatalkan',0),(195257,5424,'ar','ØªÙ… Ø¥Ù„ØºØ§Ø¡',0),(195258,5424,'fr','AnnulÃ©',0),(195259,5424,'jp','å?–ã‚Šæ¶ˆã?—ã?¾ã?—ã?Ÿ',0),(195260,5424,'pt','Cancelado',0),(195261,5424,'ru','ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ð¾',0),(195262,5424,'es','Cancelado',0),(195263,5424,'de','Abgebrochen',0),(195264,5424,'en','Canceled',0),(195265,5425,'is','',0),(195266,5425,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(195267,5425,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(195268,5425,'tr','Hareketleri gÃ¶rÃ¼ntÃ¼leme',0),(195269,5425,'pl','WyÅ›wietlanie transakcji',0),(195270,5425,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(195271,5425,'ur','ÚˆØ³Ù¾Ù„Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ†',0),(195272,5425,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð°',0),(195273,5425,'vi','Hiá»ƒn thá»‹ giao dá»‹ch',0),(195274,5425,'af','Wys Transaksies',0),(195275,5425,'ro','Arata tranzactiile',0),(195276,5425,'et','Kuva kanded',0),(195277,5425,'si','Izpis transakcij',0),(195278,5425,'ba','Menampilkan transaksi',0),(195279,5425,'nl','De transacties worden weergegeven',0),(195280,5425,'fi','NÃ¤ytÃ¤ tapahtumat',0),(195281,5425,'no','Vise transaksjoner',0),(195282,5425,'da','Vise transaktioner',0),(195283,5425,'ko','íŠ¸ëžœìž­ì…˜ í‘œì‹œ',0),(195284,5425,'he','×”×¦×’ ×¢×¡×§××•×ª',0),(195285,5425,'el','Î•Î¼Ï†Î±Î½Î¯ÏƒÎµÏ„Îµ Ï„Î¹Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚',0),(195286,5425,'zh','æ˜¾ç¤ºäº¤æ˜“\r\n',0),(195287,5425,'sv','Visa transaktioner',0),(195288,5425,'it','Visualizzare le transazioni',0),(195289,5425,'tl','',0),(195290,5425,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(195291,5425,'hi','à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤•à¥‹ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤',0),(195292,5425,'ms','Paparan urusniaga',0),(195293,5425,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(195294,5425,'fr','Afficher les Transactions',0),(195295,5425,'jp','å?–å¼•ã?®è¡¨ç¤º',0),(195296,5425,'pt','Exibir transaÃ§Ãµes',0),(195297,5425,'ru','ÐžÑ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ ÑÐ´ÐµÐ»Ð¾Ðº',0),(195298,5425,'es','Desplegar Transacciones',0),(195299,5425,'de','Transaktionen anzeigen',0),(195300,5425,'en','Display Transactions',0),(195301,5426,'is','',0),(195302,5426,'dr','Ù†Ù…Ø§ÙŠØ´ Ù„ØºÙˆ Ø´Ø¯ ',0),(195303,5426,'pr','Ù†Ù…Ø§ÙŠØ´ Ù„ØºÙˆ Ø´Ø¯ ',0),(195304,5426,'tr','GÃ¶steri iptal edildi',0),(195305,5426,'pl','PokaÅ¼ anulowane',0),(195306,5426,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð¸',0),(195307,5426,'ur','Ø´Ùˆ Ù…Ù†Ø³ÙˆØ®',0),(195308,5426,'sr','Ð•Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð°',0),(195309,5426,'vi','Hiá»ƒn thá»‹ há»§y',0),(195310,5426,'af','Wys Gekanselleerdes',0),(195311,5426,'ro','Spectacolul anulat',0),(195312,5426,'et','NÃ¤ita tÃ¼histatud',0),(195313,5426,'si','PrikaÅ¾i odpovedan',0),(195314,5426,'ba','Tampilkan dibatalkan',0),(195315,5426,'nl','Toon geannuleerd',0),(195316,5426,'fi','NÃ¤ytÃ¤ peruutettu',0),(195317,5426,'no','Vis avbrutt',0),(195318,5426,'da','Vis annulleret',0),(195319,5426,'ko','ê³µì—° ì·¨ì†Œ',0),(195320,5426,'he','×”×¦×’ ×‘×•×˜×œ×”',0),(195321,5426,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Îµ Î±ÎºÏ…ÏÏŽÏƒÎµÎ¹Ï‚',0),(195322,5426,'zh','æ˜¾ç¤ºå·²å–æ¶ˆ\r\n',0),(195323,5426,'sv','Visa avbryts',0),(195324,5426,'it','Spettacolo annullato',0),(195325,5426,'tl','',0),(195326,5426,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(195327,5426,'hi','à¤¶à¥‹ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(195328,5426,'ms','Papar dibatalkan',0),(195329,5426,'ar','ØªÙ… Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø¹Ø±Ø¶',0),(195330,5426,'fr','Spectacle annulÃ©',0),(195331,5426,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«æ¸ˆã?®è¡¨ç¤º',0),(195332,5426,'pt','Show cancelado',0),(195333,5426,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ð½Ð¾Ðµ',0),(195334,5426,'es','Mostrar Cancelados',0),(195335,5426,'de','Karte abgebrochen',0),(195336,5426,'en','Show Canceled',0),(195337,5427,'is','',0),(195338,5427,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(195339,5427,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(195340,5427,'tr','Hesap bilgileri baÅŸarÄ±yla kaydedildi',0),(195341,5427,'pl','Informacje o koncie Zapisano pomyÅ›lnie',0),(195342,5427,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð°, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(195343,5427,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸',0),(195344,5427,'sr','ÐÐ°Ð»Ð¾Ð³ Ð˜Ð½Ñ„Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(195345,5427,'vi','ThÃ´ng Tin TK Sao LÆ°u ThÃ nh CÃ´ng',0),(195346,5427,'af','Rekeninginfo Suksesvol Gestoor',0),(195347,5427,'ro','Info cont salvat cu suuces',0),(195348,5427,'et','Konto informatsioon salvestati edukalt',0),(195349,5427,'si','RaÄun Info shranjen',0),(195350,5427,'ba','Informasi Akun Berhasil Disimpan',0),(195351,5427,'nl','Accountinfo succesvol opgeslagen',0),(195352,5427,'fi','Tilin tiedot tallennettu',0),(195353,5427,'no','Kontoinformasjon lagret',0),(195354,5427,'da','Kontoinfo gemt med succes',0),(195355,5427,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ ëœ ê³„ì • ì •ë³´',0),(195356,5427,'he','×¤×¨×˜×™ ×”×—×©×‘×•×Ÿ ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(195357,5427,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€Î¿Ï… Î±Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(195358,5427,'zh','å¸æˆ·ä¿¡æ¯å·²æˆåŠŸä¿å­˜\r\n',0),(195359,5427,'sv','Kontoinformation som sparats',0),(195360,5427,'it','Informazioni del profilo salvate correttamente.',0),(195361,5427,'tl','',0),(195362,5427,'th','&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(195363,5427,'hi','à¤–à¤¾à¤¤à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(195364,5427,'ms','Maklumat akaun yang berjaya disimpan',0),(195365,5427,'ar','Ø­ÙØ¸Øª Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(195366,5427,'fr','Info du compte sauvegardÃ©e avec succÃ¨s',0),(195367,5427,'jp','å?£åº§æƒ…å ±ã?Œä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(195368,5427,'pt','InformaÃ§Ã£o de conta com sucesso',0),(195369,5427,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(195370,5427,'es','Info de Cuenta Guardada Exitosamente',0),(195371,5427,'de','Kontoinfo erfolgreich gespeichert',0),(195372,5427,'en','Account Info Saved Successfully',0),(195373,5428,'is','',0),(195374,5428,'dr','ØªØ§Ø±ÙŠØ® ÙØ§ÙŠÙ„ Ù¾ÙŠÙˆØ³Øª ',0),(195375,5428,'pr','ØªØ§Ø±ÙŠØ® ÙØ§ÙŠÙ„ Ù¾ÙŠÙˆØ³Øª ',0),(195376,5428,'tr','ACH dosya tarihi',0),(195377,5428,'pl','ACH pliku Data',0),(195378,5428,'bg','ACH Ñ„Ð°Ð¹Ð»Ð° Ð´Ð°Ñ‚Ð°',0),(195379,5428,'ur','Ø§Ú† Ù…Ø³Ù„ ØªØ§Ø±ÛŒØ®',0),(195380,5428,'sr','ÐÑ… Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(195381,5428,'vi','NgÃ y ACH File',0),(195382,5428,'af','ACH LÃªerdatum',0),(195383,5428,'ro','ACH Data fisier',0),(195384,5428,'et','ACH faili kuupÃ¤ev',0),(195385,5428,'si','Datum datoteke ACH',0),(195386,5428,'ba','Tanggal File ACH',0),(195387,5428,'nl','ACH bestandsdatum',0),(195388,5428,'fi','ACH tiedoston pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(195389,5428,'no','ACH filen dato',0),(195390,5428,'da','ACH fildato',0),(195391,5428,'ko','ACH íŒŒì¼ ë‚ ì§œ',0),(195392,5428,'he','×ª××¨×™×š ×”×§×•×‘×¥ ACH',0),(195393,5428,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï… ACH',0),(195394,5428,'zh','è‡ªåŠ¨åŒ–äº¤æ˜“çš„æ–‡ä»¶æ—¥æœŸ',0),(195395,5428,'sv','ACH fildatum',0),(195396,5428,'it','Data File ACH',0),(195397,5428,'tl','',0),(195398,5428,'th','&#3652;&#3615;&#3621;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3619;&#3632;&#3610;&#3610; ACH ',0),(195399,5428,'hi','ACH à¤«à¤¼à¤¾à¤‡à¤² à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(195400,5428,'ms','Tarikh fail men',0),(195401,5428,'ar','ØªØ§Ø±ÙŠØ® Ù…Ù„Ù Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(195402,5428,'fr','Date de DÃ©pÃ´t de ODC',0),(195403,5428,'jp','ACHãƒ•ã‚¡ã‚¤ãƒ«æ—¥',0),(195404,5428,'pt','ACH arquivo data',0),(195405,5428,'ru','Ð”Ð°Ñ‚Ð° Ñ„Ð°Ð¹Ð»Ð° ACH',0),(195406,5428,'es','Fecha Archivo ACH',0),(195407,5428,'de','ACH Dateidatum',0),(195408,5428,'en','ACH File Date',0),(195409,5429,'is','',0),(195410,5429,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙŠÙ„ Ù¾ÙŠÙˆØ³Øª',0),(195411,5429,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙŠÙ„ Ù¾ÙŠÙˆØ³Øª',0),(195412,5429,'tr','ACH dosya numarasÄ±',0),(195413,5429,'pl','ACH numer pliku',0),(195414,5429,'bg','ACH Ð²Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€',0),(195415,5429,'ur','Ø§Ú† ÙØ§Ø¦Ù„ Ù†Ù…Ø¨Ø±',0),(195416,5429,'sr','ÐÑ… Ð±Ñ€Ð¾Ñ˜ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(195417,5429,'vi','Sá»‘ File ACH',0),(195418,5429,'af','ACH LÃªernommer',0),(195419,5429,'ro','ACH Numar fisier',0),(195420,5429,'et','ACH faili Number',0),(195421,5429,'si','ACH evidenÄno Å¡tevilko',0),(195422,5429,'ba','Nomor File ACH',0),(195423,5429,'nl','ACH dossiernummer',0),(195424,5429,'fi','ACH tiedostonumero',0),(195425,5429,'no','ACH filnummer',0),(195426,5429,'da','ACH-filnummer',0),(195427,5429,'ko','ACH íŒŒì¼ ë²ˆí˜¸',0),(195428,5429,'he','×ž×¡×¤×¨ ×”×§×•×‘×¥ ACH',0),(195429,5429,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Ï€ÏÏ‰Ï„Î¿ÎºÏŒÎ»Î»Î¿Ï… ACH',0),(195430,5429,'zh','è‡ªåŠ¨åŒ–äº¤æ˜“çš„æ–‡ä»¶å·\r\n',0),(195431,5429,'sv','ACH filnummer',0),(195432,5429,'it','Numero di File ACH',0),(195433,5429,'tl','',0),(195434,5429,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3652;&#3615;&#3621;&#3660;&#3619;&#3632;&#3610;&#3610; ACH',0),(195435,5429,'hi','ACH à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(195436,5429,'ms','Nombor fail men',0),(195437,5429,'ar','Ø±Ù‚Ù… Ø§Ù„Ù…Ù„Ù Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(195438,5429,'fr','NumÃ©ro du Dossier ODC',0),(195439,5429,'jp','ACHãƒ•ã‚¡ã‚¤ãƒ«ç•ªå?·',0),(195440,5429,'pt','NÃºmero de arquivo ACH',0),(195441,5429,'ru','ÐÐ¾Ð¼ÐµÑ€ Ñ„Ð°Ð¹Ð»Ð° ACH',0),(195442,5429,'es','NÃºmero Archivo ACH',0),(195443,5429,'de','ACH Dateinummer',0),(195444,5429,'en','ACH File Number',0),(195445,5430,'is','',0),(195446,5430,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ',0),(195447,5430,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ',0),(195448,5430,'tr','Banka hesabÄ±',0),(195449,5430,'pl','Konto bankowe',0),(195450,5430,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°',0),(195451,5430,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(195452,5430,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(195453,5430,'vi','TK NgÃ¢n HÃ ng',0),(195454,5430,'af','Bankrekening',0),(195455,5430,'ro','Cont bancar',0),(195456,5430,'et','Pangakonto',0),(195457,5430,'si','BanÄni raÄun',0),(195458,5430,'ba','Rekening bank',0),(195459,5430,'nl','Bankrekening',0),(195460,5430,'fi','Pankkitili',0),(195461,5430,'no','Bankkonto',0),(195462,5430,'da','Bankkonto',0),(195463,5430,'ko','ì€í–‰ ê³„ì¢Œ',0),(195464,5430,'he','×—×©×‘×•×Ÿ ×‘× ×§',0),(195465,5430,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(195466,5430,'zh','é“¶è¡Œå¸æˆ·\r\n',0),(195467,5430,'sv','Bankkonto',0),(195468,5430,'it','Conto corrente bancario',0),(195469,5430,'tl','',0),(195470,5430,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(195471,5430,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾',0),(195472,5430,'ms','Akaun bank',0),(195473,5430,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØµØ±Ù',0),(195474,5430,'fr','Compte bancaire',0),(195475,5430,'jp','éŠ€è¡Œå?£åº§',0),(195476,5430,'pt','Conta bancÃ¡ria',0),(195477,5430,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ ÑÑ‡ÐµÑ‚',0),(195478,5430,'es','Cuenta Bancario',0),(195479,5430,'de','Bankkonto',0),(195480,5430,'en','Bank Account',0),(195481,5431,'is','',0),(195482,5431,'dr','/ Ø¢Ù¾Ø¯ÛŒØª  Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ ',0),(195483,5431,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ ',0),(195484,5431,'tr','Banka hesabÄ± ekleyin/gÃ¼ncelleyin',0),(195485,5431,'pl','DodaÄ‡ konto bankowe/aktualizacja',0),(195486,5431,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(195487,5431,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(195488,5431,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ñƒ Ð±Ð°Ð½Ñ†Ð¸/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(195489,5431,'vi','ThÃªm/Cáº­p Nháº­t TK NgÃ¢n HÃ ng',0),(195490,5431,'af','Bankrekening Byvoeg/Opdateer',0),(195491,5431,'ro','Cont bancar Adauga/Modifica',0),(195492,5431,'et','Pangakonto lisamine/uuendamine',0),(195493,5431,'si','BanÄni raÄun Dodaj/posodobi',0),(195494,5431,'ba','Rekening bank Tambahkan/Perbarui',0),(195495,5431,'nl','Bank Account toevoegen/bijwerken',0),(195496,5431,'fi','Pankkitilin lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(195497,5431,'no','Bankkonto/Oppdater',0),(195498,5431,'da','Bankkonto TilfÃ¸j/opdater',0),(195499,5431,'ko','ì€í–‰ ê³„ì¢Œ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(195500,5431,'he','×”×•×¡×£/×¢×“×›×Ÿ ×—×©×‘×•×Ÿ ×‘× ×§',0),(195501,5431,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(195502,5431,'zh','é“¶è¡Œå¸æˆ·æ–°å¢ž/æ›´æ–°\r\n',0),(195503,5431,'sv','Bankkonto LÃ¤gg till/uppdatera',0),(195504,5431,'it','Aggiungere/aggiornare un conto bancario',0),(195505,5431,'tl','',0),(195506,5431,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(195507,5431,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(195508,5431,'ms','Akaun bank Tambah/Kemaskini',0),(195509,5431,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø­Ø³Ø§Ø¨ Ù…ØµØ±Ù',0),(195510,5431,'fr','Compte bancaire ajouter/mettre Ã  jour',0),(195511,5431,'jp','éŠ€è¡Œå?£åº§ã?®è¿½åŠ /æ›´æ–°',0),(195512,5431,'pt','Adicionar/atualizar a conta bancÃ¡ria',0),(195513,5431,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ ÑÑ‡ÐµÑ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(195514,5431,'es','Cuenta Bancario Agregar/Actualizar',0),(195515,5431,'de','Bankkonto hinzufÃ¼gen/aktualisieren',0),(195516,5431,'en','Bank Account Add/Update',0),(195517,5432,'is','',0),(195518,5432,'dr','.',0),(195519,5432,'pr','Ø­Ø°Ù Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯.',0),(195520,5432,'tr','Banka hesabÄ± baÅŸarÄ±yla silindi',0),(195521,5432,'pl','Konto usuniÄ™te pomyÅ›lnie',0),(195522,5432,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(195523,5432,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(195524,5432,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(195525,5432,'vi','XÃ³a TK NgÃ¢n HÃ ng ThÃ nh CÃ´ng',0),(195526,5432,'af','Bankrekening Suksesvol Geskrap',0),(195527,5432,'ro','Cont bancar eliminÄƒ cu succes',0),(195528,5432,'et','Pangakonto kustutati edukalt',0),(195529,5432,'si','BanÄni raÄun uspeÅ¡no izbrisana',0),(195530,5432,'ba','Rekening bank yang berhasil dihapus',0),(195531,5432,'nl','Bank Account met succes verwijderd',0),(195532,5432,'fi','Pankkitilin poistettu',0),(195533,5432,'no','Konto slettet',0),(195534,5432,'da','Bank konto slettet',0),(195535,5432,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì€í–‰ ê³„ì¢Œ',0),(195536,5432,'he','×—×©×‘×•×Ÿ ×‘× ×§ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(195537,5432,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(195538,5432,'zh','é“¶è¡Œå¸æˆ·åˆ é™¤æˆåŠŸ\r\n',0),(195539,5432,'sv','Bank konto raderades',0),(195540,5432,'it','Bank Account eliminato con successo',0),(195541,5432,'tl','',0),(195542,5432,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(195543,5432,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(195544,5432,'ms','Akaun bank yang dihapuskan dengan jayanya',0),(195545,5432,'ar','Ø­Ø°Ù Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØµØ±Ù Ø¨Ù†Ø¬Ø§Ø­',0),(195546,5432,'fr','Compte bancaire supprimÃ© avec succÃ¨s',0),(195547,5432,'jp','éŠ€è¡Œå?£åº§ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(195548,5432,'pt','Conta bancÃ¡ria apagada com sucesso',0),(195549,5432,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð¡Ñ‡ÐµÑ‚ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½',0),(195550,5432,'es','Cuenta Bancario Eliminada Exitosamente',0),(195551,5432,'de','Bank-Konto wurde erfolgreich gelÃ¶scht',0),(195552,5432,'en','Bank Account Deleted Successfully',0),(195553,5433,'is','',0),(195554,5433,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ',0),(195555,5433,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ',0),(195556,5433,'tr','Banka hesap numarasÄ±',0),(195557,5433,'pl','Numer konta bankowego',0),(195558,5433,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(195559,5433,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø±',0),(195560,5433,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(195561,5433,'vi','Sá»‘ TK NgÃ¢n HÃ ng',0),(195562,5433,'af','Bankrekeningnommer',0),(195563,5433,'ro','NumÄƒrul de cont bancar',0),(195564,5433,'et','Pangakonto Number',0),(195565,5433,'si','Å tevilka banÄnega raÄuna',0),(195566,5433,'ba','Nomor rekening bank',0),(195567,5433,'nl','Bankrekeningnummer',0),(195568,5433,'fi','Pankkitilinumero',0),(195569,5433,'no','Bankkontonummeret',0),(195570,5433,'da','Bankkontonummeret',0),(195571,5433,'ko','ì€í–‰ ê³„ì¢Œ ë²ˆí˜¸',0),(195572,5433,'he','×ž×¡×¤×¨ ×—×©×‘×•×Ÿ ×‘× ×§',0),(195573,5433,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(195574,5433,'zh','é“¶è¡Œå¸å·\r\n',0),(195575,5433,'sv','Bankkontonummer',0),(195576,5433,'it','Numero di conto bancario',0),(195577,5433,'tl','',0),(195578,5433,'th','&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3610;&#3633;&#3597;&#3594;&#3637;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(195579,5433,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(195580,5433,'ms','Nombor akaun bank',0),(195581,5433,'ar','Ø±Ù‚Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØµØ±Ù',0),(195582,5433,'fr','NumÃ©ro de compte bancaire',0),(195583,5433,'jp','éŠ€è¡Œå?£åº§ç•ªå?·',0),(195584,5433,'pt','NÃºmero de conta bancÃ¡ria',0),(195585,5433,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ Ð¡Ñ‡ÐµÑ‚Ð°',0),(195586,5433,'es','Numero de Cuenta Bancario',0),(195587,5433,'de','Bank Account Number',0),(195588,5433,'en','Bank Account Number',0),(195589,5434,'is','',0),(195590,5434,'dr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ',0),(195591,5434,'pr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ',0),(195592,5434,'tr','Banka hesap tÃ¼rÃ¼',0),(195593,5434,'pl','Typ konta bankowego',0),(195594,5434,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ñ‚Ð¸Ð¿',0),(195595,5434,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(195596,5434,'sr','Ð’Ñ€ÑÑ‚Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(195597,5434,'vi','Loáº¡i TK NgÃ¢n HÃ ng',0),(195598,5434,'af','Bankrekening Tipe',0),(195599,5434,'ro','Tip cont bancar',0),(195600,5434,'et','Pangakonto tÃ¼Ã¼p',0),(195601,5434,'si','Vrsta banÄnega raÄuna',0),(195602,5434,'ba','Jenis rekening bank',0),(195603,5434,'nl','Bankrekening Type',0),(195604,5434,'fi','Pankkitilin tyyppi',0),(195605,5434,'no','Bankkontotypen',0),(195606,5434,'da','Bankkonto Type',0),(195607,5434,'ko','ì€í–‰ ê³„ì • ìœ í˜•',0),(195608,5434,'he','×¡×•×’ ×—×©×‘×•×Ÿ ×‘× ×§',0),(195609,5434,'el','Î¤ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î¤ÏÎ¬Ï€ÎµÎ¶Î±Ï‚',0),(195610,5434,'zh','é“¶è¡Œå¸æˆ·ç±»åž‹\r\n',0),(195611,5434,'sv','Bankkonto typ',0),(195612,5434,'it','Tipo di conto bancario',0),(195613,5434,'tl','',0),(195614,5434,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3633;&#3597;&#3594;&#3637;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(195615,5434,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(195616,5434,'ms','Jenis akaun bank',0),(195617,5434,'ar','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØµØ±Ù',0),(195618,5434,'fr','Type de compte bancaire',0),(195619,5434,'jp','éŠ€è¡Œå?£åº§ã?®ç¨®é¡ž',0),(195620,5434,'pt','Tipo de conta bancÃ¡ria',0),(195621,5434,'ru','Ð¢Ð¸Ð¿ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(195622,5434,'es','Tipo de Cuenta Bancario',0),(195623,5434,'de','Bank Account-Typ',0),(195624,5434,'en','Bank Account Type',0),(195625,5435,'is','',0),(195626,5435,'dr','Ø¢Ø¯Ø±Ø³ Ø¨Ø§Ù†Ùƒ',0),(195627,5435,'pr','Ø¢Ø¯Ø±Ø³ Ø¨Ø§Ù†Ùƒ',0),(195628,5435,'tr','Banka adresi',0),(195629,5435,'pl','Adres banku',0),(195630,5435,'bg','ÐÐ´Ñ€ÐµÑ Ð½Ð° Ð±Ð°Ð½ÐºÐ°Ñ‚Ð°',0),(195631,5435,'ur','Ø¨ÛŒÙ†Ú© Ù¾ØªÛ',0),(195632,5435,'sr','ÐÐ´Ñ€ÐµÑÐ° Ð±Ð°Ð½ÐºÐµ',0),(195633,5435,'vi','Äá»‹a chá»‰ NgÃ¢n hÃ ng',0),(195634,5435,'af','Bank Adres',0),(195635,5435,'ro','Adresa bancii',0),(195636,5435,'et','Panga aadress',0),(195637,5435,'si','Naslov banke',0),(195638,5435,'ba','Alamat Bank',0),(195639,5435,'nl','Adres van de Bank',0),(195640,5435,'fi','Pankin osoite',0),(195641,5435,'no','Bankadressen',0),(195642,5435,'da','Bank adresse',0),(195643,5435,'ko','ì€í–‰ ì£¼ì†Œ',0),(195644,5435,'he','×›×ª×•×‘×ª ×‘× ×§',0),(195645,5435,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(195646,5435,'zh','é“¶è¡Œåœ°å€\r\n',0),(195647,5435,'sv','Bankens adress',0),(195648,5435,'it','Indirizzo della banca',0),(195649,5435,'tl','',0),(195650,5435,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3586;&#3629;&#3591;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(195651,5435,'hi','à¤¬à¥ˆà¤‚à¤• à¤•à¤¾ à¤ªà¤¤à¤¾',0),(195652,5435,'ms','Alamat Bank',0),(195653,5435,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ù…ØµØ±Ù',0),(195654,5435,'fr','Adresse de la Banque',0),(195655,5435,'jp','éŠ€è¡Œã?®ä½?æ‰€',0),(195656,5435,'pt','EndereÃ§o do banco',0),(195657,5435,'ru','ÐÐ´Ñ€ÐµÑ Ð±Ð°Ð½ÐºÐ°',0),(195658,5435,'es','DirecciÃ³n de Banco',0),(195659,5435,'de','Adresse der Bank',0),(195660,5435,'en','Bank Address',0),(195661,5436,'is','',0),(195662,5436,'dr','Ø´Ù‡Ø±  Ø¨Ø§Ù†Ùƒ  ',0),(195663,5436,'pr','Ø´Ù‡Ø±  Ø¨Ø§Ù†Ùƒ  ',0),(195664,5436,'tr','BankanÄ±n bulunduÄŸu ÅŸehir',0),(195665,5436,'pl','Bank City',0),(195666,5436,'bg','Ð‘Ð°Ð½ÐºÐ° Ð¡Ð¸Ñ‚Ð¸',0),(195667,5436,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ø´ÛØ±',0),(195668,5436,'sr','Ð“Ñ€Ð°Ð´ Ð±Ð°Ð½ÐºÐµ',0),(195669,5436,'vi','NgÃ¢n hÃ ng thÃ nh phá»‘',0),(195670,5436,'af','Bank Dorp/Stad',0),(195671,5436,'ro','Banca City',0),(195672,5436,'et','Panga asukoha linna',0),(195673,5436,'si','Banka City',0),(195674,5436,'ba','Kota Bank',0),(195675,5436,'nl','Vestigingsplaats bank',0),(195676,5436,'fi','Hoitaa pankkiasiansa kaupunki',0),(195677,5436,'no','Banksted',0),(195678,5436,'da','Bank City',0),(195679,5436,'ko','ì€í–‰ ì‹œí‹°',0),(195680,5436,'he','×¡×™×˜×™ ×‘× ×§',0),(195681,5436,'el','Î¤Î¡Î‘Î Î•Î–Î‘ Î ÎŸÎ›Î—',0),(195682,5436,'zh','é“¶åŸŽ\r\n',0),(195683,5436,'sv','Bank stad',0),(195684,5436,'it','CittÃ  di banca',0),(195685,5436,'tl','',0),(195686,5436,'th','&#3629;&#3635;&#3648;&#3616;&#3629;/&#3648;&#3586;&#3605; &#3607;&#3637;&#3656;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(195687,5436,'hi','à¤¬à¥ˆà¤‚à¤• à¤¸à¤¿à¤Ÿà¥€',0),(195688,5436,'ms','Bank City',0),(195689,5436,'ar','Ø³ÙŠØªÙŠ Ø¨Ù†Ùƒ',0),(195690,5436,'fr','Ville de banque',0),(195691,5436,'jp','éŠ€è¡Œã?®ç”º',0),(195692,5436,'pt','Banco cidade',0),(195693,5436,'ru','Ð¡Ð¸Ñ‚Ð¸ Ð‘Ð°Ð½Ðº',0),(195694,5436,'es','Ciudad de Banco',0),(195695,5436,'de','Bank-Stadt',0),(195696,5436,'en','Bank City',0),(195697,5437,'is','',0),(195698,5437,'dr','Ù†Ø§Ù… ØªÙ…Ø§Ø³ Ø¨Ø§Ù†Ùƒ  ',0),(195699,5437,'pr','Ù†Ø§Ù… ØªÙ…Ø§Ø³ Ø¨Ø§Ù†Ùƒ  ',0),(195700,5437,'tr','Banka irtibat ismi',0),(195701,5437,'pl','Kontakt Nazwa banku',0),(195702,5437,'bg','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð¸Ð¼Ðµ Ð½Ð° Ð±Ð°Ð½ÐºÐ°Ñ‚Ð°',0),(195703,5437,'ur','Ø¨ÛŒÙ†Ú© Ø±Ø§Ø¨Ø·Û’ Ú©Û’ Ù†Ø§Ù…',0),(195704,5437,'sr','Ð˜Ð¼Ðµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(195705,5437,'vi','TÃªn liÃªn há»‡ ngÃ¢n hÃ ng',0),(195706,5437,'af','Bank Kontak Naam',0),(195707,5437,'ro','Banca cu numele de Contact',0),(195708,5437,'et','Panga nimi',0),(195709,5437,'si','Banka ime stika',0),(195710,5437,'ba','Nama kontak Bank',0),(195711,5437,'nl','De naam van de contactpersoon van de Bank',0),(195712,5437,'fi','Pankin yhteyshenkilÃ¶',0),(195713,5437,'no','Banken kontaktnavn',0),(195714,5437,'da','Kontakt banknavn',0),(195715,5437,'ko','ì€í–‰ ì—°ë½ì²˜ ì´ë¦„',0),(195716,5437,'he','×©× ××™×© ×§×©×¨ ×‘× ×§',0),(195717,5437,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÏŒÎ½Î¿Î¼Î± ÎµÏ€Î±Ï†Î®Ï‚',0),(195718,5437,'zh','é“¶è¡Œè”ç³»äººå§“å\r\n',0),(195719,5437,'sv','Bankens namn',0),(195720,5437,'it','Nome di contatto banca',0),(195721,5437,'tl','',0),(195722,5437,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3607;&#3637;&#3656;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3652;&#3604;&#3657;&#3651;&#3609;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(195723,5437,'hi','à¤¬à¥ˆà¤‚à¤• à¤¸à¤‚à¤ªà¤°à¥à¤• à¤¨à¤¾à¤®',0),(195724,5437,'ms','Nama kenalan Bank',0),(195725,5437,'ar','Ø§Ø³Ù… Ø¬Ù‡Ø© Ø§Ù„Ø§ØªØµØ§Ù„ ÙÙŠ Ø§Ù„Ø¨Ù†Ùƒ',0),(195726,5437,'fr','Nom du Contact Banque',0),(195727,5437,'jp','éŠ€è¡Œã?®é€£çµ¡æ‹…å½“è€…å??',0),(195728,5437,'pt','Nome de contato do banco',0),(195729,5437,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð¾Ðµ Ð›Ð¸Ñ†Ð¾ Ð‘Ð°Ð½ÐºÐ°',0),(195730,5437,'es','Banco Nombre de Contacto',0),(195731,5437,'de','Name der Bank-Kontakt',0),(195732,5437,'en','Bank Contact Name',0),(195733,5438,'is','',0),(195734,5438,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ù„ØºÙˆ Ø´Ø¯',0),(195735,5438,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ù„ØºÙˆ Ø´Ø¯',0),(195736,5438,'tr','Ä°ptal banka hesaplarÄ±mÄ±z',0),(195737,5438,'pl','Bank informacji anulowane',0),(195738,5438,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½',0),(195739,5438,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ùˆ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(195740,5438,'sr','Ð‘Ð°Ð½ÐºÐ° Ð˜Ð½Ñ„Ð¾ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð°',0),(195741,5438,'vi','XÃ³a thÃ´ng tin ngÃ¢n hÃ ng',0),(195742,5438,'af','Bank Info Gekanselleer',0),(195743,5438,'ro','Info bancar anulat',0),(195744,5438,'et','Panga Info tÃ¼histatud',0),(195745,5438,'si','BanÄni Info odpovedan',0),(195746,5438,'ba','Info Bank yang dibatalkan',0),(195747,5438,'nl','Bank Info geannuleerd',0),(195748,5438,'fi','Bank Info peruutettu',0),(195749,5438,'no','Bank Info avbrutt',0),(195750,5438,'da','Bank Info annulleret',0),(195751,5438,'ko','ì·¨ì†Œ í•˜ëŠ” ì€í–‰ ì •ë³´',0),(195752,5438,'he','×¤×¨×˜×™ ×”×‘× ×§ ×‘×™×˜×œ',0),(195753,5438,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï„ÏÎ¬Ï€ÎµÎ¶Î±Ï‚ Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ',0),(195754,5438,'zh','é“¶è¡Œä¿¡æ¯å–æ¶ˆ\r\n',0),(195755,5438,'sv','Bank Info avbryts',0),(195756,5438,'it','Info banca annullato',0),(195757,5438,'tl','',0),(195758,5438,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(195759,5438,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤°à¤¦à¥à¤¦ à¤•à¤¿à¤¯à¤¾',0),(195760,5438,'ms','Info Bank yang dibatalkan',0),(195761,5438,'ar','Ø¨Ù†Ùƒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¥Ù„ØºØ§Ø¡',0),(195762,5438,'fr','Banque Info annulÃ©',0),(195763,5438,'jp','éŠ€è¡Œæƒ…å ±ã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?—ã?¾ã?—ã?Ÿ',0),(195764,5438,'pt','InformaÃ§Ã£o bancÃ¡ria cancelada',0),(195765,5438,'ru','Ð˜Ð½Ñ„Ð¾ Ð‘Ð°Ð½ÐºÐ° ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð°',0),(195766,5438,'es','InformaciÃ³n de Banco Cancelada',0),(195767,5438,'de','Bankverbindung abgebrochen',0),(195768,5438,'en','Bank Info Canceled',0),(195769,5439,'is','',0),(195770,5439,'dr','Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ ',0),(195771,5439,'pr','Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ ',0),(195772,5439,'tr','Banka adÄ±',0),(195773,5439,'pl','Nazwa banku',0),(195774,5439,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð±Ð°Ð½ÐºÐ°Ñ‚Ð°',0),(195775,5439,'ur','Ø¨ÛŒÙ†Ú© Ú©Ø§ Ù†Ø§Ù…',0),(195776,5439,'sr','Ð˜Ð¼Ðµ Ð±Ð°Ð½ÐºÐµ',0),(195777,5439,'vi','TÃªn ngÃ¢n hÃ ng ',0),(195778,5439,'af','Bank Naam',0),(195779,5439,'ro','Numele bÄƒncii',0),(195780,5439,'et','Panga nimi',0),(195781,5439,'si','Ime banke',0),(195782,5439,'ba','Nama Bank',0),(195783,5439,'nl','Naam van Bank',0),(195784,5439,'fi','Pankin nimi',0),(195785,5439,'no','Banknavnet',0),(195786,5439,'da','Banknavn',0),(195787,5439,'ko','ì€í–‰ ì´ë¦„',0),(195788,5439,'he','×©× ×‘× ×§',0),(195789,5439,'el','Î•Î Î©ÎÎ¥ÎœÎ™Î‘ Î¤Î¡Î‘Î Î•Î–Î‘Î£',0),(195790,5439,'zh','é“¶è¡Œåç§°\r\n',0),(195791,5439,'sv','Bankens namn',0),(195792,5439,'it','Nome della banca',0),(195793,5439,'tl','',0),(195794,5439,'th','&#3594;&#3639;&#3656;&#3629;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(195795,5439,'hi','à¤¬à¥ˆà¤‚à¤• à¤•à¤¾ à¤¨à¤¾à¤®',0),(195796,5439,'ms','Nama Bank',0),(195797,5439,'ar','Ø§Ø³Ù… Ø§Ù„Ø¨Ù†Ùƒ',0),(195798,5439,'fr','Nom de la Banque',0),(195799,5439,'jp','éŠ€è¡Œå??',0),(195800,5439,'pt','Nome do banco',0),(195801,5439,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð‘Ð°Ð½ÐºÐ°',0),(195802,5439,'es','Nombre de Banco',0),(195803,5439,'de','Name der Bank',0),(195804,5439,'en','Bank Name',0),(195805,5440,'is','',0),(195806,5440,'dr','ØªÙ„ÙÙ† Ø¨Ø§Ù†Ùƒ',0),(195807,5440,'pr','ØªÙ„ÙÙ† Ø¨Ø§Ù†Ùƒ',0),(195808,5440,'tr','Banka telefon',0),(195809,5440,'pl','Telefon z banku',0),(195810,5440,'bg','Ð‘Ð°Ð½ÐºÐ° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(195811,5440,'ur','Ø¨ÛŒÙ†Ú© ÙÙˆÙ†',0),(195812,5440,'sr','Ð‘Ð°Ð½ÐºÐ° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(195813,5440,'vi','Phone ngÃ¢n hÃ ng ',0),(195814,5440,'af','Bank Telefoon',0),(195815,5440,'ro','Banca telefon',0),(195816,5440,'et','Panga telefoni',0),(195817,5440,'si','Banka telefon',0),(195818,5440,'ba','Bank telepon',0),(195819,5440,'nl','Bank telefoon',0),(195820,5440,'fi','Pankin puhelimen',0),(195821,5440,'no','Banken telefon',0),(195822,5440,'da','Bank telefon',0),(195823,5440,'ko','ì€í–‰ ì „í™”',0),(195824,5440,'he','×˜×œ×¤×•×Ÿ ×”×‘× ×§',0),(195825,5440,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ Ï„ÏÎ¬Ï€ÎµÎ¶Î±',0),(195826,5440,'zh','é“¶è¡Œç”µè¯\r\n',0),(195827,5440,'sv','Bank telefon',0),(195828,5440,'it','Banca telefono',0),(195829,5440,'tl','',0),(195830,5440,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(195831,5440,'hi','à¤¬à¥ˆà¤‚à¤• à¤«à¥‹à¤¨',0),(195832,5440,'ms','Telefon Bank',0),(195833,5440,'ar','Ù‡Ø§ØªÙ Ø§Ù„Ø¨Ù†Ùƒ',0),(195834,5440,'fr','TÃ©lÃ©phone de la Banque',0),(195835,5440,'jp','éŠ€è¡Œã?®é›»è©±ç•ªå?·',0),(195836,5440,'pt','Telefone do banco',0),(195837,5440,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð° Ð‘Ð°Ð½ÐºÐ°',0),(195838,5440,'es','TelÃ©fono de Banco',0),(195839,5440,'de','Bank-Telefon',0),(195840,5440,'en','Bank Phone',0),(195841,5441,'is','',0),(195842,5441,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø³ÙŠØ± ÙŠØ§Ø¨ÙŠ Ø¨Ø§Ù†ÙƒÙŠ   ',0),(195843,5441,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø³ÙŠØ± ÙŠØ§Ø¨ÙŠ Ø¨Ø§Ù†ÙƒÙŠ   ',0),(195844,5441,'tr','Banka yÃ¶nlendirme numarasÄ±',0),(195845,5441,'pl','Numer rozliczeniowy banku',0),(195846,5441,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð² Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(195847,5441,'ur','Ø¨ÛŒÙ†Ú© Ø±ÙˆÙ¹Ù†Ú¯ Ù†Ù…Ø¨Ø±',0),(195848,5441,'sr','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(195849,5441,'vi','TrÃ¬nh tá»± ngÃ¢n hÃ ng sá»‘',0),(195850,5441,'af','Bank \"Routing\" Nommer',0),(195851,5441,'ro','NumÄƒrul de Banca circuit',0),(195852,5441,'et','Panga marsruudinumber',0),(195853,5441,'si','BanÄna Å¡tevilka proizvodnega postopka',0),(195854,5441,'ba','Nomor Routing Bank',0),(195855,5441,'nl','Bank bewerkingsplannummer',0),(195856,5441,'fi','Pankin reititysnumero',0),(195857,5441,'no','Banken rutenummeret',0),(195858,5441,'da','Bank registreringsnummer',0),(195859,5441,'ko','ì€í–‰ ë¼ìš°íŒ… ë²ˆí˜¸',0),(195860,5441,'he','×ž×¡×¤×¨ ×”× ×™×ª×•×‘ ×©×œ ×”×‘× ×§',0),(195861,5441,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Î¤ÏÎ¬Ï€ÎµÎ¶Î±Ï‚',0),(195862,5441,'zh','é“¶è¡Œç¼–å·\r\n',0),(195863,5441,'sv','Bankens Routing-nummer',0),(195864,5441,'it','Numero di percorso di banca',0),(195865,5441,'tl','',0),(195866,5441,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3650;&#3629;&#3609;&#3648;&#3591;&#3636;&#3609;&#3612;&#3656;&#3634;&#3609;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(195867,5441,'hi','à¤¬à¥ˆà¤‚à¤• à¤°à¥‚à¤Ÿà¤¿à¤‚à¤— à¤¨à¤‚à¤¬à¤°',0),(195868,5441,'ms','Nombor penghalaan Bank',0),(195869,5441,'ar','Ø±Ù‚Ù… Ø§Ù„ØªÙˆØ¬ÙŠÙ‡ Ø§Ù„Ù…ØµØ±ÙÙŠ',0),(195870,5441,'fr','NumÃ©ro d\'acheminement bancaire',0),(195871,5441,'jp','éŠ€è¡Œãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå?·',0),(195872,5441,'pt','NÃºmero de roteamento do banco',0),(195873,5441,'ru','Ð‘Ð°Ð½Ðº Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð½Ð¾Ð¼ÐµÑ€',0),(195874,5441,'es','Banco Numero de Ruta (Routing)',0),(195875,5441,'de','Bankleitzahl',0),(195876,5441,'en','Bank Routing Number',0),(195877,5442,'is','',0),(195878,5442,'dr','ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ù†ÙƒÙŠ',0),(195879,5442,'pr','ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ù†ÙƒÙŠ',0),(195880,5442,'tr','Banka devlet',0),(195881,5442,'pl','Bank PaÅ„stwa',0),(195882,5442,'bg','Ð‘Ð°Ð½ÐºÐ°Ñ‚Ð° Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°',0),(195883,5442,'ur','Ø§Ø³Ù¹ÛŒÙ¹ Ø¨ÛŒÙ†Ú©',0),(195884,5442,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ðµ Ð±Ð°Ð½ÐºÐµ',0),(195885,5442,'vi','NgÃ¢n hÃ ng tiá»ƒu bang',0),(195886,5442,'af','Bank Staat (Landsgebied)',0),(195887,5442,'ro','Banca de stat',0),(195888,5442,'et','Pank riik',0),(195889,5442,'si','Banke Älanice',0),(195890,5442,'ba','Bank Negara',0),(195891,5442,'nl','Bank staat',0),(195892,5442,'fi','Pankin valtion',0),(195893,5442,'no','Bank tilstand',0),(195894,5442,'da','Bank stat',0),(195895,5442,'ko','ì€í–‰ ìƒíƒœ',0),(195896,5442,'he','×ž×“×™× ×ª ×”×‘× ×§',0),(195897,5442,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎºÏÎ¬Ï„Î¿Ï…Ï‚',0),(195898,5442,'zh','å›½å®¶é“¶è¡Œ\r\n',0),(195899,5442,'sv','Bank staten',0),(195900,5442,'it','Banca stato',0),(195901,5442,'tl','',0),(195902,5442,'th','&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3585;&#3621;&#3634;&#3591;',0),(195903,5442,'hi','à¤¬à¥ˆà¤‚à¤• à¤°à¤¾à¤œà¥à¤¯',0),(195904,5442,'ms','Bank Negara',0),(195905,5442,'ar','Ø¨Ù†Ùƒ Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(195906,5442,'fr','Ã‰tat de la Banque',0),(195907,5442,'jp','éŠ€è¡Œã?®å·ž',0),(195908,5442,'pt','Banco estado',0),(195909,5442,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð±Ð°Ð½ÐºÐ°',0),(195910,5442,'es','Banco Estado',0),(195911,5442,'de','Bank-Zustand',0),(195912,5442,'en','Bank State',0),(195913,5443,'is','',0),(195914,5443,'dr','ÙƒØ¯Ù¾Ø³ØªÙŠ Ø¨Ø§Ù†Ùƒ',0),(195915,5443,'pr','ÙƒØ¯Ù¾Ø³ØªÙŠ Ø¨Ø§Ù†Ùƒ',0),(195916,5443,'tr','Banka ZIP',0),(195917,5443,'pl','Bank pocztowy',0),(195918,5443,'bg','Ð‘Ð°Ð½ÐºÐ° Zip',0),(195919,5443,'ur','Ø¨ÛŒÙ†Ú© Ø²Ù¾',0),(195920,5443,'sr','Ð‘Ð°Ð½ÐºÐ° Ð—Ð¸Ð¿',0),(195921,5443,'vi','Zip NgÃ¢n HÃ ng',0),(195922,5443,'af','Bank Poskode',0),(195923,5443,'ro','Banca Zip',0),(195924,5443,'et','Panga Zip',0),(195925,5443,'si','Banka Zip',0),(195926,5443,'ba','Bank Zip',0),(195927,5443,'nl','Bank Zip',0),(195928,5443,'fi','Pankin Zip',0),(195929,5443,'no','Banken Zip',0),(195930,5443,'da','Bank Zip',0),(195931,5443,'ko','ì€í–‰ ìš°íŽ¸ ë²ˆí˜¸',0),(195932,5443,'he','×ž×™×§×•×“ ×”×‘× ×§',0),(195933,5443,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± Zip',0),(195934,5443,'zh','é“¶è¡Œé‚®ç¼–\r\n',0),(195935,5443,'sv','Bank Zip',0),(195936,5443,'it','Banca Zip',0),(195937,5443,'tl','',0),(195938,5443,'th','&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;&#3586;&#3629;&#3591;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(195939,5443,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤¼à¤¿à¤ª',0),(195940,5443,'ms','Bank Zip',0),(195941,5443,'ar','Ø§Ù„Ø¨Ù†Ùƒ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(195942,5443,'fr','Banque Zip',0),(195943,5443,'jp','éŠ€è¡Œã?®éƒµä¾¿ç•ªå?·',0),(195944,5443,'pt','Banco Postal',0),(195945,5443,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ Ð±Ð°Ð½Ðº',0),(195946,5443,'es','Banco CÃ³digo Postal',0),(195947,5443,'de','Bank-Zip',0),(195948,5443,'en','Bank Zip',0),(195949,5444,'is','',0),(195950,5444,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨',0),(195951,5444,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨',0),(195952,5444,'tr','VarsayÄ±lan hesap',0),(195953,5444,'pl','DomyÅ›lne konto',0),(195954,5444,'bg','ÐÐºÐ°ÑƒÐ½Ñ‚ÑŠÑ‚ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(195955,5444,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(195956,5444,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(195957,5444,'vi','TK Máº·c Äá»‹nh',0),(195958,5444,'af','Verstekte Rekening',0),(195959,5444,'ro','Cont implicit',0),(195960,5444,'et','Vaikekonto',0),(195961,5444,'si','Privzeti raÄun',0),(195962,5444,'ba','Akun bawaan',0),(195963,5444,'nl','Standaardaccount',0),(195964,5444,'fi','Oletustili',0),(195965,5444,'no','Standardkontoen',0),(195966,5444,'da','Standard-konto',0),(195967,5444,'ko','ê¸°ë³¸ ê³„ì •',0),(195968,5444,'he','×—×©×‘×•×Ÿ ×‘×¨×™×¨×ª ×”×ž×—×“×œ',0),(195969,5444,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(195970,5444,'zh','é»˜è®¤å¸æˆ·\r\n',0),(195971,5444,'sv','Standardkontot',0),(195972,5444,'it','Account predefinito',0),(195973,5444,'tl','',0),(195974,5444,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(195975,5444,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤–à¤¾à¤¤à¤¾',0),(195976,5444,'ms','Akaun lalai',0),(195977,5444,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠ',0),(195978,5444,'fr','Compte par dÃ©faut',0),(195979,5444,'jp','æ—¢å®šå?£åº§',0),(195980,5444,'pt','Conta padrÃ£o',0),(195981,5444,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(195982,5444,'es','Cuenta por Defecto',0),(195983,5444,'de','Standardkonto',0),(195984,5444,'en','Default Account',0),(195985,5445,'is','',0),(195986,5445,'dr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†ÙƒÙŠ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(195987,5445,'pr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†ÙƒÙŠ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(195988,5445,'tr','Girilen hiÃ§bir banka hesaplarÄ±',0),(195989,5445,'pl','Nie kont bankowych wszedÅ‚',0),(195990,5445,'bg','ÐÑÐ¼Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸',0),(195991,5445,'ur','Ú©ÙˆØ¦ÛŒ Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(195992,5445,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ñƒ Ð±Ð°Ð½Ñ†Ð¸ ÑƒÐ½ÐµÑ‚',0),(195993,5445,'vi','ChÆ°a Nháº­p TK NgÃ¢n HÃ ng',0),(195994,5445,'af','Geen Bankrekenige Ingevoer',0),(195995,5445,'ro','Nu conturile au intrat',0),(195996,5445,'et','Pole sisestanud pangakontod',0),(195997,5445,'si','Brez banÄnih raÄunov, vstopil',0),(195998,5445,'ba','No Rekening Bank yang masuk',0),(195999,5445,'nl','Geen Bank Accounts ingevoerd',0),(196000,5445,'fi','Ei ole pankkitiliÃ¤, tuli',0),(196001,5445,'no','Noen bankkonto som er angitt',0),(196002,5445,'da','Nogen bankkonti, der er angivet',0),(196003,5445,'ko','ì•„ë‹ˆ ì€í–‰ ê³„ì¢Œ ìž…ë ¥',0),(196004,5445,'he','××™×Ÿ ×—×©×‘×•× ×•×ª ×”×‘× ×§ × ×›× ×¡',0),(196005,5445,'el','Î”ÎµÎ½ Î­Ï‡Î¿Ï…Î½ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï„Î­Î¸Î·ÎºÎµ',0),(196006,5445,'zh','æ²¡æœ‰è¾“å…¥çš„é“¶è¡Œå¸å·\r\n',0),(196007,5445,'sv','Ingen bankkonton som anges',0),(196008,5445,'it','Senza conti bancari iscritti',0),(196009,5445,'tl','',0),(196010,5445,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3610;&#3633;&#3597;&#3594;&#3637;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3607;&#3637;&#3656;&#3611;&#3657;&#3629;&#3609;',0),(196011,5445,'hi','à¤•à¥‹à¤ˆ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‹à¤‚ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(196012,5445,'ms','Tiada akaun Bank yang dimasukkan',0),(196013,5445,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø­Ø³Ø§Ø¨Ø§Øª Ù…ØµØ±ÙÙŠØ© Ø¯Ø®Ù„Øª',0),(196014,5445,'fr','Aucun compte bancaire est entrÃ©',0),(196015,5445,'jp','éŠ€è¡Œå?£åº§ã?Œå…¥åŠ›ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(196016,5445,'pt','Sem contas bancÃ¡rias entrado',0),(196017,5445,'ru','Ð‘ÐµÐ· Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð² Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»',0),(196018,5445,'es','No Se Encontro Cuentas Bancarias',0),(196019,5445,'de','Keine Bank-Konten eingegeben',0),(196020,5445,'en','No Bank Accounts Entered',0),(196021,5446,'is','',0),(196022,5446,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø§ÙˆÙ„ÙŠÙ‡ ',0),(196023,5446,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø§ÙˆÙ„ÙŠÙ‡ ',0),(196024,5446,'tr','Prenote ayrÄ±ntÄ±larÄ±',0),(196025,5446,'pl','Prenote szczegÃ³Å‚y',0),(196026,5446,'bg','Prenote Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(196027,5446,'ur','ØªÙØµÛŒÙ„Ø§Øª Ú©Û’ Ù¾Ø±Ø§Ù†ÙˆÙ¹ÛŒ',0),(196028,5446,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ‚Ðµ Ð´ÐµÑ‚Ð°Ñ™Ð¸',0),(196029,5446,'vi','Chi tiáº¿t ghi chÃº trÆ°á»›c',0),(196030,5446,'af','Vooraf Nota Besonderhede',0),(196031,5446,'ro','Detalii prenote',0),(196032,5446,'et','Prenote Ã¼ksikasjad',0),(196033,5446,'si','Prenote podrobnosti',0),(196034,5446,'ba','Prenote rincian',0),(196035,5446,'nl','Prenote Details',0),(196036,5446,'fi','Esilaskun tiedot',0),(196037,5446,'no','Prenote detaljer',0),(196038,5446,'da','Advisering detaljer',0),(196039,5446,'ko','Prenote ì„¸ë¶€ ì‚¬í•­',0),(196040,5446,'he','×¤×¨×˜×™× prenote',0),(196041,5446,'el','Prenote Ï€Î»Î¿Î¯Î¿Ï…',0),(196042,5446,'zh','é¢„è¯´æ˜Žè¯¦ç»†\r\n',0),(196043,5446,'sv','Detaljer fÃ¶r fÃ¶rauktorisering',0),(196044,5446,'it','Prenote dettagli',0),(196045,5446,'tl','',0),(196046,5446,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3585;&#3656;&#3629;&#3609;',0),(196047,5446,'hi','Prenote à¤µà¤¿à¤µà¤°à¤£',0),(196048,5446,'ms','Prenote butir-butir',0),(196049,5446,'ar','Ø¨Ø±Ù†Øª Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(196050,5446,'fr','Note prÃ©liminaire dÃ©tails',0),(196051,5446,'jp','äº‹å‰?ãƒ¡ãƒ¢è©³ç´°',0),(196052,5446,'pt','Prenote detalhes',0),(196053,5446,'ru','Prenote Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(196054,5446,'es','Deatalles de Prenota',0),(196055,5446,'de','Prenote Details',0),(196056,5446,'en','Prenote Details',0),(196057,5447,'is','',0),(196058,5447,'dr','Ù‚Ø¨ÙˆÙ„  ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø§ÙˆÙ„ÙŠÙ‡ ',0),(196059,5447,'pr','Ù‚Ø¨ÙˆÙ„  ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø§ÙˆÙ„ÙŠÙ‡ ',0),(196060,5447,'tr','Tamam prenote',0),(196061,5447,'pl','Prenote OK',0),(196062,5447,'bg','Prenote OK',0),(196063,5447,'ur','Ù¹Ú¾ÛŒÚ© ÛÛ’ Ù¾Ø±Ø§Ù†ÙˆÙ¹ÛŒ',0),(196064,5447,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ‚Ðµ Ñƒ Ñ€ÐµÐ´Ñƒ',0),(196065,5447,'vi','OK ghi chÃº trÆ°á»›c',0),(196066,5447,'af','Vooraf Nota OK',0),(196067,5447,'ro','Prenote OK',0),(196068,5447,'et','Prenote OK',0),(196069,5447,'si','Prenote OK',0),(196070,5447,'ba','Prenote OK',0),(196071,5447,'nl','Prenote OK',0),(196072,5447,'fi','Esilaskun OK',0),(196073,5447,'no','Prenote OK',0),(196074,5447,'da','Prenote OK',0),(196075,5447,'ko','í™•ì¸ì„ prenote',0),(196076,5447,'he','Prenote ×‘×¡×“×¨',0),(196077,5447,'el','Prenote OK',0),(196078,5447,'zh','é¢„è¯´æ˜ŽæˆåŠŸ\r\n',0),(196079,5447,'sv','OK fÃ¶r fÃ¶rauktorisering',0),(196080,5447,'it','Prenote OK',0),(196081,5447,'tl','',0),(196082,5447,'th','&#3605;&#3585;&#3621;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3585;&#3656;&#3629;&#3609;',0),(196083,5447,'hi','à¤ à¥€à¤• prenote',0),(196084,5447,'ms','Prenote OK',0),(196085,5447,'ar','Ø¨Ø±Ù†Øª Ù…ÙˆØ§ÙÙ‚',0),(196086,5447,'fr','Prenote OK',0),(196087,5447,'jp','äº‹å‰?ãƒ¡ãƒ¢ï¼¯ï¼«',0),(196088,5447,'pt','Prenote OK',0),(196089,5447,'ru','Prenote ÐžÐš',0),(196090,5447,'es','Prenota OK',0),(196091,5447,'de','Prenote OK',0),(196092,5447,'en','Prenote OK',0),(196093,5448,'is','',0),(196094,5448,'dr','9 Ø±Ù‚Ù…ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(196095,5448,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø±Ù‡Ú¯ÙŠØ±ÙŠ Ø¨Ø§ÙŠØ¯ 9 Ø±Ù‚Ù…ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(196096,5448,'tr','Ãœretim akÄ±ÅŸÄ± numarasÄ± 9 haneli olmalÄ±dÄ±r',0),(196097,5448,'pl','Numer marszruty musi byÄ‡ 9 cyfr',0),(196098,5448,'bg','ÐœÐ°Ñ€ÑˆÑ€ÑƒÑ‚Ð° Ñ‡Ð¸ÑÐ»Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ 9 Ñ†Ð¸Ñ„Ñ€Ð¸',0),(196099,5448,'ur','Ø±ÙˆÙ¹ Ù†Ù…Ø¨Ø± 9 Ø§Ø¹Ø¯Ø§Ø¯ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(196100,5448,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¾Ð³ Ð¿Ð¾ÑÑ‚ÑƒÐ¿ÐºÐ° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ 9 Ñ†Ð¸Ñ„Ð°Ñ€Ð°',0),(196101,5448,'vi','Sá»‘ Ä‘á»‹nh tuyáº¿n pháº£i cÃ³ 9',0),(196102,5448,'af','Routing nommer 9 syfers moet wees',0),(196103,5448,'ro','NumÄƒrul de circuit trebuie sÄƒ fie 9 cifre',0),(196104,5448,'et','Protsessikoodi peab olema 9-kohaline',0),(196105,5448,'si','Å tevilka proizvodnega postopka mora biti 9 Å¡tevilk',0),(196106,5448,'ba','Nomor routing harus 9 digit',0),(196107,5448,'nl','Bewerkingsplannummer moet 9 cijfers',0),(196108,5448,'fi','Reitityksen numeron on oltava 9 numeroa',0),(196109,5448,'no','Rutenummeret mÃ¥ vÃ¦re 9 siffer',0),(196110,5448,'da','Registreringsnummeret skal bestÃ¥ af 9 cifre',0),(196111,5448,'ko','ë¼ìš°íŒ… ë²ˆí˜¸ 9 ìžë¦¬ ì—¬ì•¼ í•©ë‹ˆë‹¤.',0),(196112,5448,'he','×ž×¡×¤×¨ ×”× ×™×ª×•×‘ ×œ×”×™×•×ª 9 ×¡×¤×¨×•×ª',0),(196113,5448,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ 9 ÏˆÎ·Ï†Î¯Î±',0),(196114,5448,'zh','è·¯å¾„å·ç å¿…é¡»9ä½æ•°\r\n',0),(196115,5448,'sv','Organisationsnumret mÃ¥ste vara 9 siffror',0),(196116,5448,'it','Numero di percorso deve essere di 9 cifre',0),(196117,5448,'tl','',0),(196118,5448,'th','Routing Number &#3605;&#3657;&#3629;&#3591;&#3617;&#3637; 9 &#3605;&#3633;&#3623;',0),(196119,5448,'hi','à¤…à¤¨à¥à¤®à¤¾à¤°à¥à¤—à¤£ à¤¸à¤‚à¤–à¥à¤¯à¤¾ 9 à¤…à¤‚à¤• à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(196120,5448,'ms','Penghalaan nombor mesti 9 digit',0),(196121,5448,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø§Ù„ØªÙˆØ¬ÙŠÙ‡ Ø±Ù‚Ù… 9 Ø£Ø±Ù‚Ø§Ù…',0),(196122,5448,'fr','NumÃ©ro d\'acheminement doit Ãªtre 9 chiffres',0),(196123,5448,'jp','ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå?·ã?¯ï¼™æ¡?ã?§ã?ªã??ã?¦ã?¯ã?ªã‚Šã?¾ã?›ã‚“',0),(196124,5448,'pt','NÃºmero de roteamento deve ser 9 dÃ­gitos',0),(196125,5448,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð° Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ 9 Ñ†Ð¸Ñ„Ñ€',0),(196126,5448,'es','NÃºmero de Routing Debe Tener 9 DÃ­gitos',0),(196127,5448,'de','Bankleitzahl muss 9 Ziffern sein.',0),(196128,5448,'en','Routing Number Must Be 9 Digits',0),(196129,5449,'is','',0),(196130,5449,'dr','Ù¾Ø³ Ø§Ù†Ø¯Ø§Ø²Ù‡Ø§',0),(196131,5449,'pr','Ù¾Ø³ Ø§Ù†Ø¯Ø§Ø²Ù‡Ø§',0),(196132,5449,'tr','Tasarruf',0),(196133,5449,'pl','OszczÄ™dnoÅ›ci',0),(196134,5449,'bg','Ð¡Ð¿ÐµÑÑ‚ÑÐ²Ð°Ð½Ð¸Ñ',0),(196135,5449,'ur','Ø¨Ú†Øª',0),(196136,5449,'sr','Ð¨Ñ‚ÐµÐ´ÑšÐ°',0),(196137,5449,'vi','Tiáº¿t kiá»‡m',0),(196138,5449,'af','Spaar',0),(196139,5449,'ro','Economii',0),(196140,5449,'et','Kokkuhoid',0),(196141,5449,'si','Prihranki',0),(196142,5449,'ba','Tabungan',0),(196143,5449,'nl','Besparingen',0),(196144,5449,'fi','SÃ¤Ã¤stÃ¶t',0),(196145,5449,'no','Besparelser',0),(196146,5449,'da','Besparelser',0),(196147,5449,'ko','ì €ì¶•',0),(196148,5449,'he','×—×¡×›×•× ×•×ª',0),(196149,5449,'el','Î•Î¾Î¿Î¹ÎºÎ¿Î½ÏŒÎ¼Î·ÏƒÎ·',0),(196150,5449,'zh','å‚¨è“„\r\n',0),(196151,5449,'sv','Besparingar',0),(196152,5449,'it','Risparmio',0),(196153,5449,'tl','',0),(196154,5449,'th','&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;',0),(196155,5449,'hi','à¤¬à¤šà¤¤',0),(196156,5449,'ms','Simpanan',0),(196157,5449,'ar','ØªØ­Ù‚ÙŠÙ‚ ÙˆÙÙˆØ±Ø§Øª',0),(196158,5449,'fr','Ã‰pargne',0),(196159,5449,'jp','è²¯è“„',0),(196160,5449,'pt','PoupanÃ§a',0),(196161,5449,'ru','Ð­ÐºÐ¾Ð½Ð¾Ð¼Ð¸Ñ',0),(196162,5449,'es','Ahorros',0),(196163,5449,'de','Einsparungen',0),(196164,5449,'en','Savings',0),(196165,5450,'is','',0),(196166,5450,'dr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ù† Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(196167,5450,'pr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ù† Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(196168,5450,'tr','VarsayÄ±lan olarak ayarla',0),(196169,5450,'pl','Zestaw jako domyÅ›lnÄ…',0),(196170,5450,'bg','Ð—Ð°Ð´Ð°Ð¹ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(196171,5450,'ur','Ø¨Ø·ÙˆØ± Ø·Û’ Ø´Ø¯Û Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(196172,5450,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ ÐºÐ°Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸',0),(196173,5450,'vi','Äáº·t máº·c Ä‘á»‹nh',0),(196174,5450,'af','Stel As verstek',0),(196175,5450,'ro','Set ca implicit',0),(196176,5450,'et','Sea vaikimisi',0),(196177,5450,'si','Nastavi kot privzeto',0),(196178,5450,'ba','Set As Default',0),(196179,5450,'nl','Als standaard instellen',0),(196180,5450,'fi','Aseta oletukseksi',0),(196181,5450,'no','Angi som standard',0),(196182,5450,'da','SÃ¦t som standard',0),(196183,5450,'ko','ê¸°ë³¸ìœ¼ë¡œ ì„¤ì •',0),(196184,5450,'he','×§×‘×¢ ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(196185,5450,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ Ï‰Ï‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î·',0),(196186,5450,'zh','è®¾ä¸ºé»˜è®¤\r\n',0),(196187,5450,'sv','Ange som standard',0),(196188,5450,'it','Impostato come predefinito',0),(196189,5450,'tl','',0),(196190,5450,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3605;&#3634;&#3617;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(196191,5450,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ',0),(196192,5450,'ms','Set sebagai lalai',0),(196193,5450,'ar','ØªØ¹ÙŠÙŠÙ† ÙƒØ§ÙØªØ±Ø§Ø¶ÙŠ',0),(196194,5450,'fr','Ensemble comme par dÃ©faut',0),(196195,5450,'jp','æ—¢å®šã?«ã?™ã‚‹',0),(196196,5450,'pt','Conjunto como padrÃ£o',0),(196197,5450,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(196198,5450,'es','Configurar como Predeterminado',0),(196199,5450,'de','Als Standard festlegen',0),(196200,5450,'en','Set As Default',0),(196201,5451,'is','',0),(196202,5451,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ  Ùˆ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(196203,5451,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ  Ùˆ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(196204,5451,'tr','Ãœretim akÄ±ÅŸÄ± numarasÄ± ve bir hesap numarasÄ± girmeniz gerekir.',0),(196205,5451,'pl','NaleÅ¼y wprowadziÄ‡ numer marszruty i numer konta.',0),(196206,5451,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€ Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°.',0),(196207,5451,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø±ÙˆÙ¹ Ù†Ù…Ø¨Ø± Ø§ÙˆØ± Ø§ÛŒÚ© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(196208,5451,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð±Ð°Ð½ÐºÐµ Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð°.',0),(196209,5451,'vi','báº¡n pháº£i nháº­p 1 sá»‘ Ä‘á»‹nh tuyáº¿n & 1 sá»‘ TK',0),(196210,5451,'af','U moet \'n AFRONDSGETAL invoer en \'n REKENINGNOMMER.',0),(196211,5451,'ro','Trebuie sÄƒ introduceÅ£i un numÄƒr de rutare ÅŸi un numÄƒr de cont.',0),(196212,5451,'et','Te peate sisestama marsuudinumbri ja konto',0),(196213,5451,'si','Morate vnesti Å¡tevilko proizvodnega postopka in Å¡tevilka raÄuna.',0),(196214,5451,'ba','Anda harus memasukkan nomor routing dan nomor rekening.',0),(196215,5451,'nl','U moet het nummer van een bewerkingsplan en een rekeningnummer invoeren.',0),(196216,5451,'fi','Anna pankin koodi ja tilinumero.',0),(196217,5451,'no','Du mÃ¥ angi et registreringsnummer og et kontonummer.',0),(196218,5451,'da','Du skal angive et registreringsnummer og et kontonummer.',0),(196219,5451,'ko','ë¼ìš°íŒ… ë²ˆí˜¸ ë° ê³„ì¢Œ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(196220,5451,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ž×¡×¤×¨ × ×™×ª×•×‘ ×•×ž×¡×¤×¨ ×—×©×‘×•×Ÿ.',0),(196221,5451,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± ÎºÏ‰Î´Î¹ÎºÏŒ Ï†Î±ÏƒÎµÎ¿Î»Î¿Î³Î¯Î¿Ï… ÎºÎ±Î¹ Î±ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï.',0),(196222,5451,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªè·¯å¾„å·ç å’Œå¸æˆ·å·ç ã€‚\r\n',0),(196223,5451,'sv','Du mÃ¥ste ange ett clearingnummer och ett kontonummer.',0),(196224,5451,'it','Ãˆ necessario immettere un numero di percorso e un numero di conto.',0),(196225,5451,'tl','',0),(196226,5451,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3619;&#3629;&#3585; routing number &#3649;&#3621;&#3632;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(196227,5451,'hi','à¤†à¤ªà¤•à¥‹ à¤•à¥‹à¤ˆ à¤°à¥‚à¤Ÿà¤¿à¤‚à¤— à¤¨à¤‚à¤¬à¤° à¤”à¤° à¤à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(196228,5451,'ms','Anda mesti masukkan nombor penghalaan dan nombor akaun.',0),(196229,5451,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… ØªÙˆØ¬ÙŠÙ‡ ÙˆØ±Ù‚Ù… Ø­Ø³Ø§Ø¨.',0),(196230,5451,'fr','Vous devez entrer un numÃ©ro de suivi et un numÃ©ro de compte.',0),(196231,5451,'jp','ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå?·ã?¨å?£åº§ç•ªå?·ã‚’å…¥åŠ›ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(196232,5451,'pt','VocÃª deve digitar um nÃºmero e um nÃºmero de conta.',0),(196233,5451,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð°.',0),(196234,5451,'es','Debe introducir un nÃºmero de enrutado y cuenta',0),(196235,5451,'de','Sie mÃ¼ssen eine Bankleitzahl und Kontonummer eingeben.',0),(196236,5451,'en','You must enter a routing number and an account number.',0),(196237,5452,'is','',0),(196238,5452,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ ',0),(196239,5452,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ ',0),(196240,5452,'tr','Banka bilgileri',0),(196241,5452,'pl','Bank informacji',0),(196242,5452,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(196243,5452,'ur','Ø¨Ù†Ú© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(196244,5452,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð±Ð°Ð½Ñ†Ð¸',0),(196245,5452,'vi','ThÃ´ng tin ngÃ¢n hÃ ng',0),(196246,5452,'af','Bank Inligting',0),(196247,5452,'ro','InformaÅ£iile bancare',0),(196248,5452,'et','Panga informatsioon',0),(196249,5452,'si','Banka informacije',0),(196250,5452,'ba','Informasi Bank',0),(196251,5452,'nl','Bankinformatie',0),(196252,5452,'fi','Pankin tiedot',0),(196253,5452,'no','Bankinformasjon',0),(196254,5452,'da','Bankoplysninger',0),(196255,5452,'ko','ì€í–‰ ì •ë³´',0),(196256,5452,'he','×ž×™×“×¢ ×‘× ×§',0),(196257,5452,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½',0),(196258,5452,'zh','é“¶è¡Œä¿¡æ¯\r\n',0),(196259,5452,'sv','Bankinformation',0),(196260,5452,'it','Informazioni bancarie',0),(196261,5452,'tl','',0),(196262,5452,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(196263,5452,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(196264,5452,'ms','Maklumat Bank',0),(196265,5452,'ar','Ø¨Ù†Ùƒ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(196266,5452,'fr','Information de la Banque',0),(196267,5452,'jp','éŠ€è¡Œæƒ…å ±',0),(196268,5452,'pt','InformaÃ§Ãµes bancÃ¡rias',0),(196269,5452,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð‘Ð°Ð½ÐºÐ°',0),(196270,5452,'es','InformaciÃ³n de Banco',0),(196271,5452,'de','Bankinformationen',0),(196272,5452,'en','Bank Information',0),(196273,5453,'is','',0),(196274,5453,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(196275,5453,'pr','Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(196276,5453,'tr','DoÄŸrudan yatÄ±rma',0),(196277,5453,'pl','PoÃŠrednictwem',0),(196278,5453,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(196279,5453,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹',0),(196280,5453,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(196281,5453,'vi','Giao dá»‹ch trá»±c tiáº¿p',0),(196282,5453,'af','Direkte Deposito',0),(196283,5453,'ro','Direct de depozit',0),(196284,5453,'et','Otsene hoiuste Â®',0),(196285,5453,'si','Neposredno depozit',0),(196286,5453,'ba','Deposit langsung',0),(196287,5453,'nl','Directe storting',0),(196288,5453,'fi','Suora Talletuslokero Â®',0),(196289,5453,'no','Direkte innskudd',0),(196290,5453,'da','Direkte depositum',0),(196291,5453,'ko','ì§ì ‘ ìž…ê¸ˆ',0),(196292,5453,'he','×”×¤×§×“×” ×™×©×™×¨×”',0),(196293,5453,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(196294,5453,'zh','ç›´æŽ¥å­˜æ¬¾\r\n',0),(196295,5453,'sv','Direkt insÃ¤ttning',0),(196296,5453,'it','Deposito diretto',0),(196297,5453,'tl','',0),(196298,5453,'th','&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(196299,5453,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾',0),(196300,5453,'ms','Deposit terus',0),(196301,5453,'ar','Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(196302,5453,'fr','DÃ©pÃ´t direct',0),(196303,5453,'jp','å?£åº§æŒ¯è¾¼',0),(196304,5453,'pt','DepÃ³sito direto',0),(196305,5453,'ru','ÐŸÑ€ÑÐ¼Ð¾Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(196306,5453,'es','DepÃ³sito Directo',0),(196307,5453,'de','Direkte Ablagerung',0),(196308,5453,'en','Direct Deposit',0),(196309,5454,'is','',0),(196310,5454,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(196311,5454,'pr','Ø§Ø¹Ù„Ø§Ù… Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(196312,5454,'tr','DoÄŸrudan yatÄ±rma bildirim',0),(196313,5454,'pl','Powiadomienie o wpÅ‚acie bezpoÅ›rednie',0),(196314,5454,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑƒÐ²ÐµÐ´Ð¾Ð¼ÑÐ²Ð°Ð½Ðµ',0),(196315,5454,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹',0),(196316,5454,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¾Ð±Ð°Ð²Ð¸Ñ˜ÐµÑÑ‚Ð¸',0),(196317,5454,'vi','ThÃ´ng bÃ¡o táº¡m á»©ng trá»±c tiáº¿p',0),(196318,5454,'af','Direkte Deposito Kennisgewing.',0),(196319,5454,'ro','Notificarea direct de depozit',0),(196320,5454,'et','Panga Ã¼lekanne teatamine',0),(196321,5454,'si','Obvestilo o neposredni polog',0),(196322,5454,'ba','Deposit langsung pemberitahuan',0),(196323,5454,'nl','Directe storting kennisgeving',0),(196324,5454,'fi','Suora talletus ilmoitus',0),(196325,5454,'no','Direkte innskudd varsling',0),(196326,5454,'da','Direkte depositum anmeldelse',0),(196327,5454,'ko','ì§ì ‘ ìž…ê¸ˆ ì•Œë¦¼',0),(196328,5454,'he','×”×•×“×¢×” ×¢×œ ×”×¤×§×“×” ×™×©×™×¨×”',0),(196329,5454,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(196330,5454,'zh','ç›´æŽ¥å­˜æ¬¾çš„é€šçŸ¥\r\n',0),(196331,5454,'sv','Direkt insÃ¤ttning anmÃ¤lan',0),(196332,5454,'it','Notifica del deposito diretto',0),(196333,5454,'tl','',0),(196334,5454,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3585;&#3634;&#3619;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(196335,5454,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾',0),(196336,5454,'ms','Pemberitahuan Deposit terus',0),(196337,5454,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(196338,5454,'fr','Notification de dÃ©pÃ´t direct',0),(196339,5454,'jp','å?£åº§æŒ¯è¾¼é€šçŸ¥æ›¸',0),(196340,5454,'pt','NotificaÃ§Ã£o de depÃ³sito direto',0),(196341,5454,'ru','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ñ ÐŸÑ€ÑÐ¼Ð¾Ð³Ð¾ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(196342,5454,'es','DepÃ³sito Directo NotificaciÃ³n',0),(196343,5454,'de','Direkte Ablagerung Benachrichtigung',0),(196344,5454,'en','Direct Deposit Notification',0),(196345,5455,'is','',0),(196346,5455,'dr','Ù†Ù…Ø§ÙŠØ´ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù„ØºÙˆ Ø´Ø¯Ù‡ ',0),(196347,5455,'pr','Ù†Ù…Ø§ÙŠØ´ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù„ØºÙˆ Ø´Ø¯Ù‡ ',0),(196348,5455,'tr','Ä°ptal edilen dosyalarÄ± gÃ¶ster',0),(196349,5455,'pl','PokaÅ¼ anulowane plikÃ³w',0),(196350,5455,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(196351,5455,'ur','Ù…Ù†Ø³ÙˆØ® Ù…Ø³Ù„ÛŒÚº Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(196352,5455,'sr','Ð•Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(196353,5455,'vi','Hiá»ƒn thá»‹ há»“ sÆ¡ há»§y ',0),(196354,5455,'af','Wys Gekansselleerde LÃªer',0),(196355,5455,'ro','Arata fisierele anulate',0),(196356,5455,'et','TÃ¼histatud failide kuvamine',0),(196357,5455,'si','PrikaÅ¾i datoteke preklicane',0),(196358,5455,'ba','Menampilkan file dibatalkan',0),(196359,5455,'nl','Geannuleerde bestanden weergeven',0),(196360,5455,'fi','NÃ¤ytÃ¤ peruutettu tiedostot',0),(196361,5455,'no','Vise avbrutte filer',0),(196362,5455,'da','Vis annulleret filer',0),(196363,5455,'ko','ì·¨ì†Œ ëœ íŒŒì¼ í‘œì‹œ',0),(196364,5455,'he','×”×¦×’ ×§×‘×¦×™× ×©×‘×•×˜×œ×•',0),(196365,5455,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Îµ Î±ÎºÏ…ÏÏŽÏƒÎµÎ¹Ï‚ Î±ÏÏ‡ÎµÎ¯Î±',0),(196366,5455,'zh','æ˜¾ç¤ºå·²å–æ¶ˆçš„æ–‡ä»¶\r\n',0),(196367,5455,'sv','Visa avbrutna filer',0),(196368,5455,'it','Visualizza file annullati',0),(196369,5455,'tl','',0),(196370,5455,'th','&#3649;&#3626;&#3604;&#3591;&#3649;&#3615;&#3657;&#3617;&#3607;&#3637;&#3656;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(196371,5455,'hi','à¤°à¤¦à¥à¤¦ à¤•à¤¿à¤ à¤—à¤ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(196372,5455,'ms','Tayang fail telah dibatalkan',0),(196373,5455,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù…Ù„ÙØ§Øª Ø§Ù„Ù…Ù„ØºØ§Ø©',0),(196374,5455,'fr','Afficher les fichiers annulÃ©es',0),(196375,5455,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«æ¸ˆãƒ•ã‚¡ã‚¤ãƒ«ã?®è¡¨ç¤º',0),(196376,5455,'pt','Mostrar Arquivos Cancelados',0),(196377,5455,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ð½Ñ‹Ðµ Ð¤Ð°Ð¹Ð»Ñ‹',0),(196378,5455,'es','Mostrar Files Cancelados',0),(196379,5455,'de','Abgebrochene Dateien anzeigen',0),(196380,5455,'en','Show Canceled Files',0),(196381,5456,'is','',0),(196382,5456,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙØ§ÙƒØªÙˆØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(196383,5456,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙØ§ÙƒØªÙˆØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(196384,5456,'tr','Fatura gÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klatÄ±n',0),(196385,5456,'pl','Kliknij, aby wyÅ›wietliÄ‡ faktury',0),(196386,5456,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(196387,5456,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(196388,5456,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(196389,5456,'vi','Nháº¥n Ä‘á»ƒ xem hÃ³a Ä‘Æ¡n',0),(196390,5456,'af','Kliek om te Faktuur te Besigtig',0),(196391,5456,'ro','Click pentru a vizualiza factura',0),(196392,5456,'et','KlÃµpsa, et nÃ¤ha arvet',0),(196393,5456,'si','Kliknite za ogled raÄuna',0),(196394,5456,'ba','Klik untuk melihat faktur',0),(196395,5456,'nl','Klik om te bekijken factuur',0),(196396,5456,'fi','Klikkaa nÃ¤hdÃ¤ksesi laskun',0),(196397,5456,'no','Klikk for Ã¥ vise faktura',0),(196398,5456,'da','Klik her for at se faktura',0),(196399,5456,'ko','ì²­êµ¬ì„œ ë³´ê¸°ë¥¼ í´ë¦­í•©ë‹ˆë‹¤',0),(196400,5456,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’ ×—×©×‘×•× ×™×ª',0),(196401,5456,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(196402,5456,'zh','ç‚¹å‡»æŸ¥çœ‹å‘ç¥¨\r\n',0),(196403,5456,'sv','Klicka fÃ¶r att Visa faktura',0),(196404,5456,'it','Clicca per vedere fattura',0),(196405,5456,'tl','',0),(196406,5456,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(196407,5456,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(196408,5456,'ms','Klik untuk lihat invois',0),(196409,5456,'ar','Ø£Ù†Ù‚Ø± Ù„Ø¹Ø±Ø¶ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(196410,5456,'fr','Cliquer ici pour voir la facture',0),(196411,5456,'jp','è«‹æ±‚æ›¸ã‚’è¦‹ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯',0),(196412,5456,'pt','Clique para ver a factura',0),(196413,5456,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð¡Ñ‡ÐµÑ‚Ð°',0),(196414,5456,'es','Click para ver la Factura',0),(196415,5456,'de','Hier klicken, um die Rechnung anzuzeigen',0),(196416,5456,'en','Click to view Invoice',0),(196417,5457,'is','',0),(196418,5457,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(196419,5457,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(196420,5457,'tr','MÃ¼ÅŸteri No',0),(196421,5457,'pl','Nr odbiorcy faktury',0),(196422,5457,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ No.',0),(196423,5457,'ur','Ú©Ø³Ù¹Ù…Ø± Ù†Ù…Ø¨Ø±',0),(196424,5457,'sr','Ð‘Ñ€ . ÐºÑƒÐ¿Ñ†Ð°.',0),(196425,5457,'vi','KhÃ¡ch hÃ ng sá»‘',0),(196426,5457,'af','Klant / KliÃ«nt Nr.',0),(196427,5457,'ro','Client nr.',0),(196428,5457,'et','Kliendi nr.',0),(196429,5457,'si','Å t.',0),(196430,5457,'ba','Pelanggan No.',0),(196431,5457,'nl','Klantnr.',0),(196432,5457,'fi','Nro',0),(196433,5457,'no','Kundenr.',0),(196434,5457,'da','Debitornr.',0),(196435,5457,'ko','ê³ ê° ë²ˆí˜¸',0),(196436,5457,'he','×ž×¡×¤×¨ ×œ×§×•×—×•×ª',0),(196437,5457,'el','ÎšÏ‰Î´. Ï€ÎµÎ»Î¬Ï„Î·',0),(196438,5457,'zh','å®¢æˆ·ç¼–å·',0),(196439,5457,'sv','Kundnr.',0),(196440,5457,'it','Numero cliente',0),(196441,5457,'tl','',0),(196442,5457,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(196443,5457,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¤‚.',0),(196444,5457,'ms','No. pelanggan',0),(196445,5457,'ar','Ø±Ù‚Ù… Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(196446,5457,'fr','NÂ° client',0),(196447,5457,'jp','é¡§å®¢ç•ªå?·',0),(196448,5457,'pt','N Âº cliente',0),(196449,5457,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(196450,5457,'es','NÃºmero de Cliente',0),(196451,5457,'de','Kunden-Nr.',0),(196452,5457,'en','Customer No.',0),(196453,5458,'is','',0),(196454,5458,'dr','(ØªØ¹Ù‡Ø¯',0),(196455,5458,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø¯Ù‡ÙŠ(ØªØ¹Ù‡Ø¯',0),(196456,5458,'tr','Toplam sÃ¼re',0),(196457,5458,'pl','Suma Å‚Ä…czna naleÅ¼noÅ›ci',0),(196458,5458,'bg','ÐžÐ±Ñ‰Ð¾ Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸',0),(196459,5458,'ur','Ú©Ù„ Ù…Ù‚Ø±Ø±Û',0),(196460,5458,'sr','Ð£ÐºÑƒÐ¿Ð°Ð½ Ð´ÑƒÐ³',0),(196461,5458,'vi','Tá»•ng cá»™ng Ä‘áº¿n háº¡n',0),(196462,5458,'af','Totaal Verskuldig',0),(196463,5458,'ro','Total util',0),(196464,5458,'et','Kokku',0),(196465,5458,'si','Skupno dolgovano',0),(196466,5458,'ba','Total Due',0),(196467,5458,'nl','Totale Due',0),(196468,5458,'fi','YhteensÃ¤',0),(196469,5458,'no','Innbetaling',0),(196470,5458,'da','Samlede Due',0),(196471,5458,'ko','í•©ê³„',0),(196472,5458,'he','×¡×”\"×› ×œ×¤×¨×¢×•×Ÿ',0),(196473,5458,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Î±Ï€Î±Î¹Ï„Î·Ï„ÏŒ',0),(196474,5458,'zh','æ€»æˆªæ­¢\r\n',0),(196475,5458,'sv','Totala betalas',0),(196476,5458,'it','Totale dovuto',0),(196477,5458,'tl','',0),(196478,5458,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(196479,5458,'hi','à¤•à¥à¤² à¤¬à¤•à¤¾à¤¯à¤¾',0),(196480,5458,'ms','Jumlah terhutang',0),(196481,5458,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(196482,5458,'fr','Montant total Ã  payer',0),(196483,5458,'jp','æ‰‹æ•°æ–™å?ˆè¨ˆ',0),(196484,5458,'pt','Total devido',0),(196485,5458,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾',0),(196486,5458,'es','Total Debido',0),(196487,5458,'de','Gesamtbetrag',0),(196488,5458,'en','Total Due',0),(196489,5459,'is','',0),(196490,5459,'dr','Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø± ØµÙØ­Ù‡ Ø¨Ø¹Ø¯',0),(196491,5459,'pr','Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø± ØµÙØ­Ù‡ Ø¨Ø¹Ø¯',0),(196492,5459,'tr','Bir sonraki sayfada devam',0),(196493,5459,'pl','CiÄ…g dalszy na nastÄ™pnej stronie',0),(196494,5459,'bg','ÐŸÑ€Ð¾Ð´ÑŠÐ»Ð¶Ð°Ð²Ð° Ð½Ð° ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(196495,5459,'ur','Ø§Ú¯Ù„Û’ ØµÙØ­Û’ Ù¾Ø± Ø¬Ø§Ø±ÛŒ',0),(196496,5459,'sr','ÐÐ°ÑÑ‚Ð°Ð²Ð°Ðº Ð½Ð° ÑÐ»ÐµÐ´ÐµÑ›Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(196497,5459,'vi','Tiáº¿p theo trang sau',0),(196498,5459,'af','Vervolg op volgende blad',0),(196499,5459,'ro','ContinuÄƒ pe pagina urmÄƒtoare',0),(196500,5459,'et','JÃ¤tkub jÃ¤rgmisel lehel',0),(196501,5459,'si','Nadaljevanje na naslednji strani',0),(196502,5459,'ba','Lanjut ke halaman berikutnya',0),(196503,5459,'nl','Vervolg op volgende pagina',0),(196504,5459,'fi','Jatkuu seuraavalla sivulla',0),(196505,5459,'no','Fortsetter pÃ¥ neste side',0),(196506,5459,'da','FortsÃ¦ttes nÃ¦ste side',0),(196507,5459,'ko','ë‹¤ìŒ íŽ˜ì´ì§€ì— ê³„ì†',0),(196508,5459,'he','×”×ž×©×š ×‘×“×£ ×”×‘×',0),(196509,5459,'el','Î£Ï…Î½ÎµÏ‡Î¯Î¶Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î·Î½ ÎµÏ€ÏŒÎ¼ÎµÎ½Î· ÏƒÎµÎ»Î¯Î´Î±',0),(196510,5459,'zh','ç»­ä¸‹é¡µ\r\n',0),(196511,5459,'sv','FortsÃ¤tter pÃ¥ nÃ¤sta sida',0),(196512,5459,'it','Continua alla pagina successiva',0),(196513,5459,'tl','',0),(196514,5459,'th','&#3605;&#3656;&#3629;&#3651;&#3609;&#3627;&#3609;&#3657;&#3634;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(196515,5459,'hi','à¤…à¤—à¤²à¥‡ à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤œà¤¾à¤°à¥€',0),(196516,5459,'ms','Sambungan di muka surat seterusnya',0),(196517,5459,'ar','ØªØ§Ø¨Ø¹ ÙÙŠ Ø§Ù„ØµÙØ­Ø© Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(196518,5459,'fr','Suite page suivante',0),(196519,5459,'jp','æ¬¡ã?®ãƒšãƒ¼ã‚¸ã?«ç¶šã??',0),(196520,5459,'pt','Continua na prÃ³xima pÃ¡gina',0),(196521,5459,'ru','Ð—Ð°ÐºÐ°Ð½Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ Ð½Ð° ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(196522,5459,'es','Continuado en la siguiente pÃ¡gina',0),(196523,5459,'de','Fortsetzung auf der nÃ¤chsten Seite',0),(196524,5459,'en','Continued on next page',0),(196525,5460,'is','',0),(196526,5460,'dr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙŠÙ„  Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª  Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(196527,5460,'pr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙŠÙ„  Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª  Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(196528,5460,'tr','DoÄŸrudan yatÄ±rma dosyasÄ± oluÅŸturma',0),(196529,5460,'pl','UtwÃ³rz plik przelewu',0),(196530,5460,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ Ñ„Ð°Ð¹Ð» Ñ Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(196531,5460,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ Ù…Ø³Ù„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(196532,5460,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(196533,5460,'vi','Táº¡o há»“ sÆ¡ thanh toÃ¡n trá»±c tiáº¿p',0),(196534,5460,'af','Skep Direkte DepositolÃªers',0),(196535,5460,'ro','CreaÅ£i fiÅŸierul Direct de depozit',0),(196536,5460,'et','Panga Ã¼lekanne faili loomine',0),(196537,5460,'si','Ustvarite datoteko neposredno depozit',0),(196538,5460,'ba','Membuat Deposit langsung File',0),(196539,5460,'nl','Directe storting bestand maken',0),(196540,5460,'fi','Suoraan tallettaa tiedoston luominen',0),(196541,5460,'no','Opprette direkte innskudd fil',0),(196542,5460,'da','Oprette direkte indbetaling fil',0),(196543,5460,'ko','ì´ì²´ íŒŒì¼ ìž‘ì„±',0),(196544,5460,'he','×™×¦×™×¨×ª ×§×•×‘×¥ ×”×¤×§×“×” ×™×©×™×¨×”',0),(196545,5460,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï… Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(196546,5460,'zh','åˆ›å»ºç›´æŽ¥å­˜æ¬¾æ–‡ä»¶\r\n',0),(196547,5460,'sv','Skapa direkt insÃ¤ttning fil',0),(196548,5460,'it','Creare File deposito diretto',0),(196549,5460,'tl','',0),(196550,5460,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3615;&#3657;&#3617;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(196551,5460,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤«à¤¼à¤¾à¤‡à¤² à¤¬à¤¨à¤¾à¤à¤',0),(196552,5460,'ms','Mencipta fail Deposit terus',0),(196553,5460,'ar','Ù‚Ù… Ø¨Ø¥Ù†Ø´Ø§Ø¡ Ù…Ù„Ù Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(196554,5460,'fr','CrÃ©er fichier de virement automatique',0),(196555,5460,'jp','å?£åº§æŒ¯è¾¼ãƒ•ã‚¡ã‚¤ãƒ«ã?®ä½œæˆ?',0),(196556,5460,'pt','Criar arquivo de depÃ³sito direto',0),(196557,5460,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¤Ð°Ð¹Ð»Ñ‹ ÐŸÑ€ÑÐ¼Ð¾Ð³Ð¾ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(196558,5460,'es','Crear Archivo de DepÃ³sito Directo',0),(196559,5460,'de','Direkte Ablagerung-Datei erstellen',0),(196560,5460,'en','Create Direct Deposit File',0),(196561,5461,'is','',0),(196562,5461,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ â€“ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ú¯Ù… Ø´Ø¯Ù‡ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ . Ø¨Ù‡ Ù‚Ø³Ù…Øª ØªÙ†Ø¸ÙŠÙ… Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡ Ø¨Ø±ÙˆÙŠØ¯ â€“ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ',0),(196563,5461,'pr','Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ â€“ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ú¯Ù… Ø´Ø¯Ù‡ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ . Ø¨Ù‡ Ù‚Ø³Ù…Øª ØªÙ†Ø¸ÙŠÙ… Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø±ÙˆÙŠØ¯ â€“ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ',0),(196564,5461,'tr','DoÄŸrudan yatÄ±rma kullanÄ±lamaz. Eksik alanlarÄ± vardÄ±r. Bordro Ã§ek hesaplarÄ±-> kurulum-> gidin',0),(196565,5461,'pl','Nie moÅ¼na uÅ¼ywaÄ‡ przelewu. Tam sÄ… brakujÄ…ce pola. PrzejdÅº do listy pÅ‚ac-> instalacji-> sprawdzanie kont',0),(196566,5461,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°. Ð˜Ð¼Ð° Ð»Ð¸Ð¿ÑÐ²Ð°Ñ‰Ð¸ Ð¿Ð¾Ð»ÐµÑ‚Ð°. ÐžÑ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð° Ð¢Ð Ð—-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-> Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(196567,5461,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ Û” ØºØ§Ø¦Ø¨ Ù‚Ø·Ø¹Ø§Øª ÛÛŒÚº Û” Ù¾Û’ Ø±ÙˆÙ„->-> Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Û’ Ù„ÛŒÛ’ Ø¬Ø§Ø¦ÛŒÚº',0),(196568,5461,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÐµ Ð½Ðµ Ð¼Ð¾Ð³Ñƒ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸. ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ðµ Ð¿Ð¾Ñ™Ð° Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ. Ð˜Ð´Ð¸Ñ‚Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¸ Ñ‚ÐµÐºÑƒÑ›Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(196569,5461,'vi','Giao dá»‹ch trá»±c tiáº¿p khÃ´ng dÃ¹ng Ä‘Æ°á»£c. Thiáº¿u trÆ°á»ng. HÃ£y Ä‘áº¿n Tráº£ lÆ°Æ¡ng -> Setup -> TK SÃ©c',0),(196570,5461,'af','Direkte Deposito kan nie gebruik word.  Daar is vermisde velde.  Gaan na Loonrol -> Opstelling -> Tjekrekeninge',0),(196571,5461,'ro','Imposibil de utilizat direct de depozit. ExistÄƒ domenii lipsesc. Du-te la salarizare-> Setup-> verificarea conturilor',0),(196572,5461,'et','Panga Ã¼lekanne ei saa kasutada. Seal on puuduvad vÃ¤ljad. Mine palga->-> kontrolli-kontode seadistamine',0),(196573,5461,'si','Neposreden vloga ni mogoÄe uporabiti. Obstajajo manjkajoÄa polja. Å el na plaÄilni listi-> Setup-> preverjanje raÄunov',0),(196574,5461,'ba','Deposit langsung tidak dapat digunakan. Terdapat bidang hilang. Pergi ke penggajian-> Setup-> rekening',0),(196575,5461,'nl','Directe storting kan niet worden gebruikt. Er zijn ontbrekende velden. Ga naar Payroll-> Setup-> controle van de rekeningen',0),(196576,5461,'fi','Suora talletus ei voi kÃ¤yttÃ¤Ã¤. TÃ¤llÃ¤ hetkellÃ¤ puuttuvat kentÃ¤t. Siirry Palkanlaskennan-> asetukset-> tarkastaa tilit',0),(196577,5461,'no','Direkte innskudd kan ikke brukes. Det er manglende felt. GÃ¥ til lÃ¸nn-> Setup-> sjekker regnskapet',0),(196578,5461,'da','Direkte depositum kan ikke bruges. Der er manglende felter. GÃ¥ til lÃ¸n-> Setup-> lÃ¸nkonti',0),(196579,5461,'ko','ì§ì ‘ ìž…ê¸ˆì„ ì‚¬ìš©í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤. ëˆ„ë½ ëœ í•„ë“œê°€ ìžˆìŠµë‹ˆë‹¤. ê¸‰ì—¬->-> ë‹¹ì¢Œ ê³„ì • ì„¤ì •ì—ê°€ ì„œ',0),(196580,5461,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×©×ª×ž×© ×”×¤×§×“×” ×™×©×™×¨×”. ×™×©× × ×©×“×•×ª ×—×¡×¨×™×. ×œ×œ×›×ª ×ž×©×›×•×¨×•×ª-> ×”×”×ª×§× ×”-> ×—×©×‘×•× ×•×ª ×‘× ×§',0),(196581,5461,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯. Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÎºÎµÎ½Î¬ Ï€ÎµÎ´Î¯Î±. ÎœÎµÏ„Î±Î²ÎµÎ¯Ï„Îµ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚-> Ï„Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Ï„Ï‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(196582,5461,'zh','ç›´æŽ¥å­˜æ¬¾ä¸èƒ½ä½¿ç”¨ã€‚æœ‰ç¼ºé¢†åŸŸã€‚å‰å¾€è–ªèµ„->â€œè®¾ç½®â€œ - >æ”¯ç¥¨å¸æˆ·\r\n',0),(196583,5461,'sv','Direkt insÃ¤ttning kan inte anvÃ¤ndas. Det finns saknas fÃ¤lt. GÃ¥ till lÃ¶nesystemet-> Setup-> kontroll konton',0),(196584,5461,'it','Deposito diretto non puÃ² essere utilizzato. Ci sono campi mancanti. Vai a libro paga-> Setup-> conti correnti',0),(196585,5461,'tl','',0),(196586,5461,'th','Direct Deposit cannot be used. There are missing fields. Go to Payroll -> Setup -> Checking Accounts',0),(196587,5461,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾à¥¤ à¤²à¤¾à¤ªà¤¤à¤¾ à¤«à¤¼à¥€à¤²à¥à¤¡à¥ à¤¸ à¤¹à¥ˆà¤‚à¥¤ -> à¤¸à¥‡à¤Ÿà¤…à¤ª-> à¤œà¤¾à¤à¤š à¤–à¤¾à¤¤à¥‹à¤‚ à¤ªà¥‡à¤°à¥‹à¤² à¤ªà¤° à¤œà¤¾à¤à¤',0),(196588,5461,'ms','Deposit langsung tidak boleh digunakan. Terdapat bidang-bidang yang hilang. Pergi ke gaji-> persediaan-> menyemak akaun',0),(196589,5461,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±. ÙˆÙ‡Ù†Ø§Ùƒ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…ÙÙ‚ÙˆØ¯Ø©. Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰ Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø±ÙˆØ§ØªØ¨-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-> Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(196590,5461,'fr','DÃ©pÃ´t direct ne peuvent pas Ãªtre utilisÃ©. Il y a des champs manquants. Aller Ã  la paie-> Setup-> vÃ©rification des comptes',0),(196591,5461,'jp','å?£åº§æŒ¯è¾¼ã?Œä½¿ç”¨ã?§ã??ã?¾ã?›ã‚“ã€‚ç©ºæ¬„ã?®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã?Œã?‚ã‚Šã?¾ã?™ã€‚çµ¦ä¸Žâ†’è¨­å®šâ†’å½“åº§é ?é‡‘ã?¸é€²ã‚“ã?§ã??ã? ã?•ã?„',0),(196592,5461,'pt','DepÃ³sito direto nÃ£o pode ser usado. HÃ¡ falta de campos. Ir para-> Setup-> contas de folha de pagamento',0),(196593,5461,'ru','ÐŸÑ€ÑÐ¼Ð¾Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒÑÑ. Ð•ÑÑ‚ÑŒ Ð¿Ñ€Ð¾Ð¿ÑƒÑ‰ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ð¾Ð»Ñ. Ð˜Ð´Ð¸Ñ‚Ðµ Ð² ÐÐ°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ Ð—/ÐŸ -> Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ -> ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(196594,5461,'es','DepÃ³sito Directo no se puede usar. Faltan campos. Va a la NÃ³mina -> ConfiguraciÃ³n -> Cuentas de Cheques',0),(196595,5461,'de','Direkte Einzahlung kann nicht verwendet werden. Fehlende Felder sind vorhanden. Gehen Sie in die Personalabrechnung-> Setup-> Girokonten',0),(196596,5461,'en','Direct Deposit cannot be used. There are missing fields. Go to Payroll -> Setup -> Checking Accounts',0),(196597,5462,'is','',0),(196598,5462,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(196599,5462,'pr','Ø´Ø±Ø­ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(196600,5462,'tr','DoÄŸrudan yatÄ±rma iÅŸlem aÃ§Ä±klamasÄ±',0),(196601,5462,'pl','Przelewem opis transakcji',0),(196602,5462,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÐ´ÐµÐ»ÐºÐ° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(196603,5462,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(196604,5462,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¾Ð¿Ð¸Ñ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð°',0),(196605,5462,'vi','Diá»…n giáº£i giao dá»‹ch trá»±c tiáº¿p',0),(196606,5462,'af','Direkte Deposito Transaksie Beskrywing.',0),(196607,5462,'ro','Direct de depozit tranzacÅ£ii Descriere',0),(196608,5462,'et','Panga Ã¼lekanne tehingu kirjeldus',0),(196609,5462,'si','Opis transakcije neposredno depozit',0),(196610,5462,'ba','Deposit langsung transaksi Deskripsi',0),(196611,5462,'nl','Directe storting transactie beschrijving',0),(196612,5462,'fi','Suora talletus tapahtuman kuvaus',0),(196613,5462,'no','Direkte innskudd transaksjonsbeskrivelsen',0),(196614,5462,'da','Direkte depositum posteringsbeskrivelse',0),(196615,5462,'ko','ì§ì ‘ ìž…ê¸ˆ ê±°ëž˜ ì„¤ëª…',0),(196616,5462,'he','×ª××•×¨ ×¢×¡×§×” ×”×¤×§×“×” ×™×©×™×¨×”',0),(196617,5462,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(196618,5462,'zh','ç›´æŽ¥å­˜æ¬¾äº¤æ˜“çš„è¯´æ˜Ž\r\n',0),(196619,5462,'sv','Direkt insÃ¤ttning transaktionen Beskrivning',0),(196620,5462,'it','Descrizione della transazione deposito diretto',0),(196621,5462,'tl','',0),(196622,5462,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(196623,5462,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤µà¤¿à¤µà¤°à¤£',0),(196624,5462,'ms','Penerangan urus niaga Deposit terus',0),(196625,5462,'ar','ÙˆØµÙ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(196626,5462,'fr','Description de Transaction de dÃ©pÃ´t direct',0),(196627,5462,'jp','å?£åº§æŒ¯è¾¼å?–å¼•è©³ç´°',0),(196628,5462,'pt','DescriÃ§Ã£o da transaÃ§Ã£o de depÃ³sito direto',0),(196629,5462,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(196630,5462,'es','DepÃ³sito Directo DescripciÃ³n de TransacciÃ³n',0),(196631,5462,'de','Direkte Ablagerung Transaktionsbeschreibung',0),(196632,5462,'en','Direct Deposit Transaction Description',0),(196633,5463,'is','',0),(196634,5463,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(196635,5463,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(196636,5463,'tr','DoÄŸrudan yatÄ±rma dosya indirmek',0),(196637,5463,'pl','Pobierz plik przelewu',0),(196638,5463,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¾ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(196639,5463,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ ÙØ§Ø¦Ù„ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(196640,5463,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¼Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(196641,5463,'vi','Táº£i há»“ sÆ¡ giao dá»‹ch trá»±c tiáº¿p',0),(196642,5463,'af','Aflaai van Direkte Deposito LÃªer',0),(196643,5463,'ro','DescarcÄƒ Direct de depozit',0),(196644,5463,'et','Panga Ã¼lekanne faili alla laadida',0),(196645,5463,'si','Travnato griÄevje neposreden vloga pila',0),(196646,5463,'ba','Download File Deposit langsung',0),(196647,5463,'nl','Directe storting bestand downloaden',0),(196648,5463,'fi','Lataa suoraan tallettaa tiedosto',0),(196649,5463,'no','Laste ned direkte innskudd fil',0),(196650,5463,'da','Download direkte indbetaling fil',0),(196651,5463,'ko','ì§ì ‘ ìž…ê¸ˆ íŒŒì¼ ë‹¤ìš´ë¡œë“œ',0),(196652,5463,'he','×”×•×¨×“ ×§×•×‘×¥ ×”×¤×§×“×” ×™×©×™×¨×”',0),(196653,5463,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(196654,5463,'zh','ç›´æŽ¥å­˜æ¬¾æ–‡ä»¶ä¸‹è½½\r\n',0),(196655,5463,'sv','HÃ¤mta direkt insÃ¤ttning filen',0),(196656,5463,'it','Scarica File deposito diretto',0),(196657,5463,'tl','',0),(196658,5463,'th','&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;&#3652;&#3615;&#3621;&#3660;&#3585;&#3634;&#3619;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(196659,5463,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤«à¤¼à¤¾à¤‡à¤² à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(196660,5463,'ms','Muat turun fail Deposit terus',0),(196661,5463,'ar','ØªØ­Ù…ÙŠÙ„ Ù…Ù„Ù Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(196662,5463,'fr','TÃ©lÃ©charger le fichier du dÃ©pÃ´t Direct',0),(196663,5463,'jp','å?£åº§æŒ¯è¾¼ãƒ•ã‚¡ã‚¤ãƒ«ã?®ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰',0),(196664,5463,'pt','Baixar arquivo de depÃ³sito direto',0),(196665,5463,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ð¤Ð°Ð¹Ð»Ñ‹ ÐŸÑ€ÑÐ¼Ð¾Ð³Ð¾ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(196666,5463,'es','Descargar Archivo de DepÃ³sito Directo',0),(196667,5463,'de','Direkte Ablagerung Datei herunterladen',0),(196668,5463,'en','Download Direct Deposit File',0),(196669,5464,'is','',0),(196670,5464,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(196671,5464,'pr','Ú†Ø§Ù¾ ØªÙ‡ Ú†Ùƒ Ù‡Ø§ÙŠ Ø³Ù¾Ø±Ø¯Ù‡(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(196672,5464,'tr','DoÄŸrudan yatÄ±rma taslaklarÄ± YazdÄ±r',0),(196673,5464,'pl','Druku przelewu artykuÅ‚Ã³w',0),(196674,5464,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐœÑŠÐ½Ð¸Ñ‡ÐµÑ‚Ð°',0),(196675,5464,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ Ú©Ø¦ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(196676,5464,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¾Ð´ÑÐµÑ‡Ñ†Ð¸Ð¼Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(196677,5464,'vi','In ghi ná»£ trá»±c tiáº¿p',0),(196678,5464,'af','Druk Direkte Deposito Teenblaadjie',0),(196679,5464,'ro','Imprima Direct de depozit romÃ¢ni',0),(196680,5464,'et','Prindi otsene hoiuste Kategooriad:',0),(196681,5464,'si','Tiskanje neposredno depozit Å¡krbin',0),(196682,5464,'ba','Rintisan bertopik Deposit langsung mencetak',0),(196683,5464,'nl','Directe storting Stubs afdrukken',0),(196684,5464,'fi','Tulostaa suoraan tallettaa Luokka:',0),(196685,5464,'no','Skrive ut direkte innskudd stubber',0),(196686,5464,'da','Udskrive direkte indbetaling stubbe',0),(196687,5464,'ko','ì§ì ‘ ìž…ê¸ˆ ëª…ì„¸ì„œë¥¼ ì¸ì‡„',0),(196688,5464,'he','×”×“×¤×¡ ×¨×›×™×‘×™ Stub ×”×¤×§×“×” ×™×©×™×¨×”',0),(196689,5464,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÏ€Î­ÎºÏ„Î±ÏƒÎ·',0),(196690,5464,'zh','æ‰“å°ç›´æŽ¥å­˜æ¬¾å­˜æ ¹\r\n',0),(196691,5464,'sv','Skriva ut direkt insÃ¤ttning-stubbar',0),(196692,5464,'it','Stampare gli stub deposito diretto',0),(196693,5464,'tl','',0),(196694,5464,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3657;&#3609;&#3586;&#3633;&#3657;&#3623;&#3648;&#3594;&#3655;&#3588;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(196695,5464,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ Stubs à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(196696,5464,'ms','Cetak Deposit terus tunas',0),(196697,5464,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¨Ø°Ø±Ø© Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(196698,5464,'fr','Imprimer les talons de chÃ¨que de dÃ©pÃ´t Direct',0),(196699,5464,'jp','å?£åº§æŒ¯è¾¼æŽ§ã?ˆã‚’å?°åˆ·',0),(196700,5464,'pt','Imprimir recibos de depÃ³sito direto',0),(196701,5464,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°Ð³Ð»ÑƒÑˆÐºÐ¸ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(196702,5464,'es','Imprimir TalÃ³nes de DepÃ³sitos Directos',0),(196703,5464,'de','Direkte Ablagerung Stubs zu drucken',0),(196704,5464,'en','Print Direct Deposit Stubs',0),(196705,5465,'is','',0),(196706,5465,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ø±Ø­ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(196707,5465,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ø±Ø­ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(196708,5465,'tr','DoÄŸrudan yatÄ±rma iÅŸlemi aÃ§Ä±klama girmeniz gerekir.',0),(196709,5465,'pl','NaleÅ¼y wprowadziÄ‡ przelewem opis transakcji.',0),(196710,5465,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð·Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸ÑÑ‚Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚.',0),(196711,5465,'ur','Ø¢Ù¾ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† ØªØµØ±ÛŒØ­ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(196712,5465,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¾Ð¿Ð¸Ñ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚.',0),(196713,5465,'vi','Báº¡n pháº£i nháº­p 1 giao dá»‹ch trá»±c tiáº¿p',0),(196714,5465,'af','U moet \'n direkte depositotransaksiebeskrywing invoer',0),(196715,5465,'ro','Trebuie sa introducetii o DD descriere',0),(196716,5465,'et','Te peate sisestama direct deposit transaction description.',0),(196717,5465,'si','Vnesite opis transakcije neposredno depozit.',0),(196718,5465,'ba','Anda harus memasukkan gambaran transaksi deposit langsung.',0),(196719,5465,'nl','U moet een directe storting transactie omschrijving invoeren.',0),(196720,5465,'fi','Kirjoita tilisiirron tapahtuman kuvaus.',0),(196721,5465,'no','Du mÃ¥ angi en direkte innskudd transaksjonsbeskrivelsen.',0),(196722,5465,'da','Du skal angive en direkte indbetaling posteringsbeskrivelse.',0),(196723,5465,'ko','ì§ì ‘ ìž…ê¸ˆ ê±°ëž˜ ì„¤ëª…ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(196724,5465,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ª×™××•×¨ ×¢×¡×§×ª ×”×¤×§×“×” ×™×©×™×¨×”.',0),(196725,5465,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚ Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·.',0),(196726,5465,'zh','ä½ å¿…é¡»è¾“å…¥ç›´æŽ¥å­˜æ¬¾äº¤æ˜“çš„æè¿°ã€‚\r\n',0),(196727,5465,'sv','Du mÃ¥ste ange en direkt insÃ¤ttning transaktionen beskrivning.',0),(196728,5465,'it','Ãˆ necessario inserire una descrizione delle transazioni di deposito diretto.',0),(196729,5465,'tl','',0),(196730,5465,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3611;&#3657;&#3629;&#3609;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3',0),(196731,5465,'hi','à¤¤à¥à¤® à¤à¤• à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤µà¤¿à¤µà¤°à¤£ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(196732,5465,'ms','Anda mesti masukkan Perihalan transaksi deposit terus.',0),(196733,5465,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ ÙˆØµÙ Ø­Ø±ÙƒØ© Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ø¨Ø§Ø´Ø±.',0),(196734,5465,'fr','Vous devez entrer une description de transaction de dÃ©pÃ´t direct',0),(196735,5465,'jp','å?£åº§æŒ¯è¾¼å?–å¼•è©³ç´°ã‚’å…¥åŠ›ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(196736,5465,'pt','VocÃª deve digitar uma descriÃ§Ã£o da transaÃ§Ã£o de depÃ³sito direto.',0),(196737,5465,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚.',0),(196738,5465,'es','Debe introducir una descripciÃ³n de la transacciÃ³n de depÃ³sito directo.',0),(196739,5465,'de','Sie mÃ¼ssen eine direkte Ablagerung Transaktionsbeschreibung eingeben.',0),(196740,5465,'en','You must enter a direct deposit transaction description.',0),(196741,5466,'is','',0),(196742,5466,'dr','Ú†Ø§Ù¾ ØªÙ…Ø§Ù… Ú¯Ø±ÙˆÙ‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(196743,5466,'pr','Ú†Ø§Ù¾ ØªÙ…Ø§Ù… Ú¯Ø±ÙˆÙ‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(196744,5466,'tr','Fatura YazdÄ±r tÃ¼m grup',0),(196745,5466,'pl','Grupa caÅ‚ego wydruku faktur',0),(196746,5466,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ñ†ÑÐ»Ð°Ñ‚Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(196747,5466,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù¾ÙˆØ±Û’ Ú¯Ø±ÙˆÙ¾ ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ',0),(196748,5466,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ñ†ÐµÐ»Ñƒ Ð³Ñ€ÑƒÐ¿Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(196749,5466,'vi','In toÃ n bá»™ nhÃ³m hÃ³a Ä‘Æ¡n',0),(196750,5466,'af','Druk Hele Groep Fakture',0),(196751,5466,'ro','Imprimare Ã®ntregul grup de facturi',0),(196752,5466,'et','TrÃ¼ki Kogu Arvete Grupp',0),(196753,5466,'si','Natisni celoten skupine raÄunov',0),(196754,5466,'ba','Cetak seluruh kelompok faktur',0),(196755,5466,'nl','Hele groep afdrukken van facturen',0),(196756,5466,'fi','Tulosta koko konsernin laskujen',0),(196757,5466,'no','Skriv ut hele gruppen av fakturaer',0),(196758,5466,'da','Udskriv hele gruppen af fakturaer',0),(196759,5466,'ko','ì²­êµ¬ì„œì˜ ì¸ì‡„ ì „ì²´ ê·¸ë£¹',0),(196760,5466,'he','×”×“×¤×¡ ×›×œ ×§×‘×•×¦×” ×©×œ ×—×©×‘×•× ×™×•×ª',0),(196761,5466,'el','ÎŸÎ¼Î¬Î´Î± Î¿Î»ÏŒÎºÎ»Î·ÏÎ¿ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(196762,5466,'zh','æ‰“å°æ•´ç»„å‘ç¥¨\r\n',0),(196763,5466,'sv','Skriv ut hela gruppen av fakturor',0),(196764,5466,'it','Gruppo di tutta la stampa delle fatture',0),(196765,5466,'tl','',0),(196766,5466,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3585;&#3621;&#3640;&#3656;&#3617;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(196767,5466,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¾ à¤¸à¤‚à¤ªà¥‚à¤°à¥à¤£ à¤¸à¤®à¥‚à¤¹',0),(196768,5466,'ms','Cetak seluruh Kumpulan invois',0),(196769,5466,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© ÙƒÙ„Ù‡Ø§ Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(196770,5466,'fr','Groupe de toute impression de factures',0),(196771,5466,'jp','è«‹æ±‚æ›¸ã?®å…¨ã?¦ã?®ã‚°ãƒ«ãƒ¼ãƒ—ã‚’å?°åˆ·',0),(196772,5466,'pt','Grupo de toda a impressÃ£o de faturas',0),(196773,5466,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð²ÑÐµÐ¹ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(196774,5466,'es','Imprimir Grupo Entero de Facturas',0),(196775,5466,'de','Gesamte Gruppe von Rechnungen',0),(196776,5466,'en','Print Entire Group of Invoices',0),(196777,5467,'is','',0),(196778,5467,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(196779,5467,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(196780,5467,'tr','Yeni baskÄ± faturalar',0),(196781,5467,'pl','WydrukowaÄ‡ faktury',0),(196782,5467,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(196783,5467,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹',0),(196784,5467,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(196785,5467,'vi','In láº¡i hÃ³a Ä‘Æ¡n',0),(196786,5467,'af','Herdruk Fakture',0),(196787,5467,'ro','Facturi de retipÄƒrire',0),(196788,5467,'et','Arvete kordustrÃ¼kk',0),(196789,5467,'si','Ponatis raÄunov',0),(196790,5467,'ba','Faktur cetak ulang',0),(196791,5467,'nl','Herdruk facturen',0),(196792,5467,'fi','Tulostaa laskuja',0),(196793,5467,'no','Skrive ut fakturaer',0),(196794,5467,'da','Genoptryk fakturaer',0),(196795,5467,'ko','ìž¬ë°œí–‰ ì²­êµ¬ì„œ',0),(196796,5467,'he','×”×“×¤×¡ ×©×•×‘ ×—×©×‘×•× ×™×•×ª',0),(196797,5467,'el','Î‘Î½Î¬Ï„Ï…Ï€Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(196798,5467,'zh','é‡å°å‘ç¥¨\r\n',0),(196799,5467,'sv','Nytryck fakturor',0),(196800,5467,'it','Ristampa fatture',0),(196801,5467,'tl','',0),(196802,5467,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(196803,5467,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤šà¤¾à¤²à¤¾à¤¨',0),(196804,5467,'ms','Pencetakan semula invois',0),(196805,5467,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(196806,5467,'fr','RÃ©impression de factures',0),(196807,5467,'jp','è«‹æ±‚æ›¸ã?®å†?å?°åˆ·',0),(196808,5467,'pt','ReimpressÃ£o de facturas',0),(196809,5467,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(196810,5467,'es','Reimprimir Facturas',0),(196811,5467,'de','Reprint-Rechnungen',0),(196812,5467,'en','Reprint Invoices',0),(196813,5468,'is','',0),(196814,5468,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ ÙØ§ÙƒØªÙˆØ± Ø®Ø§Øµ ÙŠØ§ Ú¯Ø±ÙˆÙ‡ÙŠ Ø§Ø² ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(196815,5468,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ ÙØ§ÙƒØªÙˆØ± Ø®Ø§Øµ ÙŠØ§ Ú¯Ø±ÙˆÙ‡ÙŠ Ø§Ø² ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(196816,5468,'tr','Reprint belirli fatura veya fatura gruplarÄ±',0),(196817,5468,'pl','Przedruk fakturze lub grup faktur',0),(196818,5468,'bg','ÐŸÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð»Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸ Ð¾Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(196819,5468,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ú¯Ø±ÙˆÛÙˆÚº ÛŒØ§ Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ Ù…Ø®ØµÙˆØµ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(196820,5468,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¸Ð»Ð¸ Ð³Ñ€ÑƒÐ¿Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(196821,5468,'vi','In láº¡i hÃ³a Ä‘Æ¡n hay nhÃ³m hÃ³a Ä‘Æ¡n cá»¥ thá»ƒ',0),(196822,5468,'af','Herdruk Spesifieke Fakture of Groepe van Fakture',0),(196823,5468,'ro','ImprimaÅ£i din nou factura specifice sau grupuri de facturi',0),(196824,5468,'et','KordustrÃ¼kk konkreetseid arve vÃµi arvete rÃ¼hmad',0),(196825,5468,'si','Ponatis posebne raÄuna ali skupine raÄunov',0),(196826,5468,'ba','Faktur cetak ulang tertentu atau kelompok faktur',0),(196827,5468,'nl','Herdruk specifieke factuur of groepen van facturen',0),(196828,5468,'fi','Tulostaa tiettyyn laskuun tai ryhmien laskujen',0),(196829,5468,'no','Opptrykk bestemt faktura eller grupper av fakturaer',0),(196830,5468,'da','Genoptryk bestemt faktura eller grupper af fakturaer',0),(196831,5468,'ko','ë¬´ë‹¨ ì „ìž¬ íŠ¹ì • ì†¡ìž¥ ë˜ëŠ” ì²­êµ¬ì„œì˜ ê·¸ë£¹',0),(196832,5468,'he','×œ×”×“×¤×™×¡ ×ž×—×“×© ×”×¡×¤×¦×™×¤×™ ×‘×—×©×‘×•× ×™×ª ××• ×§×‘×•×¦×•×ª ×©×œ ×—×©×‘×•× ×™×•×ª',0),(196833,5468,'el','Î‘Î½Î¬Ï„Ï…Ï€Î¿ ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î± Î® Î¿Î¼Î¬Î´ÎµÏ‚ Ï„Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(196834,5468,'zh','é‡å°ç‰¹å®šå‘ç¥¨æˆ–å‘ç¥¨ç»„\r\n',0),(196835,5468,'sv','Nytryck viss faktura eller grupper av fakturor',0),(196836,5468,'it','Ristampa fattura specifici o gruppi di fatture',0),(196837,5468,'tl','',0),(196838,5468,'th','&#3619;&#3632;&#3610;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3627;&#3619;&#3639;&#3629;&#3585;&#3621;&#3640;&#3656;&#3617;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3',0),(196839,5468,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¯à¤¾ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¤¾ à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£',0),(196840,5468,'ms','Pencetakan semula invois tertentu atau kumpulan-kumpulan invois',0),(196841,5468,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø·Ø¨Ø§Ø¹Ø© ÙØ§ØªÙˆØ±Ø© Ù…Ø¹ÙŠÙ†Ø© Ø£Ùˆ Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ù…Ù† Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(196842,5468,'fr','RÃ©imprimer une facture spÃ©cifique ou groupes de factures',0),(196843,5468,'jp','ç‰¹å®šè«‹æ±‚æ›¸ã?‹è«‹æ±‚æ›¸ã‚°ãƒ«ãƒ¼ãƒ—ã?®å†?å?°åˆ·',0),(196844,5468,'pt','ReimpressÃ£o factura especÃ­ficos ou grupos de faturas',0),(196845,5468,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ð¾Ð³Ð¾ Ð¡Ñ‡ÐµÑ‚Ð° Ð¸Ð»Ð¸ Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(196846,5468,'es','Reimprimir una Factura Especifica o Grupos de Facturas',0),(196847,5468,'de','Nachdruck bestimmten Rechnung oder Gruppen von Rechnungen',0),(196848,5468,'en','Reprint Specific Invoice or Groups of Invoices',0),(196849,5469,'is','',0),(196850,5469,'dr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± ',0),(196851,5469,'pr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± ',0),(196852,5469,'tr','BaÅŸlangÄ±Ã§ta fatura tarihi',0),(196853,5469,'pl','PoczÄ…tku Data faktury',0),(196854,5469,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(196855,5469,'ur','Ø¢ØºØ§Ø² Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(196856,5469,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(196857,5469,'vi','NgÃ y báº¯t Ä‘áº§u ra hÃ³a Ä‘Æ¡n',0),(196858,5469,'af','Beginnende Faktuur Datum',0),(196859,5469,'ro','ÃŽnceputul a facturÄƒrii',0),(196860,5469,'et','Arve alguskuupÃ¤ev',0),(196861,5469,'si','Datum zaÄetka raÄuna',0),(196862,5469,'ba','Tanggal faktur awal',0),(196863,5469,'nl','Begin factuurdatum',0),(196864,5469,'fi','Alussa laskutuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(196865,5469,'no','Begynnelsen fakturadatoen',0),(196866,5469,'da','Begyndelsen fakturadatoen',0),(196867,5469,'ko','ì‹œìž‘ ì†¡ìž¥ ë‚ ì§œ',0),(196868,5469,'he','×ª××¨×™×š ×—×©×‘×•× ×™×ª ×”×”×ª×—×œ×”',0),(196869,5469,'el','Î—Î¼/Î½Î¯Î± Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Î±ÏÏ‡Î®',0),(196870,5469,'zh','å‘ç¥¨æ—¥æœŸå¼€å§‹\r\n',0),(196871,5469,'sv','BÃ¶rjan fakturadatum',0),(196872,5469,'it','Inizio data fattura',0),(196873,5469,'tl','',0),(196874,5469,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(196875,5469,'hi','à¤¶à¥à¤°à¥à¤†à¤¤ à¤šà¤¾à¤²à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(196876,5469,'ms','Tarikh invois awal',0),(196877,5469,'ar','Ø¨Ø¯Ø§ÙŠØ© ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(196878,5469,'fr','DÃ©but Date de la facture',0),(196879,5469,'jp','è«‹æ±‚æ—¥ã?®é–‹å§‹',0),(196880,5469,'pt','Data de inÃ­cio fatura',0),(196881,5469,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° ÑÑ‡ÐµÑ‚Ð°',0),(196882,5469,'es','Fecha de Iniciode Factura',0),(196883,5469,'de','Rechnungsdatum Anfang',0),(196884,5469,'en','Beginning Invoice Date',0),(196885,5470,'is','',0),(196886,5470,'dr','Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ®  ÙØ§ÙƒØªÙˆØ± ',0),(196887,5470,'pr','Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ®  ÙØ§ÙƒØªÙˆØ± ',0),(196888,5470,'tr','Son fatura tarihi',0),(196889,5470,'pl','ZakoÅ„czenie Data faktury',0),(196890,5470,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(196891,5470,'ur','Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(196892,5470,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(196893,5470,'vi','NgÃ y hÃ³a Ä‘Æ¡n cuá»‘i',0),(196894,5470,'af','Eindigende Faktuur Datum',0),(196895,5470,'ro','Data de facturÄƒ se Ã®ncheie',0),(196896,5470,'et','Arve lÃµppkuupÃ¤ev',0),(196897,5470,'si','KonÄni datum raÄuna',0),(196898,5470,'ba','Akhir tanggal faktur',0),(196899,5470,'nl','Factuur einddatum',0),(196900,5470,'fi','Laskun Lopetuspvm',0),(196901,5470,'no','Sluttdato for faktura',0),(196902,5470,'da','Faktura slutdato',0),(196903,5470,'ko','ê²°ë§ ì†¡ìž¥ ë‚ ì§œ',0),(196904,5470,'he','×ª××¨×™×š ×—×©×‘×•× ×™×ª ×¡×•×£',0),(196905,5470,'el','Î—Î¼/Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(196906,5470,'zh','å‘ç¥¨æ—¥æœŸç»“æŸ\r\n',0),(196907,5470,'sv','Slutdatum fÃ¶r faktura',0),(196908,5470,'it','Data fattura fine',0),(196909,5470,'tl','',0),(196910,5470,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(196911,5470,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¨à¥‡ à¤•à¥‡ à¤šà¤¾à¤²à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(196912,5470,'ms','Tarikh invois berakhir',0),(196913,5470,'ar','Ø§Ù†ØªÙ‡Ø§Ø¡ ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(196914,5470,'fr','Date de la facture finale',0),(196915,5470,'jp','è«‹æ±‚æ—¥ã?®çµ‚äº†',0),(196916,5470,'pt','Data de factura final',0),(196917,5470,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(196918,5470,'es','Fecha Final de Factura',0),(196919,5470,'de','Enddatum Rechnung',0),(196920,5470,'en','Ending Invoice Date',0),(196921,5471,'is','',0),(196922,5471,'dr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(196923,5471,'pr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(196924,5471,'tr','Fatura numarasÄ± aralÄ±ÄŸÄ±',0),(196925,5471,'pl','Zakres numerÃ³w faktur',0),(196926,5471,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(196927,5471,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø± Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(196928,5471,'sr','ÐžÐ¿ÑÐµÐ³ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(196929,5471,'vi','Pháº¡m vi sá»‘ hÃ³a Ä‘Æ¡n',0),(196930,5471,'af','Faktuurnommer Reeks',0),(196931,5471,'ro','Gama de numÄƒrul facturii',0),(196932,5471,'et','Arve numbri vahemik',0),(196933,5471,'si','Obseg Å¡tevilko raÄuna',0),(196934,5471,'ba','Kisaran nomor faktur',0),(196935,5471,'nl','Factuur nummer bereik',0),(196936,5471,'fi','Laskun numeroalueen',0),(196937,5471,'no','Utvalg av faktura',0),(196938,5471,'da','Faktura nummeret vifte',0),(196939,5471,'ko','ì†¡ìž¥ ë²ˆí˜¸ ë²”ìœ„',0),(196940,5471,'he','×˜×•×•×— ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(196941,5471,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÏƒÎµÎ¹ÏÎ¬Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(196942,5471,'zh','å‘ç¥¨ç¼–å·èŒƒå›´\r\n',0),(196943,5471,'sv','Faktura nummer sortiment',0),(196944,5471,'it','Gamma di numero fattura',0),(196945,5471,'tl','',0),(196946,5471,'th','&#3594;&#3656;&#3623;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(196947,5471,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¶à¥à¤°à¥ƒà¤‚à¤–à¤²à¤¾',0),(196948,5471,'ms','Julat nombor invois',0),(196949,5471,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(196950,5471,'fr','Plage de numÃ©ros de facture',0),(196951,5471,'jp','è«‹æ±‚æ›¸ç•ªå?·ç¯„å›²',0),(196952,5471,'pt','Gama de nÃºmero de factura',0),(196953,5471,'ru','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð½Ð¾Ð¼ÐµÑ€Ð¾Ð² ÑÑ‡ÐµÑ‚Ð°',0),(196954,5471,'es','Factura Rango de NÃºmeros',0),(196955,5471,'de','Rechnung Zahlenbereich',0),(196956,5471,'en','Invoice Number Range',0),(196957,5472,'is','',0),(196958,5472,'dr','Ú†Ø§Ù¾ Ø¯ÙˆØ¨Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(196959,5472,'pr','Ú†Ø§Ù¾ Ø¯ÙˆØ¨Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(196960,5472,'tr','FaturayÄ± yeniden yazdÄ±rÄ±n',0),(196961,5472,'pl','Faktury przedruku',0),(196962,5472,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°',0),(196963,5472,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹',0),(196964,5472,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(196965,5472,'vi','In láº¡i hÃ³a Ä‘Æ¡n',0),(196966,5472,'af','Faktuur Herdruk',0),(196967,5472,'ro','ImprimaÅ£i din nou factura',0),(196968,5472,'et','Arve kordustrÃ¼kk',0),(196969,5472,'si','Ponatis raÄuna',0),(196970,5472,'ba','Faktur cetak ulang',0),(196971,5472,'nl','Factuur herdruk',0),(196972,5472,'fi','Laskun uusintapainoksia',0),(196973,5472,'no','Faktura opptrykk',0),(196974,5472,'da','Faktura genoptryk',0),(196975,5472,'ko','ì²­êµ¬ì„œ ìž¬ë°œí–‰',0),(196976,5472,'he','×”×“×¤×¡×” ×ž×—×“×© ×©×œ ×—×©×‘×•× ×™×ª',0),(196977,5472,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î•Ï€Î±Î½ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(196978,5472,'zh','å‘ç¥¨é‡å°\r\n',0),(196979,5472,'sv','Faktura Reprint',0),(196980,5472,'it','Ristampa fattura',0),(196981,5472,'tl','',0),(196982,5472,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(196983,5472,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£',0),(196984,5472,'ms','Pencetakan semula invois',0),(196985,5472,'ar','Ø·Ø¨Ø¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(196986,5472,'fr','RÃ©impression de la facture',0),(196987,5472,'jp','è«‹æ±‚æ›¸å†?å?°åˆ·',0),(196988,5472,'pt','ReimpressÃ£o da factura',0),(196989,5472,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚Ð°',0),(196990,5472,'es','Factura Reimprimir',0),(196991,5472,'de','Rechnung-Reprint',0),(196992,5472,'en','Invoice Reprint',0),(196993,5473,'is','',0),(196994,5473,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú†Ø§Ù¾ Ø¯ÙˆØ¨Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ±',0),(196995,5473,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú†Ø§Ù¾ Ø¯ÙˆØ¨Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ±',0),(196996,5473,'tr','FaturayÄ± yeni baskÄ± seÃ§imi',0),(196997,5473,'pl','Faktury przedruku wybÃ³r',0),(196998,5473,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ñ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¸Ð·Ð±Ð¾Ñ€',0),(196999,5473,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ Ø§Ù†ØªØ®Ø§Ø¨',0),(197000,5473,'sr','ÐžÐ´Ð°Ð±Ð¸Ñ€ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(197001,5473,'vi','Chá»n In láº¡i hÃ³a Ä‘Æ¡n',0),(197002,5473,'af','Faktuur Herdruk Seleksie',0),(197003,5473,'ro','SelecÅ£ie de imprimaÅ£i din nou factura',0),(197004,5473,'et','Arve kordustrÃ¼kk valik',0),(197005,5473,'si','Ponatis izbira raÄuna',0),(197006,5473,'ba','Faktur cetak ulang pilihan',0),(197007,5473,'nl','Factuur herdruk selectie',0),(197008,5473,'fi','Laskun uusintapainos valinta',0),(197009,5473,'no','Faktura opptrykk utvalg',0),(197010,5473,'da','Faktura genoptryk udvalg',0),(197011,5473,'ko','ì²­êµ¬ì„œ ìž¬ë°œí–‰ ì„ íƒ',0),(197012,5473,'he','×‘×—×™×¨×ª ×”×“×¤×¡×” ×ž×—×“×© ×—×©×‘×•× ×™×ª',0),(197013,5473,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î•Ï€Î±Î½ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÏ€Î¹Î»Î¿Î³Î®',0),(197014,5473,'zh','å‘ç¥¨é‡å°é€‰æ‹©\r\n',0),(197015,5473,'sv','Faktura Reprint urval',0),(197016,5473,'it','Selezione ristampa fattura',0),(197017,5473,'tl','',0),(197018,5473,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(197019,5473,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤šà¤¯à¤¨',0),(197020,5473,'ms','Invois pencetakan semula pilihan',0),(197021,5473,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø·Ø¨Ø¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(197022,5473,'fr','SÃ©lection de rÃ©impression de facture',0),(197023,5473,'jp','è«‹æ±‚æ›¸å†?å?°åˆ·é?¸æŠžè‚¢',0),(197024,5473,'pt','SeleÃ§Ã£o de reimpressÃ£o de nota fiscal',0),(197025,5473,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ ÐŸÐµÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚ÐºÐ°',0),(197026,5473,'es','Factura SelecciÃ³n de ReimpresiÃ³n',0),(197027,5473,'de','Rechnung-Reprint-Auswahl',0),(197028,5473,'en','Invoice Reprint Selection',0),(197029,5474,'is','',0),(197030,5474,'dr','Ú†Ø§Ù¾  ØªÙ…Ø§Ù…  ÙØ§ÙƒØªÙˆØ± Ø¨Ù‡ ØµÙˆØ±Øª Ú¯Ø±ÙˆÙ‡ÙŠ',0),(197031,5474,'pr','Ú†Ø§Ù¾  ØªÙ…Ø§Ù…  ÙØ§ÙƒØªÙˆØ± Ø¨Ù‡ ØµÙˆØ±Øª Ú¯Ø±ÙˆÙ‡ÙŠ',0),(197032,5474,'tr','Gruptaki tÃ¼m faturalarÄ± yazdÄ±rma',0),(197033,5474,'pl','Drukowanie wszystkich faktur w grupie',0),(197034,5474,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð² Ð³Ñ€ÑƒÐ¿Ð°',0),(197035,5474,'ur','Ú¯Ø±ÙˆÙ¾ Ù…ÛŒÚº ØªÙ…Ø§Ù… ÙˆØ¨Ø¬Ù„ÛŒ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(197036,5474,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑÐ²Ð¸Ñ… Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñƒ Ð³Ñ€ÑƒÐ¿Ð¸',0),(197037,5474,'vi','In táº¥t cáº£ hÃ³a Ä‘Æ¡n trong nhÃ³m',0),(197038,5474,'af','Druk alle Fakture in Groep',0),(197039,5474,'ro','ImprimaÅ£i toate facturile Ã®n grup',0),(197040,5474,'et','Prindi kÃµik arved rÃ¼hmas',0),(197041,5474,'si','Natisnete vse raÄune v skupini',0),(197042,5474,'ba','Mencetak semua tagihan dalam kelompok',0),(197043,5474,'nl','Alle facturen in de groep afdrukken',0),(197044,5474,'fi','Tulostaa kaikki laskut ryhmÃ¤ssÃ¤',0),(197045,5474,'no','Skriv ut alle fakturaer i gruppen',0),(197046,5474,'da','Udskrive alle fakturaer i gruppen',0),(197047,5474,'ko','ê·¸ë£¹ì— ìžˆëŠ” ëª¨ë“  ì†¡ìž¥ ì¸ì‡„',0),(197048,5474,'he','×œ×”×“×¤×™×¡ ××ª ×›×œ ×”×—×©×‘×•× ×™×•×ª ×‘×§×‘×•×¦×”',0),(197049,5474,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ ÏŒÎ»Î± Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÏƒÏ„Î·Î½ Î¿Î¼Î¬Î´Î±',0),(197050,5474,'zh','æ‰“å°æ‰€æœ‰å‘ç¥¨ç»„\r\n',0),(197051,5474,'sv','Skriva ut alla fakturor i grupp',0),(197052,5474,'it','Stampare tutte le fatture in gruppo',0),(197053,5474,'tl','',0),(197054,5474,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(197055,5474,'hi','à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤¸à¤­à¥€ à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(197056,5474,'ms','Mencetak semua invois dalam Kumpulan',0),(197057,5474,'ar','Ø·Ø¨Ø§Ø¹Ø© ÙƒØ§ÙØ© Ø§Ù„ÙÙˆØ§ØªÙŠØ± ÙÙŠ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(197058,5474,'fr','Imprimer toutes les factures en groupe',0),(197059,5474,'jp','ã‚°ãƒ«ãƒ¼ãƒ—å†…ã?®å…¨è«‹æ±‚æ›¸ã‚’å?°åˆ·',0),(197060,5474,'pt','Imprimir todas as faturas em grupo',0),(197061,5474,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð²ÑÐµÑ… ÑÑ‡ÐµÑ‚Ð¾Ð² Ð² Ð³Ñ€ÑƒÐ¿Ð¿Ðµ',0),(197062,5474,'es','Imprimir Todos las Facturas en el Grupo',0),(197063,5474,'de','Alle Rechnungen in Gruppe Drucken',0),(197064,5474,'en','Print All Invoices in Group',0),(197065,5475,'is','',0),(197066,5475,'dr','Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(197067,5475,'pr','Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(197068,5475,'tr','YazdÄ±r\'Ä± tÄ±klatÄ±n',0),(197069,5475,'pl','Kliknij opcjÄ™ Print',0),(197070,5475,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿ÐµÑ‡Ð°Ñ‚',0),(197071,5475,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¨Ø·Ø±Ù Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(197072,5475,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° ÐŸÑ€Ð¸Ð½Ñ‚',0),(197073,5475,'vi','Nháº¥n Ä‘á»ƒ In',0),(197074,5475,'af','Kliek om te Druk',0),(197075,5475,'ro','FaceÅ£i clic pe imprimare',0),(197076,5475,'et','Kliki trÃ¼kkimiseks',0),(197077,5475,'si','Kliknite Natisni',0),(197078,5475,'ba','Klik untuk cetak',0),(197079,5475,'nl','Klik op afdrukken',0),(197080,5475,'fi','Klikkaa Tulosta',0),(197081,5475,'no','Klikk for Ã¥ skrive ut',0),(197082,5475,'da','Klik pÃ¥ Udskriv',0),(197083,5475,'ko','ì¸ì‡„ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(197084,5475,'he','×œ×—×¥ ×¢×œ ×”×“×¤×¡',0),(197085,5475,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(197086,5475,'zh','ç‚¹å‡»æ‰“å°\r\n',0),(197087,5475,'sv','Klicka pÃ¥ Skriv ut',0),(197088,5475,'it','Clicca per stampare',0),(197089,5475,'tl','',0),(197090,5475,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3626;&#3633;&#3656;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(197091,5475,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(197092,5475,'ms','Klik untuk cetakan',0),(197093,5475,'ar','Ø£Ù†Ù‚Ø± Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(197094,5475,'fr','Cliquer pour imprimer',0),(197095,5475,'jp','å?°åˆ·ã?™ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯',0),(197096,5475,'pt','Clique para imprimir',0),(197097,5475,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð´Ð»Ñ ÐŸÐµÑ‡Ð°Ñ‚Ð¸',0),(197098,5475,'es','Click para Imprimir',0),(197099,5475,'de','Klicken Sie auf Drucken',0),(197100,5475,'en','Click to Print',0),(197101,5476,'is','',0),(197102,5476,'dr','Ø¨Ø¯ÙˆÙ† Ø¬Ø²Ø¦ÙŠØ§Øª Ø«Ø¨ØªÙŠ',0),(197103,5476,'pr','Ø¨Ø¯ÙˆÙ† Ø¬Ø²Ø¦ÙŠØ§Øª Ø«Ø¨ØªÙŠ',0),(197104,5476,'tr','HiÃ§bir detay giriÅŸ',0),(197105,5476,'pl','Brak szczegÃ³Å‚Ã³w wpisÃ³w',0),(197106,5476,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(197107,5476,'ur','Ú©ÙˆØ¦ÛŒ ØªÙØµÛŒÙ„ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù†ÛÛŒÚº',0),(197108,5476,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð±ÐµÐ· Ð´ÐµÑ‚Ð°Ñ™Ð°',0),(197109,5476,'vi','ChÆ°a nháº­p chi tiáº¿t',0),(197110,5476,'af','Geen Detail Inskrywings',0),(197111,5476,'ro','Nici o intrare de detaliu',0),(197112,5476,'et','Ãœkski Detail kanded',0),(197113,5476,'si','Vnosov ni podrobno',0),(197114,5476,'ba','Tidak ada Detail entri',0),(197115,5476,'nl','Geen Detail posten',0),(197116,5476,'fi','Ei yksityiskohtia merkintÃ¶jÃ¤',0),(197117,5476,'no','Ingen detaljposter',0),(197118,5476,'da','Ingen detalje poster',0),(197119,5476,'ko','ì„¸ë¶€ í•­ëª©ì´ ì—†ìŠµë‹ˆë‹¤.',0),(197120,5476,'he','××™×Ÿ ×¤×™×¨×•×˜ ×¢×¨×›×™',0),(197121,5476,'el','Î”ÎµÎ½ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(197122,5476,'zh','æ²¡æœ‰è¯¦ç»†æ¡ç›®\r\n',0),(197123,5476,'sv','Ingen detalj poster',0),(197124,5476,'it','Nessun dettaglio voci',0),(197125,5476,'tl','',0),(197126,5476,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(197127,5476,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¨à¤¹à¥€à¤‚ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(197128,5476,'ms','Masukan butiran',0),(197129,5476,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ù„Ù„ØªÙØ§ØµÙŠÙ„',0),(197130,5476,'fr','Aucune entrÃ©e de dÃ©tail',0),(197131,5476,'jp','è©³ç´°ã?®å…¥åŠ›ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(197132,5476,'pt','NÃ£o hÃ¡ entradas de detalhe',0),(197133,5476,'ru','ÐÐµÑ‚ Ð´ÐµÑ‚Ð°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(197134,5476,'es','No Entradas Detalladas',0),(197135,5476,'de','Kein Detail-EintrÃ¤ge',0),(197136,5476,'en','No Detail Entries',0),(197137,5477,'is','',0),(197138,5477,'dr','(Ø¨Ø±Ø¯Ø§Ø´ØªÙ† ) Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(197139,5477,'pr','Ø§Ù†ØªØ®Ø§Ø¨ (Ø¨Ø±Ø¯Ø§Ø´ØªÙ† ) Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(197140,5477,'tr','MÃ¼ÅŸteri alma',0),(197141,5477,'pl','OdbiÃ³r klienta',0),(197142,5477,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¿Ð¸ÐºÐ°Ð¿',0),(197143,5477,'ur','Ú©Ø³Ù¹Ù…Ø± Ø§Ù¹Ú¾Ø§ Ù„ÛŒÙ†Ø§',0),(197144,5477,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð¿Ð¸ÐºÐ°Ð¿',0),(197145,5477,'vi','ÄÃ³n KhÃ¡ch hÃ ng',0),(197146,5477,'af','Klant / KliÃ«nt Afhaal',0),(197147,5477,'ro','Client Pickup',0),(197148,5477,'et','Kliendi pikap',0),(197149,5477,'si','Kupec Pickup',0),(197150,5477,'ba','Pelanggan Pickup',0),(197151,5477,'nl','Klant Pickup',0),(197152,5477,'fi','Asiakkaan noudettavissa',0),(197153,5477,'no','Kunden Pickup',0),(197154,5477,'da','Kunde Pickup',0),(197155,5477,'ko','ê³ ê° í”½ì—…',0),(197156,5477,'he','××™×¡×•×£ ×œ×§×•×—×•×ª',0),(197157,5477,'el','Pickup Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(197158,5477,'zh','å®¢æˆ·å–ä»¶\r\n',0),(197159,5477,'sv','Kunden Pickup',0),(197160,5477,'it','Cliente Pickup',0),(197161,5477,'tl','',0),(197162,5477,'th','&#3648;&#3585;&#3655;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(197163,5477,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¬à¤Ÿà¥‹à¤°à¤¨à¤¾',0),(197164,5477,'ms','Pikap pelanggan',0),(197165,5477,'ar','Ø¨ÙŠÙƒ Ø¢Ø¨ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(197166,5477,'fr','Client Pickup',0),(197167,5477,'jp','é¡§å®¢ãƒ”ãƒƒã‚¯ã‚¢ãƒƒãƒ—',0),(197168,5477,'pt','Cliente Pickup',0),(197169,5477,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ð¸ÐºÐ°Ð¿',0),(197170,5477,'es','Cliente Recoger Compras',0),(197171,5477,'de','Kunden-Pickup',0),(197172,5477,'en','Customer Pickup',0),(197173,5478,'is','',0),(197174,5478,'dr','ØªØ­ÙˆÙŠÙ„ Ø¯Ø§Ø¯Ù†  Ø¨Ù‡ ',0),(197175,5478,'pr','ØªØ­ÙˆÙŠÙ„ Ø¯Ø§Ø¯Ù†  Ø¨Ù‡ ',0),(197176,5478,'tr','Teslim et',0),(197177,5478,'pl','DostarczyÄ‡ do',0),(197178,5478,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÑÑ‚ Ð½Ð°',0),(197179,5478,'ur','ÙØ±Ø§ÛÙ…',0),(197180,5478,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð¸',0),(197181,5478,'vi','Chuyá»ƒn tá»›i',0),(197182,5478,'af','Aflewering aan',0),(197183,5478,'ro','Livra',0),(197184,5478,'et','Pakkuda',0),(197185,5478,'si','Dostaviti',0),(197186,5478,'ba','Memberikan kepada',0),(197187,5478,'nl','Leveren aan',0),(197188,5478,'fi','Toimittaa',0),(197189,5478,'no','Levere til',0),(197190,5478,'da','Levere til',0),(197191,5478,'ko','ì— ê²Œ ì „ë‹¬',0),(197192,5478,'he','×œ×”×¢×‘×™×¨',0),(197193,5478,'el','Î Î±ÏÎ±Î´ÏŽÏƒÎµÎ¹',0),(197194,5478,'zh','é€è´§åˆ°\r\n',0),(197195,5478,'sv','Leverera till',0),(197196,5478,'it','Spedire a',0),(197197,5478,'tl','',0),(197198,5478,'th','&#3626;&#3656;&#3591;&#3617;&#3629;&#3610;&#3652;&#3611;&#3607;&#3637;&#3656;&#3652;&#3627;&#3609;',0),(197199,5478,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤¦à¥à¤§à¤¾à¤°',0),(197200,5478,'ms','Menghantar kepada',0),(197201,5478,'ar','ØªØ³Ù„ÙŠÙ… Ø¥Ù„Ù‰',0),(197202,5478,'fr','Livrer Ã ',0),(197203,5478,'jp','å±Šã?‘å…ˆ',0),(197204,5478,'pt','Entregar para',0),(197205,5478,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð²',0),(197206,5478,'es','Entregar a',0),(197207,5478,'de','Liefern an',0),(197208,5478,'en','Deliver to',0),(197209,5479,'is','',0),(197210,5479,'dr','( Ø³Ù¾Ø±Ø¯Ù‡ Ú¯Ø°Ø§Ø´ØªÙ† ) Ø¨Ø§ ÙØ±Ù…Ø§ÛŒØ´',0),(197211,5479,'pr','Ø°Ø®ÙŠØ±Ù‡ Ú©Ø±Ø¯Ù† ( Ø³Ù¾Ø±Ø¯Ù‡ Ú¯Ø°Ø§Ø´ØªÙ† ) Ø¨Ø§ Ø³ÙØ§Ø±Ø´',0),(197212,5479,'tr','Ã–deme emri ile',0),(197213,5479,'pl','ZÅ‚oÅ¼enie zamÃ³wienia',0),(197214,5479,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(197215,5479,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ø³Ø§ØªÚ¾ Ø¬Ù…Ø¹',0),(197216,5479,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° ÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(197217,5479,'vi','Äáº·t cá»c khi Ä‘áº·t hÃ ng',0),(197218,5479,'af','Deposito met orde',0),(197219,5479,'ro','Depozit cu comanda',0),(197220,5479,'et','Hoiuse jÃ¤rjekorras',0),(197221,5479,'si','Depozit z naroÄilom',0),(197222,5479,'ba','Deposit dengan Order',0),(197223,5479,'nl','Storting bij bestelling',0),(197224,5479,'fi','Talletus, jotta',0),(197225,5479,'no','Innskudd med ordre',0),(197226,5479,'da','Indbetaling med ordre',0),(197227,5479,'ko','ì£¼ë¬¸ ìž…ê¸ˆ',0),(197228,5479,'he','×¤×™×§×“×•×Ÿ ×¢× ×¡×“×¨',0),(197229,5479,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÏ„Î· Î´Î¹Î±Ï„Î±Î³Î®',0),(197230,5479,'zh','å­˜æ”¾è®¢è´­\r\n',0),(197231,5479,'sv','InsÃ¤ttning med ordning',0),(197232,5479,'it','Deposito con ordine',0),(197233,5479,'tl','',0),(197234,5479,'th','&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3585;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(197235,5479,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¥‡ à¤¸à¤¾à¤¥ à¤œà¤®à¤¾',0),(197236,5479,'ms','Deposit dengan perintah',0),(197237,5479,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ø¹ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(197238,5479,'fr','DÃ©pÃ´t avec ordonnance',0),(197239,5479,'jp','æ³¨æ–‡ã?¨ã?®é ?ã‚Šé‡‘',0),(197240,5479,'pt','DepÃ³sito com ordem',0),(197241,5479,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð¼',0),(197242,5479,'es','DepÃ³sito con el Orden',0),(197243,5479,'de','Anzahlung bei Bestellung',0),(197244,5479,'en','Deposit With Order',0),(197245,5480,'is','',0),(197246,5480,'dr','ØªØ®Ù…ÙŠÙ†  Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(197247,5480,'pr','ØªØ®Ù…ÙŠÙ†  Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(197248,5480,'tr','Tahmini iÃ§in verilen',0),(197249,5480,'pl','Szacunek dla',0),(197250,5480,'bg','Ð—Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð°Ñ‚Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(197251,5480,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¯ÛŒ Ú¯Ø¦ÛŒ',0),(197252,5480,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð° Ð´Ð°Ð¾ Ð·Ð°',0),(197253,5480,'vi','Dá»± trÃ¹ cho',0),(197254,5480,'af','Skatting Gegee Vir',0),(197255,5480,'ro','Estimare pentru',0),(197256,5480,'et','Antud hinnang',0),(197257,5480,'si','Oceno',0),(197258,5480,'ba','Perkiraan yang diberikan untuk',0),(197259,5480,'nl','Raming gegeven voor',0),(197260,5480,'fi','Arvio annetaan',0),(197261,5480,'no','Estimat gitt For',0),(197262,5480,'da','SkÃ¸n givet til',0),(197263,5480,'ko','ê²¬ì ì— ëŒ€ í•œ ì œê³µ',0),(197264,5480,'he','×”×¢×¨×›×” ×¢×œ',0),(197265,5480,'el','Î•ÎºÏ„Î¯Î¼Î·ÏƒÎ· Î³Î¹Î±',0),(197266,5480,'zh','ä¼°è®¡ç»™å‡º\r\n',0),(197267,5480,'sv','Uppskattning fÃ¶r',0),(197268,5480,'it','Stima dato per',0),(197269,5480,'tl','',0),(197270,5480,'th','&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3651;&#3627;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(197271,5480,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤¿à¤ à¤—à¤',0),(197272,5480,'ms','Anggaran yang diberikan untuk',0),(197273,5480,'ar','ÙˆÙ†Ø¸Ø±Ø§ Ù„ØªÙ‚Ø¯ÙŠØ±',0),(197274,5480,'fr','Estimation fournie pour',0),(197275,5480,'jp','ï½žã?¸ã?®è¦‹ç©?ã‚Š',0),(197276,5480,'pt','Estimativa dada para',0),(197277,5480,'ru','Ð¡Ð¼ÐµÑ‚Ð° Ð½Ð°',0),(197278,5480,'es','Estimado Dado para',0),(197279,5480,'de','SchÃ¤tzung fÃ¼r die',0),(197280,5480,'en','Estimate Given For',0),(197281,5481,'is','',0),(197282,5481,'dr','(Ù…Ø¬ÙˆØ²) ÙØ±Ù…Ø§ÛŒØ´ ',0),(197283,5481,'pr','Ø¨Ù„ÙŠØ·(Ù…Ø¬ÙˆØ²) Ø³ÙØ§Ø±Ø´ ',0),(197284,5481,'tr','SipariÅŸ Bilet',0),(197285,5481,'pl','ZamÃ³wienie biletÃ³w',0),(197286,5481,'bg','Ð ÐµÐ´ Ð±Ð¸Ð»ÐµÑ‚',0),(197287,5481,'ur','ØªØ±ØªÛŒØ¨ Ù¹Ú©Ù¹',0),(197288,5481,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(197289,5481,'vi','VÃ© Ä‘Æ¡n hÃ ng',0),(197290,5481,'af','Orde kaartjie',0),(197291,5481,'ro','Bilet de ordine',0),(197292,5481,'et','Tellimuse Piletite',0),(197293,5481,'si','NaroÄilo vozovnic',0),(197294,5481,'ba','Pesanan Tiket',0),(197295,5481,'nl','Volgorde Ticket',0),(197296,5481,'fi','Tilaa lippu',0),(197297,5481,'no','Bestill billett',0),(197298,5481,'da','Bestil billet',0),(197299,5481,'ko','ì£¼ë¬¸ í‹°ì¼“',0),(197300,5481,'he','×”×–×ž× ×ª ×›×¨×˜×™×¡×™×',0),(197301,5481,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÎ¹ÏƒÎ¹Ï„Î·ÏÎ¯Ï‰Î½',0),(197302,5481,'zh','è®¢è´­æœºç¥¨\r\n',0),(197303,5481,'sv','BestÃ¤lla biljett',0),(197304,5481,'it','Ordine biglietti',0),(197305,5481,'tl','',0),(197306,5481,'th','&#3605;&#3633;&#3659;&#3623;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(197307,5481,'hi','à¤•à¥à¤°à¤® à¤Ÿà¤¿à¤•à¤Ÿ',0),(197308,5481,'ms','Tempahan Tiket',0),(197309,5481,'ar','ØªØ±ØªÙŠØ¨ Ø­Ø¬Ø² Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(197310,5481,'fr','Bon billet',0),(197311,5481,'jp','æ³¨æ–‡ãƒ?ã‚±ãƒƒãƒˆ',0),(197312,5481,'pt','Ordem de passagem',0),(197313,5481,'ru','Ð—Ð°ÐºÐ°Ð· Ð±Ð¸Ð»ÐµÑ‚Ð°',0),(197314,5481,'es','Boleto de Orden',0),(197315,5481,'de','Bestellung Ticket',0),(197316,5481,'en','Order Ticket',0),(197317,5482,'is','',0),(197318,5482,'dr','Ø®Ø¯Ù…Ø§Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(197319,5482,'pr','Ø®Ø¯Ù…Ø§Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(197320,5482,'tr','Gerekli hizmet',0),(197321,5482,'pl','UsÅ‚ugi potrzebne',0),(197322,5482,'bg','Ð£ÑÐ»ÑƒÐ³Ð° Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸',0),(197323,5482,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(197324,5482,'sr','Ð£ÑÐ»ÑƒÐ³Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ',0),(197325,5482,'vi','Dá»‹ch vá»¥ cáº§n',0),(197326,5482,'af','Diens Benodig',0),(197327,5482,'ro','Serviciul necesare',0),(197328,5482,'et','Tellida',0),(197329,5482,'si','Storitev, ki so potrebne',0),(197330,5482,'ba','Layanan yang diperlukan',0),(197331,5482,'nl','Service nodig',0),(197332,5482,'fi','Tarvitsee huoltoa',0),(197333,5482,'no','Tjenesten som er nÃ¸dvendig',0),(197334,5482,'da','Service behov',0),(197335,5482,'ko','ì„œë¹„ìŠ¤ í•„ìš”',0),(197336,5482,'he','× ×“×¨×© ×©×¨×•×ª',0),(197337,5482,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹',0),(197338,5482,'zh','æœåŠ¡æ‰€éœ€\r\n',0),(197339,5482,'sv','TjÃ¤nsten behÃ¶vs',0),(197340,5482,'it','Servizio necessario',0),(197341,5482,'tl','',0),(197342,5482,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(197343,5482,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(197344,5482,'ms','Perkhidmatan yang diperlukan',0),(197345,5482,'ar','Ø§Ù„Ø®Ø¯Ù…Ø© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(197346,5482,'fr','Service requis',0),(197347,5482,'jp','å¿…è¦?ã?ªã‚µãƒ¼ãƒ“ã‚¹',0),(197348,5482,'pt','ServiÃ§o necessÃ¡rio',0),(197349,5482,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ñ‹Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(197350,5482,'es','Servicios Necesitados',0),(197351,5482,'de','Service benÃ¶tigt',0),(197352,5482,'en','Service Needed',0),(197353,5483,'is','',0),(197354,5483,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(197355,5483,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(197356,5483,'tr','Servis sipariÅŸine Ekle',0),(197357,5483,'pl','Dodaj zlecenie serwisowe',0),(197358,5483,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(197359,5483,'ur','Ø®Ø¯Ù…Øª Ú©Û’ Ø­Ú©Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(197360,5483,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(197361,5483,'vi','ThÃªm ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(197362,5483,'af','Diensbestelling Byvoeg',0),(197363,5483,'ro','Adauga comandÄƒ de service',0),(197364,5483,'et','Hooldustellimuse lisamine',0),(197365,5483,'si','Dodaj servisni nalog',0),(197366,5483,'ba','Tambahkan Service Order',0),(197367,5483,'nl','Serviceorder toevoegen',0),(197368,5483,'fi','Huoltotilauksen lisÃ¤Ã¤minen',0),(197369,5483,'no','Serviceordren legge',0),(197370,5483,'da','Serviceordren tilfÃ¸je',0),(197371,5483,'ko','ì„œë¹„ìŠ¤ ì˜¤ë”ì— ì¶”ê°€',0),(197372,5483,'he','×”×•×¡×£ ×”×–×ž× ×ª ×©×¨×•×ª',0),(197373,5483,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÎ½Ï„Î¿Î»Î®Ï‚ Ï„ / Ï…',0),(197374,5483,'zh','æœåŠ¡è®¢å•å¢žåŠ \r\n',0),(197375,5483,'sv','LÃ¤gg till serviceorder',0),(197376,5483,'it','Ordine di servizio aggiungere',0),(197377,5483,'tl','',0),(197378,5483,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(197379,5483,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(197380,5483,'ms','Pesanan Perkhidmatan Tambah',0),(197381,5483,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(197382,5483,'fr','Commande service ajouter',0),(197383,5483,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®è¿½åŠ ',0),(197384,5483,'pt','Ordem de serviÃ§o adicionar',0),(197385,5483,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(197386,5483,'es','Orden de Servicio Agregar',0),(197387,5483,'de','Serviceauftrag hinzufÃ¼gen',0),(197388,5483,'en','Service Order Add',0),(197389,5484,'is','',0),(197390,5484,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(197391,5484,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(197392,5484,'tr','Maddesi notlarÄ±',0),(197393,5484,'pl','Przedmiot uwagi',0),(197394,5484,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸Ñ‚Ðµ',0),(197395,5484,'ur','Ù†ÙˆÙ¹ Ø´Û’',0),(197396,5484,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(197397,5484,'vi','Ghi chÃº hÃ ng',0),(197398,5484,'af','Item Nota\'s',0),(197399,5484,'ro','Element de note',0),(197400,5484,'et','Toote mÃ¤rkused',0),(197401,5484,'si','Element opombe',0),(197402,5484,'ba','Item catatan',0),(197403,5484,'nl','Object notities',0),(197404,5484,'fi','Asian huomautukset',0),(197405,5484,'no','Elementet notater',0),(197406,5484,'da','Vare noter',0),(197407,5484,'ko','í•­ëª© ì°¸ê³ ',0),(197408,5484,'he','×”×¢×¨×•×ª ×¤×¨×™×˜',0),(197409,5484,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(197410,5484,'zh','é¡¹ç›®é™„æ³¨\r\n',0),(197411,5484,'sv','Artikeln noterar',0),(197412,5484,'it','Elemento note',0),(197413,5484,'tl','',0),(197414,5484,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(197415,5484,'hi','à¤†à¤‡à¤Ÿà¤® à¤¨à¥‹à¤Ÿà¥à¤¸',0),(197416,5484,'ms','Nota barang',0),(197417,5484,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„ØµÙ†Ù',0),(197418,5484,'fr','Article Remarques',0),(197419,5484,'jp','å“?ç›®ãƒ¡ãƒ¢',0),(197420,5484,'pt','Notas de item',0),(197421,5484,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(197422,5484,'es','Item Notas',0),(197423,5484,'de','Notizen zum',0),(197424,5484,'en','Item Notes',0),(197425,5485,'is','',0),(197426,5485,'dr','Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯  Ø§Ú¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù†ÙŠØ³Øª ',0),(197427,5485,'pr','Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯  Ø§Ú¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù†ÙŠØ³Øª ',0),(197428,5485,'tr','Stok deÄŸilse boÅŸ bÄ±rakÄ±n',0),(197429,5485,'pl','Pozostaw to pole puste, jeÅ›li nie zapasÃ³w',0),(197430,5485,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð°ÐºÐ¾ Ð½Ðµ Ð¸ Ð¾Ð¿Ð¸Ñ',0),(197431,5485,'ur','Ø®Ø§Ù„ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù†ÛÛŒÚº ØªÙˆ Ú†Ú¾ÙˆÚ‘ Ø¯Ùˆ',0),(197432,5485,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð°ÐºÐ¾ Ð½Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(197433,5485,'vi','Äá»ƒ Trá»‘ng náº¿u KHÃ”NG pháº£i lÃ  hÃ ng trong kho',0),(197434,5485,'af','Laat Oop indien NIE Voorraad',0),(197435,5485,'ro','LÄƒsaÅ£i necompletat dacÄƒ nu de inventar',0),(197436,5485,'et','JÃ¤ta tÃ¼hjaks, kui ei ole inventuuri kaup',0),(197437,5485,'si','Pustite prazno, Äe ni zaloge',0),(197438,5485,'ba','Kosongkan jika tidak persediaan',0),(197439,5485,'nl','Laat leeg indien niet inventaris',0),(197440,5485,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi jos ei varastossa',0),(197441,5485,'no','La stÃ¥ tomt hvis ikke lager',0),(197442,5485,'da','Lad feltet vÃ¦re tomt, hvis ikke lager',0),(197443,5485,'ko','ìž¬ê³  ì—†ìœ¼ë©´ ê³µëž€ ì²˜ë¦¬',0),(197444,5485,'he','×œ×”×©××™×¨ ×¨×™×§ ×× ×œ× ×ž×œ××™',0),(197445,5485,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ ÎµÎ¬Î½ ÏŒÏ‡Î¹ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(197446,5485,'zh','å¦‚æžœæ²¡æœ‰åº“å­˜ç•™ç©ºç™½\r\n',0),(197447,5485,'sv','LÃ¤mna tom om inte inventering',0),(197448,5485,'it','Lasciare vuoto se non per inventario',0),(197449,5485,'tl','',0),(197450,5485,'th','&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3606;&#3657;&#3634;&#3652;&#3617;&#3656;&#3617;&#3637;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;',0),(197451,5485,'hi','à¤¯à¤¦à¤¿ à¤¸à¥‚à¤šà¥€ à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤²à¥€ à¤›à¥‹à¤¡à¤¼',0),(197452,5485,'ms','Tinggalkan kosong jika tidak inventori',0),(197453,5485,'ar','Ø£ØªØ±Ùƒ Ø§Ù„Ø®Ø§Ù†Ø© Ø®Ø§Ù„ÙŠØ© Ø¥Ù† Ù„Ù… ÙŠÙƒÙ† Ø§Ù„ØµÙ†Ù Ù…Ù† Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(197454,5485,'fr','Laisser en blanc si ce n\'est l\'inventaire',0),(197455,5485,'jp','åœ¨åº«ã?§ã?ªã?‘ã‚Œã?°ç©ºæ¬„ã?«ã?—ã?¦ã?Šã??',0),(197456,5485,'pt','Deixe em branco se nÃ£o inventÃ¡rio',0),(197457,5485,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, ÐµÑÐ»Ð¸ Ð½Ðµ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(197458,5485,'es','Dejar en Blanco si NO es Inventario',0),(197459,5485,'de','Leer lassen, wenn nicht Lager',0),(197460,5485,'en','Leave Blank if NOT Inventory',0),(197461,5486,'is','',0),(197462,5486,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡ ',0),(197463,5486,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡ ',0),(197464,5486,'tr','Fulfillment sipariÅŸler',0),(197465,5486,'pl','Realizacja zamÃ³wieÅ„',0),(197466,5486,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(197467,5486,'ur','ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(197468,5486,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(197469,5486,'vi','ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(197470,5486,'af','Uitvoeringsbestellings',0),(197471,5486,'ro','ÃŽndeplinirea comenzilor',0),(197472,5486,'et','Kaubatellimused',0),(197473,5486,'si','Izpolnitev naroÄila',0),(197474,5486,'ba','Pemenuhan Pesanan',0),(197475,5486,'nl','Vervulling Orders',0),(197476,5486,'fi','TÃ¤yttÃ¤minen tilaukset',0),(197477,5486,'no','FullfÃ¸ringen bestillinger',0),(197478,5486,'da','Opfyldelse ordrer',0),(197479,5486,'ko','í–‰ ìˆœì„œ',0),(197480,5486,'he','×ž×™×ž×•×© ×”×–×ž× ×•×ª',0),(197481,5486,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(197482,5486,'zh','å±¥è¡Œè®¢å•\r\n',0),(197483,5486,'sv','Uppfyllelse order',0),(197484,5486,'it','Evasione ordini',0),(197485,5486,'tl','',0),(197486,5486,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(197487,5486,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶',0),(197488,5486,'ms','Perlaksanaan perintah',0),(197489,5486,'ar','Ø·Ù„Ø¨ÙŠØ§Øª',0),(197490,5486,'fr','Commandes produits',0),(197491,5486,'jp','å±¥è¡Œæ³¨æ–‡',0),(197492,5486,'pt','Cumprimento de ordens',0),(197493,5486,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(197494,5486,'es','Ordenes de Cumplimiento',0),(197495,5486,'de','Fulfillment-Bestellungen',0),(197496,5486,'en','Fulfillment Orders',0),(197497,5487,'is','',0),(197498,5487,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ ',0),(197499,5487,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ ',0),(197500,5487,'tr','SipariÅŸ birimi raporu',0),(197501,5487,'pl','ZamÃ³wienia raportu',0),(197502,5487,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(197503,5487,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ø­Ø¬Ù… Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(197504,5487,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(197505,5487,'vi','BÃ¡o cÃ¡o Khá»‘i lÆ°á»£ng Ä‘Æ¡n hÃ ng',0),(197506,5487,'af','Bestelling Volume Verslag',0),(197507,5487,'ro','Raport de volumul comenzii',0),(197508,5487,'et','Tellimuse mahu aruande',0),(197509,5487,'si','Naloga obsega poroÄila',0),(197510,5487,'ba','Urutan Volume laporan',0),(197511,5487,'nl','Volgorde Volume verslag',0),(197512,5487,'fi','Tilausten mÃ¤Ã¤rÃ¤-raportin',0),(197513,5487,'no','Volum rapport',0),(197514,5487,'da','Rapport over volumen',0),(197515,5487,'ko','ì£¼ë¬¸ ë³¼ë¥¨ ë³´ê³ ì„œ',0),(197516,5487,'he','×¡×“×¨ ×›×¨×š ×—',0),(197517,5487,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î¿ ÏŒÎ³ÎºÎ¿Ï‚ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ·',0),(197518,5487,'zh','è®¢å•é‡æŠ¥å‘Š\r\n',0),(197519,5487,'sv','BestÃ¤ll rapporten volym',0),(197520,5487,'it','Report Volume Order',0),(197521,5487,'tl','',0),(197522,5487,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(197523,5487,'hi','à¤†à¤¦à¥‡à¤¶ à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(197524,5487,'ms','Laporan jumlah pesanan',0),(197525,5487,'ar','Ø£Ù…Ø± Ø­Ø¬Ù… Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(197526,5487,'fr','Rapport de Volume de commande',0),(197527,5487,'jp','æ³¨æ–‡å‡ºæ?¥é«˜ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(197528,5487,'pt','RelatÃ³rio de Volume de ordem',0),(197529,5487,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾Ð±ÑŠÐµÐ¼ Ð·Ð°ÐºÐ°Ð·Ð°',0),(197530,5487,'es','Informe de VolÃºmen de Ordenes',0),(197531,5487,'de','Volume-Bericht bestellen',0),(197532,5487,'en','Order Volume Report',0),(197533,5488,'is','',0),(197534,5488,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(197535,5488,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(197536,5488,'tr','Servis sipariÅŸleri',0),(197537,5488,'pl','ZleceÅ„ serwisowych',0),(197538,5488,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(197539,5488,'ur','Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(197540,5488,'sr','ÐÐ°Ð»Ð¾Ð·Ð¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(197541,5488,'vi','ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(197542,5488,'af','Diensbestellings',0),(197543,5488,'ro','Comenzi de service',0),(197544,5488,'et','Hooldustellimuste',0),(197545,5488,'si','Servisne naloge',0),(197546,5488,'ba','Layanan pesanan',0),(197547,5488,'nl','Serviceorders',0),(197548,5488,'fi','Huoltotilaukset',0),(197549,5488,'no','Serviceordrer',0),(197550,5488,'da','Serviceordrer',0),(197551,5488,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸',0),(197552,5488,'he','×”×–×ž× ×•×ª ×©×¨×•×ª',0),(197553,5488,'el','Î•Î½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(197554,5488,'zh','æœåŠ¡è®¢å•\r\n',0),(197555,5488,'sv','Serviceorder',0),(197556,5488,'it','Ordini di servizio',0),(197557,5488,'tl','',0),(197558,5488,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(197559,5488,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶',0),(197560,5488,'ms','Pesanan Perkhidmatan',0),(197561,5488,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(197562,5488,'fr','Commandes services',0),(197563,5488,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡',0),(197564,5488,'pt','Ordens de serviÃ§o',0),(197565,5488,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð½Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(197566,5488,'es','Ordenes de Servicio',0),(197567,5488,'de','ServiceauftrÃ¤ge',0),(197568,5488,'en','Service Orders',0),(197569,5489,'is','',0),(197570,5489,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(197571,5489,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(197572,5489,'tr','Servis sipariÅŸi raporunu',0),(197573,5489,'pl','Raport zamÃ³wienie usÅ‚ugi',0),(197574,5489,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(197575,5489,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(197576,5489,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(197577,5489,'vi','BÃ¡o cÃ¡o Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(197578,5489,'af','Diensbestelling  Verslag',0),(197579,5489,'ro','Raport de comandÄƒ service',0),(197580,5489,'et','Teenuse tellimuse aruanne',0),(197581,5489,'si','PoroÄilo naroÄilo storitev',0),(197582,5489,'ba','Laporan Order Layanan',0),(197583,5489,'nl','Rapport Service Order',0),(197584,5489,'fi','Huoltotilauksen raportti',0),(197585,5489,'no','Tjenesten rapport',0),(197586,5489,'da','Rapport over service',0),(197587,5489,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ë³´ê³ ì„œ',0),(197588,5489,'he','×“×•×— ×”×–×ž× ×ª ×©×¨×•×ª',0),(197589,5489,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± ÏƒÎµÎ¹ÏÎ¬ Î­ÎºÎ¸ÎµÏƒÎ·',0),(197590,5489,'zh','æœåŠ¡è®¢å•æŠ¥å‘Š\r\n',0),(197591,5489,'sv','TjÃ¤nsten BestÃ¤ll rapporten',0),(197592,5489,'it','Relazione di ordine di servizio',0),(197593,5489,'tl','',0),(197594,5489,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(197595,5489,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(197596,5489,'ms','Laporan pesanan Perkhidmatan',0),(197597,5489,'ar','ØªÙ‚Ø±ÙŠØ± Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(197598,5489,'fr','Ã‰tat de commande de service',0),(197599,5489,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(197600,5489,'pt','RelatÃ³rio de ordem de serviÃ§o',0),(197601,5489,'ru','Ð¡Ð»ÑƒÐ¶Ð±Ð° Ð·Ð°ÐºÐ°Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(197602,5489,'es','Informe de Orden de Servicio',0),(197603,5489,'de','Bestellung Servicebericht',0),(197604,5489,'en','Service Order Report',0),(197605,5490,'is','',0),(197606,5490,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(197607,5490,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(197608,5490,'tr','Servis sipariÅŸ birimi ayrÄ±ntÄ±larÄ±',0),(197609,5490,'pl','SzczegÃ³Å‚y wielkoÅ›Ä‡ zamÃ³wienia usÅ‚ugi',0),(197610,5490,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð·Ð° Ð¾Ð±ÐµÐ¼Ð° Ð½Ð° ÑÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(197611,5490,'ur','Ø³Ø±ÙˆØ³ Ú©ÛŒ ØªØ±ØªÛŒØ¨ ØµÙˆØª Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(197612,5490,'sr','Ð¡ÐµÑ€Ð²Ð¸Ñ Ð”ÐµÑ‚Ð°Ñ™Ð¸ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½',0),(197613,5490,'vi','Chi tiáº¿t khá»‘i lÆ°á»£ng ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(197614,5490,'af','Diensbestelling Volume Details',0),(197615,5490,'ro','Serviciu comanda volum detalii',0),(197616,5490,'et','Teenuse tellimuse mahu Ã¼ksikasjad',0),(197617,5490,'si','Podrobnosti o naroÄilu obsega storitev',0),(197618,5490,'ba','Layanan rincian pesanan Volume',0),(197619,5490,'nl','Service Order Volume Details',0),(197620,5490,'fi','Huoltotilauksen aseman tiedot',0),(197621,5490,'no','Tjenesten Ordredetaljer volum',0),(197622,5490,'da','Tjenesten Volume ordreoplysninger',0),(197623,5490,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ë³¼ë¥¨ ì •ë³´',0),(197624,5490,'he','×©×™×¨×•×ª ××—×¡×•×Ÿ Order Details',0),(197625,5490,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÏŒÎ³ÎºÎ¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(197626,5490,'zh','æœåŠ¡è®¢å•é‡è¯¦æƒ…\r\n',0),(197627,5490,'sv','Information om service Order volym',0),(197628,5490,'it','Servizio ordine Volume dettagli',0),(197629,5490,'tl','',0),(197630,5490,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3592;&#3635;&#3609;&#3623;&#3609;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(197631,5490,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤µà¤¿à¤µà¤°à¤£',0),(197632,5490,'ms','Butir-butir jumlah pesanan Perkhidmatan',0),(197633,5490,'ar','Ø®Ø¯Ù…Ø© ØªØ±ØªÙŠØ¨ Ø­Ø¬Ù… Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(197634,5490,'fr','DÃ©tails de la commande Volume service',0),(197635,5490,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡å‡ºæ?¥é«˜è©³ç´°',0),(197636,5490,'pt','Detalhes de Volume de ordem de serviÃ§o',0),(197637,5490,'ru','ÐžÐ±ÑŠÐµÐ¼ Ð´ÐµÑ‚Ð°Ð»Ð¸ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð°',0),(197638,5490,'es','Orden de Servicio Detalles de VolÃºmen',0),(197639,5490,'de','Bestelldetails Band Service',0),(197640,5490,'en','Service Order Volume Details',0),(197641,5491,'is','',0),(197642,5491,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(197643,5491,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(197644,5491,'tr','KarÅŸÄ±lama sipariÅŸi',0),(197645,5491,'pl','Realizacja zamÃ³wienia',0),(197646,5491,'bg','Ð ÐµÐ´ Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(197647,5491,'ur','Ø¢Ø±ÚˆØ± ØªÚ©Ù…ÛŒÙ„',0),(197648,5491,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(197649,5491,'vi','ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(197650,5491,'af','Uitvoeringsbestelling',0),(197651,5491,'ro','ÃŽndeplinirea comenzii',0),(197652,5491,'et','Kaubatellimus',0),(197653,5491,'si','Izpolnitev nalog',0),(197654,5491,'ba','Pemenuhan Order',0),(197655,5491,'nl','Vervulling volgorde',0),(197656,5491,'fi','Suunnitellun tilauksen',0),(197657,5491,'no','Planlagt bestilling',0),(197658,5491,'da','Opfyldelsesordre',0),(197659,5491,'ko','í–‰ ìˆœì„œ',0),(197660,5491,'he','×¡×“×¨ ×”×’×©×ž×”',0),(197661,5491,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(197662,5491,'zh','å±¥è¡Œè®¢å•\r\n',0),(197663,5491,'sv','Uppfyllelseordern',0),(197664,5491,'it','Ordine di evasione',0),(197665,5491,'tl','',0),(197666,5491,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(197667,5491,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶',0),(197668,5491,'ms','Perlaksanaan perintah',0),(197669,5491,'ar','Ø·Ù„Ø¨ÙŠØ©',0),(197670,5491,'fr','Ordre de traitement',0),(197671,5491,'jp','å±¥è¡Œæ³¨æ–‡',0),(197672,5491,'pt','Ordem de cumprimento',0),(197673,5491,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(197674,5491,'es','Orden de Cumplimiento',0),(197675,5491,'de','AusfÃ¼hrungsauftrag',0),(197676,5491,'en','Fulfillment Order',0),(197677,5492,'is','',0),(197678,5492,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(197679,5492,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(197680,5492,'tr','Servis sipariÅŸi',0),(197681,5492,'pl','Zlecenie serwisowe',0),(197682,5492,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(197683,5492,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(197684,5492,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(197685,5492,'vi','ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(197686,5492,'af','Diens Bestel',0),(197687,5492,'ro','ComandÄƒ de service',0),(197688,5492,'et','Teenuse tellimine',0),(197689,5492,'si','Servisni nalog',0),(197690,5492,'ba','Service Order',0),(197691,5492,'nl','Serviceorder',0),(197692,5492,'fi','Huoltotilaus',0),(197693,5492,'no','Serviceordre',0),(197694,5492,'da','Serviceordre',0),(197695,5492,'ko','ì„œë¹„ìŠ¤ ì˜¤ë”',0),(197696,5492,'he','×”×–×ž× ×ª ×©×™×¨×•×ª',0),(197697,5492,'el','Î•Î½Ï„Î¿Î»Î® Ï„ / Ï…',0),(197698,5492,'zh','æœåŠ¡è®¢å•\r\n',0),(197699,5492,'sv','Serviceorder',0),(197700,5492,'it','Ordine di servizio',0),(197701,5492,'tl','',0),(197702,5492,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(197703,5492,'hi','à¤¸à¤°à¥à¤µà¤¿à¤¸ à¤•à¥à¤°à¤®',0),(197704,5492,'ms','Pesanan Perkhidmatan',0),(197705,5492,'ar','Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(197706,5492,'fr','Ordre de service',0),(197707,5492,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡',0),(197708,5492,'pt','Ordem de serviÃ§o',0),(197709,5492,'ru','Ð¡ÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð·',0),(197710,5492,'es','Orden de Servicio',0),(197711,5492,'de','Serviceauftrag',0),(197712,5492,'en','Service Order',0),(197713,5493,'is','',0),(197714,5493,'dr','Ø§Ø¬Ø±Ø§',0),(197715,5493,'pr','Ø§Ø¬Ø±Ø§',0),(197716,5493,'tr','Yerine getirilmesi',0),(197717,5493,'pl','SpeÅ‚nienie',0),(197718,5493,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(197719,5493,'ur','ØªÚ©Ù…ÛŒÙ„',0),(197720,5493,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ',0),(197721,5493,'vi','HOÃ€N THÃ€NH',0),(197722,5493,'af','Uitvoering',0),(197723,5493,'ro','ÃŽmplinirea',0),(197724,5493,'et','MÃ¼Ã¼gitellimusi',0),(197725,5493,'si','Izpolnitev',0),(197726,5493,'ba','Pemenuhan',0),(197727,5493,'nl','Vervulling',0),(197728,5493,'fi','TÃ¤yttÃ¤minen',0),(197729,5493,'no','Oppfyllelse',0),(197730,5493,'da','Opfyldelse',0),(197731,5493,'ko','ì´ í–‰',0),(197732,5493,'he','×”×’×©×ž×”',0),(197733,5493,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ·',0),(197734,5493,'zh','å±¥è¡Œ\r\n',0),(197735,5493,'sv','Uppfyllelse',0),(197736,5493,'it','Adempimento',0),(197737,5493,'tl','',0),(197738,5493,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(197739,5493,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿',0),(197740,5493,'ms','Memenuhi',0),(197741,5493,'ar','ÙˆÙØ§Ø¡',0),(197742,5493,'fr','Fulfillment',0),(197743,5493,'jp','å±¥è¡Œ',0),(197744,5493,'pt','Cumprimento',0),(197745,5493,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ',0),(197746,5493,'es','Cumplimiento',0),(197747,5493,'de','ErfÃ¼llung',0),(197748,5493,'en','Fulfillment',0),(197749,5494,'is','',0),(197750,5494,'dr','Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´',0),(197751,5494,'pr','Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´',0),(197752,5494,'tr','SatÄ±ÅŸ noktalarÄ±',0),(197753,5494,'pl','Punkt sprzedaÅ¼y',0),(197754,5494,'bg','Ð¢Ð¾Ñ‡ÐºÐ° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(197755,5494,'ur','Ù¾ÙˆØ§Ø¦Ù†Ù¹ Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(197756,5494,'sr','ÐŸÐ¾Ð¸Ð½Ñ‚ Ð¾Ñ„ Ð¡Ð°Ð»Ðµ',0),(197757,5494,'vi','Äiá»ƒm BÃ¡n HÃ ng',0),(197758,5494,'af','Punt van Verkope',0),(197759,5494,'ro','Punctul de vÃ¢nzare',0),(197760,5494,'et','MÃ¼Ã¼gikoht',0),(197761,5494,'si','Point of Sale',0),(197762,5494,'ba','Point of Sale',0),(197763,5494,'nl','Point of Sale',0),(197764,5494,'fi','Point of Sale',0),(197765,5494,'no','Point of Sale',0),(197766,5494,'da','Point of Sale',0),(197767,5494,'ko','íŒë§¤ í¬ì¸íŠ¸',0),(197768,5494,'he','×§×•×¤×”',0),(197769,5494,'el','Point of Sale',0),(197770,5494,'zh','é”€å”®ç‚¹\r\n\r\n',0),(197771,5494,'sv','Point of Sale',0),(197772,5494,'it','Punto di vendita',0),(197773,5494,'tl','',0),(197774,5494,'th','&#3592;&#3640;&#3604;&#3586;&#3634;&#3618;',0),(197775,5494,'hi','à¤ªà¥‹à¤‡à¤‚à¤Ÿ à¤‘à¤« à¤¸à¥‡à¤²',0),(197776,5494,'ms','Point of Sale',0),(197777,5494,'ar','Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(197778,5494,'fr','Point de vente',0),(197779,5494,'jp','Counter Order',0),(197780,5494,'pt','Ponto de venda',0),(197781,5494,'ru','Ð¢Ð¾Ñ‡ÐºÐ¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(197782,5494,'es','Punto de Venta',0),(197783,5494,'de','Point of Sale',0),(197784,5494,'en','Point of Sale',0),(197785,5495,'is','',0),(197786,5495,'dr','OH  Ø¹Ø¯Ø¯ ØµÙØ± ..',0),(197787,5495,'pr','OH  Ø¹Ø¯Ø¯ ØµÙØ± ..',0),(197788,5495,'tr','OH',0),(197789,5495,'pl','AHA',0),(197790,5495,'bg','Ðž',0),(197791,5495,'ur','Ø§ÙˆÛ',0),(197792,5495,'sr','ÐžÐ¥',0),(197793,5495,'vi','OH',0),(197794,5495,'af','O',0),(197795,5495,'ro','OH',0),(197796,5495,'et','OH',0),(197797,5495,'si','OH',0),(197798,5495,'ba','OH',0),(197799,5495,'nl','OH',0),(197800,5495,'fi','OH',0),(197801,5495,'no','OH',0),(197802,5495,'da','Ã…H',0),(197803,5495,'ko','ì˜¤ ì˜¤',0),(197804,5495,'he','. ×”×•',0),(197805,5495,'el','Î©',0),(197806,5495,'zh','ä¿„äº¥ä¿„å·ž\r\n',0),(197807,5495,'sv','OH',0),(197808,5495,'it','OH',0),(197809,5495,'tl','',0),(197810,5495,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3651;&#3609;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;',0),(197811,5495,'hi','à¤“à¤¹',0),(197812,5495,'ms','OH',0),(197813,5495,'ar','Ø£ÙˆÙ‡',0),(197814,5495,'fr','OH',0),(197815,5495,'jp','OH',0),(197816,5495,'pt','AH',0),(197817,5495,'ru','OH',0),(197818,5495,'es','OH',0),(197819,5495,'de','OH',0),(197820,5495,'en','OH',0),(197821,5496,'is','',0),(197822,5496,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡(ØªÙƒÙ…ÙŠÙ„ÙŠ',0),(197823,5496,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡(ØªÙƒÙ…ÙŠÙ„ÙŠ',0),(197824,5496,'tr','Yerine getirilmesi sipariÅŸ Ekle/GÃ¼ncelle',0),(197825,5496,'pl','Realizacja zamÃ³wienia dodaÄ‡/aktualizacja',0),(197826,5496,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(197827,5496,'ur','Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(197828,5496,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(197829,5496,'vi','ThÃªm/Cáº­p Nháº­t ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(197830,5496,'af','Uitvoeringsbestelling Byvoeg/Opdateer',0),(197831,5496,'ro','Adauga/Actualizeaza Comanda Client cu livrare',0),(197832,5496,'et','Lisa/Uuenda kaubatellimust',0),(197833,5496,'si','Izpolnitev nalog Dodaj/posodobi',0),(197834,5496,'ba','Tambah/Ganti Pemenuhan Pesanan',0),(197835,5496,'nl','Vervulling Order toevoegen/bijwerken',0),(197836,5496,'fi','TÃ¤yttÃ¤minen aste lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(197837,5496,'no','Oppfyllelse for Legg til/Oppdater',0),(197838,5496,'da','Opfyldelse rÃ¦kkefÃ¸lge TilfÃ¸j/opdater',0),(197839,5496,'ko','ì„±ì·¨ë¥¼ ìˆœì„œë¥¼ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(197840,5496,'he','×”×¡×“×¨ ×©×œ ×”×’×©×ž×” ×”×•×¡×£/×¢×“×›×Ÿ',0),(197841,5496,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(197842,5496,'zh','å¢žåŠ /æ›´æ–°å±¥è¡Œè®¢å•\r\n',0),(197843,5496,'sv','TillfredsstÃ¤llelse fÃ¶r LÃ¤gg till/uppdatera',0),(197844,5496,'it','Evasione ordine aggiungere/aggiornare',0),(197845,5496,'tl','',0),(197846,5496,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3634;&#3617;&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&',0),(197847,5496,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(197848,5496,'ms','Memenuhi perintah Tambah/Kemaskini',0),(197849,5496,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø·Ù„Ø¨ÙŠØ©',0),(197850,5496,'fr','Fulfillment ordre ajouter/mettre Ã  jour',0),(197851,5496,'jp','é?”æˆ?æ³¨æ–‡ã€€è¿½åŠ /æ›´æ–°',0),(197852,5496,'pt','Ordem de realizaÃ§Ã£o adicionar/atualizar',0),(197853,5496,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(197854,5496,'es','Pedido de Cumplimiento Agregar/Actualizar',0),(197855,5496,'de','ErfÃ¼llung Auftrag hinzufÃ¼gen/aktualisieren',0),(197856,5496,'en','Fulfillment Order Add/Update',0),(197857,5497,'is','',0),(197858,5497,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø¯Ù…Ø§Øª ',0),(197859,5497,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(197860,5497,'tr','Servis sipariÅŸi Ekle/GÃ¼ncelle',0),(197861,5497,'pl','ZamÃ³wienie usÅ‚ugi Dodaj/Aktualizuj',0),(197862,5497,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(197863,5497,'ur','Ø®Ø¯Ù…Øª Ú©Û’ Ø­Ú©Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(197864,5497,'sr','Ð£ÑÐ»ÑƒÐ³Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(197865,5497,'vi','ThÃªm/Cáº­p Nháº­t ÄÆ¡n Äáº·t HÃ ng Dá»‹ch Vá»¥',0),(197866,5497,'af','Diensbestelling Byvoeg/Opdateer',0),(197867,5497,'ro','Adauga/Actualizeaza comanda service',0),(197868,5497,'et','Teenuse tellimuse lisamine/uuendamine',0),(197869,5497,'si','Servisni nalog Dodaj/posodobi',0),(197870,5497,'ba','Layanan pesanan Tambahkan/Perbarui',0),(197871,5497,'nl','Service Order toevoegen/bijwerken',0),(197872,5497,'fi','Palvelun tilauksen lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(197873,5497,'no','Tjenesten for Legg til/Oppdater',0),(197874,5497,'da','Service rÃ¦kkefÃ¸lge TilfÃ¸j/opdater',0),(197875,5497,'ko','ì„œë¹„ìŠ¤ë¥¼ ìˆœì„œë¥¼ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(197876,5497,'he','×”×–×ž× ×ª ×©×™×¨×•×ª ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(197877,5497,'el','Î¤Î¬Î¾Î· Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(197878,5497,'zh','å¢žåŠ /æ›´æ–°æœåŠ¡è®¢å•\r\n',0),(197879,5497,'sv','Service bestÃ¤llning LÃ¤gg till/uppdatera',0),(197880,5497,'it','Servizio ordine aggiungere/aggiornare',0),(197881,5497,'tl','',0),(197882,5497,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(197883,5497,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(197884,5497,'ms','Perkhidmatan Pesanan Tambah/Kemaskini',0),(197885,5497,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(197886,5497,'fr','Service commande Ajouter/mettre Ã  jour',0),(197887,5497,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã€€è¿½åŠ /æ›´æ–°',0),(197888,5497,'pt','Ordem de serviÃ§o adicionar/atualizar',0),(197889,5497,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð· Ð±Ð¸Ð»ÐµÑ‚Ð¾Ð²',0),(197890,5497,'es','Orden de Servicio Agregar/Actualizar',0),(197891,5497,'de','Service Bestellung hinzufÃ¼gen/aktualisieren',0),(197892,5497,'en','Service Order Add/Update',0),(197893,5498,'is','',0),(197894,5498,'dr','Ø«Ø¨Øª Ùˆ  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡',0),(197895,5498,'pr','Ø«Ø¨Øª Ùˆ  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡',0),(197896,5498,'tr','Girin ve Fulfillment sipariÅŸler gÃ¼ncelleÅŸtirin',0),(197897,5498,'pl','Wprowadzania i aktualizacji realizacji zamÃ³wieÅ„',0),(197898,5498,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(197899,5498,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Ø§ÙˆØ± ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(197900,5498,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(197901,5498,'vi','Nháº­p & cáº­p nháº­t ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(197902,5498,'af','Invoer en Opdateer van Uitvoeringsbestelling',0),(197903,5498,'ro','IntroduceÅ£i ÅŸi actualizaÅ£i comenzile de Ã®mplinire',0),(197904,5498,'et','Sisesta ja uuenda kaubatellimusi',0),(197905,5498,'si','Vnesete in posodobite izpolnitev naroÄila',0),(197906,5498,'ba','Masukkan dan Ganti Pemenuhan Pesanan',0),(197907,5498,'nl','Invoeren en bijwerken van vervulling Orders',0),(197908,5498,'fi','Vakiokustannus syÃ¶tetÃ¤Ã¤n ja pÃ¤ivitetÃ¤Ã¤n tÃ¤yttÃ¤minen tilaukset',0),(197909,5498,'no','Angi og Oppdatere oppfyllelse ordrer',0),(197910,5498,'da','Indtaste og opdatere opfyldelse ordrer',0),(197911,5498,'ko','ìž…ë ¥ ë° ì„±ì·¨ ì£¼ë¬¸ ì—…ë°ì´íŠ¸',0),(197912,5498,'he','×œ×”×–×™×Ÿ ×•×œ×¢×“×›×Ÿ ×ž×™×ž×•×© ×”×–×ž× ×•×ª',0),(197913,5498,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ ÎºÎ±Î¹ ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÏ„Îµ Ï„Î·Î½ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(197914,5498,'zh','å±¥è¡Œè®¢å•è¾“å…¥å’Œæ›´æ–°\r\n',0),(197915,5498,'sv','Ange och uppdatera uppfyllelse order',0),(197916,5498,'it','Inserire e aggiornare gli ordini di adempimento',0),(197917,5498,'tl','',0),(197918,5498,'th','&#3611;&#3657;&#3629;&#3609;&#3649;&#3621;&#3632;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(197919,5498,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(197920,5498,'ms','Memasukkan dan mengemaskini memenuhi pesanan',0),(197921,5498,'ar','Ø¥Ø¯Ø®Ø§Ù„ ÙˆØªØ­Ø¯ÙŠØ« Ø£ÙˆØ§Ù…Ø± Ø§Ù„ÙˆÙØ§Ø¡',0),(197922,5498,'fr','Saisir et dâ€™actualiser des ordres',0),(197923,5498,'jp','å±¥è¡Œæ³¨æ–‡ã?®å…¥åŠ›ã?¨æ›´æ–°',0),(197924,5498,'pt','Inserir e atualizar o cumprimento de ordens',0),(197925,5498,'ru','Ð’Ð²Ð¾Ð´ Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(197926,5498,'es','Introducir y Actualizar Pedidos de Cumplimiento',0),(197927,5498,'de','Eingabe und Aktualisierung Fulfillment-Bestellungen',0),(197928,5498,'en','Enter and Update Fulfillment Orders',0),(197929,5499,'is','',0),(197930,5499,'dr','Ø«Ø¨Øª Ùˆ  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(197931,5499,'pr','Ø«Ø¨Øª Ùˆ  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(197932,5499,'tr','Girin ve servis sipariÅŸlerini gÃ¼ncelleÅŸtirme',0),(197933,5499,'pl','WprowadÅº i aktualizowanie zleceÅ„ serwisowych',0),(197934,5499,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(197935,5499,'ur','Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø®Ø¯Ù…Øª Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(197936,5499,'sr','Ð£Ð½Ð¾Ñ Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(197937,5499,'vi','Nháº­p & cáº­p nháº­t Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥',0),(197938,5499,'af','Invoer en Opdateer van Nuwe Diensbestellings',0),(197939,5499,'ro','IntroduceÅ£i ÅŸi actualizaÅ£i comenzile de Service',0),(197940,5499,'et','Sisesta ja uuenda teenusetellimusi',0),(197941,5499,'si','Vnesete in posodobite servisnih nalogov',0),(197942,5499,'ba','Buat dan Koreksi Layanan Pesanan',0),(197943,5499,'nl','Invoeren en bijwerken van serviceorders',0),(197944,5499,'fi','SyÃ¶tÃ¤ ja pÃ¤ivitÃ¤ huoltotilauksia',0),(197945,5499,'no','Angi og oppdatere serviceordrer',0),(197946,5499,'da','Indtaste og opdatere serviceordrer',0),(197947,5499,'ko','ìž…ë ¥ ë° ì„œë¹„ìŠ¤ ì£¼ë¬¸ ì—…ë°ì´íŠ¸',0),(197948,5499,'he','×”×›× ×¡ ×•×¢×“×›×Ÿ ×”×–×ž× ×•×ª ×©×¨×•×ª',0),(197949,5499,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ ÎºÎ±Î¹ Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Ï„Î¹Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„/Ï…',0),(197950,5499,'zh','è¾“å…¥å’Œæ›´æ–°æœåŠ¡è®¢å•',0),(197951,5499,'sv','Ange och uppdatera serviceorder',0),(197952,5499,'it','Inserire e aggiornare gli ordini di servizio',0),(197953,5499,'tl','',0),(197954,5499,'th','&#3611;&#3657;&#3629;&#3609;&#3649;&#3621;&#3632;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(197955,5499,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶',0),(197956,5499,'ms','Memasukkan dan mengemaskini perkhidmatan pesanan',0),(197957,5499,'ar','Ø¥Ø¯Ø®Ø§Ù„ ÙˆØªØ­Ø¯ÙŠØ« Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(197958,5499,'fr','Entrer et changer commandes services nouvelle',0),(197959,5499,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®å…¥åŠ›ã?¨æ›´æ–°',0),(197960,5499,'pt','Inserir e atualizar de ordens de serviÃ§o',0),(197961,5499,'ru','Ð’Ð²Ð¾Ð´ Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(197962,5499,'es','Introducir y Actualizar Pedidos de Servicio',0),(197963,5499,'de','Eingeben und Aktualisieren von ServiceauftrÃ¤gen',0),(197964,5499,'en','Enter and Update Service Orders',0),(197965,5500,'is','',0),(197966,5500,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø®ÙˆØ¯ Ø±Ø§ Ø§Ø² Ø§ÙŠÙ†Ø¬Ø§ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(197967,5500,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø®ÙˆØ¯ Ø±Ø§ Ø§Ø² Ø§ÙŠÙ†Ø¬Ø§ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(197968,5500,'tr','ParÃ§a, mÃ¼ÅŸterilere',0),(197969,5500,'pl','UtwÃ³r klientÃ³w tutaj',0),(197970,5500,'bg','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ñ‚ÑƒÐº',0),(197971,5500,'ur','Ø¢Ù¾ Ú©Û’ Ú¯Ø§ÛÚ©ÙˆÚº Ú©Ùˆ ÛŒÛØ§Úº Ú©Û’ Ù¹Ø±ÛŒÚ©',0),(197972,5500,'sr','ÐŸÐ¾Ñ˜Ð°Ð¼ Ð¾ ÐºÑƒÐ¿Ñ†Ð¸Ð¼Ð° Ð¾Ð²Ð´Ðµ',0),(197973,5500,'vi','Theo dÃµi KhÃ¡ch hÃ ng cá»§a báº¡n á»Ÿ Ä‘Ã¢y',0),(197974,5500,'af','Opsporing van Klant / KliÃ«nt hier',0),(197975,5500,'ro','Piesa de clienÅ£ii dumneavoastrÄƒ aici',0),(197976,5500,'et','Track teie kliendid',0),(197977,5500,'si','Track vaÅ¡ih strank tukaj',0),(197978,5500,'ba','Melacak pelanggan Anda di sini',0),(197979,5500,'nl','Spoor van uw klanten hier',0),(197980,5500,'fi','Seurata asiakkaita tÃ¤Ã¤llÃ¤',0),(197981,5500,'no','Oversikt over kundene her',0),(197982,5500,'da','Styr pÃ¥ dine kunder her',0),(197983,5500,'ko','ì—¬ê¸°ì— ê·€í•˜ì˜ ê³ ê°ì˜ íŠ¸ëž™',0),(197984,5500,'he','×ž×¢×§×‘ ××—×¨×™ ×”×œ×§×•×—×•×ª ×›××Ÿ',0),(197985,5500,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹ Ï„Ï‰Î½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ ÏƒÎ±Ï‚ ÎµÎ´ÏŽ',0),(197986,5500,'zh','åœ¨è¿™é‡Œè·Ÿè¸ªæ‚¨çš„å®¢æˆ·\r\n',0),(197987,5500,'sv','Koll pÃ¥ dina kunder hÃ¤r',0),(197988,5500,'it','Segui qui il tuo cliente',0),(197989,5500,'tl','',0),(197990,5500,'th','&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;',0),(197991,5500,'hi','à¤¯à¤¹à¤¾à¤ à¤…à¤ªà¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¤¾ à¤Ÿà¥à¤°à¥ˆà¤•',0),(197992,5500,'ms','Trek daripada pelanggan-pelanggan anda di sini',0),(197993,5500,'ar','Ø§Ù„Ù…Ø³Ø§Ø± Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù‡Ù†Ø§',0),(197994,5500,'fr','Piste de vos clients ici',0),(197995,5500,'jp','Track of Your Customers Here',0),(197996,5500,'pt','Faixa de seus clientes aqui',0),(197997,5500,'ru','Ð¢Ñ€ÐµÐº Ð²Ð°ÑˆÐ¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(197998,5500,'es','Trazar Sus Clientes Aqui',0),(197999,5500,'de','Ãœberblick Ã¼ber Ihre Kunden hier',0),(198000,5500,'en','Track of Your Customers Here',0),(198001,5501,'is','',0),(198002,5501,'dr','Ø¯Ø±ØµØ¯ Ø§Ø¶Ø§ÙÙŠ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ â€“ Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø¯Ù…Ø§Øª',0),(198003,5501,'pr','Ø¯Ø±ØµØ¯ Ø§Ø¶Ø§ÙÙŠ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ â€“ Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø¯Ù…Ø§Øª',0),(198004,5501,'tr','Ãœcret eklemek iÃ§in saÃ§aklar %<br><small>(servis sipariÅŸi maliyetleri iÃ§in)</small>',0),(198005,5501,'pl','Marginesie % aby dodaÄ‡ do wynagrodzenia<br><small>(do kosztÃ³w zamÃ³wienia)</small>',0),(198006,5501,'bg','Ð ÐµÑÐ½Ð¸ %, Ð·Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ ÐºÑŠÐ¼ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ<br><small>(Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·)</small>',0),(198007,5501,'ur','Ø¬Ú¾Ø§Ù„Ø± % Ú©Û’ Ù„Ø¦Û’ Ø§Ø¬Ø±Øª Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’<br><small>(Ø®Ø¯Ù…Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©Û’ Ù„Ø¦Û’)</small>',0),(198008,5501,'sr','Ð ÐµÑÐµ % Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ<br><small>(Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ ÑÐµÑ€Ð²Ð¸ÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°)</small>',0),(198009,5501,'vi','%Trá»£ cáº¥p cá»™ng vÃ o lÆ°Æ¡ng(cho giÃ¡ thÃ nh Ä‘Æ¡n hÃ ng dá»‹ch vá»¥)',0),(198010,5501,'af','Fraiings % by lone<br><small>(vir diens bestel koste)</small>',0),(198011,5501,'ro','Franjuri % pentru a adÄƒuga la salariile<br><small>(pentru costurile de comandÄƒ Service)</small>',0),(198012,5501,'et','Narmad % lisamiseks palk<br><small>(jaoks hooldustellimuse hooldusmaksumused)</small>',0),(198013,5501,'si','Resice % dodati plaÄe<br><small>(za stroÅ¡ke servisa naloga)</small>',0),(198014,5501,'ba','Pinggiran % untuk menambah upah<br><small>(biaya layanan pesanan)</small>',0),(198015,5501,'nl','Marge % toe te voegen aan lonen<br><small>(voor bestelling servicekosten)</small>',0),(198016,5501,'fi','Hapsut % lisÃ¤Ã¤ palkkaa<br><small>(ja tilauksen huoltokustannukset)</small>',0),(198017,5501,'no','Utkanten % legge til lÃ¸nn<br><small>(for ordre servicekostnader)</small>',0),(198018,5501,'da','Frynser % fÃ¸je til lÃ¸n<br><small>(for serviceomkostninger)</small>',0),(198019,5501,'ko','ë³€ë‘ë¦¬ % ìž„ê¸ˆì— ì¶”ê°€ í•˜ë ¤ë©´<br><small>(ì„œë¹„ìŠ¤ ì£¼ë¬¸ ë¹„ìš©)ì— ëŒ€ í•œ</small>',0),(198020,5501,'he','×‘×©×•×œ×™ % ×›×“×™ ×œ×”×•×¡×™×£ ×œ×©×›×¨<br><small>(×¢×‘×•×¨ ×©×™×¨×•×ª ×”×¡×“×¨ ×¢×œ×•×™×•×ª)</small>',0),(198021,5501,'el','% Î ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÏƒÎµ Î¼Î¹ÏƒÎ¸Î¿ÏÏ‚<br><small>(Î³Î¹Î± Ï„Î·Î½ Ï…Ï€Î·ÏÎµÏƒÎ¯Î± ÎºÎ¿ÏƒÏ„Î¯Î¶ÎµÎ¹ Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±)</small>',0),(198022,5501,'zh','é™„åŠ ï¼…æ–°å¢žåˆ°å·¥èµ„ï¼ˆæœåŠ¡è®¢è´­è´¹ç”¨ï¼‰\r\n',0),(198023,5501,'sv','Fransar % att lÃ¤gga till lÃ¶ner<br><small>(fÃ¶r bestÃ¤llning servicekostnader)</small>',0),(198024,5501,'it','Frange % aggiungere agli stipendi<br><small>(per costi di ordine di servizio)</small>',0),(198025,5501,'tl','',0),(198026,5501,'th','&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3607;&#3637;&#3656;&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3627;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3656;&#3634;&#3649;&#3619;&#3591; <small>(&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&',0),(198027,5501,'hi','à¤•à¤¿à¤¨à¤¾à¤°à¥‡ % à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤<br><small>(à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¤¤ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶)</small>',0),(198028,5501,'ms','Pinggiran % untuk menambah kepada upah<br><small>(untuk kos pesanan Perkhidmatan)</small>',0),(198029,5501,'ar','% Ù‡Ø§Ù…Ø´ Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø§Ù„Ø£Ø¬ÙˆØ±<br><small>(Ø¨Ø§Ù„Ù†Ø³Ø¨Ø© Ù„ØªÙƒØ§Ù„ÙŠÙ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©)</small>',0),(198030,5501,'fr','Franges % Ã  ajouter aux salaires<br><small>(pour les coÃ»ts de commande de Service)</small>',0),(198031,5501,'jp','ãƒžãƒ¼ã‚¸ãƒ³ã?Œè³ƒé‡‘ã?«è¿½åŠ ã?•ã‚Œã?¾ã?™<br><small>(ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡è²»ç”¨ã?®ã?Ÿã‚?)</small>',0),(198032,5501,'pt','% De margem para adicionar a salÃ¡rios<br><small>(para os custos de ordem de serviÃ§o)</small>',0),(198033,5501,'ru','ÐŸÐµÑ€Ð¸Ñ„ÐµÑ€Ð¸Ð¸ % Ð´Ð»Ñ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹<br><small>(Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÑƒÑÐ»ÑƒÐ³Ð¸)</small>',0),(198034,5501,'es','Margen% a Agregar a Sueldos<br><chico>(para Costos de Ordenes de Servicio</chico>',0),(198035,5501,'de','Fransen % hinzu, LÃ¶hne<br><small>(fÃ¼r Bestellung Servicekosten)</small>',0),(198036,5501,'en','Fringes% to Add to Wages<br><small>(for Service Order Costs)</small>',0),(198037,5502,'is','',0),(198038,5502,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ ',0),(198039,5502,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ ',0),(198040,5502,'tr','KarÅŸÄ±lama sipariÅŸi ekle',0),(198041,5502,'pl','Realizacja zamÃ³wienia dodaÄ‡',0),(198042,5502,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€ÐµÐ´ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(198043,5502,'ur','Ø¢Ø±ÚˆØ± ØªÚ©Ù…ÛŒÙ„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(198044,5502,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ',0),(198045,5502,'vi','ThÃªm ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(198046,5502,'af','Uitvoeringsbestelling Byvoeg',0),(198047,5502,'ro','Adauga Ã®ndeplinirea comenzii',0),(198048,5502,'et','Kaubatellimuse lisamine',0),(198049,5502,'si','Dodaj izpolnitev nalog',0),(198050,5502,'ba','Tambahkan pemenuhan Order',0),(198051,5502,'nl','Vervulling Order toevoegen',0),(198052,5502,'fi','Suunnitellun tilauksen lisÃ¤Ã¤minen',0),(198053,5502,'no','Innfrielsesordren legge',0),(198054,5502,'da','Opfyldelsesordre tilfÃ¸je',0),(198055,5502,'ko','í–‰ ìˆœì„œ ì¶”ê°€',0),(198056,5502,'he','×ž×™×ž×•×© ×”×¡×“×¨ ×œ×”×•×¡×™×£',0),(198057,5502,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(198058,5502,'zh','æ–°å¢žå±¥è¡Œè®¢å•\r\n',0),(198059,5502,'sv','Uppfyllelseordern lÃ¤gga till',0),(198060,5502,'it','Aggiungi ordine di evasione',0),(198061,5502,'tl','',0),(198062,5502,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(198063,5502,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(198064,5502,'ms','Tambah memenuhi perintah',0),(198065,5502,'ar','Ø¥Ø¶Ø§ÙØ© Ø·Ù„Ø¨ÙŠØ©',0),(198066,5502,'fr','Ajouter des ordres de traitement',0),(198067,5502,'jp','å±¥è¡Œæ³¨æ–‡ã?®è¿½åŠ ',0),(198068,5502,'pt','Adicionar o ordem de cumprimento',0),(198069,5502,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(198070,5502,'es','Agregar Orden de Cumplimiento',0),(198071,5502,'de','Bestellvorschlag hinzufÃ¼gen',0),(198072,5502,'en','Fulfillment Order Add',0),(198073,5503,'is','',0),(198074,5503,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø±Ù‡Ø§ÙŠ Ø¨ÙŠØ´ØªØ± ',0),(198075,5503,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø±Ù‡Ø§ÙŠ Ø¨ÙŠØ´ØªØ± ',0),(198076,5503,'tr','SatÄ±r Ekle',0),(198077,5503,'pl','DodaÄ‡ wiÄ™cej linii',0),(198078,5503,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ñ€ÐµÐ´Ð¾Ð²Ðµ',0),(198079,5503,'ur','Ù…Ø²ÛŒØ¯ Ù„Ø§Ø¦Ù†ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(198080,5503,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ð¸ÑˆÐµ Ñ€ÐµÐ´Ð¾Ð²Ð°',0),(198081,5503,'vi','ThÃªm DÃ²ng',0),(198082,5503,'af','Meer Lyne Byvoeg',0),(198083,5503,'ro','Adauga mai multe randuri',0),(198084,5503,'et','Lisa ridu',0),(198085,5503,'si','Dodajte veÄ linij',0),(198086,5503,'ba','Tambahkan baris lain',0),(198087,5503,'nl','Meer regels toevoegen',0),(198088,5503,'fi','LisÃ¤tÃ¤ rivejÃ¤',0),(198089,5503,'no','Legge til flere linjer',0),(198090,5503,'da','TilfÃ¸je flere linjer',0),(198091,5503,'ko','ë” ë§Žì€ ë¼ì¸ì„ ì¶”ê°€',0),(198092,5503,'he','×”×•×¡×£ ×¢×•×“ ×©×•×¨×•×ª',0),(198093,5503,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Î³ÏÎ±Î¼Î¼Î­Ï‚',0),(198094,5503,'zh','å¢žåŠ æ›´å¤šè¡Œ\r\n',0),(198095,5503,'sv','LÃ¤gga till fler rader',0),(198096,5503,'it','Aggiungere ulteriori righe',0),(198097,5503,'tl','',0),(198098,5503,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3609;&#3637;&#3657;',0),(198099,5503,'hi','à¤…à¤§à¤¿à¤• à¤ªà¤‚à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(198100,5503,'ms','Tambah lagi laluan',0),(198101,5503,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ø³Ø·Ø± Ø®Ø±Ù‰',0),(198102,5503,'fr','Ajouter plus de Lignes',0),(198103,5503,'jp','ãƒ©ã‚¤ãƒ³ã?®è¿½åŠ ',0),(198104,5503,'pt','Adicionar mais linhas',0),(198105,5503,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¡Ñ‚Ñ€Ð¾ÐºÐ¸',0),(198106,5503,'es','Agregar MÃ¡s LÃ­neas',0),(198107,5503,'de','FÃ¼gen Sie weitere Zeilen',0),(198108,5503,'en','Add More Lines',0),(198109,5504,'is','',0),(198110,5504,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(198111,5504,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(198112,5504,'tr','KarÅŸÄ±lama sipariÅŸi gÃ¼ncelleÅŸtirmesi',0),(198113,5504,'pl','Realizacja zamÃ³wienia aktualizacji',0),(198114,5504,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(198115,5504,'ur','Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(198116,5504,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(198117,5504,'vi','Cáº­p nháº­t ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(198118,5504,'af','Uitvoeringsbestelling Opdatering',0),(198119,5504,'ro','Actualizare de ordinea Ã®mplinirea',0),(198120,5504,'et','Kaubatellimuse uuendamine',0),(198121,5504,'si','Izpolnitve nalog posodobitev',0),(198122,5504,'ba','Pemenuhan Order Update',0),(198123,5504,'nl','Vervulling volgorde Update',0),(198124,5504,'fi','TÃ¤yttÃ¤minen pÃ¤ivitys',0),(198125,5504,'no','Oppfyllelsen ordreoppdatering',0),(198126,5504,'da','Opfyldelse ordrevedligeholdelse',0),(198127,5504,'ko','í–‰ ì£¼ë¬¸ ì—…ë°ì´íŠ¸',0),(198128,5504,'he','×¢×“×›×•×Ÿ ×”×–×ž× ×” ×”×’×©×ž×”',0),(198129,5504,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Î´Î¹Î¬Ï„Î±Î¾Î· Update',0),(198130,5504,'zh','å®Œæˆè®¢è´­æ›´æ–°\r\n',0),(198131,5504,'sv','Uppfyllelse orderuppdatering',0),(198132,5504,'it','Aggiornamento ordine di adempimento',0),(198133,5504,'tl','',0),(198134,5504,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(198135,5504,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(198136,5504,'ms','Memenuhi perintah Kemaskini',0),(198137,5504,'ar','ØªØ­Ø¯ÙŠØ« Ø·Ù„Ø¨ÙŠØ©',0),(198138,5504,'fr','Mise Ã  jour de la commande Fulfillment',0),(198139,5504,'jp','å±¥è¡Œæ³¨æ–‡ã?®æ›´æ–°',0),(198140,5504,'pt','AtualizaÃ§Ã£o de ordem de cumprimento',0),(198141,5504,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(198142,5504,'es','Orden de Cumplimiento Actualizar',0),(198143,5504,'de','ErfÃ¼llung-Auftrag-Update',0),(198144,5504,'en','Fulfillment Order Update',0),(198145,5505,'is','',0),(198146,5505,'dr','Ø³Ø·Ø±Ù‡Ø§ÙŠ Ø¨ÙŠØ´ØªØ±',0),(198147,5505,'pr','Ø³Ø·Ø±Ù‡Ø§ÙŠ Ø¨ÙŠØ´ØªØ±',0),(198148,5505,'tr','Daha fazla Ã§izgi',0),(198149,5505,'pl','WiÄ™cej linii',0),(198150,5505,'bg','ÐŸÐ¾Ð²ÐµÑ‡Ðµ Ð»Ð¸Ð½Ð¸Ð¸',0),(198151,5505,'ur','Ù…Ø²ÛŒØ¯ Ù„Ø§Ø¦Ù†ÛŒÚº',0),(198152,5505,'sr','Ð’Ð¸ÑˆÐµ Ñ€ÐµÐ´Ð¾Ð²Ð°',0),(198153,5505,'vi','ThÃªm dÃ²ng',0),(198154,5505,'af','Meer Lyne',0),(198155,5505,'ro','Mai multe linii',0),(198156,5505,'et','Veel ridu',0),(198157,5505,'si','VeÄ vrstic',0),(198158,5505,'ba','Lebih baris',0),(198159,5505,'nl','Meer lijnen',0),(198160,5505,'fi','LisÃ¤Ã¤ rivejÃ¤',0),(198161,5505,'no','Flere linjer',0),(198162,5505,'da','Flere linjer',0),(198163,5505,'ko','ë” ë¼ì¸',0),(198164,5505,'he','×©×•×¨×•×ª × ×•×¡×¤×•×ª',0),(198165,5505,'el','Î ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Î³ÏÎ±Î¼Î¼Î­Ï‚',0),(198166,5505,'zh','æ›´å¤šè¡Œ\r\n',0),(198167,5505,'sv','Fler rader',0),(198168,5505,'it','PiÃ¹ linee',0),(198169,5505,'tl','',0),(198170,5505,'th','&#3629;&#3637;&#3585;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;',0),(198171,5505,'hi','à¤…à¤§à¤¿à¤• à¤²à¤¾à¤‡à¤¨à¥‹à¤‚',0),(198172,5505,'ms','Garis-garis yang lebih banyak',0),(198173,5505,'ar','Ø³Ø·ÙˆØ± Ø¥Ø¶Ø§ÙÙŠØ©',0),(198174,5505,'fr','Plus de lignes',0),(198175,5505,'jp','è¿½åŠ ãƒ©ã‚¤ãƒ³',0),(198176,5505,'pt','Mais linhas',0),(198177,5505,'ru','Ð‘Ð¾Ð»ÑŒÑˆÐµ Ð»Ð¸Ð½Ð¸Ð¹',0),(198178,5505,'es','MÃ¡s Lineas',0),(198179,5505,'de','Weitere Linien',0),(198180,5505,'en','More Lines',0),(198181,5506,'is','',0),(198182,5506,'dr','Ø±Ø¯Ù‡ Ø®Ø¯Ù…Ø§Øª',0),(198183,5506,'pr','Ø±Ø¯Ù‡ Ø®Ø¯Ù…Ø§Øª',0),(198184,5506,'tr','Hizmet sÄ±nÄ±fÄ±',0),(198185,5506,'pl','Klasa Service',0),(198186,5506,'bg','Ð£ÑÐ»ÑƒÐ³Ð°Ñ‚Ð° ÐºÐ»Ð°Ñ',0),(198187,5506,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ Ú©Ù„Ø§Ø³',0),(198188,5506,'sr','Ð£ÑÐ»ÑƒÐ³Ð° ÐºÐ»Ð°ÑÐ°',0),(198189,5506,'vi','Cáº¥p báº­c Dá»‹ch vá»¥',0),(198190,5506,'af','Diens Klas',0),(198191,5506,'ro','Clasa de serviciu',0),(198192,5506,'et','Teenuste liik',0),(198193,5506,'si','Storitev razred',0),(198194,5506,'ba','Layanan kelas',0),(198195,5506,'nl','Service-klasse',0),(198196,5506,'fi','Palveluluokka.',0),(198197,5506,'no','Tjenesteklassen',0),(198198,5506,'da','Serviceklasse',0),(198199,5506,'ko','ì„œë¹„ìŠ¤ í´ëž˜ìŠ¤',0),(198200,5506,'he','×ž×—×œ×§×ª ×©×¨×•×ª',0),(198201,5506,'el','ÎšÎ»Î¬ÏƒÎ· Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚',0),(198202,5506,'zh','æœåŠ¡ç­‰çº§\r\n',0),(198203,5506,'sv','TjÃ¤nsteklassen',0),(198204,5506,'it','Classe di servizio',0),(198205,5506,'tl','',0),(198206,5506,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(198207,5506,'hi','à¤¸à¥‡à¤µà¤¾ à¤µà¤°à¥à¤—',0),(198208,5506,'ms','Kelas Perkhidmatan',0),(198209,5506,'ar','ÙØ¦Ø© Ø§Ù„Ø®Ø¯Ù…Ø©',0),(198210,5506,'fr','Classe de service',0),(198211,5506,'jp','ã‚µãƒ¼ãƒ“ã‚¹éšŽç´š',0),(198212,5506,'pt','Classe de serviÃ§o',0),(198213,5506,'ru','ÐšÐ»Ð°ÑÑ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(198214,5506,'es','Clase de Servicio',0),(198215,5506,'de','Service-Klasse',0),(198216,5506,'en','Service Class',0),(198217,5507,'is','',0),(198218,5507,'dr','Ø±Ø¯Ù‡ Ø®Ø¯Ù…Ø§Øª  Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(198219,5507,'pr','Ø±Ø¯Ù‡ Ø®Ø¯Ù…Ø§Øª  Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(198220,5507,'tr','Hizmet sÄ±nÄ±fÄ±, bu isimde zaten',0),(198221,5507,'pl','Klasa usÅ‚uga juÅ¼ istnieje pod tÄ… nazwÄ…',0),(198222,5507,'bg','Ð£ÑÐ»ÑƒÐ³Ð°Ñ‚Ð° ÐºÐ»Ð°Ñ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ñ Ñ‚Ð¾Ð²Ð° Ð¸Ð¼Ðµ',0),(198223,5507,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ Ú©Ù„Ø§Ø³ Ø§Ø³ Ù†Ø§Ù… Ø³Û’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(198224,5507,'sr','Ð£ÑÐ»ÑƒÐ³Ð° ÐºÐ»Ð°ÑÐ° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð¿Ð¾Ð´ Ñ‚Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼',0),(198225,5507,'vi','Cáº¥p báº­c Dá»‹ch vá»¥ Ä‘Ã£ tá»“n táº¡i dÆ°á»›i tÃªn nÃ y',0),(198226,5507,'af','\'n Diensklas met daardie Naam Bestaan Alreeds',0),(198227,5507,'ro','Clasa de servicii existÄƒ deja cÄƒ numele de',0),(198228,5507,'et','Selle nimega teenus klass on juba olemas',0),(198229,5507,'si','Razred storitev Å¾e obstaja s tem imenom',0),(198230,5507,'ba','Layanan kelas sudah ada menurut nama',0),(198231,5507,'nl','Service-klasse bestaat al met die naam',0),(198232,5507,'fi','Palveluluokka on jo olemassa samanniminen',0),(198233,5507,'no','Tjenesteklassen finnes allerede med det navnet',0),(198234,5507,'da','Serviceklasse findes allerede med navnet',0),(198235,5507,'ko','ì„œë¹„ìŠ¤ í´ëž˜ìŠ¤ê°€ ì´ë¯¸ ê·¸ ì´ë¦„ìœ¼ë¡œ',0),(198236,5507,'he','×ž×—×œ×§×ª ×©×™×¨×•×ª ×›×‘×¨ ×§×™×™× ×‘×©× ×”×–×”',0),(198237,5507,'el','ÎšÎ»Î¬ÏƒÎ· Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(198238,5507,'zh','æœåŠ¡ç­‰çº§å·²ç»å­˜åœ¨è¯¥åç§°\r\n',0),(198239,5507,'sv','TjÃ¤nsteklassen finns redan med det namnet',0),(198240,5507,'it','Classe di servizio giÃ  esistente con lo stesso nome',0),(198241,5507,'tl','',0),(198242,5507,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;&#3650;&#3604;&#3618;&#3594;&#3639;&#3656;&#3629;&#3609;&#3',0),(198243,5507,'hi','à¤¸à¥‡à¤µà¤¾ à¤µà¤°à¥à¤— à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‰à¤¸ à¤¨à¤¾à¤® à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(198244,5507,'ms','Kelas Perkhidmatan telah wujud dengan nama itu',0),(198245,5507,'ar','ÙØ¦Ø© Ø®Ø¯Ù…Ø© Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹ Ø¨Ù‡Ø°Ø§ Ø§Ù„Ø§Ø³Ù…',0),(198246,5507,'fr','Classe de service existe dÃ©jÃ  sous ce nom',0),(198247,5507,'jp','ã??ã?®å??å‰?ã?®ã‚µãƒ¼ãƒ“ã‚¹éšŽç´šã?¯ã?™ã?§ã?«å­˜åœ¨ã?—ã?¦ã?„ã?¾ã?™',0),(198248,5507,'pt','Classe de serviÃ§o jÃ¡ existe com esse nome',0),(198249,5507,'ru','ÐšÐ»Ð°ÑÑ ÑÐ»ÑƒÐ¶Ð±Ñ‹ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚, Ñ ÑÑ‚Ð¸Ð¼ Ð¸Ð¼ÐµÐ½ÐµÐ¼',0),(198250,5507,'es','Clase de Servicio Y Existe por este Nombre',0),(198251,5507,'de','Service-Klasse ist bereits mit diesem Namen vorhanden.',0),(198252,5507,'en','Service Class Already Exists by That Name',0),(198253,5508,'is','',0),(198254,5508,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø±Ø¯Ù‡ Ø®Ø¯Ù…Ø§Øª ',0),(198255,5508,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø±Ø¯Ù‡ Ø®Ø¯Ù…Ø§Øª ',0),(198256,5508,'tr','Hizmet sÄ±nÄ±fÄ± DÃ¼zenle',0),(198257,5508,'pl','Edytowanie usÅ‚ugi Klasa',0),(198258,5508,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð¸ ÐºÐ»Ð°Ñ',0),(198259,5508,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ Ú©Ù„Ø§Ø³ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(198260,5508,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑƒÑÐ»ÑƒÐ³Ð° ÐºÐ»Ð°ÑÐ°',0),(198261,5508,'vi','Cáº­p nháº­t cáº¥p báº­c dá»‹ch vá»¥',0),(198262,5508,'af','Diens Klas Opdateer',0),(198263,5508,'ro','Editare imagini clasa',0),(198264,5508,'et','Redigeeri teenindusklass',0),(198265,5508,'si','Urejanje storitev razred',0),(198266,5508,'ba','Mengedit layanan kelas',0),(198267,5508,'nl','Service-klasse bewerken',0),(198268,5508,'fi','Muokkaa palveluluokka.',0),(198269,5508,'no','Redigere tjenesteklassen',0),(198270,5508,'da','Redigere serviceklasse',0),(198271,5508,'ko','ì„œë¹„ìŠ¤ í´ëž˜ìŠ¤ë¥¼ íŽ¸ì§‘',0),(198272,5508,'he','×¢×“×›×•×Ÿ ×ž×—×œ×§×ª ×©×¨×•×ª',0),(198273,5508,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎºÎ»Î¬ÏƒÎ· Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚',0),(198274,5508,'zh','æœåŠ¡ç­‰çº§æ›´æ–°\r\n',0),(198275,5508,'sv','Redigera tjÃ¤nsteklassen',0),(198276,5508,'it','Modificare la classe di servizio',0),(198277,5508,'tl','',0),(198278,5508,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3632;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(198279,5508,'hi','à¤¸à¤°à¥à¤µà¤¿à¤¸ à¤•à¥à¤²à¤¾à¤¸ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(198280,5508,'ms','Edit perkhidmatan kelas',0),(198281,5508,'ar','ØªØ­Ø±ÙŠØ± ÙØ¦Ø© Ø§Ù„Ø®Ø¯Ù…Ø©',0),(198282,5508,'fr','Modifier la classe de Service',0),(198283,5508,'jp','ã‚µãƒ¼ãƒ“ã‚¹éšŽç´šã?®æ›´æ–°',0),(198284,5508,'pt','Editar a classe de serviÃ§o',0),(198285,5508,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÐºÐ»Ð°ÑÑÐ° ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(198286,5508,'es','Clase de Servicio Actualizar',0),(198287,5508,'de','Bearbeiten Service-Klasse',0),(198288,5508,'en','Edit Service Class',0),(198289,5509,'is','',0),(198290,5509,'dr','Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø§Øª',0),(198291,5509,'pr','Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø§Øª',0),(198292,5509,'tr','Hizmet tÃ¼rÃ¼',0),(198293,5509,'pl','Typ usÅ‚ugi:',0),(198294,5509,'bg','Ð¢Ð¸Ð¿ ÑƒÑÐ»ÑƒÐ³Ð°',0),(198295,5509,'ur','Ø®Ø¯Ù…Øª Ù‚Ø³Ù…',0),(198296,5509,'sr','Ð¢Ð¸Ð¿ ÑƒÑÐ»ÑƒÐ³Ðµ',0),(198297,5509,'vi','Loáº¡i dá»‹ch vá»¥',0),(198298,5509,'af','Diens Tipe',0),(198299,5509,'ro','Tipul de serviciu',0),(198300,5509,'et','Teenuse tÃ¼Ã¼p',0),(198301,5509,'si','Vrsta storitve',0),(198302,5509,'ba','Jenis layanan',0),(198303,5509,'nl','Servicetype',0),(198304,5509,'fi','Palvelutyyppi',0),(198305,5509,'no','Tjenestetype',0),(198306,5509,'da','Tjenestetypen',0),(198307,5509,'ko','ì„œë¹„ìŠ¤ ìœ í˜•',0),(198308,5509,'he','×¡×•×’ ×©×¨×•×ª',0),(198309,5509,'el','Î¤ÏÏ€Î¿Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚',0),(198310,5509,'zh','æœåŠ¡ç±»åž‹\r\n',0),(198311,5509,'sv','Typ av tjÃ¤nst',0),(198312,5509,'it','Tipo di servizio',0),(198313,5509,'tl','',0),(198314,5509,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(198315,5509,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(198316,5509,'ms','Jenis Perkhidmatan',0),(198317,5509,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø®Ø¯Ù…Ø©',0),(198318,5509,'fr','Type de service',0),(198319,5509,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã‚¿ã‚¤ãƒ—',0),(198320,5509,'pt','Tipo de serviÃ§o',0),(198321,5509,'ru','Ð¢Ð¸Ð¿ ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(198322,5509,'es','Tipo de Servicio',0),(198323,5509,'de','Diensttyp',0),(198324,5509,'en','Service Type',0),(198325,5510,'is','',0),(198326,5510,'dr','Ù†Ø±Ø® Ø³Ø§Ø¹ØªÙŠ ',0),(198327,5510,'pr','Ù†Ø±Ø® Ø³Ø§Ø¹ØªÙŠ ',0),(198328,5510,'tr','Saat Ã¼creti',0),(198329,5510,'pl','Stawka godzinowa',0),(198330,5510,'bg','ÐŸÐ¾Ñ‡Ð°ÑÐ¾Ð²Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(198331,5510,'ur','Û” Û±Û´',0),(198332,5510,'sr','Ð¢Ð°Ñ€Ð¸Ñ„Ñƒ',0),(198333,5510,'vi','GiÃ¡ hÃ ng giá»',0),(198334,5510,'af','Uurlikse Tarief',0),(198335,5510,'ro','Tarif orar',0),(198336,5510,'et','Tunnitasu',0),(198337,5510,'si','Urna postavka',0),(198338,5510,'ba','Tarif per jam',0),(198339,5510,'nl','Uurtarief',0),(198340,5510,'fi','Tuntihinta',0),(198341,5510,'no','TimelÃ¸nn',0),(198342,5510,'da','TimelÃ¸n',0),(198343,5510,'ko','ì‹œê°„ë‹¹ ìš”ê¸ˆ',0),(198344,5510,'he','×ª×¢×¨×™×£',0),(198345,5510,'el','Î©ÏÎ¿Î¼Î¯ÏƒÎ¸Î¹Î¿',0),(198346,5510,'zh','æ—¶è–ª\r\n',0),(198347,5510,'sv','Timtaxa',0),(198348,5510,'it','Tariffa oraria',0),(198349,5510,'tl','',0),(198350,5510,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3619;&#3634;&#3618;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(198351,5510,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾ à¤•à¥€ à¤¦à¤°',0),(198352,5510,'ms','Ganda kadar',0),(198353,5510,'ar','Ø§Ù„Ø£Ø¬Ø± Ø¨Ø§Ù„Ø³Ø§Ø¹Ø©',0),(198354,5510,'fr','Taux horaire',0),(198355,5510,'jp','æ™‚é–“æ¯Žæ–™é‡‘',0),(198356,5510,'pt','Taxa horÃ¡ria',0),(198357,5510,'ru','ÐŸÐ¾Ñ‡Ð°ÑÐ¾Ð²Ð°Ñ ÑÑ‚Ð°Ð²ÐºÐ°',0),(198358,5510,'es','Tasa por Hora',0),(198359,5510,'de','Stundensatz',0),(198360,5510,'en','Hourly Rate',0),(198361,5511,'is','',0),(198362,5511,'dr','Ø¨Ø§ÙŠØ¯ Ø§ÙˆÙ„  Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª Ùˆ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø®Ø¯Ù…Ø§Øª ÙˆØ§Ø±Ø¯ Ø´ÙˆØ¯ ',0),(198363,5511,'pr','Ø¨Ø§ÙŠØ¯ Ø§ÙˆÙ„  Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª Ùˆ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø®Ø¯Ù…Ø§Øª ÙˆØ§Ø±Ø¯ Ø´ÙˆØ¯ ',0),(198364,5511,'tr','Hizmet tÃ¼rÃ¼ girin ve sÄ±nÄ±flarÄ± ilk Servisi gerekir',0),(198365,5511,'pl','NaleÅ¼y wprowadziÄ‡ typÃ³w usÅ‚ug i usÅ‚ugi klas pierwszych',0),(198366,5511,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð¸Ð´Ð¾Ð²ÐµÑ‚Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸ Ð¸ Ð¿ÑŠÑ€Ð²Ð° ÑÐ»ÑƒÐ¶Ð±Ð° ÐºÐ»Ð°ÑÐ¾Ð²Ðµ',0),(198367,5511,'ur','Ù„Ø§Ø²Ù…ÛŒ Ø³Ø±ÙˆØ³ Ø§Ù‚Ø³Ø§Ù… Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø·Ø¨Ù‚Ø§Øª Ú©Ùˆ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø³Ø±ÙˆØ³',0),(198368,5511,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ Ð²Ñ€ÑÑ‚Ðµ ÑƒÑÐ»ÑƒÐ³Ð° Ð¸ ÑÐµÑ€Ð²Ð¸ÑÐ° Ð¿Ñ€ÐµÐ´Ð°Ð²Ð°ÑšÐ° Ð¿Ñ€Ð²Ð¾',0),(198369,5511,'vi','Pháº£i nháº­p loáº¡i dá»‹ch vá»¥ vÃ  háº¡ng dá»‹ch vá»¥ TrÆ°á»›c',0),(198370,5511,'af','Moet EERS Dienstipe en Diensklasse Invoer',0),(198371,5511,'ro','Trebuie sÄƒ introduceÅ£i imagini tipuri ÅŸi clase de servicii Ã®n primul rÃ¢nd',0),(198372,5511,'et','Peate sisestama teenuste liigid ja teenuste klasside esimene',0),(198373,5511,'si','Vnesite vrste storitev in storitev razredov najprej',0),(198374,5511,'ba','Harus memasukkan tipe layanan dan layanan kelas pertama',0),(198375,5511,'nl','Moet invoeren servicetypen en eerste klassen Service',0),(198376,5511,'fi','Anna palvelutyypit ja palvelun sarjat ensin',0),(198377,5511,'no','MÃ¥ angi tjenestetyper og Service klasser fÃ¸rst',0),(198378,5511,'da','Skal indtaste tjenestetyper og tjeneste klasser fÃ¸rst',0),(198379,5511,'ko','ì„œë¹„ìŠ¤ ì¢…ë¥˜ë¥¼ ìž…ë ¥ í•˜ ê³  ë¨¼ì € í´ëž˜ìŠ¤ë¥¼ ì„œë¹„ìŠ¤ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(198380,5511,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×¡×•×’×™× ×©×™×¨×•×ª ×•×©×™×¨×•×ª ×©×™×¢×•×¨×™× ×§×•×“×',0),(198381,5511,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„ÏÏ€Î¿Ï…Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ ÎºÎ±Î¹ Ï…Ï€Î·ÏÎµÏƒÎ¯Î± Ï€ÏÏŽÏ„Î± Î¼Î±Î¸Î®Î¼Î±Ï„Î±',0),(198382,5511,'zh','å¿…é¡»é¦–å…ˆè¾“å…¥æœåŠ¡ç§ç±»å’ŒæœåŠ¡çº§åˆ«\r\n',0),(198383,5511,'sv','MÃ¥ste ange tjÃ¤nsttyp och tjÃ¤nsten klasser fÃ¶rst',0),(198384,5511,'it','Deve entrare in servizio tipi e classi di servizio in primo luogo',0),(198385,5511,'tl','',0),(198386,5511,'th','&#3605;&#3657;&#3629;&#3591;&#3611;&#3657;&#3629;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3649;&#3621;&#3632;&#3619;&#3632;&#3604;&#3633;&#3610;&#3610;&#3619;&#3',0),(198387,5511,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤¸à¥‡à¤µà¤¾ à¤µà¤°à¥à¤— à¤ªà¤¹à¤²à¥‡ à¤šà¤¾à¤¹à¤¿à¤',0),(198388,5511,'ms','Mesti masukkan jenis-jenis perkhidmatan dan perkhidmatan kelas pertama',0),(198389,5511,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø®Ø¯Ù…Ø© ÙˆØ®Ø¯Ù…Ø© Ø§Ù„ÙØ¦Ø§Øª Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(198390,5511,'fr','Doit entrer les Types de services et dâ€™abord les Classes de Service',0),(198391,5511,'jp','ã?¾ã?šã‚µãƒ¼ãƒ“ã‚¹ã‚¿ã‚¤ãƒ—ã?¨ã‚µãƒ¼ãƒ“ã‚¹éšŽç´šã‚’å…¥åŠ›ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(198392,5511,'pt','Deve inserir tipos de serviÃ§o e Classes de serviÃ§o primeiro',0),(198393,5511,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ñ‚Ð¸Ð¿Ñ‹ ÑÐ»ÑƒÐ¶Ð± Ð¸ ÐºÐ»Ð°ÑÑÑ‹ ÑÐ»ÑƒÐ¶Ð±Ñ‹ ÑÐ½Ð°Ñ‡Ð°Ð»Ð°',0),(198394,5511,'es','Debe Introducir Tipos de Servicios y Clases de Servicios PRIMERO',0),(198395,5511,'de','Geben Sie Diensttypen und Service-Klassen zuerst muss',0),(198396,5511,'en','Must Enter Service Types and Service Classes FIRST',0),(198397,5512,'is','',0),(198398,5512,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø±Ø® Ø®Ø¯Ù…Ø§Øª ',0),(198399,5512,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø±Ø® Ø®Ø¯Ù…Ø§Øª ',0),(198400,5512,'tr','Hizmet emek oranlarÄ±',0),(198401,5512,'pl','Pracy cena usÅ‚ugi',0),(198402,5512,'bg','Ð£ÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ñ‚Ñ€ÑƒÐ´Ð¾Ð²Ð¾ Ñ†ÐµÐ½Ð¸',0),(198403,5512,'ur','Ø®Ø¯Ù…Øª Ú©Û’ Ù…Ø²Ø¯ÙˆØ± Ú©ÛŒ Ø´Ø±Ø­',0),(198404,5512,'sr','Ð£ÑÐ»ÑƒÐ³Ð° Ñ€Ð°Ð´ ÑÑ‚Ð¾Ð¿Ðµ',0),(198405,5512,'vi','Cáº­p nháº­t giÃ¡ dá»‹ch vá»¥',0),(198406,5512,'af','Diens Skale Opdateer',0),(198407,5512,'ro','Servicii tarife muncii',0),(198408,5512,'et','Teenuse Labor mÃ¤Ã¤rad',0),(198409,5512,'si','Labor cene storitev',0),(198410,5512,'ba','TARIF tenaga kerja Layanan',0),(198411,5512,'nl','Service arbeid tarieven',0),(198412,5512,'fi','Palvelu tyÃ¶voiman hinnat',0),(198413,5512,'no','Tjenesten Ap. priser',0),(198414,5512,'da','Service Labor priser',0),(198415,5512,'ko','ì„œë¹„ìŠ¤ ë…¸ë™ ìš”ê¸ˆ',0),(198416,5512,'he','×¢×“×›×•×Ÿ ×ª×¢×¨×™×¤×™ ×©×¨×•×ª',0),(198417,5512,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î¿ÏƒÎ¿ÏƒÏ„Î¬',0),(198418,5512,'zh','æœåŠ¡ä»·æ ¼æ›´æ–°\r\n',0),(198419,5512,'sv','TjÃ¤nsten Labor priser',0),(198420,5512,'it','Servizio lavoro tariffe',0),(198421,5512,'tl','',0),(198422,5512,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3629;&#3633;&#3605;&#3619;&#3634;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(198423,5512,'hi','à¤¸à¥‡à¤µà¤¾ à¤¶à¥à¤°à¤® à¤¦à¤°à¥‹à¤‚',0),(198424,5512,'ms','Kadar buruh Perkhidmatan',0),(198425,5512,'ar','Ø£Ø³Ø¹Ø§Ø± Ø®Ø¯Ù…Ø© Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ø§Ù„',0),(198426,5512,'fr','Tarifs du service du travail',0),(198427,5512,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ–™é‡‘ã?®æ›´æ–°',0),(198428,5512,'pt','Taxas de serviÃ§o do trabalho',0),(198429,5512,'ru','Ð¢Ð°Ñ€Ð¸Ñ„Ñ‹ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð¸ Ñ‚Ñ€ÑƒÐ´Ð°',0),(198430,5512,'es','Tasas de Servicio Actualizar',0),(198431,5512,'de','Service-Labor-Preise',0),(198432,5512,'en','Service Labor Rates',0),(198433,5513,'is','',0),(198434,5513,'dr','Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø§Øª Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù… Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(198435,5513,'pr','Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø§Øª Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù… Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(198436,5513,'tr','Hizmet tÃ¼rÃ¼, bu isimde zaten',0),(198437,5513,'pl','Typ usÅ‚ugi juÅ¼ istnieje pod tÄ… nazwÄ…',0),(198438,5513,'bg','Ð¢Ð¸Ð¿ ÑƒÑÐ»ÑƒÐ³Ð° Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ñ Ñ‚Ð¾Ð²Ð° Ð¸Ð¼Ðµ',0),(198439,5513,'ur','Ø®Ø¯Ù…Øª Ù‚Ø³Ù… Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø³ Ú©Ø§ Ù†Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(198440,5513,'sr','Ð¢Ð¸Ð¿ ÑƒÑÐ»ÑƒÐ³Ðµ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð¿Ð¾Ð´ Ñ‚Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼',0),(198441,5513,'vi','Loáº¡i dá»‹ch vá»¥ Ä‘Ã£ tá»“n táº¡i dÆ°á»›i tÃªn nÃ y',0),(198442,5513,'af','Diens Tipe met daardie Naam bestaan alreeds',0),(198443,5513,'ro','Tipul de serviciu existÄƒ deja cÄƒ numele de',0),(198444,5513,'et','Teenuse tÃ¼Ã¼p juba olemas nimega',0),(198445,5513,'si','S tem imenom Å¾e obstaja storitev tip',0),(198446,5513,'ba','Jenis layanan yang sudah ada dengan nama itu',0),(198447,5513,'nl','Servicetype bestaat al met die naam',0),(198448,5513,'fi','Palvelutyyppi on jo samanniminen',0),(198449,5513,'no','Tjenestetype finnes allerede med det navnet',0),(198450,5513,'da','Tjenestetype findes allerede med navnet',0),(198451,5513,'ko','ì„œë¹„ìŠ¤ ìœ í˜•ì„ í•´ë‹¹ ì´ë¦„ìœ¼ë¡œ ì´ë¯¸',0),(198452,5513,'he','×¡×•×’ ×©×™×¨×•×ª ×›×‘×¨ ×§×™×™× ×‘×©× ×”×–×”',0),(198453,5513,'el','Î¤ÏÏ€Î¿Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(198454,5513,'zh','æœåŠ¡ç±»åž‹å·²ç»å­˜åœ¨è¯¥åç§°çš„\r\n',0),(198455,5513,'sv','Typ av tjÃ¤nst finns redan med det namnet',0),(198456,5513,'it','Tipo di servizio giÃ  esistente con lo stesso nome',0),(198457,5513,'tl','',0),(198458,5513,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3617;&#3638;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;&#3650;&#3604;&#3618;&#3594;&#3639;&#3656;&#3629;&#3609;&#3633;&#3657;&#3609;',0),(198459,5513,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‰à¤¸ à¤¨à¤¾à¤® à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(198460,5513,'ms','Jenis Perkhidmatan telah wujud dengan nama itu',0),(198461,5513,'ar','Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø© Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹ Ø¨Ù‡Ø°Ø§ Ø§Ù„Ø§Ø³Ù…',0),(198462,5513,'fr','Type de service existe dÃ©jÃ  sous ce nom',0),(198463,5513,'jp','ã??ã?®å??å‰?ã?®ã‚µãƒ¼ãƒ“ã‚¹ã‚¿ã‚¤ãƒ—ã?¯ã?™ã?§ã?«å­˜åœ¨ã?—ã?¦ã?„ã?¾ã?™',0),(198464,5513,'pt','Tipo de serviÃ§o jÃ¡ existe com esse nome',0),(198465,5513,'ru','Ð¢Ð¸Ð¿ ÑÐ»ÑƒÐ¶Ð±Ñ‹ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚, Ñ ÑÑ‚Ð¸Ð¼ Ð¸Ð¼ÐµÐ½ÐµÐ¼',0),(198466,5513,'es','Tipo de Servicio ya existe por ese Nombre',0),(198467,5513,'de','Diensttyp ist mit diesem Namen bereits vorhanden.',0),(198468,5513,'en','Service Type already exists by that Name',0),(198469,5514,'is','',0),(198470,5514,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø§Øª ',0),(198471,5514,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø§Øª ',0),(198472,5514,'tr','Hizmet tÃ¼rÃ¼ gÃ¼ncelleme',0),(198473,5514,'pl','UsÅ‚ugi typu Update',0),(198474,5514,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ñ‚Ð¸Ð¿Ð° Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð¸Ñ‚Ðµ',0),(198475,5514,'ur','Ø®Ø¯Ù…Øª Ù‚Ø³Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(198476,5514,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð²Ñ€ÑÑ‚Ð° ÑƒÑÐ»ÑƒÐ³Ð°',0),(198477,5514,'vi','Cáº­p nháº­t loáº¡i dá»‹ch vá»¥',0),(198478,5514,'af','Diens Tipes Opdateer',0),(198479,5514,'ro','Actualizare de tip serviciu',0),(198480,5514,'et','Teenuse tÃ¼Ã¼p vÃ¤rskendamine',0),(198481,5514,'si','Vrsta storitev posodabljanja',0),(198482,5514,'ba','Jenis Layanan Update',0),(198483,5514,'nl','Service Type Update',0),(198484,5514,'fi','Tyypin pÃ¤ivitys',0),(198485,5514,'no','Service Type oppdatering',0),(198486,5514,'da','Service Type opdatering',0),(198487,5514,'ko','ì„œë¹„ìŠ¤ ìœ í˜• ì—…ë°ì´íŠ¸',0),(198488,5514,'he','×¢×“×›×•×Ÿ ×¡×•×’ ×©×™×¨×•×ª',0),(198489,5514,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï… ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(198490,5514,'zh','æœåŠ¡ç±»åž‹æ›´æ–°\r\n',0),(198491,5514,'sv','Service typ uppdatering',0),(198492,5514,'it','Servizio tipo aggiornamento',0),(198493,5514,'tl','',0),(198494,5514,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(198495,5514,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(198496,5514,'ms','Kemaskini jenis Perkhidmatan',0),(198497,5514,'ar','ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ø®Ø¯Ù…Ø©',0),(198498,5514,'fr','Mise Ã  jour de Type service',0),(198499,5514,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã‚¿ã‚¤ãƒ—ã?®æ›´æ–°',0),(198500,5514,'pt','ActualizaÃ§Ã£o do tipo de serviÃ§o',0),(198501,5514,'ru','Ð¢Ð¸Ð¿ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(198502,5514,'es','Tipo de Servicio Actualizar',0),(198503,5514,'de','Service-Typ-Update',0),(198504,5514,'en','Service Type Update',0),(198505,5515,'is','',0),(198506,5515,'dr','( Ù…Ø¬Ù…ÙˆØ¹Ø§Ø³Ù‡Ø§ÙŠ) ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø¯Ù…Ø§Øª  Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡( Ù†ÙŠØ±ÙˆÙŠ ÙƒØ§Ø±Ú¯Ø±ÙŠ',0),(198507,5515,'pr','Ø«Ø¨Øª Ø·Ø¨Ù‚Ù‡ Ù‡Ø§ÙŠ ( ÙƒÙ„Ø§Ø³Ù‡Ø§ÙŠ) Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª  Ø¯Ø³ØªÙ…Ø²Ø¯( Ù†ÙŠØ±ÙˆÙŠ ÙƒØ§Ø±Ú¯Ø±ÙŠ',0),(198508,5515,'tr','Servis sipariÅŸi sÄ±nÄ±flarÄ± laboratuarÄ±nÄ±n girin veya',0),(198509,5515,'pl','WprowadÅº klas zamÃ³wienia usÅ‚ugi laboratorium lub',0),(198510,5515,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÐºÐ»Ð°ÑÐ¾Ð²Ðµ Ð½Ð° Ð»Ð°Ð±Ð¾Ñ€Ð°Ñ‚Ð¾Ñ€Ð¸ÑÑ‚Ð° Ð¸Ð»Ð¸',0),(198511,5515,'ur','Ù„ÛŒØ¨ Ú©ÛŒ Ø®Ø¯Ù…Øª Ø¢Ø±ÚˆØ± Ú©ÛŒ Ú©Ù„Ø§Ø³ÛŒÚº Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº ÛŒØ§',0),(198512,5515,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑÐµÑ€Ð²Ð¸ÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð° ÐºÐ»Ð°ÑÐµ Ð»Ð°Ð±Ð¾Ñ€Ð°Ñ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð¸Ð»Ð¸',0),(198513,5515,'vi','Nháº­p lab thá»© báº­c cho Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥ hay',0),(198514,5515,'af','Diens Bestellings Klasse of Laboratorium Invoer',0),(198515,5515,'ro','IntroduceÅ£i imagini ordinea claselor de laborator sau',0),(198516,5515,'et','Sisestage tellimuse teenindustaset lab vÃµi',0),(198517,5515,'si','Vnesite storitev nalog razredov laboratoriju ali',0),(198518,5515,'ba','Masukkan kelas Order layanan laboratorium atau',0),(198519,5515,'nl','Voer Service Order klassen van Lab of',0),(198520,5515,'fi','Kirjoita tilauksen palveluluokat Lab tai',0),(198521,5515,'no','Angi rekkefÃ¸lgen Tjenesteklasser av Lab eller',0),(198522,5515,'da','Angiv rÃ¦kkefÃ¸lge tjenesteklasser i Lab eller',0),(198523,5515,'ko','ì‹¤í—˜ì‹¤ì˜ ì„œë¹„ìŠ¤ ì£¼ë¬¸ í´ëž˜ìŠ¤ë¥¼ ìž…ë ¥ ë˜ëŠ”',0),(198524,5515,'he','×”×–×Ÿ ×¡×“×¨ ×ž×—×œ×§×•×ª ×©×™×¨×•×ª ×ž×¢×‘×“×” ××•',0),(198525,5515,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Î¸Î­ÏƒÎ·Ï‚ Ï„Î¿Ï… ÎµÏÎ³Î±ÏƒÏ„Î·ÏÎ¯Î¿Ï… Î®',0),(198526,5515,'zh','è¾“å…¥å®žéªŒå®¤æœåŠ¡è®¢å•ç±»åˆ«æˆ–',0),(198527,5515,'sv','Ange Service Order klasser av Lab eller',0),(198528,5515,'it','Inserire le classi di ordine di servizio del laboratorio o',0),(198529,5515,'tl','',0),(198530,5515,'th','&#3611;&#3657;&#3629;&#3609;&#3619;&#3632;&#3604;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(198531,5515,'hi','à¤²à¥ˆà¤¬ à¤•à¥€ à¤¸à¥‡à¤µà¤¾ à¤•à¥à¤°à¤® à¤•à¤•à¥à¤·à¤¾à¤à¤‚ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾',0),(198532,5515,'ms','Masukkan kelas pesanan perkhidmatan makmal atau',0),(198533,5515,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø®Ø¯Ù…Ø© ØªØ±ØªÙŠØ¨ Ø§Ù„Ø·Ø¨Ù‚Ø§Øª Ù…Ù† Ù…Ø®ØªØ¨Ø± Ø£Ùˆ',0),(198534,5515,'fr','Entrer dans les Classes de commande de Service du laboratoire ou',0),(198535,5515,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡åŠ´åƒ?éšŽç´šã?®å…¥åŠ›',0),(198536,5515,'pt','Digite Classes de ordem de serviÃ§o de laboratÃ³rio ou',0),(198537,5515,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð·Ð°ÐºÐ°Ð· ÐºÐ»Ð°ÑÑÑ‹ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð»Ð°Ð±Ð¾Ñ€Ð°Ñ‚Ð¾Ñ€Ð¸Ð¸ Ð¸Ð»Ð¸',0),(198538,5515,'es','Introducir Clases de Pedidos de Servicio de Lab o',0),(198539,5515,'de','Geben Sie Auftrag Dienstklassen Lab oder',0),(198540,5515,'en','Enter Service Order Classes of Lab or',0),(198541,5516,'is','',0),(198542,5516,'dr','Ø«Ø¨Øª Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(198543,5516,'pr','Ø«Ø¨Øª Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(198544,5516,'tr','Servis sipariÅŸi tÃ¼rlerini iÅŸ girin',0),(198545,5516,'pl','Wprowadzenie usÅ‚ugi typy zleceÅ„ pracy',0),(198546,5516,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð¸Ð´Ð¾Ð²Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð· Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(198547,5516,'ur','Ø®Ø¯Ù…Øª ØªØ±ØªÛŒØ¨ Ù‚Ø³Ù… Ú©Û’ Ú©Ø§Ù… Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(198548,5516,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð²Ñ€ÑÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ Ñ€Ð°Ð´Ð°',0),(198549,5516,'vi','Nháº­p loáº¡i cÃ´ng viá»‡c cá»§a Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥',0),(198550,5516,'af','Diens Bestellings Tipes of Werk Invoer',0),(198551,5516,'ro','IntroduceÅ£i imagini tipuri de ordine de lucru',0),(198552,5516,'et','Sisestage tÃ¶Ã¶ hooldustellimuse liik',0),(198553,5516,'si','Vnesite vrste servisnih nalogov dela',0),(198554,5516,'ba','Masukkan jenis Order layanan pekerjaan',0),(198555,5516,'nl','Serviceordersoorten werk invoeren',0),(198556,5516,'fi','MÃ¤Ã¤ritÃ¤ huoltotilauksen tyyppejÃ¤ tyÃ¶n',0),(198557,5516,'no','Angi serviceordretyper arbeid',0),(198558,5516,'da','Angiv Serviceordretyper arbejde',0),(198559,5516,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ìœ í˜•ì˜ ìž‘ì—… ìž…ë ¥',0),(198560,5516,'he','×”×–×Ÿ ×©×™×¨×•×ª ×”×¡×“×¨ ×¡×•×’×™ ×¢×‘×•×“×•×ª',0),(198561,5516,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„ÏÏ€Î¿Ï…Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ Ï„Î¿Ï… Î­ÏÎ³Î¿Ï…',0),(198562,5516,'zh','è¾“å…¥å·¥ä½œæœåŠ¡è®¢å•ç±»åž‹',0),(198563,5516,'sv','Ange serviceordertyper arbete',0),(198564,5516,'it','Immettere i tipi di ordine di servizio del lavoro',0),(198565,5516,'tl','',0),(198566,5516,'th','&#3611;&#3657;&#3629;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(198567,5516,'hi','à¤•à¤¾à¤® à¤•à¥€ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(198568,5516,'ms','Masukkan jenis pesanan Perkhidmatan kerja',0),(198569,5516,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø®Ø¯Ù…Ø© ØªØ±ØªÙŠØ¨ Ø£Ù†ÙˆØ§Ø¹ Ù…Ù† Ø§Ù„Ø¹Ù…Ù„',0),(198570,5516,'fr','Entrez les Types de commande de Service de travail',0),(198571,5516,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ä½œæ¥­ã‚¿ã‚¤ãƒ—ã?®å…¥åŠ›',0),(198572,5516,'pt','Digite tipos de ordem de serviÃ§o do trabalho',0),(198573,5516,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿Ñ‹ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(198574,5516,'es','Introducir Tipos de Trabajo de Pedidos de Servicio',0),(198575,5516,'de','Geben Sie Service Order-Typen arbeiten',0),(198576,5516,'en','Enter Service Order Types of Work',0),(198577,5517,'is','',0),(198578,5517,'dr','Ù†Ø±Ø® Ù‡Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ø¯Ø³ØªÙ…Ø²Ø¯  Ø¨Ø±Ø§ÙŠ Ø§Ù†ÙˆØ§Ø¹  Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ùˆ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ù‡Ø§ ',0),(198579,5517,'pr','Ù†Ø±Ø® Ù‡Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ø¯Ø³ØªÙ…Ø²Ø¯  Ø¨Ø±Ø§ÙŠ Ø§Ù†ÙˆØ§Ø¹  Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ùˆ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ù‡Ø§ ',0),(198580,5517,'tr','Servis sipariÅŸi tÃ¼rleri ve sÄ±nÄ±flar iÃ§in emek oranlarÄ±',0),(198581,5517,'pl','Cena pracy dla typÃ³w usÅ‚ug Order i klasy',0),(198582,5517,'bg','Ð¢Ñ€ÑƒÐ´Ð¾Ð²Ð¾ Ñ†ÐµÐ½Ð¸ Ð·Ð° Ð²Ð¸Ð´Ð¾Ð²Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð· Ð¸ ÐºÐ»Ð°ÑÐ¾Ð²Ðµ',0),(198583,5517,'ur','Ù…Ø²Ø¯ÙˆØ± Ú©ÛŒ Ø´Ø±Ø­ Ø®Ø¯Ù…Øª ØªØ±ØªÛŒØ¨ Ø§Ù‚Ø³Ø§Ù… Ø§ÙˆØ± Ú©Ù„Ø§Ø³ÙˆÚº Ú©Û’ Ù„Ø¦Û’',0),(198584,5517,'sr','Ð Ð°Ð´ ÑÑ‚Ð¾Ð¿Ðµ Ð·Ð° Ð²Ñ€ÑÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ Ð¸ Ð¿Ñ€ÐµÐ´Ð°Ð²Ð°ÑšÐ°',0),(198585,5517,'vi','GiÃ¡ nhÃ¢n cÃ´ng cho loáº¡i & cáº¥p báº­c Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(198586,5517,'af','Arbeidsskale vir Diens Bestellingstipes en Klasse',0),(198587,5517,'ro','Muncii tarife pentru serviciul de ordine tipuri ÅŸi clase',0),(198588,5517,'et','Labor mÃ¤Ã¤rad hooldustellimuste liike ja klassi',0),(198589,5517,'si','Labor stopnje za vrste servisnih nalogov in razredov',0),(198590,5517,'ba','Harga tenaga kerja untuk kelas dan jenis Order Layanan',0),(198591,5517,'nl','Arbeid tarieven voor serviceordersoorten en klassen',0),(198592,5517,'fi','TyÃ¶voiman hinnat huoltotilauksen tyyppejÃ¤ ja luokkia',0),(198593,5517,'no','Ap. priser for serviceordretyper og klasser',0),(198594,5517,'da','Labor satser for Serviceordretyper og klasser',0),(198595,5517,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ìœ í˜• ë° í´ëž˜ìŠ¤ì— ëŒ€ í•œ ë…¸ë™ ìš”ê¸ˆ',0),(198596,5517,'he','×”×ž×—×™×¨×™× ×”×¢×‘×•×“×” ×¢×‘×•×¨ ×©×™×¨×•×ª ×”×¡×“×¨ ×¡×•×’×™× ×©×œ ×ž×—×œ×§×•×ª',0),(198597,5517,'el','Î•ÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î¿ÏƒÎ¿ÏƒÏ„Î¬ Ï…Ï€Î·ÏÎµÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï…Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½/ÎµÎ½Ï„Î¿Î»ÏŽÎ½ ÎºÎ±Î¹ Ï„Î¹Ï‚ ÎºÎ»Î¬ÏƒÎµÎ¹Ï‚',0),(198598,5517,'zh','ä¸ºæœåŠ¡è®¢å•ç±»åž‹å’Œç­‰çº§çš„åŠ³åŠ¨åŠ›ä»·æ ¼\r\n',0),(198599,5517,'sv','Labor priser fÃ¶r serviceordertyper och klasser',0),(198600,5517,'it','Tariffe di manodopera per classi e tipi di ordine di servizio',0),(198601,5517,'tl','',0),(198602,5517,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3656;&#3634;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3',0),(198603,5517,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤•à¤¾à¤° à¤”à¤° à¤•à¤•à¥à¤·à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥à¤°à¤® à¤¦à¤°à¥‹à¤‚',0),(198604,5517,'ms','Kadar buruh jenis pesanan Perkhidmatan dan kelas',0),(198605,5517,'ar','Ù…Ø¹Ø¯Ù„Ø§Øª Ø§Ù„Ø¹Ù…Ø§Ù„Ø© Ù„Ø®Ø¯Ù…Ø© ØªØ±ØªÙŠØ¨ Ø£Ù†ÙˆØ§Ø¹ ÙˆÙØ¦Ø§Øª',0),(198606,5517,'fr','Labor tarifs pour les Classes et les Types d\'ordres de Service',0),(198607,5517,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã‚¿ã‚¤ãƒ—ã?¨éšŽç´šã?®ã?Ÿã‚?ã?®åŠ´åƒ?æ–™é‡‘',0),(198608,5517,'pt','Taxas trabalhistas para Classes e tipos de ordem de serviÃ§o',0),(198609,5517,'ru','Ð¢Ñ€ÑƒÐ´Ð¾Ð²Ñ‹Ðµ Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»Ð¸ Ñ‚Ð¸Ð¿Ñ‹ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¸ ÐºÐ»Ð°ÑÑÑ‹',0),(198610,5517,'es','Tasas de Labor para Tipos y Clases de Ordenes de Servicio',0),(198611,5517,'de','Labor Preise fÃ¼r Service-Order-Typen und Klassen',0),(198612,5517,'en','Labor Rates for Service Order Types and Classes',0),(198613,5518,'is','',0),(198614,5518,'dr','Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª',0),(198615,5518,'pr','Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª',0),(198616,5518,'tr','Hizmet sÄ±nÄ±flarÄ±',0),(198617,5518,'pl','Serwis klasy',0),(198618,5518,'bg','Ð¡Ð»ÑƒÐ¶Ð±Ð° ÐºÐ»Ð°ÑÐ¾Ð²Ðµ',0),(198619,5518,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ Ú©Ù„Ø§Ø³ÛŒÚº',0),(198620,5518,'sr','Ð£ÑÐ»ÑƒÐ³Ðµ Ð¿Ñ€ÐµÐ´Ð°Ð²Ð°ÑšÐ°',0),(198621,5518,'vi','Cáº¥p báº­c Dá»‹ch vá»¥',0),(198622,5518,'af','Diens Klasse',0),(198623,5518,'ro','Clase de service',0),(198624,5518,'et','Teenuste liigid',0),(198625,5518,'si','Razredov storitev',0),(198626,5518,'ba','Layanan kelas',0),(198627,5518,'nl','Service klassen',0),(198628,5518,'fi','Palveluluokat',0),(198629,5518,'no','Tjenesteklasser',0),(198630,5518,'da','Tjenesteklasser',0),(198631,5518,'ko','ì„œë¹„ìŠ¤ í´ëž˜ìŠ¤',0),(198632,5518,'he','×ž×—×œ×§×•×ª ×©×¨×•×ª',0),(198633,5518,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï„Î¬Î¾ÎµÎ¹Ï‚',0),(198634,5518,'zh','æœåŠ¡ç­‰çº§\r\n',0),(198635,5518,'sv','TjÃ¤nsteklasser',0),(198636,5518,'it','Classi di servizio',0),(198637,5518,'tl','',0),(198638,5518,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(198639,5518,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¤•à¥à¤·à¤¾à¤à¤‚',0),(198640,5518,'ms','Kelas Perkhidmatan',0),(198641,5518,'ar','ÙØ¦Ø§Øª Ø§Ù„Ø®Ø¯Ù…Ø©',0),(198642,5518,'fr','Classes de service',0),(198643,5518,'jp','ã‚µãƒ¼ãƒ“ã‚¹æŽˆæ¥­',0),(198644,5518,'pt','Classes de serviÃ§o',0),(198645,5518,'ru','ÐšÐ»Ð°ÑÑÑ‹ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(198646,5518,'es','Clases de Servicios',0),(198647,5518,'de','Service-Klassen',0),(198648,5518,'en','Service Classes',0),(198649,5519,'is','',0),(198650,5519,'dr','Ù†Ø±Ø® Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(198651,5519,'pr','Ù†Ø±Ø® Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(198652,5519,'tr','Servis sipariÅŸ iÅŸÃ§ilik fiyatlarÄ±',0),(198653,5519,'pl','Cena pracy zamÃ³wienia usÅ‚ugi',0),(198654,5519,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ‚Ñ€ÑƒÐ´Ð¾Ð²Ð¾ Ñ†ÐµÐ½Ð¸',0),(198655,5519,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ù…Ø²Ø¯ÙˆØ± Ø´Ø±Ø­',0),(198656,5519,'sr','Ð£ÑÐ»ÑƒÐ³Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ€Ð°Ð´ ÑÑ‚Ð¾Ð¿Ðµ',0),(198657,5519,'vi','GiÃ¡ nhÃ¢n cÃ´ng cho ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(198658,5519,'af','Diens Bestelling Arbeid Skale',0),(198659,5519,'ro','Tarif manopera comanda service',0),(198660,5519,'et','Teenuse tellimuse Labor mÃ¤Ã¤rad',0),(198661,5519,'si','Servisni nalog Labor stopnje',0),(198662,5519,'ba','Tarif Layanan pesanan tenaga kerja',0),(198663,5519,'nl','Service Order arbeid tarieven',0),(198664,5519,'fi','Palvelun tilaa tyÃ¶voiman hinnat',0),(198665,5519,'no','Tjenesten Bestill Ap. priser',0),(198666,5519,'da','Service Bestil Labor priser',0),(198667,5519,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ë…¸ë™ ìš”ê¸ˆ',0),(198668,5519,'he','×ª×¢×¨×™×¤×™ ×¢×‘×•×“×” ×©×œ ×”×–×ž× ×ª ×©×¨×•×ª',0),(198669,5519,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï€Î¿ÏƒÎ¿ÏƒÏ„Î¬ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(198670,5519,'zh','æœåŠ¡è®¢å•åŠ³åŠ¨åŠ›ä»·æ ¼\r\n',0),(198671,5519,'sv','Service bestÃ¤llning Labor priser',0),(198672,5519,'it','Servizio ordine lavoro tariffe',0),(198673,5519,'tl','',0),(198674,5519,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(198675,5519,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¶à¥à¤°à¤® à¤¦à¤°à¥‹à¤‚',0),(198676,5519,'ms','Kadar buruh Perkhidmatan Pesanan',0),(198677,5519,'ar','Ù…Ø¹Ø¯Ù„Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(198678,5519,'fr','Service commander prix Labor',0),(198679,5519,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®å€¤æ®µãƒªã‚¹ãƒˆ',0),(198680,5519,'pt','Taxas trabalhistas de ordem de serviÃ§o',0),(198681,5519,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ñ‚Ñ€ÑƒÐ´Ð° Ñ‚Ð°Ñ€Ð¸Ñ„Ñ‹',0),(198682,5519,'es','Orden de Servicio Tasas de Mano de Obra',0),(198683,5519,'de','Service Bestellung Labor Preise',0),(198684,5519,'en','Service Order Labor Rates',0),(198685,5520,'is','',0),(198686,5520,'dr','Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª ',0),(198687,5520,'pr','Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª ',0),(198688,5520,'tr','Hizmet tÃ¼rleri',0),(198689,5520,'pl','Rodzaj usÅ‚ugi',0),(198690,5520,'bg','Ð’Ð¸Ð´Ð¾Ð²Ðµ ÑÐµÑ€Ð²Ð¸Ð·',0),(198691,5520,'ur','Ø®Ø¯Ù…Øª Ù‚Ø³Ù…',0),(198692,5520,'sr','Ð’Ñ€ÑÑ‚Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(198693,5520,'vi','Loáº¡i dá»‹ch vá»¥',0),(198694,5520,'af','Diens Tipes',0),(198695,5520,'ro','Tipuri de service',0),(198696,5520,'et','Teenistuse liigid',0),(198697,5520,'si','Vrste storitev',0),(198698,5520,'ba','Tipe layanan',0),(198699,5520,'nl','Servicetypen',0),(198700,5520,'fi','Palvelutyypit',0),(198701,5520,'no','Tjenestetyper',0),(198702,5520,'da','Tjenestetyper',0),(198703,5520,'ko','ì„œë¹„ìŠ¤ ì¢…ë¥˜',0),(198704,5520,'he','×¡×•×’×™ ×©×¨×•×ª',0),(198705,5520,'el','Î¤ÏÏ€Î¿Ï…Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚',0),(198706,5520,'zh','æœåŠ¡ç±»åž‹\r\n',0),(198707,5520,'sv','TjÃ¤nsttyper',0),(198708,5520,'it','Tipi di servizio',0),(198709,5520,'tl','',0),(198710,5520,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(198711,5520,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(198712,5520,'ms','Jenis-jenis Perkhidmatan',0),(198713,5520,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø®Ø¯Ù…Ø©',0),(198714,5520,'fr','Types de services',0),(198715,5520,'jp','ã‚µãƒ¼ãƒ“ã‚¹ç¨®é¡ž',0),(198716,5520,'pt','Tipos de serviÃ§o',0),(198717,5520,'ru','Ð¢Ð¸Ð¿Ñ‹ ÑÐ»ÑƒÐ¶Ð±',0),(198718,5520,'es','Servicios Tipos de',0),(198719,5520,'de','Service-Typen',0),(198720,5520,'en','Service Types',0),(198721,5521,'is','',0),(198722,5521,'dr','Ù…Ø§Ø´ÙŠÙ† Ø­Ø³Ø§Ø¨',0),(198723,5521,'pr','Ù…Ø§Ø´ÙŠÙ† Ø­Ø³Ø§Ø¨',0),(198724,5521,'tr','Hesap makinesi',0),(198725,5521,'pl','Kalkulator',0),(198726,5521,'bg','ÐšÐ°Ð»ÐºÑƒÐ»Ð°Ñ‚Ð¾Ñ€',0),(198727,5521,'ur','Ú©ÛŒÙ„Ú©ÙˆÙ„ÛŒÙ¹Ø±',0),(198728,5521,'sr','ÐšÐ°Ð»ÐºÑƒÐ»Ð°Ñ‚Ð¾Ñ€',0),(198729,5521,'vi','MÃ¡y tÃ­nh',0),(198730,5521,'af','Sakrekenaar',0),(198731,5521,'ro','Calculator',0),(198732,5521,'et','Kalkulaator',0),(198733,5521,'si','Kalkulator',0),(198734,5521,'ba','Kalkulator',0),(198735,5521,'nl','Rekenmachine',0),(198736,5521,'fi','Laskin',0),(198737,5521,'no','Kalkulator',0),(198738,5521,'da','Lommeregner',0),(198739,5521,'ko','ê³„ì‚°ê¸°',0),(198740,5521,'he','×ž×—×©×‘×•×Ÿ',0),(198741,5521,'el','Î‘ÏÎ¹Î¸Î¼Î¿Î¼Î·Ï‡Î±Î½Î®',0),(198742,5521,'zh','è®¡ç®—å™¨\r\n',0),(198743,5521,'sv','Kalkylatorn',0),(198744,5521,'it','Calcolatrice',0),(198745,5521,'tl','',0),(198746,5521,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3588;&#3636;&#3604;&#3648;&#3621;&#3586;',0),(198747,5521,'hi','à¤•à¥ˆà¤²à¤•à¥à¤¯à¥‚à¤²à¥‡à¤Ÿà¤°',0),(198748,5521,'ms','Kalkulator',0),(198749,5521,'ar','Ø¢Ù„Ø© Ø­Ø§Ø³Ø¨Ø©',0),(198750,5521,'fr','Calculatrice',0),(198751,5521,'jp','è¨ˆç®—æ©Ÿ',0),(198752,5521,'pt','Calculadora',0),(198753,5521,'ru','ÐšÐ°Ð»ÑŒÐºÑƒÐ»ÑÑ‚Ð¾Ñ€',0),(198754,5521,'es','Calculador',0),(198755,5521,'de','Rechner',0),(198756,5521,'en','Calculator',0),(198757,5522,'is','',0),(198758,5522,'dr','Ø¨ÙŠÙ…Ø§Ø±Ø§Ù† ',0),(198759,5522,'pr','Ø¨ÙŠÙ…Ø§Ø±Ø§Ù† ',0),(198760,5522,'tr','Hastalar',0),(198761,5522,'pl','PacjentÃ³w',0),(198762,5522,'bg','ÐŸÐ°Ñ†Ð¸ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ',0),(198763,5522,'ur','Ù…Ø±ÛŒØ¶ÙˆÚº',0),(198764,5522,'sr','ÐŸÐ°Ñ†Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸',0),(198765,5522,'vi','Bá»‡nh nhÃ¢n',0),(198766,5522,'af','Pasiente',0),(198767,5522,'ro','PacienÅ£ii',0),(198768,5522,'et','Patsiendid',0),(198769,5522,'si','Bolniki',0),(198770,5522,'ba','Pasien',0),(198771,5522,'nl','PatiÃ«nten',0),(198772,5522,'fi','Potilaat',0),(198773,5522,'no','Pasienter',0),(198774,5522,'da','Patienter',0),(198775,5522,'ko','í™˜ìž',0),(198776,5522,'he','×—×•×œ×™×',0),(198777,5522,'el','Î‘ÏƒÎ¸ÎµÎ½ÎµÎ¯Ï‚',0),(198778,5522,'zh','ç—…äºº\r\n',0),(198779,5522,'sv','Patienter',0),(198780,5522,'it','Pazienti',0),(198781,5522,'tl','',0),(198782,5522,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(198783,5522,'hi','à¤°à¥‹à¤—à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡',0),(198784,5522,'ms','Pesakit-pesakit',0),(198785,5522,'ar','Ø§Ù„Ù…Ø±Ø¶Ù‰',0),(198786,5522,'fr','Patients',0),(198787,5522,'jp','é¡§å®¢',0),(198788,5522,'pt','Pacientes',0),(198789,5522,'ru','Ð‘Ð¾Ð»ÑŒÐ½Ñ‹Ñ…',0),(198790,5522,'es','Pacientes',0),(198791,5522,'de','Patienten',0),(198792,5522,'en','Patients',0),(198793,5523,'is','',0),(198794,5523,'dr','(Ù…Ø´ØªØ±ÙŠØ§Ù†) Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§',0),(198795,5523,'pr','ØªØºÙŠÙŠØ± Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø·Ø¨Ù‚ Ø¨ÙŠÙ…Ø§Ø±Ø§Ù† Ø´Ù…Ø§(Ù…Ø´ØªØ±ÙŠØ§Ù†) Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§',0),(198796,5523,'tr','Burada hastalarÄ±na (mÃ¼ÅŸteriler) Ã¼zerinde bilgi deÄŸiÅŸtirme',0),(198797,5523,'pl','ZmieniÄ‡ na temat swoich pacjentÃ³w (klienci)',0),(198798,5523,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð¿Ð°Ñ†Ð¸ÐµÐ½Ñ‚Ð¸ (ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸) Ñ‚ÑƒÐº',0),(198799,5523,'ur','ÛŒÛØ§Úº Ø§Ù¾Ù†Û’ Ù…Ø±ÛŒØ¶ (Ú¯Ø§ÛÚ©ÙˆÚº) Ù¾Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(198800,5523,'sr','ÐŸÑ€ÐµÑÐµÐ´Ð°ÑšÐµ Ð˜Ð½Ñ„Ð¾ Ð¿Ð°Ñ†Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸Ð¼Ð° (ÐºÑƒÐ¿Ñ†Ð¸)',0),(198801,5523,'vi','Thay Ä‘á»•i thÃ´ng tin Bá»‡nh nhÃ¢n (khÃ¡ch hÃ ng) á»Ÿ Ä‘Ã¢y',0),(198802,5523,'af','Verander Inligting omtrent U Pasiente (KliÃ«nte) Hier',0),(198803,5523,'ro','Schimba informaÅ£ii despre dumneavoastrÄƒ pacienÅ£i (clienÅ£i) aici',0),(198804,5523,'et','Muuda infot oma patsientidele (kliendid) siin',0),(198805,5523,'si','Tukaj spremenite Info na vaÅ¡ bolniki (uporabniki)',0),(198806,5523,'ba','Mengubah Info pada pasien Anda (pelanggan) di sini',0),(198807,5523,'nl','Hier informatie over uw patiÃ«nten (klanten) wijzigen',0),(198808,5523,'fi','Muuttaa tietoja potilailla (asiakkaat) tÃ¤Ã¤llÃ¤',0),(198809,5523,'no','Endre informasjon om pasienter (kunder) her',0),(198810,5523,'da','Ã†ndre Info pÃ¥ dine patienter (kunder) her',0),(198811,5523,'ko','ì—¬ê¸° í™˜ìž (ê³ ê°)ì— ëŒ€ í•œ ì •ë³´ ë³€ê²½',0),(198812,5523,'he','×›××Ÿ ×©×™× ×•×™ ×¤×¨×˜×™ ×¢×œ ×”×ž×˜×•×¤×œ×™× ×©×œ×š (×œ×§×•×—×•×ª)',0),(198813,5523,'el','Î‘Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Î±ÏƒÎ¸ÎµÎ½ÎµÎ¯Ï‚ ÏƒÎ±Ï‚ (Ï€ÎµÎ»Î¬Ï„ÎµÏ‚) ÎµÎ´ÏŽ',0),(198814,5523,'zh','åœ¨è¿™é‡Œæ›´æ”¹æ‚¨çš„ç—…äººï¼ˆå®¢æˆ·ï¼‰çš„ä¿¡æ¯\r\n\r\n',0),(198815,5523,'sv','Ã„ndra information om dina patienter (kunder) hÃ¤r',0),(198816,5523,'it','Cambiare qui informazioni su vostri pazienti (clienti)',0),(198817,5523,'tl','',0),(198818,5523,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;',0),(198819,5523,'hi','à¤¯à¤¹à¤¾à¤ à¤…à¤ªà¤¨à¥‡ à¤°à¥‹à¤—à¤¿à¤¯à¥‹à¤‚ (à¤—à¥à¤°à¤¾à¤¹à¤•) à¤ªà¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(198820,5523,'ms','Tukar maklumat tentang pesakit anda (pelanggan) di sini',0),(198821,5523,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ Ø§Ù„Ù…Ø±Ø¶Ù‰ (Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡) Ù‡Ù†Ø§',0),(198822,5523,'fr','Modifier ici les infos sur vos Patients (clients)',0),(198823,5523,'jp','ã?“ã?“ã?§é¡§å®¢ã?®æƒ…å ±ã‚’å¤‰æ›´ã?™ã‚‹',0),(198824,5523,'pt','Alterar a informaÃ§Ã£o sobre seus pacientes (clientes) aqui',0),(198825,5523,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð¾ Ð²Ð°ÑˆÐ¸Ñ… Ð¿Ð°Ñ†Ð¸ÐµÐ½Ñ‚Ð¾Ð² (ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²) Ð·Ð´ÐµÑÑŒ',0),(198826,5523,'es','Cambiar Info Sobre sus Pacientes(Clientes) Aqui',0),(198827,5523,'de','Ã„ndern Sie hier Informationen Ã¼ber Ihre Patienten (Kunden)',0),(198828,5523,'en','Change Info on Your Patients (Customers) Here',0),(198829,5524,'is','',0),(198830,5524,'dr','Ù‚Ø³Ù…Øª Ø²ÙŠØ± Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(198831,5524,'pr','Ù‚Ø³Ù…Øª Ø²ÙŠØ± Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(198832,5524,'tr','Yeniden sÄ±ralama',0),(198833,5524,'pl','PoniÅ¼ej ponownego',0),(198834,5524,'bg','ÐŸÐ¾-Ð´Ð¾Ð»Ñƒ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(198835,5524,'ur','Ø±ÛŒÚ©Ø§Ø±ÚˆØ± Ù†ÛŒÚ†Û’',0),(198836,5524,'sr','Ð˜ÑÐ¿Ð¾Ð´ Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(198837,5524,'vi','ÄÆ¡n Äáº·t HÃ ng Láº¡i DÆ°á»›i ÄÃ¢y',0),(198838,5524,'af','Onder Herbestellingsvlak',0),(198839,5524,'ro','Reluare comandÄƒ de mai jos',0),(198840,5524,'et','VÃ¤iksem kordustellimus',0),(198841,5524,'si','Pod signalno',0),(198842,5524,'ba','Di bawah ini menyusun ulang',0),(198843,5524,'nl','Hieronder opnieuw ordenen',0),(198844,5524,'fi','Alla JÃ¤rjestÃ¤',0),(198845,5524,'no','Under ordne',0),(198846,5524,'da','Under Ordn igen',0),(198847,5524,'ko','ìž¬ì£¼ë¬¸ ì•„ëž˜',0),(198848,5524,'he','×œ×”×œ×Ÿ ×¡×“×¨ ×ž×—×“×©',0),(198849,5524,'el','Î Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(198850,5524,'zh','ä¸‹é¢é‡æ–°æŽ’åº\r\n',0),(198851,5524,'sv','Under ordna',0),(198852,5524,'it','Sotto riordino',0),(198853,5524,'tl','',0),(198854,5524,'th','&#3586;&#3657;&#3634;&#3591;&#3621;&#3656;&#3634;&#3591;&#3648;&#3611;&#3655;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(198855,5524,'hi','à¤¨à¥€à¤šà¥‡ à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(198856,5524,'ms','Di bawah susun semula',0),(198857,5524,'ar','Ø£Ø¯Ù†Ø§Ù‡ Ø¥Ø¹Ø§Ø¯Ø© ØªØ±ØªÙŠØ¨',0),(198858,5524,'fr','Sous rÃ©organiser',0),(198859,5524,'jp','å†?æ³¨æ–‡ã?®ä¸‹',0),(198860,5524,'pt','Abaixo reordenar',0),(198861,5524,'ru','ÐÐ¸Ð¶Ðµ ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾Ð³Ð¾ Ð—Ð°ÐºÐ°Ð·Ð°',0),(198862,5524,'es','Reordenar Abajo',0),(198863,5524,'de','Unter Reorder',0),(198864,5524,'en','Below Reorder',0),(198865,5525,'is','',0),(198866,5525,'dr','Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(198867,5525,'pr','Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(198868,5525,'tr','Ãœzerinde PO',0),(198869,5525,'pl','Na PO',0),(198870,5525,'bg','ÐÐ° PO',0),(198871,5525,'ur','Ù¾ÙˆØ³Ù¹ Ù¾Ø±',0),(198872,5525,'sr','ÐÐ° Ð¿Ð¾-Ð°',0),(198873,5525,'vi','TrÃªn Ä‘Æ¡n mua hÃ ng',0),(198874,5525,'af','OP AB',0),(198875,5525,'ro','Pe PO',0),(198876,5525,'et','Linna PO',0),(198877,5525,'si','Na PO',0),(198878,5525,'ba','Pada PO',0),(198879,5525,'nl','Op PO',0),(198880,5525,'fi','Kaupungin PO',0),(198881,5525,'no','PÃ¥ PO',0),(198882,5525,'da','PÃ¥ PO',0),(198883,5525,'ko','í¬ì—',0),(198884,5525,'he','×‘×¤×•',0),(198885,5525,'el','Î£Ï„Î·Î½ PO',0),(198886,5525,'zh','é‡‡è´­è®¢å•\r\n',0),(198887,5525,'sv','PÃ¥ PO',0),(198888,5525,'it','Sul PO',0),(198889,5525,'tl','',0),(198890,5525,'th','&#3610;&#3609;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(198891,5525,'hi','à¤ªà¤° à¤ªà¥‹',0),(198892,5525,'ms','Pada PO',0),(198893,5525,'ar','Ø¹Ù„Ù‰ Ø¨Ùˆ',0),(198894,5525,'fr','Sur PO',0),(198895,5525,'jp','ç™ºæ³¨æ›¸ä¸Š',0),(198896,5525,'pt','No PO',0),(198897,5525,'ru','ÐÐ° PO',0),(198898,5525,'es','En OC',0),(198899,5525,'de','Am PO',0),(198900,5525,'en','On PO',0),(198901,5526,'is','',0),(198902,5526,'dr','Ù…Ù‚Ø§Ø¯ÙŠØ± ',0),(198903,5526,'pr','Ù…Ù‚Ø§Ø¯ÙŠØ± ',0),(198904,5526,'tr','MiktarlarÄ±',0),(198905,5526,'pl','IloÅ›ci',0),(198906,5526,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(198907,5526,'ur','Ù…Ù‚Ø¯Ø§Ø±',0),(198908,5526,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(198909,5526,'vi','Sá»‘ lÆ°á»£ng ',0),(198910,5526,'af','Hoeveelhede',0),(198911,5526,'ro','CantitÄƒÅ£ile',0),(198912,5526,'et','Kogused',0),(198913,5526,'si','KoliÄine',0),(198914,5526,'ba','Jumlah',0),(198915,5526,'nl','Hoeveelheden',0),(198916,5526,'fi','MÃ¤Ã¤rÃ¤t',0),(198917,5526,'no','Antall',0),(198918,5526,'da','MÃ¦ngder',0),(198919,5526,'ko','ìˆ˜ëŸ‰',0),(198920,5526,'he','×›×ž×•×™×•×ª',0),(198921,5526,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚',0),(198922,5526,'zh','æ•°é‡\r\n',0),(198923,5526,'sv','Kvantiteter',0),(198924,5526,'it','Quantitativi',0),(198925,5526,'tl','',0),(198926,5526,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(198927,5526,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(198928,5526,'ms','Kuantiti yang',0),(198929,5526,'ar','ÙƒÙ…ÙŠØ§Øª',0),(198930,5526,'fr','QuantitÃ©s',0),(198931,5526,'jp','æ•°é‡?',0),(198932,5526,'pt','Quantidades',0),(198933,5526,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(198934,5526,'es','Cantidades',0),(198935,5526,'de','Mengen',0),(198936,5526,'en','Quantities',0),(198937,5527,'is','',0),(198938,5527,'dr','Ø³ÙØ§Ø±Ø´ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ Ø´Ø¯Ù‡ ',0),(198939,5527,'pr','Ø³ÙØ§Ø±Ø´ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ Ø´Ø¯Ù‡ ',0),(198940,5527,'tr','Ã–nerilen sipariÅŸ',0),(198941,5527,'pl','Sugerowane zlecenia',0),(198942,5527,'bg','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(198943,5527,'ur','ØªØ¬ÙˆÛŒØ² Ú©Ø±Ø¯Û ØªØ±ØªÛŒØ¨',0),(198944,5527,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ… Ð½Ð°Ð»Ð¾Ð³Ð°',0),(198945,5527,'vi','Gá»£i Ã½ Ä‘Æ¡n hÃ ng',0),(198946,5527,'af','Voorgestelde Bestelling',0),(198947,5527,'ro','Sugerat ordine',0),(198948,5527,'et','Soovitatud jÃ¤rjekorras',0),(198949,5527,'si','Predlagal vrstni red',0),(198950,5527,'ba','Disarankan agar',0),(198951,5527,'nl','Voorgestelde Order',0),(198952,5527,'fi','JÃ¤rjestyksessÃ¤',0),(198953,5527,'no','ForeslÃ¥tte rekkefÃ¸lge',0),(198954,5527,'da','ForeslÃ¥ede rÃ¦kkefÃ¸lge',0),(198955,5527,'ko','ì œì•ˆ ëœ ìˆœì„œ',0),(198956,5527,'he','×”×¡×“×¨ ×”×ž×•×¦×¢',0),(198957,5527,'el','Î ÏÎ¿Ï„ÎµÎ¹Î½ÏŒÎ¼ÎµÎ½Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(198958,5527,'zh','å»ºè®®çš„é¡ºåº\r\n',0),(198959,5527,'sv','FÃ¶reslagna ordningen',0),(198960,5527,'it','Ordine suggerito',0),(198961,5527,'tl','',0),(198962,5527,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3649;&#3609;&#3632;&#3609;&#3635;',0),(198963,5527,'hi','à¤¸à¥à¤à¤¾à¤ à¤—à¤ à¤•à¥à¤°à¤®',0),(198964,5527,'ms','Perintah yang dicadangkan',0),(198965,5527,'ar','Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ù…Ù‚ØªØ±Ø­',0),(198966,5527,'fr','Ordre suggÃ©rÃ©',0),(198967,5527,'jp','æ??æ¡ˆã?•ã‚Œã?Ÿæ³¨æ–‡',0),(198968,5527,'pt','Ordem sugerida',0),(198969,5527,'ru','ÐŸÑ€ÐµÐ´Ð»Ð°Ð³Ð°ÐµÐ¼Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(198970,5527,'es','Orden Sugerido',0),(198971,5527,'de','Vorgeschlagene Reihenfolge',0),(198972,5527,'en','Suggested Order',0),(198973,5528,'is','',0),(198974,5528,'dr','Ø§ÙƒÙ†ÙˆÙ† Ù…Ø±ØªØ¨ ÙƒÙ†ÙŠØ¯',0),(198975,5528,'pr','Ø§ÙƒÙ†ÙˆÙ† Ù…Ø±ØªØ¨ ÙƒÙ†ÙŠØ¯',0),(198976,5528,'tr','Åžimdi sipariÅŸ',0),(198977,5528,'pl','ZamÃ³w teraz',0),(198978,5528,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹ ÑÐµÐ³Ð°',0),(198979,5528,'ur','Ø§Ø¨ Ø¢Ø±ÚˆØ±',0),(198980,5528,'sr','ÐÐ°Ñ€ÑƒÑ†Ð¸Ñ‚Ðµ Ð¾Ð´Ð¼Ð°Ñ…',0),(198981,5528,'vi','Äáº·t hÃ ng ngay bÃ¢y giá»',0),(198982,5528,'af','Bestel Nou',0),(198983,5528,'ro','Comanda acum',0),(198984,5528,'et','Telli kohe',0),(198985,5528,'si','NaroÄite zdaj',0),(198986,5528,'ba','Order sekarang',0),(198987,5528,'nl','Bestel nu',0),(198988,5528,'fi','Tilaa nyt',0),(198989,5528,'no','Bestill nÃ¥',0),(198990,5528,'da','Bestil nu',0),(198991,5528,'ko','ì§€ê¸ˆ ì£¼ë¬¸',0),(198992,5528,'he','×”×–×ž×Ÿ ×›×¢×ª',0),(198993,5528,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï„ÏŽÏÎ±',0),(198994,5528,'zh','ç«‹å³è®¢è´­\r\n',0),(198995,5528,'sv','BestÃ¤ll nu',0),(198996,5528,'it','Ordine ora',0),(198997,5528,'tl','',0),(198998,5528,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(198999,5528,'hi','à¤†à¤¦à¥‡à¤¶ à¤…à¤¬',0),(199000,5528,'ms','Tempah sekarang',0),(199001,5528,'ar','Ø£Ø·Ù„Ø¨ Ø§Ù„Ø¢Ù†',0),(199002,5528,'fr','Commandez maintenant',0),(199003,5528,'jp','ä»Šæ³¨æ–‡ã?™ã‚‹',0),(199004,5528,'pt','Ordem agora',0),(199005,5528,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¡ÐµÐ¹Ñ‡Ð°Ñ',0),(199006,5528,'es','Ordenar Ahora',0),(199007,5528,'de','Jetzt bestellen',0),(199008,5528,'en','Order Now',0),(199009,5529,'is','',0),(199010,5529,'dr','/ Ø±ÙˆØ´ Ù‡Ø§',0),(199011,5529,'pr','ØªØ¹ÙŠÙŠÙ† Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´  Ø¨Ø±Ø§ÙŠ  Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ Ù‡Ø§ / Ø±ÙˆØ´ Ù‡Ø§',0),(199012,5529,'tr','GÃ¶rÃ¼ntÃ¼leme sÄ±rasÄ± taÅŸÄ±yÄ±cÄ±larÄ±/yÃ¶ntemleri atama',0),(199013,5529,'pl','PrzypisaÄ‡ kolejnoÅ›Ä‡ wyÅ›wietlania przewoÅºnikÃ³w/metody',0),(199014,5529,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´Ð° Ð½Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡Ð¸/Ð¼ÐµÑ‚Ð¾Ð´Ð¸',0),(199015,5529,'ur','ÚˆØ³Ù¾Ù„Û’ Ø­Ú©Ù… Ø¨Ø±Ø¯Ø§Ø±/Ø·Ø±ÛŒÙ‚ÙˆÚº Ú©Ùˆ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(199016,5529,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð´Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ð¸ Ð½Ð¾ÑÐ¸Ð¾Ñ†Ð¸/Ð¼ÐµÑ‚Ð¾Ð´Ðµ',0),(199017,5529,'vi','Chá»‰ Äá»‹nh Hiá»ƒn Thá»‹ ÄÆ¡n Äáº·t HÃ ng Theo HÃ£ng Váº­n Chuyá»ƒn/PhÆ°Æ¡ng Thá»©c',0),(199018,5529,'af','Wys vertoon orde vir draers/metodes',0),(199019,5529,'ro','AtribuiÅ£i ordinea de afiÅŸare a operatorilor de transport/metode',0),(199020,5529,'et','KuvamisjÃ¤rjestuse mÃ¤Ã¤ramiseks vedajate/meetodid',0),(199021,5529,'si','Vrstni red prikaza dodeliti prevozniki/metode',0),(199022,5529,'ba','Menetapkan urutan tampilan ke operator/metode',0),(199023,5529,'nl','Weergavevolgorde toewijzen aan vervoerders/methoden',0),(199024,5529,'fi','MÃ¤Ã¤rittÃ¤Ã¤ jÃ¤rjestyksen harjoittajien/menetelmÃ¤t',0),(199025,5529,'no','Tilordne visningsrekkefÃ¸lgen til operatÃ¸rer/metoder',0),(199026,5529,'da','Tildele visningsrÃ¦kkefÃ¸lgen til luftfartsselskaber/metoder',0),(199027,5529,'ko','ì‚¬ì—…ìž/ë°©ë²• í‘œì‹œ ìˆœì„œë¥¼ ì§€ì •',0),(199028,5529,'he','×œ×”×§×¦×•×ª ×¡×“×¨ ×”×ª×¦×•×’×” × ×•×©××•×ª/×©×™×˜×•×ª',0),(199029,5529,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ ÏƒÎµÎ¹ÏÎ¬ ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ·Ï‚ ÏƒÎµ Î¼ÎµÏ„Î±Ï†Î¿ÏÎµÎ¯Ï‚/Î¼ÎµÎ¸ÏŒÎ´Î¿Ï…Ï‚',0),(199030,5529,'zh','æŒ‡å®šæ˜¾ç¤ºé¡ºåºä¸ºè¿è¥å•†/æ–¹æ³•\r\n',0),(199031,5529,'sv','Tilldela visningsordningen bÃ¤rare/metoder',0),(199032,5529,'it','Assegnare l\'ordine di visualizzazione ai vettori/metodi',0),(199033,5529,'tl','',0),(199034,5529,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;&#3649;&#3626;&#3604;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3641;&#3656;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;/&#3623;&#3636;&#3608;&#',0),(199035,5529,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¥à¤°à¤® à¤µà¤¾à¤¹à¤•/à¤µà¤¿à¤§à¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(199036,5529,'ms','Peruntukkan susunan paparan kepada pembawa/kaedah',0),(199037,5529,'ar','ØªØ¹ÙŠÙŠÙ† ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ø±Ø¶ Ù„Ù„Ù†Ø§Ù‚Ù„ÙŠÙ†/Ø£Ø³Ø§Ù„ÙŠØ¨',0),(199038,5529,'fr','Attribuer l\'ordre d\'affichage aux transporteurs/mÃ©thodes',0),(199039,5529,'jp','ç™ºé€?æ¥­è€…/æ–¹æ³•ã?®è¡¨ç¤ºé †ã?®å‰²ã‚Šå½“ã?¦',0),(199040,5529,'pt','Atribuir a ordem de exibiÃ§Ã£o para as transportadoras/mÃ©todos',0),(199041,5529,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ Ð´Ð»Ñ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸ÐºÐ¾Ð²/Ð¼ÐµÑ‚Ð¾Ð´Ñ‹',0),(199042,5529,'es','Asignar Pedido de Desplegar a Transportadores/MÃ©todos',0),(199043,5529,'de','TrÃ¤ger/Methoden Anzeigereihenfolge zuweisen',0),(199044,5529,'en','Assign Display Order to Carriers/Methods',0),(199045,5530,'is','',0),(199046,5530,'dr','/Ø±ÙˆØ´ Ù†Ù…Ø§ÙŠØ´ ÙØ±Ù…Ø§ÛŒØ´',0),(199047,5530,'pr','Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ /Ø±ÙˆØ´ Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´',0),(199048,5530,'tr','TaÅŸÄ±yÄ±cÄ±/yÃ¶ntem gÃ¶rÃ¼ntÃ¼leme sÄ±rasÄ±',0),(199049,5530,'pl','KolejnoÅ›Ä‡ wyÅ›wietlania przewoÅºnika/Metoda',0),(199050,5530,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡/Ð¼ÐµÑ‚Ð¾Ð´Ð° Ð´Ð¸ÑÐ¿Ð»ÐµÐ¹ Ñ€ÐµÐ´',0),(199051,5530,'ur','Ú©ÛŒØ±ÛŒØ¦Ø±/Ø·Ø±ÛŒÙ‚Û ÚˆØ³Ù¾Ù„Û’ ØªØ±ØªÛŒØ¨',0),(199052,5530,'sr','ÐÐ¾ÑÐ°Ñ‡ /Ð½Ð°Ñ‡Ð¸Ð½ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(199053,5530,'vi','HÃ£ng Váº­n Chuyá»ƒn/PhÆ°Æ¡ng Thá»©c Äáº·t HÃ ng',0),(199054,5530,'af','Wys Bestelling Karweier/Metode',0),(199055,5530,'ro','Ordinea de afiÅŸare transportator/metoda',0),(199056,5530,'et','Vedaja/meetod kuvamise jÃ¤rjestus',0),(199057,5530,'si','Vrstni red prikaza prevoznik/metoda',0),(199058,5530,'ba','Urutan tampilan pembawa metode',0),(199059,5530,'nl','De orde van de vertoning van de vervoerder/methode',0),(199060,5530,'fi','Operaattorin/menetelmÃ¤llÃ¤ nÃ¤yttÃ¶jÃ¤rjestys',0),(199061,5530,'no','TransportÃ¸r/metode visningsrekkefÃ¸lgen',0),(199062,5530,'da','Carrier/metode visningsrÃ¦kkefÃ¸lgen',0),(199063,5530,'ko','ìºë¦¬ì–´/ë©”ì„œë“œ í‘œì‹œ ìˆœì„œ',0),(199064,5530,'he','×¡×“×¨ ×”×ª×¦×•×’×” ×”×ž×•×‘×™×œ/×¤×¢×•×œ×ª ×©×™×¨×•×ª',0),(199065,5530,'el','Î£ÎµÎ¹ÏÎ¬ ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ·Ï‚/Î¼Î­Î¸Î¿Î´Î¿ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(199066,5530,'zh','æ‰¿è¿äºº/æ–¹æ³•æ˜¾ç¤ºé¡ºåº\r\n',0),(199067,5530,'sv','BÃ¤rare/metod visningsordning',0),(199068,5530,'it','Ordine di visualizzazione di vettore/metodo',0),(199069,5530,'tl','',0),(199070,5530,'th','&#3649;&#3626;&#3604;&#3591;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;/&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#',0),(199071,5530,'hi','à¤µà¤¾à¤¹à¤•/à¤µà¤¿à¤§à¤¿ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¥à¤°à¤®',0),(199072,5530,'ms','Susunan paparan pembawa/kaedah',0),(199073,5530,'ar','ØªØ±ØªÙŠØ¨ Ø¹Ø±Ø¶ Ø§Ù„Ù†Ø§Ù‚Ù„/Ø§Ù„Ø£Ø³Ù„ÙˆØ¨',0),(199074,5530,'fr','Ordre d\'affichage de transporteur/mÃ©thode',0),(199075,5530,'jp','ç™ºé€?æ¥­è€…/æ–¹æ³•ã?®è¡¨ç¤ºé †',0),(199076,5530,'pt','Ordem de exibiÃ§Ã£o do portador/mÃ©todo',0),(199077,5530,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº/Ð¼ÐµÑ‚Ð¾Ð´',0),(199078,5530,'es','Transportador/MÃ©todo Pedido de Deplegar',0),(199079,5530,'de','TrÃ¤ger/Methode Anzeigereihenfolge',0),(199080,5530,'en','Carrier/Method Display Order',0),(199081,5531,'is','',0),(199082,5531,'dr','ØªØ¹ÙŠÙŠÙ† Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´',0),(199083,5531,'pr','ØªØ¹ÙŠÙŠÙ† Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´',0),(199084,5531,'tr','GÃ¶rÃ¼ntÃ¼leme sÄ±rasÄ± atamak',0),(199085,5531,'pl','PrzypisaÄ‡ kolejnoÅ›Ä‡ wyÅ›wietlania',0),(199086,5531,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´Ð° Ð½Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ',0),(199087,5531,'ur','ÚˆØ³Ù¾Ù„Û’ ØªØ±ØªÛŒØ¨ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(199088,5531,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´',0),(199089,5531,'vi','Chá»‰ Äá»‹nh Hiá»ƒn Thá»‹ ÄÆ¡n Äáº·t HÃ ng ',0),(199090,5531,'af','Wys vertoon orde',0),(199091,5531,'ro','AtribuiÅ£i ordinea de afiÅŸare',0),(199092,5531,'et','JÃ¤rjekorra mÃ¤Ã¤ramine',0),(199093,5531,'si','DoloÄite vrstni red prikaza',0),(199094,5531,'ba','Menetapkan urutan tampilan',0),(199095,5531,'nl','Weergavevolgorde toewijzen',0),(199096,5531,'fi','MÃ¤Ã¤rittÃ¤Ã¤ jÃ¤rjestyksen',0),(199097,5531,'no','Tilordne visningsrekkefÃ¸lgen',0),(199098,5531,'da','Tildele visningsrÃ¦kkefÃ¸lgen',0),(199099,5531,'ko','í‘œì‹œ ìˆœì„œë¥¼ ì§€ì •',0),(199100,5531,'he','×œ×”×§×¦×•×ª ×¡×“×¨ ×”×ª×¦×•×’×”',0),(199101,5531,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ ÏƒÎµÎ¹ÏÎ¬ ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ·Ï‚',0),(199102,5531,'zh','æŒ‡å®šæ˜¾ç¤ºé¡ºåº\r\n',0),(199103,5531,'sv','Tilldela visningsordning',0),(199104,5531,'it','Assegnare l\'ordine di visualizzazione',0),(199105,5531,'tl','',0),(199106,5531,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(199107,5531,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¥à¤°à¤® à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(199108,5531,'ms','Peruntukkan susunan paparan',0),(199109,5531,'ar','ØªØ¹ÙŠÙŠÙ† ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ø±Ø¶',0),(199110,5531,'fr','Attribuer l\'ordre d\'affichage',0),(199111,5531,'jp','è¡¨ç¤ºé †ã?®å‰²ã‚Šå½“ã?¦',0),(199112,5531,'pt','Atribuir a ordem de exibiÃ§Ã£o',0),(199113,5531,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(199114,5531,'es','Asignar Pedido de Desplegar',0),(199115,5531,'de','Anzeigereihenfolge zuweisen',0),(199116,5531,'en','Assign Display Order',0),(199117,5532,'is','',0),(199118,5532,'dr','(ØªØ°ÙƒØ±) Ø¨ÛŒØ¬Ú© ',0),(199119,5532,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª (ØªØ°ÙƒØ±) ÙØ§ÙƒØªÙˆØ± ',0),(199120,5532,'tr','VarsayÄ±lan Fatura Not',0),(199121,5532,'pl','Uwaga DomyÅ›lnie faktury',0),(199122,5532,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(199123,5532,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÙˆÙ¹',0),(199124,5532,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(199125,5532,'vi','Ghi chÃº hÃ³a Ä‘Æ¡n máº·c Ä‘á»‹nh',0),(199126,5532,'af','Verstekte Faktuurnota',0),(199127,5532,'ro','Mesaj factura',0),(199128,5532,'et','Vaikimisi mÃ¤rkus arvel',0),(199129,5532,'si','Opomba privzeti raÄun',0),(199130,5532,'ba','Default faktur catatan',0),(199131,5532,'nl','Standaard factuur Opmerking',0),(199132,5532,'fi','Oletusarvoisesti laskun Huomautus',0),(199133,5532,'no','Standard fakturaen Merk',0),(199134,5532,'da','Standard faktura BemÃ¦rk',0),(199135,5532,'ko','ê¸°ë³¸ ì†¡ìž¥ ì°¸ê³ ',0),(199136,5532,'he','×”×¢×¨×” ×—×©×‘×•× ×™×ª ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(199137,5532,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(199138,5532,'zh','é»˜è®¤å‘ç¥¨è¯´æ˜Ž\r\n',0),(199139,5532,'sv','Standard faktura Obs',0),(199140,5532,'it','Nota fattura predefinito',0),(199141,5532,'tl','',0),(199142,5532,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(199143,5532,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¥‹à¤Ÿ',0),(199144,5532,'ms','Lalai invois Nota',0),(199145,5532,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(199146,5532,'fr','Note de facture par dÃ©faut',0),(199147,5532,'jp','æ—¢å®šã?®è«‹æ±‚æ›¸ãƒ¡ãƒ¢',0),(199148,5532,'pt','Nota de fatura padrÃ£o',0),(199149,5532,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÑÑ‡ÐµÑ‚Ð°',0),(199150,5532,'es','Nota de Factura por Defecto',0),(199151,5532,'de','Standard Rechnung Hinweis',0),(199152,5532,'en','Default Invoice Note',0),(199153,5533,'is','',0),(199154,5533,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ÙØ§ÙƒØªÙˆØ± ',0),(199155,5533,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ÙØ§ÙƒØªÙˆØ± ',0),(199156,5533,'tr','VarsayÄ±lan Fatura fiyat birimi',0),(199157,5533,'pl','DomyÅ›lnie faktura cena jednostki',0),(199158,5533,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ†ÐµÐ½Ð°',0),(199159,5533,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ù†ÙˆØ§Ø¦Ø³ Ù‚ÛŒÙ…Øª ÛŒÙˆÙ†Ù¹',0),(199160,5533,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ñ†ÐµÐ½Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(199161,5533,'vi','ÄÆ¡n vá»‹ giÃ¡ HÃ³a Ä‘Æ¡n máº·c Ä‘á»‹nh',0),(199162,5533,'af','Verstek faktuur prys eenheid',0),(199163,5533,'ro','Pret unitar factura',0),(199164,5533,'et','Vaikimisi arve hinnaÃ¼hik',0),(199165,5533,'si','Privzeti raÄun cena enote',0),(199166,5533,'ba','Default faktur harga Unit',0),(199167,5533,'nl','Standaardeenheid factuur prijs',0),(199168,5533,'fi','OletusyksikkÃ¶ laskun hinta',0),(199169,5533,'no','Standard faktura prisenhet',0),(199170,5533,'da','Standard faktura prisenhed',0),(199171,5533,'ko','ê¸°ë³¸ ì†¡ìž¥ ê°€ê²© ë‹¨ìœ„',0),(199172,5533,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×—×©×‘×•× ×™×ª ×ž×—×™×¨ ×”×™×—×™×“×”',0),(199173,5533,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¼Î¿Î½Î¬Î´Î± Ï„Î¹Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(199174,5533,'zh','é»˜è®¤å‘ç¥¨ä»·æ ¼å•ä½\r\n',0),(199175,5533,'sv','Standard faktura prisenhet',0),(199176,5533,'it','UnitÃ  di misura predefinita fattura prezzo',0),(199177,5533,'tl','',0),(199178,5533,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(199179,5533,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤•à¤¾à¤ˆ',0),(199180,5533,'ms','Lalai invois harga Unit',0),(199181,5533,'ar','ÙˆØ­Ø¯Ø© Ø³Ø¹Ø± Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(199182,5533,'fr','UnitÃ© de prix de facturation par dÃ©faut',0),(199183,5533,'jp','æ—¢å®šè«‹æ±‚æ›¸ä¾¡æ ¼å?˜ä½?',0),(199184,5533,'pt','Unidade de preÃ§o de factura de padrÃ£o',0),(199185,5533,'ru','Ð¦ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹ ÑÑ‡ÐµÑ‚Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(199186,5533,'es','Precio de Unidad de Factura por Defecto',0),(199187,5533,'de','Rechnung Preis Standardeinheit',0),(199188,5533,'en','Default Invoice Price Unit',0),(199189,5534,'is','',0),(199190,5534,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ ÙˆØ§Ø­Ø¯ ÙØ±ÙˆØ´ ÙØ§ÙƒØªÙˆØ±',0),(199191,5534,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ ÙˆØ§Ø­Ø¯ ÙØ±ÙˆØ´ ÙØ§ÙƒØªÙˆØ±',0),(199192,5534,'tr','VarsayÄ±lan Fatura satÄ±ÅŸ birimi',0),(199193,5534,'pl','DomyÅ›lnÄ… jednostkÄ… sprzedaÅ¼y faktura',0),(199194,5534,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(199195,5534,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ù†ÙˆØ§Ø¦Ø³ ÙØ±ÙˆØ®Øª ÛŒÙˆÙ†Ù¹',0),(199196,5534,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ ÐºÑƒÐ¿Ñ†Ñƒ',0),(199197,5534,'vi','ÄÆ¡n vá»‹ bÃ¡n HÃ³a Ä‘Æ¡n máº·c Ä‘á»‹nh',0),(199198,5534,'af','Verstekte Verkoopte Faktuureenheid',0),(199199,5534,'ro','Unitate de vanzare factura',0),(199200,5534,'et','Vaikimisi arve mÃ¼Ã¼giÃ¼hik',0),(199201,5534,'si','Privzeti raÄun prodaja enote',0),(199202,5534,'ba','Default faktur Jual Unit',0),(199203,5534,'nl','Standaardeenheid factuur verkopen',0),(199204,5534,'fi','Laskun myydÃ¤ OletusyksikkÃ¶',0),(199205,5534,'no','Faktura selge standardenhet',0),(199206,5534,'da','Standard faktura sÃ¦lge enhed',0),(199207,5534,'ko','ê¸°ë³¸ ì†¡ìž¥ íŒë§¤ ë‹¨ìœ„',0),(199208,5534,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×—×©×‘×•× ×™×ª ×œ×ž×›×•×¨ ×”×™×—×™×“×”',0),(199209,5534,'el','Î Ï‰Î»Î®ÏƒÏ„Îµ Ï„Î· Î¼Î¿Î½Î¬Î´Î± Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(199210,5534,'zh','é»˜è®¤å‘ç¥¨ä¾›åº”å•ä½\r\n',0),(199211,5534,'sv','Standard faktura sÃ¤ljer enheten',0),(199212,5534,'it','UnitÃ  di misura predefinita fattura vendita',0),(199213,5534,'tl','',0),(199214,5534,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(199215,5534,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¬à¥‡à¤š à¤‡à¤•à¤¾à¤ˆ',0),(199216,5534,'ms','Lalai invois menjual Unit',0),(199217,5534,'ar','ÙˆØ­Ø¯Ø© Ø¨ÙŠØ¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(199218,5534,'fr','UnitÃ© de vente facture par dÃ©faut',0),(199219,5534,'jp','æ—¢å®šè«‹æ±‚æ›¸è²©å£²å?˜ä½?',0),(199220,5534,'pt','Unidade de venda padrÃ£o factura',0),(199221,5534,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÑÑ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ñ‚ÑŒ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(199222,5534,'es','Unidad de Venta de Factura por Defecto',0),(199223,5534,'de','Rechnung verkaufen Standardeinheit',0),(199224,5534,'en','Default Invoice Sell Unit',0),(199225,5535,'is','',0),(199226,5535,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¯Ø±Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(199227,5535,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¯Ø±Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(199228,5535,'tr','VarsayÄ±lan satÄ±ÅŸ birim fiyatÄ± birim baÅŸÄ±na',0),(199229,5535,'pl','DomyÅ›lne jednostki sprzedaÅ¼ jednostkowa cena',0),(199230,5535,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð°',0),(199231,5535,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù‚ÛŒÙ…Øª Ø·Û’ Ø´Ø¯Û ÙØ±ÙˆØ®Øª ÛŒÙˆÙ†Ù¹Ø³',0),(199232,5535,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ñ†ÐµÐ½Ð°',0),(199233,5535,'vi','ÄÆ¡n vá»‹ bÃ¡n máº·c Ä‘á»‹nh má»—i Ä‘Æ¡n vá»‹ giÃ¡',0),(199234,5535,'af','Verstekte Verkoopte Eenhede per Eenheidsprys',0),(199235,5535,'ro','Unitate de vanzare / pret unitar ',0),(199236,5535,'et','MÃ¼Ã¼a Ã¼hikud hinnaÃ¼hiku kohta',0),(199237,5535,'si','Privzeto prodaja enot po ceni',0),(199238,5535,'ba','Default menjual unit per Unit harga',0),(199239,5535,'nl','Standaard verkopen eenheden per prijs eenheid',0),(199240,5535,'fi','Myy oletusyksikÃ¶t hintayksikkÃ¶Ã¤ kohti',0),(199241,5535,'no','Standard selger enheter per prisenhet',0),(199242,5535,'da','Standard sÃ¦lge enheder pr. prisenhed',0),(199243,5535,'ko','ê°€ê²© ë‹¨ìœ„ ë‹¹ ê¸°ë³¸ íŒë§¤ ë‹¨ìœ„',0),(199244,5535,'he','×™×—×™×“×•×ª ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×œ×ž×›×•×¨ ×‘×›×œ ×ž×—×™×¨ ×™×—×™×“×”',0),(199245,5535,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Î¼Î¿Î½Î¬Î´ÎµÏ‚ Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚ Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Ï„Î¹Î¼Î®',0),(199246,5535,'zh','é»˜è®¤æ¯å•ä½ä»·æ ¼ä¾›åº”å•ä½\r\n',0),(199247,5535,'sv','Standard sÃ¤lja enheter per prisenhet',0),(199248,5535,'it','Predefinito vendere unitÃ  prezzo unitario',0),(199249,5535,'tl','',0),(199250,5535,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(199251,5535,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¬à¥‡à¤š à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤•à¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯',0),(199252,5535,'ms','Lalai menjual unit-unit harga seunit',0),(199253,5535,'ar','Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ø¨ÙŠØ¹ ÙˆØ­Ø¯Ø§Øª ÙƒÙ„ ÙˆØ­Ø¯Ø© Ø³Ø¹Ø±',0),(199254,5535,'fr','UnitÃ©s de vente par dÃ©faut prix unitaire',0),(199255,5535,'jp','å?˜ä¾¡ã?”ã?¨ã?®æ—¢å®šè²©å£²æ•°',0),(199256,5535,'pt','Unidades de venda padrÃ£o preÃ§o unitÃ¡rio',0),(199257,5535,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¿Ñ€Ð¾Ð´Ð°Ñ‚ÑŒ ÐµÐ´Ð¸Ð½Ð¸Ñ† Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ Ñ†ÐµÐ½Ñ‹',0),(199258,5535,'es','Unidades de Venta por Defecto por Unidad de Precio',0),(199259,5535,'de','Verkauf Standardeinheiten pro Preiseinheit',0),(199260,5535,'en','Default Sell Units per Price Unit',0),(199261,5536,'is','',0),(199262,5536,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø´ØªØ±ÙŠ',0),(199263,5536,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø´ØªØ±ÙŠ',0),(199264,5536,'tr','Ä°stemci PO',0),(199265,5536,'pl','Klient PO',0),(199266,5536,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ PO',0),(199267,5536,'ur','ÙˆØµÙˆÙ„ Ú©Ø§Ø± Ù¾Ùˆ',0),(199268,5536,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð° ÐŸÐž',0),(199269,5536,'vi','ÄÆ¡n mua hÃ ng cá»§a KhÃ¡ch hÃ ng',0),(199270,5536,'af','Klient AB',0),(199271,5536,'ro','Clientul PO',0),(199272,5536,'et','Kliendi PO',0),(199273,5536,'si','Odjemalec PO',0),(199274,5536,'ba','Klien PO',0),(199275,5536,'nl','Client PO',0),(199276,5536,'fi','Asiakkaan PO',0),(199277,5536,'no','Klienten PO',0),(199278,5536,'da','Klienten PO',0),(199279,5536,'ko','í´ë¼ì´ì–¸íŠ¸ í¬',0),(199280,5536,'he','×œ×§×•×— ×¤×•',0),(199281,5536,'el','Î ÎµÎ»Î¬Ï„Î· Î±Î½Î¬',0),(199282,5536,'zh','å®¢æˆ·é‡‡è´­è®¢å•\r\n',0),(199283,5536,'sv','Klienten PO',0),(199284,5536,'it','Client PO',0),(199285,5536,'tl','',0),(199286,5536,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3592;&#3657;&#3634;&#3591;',0),(199287,5536,'hi','à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ à¤ªà¥‹',0),(199288,5536,'ms','Pelanggan PO',0),(199289,5536,'ar','Ø¹Ù…ÙŠÙ„ Ø¨Ø±ÙŠØ¯',0),(199290,5536,'fr','Client PO',0),(199291,5536,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆç™ºæ³¨æ›¸',0),(199292,5536,'pt','Cliente PO',0),(199293,5536,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ PO',0),(199294,5536,'es','Cliente OP',0),(199295,5536,'de','Client PO',0),(199296,5536,'en','Client PO',0),(199297,5537,'is','',0),(199298,5537,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(199299,5537,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(199300,5537,'tr','VarsayÄ±lan saat baÅŸÄ±na maliyeti',0),(199301,5537,'pl','DomyÅ›lny koszt za godzinÄ™',0),(199302,5537,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ñ‡Ð°Ñ',0),(199303,5537,'ur','Ø·Û’ Ø´Ø¯Û Ù‚ÛŒÙ…Øª ÙÛŒ Ú¯Ú¾Ù†Ù¹Û',0),(199304,5537,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ ÑÐ°Ñ‚Ñƒ',0),(199305,5537,'vi','Chi PhÃ­ má»—i giá» máº·c Ä‘á»‹nh',0),(199306,5537,'af','Verstekte Koste per Uur',0),(199307,5537,'ro','Cost implicitÄƒ pe orÄƒ',0),(199308,5537,'et','Vaikimisi on tunnikulu',0),(199309,5537,'si','Privzeti stroÅ¡ek na uro',0),(199310,5537,'ba','Standar biaya per jam',0),(199311,5537,'nl','Standaard de kostenwaarde per uur',0),(199312,5537,'fi','Oletuksena tuntikustannus',0),(199313,5537,'no','Standard kostnad per time',0),(199314,5537,'da','Standardomkostningen pr. time',0),(199315,5537,'ko','ì‹œê°„ë‹¹ ê¸°ë³¸ ë¹„ìš©',0),(199316,5537,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×œ×•×ª ×œ×©×¢×”',0),(199317,5537,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ ÏŽÏÎ±',0),(199318,5537,'zh','è¿çº¦æˆæœ¬æ¯å°æ—¶\r\n',0),(199319,5537,'sv','Standard kostnad per timme',0),(199320,5537,'it','Costo predefinito all\'ora',0),(199321,5537,'tl','',0),(199322,5537,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(199323,5537,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾',0),(199324,5537,'ms','Lalai kos setiap jam',0),(199325,5537,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠØ© Ù„Ù„Ø³Ø§Ø¹Ø©',0),(199326,5537,'fr','CoÃ»t par dÃ©faut Ã  l\'heure',0),(199327,5537,'jp','æ—¢å®šæ™‚é–“æ¯Žè²»ç”¨',0),(199328,5537,'pt','Custo padrÃ£o por hora',0),(199329,5537,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð·Ð° Ñ‡Ð°Ñ',0),(199330,5537,'es','Costo por Hora por Defecto',0),(199331,5537,'de','Standardkosten pro Stunde',0),(199332,5537,'en','Default Cost per Hour',0),(199333,5538,'is','',0),(199334,5538,'dr','ÙƒØ§Ù…Ù„ ÙƒÙ†ÙŠØ¯ ÙÙ‚Ø· Ø§Ú¯Ø± Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ÙŠÙƒ Ù¾ÙŠÙ…Ø§Ù†ÙƒØ§Ø± Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ ',0),(199335,5538,'pr','ÙƒØ§Ù…Ù„ ÙƒÙ†ÙŠØ¯ ÙÙ‚Ø· Ø§Ú¯Ø± Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ÙŠÙƒ Ù¾ÙŠÙ…Ø§Ù†ÙƒØ§Ø± Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ ',0),(199336,5538,'tr','EÄŸer satÄ±cÄ± yÃ¼klenici olarak servis sipariÅŸleri iÃ§in kullanÄ±lan <u>yalnÄ±zca</u> iÃ§inde doldurmak',0),(199337,5538,'pl','WypeÅ‚niÄ‡ <u>tylko</u> JeÅ›li dostawca stosuje siÄ™ jako wykonawca zleceÅ„ serwisowych',0),(199338,5538,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ <u>ÑÐ°Ð¼Ð¾</u> Ð°ÐºÐ¾ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° ÐºÐ°Ñ‚Ð¾ Ð¸Ð·Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ» Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(199339,5538,'ur','<u>ØµØ±Ù</u> Ù…ÛŒÚº Ø¨Ú¾Ø±ÛŒÚº ØªÙˆ ÙˆÛŒÙ†ÚˆØ± Ù¹Ú¾ÛŒÚ©ÛŒØ¯Ø§Ø± Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø®Ø¯Ù…Øª Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(199340,5538,'sr','ÐŸÐ¾Ð¿ÑƒÐ½Ð¸Ñ‚Ð¸ <u>ÑÐ°Ð¼Ð¾</u> Ð°ÐºÐ¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÐºÐ°Ð¾ Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡ Ñ€Ð°Ð´Ð¾Ð²Ð° Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(199341,5538,'vi','Chá»‰ Ä‘iá»n khi NgÆ°á»i bÃ¡n lÃ  nhÃ  tháº§u thá»±c hiá»‡n Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥',0),(199342,5538,'af','Vul SLEGS in indien Verskaffer gebruik is as \'n Kontrakteur vir Diens Bestelling Werk',0),(199343,5538,'ro','CompletaÅ£i <u>doar</u> dacÄƒ vÃ¢nzÄƒtorul utilizate ca antreprenor pentru comenzi de Service',0),(199344,5538,'et','TÃ¤ita <u>ainult</u> juhul, kui hankija kasutada hooldustellimuste tÃ¶Ã¶vÃµtja',0),(199345,5538,'si','Izpolnite <u>samo</u> Äe dobavitelj uporablja kot izvajalec za servisne naloge',0),(199346,5538,'ba','Mengisi <u>hanya</u> jika Vendor digunakan sebagai kontraktor untuk layanan pesanan',0),(199347,5538,'nl','Vul <u>alleen</u> als leverancier als aannemer voor serviceorders gebruikt',0),(199348,5538,'fi','TÃ¤ytÃ¤ <u>vain</u> , jos toimittaja kÃ¤yttÃ¤Ã¤ urakoitsijan huoltotilauksille',0),(199349,5538,'no','Fyll ut <u>bare</u> hvis leverandÃ¸ren brukes som entreprenÃ¸r for serviceordrer',0),(199350,5538,'da','Udfyldes <u>kun</u> hvis kreditor bruges som entreprenÃ¸r for serviceordrer',0),(199351,5538,'ko','ê³µê¸‰ ì—…ì²´ ì„œë¹„ìŠ¤ ëª…ë ¹ì— ëŒ€ í•œ ê³„ì•½ìžë¡œ ì„œ ì‚¬ìš© í•˜ëŠ” ê²½ìš°ì— <u></u> ì±„ìš°ê¸°',0),(199352,5538,'he','×ž×œ× <u>×¨×§</u> ×× ×”×¡×¤×§ ×ž×©×ž×© ×›×§×‘×œ×Ÿ ×©×™×¨×•×ª ×”×–×ž× ×•×ª',0),(199353,5538,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏŽÏƒÏ„Îµ <u>Î¼ÏŒÎ½Î¿</u> ÎµÎ¬Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Ï‰Ï‚ Î±Î½Î¬Î´Î¿Ï‡Î¿Ï‚ Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„/Ï…',0),(199354,5538,'zh','ä»…ä»…å½“é”€å”®å•†ç”¨ä½œæœåŠ¡è®¢å•å·¥ä½œæ‰¿åŒ…å•†æ—¶å¡«å†™\r\n',0),(199355,5538,'sv','Fyll i <u>bara</u> om leverantÃ¶r anvÃ¤nds som entreprenÃ¶r fÃ¶r serviceorder',0),(199356,5538,'it','Compilare <u>solo</u> se il fornitore utilizzato come appaltatore per gli ordini di assistenza',0),(199357,5538,'tl','',0),(199358,5538,'th','Fill In ONLY if Vendor used as a Contractor for Service Order Work',0),(199359,5538,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤ à¥‡à¤•à¥‡à¤¦à¤¾à¤° à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾, à¤¤à¥‹ <u>à¤•à¥‡à¤µà¤²</u> à¤®à¥‡à¤‚ à¤­à¤°à¥‡à¤‚',0),(199360,5538,'ms','Isi dalam <u>sahaja</u> jika Penjual digunakan sebagai kontraktor bagi pesanan Perkhidmatan',0),(199361,5538,'ar','Ø£Ù…Ù„Ø§ ÙÙŠ <u>Ø¥Ù„Ø§</u> Ø¥Ø°Ø§ Ø§Ù„Ù…ÙˆØ±Ø¯ ÙƒÙ…Ù‚Ø§ÙˆÙ„ \"Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©\"',0),(199362,5538,'fr','Remplir <u>uniquement</u> si le fournisseur utilisÃ© comme entrepreneur pour les commandes de Service',0),(199363,5538,'jp','æ¥­è€…ã?Œã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ä½œæ¥­ã?®ã?Ÿã‚?ã?«è«‹ã?‘è² ã?„æ¥­è€…ã?¨ã?—ã?¦åˆ©ç”¨ã?•ã‚Œã?¦ã?„ã‚‹å ´å?ˆã?®ã?¿è¨˜å…¥ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(199364,5538,'pt','Preencha <u>apenas</u> se o fornecedor usado como empreiteiro para ordens de serviÃ§o',0),(199365,5538,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚Ðµ <u>Ñ‚Ð¾Ð»ÑŒÐºÐ¾</u> ÐµÑÐ»Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð² ÐºÐ°Ñ‡ÐµÑÑ‚Ð²Ðµ Ð¿Ð¾Ð´Ñ€ÑÐ´Ñ‡Ð¸ÐºÐ° Ð´Ð»Ñ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(199366,5538,'es','Llenar SOLO si el Proveedor se usa como Contratista para Trabajo de Orden de Servicio',0),(199367,5538,'de','FÃ¼llen Sie <u>nur</u> wenn VerkÃ¤ufer als Auftragnehmer fÃ¼r ServiceauftrÃ¤ge verwendet',0),(199368,5538,'en','Fill in <u>only</u> if Vendor used as Contractor for Service Orders',0),(199369,5539,'is','',0),(199370,5539,'dr','ÙŠÙƒ Ù¾ÙŠÙ…Ø§Ù†ÙƒØ§Ø± Ù†ÙŠØ³Øª ',0),(199371,5539,'pr','ÙŠÙƒ Ù¾ÙŠÙ…Ø§Ù†ÙƒØ§Ø± Ù†ÙŠØ³Øª ',0),(199372,5539,'tr','Bir mÃ¼teahhit',0),(199373,5539,'pl','Nie wykonawcy',0),(199374,5539,'bg','ÐÐµ Ð¸Ð·Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»',0),(199375,5539,'ur','Ø§ÛŒÚ© Ù¹Ú¾ÛŒÚ©ÛŒØ¯Ø§Ø± Ú©Û’ Ù†ÛÛŒÚº',0),(199376,5539,'sr','ÐÐµ Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð° Ñ€Ð°Ð´Ð¾Ð²Ð°',0),(199377,5539,'vi','KhÃ´ng pháº£i nhÃ  tháº§u',0),(199378,5539,'af','Nie \'n Kontrakteur',0),(199379,5539,'ro','Nu un antreprenor',0),(199380,5539,'et','Mitte tÃ¶Ã¶vÃµtja',0),(199381,5539,'si','Ni izvajalca',0),(199382,5539,'ba','Tidak seorang kontraktor',0),(199383,5539,'nl','Niet een aannemer',0),(199384,5539,'fi','EikÃ¤ urakoitsija',0),(199385,5539,'no','Ikke en entreprenÃ¸r',0),(199386,5539,'da','Ikke en entreprenÃ¸r',0),(199387,5539,'ko','í•˜ì§€ ê³„ì•½ìž',0),(199388,5539,'he','×œ× ×§×‘×œ×Ÿ',0),(199389,5539,'el','ÎŒÏ‡Î¹ Î­Î½Î±Î½ ÎµÏÎ³Î¿Î»Î®Ï€Ï„Î·',0),(199390,5539,'zh','éžæ‰¿åŒ…æ–¹\r\n',0),(199391,5539,'sv','Inte en entreprenÃ¶r',0),(199392,5539,'it','Non un imprenditore',0),(199393,5539,'tl','',0),(199394,5539,'th','&#3652;&#3617;&#3656;&#3651;&#3594;&#3657;&#3612;&#3641;&#3657;&#3619;&#3633;&#3610;&#3648;&#3627;&#3617;&#3634;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(199395,5539,'hi','à¤¨à¤¹à¥€à¤‚ à¤à¤• à¤ à¥‡à¤•à¥‡à¤¦à¤¾à¤°',0),(199396,5539,'ms','Bukan kontraktor',0),(199397,5539,'ar','Ù„Ø§ Ø£Ø­Ø¯ Ø§Ù„Ù…Ù‚Ø§ÙˆÙ„ÙŠÙ†',0),(199398,5539,'fr','Pas un entrepreneur',0),(199399,5539,'jp','è«‹è² æ¥­è€…ã?§ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(199400,5539,'pt','NÃ£o Ã© um contratante',0),(199401,5539,'ru','ÐÐµ Ð¿Ð¾Ð´Ñ€ÑÐ´Ñ‡Ð¸Ðº',0),(199402,5539,'es','No es Contratista',0),(199403,5539,'de','Kein Auftragnehmer',0),(199404,5539,'en','Not a Contractor',0),(199405,5540,'is','',0),(199406,5540,'dr','ÙŠÙƒ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª Ù†ÙŠØ³Øª ',0),(199407,5540,'pr','ÙŠÙƒ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª Ù†ÙŠØ³Øª ',0),(199408,5540,'tr','Bir servis gÃ¶revlisi',0),(199409,5540,'pl','Nie pracownik serwisu',0),(199410,5540,'bg','ÐÐµ ÑƒÑÐ»ÑƒÐ³Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº',0),(199411,5540,'ur','Ù†ÛÛŒÚº Ø§ÛŒÚ© Ø®Ø¯Ù…Øª Ú©Û’ Ú©Ø§Ø±Ú©Ù†',0),(199412,5540,'sr','ÐÐµ ÑƒÑÐ»ÑƒÐ³Ð° Ñ€Ð°Ð´Ð½Ð¸Ðº',0),(199413,5540,'vi','KhÃ´ng pháº£i lÃ  cÃ´ng nhÃ¢n dá»‹ch vá»¥',0),(199414,5540,'af','Nie \'n Diens Werker',0),(199415,5540,'ro','Nu un lucrÄƒtor de serviciu',0),(199416,5540,'et','Pole teenust tÃ¶Ã¶taja',0),(199417,5540,'si','Ne storitve delavec',0),(199418,5540,'ba','Tidak seorang pekerja Layanan',0),(199419,5540,'nl','Niet een Service arbeider',0),(199420,5540,'fi','Ei palvelun tyÃ¶ntekijÃ¤',0),(199421,5540,'no','Ikke en Service arbeidstaker',0),(199422,5540,'da','Ikke en Service arbejdstager',0),(199423,5540,'ko','ì•„ë‹ˆ ì„œë¹„ìŠ¤ ë…¸ë™ìž',0),(199424,5540,'he','×œ× ×¢×•×‘×“ ×©×¨×•×ª',0),(199425,5540,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î½Î±Ï‚ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±',0),(199426,5540,'zh','éžæœåŠ¡å·¥ä½œè€…\r\n',0),(199427,5540,'sv','Inte en tjÃ¤nst arbetstagare',0),(199428,5540,'it','Non un operaio del servizio',0),(199429,5540,'tl','',0),(199430,5540,'th','&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3588;&#3609;&#3607;&#3635;&#3591;&#3634;&#3609;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(199431,5540,'hi','à¤¨à¤¹à¥€à¤‚ à¤à¤• à¤¸à¥‡à¤µà¤¾ à¤•à¤¾à¤°à¥à¤¯à¤•à¤°à¥à¤¤à¤¾',0),(199432,5540,'ms','Tidak seorang pekerja Perkhidmatan',0),(199433,5540,'ar','Ù„Ø§ Ø¹Ø§Ù…Ù„ Ø®Ø¯Ù…Ø©',0),(199434,5540,'fr','Pas un travailleur des services',0),(199435,5540,'jp','ã‚µãƒ¼ãƒ“ã‚¹åŠ´åƒ?è€…ã?§ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(199436,5540,'pt','NÃ£o Ã© um trabalhador de serviÃ§o',0),(199437,5540,'ru','ÐÐµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(199438,5540,'es','No es un Trabajador de Servicio',0),(199439,5540,'de','Keine Service-Arbeiter',0),(199440,5540,'en','Not a Service Worker',0),(199441,5541,'is','',0),(199442,5541,'dr','Ø±Ø¯Ù‡ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª ',0),(199443,5541,'pr','Ø±Ø¯Ù‡ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª ',0),(199444,5541,'tr','Hizmet iÅŸÃ§i sÄ±nÄ±fÄ±',0),(199445,5541,'pl','UsÅ‚ugi pracownikÃ³w klasy',0),(199446,5541,'bg','Ð£ÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº ÐºÐ»Ð°Ñ',0),(199447,5541,'ur','Ø®Ø¯Ù…Øª Ú©Ø§Ø±Ú©Ù† Ú©Ù„Ø§Ø³',0),(199448,5541,'sr','Ð£ÑÐ»ÑƒÐ³Ðµ Ñ€Ð°Ð´Ð½Ð¸ÐºÑƒ ÐºÐ»Ð°ÑÐµ',0),(199449,5541,'vi','Cáº¥p báº­c dá»‹ch vá»¥',0),(199450,5541,'af','Diens Werker Klas',0),(199451,5541,'ro','Clasa de lucrÄƒtorul serviciului',0),(199452,5541,'et','TÃ¶Ã¶taja teenindusklass',0),(199453,5541,'si','Storitev delavec razred',0),(199454,5541,'ba','Kelas pekerja Layanan',0),(199455,5541,'nl','Service Worker-klasse',0),(199456,5541,'fi','TyÃ¶ntekijÃ¤n Palveluluokka',0),(199457,5541,'no','Arbeidstaker tjenesteklassen',0),(199458,5541,'da','Service arbejdstager klasse',0),(199459,5541,'ko','ì„œë¹„ìŠ¤ ë…¸ë™ìž í´ëž˜ìŠ¤',0),(199460,5541,'he','×ž×—×œ×§×ª ×©×™×¨×•×ª ×”×¢×•×‘×“',0),(199461,5541,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(199462,5541,'zh','æœåŠ¡å·¥äººç­‰çº§\r\n',0),(199463,5541,'sv','TjÃ¤nsteklassen arbetare',0),(199464,5541,'it','Classe di servizio lavoro',0),(199465,5541,'tl','',0),(199466,5541,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3588;&#3609;&#3607;&#3635;&#3591;&#3634;&#3609;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(199467,5541,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¤°à¥à¤—',0),(199468,5541,'ms','Kelas pekerja Perkhidmatan',0),(199469,5541,'ar','ÙØ¦Ø© Ø¹Ø§Ù…Ù„ Ø®Ø¯Ù…Ø©',0),(199470,5541,'fr','Classe Worker service',0),(199471,5541,'jp','ã‚µãƒ¼ãƒ“ã‚¹åŠ´åƒ?è€…éšŽç´š',0),(199472,5541,'pt','Classe de trabalhador do serviÃ§o',0),(199473,5541,'ru','ÐšÐ»Ð°ÑÑ Worker ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(199474,5541,'es','Clase de Trabajador de Servicio',0),(199475,5541,'de','Service-Arbeiter-Klasse',0),(199476,5541,'en','Service Worker Class',0),(199477,5542,'is','',0),(199478,5542,'dr','Ù†Ù…Ø§ÙŠØ´  ØªÙ‡ Ú†Ùƒ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(199479,5542,'pr','Ù†Ù…Ø§ÙŠØ´  ØªÙ‡ Ú†Ùƒ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(199480,5542,'tr','GÃ¶rÃ¼nÃ¼m doÄŸrudan yatÄ±rma saplama',0),(199481,5542,'pl','Widok bezpoÅ›redni depozyt Stub',0),(199482,5542,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿ÑŠÐ½',0),(199483,5542,'ur','Ù…Ù†Ø¸Ø± Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ø¯Ø§Ú‘Ú¾',0),(199484,5542,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¾Ð´ÑÐµÑ‡Ð°Ðº',0),(199485,5542,'vi','Xem thanh toÃ¡n trá»±c tiáº¿p',0),(199486,5542,'af','Wys Direkte Deposito Teenbladjie',0),(199487,5542,'ro','Vezi Direct de depozit ciot',0),(199488,5542,'et','Vaade otse hoiule VÃ¤lislingid',0),(199489,5542,'si','Pogled neposreden vloga Å¡tor',0),(199490,5542,'ba','Lihat Direct Deposit rintisan',0),(199491,5542,'nl','Weergave directe storting Stub',0),(199492,5542,'fi','Katso suora talletus tynkÃ¤',0),(199493,5542,'no','Vis direkte innskudd Stub',0),(199494,5542,'da','Se direkte indbetaling Stub',0),(199495,5542,'ko','ë³´ê¸° ì§ì ‘ ìž…ê¸ˆ ìŠ¤í…',0),(199496,5542,'he','×ª×¦×•×’×ª ×”×¤×§×“×” ×™×©×™×¨×” Stub',0),(199497,5542,'el','Î˜Î­Î± Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÏ„Î­Î»ÎµÏ‡Î¿Ï‚',0),(199498,5542,'zh','æŸ¥çœ‹ç›´æŽ¥å­˜æ¬¾å­˜æ ¹\r\n',0),(199499,5542,'sv','Visa direkt insÃ¤ttning Stub',0),(199500,5542,'it','Vista Stub deposito diretto',0),(199501,5542,'tl','',0),(199502,5542,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(199503,5542,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤¸à¥à¤Ÿà¤¬',0),(199504,5542,'ms','Rencana tunas Deposit terus View',0),(199505,5542,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± ÙƒØ¹Ø¨ Ø§Ù„Ø±ÙˆØªÙŠÙ†',0),(199506,5542,'fr','Vue DÃ©pÃ´t Direct Stub',0),(199507,5542,'jp','å?£åº§æŒ¯è¾¼æŽ§ã?ˆã?®è¡¨ç¤º',0),(199508,5542,'pt','EsboÃ§o do depÃ³sito direto de vista',0),(199509,5542,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð·Ð°Ð³Ð»ÑƒÑˆÐºÐ¸',0),(199510,5542,'es','Visionar TalÃ³n de DepÃ³sito Directo',0),(199511,5542,'de','Ansicht direkte Ablagerung Stub',0),(199512,5542,'en','View Direct Deposit Stub',0),(199513,5543,'is','',0),(199514,5543,'dr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(199515,5543,'pr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(199516,5543,'tr','GeÃ§ersiz iÅŸlem',0),(199517,5543,'pl','UniewaÅ¼nij transakcjÄ™',0),(199518,5543,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(199519,5543,'ur','Ø¨Ø±Ø¨Ø§Ø¯ Ù„ÛŒÙ† Ø¯ÛŒÙ†',0),(199520,5543,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(199521,5543,'vi','Há»§y giao dá»‹ch',0),(199522,5543,'af','Leemte transaksie',0),(199523,5543,'ro','Anula tranzactia',0),(199524,5543,'et','Tehingu tÃ¼histamine',0),(199525,5543,'si','Razveljavi transakcijo',0),(199526,5543,'ba','Membatalkan transaksi',0),(199527,5543,'nl','VOID transactie',0),(199528,5543,'fi','MitÃ¤tÃ¶i tapahtuma',0),(199529,5543,'no','Ugyldig transaksjon',0),(199530,5543,'da','Annullere transaktionen',0),(199531,5543,'ko','Void íŠ¸ëžœìž­ì…˜',0),(199532,5543,'he','×¢×¡×§×ª void',0),(199533,5543,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(199534,5543,'zh','äº¤æ˜“æ— æ•ˆ\r\n',0),(199535,5543,'sv','Annullera transaktion',0),(199536,5543,'it','Invalidare la transazione',0),(199537,5543,'tl','',0),(199538,5543,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(199539,5543,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨',0),(199540,5543,'ms','Transaksi yang tidak sah',0),(199541,5543,'ar','Ø¹Ù…Ù„ÙŠØ© Ù…Ù„ØºØ§Ø©',0),(199542,5543,'fr','Invalider',0),(199543,5543,'jp','å?–å¼•ã?®ç ´æ£„',0),(199544,5543,'pt','Anular a transaÃ§Ã£o',0),(199545,5543,'ru','ÐÐ¸Ñ‡Ñ‚Ð¾Ð¶Ð½Ð¾Ð¹ ÑÐ´ÐµÐ»ÐºÐ¸',0),(199546,5543,'es','TransacciÃ³n Anulada',0),(199547,5543,'de','Void Transaktion',0),(199548,5543,'en','Void Transaction',0),(199549,5544,'is','',0),(199550,5544,'dr','Ú†Ùƒ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯',0),(199551,5544,'pr','Ú†Ùƒ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯',0),(199552,5544,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde yazÄ±lÄ± onay',0),(199553,5544,'pl','Wyboru pomyÅ›lnie zapisane',0),(199554,5544,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ°, Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(199555,5544,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ù„Ú©Ú¾Û’ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(199556,5544,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½',0),(199557,5544,'vi','Viáº¿t SÃ©c thÃ nh cÃ´ng',0),(199558,5544,'af','Tjek Suksesvol Uitgeskryf',0),(199559,5544,'ro','Selectare scris cu succes',0),(199560,5544,'et','Sisse kirjutatud edukalt',0),(199561,5544,'si','Preverite uspeÅ¡no pisno',0),(199562,5544,'ba','Check ditulis berhasil',0),(199563,5544,'nl','Selectievakje geschreven met succes',0),(199564,5544,'fi','Uloskirjautuminen kirjoitus onnistui',0),(199565,5544,'no','Sjekk skrevet uten problemer',0),(199566,5544,'da','Tjekke skriftlige med succes',0),(199567,5544,'ko','ì„±ê³µì ìœ¼ë¡œ ìž‘ì„± ëœ ì²´í¬',0),(199568,5544,'he','×”×¡×™×ž×•×Ÿ ×›×ª×•×‘ ×‘×”×¦×œ×—×”',0),(199569,5544,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿ Î³ÏÎ±Ï€Ï„ÏŒ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(199570,5544,'zh','æ£€æŸ¥æˆåŠŸå†™å…¥\r\n',0),(199571,5544,'sv','Kontrollera skrivet framgÃ¥ngsrikt',0),(199572,5544,'it','Controllare scritto correttamente',0),(199573,5544,'tl','',0),(199574,5544,'th','&#3585;&#3634;&#3619;&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(199575,5544,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤²à¤¿à¤–à¤¾ à¤šà¥‡à¤•',0),(199576,5544,'ms','Cek yang ditulis berjaya',0),(199577,5544,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù…ÙƒØªÙˆØ¨ Ø¨Ù†Ø¬Ø§Ø­',0),(199578,5544,'fr','Cocher Ã©crit avec succÃ¨s',0),(199579,5544,'jp','å°?åˆ‡æ‰‹ã?Œæ›¸ã??è¾¼ã?¾ã‚Œã?¾ã?—ã?Ÿ',0),(199580,5544,'pt','Cheque escrito com sucesso',0),(199581,5544,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½',0),(199582,5544,'es','Cheque Escrito Exitosamente',0),(199583,5544,'de','KontrollkÃ¤stchen erfolgreich geschrieben',0),(199584,5544,'en','Check Written Successfully',0),(199585,5545,'is','',0),(199586,5545,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(199587,5545,'pr','Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(199588,5545,'tr','Ã–nceden oluÅŸturulmuÅŸ depozito Check',0),(199589,5545,'pl','Depozyt wyboru utwo-',0),(199590,5545,'bg','Ð’Ð»Ð¾Ð³ ÑˆÐ°Ñ… Ð²ÐµÑ‡Ðµ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð°',0),(199591,5545,'ur','Ù¾ÛÙ„Û’ Ø¨Ù†Ø§ ÚˆÙ¾Ø§Ø²Ù¹ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(199592,5545,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð²ÐµÑ› ÐºÑ€ÐµÐ¸Ñ€Ð°Ð»Ð¸',0),(199593,5545,'vi','ÄÃ£ táº¡o SÃ©c Ä‘áº·t trÆ°á»›c',0),(199594,5545,'af','Deposito tjek reeds geskep',0),(199595,5545,'ro','Depozit a verifica creat deja',0),(199596,5545,'et','Tagatisraha sisse juba loodud',0),(199597,5545,'si','Vloga Äek Å¾e ustvarili',0),(199598,5545,'ba','Check deposit yang sudah dibuat',0),(199599,5545,'nl','Storting Check al gemaakt',0),(199600,5545,'fi','Internet LAN jo luonut',0),(199601,5545,'no','Innskudd sjekk allerede opprettet',0),(199602,5545,'da','Depositum Check allerede oprettet',0),(199603,5545,'ko','ì´ë¯¸ ë§Œë“  ë³´ì¦ê¸ˆ í™•ì¸',0),(199604,5545,'he','×”×¤×™×§×“×•×Ÿ ×›×‘×¨ ×™×¦×¨×ª',0),(199605,5545,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Ï‡Ï‰ Î®Î´Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹',0),(199606,5545,'zh','æŒ‰é‡‘æ”¯ç¥¨å·²ç»å»ºç«‹\r\n',0),(199607,5545,'sv','InsÃ¤ttning du redan skapat',0),(199608,5545,'it','Deposito assegno giÃ  creato',0),(199609,5545,'tl','',0),(199610,5545,'th','&#3648;&#3594;&#3655;&#3588;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3606;&#3641;&#3585;&#3626;&#3619;&#3657;&#3634;&#3591;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(199611,5545,'hi','à¤œà¤®à¤¾ à¤•à¤°à¥‡à¤‚ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¬à¤¨à¤¾à¤ à¤—à¤ à¤šà¥‡à¤•',0),(199612,5545,'ms','Semak Deposit yang telah dicipta',0),(199613,5545,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø¨Ø§Ù„ÙØ¹Ù„ Ø¨Ø¥Ù†Ø´Ø§Ø¡',0),(199614,5545,'fr','ChÃ¨que de dÃ©pÃ´t dÃ©jÃ  crÃ©Ã©',0),(199615,5545,'jp','é ?ã?‹ã‚Šå°?åˆ‡æ‰‹ã?Œã?™ã?§ã?«ä½œæˆ?ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(199616,5545,'pt','Check depÃ³sito jÃ¡ criado',0),(199617,5545,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ Ñ‡ÐµÐº ÑƒÐ¶Ðµ ÑÐ¾Ð·Ð´Ð°Ð½',0),(199618,5545,'es','Cheque de DepÃ³sito Ya Creado',0),(199619,5545,'de','Kaution-Schecks, die bereits erstellt',0),(199620,5545,'en','Deposit Check Already Created',0),(199621,5546,'is','',0),(199622,5546,'dr','Ø¯Ø± Ù…ÙˆÙ‚Ø¹ Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø®Ø·Ø§ÙŠÙŠ Ø±Ø® Ø¯Ø§Ø¯ ',0),(199623,5546,'pr','Ø¯Ø± Ù…ÙˆÙ‚Ø¹ Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø®Ø·Ø§ÙŠÙŠ Ø±Ø® Ø¯Ø§Ø¯ ',0),(199624,5546,'tr','Onay yazÄ±lÄ±rken hata oluÅŸtu',0),(199625,5546,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania wyboru',0),(199626,5546,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð° Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¸ÑÐ°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(199627,5546,'ur','Ú†ÛŒÚ© Ø§Ù† Ú©ÛŒ ØªØ­Ø±ÛŒØ± Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ ÙˆØ§Ù‚Ø¹ ÛÙˆØ§',0),(199628,5546,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð³Ñ€ÐµÑˆÐºÐµ Ð¿Ñ€Ð¸ Ð¿Ð¸ÑÐ°ÑšÑƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(199629,5546,'vi','Lá»—i xuáº¥t hiá»‡n khi viáº¿t SÃ©c',0),(199630,5546,'af','Fout het voorgekom tydens skryf kontroleer',0),(199631,5546,'ro','Eroare Ã®n timp ce scris Check',0),(199632,5546,'et','VÃ¤ljaregistreerimine kirjutamisel ilmnes tÃµrge',0),(199633,5546,'si','Pisno preverjanje je priÅ¡lo do napake',0),(199634,5546,'ba','Terjadi kesalahan saat menulis Check',0),(199635,5546,'nl','Er is een fout opgetreden tijdens het schrijven van selectievakje',0),(199636,5546,'fi','Virhe kirjoitettaessa uloskirjautuminen',0),(199637,5546,'no','Det oppstod feil under skriving av',0),(199638,5546,'da','Der opstod fejl under skriver Check',0),(199639,5546,'ko','ì²´í¬ë¥¼ ì“°ëŠ” ë™ì•ˆ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(199640,5546,'he','××™×¨×¢×” ×©×’×™××” ×‘×¢×ª ×›×ª×™×‘×ª ×¡×™×ž×•×Ÿ',0),(199641,5546,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ³Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(199642,5546,'zh','ä¹¦å†™æ”¯ç¥¨æ—¶å‘ç”Ÿé”™è¯¯',0),(199643,5546,'sv','Fel uppstod nÃ¤r skriva Check',0),(199644,5546,'it','Errore durante la scrittura di controllo',0),(199645,5546,'tl','',0),(199646,5546,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3648;&#3585;&#3636;&#3604;&#3586;&#3638;&#3657;&#3609;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3585;&#3634;&#3619;&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3',0),(199647,5546,'hi','à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¤à¥‡ à¤¸à¤®à¤¯ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤¹à¥à¤ˆ',0),(199648,5546,'ms','Ralat berlaku ketika menulis cek',0),(199649,5546,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(199650,5546,'fr','Erreur s\'est produite lors de l\'Ã©criture chÃ¨que',0),(199651,5546,'jp','å°?åˆ‡æ‰‹æ›¸ã??è¾¼ã?¿ä¸­ã?«ã‚¨ãƒ©ãƒ¼ã?Œç™ºç”Ÿã?—ã?¾ã?—ã?Ÿ',0),(199652,5546,'pt','Ocorreu um erro ao escrever o cheque',0),(199653,5546,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð° Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(199654,5546,'es','Error OcurriÃ³ Mientras que Elaborar el Cheque',0),(199655,5546,'de','Fehler beim Schreiben von Check',0),(199656,5546,'en','Error Occurred While Writing Check',0),(199657,5547,'is','',0),(199658,5547,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(199659,5547,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(199660,5547,'tr','MaaÅŸ Ã¶deme Ã§eki yazmak',0),(199661,5547,'pl','Pisz listy pÅ‚ac zastaw sprawdzanie',0),(199662,5547,'bg','ÐÐ°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ‡ÐµÐº',0),(199663,5547,'ur','Ù¾Û’ Ø±ÙˆÙ„ ÚˆÙ¾Ø§Ø²Ù¹ Ú†ÛŒÚ© Ù„Ú©Ú¾',0),(199664,5547,'sr','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ',0),(199665,5547,'vi','Viáº¿t sÃ©c táº¡m á»©ng lÆ°Æ¡ng',0),(199666,5547,'af','Skryf Loonrol Deposito Tjeks',0),(199667,5547,'ro','Scrie salarizare depozit CEC',0),(199668,5547,'et','Write Payroll Deposit Check',0),(199669,5547,'si','Napisati Payroll vloga Äek',0),(199670,5547,'ba','Menulis penggajian Deposit Check',0),(199671,5547,'nl','Schrijven van Payroll storting Check',0),(199672,5547,'fi','Kirjoita palkanlaskennan talletus tarkistaa',0),(199673,5547,'no','Skrive lÃ¸nn innskudd sjekk',0),(199674,5547,'da','Skrive lÃ¸nningslisten depositum Check',0),(199675,5547,'ko','ê¸‰ì—¬ ìž…ê¸ˆ í‘œ ìž‘ì„±',0),(199676,5547,'he','×œ×›×ª×•×‘ ×¦\'×§ ×¤×™×§×“×•×Ÿ ×”×ž×©×›×•×¨×ª',0),(199677,5547,'el','Î“ÏÎ¬ÏˆÏ„Îµ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Ï‡Ï‰',0),(199678,5547,'zh','å†™å·¥èµ„æŒ‰é‡‘æ”¯ç¥¨\r\n',0),(199679,5547,'sv','Skriv lÃ¶nelistan insÃ¤ttning Check',0),(199680,5547,'it','Payroll deposito assegno',0),(199681,5547,'tl','',0),(199682,5547,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3605;&#3633;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(199683,5547,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤œà¤®à¤¾ à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡',0),(199684,5547,'ms','Menulis gaji Deposit cek',0),(199685,5547,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(199686,5547,'fr','Faire chÃ¨que de dÃ©pÃ´t de paie',0),(199687,5547,'jp','çµ¦ä¸Žæ”¯æ‰•å°?åˆ‡æ‰‹ã‚’æ›¸ã??è¾¼ã‚€',0),(199688,5547,'pt','DepÃ³sito de folha de pagamento de cheque',0),(199689,5547,'ru','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ',0),(199690,5547,'es','Escribir comprobante de deposito de nÃ³mina',0),(199691,5547,'de','Personalabrechnung Einzahlung Scheck',0),(199692,5547,'en','Write Payroll Deposit Check',0),(199693,5548,'is','',0),(199694,5548,'dr','Ø±ÙˆØ´ Ù„ØºÙˆ Ø´Ù†Ø§Ø®ØªÙ‡ Ù†ÙŠØ³Øª',0),(199695,5548,'pr','Ø±ÙˆØ´ Ù„ØºÙˆ Ø´Ù†Ø§Ø®ØªÙ‡ Ù†ÙŠØ³Øª',0),(199696,5548,'tr','TanÄ±nmayan iptal yÃ¶ntemi',0),(199697,5548,'pl','Metoda anulowanie nie rozpoznany',0),(199698,5548,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð¼ÐµÑ‚Ð¾Ð´ Ð½Ðµ ÑÐµ Ñ€Ð°Ð·Ð¿Ð¾Ð·Ð½Ð°Ð²Ð°',0),(199699,5548,'ur','Ù…Ù†Ø³ÙˆØ®ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ùˆ Ù†ÛÛŒÚº ØªØ³Ù„ÛŒÙ… Ú©ÛŒØ§',0),(199700,5548,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð¼ÐµÑ‚Ð¾Ð´ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€ÐµÐ¿Ð¾Ð·Ð½Ð°Ñ‚',0),(199701,5548,'vi','KhÃ´ng nháº­n ra phÆ°Æ¡ng phÃ¡p xÃ³a ',0),(199702,5548,'af','Kansellasie metode nie herken nie',0),(199703,5548,'ro','Metoda de anulare nu recunoscute',0),(199704,5548,'et','TÃ¼histamise meetod ei tunnistata',0),(199705,5548,'si','Preklic metoda ne prepozna',0),(199706,5548,'ba','Metode pembatalan tidak diakui',0),(199707,5548,'nl','Annulering methode niet herkend',0),(199708,5548,'fi','Leimaamisesta ei tunnisteta',0),(199709,5548,'no','Avbestilling metoden ikke gjenkjent',0),(199710,5548,'da','Aflysning metode ikke genkendt',0),(199711,5548,'ko','ì·¨ì†Œ ë©”ì„œë“œë¥¼ ì¸ì‹ í•˜ì§€',0),(199712,5548,'he','×‘×™×˜×•×œ ×©×™×˜×ª ×œ× ×ž×–×•×”×”',0),(199713,5548,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· Î¼Î­Î¸Î¿Î´Î¿Ï‚ Î´ÎµÎ½ Î±Î½Î±Î³Î½Ï‰ÏÎ¯Î¶ÎµÏ„Î±Î¹',0),(199714,5548,'zh','å–æ¶ˆæ–¹æ³•æ— æ³•è¯†åˆ«\r\n',0),(199715,5548,'sv','Avbokning metod inte erkÃ¤nd',0),(199716,5548,'it','Metodo di cancellazione non riconosciuto',0),(199717,5548,'tl','',0),(199718,5548,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3618;&#3629;&#3617;&#3619;&#3633;&#3610;',0),(199719,5548,'hi','à¤°à¤¦à¥à¤¦à¥€à¤•à¤°à¤£ à¤µà¤¿à¤§à¤¿ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¹à¤šà¤¾à¤¨à¤¾',0),(199720,5548,'ms','Kaedah pembatalan yang tidak diiktiraf',0),(199721,5548,'ar','Ø£Ø³Ù„ÙˆØ¨ Ø§Ù„Ø¥Ù„ØºØ§Ø¡ ØºÙŠØ± Ù…Ø¹ØªØ±Ù Ø¨Ù‡Ø§',0),(199722,5548,'fr','MÃ©thode d\'annulation non reconnu',0),(199723,5548,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«æ–¹æ³•ã?Œèª?è­˜ã?§ã??ã?¾ã?›ã‚“',0),(199724,5548,'pt','MÃ©todo de cancelamento nÃ£o reconhecido',0),(199725,5548,'ru','ÐœÐµÑ‚Ð¾Ð´ Ð¾Ñ‚Ð¼ÐµÐ½Ñ‹ Ð½Ðµ Ð¿Ñ€Ð¸Ð·Ð½Ð°ÑŽÑ‚ÑÑ',0),(199726,5548,'es','Metodo de Cancelar No Reconocido',0),(199727,5548,'de','Abbruchmethode nicht erkannt',0),(199728,5548,'en','Cancellation Method Not Recognized',0),(199729,5549,'is','',0),(199730,5549,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø±ÙˆØ´ Ù…Ø­Ø§Ø³Ø¨Ù‡ ',0),(199731,5549,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø±ÙˆØ´ Ù…Ø­Ø§Ø³Ø¨Ù‡ ',0),(199732,5549,'tr','Ä°ptal yÃ¶ntemi seÃ§in',0),(199733,5549,'pl','Wybierz metodÄ™ anulowania',0),(199734,5549,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¼ÐµÑ‚Ð¾Ð´ Ð·Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ',0),(199735,5549,'ur','Ù…Ù†Ø³ÙˆØ®ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(199736,5549,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼ÐµÑ‚Ð¾Ð´ Ð·Ð° Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ',0),(199737,5549,'vi','Chá»n theo phÆ°Æ¡ng thá»©c há»§y',0),(199738,5549,'af','Kies metode van kansellasie',0),(199739,5549,'ro','AlegeÅ£i metoda de anulare',0),(199740,5549,'et','Vali tÃ¼histamise meetod',0),(199741,5549,'si','Izberite metodo odpovedi',0),(199742,5549,'ba','Memilih metode pembatalan',0),(199743,5549,'nl','Kies methode van annulering',0),(199744,5549,'fi','Valitse peruutus',0),(199745,5549,'no','Velg metode for sletting',0),(199746,5549,'da','VÃ¦lg metode til annullering',0),(199747,5549,'ko','ì„ íƒ ì·¨ì†Œ ë°©ë²•',0),(199748,5549,'he','×‘×—×¨×• ×©×™×˜×ª ×”×‘×™×˜×•×œ',0),(199749,5549,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î­Î¸Î¿Î´Î¿ Î±ÎºÏÏÏ‰ÏƒÎ·Ï‚',0),(199750,5549,'zh','é€‰æ‹©æ¶ˆé™¤æ–¹æ³•\r\n',0),(199751,5549,'sv','VÃ¤lja metod fÃ¶r avbokning',0),(199752,5549,'it','Scegli il metodo di cancellazione',0),(199753,5549,'tl','',0),(199754,5549,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3650;&#3604;&#3618;&#3623;&#3636;&#3608;&#3637;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(199755,5549,'hi','à¤°à¤¦à¥à¤¦ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤µà¤¿à¤§à¤¿ à¤•à¤¾ à¤šà¤¯à¤¨',0),(199756,5549,'ms','Pilih kaedah pembatalan',0),(199757,5549,'ar','Ø§Ø®ØªØ± Ø·Ø±ÙŠÙ‚Ø© Ù„Ø¥Ù„ØºØ§Ø¡',0),(199758,5549,'fr','Choisissez la mÃ©thode d\'annulation',0),(199759,5549,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«æ–¹æ³•ã?®é?¸æŠž',0),(199760,5549,'pt','Escolha o mÃ©todo de cancelamento',0),(199761,5549,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ¿Ð¾ÑÐ¾Ð± Ð¾Ñ‚Ð¼ÐµÐ½Ñ‹',0),(199762,5549,'es','Seleccionar MÃ©todo de CancelaciÃ³n',0),(199763,5549,'de','WÃ¤hlen Sie Art der KÃ¼ndigung',0),(199764,5549,'en','Choose Method Of Cancellation',0),(199765,5550,'is','',0),(199766,5550,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(199767,5550,'pr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(199768,5550,'tr','DoÄŸrudan yatÄ±rma iÅŸlem geÃ§ersiz',0),(199769,5550,'pl','UniewaÅ¼nij transakcjÄ™ bezpoÅ›redni depozyt',0),(199770,5550,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ Ð¿Ñ€ÐµÐºÐ¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÐ´ÐµÐ»ÐºÐ°',0),(199771,5550,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† ØµÙØ±',0),(199772,5550,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(199773,5550,'vi','XÃ³a giao dá»‹ch trá»±c tiáº¿p',0),(199774,5550,'af','Direkte deposito transaksie void',0),(199775,5550,'ro','Anula Direct de depozit tranzacÅ£ii',0),(199776,5550,'et','Otsene hoiuste tehing tÃ¼hine',0),(199777,5550,'si','Void transakcije neposredno depozit',0),(199778,5550,'ba','Membatalkan transaksi Deposit langsung',0),(199779,5550,'nl','VOID directe storting transactie',0),(199780,5550,'fi','MitÃ¤tÃ¶i suora talletus tapahtuma',0),(199781,5550,'no','Ugyldig direkte innskudd transaksjonen',0),(199782,5550,'da','Annullere direkte indbetalingen',0),(199783,5550,'ko','ì§ì ‘ ìž…ê¸ˆ ê±°ëž˜ë¥¼ ë¬´íš¨í™”',0),(199784,5550,'he','×œ×‘×˜×œ ×¢×¡×§×ª ×”×¤×§×“×” ×™×©×™×¨×”',0),(199785,5550,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚ Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(199786,5550,'zh','ç›´æŽ¥å­˜æ¬¾äº¤æ˜“æ— æ•ˆ\r\n',0),(199787,5550,'sv','Annullera direkt insÃ¤ttning transaktion',0),(199788,5550,'it','Invalidare la transazione deposito diretto',0),(199789,5550,'tl','',0),(199790,5550,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(199791,5550,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¶à¥‚à¤¨à¥à¤¯',0),(199792,5550,'ms','Membatalkan transaksi Deposit terus',0),(199793,5550,'ar','Ø¥Ø¨Ø·Ø§Ù„ Ø­Ø±ÙƒØ© Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(199794,5550,'fr','Annuler l\'opÃ©ration de dÃ©pÃ´t Direct',0),(199795,5550,'jp','å?£åº§æŒ¯è¾¼å?–å¼•ã?®ç ´æ£„',0),(199796,5550,'pt','Anular a transaÃ§Ã£o de depÃ³sito direto',0),(199797,5550,'ru','ÐÐµÐ´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð¹ ÑÐ´ÐµÐ»ÐºÐ¸ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(199798,5550,'es','TransacciÃ³n de DepÃ³sito Directo Anulada',0),(199799,5550,'de','Void Direkteinzahlung Transaktion',0),(199800,5550,'en','Void Direct Deposit Transaction',0),(199801,5551,'is','',0),(199802,5551,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… 1- Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù¾ÙŠÙˆØ³Øª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª Ùˆ Ø§ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø¨Ù‡ Ø®Ø§Ø·Ø± Ø®Ø·Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(199803,5551,'pr','Ø´Ø±Ø­ Ø§Ø¨Ø·Ø§Ù„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… 1- Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù¾ÙŠÙˆØ³Øª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª Ùˆ Ø§ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø¨Ù‡ Ø®Ø§Ø·Ø± Ø®Ø·Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(199804,5551,'tr','Bu seÃ§eneÄŸi ACH dosyanÄ±n gÃ¶nderildiÄŸi ve bu iÅŸlem ACH iÅŸleme hatasÄ± nedeniyle baÅŸarÄ±sÄ±z oldu. Ã‡alÄ±ÅŸanÄ±n banka bilgileri ayarlamalar ve bu hareket bir gelecekte dosyasÄ±na ekleyin.',0),(199805,5551,'pl','TÄ™ opcjÄ™ naleÅ¼y wybraÄ‡, jeÅ›li plik ACH zostaÅ‚ wysÅ‚any, a tej transakcji nie powiodÅ‚o siÄ™ z powodu bÅ‚Ä™dÃ³w przetwarzania ACH. MoÅ¼na wprowadziÄ‡ korekty do pracownika banku informacji i obejmujÄ… tej transakcji w przyszÅ‚oÅ›ci pliku.',0),(199806,5551,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð¾Ð¿Ñ†Ð¸Ñ, Ð°ÐºÐ¾ ÐÐšÐš Ñ„Ð°Ð¹Ð»ÑŠÑ‚ Ðµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾, Ð¸ Ñ‚Ð°Ð·Ð¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð° Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð³Ñ€ÐµÑˆÐºÐ¸ Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°Ñ‚Ð° Ð½Ð° ACH. ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ ÐºÐ¾Ñ€ÐµÐ',0),(199807,5551,'ur','Ø§Ú† Ù…Ø³Ù„ Ú©Ùˆ Ø¨Ú¾ÛŒØ¬Ø§ Ú¯ÛŒØ§ ØªÚ¾Ø§ Ø§ÙˆØ± Ø§Ø³ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø§Ú† Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ú©Û’ Ù†Ù‚Ø§Ø¦Øµ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯Ø¦ÛŒ ØªÙˆ Ø§Ø³ Ø§Ø®ØªÛŒØ§Ø± Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Û” Ø¢Ù¾ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¨Ù†Ú© Ú©ÛŒ Ù…Ø¹',0),(199808,5551,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ Ð°ÐºÐ¾ ÐÑ… Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ñ‚Ð°, Ð° Ð¾Ð²Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð° Ð·Ð±Ð¾Ð³ ÐÑ… Ð¾Ð±Ñ€Ð°Ð´Ñƒ Ð³Ñ€ÐµÑˆÐ°ÐºÐ°. ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¿Ð¾Ð´ÐµÑÐ¸Ð¼ Ð´Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð±Ð°',0),(199809,5551,'vi','Chá»n lá»±a chá»n nÃ y khi há»“ sÆ¡ ACH Ä‘Ã£ gá»­i vÃ  giao dá»‹ch nÃ y tháº¥t báº¡i vÃ¬ xá»­ lÃ½ ACH bá»‹ lá»—i. Báº¡n cÃ³ thá»ƒ chá»‰nh sá»­a thÃ´ng tin ngÃ¢n hÃ ng cá»§a nhÃ¢n viÃªn & bao gá»“m giao dá»‹ch nÃ y vÃ o trong há»“ sÆ¡ tÆ°Æ¡ng lai  ',0),(199810,5551,'af','Kies hierdie opsie as die ACH lÃªer gestuur was, en hierdie transaksie misluk as gevolg van ACH verwerking foute. Jy kan maak aanpassings tot die werknemer se bank inligting en sluit hierdie transaksie in \'n toekomstige lÃªer.',0),(199811,5551,'ro','SelectaÅ£i aceastÄƒ opÅ£iune dacÄƒ fiÅŸierul ACH s-a trimis, ÅŸi aceastÄƒ tranzacÅ£ie a eÅŸuat din cauza erorilor de prelucrare ACH. PuteÅ£i face ajustÄƒri pentru a angajat banca de informaÅ£ii ÅŸi includ aceastÄƒ tranzacÅ£ie Ã®ntr-un fiÅŸier viitor.',0),(199812,5551,'et','Valige see suvand, kui ACH fail saadeti, ja see tehing ebaÃµnnestus ACH tÃ¶Ã¶tlemise tÃµrgete tÃµttu. Panga tÃ¶Ã¶tajateavet korrigeerida ja lisada selle tehingu tulevase faili.',0),(199813,5551,'si','To moÅ¾nost izberite, Äe datoteka ACH je bil poslan, in te transakcije ni uspela zaradi napake obdelave ACH. Lahko prilagoditve zaposlenega banÄne podatke in vkljuÄujejo to transakcijo v prihodnje datoteke.',0),(199814,5551,'ba','Pilih pilihan ini jika ACH file diutus, dan transaksi ini gagal karena kesalahan pengolahan ACH. Anda dapat membuat penyesuaian terhadap informasi bank karyawan dan termasuk transaksi ini dalam file masa depan.',0),(199815,5551,'nl','Kies deze optie als het bestand ACH werd gestuurd, en deze transactie is mislukt vanwege ACH verwerkingsfouten. U kunt aanpassingen aan te brengen van de werknemer bankgegevens en deze transactie opnemen in een toekomstige bestand.',0),(199816,5551,'fi','Valitse tÃ¤mÃ¤ vaihtoehto, jos ACH tiedosto on lÃ¤hetetty, ja tÃ¤mÃ¤ tapahtuma epÃ¤onnistui ACH kÃ¤sittelemisen virheitÃ¤. Voit tehdÃ¤ muutoksia tyÃ¶ntekijÃ¤n pankin tiedot ja sisÃ¤llyttÃ¤Ã¤ tÃ¤mÃ¤n tapahtuman tiedoston tulevat.',0),(199817,5551,'no','Velg dette alternativet hvis ACH filen ble sendt, og denne transaksjonen mislyktes pÃ¥ grunn av behandlingsfeil ACH. Du kan justere den ansattes bankinformasjon og inkluderer denne transaksjonen i en fremtidig fil.',0),(199818,5551,'da','VÃ¦lg denne indstilling, hvis ACH-filen blev sendt, og denne transaktionen mislykkedes pÃ¥ grund af ACH behandling fejl. Du kan foretage justeringer til medarbejderens bankoplysninger og omfatter denne transaktion i en fremtidig fil.',0),(199819,5551,'ko','ACH íŒŒì¼ ì „ì†¡ í•˜ ê³ ì´ íŠ¸ëžœìž­ì…˜ ACH ì²˜ë¦¬ ì˜¤ë¥˜ ë•Œë¬¸ì— ì‹¤íŒ¨ í•˜ëŠ” ê²½ìš°ì´ ì˜µì…˜ì„ ì„ íƒ í•©ë‹ˆë‹¤. ì§ì›ì˜ ì€í–‰ ì •ë³´ë¥¼ ì¡°ì • í•˜ ê³  ë¯¸ëž˜ íŒŒì¼ì—ì´ ê±°ëž˜ë¥¼ í¬í•¨í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(199820,5551,'he','×‘×—×¨ ×‘××¤×©×¨×•×ª ×–×• ×× × ×©×œ×— ××ª ×”×§×•×‘×¥ ACH, ×ª× ×•×¢×” ×–×• × ×›×©×œ×” ×¢×§×‘ ×©×’×™××•×ª ×¢×™×‘×•×“ ACH. × ×™×ª×Ÿ ×œ×‘×¦×¢ ×”×ª××ž×•×ª ×¤×¨×˜×™ ×”×‘× ×§ ×©×œ ×”×¢×•×‘×“, ×œ×›×œ×•×œ ×ª× ×•×¢×” ×–×• ×‘×§×•×‘×¥ ×‘×¢×ª×™×“.',0),(199821,5551,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® ÎµÎ¬Î½ ÏƒÏ„Î¬Î»Î¸Î·ÎºÎµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ ACH, ÎºÎ±Î¹ Î· Ï€ÏÎ¬Î¾Î· Î±Ï…Ï„Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ Î»ÏŒÎ³Ï‰ ACH ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½. ÎœÏ€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± ÎºÎ¬Î½ÎµÏ„Îµ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚',0),(199822,5551,'zh','å¦‚æžœè‡ªåŠ¨äº¤æ˜“æ‰€çš„æ–‡ä»¶å‘é€å‡ºåŽ»é€‰æ‹©æ­¤é€‰é¡¹ï¼Œè¿™ç¬”äº¤æ˜“å¤±è´¥ï¼Œå› ä¸ºè‡ªåŠ¨äº¤æ˜“æ‰€å¤„ç†é”™è¯¯ã€‚æ‚¨å¯ä»¥å¯¹å‘˜å·¥çš„é“¶è¡Œä¿¡æ¯çš„è°ƒæ•´ï¼ŒåŒ…æ‹¬è¿™ä¸ªäº¤æ˜“åœ¨æœªæ¥çš„æ–‡ä»¶ã€‚\r\n',0),(199823,5551,'sv','VÃ¤lj det hÃ¤r alternativet om filen ACH skickades, och denna transaktion misslyckades pÃ¥ grund av ACH bearbetning fel. Du kan gÃ¶ra justeringar i den anstÃ¤lldes bankinformation och inkludera transaktionen i en framtida fil.',0),(199824,5551,'it','Scegliere questa opzione se Ã¨ stato inviato il file ACH, e questa transazione non riuscita a causa di errori di elaborazione ACH. Ãˆ possibile apportare modifiche alle informazioni bancarie del dipendente e includere questa transazione in un file in futu',0),(199825,5551,'tl','',0),(199826,5551,'th','Choose this option if the ACH file was sent, and this transaction failed because of ACH processing errors. You can make adjustments to the employee\'s bank information and include this transaction in a future file.',0),(199827,5551,'hi','à¤‡à¤¸ à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¥‹ à¤šà¥à¤¨à¥‡à¤‚ à¤¯à¤¦à¤¿ ACH à¤«à¤¼à¤¾à¤‡à¤² à¤­à¥‡à¤œà¥€ à¤¥à¥€, à¤”à¤° à¤‡à¤¸ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ ACH à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤•à¤¾à¤°à¤£ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾à¥¤ à¤†à',0),(199828,5551,'ms','Pilih opsyen ini jika fail men dihantar, dan urus niaga ini gagal kerana ralat pemprosesan men. Anda boleh membuat pelarasan untuk maklumat bank pekerja dan termasuk transaksi ini dalam fail pada masa hadapan.',0),(199829,5551,'ar','Ø§Ø®ØªØ± Ù‡Ø°Ø§ Ø§Ù„Ø®ÙŠØ§Ø± Ø¥Ø°Ø§ ØªÙ… Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ù…Ù„Ù Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ØŒ ÙˆÙ‡Ø°Ù‡ Ø§Ù„ØµÙÙ‚Ø© ÙØ´Ù„Øª Ø¨Ø³Ø¨Ø¨ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ø£Ø®Ø·Ø§Ø¡. ÙŠÙ…ÙƒÙ†Ùƒ Ø¥Ø¬Ø±Ø§Ø¡ ØªØ¹Ø¯ÙŠÙ„Ø§Øª Ø¹Ù„Ù‰ Ù',0),(199830,5551,'fr','Choisissez cette option si le fichier ACH a Ã©tÃ© envoyÃ©, et cette opÃ©ration a Ã©chouÃ© en raison d\'erreurs de traitement ACH. Vous pouvez effectuer des rÃ©glages sur les coordonnÃ©es bancaires de l\'employÃ© et inclure cette transaction dans un fichier ',0),(199831,5551,'jp','ã‚‚ã?—ã??ã?®ï¼¡ï¼£ï¼¨ãƒ•ã‚¡ã‚¤ãƒ«ã?Œé€?ä¿¡æ¸ˆã?§ã€?ã?“ã?®å‡¦ç?†ã?Œï¼¡ï¼£ï¼¨å‡¦ç?†ä¸­ã‚¨ãƒ©ãƒ¼ã?®ã?Ÿã‚?ã?«å¤±æ•—ã?—ã?Ÿã‚‰ã€?ã?“ã?®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’é?¸æŠžã?—ã?¦ã??ã? ã?•ã?„ã€‚ã€€å¾“æ¥­å“¡éŠ€è¡Œæƒ…å ±ã?¸ã?®èª¿æ•´ã?Œã?§ã??ã€?ã?“ã?®å‡¦ç?†ã‚’ä»Šå¾Œã?®ãƒ•ã‚¡ã‚¤',0),(199832,5551,'pt','Escolha esta opÃ§Ã£o se o arquivo ACH foi enviado, e esta transaÃ§Ã£o falhou devido a erros de processamento de ACH. VocÃª pode fazer ajustes Ã s informaÃ§Ãµes do banco do funcionÃ¡rio e incluir essa transaÃ§Ã£o em um arquivo de futuro.',0),(199833,5551,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð¾Ñ‚ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€, ÐµÑÐ»Ð¸ Ñ„Ð°Ð¹Ð» ACH Ð±Ñ‹Ð» Ð¿Ð¾ÑÐ»Ð°Ð½, Ð¸ ÑÑ‚Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð½Ðµ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð° Ð¸Ð·-Ð·Ð° Ð¾ÑˆÐ¸Ð±ÐºÐ¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ ACH. Ð’Ñ‹ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð²Ð½ÐµÑÑ‚Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð² Ñ€ÐµÐºÐ²Ð¸Ð·Ð',0),(199834,5551,'es','Seleccionar esta opciÃ³n si el archivo ACH se mandÃ³, y esta transacciÃ³n fallÃ³ porque habÃ­a errores en el proceso de ACH. Puede hacer ajustes a la informaciÃ³n bancaria de empleado y incluir esta transacciÃ³n en en archivo en el porvenir',0),(199835,5551,'de','WÃ¤hlen Sie diese Option, wenn die ACH-Datei gesendet wurde, und dieser Transaktion ACH Verarbeitungsfehler scheiterte. Anpassungen des Mitarbeiters Bankinformationen kÃ¶nnen und fÃ¼gen diese Transaktion einer zukÃ¼nftigen Datei.',0),(199836,5551,'en','Choose this option if the ACH file was sent, and this transaction failed because of ACH processing errors. You can make adjustments to the employee\'s bank information and include this transaction in a future file.',0),(199837,5552,'is','',0),(199838,5552,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… 2- Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù¾ÙŠÙˆØ³Øª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª Ùˆ Ø§ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø¨Ù‡ Ø®Ø§Ø·Ø± Ø®Ø·Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(199839,5552,'pr','Ø´Ø±Ø­ Ø§Ø¨Ø·Ø§Ù„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… 2- Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù¾ÙŠÙˆØ³Øª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª Ùˆ Ø§ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø¨Ù‡ Ø®Ø§Ø·Ø± Ø®Ø·Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(199840,5552,'tr','Bu seÃ§eneÄŸi ACH dosyanÄ±n gÃ¶nderildiÄŸi ve bu iÅŸlem ACH iÅŸleme hatasÄ± nedeniyle baÅŸarÄ±sÄ±z oldu. Ã‡alÄ±ÅŸanÄ±n banka bilgileri ayarlamalar, kendi Ã¶deme verileri gÃ¼ncelleÅŸtirmek ve bu hareket bir gelecekte dosyasÄ±na ekleyin.',0),(199841,5552,'pl','TÄ™ opcjÄ™ naleÅ¼y wybraÄ‡, jeÅ›li plik ACH zostaÅ‚ wysÅ‚any, a tej transakcji nie powiodÅ‚o siÄ™ z powodu bÅ‚Ä™dÃ³w przetwarzania ACH. MoÅ¼na wprowadziÄ‡ korekty do pracownika banku informacji, aktualizacja danych zapÅ‚aciÄ‡ jego lub jej i obejmujÄ… tej ',0),(199842,5552,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð¾Ð¿Ñ†Ð¸Ñ, Ð°ÐºÐ¾ ÐÐšÐš Ñ„Ð°Ð¹Ð»ÑŠÑ‚ Ðµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾, Ð¸ Ñ‚Ð°Ð·Ð¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð° Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð³Ñ€ÐµÑˆÐºÐ¸ Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°Ñ‚Ð° Ð½Ð° ACH. ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ ÐºÐ¾Ñ€ÐµÐ',0),(199843,5552,'ur','Ø§Ú† Ù…Ø³Ù„ Ú©Ùˆ Ø¨Ú¾ÛŒØ¬Ø§ Ú¯ÛŒØ§ ØªÚ¾Ø§ Ø§ÙˆØ± Ø§Ø³ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø§Ú† Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ú©Û’ Ù†Ù‚Ø§Ø¦Øµ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯Ø¦ÛŒ ØªÙˆ Ø§Ø³ Ø§Ø®ØªÛŒØ§Ø± Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Û” Ø¢Ù¾ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¨ÛŒÙ†Ú© Ú©ÛŒ Ù…',0),(199844,5552,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ Ð°ÐºÐ¾ ÐÑ… Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ñ‚Ð°, Ð° Ð¾Ð²Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð° Ð·Ð±Ð¾Ð³ ÐÑ… Ð¾Ð±Ñ€Ð°Ð´Ñƒ Ð³Ñ€ÐµÑˆÐ°ÐºÐ°. ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð¿Ð¾Ð´ÐµÑÐ¸Ð¼ Ð´Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð±Ð°Ð½Ñ†Ð',0),(199845,5552,'vi','Chá»n lá»±a chá»n nÃ y khi há»“ sÆ¡ ACH Ä‘Ã£ gá»­i vÃ  giao dá»‹ch nÃ y tháº¥t báº¡i vÃ¬ xá»­ lÃ½ ACH bá»‹ lá»—i. Báº¡n cÃ³ thá»ƒ chá»‰nh sá»­a thÃ´ng tin ngÃ¢n hÃ ng cá»§a nhÃ¢n viÃªn, cáº­p nháº­t dá»¯ liá»‡u tráº£ lÆ°Æ¡ng cá»§a há» & bao gá»“m giao ',0),(199846,5552,'af','Kies hierdie opsie as die ACH lÃªer gestuur was, en hierdie transaksie misluk as gevolg van ACH verwerking foute. Jy kan aanpassings tot die werknemer se bank inligting maak, sy of haar salaris data bywerk en sluit hierdie transaksie in \'n toekomstige lÃª',0),(199847,5552,'ro','SelectaÅ£i aceastÄƒ opÅ£iune dacÄƒ fiÅŸierul ACH s-a trimis, ÅŸi aceastÄƒ tranzacÅ£ie a eÅŸuat din cauza erorilor de prelucrare ACH. PuteÅ£i face ajustÄƒri pentru a angajat banca de informaÅ£ii, de a actualiza datele de plata lui sau a ei ÅŸi includ aceas',0),(199848,5552,'et','Valige see suvand, kui ACH fail saadeti, ja see tehing ebaÃµnnestus ACH tÃ¶Ã¶tlemise tÃµrgete tÃµttu. Kohanduste tegemiseks panga tÃ¶Ã¶tajateavet, oma palga andmeid vÃ¤rskendada ja kaasata selle tehingu tulevase faili.',0),(199849,5552,'si','To moÅ¾nost izberite, Äe datoteka ACH je bil poslan, in te transakcije ni uspela zaradi napake obdelave ACH. Prilagoditve zaposlenega banÄne podatke, posodobite svoje podatke za plaÄilo in vkljuÄujejo to transakcijo v prihodnje datoteke.',0),(199850,5552,'ba','Pilih pilihan ini jika ACH file diutus, dan transaksi ini gagal karena kesalahan pengolahan ACH. Anda dapat melakukan penyesuaian untuk informasi karyawan bank, update nya membayar data dan termasuk transaksi ini dalam file masa depan.',0),(199851,5552,'nl','Kies deze optie als het bestand ACH werd gestuurd, en deze transactie is mislukt vanwege ACH verwerkingsfouten. U kunt aanpassingen aan te brengen de bankgegevens van de werknemer, zijn of haar loon gegevens bijwerken en deze transactie opnemen in een toe',0),(199852,5552,'fi','Valitse tÃ¤mÃ¤ vaihtoehto, jos ACH tiedosto on lÃ¤hetetty, ja tÃ¤mÃ¤ tapahtuma epÃ¤onnistui ACH kÃ¤sittelemisen virheitÃ¤. Voit tehdÃ¤ muutoksia pankin tyÃ¶ntekijÃ¤tiedot, PÃ¤ivitÃ¤ maksu tietonsa ja sisÃ¤llyttÃ¤Ã¤ tÃ¤mÃ¤n tapahtuman tiedoston tulevat.',0),(199853,5552,'no','Velg dette alternativet hvis ACH filen ble sendt, og denne transaksjonen mislyktes pÃ¥ grunn av behandlingsfeil ACH. Du kan justere den ansattes bankinformasjon, oppdatere sin lÃ¸nn data og inkluderer denne transaksjonen i en fremtidig fil.',0),(199854,5552,'da','VÃ¦lg denne indstilling, hvis ACH-filen blev sendt, og denne transaktionen mislykkedes pÃ¥ grund af ACH behandling fejl. Du kan foretage justeringer til medarbejderens bankoplysninger, opdatere hans eller hendes lÃ¸n data og medtage denne transaktion i en',0),(199855,5552,'ko','ACH íŒŒì¼ ì „ì†¡ í•˜ ê³ ì´ íŠ¸ëžœìž­ì…˜ ACH ì²˜ë¦¬ ì˜¤ë¥˜ ë•Œë¬¸ì— ì‹¤íŒ¨ í•˜ëŠ” ê²½ìš°ì´ ì˜µì…˜ì„ ì„ íƒ í•©ë‹ˆë‹¤. ì§ì›ì˜ ì€í–‰ ì •ë³´ë¥¼ ì¡°ì • í•˜ ê³ , ì§€ë¶ˆ ë°ì´í„°ë¥¼ ì—…ë°ì´íŠ¸ í•˜ ê³ , ë¯¸ëž˜ íŒŒì¼ì—ì´ ê±°ëž˜ë¥¼ í¬í•¨ ìˆ˜ ìžˆìŠµë',0),(199856,5552,'he','×‘×—×¨ ×‘××¤×©×¨×•×ª ×–×• ×× × ×©×œ×— ××ª ×”×§×•×‘×¥ ACH, ×ª× ×•×¢×” ×–×• × ×›×©×œ×” ×¢×§×‘ ×©×’×™××•×ª ×¢×™×‘×•×“ ACH. × ×™×ª×Ÿ ×œ×‘×¦×¢ ×”×ª××ž×•×ª ×¤×¨×˜×™ ×”×‘× ×§ ×©×œ ×”×¢×•×‘×“, ×œ×¢×“×›×Ÿ ××ª × ×ª×•× ×™ ×”×©×›×¨ ×©×œ×• ××• ×©×œ×”, ×œ×›×œ×•',0),(199857,5552,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® ÎµÎ¬Î½ ÏƒÏ„Î¬Î»Î¸Î·ÎºÎµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ ACH, ÎºÎ±Î¹ Î· Ï€ÏÎ¬Î¾Î· Î±Ï…Ï„Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ Î»ÏŒÎ³Ï‰ ACH ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½. ÎœÏ€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± ÎºÎ¬Î½Ï„Îµ Ï„Î¹Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î',0),(199858,5552,'zh','å¦‚æžœè‡ªåŠ¨äº¤æ˜“æ‰€çš„æ–‡ä»¶å‘é€å‡ºåŽ»é€‰æ‹©æ­¤é€‰é¡¹ï¼Œè¿™ç¬”äº¤æ˜“å¤±è´¥ï¼Œå› ä¸ºè‡ªåŠ¨äº¤æ˜“æ‰€å¤„ç†é”™è¯¯ã€‚æ‚¨å¯ä»¥å¯¹å‘˜å·¥çš„é“¶è¡Œä¿¡æ¯çš„è°ƒæ•´ï¼Œæ›´æ–°ä»–æˆ–å¥¹çš„è–ªé…¬æ•°æ®ï¼Œå…¶ä¸­åŒ…æ‹¬åœ¨æœªæ¥çš„æ–‡ä»¶ä¸­äº¤æ˜“\r\n',0),(199859,5552,'sv','VÃ¤lj det hÃ¤r alternativet om filen ACH skickades, och denna transaktion misslyckades pÃ¥ grund av ACH bearbetning fel. Du kan gÃ¶ra justeringar i den anstÃ¤lldes bankinformation, uppdatera hans eller hennes lÃ¶n och inkludera transaktionen i en framtida',0),(199860,5552,'it','Scegliere questa opzione se Ã¨ stato inviato il file ACH, e questa transazione non riuscita a causa di errori di elaborazione ACH. Possibile apportare modifiche alle informazioni bancarie del dipendente, aggiornare i suoi dati paga e includere questa tran',0),(199861,5552,'tl','',0),(199862,5552,'th','Choose this option if the ACH file was sent, and this transaction failed because of ACH processing errors. You can make adjustments to the employee\'s bank information, update his or her pay data and include this transaction in a future file.',0),(199863,5552,'hi','à¤‡à¤¸ à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¥‹ à¤šà¥à¤¨à¥‡à¤‚ à¤¯à¤¦à¤¿ ACH à¤«à¤¼à¤¾à¤‡à¤² à¤­à¥‡à¤œà¥€ à¤¥à¥€, à¤”à¤° à¤‡à¤¸ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ ACH à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤•à¤¾à¤°à¤£ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾à¥¤ à¤†à',0),(199864,5552,'ms','Pilih opsyen ini jika fail men dihantar, dan urus niaga ini gagal kerana ralat pemprosesan men. Anda boleh membuat pelarasan untuk maklumat bank pekerja, mengemaskini data-data gaji beliau dan urus niaga ini dalam fail pada masa hadapan.',0),(199865,5552,'ar','Ø§Ø®ØªØ± Ù‡Ø°Ø§ Ø§Ù„Ø®ÙŠØ§Ø± Ø¥Ø°Ø§ ØªÙ… Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ù…Ù„Ù Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ØŒ ÙˆÙ‡Ø°Ù‡ Ø§Ù„ØµÙÙ‚Ø© ÙØ´Ù„Øª Ø¨Ø³Ø¨Ø¨ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ø£Ø®Ø·Ø§Ø¡. ÙŠÙ…ÙƒÙ†Ùƒ Ø¥Ø¬Ø±Ø§Ø¡ ØªØ¹Ø¯ÙŠÙ„Ø§Øª Ø¹Ù„Ù‰ Ø',0),(199866,5552,'fr','Choisissez cette option si le fichier ACH a Ã©tÃ© envoyÃ©, et cette opÃ©ration a Ã©chouÃ© en raison d\'erreurs de traitement ACH. Vous pouvez effectuer des rÃ©glages sur les coordonnÃ©es bancaires de l\'employÃ©, mettre Ã  jour ses donnÃ©es de paye et inclu',0),(199867,5552,'jp','ã‚‚ã?—ã??ã?®ï¼¡ï¼£ï¼¨ãƒ•ã‚¡ã‚¤ãƒ«ã?Œé€?ä¿¡æ¸ˆã?§ã€?ã?“ã?®å‡¦ç?†ã?Œï¼¡ï¼£ï¼¨å‡¦ç?†ä¸­ã‚¨ãƒ©ãƒ¼ã?®ã?Ÿã‚?ã?«å¤±æ•—ã?—ã?Ÿã‚‰ã€?ã?“ã?®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’é?¸æŠžã?—ã?¦ã??ã? ã?•ã?„ã€‚å¾“æ¥­å“¡éŠ€è¡Œæƒ…å ±ã?¸ã?®èª¿æ•´ã‚„çµ¦ä¸Žãƒ‡ãƒ¼ã‚¿ã?®æ›´æ–°ã?Œã?§ã??ã€?ã?“ã?®å‡¦',0),(199868,5552,'pt','Escolha esta opÃ§Ã£o se o arquivo ACH foi enviado, e esta transaÃ§Ã£o falhou devido a erros de processamento de ACH. VocÃª pode fazer ajustes Ã s informaÃ§Ãµes do banco do funcionÃ¡rio, actualizar os seus dados de pagamento e incluir essa transaÃ§Ã£o em u',0),(199869,5552,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð¾Ñ‚ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€, ÐµÑÐ»Ð¸ Ñ„Ð°Ð¹Ð» ACH Ð±Ñ‹Ð» Ð¿Ð¾ÑÐ»Ð°Ð½, Ð¸ ÑÑ‚Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð½Ðµ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð° Ð¸Ð·-Ð·Ð° Ð¾ÑˆÐ¸Ð±ÐºÐ¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ ACH. ÐœÐ¾Ð¶Ð½Ð¾ Ð²Ð½ÐµÑÑ‚Ð¸ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ð²Ñ‹ Ð² Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(199870,5552,'es','Seleccionar esta opciÃ³n si el archivo ACH se mandÃ³, y esta transacciÃ³n fallÃ³ porque habÃ­a errores en el proceso de ACH. Puede hacer ajustes a la informaciÃ³n bancaria de empleado y incluir esta transacciÃ³n, actualizar sus datos de pagos y incluir es',0),(199871,5552,'de','WÃ¤hlen Sie diese Option, wenn die ACH-Datei gesendet wurde, und dieser Transaktion ACH Verarbeitungsfehler scheiterte. Anpassungen des Mitarbeiters Bankinformationen kÃ¶nnen, seine Zahlen Daten zu aktualisieren und diese Transaktion in einer zukÃ¼nftigen',0),(199872,5552,'en','Choose this option if the ACH file was sent, and this transaction failed because of ACH processing errors. You can make adjustments to the employee\'s bank information, update his or her pay data and include this transaction in a future file.',0),(199873,5553,'is','',0),(199874,5553,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… 3- Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø±  ÙØ§ÙŠÙ„ Ù¾ÙŠÙˆØ³Øª Ù‡Ù†ÙˆØ²  ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ùˆ  Ø´Ù…Ø§ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(199875,5553,'pr','Ø´Ø±Ø­ Ø§Ø¨Ø·Ø§Ù„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… 3- Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø±  ÙØ§ÙŠÙ„ Ù¾ÙŠÙˆØ³Øª Ù‡Ù†ÙˆØ²  ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ùˆ  Ø´Ù…Ø§ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…Ø­Ø§Ø³Ø¨Ø§Øª ',0),(199876,5553,'tr','ACH dosya gÃ¶nderilmedi ve maaÅŸ hesaplamalarÄ± yeniden Ã§alÄ±ÅŸtÄ±rÄ±n ve yeni bir dosya oluÅŸturmak istiyorsanÄ±z bu seÃ§eneÄŸi seÃ§in.',0),(199877,5553,'pl','TÄ™ opcjÄ™ naleÅ¼y wybraÄ‡, jeÅ›li plik ACH nie zostaÅ‚a wysÅ‚ana, i chcesz, aby ponownie uruchomiÄ‡ obliczenia wynagrodzenia i utworzyÄ‡ nowy plik.',0),(199878,5553,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð¾Ð¿Ñ†Ð¸Ñ, Ð°ÐºÐ¾ ÐÐšÐš Ñ„Ð°Ð¹Ð»ÑŠÑ‚ Ð¾Ñ‰Ðµ Ð½Ðµ Ðµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½, Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ÑÑ‚Ð° Ð¾Ñ‚Ð½Ð¾Ð²Ð¾ Ð¸ Ð´Ð° ÑÐµ ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ð½Ð¾Ð² Ñ„Ð°Ð¹Ð».',0),(199879,5553,'ur','Ø§Ú† Ù…Ø³Ù„ Ú©Ùˆ Ù†ÛÛŒÚº Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ØŒ Ø§ÙˆØ± Ø¢Ù¾ ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ø­Ø³Ø§Ø¨ Ú©Ùˆ Ø¯ÙˆØ¨Ø§Ø±Û Ú†Ù„Ø§Ø¦ÛŒÚº Ø§ÙˆØ± Ù†Ø¦ÛŒ Ù…Ø³Ù„ Ø¨Ù†Ø§Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº ØªÙˆ Ø§Ø³ Ø§Ø®ØªÛŒØ§Ø± Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Û”',0),(199880,5553,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ Ð°ÐºÐ¾ ÐÑ… Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ñ‚, Ð° Ð²Ð¸ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð¿Ð¾ÐºÑ€ÐµÐ½Ð¸Ñ‚Ðµ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ Ð¿Ð»Ð°Ñ‚Ð° Ð¸ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ.',0),(199881,5553,'vi','Chá»n lá»±a chá»n nÃ y khi há»“ sÆ¡ ACH Ä‘Ã£ gá»­i vÃ  giao dá»‹ch nÃ y tháº¥t báº¡i vÃ¬ xá»­ lÃ½ ACH bá»‹ lá»—i & báº¡n muá»‘n tÃ­nh láº¡i lÆ°Æ¡ng & táº¡o 1 há»“ sÆ¡ má»›i',0),(199882,5553,'af','Kies hierdie opsie as die ACH-lÃªer is nie gestuur is nie, en jy wil betaal berekeninge weer loop en \'n nuwe lÃªer skep nie.',0),(199883,5553,'ro','SelectaÅ£i aceastÄƒ opÅ£iune dacÄƒ fiÅŸierul ACH nu a fost trimis, ÅŸi doriÅ£i sÄƒ ruleze calculele de plata din nou ÅŸi de a crea un nou fiÅŸier.',0),(199884,5553,'et','Valige see suvand, kui ACH faili ei ole ja tasu arvutused uuesti kÃ¤ivitada ja luua uus fail.',0),(199885,5553,'si','To moÅ¾nost izberite, Äe ACH datoteka ni bila poslana, in ga Å¾elite znova zagnati plaÄati izraÄune in ustvariti novo datoteko.',0),(199886,5553,'ba','Pilih pilihan ini jika ACH file belum terkirim, dan Anda ingin menjalankan perhitungan membayar lagi dan membuat file baru.',0),(199887,5553,'nl','Kies deze optie als de ACH-bestand niet is verzonden, en u wilt betalen berekeningen opnieuw uitvoeren en een nieuw bestand maken.',0),(199888,5553,'fi','Valitse tÃ¤mÃ¤ vaihtoehto, jos ACH-tiedosto ei ole lÃ¤hetetty ja haluat suorittaa maksu laskelmat uudelleen ja luoda uuden tiedoston.',0),(199889,5553,'no','Velg dette alternativet hvis filen ACH ikke er sendt, og du vil kjÃ¸re lÃ¸nn beregninger pÃ¥ nytt og opprette en ny fil.',0),(199890,5553,'da','VÃ¦lg denne indstilling, hvis ACH-filen ikke er blevet sendt, og du Ã¸nsker at kÃ¸re pay beregninger igen og oprette en ny fil.',0),(199891,5553,'ko','ACH íŒŒì¼ ì „ì†¡ ë˜ì§€ ì•Šì€, í•˜ ê³  ì‹¶ì€ ì§€ë¶ˆ ê³„ì‚°ì„ ë‹¤ì‹œ ì‹¤í–‰ í•˜ ê³  ìƒˆ íŒŒì¼ì„ ë§Œë“¤ ê²½ìš°ì´ ì˜µì…˜ì„ ì„ íƒ í•©ë‹ˆë‹¤.',0),(199892,5553,'he','×‘×—×¨ ×‘××¤×©×¨×•×ª ×–×• ×× ×œ× × ×©×œ×— ××ª ×”×§×•×‘×¥ ACH, ×‘×¨×¦×•× ×š ×œ×”×¤×¢×™×œ ×©×•×‘ ××ª ×—×™×©×•×‘×™ ×”×©×›×¨, ×œ×™×¦×•×¨ ×§×•×‘×¥ ×—×“×©.',0),(199893,5553,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î®, ÎµÎ¬Î½ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ ÏƒÏ„Î±Î»ÎµÎ¯ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ ACH, ÎºÎ±Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎµÎºÏ„ÎµÎ»Î­ÏƒÎµÏ„Îµ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ Î±Î¼Î¿Î¹Î²Î®Ï‚ ÎºÎ±Î¹ Ï€Î¬Î»Î¹ ÎºÎ±Î¹ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î­Î½',0),(199894,5553,'zh','å¦‚æžœè‡ªåŠ¨äº¤æ˜“æ‰€çš„æ–‡ä»¶æ²¡æœ‰è¢«å‘é€é€‰æ‹©æ­¤é€‰é¡¹ï¼Œå¹¶ä¸”è¦å†æ¬¡è¿è¡Œè®¡ç®—ç¼´çº³ï¼Œå¹¶åˆ›å»ºä¸€ä¸ªæ–°æ–‡ä»¶ã€‚\r\n',0),(199895,5553,'sv','VÃ¤lj det hÃ¤r alternativet om filen ACH inte har skickats, och du vill kÃ¶ra lÃ¶n berÃ¤kningar igen och skapa en ny fil.',0),(199896,5553,'it','Scegliere questa opzione se non Ã¨ stato inviato il file ACH, e si desidera eseguire calcoli di pagare di nuovo e creare un nuovo file.',0),(199897,5553,'tl','',0),(199898,5553,'th','Choose this option if the ACH file has not been sent, and you want to run pay calculations again and create a new file.',0),(199899,5553,'hi','ACH à¤«à¤¼à¤¾à¤‡à¤² à¤­à¥‡à¤œà¤¾ à¤¨à¤¹à¥€à¤‚ à¤—à¤¯à¤¾ à¤¹à¥ˆ, à¤”à¤° à¤¤à¥à¤® à¤ªà¥‡ à¤ªà¤°à¤¿à¤•à¤²à¤¨à¥‹à¤‚ à¤•à¥‹ à¤«à¤¿à¤° à¤¸à¥‡ à¤šà¤²à¤¾à¤à¤ à¤”à¤° à¤à¤• à¤¨à¤ˆ à¤«à¤¼à¤¾à¤‡à¤² à¤¬à¤¨à¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤¤à¥‹ à¤¯à¤¹ à¤µà¤¿à¤•',0),(199900,5553,'ms','Pilih opsyen ini jika fail men tidak dihantar, dan anda mahu jalankan pengiraan gaji semula dan mencipta fail baru.',0),(199901,5553,'ar','Ø§Ø®ØªØ± Ù‡Ø°Ø§ Ø§Ù„Ø®ÙŠØ§Ø± Ø¥Ø°Ø§ Ù„Ù… ÙŠØªÙ… Ø¥Ø±Ø³Ø§Ù„ Ù…Ù„Ù Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ØŒ ÙˆÙƒÙ†Øª ØªØ±ØºØ¨ ÙÙŠ ØªØ´ØºÙŠÙ„ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ ÙˆÙ‚Ù… Ø¨Ø¥Ù†Ø´Ø§Ø¡ Ù…Ù„Ù Ø¬Ø¯ÙŠØ¯.',0),(199902,5553,'fr','Choisissez cette option si le fichier ACH n\'a pas Ã©tÃ© envoyÃ©, et que vous souhaitez rÃ©exÃ©cuter le calcul de la rÃ©munÃ©ration et de crÃ©er un nouveau fichier.',0),(199903,5553,'jp','ã‚‚ã?—ã‚‚ã??ã?®ï¼¡ï¼£ï¼¨ãƒ•ã‚¡ã‚¤ãƒ«ã?Œé€?ä¿¡æ¸ˆã?§ã€?çµ¦ä¸Žè¨ˆç®—ã‚’å†?ã?³å®Ÿæ–½ã?—ã?¦æ–°ã?—ã?„ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ä½œã‚Šã?Ÿã?„ã?ªã‚‰ã€?ã?“ã?®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’é?¸æŠžã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(199904,5553,'pt','Escolha esta opÃ§Ã£o se o arquivo ACH nÃ£o foi enviado, e vocÃª deseja executar cÃ¡lculos de pagar novamente e criar um novo arquivo.',0),(199905,5553,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð¾Ñ‚ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€, ÐµÑÐ»Ð¸ Ð½Ðµ Ð±Ñ‹Ð» Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½ Ñ„Ð°Ð¹Ð» ACH, Ð¸ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑÐ½Ð¾Ð²Ð° Ð·Ð°Ð¿ÑƒÑÑ‚Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ðµ Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð¸ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ„Ð°Ð¹Ð».',0),(199906,5553,'es','Seleccionar esta opciÃ³n si el archivo ACH no se mandÃ³, y quiere hacer CÃ¡lculos de pagos otra vez y crear un nuevo archivo',0),(199907,5553,'de','WÃ¤hlen Sie diese Option, wenn die ACH-Datei wurde nicht gesendet, und Sie zahlen Berechnungen erneut ausfÃ¼hren und eine neue Datei erstellen mÃ¶chten.',0),(199908,5553,'en','Choose this option if the ACH file has not been sent, and you want to run pay calculations again and create a new file.',0),(199909,5554,'is','',0),(199910,5554,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… 4- Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± ÙØ§ÙŠÙ„  Ù¾ÙŠÙˆØ³Øª Ù‡Ù†ÙˆØ²  ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ùˆ Ø´Ù…Ø§ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(199911,5554,'pr','Ø´Ø±Ø­ Ø§Ø¨Ø·Ø§Ù„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… 4- Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± ÙØ§ÙŠÙ„  Ù¾ÙŠÙˆØ³Øª Ù‡Ù†ÙˆØ²  ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ùˆ Ø´Ù…Ø§ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(199912,5554,'tr','ACH dosya gÃ¶nderilmedi ve Ã§alÄ±ÅŸan Ã¶deme verileri dÃ¼zenlemek istiyorsanÄ±z bu seÃ§eneÄŸi seÃ§in hesaplamalar yeniden Ã§alÄ±ÅŸtÄ±rÄ±n ve yeni bir dosya oluÅŸturun.',0),(199913,5554,'pl','Wybierz tÄ™ opcjÄ™, jeÅ›li plik ACH nie zostaÅ‚a wysÅ‚ana, i chcesz edytowaÄ‡ dane wynagrodzenie pracownika, ponownie uruchomiÄ‡ obliczenia i utworzyÄ‡ nowy plik.',0),(199914,5554,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð¾Ð¿Ñ†Ð¸Ñ, Ð°ÐºÐ¾ ÐÐšÐš Ñ„Ð°Ð¹Ð»ÑŠÑ‚ Ð¾Ñ‰Ðµ Ð½Ðµ Ðµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½, Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ», Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð¾Ñ‚Ð½Ð¾Ð²Ð',0),(199915,5554,'ur','Ø§Ú† Ù…Ø³Ù„ Ú©Ùˆ Ù†ÛÛŒÚº Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ØŒ Ø§ÙˆØ± Ø¢Ù¾ Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û Ú©Û’ ÚˆÛŒÙ¹Ø§ØŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº ØªÙˆ ÛŒÛ Ø§Ø®ØªÛŒØ§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Ø­Ø³Ø§Ø¨ Ø¯ÙˆØ¨Ø§Ø±Û Ú†Ù„Ø§Ø¦ÛŒÚºØŒ Ø§ÙˆØ± Ø§ÛŒÚ© Ù†Ø¦ÛŒ Ù',0),(199916,5554,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ Ð°ÐºÐ¾ ÐÑ… Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ñ‚, Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° ÑƒÑ€ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ð¼Ð° Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð¿Ð¾ÐºÑ€ÐµÐ½Ð¸Ñ‚Ðµ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ° Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸',0),(199917,5554,'vi','Chá»n lá»±a chá»n nÃ y khi há»“ sÆ¡ ACH Ä‘Ã£ gá»­i vÃ  giao dá»‹ch nÃ y tháº¥t báº¡i vÃ¬ xá»­ lÃ½ ACH bá»‹ lá»—i vÃ  báº¡n muá»‘n chá»‰nh sá»­a dá»¯ liá»‡u tráº£ lÆ°Æ¡ng cá»§a nhÃ¢n viÃªn, tÃ­nh láº¡i lÆ°Æ¡ng & táº¡o 1 há»“ sÆ¡ má»›i',0),(199918,5554,'af','Kies hierdie opsie as die ACH-lÃªer is nie gestuur is nie, en jy wil redigeer werknemer betaal data, berekeninge weer loop nie, en \'n nuwe lÃªer skep nie.',0),(199919,5554,'ro','AlegeÅ£i aceastÄƒ opÅ£iune dacÄƒ fiÅŸierul ACH nu a fost trimis, ÅŸi doriÅ£i sÄƒ editaÅ£i datele de plata angajat, executa calculele din nou, ÅŸi de a crea un nou fiÅŸier.',0),(199920,5554,'et','Valige see suvand, kui ACH faili ei ole tÃ¶Ã¶taja palga andmete redigeerimiseks arvutused uuesti kÃ¤ivitada ja luua uus fail.',0),(199921,5554,'si','To moÅ¾nost izberite, Äe ACH datoteka ni bila poslana, in Å¾elite urediti zaposleni plaÄati podatkov, znova zaÅ¾enite izraÄune in ustvariti novo datoteko.',0),(199922,5554,'ba','Pilih pilihan ini jika ACH file belum terkirim, dan Anda ingin mengedit data membayar karyawan, menjalankan perhitungan lagi, dan membuat file baru.',0),(199923,5554,'nl','Kies deze optie als de ACH-bestand niet is verzonden, en u wilt gegevens over werknemers betalen, bewerken berekeningen opnieuw uitvoeren en een nieuw bestand maken.',0),(199924,5554,'fi','Valitse tÃ¤mÃ¤ vaihtoehto, jos ACH-tiedosto ei ole lÃ¤hetetty ja haluat muokata maksu tyÃ¶ntekijÃ¤tiedot Suorita laskutoimituksia uudelleen ja luoda uuden tiedoston.',0),(199925,5554,'no','Velg dette alternativet hvis filen ACH ikke er sendt, og du vil redigere betale ansattdata, KjÃ¸r beregninger igjen, og opprette en ny fil.',0),(199926,5554,'da','VÃ¦lg denne indstilling, hvis ACH-filen ikke er blevet sendt, og du vil redigere medarbejder lÃ¸n data, kÃ¸re beregninger igen, og Opret en ny fil.',0),(199927,5554,'ko','ë‹¤ì‹œ ê³„ì‚°ì„ ì‹¤í–‰ ACH íŒŒì¼ ì „ì†¡ ë˜ì§€ ì•Šì•˜ìŠµë‹ˆë‹¤, ì§ì› ê¸‰ì—¬ ë°ì´í„°ë¥¼ íŽ¸ì§‘ í•˜ë ¤ëŠ” ê²½ìš°ì´ ì˜µì…˜ì„ ì„ íƒ í•˜ ê³  ìƒˆ íŒŒì¼ì„ ë§Œë“­ë‹ˆë‹¤.',0),(199928,5554,'he','×‘×—×¨ ×‘××¤×©×¨×•×ª ×–×• ×× ×”×§×•×‘×¥ ACH ×œ× × ×©×œ×—×”, ×•×‘×¨×¦×•× ×š ×œ×¢×¨×•×š ××ª × ×ª×•× ×™ ×©×›×¨ ×¢×•×‘×“×™×, ×”×¤×¢×œ ×©×•×‘ ××ª ×”×—×™×©×•×‘×™×, ×œ×™×¦×•×¨ ×§×•×‘×¥ ×—×“×©.',0),(199929,5554,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î®, ÎµÎ¬Î½ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ ÏƒÏ„Î±Î»ÎµÎ¯ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ ACH, ÎºÎ±Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î´ÎµÎ´Î¿Î¼Î­Î½Î± Î±Î¼Î¿Î¹Î²ÏŽÎ½ Ï…Ï€Î±Î»Î»Î®Î»Ï‰Î½, ÎµÎºÏ„ÎµÎ»Î­ÏƒÎµÏ„Îµ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼',0),(199930,5554,'zh','å¦‚æžœè‡ªåŠ¨äº¤æ˜“æ‰€çš„æ–‡ä»¶æ²¡æœ‰è¢«å‘é€é€‰æ‹©æ­¤é€‰é¡¹ï¼Œå¹¶ä¸”æ‚¨è¦ç¼–è¾‘çš„å‘˜å·¥è–ªé…¬æ•°æ®ï¼Œå†æ¬¡è¿è¡Œè®¡ç®—ï¼Œå¹¶åˆ›å»ºä¸€ä¸ªæ–°æ–‡ä»¶ã€‚\r\n',0),(199931,5554,'sv','VÃ¤lj det hÃ¤r alternativet om filen ACH inte har skickats, och du vill redigera data om anstÃ¤llda lÃ¶n, kÃ¶ra berÃ¤kningar igen, och skapa en ny fil.',0),(199932,5554,'it','Scegliere questa opzione se non Ã¨ stato inviato il file ACH, e si desidera modificare i dati del dipendente paga, eseguire calcoli di nuovo e creare un nuovo file.',0),(199933,5554,'tl','',0),(199934,5554,'th','Choose this option if the ACH file has not been sent, and you want to edit employee pay data, run calculations again, and create a new file.',0),(199935,5554,'hi','ACH à¤«à¤¼à¤¾à¤‡à¤² à¤­à¥‡à¤œà¤¾ à¤¨à¤¹à¥€à¤‚ à¤—à¤¯à¤¾ à¤¹à¥ˆ, à¤”à¤° à¤†à¤ª à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨ à¤¡à¥‡à¤Ÿà¤¾, à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤¤à¥‹ à¤¯à¤¹ à¤µà¤¿à¤•à¤²à¥à¤ª à¤šà¥à¤¨à¥‡à¤‚ à¤ªà¤°à¤¿à¤•à¤²',0),(199936,5554,'ms','Pilih opsyen ini jika fail men tidak dihantar, dan anda ingin mengedit data gaji pekerja, jalankan pengiraan semula, dan mencipta fail baru.',0),(199937,5554,'ar','Ø§Ø®ØªØ± Ù‡Ø°Ø§ Ø§Ù„Ø®ÙŠØ§Ø± Ø¥Ø°Ø§ Ù„Ù… ÙŠØªÙ… Ø¥Ø±Ø³Ø§Ù„ Ù…Ù„Ù Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ØŒ ÙˆÙƒÙ†Øª ØªØ±ØºØ¨ ÙÙŠ ØªØ­Ø±ÙŠØ± Ø¨ÙŠØ§Ù†Ø§Øª Ø£Ø¬ÙˆØ± Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†ØŒ ØªØ´ØºÙŠÙ„ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ØŒ ÙˆÙ‚Ù… Ø¨Ø¥Ù†Ø´Ø§Ø¡ Ù…Ù„Ù Ø',0),(199938,5554,'fr','Choisissez cette option si le fichier ACH n\'a pas Ã©tÃ© envoyÃ©, et que vous souhaitez modifier les donnÃ©es de paye des employÃ©s, d\'exÃ©cuter de nouveau les calculs et crÃ©ez un nouveau fichier.',0),(199939,5554,'jp','ã‚‚ã?—ã‚‚ã??ã?®ï¼¡ï¼£ï¼¨ãƒ•ã‚¡ã‚¤ãƒ«ã?Œé€?ä¿¡æ¸ˆã?§ã€?å¾“æ¥­å“¡çµ¦ä¸Žãƒ‡ãƒ¼ã‚¿ã‚’ç·¨é›†ã?—ã€?å†?è¨ˆç®—ã?—ã€?æ–°ã?—ã?„ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ä½œã‚Šã?Ÿã?„ã?ªã‚‰ã€?ã?“ã?®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’é?¸æŠžã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(199940,5554,'pt','Escolha esta opÃ§Ã£o se o arquivo ACH nÃ£o foi enviado, e vocÃª deseja editar dados de remuneraÃ§Ã£o de funcionÃ¡rios, executar cÃ¡lculos novamente e crie um novo arquivo.',0),(199941,5554,'ru','Ð¡Ð½Ð¾Ð²Ð° Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð¾Ñ‚ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€, ÐµÑÐ»Ð¸ Ñ„Ð°Ð¹Ð» ACH Ð½Ðµ Ð±Ñ‹Ð» Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½, Ð¸ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð²Ð¾Ð·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ñ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð², Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ð¹ ',0),(199942,5554,'es','Seleccionar esta opciÃ³n si el archivo ACH no se mandÃ³, y quiere editar datos de pagos al empleados, hacer cÃ¡lculos de nuevo, y crear un nuevo archivo',0),(199943,5554,'de','Diese Option wÃ¤hlen, wenn die ACH-Datei wurde nicht gesendet, und Sie zahlen Mitarbeiterdaten bearbeiten mÃ¶chten Berechnungen erneut ausfÃ¼hren und eine neue Datei erstellen.',0),(199944,5554,'en','Choose this option if the ACH file has not been sent, and you want to edit employee pay data, run calculations again, and create a new file.',0),(199945,5555,'is','',0),(199946,5555,'dr','Ø¯Ø± Ø·ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…Ø¹Ø§Ù…Ù„Ù‡  Ø®Ø·Ø§ÙŠÙŠ Ø±Ø® Ø¯Ø§Ø¯',0),(199947,5555,'pr','Ø¯Ø± Ø·ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…Ø¹Ø§Ù…Ù„Ù‡  Ø®Ø·Ø§ÙŠÙŠ Ø±Ø® Ø¯Ø§Ø¯',0),(199948,5555,'tr','Hareket iÅŸleme sÄ±rasÄ±nda hata oluÅŸtu',0),(199949,5555,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas przetwarzania transakcji',0),(199950,5555,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð° Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°Ñ‚Ð° Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(199951,5555,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ ÙˆØ§Ù‚Ø¹ ÛÙˆØ§',0),(199952,5555,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð³Ñ€ÐµÑˆÐºÐµ Ñ‚Ð¾ÐºÐ¾Ð¼ Ð¾Ð±Ñ€Ð°Ð´Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(199953,5555,'vi','Lá»—i khi xá»­ lÃ½ giao dá»‹ch',0),(199954,5555,'af','Fout het voorgekom tydens verwerking van transaksie',0),(199955,5555,'ro','Eroare Ã®n timpul procesÄƒrii tranzacÅ£iei',0),(199956,5555,'et','Tehingu tÃ¶Ã¶tlemisel ilmnes tÃµrge',0),(199957,5555,'si','Napaka med obdelavo transakcij',0),(199958,5555,'ba','Kesalahan terjadi selama proses transaksi',0),(199959,5555,'nl','Er is een fout opgetreden tijdens de transactieverwerking van de',0),(199960,5555,'fi','Virhe tapahtumien kÃ¤sittely',0),(199961,5555,'no','Det oppstod feil under behandling av transaksjoner',0),(199962,5555,'da','Der opstod fejl under transaktionsbehandling',0),(199963,5555,'ko','íŠ¸ëžœìž­ì…˜ ì²˜ë¦¬ ì¤‘ ì˜¤ë¥˜ ë°œìƒ',0),(199964,5555,'he','××™×¨×¢×” ×©×’×™××” ×‘×ž×”×œ×š ×¢×™×‘×•×“ ×˜×¨× ×–×§×¦×™×•×ª',0),(199965,5555,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½',0),(199966,5555,'zh','äº¤æ˜“å¤„ç†è¿‡ç¨‹ä¸­å‡ºçŽ°é”™è¯¯',0),(199967,5555,'sv','Fel uppstod under bearbetning av transaktioner',0),(199968,5555,'it','Si Ã¨ verificato un errore durante l\'elaborazione delle transazioni',0),(199969,5555,'tl','',0),(199970,5555,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3648;&#3585;&#3636;&#3604;&#3586;&#3638;&#3657;&#3609;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3',0),(199971,5555,'hi','à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤¹à¥à¤ˆ',0),(199972,5555,'ms','Ralat berlaku semasa memproses urus niaga',0),(199973,5555,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(199974,5555,'fr','Erreur s\'est produite lors du traitement de la Transaction',0),(199975,5555,'jp','å‡¦ç?†ä¸­ã?®ã‚¨ãƒ©ãƒ¼ã?Œç™ºç”Ÿã?—ã?¾ã?—ã?Ÿ',0),(199976,5555,'pt','Ocorreu um erro durante o processamento de transaÃ§Ãµes',0),(199977,5555,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð° Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ñ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹',0),(199978,5555,'es','Error OcurriÃ³ Durante el Procedimiento de la TransacciÃ³n',0),(199979,5555,'de','Fehler bei der Transaktionsverarbeitung',0),(199980,5555,'en','Error Occurred During Transaction Processing',0),(199981,5556,'is','',0),(199982,5556,'dr','Ø§Ø®ØªÙŠØ§Ø±ÙŠ â€“ ØªØ¹ÙŠÙŠÙ† ÙƒØ¯ Ø®Ø·Ø§ ',0),(199983,5556,'pr','Ø§Ø®ØªÙŠØ§Ø±ÙŠ â€“ ØªØ¹ÙŠÙŠÙ† ÙƒØ¯ Ø®Ø·Ø§ ',0),(199984,5556,'tr','Ä°steÄŸe baÄŸlÄ± - hata kodu atama',0),(199985,5556,'pl','Opcjonalnie - przypisaÄ‡ kod bÅ‚Ä™du',0),(199986,5556,'bg','ÐŸÐ¾ Ð¸Ð·Ð±Ð¾Ñ€ - Ð¿Ñ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð´ Ð½Ð° Ð³Ñ€ÐµÑˆÐºÐ°',0),(199987,5556,'ur','Ø§Ø®ØªÛŒØ§Ø±ÛŒ - ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº Ù†Ù‚Øµ Ú©ÙˆÚˆ',0),(199988,5556,'sr','ÐžÐ¿Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð¾ - Ð´Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ ÐºÃ´Ð´ Ð³Ñ€ÐµÑˆÐºÐµ',0),(199989,5556,'vi','Lá»±a chá»n - chá»‰ Ä‘á»‹nh mÃ£ lá»—i',0),(199990,5556,'af','Opsioneel - foutkode wys',0),(199991,5556,'ro','OpÅ£ional - asociaÅ£i codul de eroare',0),(199992,5556,'et','Vabatahtlik - mÃ¤Ã¤rata vea kood',0),(199993,5556,'si','Neobvezno - dodelite Å¡ifro napake',0),(199994,5556,'ba','Opsional - menetapkan kode kesalahan',0),(199995,5556,'nl','Optioneel - foutcode toewijzen',0),(199996,5556,'fi','Valinnainen - mÃ¤Ã¤rittÃ¤Ã¤ virhekoodin',0),(199997,5556,'no','Valgfritt - tilordne feilkode',0),(199998,5556,'da','Valgfri - tildele fejlkode',0),(199999,5556,'ko','ì˜µì…˜-ì˜¤ë¥˜ ì½”ë“œë¥¼ í• ë‹¹',0),(200000,5556,'he','××•×¤×¦×™×•× ×œ×™ - ×œ×”×§×¦×•×ª ×§×•×“ ×©×’×™××”',0),(200001,5556,'el','Î ÏÎ¿Î±Î¹ÏÎµÏ„Î¹ÎºÎ¬ - Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ ÎºÏ‰Î´Î¹ÎºÏŒ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚',0),(200002,5556,'zh','å¯é€‰- åˆ†é…é”™è¯¯ä»£ç \r\n',0),(200003,5556,'sv','Tillval - tilldela felkod',0),(200004,5556,'it','Facoltativo - assegnare il codice di errore',0),(200005,5556,'tl','',0),(200006,5556,'th','&#3607;&#3637;&#3656;&#3648;&#3611;&#3655;&#3609;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585; - &#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3627;&#3633;&#3626;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(200007,5556,'hi','à¤µà¥ˆà¤•à¤²à¥à¤ªà¤¿à¤• - à¤…à¤¸à¤¾à¤‡à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹à¤¡',0),(200008,5556,'ms','Pilihan - memperuntukkan kod ralat',0),(200009,5556,'ar','Ø§Ø®ØªÙŠØ§Ø±ÙŠ--ØªØ¹ÙŠÙŠÙ† Ø±Ù…Ø² Ø§Ù„Ø®Ø·Ø£',0),(200010,5556,'fr','Facultatif - affecter un Code erreur',0),(200011,5556,'jp','ä»»æ„?ãƒ¼å‰²ã‚Šå½“ã?¦ã‚¨ãƒ©ãƒ¼ã‚³ãƒ¼ãƒ‰',0),(200012,5556,'pt','Opcional - atribuir o cÃ³digo de erro',0),(200013,5556,'ru','ÐžÐ¿Ñ†Ð¸Ð¾Ð½Ð°Ð»ÑŒÐ½Ð¾ - Ð½Ð°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ ÐºÐ¾Ð´ Ð¾ÑˆÐ¸Ð±ÐºÐ¸',0),(200014,5556,'es','Opcional - Asignar CÃ³digo de Error',0),(200015,5556,'de','Optional - Fehlercode zuweisen',0),(200016,5556,'en','Optional - Assign Error Code',0),(200017,5557,'is','',0),(200018,5557,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(200019,5557,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(200020,5557,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde yapÄ±lan iÅŸlem deÄŸiÅŸiklikleri',0),(200021,5557,'pl','Zmiany transakcji pomyÅ›lnie',0),(200022,5557,'bg','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÐ½Ð¸Ñ‚Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(200023,5557,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ú©ÛŒ Ú¯Ø¦ÛŒ Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(200024,5557,'sr','Ð¢Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð¸Ð·Ð¼ÐµÐ½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(200025,5557,'vi','Thay Ä‘á»•i giao dá»‹ch thÃ nh cÃ´ng',0),(200026,5557,'af','Transaksie Veranderinge was Suksesvol',0),(200027,5557,'ro','TranzacÅ£ie modificÄƒrile fÄƒcute cu succes',0),(200028,5557,'et','Tehingu muudatuse tegemine Ãµnnestus',0),(200029,5557,'si','Transakcija spremembe uspeÅ¡no',0),(200030,5557,'ba','Perubahan transaksi yang dibuat berhasil',0),(200031,5557,'nl','Transactie wijzigingen met succes',0),(200032,5557,'fi','Tapahtuman muutokset onnistuneesti',0),(200033,5557,'no','Transaksjonen endringer vellykket',0),(200034,5557,'da','Transaktionen Ã¦ndringer med succes',0),(200035,5557,'ko','íŠ¸ëžœìž­ì…˜ ë³€ê²½ ë‚´ìš©ì„ ì„±ê³µì ìœ¼ë¡œ',0),(200036,5557,'he','×¢×¡×§×ª ×©×™× ×•×™×™× ×©×‘×•×¦×¢×• ×‘×”×¦×œ×—×”',0),(200037,5557,'el','Î£Ï…Î½Î±Î»Î»Î±Î³Î® Î±Î»Î»Î±Î³Î­Ï‚ Ï€Î¿Ï… Î­Î³Î¹Î½Î±Î½ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(200038,5557,'zh','äº¤æ˜“æ›´æ”¹æˆåŠŸ\r\n',0),(200039,5557,'sv','Transaktionen Ã¤ndringar framgÃ¥ngsrikt',0),(200040,5557,'it','Cambiamenti di transazione effettuate con successo',0),(200041,5557,'tl','',0),(200042,5557,'th','&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(200043,5557,'hi','à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤•à¤¿à¤ à¤—à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(200044,5557,'ms','Perubahan transaksi yang dibuat berjaya',0),(200045,5557,'ar','ØºÙŠÙ‘Ø±Øª Ø§Ù„Ø¹Ù…Ù„ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(200046,5557,'fr','Changements de transaction effectuÃ©es avec succÃ¨s',0),(200047,5557,'jp','å‡¦ç?†å¤‰æ›´ã?Œå®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(200048,5557,'pt','AlteraÃ§Ãµes de transaÃ§Ãµes feitas com sucesso',0),(200049,5557,'ru','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ, Ð²Ð½ÐµÑÐµÐ½Ð½Ñ‹Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(200050,5557,'es','Cambios de Transacciones se Hicieron Exitosamente',0),(200051,5557,'de','Ã„nderungen der Transaktion erfolgreich hergestellt',0),(200052,5557,'en','Transaction Changes Made Successfully',0),(200053,5558,'is','',0),(200054,5558,'dr','Ø§Ø¨Ø·Ø§Ù„ ØªÙ…Ø§Ù… Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ùˆ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø¯Ø± Ø§ÙŠÙ† ÙØ§ÙŠÙ„ ',0),(200055,5558,'pr','Ø§Ø¨Ø·Ø§Ù„ ØªÙ…Ø§Ù… Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ùˆ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø¯Ø± Ø§ÙŠÙ† ÙØ§ÙŠÙ„ ',0),(200056,5558,'tr','TÃ¼m hareketleri ve hesaplamalar bu dosyada geÃ§ersiz',0),(200057,5558,'pl','UniewaÅ¼nij wszystkie transakcje i obliczenia w tym pliku',0),(200058,5558,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ÑÑ‚Ð° Ð² Ñ‚Ð¾Ð·Ð¸ Ñ„Ð°Ð¹Ð»',0),(200059,5558,'ur','ØªÙ…Ø§Ù… Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø§ÙˆØ± Ø­Ø³Ø§Ø¨ Ø§Ø³ Ù…Ø³Ù„ Ù…ÛŒÚº ØµÙØ±',0),(200060,5558,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ ÑÐ²Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ð°ÑšÐ° Ñƒ Ð¾Ð²Ð¾Ñ˜ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸',0),(200061,5558,'vi','Há»§y táº¥t cáº£ giao dá»‹ch vÃ  tÃ­nh toÃ¡n trong há»“ sÆ¡ nÃ y',0),(200062,5558,'af','Alle Transaksies En Berekeninge In Hierdie LÃªer Moet Ongeldig Gemaak Word',0),(200063,5558,'ro','Anula toate tranzacÅ£iile ÅŸi calculele din acest fiÅŸier',0),(200064,5558,'et','Annulleeri ainult see tehing ja selle kalkulatsioonid selles failis',0),(200065,5558,'si','Razveljavi vse posle in izraÄuni v tej datoteki',0),(200066,5558,'ba','Membatalkan semua transaksi dan perhitungan dalam File ini',0),(200067,5558,'nl','VOID alle transacties en berekeningen In dit bestand',0),(200068,5558,'fi','MitÃ¤tÃ¶idÃ¤ kaikki liiketoimet ja laskelmia tÃ¤mÃ¤n tiedoston',0),(200069,5558,'no','Annullere alle transaksjoner og beregninger i denne filen',0),(200070,5558,'da','Annullere alle transaktioner og beregninger i denne fil',0),(200071,5558,'ko','ëª¨ë“  ê±°ëž˜ ë°ì´ íŒŒì¼ì— ìžˆëŠ” ê³„ì‚°ì„ ë¬´íš¨ë¡œ',0),(200072,5558,'he','×œ×‘×˜×œ ×›×œ ×˜×¨× ×–×§×¦×™×•×ª ×•×”×—×™×©×•×‘×™× ×”×›×œ×•×œ×™× ×‘×§×•×‘×¥ ×–×”',0),(200073,5558,'el','Î‘ÎºÏ…ÏÏŽÏƒÎµÎ¹ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ ÎºÎ±Î¹ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Î¯ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(200074,5558,'zh','åœ¨è¿™ä¸ªæ–‡ä»¶ä¸­çš„æ— æ‰€æœ‰æ•ˆäº¤æ˜“å’Œè®¡ç®—\r\n',0),(200075,5558,'sv','Annullera alla transaktioner och berÃ¤kningar i denna fil',0),(200076,5558,'it','Annullare tutte le operazioni e i calcoli In questo File',0),(200077,5558,'tl','',0),(200078,5558,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3651;&#3609;&#3652;&#3615;&#3621;&#3660;&#3609;&#3637;&#3657;',0),(200079,5558,'hi','à¤¸à¤­à¥€ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤”à¤° à¤—à¤£à¤¨à¤¾ à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤² à¤®à¥‡à¤‚ à¤¶à¥‚à¤¨à¥à¤¯',0),(200080,5558,'ms','Membatalkan semua urus niaga dan pengiraan dalam fail ini',0),(200081,5558,'ar','Ø¥ÙØ±Ø§Øº ÙƒØ§ÙØ© Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙˆØ§Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ÙŠØ© ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù…Ù„Ù',0),(200082,5558,'fr','Annuler toutes les Transactions et les calculs dans ce fichier',0),(200083,5558,'jp','ã?“ã?®ãƒ•ã‚¡ã‚¤ãƒ«ã?®å…¨ã?¦ã?®å‡¦ç?†ã?¨è¨ˆç®—ã‚’ç ´æ£„ã?™ã‚‹',0),(200084,5558,'pt','Anular todas as transaÃ§Ãµes e cÃ¡lculos neste arquivo',0),(200085,5558,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²ÑÐµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ð¸ Ñ€Ð°ÑÑ‡ÐµÑ‚Ñ‹ Ð² ÑÑ‚Ð¾Ð¼ Ñ„Ð°Ð¹Ð»Ðµ',0),(200086,5558,'es','Anular Todas las Transacciones y CÃ¡lculos En Este File',0),(200087,5558,'de','Werden Sie alle Transaktionen und Berechnungen In dieser Datei',0),(200088,5558,'en','Void All Transactions And Calculations In This File',0),(200089,5559,'is','',0),(200090,5559,'dr','Ø§Ø¨Ø·Ø§Ù„ ØªÙ…Ø§Ù… Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ùˆ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ùˆ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª  Ø¯Ø± Ø§ÙŠÙ† ÙØ§ÙŠÙ„ ',0),(200091,5559,'pr','Ø§Ø¨Ø·Ø§Ù„ ØªÙ…Ø§Ù… Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ùˆ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ùˆ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª  Ø¯Ø± Ø§ÙŠÙ† ÙØ§ÙŠÙ„ ',0),(200092,5559,'tr','TÃ¼m hareketler, hesaplamalar ve Ã¶deme verileri bu dosyada geÃ§ersiz',0),(200093,5559,'pl','UniewaÅ¼nij wszystkie transakcje, obliczenia i zapÅ‚aciÄ‡ danych w tym pliku',0),(200094,5559,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸, Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ Ð² Ñ‚Ð¾Ð·Ð¸ Ñ„Ð°Ð¹Ð»',0),(200095,5559,'ur','ØªÙ…Ø§Ù… Ù„ÛŒÙ† Ø¯ÛŒÙ†ØŒ Ø­Ø³Ø§Ø¨ Ø§ÙˆØ± Ø§Ø³ ÙØ§Ø¦Ù„ Ù…ÛŒÚº ØªÙ†Ø®ÙˆØ§Û Ú©Û’ ÚˆÛŒÙ¹Ø§ ØµÙØ±',0),(200096,5559,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ, Ð¿Ñ€Ð¾Ñ€Ð°Ñ‡ÑƒÐ½Ð¸Ð¼Ð° Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñƒ Ð¾Ð²Ð¾Ñ˜ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸',0),(200097,5559,'vi','Há»§y táº¥t cáº£ giao dá»‹ch, tÃ­nh toÃ¡n & dá»¯ liá»‡u thanh toÃ¡n trong há»“ sÆ¡ nÃ y',0),(200098,5559,'af','Alle Transaksies, Berekeninge En Loon Data In Hierdie LÃªer Moet Ongeldig Gemaak Word',0),(200099,5559,'ro','Anula toate tranzacÅ£iile, calcule ÅŸi datele de platÄƒ Ã®n acest fiÅŸier',0),(200100,5559,'et','Annulleeri ainult see tehing ja selle kalkulatsioonid ja makseandmed selles failis',0),(200101,5559,'si','Razveljavi vse transakcije, izraÄuni in plaÄati podatkov v tej datoteki',0),(200102,5559,'ba','Membatalkan semua transaksi, perhitungan dan membayar Data dalam File ini',0),(200103,5559,'nl','VOID alle transacties, berekeningen en betalen gegevens In dit bestand',0),(200104,5559,'fi','MitÃ¤tÃ¶idÃ¤ kaikki liiketoimiin, laskelmat ja maksu tiedot tÃ¤stÃ¤ tiedostosta',0),(200105,5559,'no','Annullere alle transaksjoner, beregninger og betale Data i denne filen',0),(200106,5559,'da','Annullere alle transaktioner, beregninger og lÃ¸n Data i denne fil',0),(200107,5559,'ko','ëª¨ë“  íŠ¸ëžœìž­ì…˜, ê³„ì‚° ë° ì§€ë¶ˆì´ì´ íŒŒì¼ì˜ ë°ì´í„° ë¬´íš¨',0),(200108,5559,'he','×ª×•×§×£ ×›×œ ×¢×¡×§××•×ª, ×—×™×©×•×‘×™× ×•× ×ª×•× ×™ ×”×©×›×¨ ×‘×§×•×‘×¥ ×–×”',0),(200109,5559,'el','Î‘ÎºÏ…ÏÏŽÏƒÎµÎ¹ ÏŒÎ»ÎµÏ‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚, Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ ÎºÎ±Î¹ Pay Î´ÎµÎ´Î¿Î¼Î­Î½Î± ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(200110,5559,'zh','åœ¨æ­¤æ–‡ä»¶ä¸­ä½œåºŸæ‰€æœ‰äº¤æ˜“ï¼Œè®¡ç®—å’Œè–ªé…¬æ•°æ®',0),(200111,5559,'sv','Annullera alla transaktioner, berÃ¤kningar och betala Data i denna fil',0),(200112,5559,'it','Annullare tutte le transazioni, i calcoli e dati di retribuzione In questo File',0),(200113,5559,'tl','',0),(200114,5559,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3649;&#3621;&#3632;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3651;&#3609;&#3652;&#3615;&#3621;&#3660;&#3609;&#3637;&#3657;',0),(200115,5559,'hi','à¤¸à¤­à¥€ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨, à¤—à¤£à¤¨à¤¾ à¤”à¤° à¤µà¥‡à¤¤à¤¨ à¤¡à¥‡à¤Ÿà¤¾ à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤² à¤®à¥‡à¤‚ à¤¶à¥‚à¤¨à¥à¤¯',0),(200116,5559,'ms','Membatalkan semua urus niaga, pengiraan dan membayar Data dalam fail ini',0),(200117,5559,'ar','Ø¥ÙØ±Ø§Øº ÙƒØ§ÙØ© Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙˆØ§Ù„Ø­Ø³Ø§Ø¨Ø§Øª ÙˆØ¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¯ÙØ¹ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù…Ù„Ù',0),(200118,5559,'fr','Annuler toutes les Transactions, les calculs et les donnÃ©es salariales dans ce fichier',0),(200119,5559,'jp','ã?“ã?®ãƒ•ã‚¡ã‚¤ãƒ«ã?®å…¨ã?¦ã?®å‡¦ç?†ã?¨ã€?è¨ˆç®—ã€?æ”¯æ‰•ã?„ãƒ‡ãƒ¼ã‚¿ã‚’ç ´æ£„ã?™ã‚‹',0),(200120,5559,'pt','Anular todas as transaÃ§Ãµes, os cÃ¡lculos e dados de pagamento neste arquivo',0),(200121,5559,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²ÑÐµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸, Ñ€Ð°ÑÑ‡ÐµÑ‚Ñ‹ Ð¸ Ð¾Ð¿Ð»Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð² ÑÑ‚Ð¾Ð¼ Ñ„Ð°Ð¹Ð»Ðµ',0),(200122,5559,'es','Anular Todas las Transacciones, CÃ¡lculos y Datos de Pagos En Este File',0),(200123,5559,'de','Werden Sie alle Transaktionen, Berechnungen und Zahlen Daten In dieser Datei',0),(200124,5559,'en','Void All Transactions, Calculations And Pay Data In This File',0),(200125,5560,'is','',0),(200126,5560,'dr','Ø§Ø¨Ø·Ø§Ù„ ÙÙ‚Ø· Ø§ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡ Ùˆ Ù…Ø­Ø§Ø³Ø¨Ø§ØªØ´ ',0),(200127,5560,'pr','Ø§Ø¨Ø·Ø§Ù„ ÙÙ‚Ø· Ø§ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡ Ùˆ Ù…Ø­Ø§Ø³Ø¨Ø§ØªØ´ ',0),(200128,5560,'tr','Sadece bu hareket ve hesaplama geÃ§ersiz',0),(200129,5560,'pl','UniewaÅ¼nij tylko tej transakcji i jej obliczenia',0),(200130,5560,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Ñ‚Ð°Ð·Ð¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¸ Ð½ÐµÐ³Ð¾Ð²Ð¸Ñ‚Ðµ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(200131,5560,'ur','ØµØ±Ù Ø§Ø³ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø§ÙˆØ± Ø§Ø³ Ú©Û’ ØªØ®Ù…ÛŒÛ Ø¬Ø§Øª ØµÙØ±',0),(200132,5560,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð¾Ð²Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð¸ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÑƒ',0),(200133,5560,'vi','Chá»‰ Há»§y giao dá»‹ch & tÃ­nh toÃ¡n nÃ y',0),(200134,5560,'af','Void slegs hierdie transaksie en sy berekeninge',0),(200135,5560,'ro','Anula numai aceastÄƒ tranzacÅ£ie ÅŸi calculele',0),(200136,5560,'et','Annulleeri ainult see tehing ja selle kalkulatsioonid',0),(200137,5560,'si','NiÄna le to transakcijo in svojih izraÄunih',0),(200138,5560,'ba','Membatalkan transaksi ini dan perhitungan',0),(200139,5560,'nl','Void alleen deze transactie en de berekeningen',0),(200140,5560,'fi','MitÃ¤tÃ¶idÃ¤ tÃ¤mÃ¤n tapahtuman ja sen laskelmat',0),(200141,5560,'no','Annullere bare denne transaksjonen og beregningene',0),(200142,5560,'da','Ugyldig kun denne transaktion og sine beregninger',0),(200143,5560,'ko','ë¬´íš¨ë§Œì´ ê±°ëž˜ì™€ ê³„ì‚°',0),(200144,5560,'he','×ª×•×§×£ ×¨×§ ×ª× ×•×¢×” ×–×• ×•×—×™×©×•×‘×™× ×©×œ×•',0),(200145,5560,'el','ÎÎ± Î±ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Î¼ÏŒÎ½Î¿ Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚ ÎºÎ±Î¹ Ï„Î¿Ï…Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ Ï„Î·Ï‚',0),(200146,5560,'zh','ä»…ä½œåºŸæ­¤äº¤æ˜“åŠå…¶è®¡ç®—',0),(200147,5560,'sv','Annullera endast denna transaktion och dess berÃ¤kningar',0),(200148,5560,'it','Annullare solo questa transazione e calcoli',0),(200149,5560,'tl','',0),(200150,5560,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(200151,5560,'hi','à¤•à¥‡à¤µà¤² à¤‡à¤¸ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤”à¤° à¤‡à¤¸à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤¶à¥‚à¤¨à¥à¤¯',0),(200152,5560,'ms','Membatalkan sahaja urusniaga ini dan pengiraan yang',0),(200153,5560,'ar','Ø§Ù„ÙØ±Ø§Øº ÙÙ‚Ø· Ù…Ù† Ù‡Ø°Ù‡ Ø§Ù„Ø­Ø±ÙƒØ© ÙˆØ­Ø³Ø§Ø¨Ø§ØªÙ‡Ø§',0),(200154,5560,'fr','Void seulement cette Transaction et ses calculs',0),(200155,5560,'jp','ã?“ã?®å‡¦ç?†ã?¨ã??ã?®è¨ˆç®—ã? ã?‘ã‚’ç ´æ£„ã?™ã‚‹',0),(200156,5560,'pt','Vazio sÃ³ esta transaÃ§Ã£o e seus cÃ¡lculos',0),(200157,5560,'ru','ÐÐµÐ´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼Ð¸ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÑÑ‚Ð¾Ð¹ ÑÐ´ÐµÐ»ÐºÐ¸ Ð¸ Ñ€Ð°ÑÑ‡ÐµÑ‚Ñ‹',0),(200158,5560,'es','Anular Solo Esta TransacciÃ³n Y Sus CÃ¡lculos',0),(200159,5560,'de','Werden Sie nur diese Transaktion und ihre Berechnungen',0),(200160,5560,'en','Void Only This Transaction And Its Calculations',0),(200161,5561,'is','',0),(200162,5561,'dr','(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(200163,5561,'pr','Ø§Ø¨Ø·Ø§Ù„ ÙÙ‚Ø· Ø§ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡ Ùˆ Ù…Ø­Ø§Ø³Ø¨Ø§ØªØ´ Ùˆ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(200164,5561,'tr','Sadece bu hareket ve hesaplama iptal ve Ã¶deme veri',0),(200165,5561,'pl','UniewaÅ¼nij tylko tej transakcji i jej obliczenia i zapÅ‚aty danych',0),(200166,5561,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Ñ‚Ð°Ð·Ð¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ÑÑ‚Ð° ÑÐ¸ Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð´Ð°Ð½Ð½Ð¸',0),(200167,5561,'ur','ØµØ±Ù Ø§Ø³ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø§ÙˆØ± Ø§Ø³ Ú©Û’ ØªØ®Ù…ÛŒÛ Ø¬Ø§Øª ØµÙØ± Ø§ÙˆØ± Ú©ÙˆØ§Ø¦Ù Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(200168,5561,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð¾Ð²Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð¸ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÑƒ Ð¸ Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(200169,5561,'vi','Chá»‰ Há»§y giao dá»‹ch, tÃ­nh toÃ¡n & dá»¯ liá»‡u thanh toÃ¡n nÃ y',0),(200170,5561,'af','Slegs Hierdie Transaksie En Sy Berekeninge en Besoldiging Data is Ongeldig',0),(200171,5561,'ro','Anula numai aceastÄƒ tranzacÅ£ie ÅŸi calculele ÅŸi sÄƒ plÄƒteascÄƒ date',0),(200172,5561,'et','Annulleeri ainult see tehing ja selle kalkulatsioonid ja makseandmed',0),(200173,5561,'si','NiÄna le to transakcijo in njegove izraÄune in plaÄati podatkov',0),(200174,5561,'ba','Membatalkan transaksi ini dan perhitungan dan membayar Data',0),(200175,5561,'nl','Void alleen deze transactie en de berekeningen en betalen van gegevens',0),(200176,5561,'fi','MitÃ¤tÃ¶idÃ¤ tÃ¤mÃ¤n tapahtuman ja laskelmansa ja maksaa tiedot',0),(200177,5561,'no','Annullere bare denne transaksjonen og beregningene og betale Data',0),(200178,5561,'da','Ugyldig kun denne transaktion og sine beregninger og betale Data',0),(200179,5561,'ko','ë¬´íš¨ë§Œì´ ê±°ëž˜ ë° ê³„ì‚° ë°ì´í„°ë¥¼ ì§€ë¶ˆ í•˜ ê³ ',0),(200180,5561,'he','×ª×•×§×£ ×¨×§ ×ª× ×•×¢×” ×–×• ×•×—×™×©×•×‘×™× ×©×œ×• ×•×œ×©×œ× × ×ª×•× ×™×',0),(200181,5561,'el','ÎÎ± Î±ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Î¼ÏŒÎ½Î¿ Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚ ÎºÎ±Î¹ Ï„Î¿Ï…Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ ÎºÎ±Î¹ Î½Î± Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(200182,5561,'zh','ä»…ä½œåºŸæ­¤äº¤æ˜“åŠå…¶è®¡ç®—åŠè–ªé‡‘æ•°æ®',0),(200183,5561,'sv','Annullera endast denna transaktion och dess berÃ¤kningar och Data',0),(200184,5561,'it','Annullare solo questa transazione e relativi calcoli e pagare i dati',0),(200185,5561,'tl','',0),(200186,5561,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3609;&#3637;&#3657;,&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3649;&#3621;&#3632;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#',0),(200187,5561,'hi','à¤•à¥‡à¤µà¤² à¤‡à¤¸ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤”à¤° à¤‡à¤¸à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤¶à¥‚à¤¨à¥à¤¯ à¤”à¤° à¤¡à¥‡à¤Ÿà¤¾ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(200188,5561,'ms','Membatalkan sahaja urusniaga ini dan pengiraan yang dan membayar Data',0),(200189,5561,'ar','Ø§Ù„ÙØ±Ø§Øº ÙÙ‚Ø· Ù…Ù† Ù‡Ø°Ù‡ Ø§Ù„Ø­Ø±ÙƒØ© ÙˆØ­Ø³Ø§Ø¨Ø§ØªÙ‡Ø§ ÙˆØ¯ÙØ¹ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(200190,5561,'fr','Void seulement cette Transaction et ses calculs et payer des donnÃ©es',0),(200191,5561,'jp','ã?“ã?®å‡¦ç?†ã?¨ã??ã?®è¨ˆç®—ã€?æ”¯æ‰•ã?„ãƒ‡ãƒ¼ã‚¿ã? ã?‘ã‚’ç ´æ£„ã?™ã‚‹',0),(200192,5561,'pt','Vazio sÃ³ esta transaÃ§Ã£o e seus cÃ¡lculos e pagar dados',0),(200193,5561,'ru','ÐÐµÐ´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼Ð¸ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÑÑ‚Ð¾Ð¹ ÑÐ´ÐµÐ»ÐºÐ¸ Ð¸ ÐµÐµ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¸ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(200194,5561,'es','Anular Solo Esta TransacciÃ³n Y Sus CÃ¡lculos y Datos de Pagos',0),(200195,5561,'de','Werden nur diese Transaktion und ihre Berechnungen und Zahlen Daten',0),(200196,5561,'en','Void Only This Transaction And Its Calculations And Pay Data',0),(200197,5562,'is','',0),(200198,5562,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(200199,5562,'pr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(200200,5562,'tr','Direkt mevduat dosyalar',0),(200201,5562,'pl','KierowaÄ‡ zastaw Akta',0),(200202,5562,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(200203,5562,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ Ù…Ø³Ù„ÛŒÚº',0),(200204,5562,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(200205,5562,'vi','Há»“ sÆ¡ giao dá»‹ch trá»±c tiáº¿p',0),(200206,5562,'af','Direkte DepositolÃªers',0),(200207,5562,'ro','Fisiere depozit direct',0),(200208,5562,'et','Otsene hoiuste failid',0),(200209,5562,'si','Neposreden vloga pila',0),(200210,5562,'ba','Deposit langsung file',0),(200211,5562,'nl','Directe storting bestanden',0),(200212,5562,'fi','Suora talletus tiedostot',0),(200213,5562,'no','Direkte innskudd fil-stÃ¸rrelse',0),(200214,5562,'da','Lede indestÃ¥ende filer',0),(200215,5562,'ko','ì§ì ‘ ìž…ê¸ˆ íŒŒì¼',0),(200216,5562,'he','×”×¤×§×“×” ×™×©×™×¨×” ×§×‘×¦×™×',0),(200217,5562,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î±ÏÏ‡ÎµÎ¯Î±',0),(200218,5562,'zh','ç›´æŽ¥å­˜å…¥æ¡£æ¡ˆ\r\n',0),(200219,5562,'sv','Direkt insÃ¤ttning filer',0),(200220,5562,'it','Deposito diretto file',0),(200221,5562,'tl','',0),(200222,5562,'th','&#3652;&#3615;&#3621;&#3660;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(200223,5562,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(200224,5562,'ms','Deposit terus fail',0),(200225,5562,'ar','Ù…Ù„ÙØ§Øª Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(200226,5562,'fr','DÃ©pÃ´t direct de fichiers',0),(200227,5562,'jp','ç›´æŽ¥å…¥é‡‘ãƒ•ã‚¡ã‚¤ãƒ«',0),(200228,5562,'pt','DepÃ³sito direto arquivos',0),(200229,5562,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ ÐŸÑ€ÑÐ¼Ð¾Ð³Ð¾ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(200230,5562,'es','Archivos de DepÃ³sitos Directos',0),(200231,5562,'de','Direkte Ablagerung Dateien',0),(200232,5562,'en','Direct Deposit Files',0),(200233,5563,'is','',0),(200234,5563,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(200235,5563,'pr','Ù†Ù…Ø§ÙŠØ´ Ùˆ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ø³Ù¾Ø±Ø¯Ù‡(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(200236,5563,'tr','GÃ¶rÃ¼nÃ¼m ve doÄŸrudan yatÄ±rma dosya indirme',0),(200237,5563,'pl','Zobacz i Pobierz pliki bezpoÅ›redni depozyt',0),(200238,5563,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¸ Ð¸Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(200239,5563,'ur','Ø¯ÛŒÚ©Ú¾ÛŒÚº Ø§ÙˆØ± ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ù…Ø³Ù„ÛŒÚº',0),(200240,5563,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(200241,5563,'vi','Xem & táº£i há»“ sÆ¡ thanh toÃ¡n trá»±c tiáº¿p',0),(200242,5563,'af','Besigtig en Aflaai van Direkte DepositolÃªers',0),(200243,5563,'ro','Vizualiza ÅŸi descÄƒrca fiÅŸiere Direct de depozit',0),(200244,5563,'et','Saate vaadata ja alla laadida otse hoiule',0),(200245,5563,'si','Pregledovanje in prenos datotek neposredno depozit',0),(200246,5563,'ba','Melihat dan men-Download file Deposit langsung',0),(200247,5563,'nl','Bekijken en downloaden van bestanden van de directe storting',0),(200248,5563,'fi','Katso ja Download antaa tehtÃ¤vÃ¤ksi esiintymÃ¤ arkistoida',0),(200249,5563,'no','Vise og laste ned direkte innskudd fil-stÃ¸rrelse',0),(200250,5563,'da','Se og Download direkte indestÃ¥ende filer',0),(200251,5563,'ko','ë³´ê¸° ë° ì§ì ‘ ìž…ê¸ˆ íŒŒì¼ ë‹¤ìš´ë¡œë“œ',0),(200252,5563,'he','×œ×”×¦×™×’ ×•×œ×”×•×¨×™×“ ×§×‘×¦×™× ×”×¤×§×“×” ×™×©×™×¨×”',0),(200253,5563,'el','Î”ÎµÎ¯Ï„Îµ ÎºÎ±Î¹ Î½Î± ÎºÎ±Ï„ÎµÎ²Î¬ÏƒÎµÏ„Îµ Ï„Î·Î½ Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î±ÏÏ‡ÎµÎ¯Î±',0),(200254,5563,'zh','æŸ¥çœ‹å’Œä¸‹è½½çš„ç›´æŽ¥å­˜æ¬¾æ–‡ä»¶\r\n',0),(200255,5563,'sv','Visa och hÃ¤mta direkt insÃ¤ttning filer',0),(200256,5563,'it','Visualizzare e scaricare i file deposito diretto',0),(200257,5563,'tl','',0),(200258,5563,'th','&#3649;&#3626;&#3604;&#3591;&#3649;&#3621;&#3632;&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;&#3652;&#3615;&#3621;&#3660;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(200259,5563,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤”à¤° à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤«à¤¼à¤¾à¤‡à¤²à¥‹à¤‚ à¤•à¥‹ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(200260,5563,'ms','Melihat dan memuat turun fail-fail Deposit terus',0),(200261,5563,'ar','Ø¹Ø±Ø¶ ÙˆØªØ­Ù…ÙŠÙ„ Ù…Ù„ÙØ§Øª Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(200262,5563,'fr','Visualiser et tÃ©lÃ©charger des fichiers de virement automatique',0),(200263,5563,'jp','å?£åº§æŒ¯è¾¼ãƒ•ã‚¡ã‚¤ãƒ«ã?®è¡¨ç¤ºã?¨ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰',0),(200264,5563,'pt','Ver e baixar arquivos de depÃ³sito direto',0),(200265,5563,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð¸ Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ð¤Ð°Ð¹Ð»Ñ‹ ÐŸÑ€ÑÐ¼Ð¾Ð³Ð¾ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(200266,5563,'es','Visionar y Descargar Archivos de DepÃ³sitos Directos',0),(200267,5563,'de','Ansicht und Download Direct Deposit-Dateien',0),(200268,5563,'en','View and Download Direct Deposit Files',0),(200269,5564,'is','',0),(200270,5564,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙØ§ÙŠÙ„ ',0),(200271,5564,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙØ§ÙŠÙ„ ',0),(200272,5564,'tr','Dosya kimliÄŸi',0),(200273,5564,'pl','ID pliku',0),(200274,5564,'bg','Ð˜Ð” Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(200275,5564,'ur','Ù…Ø³Ù„ ØªØ´Ø®Øµ',0),(200276,5564,'sr','Ð˜Ð” Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(200277,5564,'vi','ID Há»“ sÆ¡',0),(200278,5564,'af','LÃªer ID',0),(200279,5564,'ro','ID fisier',0),(200280,5564,'et','Faili ID',0),(200281,5564,'si','ID datoteke',0),(200282,5564,'ba','File ID',0),(200283,5564,'nl','Bestands-ID',0),(200284,5564,'fi','Tiedostotunnus',0),(200285,5564,'no','Fil-ID',0),(200286,5564,'da','Fil-ID',0),(200287,5564,'ko','íŒŒì¼ ID',0),(200288,5564,'he','×ž×–×”×” ×§×•×‘×¥',0),(200289,5564,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(200290,5564,'zh','æ–‡ä»¶ID\r\n',0),(200291,5564,'sv','Fil-ID',0),(200292,5564,'it','File ID',0),(200293,5564,'tl','',0),(200294,5564,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3652;&#3615;&#3621;&#3660;',0),(200295,5564,'hi','à¤«à¤¼à¤¾à¤‡à¤² ID',0),(200296,5564,'ms','Pengenalan fail',0),(200297,5564,'ar','Ù…Ø¹Ø±Ù‘Ù Ø§Ù„Ù…Ù„ÙÙ‘',0),(200298,5564,'fr','ID de fichier',0),(200299,5564,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ï¼©ï¼¤',0),(200300,5564,'pt','Arquivo ID',0),(200301,5564,'ru','ID Ð¤Ð°Ð¹Ð»Ð°',0),(200302,5564,'es','File ID',0),(200303,5564,'de','Datei-ID',0),(200304,5564,'en','File ID',0),(200305,5565,'is','',0),(200306,5565,'dr','(Ø³Ø§Ø¨Ù‚Ù‡ )  Ù†ÙŠØ³Øª',0),(200307,5565,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ø«Ø¨Øª (Ø³Ø§Ø¨Ù‚Ù‡ )  Ù†ÙŠØ³Øª',0),(200308,5565,'tr','KayÄ±t bulunamadÄ±',0),(200309,5565,'pl','Nie moÅ¼na odnaleÅºÄ‡ rekordu',0),(200310,5565,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð·Ð°Ð¿Ð¸Ñ',0),(200311,5565,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ù†ÛÛŒÚº Ù…Ù„ Ø³Ú©Ø§',0),(200312,5565,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð·Ð°Ð¿Ð¸Ñ',0),(200313,5565,'vi','KhÃ´ng tÃ¬m tháº¥y há»“ sÆ¡',0),(200314,5565,'af','Kon vind nie rekord',0),(200315,5565,'ro','Nu am gasit inregistrarea',0),(200316,5565,'et','Ei leia kirjet',0),(200317,5565,'si','Zapisa ni bilo mogoÄe najti.',0),(200318,5565,'ba','Tidak dapat menemukan Record',0),(200319,5565,'nl','Kan Record niet vinden',0),(200320,5565,'fi','Tietuetta ei lÃ¶ydy',0),(200321,5565,'no','Finner ikke posten',0),(200322,5565,'da','Kunne ikke finde posten',0),(200323,5565,'ko','ë ˆì½”ë“œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(200324,5565,'he','×œ× × ×™×ª×Ÿ ×œ×ž×¦×•× ×¨×©×•×ž×”',0),(200325,5565,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(200326,5565,'zh','æ— æ³•æŸ¥æ‰¾è®°å½•\r\n',0),(200327,5565,'sv','Kunde inte hitta posten',0),(200328,5565,'it','Non poteva trovare Record',0),(200329,5565,'tl','',0),(200330,5565,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3588;&#3657;&#3609;&#3627;&#3634;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3652;&#3604;&#3657;',0),(200331,5565,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(200332,5565,'ms','Tidak dapat mencari rekod',0),(200333,5565,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø³Ø¬Ù„',0),(200334,5565,'fr','N\'a pas trouvÃ© d\'enregistrement',0),(200335,5565,'jp','è¨˜éŒ²ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(200336,5565,'pt','NÃ£o foi possÃ­vel localizar o registro',0),(200337,5565,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÐÐ°Ð¹Ñ‚Ð¸ Ð—Ð°Ð¿Ð¸ÑÑŒ',0),(200338,5565,'es','No se puede encontrar el registro',0),(200339,5565,'de','Datensatz konnte nicht gefunden werden.',0),(200340,5565,'en','Could Not Find Record',0),(200341,5566,'is','',0),(200342,5566,'dr','Ù‚Ø§Ù„Ø¨ ÙØ§ÙƒØªÙˆØ± ',0),(200343,5566,'pr','Ù‚Ø§Ù„Ø¨ ÙØ§ÙƒØªÙˆØ± ',0),(200344,5566,'tr','Fatura formatÄ±',0),(200345,5566,'pl','Format faktury',0),(200346,5566,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°',0),(200347,5566,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(200348,5566,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(200349,5566,'vi','Dáº¡ng HÃ³a Ä‘Æ¡n ',0),(200350,5566,'af','Faktuurformaat',0),(200351,5566,'ro','Format factura',0),(200352,5566,'et','Arve formaat',0),(200353,5566,'si','Oblika raÄuna',0),(200354,5566,'ba','Faktur Format',0),(200355,5566,'nl','Factuur opmaken',0),(200356,5566,'fi','Laskun muoto',0),(200357,5566,'no','Faktura-Format',0),(200358,5566,'da','Faktura Format',0),(200359,5566,'ko','ì†¡ìž¥ í˜•ì‹',0),(200360,5566,'he','×ª×‘× ×™×ª ×—×©×‘×•× ×™×ª',0),(200361,5566,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¼Î¿ÏÏ†Î®',0),(200362,5566,'zh','å‘ç¥¨æ ¼å¼\r\n',0),(200363,5566,'sv','Faktura-Format',0),(200364,5566,'it','Formato fattura',0),(200365,5566,'tl','',0),(200366,5566,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(200367,5566,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(200368,5566,'ms','Format invois',0),(200369,5566,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(200370,5566,'fr','Format de facture',0),(200371,5566,'jp','è«‹æ±‚æ›¸ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(200372,5566,'pt','Formato de factura',0),(200373,5566,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð¡Ñ‡ÐµÑ‚Ð°',0),(200374,5566,'es','Formato de Factura',0),(200375,5566,'de','Rechnungsformat',0),(200376,5566,'en','Invoice Format',0),(200377,5567,'is','',0),(200378,5567,'dr','Ú†Ø§Ù¾ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(200379,5567,'pr','Ú†Ø§Ù¾ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(200380,5567,'tr','Standart yazdÄ±rma',0),(200381,5567,'pl','Standardowe drukowanie',0),(200382,5567,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ð¿ÐµÑ‡Ð°Ñ‚',0),(200383,5567,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ',0),(200384,5567,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ ÐŸÑ€Ð¸Ð½Ñ‚',0),(200385,5567,'vi','In chuáº©n',0),(200386,5567,'af','Standaard Uitdruk',0),(200387,5567,'ro','Imprimare standard',0),(200388,5567,'et','Standard printimine',0),(200389,5567,'si','Standard tiskanja',0),(200390,5567,'ba','Standar cetak',0),(200391,5567,'nl','Standaard afdrukken',0),(200392,5567,'fi','Standard tulosta',0),(200393,5567,'no','Standard trykk',0),(200394,5567,'da','Standard Print',0),(200395,5567,'ko','í‘œì¤€ ì¸ì‡„',0),(200396,5567,'he','×”×“×¤×¡×” ×¡×˜× ×“×¨×˜×™×ª',0),(200397,5567,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€ÏÏŒÏ„Ï…Ï€Î¿',0),(200398,5567,'zh','æ ‡å‡†æ‰“å°\r\n',0),(200399,5567,'sv','Standard Print',0),(200400,5567,'it','Stampa standard',0),(200401,5567,'tl','',0),(200402,5567,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3649;&#3610;&#3610;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(200403,5567,'hi','à¤®à¤¾à¤¨à¤• à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(200404,5567,'ms','Cetak Standard',0),(200405,5567,'ar','Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(200406,5567,'fr','Impression standard',0),(200407,5567,'jp','æ¨™æº–å?°åˆ·',0),(200408,5567,'pt','ImpressÃ£o PadrÃ£o',0),(200409,5567,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(200410,5567,'es','Imprimir EstÃ¡ndar',0),(200411,5567,'de','Norm Print',0),(200412,5567,'en','Standard Print',0),(200413,5568,'is','',0),(200414,5568,'dr','Ù…ØªÙˆÙ‚Ù ÙƒØ±Ø¯Ù† Ø³Ø± ØµÙØ­Ù‡ Ø¨Ø±Ø§ÙŠ  Ù¾ÙŠØ´ Ú†Ø§Ù¾ Ù‡Ø§',0),(200415,5568,'pr','Ù…ØªÙˆÙ‚Ù ÙƒØ±Ø¯Ù† Ø³Ø± ØµÙØ­Ù‡ Ø¨Ø±Ø§ÙŠ  Ù¾ÙŠØ´ Ú†Ø§Ù¾ Ù‡Ø§',0),(200416,5568,'tr','Ãœstbilgi bastÄ±rmak iÃ§in baskÄ±lar',0),(200417,5568,'pl','PomiÅ„ nagÅ‚Ã³wka dla przebitki',0),(200418,5568,'bg','ÐŸÐ¾Ñ‚Ð¸ÑÐºÐ°Ð½Ðµ Ð½Ð° Ð·Ð°Ð³Ð»Ð°Ð²Ð½Ð¸Ñ Ð±Ð»Ð¾Ðº Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸',0),(200419,5568,'ur','Ø³Ø±ØªØ­Ø±ÛŒØ± Ú©Û’ Ù„ÛŒÛ’ Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ Ø¯Ø¨Ø§Ø¦ÛŒÚº Û”',0),(200420,5568,'sr','ÐŸÐ¾Ñ‚Ð¸ÑÐ½ÑƒÑ‚Ð¸ Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ðµ Ð·Ð° ÐŸÑ€ÐµÐ¿Ñ€Ð¸Ð½Ñ‚Ñ',0),(200421,5568,'vi','Bá» tiÃªu Ä‘á» in trÆ°á»›c',0),(200422,5568,'af','Dekblad vir Preprints onderdruk',0),(200423,5568,'ro','Suprima antetul pentru neverificate',0),(200424,5568,'et','TÃµkesta pÃ¤ise preprindid',0),(200425,5568,'si','Zatiranje glava za nepregledanih',0),(200426,5568,'ba','Header untuk menekan Pracetak',0),(200427,5568,'nl','Koptekst voor Voordrukken onderdrukken',0),(200428,5568,'fi','Piilota otsikon koevedoksia',0),(200429,5568,'no','Skjul topptekst for samlingen',0),(200430,5568,'da','Undertrykke Header efter Preprints',0),(200431,5568,'ko','ìžë£Œì— ëŒ€ í•œ í—¤ë”ë¥¼ ì–µì œ',0),(200432,5568,'he','×œ×“×›× ××ª ×”×›×•×ª×¨×ª ×¢×‘×•×¨ ×ª×ž×¦×•×ª×™',0),(200433,5568,'el','Suppress Header Î³Î¹Î± Ï€ÏÎ¿Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏƒÎµÎ¹Ï‚',0),(200434,5568,'zh','ç¦æ­¢æŽ¥å¤´é¢„å°æœ¬\r\n',0),(200435,5568,'sv','Undertrycka sidhuvud fÃ¶r Preprints',0),(200436,5568,'it','Eliminare l\'intestazione per Preprints',0),(200437,5568,'tl','',0),(200438,5568,'th','&#3627;&#3618;&#3640;&#3604;&#3627;&#3633;&#3623;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3656;&#3629;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(200439,5568,'hi','à¤¶à¥€à¤°à¥à¤· à¤²à¥‡à¤– à¤•à¥‡ à¤²à¤¿à¤ Preprints à¤•à¥‹ à¤¦à¤¬à¤¾à¤¨à¥‡',0),(200440,5568,'ms','Menyekat tajuk untuk penulisan',0),(200441,5568,'ar','Ù‚Ù…Ø¹ Ø±Ø£Ø³ Ø¨Ø±ÙŠØ¨Ø±ÙŠÙ†ØªØ³',0),(200442,5568,'fr','Supprimer en-tÃªte de prÃ©publications',0),(200443,5568,'jp','äº‹å‰?å?°åˆ·ã?®ãƒ˜ãƒƒãƒ€ãƒ¼ã‚’éš ã?™',0),(200444,5568,'pt','Suprimir CabeÃ§alho para PrÃ©-Impressos',0),(200445,5568,'ru','ÐŸÐ¾Ð´Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²Ð¾Ðº Ð´Ð»Ñ ÐŸÑ€ÐµÐ¿Ñ€Ð¸Ð½Ñ‚Ñ‹',0),(200446,5568,'es','Suprimir Encabezado para Preimpresiones',0),(200447,5568,'de','Header fÃ¼r Preprints unterdrÃ¼cken',0),(200448,5568,'en','Suppress Header for Preprints',0),(200449,5569,'is','',0),(200450,5569,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø´Ù…Ø§',0),(200451,5569,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø´Ù…Ø§',0),(200452,5569,'tr','Senin PO',0),(200453,5569,'pl','PO',0),(200454,5569,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²',0),(200455,5569,'ur','Ø¢Ù¾ Ú©ÛŒ Ù¾ÙˆØ³Ù¹',0),(200456,5569,'sr','Ð¢Ð²Ð¾Ñ˜ Ð½Ð°Ð´Ð·Ð¾Ñ€Ð½Ð¸Ðº',0),(200457,5569,'vi','ÄÆ¡n mua hÃ ng cá»§a báº¡n',0),(200458,5569,'af','U AB',0),(200459,5569,'ro','PO-ul dumneavoastra',0),(200460,5569,'et','Teie ostutellimus',0),(200461,5569,'si','VaÅ¡e PO',0),(200462,5569,'ba','PO Anda',0),(200463,5569,'nl','Uw PO',0),(200464,5569,'fi','Oman PO',0),(200465,5569,'no','Din PO',0),(200466,5569,'da','Din PO',0),(200467,5569,'ko','ë‹¹ì‹ ì˜ í¬',0),(200468,5569,'he','×”×ª×¢×•×“×ª ×–×”×•×ª ×©×œ×š',0),(200469,5569,'el','Î˜Îˆ',0),(200470,5569,'zh','æ‚¨çš„é‡‡è´­è®¢å•\r\n',0),(200471,5569,'sv','Din PO',0),(200472,5569,'it','Il PO',0),(200473,5569,'tl','',0),(200474,5569,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(200475,5569,'hi','à¤…à¤ªà¤¨à¥‡ à¤ªà¥‹',0),(200476,5569,'ms','PO anda',0),(200477,5569,'ar','Øµ. Ø¨ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(200478,5569,'fr','Votre bon de commande',0),(200479,5569,'jp','æ³¨æ–‡æ›¸',0),(200480,5569,'pt','Seu PO',0),(200481,5569,'ru','Ð’Ð°Ñˆ PO',0),(200482,5569,'es','Su OC',0),(200483,5569,'de','Ihr PO',0),(200484,5569,'en','Your PO',0),(200485,5570,'is','',0),(200486,5570,'dr','Ù‡ÙŠÚ†ÙƒØ¯Ø§Ù…',0),(200487,5570,'pr','Ù‡ÙŠÚ†ÙƒØ¯Ø§Ù…',0),(200488,5570,'tr','Herhangi bir',0),(200489,5570,'pl','Wszelkie',0),(200490,5570,'bg','Ð’ÑÐµÐºÐ¸',0),(200491,5570,'ur','Ú©Ø³ÛŒ Ø¨Ú¾ÛŒ',0),(200492,5570,'sr','Ð‘Ð¸Ð»Ð¾ ÐºÐ¾Ñ˜Ð¸',0),(200493,5570,'vi','Báº¥t ká»³',0),(200494,5570,'af','Enige',0),(200495,5570,'ro','Orice',0),(200496,5570,'et','Mistahes',0),(200497,5570,'si','Vse',0),(200498,5570,'ba','Setiap',0),(200499,5570,'nl','Elke',0),(200500,5570,'fi','Kaikki',0),(200501,5570,'no','Noen',0),(200502,5570,'da','Enhver',0),(200503,5570,'ko','ì–´ë–¤',0),(200504,5570,'he','×›×œ',0),(200505,5570,'el','ÎšÎ¬Î¸Îµ',0),(200506,5570,'zh','ä»»ä½•\r\n',0),(200507,5570,'sv','NÃ¥gon',0),(200508,5570,'it','Qualsiasi',0),(200509,5570,'tl','',0),(200510,5570,'th','&#3610;&#3634;&#3591;',0),(200511,5570,'hi','à¤•à¤¿à¤¸à¥€ à¤­à¥€',0),(200512,5570,'ms','Mana-mana',0),(200513,5570,'ar','Ø£ÙŠ',0),(200514,5570,'fr','N\'importe quel',0),(200515,5570,'jp','ã?©ã‚Œã?§ã‚‚',0),(200516,5570,'pt','Qualquer',0),(200517,5570,'ru','Ð›ÑŽÐ±Ð¾Ð¹',0),(200518,5570,'es','Alguno',0),(200519,5570,'de','Alle',0),(200520,5570,'en','Any',0),(200521,5571,'is','',0),(200522,5571,'dr',' Ø¯Ø±Ø¬  Ø®ÙˆØ¯ÙƒØ§Ø±',0),(200523,5571,'pr',' Ø¯Ø±Ø¬  Ø®ÙˆØ¯ÙƒØ§Ø±',0),(200524,5571,'tr','Eklenen otomatik',0),(200525,5571,'pl','Auto dodaje',0),(200526,5571,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ñ',0),(200527,5571,'ur','Ø®ÙˆØ¯ Ú©Ø§Ø± Ø¯Ø§Ø®Ù„ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(200528,5571,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ ÑƒÐ¼ÐµÑ‚Ð½ÑƒÑ‚Ð¾',0),(200529,5571,'vi','Tá»± Äá»™ng ChÃ¨n ThÃªm',0),(200530,5571,'af','Outomatiese ingevoeg',0),(200531,5571,'ro','Auto inserate',0),(200532,5571,'et','Auto lisatud',0),(200533,5571,'si','Samodejno vstavi',0),(200534,5571,'ba','Auto dimasukkan',0),(200535,5571,'nl','Auto ingevoegd',0),(200536,5571,'fi','Auto lisÃ¤tÃ¤',0),(200537,5571,'no','Automatisk satt inn',0),(200538,5571,'da','Automatisk indsat',0),(200539,5571,'ko','ìžë™ ì‚½ìž…',0),(200540,5571,'he','××•×˜×•×ž×˜×™ × ×•×¡×£',0),(200541,5571,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(200542,5571,'zh','è‡ªåŠ¨æ’å…¥\r\n',0),(200543,5571,'sv','Auto infÃ¶ras',0),(200544,5571,'it','Auto inserita',0),(200545,5571,'tl','',0),(200546,5571,'th','&#3649;&#3607;&#3619;&#3585;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;',0),(200547,5571,'hi','à¤‘à¤Ÿà¥‹ à¤¡à¤¾à¤²à¤¾',0),(200548,5571,'ms','Auto yang dimasukkan',0),(200549,5571,'ar','Ø¥Ø¯Ø±Ø§Ø¬ ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(200550,5571,'fr','Auto insÃ©rÃ©',0),(200551,5571,'jp','è‡ªå‹•çš„ã?«æŒ¿å…¥ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(200552,5571,'pt','Auto inserido',0),(200553,5571,'ru','Ð’ÑÑ‚Ð°Ð²ÐºÐ¸ Ð°Ð²Ñ‚Ð¾',0),(200554,5571,'es','Auto Insertado',0),(200555,5571,'de','Automatisch eingefÃ¼gt',0),(200556,5571,'en','Auto Inserted',0),(200557,5572,'is','',0),(200558,5572,'dr','Ø¯Ø±Ø¬ ÙƒØ±Ø¯Ù† Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(200559,5572,'pr','Ø¯Ø±Ø¬ ÙƒØ±Ø¯Ù† Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(200560,5572,'tr','Ekleme baÅŸarÄ±lÄ±',0),(200561,5572,'pl','Wstaw sukces',0),(200562,5572,'bg','Ð’Ð¼ÑŠÐºÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(200563,5572,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(200564,5572,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ ÑƒÑÐ¿ÐµÑˆÐ°Ð½',0),(200565,5572,'vi','ChÃ¨n thÃ nh cÃ´ng',0),(200566,5572,'af','Invoer suksesvol',0),(200567,5572,'ro','Inserare de succes',0),(200568,5572,'et','Sisesta edukas',0),(200569,5572,'si','Vstavljanje uspeÅ¡no',0),(200570,5572,'ba','Sisipkan sukses',0),(200571,5572,'nl','Succesvolle invoegen',0),(200572,5572,'fi','LisÃ¤Ã¤ onnistunut',0),(200573,5572,'no','Sett inn vellykket',0),(200574,5572,'da','IndsÃ¦t vellykket',0),(200575,5572,'ko','ì‚½ìž… ì„±ê³µ',0),(200576,5572,'he','×”×•×¡×¤×” ×ž×•×¦×œ×—',0),(200577,5572,'el','Î•Ï€Î¹Ï„Ï…Ï‡Î®Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(200578,5572,'zh','æ’å…¥æˆåŠŸ\r\n',0),(200579,5572,'sv','Infoga framgÃ¥ngsrika',0),(200580,5572,'it','Inserto di successo',0),(200581,5572,'tl','',0),(200582,5572,'th','&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(200583,5572,'hi','à¤¸à¤«à¤² à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(200584,5572,'ms','Masukkan berjaya',0),(200585,5572,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ù„Ù†Ø§Ø¬Ø­Ø©',0),(200586,5572,'fr','Insertion rÃ©ussie',0),(200587,5572,'jp','æŒ¿å…¥ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(200588,5572,'pt','InserÃ§Ã£o bem sucedida',0),(200589,5572,'ru','Ð’ÑÑ‚Ð°Ð²ÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(200590,5572,'es','Insertar exitoso',0),(200591,5572,'de','Erfolgreiche einfÃ¼gen',0),(200592,5572,'en','Insert successful',0),(200593,5573,'is','',0),(200594,5573,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø«Ø¨Øª Ø¯Ø§Ø±Ù†Ø¯',0),(200595,5573,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø«Ø¨Øª Ø¯Ø§Ø±Ù†Ø¯',0),(200596,5573,'tr','Yeniden sipariÅŸ ihtiyaÃ§ duyan maddeler',0),(200597,5573,'pl','Elementy wymagajÄ…ce ponownego',0),(200598,5573,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ ÑÐµ Ð½Ð°Ð»Ð°Ð³Ð° Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(200599,5573,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©Ùˆ Ù¾Ú¾Ø± ØªØ±ØªÛŒØ¨ Ø¯ÛŒÙ†Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(200600,5573,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ ÐºÐ¾Ñ˜Ðµ Ñ‚Ñ€ÐµÐ±Ð° Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(200601,5573,'vi','Máº·t hÃ ng cáº§n pháº£i Ä‘áº·t hÃ ng láº¡i',0),(200602,5573,'af','Items moet Herbestel word',0),(200603,5573,'ro','Articole care au nevoie de reluare a comenzii',0),(200604,5573,'et','Vajavad Ãœmberkorr.',0),(200605,5573,'si','Predmete, ki potrebujejo naroÄanja',0),(200606,5573,'ba','Item membutuhkan menyusun ulang',0),(200607,5573,'nl','Items nodig opnieuw ordenen',0),(200608,5573,'fi','Tuotteet tarvitsevat JÃ¤rjestÃ¤',0),(200609,5573,'no','Elementer som trenger ordne',0),(200610,5573,'da','Elementer krÃ¦ver Ordn igen',0),(200611,5573,'ko','í•­ëª© ìˆœì„œ ë³€ê²½ í•„ìš”',0),(200612,5573,'he','×¤×¨×™×˜×™× ×”×–×§×•×§×™× ×—×™×“×•×©',0),(200613,5573,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Ï‡ÏÎµÎ¹Î¬Î¶Î¿Î½Ï„Î±Î¹ Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(200614,5573,'zh','é¡¹ç›®éœ€è¦é‡æ–°æŽ’åº\r\n',0),(200615,5573,'sv','Som behÃ¶ver Ã¤ndra ordning',0),(200616,5573,'it','Elementi che necessitano di riordino',0),(200617,5573,'tl','',0),(200618,5573,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(200619,5573,'hi','à¤œà¤¼à¤°à¥‚à¤°à¤¤ à¤•à¥‡ à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤†à¤‡à¤Ÿà¤®',0),(200620,5573,'ms','Item-item yang memerlukan susun semula',0),(200621,5573,'ar','Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„ØªÙŠ ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ Ø¥Ø¹Ø§Ø¯Ø© ØªØ±ØªÙŠØ¨',0),(200622,5573,'fr','Ã‰lÃ©ments qui ont besoin de rÃ©organiser',0),(200623,5573,'jp','å†?æ³¨æ–‡å¿…è¦?å“?ç›®',0),(200624,5573,'pt','Itens que necessitam reposiÃ§Ã£o',0),(200625,5573,'ru','Ð¢Ð¾Ð²Ð°Ñ€Ñ‹ ÐÑƒÐ¶Ð´Ð°ÑŽÑ‰Ð¸ÐµÑÑ Ð’ ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾Ð¼ Ð—Ð°ÐºÐ°Ð·Ðµ',0),(200626,5573,'es','Items que Necesitan un Reorden',0),(200627,5573,'de','Elemente benÃ¶tigen neu anordnen',0),(200628,5573,'en','Items Needing Reorder',0),(200629,5574,'is','',0),(200630,5574,'dr','Ø¨Ø§ÙŠØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡  Ø®Ø§ØµÙŠ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(200631,5574,'pr','Ø¨Ø§ÙŠØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡  Ø®Ø§ØµÙŠ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(200632,5574,'tr','Ã–zel satÄ±cÄ± seÃ§meniz gerekir',0),(200633,5574,'pl','NaleÅ¼y wybraÄ‡ okreÅ›lonego dostawcy',0),(200634,5574,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚ÐµÐ½ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(200635,5574,'ur','Ù…Ø®ØµÙˆØµ ÙˆÛŒÙ†ÚˆØ± Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(200636,5574,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(200637,5574,'vi','Pháº£i chá»n ngÆ°á»i bÃ¡n cá»¥ thá»ƒ',0),(200638,5574,'af','Moet \'n Spesifieke Verskaffer selekteer',0),(200639,5574,'ro','Trebuie sÄƒ selectaÅ£i specifice furnizor',0),(200640,5574,'et','Peate valima konkreetse hankija',0),(200641,5574,'si','Izbrati morate doloÄenega dobavitelja',0),(200642,5574,'ba','Harus memilih Vendor tertentu',0),(200643,5574,'nl','Specifieke leverancier moet selecteren',0),(200644,5574,'fi','Valitse tietyn toimittajan',0),(200645,5574,'no','MÃ¥ velge bestemt leverandÃ¸r',0),(200646,5574,'da','Skal vÃ¦lge specifik leverandÃ¸r',0),(200647,5574,'ko','íŠ¹ì • ê³µê¸‰ ì—…ì²´ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(200648,5574,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×¡×¤×§ ×¡×¤×¦×™×¤×™',0),(200649,5574,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(200650,5574,'zh','å¿…é¡»é€‰æ‹©ç‰¹å®šçš„ä¾›åº”å•†\r\n',0),(200651,5574,'sv','MÃ¥ste vÃ¤lja specifik leverantÃ¶r',0),(200652,5574,'it','Necessario selezionare fornitore specifico',0),(200653,5574,'tl','',0),(200654,5574,'th','&#3605;&#3657;&#3629;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3649;&#3610;&#3610;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3592;&#3634;&#3632;&#3592;&#3591;',0),(200655,5574,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(200656,5574,'ms','Mesti memilih pembekal tertentu',0),(200657,5574,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø¥Ø®ØªÙŠØ§Ø± Ù…ÙˆØ±Ù‘Ø¯ Ù…Ø­Ø¯Ù‘Ø¯',0),(200658,5574,'fr','Devez sÃ©lectionner fournisseur spÃ©cifique',0),(200659,5574,'jp','ç‰¹å®šæ¥­è€…ã‚’é?¸æŠžã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(200660,5574,'pt','Deve selecionar fornecedor especÃ­fico',0),(200661,5574,'ru','ÐÐ°Ð´Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ð¾Ð³Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(200662,5574,'es','Debe seleccionar un Proveedor EspecÃ­fico',0),(200663,5574,'de','Bestimmten Kreditor muss ausgewÃ¤hlt werden.',0),(200664,5574,'en','Must select Specific Vendor',0),(200665,5575,'is','',0),(200666,5575,'dr','ÙƒØ¯ ÙƒØ§Ù„Ø§ÙŠ Ù…Ø§',0),(200667,5575,'pr','ÙƒØ¯ ÙƒØ§Ù„Ø§ÙŠ Ù…Ø§',0),(200668,5575,'tr','Bizim madde kodu',0),(200669,5575,'pl','Nasz kod towaru',0),(200670,5575,'bg','ÐÐ°ÑˆÐ¸ÑÑ‚ ÐºÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(200671,5575,'ur','ÛÙ…Ø§Ø±ÛŒ Ø´Û’ Ú©Ø§ Ú©ÙˆÚˆ',0),(200672,5575,'sr','ÐÐ°Ð¼ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(200673,5575,'vi','MÃ£ hÃ ng cá»§a chÃºng tÃ´i',0),(200674,5575,'af','Ons Item Kode',0),(200675,5575,'ro','Codul nostru de element',0),(200676,5575,'et','Meie kauba kood',0),(200677,5575,'si','NaÅ¡a Å ifra artikla',0),(200678,5575,'ba','Kode Item kami',0),(200679,5575,'nl','Onze Artikelcode',0),(200680,5575,'fi','Nimikkeen koodi',0),(200681,5575,'no','VÃ¥re Varekode',0),(200682,5575,'da','Vores varekode',0),(200683,5575,'ko','í•­ëª© ì½”ë“œ',0),(200684,5575,'he','×§×•×“ ×¤×¨×™×˜ ×©×œ× ×•',0),(200685,5575,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î¼Î±Ï‚',0),(200686,5575,'zh','æˆ‘ä»¬çš„é¡¹ç›®ä»£ç \r\n',0),(200687,5575,'sv','VÃ¥ra Artikelkod',0),(200688,5575,'it','Il nostro codice articolo',0),(200689,5575,'tl','',0),(200690,5575,'th','&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3614;&#3623;&#3585;&#3648;&#3619;&#3634;',0),(200691,5575,'hi','à¤¹à¤®à¤¾à¤°à¥‡ à¤®à¤¦ à¤•à¥‹à¤¡',0),(200692,5575,'ms','Kami Kod Item',0),(200693,5575,'ar','Ù„Ø¯ÙŠÙ†Ø§ ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù',0),(200694,5575,'fr','Notre Code de l\'article',0),(200695,5575,'jp','å“?ç›®ã‚³ãƒ¼ãƒ‰',0),(200696,5575,'pt','Nosso cÃ³digo de Item',0),(200697,5575,'ru','ÐšÐ¾Ð´ ÐÐ°ÑˆÐµÐ³Ð¾ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(200698,5575,'es','Nuestro CÃ³digo de Item',0),(200699,5575,'de','Unsere Artikelcode',0),(200700,5575,'en','Our Item Code',0),(200701,5576,'is','',0),(200702,5576,'dr','Ù‚Ø§Ù„Ø¨ Ú¯Ø²Ø§Ø±Ø´ ',0),(200703,5576,'pr','Ù‚Ø§Ù„Ø¨ Ú¯Ø²Ø§Ø±Ø´ ',0),(200704,5576,'tr','Rapor formatÄ±',0),(200705,5576,'pl','Format raportu',0),(200706,5576,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(200707,5576,'ur','Ø±Ù¾ÙˆØ±Ù¹ ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(200708,5576,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(200709,5576,'vi','Dáº¡ng BÃ¡o cÃ¡o ',0),(200710,5576,'af','Verslagformaat',0),(200711,5576,'ro','Raport Format',0),(200712,5576,'et','Aruande vorm',0),(200713,5576,'si','Oblika poroÄila',0),(200714,5576,'ba','Format laporan',0),(200715,5576,'nl','Rapportindeling',0),(200716,5576,'fi','Raporttimuoto',0),(200717,5576,'no','Rapportformatet',0),(200718,5576,'da','Rapportformat',0),(200719,5576,'ko','ë³´ê³ ì„œ í˜•ì‹',0),(200720,5576,'he','×‘×ª×‘× ×™×ª ×“×•×—',0),(200721,5576,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î¼Î¿ÏÏ†Î®',0),(200722,5576,'zh','æŠ¥å‘Šæ ¼å¼\r\n',0),(200723,5576,'sv','Rapportformatet',0),(200724,5576,'it','Rapporto di formato',0),(200725,5576,'tl','',0),(200726,5576,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(200727,5576,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª',0),(200728,5576,'ms','Format laporan',0),(200729,5576,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(200730,5576,'fr','Format du rapport',0),(200731,5576,'jp','ãƒ¬ãƒ?ãƒ¼ãƒˆãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(200732,5576,'pt','Formato de relatÃ³rio',0),(200733,5576,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐžÑ‚Ñ‡ÐµÑ‚Ð°',0),(200734,5576,'es','Formato de Informe',0),(200735,5576,'de','Berichtsformat',0),(200736,5576,'en','Report Format',0),(200737,5577,'is','',0),(200738,5577,'dr','Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÙŠØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(200739,5577,'pr','Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÙŠØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(200740,5577,'tr','SatÄ±cÄ± satÄ±nalma Ã¶neri',0),(200741,5577,'pl','Propozycja zakupu sprzedawca',0),(200742,5577,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(200743,5577,'ur','ÙˆÛŒÙ†ÚˆØ± Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ ØªØ¬ÙˆÛŒØ²',0),(200744,5577,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð³ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(200745,5577,'vi','Gá»£i Ã½ mua cá»§a ngÆ°á»i bÃ¡n',0),(200746,5577,'af','Handelaar aankoop suggestie',0),(200747,5577,'ro','Sugestie de cumpÄƒrare furnizor',0),(200748,5577,'et','Hankija ostu soovitus',0),(200749,5577,'si','Prodajalec nakup predlog',0),(200750,5577,'ba','Penjual pembelian saran',0),(200751,5577,'nl','Leverancier aankoop suggestie',0),(200752,5577,'fi','Toimittajan ostojen ehdotus',0),(200753,5577,'no','LeverandÃ¸ren KjÃ¸p forslag',0),(200754,5577,'da','Kreditor KÃ¸b forslag',0),(200755,5577,'ko','ê³µê¸‰ ì—…ì²´ êµ¬ë§¤ ì œì•ˆ',0),(200756,5577,'he','×”×ž×œ×¦×ª ×§× ×™×™×” ×©×œ ×¡×¤×§',0),(200757,5577,'el','Î ÏÏŒÏ„Î±ÏƒÎ· Î±Î³Î¿ÏÎ¬Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(200758,5577,'zh','ä¾›åº”å•†è´­ä¹°å»ºè®®\r\n',0),(200759,5577,'sv','LeverantÃ¶r inkÃ¶psfÃ¶rslag',0),(200760,5577,'it','Proposta di acquisto del fornitore',0),(200761,5577,'tl','',0),(200762,5577,'th','&#3585;&#3634;&#3619;&#3648;&#3626;&#3609;&#3629;&#3649;&#3609;&#3632;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(200763,5577,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤–à¤°à¥€à¤¦ à¤¸à¥à¤à¤¾à¤µ',0),(200764,5577,'ms','Cadangan pembelian Penjual',0),(200765,5577,'ar','Ø§Ù‚ØªØ±Ø§Ø­ Ø´Ø±Ø§Ø¡ Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(200766,5577,'fr','Suggestion dâ€™achat fournisseur',0),(200767,5577,'jp','æ¥­è€…è³¼å…¥æ??æ¡ˆ',0),(200768,5577,'pt','SugestÃ£o de compra de fornecedor',0),(200769,5577,'ru','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(200770,5577,'es','Proveedor Sugerencias de Compras',0),(200771,5577,'de','Kreditor Einkauf Vorschlag',0),(200772,5577,'en','Vendor Purchase Suggestion',0),(200773,5578,'is','',0),(200774,5578,'dr','( ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(200775,5578,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ù† ( ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(200776,5578,'tr','Ekleme sÄ±rasÄ±nda hata oluÅŸtu',0),(200777,5578,'pl','BÅ‚Ä…d podczas wstawiania',0),(200778,5578,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ',0),(200779,5578,'ur','Ø¯Ø§Ø®Ù„ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ',0),(200780,5578,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ ÑƒÐ¼ÐµÑ‚Ð°ÑšÐ°',0),(200781,5578,'vi','Lá»—i khi chÃ¨n',0),(200782,5578,'af','Fout tydens insetsel',0),(200783,5578,'ro','Eroare Ã®n timpul Inserare',0),(200784,5578,'et','Viga insert',0),(200785,5578,'si','Napaka med Vstavljanje',0),(200786,5578,'ba','Error selama insert',0),(200787,5578,'nl','Fout tijdens invoegen',0),(200788,5578,'fi','Virhe insert',0),(200789,5578,'no','Feil under Sett inn',0),(200790,5578,'da','Fejl under IndsÃ¦t',0),(200791,5578,'ko','ì‚½ìž… ì¤‘ ì˜¤ë¥˜ ë°œìƒ',0),(200792,5578,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×”',0),(200793,5578,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(200794,5578,'zh','æ’å…¥è¿‡ç¨‹ä¸­å‡ºçŽ°é”™è¯¯',0),(200795,5578,'sv','Fel under Infoga',0),(200796,5578,'it','Errore durante l\'inserimento',0),(200797,5578,'tl','',0),(200798,5578,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;',0),(200799,5578,'hi','à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(200800,5578,'ms','Kesilapan semasa memasukkan',0),(200801,5578,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¯Ø±Ø§Ø¬',0),(200802,5578,'fr','Erreur lors de l\'insertion',0),(200803,5578,'jp','æŒ¿å…¥æ™‚ã?®ã‚¨ãƒ©ãƒ¼',0),(200804,5578,'pt','Erro durante a inserÃ§Ã£o',0),(200805,5578,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð²Ð¾Ð´Ðµ',0),(200806,5578,'es','Error durante inserciÃ³n',0),(200807,5578,'de','Fehler beim EinfÃ¼gen',0),(200808,5578,'en','Error during insert',0),(200809,5579,'is','',0),(200810,5579,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ÙŠ',0),(200811,5579,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ÙŠ',0),(200812,5579,'tr','SatÄ±ÅŸ birimleri cinsinden',0),(200813,5579,'pl','w sprzedaÅ¼y jednostek',0),(200814,5579,'bg','Ð² Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(200815,5579,'ur','ÙØ±ÙˆØ®Øª Ú©Û’ ÛŒÙˆÙ†Ù¹Ø³ Ù…ÛŒÚº',0),(200816,5579,'sr','Ñƒ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°Ð¼Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(200817,5579,'vi','Ä‘Æ¡n vá»‹ bÃ¡n',0),(200818,5579,'af','in verkoopte eenhede',0),(200819,5579,'ro','Ã®n unitÄƒÅ£ile de vÃ¢nzare',0),(200820,5579,'et','mÃ¼Ã¼k Ã¼hikutes',0),(200821,5579,'si','v prodajo enot',0),(200822,5579,'ba','dalam menjual unit',0),(200823,5579,'nl','in verkopen eenheden',0),(200824,5579,'fi','myy yksikÃ¶issÃ¤',0),(200825,5579,'no','i selge enheter',0),(200826,5579,'da','i SÃ¦lg enheder',0),(200827,5579,'ko','íŒë§¤ ë‹¨ìœ„',0),(200828,5579,'he','×œ×ž×›×•×¨ ×™×—×™×“×•×ª',0),(200829,5579,'el','ÏƒÏ„Î·Î½ Ï€ÏŽÎ»Î·ÏƒÎ· Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(200830,5579,'zh','åœ¨å‡ºå”®å•ä½\r\n',0),(200831,5579,'sv','i sÃ¤lja enheter',0),(200832,5579,'it','nelle unitÃ  di vendita',0),(200833,5579,'tl','',0),(200834,5579,'th','&#3651;&#3609;&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3634;&#3618;',0),(200835,5579,'hi','à¤¬à¥‡à¤š à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚',0),(200836,5579,'ms','dalam unit-unit jual',0),(200837,5579,'ar','ÙÙŠ Ø¨ÙŠØ¹ ÙˆØ­Ø¯Ø§Øª',0),(200838,5579,'fr','immeubles Ã  vendre',0),(200839,5579,'jp','è²©å£²å?˜ä½?',0),(200840,5579,'pt','em unidades de venda',0),(200841,5579,'ru','Ð² Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ñƒ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°Ñ…',0),(200842,5579,'es','en unidades de ventas',0),(200843,5579,'de','im Verkauf',0),(200844,5579,'en','in sell units',0),(200845,5580,'is','',0),(200846,5580,'dr','Ø¨Ø¯Ù‡ÙŠ Ø·Ø¨Ù‚',0),(200847,5580,'pr','Ø¨Ø¯Ù‡ÙŠ Ø·Ø¨Ù‚',0),(200848,5580,'tr','SÃ¼re sonu',0),(200849,5580,'pl','Spowodowane przez',0),(200850,5580,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð¼Ð¸ Ð¾Ñ‚',0),(200851,5580,'ur','ÙˆØ§Ø¬Ø¨ ØªØ§Ø±ÛŒØ®',0),(200852,5580,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(200853,5580,'vi','Äáº¿n háº¡n bá»Ÿi',0),(200854,5580,'af','Verskuldig Deur',0),(200855,5580,'ro','Datorate de',0),(200856,5580,'et','TÃ¤htaeg',0),(200857,5580,'si','Ki jih morajo',0),(200858,5580,'ba','Karena pada',0),(200859,5580,'nl','Einddatum',0),(200860,5580,'fi','MÃ¤Ã¤rÃ¤pÃ¤ivÃ¤',0),(200861,5580,'no','Forfaller',0),(200862,5580,'da','Forfalder senest',0),(200863,5580,'ko','ê¸°í•œ',0),(200864,5580,'he','×ª××¨×™×š ×™×¢×“',0),(200865,5580,'el','ÎŸÏ†ÎµÎ¯Î»Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ',0),(200866,5580,'zh','å› å—\r\n',0),(200867,5580,'sv','PÃ¥ grund av',0),(200868,5580,'it','Dovuti dalle',0),(200869,5580,'tl','',0),(200870,5580,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3650;&#3604;&#3618;',0),(200871,5580,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¨à¤¿à¤¯à¤¤',0),(200872,5580,'ms','Kena dibayar oleh',0),(200873,5580,'ar','ØªØ§Ø±ÙŠØ® Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(200874,5580,'fr','Due par',0),(200875,5580,'jp','ï½žã?¾ã?§ã?«',0),(200876,5580,'pt','Devidas pelos',0),(200877,5580,'ru','Ð¡Ñ€Ð¾Ðº',0),(200878,5580,'es','Debido Por',0),(200879,5580,'de','FÃ¤llig am',0),(200880,5580,'en','Due By',0),(200881,5581,'is','',0),(200882,5581,'dr','( Ø§Ø±Ø³Ø§Ù„ )  Ø§Ø² Ø·Ø±ÙŠÙ‚ ',0),(200883,5581,'pr','Ø­Ù…Ù„( Ø§Ø±Ø³Ø§Ù„ )  Ø§Ø² Ø·Ø±ÙŠÙ‚ ',0),(200884,5581,'tr','Via gemi',0),(200885,5581,'pl','Statek za poÅ›rednictwem',0),(200886,5581,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ·',0),(200887,5581,'ur','Ø¬ÛØ§Ø² Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(200888,5581,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚Ð¸ Ð¿ÑƒÑ‚ÐµÐ¼',0),(200889,5581,'vi','Chuyá»ƒn Ä‘áº¿n qua',0),(200890,5581,'af','Versend Via',0),(200891,5581,'ro','NavÄƒ prin intermediul',0),(200892,5581,'et','Laeva kaudu',0),(200893,5581,'si','Ladja preko',0),(200894,5581,'ba','Kapal melalui',0),(200895,5581,'nl','Verzenden Via',0),(200896,5581,'fi','LÃ¤hettÃ¤Ã¤ kautta',0),(200897,5581,'no','Sendes med',0),(200898,5581,'da','Skibet Via',0),(200899,5581,'ko','í†µí•´ ë°œì†¡',0),(200900,5581,'he','×ž×©×œ×•×— ×“×¨×š',0),(200901,5581,'el','Î Î»Î¿Î¯Î¿ Î¼Î­ÏƒÏ‰',0),(200902,5581,'zh','èˆªè¿é€šè¿‡\r\n',0),(200903,5581,'sv','Skicka Via',0),(200904,5581,'it','Nave Via',0),(200905,5581,'tl','',0),(200906,5581,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3650;&#3604;&#3618;&#3607;&#3634;&#3591;',0),(200907,5581,'hi','à¤‡à¤¸à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤µà¤¿à¤¤à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(200908,5581,'ms','Kapal melalui',0),(200909,5581,'ar','Ø§Ù„Ø´Ø­Ù† Ø¹Ù† Ø·Ø±ÙŠÙ‚',0),(200910,5581,'fr','Livrons Via',0),(200911,5581,'jp','ï½žçµŒç”±ç™ºé€?',0),(200912,5581,'pt','Enviamos Via',0),(200913,5581,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÑÐµÐ¼ Ñ‡ÐµÑ€ÐµÐ·',0),(200914,5581,'es','Enviar Via',0),(200915,5581,'de','Versenden mit',0),(200916,5581,'en','Ship Via',0),(200917,5582,'is','',0),(200918,5582,'dr','Ø¨Ø±Ø§ÙŠ Ù†Ø§Ù… ',0),(200919,5582,'pr','Ø¨Ø±Ø§ÙŠ Ù†Ø§Ù… ',0),(200920,5582,'tr','Hedef',0),(200921,5582,'pl','Do',0),(200922,5582,'bg','Ð”Ð°',0),(200923,5582,'ur','Ú©Ø±Ù†Ø§',0),(200924,5582,'sr','Ð”Ð°',0),(200925,5582,'vi','Tá»›i',0),(200926,5582,'af','Aan',0),(200927,5582,'ro','Pentru a',0),(200928,5582,'et','Et',0),(200929,5582,'si','Za',0),(200930,5582,'ba','Untuk',0),(200931,5582,'nl','Aan',0),(200932,5582,'fi','Jotta',0),(200933,5582,'no','Til',0),(200934,5582,'da','Til',0),(200935,5582,'ko','ë°›ëŠ” ì‚¬ëžŒ',0),(200936,5582,'he','×›×“×™',0),(200937,5582,'el','ÎÎ±',0),(200938,5582,'zh','è¦\r\n',0),(200939,5582,'sv','Till',0),(200940,5582,'it','A',0),(200941,5582,'tl','',0),(200942,5582,'th','&#3606;&#3638;&#3591;',0),(200943,5582,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(200944,5582,'ms','Untuk',0),(200945,5582,'ar','Ø¥Ù„Ù‰',0),(200946,5582,'fr','Ã€',0),(200947,5582,'jp','ï½žã?«',0),(200948,5582,'pt','Para',0),(200949,5582,'ru','ÐšÐ¾Ð¼Ñƒ',0),(200950,5582,'es','Para',0),(200951,5582,'de','An',0),(200952,5582,'en','To',0),(200953,5583,'is','',0),(200954,5583,'dr','Ù…Ø´ØªØ±ÙŠ',0),(200955,5583,'pr','Ù…Ø´ØªØ±ÙŠ',0),(200956,5583,'tr','Ä°stemci',0),(200957,5583,'pl','Klient',0),(200958,5583,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚',0),(200959,5583,'ur','ÙˆØµÙˆÙ„ Ú©Ø§Ø±',0),(200960,5583,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚',0),(200961,5583,'vi','KhÃ¡ch hÃ ng',0),(200962,5583,'af','Klient',0),(200963,5583,'ro','Client',0),(200964,5583,'et','Kliendi',0),(200965,5583,'si','Odjemalec',0),(200966,5583,'ba','Klien',0),(200967,5583,'nl','Client',0),(200968,5583,'fi','Asiakas',0),(200969,5583,'no','Klienten',0),(200970,5583,'da','Klient',0),(200971,5583,'ko','í´ë¼ì´ì–¸íŠ¸',0),(200972,5583,'he','×œ×§×•×—',0),(200973,5583,'el','Î ÎµÎ»Î¬Ï„Î·',0),(200974,5583,'zh','å®¢æˆ·ç«¯\r\n',0),(200975,5583,'sv','Klienten',0),(200976,5583,'it','Cliente',0),(200977,5583,'tl','',0),(200978,5583,'th','&#3612;&#3641;&#3657;&#3592;&#3657;&#3634;&#3591;',0),(200979,5583,'hi','à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ',0),(200980,5583,'ms','Pelanggan',0),(200981,5583,'ar','Ø¹Ù…ÙŠÙ„',0),(200982,5583,'fr','Client',0),(200983,5583,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆ',0),(200984,5583,'pt','Cliente',0),(200985,5583,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚',0),(200986,5583,'es','Cliente',0),(200987,5583,'de','Client',0),(200988,5583,'en','Client',0),(200989,5584,'is','',0),(200990,5584,'dr','Pkgs  Ù‡Ø±  ÙƒÙŠÙ„Ùˆ Ú¯Ø±Ù… ',0),(200991,5584,'pr','Pkgs  Ù‡Ø±  ÙƒÙŠÙ„Ùˆ Ú¯Ø±Ù… ',0),(200992,5584,'tr','Pkgs',0),(200993,5584,'pl','Pkgs',0),(200994,5584,'bg','Pkgs',0),(200995,5584,'ur','Ù¾Ú©Ú¯Ø³',0),(200996,5584,'sr','ÐŸÐºÐ³Ñ',0),(200997,5584,'vi','Bao gÃ³i',0),(200998,5584,'af','Pkgs',0),(200999,5584,'ro','PKGS',0),(201000,5584,'et','Pkgs',0),(201001,5584,'si','Pkgs',0),(201002,5584,'ba','Pkgs',0),(201003,5584,'nl','Pkgs',0),(201004,5584,'fi','Pakettien',0),(201005,5584,'no','PKGS',0),(201006,5584,'da','PKGS',0),(201007,5584,'ko','Pkgs',0),(201008,5584,'he','Pkgs',0),(201009,5584,'el','Pkgs',0),(201010,5584,'zh','åŒ…\r\n',0),(201011,5584,'sv','Pkgs',0),(201012,5584,'it','Pkgs',0),(201013,5584,'tl','',0),(201014,5584,'th','Pkgs',0),(201015,5584,'hi','Pkgs',0),(201016,5584,'ms','Pkgs',0),(201017,5584,'ar','Ø¨ÙƒØ¬Ø³',0),(201018,5584,'fr','Pkgs',0),(201019,5584,'jp','ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸',0),(201020,5584,'pt','Pkgs',0),(201021,5584,'ru','Pkgs',0),(201022,5584,'es','Paqs',0),(201023,5584,'de','Pkgs',0),(201024,5584,'en','Pkgs',0),(201025,5585,'is','',0),(201026,5585,'dr','(Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡) Ø¯Ø± Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ ',0),(201027,5585,'pr','Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´Ø¯Ù‡ (Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡) Ø¯Ø± Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ ',0),(201028,5585,'tr','Depozito Check-in dahil',0),(201029,5585,'pl','Zawarte w zastaw sprawdzanie',0),(201030,5585,'bg','Ð’ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ‡ÐµÐº',0),(201031,5585,'ur','Ø¬Ù…Ø¹ Ú†ÛŒÚ© Ù…ÛŒÚº Ø´Ø§Ù…Ù„',0),(201032,5585,'sr','Ð£ÐºÑ™ÑƒÑ‡ÐµÐ½ Ñƒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(201033,5585,'vi','Bao gá»“m trong SÃ©c Ä‘áº·t cá»c',0),(201034,5585,'af','Ingesluit in Deposito Tjek',0),(201035,5585,'ro','Incluse Ã®n depozit a verifica',0),(201036,5585,'et','Kaasatud hoiuste sisse',0),(201037,5585,'si','VkljuÄeni v vloga Äek',0),(201038,5585,'ba','Termasuk di Deposit cek',0),(201039,5585,'nl','Opgenomen in storting Check',0),(201040,5585,'fi','SisÃ¤ltyvÃ¤t Internet LAN',0),(201041,5585,'no','Inkludert i innskudd sjekk',0),(201042,5585,'da','Inkluderet i depositum Check',0),(201043,5585,'ko','ì˜ˆê¸ˆì— í¬í•¨',0),(201044,5585,'he','×›×œ×•×œ ×”×¤×™×§×“×•×Ÿ',0),(201045,5585,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î·Î½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Ï‡Ï‰',0),(201046,5585,'zh','åŒ…æ‹¬åœ¨å­˜æ¬¾æ”¯ç¥¨\r\n',0),(201047,5585,'sv','IngÃ¥r i insÃ¤ttning kontroll',0),(201048,5585,'it','Incluso nel controllo del deposito',0),(201049,5585,'tl','',0),(201050,5585,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3613;&#3634;&#3585;&#3648;&#3594;&#3655;&#3588;',0),(201051,5585,'hi','à¤œà¤®à¤¾ à¤•à¥€ à¤œà¤¾à¤‚à¤š à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤²',0),(201052,5585,'ms','Termasuk dalam Deposit cek',0),(201053,5585,'ar','ÙˆØ´Ù…Ù„Øª ÙÙŠ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(201054,5585,'fr','Inclus dans le chÃ¨que de dÃ©pÃ´t',0),(201055,5585,'jp','é ?ã‚Šé‡‘å°?åˆ‡æ‰‹ã?«å?«ã‚?ã‚‹',0),(201056,5585,'pt','IncluÃ­do na conta de depÃ³sito',0),(201057,5585,'ru','Ð’ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ Ñ‡ÐµÐº',0),(201058,5585,'es','Incluido en Cheque de DepÃ³sito',0),(201059,5585,'de','ErfaÃŸte Deposit-Check',0),(201060,5585,'en','Included in Deposit Check',0),(201061,5586,'is','',0),(201062,5586,'dr','Ø¯Ø± Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†ÙƒÙŠ  Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù†ÙŠØ§Ù…Ø¯Ù‡ Ø§Ø³Øª',0),(201063,5586,'pr','Ø¯Ø± Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†ÙƒÙŠ  Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù†ÙŠØ§Ù…Ø¯Ù‡ Ø§Ø³Øª',0),(201064,5586,'tr','Depozito Check-in dahil deÄŸildir',0),(201065,5586,'pl','NIE zawarte w zastaw sprawdzanie',0),(201066,5586,'bg','ÐÐ• ÑÐ° Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ‡ÐµÐº',0),(201067,5586,'ur','Ø¬Ù…Ø¹ Ú†ÛŒÚ© Ù…ÛŒÚº Ø´Ø§Ù…Ù„ Ù†ÛÛŒÚº',0),(201068,5586,'sr','ÐÐ˜ÐˆÐ• ÑƒÐºÑ™ÑƒÑ‡ÐµÐ½ Ñƒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(201069,5586,'vi','KhÃ´ng bao gá»“m trong sÃ©c',0),(201070,5586,'af','NIE Ingesluit in Deposito Tjek',0),(201071,5586,'ro','NU sunt incluse Ã®n depozit a verifica',0),(201072,5586,'et','EI kuulu tagatisraha sisse',0),(201073,5586,'si','NISO vkljuÄeni v vloga Äek',0),(201074,5586,'ba','TIDAK termasuk di Deposit cek',0),(201075,5586,'nl','NIET opgenomen in storting Check',0),(201076,5586,'fi','SisÃ¤lly Internet LAN',0),(201077,5586,'no','IKKE inkludert i innskudd sjekk',0),(201078,5586,'da','IKKE inkluderet i depositum Check',0),(201079,5586,'ko','ì˜ˆê¸ˆì— í¬í•¨ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(201080,5586,'he','×œ× × ×›×œ×œ ×”×¤×™×§×“×•×Ÿ',0),(201081,5586,'el','Î”Î•Î Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î·Î½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Ï‡Ï‰',0),(201082,5586,'zh','ä¸åŒ…æ‹¬åœ¨æŒ‰é‡‘æ”¯ç¥¨\r\n',0),(201083,5586,'sv','INTE ingÃ¥r i insÃ¤ttning kontroll',0),(201084,5586,'it','NON incluso nel controllo del deposito',0),(201085,5586,'tl','',0),(201086,5586,'th','&#3652;&#3617;&#3656;&#3619;&#3623;&#3617;&#3651;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3594;&#3655;&#3588;',0),(201087,5586,'hi','à¤œà¤®à¤¾ à¤•à¥€ à¤œà¤¾à¤‚à¤š à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¨à¤¹à¥€à¤‚',0),(201088,5586,'ms','TIDAK termasuk dalam Deposit cek',0),(201089,5586,'ar','Ù„Ù… ØªØ¯Ø±Ø¬ ÙÙŠ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(201090,5586,'fr','PAS incluse dans le chÃ¨que de dÃ©pÃ´t',0),(201091,5586,'jp','é ?ã‚Šé‡‘å°?åˆ‡æ‰‹ã?«ã?¯å?«ã‚?ã?ªã?„',0),(201092,5586,'pt','NÃ£o incluÃ­do na conta de depÃ³sito',0),(201093,5586,'ru','ÐÐ• Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ Ñ‡ÐµÐº',0),(201094,5586,'es','No Incluido en el Cheque de DepÃ³sito',0),(201095,5586,'de','NICHT erfaÃŸte Deposit-Check',0),(201096,5586,'en','NOT Included in Deposit Check',0),(201097,5587,'is','',0),(201098,5587,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(201099,5587,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(201100,5587,'tr','Servis sipariÅŸi gÃ¼ncelleÅŸtirmesi',0),(201101,5587,'pl','ZamÃ³wienie usÅ‚ugi aktualizacji',0),(201102,5587,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(201103,5587,'ur','Ø®Ø¯Ù…Øª ØªØ±ØªÛŒØ¨ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(201104,5587,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° ÑÐµÑ€Ð²Ð¸ÑÐ°',0),(201105,5587,'vi','Cáº­p nháº­t Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(201106,5587,'af','Diensbestelling Opdatering',0),(201107,5587,'ro','Serviciu comanda Update',0),(201108,5587,'et','Teenuse tellimuse uuendamine',0),(201109,5587,'si','Da posodobitev storitev',0),(201110,5587,'ba','Layanan Update pesanan',0),(201111,5587,'nl','Service Order Update',0),(201112,5587,'fi','Jotta pÃ¤ivitys',0),(201113,5587,'no','Tjenesten ordreoppdatering',0),(201114,5587,'da','Service ordrevedligeholdelse',0),(201115,5587,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ì—…ë°ì´íŠ¸',0),(201116,5587,'he','×¢×“×›×•×Ÿ ×”×–×ž× ×ª ×©×™×¨×•×ª',0),(201117,5587,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Î´Î¹Î¬Ï„Î±Î¾Î· Update',0),(201118,5587,'zh','æœåŠ¡è®¢è´­æ›´æ–°\r\n',0),(201119,5587,'sv','TjÃ¤nsten orderuppdatering',0),(201120,5587,'it','Aggiornamento ordine di servizio',0),(201121,5587,'tl','',0),(201122,5587,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(201123,5587,'hi','à¤¸à¤°à¥à¤µà¤¿à¤¸ à¤•à¥à¤°à¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(201124,5587,'ms','Perkhidmatan perintah Kemaskini',0),(201125,5587,'ar','Ø®Ø¯Ù…Ø© ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù†Ø¸Ø§Ù…',0),(201126,5587,'fr','Mise Ã  jour de commande de service',0),(201127,5587,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®æ›´æ–°',0),(201128,5587,'pt','AtualizaÃ§Ã£o de ordem de serviÃ§o',0),(201129,5587,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(201130,5587,'es','Orden de Servicio Actualizar',0),(201131,5587,'de','Service-Auftrag-Update',0),(201132,5587,'en','Service Order Update',0),(201133,5588,'is','',0),(201134,5588,'dr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(201135,5588,'pr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(201136,5588,'tr','Ä°ÅŸ emri',0),(201137,5588,'pl','Zlecenia',0),(201138,5588,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ°',0),(201139,5588,'ur','ØªØ±ØªÛŒØ¨ Ú©Ø§Ù…',0),(201140,5588,'sr','Ð Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(201141,5588,'vi','ÄÆ¡n hÃ ng cÃ´ng viá»‡c ',0),(201142,5588,'af','Werksbestelling',0),(201143,5588,'ro','Comanda de lucru',0),(201144,5588,'et','TÃ¶Ã¶ tellimus',0),(201145,5588,'si','Delovnega naloga',0),(201146,5588,'ba','Urutan kerja',0),(201147,5588,'nl','Werkorder',0),(201148,5588,'fi','TyÃ¶tilaus',0),(201149,5588,'no','Arbeidsordre',0),(201150,5588,'da','Arbejdsseddel',0),(201151,5588,'ko','ìž‘ì—… ìˆœì„œ',0),(201152,5588,'he','. ×”×–×ž× ×”',0),(201153,5588,'el','Î•Î½Ï„Î¿Î»Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(201154,5588,'zh','å·¥ä½œå•\r\n',0),(201155,5588,'sv','Arbetsorder',0),(201156,5588,'it','Ordine di lavoro',0),(201157,5588,'tl','',0),(201158,5588,'th','&#3591;&#3634;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(201159,5588,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤®',0),(201160,5588,'ms','Arahan kerja',0),(201161,5588,'ar','Ø£Ù…Ø± Ø¹Ù…Ù„',0),(201162,5588,'fr','Bon de travail',0),(201163,5588,'jp','ä½œæ¥­æ³¨æ–‡',0),(201164,5588,'pt','Ordem de serviÃ§o',0),(201165,5588,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(201166,5588,'es','Orden de trabajo',0),(201167,5588,'de','Arbeitsauftrag',0),(201168,5588,'en','Work Order',0),(201169,5589,'is','',0),(201170,5589,'dr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ  Ø®Ø¯Ù…Ø§Øª ',0),(201171,5589,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ  Ø®Ø¯Ù…Ø§Øª ',0),(201172,5589,'tr','Hizmet notlar',0),(201173,5589,'pl','ZauwaÅ¼a, usÅ‚ugi',0),(201174,5589,'bg','Ð¡Ð»ÑƒÐ¶ÐµÐ±Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(201175,5589,'ur','Ø®Ø¯Ù…Øª Ù†ÙˆÙ¹',0),(201176,5589,'sr','Ð¡ÐµÑ€Ð²Ð¸Ñ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(201177,5589,'vi','Ghi chÃº Dá»‹ch vá»¥',0),(201178,5589,'af','Diens Notas',0),(201179,5589,'ro','Note de serviciu',0),(201180,5589,'et','Teenuse mÃ¤rkmed',0),(201181,5589,'si','Storitev opombe',0),(201182,5589,'ba','Catatan Layanan',0),(201183,5589,'nl','Service-opmerkingen',0),(201184,5589,'fi','Asepalvelus huomata',0),(201185,5589,'no','Tjenesten notater',0),(201186,5589,'da','Service noter',0),(201187,5589,'ko','ì„œë¹„ìŠ¤ ì •ë³´',0),(201188,5589,'he','×”×¢×¨×•×ª ×©×¨×•×ª',0),(201189,5589,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(201190,5589,'zh','æœåŠ¡é¡»çŸ¥\r\n',0),(201191,5589,'sv','TjÃ¤nsten anteckningar',0),(201192,5589,'it','Note di servizio',0),(201193,5589,'tl','',0),(201194,5589,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(201195,5589,'hi','à¤¸à¥‡à¤µà¤¾ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(201196,5589,'ms','Nota Perkhidmatan',0),(201197,5589,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø®Ø¯Ù…Ø§Øª',0),(201198,5589,'fr','Notes de service',0),(201199,5589,'jp','ä½œæ¥­ãƒ¡ãƒ¢',0),(201200,5589,'pt','Notas de serviÃ§o',0),(201201,5589,'ru','Ð¡Ð»ÑƒÐ¶Ð±Ð° Ð·Ð°Ð¼ÐµÑ‚Ð¾Ðº',0),(201202,5589,'es','Notas de Servicio',0),(201203,5589,'de','Service-Hinweise',0),(201204,5589,'en','Service Notes',0),(201205,5590,'is','',0),(201206,5590,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§ ÙØ±Ù…Ø§ÛŒØ´ ',0),(201207,5590,'pr','Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§ Ø³ÙØ§Ø±Ø´ ',0),(201208,5590,'tr','SipariÅŸ ile para yatÄ±rma',0),(201209,5590,'pl','Kaucji z zamÃ³wienia',0),(201210,5590,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð»Ð°Ñ‚Ð° Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(201211,5590,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ø¯Ø§ Ú©ÛŒ Ø¬Ù…Ø¹',0),(201212,5590,'sr','ÐšÐ°Ð¿Ð°Ñ€Ñƒ ÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(201213,5590,'vi','Äáº·t cá»c Ä‘Ã£ tráº£ khi Ä‘áº·t hÃ ng',0),(201214,5590,'af','Deposito Betaal met Bestelling',0),(201215,5590,'ro','Depozit plÄƒtit cu comanda',0),(201216,5590,'et','Tagatisraha tasuda tellimuse',0),(201217,5590,'si','Depozit, plaÄan z naroÄilom',0),(201218,5590,'ba','Deposit yang dibayar dengan Order',0),(201219,5590,'nl','Vooruitbetaling bij bestelling',0),(201220,5590,'fi','Talletus maksetaan, jotta',0),(201221,5590,'no','Depositum betalt bestilling',0),(201222,5590,'da','Depositum betalt med ordre',0),(201223,5590,'ko','ìž…ê¸ˆ ì£¼ë¬¸ ì§€ë¶ˆ',0),(201224,5590,'he','×¤×™×§×“×•×Ÿ ×©×™×œ× ×¢× ×¡×“×¨',0),(201225,5590,'el','Î ÏÎ¿ÎºÎ±Ï„Î±Î²Î¿Î»Î®Ï‚ Î¼Îµ Î´Î¹Î±Ï„Î±Î³Î®',0),(201226,5590,'zh','å­˜æ¬¾æ”¯ä»˜çš„è®¢å•\r\n',0),(201227,5590,'sv','Depositionen betalas med bestÃ¤llning',0),(201228,5590,'it','Caparra versata con ordine',0),(201229,5590,'tl','',0),(201230,5590,'th','&#3613;&#3634;&#3585;&#3592;&#3656;&#3634;&#3618;&#3604;&#3657;&#3623;&#3618;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(201231,5590,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¥‡ à¤¸à¤¾à¤¥ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤œà¤®à¤¾',0),(201232,5590,'ms','Deposit yang dibayar dengan perintah',0),(201233,5590,'ar','Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© Ù…Ø¹ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(201234,5590,'fr','Acompte versÃ© avec ordonnance',0),(201235,5590,'jp','æ³¨æ–‡ã?¨æ‰•ã‚?ã‚Œã?Ÿé ?ã‚Šé‡‘',0),(201236,5590,'pt','DepÃ³sito pago com ordem',0),(201237,5590,'ru','Ð’Ð·Ð½Ð¾Ñ Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð¼',0),(201238,5590,'es','DepÃ³sito Pagado con el Orden',0),(201239,5590,'de','Anzahlung bei Bestellung',0),(201240,5590,'en','Deposit Paid with Order',0),(201241,5591,'is','',0),(201242,5591,'dr','Ù…Ù‚Ø¯Ø§Ø± Ú©Ø§Ø¯Ø±',0),(201243,5591,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú©Ø§Ø¯Ø±',0),(201244,5591,'tr','Bo Mkt.',0),(201245,5591,'pl','IloÅ›Ä‡ B.O.',0),(201246,5591,'bg','Ð‘Ð¾ ÐºÐ¾Ð»',0),(201247,5591,'ur','B.O. Ù‚ÛŒ',0),(201248,5591,'sr','Ð‘.Ðž. ÐšÐ¾Ð».',0),(201249,5591,'vi','Sá»‘ lÆ°á»£ng B.O.',0),(201250,5591,'af','B.O. Qty',0),(201251,5591,'ro','Bo cantit',0),(201252,5591,'et','Bo kogus',0),(201253,5591,'si','Bo koliÄina',0),(201254,5591,'ba','B.O. Qty',0),(201255,5591,'nl','Bo Qty',0),(201256,5591,'fi','Bo mÃ¤Ã¤rÃ¤',0),(201257,5591,'no','Bo Ant',0),(201258,5591,'da','Bo Qty',0),(201259,5591,'ko','ì‚¬ìš´ë“œ ìˆ˜ëŸ‰',0),(201260,5591,'he','×›×ž×•×ª ×©×œ ×¨×™×— ×¨×¢',0),(201261,5591,'el','B.O. Î Î¿Ïƒ.',0),(201262,5591,'zh','ä¸šåŠ¡å¯¹è±¡æ•°é‡\r\n',0),(201263,5591,'sv','Bo Kvt',0),(201264,5591,'it','B.O. Qty',0),(201265,5591,'tl','',0),(201266,5591,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3610;&#3636;&#3621;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(201267,5591,'hi','à¤¬à¥‹ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(201268,5591,'ms','B.O. Qty',0),(201269,5591,'ar','B.O. Qty',0),(201270,5591,'fr','B.O. Qty',0),(201271,5591,'jp','B.O.æ•°é‡?',0),(201272,5591,'pt','B.o. n Qty',0),(201273,5591,'ru','B.O. Qty',0),(201274,5591,'es','B.O. Cantidad',0),(201275,5591,'de','B.o. Qty',0),(201276,5591,'en','B.O. Qty',0),(201277,5592,'is','',0),(201278,5592,'dr',':1',0),(201279,5592,'pr','Ù„ÙŠØ³Øª Ø±Ù†Ú¯  Ø·Ø±Ù :1',0),(201280,5592,'tr','Renkli liste yan 1:',0),(201281,5592,'pl','Strona listy kolor 1:',0),(201282,5592,'bg','Ð¦Ð²ÐµÑ‚ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº ÑÑ‚Ñ€Ð°Ð½Ð° 1:',0),(201283,5592,'ur','ÙÛØ±Ø³Øª Ú©ÛŒ Ø·Ø±Ù 1 Ø±Ù†Ú¯:',0),(201284,5592,'sr','Ð‘Ð¾Ñ˜Ð° Ð»Ð¸ÑÑ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð° 1:',0),(201285,5592,'vi','Danh sÃ¡ch máº§u máº·t 1',0),(201286,5592,'af','Kleur Lys Kant 1:',0),(201287,5592,'ro','Culoare lista partea 1:',0),(201288,5592,'et','VÃ¤rv loendist pool 1:',0),(201289,5592,'si','Barvni seznam strani 1:',0),(201290,5592,'ba','Warna daftar samping 1:',0),(201291,5592,'nl','Kleur lijst kant 1:',0),(201292,5592,'fi','VÃ¤ri luettelon puolella 1:',0),(201293,5592,'no','Farge listen Side 1:',0),(201294,5592,'da','Farve liste Side 1:',0),(201295,5592,'ko','ìƒ‰ ëª©ë¡ ì¸¡ë©´ 1:',0),(201296,5592,'he','×‘×¨×©×™×ž×” ×¦×‘×¢ ×¦×“ 1:',0),(201297,5592,'el','Î§ÏÏŽÎ¼Î± Î»Î¯ÏƒÏ„Î± Ï€Î»ÎµÏ…ÏÎ¬ 1:',0),(201298,5592,'zh','é¢œè‰²åˆ—è¡¨ä¾§1ï¼š\r\n',0),(201299,5592,'sv','FÃ¤rg listan sida 1:',0),(201300,5592,'it','Colore elenco lato 1:',0),(201301,5592,'tl','',0),(201302,5592,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3637;&#3627;&#3609;&#3657;&#3634; 1',0),(201303,5592,'hi','à¤°à¤‚à¤— à¤¸à¥‚à¤šà¥€ à¤¸à¤¾à¤‡à¤¡ 1:',0),(201304,5592,'ms','Warna senarai Bahagian 1:',0),(201305,5592,'ar','Ù„ÙˆÙ† Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠØ© 1:',0),(201306,5592,'fr','CÃ´tÃ© colorÃ© Liste 1 :',0),(201307,5592,'jp','ã‚µã‚¤ãƒ‰ï¼‘ã€€è‰²ãƒªã‚¹ãƒˆï¼š',0),(201308,5592,'pt','Cor lista lado 1:',0),(201309,5592,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¦Ð²ÐµÑ‚Ð¾Ð² Ð§Ð°ÑÑ‚ÑŒ 1:',0),(201310,5592,'es','Lista de Colores Lado 1:',0),(201311,5592,'de','Farbe-Liste-Seite 1:',0),(201312,5592,'en','Color List Side 1:',0),(201313,5593,'is','',0),(201314,5593,'dr',':2:',0),(201315,5593,'pr','Ù„ÙŠØ³Øª Ø±Ù†Ú¯  Ø·Ø±Ù :2:',0),(201316,5593,'tr','Renkli liste yan 2:',0),(201317,5593,'pl','Strona listy kolor 2:',0),(201318,5593,'bg','Ð¦Ð²ÐµÑ‚ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº ÑÑ‚Ñ€Ð°Ð½Ð° 2:',0),(201319,5593,'ur','ÙÛØ±Ø³Øª Ú©ÛŒ Ø·Ø±Ù 2 Ø±Ù†Ú¯:',0),(201320,5593,'sr','Ð‘Ð¾Ñ˜Ð° Ð»Ð¸ÑÑ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð° 2:',0),(201321,5593,'vi','Danh sÃ¡ch máº§u máº·t 2',0),(201322,5593,'af','Kleur Lys Kant 2:',0),(201323,5593,'ro','Culoare lista partea 2:',0),(201324,5593,'et','VÃ¤rv loendist pool 2:',0),(201325,5593,'si','Barvni seznam strani 2:',0),(201326,5593,'ba','Warna daftar sisi 2:',0),(201327,5593,'nl','Bladzijde 2 van de lijst van kleur:',0),(201328,5593,'fi','VÃ¤ri luettelosta sivu 2:',0),(201329,5593,'no','Farge listen Side 2:',0),(201330,5593,'da','Farve liste Side 2:',0),(201331,5593,'ko','ìƒ‰ ëª©ë¡ ì¸¡ë©´ 2:',0),(201332,5593,'he','×‘×¨×©×™×ž×” ×¦×‘×¢ ×¦×“ 2:',0),(201333,5593,'el','Î§ÏÏŽÎ¼Î± Î»Î¯ÏƒÏ„Î± Ï€Î»ÎµÏ…ÏÎ¬ 2:',0),(201334,5593,'zh','é¢œè‰²åˆ—è¡¨ä¾§2ï¼š\r\n',0),(201335,5593,'sv','FÃ¤rg lista sidan 2:',0),(201336,5593,'it','Colore elenco lato 2:',0),(201337,5593,'tl','',0),(201338,5593,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3637;&#3627;&#3609;&#3657;&#3634; 2',0),(201339,5593,'hi','à¤°à¤‚à¤— à¤¸à¥‚à¤šà¥€ à¤¸à¤¾à¤‡à¤¡ 2:',0),(201340,5593,'ms','Warna senarai Bahagian 2:',0),(201341,5593,'ar','Ù„ÙˆÙ† Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠØ© 2:',0),(201342,5593,'fr','CÃ´tÃ© colorÃ© liste 2 :',0),(201343,5593,'jp','ã‚µã‚¤ãƒ‰ï¼’ã€€è‰²ãƒªã‚¹ãƒˆï¼š',0),(201344,5593,'pt','Cor lista lado 2:',0),(201345,5593,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¦Ð²ÐµÑ‚Ð¾Ð² Ð§Ð°ÑÑ‚ÑŒ 2:',0),(201346,5593,'es','Lista de Colores Lado 2:',0),(201347,5593,'de','Farbe Liste Seite 2:',0),(201348,5593,'en','Color List Side 2:',0),(201349,5594,'is','',0),(201350,5594,'dr','1',0),(201351,5594,'pr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ø² Ø±Ù†Ú¯Ù‡Ø§ Ø¬Ù‡Øª 1',0),(201352,5594,'tr','# 1 yan Renkler:',0),(201353,5594,'pl','# Kolorystyka strony 1:',0),(201354,5594,'bg','# Ð¦Ð²ÐµÑ‚Ð¾Ð²Ðµ ÑÑ‚Ñ€Ð°Ð½Ð° 1:',0),(201355,5594,'ur','# 1 Ú©ÛŒ Ø·Ø±Ù Ø±Ù†Ú¯:',0),(201356,5594,'sr','# Ð‘Ð¾Ñ˜Ðµ ÑÑ‚Ñ€Ð°Ð½Ð° 1:',0),(201357,5594,'vi','Sá»‘ máº§u máº·t 1:',0),(201358,5594,'af','# Kleure Kant 1:',0),(201359,5594,'ro','# Culori partea 1:',0),(201360,5594,'et','# VÃ¤rvid esikÃ¼lge:',0),(201361,5594,'si','# Barve strani 1:',0),(201362,5594,'ba','# Warna samping 1:',0),(201363,5594,'nl','# Kleuren kant 1:',0),(201364,5594,'fi','# VÃ¤rit Side 1:',0),(201365,5594,'no','# Farger Side 1:',0),(201366,5594,'da','# Farver Side 1:',0),(201367,5594,'ko','# 1 ë©´ ìƒ‰ìƒ:',0),(201368,5594,'he','# ×¦×‘×¢×™× ×¦×“ 1:',0),(201369,5594,'el','# Î§ÏÏŽÎ¼Î±Ï„Î± Ï€Î»ÎµÏ…ÏÎ¬ 1:',0),(201370,5594,'zh','ï¼ƒé¢œè‰²ä¾§1ï¼š\r\n',0),(201371,5594,'sv','# FÃ¤rger sidan 1:',0),(201372,5594,'it','# Colori lato 1:',0),(201373,5594,'tl','',0),(201374,5594,'th','&#3626;&#3637; &#3627;&#3609;&#3657;&#3634; 1:\n',0),(201375,5594,'hi','# 1 à¤•à¥€ à¤“à¤° à¤°à¤‚à¤—:',0),(201376,5594,'ms','# Warna Bahagian 1:',0),(201377,5594,'ar','# Ø£Ù„ÙˆØ§Ù† Ø§Ù„Ø¬Ø§Ù†Ø¨ 1:',0),(201378,5594,'fr','# Couleurs face 1 :',0),(201379,5594,'jp','ã‚µã‚¤ãƒ‰ï¼‘ã€€è‰²ã?®æ•°ï¼š',0),(201380,5594,'pt','# Cores lado 1:',0),(201381,5594,'ru','# Ð¦Ð²ÐµÑ‚Ð° ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð° 1:',0),(201382,5594,'es','# Colores Lado 1:',0),(201383,5594,'de','# Farben Seite 1:',0),(201384,5594,'en','# Colors Side 1:',0),(201385,5595,'is','',0),(201386,5595,'dr','2',0),(201387,5595,'pr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ø² Ø±Ù†Ú¯Ù‡Ø§ Ø¬Ù‡Øª 2',0),(201388,5595,'tr','# 2 Side Renkler:',0),(201389,5595,'pl','# Strona 2 kolory:',0),(201390,5595,'bg','# Ð¦Ð²ÐµÑ‚Ð¾Ð²Ðµ ÑÑ‚Ñ€Ð°Ð½Ð° 2:',0),(201391,5595,'ur','# 2 Ú©ÛŒ Ø·Ø±Ù Ø±Ù†Ú¯:',0),(201392,5595,'sr','# Ð‘Ð¾Ñ˜Ðµ ÑÑ‚Ñ€Ð°Ð½Ð° 2:',0),(201393,5595,'vi','Sá»‘ máº§u máº·t 2:',0),(201394,5595,'af','# Kleure Kant 2:',0),(201395,5595,'ro','# Culori partea 2:',0),(201396,5595,'et','# VÃ¤rvid pool 2:',0),(201397,5595,'si','# Barve strani 2:',0),(201398,5595,'ba','# Warna sisi 2:',0),(201399,5595,'nl','# Kleuren kant 2:',0),(201400,5595,'fi','# VÃ¤rit, 2-puoli:',0),(201401,5595,'no','# Farger Side 2:',0),(201402,5595,'da','# Farver Side 2:',0),(201403,5595,'ko','# 2 ë©´ ìƒ‰ìƒ:',0),(201404,5595,'he','# ×¦×‘×¢×™× ×¦×“ 2:',0),(201405,5595,'el','# Î§ÏÏŽÎ¼Î±Ï„Î± Ï€Î»ÎµÏ…ÏÎ¬ 2:',0),(201406,5595,'zh','ï¼ƒé¢œè‰²ä¾§2ï¼š\r\n',0),(201407,5595,'sv','# FÃ¤rger sidan 2:',0),(201408,5595,'it','# Colori lato 2:',0),(201409,5595,'tl','',0),(201410,5595,'th','&#3626;&#3637; &#3627;&#3609;&#3657;&#3634; 2:\n',0),(201411,5595,'hi','# 2 à¤•à¥€ à¤“à¤° à¤°à¤‚à¤—:',0),(201412,5595,'ms','# Warna sampingan 2:',0),(201413,5595,'ar','# Ø£Ù„ÙˆØ§Ù† Ø§Ù„Ø¬Ø§Ù†Ø¨ 2:',0),(201414,5595,'fr','# Couleurs face 2 :',0),(201415,5595,'jp','ã‚µã‚¤ãƒ‰ï¼’ã€€è‰²ã?®æ•°ï¼š',0),(201416,5595,'pt','# Cores lado 2:',0),(201417,5595,'ru','# Ð¦Ð²ÐµÑ‚Ð¾Ð² Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð° 2:',0),(201418,5595,'es','# Colores Lado 2:',0),(201419,5595,'de','# Farben Seite 2:',0),(201420,5595,'en','# Colors Side 2:',0),(201421,5596,'is','',0),(201422,5596,'dr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ø² ØµÙØ­Ø§Øª',0),(201423,5596,'pr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ø² ØµÙØ­Ø§Øª',0),(201424,5596,'tr','# SayfalarÄ±',0),(201425,5596,'pl','# Stron',0),(201426,5596,'bg','# Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(201427,5596,'ur','# ØµÙØ­Ø§Øª',0),(201428,5596,'sr','# Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(201429,5596,'vi','Sá»‘ trang',0),(201430,5596,'af','# Bladsye',0),(201431,5596,'ro','# Pagini',0),(201432,5596,'et','# LehekÃ¼lgede',0),(201433,5596,'si','# Strani',0),(201434,5596,'ba','# Halaman',0),(201435,5596,'nl','# Pagina \'s',0),(201436,5596,'fi','# Sivut',0),(201437,5596,'no','# Sider',0),(201438,5596,'da','# Sider',0),(201439,5596,'ko','# íŽ˜ì´ì§€',0),(201440,5596,'he','# ×“×¤×™×',0),(201441,5596,'el','# Î£ÎµÎ»Î¯Î´ÎµÏ‚',0),(201442,5596,'zh','ï¼ƒé¡µ\r\n',0),(201443,5596,'sv','# Sidor',0),(201444,5596,'it','# Pagine',0),(201445,5596,'tl','',0),(201446,5596,'th','&#3627;&#3609;&#3657;&#3634;',0),(201447,5596,'hi','# à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚',0),(201448,5596,'ms','# Laman',0),(201449,5596,'ar','# ØµÙØ­Ø§Øª',0),(201450,5596,'fr','# Pages',0),(201451,5596,'jp','ãƒšãƒ¼ã‚¸æ•°',0),(201452,5596,'pt','# PÃ¡ginas',0),(201453,5596,'ru','# Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†',0),(201454,5596,'es','# PÃ¡ginas',0),(201455,5596,'de','# Seiten',0),(201456,5596,'en','# Pages',0),(201457,5597,'is','',0),(201458,5597,'dr','(Ø¶Ø±Ø±) / Ù†ÙˆØ¨Øª ',0),(201459,5597,'pr','ÙƒØ§Ø±  Ùˆ Ø´ÙƒØ³Øª(Ø²ÙŠØ§Ù†) / Ù†ÙˆØ¨Øª ',0),(201460,5597,'tr','Ä°ÅŸ & Flop/kapat',0),(201461,5597,'pl','Praca & Flop/Turn',0),(201462,5597,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° & Ñ„Ð»Ð¾Ð¿Ð°/Ð·Ð°Ð²Ð¾Ð¹',0),(201463,5597,'ur','Ú©Ø§Ù… & Ù†Ú©Ø§Ù…/Ù…ÙˆÚ‘',0),(201464,5597,'sr','ÐŸÐ¾ÑÐ»Ð° & Ð¤Ð»Ð¾Ð¿/Ñ€ÐµÐ´',0),(201465,5597,'vi','CÃ´ng viá»‡c & tháº¥t báº¡i/LÆ°á»£t',0),(201466,5597,'af','Werk & Flop/draai',0),(201467,5597,'ro','Munca & Flop/Turn',0),(201468,5597,'et','Vahetus',0),(201469,5597,'si','Delo & Flop/Turn',0),(201470,5597,'ba','Pekerjaan & Flop/giliran',0),(201471,5597,'nl','Werk & Flop/Turn',0),(201472,5597,'fi','TyÃ¶n & floppi/Piilota',0),(201473,5597,'no','Arbeid & floppen/slukke',0),(201474,5597,'da','Arbejde & Flop/Turn',0),(201475,5597,'ko','ìž‘ì—… & í”Œë¡­/ë°©í–¥',0),(201476,5597,'he','×¢×‘×•×“×” & ×¤×œ×•×¤/×”×ª×•×¨',0),(201477,5597,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± & Flop/ÏƒÎµÎ¹ÏÎ¬',0),(201478,5597,'zh','å·¥ä½œä¸Žè·³é«˜/å¼€å¯\r\n',0),(201479,5597,'sv','Arbete & Flop/Turn',0),(201480,5597,'it','Lavoro & Flop/Turn',0),(201481,5597,'tl','',0),(201482,5597,'th','&#3591;&#3634;&#3609;&#3649;&#3621;&#3632;&#3588;&#3623;&#3634;&#3617;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;/&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;',0),(201483,5597,'hi','à¤•à¤¾à¤® & à¤«à¥à¤²à¥‰à¤ª/à¤®à¥‹à¤¡à¤¼',0),(201484,5597,'ms','Kerja & Flop/pusingan',0),(201485,5597,'ar','Ø¹Ù…Ù„ Ø¢Ù†Ø¯ Ø§Ù„ØªØ®Ø¨Ø·/Ø¯ÙˆØ±Ø©',0),(201486,5597,'fr','Travail & Flop/tour',0),(201487,5597,'jp','Work&Flop/Turn',0),(201488,5597,'pt','Trabalho & Flop/Turn',0),(201489,5597,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° & Ñ„Ð»Ð¾Ð¿Ðµ/Ð¿Ð¾Ð²Ð¾Ñ€Ð¾Ñ‚',0),(201490,5597,'es','Trabajo&Fallo/Giro',0),(201491,5597,'de','Arbeit & Flop/Turn',0),(201492,5597,'en','Work&Flop/Turn',0),(201493,5598,'is','',0),(201494,5598,'dr','IPH   ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ',0),(201495,5598,'pr','IPH   ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ',0),(201496,5598,'tr','IPH birimleri',0),(201497,5598,'pl','IPH jednostek',0),(201498,5598,'bg','IPH ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(201499,5598,'ur','Ø§Ù ÛŒÙˆÙ†Ù¹Ø³',0),(201500,5598,'sr','Ð˜ÐŸÐ¥ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(201501,5598,'vi','ÄÆ¡n vá»‹ IPH',0),(201502,5598,'af','IPH eenhede',0),(201503,5598,'ro','UnitÄƒÅ£i de IPH',0),(201504,5598,'et','IPH Ã¼hikut',0),(201505,5598,'si','IPH enot',0),(201506,5598,'ba','IPH unit',0),(201507,5598,'nl','WIV eenheden',0),(201508,5598,'fi','IPH yksikÃ¶t',0),(201509,5598,'no','IPH enheter',0),(201510,5598,'da','IPH enheder',0),(201511,5598,'ko','IPH ë‹¨ìœ„',0),(201512,5598,'he','×™×—×™×“×•×ª IPH',0),(201513,5598,'el','IPH Î¼Î¿Î½Î¬Î´ÎµÏ‚',0),(201514,5598,'zh','æ¯å°æ—¶æ‰“å°çš„å•ä½\r\n',0),(201515,5598,'sv','IPH enheter',0),(201516,5598,'it','UnitÃ  IPH',0),(201517,5598,'tl','',0),(201518,5598,'th','&#3627;&#3609;&#3656;&#3623;&#3618; IPH',0),(201519,5598,'hi','IPH à¤‡à¤•à¤¾à¤‡à¤¯à¤¾à¤',0),(201520,5598,'ms','Unit IPH',0),(201521,5598,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù…Ø¹Ù‡Ø¯',0),(201522,5598,'fr','UnitÃ©s de l\'IPH',0),(201523,5598,'jp','ï¼©ï¼°ï¼¨å?˜ä½?',0),(201524,5598,'pt','Unidades do IPH',0),(201525,5598,'ru','IPH ÐµÐ´Ð¸Ð½Ð¸Ñ†',0),(201526,5598,'es','Unidades IPH',0),(201527,5598,'de','IPH-Einheiten',0),(201528,5598,'en','IPH Units',0),(201529,5599,'is','',0),(201530,5599,'dr','(Ù¾Ø§ÙŠÙ‡ ) Ø®Ø·ÙŠ',0),(201531,5599,'pr','Ø¯Ø§Ù…Ù†Ù‡ (Ù¾Ø§ÙŠÙ‡ ) Ø®Ø·ÙŠ',0),(201532,5599,'tr','DoÄŸrusal Ft.',0),(201533,5599,'pl','Liniowy metrÃ³w.',0),(201534,5599,'bg','Ð›Ð¸Ð½ÐµÐ¹Ð½Ð¸ Ð¼ÐµÑ‚Ñ€Ð°.',0),(201535,5599,'ur','Ù„Ú©ÛŒØ±ÛŒ ÙÙ¹ ÛÛ’ Û”',0),(201536,5599,'sr','Ð›Ð¸Ð½ÐµÐ°Ñ€Ð½Ð¸ Ð¤Ñ‚.',0),(201537,5599,'vi','Feet Ä‘Æ°á»ng tháº³ng',0),(201538,5599,'af','LineÃªre Ft.',0),(201539,5599,'ro','Ft liniare.',0),(201540,5599,'et','Lineaarne jalga.',0),(201541,5599,'si','Linearni Ft.',0),(201542,5599,'ba','Linier kaki.',0),(201543,5599,'nl','Lineaire Ft.',0),(201544,5599,'fi','Lineaarinen metrin.',0),(201545,5599,'no','LineÃ¦r Ft.',0),(201546,5599,'da','LineÃ¦r Ft.',0),(201547,5599,'ko','ì„ í˜• í”¼íŠ¸ìž…ë‹ˆë‹¤.',0),(201548,5599,'he','×¨×’×œ ×œ×™× ×™××¨×™.',0),(201549,5599,'el','Î“ÏÎ±Î¼Î¼Î¹ÎºÎ® Ft.',0),(201550,5599,'zh','çº¿æ€§è‹±å°ºã€‚\r\n',0),(201551,5599,'sv','LinjÃ¤r Ft.',0),(201552,5599,'it','Lineare Ft.',0),(201553,5599,'tl','',0),(201554,5599,'th','Linear Ft.',0),(201555,5599,'hi','à¤°à¥ˆà¤–à¤¿à¤• Ft.',0),(201556,5599,'ms','Linear ka.',0),(201557,5599,'ar','Ù‚Ø¯Ù… Ø®Ø·ÙŠØ©.',0),(201558,5599,'fr','MÃ¨tres linÃ©aires.',0),(201559,5599,'jp','Linear Ft.',0),(201560,5599,'pt','Linear Ft.',0),(201561,5599,'ru','Ð›Ð¸Ð½ÐµÐ¹Ð½Ñ‹Ñ… Ñ„ÑƒÑ‚Ð¾Ð².',0),(201562,5599,'es','Pie Linear',0),(201563,5599,'de','Lineare Ft.',0),(201564,5599,'en','Linear Ft.',0),(201565,5600,'is','',0),(201566,5600,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø±Ù†Ú¯Ù‡Ø§  Ú†Ø§Ù¾ ÙŠÙƒØ·Ø±ÙÙ‡',0),(201567,5600,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø±Ù†Ú¯Ù‡Ø§  Ú†Ø§Ù¾ ÙŠÙƒØ·Ø±ÙÙ‡',0),(201568,5600,'tr','Max.Colors tek taraflÄ± yazdÄ±rma',0),(201569,5600,'pl','Max.Colors druk jednostronny',0),(201570,5600,'bg','Max.Colors ÐµÐ´Ð½Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½ Ð¿ÐµÑ‡Ð°Ñ‚',0),(201571,5600,'ur','Max.Colors ÛŒÚ© Ø±Ø®Û’ Ø·ÙˆØ± Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(201572,5600,'sr','ÐˆÐµÐ´Ð½Ð¾ÑÑ‚Ñ€Ð°Ð½Ð° ÐŸÑ€Ð¸Ð½Ñ‚ ÐœÐ°x.Ð¦Ð¾Ð»Ð¾Ñ€Ñ',0),(201573,5600,'vi','Máº§u tá»‘i Ä‘a in má»™t máº·t',0),(201574,5600,'af','Max.Colors eensydige druk',0),(201575,5600,'ro','Max.Colors Print unilateral',0),(201576,5600,'et','Max.Colors Ã¼hepoolne printimine',0),(201577,5600,'si','Enostranski tisk Max.Colors',0),(201578,5600,'ba','Max.Colors satu sisi cetak',0),(201579,5600,'nl','Max.Colors eenzijdig afdrukken',0),(201580,5600,'fi','Max.Colors yksipuolinen tulostus',0),(201581,5600,'no','Max.Colors ensidig utskrift',0),(201582,5600,'da','Max.Colors ensidige Print',0),(201583,5600,'ko','Max.Colors ì–‘ë©´ ì¸ì‡„',0),(201584,5600,'he','×”×“×¤×¡×” ×—×“-×¦×“×“×™×ª Max.Colors',0),(201585,5600,'el','ÎœÎ¿Î½ÏŒÏ€Î»ÎµÏ…ÏÎ· ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Max.Colors',0),(201586,5600,'zh','æœ€å¤šè‰²å½©å•é¢æ‰“å°\r\n',0),(201587,5600,'sv','Max.Colors enkelsidig utskrift',0),(201588,5600,'it','Max.Colors stampa unilaterale',0),(201589,5600,'tl','',0),(201590,5600,'th','&#3626;&#3637;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3627;&#3609;&#3657;&#3634;&#3648;&#3604;&#3637;&#3618;&#3623;',0),(201591,5600,'hi','Max.Colors à¤à¤• à¤¤à¤°à¤«à¤¾ à¤®à¥à¤¦à¥à¤°à¤£',0),(201592,5600,'ms','Cetak berat sebelah Max.Colors',0),(201593,5600,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø£Ø­Ø§Ø¯ÙŠØ© Ø§Ù„Ø¬Ø§Ù†Ø¨ Max.Colors',0),(201594,5600,'fr','Impression recto Max.Colors',0),(201595,5600,'jp','ç‰‡é?¢å?°åˆ·ã?®æœ€å¤§è‰²æ•°',0),(201596,5600,'pt','Max.Colors impressÃ£o unilateral',0),(201597,5600,'ru','ÐœÐ°ÐºÑ. Ð¦Ð²ÐµÑ‚Ð¾Ð² ÐžÐ´Ð½Ð¾ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð½ÑÑ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(201598,5600,'es','Max. Colores ImpresiÃ³n de Un Lado',0),(201599,5600,'de','Max.Colors einseitig drucken',0),(201600,5600,'en','Max.Colors One-Sided Print',0),(201601,5601,'is','',0),(201602,5601,'dr','1  ÙˆÙ‚ØªÙŠ Ú†Ø§Ù¾ Ø¯Ùˆ Ø·Ø±ÙÙ‡ Ø§Ø³Øª ',0),(201603,5601,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø±Ù†Ú¯Ù‡Ø§  Ø·Ø±Ù  1  ÙˆÙ‚ØªÙŠ Ú†Ø§Ù¾ Ø¯Ùˆ Ø·Ø±ÙÙ‡ Ø§Ø³Øª ',0),(201604,5601,'tr','Max.Colors yan 1 ne zaman 2 taraflÄ± yazdÄ±rma',0),(201605,5601,'pl','Stronie Max.Colors 1 2-stronne wydruku',0),(201606,5601,'bg','Max.Colors ÑÑ‚Ñ€Ð°Ð½Ð° 1, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ 2-ÐµÐ´Ð½Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½ Ð¿ÐµÑ‡Ð°Ñ‚',0),(201607,5601,'ur','Max.Colors Ú©ÛŒ Ø·Ø±Ù 1 Ø¬Ø¨ 2 Ø·Ø±ÙÛ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ',0),(201608,5601,'sr','ÐœÐ°x .Ð¦Ð¾Ð»Ð¾Ñ€Ñ ÑÑ‚Ñ€Ð°Ð½Ð° 1 ÐºÐ°Ð´Ð° 2-Ð¡Ð¸Ð´ÐµÐ´ ÐŸÑ€Ð¸Ð½Ñ‚',0),(201609,5601,'vi','Máº§u tá»‘i Ä‘a trÃªn máº·t 1 khi in hai máº·t',0),(201610,5601,'af','Max.Colors kant 1 wanneer 2-geskaar druk',0),(201611,5601,'ro','Max.Colors partea 1 cÃ¢nd douÄƒ feÈ›e Print',0),(201612,5601,'et','Max.Colors kÃ¼ljel 1 kui kahepoolne printimine',0),(201613,5601,'si','Max.Colors stran 1 ko dvostranski tisk',0),(201614,5601,'ba','Max.Colors sisi 1 ketika 2 sisi cetak',0),(201615,5601,'nl','Max.Colors kant 1 als 2-zijdig afdrukken',0),(201616,5601,'fi','Max.Colors puolella 1 Kun 2-puolinen tulostus',0),(201617,5601,'no','Max.Colors Side 1 nÃ¥r dobbeltsidig utskrift',0),(201618,5601,'da','Max.Colors Side 1 nÃ¥r 2-sidet udskrivning',0),(201619,5601,'ko','Max.Colors ì‚¬ì´ë“œ 1 ë•Œ ì–‘ë©´ ì¸ì‡„',0),(201620,5601,'he','Max.Colors ×¦×“ 1 ×›××©×¨ ×“×•-×¦×“×“×™×ª ×”×“×¤×¡×”',0),(201621,5601,'el','Max.Colors Ï€Î»ÎµÏ…ÏÎ¬ 1 ÏŒÏ„Î±Î½ 2 ÏŒÏˆÎµÏ‰Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(201622,5601,'zh','å½“åŒé¢æ‰“å°æ—¶æœ€å¤šè‰²å½©ä¾§é¢1\r\n',0),(201623,5601,'sv','Max.Colors sidan 1 vid dubbelsidig utskrift',0),(201624,5601,'it','Max.Colors lato 1 quando 2-Sided Print',0),(201625,5601,'tl','',0),(201626,5601,'th','&#3626;&#3637;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3651;&#3609;&#3627;&#3609;&#3638;&#3656;&#3591;&#3627;&#3609;&#3657;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3649;&#3610;&#3610;&#3',0),(201627,5601,'hi','Max.Colors à¤ªà¤•à¥à¤· 1 à¤œà¤¬ 2-à¤¤à¤°à¤«à¤¾ à¤®à¥à¤¦à¥à¤°à¤£',0),(201628,5601,'ms','Max.Colors Bahagian 1 apabila muka 2 cetak',0),(201629,5601,'ar','Max.Colors Ø§Ù„Ø¬Ø§Ù†Ø¨ 1 Ø¹Ù†Ø¯ Ø§Ù„ÙˆØ¬Ù‡ÙŠÙ† Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(201630,5601,'fr','Max.Colors cÃ´tÃ© 1 lorsque recto-verso impression',0),(201631,5601,'jp','ä¸¡é?¢å?°åˆ·ã?®å ´å?ˆã?®é?¢ï¼‘ã?®æœ€å¤§è‰²æ•°',0),(201632,5601,'pt','Max.Colors lado 1 quando verso impressÃ£o',0),(201633,5601,'ru','ÐœÐ°ÐºÑ.Ð¦Ð²ÐµÑ‚Ð¾Ð² Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð° 1 ÐºÐ¾Ð³Ð´Ð° 2-Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð½ÑÑ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(201634,5601,'es','Max. Colores Lado 1 cuando ImpresiÃ³n de 2 Lados',0),(201635,5601,'de','Max.Colors Seite 1 bei beidseitiger Druck',0),(201636,5601,'en','Max.Colors Side 1 when 2-Sided Print',0),(201637,5602,'is','',0),(201638,5602,'dr','2  ÙˆÙ‚ØªÙŠ Ú†Ø§Ù¾ Ø¯Ùˆ Ø·Ø±ÙÙ‡ Ø§Ø³Øª',0),(201639,5602,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø±Ù†Ú¯Ù‡Ø§  Ø·Ø±Ù  2  ÙˆÙ‚ØªÙŠ Ú†Ø§Ù¾ Ø¯Ùˆ Ø·Ø±ÙÙ‡ Ø§Ø³Øª',0),(201640,5602,'tr','Max.Colors yÃ¼z 2 ne zaman 2 taraflÄ± yazdÄ±rma',0),(201641,5602,'pl','Stronie Max.Colors 2 dwustronne drukowanie',0),(201642,5602,'bg','Max.Colors ÑÑ‚Ñ€Ð°Ð½Ð° 2, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ 2-ÐµÐ´Ð½Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½ Ð¿ÐµÑ‡Ð°Ñ‚',0),(201643,5602,'ur','Max.Colors Ú©ÛŒ Ø·Ø±Ù 2 Ø¬Ø¨ 2 Ø·Ø±ÙÛ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ',0),(201644,5602,'sr','ÐœÐ°x .Ð¦Ð¾Ð»Ð¾Ñ€Ñ ÑÑ‚Ñ€Ð°Ð½Ñƒ 2 ÐºÐ°Ð´Ð° 2-Ð¡Ð¸Ð´ÐµÐ´ ÐŸÑ€Ð¸Ð½Ñ‚',0),(201645,5602,'vi','Máº§u tá»‘i Ä‘a trÃªn máº·t 2 khi in hai máº·t',0),(201646,5602,'af','Max.Colors kant 2 wanneer 2-geskaar druk',0),(201647,5602,'ro','Max.Colors partea 2 atunci cÃ¢nd douÄƒ feÈ›e Print',0),(201648,5602,'et','Max.Colors pool 2 kui kahepoolne printimine',0),(201649,5602,'si','Max.Colors stran 2 ÄŒe 2-stranski tisk',0),(201650,5602,'ba','Max.Colors sisi 2 ketika 2 sisi cetak',0),(201651,5602,'nl','Max.Colors kant 2 bij 2-zijdig afdrukken',0),(201652,5602,'fi','Max.Colors puolella 2 Kun 2-puolinen tulostus',0),(201653,5602,'no','Max.Colors Side 2 nÃ¥r dobbeltsidig utskrift',0),(201654,5602,'da','Max.Colors Side 2 nÃ¥r 2-sidet udskrivning',0),(201655,5602,'ko','Max.Colors ì‚¬ì´ë“œ 2 ë•Œ ì–‘ë©´ ì¸ì‡„',0),(201656,5602,'he','Max.Colors ×¦×“ 2 ×›××©×¨ ×“×•-×¦×“×“×™×ª ×”×“×¤×¡×”',0),(201657,5602,'el','Max.Colors Ï€Î»ÎµÏ…ÏÎ¬ 2 ÏŒÏ„Î±Î½ 2 ÏŒÏˆÎµÏ‰Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(201658,5602,'zh','å½“åŒé¢æ‰“å°æ—¶æœ€å¤šè‰²å½©ä¾§é¢2\r\n',0),(201659,5602,'sv','Max.Colors sidan 2 vid dubbelsidig utskrift',0),(201660,5602,'it','Max.Colors lato 2 quando 2-Sided Print',0),(201661,5602,'tl','',0),(201662,5602,'th','&#3626;&#3637;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3651;&#3609;&#3626;&#3629;&#3591;&#3627;&#3609;&#3657;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3649;&#3610;&#3610;&#3626;&#3629;&#3',0);
INSERT INTO `langdef` VALUES (201663,5602,'hi','Max.Colors à¤¤à¤°à¤« 2 à¤œà¤¬ 2-à¤¤à¤°à¤«à¤¾ à¤®à¥à¤¦à¥à¤°à¤£',0),(201664,5602,'ms','Max.Colors Bahagian 2 apabila muka 2 cetak',0),(201665,5602,'ar','Max.Colors Ø§Ù„Ø¬Ø§Ù†Ø¨ 2 Ø¹Ù†Ø¯ Ø§Ù„ÙˆØ¬Ù‡ÙŠÙ† Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(201666,5602,'fr','Max.Colors cÃ´tÃ© 2 lorsque recto-verso impression',0),(201667,5602,'jp','ä¸¡é?¢å?°åˆ·ã?®å ´å?ˆã?®é?¢ï¼’ã?®æœ€å¤§è‰²æ•°',0),(201668,5602,'pt','Max.Colors lado 2 quando verso impressÃ£o',0),(201669,5602,'ru','ÐœÐ°ÐºÑ.Ð¦Ð²ÐµÑ‚Ð¾Ð² Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð° 2 ÐºÐ¾Ð³Ð´Ð° 2-Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð½ÑÑ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(201670,5602,'es','Max. Colores Lado 2 cuando ImpresiÃ³n de 2 Lados',0),(201671,5602,'de','Max.Colors Seite 2 bei beidseitiger Druck',0),(201672,5602,'en','Max.Colors Side 2 when 2-Sided Print',0),(201673,5603,'is','',0),(201674,5603,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ø±Ù†Ú¯Ù‡Ø§ÙŠ Ø§ÙŠÙ† Ù…Ø§Ø´ÙŠÙ† Ú†Ø§Ù¾ ',0),(201675,5603,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ø±Ù†Ú¯Ù‡Ø§ÙŠ Ø§ÙŠÙ† Ù…Ø§Ø´ÙŠÙ† Ú†Ø§Ù¾ ',0),(201676,5603,'tr','En az bu basÄ±n renkler',0),(201677,5603,'pl','Minimalna kolory to naciÅ›nij',0),(201678,5603,'bg','ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼ Ñ‚Ð¾Ð²Ð° Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ ÐŸÑ€ÐµÑ',0),(201679,5603,'ur','Ú©Ù… Ø§Ø² Ú©Ù… ÛŒÛ Ù¾Ø±ÛŒØ³ Ø±Ù†Ú¯',0),(201680,5603,'sr','ÐžÐ²Ð¾ Ñ˜Ðµ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð±Ð¾Ñ˜Ðµ Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ',0),(201681,5603,'vi','Máº§u Tá»‘i thiá»ƒu cho báº£n in nÃ y',0),(201682,5603,'af','Minimum kleure dit druk',0),(201683,5603,'ro','Minim culori acest comunicat de presÄƒ',0),(201684,5603,'et','Minimaalne vÃ¤rvi see ajakirjandus',0),(201685,5603,'si','Najmanj barve to Press',0),(201686,5603,'ba','Minimal warna ini tekan',0),(201687,5603,'nl','Minimum kleuren dit Press',0),(201688,5603,'fi','VÃ¤hintÃ¤Ã¤n vÃ¤rit TÃ¤mÃ¤ paina',0),(201689,5603,'no','Minimum farger dette trykk',0),(201690,5603,'da','Minimum farver dette tryk',0),(201691,5603,'ko','ìµœì†Œ ìƒ‰ìƒì´ ë³´ë„',0),(201692,5603,'he','×ž×™× ×™×ž×•× ×¦×‘×¢×™× ×–×” ×œ×¢×™×ª×•× ×•×ª',0),(201693,5603,'el','Î¤Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î±Ï…Ï„ÏŒ Ï‡ÏÏŽÎ¼Î±Ï„Î± Ï„ÏÏ€Î¿Ï…',0),(201694,5603,'zh','æ­¤å°åˆ·æœ€å°é¢œè‰²\r\n',0),(201695,5603,'sv','Minimum fÃ¤rger detta tryck',0),(201696,5603,'it','Minimo questo colori stampa',0),(201697,5603,'tl','',0),(201698,5603,'th','&#3626;&#3637;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;&#3585;&#3604;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;',0),(201699,5603,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤‡à¤¸ à¤ªà¥à¤°à¥‡à¤¸ à¤°à¤‚à¤—',0),(201700,5603,'ms','Sekurang-kurangnya warna ini Seluar',0),(201701,5603,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† Ø£Ù„ÙˆØ§Ù† Ù‡Ø°Ø§ Ø§Ù„ØµØ­ÙÙŠ',0),(201702,5603,'fr','Minimum couleurs cela presse',0),(201703,5603,'jp','ã?“ã?®ãƒ—ãƒ¬ã‚¹ã?®æœ€å°?è‰²æ•°',0),(201704,5603,'pt','MÃ­nimo cores esta imprensa',0),(201705,5603,'ru','ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼ Ñ†Ð²ÐµÑ‚Ð° ÑÑ‚Ð¾ Ð¿Ñ€ÐµÑÑ',0),(201706,5603,'es','Colores MÃ­nimos para esta ImpresiÃ³n',0),(201707,5603,'de','Minimale Farben dies Presse',0),(201708,5603,'en','Minimum Colors this Press',0),(201709,5604,'is','',0),(201710,5604,'dr','ÙÙˆØª Ù…Ø±Ø¨Ø¹ ',0),(201711,5604,'pr','ÙÙˆØª Ù…Ø±Ø¨Ø¹ ',0),(201712,5604,'tr','Sq.Ft.',0),(201713,5604,'pl','StÃ³p kwadratowych.',0),(201714,5604,'bg','Sq.Ft.',0),(201715,5604,'ur','Ù…Ø±Ø¨Ø¹ ÙÙ¹ ÛÛ’ Û”',0),(201716,5604,'sr','Ð¡q.Ð¤Ñ‚.',0),(201717,5604,'vi','Sq.Ft.',0),(201718,5604,'af','Sq.Ft.',0),(201719,5604,'ro','Sq.Ft.',0),(201720,5604,'et','Sq.Ft.',0),(201721,5604,'si','Sq.Ft.',0),(201722,5604,'ba','Sq.Ft.',0),(201723,5604,'nl','Terrassen.',0),(201724,5604,'fi','Sq.Ft.',0),(201725,5604,'no','Sq.Ft.',0),(201726,5604,'da','Sq.Ft.',0),(201727,5604,'ko','Sq.Ftìž…ë‹ˆë‹¤.',0),(201728,5604,'he','Sq.Ft.',0),(201729,5604,'el','Sq.Ft.',0),(201730,5604,'zh','å¹³æ–¹å‘Ž\r\n',0),(201731,5604,'sv','Sq.Ft.',0),(201732,5604,'it','Sq.',0),(201733,5604,'tl','',0),(201734,5604,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3615;&#3640;&#3605;',0),(201735,5604,'hi','Sq.Ft.',0),(201736,5604,'ms','Sq.Ft.',0),(201737,5604,'ar','Ù‚Ø¯Ù… Ù…Ø±Ø¨Ø¹.',0),(201738,5604,'fr','Pi.ca.',0),(201739,5604,'jp','Sq.Ft.',0),(201740,5604,'pt','Sq. ft.',0),(201741,5604,'ru','Sq.Ft.',0),(201742,5604,'es','Pies Cuadrado',0),(201743,5604,'de','Sq.Ft.',0),(201744,5604,'en','Sq.Ft.',0),(201745,5605,'is','',0),(201746,5605,'dr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ø² Ø§Ù…Ø¶Ø§ Ù‡Ø§',0),(201747,5605,'pr','Ù‡ÙŠÚ† ÙƒØ¯Ø§Ù… Ø§Ø² Ø§Ù…Ø¶Ø§ Ù‡Ø§',0),(201748,5605,'tr','# Ä°mzalar',0),(201749,5605,'pl','# PodpisÃ³w',0),(201750,5605,'bg','# ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ¸',0),(201751,5605,'ur','# Ø¯Ø³ØªØ®Ø·',0),(201752,5605,'sr','# ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ°',0),(201753,5605,'vi','Sá»‘ Chá»¯ kÃ½',0),(201754,5605,'af','# Ondertekenaars',0),(201755,5605,'ro','# SemnÄƒturi',0),(201756,5605,'et','# Allkirjad',0),(201757,5605,'si','# Podpisov',0),(201758,5605,'ba','# Tanda tangan',0),(201759,5605,'nl','# Handtekeningen',0),(201760,5605,'fi','# Allekirjoitukset',0),(201761,5605,'no','# Signaturer',0),(201762,5605,'da','# Signaturer',0),(201763,5605,'ko','# ì„œëª…',0),(201764,5605,'he','# ×—×ª×™×ž×•×ª',0),(201765,5605,'el','# Î¥Ï€Î¿Î³ÏÎ±Ï†Î­Ï‚',0),(201766,5605,'zh','ï¼ƒç­¾å\r\n',0),(201767,5605,'sv','# Signaturer',0),(201768,5605,'it','# Firme',0),(201769,5605,'tl','',0),(201770,5605,'th','&#3621;&#3634;&#3618;&#3617;&#3639;&#3629;&#3594;&#3639;&#3656;&#3629;',0),(201771,5605,'hi','# à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°',0),(201772,5605,'ms','# Tandatangan',0),(201773,5605,'ar','# ØªÙˆØ§Ù‚ÙŠØ¹',0),(201774,5605,'fr','# Signatures',0),(201775,5605,'jp','ç½²å??ã?®æ•°',0),(201776,5605,'pt','# Assinaturas',0),(201777,5605,'ru','# ÐŸÐ¾Ð´Ð¿Ð¸ÑÐµÐ¹',0),(201778,5605,'es','# Firmas',0),(201779,5605,'de','-Signaturen',0),(201780,5605,'en','# Signatures',0),(201781,5606,'is','',0),(201782,5606,'dr','ØµÙØ­Ø§Øª  Ø¯Ø± Ù‡Ø± Ø§Ù…Ø¶Ø§Ø¡',0),(201783,5606,'pr','ØµÙØ­Ø§Øª  Ø¯Ø± Ù‡Ø± Ø§Ù…Ø¶Ø§Ø¡',0),(201784,5606,'tr','Sayfalar/SIG',0),(201785,5606,'pl','Strony/Sig',0),(201786,5606,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸/Sig',0),(201787,5606,'ur','ØµÙØ­Ø§Øª/Ø¢Ø®Ø±ÛŒ Ø¯Ù†',0),(201788,5606,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°/Ð¡Ð¸Ð³',0),(201789,5606,'vi','Trang/Sá»‘ tay',0),(201790,5606,'af','Bladsye/Sig',0),(201791,5606,'ro','Pagini/Sig',0),(201792,5606,'et','Lehed/Sig',0),(201793,5606,'si','Strani/Sig',0),(201794,5606,'ba','Halaman Sig',0),(201795,5606,'nl','Pagina\'s / Sig',0),(201796,5606,'fi','Sivut/Sig',0),(201797,5606,'no','Sider/Sig',0),(201798,5606,'da','Sider/signa',0),(201799,5606,'ko','íŽ˜ì´ì§€/ì‹œê·¸ë§ˆ',0),(201800,5606,'he','×¢×ž×•×“×™×/×¡×™×’',0),(201801,5606,'el','Î£ÎµÎ»Î¯Î´ÎµÏ‚/Sig',0),(201802,5606,'zh','é¡µ/ç­¾å\r\n',0),(201803,5606,'sv','Sidor/Sig',0),(201804,5606,'it','Pagine/Sig',0),(201805,5606,'tl','',0),(201806,5606,'th','&#3627;&#3609;&#3657;&#3634;/&#3626;&#3633;&#3597;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;',0),(201807,5606,'hi','à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚/Sig',0),(201808,5606,'ms','Muka surat/Sig',0),(201809,5606,'ar','Ø³ÙŠØ¬/ØµÙØ­Ø§Øª',0),(201810,5606,'fr','Pages/Sig',0),(201811,5606,'jp','ãƒšãƒ¼ã‚¸/ç½²å??',0),(201812,5606,'pt','PÃ¡ginas/Sig',0),(201813,5606,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†/Sig',0),(201814,5606,'es','PÃ¡ginas/Sig',0),(201815,5606,'de','Seiten/Sig',0),(201816,5606,'en','Pages/Sig',0),(201817,5607,'is','',0),(201818,5607,'dr','1 ',0),(201819,5607,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø±Ù†Ú¯Ù‡Ø§ Ø¬Ù‡Øª 1 ',0),(201820,5607,'tr','# 1 yan Renkler:',0),(201821,5607,'pl','# Kolorystyka strony 1:',0),(201822,5607,'bg','# Ð¦Ð²ÐµÑ‚Ð¾Ð²Ðµ ÑÑ‚Ñ€Ð°Ð½Ð° 1:',0),(201823,5607,'ur','# 1 Ú©ÛŒ Ø·Ø±Ù Ø±Ù†Ú¯:',0),(201824,5607,'sr','# Ð‘Ð¾Ñ˜Ðµ ÑÑ‚Ñ€Ð°Ð½Ð° 1:',0),(201825,5607,'vi','Sá»‘ máº§u máº·t 1:',0),(201826,5607,'af','# Kleure Kant 1',0),(201827,5607,'ro','# Culori partea 1:',0),(201828,5607,'et','# VÃ¤rvid esikÃ¼lge:',0),(201829,5607,'si','# Barve strani 1:',0),(201830,5607,'ba','# Warna samping 1:',0),(201831,5607,'nl','# Kleuren kant 1:',0),(201832,5607,'fi','# VÃ¤rit Side 1:',0),(201833,5607,'no','# Farger Side 1:',0),(201834,5607,'da','# Farver Side 1:',0),(201835,5607,'ko','# 1 ë©´ ìƒ‰ìƒ:',0),(201836,5607,'he','# ×¦×‘×¢×™× ×¦×“ 1:',0),(201837,5607,'el','# Î§ÏÏŽÎ¼Î±Ï„Î± Ï€Î»ÎµÏ…ÏÎ¬ 1:',0),(201838,5607,'zh','ï¼ƒé¢œè‰²ä¾§1ï¼š\r\n',0),(201839,5607,'sv','# FÃ¤rger sidan 1:',0),(201840,5607,'it','# Colori lato 1:',0),(201841,5607,'tl','',0),(201842,5607,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3626;&#3637;&#3604;&#3657;&#3634;&#3609; 1\n',0),(201843,5607,'hi','# 1 à¤•à¥€ à¤“à¤° à¤°à¤‚à¤—:',0),(201844,5607,'ms','# Warna Bahagian 1:',0),(201845,5607,'ar','# Ø£Ù„ÙˆØ§Ù† Ø§Ù„Ø¬Ø§Ù†Ø¨ 1:',0),(201846,5607,'fr','# Couleurs face 1 :',0),(201847,5607,'jp','ã‚µã‚¤ãƒ‰ï¼‘ã€€è‰²ã?®æ•°ï¼š',0),(201848,5607,'pt','# Cores lado 1:',0),(201849,5607,'ru','# Ð¦Ð²ÐµÑ‚Ð¾Ð² Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð° 1:',0),(201850,5607,'es','# Colores Lado 1:',0),(201851,5607,'de','# Farben Seite 1:',0),(201852,5607,'en','# Colors Side 1:',0),(201853,5608,'is','',0),(201854,5608,'dr','2 ',0),(201855,5608,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø±Ù†Ú¯Ù‡Ø§ Ø¬Ù‡Øª 2 ',0),(201856,5608,'tr','# 2 Side Renkler:',0),(201857,5608,'pl','# Strona 2 kolory:',0),(201858,5608,'bg','# Ð¦Ð²ÐµÑ‚Ð¾Ð²Ðµ ÑÑ‚Ñ€Ð°Ð½Ð° 2:',0),(201859,5608,'ur','# 2 Ú©ÛŒ Ø·Ø±Ù Ø±Ù†Ú¯:',0),(201860,5608,'sr','# Ð‘Ð¾Ñ˜Ðµ ÑÑ‚Ñ€Ð°Ð½Ð° 2:',0),(201861,5608,'vi','Sá»‘ máº§u máº·t 2:',0),(201862,5608,'af','# Kleure Kant 2',0),(201863,5608,'ro','# Culori partea 2:',0),(201864,5608,'et','# VÃ¤rvid pool 2:',0),(201865,5608,'si','# Barve strani 2:',0),(201866,5608,'ba','# Warna sisi 2:',0),(201867,5608,'nl','# Kleuren kant 2:',0),(201868,5608,'fi','# VÃ¤rit, 2-puoli:',0),(201869,5608,'no','# Farger Side 2:',0),(201870,5608,'da','# Farver Side 2:',0),(201871,5608,'ko','# 2 ë©´ ìƒ‰ìƒ:',0),(201872,5608,'he','# ×¦×‘×¢×™× ×¦×“ 2:',0),(201873,5608,'el','# Î§ÏÏŽÎ¼Î±Ï„Î± Ï€Î»ÎµÏ…ÏÎ¬ 2:',0),(201874,5608,'zh','ï¼ƒé¢œè‰²ä¾§2ï¼š\r\n',0),(201875,5608,'sv','# FÃ¤rger sidan 2:',0),(201876,5608,'it','# Colori lato 2:',0),(201877,5608,'tl','',0),(201878,5608,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3626;&#3637;&#3604;&#3657;&#3634;&#3609; 2',0),(201879,5608,'hi','# 2 à¤•à¥€ à¤“à¤° à¤°à¤‚à¤—:',0),(201880,5608,'ms','# Warna sampingan 2:',0),(201881,5608,'ar','# Ø£Ù„ÙˆØ§Ù† Ø§Ù„Ø¬Ø§Ù†Ø¨ 2:',0),(201882,5608,'fr','# Couleurs face 2 :',0),(201883,5608,'jp','ã‚µã‚¤ãƒ‰ï¼’ã€€è‰²ã?®æ•°ï¼š',0),(201884,5608,'pt','# Cores lado 2:',0),(201885,5608,'ru','# Ð¦Ð²ÐµÑ‚Ð¾Ð² Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð° 2:',0),(201886,5608,'es','# Colres Lado 2:',0),(201887,5608,'de','# Farben Seite 2:',0),(201888,5608,'en','# Colors Side 2:',0),(201889,5609,'is','',0),(201890,5609,'dr','ØµÙØ­Ø§Øª  Ø¯Ø± Ù‡Ø± Ø§Ù…Ø¶Ø§Ø¡',0),(201891,5609,'pr','ØµÙØ­Ø§Øª  Ø¯Ø± Ù‡Ø± Ø§Ù…Ø¶Ø§Ø¡',0),(201892,5609,'tr','Sayfalar/SIG',0),(201893,5609,'pl','Strony/Sig',0),(201894,5609,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸/Sig',0),(201895,5609,'ur','ØµÙØ­Ø§Øª/Ø¢Ø®Ø±ÛŒ Ø¯Ù†',0),(201896,5609,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°/Ð¡Ð¸Ð³',0),(201897,5609,'vi','Trang/Sá»‘ tay',0),(201898,5609,'af','Bladsye/Sig',0),(201899,5609,'ro','Pagini/Sig',0),(201900,5609,'et','Lehed/Sig',0),(201901,5609,'si','Strani/Sig',0),(201902,5609,'ba','Halaman Sig',0),(201903,5609,'nl','Pagina\'s / Sig',0),(201904,5609,'fi','Sivut/Sig',0),(201905,5609,'no','Sider/Sig',0),(201906,5609,'da','Sider/signa',0),(201907,5609,'ko','íŽ˜ì´ì§€/ì‹œê·¸ë§ˆ',0),(201908,5609,'he','×¢×ž×•×“×™×/×¡×™×’',0),(201909,5609,'el','Î£ÎµÎ»Î¯Î´ÎµÏ‚/Sig',0),(201910,5609,'zh','é¡µ/ç­¾å\r\n',0),(201911,5609,'sv','Sidor/Sig',0),(201912,5609,'it','Pagine/Sig',0),(201913,5609,'tl','',0),(201914,5609,'th','&#3627;&#3609;&#3657;&#3634;/&#3626;&#3633;&#3597;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;',0),(201915,5609,'hi','à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚/Sig',0),(201916,5609,'ms','Muka surat/Sig',0),(201917,5609,'ar','Ø³ÙŠØ¬/ØµÙØ­Ø§Øª',0),(201918,5609,'fr','Pages/Sig',0),(201919,5609,'jp','ãƒšãƒ¼ã‚¸/ç½²å??',0),(201920,5609,'pt','PÃ¡ginas/Sig',0),(201921,5609,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†/Sig',0),(201922,5609,'es','PÃ¡ginas/Sig',0),(201923,5609,'de','Seiten/Sig',0),(201924,5609,'en','Pages/Sig',0),(201925,5610,'is','',0),(201926,5610,'dr','Ø§Ù…Ø¶Ø§Ø¡ Ù‡Ø§',0),(201927,5610,'pr','Ø§Ù…Ø¶Ø§Ø¡ Ù‡Ø§',0),(201928,5610,'tr','Ä°mzalar',0),(201929,5610,'pl','Podpisy',0),(201930,5610,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ¸',0),(201931,5610,'ur','Ø¯Ø³ØªØ®Ø·',0),(201932,5610,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ¸',0),(201933,5610,'vi','Chá»¯ kÃ½',0),(201934,5610,'af','Hantekeninge',0),(201935,5610,'ro','SemnÄƒturi',0),(201936,5610,'et','Allkirjad',0),(201937,5610,'si','Podpisi',0),(201938,5610,'ba','Tanda tangan',0),(201939,5610,'nl','Handtekeningen',0),(201940,5610,'fi','Allekirjoitukset',0),(201941,5610,'no','Signaturer',0),(201942,5610,'da','Signaturer',0),(201943,5610,'ko','ì„œëª…',0),(201944,5610,'he','×—×ª×™×ž×•×ª',0),(201945,5610,'el','Î¥Ï€Î¿Î³ÏÎ±Ï†Î­Ï‚',0),(201946,5610,'zh','ç­¾å\r\n',0),(201947,5610,'sv','Signaturer',0),(201948,5610,'it','Firme',0),(201949,5610,'tl','',0),(201950,5610,'th','&#3621;&#3634;&#3618;&#3648;&#3595;&#3655;&#3609;',0),(201951,5610,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤°à¥‡à¤‚',0),(201952,5610,'ms','Tandatangan',0),(201953,5610,'ar','Ø§Ù„ØªÙˆØ§Ù‚ÙŠØ¹',0),(201954,5610,'fr','Signatures',0),(201955,5610,'jp','ç½²å??',0),(201956,5610,'pt','Assinaturas',0),(201957,5610,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ¸',0),(201958,5610,'es','Firmas',0),(201959,5610,'de','Signaturen',0),(201960,5610,'en','Signatures',0),(201961,5611,'is','',0),(201962,5611,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚Ø³Ù…Øª Ù‡Ø§',0),(201963,5611,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚Ø³Ù…Øª Ù‡Ø§',0),(201964,5611,'tr','ParÃ§alar eklemek',0),(201965,5611,'pl','DodaÄ‡ czÄ™Å›ci',0),(201966,5611,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‡Ð°ÑÑ‚Ð¸',0),(201967,5611,'ur','Ø­ØµÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(201968,5611,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÐµÐ³Ð¼ÐµÐ½Ð°Ñ‚Ð°',0),(201969,5611,'vi','ThÃªm Pháº§n',0),(201970,5611,'af','Onderdele Byvoeg',0),(201971,5611,'ro','Adauga piese',0),(201972,5611,'et','Lisa osad',0),(201973,5611,'si','PoveÄati dele',0),(201974,5611,'ba','Tambahkan bagian',0),(201975,5611,'nl','Delen toevoegen',0),(201976,5611,'fi','LisÃ¤Ã¤ osia',0),(201977,5611,'no','Legge til deler',0),(201978,5611,'da','TilfÃ¸je dele',0),(201979,5611,'ko','ë¶€í’ˆ ì¶”ê°€',0),(201980,5611,'he','×”×•×¡×£ ×—×œ×§×™×',0),(201981,5611,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î± Î¼Î­ÏÎ·',0),(201982,5611,'zh','å¢žåŠ éƒ¨ä»¶\r\n',0),(201983,5611,'sv','LÃ¤gga till delar',0),(201984,5611,'it','Aggiungere parti',0),(201985,5611,'tl','',0),(201986,5611,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3656;&#3623;&#3609;',0),(201987,5611,'hi','à¤­à¤¾à¤—à¥‹à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(201988,5611,'ms','Menambah bahagian-bahagian',0),(201989,5611,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ø¬Ø²Ø§Ø¡',0),(201990,5611,'fr','Ajouter des composants',0),(201991,5611,'jp','éƒ¨å“?ã?®è¿½åŠ ',0),(201992,5611,'pt','Adicionar peÃ§as',0),(201993,5611,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‡Ð°ÑÑ‚ÐµÐ¹',0),(201994,5611,'es','Agregar Partes',0),(201995,5611,'de','HinzufÃ¼gen von Abschnitten',0),(201996,5611,'en','Add Parts',0),(201997,5612,'is','',0),(201998,5612,'dr','Ø¹Ù…Ù„ÙƒØ±Ø¯  ÙØ¹Ù„ÙŠ  Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª',0),(201999,5612,'pr','Ø¹Ù…Ù„ÙƒØ±Ø¯  ÙØ¹Ù„ÙŠ  Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª',0),(202000,5612,'tr','Servis sipariÅŸleri iÃ§in geÃ§erli Ã§alÄ±ÅŸma',0),(202001,5612,'pl','BieÅ¼Ä…ce prace dla zleceÅ„ serwisowych',0),(202002,5612,'bg','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(202003,5612,'ur','Ø­Ø§Ù„ÛŒÛ Ú©Ø§Ù… Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(202004,5612,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ñ€Ð°Ð´ Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(202005,5612,'vi','Hiá»‡n Ä‘ang lÃ m nhá»¯ng Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥',0),(202006,5612,'af','Huidige Werk vir Diens Bestellings',0),(202007,5612,'ro','Curent de lucru pentru comenzi de Service',0),(202008,5612,'et','Praegune tÃ¶Ã¶ hooldustellimuste',0),(202009,5612,'si','Sedanje delo za servisne naloge',0),(202010,5612,'ba','Pekerjaan Sekarang untuk Layanan Pesanan',0),(202011,5612,'nl','Huidige werk voor serviceorders',0),(202012,5612,'fi','Nykyinen tyÃ¶ huoltotilauksille',0),(202013,5612,'no','NÃ¥vÃ¦rende arbeid for serviceordrer',0),(202014,5612,'da','NuvÃ¦rende arbejde for serviceordrer',0),(202015,5612,'ko','ì„œë¹„ìŠ¤ ëª…ë ¹ì— ëŒ€ í•œ í˜„ìž¬ ìž‘ì—…',0),(202016,5612,'he','×”×¢×‘×•×“×” ×”× ×•×›×—×™×ª ×¢×‘×•×¨ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(202017,5612,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(202018,5612,'zh','å½“å‰å·¥ä½œçš„æœåŠ¡ä»¤\r\n',0),(202019,5612,'sv','Nuvarande arbete fÃ¶r serviceorder',0),(202020,5612,'it','Lavori in corso per ordini di servizio',0),(202021,5612,'tl','',0),(202022,5612,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3585;&#3635;&#3621;&#3633;&#3591;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;',0),(202023,5612,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶',0),(202024,5612,'ms','Semasa kerja-kerja Perkhidmatan Pesanan',0),(202025,5612,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø­Ø§Ù„ÙŠ Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(202026,5612,'fr','Travaux en cours pour les commandes de Service',0),(202027,5612,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®ç?¾åœ¨ã?®ä½œæ¥­',0),(202028,5612,'pt','Trabalho atual para ordens de serviÃ§o',0),(202029,5612,'ru','Ð¢ÐµÐºÑƒÑ‰ÐµÐ¹ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð´Ð»Ñ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(202030,5612,'es','Trabajo Actual para Pedidos de Servicios',0),(202031,5612,'de','Aktuelle Arbeiten fÃ¼r ServiceauftrÃ¤ge',0),(202032,5612,'en','Current Work for Service Orders',0),(202033,5613,'is','',0),(202034,5613,'dr','E',0),(202035,5613,'pr','E',0),(202036,5613,'tr','E',0),(202037,5613,'pl','E',0),(202038,5613,'bg','E',0),(202039,5613,'ur','E',0),(202040,5613,'sr','Ð•',0),(202041,5613,'vi','E',0),(202042,5613,'af','E',0),(202043,5613,'ro','E',0),(202044,5613,'et','E',0),(202045,5613,'si','E',0),(202046,5613,'ba','E',0),(202047,5613,'nl','E',0),(202048,5613,'fi','E',0),(202049,5613,'no','E',0),(202050,5613,'da','E',0),(202051,5613,'ko','E',0),(202052,5613,'he','E',0),(202053,5613,'el','Î•',0),(202054,5613,'zh','E\r\n',0),(202055,5613,'sv','E',0),(202056,5613,'it','E',0),(202057,5613,'tl','',0),(202058,5613,'th','E',0),(202059,5613,'hi','à¤ˆ',0),(202060,5613,'ms','E',0),(202061,5613,'ar','Ù‡',0),(202062,5613,'fr','E',0),(202063,5613,'jp','E',0),(202064,5613,'pt','E',0),(202065,5613,'ru','E',0),(202066,5613,'es','E',0),(202067,5613,'de','E',0),(202068,5613,'en','E',0),(202069,5614,'is','',0),(202070,5614,'dr','/ Ù¾Ø§ÙŠØ§Ù† ',0),(202071,5614,'pr','Ø´Ø±ÙˆØ¹ / Ù¾Ø§ÙŠØ§Ù† ',0),(202072,5614,'tr','Start / Stop',0),(202073,5614,'pl','Start / Stop',0),(202074,5614,'bg','Ð¡Ñ‚Ð°Ñ€Ñ‚ / ÑÑ‚Ð¾Ð¿',0),(202075,5614,'ur','Ø´Ø±ÙˆØ¹ / Ø±ÙˆÚ©ÛŒÚº',0),(202076,5614,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚Ð°ÑšÐµ / Ð·Ð°ÑƒÑÑ‚Ð°Ð²Ð¸',0),(202077,5614,'vi','Báº¯t Ä‘áº§u / Dá»«ng',0),(202078,5614,'af','Begin / Stop',0),(202079,5614,'ro','Start / Stop',0),(202080,5614,'et','Start / Stop',0),(202081,5614,'si','Start / Stop',0),(202082,5614,'ba','Start / Stop',0),(202083,5614,'nl','Start / Stop',0),(202084,5614,'fi','Start / Stop',0),(202085,5614,'no','Start / stopp',0),(202086,5614,'da','Start / Stop',0),(202087,5614,'ko','ì‹œìž‘/ì¤‘ì§€',0),(202088,5614,'he','×œ×”×ª×—×™×œ / ×œ×”×¤×¡×™×§',0),(202089,5614,'el','ÎˆÎ½Î±ÏÎ¾Î· / Î´Î¹Î±ÎºÎ¿Ï€Î®',0),(202090,5614,'zh','å¯åŠ¨/åœæ­¢\r\n',0),(202091,5614,'sv','Starta / stoppa',0),(202092,5614,'it','Start / Stop',0),(202093,5614,'tl','',0),(202094,5614,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;/&#3627;&#3618;&#3640;&#3604;',0),(202095,5614,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤•à¤°à¥‡à¤‚ /',0),(202096,5614,'ms','Mula / berhenti',0),(202097,5614,'ar','Ø¨Ø¯Ø¡/Ø¥ÙŠÙ‚Ø§Ù',0),(202098,5614,'fr','Start / Stop',0),(202099,5614,'jp','é–‹å§‹/å?œæ­¢',0),(202100,5614,'pt','Iniciar / parar',0),(202101,5614,'ru','Ð¡Ñ‚Ð°Ñ€Ñ‚ / ÑÑ‚Ð¾Ð¿',0),(202102,5614,'es','Comenzar / Detener',0),(202103,5614,'de','Start / Stopp',0),(202104,5614,'en','Start / Stop',0),(202105,5615,'is','',0),(202106,5615,'dr','Ø²Ù…Ø§Ù† Ø«Ø¨Øª Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(202107,5615,'pr','Ø²Ù…Ø§Ù† Ø«Ø¨Øª Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(202108,5615,'tr','Servis sipariÅŸleri iÃ§in zaman giriÅŸi',0),(202109,5615,'pl','Czas wejÅ›cia dla zleceÅ„ serwisowych',0),(202110,5615,'bg','Ð’ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð²Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(202111,5615,'ur','ÙˆÙ‚Øª Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’',0),(202112,5615,'sr','Ð£Ð½Ð¾Ñ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(202113,5615,'vi','Nháº­p Thá»i Gian Cho ÄÆ¡n HÃ ng Dá»‹ch Vá»¥',0),(202114,5615,'af','Tydinskrywing vir Diensbestellings',0),(202115,5615,'ro','Timp de intrare pentru comenzi de Service',0),(202116,5615,'et','RÃ¼hmatreeningutes hooldustellimuste',0),(202117,5615,'si','Vnos Äasa za servisne naloge',0),(202118,5615,'ba','Catatan waktu untuk layanan pesanan',0),(202119,5615,'nl','Tijd vermelding voor serviceorders',0),(202120,5615,'fi','AikamerkintÃ¤ huoltotilauksille',0),(202121,5615,'no','TidsoppfÃ¸ring for serviceordrer',0),(202122,5615,'da','Tid posten for serviceordrer',0),(202123,5615,'ko','ì„œë¹„ìŠ¤ ì˜¤ë”ì— ëŒ€ í•œ ì‹œê°„ í•­ëª©',0),(202124,5615,'he','×¢×¨×š ×”×–×ž×Ÿ ×¢×‘×•×¨ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(202125,5615,'el','Î§ÏÏŒÎ½Î¿Ï‚ Î­Î½Î±ÏÎ¾Î·Ï‚ Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(202126,5615,'zh','ä¸ºæœåŠ¡è®¢å•æ—¶é—´è¾“å…¥\r\n',0),(202127,5615,'sv','Tid posten fÃ¶r serviceorder',0),(202128,5615,'it','Entrata di tempo per gli ordini di servizio',0),(202129,5615,'tl','',0),(202130,5615,'th','&#3648;&#3623;&#3621;&#3634;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(202131,5615,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤®à¤¯ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(202132,5615,'ms','Masa kemasukan bagi pesanan Perkhidmatan',0),(202133,5615,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„ÙˆÙ‚Øª Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(202134,5615,'fr','EntrÃ©e de temps pour les commandes de Service',0),(202135,5615,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®å…¥åŠ›æ™‚é–“',0),(202136,5615,'pt','Entrada de tempo de ordens de serviÃ§o',0),(202137,5615,'ru','Ð’Ð²Ð¾Ð´ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð´Ð»Ñ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(202138,5615,'es','Entrada de Tiempo para Ordenes de Servicio',0),(202139,5615,'de','Personalzeiterfassung fÃ¼r ServiceauftrÃ¤ge',0),(202140,5615,'en','Time Entry for Service Orders',0),(202141,5616,'is','',0),(202142,5616,'dr','V',0),(202143,5616,'pr','V',0),(202144,5616,'tr','V',0),(202145,5616,'pl','V',0),(202146,5616,'bg','V',0),(202147,5616,'ur','V',0),(202148,5616,'sr','Ð’',0),(202149,5616,'vi','V',0),(202150,5616,'af','V',0),(202151,5616,'ro','V',0),(202152,5616,'et','V',0),(202153,5616,'si','PROTI',0),(202154,5616,'ba','V',0),(202155,5616,'nl','V',0),(202156,5616,'fi','V',0),(202157,5616,'no','V',0),(202158,5616,'da','V',0),(202159,5616,'ko','V',0),(202160,5616,'he','V',0),(202161,5616,'el','V',0),(202162,5616,'zh','V\r\n',0),(202163,5616,'sv','V',0),(202164,5616,'it','V',0),(202165,5616,'tl','',0),(202166,5616,'th','V',0),(202167,5616,'hi','V',0),(202168,5616,'ms','V',0),(202169,5616,'ar','V',0),(202170,5616,'fr','V',0),(202171,5616,'jp','C',0),(202172,5616,'pt','V',0),(202173,5616,'ru','V',0),(202174,5616,'es','V',0),(202175,5616,'de','V',0),(202176,5616,'en','V',0),(202177,5617,'is','',0),(202178,5617,'dr','ÙƒØ§Ø±Ú¯Ø±',0),(202179,5617,'pr','ÙƒØ§Ø±Ú¯Ø±',0),(202180,5617,'tr','Ä°ÅŸÃ§i',0),(202181,5617,'pl','Pracownik',0),(202182,5617,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº',0),(202183,5617,'ur','Ú©Ø§Ø±Ú©Ù†',0),(202184,5617,'sr','Ð Ð°Ð´Ð½Ð¸Ðº',0),(202185,5617,'vi','CÃ´ng nhÃ¢n',0),(202186,5617,'af','Werker',0),(202187,5617,'ro','LucrÄƒtor',0),(202188,5617,'et','TÃ¶Ã¶line',0),(202189,5617,'si','Delavec',0),(202190,5617,'ba','Pekerja',0),(202191,5617,'nl','Werknemer',0),(202192,5617,'fi','TyÃ¶ntekijÃ¤',0),(202193,5617,'no','Arbeideren',0),(202194,5617,'da','Arbejdstager',0),(202195,5617,'ko','ìž‘ì—…ìž',0),(202196,5617,'he','×”×¢×•×‘×“',0),(202197,5617,'el','Î•ÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚',0),(202198,5617,'zh','å·¥äºº\r\n',0),(202199,5617,'sv','Arbetstagaren',0),(202200,5617,'it','Operaio',0),(202201,5617,'tl','',0),(202202,5617,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(202203,5617,'hi','à¤•à¤¾à¤°à¥à¤¯à¤•à¤°à¥à¤¤à¤¾',0),(202204,5617,'ms','Pekerja',0),(202205,5617,'ar','Ø¹Ø§Ù…Ù„',0),(202206,5617,'fr','Travailleur',0),(202207,5617,'jp','ä½œæ¥­è€…',0),(202208,5617,'pt','Trabalhador',0),(202209,5617,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº',0),(202210,5617,'es','Trabajador',0),(202211,5617,'de','Arbeiter',0),(202212,5617,'en','Worker',0),(202213,5618,'is','',0),(202214,5618,'dr','Ø§ØªÙˆÙ…Ø§ØªÙŠÙƒ Ù‚Ø¨Ù„ Ø§Ø² Ø¨Ø³ØªÙ† Ø³Ø§Ù„',0),(202215,5618,'pr','Ø§ØªÙˆÙ…Ø§ØªÙŠÙƒ Ù‚Ø¨Ù„ Ø§Ø² Ø¨Ø³ØªÙ† Ø³Ø§Ù„',0),(202216,5618,'tr','YÄ±lÄ± kapat otomatik',0),(202217,5618,'pl','Automatyczne przez blisko rok',0),(202218,5618,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¾Ñ‚ Ð±Ð»Ð¸Ð·Ð¾ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(202219,5618,'ur','Ù‚Ø±ÛŒØ¨ÛŒ Ø³Ø§Ù„ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø®ÙˆØ¯ Ú©Ø§Ø±',0),(202220,5618,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð·Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(202221,5618,'vi','Tá»± Äá»™ng Khi NÄƒm KhÃ³a Sá»•',0),(202222,5618,'af','Outomatiese deur sluit jaar',0),(202223,5618,'ro','Automate de aproape an',0),(202224,5618,'et','Automaatne Sule aasta vÃµrra',0),(202225,5618,'si','Samodejno zapri leto',0),(202226,5618,'ba','Otomatis menutup tahun',0),(202227,5618,'nl','Automatische door jaar afsluiten',0),(202228,5618,'fi','Automaattinen Sulje vuosi',0),(202229,5618,'no','Automatisk av Lukk Ã¥r',0),(202230,5618,'da','Automatisk af tÃ¦t Ã¥r',0),(202231,5618,'ko','ìžë™ ë‹«ê¸° ì—°ë„ë³„',0),(202232,5618,'he','××•×˜×•×ž×˜×™ ×œ×¤×™ ×©× ×” ×§×¨×•×‘×™×',0),(202233,5618,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· Î±Ï€ÏŒ Ï„Î¿Î½ ÎºÎ»ÎµÎ¯ÏƒÎ¹Î¼Î¿ Î­Ï„Î¿Ï…Ï‚',0),(202234,5618,'zh','æŒ‰å¹´è‡ªåŠ¨å…³é—­\r\n',0),(202235,5618,'sv','Automatisk nÃ¤ra Ã¥r',0),(202236,5618,'it','Automatico di chiusura anno',0),(202237,5618,'tl','',0),(202238,5618,'th','&#3611;&#3636;&#3604;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;&#3648;&#3617;&#3639;&#3656;&#3629;&#3626;&#3636;&#3657;&#3609;&#3611;&#3637;',0),(202239,5618,'hi','à¤¸à¥à¤µà¤¤: à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚ à¤µà¤°à¥à¤· à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(202240,5618,'ms','Automatik tutup tahun',0),(202241,5618,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠ Ø¨Ø¥ØºÙ„Ø§Ù‚ Ø§Ù„Ø³Ù†Ø©',0),(202242,5618,'fr','Automatique de clÃ´turer l\'exercice',0),(202243,5618,'jp','çµ‚äº†æ¸ˆä¼šè¨ˆå¹´åº¦åˆ¥è‡ªå‹•',0),(202244,5618,'pt','AutomÃ¡tico pelo prÃ³ximo ano',0),(202245,5618,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ°Ñ, Ð·Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ Ð³Ð¾Ð´',0),(202246,5618,'es','Automatico por Cerrar Ejercicio',0),(202247,5618,'de','Automatische schlieÃŸen Jahr',0),(202248,5618,'en','Automatic by Close Year',0),(202249,5619,'is','',0),(202250,5619,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ø³ØªÙ‡ Ø´Ø¯ ',0),(202251,5619,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ø³ØªÙ‡ Ø´Ø¯ ',0),(202252,5619,'tr','BaÅŸarÄ±yla kapatÄ±ldÄ±',0),(202253,5619,'pl','PomyÅ›lnie zamkniÄ™te',0),(202254,5619,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(202255,5619,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(202256,5619,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(202257,5619,'vi','KhÃ³a sá»• thÃ nh cÃ´ng',0),(202258,5619,'af','Suksesvol Gesluit',0),(202259,5619,'ro','ÃŽnchis cu succes',0),(202260,5619,'et','Sulgemine oli edukas',0),(202261,5619,'si','UspeÅ¡no zakljuÄila',0),(202262,5619,'ba','Ditutup berhasil',0),(202263,5619,'nl','Gesloten met succes',0),(202264,5619,'fi','Sulkeminen onnistui',0),(202265,5619,'no','Lukket',0),(202266,5619,'da','Lukket med succes',0),(202267,5619,'ko','ì„±ê³µì ìœ¼ë¡œ ì¢…ë£Œ',0),(202268,5619,'he','× ×¡×’×¨×” ×‘×”×¦×œ×—×”',0),(202269,5619,'el','ÎˆÎºÎ»ÎµÎ¹ÏƒÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(202270,5619,'zh','æˆåŠŸå…³é—­\r\n',0),(202271,5619,'sv','StÃ¤ngt framgÃ¥ngsrikt',0),(202272,5619,'it','Chiusa con successo',0),(202273,5619,'tl','',0),(202274,5619,'th','&#3611;&#3636;&#3604;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(202275,5619,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤‚à¤¦ à¤¹à¥‹',0),(202276,5619,'ms','Berjaya ditutup',0),(202277,5619,'ar','Ø£Ù‚ÙÙ„ Ø¨Ù†Ø¬Ø§Ø­',0),(202278,5619,'fr','FermÃ© avec succÃ¨s',0),(202279,5619,'jp','é–‰ã‚?ã?¾ã?—ã?Ÿ',0),(202280,5619,'pt','Encerrado com sucesso',0),(202281,5619,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ð¾',0),(202282,5619,'es','Cerrado Exitosamente',0),(202283,5619,'de','Erfolgreich abgeschlossen',0),(202284,5619,'en','Closed Successfully',0),(202285,5620,'is','',0),(202286,5620,'dr','Ø¨Ø³ØªÙ†  Ø¯ÙˆØ±Ù‡',0),(202287,5620,'pr','Ø¨Ø³ØªÙ†  Ø¯ÙˆØ±Ù‡',0),(202288,5620,'tr','Kapatma dÃ¶nemi',0),(202289,5620,'pl','ZamknÄ…Ä‡ okres',0),(202290,5620,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(202291,5620,'ur','Ø¯ÙˆØ± Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº',0),(202292,5620,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(202293,5620,'vi','Ká»³ KhÃ³a sá»•',0),(202294,5620,'af','Periode Sluit',0),(202295,5620,'ro','Inchide perioada',0),(202296,5620,'et','Sulge periood',0),(202297,5620,'si','Zaprite obdobje',0),(202298,5620,'ba','Menutup periode',0),(202299,5620,'nl','Sluit periode',0),(202300,5620,'fi','Sulje kausi',0),(202301,5620,'no','Lukk periode',0),(202302,5620,'da','Luk periode',0),(202303,5620,'ko','ê¸°ê°„ ì¢…ë£Œ',0),(202304,5620,'he','×¡×’×™×¨×ª ×”×ª×§×•×¤×”',0),(202305,5620,'el','ÎšÎ»ÎµÎ¯ÏƒÎ¹Î¼Î¿ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(202306,5620,'zh','å…³é—­æœŸé—´\r\n',0),(202307,5620,'sv','StÃ¤ng Period',0),(202308,5620,'it','Chiudere il periodo',0),(202309,5620,'tl','',0),(202310,5620,'th','&#3611;&#3636;&#3604;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(202311,5620,'hi','à¤…à¤µà¤§à¤¿ à¤•à¥‹ à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(202312,5620,'ms','Tutup tempoh',0),(202313,5620,'ar','Ø¥ØºÙ„Ø§Ù‚ Ø§Ù„ÙØªØ±Ø©',0),(202314,5620,'fr','Fermer pÃ©riode',0),(202315,5620,'jp','é–‰ã‚?æœŸé–“',0),(202316,5620,'pt','Fechar perÃ­odo',0),(202317,5620,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(202318,5620,'es','Cerrar PerÃ­odo',0),(202319,5620,'de','Zeitraum zu schlieÃŸen',0),(202320,5620,'en','Close Period',0),(202321,5621,'is','',0),(202322,5621,'dr','Ø¨Ø³ØªÙ† Ø³Ø§Ù„ Ø¨Ø±Ø§ÙŠ',0),(202323,5621,'pr','Ø¨Ø³ØªÙ† Ø³Ø§Ù„ Ø¨Ø±Ø§ÙŠ',0),(202324,5621,'tr','YÄ±l iÃ§in yakÄ±n',0),(202325,5621,'pl','Blisko rok',0),(202326,5621,'bg','Ð‘Ð»Ð¸Ð·Ð¾ Ð³Ð¾Ð´Ð¸Ð½Ð° Ð·Ð°',0),(202327,5621,'ur','Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ Ø¨Ù†Ø¯',0),(202328,5621,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð·Ð°',0),(202329,5621,'vi','NÄƒm KhÃ³a sá»• cho',0),(202330,5621,'af','Sluit Jaar vir',0),(202331,5621,'ro','ÃŽnchide an pentru',0),(202332,5621,'et','Sule aasta',0),(202333,5621,'si','Zapri leto za',0),(202334,5621,'ba','Menutup tahun untuk',0),(202335,5621,'nl','Sluiten jaar voor',0),(202336,5621,'fi','Sulje vuosi',0),(202337,5621,'no','Lukk Ã¥r',0),(202338,5621,'da','Lukke Ã¥r for',0),(202339,5621,'ko','ì˜¬í•´ë¥¼ ë‹«ìŠµë‹ˆë‹¤',0),(202340,5621,'he','×¡×•×’×¨×™× ×©× ×”',0),(202341,5621,'el','ÎšÎ»ÎµÎ¯ÏƒÎµÎ¹ Î­Ï„Î¿Ï‚ Î³Î¹Î±',0),(202342,5621,'zh','è¿‘ä¸€å¹´\r\n',0),(202343,5621,'sv','StÃ¤ng Ã¥r fÃ¶r',0),(202344,5621,'it','Chiudere l\'anno per',0),(202345,5621,'tl','',0),(202346,5621,'th','&#3611;&#3636;&#3604;&#3611;&#3637;&#3586;&#3629;&#3591;',0),(202347,5621,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(202348,5621,'ms','Tutup tahun bagi',0),(202349,5621,'ar','Ø§Ù„Ø³Ù†Ø© Ù„Ø¥ØºÙ„Ø§Ù‚',0),(202350,5621,'fr','ClÃ´ture de l\'annÃ©e pour',0),(202351,5621,'jp','ã?“ã?®ä¼šè¨ˆå¹´åº¦ã‚’é–‰ã‚?ã‚‹',0),(202352,5621,'pt','Fechar o ano para',0),(202353,5621,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ Ð³Ð¾Ð´ Ð´Ð»Ñ',0),(202354,5621,'es','Cerrar AÃ±o para',0),(202355,5621,'de','SchlieÃŸen Jahr fÃ¼r',0),(202356,5621,'en','Close Year for',0),(202357,5622,'is','',0),(202358,5622,'dr','Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø¨Ø³ØªÙ†  ÙŠÙƒ Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ Ø§Ù†Ø¨Ø§Ø´ØªÙ‡ Ø§ÙŠØ¬Ø§Ø¯ Ø´ÙˆØ¯ ',0),(202359,5622,'pr','Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø¨Ø³ØªÙ†  ÙŠÙƒ Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ Ø§Ù†Ø¨Ø§Ø´ØªÙ‡ Ø§ÙŠØ¬Ø§Ø¯ Ø´ÙˆØ¯ ',0),(202360,5622,'tr','HesabÄ±nÄ±zÄ± kapatmadan Ã¶nce bir yedek AkÃ§eye Ã–nckeki tipi oluÅŸturmanÄ±z gerekir',0),(202361,5622,'pl','NaleÅ¼y utworzyÄ‡ typ wstrzymanych dochodÃ³w konta przed zamkniÄ™ciem',0),(202362,5622,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ñ‚Ðµ Ð½ÐµÑ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° Ñ‚Ð¸Ð¿ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¿Ñ€ÐµÐ´Ð¸ Ð·Ð°Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ',0),(202363,5622,'ur','Ø§ÛŒÚ© Ø¢Ù…Ø¯Ù†ÛŒ Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾ÛŒ Ù‚Ø³Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³Û’ Ù‚Ø¨Ù„ Ø¨Ù†Ø¯ Ø¨Ù†Ø§Ù†Û’ Ú†Ø§ÛÛŒÛ’',0),(202364,5622,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð½ÐµÑ€Ð°ÑÐ¿Ð¾Ñ€ÐµÑ’ÐµÐ½Ðµ Ñ‚Ð¸Ð¿ ÐºÐ¾Ð½Ñ‚Ð° Ð¿Ñ€Ðµ Ð·Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐ°',0),(202365,5622,'vi','Pháº£i táº¡o Loáº¡i TK Lá»£i Nhuáº­n ChÆ°a PhÃ¢n Bá»• trÆ°á»›c khi khÃ³a sá»•',0),(202366,5622,'af','Moet skep \'n behou verdienste tipe rekening voor SLUITING',0),(202367,5622,'ro','Trebuie sÄƒ creaÅ£i un tip de pÄƒstrat cÃ¢ÅŸtigurile cont Ã®nainte de Ã®nchiderea',0),(202368,5622,'et','Tuleb luua jaotamata kasumi tÃ¼Ã¼p konto enne sulgemist',0),(202369,5622,'si','Morate ustvariti vrsto zadrÅ¾ani dobiÄek raÄun pred zaprtjem',0),(202370,5622,'ba','Harus membuat sebagai laba ditahan jenis Account sebelum penutupan',0),(202371,5622,'nl','Een behouden winst type Account vÃ³Ã³r sluiten moet maken',0),(202372,5622,'fi','On luotava saatuihin tuloihin tyyppi huomioon ennen sulkemista',0),(202373,5622,'no','MÃ¥ opprette en opptjente inntekter type konto fÃ¸r lukking',0),(202374,5622,'da','Skal oprette en overfÃ¸rt overskud type konto fÃ¸r lukning',0),(202375,5622,'ko','ë‹«ê¸° ì „ì— ê³„ì • ìœ ì§€ ìˆ˜ìž… ìœ í˜• ë§Œë“¤ì–´ì•¼ í•©ë‹ˆë‹¤.',0),(202376,5622,'he','×¢×œ×™×š ×œ×™×¦×•×¨ ×¡×•×’ ×™×™×©×ž×¨×• ×”×¨×•×•×—×™× ×—×©×‘×•×Ÿ ×œ×¤× ×™ ×¡×’×™×¨×ª',0),(202377,5622,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î­Î½Î±Î½ Ï„ÏÏ€Î¿ ÎºÎ­ÏÎ´Î· ÎµÎ¹Ï‚ Î½Î­Î¿Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î¿ ÎºÎ»ÎµÎ¯ÏƒÎ¹Î¼Î¿',0),(202378,5622,'zh','å¿…é¡»åœ¨ç»“æŸå‰å»ºç«‹ä¸€ä¸ªä¿ç•™ç›ˆä½™ç±»åž‹çš„å¸æˆ·\r\n',0),(202379,5622,'sv','MÃ¥ste skapa en balanserade vinstmedel typ konto innan stÃ¤ngning',0),(202380,5622,'it','Deve creare un tipo di guadagni mantenuti conto prima di chiusura',0),(202381,5622,'tl','',0),(202382,5622,'th','&#3605;&#3657;&#3629;&#3591;&#3626;&#3619;&#3657;&#3634;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3633;&#3597;&#3594;&#3637;&#3585;&#3635;&#3652;&#3619;&#3626;&#3632;&#3626;&#3617;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3611;&#3',0),(202383,5622,'hi','à¤à¤• à¤†à¤¯ à¤•à¤¾à¤¯à¤® à¤ªà¥à¤°à¤•à¤¾à¤° à¤–à¤¾à¤¤à¥‡ à¤¬à¤‚à¤¦ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¬à¤¨à¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(202384,5622,'ms','Mesti mencipta jenis keuntungan terkumpul akaun sebelum tutup',0),(202385,5622,'ar','ÙŠØ¬Ø¨ Ø¥Ù†Ø´Ø§Ø¡ Ù†ÙˆØ¹ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø­ØªØ¬Ø²Ø© Ù‚Ø¨Ù„ Ø¥ØºÙ„Ø§Ù‚ Ø­Ø³Ø§Ø¨',0),(202386,5622,'fr','Devez crÃ©er un type de bÃ©nÃ©fices non rÃ©partis compte avant la fermeture',0),(202387,5622,'jp','é–‰ã‚?ã‚‹å‰?ã?«ç•™ä¿?åˆ©ç›Šã‚¿ã‚¤ãƒ—ã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½œæˆ?ã?—ã?¦ã??ã? ã?•ã?„',0),(202388,5622,'pt','Deve criar um tipo de lucros acumulados conta antes de fechar',0),(202389,5622,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿ÐµÑ€ÐµÐ´ Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¸ÐµÐ¼ Ñ‚Ð¸Ð¿ ÐÐµÑ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ð°Ñ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ',0),(202390,5622,'es','Deb Crear una Cuenta de Tipo Utilidades Retenidos Antes que Cerrar',0),(202391,5622,'de','MÃ¼ssen einen Konto vor SchlieÃŸung einbehaltenen Einnahmen-Typ erstellen',0),(202392,5622,'en','Must create a Retained Earnings type Account Before Closing',0),(202393,5623,'is','',0),(202394,5623,'dr','Ø¨Ø³ØªÙ† Ø³Ø§Ù„',0),(202395,5623,'pr','Ø¨Ø³ØªÙ† Ø³Ø§Ù„',0),(202396,5623,'tr','YÄ±lÄ± kapat',0),(202397,5623,'pl','Blisko rok',0),(202398,5623,'bg','Ð‘Ð»Ð¸Ð·Ð¾ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(202399,5623,'ur','Ø³Ø§Ù„ Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº',0),(202400,5623,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(202401,5623,'vi','NÄƒm KhÃ³a sá»•',0),(202402,5623,'af','Jaar Afsluit',0),(202403,5623,'ro','ÃŽnchide an',0),(202404,5623,'et','Aasta sulgemine',0),(202405,5623,'si','Zapri leto',0),(202406,5623,'ba','Menutup tahun',0),(202407,5623,'nl','Sluiten jaar',0),(202408,5623,'fi','Sulje vuosi',0),(202409,5623,'no','Lukk Ã¥r',0),(202410,5623,'da','Lukke Ã¥r',0),(202411,5623,'ko','1 ë…„ ê°€ê¹Œì´',0),(202412,5623,'he','×¡×•×’×¨×™× ×©× ×”',0),(202413,5623,'el','ÎšÎ»ÎµÎ¯ÏƒÎµÎ¹ Î­Ï„Î¿Ï‚',0),(202414,5623,'zh','å…³é—­å¹´\r\n',0),(202415,5623,'sv','StÃ¤ng Ã¥r',0),(202416,5623,'it','Chiudere l\'anno',0),(202417,5623,'tl','',0),(202418,5623,'th','&#3611;&#3636;&#3604;&#3611;&#3637;',0),(202419,5623,'hi','à¤µà¤°à¥à¤· à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(202420,5623,'ms','Tutup tahun',0),(202421,5623,'ar','Ø¥Ù‚ÙØ§Ù„ Ø§Ù„Ø³Ù†Ø©',0),(202422,5623,'fr','ClÃ´ture exercice',0),(202423,5623,'jp','é–‰ã‚?å¹´',0),(202424,5623,'pt','Fechar o ano',0),(202425,5623,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ Ð³Ð¾Ð´',0),(202426,5623,'es','Cerrar AÃ±o',0),(202427,5623,'de','Jahr schlieÃŸen',0),(202428,5623,'en','Close Year',0),(202429,5624,'is','',0),(202430,5624,'dr','Ù‚Ø§Ù„Ø¨ ÙØ§ÙƒØªÙˆØ± Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(202431,5624,'pr','Ù‚Ø§Ù„Ø¨ ÙØ§ÙƒØªÙˆØ± Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(202432,5624,'tr','Birim fiyat iÃ§in fatura formatÄ±',0),(202433,5624,'pl','Faktura Format cena jednostkowa',0),(202434,5624,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð°',0),(202435,5624,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©Û’ Ù„Ø¦Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(202436,5624,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð°',0),(202437,5624,'vi','Dáº¡ng HÃ³a Ä‘Æ¡n cho Ä‘Æ¡n vá»‹ giÃ¡',0),(202438,5624,'af','Faktuurformaat vir Eenheidsprys',0),(202439,5624,'ro','Format pret unitar factura',0),(202440,5624,'et','Arve vorm Ã¼hikuhind',0),(202441,5624,'si','Oblika raÄuna za ceno enote',0),(202442,5624,'ba','Faktur Format untuk harga satuan',0),(202443,5624,'nl','Factuur opmaken voor prijs per eenheid',0),(202444,5624,'fi','Laskun muoto YksikkÃ¶hinta',0),(202445,5624,'no','Faktura Format salgspris',0),(202446,5624,'da','Faktura Format til salgspris',0),(202447,5624,'ko','ë‹¨ê°€ ëŒ€ í•œ ì²­êµ¬ì„œ ì„œì‹',0),(202448,5624,'he','×¢×™×¦×•×‘ ×—×©×‘×•× ×™×ª ×¢×‘×•×¨ ×”×ž×—×™×¨ ×œ×™×—×™×“×”',0),(202449,5624,'el','ÎœÎ¿ÏÏ†Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î³Î¹Î± Ï„Î¹Î¼Î® Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(202450,5624,'zh','å‘ç¥¨æ ¼å¼å•ä»·\r\n',0),(202451,5624,'sv','Faktura Format fÃ¶r Enhetspris',0),(202452,5624,'it','Formato fattura per il prezzo unitario',0),(202453,5624,'tl','',0),(202454,5624,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(202455,5624,'hi','à¤‡à¤•à¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(202456,5624,'ms','Format invois harga Unit',0),(202457,5624,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù„Ø³Ø¹Ø± Ø§Ù„ÙˆØ­Ø¯Ø©',0),(202458,5624,'fr','Format de facture pour prix unitaire',0),(202459,5624,'jp','å?˜ä¾¡ç”¨è«‹æ±‚æ›¸ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(202460,5624,'pt','Formato de factura por preÃ§o unitÃ¡rio',0),(202461,5624,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð´Ð»Ñ Ð¦ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(202462,5624,'es','Formato de Factura para Precio de Unidad',0),(202463,5624,'de','Rechnungsformat fÃ¼r VK-Preis',0),(202464,5624,'en','Invoice Format for Unit Price',0),(202465,5625,'is','',0),(202466,5625,'dr','Ù…ØªÙˆÙ‚Ù ÙƒØ±Ø¯Ù† Ú†Ø§Ù¾  Ø³ØªÙˆÙ†  Ù‚ÙŠÙ…Øª ÙˆØ§Ø­Ø¯ ',0),(202467,5625,'pr','Ù…ØªÙˆÙ‚Ù ÙƒØ±Ø¯Ù† Ú†Ø§Ù¾  Ø³ØªÙˆÙ†  Ù‚ÙŠÙ…Øª ÙˆØ§Ø­Ø¯ ',0),(202468,5625,'tr','Birim fiyat sÃ¼tununu yazdÄ±rÄ±lmÄ±yor.',0),(202469,5625,'pl','Nie Drukuj Unit Price kolumna',0),(202470,5625,'bg','ÐÐµ ÑÐµ Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ñ‚ ÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð° ÐºÐ¾Ð»Ð¾Ð½Ð°',0),(202471,5625,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©Û’ Ú©Ø§Ù„Ù… Ú†Ú¾Ø§Ù¾ Ù†ÛÛŒÚº',0),(202472,5625,'sr','ÐÐµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜Ñƒ ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð° ÐºÐ¾Ð»Ð¾Ð½Ðµ',0),(202473,5625,'vi','Äá»«ng in cá»™t Ä‘Æ¡n vá»‹ giÃ¡',0),(202474,5625,'af','Moenie die Eenheidspryskolom uitdruk nie',0),(202475,5625,'ro','Nu se imprimÄƒ coloana de preÅ£ unitar',0),(202476,5625,'et','Prindib Ã¼ksuse hinnaveerule',0),(202477,5625,'si','Ne natisnejo stolpca cena enote',0),(202478,5625,'ba','Tidak mencetak kolom harga Unit',0),(202479,5625,'nl','Eenheid prijs kolom worden niet afgedrukt',0),(202480,5625,'fi','Ã„lÃ¤ tulosta kappalehintasarakkeessa',0),(202481,5625,'no','Ikke Skriv ut enhet pris-kolonnen',0),(202482,5625,'da','Udskriv ikke enhed pris kolonne',0),(202483,5625,'ko','ë‹¨ìœ„ ê°€ê²© ì—´ ì¸ì‡„ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(202484,5625,'he','××œ ×ª×¤×¨×¡×ž×™ ××ª ×¢×ž×•×“×ª Price ×™×—×™×“×”',0),(202485,5625,'el','ÎœÎ·Î½ ÎµÎºÏ„Ï…Ï€ÏŽÎ½ÎµÏ„Îµ Î¼Î¿Î½Î¬Î´Î± Ï„Î¹Î¼Î®Ï‚ ÏƒÏ„Î®Î»Î·',0),(202486,5625,'zh','ä¸è¦å°åˆ·å®šä»·æ ¼åˆ—\r\n',0),(202487,5625,'sv','Skriv inte ut kolumnen enhet pris',0),(202488,5625,'it','Non stampare la colonna prezzo Unit',0),(202489,5625,'tl','',0),(202490,5625,'th','&#3627;&#3618;&#3640;&#3604;&#3627;&#3633;&#3623;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3656;&#3629;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(202491,5625,'hi','à¤‡à¤•à¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤‚à¤­ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨ à¤•à¤°à¥‡à¤‚',0),(202492,5625,'ms','Cetak Unit harga kolum',0),(202493,5625,'ar','Ù„Ø§ ØªÙ‚Ù… Ø¨Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¹Ù…ÙˆØ¯ Ø³Ø¹Ø± Ø§Ù„ÙˆØ­Ø¯Ø©',0),(202494,5625,'fr','Ne pas afficher la colonne prix unitÃ©',0),(202495,5625,'jp','å?˜ä¾¡æ¬„ã?¯å?°åˆ·ã?—ã?ªã?„ã?§ä¸‹ã?•ã?„',0),(202496,5625,'pt','NÃ£o imprimir a coluna de preÃ§o de unidade',0),(202497,5625,'ru','ÐÐµ Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ð»Ð±ÐµÑ† Ð¦ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(202498,5625,'es','No Imprimir Columna de Precio de Unidad',0),(202499,5625,'de','Unit Price-Spalte nicht gedruckt',0),(202500,5625,'en','Do Not Print Unit Price Column',0),(202501,5626,'is','',0),(202502,5626,'dr','Ø¢ÙŠØ§ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø³ØªØŸ',0),(202503,5626,'pr','Ø¢ÙŠØ§ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø³ØªØŸ',0),(202504,5626,'tr','Hizmet emek vergiye tabi mi?',0),(202505,5626,'pl','Jest serwis pracy opodatkowaniu?',0),(202506,5626,'bg','Ð• Ñ‚Ñ€ÑƒÐ´Ð¾Ð²Ð¾ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð²Ð°Ð½Ðµ?',0),(202507,5626,'ur','Ø®Ø¯Ù…Øª Ù…Ø²Ø¯ÙˆØ± Ù¹ÛŒÚ©Ø³ Ø¹Ø§Ø¦Ø¯ ÛÙˆØªØ§ ÛÛ’ØŸ',0),(202508,5626,'sr','Ð”Ð° Ð»Ð¸ Ñ˜Ðµ ÑƒÑÐ»ÑƒÐ³Ð° Ñ€Ð°Ð´Ð½Ð¾ Ð¿Ð»Ð°Ð¶Ð°?',0),(202509,5626,'vi','NhÃ¢n cÃ´ng dá»‹ch vá»¥ cÃ³ pháº£i chá»‹u thuáº¿?',0),(202510,5626,'af','Is Diens Arbeid Belasbaar?',0),(202511,5626,'ro','Este serviciul muncii impozabile?',0),(202512,5626,'et','On teenus Labor maksustatav?',0),(202513,5626,'si','Je Labor davÄna storitev?',0),(202514,5626,'ba','Adalah jasa tenaga kerja pajak?',0),(202515,5626,'nl','Is Service arbeid belastbare?',0),(202516,5626,'fi','On palvelu Labor verovelvollinen?',0),(202517,5626,'no','Er tjenesten Ap. skattepliktig?',0),(202518,5626,'da','Der er Service Labor skattepligtigt?',0),(202519,5626,'ko','ì„œë¹„ìŠ¤ ë…¸ë™ ê³¼ì„¸ëŠ”?',0),(202520,5626,'he','?×”×× ×™×© ×ž×¡ ×¢×œ ×¢×‘×•×“×ª ×©×¨×•×ª',0),(202521,5626,'el','Î•Î¯Î½Î±Î¹ Ï…Ï€Î·ÏÎµÏƒÎ¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿;',0),(202522,5626,'zh','æœåŠ¡åŠ³åŠ¨æ˜¯å¦å¾ç¨Žï¼Ÿ\r\n',0),(202523,5626,'sv','Ã„r tjÃ¤nsten Labor beskattningsbara?',0),(202524,5626,'it','Ãˆ il servizio lavoro tassabile?',0),(202525,5626,'tl','',0),(202526,5626,'th','&#3648;&#3611;&#3655;&#3609;&#3616;&#3634;&#3625;&#3637;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(202527,5626,'hi','à¤¸à¥‡à¤µà¤¾ à¤¶à¥à¤°à¤® à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤¹à¥ˆ?',0),(202528,5626,'ms','Adakah Perkhidmatan buruh dikenakan cukai?',0),(202529,5626,'ar','Ù‡Ùˆ Ø®Ø¯Ù…Ø© Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©ØŸ',0),(202530,5626,'fr','Est un Service Taxable du travail ?',0),(202531,5626,'jp','ã‚µãƒ¼ãƒ“ã‚¹åŠ´åƒ?ã?¯èª²ç¨Žå¯¾è±¡ã?§ã?™ã?‹ï¼Ÿ',0),(202532,5626,'pt','Ã‰ serviÃ§o tributÃ¡vel do trabalho?',0),(202533,5626,'ru','Ð­Ñ‚Ð¾ ÑÐ»ÑƒÐ¶Ð±Ð° Ñ‚Ñ€ÑƒÐ´Ð° Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼?',0),(202534,5626,'es','Â¿Es Labor de Servicios Imponible?',0),(202535,5626,'de','Ist Service Labor steuerpflichtig?',0),(202536,5626,'en','Is Service Labor Taxable?',0),(202537,5627,'is','',0),(202538,5627,'dr','Ø­Ø³Ø§Ø¨ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„',0),(202539,5627,'pr','Ø­Ø³Ø§Ø¨ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„',0),(202540,5627,'tr','Hizmet satÄ±ÅŸ emek GL hesabÄ±',0),(202541,5627,'pl','Konto usÅ‚ugi sprzedaÅ¼y pracy GL',0),(202542,5627,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ñ‚Ñ€ÑƒÐ´Ð¾Ð²Ð¾ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(202543,5627,'ur','Ø³Ø±ÙˆØ³ ÙØ±ÙˆØ®Øª Ù…Ø²Ø¯ÙˆØ± Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(202544,5627,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° ÑƒÑÐ»ÑƒÐ³Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ñ€Ð°Ð´ Ð“Ð›',0),(202545,5627,'vi','NhÃ¢n cÃ´ng nhÃ¢n viÃªn phá»¥c vá»¥ trong TK sá»• cÃ¡i',0),(202546,5627,'af','Diensverkope Arbeid AG Rekening',0),(202547,5627,'ro','Contul serviciului de vÃ¢nzÄƒri GL muncii',0),(202548,5627,'et','Teenusekonto mÃ¼Ã¼gi Labor GL',0),(202549,5627,'si','RaÄun storitve prodaje Labor GL',0),(202550,5627,'ba','Account layanan penjualan GL tenaga kerja',0),(202551,5627,'nl','Verkoop arbeid GL serviceaccount',0),(202552,5627,'fi','Myynnin Labor GL tili',0),(202553,5627,'no','Tjenestekontoen for salg Ap. GL',0),(202554,5627,'da','Salg Labor GL tjenestekonto',0),(202555,5627,'ko','ì„œë¹„ìŠ¤ íŒë§¤ ë…¸ë™ GL ê³„ì •',0),(202556,5627,'he','×—×©×‘×•×Ÿ GL ×¢×‘×•×“×” ×ž×›×™×¨×•×ª ×©×™×¨×•×ª',0),(202557,5627,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(202558,5627,'zh','æœåŠ¡é”€å”®åŠ³åŠ¨æ€»å¸å¸æˆ·\r\n',0),(202559,5627,'sv','FÃ¶rsÃ¤ljning Labor GL-tjÃ¤nstkontot',0),(202560,5627,'it','Servizio conto vendita GL Labor',0),(202561,5627,'tl','',0),(202562,5627,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(202563,5627,'hi','à¤¸à¥‡à¤µà¤¾ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤ªà¤°à¤¿à¤¶à¥à¤°à¤® GL à¤–à¤¾à¤¤à¥‡',0),(202564,5627,'ms','Akaun jualan GL buruh Perkhidmatan',0),(202565,5627,'ar','Ø­Ø³Ø§Ø¨ Ø®Ø¯Ù…Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª GL Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ø§Ù„',0),(202566,5627,'fr','Compte de service vente GL Labor',0),(202567,5627,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã‚»ãƒ¼ãƒ«ã‚¹åŠ´åƒ?ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(202568,5627,'pt','Conta de serviÃ§o de vendas GL trabalhistas',0),(202569,5627,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ñ‚Ñ€ÑƒÐ´Ð° GL',0),(202570,5627,'es','Cuenta LM de Labor de Ventas de Servicios',0),(202571,5627,'de','Vertrieb Labor GL-Dienstkonto',0),(202572,5627,'en','Service Sales Labor GL Account',0),(202573,5628,'is','',0),(202574,5628,'dr','Ù‡Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø§Ù†',0),(202575,5628,'pr','Ù‡Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø§Ù†',0),(202576,5628,'tr','TÃ¼m kullanÄ±cÄ±lar',0),(202577,5628,'pl','Wszystkich uÅ¼ytkownikÃ³w',0),(202578,5628,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(202579,5628,'ur','ØªÙ…Ø§Ù… ØµØ§Ø±ÙÛŒÙ†',0),(202580,5628,'sr','Ð¡Ð²Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸',0),(202581,5628,'vi','Táº¥t Cáº£ NgÆ°á»i Sá»­ Dá»¥ng',0),(202582,5628,'af','Alle Gebruikers',0),(202583,5628,'ro','Toti utilisatorii',0),(202584,5628,'et','KÃµik kasutajad',0),(202585,5628,'si','Vse uporabnike',0),(202586,5628,'ba','Semua pengguna',0),(202587,5628,'nl','Alle gebruikers',0),(202588,5628,'fi','Kaikki kÃ¤yttÃ¤jÃ¤t',0),(202589,5628,'no','Alle brukere',0),(202590,5628,'da','Alle brugere',0),(202591,5628,'ko','ëª¨ë“  ì‚¬ìš©ìž',0),(202592,5628,'he','×›×œ ×”×ž×©×ª×ž×©×™×',0),(202593,5628,'el','ÎŒÎ»Î¿Î¹ Î¿Î¹ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(202594,5628,'zh','æ‰€æœ‰ç”¨æˆ·\r\n',0),(202595,5628,'sv','Alla anvÃ¤ndare',0),(202596,5628,'it','Tutti gli utenti',0),(202597,5628,'tl','',0),(202598,5628,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(202599,5628,'hi','à¤¸à¤­à¥€ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(202600,5628,'ms','Semua pengguna',0),(202601,5628,'ar','ÙƒØ§ÙØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(202602,5628,'fr','Tous les utilisateurs',0),(202603,5628,'jp','å…¨ã?¦ã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(202604,5628,'pt','Todos os usuÃ¡rios',0),(202605,5628,'ru','Ð’ÑÐµ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸',0),(202606,5628,'es','Todos los Usuarios',0),(202607,5628,'de','Alle Benutzer',0),(202608,5628,'en','All Users',0),(202609,5629,'is','',0),(202610,5629,'dr','ÙÙ‚Ø· ÙƒØ§Ø± Ù…Ù† ',0),(202611,5629,'pr','ÙÙ‚Ø· ÙƒØ§Ø± Ù…Ù† ',0),(202612,5629,'tr','Sadece benim iÅŸ',0),(202613,5629,'pl','Moja praca tylko',0),(202614,5629,'bg','ÐœÐ¾ÑÑ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° ÑÐ°Ð¼Ð¾',0),(202615,5629,'ur','Ù…ÛŒØ±Ø§ Ú©Ø§Ù… ØµØ±Ù',0),(202616,5629,'sr','Ð¡Ð°Ð¼Ð¾ Ð¼Ð¾Ñ˜ Ñ€Ð°Ð´',0),(202617,5629,'vi','Chá»‰ cÃ´ng viá»‡c cá»§a tÃ´i',0),(202618,5629,'af','My Werk Alleenlik',0),(202619,5629,'ro','Munca mea numai',0),(202620,5629,'et','Minu tÃ¶Ã¶ ainult',0),(202621,5629,'si','Moje delo samo',0),(202622,5629,'ba','Pekerjaan saya hanya',0),(202623,5629,'nl','Mijn werk alleen',0),(202624,5629,'fi','TyÃ¶ni vain',0),(202625,5629,'no','Mitt arbeid bare',0),(202626,5629,'da','Mit arbejde kun',0),(202627,5629,'ko','ë‚´ ìž‘í’ˆë§Œ',0),(202628,5629,'he','×”×¢×‘×•×“×” ×©×œ×™ ×‘×œ×‘×“',0),(202629,5629,'el','Î— Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î¼Î¿Ï… Î¼ÏŒÎ½Î¿',0),(202630,5629,'zh','ä»…æˆ‘çš„å·¥ä½œ\r\n',0),(202631,5629,'sv','Mitt arbete endast',0),(202632,5629,'it','Solo il mio lavoro',0),(202633,5629,'tl','',0),(202634,5629,'th','&#3585;&#3634;&#3619;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3593;&#3633;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(202635,5629,'hi','à¤®à¥‡à¤°à¤¾ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥‡à¤µà¤²',0),(202636,5629,'ms','Kerja saya hanya',0),(202637,5629,'ar','Ø¹Ù…Ù„ÙŠ ÙÙ‚Ø·',0),(202638,5629,'fr','Mon travail seulement',0),(202639,5629,'jp','ç§?ã?®ä½œæ¥­ã?®ã?¿',0),(202640,5629,'pt','Meu trabalho sÃ³',0),(202641,5629,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¼Ð¾Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(202642,5629,'es','Mi Trabajo Solamente',0),(202643,5629,'de','Meine Arbeit nur',0),(202644,5629,'en','My Work Only',0),(202645,5630,'is','',0),(202646,5630,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(202647,5630,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(202648,5630,'tr','Servis sipariÅŸi zaman izci',0),(202649,5630,'pl','UsÅ‚ugi zamÃ³wienia czas Tracker',0),(202650,5630,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð²Ñ€ÐµÐ¼Ðµ Tracker',0),(202651,5630,'ur','Ø®Ø¯Ù…Øª Ø¢Ø±ÚˆØ± ÙˆÙ‚Øª Ø³Ø±Ø§Øº Ø±Ø§Û Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº',0),(202652,5630,'sr','Ð£ÑÐ»ÑƒÐ³Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ñ‚Ñ€Ð°Ð³Ð°Ñ‡',0),(202653,5630,'vi','TÃ¬m thá»i gian Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(202654,5630,'af','Diensbestelling Tydsporing',0),(202655,5630,'ro','Serviciul comenzii timp Tracker',0),(202656,5630,'et','Teenuse tellimuse aeg Tracker',0),(202657,5630,'si','Servisnega naloga Äas Tracker',0),(202658,5630,'ba','Layanan pesanan pelacak waktu',0),(202659,5630,'nl','Drijver van de tijd van de volgorde van service',0),(202660,5630,'fi','Palvelun tilauksen Time Tracker',0),(202661,5630,'no','Tjenesten for tid sporing',0),(202662,5630,'da','Service bestil tid Tracker',0),(202663,5630,'ko','ì„œë¹„ìŠ¤ ì˜¤ë” ì‹œê°„ ì¶”ì ê¸°',0),(202664,5630,'he','×©×™×¨×•×ª ×”×–×ž× ×ª ×–×ž×Ÿ ×”×ž×¢×§×‘',0),(202665,5630,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎºÎ±Ï„Î±Î³ÏÎ±Ï†Î­Î±Ï‚ Ï‡ÏÏŒÎ½Î¿Ï…',0),(202666,5630,'zh','è®¢è´§æ—¶é—´è¿½è¸ªæœåŠ¡\r\n',0),(202667,5630,'sv','TjÃ¤nsten BestÃ¤ll tid Tracker',0),(202668,5630,'it','Servizio ordine Time Tracker',0),(202669,5630,'tl','',0),(202670,5630,'th','&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3648;&#3623;&#3621;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(202671,5630,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤Ÿà¤¾à¤‡à¤® à¤Ÿà¥à¤°à¥ˆà¤•à¤°',0),(202672,5630,'ms','Perkhidmatan perintah masa Tracker',0),(202673,5630,'ar','ØªØ¹Ù‚Ø¨ Ø§Ù„ÙˆÙ‚Øª Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(202674,5630,'fr','Service commande Time Tracker',0),(202675,5630,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡æ™‚é–“è¨˜éŒ²',0),(202676,5630,'pt','Rastreador de tempo de ordem de serviÃ§o',0),(202677,5630,'ru','ÐžÑ‚ÑÐ»ÐµÐ¶Ñ‹Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð·Ð°ÐºÐ°Ð·Ð° Ð±Ð¸Ð»ÐµÑ‚Ð¾Ð²',0),(202678,5630,'es','Orden de Servicio Rastreador de Tiempo',0),(202679,5630,'de','Service Bestellung Time Tracker',0),(202680,5630,'en','Service Order Time Tracker',0),(202681,5631,'is','',0),(202682,5631,'dr','(ÙˆÙŠÚ˜Ù‡',0),(202683,5631,'pr','Ø³ÙØ§Ø±Ø´ Ø«Ø§Ø¨Øª(ÙˆÙŠÚ˜Ù‡',0),(202684,5631,'tr','Ã–zel sipariÅŸ',0),(202685,5631,'pl','OkreÅ›lonej kolejnoÅ›ci',0),(202686,5631,'bg','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ñ€ÐµÐ´',0),(202687,5631,'ur','Ù…Ø®ØµÙˆØµ ØªØ±ØªÛŒØ¨',0),(202688,5631,'sr','ÐžÐ´Ñ€ÐµÑ’ÐµÐ½Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(202689,5631,'vi','ÄÆ¡n hÃ ng cá»¥ thá»ƒ',0),(202690,5631,'af','Spesifieke Bestelling',0),(202691,5631,'ro','AnumitÄƒ ordine',0),(202692,5631,'et','Kindlas jÃ¤rjestuses',0),(202693,5631,'si','DoloÄenem vrstnem redu',0),(202694,5631,'ba','Urutan tertentu',0),(202695,5631,'nl','Specifieke volgorde',0),(202696,5631,'fi','TietyssÃ¤ jÃ¤rjestyksessÃ¤',0),(202697,5631,'no','Bestemt rekkefÃ¸lge',0),(202698,5631,'da','Bestemt rÃ¦kkefÃ¸lge',0),(202699,5631,'ko','íŠ¹ì • í•œ ìˆœì„œ',0),(202700,5631,'he','×”×–×ž× ×” ×ž×¡×•×™×ž×ª',0),(202701,5631,'el','Î£Ï…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î· ÏƒÎµÎ¹ÏÎ¬',0),(202702,5631,'zh','ç‰¹å®šçš„é¡ºåº\r\n',0),(202703,5631,'sv','Viss ordning',0),(202704,5631,'it','Ordine specifico',0),(202705,5631,'tl','',0),(202706,5631,'th','&#3619;&#3632;&#3610;&#3640;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(202707,5631,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤†à¤¦à¥‡à¤¶',0),(202708,5631,'ms','Perintah khusus',0),(202709,5631,'ar','ØªØ±ØªÙŠØ¨ Ù…Ø¹ÙŠÙ†',0),(202710,5631,'fr','Ordre spÃ©cifique',0),(202711,5631,'jp','ç‰¹å®šæ³¨æ–‡',0),(202712,5631,'pt','Ordem especÃ­fica',0),(202713,5631,'ru','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ñ‹Ð¹ Ð—Ð°ÐºÐ°Ð·',0),(202714,5631,'es','Orden EspecÃ­fico',0),(202715,5631,'de','Bestimmten Reihenfolge',0),(202716,5631,'en','Specific Order',0),(202717,5632,'is','',0),(202718,5632,'dr','Ø§Ø±Ø³Ø§Ù„ Ø²Ù…Ø§Ù† Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(202719,5632,'pr','Ø§Ø±Ø³Ø§Ù„ Ø²Ù…Ø§Ù† Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(202720,5632,'tr','SipariÅŸ mesaj zamanÄ±',0),(202721,5632,'pl','Po czasie na zamÃ³wienie',0),(202722,5632,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð¹ Ð²Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(202723,5632,'ur','Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù¾ÙˆØ³Ù¹ Ú©Û’ ÙˆÙ‚Øª',0),(202724,5632,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ñ˜Ðµ Ð´Ð° Ñ€ÐµÐ´',0),(202725,5632,'vi','ÄÄƒng thá»i gian Ä‘áº·t hÃ ng',0),(202726,5632,'af','Pos Tyd om te Bestel',0),(202727,5632,'ro','Post data la comanda',0),(202728,5632,'et','Postitus aeg tellida',0),(202729,5632,'si','Post Äas po naroÄilu',0),(202730,5632,'ba','Waktu Post untuk Order',0),(202731,5632,'nl','Post tijd om te bestellen',0),(202732,5632,'fi','JÃ¤lkeinen aika tilata',0),(202733,5632,'no','Innlegget tid Ã¥ bestille',0),(202734,5632,'da','Post tid at bestille',0),(202735,5632,'ko','ê²Œì‹œë¬¼ ì‹œê°„ ìˆœì„œì—',0),(202736,5632,'he','×”×§×¤×¦×•×ª ×œ×¤×™ ×”×–×ž× ×”',0),(202737,5632,'el','Î”Î·Î¼Î¿ÏƒÎ¯ÎµÏ…ÏƒÎ· ÏŽÏÎ± ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î·',0),(202738,5632,'zh','å‘å¸ƒæ—¶é—´è®¢è´­\r\n',0),(202739,5632,'sv','Post tid att bestÃ¤lla',0),(202740,5632,'it','Tempo di post per ordine',0),(202741,5632,'tl','',0),(202742,5632,'th','&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3611;&#3607;&#3637;&#3656;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(202743,5632,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¤¾ à¤¸à¤®à¤¯',0),(202744,5632,'ms','Masa Post untuk perintah',0),(202745,5632,'ar','Ù…Ø´Ø§Ø±ÙƒØ© ÙˆÙ‚Øª Ù„Ù„ØªØ±ØªÙŠØ¨',0),(202746,5632,'fr','Message de temps Ã  l\'ordre',0),(202747,5632,'jp','æ³¨æ–‡æ™‚é–“ã?®è¨ˆä¸Š',0),(202748,5632,'pt','Hora de post de ordem',0),(202749,5632,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ðµ Ð²Ñ€ÐµÐ¼Ñ Ð½Ð° Ð·Ð°ÐºÐ°Ð·',0),(202750,5632,'es','Asentar Tiempo para Ordenar',0),(202751,5632,'de','Post Time bestellen',0),(202752,5632,'en','Post Time to Order',0),(202753,5633,'is','',0),(202754,5633,'dr','(Ø³Ø±Ø¹Øª Ø¯Ø± Ù‡Ø±Ø³Ø§Ø¹Øª',0),(202755,5633,'pr','Ù†Ø±Ø® (Ø³Ø±Ø¹Øª Ø¯Ø± Ù‡Ø±Ø³Ø§Ø¹Øª',0),(202756,5633,'tr','OranÄ±/saat',0),(202757,5633,'pl','Stawki/Hr',0),(202758,5633,'bg','ÐšÑƒÑ€Ñ/Hr',0),(202759,5633,'ur','Ø´Ø±Ø­/Hr',0),(202760,5633,'sr','Ð¡Ñ‚Ð¾Ð¿Ð°/Ð¥Ñ€',0),(202761,5633,'vi','GiÃ¡/giá»',0),(202762,5633,'af','Tarief/Uur',0),(202763,5633,'ro','Rata/orÄƒ',0),(202764,5633,'et','Kiirus tunnis',0),(202765,5633,'si','Stopnja/Hr',0),(202766,5633,'ba','Tingkat/Hr',0),(202767,5633,'nl','Tarief/Hr',0),(202768,5633,'fi','Korko/h',0),(202769,5633,'no','Hastighet/Hr',0),(202770,5633,'da','Sats/Hr',0),(202771,5633,'ko','ì†ë„/ì‹œê°„',0),(202772,5633,'he','×ª×¢×¨×™×£ ×œ×©×¢×”',0),(202773,5633,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ/Hr',0),(202774,5633,'zh','ä»·æ ¼/å°æ—¶\r\n',0),(202775,5633,'sv','Kurs/Hr',0),(202776,5633,'it','Tasso/Hr',0),(202777,5633,'tl','',0),(202778,5633,'th','&#3629;&#3633;&#3605;&#3619;&#3634;/&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(202779,5633,'hi','à¤¦à¤°/Hr',0),(202780,5633,'ms','Kadar/sumber manusia',0),(202781,5633,'ar','Ù…Ø¹Ø¯Ù„/Ø§Ù„Ù…ÙˆØ§Ø±Ø¯ Ø§Ù„Ø¨Ø´Ø±ÙŠØ©',0),(202782,5633,'fr','Taux/Hr',0),(202783,5633,'jp','æ–™é‡‘/æ™‚é–“',0),(202784,5633,'pt','Taxa/Hr',0),(202785,5633,'ru','ÐšÑƒÑ€Ñ/Hr',0),(202786,5633,'es','Tasa/Hora',0),(202787,5633,'de','Preis/Std.',0),(202788,5633,'en','Rate/Hr',0),(202789,5634,'is','',0),(202790,5634,'dr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯',0),(202791,5634,'pr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯',0),(202792,5634,'tr','Yeni dÃ¼zen seÃ§meden Ã¶nce deÄŸiÅŸiklikleri kaydetmek',0),(202793,5634,'pl','ZapisaÄ‡ zmiany przed wybraniem nowego porzÄ…dku',0),(202794,5634,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(202795,5634,'ur','Ù†Ø¦ÛŒ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ø³Û’ Ù¾ÛÙ„Û’ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(202796,5634,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð¿Ñ€Ðµ Ð½ÐµÐ³Ð¾ ÑˆÑ‚Ð¾ Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(202797,5634,'vi','Sao lÆ°u thay Ä‘á»•i trÆ°á»›c khi chá»n Ä‘Æ¡n hÃ ng má»›i',0),(202798,5634,'af','Stoor Veranderinge Alvorens Nuwe Datums of Werker Gekies word',0),(202799,5634,'ro','SalvaÅ£i modificÄƒrile Ã®nainte de a selecta noua ordine',0),(202800,5634,'et','Salvesta muudatused enne uue tellimuse valimist',0),(202801,5634,'si','Shranite spremembe pred izbiro novega reda',0),(202802,5634,'ba','Simpan perubahan sebelum memilih Orde Baru',0),(202803,5634,'nl','Wijzigingen opslaan voordat u nieuwe orde',0),(202804,5634,'fi','Tallentaa muutokset ennen valitsemalla uusi jÃ¤rjestys',0),(202805,5634,'no','Lagre endringene fÃ¸r du velger ny ordre',0),(202806,5634,'da','Gemme Ã¦ndringer, fÃ¸r du vÃ¦lger ny ordre',0),(202807,5634,'ko','ìƒˆë¡œìš´ ì§ˆì„œë¥¼ ì„ íƒ í•˜ê¸° ì „ì— ë³€ê²½ ì‚¬í•­ì„ ì €ìž¥í•©ë‹ˆë‹¤',0),(202808,5634,'he','×œ×©×ž×•×¨ ××ª ×”×©×™× ×•×™×™× ×œ×¤× ×™ ×‘×—×™×¨×ª ×¡×“×¨ ×—×“×©',0),(202809,5634,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® Ï„Î·Ï‚ Î½Î­Î±Ï‚ Ï„Î¬Î¾Î·Ï‚',0),(202810,5634,'zh','ä¿å­˜åœ¨é€‰æ‹©æ–°ç§©åºçš„å˜åŒ–\r\n',0),(202811,5634,'sv','Spara Ã¤ndringar innan du vÃ¤ljer ny Order',0),(202812,5634,'it','Salvare le modifiche prima di selezionare il nuovo ordine',0),(202813,5634,'tl','',0),(202814,5634,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3',0),(202815,5634,'hi','à¤¨à¤ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¥‹à¤‚ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(202816,5634,'ms','Menyimpan perubahan sebelum memilih perintah baru',0),(202817,5634,'ar','Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(202818,5634,'fr','Enregistrer les modifications avant de sÃ©lectionner le nouvel ordre',0),(202819,5634,'jp','æ–°è¦?æ³¨æ–‡ã‚’é?¸æŠžã?™ã‚‹å‰?ã?«å¤‰æ›´ã‚’ä¿?å­˜ã?™ã‚‹',0),(202820,5634,'pt','Salvar as alteraÃ§Ãµes antes de selecionar a nova ordem',0),(202821,5634,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð”Ð¾ Ð’Ñ‹Ð±Ð¾Ñ€Ð° ÐÐ¾Ð²Ð¾Ð³Ð¾ Ð—Ð°ÐºÐ°Ð·Ð°',0),(202822,5634,'es','Guardar Cambios Antes Que Seleccionar Nuevo Pedido',0),(202823,5634,'de','Speichern von Ã„nderungen vor der Auswahl neuen Auftrag',0),(202824,5634,'en','Save Changes Before Selecting New Order',0),(202825,5635,'is','',0),(202826,5635,'dr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(202827,5635,'pr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(202828,5635,'tr','Servis sipariÅŸi zaman DÃ¼zenleyicisi',0),(202829,5635,'pl','Edytor czasu zlecenia usÅ‚ugi',0),(202830,5635,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð²Ñ€ÐµÐ¼Ðµ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¾Ñ€',0),(202831,5635,'ur','Ø®Ø¯Ù…Øª Ú©Û’ Ø¢Ø±ÚˆØ± ÙˆÙ‚Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø§Ø±',0),(202832,5635,'sr','Ð£ÑÐ»ÑƒÐ³Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð•Ð´Ð¸Ñ‚Ð¾Ñ€',0),(202833,5635,'vi','BiÃªn Táº­p Thá»i Gian ÄÆ¡n HÃ ng Dá»‹ch Vá»¥',0),(202834,5635,'af','Diensbestelling Tyd Redigeerder',0),(202835,5635,'ro','Serviciul comenzii timp Editor',0),(202836,5635,'et','Teenuse tellimuse toimetaja',0),(202837,5635,'si','Servisnega naloga Äas urednik',0),(202838,5635,'ba','Layanan urutan waktu Editor',0),(202839,5635,'nl','Service Order tijd Editor',0),(202840,5635,'fi','Palvelun tilaus aika Editor',0),(202841,5635,'no','Tjenesten for tiden Editor',0),(202842,5635,'da','Service bestil tid Editor',0),(202843,5635,'ko','ì„œë¹„ìŠ¤ ì˜¤ë” ì‹œê°„ íŽ¸ì§‘ê¸°',0),(202844,5635,'he','×©×™×¨×•×ª ×”×–×ž× ×ª ×–×ž×Ÿ ×¢×•×¨×š',0),(202845,5635,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï‡ÏÏŒÎ½Î¿Ï… ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î®',0),(202846,5635,'zh','æœåŠ¡è®¢å•æ—¶é—´ç¼–è¾‘å™¨\r\n',0),(202847,5635,'sv','TjÃ¤nsten BestÃ¤ll tid redaktÃ¶r',0),(202848,5635,'it','Servizio ordine tempo Editor',0),(202849,5635,'tl','',0),(202850,5635,'th','&#3612;&#3641;&#3657;&#3649;&#3585;&#3657;&#3652;&#3586;&#3648;&#3623;&#3621;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(202851,5635,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¸à¤®à¤¯ à¤¸à¤‚à¤ªà¤¾à¤¦à¤•',0),(202852,5635,'ms','Perkhidmatan perintah masa Editor',0),(202853,5635,'ar','Ø®Ø¯Ù…Ø© ØªØ±ØªÙŠØ¨ Ø§Ù„ÙˆÙ‚Øª Ù…Ø­Ø±Ø±',0),(202854,5635,'fr','Ã‰diteur de temps de l\'heure de commande de service',0),(202855,5635,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡æ™‚é–“ç·¨é›†',0),(202856,5635,'pt','Editor de tempo de ordem de serviÃ§o',0),(202857,5635,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¾Ñ€ Ð²Ñ€ÐµÐ¼Ñ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð°',0),(202858,5635,'es','Orden de Servicio Editor de Tiempo',0),(202859,5635,'de','Editor fÃ¼r die Zeit von Service-Bestellung',0),(202860,5635,'en','Service Order Time Editor',0),(202861,5636,'is','',0),(202862,5636,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒÙ„ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(202863,5636,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒÙ„ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(202864,5636,'tr','Toplam iÅŸÃ§i Ã¼cretleri',0),(202865,5636,'pl','CaÅ‚kowite koszty robocizny',0),(202866,5636,'bg','ÐžÐ±Ñ‰Ð¾ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ñ‚Ñ€ÑƒÐ´',0),(202867,5636,'ur','Ú©Ù„ Ù…Ø²Ø¯ÙˆØ± Ú†Ø§Ø±Ø¬Ø²',0),(202868,5636,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð·Ð° Ñ€Ð°Ð´',0),(202869,5636,'vi','Tá»•ng cá»™ng phÃ­ nhÃ¢n cÃ´ng',0),(202870,5636,'af','Totale Arbeidkostes',0),(202871,5636,'ro','Total taxe muncii',0),(202872,5636,'et','TÃ¶Ã¶jÃµu kulud kokku',0),(202873,5636,'si','Skupni stroÅ¡ki dela',0),(202874,5636,'ba','Total biaya tenaga kerja',0),(202875,5636,'nl','Totaal arbeid kosten',0),(202876,5636,'fi','YhteensÃ¤ Labour maksut',0),(202877,5636,'no','Ap. totalkostnadene',0),(202878,5636,'da','Samlede Labor omkostninger',0),(202879,5636,'ko','ì´ ë…¸ë™ ë¹„ìš©',0),(202880,5636,'he','×¡×” ×› ×—×™×•×‘×™× ×”×¢×‘×•×“×”',0),(202881,5636,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ­Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(202882,5636,'zh','äººå·¥è´¹ç”¨æ€»è®¡\r\n',0),(202883,5636,'sv','Totala Labor avgifter',0),(202884,5636,'it','Spese totali di lavoro',0),(202885,5636,'tl','',0),(202886,5636,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3588;&#3656;&#3634;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(202887,5636,'hi','à¤•à¥à¤² à¤¶à¥à¤°à¤® à¤†à¤°à¥‹à¤ª',0),(202888,5636,'ms','Jumlah caj buruh',0),(202889,5636,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ø§Ù„',0),(202890,5636,'fr','Total des droits du travail',0),(202891,5636,'jp','äººä»¶è²»ç·?é¡?',0),(202892,5636,'pt','Totais encargos trabalhistas',0),(202893,5636,'ru','ÐžÐ±Ñ‰Ð¸Ðµ Ð¸Ð·Ð´ÐµÑ€Ð¶ÐºÐ¸ Ñ‚Ñ€ÑƒÐ´Ð°',0),(202894,5636,'es','Total Cargos de Labor',0),(202895,5636,'de','Labor GesamtgebÃ¼hren',0),(202896,5636,'en','Total Labor Charges',0),(202897,5637,'is','',0),(202898,5637,'dr','ÙƒØ§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(202899,5637,'pr','ÙƒØ§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(202900,5637,'tr','Servis sipariÅŸleri iÃ§in Ã§alÄ±ÅŸma',0),(202901,5637,'pl','Praca dla zleceÅ„ serwisowych',0),(202902,5637,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(202903,5637,'ur','Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ú©Ø§Ù…',0),(202904,5637,'sr','Ð Ð°Ð´ Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(202905,5637,'vi','CÃ´ng viá»‡c cho Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(202906,5637,'af','Werk vir Diens Bestellings',0),(202907,5637,'ro','De lucru pentru comenzi de Service',0),(202908,5637,'et','TÃ¶Ã¶ta teeninduse tellmuste jaoks',0),(202909,5637,'si','Delo za servisne naloge',0),(202910,5637,'ba','Bekerja untuk layanan pesanan',0),(202911,5637,'nl','Werk voor serviceorders',0),(202912,5637,'fi','TyÃ¶n huoltotilauksille',0),(202913,5637,'no','Arbeid for serviceordrer',0),(202914,5637,'da','Arbejde for serviceordrer',0),(202915,5637,'ko','ì„œë¹„ìŠ¤ ì˜¤ë”ì— ëŒ€ í•œ ìž‘ì—…',0),(202916,5637,'he','×¢×‘×•×“×” ×¢×‘×•×¨ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(202917,5637,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(202918,5637,'zh','å·¥ä½œæœåŠ¡è®¢å•\r\n',0),(202919,5637,'sv','Arbete fÃ¶r serviceorder',0),(202920,5637,'it','Lavoro per gli ordini di servizio',0),(202921,5637,'tl','',0),(202922,5637,'th','&#3607;&#3635;&#3591;&#3634;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(202923,5637,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾à¤®',0),(202924,5637,'ms','Kerja-kerja Perkhidmatan Pesanan',0),(202925,5637,'ar','Ø§Ù„Ø¹Ù…Ù„ Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(202926,5637,'fr','Travail pour les commandes de Service',0),(202927,5637,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®ä½œæ¥­',0),(202928,5637,'pt','Trabalho para ordens de serviÃ§o',0),(202929,5637,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð´Ð»Ñ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(202930,5637,'es','Trabajo para Ordenes de Servicio',0),(202931,5637,'de','Arbeit fÃ¼r ServiceauftrÃ¤ge',0),(202932,5637,'en','Work for Service Orders',0),(202933,5638,'is','',0),(202934,5638,'dr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙƒØªÙˆØ± ',0),(202935,5638,'pr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙƒØªÙˆØ± ',0),(202936,5638,'tr','Fatura oluÅŸtur',0),(202937,5638,'pl','Tworzenie faktury',0),(202938,5638,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(202939,5638,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(202940,5638,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(202941,5638,'vi','Táº¡o hÃ³a Ä‘Æ¡n',0),(202942,5638,'af','Skep Faktuur',0),(202943,5638,'ro','Creare facturÄƒ',0),(202944,5638,'et','Loo arve',0),(202945,5638,'si','Ustvarjanje raÄuna',0),(202946,5638,'ba','Membuat faktur',0),(202947,5638,'nl','Factuur maken',0),(202948,5638,'fi','Luo lasku',0),(202949,5638,'no','Opprett faktura',0),(202950,5638,'da','Oprette faktura',0),(202951,5638,'ko','ì†¡ìž¥ ìž‘ì„±',0),(202952,5638,'he','×¦×•×¨ ×—×©×‘×•× ×™×ª',0),(202953,5638,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(202954,5638,'zh','åˆ›å»ºå‘ç¥¨\r\n',0),(202955,5638,'sv','Skapa faktura',0),(202956,5638,'it','Crea fattura',0),(202957,5638,'tl','',0),(202958,5638,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(202959,5638,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¬à¤¨à¤¾à¤à¤',0),(202960,5638,'ms','Cipta invois',0),(202961,5638,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙØ§ØªÙˆØ±Ø©',0),(202962,5638,'fr','CrÃ©er facture',0),(202963,5638,'jp','è«‹æ±‚æ›¸ã?®ä½œæˆ?',0),(202964,5638,'pt','Criar fatura',0),(202965,5638,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚',0),(202966,5638,'es','Crear Factura',0),(202967,5638,'de','Rechnung erstellen',0),(202968,5638,'en','Create Invoice',0),(202969,5639,'is','',0),(202970,5639,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ø±ÙˆÙŠØ³ Ø³ÙØ§Ø±Ø´  Ø²Ù…Ø§Ù† Ùˆ Ù¾Ø³Øª ',0),(202971,5639,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ø±ÙˆÙŠØ³ Ø³ÙØ§Ø±Ø´  Ø²Ù…Ø§Ù† Ùˆ Ù¾Ø³Øª ',0),(202972,5639,'tr','Servis sipariÅŸ saati & yazÄ± dÃ¼zenleme',0),(202973,5639,'pl','Edytuj Post & czas zlecenia usÅ‚ugi',0),(202974,5639,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‡Ð°Ñ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð· & Ð¿Ð¾ÑÑ‚',0),(202975,5639,'ur','Ø®Ø¯Ù…Øª Ø¢Ø±ÚˆØ± ÙˆÙ‚Øª & Ù¾ÙˆØ³Ù¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(202976,5639,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑƒÑÐ»ÑƒÐ³Ð° Ð²Ñ€ÐµÐ¼Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ & ÐŸÐ¾ÑÑ‚',0),(202977,5639,'vi','Sá»­a Thá»i Gian Äáº·t HÃ ng & ÄÄƒng LÃªn',0),(202978,5639,'af','Redigeer Diens Bestel Tyd & Pos',0),(202979,5639,'ro','Editare imagini comenzii timp & Post',0),(202980,5639,'et','Redigeeri teenuse tellimuse aeg & Post',0),(202981,5639,'si','Urejanje storitev ura naloga & Post',0),(202982,5639,'ba','Mengedit Layanan urutan waktu & posting',0),(202983,5639,'nl','Service Ordertijd & Post bewerken',0),(202984,5639,'fi','Muokkaa tilauksen palveluajan & Post',0),(202985,5639,'no','Redigere Service Ordretidspunkt & innlegg',0),(202986,5639,'da','Redigere Service Ordretidspunkt & indlÃ¦g',0),(202987,5639,'ko','ì„œë¹„ìŠ¤ ì˜¤ë” ì‹œê°„ & ê²Œì‹œë¬¼ íŽ¸ì§‘',0),(202988,5639,'he','×¢×¨×™×›×ª ×–×ž×Ÿ ×”×–×ž× ×ª ×©×™×¨×•×ª & ×¤×•×¡×˜',0),(202989,5639,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÏŽÏÎ± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î± & Î¸Î­ÏƒÎ·',0),(202990,5639,'zh','ç¼–è¾‘æœåŠ¡è®¢è´§æ—¶é—´å’Œé‚®æ”¿ä¸š\r\n',0),(202991,5639,'sv','Redigera tjÃ¤nsten Ordertid & inlÃ¤gg',0),(202992,5639,'it','Modificare il tempo di ordine di servizio & Post',0),(202993,5639,'tl','',0),(202994,5639,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3648;&#3623;&#3621;&#3634;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(202995,5639,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¸à¤®à¤¯ & à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤',0),(202996,5639,'ms','Edit waktu pesanan Perkhidmatan & Post',0),(202997,5639,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„ÙˆÙ‚Øª Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© Ø¢Ù†Ø¯ Ø¨ÙˆØ³Øª',0),(202998,5639,'fr','Modifier l\'heure de commande de Service & Post',0),(202999,5639,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡æ™‚é–“ã?®ç·¨é›†ã?¨è¨ˆä¸Š',0),(203000,5639,'pt','Editar o tempo da ordem de serviÃ§o & Post',0),(203001,5639,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ð±Ð¸Ð»ÐµÑ‚Ð¾Ð² & Ð¿Ð¾ÑÑ‚',0),(203002,5639,'es','Editar Orden de Servicio Tiempo & Asiento',0),(203003,5639,'de','Bearbeiten Sie Service Auftragszeit & Post',0),(203004,5639,'en','Edit Service Order Time & Post',0),(203005,5640,'is','',0),(203006,5640,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø²Ù…Ø§Ù† Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡ ',0),(203007,5640,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø²Ù…Ø§Ù† Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡ ',0),(203008,5640,'tr','GÃ¶nderilmemiÅŸ zaman DÃ¼zenle',0),(203009,5640,'pl','Edytuj niezaksiÄ™gowane czas',0),(203010,5640,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸Ñ‚Ðµ Ð²Ñ€ÐµÐ¼Ðµ',0),(203011,5640,'ur','Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ ÙˆÙ‚Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(203012,5640,'sr','ÐÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸ Ð²Ñ€Ð¸Ñ˜ÐµÐ¼Ðµ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐ°',0),(203013,5640,'vi','Sá»­a Thá»i Gian ChÆ°a ÄÄƒng LÃªn',0),(203014,5640,'af','Redigeer Ongeposde Tyd',0),(203015,5640,'ro','Editare timp neÃ®nregistrate',0),(203016,5640,'et','Redigeeri sisestamata aeg',0),(203017,5640,'si','Urejanje neknjiÅ¾enih Äas',0),(203018,5640,'ba','Mengedit Unposted waktu',0),(203019,5640,'nl','Bewerken van niet-geboekte tijd',0),(203020,5640,'fi','Kirjaamattomat viimeksi muokattu',0),(203021,5640,'no','Redigere tid',0),(203022,5640,'da','Redigere ikkebogfÃ¸rte tid',0),(203023,5640,'ko','ê²Œì‹œ ì‹œê°„ íŽ¸ì§‘',0),(203024,5640,'he','×¢×¨×™×›×ª ×–×ž×Ÿ ×©×œ× × ×¨×©×ž×•',0),(203025,5640,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼Î· Î±Î½Î±ÏÏ„Î·Î¼Î­Î½ÎµÏ‚ Ï‡ÏÏŒÎ½Î¿',0),(203026,5640,'zh','ç¼–è¾‘æœªå‘å¸ƒæ—¶é—´\r\n',0),(203027,5640,'sv','Redigera obokade tid',0),(203028,5640,'it','Modifica tempo non registrata',0),(203029,5640,'tl','',0),(203030,5640,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(203031,5640,'hi','Unposted à¤¸à¤®à¤¯ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(203032,5640,'ms','Edit masa Unposted',0),(203033,5640,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„ÙˆÙ‚Øª ØºÙŠØ± Ø§Ù„Ù…Ù†Ø´ÙˆØ±Ø©',0),(203034,5640,'fr','Modifier le temps non comptabilisÃ©s',0),(203035,5640,'jp','æœªè¨ˆä¸Šæ™‚é–“ã?®ç·¨é›†',0),(203036,5640,'pt','Editar tempo nÃ£o lanÃ§ado',0),(203037,5640,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð½ÐµÐ¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð²Ñ€ÐµÐ¼Ñ',0),(203038,5640,'es','Editar Item No Asentado',0),(203039,5640,'de','Nicht gebuchte Zeit zu bearbeiten',0),(203040,5640,'en','Edit Unposted Time',0),(203041,5641,'is','',0),(203042,5641,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´  Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ ',0),(203043,5641,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´  Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ ',0),(203044,5641,'tr','Yerine getirilmesi iÅŸleme',0),(203045,5641,'pl','SpeÅ‚nienie przetwarzania',0),(203046,5641,'bg','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(203047,5641,'ur','ØªÚ©Ù…ÛŒÙ„ Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯',0),(203048,5641,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð¾Ð±Ñ€Ð°Ð´Ðµ',0),(203049,5641,'vi','Xá»­ lÃ½ ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(203050,5641,'af','Uitvoeringsbestelling Prosesering',0),(203051,5641,'ro','ÃŽmplinirea de prelucrare',0),(203052,5641,'et','Eneseteostus tÃ¶Ã¶tlemine',0),(203053,5641,'si','Izpolnitev obdelave',0),(203054,5641,'ba','Pemenuhan pengolahan',0),(203055,5641,'nl','Vervulling Processing',0),(203056,5641,'fi','TÃ¤yttÃ¤minen kÃ¤sittely',0),(203057,5641,'no','Oppfyllelsen behandling',0),(203058,5641,'da','Opfyldelse behandling',0),(203059,5641,'ko','í–‰ ì²˜ë¦¬',0),(203060,5641,'he','×¢×™×‘×•×“ ×”×’×©×ž×”',0),(203061,5641,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(203062,5641,'zh','å®žçŽ°åŠ å·¥\r\n',0),(203063,5641,'sv','Uppfyllelse bearbetning',0),(203064,5641,'it','Elaborazione di adempimento',0),(203065,5641,'tl','',0),(203066,5641,'th','&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(203067,5641,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(203068,5641,'ms','Pemprosesan memenuhi',0),(203069,5641,'ar','ØªØ¬Ù‡ÙŠØ² ÙˆÙØ§Ø¡',0),(203070,5641,'fr','Traitement de l\'accomplissement',0),(203071,5641,'jp','é?”æˆ?å‡¦ç?†ä¸­',0),(203072,5641,'pt','Processamento de cumprimento',0),(203073,5641,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸',0),(203074,5641,'es','Procesando el Complemeto',0),(203075,5641,'de','ErfÃ¼llung-Verarbeitung',0),(203076,5641,'en','Fulfillment Processing',0),(203077,5642,'is','',0),(203078,5642,'dr','(Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡ ) Ø¯Ø± ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø®Ø¯Ù…Ø§Øª',0),(203079,5642,'pr','Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… (Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡ ) Ø¯Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª',0),(203080,5642,'tr','GÃ¼nlÃ¼k saat servis sipariÅŸleri',0),(203081,5642,'pl','Godziny dziennika zleceÅ„ serwisowych',0),(203082,5642,'bg','Ð§Ð°ÑÐ° Ð½Ð° Ñ€ÐµÐ³Ð¸ÑÑ‚ÑŠÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(203083,5642,'ur','Ù„Ø§Ú¯ Ú¯Ú¾Ù†Ù¹Û’ Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø±',0),(203084,5642,'sr','Ð•Ð²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ð° ÑÐ°Ñ‚Ð¸ Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(203085,5642,'vi','Sá»‘ giá» cho Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(203086,5642,'af','Boek Ure op Diensbestellings',0),(203087,5642,'ro','Jurnal de ore pe comenzi de Service',0),(203088,5642,'et','Hooldustellimuste Logi tundide',0),(203089,5642,'si','Dnevnik ur na servisnih nalogih',0),(203090,5642,'ba','Log jam pada layanan pesanan',0),(203091,5642,'nl','Log uren op serviceorders',0),(203092,5642,'fi','Loki tuntia huoltotilausten',0),(203093,5642,'no','Logg timer pÃ¥ serviceordrer',0),(203094,5642,'da','Log timer pÃ¥ serviceordrer',0),(203095,5642,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ì— ëŒ€í•´ ë¡œê·¸ ì‹œê°„',0),(203096,5642,'he','×™×•×ž×Ÿ ×©×¢×•×ª ×¢×œ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(203097,5642,'el','ÎÏÎµÏ‚ ÎºÎ±Ï„Î±Î³ÏÎ±Ï†Î®Ï‚ Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(203098,5642,'zh','åœ¨æœåŠ¡è®¢å•æ—¥å¿—æ—¶é—´\r\n',0),(203099,5642,'sv','Log timmar pÃ¥ serviceorder',0),(203100,5642,'it','Registro ore sugli ordini di servizio',0),(203101,5642,'tl','',0),(203102,5642,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3619;&#3632;&#3610;&#3610;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3',0),(203103,5642,'hi','à¤²à¥‰à¤— à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°',0),(203104,5642,'ms','Jam log pada pesanan Perkhidmatan',0),(203105,5642,'ar','Ø³Ø§Ø¹Ø§Øª Ø³Ø¬Ù„ ÙÙŠ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(203106,5642,'fr','Journal des heures sur les ordres de Service',0),(203107,5642,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®ãƒ­ã‚°æ™‚é–“',0),(203108,5642,'pt','Horas de log em ordens de serviÃ§o',0),(203109,5642,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ñ‡Ð°ÑÐ¾Ð² Ð¿Ð¾ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ð¼ Ð·Ð°ÐºÐ°Ð·Ð°Ð¼',0),(203110,5642,'es','Horas de BitÃ¡cora en Ordenes de Servicio',0),(203111,5642,'de','Protokoll Stunden auf ServiceauftrÃ¤ge',0),(203112,5642,'en','Log Hours on Service Orders',0),(203113,5643,'is','',0),(203114,5643,'dr','(Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡ Ø²Ù…Ø§Ù† Ø¬Ø¯ÙŠØ¯',0),(203115,5643,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø¯Ø± Ø²Ù…Ø§Ù† Ø¬Ø¯ÙŠØ¯        (Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡ Ø²Ù…Ø§Ù† Ø¬Ø¯ÙŠØ¯',0),(203116,5643,'tr','Oturum yeni zaman',0),(203117,5643,'pl','Rejestracja nowego czasu',0),(203118,5643,'bg','Ð’Ð»ÐµÐ·Ñ‚Ðµ \"Ð½Ð¾Ð²Ð¾Ñ‚Ð¾ Ð²Ñ€ÐµÐ¼Ðµ\"',0),(203119,5643,'ur','Ù†ÛŒØ§ ÙˆÙ‚Øª Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº',0),(203120,5643,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(203121,5643,'vi','Giá» Cháº¥m cÃ´ng má»›i',0),(203122,5643,'af','Log Nuwe Tyd',0),(203123,5643,'ro','Jurnal nou timp',0),(203124,5643,'et','Logige uue aja',0),(203125,5643,'si','Prijavite nov Äas',0),(203126,5643,'ba','Login baru waktu',0),(203127,5643,'nl','Meld u nieuwe tijd',0),(203128,5643,'fi','Kirjaudu uusi aika',0),(203129,5643,'no','Logg ny tid',0),(203130,5643,'da','Log ny tid',0),(203131,5643,'ko','ìƒˆë¡œìš´ ì‹œê°„ ë¡œê·¸',0),(203132,5643,'he','×ª×¢×“ ×–×ž×Ÿ ×—×“×©',0),(203133,5643,'el','Î£Ï…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Î½Î­Î± ÏŽÏÎ±',0),(203134,5643,'zh','è®°å½•æ–°æ—¶é—´\r\n',0),(203135,5643,'sv','Logga in ny tid',0),(203136,5643,'it','Accedere di nuovo orario',0),(203137,5643,'tl','',0),(203138,5643,'th','&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3619;&#3632;&#3610;&#3610;&#3588;&#3619;&#3633;&#3657;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(203139,5643,'hi','à¤¨à¤ˆ à¤¸à¤®à¤¯ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¥‡à¤‚',0),(203140,5643,'ms','Log masa baru',0),(203141,5643,'ar','ØªØ³Ø¬ÙŠÙ„ ÙˆÙ‚Øª Ø¬Ø¯ÙŠØ¯',0),(203142,5643,'fr','Connecter la nouvelle heure',0),(203143,5643,'jp','æ–°ã?—ã?„æ™‚é–“è¨˜éŒ²',0),(203144,5643,'pt','Log novo tempo',0),(203145,5643,'ru','Ð—Ð°Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ðµ Ð’Ñ€ÐµÐ¼Ñ',0),(203146,5643,'es','Poner en BitÃ¡cora Nuevo Tiempo',0),(203147,5643,'de','Melden Sie neues Zeit',0),(203148,5643,'en','Log New Time',0),(203149,5644,'is','',0),(203150,5644,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(203151,5644,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(203152,5644,'tr','Hizmet iÅŸleme',0),(203153,5644,'pl','UsÅ‚ugi przetwarzania',0),(203154,5644,'bg','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð°Ñ‚Ð°',0),(203155,5644,'ur','Ø®Ø¯Ù…Øª Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯',0),(203156,5644,'sr','Ð£ÑÐ»ÑƒÐ³Ð° Ð¾Ð±Ñ€Ð°Ð´Ðµ',0),(203157,5644,'vi','Xá»­ lÃ½ dá»‹ch vá»¥',0),(203158,5644,'af','Diens Prossesering',0),(203159,5644,'ro','Procesare comanda service',0),(203160,5644,'et','Teenuse tÃ¶Ã¶tlemine',0),(203161,5644,'si','Storitve obdelave',0),(203162,5644,'ba','Jasa pemrosesan',0),(203163,5644,'nl','Service Processing',0),(203164,5644,'fi','Palvelu kÃ¤sittely',0),(203165,5644,'no','Tjenesten behandling',0),(203166,5644,'da','Service behandling',0),(203167,5644,'ko','ì„œë¹„ìŠ¤ ì²˜ë¦¬',0),(203168,5644,'he','×©×™×¨×•×ª ×¢×™×‘×•×“',0),(203169,5644,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(203170,5644,'zh','æœåŠ¡å¤„ç†\r\n',0),(203171,5644,'sv','TjÃ¤nsten bearbetning',0),(203172,5644,'it','Servizio elaborazione',0),(203173,5644,'tl','',0),(203174,5644,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(203175,5644,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(203176,5644,'ms','Perkhidmatan pemprosesan',0),(203177,5644,'ar','ØªØ¬Ù‡ÙŠØ² Ø§Ù„Ø®Ø¯Ù…Ø©',0),(203178,5644,'fr','Traitement du service',0),(203179,5644,'jp','ã‚µãƒ¼ãƒ“ã‚¹å‡¦ç?†ä¸­',0),(203180,5644,'pt','Processamento de serviÃ§o',0),(203181,5644,'ru','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð¾Ð´ÐµÐ¶Ð´Ñ‹',0),(203182,5644,'es','Procesando Ordenes de Servicios',0),(203183,5644,'de','Serviceabwicklung',0),(203184,5644,'en','Service Processing',0),(203185,5645,'is','',0),(203186,5645,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ ',0),(203187,5645,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ ',0),(203188,5645,'tr','SipariÅŸ ayrÄ±ntÄ±larÄ±nÄ± gÃ¶rÃ¼ntÃ¼leme',0),(203189,5645,'pl','Zobacz szczegÃ³Å‚y zamÃ³wienia',0),(203190,5645,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(203191,5645,'ur','Ø¢Ø±ÚˆØ± ØªÙØ§ØµÛŒÙ„ Ù…Ù†Ø¸Ø±',0),(203192,5645,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð´ÐµÑ‚Ð°Ñ™Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(203193,5645,'vi','Xem Ä‘Æ¡n hÃ ng chi tiáº¿t',0),(203194,5645,'af','Besigtig Bestelling Besonderhede',0),(203195,5645,'ro','Vezi detalii comanda',0),(203196,5645,'et','Vaata tellimuse andmeid',0),(203197,5645,'si','Ogled podrobnosti o naroÄilu',0),(203198,5645,'ba','Lihat rincian pesanan',0),(203199,5645,'nl','Weergave Orderinformatie',0),(203200,5645,'fi','NÃ¤ytÃ¤ tilauksen tiedot',0),(203201,5645,'no','Vis Ordredetaljer',0),(203202,5645,'da','Se ordreoplysninger',0),(203203,5645,'ko','ì£¼ë¬¸ ì„¸ë¶€ ì •ë³´ ë³´ê¸°',0),(203204,5645,'he','×”×¦×’ ×¤×¨×˜×™ ×”×–×ž× ×”',0),(203205,5645,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(203206,5645,'zh','æŸ¥çœ‹è®¢å•è¯¦ç»†ä¿¡æ¯\r\n',0),(203207,5645,'sv','Visa Orderdetaljer',0),(203208,5645,'it','Maggiori dettagli ordine',0),(203209,5645,'tl','',0),(203210,5645,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(203211,5645,'hi','à¤‘à¤°à¥à¤¡à¤° à¤µà¤¿à¤µà¤°à¤£ à¤¦à¥‡à¤–à¥‡à¤‚',0),(203212,5645,'ms','Butir-butir pesanan View',0),(203213,5645,'ar','Ø¹Ø±Ø¶ ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(203214,5645,'fr','Voir les dÃ©tails de commande',0),(203215,5645,'jp','æ³¨æ–‡è©³ç´°ã?®è¡¨ç¤º',0),(203216,5645,'pt','Ver os detalhes do pedido',0),(203217,5645,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð”ÐµÑ‚Ð°Ð»ÐµÐ¹ Ð—Ð°ÐºÐ°Ð·Ð°',0),(203218,5645,'es','Ver Detalles de Orden',0),(203219,5645,'de','Order Details anzeigen',0),(203220,5645,'en','View Order Details',0),(203221,5646,'is','',0),(203222,5646,'dr','Ù‡ÙŠÚ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª',0),(203223,5646,'pr','Ù‡ÙŠÚ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª',0),(203224,5646,'tr','HayÄ±r faturalandÄ±rÄ±lmamÄ±ÅŸ',0),(203225,5646,'pl','Nie nieopÅ‚aconych',0),(203226,5646,'bg','ÐÐµ Unbilled',0),(203227,5646,'ur','Ù†ÛÛŒÚº ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„',0),(203228,5646,'sr','ÐÐµ Ð£Ð½Ð±Ð¸Ð»Ð»ÐµÐ´',0),(203229,5646,'vi','khÃ´ng cÃ³ chÆ°a ra hÃ³a Ä‘Æ¡n',0),(203230,5646,'af','Geen Ongefaktureerd',0),(203231,5646,'ro','Nu Unbilled',0),(203232,5646,'et','Ilma arveta ei ole',0),(203233,5646,'si','Ne Unbilled',0),(203234,5646,'ba','Tidak tertagih',0),(203235,5646,'nl','Geen ongefactureerde',0),(203236,5646,'fi','Ei Unbilled',0),(203237,5646,'no','Ikke fakturert',0),(203238,5646,'da','Ikke faktureret',0),(203239,5646,'ko','ì•„ë‹ˆ ë°',0),(203240,5646,'he','×œ× Unbilled',0),(203241,5646,'el','Î”ÎµÎ½ Î±Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î·',0),(203242,5646,'zh','æ²¡æœ‰æœªå¼€å•\r\n',0),(203243,5646,'sv','Inte relaterade',0),(203244,5646,'it','No attivitÃ  non ancora fatturate',0),(203245,5646,'tl','',0),(203246,5646,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(203247,5646,'hi','à¤•à¥‹à¤ˆ Unbilled',0),(203248,5646,'ms','Tidak lepas',0),(203249,5646,'ar','Ù„Ø§ ÙÙˆØ§ØªÙŠØ±',0),(203250,5646,'fr','Non non facturÃ©s',0),(203251,5646,'jp','æœªè«‹æ±‚ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(203252,5646,'pt','NÃ£o faturada',0),(203253,5646,'ru','ÐÐµ Ð½ÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ…',0),(203254,5646,'es','No Hay No Facturados',0),(203255,5646,'de','Nein noch nicht fakturierte',0),(203256,5646,'en','No Unbilled',0),(203257,5647,'is','',0),(203258,5647,'dr','Ú†Ø§Ù¾ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(203259,5647,'pr','Ú†Ø§Ù¾ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(203260,5647,'tr','Fatura YazdÄ±r',0),(203261,5647,'pl','Drukowanie faktur',0),(203262,5647,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(203263,5647,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(203264,5647,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(203265,5647,'vi','In hÃ³a Ä‘Æ¡n',0),(203266,5647,'af','Druk Fakture',0),(203267,5647,'ro','TipÄƒriÅ£i facturi',0),(203268,5647,'et','TrÃ¼ki Arved',0),(203269,5647,'si','Tiskanje raÄunov',0),(203270,5647,'ba','Faktur cetak',0),(203271,5647,'nl','Facturen afdrukken',0),(203272,5647,'fi','Tulostaa laskuja',0),(203273,5647,'no','Skrive ut fakturaer',0),(203274,5647,'da','Udskrive fakturaer',0),(203275,5647,'ko','ì¸ë³´ì´ìŠ¤ë¥¼ ì¸ì‡„',0),(203276,5647,'he','×”×“×¤×¡ ×—×©×‘×•× ×™×•×ª',0),(203277,5647,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(203278,5647,'zh','æ‰“å°å‘ç¥¨\r\n',0),(203279,5647,'sv','Skriva ut fakturor',0),(203280,5647,'it','Stampare le fatture',0),(203281,5647,'tl','',0),(203282,5647,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(203283,5647,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(203284,5647,'ms','Mencetak invois',0),(203285,5647,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(203286,5647,'fr','Imprimer des factures',0),(203287,5647,'jp','è«‹æ±‚æ›¸ã?®å?°åˆ·',0),(203288,5647,'pt','Imprimir facturas',0),(203289,5647,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(203290,5647,'es','Imprimir Facturas',0),(203291,5647,'de','Rechnungen drucken',0),(203292,5647,'en','Print Invoices',0),(203293,5648,'is','',0),(203294,5648,'dr','Ù‡ÙŠÚ† Ù…Ø­Ù„ÙŠ Ù…Ø´Ø®Øµ Ù†Ø´Ø¯Ù‡ ',0),(203295,5648,'pr','Ù‡ÙŠÚ† Ù…Ø­Ù„ÙŠ Ù…Ø´Ø®Øµ Ù†Ø´Ø¯Ù‡ ',0),(203296,5648,'tr','Belirtilen konum',0),(203297,5648,'pl','Nie lokalizacji okreÅ›lonej',0),(203298,5648,'bg','ÐÑÐ¼Ð° ÑƒÐºÐ°Ð·Ð°Ð½Ð¾Ñ‚Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(203299,5648,'ur','Ú©Ø³ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Ø§ Ø§Ø®ØªØµØ§Øµ',0),(203300,5648,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð½Ð°Ð²ÐµÐ´ÐµÐ½Ð°',0),(203301,5648,'vi','KhÃ´ng vá»‹ trÃ­ cá»¥ thá»ƒ',0),(203302,5648,'af','Geen Ligging Gespesifisser',0),(203303,5648,'ro','Nici locaÅ£ia specificatÄƒ',0),(203304,5648,'et','Ãœhtki asukohta pole mÃ¤Ã¤ratud',0),(203305,5648,'si','No mesto, navedeno',0),(203306,5648,'ba','Tidak ada lokasi yang ditentukan',0),(203307,5648,'nl','Geen locatie gespecificeerd',0),(203308,5648,'fi','MÃ¤Ã¤ritetty sijainti',0),(203309,5648,'no','Ingen plasseringen som er angitt',0),(203310,5648,'da','Ingen angivne placering',0),(203311,5648,'ko','ì§€ì • ëœ ìœ„ì¹˜ê°€ ì—†ê³ ',0),(203312,5648,'he','××™×Ÿ ×‘×ž×™×§×•× ×©×¦×•×™×Ÿ',0),(203313,5648,'el','ÎšÎ±Î¼Î¯Î± Î¸Î­ÏƒÎ· Ï€Î¿Ï… ÎºÎ±Î¸Î¿ÏÎ¯Î¶ÎµÏ„Î±Î¹',0),(203314,5648,'zh','æ²¡æœ‰æŒ‡å®šä½ç½®\r\n',0),(203315,5648,'sv','Ingen plats anges',0),(203316,5648,'it','Nessuna locazione specificata',0),(203317,5648,'tl','',0),(203318,5648,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3592;&#3634;&#3632;&#3592;&#3591;',0),(203319,5648,'hi','à¤•à¥‹à¤ˆ à¤¸à¥à¤¥à¤¾à¤¨ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ',0),(203320,5648,'ms','Tiada lokasi yang ditetapkan',0),(203321,5648,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…ÙˆÙ‚Ø¹ Ù…Ø­Ø¯Ø¯',0),(203322,5648,'fr','Aucun emplacement spÃ©cifiÃ©',0),(203323,5648,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã?Œç‰¹å®šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(203324,5648,'pt','Nenhum local especificado',0),(203325,5648,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ðµ ÑƒÐºÐ°Ð·Ð°Ð½Ð¾',0),(203326,5648,'es','No hay UbicaciÃ³n Especificada',0),(203327,5648,'de','Kein Ort angegeben',0),(203328,5648,'en','No Location Specified',0),(203329,5649,'is','',0),(203330,5649,'dr','Ø®Ø¯Ù…Ø§Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ø¯Ù‡ ',0),(203331,5649,'pr','Ø®Ø¯Ù…Ø§Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ø¯Ù‡ ',0),(203332,5649,'tr','Ä°stenen hizmet',0),(203333,5649,'pl','UsÅ‚ugi wymagane',0),(203334,5649,'bg','Ð˜ÑÐºÐ°Ð½Ð°Ñ‚Ð° ÑƒÑÐ»ÑƒÐ³Ð°',0),(203335,5649,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ Ø®Ø¯Ù…Øª',0),(203336,5649,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°Ð½Ñƒ ÑƒÑÐ»ÑƒÐ³Ñƒ',0),(203337,5649,'vi','YÃªu cáº§u dá»‹ch vá»¥',0),(203338,5649,'af','Diens Versoek ',0),(203339,5649,'ro','Serviciul solicitat',0),(203340,5649,'et','Teenusest',0),(203341,5649,'si','Zahtevano storitev',0),(203342,5649,'ba','Layanan yang diminta',0),(203343,5649,'nl','Gevraagde dienst',0),(203344,5649,'fi','Halutun palvelun',0),(203345,5649,'no','Tjenesten forespurt',0),(203346,5649,'da','Ã˜nskede tjeneste',0),(203347,5649,'ko','ì„œë¹„ìŠ¤ ìš”ì²­',0),(203348,5649,'he','×”×©×™×¨×•×ª ×”×ž×‘×•×§×©',0),(203349,5649,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î¿Ï… Î¶Î·Ï„ÎµÎ¯Ï„Î±Î¹',0),(203350,5649,'zh','æœåŠ¡è¯·æ±‚\r\n',0),(203351,5649,'sv','BegÃ¤rda tjÃ¤nsten',0),(203352,5649,'it','Servizio richiesto',0),(203353,5649,'tl','',0),(203354,5649,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(203355,5649,'hi','à¤…à¤¨à¥à¤°à¥‹à¤§à¤¿à¤¤ à¤¸à¥‡à¤µà¤¾',0),(203356,5649,'ms','Perkhidmatan yang diminta',0),(203357,5649,'ar','Ø§Ù„Ø®Ø¯Ù…Ø© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(203358,5649,'fr','Service demandÃ©',0),(203359,5649,'jp','è¦?æ±‚ã?•ã‚Œã?Ÿã‚µãƒ¼ãƒ“ã‚¹',0),(203360,5649,'pt','ServiÃ§o solicitado',0),(203361,5649,'ru','Ð¡Ð»ÑƒÐ¶Ð±Ð° Ð¿Ñ€Ð¾ÑÐ¸Ð»Ð°',0),(203362,5649,'es','Servicio Pedido',0),(203363,5649,'de','GewÃ¼nschten Dienst',0),(203364,5649,'en','Service Requested',0),(203365,5650,'is','',0),(203366,5650,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø²Ù…Ø§Ù† ÙƒØ§Ø± Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(203367,5650,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø²Ù…Ø§Ù† ÙƒØ§Ø± Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(203368,5650,'tr','Emek zaman sipariÅŸine Ekle',0),(203369,5650,'pl','Dodaj czas pracy na zamÃ³wienie',0),(203370,5650,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ñ‚Ñ€ÑƒÐ´Ð¾Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(203371,5650,'ur','Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…Ø­Ù†Øª ÙˆÙ‚Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(203372,5650,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ñ€Ð°Ð´Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð´Ð° Ð½Ð°Ð»Ð¾Ð³',0),(203373,5650,'vi','ThÃªm Giá» NhÃ¢n CÃ´ng Cho ÄÆ¡n Äáº·t HÃ ng',0),(203374,5650,'af','Arbeidtyd om te Bestel Byvoeg',0),(203375,5650,'ro','Adauga timp de lucru la comanda',0),(203376,5650,'et','Lisa Labor aega, et',0),(203377,5650,'si','Dodaj Labor Äas po naroÄilu',0),(203378,5650,'ba','Menambahkan waktu tenaga kerja untuk Order',0),(203379,5650,'nl','Arbeid tijd toevoegen aan bestelling',0),(203380,5650,'fi','LisÃ¤Ã¤ tyÃ¶mÃ¤Ã¤rÃ¤ aikaa tilata',0),(203381,5650,'no','Legge til Ap. tid til ordre',0),(203382,5650,'da','TilfÃ¸je Labor tid til ordre',0),(203383,5650,'ko','ë…¸ë™ ì‹œê°„ ìˆœì„œì— ì¶”ê°€',0),(203384,5650,'he','×”×•×¡×£ ×–×ž×Ÿ ×¢×‘×•×“×” ×œ×”×–×ž× ×”',0),(203385,5650,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï‡ÏÏŒÎ½Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î·',0),(203386,5650,'zh','å¢žåŠ åŠ³åŠ¨æ—¶é—´è®¢è´­\r\n',0),(203387,5650,'sv','LÃ¤gga till Labor tid i bestÃ¤llning',0),(203388,5650,'it','Aggiungere ora lavoro all\'ordine',0),(203389,5650,'tl','',0),(203390,5650,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(203391,5650,'hi','à¤¶à¥à¤°à¤® à¤¸à¤®à¤¯ à¤•à¥‹ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(203392,5650,'ms','Tambah masa buruh kepada perintah',0),(203393,5650,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆÙ‚Øª Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù†Ø¸Ø§Ù…',0),(203394,5650,'fr','Ajouter Main d\'Oeuvre a une Commande',0),(203395,5650,'jp','æ³¨æ–‡ã?®åŠ´åƒ?æ™‚é–“ã?®è¿½åŠ ',0),(203396,5650,'pt','Adicionar tempo trabalhista Ã  ordem',0),(203397,5650,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ñ€ÑƒÐ´Ð° Ð²Ñ€ÐµÐ¼Ñ Ð½Ð° Ð·Ð°ÐºÐ°Ð·',0),(203398,5650,'es','Agregar Horas de Trabajo al Pedido',0),(203399,5650,'de','Labor Zeit Bestellung hinzufÃ¼gen',0),(203400,5650,'en','Add Labor Time to Order',0),(203401,5651,'is','',0),(203402,5651,'dr','/ Ø§Ø±Ø³Ø§Ù„  Ø³Ø§Ø¹Ø§Øª Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡ ',0),(203403,5651,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ / Ø§Ø±Ø³Ø§Ù„  Ø³Ø§Ø¹Ø§Øª Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡ ',0),(203404,5651,'tr','DÃ¼zenle/deftere nakledilmemiÅŸ saat',0),(203405,5651,'pl','Edytuj Post niezaksiÄ™gowane godziny',0),(203406,5651,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ð¿Ð¾ÑÑ‚ Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸Ñ‚Ðµ Ñ‡Ð°ÑÐ°',0),(203407,5651,'ur','ØªØ¯ÙˆÛŒÙ†/Ù¾ÙˆØ³Ù¹ Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª',0),(203408,5651,'sr','Ð£Ñ€ÐµÐ´Ð¸ /ÐŸÐ¾ÑÑ‚ Ð½ÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ ÑÐ°Ñ‚Ð¸',0),(203409,5651,'vi','Sá»­a/Káº¿t Chuyá»ƒn nhá»¯ng giá» chÆ°a káº¿t chuyá»ƒn',0),(203410,5651,'af','Redigeer/Pos Ongeposteerde Ure',0),(203411,5651,'ro','Editare/Post neÃ®ncÄƒrcate ore',0),(203412,5651,'et','Edit/Post sisestamata tundi',0),(203413,5651,'si','Uredi/Post neknjiÅ¾enih ur',0),(203414,5651,'ba','Edit posting Unposted jam',0),(203415,5651,'nl','Bewerken/Post niet-doorgevoerde uur',0),(203416,5651,'fi','Muokkaa/kirjaa kirjaamattomat tunnit',0),(203417,5651,'no','Rediger/Post timer',0),(203418,5651,'da','Rediger/indlÃ¦g ikke-bogfÃ¸rte timer',0),(203419,5651,'ko','íŽ¸ì§‘/í¬ìŠ¤íŠ¸ ê²Œì‹œ ì‹œê°„',0),(203420,5651,'he','×©×¢×•×ª ×©×œ× × ×¨×©×ž×• ×¢×¨×™×›×”/×¨×™×©×•×',0),(203421,5651,'el','ÎœÎ· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±/Post ÏŽÏÎµÏ‚',0),(203422,5651,'zh','ç¼–è¾‘/å°æ—¶åŽæœªå‘å¸ƒ\r\n',0),(203423,5651,'sv','Redigera/Post ej bokfÃ¶rda timmar',0),(203424,5651,'it','Modifica/Post non registrate ore',0),(203425,5651,'tl','',0),(203426,5651,'th','&#3649;&#3585;&#3657;&#3652;&#3586;/&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; &#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&',0),(203427,5651,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚/à¤ªà¥‹à¤¸à¥à¤Ÿ Unposted à¤˜à¤‚à¤Ÿà¥‡',0),(203428,5651,'ms','Unposted Edit Post jam',0),(203429,5651,'ar','ØªØ­Ø±ÙŠØ±/ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…Ø±Ø­Ù„ Ø³Ø§Ø¹Ø§Øª',0),(203430,5651,'fr','Heures non comptabilisÃ©es Edit/Post',0),(203431,5651,'jp','æœªè¨ˆä¸Šæ™‚é–“ã?®ç·¨é›†/è¨ˆä¸Š',0),(203432,5651,'pt','Edit/Post nÃ£o lanÃ§adas horas',0),(203433,5651,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ/Ð¿Ð¾ÑÑ‚ Ð½ÐµÐ¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ñ‡Ð°ÑÐ¾Ð²',0),(203434,5651,'es','Editar/Asentar Horas no Asentados',0),(203435,5651,'de','Bearbeiten/Post ungebuchte Stunden',0),(203436,5651,'en','Edit/Post Unposted Hours',0),(203437,5652,'is','',0),(203438,5652,'dr','Ø§ÙƒÙ†ÙˆÙ† ÙØ§ÙƒØªÙˆØ± Ø´ÙˆØ¯',0),(203439,5652,'pr','Ø§ÙƒÙ†ÙˆÙ† ÙØ§ÙƒØªÙˆØ± Ø´ÙˆØ¯',0),(203440,5652,'tr','Åžimdi fatura',0),(203441,5652,'pl','Teraz faktury',0),(203442,5652,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° ÑÐµÐ³Ð°',0),(203443,5652,'ur','Ø§Ø¨ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(203444,5652,'sr','Ð¡Ð°Ð´Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(203445,5652,'vi','HÃ³a Ä‘Æ¡n bÃ¢y giá»',0),(203446,5652,'af','Faktuur nou',0),(203447,5652,'ro','FacturÄƒ acum',0),(203448,5652,'et','Arve nÃ¼Ã¼d',0),(203449,5652,'si','RaÄun zdaj',0),(203450,5652,'ba','Faktur sekarang',0),(203451,5652,'nl','Factuur nu',0),(203452,5652,'fi','Laskuta nyt',0),(203453,5652,'no','Faktura nÃ¥',0),(203454,5652,'da','Fakturaen nu',0),(203455,5652,'ko','ì§€ê¸ˆ ì†¡ìž¥',0),(203456,5652,'he','×—×©×‘×•× ×™×ª ×¢×›×©×™×•',0),(203457,5652,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„ÏŽÏÎ±',0),(203458,5652,'zh','çŽ°åœ¨å‘ç¥¨\r\n',0),(203459,5652,'sv','Faktura nu',0),(203460,5652,'it','Fattura ora',0),(203461,5652,'tl','',0),(203462,5652,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3603;&#3632;&#3609;&#3637;&#3657;',0),(203463,5652,'hi','à¤…à¤¬ à¤šà¤¾à¤²à¤¾à¤¨',0),(203464,5652,'ms','Invois sekarang',0),(203465,5652,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¢Ù†',0),(203466,5652,'fr','Facture maintenant',0),(203467,5652,'jp','ä»Šè«‹æ±‚ã?™ã‚‹',0),(203468,5652,'pt','Factura agora',0),(203469,5652,'ru','Ð¡Ñ‡ÐµÑ‚ ÑÐµÐ¹Ñ‡Ð°Ñ',0),(203470,5652,'es','Factura Ahora',0),(203471,5652,'de','Rechnung jetzt',0),(203472,5652,'en','Invoice Now',0),(203473,5653,'is','',0),(203474,5653,'dr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² ÙƒÙ„ÙŠÙƒ ÙƒØ±Ø¯Ù† ',0),(203475,5653,'pr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² ÙƒÙ„ÙŠÙƒ ÙƒØ±Ø¯Ù† ',0),(203476,5653,'tr','Yi tÄ±klatmadan Ã¶nce deÄŸiÅŸiklikleri kaydetmek',0),(203477,5653,'pl','ZapisaÄ‡ zmiany przed klikniÄ™ciem przycisku',0),(203478,5653,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ',0),(203479,5653,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±Ù†Û’ Ø³Û’ Ù¾ÛÙ„Û’',0),(203480,5653,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð¿Ñ€Ðµ Ð½ÐµÐ³Ð¾ ÑˆÑ‚Ð¾ ÐºÐ»Ð¸ÐºÐ½ÐµÑ‚Ðµ',0),(203481,5653,'vi','Sao lÆ°u thay Ä‘á»•i TrÆ°á»›c khi nháº¥p',0),(203482,5653,'af','Stoor Veranderinge VOOR u Kliek',0),(203483,5653,'ro','SalvaÅ£i modificÄƒrile Ã®nainte de clic pe',0),(203484,5653,'et','Salvesta muudatused ENNE klÃµpsamist',0),(203485,5653,'si','Preden kliknete Shrani spremembe',0),(203486,5653,'ba','Simpan perubahan sebelum mengklik',0),(203487,5653,'nl','Wijzigingen opslaan voordat u klikt op',0),(203488,5653,'fi','Tallenna muutokset ennen kuin valitset',0),(203489,5653,'no','Lagre endringer fÃ¸r du klikker',0),(203490,5653,'da','Gemme Ã¦ndringer, fÃ¸r du klikker pÃ¥',0),(203491,5653,'ko','í´ë¦­ í•˜ê¸° ì „ì— ë³€ê²½ ì‚¬í•­ì„ ì €ìž¥í•©ë‹ˆë‹¤',0),(203492,5653,'he','×œ×©×ž×•×¨ ×©×™× ×•×™×™× ×œ×¤× ×™ ×œ×—×™×¦×”',0),(203493,5653,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï„Ï‰Î½ Î±Î»Î»Î±Î³ÏŽÎ½ Ï€ÏÎ¹Î½ Î½Î± ÎºÎ¬Î½ÎµÏ„Îµ ÎºÎ»Î¹Îº',0),(203494,5653,'zh','ç„¶åŽå†ç‚¹å‡»ä¿å­˜æ›´æ”¹\r\n',0),(203495,5653,'sv','Spara Ã¤ndringar innan du klickar pÃ¥',0),(203496,5653,'it','Salvare le modifiche prima di fare clic',0),(203497,5653,'tl','',0),(203498,5653,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3656;&#3629;&#3609;&#3588;&#3621;&#3636;&#3585;',0),(203499,5653,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡',0),(203500,5653,'ms','Menyimpan perubahan sebelum klik',0),(203501,5653,'ar','Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ù„Ù†Ù‚Ø± ÙÙˆÙ‚',0),(203502,5653,'fr','Enregistrer les modifications avant de cliquer sur',0),(203503,5653,'jp','ã‚¯ãƒªãƒƒã‚¯ã?™ã‚‹å‰?ã?«å¤‰æ›´ã‚’ä¿?å­˜',0),(203504,5653,'pt','Salvar as alteraÃ§Ãµes antes de clicar em',0),(203505,5653,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð”Ðž ÐÐ°Ð¶Ð°Ñ‚Ð¸Ñ',0),(203506,5653,'es','Guardar Cambios ANTES QUE Click',0),(203507,5653,'de','Speichern Sie Ã„nderungen, bevor Sie auf',0),(203508,5653,'en','Save Changes BEFORE Clicking',0),(203509,5654,'is','',0),(203510,5654,'dr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(203511,5654,'pr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(203512,5654,'tr','Bu sÄ±rada tamamladÄ±',0),(203513,5654,'pl','To zamÃ³wienie zostaÅ‚o zakoÅ„czone',0),(203514,5654,'bg','Ð¢Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ðµ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð°',0),(203515,5654,'ur','Ø§Ø³ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(203516,5654,'sr','ÐžÐ²Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½Ð°',0),(203517,5654,'vi','ÄÆ¡n hÃ ng nÃ y Ä‘Ã£ hoÃ n thÃ nh',0),(203518,5654,'af','Hierdie bestelling is Voltooi',0),(203519,5654,'ro','Acest ordin a fost finalizat',0),(203520,5654,'et','Tellimuse lÃµpule',0),(203521,5654,'si','Ta naloga je bila dokonÄana',0),(203522,5654,'ba','Urutan ini telah selesai',0),(203523,5654,'nl','Deze bestelling is voltooid',0),(203524,5654,'fi','TÃ¤mÃ¤ tilaus on valmis',0),(203525,5654,'no','Denne bestillingen er fullfÃ¸rt',0),(203526,5654,'da','Denne ordre er afsluttet',0),(203527,5654,'ko','ì´ ì£¼ë¬¸ì´ ì™„ë£Œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(203528,5654,'he','×¦×• ×–×” ×”×•×©×œ×ž×”',0),(203529,5654,'el','Î‘Ï…Ï„Î® Î· ÏƒÎµÎ¹ÏÎ¬ Î­Ï‡ÎµÎ¹ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(203530,5654,'zh','æ­¤è®¢å•å·²å®Œæˆ\r\n',0),(203531,5654,'sv','Denna ordning har slutfÃ¶rts',0),(203532,5654,'it','Questo ordine Ã¨ stato completato',0),(203533,5654,'tl','',0),(203534,5654,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(203535,5654,'hi','à¤¯à¤¹ à¤•à¥à¤°à¤® à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤šà¥à¤•à¤¾ à¤¹à¥ˆ',0),(203536,5654,'ms','Perintah ini telah siap',0),(203537,5654,'ar','ÙˆÙ‚Ø¯ Ø§ÙƒØªÙ…Ù„ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(203538,5654,'fr','Ce dÃ©cret a Ã©tÃ© complÃ©tÃ©',0),(203539,5654,'jp','ã?“ã?®æ³¨æ–‡ã?¯å®Œäº†ã?—ã?¾ã?—ã?Ÿ',0),(203540,5654,'pt','Esta ordem foi concluÃ­da',0),(203541,5654,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð±Ñ‹Ð» Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½',0),(203542,5654,'es','Este Orden se CompletÃ³',0),(203543,5654,'de','Dieser Auftrag ist abgeschlossen',0),(203544,5654,'en','This order has been Completed',0),(203545,5655,'is','',0),(203546,5655,'dr','(Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡',0),(203547,5655,'pr','Ù†Ù…Ø§ÙŠØ´ Ø²Ù…Ø§Ù† ÙƒØ§Ø±(Ø¯Ø³ØªÙ…Ø²Ø¯',0),(203548,5655,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ Ã§alÄ±ÅŸma zamanÄ±',0),(203549,5655,'pl','Widok czas pracy',0),(203550,5655,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ñ‚Ñ€ÑƒÐ´Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(203551,5655,'ur','ÙˆÛŒÙˆ Ú©Û’ Ù…Ø²Ø¯ÙˆØ± ÙˆÙ‚Øª',0),(203552,5655,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ€Ð°Ð´Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(203553,5655,'vi','Xem giá» nhÃ¢n cÃ´ng',0),(203554,5655,'af','Besigtig Arbeid Tyd',0),(203555,5655,'ro','Vezi timpul muncii',0),(203556,5655,'et','Vaata tÃ¶Ã¶aega',0),(203557,5655,'si','Pogled dela Äasa',0),(203558,5655,'ba','Waktu lihat tenaga kerja',0),(203559,5655,'nl','Arbeid weergavetijd',0),(203560,5655,'fi','NÃ¤ytÃ¤ tyÃ¶mÃ¤Ã¤rÃ¤ aika',0),(203561,5655,'no','Se Ap tid',0),(203562,5655,'da','Se Labor tid',0),(203563,5655,'ko','ë³´ê¸° ë…¸ë™ ì‹œê°„',0),(203564,5655,'he','×ª×¦×•×’×ª ×–×ž×Ÿ ×”×¢×‘×•×“×”',0),(203565,5655,'el','Î ÏÎ¿Î²Î¿Î»Î® ÏŽÏÎ± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(203566,5655,'zh','æŸ¥çœ‹åŠ³åŠ¨æ—¶é—´\r\n',0),(203567,5655,'sv','Visa Labor tid',0),(203568,5655,'it','Visualizzazione tempo lavoro',0),(203569,5655,'tl','',0),(203570,5655,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(203571,5655,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¶à¥à¤°à¤® à¤¸à¤®à¤¯',0),(203572,5655,'ms','Pandangan buruh masa',0),(203573,5655,'ar','Ø¹Ø±Ø¶ ÙˆÙ‚Øª Ø§Ù„Ø¹Ù…Ù„',0),(203574,5655,'fr','Vue du travail temps',0),(203575,5655,'jp','åŠ´åƒ?æ™‚é–“ã?®è¡¨ç¤º',0),(203576,5655,'pt','Vista do trabalho tempo',0),(203577,5655,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð¸ Ñ‚Ñ€ÑƒÐ´Ð°',0),(203578,5655,'es','Visionar Tiempo Laboral',0),(203579,5655,'de','Ansicht Arbeit Zeit',0),(203580,5655,'en','View Labor Time',0),(203581,5656,'is','',0),(203582,5656,'dr','Ù†Ø§Ø¸Ø± Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(203583,5656,'pr','Ù†Ø§Ø¸Ø± Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(203584,5656,'tr','Servis sipariÅŸi zaman GÃ¶rÃ¼ntÃ¼leyici',0),(203585,5656,'pl','PodglÄ…d czas zamÃ³wienia usÅ‚ugi',0),(203586,5656,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð²Ñ€ÐµÐ¼Ðµ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(203587,5656,'ur','Ø®Ø¯Ù…Øª Ú©Û’ Ø¢Ø±ÚˆØ± ÙˆÙ‚Øª Ù†Ø§Ø¸Ø±',0),(203588,5656,'sr','Ð£ÑÐ»ÑƒÐ³Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð’Ð¸ÐµwÐµÑ€',0),(203589,5656,'vi','Xem Thá»i Gian ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(203590,5656,'af','Diensbestelling Tydsbesigtiger',0),(203591,5656,'ro','Serviciul comenzii timp Viewer',0),(203592,5656,'et','Teenuse tellimuse aeg vaataja',0),(203593,5656,'si','Servisnega naloga Äas gledalec',0),(203594,5656,'ba','Layanan urutan waktu Viewer',0),(203595,5656,'nl','Service Order tijd Viewer',0),(203596,5656,'fi','Palvelun tilauksen kertaa katsojan',0),(203597,5656,'no','Tjenesten for tiden Viewer',0),(203598,5656,'da','Service bestil tid Viewer',0),(203599,5656,'ko','ì„œë¹„ìŠ¤ ì˜¤ë” ì‹œê°„ ë·°ì–´',0),(203600,5656,'he','×©×™×¨×•×ª ×¡×“×¨ ×”×–×ž×Ÿ ×”×¦×•×¤×”',0),(203601,5656,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï‡ÏÏŒÎ½Î¿ Ï€ÏÎ¿Î²Î¿Î»Î®Ï‚',0),(203602,5656,'zh','æœåŠ¡è®¢å•æ—¶é—´æŸ¥çœ‹å™¨\r\n',0),(203603,5656,'sv','TjÃ¤nsten BestÃ¤ll tid Viewer',0),(203604,5656,'it','Servizio ordine tempo Viewer',0),(203605,5656,'tl','',0),(203606,5656,'th','&#3612;&#3641;&#3657;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3623;&#3621;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(203607,5656,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¸à¤®à¤¯ à¤¦à¤°à¥à¤¶à¤•',0),(203608,5656,'ms','Perkhidmatan perintah masa penonton',0),(203609,5656,'ar','Ø®Ø¯Ù…Ø© Ø£Ù…Ø± Ø§Ù„Ù…Ø´Ø§Ù‡Ø¯ Ø§Ù„ÙˆÙ‚Øª',0),(203610,5656,'fr','Service commande temps Viewer',0),(203611,5656,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡æ™‚é–“ãƒ“ãƒ¥ãƒ¼ã‚¢ãƒ¼',0),(203612,5656,'pt','Visualizador de tempo de ordem de serviÃ§o',0),(203613,5656,'ru','Ð¡Ð»ÑƒÐ¶Ð±Ð° Ð·Ð°ÐºÐ°Ð·Ð° Ð²Ñ€ÐµÐ¼Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð°',0),(203614,5656,'es','Orden de Servicio Vizualizador de Tiempo',0),(203615,5656,'de','Service-Auftrag-Time-Viewer',0),(203616,5656,'en','Service Order Time Viewer',0),(203617,5657,'is','',0),(203618,5657,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø­Ø³Ø§Ø¨ ',0),(203619,5657,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø­Ø³Ø§Ø¨ ',0),(203620,5657,'tr','Hesap arama',0),(203621,5657,'pl','Wyszukiwania kont',0),(203622,5657,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸',0),(203623,5657,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(203624,5657,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(203625,5657,'vi','TÃ¬m TK',0),(203626,5657,'af','Soek Rekening',0),(203627,5657,'ro','Cauta cont',0),(203628,5657,'et','Konto otsimine',0),(203629,5657,'si','RaÄun za iskanje',0),(203630,5657,'ba','Pencarian Akun',0),(203631,5657,'nl','Rekening Lookup',0),(203632,5657,'fi','Tilin valinta',0),(203633,5657,'no','Konto oppslag',0),(203634,5657,'da','Konto opslag',0),(203635,5657,'ko','ê³„ì • ì¡°íšŒ',0),(203636,5657,'he','×—×™×¤×•×© ×—×©×‘×•×Ÿ',0),(203637,5657,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(203638,5657,'zh','è´¦æˆ·æŸ¥è¯¢\r\n',0),(203639,5657,'sv','Konto Lookup',0),(203640,5657,'it','Conto ricerca',0),(203641,5657,'tl','',0),(203642,5657,'th','&#3588;&#3657;&#3609;&#3604;&#3641;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(203643,5657,'hi','à¤–à¤¾à¤¤à¤¾ à¤²à¥à¤•à¤…à¤ª',0),(203644,5657,'ms','Lookup akaun',0),(203645,5657,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø­Ø³Ø§Ø¨',0),(203646,5657,'fr','Recherche de compte',0),(203647,5657,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(203648,5657,'pt','Pesquisa de conta',0),(203649,5657,'ru','ÐŸÐ¾Ð¸ÑÐº ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(203650,5657,'es','Busqueda de Cuenta',0),(203651,5657,'de','Konto Lookup',0),(203652,5657,'en','Account Lookup',0),(203653,5658,'is','',0),(203654,5658,'dr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø·Ø¨Ù‚ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨',0),(203655,5658,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø·Ø¨Ù‚ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨',0),(203656,5658,'tr','Hesap No gÃ¶re sÄ±ralayÄ±n.',0),(203657,5658,'pl','Sortuj wg Nr konta.',0),(203658,5658,'bg','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Nr.',0),(203659,5658,'ur','Ø¨Ø°Ø±ÛŒØ¹Û Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§ÛŒÙ† Ø¢Ø± Û”',0),(203660,5658,'sr','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾ Ð½Ð°Ð»Ð¾Ð³Ñƒ ÐÑ€.',0),(203661,5658,'vi','Sáº¯p Xáº¿p Theo Sá»‘ TK',0),(203662,5658,'af','Sorteer per Rekening Nr.',0),(203663,5658,'ro','Un fel de cont Nr.',0),(203664,5658,'et','Sorteeri konto Nr.',0),(203665,5658,'si','Razvrsti po raÄun Nr.',0),(203666,5658,'ba','Urutkan Account Nr.',0),(203667,5658,'nl','Sorteer volgens account nr.',0),(203668,5658,'fi','Lajittele tilin Nr.',0),(203669,5658,'no','Sorter etter konto Nr.',0),(203670,5658,'da','SortÃ©r efter konto Nr.',0),(203671,5658,'ko','ê³„ì • Nr ì •ë ¬ìž…ë‹ˆë‹¤.',0),(203672,5658,'he','×ž×™×™×Ÿ ×œ×¤×™ ×—×©×‘×•×Ÿ Nr.',0),(203673,5658,'el','Î¤Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ· ÎºÎ±Ï„Î¬ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Nr.',0),(203674,5658,'zh','æŒ‰å¸æˆ·å·ç åˆ†ç±»\r\n',0),(203675,5658,'sv','Sortera efter konto Nr.',0),(203676,5658,'it','Ordina per conto Nr.',0),(203677,5658,'tl','',0),(203678,5658,'th','&#3592;&#3633;&#3604;&#3648;&#3619;&#3637;&#3618;&#3591;&#3650;&#3604;&#3618;&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(203679,5658,'hi','à¤–à¤¾à¤¤à¤¾ à¤à¤¨. à¤†à¤°. à¤¸à¥‡ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚à¥¤',0),(203680,5658,'ms','Susun mengikut akaun Nr.',0),(203681,5658,'ar','ÙØ±Ø² Ø­Ø³Ø¨ Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨.',0),(203682,5658,'fr','Trier par compte Nr.',0),(203683,5658,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå?·åˆ¥ã?«åˆ†é¡ž',0),(203684,5658,'pt','Ordenar por conta Nr.',0),(203685,5658,'ru','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ° Ð¿Ð¾ ÑÑ‡ÐµÑ‚Ñƒ Nr.',0),(203686,5658,'es','Clasificar por NÃºmero de Cuenta',0),(203687,5658,'de','Sortieren nach Konto Nr.',0),(203688,5658,'en','Sort by Account Nr.',0),(203689,5659,'is','',0),(203690,5659,'dr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø·Ø¨Ù‚ Ø´Ø±Ø­ ',0),(203691,5659,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø·Ø¨Ù‚ Ø´Ø±Ø­ ',0),(203692,5659,'tr','AÃ§Ä±klamasÄ±na gÃ¶re sÄ±rala',0),(203693,5659,'pl','Sortuj wg opisu',0),(203694,5659,'bg','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð¹ Ð¿Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(203695,5659,'ur','Ú†Ú¾Ø§Ù†Ù¹ÛŒÚº Ø¨Ù…Ø·Ø§Ø¨Ù‚ ØªØµØ±ÛŒØ­',0),(203696,5659,'sr','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾ Ð¾Ð¿Ð¸ÑÑƒ',0),(203697,5659,'vi','Sáº¯p xáº¿p theo mÃ´ táº£',0),(203698,5659,'af','Sorteer volgens Beskrywing',0),(203699,5659,'ro','Un fel de Descriere',0),(203700,5659,'et','Sortimisalus: kirjeldus',0),(203701,5659,'si','Razvrsti po opisu',0),(203702,5659,'ba','Urutkan berdasar Deskripsi',0),(203703,5659,'nl','Sorteer volgen beschrijving',0),(203704,5659,'fi','Lajittelun kuvaus',0),(203705,5659,'no','Sorter etter beskrivelse',0),(203706,5659,'da','Sorter efter beskrivelse',0),(203707,5659,'ko','ì •ë ¬ ì„¤ëª…',0),(203708,5659,'he','×ž×™×™×Ÿ ×œ×¤×™ ×ª××•×¨',0),(203709,5659,'el','Î¤Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ· ÎºÎ±Ï„Î¬ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(203710,5659,'zh','æŽ’åºæ–¹å¼è¯´æ˜Žåˆ†ç±»\r\n',0),(203711,5659,'sv','Sortera enligt beskrivning',0),(203712,5659,'it','Ordina per Descrizione',0),(203713,5659,'tl','',0),(203714,5659,'th','&#3592;&#3633;&#3604;&#3648;&#3619;&#3637;&#3618;&#3591;&#3650;&#3604;&#3618;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(203715,5659,'hi','à¤µà¤°à¥à¤£à¤¨ à¤¸à¥‡ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(203716,5659,'ms','Susun mengikut keterangan',0),(203717,5659,'ar','ÙØ±Ø² Ø­Ø³Ø¨ Ø§Ù„ÙˆØµÙ',0),(203718,5659,'fr','Trier par Description',0),(203719,5659,'jp','è§£èª¬åˆ¥ã?«åˆ†é¡ž',0),(203720,5659,'pt','Ordenar por descriÃ§Ã£o',0),(203721,5659,'ru','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð¾ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸ÑŽ',0),(203722,5659,'es','Clasificar por DescripciÃ³n',0),(203723,5659,'de','Sortieren nach Beschreibung',0),(203724,5659,'en','Sort by Description',0),(203725,5660,'is','',0),(203726,5660,'dr',' Ø±ÙˆØ´Ù†',0),(203727,5660,'pr',' Ø±ÙˆØ´Ù†',0),(203728,5660,'tr','Lite',0),(203729,5660,'pl','Lite',0),(203730,5660,'bg','Lite',0),(203731,5660,'ur','Ù„Ø§Ø¦Ù¹',0),(203732,5660,'sr','Ð›Ð¸Ñ‚Ðµ',0),(203733,5660,'vi','Thiáº¿u ',0),(203734,5660,'af','Lite',0),(203735,5660,'ro','Lite',0),(203736,5660,'et','Lite',0),(203737,5660,'si','Lite',0),(203738,5660,'ba','Lite',0),(203739,5660,'nl','Lite',0),(203740,5660,'fi','Lite',0),(203741,5660,'no','Lite',0),(203742,5660,'da','Lite',0),(203743,5660,'ko','ë¼ì´íŠ¸',0),(203744,5660,'he','×œ×™×™×˜',0),(203745,5660,'el','Lite',0),(203746,5660,'zh','å»ºå…´\r\n',0),(203747,5660,'sv','Lite',0),(203748,5660,'it','Lite',0),(203749,5660,'tl','',0),(203750,5660,'th','Lite',0),(203751,5660,'hi','à¤²à¤¾à¤‡à¤Ÿ',0),(203752,5660,'ms','Lite',0),(203753,5660,'ar','Ù„Ø§ÙŠØª',0),(203754,5660,'fr','Lite',0),(203755,5660,'jp','Lite',0),(203756,5660,'pt','Lite',0),(203757,5660,'ru','Lite',0),(203758,5660,'es','Lite',0),(203759,5660,'de','Lite',0),(203760,5660,'en','Lite',0),(203761,5661,'is','',0),(203762,5661,'dr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(203763,5661,'pr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(203764,5661,'tr','MÃ¼ÅŸteri MevduatÄ±',0),(203765,5661,'pl','Depozyty klientÃ³w',0),(203766,5661,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(203767,5661,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ø°Ø®Ø§Ø¦Ø±',0),(203768,5661,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(203769,5661,'vi','Äáº·t cá»c cá»§a KhÃ¡ch hÃ ng',0),(203770,5661,'af','Klant / KliÃ«nt Deposito\'s',0),(203771,5661,'ro','Depozitele clienÅ£ilor',0),(203772,5661,'et','Klientide hoiuste maht',0),(203773,5661,'si','Depoziti strank',0),(203774,5661,'ba','Simpanan nasabah',0),(203775,5661,'nl','CliÃ«ntentegoeden',0),(203776,5661,'fi','Asiakkaan talletuksiin',0),(203777,5661,'no','Kunde innskudd',0),(203778,5661,'da','Kunde indskud',0),(203779,5661,'ko','ê³ ê° ì˜ˆê¸ˆ',0),(203780,5661,'he','×¤×§×“×•× ×•×ª ×”×œ×§×•×—',0),(203781,5661,'el','ÎšÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(203782,5661,'zh','å®¢æˆ·å­˜æ¬¾\r\n',0),(203783,5661,'sv','Kund inlÃ¥ning',0),(203784,5661,'it','Depositi dei clienti',0),(203785,5661,'tl','',0),(203786,5661,'th','&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(203787,5661,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤®à¤¾',0),(203788,5661,'ms','Deposit pelanggan',0),(203789,5661,'ar','ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(203790,5661,'fr','DÃ©pÃ´ts de la clientÃ¨le',0),(203791,5661,'jp','é¡§å®¢é ?ã‚Šé‡‘',0),(203792,5661,'pt','DepÃ³sitos de clientes',0),(203793,5661,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(203794,5661,'es','Cliente DepÃ³sitos',0),(203795,5661,'de','Kundengelder',0),(203796,5661,'en','Customer Deposits',0),(203797,5662,'is','',0),(203798,5662,'dr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ',0),(203799,5662,'pr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ',0),(203800,5662,'tr','Ä°ÅŸÃ§i saat birimi adÄ±',0),(203801,5662,'pl','Nazwa jednostki dla godzin pracy',0),(203802,5662,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ñ‚Ñ€ÑƒÐ´ Ñ‡Ð°ÑÐ°',0),(203803,5662,'ur','Ù…Ø²Ø¯ÙˆØ± Ú©Û’ Ø§ÙˆÙ‚Ø§Øª Ú©Û’ Ù„Ø¦Û’ ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù…',0),(203804,5662,'sr','Ð˜Ð¼Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð·Ð° Ñ€Ð°Ð´ ÑÐ°Ñ‚Ð¸',0),(203805,5662,'vi','TÃªn ÄÆ¡n vá»‹ cho giá» nhÃ¢n cÃ´ng',0),(203806,5662,'af','Eenheidsnaam vir Ure Arbeid',0),(203807,5662,'ro','Nume de unitatea pentru muncÄƒ ore',0),(203808,5662,'et','Ãœhiku nimi Labor tundi',0),(203809,5662,'si','Ime enote za ure dela',0),(203810,5662,'ba','Nama unit selama jam kerja',0),(203811,5662,'nl','Naam van de eenheid voor arbeid uur',0),(203812,5662,'fi','YksikÃ¶n nimi tyÃ¶tunnit',0),(203813,5662,'no','Navn for arbeidstimer',0),(203814,5662,'da','Enhed navn for Labor timer',0),(203815,5662,'ko','ë…¸ë™ ì‹œê°„ì— ëŒ€ í•œ ìž¥ì¹˜ ì´ë¦„',0),(203816,5662,'he','×©× ×™×—×™×“×” ×¢×‘×•×¨ ×©×¢×•×ª ×”×¢×‘×•×“×”',0),(203817,5662,'el','ÎŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î±Ï‚ Î³Î¹Î± ÏŽÏÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(203818,5662,'zh','åŠ³åŠ¨æ—¶é—´å•ä½åç§°\r\n',0),(203819,5662,'sv','Enhetens namn i arbets timmar',0),(203820,5662,'it','Nome dell\'unitÃ  per ore lavoro',0),(203821,5662,'tl','',0),(203822,5662,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3629;&#3591;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(203823,5662,'hi','à¤¶à¥à¤°à¤® à¤˜à¤‚à¤Ÿà¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤¨à¤¾à¤®',0),(203824,5662,'ms','Nama unit jam buruh',0),(203825,5662,'ar','Ø§Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø© Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„',0),(203826,5662,'fr','Nom de l\'unitÃ© pendant les heures du travail',0),(203827,5662,'jp','åŠ´åƒ?è€…å‹¤å‹™æ™‚é–“ã?®å?˜ä½?å??',0),(203828,5662,'pt','Nome da unidade por horas do trabalho',0),(203829,5662,'ru','Ð˜Ð¼Ñ ÑƒÑÑ‚Ñ€Ð¾Ð¹ÑÑ‚Ð²Ð° Ð´Ð»Ñ Ñ‚Ñ€ÑƒÐ´Ð¾Ð²Ñ‹Ñ… Ñ‡Ð°ÑÐ¾Ð²',0),(203830,5662,'es','Nombre de Unidad para Horas Laborales',0),(203831,5662,'de','GerÃ¤tename fÃ¼r Arbeits-Stunden',0),(203832,5662,'en','Unit Name for Labor Hours',0),(203833,5663,'is','',0),(203834,5663,'dr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(203835,5663,'pr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(203836,5663,'tr','Servis sipariÅŸi mevduat',0),(203837,5663,'pl','ZÅ‚oÅ¼enia zamÃ³wienia usÅ‚ugi',0),(203838,5663,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(203839,5663,'ur','Ø®Ø¯Ù…Øª Ø¢Ø±ÚˆØ± Ø¬Ù…Ø¹',0),(203840,5663,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(203841,5663,'vi','Äáº·t cá»c Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(203842,5663,'af','Diensbestelling Deposito',0),(203843,5663,'ro','Depozit de comandÄƒ service',0),(203844,5663,'et','Teenuse tellimuse tagatisraha',0),(203845,5663,'si','Storitev naroÄilo depozita',0),(203846,5663,'ba','Layanan pesanan Deposit',0),(203847,5663,'nl','Service Order storting',0),(203848,5663,'fi','Palvelun tilauksen talletus',0),(203849,5663,'no','Tjenesten for innskudd',0),(203850,5663,'da','Tjenesten Order depositum',0),(203851,5663,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ìž…ê¸ˆ',0),(203852,5663,'he','×¤×§×“×•×Ÿ ×”×–×ž× ×ª ×©×¨×•×ª',0),(203853,5663,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(203854,5663,'zh','æœåŠ¡è®¢å•å­˜æ¬¾\r\n',0),(203855,5663,'sv','Service bestÃ¤llning insÃ¤ttning',0),(203856,5663,'it','Deposito di ordine di servizio',0),(203857,5663,'tl','',0),(203858,5663,'th','&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(203859,5663,'hi','à¤¸à¤°à¥à¤µà¤¿à¤¸ à¤•à¥à¤°à¤® à¤œà¤®à¤¾',0),(203860,5663,'ms','Perkhidmatan perintah Deposit',0),(203861,5663,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(203862,5663,'fr','DÃ©pÃ´t de commande de service',0),(203863,5663,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡é ?ã‚Šé‡‘',0),(203864,5663,'pt','DepÃ³sito de ordem de serviÃ§o',0),(203865,5663,'ru','Ð¡Ð»ÑƒÐ¶Ð±Ð° Ð·Ð°ÐºÐ°Ð·Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(203866,5663,'es','Orden de Servicio DepÃ³sito',0),(203867,5663,'de','Service Bestellung Anzahlung',0),(203868,5663,'en','Service Order Deposit',0),(203869,5664,'is','',0),(203870,5664,'dr','Ù‡ÙŠÚ† Ú©Ø§Ù„Ø§Ù‡Ø§ÙŠ Ø¯Ø± Ø­Ø§Ù„ Ø³Ø§Ø®Øª Ù†ÙŠØ³Øª ',0),(203871,5664,'pr','Ù‡ÙŠÚ† Ú©Ø§Ù„Ø§Ù‡Ø§ÙŠ Ø¯Ø± Ø­Ø§Ù„ Ø³Ø§Ø®Øª Ù†ÙŠØ³Øª ',0),(203872,5664,'tr','Devam etmekte olan hiÃ§bir iÅŸ',0),(203873,5664,'pl','Nie w toku',0),(203874,5664,'bg','ÐÑÐ¼Ð° Ñ‚ÐµÐºÑƒÑ‰Ð°',0),(203875,5664,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø§Ù… Ø¬Ø§Ø±ÛŒ',0),(203876,5664,'sr','ÐÐµ Ñ€Ð°Ð´Ð¸Ð¼ Ð½Ð° Ñ‚Ð¾Ð¼Ðµ.',0),(203877,5664,'vi','KhÃ´ng cÃ³ viá»‡c dang dá»Ÿ',0),(203878,5664,'af','Geen Werk aan die Gang',0),(203879,5664,'ro','Nici o lucrare Ã®n curs',0),(203880,5664,'et','Pooleliolevad',0),(203881,5664,'si','Nobene nedokonÄane',0),(203882,5664,'ba','Tidak bekerja di kemajuan',0),(203883,5664,'nl','Geen Work in Progress',0),(203884,5664,'fi','Ei tyÃ¶n alla',0),(203885,5664,'no','Ingen i arbeid',0),(203886,5664,'da','Ingen igangvÃ¦rende',0),(203887,5664,'ko','ì§„í–‰ ì¤‘ì¸ ìž‘ì—… ì—†ìŒ',0),(203888,5664,'he','××™×Ÿ ×¢×‘×•×“×” ×‘×ª×”×œ×™×š',0),(203889,5664,'el','ÎšÎ±Î½Î­Î½Î± Î­ÏÎ³Î¿ ÏƒÎµ ÎµÎ¾Î­Î»Î¹Î¾Î·',0),(203890,5664,'zh','æ²¡æœ‰è¿›è¡Œä¸­çš„å·¥ä½œ\r\n',0),(203891,5664,'sv','Ingen i arbete',0),(203892,5664,'it','Nessun lavoro in corso',0),(203893,5664,'tl','',0),(203894,5664,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3607;&#3635;&#3591;&#3634;&#3609;&#3651;&#3609;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;',0),(203895,5664,'hi','à¤•à¥‹à¤ˆ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤—à¤¤à¤¿',0),(203896,5664,'ms','Tidak ada kerja dalam pelaksanaan',0),(203897,5664,'ar','Ù„Ø§ Ø§Ù„ØªÙ‚Ø¯Ù… ÙÙŠ Ø§Ù„Ø¹Ù…Ù„',0),(203898,5664,'fr','Aucun travail en cours',0),(203899,5664,'jp','å‡¦ç?†ä¸­ã?®ä½œæ¥­ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(203900,5664,'pt','NÃ£o hÃ¡ trabalho em andamento',0),(203901,5664,'ru','ÐÐµ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(203902,5664,'es','No hay Trabajo en Progreo',0),(203903,5664,'de','Keine bei der Arbeit',0),(203904,5664,'en','No Work in Progress',0),(203905,5665,'is','',0),(203906,5665,'dr','Ø²Ù…Ø§Ù† ÙˆØ±ÙˆØ¯ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(203907,5665,'pr','Ø²Ù…Ø§Ù† ÙˆØ±ÙˆØ¯ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(203908,5665,'tr','Servis sipariÅŸi gÃ¼nlÃ¼ÄŸÃ¼ zaman',0),(203909,5665,'pl','Czas dziennika zlecenia usÅ‚ugi',0),(203910,5665,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ€ÐµÐ³Ð¸ÑÑ‚ÑŠÑ€ Ð²Ñ€ÐµÐ¼Ðµ',0),(203911,5665,'ur','Ø®Ø¯Ù…Øª ØªØ±ØªÛŒØ¨ Ù„Ø§Ú¯ ÙˆÙ‚Øª',0),(203912,5665,'sr','Ð’Ñ€ÐµÐ¼Ðµ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ€Ð°ÑšÐ° Ð½Ð°Ð»Ð¾Ð³Ð° ÑÐµÑ€Ð²Ð¸ÑÐ°',0),(203913,5665,'vi','Nháº­t kÃ½ thá»i gian Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(203914,5665,'af','Diensbestelling Log Tyd',0),(203915,5665,'ro','Serviciu comanda jurnal timp',0),(203916,5665,'et','Teenuse tellimuse Logi aeg',0),(203917,5665,'si','ÄŒasa dnevnika naroÄilo storitev',0),(203918,5665,'ba','Waktu layanan pesanan Log',0),(203919,5665,'nl','Service Order Log tijd',0),(203920,5665,'fi','Tilauksen loki aikaa',0),(203921,5665,'no','Tjenesten Ordretidspunkt Logg',0),(203922,5665,'da','Service Ordretidspunkt Log',0),(203923,5665,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ë¡œê·¸ ì‹œê°„',0),(203924,5665,'he','×©×™×¨×•×ª ×”×–×ž× ×ª ×™×•×ž×Ÿ ×–×ž×Ÿ',0),(203925,5665,'el','Î§ÏÏŒÎ½Î¿Ï‚ ÎºÎ±Ï„Î±Î³ÏÎ±Ï†Î®Ï‚ Ï„Î¬Î¾Î·Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±',0),(203926,5665,'zh','æœåŠ¡è®¢å•æ—¥å¿—æ—¶é—´\r\n',0),(203927,5665,'sv','Service Order logga tid',0),(203928,5665,'it','Tempo di servizio ordine Log',0),(203929,5665,'tl','',0),(203930,5665,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(203931,5665,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤²à¥‰à¤— à¤¸à¤®à¤¯',0),(203932,5665,'ms','Perkhidmatan perintah Log masa',0),(203933,5665,'ar','Ø®Ø¯Ù…Ø© Ø§Ù„Ù†Ø¸Ø§Ù… Ø³Ø¬Ù„ Ø§Ù„ÙˆÙ‚Øª',0),(203934,5665,'fr','Temps de service Order Log',0),(203935,5665,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ãƒ­ã‚°æ™‚é–“',0),(203936,5665,'pt','Tempo de registro de ordem de serviÃ§o',0),(203937,5665,'ru','Ð’Ñ€ÐµÐ¼Ñ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð° Ð¶ÑƒÑ€Ð½Ð°Ð»Ð°',0),(203938,5665,'es','Orden de Servicio Tiempo Calculado',0),(203939,5665,'de','Service Log Auftragszeit',0),(203940,5665,'en','Service Order Log Time',0),(203941,5666,'is','',0),(203942,5666,'dr','Ø²Ù…Ø§Ù† Ø´Ø±ÙˆØ¹ ',0),(203943,5666,'pr','Ø²Ù…Ø§Ù† Ø´Ø±ÙˆØ¹ ',0),(203944,5666,'tr','BaÅŸlangÄ±Ã§ saati',0),(203945,5666,'pl','Czas rozpoczÄ™cia',0),(203946,5666,'bg','ÐÐ°Ñ‡Ð°Ð»ÐµÐ½ Ñ‡Ð°Ñ',0),(203947,5666,'ur','ÙˆÙ‚Øª Ø¢ØºØ§Ø²',0),(203948,5666,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(203949,5666,'vi','Thá»i gian Báº¯t Ä‘áº§u',0),(203950,5666,'af','Begin Tyd',0),(203951,5666,'ro','Ora de Ã®ncepere',0),(203952,5666,'et','Algusaeg',0),(203953,5666,'si','ZaÄetni Äas',0),(203954,5666,'ba','Waktu mulai',0),(203955,5666,'nl','Begintijd',0),(203956,5666,'fi','Alkamisaika',0),(203957,5666,'no','Starttid',0),(203958,5666,'da','Starttidspunkt',0),(203959,5666,'ko','ì‹œìž‘ ì‹œê°„',0),(203960,5666,'he','×©×¢×ª ×”×”×ª×—×œ×”',0),(203961,5666,'el','ÎÏÎ± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(203962,5666,'zh','å¼€å§‹æ—¶é—´\r\n',0),(203963,5666,'sv','Starttid',0),(203964,5666,'it','Ora di inizio',0),(203965,5666,'tl','',0),(203966,5666,'th','&#3648;&#3623;&#3621;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(203967,5666,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¸à¤®à¤¯',0),(203968,5666,'ms','Masa mula',0),(203969,5666,'ar','ÙˆÙ‚Øª Ø§Ù„Ø¨Ø¯Ø¡',0),(203970,5666,'fr','Heure de dÃ©but',0),(203971,5666,'jp','é–‹å§‹æ™‚é–“',0),(203972,5666,'pt','Hora de inÃ­cio',0),(203973,5666,'ru','Ð’Ñ€ÐµÐ¼Ñ ÐÐ°Ñ‡Ð°Ð»Ð°',0),(203974,5666,'es','Tiempo de Comienza',0),(203975,5666,'de','Startzeit',0),(203976,5666,'en','Start Time',0),(203977,5667,'is','',0),(203978,5667,'dr','ÙƒØ§Ø±Ú¯Ø±Ø§Ù†ÙŠ ÙƒÙ‡ Ø§Ø®ÙŠØ±Ø§ ÙƒØ§Ù‡Ø´ ÙŠØ§ÙØªÙ‡ Ø§Ù†Ø¯',0),(203979,5667,'pr','ÙƒØ§Ø±Ú¯Ø±Ø§Ù†ÙŠ ÙƒÙ‡ Ø§Ø®ÙŠØ±Ø§ ÙƒØ§Ù‡Ø´ ÙŠØ§ÙØªÙ‡ Ø§Ù†Ø¯',0),(203980,5667,'tr','Åžu anda gÃ¼nlÃ¼ÄŸe kaydedilen iÅŸÃ§ilerin',0),(203981,5667,'pl','PracownikÃ³w zalogowany',0),(203982,5667,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ†Ð¸Ñ‚Ðµ Ð²Ð»ÐµÐ·Ð»Ð¸',0),(203983,5667,'ur','Ø§Ø³ ÙˆÙ‚Øª Ù„Ø§Ú¯ Ø§Ù† Ú©Ø§Ø±Ú©Ù†ÙˆÚº',0),(203984,5667,'sr','Ð Ð°Ð´Ð½Ð¸Ñ†Ð¸ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð¸',0),(203985,5667,'vi','CÃ´ng nhÃ¢n hiá»‡n Ä‘ang lÃ m',0),(203986,5667,'af','Werkers Huidiglik Aangeteken',0),(203987,5667,'ro','LucrÄƒtorii log',0),(203988,5667,'et','Sisse logitud tÃ¶Ã¶tajad',0),(203989,5667,'si','Delavci, ki so trenutno prijavljeni',0),(203990,5667,'ba','Pekerja login',0),(203991,5667,'nl','Werknemers hebt aangemeld.',0),(203992,5667,'fi','TyÃ¶ntekijÃ¶iden kirjautuneena',0),(203993,5667,'no','Arbeidere logget',0),(203994,5667,'da','Arbejdstagere i Ã¸jeblikket logget',0),(203995,5667,'ko','í˜„ìž¬ ë¡œê·¸ì¸ ë…¸ë™ìž',0),(203996,5667,'he','×”×¢×•×‘×“×™× ×ž×—×•×‘×¨×™× ×›×¢×ª',0),(203997,5667,'el','Î•ÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Î¹ Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ ÏƒÏ…Î½Î´ÎµÎ´ÎµÎ¼Î­Î½Î¿Ï‚',0),(203998,5667,'zh','å·¥äººå½“å‰ç™»å½•\r\n',0),(203999,5667,'sv','Arbetstagare som inloggad',0),(204000,5667,'it','Lavoratori attualmente connessi',0),(204001,5667,'tl','',0),(204002,5667,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3619;&#3632;&#3610;&#3610;&#3651;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(204003,5667,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤²à¥‰à¤— à¤‡à¤¨ à¤¶à¥à¤°à¤®à¤¿à¤•à¥‹à¤‚',0),(204004,5667,'ms','Pekerja-pekerja yang log masuk',0),(204005,5667,'ar','Ø§Ù„Ø¹Ø§Ù…Ù„ÙŠÙ† Ø­Ø§Ù„ÙŠØ§ Ø¨ØªØ³Ø¬ÙŠÙ„',0),(204006,5667,'fr','Travailleurs actuellement connectÃ©s',0),(204007,5667,'jp','ä½œæ¥­è€…ã?¯ç?¾åœ¨ãƒ­ã‚°ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(204008,5667,'pt','Trabalhadores atualmente conectados',0),(204009,5667,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¸ Ð² Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð¶ÑƒÑ€Ð½Ð°Ð»',0),(204010,5667,'es','Trabajadores Actualmente Conectados',0),(204011,5667,'de','Arbeiter angemeldet',0),(204012,5667,'en','Workers Currently Logged',0),(204013,5668,'is','',0),(204014,5668,'dr','ÙØ¹Ù„Ø§ Ø¯Ø± Ø­Ø§Ù„ ÙƒØ§Ø± Ø¨Ø± Ø±ÙˆÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª',0),(204015,5668,'pr','ÙØ¹Ù„Ø§ Ø¯Ø± Ø­Ø§Ù„ ÙƒØ§Ø± Ø¨Ø± Ø±ÙˆÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª',0),(204016,5668,'tr','Åžu anda servis sipariÅŸlerinde Ã§alÄ±ÅŸma',0),(204017,5668,'pl','Obecnie pracuje nad zleceÅ„ serwisowych',0),(204018,5668,'bg','Ð’ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð¸ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(204019,5668,'ur','Ø§Ø³ ÙˆÙ‚Øª Ø®Ø¯Ù…Øª Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ú©Ø§Ù… Ú©Ø±Ù†Û’ ÙˆØ§Ù„Û’',0),(204020,5668,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ñ€Ð°Ð´Ð¸ Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(204021,5668,'vi','Hiá»‡n Ä‘ang lÃ m nhá»¯ng Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥',0),(204022,5668,'af','Werk Tans aan Diens Bestellings',0),(204023,5668,'ro','LucreazÄƒ Ã®n prezent la comenzi de Service',0),(204024,5668,'et','Praegu kÃ¤sil hooldustellimuste',0),(204025,5668,'si','Trenutno delajo na servisnih nalogih',0),(204026,5668,'ba','Sekarang sedan dalam Layanan Pesanan',0),(204027,5668,'nl','Momenteel werkt aan serviceorders',0),(204028,5668,'fi','Parhaillaan huoltotilaukset',0),(204029,5668,'no','Jobber pÃ¥ serviceordrer',0),(204030,5668,'da','Arbejder i Ã¸jeblikket pÃ¥ serviceordrer',0),(204031,5668,'ko','í˜„ìž¬ ìž‘ì—… ì¤‘ì¸ ì„œë¹„ìŠ¤ ì£¼ë¬¸',0),(204032,5668,'he','×›×¨×’×¢ ×¢×•×‘×“ ×¢×œ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(204033,5668,'el','Î£Î®Î¼ÎµÏÎ± ÎµÏÎ³Î¬Î¶ÎµÏ„Î±Î¹ Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(204034,5668,'zh','ç›®å‰æ­£è‡´åŠ›äºŽæœåŠ¡è®¢å•\r\n',0),(204035,5668,'sv','FÃ¶r nÃ¤rvarande arbetar pÃ¥ serviceorder',0),(204036,5668,'it','Attualmente lavorando su ordini di servizio',0),(204037,5668,'tl','',0),(204038,5668,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3607;&#3635;&#3629;&#3618;&#3641;&#3656;&#3586;&#3603;&#3632;&#3609;&#3637;&#3657;',0),(204039,5668,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤•à¤¾à¤® à¤•à¤°',0),(204040,5668,'ms','Sedang bekerja pada pesanan Perkhidmatan',0),(204041,5668,'ar','ÙˆØªØ¹Ù…Ù„ Ø­Ø§Ù„ÙŠØ§ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(204042,5668,'fr','Travaille actuellement sur les ordres de Service',0),(204043,5668,'jp','ç?¾åœ¨ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®ä½œæ¥­ã‚’ã?—ã?¦ã?„ã?¾ã?™',0),(204044,5668,'pt','Atualmente trabalhando em ordens de serviÃ§o',0),(204045,5668,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð°ÐµÑ‚ Ð¿Ð¾ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ð¼ Ð·Ð°ÐºÐ°Ð·Ð°Ð¼',0),(204046,5668,'es','Actualmente Trabajando en Pedidos de Servicios',0),(204047,5668,'de','Arbeitet derzeit an der Service-AuftrÃ¤ge',0),(204048,5668,'en','Currently Working on Service Orders',0),(204049,5669,'is','',0),(204050,5669,'dr','Ø§Ø¶Ø§ÙÙ‡ ÙƒØ±Ø¯Ù† Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(204051,5669,'pr','Ø§Ø¶Ø§ÙÙ‡ ÙƒØ±Ø¯Ù† Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(204052,5669,'tr','Servis sipariÅŸine Ekle mevduat',0),(204053,5669,'pl','Zlecenie serwisowe dodaÄ‡ depozytu',0),(204054,5669,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð· Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(204055,5669,'ur','Ø®Ø¯Ù…Øª Ø¢Ø±ÚˆØ± Ø¬Ù…Ø¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(204056,5669,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(204057,5669,'vi','ThÃªm tiá»n cá»c cá»§a Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(204058,5669,'af','Diensbestelling Deposito Byvoeg',0),(204059,5669,'ro','ComandÄƒ de service adÄƒuga depozit',0),(204060,5669,'et','Hooldustellimuse lisada tagatisraha',0),(204061,5669,'si','Servisni nalog dodati depozit',0),(204062,5669,'ba','Service Order menambahkan Deposit',0),(204063,5669,'nl','Serviceorder toevoegen storting',0),(204064,5669,'fi','Huoltotilauksen lisÃ¤Ã¤minen Internet',0),(204065,5669,'no','Serviceordren legge innskudd',0),(204066,5669,'da','Serviceordren tilfÃ¸je depositum',0),(204067,5669,'ko','ì„œë¹„ìŠ¤ ì˜¤ë”ì—ëŠ” ì¶”ê°€ ìž…ê¸ˆ',0),(204068,5669,'he','×”×•×¡×£ ×¤×§×“×•×Ÿ ×œ×”×–×ž× ×ª ×©×¨×•×ª',0),(204069,5669,'el','Î•Î½Ï„Î¿Î»Î® Ï„ / Ï… Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(204070,5669,'zh','æ–°å¢žå­˜æ¬¾æœåŠ¡è®¢å•\r\n',0),(204071,5669,'sv','Serviceordern lÃ¤gga till insÃ¤ttning',0),(204072,5669,'it','Ordine di servizio aggiungere deposito',0),(204073,5669,'tl','',0),(204074,5669,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(204075,5669,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤œà¤®à¤¾',0),(204076,5669,'ms','Pesanan Perkhidmatan Tambah Deposit',0),(204077,5669,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù…Ø± Ø®Ø¯Ù…Ø© Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(204078,5669,'fr','Commande service ajoutez dÃ©pÃ´t',0),(204079,5669,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡é ?ã‚Šé‡‘è¿½åŠ ',0),(204080,5669,'pt','Ordem de serviÃ§o adicionar depÃ³sito',0),(204081,5669,'ru','Ð¡ÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð· Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(204082,5669,'es','Orden de Servicio Agregar DepÃ³sito',0),(204083,5669,'de','Serviceauftrag hinzufÃ¼gen Einzahlung',0),(204084,5669,'en','Service Order Add Deposit',0),(204085,5670,'is','',0),(204086,5670,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù¾Ø±Ø¯Ù‡',0),(204087,5670,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù¾Ø±Ø¯Ù‡',0),(204088,5670,'tr','Mevduat eklemek',0),(204089,5670,'pl','DodaÄ‡ depozytu',0),(204090,5670,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(204091,5670,'ur','Ø¬Ù…Ø¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(204092,5670,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(204093,5670,'vi','ThÃªm Tiá»n Äáº·t Cá»c',0),(204094,5670,'af','Voeg \'n Deposito by',0),(204095,5670,'ro','Adauga depozit',0),(204096,5670,'et','Lisa deposiiti',0),(204097,5670,'si','Dodaj depozit',0),(204098,5670,'ba','Tambahkan deposito',0),(204099,5670,'nl','Toevoegen van storting',0),(204100,5670,'fi','LisÃ¤Ã¤ talletus',0),(204101,5670,'no','Legge til innskudd',0),(204102,5670,'da','TilfÃ¸je depositum',0),(204103,5670,'ko','ë³´ì¦ê¸ˆì„ ì¶”ê°€',0),(204104,5670,'he','×”×•×¡×£ ×¤×§×“×•×Ÿ',0),(204105,5670,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(204106,5670,'zh','å¢žåŠ å­˜æ¬¾\r\n',0),(204107,5670,'sv','LÃ¤gg till insÃ¤ttning',0),(204108,5670,'it','Aggiungi deposito',0),(204109,5670,'tl','',0),(204110,5670,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;',0),(204111,5670,'hi','à¤œà¤®à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(204112,5670,'ms','Tambah Deposit',0),(204113,5670,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥ÙŠØ¯Ø§Ø¹',0),(204114,5670,'fr','Ajouter DÃ©pÃ´t',0),(204115,5670,'jp','é ?ã‚Šé‡‘è¿½åŠ ',0),(204116,5670,'pt','Adicionar o depÃ³sito',0),(204117,5670,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(204118,5670,'es','Agregar DepÃ³sito',0),(204119,5670,'de','FÃ¼gen Sie Einzahlung',0),(204120,5670,'en','Add Deposit',0),(204121,5671,'is','',0),(204122,5671,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø·Ø¨Ù‚ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(204123,5671,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø·Ø¨Ù‚ Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(204124,5671,'tr','Para Ã¶denmiÅŸ',0),(204125,5671,'pl','ZapÅ‚acono w dniu wpÅ‚aty',0),(204126,5671,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ Ð·Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(204127,5671,'ur','ÚˆÙ¾Ø§Ø²Ù¹ Ù¾Ø± Ø§Ø¯Ø§ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(204128,5671,'sr','ÐŸÐ»Ð°Ñ›ÐµÐ½Ð¸ Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(204129,5671,'vi','Tráº£ trÃªn tiá»n cá»c',0),(204130,5671,'af','Betaal Op Deposito',0),(204131,5671,'ro','PlÄƒtit depozit',0),(204132,5671,'et','Makstud tagatisraha',0),(204133,5671,'si','Depozit',0),(204134,5671,'ba','Membayar deposit',0),(204135,5671,'nl','Betaald op storting',0),(204136,5671,'fi','Maksettu talletus',0),(204137,5671,'no','Betalt pÃ¥ innskudd',0),(204138,5671,'da','Betalt pÃ¥ indbetaling',0),(204139,5671,'ko','ì˜ˆê¸ˆì— ì§€ë¶ˆ',0),(204140,5671,'he','×©×™×œ×ž×ª×™ ×¢×œ ×”×¤×§×“×ª',0),(204141,5671,'el','ÎšÎ±Ï„Î±Î²Î»Î·Î¸ÎµÎ¯ ÏƒÏ„Î·Î½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(204142,5671,'zh','å­˜æ¬¾æ”¯ä»˜\r\n',0),(204143,5671,'sv','Betalas pÃ¥ insÃ¤ttning',0),(204144,5671,'it','Pagato sul deposito',0),(204145,5671,'tl','',0),(204146,5671,'th','&#3592;&#3656;&#3634;&#3618;&#3650;&#3604;&#3618;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;',0),(204147,5671,'hi','à¤ªà¤° à¤œà¤®à¤¾ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(204148,5671,'ms','Dibayar atas Deposit',0),(204149,5671,'ar','Ù…Ø¯ÙÙˆØ¹ Ø¹Ù„Ù‰ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(204150,5671,'fr','VersÃ©s sur les dÃ©pÃ´ts',0),(204151,5671,'jp','é ?ã?‹ã‚Šé‡‘æ‰•ã?„',0),(204152,5671,'pt','Pago no depÃ³sito',0),(204153,5671,'ru','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ð» Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(204154,5671,'es','Pagado en DepÃ³sito',0),(204155,5671,'de','Auf Kaution gezahlt',0),(204156,5671,'en','Paid on Deposit',0),(204157,5672,'is','',0),(204158,5672,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ø²Ø¯ÙŠÙƒ ÙŠØ§  ÙØ±Ø§ØªØ± Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯ ',0),(204159,5672,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ø²Ø¯ÙŠÙƒ ÙŠØ§  ÙØ±Ø§ØªØ± Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯ ',0),(204160,5672,'tr','Emir yakÄ±n veya tahmini Ã¼zerine',0),(204161,5672,'pl','ZamÃ³wienia w pobliÅ¼u lub nad szacunek',0),(204162,5672,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð±Ð»Ð¸Ð·Ð¾ Ð´Ð¾ Ð¸Ð»Ð¸ Ð½Ð°Ð´ Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(204163,5672,'ur','Ú©Û’ Ù‚Ø±ÛŒØ¨ ÛŒØ§ Ø§Ø³ Ú©Û’ Ø§Ù†Ø¯Ø§Ø²Û’ Ù¾Ø± Ø­Ú©Ù…',0),(204164,5672,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ñƒ Ð±Ð»Ð¸Ð·Ð¸Ð½Ð¸ Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐºÐ¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°',0),(204165,5672,'vi','ÄÆ¡n hÃ ng gáº§n hay hÆ¡n dá»± trÃ¹',0),(204166,5672,'af','Bestellings Nader of Oorskry Skatting',0),(204167,5672,'ro','Comenzi lÃ¢ngÄƒ sau prin estimare',0),(204168,5672,'et','Asuvaid ja jooksul hinnangu tellimuste',0),(204169,5672,'si','NaroÄila v bliÅ¾ini ali ocenjeni',0),(204170,5672,'ba','Pesanan di dekat atau di atas perkiraan',0),(204171,5672,'nl','Bestellingen in de buurt van of Over schatting',0),(204172,5672,'fi','LÃ¤hellÃ¤ tai poistot',0),(204173,5672,'no','Ordrer i nÃ¦rheten eller Over anslag',0),(204174,5672,'da','Ordrer i nÃ¦rheden af eller Over skÃ¸n',0),(204175,5672,'ko','ê·¼ì²˜ ë˜ëŠ” ê²¬ì  ì£¼ë¬¸',0),(204176,5672,'he','×”×–×ž× ×•×ª ×œ×™×“ ××• ×¢×œ ×”×¢×¨×›×”',0),(204177,5672,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î® ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ· Ï€Î»Î·ÏƒÎ¯Î¿Î½',0),(204178,5672,'zh','è®¢å•æŽ¥è¿‘æˆ–è¶…è¿‡é¢„è®¡\r\n',0),(204179,5672,'sv','Order nÃ¤ra eller Ã¶ver uppskattningen',0),(204180,5672,'it','Ordini vicino o sopra la stima',0),(204181,5672,'tl','',0),(204182,5672,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3651;&#3585;&#3621;&#3657;&#3627;&#3619;&#3639;&#3629;&#3648;&#3585;&#3636;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(204183,5672,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤ªà¤¾à¤¸ à¤¯à¤¾ à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(204184,5672,'ms','Perintah-perintah yang berhampiran atau ke atas anggaran',0),(204185,5672,'ar','Ø£ÙˆØ§Ù…Ø± Ù‚Ø±Ø¨ Ø£Ùˆ Ø¹Ù„Ù‰ Ù…Ø¯Ù‰ ØªÙ‚Ø¯ÙŠØ±',0),(204186,5672,'fr','Commandes sur devis ou proche',0),(204187,5672,'jp','è¦‹ç©?ã‚Šè‡³è¿‘ãƒ»è¶…é?Žæ³¨æ–‡',0),(204188,5672,'pt','Ordens perto ou sobre a estimativa',0),(204189,5672,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ñ€ÑÐ´Ð¾Ð¼ Ð¸Ð»Ð¸ Ð½Ð°Ð´ ÑÐ¼ÐµÑ‚Ð°',0),(204190,5672,'es','Pedidos Cerca o MÃ¡s de los Estimados',0),(204191,5672,'de','Bestellungen in der NÃ¤he oder Ã¼ber geschÃ¤tzte',0),(204192,5672,'en','Orders Near or Over Estimate',0),(204193,5673,'is','',0),(204194,5673,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(204195,5673,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(204196,5673,'tr','Ãœcretleri-Tarih',0),(204197,5673,'pl','OpÅ‚aty do dnia',0),(204198,5673,'bg','Ð¢Ð°ÐºÑÐ¸ ÐºÑŠÐ¼-Ð´Ð°Ñ‚Ð°',0),(204199,5673,'ur','Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(204200,5673,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(204201,5673,'vi','PhÃ­ Ä‘áº¿n ngÃ y',0),(204202,5673,'af','Kostes Byhou',0),(204203,5673,'ro','Taxe la zi',0),(204204,5673,'et','Maksud-kuupÃ¤ev',0),(204205,5673,'si','StroÅ¡ki do datuma',0),(204206,5673,'ba','Biaya To-date',0),(204207,5673,'nl','Kosten tot heden',0),(204208,5673,'fi','Maksujen tÃ¤hÃ¤n saakka',0),(204209,5673,'no','Kostnader til-dato',0),(204210,5673,'da','Afgifter til-dato',0),(204211,5673,'ko','ì²­êµ¬ ë‚ ì§œ',0),(204212,5673,'he','×—×™×•×‘×™× ×¢×“ ×”×™×•×',0),(204213,5673,'el','Î¤Î­Î»Î· Î½Î±-Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(204214,5673,'zh','æ”¶è´¹è‡³ä»Š\r\n',0),(204215,5673,'sv','Avgifter till-datum',0),(204216,5673,'it','Accuse a-data',0),(204217,5673,'tl','',0),(204218,5673,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3606;&#3638;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(204219,5673,'hi','à¤†à¤°à¥‹à¤ª-à¤¤à¤¾à¤°à¥€à¤–',0),(204220,5673,'ms','Caj sehingga kini',0),(204221,5673,'ar','Ø±Ø³ÙˆÙ… Ù„Ù„ØªØ§Ø±ÙŠØ®',0),(204222,5673,'fr','Frais Ã  ce jour',0),(204223,5673,'jp','æœ¬æ—¥ã?¾ã?§ã?®æ–™é‡‘',0),(204224,5673,'pt','Encargos atÃ© Ã  data',0),(204225,5673,'ru','ÐžÐ±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ Ðº Ð”Ð°Ñ‚Ð°',0),(204226,5673,'es','Cargas hasta la Fecha',0),(204227,5673,'de','GebÃ¼hren-To-date',0),(204228,5673,'en','Charges To-date',0),(204229,5674,'is','',0),(204230,5674,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ÙŠ Ù†Ø²Ø¯ÙŠÙƒ ÙŠØ§ Ø¨ÙŠØ´ Ø§Ø² Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙˆØ§Ù‚Ø¹ÙŠ',0),(204231,5674,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ÙŠ Ù†Ø²Ø¯ÙŠÙƒ ÙŠØ§ Ø¨ÙŠØ´ Ø§Ø² Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙˆØ§Ù‚Ø¹ÙŠ',0),(204232,5674,'tr','YakÄ±n veya tahmin Ã¼zerinden sipariÅŸ yok',0),(204233,5674,'pl','Nie zamÃ³wienia, w pobliÅ¼u lub nad szacunek',0),(204234,5674,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð±Ð»Ð¸Ð·Ð¾ Ð´Ð¾ Ð¸Ð»Ð¸ Ð½Ð°Ð´ Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(204235,5674,'ur','Ú©Û’ Ù‚Ø±ÛŒØ¨ ÛŒØ§ Ø§Ø³ Ú©Û’ Ø§Ù†Ø¯Ø§Ø²Û’ Ù¾Ø± Ú©ÙˆØ¦ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø§Ø±ÛŒ',0),(204236,5674,'sr','ÐÐ¸ÐºÐ°ÐºÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ° Ð±Ð»Ð¸Ð·Ñƒ Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐºÐ¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°',0),(204237,5674,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n hÃ ng gáº§n hoáº·c vÆ°á»£t quÃ¡ dá»± trÃ¹',0),(204238,5674,'af','Geen Bestellings Naby of Meer As Beraming',0),(204239,5674,'ro','Comenzi lÃ¢ngÄƒ sau prin estimare',0),(204240,5674,'et','Asuvaid ja jooksul hinnangu tellimuste',0),(204241,5674,'si','Brez naroÄil, v bliÅ¾ini ali ocenjeni',0),(204242,5674,'ba','Tidak ada order yang mendekati atau melampaui perkiraan',0),(204243,5674,'nl','Geen Orders in de buurt van of Over schatting',0),(204244,5674,'fi','Ei tilauksia lÃ¤helle tai pÃ¤Ã¤lle arvio',0),(204245,5674,'no','Ingen ordrer i nÃ¦rheten eller Over anslag',0),(204246,5674,'da','Ingen ordrer i nÃ¦rheden af eller Over skÃ¸n',0),(204247,5674,'ko','ì•„ë‹ˆ ì£¼ë¬¸ ê·¼ì²˜ ë˜ëŠ” ê²¬ì ',0),(204248,5674,'he','×¤×§×•×“×•×ª ×œ×™×“ ××• ×¢×œ ×”×¢×¨×›×”',0),(204249,5674,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ ÎºÎ¿Î½Ï„Î¬ Î® Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Ï„Î·Î½ ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ·',0),(204250,5674,'zh','æ²¡æœ‰æŽ¥è¿‘æˆ–è¶…è¿‡é¢„ç®—çš„è®¢å•\r\n',0),(204251,5674,'sv','Inga order nÃ¤ra eller Ã¶ver uppskattning',0),(204252,5674,'it','Nessun ordine vicino o sopra la stima',0),(204253,5674,'tl','',0),(204254,5674,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3651;&#3585;&#3621;&#3657;&#3627;&#3619;&#3639;&#3629;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3585;&#3634;&#3619;&#3',0),(204255,5674,'hi','à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤ªà¤¾à¤¸ à¤¯à¤¾ à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(204256,5674,'ms','Tidak ada arahan yang berhampiran atau ke atas anggaran',0),(204257,5674,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙˆØ§Ù…Ø± Ù‚Ø±Ø¨ Ø£Ùˆ Ø¹Ù„Ù‰ Ù…Ø¯Ù‰ ØªÙ‚Ø¯ÙŠØ±',0),(204258,5674,'fr','Aucune commande sur estimation ou proche',0),(204259,5674,'jp','è¦‹ç©?ã‚Šè‡³è¿‘ãƒ»è¶…é?Žã?®æ³¨æ–‡ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(204260,5674,'pt','Nenhuma ordem perto ou sobre a estimativa',0),(204261,5674,'ru','ÐÐµÑ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð², Ð²Ð¾Ð·Ð»Ðµ Ð¸Ð»Ð¸ Ð·Ð° Ð¾Ñ†ÐµÐ½ÐºÑƒ',0),(204262,5674,'es','Ningunos Ordenes Estan Cerca o MÃ¡s que los Estimados',0),(204263,5674,'de','Keine Bestellungen in der NÃ¤he oder Ã¼ber geschÃ¤tzte',0),(204264,5674,'en','No Orders Near or Over Estimate',0),(204265,5675,'is','',0),(204266,5675,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø² ',0),(204267,5675,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø² ',0),(204268,5675,'tr','AÃ§Ä±k sipariÅŸ listesi',0),(204269,5675,'pl','Aby otworzyÄ‡ listÄ™',0),(204270,5675,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ñ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(204271,5675,'ur','Ú©Ú¾Ù„ÛŒ Ø¢Ø±ÚˆØ± ÙÛØ±Ø³Øª',0),(204272,5675,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸Ñ… Ð½Ð°Ð»Ð¾Ð³Ð°',0),(204273,5675,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng má»Ÿ',0),(204274,5675,'af','Oop Bestellingslys',0),(204275,5675,'ro','Ordinea de Open lista',0),(204276,5675,'et','Nimekiri avatud tellimustest',0),(204277,5675,'si','Seznam odprtih nalogov',0),(204278,5675,'ba','Daftar open posisi',0),(204279,5675,'nl','Open Orderlijst',0),(204280,5675,'fi','Avaa huoltotilauksen luettelo',0),(204281,5675,'no','Ã…pne listen',0),(204282,5675,'da','Ã…ben ordre liste',0),(204283,5675,'ko','ì˜¤í”ˆ ìˆœì„œ ëª©ë¡',0),(204284,5675,'he','×¨×©×™×ž×ª ×”×–×ž× ×” ×¤×ª×•×—×”',0),(204285,5675,'el','Î£ÎµÎ¹ÏÎ¬ Î»Î¯ÏƒÏ„Î±',0),(204286,5675,'zh','å¼€æ”¾è®¢å•åˆ—è¡¨\r\n',0),(204287,5675,'sv','Ã–ppna listan',0),(204288,5675,'it','Elenco ordine aperto',0),(204289,5675,'tl','',0),(204290,5675,'th','&#3648;&#3611;&#3636;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(204291,5675,'hi','à¤–à¥à¤²à¤¾ à¤†à¤¦à¥‡à¤¶ à¤¸à¥‚à¤šà¥€',0),(204292,5675,'ms','Senarai pesanan yang terbuka',0),(204293,5675,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ù…ÙØªÙˆØ­',0),(204294,5675,'fr','Liste de commande en cours',0),(204295,5675,'jp','ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(204296,5675,'pt','Lista de pedidos em aberto',0),(204297,5675,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(204298,5675,'es','Lista de Ordenes Abiertos',0),(204299,5675,'de','Offene Liste',0),(204300,5675,'en','Open Order List',0),(204301,5676,'is','',0),(204302,5676,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª Ù†Ø²Ø¯ÙŠÙƒ  ÙŠØ§  Ø¨ÛŒØ´ Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯',0),(204303,5676,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª Ù†Ø²Ø¯ÙŠÙƒ  ÙŠØ§  Ø¨ÛŒØ´ Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯',0),(204304,5676,'tr','Ã‡evre ya da tahmin servis sipariÅŸleri',0),(204305,5676,'pl','W pobliÅ¼u lub nad szacunek zleceÅ„ serwisowych',0),(204306,5676,'bg','Ð‘Ð»Ð¸Ð·ÐºÐ¾ Ð¸Ð»Ð¸ Ð½Ð°Ð´ Ð¾Ñ†ÐµÐ½ÐºÐ°Ñ‚Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(204307,5676,'ur','Ø®Ø¯Ù…Øª Ú©Û’ Ù‚Ø±ÛŒØ¨ ÛŒØ§ Ø§Ù†Ú©Ù… Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Ø§ Ø­Ú©Ù… Ø¯Û’ Ø¯ÛŒØ§ Û”',0),(204308,5676,'sr','ÐÐ°Ð»Ð¾Ð·Ð¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ Ð±Ð»Ð¸Ð·Ñƒ Ð¸Ð»Ð¸ Ð³Ð¾Ñ‚Ð¾Ð²Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°',0),(204309,5676,'vi','ÄÆ¡n hÃ ng dá»‹ch vá»¥ gáº§n hay vÆ°á»£t quÃ¡ má»©c dá»± trÃ¹',0),(204310,5676,'af','Diensbestelling Naby of Meer as Kwotasie',0),(204311,5676,'ro','Serviciul comenzi estimarea lÃ¢ngÄƒ sau peste',0),(204312,5676,'et','Hooldustellimused lÃ¤heduses vÃµi Ã¼le hinnang',0),(204313,5676,'si','Servisni nalogi blizu ali nad oceno',0),(204314,5676,'ba','Layanan pesanan perkiraan dekat atau lebih',0),(204315,5676,'nl','In de omgeving van of Over schatting serviceorders',0),(204316,5676,'fi','Huoltotilaukset lÃ¤hellÃ¤ tai yli arvio',0),(204317,5676,'no','Serviceordrer nÃ¦r eller Over anslag',0),(204318,5676,'da','Serviceordrer i nÃ¦rheden af eller Over skÃ¸n',0),(204319,5676,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ê·¼ì²˜ ì´ìƒ ì˜ˆìƒ',0),(204320,5676,'he','×”×–×ž× ×•×ª ×©×™×¨×•×ª ×œ×™×“ ××• ×ž×¢×œ ×”××•×ž×“×Ÿ',0),(204321,5676,'el','Î•Î½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï… ÎºÎ¿Î½Ï„Î¬ Î® Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ·',0),(204322,5676,'zh','æŽ¥è¿‘æˆ–è¶…è¿‡é¢„ç®—æœåŠ¡ä»¤\r\n',0),(204323,5676,'sv','Serviceorder nÃ¤ra eller Ã¶ver uppskattning',0),(204324,5676,'it','Servizio ordini stima vicino o sopra',0),(204325,5676,'tl','',0),(204326,5676,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3651;&#3585;&#3621;&#3657;&#3627;&#3619;&#3639;&#3629;&#3648;&#3585;&#3636;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3',0),(204327,5676,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤¨à¤¿à¤•à¤Ÿ à¤¯à¤¾ à¤…à¤§à¤¿à¤• à¤¸à¥‡ à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(204328,5676,'ms','Perkhidmatan Pesanan anggaran yang berhampiran atau ke atas',0),(204329,5676,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© ØªÙ‚Ø¯ÙŠØ± Ø§Ù„Ù‚Ø±ÙŠØ¨ Ø£Ùˆ Ø£ÙƒØ«Ø±',0),(204330,5676,'fr','Service ordonne une estimation proche ou plue',0),(204331,5676,'jp','è¦‹ç©?ã‚Šè‡³è¿‘ãƒ»è¶…é?Žã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡',0),(204332,5676,'pt','Estimativa perto ou sobre ordens de serviÃ§o',0),(204333,5676,'ru','Ð¡ÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð¾Ñ†ÐµÐ½ÐºÐ¸ Ð²Ð±Ð»Ð¸Ð·Ð¸ Ð¸Ð»Ð¸ ÑÑ‚Ð°Ñ€ÑˆÐµ',0),(204334,5676,'es','Ordenes de Servicio Cerca o MÃ¡s que los Estimados',0),(204335,5676,'de','ServiceauftrÃ¤ge nahe oder Ã¼ber SchÃ¤tzung',0),(204336,5676,'en','Service Orders Near or Over Estimate',0),(204337,5677,'is','',0),(204338,5677,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙØ±Ø§ØªØ± Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯ ',0),(204339,5677,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙØ±Ø§ØªØ± Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯ ',0),(204340,5677,'tr','Emir Ã¼zerine tahmini',0),(204341,5677,'pl','ZamÃ³wienia na szacunek',0),(204342,5677,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð´ Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(204343,5677,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ù¾Ø± Ø­Ú©Ù…',0),(204344,5677,'sr','ÐÐ°Ð»Ð¾Ð³Ðµ Ð¿Ñ€ÐµÐºÐ¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°',0),(204345,5677,'vi','ÄÆ¡n hÃ ng quÃ¡ dá»± trÃ¹',0),(204346,5677,'af','Bestellings Meer as Skatting',0),(204347,5677,'ro','Comenzi Supraestimate',0),(204348,5677,'et','Tellimuste jooksul hinnangu',0),(204349,5677,'si','NaroÄila nad oceno',0),(204350,5677,'ba','Pesanan lebih dari perkiraan',0),(204351,5677,'nl','Bestellingen Over schatting',0),(204352,5677,'fi','Tilaukset yli arvio',0),(204353,5677,'no','Bestillinger Over anslag',0),(204354,5677,'da','Ordrer Over skÃ¸n',0),(204355,5677,'ko','ì£¼ë¬¸ ê²¬ì ì„ í†µí•´',0),(204356,5677,'he','×”×–×ž× ×•×ª ×ž×¢×œ ×”××•×ž×“×Ÿ',0),(204357,5677,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î¬Î½Ï‰ ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ·',0),(204358,5677,'zh','è®¢å•è¶…è¿‡ä¼°è®¡\r\n',0),(204359,5677,'sv','Order Ã¶ver uppskattningen',0),(204360,5677,'it','Ordini superiori stima',0),(204361,5677,'tl','',0),(204362,5677,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;',0),(204363,5677,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤†à¤¦à¥‡à¤¶',0),(204364,5677,'ms','Tempahan lebih dari anggaran',0),(204365,5677,'ar','Ø£ÙˆØ§Ù…Ø± Ø¹Ù„Ù‰ Ù…Ø¯Ù‰ ØªÙ‚Ø¯ÙŠØ±',0),(204366,5677,'fr','Commandes sur devis',0),(204367,5677,'jp','æŽ¨å®šå€¤ä»¥ä¸Šã?®æ³¨æ–‡',0),(204368,5677,'pt','Ordens durante estimativa',0),(204369,5677,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð¿Ð¾ ÑÐ¼ÐµÑ‚Ðµ',0),(204370,5677,'es','Pedidos MÃ¡s de los Estimados ',0),(204371,5677,'de','Bestellungen Ã¼ber geschÃ¤tzte',0),(204372,5677,'en','Orders Over Estimate',0),(204373,5678,'is','',0),(204374,5678,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(204375,5678,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ù…Ù„ Ø´Ø¯Ù‡ ',0),(204376,5678,'tr','Sevk tamamlanmÄ±ÅŸ sipariÅŸ ayrÄ±ntÄ±larÄ± gÃ¶rÃ¼ntÃ¼leme',0),(204377,5678,'pl','Zobacz szczegÃ³Å‚y wypeÅ‚nionego zamÃ³wienia wysÅ‚ane',0),(204378,5678,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð·Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(204379,5678,'ur','Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ù…Ú©Ù…Ù„ Ø¢Ø±ÚˆØ± ØªÙØ§ØµÛŒÙ„ Ú©Ø§ Ù…Ù†Ø¸Ø± Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(204380,5678,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸Ñ… Ð”ÐµÑ‚Ð°Ñ™Ð¸ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð°',0),(204381,5678,'vi','Xem Ä‘Æ¡n hÃ ng chi tiáº¿t Ä‘Ã£ chuyá»ƒn',0),(204382,5678,'af','Besigtig Voltooide Bestelling besonderhede Versend',0),(204383,5678,'ro','Vezi detalii comandÄƒ completat expediate',0),(204384,5678,'et','Vaata komplekteeritud Tellimuse Ã¼ksikasjad lÃ¤hetatud',0),(204385,5678,'si','Ogled podrobnosti izpolnjen nalog dobavljen',0),(204386,5678,'ba','Lihat rincian menyelesaikan pesanan dikirim',0),(204387,5678,'nl','Voltooide Bestellingsgegevens verzonden bekijken',0),(204388,5678,'fi','Katso valmiit Tilaustiedot lÃ¤hetetÃ¤Ã¤n',0),(204389,5678,'no','Vis utfylte bestillingsdetaljer sendt',0),(204390,5678,'da','Se fÃ¦rdige Ordredetaljer afsendt',0),(204391,5678,'ko','ë°°ì†¡ ì™„ë£Œ ëœ ì£¼ë¬¸ ì„¸ë¶€ ì •ë³´ ë³´ê¸°',0),(204392,5678,'he','×”×¦×’ ××ª ×¤×¨×˜×™ ×”×”×–×ž× ×” ×©×”×•×©×œ×ž×• ×©× ×©×œ×—×•',0),(204393,5678,'el','Î”ÎµÎ¯Ï„Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½Î·Ï‚ Î´Î¹Î±Ï„Î±Î³Î®Ï‚ Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(204394,5678,'zh','æŸ¥çœ‹å·²å®Œæˆçš„è®¢å•æ˜Žç»†å‘è´§\r\n',0),(204395,5678,'sv','Visa slutfÃ¶rda Orderdetaljer levereras',0),(204396,5678,'it','Visualizzare dettagli modulo d\'ordine spediti',0),(204397,5678,'tl','',0),(204398,5678,'th','&#3604;&#3641;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3626;&#3617;&#3610;&#3641;&#3',0),(204399,5678,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤•à¤¿à¤ à¤—à¤ à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤µà¤¿à¤µà¤°à¤£ à¤¦à¥‡à¤–à¥‡à¤‚',0),(204400,5678,'ms','Lihat butir-butir lengkap pesanan yang dihantar',0),(204401,5678,'ar','Ø¹Ø±Ø¶ ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø© Ø§Ù„ØªÙŠ ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(204402,5678,'fr','Afficher les dÃ©tails de commande terminÃ©e expÃ©diÃ©s',0),(204403,5678,'jp','ç™ºé€?æ¸ˆå®Œäº†æ³¨æ–‡è©³ç´°ã?®è¡¨ç¤º',0),(204404,5678,'pt','Ver os detalhes do pedido preenchido enviados',0),(204405,5678,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(204406,5678,'es','Ver Detalles de Ordenes Completados Enviados',0),(204407,5678,'de','Detailansicht abgeschlossene Bestellung ausgeliefert',0),(204408,5678,'en','View Completed Order Details Shipped',0),(204409,5679,'is','',0),(204410,5679,'dr','Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ ',0),(204411,5679,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ ',0),(204412,5679,'tr','Bitti tahmin sipariÅŸleri listesi',0),(204413,5679,'pl','Na oszacowanie listy zamÃ³wieÅ„',0),(204414,5679,'bg','ÐŸÐ¾Ð²ÐµÑ‡Ðµ Ð¿Ñ€Ð¾Ð³Ð½Ð¾Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(204415,5679,'ur','Ø²ÛŒØ§Ø¯Û Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(204416,5679,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(204417,5679,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng cao hÆ¡n dá»± trÃ¹',0),(204418,5679,'af','Meer as Skatting Bestellingslys',0),(204419,5679,'ro','Peste lista de comenzi de estimare',0),(204420,5679,'et','Ãœle hinnangu tellimuste loend',0),(204421,5679,'si','Nad oceno naroÄila seznam',0),(204422,5679,'ba','Lebih dari perkiraan perintah daftar',0),(204423,5679,'nl','Over raming Orders lijst',0),(204424,5679,'fi','Tilaukset yli Arvioluettelo',0),(204425,5679,'no','Over estimatliste ordrer',0),(204426,5679,'da','Over estimatlisten ordrer',0),(204427,5679,'ko','ì´ìƒ ê²¬ì  ì£¼ë¬¸ ëª©ë¡',0),(204428,5679,'he','×¨×©×™×ž×ª ×”×–×ž× ×•×ª ×”×¢×¨×›×” × ×’×ž×¨',0),(204429,5679,'el','Î Î¬Î½Ï‰ Î±Ï€ÏŒ ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î»Î¯ÏƒÏ„Î±',0),(204430,5679,'zh','é«˜ä¼°è®¢å•åˆ—è¡¨\r\n',0),(204431,5679,'sv','Ã–ver uppskattningslistan order',0),(204432,5679,'it','Elenco di ordini oltre stime',0),(204433,5679,'tl','',0),(204434,5679,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3609;&#3592;&#3634;&#3585;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;',0),(204435,5679,'hi','à¤…à¤§à¤¿à¤• à¤¸à¥‡ à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¸à¥‚à¤šà¥€',0),(204436,5679,'ms','Senarai pesanan anggaran ke atas',0),(204437,5679,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø£ÙˆØ§Ù…Ø± ØªÙ‚Ø¯ÙŠØ± Ø£ÙƒØ«Ø±',0),(204438,5679,'fr','Liste de commandes d\'estimations plus',0),(204439,5679,'jp','è¦‹ç©?ã‚Šè¶…é?Žæ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(204440,5679,'pt','Lista de ordens de estimativa mais',0),(204441,5679,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð±Ð¾Ð»ÐµÐµ ÐžÑ†ÐµÐ½ÐºÐ°',0),(204442,5679,'es','Lista de Ordenes Sobrevalorados',0),(204443,5679,'de','Ãœber SchÃ¤tzung Auftragsliste',0),(204444,5679,'en','Over Estimate Orders List',0),(204445,5680,'is','',0),(204446,5680,'dr','Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ Ù‚Ø¨Ù„ Ø§Ø² Ù¾Ø§ÙŠØ§Ù† Ø³Ø§Ù„ ',0),(204447,5680,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ Ù‚Ø¨Ù„ Ø§Ø² Ù¾Ø§ÙŠØ§Ù† Ø³Ø§Ù„ ',0),(204448,5680,'tr','YÄ±l sonundan Ã¶nce deftere nakledilmemiÅŸ kuponlarÄ±',0),(204449,5680,'pl','NiezaksiÄ™gowane bony przed koniec roku',0),(204450,5680,'bg','ÐÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ ÐºÑ€Ð°Ñ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(204451,5680,'ur','Ø³Ø§Ù„ Ú©Û’ Ø§Ø®ØªØªØ§Ù… Ø³Û’ Ù‚Ø¨Ù„ Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ ÙˆØ§Ø¤Ú†Ø±',0),(204452,5680,'sr','ÐÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ Ð¿Ñ€Ðµ ÐºÑ€Ð°Ñ˜Ð° Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(204453,5680,'vi','Phiáº¿u KhÃ´ng káº¿t chuyá»ƒn trÆ°á»›c cuá»‘i nÄƒm',0),(204454,5680,'af','Onposde Bewysstukke Voor Jaareinde',0),(204455,5680,'ro','Vouchere neÃ®ncÄƒrcate Ã®nainte de sfÃ¢rÅŸitul anului',0),(204456,5680,'et','Sisestamata kanded enne aasta lÃµppu',0),(204457,5680,'si','Neobjavljene bonov leto konca',0),(204458,5680,'ba','Unposted voucher sebelum akhir tahun',0),(204459,5680,'nl','Niet-doorgevoerde Vouchers voorafgaand aan het eind van het jaar',0),(204460,5680,'fi','Kirjaamattomat tositteita ennen vuoden loppua',0),(204461,5680,'no','Ikke-bokfÃ¸rt bilag fÃ¸r Ã¥rsskiftet',0),(204462,5680,'da','Ikke-bogfÃ¸rte gavekort inden Ã¥rets udgang',0),(204463,5680,'ko','ì—°ë§ ì „ì— ê²Œì‹œ ìƒí’ˆê¶Œ',0),(204464,5680,'he','×©×•×‘×¨×™× ×©×œ× × ×¨×©×ž×• ×œ×¤× ×™ ×¡×•×£ ×”×©× ×”',0),(204465,5680,'el','ÎœÎ· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î± Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î¿ Ï„Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î­Ï„Î¿Ï…Ï‚',0),(204466,5680,'zh','æœªå‘å¸ƒçš„ä¼˜æƒ åˆ¸è‡³å¹´åº•å‰\r\n',0),(204467,5680,'sv','Ej bokfÃ¶rda verifikationer fÃ¶re Ã¥rets slut',0),(204468,5680,'it','Voucher non registrata prima della fine dell\'anno',0),(204469,5680,'tl','',0),(204470,5680,'th','&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3585;&#3656;&#3629;&#3609;&#3607;&#3637;&#3656;&#3592;&#3632;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3',0),(204471,5680,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤…à¤‚à¤¤ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ unposted à¤µà¤¾à¤‰à¤šà¤°',0),(204472,5680,'ms','Unposted baucar sebelum akhir tahun',0),(204473,5680,'ar','Ù‚Ø³Ø§Ø¦Ù… ØºÙŠØ± Ø§Ù„Ù…Ù†Ø´ÙˆØ±Ø© Ù‚Ø¨Ù„ Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(204474,5680,'fr','ChÃ¨ques non comptabilisÃ©s avant la fin de l\'annÃ©e',0),(204475,5680,'jp','ä¼šè¨ˆå¹´åº¦æœ«ã?¾ã?§ã?®æœªè¨ˆä¸Šã?®ä¼?ç¥¨',0),(204476,5680,'pt','Vouchers nÃ£o lanÃ§ados antes do final do ano',0),(204477,5680,'ru','ÐÐµÐ¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹ Ð´Ð¾ ÐºÐ¾Ð½Ñ†Ð° Ð³Ð¾Ð´Ð°',0),(204478,5680,'es','Vouchers No Asentados Antes del Fin del Ejercicio',0),(204479,5680,'de','Ungebuchte Gutscheine vor Ende des Jahres',0),(204480,5680,'en','Unposted Vouchers Prior to Year End',0),(204481,5681,'is','',0),(204482,5681,'dr','Ø´Ù…Ø§ Ø¯Ø§Ø±ÙŠØ¯ ',0),(204483,5681,'pr','Ø´Ù…Ø§ Ø¯Ø§Ø±ÙŠØ¯ ',0),(204484,5681,'tr','Sen-si olmak',0),(204485,5681,'pl','Masz',0),(204486,5681,'bg','Ð˜Ð¼Ð°Ñ‚Ðµ',0),(204487,5681,'ur','Ø¢Ù¾ Ú©Û’ Ù¾Ø§Ø³ ÛÛ’',0),(204488,5681,'sr','ÐˆÐµÑÐ¸',0),(204489,5681,'vi','Báº¡n cÃ³',0),(204490,5681,'af','U het',0),(204491,5681,'ro','Aveti',0),(204492,5681,'et','Teil on',0),(204493,5681,'si','Imate',0),(204494,5681,'ba','Anda memiliki',0),(204495,5681,'nl','U hebt',0),(204496,5681,'fi','Sinulla on',0),(204497,5681,'no','Du har',0),(204498,5681,'da','Du har',0),(204499,5681,'ko','ë‹¹ì‹ ì€',0),(204500,5681,'he','×™×© ×œ×š',0),(204501,5681,'el','ÎˆÏ‡ÎµÏ„Îµ',0),(204502,5681,'zh','æ‚¨æœ‰\r\n',0),(204503,5681,'sv','Du har',0),(204504,5681,'it','Avete',0),(204505,5681,'tl','',0),(204506,5681,'th','&#3588;&#3640;&#3603;&#3617;&#3637;',0),(204507,5681,'hi','à¤†à¤ªà¤•à¥‡ à¤ªà¤¾à¤¸',0),(204508,5681,'ms','Anda mempunyai',0),(204509,5681,'ar','Ù„Ø¯ÙŠÙƒ',0),(204510,5681,'fr','Vous avez',0),(204511,5681,'jp','ã?‚ã?ªã?Ÿã?ŒæŒ?ã?£ã?¦ã?„ã‚‹ã?®ã?¯',0),(204512,5681,'pt','VocÃª tem',0),(204513,5681,'ru','Ð£ Ð²Ð°Ñ ÐµÑÑ‚ÑŒ',0),(204514,5681,'es','Usted tiene',0),(204515,5681,'de','Sie haben',0),(204516,5681,'en','You Have',0),(204517,5682,'is','',0),(204518,5682,'dr','Ø§ÙŠÙ…ÙŠÙ„ ÙØ§ÙƒØªÙˆØ± ',0),(204519,5682,'pr','Ø§ÙŠÙ…ÙŠÙ„ ÙØ§ÙƒØªÙˆØ± ',0),(204520,5682,'tr','E-posta fatura',0),(204521,5682,'pl','Poczta elektroniczna faktura',0),(204522,5682,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¸Ð¼ÐµÐ¹Ð»',0),(204523,5682,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(204524,5682,'sr','Ð•Ð¼Ð°Ð¸Ð» Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(204525,5682,'vi','Email hÃ³a Ä‘Æ¡n',0),(204526,5682,'af','E-pos Faktuur',0),(204527,5682,'ro','E-mail factura',0),(204528,5682,'et','Saada arve e-krjaga',0),(204529,5682,'si','E-poÅ¡tni raÄun',0),(204530,5682,'ba','Email faktur',0),(204531,5682,'nl','E-factuur',0),(204532,5682,'fi','SÃ¤hkÃ¶postilaskun',0),(204533,5682,'no','E-faktura',0),(204534,5682,'da','E-mail-faktura',0),(204535,5682,'ko','ì´ë©”ì¼ ì²­êµ¬ì„œ',0),(204536,5682,'he','×—×©×‘×•× ×™×ª ×“×•×\"×œ',0),(204537,5682,'el','ÎœÎ®Î½Ï…Î¼Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(204538,5682,'zh','ç”µå­é‚®ä»¶å‘ç¥¨\r\n',0),(204539,5682,'sv','E-faktura',0),(204540,5682,'it','Fattura email',0),(204541,5682,'tl','',0),(204542,5682,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(204543,5682,'hi','à¤ˆà¤®à¥‡à¤² à¤šà¤¾à¤²à¤¾à¤¨',0),(204544,5682,'ms','E-mel invois',0),(204545,5682,'ar','Ø£Ø±Ø³Ù„ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(204546,5682,'fr','Facture Ã©lectronique',0),(204547,5682,'jp','è«‹æ±‚æ›¸ã?®ï¼¥ãƒ¡ãƒ¼ãƒ«',0),(204548,5682,'pt','E-mail fatura',0),(204549,5682,'ru','Email Ð¡Ñ‡ÐµÑ‚',0),(204550,5682,'es','Email Factura',0),(204551,5682,'de','E-Mail-Rechnung',0),(204552,5682,'en','Email Invoice',0),(204553,5683,'is','',0),(204554,5683,'dr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡   ÙØ§ÙƒØªÙˆØ± Ø´Ù…Ø§ Ø§Ø³Øª',0),(204555,5683,'pr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡   ÙØ§ÙƒØªÙˆØ± Ø´Ù…Ø§ Ø§Ø³Øª',0),(204556,5683,'tr','EÄŸer fatura baÄŸlÄ± olduÄŸunu',0),(204557,5683,'pl','DoÅ‚Ä…czona jest faktura',0),(204558,5683,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¾ Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(204559,5683,'ur','Ø¢Ù¾ Ú©Û’ Ø¨Ù„ Ø³Û’ Ù…Ù†Ø³Ù„Ú© ÛÛ’',0),(204560,5683,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ Ñ˜Ðµ Ð’Ð°ÑˆÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(204561,5683,'vi','KÃ¨m Theo LÃ  HÃ³a ÄÆ¡n Cá»§a Báº¡n',0),(204562,5683,'af','U Faktuur is Aangeheg',0),(204563,5683,'ro','AtaÅŸat este factura',0),(204564,5683,'et','Lisatud on teie arve',0),(204565,5683,'si','PriloÅ¾en je vaÅ¡ raÄun',0),(204566,5683,'ba','Terlampir adalah faktur Anda',0),(204567,5683,'nl','Uw factuur is bijgevoegd',0),(204568,5683,'fi','LiitteenÃ¤ on lasku',0),(204569,5683,'no','Vedlagt er fakturaen',0),(204570,5683,'da','VedhÃ¦ftet er din faktura',0),(204571,5683,'ko','ì²¨ë¶€ëŠ” ì†¡ìž¥',0),(204572,5683,'he','×ž×¦×•×¨×¤×ª ×—×©×‘×•× ×™×ª ×©×œ×š',0),(204573,5683,'el','Î”Î¯Ï€Î»Î± Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹ÏŒ ÏƒÎ±Ï‚',0),(204574,5683,'zh','éšä¿¡é™„ä¸Šæ‚¨çš„å‘ç¥¨\r\n',0),(204575,5683,'sv','Bifogat Ã¤r din faktura',0),(204576,5683,'it','La fattura Ã¨ allegata',0),(204577,5683,'tl','',0),(204578,5683,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3649;&#3609;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(204579,5683,'hi','à¤¸à¤‚à¤²à¤—à¥à¤¨ à¤¹à¥ˆ à¤†à¤ªà¤•à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(204580,5683,'ms','Berikut adalah invois',0),(204581,5683,'ar','Ø§Ù„Ù…Ø±ÙÙ‚Ø© Ù‡ÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(204582,5683,'fr','AttachÃ© est votre facture',0),(204583,5683,'jp','è«‹æ±‚æ›¸ã‚’æ·»ä»˜ã?—ã?¾ã?—ã?Ÿ',0),(204584,5683,'pt','Em anexo Ã© sua fatura',0),(204585,5683,'ru','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(204586,5683,'es','Anexado es su Factura',0),(204587,5683,'de','Ihre Rechnung ist beigefÃ¼gt',0),(204588,5683,'en','Attached is your Invoice',0),(204589,5684,'is','',0),(204590,5684,'dr','Ù†ÙˆØ¹ Ø§ÙŠÙ…ÙŠÙ„ ',0),(204591,5684,'pr','Ù†ÙˆØ¹ Ø§ÙŠÙ…ÙŠÙ„ ',0),(204592,5684,'tr','E-posta tÃ¼rÃ¼',0),(204593,5684,'pl','Wpisz e-mail',0),(204594,5684,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð»Ð°',0),(204595,5684,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ù‚Ø³Ù…',0),(204596,5684,'sr','Ð¢Ð¸Ð¿ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(204597,5684,'vi','Loáº¡i Email',0),(204598,5684,'af','E-pos Tipe',0),(204599,5684,'ro','Tipul de e-mail',0),(204600,5684,'et','E-maili tÃ¼Ã¼p',0),(204601,5684,'si','Vrsta e-poÅ¡te',0),(204602,5684,'ba','Jenis email',0),(204603,5684,'nl','Type Email',0),(204604,5684,'fi','SÃ¤hkÃ¶postin tyyppi',0),(204605,5684,'no','Epost Type',0),(204606,5684,'da','E-mail Type',0),(204607,5684,'ko','ì´ë©”ì¼ í˜•ì‹',0),(204608,5684,'he','×¡×•×’ ×“×•×\"×œ',0),(204609,5684,'el','Î¤ÏÏ€Î¿Ï‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(204610,5684,'zh','ç”µå­é‚®ä»¶ç±»åž‹\r\n',0),(204611,5684,'sv','E-Type',0),(204612,5684,'it','Tipo di e-mail',0),(204613,5684,'tl','',0),(204614,5684,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(204615,5684,'hi','à¤ˆà¤®à¥‡à¤² à¤ªà¥à¤°à¤•à¤¾à¤°',0),(204616,5684,'ms','Jenis e-mel',0),(204617,5684,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(204618,5684,'fr','Type de messagerie',0),(204619,5684,'jp','ï¼¥ãƒ¡ãƒ¼ãƒ«ã‚¿ã‚¤ãƒ—',0),(204620,5684,'pt','Tipo de e-mail',0),(204621,5684,'ru','Ð¢Ð¸Ð¿ Email',0),(204622,5684,'es','Email Tipo',0),(204623,5684,'de','E-Mail-Typ',0),(204624,5684,'en','Email Type',0),(204625,5685,'is','',0),(204626,5685,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø¬Ø¯ÙŠØ¯ ',0),(204627,5685,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø¬Ø¯ÙŠØ¯ ',0),(204628,5685,'tr','Yeni e-posta',0),(204629,5685,'pl','Nowy poczta elektroniczna',0),(204630,5685,'bg','ÐÐ¾Ð² Ð¸Ð¼ÐµÐ¹Ð»',0),(204631,5685,'ur','Ù†Ø¦ÛŒ Ø§ÛŒ Ù…ÛŒÙ„',0),(204632,5685,'sr','ÐÐ¾Ð²Ñƒ Ðµ-Ð¿Ð¾Ñ€ÑƒÐºÑƒ',0),(204633,5685,'vi','Email má»›i',0),(204634,5685,'af','Nuwe E-pos',0),(204635,5685,'ro','Nou poÅŸtÄƒ electronicÄƒ',0),(204636,5685,'et','Uus e-kiri',0),(204637,5685,'si','Nov Email',0),(204638,5685,'ba','Email baru',0),(204639,5685,'nl','Nieuwe E-mail',0),(204640,5685,'fi','Uusi sÃ¤hkÃ¶posti',0),(204641,5685,'no','Ny e-post',0),(204642,5685,'da','Ny Email',0),(204643,5685,'ko','ìƒˆë¡œìš´ ì´ë©”ì¼',0),(204644,5685,'he','×“×•×\"×œ ×—×“×©',0),(204645,5685,'el','ÎÎ­Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(204646,5685,'zh','æ–°çš„ç”µå­é‚®ä»¶\r\n',0),(204647,5685,'sv','Ny e-post',0),(204648,5685,'it','Nuova Email',0),(204649,5685,'tl','',0),(204650,5685,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(204651,5685,'hi','à¤¨à¤¯à¤¾ à¤ˆà¤®à¥‡à¤²',0),(204652,5685,'ms','E-mel baru',0),(204653,5685,'ar','Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¬Ø¯ÙŠØ¯',0),(204654,5685,'fr','Nouvel Email',0),(204655,5685,'jp','æ–°è¦?ï¼¥ãƒ¡ãƒ¼ãƒ«',0),(204656,5685,'pt','Novo E-mail',0),(204657,5685,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Email',0),(204658,5685,'es','Nuevo Email',0),(204659,5685,'de','Neue e-Mail-Adresse',0),(204660,5685,'en','New Email',0),(204661,5686,'is','',0),(204662,5686,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ø¬Ù‡Øª ÙØ±Ø³ØªØ§Ø¯Ù† Ø¨Ù‡ ',0),(204663,5686,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ø¬Ù‡Øª ÙØ±Ø³ØªØ§Ø¯Ù† Ø¨Ù‡ ',0),(204664,5686,'tr','GÃ¶ndermek iÃ§in e-posta adresleri seÃ§me',0),(204665,5686,'pl','Wybierz adresy E-mail do wysyÅ‚ania do',0),(204666,5686,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑÐ¸ Ð·Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð´Ð¾',0),(204667,5686,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø¨Ú¾ÛŒØ¬Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù¾ØªØ§ Ø¬Ø§Øª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(204668,5686,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð°Ð´Ñ€ÐµÑÐµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ð¾ÑÐ»Ð°Ð»Ð¸',0),(204669,5686,'vi','Chá»n Äá»‹a Chá»‰ Email gá»­i tá»›i',0),(204670,5686,'af','Kies E-posadres na stuur aan',0),(204671,5686,'ro','SelectaÈ›i adresele de E-mail pentru a trimite',0),(204672,5686,'et','Vali e-maili aadressid, kuhu soovid saata',0),(204673,5686,'si','Izberite e-poÅ¡tne naslove za poÅ¡iljanje',0),(204674,5686,'ba','Pilih Alamat Email untuk mengirim ke',0),(204675,5686,'nl','Selecteer e-mailadressen te verzenden',0),(204676,5686,'fi','Valitse sÃ¤hkÃ¶postiosoitteet lÃ¤hettÃ¤Ã¤',0),(204677,5686,'no','Velge e-postadresser til Ã¥ sende til',0),(204678,5686,'da','VÃ¦lge E-mail-adresser til at sende til',0),(204679,5686,'ko','ë³´ë‚´ê¸° ì´ë©”ì¼ ì£¼ì†Œ ì„ íƒ',0),(204680,5686,'he','×‘×—×¨ ×›×ª×•×‘×ª ×“×•×\"×œ ×œ×©×œ×•×— ××œ',0),(204681,5686,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î³Î¹Î± Ï„Î·Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ',0),(204682,5686,'zh','é€‰æ‹©å‘é€åˆ°ç”µå­é‚®ä»¶åœ°å€\r\n',0),(204683,5686,'sv','VÃ¤lj e-postadresser att skicka till',0),(204684,5686,'it','Selezionare gli indirizzi Email per inviare a',0),(204685,5686,'tl','',0),(204686,5686,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3656;&#3591;',0),(204687,5686,'hi','à¤ˆà¤®à¥‡à¤² à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¤à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(204688,5686,'ms','Pilih alamat e-mel untuk menghantar kepada',0),(204689,5686,'ar','Ø­Ø¯Ø¯ \"Ø¹Ù†Ø§ÙˆÙŠÙ† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ\" Ù„Ø¥Ø±Ø³Ø§Ù„ Ø¥Ù„Ù‰',0),(204690,5686,'fr','SÃ©lectionnez les adresses de courriel Ã  envoyer Ã ',0),(204691,5686,'jp','é€?ä¿¡ã?™ã‚‹ï¼¥ãƒ¡ãƒ¼ãƒ«ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’é?¸æŠž',0),(204692,5686,'pt','Selecione endereÃ§os de E-mail para enviar para',0),(204693,5686,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Email ÐÐ´Ñ€ÐµÑ Ð´Ð»Ñ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(204694,5686,'es','Seleccionar Direcciones de Email para mandar a ',0),(204695,5686,'de','WÃ¤hlen Sie E-Mail-Adressen schicken',0),(204696,5686,'en','Select Email Addresses to send to',0),(204697,5687,'is','',0),(204698,5687,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ ',0),(204699,5687,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ ',0),(204700,5687,'tr','E-posta ÅŸu adrese gÃ¶nderin',0),(204701,5687,'pl','WyÅ›lij E-mail na adres',0),(204702,5687,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¸Ð¼ÐµÐ¹Ð» Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð°Ð´Ñ€ÐµÑ',0),(204703,5687,'ur','Ø§Ø³ Ù¾ØªÛ Ù¾Ø± Ø§ÛŒ Ù…ÛŒÙ„ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(204704,5687,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð•-Ð¼Ð°Ð¸Ð» Ð½Ð° Ð¾Ð²Ñƒ Ð°Ð´Ñ€ÐµÑÑƒ',0),(204705,5687,'vi','Gá»­i Email tá»›i Ä‘á»‹a chá»‰ nÃ y',0),(204706,5687,'af','Stuur E-pos na hierdie Adres',0),(204707,5687,'ro','Trimite Email la aceasta adresa',0),(204708,5687,'et','Saada e-kiri sellele aadressile',0),(204709,5687,'si','PoÅ¡lji Email na ta naslov',0),(204710,5687,'ba','Mengirim Email ke alamat ini',0),(204711,5687,'nl','Stuur E-mail naar dit adres',0),(204712,5687,'fi','LÃ¤hetÃ¤ sÃ¤hkÃ¶postia tÃ¤hÃ¤n osoitteeseen',0),(204713,5687,'no','Send e-post til denne adressen',0),(204714,5687,'da','Send E-mail til denne adresse',0),(204715,5687,'ko','ì´ ì£¼ì†Œë¡œ ì´ë©”ì¼ì„ ë³´ë‚´',0),(204716,5687,'he','×©×œ×— ×“×•×\"×œ ×œ×›×ª×•×‘×ª ×–×•',0),(204717,5687,'el','Î£Ï„ÎµÎ¯Î»ÎµÏ„Îµ Email ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(204718,5687,'zh','å‘é€ç”µå­é‚®ä»¶åˆ°è¿™ä¸ªåœ°å€\r\n',0),(204719,5687,'sv','Skicka mail till denna adress',0),(204720,5687,'it','Invia Email a questo indirizzo',0),(204721,5687,'tl','',0),(204722,5687,'th','&#3626;&#3656;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3652;&#3611;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3609;&#3637;&#3657;',0),(204723,5687,'hi','à¤‡à¤¸ à¤ªà¤¤à¥‡ à¤ªà¤° à¤ˆà¤®à¥‡à¤² à¤­à¥‡à¤œà¥‡à¤‚',0),(204724,5687,'ms','Menghantar e-mel ke alamat ini',0),(204725,5687,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¥Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(204726,5687,'fr','Envoyer par courriel Ã  cette adresse',0),(204727,5687,'jp','ã?“ã?®ã‚¢ãƒ‰ãƒ¬ã‚¹ã?«ï¼¥ãƒ¡ãƒ¼ãƒ«ã‚’é€?ä¿¡ã?™ã‚‹',0),(204728,5687,'pt','Enviar E-mail para este endereÃ§o',0),(204729,5687,'ru','ÐÐ°Ð¿Ð¸ÑˆÐ¸Ñ‚Ðµ Ð½Ð° ÑÑ‚Ð¾Ñ‚ Ð°Ð´Ñ€ÐµÑ',0),(204730,5687,'es','Enviar Email a esta DirecciÃ³n',0),(204731,5687,'de','Senden Sie E-Mail an diese Adresse',0),(204732,5687,'en','Send Email to this Address',0),(204733,5688,'is','',0),(204734,5688,'dr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ',0),(204735,5688,'pr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ',0),(204736,5688,'tr','SatÄ±ÅŸ iadeleri',0),(204737,5688,'pl','Zwrot',0),(204738,5688,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ð¸Ñ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(204739,5688,'ur','Ø³ÛŒÙ„Ø² Ø±Ù‚ÙˆÙ… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(204740,5688,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ñ€ÐµÑ„ÑƒÐ½Ð´Ð°Ñ†Ð¸Ñ˜Ðµ',0),(204741,5688,'vi','HoÃ n tráº£',0),(204742,5688,'af','Verkope terugbetalings',0),(204743,5688,'ro','Sales restituire',0),(204744,5688,'et','MÃ¼Ã¼gihÃ¼vituste',0),(204745,5688,'si','Prodajnih nadomestil',0),(204746,5688,'ba','Pengembalian uang penjualan',0),(204747,5688,'nl','Verkoop restituties',0),(204748,5688,'fi','Myynnin palautukset',0),(204749,5688,'no','Salg refusjoner',0),(204750,5688,'da','Salg restitutioner',0),(204751,5688,'ko','íŒë§¤ í™˜ë¶ˆ',0),(204752,5688,'he','×”×—×–×¨×™× ×ž×›×™×¨×•×ª',0),(204753,5688,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î­Ï‚ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½ Î³Î¹Î± Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(204754,5688,'zh','é”€å”®é€€æ¬¾\r\n',0),(204755,5688,'sv','FÃ¶rsÃ¤ljning Ã¥terbetalningar',0),(204756,5688,'it','Vendita restituzioni',0),(204757,5688,'tl','',0),(204758,5688,'th','&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;&#3651;&#3627;&#3657;',0),(204759,5688,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤°à¤¿à¤«à¤‚à¤¡',0),(204760,5688,'ms','Pulangan jualan',0),(204761,5688,'ar','Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ±Ø¯Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(204762,5688,'fr','Remboursements ventes',0),(204763,5688,'jp','ã‚»ãƒ¼ãƒ«ã‚¹è¿”é‡‘',0),(204764,5688,'pt','Reembolso de vendas',0),(204765,5688,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(204766,5688,'es','Reembolsos de Ventas',0),(204767,5688,'de','Vertrieb Erstattungen',0),(204768,5688,'en','Sales Refunds',0),(204769,5689,'is','',0),(204770,5689,'dr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(204771,5689,'pr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(204772,5689,'tr','Geri Ã¶deme',0),(204773,5689,'pl','Refundacji',0),(204774,5689,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(204775,5689,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(204776,5689,'sr','ÐŸÐ¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°',0),(204777,5689,'vi','HoÃ n láº¡i',0),(204778,5689,'af','Terugbetaling',0),(204779,5689,'ro','Restituirea',0),(204780,5689,'et','Toetuse',0),(204781,5689,'si','Nadomestila',0),(204782,5689,'ba','Pengembalian dana',0),(204783,5689,'nl','Restitutie',0),(204784,5689,'fi','Tuki',0),(204785,5689,'no','Tilbakebetaling',0),(204786,5689,'da','Restitution',0),(204787,5689,'ko','í™˜ë¶ˆ',0),(204788,5689,'he','×”×—×–×¨',0),(204789,5689,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(204790,5689,'zh','é€€æ¬¾\r\n',0),(204791,5689,'sv','Ã…terbetalning',0),(204792,5689,'it','Rimborso',0),(204793,5689,'tl','',0),(204794,5689,'th','&#3585;&#3634;&#3619;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;',0),(204795,5689,'hi','à¤µà¤¾à¤ªà¤¸à¥€',0),(204796,5689,'ms','Bayaran balik',0),(204797,5689,'ar','Ø¨Ø±Ø¯',0),(204798,5689,'fr','Remboursement',0),(204799,5689,'jp','è¿”é‡‘',0),(204800,5689,'pt','RestituiÃ§Ã£o',0),(204801,5689,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚',0),(204802,5689,'es','Reembolsar',0),(204803,5689,'de','Erstattung',0),(204804,5689,'en','Refund',0),(204805,5690,'is','',0),(204806,5690,'dr','Ù…Ù‚Ø¯Ø§Ø± Ú†Ùƒ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(204807,5690,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú†Ùƒ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(204808,5690,'tr','Geri Ã¶deme onay miktarÄ±nÄ±',0),(204809,5690,'pl','Kwota czeku',0),(204810,5690,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð¿Ñ€Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(204811,5690,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©Û’ Ú†ÛŒÚ© Ú©ÛŒ Ø±Ù‚Ù…',0),(204812,5690,'sr','Ð˜Ð·Ð½Ð¾Ñ Ñ‡ÐµÐºÐ° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°',0),(204813,5690,'vi','Sá»‘ Tiá»n SÃ©c HoÃ n Tráº£',0),(204814,5690,'af','Bedrag van terugbetaling kontroleer',0),(204815,5690,'ro','Suma de restituire verifica',0),(204816,5690,'et','Summa toetust kontrolli',0),(204817,5690,'si','Znesek nadomestila potrdite',0),(204818,5690,'ba','Jumlah pengembalian Check',0),(204819,5690,'nl','Bedrag van restitutie cheque',0),(204820,5690,'fi','MÃ¤Ã¤rÃ¤ hyvityksen sekki',0),(204821,5690,'no','Mengden av tilbakebetaling av',0),(204822,5690,'da','MÃ¦ngden af refusion Check',0),(204823,5690,'ko','í™˜ë¶ˆ í™•ì¸ ê¸ˆì•¡',0),(204824,5690,'he','×›×ž×•×ª ×”×—×–×¨ ×¦\'×§',0),(204825,5690,'el','Î Î»Î®Î¸Î¿Ï‚ ÎµÏ€Î¹Ï„Î±Î³ÏŽÎ½ ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚',0),(204826,5690,'zh','é€€æ¬¾æ”¯ç¥¨é‡‘é¢\r\n',0),(204827,5690,'sv','Beloppet fÃ¶r exportbidraget Check',0),(204828,5690,'it','Importo dell\'assegno di rimborso',0),(204829,5690,'tl','',0),(204830,5690,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3586;&#3629;&#3591;&#3607;&#3637;&#3656;&#3588;&#3639;&#3609;',0),(204831,5690,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤šà¥‡à¤• à¤•à¥€ à¤°à¤¾à¤¶à¤¿',0),(204832,5690,'ms','Jumlah cek bayaran balik',0),(204833,5690,'ar','Ù…Ù‚Ø¯Ø§Ø± Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ø³ØªØ±Ø¯Ø§Ø¯',0),(204834,5690,'fr','Montant du chÃ¨que de remboursement',0),(204835,5690,'jp','è¿”é‡‘å°?åˆ‡æ‰‹ã?®ç·?é¡?',0),(204836,5690,'pt','Quantidade de cheque de reembolso',0),(204837,5690,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð¾Ð¼',0),(204838,5690,'es','Monto de Cheque de DevoluciÃ³n',0),(204839,5690,'de','HÃ¶he der RÃ¼ckerstattungsforderung',0),(204840,5690,'en','Amount of Refund Check',0),(204841,5691,'is','',0),(204842,5691,'dr','Ø¯Ø± Ú†Ùƒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(204843,5691,'pr','Ø¯Ø± Ú†Ùƒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(204844,5691,'tr','Check-In dahil',0),(204845,5691,'pl','To sprawdziÄ‡',0),(204846,5691,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð² ÑˆÐ°Ñ…',0),(204847,5691,'ur','Ù…ÛŒÚº Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(204848,5691,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ Ñƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(204849,5691,'vi','Bao gá»“m trong SÃ©c',0),(204850,5691,'af','Ingesluit in Tjek',0),(204851,5691,'ro','Includ Ã®n a verifica',0),(204852,5691,'et','Kontrolli hulka',0),(204853,5691,'si','VkljuÄujejo v pregled',0),(204854,5691,'ba','Termasuk di cek',0),(204855,5691,'nl','Opnemen In toom',0),(204856,5691,'fi','Ovat kurissa',0),(204857,5691,'no','Inkludere i sjakk',0),(204858,5691,'da','Medtage i markeringen',0),(204859,5691,'ko','ì²´í¬ì— í¬í•¨',0),(204860,5691,'he','×›×œ×•×œ ×¡×™×ž×•×Ÿ',0),(204861,5691,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï…Ï€ÏŒ Î­Î»ÎµÎ³Ï‡Î¿',0),(204862,5691,'zh','åŒ…æ‹¬æ£€æŸ¥\r\n',0),(204863,5691,'sv','Inkludera i schack',0),(204864,5691,'it','Includere nel controllo',0),(204865,5691,'tl','',0),(204866,5691,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3648;&#3594;&#3655;&#3588;',0),(204867,5691,'hi','à¤œà¤¾à¤‚à¤š à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(204868,5691,'ms','Termasuk dalam semak',0),(204869,5691,'ar','ÙˆØªØ´Ù…Ù„ ÙÙŠ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(204870,5691,'fr','Inclure dans la vÃ©rification',0),(204871,5691,'jp','å°?åˆ‡æ‰‹ã?«å?«ã‚€',0),(204872,5691,'pt','Incluir na seleÃ§Ã£o',0),(204873,5691,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð² Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÑƒ',0),(204874,5691,'es','Incluir e Cheque',0),(204875,5691,'de','Enthalten In Schach',0),(204876,5691,'en','Include In Check',0),(204877,5692,'is','',0),(204878,5692,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(204879,5692,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(204880,5692,'tr','Geri Ã¶deme tutarÄ±',0),(204881,5692,'pl','WysokoÅ›Ä‡ refundacji',0),(204882,5692,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(204883,5692,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©ÛŒ Ø±Ù‚Ù…',0),(204884,5692,'sr','Ð˜Ð·Ð½Ð¾Ñ Ñ€ÐµÑ„ÑƒÐ½Ð´Ð°Ñ†Ð¸Ñ˜Ðµ',0),(204885,5692,'vi','Sá»‘ tiá»n HoÃ n láº¡i',0),(204886,5692,'af','Terbetaalde Bedrag',0),(204887,5692,'ro','Suma restituirii',0),(204888,5692,'et','Toetuse summa',0),(204889,5692,'si','Znesek nadomestila',0),(204890,5692,'ba','Jumlah pengembalian uang',0),(204891,5692,'nl','Restitutie',0),(204892,5692,'fi','MÃ¤Ã¤rÃ¤',0),(204893,5692,'no','RefusjonsbelÃ¸pet',0),(204894,5692,'da','RefusionsbelÃ¸bet',0),(204895,5692,'ko','í™˜ë¶ˆ ê¸ˆì•¡',0),(204896,5692,'he','×¡×›×•× ×”×”×—×–×¨',0),(204897,5692,'el','TÎ¿ ÏÏˆÎ¿Ï‚ Ï„Î¿Ï… Ï€Î¿ÏƒÎ¿Ï',0),(204898,5692,'zh','é€€æ¬¾é‡‘é¢\r\n',0),(204899,5692,'sv','Ã…terbetala',0),(204900,5692,'it','Importo del rimborso',0),(204901,5692,'tl','',0),(204902,5692,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;&#3651;&#3627;&#3657;',0),(204903,5692,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤°à¤¾à¤¶à¤¿',0),(204904,5692,'ms','Jumlah bayaran balik',0),(204905,5692,'ar','Ù…Ù‚Ø¯Ø§Ø± Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø±ØªØ¬Ø¹',0),(204906,5692,'fr','Montant du remboursement',0),(204907,5692,'jp','è¿”é‡‘é¡?',0),(204908,5692,'pt','Montante da restituiÃ§Ã£o',0),(204909,5692,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð²Ð¾Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ñ',0),(204910,5692,'es','Monto de Reembolso',0),(204911,5692,'de','RÃ¼ckerstattungsbetrag',0),(204912,5692,'en','Refund Amount',0),(204913,5693,'is','',0),(204914,5693,'dr','- Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ',0),(204915,5693,'pr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø³ÙŠÙ‡- Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ',0),(204916,5693,'tr','Kredi geri Ã¶deme',0),(204917,5693,'pl','Zwrotu kredytu',0),(204918,5693,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(204919,5693,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©Ø±ÛŒÚˆÙ¹',0),(204920,5693,'sr','ÐŸÐ¾Ð²Ñ€Ð°Ñ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(204921,5693,'vi','TÃ­n Dá»¥ng HoÃ n Tráº£',0),(204922,5693,'af','Terugbetaling krediet',0),(204923,5693,'ro','Credit de rambursare',0),(204924,5693,'et','Laenude tagasimaksmine',0),(204925,5693,'si','VraÄilo kredita',0),(204926,5693,'ba','Pengembalian kredit',0),(204927,5693,'nl','Restitutie krediet',0),(204928,5693,'fi','Tuen luotto',0),(204929,5693,'no','Refusjon-kreditt',0),(204930,5693,'da','Restitutionen kredit',0),(204931,5693,'ko','í™˜ë¶ˆ ì‹ ìš©',0),(204932,5693,'he','×”×—×–×¨ ×›×¡×¤×™ ××©×¨××™',0),(204933,5693,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ¿Ï',0),(204934,5693,'zh','ä¿¡ç”¨å¡é€€æ¬¾\r\n',0),(204935,5693,'sv','Ã…terbetala krediter',0),(204936,5693,'it','Rimborso credito',0),(204937,5693,'tl','',0),(204938,5693,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;',0),(204939,5693,'hi','à¤‹à¤£ à¤µà¤¾à¤ªà¤¸à¥€',0),(204940,5693,'ms','Bayaran balik kredit',0),(204941,5693,'ar','Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(204942,5693,'fr','Remboursement crÃ©dit',0),(204943,5693,'jp','è¿”é‡‘è²¸æ–¹',0),(204944,5693,'pt','RestituiÃ§Ã£o de crÃ©dito',0),(204945,5693,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(204946,5693,'es','CrÃ©dito de DevoluciÃ³n',0),(204947,5693,'de','Erstattung Credit',0),(204948,5693,'en','Refund Credit',0),(204949,5694,'is','',0),(204950,5694,'dr','- Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ) Ø¨Ø§ Ú†Ùƒ ',0),(204951,5694,'pr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø³ÙŠÙ‡- Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ) Ø¨Ø§ Ú†Ùƒ ',0),(204952,5694,'tr','Check Kredi geri Ã¶deme',0),(204953,5694,'pl','Zwrotu kredytu przez wyboru',0),(204954,5694,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ñ Ñ‡ÐµÐº',0),(204955,5694,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú†ÛŒÚ© Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(204956,5694,'sr','ÐŸÐ¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ñ‡ÐµÐº',0),(204957,5694,'vi','TÃ­n Dá»¥ng HoÃ n Tráº£ Báº±ng SÃ©c',0),(204958,5694,'af','Terugbetaling krediet deur toom',0),(204959,5694,'ro','Rambursare Credit de selectare',0),(204960,5694,'et','Toetuse krediidi tÅ¡ekiga',0),(204961,5694,'si','VraÄilo kredita s Äekom',0),(204962,5694,'ba','Pengembalian kredit dengan cek',0),(204963,5694,'nl','Restitutie krediet per cheque',0),(204964,5694,'fi','Tuen luotto tarkistaa',0),(204965,5694,'no','Refundere kredittkort med sjekk',0),(204966,5694,'da','Tilbagebetale kreditten ved Check',0),(204967,5694,'ko','ìˆ˜ í‘œë¡œ í™˜ë¶ˆ ì‹ ìš©',0),(204968,5694,'he','×”×—×–×¨ ×›×¡×¤×™ ××©×¨××™ ×‘×¦\'×§',0),(204969,5694,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ¿Ï Î¼Îµ ÎµÏ€Î¹Ï„Î±Î³Î®',0),(204970,5694,'zh','é€šè¿‡æ£€æŸ¥ä¿¡ç”¨å¡é€€æ¬¾\r\n',0),(204971,5694,'sv','Ã…terbetalning Credit check',0),(204972,5694,'it','Rimborso credito tramite assegno',0),(204973,5694,'tl','',0),(204974,5694,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;&#3604;&#3657;&#3623;&#3618;&#3648;&#3594;&#3655;&#3588;',0),(204975,5694,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤šà¥‡à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(204976,5694,'ms','Bayaran balik kredit cek',0),(204977,5694,'ar','Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¨Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(204978,5694,'fr','Remboursement de crÃ©dit par chÃ¨que',0),(204979,5694,'jp','å°?åˆ‡æ‰‹ã?®è¿”é‡‘è²¸æ–¹',0),(204980,5694,'pt','CrÃ©dito de reembolso por cheque',0),(204981,5694,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð° Ð¿Ð¾ Ñ‡ÐµÐºÑƒ',0),(204982,5694,'es','CrÃ©dito de Reembolso por Cheque',0),(204983,5694,'de','Erstattung Guthaben per Scheck',0),(204984,5694,'en','Refund Credit by Check',0),(204985,5695,'is','',0),(204986,5695,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù†Ø¯Ù‡ Ø¨Ø³ØªØ§Ù†Ú©Ø§Ø±',0),(204987,5695,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù†Ø¯Ù‡ Ø¨Ø³ØªØ§Ù†Ú©Ø§Ø±',0),(204988,5695,'tr','Check Kredi dengesi iÃ§in yazmak',0),(204989,5695,'pl','Napisz SprawdÅº saldo kredytowe',0),(204990,5695,'bg','ÐŸÐ¸ÑˆÐ° Ñ‡ÐµÐº Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ ÑÐ°Ð»Ð´Ð¾',0),(204991,5695,'ur','Ú©Ø±ÛŒÚˆÙ¹ ØªÙˆØ§Ø²Ù† Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ù„Ú©Ú¾ØªÛ’ ÛÛŒÚº Û”',0),(204992,5695,'sr','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(204993,5695,'vi','Viáº¿t SÃ©c Cho DÆ° CÃ³',0),(204994,5695,'af','Skryf Tjek uit vir Kredietbalans',0),(204995,5695,'ro','Scrie verificare sold creditor',0),(204996,5695,'et','Write Check for Credit Balance',0),(204997,5695,'si','Pisati preveri dobroimetje',0),(204998,5695,'ba','Menulis cek saldo',0),(204999,5695,'nl','Selectievakje voor creditsaldo schrijven',0),(205000,5695,'fi','Kirjoita tarkistaa maksettavien saldosta',0),(205001,5695,'no','Skriv Sjekk om kreditsaldo',0),(205002,5695,'da','Skriv Check for kredit Balance',0),(205003,5695,'ko','ì‹ ìš© ìž”ì•¡ì— ëŒ€ í•œ ìˆ˜ í‘œë¥¼ ì¨',0),(205004,5695,'he','×œ×¨×©×•× ×¦\'×§ ×¢×‘×•×¨ ×™×ª×¨×ª ×–×›×•×ª',0),(205005,5695,'el','Î“ÏÎ¬ÏˆÏ„Îµ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î³Î¹Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(205006,5695,'zh','å†™æ£€æŸ¥ä¿¡ç”¨å¡ä½™é¢\r\n',0),(205007,5695,'sv','Skriv kontrollera saldo',0),(205008,5695,'it','Assegno per il saldo a credito',0),(205009,5695,'tl','',0),(205010,5695,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3618;&#3629;&#3604;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(205011,5695,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¶à¥‡à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡',0),(205012,5695,'ms','Menulis semak baki kredit',0),(205013,5695,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ø¯Ø§Ø¦Ù†',0),(205014,5695,'fr','Faire le chÃ¨que de solde crÃ©diteur',0),(205015,5695,'jp','è²¸æ–¹æ®‹é«˜ã?®å°?åˆ‡æ‰‹ã‚’æ›¸ã??',0),(205016,5695,'pt','Cheque por saldo credor',0),(205017,5695,'ru','Ð’Ñ‹Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ñ‡ÐµÐº Ð½Ð° Ð¾ÑÑ‚Ð°Ñ‚Ð¾Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(205018,5695,'es','Escribir cheques para Balance de crÃ©dito',0),(205019,5695,'de','Scheck fÃ¼r Guthaben',0),(205020,5695,'en','Write Check for Credit Balance',0),(205021,5696,'is','',0),(205022,5696,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø¨Ø±Ø§ÙŠ Ù„ØºÙˆ Ù…Ø§Ù†Ø¯Ù‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± Ø¯Ø± Ø­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(205023,5696,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø¨Ø±Ø§ÙŠ Ù„ØºÙˆ Ù…Ø§Ù†Ø¯Ù‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± Ø¯Ø± Ø­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(205024,5696,'tr','Ã‡ek mÃ¼ÅŸteri hesabÄ±nÄ±n alacak bakiyesi iptal etmek iÃ§in yaz',0),(205025,5696,'pl','Napisz wyboru aby anulowaÄ‡ saldo kredytowe konta klienta',0),(205026,5696,'bg','ÐŸÐ¸ÑˆÐ° Ñ‡ÐµÐº Ð·Ð° Ð´Ð° Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ ÑÐ°Ð»Ð´Ð¾ Ð¿Ð¾ ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(205027,5696,'ur','Ú©Ø³Ù¹Ù…Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾Ø± Ú©Ø±ÛŒÚˆÙ¹ ØªÙˆØ§Ø²Ù† Ú©Ùˆ Ù…Ù†Ø³ÙˆØ® Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú†ÛŒÚ© Ù„Ú©Ú¾',0),(205028,5696,'sr','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´Ð° Ð¾Ñ‚ÐºÐ°Ð¶ÐµÑ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÑÐ°Ð»Ð´Ð¾ Ð½Ð° ÐºÐ¾Ð½Ñ‚Ñƒ ÐºÑƒÐ¿Ñ†Ð°',0),(205029,5696,'vi','Viáº¿t SÃ©c XÃ³a DÆ° CÃ³ TrÃªn TK KhÃ¡ch HÃ ng',0),(205030,5696,'af','Skryf Tjek uit om Kredietbalans vir Klant/KliÃ«ntrekening te Kanselleer',0),(205031,5696,'ro','Scrie Check pentru a anula soldul creditor cont client',0),(205032,5696,'et','Write Check to Cancel Credit Balance on Customer Account',0),(205033,5696,'si','NapiÅ¡ite pregled odpovedati dobroimetje na raÄun kupca',0),(205034,5696,'ba','Menulis cek untuk membatalkan Saldo kredit pada Account pelanggan',0),(205035,5696,'nl','Schrijf Check om te annuleren creditsaldo op de Account van de klant',0),(205036,5696,'fi','Kirjoita tarkistaa peruuttaa asiakkaan tilin saldo',0),(205037,5696,'no','Skriv sjekk for Ã¥ avbryte kreditsaldo kundekontoen',0),(205038,5696,'da','Skriv Check for at annullere kreditsaldo pÃ¥ kundekonto',0),(205039,5696,'ko','ê³ ê° ê³„ì •ì— ì‹ ìš© ìž”ì•¡ì„ ì·¨ì†Œ í•˜ë ¤ë©´ í™•ì¸ ìž‘ì„±',0),(205040,5696,'he','×œ×¨×©×•× ×¦\'×§ ×›×“×™ ×œ×‘×˜×œ ××ª ×™×ª×¨×ª ×–×›×•×ª ×‘×—×©×‘×•×Ÿ ×”×œ×§×•×—',0),(205041,5696,'el','Î“ÏÎ¬ÏˆÏ„Îµ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î½Î± Î±ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ ÏƒÎµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(205042,5696,'zh','å†™æ”¯ç¥¨ä»¥å–æ¶ˆå®¢æˆ·å¸æˆ·ä¸Šçš„ä¿¡ç”¨ä½™é¢\r\n',0),(205043,5696,'sv','Skriva fÃ¶r att avbryta kredit balans pÃ¥ kundkontot',0),(205044,5696,'it','Assegno per annullare il saldo a credito sul conto cliente',0),(205045,5696,'tl','',0),(205046,5696,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3648;&#3614;&#3639;&#3656;&#3629;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3618;&#3629;&#3604;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3651;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3',0),(205047,5696,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¶à¥‡à¤· à¤ªà¤° à¤—à¥à¤°à¤¾à¤¹à¤• à¤–à¤¾à¤¤à¥‡ à¤•à¥‹ à¤°à¤¦à¥à¤¦ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡',0),(205048,5696,'ms','Menulis cek untuk membatalkan baki kredit pada akaun pelanggan',0),(205049,5696,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ø¯Ø§Ø¦Ù† ÙÙŠ Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(205050,5696,'fr','Faire le chÃ¨que pour annuler le solde crÃ©diteur compte client',0),(205051,5696,'jp','é¡§å®¢ã‚¢ã‚«ã‚¦ãƒ³ãƒˆä¸Šã?®è²¸æ–¹æ®‹é«˜ã?®å?–ã‚Šæ¶ˆã?—å°?åˆ‡æ‰‹ã?®æ›¸ã??è¾¼ã?¿',0),(205052,5696,'pt','Cheque para cancelar o saldo de crÃ©dito na conta do cliente',0),(205053,5696,'ru','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¾ÑÑ‚Ð°Ñ‚Ð¾Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð° Ð½Ð° ÑÑ‡ÐµÑ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(205054,5696,'es','Elaborar Cheques para Cancelar el Balance de CrÃ©dito en la Cuenta de Cliente',0),(205055,5696,'de','Scheck um Guthaben auf dem Kundenkonto kÃ¼ndigen',0),(205056,5696,'en','Write Check to Cancel Credit Balance on Customer Account',0),(205057,5697,'is','',0),(205058,5697,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ù†Ø¸Ø±Ø§Øª ',0),(205059,5697,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ù†Ø¸Ø±Ø§Øª ',0),(205060,5697,'tr','E-posta yorum',0),(205061,5697,'pl','Elektroniczna komentarz',0),(205062,5697,'bg','Ð˜Ð¼ÐµÐ¹Ð» ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(205063,5697,'ur','Ø§ÛŒ Ù…ÛŒÙ„ ØªØ¨ØµØ±Û',0),(205064,5697,'sr','Ð• -Ð¿Ð¾ÑˆÑ‚Ð° ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(205065,5697,'vi','Email pháº£n há»“i',0),(205066,5697,'af','E-pos \"Comment\"',0),(205067,5697,'ro','Comentariu de e-mail',0),(205068,5697,'et','Post Kommenteeri',0),(205069,5697,'si','Komentar email',0),(205070,5697,'ba','Email komentar',0),(205071,5697,'nl','E-mail commentaar',0),(205072,5697,'fi','LÃ¤hetÃ¤ kommentti',0),(205073,5697,'no','E-kommentar',0),(205074,5697,'da','E-mail kommentar',0),(205075,5697,'ko','ì´ë©”ì¼ ëŒ“ê¸€',0),(205076,5697,'he','×”×¢×¨×ª ×“×•×\"×œ',0),(205077,5697,'el','Î£Ï‡ÏŒÎ»Î¹Î¿ Ï„Î¿Ï… Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(205078,5697,'zh','ç”µå­é‚®ä»¶è¯„è®º\r\n',0),(205079,5697,'sv','E-post kommentar',0),(205080,5697,'it','Commento di e-mail',0),(205081,5697,'tl','',0),(205082,5697,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3588;&#3623;&#3634;&#3617;&#3588;&#3636;&#3604;&#3648;&#3627;&#3655;&#3609;',0),(205083,5697,'hi','à¤ˆà¤®à¥‡à¤² à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€',0),(205084,5697,'ms','Komen e-mel',0),(205085,5697,'ar','Ø£Ø±Ø³Ù„ Ø§Ù„ØªØ¹Ù„ÙŠÙ‚',0),(205086,5697,'fr','Commentaire par courriel',0),(205087,5697,'jp','E-ãƒ¡ãƒ¼ãƒ«ã‚³ãƒ¡ãƒ³ãƒˆ',0),(205088,5697,'pt','ComentÃ¡rio de e-mail',0),(205089,5697,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹',0),(205090,5697,'es','Email Comentario',0),(205091,5697,'de','E-Mail Kommentar',0),(205092,5697,'en','Email Comment',0),(205093,5698,'is','',0),(205094,5698,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(205095,5698,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(205096,5698,'tr','SatÄ±cÄ± dosyayÄ± seÃ§in',0),(205097,5698,'pl','Zaznacz plik dostawcy',0),(205098,5698,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð» Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(205099,5698,'ur','ÙˆÛŒÙ†ÚˆØ± Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(205100,5698,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(205101,5698,'vi','Chá»n há»“ sÆ¡ ngÆ°á»i bÃ¡n ',0),(205102,5698,'af','Selekteer Verskaffer LÃªer',0),(205103,5698,'ro','SelectaÅ£i fiÅŸierul de furnizor',0),(205104,5698,'et','Vali tarnija fail',0),(205105,5698,'si','Izberite datoteko dobavitelja',0),(205106,5698,'ba','Pilih Vendor File',0),(205107,5698,'nl','Selecteer leverancier bestand',0),(205108,5698,'fi','Valitse toimittajan tiedosto',0),(205109,5698,'no','Velg leverandÃ¸ren fil',0),(205110,5698,'da','VÃ¦lg kreditor fil',0),(205111,5698,'ko','ê³µê¸‰ ì—…ì²´ íŒŒì¼ ì„ íƒ',0),(205112,5698,'he','×‘×—×¨ ×§×•×‘×¥ ×¡×¤×§',0),(205113,5698,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(205114,5698,'zh','é€‰æ‹©ä¾›åº”å•†æ¡£æ¡ˆ\r\n',0),(205115,5698,'sv','VÃ¤lj leverantÃ¶r-fil',0),(205116,5698,'it','Selezionare File fornitore',0),(205117,5698,'tl','',0),(205118,5698,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3615;&#3621;&#3660;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(205119,5698,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(205120,5698,'ms','Pilih fail Penjual',0),(205121,5698,'ar','Ø§Ø®ØªØ± Ù…Ù„Ù Ø§Ù„Ù…ÙˆØ±Ø¯',0),(205122,5698,'fr','SÃ©lectionnez le fichier fournisseur',0),(205123,5698,'jp','æ¥­è€…ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é?¸æŠž',0),(205124,5698,'pt','Selecione o arquivo do vendedor',0),(205125,5698,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¤Ð°Ð¹Ð» ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(205126,5698,'es','Seleccionar File de Proveedor',0),(205127,5698,'de','Kreditor-Datei auswÃ¤hlen',0),(205128,5698,'en','Select Vendor File',0),(205129,5699,'is','',0),(205130,5699,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù†Ø¯ ',0),(205131,5699,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù†Ø¯ ',0),(205132,5699,'tr','Ä°thal satÄ±cÄ±lar',0),(205133,5699,'pl','DostawcÃ³w importowane',0),(205134,5699,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð½Ð° Ð²Ð½ÐµÑÐµÐ½Ð¸',0),(205135,5699,'ur','Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©Ùˆ Ø¯Ø±Ø¢Ù…Ø¯ Ú©ÛŒØ§',0),(205136,5699,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸ ÑƒÐ²ÐµÐ·ÐµÐ½',0),(205137,5699,'vi','ÄÃ£ nháº­p ngÆ°á»i bÃ¡n',0),(205138,5699,'af','Verskaffers Invoer',0),(205139,5699,'ro','Furnizori importate',0),(205140,5699,'et','Tarnijaid imporditud',0),(205141,5699,'si','Prodajalci, uvoÅ¾enih',0),(205142,5699,'ba','Vendor yang diimpor',0),(205143,5699,'nl','Leveranciers geÃ¯mporteerd',0),(205144,5699,'fi','Toimittajien tuotu',0),(205145,5699,'no','LeverandÃ¸rer importert',0),(205146,5699,'da','Kreditorer importeret',0),(205147,5699,'ko','ê°€ì ¸ì˜¨ ê³µê¸‰ ì—…ì²´',0),(205148,5699,'he','×”×¡×¤×§×™× ×™×•×‘××•',0),(205149,5699,'el','Î Ï‰Î»Î·Ï„Î­Ï‚ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(205150,5699,'zh','è¿›å£ä¾›åº”å•†\r\n',0),(205151,5699,'sv','LeverantÃ¶rer som importeras',0),(205152,5699,'it','Fornitori di importati',0),(205153,5699,'tl','',0),(205154,5699,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3606;&#3641;&#3585;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3649;&#3621;&#3657;&#3623;',0),(205155,5699,'hi','à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(205156,5699,'ms','Vendor yang diimport',0),(205157,5699,'ar','Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ† Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(205158,5699,'fr','Vendeurs importÃ©s',0),(205159,5699,'jp','æ¥­è€…å?–ã‚Šè¾¼ã?¿',0),(205160,5699,'pt','Fornecedores importados',0),(205161,5699,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹',0),(205162,5699,'es','Proveedores Importados',0),(205163,5699,'de','Herstellern nicht importiert',0),(205164,5699,'en','Vendors Imported',0),(205165,5700,'is','',0),(205166,5700,'dr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(205167,5700,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(205168,5700,'tr','SatÄ±cÄ± dosya sÃ¼tun biÃ§imi',0),(205169,5700,'pl','Format pliku w kolumnie dostawcy',0),(205170,5700,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(205171,5700,'ur','Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(205172,5700,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(205173,5700,'vi','Há»“ sÆ¡ NgÆ°á»i bÃ¡n dáº¡ng cá»™t',0),(205174,5700,'af','Handelaar kolom lÃªerformaat',0),(205175,5700,'ro','Furnizor fiÅŸier Format coloane',0),(205176,5700,'et','Hankija veeru vormingus',0),(205177,5700,'si','Zapisa stolpec dobavitelja',0),(205178,5700,'ba','Penjual Format File kolom',0),(205179,5700,'nl','Bestandsindeling kolom leverancier',0),(205180,5700,'fi','Toimittajan sarakkeessa muodossa',0),(205181,5700,'no','LeverandÃ¸r-kolonnen filformat',0),(205182,5700,'da','Kreditor-kolonne filformat',0),(205183,5700,'ko','ê³µê¸‰ ì—…ì²´ íŒŒì¼ ì—´ í˜•ì‹',0),(205184,5700,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×§×•×‘×¥ ×¡×¤×§×™×',0),(205185,5700,'el','ÎœÎ¿ÏÏ†Î® ÏƒÏ„Î®Î»Î·Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½',0),(205186,5700,'zh','ä¾›åº”å•†æ¡£æ¡ˆæ æ ¼å¼\r\n',0),(205187,5700,'sv','LeverantÃ¶r-kolumn filformatet',0),(205188,5700,'it','Formato di colonna File fornitore',0),(205189,5700,'tl','',0),(205190,5700,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(205191,5700,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(205192,5700,'ms','Format kolum fail Penjual',0),(205193,5700,'ar','Ø¨Ù†ÙŠØ© (Ø®Ø§Ù†Ø§Øª) Ù…Ù„Ù Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(205194,5700,'fr','Format de colonne pour le fichier du vendeur',0),(205195,5700,'jp','æ¥­è€…ãƒ•ã‚¡ã‚¤ãƒ«åˆ—ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(205196,5700,'pt','Formato de coluna do arquivo de fornecedor',0),(205197,5700,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð¾Ð² Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(205198,5700,'es','Proveedor Formato File Columna',0),(205199,5700,'de','Kreditor-Spalte Dateiformat',0),(205200,5700,'en','Vendor File Column Format',0),(205201,5701,'is','',0),(205202,5701,'dr','Ø´Ø±Ø§ÙŠØ· Ø´ÙØ§Ù‡Ù‰',0),(205203,5701,'pr','Ø´Ø±Ø§ÙŠØ· Ø´ÙØ§Ù‡Ù‰',0),(205204,5701,'tr','SÃ¶zlÃ¼ ÅŸartlarÄ±',0),(205205,5701,'pl','Werbalne warunki',0),(205206,5701,'bg','Ð’ÐµÑ€Ð±Ð°Ð»Ð½Ð° Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð¸',0),(205207,5701,'ur','Ø²Ø¨Ø§Ù†ÛŒ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø·',0),(205208,5701,'sr','Ð’ÐµÑ€Ð±Ð°Ð»Ð½Ð° ÑƒÑÐ»Ð¾Ð²Ð¸',0),(205209,5701,'vi','Äiá»u khoáº£n Báº±ng Miá»‡ng',0),(205210,5701,'af','Mondelingse Terme',0),(205211,5701,'ro','Termeni verbale',0),(205212,5701,'et','Verbaalne tingimused',0),(205213,5701,'si','Verbalne izraze',0),(205214,5701,'ba','Syarat-syarat verbal',0),(205215,5701,'nl','Verbale voorwaarden',0),(205216,5701,'fi','Sanallinen ehdot',0),(205217,5701,'no','Verbale vilkÃ¥r',0),(205218,5701,'da','Verbale udtryk',0),(205219,5701,'ko','êµ¬ë‘ ìš©ì–´',0),(205220,5701,'he','×ª× ××™ ×ž×™×œ×•×œ×™×ª',0),(205221,5701,'el','Î›ÎµÎºÏ„Î¹ÎºÏŽÎ½ ÏŒÏÏ‰Î½',0),(205222,5701,'zh','è¨€è¯­æ¡æ¬¾\r\n',0),(205223,5701,'sv','Verbala villkor',0),(205224,5701,'it','Termini verbali',0),(205225,5701,'tl','',0),(205226,5701,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3604;&#3657;&#3623;&#3618;&#3611;&#3634;&#3585;&#3648;&#3611;&#3621;&#3656;&#3634;',0),(205227,5701,'hi','à¤®à¥Œà¤–à¤¿à¤• à¤¶à¤°à¥à¤¤à¥‹à¤‚',0),(205228,5701,'ms','Terma-terma lisan',0),(205229,5701,'ar','Ø§Ù„Ø´Ø±ÙˆØ· Ø§Ù„Ø´ÙÙ‡ÙŠØ©',0),(205230,5701,'fr','Conditions verbales',0),(205231,5701,'jp','è¨€èªžæ?¡ä»¶',0),(205232,5701,'pt','Termos verbais',0),(205233,5701,'ru','Ð¡Ð»Ð¾Ð²ÐµÑÐ½Ñ‹Ðµ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ñ‹',0),(205234,5701,'es','TÃ©rminos Verbales',0),(205235,5701,'de','Verbale Begriffe',0),(205236,5701,'en','Verbal Terms',0),(205237,5702,'is','',0),(205238,5702,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†',0),(205239,5702,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†',0),(205240,5702,'tr','Alma satÄ±cÄ±lar',0),(205241,5702,'pl','ZaimportowaÄ‡ dostawcÃ³w',0),(205242,5702,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(205243,5702,'ur','Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©Ùˆ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(205244,5702,'sr','Ð£Ð²Ð¾Ð· Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(205245,5702,'vi','Nháº­p ngÆ°á»i bÃ¡n',0),(205246,5702,'af','Invoer van Verskaffers',0),(205247,5702,'ro','Furnizori de import',0),(205248,5702,'et','Impordi hankijad',0),(205249,5702,'si','Uvoz dobaviteljev',0),(205250,5702,'ba','Impor vendor',0),(205251,5702,'nl','Importeren van leveranciers',0),(205252,5702,'fi','Tuo toimittajat',0),(205253,5702,'no','Importere leverandÃ¸rer',0),(205254,5702,'da','Importere leverandÃ¸rer',0),(205255,5702,'ko','ê°€ì ¸ì˜¤ê¸° ê³µê¸‰ ì—…ì²´',0),(205256,5702,'he','×™×‘× ×¡×¤×§×™×',0),(205257,5702,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï€Ï‰Î»Î·Ï„ÏŽÎ½',0),(205258,5702,'zh','å¯¼å…¥ä¾›åº”å•†\r\n',0),(205259,5702,'sv','Importera leverantÃ¶rer',0),(205260,5702,'it','Fornitori di importazione',0),(205261,5702,'tl','',0),(205262,5702,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(205263,5702,'hi','à¤†à¤¯à¤¾à¤¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(205264,5702,'ms','Pembekal import',0),(205265,5702,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ†',0),(205266,5702,'fr','Importer des vendeurs',0),(205267,5702,'jp','æ¥­è€…ã‚’å?–ã‚Šè¾¼ã‚€',0),(205268,5702,'pt','Fornecedores de importaÃ§Ã£o',0),(205269,5702,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(205270,5702,'es','Importar Proveedores',0),(205271,5702,'de','Import-Anbieter',0),(205272,5702,'en','Import Vendors',0),(205273,5703,'is','',0),(205274,5703,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± \r\n NolaPro',0),(205275,5703,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± \r\n NolaPro',0),(205276,5703,'tr','Sistem iÃ§ine satÄ±cÄ± listesini al',0),(205277,5703,'pl','Listy dostawcy importu do systemu',0),(205278,5703,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(205279,5703,'ur','Ù†Ø¸Ø§Ù… Ù…ÛŒÚº Ø¯Ø±Ø¢Ù…Ø¯ ÙˆÛŒÙ†ÚˆØ± ÙÛØ±Ø³Øª',0),(205280,5703,'sr','Ð£Ð²Ð¾Ð· Ð»Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼',0),(205281,5703,'vi','Nháº­p danh sÃ¡ch ngÆ°á»i bÃ¡n vÃ o NolaPro',0),(205282,5703,'af','Invoer van Verskafferlys binne-in NolaPro',0),(205283,5703,'ro','Import listÄƒ de furnizor Ã®n sistem',0),(205284,5703,'et','Impordi hankijate nimekiri NolaPro-sse',0),(205285,5703,'si','Uvozi seznam dobaviteljev v sistem',0),(205286,5703,'ba','Daftar Vendor impor ke dalam sistem',0),(205287,5703,'nl','Leverancier-lijst importeren in systeem',0),(205288,5703,'fi','Tuo toimittajaluettelo jÃ¤rjestelmÃ¤Ã¤n',0),(205289,5703,'no','Importer leverandÃ¸roversikten i System',0),(205290,5703,'da','Import Vendor List i System',0),(205291,5703,'ko','ì‹œìŠ¤í…œìœ¼ë¡œ ê°€ì ¸ì˜¤ê¸° ê³µê¸‰ ì—…ì²´ ëª©ë¡',0),(205292,5703,'he','NolaPro ×™×‘× ×¨×©×™×ž×ª ×¡×¤×§×™× ×œ×ª×•×š',0),(205293,5703,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î»Î¯ÏƒÏ„Î±Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(205294,5703,'zh','å¯¼å…¥ä¾›åº”å•†åå•åˆ°NolaPro\r\n',0),(205295,5703,'sv','Importera leverantÃ¶rslistan till System',0),(205296,5703,'it','Elenco di fornitori di importazione nel sistema',0),(205297,5703,'tl','',0),(205298,5703,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3652;&#3611;&#3626;&#3641;&#3656; Nolapro',0),(205299,5703,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥‚à¤šà¥€ à¤†à¤¯à¤¾à¤¤ à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤®à¥‡à¤‚',0),(205300,5703,'ms','Senarai penjual import ke dalam sistem',0),(205301,5703,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(205302,5703,'fr','Liste de fournisseurs d\'importation dans le systÃ¨me',0),(205303,5703,'jp','æ¥­è€…ãƒªã‚¹ãƒˆã‚’Nolaproã?¸ã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆ',0),(205304,5703,'pt','Lista de fornecedores de importaÃ§Ã£o no sistema',0),(205305,5703,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¡Ð¿Ð¸ÑÐºÐ° ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð² NolaPro',0),(205306,5703,'es','Importar Lista de Proveedores a NolaPro',0),(205307,5703,'de','Anbieter-Liste importieren in System',0),(205308,5703,'en','Import Vendor List into System',0),(205309,5704,'is','',0),(205310,5704,'dr','Ø¨Ø±Ø§ÙŠ ÙŠÙƒ Ú†Ùƒ Ù†Ù‚Ø¯ Ù†Ø´Ø¯Ù‡ â€“ Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(205311,5704,'pr','Ø¨Ø±Ø§ÙŠ ÙŠÙƒ Ú†Ùƒ Ù†Ù‚Ø¯ Ù†Ø´Ø¯Ù‡ â€“ Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(205312,5704,'tr','Bir onay UNCASH iÃ§in kontrol numarasÄ± girin',0),(205313,5704,'pl','Do UNCASH wyboru, wpisz numer SprawdÅº',0),(205314,5704,'bg','Ð”Ð° UNCASH Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(205315,5704,'ur','ÛŒÙˆÙ†Ú©Ø§Ø´ Ø§ÛŒÚ© Ú†ÛŒÚ© Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ØŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(205316,5704,'sr','Ð”Ð° Ð£ÐÐ¦ÐÐ¡Ð¥ Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ, ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð°',0),(205317,5704,'vi','Äá»ƒ khÃ´ng Ä‘á»•i SÃ©c thÃ nh tiá»n máº·t, nháº­p sá»‘ SÃ©c',0),(205318,5704,'af','Om \'n tjek te WISSEL, voer die Tjeknommer in',0),(205319,5704,'ro','Pentru a UNCASH un control, introduceÅ£i numÄƒrul verifica',0),(205320,5704,'et','UNCASH on sisse, sisestage telefoninumber kontrollida',0),(205321,5704,'si','UNCASH pregled, vnesite Å¡tevilko preverite',0),(205322,5704,'ba','UNCASH cek, masukkan nomor Check',0),(205323,5704,'nl','Om te UNCASH een controle, het nummer controleren',0),(205324,5704,'fi','UNCASH tarkistaa, valitse Tarkista',0),(205325,5704,'no','For Ã¥ UNCASH en sjekk, angi sjekk',0),(205326,5704,'da','For at UNCASH en check, indtaste den indskrive nummer',0),(205327,5704,'ko','í‘œ UNCASHë¥¼ í™•ì¸ ë²ˆí˜¸ë¥¼ ìž…ë ¥',0),(205328,5704,'he','×›×“×™ UNCASH ×”×ž×—××”, ×”×–×Ÿ ××ª ×”×ž×¡×¤×¨ ×‘×“×•×§',0),(205329,5704,'el','ÎÎ± UNCASH Î¼Î¹Î± ÎµÏ€Î¹Ï„Î±Î³Î®, ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(205330,5704,'zh','è¦ä¸å…‘çŽ°æ”¯ç¥¨ï¼Œæ”¯ç¥¨å·ç è¾“å…¥\r\n',0),(205331,5704,'sv','FÃ¶r att UNCASH en kontroll, anger du kontrollera numret',0),(205332,5704,'it','Per UNCASH un assegno, immettere il numero di controllo',0),(205333,5704,'tl','',0),(205334,5704,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3648;&#3594;&#3655;&#3588;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;, &#3611;&#3657;&#3629;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&',0),(205335,5704,'hi','UNCASH à¤à¤• à¤šà¥‡à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ à¤¨à¤‚à¤¬à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(205336,5704,'ms','Untuk UNCASH cek, masukkan nombor semakan',0),(205337,5704,'ar','Ø£ÙˆÙ†ÙƒØ§Ø´ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±ØŒ Ø£Ø¯Ø®Ù„ \"Ø±Ù‚Ù… Ø§Ù„ØªØ­Ù‚Ù‚\"',0),(205338,5704,'fr','Pour UNCASH un chÃ¨que, entrez le numÃ©ro de vÃ©rifier',0),(205339,5704,'jp','å°?åˆ‡æ‰‹ã‚’æœªæ?›é‡‘ã?«ã?™ã‚‹ã?«ã?¯ã€?å°?åˆ‡æ‰‹ç•ªå?·ã‚’å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(205340,5704,'pt','Para UNCASH um cheque, digite o nÃºmero do cheque',0),(205341,5704,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ UNCASH Ñ‡ÐµÐº, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(205342,5704,'es','Para DESCAMBIAR un cheque, ingresar el NÃºmero de Cheque',0),(205343,5704,'de','Um einen Scheck UNCASH, geben Sie die Schecknummer',0),(205344,5704,'en','To UNCASH a check, enter the Check Number',0),(205345,5705,'is','',0),(205346,5705,'dr','(Ú©Ù…Ú©',0),(205347,5705,'pr','Ø³Ù‡Ù… (Ú©Ù…Ú©',0),(205348,5705,'tr','KatkÄ±',0),(205349,5705,'pl','WkÅ‚ad',0),(205350,5705,'bg','ÐŸÑ€Ð¸Ð½Ð¾Ñ',0),(205351,5705,'ur','Ø§Ø¹Ø§Ù†Øª',0),(205352,5705,'sr','Ð”Ð¾Ð¿Ñ€Ð¸Ð½Ð¾Ñ',0),(205353,5705,'vi','ÄÃ³ng gÃ³p',0),(205354,5705,'af','Bydrae',0),(205355,5705,'ro','ContribuÅ£ia',0),(205356,5705,'et','Toetus',0),(205357,5705,'si','Prispevek',0),(205358,5705,'ba','Kontribusi',0),(205359,5705,'nl','Bijdrage',0),(205360,5705,'fi','Osuus',0),(205361,5705,'no','Bidrag',0),(205362,5705,'da','Bidrag',0),(205363,5705,'ko','ê¸°ì—¬',0),(205364,5705,'he','×”×ª×¨×•×ž×”',0),(205365,5705,'el','Î£Ï…Î¼Î²Î¿Î»Î®',0),(205366,5705,'zh','æçŒ®\r\n',0),(205367,5705,'sv','Bidrag',0),(205368,5705,'it','Contributo',0),(205369,5705,'tl','',0),(205370,5705,'th','&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3592;&#3634;&#3588;',0),(205371,5705,'hi','à¤¯à¥‹à¤—à¤¦à¤¾à¤¨',0),(205372,5705,'ms','Sumbangan',0),(205373,5705,'ar','Ù…Ø³Ø§Ù‡Ù…Ø©',0),(205374,5705,'fr','Contribution',0),(205375,5705,'jp','å¯„ä»˜',0),(205376,5705,'pt','ContribuiÃ§Ã£o',0),(205377,5705,'ru','Ð’ÐºÐ»Ð°Ð´',0),(205378,5705,'es','ContribuciÃ³n',0),(205379,5705,'de','Beitrag',0),(205380,5705,'en','Contribution',0),(205381,5706,'is','',0),(205382,5706,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰ ',0),(205383,5706,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰ ',0),(205384,5706,'tr','Medicare vergi',0),(205385,5706,'pl','Medicare podatku',0),(205386,5706,'bg','Medicare Ð´Ð°Ð½ÑŠÐº',0),(205387,5706,'ur','Ù…ÛŒÚˆÛŒ Ù¹ÛŒÚ©Ø³',0),(205388,5706,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(205389,5706,'vi','Thuáº¿ chÄƒm sÃ³c y táº¿',0),(205390,5706,'af','Medicare belasting',0),(205391,5706,'ro','Medicare fiscale',0),(205392,5706,'et','Medicare maksu',0),(205393,5706,'si','DavÄnih Medicare',0),(205394,5706,'ba','Medicare pajak',0),(205395,5706,'nl','Medicare belasting',0),(205396,5706,'fi','Medicare vero',0),(205397,5706,'no','Medicare skatt',0),(205398,5706,'da','Medicare skat',0),(205399,5706,'ko','ë©”ë””ì¼€ì–´ ì„¸',0),(205400,5706,'he','Medicare ×ž×¡',0),(205401,5706,'el','Medicare Ï†ÏŒÏÎ¿',0),(205402,5706,'zh','åŒ»ç–—ä¿é™©ç¨Ž\r\n',0),(205403,5706,'sv','Medicare skatt',0),(205404,5706,'it','Medicare fiscale',0),(205405,5706,'tl','',0),(205406,5706,'th','&#3616;&#3634;&#3625;&#3637;&#3588;&#3656;&#3634;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;',0),(205407,5706,'hi','à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤° à¤Ÿà¥ˆà¤•à¥à¤¸',0),(205408,5706,'ms','Cukai Medicare',0),(205409,5706,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(205410,5706,'fr','ImpÃ´t assurance maladie',0),(205411,5706,'jp','åŒ»ç™‚ä¿?é™ºç¨Ž',0),(205412,5706,'pt','Imposto de Medicare',0),(205413,5706,'ru','Medicare Ð½Ð°Ð»Ð¾Ð³',0),(205414,5706,'es','Impuesto de Medicare',0),(205415,5706,'de','Krankenversicherung',0),(205416,5706,'en','Medicare Tax',0),(205417,5707,'is','',0),(205418,5707,'dr','(Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(205419,5707,'pr','Ù…Ø®ØªÙ„Ù(Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(205420,5707,'tr','Misc',0),(205421,5707,'pl','Misc',0),(205422,5707,'bg','Ð Ð°Ð·Ð½Ð¸',0),(205423,5707,'ur','Ù…ØªÙØ±Ù‚',0),(205424,5707,'sr','ÐœÐ˜Ð¡Ð¦',0),(205425,5707,'vi','Láº·t váº·t',0),(205426,5707,'af','Misc',0),(205427,5707,'ro','Misc',0),(205428,5707,'et','Varia',0),(205429,5707,'si','Misc',0),(205430,5707,'ba','Misc',0),(205431,5707,'nl','Misc',0),(205432,5707,'fi','Muut',0),(205433,5707,'no','Diverse',0),(205434,5707,'da','Misc',0),(205435,5707,'ko','ê¸°íƒ€',0),(205436,5707,'he','Misc',0),(205437,5707,'el','Misc',0),(205438,5707,'zh','æ‚é¡¹\r\n',0),(205439,5707,'sv','Misc',0),(205440,5707,'it','Misc',0),(205441,5707,'tl','',0),(205442,5707,'th','&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;',0),(205443,5707,'hi','Misc',0),(205444,5707,'ms','MISC',0),(205445,5707,'ar','Ù…ØªÙØ±Ù‚Ø§Øª',0),(205446,5707,'fr','Misc',0),(205447,5707,'jp','ã??ã?®ä»–',0),(205448,5707,'pt','Misc',0),(205449,5707,'ru','Ð Ð°Ð·Ð½Ð¾Ðµ',0),(205450,5707,'es','Misc.',0),(205451,5707,'de','Misc',0),(205452,5707,'en','Misc',0),(205453,5708,'is','',0),(205454,5708,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª  Ø­Ù‚ÙˆÙ‚',0),(205455,5708,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª  Ø­Ù‚ÙˆÙ‚',0),(205456,5708,'tr','Misc vergiden maaÅŸ',0),(205457,5708,'pl','Misc opodatkowaniu pÅ‚ac',0),(205458,5708,'bg','Ð Ð°Ð·Ð½Ð¸ Ð½ÐµÐ¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(205459,5708,'ur','Ù…ØªÙØ±Ù‚ Ù…Ø³ØªØ«Ù†Ù°ÛŒ ØªÙ†Ø®ÙˆØ§Û',0),(205460,5708,'sr','ÐœÐ˜Ð¡Ð¦ Ð¿Ð»Ð°Ñ‚Ðµ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ðµ Ð¾Ð¿Ð¾Ñ€ÐµÐ·ÑƒÑ˜Ðµ',0),(205461,5708,'vi','Thanh toÃ¡n khoáº£n láº·t váº·t khÃ´ng chá»‹u thuáº¿',0),(205462,5708,'af','Allerlei Nie-Belasbare Besoldiging',0),(205463,5708,'ro','Misc neimpozabile plata',0),(205464,5708,'et','Varia mittemaksukohustuslasest tasu',0),(205465,5708,'si','Misc davÄni zavezanec plaÄati',0),(205466,5708,'ba','Misc tidak kena pajak membayar',0),(205467,5708,'nl','Misc niet-belastbare loon',0),(205468,5708,'fi','Muut verovelvollisen maksu',0),(205469,5708,'no','Diverse ikke-skattepliktige lÃ¸nn',0),(205470,5708,'da','Misc ikkeâ€“afgiftspligtige lÃ¸n',0),(205471,5708,'ko','ê¸°íƒ€ ë¹„ ê³¼ì„¸ ê¸‰ì—¬',0),(205472,5708,'he','Misc ×©××™× ×• ×—×™×™×‘ ×œ×©×œ× ×©×›×¨',0),(205473,5708,'el','Misc Î±Ï†Î¿ÏÎ¿Î»ÏŒÎ³Î·Ï„Î¿ Î±Î¼Î¿Î¹Î²ÏŽÎ½',0),(205474,5708,'zh','æ‚é¡¹éžåº”ç¨Žè–ªé…¬\r\n',0),(205475,5708,'sv','Misc icke beskattningsbara lÃ¶n',0),(205476,5708,'it','Misc Non imponibile paga',0),(205477,5708,'tl','',0),(205478,5708,'th','&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;',0),(205479,5708,'hi','à¤µà¤¿à¤µà¤¿à¤§ à¤—à¥ˆà¤°-à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨',0),(205480,5708,'ms','MISC tidak dikenakan cukai gaji',0),(205481,5708,'ar','Ù…ØªÙØ±Ù‚Ø§Øª ÙÙŠ Ø§Ù„Ø£Ø¬ÙˆØ± ØºÙŠØ± Ø§Ù„Ø®Ø§Ø¶Ø¹Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(205482,5708,'fr','RÃ©munÃ©ration Non imposable misc',0),(205483,5708,'jp','ã??ã?®ä»–é?žèª²ç¨Žå¯¾è±¡æ”¯æ‰•',0),(205484,5708,'pt','Misc nÃ£o-tributÃ¡veis Pay',0),(205485,5708,'ru','ÐŸÑ€Ð¾Ñ‡Ð¸Ðµ Ð½ÐµÐ¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ñ‹Ðµ ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ðµ',0),(205486,5708,'es','Pago Misc. No-Imponible',0),(205487,5708,'de','Misc Nichtsteuerpflichtige Pay',0),(205488,5708,'en','Misc Nontaxable Pay',0),(205489,5709,'is','',0),(205490,5709,'dr','Ù‡ÙŠÚ† ÙƒØ§Ø±Ù…Ù†Ø¯ ÙØ¹Ø§Ù„ÙŠ ',0),(205491,5709,'pr','Ù‡ÙŠÚ† ÙƒØ§Ø±Ù…Ù†Ø¯ ÙØ¹Ø§Ù„ÙŠ ',0),(205492,5709,'tr','Aktif Ã§alÄ±ÅŸan',0),(205493,5709,'pl','Nie aktywnych pracownikÃ³w',0),(205494,5709,'bg','ÐÑÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(205495,5709,'ur','Ú©ÙˆØ¦ÛŒ ÙØ¹Ø§Ù„ Ù…Ù„Ø§Ø²Ù…ÛŒÙ†',0),(205496,5709,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸Ñ… Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(205497,5709,'vi','KhÃ´ng cÃ³ nhÃ¢n viÃªn Ä‘ang hoáº¡t Ä‘á»™ng',0),(205498,5709,'af','Geen Aktiewe Werknemers',0),(205499,5709,'ro','Nici angajaÅ£ii activ',0),(205500,5709,'et','Ãœhtegi aktiivset tÃ¶Ã¶tajat',0),(205501,5709,'si','Ni aktivno zaposlenih',0),(205502,5709,'ba','Karyawan tidak aktif',0),(205503,5709,'nl','Geen actieve medewerkers',0),(205504,5709,'fi','TyÃ¶ntekijÃ¤Ã¤ ei ole aktiivinen',0),(205505,5709,'no','Ingen aktive ansatte',0),(205506,5709,'da','Ingen aktive medarbejdere',0),(205507,5709,'ko','ì§ì›ì´ ì•„ë‹ˆ í™œì„±',0),(205508,5709,'he','×‘×œ×™ ×¢×•×‘×“×™× ×¤×¢×™×œ×™×',0),(205509,5709,'el','Î•Î½ÎµÏÎ³ÏŒ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Î´ÎµÎ½',0),(205510,5709,'zh','æ— åœ¨èŒèŒå·¥\r\n',0),(205511,5709,'sv','Inga aktiva anstÃ¤llda',0),(205512,5709,'it','Nessun collaboratori attivi',0),(205513,5709,'tl','',0),(205514,5709,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3591;&#3634;&#3609;',0),(205515,5709,'hi','à¤•à¥‹à¤ˆ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚',0),(205516,5709,'ms','Tiada kakitangan aktif',0),(205517,5709,'ar','Ø£ÙŠ Ù…ÙˆØ¸Ù Ù†Ø´Ø·',0),(205518,5709,'fr','Aucun des employÃ©s actifs',0),(205519,5709,'jp','ç?¾å½¹å¾“æ¥­å“¡ã?Œã?„ã?¾ã?›ã‚“',0),(205520,5709,'pt','Sem empregados ativos',0),(205521,5709,'ru','ÐÐµÑ‚ ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ñ… Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(205522,5709,'es','No Hay Empleados Activos',0),(205523,5709,'de','Keine aktive Mitarbeiter',0),(205524,5709,'en','No Active Employees',0),(205525,5710,'is','',0),(205526,5710,'dr',' Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯ Ùˆ ÙƒØ³ÙˆØ±Ø§Øª ',0),(205527,5710,'pr',' Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯ Ùˆ ÙƒØ³ÙˆØ±Ø§Øª ',0),(205528,5710,'tr','Bordro personel maaÅŸ ve kesintiler gÃ¼ncelleÅŸtirme',0),(205529,5710,'pl','Wynagrodzenia pracownika wynagrodzenia i odliczeÅ„ aktualizacji',0),(205530,5710,'bg','Ð¢Ð Ð— ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¸ ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(205531,5710,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©Û’ Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û Ø§ÙˆØ± Ú©Ù¹ÙˆØªÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(205532,5710,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(205533,5710,'vi','Cáº­p Nháº­t LÆ°Æ¡ng & Giáº£m Trá»« LÆ°Æ¡ng NhÃ¢n ViÃªn',0),(205534,5710,'af','Loonrol Werknemer Loon en Aftrekking Opdateer',0),(205535,5710,'ro','Plata de angajat salarizare ÅŸi deduceri Update',0),(205536,5710,'et','Palk tÃ¶Ã¶taja palga ja mahaarvamiste Update',0),(205537,5710,'si','PlaÄa zaposlenega izplaÄane plaÄe in odbitki posodobitev',0),(205538,5710,'ba','Penggajian karyawan gaji dan pengurangan Update',0),(205539,5710,'nl','Payroll werknemer betalen en inhoudingen Update',0),(205540,5710,'fi','Palkanlaskenta tyÃ¶ntekijÃ¶iden palkkojen ja vÃ¤hennykset pÃ¤ivitys',0),(205541,5710,'no','LÃ¸nn ansatte lÃ¸nn og fradrag oppdatering',0),(205542,5710,'da','LÃ¸nsum medarbejder lÃ¸n og fradrag opdatering',0),(205543,5710,'ko','ê¸‰ì—¬ ì§ì› ê¸‰ì—¬ì™€ ê³µì œ ì—…ë°ì´íŠ¸',0),(205544,5710,'he','×©×›×¨ ×”×¢×•×‘×“ ×ª×©×œ×•× ×•×¢×“×›×•×Ÿ × ×™×›×•×™×™×',0),(205545,5710,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Ï…Ï€Î±Î»Î»Î®Î»Ï‰Î½ Î±Î¼Î¿Î¹Î²ÏŽÎ½ ÎºÎ±Î¹ ÎºÏÎ±Ï„Î®ÏƒÎµÏ‰Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(205546,5710,'zh','å‘˜å·¥å·¥èµ„åŠè–ªé‡‘æ€»é¢æ‰£é™¤æ›´æ–°\r\n',0),(205547,5710,'sv','LÃ¶n arbetstagaren lÃ¶n och avdrag uppdatering',0),(205548,5710,'it','Paghe dei dipendenti paga e aggiornamento detrazioni',0),(205549,5710,'tl','',0),(205550,5710,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3632;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3591;&#3636;&#3609; &#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#',0),(205551,5710,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨ à¤”à¤° à¤•à¤Ÿà¥Œà¤¤à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(205552,5710,'ms','Gaji pekerja gaji dan potongan Kemaskini',0),(205553,5710,'ar','Ø±Ø§ØªØ¨ Ø§Ù„Ù…ÙˆØ¸Ù Ø§Ù„Ø±ÙˆØ§ØªØ¨ ÙˆØ§Ù„Ø§Ø³ØªÙ‚Ø·Ø§Ø¹Ø§Øª Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(205554,5710,'fr','Mise Ã  jour de retenues et de paie de l\'employÃ© paie',0),(205555,5710,'jp','å¾“æ¥­å“¡çµ¦ä¸Žã?¨æŽ§é™¤ã?®æ›´æ–°',0),(205556,5710,'pt','SalÃ¡rio de empregado da folha de pagamento e atualizaÃ§Ã£o de deduÃ§Ãµes',0),(205557,5710,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½ÑƒÑŽ Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚ÑŒ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð£Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ',0),(205558,5710,'es','Actualizar Pagos y Deducciones de la NÃ³mina del Empleado',0),(205559,5710,'de','Abrechnung Mitarbeiter Lohn und AbzÃ¼ge-Update',0),(205560,5710,'en','Payroll Employee Pay and Deductions Update',0),(205561,5711,'is','',0),(205562,5711,'dr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(205563,5711,'pr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(205564,5711,'tr','FiÅŸler gizle',0),(205565,5711,'pl','Ukryj bony',0),(205566,5711,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸',0),(205567,5711,'ur','ÙˆØ§Ø¤Ú†Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(205568,5711,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ',0),(205569,5711,'vi','Giáº¥u Phiáº¿u',0),(205570,5711,'af','Verberg Bewysstukke',0),(205571,5711,'ro','Ascunde vouchere',0),(205572,5711,'et','Peida maksedokumendid',0),(205573,5711,'si','Skrij bonov',0),(205574,5711,'ba','Menyembunyikan voucher',0),(205575,5711,'nl','Vouchers verbergen',0),(205576,5711,'fi','Piilota tositteet',0),(205577,5711,'no','Skjule bilag',0),(205578,5711,'da','Skjule vÃ¦rdikuponer',0),(205579,5711,'ko','ìƒí’ˆê¶Œì„ ìˆ¨ê¸°ê¸°',0),(205580,5711,'he','×”×¡×ª×¨ ×©×•×‘×¨×™×',0),(205581,5711,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î±',0),(205582,5711,'zh','éšè—å‡­è¯\r\n',0),(205583,5711,'sv','DÃ¶lja kuponger',0),(205584,5711,'it','Nascondere il voucher',0),(205585,5711,'tl','',0),(205586,5711,'th','&#3595;&#3656;&#3629;&#3609;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(205587,5711,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤›à¥à¤ªà¤¾à¤à¤',0),(205588,5711,'ms','Sembunyi baucar',0),(205589,5711,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª',0),(205590,5711,'fr','Cacher les piÃ¨ces justificatives',0),(205591,5711,'jp','ä¼?ç¥¨ã‚’éš ã?™',0),(205592,5711,'pt','Esconder os Vouchers',0),(205593,5711,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹',0),(205594,5711,'es','Esconder Vouchers',0),(205595,5711,'de','Ausblenden Gutscheine',0),(205596,5711,'en','Hide Vouchers',0),(205597,5712,'is','',0),(205598,5712,'dr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(205599,5712,'pr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ',0),(205600,5712,'tr','FiÅŸleri gÃ¶stermek',0),(205601,5712,'pl','PokaÅ¼ zaÅ‚Ä…czniki',0),(205602,5712,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸',0),(205603,5712,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(205604,5712,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ',0),(205605,5712,'vi','Hiá»ƒn thá»‹ phiáº¿u',0),(205606,5712,'af','Wys Bewysstukke',0),(205607,5712,'ro','AratÄƒ vouchere',0),(205608,5712,'et','Kuva kanded',0),(205609,5712,'si','PokaÅ¾i bonov',0),(205610,5712,'ba','Voucher Tampilkan',0),(205611,5712,'nl','Toon Vouchers',0),(205612,5712,'fi','Tositteet',0),(205613,5712,'no','Vis bilag',0),(205614,5712,'da','Vis vÃ¦rdikuponer',0),(205615,5712,'ko','ì‡¼ ìƒí’ˆê¶Œ',0),(205616,5712,'he','×”×¦×’ ×©×•×‘×¨×™×',0),(205617,5712,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î±',0),(205618,5712,'zh','æ˜¾ç¤ºåˆ¸\r\n',0),(205619,5712,'sv','Visa verifikationer',0),(205620,5712,'it','Visualizza voucher',0),(205621,5712,'tl','',0),(205622,5712,'th','&#3649;&#3626;&#3604;&#3591;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(205623,5712,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(205624,5712,'ms','Menunjukkan baucer',0),(205625,5712,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù‚Ø³Ø§Ø¦Ù…',0),(205626,5712,'fr','Montrer les bons',0),(205627,5712,'jp','ä¼?ç¥¨ã‚’è¡¨ç¤º',0),(205628,5712,'pt','Mostrar comprovantes',0),(205629,5712,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹',0),(205630,5712,'es','Mostrar Vouchers',0),(205631,5712,'de','Karte Gutscheine',0),(205632,5712,'en','Show Vouchers',0),(205633,5713,'is','',0),(205634,5713,'dr','Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ ',0),(205635,5713,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ ',0),(205636,5713,'tr','Deftere nakledilmemiÅŸ kuponlarÄ±',0),(205637,5713,'pl','NiezaksiÄ™gowane bony',0),(205638,5713,'bg','ÐÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸',0),(205639,5713,'ur','Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ ÙˆØ§Ø¤Ú†Ø±',0),(205640,5713,'sr','ÐÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ',0),(205641,5713,'vi','Phiáº¿u KhÃ´ng káº¿t chuyá»ƒn',0),(205642,5713,'af','Onposde Bewysstukke',0),(205643,5713,'ro','Bonuri de neÃ®nregistrate',0),(205644,5713,'et','Sisestamata kanded',0),(205645,5713,'si','Neobjavljene bonov',0),(205646,5713,'ba','Unposted voucher',0),(205647,5713,'nl','Niet-doorgevoerde Vouchers',0),(205648,5713,'fi','Kirjaamattomat tositteet',0),(205649,5713,'no','Ikke-bokfÃ¸rt bilag',0),(205650,5713,'da','Ikke-bogfÃ¸rte bilag',0),(205651,5713,'ko','ê²Œì‹œ ë˜ì§€ ì•Šì€ ìƒí’ˆê¶Œ',0),(205652,5713,'he','×©×•×‘×¨×™× ×©×œ× × ×¨×©×ž×•',0),(205653,5713,'el','ÎœÎ· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î±',0),(205654,5713,'zh','æœªå‘å¸ƒçš„ä¼˜æƒ åˆ¸\r\n',0),(205655,5713,'sv','Ej bokfÃ¶rda verifikationer',0),(205656,5713,'it','Voucher non registrata',0),(205657,5713,'tl','',0),(205658,5713,'th','&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(205659,5713,'hi','Unposted à¤µà¤¾à¤‰à¤šà¤°',0),(205660,5713,'ms','Unposted baucar',0),(205661,5713,'ar','Ù‚Ø³Ø§Ø¦Ù… ØºÙŠØ± Ø§Ù„Ù…Ù†Ø´ÙˆØ±Ø©',0),(205662,5713,'fr','ChÃ¨ques non comptabilisÃ©s',0),(205663,5713,'jp','æœªè¨ˆä¸Šä¼?ç¥¨',0),(205664,5713,'pt','Vouchers nÃ£o lanÃ§ados',0),(205665,5713,'ru','ÐÐµÐ¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹',0),(205666,5713,'es','Vouchers No Asentados',0),(205667,5713,'de','Ungebuchte Gutscheine',0),(205668,5713,'en','Unposted Vouchers',0),(205669,5714,'is','',0),(205670,5714,'dr','Ø¨Ø±Ø§ÙŠ Ø­Ø°Ù ÙƒØ±Ø¯Ù† Ø¨Ø§ÙŠØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯',0),(205671,5714,'pr','Ø¨Ø±Ø§ÙŠ Ø­Ø°Ù ÙƒØ±Ø¯Ù† Ø¨Ø§ÙŠØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯',0),(205672,5714,'tr','SÄ±fÄ±r silmek iÃ§in olmalÄ±',0),(205673,5714,'pl','Musi byÄ‡ Zero do usuniÄ™cia',0),(205674,5714,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð½ÑƒÐ»Ð° Ð·Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(205675,5714,'ur','Ø­Ø°Ù Ú©Û’ Ù„ÛŒÛ’ Ø¨Ù†Ø¯ÛŒ ØµÙØ± ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒÛ’',0),(205676,5714,'sr','ÐœÐ¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð½ÑƒÐ»Ð° Ð·Ð° Ð±Ñ€Ð¸ÑÐ°ÑšÐµ',0),(205677,5714,'vi','Pháº£i lÃ  0 Ä‘á»ƒ xÃ³a',0),(205678,5714,'af','Moet Nul wees om te Skrap',0),(205679,5714,'ro','Trebuie sÄƒ fie Zero a ÅŸterge',0),(205680,5714,'et','Null, kui soovid kustutada',0),(205681,5714,'si','Mora biti niÄ izbrisati',0),(205682,5714,'ba','Harus nol untuk menghapus',0),(205683,5714,'nl','Moet nul te verwijderen',0),(205684,5714,'fi','On oltava nolla poistaa',0),(205685,5714,'no','MÃ¥ vÃ¦re null Slett',0),(205686,5714,'da','Skal vÃ¦re nul for at slette',0),(205687,5714,'ko','ì‚­ì œë¥¼ 0 ì´ì–´ì•¼ í•©ë‹ˆë‹¤.',0),(205688,5714,'he','×—×™×™×‘ ×œ×”×™×•×ª ××¤×¡ ×¢×œ ×ž×—×§',0),(205689,5714,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼Î·Î´Î­Î½ Î³Î¹Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(205690,5714,'zh','å¿…é¡»ä¸ºé›¶ä»¥åˆ é™¤\r\n',0),(205691,5714,'sv','MÃ¥ste vara noll fÃ¶r att ta bort',0),(205692,5714,'it','Deve essere Zero per cancellare',0),(205693,5714,'tl','',0),(205694,5714,'th','&#3605;&#3657;&#3629;&#3591;&#3648;&#3611;&#3655;&#3609;&#3624;&#3641;&#3609;&#3618;&#3660;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3621;&#3610;',0),(205695,5714,'hi','à¤¹à¤Ÿà¤¾à¤à¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥‚à¤¨à¥à¤¯ à¤¹à¥‹à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(205696,5714,'ms','Mesti sifar untuk Hapus',0),(205697,5714,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† ØµÙØ±Ø§Ù‹ Ù„Ù„Ø­Ø°Ù',0),(205698,5714,'fr','Doit Ãªtre Ã©gal Ã  zÃ©ro Ã  supprimer',0),(205699,5714,'jp','æ¶ˆåŽ»ã?™ã‚‹ã?«ã?¯ï¼?ã?§ã?ªã?‘ã‚Œã?°ã?„ã?‘ã?¾ã?›ã‚“',0),(205700,5714,'pt','Deve ser Zero para excluir',0),(205701,5714,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð²Ð½Ð¾ Ð½ÑƒÐ»ÑŽ Ð´Ð»Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ',0),(205702,5714,'es','Debe ser Cero para Eliminar',0),(205703,5714,'de','NULL zu lÃ¶schen muss sein',0),(205704,5714,'en','Must be Zero to Delete',0),(205705,5715,'is','',0),(205706,5715,'dr','EIC  ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ Ù…Ø§Ù„ÙŠØ§Øª',0),(205707,5715,'pr','EIC  ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ Ù…Ø§Ù„ÙŠØ§Øª',0),(205708,5715,'tr','EIC vergi',0),(205709,5715,'pl','EIC podatku',0),(205710,5715,'bg','Ð•Ð˜Ð¦ Ð´Ð°Ð½ÑŠÐº',0),(205711,5715,'ur','Ù¹ÛŒÚ©Ø³',0),(205712,5715,'sr','Ð•Ð˜Ð¦ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(205713,5715,'vi','Thuáº¿ EIC',0),(205714,5715,'af','EIC belasting',0),(205715,5715,'ro','EIC fiscale',0),(205716,5715,'et','EIC maksu',0),(205717,5715,'si','EIC davka',0),(205718,5715,'ba','Pajak EIC',0),(205719,5715,'nl','EIC belasting',0),(205720,5715,'fi','EIC vero',0),(205721,5715,'no','EIC skatt',0),(205722,5715,'da','EIC skat',0),(205723,5715,'ko','EIC ì„¸ê¸ˆ',0),(205724,5715,'he','EIC ×ž×¡',0),(205725,5715,'el','Î•ÎšÎ  Ï†ÏŒÏÎ¿Ï…',0),(205726,5715,'zh','é›‡ä¸»è¯†åˆ«ç¨Ž\r\n',0),(205727,5715,'sv','EIC skatt',0),(205728,5715,'it','EIC fiscale',0),(205729,5715,'tl','',0),(205730,5715,'th','&#3616;&#3634;&#3625;&#3637; EIC ',0),(205731,5715,'hi','EIC à¤Ÿà¥ˆà¤•à¥à¤¸',0),(205732,5715,'ms','EIC cukai',0),(205733,5715,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø¥ÙŠÙƒ',0),(205734,5715,'fr','ImpÃ´t CPN',0),(205735,5715,'jp','EICç¨Ž',0),(205736,5715,'pt','EIC imposto',0),(205737,5715,'ru','Ð•Ð˜Ð¦ Ð½Ð°Ð»Ð¾Ð³',0),(205738,5715,'es','EIC Impuesto',0),(205739,5715,'de','EIC Steuer',0),(205740,5715,'en','EIC Tax',0),(205741,5716,'is','',0),(205742,5716,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø¹Ø§Ø´ Ùˆ ØªØ®ÙÙŠÙØ§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ ( ÙŠØ§ Ø«Ø¨Øª Ø¬Ø¯ÙŠØ¯ )',0),(205743,5716,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù‚ÙˆÙ‚ Ùˆ ØªØ®ÙÙŠÙØ§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ ( ÙŠØ§ Ø«Ø¨Øª Ø¬Ø¯ÙŠØ¯ )',0),(205744,5716,'tr','Ekle/GÃ¼ncelle Ã§alÄ±ÅŸan Ã¶deme ve kesinti bilgileri (veya yeni girin)',0),(205745,5716,'pl','Dodaj/zaktualizuj pracownika zapÅ‚aciÄ‡ i odliczenia informacji (lub wprowadziÄ‡ nowe)',0),(205746,5716,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð¸ Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ (Ð¸Ð»Ð¸ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð¾)',0),(205747,5716,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø§Ø¯Ø§ Ú©Ø±ÛŒÚº Ø§ÙˆØ± ÙˆØ¶Ø¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª (ÛŒØ§ Ù†ÛŒØ§ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº)',0),(205748,5716,'sr','/ ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð¸ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° (Ð¸Ð»Ð¸ ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¾)',0),(205749,5716,'vi','ThÃªm/Cáº­p Nháº­t LÆ°Æ¡ng NhÃ¢n ViÃªn & CÃ¡c Khoáº£n Giáº£m Trá»« (hay cáº­p nháº­t má»›i)',0),(205750,5716,'af','Byvoeg/Opdateer Werknemer Loon en Aftrekkings Informasie (of voer nuwe in)',0),(205751,5716,'ro','Adauga/Actualizeaza Plati si Deduceri Angajat',0),(205752,5716,'et','Lisa/Uuenda tÃ¶Ã¶taja palga ja palgast kinnipidamise informatsioon (vÃµi sisesta uus)',0),(205753,5716,'si','Dodaj/posodobi zaposleni plaÄati in odbitek informacije (ali pa vnesite novo)',0),(205754,5716,'ba','Tambah/Ganti Gaji Karyawan dan Bonus',0),(205755,5716,'nl','Toevoegen/bijwerken werknemer betalen en aftrek informatie (of nieuwe invoeren)',0),(205756,5716,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ tyÃ¶ntekijÃ¤ maksaa ja vÃ¤hennyksen tiedot (tai kirjoita uusi)',0),(205757,5716,'no','Legg til/Oppdater ansatte betale og fradrag informasjon (eller nye)',0),(205758,5716,'da','TilfÃ¸j/opdater medarbejderen betale og fradrag oplysninger (eller indtast nye)',0),(205759,5716,'ko','ì¶”ê°€/ì—…ë°ì´íŠ¸ ì§ì› ì§€ë¶ˆ ë° ê³µì œ ì •ë³´ (ë˜ëŠ” ìƒˆë¡œìš´ ìž…ë ¥)',0),(205760,5716,'he','×”×•×¡×£/×¢×“×›×Ÿ ×”×¢×•×‘×“ ×œ×©×œ× ×•×ž×™×“×¢ × ×™×›×•×™ (××• ×”×–×Ÿ ×”×—×“×©)',0),(205761,5716,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Ï€Î»Î·ÏÏŽÏƒÎµÎ¹ ÎºÎ±Î¹ Ï€Î±ÏÎ±ÎºÏÎ¬Ï„Î·ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ (Î® ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î½Î­Î±)',0),(205762,5716,'zh','å¢žåŠ /æ›´æ–°å‘˜å·¥è–ªé…¬ä¸Žæ‰£é™¤ä¿¡æ¯ï¼ˆæˆ–è¾“å…¥æ–°ï¼‰\r\n',0),(205763,5716,'sv','LÃ¤gg till/uppdatera anstÃ¤lld betala och avdrag Information (eller ange nytt)',0),(205764,5716,'it','Aggiungi/Aggiorna dipendente paga e informazioni di deduzione (o inserire)',0),(205765,5716,'tl','',0),(205766,5716,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3649;&#3621;&#3632;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&',0),(205767,5716,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨ à¤”à¤° à¤•à¤Ÿà¥Œà¤¤à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ (à¤¯à¤¾ à¤¨à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚)',0),(205768,5716,'ms','Tambah/Kemaskini pekerja membayar dan maklumat potongan (atau masukkan baru)',0),(205769,5716,'ar','Ø¯ÙØ¹ Ø§Ù„Ù…ÙˆØ¸Ù Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« ÙˆÙ…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø®ØµÙ… (Ø£Ùˆ Ø£Ø¯Ø®Ù„ Ø¬Ø¯ÙŠØ¯)',0),(205770,5716,'fr','Paie de lâ€™employÃ© ajouter/mettre Ã  jour et informations de dÃ©duction (ou entrer de nouveau)',0),(205771,5716,'jp','å¾“æ¥­å“¡çµ¦ä¸Žã?¨æŽ§é™¤æƒ…å ±ã?®è¿½åŠ /æ›´æ–°ï¼ˆã‚‚ã?—ã??ã?¯æ–°è¦?å…¥åŠ›ï¼‰',0),(205772,5716,'pt','Adicionar/atualizar o funcionÃ¡rio pagar e deduÃ§Ã£o de informaÃ§Ãµes (ou insira de novo)',0),(205773,5716,'ru','Ð”Ð¾Ð´Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐžÐ¿Ð»Ð°Ñ‚Ñƒ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð¸ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð£Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ð¹ (Ð¸Ð»Ð¸ Ð²Ð²ÐµÑÑ‚Ð¸ Ð½Ð¾Ð²Ð¾Ðµ)',0),(205774,5716,'es','Agregar/Actualizar InformaciÃ³n de Pagos y Deducciones de Empleado (o introducir nueva)',0),(205775,5716,'de','HinzufÃ¼gen/aktualisieren Arbeitnehmer zahlen und Abzug Informationen (oder neu eingeben)',0),(205776,5716,'en','Add/Update Employee Pay and Deduction Information (or enter new)',0),(205777,5717,'is','',0),(205778,5717,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù…Ø¹Ø§Ø´ ÙƒØ§Ø±Ù…Ù†Ø¯ â€“ Ø§ØµÙ„Ø§Ø­  Ú†Ùƒ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(205779,5717,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯ â€“ ÙˆÙŠØ±Ø§ÙŠØ´ Ú†Ùƒ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(205780,5717,'tr','Ã‡alÄ±ÅŸan onay DÃ¼zenle',0),(205781,5717,'pl','Edycja wyboru pracownika',0),(205782,5717,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¾Ñ‚Ð¼ÐµÑ‚ÐºÐ° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(205783,5717,'ur','Ù…Ù„Ø§Ø²Ù… Ú†ÛŒÚ© ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(205784,5717,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(205785,5717,'vi','Kiá»ƒm Tra NhÃ¢n ViÃªn ',0),(205786,5717,'af','Werknemer Tjek Redigeer',0),(205787,5717,'ro','Editeaza Cec angajat',0),(205788,5717,'et','TÃ¶Ã¶taja vÃ¤ljaregistreerimine Edit',0),(205789,5717,'si','Urejanje preverjanje zaposlenih',0),(205790,5717,'ba','Cek Penggantian Karyawan',0),(205791,5717,'nl','Werknemer controle bewerken',0),(205792,5717,'fi','TyÃ¶ntekijÃ¤n uloskirjautuminen muokkaus',0),(205793,5717,'no','Arbeidstaker av Edit',0),(205794,5717,'da','Medarbejder Check Rediger',0),(205795,5717,'ko','ì§ì› í‘œ íŽ¸ì§‘',0),(205796,5717,'he','×”×¢×•×‘×“ ×”×¡×™×ž×•×Ÿ ×¢×¨×•×š',0),(205797,5717,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(205798,5717,'zh','å‘˜å·¥æ£€æŸ¥ç¼–è¾‘\r\n',0),(205799,5717,'sv','AnstÃ¤lld kontrollera redigera',0),(205800,5717,'it','Impiegato controllo Edit',0),(205801,5717,'tl','',0),(205802,5717,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(205803,5717,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤šà¥‡à¤• à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(205804,5717,'ms','Edit Daftar pekerja',0),(205805,5717,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù…ÙˆØ¸Ù',0),(205806,5717,'fr','EmployÃ© contrÃ´le Edit',0),(205807,5717,'jp','å¾“æ¥­å“¡ã€€æ”¯æ‰•ã?„/æŽ§é™¤ã€€è¿½åŠ /æ›´æ–°',0),(205808,5717,'pt','Empregado Check Edit',0),(205809,5717,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(205810,5717,'es','Cheque de Empleado Editar',0),(205811,5717,'de','Mitarbeiter Check bearbeiten',0),(205812,5717,'en','Employee Check Edit',0),(205813,5718,'is','',0),(205814,5718,'dr','Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(205815,5718,'pr','Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(205816,5718,'tr','Gemi iÃ§in tÄ±klayÄ±n',0),(205817,5718,'pl','Kliknij, aby statek',0),(205818,5718,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(205819,5718,'ur','Ú©Ø´ØªÛŒ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(205820,5718,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð±Ñ€Ð¾Ð´',0),(205821,5718,'vi','Nháº¥n Ä‘á»ƒ chuyá»ƒn',0),(205822,5718,'af','Kliek om te Versend',0),(205823,5718,'ro','FaceÅ£i clic pentru a navei',0),(205824,5718,'et','KlÃµpsa tarnimiseks',0),(205825,5718,'si','Kliknite za ladje',0),(205826,5718,'ba','Klik untuk kapal',0),(205827,5718,'nl','Klik om schip',0),(205828,5718,'fi','Valitse laiva',0),(205829,5718,'no','Klikk pÃ¥ skip',0),(205830,5718,'da','Klik for at skibet',0),(205831,5718,'ko','ìš°ì£¼ì„ ì„ í´ë¦­',0),(205832,5718,'he','×œ×—×¥ ×¢×œ ×”×¡×¤×™× ×”',0),(205833,5718,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Ï€Î»Î¿Î¯Î¿',0),(205834,5718,'zh','ç‚¹å‡»è¿é€\r\n',0),(205835,5718,'sv','Klicka pÃ¥ fartyg',0),(205836,5718,'it','Clicca per consegnare',0),(205837,5718,'tl','',0),(205838,5718,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(205839,5718,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(205840,5718,'ms','Klik untuk kapal',0),(205841,5718,'ar','Ø£Ù†Ù‚Ø± Ù„Ù„Ø´Ø­Ù†',0),(205842,5718,'fr','Cliquer pour navire',0),(205843,5718,'jp','ç™ºé€?ã?™ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯',0),(205844,5718,'pt','Clique para navio',0),(205845,5718,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(205846,5718,'es','Click para Enviar',0),(205847,5718,'de','Klicken Sie auf Schiff',0),(205848,5718,'en','Click to Ship',0),(205849,5719,'is','',0),(205850,5719,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù  ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(205851,5719,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù  ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(205852,5719,'tr','PDF gÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klatÄ±n',0),(205853,5719,'pl','Kliknij, aby przeglÄ…daÄ‡ PDF',0),(205854,5719,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ PDF',0),(205855,5719,'ur','Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(205856,5719,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ð»Ð¸ ÐŸÐ”Ð¤',0),(205857,5719,'vi','Nháº¥n Ä‘á»ƒ xem PDF',0),(205858,5719,'af','Kliek om PDF te Besigtig',0),(205859,5719,'ro','Click pentru a vizualiza PDF',0),(205860,5719,'et','KlÃµpsake, et vaadata PDF',0),(205861,5719,'si','Kliknite za ogled PDF',0),(205862,5719,'ba','Klik untuk melihat PDF',0),(205863,5719,'nl','Klik om PDF te bekijken',0),(205864,5719,'fi','Klikkaa nÃ¤hdÃ¤ksesi PDF',0),(205865,5719,'no','Klikk for Ã¥ vise PDF',0),(205866,5719,'da','Klik her for at se PDF',0),(205867,5719,'ko','í´ë¦­ í•˜ ì—¬ PDF ë³´ê¸°',0),(205868,5719,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’ ×ž×¡×ž×š PDF',0),(205869,5719,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î± PDF',0),(205870,5719,'zh','ç‚¹å‡»æŸ¥çœ‹PDFæ ¼å¼\r\n',0),(205871,5719,'sv','Klicka fÃ¶r att visa PDF',0),(205872,5719,'it','Mostra pdf',0),(205873,5719,'tl','',0),(205874,5719,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3648;&#3611;&#3655;&#3609; PDF',0),(205875,5719,'hi','à¤ªà¥€à¤¡à¥€à¤à¤« à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(205876,5719,'ms','Klik untuk melihat PDF',0),(205877,5719,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ø¹Ø±Ø¶ PDF',0),(205878,5719,'fr','Cliquez pour voir le PDF',0),(205879,5719,'jp','PDFã‚’è¦‹ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯',0),(205880,5719,'pt','Clique para ver o PDF',0),(205881,5719,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð´Ð»Ñ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð’ PDF Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ',0),(205882,5719,'es','Click para Ver PDF',0),(205883,5719,'de','Klicken Sie PDF an',0),(205884,5719,'en','Click to View PDF',0),(205885,5720,'is','',0),(205886,5720,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ¹Ù„ÙŠ ',0),(205887,5720,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ¹Ù„ÙŠ ',0),(205888,5720,'tr','MÃ¼ÅŸteri No',0),(205889,5720,'pl','Nr odbiorcy faktury',0),(205890,5720,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ No.',0),(205891,5720,'ur','Ú©Ø³Ù¹Ù…Ø± Ù†Ù…Ø¨Ø±',0),(205892,5720,'sr','Ð‘Ñ€ . ÐºÑƒÐ¿Ñ†Ð°.',0),(205893,5720,'vi','KhÃ¡ch hÃ ng sá»‘ ',0),(205894,5720,'af','Klant No.',0),(205895,5720,'ro','Client nr.',0),(205896,5720,'et','Kliendi nr.',0),(205897,5720,'si','Å t.',0),(205898,5720,'ba','Pelanggan No.',0),(205899,5720,'nl','Klantnr.',0),(205900,5720,'fi','Nro',0),(205901,5720,'no','Kundenr.',0),(205902,5720,'da','Debitornr.',0),(205903,5720,'ko','ê³ ê° ë²ˆí˜¸',0),(205904,5720,'he','×ž×¡×¤×¨ ×œ×§×•×—',0),(205905,5720,'el','ÎšÏ‰Î´. Ï€ÎµÎ»Î¬Ï„Î·',0),(205906,5720,'zh','å®¢æˆ·ç¼–å·\r\n',0),(205907,5720,'sv','Kundnr.',0),(205908,5720,'it','Nr. cliente',0),(205909,5720,'tl','',0),(205910,5720,'th','&#3621;&#3635;&#3604;&#3633;&#3610;&#3607;&#3637;&#3656;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(205911,5720,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¤‚.',0),(205912,5720,'ms','No. pelanggan',0),(205913,5720,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(205914,5720,'fr','NÂ° client',0),(205915,5720,'jp','é¡§å®¢ç•ªå?·',0),(205916,5720,'pt','N Âº cliente',0),(205917,5720,'ru','No. ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(205918,5720,'es','NÃºmero de Cliente',0),(205919,5720,'de','Kunden-Nr.',0),(205920,5720,'en','Customer No.',0),(205921,5721,'is','',0),(205922,5721,'dr','ØªØ¨ØµØ±Ù‡  ÙƒØ§Ù„Ø§',0),(205923,5721,'pr','ØªØ¨ØµØ±Ù‡  ÙƒØ§Ù„Ø§',0),(205924,5721,'tr','Madde No',0),(205925,5721,'pl','Nr zapasu.',0),(205926,5721,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» No.',0),(205927,5721,'ur','Ø¢Ø¦Ù¹Ù… Ù†Ù…Ø¨Ø±',0),(205928,5721,'sr','Ð‘Ñ€ . Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(205929,5721,'vi','HÃ ng sá»‘',0),(205930,5721,'af','Item Nr.',0),(205931,5721,'ro','Articol nr.',0),(205932,5721,'et','Toote nr.',0),(205933,5721,'si','Artikel Å¡t.',0),(205934,5721,'ba','Item nomor',0),(205935,5721,'nl','Artikelnr.',0),(205936,5721,'fi','Nimikkeen nro',0),(205937,5721,'no','Varenr.',0),(205938,5721,'da','Varenr.',0),(205939,5721,'ko','í•­ëª© ë²ˆí˜¸',0),(205940,5721,'he','×ž×¡×¤×¨ ×¤×¨×™×˜',0),(205941,5721,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±ÏÎ¹Î¸.',0),(205942,5721,'zh','äº§å“ç¼–å·\r\n',0),(205943,5721,'sv','Artikelnr',0),(205944,5721,'it','Articolo no.',0),(205945,5721,'tl','',0),(205946,5721,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(205947,5721,'hi','à¤®à¤¦ à¤¸à¤‚.',0),(205948,5721,'ms','Item No.',0),(205949,5721,'ar','Ø±Ù‚Ù… Ø§Ù„ØµÙ†Ù',0),(205950,5721,'fr','NumÃ©ro d\'article',0),(205951,5721,'jp','å“?ç›®ç•ªå?·',0),(205952,5721,'pt','Artigo no.',0),(205953,5721,'ru','Ð¢Ð¾Ð²Ð°Ñ€ No.',0),(205954,5721,'es','Item No.',0),(205955,5721,'de','Artikel-Nr.',0),(205956,5721,'en','Item No.',0),(205957,5722,'is','',0),(205958,5722,'dr','Ú†Ø§Ù¾ Ø¨Ù‡ ØµÙˆØ±Øª\r\n HTML',0),(205959,5722,'pr','Ú†Ø§Ù¾ Ø¨Ù‡ ØµÙˆØ±Øª\r\n HTML',0),(205960,5722,'tr','HTML\'de yazdÄ±rma',0),(205961,5722,'pl','Drukowania w formacie HTML',0),(205962,5722,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð² HTML',0),(205963,5722,'ur','HTML Ù…ÛŒÚº Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(205964,5722,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñƒ Ð¥Ð¢ÐœÐ› Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(205965,5722,'vi','In trÃªn HTML',0),(205966,5722,'af','Druk in HTML',0),(205967,5722,'ro','Imprimare Ã®n HTML',0),(205968,5722,'et','Prindi HTML',0),(205969,5722,'si','Tiskanje HTML',0),(205970,5722,'ba','Mencetak dalam HTML',0),(205971,5722,'nl','Afdrukken in HTML',0),(205972,5722,'fi','Tulostaminen HTML-muodossa',0),(205973,5722,'no','Skrive ut i HTML',0),(205974,5722,'da','Udskrive i HTML',0),(205975,5722,'ko','Html ì¸ì‡„',0),(205976,5722,'he','HTML-×”×“×¤×¡ ×‘',0),(205977,5722,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÎµ Î¼Î¿ÏÏ†Î® HTML',0),(205978,5722,'zh','åœ¨HTMLä¸­æ‰“å°\r\n',0),(205979,5722,'sv','Skriva ut i HTML',0),(205980,5722,'it','Stampare in HTML',0),(205981,5722,'tl','',0),(205982,5722,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3609; HTML',0),(205983,5722,'hi','HTML à¤®à¥‡à¤‚ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(205984,5722,'ms','Mencetak dalam HTML',0),(205985,5722,'ar','Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© ÙÙŠ Ø¥ØªØ´ ØªÙŠ Ø£Ù… Ø§Ù„',0),(205986,5722,'fr','Imprimer au format HTML',0),(205987,5722,'jp','HTMLã?§å?°åˆ·',0),(205988,5722,'pt','ImpressÃ£o em HTML',0),(205989,5722,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð² HTML',0),(205990,5722,'es','Imprimir en HTML',0),(205991,5722,'de','Im HTML-Format drucken',0),(205992,5722,'en','Print in HTML',0),(205993,5723,'is','',0),(205994,5723,'dr','( Ø§Ø±Ø³Ø§Ù„ ) Ø¨Ù‡ / ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(205995,5723,'pr','Ø­Ù…Ù„( Ø§Ø±Ø³Ø§Ù„ ) Ø¨Ù‡ / ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(205996,5723,'tr','Gemi / satÄ±lan',0),(205997,5723,'pl','Statek / sprzedane',0),(205998,5723,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð´Ð¾ / Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°',0),(205999,5723,'ur','Ú©Û’ Ù„Ø¦Û’ Ø¬ÛØ§Ø² / ÙØ±ÙˆØ®Øª',0),(206000,5723,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ / Ð¿Ñ€Ð¾Ð´Ð°Ð¾',0),(206001,5723,'vi','Chuyá»ƒn Ä‘áº¿n/bÃ¡n cho',0),(206002,5723,'af','Versend Na/Verkoop Aan',0),(206003,5723,'ro','NavÄƒ la / a vÃ¢ndut',0),(206004,5723,'et','Kauba saaja / mÃ¼Ã¼dud',0),(206005,5723,'si','Dostava / prodaja',0),(206006,5723,'ba','Kapal ke / dijual',0),(206007,5723,'nl','Verzenden naar / verkocht aan',0),(206008,5723,'fi','Aluksen / myyty',0),(206009,5723,'no','Leveringsgate / solgt til',0),(206010,5723,'da','Skib til / solgt til',0),(206011,5723,'ko','ë°°ì†¡ / íŒë§¤',0),(206012,5723,'he','×œ×ž×©×œ×•×— / ×ž×›×¨',0),(206013,5723,'el','Î Î»Î¿Î¯Î¿ Î½Î± / Ï€Ï‰Î»Î¿ÏÎ½Ï„Î±Î¹',0),(206014,5723,'zh','å‘é€åˆ°/å‡ºå”®ç»™\r\n',0),(206015,5723,'sv','Fartyget till / sÃ¤ljs till',0),(206016,5723,'it','Nave a / venduto a',0),(206017,5723,'tl','',0),(206018,5723,'th','&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3652;&#3611;/&#3586;&#3634;&#3618;&#3652;&#3611;',0),(206019,5723,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ / à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥‡à¤š à¤¦à¤¿à¤¯à¤¾',0),(206020,5723,'ms','Kapal / dijual kepada',0),(206021,5723,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰/ØªØ¨Ø§Ø¹ Ø¥Ù„Ù‰',0),(206022,5723,'fr','ExpÃ©dier Ã  / vendues Ã ',0),(206023,5723,'jp','é…?é€?å…ˆ/è²©å£²å…ˆ',0),(206024,5723,'pt','Enviar para / vendidos para',0),(206025,5723,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ / Ð¿Ñ€Ð¾Ð´Ð°Ð½',0),(206026,5723,'es','Enviar-A/Vendido-A',0),(206027,5723,'de','Ship to / verkauft',0),(206028,5723,'en','Ship to/Sold to',0),(206029,5724,'is','',0),(206030,5724,'dr','Ø§Ø±ØªÙ‚Ø§ ÙŠØ§ÙØªÙ†',0),(206031,5724,'pr','Ø§Ø±ØªÙ‚Ø§ ÙŠØ§ÙØªÙ†',0),(206032,5724,'tr','YÃ¼kseltme',0),(206033,5724,'pl','Uaktualnienia',0),(206034,5724,'bg','ÐÐ°Ð´ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(206035,5724,'ur','Ø¯Ø±Ø¬Û Ø§ÙØ²ÙˆÚº Ú©Ø±ÛŒÚº',0),(206036,5724,'sr','ÐÐ°Ð´Ð¾Ð³Ñ€Ð°Ð´ÑšÐ°',0),(206037,5724,'vi','NÃ¢ng cáº¥p!',0),(206038,5724,'af','Opgradeer!',0),(206039,5724,'ro','Upgrade-ul',0),(206040,5724,'et','Upgrade',0),(206041,5724,'si','Nadgradnja',0),(206042,5724,'ba','Meng-upgrade',0),(206043,5724,'nl','Upgrade',0),(206044,5724,'fi','PÃ¤ivitys',0),(206045,5724,'no','Oppgradering',0),(206046,5724,'da','Opgradering',0),(206047,5724,'ko','ì—…ê·¸ë ˆì´ë“œ',0),(206048,5724,'he','×©×“×¨×•×’',0),(206049,5724,'el','Î‘Î½Î±Î²Î¬Î¸Î¼Î¹ÏƒÎ·',0),(206050,5724,'zh','å‡çº§ï¼\r\n',0),(206051,5724,'sv','Uppgradera',0),(206052,5724,'it','Aggiornamento',0),(206053,5724,'tl','',0),(206054,5724,'th','&#3629;&#3633;&#3614;&#3648;&#3585;&#3619;&#3604;!',0),(206055,5724,'hi','à¤¨à¤µà¥€à¤¨à¥€à¤•à¤°à¤£',0),(206056,5724,'ms','Naik taraf',0),(206057,5724,'ar','ØªØ±Ù‚ÙŠØ©',0),(206058,5724,'fr','Mise Ã  niveau',0),(206059,5724,'jp','ã‚¢ãƒƒãƒ—ã‚°ãƒ¬ãƒ¼ãƒ‰ï¼?',0),(206060,5724,'pt','AtualizaÃ§Ã£o',0),(206061,5724,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(206062,5724,'es','Actualizar a Nueva VersiÃ³n!',0),(206063,5724,'de','Upgrade',0),(206064,5724,'en','Upgrade',0),(206065,5725,'is','',0),(206066,5725,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´Ú¯Ø± ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(206067,5725,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´Ú¯Ø± ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(206068,5725,'tr','Kredi kartÄ± iÅŸlemci',0),(206069,5725,'pl','Procesor karty kredytowej',0),(206070,5725,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑÐ¾Ñ€ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(206071,5725,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù¾Ø±ÙˆØ³ÛŒØ³Ø±',0),(206072,5725,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€',0),(206073,5725,'vi','Bá»™ xá»­ lÃ½ tháº» tÃ­n dá»¥ng',0),(206074,5725,'af','Kredietkaart Prosesseerder',0),(206075,5725,'ro','Procesor de Card de credit',0),(206076,5725,'et','Krediitkaardi tÃ¶Ã¶tleja',0),(206077,5725,'si','Kreditno kartico procesor',0),(206078,5725,'ba','Prosesor kartu kredit',0),(206079,5725,'nl','Credit Card Processor',0),(206080,5725,'fi','Luottokorttien kÃ¤sittelijÃ¤',0),(206081,5725,'no','Kredittkortbehandleren',0),(206082,5725,'da','Kreditkortprocessor',0),(206083,5725,'ko','ì‹ ìš© ì¹´ë“œ í”„ë¡œì„¸ì„œ',0),(206084,5725,'he','×‘×ž×¢×‘×“ ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(206085,5725,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î® Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(206086,5725,'zh','ä¿¡ç”¨å¡å¤„ç†å™¨\r\n',0),(206087,5725,'sv','KreditkortsfÃ¶retag',0),(206088,5725,'it','Processore di carta di credito',0),(206089,5725,'tl','',0),(206090,5725,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(206091,5725,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤°',0),(206092,5725,'ms','Pemproses kad kredit',0),(206093,5725,'ar','Ù…Ø¹Ø§Ù„Ø¬ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(206094,5725,'fr','Processeur de carte de crÃ©dit',0),(206095,5725,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ã?®å‡¦ç?†è£…ç½®',0),(206096,5725,'pt','Processador de cartÃ£o de crÃ©dito',0),(206097,5725,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(206098,5725,'es','Tarjeta de CrÃ©dito Procesador',0),(206099,5725,'de','Kreditkarteninstitut',0),(206100,5725,'en','Credit Card Processor',0),(206101,5726,'is','',0),(206102,5726,'dr','(Ø¯Ø³ØªÙŠ',0),(206103,5726,'pr','Ù‡Ú† ÙƒØ¯Ø§Ù… (Ø¯Ø³ØªÙŠ',0),(206104,5726,'tr','HiÃ§biri (Manuel)',0),(206105,5726,'pl','Brak (PodrÄ™cznik)',0),(206106,5726,'bg','ÐÑÐ¼Ð° (Ñ€ÑŠÑ‡Ð½Ð¾)',0),(206107,5726,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ú¾ÛŒ (ÛØ¯Ø§ÛŒØª Ù†Ø§Ù…Û)',0),(206108,5726,'sr','ÐÐ¸Ñ˜ÐµÐ´Ð½Ð° (Ñ€ÑƒÑ‡Ð½Ð¾)',0),(206109,5726,'vi','KhÃ´ng (thá»§ cÃ´ng)',0),(206110,5726,'af','Geen (per Hand)',0),(206111,5726,'ro','Nici unul (Manual)',0),(206112,5726,'et','Ãœkski (kÃ¤sitsi)',0),(206113,5726,'si','Nobeden (roÄno)',0),(206114,5726,'ba','Tidak ada (Manual)',0),(206115,5726,'nl','Geen (handmatig)',0),(206116,5726,'fi','YksikÃ¤Ã¤n (manuaalinen)',0),(206117,5726,'no','Ingen (manuell)',0),(206118,5726,'da','Ingen (manuel)',0),(206119,5726,'ko','ì—†ìŒ (ìˆ˜ë™)',0),(206120,5726,'he','××£ ××—×“ (×™×“× ×™)',0),(206121,5726,'el','ÎšÎ±Î½Î­Î½Î±Ï‚ (Î¼Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î·)',0),(206122,5726,'zh','æ— ï¼ˆæ‰‹åŠ¨ï¼‰\r\n',0),(206123,5726,'sv','Ingen (manuell)',0),(206124,5726,'it','Nessuno (manuale)',0),(206125,5726,'tl','',0),(206126,5726,'th','&#3652;&#3617;&#3656;&#3617;&#3637; (&#3588;&#3641;&#3656;&#3617;&#3639;&#3629;)',0),(206127,5726,'hi','à¤•à¥‹à¤ˆ à¤¨à¤¹à¥€à¤‚ (à¤®à¥ˆà¤¨à¥à¤…à¤²)',0),(206128,5726,'ms','Tiada (Manual)',0),(206129,5726,'ar','Ø¨Ù„Ø§ (ÙŠØ¯ÙˆÙŠ)',0),(206130,5726,'fr','Aucun (manuel)',0),(206131,5726,'jp','ä½•ã‚‚ã?ªã?„ï¼ˆãƒžãƒ‹ãƒ¥ã‚¢ãƒ«ï¼‰',0),(206132,5726,'pt','Nenhum (Manual)',0),(206133,5726,'ru','ÐÐµÑ‚ (Ñ€ÑƒÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾)',0),(206134,5726,'es','Ninguno (Manual)',0),(206135,5726,'de','Keine (manuell)',0),(206136,5726,'en','None (Manual)',0),(206137,5727,'is','',0),(206138,5727,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(206139,5727,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(206140,5727,'tr','VarsayÄ±lan fiyat dÃ¼zeyi',0),(206141,5727,'pl','DomyÅ›lnie poziom cen',0),(206142,5727,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð¾ Ñ€Ð°Ð²Ð½Ð¸Ñ‰Ðµ',0),(206143,5727,'ur','Ø·Û’ Ø´Ø¯Û Ù‚ÛŒÙ…Øª Ø³Ø·Ø­',0),(206144,5727,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð°',0),(206145,5727,'vi','GiÃ¡ Máº·c Ä‘á»‹nh',0),(206146,5727,'af','Verstekte Prysvlak',0),(206147,5727,'ro','Nivelul de pret implicit',0),(206148,5727,'et','Vaikimisi hinnatase',0),(206149,5727,'si','Privzeta raven cen',0),(206150,5727,'ba','Tingkat harga standar',0),(206151,5727,'nl','Standaard prijsniveau',0),(206152,5727,'fi','Oletuksena hintataso',0),(206153,5727,'no','Standard prisnivÃ¥',0),(206154,5727,'da','Standard prisniveau',0),(206155,5727,'ko','ê¸°ë³¸ ê°€ê²© ìˆ˜ì¤€',0),(206156,5727,'he','×¨×ž×ª ×ž×—×™×¨ ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(206157,5727,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½',0),(206158,5727,'zh','é¢„è®¾ä»·æ ¼æ°´å¹³\r\n',0),(206159,5727,'sv','Standard prisnivÃ¥n',0),(206160,5727,'it','Livello di prezzo predefinito',0),(206161,5727,'tl','',0),(206162,5727,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(206163,5727,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°',0),(206164,5727,'ms','Aras harga lalai',0),(206165,5727,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(206166,5727,'fr','Niveau de prix par dÃ©faut',0),(206167,5727,'jp','æ—¢å®šä¾¡æ ¼æ¨™æº–',0),(206168,5727,'pt','NÃ­vel de preÃ§o padrÃ£o',0),(206169,5727,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ñ†ÐµÐ½',0),(206170,5727,'es','Nivel de Precios por Defecto',0),(206171,5727,'de','Standard-Preisniveau',0),(206172,5727,'en','Default Price Level',0),(206173,5728,'is','',0),(206174,5728,'dr','Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(206175,5728,'pr','Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(206176,5728,'tr','SipariÅŸ iÃ§in fiyat teklifi yazdÄ±r',0),(206177,5728,'pl','Druk oferty dla zamÃ³wienia',0),(206178,5728,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(206179,5728,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº',0),(206180,5728,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° Ð½Ð°Ð»Ð¾Ð³',0),(206181,5728,'vi','In bÃ¡o giÃ¡ cho Ä‘Æ¡n hÃ ng',0),(206182,5728,'af','Druk Kwotasie vir Bestelling',0),(206183,5728,'ro','Citat pentru comanda de imprimare',0),(206184,5728,'et','Tellimuse jaoks hinnapakkumise printimine',0),(206185,5728,'si','Natisni ponudbo za naroÄilo',0),(206186,5728,'ba','Mencetak kutipan untuk Order',0),(206187,5728,'nl','Offerte voor Order afdrukt',0),(206188,5728,'fi','Tulosta tarjous tilaus',0),(206189,5728,'no','Skrive ut tilbud for bestilling',0),(206190,5728,'da','Udskrive tilbud til ordre',0),(206191,5728,'ko','ì¸ì‡„ ì£¼ë¬¸ ê²¬ì ',0),(206192,5728,'he','×”×“×¤×¡ ×”×¦×¢×ª ×ž×—×™×¨ ×¢×‘×•×¨ ×”×–×ž× ×”',0),(206193,5728,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(206194,5728,'zh','æ‰“å°è®¢å•æŠ¥ä»·\r\n',0),(206195,5728,'sv','Skriv ut offert fÃ¶r bestÃ¤llning',0),(206196,5728,'it','Stampare il preventivo per ordine',0),(206197,5728,'tl','',0),(206198,5728,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(206199,5728,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(206200,5728,'ms','Cetak Quote untuk pesanan',0),(206201,5728,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù„Ù„Ù†Ø¸Ø§Ù…',0),(206202,5728,'fr','Devis pour la commande d\'impression',0),(206203,5728,'jp','æ³¨æ–‡ã?®è¦‹ç©?ã‚Šã‚’å?°åˆ·',0),(206204,5728,'pt','Imprimir cotaÃ§Ã£o por ordem',0),(206205,5728,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÐ¼ÐµÑ‚Ñ‹ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(206206,5728,'es','CotizaciÃ³n de ImpresiÃ³n para el Orden',0),(206207,5728,'de','Angebot fÃ¼r Bestellung drucken',0),(206208,5728,'en','Print Quote for Order',0),(206209,5729,'is','',0),(206210,5729,'dr','/ ÙˆØ±Ù‚',0),(206211,5729,'pr','Ù‡Ø²ÙŠÙ†Ù‡ / ÙˆØ±Ù‚',0),(206212,5729,'tr','Maliyet/levha',0),(206213,5729,'pl','Koszt/arkusz',0),(206214,5729,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸/Ð»Ð¸ÑÑ‚',0),(206215,5729,'ur','Ù„Ø§Ú¯Øª/ÙˆØ±Ù‚',0),(206216,5729,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº/Ð»Ð¸ÑÑ‚',0),(206217,5729,'vi','GiÃ¡ / Trang',0),(206218,5729,'af','Koste/vel',0),(206219,5729,'ro','Costul/foaie',0),(206220,5729,'et','Kulu/leht',0),(206221,5729,'si','StroÅ¡ki/list',0),(206222,5729,'ba','Biaya/lembar',0),(206223,5729,'nl','Kosten per vel',0),(206224,5729,'fi','Kustannukset/arkki',0),(206225,5729,'no','Kostnad/ark',0),(206226,5729,'da','Omkostninger/ark',0),(206227,5729,'ko','ë¹„ìš©/ì‹œíŠ¸',0),(206228,5729,'he','×¢×œ×•×ª/×’×™×œ×™×•×Ÿ',0),(206229,5729,'el','ÎšÏŒÏƒÏ„Î¿Ï‚/Ï†ÏÎ»Î»Î¿',0),(206230,5729,'zh','æˆæœ¬/è¡¨\r\n',0),(206231,5729,'sv','Kostnad/ark',0),(206232,5729,'it','Costo per foglio',0),(206233,5729,'tl','',0),(206234,5729,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;/&#3649;&#3612;&#3656;&#3609;',0),(206235,5729,'hi','à¤²à¤¾à¤—à¤¤/à¤šà¤¾à¤¦à¤°',0),(206236,5729,'ms','Kos/lembaran',0),(206237,5729,'ar','Ø§Ù„ØªÙƒÙ„ÙØ©/ÙˆØ±Ù‚Ø©',0),(206238,5729,'fr','CoÃ»t/feuille',0),(206239,5729,'jp','è²»ç”¨/ã‚·ãƒ¼ãƒˆ',0),(206240,5729,'pt','Custo/folha',0),(206241,5729,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ/Ð»Ð¸ÑÑ‚',0),(206242,5729,'es','Costo/Hoja',0),(206243,5729,'de','Kosten pro Blatt',0),(206244,5729,'en','Cost/Sheet',0),(206245,5730,'is','',0),(206246,5730,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(206247,5730,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(206248,5730,'tr','SÃ¼re raporu - servis sipariÅŸleri',0),(206249,5730,'pl','Raport czasu - zleceÅ„ serwisowych',0),(206250,5730,'bg','Ð’Ñ€ÐµÐ¼ÐµÑ‚Ð¾ Ð´Ð¾ÐºÐ»Ð°Ð´ - Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(206251,5730,'ur','ÙˆÙ‚Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ - Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(206252,5730,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ - Ð½Ð°Ð»Ð¾Ð·Ð¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(206253,5730,'vi','BÃ¡o cÃ¡o thá»i gian Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(206254,5730,'af','Diens Bestelling Tydverslag',0),(206255,5730,'ro','Timp raport - comenzi de Service',0),(206256,5730,'et','Aruanne - hooldustellimuste',0),(206257,5730,'si','Time poroÄilo - servisnih nalogov',0),(206258,5730,'ba','Waktu laporan - Layanan pesanan',0),(206259,5730,'nl','Rapport over de responstijden - serviceorders',0),(206260,5730,'fi','Aikaraportti - huoltotilauksia',0),(206261,5730,'no','Rapport - serviceordrer',0),(206262,5730,'da','Time rapport - serviceordrer',0),(206263,5730,'ko','ì‹œê°„ ë³´ê³ ì„œ-ì„œë¹„ìŠ¤ ì£¼ë¬¸',0),(206264,5730,'he','×“×•×— ×‘×–×ž×Ÿ - ×©×™×¨×•×ª ×”×–×ž× ×•×ª',0),(206265,5730,'el','Î§ÏÏŒÎ½Î¿Ï‚ Î­ÎºÎ¸ÎµÏƒÎ·Ï‚ - ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(206266,5730,'zh','æœåŠ¡è®¢å•æ—¶é—´æŠ¥å‘Š\r\n',0),(206267,5730,'sv','Tidrapport - serviceorder',0),(206268,5730,'it','Rapporto tempo - ordini di servizio',0),(206269,5730,'tl','',0),(206270,5730,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3648;&#3623;&#3621;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(206271,5730,'hi','à¤¸à¤®à¤¯ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ - à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶',0),(206272,5730,'ms','Laporan masa - pesanan Perkhidmatan',0),(206273,5730,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ÙˆÙ‚Øª-Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(206274,5730,'fr','Rapport de temps - Service commandes',0),(206275,5730,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡æ™‚é–“ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(206276,5730,'pt','RelatÃ³rio de tempo - ordens de serviÃ§o',0),(206277,5730,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ - ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(206278,5730,'es','Orden de Servicio Informe de Tiempo',0),(206279,5730,'de','Time-Bericht - Service-AuftrÃ¤ge',0),(206280,5730,'en','Time Report - Service Orders',0),(206281,5731,'is','',0),(206282,5731,'dr','Ù†Ù…Ø§ÙŠØ´ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ ',0),(206283,5731,'pr','Ù†Ù…Ø§ÙŠØ´ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ ',0),(206284,5731,'tr','Show Notlar',0),(206285,5731,'pl','PokaÅ¼ notatki',0),(206286,5731,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸Ñ‚Ðµ',0),(206287,5731,'ur','Ù†ÙˆÙ¹ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(206288,5731,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð±ÐµÐ»ÐµÑˆÐºÐµ',0),(206289,5731,'vi','Hiá»ƒn thá»‹ ghi chÃº',0),(206290,5731,'af','Wys Notas',0),(206291,5731,'ro','AratÄƒ Note',0),(206292,5731,'et','Saate mÃ¤rkmed kuvada',0),(206293,5731,'si','PrikaÅ¾ite opombe',0),(206294,5731,'ba','Tampilkan catatan',0),(206295,5731,'nl','Toon Notes',0),(206296,5731,'fi','NÃ¤ytÃ¤ huomautukset',0),(206297,5731,'no','Show noter',0),(206298,5731,'da','Vis noter',0),(206299,5731,'ko','ë…¸íŠ¸ ë³´ê¸°',0),(206300,5731,'he','×”×¦×’ ×”×¢×¨×•×ª',0),(206301,5731,'el','Show Î£Î—ÎœÎ•Î™Î©Î£Î•Î™Î£',0),(206302,5731,'zh','æ˜¾ç¤ºå¤‡æ³¨\r\n',0),(206303,5731,'sv','Visa anteckningar',0),(206304,5731,'it','Visualizza note',0),(206305,5731,'tl','',0),(206306,5731,'th','&#3649;&#3626;&#3604;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(206307,5731,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(206308,5731,'ms','Nota-Nota Papar',0),(206309,5731,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(206310,5731,'fr','Montrer les Notes',0),(206311,5731,'jp','ãƒ¡ãƒ¢ã?®è¡¨ç¤º',0),(206312,5731,'pt','Mostrar notas',0),(206313,5731,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(206314,5731,'es','Mostrar Notas',0),(206315,5731,'de','Shownotes',0),(206316,5731,'en','Show Notes',0),(206317,5732,'is','',0),(206318,5732,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø«Ø§Ø¨Øª',0),(206319,5732,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø«Ø§Ø¨Øª',0),(206320,5732,'tr','Ã–zel iÅŸÃ§i',0),(206321,5732,'pl','OkreÅ›lonego pracownika',0),(206322,5732,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº',0),(206323,5732,'ur','Ù…Ø®ØµÙˆØµ Ú©Ø§Ø±Ú©Ù†',0),(206324,5732,'sr','ÐžÐ´Ñ€ÐµÑ’ÐµÐ½Ð¸ Ñ€Ð°Ð´Ð½Ð¸Ðº',0),(206325,5732,'vi','CÃ´ng NhÃ¢n cá»¥ thá»ƒ',0),(206326,5732,'af','Spesifieke Werker',0),(206327,5732,'ro','Munca specifice',0),(206328,5732,'et','Konkreetse tÃ¶Ã¶taja',0),(206329,5732,'si','Posebne delavec',0),(206330,5732,'ba','Khusus pekerja',0),(206331,5732,'nl','Specifieke werknemer',0),(206332,5732,'fi','TiettyÃ¤ tyÃ¶ntekijÃ¤Ã¤',0),(206333,5732,'no','Bestemte arbeidstaker',0),(206334,5732,'da','Bestemt arbejder',0),(206335,5732,'ko','íŠ¹ì • ìž‘ì—…ìž',0),(206336,5732,'he','×¢×•×‘×“ ×ž×¡×•×™×',0),(206337,5732,'el','Î£Ï…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿',0),(206338,5732,'zh','å…·ä½“å·¥äºº\r\n',0),(206339,5732,'sv','SÃ¤rskilda arbetstagaren',0),(206340,5732,'it','Operaio specifico',0),(206341,5732,'tl','',0),(206342,5732,'th','&#3619;&#3632;&#3610;&#3640;&#3588;&#3609;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(206343,5732,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤•à¤¾à¤°à¥à¤¯à¤•à¤°à¥à¤¤à¤¾',0),(206344,5732,'ms','Pekerja tertentu',0),(206345,5732,'ar','Ø¹Ø§Ù…Ù„ Ù…Ø­Ø¯Ø¯',0),(206346,5732,'fr','Travailleur spÃ©cifique',0),(206347,5732,'jp','ç‰¹å®šã?®ä½œæ¥­å“¡',0),(206348,5732,'pt','Trabalhador especÃ­fico',0),(206349,5732,'ru','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ñ‹Ð¹ Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº',0),(206350,5732,'es','Trabajador EspecÃ­fico',0),(206351,5732,'de','Bestimmte Arbeitnehmer',0),(206352,5732,'en','Specific Worker',0),(206353,5733,'is','',0),(206354,5733,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø²Ù…Ø§Ù† ',0),(206355,5733,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø²Ù…Ø§Ù† ',0),(206356,5733,'tr','SÃ¼re raporu',0),(206357,5733,'pl','Raport czasu',0),(206358,5733,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(206359,5733,'ur','ÙˆÙ‚Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(206360,5733,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(206361,5733,'vi','BÃ¡o cÃ¡o thá»i gian ',0),(206362,5733,'af','Tyd Verslag',0),(206363,5733,'ro','Raport de timp',0),(206364,5733,'et','Aruanne',0),(206365,5733,'si','Time poroÄilo',0),(206366,5733,'ba','Waktu laporan',0),(206367,5733,'nl','Rapport over de responstijden',0),(206368,5733,'fi','Aikaraportti',0),(206369,5733,'no','Rapport',0),(206370,5733,'da','Time rapport',0),(206371,5733,'ko','ì‹œê°„ ë³´ê³ ì„œ',0),(206372,5733,'he','×“×•×— ×‘×–×ž×Ÿ',0),(206373,5733,'el','Î§ÏÏŒÎ½Î¿Ï‚ Î­ÎºÎ¸ÎµÏƒÎ·Ï‚',0),(206374,5733,'zh','æ—¶é—´æŠ¥å‘Š\r\n',0),(206375,5733,'sv','Tidrapport',0),(206376,5733,'it','Rapporto tempo',0),(206377,5733,'tl','',0),(206378,5733,'th','&#3648;&#3623;&#3621;&#3634;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(206379,5733,'hi','à¤¸à¤®à¤¯ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(206380,5733,'ms','Laporan masa',0),(206381,5733,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ÙˆÙ‚Øª',0),(206382,5733,'fr','Rapport de temps',0),(206383,5733,'jp','æ™‚é–“ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(206384,5733,'pt','RelatÃ³rio de tempo',0),(206385,5733,'ru','Ð’Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾Ð¹ ÐžÑ‚Ñ‡ÐµÑ‚',0),(206386,5733,'es','Informe de Tiempo',0),(206387,5733,'de','Time-Bericht',0),(206388,5733,'en','Time Report',0),(206389,5734,'is','',0),(206390,5734,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø²Ù…Ø§Ù† Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(206391,5734,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø²Ù…Ø§Ù† Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(206392,5734,'tr','SÃ¼re raporu - servis sipariÅŸleri',0),(206393,5734,'pl','Raport czasu - zleceÅ„ serwisowych',0),(206394,5734,'bg','Ð’Ñ€ÐµÐ¼ÐµÑ‚Ð¾ Ð´Ð¾ÐºÐ»Ð°Ð´ - Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(206395,5734,'ur','ÙˆÙ‚Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ - Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(206396,5734,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ - Ð½Ð°Ð»Ð¾Ð·Ð¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(206397,5734,'vi','BÃ¡o cÃ¡o thá»i gian cho cÃ´ng viá»‡c Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(206398,5734,'af','Tyd Verslag vir Diensbestellingswerk',0),(206399,5734,'ro','Timp raport - comenzi de Service',0),(206400,5734,'et','Aruanne - hooldustellimuste',0),(206401,5734,'si','Time poroÄilo - servisnih nalogov',0),(206402,5734,'ba','Waktu laporan - Layanan pesanan',0),(206403,5734,'nl','Rapport over de responstijden - serviceorders',0),(206404,5734,'fi','Aikaraportti - huoltotilauksia',0),(206405,5734,'no','Rapport - serviceordrer',0),(206406,5734,'da','Time rapport - serviceordrer',0),(206407,5734,'ko','ì‹œê°„ ë³´ê³ ì„œ-ì„œë¹„ìŠ¤ ì£¼ë¬¸',0),(206408,5734,'he','×“×•×— ×‘×–×ž×Ÿ - ×©×™×¨×•×ª ×”×–×ž× ×•×ª',0),(206409,5734,'el','Î§ÏÏŒÎ½Î¿Ï‚ Î­ÎºÎ¸ÎµÏƒÎ·Ï‚ - ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(206410,5734,'zh','æœåŠ¡è®¢å•å·¥ä½œæ—¶é—´æŠ¥å‘Š\r\n',0),(206411,5734,'sv','Tidrapport - serviceorder',0),(206412,5734,'it','Rapporto tempo - ordini di servizio',0),(206413,5734,'tl','',0),(206414,5734,'th','&#3648;&#3623;&#3621;&#3634;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(206415,5734,'hi','à¤¸à¤®à¤¯ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ - à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶',0),(206416,5734,'ms','Laporan masa - pesanan Perkhidmatan',0),(206417,5734,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ÙˆÙ‚Øª-Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(206418,5734,'fr','Rapport de temps - Service commandes',0),(206419,5734,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ä½œæ¥­ã?®æ™‚é–“ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(206420,5734,'pt','RelatÃ³rio de tempo - ordens de serviÃ§o',0),(206421,5734,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ - ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(206422,5734,'es','Informe de Tiempo para Trabajo en Ordenes de Servicio',0),(206423,5734,'de','Time-Bericht - Service-AuftrÃ¤ge',0),(206424,5734,'en','Time Report - Service Orders',0),(206425,5735,'is','',0),(206426,5735,'dr','Ù…Ø´ÙƒÙ„ ',0),(206427,5735,'pr','Ù…Ø´ÙƒÙ„ ',0),(206428,5735,'tr','Zor',0),(206429,5735,'pl','Trudne',0),(206430,5735,'bg','Ð¢Ñ€ÑƒÐ´Ð½Ð¾',0),(206431,5735,'ur','Ù…Ø´Ú©Ù„',0),(206432,5735,'sr','Ð¢ÐµÑˆÐºÐ¾',0),(206433,5735,'vi','KhÃ³',0),(206434,5735,'af','Moeilik',0),(206435,5735,'ro','Dificil',0),(206436,5735,'et','Raske',0),(206437,5735,'si','TeÅ¾ko',0),(206438,5735,'ba','Sulit',0),(206439,5735,'nl','Moeilijk',0),(206440,5735,'fi','Vaikea',0),(206441,5735,'no','Vanskelig',0),(206442,5735,'da','Vanskeligt',0),(206443,5735,'ko','ì–´ë ¤ìš´',0),(206444,5735,'he','×ž×¡×•×‘×š',0),(206445,5735,'el','Î”ÏÏƒÎºÎ¿Î»Î¿',0),(206446,5735,'zh','å›°éš¾\r\n',0),(206447,5735,'sv','SvÃ¥rt',0),(206448,5735,'it','Difficile',0),(206449,5735,'tl','',0),(206450,5735,'th','&#3618;&#3634;&#3585;',0),(206451,5735,'hi','à¤®à¥à¤¶à¥à¤•à¤¿à¤²',0),(206452,5735,'ms','Sukar',0),(206453,5735,'ar','ØµØ¹Ø¨Ø©',0),(206454,5735,'fr','Difficile',0),(206455,5735,'jp','ã‚€ã?šã?‹ã?—ã?„',0),(206456,5735,'pt','DifÃ­cil',0),(206457,5735,'ru','Ð¢Ñ€ÑƒÐ´Ð½Ð¾',0),(206458,5735,'es','DifÃ­cil',0),(206459,5735,'de','Schwierig',0),(206460,5735,'en','Difficult',0),(206461,5736,'is','',0),(206462,5736,'dr','- Ø«Ø¨Øª ÙƒØ±Ø¯Ù† ÙŠØ§ Ù¾ÙˆØ´Ø´( Ù…Ø±ÙˆØ±) Ø²ÙŠØ§Ø¯  Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÙŠØ¯ ',0),(206463,5736,'pr','Ø´Ø±Ø­ Ù…Ø´ÙƒÙ„ Ú†Ø§Ù¾- Ø«Ø¨Øª ÙƒØ±Ø¯Ù† ÙŠØ§ Ù¾ÙˆØ´Ø´( Ù…Ø±ÙˆØ±) Ø²ÙŠØ§Ø¯  Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÙŠØ¯ ',0),(206464,5736,'tr',' -KayÄ±t veya aÄŸÄ±r kapsama yakÄ±n',0),(206465,5736,'pl',' -Zamknij rejestr lub ciÄ™Å¼kie pokrycie',0),(206466,5736,'bg',' -Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÑ‚Ðµ Ñ€ÐµÐ³Ð¸ÑÑ‚ÑŠÑ€Ð° Ð¸Ð»Ð¸ Ñ‚ÐµÐ¶ÐºÐ¸ Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ',0),(206467,5736,'ur',' -Ø±Ø¬Ø³Ù¹Ø± ÛŒØ§ Ø¨Ú¾Ø§Ø±ÛŒ Ú©ÙˆØ±ÛŒØ¬ Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº',0),(206468,5736,'sr',' -Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ ÐºÐ°ÑÑƒ Ð¸Ð»Ð¸ Ñ‚ÐµÑˆÐºÐµ Ð¿Ð¾ÐºÑ€Ð¸Ð²ÐµÐ½Ð¾ÑÑ‚',0),(206469,5736,'vi','ÄÄƒng kÃ½ gáº§n hay pháº¡m vi báº£o hiá»ƒm cao',0),(206470,5736,'af',' -Sluit Register of swaar dekking',0),(206471,5736,'ro',' -ÃŽnchideÅ£i registrul sau grele de acoperire',0),(206472,5736,'et',' -Registrisse vÃµi raske katte sulgemine',0),(206473,5736,'si',' -Zaprite Register ali teÅ¾ke pokritost',0),(206474,5736,'ba',' -Menutup daftar atau berat cakupan',0),(206475,5736,'nl',' -Sluit Register of zware dekking',0),(206476,5736,'fi',' -Sulje RekisterÃ¶idy tai raskas kattavuus',0),(206477,5736,'no',' -Lukk Register eller tunge dekning',0),(206478,5736,'da',' -Luk Register eller tunge dÃ¦kning',0),(206479,5736,'ko',' -ë“±ë¡ ë˜ëŠ” ë¬´ê±°ìš´ ì ìš© ë‹«ê¸°',0),(206480,5736,'he',' -×¡×’×™×¨×ª ×”×§×•×¤×” ××• ×›×™×¡×•×™ ×›×‘×“',0),(206481,5736,'el',' -ÎšÎ»ÎµÎ¯ÏƒÏ„Îµ Ï„Î¿ Î¼Î·Ï„ÏÏŽÎ¿ Î® Î²Î±ÏÎ¹Î¬ ÎºÎ¬Î»Ï…ÏˆÎ·',0),(206482,5736,'zh','å…³é—­æ³¨å†Œæˆ–é‡è¦†ç›–\r\n',0),(206483,5736,'sv',' -StÃ¤ng Register eller tunga tÃ¤ckning',0),(206484,5736,'it',' -Chiudere il registro o copertura pesante',0),(206485,5736,'tl','',0),(206486,5736,'th','&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3621;&#3591;&#3607;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;&#3627;&#3619;&#3639;&#3629;&#3611;&#3585;&#3611;&#3636;&#3604;&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;',0),(206487,5736,'hi',' -à¤°à¤œà¤¿à¤¸à¥à¤Ÿà¤° à¤¯à¤¾ à¤­à¤¾à¤°à¥€ à¤•à¤µà¤°à¥‡à¤œ à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(206488,5736,'ms',' -Menutup Daftar atau liputan berat',0),(206489,5736,'ar',' -Ø¥ØºÙ„Ø§Ù‚ Ø§Ù„Ø³Ø¬Ù„ Ø£Ùˆ Ø§Ù„ØªØºØ·ÙŠØ© Ø§Ù„Ø«Ù‚ÙŠÙ„Ø©',0),(206490,5736,'fr',' -Fermer le registre ou couverture lourde',0),(206491,5736,'jp',' -Close Register or Heavy Coverage',0),(206492,5736,'pt',' -Fechar o registo ou cobertura pesada',0),(206493,5736,'ru',' -Ð—Ð°ÐºÑ€Ð¾Ð¹Ñ‚Ðµ Ñ€ÐµÐµÑÑ‚Ñ€ Ð¸Ð»Ð¸ Ñ‚ÑÐ¶ÐµÐ»Ð¾Ð³Ð¾ Ð¿Ð¾ÐºÑ€Ñ‹Ñ‚Ð¸Ñ',0),(206494,5736,'es',' -Cerrar RegÃ­stro o Demasiada Cobertura ',0),(206495,5736,'de',' -Register oder schwere Abdeckung schlieÃŸen',0),(206496,5736,'en',' -Close Register or Heavy Coverage',0),(206497,5737,'is','',0),(206498,5737,'dr','Ø¢Ø³Ø§Ù† ',0),(206499,5737,'pr','Ø¢Ø³Ø§Ù† ',0),(206500,5737,'tr','Kolay',0),(206501,5737,'pl','Åatwe',0),(206502,5737,'bg','Ð›ÐµÑÐ½Ð¾',0),(206503,5737,'ur','Ø¢Ø³Ø§Ù†',0),(206504,5737,'sr','Ð›Ð°ÐºÐ¾',0),(206505,5737,'vi','Dá»…',0),(206506,5737,'af','Maklik',0),(206507,5737,'ro','UÅŸor',0),(206508,5737,'et','Lihtne',0),(206509,5737,'si','Enostavno',0),(206510,5737,'ba','Mudah',0),(206511,5737,'nl','Gemakkelijk',0),(206512,5737,'fi','Helppoa',0),(206513,5737,'no','Lett',0),(206514,5737,'da','Nem',0),(206515,5737,'ko','ì‰¬ìš´',0),(206516,5737,'he','×§×œ',0),(206517,5737,'el','Î•ÏÎºÎ¿Î»Î·',0),(206518,5737,'zh','å®¹æ˜“\r\n',0),(206519,5737,'sv','LÃ¤tt',0),(206520,5737,'it','Facile',0),(206521,5737,'tl','',0),(206522,5737,'th','&#3591;&#3656;&#3634;&#3618;',0),(206523,5737,'hi','à¤†à¤¸à¤¾à¤¨',0),(206524,5737,'ms','Mudah',0),(206525,5737,'ar','Ø³Ù‡Ù„Ø©',0),(206526,5737,'fr','Facile',0),(206527,5737,'jp','ã?‹ã‚“ã?Ÿã‚“',0),(206528,5737,'pt','FÃ¡cil',0),(206529,5737,'ru','Ð›ÐµÐ³ÐºÐ¾',0),(206530,5737,'es','FÃ¡cil',0),(206531,5737,'de','Einfach',0),(206532,5737,'en','Easy',0),(206533,5738,'is','',0),(206534,5738,'dr','-No Register and Med. to Light Coverage',0),(206535,5738,'pr',' Ø´Ø±Ø­ Ú†Ø§Ù¾ Ø¢Ø³Ø§Ù† â€“-No Register and Med. to Light Coverage',0),(206536,5738,'tr',' -HiÃ§bir kayÄ±t ve Med. Ä±ÅŸÄ±k kapsama',0),(206537,5738,'pl',' -Brak rejestru i Med. lekkie pokrycie',0),(206538,5738,'bg',' -ÐÑÐ¼Ð° Ñ€ÐµÐ³Ð¸ÑÑ‚ÑŠÑ€ Ð¸ Med. ÐºÑŠÐ¼ ÑÐ²ÐµÑ‚Ð»Ð¾ Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ',0),(206539,5738,'ur',' -Ú©ÙˆØ¦ÛŒ Ø±Ø¬Ø³Ù¹Ø± Ø§ÙˆØ± Ø±ÙˆØ´Ù†ÛŒ Ú©ÛŒ Ú©ÙˆØ±ÛŒØ¬ Ú©Û’ Ù„ÛŒÛ’ Med.',0),(206540,5738,'sr',' -ÐÐµÐ¼Ð° Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ° Ð¸ ÐœÐµÐ´. Ð½Ð° Ð»Ð°Ð³Ð°Ð½ Ð¿Ð¾ÐºÑ€Ð¸Ð²ÐµÐ½Ð¾ÑÑ‚',0),(206541,5738,'vi','KhÃ´ng Ä‘Äƒng kÃ½ & Med. cho pháº¡m vi nháº¹',0),(206542,5738,'af',' -Geen Register en vas na ligte bedekking',0),(206543,5738,'ro',' -Nici un registru ÅŸi Med. la lumina acoperire',0),(206544,5738,'et',' -Nr registris ja Med. kerge katvuse',0),(206545,5738,'si',' -Ni Register in Med. slabÅ¡o prekrivnost',0),(206546,5738,'ba',' -Tidak ada pendaftaran dan Med. ke cahaya cakupan',0),(206547,5738,'nl',' -Geen Register en Med. naar lichte dekking',0),(206548,5738,'fi',' -Ei rekisterÃ¶i ja Med. kevyt kattavuus',0),(206549,5738,'no',' -Ingen Register og Med. til lys dekning',0),(206550,5738,'da',' -Ingen Register og Med. til let dÃ¦kning',0),(206551,5738,'ko',' -ë“±ë¡ ë° ê°€ë²¼ìš´ ì ìš©ì„ ì¤‘ê²¬ ê¸°ì—…',0),(206552,5738,'he',' . ××™×Ÿ ×¨×™×©×•×, ×”×ª×™×›×•×Ÿ ×›×“×™ ×›×™×¡×•×™',0),(206553,5738,'el',' -Î”ÎµÎ½ Î¼Î·Ï„ÏÏŽÎ¿ ÎºÎ±Î¹ Med. Î³Î¹Î± ÎµÎ»Î±Ï†ÏÎ¹Î¬ ÎºÎ¬Î»Ï…ÏˆÎ·',0),(206554,5738,'zh','è½»æ¾æ‰“å°è§£é‡Š\r\n',0),(206555,5738,'sv',' -Ingen Register och Med. att lÃ¤tt tÃ¤ckning',0),(206556,5738,'it',' -Nessun registro e MED. a copertura di luce',0),(206557,5738,'tl','',0),(206558,5738,'th','-No Register and Med. to Light Coverage',0),(206559,5738,'hi',' -à¤•à¥‹à¤ˆ à¤°à¤œà¤¿à¤¸à¥à¤Ÿà¤° à¤”à¤° Med. à¤ªà¥à¤°à¤•à¤¾à¤¶ à¤•à¤µà¤°à¥‡à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(206560,5738,'ms',' -Tiada Daftar dan Med. kepada perlindungan cahaya',0),(206561,5738,'ar',' -Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø³Ø¬Ù„ ÙˆÙÙˆÙ„ÙØ¬Ø§Ù†Ø¬ Ù„Ù„ØªØºØ·ÙŠØ© Ø§Ù„Ø®ÙÙŠÙØ©',0),(206562,5738,'fr',' -Aucun registre et med. couverture lÃ©gÃ¨re',0),(206563,5738,'jp',' -No Register and Med. to Light Coverage',0),(206564,5738,'pt',' -Nenhum registo e med. para cobertura de luz',0),(206565,5738,'ru',' -ÐÐµÑ‚ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð° Ð¸ ÑÑ€ÐµÐ´Ð½Ð¸Ðµ Ð´Ð»Ñ ÑÐ²ÐµÑ‚Ð° Ð¾ÑÐ²ÐµÑ‰ÐµÐ½Ð¸Ðµ',0),(206566,5738,'es',' -No Regisro y Cobertura de Medio a Clara',0),(206567,5738,'de',' -Keine Register und Med., leichte Abdeckung',0),(206568,5738,'en',' -No Register and Med. to Light Coverage',0),(206569,5739,'is','',0),(206570,5739,'dr',': Ø«Ø¨Øª Ù†Ø§Ù… Ø³Ø§Ø¯Ù‡ Ùˆ  Med. to Light Coverage',0),(206571,5739,'pr','  Ø´Ø±Ø­ Ú†Ø§Ù¾ Ù†Ø±Ù…Ø§Ù„ : Ø«Ø¨Øª Ù†Ø§Ù… Ø³Ø§Ø¯Ù‡ Ùˆ  Med. to Light Coverage',0),(206572,5739,'tr',' -Basit kayÄ±t ve Med. Ä±ÅŸÄ±k kapsama',0),(206573,5739,'pl',' -Zarejestruj siÄ™ proste i Med. lekkie pokrycie',0),(206574,5739,'bg',' -ÐŸÑ€Ð¾ÑÑ‚Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚ÑŠÑ€ Ð¸ Med. ÐºÑŠÐ¼ ÑÐ²ÐµÑ‚Ð»Ð¾ Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ',0),(206575,5739,'ur',' -Ø³Ø§Ø¯Û Ø±Ø¬Ø³Ù¹Ø± Ø§ÙˆØ± Ø±ÙˆØ´Ù†ÛŒ Ú©ÛŒ Ú©ÙˆØ±ÛŒØ¬ Ú©Û’ Ù„ÛŒÛ’ Med.',0),(206576,5739,'sr',' -ÐˆÐµÐ´Ð½Ð¾ÑÑ‚Ð°Ð²Ð½Ð¾ Ð ÐµÐ³Ð¸ÑÑ‚ÐµÑ€ Ð¸ ÐœÐµÐ´. Ð½Ð° Ð»Ð°Ð³Ð°Ð½ Ð¿Ð¾ÐºÑ€Ð¸Ð²ÐµÐ½Ð¾ÑÑ‚',0),(206577,5739,'vi',' -ÄÄƒng kÃ½ Ä‘Æ¡n giáº£n & trung bÃ¬ng tá»›i pháº¡m vi nháº¹',0),(206578,5739,'af',' -Eenvoudige Register en vas na ligte bedekking',0),(206579,5739,'ro',' -Simplu registru ÅŸi Med. la lumina acoperire',0),(206580,5739,'et',' -Lihtne registri ja Med. kerge katvuse',0),(206581,5739,'si',' -Preprosto Register in Med. slabÅ¡o prekrivnost',0),(206582,5739,'ba',' -Pendaftaran sederhana dan Med. ke cahaya cakupan',0),(206583,5739,'nl',' -Eenvoudige Register en Med. naar lichte dekking',0),(206584,5739,'fi',' -Yksinkertainen rekisterin ja Med. kevyt kattavuus',0),(206585,5739,'no',' -Enkel Register og Med. til lys dekning',0),(206586,5739,'da',' -Enkel Register og Med. til let dÃ¦kning',0),(206587,5739,'ko',' -ê°„ë‹¨í•œ ë ˆì§€ìŠ¤í„°ì™€ ê°€ë²¼ìš´ ì ìš©ì„ ì¤‘ê²¬ ê¸°ì—…',0),(206588,5739,'he',' -×”×¨×©×ž×” ×¤×©×•×˜×” ×•××ª ×”×ª×™×›×•×Ÿ ×›×“×™ ×›×™×¡×•×™',0),(206589,5739,'el',' -Î‘Ï€Î»ÏŒ Î¼Î·Ï„ÏÏŽÎ¿ ÎºÎ±Î¹ Med. Î³Î¹Î± ÎµÎ»Î±Ï†ÏÎ¹Î¬ ÎºÎ¬Î»Ï…ÏˆÎ·',0),(206590,5739,'zh','ç®€å•çš„æ³¨å†Œå’ŒåŒ»ç–—ã€‚å¯¹è¦†ç›–\r\n',0),(206591,5739,'sv',' -Enkel Register och Med. att lÃ¤tt tÃ¤ckning',0),(206592,5739,'it',' -Registro semplice e MED. a copertura di luce',0),(206593,5739,'tl','',0),(206594,5739,'th',' -Simple Register and Med. to Light Coverage',0),(206595,5739,'hi',' -à¤¸à¤°à¤² à¤°à¤œà¤¿à¤¸à¥à¤Ÿà¤° à¤”à¤° Med. à¤ªà¥à¤°à¤•à¤¾à¤¶ à¤•à¤µà¤°à¥‡à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(206596,5739,'ms',' -Mudah mendaftar dan Med. kepada perlindungan cahaya',0),(206597,5739,'ar',' --Ø§Ù„Ø³Ø¬Ù„ Ø¨Ø³ÙŠØ·Ø© ÙˆØ§Ù„Ø¯ÙƒØªÙˆØ± Ù„Ù„ØªØºØ·ÙŠØ© Ø§Ù„Ø®ÙÙŠÙØ©',0),(206598,5739,'fr',' -Registre simple et med. couverture lÃ©gÃ¨re',0),(206599,5739,'jp',' -Simple Register and Med. to Light Coverage',0),(206600,5739,'pt',' -Simples registo e med. para cobertura de luz',0),(206601,5739,'ru',' -ÐŸÑ€Ð¾ÑÑ‚Ð¾ Ð·Ð°Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒÑÑ Ð¸ ÑÑ€ÐµÐ´Ð½Ð¸Ðµ Ð´Ð»Ñ ÑÐ²ÐµÑ‚Ð° Ð¾ÑÐ²ÐµÑ‰ÐµÐ½Ð¸Ðµ',0),(206602,5739,'es','-Registro Simple y Cobertura Desde Medio Hasta Ligero',0),(206603,5739,'de',' -Einfach registrieren und Med., leichte Abdeckung',0),(206604,5739,'en',' -Simple Register and Med. to Light Coverage',0),(206605,5740,'is','',0),(206606,5740,'dr','Ù…Ø´ÙƒÙ„ Ú†Ø§Ù¾',0),(206607,5740,'pr','Ù…Ø´ÙƒÙ„ Ú†Ø§Ù¾',0),(206608,5740,'tr','BasÄ±n zorluk',0),(206609,5740,'pl','NaciÅ›nij trudnoÅ›ci',0),(206610,5740,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ñ‚Ñ€ÑƒÐ´Ð½Ð¾ÑÑ‚',0),(206611,5740,'ur','Ù¾Ø±ÛŒØ³ Ù…ÛŒÚº Ù…Ø´Ú©Ù„ Ú©Ø§ Ø³Ø§Ù…Ù†Ø§',0),(206612,5740,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ Ñ‚ÐµÐ¶Ð¸Ð½Ðµ',0),(206613,5740,'vi','KhÃ³ khÄƒn trong in áº¥n',0),(206614,5740,'af','Druk probleme',0),(206615,5740,'ro','Dificultatea de presÄƒ',0),(206616,5740,'et','Vajutage raskustes',0),(206617,5740,'si','Pritisnite teÅ¾ave',0),(206618,5740,'ba','Tekan kesulitan',0),(206619,5740,'nl','Druk op de moeilijkheid',0),(206620,5740,'fi','Paina vaikeus',0),(206621,5740,'no','Trykk problemer',0),(206622,5740,'da','Tryk pÃ¥ vanskeligheder',0),(206623,5740,'ko','ë³´ë„ ì–´ë ¤ì›€',0),(206624,5740,'he','×”×§×© ×¢×œ ×§×•×©×™',0),(206625,5740,'el','Î Î±Ï„Î®ÏƒÏ„Îµ Î´Ï…ÏƒÎºÎ¿Î»Î¯Î±',0),(206626,5740,'zh','å°åˆ·éš¾åº¦\r\n',0),(206627,5740,'sv','Tryck pÃ¥ svÃ¥righeter',0),(206628,5740,'it','DifficoltÃ  di stampa',0),(206629,5740,'tl','',0),(206630,5740,'th','&#3585;&#3604;&#3618;&#3634;&#3585;&#3621;&#3635;&#3610;&#3634;&#3585;',0),(206631,5740,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤®à¥‡à¤‚ à¤•à¤ à¤¿à¤¨à¤¾à¤ˆ',0),(206632,5740,'ms','Tekan kesukaran',0),(206633,5740,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ ØµØ¹ÙˆØ¨Ø©',0),(206634,5740,'fr','DifficultÃ© de presse',0),(206635,5740,'jp','ãƒ—ãƒ¬ã‚¹å•?é¡Œç‚¹',0),(206636,5740,'pt','Dificuldade de imprensa',0),(206637,5740,'ru','Ð¢Ñ€ÑƒÐ´Ð½Ð¾ÑÑ‚ÑŒ Ð¿Ñ€ÐµÑÑ',0),(206638,5740,'es','Dificultad de Prensa',0),(206639,5740,'de','DrÃ¼cken Sie Schwierigkeiten',0),(206640,5740,'en','Press Difficulty',0),(206641,5741,'is','',0),(206642,5741,'dr','Ù…Ø´ÙƒÙ„ Ú†Ø§Ù¾',0),(206643,5741,'pr','Ù…Ø´ÙƒÙ„ Ú†Ø§Ù¾',0),(206644,5741,'tr','Zor YazdÄ±r',0),(206645,5741,'pl','Trudne wydruku',0),(206646,5741,'bg','Ð¢Ñ€ÑƒÐ´Ð½Ð¾ Ð¿ÐµÑ‡Ð°Ñ‚',0),(206647,5741,'ur','Ù…Ø´Ú©Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(206648,5741,'sr','Ð¢ÐµÑˆÐºÐ¾ ÐŸÑ€Ð¸Ð½Ñ‚',0),(206649,5741,'vi','KhÃ³ In',0),(206650,5741,'af','Moeilik druk',0),(206651,5741,'ro','Dificil de imprimare',0),(206652,5741,'et','Raske printimine',0),(206653,5741,'si','TeÅ¾ko Print',0),(206654,5741,'ba','Sulit cetak',0),(206655,5741,'nl','Moeilijk afdrukken',0),(206656,5741,'fi','Vaikea tulosta',0),(206657,5741,'no','Vanskelig ut',0),(206658,5741,'da','Vanskeligt Print',0),(206659,5741,'ko','ì–´ë ¤ìš´ ì¸ì‡„',0),(206660,5741,'he','× ×§×•×“×” ×ž×¡×•×‘×›×ª',0),(206661,5741,'el','Î”ÏÏƒÎºÎ¿Î»Î¿ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(206662,5741,'zh','æ‰“å°å›°éš¾\r\n',0),(206663,5741,'sv','SvÃ¥rt Print',0),(206664,5741,'it','Stampa difficile',0),(206665,5741,'tl','',0),(206666,5741,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3618;&#3634;&#3585;',0),(206667,5741,'hi','à¤®à¥à¤¶à¥à¤•à¤¿à¤² à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(206668,5741,'ms','Cetak sukar',0),(206669,5741,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ØµØ¹Ø¨Ø©',0),(206670,5741,'fr','Print difficile',0),(206671,5741,'jp','å›°é›£ã?ªå?°åˆ·',0),(206672,5741,'pt','DifÃ­cil imprimir',0),(206673,5741,'ru','Ð¡Ð»Ð¾Ð¶Ð½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(206674,5741,'es','ImpresiÃ³n DifÃ­cil',0),(206675,5741,'de','Schwer drucken',0),(206676,5741,'en','Difficult Print',0),(206677,5742,'is','',0),(206678,5742,'dr','Ú†Ø§Ù¾ Ø¢Ø³Ø§Ù† ',0),(206679,5742,'pr','Ú†Ø§Ù¾ Ø¢Ø³Ø§Ù† ',0),(206680,5742,'tr','Kolay yazdÄ±rma',0),(206681,5742,'pl','Åatwe drukowanie',0),(206682,5742,'bg','Ð›ÐµÑÐµÐ½ Ð¿ÐµÑ‡Ð°Ñ‚',0),(206683,5742,'ur','Ø¢Ø³Ø§Ù† Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(206684,5742,'sr','Ð›Ð°ÐºÐ¾ ÐŸÑ€Ð¸Ð½Ñ‚',0),(206685,5742,'vi','In Dá»…',0),(206686,5742,'af','Maklik druk',0),(206687,5742,'ro','UÅŸor de imprimare',0),(206688,5742,'et','Easy Print.',0),(206689,5742,'si','Preprosto tiskanje',0),(206690,5742,'ba','Cetak mudah',0),(206691,5742,'nl','Easy Print',0),(206692,5742,'fi','Helppo kirjoittaa',0),(206693,5742,'no','Easy Print',0),(206694,5742,'da','Easy Print',0),(206695,5742,'ko','ì‰½ê²Œ ì¸ì‡„',0),(206696,5742,'he','Easy Print',0),(206697,5742,'el','Î•ÏÎºÎ¿Î»Î· ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(206698,5742,'zh','è½»æ¾æ‰“å°\r\n',0),(206699,5742,'sv','Easy Print',0),(206700,5742,'it','Easy Print',0),(206701,5742,'tl','',0),(206702,5742,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3591;&#3656;&#3634;&#3618;',0),(206703,5742,'hi','à¤†à¤¸à¤¾à¤¨ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(206704,5742,'ms','Mudah cetak',0),(206705,5742,'ar','Ø³Ù‡Ù„ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(206706,5742,'fr','Easy Print',0),(206707,5742,'jp','å®¹æ˜“ã?ªå?°åˆ·',0),(206708,5742,'pt','Easy Print',0),(206709,5742,'ru','Ð›ÐµÐ³ÐºÐ°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(206710,5742,'es','ImpresiÃ³n FÃ¡cil',0),(206711,5742,'de','Easy Print',0),(206712,5742,'en','Easy Print',0),(206713,5743,'is','',0),(206714,5743,'dr','Ú†Ø§Ù¾ Ù†Ø±Ù…Ø§Ù„',0),(206715,5743,'pr','Ú†Ø§Ù¾ Ù†Ø±Ù…Ø§Ù„',0),(206716,5743,'tr','Normal yazdÄ±rma',0),(206717,5743,'pl','Normalny druk',0),(206718,5743,'bg','ÐÐ¾Ñ€Ð¼Ð°Ð»Ð½Ð° Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(206719,5743,'ur','Ø¹Ø§Ù… Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(206720,5743,'sr','ÐÐ¾Ñ€Ð¼Ð°Ð»Ð°Ð½ ÐŸÑ€Ð¸Ð½Ñ‚',0),(206721,5743,'vi','In BÃ¬nh thÆ°á»ng ',0),(206722,5743,'af','Druk Normaalweg',0),(206723,5743,'ro','Normale de imprimare',0),(206724,5743,'et','Normaalset',0),(206725,5743,'si','Normalni tisk',0),(206726,5743,'ba','Cetak normal',0),(206727,5743,'nl','Normaal afdrukken',0),(206728,5743,'fi','Normaali tulostus',0),(206729,5743,'no','Normal ut',0),(206730,5743,'da','Normal Print',0),(206731,5743,'ko','ì¼ë°˜ ì¸ì‡„',0),(206732,5743,'he','×”×“×¤×¡×” ×¨×’×™×œ×”',0),(206733,5743,'el','ÎšÎ±Î½Î¿Î½Î¹ÎºÎ® ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(206734,5743,'zh','æ­£å¸¸æ‰“å°\r\n',0),(206735,5743,'sv','Normal utskrift',0),(206736,5743,'it','Stampa normale',0),(206737,5743,'tl','',0),(206738,5743,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3611;&#3585;&#3605;&#3636;',0),(206739,5743,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤®à¥à¤¦à¥à¤°à¤£',0),(206740,5743,'ms','Cetakan biasa',0),(206741,5743,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¹Ø§Ø¯ÙŠØ©',0),(206742,5743,'fr','Impression normale',0),(206743,5743,'jp','é€šå¸¸å?°åˆ·',0),(206744,5743,'pt','ImpressÃ£o normal',0),(206745,5743,'ru','ÐÐ¾Ñ€Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(206746,5743,'es','ImpresiÃ³n Normal',0),(206747,5743,'de','Normal Drucken',0),(206748,5743,'en','Normal Print',0),(206749,5744,'is','',0),(206750,5744,'dr','Ù†ÙˆØ¹ Ø¬Ù‡Øª Ú¯ÙŠØ±ÙŠ',0),(206751,5744,'pr','Ù†ÙˆØ¹ Ø¬Ù‡Øª Ú¯ÙŠØ±ÙŠ',0),(206752,5744,'tr','Oryantasyon tÃ¼rÃ¼',0),(206753,5744,'pl','Typ orientacji',0),(206754,5744,'bg','ÐžÑ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ Ñ‚Ð¸Ð¿',0),(206755,5744,'ur','Ø³Ù…Øª Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(206756,5744,'sr','ÐžÑ€Ð¸Ñ˜ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ˜Ð° Ñ‚Ð¸Ð¿Ð°',0),(206757,5744,'vi','Loáº¡i PhÆ°Æ¡ng Ä‘Ã´ng',0),(206758,5744,'af','OriÃ«ntasie tipe',0),(206759,5744,'ro','Orientarea tip',0),(206760,5744,'et','Paigutus tÃ¼Ã¼p',0),(206761,5744,'si','Vrsta usmerjenost',0),(206762,5744,'ba','Jenis orientasi',0),(206763,5744,'nl','Afdrukstand Type',0),(206764,5744,'fi','Suunta tyyppi',0),(206765,5744,'no','Orientering Type',0),(206766,5744,'da','Orientering Type',0),(206767,5744,'ko','ë°©í–¥ í˜•ì‹',0),(206768,5744,'he','×”×ª×ž×¦××•×ª ×¡×•×’',0),(206769,5744,'el','Î ÏÎ¿ÏƒÎ±Î½Î±Ï„Î¿Î»Î¹ÏƒÎ¼ÏŒÏ‚ Ï„ÏÏ€Î¿Ï…',0),(206770,5744,'zh','å®šä½ç±»åž‹\r\n',0),(206771,5744,'sv','Orientering typ',0),(206772,5744,'it','Tipo di orientamento',0),(206773,5744,'tl','',0),(206774,5744,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;',0),(206775,5744,'hi','à¤“à¤°à¤¿à¤à¤‚à¤Ÿà¥‡à¤¶à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(206776,5744,'ms','Jenis orientasi',0),(206777,5744,'ar','Ù†ÙˆØ¹ Ø§Ù„ØªÙˆØ¬Ù‡',0),(206778,5744,'fr','Type d\'orientation',0),(206779,5744,'jp','ã‚ªãƒªã‚¨ãƒ³ãƒ†ãƒ¼ã‚·ãƒ§ãƒ³ã‚¿ã‚¤ãƒ—',0),(206780,5744,'pt','Tipo de orientaÃ§Ã£o',0),(206781,5744,'ru','Ð¢Ð¸Ð¿ Ð¾Ñ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ð¸',0),(206782,5744,'es','Tipo de OrientaciÃ³n',0),(206783,5744,'de','Orientierung-Typ',0),(206784,5744,'en','Orientation Type',0),(206785,5745,'is','',0),(206786,5745,'dr','Ø§Ù†ÙˆØ§Ø¹ Ø¬Ù‡Øª Ú¯ÙŠØ±ÙŠ',0),(206787,5745,'pr','Ø§Ù†ÙˆØ§Ø¹ Ø¬Ù‡Øª Ú¯ÙŠØ±ÙŠ',0),(206788,5745,'tr','Oryantasyon tÃ¼rleri',0),(206789,5745,'pl','Typy orientacji',0),(206790,5745,'bg','ÐžÑ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(206791,5745,'ur','Ø³Ù…Øª Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(206792,5745,'sr','ÐŸÐ¾Ð»Ð¾Ð¶Ð°Ñ˜ Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸',0),(206793,5745,'vi','Loáº¡i PhÆ°Æ¡ng Ä‘Ã´ng',0),(206794,5745,'af','OriÃ«ntasie tipes',0),(206795,5745,'ro','Tipuri de orientare',0),(206796,5745,'et','Orientatsiooni tÃ¼Ã¼bid',0),(206797,5745,'si','Usmerjenost vrste',0),(206798,5745,'ba','Jenis orientasi',0),(206799,5745,'nl','Afdrukstand typen',0),(206800,5745,'fi','Suunta eri',0),(206801,5745,'no','Orientering typer',0),(206802,5745,'da','Orientering typer',0),(206803,5745,'ko','ë°©í–¥ í˜•ì‹',0),(206804,5745,'he','×”×ª×ž×¦××•×ª ×¡×•×’×™×',0),(206805,5745,'el','Î¤ÏÏ€Î¿Î¹ Ï€ÏÎ¿ÏƒÎ±Î½Î±Ï„Î¿Î»Î¹ÏƒÎ¼ÏŒ',0),(206806,5745,'zh','å®šä½ç±»åž‹\r\n',0),(206807,5745,'sv','Orientering typer',0),(206808,5745,'it','Tipi di orientamento',0),(206809,5745,'tl','',0),(206810,5745,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;',0),(206811,5745,'hi','à¤“à¤°à¤¿à¤à¤‚à¤Ÿà¥‡à¤¶à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(206812,5745,'ms','Jenis-jenis orientasi',0),(206813,5745,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ù…ÙŠÙ„',0),(206814,5745,'fr','Types d\'orientation',0),(206815,5745,'jp','ã‚ªãƒªã‚¨ãƒ³ãƒ†ãƒ¼ã‚·ãƒ§ãƒ³ã‚¿ã‚¤ãƒ—',0),(206816,5745,'pt','Tipos de orientaÃ§Ã£o',0),(206817,5745,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð¾Ñ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ð¸',0),(206818,5745,'es','Tipos de OrientaciÃ³n',0),(206819,5745,'de','Orientierung-Typen',0),(206820,5745,'en','Orientation Types',0),(206821,5746,'is','',0),(206822,5746,'dr','Ø«Ø¨Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(206823,5746,'pr','Ø«Ø¨Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(206824,5746,'tr','Girdi zaten var',0),(206825,5746,'pl','JuÅ¼ istnieje wpis',0),(206826,5746,'bg','Ð’ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(206827,5746,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(206828,5746,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(206829,5746,'vi','Entry Ä‘Ã£ tá»“n táº¡i',0),(206830,5746,'af','Inskrywing Bestaan Alreeds',0),(206831,5746,'ro','Intrare existÄƒ deja',0),(206832,5746,'et','On juba olemas',0),(206833,5746,'si','Vnos Å¾e obstaja',0),(206834,5746,'ba','Entri yang sudah ada',0),(206835,5746,'nl','Vermelding die bestaat al',0),(206836,5746,'fi','Jo olemassa',0),(206837,5746,'no','OppfÃ¸ringen finnes allerede',0),(206838,5746,'da','Posten findes allerede',0),(206839,5746,'ko','í•­ëª©ì´ ì´ë¯¸ ìžˆìœ¼ë©´',0),(206840,5746,'he','×§×™×™× ×›×‘×¨ ×¢×¨×š',0),(206841,5746,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(206842,5746,'zh','æ¡ç›®å·²å­˜åœ¨',0),(206843,5746,'sv','Posten finns redan',0),(206844,5746,'it','Esiste giÃ  la voce',0),(206845,5746,'tl','',0),(206846,5746,'th','&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(206847,5746,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(206848,5746,'ms','Sudah wujud',0),(206849,5746,'ar','Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹',0),(206850,5746,'fr','EntrÃ©e existe dÃ©jÃ ',0),(206851,5746,'jp','ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?Œæ—¢ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(206852,5746,'pt','Entrada jÃ¡ existe.',0),(206853,5746,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(206854,5746,'es','Entrada Ya Existe',0),(206855,5746,'de','Eintrag ist bereits vorhanden',0),(206856,5746,'en','Entry Already Exists',0),(206857,5747,'is','',0),(206858,5747,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª',0),(206859,5747,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª',0),(206860,5747,'tr','Hata giriÅŸi ekleme',0),(206861,5747,'pl','BÅ‚Ä…d dodawania wpisu',0),(206862,5747,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(206863,5747,'ur','Ù†Ù‚Øµ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(206864,5747,'sr','Ð“Ñ€ÐµÑˆÐºÐµ Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ ÑÑ‚Ð°Ð²ÐºÐ°',0),(206865,5747,'vi','CÃ³ Lá»—i Khi ThÃªm Entry',0),(206866,5747,'af','Fout met Byvoeging van Inskrywing',0),(206867,5747,'ro','Eroare adÄƒugarea de intrare',0),(206868,5747,'et','Viga lisades kanne',0),(206869,5747,'si','Napaka dodal vnos',0),(206870,5747,'ba','Kesalahan menambahkan entri',0),(206871,5747,'nl','Fout toe te voegen vermelding',0),(206872,5747,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ merkintÃ¤',0),(206873,5747,'no','Legge feilpost',0),(206874,5747,'da','Fejl tilfÃ¸je posten',0),(206875,5747,'ko','ì˜¤ë¥˜ ì¶”ê°€ í•­ëª©',0),(206876,5747,'he','×©×’×™××” ×”×•×¡×¤×ª ×¢×¨×š',0),(206877,5747,'el','Î›Î¬Î¸Î¿Ï‚ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(206878,5747,'zh','é”™è¯¯ï¼šæ–°å¢žæ¡ç›®',0),(206879,5747,'sv','Fel att lÃ¤gga till posten',0),(206880,5747,'it','Errore aggiunta voce',0),(206881,5747,'tl','',0),(206882,5747,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(206883,5747,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(206884,5747,'ms','Ralat menambah kemasukan',0),(206885,5747,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(206886,5747,'fr','Erreur ajout d\'entrÃ©e',0),(206887,5747,'jp','ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(206888,5747,'pt','Erro adicionando a entrada',0),(206889,5747,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(206890,5747,'es','Error Agregando Entrada',0),(206891,5747,'de','HinzufÃ¼gen von Fehlereintrag',0),(206892,5747,'en','Error Adding Entry',0),(206893,5748,'is','',0),(206894,5748,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø¬Ù‡Øª Ú¯ÙŠØ±ÙŠ',0),(206895,5748,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø¬Ù‡Øª Ú¯ÙŠØ±ÙŠ',0),(206896,5748,'tr','Oryantasyon tÃ¼rÃ¼ Ekle',0),(206897,5748,'pl','Typ orientacji dodaÄ‡',0),(206898,5748,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð¾Ñ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ',0),(206899,5748,'ur','Ø³Ù…Øª Ø¨Ù†Ø¯ÛŒ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(206900,5748,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ‚Ð¸Ð¿Ð° Ð¾Ñ€Ð¸Ñ˜ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ˜Ðµ',0),(206901,5748,'vi','ThÃªm Loáº¡i PhÆ°Æ¡ng Ä‘Ã´ng',0),(206902,5748,'af','OriÃ«ntasie tipe voeg',0),(206903,5748,'ro','Adauga orientarea tip',0),(206904,5748,'et','Paigutus tÃ¼Ã¼p lisamine',0),(206905,5748,'si','Vrsta usmerjenost dodati',0),(206906,5748,'ba','Menambahkan jenis orientasi',0),(206907,5748,'nl','Afdrukstand Type toevoegen',0),(206908,5748,'fi','Suunta lisÃ¤Ã¤',0),(206909,5748,'no','Retning du legge til',0),(206910,5748,'da','Orientering Type tilfÃ¸je',0),(206911,5748,'ko','ë°©í–¥ í˜•ì‹ ì¶”ê°€',0),(206912,5748,'he','×”×ª×ž×¦××•×ª ×”×§×œ×“ ×”×•×¡×¤×ª',0),(206913,5748,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„ÏÏ€Î¿Ï… Ï€ÏÎ¿ÏƒÎ±Î½Î±Ï„Î¿Î»Î¹ÏƒÎ¼ÏŒ',0),(206914,5748,'zh','å®šä½ç±»åž‹æ·»åŠ \r\n',0),(206915,5748,'sv','Orientering typ lÃ¤gga till',0),(206916,5748,'it','Aggiungi tipo di orientamento',0),(206917,5748,'tl','',0),(206918,5748,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;',0),(206919,5748,'hi','à¤“à¤°à¤¿à¤à¤‚à¤Ÿà¥‡à¤¶à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(206920,5748,'ms','Tambah jenis orientasi',0),(206921,5748,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„ØªÙˆØ¬Ù‡',0),(206922,5748,'fr','Ajouter Type d\'orientation',0),(206923,5748,'jp','ã‚ªãƒªã‚¨ãƒ³ãƒ†ãƒ¼ã‚·ãƒ§ãƒ³ã‚¿ã‚¤ãƒ—ã?®è¿½åŠ ',0),(206924,5748,'pt','Adicionar o tipo de orientaÃ§Ã£o',0),(206925,5748,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð¾Ñ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ð¸',0),(206926,5748,'es','Agregar Tipo de OrientaciÃ³n',0),(206927,5748,'de','Orientierung-Typ hinzufÃ¼gen',0),(206928,5748,'en','Orientation Type Add',0),(206929,5749,'is','',0),(206930,5749,'dr','-Ù„ÙŠØ³Øª Ø¬Ù‡ØªÚ¯ÙŠØ±ÙŠ',0),(206931,5749,'pr','Ú†Ø§Ù¾ Ù†ÙˆØ¹ Ø¬Ù‡ØªÚ¯ÙŠØ±ÙŠ-Ù„ÙŠØ³Øª Ø¬Ù‡ØªÚ¯ÙŠØ±ÙŠ',0),(206932,5749,'tr','YÃ¶nlendirme listesi',0),(206933,5749,'pl','Lista orientacji',0),(206934,5749,'bg','ÐžÑ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ ÑÐ¿Ð¸ÑÑŠÐº',0),(206935,5749,'ur','Ø³Ù…Øª Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(206936,5749,'sr','ÐŸÐ¾Ð»Ð¾Ð¶Ð°Ñ˜ Ð»Ð¸ÑÑ‚Ð°',0),(206937,5749,'vi','Danh sÃ¡ch Ä‘á»‹nh hÆ°á»›ng',0),(206938,5749,'af','Orientasielys',0),(206939,5749,'ro','Lista de orientare',0),(206940,5749,'et','Loendis paigutus',0),(206941,5749,'si','Seznam usmerjenost',0),(206942,5749,'ba','Daftar orientasi',0),(206943,5749,'nl','Lijst Afdrukstand',0),(206944,5749,'fi','Suuntautumiseen luettelo',0),(206945,5749,'no','Retning-listen',0),(206946,5749,'da','Orientering listen',0),(206947,5749,'ko','ë°©í–¥ ëª©ë¡',0),(206948,5749,'he','×”×ª×ž×¦××•×ª ×¨×©×™×ž×”',0),(206949,5749,'el','Î›Î¯ÏƒÏ„Î± Î ÏÎ¿ÏƒÎ±Î½Î±Ï„Î¿Î»Î¹ÏƒÎ¼ÏŒÏ‚',0),(206950,5749,'zh','å®šä½åˆ—è¡¨\r\n',0),(206951,5749,'sv','Orientering lista',0),(206952,5749,'it','Lista di orientamento',0),(206953,5749,'tl','',0),(206954,5749,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;',0),(206955,5749,'hi','à¤“à¤°à¤¿à¤à¤‚à¤Ÿà¥‡à¤¶à¤¨ à¤¸à¥‚à¤šà¥€',0),(206956,5749,'ms','Senarai orientasi',0),(206957,5749,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ù„ØªÙˆØ¬Ù‡',0),(206958,5749,'fr','Liste d\'orientation',0),(206959,5749,'jp','ã‚ªãƒªã‚¨ãƒ³ãƒ†ãƒ¼ã‚·ãƒ§ãƒ³ãƒªã‚¹ãƒˆ',0),(206960,5749,'pt','Lista de orientaÃ§Ã£o',0),(206961,5749,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¾Ñ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ð¸',0),(206962,5749,'es','Lista de OrientaciÃ³n',0),(206963,5749,'de','Orientierung-Liste',0),(206964,5749,'en','Orientation List',0),(206965,5750,'is','',0),(206966,5750,'dr','Ú†Ø§Ù¾ Ø§Ù†ÙˆØ§Ø¹ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ÙƒØ§Ø± ',0),(206967,5750,'pr','Ú†Ø§Ù¾ Ø§Ù†ÙˆØ§Ø¹ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ÙƒØ§Ø± ',0),(206968,5750,'tr','Standart Ã§alÄ±ÅŸma tÃ¼rleri',0),(206969,5750,'pl','Typy standardowych prac',0),(206970,5750,'bg','Ð’Ð¸Ð´Ð¾Ð²Ðµ Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(206971,5750,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ú©Ø§Ù… Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(206972,5750,'sr','Ð’Ñ€ÑÑ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸Ñ… Ñ€Ð°Ð´Ð°',0),(206973,5750,'vi','Loáº¡i cÃ´ng viá»‡c chuáº©n',0),(206974,5750,'af','Standaard Werkstipes',0),(206975,5750,'ro','Tipuri standard de lucru',0),(206976,5750,'et','Standard tÃ¶Ã¶liigid',0),(206977,5750,'si','Standardno delo vrste',0),(206978,5750,'ba','Jenis standar kerja',0),(206979,5750,'nl','Standaard werksoorten',0),(206980,5750,'fi','Standard tyÃ¶tyypit',0),(206981,5750,'no','Standard arbeidstyper',0),(206982,5750,'da','Standard arbejdstyper',0),(206983,5750,'ko','í‘œì¤€ ìž‘ì—… í˜•ì‹',0),(206984,5750,'he','×¡×•×’×™ ×¢×‘×•×“×” ×¨×’×™×œ',0),(206985,5750,'el','Î¤Ï…Ï€Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î· ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï…Ï‚',0),(206986,5750,'zh','æ ‡å‡†å·¥ä½œç±»åž‹\r\n',0),(206987,5750,'sv','Standard arbetstyper',0),(206988,5750,'it','Tipi di lavoro standard',0),(206989,5750,'tl','',0),(206990,5750,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(206991,5750,'hi','à¤®à¤¾à¤¨à¤• à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤°',0),(206992,5750,'ms','Jenis-jenis kerja-kerja piawai',0),(206993,5750,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(206994,5750,'fr','Types de travail standard',0),(206995,5750,'jp','æ¨™æº–ä»•äº‹å†…å®¹',0),(206996,5750,'pt','Tipos de trabalho padrÃ£o',0),(206997,5750,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ Ð¢Ð¸Ð¿Ñ‹ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(206998,5750,'es','Tipos de Trabajo Estandares',0),(206999,5750,'de','Standardwerk-Typen',0),(207000,5750,'en','Standard Work Types',0),(207001,5751,'is','',0),(207002,5751,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§Ù†ÙˆØ§Ø¹ Ø¬Ù‡Øª Ú¯ÙŠØ±ÙŠ Ù‡Ø§',0),(207003,5751,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§Ù†ÙˆØ§Ø¹ Ø¬Ù‡Øª Ú¯ÙŠØ±ÙŠ Ù‡Ø§',0),(207004,5751,'tr','Kurulum oryantasyon tÃ¼rleri',0),(207005,5751,'pl','Typy orientacji instalacji',0),(207006,5751,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¾Ñ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸ÑÑ‚Ð° Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(207007,5751,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ø³Ù…Øª Ø¨Ù†Ø¯ÛŒ Ú©Û’ Ø§Ù‚Ø³Ø§Ù…',0),(207008,5751,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¿Ð¾Ð»Ð¾Ð¶Ð°Ñ˜Ð° Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸',0),(207009,5751,'vi','Setup loáº¡i Ä‘á»‹nh hÆ°á»›ng',0),(207010,5751,'af','Opstelling oriÃ«ntasie tipes',0),(207011,5751,'ro','Configurare tipuri de orientare',0),(207012,5751,'et','Setup orientatsiooni tÃ¼Ã¼bid',0),(207013,5751,'si','Nastavitev usmerjenosti vrste',0),(207014,5751,'ba','Pengaturan orientasi jenis',0),(207015,5751,'nl','Setup oriÃ«ntatie typen',0),(207016,5751,'fi','Suunta tiedostotyypit',0),(207017,5751,'no','Installasjonsprogrammet orientering typer',0),(207018,5751,'da','Setup orientering typer',0),(207019,5751,'ko','ì„¤ì¹˜ ë°©í–¥ í˜•ì‹',0),(207020,5751,'he','×¡×•×’×™ ×”×ª×ž×¦××•×ª ×›×™×•×•× ×•×Ÿ',0),(207021,5751,'el','Î¤ÏÏ€Î¿Î¹ Ï€ÏÎ¿ÏƒÎ±Î½Î±Ï„Î¿Î»Î¹ÏƒÎ¼Î¿Ï ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(207022,5751,'zh','å®‰è£…å®šä½ç±»åž‹\r\n',0),(207023,5751,'sv','Setup orientering typer',0),(207024,5751,'it','Tipi di installazione orientamento',0),(207025,5751,'tl','',0),(207026,5751,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;',0),(207027,5751,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤“à¤°à¤¿à¤à¤‚à¤Ÿà¥‡à¤¶à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(207028,5751,'ms','Persediaan orientasi jenis',0),(207029,5751,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„ØªÙˆØ¬Ù‡',0),(207030,5751,'fr','Configurer les Types d\'Orientation',0),(207031,5751,'jp','ã‚ªãƒªã‚¨ãƒ³ãƒ†ãƒ¼ã‚·ãƒ§ãƒ³ã‚¿ã‚¤ãƒ—ã?®è¨­å®š',0),(207032,5751,'pt','Tipos de orientaÃ§Ã£o de instalaÃ§Ã£o',0),(207033,5751,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð¾Ñ€Ð¸ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(207034,5751,'es','Configurar Tipos de OrientaciÃ³n',0),(207035,5751,'de','Arten von Setup-Orientierung',0),(207036,5751,'en','Setup Orientation Types',0),(207037,5752,'is','',0),(207038,5752,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾ Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  ',0),(207039,5752,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú†Ø§Ù¾ Ø§Ù†ÙˆØ§Ø¹ ÙƒØ§Ø± Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  ',0),(207040,5752,'tr','Standart iÅŸ tÃ¼rlerini Kur',0),(207041,5752,'pl','Ustawienie Standard pracy typÃ³w',0),(207042,5752,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð²Ð¸Ð´Ð¾Ð²Ðµ Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(207043,5752,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ú©Ø§Ù… Ø§Ù‚Ø³Ø§Ù… Ø³ÛŒÙ¹ Ø§Ù¾',0),(207044,5752,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð²Ñ€ÑÑ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸Ñ… Ñ€Ð°Ð´Ð°',0),(207045,5752,'vi','Setup loáº¡i cÃ´ng viá»‡c chuáº©n',0),(207046,5752,'af','Opstelling van Standaard Werk Tipes',0),(207047,5752,'ro','Configurare tipuri Standard de lucru',0),(207048,5752,'et','Setup ÏŒhtse tÃ¼Ã¼bid',0),(207049,5752,'si','Setup standardno delo vrste',0),(207050,5752,'ba','Setup jenis standar kerja',0),(207051,5752,'nl','Setup standaard werksoorten',0),(207052,5752,'fi','Asennus Standard tyÃ¶tyypit',0),(207053,5752,'no','Sette Standard arbeidstyper',0),(207054,5752,'da','OpsÃ¦tning af Standard arbejdstyper',0),(207055,5752,'ko','í‘œì¤€ ìž‘ì—… ì¢…ë¥˜ ì„¤ì •',0),(207056,5752,'he','×”×’×“×¨×ª ×¡×•×’×™ ×¢×‘×•×“×” ×¨×’×™×œ',0),(207057,5752,'el','Î£Ï„Î®ÏƒÎµÏ„Îµ Ï„Ï…Ï€Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î· ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï…Ï‚',0),(207058,5752,'zh','è®¾ç½®æ ‡å‡†å·¥ä½œç±»åž‹\r\n',0),(207059,5752,'sv','StÃ¤lla in Standard arbetstyper',0),(207060,5752,'it','Configurare i tipi di lavoro Standard',0),(207061,5752,'tl','',0),(207062,5752,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(207063,5752,'hi','à¤®à¤¾à¤¨à¤• à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(207064,5752,'ms','Persediaan jenis kerja-kerja piawai',0),(207065,5752,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(207066,5752,'fr','Configurer les Types de travail Standard',0),(207067,5752,'jp','æ¨™æº–ä»•äº‹å†…å®¹ã?®è¨­å®š',0),(207068,5752,'pt','ConfiguraÃ§Ã£o de tipos de trabalho padrÃ£o',0),(207069,5752,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ Ð¢Ð¸Ð¿Ñ‹ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(207070,5752,'es','Configurar Tipos EstÃ¡ndares de Trabajo',0),(207071,5752,'de','Setup-Standardwerk Typen',0),(207072,5752,'en','Setup Standard Work Types',0),(207073,5753,'is','',0),(207074,5753,'dr','Ø³Ø§Ù„ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(207075,5753,'pr','Ø³Ø§Ù„ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(207076,5753,'tr','YTD',0),(207077,5753,'pl','od poczÄ…tku roku',0),(207078,5753,'bg','Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(207079,5753,'ur','ÛŒÙ¹Ø¯',0),(207080,5753,'sr','Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(207081,5753,'vi','Tá»•ng sá»‘ Ä‘áº§u nÄƒm Ä‘áº¿n nay',0),(207082,5753,'af','jtd',0),(207083,5753,'ro','ytd',0),(207084,5753,'et','Aasta algusest tÃ¤naseni',0),(207085,5753,'si','YTD',0),(207086,5753,'ba','YTD',0),(207087,5753,'nl','YTD',0),(207088,5753,'fi','vuoden alusta',0),(207089,5753,'no','hittil i Ã¥r',0),(207090,5753,'da','Ã…TD',0),(207091,5753,'ko','ytd',0),(207092,5753,'he','×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(207093,5753,'el','YTD',0),(207094,5753,'zh','å¹´åˆè‡³ä»Š\r\n',0),(207095,5753,'sv','YTD',0),(207096,5753,'it','YTD',0),(207097,5753,'tl','',0),(207098,5753,'th','ytd',0),(207099,5753,'hi','ytd',0),(207100,5753,'ms','THK',0),(207101,5753,'ar','Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(207102,5753,'fr','depuis un an',0),(207103,5753,'jp','å¹´é–“ç´¯ç©?',0),(207104,5753,'pt','acumulado no ano',0),(207105,5753,'ru','Ñ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð°',0),(207106,5753,'es','AÃ±o',0),(207107,5753,'de','YTD',0),(207108,5753,'en','YTD',0),(207109,5754,'is','',0),(207110,5754,'dr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ ØªØ±Ø®ÙŠØµ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(207111,5754,'pr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ ØªØ±Ø®ÙŠØµ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(207112,5754,'tr','Sevk irsaliyesi yayÄ±n tarihleri',0),(207113,5754,'pl','Daty wydania przesyÅ‚ki',0),(207114,5754,'bg','Ð˜Ð·Ð´Ð°Ð²Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð¸',0),(207115,5754,'ur','Ú©Ú¾ÛŒÙ¾ Ø±ÛØ§Ø¦ÛŒ ØªØ§Ø±ÛŒØ®ÛŒÚº',0),(207116,5754,'sr','Ð”Ð°Ñ‚ÑƒÐ¼Ð¸ Ð¸Ð·Ð´Ð°Ð²Ð°ÑšÐ° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(207117,5754,'vi','NgÃ y giao chuyáº¿n hÃ ng ',0),(207118,5754,'af','Besending Vrystellingsdatums',0),(207119,5754,'ro','Datele de lansare de expediere',0),(207120,5754,'et','Saadetise avaldamise kuupÃ¤evad',0),(207121,5754,'si','PoÅ¡iljki javnost datumi',0),(207122,5754,'ba','Pengiriman tanggal rilis',0),(207123,5754,'nl','Verzenddatums Release',0),(207124,5754,'fi','Toimituksen julkaisupÃ¤ivÃ¤t',0),(207125,5754,'no','Forsendelsen Release datoer',0),(207126,5754,'da','Forsendelse udgivelsesdatoer',0),(207127,5754,'ko','ì„ ì  ì¶œì‹œ ë‚ ì§œ',0),(207128,5754,'he','×ª××¨×™×›×™ ×©×—×¨×•×¨ ×”×ž×©×œ×•×—',0),(207129,5754,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚ ÎºÏ…ÎºÎ»Î¿Ï†Î¿ÏÎ¯Î±Ï‚',0),(207130,5754,'zh','å‘è´§å‘å¸ƒæ—¥æœŸ\r\n',0),(207131,5754,'sv','Release utleveransdatum',0),(207132,5754,'it','Date di uscita della spedizione',0),(207133,5754,'tl','',0),(207134,5754,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(207135,5754,'hi','à¤²à¤¦à¤¾à¤¨ à¤°à¤¿à¤²à¥€à¤œ à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤',0),(207136,5754,'ms','Penghantaran siaran tarikh',0),(207137,5754,'ar','Ù…ÙˆØ§Ø¹ÙŠØ¯ Ø§Ù„Ø¥ÙØ±Ø§Ø¬ Ø¹Ù† Ø§Ù„Ø´Ø­Ù†Ø©',0),(207138,5754,'fr','Dates de sortie de livraison',0),(207139,5754,'jp','ç™ºé€?æ—¥',0),(207140,5754,'pt','Datas de lanÃ§amento da expediÃ§Ã£o',0),(207141,5754,'ru','Ð ÐµÐ»Ð¸Ð· Ð´Ð°Ñ‚Ñ‹ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(207142,5754,'es','Fechas de LiberaciÃ³n de EnvÃ­os ',0),(207143,5754,'de','Versand Release-Termine',0),(207144,5754,'en','Shipment Release Dates',0),(207145,5755,'is','',0),(207146,5755,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ¯Ø§Ù… Ù…Ù‚Ø¯Ø§Ø±',0),(207147,5755,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ¯Ø§Ù… Ù…Ù‚Ø¯Ø§Ø±',0),(207148,5755,'tr','Hangi miktar seÃ§in',0),(207149,5755,'pl','Wybierz ktÃ³ra iloÅ›Ä‡',0),(207150,5755,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(207151,5755,'ur','Ø¬Ù† Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(207152,5755,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ¾Ñ˜Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(207153,5755,'vi','Chá»n sá»‘ lÆ°á»£ng nÃ o',0),(207154,5755,'af','Kies watter hoeveelheid',0),(207155,5755,'ro','SelectaÅ£i cantitatea care',0),(207156,5755,'et','Vali milline kogus',0),(207157,5755,'si','Izberite katere koliÄina',0),(207158,5755,'ba','Pilih jumlah yang',0),(207159,5755,'nl','Selecteer welke hoeveelheid',0),(207160,5755,'fi','Valitse mikÃ¤ mÃ¤Ã¤rÃ¤',0),(207161,5755,'no','Velg hvilke antall',0),(207162,5755,'da','VÃ¦lg hvilken mÃ¦ngde',0),(207163,5755,'ko','ì–´ë–¤ ìˆ˜ëŸ‰ ì„ íƒ',0),(207164,5755,'he','×‘×—×¨ ××™×–×• ×›×ž×•×ª',0),(207165,5755,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€Î¿Î¹Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(207166,5755,'zh','é€‰æ‹©å“ªä¸ªæ•°é‡\r\n',0),(207167,5755,'sv','VÃ¤lj vilken kvantitet',0),(207168,5755,'it','Selezionare quale quantitÃ ',0),(207169,5755,'tl','',0),(207170,5755,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3629;&#3633;&#3609;&#3652;&#3627;&#3609;',0),(207171,5755,'hi','à¤•à¥Œà¤¨ à¤¸à¤¾ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(207172,5755,'ms','Pilih kuantiti yang',0),(207173,5755,'ar','Ø­Ø¯Ø¯ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ',0),(207174,5755,'fr','SÃ©lectionnez quelle quantitÃ©',0),(207175,5755,'jp','ã?©ã?®æ•°é‡?ã?‹ã‚’é?¸æŠž',0),(207176,5755,'pt','Selecione qual quantidade',0),(207177,5755,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐšÐ°ÐºÐ¾Ðµ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(207178,5755,'es','Seleccionar Cual Cantidad',0),(207179,5755,'de','WÃ¤hlen Sie die Menge',0),(207180,5755,'en','Select Which Quantity',0),(207181,5756,'is','',0),(207182,5756,'dr','Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø± Ø³ÙØ§Ø±Ø´ ',0),(207183,5756,'pr','Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø± Ø³ÙØ§Ø±Ø´ ',0),(207184,5756,'tr','SipariÅŸ yapmak',0),(207185,5756,'pl','Aby do zamÃ³wienia',0),(207186,5756,'bg','Ð”Ð° ÑÐµ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ Ð² Ñ€ÐµÐ´',0),(207187,5756,'ur','Ù…ÛŒÚº Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(207188,5756,'sr','ÐŸÑ€ÐµÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ð¸ Ñƒ Ð½Ð°Ð»Ð¾Ð³',0),(207189,5756,'vi','Chuyá»ƒn sang Ä‘áº·t hÃ ng',0),(207190,5756,'af','Maak in orde',0),(207191,5756,'ro','Pentru a face Ã®n ordinea',0),(207192,5756,'et','Teha tellimusse',0),(207193,5756,'si','Da bi v red',0),(207194,5756,'ba','Untuk membuat ke dalam urutan',0),(207195,5756,'nl','Om in orde te maken',0),(207196,5756,'fi','Jotta kuntoon',0),(207197,5756,'no','Ã… gjÃ¸re i orden',0),(207198,5756,'da','GÃ¸re til ordre',0),(207199,5756,'ko','ìˆœì„œì—',0),(207200,5756,'he','×›×“×™ ×œ×¢×©×•×ª ×¡×“×¨',0),(207201,5756,'el','ÎÎ± ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(207202,5756,'zh','ä½¿ä¹‹è¿›å…¥è®¢å•\r\n',0),(207203,5756,'sv','Att gÃ¶ra i ordning',0),(207204,5756,'it','Per fare in ordine',0),(207205,5756,'tl','',0),(207206,5756,'th','&#3606;&#3638;&#3591;&#3607;&#3635;&#3651;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(207207,5756,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(207208,5756,'ms','Untuk membuat ke dalam perintah',0),(207209,5756,'ar','Ù„Ø¬Ø¹Ù„ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(207210,5756,'fr','Pour faire dans l\'ordre',0),(207211,5756,'jp','æ³¨æ–‡ã?«ã?™ã‚‹ã?Ÿã‚?ã?«',0),(207212,5756,'pt','Para fazer em ordem',0),(207213,5756,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(207214,5756,'es','Para Hacer A Un Orden',0),(207215,5756,'de','Bestellung machen',0),(207216,5756,'en','To Make Into Order',0),(207217,5757,'is','',0),(207218,5757,'dr','0= Ø®ÙŠØ±)',0),(207219,5757,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ù‡Ø±Ù‡   0= Ø®ÙŠØ±)',0),(207220,5757,'tr','Åžarj faiz (0 = HayÄ±r)',0),(207221,5757,'pl','Naliczania odsetek (0 = nie)',0),(207222,5757,'bg','ÐÐ°Ñ‡Ð¸ÑÐ»ÑÐ²Ð° Ð»Ð¸Ñ…Ð²Ð° (0 = Ð½Ðµ)',0),(207223,5757,'ur','Ú†Ø§Ø±Ø¬ Ø³ÙˆØ¯ (0 = NO)',0),(207224,5757,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÑƒÑ˜Ðµ ÐºÐ°Ð¼Ð°Ñ‚Ñƒ (0 = Ð½Ðµ)',0),(207225,5757,'vi','TÃ­nh lÃ£i suáº¥t (0=NO)',0),(207226,5757,'af','Hef Rente (0=NEE)',0),(207227,5757,'ro','Percepe dobÃ¢nda (0 = nu)',0),(207228,5757,'et','KÃ¼si viivist (0=EI)',0),(207229,5757,'si','Obresti (0 = ne)',0),(207230,5757,'ba','Mengenakan bunga (0 = tidak ada)',0),(207231,5757,'nl','Rente in rekening brengen (0 = nee)',0),(207232,5757,'fi','Korkoja (0 = ei)',0),(207233,5757,'no','Beregne rente (0 = ingen)',0),(207234,5757,'da','OpkrÃ¦ve renter (0 = nej)',0),(207235,5757,'ko','ìš”ê¸ˆ ê´€ì‹¬ (0 = ì•„ë‹ˆì˜¤)',0),(207236,5757,'he','×’×•×‘×” ×”×¨×™×‘×™×ª (0 = ×œ×)',0),(207237,5757,'el','Î§ÏÎµÏŽÎ½Î¿Ï…Î½ Ï„Î¿Î½ Ï„ÏŒÎºÎ¿ (0 = ÏŒÏ‡Î¹)',0),(207238,5757,'zh','æ”¶å–åˆ©æ¯ï¼ˆ0=å¦ï¼‰\r\n',0),(207239,5757,'sv','Debitera rÃ¤nta (0 = Nej)',0),(207240,5757,'it','Carica di interesse (0 = NO)',0),(207241,5757,'tl','',0),(207242,5757,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618; (0=&#3652;&#3617;&#3656;)',0),(207243,5757,'hi','à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤¬à¥à¤¯à¤¾à¤œ (0 = à¤¨à¤¹à¥€à¤‚)',0),(207244,5757,'ms','Caj faedah (0 = tidak)',0),(207245,5757,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(207246,5757,'fr','Percevoir des intÃ©rÃªts (0 = non)',0),(207247,5757,'jp','åˆ©å­?ã?®è«‹æ±‚ï¼ˆï¼?=NO)',0),(207248,5757,'pt','Cobrar juros (0 = nÃ£o)',0),(207249,5757,'ru','ÐÐ°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð² (0 = Ð½ÐµÑ‚)',0),(207250,5757,'es','Cobrar InterÃ©ses (0=NO)',0),(207251,5757,'de','Zinsen berechnen (0 = Nein)',0),(207252,5757,'en','Charge Interest (0=NO)',0),(207253,5758,'is','',0),(207254,5758,'dr','Ø´Ø±Ø­ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª ',0),(207255,5758,'pr','Ø´Ø±Ø­ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª ',0),(207256,5758,'tr','VarsayÄ±lan fiyat<br>DÃ¼zey aÃ§Ä±klamasÄ±',0),(207257,5758,'pl','DomyÅ›lna cena<br>Opis poziomu',0),(207258,5758,'bg','Ð¦ÐµÐ½Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ<br>ÐÐ¸Ð²Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(207259,5758,'ur','Ø·Û’ Ø´Ø¯Û Ù‚ÛŒÙ…Øª<br>Ø³Ø·Ø­ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(207260,5758,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ñ†ÐµÐ½Ð°<br>ÐžÐ¿Ð¸Ñ Ð½Ð¸Ð²Ð¾Ð°',0),(207261,5758,'vi','MÃ´ táº£ má»©c Ä‘á»™ giÃ¡ máº·c Ä‘á»‹nh',0),(207262,5758,'af','Verstekte Prysvlak Beskrywing',0),(207263,5758,'ro','Implicit de preÅ£<br>Nivel Descriere',0),(207264,5758,'et','Vaike hind<br>Kirjeldus',0),(207265,5758,'si','Privzeti cenik<br>Ravni opis',0),(207266,5758,'ba','Standar harga<br>Level Deskripsi',0),(207267,5758,'nl','Standaard prijs<br>Beschrijving van het niveau',0),(207268,5758,'fi','Default hinta<br>Tason kuvaus',0),(207269,5758,'no','Standardpris<br>Beskrivelse',0),(207270,5758,'da','Standardpris<br>Niveau beskrivelse',0),(207271,5758,'ko','ê¸°ë³¸ ê°€ê²©<br>ë ˆë²¨ ì„¤ëª…',0),(207272,5758,'he','×ž×—×™×¨ ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ<br>×ª×™××•×¨ ×¨×ž×ª',0),(207273,5758,'el','Î¤Î¹Î¼Î® Î’Îœ<br>Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎµÏ€Î¹Ï€Î­Î´Î¿Ï…',0),(207274,5758,'zh','é¢„è®¾ä»·æ ¼å±‚æ¬¡çš„æè¿°\r\n',0),(207275,5758,'sv','Standard pris<br>Beskrivning nivÃ¥',0),(207276,5758,'it','Prezzo predefinito<br>Livello Descrizione',0),(207277,5758,'tl','',0),(207278,5758,'th','&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(207279,5758,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¥‚à¤²à¥à¤¯<br>à¤¸à¥à¤¤à¤°à¥€à¤¯ à¤µà¤¿à¤µà¤°à¤£',0),(207280,5758,'ms','Harga lalai<br>Peringkat penerangan',0),(207281,5758,'ar','Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ<br>ÙˆØµÙ Ù…Ø³ØªÙˆÙ‰',0),(207282,5758,'fr','Prix par dÃ©faut<br>Description des niveaux',0),(207283,5758,'jp','æ—¢å®šä¾¡æ ¼æ¨™æº–è§£èª¬',0),(207284,5758,'pt','PreÃ§o padrÃ£o<br>DescriÃ§Ã£o do nÃ­vel',0),(207285,5758,'ru','Ð¦ÐµÐ½Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ<br>ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑƒÑ€Ð¾Ð²Ð½Ñ',0),(207286,5758,'es','DescripciÃ³n de Nivel de Precios por Defecto',0),(207287,5758,'de','Standardpreis<br>Beschreibung',0),(207288,5758,'en','Default Price<br>Level Description',0),(207289,5759,'is','',0),(207290,5759,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ù…Ù„ Ø§Ø² Ø·Ø±ÙŠÙ‚ ',0),(207291,5759,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ù…Ù„ Ø§Ø² Ø·Ø±ÙŠÙ‚ ',0),(207292,5759,'tr','VarsayÄ±lan gemi yoluyla',0),(207293,5759,'pl','Statek domyÅ›lnie za pomocÄ…',0),(207294,5759,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ñ€Ð°Ð± Ñ‡Ñ€ÐµÐ·',0),(207295,5759,'ur','Ø·Û’ Ø´Ø¯Û Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(207296,5759,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð±Ñ€Ð¾Ð´ Ð¿Ñ€ÐµÐºÐ¾',0),(207297,5759,'vi','Váº­n chuyá»ƒn máº·c Ä‘á»‹nh qua',0),(207298,5759,'af','Verstekte Versending Via',0),(207299,5759,'ro','Implicit navei prin intermediul',0),(207300,5759,'et','Vaikimisi laeva kaudu',0),(207301,5759,'si','Privzeto ladja preko',0),(207302,5759,'ba','Default kapal melalui',0),(207303,5759,'nl','Standaard schip Via',0),(207304,5759,'fi','Oletuksena laiva kautta',0),(207305,5759,'no','Standard skip Via',0),(207306,5759,'da','Standard skib Via',0),(207307,5759,'ko','í†µí•´ ê¸°ë³¸ ë°°',0),(207308,5759,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×”×¡×¤×™× ×” ×“×¨×š',0),(207309,5759,'el','Î Î»Î¿Î¯Î¿Ï… Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î¼Î­ÏƒÏ‰',0),(207310,5759,'zh','é»˜è®¤è¿è¾“é€šè¿‡\r\n',0),(207311,5759,'sv','Standard fartyg Via',0),(207312,5759,'it','Nave predefinito tramite',0),(207313,5759,'tl','',0),(207314,5759,'th','&#3650;&#3604;&#3618;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;',0),(207315,5759,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤œà¤¹à¤¾à¤œ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(207316,5759,'ms','Lalai kapal melalui',0),(207317,5759,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ø¹Ù† Ø·Ø±ÙŠÙ‚',0),(207318,5759,'fr','ExpÃ©dier par dÃ©faut par',0),(207319,5759,'jp','æ—¢å®šç™ºé€?çµŒç”±',0),(207320,5759,'pt','Navio padrÃ£o atravÃ©s de',0),(207321,5759,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ñ‡ÐµÑ€ÐµÐ·',0),(207322,5759,'es','MÃ©todo de Transporte por Defecto Via',0),(207323,5759,'de','Standard-Schiff Ã¼ber',0),(207324,5759,'en','Default Ship Via',0),(207325,5760,'is','',0),(207326,5760,'dr','Ø´Ø±Ø­ Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ ',0),(207327,5760,'pr','Ø´Ø±Ø­ Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ ',0),(207328,5760,'tr','GL satÄ±ÅŸ hesabÄ± aÃ§Ä±klamasÄ±',0),(207329,5760,'pl','Opis konta sprzedaÅ¼y GL',0),(207330,5760,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(207331,5760,'ur','Ø¬ÛŒØ¬Û’ Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(207332,5760,'sr','ÐžÐ¿Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð›',0),(207333,5760,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Diá»…n Giáº£i Doanh Thu HÃ ng BÃ¡n',0),(207334,5760,'af','AG Verkope Rekening Beskrywing',0),(207335,5760,'ro','Descriere de vÃ¢nzÄƒri cont GL',0),(207336,5760,'et','GL mÃ¼Ã¼gikontole kirjeldus',0),(207337,5760,'si','Opis prodajne raÄun GL',0),(207338,5760,'ba','GL penjualan rekening',0),(207339,5760,'nl','GL omzetrekening beschrijving',0),(207340,5760,'fi','GL myynnin tilin kuvaus',0),(207341,5760,'no','GL salgskontoen beskrivelse',0),(207342,5760,'da','GL salgskontoen beskrivelse',0),(207343,5760,'ko','GL íŒë§¤ ê³„ì • ì„¤ëª…',0),(207344,5760,'he','×ª×™××•×¨ ×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª GL',0),(207345,5760,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ GL',0),(207346,5760,'zh','æ€»å¸é”€å”®å¸æˆ·è¯´æ˜Ž\r\n',0),(207347,5760,'sv','GL fÃ¶rsÃ¤ljningskontot Beskrivning',0),(207348,5760,'it','Descrizione conto vendita GL',0),(207349,5760,'tl','',0),(207350,5760,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(207351,5760,'hi','à¤œà¥€à¤à¤² à¤µà¤¿à¤•à¥à¤°à¤¯ à¤–à¤¾à¤¤à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(207352,5760,'ms','Keterangan akaun jualan GL',0),(207353,5760,'ar','Ø¨ÙŠØ§Ù† Ø­Ø³Ø§Ø¨ Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(207354,5760,'fr','Description de vente compte GL',0),(207355,5760,'jp','ï¼§ï¼¬è²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆè§£èª¬',0),(207356,5760,'pt','DescriÃ§Ã£o de contas de vendas de GL',0),(207357,5760,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ GL',0),(207358,5760,'es','LM DescripciÃ³n de Cuenta de Ventas',0),(207359,5760,'de','GL Verkaufskonto Beschreibung',0),(207360,5760,'en','GL Sales Account Description',0),(207361,5761,'is','',0),(207362,5761,'dr','Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(207363,5761,'pr','Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(207364,5761,'tr','SatÄ±cÄ± adÄ±',0),(207365,5761,'pl','Nazwa sprzedawcy',0),(207366,5761,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(207367,5761,'ur','Ø¨Ù†Ø§Ú©Ø± Ù†Ø§Ù…',0),(207368,5761,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ† Ð¸Ð¼Ðµ',0),(207369,5761,'vi','TÃªn NhÃ¢n viÃªn kinh doanh',0),(207370,5761,'af','Verkoopspersoon Naam',0),(207371,5761,'ro','Nume vanzator',0),(207372,5761,'et','MÃ¼Ã¼ja nimi',0),(207373,5761,'si','Prodajalec ime',0),(207374,5761,'ba','Nama Penjual',0),(207375,5761,'nl','Naam van de verkoper',0),(207376,5761,'fi','Myyntimies nimi',0),(207377,5761,'no','Selger navn',0),(207378,5761,'da','SÃ¦lger navn',0),(207379,5761,'ko','íŒë§¤ì› ì´ë¦„',0),(207380,5761,'he','×©× ××™×© ×ž×›×™×¨×•×ª',0),(207381,5761,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Ï€Ï‰Î»Î·Ï„Î®',0),(207382,5761,'zh','æŽ¨é”€å‘˜åå­—\r\n',0),(207383,5761,'sv','FÃ¶rsÃ¤ljaren namn',0),(207384,5761,'it','Nome del venditore',0),(207385,5761,'tl','',0),(207386,5761,'th','&#3594;&#3639;&#3656;&#3629;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(207387,5761,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¾à¤®',0),(207388,5761,'ms','Nama jurujual',0),(207389,5761,'ar','Ø§Ø³Ù… Ø¨Ø§Ø¦Ø¹',0),(207390,5761,'fr','Nom du vendeur',0),(207391,5761,'jp','ã‚»ãƒ¼ãƒ«ã‚¹æ‹…å½“è€…å??',0),(207392,5761,'pt','Nome do vendedor',0),(207393,5761,'ru','Ð˜Ð¼Ñ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(207394,5761,'es','Nombre de Vendedor',0),(207395,5761,'de','VerkÃ¤ufer Name',0),(207396,5761,'en','Salesman Name',0),(207397,5762,'is','',0),(207398,5762,'dr','Ù†Ø§Ù… Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(207399,5762,'pr','Ù†Ø§Ù… Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(207400,5762,'tr','SatÄ±ÅŸ vergisi adÄ±',0),(207401,5762,'pl','Nazwa podatku',0),(207402,5762,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(207403,5762,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©Ø§ Ù†Ø§Ù…',0),(207404,5762,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ñƒ Ð¸Ð¼Ðµ',0),(207405,5762,'vi','TÃªn thuáº¿ bÃ¡n hÃ ng',0),(207406,5762,'af','Verkoopsbelasting Naam',0),(207407,5762,'ro','Numele de impozitul pe vÃ¢nzÄƒri',0),(207408,5762,'et','KÃ¤ibemaksu nimi',0),(207409,5762,'si','Ime prodajnega davka',0),(207410,5762,'ba','Nama pajak penjualan',0),(207411,5762,'nl','Sales Tax naam',0),(207412,5762,'fi','ArvonlisÃ¤veron nimi',0),(207413,5762,'no','Mva-navn',0),(207414,5762,'da','Sales Tax navn',0),(207415,5762,'ko','íŒë§¤ì„¸ ì´ë¦„',0),(207416,5762,'he','×ž×¢ ×ž ×©×',0),(207417,5762,'el','ÎŒÎ½Î¿Î¼Î± Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(207418,5762,'zh','é”€å”®ç¨Žå\r\n',0),(207419,5762,'sv','Moms namn',0),(207420,5762,'it','Nome di IVA',0),(207421,5762,'tl','',0),(207422,5762,'th','&#3594;&#3639;&#3656;&#3629;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(207423,5762,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤•à¤¾ à¤¨à¤¾à¤®',0),(207424,5762,'ms','Nama cukai jualan',0),(207425,5762,'ar','Ø¥Ø³Ù… Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(207426,5762,'fr','Nom de la taxe de vente',0),(207427,5762,'jp','å£²ä¸Šç¨Žå??',0),(207428,5762,'pt','Nome de imposto sobre vendas',0),(207429,5762,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(207430,5762,'es','Nombre de IVA',0),(207431,5762,'de','Umsatzsteuer-Name',0),(207432,5762,'en','Sales Tax Name',0),(207433,5763,'is','',0),(207434,5763,'dr','Ù†Ø§Ù… Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(207435,5763,'pr','Ù†Ø§Ù… Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(207436,5763,'tr','Hizmet Rep adÄ±',0),(207437,5763,'pl','Nazwa usÅ‚ugi Rep',0),(207438,5763,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»',0),(207439,5763,'ur','Ù†Ø§Ù… Ø®Ø¯Ù…Øª Ø¬Ù…ÛÙˆØ±ÛŒÛ',0),(207440,5763,'sr','Ð˜Ð¼Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ‚ÐµÑ€Ð°',0),(207441,5763,'vi','TÃªn nhÃ¢n viÃªn phá»¥c vá»¥',0),(207442,5763,'af','Diens Verteenwoordiger Naam',0),(207443,5763,'ro','Numele de service Rep',0),(207444,5763,'et','Teenuse Rep nimi',0),(207445,5763,'si','Service Rep ime',0),(207446,5763,'ba','Service Rep nama',0),(207447,5763,'nl','Service Rep naam',0),(207448,5763,'fi','Asepalvelus ripsi nimi',0),(207449,5763,'no','Service Rep navn',0),(207450,5763,'da','Service Rep navn',0),(207451,5763,'ko','ì„œë¹„ìŠ¤ ë‹´ë‹¹ìž ì´ë¦„',0),(207452,5763,'he','×©× × ×¦×™×’ ×©×™×¨×•×ª',0),(207453,5763,'el','ÎŒÎ½Î¿Î¼Î± Ï…Ï†Î¬ÏƒÎ¼Î±Ï„ÏŒÏ‚ ÏƒÎ±Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±',0),(207454,5763,'zh','æœåŠ¡ä»£è¡¨å§“å\r\n',0),(207455,5763,'sv','TjÃ¤nst Rep namn',0),(207456,5763,'it','Nome servizio Rep',0),(207457,5763,'tl','',0),(207458,5763,'th','&#3594;&#3639;&#3656;&#3629;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(207459,5763,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(207460,5763,'ms','Nama wakil Perkhidmatan',0),(207461,5763,'ar','Ø¥Ø³Ù… Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ø®Ø¯Ù…Ø§Øª',0),(207462,5763,'fr','Nom du service Rep',0),(207463,5763,'jp','ã‚»ãƒ¼ãƒ“ã‚¹æ‹…å½“è€…å??',0),(207464,5763,'pt','Nome do representante de serviÃ§o',0),(207465,5763,'ru','Ð˜Ð¼Ñ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Rep',0),(207466,5763,'es','Nombre de Rep. de Servicio',0),(207467,5763,'de','Service Rep Name',0),(207468,5763,'en','Service Rep Name',0),(207469,5764,'is','',0),(207470,5764,'dr','_ Ù†Ø§Ù… ',0),(207471,5764,'pr','Ø­Ù…Ù„ Ø¨Ù‡ _ Ù†Ø§Ù… ',0),(207472,5764,'tr','Gemi iÃ§in ad',0),(207473,5764,'pl','ImiÄ™ odbiorcy',0),(207474,5764,'bg','Ð˜Ð¼Ðµ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(207475,5764,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ Ù¾ÛÙ„ÛŒ Ú©Ø§ Ù†Ø§Ù…',0),(207476,5764,'sr','ÐŸÑ€Ð²Ð¾ Ð¸Ð¼Ðµ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(207477,5764,'vi','Gá»­i Ä‘áº¿n: tÃªn ',0),(207478,5764,'af','Versend-Na Voornaam',0),(207479,5764,'ro','Livrare-la nume',0),(207480,5764,'et','Saaja eesnimi',0),(207481,5764,'si','Imena prve dobave',0),(207482,5764,'ba','Kapal ke nama pertama',0),(207483,5764,'nl','Verzendcode voornaam',0),(207484,5764,'fi','Toimitusasiakkaan etunimi',0),(207485,5764,'no','Lever til-navn',0),(207486,5764,'da','Skib-til fornavn',0),(207487,5764,'ko','ìš´ì†¡ì§€ ì´ë¦„',0),(207488,5764,'he','×”×©× ×”×¤×¨×˜×™ ×œ×ž×©×œ×•×—',0),(207489,5764,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ ÏŒÎ½Î¿Î¼Î±',0),(207490,5764,'zh','èˆ°å\r\n',0),(207491,5764,'sv','FÃ¶rsta leveransnamnet',0),(207492,5764,'it','Spedire a nome',0),(207493,5764,'tl','',0),(207494,5764,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3594;&#3639;&#3656;&#3629;',0),(207495,5764,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤®',0),(207496,5764,'ms','Kapal untuk nama pertama',0),(207497,5764,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„',0),(207498,5764,'fr','Destinataire prÃ©nom',0),(207499,5764,'jp','é…?é€?å…ˆå??å‰?',0),(207500,5764,'pt','Envio-a primeiro nome',0),(207501,5764,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð½Ð° Ð¸Ð¼Ñ',0),(207502,5764,'es','Enviar a Primer Nombre',0),(207503,5764,'de','Lieferadresse Vorname',0),(207504,5764,'en','Ship-to First Name',0),(207505,5765,'is','',0),(207506,5765,'dr','_Ø­Ù…Ù„ Ø¨Ù‡  _ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ',0),(207507,5765,'pr','_Ø­Ù…Ù„ Ø¨Ù‡  _ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ',0),(207508,5765,'tr','AdÄ± geÃ§en gÃ¶nderilecek',0),(207509,5765,'pl','Statek do nazwiska',0),(207510,5765,'bg','Ð¤Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(207511,5765,'ur','Ø¬ÛØ§Ø² Ú©Ùˆ Ø®Ø§Ù†Ø¯Ø§Ù†ÛŒ Ù†Ø§Ù…',0),(207512,5765,'sr','ÐŸÑ€ÐµÐ·Ð¸Ð¼Ðµ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(207513,5765,'vi','Gá»­i Ä‘áº¿n: há»',0),(207514,5765,'af','Versend-Na Van',0),(207515,5765,'ro','Livrare-la nume',0),(207516,5765,'et','Saaja perekonnanimi',0),(207517,5765,'si','Za dobavo priimek',0),(207518,5765,'ba','Kapal ke nama terakhir',0),(207519,5765,'nl','Verzendcode achternaam',0),(207520,5765,'fi','Toimitusasiakkaan sukunimi',0),(207521,5765,'no','Lever til-etternavn',0),(207522,5765,'da','Skib-til efternavn',0),(207523,5765,'ko','í•˜ ì„±',0),(207524,5765,'he','×œ×ž×©×œ×•×— ×©× ×ž×©×¤×—×”',0),(207525,5765,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ ÎµÏ€ÏŽÎ½Ï…Î¼Î¿',0),(207526,5765,'zh','èˆ°å¯¹å§“æ°\r\n',0),(207527,5765,'sv','Senaste Leveransnamn',0),(207528,5765,'it','Spedire a cognome',0),(207529,5765,'tl','',0),(207530,5765,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3609;&#3634;&#3617;&#3626;&#3585;&#3640;&#3621;',0),(207531,5765,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤®',0),(207532,5765,'ms','Kapal untuk nama',0),(207533,5765,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ø³Ù… Ø¢Ø®Ø±',0),(207534,5765,'fr','PrÃ©nom destinataire',0),(207535,5765,'jp','é…?é€?å…ˆå§“å??',0),(207536,5765,'pt','Envio-a sobrenome',0),(207537,5765,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ',0),(207538,5765,'es','Enviar a Apellido',0),(207539,5765,'de','Lieferadresse Nachnamen',0),(207540,5765,'en','Ship-to Last Name',0),(207541,5766,'is','',0),(207542,5766,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  Ø²ÙŠØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± Ø³ÙŠØ³ØªÙ… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ù†Ø¯ ',0),(207543,5766,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  Ø²ÙŠØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± Ø³ÙŠØ³ØªÙ… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ù†Ø¯ ',0),(207544,5766,'tr','AÅŸaÄŸÄ±daki Customer(s), zaten sistemde var',0),(207545,5766,'pl','NastÄ™pujÄ…cych odbiorcÃ³w juÅ¼ istnieje w systemie',0),(207546,5766,'bg','Ð’ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‚ ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚(Ð¸)',0),(207547,5766,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Customer(s) Ú©Ùˆ Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ø§Ø³ Ù†Ø¸Ø§Ù… Ù…ÛŒÚº Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(207548,5766,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ.\\\\Ð–ÐµÐ»Ð¸Ñ‚Ðµ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ðµ Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ',0),(207549,5766,'vi','KhÃ¡ch hÃ ng nÃ y Ä‘Ã£ cÃ³ trong há»‡ thá»‘ng',0),(207550,5766,'af','Die Volgende Klient(e)/Klant(e) Bestaan Alreeds in die Sisteem',0),(207551,5766,'ro','UrmÄƒtoarele terminologicÄƒ existÄƒ deja Ã®n sistemul de',0),(207552,5766,'et','JÃ¤rgmised kliendid on sÃ¼steemis juba olemas',0),(207553,5766,'si','Naslednje odjemalcev, ki Å¾e obstajajo v sistemu',0),(207554,5766,'ba','Customer(s) berikut sudah ada dalam sistem',0),(207555,5766,'nl','De volgende klant bestaat reeds in het systeem',0),(207556,5766,'fi','Seuraavat Ticketin jo olemassa jÃ¤rjestelmÃ¤ssÃ¤',0),(207557,5766,'no','FÃ¸lgende kunden(e) finnes allerede i systemet',0),(207558,5766,'da','De fÃ¸lgende oversÃ¦ttelsesenheden findes allerede i systemet',0),(207559,5766,'ko','ë‹¤ìŒ Customer(s) ì‹œìŠ¤í…œì— ì´ë¯¸ ì¡´ìž¬',0),(207560,5766,'he','Customer(s) ×”×‘××™× ×›×‘×¨ ×§×™×™× ×‘×ž×¢×¨×›×ª',0),(207561,5766,'el','Î¤Î¿ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Ï€ÎµÎ»Î¬Ï„Î·Ï‚ (ÎµÏ‚) Ï€Î¿Ï… Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î®Î´Î· ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(207562,5766,'zh','ä»¥ä¸‹å®¢æˆ·ï¼ˆä»¬ï¼‰å·²å­˜åœ¨äºŽç³»ç»Ÿ\r\n\r\nRead phoneticallyYÇxiÃ  kÃ¨hÃ¹ (s) yÇ cÃºnzÃ i yÃº xÃ¬tÇ’ng\r\nDictionarynoun0.æ–‡æœ¬0.æ¡ˆæ–‡0.æ­£æ–‡0.è¯¾æ–‡0.å†™ä½œ0.çº‚0.çº‚è¾‘',0),(207563,5766,'sv','De fÃ¶ljande egna kunder finns redan i systemet',0),(207564,5766,'it','I seguente cliente esistono giÃ  nel sistema',0),(207565,5766,'tl','',0),(207566,5766,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3605;&#3656;&#3629;&#3652;&#3611;&#3609;&#3637;&#3657;&#3618;&#3633;&#3591;&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3632;&#3610;&#3610;',0),(207567,5766,'hi','à¤¨à¤¿à¤®à¥à¤¨ Customer(s) à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤®à¥‡à¤‚ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦',0),(207568,5766,'ms','Pelanggan(-pelanggan) berikut sudah wujud di dalam sistem',0),(207569,5766,'ar','Customer(s) Ø§Ù„ØªØ§Ù„ÙŠØ© Ù…ÙˆØ¬ÙˆØ¯Ø© Ø¨Ø§Ù„ÙØ¹Ù„ ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(207570,5766,'fr','L\'ou les clients suivants existent dÃ©jÃ  dans le systÃ¨me',0),(207571,5766,'jp','ã‚·ã‚¹ãƒ†ãƒ å†…ã?«æ¬¡ã?®é¡§å®¢ã?Œã?™ã?§ã?«å­˜åœ¨ã?—ã?¦ã?„ã?¾ã?™',0),(207572,5766,'pt','Os seguintes clientes jÃ¡ existem no sistema',0),(207573,5766,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð¸Ñ‚Ð¾Ð³ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ðµ',0),(207574,5766,'es','El(Los) Cliente(s) Siguente Ya Existe en el Sistema',0),(207575,5766,'de','Die folgenden Kunden sind bereits im System vorhanden.',0),(207576,5766,'en','The Following Customer(s) Already Exist in the System',0),(207577,5767,'is','',0),(207578,5767,'dr','(Ø¹ÙˆØ§Ø±Ø¶) Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠ ÙÙ‡Ø±Ø³Øª Ø´Ø¯Ù‡ ',0),(207579,5767,'pr','Ø¨Ø¯Ù‡ÙŠ(Ø¹ÙˆØ§Ø±Ø¶) Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠ ÙÙ‡Ø±Ø³Øª Ø´Ø¯Ù‡ ',0),(207580,5767,'tr','Nedeniyle planlanan sevkiyat',0),(207581,5767,'pl','Regularnych dostaw ze wzglÄ™du',0),(207582,5767,'bg','Ð ÐµÐ´Ð¾Ð²Ð½Ð¸ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð¸ Ð¿Ð¾Ñ€Ð°Ð´Ð¸',0),(207583,5767,'ur','Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ ØªØ±Ø³ÛŒÙ„ Ú©ÛŒ ÙˆØ¬Û Ø³Û’',0),(207584,5767,'sr','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°Ð½Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ñ‚ÐµÑ€Ð¼Ð¸Ð½',0),(207585,5767,'vi','Äáº¿n háº¡n chuyá»ƒn hÃ ng Ä‘á»‹nh ká»³',0),(207586,5767,'af','Geskeduleerde Versendings Verskuldig',0),(207587,5767,'ro','Transporturile regulate datorate',0),(207588,5767,'et','Kavandatud saadetistele tÃµttu',0),(207589,5767,'si','Redne dobave zaradi',0),(207590,5767,'ba','Dijadwalkan pengiriman karena',0),(207591,5767,'nl','Geplande zendingen verschuldigde',0),(207592,5767,'fi','Suunniteltu siirtojen mÃ¤Ã¤rÃ¤',0),(207593,5767,'no','Planlagte forsendelser grunn',0),(207594,5767,'da','Planlagte leverancer grund',0),(207595,5767,'ko','ì¸í•´ ì˜ˆì • ëœ ì¶œí•˜',0),(207596,5767,'he','×ž×©×œ×•×—×™× ×ž×ª×•×–×ž× ×•×ª ×‘×©×œ',0),(207597,5767,'el','Î ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÎ¼Î­Î½ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ Î»ÏŒÎ³Ï‰',0),(207598,5767,'zh','é¢„å®šå‡ºè´§é‡äºŽ\r\n',0),(207599,5767,'sv','Schemalagda fÃ¶rsÃ¤ndelser pÃ¥ grund',0),(207600,5767,'it','Spedizioni pianificate dovuto',0),(207601,5767,'tl','',0),(207602,5767,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3607;&#3637;&#3656;&#3626;&#3617;&#3588;&#3623;&#3619;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(207603,5767,'hi','à¤•à¤¾à¤°à¤£ à¤…à¤¨à¥à¤¸à¥‚à¤šà¤¿à¤¤ à¤²à¤¦à¤¾à¤¨',0),(207604,5767,'ms','Penghantaran dijadualkan disebabkan oleh',0),(207605,5767,'ar','Ø§Ù„Ø´Ø­Ù†Ø§Øª Ø§Ù„Ù…Ù‚Ø±Ø±Ø© Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø©',0),(207606,5767,'fr','Envois rÃ©guliers Due',0),(207607,5767,'jp','äºˆå®šç™ºé€?æœŸæ—¥',0),(207608,5767,'pt','TransferÃªncias regulares devido',0),(207609,5767,'ru','Ð ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ñ‹Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¸Ð·-Ð·Ð°',0),(207610,5767,'es','EnvÃ­os Programados Pagaderos',0),(207611,5767,'de','Geplante Sendungen aufgrund',0),(207612,5767,'en','Scheduled Shipments Due',0),(207613,5768,'is','',0),(207614,5768,'dr','Ø­Ù…Ù„ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(207615,5768,'pr','Ø­Ù…Ù„ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(207616,5768,'tr','Standart nakliye',0),(207617,5768,'pl','Standardowe wysyÅ‚ki',0),(207618,5768,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(207619,5768,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø´Ù¾Ù†Ú¯',0),(207620,5768,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(207621,5768,'vi','Váº­n chuyá»ƒn chuáº©n',0),(207622,5768,'af','Standaard Versending',0),(207623,5768,'ro','Standard de transport maritim',0),(207624,5768,'et','Standard Shipping',0),(207625,5768,'si','Standardna dostava',0),(207626,5768,'ba','Standar pengiriman',0),(207627,5768,'nl','Standaard verzending',0),(207628,5768,'fi','Normaalikuljetus',0),(207629,5768,'no','Standard Norge',0),(207630,5768,'da','Standard fragt',0),(207631,5768,'ko','í‘œì¤€ ë°°ì†¡',0),(207632,5768,'he','×ž×©×œ×•×— ×¨×’×™×œ',0),(207633,5768,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î±',0),(207634,5768,'zh','æ ‡å‡†èˆªè¿\r\n',0),(207635,5768,'sv','Standard frakt',0),(207636,5768,'it','Spedizione standard',0),(207637,5768,'tl','',0),(207638,5768,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(207639,5768,'hi','à¤®à¤¾à¤¨à¤• à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(207640,5768,'ms','Standard penghantaran',0),(207641,5768,'ar','Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(207642,5768,'fr','Livraison standard',0),(207643,5768,'jp','æ¨™æº–ç™ºé€?',0),(207644,5768,'pt','Frete padrÃ£o',0),(207645,5768,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð°Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(207646,5768,'es','Transporte EstÃ¡ndar',0),(207647,5768,'de','Standard-Versand',0),(207648,5768,'en','Standard Shipping',0),(207649,5769,'is','',0),(207650,5769,'dr','Ù‚Ø§Ù„Ø¨ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(207651,5769,'pr','Ù‚Ø§Ù„Ø¨ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(207652,5769,'tr','SatÄ±n alma sipariÅŸi biÃ§imi',0),(207653,5769,'pl','Format zamÃ³wienia zakupu',0),(207654,5769,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(207655,5769,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(207656,5769,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(207657,5769,'vi','Kiá»ƒu ÄÆ¡n Mua HÃ ng',0),(207658,5769,'af','Aankoopbestelling Formaat',0),(207659,5769,'ro','Format de comandÄƒ cumpÄƒrare',0),(207660,5769,'et','Ostu tellimuse vorm',0),(207661,5769,'si','Nabavni nalog Format',0),(207662,5769,'ba','Format Order Pembelian',0),(207663,5769,'nl','Aankoop Order Format',0),(207664,5769,'fi','Tilauksen muodossa',0),(207665,5769,'no','Format for bestillinger',0),(207666,5769,'da','KÃ¸b Order Format',0),(207667,5769,'ko','êµ¬ë§¤ ì£¼ë¬¸ í˜•ì‹',0),(207668,5769,'he','×ª×‘× ×™×ª ×”×–×ž× ×ª ×¨×›×™×©×”',0),(207669,5769,'el','Format Î³Î¹Î± Î±Î³Î¿ÏÎ¬',0),(207670,5769,'zh','é‡‡è´­è®¢å•æ ¼å¼\r\n',0),(207671,5769,'sv','Kundorderformat',0),(207672,5769,'it','Formato di ordine di acquisto',0),(207673,5769,'tl','',0),(207674,5769,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(207675,5769,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(207676,5769,'ms','Pembelian perintah Format',0),(207677,5769,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(207678,5769,'fr','Format de commande d\'achat',0),(207679,5769,'jp','ç™ºæ³¨æ›¸ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(207680,5769,'pt','Formato de Ordem de Compra',0),(207681,5769,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(207682,5769,'es','Formato de Orden de Compra',0),(207683,5769,'de','Kauf-Order-Format',0),(207684,5769,'en','Purchase Order Format',0),(207685,5770,'is','',0),(207686,5770,'dr','ÙÙ‚Ø· Ø¨Ø¯ÙˆÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(207687,5770,'pr','ÙÙ‚Ø· Ø¨Ø¯ÙˆÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(207688,5770,'tr','Non-PO sadece',0),(207689,5770,'pl','Nie PO tylko',0),(207690,5770,'bg','ÐÐµ-PO ÑÐ°Ð¼Ð¾',0),(207691,5770,'ur','Ù¾Ùˆ-ØºÛŒØ± ØµØ±Ù',0),(207692,5770,'sr','ÐÐ¾Ð½ -ÐŸÐž ÑÐ°Ð¼Ð¾',0),(207693,5770,'vi','Chá»‰ khÃ´ng Ä‘Æ¡n mua hÃ ng',0),(207694,5770,'af','Nie-AB Alleenlik',0),(207695,5770,'ro','Non-PO numai',0),(207696,5770,'et','Non-PO ainult',0),(207697,5770,'si','Non-PO le',0),(207698,5770,'ba','Bebas-PO hanya',0),(207699,5770,'nl','Niet-PO alleen',0),(207700,5770,'fi','Ei-PO vain',0),(207701,5770,'no','Ikke-PO bare',0),(207702,5770,'da','Ikke-PO kun',0),(207703,5770,'ko','ë¹„ í¬ë§Œ',0),(207704,5770,'he','×”×œ×-×¤×• ×‘×œ×‘×“',0),(207705,5770,'el','ÎœÎ·-PO Î¼ÏŒÎ½Î¿',0),(207706,5770,'zh','ä»…éžè®¢å•\r\n',0),(207707,5770,'sv','Icke-PO endast',0),(207708,5770,'it','Senza ordine solo',0),(207709,5770,'tl','',0),(207710,5770,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(207711,5770,'hi','à¤—à¥ˆà¤°-PO à¤•à¥‡à¤µà¤²',0),(207712,5770,'ms','Bebas-PO hanya',0),(207713,5770,'ar','ØºÙŠØ± Ø¨Ùˆ ÙÙ‚Ø·',0),(207714,5770,'fr','Sans BC uniquement',0),(207715,5770,'jp','ç™ºæ³¨æ›¸ã?ªã?—ã?®ã?¿',0),(207716,5770,'pt','NÃ£o-PO apenas',0),(207717,5770,'ru','ÐÐµ PO Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(207718,5770,'es','No-OC Solamente',0),(207719,5770,'de','Nicht-PO nur',0),(207720,5770,'en','Non-PO Only',0),(207721,5771,'is','',0),(207722,5771,'dr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(207723,5771,'pr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(207724,5771,'tr','Sadece PO',0),(207725,5771,'pl','Tylko PO',0),(207726,5771,'bg','PO ÑÐ°Ð¼Ð¾',0),(207727,5771,'ur','ØµØ±Ù Ù¾Ùˆ',0),(207728,5771,'sr','Ð¡Ð°Ð¼Ð¾ ÐŸÐž',0),(207729,5771,'vi','Chá»‰ Ä‘Æ¡n mua hÃ ng',0),(207730,5771,'af','AB Alleenlik',0),(207731,5771,'ro','PO doar',0),(207732,5771,'et','PO ainult',0),(207733,5771,'si','PO le',0),(207734,5771,'ba','PO hanya',0),(207735,5771,'nl','PO alleen',0),(207736,5771,'fi','PO vain',0),(207737,5771,'no','PO bare',0),(207738,5771,'da','PO kun',0),(207739,5771,'ko','í¬ë§Œ',0),(207740,5771,'he','×¤×• ×‘×œ×‘×“',0),(207741,5771,'el','PO Î¼ÏŒÎ½Î¿',0),(207742,5771,'zh','åªæœ‰é‡‡è´­è®¢å•\r\n',0),(207743,5771,'sv','PO endast',0),(207744,5771,'it','PO solo',0),(207745,5771,'tl','',0),(207746,5771,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(207747,5771,'hi','à¤ªà¥‹ à¤¹à¥€',0),(207748,5771,'ms','PO hanya',0),(207749,5771,'ar','Øµ. Ø¨ ÙÙ‚Ø·',0),(207750,5771,'fr','PO seulement',0),(207751,5771,'jp','ç™ºæ³¨æ›¸ã?®ã?¿',0),(207752,5771,'pt','PO sÃ³',0),(207753,5771,'ru','PO Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(207754,5771,'es','OC Solo',0),(207755,5771,'de','PO nur',0),(207756,5771,'en','PO Only',0),(207757,5772,'is','',0),(207758,5772,'dr','Ù„ÙŠØ³Øª Ø¯Ø±ÙŠØ§ÙØª Ø®Ø±ÙŠØ¯Ù‡Ø§',0),(207759,5772,'pr','Ù„ÙŠØ³Øª Ø¯Ø±ÙŠØ§ÙØª Ø®Ø±ÙŠØ¯Ù‡Ø§',0),(207760,5772,'tr','SatÄ±n alÄ±nan liste',0),(207761,5772,'pl','Otrzymane listy zakupÃ³w',0),(207762,5772,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(207763,5772,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ù…ÙˆØµÙˆÙ„Û ÙÛØ±Ø³Øª',0),(207764,5772,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð»Ð¸ÑÑ‚Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐ¸',0),(207765,5772,'vi','Danh sÃ¡ch mua hÃ ng Ä‘Ã£ nháº­n',0),(207766,5772,'af','Aankope Ontvang Lys',0),(207767,5772,'ro','Lista de achiziÅ£ii primite',0),(207768,5772,'et','Ostetud sai loend',0),(207769,5772,'si','Nakupe prejeti seznam',0),(207770,5772,'ba','Pembelian menerima daftar',0),(207771,5772,'nl','Aankopen ontvangen lijst',0),(207772,5772,'fi','Ostot sai luettelon',0),(207773,5772,'no','KjÃ¸p mottatt liste',0),(207774,5772,'da','KÃ¸b af modtagne liste',0),(207775,5772,'ko','êµ¬ë§¤ ì ‘ìˆ˜ ëª©ë¡',0),(207776,5772,'he','×”×¨×©×™×ž×” ×©×”×ª×§×‘×œ×” ×¨×›×™×©×•×ª',0),(207777,5772,'el','ÎˆÎ»Î±Î²Îµ Î»Î¯ÏƒÏ„Î± Î±Î³Î¿ÏÏŽÎ½',0),(207778,5772,'zh','é‡‡è´­æ”¶åˆ°æ¸…å•\r\n',0),(207779,5772,'sv','InkÃ¶p mottagna lista',0),(207780,5772,'it','Elenco ricevute di acquisti',0),(207781,5772,'tl','',0),(207782,5772,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3595;&#3639;&#3657;&#3629;',0),(207783,5772,'hi','à¤–à¤°à¥€à¤¦ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¸à¥‚à¤šà¥€',0),(207784,5772,'ms','Senarai pembelian yang diterima',0),(207785,5772,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ø´ØªØ±ÙŠØ§Øª Ø§Ù„Ù…Ø³ØªÙ„Ù…Ø©',0),(207786,5772,'fr','Liste reÃ§us d\'achats',0),(207787,5772,'jp','å?—é ˜æ¸ˆè³¼å…¥ç‰©ãƒªã‚¹ãƒˆ',0),(207788,5772,'pt','Lista de compras recebidas',0),(207789,5772,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº',0),(207790,5772,'es','Lista de Compras Recibidas',0),(207791,5772,'de','EinkÃ¤ufe Empfangene Liste',0),(207792,5772,'en','Purchases Received List',0),(207793,5773,'is','',0),(207794,5773,'dr','Ù…ØªÙ† Ø¯Ø± ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(207795,5773,'pr','Ù…ØªÙ† Ø¯Ø± ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(207796,5773,'tr','Notlardaki metinleri',0),(207797,5773,'pl','Tekstu w notatkach',0),(207798,5773,'bg','Ð¢ÐµÐºÑÑ‚Ð° Ð² Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸Ñ‚Ðµ',0),(207799,5773,'ur','Ù…ØªÙ† Ù†ÙˆÙ¹',0),(207800,5773,'sr','Ð¢ÐµÐºÑÑ‚ Ñƒ Ð±ÐµÐ»ÐµÑˆÐºÐ°Ð¼Ð°',0),(207801,5773,'vi','VÄƒn báº£n trong ghi chÃº',0),(207802,5773,'af','Teks in Notas',0),(207803,5773,'ro','Textul Ã®n notele',0),(207804,5773,'et','MÃ¤rkmete tekst',0),(207805,5773,'si','Besedilo opombe',0),(207806,5773,'ba','Teks dalam catatan',0),(207807,5773,'nl','Tekst in notities',0),(207808,5773,'fi','TekstiÃ¤ muistiinpanoista',0),(207809,5773,'no','Tekst i notater',0),(207810,5773,'da','Tekst i noter',0),(207811,5773,'ko','ë…¸íŠ¸ì—ì„œ í…ìŠ¤íŠ¸',0),(207812,5773,'he','×˜×§×¡×˜ ×‘×”×¢×¨×•×ª',0),(207813,5773,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÎµ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(207814,5773,'zh','æ³¨é‡Šä¸­çš„æ–‡å­—\r\n',0),(207815,5773,'sv','Text i anteckningar',0),(207816,5773,'it','Testo nelle note',0),(207817,5773,'tl','',0),(207818,5773,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3651;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(207819,5773,'hi','à¤¨à¥‹à¤Ÿà¥à¤¸ à¤®à¥‡à¤‚ à¤ªà¤¾à¤ ',0),(207820,5773,'ms','Teks dalam Nota-Nota',0),(207821,5773,'ar','Ù†Øµ ÙÙŠ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(207822,5773,'fr','Texte en Notes',0),(207823,5773,'jp','ãƒ¡ãƒ¢ã?®æ–‡ç« ',0),(207824,5773,'pt','Texto em notas',0),(207825,5773,'ru','Ð¢ÐµÐºÑÑ‚ Ð² Ð·Ð°Ð¼ÐµÑ‚ÐºÐ°Ñ…',0),(207826,5773,'es','Texto en Notas',0),(207827,5773,'de','Text in Notizen',0),(207828,5773,'en','Text in Notes',0),(207829,5774,'is','',0),(207830,5774,'dr','(  Ø¯Ø±ÙŠØ§ÙØªÙ‡Ø§',0),(207831,5774,'pr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ¯Ø§Ù… Ø±Ø³ÙŠØ¯Ù‡Ø§(  Ø¯Ø±ÙŠØ§ÙØªÙ‡Ø§',0),(207832,5774,'tr','Hangi bilgileri gÃ¶ster',0),(207833,5774,'pl','PokaÅ¼ jakie wpÅ‚ywy',0),(207834,5774,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ð¸ Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ¸',0),(207835,5774,'ur','Ø¬Ø³ Ú©ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(207836,5774,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ',0),(207837,5774,'vi','Hiá»ƒn thá»‹ biÃªn nháº­n nÃ o',0),(207838,5774,'af','Wys watter kwitansies',0),(207839,5774,'ro','AratÄƒ care Ã®ncasÄƒri',0),(207840,5774,'et','NÃ¤ita milliste orderitega',0),(207841,5774,'si','PokaÅ¾i kateri prejemki',0),(207842,5774,'ba','Tampilkan penerimaan yang',0),(207843,5774,'nl','Show die ontvangsten',0),(207844,5774,'fi','NÃ¤ytÃ¤ vastaanotot',0),(207845,5774,'no','Viser hvilke kvitteringer',0),(207846,5774,'da','Vis som kvitteringer',0),(207847,5774,'ko','ì˜ìˆ˜ì¦ ë³´ê¸°',0),(207848,5774,'he','×ž×¦×™×’×™× ××ª ×”×”×›× ×¡×•×ª',0),(207849,5774,'el','Î”ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î»Î±Î²Î­Ï‚ Ï€Î¿Ï…',0),(207850,5774,'zh','æ˜¾ç¤ºå“ªäº›æ”¶æ®\r\n',0),(207851,5774,'sv','Visa vilka inleveranser',0),(207852,5774,'it','Mostrare che le ricevute',0),(207853,5774,'tl','',0),(207854,5774,'th','&#3649;&#3626;&#3604;&#3591;&#3604;&#3657;&#3623;&#3618;&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3629;&#3633;&#3609;&#3652;&#3627;&#3609;',0),(207855,5774,'hi','à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚',0),(207856,5774,'ms','Menunjukkan resit yang',0),(207857,5774,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„ØªÙŠ',0),(207858,5774,'fr','PrÃ©senter les reÃ§us',0),(207859,5774,'jp','ã?©ã?®é ˜å?Žæ›¸ã‚’è¡¨ç¤º',0),(207860,5774,'pt','Mostrar quais recibos',0),(207861,5774,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ, ÐºÐ°ÐºÐ¸Ðµ Ð¿Ð¾ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ',0),(207862,5774,'es','Muestra Cuales Recibos',0),(207863,5774,'de','Welche Belege anzeigen',0),(207864,5774,'en','Show Which Receipts',0),(207865,5775,'is','',0),(207866,5775,'dr','Ø¯Ø±ÙŠØ§ÙØª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(207867,5775,'pr','Ø¯Ø±ÙŠØ§ÙØª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(207868,5775,'tr','SipariÅŸ alma',0),(207869,5775,'pl','OtrzymujÄ… PO',0),(207870,5775,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° PO',0),(207871,5775,'ur','Ù¾Ùˆ ÙˆØµÙˆÙ„ Ú©Ø±ÛŒÚº',0),(207872,5775,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð¸ ÐŸÐž',0),(207873,5775,'vi','Nháº­n ÄÆ¡n Mua HÃ ng',0),(207874,5775,'af','Ontvang AB',0),(207875,5775,'ro','Primi PO',0),(207876,5775,'et','Saada PO',0),(207877,5775,'si','Prejemajo pad',0),(207878,5775,'ba','Menerima PO',0),(207879,5775,'nl','Ontvangen PO',0),(207880,5775,'fi','Saada PO',0),(207881,5775,'no','Motta PO',0),(207882,5775,'da','Modtage PO',0),(207883,5775,'ko','í¬ë¥¼ ë°›ì„',0),(207884,5775,'he','×œ×§×‘×œ ×¤×•',0),(207885,5775,'el','Î›Î¬Î²ÎµÏ„Îµ PO',0),(207886,5775,'zh','æŽ¥æ”¶è®¢å•\r\n',0),(207887,5775,'sv','FÃ¥ PO',0),(207888,5775,'it','Ricevere PO',0),(207889,5775,'tl','',0),(207890,5775,'th','&#3619;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(207891,5775,'hi','PO à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(207892,5775,'ms','Menerima PO',0),(207893,5775,'ar','ØªÙ„Ù‚ÙŠ Ø¨Ùˆ',0),(207894,5775,'fr','Recevoir les PO',0),(207895,5775,'jp','POå?—é ˜',0),(207896,5775,'pt','Receber PO',0),(207897,5775,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ PO',0),(207898,5775,'es','Recibir OC',0),(207899,5775,'de','PO zu empfangen',0),(207900,5775,'en','Receive PO',0),(207901,5776,'is','',0),(207902,5776,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨ Ù…Ù† ',0),(207903,5776,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨ Ù…Ù† ',0),(207904,5776,'tr','Benim hesap listesi alma',0),(207905,5776,'pl','Importowanie listy konta',0),(207906,5776,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¼Ð¾Ñ Ð¿Ñ€Ð¾Ñ„Ð¸Ð» ÑÐ¿Ð¸ÑÑŠÐº',0),(207907,5776,'ur','Ø§Ù¾Ù†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ ÙÛØ±Ø³Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(207908,5776,'sr','Ð£Ð²Ð¾Ð· Ð»Ð¸ÑÑ‚Ðµ Ð¼Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½',0),(207909,5776,'vi','Nháº­p Danh SÃ¡ch TK Cá»§a TÃ´i ',0),(207910,5776,'af','Invoer van My Rekening Lys',0),(207911,5776,'ro','Lista mea de cont de import',0),(207912,5776,'et','Impordi minu kontode nimekiri',0),(207913,5776,'si','Uvoziti svoj seznam raÄunov',0),(207914,5776,'ba','Impor Daftar Account saya',0),(207915,5776,'nl','Mijn Accountlijst importeren',0),(207916,5776,'fi','Tuo huomioon listallani',0),(207917,5776,'no','Importere kontolisten min',0),(207918,5776,'da','Importere min firmaoversigt',0),(207919,5776,'ko','ë‚´ ê³„ì • ëª©ë¡ ê°€ì ¸ì˜¤ê¸°',0),(207920,5776,'he','×œ×™×™×‘× ××ª ×¨×©×™×ž×ª ×”×—×©×‘×•×Ÿ ×©×œ×™',0),(207921,5776,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î»Î¯ÏƒÏ„Î±Ï‚ Î¼Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(207922,5776,'zh','å¯¼å…¥æˆ‘çš„å¸æˆ·åˆ—è¡¨\r\n',0),(207923,5776,'sv','Importera kontolista',0),(207924,5776,'it','Importare la mia lista di Account',0),(207925,5776,'tl','',0),(207926,5776,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3586;&#3629;&#3591;&#3593;&#3633;&#3609;',0),(207927,5776,'hi','à¤®à¥‡à¤°à¤¾ à¤–à¤¾à¤¤à¤¾ à¤¸à¥‚à¤šà¥€ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(207928,5776,'ms','Mengimport senarai akaun saya',0),(207929,5776,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ø¨Ù„Ø¯ÙŠ',0),(207930,5776,'fr','Importer ma liste de compte',0),(207931,5776,'jp','ãƒžã‚¤ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒªã‚¹ãƒˆã‚’å?–ã‚Šè¾¼ã‚€',0),(207932,5776,'pt','Importar minha lista de conta',0),(207933,5776,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ¿Ð¸ÑÐºÐ° Ð¼Ð¾ÐµÐ¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(207934,5776,'es','Importar la Lista de Mi Cuenta',0),(207935,5776,'de','Mein Kontoliste importieren',0),(207936,5776,'en','Import My Account List',0),(207937,5777,'is','',0),(207938,5777,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ØµÙ†Ø¹ØªÙŠ ',0),(207939,5777,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ØµÙ†Ø¹ØªÙŠ ',0),(207940,5777,'tr','EndÃ¼stri Standart hesap setleri',0),(207941,5777,'pl','PrzemysÅ‚ konto standardowe ZESTAWY',0),(207942,5777,'bg','Ð˜Ð½Ð´ÑƒÑÑ‚Ñ€Ð¸ÑÑ‚Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ð°ÐºÐ°ÑƒÐ½Ñ‚ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¸',0),(207943,5777,'ur','ØµÙ†Ø¹Øª Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ Ú©Ø±ØªØ§ ÛÛ’',0),(207944,5777,'sr','Ð˜Ð½Ð´ÑƒÑÑ‚Ñ€Ð¸Ñ˜Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ ÑÐºÑƒÐ¿Ð¾Ð²Ð°',0),(207945,5777,'vi','TK Chuáº©n Cá»§a NgÃ nh CÃ´ng Nghiá»‡p',0),(207946,5777,'af','Industrie Standaard Rekeningstelle',0),(207947,5777,'ro','Seturi de cont Standard industrie',0),(207948,5777,'et','TÃ¶Ã¶stuse Standard konto komplektid',0),(207949,5777,'si','Industrija standardni raÄun sklopov',0),(207950,5777,'ba','Set akun standar industri',0),(207951,5777,'nl','Industrie standaard Account Sets',0),(207952,5777,'fi','Teollisuuden normaali tili asetetaan',0),(207953,5777,'no','Industri Standard konto sett',0),(207954,5777,'da','Industrien Standard konto sÃ¦t',0),(207955,5777,'ko','ì—…ê³„ í‘œì¤€ ê³„ì • ì§‘í•©',0),(207956,5777,'he','×ª×¢×©×™×™×ª ×—×©×‘×•×Ÿ ×¨×’×™×œ ×¡×˜×™×',0),(207957,5777,'el','Î’Î¹Î¿Î¼Î·Ï‡Î±Î½Î¯Î± Ï„Ï…Ï€Î¹ÎºÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÏƒÏÎ½Î¿Î»Î±',0),(207958,5777,'zh','è¡Œä¸šæ ‡å‡†å¸æˆ·è®¾ç½®\r\n',0),(207959,5777,'sv','Industrin Standard konto uppsÃ¤ttningar',0),(207960,5777,'it','Set di Account Standard di industria',0),(207961,5777,'tl','',0),(207962,5777,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3629;&#3640;&#3605;&#3626;&#3634;&#3627;&#3585;&#3619;&#3619;&#3617;',0),(207963,5777,'hi','à¤‰à¤¦à¥à¤¯à¥‹à¤— à¤®à¤¾à¤¨à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿ',0),(207964,5777,'ms','Set akaun Standard industri',0),(207965,5777,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø­Ø³Ø§Ø¨ Ù…Ø¹ÙŠØ§Ø± Ø§Ù„ØµÙ†Ø§Ø¹Ø©',0),(207966,5777,'fr','Jeux de compte Standard de l\'industrie',0),(207967,5777,'jp','ç”£æ¥­åŸºæº–ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚»ãƒƒãƒˆ',0),(207968,5777,'pt','Conjuntos de conta Standard da indÃºstria',0),(207969,5777,'ru','ÐÐ°Ð±Ð¾Ñ€Ñ‹ Ð¸Ð½Ð´ÑƒÑÑ‚Ñ€Ð¸Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð°Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(207970,5777,'es','Juegos EstÃ¡ndares de Cuentas de la Industria',0),(207971,5777,'de','Industrie-Standard-Account-Sets',0),(207972,5777,'en','Industry Standard Account Sets',0),(207973,5778,'is','',0),(207974,5778,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ Ø¯Ø± Ø¬Ø¯ÙˆÙ„ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø³Ø§Ø®Øª ',0),(207975,5778,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ Ø¯Ø± Ø¬Ø¯ÙˆÙ„ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø³Ø§Ø®Øª ',0),(207976,5778,'tr','Standart sanayi tabloya hesaplarÄ± al',0),(207977,5778,'pl','Importowania kont standardowych tabela',0),(207978,5778,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð² ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸Ñ‚Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(207979,5778,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ ØµÙ†Ø¹Øª Ø¬Ø¯ÙˆÙ„ Ù…ÛŒÚº Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(207980,5778,'sr','Ð£Ð²Ð¾Ð· Ð½Ð°Ð»Ð¾Ð³Ð° Ñƒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð¸Ð½Ð´ÑƒÑÑ‚Ñ€Ð¸Ñ˜Ð¸ ÑÑ‚Ð¾',0),(207981,5778,'vi','Káº¿t Chuyá»ƒn TK ThÃ nh Báº£ng Chuáº©n Cá»§a NgÃ nh CÃ´ng Nghiá»‡p',0),(207982,5778,'af','Invoer van Rekeninge Binne die Standaard Industrie Tabel',0),(207983,5778,'ro','Importa conturile Ã®n industria Standard de masÄƒ',0),(207984,5778,'et','Kontod importida standardproovidega tabel',0),(207985,5778,'si','Uvozite raÄune v tabelo Standard industrije',0),(207986,5778,'ba','Mengimpor account ke dalam tabel standar industri',0),(207987,5778,'nl','Accounts in standaard industrie tabel importeren',0),(207988,5778,'fi','Tuo tilit alan taulukkoon',0),(207989,5778,'no','Importere kontoer til standardiserte tabell',0),(207990,5778,'da','Importere konti til branchestandardiseret tabel',0),(207991,5778,'ko','ì—…ê³„ í‘œì¤€ í…Œì´ë¸”ë¡œ ê°€ì ¸ì˜¤ê¸° ê³„ì •',0),(207992,5778,'he','×œ×™×™×‘× ×—×©×‘×•× ×•×ª ×œ×ª×•×š ×”×˜×‘×œ×” ×”×¡×˜× ×“×¨×˜×™×ª ×‘×¢× ×£',0),(207993,5778,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ ÏƒÎµ Î²Î¹Î¿Î¼Î·Ï‡Î±Î½Î¯Î± Ï€ÏÏŒÏ„Ï…Ï€Î¿ Ï€Î¯Î½Î±ÎºÎ±',0),(207994,5778,'zh','å‘å¸æˆ·å¯¼å…¥æ ‡å‡†å·¥ä¸šè¡¨\r\n',0),(207995,5778,'sv','Importera konton till Standard industri tabell',0),(207996,5778,'it','Importare gli account in tabella Standard industriali',0),(207997,5778,'tl','',0),(207998,5778,'th','&#3607;&#3635;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3652;&#3611;&#3626;&#3641;&#3656;&#3605;&#3634;&#3619;&#3634;&#3591;&#3617;&#3634;&#3605;&#3619;&#3',0),(207999,5778,'hi','à¤²à¥‡à¤–à¤¾ à¤®à¤¾à¤¨à¤• à¤‰à¤¦à¥à¤¯à¥‹à¤— à¤Ÿà¥‡à¤¬à¤² à¤®à¥‡à¤‚ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(208000,5778,'ms','Import akaun ke dalam Jadual Standard industri',0),(208001,5778,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª ÙÙŠ Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„ØµÙ†Ø§Ø¹Ø© Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(208002,5778,'fr','Importer des comptes dans la Table Standard de l\'industrie',0),(208003,5778,'jp','æ¨™æº–æ¥­ç•Œè¡¨ã?¸ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆ',0),(208004,5778,'pt','Importar contas para tabela de padrÃ£o da indÃºstria',0),(208005,5778,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñƒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… Ð¿Ñ€Ð¾Ð¼Ñ‹ÑˆÐ»ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(208006,5778,'es','Importar Cuentas a la Tabla EstÃ¡ndar de la Industria',0),(208007,5778,'de','Konten in Industriestandard-Tabelle importieren',0),(208008,5778,'en','Import Accounts Into Standard Industry Table',0),(208009,5779,'is','',0),(208010,5779,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø³Ø§Ø®Øª Ø¯Ø± Ø¬Ø¯ÙˆÙ„ ØªÙ†Ø¸ÙŠÙ… \r\n Setup Table',0),(208011,5779,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø³Ø§Ø®Øª Ø¯Ø± Ø¬Ø¯ÙˆÙ„ ØªÙ†Ø¸ÙŠÙ… \r\n Setup Table',0),(208012,5779,'tr','EndÃ¼stri Standart hesaplarÄ± kurulumu tabloya almak',0),(208013,5779,'pl','Importowanie konfiguracji tabeli przemysÅ‚u standardowych kont',0),(208014,5779,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ð´ÑƒÑÑ‚Ñ€Ð¸ÑÑ‚Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸ Ð² Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð° ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(208015,5779,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ø¬Ø¯ÙˆÙ„ Ù…ÛŒÚº ØµÙ†Ø¹Øª Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(208016,5779,'sr','Ð£Ð²Ð¾Ð· Ð¸Ð½Ð´ÑƒÑÑ‚Ñ€Ð¸Ñ˜Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸ Ñƒ Ñ‚Ð°Ð±ÐµÐ»Ð¸ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(208017,5779,'vi','Káº¿t Chuyá»ƒn TK Chuáº©n Cá»§a NgÃ nh CÃ´ng Nghiá»‡p sang Báº£ng Setup',0),(208018,5779,'af','Invoer van Industrie Standaard Rekening binne-in Opstellingstabel',0),(208019,5779,'ro','Industria Standard conturi de import Ã®n tabelul Parametrizare',0),(208020,5779,'et','TÃ¶Ã¶stuse Standard kontod importida tabeli seadistamine',0),(208021,5779,'si','Uvoz industrija standardni raÄuni v nastavitveni tabeli',0),(208022,5779,'ba','Mengimpor account standar industri ke dalam tabel Setup',0),(208023,5779,'nl','Industrie standaard mailaccounts importeren in instellingentabel',0),(208024,5779,'fi','Tuo teollisuuden normaalien tilien asetukset-taulukossa',0),(208025,5779,'no','Importere industrien standardkontoer i oppsettstabellen',0),(208026,5779,'da','Importere industri Standard konti i opsÃ¦tningstabellen',0),(208027,5779,'ko','ì‚°ì—… í‘œì¤€ ê³„ì • ì„¤ì¹˜ í…Œì´ë¸”ë¡œ ê°€ì ¸ì˜¤ê¸°',0),(208028,5779,'he','×œ×™×™×‘× ×—×©×‘×•× ×•×ª ×¨×’×™×œ×™× ×ª×¢×©×™×™×ª ×˜×‘×œ×ª ×›×™×•×•× ×•×Ÿ',0),(208029,5779,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î²Î¹Î¿Î¼Î·Ï‡Î±Î½Î¯Î± Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ ÏƒÎµ Ï€Î¯Î½Î±ÎºÎ± Ï€Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚',0),(208030,5779,'zh','å¯¼å…¥å·¥ä¸šæ ‡å‡†å¸æˆ·åˆ°å®‰è£…ç¨‹åºè¡¨\r\n',0),(208031,5779,'sv','Importera industrin Standard konton till tabellen',0),(208032,5779,'it','Importare account Standard di industria nella tabella Setup',0),(208033,5779,'tl','',0),(208034,5779,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3650;&#3619;&#3591;&#3591;&#3634;&#3609;&#3652;&#3611;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3605;&#3633;&#3656;&#3591;&#3',0),(208035,5779,'hi','à¤‰à¤¦à¥à¤¯à¥‹à¤— à¤®à¤¾à¤¨à¤• à¤–à¤¾à¤¤à¥‡ à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(208036,5779,'ms','Import akaun Standard industri ke dalam Jadual persediaan',0),(208037,5779,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© ÙÙŠ Ø§Ù„ØµÙ†Ø§Ø¹Ø© ÙÙŠ Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(208038,5779,'fr','Importer les comptes Standard de l\'industrie dans la Table paramÃ¨tres',0),(208039,5779,'jp','è¨­å®šè¡¨ã?¸æ¥­ç•Œæ¨™æº–ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆ',0),(208040,5779,'pt','Importar contas padrÃ£o da indÃºstria para a tabela de configuraÃ§Ã£o',0),(208041,5779,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¿Ñ€Ð¾Ð¼Ñ‹ÑˆÐ»ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð² Ð² Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ðµ ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(208042,5779,'es','Importar Cuentas EstÃ¡ndares de una Industria a la Tabla de ConfiguraciÃ³n',0),(208043,5779,'de','Industrie Standardkonten in Setuptabelle importieren',0),(208044,5779,'en','Import Industry Standard Accounts into Setup Table',0),(208045,5780,'is','',0),(208046,5780,'dr','(Ø¯Ø§Ø¯Ùˆ Ø³ØªØ¯',0),(208047,5780,'pr','ÙƒØ¯ Ø³Ø§Ø®Øª (Ø¯Ø§Ø¯Ùˆ Ø³ØªØ¯',0),(208048,5780,'tr','EndÃ¼stri kodu',0),(208049,5780,'pl','Kod Industry',0),(208050,5780,'bg','ÐžÑ‚Ñ€Ð°ÑÐ»Ð¾Ð² ÐºÐ¾Ð´',0),(208051,5780,'ur','ØµÙ†Ø¹Øª Ú©ÙˆÚˆ',0),(208052,5780,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð´ÐµÐ»Ð°Ñ‚Ð½Ð¾ÑÑ‚Ð¸',0),(208053,5780,'vi','MÃ£ cÃ´ng nghiá»‡p',0),(208054,5780,'af','Industrie Kode',0),(208055,5780,'ro','Industria cod',0),(208056,5780,'et','TÃ¶Ã¶stus-kood',0),(208057,5780,'si','Industry zakonika',0),(208058,5780,'ba','Industri kode',0),(208059,5780,'nl','Industrie Code',0),(208060,5780,'fi','Alan koodi',0),(208061,5780,'no','Industry kode',0),(208062,5780,'da','Industrien kode',0),(208063,5780,'ko','ì‚°ì—… ì½”ë“œ',0),(208064,5780,'he','×ª×¢×©×™×™×ª ×§×•×“',0),(208065,5780,'el','Î’Î¹Î¿Î¼Î·Ï‡Î±Î½Î¯Î± ÎºÏŽÎ´Î¹ÎºÎ±',0),(208066,5780,'zh','è¡Œä¸šä»£ç \r\n',0),(208067,5780,'sv','Industrin kod',0),(208068,5780,'it','Codice di industria',0),(208069,5780,'tl','',0),(208070,5780,'th','&#3619;&#3627;&#3633;&#3626;&#3629;&#3640;&#3605;&#3626;&#3634;&#3627;&#3585;&#3619;&#3619;&#3617;',0),(208071,5780,'hi','à¤‰à¤¦à¥à¤¯à¥‹à¤— à¤•à¥‹à¤¡',0),(208072,5780,'ms','Kod industri',0),(208073,5780,'ar','Ø±Ù…Ø² Ø§Ù„ØµÙ†Ø§Ø¹Ø©',0),(208074,5780,'fr','Code de l\'industrie',0),(208075,5780,'jp','æ¥­ç•Œã‚³ãƒ¼ãƒ‰',0),(208076,5780,'pt','CÃ³digo da indÃºstria',0),(208077,5780,'ru','ÐšÐ¾Ð´ Ð¾Ñ‚Ñ€Ð°ÑÐ»Ð¸',0),(208078,5780,'es','CÃ³digo de la Industria',0),(208079,5780,'de','Branchencode',0),(208080,5780,'en','Industry Code',0),(208081,5781,'is','',0),(208082,5781,'dr','Ø´Ø±Ø­ Ø³Ø§Ø®Øª ',0),(208083,5781,'pr','Ø´Ø±Ø­ Ø³Ø§Ø®Øª ',0),(208084,5781,'tr','Sanayi aÃ§Ä±klamasÄ±',0),(208085,5781,'pl','Opis przemysÅ‚u',0),(208086,5781,'bg','ÐŸÑ€Ð¾Ð¼Ð¸ÑˆÐ»ÐµÐ½Ð¾ÑÑ‚ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(208087,5781,'ur','ØµÙ†Ø¹Øª Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(208088,5781,'sr','ÐžÐ¿Ð¸Ñ Ð´ÐµÐ»Ð°Ñ‚Ð½Ð¾ÑÑ‚Ð¸',0),(208089,5781,'vi','MÃ´ táº£ cÃ´ng nghiá»‡p',0),(208090,5781,'af','Industrie Beskrywing',0),(208091,5781,'ro','Industrie Descriere',0),(208092,5781,'et','TÃ¶Ã¶stuse kirjeldus',0),(208093,5781,'si','Industrija opis',0),(208094,5781,'ba','Industri Deskripsi',0),(208095,5781,'nl','Beschrijving van de industrie',0),(208096,5781,'fi','Alan kuvaus',0),(208097,5781,'no','Industrien beskrivelse',0),(208098,5781,'da','Industri beskrivelse',0),(208099,5781,'ko','ê¸°ì—… ì„¤ëª…',0),(208100,5781,'he','×ª×™××•×¨ ×‘×ª×¢×©×™×™×”',0),(208101,5781,'el','Î’Î¹Î¿Î¼Î·Ï‡Î±Î½Î¯Î± Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(208102,5781,'zh','äº§ä¸šä»‹ç»\r\n',0),(208103,5781,'sv','Industri Beskrivning',0),(208104,5781,'it','Descrizione di industria',0),(208105,5781,'tl','',0),(208106,5781,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3629;&#3640;&#3605;&#3626;&#3634;&#3627;&#3585;&#3619;&#3619;&#3617;',0),(208107,5781,'hi','à¤‰à¤¦à¥à¤¯à¥‹à¤— à¤µà¤¿à¤µà¤°à¤£',0),(208108,5781,'ms','Description/kawalan industri',0),(208109,5781,'ar','ÙˆØµÙ Ø§Ù„ØµÙ†Ø§Ø¹Ø©',0),(208110,5781,'fr','Description de l\'industrie',0),(208111,5781,'jp','æ¥­ç•Œè§£èª¬',0),(208112,5781,'pt','IndÃºstria descriÃ§Ã£o',0),(208113,5781,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¾Ñ‚Ñ€Ð°ÑÐ»Ð¸',0),(208114,5781,'es','DescripciÃ³n de la Industria',0),(208115,5781,'de','Industrie-Beschreibung',0),(208116,5781,'en','Industry Description',0),(208117,5782,'is','',0),(208118,5782,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨ Ù…Ù†',0),(208119,5782,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨ Ù…Ù†',0),(208120,5782,'tr','Benim hesap listesi alma',0),(208121,5782,'pl','Importowanie listy konta',0),(208122,5782,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¼Ð¾Ñ Ð¿Ñ€Ð¾Ñ„Ð¸Ð» ÑÐ¿Ð¸ÑÑŠÐº',0),(208123,5782,'ur','Ø§Ù¾Ù†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ ÙÛØ±Ø³Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(208124,5782,'sr','Ð£Ð²Ð¾Ð· Ð»Ð¸ÑÑ‚Ðµ Ð¼Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½',0),(208125,5782,'vi','Nháº­p Danh SÃ¡ch TK Cá»§a TÃ´i ',0),(208126,5782,'af','Invoer van My Rekening Lys',0),(208127,5782,'ro','Lista mea de cont de import',0),(208128,5782,'et','Impordi minu kontode nimekiri',0),(208129,5782,'si','Uvoziti svoj seznam raÄunov',0),(208130,5782,'ba','Impor Daftar Account saya',0),(208131,5782,'nl','Mijn Accountlijst importeren',0),(208132,5782,'fi','Tuo huomioon listallani',0),(208133,5782,'no','Importere kontolisten min',0),(208134,5782,'da','Importere min firmaoversigt',0),(208135,5782,'ko','ë‚´ ê³„ì • ëª©ë¡ ê°€ì ¸ì˜¤ê¸°',0),(208136,5782,'he','×œ×™×™×‘× ××ª ×¨×©×™×ž×ª ×”×—×©×‘×•×Ÿ ×©×œ×™',0),(208137,5782,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î»Î¯ÏƒÏ„Î±Ï‚ Î¼Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(208138,5782,'zh','å¯¼å…¥æˆ‘çš„å¸æˆ·åˆ—è¡¨\r\n',0),(208139,5782,'sv','Importera kontolista',0),(208140,5782,'it','Importare la mia lista di Account',0),(208141,5782,'tl','',0),(208142,5782,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3586;&#3629;&#3591;&#3593;&#3633;&#3609;',0),(208143,5782,'hi','à¤®à¥‡à¤°à¤¾ à¤–à¤¾à¤¤à¤¾ à¤¸à¥‚à¤šà¥€ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(208144,5782,'ms','Mengimport senarai akaun saya',0),(208145,5782,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ø¨Ù„Ø¯ÙŠ',0),(208146,5782,'fr','Importer ma liste de compte',0),(208147,5782,'jp','ãƒžã‚¤ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒªã‚¹ãƒˆã‚’å?–ã‚Šè¾¼ã‚€',0),(208148,5782,'pt','Importar minha lista de conta',0),(208149,5782,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ¿Ð¸ÑÐºÐ° Ð¼Ð¾ÐµÐ¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(208150,5782,'es','Importar la Lista de Mi Cuenta',0),(208151,5782,'de','Mein Kontoliste importieren',0),(208152,5782,'en','Import My Account List',0),(208153,5783,'is','',0),(208154,5783,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(208155,5783,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(208156,5783,'tr','Yinelenen giriÅŸleri Ekle',0),(208157,5783,'pl','DodaÄ‡ powtarzajÄ…ce zapisÃ³w ksiÄ™gi',0),(208158,5783,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(208159,5783,'ur','Ù…Ú©Ø±Ø± Ú©Ú¾Ø§ØªØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(208160,5783,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑšÐ¸Ð³Ðµ',0),(208161,5783,'vi','ThÃªm bÃºt toÃ¡n sá»• cÃ¡i Ä‘á»‹nh ká»³',0),(208162,5783,'af','Skep Herhalende Grootboekinskrywings',0),(208163,5783,'ro','Adauga intrÄƒrile din registrul de recurente',0),(208164,5783,'et','Lisada korduvad kanded',0),(208165,5783,'si','Dodaj ponavljajoÄe se postavke',0),(208166,5783,'ba','Tambahkan berulang entri buku besar',0),(208167,5783,'nl','Terugkerende posten toevoegen',0),(208168,5783,'fi','LisÃ¤Ã¤ toistuvat tapahtumat',0),(208169,5783,'no','Legge til gjentakende poster',0),(208170,5783,'da','TilfÃ¸je tilbagevendende poster',0),(208171,5783,'ko','ë˜í’€ì´ ë˜ëŠ” ë ˆì € í•­ëª© ì¶”ê°€',0),(208172,5783,'he','×”×•×¡×¤×ª ×¤×§×•×“×•×ª ×™×•×ž×Ÿ ×—×•×–×¨×•×ª',0),(208173,5783,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(208174,5783,'zh','æ–°å¢žå®šæœŸèŽ±æ°ä½œå“\r\n',0),(208175,5783,'sv','LÃ¤gg till Ã¥terkommande transaktioner',0),(208176,5783,'it','Aggiungi ricorrenti movimenti contabili',0),(208177,5783,'tl','',0),(208178,5783,'th','&#3585;&#3619;&#3629;&#3585;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(208179,5783,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(208180,5783,'ms','Menambah penyertaan Lejar yang berulang',0),(208181,5783,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚ÙŠÙˆØ¯ ÙŠÙˆÙ…ÙŠØ© Ù…ØªÙƒØ±Ø±Ø©',0),(208182,5783,'fr','Ajouter des Ã©critures rÃ©currentes',0),(208183,5783,'jp','è‡ªå‹•æ›´æ–°å¸³ç°¿è¨˜å…¥è¿½åŠ ',0),(208184,5783,'pt','Adicionar movimentos recorrentes',0),(208185,5783,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰ÐµÐ³Ð¾ÑÑ ÑƒÑ‡Ñ‚ÐµÐ½Ð½Ñ‹Ñ…',0),(208186,5783,'es','Agregar Entradas REcurrentes de Libro Mayor',0),(208187,5783,'de','Wiederkehrende Posten hinzufÃ¼gen',0),(208188,5783,'en','Add Recurring Ledger Entries',0),(208189,5784,'is','',0),(208190,5784,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ù¾Ø³Øª  ÙƒØ±Ø¯Ù†',0),(208191,5784,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ù¾Ø³Øª  ÙƒØ±Ø¯Ù†',0),(208192,5784,'tr','Post sÄ±rasÄ±nda hata oluÅŸtu',0),(208193,5784,'pl','BÅ‚Ä…d podczas postu',0),(208194,5784,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð¿Ð¾ÑÑ‚',0),(208195,5784,'ur','Ù¾ÙˆØ³Ù¹ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ',0),(208196,5784,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ ÐŸÐ¾ÑÑ‚',0),(208197,5784,'vi','Lá»—i khi káº¿t chuyá»ƒn',0),(208198,5784,'af','Fout het ingesluip Gedurende Pos',0),(208199,5784,'ro','Eroare Ã®n timpul Post',0),(208200,5784,'et','Viga Post',0),(208201,5784,'si','Napaka med Post',0),(208202,5784,'ba','Error selama posting',0),(208203,5784,'nl','Fout tijdens Post',0),(208204,5784,'fi','Virhe viesti',0),(208205,5784,'no','Feil under Post',0),(208206,5784,'da','Fejl under Post',0),(208207,5784,'ko','Post ë„ì¤‘ ì˜¤ë¥˜',0),(208208,5784,'he','×©×’×™××” ×‘×ž×”×œ×š Post',0),(208209,5784,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î¬ÏÎºÎµÎ¹Î± Ï„Î¿Ï… Post',0),(208210,5784,'zh','é‚®å¯„è¿‡ç¨‹ä¸­å‡ºçŽ°é”™è¯¯',0),(208211,5784,'sv','Fel under Post',0),(208212,5784,'it','Errore durante il Post',0),(208213,5784,'tl','',0),(208214,5784,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(208215,5784,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(208216,5784,'ms','Ralat semasa Post',0),(208217,5784,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(208218,5784,'fr','Erreur pendant le Post',0),(208219,5784,'jp','è¨ˆä¸Šä¸­ã?®ã‚¨ãƒ©ãƒ¼',0),(208220,5784,'pt','Erro durante o Post',0),(208221,5784,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð’Ð¾ Ð’Ñ€ÐµÐ¼Ñ ÐŸÑ€Ð¾Ð²Ð¾Ð´ÐºÐ¸',0),(208222,5784,'es','Error Durante Asentar',0),(208223,5784,'de','Fehler wÃ¤hrend des Post',0),(208224,5784,'en','Error During Post',0),(208225,5785,'is','',0),(208226,5785,'dr','(Ø¢Ú¯Ù‡ÙŠ',0),(208227,5785,'pr','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø±ÙŠÙ† Ù¾Ø³Øª Ø´Ø¯Ù‡  (Ø¢Ú¯Ù‡ÙŠ',0),(208228,5785,'tr','Son yayÄ±nlanan tarihi',0),(208229,5785,'pl','Ostatnio wysÅ‚any dnia',0),(208230,5785,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð°Ñ‚Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð° Ð´Ð°Ñ‚Ð°',0),(208231,5785,'ur','Ø¢Ø®Ø±ÛŒ Ø§Ø´ØªÛØ§Ø± Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(208232,5785,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ',0),(208233,5785,'vi','NgÃ y káº¿t chuyá»ƒn cuá»‘i',0),(208234,5785,'af','Laaste Geposde Datum',0),(208235,5785,'ro','Ultima data postat',0),(208236,5785,'et','Viimase sisestatud kuupÃ¤ev',0),(208237,5785,'si','Datum zadnjega knjiÅ¾enega',0),(208238,5785,'ba','Posted tanggal terakhir',0),(208239,5785,'nl','Datum van de laatste geboekte',0),(208240,5785,'fi','Viimeinen kirjauspÃ¤ivÃ¤',0),(208241,5785,'no','Dato for siste bokfÃ¸rte',0),(208242,5785,'da','Sidste bogfÃ¸rte dato',0),(208243,5785,'ko','ë§ˆì§€ë§‰ ê²Œì‹œ ë‚ ì§œ',0),(208244,5785,'he','×”×ª××¨×™×š ×”××—×¨×•×Ÿ ×¤×•×¨×¡×',0),(208245,5785,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®Î¸Î·ÎºÎµ',0),(208246,5785,'zh','æœ€åŽå‘å¸ƒæ—¥æœŸ\r\n',0),(208247,5785,'sv','Senaste bokfÃ¶rda datum',0),(208248,5785,'it','Ultima data inserita',0),(208249,5785,'tl','',0),(208250,5785,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(208251,5785,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(208252,5785,'ms','Tarikh siaran terakhir',0),(208253,5785,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù†Ø´Ø± Ø§Ù„Ø£Ø®ÙŠØ±',0),(208254,5785,'fr','DerniÃ¨re Date signalÃ©e',0),(208255,5785,'jp','å‰?å›žè¨ˆä¸Šæ—¥',0),(208256,5785,'pt','Ãšltima data postada',0),(208257,5785,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ ÑƒÑ‡Ñ‚ÐµÐ½Ð½Ð¾Ð³Ð¾',0),(208258,5785,'es','Ãšltima Fecha Asentada',0),(208259,5785,'de','Datum der letzten gebuchten',0),(208260,5785,'en','Last Posted Date',0),(208261,5786,'is','',0),(208262,5786,'dr','Ù‡ÙŠÚ† Ù…Ø·Ø§Ø¨Ù‚ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(208263,5786,'pr','Ù‡ÙŠÚ† Ù…Ø·Ø§Ø¨Ù‚ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(208264,5786,'tr','EÅŸleÅŸme bulunamadÄ±',0),(208265,5786,'pl','Nie znaleziono odpowiednikÃ³w',0),(208266,5786,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ñ',0),(208267,5786,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(208268,5786,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð¸Ñ… Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ°',0),(208269,5786,'vi','KhÃ´ng tÃ¬m tháº¥y',0),(208270,5786,'af','Geen pasmaats gevind nie',0),(208271,5786,'ro','Nicio potrivire gÄƒsit',0),(208272,5786,'et','Vasteid ei leitud',0),(208273,5786,'si','Ni zadetkov',0),(208274,5786,'ba','Tidak ada pertandingan yang ditemukan',0),(208275,5786,'nl','Geen overeenkomsten gevonden',0),(208276,5786,'fi','Ei hakutuloksia',0),(208277,5786,'no','Ingen treff',0),(208278,5786,'da','Ingen kampe fandt',0),(208279,5786,'ko','ì—†ìŒ ì¼ì¹˜ í•˜ëŠ” ê²°ê³¼',0),(208280,5786,'he','×œ× × ×ž×¦××• ×”×ª××ž×•×ª',0),(208281,5786,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÎµÏ‚',0),(208282,5786,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…\r\n',0),(208283,5786,'sv','Inga trâ”œÃ±ffar hittades',0),(208284,5786,'it','Nessun risultato trovato.',0),(208285,5786,'tl','',0),(208286,5786,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(208287,5786,'hi','à¤•à¥‹à¤ˆ à¤œà¥‹à¤¡à¤¼ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(208288,5786,'ms','Tiada padanan ditemui',0),(208289,5786,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ ØªØ·Ø§Ø¨Ù‚Ø§Øª',0),(208290,5786,'fr','Aucune correspondance trouvÃ©e',0),(208291,5786,'jp','é?©å?ˆé …ç›®ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(208292,5786,'pt','Nenhuma correspondÃªncia encontrada',0),(208293,5786,'ru','Ð¡Ð¾Ð²Ð¿Ð°Ð´ÐµÐ½Ð¸Ð¹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(208294,5786,'es','No se Encontraron Equivalencias',0),(208295,5786,'de','Keine Treffer gefunden',0),(208296,5786,'en','No Matches Found',0),(208297,5787,'is','',0),(208298,5787,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø³Øª Ø´Ø¯Ù‡ ',0),(208299,5787,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø³Øª Ø´Ø¯Ù‡ ',0),(208300,5787,'tr','BaÅŸarÄ±yla gÃ¶nderildi',0),(208301,5787,'pl','WysÅ‚any pomyÅ›lnie',0),(208302,5787,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(208303,5787,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(208304,5787,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸',0),(208305,5787,'vi','Káº¿t chuyá»ƒn thÃ nh cÃ´ng',0),(208306,5787,'af','Suksesvol Gepos',0),(208307,5787,'ro','Postat cu succes',0),(208308,5787,'et','Postitatud edukalt',0),(208309,5787,'si','Objavljeno uspeÅ¡no',0),(208310,5787,'ba','Dikirim berhasil',0),(208311,5787,'nl','Gepost met succes',0),(208312,5787,'fi','LÃ¤hetetty onnistuneesti',0),(208313,5787,'no','Postet vellykket',0),(208314,5787,'da','Sendt med succes',0),(208315,5787,'ko','ì„±ê³µì ìœ¼ë¡œ ê²Œì‹œ ë¨',0),(208316,5787,'he','×¤×•×¨×¡× ×‘×”×¦×œ×—×”',0),(208317,5787,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(208318,5787,'zh','æˆåŠŸå‘å¸ƒ\r\n',0),(208319,5787,'sv','Postat framgÃ¥ngsrikt',0),(208320,5787,'it','Inviato con successo',0),(208321,5787,'tl','',0),(208322,5787,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3592;&#3634;&#3585;&#3626;&#3617;&#3640;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(208323,5787,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¥à¤°à¤•à¤¾à¤¶à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¥à¤¾',0),(208324,5787,'ms','Posted berjaya',0),(208325,5787,'ar','Ø£Ø±Ø³Ù„Øª Ø¨Ù†Ø¬Ø§Ø­',0),(208326,5787,'fr','PostÃ© avec succÃ¨s',0),(208327,5787,'jp','è¨ˆä¸Šã?•ã‚Œã?¾ã?—ã?Ÿ',0),(208328,5787,'pt','Postado com sucesso',0),(208329,5787,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾',0),(208330,5787,'es','Asentado Exitosamente',0),(208331,5787,'de','Erfolgreich geschrieben',0),(208332,5787,'en','Posted Successfully',0),(208333,5788,'is','',0),(208334,5788,'dr','Ø§Ø±Ø³Ø§Ù„ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(208335,5788,'pr','Ø§Ø±Ø³Ø§Ù„ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(208336,5788,'tr','Yinelenen defter giriÅŸlerini deftere nakletmek',0),(208337,5788,'pl','Cykliczne zapisy ksiÄ™gi',0),(208338,5788,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ñ‚Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(208339,5788,'ur','Ù…Ú©Ø±Ø± Ú©Ú¾Ø§ØªØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº',0),(208340,5788,'sr','ÐšÑšÐ¸Ð¶ÐµÑšÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸ ÐºÑšÐ¸Ð³Ðµ',0),(208341,5788,'vi','Káº¿t chuyá»ƒn bÃºt toÃ¡n sá»• cÃ¡i Ä‘á»‹nh ká»³',0),(208342,5788,'af','Pos Herhalende Grootboekinskrywings',0),(208343,5788,'ro','ÃŽnregistra intrÄƒrile din registrul de recurente',0),(208344,5788,'et','Korduva pearaamatu kannete konteerimine',0),(208345,5788,'si','KnjiÅ¾ite ponavljajoÄe se postavke',0),(208346,5788,'ba','Posting berulang entri buku besar',0),(208347,5788,'nl','Post terugkerende posten',0),(208348,5788,'fi','Kirjaa toistuvat tapahtumat',0),(208349,5788,'no','BokfÃ¸re gjentakelsesposter finans',0),(208350,5788,'da','Sende gentagelsesposterne finans',0),(208351,5788,'ko','ë˜í’€ì´ ë˜ëŠ” ì›ìž¥ í•­ëª© ê²Œì‹œ',0),(208352,5788,'he','×¤×•×¡×˜ ×¤×§×•×“×•×ª ×™×•×ž×Ÿ ×—×•×–×¨×•×ª',0),(208353,5788,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÏ„Îµ Ï„Î¹Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚',0),(208354,5788,'zh','é‚®æ”¿å®šæœŸèŽ±æ°ä½œå“\r\n',0),(208355,5788,'sv','BokfÃ¶r Ã¥terkommande transaktioner',0),(208356,5788,'it','Registrare movimenti contabili ricorrenti',0),(208357,5788,'tl','',0),(208358,5788,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(208359,5788,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¾à¤¦',0),(208360,5788,'ms','Menghantar penyertaan Lejar yang berulang',0),(208361,5788,'ar','ØªØ±Ø­ÙŠÙ„ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ù…ØªÙƒØ±Ø±Ø©',0),(208362,5788,'fr','Valider des Ã©critures comptables rÃ©currentes',0),(208363,5788,'jp','ç¹°ã‚Šè¿”ã?—å…ƒå¸³ã?®è¨˜å¸³ã‚’è¨ˆä¸Š',0),(208364,5788,'pt','Post movimentos recorrentes',0),(208365,5788,'ru','Ð Ð°Ð·Ð¼ÐµÑ‰Ð°Ñ‚ÑŒ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ ÑƒÑ‡Ñ‚ÐµÐ½Ð½Ñ‹Ñ…',0),(208366,5788,'es','Asentar Entradas de Libro Mayor Recurrentes',0),(208367,5788,'de','Post wiederkehrende Posten',0),(208368,5788,'en','Post Recurring Ledger Entries',0),(208369,5789,'is','',0),(208370,5789,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø«Ø¨ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø±Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(208371,5789,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø«Ø¨ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø±Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(208372,5789,'tr','Yinelenen defter giriÅŸlerini GÃ¼ncelleÅŸtir',0),(208373,5789,'pl','Aktualizacja cykliczne zapisÃ³w ksiÄ™gi',0),(208374,5789,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(208375,5789,'ur','Ù…Ú©Ø±Ø± Ú©Ú¾Ø§ØªØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(208376,5789,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑšÐ¸Ð³Ðµ',0),(208377,5789,'vi','Cáº­p nháº­t bÃºt toÃ¡n sá»• cÃ¡i Ä‘á»‹nh ká»³',0),(208378,5789,'af','Herhalende Grootboekinskrywings Opdateer',0),(208379,5789,'ro','Actualiza intrÄƒrile din registrul de recurente',0),(208380,5789,'et','Korduvad kanded uuendamiseks',0),(208381,5789,'si','Posodobite ponavljajoÄe se postavke',0),(208382,5789,'ba','Memperbarui entri buku besar berulang',0),(208383,5789,'nl','Bijwerken van terugkerende posten',0),(208384,5789,'fi','PÃ¤ivitÃ¤ toistuvat tapahtumat',0),(208385,5789,'no','Oppdatere regelmessig poster',0),(208386,5789,'da','Opdatere tilbagevendende poster',0),(208387,5789,'ko','ë˜í’€ì´ ë˜ëŠ” ë ˆì € í•­ëª© ì—…ë°ì´íŠ¸',0),(208388,5789,'he','×¢×“×›×•×Ÿ ×¤×§×•×“×•×ª ×™×•×ž×Ÿ ×—×•×–×¨×•×ª',0),(208389,5789,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(208390,5789,'zh','èŽ±æ°å®šæœŸæ›´æ–°æ¡ç›®\r\n',0),(208391,5789,'sv','Uppdatera Ã¥terkommande transaktioner',0),(208392,5789,'it','Aggiornamento movimenti contabili ricorrenti',0),(208393,5789,'tl','',0),(208394,5789,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(208395,5789,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(208396,5789,'ms','Kemaskini Terakhir penyertaan Lejar yang berulang',0),(208397,5789,'ar','ØªØ­Ø¯ÙŠØ« Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ© Ø§Ù„Ù…ØªÙƒØ±Ø±Ø©',0),(208398,5789,'fr','Mise Ã  jour pÃ©riodique des Ã©critures comptables',0),(208399,5789,'jp','ç¹°ã‚Šè¿”ã?—å…ƒå¸³ã?®è¨˜å¸³ã‚’æ›´æ–°',0),(208400,5789,'pt','Atualizar movimentos recorrentes',0),(208401,5789,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(208402,5789,'es','Actualizando Entradas de Libro Mayor Recurrentes',0),(208403,5789,'de','Wiederkehrende Posten zu aktualisieren',0),(208404,5789,'en','Update Recurring Ledger Entries',0),(208405,5790,'is','',0),(208406,5790,'dr','Ø¢Ø®Ø±ÙŠÙ† Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø¯Ø± ',0),(208407,5790,'pr','Ø¢Ø®Ø±ÙŠÙ† Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø¯Ø± ',0),(208408,5790,'tr','Son YayÄ±nlanan',0),(208409,5790,'pl','Ostatnio zamieszczone na',0),(208410,5790,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾ Ð½Ð°',0),(208411,5790,'ur','Ø¢Ø®Ø±ÛŒ Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ù¾Ø±',0),(208412,5790,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿ÑƒÑ‚ Ð±Ð¸Ð¾ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½ Ð½Ð°',0),(208413,5790,'vi','Káº¿t chuyá»ƒn cuá»‘i vÃ o ',0),(208414,5790,'af','Laaste Gepos Op',0),(208415,5790,'ro','Ultimele postat pe',0),(208416,5790,'et','Viimati postitatud',0),(208417,5790,'si','Nazadnje objavljen na',0),(208418,5790,'ba','Terakhir dikirim pada',0),(208419,5790,'nl','Laatst gepost op',0),(208420,5790,'fi','Viimeksi lÃ¤hetetty',0),(208421,5790,'no','Sist postet pÃ¥',0),(208422,5790,'da','Sidst indsendt pÃ¥',0),(208423,5790,'ko','ì— ê²Œì‹œ ëœ ë§ˆì§€ë§‰',0),(208424,5790,'he','×”××—×¨×•×Ÿ ×¤×•×¨×¡× ×‘',0),(208425,5790,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î±Ï†Î¯ÏƒÎ± ÎµÏ€Î¬Î½Ï‰',0),(208426,5790,'zh','æœ€åŽå‘å¸ƒæ—¶é—´ï¼š\r\n',0),(208427,5790,'sv','Senast Inlagd pÃ¥',0),(208428,5790,'it','Ultimo pubblicato su',0),(208429,5790,'tl','',0),(208430,5790,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(208431,5790,'hi','à¤ªà¤¿à¤›à¤²à¤¾ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(208432,5790,'ms','Terakhir yang dikirim',0),(208433,5790,'ar','Ø¹Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ Ø¢Ø®Ø±',0),(208434,5790,'fr','PostÃ©e en dernier',0),(208435,5790,'jp','æœ€çµ‚è¨ˆä¸Šæ—¥æ™‚',0),(208436,5790,'pt','Ãšltimo Postado em',0),(208437,5790,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹, ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¾',0),(208438,5790,'es','Asentado la Ãšltima Vez En',0),(208439,5790,'de','Zuletzt am',0),(208440,5790,'en','Last Posted On',0),(208441,5791,'is','',0),(208442,5791,'dr','Ù‡ÙŠÚ† Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø±ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(208443,5791,'pr','Ù‡ÙŠÚ† Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø±ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(208444,5791,'tr','SeÃ§ili hiÃ§bir yinelenen defter giriÅŸleri',0),(208445,5791,'pl','Nie cykliczne wybranych zapisÃ³w ksiÄ™gi',0),(208446,5791,'bg','ÐÐµ Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(208447,5791,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ú©Ø±Ø± Ú©Ú¾Ø§ØªØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù…Ù†ØªØ®Ø¨',0),(208448,5791,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð½Ð°Ð²Ñ™Ð°ÑšÐ° ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾',0),(208449,5791,'vi','ChÆ°a chá»n bÃºt toÃ¡n sá»• cÃ¡i Ä‘á»‹nh ká»³',0),(208450,5791,'af','Geen Herhaaldende Grootboek Inskrywings Geselekteer',0),(208451,5791,'ro','Nu recurente intrÄƒrile din registrul de selectat',0),(208452,5791,'et','Pole korduv andmikukannete valitud',0),(208453,5791,'si','Ni ponavljajoÄih se postavke izbrane',0),(208454,5791,'ba','Tidak ada entri Ledger berulang yang dipilih',0),(208455,5791,'nl','Geen terugkerende posten geselecteerd',0),(208456,5791,'fi','Ei toistuvia tapahtumia valittu',0),(208457,5791,'no','Noen regelmessig poster valgt',0),(208458,5791,'da','Ingen tilbagevendende poster markeret',0),(208459,5791,'ko','ì—†ìŒ ë˜í’€ì´ ë˜ëŠ” ë ˆì € í•­ëª© ì„ íƒ',0),(208460,5791,'he','××™×Ÿ ×¤×§×•×“×•×ª ×™×•×ž×Ÿ ×—×•×–×¨×•×ª ×©× ×‘×—×¨×•',0),(208461,5791,'el','Î”ÎµÎ½ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(208462,5791,'zh','æ²¡æœ‰å·²é€‰çš„å¾ªçŽ¯åˆ†ç±»å¸æ¡ç›®\r\n',0),(208463,5791,'sv','Inga Ã¥terkommande transaktioner markerade',0),(208464,5791,'it','No movimenti contabili ricorrenti selezionati',0),(208465,5791,'tl','',0),(208466,5791,'th','&#3652;&#3617;&#3656;&#3595;&#3657;&#3635;&#3585;&#3633;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(208467,5791,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤šà¤¯à¤¨à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚',0),(208468,5791,'ms','Tiada masukan Lejar berulang yang dipilih',0),(208469,5791,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ù…ØªÙƒØ±Ø±Ø© Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(208470,5791,'fr','Aucune Ã©critures rÃ©currentes sÃ©lectionnÃ©s',0),(208471,5791,'jp','ç¹°ã‚Šè¿”ã?—å…ƒå¸³ã?®è¨˜å¸³ã?Œé?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(208472,5791,'pt','NÃ£o hÃ¡ movimentos recorrentes selecionados',0),(208473,5791,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ…ÑÑ ÑƒÑ‡Ñ‚ÐµÐ½Ð½Ñ‹Ñ… Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(208474,5791,'es','No se Seleccionaron Entradas de Libro Mayor Recurrentes',0),(208475,5791,'de','Keine wiederkehrende Posten ausgewÃ¤hlt',0),(208476,5791,'en','No Recurring Ledger Entries Selected',0),(208477,5792,'is','',0),(208478,5792,'dr','Ø³Ù†Ø¯Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ  Ù‡Ø²ÙŠÙ†Ù‡ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ ',0),(208479,5792,'pr','Ø³Ù†Ø¯Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ  Ù‡Ø²ÙŠÙ†Ù‡ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ ',0),(208480,5792,'tr','Yinelenen fiÅŸ',0),(208481,5792,'pl','Cykliczne Voucher',0),(208482,5792,'bg','ÐŸÐ¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(208483,5792,'ur','Ù…Ú©Ø±Ø± ÙˆØ§Ø¤Ú†Ø±',0),(208484,5792,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(208485,5792,'vi','Phiáº¿u Ä‘á»‹nh ká»³',0),(208486,5792,'af','Herhalende Bewysstuk ',0),(208487,5792,'ro','Recurente Voucher',0),(208488,5792,'et','Korduvad kanne',0),(208489,5792,'si','PonavljajoÄe se kupon',0),(208490,5792,'ba','Voucher berulang',0),(208491,5792,'nl','Terugkerende Voucher',0),(208492,5792,'fi','Toistuva tosite',0),(208493,5792,'no','Regelmessige bilag',0),(208494,5792,'da','Tilbagevendende Voucher',0),(208495,5792,'ko','ë˜í’€ì´ ë°”ìš°ì²˜',0),(208496,5792,'he','×©×•×‘×¨ ×—×•×–×¨×•×ª',0),(208497,5792,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(208498,5792,'zh','å¾ªçŽ¯æœŸåˆ¸\r\n',0),(208499,5792,'sv','Ã…terkommande verifikation',0),(208500,5792,'it','Voucher ricorrenti',0),(208501,5792,'tl','',0),(208502,5792,'th','&#3588;&#3639;&#3609;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(208503,5792,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤µà¤¾à¤‰à¤šà¤°',0),(208504,5792,'ms','Baucar yang berulang',0),(208505,5792,'ar','Ù…Ø³ØªÙ†Ø¯Ø§Øª Ù…ØªÙƒØ±Ù‘Ø±Ø©',0),(208506,5792,'fr','Bon rÃ©current',0),(208507,5792,'jp','ç¹°ã‚Šè¿”ã?—ä¼?ç¥¨',0),(208508,5792,'pt','Voucher recorrente',0),(208509,5792,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(208510,5792,'es','Voucher Recurrente',0),(208511,5792,'de','Wiederkehrende Gutschein',0),(208512,5792,'en','Recurring Voucher',0),(208513,5793,'is','',0),(208514,5793,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(208515,5793,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(208516,5793,'tr','Yinelenen defter giriÅŸlerini GÃ¼ncelleÅŸtir',0),(208517,5793,'pl','Aktualizacja cykliczne zapisÃ³w ksiÄ™gi',0),(208518,5793,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(208519,5793,'ur','Ù…Ú©Ø±Ø± Ú©Ú¾Ø§ØªØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(208520,5793,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑšÐ¸Ð³Ðµ',0),(208521,5793,'vi','Cáº­p Nháº­t BÃºt ToÃ¡n Sá»• CÃ¡i Äá»‹nh Ká»³',0),(208522,5793,'af','Opdateer Herhaalde Grootboekinskrywings',0),(208523,5793,'ro','Actualiza intrÄƒrile din registrul de recurente',0),(208524,5793,'et','Korduvad kanded uuendamiseks',0),(208525,5793,'si','Posodobite ponavljajoÄe se postavke',0),(208526,5793,'ba','Memperbarui entri buku besar berulang',0),(208527,5793,'nl','Bijwerken van terugkerende posten',0),(208528,5793,'fi','PÃ¤ivitÃ¤ toistuvat tapahtumat',0),(208529,5793,'no','Oppdatere regelmessig poster',0),(208530,5793,'da','Opdatere tilbagevendende poster',0),(208531,5793,'ko','ë˜í’€ì´ ë˜ëŠ” ë ˆì € í•­ëª© ì—…ë°ì´íŠ¸',0),(208532,5793,'he','×¢×“×›×•×Ÿ ×¤×§×•×“×•×ª ×™×•×ž×Ÿ ×—×•×–×¨×•×ª',0),(208533,5793,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(208534,5793,'zh','æ›´æ–°å¾ªçŽ¯åˆ†ç±»å¸æ¡ç›®\r\n',0),(208535,5793,'sv','Uppdatera Ã¥terkommande transaktioner',0),(208536,5793,'it','Aggiornamento movimenti contabili ricorrenti',0),(208537,5793,'tl','',0),(208538,5793,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656; GL &#3595;&#3638;&#3656;&#3591;&#3648;&#3585;&#3636;&#3604;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(208539,5793,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(208540,5793,'ms','Kemaskini Terakhir penyertaan Lejar yang berulang',0),(208541,5793,'ar','ØªØ­Ø¯ÙŠØ« Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ù…ØªÙƒØ±Ø±Ø©',0),(208542,5793,'fr','Mise Ã  jour pÃ©riodique des Ã©critures comptables',0),(208543,5793,'jp','ç¹°ã‚Šè¿”ã?—å…ƒå¸³ã?®è¨˜å¸³ã‚’æ›´æ–°',0),(208544,5793,'pt','Atualizar movimentos recorrentes',0),(208545,5793,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(208546,5793,'es','Actualizar Entradas de Libro Mayor Recurrentes',0),(208547,5793,'de','Wiederkehrende Posten zu aktualisieren',0),(208548,5793,'en','Update Recurring Ledger Entries',0),(208549,5794,'is','',0),(208550,5794,'dr','ÙƒÙ„Ù…Ù‡ Ø¯Ø± Ø´Ø±Ø­ ',0),(208551,5794,'pr','ÙƒÙ„Ù…Ù‡ Ø¯Ø± Ø´Ø±Ø­ ',0),(208552,5794,'tr','Kelime aÃ§Ä±klama',0),(208553,5794,'pl','SÅ‚owa w opisie',0),(208554,5794,'bg','Ð”ÑƒÐ¼Ð° Ð² Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸ÐµÑ‚Ð¾',0),(208555,5794,'ur','Ù„ÙØ¸ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª Ù…ÛŒÚº',0),(208556,5794,'sr','Ð ÐµÑ‡ Ñƒ Ð¾Ð¿Ð¸ÑÑƒ',0),(208557,5794,'vi','Tá»« trong diá»…n giáº£i',0),(208558,5794,'af','Woord in Beskrywing',0),(208559,5794,'ro','CuvÃ¢ntul Ã®n Descriere',0),(208560,5794,'et','Kirjeldus',0),(208561,5794,'si','Besede v opis',0),(208562,5794,'ba','Kata keterangan',0),(208563,5794,'nl','Word in beschrijving',0),(208564,5794,'fi','Sanan kuvaus',0),(208565,5794,'no','Ord i Beskrivelse',0),(208566,5794,'da','Ord i beskrivelsen',0),(208567,5794,'ko','ë‹¨ì–´ ì„¤ëª…ì—',0),(208568,5794,'he','Word ×‘×ª×™××•×¨',0),(208569,5794,'el','Î›Î­Î¾Î· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(208570,5794,'zh','æè¿°å­—å¥\r\n',0),(208571,5794,'sv','Ord i beskrivningen',0),(208572,5794,'it','Parola nella descrizione',0),(208573,5794,'tl','',0),(208574,5794,'th','&#3588;&#3635;&#3651;&#3609;&#3585;&#3634;&#3619;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(208575,5794,'hi','à¤¶à¤¬à¥à¤¦ à¤µà¤°à¥à¤£à¤¨ à¤®à¥‡à¤‚',0),(208576,5794,'ms','Perkataan penerangan',0),(208577,5794,'ar','ÙƒÙ„Ù…Ø© ÙÙŠ ÙˆØµÙ',0),(208578,5794,'fr','Mot dans la Description',0),(208579,5794,'jp','èª¬æ˜Žå†…ã?®å?˜èªž',0),(208580,5794,'pt','Palavra na descriÃ§Ã£o',0),(208581,5794,'ru','Ð¡Ð»Ð¾Ð²Ð¾ Ð² ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ð¸',0),(208582,5794,'es','DescripciÃ³n Palabra en',0),(208583,5794,'de','Wort in Beschreibung',0),(208584,5794,'en','Word in Description',0),(208585,5795,'is','',0),(208586,5795,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡',0),(208587,5795,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡',0),(208588,5795,'tr','Yinelenen giriÅŸ Ekle/GÃ¼ncelle',0),(208589,5795,'pl','Cykliczne wpis Dodaj/Aktualizuj',0),(208590,5795,'bg','ÐŸÐ¾Ð²Ñ‚Ð°Ñ€ÑÑ‰ ÑÐµ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(208591,5795,'ur','Ø¨Ø§Ø± Ø¨Ø§Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(208592,5795,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð”Ð¾Ð´Ð°Ñ˜/ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜',0),(208593,5795,'vi','ThÃªm/Cáº­p Nháº­t Entry Äá»‹nh Ká»³',0),(208594,5795,'af','Herhaaldende Inskrywings Byvoeg/Opdateer',0),(208595,5795,'ro','Adauga/Actualizeaza intrari recurente ',0),(208596,5795,'et','Korduvad kanne lisamine/uuendamine',0),(208597,5795,'si','PonavljajoÄe se vnos Dodaj/posodobi',0),(208598,5795,'ba','Berulang entri Tambahkan/Perbarui',0),(208599,5795,'nl','Terugkerende item toevoegen/bijwerken',0),(208600,5795,'fi','Toistuva tapahtuma lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(208601,5795,'no','Regelmessige oppfÃ¸ring/Oppdater',0),(208602,5795,'da','Tilbagevendende post TilfÃ¸j/opdater',0),(208603,5795,'ko','ë˜í’€ì´ í•­ëª© ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(208604,5795,'he','×—×•×–×¨×•×ª ×›× ×™×¡×” ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(208605,5795,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½Î· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(208606,5795,'zh','å¢žåŠ /æ›´æ–°å¾ªçŽ¯æ¡ç›®\r\n',0),(208607,5795,'sv','Ã…terkommande post LÃ¤gg till/uppdatera',0),(208608,5795,'it','Ricorrente voce Aggiungi/Aggiorna',0),(208609,5795,'tl','',0),(208610,5795,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3656;&#3629;&#3618; &#3654;',0),(208611,5795,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(208612,5795,'ms','Berulang kemasukan Tambah/Kemaskini',0),(208613,5795,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ù…ØªÙƒØ±Ù‘Ø±Ø©',0),(208614,5795,'fr','RÃ©current entrÃ©e ajout/mise Ã  jour',0),(208615,5795,'jp','ç¹°ã‚Šè¿”ã?—è¨˜å¸³ã€€è¿½åŠ /æ›´æ–°',0),(208616,5795,'pt','Recorrente entrada adicionar/atualizar',0),(208617,5795,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(208618,5795,'es','Entrada Recurrente Agregar/Actualizar',0),(208619,5795,'de','Wiederkehrenden Eintrag hinzufÃ¼gen/aktualisieren',0),(208620,5795,'en','Recurring Entry Add/Update',0),(208621,5796,'is','',0),(208622,5796,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø«Ø¨ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø±Ø´ÙˆÙ†Ø¯Ù‡ ',0),(208623,5796,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø«Ø¨ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø±Ø´ÙˆÙ†Ø¯Ù‡ ',0),(208624,5796,'tr','Yinelenen giriÅŸler girin/gÃ¼ncelleme',0),(208625,5796,'pl','WprowadÅº/aktualizacja ksiÄ™gowania okresowe',0),(208626,5796,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(208627,5796,'ur','Ù…Ú©Ø±Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(208628,5796,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(208629,5796,'vi','Nháº­p/Cáº­p Nháº­t BÃºt ToÃ¡n Äá»‹nh Ká»³',0),(208630,5796,'af','Invoer/Opdateer Herhalende Inskrywings',0),(208631,5796,'ro','IntroduceÅ£i/actualizare intrÄƒri recurente',0),(208632,5796,'et','Korduvaid kandeid sisestamine/ajakohastamine',0),(208633,5796,'si','Vnos/posodobitev ponavljajoÄih se postavkah',0),(208634,5796,'ba','Masukkan/Update berulang entri',0),(208635,5796,'nl','Periodieke posten invoeren/bijwerken',0),(208636,5796,'fi','PÃ¤ivittÃ¤minen toistuvia tapahtumia',0),(208637,5796,'no','Angi/Oppdater gjentakelsesposter',0),(208638,5796,'da','Indtaste/opdatere gentagelsesposterne',0),(208639,5796,'ko','ë˜í’€ì´ í•­ëª© ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(208640,5796,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×¢×¨×›×™× ×—×•×–×¨×™×',0),(208641,5796,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(208642,5796,'zh','è¾“å…¥/æ›´æ–°å‘¨æœŸæ€§æ¡ç›®',0),(208643,5796,'sv','Ange/uppdatera Ã¥terkommande poster',0),(208644,5796,'it','Inserire o aggiornare le registrazioni periodiche',0),(208645,5796,'tl','',0),(208646,5796,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3604;&#3595;&#3657;&#3635;',0),(208647,5796,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(208648,5796,'ms','Masukkan/Kemaskini entri berulang',0),(208649,5796,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ù…ØªÙƒØ±Ù‘Ø±Ø©',0),(208650,5796,'fr','Entrez/mise Ã  jour des entrÃ©es rÃ©currentes',0),(208651,5796,'jp','å??å¾©å…¥åŠ›ã?®å…¥åŠ›/æ›´æ–°',0),(208652,5796,'pt','Inserir/atualizar entradas recorrentes',0),(208653,5796,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ…ÑÑ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(208654,5796,'es','Introducir/Actualizar Entradas Recurrentes',0),(208655,5796,'de','Geben Sie/Update Dauerbuchungen',0),(208656,5796,'en','Enter/Update Recurring Entries',0),(208657,5797,'is','',0),(208658,5797,'dr','Ø§Ø±Ø³Ø§Ù„ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ ',0),(208659,5797,'pr','Ø§Ø±Ø³Ø§Ù„ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ ',0),(208660,5797,'tr','Yinelenen giriÅŸleri',0),(208661,5797,'pl','Cykliczne wpisÃ³w',0),(208662,5797,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ñ‚Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(208663,5797,'ur','Ù…Ú©Ø±Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº',0),(208664,5797,'sr','ÐšÑšÐ¸Ð¶ÐµÑšÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸',0),(208665,5797,'vi','Káº¿t chuyá»ƒn bÃºt toÃ¡n Ä‘á»‹nh ká»³',0),(208666,5797,'af','Pos Herhalende Inskrywings',0),(208667,5797,'ro','ÃŽnregistra intrÄƒri recurente',0),(208668,5797,'et','PÃ¤rast korduvaid kandeid',0),(208669,5797,'si','KnjiÅ¾ite ponavljajoÄe se postavke',0),(208670,5797,'ba','Mengirim entri berulang',0),(208671,5797,'nl','Terugkerende posten',0),(208672,5797,'fi','Kirjaamaan toistuvia tapahtumia',0),(208673,5797,'no','BokfÃ¸re gjentakelsesposter',0),(208674,5797,'da','Sende gentagelsesposterne',0),(208675,5797,'ko','ë˜í’€ì´ ë˜ëŠ” í•­ëª© ê²Œì‹œ',0),(208676,5797,'he','×œ×›×ª×•×‘ ×¢×¨×›×™× ×—×•×–×¨×™×',0),(208677,5797,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½Ï‰Î½ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(208678,5797,'zh','å‘å¸ƒå¾ªçŽ¯æ¡ç›®\r\n',0),(208679,5797,'sv','BokfÃ¶r Ã¥terkommande poster',0),(208680,5797,'it','Inviare le voci ricorrenti',0),(208681,5797,'tl','',0),(208682,5797,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3604;&#3586;&#3638;&#3657;&#3609;&#3629;&#3637;&#3585;&#3588;&#3619;&#3',0),(208683,5797,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¾à¤¦',0),(208684,5797,'ms','Post entri berulang',0),(208685,5797,'ar','ØªØ±Ø­ÙŠÙ„ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ù…ØªÙƒØ±Ù‘Ø±Ø©',0),(208686,5797,'fr','Valider les Ã©critures pÃ©riodiques',0),(208687,5797,'jp','ç¹°ã‚Šè¿”ã?—è¨˜å…¥ã‚’è¨˜å¸³',0),(208688,5797,'pt','Postar entradas recorrentes',0),(208689,5797,'ru','ÐŸÐ¾ÑÐ»Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ…ÑÑ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(208690,5797,'es','Asentar Entradas Recurrentes',0),(208691,5797,'de','Post Dauerbuchungen',0),(208692,5797,'en','Post Recurring Entries',0),(208693,5798,'is','',0),(208694,5798,'dr','Ø§Ø±Ø³Ø§Ù„ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(208695,5798,'pr','Ø§Ø±Ø³Ø§Ù„ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(208696,5798,'tr','Yinelenen defter giriÅŸlerini deftere nakletmek',0),(208697,5798,'pl','Cykliczne zapisy ksiÄ™gi',0),(208698,5798,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ñ‚Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(208699,5798,'ur','Ù…Ú©Ø±Ø± Ú©Ú¾Ø§ØªØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº',0),(208700,5798,'sr','ÐšÑšÐ¸Ð¶ÐµÑšÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸ ÐºÑšÐ¸Ð³Ðµ',0),(208701,5798,'vi','Káº¿t Chuyá»ƒn BÃºt ToÃ¡n Sá»• CÃ¡i Äá»‹nh Ká»³',0),(208702,5798,'af','Pos Herhalende Grootboekinskrywings',0),(208703,5798,'ro','ÃŽnregistra intrÄƒrile din registrul de recurente',0),(208704,5798,'et','Korduva pearaamatu kannete konteerimine',0),(208705,5798,'si','KnjiÅ¾ite ponavljajoÄe se postavke',0),(208706,5798,'ba','Posting berulang entri buku besar',0),(208707,5798,'nl','Post terugkerende posten',0),(208708,5798,'fi','Kirjaa toistuvat tapahtumat',0),(208709,5798,'no','BokfÃ¸re gjentakelsesposter finans',0),(208710,5798,'da','Sende gentagelsesposterne finans',0),(208711,5798,'ko','ë˜í’€ì´ ë˜ëŠ” ì›ìž¥ í•­ëª© ê²Œì‹œ',0),(208712,5798,'he','×¤×•×¡×˜ ×¤×§×•×“×•×ª ×™×•×ž×Ÿ ×—×•×–×¨×•×ª',0),(208713,5798,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÏ„Îµ Ï„Î¹Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚',0),(208714,5798,'zh','å‘å¸ƒå¾ªçŽ¯åˆ†ç±»å¸æ¡ç›®\r\n',0),(208715,5798,'sv','BokfÃ¶r Ã¥terkommande transaktioner',0),(208716,5798,'it','Registrare movimenti contabili ricorrenti',0),(208717,5798,'tl','',0),(208718,5798,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(208719,5798,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¾à¤¦',0),(208720,5798,'ms','Menghantar penyertaan Lejar yang berulang',0),(208721,5798,'ar','ØªØ±Ø­ÙŠÙ„ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ù…ØªÙƒØ±Ø±Ø©',0),(208722,5798,'fr','Valider des Ã©critures comptables rÃ©currentes',0),(208723,5798,'jp','å??å¾©å…ƒå¸³å…¥åŠ›ã?®è¨ˆä¸Š',0),(208724,5798,'pt','Post movimentos recorrentes',0),(208725,5798,'ru','Ð Ð°Ð·Ð¼ÐµÑ‰Ð°Ñ‚ÑŒ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ ÑƒÑ‡Ñ‚ÐµÐ½Ð½Ñ‹Ñ…',0),(208726,5798,'es','Asentar Entradas del Libro Mayor Recurrentes',0),(208727,5798,'de','Post wiederkehrende Posten',0),(208728,5798,'en','Post Recurring Ledger Entries',0),(208729,5799,'is','',0),(208730,5799,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(208731,5799,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(208732,5799,'tr','Yinelenen defter giriÅŸleri',0),(208733,5799,'pl','Cykliczne zapisÃ³w ksiÄ™gi',0),(208734,5799,'bg','ÐŸÐ¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(208735,5799,'ur','Ù…Ú©Ø±Ø± Ú©Ú¾Ø§ØªØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(208736,5799,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑšÐ¸Ð³Ðµ',0),(208737,5799,'vi','BÃºt ToÃ¡n Sá»• CÃ¡i Äá»‹nh Ká»³',0),(208738,5799,'af','Herhalende Grootboekinskrywings',0),(208739,5799,'ro','IntrÄƒrile din registrul de recurente',0),(208740,5799,'et','Korduvad kanded',0),(208741,5799,'si','PonavljajoÄe se postavke',0),(208742,5799,'ba','Berulang entri buku besar',0),(208743,5799,'nl','Terugkerende posten',0),(208744,5799,'fi','Toistuvat tapahtumat',0),(208745,5799,'no','Periodiske poster',0),(208746,5799,'da','Tilbagevendende poster',0),(208747,5799,'ko','ë˜í’€ì´ ë˜ëŠ” ë ˆì € í•­ëª©',0),(208748,5799,'he','×¤×§×•×“×•×ª ×™×•×ž×Ÿ ×—×•×–×¨×•×ª',0),(208749,5799,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(208750,5799,'zh','å¾ªçŽ¯åˆ†ç±»å¸æ¡ç›®\r\n',0),(208751,5799,'sv','Ã…terkommande transaktioner',0),(208752,5799,'it','Movimenti contabili ricorrenti',0),(208753,5799,'tl','',0),(208754,5799,'th','&#3585;&#3619;&#3629;&#3585;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(208755,5799,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚',0),(208756,5799,'ms','Penyertaan Lejar yang berulang',0),(208757,5799,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ù…ØªÙƒØ±Ø±Ø©',0),(208758,5799,'fr','RÃ©current des Ã©critures comptables',0),(208759,5799,'jp','ç¹°ã‚Šè¿”ã?—å…ƒå¸³è¨˜å¸³',0),(208760,5799,'pt','Movimentos recorrentes',0),(208761,5799,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(208762,5799,'es','Entradas Recurrentes de Libro Mayor',0),(208763,5799,'de','Wiederkehrende Posten',0),(208764,5799,'en','Recurring Ledger Entries',0),(208765,5800,'is','',0),(208766,5800,'dr','(ØªØªÙ…Ù‡ Ø­Ø³Ø§Ø¨) Ø¨ÛŒÙ„Ø§Ù†Ø³ Ø§ÙØªØªØ§Ø­ÙŠÙ‡',0),(208767,5800,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ±(ØªØªÙ…Ù‡ Ø­Ø³Ø§Ø¨) ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡',0),(208768,5800,'tr','Bakiye faturayÄ± baÅŸlayan Ekle',0),(208769,5800,'pl','DodaÄ‡ poczÄ…wszy od rÃ³wnowagi faktury',0),(208770,5800,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(208771,5800,'ur','ØªÙˆØ§Ø²Ù† Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø¢ØºØ§Ø² Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(208772,5800,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ‡Ð¸ÑšÐµ ÑÐ°Ð»Ð´Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(208773,5800,'vi','ThÃªm hÃ³a Ä‘Æ¡n sá»‘ dÆ° báº¯t Ä‘áº§u ',0),(208774,5800,'af','Begin Balans Faktuur Byvoeg',0),(208775,5800,'ro','Adauga Ã®nceput soldul facturii',0),(208776,5800,'et','Lisada alates jÃ¤Ã¤ksumma arve',0),(208777,5800,'si','Dodaj zaÄetek saldo raÄuna',0),(208778,5800,'ba','Tambahkan mulai saldo faktur',0),(208779,5800,'nl','Begin evenwicht factuur toevoegen',0),(208780,5800,'fi','LisÃ¤Ã¤ alkaa tasapaino laskun',0),(208781,5800,'no','Legge til begynnelsen balanse faktura',0),(208782,5800,'da','TilfÃ¸je begynder Balance faktura',0),(208783,5800,'ko','ì‹œìž‘ ê· í˜• ì†¡ìž¥ ì¶”ê°€',0),(208784,5800,'he','×œ×”×•×¡×™×£ ×”×—×œ ××™×–×•×Ÿ ×—×©×‘×•× ×™×ª',0),(208785,5800,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î±ÏÏ‡Î¯Î¶ÎµÎ¹ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(208786,5800,'zh','æ–°å¢žæœŸåˆå‘ç¥¨\r\n',0),(208787,5800,'sv','LÃ¤gg till bÃ¶rjan balans faktura',0),(208788,5800,'it','Aggiungere all\'inizio Saldo fattura',0),(208789,5800,'tl','',0),(208790,5800,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604;',0),(208791,5800,'hi','à¤¶à¥à¤°à¥à¤†à¤¤ à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(208792,5800,'ms','Tambah bermula invois baki',0),(208793,5800,'ar','Ø£Ø¶Ù Ø§Ø¨ØªØ¯Ø§Ø¡ Ù…Ù† Ø±ØµÙŠØ¯ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(208794,5800,'fr','Ajouter commenÃ§ant la facture de solde',0),(208795,5800,'jp','æœŸé¦–æ®‹é«˜è«‹æ±‚æ›¸ã?®è¿½åŠ ',0),(208796,5800,'pt','Adicionar comeÃ§ando a factura de equilÃ­brio',0),(208797,5800,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð°Ñ‡Ð¸Ð½Ð°Ñ Ð±Ð°Ð»Ð°Ð½Ñ ÑÑ‡ÐµÑ‚Ð°',0),(208798,5800,'es','Agregar Factura de Saldo de Inicio',0),(208799,5800,'de','FÃ¼gen Sie Beginn Gleichgewicht Rechnung hinzu',0),(208800,5800,'en','Add Beginning Balance Invoice',0),(208801,5801,'is','',0),(208802,5801,'dr','ØªØ§Ø±ÙŠØ® Ø§ÙˆÙ„ÙŠÙ‡ ÙØ§ÙƒØªÙˆØ± ',0),(208803,5801,'pr','ØªØ§Ø±ÙŠØ® Ø§ÙˆÙ„ÙŠÙ‡ ÙØ§ÙƒØªÙˆØ± ',0),(208804,5801,'tr','Orijinal fatura tarihi',0),(208805,5801,'pl','Oryginalny Data faktury',0),(208806,5801,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÐµÐ½ Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(208807,5801,'ur','Ø§ØµÙ„ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(208808,5801,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(208809,5801,'vi','NgÃ y hÃ³a Ä‘Æ¡n gá»‘c',0),(208810,5801,'af','Oorspronklike Faktuur Datum',0),(208811,5801,'ro','Data facturii originale',0),(208812,5801,'et','Algse arve kuupÃ¤ev',0),(208813,5801,'si','Prvotni datum raÄuna',0),(208814,5801,'ba','Asli tanggal faktur',0),(208815,5801,'nl','Oorspronkelijke factuurdatum',0),(208816,5801,'fi','AlkuperÃ¤isen laskun luontipÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(208817,5801,'no','Opprinnelige fakturadatoen',0),(208818,5801,'da','Originale fakturadato',0),(208819,5801,'ko','ì›ëž˜ ì†¡ìž¥ ë‚ ì§œ',0),(208820,5801,'he','×ª××¨×™×š ×—×©×‘×•× ×™×ª ×ž×§×•×¨×™×ª',0),(208821,5801,'el','Î‘ÏÏ‡Î¹ÎºÎ® Î—Î¼/Î½Î¯Î± Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(208822,5801,'zh','åŽŸå§‹å‘ç¥¨æ—¥æœŸ\r\n',0),(208823,5801,'sv','Ursprungliga fakturadatum',0),(208824,5801,'it','Data della fattura originale',0),(208825,5801,'tl','',0),(208826,5801,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3604;&#3633;&#3657;&#3591;&#3648;&#3604;&#3636;&#3617;',0),(208827,5801,'hi','à¤®à¥‚à¤² à¤šà¤¾à¤²à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿',0),(208828,5801,'ms','Tarikh invois asal',0),(208829,5801,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø£ØµÙ„ÙŠØ©',0),(208830,5801,'fr','Date de la facture originale',0),(208831,5801,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«è«‹æ±‚æ—¥',0),(208832,5801,'pt','Data da factura original',0),(208833,5801,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð”Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð°',0),(208834,5801,'es','Fecha de Factura Original',0),(208835,5801,'de','UrsprÃ¼nglichen Rechnungsdatum',0),(208836,5801,'en','Original Invoice Date',0),(208837,5802,'is','',0),(208838,5802,'dr','(Ø¨ÛŒÙ„Ø§Ù†Ø³Ù‡Ø§ÙŠ) Ù„ÛŒØ¬Ø± Ø§Ø«Ø± Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø¯Ø§Ø´Øª ',0),(208839,5802,'pr','Ø±ÙˆÙŠ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ (ØªØ±Ø§Ø²Ù‡Ø§ÙŠ) Ø¯ÙØªØ± ÙƒÙ„ Ø§Ø«Ø± Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø¯Ø§Ø´Øª ',0),(208840,5802,'tr','(GL bakiyeleri etkilemez)',0),(208841,5802,'pl','(Nie wpÅ‚ynie GL salda)',0),(208842,5802,'bg','(ÐÑÐ¼Ð° Ð´Ð° ÑÐµ Ð¾Ñ‚Ñ€Ð°Ð·Ð¸ GL ÑÐ°Ð»Ð´Ð°)',0),(208843,5802,'ur','(Ø¬ÛŒØ¬Û’ Ø¨ÛŒÙ„Ù†Ø³ Ù…ØªØ§Ø«Ø± Ù†ÛÛŒÚº ÛÙˆ Ú¯ÛŒ)',0),(208844,5802,'sr','(ÐÐµÑ›Ðµ ÑƒÑ‚Ð¸Ñ†Ð°Ñ‚Ð¸ Ð½Ð° Ð“Ð› ÑÐ°Ð»Ð´Ð°)',0),(208845,5802,'vi','(KhÃ´ng áº£nh hÆ°á»Ÿng Ä‘áº¿n sá»‘ dÆ° sá»• cÃ¡i)',0),(208846,5802,'af','(Sal nie AG Balanse affekteer nie)',0),(208847,5802,'ro','Nu va afecta GL',0),(208848,5802,'et','Ei mÃµjuta pearaamatu bilanssi',0),(208849,5802,'si','(Ne bo vplivalo na GL bilance)',0),(208850,5802,'ba','(Tidak akan mempengaruhi saldo GL)',0),(208851,5802,'nl','(Geen invloed op GL saldi)',0),(208852,5802,'fi','(Ei vaikuta GL saldot)',0),(208853,5802,'no','(Vil ikke pÃ¥virke GL balanserer)',0),(208854,5802,'da','(Vil ikke pÃ¥virke GL saldi)',0),(208855,5802,'ko','(ì˜í–¥ì„ ì£¼ì§€ ì•ŠìŠµë‹ˆë‹¤ GL ê· í˜•)',0),(208856,5802,'he','(×œ× ×™×©×¤×™×¢×• ×¢×œ ×™×ª×¨×•×ª GL)',0),(208857,5802,'el','(Î”ÎµÎ½ Î¸Î± ÎµÏ€Î·ÏÎµÎ¬ÏƒÎµÎ¹ Ï„Î± Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î± GL)',0),(208858,5802,'zh','ï¼ˆä¸ä¼šå½±å“æ€»å¸ç»“ä½™ï¼‰\r\n',0),(208859,5802,'sv','(PÃ¥verkar inte GL saldon)',0),(208860,5802,'it','(Non influirÃ  saldi GL)',0),(208861,5802,'tl','',0),(208862,5802,'th','(Will not affect GL Balances)',0),(208863,5802,'hi','(GL à¤¶à¥‡à¤· à¤ªà¥à¤°à¤­à¤¾à¤µà¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤—à¤¾)',0),(208864,5802,'ms','(Tidak akan mempengaruhi baki GL)',0),(208865,5802,'ar','(Ù„Ù† ØªØ¤Ø«Ø± Ø¹Ù„Ù‰ Ø£Ø±ØµØ¯Ø© GL)',0),(208866,5802,'fr','(N\'affectera pas de soldes GL)',0),(208867,5802,'jp','ï¼ˆï¼§ï¼¬ãƒ?ãƒ©ãƒ³ã‚¹ã?«ã?¯å½±éŸ¿ã?—ã?ªã?„ï¼‰',0),(208868,5802,'pt','(NÃ£o afetarÃ¡ os saldos GL)',0),(208869,5802,'ru','(ÐÐµ Ð²Ð»Ð¸ÑÐµÑ‚ Ð½Ð° Ð±Ð°Ð»Ð°Ð½Ñ GL)',0),(208870,5802,'es','(No se afectarÃ¡n los Balances LM',0),(208871,5802,'de','(GL Salden wirkt sich nicht)',0),(208872,5802,'en','(Will not affect GL Balances)',0),(208873,5803,'is','',0),(208874,5803,'dr','(ØªØ³ÙˆÙŠÙ‡) Ø­Ø³Ø§Ø¨ Ø¨ÛŒØ¬Ú© Ø¨ÛŒÙ„Ø§Ù†Ø³ Ø§ÙØªØªØ§Ø­ÙŠÙ‡',0),(208875,5803,'pr',' Ø«Ø¨Øª Ù¾Ø§ÙŠØ§Ù¾Ø§ÙŠ(ØªØ³ÙˆÙŠÙ‡) Ø­Ø³Ø§Ø¨ ÙØ§ÙƒØªÙˆØ± ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡',0),(208876,5803,'tr','Bakiye faturayÄ± baÅŸlayan giriÅŸ mahsup',0),(208877,5803,'pl','PoczÄ…wszy od rÃ³wnowagi faktury przesuniÄ™cie wejÅ›cia',0),(208878,5803,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐžÑ‚Ð¼ÐµÑÑ‚ÐµÐ½Ð¾ Ð²ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ',0),(208879,5803,'ur','Ø¢ÙØ³Ù¹ Ø§Ù†Ø¯Ø±Ø§Ø¬ ØªÙˆØ§Ø²Ù† Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¨ØªØ¯Ø§Ø¡',0),(208880,5803,'sr','ÐŸÐ¾Ñ‡Ð¸ÑšÐµ ÑÐ°Ð»Ð´Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¿Ð¾Ð¼Ð°Ðº ÑÑ‚Ð°Ð²ÐºÐ°',0),(208881,5803,'vi','BÃºt ToÃ¡n XÃ³a Sá»‘ DÆ° Äáº§u Ká»³ Cá»§a HÃ³a ÄÆ¡n',0),(208882,5803,'af','Faktuur Beginbalans \"Offset\" Inskrywing',0),(208883,5803,'ro','ÃŽncepÃ¢nd cu soldul facturii compensa intrare',0),(208884,5803,'et','Alguses bilansi arve tasakaalustatud kanne',0),(208885,5803,'si','ZaÄetek saldo raÄuna izravnavo vstop',0),(208886,5803,'ba','Mulai saldo faktur mengimbangi entri',0),(208887,5803,'nl','Begin evenwicht factuur gecompenseerd Entry',0),(208888,5803,'fi','Alkaa tasapaino lasku tasoittaa merkintÃ¤',0),(208889,5803,'no','Begynner balanse faktura forskyvning oppfÃ¸ring',0),(208890,5803,'da','Begyndende Balance faktura udligne posten',0),(208891,5803,'ko','í•­ëª©ì„ ì˜¤í”„ì…‹ ì‹œìž‘ ìž”ì•¡ ì²­êµ¬ì„œ',0),(208892,5803,'he','×”×—×œ ××™×–×•×Ÿ ×—×©×‘×•× ×™×ª ×œ×§×–×– ×›× ×™×¡×”',0),(208893,5803,'el','Î‘ÏÏ‡Î®Ï‚ Î³ÎµÎ½Î¿Î¼Î­Î½Î·Ï‚ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±Î½Ï„Î¹ÏƒÏ„Î¬Î¸Î¼Î¹ÏƒÎ· ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(208894,5803,'zh','æœŸåˆå‘ç¥¨å†²é”€æ¡ç›®\r\n',0),(208895,5803,'sv','BÃ¶rjan balans faktura kompensera intrÃ¤de',0),(208896,5803,'it','Inizio Saldo fattura compensata voce',0),(208897,5803,'tl','',0),(208898,5803,'th','&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3650;&#3605;&#3657;&#3605;&#3629;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3',0),(208899,5803,'hi','à¤¶à¥à¤°à¥à¤†à¤¤ à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤‘à¤«à¤¸à¥‡à¤Ÿ',0),(208900,5803,'ms','Bermula invois baki mengimbangi kemasukan',0),(208901,5803,'ar','Ø§Ø¨ØªØ¯Ø§Ø¡ Ù…Ù† Ø±ØµÙŠØ¯ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¥Ø²Ø§Ø­Ø© Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(208902,5803,'fr','CommenÃ§ant la facture de solde compensÃ© entrÃ©e',0),(208903,5803,'jp','æœŸé¦–æ®‹é«˜è«‹æ±‚æ›¸ç›¸æ®ºå…¥åŠ›',0),(208904,5803,'pt','ComeÃ§ando a factura de equilÃ­brio Offset entrada',0),(208905,5803,'ru','ÐÐ°Ñ‡Ð¸Ð½Ð°Ñ Ð±Ð°Ð»Ð°Ð½Ñ ÑÑ‡ÐµÑ‚Ð° ÐºÐ¾Ð¼Ð¿ÐµÐ½ÑÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²Ñ…Ð¾Ð´',0),(208906,5803,'es','Factura de Entada de Offset de Saldo de Inicio',0),(208907,5803,'de','Beginn Gleichgewicht Rechnung ausgleichen Eintrag',0),(208908,5803,'en','Beginning Balance Invoice Offset Entry',0),(208909,5804,'is','',0),(208910,5804,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙŠÙ‡ ',0),(208911,5804,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙŠÙ‡ ',0),(208912,5804,'tr','Bakiyeleri baÅŸlayan Ekle',0),(208913,5804,'pl','DodaÄ‡ poczÄ…wszy od salda',0),(208914,5804,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½ÑÐ¸',0),(208915,5804,'ur','Ø¨ÛŒÙ„Ù†Ø³ Ú©Û’ Ø¢ØºØ§Ø² Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(208916,5804,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ‡Ð¸ÑšÐµ ÑÐ°Ð»Ð´Ð°',0),(208917,5804,'vi','ThÃªm Sá»‘ DÆ° Äáº§u',0),(208918,5804,'af','Voer Beginbalanse in',0),(208919,5804,'ro','Adauga Balantele Initiale',0),(208920,5804,'et','Lisa algsaldod',0),(208921,5804,'si','Dodaj zaÄetek bilance',0),(208922,5804,'ba','Memasukkan Saldo Awal',0),(208923,5804,'nl','Toevoegen vanaf saldi',0),(208924,5804,'fi','LisÃ¤Ã¤ alkusaldot',0),(208925,5804,'no','Legge til begynnelsen saldoer',0),(208926,5804,'da','TilfÃ¸je begynder saldi',0),(208927,5804,'ko','ì‹œìž‘ ìž”ì•¡ ì¶”ê°€',0),(208928,5804,'he','×”×•×¡×£ ×ž××–× ×™× ×”×ª×—×œ×ª×™×™×',0),(208929,5804,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î±ÏÏ‡Î¯Î¶Î¿Î½Ï„Î±Ï‚ Ï„Î± Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î±',0),(208930,5804,'zh','å¢žåŠ åˆæœŸä½™é¢\r\n',0),(208931,5804,'sv','LÃ¤gg till bÃ¶rjan saldon',0),(208932,5804,'it','Aggiungere all\'inizio saldi',0),(208933,5804,'tl','',0),(208934,5804,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3618;&#3629;&#3604;&#3618;&#3585;&#3617;&#3634;',0),(208935,5804,'hi','à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤•à¥€ à¤¶à¥à¤°à¥à¤†à¤¤ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(208936,5804,'ms','Tambah bermula baki',0),(208937,5804,'ar','Ø£Ø¶Ù Ø£Ø±ØµØ¯Ø© Ø¥ÙØªØªØ§Ø­ÙŠØ©',0),(208938,5804,'fr','Ajouter DÃ©but des soldes',0),(208939,5804,'jp','é–‹å§‹ãƒ?ãƒ©ãƒ³ã‚¹ã‚’è¿½åŠ ',0),(208940,5804,'pt','Adicionar comeÃ§ando saldos',0),(208941,5804,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð‘Ð°Ð»Ð°Ð½Ñ',0),(208942,5804,'es','Agregar Balance Inicial',0),(208943,5804,'de','FÃ¼gen Sie Anfang Salden',0),(208944,5804,'en','Add Beginning Balances',0),(208945,5805,'is','',0),(208946,5805,'dr','Ø«Ø¨Øª ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ',0),(208947,5805,'pr','Ø«Ø¨Øª ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ',0),(208948,5805,'tr','BaÅŸlangÄ±Ã§ bakiyesi faturalar (sadece baÅŸlangÄ±Ã§ iÃ§in) girin',0),(208949,5805,'pl','WprowadÅº poczÄ…tek saldo faktury (do uruchamiania tylko)',0),(208950,5805,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ (Ð·Ð° ÑÑ‚Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ ÑÐ°Ð¼Ð¾)',0),(208951,5805,'ur','Ø¢ØºØ§Ø² ØªÙˆØ§Ø²Ù† ÙˆØ¨Ø¬Ù„ÛŒ (Ú©Û’ Ù„Ø¦Û’ ÙÙ‚Ø· Ø¢ØºØ§Ø²) Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(208952,5805,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð¾Ñ‡ÐµÑ‚Ð°Ðº ÑÐ°Ð»Ð´Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ (Ð·Ð° Ð¿Ð¾ÐºÑ€ÐµÑ‚Ð°ÑšÐµ ÑÐ°Ð¼Ð¾)',0),(208953,5805,'vi','Nháº­p sá»‘ dÆ° hÃ³a Ä‘Æ¡n Ä‘áº§u ká»³ (chá»‰ khi báº¯t Ä‘áº§u)',0),(208954,5805,'af','Voer Fakture Beginbalans In (slegs vir nuwe onderneming)',0),(208955,5805,'ro','IntroduceÅ£i Ã®nceputul soldul facturilor (pentru startup numai)',0),(208956,5805,'et','Sisestage alguse saldo arved (startup ainult)',0),(208957,5805,'si','Vnesite zaÄetek raÄune bilance (za zaÄetek samo)',0),(208958,5805,'ba','Masukkan awal saldo faktur (untuk startup)',0),(208959,5805,'nl','Begin evenwicht facturen invoeren (voor opstarten alleen)',0),(208960,5805,'fi','Kirjoita alussa tasapaino laskut (kÃ¤ynnistys)',0),(208961,5805,'no','Angi begynnelsen balanse fakturaer (for oppstart bare)',0),(208962,5805,'da','Angiv starten Balance fakturaer (til start kun)',0),(208963,5805,'ko','(ì‹œë™ë§Œ)ì— ëŒ€ í•œ ì‹œìž‘ ê· í˜• ì†¡ìž¥ ìž…ë ¥',0),(208964,5805,'he','×”×–×Ÿ ×”×”×ª×—×œ×” ×œ××™×–×•×Ÿ ×—×©×‘×•× ×™×•×ª (×¢×‘×•×¨ ×”×¤×¢×œ×” ×‘×œ×‘×“)',0),(208965,5805,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î±ÏÏ‡Î® Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± (Î³Î¹Î± Ï„Î·Î½ ÎµÎºÎºÎ¯Î½Î·ÏƒÎ· Î¼ÏŒÎ½Î¿)',0),(208966,5805,'zh','è¾“å…¥æœŸåˆå‘ç¥¨ï¼ˆåªç”¨äºŽå¯åŠ¨ï¼‰',0),(208967,5805,'sv','Ange bÃ¶rjan balans fakturor (fÃ¶r start endast)',0),(208968,5805,'it','Immettere inizio saldo fatture (per solo l\'avvio)',0),(208969,5805,'tl','',0),(208970,5805,'th','&#3611;&#3657;&#3629;&#3609;&#3618;&#3629;&#3604;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604; (&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&',0),(208971,5805,'hi','à¤¶à¥à¤°à¥à¤†à¤¤ à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤šà¤¾à¤²à¤¾à¤¨ (à¤¸à¥à¤Ÿà¤¾à¤°à¥à¤Ÿà¤…à¤ª à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‡à¤µà¤²) à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(208972,5805,'ms','Masukkan invois baki permulaan (untuk permulaan sahaja)',0),(208973,5805,'ar','Ø£Ø¯Ø®Ù„ \"Ø¨Ø¯Ø§ÙŠØ© Ø±ØµÙŠØ¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ±\" (Ù„Ø¨Ø¯Ø¡ Ø§Ù„ØªØ´ØºÙŠÙ„ ÙÙ‚Ø·)',0),(208974,5805,'fr','Entrez le dÃ©but solde factures (pour dÃ©marrage uniquement)',0),(208975,5805,'jp','æœŸé¦–æ®‹é«˜è«‹æ±‚æ›¸ã?®å…¥åŠ›ï¼ˆã‚¹ã‚¿ãƒ¼ãƒˆã‚¢ãƒƒãƒ—æ™‚ã?®ã?¿ï¼‰',0),(208976,5805,'pt','Digite o inÃ­cio equilÃ­brio facturas (para inicializaÃ§Ã£o somente)',0),(208977,5805,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð¾ Ð±Ð°Ð»Ð°Ð½ÑÐ° ÑÑ‡ÐµÑ‚Ð° (Ð´Ð»Ñ Ð·Ð°Ð¿ÑƒÑÐºÐ° Ñ‚Ð¾Ð»ÑŒÐºÐ¾)',0),(208978,5805,'es','Introducir Facturas de Saldos de Inicio (para activaciÃ³n solamente)',0),(208979,5805,'de','Geben Sie Anfang Balance Rechnungen (fÃ¼r den Start nur)',0),(208980,5805,'en','Enter Beginning Balance Invoices (for startup only)',0),(208981,5806,'is','',0),(208982,5806,'dr','-Ø¨Ø±Ø§ÙŠ Ø§Ø¬Ø±Ø§ Ø¯ÙƒÙ…Ù‡ Ø²ÙŠØ± Ø±Ø§ Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ ÙƒÙ†ÙŠØ¯.',0),(208983,5806,'pr','ØªØ±Ø§Ø²Ù‡Ø§ÙŠ Ø§ÙØªØªØ§Ø­ÙŠÙ‡ Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯-Ø¨Ø±Ø§ÙŠ Ø§Ø¬Ø±Ø§ Ø¯ÙƒÙ…Ù‡ Ø²ÙŠØ± Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯.',0),(208984,5806,'tr','Bakiyeleri uygulamak iÃ§in aÅŸaÄŸÄ±ya tÄ±klayÄ±n kurtardÄ± - baÅŸlangÄ±Ã§',0),(208985,5806,'pl','PoczÄ…wszy od salda zapisane - kliknij poniÅ¼ej, aby stosowaÄ‡',0),(208986,5806,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾ ÑÐ°Ð»Ð´Ð° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸ - Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ, Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°Ñ‚',0),(208987,5806,'ur','Ø´Ø±ÙˆØ¹ Ø³Û’ Ø¨ÛŒÙ„Ù†Ø³ Ù„Ú¯Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº Ù†ÛŒÚ†Û’ Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº-',0),(208988,5806,'sr','ÐŸÐ¾Ñ‡Ð¸ÑšÐµ ÑÐ°Ð»Ð´Ð° ÑÐ¿Ð°ÑÐ¸Ð¾ - ÐºÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ð»Ð¸',0),(208989,5806,'vi','Sao lÆ°u sá»‘ dÆ° báº¯t Ä‘áº§u - Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ Ã¡p dá»¥ng',0),(208990,5806,'af','Beginbalans Gestoor - Kliek Onderaan om Toe te pas.',0),(208991,5806,'ro','ÃŽncepÃ¢nd cu soldurile salvat - Click mai jos pentru a aplica',0),(208992,5806,'et','Alguses saldode salvestatud - kliki allpool kohaldada',0),(208993,5806,'si','ZaÄetek bilance shranjene - kliknite spodaj, da zaprosijo',0),(208994,5806,'ba','Mulai saldo disimpan - klik di bawah ini untuk mengajukan',0),(208995,5806,'nl','Begin saldi opgeslagen - Klik hieronder om toe te passen',0),(208996,5806,'fi','Alkusaldot tallennettu - klikkaa alla soveltamaan',0),(208997,5806,'no','Begynner balanserer lagret - Klikk nedenfor gjelder',0),(208998,5806,'da','Begynder saldi gemt - Klik nedenfor til at anvende',0),(208999,5806,'ko','ì‹œìž‘ ìž”ì•¡ ì €ìž¥-ì ìš© í•˜ë ¤ë©´ ì•„ëž˜ë¥¼ í´ë¦­ í•˜ì„¸ìš”',0),(209000,5806,'he','×ž×ª×—×™×œ ×™×ª×¨×•×ª ×”×¦×™×œ - ×œ×—×¥ ×œ×”×œ×Ÿ ×›×“×™ ×œ×”×—×™×œ',0),(209001,5806,'el','Î‘ÏÏ‡Î¯Î¶ÎµÎ¹ Ï„Î± Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î± Î­ÏƒÏ‰ÏƒÎµ - ÎºÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î³Î¹Î± Î½Î± ÎµÏ†Î±ÏÎ¼ÏŒÏƒÎµÎ¹',0),(209002,5806,'zh','æœŸåˆä½™é¢ä¿å­˜ -ç‚¹å‡»ä¸‹é¢ç”³è¯·\r\n',0),(209003,5806,'sv','BÃ¶rjan saldon sparat - Klicka nedan fÃ¶r att ansÃ¶ka',0),(209004,5806,'it','Inizio saldi salvati - cliccare di seguito per applicare',0),(209005,5806,'tl','',0),(209006,5806,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604;&#3649;&#3621;&#3657;&#3623; &#3588;&#3621;&#3636;&#3585;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#',0),(209007,5806,'hi','à¤¬à¤šà¤¾à¤¯à¤¾ - à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤•à¥‹ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚ à¤¶à¥à¤°à¥à¤†à¤¤',0),(209008,5806,'ms','Bermula baki-baki yang disimpan - klik di bawah untuk memohon',0),(209009,5806,'ar','Ø§Ø¨ØªØ¯Ø§Ø¡ Ù…Ù† Ø§Ù„Ø£Ø±ØµØ¯Ø© Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø©-Ø§Ù†Ù‚Ø± Ø£Ø¯Ù†Ø§Ù‡ Ù„ØªØ·Ø¨ÙŠÙ‚',0),(209010,5806,'fr','DÃ©but des soldes sauvÃ©s - cliquez ci-dessous pour appliquer',0),(209011,5806,'jp','æœŸé¦–æ®‹é«˜ã?Œä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿãƒ¼é?©ç”¨ã?™ã‚‹ã?«ã?¯ä¸‹ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(209012,5806,'pt','ComeÃ§ando saldos salvos - clique abaixo para aplicar',0),(209013,5806,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð¾ÑÑ‚Ð°Ñ‚ÐºÐ¸ ÑÐ¿Ð°Ñ - Ð½Ð°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð¸Ð¶Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(209014,5806,'es','Saldos de Inicio Guardados - Hace Click Abajo para Aplicar',0),(209015,5806,'de','Anfang Salden gespeichert - klicken Sie unten auf anwenden',0),(209016,5806,'en','Beginning Balances Saved - Click Below to Apply',0),(209017,5807,'is','',0),(209018,5807,'dr','Ù…Ø§Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ø§ÙØªØªØ§Ø­ÙŠÙ‡',0),(209019,5807,'pr','Ù…Ø§Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ø§ÙØªØªØ§Ø­ÙŠÙ‡',0),(209020,5807,'tr','BaÅŸlangÄ±Ã§ stok bakiyeleri',0),(209021,5807,'pl','PoczÄ…tku inwentaryzacji salda',0),(209022,5807,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð’ÐµÐ·Ð½Ð¸',0),(209023,5807,'ur','Ø¢ØºØ§Ø² Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¨ÛŒÙ„Ù†Ø³',0),(209024,5807,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð·Ð°Ð»Ð¸Ñ…Ð° ÑÐ°Ð»Ð´Ð°',0),(209025,5807,'vi','DÆ° Ná»£ Äáº§u Ká»³ HÃ ng HÃ³a',0),(209026,5807,'af','Aanvanklike VOORRAADBALANSE',0),(209027,5807,'ro','ÃŽnceputul stocuri solduri',0),(209028,5807,'et','Alguses lao kaalud',0),(209029,5807,'si','ZaÄetku popis stanja',0),(209030,5807,'ba','Awal persediaan saldo',0),(209031,5807,'nl','Begin inventaris saldi',0),(209032,5807,'fi','Varaston alkusaldot',0),(209033,5807,'no','Begynnelsen lager mellomvÃ¦rende',0),(209034,5807,'da','Startsaldoen lager',0),(209035,5807,'ko','ì²˜ìŒ ìž¬ê³  ëª©ë¡ ê· í˜•',0),(209036,5807,'he','×”×ª×—×œ×ª ×™×ª×¨×•×ª ×ž×œ××™',0),(209037,5807,'el','Î‘ÏÏ‡Î® Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯ÎµÏ‚',0),(209038,5807,'zh','æœŸåˆå­˜è´§ç»“ä½™\r\n',0),(209039,5807,'sv','IngÃ¥ende lager balanser',0),(209040,5807,'it','Inizio saldi di magazzino',0),(209041,5807,'tl','',0),(209042,5807,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3618;&#3585;&#3617;&#3634;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604;',0),(209043,5807,'hi','à¤¶à¥à¤°à¥à¤†à¤¤ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿',0),(209044,5807,'ms','Baki awal inventori',0),(209045,5807,'ar','Ø§Ù„Ø£Ø±ØµØ¯Ø© Ø§Ù„Ø¥ÙØªØªØ§Ø­ÙŠØ© Ù„Ù„Ù…Ø®Ø²ÙˆÙ†',0),(209046,5807,'fr','Soldes d\'inventaire',0),(209047,5807,'jp','æœŸé¦–åœ¨åº«æ®‹é«˜',0),(209048,5807,'pt','Saldos de estoque de inÃ­cio',0),(209049,5807,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¾ÑÑ‚Ð°Ñ‚ÐºÐ¾Ð²',0),(209050,5807,'es','Saldos de Inicio de Inventario',0),(209051,5807,'de','Anfang-Inventur-Waagen',0),(209052,5807,'en','Beginning Inventory Balances',0),(209053,5808,'is','',0),(209054,5808,'dr','/ Ø«Ø¨Øª (ÙˆØ±ÙˆØ¯ ) Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ ',0),(209055,5808,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ú©Ø§Ø±Ø¨Ø±Ú¯ / Ø«Ø¨Øª (ÙˆØ±ÙˆØ¯ ) Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ ',0),(209056,5808,'tr','Ã‡alÄ±ÅŸma/girin sayar oluÅŸturmak',0),(209057,5808,'pl','Tworzenie arkusza/WprowadÅº liczby',0),(209058,5808,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½ Ð»Ð¸ÑÑ‚/Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð±Ñ€Ð¾Ñ',0),(209059,5808,'ur','Ù‚Ø±Ø·Ø§Ø³ Ú©Ø§Ø±/Ø¯Ø§Ø®Ù„ Ø´Ù…Ø§Ø± Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(209060,5808,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð»Ð¸ÑÑ‚Ð°/ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ Ñ‚Ð°Ñ‡Ð°ÐºÐ°',0),(209061,5808,'vi','Táº¡o trang/nháº­p bá»™ Ä‘áº¿m',0),(209062,5808,'af','Skep werkblad/tik tellings',0),(209063,5808,'ro','Creare foaie de lucru/introduceÅ£i conteazÄƒ',0),(209064,5808,'et','Saate luua tÃ¶Ã¶lehe/sisestage arv',0),(209065,5808,'si','Ustvarite delovni list/vnesite Å¡teje',0),(209066,5808,'ba','Membuat lembar kerja/masuk hitungan',0),(209067,5808,'nl','Maak van werkblad/Voer graven',0),(209068,5808,'fi','Luo laskentataulukon/astua laskee',0),(209069,5808,'no','Opprette regneark/angi teller',0),(209070,5808,'da','Oprette regneark/Angiv tÃ¦ller',0),(209071,5808,'ko','ì›Œí¬ì‹œíŠ¸/ìž…ë ¥ ì¹´ìš´íŠ¸ ë§Œë“¤ê¸°',0),(209072,5808,'he','×œ×™×¦×•×¨ ×¡×¤×™×¨×•×ª ×”×–×Ÿ/×’×œ×™×•×Ÿ',0),(209073,5808,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï†ÏÎ»Î»Î¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚/ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼ÎµÏ„ÏÎ¬ÎµÎ¹',0),(209074,5808,'zh','åˆ›å»ºå·¥ä½œè¡¨/è®¡æ•°è¾“å…¥\r\n',0),(209075,5808,'sv','Skapa kalkylblad/ange rÃ¤knas',0),(209076,5808,'it','Creare il foglio di lavoro/invio conteggi',0),(209077,5808,'tl','',0),(209078,5808,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3607;&#3635;&#3585;&#3634;&#3619;/&#3585;&#3634;&#3619;&#3609;&#3633;&#3610;&#3607;&#3637;&#3656;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(209079,5808,'hi','à¤•à¤¾à¤°à¥à¤¯à¤ªà¤¤à¥à¤°à¤•/à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤—à¤¿à¤¨à¤¤à¥€ à¤¬à¤¨à¤¾à¤à¤',0),(209080,5808,'ms','Membuat tuduhan documents/masukkan.',0),(209081,5808,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙˆØ±Ù‚Ø© Ø¹Ù…Ù„ Ø£Ø¯Ø®Ù„ Ø§Ù„ØªÙ‡Ù…',0),(209082,5808,'fr','CrÃ©er compte/entrer dans la feuille de calcul',0),(209083,5808,'jp','ãƒ¯ãƒ¼ã‚¯ã‚·ãƒ¼ãƒˆã?®ä½œæˆ?/è¨ˆç®—ã?®å…¥åŠ›',0),(209084,5808,'pt','Criar planilha/entrar contagens',0),(209085,5808,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð»Ð¸ÑÑ‚Ð°/Ð²Ð²Ð¾Ð´ Ð³Ñ€Ð°Ñ„Ð¾Ð²',0),(209086,5808,'es','Crear Hoja de Trabajo/Ingresar Conteos',0),(209087,5808,'de','Arbeitsblatt/Eingabetaste zÃ¤hlt zu erstellen',0),(209088,5808,'en','Create Worksheet/Enter Counts',0),(209089,5809,'is','',0),(209090,5809,'dr','ØªØ±Ø§Ø²Ù‡Ø§ÙŠ Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ÙƒØ§Ù„Ø§ ',0),(209091,5809,'pr','ØªØ±Ø§Ø²Ù‡Ø§ÙŠ Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ÙƒØ§Ù„Ø§ ',0),(209092,5809,'tr','Madde bakiyelerini baÅŸlayan',0),(209093,5809,'pl','Element poczÄ…wszy od salda',0),(209094,5809,'bg','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ñ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½ÑÐ¸',0),(209095,5809,'ur','Ø´Û’ Ø¨ÛŒÙ„Ù†Ø³ Ú©Ø§ Ø¢ØºØ§Ø²',0),(209096,5809,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ð¿Ð¾Ñ‡ÐµÐ²ÑˆÐ¸ ÑÐ°Ð»Ð´Ð°',0),(209097,5809,'vi','Sá»‘ dÆ° Ä‘áº§u ká»³ cá»§a hÃ ng',0),(209098,5809,'af','Item Begin Balanse',0),(209099,5809,'ro','Element Ã®nceputul-solduri',0),(209100,5809,'et','Toote algkogus',0),(209101,5809,'si','ToÄka zaÄetek bilance',0),(209102,5809,'ba','Item mulai saldo',0),(209103,5809,'nl','Item begin saldi',0),(209104,5809,'fi','Nimikkeen alkusaldot',0),(209105,5809,'no','Elementet begynner saldoer',0),(209106,5809,'da','Varen begynder saldi',0),(209107,5809,'ko','ê· í˜•ì„ ì‹œìž‘ í•˜ëŠ” í•­ëª©',0),(209108,5809,'he','×¤×¨×™×˜ ×ž×ª×—×™×œ ×™×ª×¨×•×ª',0),(209109,5809,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±ÏÏ‡Î¯Î¶ÎµÎ¹ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯ÎµÏ‚',0),(209110,5809,'zh','é¡¹ç›®æœŸåˆä½™é¢\r\n',0),(209111,5809,'sv','Artikeln bÃ¶rjar saldon',0),(209112,5809,'it','Elemento inizio saldi',0),(209113,5809,'tl','',0),(209114,5809,'th','&#3618;&#3629;&#3604;&#3618;&#3585;&#3617;&#3634;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(209115,5809,'hi','à¤†à¤‡à¤Ÿà¤® à¤®à¥‡à¤‚ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤•à¥€ à¤¶à¥à¤°à¥à¤†à¤¤',0),(209116,5809,'ms','Item yang bermula baki',0),(209117,5809,'ar','Ø§Ù„Ø£Ø±ØµØ¯Ø© Ø§Ù„Ø¥ÙØªØªØ§Ø­ÙŠØ© Ù„Ù„Ø£ØµÙ†Ø§Ù',0),(209118,5809,'fr','Point de dÃ©but des soldes',0),(209119,5809,'jp','é–‹å§‹ãƒ?ãƒ©ãƒ³ã‚¹å“?ç›®',0),(209120,5809,'pt','Item comeÃ§ando saldos',0),(209121,5809,'ru','ÐŸÑƒÐ½ÐºÑ‚, Ð½Ð°Ñ‡Ð°Ð»Ð¾ Ð¾ÑÑ‚Ð°Ñ‚ÐºÐ¾Ð²',0),(209122,5809,'es','Item Saldo de Inicio',0),(209123,5809,'de','Element Anfang Salden',0),(209124,5809,'en','Item Beginning Balances',0),(209125,5810,'is','',0),(209126,5810,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ø§Ø¬Ø±Ø§',0),(209127,5810,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ø§Ø¬Ø±Ø§',0),(209128,5810,'tr','GÃ¶zden geÃ§irin ve uygulayÄ±n',0),(209129,5810,'pl','PrzeglÄ…d i zastosowanie',0),(209130,5810,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ð¹Ñ‚Ðµ Ð¸ ÑÐµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°',0),(209131,5810,'ur','Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº Ø§ÙˆØ± Ù„Ú¯Ø§Ø¦ÛŒÚº',0),(209132,5810,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð¸ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð°',0),(209133,5810,'vi','ÄÃ¡nh giÃ¡ & Ã¡p dá»¥ng',0),(209134,5810,'af','Hersien en wend',0),(209135,5810,'ro','De revizuire ÅŸi de a aplica',0),(209136,5810,'et','Vaadata lÃ¤bi ja rakendada',0),(209137,5810,'si','Pregled in uporabljajo',0),(209138,5810,'ba','Meninjau dan menerapkan',0),(209139,5810,'nl','Controleer en de toepassing',0),(209140,5810,'fi','Tarkistaa ja lisÃ¤tÃ¤',0),(209141,5810,'no','Se gjennom og bruke',0),(209142,5810,'da','GennemgÃ¥ og anvende',0),(209143,5810,'ko','ê²€í†  ë° ì ìš©',0),(209144,5810,'he','×¡×§×™×¨×ª ×•×œ×”×—×™×œ',0),(209145,5810,'el','Î•Î¾Î­Ï„Î±ÏƒÎ·Ï‚ ÎºÎ±Î¹ ÎµÏ†Î±ÏÎ¼ÏŒÎ¶Î¿Ï…Î½',0),(209146,5810,'zh','å¤å®¡å’Œåº”ç”¨\r\n',0),(209147,5810,'sv','Granska och tillÃ¤mpa',0),(209148,5810,'it','Esaminare e applicare',0),(209149,5810,'tl','',0),(209150,5810,'th','&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3649;&#3621;&#3632;&#3611;&#3619;&#3632;&#3618;&#3640;&#3585;&#3605;&#3660;&#3651;&#3594;&#3657;',0),(209151,5810,'hi','à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(209152,5810,'ms','Mengkaji semula dan digunakan',0),(209153,5810,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© ÙˆØªØ·Ø¨ÙŠÙ‚',0),(209154,5810,'fr','Consultez et appliquez',0),(209155,5810,'jp','è¦‹ç›´ã?—ã?¨é?©ç”¨',0),(209156,5810,'pt','Rever e aplicar',0),(209157,5810,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð¸Ñ‚Ðµ Ð¸ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚Ðµ',0),(209158,5810,'es','Revisar y Aplicar',0),(209159,5810,'de','Lesen und anwenden',0),(209160,5810,'en','Review and Apply',0),(209161,5811,'is','',0),(209162,5811,'dr','(Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙƒØ±Ø¯Ù†',0),(209163,5811,'pr','Ø§Ø¹Ù…Ø§Ù„ ÙƒØ±Ø¯Ù† (Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙƒØ±Ø¯Ù†',0),(209164,5811,'tr','Uygula',0),(209165,5811,'pl','Stosuje siÄ™',0),(209166,5811,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶Ð¸',0),(209167,5811,'ur','Ù„Ú¯Ø§Ø¦ÛŒÚº',0),(209168,5811,'sr','ÐŸÑ€Ð¸Ð¼ÐµÐ½Ð°',0),(209169,5811,'vi','á»¨ng Dá»¥ng',0),(209170,5811,'af','Toepas',0),(209171,5811,'ro','Se aplicÄƒ',0),(209172,5811,'et','Rakenda',0),(209173,5811,'si','Uporablja',0),(209174,5811,'ba','Menerapkan',0),(209175,5811,'nl','Toepassing',0),(209176,5811,'fi','Sovelletaan',0),(209177,5811,'no','Bruke',0),(209178,5811,'da','Anvende',0),(209179,5811,'ko','ì ìš©',0),(209180,5811,'he','×”×—×œ',0),(209181,5811,'el','Î™ÏƒÏ‡ÏÎ¿Ï…Î½',0),(209182,5811,'zh','åº”ç”¨\r\n',0),(209183,5811,'sv','TillÃ¤mpa',0),(209184,5811,'it','Applicare',0),(209185,5811,'tl','',0),(209186,5811,'th','&#3651;&#3594;&#3657;',0),(209187,5811,'hi','à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(209188,5811,'ms','Memohon',0),(209189,5811,'ar','ØªØ·Ø¨ÙŠÙ‚',0),(209190,5811,'fr','Appliquer',0),(209191,5811,'jp','é?©ç”¨',0),(209192,5811,'pt','Aplicar',0),(209193,5811,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(209194,5811,'es','Aplicar',0),(209195,5811,'de','Gelten',0),(209196,5811,'en','Apply',0),(209197,5812,'is','',0),(209198,5812,'dr','Ù‡ÙŠÚ† ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(209199,5812,'pr','Ù‡ÙŠÚ† ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(209200,5812,'tr','HiÃ§bir baÅŸlangÄ±Ã§ bakiyeleri bulundu',0),(209201,5812,'pl','Nie ma poczÄ…tku salda Znalezione',0),(209202,5812,'bg','ÐÑÐ¼Ð° Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ ÑÐ°Ð»Ð´Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(209203,5812,'ur','Ú©ÙˆØ¦ÛŒ Ø¢ØºØ§Ø² Ø¨ÛŒÙ„Ù†Ø³ Ù…Ù„Ø§',0),(209204,5812,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° ÑÐ°Ð»Ð´Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(209205,5812,'vi','KhÃ´ng tÃ¬m tháº¥y sá»‘ dÆ° ban Ä‘áº§u',0),(209206,5812,'af','Geen Beginbalanse Gevind',0),(209207,5812,'ro','Nu soldurile Ã®nceputul gÄƒsit',0),(209208,5812,'et','Leitud alguse saldod',0),(209209,5812,'si','Ne zaÄetku bilance naÅ¡el',0),(209210,5812,'ba','Saldo awal tidak ditemukan',0),(209211,5812,'nl','Geen begin saldi gevonden',0),(209212,5812,'fi','Ei lÃ¶ytynyt alkusaldot',0),(209213,5812,'no','Ingen begynnelsen balanserer funnet',0),(209214,5812,'da','Ingen primosaldi fundet',0),(209215,5812,'ko','ì•„ë‹ˆ ì‹œìž‘ ê· í˜•ì„ ë°œê²¬',0),(209216,5812,'he','××™×Ÿ ×™×ª×¨×•×ª ×”×”×ª×—×œ×” ×ž×¦××”',0),(209217,5812,'el','ÎšÎ±Î¼Î¯Î± Î±ÏÏ‡Î® Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(209218,5812,'zh','æœªæ‰¾åˆ°æœŸåˆç»“ä½™\r\n',0),(209219,5812,'sv','Inga ingÃ¥ende balanser hittade',0),(209220,5812,'it','No saldi inizio trovati',0),(209221,5812,'tl','',0),(209222,5812,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3618;&#3585;&#3617;&#3634;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604;',0),(209223,5812,'hi','à¤•à¥‹à¤ˆ à¤¶à¥à¤°à¥à¤†à¤¤ à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤ªà¤¾à¤¯à¤¾',0),(209224,5812,'ms','Tiada baki awal yang ditemui',0),(209225,5812,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£Ø±ØµØ¯Ø© Ø¥ÙØªØªØ§Ø­ÙŠØ©',0),(209226,5812,'fr','Aucun solde de dÃ©but trouvÃ©',0),(209227,5812,'jp','æœŸé¦–æ®‹é«˜ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(209228,5812,'pt','NÃ£o hÃ¡ saldos de inÃ­cio encontrados',0),(209229,5812,'ru','ÐÐµ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¾ÑÑ‚Ð°Ñ‚ÐºÐ¸ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(209230,5812,'es','No Se Encontro Balances de Inicio',0),(209231,5812,'de','Kein Anfang Salden gefunden',0),(209232,5812,'en','No Beginning Balances Found',0),(209233,5813,'is','',0),(209234,5813,'dr','Ø§Ø³Ù†Ø§Ø¯  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¹Ù…Ø§Ù„  Ø´Ø¯',0),(209235,5813,'pr','Ø§Ø³Ù†Ø§Ø¯  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¹Ù…Ø§Ù„  Ø´Ø¯',0),(209236,5813,'tr','KayÄ±t baÅŸarÄ±yla uygulandÄ±',0),(209237,5813,'pl','Rekordy zostaÅ‚y pomyÅ›lnie zastosowane',0),(209238,5813,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸Ñ‚Ðµ ÑÐ° Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(209239,5813,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù†ÛÛŒÚº Ù„Ú¯Ø§Ø¦ÛŒ ØªÚ¾ÛŒ',0),(209240,5813,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÑÑƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¸Ð¼ÐµÑšÐµÐ½Ðµ',0),(209241,5813,'vi','Ãp dá»¥ng há»“ sÆ¡ thÃ nh cÃ´ng',0),(209242,5813,'af','Rekords was suksesvol toegepas',0),(209243,5813,'ro','ÃŽnregistrÄƒrile au fost aplicate cu succes',0),(209244,5813,'et','Kirjete rakendati edukalt',0),(209245,5813,'si','Zapisi so bile uspeÅ¡no uveljavljene',0),(209246,5813,'ba','Catatan diterapkan berhasil',0),(209247,5813,'nl','Records zijn met succes toegepast',0),(209248,5813,'fi','Tietueet on sovellettu onnistuneesti',0),(209249,5813,'no','Poster ble aktivert',0),(209250,5813,'da','Poster blev anvendt med succes',0),(209251,5813,'ko','ë ˆì½”ë“œëŠ” ì„±ê³µì ìœ¼ë¡œ ì ìš© ëœ',0),(209252,5813,'he','×¨×©×•×ž×•×ª ×”×•×—×œ×• ×‘×”×¦×œ×—×”',0),(209253,5813,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ ÎµÏ†Î±ÏÎ¼ÏŒÏƒÏ„Î·ÎºÎ±Î½ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(209254,5813,'zh','è®°å½•åº”ç”¨æˆåŠŸ\r\n',0),(209255,5813,'sv','Poster har tillÃ¤mpats framgÃ¥ngsrikt',0),(209256,5813,'it','Record sono stati applicati con successo',0),(209257,5813,'tl','',0),(209258,5813,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3611;&#3619;&#3632;&#3618;&#3640;&#3585;&#3605;&#3660;&#3651;&#3594;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(209259,5813,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤²à¤¾à¤—à¥‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(209260,5813,'ms','Rekod-rekod yang digunakan berjaya',0),(209261,5813,'ar','Ø³Ø¬Ù„Ø§Øª ØªÙ… ØªØ·Ø¨ÙŠÙ‚Ù‡ Ø¨Ù†Ø¬Ø§Ø­',0),(209262,5813,'fr','Dossiers ont Ã©tÃ© appliquÃ©s avec succÃ¨s',0),(209263,5813,'jp','è¨˜éŒ²ã?Œé?©ç”¨ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(209264,5813,'pt','Registros foram aplicados com Ãªxito',0),(209265,5813,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÐµÐ½Ñ‹',0),(209266,5813,'es','Records se aplicaron exitosamente',0),(209267,5813,'de','DatensÃ¤tze wurden erfolgreich angewendet.',0),(209268,5813,'en','Records were applied successfully',0),(209269,5814,'is','',0),(209270,5814,'dr','Ø§Ø³Ù†Ø§Ø¯  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(209271,5814,'pr','Ø§Ø³Ù†Ø§Ø¯  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(209272,5814,'tr','KayÄ±t baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(209273,5814,'pl','Rekordy zostaÅ‚y pomyÅ›lnie zaktualizowane',0),(209274,5814,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸Ñ‚Ðµ ÑÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(209275,5814,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ú¯Ø¦ÛŒ',0),(209276,5814,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÑÑƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ.',0),(209277,5814,'vi','Giao Dá»‹ch Cáº­p Nháº­t ThÃ nh CÃ´ng',0),(209278,5814,'af','Rekords was suksesvol opdateer',0),(209279,5814,'ro','ÃŽnregistrÄƒrile au fost actualizate cu succes',0),(209280,5814,'et','Kirjete vÃ¤rskendamine Ãµnnestus',0),(209281,5814,'si','Zapisi so bili uspeÅ¡no posodobljeni',0),(209282,5814,'ba','Catatan yang diperbarui berhasil',0),(209283,5814,'nl','Records zijn bijgewerkt',0),(209284,5814,'fi','Tietueiden pÃ¤ivitys onnistui',0),(209285,5814,'no','Poster ble oppdatert',0),(209286,5814,'da','Poster blev opdateret',0),(209287,5814,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ëœ ë ˆì½”ë“œê°€',0),(209288,5814,'he','×¨×©×•×ž×•×ª ×¢×•×“×›× ×• ×‘×”×¦×œ×—×”',0),(209289,5814,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎ±Î½ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(209290,5814,'zh','è®°å½•æ›´æ–°æˆåŠŸ\r\n',0),(209291,5814,'sv','Poster har uppdaterats',0),(209292,5814,'it','I record sono stati aggiornati con successo',0),(209293,5814,'tl','',0),(209294,5814,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(209295,5814,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(209296,5814,'ms','Rekod telah dikemaskini berjaya',0),(209297,5814,'ar','Ø­Ø¯Ù‘Ø«Øª Ø§Ù„Ø³Ø¬Ù„Ù‘Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(209298,5814,'fr','Enregistrements ont Ã©tÃ© mis Ã  jour avec succÃ¨s',0),(209299,5814,'jp','è¨˜éŒ²ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(209300,5814,'pt','Registros foram atualizados com sucesso',0),(209301,5814,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(209302,5814,'es','Records se actualizaron exitosamente',0),(209303,5814,'de','DatensÃ¤tze wurden erfolgreich aktualisiert.',0),(209304,5814,'en','Records were updated successfully',0),(209305,5815,'is','',0),(209306,5815,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ø§Ø¬Ø±Ø§ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ',0),(209307,5815,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ Ø§Ø¬Ø±Ø§ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ',0),(209308,5815,'tr','GÃ¶zden geÃ§irin ve BaÅŸlangÄ±Ã§ bakiyesi GiriÅŸleri Uygula',0),(209309,5815,'pl','Opisz i poczÄ…tku zapisy bilansu',0),(209310,5815,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ð¹Ñ‚Ðµ Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½Ñ',0),(209311,5815,'ur','Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº Ø§ÙˆØ± Ø¢ØºØ§Ø² ØªÙˆØ§Ø²Ù† Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù„Ú¯Ø§Ø¦ÛŒÚº',0),(209312,5815,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð¸ Ð·Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ ÑÐ°Ð»Ð´Ð¾ Ð·Ð° Ð¿Ð¾Ñ‡ÐµÑ‚Ð°Ðº',0),(209313,5815,'vi','ÄÃ¡nh giÃ¡ & Ã¡p dá»¥ng dÆ° ná»£ nháº­p ban Ä‘áº§u',0),(209314,5815,'af','Besigtig en \"apply\" Beginbalans Inskrywings',0),(209315,5815,'ro','Revizuirea ÅŸi aplicaÅ£i intrÄƒri de echilibru Ã®nceputul',0),(209316,5815,'et','LÃ¤bivaatamiseks ja kohaldamiseks alguse saldo kanded',0),(209317,5815,'si','Pregled in zaÄetku postavke bilance',0),(209318,5815,'ba','Meninjau dan menerapkan awal keseimbangan entri',0),(209319,5815,'nl','Herzien en begin evenwicht vereffenen',0),(209320,5815,'fi','Lue ja alkaa tasapaino kohdistettava',0),(209321,5815,'no','Se gjennom og bruke begynnelsen balanse oppfÃ¸ringer',0),(209322,5815,'da','GennemgÃ¥ og anvende begyndelsen Balance poster',0),(209323,5815,'ko','ê²€í†  í•˜ ê³  ì‹œìž‘ ìž”ì•¡ í•­ëª© ì ìš©',0),(209324,5815,'he','×¡×§×•×¨ ×•×œ××—×¨ ×”×—×œ ×”×”×ª×—×œ×” ×œ××™×–×•×Ÿ ×¢×¨×›×™',0),(209325,5815,'el','Î•Î¾Î­Ï„Î±ÏƒÎ·Ï‚ ÎºÎ±Î¹ ÎµÏ†Î±ÏÎ¼ÏŒÎ¶Î¿Ï…Î½ Ï„Î·Î½ Î±ÏÏ‡Î® ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Ï…Ï€Î¿Î»Î¿Î¯Ï€Î¿Ï…',0),(209326,5815,'zh','å¤å®¡å’Œåº”ç”¨æœŸåˆä½™é¢æ¡ç›®\r\n',0),(209327,5815,'sv','Granska och tillÃ¤mpa bÃ¶rjan balans poster',0),(209328,5815,'it','Esaminare e applicare le voci di bilancio di inizio',0),(209329,5815,'tl','',0),(209330,5815,'th','&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3649;&#3621;&#3632;&#3611;&#3619;&#3632;&#3618;&#3640;&#3585;&#3605;&#3660;&#3651;&#3594;&#3657;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3',0),(209331,5815,'hi','à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤¶à¥à¤°à¥à¤†à¤¤ à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(209332,5815,'ms','Mengkaji semula dan memohon kemasukan baki awal',0),(209333,5815,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© ÙˆØªØ·Ø¨ÙŠÙ‚ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø±ØµÙŠØ¯ Ø¨Ø¯Ø§ÙŠØ©',0),(209334,5815,'fr','RÃ©vision et lettrer les Ã©critures de solde de dÃ©but',0),(209335,5815,'jp','æœŸé¦–æ®‹é«˜ã‚¨ãƒ³ãƒˆãƒªãƒ¼ã?®ãƒ¬ãƒ“ãƒ¥ãƒ¼ã?¨é?©ç”¨',0),(209336,5815,'pt','Rever e aplicar entradas de inÃ­cio equilÃ­brio',0),(209337,5815,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð¸Ñ‚Ðµ Ð¸ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð±Ð°Ð»Ð°Ð½Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(209338,5815,'es','Revisar y Aplicar Entradas de Saldos de Inicio',0),(209339,5815,'de','ÃœberprÃ¼fen Sie und wenden Sie Anfang Balance EintrÃ¤ge',0),(209340,5815,'en','Review and Apply Beginning Balance Entries',0),(209341,5816,'is','',0),(209342,5816,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(209343,5816,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(209344,5816,'tr','VarsayÄ±lan PO',0),(209345,5816,'pl','DomyÅ›lnie PO',0),(209346,5816,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ PO',0),(209347,5816,'ur','Ø·Û’ Ø´Ø¯Û Ù¾Ùˆ',0),(209348,5816,'sr','ÐŸÐž Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾Ñ˜ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(209349,5816,'vi','ÄÆ¡n mua hÃ ng Máº·c Ä‘á»‹nh',0),(209350,5816,'af','Verstekte AB',0),(209351,5816,'ro','Implicit PO',0),(209352,5816,'et','Vaikimisi PO',0),(209353,5816,'si','Privzeta PO',0),(209354,5816,'ba','Default PO',0),(209355,5816,'nl','Standaard PO',0),(209356,5816,'fi','Oletuksena PO',0),(209357,5816,'no','Standard PO',0),(209358,5816,'da','Standard PO',0),(209359,5816,'ko','ê¸°ë³¸ í¬',0),(209360,5816,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×¤×•',0),(209361,5816,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® PO',0),(209362,5816,'zh','é»˜è®¤é‡‡è´­è®¢å•\r\n',0),(209363,5816,'sv','Standard PO',0),(209364,5816,'it','PO predefinito',0),(209365,5816,'tl','',0),(209366,5816,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(209367,5816,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤ªà¥‹',0),(209368,5816,'ms','PO lalai',0),(209369,5816,'ar','Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠ',0),(209370,5816,'fr','Par dÃ©faut PO',0),(209371,5816,'jp','æ—¢å®šã?®æ³¨æ–‡æ›¸',0),(209372,5816,'pt','PO padrÃ£o',0),(209373,5816,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ PO',0),(209374,5816,'es','OC por Defecto',0),(209375,5816,'de','Standard-PO',0),(209376,5816,'en','Default PO',0),(209377,5817,'is','',0),(209378,5817,'dr','ØªØ±Ø§Ø²Ù‡Ø§ÙŠ Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ',0),(209379,5817,'pr','ØªØ±Ø§Ø²Ù‡Ø§ÙŠ Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ',0),(209380,5817,'tr','BaÅŸlangÄ±Ã§ bakiyesi',0),(209381,5817,'pl','PoczÄ…wszy od salda',0),(209382,5817,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½ÑÐ¸',0),(209383,5817,'ur','Ø¢ØºØ§Ø² Ø¨ÛŒÙ„Ù†Ø³',0),(209384,5817,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº ÑÐ°Ð»Ð´Ð°',0),(209385,5817,'vi','Sá»‘ dÆ° báº¯t Ä‘áº§u',0),(209386,5817,'af','Begin Balanse',0),(209387,5817,'ro','ÃŽnceputul solduri',0),(209388,5817,'et','Algsaldod',0),(209389,5817,'si','ZaÄetku bilance',0),(209390,5817,'ba','Saldo awal',0),(209391,5817,'nl','Begin saldi',0),(209392,5817,'fi','Alkusaldot',0),(209393,5817,'no','Begynnelsen saldoer',0),(209394,5817,'da','Startsaldoen',0),(209395,5817,'ko','ì‹œìž‘ ìž”ì•¡',0),(209396,5817,'he','×ž××–×Ÿ ×”×ª×—×œ×ª×™',0),(209397,5817,'el','Î‘ÏÏ‡Î® Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯ÎµÏ‚',0),(209398,5817,'zh','æœŸåˆä½™é¢\r\n',0),(209399,5817,'sv','IngÃ¥ende balanser',0),(209400,5817,'it','Inizio saldi',0),(209401,5817,'tl','',0),(209402,5817,'th','&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604;',0),(209403,5817,'hi','à¤¶à¥à¤°à¥à¤†à¤¤ à¤®à¥‡à¤‚ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿',0),(209404,5817,'ms','Baki-baki awal',0),(209405,5817,'ar','Ø§Ù„Ø£Ø±ØµØ¯Ø© Ø§Ù„Ø¥ÙØªØªØ§Ø­ÙŠØ©',0),(209406,5817,'fr','Soldes d\'ouverture',0),(209407,5817,'jp','æœŸé¦–æ®‹é«˜',0),(209408,5817,'pt','Saldos de inÃ­cio',0),(209409,5817,'ru','ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð‘Ð°Ð»Ð°Ð½ÑÑ‹',0),(209410,5817,'es','Saldos de Inicio',0),(209411,5817,'de','Anfang Salden',0),(209412,5817,'en','Beginning Balances',0),(209413,5818,'is','',0),(209414,5818,'dr','Ø«Ø¨Øª ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø± Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ø§ÙŠ  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(209415,5818,'pr','Ø«Ø¨Øª ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø± Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ø§ÙŠ  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(209416,5818,'tr','Eldeki stok iÃ§in baÅŸlayan girin',0),(209417,5818,'pl','WprowadÅº poczÄ…tek Onhand dla zapasÃ³w',0),(209418,5818,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐÐ°Ñ‡Ð°Ð»Ð¾ Onhand Ð·Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(209419,5818,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø§ÙˆÙ†Ø­Ù†Úˆ Ø´Ø±ÙˆØ¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(209420,5818,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð¾Ñ‡Ð¸ÑšÐµ ÐžÐ½Ñ…Ð°Ð½Ð´ Ð·Ð° Ð·Ð°Ð»Ð¸Ñ…Ðµ',0),(209421,5818,'vi','Nháº­p Sá»‘ Äáº§u Ká»³ Cá»§a HÃ ng hÃ³a Äang CÃ³ Trong Tay',0),(209422,5818,'af','Tik begin Onhand vir voorraad',0),(209423,5818,'ro','IntroduceÅ£i Ã®ncepÃ¢nd Onhand pentru inventar',0),(209424,5818,'et','Sisestage lao TaastÃ¤itmise algus',0),(209425,5818,'si','Vnesite zaÄetek Onhand za zaloge',0),(209426,5818,'ba','Masukkan awal Onhand untuk persediaan',0),(209427,5818,'nl','Voer Onhand begin voor inventaris',0),(209428,5818,'fi','Kirjoita alkaa Onhand varastoa varten.',0),(209429,5818,'no','Angi begynnelsen Onhand for lageret',0),(209430,5818,'da','Angiv begyndende Onhand for lageret',0),(209431,5818,'ko','ìž¬ê³ ì— ëŒ€ í•œ Onhand ì‹œìž‘ ìž…ë ¥',0),(209432,5818,'he','×”×–×Ÿ ×ž×ª×—×™×œ ×‘× ×ž×¦× ×¢×‘×•×¨ ×”×ž×œ××™',0),(209433,5818,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î±ÏÏ‡Î® Onhand Î³Î¹Î± Ï„Î·Î½ Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(209434,5818,'zh','æœŸåˆå­˜è´§çŽ°æœ‰é‡è¾“å…¥',0),(209435,5818,'sv','Ange bÃ¶rjan Onhand fÃ¶r lager',0),(209436,5818,'it','Inserisci all\'inizio Onhand per inventario',0),(209437,5818,'tl','',0),(209438,5818,'th','&#3611;&#3657;&#3629;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604;',0),(209439,5818,'hi','Onhand à¤¶à¥à¤°à¥à¤†à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(209440,5818,'ms','Masukkan mulai Onhand bagi inventori',0),(209441,5818,'ar','Ø£Ø¯Ø®Ù„ Ø¨Ø¯Ø§ÙŠØ© Onhand Ù„Ù„Ù…Ø®Ø²ÙˆÙ†',0),(209442,5818,'fr','Entrez le dÃ©but Onhand pour lâ€™inventaire',0),(209443,5818,'jp','æœ€åˆ?ã?«æ‰‹å…ƒã?«ã?‚ã?£ã?Ÿåœ¨åº«ã?®å…¥åŠ›',0),(209444,5818,'pt','Digite comeÃ§ando Onhand para inventÃ¡rio',0),(209445,5818,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð¾ Onhand Ð´Ð»Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(209446,5818,'es','Ingresar Saldos de Reserva para Inventario',0),(209447,5818,'de','Geben Sie ab Onhand fÃ¼r Inventar',0),(209448,5818,'en','Enter Beginning Onhand for Inventory',0),(209449,5819,'is','',0),(209450,5819,'dr','Ù‡Ø²ÙŠÙ†Ù‡  Ù‡Ø±  ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(209451,5819,'pr','Ù‡Ø²ÙŠÙ†Ù‡  Ù‡Ø±  ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(209452,5819,'tr','Stok birimi cinsinden maliyet',0),(209453,5819,'pl','Koszt jednostkowy czas',0),(209454,5819,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° ÑÑŠÑÑ‚Ð°Ð²',0),(209455,5819,'ur','Ø§Ø³Ù¹Ø§Ú© ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(209456,5819,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(209457,5819,'vi','GiÃ¡ má»—i 1 Ä‘Æ¡n vá»‹ hÃ ng',0),(209458,5819,'af','Kosprys Per Voorraadeenheid',0),(209459,5819,'ro','Costul pe unitate de stoc',0),(209460,5819,'et','Varude Ã¼hiku kulu',0),(209461,5819,'si','StroÅ¡ek na enoto zalog',0),(209462,5819,'ba','Biaya Per Unit saham',0),(209463,5819,'nl','Kosten Per voorraad eenheid',0),(209464,5819,'fi','Varastossa yksikkÃ¶kustannukset',0),(209465,5819,'no','Kostnad Per lager enhet',0),(209466,5819,'da','Omkostning pr. lager enhed',0),(209467,5819,'ko','ìž¬ê³  ë‹¨ìœ„ ë‹¹ ë¹„ìš©',0),(209468,5819,'he','×¢×œ×•×ª ×œ×™×—×™×“×ª ×ž×œ××™',0),(209469,5819,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Î¶Ï‰Î¹ÎºÎ¿Ï ÎºÎµÏ†Î±Î»Î±Î¯Î¿Ï…',0),(209470,5819,'zh','æ¯åªè‚¡ç¥¨å•ä½æˆæœ¬\r\n',0),(209471,5819,'sv','Kostnad Per aktie',0),(209472,5819,'it','Costo Per unitÃ  di magazzino',0),(209473,5819,'tl','',0),(209474,5819,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3657;&#3634;&#3609;',0),(209475,5819,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤¶à¥‡à¤¯à¤° à¤‡à¤•à¤¾à¤ˆ à¤²à¤¾à¤—à¤¤',0),(209476,5819,'ms','Kos seunit saham',0),(209477,5819,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(209478,5819,'fr','CoÃ»t par unitÃ© de Stock',0),(209479,5819,'jp','åœ¨åº«å?˜ä¾¡ã?”ã?¨ã?®è²»ç”¨',0),(209480,5819,'pt','Custo por unidade de estoque',0),(209481,5819,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹ Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(209482,5819,'es','Costo Por Unidad de Stock',0),(209483,5819,'de','Kosten pro Stock Einheit',0),(209484,5819,'en','Cost Per Stock Unit',0),(209485,5820,'is','',0),(209486,5820,'dr','Ø«Ø¨Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ Ø¨Ù‡ ØµÙˆØ±Øª  Ø¯Ø³ØªÙŠ ',0),(209487,5820,'pr','Ø«Ø¨Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ Ø¨Ù‡ ØµÙˆØ±Øª  Ø¯Ø³ØªÙŠ ',0),(209488,5820,'tr','HesaplarÄ± el ile girin',0),(209489,5820,'pl','RÄ™cznie wprowadÅº konta',0),(209490,5820,'bg','Ð ÑŠÑ‡Ð½Ð¾ Ð²ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(209491,5820,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ùˆ Ø¯Ø³ØªÛŒ Ø·ÙˆØ± Ù¾Ø± Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(209492,5820,'sr','Ð ÑƒÑ‡Ð½Ð¸ ÑƒÐ½Ð¾Ñ ÐºÐ¾Ð½Ñ‚Ð°',0),(209493,5820,'vi','Nháº­p TK Thá»§ CÃ´ng',0),(209494,5820,'af','Invoer van Rekeninge Per Hand',0),(209495,5820,'ro','IntroduceÅ£i manual conturi',0),(209496,5820,'et','Kontode kÃ¤sitsi sisestada',0),(209497,5820,'si','Vnesite raÄune roÄno',0),(209498,5820,'ba','Masukkan account secara manual',0),(209499,5820,'nl','Accounts handmatig invoeren',0),(209500,5820,'fi','SyÃ¶tÃ¤ tilit manuaalisesti',0),(209501,5820,'no','Angi kontoer manuelt',0),(209502,5820,'da','Angive konti manuelt',0),(209503,5820,'ko','ìˆ˜ë™ìœ¼ë¡œ ê³„ì • ìž…ë ¥',0),(209504,5820,'he','×”×–×Ÿ ×‘××•×¤×Ÿ ×™×“× ×™ ×—×©×‘×•× ×•×ª',0),(209505,5820,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î¼Îµ Î¼Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î¿ Ï„ÏÏŒÏ€Î¿',0),(209506,5820,'zh','æ‰‹åŠ¨è¾“å…¥å¸æˆ·',0),(209507,5820,'sv','Ange konton manuellt',0),(209508,5820,'it','Immettere manualmente gli account',0),(209509,5820,'tl','',0),(209510,5820,'th','&#3611;&#3657;&#3629;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3604;&#3657;&#3623;&#3618;&#3617;&#3639;&#3629;',0),(209511,5820,'hi','à¤–à¤¾à¤¤à¥‹à¤‚ à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤°à¥‚à¤ª à¤¸à¥‡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(209512,5820,'ms','Masukkan akaun secara manual',0),(209513,5820,'ar','Ø£Ø¯Ø®Ù„ Ø­Ø³Ø§Ø¨Ø§Øª ÙŠØ¯ÙˆÙŠØ§Ù‹',0),(209514,5820,'fr','Entrez manuellement les comptes',0),(209515,5820,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’æ‰‹å‹•ã?§è¨˜å¸³ã?—ã?¦ã??ã? ã?•ã?„',0),(209516,5820,'pt','Inserir as contas manualmente',0),(209517,5820,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ',0),(209518,5820,'es','Introducir Cuentas Manualmente',0),(209519,5820,'de','Geben Sie Konten manuell',0),(209520,5820,'en','Enter Accounts Manually',0),(209521,5821,'is','',0),(209522,5821,'dr','(0= Ø®ÙŠØ±',0),(209523,5821,'pr','Ù‚Ø¨ÙˆÙ„ Ø§Ø±ØªÙ‚Ø§Ø¡   (0= Ø®ÙŠØ±',0),(209524,5821,'tr','TanÄ±tÄ±mlarÄ±nÄ± OK (0 = HayÄ±r)',0),(209525,5821,'pl','Promocje OK (0 = nie)',0),(209526,5821,'bg','ÐŸÑ€Ð¾Ð¼Ð¾Ñ†Ð¸Ð¸ OK (0 = Ð½Ðµ)',0),(209527,5821,'ur','Ù¾Ø±ÙˆÙ…Ø§ÙˆØ³ Ú©Û’ Ù„ÛŒÛ’ Ù¹Ú¾ÛŒÚ© ÛÛ’ (0 = NO)',0),(209528,5821,'sr','ÐŸÑ€Ð¾Ð¼Ð¾Ñ†Ð¸Ñ˜Ðµ Ñƒ Ñ€ÐµÐ´Ñƒ (0 = Ð½Ðµ)',0),(209529,5821,'vi','Khuyáº¿n máº¡i OK (0=NO)',0),(209530,5821,'af','Promos OK (0 = nie)',0),(209531,5821,'ro','Promo-uri OK (0 = nu)',0),(209532,5821,'et','Kampaaniad OK (0 = ei)',0),(209533,5821,'si','Promos OK (0 = ne)',0),(209534,5821,'ba','Promo OK (0 = tidak ada)',0),(209535,5821,'nl','Promo\'s OK (0 = nee)',0),(209536,5821,'fi','Kampanjat OK (0 = ei)',0),(209537,5821,'no','Promoer OK (0 = ingen)',0),(209538,5821,'da','Promotions OK (0 = nej)',0),(209539,5821,'ko','í™ë³´ í™•ì¸ (0 = ì•„ë‹ˆì˜¤)',0),(209540,5821,'he','×¤×¨×•×ž×•××™× ××™×©×•×¨ (0 = ×œ×)',0),(209541,5821,'el','Promos OK (0 = ÏŒÏ‡Î¹)',0),(209542,5821,'zh','åŒæ„ä¿ƒé”€ï¼ˆ0=å¦ï¼‰\r\n',0),(209543,5821,'sv','Promos OK (0 = Nej)',0),(209544,5821,'it','Promo OK (0 = NO)',0),(209545,5821,'tl','',0),(209546,5821,'th','&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3585;&#3634;&#3619;&#3650;&#3590;&#3625;&#3603;&#3634; OK (0=NO)',0),(209547,5821,'hi','à¤ªà¥à¤°à¥‹à¤®à¥‹à¤œ à¤ à¥€à¤• (0 = à¤¨à¤¹à¥€à¤‚)',0),(209548,5821,'ms','Promosi OK (0 = tidak)',0),(209549,5821,'ar','Ø§Ù„Ù…Ù„Ù„ Ù…ÙˆØ§ÙÙ‚ (0 = Ù„Ø§)',0),(209550,5821,'fr','Promos OK (0 = non)',0),(209551,5821,'jp','Promos OK (0=NO)',0),(209552,5821,'pt','Promos OK (0 = nÃ£o)',0),(209553,5821,'ru','ÐÐºÑ†Ð¸Ð¸ ÐžÐš (0 = Ð½ÐµÑ‚)',0),(209554,5821,'es','Promociones OK (0=NO)',0),(209555,5821,'de','Promos OK (0 = Nein)',0),(209556,5821,'en','Promos OK (0=NO)',0),(209557,5822,'is','',0),(209558,5822,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ Ø¬Ø§Ø±ÙŠ ',0),(209559,5822,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ Ø¬Ø§Ø±ÙŠ ',0),(209560,5822,'tr','GeÃ§erli etkin firmalarÄ±',0),(209561,5822,'pl','BieÅ¼Ä…cego aktywnego konta',0),(209562,5822,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸',0),(209563,5822,'ur','Ø­Ø§Ù„ÛŒÛ ÙØ¹Ø§Ù„ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(209564,5822,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð¿Ð¾ÑÐ»Ð¾Ð²Ð½Ð¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(209565,5822,'vi','TK Äang Hoáº¡t Äá»™ng',0),(209566,5822,'af','Huidige Aktiewe Rekeninge',0),(209567,5822,'ro','Conturile de activ curent',0),(209568,5822,'et','Praegune aktiivsed ettevÃµtted',0),(209569,5822,'si','Trenutno aktivni kupci',0),(209570,5822,'ba','Saat ini aktif account',0),(209571,5822,'nl','Huidige actieve Accounts',0),(209572,5822,'fi','Nykyinen aktiiviset asiakkuudet',0),(209573,5822,'no','Gjeldende aktive kontoer',0),(209574,5822,'da','NuvÃ¦rende aktive konti',0),(209575,5822,'ko','í˜„ìž¬ í™œì„± ê³„ì •',0),(209576,5822,'he','×ª×™×§×™ ×”×œ×§×•×—×•×ª ×”×¤×¢×™×œ×™× ×”× ×•×›×—×™',0),(209577,5822,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎµÎ½ÎµÏÎ³Î¿ÏÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(209578,5822,'zh','å½“å‰æ´»è·ƒå¸æˆ·\r\n',0),(209579,5822,'sv','Nuvarande aktiva konton',0),(209580,5822,'it','Account attivo corrente',0),(209581,5822,'tl','',0),(209582,5822,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3629;&#3618;&#3641;&#3656;',0),(209583,5822,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤–à¤¾à¤¤à¥‡',0),(209584,5822,'ms','Akaun semasa yang aktif',0),(209585,5822,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù†Ø´Ø·Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(209586,5822,'fr','Comptes actifs actuels',0),(209587,5822,'jp','ç?¾åœ¨ã?®èµ·å‹•ä¸­ã?®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(209588,5822,'pt','Contas de ativas atuais',0),(209589,5822,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(209590,5822,'es','Cuentas Activas Actuales',0),(209591,5822,'de','Aktuelle aktive Accounts',0),(209592,5822,'en','Current Active Accounts',0),(209593,5823,'is','',0),(209594,5823,'dr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ÙŠ ØªØ§ÙƒÙ†ÙˆÙ† ØªØ¹ÙŠÙŠÙ† Ù†Ø´Ø¯Ù‡ ',0),(209595,5823,'pr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ÙŠ ØªØ§ÙƒÙ†ÙˆÙ† ØªØ¹ÙŠÙŠÙ† Ù†Ø´Ø¯Ù‡ ',0),(209596,5823,'tr','HenÃ¼z atanmÄ±ÅŸ bir hesabÄ± yok',0),(209597,5823,'pl','Nie konta przypisane jeszcze',0),(209598,5823,'bg','ÐÑÐ¼Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸, Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ð¾Ñ‰Ðµ',0),(209599,5823,'ur','Ø§Ø¨Ú¾ÛŒ ØªÚ© ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(209600,5823,'sr','ÐÐµÐ¼Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð´Ð¾Ð´ÐµÐ»Ð¸Ð¾ Ñ˜Ð¾Ñˆ',0),(209601,5823,'vi','ChÆ°a Chá»‰ Äá»‹nh TK',0),(209602,5823,'af','Geen rekeninge nog toegeken',0),(209603,5823,'ro','Nu conturile desemnat Ã®ncÄƒ',0),(209604,5823,'et','Ole kontosid mÃ¤Ã¤ratud veel',0),(209605,5823,'si','RaÄunov, ki ni dodeljena Å¡e',0),(209606,5823,'ba','Tidak ada account yang diberikan belum',0),(209607,5823,'nl','Geen Accounts die nog zijn toegewezen',0),(209608,5823,'fi','TilejÃ¤ ei annettu vielÃ¤',0),(209609,5823,'no','Ingen kontoer tildelt ennÃ¥',0),(209610,5823,'da','Ingen konti, tildelt endnu',0),(209611,5823,'ko','ì•„ì§ í• ë‹¹ ê³„ì •ì´ ì—†ëŠ”',0),(209612,5823,'he','××™×Ÿ ×—×©×‘×•× ×•×ª ×©×”×•×§×¦×• ×¢×“×™×™×Ÿ',0),(209613,5823,'el','Î”ÎµÎ½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¹ÏƒÏ„ÎµÎ¯ ÏƒÎµ Î±Ï…Ï„Î­Ï‚ ÎºÎ±Î¹ Î±ÎºÏŒÎ¼Î·',0),(209614,5823,'zh','è¿˜æ²¡æœ‰å¸æˆ·åˆ†é…\r\n',0),(209615,5823,'sv','Inga konton tilldelas Ã¤nnu',0),(209616,5823,'it','Nessun account ancora assegnato',0),(209617,5823,'tl','',0),(209618,5823,'th','&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3585;&#3635;&#3627;&#3609;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(209619,5823,'hi','à¤•à¥‹à¤ˆ à¤–à¤¾à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤…à¤­à¥€ à¤¤à¤• à¤¸à¥Œà¤‚à¤ªà¤¾',0),(209620,5823,'ms','Tiada akaun yang diperuntukkan lagi',0),(209621,5823,'ar','Ù„Ø§ Ø­Ø³Ø§Ø¨Ø§Øª ØªÙ… ØªØ¹ÙŠÙŠÙ†Ù‡Ø§ Ø¨Ø¹Ø¯',0),(209622,5823,'fr','Aucun comptes affectÃ©s encore',0),(209623,5823,'jp','ã?¾ã? ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?ŒæŒ‡å®šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(209624,5823,'pt','Contas nÃ£o atribuÃ­das ainda',0),(209625,5823,'ru','ÐÐ¸ÐºÐ°ÐºÐ¸Ðµ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½',0),(209626,5823,'es','Ya No Hay Cuentas Asignadas',0),(209627,5823,'de','Keine Konten zugeordnet noch',0),(209628,5823,'en','No Accounts Assigned Yet',0),(209629,5824,'is','',0),(209630,5824,'dr','Ø¨Ø±Ø§ÙŠ ÙˆØ¶Ø¹ÙŠØª Ø¨Ù‡ Ø·Ø±Ù Ù¾Ø§ÙŠÙŠÙ† ØµÙØ­Ù‡ Ø­Ø±ÙƒØª ÙƒÙ†ÙŠØ¯ ',0),(209631,5824,'pr','Ø¨Ø±Ø§ÙŠ ÙˆØ¶Ø¹ÙŠØª Ø¨Ù‡ Ø·Ø±Ù Ù¾Ø§ÙŠÙŠÙ† ØµÙØ­Ù‡ Ø­Ø±ÙƒØª ÙƒÙ†ÙŠØ¯ ',0),(209632,5824,'tr','alt durum iÃ§in aÅŸaÄŸÄ± ilerleyin',0),(209633,5824,'pl','PrzewiÅ„ w dÃ³Å‚ do stanu',0),(209634,5824,'bg','ÐŸÑ€ÐµÐ²ÑŠÑ€Ñ‚ÐµÑ‚Ðµ Ð½Ð°Ð´Ð¾Ð»Ñƒ Ð´Ð¾ Ð´ÑŠÐ½Ð¾Ñ‚Ð¾ Ð·Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾',0),(209635,5824,'ur','Ø³Ø¨ Ø³Û’ Ù†ÛŒÚ†Û’ Ø¯Ø±Ø¬Û Ú©Û’ Ù„Ø¦Û’ Ù†ÛŒÚ†Û’ Ø·ÙˆÙ…Ø§Ø±',0),(209636,5824,'sr','ÐŸÐ¾Ð¼ÐµÑ€Ð¸Ñ‚Ðµ ÑÐµ Ð´Ð¾ Ð´Ð½Ð° Ð·Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(209637,5824,'vi','Cháº¡y xuá»‘ng cuá»‘i trang Ä‘á»ƒ tÃ¬m tÃ¬nh tráº¡ng',0),(209638,5824,'af','rol af na onder vir status',0),(209639,5824,'ro','DerulaÅ£i Ã®n jos jos pentru statutul de',0),(209640,5824,'et','Kerige all olek',0),(209641,5824,'si','se pomaknite navzdol na dnu za status',0),(209642,5824,'ba','Gulir ke bawah ke bawah untuk status',0),(209643,5824,'nl','Scroll naar beneden naar de bodem voor status',0),(209644,5824,'fi','Selaa pohjaan tila',0),(209645,5824,'no','Bla ned til bunnen for status',0),(209646,5824,'da','Rul ned til bunden for status',0),(209647,5824,'ko','ë°”ë‹¥ ìƒíƒœì— ëŒ€ í•œ ì•„ëž˜ë¡œ ìŠ¤í¬ë¡¤',0),(209648,5824,'he','×’×œ×•×œ ×ž×˜×” ×”×ª×—×ª×•×Ÿ ×¢×‘×•×¨ ×ž×¦×‘',0),(209649,5824,'el','Î¼ÎµÏ„Î±ÎºÎ¹Î½Î·Î¸ÎµÎ¯Ï„Îµ Ï€ÏÎ¿Ï‚ Ï„Î± ÎºÎ¬Ï„Ï‰ ÎºÎ¬Ï„Ï‰ Î³Î¹Î± Ï„Î·Î½ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(209650,5824,'zh','å‘ä¸‹æ»šåŠ¨è‡³åº•éƒ¨çŠ¶æ€\r\n',0),(209651,5824,'sv','BlÃ¤ddra ner till botten fÃ¶r status',0),(209652,5824,'it','scorrere verso il basso per lo stato',0),(209653,5824,'tl','',0),(209654,5824,'th','&#3648;&#3621;&#3639;&#3656;&#3629;&#3609;&#3621;&#3591;&#3626;&#3641;&#3656;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3606;&#3634;&#3609;&#3632;',0),(209655,5824,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤¸à¥à¤•à¥à¤°à¥‰à¤² à¤•à¤°à¥‡à¤‚',0),(209656,5824,'ms','Tatal ke bawah ke bawah status',0),(209657,5824,'ar','Ù‚Ù… Ø¨Ø§Ù„ØªÙ…Ø±ÙŠØ± Ù„Ø£Ø³ÙÙ„ Ø¥Ù„Ù‰ Ø£Ø³ÙÙ„ Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù…Ø±ÙƒØ²',0),(209658,5824,'fr','Faites dÃ©filer vers le bas pour le statut',0),(209659,5824,'jp','ç?¾çŠ¶ã‚’è¦‹ã‚‹ã?«ã?¯ä¸‹ã?¾ã?§ã‚¹ã‚¯ãƒ­ãƒ¼ãƒ«',0),(209660,5824,'pt','Role para baixo atÃ© a parte inferior para o status',0),(209661,5824,'ru','ÐŸÑ€Ð¾ÐºÑ€ÑƒÑ‚Ð¸Ñ‚Ðµ Ð²Ð½Ð¸Ð· Ð´Ð¾ Ð½Ð¸Ð¶Ð½ÐµÐ¹ Ñ‡Ð°ÑÑ‚Ð¸ Ð´Ð»Ñ ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(209662,5824,'es','Desplazarse hacia abajo para el status',0),(209663,5824,'de','Scrollen Sie Ende fÃ¼r status',0),(209664,5824,'en','scroll down to bottom for status',0),(209665,5825,'is','',0),(209666,5825,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ ØµÙØ­Ù‡ Ø¢Ø±Ø§ÙŠÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø­Ø³Ø§Ø¨  Ø±Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ†ÙŠØ¯',0),(209667,5825,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ ØµÙØ­Ù‡ Ø¢Ø±Ø§ÙŠÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø­Ø³Ø§Ø¨  Ø±Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ†ÙŠØ¯',0),(209668,5825,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ standart hesap dÃ¼zenleri iÃ§in tÄ±klayÄ±nÄ±z.',0),(209669,5825,'pl','Kliknij tutaj, aby widok ukÅ‚ady standardowe konto',0),(209670,5825,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¸Ð·Ð³Ð»ÐµÐ´Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¾Ñ„Ð¾Ñ€Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(209671,5825,'ur','Ù…Ù†Ø¸Ø± Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù„Û’ Ø¢Ø¤Ù¹ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(209672,5825,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð· Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(209673,5825,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ xem cÃ¡ch sáº¯p xáº¿p TK chuáº©n',0),(209674,5825,'af','Kliek Hier om Details te Besigtig',0),(209675,5825,'ro','Click aici sa Vezi cont Standard machete',0),(209676,5825,'et','KlÃµpsa siia, et nÃ¤ha standardkontosid',0),(209677,5825,'si','Kliknite tukaj za ogled standardni raÄun postavitve',0),(209678,5825,'ba','Klik disini untuk lihat akun standar layout',0),(209679,5825,'nl','Klik hier om weergave standaardaccount lay-outs',0),(209680,5825,'fi','Klikkaa tÃ¤stÃ¤ Katso perustili asettelujen',0),(209681,5825,'no','Klikk her for Ã¥ vise Standard konto oppsett',0),(209682,5825,'da','Klik her for at se standardkonto Layouts',0),(209683,5825,'ko','ì—¬ê¸°ë¥¼ í´ë¦­ ë³´ê¸° í‘œì¤€ ê³„ì • ë ˆì´ì•„ì›ƒì„',0),(209684,5825,'he','×œ×—×¦×• ×›××Ÿ ×œ×§×‘×œ×ª ×ª×¦×•×’×” ×—×©×‘×•×Ÿ ×¨×’×™×œ ×¤×¨×™×¡×•×ª',0),(209685,5825,'el','ÎšÎ»Î¹ÎºÎµÎ´ÏŽ ÏƒÎµ Î¸Î­Î± Ï„Ï…Ï€Î¹ÎºÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÏƒÏ‡ÎµÎ´Î¹Î±Î³ÏÎ¬Î¼Î¼Î±Ï„Î±',0),(209686,5825,'zh','ç‚¹å‡»è¿™é‡ŒæŸ¥çœ‹æ ‡å‡†è´¦æˆ·å¸ƒå±€\r\n',0),(209687,5825,'sv','Klicka hÃ¤r fÃ¶r att Visa Standard-konto layouter',0),(209688,5825,'it','Clicca qui per layout conto Standard vista',0),(209689,5825,'tl','',0),(209690,5825,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3648;&#3588;&#3657;&#3634;&#3650;&#3588;&#3619;&#3591;&#3612;&#3633;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(209691,5825,'hi','à¤¯à¤¹à¤¾à¤ à¤¦à¥‡à¤–à¥‡à¤‚ à¤®à¤¾à¤¨à¤• à¤–à¤¾à¤¤à¤¾ à¤²à¥‡à¤†à¤‰à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(209692,5825,'ms','Klik di sini untuk paparan akaun Standard pelan susun atur',0),(209693,5825,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¹Ø±Ø¶ ØªØ®Ø·ÙŠØ·Ø§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ',0),(209694,5825,'fr','Cliquez ici pour voir compte Standard Layouts',0),(209695,5825,'jp','æ¨™æº–ã?®ã‚«ã‚¦ãƒ³ãƒˆé…?ç½®ã‚’è¦‹ã‚‹ã?Ÿã‚?ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(209696,5825,'pt','Clique aqui para Layouts de conta padrÃ£o de exibiÃ§Ã£o',0),(209697,5825,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð»Ð¸ÑÑ‚Ð¾Ð² ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð°Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(209698,5825,'es','Click AquÃ­ para Ver Esquemas de Cuentas EstÃ¡ndares',0),(209699,5825,'de','Klicken Sie hier, um Ansichtslayouts Standardkonto',0),(209700,5825,'en','Click Here to View Standard Account Layouts',0),(209701,5826,'is','',0),(209702,5826,'dr','(Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(209703,5826,'pr','Ø§Ù‚Ù„Ø§Ù…(Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(209704,5826,'tr','Kategoriler',0),(209705,5826,'pl','Kategorie',0),(209706,5826,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(209707,5826,'ur','Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(209708,5826,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(209709,5826,'vi','Thá»ƒ loáº¡i',0),(209710,5826,'af','KategoriÃ« ',0),(209711,5826,'ro','Categorii',0),(209712,5826,'et','Kategooriad',0),(209713,5826,'si','Kategorije',0),(209714,5826,'ba','Kategori',0),(209715,5826,'nl','CategorieÃ«n',0),(209716,5826,'fi','Luokat',0),(209717,5826,'no','Kategorier',0),(209718,5826,'da','Kategorier',0),(209719,5826,'ko','ì¹´í…Œê³ ë¦¬',0),(209720,5826,'he','×§×˜×’×•×¨×™×•×ª',0),(209721,5826,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(209722,5826,'zh','åˆ†ç±»\r\n',0),(209723,5826,'sv','Kategorier',0),(209724,5826,'it','Categorie',0),(209725,5826,'tl','',0),(209726,5826,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(209727,5826,'hi','à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(209728,5826,'ms','Kategori',0),(209729,5826,'ar','Ø§Ù„ØªØµÙ†ÙŠÙØ§Øª',0),(209730,5826,'fr','CatÃ©gories',0),(209731,5826,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(209732,5826,'pt','Categorias',0),(209733,5826,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(209734,5826,'es','CategorÃ­as',0),(209735,5826,'de','Kategorien',0),(209736,5826,'en','Categories',0),(209737,5827,'is','',0),(209738,5827,'dr','Ú¯Ø±Ø¨Ù‡ Ù‡Ø§ÙŠ Ø²ÙŠØ±(ØªØ§Ø¨Ø¹-Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† ÙƒØ±Ø¯Ù†',0),(209739,5827,'pr','Ú¯Ø±Ø¨Ù‡ Ù‡Ø§ÙŠ Ø²ÙŠØ±(ØªØ§Ø¨Ø¹-Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† ÙƒØ±Ø¯Ù†',0),(209740,5827,'tr','Subs',0),(209741,5827,'pl','Napisy',0),(209742,5827,'bg','ÐŸÐ¾Ð´Ð²Ð¾Ð´Ð½Ð¸Ñ†Ð¸',0),(209743,5827,'ur','Ø¶Ù…Ù†ÛŒØ§Øª',0),(209744,5827,'sr','ÐŸÐ¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ðµ',0),(209745,5827,'vi','Phá»¥',0),(209746,5827,'af','Subs',0),(209747,5827,'ro','Subs',0),(209748,5827,'et','Subs',0),(209749,5827,'si','Subs',0),(209750,5827,'ba','Kapal selam',0),(209751,5827,'nl','Subs',0),(209752,5827,'fi','Subs',0),(209753,5827,'no','UbÃ¥ter',0),(209754,5827,'da','Subs',0),(209755,5827,'ko','ìž ìˆ˜ì •',0),(209756,5827,'he','×¦×•×œ×œ×•×ª',0),(209757,5827,'el','Î•Ï€ÏŒÎ¼',0),(209758,5827,'zh','å­\r\n',0),(209759,5827,'sv','Subs',0),(209760,5827,'it','Subs',0),(209761,5827,'tl','',0),(209762,5827,'th','&#3618;&#3656;&#3629;&#3618;',0),(209763,5827,'hi','Subs',0),(209764,5827,'ms','Kapal selam',0),(209765,5827,'ar','Ø§Ù„ØºÙˆØ§ØµØ§Øª',0),(209766,5827,'fr','Subs',0),(209767,5827,'jp','ä»£ã‚?ã‚Š',0),(209768,5827,'pt','Subs',0),(209769,5827,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð´Ð½Ð¸Ðº',0),(209770,5827,'es','Subs',0),(209771,5827,'de','U-Boote',0),(209772,5827,'en','Subs',0),(209773,5828,'is','',0),(209774,5828,'dr','Ù†Ù…Ø§ÙŠØ´ Ù‡Ù…Ù‡ ',0),(209775,5828,'pr','Ù†Ù…Ø§ÙŠØ´ Ù‡Ù…Ù‡ ',0),(209776,5828,'tr','Hepsini gÃ¶r',0),(209777,5828,'pl','Zobacz wszystkie',0),(209778,5828,'bg','Ð’Ð¸Ð¶ Ð²ÑÐ¸Ñ‡ÐºÐ¸',0),(209779,5828,'ur','Ø³Ø¨ Ú©Ú†Ú¾ Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(209780,5828,'sr','Ð’Ð¸Ð´Ð¸Ñ‚Ðµ ÑÐ²Ðµ',0),(209781,5828,'vi','Xem háº¿t',0),(209782,5828,'af','Besigtig Alles',0),(209783,5828,'ro','Vezi toate',0),(209784,5828,'et','Vaata kÃµiki',0),(209785,5828,'si','Poglej vse',0),(209786,5828,'ba','Lihat semua',0),(209787,5828,'nl','Alle bekijken',0),(209788,5828,'fi','NÃ¤ytÃ¤ kaikki',0),(209789,5828,'no','Vise alle',0),(209790,5828,'da','Se alle',0),(209791,5828,'ko','ëª¨ë‘ ë³´ê¸°',0),(209792,5828,'he','×œ×”×¦×™×’ ××ª ×›×œ',0),(209793,5828,'el','Î ÏÎ¿Î²Î¿Î»Î® ÏŒÎ»Ï‰Î½',0),(209794,5828,'zh','æŸ¥çœ‹å…¨éƒ¨\r\n',0),(209795,5828,'sv','Visa alla',0),(209796,5828,'it','Mostra tutti',0),(209797,5828,'tl','',0),(209798,5828,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(209799,5828,'hi','à¤¸à¤­à¥€ à¤¦à¥‡à¤–à¥‡à¤‚',0),(209800,5828,'ms','Lihat semua',0),(209801,5828,'ar','Ø¹Ø±Ø¶ Ø§Ù„ÙƒÙ„',0),(209802,5828,'fr','Voir tous les',0),(209803,5828,'jp','å…¨ã?¦ã?¿ã‚‹',0),(209804,5828,'pt','Ver todos os',0),(209805,5828,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð’ÑÐµ',0),(209806,5828,'es','Visionar Todo',0),(209807,5828,'de','Alle anzeigen',0),(209808,5828,'en','View All',0),(209809,5829,'is','',0),(209810,5829,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ ',0),(209811,5829,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ ',0),(209812,5829,'tr','GÃ¶rÃ¼nÃ¼m Kategoriler',0),(209813,5829,'pl','Widok kategorii',0),(209814,5829,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(209815,5829,'ur','Ù†Ù‚Ø·Û Ù†Ø¸Ø± Ú©Û’ Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(209816,5829,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(209817,5829,'vi','Xem thá»ƒ loáº¡i',0),(209818,5829,'af','Besigtig KategoriÃ«',0),(209819,5829,'ro','Vezi categorii',0),(209820,5829,'et','Kuva Kategooriad',0),(209821,5829,'si','Pogled kategorij',0),(209822,5829,'ba','Lihat Kategori ',0),(209823,5829,'nl','Weergave CategorieÃ«n',0),(209824,5829,'fi','NÃ¤ytÃ¤ Luokat',0),(209825,5829,'no','Vise kategorier',0),(209826,5829,'da','Se kategorier',0),(209827,5829,'ko','ë³´ê¸° ì¹´í…Œê³ ë¦¬',0),(209828,5829,'he','×ª×¦×•×’×ª ×§×˜×’×•×¨×™×•×ª',0),(209829,5829,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎºÎ±Ï„Î·Î³Î¿ÏÎ¹ÏŽÎ½',0),(209830,5829,'zh','æŸ¥çœ‹åˆ†ç±»\r\n',0),(209831,5829,'sv','Visa kategorier',0),(209832,5829,'it','Vista categorie',0),(209833,5829,'tl','',0),(209834,5829,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(209835,5829,'hi','à¤šà¥ˆà¤¨à¤² à¤¦à¥‡à¤–à¥‡à¤‚',0),(209836,5829,'ms','Paparan Kategori',0),(209837,5829,'ar','Ø¹Ø±Ø¶ Ø§Ù„ØªØµÙ†ÙŠÙØ§Øª',0),(209838,5829,'fr','Vue catÃ©gories',0),(209839,5829,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’ã?¿ã‚‹',0),(209840,5829,'pt','Ver categorias',0),(209841,5829,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹',0),(209842,5829,'es','Visionar CategorÃ­as',0),(209843,5829,'de','Ansicht-Kategorien',0),(209844,5829,'en','View Categories',0),(209845,5830,'is','',0),(209846,5830,'dr','ØµÙØ­Ù‡ Ø¢Ø±Ø§ÙŠÙŠ Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(209847,5830,'pr','ØµÙØ­Ù‡ Ø¢Ø±Ø§ÙŠÙŠ Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(209848,5830,'tr','Standart hesap dÃ¼zenler',0),(209849,5830,'pl','Konto standardowe ukÅ‚ady',0),(209850,5830,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¾Ñ„Ð¾Ñ€Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(209851,5830,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù„Û’ Ø¢Ø¤Ù¹',0),(209852,5830,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´Ð°',0),(209853,5830,'vi','CÃ¡ch Sáº¯p Xáº¿p TK Chuáº©n\r\n',0),(209854,5830,'af','Standaard Rekening Uitlegte',0),(209855,5830,'ro','Machete de cont standard',0),(209856,5830,'et','Standardkonto paigutusega',0),(209857,5830,'si','Standardni raÄun postavitve',0),(209858,5830,'ba','Akun standar layout',0),(209859,5830,'nl','Standaardaccount lay-outs',0),(209860,5830,'fi','Normaali tili asettelujen',0),(209861,5830,'no','Standardkonto oppsett',0),(209862,5830,'da','Standardkonto Layouts',0),(209863,5830,'ko','í‘œì¤€ ê³„ì • ë ˆì´ì•„ì›ƒ',0),(209864,5830,'he','×¤×¨×™×¡×•×ª ×—×©×‘×•×Ÿ ×¨×’×™×œ',0),(209865,5830,'el','Î¤Ï…Ï€Î¹ÎºÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÏƒÏ‡ÎµÎ´Î¹Î±Î³ÏÎ¬Î¼Î¼Î±Ï„Î±',0),(209866,5830,'zh','æ ‡å‡†è´¦æˆ·å¸ƒå±€\r\n',0),(209867,5830,'sv','Standardkonto layouter',0),(209868,5830,'it','Conto standard layout',0),(209869,5830,'tl','',0),(209870,5830,'th','&#3649;&#3612;&#3609;&#3591;&#3634;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(209871,5830,'hi','à¤®à¤¾à¤¨à¤• à¤–à¤¾à¤¤à¤¾ à¤²à¥‡à¤†à¤‰à¤Ÿ',0),(209872,5830,'ms','Susun atur akaun standard',0),(209873,5830,'ar','ØªØ®Ø·ÙŠØ·Ø§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ',0),(209874,5830,'fr','Compte standard Layouts',0),(209875,5830,'jp','æ¨™æº–ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒ¬ã‚¤ã‚¢ã‚¦ãƒˆ',0),(209876,5830,'pt','Layouts de conta Standard',0),(209877,5830,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ Ð¼Ð°ÐºÐµÑ‚Ñ‹',0),(209878,5830,'es','Esquemas de Cuentas EstÃ¡ndares',0),(209879,5830,'de','Standard-Account-Layouts',0),(209880,5830,'en','Standard Account Layouts',0),(209881,5831,'is','',0),(209882,5831,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø­Ø°Ù Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ Ù†ÙŠØ³Øª Ø²ÙŠØ±Ø§ ÙØ±Ø²Ù†Ø¯ Ø¯Ø§Ø±Ø¯',0),(209883,5831,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø­Ø°Ù Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ Ù†ÙŠØ³Øª Ø²ÙŠØ±Ø§ ÙØ±Ø²Ù†Ø¯ Ø¯Ø§Ø±Ø¯',0),(209884,5831,'tr','Ã‡Ã¼nkÃ¼ Ã§ocuklar bu kategoriyi silemezsiniz.',0),(209885,5831,'pl','Nie moÅ¼na usunÄ…Ä‡ tej kategorii, bo ma dzieci.',0),(209886,5831,'bg','Ð¢Ð°Ð·Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¸Ð·Ñ‚Ñ€Ð¸Ðµ, Ð·Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð¸Ð¼Ð° Ð´ÐµÑ†Ð°.',0),(209887,5831,'ur','ÛŒÛ Ø²Ù…Ø±Û Ø­Ø°Ù Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§ Ú©ÛŒÙˆÙ†Ú©Û Ø§Ø³ Ú©Û’ Ø¨Ú†Û’ ÛÛŒÚº Û”',0),(209888,5831,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ð¾Ð²Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ñ˜ÐµÑ€ Ð¸Ð¼Ð° Ð´ÐµÑ†Ñƒ.',0),(209889,5831,'vi','KhÃ´ng xÃ³a Ä‘Æ°á»£c thá»ƒ loáº¡i nÃ y vÃ¬ nÃ³ cÃ³ nhÃ¡nh phá»¥',0),(209890,5831,'af','Kan hierdie kategorie skrap omdat dit kinders het nie.',0),(209891,5831,'ro','Imposibil de È™ters aceastÄƒ categorie, deoarece are copii.',0),(209892,5831,'et','Seda kategooriat ei saa kustutada, kuna see on last.',0),(209893,5831,'si','Ta kategorija ni mogoÄe izbrisati, ker ima otrok.',0),(209894,5831,'ba','Tidak dapat menghapus kategori ini karena memiliki anak.',0),(209895,5831,'nl','Deze categorie kan niet verwijderen, omdat er kinderen.',0),(209896,5831,'fi','TÃ¤tÃ¤ luokkaa ei voi poistaa, koska sillÃ¤ on alisuunnitelmia.',0),(209897,5831,'no','Kan ikke slette denne kategorien fordi den har barn.',0),(209898,5831,'da','Kan ikke slette denne kategori, fordi det har bÃ¸rn.',0),(209899,5831,'ko','ì•„ì´ ë“¤ì„ê°€ì§€ê³  ìžˆê¸° ë•Œë¬¸ì—ì´ ë²”ì£¼ë¥¼ ì‚­ì œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(209900,5831,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×—×•×§ ×§×˜×’×•×¨×™×” ×–×• ×›×™ ×™×© ×œ×• ×™×œ×“×™×.',0),(209901,5831,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±, ÎµÏ€ÎµÎ¹Î´Î® Î­Ï‡ÎµÎ¹ Ï„Î± Ï€Î±Î¹Î´Î¹Î¬.',0),(209902,5831,'zh','æ— æ³•åˆ é™¤è¿™ä¸ªç±»åˆ«ï¼Œå› ä¸ºå®ƒæœ‰å­ã€‚\r\n',0),(209903,5831,'sv','Kan inte radera denna kategori eftersom det har barn.',0),(209904,5831,'it','Non Ã¨ possibile eliminare questa categoria perchÃ© ha figli.',0),(209905,5831,'tl','',0),(209906,5831,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3621;&#3610;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3609;&#3637;&#3657;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3592;&#3634;&#3585;&#3617;&#3637;&#3648;&#3604;&#3655;&#3',0),(209907,5831,'hi','à¤•à¥à¤¯à¥‹à¤‚à¤•à¤¿ à¤‡à¤¸à¥‡ à¤¬à¤šà¥à¤šà¥‹à¤‚ à¤¨à¥‡ à¤‡à¤¸ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¹à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤¸à¤•à¤¤à¥‡à¥¤',0),(209908,5831,'ms','Tidak dapat menghapuskan kategori ini kerana ia mempunyai kanak-kanak.',0),(209909,5831,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„ØªØµÙ†ÙŠÙ Ù„Ø£Ù† Ù„Ù‡ ØªÙØ±ÙŠØ¹Ø§Øª',0),(209910,5831,'fr','Impossible de supprimer cette catÃ©gorie parce qu\'il a des enfants.',0),(209911,5831,'jp','ã?“ã?®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?¯ç³»çµ±ã?Œã?‚ã‚‹ã?Ÿã‚?æ¶ˆåŽ»ã?™ã‚‹äº‹ã?Œå‡ºæ?¥ã?¾ã?›ã‚“',0),(209912,5831,'pt','NÃ£o Ã© possÃ­vel excluir esta categoria, porque tem os filhos.',0),(209913,5831,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½ÑƒÑŽ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ - Ð² Ð½ÐµÐ¹ Ð´ÐµÑ‚Ð¸.',0),(209914,5831,'es','No se puede Eliminar esta categorÃ­a porque tiene hijos',0),(209915,5831,'de','Diese Kategorie kann nicht gelÃ¶scht werden, weil sie Kinder hat.',0),(209916,5831,'en','Cannot delete this category because it has children.',0),(209917,5832,'is','',0),(209918,5832,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯ ',0),(209919,5832,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯ ',0),(209920,5832,'tr','Yeni Kategori oluÅŸturma',0),(209921,5832,'pl','Utworzenie nowej kategorii',0),(209922,5832,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(209923,5832,'ur','Ù†ÛŒØ§ Ø²Ù…Ø±Û Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(209924,5832,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(209925,5832,'vi','Táº¡o thá»ƒ loáº¡i má»›i',0),(209926,5832,'af','Skep Nuwe Kategorie',0),(209927,5832,'ro','Crea noi categorii',0),(209928,5832,'et','Loo uus kategooria',0),(209929,5832,'si','Ustvarite nove kategorije',0),(209930,5832,'ba','Buat Kategori',0),(209931,5832,'nl','Nieuwe categorie maken',0),(209932,5832,'fi','Uuden luokan luominen',0),(209933,5832,'no','Opprette ny kategori',0),(209934,5832,'da','Opret ny kategori',0),(209935,5832,'ko','ìƒˆ ë²”ì£¼ ë§Œë“¤ê¸°',0),(209936,5832,'he','×¦×•×¨ ×§×˜×’×•×¨×™×™×” ×—×“×©×”',0),(209937,5832,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î½Î­Î±Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚',0),(209938,5832,'zh','åˆ›å»ºæ–°åˆ†ç±»\r\n',0),(209939,5832,'sv','Skapa ny kategori',0),(209940,5832,'it','Creare la nuova categoria',0),(209941,5832,'tl','',0),(209942,5832,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3627;&#3617;&#3623;&#3604;',0),(209943,5832,'hi','à¤¨à¤ˆ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¬à¤¨à¤¾à¤à¤',0),(209944,5832,'ms','Mencipta kategori baru',0),(209945,5832,'ar','Ø¥Ù†Ø´Ø§Ø¡ ØªØµÙ†ÙŠÙ Ø¬Ø¯ÙŠØ¯',0),(209946,5832,'fr','CrÃ©er la nouvelle catÃ©gorie',0),(209947,5832,'jp','æ–°è¦?ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®ä½œæˆ?',0),(209948,5832,'pt','Criar nova categoria',0),(209949,5832,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ ÐÐ¾Ð²ÑƒÑŽ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(209950,5832,'es','Crear CategorÃ­a Nueva',0),(209951,5832,'de','Neue Kategorie erstellen',0),(209952,5832,'en','Create New Category',0),(209953,5833,'is','',0),(209954,5833,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ',0),(209955,5833,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ',0),(209956,5833,'tr','Hata kategori ekleme',0),(209957,5833,'pl','BÅ‚Ä…d dodawania kategorii',0),(209958,5833,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(209959,5833,'ur','Ù†Ù‚Øµ Ø²Ù…Ø±Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(209960,5833,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(209961,5833,'vi','ThÃªm thá»ƒ loáº¡i bá»‹ lá»—i',0),(209962,5833,'af','Fout voeg kategorie',0),(209963,5833,'ro','Eroare de adÄƒugare categorie',0),(209964,5833,'et','Viga lisades kategooria',0),(209965,5833,'si','Dodajanje Category napaka',0),(209966,5833,'ba','Kesalahan menambahkan kategori',0),(209967,5833,'nl','Fout toe te voegen categorie',0),(209968,5833,'fi','LisÃ¤Ã¤ luokka',0),(209969,5833,'no','Feil Ã¥ legge kategori',0),(209970,5833,'da','Fejl tilfÃ¸jelse af kategori',0),(209971,5833,'ko','ì˜¤ë¥˜ ì¶”ê°€ ë²”ì£¼',0),(209972,5833,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×§×˜×’×•×¨×™×™×”',0),(209973,5833,'el','Î›Î¬Î¸Î¿Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(209974,5833,'zh','é”™è¯¯ï¼šæ–°å¢žåˆ†ç±»\r\n',0),(209975,5833,'sv','Fel att lÃ¤gga till kategori',0),(209976,5833,'it','Errore aggiunta categoria',0),(209977,5833,'tl','',0),(209978,5833,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(209979,5833,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(209980,5833,'ms','Ralat menambah kategori',0),(209981,5833,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„ØªØµÙ†ÙŠÙ',0),(209982,5833,'fr','Erreur ajout catÃ©gorie',0),(209983,5833,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(209984,5833,'pt','Erro adicionando categoria',0),(209985,5833,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(209986,5833,'es','Error agregando CategorÃ­a',0),(209987,5833,'de','HinzufÃ¼gen von Fehlerkategorie',0),(209988,5833,'en','Error Adding Category',0),(209989,5834,'is','',0),(209990,5834,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ ',0),(209991,5834,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ ',0),(209992,5834,'tr','Hata gÃ¼ncelleÅŸtirme kategorisi',0),(209993,5834,'pl','BÅ‚Ä…d aktualizacji kategorii',0),(209994,5834,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(209995,5834,'ur','Ù†Ù‚Øµ Ø²Ù…Ø±Û ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(209996,5834,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(209997,5834,'vi','Cáº­p nháº­t thá»ƒ loáº¡i bá»‹ lá»—i',0),(209998,5834,'af','Fout Outobywerking kategorie',0),(209999,5834,'ro','Eroare de actualizare categorie',0),(210000,5834,'et','Viga ajakohastamine kategooria',0),(210001,5834,'si','Posodabljanje Category napaka',0),(210002,5834,'ba','Kesalahan update Kategori',0),(210003,5834,'nl','Fout bijwerken categorie',0),(210004,5834,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ luokka',0),(210005,5834,'no','Feil oppdatering kategori',0),(210006,5834,'da','Fejl opdatering kategori',0),(210007,5834,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì¹´í…Œê³ ë¦¬',0),(210008,5834,'he','×©×’×™××” ×‘×¢×“×›×•×Ÿ ×§×˜×’×•×¨×™×”',0),(210009,5834,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(210010,5834,'zh','é”™è¯¯æ›´æ–°åˆ†ç±»',0),(210011,5834,'sv','Fel uppdatering kategori',0),(210012,5834,'it','Errore aggiornamento categoria',0),(210013,5834,'tl','',0),(210014,5834,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(210015,5834,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(210016,5834,'ms','Ralat pengemaskinian kategori',0),(210017,5834,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„ØªØµÙ†ÙŠÙ',0),(210018,5834,'fr','CatÃ©gorie d\'erreur mise Ã  jour',0),(210019,5834,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(210020,5834,'pt','Categoria atualizaÃ§Ã£o de erro',0),(210021,5834,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(210022,5834,'es','Error Actualizando CategorÃ­a',0),(210023,5834,'de','Aktualisierung Fehlerkategorie',0),(210024,5834,'en','Error Updating Category',0),(210025,5835,'is','',0),(210026,5835,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¬Ø³ØªØ¬ÙˆÙŠ Ú¯Ø±ÙˆÙ‡ ',0),(210027,5835,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø³ØªØ¬ÙˆÙŠ Ú¯Ø±ÙˆÙ‡ ',0),(210028,5835,'tr','Arama kategorisi Ekle/GÃ¼ncelle',0),(210029,5835,'pl','Kategoria Szukaj Dodaj/Aktualizuj',0),(210030,5835,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(210031,5835,'ur','ØªÙ„Ø§Ø´ Ø²Ù…Ø±Û Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(210032,5835,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(210033,5835,'vi','ThÃªm/Cáº­p Nháº­t Thá»ƒ Loáº¡i TÃ¬m Kiáº¿m',0),(210034,5835,'af','Soek Katergorie Byvoeg/Opdateer',0),(210035,5835,'ro','CÄƒutaÅ£i categorie adaugÄƒ/actualizeazÄƒ',0),(210036,5835,'et','Lisa/Uuenda otsingukategooriaid',0),(210037,5835,'si','IÅ¡Äi kategoriji Dodaj/posodobi',0),(210038,5835,'ba','Cari kategori Tambahkan/Perbarui',0),(210039,5835,'nl','Zoek categorie toevoegen/bijwerken',0),(210040,5835,'fi','Etsi luokka lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(210041,5835,'no','SÃ¸k kategorien Legg til/Oppdater',0),(210042,5835,'da','SÃ¸g efter kategori TilfÃ¸j/opdater',0),(210043,5835,'ko','ê²€ìƒ‰ ì¹´í…Œê³ ë¦¬ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(210044,5835,'he','×§×˜×’×•×¨×™×” ×©×œ ×—×™×¤×•×© ×”×•×¡×£/×¢×“×›×Ÿ',0),(210045,5835,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(210046,5835,'zh','æœå¯»ç›®å½•æ–°å¢ž/æ›´æ–°\r\n',0),(210047,5835,'sv','SÃ¶k kategori LÃ¤gg till/uppdatera',0),(210048,5835,'it','Ricerca categoria Aggiungi/Aggiorna',0),(210049,5835,'tl','',0),(210050,5835,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3585;&#3634;&#3619; &#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(210051,5835,'hi','à¤–à¥‹à¤œ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(210052,5835,'ms','Carian kategori Tambah/Kemaskini',0),(210053,5835,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« ØªØµÙ†ÙŠÙ Ø§Ù„Ø¨Ø­Ø«',0),(210054,5835,'fr','Recherche catÃ©gorie ajouter/mettre Ã  jour',0),(210055,5835,'jp','æ¤œç´¢ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®è¿½åŠ /æ›´æ–°',0),(210056,5835,'pt','Categoria de busca adicionar/atualizar',0),(210057,5835,'ru','ÐŸÐ¾Ð¸ÑÐº ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(210058,5835,'es','CategorÃ­a de Busqueda Agregar/Actualizar',0),(210059,5835,'de','Suche Kategorie hinzufÃ¼gen/aktualisieren',0),(210060,5835,'en','Search Category Add/Update',0),(210061,5836,'is','',0),(210062,5836,'dr','-  Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø¨Ø±Ø§ÙŠ Ø¬Ù†Ø³Ù‡Ø§ÙŠ Ø¨Ø±Ø±Ø³ÙŠ Ø´Ø¯Ù‡ Ø§Ú¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ø¹Ø¯ Ø§Ø² Ø§Ø±Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(210063,5836,'pr','  Ù¾ÙŠØºØ§Ù… Ú¯Ø²ÙŠÙ†Ø´ Ø¬Ø³ØªØ¬ÙˆÙŠ Ú¯Ø±ÙˆÙ‡ Ø§ØµÙ„ÙŠ-  Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø±Ø±Ø³ÙŠ Ø´Ø¯Ù‡ Ø§Ú¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ø¹Ø¯ Ø§Ø² Ø§Ø±Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(210064,5836,'tr','EÄŸer deÄŸil iÅŸaretli Ã¶ÄŸeleri olacaktÄ±r iÃ§in seÃ§ilmiÅŸ, ana Kategoriler<br>otomatik olarak form gÃ¶nderme sonra seÃ§ilecek.',0),(210065,5836,'pl','JeÅ›li nie wybranej kategorii nadrzÄ™dnej dla zaznaczonych elementÃ³w bÄ™dzie<br>automatycznie zaznaczone po przedÅ‚oÅ¼eniu formularza.',0),(210066,5836,'bg','ÐÐºÐ¾ Ð½Ðµ Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð°, Ð¼Ð°Ð¹ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð·Ð° ÐžÑ‚Ð¼ÐµÑ‚Ð½Ð°Ñ‚Ð¸Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ñ‰Ðµ<br>Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ ÑÐµ Ð¸Ð·Ð±Ð¸Ñ€Ð°Ñ‚ ÑÐ»ÐµÐ´ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€Ð°.',0),(210067,5836,'ur','Ø§Ú¯Ø± Ù†ÛÛŒÚºØŒ ØªÙˆ Ù¾Ú‘ØªØ§Ù„ Ø´Ø¯Û Ø§Ø´ÛŒØ§ Ú©Û’ Ù„ÛŒÛ’ ÙˆØ§Ù„Ø¯ÛŒÙ† Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù… Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ØŒ Ú¯Û’<br>ÙØ§Ø±Ù… Ú©Ø±Ø§Ù†Û’ Ú©Û’ Ø¨Ø¹Ø¯ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ Ù…Ù†ØªØ®Ø¨ ÛÙˆ Û”',0),(210068,5836,'sr','Ð£ ÑÑƒÐ¿Ñ€Ð¾Ñ‚Ð½Ð¾Ð¼ Ñ›Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸, Ð½Ð°Ð´Ñ€ÐµÑ’ÐµÐ½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð·Ð° Ð¾Ð´Ð°Ð±Ñ€Ð°Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ<br>Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð±Ð¸Ñ‚Ð¸ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸ Ð½Ð°ÐºÐ¾Ð½ Ð¿Ñ€Ð¾ÑÐ»ÐµÑ’Ð¸Ð²Ð°ÑšÐ° Ð¾Ð±Ñ€Ð°ÑÑ†Ð°.',0),(210069,5836,'vi','Náº¿u khÃ´ng chá»n, há»‡ thá»‘ng sáº½ tá»± Ä‘á»™ng chá»n thá»ƒ loáº¡i gia Ä‘Ã¬nh cho sÃ©c <br />sau khi Ä‘Äƒng kÃ½.',0),(210070,5836,'af','Indien nie gekies, sal ouerkategorie vir gekiesde itemsoutomaties gekies word na die vorm inhandiging',0),(210071,5836,'ro','DacÄƒ nu alese, categoriile de pÄƒrinte pentru elemente verificate va<br>fi selectate automat dupÄƒ trimiterea formularului.',0),(210072,5836,'et','Kui ei valitud, vanema kategooria mÃ¤rgitute tahe<br>valida automaatselt pÃ¤rast vormi esitamist.',0),(210073,5836,'si','ÄŒe ne bo izbrana, nadrejene kategorije za potrjeni elementi<br>samodejno izbere po predloÅ¾itvi obrazca.',0),(210074,5836,'ba','Jika tidak dipilih, orangtua kategori untuk memeriksa item akan<br>secara otomatis dipilih setelah pengiriman form.',0),(210075,5836,'nl','Als niet gekozen, bovenliggende categorieÃ«n voor de geselecteerde items zal<br>automatisch worden geselecteerd na het indienen van formulieren.',0),(210076,5836,'fi','Jos ei valittu pÃ¤Ã¤luokat valittujen kohteiden<br>automaattisesti, lomakkeen lÃ¤hettÃ¤misen jÃ¤lkeen.',0),(210077,5836,'no','Dersom ikke valgt, overordnede kategorier for merkede elementer vil<br>automatisk velges etter skjemainnsending.',0),(210078,5836,'da','Hvis ikke valgt, overordnede kategorier for markerede elementer vil<br>automatisk vÃ¦lges efter formularafsendelse.',0),(210079,5836,'ko','ì„ íƒ, ì„ íƒ ëœ í•­ëª©ì— ëŒ€ í•œ ìƒìœ„ ë²”ì£¼ ë©ë‹ˆë‹¤ í•˜ì§€ ì•Šì„ ê²½ìš°<br>ìžë™ìœ¼ë¡œ ì–‘ì‹ ì œì¶œ í›„ ì„ íƒ í•©ë‹ˆë‹¤.',0),(210080,5836,'he','×× ×œ× × ×‘×—×¨, ×§×˜×’×•×¨×™×•×ª ××‘ ×œ×•×•×™×œ ×¤×¨×™×˜×™× ×ž×¡×•×ž× ×™×<br>×œ×”×™×•×ª × ×‘×—×¨×ª ××•×˜×•×ž×˜×™×ª ×œ××—×¨ ×©×œ×™×—×ª ×”×˜×•×¤×¡.',0),(210081,5836,'el','Î‘Î½ Î´ÎµÎ½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯, Ï…Ï€ÎµÏ-ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î± ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î¸Î±<br>Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î± ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹ Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ Ï„Î·Î½ Ï…Ï€Î¿Î²Î¿Î»Î® Ï„Î·Ï‚ Ï†ÏŒÏÎ¼Î±Ï‚.',0),(210082,5836,'zh','å¦‚æžœæ²¡æœ‰é€‰æ‹©ï¼Œå¯¹æ‰˜è¿ç‰©å“çš„çˆ¶ç±»åˆ«å°†è¡¨å•æäº¤åŽè‡ªåŠ¨é€‰å®šã€‚\r\n',0),(210083,5836,'sv','Om inte valt, Ã¶verordnade kategorier fÃ¶r markerade objekt kommer att<br>automatiskt vÃ¤ljas efter formulÃ¤rÃ¶verfÃ¶ringen.',0),(210084,5836,'it','Se non selezionate, categorie genitore per gli elementi selezionati saranno<br>essere selezionato automaticamente dopo l\'invio del modulo.',0),(210085,5836,'tl','',0),(210086,5836,'th','If not chosen, parent categories for checked items will<br />automatically be selected after form submission.',0),(210087,5836,'hi','à¤…à¤—à¤° à¤¨à¤¹à¥€à¤‚ à¤šà¥à¤¨à¤¾, à¤ªà¥ˆà¤°à¥‡à¤‚à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤ à¤šà¥‡à¤• à¤•à¤¿à¤ à¤—à¤ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¥‹à¤—à¤¾<br>à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤¸à¤¬à¤®à¤¿à¤¶à¤¨ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥à¤µà¤¤: à¤šà¤¯à¤¨à¤¿à¤¤ à¤¹à',0),(210088,5836,'ms','Jika tidak dipilih, kategori ibu/bapa bagi item-item yang telah disemak akan<br>secara automatik dipilih selepas penyerahan borang.',0),(210089,5836,'ar','Ø¥Ø°Ø§ Ù„Ù… ÙŠÙƒÙ† Ø§Ù„Ù…Ø®ØªØ§Ø±ØŒ Ø³ÙˆÙ ÙØ¦Ø§Øª Ø§Ù„Ø£ØµÙ„ Ù„Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©<br>ÙŠÙ…ÙƒÙ† ØªØ­Ø¯ÙŠØ¯ ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨Ø¹Ø¯ Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ù†Ù…ÙˆØ°Ø¬.',0),(210090,5836,'fr','Si ce n\'est choisi, la catÃ©gorie parente pour les Ã©lÃ©ments activÃ©s seront<br>automatiquement sÃ©lectionnÃ© aprÃ¨s soumission du formulaire.',0),(210091,5836,'jp','é?¸ã?°ã‚Œã?¦ã?„ã?ªã?„ã?ªã‚‰ã€?ãƒ?ã‚§ãƒƒã‚¯æ¸ˆå“?ç›®ã?®è¦ªã‚«ãƒ†ã‚´ãƒªãƒ¼ã?¯<br>ãƒ•ã‚©ãƒ¼ãƒ ã?®æ??æ¡ˆå¾Œã?«è‡ªå‹•çš„ã?«é?¸æŠžã?•ã‚Œã?¾ã?™ã€‚',0),(210092,5836,'pt','Se nÃ£o for escolhida, serÃ£o de categorias-pai para itens selecionados<br>ser selecionado automaticamente apÃ³s o envio do formulÃ¡rio.',0),(210093,5836,'ru','Ð•ÑÐ»Ð¸ Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½, Ñ€Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ñ… ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ Ð´Ð»Ñ Ð¾Ñ‚Ð¼ÐµÑ‡ÐµÐ½Ð½Ñ‹Ñ… ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð±ÑƒÐ´ÐµÑ‚<br>Ð²Ñ‹Ð±Ñ€Ð°Ð½ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð¿Ð¾ÑÐ»Ðµ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ Ñ„Ð¾Ñ€Ð¼Ñ‹.',0),(210094,5836,'es','Si no seleccionadas, categorÃ­as padres para items checados serÃ¡n<br/>seleccionadas automaticamente despuÃ©s de someter el formulario',0),(210095,5836,'de','Wenn nicht ausgewÃ¤hlt, werden Ã¼bergeordnete Kategorien fÃ¼r markierte Objekte<br>automatisch nach FormularÃ¼bergabe ausgewÃ¤hlt werden.',0),(210096,5836,'en','If not chosen, parent categories for checked items will<br />automatically be selected after form submission.',0),(210097,5837,'is','',0),(210098,5837,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(210099,5837,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(210100,5837,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ standart hesap setleri',0),(210101,5837,'pl','Widok konto standardowe ZESTAWY',0),(210102,5837,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ð°ÐºÐ°ÑƒÐ½Ñ‚ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¸',0),(210103,5837,'ur','Ù…Ù†Ø¸Ø± Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ Ú©Ø±ØªØ§ ÛÛ’',0),(210104,5837,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ ÑÐºÑƒÐ¿Ð¾Ð²Ð°',0),(210105,5837,'vi','Xem Bá»™ TK Chuáº©n',0),(210106,5837,'af','Besigtig Standaard Rekening Stelle',0),(210107,5837,'ro','Seturi de cont Standard Vezi',0),(210108,5837,'et','Vaata standardkontode sette',0),(210109,5837,'si','Pogled standardni raÄun sklopov',0),(210110,5837,'ba','Lihat akun Standard set',0),(210111,5837,'nl','Weergave standaardaccount Sets',0),(210112,5837,'fi','NÃ¤ytÃ¤ normaali tili asetetaan',0),(210113,5837,'no','Vis standardkonto sett',0),(210114,5837,'da','Se standardkonto sÃ¦t',0),(210115,5837,'ko','ë³´ê¸° í‘œì¤€ ê³„ì • ì§‘í•©',0),(210116,5837,'he','×ª×¦×•×’×ª ×¡×˜×™× ×—×©×‘×•×Ÿ ×¨×’×™×œ',0),(210117,5837,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï„Ï…Ï€Î¹ÎºÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÏƒÏÎ½Î¿Î»Î±',0),(210118,5837,'zh','æŸ¥çœ‹æ ‡å‡†å¸æˆ·è®¾ç½®\r\n',0),(210119,5837,'sv','Visa Standard-konto uppsÃ¤ttningar',0),(210120,5837,'it','Vista Account Standard set',0),(210121,5837,'tl','',0),(210122,5837,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(210123,5837,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤®à¤¾à¤¨à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿ',0),(210124,5837,'ms','Paparan akaun Standard set',0),(210125,5837,'ar','Ø¹Ø±Ø¶ Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ',0),(210126,5837,'fr','Vue Standard compte jeux',0),(210127,5837,'jp','æ¨™æº–ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚»ãƒƒãƒˆã‚’',0),(210128,5837,'pt','Conjuntos de conta padrÃ£o de exibiÃ§Ã£o',0),(210129,5837,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð½Ð°Ð±Ð¾Ñ€Ñ‹',0),(210130,5837,'es','Visionar Juegos de Cuentas EstÃ¡ndares',0),(210131,5837,'de','Ansicht-Standardkonto-Sets',0),(210132,5837,'en','View Standard Account Sets',0),(210133,5838,'is','',0),(210134,5838,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(210135,5838,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(210136,5838,'tr','Banka mevduat eklemek',0),(210137,5838,'pl','Dodaj przelew',0),(210138,5838,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²Ð»Ð¾Ð³Ð¾Ð²ÐµÑ‚Ðµ Ð² Ð±Ð°Ð½ÐºÐ¸Ñ‚Ðµ',0),(210139,5838,'ur','Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(210140,5838,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð±Ð°Ð½ÐºÐµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(210141,5838,'vi','ThÃªm TK NgÃ¢n hÃ ng Ná»£',0),(210142,5838,'af','Bank Deposito Byvoeg',0),(210143,5838,'ro','Adauga depozit bancar',0),(210144,5838,'et','Lisada pangahoiuste',0),(210145,5838,'si','Dodaj banÄni depozit',0),(210146,5838,'ba','Tambahkan deposito Bank',0),(210147,5838,'nl','Toevoegen van bankstorting',0),(210148,5838,'fi','LisÃ¤Ã¤ Bank Deposit',0),(210149,5838,'no','Legge til bankinnskudd',0),(210150,5838,'da','TilfÃ¸je Bank depositum',0),(210151,5838,'ko','ì€í–‰ ì˜ˆê¸ˆ ì¶”ê°€',0),(210152,5838,'he','×”×•×¡×£ ×¤×§×“×•×Ÿ ×‘× ×§',0),(210153,5838,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÎµ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(210154,5838,'zh','æ–°å¢žé“¶è¡Œå­˜æ¬¾\r\n',0),(210155,5838,'sv','LÃ¤gg till bankinsÃ¤ttning',0),(210156,5838,'it','Aggiungi deposito bancario',0),(210157,5838,'tl','',0),(210158,5838,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(210159,5838,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(210160,5838,'ms','Tambah Bank Deposit',0),(210161,5838,'ar','Ø£Ø¶Ù Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(210162,5838,'fr','Ajouter des dÃ©pÃ´ts bancaires',0),(210163,5838,'jp','éŠ€è¡Œé ?é‡‘ã?®è¿½åŠ ',0),(210164,5838,'pt','Adicionar o depÃ³sito bancÃ¡rio',0),(210165,5838,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(210166,5838,'es','Agregar Deposto Bancario',0),(210167,5838,'de','HinzufÃ¼gen von Bankeinlagen',0),(210168,5838,'en','Add Bank Deposit',0),(210169,5839,'is','',0),(210170,5839,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(210171,5839,'pr','ØªØ§Ø±ÙŠØ® Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(210172,5839,'tr','Ã–deme tarihi',0),(210173,5839,'pl','Data wpÅ‚aty',0),(210174,5839,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(210175,5839,'ur','Ø¬Ù…Ø¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(210176,5839,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(210177,5839,'vi','NgÃ y Äáº·t cá»c',0),(210178,5839,'af','Deposito Datum',0),(210179,5839,'ro','Data de depozit',0),(210180,5839,'et','Tagatisraha kuupÃ¤ev',0),(210181,5839,'si','Datum pologa',0),(210182,5839,'ba','Deposit tanggal',0),(210183,5839,'nl','Datum van storting',0),(210184,5839,'fi','Talletus pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(210185,5839,'no','Innbetalingen dato',0),(210186,5839,'da','Depositum dato',0),(210187,5839,'ko','ìž…ê¸ˆ ë‚ ì§œ',0),(210188,5839,'he','×ª××¨×™×š ×”×”×¤×§×“×”',0),(210189,5839,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(210190,5839,'zh','å­˜æ¬¾æ—¥æœŸ\r\n',0),(210191,5839,'sv','InsÃ¤ttning datum',0),(210192,5839,'it','Data di deposito',0),(210193,5839,'tl','',0),(210194,5839,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3613;&#3634;&#3585;',0),(210195,5839,'hi','à¤œà¤®à¤¾ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(210196,5839,'ms','Tarikh Deposit',0),(210197,5839,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(210198,5839,'fr','Date de dÃ©pÃ´t',0),(210199,5839,'jp','é ?è¨—æ—¥',0),(210200,5839,'pt','Data de depÃ³sito',0),(210201,5839,'ru','Ð”Ð°Ñ‚Ð° Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(210202,5839,'es','Fecha de DepÃ³sito',0),(210203,5839,'de','Einzahlungsdatum',0),(210204,5839,'en','Deposit Date',0),(210205,5840,'is','',0),(210206,5840,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(210207,5840,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(210208,5840,'tr','Genel muhasebe giriÅŸleri',0),(210209,5840,'pl','Zapisy ksiÄ™gi gÅ‚Ã³wnej',0),(210210,5840,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(210211,5840,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(210212,5840,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð³Ð»Ð°Ð²Ð½Ðµ ÐºÑšÐ¸Ð³Ðµ',0),(210213,5840,'vi','BÃºt ToÃ¡n Sá»• CÃ¡i Tá»•ng Há»£p',0),(210214,5840,'af','Algemene Grootboek Inskrywings',0),(210215,5840,'ro','IntrÄƒri Ã®n registrul general',0),(210216,5840,'et','Pearaamatu sissekanded',0),(210217,5840,'si','Postavke glavne knjige',0),(210218,5840,'ba','General Ledger entri',0),(210219,5840,'nl','Grootboekposten',0),(210220,5840,'fi','PÃ¤Ã¤kirjanpidon tapahtumat',0),(210221,5840,'no','Finansposter',0),(210222,5840,'da','Finansposter',0),(210223,5840,'ko','ì¼ë°˜ ë ˆì € í•­ëª©',0),(210224,5840,'he','×¤×§×•×“×•×ª ×™×•×ž×Ÿ ×›×œ×œ×™',0),(210225,5840,'el','Î•Î³Î³ÏÎ±Ï†ÏŽÎ½ Î³ÎµÎ½Î¹ÎºÎ®Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚',0),(210226,5840,'zh','æ€»å¸é¡¹\r\n',0),(210227,5840,'sv','Redovisningstransaktioner',0),(210228,5840,'it','Movimenti contabili di generale',0),(210229,5840,'tl','',0),(210230,5840,'th','&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(210231,5840,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(210232,5840,'ms','Catatan Lejar Am',0),(210233,5840,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(210234,5840,'fr','Ã‰critures comptables',0),(210235,5840,'jp','ç·?å‹˜å®šå…ƒå¸³è¨˜å…¥',0),(210236,5840,'pt','General Ledger Entries',0),(210237,5840,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð“Ð»Ð°Ð²Ð½Ð¾Ð¹ ÐšÐ½Ð¸Ð³Ð¸',0),(210238,5840,'es','Entradas de Libro Mayor',0),(210239,5840,'de','Sachposten',0),(210240,5840,'en','General Ledger Entries',0),(210241,5841,'is','',0),(210242,5841,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± ',0),(210243,5841,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± ',0),(210244,5841,'tr','-Fatura Ã¶demeleri',0),(210245,5841,'pl','PÅ‚atnoÅ›ci-faktura',0),(210246,5841,'bg','Ð—Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(210247,5841,'ur','ØºÛŒØ± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(210248,5841,'sr','Ð‘ÐµÐ· Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(210249,5841,'vi','Thanh toÃ¡n khÃ´ng cÃ³ hÃ³a Ä‘Æ¡n',0),(210250,5841,'af','Nie-Faktuur Betalings',0),(210251,5841,'ro','Plata facturilor non',0),(210252,5841,'et','Ettemaksuarve maksed',0),(210253,5841,'si','RaÄun plaÄila',0),(210254,5841,'ba','Bebas-faktur pembayaran',0),(210255,5841,'nl','Niet-factuur betalingen',0),(210256,5841,'fi','Laskujen maksut',0),(210257,5841,'no','Ikke-faktura betalinger',0),(210258,5841,'da','Ikke-fakturabetalinger',0),(210259,5841,'ko','ë¹„ ì²­êµ¬ì„œ ì§€ë¶ˆ',0),(210260,5841,'he','×ª×©×œ×•×ž×™× ×©××™× ×-×—×©×‘×•× ×™×ª',0),(210261,5841,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Î¼Î·-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(210262,5841,'zh','æ— å‘ç¥¨ä»˜æ¬¾\r\n',0),(210263,5841,'sv','Icke-faktura betalningar',0),(210264,5841,'it','Pagamenti non-fattura',0),(210265,5841,'tl','',0),(210266,5841,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(210267,5841,'hi','à¤—à¥ˆà¤°-à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(210268,5841,'ms','Invois pembayaran',0),(210269,5841,'ar','Ù…Ø¯ÙÙˆØ¹Ø§Øª ØºÙŠØ± Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(210270,5841,'fr','Paiements de facture non',0),(210271,5841,'jp','ç„¡è«‹æ±‚æ”¯æ‰•ã?„',0),(210272,5841,'pt','Pagamentos de fatura nÃ£o',0),(210273,5841,'ru','ÐÐ¾Ð¼ÐµÑ€Ð° ÑÑ‡ÐµÑ‚Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(210274,5841,'es','Pagos Ventas No Facturadas',0),(210275,5841,'de','Nicht-Rechnung Zahlungen',0),(210276,5841,'en','Non-Invoice Payments',0),(210277,5842,'is','',0),(210278,5842,'dr','/  Ø¢Ù¾Ø¯ÛŒØª  Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(210279,5842,'pr','Ø§ÙØ²ÙˆØ¯Ù† /  Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(210280,5842,'tr','Ekle/GÃ¼ncelle banka mevduat',0),(210281,5842,'pl','Dodaj/zaktualizuj dane przelew',0),(210282,5842,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ð»Ð¾Ð³Ð¾Ð²ÐµÑ‚Ðµ Ð² Ð±Ð°Ð½ÐºÐ¸Ñ‚Ðµ',0),(210283,5842,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹',0),(210284,5842,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð±Ð°Ð½ÐºÐµ',0),(210285,5842,'vi','ThÃªm/Cáº­p Nháº­t TK Äáº·t Cá»c NgÃ¢n hÃ ng',0),(210286,5842,'af','Bank Deposito Byvoeg/Opdateer ',0),(210287,5842,'ro','Depozit bancar AdÄƒugaÅ£i/actualizaÅ£i',0),(210288,5842,'et','Lisa/vÃ¤rskenda pangahoiuste',0),(210289,5842,'si','Dodaj/posodobi banÄni depozit',0),(210290,5842,'ba','Deposito Bank menambahkan Update',0),(210291,5842,'nl','Toevoegen/bijwerken Bank storting',0),(210292,5842,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ Bank Deposit',0),(210293,5842,'no','Legg til/Oppdater bankinnskudd',0),(210294,5842,'da','TilfÃ¸j/opdater Bank depositum',0),(210295,5842,'ko','ì¶”ê°€/ì—…ë°ì´íŠ¸ ì€í–‰ ì˜ˆê¸ˆ',0),(210296,5842,'he','×”×•×¡×£/×¢×“×›×Ÿ ×¤×§×“×•×Ÿ ×‘× ×§',0),(210297,5842,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(210298,5842,'zh','æ–°å¢ž/æ›´æ–°é“¶è¡Œå­˜æ¬¾\r\n',0),(210299,5842,'sv','LÃ¤gg till/uppdatera Bank insÃ¤ttning',0),(210300,5842,'it','Deposito bancario aggiungere/aggiornare',0),(210301,5842,'tl','',0),(210302,5842,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(210303,5842,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾',0),(210304,5842,'ms','Deposit Bank Tambah/Kemaskini',0),(210305,5842,'ar','Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ© Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(210306,5842,'fr','Ajouter/mettre Ã  jour la Banque dÃ©pÃ´t',0),(210307,5842,'jp','éŠ€è¡Œå…¥é‡‘ã‚’æ›´æ–°',0),(210308,5842,'pt','DepÃ³sito bancÃ¡rio adicionar/atualizar',0),(210309,5842,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(210310,5842,'es','Agregar/Actualizar Deposto Bancario',0),(210311,5842,'de','HinzufÃ¼gen/aktualisieren Bank hinterlegen',0),(210312,5842,'en','Add/Update Bank Deposit',0),(210313,5843,'is','',0),(210314,5843,'dr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† â€Œ Ù¾ÙˆÙ„ Ù†Ù‚Ø¯ Ø§Ø² Ø­Ø³Ø§Ø¨',0),(210315,5843,'pr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† â€Œ Ù¾ÙˆÙ„ Ù†Ù‚Ø¯ Ø§Ø² Ø­Ø³Ø§Ø¨',0),(210316,5843,'tr','Nakit Ã§ekilme',0),(210317,5843,'pl','WypÅ‚ata',0),(210318,5843,'bg','Ð¢ÐµÐ³Ð»ÐµÐ½Ðµ',0),(210319,5843,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(210320,5843,'sr','ÐŸÐ¾Ð´Ð¸Ð·Ð°ÑšÐµ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ',0),(210321,5843,'vi','RÃºt tiá»n',0),(210322,5843,'af','Kontant Ontrekking',0),(210323,5843,'ro','Retragere de numerar',0),(210324,5843,'et','Sularaha vÃ¤ljavÃµtt',0),(210325,5843,'si','Dvig gotovine',0),(210326,5843,'ba','Penarikan tunai',0),(210327,5843,'nl','Intrekking van cash',0),(210328,5843,'fi','KÃ¤teisnosto',0),(210329,5843,'no','Cash uttak',0),(210330,5843,'da','Kontant tilbagetrÃ¦kning',0),(210331,5843,'ko','í˜„ê¸ˆ ì¸ì¶œ',0),(210332,5843,'he','×”×¨×‘×” ×›×¡×£',0),(210333,5843,'el','Î‘Î½Î¬Î»Î·ÏˆÎ· Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½',0),(210334,5843,'zh','å–æ¬¾\r\n',0),(210335,5843,'sv','Kontantuttag',0),(210336,5843,'it','Prelievo di contanti',0),(210337,5843,'tl','',0),(210338,5843,'th','&#3606;&#3629;&#3609;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;',0),(210339,5843,'hi','à¤¨à¤•à¤¦à¥€ à¤¨à¤¿à¤•à¤¾à¤¸à¥€',0),(210340,5843,'ms','Pengeluaran Wang Tunai',0),(210341,5843,'ar','Ø§Ù„Ø³Ø­Ø¨ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(210342,5843,'fr','Retrait d\'espÃ¨ces',0),(210343,5843,'jp','ç?¾é‡‘å¼•ã??å‡ºã?—',0),(210344,5843,'pt','Retirada de dinheiro',0),(210345,5843,'ru','Ð¡Ð½ÑÑ‚Ð¸Ðµ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ñ… Ð´ÐµÐ½ÐµÐ³',0),(210346,5843,'es','Retiro de Efectivo',0),(210347,5843,'de','Bargeldbezug',0),(210348,5843,'en','Cash Withdrawal',0),(210349,5844,'is','',0),(210350,5844,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ø§Ø²  Ø­Ø³Ø§Ø¨ ØªÙ†Ø®ÙˆØ§Ù‡ Ú¯Ø±Ø¯Ø§Ù† ',0),(210351,5844,'pr','Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ø§Ø²  Ø­Ø³Ø§Ø¨ ØªÙ†Ø®ÙˆØ§Ù‡ Ú¯Ø±Ø¯Ø§Ù† ',0),(210352,5844,'tr','Bozuk para Ã¼zerinden mevduat',0),(210353,5844,'pl','Depozyt z kasy',0),(210354,5844,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¾Ñ‚ Ð´Ñ€ÐµÐ±Ð½Ð¸ Ð¿Ð°Ñ€Ð¸',0),(210355,5844,'ur','ÚˆÙ¾Ø§Ø²Ù¹ Ù¾ÛŒÙ¹ÛŒ Ú©ÛŒØ´ Ø³Û’',0),(210356,5844,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¸Ð· Ð¿Ñ€Ð¸Ñ€ÑƒÑ‡Ð½Ðµ Ð±Ð»Ð°Ð³Ð°Ñ˜Ð½Ðµ',0),(210357,5844,'vi','Äáº·t cá»c tá»« tiá»n máº·t',0),(210358,5844,'af','Deposito vanaf Kleinkas',0),(210359,5844,'ro','Depunere de numerar Petty',0),(210360,5844,'et','Tagatisraha: vÃ¤ikesed summad',0),(210361,5844,'si','Depozit iz blagajniÅ¡ke',0),(210362,5844,'ba','Deposit dari kas kecil',0),(210363,5844,'nl','Storting van kleine kas',0),(210364,5844,'fi','Talletus kÃ¤teiskassasta',0),(210365,5844,'no','Innskudd fra Petty Cash',0),(210366,5844,'da','Indbetaling fra smÃ¥penge',0),(210367,5844,'ko','í‘¼ëˆì—ì„œ ìž…ê¸ˆ',0),(210368,5844,'he','×¤×™×§×“×•×Ÿ ×ž×”×§×•×¤×”',0),(210369,5844,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï€ÎµÎ½Ï„Î±ÏÎ¿Î´ÎµÎºÎ¬ÏÎµÏ‚',0),(210370,5844,'zh','å°é¢çŽ°é‡‘å­˜æ¬¾\r\n',0),(210371,5844,'sv','InsÃ¤ttning frÃ¥n handkassa',0),(210372,5844,'it','Deposito da Petty Cash',0),(210373,5844,'tl','',0),(210374,5844,'th','&#3613;&#3634;&#3585;&#3592;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;&#3618;&#3656;&#3629;&#3618;',0),(210375,5844,'hi','à¤–à¥à¤¦à¤°à¤¾ à¤°à¥‹à¤•à¤¡à¤¼ à¤¸à¥‡ à¤œà¤®à¤¾',0),(210376,5844,'ms','Deposit daripada panjar wang runcit',0),(210377,5844,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ù† Ø§Ù„Ù†Ø«Ø±ÙŠØ©',0),(210378,5844,'fr','DÃ©pÃ´t de petite caisse',0),(210379,5844,'jp','å°?å?£ç?¾é‡‘ã?‹ã‚‰ã?®é ?ã‚Šé‡‘',0),(210380,5844,'pt','DepÃ³sito de Petty Cash',0),(210381,5844,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¾Ñ‚ ÐºÐ°ÑÑÐ¾Ð²Ð¾Ð¹ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸',0),(210382,5844,'es','DepÃ³sito de la Caja Chica',0),(210383,5844,'de','Einzahlung aus der Portokasse',0),(210384,5844,'en','Deposit from Petty Cash',0),(210385,5845,'is','',0),(210386,5845,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(210387,5845,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³Ù¾Ø±Ø¯Ù‡(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(210388,5845,'tr','Toplam mevduat',0),(210389,5845,'pl','Depozyt',0),(210390,5845,'bg','ÐžÐ±Ñ‰Ð¾ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(210391,5845,'ur','Ú©Ù„ Ø¬Ù…Ø¹',0),(210392,5845,'sr','Ð¢Ð¾Ñ‚Ð°Ð»Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(210393,5845,'vi','Tá»•ng cá»™ng kÃ½ quá»¹',0),(210394,5845,'af','Totale Deposito',0),(210395,5845,'ro','Depunere totalÄƒ',0),(210396,5845,'et','Bilansimaht',0),(210397,5845,'si','Skupno depozit',0),(210398,5845,'ba','Total setoran',0),(210399,5845,'nl','Totale storting',0),(210400,5845,'fi','Talletus',0),(210401,5845,'no','Totale innskudd',0),(210402,5845,'da','Samlede indbetaling',0),(210403,5845,'ko','ì´ ì˜ˆê¸ˆ',0),(210404,5845,'he','×¡×” ×› ×”×¤×§×“×”',0),(210405,5845,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(210406,5845,'zh','æ€»å­˜æ¬¾\r\n',0),(210407,5845,'sv','Totala insÃ¤ttning',0),(210408,5845,'it','Deposito totale',0),(210409,5845,'tl','',0),(210410,5845,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;',0),(210411,5845,'hi','à¤•à¥à¤² à¤œà¤®à¤¾',0),(210412,5845,'ms','Jumlah Deposit',0),(210413,5845,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹',0),(210414,5845,'fr','Total des dÃ©pÃ´ts',0),(210415,5845,'jp','é ?ã‚Šé‡‘ç·?é¡?',0),(210416,5845,'pt','DepÃ³sito total',0),(210417,5845,'ru','Ð’ÑÐµÐ³Ð¾ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(210418,5845,'es','Total DepÃ³sito',0),(210419,5845,'de','Total Anzahlung',0),(210420,5845,'en','Total Deposit',0),(210421,5846,'is','',0),(210422,5846,'dr','Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(210423,5846,'pr','Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(210424,5846,'tr','Teklifi yazdÄ±r',0),(210425,5846,'pl','Oferta druku',0),(210426,5846,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(210427,5846,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(210428,5846,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(210429,5846,'vi','In BÃ¡o giÃ¡ ',0),(210430,5846,'af','Kwotasie Uitdruk',0),(210431,5846,'ro','Citat de imprimare',0),(210432,5846,'et','Hinnapakkumise printimine',0),(210433,5846,'si','Natisni ponudbo',0),(210434,5846,'ba','Mengutip cetak',0),(210435,5846,'nl','Offerte afdrukken',0),(210436,5846,'fi','Tarjous tulosta',0),(210437,5846,'no','Tilbud Print',0),(210438,5846,'da','Citat Print',0),(210439,5846,'ko','ì¸ì‡„ ê²¬ì ',0),(210440,5846,'he','×”×“×¤×¡ ×”×¦×¢×ª ×ž×—×™×¨',0),(210441,5846,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(210442,5846,'zh','æ‰“å°æŠ¥ä»·\r\n',0),(210443,5846,'sv','Citera Print',0),(210444,5846,'it','Preventivo stampa',0),(210445,5846,'tl','',0),(210446,5846,'th','&#3649;&#3592;&#3657;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(210447,5846,'hi','à¤•à¥‹à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(210448,5846,'ms','Sebut harga cetakan',0),(210449,5846,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(210450,5846,'fr','Devis impression',0),(210451,5846,'jp','è¦‹ç©?ã‚Šã?®å?°åˆ·',0),(210452,5846,'pt','Imprimir cotaÃ§Ã£o',0),(210453,5846,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(210454,5846,'es','Imprimir la CotizaciÃ³n',0),(210455,5846,'de','Angebot drucken',0),(210456,5846,'en','Quote Print',0),(210457,5847,'is','',0),(210458,5847,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(210459,5847,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(210460,5847,'tr','Teklif olarak kaydet',0),(210461,5847,'pl','Zapisz jako cytat',0),(210462,5847,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ ÐºÐ°Ñ‚Ð¾ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(210463,5847,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(210464,5847,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ ÐºÐ°Ð¾ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(210465,5847,'vi','Sao lÆ°u nhÆ° lÃ  bÃ¡o giÃ¡',0),(210466,5847,'af','Stoor as Kwotasie',0),(210467,5847,'ro','Salvare ca citat',0),(210468,5847,'et','Kui tsitaat',0),(210469,5847,'si','Shrani kot citat',0),(210470,5847,'ba','Simpan sebagai kutipan',0),(210471,5847,'nl','Opslaan als Quote',0),(210472,5847,'fi','Tallenna tarjous',0),(210473,5847,'no','Lagre som tilbud',0),(210474,5847,'da','Gemme som citat',0),(210475,5847,'ko','ê²¬ì ìœ¼ë¡œ ì €ìž¥',0),(210476,5847,'he','×©×ž×•×¨ ×›×”×¦×¢×ª ×ž×—×™×¨',0),(210477,5847,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï‰Ï‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(210478,5847,'zh','å¦å­˜ä¸ºæŠ¥ä»·\r\n',0),(210479,5847,'sv','Spara som citat',0),(210480,5847,'it','Salvare come citazione',0),(210481,5847,'tl','',0),(210482,5847,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(210483,5847,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(210484,5847,'ms','Simpan sebagai Quote',0),(210485,5847,'ar','Ø§Ù„ØªØ®Ø²ÙŠÙ† ÙƒØ¹Ø±Ø¶ Ù…Ø¨Ø¯Ø¦ÙŠ',0),(210486,5847,'fr','Enregistrer en tant que citation',0),(210487,5847,'jp','è¦‹ç©?ã‚Šã?¨ã?—ã?¦ä¿?å­˜',0),(210488,5847,'pt','Salve como citaÃ§Ã£o',0),(210489,5847,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ ÐºÐ°Ðº Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(210490,5847,'es','Guardar como CotizaciÃ³n',0),(210491,5847,'de','Als Zitat speichern',0),(210492,5847,'en','Save as Quote',0),(210493,5848,'is','',0),(210494,5848,'dr','Ù‚ÙŠÙ…ØªÙ‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ ',0),(210495,5848,'pr','Ù‚ÙŠÙ…ØªÙ‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ ',0),(210496,5848,'tr','Yerine getirilmesi Quotes',0),(210497,5848,'pl','SpeÅ‚nienie Cytaty',0),(210498,5848,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð¸ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(210499,5848,'ur','Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø±Ø¬ Ú©Ø±Ù†Û’',0),(210500,5848,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ',0),(210501,5848,'vi','BÃ¡o giÃ¡ ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(210502,5848,'af','Uitvoeringsbestelling Kwotasie',0),(210503,5848,'ro','ÃŽmplinirea citate',0),(210504,5848,'et','Eneseteostus hinnapakkumisi',0),(210505,5848,'si','Izpolnitev ponudbe',0),(210506,5848,'ba','Pemenuhan Quotes',0),(210507,5848,'nl','Vervulling Quotes',0),(210508,5848,'fi','TÃ¤yttÃ¤minen lainausmerkit',0),(210509,5848,'no','Oppfyllelsen sitater',0),(210510,5848,'da','Opfyldelse citater',0),(210511,5848,'ko','ì„±ì·¨ ì¸ìš©ë¬¸',0),(210512,5848,'he','×”×¦×¢×•×ª ×ž×—×™×¨ ×ž×™×ž×•×©',0),(210513,5848,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(210514,5848,'zh','å±¥è¡Œè®¢å•æŠ¥ä»·\r\n',0),(210515,5848,'sv','Uppfyllelse citat',0),(210516,5848,'it','Citazioni di adempimento',0),(210517,5848,'tl','',0),(210518,5848,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(210519,5848,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(210520,5848,'ms','Sebut harga yang memenuhi',0),(210521,5848,'ar','ÙˆÙ†Ù‚Ù„Øª ÙˆÙØ§Ø¡',0),(210522,5848,'fr','RÃ©alisation de devis',0),(210523,5848,'jp','å±¥è¡Œæ³¨æ–‡è¦‹ç©?ã‚Š',0),(210524,5848,'pt','CitaÃ§Ãµes de cumprimento',0),(210525,5848,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(210526,5848,'es','Orden de Cumplimiento Cotizaciones',0),(210527,5848,'de','ErfÃ¼llung Zitate',0),(210528,5848,'en','Fulfillment Quotes',0),(210529,5849,'is','',0),(210530,5849,'dr','ÙƒÙ„ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(210531,5849,'pr','ÙƒÙ„ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(210532,5849,'tr','Toplam teklif',0),(210533,5849,'pl','Cytat Å‚Ä…cznie',0),(210534,5849,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð¾Ð±Ñ‰Ð¾',0),(210535,5849,'ur','Ú©Ù„ Ø³Û’ Ø§Ù‚ØªØ¨Ø§Ø³',0),(210536,5849,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(210537,5849,'vi','Tá»•ng cá»™ng BÃ¡o giÃ¡ ',0),(210538,5849,'af','Kwotasie Totaal',0),(210539,5849,'ro','Cita Total',0),(210540,5849,'et','Hinnapakkumise kogusumma',0),(210541,5849,'si','Ponudba Total',0),(210542,5849,'ba','Mengutip Total',0),(210543,5849,'nl','Citeer totaal',0),(210544,5849,'fi','Tarjouksen summa',0),(210545,5849,'no','Sitere totalt',0),(210546,5849,'da','Citere alt',0),(210547,5849,'ko','ì´ ê²¬ì ',0),(210548,5849,'he','×”×¦×¢×ª ×ž×—×™×¨ ×¡×”',0),(210549,5849,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï„Î¿ ÏƒÏÎ½Î¿Î»Î¿',0),(210550,5849,'zh','æ€»æŠ¥ä»·\r\n',0),(210551,5849,'sv','Citera totalt',0),(210552,5849,'it','Preventivo totale',0),(210553,5849,'tl','',0),(210554,5849,'th','&#3649;&#3592;&#3657;&#3591;&#3612;&#3621;&#3619;&#3623;&#3617;',0),(210555,5849,'hi','à¤•à¥à¤² à¤¬à¥‹à¤²à¥€',0),(210556,5849,'ms','Sebut harga jumlah',0),(210557,5849,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(210558,5849,'fr','Cite Total',0),(210559,5849,'jp','è¦‹ç©?ã‚Šå?ˆè¨ˆ',0),(210560,5849,'pt','Citar Total',0),(210561,5849,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€ÑƒÑŽ Ð²ÑÐµÐ³Ð¾',0),(210562,5849,'es','CotizaciÃ³n Total',0),(210563,5849,'de','Zitat von Total',0),(210564,5849,'en','Quote Total',0),(210565,5850,'is','',0),(210566,5850,'dr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(210567,5850,'pr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(210568,5850,'tr','Sadece kapalÄ± sipariÅŸler',0),(210569,5850,'pl','ZamkniÄ™te zamÃ³wienia tylko',0),(210570,5850,'bg','ÐŸÑ€Ð¸ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐ°Ð¼Ð¾',0),(210571,5850,'ur','Ø¨Ù†Ø¯ Ø§Ø­Ú©Ø§Ù…Ø§Øª ØµØ±Ù',0),(210572,5850,'sr','Ð¡Ð°Ð¼Ð¾ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(210573,5850,'vi','Chá»‰ ÄÃ³ng ÄÆ¡n Äáº·t HÃ ng',0),(210574,5850,'af','Slegs Afgesluite Bestellings',0),(210575,5850,'ro','ÃŽnchis comenzi numai',0),(210576,5850,'et','Ainult suletud tellimusd',0),(210577,5850,'si','Le zaprte naloge',0),(210578,5850,'ba','Hanya Pesanan yang Ditutup',0),(210579,5850,'nl','Gesloten bestellingen',0),(210580,5850,'fi','Suljettuja tilauksia vain',0),(210581,5850,'no','Avsluttede ordrer bare',0),(210582,5850,'da','Lukkede ordrer kun',0),(210583,5850,'ko','ë‹«ížŒëœ ì£¼ë¬¸ì—ë§Œ í•´ë‹¹',0),(210584,5850,'he','×œ×”×–×ž× ×•×ª ×¡×’×•×¨×•×ª ×‘×œ×‘×“',0),(210585,5850,'el','ÎšÎ»ÎµÎ¹ÏƒÏ„Î­Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Î¼ÏŒÎ½Î¿',0),(210586,5850,'zh','åªæœ‰å°é—­ä»¤\r\n',0),(210587,5850,'sv','StÃ¤ngda order endast',0),(210588,5850,'it','Ordini chiusi solo',0),(210589,5850,'tl','',0),(210590,5850,'th','&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(210591,5850,'hi','à¤¬à¤‚à¤¦ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡à¤µà¤²',0),(210592,5850,'ms','Perintah-perintah yang ditutup sahaja',0),(210593,5850,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…ØºÙ„Ù‚Ø© ÙÙ‚Ø·',0),(210594,5850,'fr','Commandes ferme soulements',0),(210595,5850,'jp','å®Œäº†æ¸ˆæ³¨æ–‡ã?®ã?¿',0),(210596,5850,'pt','Ordens fechadas apenas',0),(210597,5850,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(210598,5850,'es','Pedidos Cerrrados Solamente',0),(210599,5850,'de','Geschlossenen AuftrÃ¤ge nur',0),(210600,5850,'en','Closed Orders Only',0),(210601,5851,'is','',0),(210602,5851,'dr','ØªØºÙŠÙŠØ± Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(210603,5851,'pr','ØªØºÙŠÙŠØ± Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(210604,5851,'tr','SipariÅŸe DÃ¶nÃ¼ÅŸtÃ¼r',0),(210605,5851,'pl','Konwersja na zamÃ³wienie',0),(210606,5851,'bg','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð² Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(210607,5851,'ur','Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…ÛŒÚº Ø¨Ø¯Ù„ÛŒÚº',0),(210608,5851,'sr','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚ÑƒÑ˜ÐµÑ‚Ðµ Ñƒ Ð½Ð°Ð»Ð¾Ð³',0),(210609,5851,'vi','Chuyá»ƒn sang Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(210610,5851,'af','Omskakeling na Bestelling',0),(210611,5851,'ro','Conversia la comanda',0),(210612,5851,'et','Et teisendada',0),(210613,5851,'si','Pretvoriti nalog',0),(210614,5851,'ba','Mengkonversi ke urutan',0),(210615,5851,'nl','Omzetten in volgorde',0),(210616,5851,'fi','Puitetilaus',0),(210617,5851,'no','Konvertere til ordre',0),(210618,5851,'da','Konvertere til ordre',0),(210619,5851,'ko','ì£¼ë¬¸ ë³€í™˜',0),(210620,5851,'he','×”×ž×¨ ×¢×œ ×¡×“×¨',0),(210621,5851,'el','ÎœÎµÏ„Î±Ï„ÏÎ¿Ï€Î® ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(210622,5851,'zh','è½¬æ¢ä¸ºè®¢å•\r\n',0),(210623,5851,'sv','Konvertera till ordning',0),(210624,5851,'it','Convertire in ordine',0),(210625,5851,'tl','',0),(210626,5851,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3652;&#3611;&#3618;&#3633;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(210627,5851,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(210628,5851,'ms','Menukar kepada perintah',0),(210629,5851,'ar','ØªØ­ÙˆÙŠÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(210630,5851,'fr','Convertissez en commande',0),(210631,5851,'jp','æ³¨æ–‡ã?¸å¤‰æ›´',0),(210632,5851,'pt','Converter em ordem',0),(210633,5851,'ru','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ Ð² Ð·Ð°ÐºÐ°Ð·',0),(210634,5851,'es','Convertir a Pedido',0),(210635,5851,'de','Konvertieren in Ordnung',0),(210636,5851,'en','Convert to Order',0),(210637,5852,'is','',0),(210638,5852,'dr','(Ø§Ø¬Ø±Ø§Ø¡) ØªØ¹ÙˆÛŒÙ‚',0),(210639,5852,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ ØªÙƒÙ…ÙŠÙ„ÙŠ (Ø§Ø¬Ø±Ø§Ø¡) Ù…Ø¹ÙˆÙ‚',0),(210640,5852,'tr','Bekleyen yerine getirilmesi Quotes',0),(210641,5852,'pl','Czasu realizacji oferty',0),(210642,5852,'bg','Ð§Ð°ÐºÐ°Ñ‰Ð¸ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(210643,5852,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø±Ø¬ Ú©Ø±Ù†Û’',0),(210644,5852,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(210645,5852,'vi','Äang treo bÃ¡o giÃ¡ Ä‘Æ¡n hÃ ng giao táº­n nÆ¡i',0),(210646,5852,'af','Afwagtende \"Uitvoeringsbestelling  Kwotasies',0),(210647,5852,'ro','PÃ¢nÄƒ la Ã®mplinirea citate',0),(210648,5852,'et','Ootel eneseteostus hinnapakkumisi',0),(210649,5852,'si','ÄŒakajoÄe izpolnitev ponudbe',0),(210650,5852,'ba','Pemenuhan ditunda Penawaran',0),(210651,5852,'nl','In behandeling vervulling Quotes',0),(210652,5852,'fi','Odottavat tÃ¤yttÃ¤mistÃ¤ lainausmerkit',0),(210653,5852,'no','Ventende oppfyllelse sitater',0),(210654,5852,'da','Ventende opfyldelse citater',0),(210655,5852,'ko','ë³´ë¥˜ ì¤‘ì¸ í–‰ ë”°ì˜´í‘œ',0),(210656,5852,'he','×”×’×©×ž×” ×ž×ž×ª×™×Ÿ ×œ×”×¦×¢×•×ª ×ž×—×™×¨',0),(210657,5852,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬ ÎµÎºÎºÏÎµÎ¼Î® ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ·',0),(210658,5852,'zh','å¾…å±¥è¡Œè®¢å•æŠ¥ä»·\r\n',0),(210659,5852,'sv','VÃ¤ntande uppfyllelse citat',0),(210660,5852,'it','Citazioni di adempimento in sospeso',0),(210661,5852,'tl','',0),(210662,5852,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3',0),(210663,5852,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(210664,5852,'ms','Petikan-petikan menunggu',0),(210665,5852,'ar','ÙˆÙ†Ù‚Ù„Øª ÙˆÙØ§Ø¡ Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(210666,5852,'fr','Citations en attente de rÃ©alisation',0),(210667,5852,'jp','ä¿?ç•™ä¸­å±¥è¡Œæ³¨æ–‡è¦‹ç©?ã‚Š',0),(210668,5852,'pt','CotaÃ§Ãµes pendentes de cumprimento',0),(210669,5852,'ru','ÐžÐ¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(210670,5852,'es','Cotizaciones de Ordenes de Cumplimiento Pendientes',0),(210671,5852,'de','Ausstehende ErfÃ¼llung Zitate',0),(210672,5852,'en','Pending Fulfillment Quotes',0),(210673,5853,'is','',0),(210674,5853,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§Ø¬Ø±Ø§ Ù…Ø¹ÙˆÙ‚',0),(210675,5853,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§Ø¬Ø±Ø§ Ù…Ø¹ÙˆÙ‚',0),(210676,5853,'tr','Bekleyen yerine getirilmesi Quotes',0),(210677,5853,'pl','Czasu realizacji oferty',0),(210678,5853,'bg','Ð§Ð°ÐºÐ°Ñ‰Ð¸ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(210679,5853,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø±Ø¬ Ú©Ø±Ù†Û’',0),(210680,5853,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(210681,5853,'vi','Äang treo BÃ¡o giÃ¡ hoÃ n táº¥t',0),(210682,5853,'af','Afwagtende Uitvoeringskwotasies',0),(210683,5853,'ro','PÃ¢nÄƒ la Ã®mplinirea citate',0),(210684,5853,'et','Ootel eneseteostus hinnapakkumisi',0),(210685,5853,'si','ÄŒakajoÄe izpolnitev ponudbe',0),(210686,5853,'ba','Pemenuhan ditunda Penawaran',0),(210687,5853,'nl','In behandeling vervulling Quotes',0),(210688,5853,'fi','Odottavat tÃ¤yttÃ¤mistÃ¤ lainausmerkit',0),(210689,5853,'no','Ventende oppfyllelse sitater',0),(210690,5853,'da','Ventende opfyldelse citater',0),(210691,5853,'ko','ë³´ë¥˜ ì¤‘ì¸ í–‰ ë”°ì˜´í‘œ',0),(210692,5853,'he','×”×’×©×ž×” ×ž×ž×ª×™×Ÿ ×œ×”×¦×¢×•×ª ×ž×—×™×¨',0),(210693,5853,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬ ÎµÎºÎºÏÎµÎ¼Î® ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ·',0),(210694,5853,'zh','å¾…å±¥è¡ŒæŠ¥ä»·\r\n',0),(210695,5853,'sv','VÃ¤ntande uppfyllelse citat',0),(210696,5853,'it','Citazioni di adempimento in sospeso',0),(210697,5853,'tl','',0),(210698,5853,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(210699,5853,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(210700,5853,'ms','Petikan-petikan menunggu',0),(210701,5853,'ar','ÙˆÙ†Ù‚Ù„Øª ÙˆÙØ§Ø¡ Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(210702,5853,'fr','Citations en attente de rÃ©alisation',0),(210703,5853,'jp','ä¿?ç•™ä¸­å±¥è¡Œè¦‹ç©?ã‚Š',0),(210704,5853,'pt','CotaÃ§Ãµes pendentes de cumprimento',0),(210705,5853,'ru','ÐžÐ¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(210706,5853,'es','Cotizaciones de Cumplimiento Pendientes',0),(210707,5853,'de','Ausstehende ErfÃ¼llung Zitate',0),(210708,5853,'en','Pending Fulfillment Quotes',0),(210709,5854,'is','',0),(210710,5854,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø§Ø¬Ø±Ø§ Ø¬Ø¯ÙŠØ¯ ',0),(210711,5854,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø§Ø¬Ø±Ø§ Ø¬Ø¯ÙŠØ¯ ',0),(210712,5854,'tr','Yeni yerine getirilmesi tÄ±rnak',0),(210713,5854,'pl','Nowe Cytaty speÅ‚nienie',0),(210714,5854,'bg','ÐÐ¾Ð²Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(210715,5854,'ur','Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø±Ø¬ Ú©Ø±Ù†Û’',0),(210716,5854,'sr','ÐÐ¾Ð²Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ',0),(210717,5854,'vi','BÃ¡o giÃ¡ ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i Má»›i',0),(210718,5854,'af','Nuwe B2B Uitvoeringsbestelling kwotasies',0),(210719,5854,'ro','Noi Ã®mplinirea citate',0),(210720,5854,'et','Uus eneseteostus hinnapakkumisi',0),(210721,5854,'si','Nov izpolnitev ponudbe',0),(210722,5854,'ba','Baru pemenuhan Quotes',0),(210723,5854,'nl','Nieuwe vervulling Quotes',0),(210724,5854,'fi','Uusia tÃ¤yttÃ¤minen lainauksia',0),(210725,5854,'no','Nye oppfyllelse sitater',0),(210726,5854,'da','Nye opfyldelse citater',0),(210727,5854,'ko','ìƒˆë¡œìš´ ì„±ì·¨ ì¸ìš©ë¬¸',0),(210728,5854,'he','×”×¦×¢×•×ª ×ž×—×™×¨ ×ž×™×ž×•×© ×—×“×©',0),(210729,5854,'el','ÎÎ­Î± ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(210730,5854,'zh','æ–°å®žè·µè¡Œæƒ…\r\n',0),(210731,5854,'sv','Nya uppfyllelse citat',0),(210732,5854,'it','Nuove citazioni di adempimento',0),(210733,5854,'tl','',0),(210734,5854,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(210735,5854,'hi','à¤¨à¤ˆ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(210736,5854,'ms','Baru sebut harga memenuhi',0),(210737,5854,'ar','ÙˆÙ†Ù‚Ù„Øª ÙˆÙØ§Ø¡ Ø¬Ø¯ÙŠØ¯',0),(210738,5854,'fr','Nouvelle rÃ©alisation citations',0),(210739,5854,'jp','æ–°è¦?',0),(210740,5854,'pt','Novas citaÃ§Ãµes de cumprimento',0),(210741,5854,'ru','ÐÐ¾Ð²Ð¾Ðµ Ð¸ÑÐ¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(210742,5854,'es','Nuevas Cotizaciones de Cumplimiento',0),(210743,5854,'de','Neue ErfÃ¼llung Zitate',0),(210744,5854,'en','New Fulfillment Quotes',0),(210745,5855,'is','',0),(210746,5855,'dr','Ù…ØµØ±Ù Ú¯Ø±ÙˆÙ‡',0),(210747,5855,'pr','Ù…ØµØ±Ù Ú¯Ø±ÙˆÙ‡',0),(210748,5855,'tr','Kategori kullanÄ±mÄ±',0),(210749,5855,'pl','Kategoria uÅ¼ytkowania',0),(210750,5855,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(210751,5855,'ur','Ø²Ù…Ø±Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(210752,5855,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ðµ',0),(210753,5855,'vi','Sá»­ dá»¥ng thá»ƒ loáº¡i',0),(210754,5855,'af','Kategorie gebruik',0),(210755,5855,'ro','Categoria de utilizare',0),(210756,5855,'et','Kategooria kasutus',0),(210757,5855,'si','Kategorija uporabe',0),(210758,5855,'ba','Kategori penggunaan',0),(210759,5855,'nl','Categorie Taakgebruik',0),(210760,5855,'fi','Luokan kÃ¤yttÃ¶',0),(210761,5855,'no','Kategorien forbruk',0),(210762,5855,'da','Kategori skik',0),(210763,5855,'ko','ë²”ì£¼ ì‚¬ìš©',0),(210764,5855,'he','×§×˜×’×•×¨×™×” ×”×©×™×ž×•×©',0),(210765,5855,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï‡ÏÎ®ÏƒÎ·Ï‚',0),(210766,5855,'zh','åˆ†ç±»ä½¿ç”¨\r\n',0),(210767,5855,'sv','Kategori anvÃ¤ndning',0),(210768,5855,'it','Utilizzo di categoria',0),(210769,5855,'tl','',0),(210770,5855,'th','&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(210771,5855,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤‰à¤ªà¤¯à¥‹à¤—',0),(210772,5855,'ms','Penggunaan kategori',0),(210773,5855,'ar','Ø¥Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ù„ØªØµÙ†ÙŠÙ',0),(210774,5855,'fr','Utilisation de la catÃ©gorie',0),(210775,5855,'jp','ã‚«ãƒ†ã‚´ãƒªãƒ¼ä½¿ç”¨',0),(210776,5855,'pt','Categoria de uso',0),(210777,5855,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(210778,5855,'es','CategorÃ­a uso',0),(210779,5855,'de','Kategorie-Nutzung',0),(210780,5855,'en','Category Usage',0),(210781,5856,'is','',0),(210782,5856,'dr','Hierarchy Ø³Ù„Ø³Ù„Ù‡ Ù…Ø±Ø§ØªØ¨ ',0),(210783,5856,'pr','Hierarchy Ø³Ù„Ø³Ù„Ù‡ Ù…Ø±Ø§ØªØ¨ ',0),(210784,5856,'tr','HiyerarÅŸi',0),(210785,5856,'pl','Hierarchia',0),(210786,5856,'bg','Ð™ÐµÑ€Ð°Ñ€Ñ…Ð¸Ñ',0),(210787,5856,'ur','Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ',0),(210788,5856,'sr','Ð¥Ð¸Ñ˜ÐµÑ€Ð°Ñ€Ñ…Ð¸Ñ˜Ð°',0),(210789,5856,'vi','Cáº¥p báº­c',0),(210790,5856,'af','HiÃ«rargie',0),(210791,5856,'ro','Ierarhie',0),(210792,5856,'et','Hierarhia',0),(210793,5856,'si','Hierarhija',0),(210794,5856,'ba','Hirarki',0),(210795,5856,'nl','HiÃ«rarchie',0),(210796,5856,'fi','Hierarkian',0),(210797,5856,'no','Hierarki',0),(210798,5856,'da','Hierarki',0),(210799,5856,'ko','ê³„ì¸µ êµ¬ì¡°',0),(210800,5856,'he','×”×™×¨××¨×›×™×”',0),(210801,5856,'el','Î™ÎµÏÎ±ÏÏ‡Î¯Î±',0),(210802,5856,'zh','å±‚æ¬¡\r\n',0),(210803,5856,'sv','Hierarki',0),(210804,5856,'it','Gerarchia',0),(210805,5856,'tl','',0),(210806,5856,'th','&#3585;&#3634;&#3619;&#3611;&#3585;&#3588;&#3619;&#3629;&#3591;&#3649;&#3610;&#3610;&#3621;&#3635;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;',0),(210807,5856,'hi','à¤ªà¤¦à¤¾à¤¨à¥à¤•à¥à¤°à¤®',0),(210808,5856,'ms','Hierarki',0),(210809,5856,'ar','Ø§Ù„ØªØ³Ù„Ø³Ù„ Ø§Ù„Ù‡Ø±Ù…ÙŠ',0),(210810,5856,'fr','HiÃ©rarchie',0),(210811,5856,'jp','éšŽç´š',0),(210812,5856,'pt','Hierarquia',0),(210813,5856,'ru','Ð˜ÐµÑ€Ð°Ñ€Ñ…Ð¸Ñ',0),(210814,5856,'es','JerarquÃ­a',0),(210815,5856,'de','Hierarchie',0),(210816,5856,'en','Hierarchy',0),(210817,5857,'is','',0),(210818,5857,'dr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ù…ÙˆØ§Ø²ÙŠ',0),(210819,5857,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ù…ÙˆØ§Ø²ÙŠ',0),(210820,5857,'tr','Paralel etiketleri',0),(210821,5857,'pl','RÃ³wnolegle etykiety',0),(210822,5857,'bg','ÐŸÐ°Ñ€Ð°Ð»ÐµÐ»ÐµÐ½ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(210823,5857,'ur','Ù…ØªÙˆØ§Ø²ÛŒ Ù„ÛŒØ¨Ù„',0),(210824,5857,'sr','ÐŸÐ°Ñ€Ð°Ð»ÐµÐ»Ð½Ð¸ Ð¾Ð·Ð½Ð°ÐºÐµ',0),(210825,5857,'vi','NhÃ£n song song',0),(210826,5857,'af','Parallelle Ettikette',0),(210827,5857,'ro','Etichete de paralel',0),(210828,5857,'et','Paralleelselt etiketid',0),(210829,5857,'si','Vzporednih oznak',0),(210830,5857,'ba','Paralel label',0),(210831,5857,'nl','Parallelle Labels',0),(210832,5857,'fi','Samanaikaisesti otsikot',0),(210833,5857,'no','Parallell etiketter',0),(210834,5857,'da','Parallelle etiketter',0),(210835,5857,'ko','ë³‘ë ¬ ë ˆì´ë¸”',0),(210836,5857,'he','×ª×•×•×™×•×ª ×ž×§×‘×™×œ',0),(210837,5857,'el','Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚ Ï€Î±ÏÎ¬Î»Î»Î·Î»ÎµÏ‚',0),(210838,5857,'zh','å¹¶è¡Œæ ‡ç­¾\r\n',0),(210839,5857,'sv','Parallella etiketter',0),(210840,5857,'it','Etichette parallele',0),(210841,5857,'tl','',0),(210842,5857,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3619;&#3637;&#3618;&#3610;&#3648;&#3607;&#3637;&#3618;&#3610;&#3593;&#3621;&#3634;&#3585;',0),(210843,5857,'hi','à¤¸à¤®à¤¾à¤¨à¤¾à¤‚à¤¤à¤° à¤²à¥‡à¤¬à¤²à¥à¤¸',0),(210844,5857,'ms','Label selari',0),(210845,5857,'ar','ØªØ³Ù…ÙŠØ§Øª Ù…ÙˆØ§Ø²ÙŠØ©',0),(210846,5857,'fr','Ã‰tiquettes parallÃ¨les',0),(210847,5857,'jp','ä¸¦åˆ—ãƒ©ãƒ™ãƒ«',0),(210848,5857,'pt','RÃ³tulos paralelos',0),(210849,5857,'ru','ÐŸÐ°Ñ€Ð°Ð»Ð»ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸',0),(210850,5857,'es','Etiquetas Paralelos',0),(210851,5857,'de','Parallele Etiketten',0),(210852,5857,'en','Parallel Labels',0),(210853,5858,'is','',0),(210854,5858,'dr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(210855,5858,'pr','Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(210856,5858,'tr','ÃœrÃ¼n ailesi',0),(210857,5858,'pl','Pozycja rodziny',0),(210858,5858,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾',0),(210859,5858,'ur','Ø´Û’ Ø®Ø§Ù†Ø¯Ø§Ù†',0),(210860,5858,'sr','ÐŸÐ¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(210861,5858,'vi','Gia Ä‘Ã¬nh hÃ ng',0),(210862,5858,'af','Item Familie',0),(210863,5858,'ro','Element de familie',0),(210864,5858,'et','Tooteperekond',0),(210865,5858,'si','Element druÅ¾ine',0),(210866,5858,'ba','Item keluarga',0),(210867,5858,'nl','Item familie',0),(210868,5858,'fi','Nimikkeen perhe',0),(210869,5858,'no','Elementet familie',0),(210870,5858,'da','Vare familie',0),(210871,5858,'ko','í•­ëª© ê°€ì¡±',0),(210872,5858,'he','×ž×©×¤×—×ª ×¤×¨×™×˜',0),(210873,5858,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±',0),(210874,5858,'zh','é¡¹ç›®ç³»åˆ—\r\n',0),(210875,5858,'sv','Objektet familj',0),(210876,5858,'it','Elemento famiglia',0),(210877,5858,'tl','',0),(210878,5858,'th','&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3633;&#3623;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(210879,5858,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¤°à¤¿à¤µà¤¾à¤°',0),(210880,5858,'ms','Butiran keluarga',0),(210881,5858,'ar','ÙØµÙŠÙ„Ø© Ø§Ù„ØµÙ†Ù',0),(210882,5858,'fr','Famille de l\'ordre du jour',0),(210883,5858,'jp','å“?ç›®ç³»çµ±',0),(210884,5858,'pt','FamÃ­lia de item',0),(210885,5858,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÑÐµÐ¼ÑŒÑ',0),(210886,5858,'es','Item Client',0),(210887,5858,'de','Produkt-Familie',0),(210888,5858,'en','Item Family',0),(210889,5859,'is','',0),(210890,5859,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(210891,5859,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(210892,5859,'tr','Banka mevduat #',0),(210893,5859,'pl','Banku depozyt #',0),(210894,5859,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ #',0),(210895,5859,'ur','Ø¨ÛŒÙ†Ú© Ø¬Ù…Ø¹ #',0),(210896,5859,'sr','Ð‘Ð°Ð½ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ #',0),(210897,5859,'vi','TK NgÃ¢n hÃ ng Ná»£ sá»‘',0),(210898,5859,'af','Bank Deposito #',0),(210899,5859,'ro','Banca depozit #',0),(210900,5859,'et','Panga tagatisraha #',0),(210901,5859,'si','BanÄni depozit #',0),(210902,5859,'ba','Bank Deposit #',0),(210903,5859,'nl','Bank deponeren #',0),(210904,5859,'fi','Pankki tallettaa #',0),(210905,5859,'no','Banken innskudd #',0),(210906,5859,'da','Bank indbetaling #',0),(210907,5859,'ko','ì€í–‰ ì˜ˆê¸ˆ #',0),(210908,5859,'he','×‘× ×§ ×œ×”×¤×§×“×ª #',0),(210909,5859,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚ #',0),(210910,5859,'zh','é“¶è¡Œå­˜æ¬¾ï¼ƒ\r\n',0),(210911,5859,'sv','Bank insÃ¤ttning #',0),(210912,5859,'it','Banca deposito #',0),(210913,5859,'tl','',0),(210914,5859,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(210915,5859,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ #',0),(210916,5859,'ms','Bank Deposit #',0),(210917,5859,'ar','Ø¨Ù†Ùƒ Ø¥ÙŠØ¯Ø§Ø¹ #',0),(210918,5859,'fr','Banque de dÃ©pÃ´t #',0),(210919,5859,'jp','éŠ€è¡Œé ?é‡‘ç•ªå?·',0),(210920,5859,'pt','Banco depositar #',0),(210921,5859,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ #',0),(210922,5859,'es','# Deposito Bancario',0),(210923,5859,'de','Bank einzahlen #',0),(210924,5859,'en','Bank Deposit #',0),(210925,5860,'is','',0),(210926,5860,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ù‚Ø¨Ù„Ø§ Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(210927,5860,'pr','Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ù‚Ø¨Ù„Ø§ Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(210928,5860,'tr','Zaten gÃ¶nderilmiÅŸ mevduat',0),(210929,5860,'pl','Depozyt juÅ¼ przekazywane',0),(210930,5860,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð²ÐµÑ‡Ðµ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²ÐµÐ½Ð¸',0),(210931,5860,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ø¹Ø±Ø¶ Ú©ÛŒØ§ ÚˆÙ¾Ø§Ø²Ù¹',0),(210932,5860,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð²ÐµÑ› Ð¿Ñ€ÐµÐ´Ð°Ð»Ð°',0),(210933,5860,'vi','Äáº·t cá»c Ä‘Ã£ ná»™p',0),(210934,5860,'af','Deposito Alreeds Ingedien',0),(210935,5860,'ro','Depozit deja transmise',0),(210936,5860,'et','Tagatisraha on juba esitanud',0),(210937,5860,'si','Depozit, ki se Å¾e vpisali',0),(210938,5860,'ba','Deposit sudah diserahkan',0),(210939,5860,'nl','Storting reeds ingediend',0),(210940,5860,'fi','Jo lÃ¤hettÃ¤nyt talletuksen',0),(210941,5860,'no','Innskudd allerede sendt',0),(210942,5860,'da','Depositum allerede indsendt',0),(210943,5860,'ko','ì´ë¯¸ ì œì¶œ í•˜ëŠ” ì˜ˆê¸ˆ',0),(210944,5860,'he','×¤×™×§×“×•×Ÿ ×›×‘×¨ × ××¡×¤×•',0),(210945,5860,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î®Î´Î· Ï…Ï€Î¿Î²Î¬Î»ÎµÎ¹',0),(210946,5860,'zh','å­˜æ¬¾å·²æäº¤\r\n',0),(210947,5860,'sv','InsÃ¤ttning redan lÃ¤mnats in',0),(210948,5860,'it','Depositi giÃ  inviati',0),(210949,5860,'tl','',0),(210950,5860,'th','&#3617;&#3629;&#3610;&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(210951,5860,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤ à¤œà¤®à¤¾',0),(210952,5860,'ms','Deposit yang telah dikemukakan',0),(210953,5860,'ar','Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„ØªÙŠ Ù‚Ø¯Ù…Øª Ø¨Ø§Ù„ÙØ¹Ù„',0),(210954,5860,'fr','DÃ©pÃ´t dÃ©jÃ  soumis',0),(210955,5860,'jp','é ?ã?‹ã‚Šé‡‘ã?¯ã?™ã?§ã?«æ??å‡ºã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(210956,5860,'pt','DepÃ³sito jÃ¡ apresentado',0),(210957,5860,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑƒÐ¶Ðµ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸',0),(210958,5860,'es','DepÃ³sito Ya Sometido',0),(210959,5860,'de','Anzahlung bereits eingereicht',0),(210960,5860,'en','Deposit Already Submitted',0),(210961,5861,'is','',0),(210962,5861,'dr','ÙˆØ¬Ù‡ ÙƒÙ…ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ ',0),(210963,5861,'pr','ÙˆØ¬Ù‡ ÙƒÙ…ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ ',0),(210964,5861,'tr','Daha az para aldÄ±',0),(210965,5861,'pl','Mniej otrzymane Å›rodki pieniÄ™Å¼ne',0),(210966,5861,'bg','ÐŸÐ¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð¿Ð°Ñ€Ð¸',0),(210967,5861,'ur','Ú©Ù… Ù†Ù‚Ø¯ ÙˆØµÙˆÙ„ Ú©ÛŒ',0),(210968,5861,'sr','ÐœÐ°ÑšÐµ Ð¿Ñ€Ð¸Ð»Ð¸Ð² Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ',0),(210969,5861,'vi','Trá»« Tiá»n máº·t Ä‘Ã£ nháº­n ',0),(210970,5861,'af','Minus Kontant Ontvang',0),(210971,5861,'ro','Mai puÅ£in numerar primit',0),(210972,5861,'et','VÃ¤hem raha saanud',0),(210973,5861,'si','Manj gotovine',0),(210974,5861,'ba','Kurang tunai yang diterima',0),(210975,5861,'nl','Minder geld ontvangen',0),(210976,5861,'fi','VÃ¤hemmÃ¤n rahaa saanut',0),(210977,5861,'no','Mindre penger mottatt',0),(210978,5861,'da','Mindre kontanter modtaget',0),(210979,5861,'ko','ë°›ì€ ì ì€ í˜„ê¸ˆ',0),(210980,5861,'he','×¤×—×•×ª ×ž×–×•×ž× ×™× ×©× ×ª×§×‘×œ×•',0),(210981,5861,'el','Î›Î¹Î³ÏŒÏ„ÎµÏÎ± Î¼ÎµÏ„ÏÎ·Ï„Î¬ Ï€Î¿Ï… Î­Î»Î±Î²Îµ',0),(210982,5861,'zh','å°‘äºŽæ”¶åˆ°çš„çŽ°é‡‘\r\n',0),(210983,5861,'sv','Mindre kontanter tas emot',0),(210984,5861,'it','Meno contanti ricevuti',0),(210985,5861,'tl','',0),(210986,5861,'th','&#3627;&#3633;&#3585;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(210987,5861,'hi','à¤•à¤® à¤¨à¤•à¤¦ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¥€',0),(210988,5861,'ms','Kurang wang yang diterima',0),(210989,5861,'ar','Ø£Ù‚Ù„ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø§Ù„ÙˆØ§Ø±Ø¯Ø©',0),(210990,5861,'fr','Moins encaissements',0),(210991,5861,'jp','å?—é ˜ç?¾é‡‘ä¸?è¶³',0),(210992,5861,'pt','Menos dinheiro recebido',0),(210993,5861,'ru','ÐœÐµÐ½ÑŒÑˆÐµ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ñ…, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ…',0),(210994,5861,'es','Menos Efectivo Recibido',0),(210995,5861,'de','Weniger Bargeld empfangen',0),(210996,5861,'en','Less Cash Received',0),(210997,5862,'is','',0),(210998,5862,'dr','Ú†Ø§Ù¾ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ù¾Ø±Ø¯Ù‡ ',0),(210999,5862,'pr','Ú†Ø§Ù¾ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ù¾Ø±Ø¯Ù‡ ',0),(211000,5862,'tr','Havale makbuzu YazdÄ±r',0),(211001,5862,'pl','WydrukowaÄ‡ pokwitowania',0),(211002,5862,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ°Ñ‚Ð°',0),(211003,5862,'ur','ÚˆÙ¾ÙˆØ²Ù¹ Ø³Ù„Ù¾ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(211004,5862,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¸ Ð¿Ð°Ð¿Ð¸Ñ€',0),(211005,5862,'vi','In phiáº¿u Ä‘áº·t cá»c',0),(211006,5862,'af','Druk Depositostokie',0),(211007,5862,'ro','Imprima depozit alunecare',0),(211008,5862,'et','Prindi Deposiitkviitung',0),(211009,5862,'si','Tiskanje depozit Slip',0),(211010,5862,'ba','Mencetak Deposit Slip',0),(211011,5862,'nl','Afdrukken afgiftebewijs',0),(211012,5862,'fi','Tulosta Talletuskuitti',0),(211013,5862,'no','Skriv ut betalingsbilaget',0),(211014,5862,'da','Udskrive indbetalingsbilag',0),(211015,5862,'ko','ì˜ˆê¸ˆ ì „í‘œ ì¸ì‡„',0),(211016,5862,'he','×”×“×¤×¡ ×”×¤×§×“×”',0),(211017,5862,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(211018,5862,'zh','æ‰“å°å­˜æ¬¾å•\r\n',0),(211019,5862,'sv','Skriva ut insÃ¤ttningsblanketten',0),(211020,5862,'it','Stampare la distinta di deposito',0),(211021,5862,'tl','',0),(211022,5862,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3626;&#3621;&#3636;&#3611;&#3591;&#3634;&#3609;&#3613;&#3634;&#3585;',0),(211023,5862,'hi','à¤œà¤®à¤¾ à¤ªà¤°à¥à¤šà¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(211024,5862,'ms','Cetak Deposit Slip',0),(211025,5862,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚Ø³ÙŠÙ…Ø© Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(211026,5862,'fr','Imprimer le bordereau de dÃ©pÃ´t',0),(211027,5862,'jp','é ?ã?‹ã‚Šé‡‘ä¼?ç¥¨ã?®å?°åˆ·',0),(211028,5862,'pt','Imprimir o comprovante de depÃ³sito',0),(211029,5862,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸',0),(211030,5862,'es','Recibo de DepÃ³sito de Imprimir',0),(211031,5862,'de','Einzahlungsschein zu drucken',0),(211032,5862,'en','Print Deposit Slip',0),(211033,5863,'is','',0),(211034,5863,'dr','(Ø¬Ù…Ø¹ Ø¨Ø®Ø´ÙŠ Ø§Ø² Ø§Ø¹Ø¯Ø§Ø¯',0),(211035,5863,'pr','Ø²ÙŠØ± ÙƒÙ„ (Ø¬Ù…Ø¹ Ø¨Ø®Ø´ÙŠ Ø§Ø² Ø§Ø¹Ø¯Ø§Ø¯',0),(211036,5863,'tr','Ara toplam',0),(211037,5863,'pl','Razem',0),(211038,5863,'bg','ÐœÐµÐ¶Ð´Ð¸Ð½Ð½Ð° Ð¾Ð±Ñ‰Ð° ÑÑƒÐ¼Ð°',0),(211039,5863,'ur','Ø°ÛŒÙ„ÛŒ Ù…ÛŒØ²Ø§Ù†',0),(211040,5863,'sr','ÐŸÐ¾Ð´-ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(211041,5863,'vi','Tá»•ng sá»‘ phá»¥',0),(211042,5863,'af','Sub-Totaal',0),(211043,5863,'ro','Sub-Total',0),(211044,5863,'et','Vahesumma',0),(211045,5863,'si','Vmesna vsota',0),(211046,5863,'ba','Total sub',0),(211047,5863,'nl','Subtotaal',0),(211048,5863,'fi','VÃ¤lisumma',0),(211049,5863,'no','Sub totalt',0),(211050,5863,'da','Subtotal',0),(211051,5863,'ko','í•˜ìœ„ ì´',0),(211052,5863,'he','×œ×ª×©×œ×•×',0),(211053,5863,'el','Î¥Ï€Î¿-ÏƒÏÎ½Î¿Î»Î¿',0),(211054,5863,'zh','å°è®¡\r\n',0),(211055,5863,'sv','Delsumma',0),(211056,5863,'it','Totale parziale',0),(211057,5863,'tl','',0),(211058,5863,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3618;&#3656;&#3629;&#3618;',0),(211059,5863,'hi','à¤‰à¤ª à¤•à¥à¤²',0),(211060,5863,'ms','Jumlah kecil',0),(211061,5863,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹',0),(211062,5863,'fr','Total partiel',0),(211063,5863,'jp','å°?è¨ˆ',0),(211064,5863,'pt','Sub-Total',0),(211065,5863,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾',0),(211066,5863,'es','Sub-Total',0),(211067,5863,'de','Zwischensumme',0),(211068,5863,'en','Sub-Total',0),(211069,5864,'is','',0),(211070,5864,'dr','ÙƒØ¯',0),(211071,5864,'pr','ÙƒØ¯',0),(211072,5864,'tr','COD',0),(211073,5864,'pl','DORSZ',0),(211074,5864,'bg','Ð¢Ð Ð•Ð¡ÐšÐ',0),(211075,5864,'ur','Ù…ÛŒØ«Ø§Ù‚ Ø¬Ù…ÛÙˆØ±ÛŒØª',0),(211076,5864,'sr','Ð‘ÐÐšÐÐ›ÐÐ ',0),(211077,5864,'vi','COD',0),(211078,5864,'af','KBA',0),(211079,5864,'ro','NU)',0),(211080,5864,'et','TURSK',0),(211081,5864,'si','TRSKE',0),(211082,5864,'ba','COD',0),(211083,5864,'nl','KABELJAUW',0),(211084,5864,'fi','COD',0),(211085,5864,'no','TORSK',0),(211086,5864,'da','TORSK',0),(211087,5864,'ko','ëŒ€êµ¬',0),(211088,5864,'he','×‘×§×œ×”',0),(211089,5864,'el','COD',0),(211090,5864,'zh','è´§åˆ°ä»˜æ¬¾\r\n',0),(211091,5864,'sv','TORSK',0),(211092,5864,'it','COD',0),(211093,5864,'tl','',0),(211094,5864,'th','&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;&#3648;&#3617;&#3639;&#3656;&#3629;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(211095,5864,'hi','à¤•à¥‰à¤¡',0),(211096,5864,'ms','COD',0),(211097,5864,'ar','Ø§Ù„Ø¯ÙØ¹ Ø¹Ù†Ø¯ Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(211098,5864,'fr','MORUE',0),(211099,5864,'jp','ç?€æ‰•ã?„',0),(211100,5864,'pt','BACALHAU',0),(211101,5864,'ru','Ð¢Ð Ð•Ð¡ÐšÐ',0),(211102,5864,'es','COD',0),(211103,5864,'de','KABELJAU',0),(211104,5864,'en','COD',0),(211105,5865,'is','',0),(211106,5865,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ø² ',0),(211107,5865,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ø² ',0),(211108,5865,'tr','Hesap AÃ§',0),(211109,5865,'pl','OtwÃ³rz konto',0),(211110,5865,'bg','ÐžÑ‚Ð²Ð¾Ñ€Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(211111,5865,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ú¾ÙˆÙ„ÛŒÚº',0),(211112,5865,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(211113,5865,'vi','Má»Ÿ TK',0),(211114,5865,'af','Open Rekening',0),(211115,5865,'ro','Deschidere cont',0),(211116,5865,'et','Avatud konto',0),(211117,5865,'si','Odpri raÄun',0),(211118,5865,'ba','Buka akun',0),(211119,5865,'nl','Account openen',0),(211120,5865,'fi','Avaa tili',0),(211121,5865,'no','Ã…pne konto',0),(211122,5865,'da','Ã…ben konto',0),(211123,5865,'ko','ê³„ì • ì—´ê¸°',0),(211124,5865,'he','×¤×ª×— ×—×©×‘×•×Ÿ',0),(211125,5865,'el','Î†Î½Î¿Î¹Î³Î¼Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(211126,5865,'zh','æ‰“å¼€å¸æˆ·\r\n',0),(211127,5865,'sv','Ã–ppna konto',0),(211128,5865,'it','Conto aperto',0),(211129,5865,'tl','',0),(211130,5865,'th','&#3648;&#3611;&#3636;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(211131,5865,'hi','à¤–à¥à¤²à¤¾ à¤–à¤¾à¤¤à¤¾',0),(211132,5865,'ms','Buka akaun',0),(211133,5865,'ar','Ø¹Ù„Ù‰ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(211134,5865,'fr','Ouvrir un compte',0),(211135,5865,'jp','æ¸…ç®—å‹˜å®š',0),(211136,5865,'pt','Abra uma conta',0),(211137,5865,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑ‡ÐµÑ‚',0),(211138,5865,'es','Abrir Cuenta',0),(211139,5865,'de','Konto erÃ¶ffnen',0),(211140,5865,'en','Open Account',0),(211141,5866,'is','',0),(211142,5866,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø±ÙŠÙƒ ',0),(211143,5866,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø±ÙŠÙƒ ',0),(211144,5866,'tr','PayPal',0),(211145,5866,'pl','PayPal',0),(211146,5866,'bg','PayPal',0),(211147,5866,'ur','Ù¾Û’ Ù¾Ø§Ù„',0),(211148,5866,'sr','ÐŸÐ°yÐŸÐ°Ð»',0),(211149,5866,'vi','PayPal',0),(211150,5866,'af','PayPal',0),(211151,5866,'ro','PayPal',0),(211152,5866,'et','PayPal',0),(211153,5866,'si','PayPal',0),(211154,5866,'ba','PayPal',0),(211155,5866,'nl','PayPal',0),(211156,5866,'fi','PayPal',0),(211157,5866,'no','PayPal',0),(211158,5866,'da','PayPal',0),(211159,5866,'ko','íŽ˜ì´íŒ”',0),(211160,5866,'he','PayPal',0),(211161,5866,'el','PayPal',0),(211162,5866,'zh','è´å®\r\n',0),(211163,5866,'sv','PayPal',0),(211164,5866,'it','PayPal',0),(211165,5866,'tl','',0),(211166,5866,'th','PayPal',0),(211167,5866,'hi','à¤ªà¥‡à¤ªà¥ˆà¤²',0),(211168,5866,'ms','PayPal',0),(211169,5866,'ar','Ø¨Ø£ÙŠ Ø¨Ø§Ù„',0),(211170,5866,'fr','PayPal',0),(211171,5866,'jp','ãƒšã‚¤ãƒ‘ãƒ«',0),(211172,5866,'pt','PayPal',0),(211173,5866,'ru','PayPal',0),(211174,5866,'es','PayPal',0),(211175,5866,'de','PayPal',0),(211176,5866,'en','PayPal',0),(211177,5867,'is','',0),(211178,5867,'dr','Ù‚Ø¨Ù„Ø§ Ø­Ø°Ù Ø´Ø¯Ù‡ ÙŠØ§ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø¨Ø§Ù†Ùƒ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡',0),(211179,5867,'pr','Ù‚Ø¨Ù„Ø§ Ø­Ø°Ù Ø´Ø¯Ù‡ ÙŠØ§ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø¨Ø§Ù†Ùƒ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡',0),(211180,5867,'tr','Zaten silinmiÅŸ veya banka aracÄ±lÄ±ÄŸÄ±yla temizlenen',0),(211181,5867,'pl','JuÅ¼ usuniÄ™te lub rozliczone przez Bank',0),(211182,5867,'bg','Ð’ÐµÑ‡Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð¸Ð»Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÑ‚Ð²Ð° Ñ‡Ñ€ÐµÐ· Ð±Ð°Ð½ÐºÐ°',0),(211183,5867,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ø­Ø°Ù ÛŒØ§ ØµØ§Ù Ø¨ÛŒÙ†Ú© Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(211184,5867,'sr','Ð’ÐµÑ› Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ Ð¸Ð»Ð¸ Ð¾Ð¿Ð¾Ð·Ð²Ð°Ð½Ð¾ Ð¿Ñ€ÐµÐºÐ¾ Ð±Ð°Ð½ÐºÐµ',0),(211185,5867,'vi','ÄÃ£ Há»§y Hoáº·c XÃ³a Bá» Qua NgÃ¢n HÃ ng',0),(211186,5867,'af','Alreeds Geskrap of \"Cleared\" Deur Bank',0),(211187,5867,'ro','Deja ÅŸterse sau compensate prin banca',0),(211188,5867,'et','Juba kustutatud vÃµi kustutatud panga kaudu',0),(211189,5867,'si','Å½e izbrisane ali obraÄunavajo prek banke',0),(211190,5867,'ba','Sudah dihapus atau dibersihkan melalui Bank',0),(211191,5867,'nl','Al verwijderd of uitgeschakeld via Bank',0),(211192,5867,'fi','Jo poistettu tai poistettu pankin kautta',0),(211193,5867,'no','Allerede slettet eller ikke gjennom Bank',0),(211194,5867,'da','Allerede overstreget eller ryddet gennem Bank',0),(211195,5867,'ko','ì´ë¯¸ ì‚­ì œ ëœ ë˜ëŠ” ì€í–‰ì„ í†µí•´ ì‚­ì œ',0),(211196,5867,'he','×›×‘×¨ × ×ž×—×§ ××• ×›× ×§×™×™×” ×“×¨×š ×”×‘× ×§',0),(211197,5867,'el','Î‰Î´Î· Ï„Î± Î´Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î± Î® ÎµÎºÎºÎ±Î¸Î±ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹ Î¼Î­ÏƒÏ‰ Ï„ÏÎ¬Ï€ÎµÎ¶Î±Ï‚',0),(211198,5867,'zh','å·²åˆ é™¤æˆ–é€è¿‡é“¶è¡Œæ¸…é™¤\r\n',0),(211199,5867,'sv','Redan utplÃ¥nat eller rensas genom Bank',0),(211200,5867,'it','GiÃ  cancellati o eliminati tramite banca',0),(211201,5867,'tl','',0),(211202,5867,'th','&#3606;&#3641;&#3585;&#3648;&#3588;&#3621;&#3637;&#3618;&#3619;&#3660;&#3627;&#3619;&#3639;&#3629;&#3621;&#3610;&#3612;&#3656;&#3634;&#3609;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(211203,5867,'hi','à¤ªà¤¹à¤²à¥‡ à¤¹à¥€ à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤¯à¤¾ à¤¬à¥ˆà¤‚à¤• à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥‡ à¤¦à¥€',0),(211204,5867,'ms','Sudah dipadam atau sudah dijelaskan melalui Bank',0),(211205,5867,'ar','Ø­Ø°Ù Ø¨Ø§Ù„ÙØ¹Ù„ Ø£Ùˆ ØªÙ… Ù…Ø³Ø­Ù‡Ø§ Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ø§Ù„Ø¨Ù†Ùƒ',0),(211206,5867,'fr','DÃ©jÃ  supprimÃ©e ou dÃ©sactivÃ©e par l\'intermÃ©diaire de la Banque',0),(211207,5867,'jp','éŠ€è¡Œã‚’é€šã?—ã?¦ã?™ã?§ã?«æ¶ˆåŽ»ã?•ã‚Œã?Ÿã?‹ã‚¯ãƒªã‚¢ã?•ã‚Œã?¦ã?„ã?¾ã?™',0),(211208,5867,'pt','JÃ¡ excluÃ­dos ou compensadas atravÃ©s do banco',0),(211209,5867,'ru','Ð£Ð¶Ðµ ÑƒÐ´Ð°Ð»ÐµÐ½ Ð¸Ð»Ð¸ Ð¾Ñ‡Ð¸Ñ‰Ð°ÐµÑ‚ÑÑ Ñ‡ÐµÑ€ÐµÐ· Ð±Ð°Ð½Ðº',0),(211210,5867,'es','Ya Eliminado o Pasado por el Banco',0),(211211,5867,'de','Bereits gelÃ¶schte oder deaktiviertes durch Bank',0),(211212,5867,'en','Already Deleted or Cleared Through Bank',0),(211213,5868,'is','',0),(211214,5868,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(211215,5868,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(211216,5868,'tr','Banka mevduat geÃ§miÅŸi',0),(211217,5868,'pl','HistoriÄ™ depozytÃ³w bankowych',0),(211218,5868,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(211219,5868,'ur','Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(211220,5868,'sr','Ð‘Ð°Ð½ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(211221,5868,'vi','Lá»‹ch sá»­ TK NgÃ¢n hÃ ng Ná»£',0),(211222,5868,'af','Bank Deposito Geskiedenis',0),(211223,5868,'ro','Istoria de depozit bancar',0),(211224,5868,'et','Panga hoiuste ajalugu',0),(211225,5868,'si','BanÄni depozit zgodovina',0),(211226,5868,'ba','Bank Deposit sejarah',0),(211227,5868,'nl','Bank Deposit geschiedenis',0),(211228,5868,'fi','Pankki tallettaa historia',0),(211229,5868,'no','Banken innskuddshistorie',0),(211230,5868,'da','Bank depositum historie',0),(211231,5868,'ko','ì€í–‰ ì˜ˆê¸ˆ ì—­ì‚¬',0),(211232,5868,'he','×”×™×¡×˜×•×¨×™×” ×”×¤×§×“×” ×‘×‘× ×§',0),(211233,5868,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚ Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(211234,5868,'zh','é“¶è¡Œå­˜æ¬¾åŽ†å²è®°å½•\r\n',0),(211235,5868,'sv','Bank insÃ¤ttningshistoria',0),(211236,5868,'it','Storia di deposito bancario',0),(211237,5868,'tl','',0),(211238,5868,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(211239,5868,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(211240,5868,'ms','Sejarah Deposit Bank',0),(211241,5868,'ar','ØªØ§Ø±ÙŠØ® Ø¥ÙŠØ¯Ø§Ø¹ Ø¨Ù†Ùƒ',0),(211242,5868,'fr','Histoire de dÃ©pÃ´t bancaire',0),(211243,5868,'jp','éŠ€è¡Œé ?é‡‘å±¥æ­´',0),(211244,5868,'pt','HistÃ³ria de depÃ³sito de banco',0),(211245,5868,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(211246,5868,'es','Historia de Depositos Bancarios',0),(211247,5868,'de','Bank Deposit Geschichte',0),(211248,5868,'en','Bank Deposit History',0),(211249,5869,'is','',0),(211250,5869,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø³Ù¾Ø±Ø¯Ù‡',0),(211251,5869,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø³Ù¾Ø±Ø¯Ù‡',0),(211252,5869,'tr','BaÅŸlangÄ±Ã§ depozit tarihi',0),(211253,5869,'pl','Data zÅ‚oÅ¼enia rozp.',0),(211254,5869,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(211255,5869,'ur','Ø´Ø±ÙˆØ¹ Ú©Û’ Ø°Ø®ÛŒØ±Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(211256,5869,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(211257,5869,'vi','NgÃ y báº¯t Ä‘áº§u ghi ná»£',0),(211258,5869,'af','Begin Deposito Datum',0),(211259,5869,'ro','Data de depozit incep',0),(211260,5869,'et','Hoiuse alguskuupÃ¤ev',0),(211261,5869,'si','ZaÄetni polog datum',0),(211262,5869,'ba','Mulailah Deposit tanggal',0),(211263,5869,'nl','Begindatum storting',0),(211264,5869,'fi','Talletus aloituspÃ¤ivÃ¤',0),(211265,5869,'no','Start innbetalingen dato',0),(211266,5869,'da','Begynd depositum dato',0),(211267,5869,'ko','ì‹œìž‘ ìž…ê¸ˆ ë‚ ì§œ',0),(211268,5869,'he','×‘×’×™×Ÿ ×”×¤×§×“×” ×ª××¨×™×š',0),(211269,5869,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚ Ï„Î·Ï‚ Î­Î½Î±ÏÎ¾Î·Ï‚',0),(211270,5869,'zh','å¼€å§‹å­˜æ¬¾æ—¥æœŸ',0),(211271,5869,'sv','BÃ¶rja insÃ¤ttning datum',0),(211272,5869,'it','Data di deposito Begin',0),(211273,5869,'tl','',0),(211274,5869,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;',0),(211275,5869,'hi','à¤†à¤°à¤‚à¤­ à¤œà¤®à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(211276,5869,'ms','Tarikh Deposit mulakan',0),(211277,5869,'ar','ØªØ§Ø±ÙŠØ® Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø¨Ø¯Ø¡',0),(211278,5869,'fr','Date de dÃ©pÃ´t de Begin',0),(211279,5869,'jp','é ?è¨—é–‹å§‹æ—¥',0),(211280,5869,'pt','Data de depÃ³sito do Begin',0),(211281,5869,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(211282,5869,'es','Fecha de Inicio de Deposito',0),(211283,5869,'de','BEGIN Einzahlungsdatum',0),(211284,5869,'en','Begin Deposit Date',0),(211285,5870,'is','',0),(211286,5870,'dr','Ø­Ø°Ù Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(211287,5870,'pr','Ø­Ø°Ù Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(211288,5870,'tr','Silme baÅŸarÄ±lÄ±',0),(211289,5870,'pl','Skuteczne usuwanie',0),(211290,5870,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(211291,5870,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(211292,5870,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ ÑƒÑÐ¿ÐµÑˆÐ°Ð½',0),(211293,5870,'vi','XÃ³a thÃ nh cÃ´ng',0),(211294,5870,'af','Skrap Suksesvol ',0),(211295,5870,'ro','Stergere reusita',0),(211296,5870,'et','Kustutamine oli edukas',0),(211297,5870,'si','Brisanje uspeÅ¡no',0),(211298,5870,'ba','Hapus sukses',0),(211299,5870,'nl','Verwijderen succesvol',0),(211300,5870,'fi','Poista onnistunut',0),(211301,5870,'no','Slett vellykket',0),(211302,5870,'da','Slet vellykket',0),(211303,5870,'ko','ì‚­ì œ ì„±ê³µ',0),(211304,5870,'he','×ž×—×§ ×ž×•×¦×œ×—',0),(211305,5870,'el','Î•Ï€Î¹Ï„Ï…Ï‡Î®Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(211306,5870,'zh','åˆ é™¤æˆåŠŸ\r\n',0),(211307,5870,'sv','Ta bort framgÃ¥ngsrika',0),(211308,5870,'it','Eliminazione di successo',0),(211309,5870,'tl','',0),(211310,5870,'th','&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(211311,5870,'hi','à¤¹à¤Ÿà¤¾à¤à¤ à¤¸à¤«à¤²',0),(211312,5870,'ms','Delete yang berjaya',0),(211313,5870,'ar','Ø§Ù„Ø­Ø°Ù Ù†Ø§Ø¬Ø­',0),(211314,5870,'fr','Suppression rÃ©ussie',0),(211315,5870,'jp','æ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(211316,5870,'pt','Apagar bem sucedida',0),(211317,5870,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(211318,5870,'es','Eliminar Exitoso',0),(211319,5870,'de','Erfolgreiche lÃ¶schen',0),(211320,5870,'en','Delete Successful',0),(211321,5871,'is','',0),(211322,5871,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(211323,5871,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(211324,5871,'tr','Mevduat ID #',0),(211325,5871,'pl','Depozyt ID #',0),(211326,5871,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ID #',0),(211327,5871,'ur','Ø¬Ù…Ø¹ ID #',0),(211328,5871,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð˜Ð” #',0),(211329,5871,'vi','Sá»‘ ID Äáº·t cá»c',0),(211330,5871,'af','Deposito ID#',0),(211331,5871,'ro','Depozit ID #',0),(211332,5871,'et','Tagatisraha ID #',0),(211333,5871,'si','Depozit ID #',0),(211334,5871,'ba','Deposit ID #',0),(211335,5871,'nl','Storting ID #',0),(211336,5871,'fi','Talletus ID #',0),(211337,5871,'no','Innskudd ID #',0),(211338,5871,'da','Depositum ID #',0),(211339,5871,'ko','ì˜ˆê¸ˆ ID #',0),(211340,5871,'he','×¤×™×§×“×•×Ÿ ID #',0),(211341,5871,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ID #',0),(211342,5871,'zh','å­˜æ¬¾çš„IDï¼ƒ\r\n',0),(211343,5871,'sv','InsÃ¤ttning ID #',0),(211344,5871,'it','Deposito ID #',0),(211345,5871,'tl','',0),(211346,5871,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3613;&#3634;&#3585;',0),(211347,5871,'hi','à¤œà¤®à¤¾ ID #',0),(211348,5871,'ms','Deposit ID #',0),(211349,5871,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ø¹Ø±Ù #',0),(211350,5871,'fr','DÃ©pÃ´t ID #',0),(211351,5871,'jp','é ?é‡‘Iï¼¤ç•ªå?·',0),(211352,5871,'pt','DepÃ³sito ID #',0),(211353,5871,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ID#',0),(211354,5871,'es','DepÃ³sito ID#',0),(211355,5871,'de','Einzahlung ID#',0),(211356,5871,'en','Deposit ID#',0),(211357,5872,'is','',0),(211358,5872,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(211359,5872,'pr','Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) ÙŠØ§ÙØª Ù†Ø´Ø¯',0),(211360,5872,'tr','Mevduat bulunamadÄ±',0),(211361,5872,'pl','Depozyt nie znaleziono',0),(211362,5872,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(211363,5872,'ur','Ø¬Ù…Ø¹ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(211364,5872,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(211365,5872,'vi','KhÃ´ng tháº¥y Äáº·t cá»c',0),(211366,5872,'af','Deposito Nie Gevind',0),(211367,5872,'ro','Depozit nu a fost gÄƒsit',0),(211368,5872,'et','Tagatisraha ei leitud',0),(211369,5872,'si','Depozit, ni mogoÄe najti',0),(211370,5872,'ba','Deposit tidak ditemukan',0),(211371,5872,'nl','Storting niet gevonden',0),(211372,5872,'fi','Talletus ei lÃ¶ydy',0),(211373,5872,'no','Innskudd ikke funnet',0),(211374,5872,'da','Depositum ikke fundet',0),(211375,5872,'ko','ë³´ì¦ê¸ˆ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(211376,5872,'he','×”×¤×™×§×“×•×Ÿ ×œ× × ×ž×¦×',0),(211377,5872,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(211378,5872,'zh','å­˜æ¬¾æœªæ‰¾åˆ°\r\n',0),(211379,5872,'sv','InsÃ¤ttning hittades inte',0),(211380,5872,'it','Deposito non trovato',0),(211381,5872,'tl','',0),(211382,5872,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;',0),(211383,5872,'hi','à¤œà¤®à¤¾ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(211384,5872,'ms','Deposit yang tidak dijumpai',0),(211385,5872,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¥ÙŠØ¯Ø§Ø¹',0),(211386,5872,'fr','DÃ©pÃ´t non trouvÃ©',0),(211387,5872,'jp','é ?é‡‘ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(211388,5872,'pt','DepÃ³sito nÃ£o encontrado',0),(211389,5872,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½',0),(211390,5872,'es','DepÃ³sito no se EncontrÃ³',0),(211391,5872,'de','Einzahlung nicht gefunden',0),(211392,5872,'en','Deposit Not Found',0),(211393,5873,'is','',0),(211394,5873,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(211395,5873,'pr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(211396,5873,'tr','Son Ã¶deme tarihi',0),(211397,5873,'pl','Data koÅ„cowa depozytu',0),(211398,5873,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(211399,5873,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… ÚˆÙ¾Ø§Ø²Ù¹',0),(211400,5873,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(211401,5873,'vi','NgÃ y Ä‘áº·t cá»c cuá»‘i',0),(211402,5873,'af','End Deposito Datum',0),(211403,5873,'ro','Data de depozit scop',0),(211404,5873,'et','Tagatisraha lÃµppkuupÃ¤ev',0),(211405,5873,'si','KonÄni datum pologa',0),(211406,5873,'ba','Tanggal akhir Deposit',0),(211407,5873,'nl','Storting einddatum',0),(211408,5873,'fi','Talletus pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(211409,5873,'no','Innskudd sluttdatoen',0),(211410,5873,'da','Slutdato for indbetaling',0),(211411,5873,'ko','ìµœì¢… ìž…ê¸ˆ ë‚ ì§œ',0),(211412,5873,'he','×ª××¨×™×š ×”×”×¤×§×“×” ×¡×™×•×',0),(211413,5873,'el','Î¤Î­Î»Î¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(211414,5873,'zh','ç»“æŸå­˜æ¬¾æ—¥æœŸ',0),(211415,5873,'sv','InsÃ¤ttning slutdatum',0),(211416,5873,'it','Data di deposito finale',0),(211417,5873,'tl','',0),(211418,5873,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;&#3607;&#3637;&#3656;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;',0),(211419,5873,'hi','à¤…à¤‚à¤¤ à¤œà¤®à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(211420,5873,'ms','Tarikh akhir Deposit',0),(211421,5873,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(211422,5873,'fr','Date de dÃ©pÃ´t de fin',0),(211423,5873,'jp','é ?è¨—çµ‚äº†æ—¥',0),(211424,5873,'pt','Data de depÃ³sito do final',0),(211425,5873,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(211426,5873,'es','Fecha Final para Depositar',0),(211427,5873,'de','Ende Einzahlungsdatum',0),(211428,5873,'en','End Deposit Date',0),(211429,5874,'is','',0),(211430,5874,'dr','Ø§Ø³Ù†Ø§Ø¯ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(211431,5874,'pr','Ø§Ø³Ù†Ø§Ø¯ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(211432,5874,'tr','EÅŸleÅŸen kayÄ±t bulunamadÄ±',0),(211433,5874,'pl','Nie pasujÄ…cych rekordÃ³w Znalezione',0),(211434,5874,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(211435,5874,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø±ÛŒÚ©Ø§Ø±Úˆ Ù…Ù„Ø§ ÛÛ’',0),(211436,5874,'sr','ÐžÐ´Ð³Ð¾Ð²Ð°Ñ€Ð°Ñ˜ÑƒÑ›Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð¸ÑÑƒ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð¸',0),(211437,5874,'vi','KhÃ´ng tÃ¬m tháº¥y há»“ sÆ¡ phÃ¹ há»£p',0),(211438,5874,'af','Geen Ooreenstemmende Rekords Gevind',0),(211439,5874,'ro','Nicio potrivire Inregistrari gasite',0),(211440,5874,'et','Antud kriteeriumitele vastavaid andmeid ei leitud',0),(211441,5874,'si','Ni najdenih zapisov ujemanje',0),(211442,5874,'ba','Ada catatan yang cocok ditemukan',0),(211443,5874,'nl','Geen overeenkomende Records zijn gevonden',0),(211444,5874,'fi','Vastaavia merkintÃ¶jÃ¤ ei lÃ¶ydy',0),(211445,5874,'no','Finner ingen samsvarende poster',0),(211446,5874,'da','Ingen tilsvarende poster fundet',0),(211447,5874,'ko','ë°œê²¬ ì—†ìŒ ì¼ì¹˜ í•˜ëŠ” ë ˆì½”ë“œ',0),(211448,5874,'he','×œ× × ×ž×¦××• ×¨×©×•×ž×•×ª ×ª×•××ž×•×ª',0),(211449,5874,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(211450,5874,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„è®°å½•\r\n',0),(211451,5874,'sv','Hittade inga matchande poster',0),(211452,5874,'it','Trovati record corrispondenti',0),(211453,5874,'tl','',0),(211454,5874,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(211455,5874,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(211456,5874,'ms','Rekod tiada padanan ditemui',0),(211457,5874,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø³Ø¬Ù„Ø§Øª Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(211458,5874,'fr','Aucun enregistrement correspondant trouvÃ©',0),(211459,5874,'jp','ä¸€è‡´ã?™ã‚‹è¨˜éŒ²ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(211460,5874,'pt','Nenhum registro correspondente encontrado',0),(211461,5874,'ru','Ð¡Ð¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(211462,5874,'es','No se Encontraron Records Emparejados',0),(211463,5874,'de','Keine Ã¼bereinstimmenden DatensÃ¤tze gefunden',0),(211464,5874,'en','No Matching Records Found',0),(211465,5875,'is','',0),(211466,5875,'dr','Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ',0),(211467,5875,'pr','Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ',0),(211468,5875,'tr','Banka ekstresinde',0),(211469,5875,'pl','Na wyciÄ…gu bankowym',0),(211470,5875,'bg','Ð’ Ð±Ð°Ð½ÐºÐ¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(211471,5875,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ø§ÛŒÚ© Ø¨ÛŒØ§Ù† Ù¾Ø±',0),(211472,5875,'sr','ÐÐ° Ð¸Ð·Ð²Ð¾Ð´Ñƒ Ð±Ð°Ð½ÐºÐµ',0),(211473,5875,'vi','Chá»‰ sao kÃª ngÃ¢n hÃ ng',0),(211474,5875,'af','Op Bankstaat',0),(211475,5875,'ro','Pe extrasul de cont',0),(211476,5875,'et','Panga vÃ¤ljavÃµttel',0),(211477,5875,'si','Na banÄnem izpisku',0),(211478,5875,'ba','Pada pernyataan Bank',0),(211479,5875,'nl','Op bankafschrift',0),(211480,5875,'fi','Pankin tiliotteessa',0),(211481,5875,'no','Bankkontoutdraget',0),(211482,5875,'da','PÃ¥ bankens kontoudtog',0),(211483,5875,'ko','ì€í–‰ ê±°ëž˜ ë‚´ì—­ì„œì—',0),(211484,5875,'he','×¢×œ ×”×‘× ×§',0),(211485,5875,'el','Î£Ï„Î·Î½ Î´Î®Î»Ï‰ÏƒÎ· Ï„Î·Ï‚ Î¤ÏÎ¬Ï€ÎµÎ¶Î±Ï‚',0),(211486,5875,'zh','é“¶è¡Œçš„å£°æ˜Ž\r\n',0),(211487,5875,'sv','PÃ¥ bankutdrag',0),(211488,5875,'it','Sull\'estratto conto',0),(211489,5875,'tl','',0),(211490,5875,'th','&#3651;&#3609;&#3627;&#3609;&#3633;&#3591;&#3626;&#3639;&#3629;&#3649;&#3592;&#3657;&#3591;&#3618;&#3629;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(211491,5875,'hi','à¤¬à¥ˆà¤‚à¤• à¤•à¥‡ à¤¬à¤¯à¤¾à¤¨ à¤ªà¤°',0),(211492,5875,'ms','Penyata Bank',0),(211493,5875,'ar','ÙÙŠ ÙƒØ´Ù Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ',0),(211494,5875,'fr','Sur le relevÃ© bancaire',0),(211495,5875,'jp','éŠ€è¡Œå?–å¼•æ˜Žç´°æ›¸ä¸Š',0),(211496,5875,'pt','No extracto bancÃ¡rio',0),(211497,5875,'ru','Ð’ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð¹ Ð’Ñ‹Ð¿Ð¸ÑÐºÐµ',0),(211498,5875,'es','En El Estado deCuenta Bancaria',0),(211499,5875,'de','Auf Kontoauszug',0),(211500,5875,'en','On Bank Statement',0),(211501,5876,'is','',0),(211502,5876,'dr','Ø«Ø¨Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(211503,5876,'pr','Ø«Ø¨Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(211504,5876,'tr','KayÄ±t bulunamadÄ±',0),(211505,5876,'pl','Nie moÅ¼na odnaleÅºÄ‡ rekordu',0),(211506,5876,'bg','Ð—Ð°Ð¿Ð¸ÑÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(211507,5876,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(211508,5876,'sr','Ð—Ð°Ð¿Ð¸Ñ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(211509,5876,'vi','KhÃ´ng tháº¥y há»“ sÆ¡',0),(211510,5876,'af','Rekord Nie Gevind',0),(211511,5876,'ro','Inregistrari negasite',0),(211512,5876,'et','Kirjet ei leitud',0),(211513,5876,'si','Zapisa ni mogoÄe najti',0),(211514,5876,'ba','Catatan tidak ditemukan',0),(211515,5876,'nl','Record niet gevonden',0),(211516,5876,'fi','Tietuetta ei lÃ¶ytynyt',0),(211517,5876,'no','Posten ikke funnet',0),(211518,5876,'da','Post ikke fundet',0),(211519,5876,'ko','ë ˆì½”ë“œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(211520,5876,'he','×¨×©×•×ž×” ×œ× × ×ž×¦××”',0),(211521,5876,'el','Î•Î³Î³ÏÎ±Ï†Î® Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(211522,5876,'zh','æ²¡æœ‰æ‰¾åˆ°è®°å½•\r\n',0),(211523,5876,'sv','Posten hittades inte',0),(211524,5876,'it','Record non trovato',0),(211525,5876,'tl','',0),(211526,5876,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;',0),(211527,5876,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(211528,5876,'ms','Rekod tidak dijumpai',0),(211529,5876,'ar','Ø§Ù„Ø³Ø¬Ù„Ù‘ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(211530,5876,'fr','Enregistrement non trouvÃ©',0),(211531,5876,'jp','è¨˜éŒ²ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(211532,5876,'pt','Registro nÃ£o encontrado',0),(211533,5876,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ð°',0),(211534,5876,'es','Record No se EncontrÃ³',0),(211535,5876,'de','Datensatz nicht gefunden',0),(211536,5876,'en','Record Not Found',0),(211537,5877,'is','',0),(211538,5877,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ØªØºÙŠÙŠØ± Ù†ÙŠØ³Øª',0),(211539,5877,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ØªØºÙŠÙŠØ± Ù†ÙŠØ³Øª',0),(211540,5877,'tr','DeÄŸiÅŸtiremezsiniz',0),(211541,5877,'pl','Nie moÅ¼na zmieniÄ‡',0),(211542,5877,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(211543,5877,'ur','ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(211544,5877,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ð¸',0),(211545,5877,'vi','KhÃ´ng thá»ƒ thay Ä‘á»•i',0),(211546,5877,'af','Kan verander',0),(211547,5877,'ro','Imposibil de modificat',0),(211548,5877,'et','Ei saa muuta',0),(211549,5877,'si','Ni mogoÄe spremeniti',0),(211550,5877,'ba','Tidak dapat mengubah',0),(211551,5877,'nl','Niet wijzigen',0),(211552,5877,'fi','Ei voi muuttaa',0),(211553,5877,'no','Kan ikke endre',0),(211554,5877,'da','Kan ikke Ã¦ndre',0),(211555,5877,'ko','ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(211556,5877,'he','×œ× × ×™×ª×Ÿ ×œ×©× ×•×ª',0),(211557,5877,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î»Î»Î¬Î¾ÎµÎ¹',0),(211558,5877,'zh','ä¸èƒ½æ›´æ”¹\r\n',0),(211559,5877,'sv','Kan inte Ã¤ndra',0),(211560,5877,'it','Non Ã¨ possibile modificare',0),(211561,5877,'tl','',0),(211562,5877,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3652;&#3604;&#3657;',0),(211563,5877,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(211564,5877,'ms','Tidak boleh menukar',0),(211565,5877,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØºÙŠÙŠØ±',0),(211566,5877,'fr','Impossible de modifier',0),(211567,5877,'jp','å¤‰æ›´ä¸?å?¯',0),(211568,5877,'pt','NÃ£o posso mudar',0),(211569,5877,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(211570,5877,'es','No se puede Cambiar',0),(211571,5877,'de','Kann nicht geÃ¤ndert werden',0),(211572,5877,'en','Cannot Change',0),(211573,5878,'is','',0),(211574,5878,'dr','( Ø³Ù¾Ø±Ø¯Ù‡ Ø´Ø¯Ù‡ ) Ø¯Ø± Ø¨Ø§Ù†Ùƒ ',0),(211575,5878,'pr','Ø§Ù…Ø§Ù†Ù‰ ( Ø³Ù¾Ø±Ø¯Ù‡ Ø´Ø¯Ù‡ ) Ø¯Ø± Ø¨Ø§Ù†Ùƒ ',0),(211576,5878,'tr','Bankaya yatÄ±rÄ±lÄ±r',0),(211577,5878,'pl','Zdeponowane w banku',0),(211578,5878,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ€Ð° Ð² Ð±Ð°Ð½ÐºÐ°',0),(211579,5878,'ur','Ø¨ÛŒÙ†Ú© Ù…ÛŒÚº Ø¬Ù…Ø¹',0),(211580,5878,'sr','Ð”ÐµÐ¿Ð¾Ð½Ð¾Ð²Ð°Ð½ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(211581,5878,'vi','Äáº·t cá»c vÃ o ngÃ¢n hÃ ng',0),(211582,5878,'af','Gedeponeer in Bank',0),(211583,5878,'ro','Depus Ã®n Banca',0),(211584,5878,'et','Pangas hoiustatud',0),(211585,5878,'si','Deponiran v banki',0),(211586,5878,'ba','Disimpan di Bank',0),(211587,5878,'nl','Neergelegd in de Bank',0),(211588,5878,'fi','Talletettu pankkiin',0),(211589,5878,'no','Deponert i Bank',0),(211590,5878,'da','Indsat i Bank',0),(211591,5878,'ko','ì€í–‰ì— ìž…ê¸ˆ',0),(211592,5878,'he','×”×¤×§×™×“ ×‘×‘× ×§',0),(211593,5878,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÏ„Î·Î½ Î¤ÏÎ¬Ï€ÎµÎ¶Î±',0),(211594,5878,'zh','å­˜æ”¾äºŽé“¶è¡Œ\r\n',0),(211595,5878,'sv','Deponeras i Bank',0),(211596,5878,'it','Depositati in banca',0),(211597,5878,'tl','',0),(211598,5878,'th','&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3649;&#3621;&#3657;&#3623;',0),(211599,5878,'hi','à¤¬à¥ˆà¤‚à¤• à¤®à¥‡à¤‚ à¤œà¤®à¤¾ à¤•à¤¿à¤¯à¤¾',0),(211600,5878,'ms','Disimpan di Bank',0),(211601,5878,'ar','Ø§Ù„Ù…ÙˆØ¯Ø¹Ø© ÙÙŠ Ø§Ù„Ø¨Ù†Ùƒ',0),(211602,5878,'fr','DÃ©pÃ´t en banque',0),(211603,5878,'jp','éŠ€è¡Œã?«é ?ã?‘å…¥ã‚Œ',0),(211604,5878,'pt','Depositado no banco',0),(211605,5878,'ru','ÐÐ° Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð² Ð±Ð°Ð½Ðº',0),(211606,5878,'es','Depositado en el Banco',0),(211607,5878,'de','In Bank hinterlegt',0),(211608,5878,'en','Deposited in Bank',0),(211609,5879,'is','',0),(211610,5879,'dr','Ø§ÙŠØ¬Ø§Ø¯  ÙŠØ§  Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨Ø§Ù†ÙƒÙŠ',0),(211611,5879,'pr','Ø§ÙŠØ¬Ø§Ø¯  ÙŠØ§  Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨Ø§Ù†ÙƒÙŠ',0),(211612,5879,'tr','OluÅŸturma veya gÃ¼ncelleÅŸtirme banka MevduatÄ±',0),(211613,5879,'pl','Tworzenia lub aktualizacji Bank lokaty',0),(211614,5879,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð¸Ð»Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(211615,5879,'ur','ØªØ®Ù„ÛŒÙ‚ ÛŒØ§ ØªØ¬Ø¯ÛŒØ¯ Ø¨ÛŒÙ†Ú© Ú©Û’ Ø°Ø®Ø§Ø¦Ø±',0),(211616,5879,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¸Ð»Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð±Ð°Ð½ÐºÐµ Ð¿Ð¾Ð»Ð¾Ñ›Ð¸',0),(211617,5879,'vi','Táº¡o Má»›i hay cáº­p nháº­t Tiá»n Cá»c NgÃ¢n hÃ ng',0),(211618,5879,'af','Skep of Opdateer Bank Deposito\'s',0),(211619,5879,'ro','Crearea sau actualizarea Bank depozite',0),(211620,5879,'et','Loo vÃµi uuenda panga hoiuste',0),(211621,5879,'si','Ustvarjanje ali posodobitev banÄni depoziti',0),(211622,5879,'ba','Membuat atau deposito Update Bank',0),(211623,5879,'nl','Maken of Update Bank deposito \'s',0),(211624,5879,'fi','Luo tai PÃ¤ivitÃ¤ pankkiin',0),(211625,5879,'no','Opprett eller oppdater bankinnskudd',0),(211626,5879,'da','Oprette eller opdatere Bank indbetalinger',0),(211627,5879,'ko','ë§Œë“¤ê¸° ë˜ëŠ” ì—…ë°ì´íŠ¸ ì€í–‰ ì˜ˆê¸ˆ',0),(211628,5879,'he','×¦×•×¨ ××• ×¢×“×›×Ÿ ×¤×§×“×•× ×•×ª ×‘× ×§',0),(211629,5879,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ­Ï‚ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚',0),(211630,5879,'zh','åˆ›å»ºæˆ–æ›´æ–°é“¶è¡Œå­˜æ¬¾\r\n',0),(211631,5879,'sv','Skapa eller uppdatera banktillgodohavanden',0),(211632,5879,'it','Creazione o aggiornamento banca deposita',0),(211633,5879,'tl','',0),(211634,5879,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3627;&#3619;&#3639;&#3629;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(211635,5879,'hi','à¤¬à¤¨à¤¾à¤à¤ à¤¯à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾à¤°à¤¾à¤¶à¤¿à¤¯à¤¾à¤‚',0),(211636,5879,'ms','Mencipta atau Deposit Bank Kemaskini',0),(211637,5879,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø£Ùˆ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ùƒ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹',0),(211638,5879,'fr','CrÃ©ation ou mise Ã  jour de banque de dÃ©pÃ´ts',0),(211639,5879,'jp','éŠ€è¡Œé ?é‡‘ã?®ä½œæˆ?ã‚‚ã?—ã??ã?¯æ›´æ–°',0),(211640,5879,'pt','Criar ou depÃ³sitos bancÃ¡rios de atualizaÃ§Ã£o',0),(211641,5879,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¸Ð»Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(211642,5879,'es','Crear o Actualizar Depositos Bancarios',0),(211643,5879,'de','Erstellen oder aktualisieren Bank Einlagen',0),(211644,5879,'en','Create or Update Bank Deposits',0),(211645,5880,'is','',0),(211646,5880,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙˆØ¨ Ø³Ø§ÙŠØª ',0),(211647,5880,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙˆØ¨ Ø³Ø§ÙŠØª ',0),(211648,5880,'tr','ÃœrÃ¼n Web sitesi',0),(211649,5880,'pl','Witryna sieci Web produktu',0),(211650,5880,'bg','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð² ÑƒÐµÐ± ÑÐ°Ð¹Ñ‚',0),(211651,5880,'ur','Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹',0),(211652,5880,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ WÐµÐ± Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(211653,5880,'vi','Trang web Sáº£n pháº©m',0),(211654,5880,'af','Produk Webwerf',0),(211655,5880,'ro','Site-ul de produs',0),(211656,5880,'et','Toote veebileht',0),(211657,5880,'si','Product spletna stran',0),(211658,5880,'ba','Produk situs Web',0),(211659,5880,'nl','Product-website',0),(211660,5880,'fi','Internet-sivut',0),(211661,5880,'no','Produktet nettside',0),(211662,5880,'da','Produkt-websted',0),(211663,5880,'ko','ì œí’ˆ ì›¹ ì‚¬ì´íŠ¸',0),(211664,5880,'he','××ª×¨ ×ž×•×¦×¨',0),(211665,5880,'el','Î™ÏƒÏ„Î¿Ï‡ÏŽÏÎ¿Ï‚ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Ï‰Î½',0),(211666,5880,'zh','äº§å“ç½‘ç«™\r\n',0),(211667,5880,'sv','Produkt-webbplats',0),(211668,5880,'it','Sito Web del prodotto',0),(211669,5880,'tl','',0),(211670,5880,'th','&#3648;&#3623;&#3655;&#3610;&#3652;&#3595;&#3605;&#3660;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(211671,5880,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤µà¥‡à¤¬ à¤¸à¤¾à¤‡à¤Ÿ',0),(211672,5880,'ms','Laman Web produk',0),(211673,5880,'ar','Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ù†ØªØ¬ Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø¨ÙƒØ© Ø§Ù„Ø¹Ù†ÙƒØ¨ÙˆØªÙŠØ©',0),(211674,5880,'fr','Site Web du produit',0),(211675,5880,'jp','è£½å“?ã‚¦ã‚§ãƒ–ã‚µã‚¤ãƒˆ',0),(211676,5880,'pt','Web Site do produto',0),(211677,5880,'ru','Ð’ÐµÐ±-ÑÐ°Ð¹Ñ‚ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(211678,5880,'es','Sitio de Web de Producto',0),(211679,5880,'de','Produkt-Website',0),(211680,5880,'en','Product Web Site',0),(211681,5881,'is','',0),(211682,5881,'dr','http:// ÙŠØ§ https://',0),(211683,5881,'pr','Ø¨Ù‡ Ø®Ø§Ø·Ø± Ø¨Ø³Ù¾Ø§Ø±ÙŠØ¯ ÙƒÙ‡ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯  http:// ÙŠØ§ https://',0),(211684,5881,'tr','Http:// veya https:// eklemeyi unutmayÄ±n',0),(211685,5881,'pl','PamiÄ™taj, aby dodaÄ‡ http:// lub https://',0),(211686,5881,'bg','ÐÐµ Ð·Ð°Ð±Ñ€Ð°Ð²ÑÐ¹Ñ‚Ðµ Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ http:// Ð¸Ð»Ð¸ https://',0),(211687,5881,'ur','Http:// ÛŒØ§ https:// Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ÛŒØ§Ø¯ Ø±Ú©Ú¾ÛŒÚº',0),(211688,5881,'sr','ÐÐµ Ð·Ð°Ð±Ð¾Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð´Ð° Ð´Ð¾Ð´Ð°Ñ‚Ðµ http:// Ð¸Ð»Ð¸ https://',0),(211689,5881,'vi','Nhá»› thÃªm http:// or https://',0),(211690,5881,'af','Onthou om http:// of https:// te voeg',0),(211691,5881,'ro','AmintiÅ£i-vÄƒ sÄƒ adÄƒugaÈ›i http:// sau https://',0),(211692,5881,'et','Ã„rge unustage lisada http:// vÃµi https://',0),(211693,5881,'si','Ne pozabite dodati http:// ali https://',0),(211694,5881,'ba','Ingat untuk menambahkan http:// atau https://',0),(211695,5881,'nl','Herinner me om toe te voegen http:// of https://',0),(211696,5881,'fi','Muista lisÃ¤tÃ¤ http:// tai https://',0),(211697,5881,'no','Husk Ã¥ legge http:// eller https://',0),(211698,5881,'da','Husk at tilfÃ¸je http:// eller https://',0),(211699,5881,'ko','Http:// ë˜ëŠ” https://ì— ì¶”ê°€ í•´ì•¼',0),(211700,5881,'he','×–×›×•×¨ ×œ×”×•×¡×™×£ http:// ××• https://',0),(211701,5881,'el','Î˜Ï…Î¼Î·Î¸ÎµÎ¯Ï„Îµ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ http:// Î® https://',0),(211702,5881,'zh','è¯·è®°ä½ï¼Œå¢žåŠ http://æˆ–httpsï¼š//\r\n',0),(211703,5881,'sv','Kom ihÃ¥g att lÃ¤gga till http:// eller https://',0),(211704,5881,'it','Ricordarsi di aggiungere http:// o https://',0),(211705,5881,'tl','',0),(211706,5881,'th','&#3629;&#3618;&#3656;&#3634;&#3621;&#3639;&#3617;&#3648;&#3614;&#3636;&#3656;&#3617; http:// &#3627;&#3619;&#3639;&#3629; https://',0),(211707,5881,'hi','Http:// à¤¯à¤¾ https:// à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¾à¤¦ à¤°à¤–à¥‡à¤‚',0),(211708,5881,'ms','Jangan lupa untuk menambah http:// atau https://',0),(211709,5881,'ar','ØªØ°ÙƒØ± Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø¶Ø§ÙØ© http://Ø£Ùˆ https://',0),(211710,5881,'fr','N\'oubliez pas d\'ajoutez http:// ou https://',0),(211711,5881,'jp','http:// or https://ã‚’å¿…ã?šè¿½åŠ ã?—ã?¦ã??ã? ã?•ã?„',0),(211712,5881,'pt','Lembre-se de adicionar http:// ou https://',0),(211713,5881,'ru','ÐÐµ Ð·Ð°Ð±ÑƒÐ´ÑŒÑ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð² http:// Ð¸Ð»Ð¸ https://',0),(211714,5881,'es','Tener presente agregar http:// or https://',0),(211715,5881,'de','Denken Sie daran, http:// oder https:// HinzufÃ¼gen',0),(211716,5881,'en','Remember to add http:// or https://',0),(211717,5882,'is','',0),(211718,5882,'dr','Ø¶Ù…ÙŠÙ…Ù‡ ',0),(211719,5882,'pr','Ø¶Ù…ÙŠÙ…Ù‡ ',0),(211720,5882,'tr','ACH',0),(211721,5882,'pl','ACH',0),(211722,5882,'bg','ACH',0),(211723,5882,'ur','Ø§Ú†',0),(211724,5882,'sr','ÐÐ¥',0),(211725,5882,'vi','ACH',0),(211726,5882,'af','ACH',0),(211727,5882,'ro','ACH',0),(211728,5882,'et','ACH',0),(211729,5882,'si','ACH',0),(211730,5882,'ba','ACH',0),(211731,5882,'nl','ACH',0),(211732,5882,'fi','ACH',0),(211733,5882,'no','ACH',0),(211734,5882,'da','ACH',0),(211735,5882,'ko','ACH',0),(211736,5882,'he','ACH',0),(211737,5882,'el','ACH',0),(211738,5882,'zh','è‡ªåŠ¨åŒ–äº¤æ˜“æ‰€\r\n',0),(211739,5882,'sv','ACH',0),(211740,5882,'it','ACH',0),(211741,5882,'tl','',0),(211742,5882,'th','&#3619;&#3632;&#3610;&#3610; ACH',0),(211743,5882,'hi','ACH',0),(211744,5882,'ms','MEN',0),(211745,5882,'ar','Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(211746,5882,'fr','ODC',0),(211747,5882,'jp','ACH',0),(211748,5882,'pt','ACH',0),(211749,5882,'ru','ACH',0),(211750,5882,'es','ACH',0),(211751,5882,'de','ACH',0),(211752,5882,'en','ACH',0),(211753,5883,'is','',0),(211754,5883,'dr','Ø¶Ù…ÙŠÙ…Ù‡ Ø³Ù¾Ø±Ø¯Ù‡  Ù…Ø¹ÙˆÙ‚',0),(211755,5883,'pr','Ø¶Ù…ÙŠÙ…Ù‡ Ø³Ù¾Ø±Ø¯Ù‡  Ù…Ø¹ÙˆÙ‚',0),(211756,5883,'tr','ACH mevduat bekleyen',0),(211757,5883,'pl','ACH depozytÃ³w czasu',0),(211758,5883,'bg','ACH Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸ Ð´Ð¾',0),(211759,5883,'ur','Ø§Ú† Ø°Ø®Ø§Ø¦Ø± Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(211760,5883,'sr','ÐÑ… Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ðµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(211761,5883,'vi','ACH Äang Chá» Ghi Ná»£ ',0),(211762,5883,'af','ACH Deposito Wagtend',0),(211763,5883,'ro','ACH Depozite in asteptare',0),(211764,5883,'et','ACH hoiused kuni',0),(211765,5883,'si','ACH vloge do',0),(211766,5883,'ba','ACH Simpanan Tertunda',0),(211767,5883,'nl','ACH deposito\'s in afwachting van',0),(211768,5883,'fi','ACH talletukset vireillÃ¤',0),(211769,5883,'no','ACH innskudd venter',0),(211770,5883,'da','ACH indskud indtil',0),(211771,5883,'ko','ACH ì˜ˆê¸ˆ ë³´ë¥˜',0),(211772,5883,'he','ACH ×¤×™×§×“×•× ×•×ª ×ž×ž×ª×™× ×™×',0),(211773,5883,'el','ACH ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚ ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î®',0),(211774,5883,'zh','ACHçš„å­˜æ¬¾å¾…å®š\r\n',0),(211775,5883,'sv','ACH insÃ¤ttningar i avvaktan',0),(211776,5883,'it','Depositi ACH in sospeso',0),(211777,5883,'tl','',0),(211778,5883,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3588;&#3629;&#3618;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3592;&#3634;&#3585; &#3619;&#3632;&#3610;&#3610; ACH',0),(211779,5883,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ ACH à¤œà¤®à¤¾',0),(211780,5883,'ms','MEN Deposit sementara menunggu',0),(211781,5883,'ar','Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(211782,5883,'fr','Compte dâ€™Attente ODC',0),(211783,5883,'jp','ä¿?ç•™ä¸­ï¼¡ï¼£ï¼¨é ?ã‚Šé‡‘',0),(211784,5883,'pt','ACH depÃ³sitos pendentes',0),(211785,5883,'ru','ACH Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹ Ð´Ð¾',0),(211786,5883,'es','DepÃ³sitos Pendientes ACH',0),(211787,5883,'de','ACH Einlagen bis',0),(211788,5883,'en','ACH Deposits Pending',0),(211789,5884,'is','',0),(211790,5884,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¯Ø± Ø¨Ø§Ù†Ú© ',0),(211791,5884,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¯Ø± Ø¨Ø§Ù†Ú© ',0),(211792,5884,'tr','Ayarlanan banka bakiyesi',0),(211793,5884,'pl','Saldo bankowe dostosowane',0),(211794,5884,'bg','ÐšÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ð¸ Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ Ð±Ð°Ð»Ð°Ð½Ñ',0),(211795,5884,'ur','Ø¨Ù†Û’ Ø¨ÛŒÙ†Ú© Ø¨ÛŒÙ„Ù†Ø³',0),(211796,5884,'sr','ÐšÐ¾Ñ€Ð¸Ð³Ð¾Ð²Ð°Ð½Ð¸ Ð±Ð°Ð½ÐºÐ¾Ð²Ð½Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(211797,5884,'vi','Sá»­a Äá»•i Sá»‘ DÆ° NgÃ¢n HÃ ng',0),(211798,5884,'af','Aangepasde Bank Balans',0),(211799,5884,'ro','Soldul ajustat bancar',0),(211800,5884,'et','Korrigeeritud pangakonto',0),(211801,5884,'si','Prilagojene banÄne bilance',0),(211802,5884,'ba','Saldo Bank disesuaikan',0),(211803,5884,'nl','Aangepaste banksaldo',0),(211804,5884,'fi','Oikaistu pankkitalletukset',0),(211805,5884,'no','Justert banksaldo',0),(211806,5884,'da','Justerede Bank Balance',0),(211807,5884,'ko','ì¡°ì • ëœ ì€í–‰ ìž”ê³ ',0),(211808,5884,'he','×™×ª×¨×ª ×—×©×‘×•×Ÿ ×”×‘× ×§ ×ž× ×•×›×™ ×¢×•× ×ª×™×•×ª',0),(211809,5884,'el','Î¡Ï…Î¸Î¼Î¹ÏƒÎ¼Î­Î½Î¿ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(211810,5884,'zh','è°ƒæ•´åŽé“¶è¡Œç»“ä½™\r\n',0),(211811,5884,'sv','Justerade Bank balans',0),(211812,5884,'it','Bilancio bancario regolato',0),(211813,5884,'tl','',0),(211814,5884,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3610;&#3633;&#3597;&#3594;&#3637;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(211815,5884,'hi','à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤¬à¥ˆà¤‚à¤• à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸',0),(211816,5884,'ms','Baki Bank terlaras',0),(211817,5884,'ar','Ø±ØµÙŠØ¯ Ø§Ù„Ø¨Ù†Ùƒ Ø§Ù„Ù…Ø¹Ø¯Ù„',0),(211818,5884,'fr','Solde en banque corrigÃ©',0),(211819,5884,'jp','éŠ€è¡Œæ®‹é«˜ã‚’èª¿æ•´ã?—ã?¾ã?—ã?Ÿ',0),(211820,5884,'pt','Saldo bancÃ¡rio ajustado',0),(211821,5884,'ru','Ð¡ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð±Ð°Ð»Ð°Ð½Ñ',0),(211822,5884,'es','Balance Bancario Ajustado',0),(211823,5884,'de','Bereinigte Kontostand',0),(211824,5884,'en','Adjusted Bank Balance',0),(211825,5885,'is','',0),(211826,5885,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ù…ØºØ§ÙŠØ±Øª Ú¯ÙŠØ±ÙŠ Ú©Ø±Ø¯Ù†',0),(211827,5885,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ù…ØºØ§ÙŠØ±Øª Ú¯ÙŠØ±ÙŠ Ú©Ø±Ø¯Ù†',0),(211828,5885,'tr','UzlaÅŸtÄ±rmak iÃ§in bir miktar',0),(211829,5885,'pl','Kwota do pogodzenia',0),(211830,5885,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° ÑÑŠÐ³Ð»Ð°ÑÑƒÐ²Ð°Ð½Ðµ',0),(211831,5885,'ur','Ø±Ù‚Ù… Ú©Ùˆ ÛÙ… Ø¢ÛÙ†Ú¯ Ú©Ø±Ù†Û’',0),(211832,5885,'sr','Ð˜Ð·Ð½Ð¾Ñ ÐºÐ¾Ñ˜Ð¸ Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° ÑÐµ ÑƒÑÐ°Ð³Ð»Ð°ÑÐ¸',0),(211833,5885,'vi','Sá»‘ Tiá»n Cáº§n CÃ¢n Äá»‘i',0),(211834,5885,'af','Bedrag om te Rekonsilieer',0),(211835,5885,'ro','Suma de reconciliere',0),(211836,5885,'et','Summa vastavusse viia',0),(211837,5885,'si','Znesek uskladiti',0),(211838,5885,'ba','Jumlah untuk mendamaikan',0),(211839,5885,'nl','Bedrag in overeenstemming te brengen',0),(211840,5885,'fi','MÃ¤Ã¤rÃ¤ sovittamaan',0),(211841,5885,'no','Hvor Ã¥ forsone',0),(211842,5885,'da','BelÃ¸b, der skal forene',0),(211843,5885,'ko','ì¡°ì • ê¸ˆì•¡',0),(211844,5885,'he','×›×ž×•×ª ×œ×”×ª×¤×™×™×¡',0),(211845,5885,'el','Î Î¿ÏƒÏŒ Î½Î± ÏƒÏ…Î¼Ï†Î¹Î»Î¹ÏŽÏƒÎµÎ¹',0),(211846,5885,'zh','è°ƒå’Œé‡‘é¢\r\n',0),(211847,5885,'sv','Belopp att fÃ¶rena',0),(211848,5885,'it','QuantitÃ  di conciliare',0),(211849,5885,'tl','',0),(211850,5885,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(211851,5885,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤®à¤‚à¤œà¤¸à¥à¤¯',0),(211852,5885,'ms','Jumlah untuk menyelaraskan',0),(211853,5885,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„ØªÙˆÙÙŠÙ‚ Ø¨ÙŠÙ†',0),(211854,5885,'fr','Montant de concilier',0),(211855,5885,'jp','èª¿æ•´é¡?',0),(211856,5885,'pt','Quantidade de conciliar',0),(211857,5885,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ñ€Ð¸Ð¼Ð¸Ñ€Ð¸Ñ‚ÑŒ',0),(211858,5885,'es','Monto para Reconciliar',0),(211859,5885,'de','Betrag zu vereinbaren',0),(211860,5885,'en','Amount to Reconcile',0),(211861,5886,'is','',0),(211862,5886,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ù†Ùƒ  ØªØ±Ø§Ø² Ù¾Ø§ÙŠØ§Ù†ÙŠ',0),(211863,5886,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ù†Ùƒ  ØªØ±Ø§Ø² Ù¾Ø§ÙŠØ§Ù†ÙŠ',0),(211864,5886,'tr','Banka Ekstre sonu bakiyesi',0),(211865,5886,'pl','Salda koÅ„cowego oÅ›wiadczenia banku',0),(211866,5886,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð² Ð±Ð°Ð»Ð°Ð½Ñ Ð¿Ð¾ Ñ‚ÐµÐºÑƒÑ‰Ð¾ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ðµ',0),(211867,5886,'ur','Ø¨ÛŒÙ†Ú© Ú©Ø§ Ø¨ÛŒØ§Ù† Ø®ØªÙ… ÛÙˆÙ†Û’ ØªÙˆØ§Ø²Ù†',0),(211868,5886,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° ÐºÑ€Ð°Ñ˜ ÑÑ‚Ð°ÑšÐµ Ð½Ð° Ñ€Ð°Ñ†ÑƒÐ½Ñƒ',0),(211869,5886,'vi','Sá»‘ dÆ° sao kÃª cuá»‘i ká»³ ',0),(211870,5886,'af','Bankstaat End Balans',0),(211871,5886,'ro','Soldul bancar declaraÅ£ie se Ã®ncheie',0),(211872,5886,'et','Pangakonto vÃ¤ljavÃµtte lÃµppsaldo',0),(211873,5886,'si','Banka izjavo konÄni saldo',0),(211874,5886,'ba','Saldo akhir pernyataan bank',0),(211875,5886,'nl','Verklaring Ending banksaldo',0),(211876,5886,'fi','Pankin ilmoitus loppusaldo',0),(211877,5886,'no','Banken Utdrag-sluttsaldo',0),(211878,5886,'da','Bank erklÃ¦ring slutsaldo',0),(211879,5886,'ko','ì€í–‰ ë¬¸ì˜ ë ê· í˜•',0),(211880,5886,'he','×™×ª×¨×ª ×—×©×‘×•×Ÿ ×”×‘× ×§ ×ž×©×¤×˜ ×¡×™×•×',0),(211881,5886,'el','Î¥Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ Ï„Î­Î»Î¿Ï…Ï‚ Î´Î®Î»Ï‰ÏƒÎ· Ï„ÏÎ¬Ï€ÎµÎ¶Î±Ï‚',0),(211882,5886,'zh','é“¶è¡Œå¯¹è´¦å•ç»“æŸä½™é¢\r\n',0),(211883,5886,'sv','Bank uttalande slut balans',0),(211884,5886,'it','Saldi di fine istruzione banca',0),(211885,5886,'tl','',0),(211886,5886,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(211887,5886,'hi','à¤¬à¥ˆà¤‚à¤• à¤¬à¤¯à¤¾à¤¨ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¨à¥‡ à¤•à¥‡ à¤¸à¤‚à¤¤à¥à¤²à¤¨',0),(211888,5886,'ms','Baki berakhir Penyata Bank',0),(211889,5886,'ar','Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ø®ØªØ§Ù…ÙŠ Ù„Ø¨ÙŠØ§Ù† Ø§Ù„Ù…ØµØ±Ù',0),(211890,5886,'fr','DÃ©claration concernant le solde de fin',0),(211891,5886,'jp','éŠ€è¡Œæ®‹é«˜æœ€çµ‚æ®‹é«˜',0),(211892,5886,'pt','Saldo final de instruÃ§Ã£o',0),(211893,5886,'ru','Ð‘Ð°Ð½Ðº Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ¾Ð½ÐµÑ‡Ð½Ð¾Ðµ ÑÐ°Ð»ÑŒÐ´Ð¾',0),(211894,5886,'es','Estado de Cuenta Bancario Saldo Final',0),(211895,5886,'de','Anweisung Ende Bankguthaben',0),(211896,5886,'en','Bank Statement Ending Balance',0),(211897,5887,'is','',0),(211898,5887,'dr','ØµÙˆØ±Øª Ù…ØºØ§ÙŠØ±Øª ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ù†Ùƒ',0),(211899,5887,'pr','ØµÙˆØ±Øª Ù…ØºØ§ÙŠØ±Øª ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ù†Ùƒ',0),(211900,5887,'tr','Banka ekstresi Mutabakat',0),(211901,5887,'pl','Uzgadnianiem wyciÄ…gu bankowego',0),(211902,5887,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ñ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ',0),(211903,5887,'ur','Ø¨ÛŒÙ†Ú© Ú©Ø§ Ø¨ÛŒØ§Ù† Ù…ÙØ§ÛÙ…Øª',0),(211904,5887,'sr','Ð¡Ñ€Ð°Ð²ÑšÐµÑšÐµ Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(211905,5887,'vi','BÃ¡o cÃ¡o cÃ¢n Ä‘á»‘i TK ngÃ¢n hÃ ng',0),(211906,5887,'af','Bankstaat Rekonsiliasie',0),(211907,5887,'ro','Bancare declaraÅ£ie reconciliere',0),(211908,5887,'et','PangavÃ¤ljavÃµtte vastavusseviimisse',0),(211909,5887,'si','Izjava banÄnega',0),(211910,5887,'ba','Rekonsiliasi pernyataan bank',0),(211911,5887,'nl','De verzoening van de verklaring van de Bank',0),(211912,5887,'fi','Tiliotteen tÃ¤smÃ¤ytykseen',0),(211913,5887,'no','Bankkontoutdraget',0),(211914,5887,'da','Bankudtogsafstemningen',0),(211915,5887,'ko','ì€í–‰ ë¬¸ í™”í•´',0),(211916,5887,'he','×”×ª××ž×ª ×‘× ×§ ×”×¦×”×¨×”',0),(211917,5887,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± Î´Î®Î»Ï‰ÏƒÎ· ÏƒÏ…Î¼Ï†Î¹Î»Î¯Ï‰ÏƒÎ·',0),(211918,5887,'zh','é“¶è¡Œå¯¹å¸\r\n',0),(211919,5887,'sv','Bankutdraget',0),(211920,5887,'it','Riconciliazione della dichiarazione bancaria',0),(211921,5887,'tl','',0),(211922,5887,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3609;&#3637;&#3611;&#3619;&#3632;&#3609;&#3629;&#3617;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(211923,5887,'hi','à¤¬à¥ˆà¤‚à¤• à¤¬à¤¯à¤¾à¤¨ à¤¸à¥à¤²à¤¹',0),(211924,5887,'ms','Bank Penyata penyesuaian',0),(211925,5887,'ar','ØªØ³ÙˆÙŠØ© ÙƒØ´Ù Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØµØ±Ù',0),(211926,5887,'fr','Rapprochement des relevÃ©s bancaires',0),(211927,5887,'jp','éŠ€è¡Œæ˜Žç´°èª¿æ•´',0),(211928,5887,'pt','ReconciliaÃ§Ã£o de declaraÃ§Ã£o bancÃ¡ria',0),(211929,5887,'ru','Ð¡Ð²ÐµÑ€ÐºÑƒ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð¹ Ð²Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(211930,5887,'es','Estado de Cuenta Bancario ConciliaciÃ³n',0),(211931,5887,'de','Bankauszugsabstimmung',0),(211932,5887,'en','Bank Statement Reconciliation',0),(211933,5888,'is','',0),(211934,5888,'dr','ÙƒØ§Ø±Ø¨Ø±Ú¯ ØµÙˆØ±Øª Ù…ØºØ§ÙŠØ±Øª ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ù†Ùƒ',0),(211935,5888,'pr','ÙƒØ§Ø±Ø¨Ø±Ú¯ ØµÙˆØ±Øª Ù…ØºØ§ÙŠØ±Øª ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ù†Ùƒ',0),(211936,5888,'tr','Banka ekstresi mutabakat Ã§alÄ±ÅŸma sayfasÄ±',0),(211937,5888,'pl','Banku oÅ›wiadczenie pojednania arkusza',0),(211938,5888,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚ ÑÑŠÐ¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð»Ð¸ÑÑ‚',0),(211939,5888,'ur','Ø¨ÛŒÙ†Ú© Ú©Ø§ Ø¨ÛŒØ§Ù† Ù…ÙØ§ÛÙ…Øª Ù‚Ø±Ø·Ø§Ø³ Ú©Ø§Ø±',0),(211940,5888,'sr','Ð‘Ð°Ð½ÐºÐ° Ð¸Ð·Ñ˜Ð°Ð²Ð° Ð¿Ð¾Ð¼Ð¸Ñ€ÐµÑšÐµ Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð»Ð¸ÑÑ‚Ð°',0),(211941,5888,'vi','Trang bÃ¡o cÃ¡o cÃ¢n Ä‘á»‘i TK ngÃ¢n hÃ ng',0),(211942,5888,'af','Bankstaat Rekonsiliasie Werkstaat',0),(211943,5888,'ro','Bancare declaraÅ£ie de reconciliere a foii de lucru',0),(211944,5888,'et','Pangakonto vÃ¤ljavÃµtte vastavusse viimine tÃ¶Ã¶leht',0),(211945,5888,'si','Banka izjavo usklajevanje delovnega lista',0),(211946,5888,'ba','Bank pernyataan rekonsiliasi Worksheet',0),(211947,5888,'nl','Bank verklaring verzoening werkblad',0),(211948,5888,'fi','Pankin ilmoitus sovinnon laskentataulukon',0),(211949,5888,'no','Bank uttalelse avstemming regneark',0),(211950,5888,'da','Bank erklÃ¦ring forsoning regneark',0),(211951,5888,'ko','ì€í–‰ ë¬¸ í™”í•´ ì›Œí¬ì‹œíŠ¸',0),(211952,5888,'he','×”×‘× ×§ ×”×¦×”×¨×ª ×¤×™×•×¡ ×’×œ×™×•×Ÿ ×¢×‘×•×“×”',0),(211953,5888,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± Î´Î®Î»Ï‰ÏƒÎ· ÏƒÏ…Î¼Ï†Î¹Î»Î¯Ï‰ÏƒÎ· Ï†ÏÎ»Î»Î¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(211954,5888,'zh','é“¶è¡Œå¯¹å¸è¡¨\r\n',0),(211955,5888,'sv','Bank uttalande fÃ¶rsoning kalkylblad',0),(211956,5888,'it','Il foglio di lavoro di banca istruzione riconciliazione',0),(211957,5888,'tl','',0),(211958,5888,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3609;&#3637;&#3611;&#3619;&#3632;&#3609;&#3629;&#3617;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(211959,5888,'hi','à¤¬à¥ˆà¤‚à¤• à¤¬à¤¯à¤¾à¤¨ à¤¸à¥à¤²à¤¹ à¤•à¤¾à¤°à¥à¤¯à¤ªà¤¤à¥à¤°à¤•',0),(211960,5888,'ms','Lembaran kerja Penyata penyesuaian Bank penyata',0),(211961,5888,'ar','ÙˆØ±Ù‚Ø© Ø¹Ù…Ù„ ØªØ³ÙˆÙŠØ© ÙƒØ´Ù Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØµØ±Ù',0),(211962,5888,'fr','Feuille de travail de rÃ©conciliation bancaire dÃ©claration',0),(211963,5888,'jp','éŠ€è¡Œæ˜Žç´°èª¿æ•´ãƒ¯ãƒ¼ã‚¯ã‚·ãƒ¼ãƒˆ',0),(211964,5888,'pt','Planilha de ConciliaÃ§Ã£o bancÃ¡ria declaraÃ§Ã£o',0),(211965,5888,'ru','Ð›Ð¸ÑÑ‚ Ð¿Ñ€Ð¸Ð¼Ð¸Ñ€ÐµÐ½Ð¸Ñ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð±Ð°Ð½ÐºÐ°',0),(211966,5888,'es','Estado de Cuenta Bancario ConciliaciÃ³n Hoja de Trabajo',0),(211967,5888,'de','Anweisung Bankabstimmungs-Arbeitsblatt',0),(211968,5888,'en','Bank Statement Reconciliation Worksheet',0),(211969,5889,'is','',0),(211970,5889,'dr','ØªØ±Ø§Ø² ÙƒØ§Ù…Ù¾ÙŠÙˆØªØ±ÙŠ',0),(211971,5889,'pr','ØªØ±Ø§Ø² ÙƒØ§Ù…Ù¾ÙŠÙˆØªØ±ÙŠ',0),(211972,5889,'tr','Bilgisayar ayarÄ±',0),(211973,5889,'pl','Bilansu komputer',0),(211974,5889,'bg','ÐšÐ¾Ð¼Ð¿ÑŽÑ‚ÑŠÑ€Ð½Ð¸ Ð±Ð°Ð»Ð°Ð½Ñ',0),(211975,5889,'ur','Ú©Ù…Ù¾ÛŒÙˆÙ¹Ø± ØªÙˆØ§Ø²Ù†',0),(211976,5889,'sr','ÐšÐ¾Ð¼Ð¿Ñ˜ÑƒÑ‚ÐµÑ€ ÑÐ°Ð»Ð´Ð¾',0),(211977,5889,'vi','Sá»‘ dÆ° mÃ¡y tÃ­nh',0),(211978,5889,'af','Rekenaar Balans',0),(211979,5889,'ro','Calculator echilibru',0),(211980,5889,'et','Arvuti tasakaal',0),(211981,5889,'si','RaÄunalnik ravnovesje',0),(211982,5889,'ba','Keseimbangan komputer',0),(211983,5889,'nl','Computer evenwicht',0),(211984,5889,'fi','Tietokone tasapaino',0),(211985,5889,'no','Datamaskinen balanse',0),(211986,5889,'da','Computer Balance',0),(211987,5889,'ko','ì»´í“¨í„° ê· í˜•',0),(211988,5889,'he','×”×ž×—×©×‘ ××™×–×•×Ÿ',0),(211989,5889,'el','Î™ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± Ï„Î¿Ï… Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„Î®',0),(211990,5889,'zh','ç”µè„‘å¹³è¡¡\r\n',0),(211991,5889,'sv','Dator balans',0),(211992,5889,'it','Equilibrio di computer',0),(211993,5889,'tl','',0),(211994,5889,'th','&#3618;&#3629;&#3604;&#3588;&#3629;&#3617;&#3614;&#3636;&#3623;&#3648;&#3605;&#3629;&#3619;&#3660;',0),(211995,5889,'hi','à¤•à¤‚à¤ªà¥à¤¯à¥‚à¤Ÿà¤° à¤¸à¤‚à¤¤à¥à¤²à¤¨',0),(211996,5889,'ms','Baki komputer',0),(211997,5889,'ar','Ø±ØµÙŠØ¯ Ø§Ù„ÙƒÙ…Ø¨ÙŠÙˆØªØ±',0),(211998,5889,'fr','Solde ordinateur',0),(211999,5889,'jp','ã‚³ãƒ³ãƒ”ãƒ¥ãƒ¼ã‚¿ãƒ¼ãƒ?ãƒ©ãƒ³ã‚¹',0),(212000,5889,'pt','EquilÃ­brio de computador',0),(212001,5889,'ru','ÐšÐ¾Ð¼Ð¿ÑŒÑŽÑ‚ÐµÑ€ Ð±Ð°Ð»Ð°Ð½Ñ',0),(212002,5889,'es','Balance de Computadora',0),(212003,5889,'de','Computer-Balance',0),(212004,5889,'en','Computer Balance',0),(212005,5890,'is','',0),(212006,5890,'dr','- ØªØ­Øª Ø¨Ø±Ø±Ø³ÙŠ',0),(212007,5890,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ø¹Ù„Ù‚- ØªØ­Øª Ø¨Ø±Ø±Ø³ÙŠ',0),(212008,5890,'tr','Bekleyen mevduat',0),(212009,5890,'pl','Depozyty w oczekiwaniu',0),(212010,5890,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸ Ð² Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ',0),(212011,5890,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§ Ú©Û’ Ø°Ø®Ø§Ø¦Ø±',0),(212012,5890,'sr','ÐŸÐ¾Ð»Ð¾Ñ›Ð¸ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(212013,5890,'vi','Äang treo Ä‘áº·t cá»c',0),(212014,5890,'af','Deposito\'s Afwagtend',0),(212015,5890,'ro','Depozite Ã®n aÅŸteptarea',0),(212016,5890,'et','Hoiused kuni',0),(212017,5890,'si','Vloge do',0),(212018,5890,'ba','Deposito tertunda',0),(212019,5890,'nl','Deposito\'s in afwachting van',0),(212020,5890,'fi','Talletukset vireillÃ¤',0),(212021,5890,'no','Innskudd venter',0),(212022,5890,'da','Indskud indtil',0),(212023,5890,'ko','ë³´ë¥˜ ì˜ˆê¸ˆ',0),(212024,5890,'he','×¤×™×§×“×•× ×•×ª ×ž×ž×ª×™× ×™×',0),(212025,5890,'el','ÎšÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚ ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î®',0),(212026,5890,'zh','å­˜æ¬¾å¾…å®š\r\n',0),(212027,5890,'sv','InsÃ¤ttningar i avvaktan',0),(212028,5890,'it','Depositi sospesi',0),(212029,5890,'tl','',0),(212030,5890,'th','&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3607;&#3637;&#3656;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(212031,5890,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤œà¤®à¤¾',0),(212032,5890,'ms','Deposit sementara menunggu',0),(212033,5890,'ar','ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(212034,5890,'fr','DÃ©pÃ´ts en suspens',0),(212035,5890,'jp','ä¿?ç•™ä¸­é ?ã?‹ã‚Šé‡‘',0),(212036,5890,'pt','DepÃ³sitos pendentes',0),(212037,5890,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹ Ð´Ð¾',0),(212038,5890,'es','DepÃ³sitos Pendientes',0),(212039,5890,'de','Ausstehende Einlagen',0),(212040,5890,'en','Deposits Pending',0),(212041,5891,'is','',0),(212042,5891,'dr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ',0),(212043,5891,'pr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ',0),(212044,5891,'tr','Son banka hesap kesim tarihi',0),(212045,5891,'pl','Bank koniec instrukcja Data',0),(212046,5891,'bg','ÐšÑ€Ð°Ð¹ Ð±Ð°Ð½ÐºÐ¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(212047,5891,'ur','Ø¢Ø®Ø± Ø¨ÛŒÙ†Ú© Ø¨ÛŒØ§Ù† ØªØ§Ø±ÛŒØ®',0),(212048,5891,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð±Ð°Ð½ÐºÐµ Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(212049,5891,'vi','NgÃ y sao kÃª ngÃ¢n hÃ ng cuá»‘i',0),(212050,5891,'af','End Bankstaat Datum',0),(212051,5891,'ro','Data de declaraÅ£ie final Banca',0),(212052,5891,'et','LÃµpuks panga vÃ¤ljavÃµtte kuupÃ¤ev',0),(212053,5891,'si','Datum konca banÄnega izpiska',0),(212054,5891,'ba','Bank akhir pernyataan tanggal',0),(212055,5891,'nl','Einde Bank Afschriftdatum',0),(212056,5891,'fi','Lopulta tiliotteen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(212057,5891,'no','Slutten Bank Utdragsdato',0),(212058,5891,'da','Ende Bank Kontoudtogsdato',0),(212059,5891,'ko','ê²°êµ­ ì€í–‰ ê³„ì‚° ì„œ ë‚ ì§œ',0),(212060,5891,'he','×ª××¨×™×š ×¡×™×•× ×”×‘× ×§ ×”×¦×”×¨×”',0),(212061,5891,'el','Î¤Î­Î»Î¿Ï‚ Î¤ÏÎ¬Ï€ÎµÎ¶Î± Î´Î®Î»Ï‰ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(212062,5891,'zh','æœˆåº•é“¶è¡Œç»“å•æ—¥',0),(212063,5891,'sv','Datum fÃ¶r slutet bankutdrag',0),(212064,5891,'it','Banca di fine istruzione data',0),(212065,5891,'tl','',0),(212066,5891,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3586;&#3629;&#3591;&#3627;&#3609;&#3633;&#3591;&#3626;&#3639;&#3629;&#3649;&#3592;&#3657;&#3591;&#3618;&#3629;&#3604;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(212067,5891,'hi','à¤…à¤‚à¤¤ à¤¬à¥ˆà¤‚à¤• à¤¬à¤¯à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(212068,5891,'ms','Tarikh Penyata Bank akhir',0),(212069,5891,'ar','ØªØ§Ø±ÙŠØ® Ø¨ÙŠØ§Ù† Ø§Ù„Ù…ØµØ±Ù Ù†Ù‡Ø§ÙŠØ©',0),(212070,5891,'fr','Date du relevÃ© bancaire fin',0),(212071,5891,'jp','éŠ€è¡Œæ˜Žç´°æœ€çµ‚æ—¥',0),(212072,5891,'pt','Data de declaraÃ§Ã£o do banco de final',0),(212073,5891,'ru','Ð”Ð°Ñ‚Ð° Ð²Ñ‹Ð¿Ð¸ÑÐºÐ¸ Ð±Ð°Ð½ÐºÐ° ÐºÐ¾Ð½ÐµÑ†',0),(212074,5891,'es','Fecha Final de Estado de Cuenta Bancaria',0),(212075,5891,'de','Ende Bank Auszugsdatum',0),(212076,5891,'en','End Bank Statement Date',0),(212077,5892,'is','',0),(212078,5892,'dr','Ø·Ø¨Ù‚ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª  Ø¨Ù„Ù‡ Ø®ÙŠØ±',0),(212079,5892,'pr','Ø·Ø¨Ù‚ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª  Ø¨Ù„Ù‡ Ø®ÙŠØ±',0),(212080,5892,'tr','Deyim Ã¼zerinde?',0),(212081,5892,'pl','Instrukcja?',0),(212082,5892,'bg','Ð’ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°?',0),(212083,5892,'ur','Ø¨ÛŒØ§Ù† Ù¾Ø±ØŸ',0),(212084,5892,'sr','ÐÐ° Ð¸Ð·Ð²Ð¾Ð´Ñƒ?',0),(212085,5892,'vi','VÃ o Sao KÃª?',0),(212086,5892,'af','Op Staat?',0),(212087,5892,'ro','Pe Declaratie?',0),(212088,5892,'et','VÃ¤ljavÃµttel?',0),(212089,5892,'si','Na izpisku?',0),(212090,5892,'ba','Pada pernyataan?',0),(212091,5892,'nl','Verklaring?',0),(212092,5892,'fi','Tiliotteessa?',0),(212093,5892,'no','PÃ¥ setningen?',0),(212094,5892,'da','RedegÃ¸relse?',0),(212095,5892,'ko','ë¬¸ì—?',0),(212096,5892,'he','×¢×œ ×”×”×¦×”×¨×”?',0),(212097,5892,'el','Î£Îµ Î´Î®Î»Ï‰ÏƒÎ·;',0),(212098,5892,'zh','å£°æ˜Žï¼Ÿ\r\n',0),(212099,5892,'sv','PÃ¥ kontoutdraget?',0),(212100,5892,'it','Sull\'istruzione?',0),(212101,5892,'tl','',0),(212102,5892,'th','&#3610;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3618;&#3629;&#3604;&#3651;&#3594;&#3656;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(212103,5892,'hi','à¤¬à¤¯à¤¾à¤¨ à¤ªà¤°?',0),(212104,5892,'ms','Penyata?',0),(212105,5892,'ar','ÙÙŠ Ø§Ù„Ø¨ÙŠØ§Ù†ØŸ',0),(212106,5892,'fr','Sur la dÃ©claration ?',0),(212107,5892,'jp','æ˜Žç´°ä¸Šï¼Ÿ',0),(212108,5892,'pt','Na declaraÃ§Ã£o?',0),(212109,5892,'ru','Ð’ Ð’Ñ‹Ð¿Ð¸ÑÐºÑƒ?',0),(212110,5892,'es','Â¿En Estado de Cuenta?',0),(212111,5892,'de','Auf Anweisung?',0),(212112,5892,'en','On Statement?',0),(212113,5893,'is','',0),(212114,5893,'dr','(Ø±Ø³ÙŠØ¯Ù‡Ø§) Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ù†Ø¯ (Ø§Ù…Ø§Ù†ÙŠ Ù†ÙŠØ³ØªÙ†Ø¯',0),(212115,5893,'pr','Ø¯Ø±ÙŠØ§ÙØªÙ‡Ø§(Ø±Ø³ÙŠØ¯Ù‡Ø§) Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ù†Ø¯ (Ø§Ù…Ø§Ù†ÙŠ Ù†ÙŠØ³ØªÙ†Ø¯',0),(212116,5893,'tr','Makbuzlar deÄŸil yatÄ±rÄ±lÄ±r',0),(212117,5893,'pl','WpÅ‚ywy nie zÅ‚oÅ¼one',0),(212118,5893,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ¸Ñ‚Ðµ Ð½Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ€Ð°',0),(212119,5893,'ur','Ø±Ø³ÛŒØ¯ÛŒÚº Ø¬Ù…Ø¹ Ù†ÛÛŒÚº',0),(212120,5893,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ðµ Ð½Ð¸Ñ˜Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(212121,5893,'vi','BiÃªn nháº­n chÆ°a ná»™p tiá»n',0),(212122,5893,'af','Inkomstes Nog Nie Gedeponeer',0),(212123,5893,'ro','ÃŽncasÄƒri depuse nu',0),(212124,5893,'et','Laekumised ei ole hoiule',0),(212125,5893,'si','Prejemki ne deponira',0),(212126,5893,'ba','Penerimaan yang tidak disimpan',0),(212127,5893,'nl','Ontvangsten niet gedeponeerd',0),(212128,5893,'fi','Kuitit ei talletettu',0),(212129,5893,'no','Mottak ikke avsatt',0),(212130,5893,'da','Kvitteringer ikke deponeret',0),(212131,5893,'ko','ì˜ìˆ˜ì¦ ìž…ê¸ˆ í•˜ì§€',0),(212132,5893,'he','×§×‘×œ×•×ª ×œ× ×”×¤×§×™×“',0),(212133,5893,'el','ÎˆÏƒÎ¿Î´Î± Ï€Î¿Ï… Î´ÎµÎ½ Î­Ï‡Î¿Ï…Î½ ÎºÎ±Ï„Î±Ï„ÎµÎ¸ÎµÎ¯',0),(212134,5893,'zh','æ”¶ç›Šä¸æ²‰ç§¯\r\n',0),(212135,5893,'sv','Kvitton som inte deponeras',0),(212136,5893,'it','Ricevute non depositate',0),(212137,5893,'tl','',0),(212138,5893,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;',0),(212139,5893,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚ à¤œà¤®à¤¾ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾',0),(212140,5893,'ms','Resit tidak disimpan',0),(212141,5893,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ù„Ù… ØªÙˆØ¯Ø¹',0),(212142,5893,'fr','Recettes non dÃ©posÃ©s',0),(212143,5893,'jp','é ?ã?‘ã‚‰ã‚Œã?¦ã?„ã?ªã?„é ˜å?Žæ›¸',0),(212144,5893,'pt','Recebimentos nÃ£o depositados',0),(212145,5893,'ru','ÐšÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð½Ðµ ÑÐ´Ð°Ð»Ð¸ Ð½Ð° Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ',0),(212146,5893,'es','Recibos No Depositados',0),(212147,5893,'de','Einnahmen, die nicht hinterlegt',0),(212148,5893,'en','Receipts Not Deposited',0),(212149,5894,'is','',0),(212150,5894,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ù¾ÙŠÙˆØ³Øª Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù†ÙŠØ³Øª ',0),(212151,5894,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ (Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ù¾ÙŠÙˆØ³Øª Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù†ÙŠØ³Øª ',0),(212152,5894,'tr','Deyim Ã¼zerinde kalan ACH mevduat',0),(212153,5894,'pl','PozostaÅ‚e lokaty ACH nie na oÅ›wiadczenie',0),(212154,5894,'bg','ÐžÑÑ‚Ð°Ð½Ð°Ð»Ð¸Ñ‚Ðµ ACH Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸ Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(212155,5894,'ur','Ø§Ú† Ø°Ø®Ø§Ø¦Ø± Ú©Û’ Ø¨ÛŒØ§Ù† Ù¾Ø± Ù†ÛÛŒÚº Ø¨Ø§Ù‚ÛŒ',0),(212156,5894,'sr','ÐŸÑ€ÐµÐ¾ÑÑ‚Ð°Ð»Ðµ Ð½Ð°ÑÐ»Ð°Ð³Ðµ ÐÑ… Ð½Ðµ Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(212157,5894,'vi','DÆ° ná»£ ACH cÃ²n láº¡i khÃ´ng trong sao kÃª',0),(212158,5894,'af','Oorblywende ACH Deposito\'s nie op Staat',0),(212159,5894,'ro','Restul ACH depozite nu pe declaraÅ£ie',0),(212160,5894,'et','ÃœlejÃ¤Ã¤nud ACH hoiuste ei avaldus',0),(212161,5894,'si','Preostalih vlog ACH ne na izjavo',0),(212162,5894,'ba','Deposito ACH tersisa tidak pada pernyataan',0),(212163,5894,'nl','Resterende ACH deposito\'s niet over de verklaring van',0),(212164,5894,'fi','JÃ¤ljellÃ¤ ACH talletukset ei julkilausumasta',0),(212165,5894,'no','GjenvÃ¦rende ACH innskudd ikke pÃ¥ uttalelse',0),(212166,5894,'da','Resterende ACH indskud ikke pÃ¥ kontoudtog',0),(212167,5894,'ko','ê³„ì‚° ì„œì— ì—†ëŠ” ë‚˜ë¨¸ì§€ ACH ì˜ˆê¸ˆ',0),(212168,5894,'he','×¤×™×§×“×•× ×•×ª ACH ×”× ×•×ª×¨×™× ×œ× ×¢×œ ×”×”×¦×”×¨×”',0),(212169,5894,'el','Î¥Ï€Î¿Î»Î¿Î¹Ï€ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚ ACH Î´ÎµÎ½ Ï„Î·Î½ Î´Î®Î»Ï‰ÏƒÎ·',0),(212170,5894,'zh','å‰©ä½™è‡ªåŠ¨äº¤æ˜“æ‰€å­˜æ¬¾ä¸å†å£°æ˜Žä¸Š\r\n',0),(212171,5894,'sv','Ã…terstÃ¥ende ACH insÃ¤ttningar inte pÃ¥ uttalande',0),(212172,5894,'it','Restanti depositi ACH non su istruzione',0),(212173,5894,'tl','',0),(212174,5894,'th','&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585; ACH &#3618;&#3633;&#3591;&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;&#3649;&#3605;&#3656;&#3652;&#3617;&#3656;&#3649;&#3626;&#3604;&#3591;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3618;&#362',0),(212175,5894,'hi','à¤¬à¤¯à¤¾à¤¨ à¤ªà¤° à¤¨à¤¹à¥€à¤‚ ACH à¤œà¤®à¤¾ à¤¶à¥‡à¤·',0),(212176,5894,'ms','Baki Deposit men bukan pada penyata',0),(212177,5894,'ar','Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ© \"Ù…Ù† Ø±ÙˆØ§Ø³Ø¨ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹\" Ù„Ø§ ÙÙŠ Ø§Ù„Ø¨ÙŠØ§Ù†',0),(212178,5894,'fr','Autres dÃ©pÃ´ts ACH pas sur la dÃ©claration',0),(212179,5894,'jp','æ˜Žç´°ä¸Šã?«ã?ªã?„æ®‹å­˜ï¼¡ï¼£ï¼¨é ?ã‚Šé‡‘',0),(212180,5894,'pt','DepÃ³sitos de ACH restantes nÃ£o na instruÃ§Ã£o',0),(212181,5894,'ru','ÐžÑÑ‚Ð°Ð²ÑˆÐ¸ÐµÑÑ ACH Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹ Ð½Ðµ Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(212182,5894,'es','DepÃ³sitos Restantes de ACH no estan en la declaraciÃ³n',0),(212183,5894,'de','Verbleibenden ACH Einlagen nicht auf Anweisung',0),(212184,5894,'en','Remaining ACH Deposits not on Statement',0),(212185,5895,'is','',0),(212186,5895,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª)  Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù†ÙŠØ³Øª',0),(212187,5895,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ (Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª)  Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù†ÙŠØ³Øª',0),(212188,5895,'tr','Deyim Ã¼zerinde kalan mevduat',0),(212189,5895,'pl','PozostaÅ‚e lokaty nie na oÅ›wiadczenie',0),(212190,5895,'bg','ÐžÑÑ‚Ð°Ð½Ð°Ð»Ð¸Ñ‚Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸ Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(212191,5895,'ur','Ø¨Ø§Ù‚ÛŒ Ø°Ø®Ø§Ø¦Ø± Ø¨ÛŒØ§Ù† Ù¾Ø± Ù†ÛÛŒÚº',0),(212192,5895,'sr','ÐŸÑ€ÐµÐ¾ÑÑ‚Ð°Ð»Ðµ Ð½Ð°ÑÐ»Ð°Ð³Ðµ Ð½Ðµ Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(212193,5895,'vi','DÆ° ná»£ cÃ²n láº¡i khÃ´ng trong sao kÃª',0),(212194,5895,'af','Oorblywende Deposito\'s nie op Staat',0),(212195,5895,'ro','Depozite rÄƒmase nu pe declaraÅ£ie',0),(212196,5895,'et','ÃœlejÃ¤Ã¤nud hoiuste ei avaldus',0),(212197,5895,'si','Preostalih vlog ne na izjavo',0),(212198,5895,'ba','Deposito yang tersisa tidak pada pernyataan',0),(212199,5895,'nl','Overige deposito\'s niet over de verklaring van',0),(212200,5895,'fi','Muilla tileillÃ¤ ei julkilausumasta',0),(212201,5895,'no','GjenvÃ¦rende innskudd ikke pÃ¥ uttalelse',0),(212202,5895,'da','Resterende indskud ikke pÃ¥ kontoudtog',0),(212203,5895,'ko','ê³„ì‚° ì„œì— ì—†ëŠ” ë‚˜ë¨¸ì§€ ì˜ˆê¸ˆ',0),(212204,5895,'he','×¤×™×§×“×•× ×•×ª ×”× ×•×ª×¨×™× ×œ× ×¢×œ ×”×”×¦×”×¨×”',0),(212205,5895,'el','Î¥Ï€Î¿Î»Î¿Î¹Ï€ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚ Î´ÎµÎ½ Ï„Î·Î½ Î´Î®Î»Ï‰ÏƒÎ·',0),(212206,5895,'zh','å‰©ä½™å­˜æ¬¾ä¸åœ¨è¡¨ä¸Š\r\n',0),(212207,5895,'sv','Ã…terstÃ¥ende insÃ¤ttningar inte pÃ¥ uttalande',0),(212208,5895,'it','Depositi restanti non su istruzione',0),(212209,5895,'tl','',0),(212210,5895,'th','&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3618;&#3633;&#3591;&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;&#3649;&#3605;&#3656;&#3652;&#3617;&#3656;&#3649;&#3626;&#3604;&#3591;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;',0),(212211,5895,'hi','à¤¶à¥‡à¤· à¤œà¤®à¤¾ à¤¨à¤¹à¥€à¤‚ à¤¬à¤¯à¤¾à¤¨ à¤ªà¤°',0),(212212,5895,'ms','Baki Deposit tidak di penyata',0),(212213,5895,'ar','Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹Ø§Øª Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ© Ù„Ø§ ÙÙŠ Ø§Ù„Ø¨ÙŠØ§Ù†',0),(212214,5895,'fr','DÃ©pÃ´ts restants pas sur la dÃ©claration',0),(212215,5895,'jp','æ˜Žç´°ä¸Šã?«ã?ªã?„æ®‹å­˜é ?ã‚Šé‡‘',0),(212216,5895,'pt','DepÃ³sitos restantes nÃ£o na instruÃ§Ã£o',0),(212217,5895,'ru','ÐžÑÑ‚Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð²ÐºÐ»Ð°Ð´Ñ‹ Ð½Ðµ Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(212218,5895,'es','DepÃ³sitos Restantes no estan en la declaraciÃ³n',0),(212219,5895,'de','Verbleibenden Einlagen nicht auf Anweisung',0),(212220,5895,'en','Remaining Deposits not on Statement',0),(212221,5896,'is','',0),(212222,5896,'dr','(ÙˆØ¬ÙˆÙ‡) Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡ ',0),(212223,5896,'pr','ÙƒÙ„ Ú†Ùƒ Ù‡Ø§ÙŠ Ù†Ù‚Ø¯ Ù†Ø´Ø¯Ù‡ Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ (ÙˆØ¬ÙˆÙ‡) Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡ ',0),(212224,5896,'tr','Toplam uncashed denetler ve ACH Ã¶demeleri',0),(212225,5896,'pl','CaÅ‚kowitej kontroli uncashed Los i pÅ‚atnoÅ›ci ACH',0),(212226,5896,'bg','ÐžÐ±Ñ‰Ð¾ Ð½ÐµÐºÐ°ÑÐ¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¸ ACH Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(212227,5896,'ur','Ú©Ù„ Ø§Ù†Ú©Ø§Ø´Ø§Ø¯ Ú†ÛŒÚ© Ø§ÙˆØ± Ø§Ú† Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(212228,5896,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð£Ð½Ñ†Ð°ÑÑ…ÐµÐ´ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð¸ ÐÑ… Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(212229,5896,'vi','Táº¥t cáº£ SÃ©c chÆ°a Ä‘á»•i thÃ nh tiá»n máº·t & thanh toÃ¡n qua ACH',0),(212230,5896,'af','Totale Ongedeponeerde Tjeks en ACH Betalings',0),(212231,5896,'ro','Total Uncashed controale ÅŸi plÄƒÅ£ile de ACH',0),(212232,5896,'et','Uncashed kontrolli ja ACH vÃ¤ljamaksed kokku',0),(212233,5896,'si','Skupaj Uncashed pregledov in ACH plaÄila',0),(212234,5896,'ba','Total Uncashed cek dan pembayaran ACH',0),(212235,5896,'nl','Totale Uncashed controles en ACH-betalingen',0),(212236,5896,'fi','Uncashed tarkastuksia ja ACH maksut yhteensÃ¤',0),(212237,5896,'no','Totalt uinnlÃ¸ste sjekker og ACH betalinger',0),(212238,5896,'da','Samlede uindlÃ¸ste Checks og ACH betalinger',0),(212239,5896,'ko','ì´ í˜„ê¸ˆí™” ê²€ì‚¬ ë° ACH ì§€ë¶ˆ',0),(212240,5896,'he','×¡×” ×› ×‘×“×™×§×•×ª Uncashed, ACH ×ª×©×œ×•×ž×™×',0),(212241,5896,'el','Î£ÏÎ½Î¿Î»Î¿ Uncashed ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ ÎºÎ±Î¹ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ ACH',0),(212242,5896,'zh','æ€»è®¡æœªå…‘çŽ°çš„æ”¯ç¥¨å’Œè‡ªåŠ¨äº¤æ˜“æ‰€æ”¯ä»˜\r\n',0),(212243,5896,'sv','Totalt gÃ¤llde outlÃ¶sta kontroller och ACH-betalningar',0),(212244,5896,'it','Totale assegno assegni e pagamenti ACH',0),(212245,5896,'tl','',0),(212246,5896,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3648;&#3594;&#3655;&#3588;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604; &#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#',0),(212247,5896,'hi','à¤¬à¤¿à¤¨à¤¾ à¤­à¥à¤¨à¤¾à¤¯à¤¾ à¤œà¤¾à¤‚à¤š à¤”à¤° ACH à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚ à¤•à¥à¤²',0),(212248,5896,'ms','Jumlah Uncashed pemeriksaan dan pembayaran men',0),(212249,5896,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø´ÙŠÙƒØ§Øª Ù„Ù‡Ø§ ÙˆØ§Ù„Ø¯ÙØ¹ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(212250,5896,'fr','Total des chÃ¨ques non encaissÃ©s et les paiements de l\'ACH',0),(212251,5896,'jp','æœªæ?›é‡‘ã?®å°?åˆ‡æ‰‹ã?¨ACHæ”¯æ‰•ã?®ç·?é¡?',0),(212252,5896,'pt','Total contracheques cheques e pagamentos de ACH',0),(212253,5896,'ru','Ð’ÑÐµÐ³Ð¾ Ð½ÐµÐ¾Ð±Ð½Ð°Ð»Ð¸Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ñ‡ÐµÐºÐ¾Ð² Ð¸ ACH Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(212254,5896,'es','Total Cheques no Cambiados y Pagos de ACH',0),(212255,5896,'de','Total unused Kontrollen und ACH-Zahlungen',0),(212256,5896,'en','Total Uncashed Checks and ACH Payments',0),(212257,5897,'is','',0),(212258,5897,'dr','Ú†Ùƒ Ù‡Ø§ÙŠ Ù†Ù‚Ø¯ Ù†Ø´Ø¯Ù‡ Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡ ',0),(212259,5897,'pr','Ú†Ùƒ Ù‡Ø§ÙŠ Ù†Ù‚Ø¯ Ù†Ø´Ø¯Ù‡ Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡ ',0),(212260,5897,'tr','Uncashed denetler ve ACH Ã¶demeler',0),(212261,5897,'pl','Uncashed Los kontroli i pÅ‚atnoÅ›ci ACH',0),(212262,5897,'bg','ÐÐµÐºÐ°ÑÐ¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¸ ACH Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(212263,5897,'ur','Ø§Ù†Ú©Ø§Ø´Ø§Ø¯ Ú†ÛŒÚ© Ø§ÙˆØ± Ø§Ú† Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(212264,5897,'sr','Ð£Ð½Ñ†Ð°ÑÑ…ÐµÐ´ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð¸ ÐÑ… Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(212265,5897,'vi','SÃ©c khÃ´ng Ä‘á»•i thÃ nh tiá»n máº·t & thanh toÃ¡n qua ACH',0),(212266,5897,'af','Ongewisselde Tjeks en ACH Betalings',0),(212267,5897,'ro','Uncashed controale ÅŸi plÄƒÅ£ile de ACH',0),(212268,5897,'et','Uncashed kontrolli ja ACH maksed',0),(212269,5897,'si','Uncashed pregledov in ACH plaÄila',0),(212270,5897,'ba','Uncashed cek dan pembayaran ACH',0),(212271,5897,'nl','Uncashed controles en ACH-betalingen',0),(212272,5897,'fi','Uncashed tarkastuksia ja ACH maksujen',0),(212273,5897,'no','UinnlÃ¸ste sjekker og ACH betalinger',0),(212274,5897,'da','UindlÃ¸ste Checks og ACH betalinger',0),(212275,5897,'ko','í˜„ê¸ˆí™” ìˆ˜ í‘œ, ACH ì§€ë¶ˆ',0),(212276,5897,'he','×‘×“×™×§×•×ª uncashed, ACH ×ª×©×œ×•×ž×™×',0),(212277,5897,'el','Uncashed ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ ÎºÎ±Î¹ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ ACH',0),(212278,5897,'zh','æœªå…‘çŽ°çš„æ”¯ç¥¨å’Œè‡ªåŠ¨äº¤æ¢æ‰€æ”¯ä»˜\r\n',0),(212279,5897,'sv','GÃ¤llde outlÃ¶sta kontroller och ACH-betalningar',0),(212280,5897,'it','Assegno assegni e pagamenti ACH',0),(212281,5897,'tl','',0),(212282,5897,'th','&#3648;&#3594;&#3655;&#3588;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604; &#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632; ACH ',0),(212283,5897,'hi','à¤¬à¤¿à¤¨à¤¾ à¤­à¥à¤¨à¤¾à¤¯à¤¾ à¤œà¤¾à¤‚à¤š à¤”à¤° ACH à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(212284,5897,'ms','Uncashed pemeriksaan dan pembayaran men',0),(212285,5897,'ar','Ø§Ù„Ø´ÙŠÙƒØ§Øª Ù„Ù‡Ø§ ÙˆØ§Ù„Ø¯ÙØ¹ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(212286,5897,'fr','Les chÃ¨ques non encaissÃ©s et les paiements de l\'ACH',0),(212287,5897,'jp','æœªæ?›é‡‘ã?®å°?åˆ‡æ‰‹ã?¨ACHæ”¯æ‰•',0),(212288,5897,'pt','Contracheques cheques e pagamentos de ACH',0),(212289,5897,'ru','ÐÐµÐ¾Ð±Ð½Ð°Ð»Ð¸Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ñ‡ÐµÐºÐ¾Ð² Ð¸ ACH Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(212290,5897,'es','Cheques no Cambiados y Pagos de ACH',0),(212291,5897,'de','Unused Kontrollen und ACH-Zahlungen',0),(212292,5897,'en','Uncashed Checks and ACH Payments',0),(212293,5898,'is','',0),(212294,5898,'dr','ØµÙˆØ±Øª Ù…ØºØ§ÙŠØ±Øª Ø¨Ø§Ù†Ùƒ',0),(212295,5898,'pr','ØµÙˆØ±Øª Ù…ØºØ§ÙŠØ±Øª Ø¨Ø§Ù†Ùƒ',0),(212296,5898,'tr','Banka mutabakatÄ±',0),(212297,5898,'pl','Uzgodnienia bankowego',0),(212298,5898,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð° ÑÑŠÐ¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(212299,5898,'ur','Ø¨ÛŒÙ†Ú© Ù…ÙØ§ÛÙ…Øª',0),(212300,5898,'sr','Ð¡Ñ€Ð°Ð²ÑšÐµÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(212301,5898,'vi','CÃ¢n Ä‘á»‘i TK ngÃ¢n hÃ ng',0),(212302,5898,'af','Bank Rekonsiliasie',0),(212303,5898,'ro','Reconcilierea bancarÄƒ',0),(212304,5898,'et','Panga vastavusseviimine',0),(212305,5898,'si','Usklajevanje banÄnega raÄuna',0),(212306,5898,'ba','Rekonsiliasi Bank',0),(212307,5898,'nl','Verzoening van de Bank',0),(212308,5898,'fi','Pankkitilin tÃ¤smÃ¤ytys',0),(212309,5898,'no','Bankavstemming',0),(212310,5898,'da','Bankafstemning',0),(212311,5898,'ko','ì€í–‰ ì¡°ì •',0),(212312,5898,'he','×”×ª××ž×ª ×‘× ×§',0),(212313,5898,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Ï',0),(212314,5898,'zh','é“¶è¡Œå¯¹å¸\r\n',0),(212315,5898,'sv','BankavstÃ¤mning',0),(212316,5898,'it','Riconciliazione bancaria',0),(212317,5898,'tl','',0),(212318,5898,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3609;&#3637;&#3611;&#3619;&#3632;&#3609;&#3629;&#3617;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(212319,5898,'hi','à¤¬à¥ˆà¤‚à¤• à¤®à¤¿à¤²à¤¾à¤¨',0),(212320,5898,'ms','Penyata penyesuaian Bank',0),(212321,5898,'ar','ØªØ³ÙˆÙŠÙ‘Ø§Øª Ø§Ù„Ù…ØµØ§Ø±Ù',0),(212322,5898,'fr','Rapprochement bancaire',0),(212323,5898,'jp','éŠ€è¡Œèª¿æ•´',0),(212324,5898,'pt','ReconciliaÃ§Ã£o bancÃ¡ria',0),(212325,5898,'ru','Ð’Ñ‹Ð²ÐµÑ€ÐºÐ° Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(212326,5898,'es','ConciliaciÃ³n Bancaria',0),(212327,5898,'de','Bank VersÃ¶hnung',0),(212328,5898,'en','Bank Reconciliation',0),(212329,5899,'is','',0),(212330,5899,'dr','ÙƒØ§Ø± Ø¨Ø±Ú¯ ØµÙˆØ±Øª Ù…ØºØ§ÙŠØ±Øª Ø¨Ø§Ù†Ùƒ',0),(212331,5899,'pr','ÙƒØ§Ø± Ø¨Ø±Ú¯ ØµÙˆØ±Øª Ù…ØºØ§ÙŠØ±Øª Ø¨Ø§Ù†Ùƒ',0),(212332,5899,'tr','Banka mutabakatÄ± Ã§alÄ±ÅŸma sayfasÄ±',0),(212333,5899,'pl','Bank pojednania arkusza',0),(212334,5899,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð° ÑÑŠÐ¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð»Ð¸ÑÑ‚',0),(212335,5899,'ur','Ø¨ÛŒÙ†Ú© Ù…ÙØ§ÛÙ…Øª Ù‚Ø±Ø·Ø§Ø³ Ú©Ø§Ø±',0),(212336,5899,'sr','Ð‘Ð°Ð½ÐºÐ° Ð¿Ð¾Ð¼Ð¸Ñ€ÐµÑšÐµ Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð»Ð¸ÑÑ‚Ð°',0),(212337,5899,'vi','Trang cÃ¢n Ä‘á»‘i TK ngÃ¢n hÃ ng',0),(212338,5899,'af','Bank Rekonsiliasie Werkstaat',0),(212339,5899,'ro','Banca reconciliere a foii de lucru',0),(212340,5899,'et','Panga vastavusseviimise tÃ¶Ã¶leht',0),(212341,5899,'si','BanÄnega usklajevanja delovnega lista',0),(212342,5899,'ba','Bank rekonsiliasi Worksheet',0),(212343,5899,'nl','Bank verzoening werkblad',0),(212344,5899,'fi','Pankki sovinnon laskentataulukon',0),(212345,5899,'no','Bank avstemming regneark',0),(212346,5899,'da','Bank forsoning regneark',0),(212347,5899,'ko','ì€í–‰ í™”í•´ ì›Œí¬ì‹œíŠ¸',0),(212348,5899,'he','×”×‘× ×§ ×¤×™×•×¡ ×’×œ×™×•×Ÿ ×¢×‘×•×“×”',0),(212349,5899,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÏƒÏ…Î¼Ï†Î¹Î»Î¯Ï‰ÏƒÎ· Ï†ÏÎ»Î»Î¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(212350,5899,'zh','é“¶è¡Œå¯¹å¸è¡¨\r\n',0),(212351,5899,'sv','Bank fÃ¶rsoning kalkylblad',0),(212352,5899,'it','Il foglio di lavoro di banca riconciliazione',0),(212353,5899,'tl','',0),(212354,5899,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3609;&#3637;&#3611;&#3619;&#3632;&#3609;&#3629;&#3617;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(212355,5899,'hi','à¤¬à¥ˆà¤‚à¤• à¤¸à¥à¤²à¤¹ à¤•à¤¾à¤°à¥à¤¯à¤ªà¤¤à¥à¤°à¤•',0),(212356,5899,'ms','Lembaran kerja Penyata penyesuaian Bank',0),(212357,5899,'ar','ÙˆØ±Ù‚Ø© Ø¹Ù…Ù„ ØªØ³ÙˆÙŠØ© Ø§Ù„Ù…ØµØ±Ù',0),(212358,5899,'fr','Feuille de travail rapprochement bancaire',0),(212359,5899,'jp','éŠ€è¡Œå‹˜å®šèª¿æ•´ãƒ¯ãƒ¼ã‚¯ã‚·ãƒ¼ãƒˆ',0),(212360,5899,'pt','Planilha de ConciliaÃ§Ã£o bancÃ¡ria',0),(212361,5899,'ru','Ð‘Ð°Ð½Ðº Ð¿Ñ€Ð¸Ð¼Ð¸Ñ€ÐµÐ½Ð¸ÑŽ Ð»Ð¸ÑÑ‚',0),(212362,5899,'es','ConciliaciÃ³n Bancaria Hoja de Trabajo',0),(212363,5899,'de','Bankabstimmungs-Arbeitsblatt',0),(212364,5899,'en','Bank Reconciliation Worksheet',0),(212365,5900,'is','',0),(212366,5900,'dr','Ø­Ø³Ø§Ø¨ ',0),(212367,5900,'pr','Ø­Ø³Ø§Ø¨ ',0),(212368,5900,'tr','Acct',0),(212369,5900,'pl','Acct',0),(212370,5900,'bg','Acct',0),(212371,5900,'ur','Ø§Ú©Ú©Ù¹',0),(212372,5900,'sr','ÐÑ†Ñ†Ñ‚',0),(212373,5900,'vi','TK',0),(212374,5900,'af','Rek',0),(212375,5900,'ro','Acct',0),(212376,5900,'et','ACCT',0),(212377,5900,'si','Acct',0),(212378,5900,'ba','Acct',0),(212379,5900,'nl','Acct',0),(212380,5900,'fi','Acct',0),(212381,5900,'no','Acct',0),(212382,5900,'da','Acct',0),(212383,5900,'ko','Acct',0),(212384,5900,'he','×—×©×‘×•×Ÿ',0),(212385,5900,'el','Î›Î¿Î³Î±Ï',0),(212386,5900,'zh','ä¼šè®¡\r\n',0),(212387,5900,'sv','Acct',0),(212388,5900,'it','Acct',0),(212389,5900,'tl','',0),(212390,5900,'th','&#3610;&#3633;&#3597;&#3594;&#3637;',0),(212391,5900,'hi','Acct',0),(212392,5900,'ms','Acct',0),(212393,5900,'ar','Acct',0),(212394,5900,'fr','Compte',0),(212395,5900,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(212396,5900,'pt','ACCT',0),(212397,5900,'ru','Acct',0),(212398,5900,'es','Cuenta',0),(212399,5900,'de','Acct',0),(212400,5900,'en','Acct',0),(212401,5901,'is','',0),(212402,5901,'dr','( Ø³Ù¾Ø±Ø¯Ù‡ Ú¯Ø°Ø§Ø´ØªÙ† )  Ø¨Ù‡ ',0),(212403,5901,'pr','Ø°Ø®ÙŠØ±Ù‡ Ú©Ø±Ø¯Ù† ( Ø³Ù¾Ø±Ø¯Ù‡ Ú¯Ø°Ø§Ø´ØªÙ† )  Ø¨Ù‡ ',0),(212404,5901,'tr','Ä°Ã§in mevduat',0),(212405,5901,'pl','WpÅ‚aty na',0),(212406,5901,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð·Ð°',0),(212407,5901,'ur','Ú©Ùˆ Ø±ÙˆÚ©Ù†Û’ Ú©ÛŒ Ø¬Ù…Ø¹',0),(212408,5901,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð·Ð°',0),(212409,5901,'vi','Äáº·t cá»c tá»›i',0),(212410,5901,'af','Deposito te',0),(212411,5901,'ro','Depuneri Ã®n',0),(212412,5901,'et','Tagatisraha',0),(212413,5901,'si','Deponiranje na',0),(212414,5901,'ba','Deposit',0),(212415,5901,'nl','Storten op',0),(212416,5901,'fi','Tallettaa',0),(212417,5901,'no','Sette inn',0),(212418,5901,'da','Indbetaling til',0),(212419,5901,'ko','ë³´ì¦ê¸ˆì„',0),(212420,5901,'he','×œ×”×¤×§×™×“ ××ª',0),(212421,5901,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÏ„Î¿',0),(212422,5901,'zh','å­˜å…¥\r\n',0),(212423,5901,'sv','InsÃ¤ttning pÃ¥',0),(212424,5901,'it','Depositi al',0),(212425,5901,'tl','',0),(212426,5901,'th','&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3652;&#3611;&#3606;&#3638;&#3591;',0),(212427,5901,'hi','à¤œà¤®à¤¾ à¤•à¤°à¤¨à¥‡',0),(212428,5901,'ms','Deposit untuk',0),(212429,5901,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø¥Ù„Ù‰',0),(212430,5901,'fr','Effectuer un dÃ©pÃ´t sur',0),(212431,5901,'jp','ï½žã?®é ?ã‚Šé‡‘',0),(212432,5901,'pt','DepÃ³sito para',0),(212433,5901,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(212434,5901,'es','DepÃ³sito A',0),(212435,5901,'de','Einzahlen',0),(212436,5901,'en','Deposit To',0),(212437,5902,'is','',0),(212438,5902,'dr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ ',0),(212439,5902,'pr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ ',0),(212440,5902,'tr','Ã‡ek numarasÄ±',0),(212441,5902,'pl','SprawdÅº numer',0),(212442,5902,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€',0),(212443,5902,'ur','Ù†Ù…Ø¨Ø± Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(212444,5902,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ‡ÐµÐºÐ°',0),(212445,5902,'vi','Sá»‘ SÃ©c',0),(212446,5902,'af','Tjeknommer',0),(212447,5902,'ro','VerificaÅ£i numÄƒrul',0),(212448,5902,'et','TÅ¡eki Number',0),(212449,5902,'si','Preverite Å¡tevilko',0),(212450,5902,'ba','Cek nomor',0),(212451,5902,'nl','Nummer van cheque',0),(212452,5902,'fi','Sekin numero',0),(212453,5902,'no','Sjekknummer',0),(212454,5902,'da','Checknummer',0),(212455,5902,'ko','ìˆ˜ í‘œ ë²ˆí˜¸',0),(212456,5902,'he','×ž×¡×¤×¨ ×”×©×™×§',0),(212457,5902,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(212458,5902,'zh','æ”¯ç¥¨å·ç \r\n',0),(212459,5902,'sv','Checknummer',0),(212460,5902,'it','Controllare il numero',0),(212461,5902,'tl','',0),(212462,5902,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&#3588;',0),(212463,5902,'hi','à¤¨à¤‚à¤¬à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(212464,5902,'ms','Semak nombor',0),(212465,5902,'ar','Ø±Ù‚Ù… Ø§Ù„ØµÙƒ',0),(212466,5902,'fr','NumÃ©ro de chÃ¨que',0),(212467,5902,'jp','å°?åˆ‡æ‰‹ç•ªå?·',0),(212468,5902,'pt','NÃºmero do cheque',0),(212469,5902,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð§ÐµÐºÐ°',0),(212470,5902,'es','Cheque NÃºmero',0),(212471,5902,'de','Schecknummer',0),(212472,5902,'en','Check Number',0),(212473,5903,'is','',0),(212474,5903,'dr','( Ù…Ø´Ø±ÙˆØ·',0),(212475,5903,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¹ÙˆÙ‚( Ù…Ø´Ø±ÙˆØ·',0),(212476,5903,'tr','Bekleyen Mkt.',0),(212477,5903,'pl','IloÅ›Ä‡ czasu',0),(212478,5903,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð¾',0),(212479,5903,'ur','Ù‚ÛŒ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(212480,5903,'sr','ÐšÐ¾Ð» Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(212481,5903,'vi','Sá»‘ lÆ°á»£ng Ä‘ang treo',0),(212482,5903,'af','Hoev. Afwagtend',0),(212483,5903,'ro','Cantit Ã®n aÅŸteptarea',0),(212484,5903,'et','Kogus kuni',0),(212485,5903,'si','KoliÄina do',0),(212486,5903,'ba','Qty tertunda',0),(212487,5903,'nl','Aantal in afwachting van',0),(212488,5903,'fi','MÃ¤Ã¤rÃ¤ ennen',0),(212489,5903,'no','Antall ventende',0),(212490,5903,'da','Antal ventende',0),(212491,5903,'ko','ë³´ë¥˜ ì¤‘ì¸ ìˆ˜ëŸ‰',0),(212492,5903,'he','×›×ž×•×ª ×ž×ž×ª×™× ×™×',0),(212493,5903,'el','Qty ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î®',0),(212494,5903,'zh','æ•°é‡å¾…å®š\r\n',0),(212495,5903,'sv','Antal vÃ¤ntande',0),(212496,5903,'it','Qty in sospeso',0),(212497,5903,'tl','',0),(212498,5903,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(212499,5903,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤²à¤‚à¤¬à¤¿à¤¤',0),(212500,5903,'ms','Qty yang belum selesai',0),(212501,5903,'ar','Qty Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(212502,5903,'fr','QtÃ© en attendant',0),(212503,5903,'jp','ä¿?ç•™ä¸­æ•°é‡?',0),(212504,5903,'pt','Qtde pendente',0),(212505,5903,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð´Ð¾',0),(212506,5903,'es','Cant. Pendiente',0),(212507,5903,'de','Qty ausstehende',0),(212508,5903,'en','Qty Pending',0),(212509,5904,'is','',0),(212510,5904,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯ Ø¯Ø±Ø¢Ù…Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(212511,5904,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯ Ø¯Ø±Ø¢Ù…Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(212512,5904,'tr','Yeni gelir kayÄ±tlarÄ± alÄ±n',0),(212513,5904,'pl','Importuj nowe rekordy dochodÃ³w',0),(212514,5904,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð´Ð¾Ñ…Ð¾Ð´ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(212515,5904,'ur','Ø¢Ù…Ø¯Ù†ÛŒ Ú©Û’ Ù†Ø¦Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(212516,5904,'sr','Ð£Ð²ÐµÐ·Ð¸ Ð½Ð¾Ð²Ðµ Ð·Ð°Ð¿Ð¸ÑÐµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(212517,5904,'vi','Nháº­p nhá»¯ng loáº¡i doanh thu má»›i',0),(212518,5904,'af','Invoer van Nuwe Inkomste Rekords',0),(212519,5904,'ro','ImportaÈ›i Ã®nregistrÄƒrile noi venituri',0),(212520,5904,'et','Impordi uus tulude arvestust',0),(212521,5904,'si','Uvozite nove zapise, dohodek',0),(212522,5904,'ba','Mengimpor data pendapatan baru',0),(212523,5904,'nl','Nieuwe inkomen Records importeren',0),(212524,5904,'fi','Uusi tulot tietueiden tuominen',0),(212525,5904,'no','Nye inntekt oppfÃ¸ringer',0),(212526,5904,'da','Importere nye indkomst poster',0),(212527,5904,'ko','ìƒˆë¡œìš´ ì†Œë“ ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(212528,5904,'he','×™×™×‘×•× ×¨×©×•×ž×•×ª ×”×›× ×¡×•×ª ×—×“×©×•×ª',0),(212529,5904,'el','ÎÎ­ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î•Î¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(212530,5904,'zh','å¯¼å…¥æ–°çš„æ”¶å…¥çºªå½•\r\n',0),(212531,5904,'sv','Importera nya inkomst poster',0),(212532,5904,'it','Importare nuovi record di reddito',0),(212533,5904,'tl','',0),(212534,5904,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3651;&#3627;&#3617;&#3656;',0),(212535,5904,'hi','à¤†à¤¯à¤¾à¤¤ à¤¨à¤ à¤†à¤¯ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸',0),(212536,5904,'ms','Rekod pendapatan baru import',0),(212537,5904,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø¯Ø®Ù„ Ø¬Ø¯ÙŠØ¯Ø©',0),(212538,5904,'fr','Importer les nouveaux revenus Records',0),(212539,5904,'jp','æ–°è¦?å?Žå…¥è¨˜éŒ²ã?®ã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆ',0),(212540,5904,'pt','Importar novos registros de renda',0),(212541,5904,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð½Ð¾Ð²Ñ‹Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð²',0),(212542,5904,'es','Importar Records Nuevos Ingresos',0),(212543,5904,'de','Neue Einkommen DatensÃ¤tze importieren',0),(212544,5904,'en','Import New Income Records',0),(212545,5905,'is','',0),(212546,5905,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª  Ø¨ÛŒØ´ Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯ ',0),(212547,5905,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª  Ø¨ÛŒØ´ Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯ ',0),(212548,5905,'tr','Servis sipariÅŸlerini tahmini Ã¼zerine',0),(212549,5905,'pl','Zlecenia serwisowe na szacunek',0),(212550,5905,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð´ Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(212551,5905,'ur','Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ø§Ù†Ø¯Ø§Ø²Û’',0),(212552,5905,'sr','ÐÐ°Ð»Ð¾Ð·Ð¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ Ð¿Ñ€ÐµÐºÐ¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°',0),(212553,5905,'vi','ÄÆ¡n hÃ ng dá»‹ch vá»¥ quÃ¡ dá»± trÃ¹',0),(212554,5905,'af','Diensbestelling wat Kwotasie Oorskry',0),(212555,5905,'ro','Comenzi de service asupra estimare',0),(212556,5905,'et','Hooldustellimuste jooksul hinnangu',0),(212557,5905,'si','Servisne naloge ocenjeni',0),(212558,5905,'ba','Layanan pesanan lebih dari perkiraan',0),(212559,5905,'nl','Serviceorders Over schatting',0),(212560,5905,'fi','Huoltotilausten arvion',0),(212561,5905,'no','Serviceordrer Over anslag',0),(212562,5905,'da','Serviceordrer Over skÃ¸n',0),(212563,5905,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ê²¬ì ì„ í†µí•´',0),(212564,5905,'he','×”×–×ž× ×•×ª ×©×™×¨×•×ª ×ž×¢×œ ×”××•×ž×“×Ÿ',0),(212565,5905,'el','Î•Î½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï… ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ·',0),(212566,5905,'zh','é«˜ä¼°æœåŠ¡è®¢å•\r\n',0),(212567,5905,'sv','Serviceorder Ã¶ver uppskattningen',0),(212568,5905,'it','Servizio ordini superiori stima',0),(212569,5905,'tl','',0),(212570,5905,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3648;&#3585;&#3636;&#3609;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;',0),(212571,5905,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶',0),(212572,5905,'ms','Perkhidmatan Tempahan lebih dari anggaran',0),(212573,5905,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© Ø¹Ù„Ù‰ Ù…Ø¯Ù‰ ØªÙ‚Ø¯ÙŠØ±',0),(212574,5905,'fr','Commandes de service au cours de l\'estimation',0),(212575,5905,'jp','è¦‹ç©?ã‚‚ã‚Šè¶…é?Žã?®ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡',0),(212576,5905,'pt','Ordens de serviÃ§o sobre a estimativa',0),(212577,5905,'ru','Ð¡ÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð·Ð° Ð¾Ñ†ÐµÐ½ÐºÑƒ',0),(212578,5905,'es','Ordenes de Servicio MÃ¡s que los Estimados',0),(212579,5905,'de','Service-AuftrÃ¤ge Ã¼ber geschÃ¤tzte',0),(212580,5905,'en','Service Orders Over Estimate',0),(212581,5906,'is','',0),(212582,5906,'dr','/ Ø§Ø±Ø³Ø§Ù„  Ø²Ù…Ø§Ù†  ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø¯Ù…Ø§Øª',0),(212583,5906,'pr','ÙˆÙŠØ±Ø§ÙŠØ´  / Ø§Ø±Ø³Ø§Ù„  Ø²Ù…Ø§Ù†  Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(212584,5906,'tr','Servis sipariÅŸ DÃ¼zenle/mesaj zamanÄ±',0),(212585,5906,'pl','Czas edycji/Post zamÃ³wienie usÅ‚ugi',0),(212586,5906,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ð²Ñ€ÐµÐ¼Ðµ',0),(212587,5906,'ur','Ø®Ø¯Ù…Øª ØªØ±ØªÛŒØ¨ ØªØ¯ÙˆÛŒÙ†/Ù¾ÙˆØ³Ù¹ Ø¨Ø§Ø±',0),(212588,5906,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð£Ñ€ÐµÐ´Ð¸/ÐŸÐ¾ÑÑ‚ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(212589,5906,'vi','Chá»‰nh Sá»­a/ÄÄƒng Thá»i Gian ÄÆ¡n HÃ ng Dá»‹ch Vá»¥',0),(212590,5906,'af','Diens Bestelling Redigeer/Pos Tyd',0),(212591,5906,'ro','Serviciu comanda Edit/Post timp',0),(212592,5906,'et','Teenuse tellimuse Edit/Post aeg',0),(212593,5906,'si','Servisni nalog Edit/Post Äas',0),(212594,5906,'ba','Waktu layanan pesanan Edit posting',0),(212595,5906,'nl','Service bewerken/Post Ordertijd',0),(212596,5906,'fi','Muokkaa/Post aikaa',0),(212597,5906,'no','Tjenesten Ordretidspunkt Rediger/Post',0),(212598,5906,'da','Service Ordretidspunkt Edit/indlÃ¦g',0),(212599,5906,'ko','ì„œë¹„ìŠ¤ ìˆœì„œ íŽ¸ì§‘/ê²Œì‹œ ì‹œê°„',0),(212600,5906,'he','×–×ž×Ÿ ×¢×¨×™×›×”/×¨×™×©×•× ×”×–×ž× ×ª ×©×™×¨×•×ª',0),(212601,5906,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± ÏŽÏÎ± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚/Î¸Î­ÏƒÎ·',0),(212602,5906,'zh','æœåŠ¡å‘½ä»¤ç¼–è¾‘/å‘å¸ƒæ—¶é—´\r\n',0),(212603,5906,'sv','Service bestÃ¤llning Redigera/Post tid',0),(212604,5906,'it','Servizio ordine Edit/Post tempo',0),(212605,5906,'tl','',0),(212606,5906,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;/&#3648;&#3623;&#3621;&#3634;&#3611;&#3619;&#3632;&#3585;&#3634;&#3624;',0),(212607,5906,'hi','à¤¸à¤°à¥à¤µà¤¿à¤¸ à¤•à¥à¤°à¤® à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚/à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¸à¤®à¤¯',0),(212608,5906,'ms','Waktu Edit Post pesanan Perkhidmatan',0),(212609,5906,'ar','Ø²Ù…Ù† ØªØ­Ø±ÙŠØ±/ÙˆØ¸ÙŠÙØ© Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(212610,5906,'fr','Heure de service commande Edit/Post',0),(212611,5906,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ç·¨é›†/è¨ˆä¸Šæ™‚é–“',0),(212612,5906,'pt','Tempo de Edit/Post de ordem de serviÃ§o',0),(212613,5906,'ru','Ð’Ñ€ÐµÐ¼Ñ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð° Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ/Ð¿Ð¾ÑÑ‚',0),(212614,5906,'es','Orden de Servicio Editar/Asentar Tiempo',0),(212615,5906,'de','Bestellung bearbeiten/Post-Service-Zeit',0),(212616,5906,'en','Service Order Edit/Post Time',0),(212617,5907,'is','',0),(212618,5907,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(212619,5907,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(212620,5907,'tr','Servis sipariÅŸi kurulumlarÄ±',0),(212621,5907,'pl','Konfiguracje zamÃ³wienia usÅ‚ugi',0),(212622,5907,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(212623,5907,'ur','Ø®Ø¯Ù…Øª ØªØ±ØªÛŒØ¨ Ø³ÛŒÙ¹Ùˆ',0),(212624,5907,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐ° Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(212625,5907,'vi','Setup ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(212626,5907,'af','Diensbestelling Opstellings',0),(212627,5907,'ro','Setari de comandÄƒ service',0),(212628,5907,'et','Teenuse tellimuse seadistuse',0),(212629,5907,'si','Servisni nalog postavitve',0),(212630,5907,'ba','Layanan pesanan setup',0),(212631,5907,'nl','Service Order Setups',0),(212632,5907,'fi','Palvelun tilauksen asetukset',0),(212633,5907,'no','Tjenesten for oppsett',0),(212634,5907,'da','Tjenesten Order opsÃ¦tninger',0),(212635,5907,'ko','ì„œë¹„ìŠ¤ ìˆœì„œ ì„¤ì •',0),(212636,5907,'he','×©×™×¨×•×ª ×”×–×ž× ×ª ×›×™×•×•× ×•× ×™×',0),(212637,5907,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚',0),(212638,5907,'zh','æœåŠ¡è®¢å•æ•´å¤‡\r\n',0),(212639,5907,'sv','Service bestÃ¤llning uppstÃ¤llningar',0),(212640,5907,'it','Configurazioni di ordine di servizio',0),(212641,5907,'tl','',0),(212642,5907,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(212643,5907,'hi','à¤¸à¤°à¥à¤µà¤¿à¤¸ à¤•à¥à¤°à¤® Setups',0),(212644,5907,'ms','Perkhidmatan perintah Setups',0),(212645,5907,'ar','Ø®Ø¯Ù…Ø© ØªØ±ØªÙŠØ¨ Ø§Ù„Ø£Ø¬Ù‡Ø²Ø©',0),(212646,5907,'fr','Configurations de commande de service',0),(212647,5907,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(212648,5907,'pt','ConfiguraÃ§Ãµes de ordem de serviÃ§o',0),(212649,5907,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(212650,5907,'es','Configuraciones de Ordenes de Servicio',0),(212651,5907,'de','Service-Auftrag-Setups',0),(212652,5907,'en','Service Order Setups',0),(212653,5908,'is','',0),(212654,5908,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ù…Ù‚Ø¯Ø§Ø± Ù†Ù…Ø§ÙŠØ´ ',0),(212655,5908,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ù…Ù‚Ø¯Ø§Ø± Ù†Ù…Ø§ÙŠØ´ ',0),(212656,5908,'tr','Minimum ekran miktarÄ±',0),(212657,5908,'pl','WyÅ›wietlania minimalnej iloÅ›ci',0),(212658,5908,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð´Ð¸ÑÐ¿Ð»ÐµÐ¹ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(212659,5908,'ur','ÚˆØ³Ù¾Ù„Û’ Ú©ÛŒ Ú©Ù… Ø³Û’ Ú©Ù… Ù…Ù‚Ø¯Ø§Ø±',0),(212660,5908,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(212661,5908,'vi','Sá»‘ lÆ°á»£ng hiá»ƒn thá»‹ Tá»‘i thiá»ƒu',0),(212662,5908,'af','Wys Minimum Hoeveelheid',0),(212663,5908,'ro','Cantitatea minimÄƒ de afiÅŸare',0),(212664,5908,'et','Minimaalne Kuva kogus',0),(212665,5908,'si','Minimalen izloÅ¾ba koliÄina',0),(212666,5908,'ba','Kuantitas minimum tampilan',0),(212667,5908,'nl','Minimale Display hoeveelheid',0),(212668,5908,'fi','VÃ¤hintÃ¤Ã¤n nÃ¤yttÃ¶ mÃ¤Ã¤rÃ¤',0),(212669,5908,'no','Minste displayet antall',0),(212670,5908,'da','Minimum Display mÃ¦ngde',0),(212671,5908,'ko','ìµœì†Œ í‘œì‹œ ìˆ˜ëŸ‰',0),(212672,5908,'he','×›×ž×•×ª ×ž×™× ×™×ž×œ×™×ª',0),(212673,5908,'el','Î•Ï€Î¯Î´ÎµÎ¹Î¾Î· ÎµÎ»Î¬Ï‡Î¹ÏƒÏ„Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(212674,5908,'zh','æœ€å°æ˜¾ç¤ºé‡\r\n',0),(212675,5908,'sv','Minsta Display kvantitet',0),(212676,5908,'it','Visualizzazione minima quantitÃ ',0),(212677,5908,'tl','',0),(212678,5908,'th','&#3588;&#3640;&#3603;&#3616;&#3634;&#3614;&#3585;&#3634;&#3619;&#3649;&#3626;&#3604;&#3591;&#3612;&#3621;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(212679,5908,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(212680,5908,'ms','Kuantiti minimum paparan',0),(212681,5908,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(212682,5908,'fr','QuantitÃ© minimale d\'affichage',0),(212683,5908,'jp','è¡¨ç¤ºæœ€ä½Žæ•°é‡?',0),(212684,5908,'pt','Quantidade mÃ­nima de exposiÃ§Ã£o',0),(212685,5908,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ðµ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°ÐµÐ¼Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(212686,5908,'es','Cantidad de Exponer MÃ­nimo',0),(212687,5908,'de','Minimum Anzeige Menge',0),(212688,5908,'en','Minimum Display Quantity',0),(212689,5909,'is','',0),(212690,5909,'dr',':  ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³ Ø´Ù…Ø§Ø±Ø´ ÙƒÙ…ØªØ± Ø§Ø² Ø§ÙŠÙ† Ø³Ø·Ø­ Ø®Ø±ÙŠØ¯ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(212691,5909,'pr','Ø´Ø±Ø­ Ø­Ø¯Ø§Ù‚Ù„ Ù…Ù‚Ø¯Ø§Ø± Ù†Ù…Ø§ÙŠØ´:  ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø´Ù…Ø§Ø±Ø´ ÙƒÙ…ØªØ± Ø§Ø² Ø§ÙŠÙ† Ø³Ø·Ø­ Ø®Ø±ÙŠØ¯ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(212692,5909,'tr','AlÄ±ÅŸveriÅŸ sepeti Stok sayÄ±mlarÄ± bu dÃ¼zeyin altÄ±nda gÃ¶rÃ¼ntÃ¼lenmez.',0),(212693,5909,'pl','Spis liczy poniÅ¼ej tego poziomu nie pojawi siÄ™ w koszyku.',0),(212694,5909,'bg','ÐžÐ¿Ð¸ÑÐ° Ð±Ñ€Ð¾Ð¸ Ð¿Ð¾Ð´ Ñ‚Ð¾Ð²Ð° Ð½Ð¸Ð²Ð¾ Ð½ÑÐ¼Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½ Ð² ÐºÐ¾Ð»Ð¸Ñ‡ÐºÐ°Ñ‚Ð°.',0),(212695,5909,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Ù…Ø§Ø± Ø§Ø³ Ø³Ø·Ø­ Ú©Û’ Ù†ÛŒÚ†Û’ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ù…ÛŒÚº Ù†ÛÛŒÚº Ø¯Ú©Ú¾Ø§ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§ Û”',0),(212696,5909,'sr','Ð‘Ñ€Ð¾Ñ˜Ð¸ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¸ÑÐ¿Ð¾Ð´ Ð¾Ð²Ð¾Ð³ Ð½Ð¸Ð²Ð¾Ð° Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½Ð¸ Ñƒ ÐºÐ¾Ñ€Ð¿Ð¸ Ð·Ð° ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ñƒ.',0),(212697,5909,'vi','LÆ°á»£ng hÃ ng dÆ°á»›i má»©c nÃ y sáº½ khÃ´ng hiá»ƒn thá»‹ trong giá» hÃ ng',0),(212698,5909,'af','Voorraadstellings onder hierdie vlak sal nie gewys word in die \"shopping cart.\"',0),(212699,5909,'ro','Inventarul conteazÄƒ sub acest nivel nu va fi afiÅŸat Ã®n coÅŸul de cumpÄƒrÄƒturi.',0),(212700,5909,'et','Laoinventuuride allpool seda taset ei kuvata ostukorvi.',0),(212701,5909,'si','Zaloga Å¡teje pod to raven ne bo prikazan v nakupovalni voziÄek.',0),(212702,5909,'ba','Persediaan menghitung tingkat di bawah ini tidak akan ditampilkan di keranjang belanja.',0),(212703,5909,'nl','Inventaris graven onder dit niveau zal niet worden weergegeven in uw winkelwagentje.',0),(212704,5909,'fi','Inventointien alapuolelle ei nÃ¤ytetÃ¤ ostoskoriin.',0),(212705,5909,'no','Lageropptellinger under dette nivÃ¥et vil ikke vises i handlekurven.',0),(212706,5909,'da','LageroptÃ¦llinger under dette niveau vises ikke i indkÃ¸bskurven.',0),(212707,5909,'ko','ì´ ìˆ˜ì¤€ ì•„ëž˜ ìž¬ê³  ì¹´ìš´íŠ¸ ìž¥ë°”êµ¬ë‹ˆì— í‘œì‹œ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(212708,5909,'he','×¡×¤×™×¨×•×ª ×ž×œ××™ ×ž×ª×—×ª ×œ×¨×ž×” ×–×• ×œ× ×™×•×¦×’ ×œ×¢×’×œ×ª ×”×§× ×™×•×ª.',0),(212709,5909,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î¼ÎµÏ„ÏÎ¬ÎµÎ¹ ÎºÎ¬Ï„Ï‰ Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Î´ÎµÎ½ Î¸Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ ÏƒÏ„Î¿ ÎºÎ±Î»Î¬Î¸Î¹.',0),(212710,5909,'zh','åº“å­˜æŠ€æœ¯è‹¥ä½ŽäºŽè¿™ä¸ªæ°´å¹³å°†ä¸ä¼šæ˜¾ç¤ºåœ¨è´­ç‰©è½¦ã€‚\r\n',0),(212711,5909,'sv','Lagerinventeringsjournalen under denna nivÃ¥ kommer inte att visas i din kundvagn.',0),(212712,5909,'it','Conteggi di inventario sotto questo livello non verranno visualizzati nel carrello.',0),(212713,5909,'tl','',0),(212714,5909,'th','Inventory counts below this level will not be displayed in the shopping cart.',0),(212715,5909,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤®à¤¾à¤¯à¤¨à¥‡ à¤°à¤–à¤¤à¤¾ à¤¹à¥ˆ à¤‡à¤¸ à¤¸à¥à¤¤à¤° à¤¸à¥‡ à¤¨à¥€à¤šà¥‡ à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾à¥¤',0),(212716,5909,'ms','Tuduhan inventori di bawah peringkat ini tidak akan dipaparkan dalam troli membeli-belah.',0),(212717,5909,'ar','Ù„Ù† ÙŠØªÙ… Ø¹Ø±Ø¶ Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø£Ù‚Ù„ Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªÙˆÙ‰ ÙÙŠ Ø¹Ø±Ø¨Ø© Ø§Ù„ØªØ³ÙˆÙ‚.',0),(212718,5909,'fr','DÃ©nombrement des stocks au-dessous de ce niveau ne s\'affichera pas dans le panier.',0),(212719,5909,'jp','ã?“ã?®ãƒ¬ãƒ™ãƒ«ä»¥ä¸‹ã?®åœ¨åº«æ•°ã?¯ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°ã‚«ãƒ¼ãƒˆã?«è¡¨ç¤ºã?•ã‚Œã?¾ã?›ã‚“',0),(212720,5909,'pt','Contagens de inventÃ¡rio abaixo deste nÃ­vel nÃ£o serÃ£o exibidas no carrinho de compras.',0),(212721,5909,'ru','ÐžÐ¿Ð¸ÑÐ¸ Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð° Ð½Ð¸Ð¶Ðµ ÑÑ‚Ð¾Ð³Ð¾ ÑƒÑ€Ð¾Ð²Ð½Ñ Ð½Ðµ Ð±ÑƒÐ´ÐµÑ‚ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒÑÑ Ð² ÐºÐ¾Ñ€Ð·Ð¸Ð½Ðµ.',0),(212722,5909,'es','Conteos de inventario abajo de este nivel no serÃ¡n desplegados in el carrito de compras',0),(212723,5909,'de','Inventar zÃ¤hlt unterhalb dieses Niveaus werden nicht im Warenkorb angezeigt.',0),(212724,5909,'en','Inventory counts below this level will not be displayed in the shopping cart.',0),(212725,5910,'is','',0),(212726,5910,'dr','Ù†Ø§Ù…  ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(212727,5910,'pr','Ù†Ø§Ù…  ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(212728,5910,'tr','Kredi kartÄ± adÄ±',0),(212729,5910,'pl','Nazwa pierwszej karty kredytowej',0),(212730,5910,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¸Ð¼Ðµ',0),(212731,5910,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ù¾ÛÙ„Û’ Ú©Û’ Ù†Ø§Ù…',0),(212732,5910,'sr','ÐŸÑ€Ð²Ð¾ Ð¸Ð¼Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(212733,5910,'vi','TÃªn riÃªng cá»§a Tháº» tÃ­n dá»¥ng',0),(212734,5910,'af','Kredietkaart Voornaam',0),(212735,5910,'ro','Numele de primul Card de credit',0),(212736,5910,'et','Krediitkaardi eesnimi',0),(212737,5910,'si','Ime kreditne kartice',0),(212738,5910,'ba','Kartu nama',0),(212739,5910,'nl','Creditcard voornaam',0),(212740,5910,'fi','Luottokortin etunimi',0),(212741,5910,'no','Kredittkortet ditt fornavn',0),(212742,5910,'da','Kreditkort fornavn',0),(212743,5910,'ko','ì‹ ìš© ì¹´ë“œ ì´ë¦„',0),(212744,5910,'he','×©× ×¤×¨×˜×™ ×©×œ ×›×¨×˜×™×¡ ××©×¨××™',0),(212745,5910,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÏŒÎ½Î¿Î¼Î±',0),(212746,5910,'zh','ä¿¡ç”¨å¡åå­—\r\n',0),(212747,5910,'sv','Kreditkort fÃ¶rnamn',0),(212748,5910,'it','Nome carta di credito',0),(212749,5910,'tl','',0),(212750,5910,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3606;&#3639;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(212751,5910,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤®',0),(212752,5910,'ms','Nama pertama kad kredit',0),(212753,5910,'ar','Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(212754,5910,'fr','PrÃ©nom de carte de crÃ©dit',0),(212755,5910,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰å??',0),(212756,5910,'pt','Nome do primeiro cartÃ£o de crÃ©dito',0),(212757,5910,'ru','Ð˜Ð¼Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(212758,5910,'es','Tarjeta de CrÃ©dito Nombre',0),(212759,5910,'de','Kreditkarte-Vorname',0),(212760,5910,'en','Credit Card First Name',0),(212761,5911,'is','',0),(212762,5911,'dr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙØ±Ù…Ø§ÛŒØ´ Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯\" Ø¨Ø§Ø² ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨\" ØªØ§ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´ÙˆØ¯',0),(212763,5911,'pr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯\" Ø¨Ø§Ø² ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨\" ØªØ§ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´ÙˆØ¯',0),(212764,5911,'tr','Kredi kartÄ± baÅŸarÄ±lÄ± bir ÅŸekilde iÅŸlenir kadar bu sipariÅŸ iÃ§in Ã¶deme tipi \"Hesap AÃ§\" iÅŸaretlenir.',0),(212765,5911,'pl','Typ pÅ‚atnoÅ›ci dla tego zamÃ³wienia bÄ™dÄ… oznaczone \"OtwÃ³rz konto\" do karty kredytowej jest pomyÅ›lnie przetworzona.',0),(212766,5911,'bg','Ð’Ð¸Ð´Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ‰Ðµ Ð±ÑŠÐ´Ð°Ñ‚ Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ð¸ \"Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ°\" Ð´Ð¾ÐºÐ°Ñ‚Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ‚Ð° ÐºÐ°Ñ€Ñ‚Ð° Ðµ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(212767,5911,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø²ÛŒØ± Ø¹Ù…Ù„ Ù„Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Ø¬Ø¨ ØªÚ© Ú©Û Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù… \"Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ú¾ÙˆÙ„Ù†Ø§\" Ù†Ø´Ø§Ù† Ø²Ø¯ Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§ Û”',0),(212768,5911,'sr','Ð’Ñ€ÑÑ‚Ñƒ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³ Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½Ðµ \"Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½\" Ð´Ð¾Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ñ€Ð°Ñ’ÐµÐ½.',0),(212769,5911,'vi','Loáº¡i thanh toÃ¡n cho Ä‘Æ¡n hÃ ng nÃ y sáº½ Ä‘Ã¡nh dáº¥u lÃ  \"TK má»Ÿ\" cho Ä‘áº¿n khi tháº» tÃ­n dá»¥ng xá»­ lÃ½ thÃ nh cÃ´ng',0),(212770,5911,'af','Die betaaltipe vir hierdie bestelling sal gemerk word \"oop rekenig\" totdat die kredietkaart suksesvol geprosesseer is',0),(212771,5911,'ro','Tipul de platÄƒ pentru aceastÄƒ comandÄƒ va fi marcat \"deschide contul\" pÃ¢nÄƒ cÃ¢nd cardul de credit este procesat cu succes.',0),(212772,5911,'et','Selle tellimuse liik mÃ¤rgitakse \"avatud konto\" kuni krediitkaart on edukalt tÃ¶Ã¶deldud.',0),(212773,5911,'si','Vrsta plaÄila za to, da bodo oznaÄeni \"odpreti raÄun\" dokler kreditne kartice je uspeÅ¡no obdelane.',0),(212774,5911,'ba','Jenis pembayaran untuk pesanan ini akan ditandai \"open account\" sampai kartu kredit diproses berhasil.',0),(212775,5911,'nl','Het betalingstype voor deze bestelling zal worden gemarkeerd \"open account\" totdat de creditcard is met succes verwerkt.',0),(212776,5911,'fi','Tilauksen maksutapa on merkitty \"Avaa tili\" kunnes luottokortin kÃ¤sittely on onnistunut.',0),(212777,5911,'no','Betalingstype for denne bestillingen vil vÃ¦re merket \"Ã¥pne konto\" til kredittkort er behandlet.',0),(212778,5911,'da','Betalingstypen for denne ordre vil mÃ¦rkes \"Ã¥bne konto\" indtil kreditkortet er behandlet.',0),(212779,5911,'ko','ì´ ìˆœì„œë¥¼ ìœ„í•œ ì§€ë¶ˆ ìœ í˜• í‘œì‹œ ë©ë‹ˆë‹¤ \"ê³„ì¢Œ\" ì‹ ìš© ì¹´ë“œë¥¼ ì„±ê³µì ìœ¼ë¡œ ì²˜ë¦¬ ë  ë•Œê¹Œì§€.',0),(212780,5911,'he','×¡×•×’ ×”×ª×©×œ×•× ×¢×‘×•×¨ ×”×–×ž× ×” ×–×• ×™×¡×•×ž×Ÿ \"×¤×ª×— ×—×©×‘×•×Ÿ\" ×¢×“ ×›×¨×˜×™×¡ ×”××©×¨××™ ×ž×¢×•×‘×“ ×‘×”×¦×œ×—×”.',0),(212781,5911,'el','Î¤Î¿Î½ Ï„ÏÏ€Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Î¸Î± ÎµÏ€Î¹ÏƒÎ·Î¼Î±Î½Î¸Î¿ÏÎ½ \"Î±Î½Î¿Î¯Î¾ÎµÏ„Îµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ\" Î¼Î­Ï‡ÏÎ¹ Ï„Î·Î½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÎµÎ¯Î½Î±Î¹ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(212782,5911,'zh','è¯¥è®¢å•çš„ä»˜æ¬¾æ–¹å¼å°†è¢«æ ‡è®°ä¸ºâ€œå¼€æˆ·â€œï¼Œç›´åˆ°ä¿¡ç”¨å¡æˆåŠŸå¤„ç†ã€‚\r\n',0),(212783,5911,'sv','Betalningstypen fÃ¶r den hÃ¤r ordern kommer mÃ¤rkas \"Ã¶ppna konto\" tills kreditkorten behandlas framgÃ¥ngsrikt.',0),(212784,5911,'it','Il tipo di pagamento per questo ordine verrÃ  contrassegnato \"aprire conto\" fino a quando la carta di credito viene elaborata con successo.',0),(212785,5911,'tl','',0),(212786,5911,'th','The payment type for this order will be marked \"open account\" until the credit card is processed successfully.',0),(212787,5911,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¹à¥ˆ à¤œà¤¬ à¤¤à¤• à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° \"à¤–à¤¾à¤¤à¤¾ à¤–à¥‹à¤²à¥‡à¤‚\" à¤šà¤¿à¤',0),(212788,5911,'ms','Jenis bayaran pesanan akan ditandakan \"open akaun\" sehingga kad kredit berjaya diproses.',0),(212789,5911,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹ Ù„Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù… Ø³ÙŠØªÙ… ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© \"ÙØªØ­ Ø­Ø³Ø§Ø¨\" Ø­ØªÙ‰ ØªØªÙ… Ù…Ø¹Ø§Ù„Ø¬Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¨Ù†Ø¬Ø§Ø­.',0),(212790,5911,'fr','Le type de paiement pour cette commande sera marquÃ© Â« ouvrir le compte Â» jusqu\'Ã  ce que la carte de crÃ©dit est traitÃ©e avec succÃ¨s.',0),(212791,5911,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ã?Œå‡¦ç?†ã?•ã‚Œã‚‹ã?¾ã?§ã?“ã?®æ³¨æ–‡ã?®æ”¯æ‰•ã‚¿ã‚¤ãƒ—ã?¯\"ã‚ªãƒ¼ãƒ—ãƒ³ã‚¢ã‚«ã‚¦ãƒ³ãƒˆâ€?ã?¨ã?—ã?¦è¨˜ã?•ã‚Œã?¾ã?™',0),(212792,5911,'pt','O tipo de pagamento para essa ordem serÃ¡ marcado \"abrir conta\" atÃ© o cartÃ£o de crÃ©dito Ã© processado com Ãªxito.',0),(212793,5911,'ru','Ð¢Ð¸Ð¿ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð° Ð´Ð»Ñ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° Ð±ÑƒÐ´ÐµÑ‚ Ð¾Ñ‚Ð¼ÐµÑ‡ÐµÐ½ Â«Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Â» Ð´Ð¾ Ñ‚ÐµÑ… Ð¿Ð¾Ñ€, Ð¿Ð¾ÐºÐ° Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð±ÑƒÐ´ÐµÑ‚ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(212794,5911,'es','El tipo de pago para este pedido estarÃ¡ marcado \"cuenta abierta\" hasta que la tarjeta de credito se procesa',0),(212795,5911,'de','Die Zahlungsart fÃ¼r diesen Auftrag werden \"Konto erÃ¶ffnen\" markiert bis Kreditkarte erfolgreich verarbeitet wird.',0),(212796,5911,'en','The payment type for this order will be marked \"open account\" until the credit card is processed successfully.',0),(212797,5912,'is','',0),(212798,5912,'dr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(212799,5912,'pr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(212800,5912,'tr','Kredi kartÄ± soyadÄ±',0),(212801,5912,'pl','Karta kredytowa nazwisko',0),(212802,5912,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(212803,5912,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù…',0),(212804,5912,'sr','ÐŸÑ€ÐµÐ·Ð¸Ð¼Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(212805,5912,'vi','Há» cá»§a tháº» tÃ­n dá»¥ng',0),(212806,5912,'af','Kredietkaart Van',0),(212807,5912,'ro','Numele de familie carte de credit',0),(212808,5912,'et','Krediitkaardil olev perekonnanimi',0),(212809,5912,'si','Priimek kreditne kartice',0),(212810,5912,'ba','Nama kartu kredit',0),(212811,5912,'nl','Creditcard achternaam',0),(212812,5912,'fi','Luottokortin sukunimi',0),(212813,5912,'no','Kredittkortet ditt etternavn',0),(212814,5912,'da','Kreditkort efternavn',0),(212815,5912,'ko','ì‹ ìš© ì¹´ë“œ ë§ˆì§€ë§‰ ì´ë¦„',0),(212816,5912,'he','×©× ×ž×©×¤×—×” ×©×œ ×›×¨×˜×™×¡ ××©×¨××™',0),(212817,5912,'el','Î•Ï€ÏŽÎ½Ï…Î¼Î¿ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(212818,5912,'zh','ä¿¡ç”¨å¡å§“æ°\r\n',0),(212819,5912,'sv','Kreditkort efternamn',0),(212820,5912,'it','Carta di credito cognome',0),(212821,5912,'tl','',0),(212822,5912,'th','&#3594;&#3639;&#3656;&#3629;&#3626;&#3585;&#3640;&#3621;&#3612;&#3641;&#3657;&#3606;&#3639;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(212823,5912,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¤¾ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤®',0),(212824,5912,'ms','Kad nama',0),(212825,5912,'ar','Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£Ø®ÙŠØ± Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(212826,5912,'fr','Nom de famille de carte de crÃ©dit',0),(212827,5912,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰å??å­—',0),(212828,5912,'pt','Sobrenome de cartÃ£o de crÃ©dito',0),(212829,5912,'ru','Ð¤Ð°Ð¼Ð¸Ð»Ð¸Ñ ÐÐ° ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐµ',0),(212830,5912,'es','Tarjeta de CrÃ©dito Apellido',0),(212831,5912,'de','Kreditkarte-Nachname',0),(212832,5912,'en','Credit Card Last Name',0),(212833,5913,'is','',0),(212834,5913,'dr','Ù„Ø·ÙØ§ Ù…Ø§Ù‡ Ø§Ù†Ù‚Ø¶Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(212835,5913,'pr','Ù„Ø·ÙØ§ Ù…Ø§Ù‡ Ø§Ù†Ù‚Ø¶Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(212836,5913,'tr','Kredi kartÄ± sona erme ay giriniz.',0),(212837,5913,'pl','Podaj miesiÄ…c wygaÅ›niÄ™cia karty kredytowej.',0),(212838,5913,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ Ð¼ÐµÑÐµÑ†.',0),(212839,5913,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©Ø§ Ù…ÛÛŒÙ†Û Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(212840,5913,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¼ÐµÑÐµÑ† Ð¸ÑÑ‚Ð¸Ñ†Ð°ÑšÐ° Ñ€Ð¾ÐºÐ° Ð²Ð°Ð¶ÐµÑšÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ.',0),(212841,5913,'vi','Nháº­p ThÃ¡ng Háº¿t Háº¡n Tháº» TÃ­n Dá»¥ng',0),(212842,5913,'af','Voer asseblief kredietkaart vervalmaand in.',0),(212843,5913,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i luna de expirarea cardului de credit.',0),(212844,5913,'et','Palun sisesta krediitkaardi kehtivuse kuu',0),(212845,5913,'si','Vnesite mesec poteka kreditne kartice.',0),(212846,5913,'ba','Masukkan kartu kredit kadaluarsa bulan.',0),(212847,5913,'nl','Voer creditcard verlopen maand.',0),(212848,5913,'fi','Kirjoita luottokortin kulunut kuukausi.',0),(212849,5913,'no','Angi kredittkort utgÃ¥r mÃ¥ned.',0),(212850,5913,'da','Indtast kreditkort udlÃ¸bsmÃ¥neden.',0),(212851,5913,'ko','ì‹ ìš© ì¹´ë“œ ë§Œë£Œ ë‹¬ì„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤.',0),(212852,5913,'he','×”×–×™× ×• ×‘×‘×§×©×” ××ª ×—×•×“×© ×ª×¤×•×’×” ×›×¨×˜×™×¡ ××©×¨××™.',0),(212853,5913,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ Î¼Î®Î½Î± Î»Î®Î¾Î·Ï‚ Ï„Î·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚.',0),(212854,5913,'zh','è¯·è¾“å…¥ä¿¡ç”¨å¡åˆ°æœŸæœˆä»½ã€‚\r\n',0),(212855,5913,'sv','VÃ¤nligen ange kreditkort utgÃ¥ngsdatum mÃ¥nad.',0),(212856,5913,'it','Inserisci mese di scadenza della carta di credito.',0),(212857,5913,'tl','',0),(212858,5913,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3611;&#3657;&#3629;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3627;&#3617;&#3604;&#3629;&#3634;&#3618;&#3640;&#3586;&#3629;&#3591;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(212859,5913,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤®à¤¾à¤¹ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(212860,5913,'ms','Sila masukkan kad kredit tamat tempoh bulan.',0),(212861,5913,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø´Ù‡Ø± Ø§Ù†ØªÙ‡Ø§Ø¡ ØµÙ„Ø§Ø­ÙŠØ© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†.',0),(212862,5913,'fr','Sâ€™il vous plaÃ®t entrer mois dâ€™expiration de carte de crÃ©dit.',0),(212863,5913,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ã?®æœ‰åŠ¹æœŸé™?æœˆã‚’å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(212864,5913,'pt','Por favor digite o mÃªs de vencimento do cartÃ£o de crÃ©dito.',0),(212865,5913,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¼ÐµÑÑÑ† Ð¸ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ñ ÑÑ€Ð¾ÐºÐ° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹.',0),(212866,5913,'es','Por favor ingresar el mes de vencimiento de la tarjeta de crÃ©dito',0),(212867,5913,'de','Bitte geben Sie Kreditkarte Ablaufdatum Monat.',0),(212868,5913,'en','Please enter credit card expiration month.',0),(212869,5914,'is','',0),(212870,5914,'dr','Ù„Ø·ÙØ§ Ø³Ø§Ù„  Ø§Ù†Ù‚Ø¶Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(212871,5914,'pr','Ù„Ø·ÙØ§ Ø³Ø§Ù„  Ø§Ù†Ù‚Ø¶Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(212872,5914,'tr','Kredi kartÄ± sona erme yÄ±l giriniz.',0),(212873,5914,'pl','ProszÄ™ wprowadziÄ‡ rok wygaÅ›niÄ™cia karty kredytowej.',0),(212874,5914,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ð°.',0),(212875,5914,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø®ØªÙ… ÛÙˆÙ†Û’ Ø³Ø§Ù„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(212876,5914,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð¸ÑÑ‚Ð¸Ñ†Ð°ÑšÐ° Ñ€Ð¾ÐºÐ° Ð²Ð°Ð¶ÐµÑšÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ.',0),(212877,5914,'vi','Nháº­p NÄƒm Háº¿t Háº¡n Tháº» TÃ­n Dá»¥ng',0),(212878,5914,'af','Voer asseblief kredietkaart vervaljaar in.',0),(212879,5914,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i anul de expirarea cardului de credit.',0),(212880,5914,'et','Palun sisesta krediitkaardi kehtivuse aasta',0),(212881,5914,'si','Vnesite leto poteka kreditne kartice.',0),(212882,5914,'ba','Masukkan kartu kredit kadaluarsa tahun.',0),(212883,5914,'nl','Voer creditcard vervaldatum jaar.',0),(212884,5914,'fi','Kirjoita luottokortin kulunut vuosi.',0),(212885,5914,'no','Angi kredittkort utlÃ¸p Ã¥r.',0),(212886,5914,'da','Indtast kreditkort udlÃ¸b Ã¥r.',0),(212887,5914,'ko','ì‹ ìš© ì¹´ë“œ ë§Œë£Œ ì—°ë„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤.',0),(212888,5914,'he','×”×–×™× ×• ×‘×‘×§×©×” ××ª ×©× ×ª ×”×ª×¤×•×’×” ×›×¨×˜×™×¡ ××©×¨××™.',0),(212889,5914,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ Ï‡ÏÏŒÎ½Î¿ Î»Î®Î¾Î·Ï‚ Ï„Î·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚.',0),(212890,5914,'zh','è¯·è¾“å…¥ä¿¡ç”¨å¡åˆ°æœŸå¹´ä»½ã€‚\r\n',0),(212891,5914,'sv','VÃ¤nligen ange kreditkort utgÃ¥ngsdatum Ã¥ret.',0),(212892,5914,'it','Inserisci l\'anno di scadenza della carta di credito.',0),(212893,5914,'tl','',0),(212894,5914,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3611;&#3657;&#3629;&#3609;&#3611;&#3637;&#3627;&#3617;&#3604;&#3629;&#3634;&#3618;&#3640;&#3586;&#3629;&#3591;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(212895,5914,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤µà¤°à¥à¤· à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(212896,5914,'ms','Sila masukkan kad kredit tamat tempoh tahun.',0),(212897,5914,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„Ø³Ù†Ø©.',0),(212898,5914,'fr','Entrez lâ€™annÃ©e dâ€™expiration de carte de crÃ©dit.',0),(212899,5914,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ã?®æœ‰åŠ¹æœŸé™?å¹´ã‚’å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(212900,5914,'pt','Por favor, digite o ano de expiraÃ§Ã£o do cartÃ£o de crÃ©dito.',0),(212901,5914,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð³Ð¾Ð´ Ð¸ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ñ ÑÑ€Ð¾ÐºÐ° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹.',0),(212902,5914,'es','Por favor ingresar el aÃ±o de vencimiento de la tarjeta de crÃ©dito',0),(212903,5914,'de','Bitte geben Sie Kreditkarte Ablaufjahr.',0),(212904,5914,'en','Please enter credit card expiration year.',0),(212905,5915,'is','',0),(212906,5915,'dr','Ù„Ø·ÙØ§ Ù†Ø§Ù…  ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(212907,5915,'pr','Ù„Ø·ÙØ§ Ù†Ø§Ù…  ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(212908,5915,'tr','LÃ¼tfen kredi kartÄ± ilk adÄ± girin.',0),(212909,5915,'pl','ProszÄ™ podaÄ‡ imiÄ™ karty kredytowej.',0),(212910,5915,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿ÑŠÑ€Ð²Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°.',0),(212911,5915,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù¾ÛÙ„Ø§ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(212912,5915,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸Ð¼Ðµ Ð·Ð° Ð¿Ñ€Ð²Ñƒ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ.',0),(212913,5915,'vi','Nháº­p TÃªn Tháº» TÃ­n Dá»¥ng',0),(212914,5915,'af','Voer asb. \'n kredietkaart voornaam In',0),(212915,5915,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i numele de primul card de credit.',0),(212916,5915,'et','Palun sisesta krediitkaardil olev eesnimi',0),(212917,5915,'si','Vnesite ime kreditne kartice.',0),(212918,5915,'ba','Masukkan nama pertama kartu kredit.',0),(212919,5915,'nl','Voer de voornaam van de creditcard.',0),(212920,5915,'fi','Kirjoita luottokortin etunimi.',0),(212921,5915,'no','Angi kredittkort fornavn.',0),(212922,5915,'da','Indtast kreditkort fornavn.',0),(212923,5915,'ko','ì‹ ìš© ì¹´ë“œ ì²˜ìŒ ì´ë¦„ì„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤.',0),(212924,5915,'he','×”×–×™× ×• ×©× ×¤×¨×˜×™ ×›×¨×˜×™×¡ ××©×¨××™.',0),(212925,5915,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚.',0),(212926,5915,'zh','è¯·è¾“å…¥ä¿¡ç”¨å¡çš„åå­—ã€‚\r\n',0),(212927,5915,'sv','Ange kreditkort fÃ¶rnamn.',0),(212928,5915,'it','Inserisci nome carta di credito.',0),(212929,5915,'tl','',0),(212930,5915,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3611;&#3657;&#3629;&#3609;&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3606;&#3639;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(212931,5915,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(212932,5915,'ms','Sila masukkan nama pertama kad kredit.',0),(212933,5915,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø®Ø§Ù„ \"Ø§Ù„Ø¥Ø³Ù… Ø§Ù„Ø£ÙˆÙ„\" Ù„Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(212934,5915,'fr','Entrez le prÃ©nom de carte de crÃ©dit.',0),(212935,5915,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ã?®å??å‰?ã‚’å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(212936,5915,'pt','Por favor digite o nome do primeiro cartÃ£o de crÃ©dito.',0),(212937,5915,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¸Ð¼Ñ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹.',0),(212938,5915,'es','Por favor ingresar el primer nombre en la tarjeta de crÃ©dito',0),(212939,5915,'de','Bitte geben Sie Vorname Kreditkarte.',0),(212940,5915,'en','Please enter credit card first name.',0),(212941,5916,'is','',0),(212942,5916,'dr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ  ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(212943,5916,'pr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ  ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(212944,5916,'tr','LÃ¼tfen kredi kartÄ± soyadÄ± girin.',0),(212945,5916,'pl','ProszÄ™ wpisaÄ‡ nazwisko karty kredytowej.',0),(212946,5916,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°.',0),(212947,5916,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(212948,5916,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ.',0),(212949,5916,'vi','Nháº­p Há» Tháº» TÃ­n Dá»¥ng',0),(212950,5916,'af','Voer asb. \'n kredietkaart van In',0),(212951,5916,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i numele de familie a cardului de credit.',0),(212952,5916,'et','Palun sisesta krediitkaardil olev perekonnanimi',0),(212953,5916,'si','Vnesite priimek kreditne kartice.',0),(212954,5916,'ba','Masukkan nama kartu kredit.',0),(212955,5916,'nl','Geef de achternaam van de creditcard.',0),(212956,5916,'fi','Anna luottokortin sukunimi.',0),(212957,5916,'no','Angi kredittkort etternavn.',0),(212958,5916,'da','Indtast kreditkort efternavn.',0),(212959,5916,'ko','ì‹ ìš© ì¹´ë“œ ë§ˆì§€ë§‰ ì´ë¦„ì„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤.',0),(212960,5916,'he','×× × ×”×›× ×¡ ×©× ××ª×ž×•×œ ×›×¨×˜×™×¡ ××©×¨××™.',0),(212961,5916,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î•Ï€ÏŽÎ½Ï…Î¼Î¿ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±.',0),(212962,5916,'zh','è¯·è¾“å…¥ä¿¡ç”¨å¡çš„å§“æ°ã€‚\r\n',0),(212963,5916,'sv','Ange kreditkort efternamn.',0),(212964,5916,'it','Inserisci il cognome di carta di credito.',0),(212965,5916,'tl','',0),(212966,5916,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3611;&#3657;&#3629;&#3609;&#3609;&#3634;&#3617;&#3626;&#3585;&#3640;&#3621;&#3612;&#3641;&#3657;&#3606;&#3639;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(212967,5916,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(212968,5916,'ms','Sila masukkan nama pada kad kredit.',0),(212969,5916,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø®Ø§Ù„ \"Ø§Ù„Ø¥Ø³Ù… Ø§Ù„Ø£Ø®ÙŠØ±\" Ù„Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(212970,5916,'fr','Entrez le nom de famille de carte de crÃ©dit.',0),(212971,5916,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ã?®å??å­—ã‚’å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(212972,5916,'pt','Por favor digite o Ãºltimo nome de cartÃ£o de crÃ©dito.',0),(212973,5916,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ñ„Ð°Ð¼Ð¸Ð»Ð¸ÑŽ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹.',0),(212974,5916,'es','Por favor ingresar el apellido en la tarjeta de crÃ©dito',0),(212975,5916,'de','Geben Sie bitte Nachname Kreditkarte.',0),(212976,5916,'en','Please enter credit card last name.',0),(212977,5917,'is','',0),(212978,5917,'dr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(212979,5917,'pr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(212980,5917,'tr','LÃ¼tfen kredi kartÄ± numarasÄ±nÄ± girin.',0),(212981,5917,'pl','ProszÄ™ podaÄ‡ numer karty kredytowej.',0),(212982,5917,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°.',0),(212983,5917,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(212984,5917,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð±Ñ€Ð¾Ñ˜ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ.',0),(212985,5917,'vi','Nháº­p Sá»‘ Tháº» TÃ­n Dá»¥ng',0),(212986,5917,'af','Voer asseblief kredietkaartnommer in.',0),(212987,5917,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i numÄƒrul cardului de credit.',0),(212988,5917,'et','Palun sisesta krediitkaardi number',0),(212989,5917,'si','Vnesite Å¡tevilko kreditne kartice.',0),(212990,5917,'ba','Masukkan nomor kartu kredit.',0),(212991,5917,'nl','Voer credit cardnummer.',0),(212992,5917,'fi','Anna luottokorttinumero.',0),(212993,5917,'no','Skriv inn kredittkortnummer.',0),(212994,5917,'da','Angiv kreditkortnummeret.',0),(212995,5917,'ko','ì‹ ìš© ì¹´ë“œ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤.',0),(212996,5917,'he','.×× × ×”×›× ×¡ ×ž×¡×¤×¨ ×›×¨×˜×™×¡ ×”××©×¨××™',0),(212997,5917,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚.',0),(212998,5917,'zh','è¯·è¾“å…¥ä¿¡ç”¨å¡å·ç ã€‚\r\n',0),(212999,5917,'sv','VÃ¤nligen ange kreditkortsnummer.',0),(213000,5917,'it','Inserisci il numero di carta di credito.',0),(213001,5917,'tl','',0),(213002,5917,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3611;&#3657;&#3629;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(213003,5917,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¨à¤‚à¤¬à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(213004,5917,'ms','Sila masukkan nombor kad kredit.',0),(213005,5917,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(213006,5917,'fr','Veuillez saisir le numÃ©ro de carte de crÃ©dit.',0),(213007,5917,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ç•ªå?·ã‚’å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(213008,5917,'pt','Por favor insira o nÃºmero do cartÃ£o de crÃ©dito.',0),(213009,5917,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹.',0),(213010,5917,'es','Por favor ingresar el nÃºmero de la tarjeta de crÃ©dito',0),(213011,5917,'de','Bitte geben Sie Ihre Kartennummer.',0),(213012,5917,'en','Please enter credit card number.',0),(213013,5918,'is','',0),(213014,5918,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(213015,5918,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(213016,5918,'tr','Ä°ÅŸlem kredi kartÄ±',0),(213017,5918,'pl','Proces karty kredytowej',0),(213018,5918,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(213019,5918,'ur','Ø¹Ù…Ù„ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ',0),(213020,5918,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(213021,5918,'vi','Xá»­ LÃ½ tháº» tÃ­n dá»¥ng',0),(213022,5918,'af','Prosesseer Kredietkaart',0),(213023,5918,'ro','Carte de Credit proces',0),(213024,5918,'et','Protsessi krediitkaardi',0),(213025,5918,'si','Proces kreditne kartice',0),(213026,5918,'ba','Proses kartu kredit',0),(213027,5918,'nl','Proces creditcard',0),(213028,5918,'fi','Luottokortti',0),(213029,5918,'no','Prosessen kredittkort',0),(213030,5918,'da','Processen kreditkort',0),(213031,5918,'ko','í”„ë¡œì„¸ìŠ¤ ì‹ ìš© ì¹´ë“œ',0),(213032,5918,'he','×›×¨×˜×™×¡ ××©×¨××™ ×ª×”×œ×™×š',0),(213033,5918,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(213034,5918,'zh','å¤„ç†ä¿¡ç”¨å¡\r\n',0),(213035,5918,'sv','Processen kreditkort',0),(213036,5918,'it','Carta di credito del processo',0),(213037,5918,'tl','',0),(213038,5918,'th','&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(213039,5918,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡',0),(213040,5918,'ms','Proses kad kredit',0),(213041,5918,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ÙÙŠ Ø¹Ù…Ù„ÙŠØ©',0),(213042,5918,'fr','Carte de crÃ©dit de processus',0),(213043,5918,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ã?®å‡¦ç?†',0),(213044,5918,'pt','CartÃ£o de processo de crÃ©dito',0),(213045,5918,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(213046,5918,'es','Procesar Tarjeta de CrÃ©dito',0),(213047,5918,'de','Prozess-Kreditkarte',0),(213048,5918,'en','Process Credit Card',0),(213049,5919,'is','',0),(213050,5919,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(213051,5919,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(213052,5919,'tr','Kredi kartÄ± iÅŸlem kimliÄŸi',0),(213053,5919,'pl','Identyfikator transakcji karty kredytowej',0),(213054,5919,'bg','Ð˜Ð” Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(213055,5919,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(213056,5919,'sr','Ð˜Ð” Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(213057,5919,'vi','ID giao dá»‹ch tháº» tÃ­n dá»¥ng',0),(213058,5919,'af','Kredietkaart Transaksie ID',0),(213059,5919,'ro','Card de credit Transaction ID',0),(213060,5919,'et','Krediitkaardi kande ID',0),(213061,5919,'si','ID posla kreditne kartice',0),(213062,5919,'ba','ID transaksi kartu kredit',0),(213063,5919,'nl','Credit Card transactie-ID',0),(213064,5919,'fi','Luottokortin Tapahtumatunnus',0),(213065,5919,'no','Kreditt kort transaksjons-ID',0),(213066,5919,'da','Transaktions-ID, kreditkort',0),(213067,5919,'ko','ì‹ ìš© ì¹´ë“œ íŠ¸ëžœìž­ì…˜ ID',0),(213068,5919,'he','×ž×–×”×” ×ª× ×•×¢×” ×›×¨×˜×™×¡ ××©×¨××™',0),(213069,5919,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(213070,5919,'zh','ä¿¡ç”¨å¡äº¤æ˜“èº«ä»½\r\n',0),(213071,5919,'sv','Kreditkort transaktions-ID',0),(213072,5919,'it','ID transazione di carta di credito',0),(213073,5919,'tl','',0),(213074,5919,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(213075,5919,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤†à¤ˆà¤¡à¥€',0),(213076,5919,'ms','ID transaksi kad kredit',0),(213077,5919,'ar','Ù…Ø¹Ø±Ù‘Ù Ø¹Ù…Ù„ÙŠØ© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(213078,5919,'fr','ID de Transaction de carte de crÃ©dit',0),(213079,5919,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰å?–å¼•ID',0),(213080,5919,'pt','ID de transaÃ§Ã£o de cartÃ£o de crÃ©dito',0),(213081,5919,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(213082,5919,'es','Tarjeta de CrÃ©dito TransacciÃ³n ID',0),(213083,5919,'de','Kreditkarte-Transaktions-ID',0),(213084,5919,'en','Credit Card Transaction ID',0),(213085,5920,'is','',0),(213086,5920,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(213087,5920,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(213088,5920,'tr','Hata iÅŸleme Ã¶deme.',0),(213089,5920,'pl','BÅ‚Ä…d przetwarzania pÅ‚atnoÅ›ci.',0),(213090,5920,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ.',0),(213091,5920,'ur','Ù†Ù‚Øµ Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ÛÛ’ Û”',0),(213092,5920,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¾Ð±Ñ€Ð°Ð´Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°.',0),(213093,5920,'vi','Lá»—i khi xá»­ lÃ½ thanh toÃ¡n',0),(213094,5920,'af','Fout met prosessering van betaling.',0),(213095,5920,'ro','Eroare de prelucrare de platÄƒ.',0),(213096,5920,'et','Viga tÃ¶Ã¶tlemine makse.',0),(213097,5920,'si','Napake obdelave plaÄil.',0),(213098,5920,'ba','Kesalahan pengolahan pembayaran.',0),(213099,5920,'nl','Fout verwerking betaling.',0),(213100,5920,'fi','Virhe kÃ¤sittelyn maksu.',0),(213101,5920,'no','Feil behandling betaling.',0),(213102,5920,'da','Fejl forarbejdning betaling.',0),(213103,5920,'ko','ì˜¤ë¥˜ ì²˜ë¦¬ ì§€ë¶ˆìž…ë‹ˆë‹¤.',0),(213104,5920,'he','×”×ª×©×œ×•× ×¢×™×‘×•×“ ×©×’×™××”.',0),(213105,5920,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚.',0),(213106,5920,'zh','é”™è¯¯å¤„ç†ä»˜æ¬¾ã€‚',0),(213107,5920,'sv','Fel behandling betalning.',0),(213108,5920,'it','Pagamento di elaborazione di errore.',0),(213109,5920,'tl','',0),(213110,5920,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(213111,5920,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤­à¥à¤—à¤¤à¤¾à¤¨à¥¤',0),(213112,5920,'ms','Ralat pemprosesan pembayaran.',0),(213113,5920,'ar','Ø®Ø·Ø£ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ø¯ÙØ¹.',0),(213114,5920,'fr','Paiement d\'erreur de traitement.',0),(213115,5920,'jp','æ”¯æ‰•ã?®å‡¦ç?†ã‚¨ãƒ©ãƒ¼',0),(213116,5920,'pt','Pagamento de tratamento de erro.',0),(213117,5920,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°.',0),(213118,5920,'es','Error procesando pago',0),(213119,5920,'de','Fehler Verarbeitung Zahlung.',0),(213120,5920,'en','Error processing payment.',0),(213121,5921,'is','',0),(213122,5921,'dr','Ø§Ø² Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¯Ø³ØªÙŠ ',0),(213123,5921,'pr','Ø§Ø² Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¯Ø³ØªÙŠ ',0),(213124,5921,'tr','El ile iÅŸlem',0),(213125,5921,'pl','Od proces rÄ™czny',0),(213126,5921,'bg','ÐžÑ‚ Ñ€ÑŠÑ‡ÐµÐ½ Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(213127,5921,'ur','Ø¯Ø³ØªÛŒ Ú©Û’ Ø¹Ù…Ù„ Ø³Û’',0),(213128,5921,'sr','Ð˜Ð· Ñ€ÑƒÑ‡Ð½Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(213129,5921,'vi','Tá»« quy trÃ¬nh thá»§ cÃ´ng',0),(213130,5921,'af','Vanaf handgedrewe prosese',0),(213131,5921,'ro','La proces manual',0),(213132,5921,'et','KÃ¤sitsi:',0),(213133,5921,'si','Iz roÄno',0),(213134,5921,'ba','Dari proses manual',0),(213135,5921,'nl','Van handproces',0),(213136,5921,'fi','Manuaalinen prosessi',0),(213137,5921,'no','Fra manuell prosess',0),(213138,5921,'da','Fra manuel proces',0),(213139,5921,'ko','ìˆ˜ë™ í”„ë¡œì„¸ìŠ¤',0),(213140,5921,'he','×ž×ª×•×š ×ª×”×œ×™×š ×™×“× ×™',0),(213141,5921,'el','Î‘Ï€ÏŒ Ï„Î·Î½ Ï‡ÎµÎ¹ÏÎ¿ÎºÎ¯Î½Î·Ï„Î· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±',0),(213142,5921,'zh','ä»Žæ‰‹å·¥å¤„ç†\r\n',0),(213143,5921,'sv','FrÃ¥n manuell process',0),(213144,5921,'it','Dal processo manuale',0),(213145,5921,'tl','',0),(213146,5921,'th','&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3617;&#3639;&#3629;&#3607;&#3635;',0),(213147,5921,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¸à¥‡',0),(213148,5921,'ms','Daripada proses manual',0),(213149,5921,'ar','Ù…Ù† Ø¹Ù…Ù„ÙŠØ© ÙŠØ¯ÙˆÙŠØ©',0),(213150,5921,'fr','Du processus manuel',0),(213151,5921,'jp','ãƒžãƒ‹ãƒ¥ã‚¢ãƒ«å‡¦ç?†',0),(213152,5921,'pt','Do processo manual',0),(213153,5921,'ru','ÐžÑ‚ Ñ€ÑƒÑ‡Ð½Ð¾Ð¹ Ð¿Ñ€Ð¾Ñ†ÐµÑÑ',0),(213154,5921,'es','Del proceso manual',0),(213155,5921,'de','Von manueller Prozess',0),(213156,5921,'en','From manual process',0),(213157,5922,'is','',0),(213158,5922,'dr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(213159,5922,'pr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(213160,5922,'tr','KarÅŸÄ±lama sipariÅŸi mevduat',0),(213161,5922,'pl','Realizacja zamÃ³wienia depozytu',0),(213162,5922,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÑÐ²ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(213163,5922,'ur','ØªÚ©Ù…ÛŒÙ„ Ø¢Ø±ÚˆØ± Ø¬Ù…Ø¹',0),(213164,5922,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(213165,5922,'vi','Äáº·t Cá»c ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(213166,5922,'af','Uitvoeringsbestelling Deposito',0),(213167,5922,'ro','Depozit de ordinea Ã®mplinirea',0),(213168,5922,'et','Plaanitud tellimuse tagatisraha',0),(213169,5922,'si','Izpolnitve nalog depozit',0),(213170,5922,'ba','Pemenuhan Order Deposit',0),(213171,5922,'nl','Vervulling volgorde storting',0),(213172,5922,'fi','TÃ¤yttÃ¤mistÃ¤ jÃ¤rjestyksessÃ¤ talletus',0),(213173,5922,'no','Oppfyllelse for innskudd',0),(213174,5922,'da','Opfyldelse for indbetaling',0),(213175,5922,'ko','í–‰ ì£¼ë¬¸ ìž…ê¸ˆ',0),(213176,5922,'he','×ž×™×ž×•×© ×¦×• ×”×¤×§×“×”',0),(213177,5922,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(213178,5922,'zh','å±¥è¡Œè®¢å•å­˜æ¬¾\r\n',0),(213179,5922,'sv','Uppfyllelse ordning insÃ¤ttning',0),(213180,5922,'it','Deposito di evasione ordine',0),(213181,5922,'tl','',0),(213182,5922,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;',0),(213183,5922,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤œà¤®à¤¾',0),(213184,5922,'ms','Memenuhi perintah Deposit',0),(213185,5922,'ar','Ø§Ø³ØªÙŠÙØ§Ø¡ Ø£Ù…Ø± Ø¥ÙŠØ¯Ø§Ø¹',0),(213186,5922,'fr','DÃ©pÃ´t Order Fulfillment',0),(213187,5922,'jp','å‡¦ç?†æ¸ˆæ³¨æ–‡é ?ã‚Šé‡‘',0),(213188,5922,'pt','DepÃ³sito de ordem de cumprimento',0),(213189,5922,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(213190,5922,'es','Orden de Cumplimiento DepÃ³sito',0),(213191,5922,'de','ErfÃ¼llung Bestellung Anzahlung',0),(213192,5922,'en','Fulfillment Order Deposit',0),(213193,5923,'is','',0),(213194,5923,'dr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(213195,5923,'pr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(213196,5923,'tr','Ã–deme yÃ¶ntemi baÅŸarÄ±yla deÄŸiÅŸtirildi.',0),(213197,5923,'pl','Metoda pÅ‚atnoÅ›ci zostaâ”‚y zmienione.',0),(213198,5923,'bg','ÐÐ°Ñ‡Ð¸Ð½ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(213199,5923,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(213200,5923,'sr','ÐÐ°Ñ‡Ð¸Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½.',0),(213201,5923,'vi','Thay Ä‘á»•i PhÆ°Æ¡ng thá»©c Thanh ToÃ¡n thÃ nh cÃ´ng',0),(213202,5923,'af','Betalingsmetode suksesvol Verandering',0),(213203,5923,'ro','MetodÄƒ de platÄƒ schimbat cu succes.',0),(213204,5923,'et','Makseviis muudetud',0),(213205,5923,'si','NaÄin plaÄila uspeÅ¡no spremenili.',0),(213206,5923,'ba','Metode pembayaran berhasil diubah.',0),(213207,5923,'nl','Betalingsmethode gewijzigd met succes.',0),(213208,5923,'fi','Maksutapa vaihdettu.',0),(213209,5923,'no','Betalingsmetoden er endret.',0),(213210,5923,'da','Betalingsmetode skiftede med succes.',0),(213211,5923,'ko','ê²°ì œ ë°©ë²• ë³€ê²½ ì„±ê³µì ìœ¼ë¡œ.',0),(213212,5923,'he','×©×™×˜×ª ×ª×©×œ×•× ×©×•× ×” ×‘×”×¦×œ×—×”.',0),(213213,5923,'el','Î¤ÏÏŒÏ€Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î±Î»Î»Î¬Î¾ÎµÎ¹ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(213214,5923,'zh','ä»˜æ¬¾æ–¹å¼å˜æ›´æˆåŠŸã€‚\r\n',0),(213215,5923,'sv','Betalningsmetod Ã¤ndrat framgÃ¥ngsrikt.',0),(213216,5923,'it','Metodo di pagamento Ã¨ cambiato con successo.',0),(213217,5923,'tl','',0),(213218,5923,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(213219,5923,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¦à¥à¤§à¤¤à¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤° à¤¦à¤¿à¤¯à¤¾à¥¤',0),(213220,5923,'ms','Kaedah pembayaran berjaya ditukar.',0),(213221,5923,'ar','ØªØºÙŠÙŠØ± Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹ Ø¨Ù†Ø¬Ø§Ø­.',0),(213222,5923,'fr','Mode de paiement modifiÃ© avec succÃ¨s.',0),(213223,5923,'jp','æ”¯æ‰•æ–¹æ³•ã‚’å¤‰æ›´ã?—ã?¾ã?—ã?Ÿ',0),(213224,5923,'pt','Forma de pagamento alterada com Ãªxito.',0),(213225,5923,'ru','Ð¡Ð¿Ð¾ÑÐ¾Ð± Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½.',0),(213226,5923,'es','MÃ©todo de Pago cambiado exitosamente',0),(213227,5923,'de','Zahlungsart wurde erfolgreich geÃ¤ndert.',0),(213228,5923,'en','Payment method changed successfully.',0),(213229,5924,'is','',0),(213230,5924,'dr','Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ Ø§Ø¬Ø±Ø§ ÙƒÙ†ÙŠØ¯',0),(213231,5924,'pr','Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§ Ø§Ø¬Ø±Ø§ ÙƒÙ†ÙŠØ¯',0),(213232,5924,'tr','Kredi kartÄ± iÅŸlemi Ã§alÄ±ÅŸtÄ±rmak',0),(213233,5924,'pl','UruchomiÄ‡ transakcji karty kredytowej',0),(213234,5924,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(213235,5924,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú†Ù„Øª Ú©Ø±ÛŒÚº',0),(213236,5924,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚Ð°ÑšÐµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(213237,5924,'vi','Liá»‡t KÃª Giao Dá»‹ch Tháº» TÃ­n Dá»¥ng',0),(213238,5924,'af','Loop kredietkaart transaksie',0),(213239,5924,'ro','Rula tranzacÅ£ie de Card de Credit',0),(213240,5924,'et','KÃ¤ivitage krediitkaardi tehing',0),(213241,5924,'si','Zagnati transakcijo s kreditno kartico',0),(213242,5924,'ba','Menjalankan transaksi kartu kredit',0),(213243,5924,'nl','Credit Card transactie uitvoeren',0),(213244,5924,'fi','Suorita luottokorttitapahtuman',0),(213245,5924,'no','KjÃ¸re kredittkorttransaksjon',0),(213246,5924,'da','KÃ¸re kreditkorttransaktion',0),(213247,5924,'ko','ì‹ ìš© ì¹´ë“œ ê±°ëž˜ë¥¼ ì‹¤í–‰',0),(213248,5924,'he','×œ×”×¤×¢×™×œ ×ª× ×•×¢×” ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(213249,5924,'el','Î•ÎºÏ„ÎµÎ»Î­ÏƒÏ„Îµ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(213250,5924,'zh','ä¿¡ç”¨å¡äº¤æ˜“è¿è¡Œ\r\n',0),(213251,5924,'sv','KÃ¶r kreditkortstransaktion',0),(213252,5924,'it','Eseguire la transazione con carta di credito',0),(213253,5924,'tl','',0),(213254,5924,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3605;&#3656;&#3629;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;',0),(213255,5924,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤šà¤²à¤¾à¤¨à¥‡',0),(213256,5924,'ms','Menjalankan transaksi kad kredit',0),(213257,5924,'ar','ØªØ´ØºÙŠÙ„ Ù…Ø¹Ø§Ù…Ù„Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(213258,5924,'fr','ExÃ©cuter la Transaction par carte de crÃ©dit',0),(213259,5924,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰å?–å¼•ã‚’å®Ÿè¡Œã?™ã‚‹',0),(213260,5924,'pt','Executar transaÃ§Ãµes de cartÃ£o de crÃ©dito',0),(213261,5924,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸ÐµÐ¹ ÐŸÐ¾ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ðµ',0),(213262,5924,'es','Correr TransacciÃ³n de Tarjeta de CrÃ©dito',0),(213263,5924,'de','Kreditkarten-Transaktion ausfÃ¼hren',0),(213264,5924,'en','Run Credit Card Transaction',0),(213265,5925,'is','',0),(213266,5925,'dr','Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(213267,5925,'pr','Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(213268,5925,'tr','Hareket iÅŸleme.',0),(213269,5925,'pl','Transakcja nie przetworzone.',0),(213270,5925,'bg','Ð¡Ð´ÐµÐ»ÐºÐ°Ñ‚Ð° Ð½Ðµ ÑÐµ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð²Ð°Ñ‚.',0),(213271,5925,'ur','Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† Ø¹Ù…Ù„ Ù…ÛŒÚº Ù†ÛÛŒÚº Ù„Ø§ÛŒØ§ Û”',0),(213272,5925,'sr','Ð¢Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð¾Ð±Ñ€Ð°Ñ’ÐµÐ½.',0),(213273,5925,'vi','Giao dá»‹ch chÆ°a xá»­ lÃ½',0),(213274,5925,'af','Transaksie nie geproseseer nie.',0),(213275,5925,'ro','TranzacÅ£ia nu prelucrate.',0),(213276,5925,'et','Tehing ei tÃ¶Ã¶delda.',0),(213277,5925,'si','Transakcije, ki se ne obdelujejo.',0),(213278,5925,'ba','Transaksi tidak diproses.',0),(213279,5925,'nl','Transactie niet verwerkt.',0),(213280,5925,'fi','Tapahtuma ei kÃ¤sitelty.',0),(213281,5925,'no','Transaksjonen ikke behandlet.',0),(213282,5925,'da','Transaktionen behandles ikke.',0),(213283,5925,'ko','íŠ¸ëžœìž­ì…˜ ì²˜ë¦¬ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(213284,5925,'he','×”×ª× ×•×¢×” ×œ× ×ž×¢×•×‘×“.',0),(213285,5925,'el','Î£Ï…Î½Î±Î»Î»Î±Î³Î® Ï€Î¿Ï… Î´ÎµÎ½ Ï…Ï€Î¿Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ ÏƒÎµ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±.',0),(213286,5925,'zh','äº¤æ˜“æœªè¿›è¡Œå¤„ç†ã€‚\r\n',0),(213287,5925,'sv','Transaktion inte behandlas.',0),(213288,5925,'it','Transazione non elaborati.',0),(213289,5925,'tl','',0),(213290,5925,'th','&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3652;&#3617;&#3656;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;',0),(213291,5925,'hi','à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚à¥¤',0),(213292,5925,'ms','Urus niaga yang tidak diproses.',0),(213293,5925,'ar','Ù„Ù… ØªØªÙ… Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª.',0),(213294,5925,'fr','Transaction non traitÃ©e.',0),(213295,5925,'jp','å‡¦ç?†ã?•ã‚Œã?¦ã?„ã?ªã?„å?–å¼•',0),(213296,5925,'pt','TransaÃ§Ãµes nÃ£o processadas.',0),(213297,5925,'ru','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ, Ð½Ðµ Ð¾Ð±Ñ€Ð°Ð±Ð°Ñ‚Ñ‹Ð²Ð°ÑŽÑ‚ÑÑ.',0),(213298,5925,'es','TransacciÃ³n no procesada',0),(213299,5925,'de','Transaktion, die nicht verarbeitet werden.',0),(213300,5925,'en','Transaction not processed.',0),(213301,5926,'is','',0),(213302,5926,'dr','Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´Ø¯ ',0),(213303,5926,'pr','Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´Ø¯ ',0),(213304,5926,'tr','Ä°ÅŸlem baÅŸarÄ±yla iÅŸledi.',0),(213305,5926,'pl','Transakcji pomyÅ›lnie przetworzona.',0),(213306,5926,'bg','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ, Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(213307,5926,'ur','Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¹Ù…Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(213308,5926,'sr','Ð¢Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ñ€Ð°Ñ’ÐµÐ½.',0),(213309,5926,'vi','Giao dá»‹ch xá»­ lÃ½ thÃ nh cÃ´ng',0),(213310,5926,'af','Transaksie suksesvol geproseseer.',0),(213311,5926,'ro','TranzacÅ£ii procesate cu succes.',0),(213312,5926,'et','Tehing Ãµnnestus',0),(213313,5926,'si','Transakcija uspeÅ¡no obdelane.',0),(213314,5926,'ba','Transaksi yang diproses berhasil.',0),(213315,5926,'nl','Transactie verwerkt.',0),(213316,5926,'fi','Tapahtuma kÃ¤sitelty onnistuneesti.',0),(213317,5926,'no','Transaksjon behandlet.',0),(213318,5926,'da','Transaktionen er behandlet korrekt.',0),(213319,5926,'ko','ê±°ëž˜ê°€ ì„±ê³µì ìœ¼ë¡œ ì²˜ë¦¬ í•©ë‹ˆë‹¤.',0),(213320,5926,'he','×ª× ×•×¢×ª ×ž×¢×•×‘×“ ×‘×”×¦×œ×—×”.',0),(213321,5926,'el','Î£Ï…Î½Î±Î»Î»Î±Î³Î® Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± ÏƒÎµ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±.',0),(213322,5926,'zh','äº¤æ˜“æˆåŠŸå¤„ç†ã€‚\r\n',0),(213323,5926,'sv','Transaktion behandlas framgÃ¥ngsrikt.',0),(213324,5926,'it','Transazione elaborata correttamente.',0),(213325,5926,'tl','',0),(213326,5926,'th','&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(213327,5926,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨à¥¤',0),(213328,5926,'ms','Transaksi diproses berjaya.',0),(213329,5926,'ar','Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ù„ØªÙŠ ØªØªÙ… Ù…Ø¹Ø§Ù„Ø¬ØªÙ‡Ø§ Ø¨Ù†Ø¬Ø§Ø­.',0),(213330,5926,'fr','Transaction effectuÃ©e avec succÃ¨s.',0),(213331,5926,'jp','å?–å¼•ã‚’å‡¦ç?†ã?—ã?¾ã?—ã?Ÿ',0),(213332,5926,'pt','TransaÃ§Ã£o processada com Ãªxito.',0),(213333,5926,'ru','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½.',0),(213334,5926,'es','TransacciÃ³n procesada exitosamente',0),(213335,5926,'de','Transaktion erfolgreich verarbeitet.',0),(213336,5926,'en','Transaction processed successfully.',0),(213337,5927,'is','',0),(213338,5927,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ  Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(213339,5927,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ  Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(213340,5927,'tr','Kredi kartÄ± Ã¶deme seÃ§enekleri',0),(213341,5927,'pl','Opcje pÅ‚atnoÅ›ci kartÄ… kredytowÄ…',0),(213342,5927,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(213343,5927,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(213344,5927,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(213345,5927,'vi','Lá»±a Chá»n Tháº» TÃ­n Dá»¥ng',0),(213346,5927,'af','Kredietkaart Betalingsopsies',0),(213347,5927,'ro','OpÅ£iuni de platÄƒ carduri de credit',0),(213348,5927,'et','Makse Valikud',0),(213349,5927,'si','MoÅ¾nosti plaÄila kreditno kartico',0),(213350,5927,'ba','Pilihan pembayaran kartu kredit',0),(213351,5927,'nl','Credit Card betalingsopties',0),(213352,5927,'fi','Luottokorttimaksu vaihtoehtoja',0),(213353,5927,'no','Kredittkort betalingsmÃ¥ter',0),(213354,5927,'da','Kreditkort betalingsmuligheder',0),(213355,5927,'ko','ì‹ ìš© ì¹´ë“œ ì§€ë¶ˆ ì˜µì…˜',0),(213356,5927,'he','××¤×©×¨×•×™×•×ª ×ª×©×œ×•×ž×™× ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(213357,5927,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(213358,5927,'zh','ä¿¡ç”¨å¡ä»˜æ¬¾æ–¹å¼\r\n',0),(213359,5927,'sv','Kreditkort betalningsalternativ',0),(213360,5927,'it','Opzioni di pagamento carta di credito',0),(213361,5927,'tl','',0),(213362,5927,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3604;&#3657;&#3623;&#3618;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(213363,5927,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(213364,5927,'ms','Pilihan pembayaran kad kredit',0),(213365,5927,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø³Ø¯Ø§Ø¯ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(213366,5927,'fr','Options de paiement de carte de crÃ©dit',0),(213367,5927,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰æ”¯æ‰•ã?„ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(213368,5927,'pt','OpÃ§Ãµes de pagamento de cartÃ£o de crÃ©dito',0),(213369,5927,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð° ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ð¾Ð¹',0),(213370,5927,'es','Tarjeta de CrÃ©dito Opciones de Pago',0),(213371,5927,'de','Credit Card Payment-Optionen',0),(213372,5927,'en','Credit Card Payment Options',0),(213373,5928,'is','',0),(213374,5928,'dr','Ø§Ø¬Ø±Ø§Ø¡ Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(213375,5928,'pr','Ø§Ø¬Ø±Ø§Ø¡ Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(213376,5928,'tr','Kredi kartÄ± iÅŸlemleri yukarÄ± ayarla',0),(213377,5928,'pl','Konfigurowanie przetwarzania kart kredytowych',0),(213378,5928,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚Ðµ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(213379,5928,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(213380,5928,'sr','ÐŸÐ¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð¾Ð±Ñ€Ð°Ð´Ñƒ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(213381,5928,'vi','Setup QuÃ¡ TrÃ¬nh Xá»­ LÃ½ Tháº» TÃ­n Dá»¥ng',0),(213382,5928,'af','Opstelling van Kredietkaart Prosessering',0),(213383,5928,'ro','ÃŽnfiinÅ£at de prelucrare a cardului de Credit',0),(213384,5928,'et','Loodud krediitkaardi tÃ¶Ã¶tlemine',0),(213385,5928,'si','Nastavite kreditne kartice za obdelavo',0),(213386,5928,'ba','Mengatur pemrosesan kartu kredit',0),(213387,5928,'nl','Credit Card Processing instellen',0),(213388,5928,'fi','MÃ¤Ã¤ritÃ¤ luottokortin kÃ¤sittely',0),(213389,5928,'no','Definere kredittkortbehandling',0),(213390,5928,'da','OpsÃ¦tning af kreditkort forarbejdning',0),(213391,5928,'ko','ì‹ ìš© ì¹´ë“œ ì²˜ë¦¬ ì„¤ì •',0),(213392,5928,'he','×œ×”×’×“×™×¨ ×¢×™×‘×•×“ ×›×¨×˜×™×¡ ×”××©×¨××™',0),(213393,5928,'el','ÎˆÏ‡ÎµÎ¹ ÏƒÏ…ÏƒÏ„Î±Î¸ÎµÎ¯ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(213394,5928,'zh','è®¾ç½®ä¿¡ç”¨å¡å¤„ç†\r\n',0),(213395,5928,'sv','StÃ¤ll in kreditkort bearbetning',0),(213396,5928,'it','Impostare la carta di credito',0),(213397,5928,'tl','',0),(213398,5928,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(213399,5928,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤Šà¤ªà¤° à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(213400,5928,'ms','Sediakan pemprosesan kad kredit',0),(213401,5928,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(213402,5928,'fr','Mettre en place le traitement des cartes de crÃ©dit',0),(213403,5928,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ã?®å‡¦ç?†æ‰‹ç¶šã?®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(213404,5928,'pt','Configurar o processamento de cartÃ£o de crÃ©dito',0),(213405,5928,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(213406,5928,'es','Configurar Procedimiento para Tarjetas de CrÃ©dito',0),(213407,5928,'de','Credit Card Processing einrichten',0),(213408,5928,'en','Set Up Credit Card Processing',0),(213409,5929,'is','',0),(213410,5929,'dr','(ÙˆØ§Ø±Ø¯) Ø´ÙˆØ¯',0),(213411,5929,'pr','Ù‚Ø³Ù…Øª Ø²ÙŠØ± Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø§ÙƒÙ†ÙˆÙ† Ø«Ø¨Øª (ÙˆØ§Ø±Ø¯) Ø´ÙˆØ¯',0),(213412,5929,'tr','Åžimdi girmek iÃ§in tÄ±klayÄ±nÄ±z',0),(213413,5929,'pl','Kliknij poniÅ¼ej, aby wprowadziÄ‡ teraz',0),(213414,5929,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð´Ð¾Ð»Ñƒ, Ð·Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐµÐ³Ð°',0),(213415,5929,'ur','Ø§Ø¨ Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†ÛŒÚ†Û’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(213416,5929,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑÐ°Ð´Ð°',0),(213417,5929,'vi','Nháº¥n dÆ°á»›i Ä‘Ã¢y Ä‘á»ƒ Nháº­p bÃ¢y giá»',0),(213418,5929,'af','Klik hieronder om te tik nou',0),(213419,5929,'ro','Click mai jos pentru a intra acum',0),(213420,5929,'et','Sisestage nÃ¼Ã¼d klÃµpsake allpool',0),(213421,5929,'si','Kliknite spodaj za vstop zdaj',0),(213422,5929,'ba','Klik di bawah untuk memasukkannya sekarang',0),(213423,5929,'nl','Klik hieronder om nu',0),(213424,5929,'fi','Klikkaa alla olevia nyt',0),(213425,5929,'no','Klikk nedenfor for Ã¥ angi nÃ¥',0),(213426,5929,'da','Klik nedenfor for at indtaste nu',0),(213427,5929,'ko','ì•„ëž˜ ìž…ë ¥ í•˜ì„¸ìš”ë¥¼ í´ë¦­í•©ë‹ˆë‹¤',0),(213428,5929,'he','×œ×—×¥ ×œ×”×œ×Ÿ ×›×“×™ ×œ×”×™×›× ×¡ ×¢×›×©×™×•',0),(213429,5929,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î³Î¹Î± Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„ÏŽÏÎ±',0),(213430,5929,'zh','ç‚¹å‡»ä¸‹é¢ä»¥è¾“å…¥\r\n',0),(213431,5929,'sv','Klicka nedan fÃ¶r att ange nu',0),(213432,5929,'it','Clicca qui sotto per entrare ora',0),(213433,5929,'tl','',0),(213434,5929,'th','&#3588;&#3621;&#3636;&#3585;&#3586;&#3657;&#3634;&#3591;&#3621;&#3656;&#3634;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3652;&#3611;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(213435,5929,'hi','à¤…à¤¬ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(213436,5929,'ms','Klik di bawah untuk masukkan sekarang',0),(213437,5929,'ar','Ø§Ù†Ù‚Ø± Ø£Ø¯Ù†Ø§Ù‡ Ù„Ù„Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø¢Ù†',0),(213438,5929,'fr','Cliquez ci-dessous pour entrer maintenant',0),(213439,5929,'jp','ä»Šå…¥åŠ›ã?™ã‚‹ã?«ã?¯ä¸‹ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(213440,5929,'pt','Clique abaixo para entrar agora',0),(213441,5929,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ ÐÐ¸Ð¶Ðµ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ Ð¡ÐµÐ¹Ñ‡Ð°Ñ',0),(213442,5929,'es','Click Abajo Para Ingresar Ahora',0),(213443,5929,'de','Klicken Sie hier um jetzt eingeben',0),(213444,5929,'en','Click Below to Enter Now',0),(213445,5930,'is','',0),(213446,5930,'dr','Ø¨Ø±ÙˆÙŠØ¯ ',0),(213447,5930,'pr','Ø¨Ø±ÙˆÙŠØ¯ ',0),(213448,5930,'tr','Git',0),(213449,5930,'pl','IÅ›Ä‡',0),(213450,5930,'bg','ÐžÑ‚Ð¸Ð´ÐµÑ‚Ðµ',0),(213451,5930,'ur','Ø¬Ø§Ù†Ø§',0),(213452,5930,'sr','Ð˜Ð´Ð¸',0),(213453,5930,'vi','Äi',0),(213454,5930,'af','Gaan',0),(213455,5930,'ro','Du-te',0),(213456,5930,'et','Mine',0),(213457,5930,'si','Go',0),(213458,5930,'ba','Pergi',0),(213459,5930,'nl','Gaan',0),(213460,5930,'fi','Go',0),(213461,5930,'no','GÃ¥',0),(213462,5930,'da','GÃ¥',0),(213463,5930,'ko','ê°€ ì„œ',0),(213464,5930,'he','. ×§×“×™×ž×”',0),(213465,5930,'el','Î Î¬ÎµÎ¹',0),(213466,5930,'zh','è½¬åˆ°\r\n',0),(213467,5930,'sv','GÃ¥',0),(213468,5930,'it','Vai',0),(213469,5930,'tl','',0),(213470,5930,'th','&#3652;&#3611;',0),(213471,5930,'hi','à¤œà¤¾à¤“',0),(213472,5930,'ms','Pergi',0),(213473,5930,'ar','Ø§Ù„Ø°Ù‡Ø§Ø¨',0),(213474,5930,'fr','Aller',0),(213475,5930,'jp','é€²ã‚€',0),(213476,5930,'pt','Ir',0),(213477,5930,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸',0),(213478,5930,'es','Ir',0),(213479,5930,'de','Gehen',0),(213480,5930,'en','Go',0),(213481,5931,'is','',0),(213482,5931,'dr','Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡ Ø§Ø³Øª',0),(213483,5931,'pr','Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡ Ø§Ø³Øª',0),(213484,5931,'tr','Fatura ÅŸartlarÄ± eksik',0),(213485,5931,'pl','Warunki faktury brakuje',0),(213486,5931,'bg','Ð›Ð¸Ð¿ÑÐ²Ð°Ñ‚ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(213487,5931,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ù„Ø§Ù¾ØªÛ ÛÛŒÚº',0),(213488,5931,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸ ÑÑƒ Ð½ÐµÑÑ‚Ð°Ð»Ðµ',0),(213489,5931,'vi','Äiá»u khoáº£n hÃ³a Ä‘Æ¡n thiáº¿u',0),(213490,5931,'af','Faktuur terme is vermis',0),(213491,5931,'ro','Termeni de facturÄƒ lipsesc',0),(213492,5931,'et','Arve on puudu',0),(213493,5931,'si','Pogoje raÄuna manjkajo',0),(213494,5931,'ba','Syarat-syarat faktur hilang',0),(213495,5931,'nl','Factuur voorwaarden ontbreken',0),(213496,5931,'fi','Laskun ehtojen puuttuvat',0),(213497,5931,'no','FaktureringsvilkÃ¥r mangler',0),(213498,5931,'da','Faktura vilkÃ¥r der mangler',0),(213499,5931,'ko','ì†¡ìž¥ ì¡°ê±´ì€ ëˆ„ë½',0),(213500,5931,'he','×—×©×‘×•× ×™×ª ×ª× ××™ ×—×¡×¨×™×',0),(213501,5931,'el','Î¤Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€Î¿Ï… Î»ÎµÎ¯Ï€Î¿Ï…Î½',0),(213502,5931,'zh','å‘ç¥¨æ¡æ¬¾ä¸¢å¤±\r\n',0),(213503,5931,'sv','Faktura villkor saknas',0),(213504,5931,'it','Termini di fattura sono mancanti',0),(213505,5931,'tl','',0),(213506,5931,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3634;&#3604;&#3627;&#3634;&#3618;&#3652;&#3611;',0),(213507,5931,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§ à¤¹à¥ˆà¤‚',0),(213508,5931,'ms','Terma-terma invois yang hilang',0),(213509,5931,'ar','Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(213510,5931,'fr','ModalitÃ©s de facturation sont manquantes',0),(213511,5931,'jp','è«‹æ±‚æ?¡ä»¶ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(213512,5931,'pt','Termos de factura estÃ£o faltando',0),(213513,5931,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð° Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‚',0),(213514,5931,'es','TÃ©rminos de Factura se Falta',0),(213515,5931,'de','Rechnung Begriffe fehlen',0),(213516,5931,'en','Invoice Terms are missing',0),(213517,5932,'is','',0),(213518,5932,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ø°Ø®ÙŠØ±Ù‡ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ØªØ§ Ø²Ù…Ø§Ù†ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø±Ø¯Ø§Ø²Ø´  Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(213519,5932,'pr','Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ø°Ø®ÙŠØ±Ù‡ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ØªØ§ Ø²Ù…Ø§Ù†ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø±Ø¯Ø§Ø²Ø´  Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(213520,5932,'tr','Mevduat, kredi kartÄ± iÅŸlemi baÅŸarÄ±yla iÅŸleyene kadar kaydedilmez.',0),(213521,5932,'pl','WpÅ‚aty nie zostanÄ… zapisane do transakcji kredytowej zostaÅ‚a pomyÅ›lnie przetworzona.',0),(213522,5932,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ÑŠÑ‚ Ð½ÑÐ¼Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸, Ð´Ð¾ÐºÐ°Ñ‚Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° ÑÐ´ÐµÐ»ÐºÐ° Ðµ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(213523,5932,'ur','Ø¬Ù…Ø¹ Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº ÛÙˆÚº Ú¯Û’ ÛŒÛØ§Úº ØªÚ© Ú©Û Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ù¾Ø± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ ÛÛ’ Û”',0),(213524,5932,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½Ðµ Ð´Ð¾Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ñ€Ð°Ñ’ÐµÐ½.',0),(213525,5932,'vi','Äáº·t cá»c sáº½ khÃ´ng Ä‘Æ°á»£c lÆ°u cho Ä‘áº¿n khi giao dá»‹ch qua tháº» tÃ­n dá»¥ng Ä‘Ã£ xá»­ lÃ½',0),(213526,5932,'af','Die deposito sal nie gestoor word totdat die kredietkaarttransaksie suksesvol geprosessser is.',0),(213527,5932,'ro','Depozit nu se vor salva pÃ¢nÄƒ cÃ¢nd tranzacÅ£ia de card de credit a fost procesat cu succes.',0),(213528,5932,'et','Tagatisraha ei salvestata kuni krediitkaardi tehing on edukalt tÃ¶Ã¶deldud.',0),(213529,5932,'si','Depozita ne bodo shranjene, dokler kreditne kartice posla je bila predelana Å¾e uspeÅ¡no.',0),(213530,5932,'ba','Deposit tidak akan disimpan sampai transaksi kartu kredit telah berhasil diproses.',0),(213531,5932,'nl','De borg zal niet worden opgeslagen totdat de creditcardtransactie heeft met succes verwerkt.',0),(213532,5932,'fi','Talletus ei tallenneta, kunnes luottokorttitapahtuma on kÃ¤sitelty onnistuneesti.',0),(213533,5932,'no','Depositumet vil ikke bli lagret fÃ¸r kredittkorttransaksjonen har blitt behandlet.',0),(213534,5932,'da','Depositum vil ikke blive gemt, indtil kreditkorttransaktionen er blevet behandlet.',0),(213535,5932,'ko','ì˜ˆê¸ˆ ì‹ ìš© ì¹´ë“œ ê±°ëž˜ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì²˜ë¦¬ ëœ ë•Œê¹Œì§€ ì €ìž¥ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(213536,5932,'he','×”×¤×™×§×“×•×Ÿ ×œ× ×™×™×©×ž×¨×• ×¢×“ ×©×ª× ×•×¢×ª ×›×¨×˜×™×¡ ×”××©×¨××™ × ×¨×©×ž×” ×‘×”×¦×œ×—×”.',0),(213537,5932,'el','Î— Ï€ÏÎ¿ÎºÎ±Ï„Î±Î²Î¿Î»Î® Î´ÎµÎ½ Î¸Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„Î¿ÏÎ½ Î­Ï‰Ï‚ ÏŒÏ„Î¿Ï… Î· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Î­Ï‡ÎµÎ¹ ÎµÎºÏ„ÎµÎ»ÎµÏƒÏ„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(213538,5932,'zh','è¯¥å­˜æ¬¾å°†ä¸è¢«ä¿å­˜ï¼Œç›´åˆ°ä¿¡ç”¨å¡äº¤æ˜“å·²æˆåŠŸå¤„ç†ã€‚\r\n',0),(213539,5932,'sv','Depositionen kommer inte att sparas tills kreditkortstransaktionen har bearbetats framgÃ¥ngsrikt.',0),(213540,5932,'it','Il deposito non verrÃ  salvato finchÃ© la transazione con carta di credito Ã¨ stata elaborata correttamente.',0),(213541,5932,'tl','',0),(213542,5932,'th','&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3592;&#3609;&#3585;&#3623;&#3656;&#3634;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;\n&#3607;&#3635;&#',0),(213543,5932,'hi','à¤œà¤®à¤¾ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤•à¤°à¥‡à¤—à¤¾ à¤œà¤¬ à¤¤à¤• à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(213544,5932,'ms','Deposit tidak akan disimpan sehingga transaksi kad kredit telah berjaya diproses.',0),(213545,5932,'ar','Ù„Ù† ÙŠØªÙ… Ø­ÙØ¸ Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø­ØªÙ‰ Ù…Ø¹Ø§Ù…Ù„Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù‚Ø¯ ØªÙ… Ù…Ø¹Ø§Ù„Ø¬ØªÙ‡Ø§ Ø¨Ù†Ø¬Ø§Ø­.',0),(213546,5932,'fr','Le dÃ©pÃ´t n\'est pas enregistrÃ© jusqu\'Ã  ce que la transaction de carte de crÃ©dit a Ã©tÃ© traitÃ©e avec succÃ¨s.',0),(213547,5932,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰ã?®å‡¦ç?†ã?Œå®Œäº†ã?™ã‚‹ã?¾ã?§ã?“ã?®é ?ã?‹ã‚Šé‡‘ã?¯ä¿?å­˜ã?•ã‚Œã?¾ã?›ã‚“',0),(213548,5932,'pt','O depÃ³sito nÃ£o serÃ¡ salvo atÃ© que a transaÃ§Ã£o do cartÃ£o de crÃ©dito foi processada com Ãªxito.',0),(213549,5932,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð½Ðµ Ð±ÑƒÐ´ÑƒÑ‚ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹ Ð´Ð¾ Ñ‚ÐµÑ… Ð¿Ð¾Ñ€, Ð¿Ð¾ÐºÐ° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½.',0),(213550,5932,'es','El depÃ³sito no serÃ¡ guardado hasta que la transacciÃ³n de tarjeta de crÃ©dito ha sido procesado',0),(213551,5932,'de','Die Anzahlung wird nicht gespeichert werden, bis der Kreditkartentransaktion erfolgreich verarbeitet wurde.',0),(213552,5932,'en','The deposit will not be saved until the credit card transaction has been successfully processed.',0),(213553,5933,'is','',0),(213554,5933,'dr','Ù‡ÙŠÚ† ÙƒØ§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(213555,5933,'pr','Ù‡ÙŠÚ† ÙƒØ§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(213556,5933,'tr','HiÃ§bir iÅŸ kurmak iÃ§in hizmet sipariÅŸ No',0),(213557,5933,'pl','Nie znaleziono dla usÅ‚ugi nr zamÃ³wienia',0),(213558,5933,'bg','ÐÑÐ¼Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð·Ð° ÑƒÑÐ»ÑƒÐ³Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° #',0),(213559,5933,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø§Ù… Ù†ÛÛŒÚº Ù…Ù„Ø§ Ú©ÛŒ Ø®Ø¯Ù…Øª Ú©Û’ Ù„Ø¦Û’ Ø¢Ø±ÚˆØ± #',0),(213560,5933,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾ÑÐ»Ð° Ð½Ð°ÑˆÐ°Ð¾ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ Ð½Ð°Ñ€ÐµÐ´Ð¸ #',0),(213561,5933,'vi','KhÃ´ng tháº¥y cÃ´ng viá»‡c cho Ä‘Æ¡n hÃ ng dá»‹ch vá»¥ sá»‘',0),(213562,5933,'af','Geen werk gevind vir diensbestelling #',0),(213563,5933,'ro','Nici o lucrare gÄƒsit pentru serviciul de ordine #',0),(213564,5933,'et','Ãœkski tÃ¶Ã¶ ei leitud teenuse tellimuse nr',0),(213565,5933,'si','Brez dela naÅ¡el za storitev naroÄilo #',0),(213566,5933,'ba','Tidak ada pekerjaan ditemukan untuk layanan memesan #',0),(213567,5933,'nl','Geen werk gevonden voor service bestellen #',0),(213568,5933,'fi','TyÃ¶tÃ¤ ei lÃ¶ytynyt palvelun tilaus',0),(213569,5933,'no','Ingen arbeid funnet for tjenesten bestillingsnummer',0),(213570,5933,'da','Intet arbejde fandt for service Bestil #',0),(213571,5933,'ko','ì¼ ì„œë¹„ìŠ¤ì— ëŒ€ í•œ ë°œê²¬ # ì£¼ë¬¸',0),(213572,5933,'he','××™×Ÿ ×¢×‘×•×“×” ×©× ×ž×¦××• ×¢×‘×•×¨ ×©×™×¨×•×ª ×”×–×ž× ×ª #',0),(213573,5933,'el','ÎšÎ±Î¼Î¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î± Î²ÏÎ­Î¸Î·ÎºÎµ(Î²ÏÎ­Î¸Î·ÎºÎ±Î½) Î³Î¹Î± Ï…Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± #',0),(213574,5933,'zh','æ²¡æœ‰ä¸ºæœåŠ¡è®¢å•ï¼ƒæ‰¾åˆ°å·¥ä½œ\r\n',0),(213575,5933,'sv','Inget arbete hittade fÃ¶r tjÃ¤nsten BestÃ¤ll #',0),(213576,5933,'it','Nessun lavoro trovato per servizio ordine #',0),(213577,5933,'tl','',0),(213578,5933,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3591;&#3634;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;',0),(213579,5933,'hi','à¤•à¥‹à¤ˆ à¤•à¤¾à¤® à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ #',0),(213580,5933,'ms','Tiada kerja mendapati perkhidmatan pesanan #',0),(213581,5933,'ar','Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù„Ø§ Ø¹Ù…Ù„ Ù„Ø®Ø¯Ù…Ø© Ø§Ù„Ù†Ø¸Ø§Ù… #',0),(213582,5933,'fr','Aucun travail ne trouvÃ©s pour service no de commande',0),(213583,5933,'jp','ã?“ã?®ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ç•ªå?·ã?§ã?¯ä½œæ¥­ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(213584,5933,'pt','Nenhum trabalho encontrou para serviÃ§o ordem #',0),(213585,5933,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð° Ð´Ð»Ñ ÑÐ»ÑƒÐ¶Ð±Ñ‹ â„– Ð·Ð°ÐºÐ°Ð·Ð°',0),(213586,5933,'es','No se encontrÃ³ trabajo para orden de servicio #',0),(213587,5933,'de','Keine Arbeit gefunden fÃ¼r Dienst Auftragsnr.',0),(213588,5933,'en','No work found for service order #',0),(213589,5934,'is','',0),(213590,5934,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(213591,5934,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(213592,5934,'tr','Ã–deme tarihi',0),(213593,5934,'pl','PÅ‚atne do data',0),(213594,5934,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸-ÐºÑŠÐ¼-Ð´Ð°Ñ‚Ð°',0),(213595,5934,'ur','Ø§Ø¯Ø§ Ú©ÛŒØ§-Ú©Ø±Ù†Ø§-ØªØ§Ø±ÛŒØ®',0),(213596,5934,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(213597,5934,'vi','Tráº£ Ä‘áº¿n ngÃ y',0),(213598,5934,'af','Betaling-tot-op-Datum',0),(213599,5934,'ro','PlÄƒtitÄƒ la data',0),(213600,5934,'et','Makstud kuupÃ¤ev',0),(213601,5934,'si','PlaÄane do datuma',0),(213602,5934,'ba','Dibayar-to-date',0),(213603,5934,'nl','Betaald-to-date',0),(213604,5934,'fi','Maksettu pvm',0),(213605,5934,'no','Betalt-Ã¥-dato',0),(213606,5934,'da','Betalt til dato',0),(213607,5934,'ko','ì§€ë¶ˆ ë‚ ì§œ',0),(213608,5934,'he','×©×™×œ×ž×• ×¢×“ ×”×™×•×',0),(213609,5934,'el','ÎšÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹-to-Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(213610,5934,'zh','æœ€æ–°æ”¯ä»˜\r\n',0),(213611,5934,'sv','Betalas till datum',0),(213612,5934,'it','Paid-to-date',0),(213613,5934,'tl','',0),(213614,5934,'th','&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(213615,5934,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿',0),(213616,5934,'ms','Dibayar sehingga tarikh',0),(213617,5934,'ar','Ø§Ù„Ù…Ø³Ø¯Ø¯ Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(213618,5934,'fr','PayÃ© Ã  ce jour',0),(213619,5934,'jp','æœ¬æ—¥ã?¾ã?§ã?®æ”¯æ‰•æ¸ˆ',0),(213620,5934,'pt','Pago-to-date',0),(213621,5934,'ru','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ð» Ðº Ð”Ð°Ñ‚Ð°',0),(213622,5934,'es','Pagado-a la-fecha',0),(213623,5934,'de','Bezahlt-to-date',0),(213624,5934,'en','Paid-to-date',0),(213625,5935,'is','',0),(213626,5935,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(213627,5935,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(213628,5935,'tr','Ã–deme ayrÄ±ntÄ±larÄ±',0),(213629,5935,'pl','SzczegÃ³Å‚y pÅ‚atnoÅ›ci',0),(213630,5935,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(213631,5935,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(213632,5935,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(213633,5935,'vi','Chi tiáº¿t Thanh ToÃ¡n',0),(213634,5935,'af','Betalingsbesonderhede',0),(213635,5935,'ro','Detaliu de platÄƒ',0),(213636,5935,'et','Makse Ã¼ksikasjad',0),(213637,5935,'si','PlaÄilo podrobnosti',0),(213638,5935,'ba','Detail pembayaran',0),(213639,5935,'nl','Betaling Detail',0),(213640,5935,'fi','Maksu yksityiskohtaisesti',0),(213641,5935,'no','Betaling detaljer',0),(213642,5935,'da','Betaling detaljer',0),(213643,5935,'ko','ì§€ë¶ˆ ì„¸ë¶€ ì‚¬í•­',0),(213644,5935,'he','×¤×¨×˜×™ ×ª×©×œ×•×',0),(213645,5935,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(213646,5935,'zh','ä»˜æ¬¾æ˜Žç»†\r\n',0),(213647,5935,'sv','Utbetalning detalj',0),(213648,5935,'it','Dettaglio del pagamento',0),(213649,5935,'tl','',0),(213650,5935,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(213651,5935,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤µà¤°à¤£',0),(213652,5935,'ms','Butiran bayaran',0),(213653,5935,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¯ÙØ¹',0),(213654,5935,'fr','DÃ©tails de paiement',0),(213655,5935,'jp','æ”¯æ‰•ã?„è©³ç´°',0),(213656,5935,'pt','Detalhes de pagamento',0),(213657,5935,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(213658,5935,'es','Detalle de Pago',0),(213659,5935,'de','Zahlung Details',0),(213660,5935,'en','Payment Detail',0),(213661,5936,'is','',0),(213662,5936,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¬Ù‡Øª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´',0),(213663,5936,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¬Ù‡Øª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´',0),(213664,5936,'tr','Geri sipariÅŸ GÃ¼ncelleÅŸtirmesi',0),(213665,5936,'pl','WrÃ³Ä‡ do zamÃ³wienia aktualizacji',0),(213666,5936,'bg','ÐÐ°Ð·Ð°Ð´ Ñ Ñ†ÐµÐ» Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(213667,5936,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÙˆØ§Ù¾Ø³',0),(213668,5936,'sr','ÐÐ°Ð·Ð°Ð´ Ñƒ Ð½Ð°Ñ€ÐµÐ´Ð¸ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(213669,5936,'vi','Quay Láº¡i Cáº­p Nháº­t ÄÆ¡n Äáº·t HÃ ng',0),(213670,5936,'af','Terug na Bestelling Opdatering',0),(213671,5936,'ro','ÃŽnapoi la comanda Update',0),(213672,5936,'et','Aastasse uuendamisega',0),(213673,5936,'si','Nazaj, da posodobitev',0),(213674,5936,'ba','Kembali agar Update',0),(213675,5936,'nl','Terug naar Update bestellen',0),(213676,5936,'fi','Takaisin pÃ¤ivityksen tilaaminen',0),(213677,5936,'no','Tilbake til bestille oppdateringen',0),(213678,5936,'da','Tilbage til bestiller opdatering',0),(213679,5936,'ko','ì—…ë°ì´íŠ¸ë¥¼ ìœ„í•´ ë‹¤ì‹œ',0),(213680,5936,'he','×‘×—×–×¨×” ×œ×¦×•×•×ª ×¢×“×›×•×Ÿ',0),(213681,5936,'el','Î Î¯ÏƒÏ‰ Î³Î¹Î± Î½Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(213682,5936,'zh','å›žåˆ°è®¢è´­æ›´æ–°\r\n',0),(213683,5936,'sv','Tillbaka till bestÃ¤lla uppdatering',0),(213684,5936,'it','Torna a ordinare l\'aggiornamento',0),(213685,5936,'tl','',0),(213686,5936,'th','&#3585;&#3621;&#3633;&#3610;&#3652;&#3611;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(213687,5936,'hi','à¤µà¤¾à¤ªà¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹',0),(213688,5936,'ms','Kembali membuat pengemaskinian',0),(213689,5936,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø·Ù„Ø¨ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(213690,5936,'fr','Retour Ã  ordonner la mise Ã  jour',0),(213691,5936,'jp','æ³¨æ–‡ã?®æ›´æ–°ã?¸æˆ»ã‚‹',0),(213692,5936,'pt','Para pedir a atualizaÃ§Ã£o',0),(213693,5936,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(213694,5936,'es','AtrÃ¡s para Pedir la ActualizaciÃ³n',0),(213695,5936,'de','ZurÃ¼ck zu Update bestellen',0),(213696,5936,'en','Back to Order Update',0),(213697,5937,'is','',0),(213698,5937,'dr','AHS ÙˆØ±ÙˆØ¯ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ',0),(213699,5937,'pr','AHS ÙˆØ±ÙˆØ¯ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ',0),(213700,5937,'tr','AHS veri alma',0),(213701,5937,'pl','AHS importu danych',0),(213702,5937,'bg','ÐÐ§Ðš Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸',0),(213703,5937,'ur','Ø§ Ú©ÙˆØ§Ø¦Ù Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(213704,5937,'sr','Ð£Ð²Ð¾Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð°-Ð·',0),(213705,5937,'vi','Nháº­p Dá»¯ Liá»‡u AHS',0),(213706,5937,'af','AHS Data Invoer',0),(213707,5937,'ro','Import de date AHS',0),(213708,5937,'et','HAK andmete importimine',0),(213709,5937,'si','Uvoz podatkov AHS',0),(213710,5937,'ba','AHS Data impor',0),(213711,5937,'nl','AHS gegevens importeren',0),(213712,5937,'fi','AHS tietojen tuonti',0),(213713,5937,'no','Disponerer dataimport',0),(213714,5937,'da','AHS dataimport',0),(213715,5937,'ko','AHS ë°ì´í„° ê°€ì ¸ì˜¤ê¸°',0),(213716,5937,'he','×™×™×‘×•× × ×ª×•× ×™× AHS',0),(213717,5937,'el','AHS Î•Î¹ÏƒÎ±Î³.',0),(213718,5937,'zh','AHSçš„æ•°æ®å¯¼å…¥\r\n',0),(213719,5937,'sv','AHS dataimport',0),(213720,5937,'it','Importazione dati AHS',0),(213721,5937,'tl','',0),(213722,5937,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621; AHS',0),(213723,5937,'hi','AHS à¤¡à¥‡à¤Ÿà¤¾ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(213724,5937,'ms','AHS Data Import',0),(213725,5937,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¨ÙŠØ§Ù†Ø§Øª Ø¹Ø¨Ø¯ Ø§Ù„Ø­Ù…ÙŠØ¯ Ø´ÙˆÙ…Ø§Ù†',0),(213726,5937,'fr','Importation de donnÃ©es du papa',0),(213727,5937,'jp','ï¼¡ï¼¨ï¼³ãƒ‡ãƒ¼ã‚¿ã?®ã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆ',0),(213728,5937,'pt','ImportaÃ§Ã£o de dados AHS',0),(213729,5937,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… AHS',0),(213730,5937,'es','Importar Datos de AHS',0),(213731,5937,'de','AHS-Datenimport',0),(213732,5937,'en','AHS Data Import',0),(213733,5938,'is','',0),(213734,5938,'dr','ØªØ§Ø²Ù‡ ÙƒØ±Ø¯Ù† Ùˆ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ\r\nAHS',0),(213735,5938,'pr','ØªØ§Ø²Ù‡ ÙƒØ±Ø¯Ù† Ùˆ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ\r\nAHS',0),(213736,5938,'tr','AHS veri yenileme ve gÃ¶rÃ¼ntÃ¼leme',0),(213737,5938,'pl','OdÅ›wieÅ¼anie i wyÅ›wietlania danych AHS',0),(213738,5938,'bg','ÐžÐ±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð¸ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÐÐ§Ðš Ð´Ð°Ð½Ð½Ð¸',0),(213739,5938,'ur','Ø§ Ú©ÙˆØ§Ø¦Ù ØªØ§Ø²Û Ú©Ø±ÛŒÚº Ø§ÙˆØ± ÚˆØ³Ù¾Ù„Û’',0),(213740,5938,'sr','ÐžÑÐ²ÐµÐ¶Ð°Ð²Ð°ÑšÐµ Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð°-Ð·',0),(213741,5938,'vi','LÃ m Má»›i & Hiá»ƒn Thá»‹ Dá»¯ Liá»‡u AHS ',0),(213742,5938,'af','Verfris en Wys AHS Data',0),(213743,5938,'ro','ReÃ®mprospÄƒtare ÅŸi Display AHS date',0),(213744,5938,'et','VÃ¤rskenda ja ekraani AHS andmed',0),(213745,5938,'si','OsveÅ¾itev in prikaz podatkov AHS',0),(213746,5938,'ba','Data AHS refresh dan tampilan',0),(213747,5938,'nl','Vernieuwen en Display AHS gegevens',0),(213748,5938,'fi','PÃ¤ivitÃ¤ ja nÃ¤yttÃ¶ AHS tiedot',0),(213749,5938,'no','Oppdater og Vis Disponerer Data',0),(213750,5938,'da','Opdater og Display AHS Data',0),(213751,5938,'ko','AHS ë°ì´í„° ìƒˆë¡œ ê³ ì¹¨ ë° ë””ìŠ¤í”Œë ˆì´',0),(213752,5938,'he','×¨×¢× ×•×Ÿ ×•×œ×”×¦×™×’ × ×ª×•× ×™× AHS',0),(213753,5938,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ·Ï‚ ÎºÎ±Î¹ ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ AHS',0),(213754,5938,'zh','æ›´æ–°æ˜¾ç¤ºAHSçš„æ•°æ®\r\n',0),(213755,5938,'sv','Uppdatera och Visa AHS Data',0),(213756,5938,'it','Visualizzazione e aggiornamento dati AHS',0),(213757,5938,'tl','',0),(213758,5938,'th','&#3619;&#3637;&#3648;&#3615;&#3619;&#3594;&#3649;&#3621;&#3632;&#3649;&#3626;&#3604;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621; AHS',0),(213759,5938,'hi','AHS à¤¡à¥‡à¤Ÿà¤¾ à¤¤à¤¾à¤œà¤¼à¤¾ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨',0),(213760,5938,'ms','Segar semula dan paparan Data AHS',0),(213761,5938,'ar','Ø¹Ø±Ø¶ ÙˆØªØ­Ø¯ÙŠØ« Ø¨ÙŠØ§Ù†Ø§Øª Ø¹Ø¨Ø¯ Ø§Ù„Ø­Ù…ÙŠØ¯ Ø´ÙˆÙ…Ø§Ù†',0),(213762,5938,'fr','Actualisation et affichage des donnÃ©es du papa',0),(213763,5938,'jp','æ›´æ–°ã?—ã?¦AHSãƒ‡ãƒ¼ã‚¿ã‚’è¡¨ç¤ºã?•ã?›ã‚‹',0),(213764,5938,'pt','Atualizar e exibir dados AHS',0),(213765,5938,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¸ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ Ð´Ð°Ð½Ð½Ñ‹Ñ… AHS',0),(213766,5938,'es','Renovar y Desplegar Datos de AHS',0),(213767,5938,'de','AHS-Daten aktualisieren und anzeigen',0),(213768,5938,'en','Refresh and Display AHS Data',0),(213769,5939,'is','',0),(213770,5939,'dr','Ø¢Ø¯Ø±Ø³ Ø¨Ø§Ù†Ùƒ  Ø´Ù‡Ø±   Ø§Ø³ØªØ§Ù†   ÙƒØ¯Ù¾Ø³ØªÙŠ',0),(213771,5939,'pr','Ø¢Ø¯Ø±Ø³ Ø¨Ø§Ù†Ùƒ  Ø´Ù‡Ø±   Ø§Ø³ØªØ§Ù†   ÙƒØ¯Ù¾Ø³ØªÙŠ',0),(213772,5939,'tr','Banka adresi, ÅŸehir, eyalet, ZIP',0),(213773,5939,'pl','Banku adres, miasto, stan, Zip',0),(213774,5939,'bg','Ð‘Ð°Ð½ÐºÐ°Ñ‚Ð° Ð°Ð´Ñ€ÐµÑ, Ð³Ñ€Ð°Ð´, Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°, Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸',0),(213775,5939,'ur','Ø¨ÛŒÙ†Ú© Ù¾ØªÛØŒ Ø´ÛØ±ØŒ Ø±ÛŒØ§Ø³ØªØŒ Ø²Ù¾',0),(213776,5939,'sr','Ð‘Ð°Ð½ÐºÐ° Ð°Ð´Ñ€ÐµÑÑƒ, Ð³Ñ€Ð°Ð´, Ð´Ñ€Ð¶Ð°Ð²Ñƒ, Ð¿Ð¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸',0),(213777,5939,'vi','Äá»‹a chá»‰ NgÃ¢n hÃ ng, thÃ nh phá»‘, tiá»ƒu bang, Xip',0),(213778,5939,'af','Bank Adres, Dorp/Stad, Provinsie, Poskode',0),(213779,5939,'ro','Banca adresÄƒ, oraÅŸ, stat, Zip',0),(213780,5939,'et','Panga aadress, linn, riik, Zip',0),(213781,5939,'si','Banka naslov, mesto, drÅ¾ava, Zip',0),(213782,5939,'ba','Bank alamat, kota, negara, Zip',0),(213783,5939,'nl','Bank adres, stad, staat, Zip',0),(213784,5939,'fi','Pankin osoite, kaupunki, alue, postinumero',0),(213785,5939,'no','Banken adresse, by, delstat, postnummer',0),(213786,5939,'da','Bank adresse, by, stat, Zip',0),(213787,5939,'ko','ì€í–‰ ì£¼ì†Œ, ë„ì‹œ, ìƒíƒœ, ìš°íŽ¸',0),(213788,5939,'he','×”×‘× ×§ ×›×ª×•×‘×ª, ×¢×™×¨, ×ž×“×™× ×”, ×ž×™×§×•×“',0),(213789,5939,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·, Ï€ÏŒÎ»Î·, ÎÎ¿Î¼ÏŒÏ‚, Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(213790,5939,'zh','é“¶è¡Œåœ°å€ï¼Œå¸‚ï¼Œå·žï¼Œé‚®ç¼–\r\n',0),(213791,5939,'sv','Bankens adress, stad, stat, Zip',0),(213792,5939,'it','Banca indirizzo, City, State, Zip',0),(213793,5939,'tl','',0),(213794,5939,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;,&#3629;&#3635;&#3648;&#3616;&#3629;,&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;,&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;&#3586;&#3629;&#3591;&#3608;&#3609;',0),(213795,5939,'hi','à¤¬à¥ˆà¤‚à¤• à¤•à¤¾ à¤ªà¤¤à¤¾, à¤¶à¤¹à¤°, à¤°à¤¾à¤œà¥à¤¯, à¤œà¤¼à¤¿à¤ª',0),(213796,5939,'ms','Bank alamat, bandar, Negeri, Zip',0),(213797,5939,'ar','Ø¨Ù†Ùƒ Ø§Ù„Ø¹Ù†ÙˆØ§Ù†ØŒ Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©ØŒ Ø§Ù„Ø¯ÙˆÙ„Ø©ØŒ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(213798,5939,'fr','La Banque adresse, ville, Ã‰tat, Zip',0),(213799,5939,'jp','éŠ€è¡Œä½?æ‰€ã€?å¸‚ç”ºæ?‘ã€?éƒ½é?“åºœçœŒã€?éƒµä¾¿ç•ªå?·',0),(213800,5939,'pt','Banco morada, cidade, estado, Zip',0),(213801,5939,'ru','Ð‘Ð°Ð½ÐºÐ°, Ð°Ð´Ñ€ÐµÑ, Ð³Ð¾Ñ€Ð¾Ð´, ÑˆÑ‚Ð°Ñ‚, Zip',0),(213802,5939,'es','DirecciÃ³n de Banco, Ciudad, Estado, CÃ³digo Postal',0),(213803,5939,'de','Bank Adresse, Stadt, State, Zip',0),(213804,5939,'en','Bank Address, City, State, Zip',0),(213805,5940,'is','',0),(213806,5940,'dr','Ú†Ú© Ø³ÙÙŠØ¯ Ø§Ù…Ø¶Ø§Ø¡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(213807,5940,'pr','Ú†Ú© Ø³ÙÙŠØ¯ Ø§Ù…Ø¶Ø§Ø¡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(213808,5940,'tr','AÃ§Ä±k Ã§ek stok',0),(213809,5940,'pl','Czas wyboru puste',0),(213810,5940,'bg','ÐŸÑ€Ð°Ð·ÐµÐ½ Ñ‡ÐµÐº ÑÑŠÑÑ‚Ð°Ð²',0),(213811,5940,'ur','Ø®Ø§Ù„ÛŒ Ú†ÛŒÚ© Ø§Ø³Ù¹Ø§Ú©',0),(213812,5940,'sr','Ð‘Ð»Ð°Ð½ÐºÐ¾ Ñ‡ÐµÐº Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(213813,5940,'vi','HÃ ng SÃ©c tá»“n ',0),(213814,5940,'af','Blanko Tjekvoorraad',0),(213815,5940,'ro','Stoc de cec Ã®n alb',0),(213816,5940,'et','TÅ¡ekk Stock',0),(213817,5940,'si','Prazen preverjanje zaloge',0),(213818,5940,'ba','Cek kosong saham',0),(213819,5940,'nl','Selectievakje lege voorraad',0),(213820,5940,'fi','Blank Check varastossa',0),(213821,5940,'no','Tom lager',0),(213822,5940,'da','Blankocheck lager',0),(213823,5940,'ko','ë°±ì§€ ìˆ˜ í‘œ ì£¼ì‹',0),(213824,5940,'he','×ž× ×™×•×ª ×¦\'×§ ×¤×ª×•×ª',0),(213825,5940,'el','Î›ÎµÏ…ÎºÎ® ÎµÏ€Î¹Ï„Î±Î³Î® Î±Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(213826,5940,'zh','ç©ºç™½æ”¯ç¥¨è‚¡ç¥¨\r\n',0),(213827,5940,'sv','Blank Check lager',0),(213828,5940,'it','Blank Check Stock',0),(213829,5940,'tl','',0),(213830,5940,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3626;&#3605;&#3655;&#3629;&#3585;&#3607;&#3637;&#3656;&#3623;&#3656;&#3634;&#3591;',0),(213831,5940,'hi','à¤–à¤¾à¤²à¥€ à¤šà¥‡à¤• à¤¶à¥‡à¤¯à¤°',0),(213832,5940,'ms','Stok cek kosong',0),(213833,5940,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… Ø´ÙŠÙƒØ§Ù‹ Ø¹Ù„Ù‰ Ø¨ÙŠØ§Ø¶',0),(213834,5940,'fr','Stock de chÃ¨que en blanc',0),(213835,5940,'jp','æœªè¨˜å…¥å°?åˆ‡æ‰‹å¸³',0),(213836,5940,'pt','Estoque de cheque em branco',0),(213837,5940,'ru','Ð‘Ð»Ð°Ð½Ñˆ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹',0),(213838,5940,'es','Stock de Cheque Blanco',0),(213839,5940,'de','Leere Lager',0),(213840,5940,'en','Blank Check Stock',0),(213841,5941,'is','',0),(213842,5941,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ú†Ø§Ù¾ ',0),(213843,5941,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ú†Ø§Ù¾ ',0),(213844,5941,'tr','BaskÄ± kontrol',0),(213845,5941,'pl','Wyboru druku',0),(213846,5941,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð¿ÐµÑ‡Ð°Ñ‚',0),(213847,5941,'ur','Ø·Ø¨Ø§Ø¹Øª Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(213848,5941,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(213849,5941,'vi','In SÃ©c',0),(213850,5941,'af','Merk Druk',0),(213851,5941,'ro','VerificaÅ£i imprimarea',0),(213852,5941,'et','Kontrollige printimise',0),(213853,5941,'si','Preverite tiskanje',0),(213854,5941,'ba','Memeriksa pencetakan',0),(213855,5941,'nl','Afdrukken controleren',0),(213856,5941,'fi','Tarkistaa tulostusta',0),(213857,5941,'no','Sjekk utskrift',0),(213858,5941,'da','Check udskrivning',0),(213859,5941,'ko','ì¸ì‡„ í™•ì¸',0),(213860,5941,'he','×”×¡×™×ž×•×Ÿ ×”×“×¤×¡×”',0),(213861,5941,'el','Î•Î»Î­Î³Ï‡Î¿Ï… ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(213862,5941,'zh','æ£€æŸ¥æ‰“å°\r\n',0),(213863,5941,'sv','Incheckningen utskrift',0),(213864,5941,'it','Controllare la stampa',0),(213865,5941,'tl','',0),(213866,5941,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3594;&#3655;&#3588;',0),(213867,5941,'hi','à¤›à¤ªà¤¾à¤ˆ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(213868,5941,'ms','Semak cetakan',0),(213869,5941,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ØµÙ‘ÙƒÙˆÙƒ',0),(213870,5941,'fr','VÃ©rifier l\'impression',0),(213871,5941,'jp','å°?åˆ‡æ‰‹ã?®å?°åˆ·',0),(213872,5941,'pt','ImpressÃ£o de cheque',0),(213873,5941,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(213874,5941,'es','ImpresiÃ³n de Cheques',0),(213875,5941,'de','Scheckdruck',0),(213876,5941,'en','Check Printing',0),(213877,5942,'is','',0),(213878,5942,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¬Ø²Ø¡ Ø¨Ù‡ Ø¬Ø²Ø¡',0),(213879,5942,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¬Ø²Ø¡ Ø¨Ù‡ Ø¬Ø²Ø¡',0),(213880,5942,'tr','AyrÄ±ntÄ±lÄ± banka bilgileri',0),(213881,5942,'pl','Bank szczegÃ³Å‚owe informacje',0),(213882,5942,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð±Ð°Ð½ÐºÐ¾Ð²Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(213883,5942,'ur','Ø¨ÛŒÙ†Ú© Ú©ÛŒ ØªÙØµÛŒÙ„ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(213884,5942,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð´ÐµÑ‚Ð°Ñ™Ð½Ðµ Ð±Ð°Ð½Ñ†Ð¸',0),(213885,5942,'vi','ThÃ´ng tin ngÃ¢n hÃ ng chi tiáº¿t',0),(213886,5942,'af','Gedetailleerde Bank Inligting',0),(213887,5942,'ro','InformaÅ£iile detaliate bancare',0),(213888,5942,'et','Detailne pangaandmed',0),(213889,5942,'si','Podrobno banÄne podatke',0),(213890,5942,'ba','Informasi rinci Bank',0),(213891,5942,'nl','Gedetailleerde bankinformatie',0),(213892,5942,'fi','Yksityiskohtaiset pankin tiedot',0),(213893,5942,'no','Detaljert bankinformasjon',0),(213894,5942,'da','Detaljerede bankoplysninger',0),(213895,5942,'ko','ìžì„¸í•œ ì€í–‰ ì •ë³´',0),(213896,5942,'he','×ž×™×“×¢ ×‘× ×§ ×ž×¤×•×¨×˜',0),(213897,5942,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¯Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(213898,5942,'zh','è¯¦ç»†çš„é“¶è¡Œä¿¡æ¯\r\n',0),(213899,5942,'sv','Detaljerad bankinformation',0),(213900,5942,'it','Informazioni dettagliate della banca',0),(213901,5942,'tl','',0),(213902,5942,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(213903,5942,'hi','à¤µà¤¿à¤¸à¥à¤¤à¥ƒà¤¤ à¤¬à¥ˆà¤‚à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(213904,5942,'ms','Maklumat terperinci Bank',0),(213905,5942,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ØµØ±Ù Ø§Ù„Ù…ÙØµÙ‘Ù„Ø©',0),(213906,5942,'fr','Informations dÃ©taillÃ©es',0),(213907,5942,'jp','éŠ€è¡Œæƒ…å ±ã?®è©³ç´°',0),(213908,5942,'pt','InformaÃ§Ãµes detalhadas do banco',0),(213909,5942,'ru','Ð”ÐµÑ‚Ð°Ð»ÑŒÐ½Ð°Ñ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð‘Ð°Ð½ÐºÐ°',0),(213910,5942,'es','InformaciÃ³n Detallado del Banco',0),(213911,5942,'de','AusfÃ¼hrliche Bankdaten',0),(213912,5942,'en','Detailed Bank Information',0),(213913,5943,'is','',0),(213914,5943,'dr','Ø¨Ø±Ø§ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ Ù…Ø³ØªÙ‚ÙŠÙ… Ùˆ Ú†Ø§Ù¾ Ú†Ùƒ ',0),(213915,5943,'pr','Ø¨Ø±Ø§ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ Ù…Ø³ØªÙ‚ÙŠÙ… Ùˆ Ú†Ø§Ù¾ Ú†Ùƒ ',0),(213916,5943,'tr','DoÄŸrudan yatÄ±rma ve onay baskÄ± iÃ§in',0),(213917,5943,'pl','Do przelewu i wyboru druku',0),(213918,5943,'bg','Ð—Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° Ñ‡ÐµÐº',0),(213919,5943,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ø§ÙˆØ± Ú†ÛŒÚ© Ø·Ø¨Ø§Ø¹Øª Ú©Û’ Ù„ÛŒÛ’',0),(213920,5943,'sr','Ð—Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ ÑˆÑ‚Ð°Ð¼Ð¿Ñƒ',0),(213921,5943,'vi','DÃ nh cho giao dá»‹ch trá»±c tiáº¿p & in SÃ©c',0),(213922,5943,'af','Vir Direkte Deposito en uitdruk van tjeks',0),(213923,5943,'ro','Pentru direct de depozit ÅŸi selectare imprimare',0),(213924,5943,'et','Otsene hoiuste ja vÃ¤ljaregistreerimine printimiseks',0),(213925,5943,'si','Za neposredni polog in potrdite tiskanje',0),(213926,5943,'ba','Untuk deposit langsung dan memeriksa pencetakan',0),(213927,5943,'nl','Voor directe storting en selectievakje afdrukken',0),(213928,5943,'fi','Suora talletus ja tarkistaa tulostusta',0),(213929,5943,'no','For direkte innskudd og sjekk utskrift',0),(213930,5943,'da','For direkte indbetaling og check udskrivning',0),(213931,5943,'ko','ì§ì ‘ ìž…ê¸ˆ ë° ìˆ˜ í‘œ ì¸ì‡„ì— ëŒ€ í•œ',0),(213932,5943,'he','×”×¤×§×“×” ×™×©×™×¨×” ×•×”×“×¤×¡×” ×¡×™×ž×•×Ÿ',0),(213933,5943,'el','Î“Î¹Î± Ï„Î·Î½ Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎºÎ±Î¹ ÎµÎ»Î­Î³Ï‡Î¿Ï… ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(213934,5943,'zh','ç›´æŽ¥å­˜æ¬¾å’Œæ”¯ç¥¨æ‰“å°\r\n',0),(213935,5943,'sv','FÃ¶r direkt insÃ¤ttning och incheckningen utskrift',0),(213936,5943,'it','Per deposito diretto e controllo stampa',0),(213937,5943,'tl','',0),(213938,5943,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3594;&#3655;&#3',0),(213939,5943,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤”à¤° à¤šà¥‡à¤• à¤›à¤ªà¤¾à¤ˆ à¤•à¥‡ à¤²à¤¿à¤',0),(213940,5943,'ms','Bagi deposit terus dan mencetak cek',0),(213941,5943,'ar','Ù„Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± ÙˆØ§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(213942,5943,'fr','Pour le dÃ©pÃ´t direct et cocher impression',0),(213943,5943,'jp','å?£åº§æŒ¯è¾¼ã?¨å°?åˆ‡æ‰‹å?°åˆ·ã?®',0),(213944,5943,'pt','Para a impressÃ£o do cheque e depÃ³sito direto',0),(213945,5943,'ru','Ð”Ð»Ñ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ',0),(213946,5943,'es','Para depÃ³sito directo y impresiÃ³n de cheques',0),(213947,5943,'de','FÃ¼r direkte Ablagerung und Scheckdruck',0),(213948,5943,'en','For direct deposit and check printing',0),(213949,5944,'is','',0),(213950,5944,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ  ÙƒØ³Ø±ÙŠ ',0),(213951,5944,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ  ÙƒØ³Ø±ÙŠ ',0),(213952,5944,'tr','Kesirli yÃ¶nlendirme numarasÄ±',0),(213953,5944,'pl','LiczbÄ™ uÅ‚amkowÄ… z zakresu routingu',0),(213954,5944,'bg','Ð¤Ñ€Ð°ÐºÑ†Ð¸Ð¾Ð½ÐµÐ½ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð° Ñ‡Ð¸ÑÐ»Ð¾',0),(213955,5944,'ur','Ú©Ø³Ø±ÛŒ Ø±ÙˆÙ¹Ù†Ú¯ Ù†Ù…Ø¨Ø±',0),(213956,5944,'sr','Ð”ÐµÑ†Ð¸Ð¼Ð°Ð»Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¾Ð³ Ð¿Ð¾ÑÑ‚ÑƒÐ¿ÐºÐ°',0),(213957,5944,'vi','Sá»‘ Ä‘á»‹nh tuyáº¿n phÃ¢n sá»‘',0),(213958,5944,'af','Fractional Routing nommer',0),(213959,5944,'ro','NumÄƒr fracÅ£ionar rutare',0),(213960,5944,'et','Fractional protsessikood',0),(213961,5944,'si','Britansko Å¡tevilka proizvodnega postopka',0),(213962,5944,'ba','Nomor Routing pecahan',0),(213963,5944,'nl','Fractionele bewerkingsplannummer',0),(213964,5944,'fi','Fractional reititysnumero',0),(213965,5944,'no','Ruting tall',0),(213966,5944,'da','Fraktioneret registreringsnummeret',0),(213967,5944,'ko','ë¶„ìˆ˜ ì—¬ì • ìˆ˜',0),(213968,5944,'he','×ž×¡×¤×¨ ×”× ×™×ª×•×‘ ×”×—×œ×§×™',0),(213969,5944,'el','ÎšÎ»Î±ÏƒÎ¼Î±Ï„Î¹ÎºÏŒÏ‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(213970,5944,'zh','éƒ¨åˆ†è·¯å¾„å·ç \r\n',0),(213971,5944,'sv','Fraktionerad Routing Number',0),(213972,5944,'it','Numero frazionario di Routing',0),(213973,5944,'tl','',0),(213974,5944,'th','&#3651;&#3626;&#3656;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3623;&#3640;&#3656;&#3609;&#3623;&#3634;&#3618;&#3648;&#3611;&#3655;&#3609;&#3648;&#3624;&#3625;&#3626;&#3656;&#3623;&#3609;',0),(213975,5944,'hi','à¤­à¤¿à¤¨à¥à¤¨à¤¾à¤¤à¥à¤®à¤• à¤…à¤¨à¥à¤®à¤¾à¤°à¥à¤—à¤£ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(213976,5944,'ms','Pecahan jumlah penghalaan',0),(213977,5944,'ar','Ø§Ù„Ø¹Ø¯Ø¯ Ø§Ù„ÙƒØ³Ø±ÙŠ Ø§Ù„ØªÙˆØ¬ÙŠÙ‡',0),(213978,5944,'fr','Nombre fractionnaire de routage',0),(213979,5944,'jp','åˆ†æ•°ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå?·',0),(213980,5944,'pt','NÃºmero fracionÃ¡rio de roteamento',0),(213981,5944,'ru','Ð”Ñ€Ð¾Ð±Ð½Ð¾Ðµ Ñ‡Ð¸ÑÐ»Ð¾ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(213982,5944,'es','NÃºmero de Routing Fraccional',0),(213983,5944,'de','Gebrochene Bankleitzahl',0),(213984,5944,'en','Fractional Routing Number',0),(213985,5945,'is','',0),(213986,5945,'dr','1',0),(213987,5945,'pr','Ú†Ø§Ù¾ Ù‡Ø§ÙŠ Ø§ÙˆÙ„ÙŠÙ‡ Ú†Ùƒ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± â€“ Ø±ÙˆØ´  1',0),(213988,5945,'tr','Ã–nceden basÄ±lmÄ±ÅŸ onay stok-Style #1',0),(213989,5945,'pl','Nadrukiem sprawdzanie zapasÃ³w stylu #1',0),(213990,5945,'bg','ÐŸÐ¾ÑÑÐ½Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð° ÑÑ‚Ð¸Ð» #1',0),(213991,5945,'ur','Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹Ø¯ Ú†ÛŒÚ© Ø§Ø³Ù¹Ø§Ú© Ø·Ø±Ø² #1',0),(213992,5945,'sr','Ð¤Ð°Ð±Ñ€Ð¸Ñ‡ÐºÐ¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ñƒ ÑÑ‚Ð¸Ð»Ñƒ #1',0),(213993,5945,'vi','Kiá»ƒu dÃ¡ng SÃ©c in trÆ°á»›c sá»‘ 1',0),(213994,5945,'af','Vooruitgedrukte Tjek Voorraad-Styl #1',0),(213995,5945,'ro','Selectare pre-imprimate stil stoc #1',0),(213996,5945,'et','ValmistrÃ¼kitud sisse Stock-stiil #1',0),(213997,5945,'si','Nespremenljivo Äek staleÅ¾-Style #1',0),(213998,5945,'ba','Cetakan Check saham-gaya #1',0),(213999,5945,'nl','Voorgedrukte selectievakje Stock-Style #1',0),(214000,5945,'fi','Esipainettua uloskirjautuminen Stock-tyylinen #1',0),(214001,5945,'no','Fortrykt av lager-stil #1',0),(214002,5945,'da','Fortrykt kontrol lager-stil #1',0),(214003,5945,'ko','ì¸ì‡„ ëœ ìˆ˜ í‘œ ì£¼ì‹-ìŠ¤íƒ€ì¼ #1',0),(214004,5945,'he','×”×¡×™×ž×•×Ÿ ×ž×•×“×¤×¡ ×ž×¨××© ×ž×œ××™ ×‘×¡×’× ×•×Ÿ #1',0),(214005,5945,'el','Î ÏÎ¿Ï„Ï…Ï€Ï‰Î¼Î­Î½ÎµÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÏƒÏ„Î¹Î» #1',0),(214006,5945,'zh','é¢„å°æŸ¥çœ‹åº“å­˜é£Žæ ¼ï¼ƒ1\r\n',0),(214007,5945,'sv','FÃ¶rtryckta kontroll lager stil #1',0),(214008,5945,'it','Prestampati Check Stock-stile #1',0),(214009,5945,'tl','',0),(214010,5945,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3626;&#3605;&#3655;&#3629;&#3585;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3656;&#3629;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660; #1',0),(214011,5945,'hi','Preprinted à¤šà¥‡à¤• à¤¶à¥‡à¤¯à¤°-à¤¶à¥ˆà¤²à¥€ #1',0),(214012,5945,'ms','Pracetak semak stok-gaya #1',0),(214013,5945,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù…Ø·Ø¨ÙˆØ¹ Ø¹Ù„Ù‰ ØºØ±Ø§Ø± Ø§Ù„Ø£Ø³Ù‡Ù… #1',0),(214014,5945,'fr','ChÃ¨que prÃ©imprimÃ© Style Stock #1',0),(214015,5945,'jp','äº‹å‰?å?°åˆ·å°?åˆ‡æ‰‹åœ¨åº«',0),(214016,5945,'pt','SeleÃ§Ã£o prÃ©-impresso estilo Stock #1',0),(214017,5945,'ru','ÐŸÐ»Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð°Ñ ÑÑ‚Ð¸Ð»ÑŒ #1',0),(214018,5945,'es','Estilo-Stock #1 de Cheque Preimprimido',0),(214019,5945,'de','Vorgedruckte Check Stock-Style #1',0),(214020,5945,'en','Preprinted Check Stock-Style #1',0),(214021,5946,'is','',0),(214022,5946,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø§Ø³Øª ',0),(214023,5946,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø§Ø³Øª ',0),(214024,5946,'tr','Hesap numarasÄ± gerekli',0),(214025,5946,'pl','Numer konta',0),(214026,5946,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¸Ð·Ð¸ÑÐºÐ²Ð°',0),(214027,5946,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(214028,5946,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð°Ð½ Ñ˜Ðµ Ð±Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(214029,5946,'vi','YÃªu Cáº§u Sá»‘ TK',0),(214030,5946,'af','Rekeningnommer word Benodig',0),(214031,5946,'ro','Numarul contului este obligatoriu',0),(214032,5946,'et','Vajaliku arvu',0),(214033,5946,'si','Å tevilka raÄuna zahteva',0),(214034,5946,'ba','Nomor Akun Diperlukan',0),(214035,5946,'nl','Rekeningnummer dat vereist is',0),(214036,5946,'fi','Tilinumero vaaditaan',0),(214037,5946,'no','Kontonummeret som kreves',0),(214038,5946,'da','Kontonummer krÃ¦ves',0),(214039,5946,'ko','ê³„ì • ë²ˆí˜¸',0),(214040,5946,'he','× ×“×¨×© ×ž×¡×¤×¨ ×—×©×‘×•×Ÿ',0),(214041,5946,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹',0),(214042,5946,'zh','æ‰€éœ€çš„å¸æˆ·å·ç \r\n',0),(214043,5946,'sv','Kontonummer krÃ¤vs',0),(214044,5946,'it','E\' richiesto il numero del profilo',0),(214045,5946,'tl','',0),(214046,5946,'th','&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(214047,5946,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(214048,5946,'ms','Nombor akaun yang dikehendaki',0),(214049,5946,'ar','Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ù…Ø·Ù„ÙˆØ¨',0),(214050,5946,'fr','NumÃ©ro de compte nÃ©cessaire',0),(214051,5946,'jp','æœªè¨˜å…¥å°?åˆ‡æ‰‹å¸³ã?«å¿…è¦?ã?ªã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå?·',0),(214052,5946,'pt','NÃºmero de conta necessÃ¡rios',0),(214053,5946,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ',0),(214054,5946,'es','NÃºmero de Cuenta Requerido',0),(214055,5946,'de','Konto-Nummer erforderlich',0),(214056,5946,'en','Account Number Required',0),(214057,5947,'is','',0),(214058,5947,'dr','.',0),(214059,5947,'pr','Ø¢Ø¯Ø±Ø³ Ø¨Ø§Ù†Ùƒ  Ø¨Ø±Ø§ÙŠ  Ù¾Ø±ÙŠÙ†Øª Ù‡Ø§ÙŠ Ú†Ú© Ø³ÙÙŠØ¯ Ø§Ù…Ø¶Ø§Ø¡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ù„Ø§Ø²Ù… Ø§Ø³Øª.',0),(214060,5947,'tr','Banka adresi iÃ§in aÃ§Ä±k Ã§ek stok gerekli yazdÄ±rÄ±r.',0),(214061,5947,'pl','Wymagany czas drukuje puste pole wyboru adres banku.',0),(214062,5947,'bg','ÐÐ´Ñ€ÐµÑ Ð½Ð° Ð±Ð°Ð½ÐºÐ°Ñ‚Ð°, Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸ Ð·Ð° Ð¿Ñ€Ð°Ð·ÐµÐ½ Ñ‡ÐµÐº ÑÑŠÑÑ‚Ð°Ð² ÑÐµ Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°.',0),(214063,5947,'ur','Ø¨ÛŒÙ†Ú© Ø®Ø§Ù„ÛŒ Ú†ÛŒÚ© Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ù„Ø¦Û’ Ù…Ø·Ù„ÙˆØ¨Û Ù¾ØªÛ Ú†Ú¾Ø§Ù¾ØªØ§ ÛÛ’ Û”',0),(214064,5947,'sr','Ð‘Ð°Ð½ÐºÐ° Ð°Ð´Ñ€ÐµÑÐ° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð·Ð° Ð‘Ð»Ð°Ð½ÐºÐ¾ Ñ‡ÐµÐº Ð°ÐºÑ†Ð¸Ñ˜Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°.',0),(214065,5947,'vi','YÃªu cáº§u Ä‘á»‹a chá»‰ ngÃ¢n hÃ ng',0),(214066,5947,'af','Bank Adres word benodig vir blanko tjek voorraad uitdrukke.',0),(214067,5947,'ro','Adresa Banca necesare pentru stocul de cec Ã®n alb printuri.',0),(214068,5947,'et','Panga aadressi vaja tÃ¼hje stock pildid.',0),(214069,5947,'si','Naslov banke za prazen preverjanje zaloge natisne.',0),(214070,5947,'ba','Alamat Bank diperlukan untuk cek kosong saham cetakan.',0),(214071,5947,'nl','Bank adres vereist voor selectievakje lege voorraad afdrukken.',0),(214072,5947,'fi','Pankin osoite tarvittaessa valtakirjaa kaluston tulostaa.',0),(214073,5947,'no','Bankadressen kreves for tom lager utskrifter.',0),(214074,5947,'da','Bank adresse pÃ¥krÃ¦vet for blankocheck stock udskrifter.',0),(214075,5947,'ko','ë°±ì§€ ìˆ˜ í‘œ ì£¼ì‹ì— í•„ìš”í•œ ì€í–‰ ì£¼ì†Œë¥¼ ì¸ì‡„ í•©ë‹ˆë‹¤.',0),(214076,5947,'he','×›×ª×•×‘×ª ×”×‘× ×§ × ×“×¨×© ×¢×‘×•×¨ ×”×“×¤×¡×™× ×ž× ×™×•×ª ×¦\'×§ ×¤×ª×•×ª.',0),(214077,5947,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î± Î»ÎµÏ…ÎºÎ® ÎµÏ€Î¹Ï„Î±Î³Î® Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚.',0),(214078,5947,'zh','é“¶è¡Œåœ°å€éœ€è¦æ‰“å°ä¸€å¼ ç©ºç™½æ”¯ç¥¨è‚¡ç¥¨ã€‚\r\n',0),(214079,5947,'sv','Bankens adress krÃ¤vs fÃ¶r blank check lager skrivs ut.',0),(214080,5947,'it','Indirizzo banca richiesto per blank check stock stampe.',0),(214081,5947,'tl','',0),(214082,5947,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3586;&#3629;&#3591;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3648;&#3614;&#3639;&#3656;&#3629;&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3',0),(214083,5947,'hi','à¤¬à¥ˆà¤‚à¤• à¤šà¥‡à¤• à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤ªà¥‡à¤•à¥à¤·à¤¿à¤¤ à¤ªà¤¤à¤¾ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(214084,5947,'ms','Alamat Bank diperlukan untuk cetakan stok cek kosong.',0),(214085,5947,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ù†Ùƒ Ù…Ø·Ù„ÙˆØ¨ Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø´ÙŠÙƒØ§Ù‹ Ø¹Ù„Ù‰ Ø¨ÙŠØ§Ø¶.',0),(214086,5947,'fr','Adresse de la Banque requis pour stock de chÃ¨que en blanc imprime.',0),(214087,5947,'jp','æœªè¨˜å…¥å°?åˆ‡æ‰‹å¸³ã?«å¿…è¦?ã?ªéŠ€è¡Œä½?æ‰€',0),(214088,5947,'pt','EndereÃ§o do banco requerido para aÃ§Ãµes digitais de cheque em branco.',0),(214089,5947,'ru','ÐÐ´Ñ€ÐµÑ Ð±Ð°Ð½ÐºÐ°, Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ñ‹Ñ… Ð´Ð»Ñ Ð‘Ð»Ð°Ð½Ñˆ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ð¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÑ‚.',0),(214090,5947,'es','DirecciÃ³n de Banco requerida para impresiÃ³n de existencias de cheques en blanco',0),(214091,5947,'de','Bankadresse erforderlich fÃ¼r Blankoscheck Lager druckt.',0),(214092,5947,'en','Bank Address required for blank check stock prints.',0),(214093,5948,'is','',0),(214094,5948,'dr','Ø§Ø¨Ø¹Ø§Ø¯ Ú†Ùƒ Ø³ÙÙŠØ¯ Ø§Ù…Ø¶Ø§: 3 Ù‚Ø³Ù…Øª - 3.5\", 3.5\", \"4\"',0),(214095,5948,'pr','Ø§Ø¨Ø¹Ø§Ø¯ Ú†Ùƒ Ø³ÙÙŠØ¯ Ø§Ù…Ø¶Ø§: 3 Ù‚Ø³Ù…Øª - 3.5\", 3.5\", \"4\"',0),(214096,5948,'tr','AÃ§Ä±k Ã§ek boyutlarÄ±: 3 adet - 3.5\", 3.5\", 4\"',0),(214097,5948,'pl','Wyboru puste Wymiary: 3 szt - 3,5\", 3,5\", 4\"',0),(214098,5948,'bg','ÐŸÑ€Ð°Ð·ÐµÐ½ Ñ‡ÐµÐº Ñ€Ð°Ð·Ð¼ÐµÑ€Ð¸: 3 Ð±Ñ€Ð¾Ñ - 3.5\", 3.5\", 4\"',0),(214099,5948,'ur','Ø®Ø§Ù„ÛŒ Ú†ÛŒÚ© Ø§Ø¨Ø¹Ø§Ø¯: 3 Ù¹Ú©Ú‘Û’ Ù¹Ú©Ú‘Û’ - 3.5\"ØŒ 3.5\" ØŒ 4\"',0),(214100,5948,'sr','Ð‘Ð»Ð°Ð½ÐºÐ¾ Ñ‡ÐµÐº Ð´Ð¸Ð¼ÐµÐ½Ð·Ð¸Ñ˜Ðµ: 3 ÐºÐ¾Ð¼Ð°Ð´Ð° - 3.5\", 3.5\", 4\"',0),(214101,5948,'vi','KÃ­ch thÆ°á»›c cá»§a SÃ©c trá»‘ng:3 cáº¡nh - 3.5\", 3.5\", 4\"',0),(214102,5948,'af','Blanko Tjek dimensies:  3 stukke - 3.5\", 3,5\", 4\"',0),(214103,5948,'ro','CEC Ã®n alb dimensiuni: 3 piese - 3,5\", 3.5\", 4\"',0),(214104,5948,'et','TÅ¡ekk mÃµÃµtmed: 3 tÃ¼kki - 3,5\", 3.5\", 4\"',0),(214105,5948,'si','Prazno, odkljukaj polje dimenzije: 3 kosi - 3,5\", 3,5\", 4\"',0),(214106,5948,'ba','Cek kosong dimensi: potongan 3 - 3,5\", 3.5\", 4\"',0),(214107,5948,'nl','Selectievakje Lege afmetingen: 3 stuks - 3,5-inch, 3,5-inch, 4\"',0),(214108,5948,'fi','Blank Check mitat: 3 kpl - 3,5\" 3.5\", 4\"',0),(214109,5948,'no','Tom dimensjoner: 3 deler - 3,5-tommers, 3,5-tommers, 4\"',0),(214110,5948,'da','Blankocheck dimensioner: 3 stk - 3,5\", 3,5\", 4\"',0),(214111,5948,'ko','ë°±ì§€ ìˆ˜ í‘œ í¬ê¸°: 3 ê°œ ì¡°ê°-3.5\", 3.5\", 4\"',0),(214112,5948,'he','×¦\'×§ ×¤×ª×•×ª ×ž×™×“×•×ª: ×—×œ×§×™× 3 - 3.5 ××™× ×¥ \', 3.5\", 4\"',0),(214113,5948,'el','Î›ÎµÏ…ÎºÎ® ÎµÏ€Î¹Ï„Î±Î³Î® Î´Î¹Î±ÏƒÏ„Î¬ÏƒÎµÎ¹Ï‚: 3 ÎºÎ¿Î¼Î¼Î¬Ï„Î¹Î± - 3.5\", 3.5\", 4\"',0),(214114,5948,'zh','ç©ºç™½æ”¯ç¥¨å°ºå¯¸ï¼š3ä»¶- 3.5â€œï¼Œ3.5â€œï¼Œ4â€œ\r\n',0),(214115,5948,'sv','Blank Check dimensioner: 3 stycken - 3,5-3,5\", 4\"',0),(214116,5948,'it','Blank Check dimensioni: 3 pezzi - 3.5\", 3.5\", 4\"',0),(214117,5948,'tl','',0),(214118,5948,'th','&#3648;&#3594;&#3655;&#3588;&#3586;&#3609;&#3634;&#3604;&#3607;&#3637;&#3656;&#3623;&#3656;&#3634;&#3591; 3 &#3594;&#3636;&#3657;&#3609; - 3.5&#3609;&#3636;&#3657;&#3623;,3.5&#3609;&#3636;&#3657;&#3623;,4&#3609;&#3636;&#3657;&#3623;',0),(214119,5948,'hi','à¤–à¤¾à¤²à¥€ à¤šà¥‡à¤• à¤†à¤¯à¤¾à¤®: 3 à¤Ÿà¥à¤•à¤¡à¤¼à¥‡ - 3.5\", 3.5\", 4\"',0),(214120,5948,'ms','Cek kosong dimensi: 3 keping - 3.5\", 3.5\", 4\"',0),(214121,5948,'ar','Ø£Ø¨Ø¹Ø§Ø¯ Ø´ÙŠÙƒØ§Ù‹ Ø¹Ù„Ù‰ Ø¨ÙŠØ§Ø¶: Ø§Ù„Ù‚Ø·Ø¹ 3-3.5 \", 3.5\", 4 \"',0),(214122,5948,'fr','ChÃ¨que en blanc dimensions: 3 piÃ¨ces - 3,5\", 3,5\", 4\"',0),(214123,5948,'jp','æœªè¨˜å…¥å°?åˆ‡æ‰‹å¸³å¯¸æ³•ï¼šï¼“è¾º - 3.5\", 3.5\", 4\"',0),(214124,5948,'pt','Cheque em branco dimensÃµes: 3 peÃ§as - 3.5\", 3.5\", 4\"',0),(214125,5948,'ru','Ð‘Ð»Ð°Ð½Ñˆ Ñ€Ð°Ð·Ð¼ÐµÑ€Ñ‹: 3 ÑˆÑ‚ÑƒÐºÐ¸ - 3,5\", 3.5\", 4\"',0),(214126,5948,'es','Dimensiones de Cheque Blanco: 3 piezas 3.5\", 3.5\", 4\"',0),(214127,5948,'de','Blankoscheck Abmessungen: 3-teilig - 3,5\", 3,5\", 4\"',0),(214128,5948,'en','Blank Check dimensions: 3 pieces - 3.5\", 3.5\", 4\"',0),(214129,5949,'is','',0),(214130,5949,'dr','Deluxe form 80501 or VersaCheck form 1000',0),(214131,5949,'pr','Ú†Ø§Ù¾ Ú†Ùƒ  Ø³ÙÙŠØ¯ Ø§Ù…Ø¶Ø§  Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Deluxe form 80501 or VersaCheck form 1000',0),(214132,5949,'tr','Deluxe 80501 veya VersaCheck 1000 aÃ§Ä±k Ã§ek baskÄ±lar kullanÄ±n',0),(214133,5949,'pl','Drukuje puste pole wyboru UÅ¼yj formularza Deluxe 80501 lub VersaCheck 1000',0),(214134,5949,'bg','ÐŸÑ€Ð°Ð·ÐµÐ½ Ñ‡ÐµÐº Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚ÑŠÑ†Ð¸ Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð´ÐµÐ»ÑƒÐºÑ Ñ„Ð¾Ñ€Ð¼Ð° 80501 Ð¸Ð»Ð¸ VersaCheck Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€ 1000',0),(214135,5949,'ur','Ø®Ø§Ù„ÛŒ Ú†ÛŒÚ© Ù¾Ø±Ù†Ù¹Ø³ ÚˆÛŒÙ„Ú©Ø³ ÙØ§Ø±Ù… 80501 ÛŒØ§ ÙˆØ±Ø³Ú©ÛÛŒÚ© ØµÙˆØ±Øª 1000 Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(214136,5949,'sr','Ð‘Ð»Ð°Ð½ÐºÐ¾ Ñ‡ÐµÐº Ð¾Ñ‚Ð¸ÑÐ°ÐºÐ° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð”ÐµÐ»ÑƒxÐµ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ† 80501 Ð¸Ð»Ð¸ Ð’ÐµÑ€ÑÐ°Ð¦Ñ…ÐµÑ†Ðº Ð¾Ð±Ñ€Ð°ÑÑ†Ð° 1000',0),(214137,5949,'vi','DÃ¹ng dáº¡ng Deluxe 80501 hay dáº¡ng VersaCheck 1000 Ä‘á»ƒ in SÃ©c trá»‘ng ',0),(214138,5949,'af','Blanko Tjek druk deur gebruik te maak van Deluxe vorm 80501 of VersaCheck vorm 1000',0),(214139,5949,'ro','Printuri de cec Ã®n alb folosi formularul Deluxe 80501 sau formularul de VersaCheck 1000',0),(214140,5949,'et','TÅ¡ekk prinditakse kasutada standard vormi 80501 vÃµi VersaCheck 1000',0),(214141,5949,'si','Natisne prazno, odkljukaj polje uporabite Deluxe obrazec 80501 ali obrazec VersaCheck 1000',0),(214142,5949,'ba','Cek kosong cetakan menggunakan Deluxe bentuk 80501 atau VersaCheck bentuk 1000',0),(214143,5949,'nl','Selectievakje Lege afdrukken Deluxe formulier 80501 of VersaCheck formulier 1000 gebruiken',0),(214144,5949,'fi','Blank check tulosteita kÃ¤yttÃ¤Ã¤ Deluxe 80501 tai VersaCheck 1000',0),(214145,5949,'no','Tom utskrifter bruke Deluxe 80501 eller skjemaet VersaCheck 1000',0),(214146,5949,'da','Blankocheck prints bruge Deluxe formular 80501 eller VersaCheck 1000',0),(214147,5949,'ko','ë°±ì§€ ìˆ˜ í‘œ ì¸ì‡„ ì‚¬ìš© ë””ëŸ­ìŠ¤ ì–‘ì‹ 80501 ë˜ëŠ” VersaCheck ì–‘ì‹ 1000',0),(214148,5949,'he','×¦\'×§ ×¤×ª×•×ª ×”×˜×‘×™×¢×•×ª ×œ×”×©×ª×ž×© ×˜×•×¤×¡ ×“×œ×•×§×¡ 80501 ××• VersaCheck 1000',0),(214149,5949,'el','Î›ÎµÏ…ÎºÎ® ÎµÏ€Î¹Ï„Î±Î³Î® ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Deluxe 80501 Î® Î¼Î¿ÏÏ†Î® VersaCheck 1000',0),(214150,5949,'zh','ç©ºç™½æ”¯ç¥¨ä½¿ç”¨è¡¨å•80501æˆ–è€…Versacheckè¡¨å• 1000\r\n',0),(214151,5949,'sv','Blank check utskrifter anvÃ¤nder Deluxe blankett 80501 eller VersaCheck 1000',0),(214152,5949,'it','Blank check stampe utilizzano Deluxe 80501 VersaCheck formato o 1000',0),(214153,5949,'tl','',0),(214154,5949,'th','Blank Check prints use Deluxe form 80501 or VersaCheck form 1000',0),(214155,5949,'hi','à¤¡à¤¿à¤²à¤•à¥à¤¸ à¤°à¥‚à¤ª 80501 à¤¯à¤¾ VersaCheck à¤ªà¥à¤°à¤ªà¤¤à¥à¤° 1000 à¤–à¤¾à¤²à¥€ à¤šà¥‡à¤• à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—',0),(214156,5949,'ms','Cetakan cek kosong gunakan Deluxe borang 80501 atau borang VersaCheck 1000',0),(214157,5949,'ar','ÙŠØ·Ø¨Ø¹ Ø¹Ù„Ù‰ Ø¨ÙŠØ§Ø¶ Ø§Ø³ØªØ®Ø¯Ù… Ø§Ù„Ù†Ù…ÙˆØ°Ø¬ Ø¯ÙŠÙ„ÙˆÙƒØ³ 80501 Ø£Ùˆ Ø§Ù„Ù†Ù…ÙˆØ°Ø¬ ÙÙŠØ±Ø³Ø§ØªØ´ÙŠÙƒ 1000',0),(214158,5949,'fr','Impressions de chÃ¨que en blanc utilisent Deluxe 80501 VersaCheck forme ou 1000',0),(214159,5949,'jp','Blank check prints use Deluxe form 80501 or VersaCheck form 1000',0),(214160,5949,'pt','ImpressÃµes de cheque em branco usam formulÃ¡rio Deluxe 80501 ou formulÃ¡rio VersaCheck 1000',0),(214161,5949,'ru','Ð‘Ð»Ð°Ð½Ñˆ Ð¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ 80501 Ð¸Ð»Ð¸ VersaCheck Ñ„Ð¾Ñ€Ð¼Ðµ 1000',0),(214162,5949,'es','Impresiones de Cheque Blanco usan formulario Deluxe o VersaCheck Formulario 1000 ',0),(214163,5949,'de','Blankoscheck Ausdrucke verwenden Deluxe 80501 oder VersaCheck Form 1000',0),(214164,5949,'en','Blank check prints use Deluxe form 80501 or VersaCheck form 1000',0),(214165,5950,'is','',0),(214166,5950,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ù„ÙˆÚ¯Ùˆ',0),(214167,5950,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ù„ÙˆÚ¯Ùˆ',0),(214168,5950,'tr','Logo kontrol',0),(214169,5950,'pl','Wyboru Logo',0),(214170,5950,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð»Ð¾Ð³Ð¾',0),(214171,5950,'ur','Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ) Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(214172,5950,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð›Ð¾Ð³Ð¾',0),(214173,5950,'vi','Kiá»ƒm tra Logo',0),(214174,5950,'af','Tjek Embleem',0),(214175,5950,'ro','Verifica logo-ul',0),(214176,5950,'et','Kontrollige Logo',0),(214177,5950,'si','Preverite Logo',0),(214178,5950,'ba','Periksa Logo',0),(214179,5950,'nl','Selectievakje Logo',0),(214180,5950,'fi','Tarkistaa Logo',0),(214181,5950,'no','Sjekk Logo',0),(214182,5950,'da','Check Logo',0),(214183,5950,'ko','ë¡œê³  í™•ì¸',0),(214184,5950,'he','×‘×“×•×§ ×œ×•×’×•',0),(214185,5950,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ Î»Î¿Î³ÏŒÏ„Ï…Ï€Î¿Ï…',0),(214186,5950,'zh','æ£€æŸ¥æ ‡è¯†\r\n',0),(214187,5950,'sv','Kontrollera logotypen',0),(214188,5950,'it','Controllare il Logo',0),(214189,5950,'tl','',0),(214190,5950,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3626;&#3633;&#3597;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;',0),(214191,5950,'hi','à¤²à¥‹à¤—à¥‹ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(214192,5950,'ms','Semak Logo',0),(214193,5950,'ar','Ø´Ø¹Ø§Ø± Ø§Ù„ØµÙ‘Ùƒ',0),(214194,5950,'fr','Logo de cocher',0),(214195,5950,'jp','ãƒ­ã‚´ã?®ç¢ºèª?',0),(214196,5950,'pt','Verifique o logotipo',0),(214197,5950,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð›Ð¾Ð³Ð¾',0),(214198,5950,'es','Checar Logo',0),(214199,5950,'de','Check-Logo',0),(214200,5950,'en','Check Logo',0),(214201,5951,'is','',0),(214202,5951,'dr','Ø­Ø°Ù Ù„Ùˆ Ú¯Ùˆ ',0),(214203,5951,'pr','Ø­Ø°Ù Ù„Ùˆ Ú¯Ùˆ ',0),(214204,5951,'tr','Logo Sil',0),(214205,5951,'pl','UsunÄ…Ä‡ Logo',0),(214206,5951,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¾Ð³Ð¾Ñ‚Ð¾',0),(214207,5951,'ur','Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ) Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(214208,5951,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð›Ð¾Ð³Ð¾',0),(214209,5951,'vi','XÃ³a logo',0),(214210,5951,'af','Skrap Embleem',0),(214211,5951,'ro','Sterge logo',0),(214212,5951,'et','Kustuta logo',0),(214213,5951,'si','Brisanje logotipa',0),(214214,5951,'ba','Menghapus Logo',0),(214215,5951,'nl','Logo verwijderen',0),(214216,5951,'fi','Poista Logo',0),(214217,5951,'no','Slette Logo',0),(214218,5951,'da','Slette Logo',0),(214219,5951,'ko','ë¡œê³  ì‚­ì œ',0),(214220,5951,'he','×ž×—×™×§×ª ×œ×•×’×•',0),(214221,5951,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ Î»Î¿Î³ÏŒÏ„Ï…Ï€Î¿',0),(214222,5951,'zh','åˆ é™¤æ ‡å¿—\r\n',0),(214223,5951,'sv','Ta bort logotyp',0),(214224,5951,'it','Eliminare il Logo',0),(214225,5951,'tl','',0),(214226,5951,'th','&#3621;&#3610;&#3650;&#3621;&#3650;&#3585;&#3657;',0),(214227,5951,'hi','à¤²à¥‹à¤—à¥‹ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(214228,5951,'ms','Menghapuskan Logo',0),(214229,5951,'ar','Ø­Ø°Ù Ø§Ù„Ø´Ø¹Ø§Ø±',0),(214230,5951,'fr','Supprimer Logo',0),(214231,5951,'jp','ãƒ­ã‚´ã?®æ¶ˆåŽ»',0),(214232,5951,'pt','Excluir o logotipo',0),(214233,5951,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð›Ð¾Ð³Ð¾',0),(214234,5951,'es','Eliminar Logo',0),(214235,5951,'de','Logo lÃ¶schen',0),(214236,5951,'en','Delete Logo',0),(214237,5952,'is','',0),(214238,5952,'dr','(Ø³Ù‡Ø§Ù… ) Ù†ÙŠØ§Ø² Ø§Ø³Øª ',0),(214239,5952,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ  ÙƒØ³Ø±ÙŠ Ø¨Ø±Ø§ÙŠ Ú†Ùƒ Ø³ÙÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± (Ø³Ù‡Ø§Ù… ) Ù†ÙŠØ§Ø² Ø§Ø³Øª ',0),(214240,5952,'tr','Kesirli yÃ¶nlendirme numarasÄ± iÃ§in aÃ§Ä±k Ã§ek stok gerekli yazdÄ±rÄ±r.',0),(214241,5952,'pl','LiczbÄ™ uÅ‚amkowÄ… z zakresu routingu wymagane dla czeku in blanco druki pieÅ„.',0),(214242,5952,'bg','Ð¤Ñ€Ð°ÐºÑ†Ð¸Ð¾Ð½ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚ Ð·Ð° Ð¿Ñ€Ð°Ð·ÐµÐ½ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð° ÑÐ½Ð¸Ð¼ÐºÐ¸.',0),(214243,5952,'ur','Ú©Ø³Ø±ÛŒ Ø±ÙˆÙ¹Ù†Ú¯ Ù†Ù…Ø¨Ø± Ø®Ø§Ù„ÛŒ Ú†ÛŒÚ© Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ù„Ø¦Û’ Ø¯Ø±Ú©Ø§Ø± Ú†Ú¾Ø§Ù¾ØªØ§ ÛÛ’ Û”',0),(214244,5952,'sr','Ð”ÐµÑ†Ð¸Ð¼Ð°Ð»Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¾Ð³ Ð¿Ð¾ÑÑ‚ÑƒÐ¿ÐºÐ° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð·Ð° Ð‘Ð»Ð°Ð½ÐºÐ¾ Ñ‡ÐµÐº Ð°ÐºÑ†Ð¸Ñ˜Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°.',0),(214245,5952,'vi','Cáº§n Sá»‘ Ä‘á»‹nh tuyáº¿n phÃ¢n sá»‘ Ä‘á»ƒ in sÃ©c tráº¯ng',0),(214246,5952,'af','Fractional routing nommer vereis vir leÃ« merkblokkie voorraad bestel.',0),(214247,5952,'ro','NumÄƒr fracÅ£ionar rutare necesare pentru printuri stoc cec Ã®n alb.',0),(214248,5952,'et','Fractional marsruudi numbrit vaja tÃ¼hje stock pildid.',0),(214249,5952,'si','Britansko Å¡tevilka proizvodnega postopka za prazen preverjanje zaloge natisne.',0),(214250,5952,'ba','Pecahan nomor routing yang diperlukan untuk cek kosong saham cetakan.',0),(214251,5952,'nl','Fractionele bewerkingsplannummer vereist voor selectievakje lege voorraad afdrukken.',0),(214252,5952,'fi','Fractional reititysnumeron vaaditaan valtakirjaa varastossa tulostaa.',0),(214253,5952,'no','Ruting tall kreves for tom lager utskrifter.',0),(214254,5952,'da','Fraktioneret rutenummeret krÃ¦ves for blankocheck stock udskrifter.',0),(214255,5952,'ko','ë°±ì§€ ìˆ˜ í‘œ ì£¼ì‹ì— í•„ìš”í•œ ì†Œìˆ˜ ë¼ìš°íŒ… ë²ˆí˜¸ë¥¼ ì¸ì‡„ í•©ë‹ˆë‹¤.',0),(214256,5952,'he','× ×“×¨×© ×¢×‘×•×¨ ×”×“×¤×¡×™× ×ž× ×™×•×ª ×¦\'×§ ×¤×ª×•×ª ×ž×¡×¤×¨ × ×™×ª×•×‘ ×”×—×œ×§×™.',0),(214257,5952,'el','ÎšÎ»Î±ÏƒÎ¼Î±Ï„Î¹ÎºÏŒÏ‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Î»ÎµÏ…ÎºÎ® ÎµÏ€Î¹Ï„Î±Î³Î® Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚.',0),(214258,5952,'zh','éƒ¨åˆ†è·¯å¾„å·ç éœ€è¦ç©ºç™½æ”¯ç¥¨è‚¡ç¥¨æ‰“å°',0),(214259,5952,'sv','Fraktionerad routing-nummer krÃ¤vs fÃ¶r blank check lager skrivs ut.',0),(214260,5952,'it','Numero frazionario di routing necessario per blank check stock stampe.',0),(214261,5952,'tl','',0),(214262,5952,'th','&#3651;&#3626;&#3656;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3623;&#3640;&#3656;&#3609;&#3623;&#3634;&#3618;&#3648;&#3611;&#3655;&#3609;&#3648;&#3624;&#3625;&#3626;&#3656;&#3623;&#3609;&#3610;&#3633;&#3591;&#3588;&#3633;&#3610;',0),(214263,5952,'hi','à¤­à¤¿à¤¨à¥à¤¨à¤¾à¤¤à¥à¤®à¤• à¤…à¤¨à¥à¤®à¤¾à¤°à¥à¤—à¤£ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤–à¤¾à¤²à¥€ à¤šà¥‡à¤• à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤µà¤¶à¥à¤¯à¤• à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(214264,5952,'ms','Pecahan nombor penghalaan yang diperlukan untuk cetakan stok cek kosong.',0),(214265,5952,'ar','Ø§Ù„Ø¹Ø¯Ø¯ Ø§Ù„ÙƒØ³Ø±ÙŠ Ø§Ù„ØªÙˆØ¬ÙŠÙ‡ Ø§Ù„Ù„Ø§Ø²Ù… Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø´ÙŠÙƒØ§Ù‹ Ø¹Ù„Ù‰ Ø¨ÙŠØ§Ø¶.',0),(214266,5952,'fr','Nombre fractionnaire de routage requis pour stock de chÃ¨que en blanc imprime.',0),(214267,5952,'jp','æœªè¨˜å…¥å°?åˆ‡æ‰‹å¸³å?°åˆ·ã?«å¿…è¦?ã?ªåˆ†æ•°ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå?·',0),(214268,5952,'pt','Imprime nÃºmero fracionÃ¡rio de roteamento necessÃ¡rio para o estoque de cheque em branco.',0),(214269,5952,'ru','Ð”Ñ€Ð¾Ð±Ð½Ð°Ñ Ð½Ð¾Ð¼ÐµÑ€ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð° Ð´Ð»Ñ Ð‘Ð»Ð°Ð½Ñˆ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ð¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÑ‚.',0),(214270,5952,'es','NÃºmero de routing fraccional requerido para impresiones de stock de cheques en blanco',0),(214271,5952,'de','Gebrochene Bankleitzahl erforderlich fÃ¼r Blankoscheck Lager druckt.',0),(214272,5952,'en','Fractional routing number required for blank check stock prints.',0),(214273,5953,'is','',0),(214274,5953,'dr','JPEG ÙŠØ§  PNG',0),(214275,5953,'pr','ØªØµØ§ÙˆÙŠØ± Ø¨Ø§ÙŠØ¯ Ø¯Ø± Ø§ÙŠÙ† Ø¯Ùˆ Ù‚Ø§Ù„Ø¨ Ø¨Ø§Ø´Ø¯ JPEG ÙŠØ§  PNG',0),(214276,5953,'tr','Resim, JPEG veya PNG olmalÄ±dÄ±r.',0),(214277,5953,'pl','Obraz musi byÄ‡ JPEG lub PNG',0),(214278,5953,'bg','Ð˜Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ JPEG Ð¸Ð»Ð¸ PNG',0),(214279,5953,'ur','JPEG ÛŒØ§ PNG ØªØµÙˆÛŒØ± ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒÛ’',0),(214280,5953,'sr','Ð¡Ð»Ð¸ÐºÐ° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ ÐˆÐŸÐ•Ð“ Ð¸Ð»Ð¸ ÐŸÐÐ“',0),(214281,5953,'vi','áº¤n tÆ°á»£ng pháº£i lÃ  JPEG hay PNG',0),(214282,5953,'af','Beeld moet JPEG of PNG wees',0),(214283,5953,'ro','Imaginea trebuie sÄƒ fie JPEG sau PNG',0),(214284,5953,'et','Foto peab olema JPEG vÃµi PNG',0),(214285,5953,'si','Mora biti slika JPEG ali PNG',0),(214286,5953,'ba','Gambar harus JPEG atau PNG',0),(214287,5953,'nl','Afbeelding moet JPEG- of PNG',0),(214288,5953,'fi','Kuvan on oltava JPEG- tai PNG',0),(214289,5953,'no','Bildet mÃ¥ vÃ¦re JPEG eller PNG',0),(214290,5953,'da','Billedet skal vÃ¦re JPEG eller PNG',0),(214291,5953,'ko','ì´ë¯¸ì§€ê°€ëŠ” JPEG ë˜ëŠ” PNG ì—¬ì•¼ í•©ë‹ˆë‹¤.',0),(214292,5953,'he','×”×ª×ž×•× ×” ×—×™×™×‘×ª ×œ×”×™×•×ª JPEG ××• PNG',0),(214293,5953,'el','Î•Î¹ÎºÏŒÎ½Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ JPEG Î® PNG',0),(214294,5953,'zh','å›¾ç‰‡å¿…é¡»æ˜¯JPEGæˆ–PNGæ ¼å¼\r\n',0),(214295,5953,'sv','Bilden mÃ¥ste vara JPEG eller PNG',0),(214296,5953,'it','Immagine deve essere JPEG o PNG',0),(214297,5953,'tl','',0),(214298,5953,'th','&#3619;&#3641;&#3611;&#3616;&#3634;&#3614;&#3605;&#3657;&#3629;&#3591;&#3648;&#3611;&#3655;&#3609; JPEG &#3627;&#3619;&#3639;&#3629; PNG',0),(214299,5953,'hi','JPEG à¤¯à¤¾ PNG à¤›à¤µà¤¿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(214300,5953,'ms','Imej mesti JPEG atau PNG',0),(214301,5953,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙƒÙˆÙ† ØµÙˆØ±Ø© JPEG Ø£Ùˆ PNG',0),(214302,5953,'fr','Image doit Ãªtre en format JPEG ou PNG',0),(214303,5953,'jp','ç”»åƒ?ã?¯JPEGã?‹PNGã?§ã?ªã?‘ã‚Œã?°ã?„ã?‘ã?¾ã?›ã‚“',0),(214304,5953,'pt','Imagem deve ser JPEG ou PNG',0),(214305,5953,'ru','Ð˜Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ JPEG Ð¸Ð»Ð¸ PNG',0),(214306,5953,'es','Imagen debe ser JPEG o PNG',0),(214307,5953,'de','Bild muss JPEG oder PNG sein.',0),(214308,5953,'en','Image must be JPEG or PNG',0),(214309,5954,'is','',0),(214310,5954,'dr','81004',0),(214311,5954,'pr','Ú†Ø§Ù¾ Ù‡Ø§ÙŠ Ø§ÙˆÙ„ÙŠÙ‡  Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†Ù†Ø¯ Ø§Ø² ÙØ±Ù… Ù‡Ø§ÙŠ Ø¯ÙˆÙ„ÙˆÙƒØ³  81004',0),(214312,5954,'tr','BaskÄ±lar Deluxe formu 81004 kullanÄ±n',0),(214313,5954,'pl','Przebitki formularz Deluxe 81004',0),(214314,5954,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð° 81004',0),(214315,5954,'ur','Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ ÚˆÛŒÙ„Ú©Ø³ ÙØ§Ø±Ù… 81004 Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(214316,5954,'sr','ÐŸÑ€ÐµÐ¿Ñ€Ð¸Ð½Ñ‚Ñ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð”ÐµÐ»ÑƒxÐµ Ð¾Ð±Ð»Ð¸Ðº 81004',0),(214317,5954,'vi','Báº£n trÆ°á»›c khi in dÃ¹ng máº«u Deluxe 81004',0),(214318,5954,'af','Vooruitdrukte gebruik Deluxe vorm 81004',0),(214319,5954,'ro','Neverificate folosi formularul Deluxe 81004',0),(214320,5954,'et','Preprindid Deluxe vormi 81004',0),(214321,5954,'si','Nepregledanih uporabo Deluxe obrazec 81004',0),(214322,5954,'ba','Pracetak menggunakan Deluxe formulir 81004',0),(214323,5954,'nl','Voordrukken Deluxe formulier 81004 gebruiken',0),(214324,5954,'fi','Koevedoksia lomakkeessa Deluxe 81004',0),(214325,5954,'no','Dokumentutkast bruk Deluxe skjemaet 81004',0),(214326,5954,'da','Preprints bruge Deluxe form 81004',0),(214327,5954,'ko','ì‡¼í•‘ë„ ë””ëŸ­ìŠ¤ ì–‘ì‹ì„ 81004 ì‚¬ìš©',0),(214328,5954,'he','×ª×ž×¦×•×ª×™ ×”×©×ª×ž×© ×‘×˜×•×¤×¡ ×“×œ×•×§×¡ 81004',0),(214329,5954,'el','Î ÏÎ¿Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏƒÎµÎ¹Ï‚ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Deluxe Î¼Î¿ÏÏ†Î® 81004',0),(214330,5954,'zh','é¢„å°æœ¬çš„å½¢å¼ä½¿ç”¨è±ªåŽ81004\r\n',0),(214331,5954,'sv','Preprints anvÃ¤nda Deluxe form 81004',0),(214332,5954,'it','Preprint USA Deluxe modulo 81004',0),(214333,5954,'tl','',0),(214334,5954,'th','&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3594;&#3657;&#3649;&#3610;&#3610;&#3615;&#3629;&#3619;&#3660;&#3617; Deluxe 81004',0),(214335,5954,'hi','Preprints à¤¡à¤¿à¤²à¤•à¥à¤¸ à¤«à¤¾à¤°à¥à¤® 81004 à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(214336,5954,'ms','Penulisan menggunakan borang Deluxe 81004',0),(214337,5954,'ar','Ø¨Ø±ÙŠØ¨Ø±ÙŠÙ†ØªØ³ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù†Ù…ÙˆØ°Ø¬ Ø¯ÙŠÙ„ÙˆÙƒØ³ 81004',0),(214338,5954,'fr','PrÃ©publications utilisent formulaire Deluxe 81004',0),(214339,5954,'jp','ãƒ‡ãƒ©ãƒƒã‚¯ã‚¹ãƒ•ã‚©ãƒ¼ãƒ 81004ã‚’åˆ©ç”¨ã?—ã?Ÿå†?å?°åˆ·',0),(214340,5954,'pt','Preprints usam formulÃ¡rio Deluxe 81004',0),(214341,5954,'ru','ÐŸÑ€ÐµÐ¿Ñ€Ð¸Ð½Ñ‚Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð±Ð»Ð°Ð½Ðº 81004',0),(214342,5954,'es','Preimpresiones usan formulario Deluxe 81004',0),(214343,5954,'de','Preprints benutzen Deluxe 81004',0),(214344,5954,'en','Preprints use Deluxe form 81004',0),(214345,5955,'is','',0),(214346,5955,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø§Ø±Ø³Ø§Ù„ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ù‡Ø§ÙŠ Ú†Ùƒ Ø³ÙÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(214347,5955,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø§Ø±Ø³Ø§Ù„ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ù‡Ø§ÙŠ Ú†Ùƒ Ø³ÙÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(214348,5955,'tr','AÃ§Ä±k Ã§ek stok iÃ§in gerekli Ã¼retim akÄ±ÅŸÄ± numarasÄ±nÄ± yazdÄ±rÄ±r.',0),(214349,5955,'pl','Numer marszruty wymagane dla czeku in blanco czas drukuje.',0),(214350,5955,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚ Ð·Ð° Ð¿Ñ€Ð°Ð·ÐµÐ½ Ñ‡ÐµÐº ÑÑŠÑÑ‚Ð°Ð² ÑÐµ Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°.',0),(214351,5955,'ur','Ø±ÙˆÙ¹ Ù†Ù…Ø¨Ø± Ø®Ø§Ù„ÛŒ Ú†ÛŒÚ© Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ù„Ø¦Û’ Ø¯Ø±Ú©Ø§Ø± Ú†Ú¾Ø§Ù¾ØªØ§ ÛÛ’ Û”',0),(214352,5955,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¾Ð³ Ð¿Ð¾ÑÑ‚ÑƒÐ¿ÐºÐ° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð·Ð° Ð‘Ð»Ð°Ð½ÐºÐ¾ Ñ‡ÐµÐº Ð°ÐºÑ†Ð¸Ñ˜Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°.',0),(214353,5955,'vi','Cáº§n Sá»‘ Ä‘á»‹nh tuyáº¿n Ä‘á»ƒ in sÃ©c tráº¯ng',0),(214354,5955,'af','Routing nommer vereis vir leÃ« merkblokkie voorraad afdrukke.',0),(214355,5955,'ro','Printuri de distribuire numÄƒrul necesar pentru stocul de cec Ã®n alb.',0),(214356,5955,'et','Marsruudi numbrit vaja tÃ¼hje stock pildid.',0),(214357,5955,'si','Å tevilka proizvodnega postopka za prazen preverjanje zaloge natisne.',0),(214358,5955,'ba','Nomor routing yang diperlukan untuk cek kosong saham cetakan.',0),(214359,5955,'nl','Nummer van het bewerkingsplan vereist voor selectievakje lege voorraad wordt afgedrukt.',0),(214360,5955,'fi','Reititys numero vaaditaan valtakirjaa varastossa tulostaa.',0),(214361,5955,'no','Rutenummeret kreves for tom lager utskrifter.',0),(214362,5955,'da','Rutenummeret krÃ¦ves for blankocheck stock udskriver.',0),(214363,5955,'ko','ë°±ì§€ ìˆ˜ í‘œ ì£¼ì‹ì— í•„ìš”í•œ ë¼ìš°íŒ… ë²ˆí˜¸ë¥¼ ì¸ì‡„ í•©ë‹ˆë‹¤.',0),(214364,5955,'he','×ž×“×¤×™×¡ ×ž×¡×¤×¨ ×”× ×™×ª×•×‘ ×”×“×¨×•×©×™× ×¢×‘×•×¨ ×ž× ×™×•×ª ×¦\'×§ ×¤×ª×•×ª.',0),(214365,5955,'el','Î•ÎºÏ„Ï…Ï€ÏŽÎ½ÎµÎ¹ ÎºÏ‰Î´Î¹ÎºÏŒ Ï†Î±ÏƒÎµÎ¿Î»Î¿Î³Î¯Î¿Ï… Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î± Ï„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î»ÎµÏ…ÎºÎ® ÎµÏ€Î¹Ï„Î±Î³Î®.',0),(214366,5955,'zh','è·¯å¾„å·ç éœ€è¦ç©ºç™½æ”¯ç¥¨åº“å­˜æ‰“å°ã€‚\r\n',0),(214367,5955,'sv','Routing-nummer krÃ¤vs fÃ¶r blank check lager skrivs ut.',0),(214368,5955,'it','Instradamento numero richiesto per blank check stock stampe.',0),(214369,5955,'tl','',0),(214370,5955,'th','Routing number required for blank check stock prints.',0),(214371,5955,'hi','à¤°à¥‚à¤Ÿà¤¿à¤‚à¤— à¤–à¤¾à¤²à¥€ à¤šà¥‡à¤• à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤ªà¥‡à¤•à¥à¤·à¤¿à¤¤ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(214372,5955,'ms','Cetak nombor penghalaan yang diperlukan untuk stok cek kosong.',0),(214373,5955,'ar','ÙŠØ·Ø¨Ø¹ Ø±Ù‚Ù… Ø§Ù„ØªÙˆØ¬ÙŠÙ‡ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨ Ù„Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø´ÙŠÙƒØ§Ù‹ Ø¹Ù„Ù‰ Ø¨ÙŠØ§Ø¶.',0),(214374,5955,'fr','NumÃ©ro d\'acheminement nÃ©cessaire pour stock de chÃ¨que en blanc imprime.',0),(214375,5955,'jp','æœªè¨˜å…¥å°?åˆ‡æ‰‹å¸³å?°åˆ·ã?«å¿…è¦?ã?ªãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå?·',0),(214376,5955,'pt','Imprime roteamento nÃºmero necessÃ¡rio para o estoque de cheque em branco.',0),(214377,5955,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð° Ð´Ð»Ñ Ð‘Ð»Ð°Ð½Ñˆ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ð¿ÐµÑ‡Ð°Ñ‚Ð°ÐµÑ‚.',0),(214378,5955,'es','NÃºmero de Routing requerido para impresiones stock de cheques en blanco',0),(214379,5955,'de','Bankleitzahl erforderlich fÃ¼r Blankoscheck Lager druckt.',0),(214380,5955,'en','Routing number required for blank check stock prints.',0),(214381,5956,'is','',0),(214382,5956,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ ØµÙ†Ø¹Øª',0),(214383,5956,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ ØµÙ†Ø¹Øª',0),(214384,5956,'tr','AR dosya karÅŸÄ±ya yÃ¼kleme bilgileri',0),(214385,5956,'pl','Informacje o Upload plikÃ³w AR',0),(214386,5956,'bg','AR Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(214387,5956,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ ÙØ§Ø¦Ù„ Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(214388,5956,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐÐ  Ð½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ð°ÑšÐµ',0),(214389,5956,'vi','Táº£i ThÃ´ng Tin Há»“ SÆ¡ Pháº£i Thu',0),(214390,5956,'af','RO LÃªer Oplaai Inligting',0),(214391,5956,'ro','FiÅŸierul AR Ã®ncÄƒrca informaÅ£ii',0),(214392,5956,'et','AR faili Ã¼leslaadimise teave',0),(214393,5956,'si','AR File Upload informacije',0),(214394,5956,'ba','AR File Upload informasi',0),(214395,5956,'nl','AR bestand Upload informatie',0),(214396,5956,'fi','AR tiedoston palvelimeen lataamisen tiedot',0),(214397,5956,'no','AR filopplasting informasjon',0),(214398,5956,'da','AR Filsending oplysninger',0),(214399,5956,'ko','AR íŒŒì¼ ì—…ë¡œë“œ ì •ë³´',0),(214400,5956,'he','×”×¢×œ××ª ×§×•×‘×¥ AR ×ž×™×“×¢',0),(214401,5956,'el','AR Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Upload Î±ÏÏ‡ÎµÎ¯Ï‰Î½',0),(214402,5956,'zh','åº”æ”¶è´¦æ¬¾æ–‡ä»¶ä¸Šä¼ ä¿¡æ¯\r\n',0),(214403,5956,'sv','AR filen ladda upp Information',0),(214404,5956,'it','Upload di File AR informazioni',0),(214405,5956,'tl','',0),(214406,5956,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(214407,5956,'hi','à¤. à¤†à¤°. à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚ à¤¸à¥‚à¤šà¤¨à¤¾',0),(214408,5956,'ms','Maklumat meng-Upload fail AR',0),(214409,5956,'ar','ØªØ­Ù…ÙŠÙ„ Ù…Ù„Ù Ø¹ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(214410,5956,'fr','Informations de tÃ©lÃ©chargement de fichiers de l\'AR',0),(214411,5956,'jp','ARãƒ•ã‚¡ã‚¤ãƒ«ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰æƒ…å ±',0),(214412,5956,'pt','AR informaÃ§Ãµes de Upload de arquivo',0),(214413,5956,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð»Ñ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ñ„Ð°Ð¹Ð»Ð¾Ð² AR',0),(214414,5956,'es','CC InformaciÃ³n de Subir Archivos',0),(214415,5956,'de','AR-Datei-Upload-Info',0),(214416,5956,'en','AR File Upload Information',0),(214417,5957,'is','',0),(214418,5957,'dr','Ù‡ÙŠÚ† Ø´Ø±ÙƒØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(214419,5957,'pr','Ù‡ÙŠÚ† Ø´Ø±ÙƒØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(214420,5957,'tr','HiÃ§bir ÅŸirket bulundu',0),(214421,5957,'pl','Å»adna firma nie znaleziono',0),(214422,5957,'bg','ÐÐ¸ÐºÐ¾Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(214423,5957,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ù¾Ø§ÛŒØ§',0),(214424,5957,'sr','ÐÐ¸Ñ˜ÐµÐ´Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(214425,5957,'vi','KhÃ´ng tháº¥y Cty',0),(214426,5957,'af','Geen Onderneming Gevind',0),(214427,5957,'ro','Nici o companie nu a Ã®ntemeia',0),(214428,5957,'et','EttevÃµtteid ei leitud',0),(214429,5957,'si','Nobeno podjetje najdemo',0),(214430,5957,'ba','Tidak ada perusahaan yang ditemukan',0),(214431,5957,'nl','Geen bedrijf gevonden',0),(214432,5957,'fi','Ei ole yritys',0),(214433,5957,'no','Ingen selskap funnet',0),(214434,5957,'da','Ingen virksomhed fundet',0),(214435,5957,'ko','ì•„ë‹ˆ íšŒì‚¬ ë°œê²¬',0),(214436,5957,'he','×œ× × ×ž×¦××” ×—×‘×¨×”',0),(214437,5957,'el','ÎšÎ±Î¼Î¯Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(214438,5957,'zh','æœªå‘çŽ°å…¬å¸\r\n',0),(214439,5957,'sv','Inget fÃ¶retag Funna',0),(214440,5957,'it','Nessun azienda trovata',0),(214441,5957,'tl','',0),(214442,5957,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(214443,5957,'hi','à¤•à¥‹à¤ˆ à¤•à¤‚à¤ªà¤¨à¥€ à¤ªà¤¾à¤¯à¤¾',0),(214444,5957,'ms','Tidak ada syarikat yang mendapati',0),(214445,5957,'ar','Ø§Ù„Ø´Ø±ÙƒØ© Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(214446,5957,'fr','Aucune entreprise trouvÃ©',0),(214447,5957,'jp','ä¼šç¤¾ã?Œè¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“',0),(214448,5957,'pt','Nenhuma empresa encontrada',0),(214449,5957,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ð°',0),(214450,5957,'es','No se EncontrÃ³ la Empresa',0),(214451,5957,'de','Kein Unternehmen gefunden',0),(214452,5957,'en','No Company Found',0),(214453,5958,'is','',0),(214454,5958,'dr','Ù…Ø³ÙŠØ± Ùˆ Ù†Ø§Ù… ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(214455,5958,'pr','Ù…Ø³ÙŠØ± Ùˆ Ù†Ø§Ù… ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(214456,5958,'tr','Yol ve dosya adÄ±nÄ± al',0),(214457,5958,'pl','ÅšcieÅ¼ka i nazwa pliku do importu',0),(214458,5958,'bg','ÐŸÑŠÑ‚ÑÑ‚ Ð¸ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(214459,5958,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ù†Ø§Ù… Ù…Ø³Ù„ Ø§ÙˆØ± Ø±Ø§Û',0),(214460,5958,'sr','ÐŸÑƒÑ‚Ð°ÑšÐ° Ð¸ Ð¸Ð¼Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(214461,5958,'vi','ÄÆ°á»ng dáº«n & tÃªn Ä‘á»ƒ nháº­p',0),(214462,5958,'af','Lokaliteit en LÃªernaam vir Invoer',0),(214463,5958,'ro','Calea ÅŸi numele de fiÅŸier pentru Import',0),(214464,5958,'et','Tee ja failinimi importimiseks',0),(214465,5958,'si','Pot in ime datoteke za uvoz',0),(214466,5958,'ba','Jalur dan nama File untuk impor',0),(214467,5958,'nl','Pad en bestandsnaam voor invoer',0),(214468,5958,'fi','Tuo tiedostonimi ja polku',0),(214469,5958,'no','Banen og filnavnet for Import',0),(214470,5958,'da','Stien og filnavnet for Import',0),(214471,5958,'ko','ê²½ë¡œ íŒŒì¼ ì´ë¦„ ê°€ì ¸ì˜¤ê¸°',0),(214472,5958,'he','× ×ª×™×‘ ×•×©× ×§×•×‘×¥ ×œ×™×™×‘×•×',0),(214473,5958,'el','Î”Î¹Î±Î´ÏÎ¿Î¼Î® ÎºÎ±Î¹ ÏŒÎ½Î¿Î¼Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï… Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(214474,5958,'zh','è·¯å¾„å’Œæ–‡ä»¶åå¯¼å…¥\r\n',0),(214475,5958,'sv','SÃ¶kvÃ¤gen och filnamnet fÃ¶r Import',0),(214476,5958,'it','Percorso e nome File per l\'importazione',0),(214477,5958,'tl','',0),(214478,5958,'th','&#3614;&#3634;&#3608;&#3649;&#3621;&#3632;&#3594;&#3639;&#3656;&#3629;&#3652;&#3615;&#3621;&#3660;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(214479,5958,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¾à¤® à¤”à¤° à¤ªà¤¥',0),(214480,5958,'ms','Laluan dan nama fail untuk diimport',0),(214481,5958,'ar','Ù…Ø³Ø§Ø± ÙˆØ§Ø³Ù… Ù…Ù„Ù Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(214482,5958,'fr','Chemin d\'accÃ¨s et nom de fichier d\'importation',0),(214483,5958,'jp','ã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆã?™ã‚‹ãƒ‘ã‚¹ã?¨ãƒ•ã‚¡ã‚¤ãƒ«',0),(214484,5958,'pt','Caminho e nome de arquivo para importaÃ§Ã£o',0),(214485,5958,'ru','ÐŸÑƒÑ‚ÑŒ Ð¸ Ð¸Ð¼Ñ Ñ„Ð°Ð¹Ð»Ð° Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(214486,5958,'es','Ruta y Nombre de File para Importar',0),(214487,5958,'de','Pfad und Dateinamen fÃ¼r den Import',0),(214488,5958,'en','Path and File Name for Import',0),(214489,5959,'is','',0),(214490,5959,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¹Ù†ÙˆØ§Ù† Ù…Ù‚Ø¯Ø§Ø± ',0),(214491,5959,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¹Ù†ÙˆØ§Ù† Ù…Ù‚Ø¯Ø§Ø± ',0),(214492,5959,'tr','TUTAR',0),(214493,5959,'pl','KWOTA',0),(214494,5959,'bg','Ð¡Ð£ÐœÐ',0),(214495,5959,'ur','Ù…Ù‚Ø¯Ø§Ø±',0),(214496,5959,'sr','Ð˜Ð—ÐÐžÐ¡',0),(214497,5959,'vi','Sá» LÆ¯á»¢NG',0),(214498,5959,'af','BEDRAG',0),(214499,5959,'ro','SUMA',0),(214500,5959,'et','SUMMA',0),(214501,5959,'si','ZNESEK',0),(214502,5959,'ba','JUMLAH',0),(214503,5959,'nl','BEDRAG',0),(214504,5959,'fi','MÃ„Ã„RÃ„',0),(214505,5959,'no','BELÃ˜P',0),(214506,5959,'da','BELÃ˜B',0),(214507,5959,'ko','ê¸ˆì•¡',0),(214508,5959,'he','×›×ž×•×ª',0),(214509,5959,'el','Î ÎŸÎ£ÎŒ',0),(214510,5959,'zh','é‡‘é¢\r\n',0),(214511,5959,'sv','BELOPP',0),(214512,5959,'it','IMPORTO',0),(214513,5959,'tl','',0),(214514,5959,'th','&#3592;&#3635;&#3609;&#3623;&#3609;',0),(214515,5959,'hi','à¤°à¤¾à¤¶à¤¿',0),(214516,5959,'ms','JUMLAH',0),(214517,5959,'ar','Ø§Ù„Ù…Ø¨Ù„Øº',0),(214518,5959,'fr','MONTANT',0),(214519,5959,'jp','é¡?',0),(214520,5959,'pt','QUANTIDADE',0),(214521,5959,'ru','Ð¡Ð£ÐœÐœÐ',0),(214522,5959,'es','CANTIDAD',0),(214523,5959,'de','BETRAG',0),(214524,5959,'en','AMOUNT',0),(214525,5960,'is','',0),(214526,5960,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¹Ù†ÙˆØ§Ù† ØªØ§Ø±ÙŠØ®',0),(214527,5960,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¹Ù†ÙˆØ§Ù† ØªØ§Ø±ÙŠØ®',0),(214528,5960,'tr','TARÄ°HÄ°',0),(214529,5960,'pl','DATA',0),(214530,5960,'bg','Ð”ÐÐ¢Ð',0),(214531,5960,'ur','ØªØ§Ø±ÛŒØ®',0),(214532,5960,'sr','Ð”ÐÐ¢Ð£Ðœ',0),(214533,5960,'vi','NGÃ€Y',0),(214534,5960,'af','DATUM',0),(214535,5960,'ro','DATA',0),(214536,5960,'et','KUUPÃ„EV',0),(214537,5960,'si','DATUM',0),(214538,5960,'ba','TANGGAL',0),(214539,5960,'nl','DATUM',0),(214540,5960,'fi','PÃ„IVÃ„MÃ„Ã„RÃ„',0),(214541,5960,'no','DATO',0),(214542,5960,'da','DATO',0),(214543,5960,'ko','ë‚ ì§œ',0),(214544,5960,'he','×ª××¨×™×š',0),(214545,5960,'el','Î—ÎœÎ•Î¡ÎŸÎœÎ—ÎÎŠÎ‘',0),(214546,5960,'zh','æ—¥æœŸ\r\n',0),(214547,5960,'sv','DATUM',0),(214548,5960,'it','DATA',0),(214549,5960,'tl','',0),(214550,5960,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(214551,5960,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(214552,5960,'ms','TARIKH',0),(214553,5960,'ar','ØªØ§Ø±ÙŠØ®',0),(214554,5960,'fr','DATE',0),(214555,5960,'jp','æ—¥ä»˜',0),(214556,5960,'pt','DATA',0),(214557,5960,'ru','Ð”ÐÐ¢Ð',0),(214558,5960,'es','FECHA',0),(214559,5960,'de','DATUM',0),(214560,5960,'en','DATE',0),(214561,5961,'is','',0),(214562,5961,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¹Ù†ÙˆØ§Ù†  Ø³ÙØ§Ø±Ø´ Ø§Ø² ',0),(214563,5961,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¹Ù†ÙˆØ§Ù†  Ø³ÙØ§Ø±Ø´ Ø§Ø² ',0),(214564,5961,'tr','SIRASINI',0),(214565,5961,'pl','KOLEJNOÅšÄ†',0),(214566,5961,'bg','Ð Ð•Ð” ÐÐ',0),(214567,5961,'ur','Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(214568,5961,'sr','Ð Ð•Ð”ÐžÐ¡Ð›Ð•Ð”',0),(214569,5961,'vi','ÄÆ N Äáº¶T HÃ€NG Cá»¦A',0),(214570,5961,'af','BESTELLING VAN',0),(214571,5961,'ro','ORDINEA DE',0),(214572,5961,'et','JÃ„RJEKORD',0),(214573,5961,'si','VRSTNI RED',0),(214574,5961,'ba','URUTAN',0),(214575,5961,'nl','VOLGORDE VAN',0),(214576,5961,'fi','RITARIKUNTA',0),(214577,5961,'no','REKKEFÃ˜LGE',0),(214578,5961,'da','RÃ†KKEFÃ˜LGEN AF',0),(214579,5961,'ko','ìˆœì„œ',0),(214580,5961,'he','×¡×“×¨',0),(214581,5961,'el','Î£Î•Î™Î¡Î†',0),(214582,5961,'zh','è®¢è´­\r\n',0),(214583,5961,'sv','ORDNING',0),(214584,5961,'it','ORDINE DI',0),(214585,5961,'tl','',0),(214586,5961,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;',0),(214587,5961,'hi','à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(214588,5961,'ms','PERINTAH',0),(214589,5961,'ar','ØªØ±ØªÙŠØ¨',0),(214590,5961,'fr','ORDRE DE',0),(214591,5961,'jp','ï½žã?®æ³¨æ–‡',0),(214592,5961,'pt','ORDEM DE',0),(214593,5961,'ru','Ð—ÐÐšÐÐ—',0),(214594,5961,'es','PEDIDO DE',0),(214595,5961,'de','REIHENFOLGE DER',0),(214596,5961,'en','ORDER OF',0),(214597,5962,'is','',0),(214598,5962,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¹Ù†ÙˆØ§Ù†  Ø­Ù‚ÙˆÙ‚',0),(214599,5962,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¹Ù†ÙˆØ§Ù†  Ø­Ù‚ÙˆÙ‚',0),(214600,5962,'tr','Ã–DEME',0),(214601,5962,'pl','ZAPÅACIÄ†',0),(214602,5962,'bg','Ð—ÐÐŸÐ›ÐÐ©ÐÐÐ•',0),(214603,5962,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(214604,5962,'sr','ÐŸÐ›ÐÐ¢Ð˜',0),(214605,5962,'vi','THANH TOÃN',0),(214606,5962,'af','BESOLDIGING',0),(214607,5962,'ro','PLATA',0),(214608,5962,'et','MAKSMA',0),(214609,5962,'si','PLAÄŒATI',0),(214610,5962,'ba','MEMBAYAR',0),(214611,5962,'nl','BETALEN',0),(214612,5962,'fi','MAKSU',0),(214613,5962,'no','BETALE',0),(214614,5962,'da','BETALE',0),(214615,5962,'ko','ì§€ë¶ˆ',0),(214616,5962,'he','×œ×©×œ×',0),(214617,5962,'el','Î Î›Î—Î¡ÎÎ£Î•Î™',0),(214618,5962,'zh','è–ªé…¬\r\n',0),(214619,5962,'sv','BETALA',0),(214620,5962,'it','PAGARE',0),(214621,5962,'tl','',0),(214622,5962,'th','&#3592;&#3656;&#3634;&#3618;',0),(214623,5962,'hi','à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(214624,5962,'ms','MEMBAYAR',0),(214625,5962,'ar','Ø¯ÙØ¹',0),(214626,5962,'fr','PAYER',0),(214627,5962,'jp','æ”¯æ‰•ã?„',0),(214628,5962,'pt','PAGAR',0),(214629,5962,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð°',0),(214630,5962,'es','PAGO',0),(214631,5962,'de','ZAHLEN',0),(214632,5962,'en','PAY',0),(214633,5963,'is','',0),(214634,5963,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¹Ù†ÙˆØ§Ù†  Ø¨Ù‡',0),(214635,5963,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¹Ù†ÙˆØ§Ù†  Ø¨Ù‡',0),(214636,5963,'tr','Ä°Ã‡Ä°N',0),(214637,5963,'pl','DO',0),(214638,5963,'bg','ÐšÐªÐœ',0),(214639,5963,'ur','Ú©Ø±Ù†Ø§',0),(214640,5963,'sr','Ð”Ð ÐˆÐ•',0),(214641,5963,'vi','Tá»šI',0),(214642,5963,'af','AAN DIE',0),(214643,5963,'ro','PENTRU a',0),(214644,5963,'et','ET SELLE',0),(214645,5963,'si','DA JE',0),(214646,5963,'ba','UNTUK',0),(214647,5963,'nl','AAN DE',0),(214648,5963,'fi','VOIT',0),(214649,5963,'no','TIL DEN',0),(214650,5963,'da','TIL DEN',0),(214651,5963,'ko','í•˜ëŠ”',0),(214652,5963,'he','×›×“×™ ××ª',0),(214653,5963,'el','ÎÎ‘ Î¤ÎŸ',0),(214654,5963,'zh','è‡´\r\n',0),(214655,5963,'sv','TILL DEN',0),(214656,5963,'it','PER IL',0),(214657,5963,'tl','',0),(214658,5963,'th','&#3652;&#3611;&#3626;&#3641;&#3656;',0),(214659,5963,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(214660,5963,'ms','UNTUK YANG',0),(214661,5963,'ar','Ù„Ø£Ù†',0),(214662,5963,'fr','Ã€ LA',0),(214663,5963,'jp','ï½žã?¸',0),(214664,5963,'pt','PARA o',0),(214665,5963,'ru','Ð”Ð›Ð¯',0),(214666,5963,'es','AL',0),(214667,5963,'de','ZU DEN',0),(214668,5963,'en','TO THE',0),(214669,5964,'is','',0),(214670,5964,'dr','Ù‡ÙŠÚ† Ù†Ø§Ù… ÙØ§ÙŠÙ„ÙŠ  Ùˆ Ù…Ø³ÙŠØ±ÙŠ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(214671,5964,'pr','Ù‡ÙŠÚ† Ù†Ø§Ù… ÙØ§ÙŠÙ„ÙŠ  Ùˆ Ù…Ø³ÙŠØ±ÙŠ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(214672,5964,'tr','HiÃ§bir dosya adÄ± ve yolu girdi',0),(214673,5964,'pl','Nie nazwa zbioru i Å›cieÅ¼ka wszedÅ‚',0),(214674,5964,'bg','ÐÑÐ¼Ð° Ð¸Ð¼Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð» Ð¸ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸ÑÑ‚ Ð¿ÑŠÑ‚',0),(214675,5964,'ur','Ú©ÙˆØ¦ÛŒ Ù†Ø§Ù… Ù…Ø³Ù„ Ø§ÙˆØ± Ø±Ø§Û Ø¯Ø§Ø®Ù„',0),(214676,5964,'sr','ÐÐµÐ¼Ð° Ð¸Ð¼Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð¸ Ð¿ÑƒÑ‚Ð°ÑšÐ° ÐºÐ¾Ñ˜Ñƒ ÑÑ‚Ðµ ÑƒÐ½ÐµÐ»Ð¸',0),(214677,5964,'vi','KhÃ´ng nháº­p tÃªn há»“ sÆ¡ & Ä‘Æ°á»ng dáº«n',0),(214678,5964,'af','Geen LÃªernaam en Lokaliteit Ingevoer',0),(214679,5964,'ro','Nici un nume de fiÅŸier ÅŸi calea intrat',0),(214680,5964,'et','Ãœhtegi faili nimi ja tee sisestatakse',0),(214681,5964,'si','No ime datoteke in pot zaÄel',0),(214682,5964,'ba','Tidak ada nama file dan jalan masuk',0),(214683,5964,'nl','Geen bestandsnaam en het pad opgegeven',0),(214684,5964,'fi','Tiedostonimi ja polku',0),(214685,5964,'no','Ingen filnavn og bane angitt',0),(214686,5964,'da','Ingen filnavn og sti angivet',0),(214687,5964,'ko','íŒŒì¼ ì´ë¦„ ë° ê²½ë¡œ ìž…ë ¥',0),(214688,5964,'he','××™×Ÿ ×•×”× ×ª×™×‘ × ×›× ×¡×•',0),(214689,5964,'el','ÎšÎ±Î½Î­Î½Î± ÏŒÎ½Î¿Î¼Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï… ÎºÎ±Î¹ Ï„Î· Î´Î¹Î±Î´ÏÎ¿Î¼Î® Ï€Î¿Ï… Ï„Î­Î¸Î·ÎºÎµ',0),(214690,5964,'zh','æ²¡æœ‰è¾“å…¥æ–‡ä»¶åå’Œè·¯å¾„\r\n',0),(214691,5964,'sv','Inga filnamn och sÃ¶kvÃ¤g anges',0),(214692,5964,'it','Nessun nome file e percorso immesso',0),(214693,5964,'tl','',0),(214694,5964,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3594;&#3639;&#3656;&#3629;&#3652;&#3615;&#3621;&#3660;&#3649;&#3621;&#3632;&#3614;&#3634;&#3608;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3611;&#3657;&#3636;&#3629;&#3609;',0),(214695,5964,'hi','à¤•à¥‹à¤ˆ à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¾à¤® à¤”à¤° à¤ªà¤¥ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(214696,5964,'ms','Tiada nama fail dan laluan yang dimasukkan',0),(214697,5964,'ar','Ù„Ø§ Ø§Ø³Ù… Ø§Ù„Ù…Ù„Ù ÙˆØ§Ù„Ù…Ø³Ø§Ø± Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§',0),(214698,5964,'fr','Aucun nom de fichier et le chemin entrÃ©',0),(214699,5964,'jp','ãƒ•ã‚¡ã‚¤ãƒ«å??ã?¨ãƒ‘ã‚¹ã?Œå…¥åŠ›ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(214700,5964,'pt','Nenhum nome de arquivo e caminho entrado',0),(214701,5964,'ru','ÐÐµ Ð¸Ð¼Ñ Ñ„Ð°Ð¹Ð»Ð° Ð¸ Ð¿ÑƒÑ‚ÑŒ',0),(214702,5964,'es','No se EntrÃ³ el nombre de archivo ni el path',0),(214703,5964,'de','Keine Dateinamen und Pfad eingegeben',0),(214704,5964,'en','No Filename and Path Entered',0),(214705,5965,'is','',0),(214706,5965,'dr','Ú¯Ø²Ø§Ø±Ø´  Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(214707,5965,'pr','Ú¯Ø²Ø§Ø±Ø´  Ø¬Ø²Ø¦ÙŠØ§Øª ',0),(214708,5965,'tr','AyrÄ±ntÄ± raporu',0),(214709,5965,'pl','Raport szczegÃ³Å‚owy',0),(214710,5965,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð°Ñ‚Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(214711,5965,'ur','ØªÙØµÛŒÙ„ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(214712,5965,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð´ÐµÑ‚Ð°Ñ™Ñƒ',0),(214713,5965,'vi','BÃ¡o cÃ¡o chi tiáº¿t',0),(214714,5965,'af','Detail Verslag',0),(214715,5965,'ro','Raport de tip detaliu',0),(214716,5965,'et','Ãœksikasjalik aruanne',0),(214717,5965,'si','Podrobno poroÄilo',0),(214718,5965,'ba','Laporan rinci',0),(214719,5965,'nl','De lijst detail',0),(214720,5965,'fi','Yksityiskohtainen raportti',0),(214721,5965,'no','Detaljert rapport',0),(214722,5965,'da','Detaljeret rapport',0),(214723,5965,'ko','ì„¸ë¶€ ì •ë³´ ë³´ê³ ì„œ',0),(214724,5965,'he','×“×• ×— ×ž×¤×•×¨×˜',0),(214725,5965,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½',0),(214726,5965,'zh','è¯¦ç»†æŠ¥å‘Š\r\n',0),(214727,5965,'sv','Detaljerad rapport',0),(214728,5965,'it','Report dettagli',0),(214729,5965,'tl','',0),(214730,5965,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(214731,5965,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(214732,5965,'ms','Laporan terperinci',0),(214733,5965,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(214734,5965,'fr','Rapport dÃ©taillÃ©',0),(214735,5965,'jp','æ—¥å ±',0),(214736,5965,'pt','RelatÃ³rio de detalhe',0),(214737,5965,'ru','Ð”ÐµÑ‚Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÐžÑ‚Ñ‡ÐµÑ‚',0),(214738,5965,'es','Informe Detallado',0),(214739,5965,'de','Detailbericht',0),(214740,5965,'en','Detail Report',0),(214741,5966,'is','',0),(214742,5966,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(214743,5966,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(214744,5966,'tr','AlÄ±nan sipariÅŸler listesi',0),(214745,5966,'pl','Lista otrzymanych zamÃ³wieniach',0),(214746,5966,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð°',0),(214747,5966,'ur','Ù…ÙˆØµÙˆÙ„Û Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’',0),(214748,5966,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð°',0),(214749,5966,'vi','ÄÃ£ nháº­n danh sÃ¡ch Ä‘Æ¡n hÃ ng cho ',0),(214750,5966,'af','Ontvang Bestellingslys Vir',0),(214751,5966,'ro','Lista comenzilor primite pentru',0),(214752,5966,'et','Saadud korralduste nimekiri',0),(214753,5966,'si','Seznam prejetih naroÄil za',0),(214754,5966,'ba','Menerima pesanan daftar untuk',0),(214755,5966,'nl','Ontvangen Orders lijst voor',0),(214756,5966,'fi','Tilauksia luettelo',0),(214757,5966,'no','Mottatte ordrer liste For',0),(214758,5966,'da','Modtagne ordrer liste For',0),(214759,5966,'ko','ë°›ì€ ì£¼ë¬¸ ëª©ë¡',0),(214760,5966,'he','×¨×©×™×ž×ª ×”×–×ž× ×•×ª ×©×”×ª×§×‘×œ×• ×¢×‘×•×¨',0),(214761,5966,'el','Î›Î¯ÏƒÏ„Î± Î»Î¬Î²ÎµÎ¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î³Î¹Î±',0),(214762,5966,'zh','å¯¹äºŽæ”¶åˆ°çš„è®¢å•åˆ—è¡¨\r\n',0),(214763,5966,'sv','Mottagna orderlistan fÃ¶r',0),(214764,5966,'it','Elenco di ordini ricevuti per',0),(214765,5966,'tl','',0),(214766,5966,'th','&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(214767,5966,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤†à¤¦à¥‡à¤¶ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(214768,5966,'ms','Senarai Tempahan diterima untuk',0),(214769,5966,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…Ø³ØªÙ„Ù…Ø©',0),(214770,5966,'fr','Liste des ordres reÃ§us des',0),(214771,5966,'jp','å?—é ˜æ¸ˆæ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(214772,5966,'pt','Lista de ordens recebidas para',0),(214773,5966,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð´Ð»Ñ',0),(214774,5966,'es','Lista de Ordenes Recibidos Para',0),(214775,5966,'de','Liste der empfangenen Orders fÃ¼r',0),(214776,5966,'en','Received Orders List For',0),(214777,5967,'is','',0),(214778,5967,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(214779,5967,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(214780,5967,'tr','AlÄ±nan sipariÅŸler listesi',0),(214781,5967,'pl','Listy zleceÅ„ otrzymanych',0),(214782,5967,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(214783,5967,'ur','ÙÛØ±Ø³Øª Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…ÙˆØµÙˆÙ„',0),(214784,5967,'sr','Ð›Ð¸ÑÑ‚Ðµ ÑÐ° Ð½Ð°Ð»Ð¾Ð·Ð¸ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð¸',0),(214785,5967,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng Ä‘Ã£ nháº­n',0),(214786,5967,'af','Lys van Bestellings Ontvang',0),(214787,5967,'ro','Liste cu ordinele primite',0),(214788,5967,'et','Saadud tellimuste loendit',0),(214789,5967,'si','Seznama prejetih naroÄil',0),(214790,5967,'ba','Daftar pesanan yang diterima',0),(214791,5967,'nl','Lijsten met bestellingen ontvangen',0),(214792,5967,'fi','Luettelo tilaukset',0),(214793,5967,'no','Lister over ordrer mottatt',0),(214794,5967,'da','Lister over indkomne ordrer',0),(214795,5967,'ko','ì£¼ë¬¸ ì ‘ìˆ˜ ëª©ë¡',0),(214796,5967,'he','×¨×©×™×ž×•×ª ×©×œ ×”×–×ž× ×•×ª ×©× ×ª×§×‘×œ×•',0),(214797,5967,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ Ï„Ï‰Î½ ÎµÎ½Ï„Î¿Î»ÏŽÎ½ Ï€Î¿Ï… Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½',0),(214798,5967,'zh','æ”¶åˆ°çš„è®¢å•åˆ—è¡¨\r\n',0),(214799,5967,'sv','Listor Ã¶ver orderingÃ¥ngen',0),(214800,5967,'it','Elenchi degli ordini ricevuti',0),(214801,5967,'tl','',0),(214802,5967,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(214803,5967,'hi','à¤¸à¥‚à¤šà¤¿à¤¯à¥‹à¤‚ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(214804,5967,'ms','Senarai pesanan yang diterima',0),(214805,5967,'ar','Ù‚ÙˆØ§Ø¦Ù… Ù„ØªÙ„Ù‚ÙŠ Ø£ÙˆØ§Ù…Ø±',0),(214806,5967,'fr','Listes des commandes reÃ§ues',0),(214807,5967,'jp','å?—é ˜æ¸ˆæ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(214808,5967,'pt','Listas de ordens recebidas',0),(214809,5967,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(214810,5967,'es','Listas de Pedidos Recibidos',0),(214811,5967,'de','Listen der AuftrÃ¤ge',0),(214812,5967,'en','Lists of Orders Received',0),(214813,5968,'is','',0),(214814,5968,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù‚Ø§Ø¨Ù„ÙŠØª Ø³ÙˆØ¯ Ø¯Ù‡ÙŠ',0),(214815,5968,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù‚Ø§Ø¨Ù„ÙŠØª Ø³ÙˆØ¯ Ø¯Ù‡ÙŠ',0),(214816,5968,'tr','KarlÄ±lÄ±k raporu',0),(214817,5968,'pl','Raport rentownoÅ›Ä‡',0),(214818,5968,'bg','Ð ÐµÐ½Ñ‚Ð°Ð±Ð¸Ð»Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð´Ð¾ÐºÐ»Ð°Ð´',0),(214819,5968,'ur','Ù…Ù†Ø§ÙØ¹ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(214820,5968,'sr','ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚Ð°Ð±Ð¸Ð»Ð½Ð¾ÑÑ‚ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(214821,5968,'vi','BÃ¡o CÃ¡o lá»£i nhuáº­n',0),(214822,5968,'af','Winsgewendheidsverslag',0),(214823,5968,'ro','Raport de rentabilitate',0),(214824,5968,'et','Kasumlikkuse aruanne',0),(214825,5968,'si','Donosnost poroÄilo',0),(214826,5968,'ba','Profitabilitas laporan',0),(214827,5968,'nl','Winstgevendheid verslag',0),(214828,5968,'fi','Kannattavuusraportti',0),(214829,5968,'no','LÃ¸nnsomhet rapport',0),(214830,5968,'da','Rentabiliteten rapport',0),(214831,5968,'ko','ìˆ˜ìµì„± ë³´ê³ ì„œ',0),(214832,5968,'he','×‘×“×•×— ×”×¨×•×•×—×™×•×ª',0),(214833,5968,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ ÎºÎµÏÎ´Î¿Ï†Î¿ÏÎ¯Î±',0),(214834,5968,'zh','ç›ˆåˆ©æŠ¥å‘Š\r\n',0),(214835,5968,'sv','LÃ¶nsamhet rapport',0),(214836,5968,'it','Relazione di redditivitÃ ',0),(214837,5968,'tl','',0),(214838,5968,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3623;&#3634;&#3617;&#3652;&#3604;&#3657;&#3648;&#3611;&#3619;&#3637;&#3618;&#3610;',0),(214839,5968,'hi','à¤²à¤¾à¤­à¤ªà¥à¤°à¤¦à¤¤à¤¾ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(214840,5968,'ms','Laporan keuntungan',0),(214841,5968,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø±Ø¨Ø­ÙŠØ©',0),(214842,5968,'fr','Rapport de rentabilitÃ©',0),(214843,5968,'jp','ã‚»ãƒ¼ãƒ«ã‚¹å?Žç›Šæ€§ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(214844,5968,'pt','RelatÃ³rio de rentabilidade',0),(214845,5968,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ ÐŸÐ¾ Ð”Ð¾Ñ…Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸',0),(214846,5968,'es','Informe de Renatbilidad',0),(214847,5968,'de','RentabilitÃ¤t-Bericht',0),(214848,5968,'en','Profitability Report',0),(214849,5969,'is','',0),(214850,5969,'dr','ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ ÙˆØ²ÙŠØ§Ù†',0),(214851,5969,'pr','ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ ÙˆØ²ÙŠØ§Ù†',0),(214852,5969,'tr','Gelir tablosu',0),(214853,5969,'pl','Rachunek zyskÃ³w i strat',0),(214854,5969,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð´Ð¾Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(214855,5969,'ur','Ø¢Ù…Ø¯Ù†ÛŒ Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(214856,5969,'sr','Ð‘Ð¸Ð»Ð°Ð½ÑÐ°',0),(214857,5969,'vi','BÃ¡o cÃ¡o thu nháº­p',0),(214858,5969,'af','Inkomste Staat',0),(214859,5969,'ro','DeclaraÅ£ie de venit',0),(214860,5969,'et','Kasumiaruanne',0),(214861,5969,'si','Izkaz poslovnega izida',0),(214862,5969,'ba','Laporan laba rugi',0),(214863,5969,'nl','Winst-en verliesrekening',0),(214864,5969,'fi','Tuloslaskelma',0),(214865,5969,'no','Resultatregnskapet',0),(214866,5969,'da','ResultatopgÃ¸relsen',0),(214867,5969,'ko','ì†ìµ ê³„ì‚° ì„œ',0),(214868,5969,'he','×“×•×— ×¨×•×•×— ×•×”×¤×¡×“',0),(214869,5969,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÏƒÏŒÎ´Ï‰Î½ ÎºÎ±Î¹ ÎµÎ¾ÏŒÎ´Ï‰Î½',0),(214870,5969,'zh','æŸç›Šè¡¨\r\n',0),(214871,5969,'sv','ResultatrÃ¤kningen',0),(214872,5969,'it','Conto economico',0),(214873,5969,'tl','',0),(214874,5969,'th','&#3591;&#3610;&#3585;&#3635;&#3652;&#3619;&#3586;&#3634;&#3604;&#3607;&#3640;&#3609;',0),(214875,5969,'hi','à¤†à¤¯ à¤¸à¥à¤Ÿà¥‡à¤Ÿà¤®à¥‡à¤‚à¤Ÿ',0),(214876,5969,'ms','Penyata pendapatan',0),(214877,5969,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¯Ø®Ù„',0),(214878,5969,'fr','Compte de rÃ©sultat',0),(214879,5969,'jp','å?Žå…¥æ˜Žç´°',0),(214880,5969,'pt','DemonstraÃ§Ã£o de resultados',0),(214881,5969,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑÑ… Ð¸ ÑƒÐ±Ñ‹Ñ‚ÐºÐ°Ñ…',0),(214882,5969,'es','DeclaraciÃ³n de Ingresos',0),(214883,5969,'de','Gewinn-und Verlustrechnung',0),(214884,5969,'en','Income Statement',0),(214885,5970,'is','',0),(214886,5970,'dr','Ù†Ù…Ø§ÙŠØ´  ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ ÙˆØ²ÙŠØ§Ù†',0),(214887,5970,'pr','Ù†Ù…Ø§ÙŠØ´  ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ ÙˆØ²ÙŠØ§Ù†',0),(214888,5970,'tr','GÃ¶rÃ¼nÃ¼m gelir tablosu',0),(214889,5970,'pl','Widok rachunku zyskÃ³w i strat',0),(214890,5970,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° ÐžÐŸÐ ',0),(214891,5970,'ur','Ø¢Ù…Ø¯Ù†ÛŒ Ú©Ø§ Ø¨ÛŒØ§Ù† Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(214892,5970,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð±Ð¸Ð»Ð°Ð½ÑÐ°',0),(214893,5970,'vi','Xem sao kÃª thu nháº­p',0),(214894,5970,'af','Besigtig Inkomstestaat',0),(214895,5970,'ro','DeclaraÅ£ie de venit Vezi',0),(214896,5970,'et','Vaata sissetulekute vÃ¤ljavÃµtet',0),(214897,5970,'si','Pogled izkaza',0),(214898,5970,'ba','Lihat laporan laba rugi',0),(214899,5970,'nl','Weergave winst-en verliesrekening',0),(214900,5970,'fi','Katso tuloslaskelma',0),(214901,5970,'no','Vis resultatregnskapet',0),(214902,5970,'da','Se resultatopgÃ¸relsen',0),(214903,5970,'ko','ë³´ê¸° ì†ìµ ê³„ì‚° ì„œ',0),(214904,5970,'he','×ª×¦×•×’×ª ×“×•×— ×¨×•×•×— ×•×”×¤×¡×“',0),(214905,5970,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Ï€Î¿Ï„ÎµÎ»ÎµÏƒÎ¼Î¬Ï„Ï‰Î½',0),(214906,5970,'zh','æŸ¥çœ‹æŸç›Šè¡¨\r\n',0),(214907,5970,'sv','Visa resultatrÃ¤kning',0),(214908,5970,'it','Conto economico vista',0),(214909,5970,'tl','',0),(214910,5970,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(214911,5970,'hi','à¤†à¤¯ à¤•à¤¥à¤¨ à¤¦à¥‡à¤–à¥‡à¤‚',0),(214912,5970,'ms','Lihat penyata pendapatan',0),(214913,5970,'ar','Ø¹Ø±Ø¶ Ø¨ÙŠØ§Ù† Ø§Ù„Ø¯Ø®Ù„',0),(214914,5970,'fr','Compte de rÃ©sultat de vue',0),(214915,5970,'jp','å?Žå…¥æ˜Žç´°ã?®è¡¨ç¤º',0),(214916,5970,'pt','Ver demonstraÃ§Ã£o',0),(214917,5970,'ru','ÐœÐ½ÐµÐ½Ð¸Ðµ Ð¾ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑÑ… Ð¸ ÑƒÐ±Ñ‹Ñ‚ÐºÐ°Ñ…',0),(214918,5970,'es','Visionar Estado de Cuenta de Renta',0),(214919,5970,'de','Ansicht Gewinn-und Verlustrechnung',0),(214920,5970,'en','View Income Statement',0),(214921,5971,'is','',0),(214922,5971,'dr','Ø®Ù„Ø§ØµÙ‡ Ø¯Ø±Ø¢Ù…Ø¯',0),(214923,5971,'pr','Ø®Ù„Ø§ØµÙ‡ Ø¯Ø±Ø¢Ù…Ø¯',0),(214924,5971,'tr','Gelir Ã–zeti',0),(214925,5971,'pl','KrÃ³tki opis dochodÃ³w',0),(214926,5971,'bg','ÐŸÑ€Ð¸Ñ…Ð¾Ð´Ð¸ Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(214927,5971,'ur','Ø¢Ù…Ø¯Ù†ÛŒ Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(214928,5971,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(214929,5971,'vi','Tá»•ng há»£p thu nháº­p',0),(214930,5971,'af','Inkomste Opsomming',0),(214931,5971,'ro','Venituri Rezumat',0),(214932,5971,'et','Tulu KokkuvÃµte',0),(214933,5971,'si','Dohodek Povzetek',0),(214934,5971,'ba','Pendapatan Ringkasan',0),(214935,5971,'nl','Inkomsten Samenvatting',0),(214936,5971,'fi','Tulot Yhteenveto',0),(214937,5971,'no','Inntekt Sammendrag',0),(214938,5971,'da','Indkomst ResumÃ©',0),(214939,5971,'ko','ìˆ˜ìž… ìš”ì•½',0),(214940,5971,'he','×¡×™×›×•× ×”×›× ×¡×•×ª',0),(214941,5971,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Ï„Î¿Ï… ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(214942,5971,'zh','æ”¶ç›Šæ±‡æ€»\r\n',0),(214943,5971,'sv','Inkomst Sammanfattning',0),(214944,5971,'it','Riepilogo di reddito',0),(214945,5971,'tl','',0),(214946,5971,'th','&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3650;&#3604;&#3618;&#3626;&#3619;&#3640;&#3611;',0),(214947,5971,'hi','à¤†à¤¯ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(214948,5971,'ms','Ringkasan pendapatan',0),(214949,5971,'ar','Ù…Ù„Ø®Ù‘Øµ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯',0),(214950,5971,'fr','RÃ©sumÃ© de revenu',0),(214951,5971,'jp','å?Žå…¥ç·?æ‹¬',0),(214952,5971,'pt','Resumo de renda',0),(214953,5971,'ru','Ð”Ð¾Ñ…Ð¾Ð´ Ð ÐµÑ„ÐµÑ€Ð°Ñ‚',0),(214954,5971,'es','Sumario de Ingresos',0),(214955,5971,'de','Einkommen-Zusammenfassung',0),(214956,5971,'en','Income Summary',0),(214957,5972,'is','',0),(214958,5972,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡',0),(214959,5972,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡',0),(214960,5972,'tr','Fullfillment sipariÅŸler iÃ§in varsayÄ±lan Kategori',0),(214961,5972,'pl','Kategorii domyÅ›lnej dla Fullfillment zamÃ³wienia',0),(214962,5972,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð·Ð° Fullfillment Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(214963,5972,'ur','ÙÙˆÙ„ÙÙ„Ù…ÛŒÙ†Ù¹ Ú©Û’ Ø­Ú©Ù… Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û Ø²Ù…Ø±Û',0),(214964,5972,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð·Ð° Ð¤ÑƒÐ»Ð»Ñ„Ð¸Ð»Ð»Ð¼ÐµÐ½Ñ‚ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(214965,5972,'vi','Thá»ƒ loáº¡i máº·c Ä‘á»‹nh cho ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(214966,5972,'af','Verstekte Kategorie vir Nuwe Uitvoeringsbestelling ',0),(214967,5972,'ro','Categoria implicit pentru laolaltÄƒ comenzi',0),(214968,5972,'et','Vaikimisi kategooria kaubatellimuse jaoks',0),(214969,5972,'si','Privzeta kategorija za Fullfillment naroÄila',0),(214970,5972,'ba','Patokan Jenis untuk Pemenuhan Pesanan',0),(214971,5972,'nl','Standaardcategorie voor Fullfillment bestellingen',0),(214972,5972,'fi','Fullfillment tilaukset oletusluokka',0),(214973,5972,'no','Standardkategori for Fullfillment bestillinger',0),(214974,5972,'da','Standardart for fuldendelse ordrer',0),(214975,5972,'ko','Fullfillment ì£¼ë¬¸ì— ëŒ€ í•œ ê¸°ë³¸ ì¹´í…Œê³ ë¦¬',0),(214976,5972,'he','×§×˜×’×•×¨×™×ª ×‘×¨×™×¨×ª ×ž×—×“×œ ×¢×‘×•×¨ ×”×–×ž× ×•×ª Fullfillment',0),(214977,5972,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Fullfillment',0),(214978,5972,'zh','é»˜è®¤åˆ†ç±»ä¸ºå±¥è¡Œè®¢å•\r\n',0),(214979,5972,'sv','Standardkategori fÃ¶r Fullfillment order',0),(214980,5972,'it','Categoria predefinita per gli ordini Fullfillment',0),(214981,5972,'tl','',0),(214982,5972,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3',0),(214983,5972,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ Fullfillment à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(214984,5972,'ms','Kategori lalai untuk pesanan Fullfillment',0),(214985,5972,'ar','Ø§Ù„ÙØ¦Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø´Ø±Ø§ÙƒØ©',0),(214986,5972,'fr','CatÃ©gorie par dÃ©faut pour les commandes Fullfillment',0),(214987,5972,'jp','å‡¦ç?†æ¸ˆæ³¨æ–‡ã?®æ—¢å®šã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(214988,5972,'pt','Categoria PadrÃ£o de Ordens de Preenchimento',0),(214989,5972,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ Ð¸ÑÐ¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(214990,5972,'es','CategorÃ­a por Defecto para Ordenes de Cumplimiento',0),(214991,5972,'de','Standardkategorie fÃ¼r Fullfillment-Bestellungen',0),(214992,5972,'en','Default Category for Fullfillment Orders',0),(214993,5973,'is','',0),(214994,5973,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(214995,5973,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(214996,5973,'tr','Faturalar iÃ§in varsayÄ±lan Kategori',0),(214997,5973,'pl','Kategorii domyÅ›lnej dla faktur',0),(214998,5973,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(214999,5973,'ur','Ø·Û’ Ø´Ø¯Û Ø²Ù…Ø±Û ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ù„Ø¦Û’',0),(215000,5973,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(215001,5973,'vi','Thá»ƒ loáº¡i máº·c Ä‘á»‹nh cho hÃ³a Ä‘Æ¡n',0),(215002,5973,'af','Verstekte Kategorie vir Fakture',0),(215003,5973,'ro','Categoria implicit pentru facturile',0),(215004,5973,'et','Arvete vaikekategooria',0),(215005,5973,'si','Privzeta kategorija za raÄune',0),(215006,5973,'ba','Kategori standar untuk faktur',0),(215007,5973,'nl','Standaardcategorie voor facturen',0),(215008,5973,'fi','Laskujen oletusluokka',0),(215009,5973,'no','Standardkategori for fakturaer',0),(215010,5973,'da','Standardart for fakturaer',0),(215011,5973,'ko','ì²­êµ¬ì„œ ê¸°ë³¸ ì¹´í…Œê³ ë¦¬',0),(215012,5973,'he','×§×˜×’×•×¨×™×ª ×‘×¨×™×¨×ª ×ž×—×“×œ ×¢×‘×•×¨ ×—×©×‘×•× ×™×•×ª',0),(215013,5973,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î³Î¹Î± Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(215014,5973,'zh','é»˜è®¤åˆ†ç±»å‘ç¥¨\r\n',0),(215015,5973,'sv','Standardkategori fÃ¶r fakturor',0),(215016,5973,'it','Categoria predefinita per le fatture',0),(215017,5973,'tl','',0),(215018,5973,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(215019,5973,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(215020,5973,'ms','Kategori lalai untuk invois',0),(215021,5973,'ar','Ø§Ù„ÙØ¦Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ù„Ù„ÙÙˆØ§ØªÙŠØ±',0),(215022,5973,'fr','CatÃ©gorie par dÃ©faut pour les factures',0),(215023,5973,'jp','è«‹æ±‚æ›¸ã?®æ—¢å®šã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(215024,5973,'pt','Categoria PadrÃ£o de Faturas',0),(215025,5973,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(215026,5973,'es','CategorÃ­a por Defecto para Facturas',0),(215027,5973,'de','Standardkategorie fÃ¼r Rechnungen',0),(215028,5973,'en','Default Category for Invoices',0),(215029,5974,'is','',0),(215030,5974,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± ',0),(215031,5974,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± ',0),(215032,5974,'tr','VarsayÄ±lan kategori iÃ§in fatura olmadan satÄ±ÅŸ gelirleri',0),(215033,5974,'pl','Kategorii domyÅ›lnej dla sprzedaÅ¼y przychody bez faktury',0),(215034,5974,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ð±ÐµÐ· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(215035,5974,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø¨ØºÛŒØ± Ø³ÛŒÙ„Ø² Ø±Ø³ÛŒØ¯ÙˆÚº Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û Ø²Ù…Ø±Û',0),(215036,5974,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð·Ð° ÑƒÐ»Ð°Ð·Ð½Ðµ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ñ†Ðµ Ð±ÐµÐ· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(215037,5974,'vi','Thá»ƒ loáº¡i máº·c Ä‘á»‹nh cho biÃªn nháº­n bÃ¡n hÃ ng khÃ´ng cÃ³ hÃ³a Ä‘Æ¡n',0),(215038,5974,'af','Verstek kategorie vir verkope kwitansies sonder faktuur',0),(215039,5974,'ro','Categoria implicit pentru recepÅ£ii vÃ¢nzÄƒri fÄƒrÄƒ facturÄƒ',0),(215040,5974,'et','Ilma arve ostukviitungid vaikekategooria',0),(215041,5974,'si','Privzeta kategorija prodaje prevzemnic brez raÄuna',0),(215042,5974,'ba','Kategori standar untuk penjualan penerimaan tanpa faktur',0),(215043,5974,'nl','Standaardcategorie voor verkoop ontvangsten zonder factuur',0),(215044,5974,'fi','Myyntituloja ilman laskua oletusluokka',0),(215045,5974,'no','Standardkategori for avsetning kvitteringer uten faktura',0),(215046,5974,'da','Standardart for salg kvitteringer uden faktura',0),(215047,5974,'ko','ì†¡ìž¥ ì—†ì´ íŒë§¤ ì˜ìˆ˜ì¦ì— ëŒ€ í•œ ê¸°ë³¸ ì¹´í…Œê³ ë¦¬',0),(215048,5974,'he','×§×˜×’×•×¨×™×ª ×‘×¨×™×¨×ª ×ž×—×“×œ ×¢×‘×•×¨ ×”×—×©×‘×•× ×™×ª ×œ×œ× ×—×©×‘×•× ×™×ª',0),(215049,5974,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î³Î¹Î± Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î»Î±Î²Î­Ï‚ Ï€ÏŽÎ»Î·ÏƒÎµÏ‰Î½ Ï‡Ï‰ÏÎ¯Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(215050,5974,'zh','é»˜è®¤æ— å‘ç¥¨é”€å”®æ”¶æ®åˆ†ç±»\r\n',0),(215051,5974,'sv','Standardkategori fÃ¶r fÃ¶rsÃ¤ljning inleveranser utan faktura',0),(215052,5974,'it','Categoria predefinita per le ricevute di vendita senza fattura',0),(215053,5974,'tl','',0),(215054,5974,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3',0),(215055,5974,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(215056,5974,'ms','Kategori lalai bagi resit jualan tanpa invois',0),(215057,5974,'ar','Ø§Ù„ÙØ¦Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ù„Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¯ÙˆÙ† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(215058,5974,'fr','CatÃ©gorie par dÃ©faut pour les reÃ§us de vente sans facture',0),(215059,5974,'jp','è«‹æ±‚æ›¸ã?ªã?—ã‚»ãƒ¼ãƒ«ã‚¹é ˜å?Žæ›¸ã?®æ—¢å®šã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(215060,5974,'pt','Categoria PadrÃ£o de Recibos Comerciais sem Fatura',0),(215061,5974,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð±ÐµÐ· ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(215062,5974,'es','CategorÃ­a por Defecto para Recibos de Ventas sin Facura',0),(215063,5974,'de','Standardkategorie fÃ¼r Belege fÃ¼r Lieferungen ohne Rechnung',0),(215064,5974,'en','Default Category for Sales Receipts without Invoice',0),(215065,5975,'is','',0),(215066,5975,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(215067,5975,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(215068,5975,'tr','Servis sipariÅŸleri iÃ§in varsayÄ±lan Kategori',0),(215069,5975,'pl','Kategorii domyÅ›lnej dla zleceÅ„ serwisowych',0),(215070,5975,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÑ‚Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(215071,5975,'ur','Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ø·Û’ Ø´Ø¯Û Ø²Ù…Ø±Û',0),(215072,5975,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(215073,5975,'vi','Thá»ƒ loáº¡i máº·c Ä‘á»‹nh cho ÄÆ¡n HÃ ng Dá»‹ch Vá»¥',0),(215074,5975,'af','Verstekte Kategorie vir Diens Bestellings',0),(215075,5975,'ro','Categoria implicit pentru comenzi de Service',0),(215076,5975,'et','Hooldustellimuste vaikekategooria',0),(215077,5975,'si','Privzeta kategorija za servisne naloge',0),(215078,5975,'ba','Patokan Jenis untuk Layanan Pesanan',0),(215079,5975,'nl','Standaardcategorie voor serviceorders',0),(215080,5975,'fi','Huoltotilausten oletusluokka',0),(215081,5975,'no','Standardkategori for serviceordrer',0),(215082,5975,'da','Standardart for serviceordrer',0),(215083,5975,'ko','ì„œë¹„ìŠ¤ ëª…ë ¹ì— ëŒ€ í•œ ê¸°ë³¸ ì¹´í…Œê³ ë¦¬',0),(215084,5975,'he','×§×˜×’×•×¨×™×ª ×‘×¨×™×¨×ª ×ž×—×“×œ ×¢×‘×•×¨ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(215085,5975,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚ Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(215086,5975,'zh','é»˜è®¤åˆ†ç±»ä¸ºæœåŠ¡ä»¤\r\n',0),(215087,5975,'sv','Standardkategori fÃ¶r serviceorder',0),(215088,5975,'it','Categoria predefinita per gli ordini di servizio',0),(215089,5975,'tl','',0),(215090,5975,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(215091,5975,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(215092,5975,'ms','Kategori lalai untuk Tempahan Perkhidmatan',0),(215093,5975,'ar','Ø§Ù„ÙØ¦Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(215094,5975,'fr','CatÃ©gorie par dÃ©faut pour les commandes de Service',0),(215095,5975,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®æ—¢å®šã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(215096,5975,'pt','Categoria PadrÃ£o de Ordens de ServiÃ§o',0),(215097,5975,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(215098,5975,'es','CategorÃ­a por Defecto para Ordenes de Servicio',0),(215099,5975,'de','Standardkategorie fÃ¼r ServiceauftrÃ¤ge',0),(215100,5975,'en','Default Category for Service Orders',0),(215101,5976,'is','',0),(215102,5976,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´',0),(215103,5976,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´',0),(215104,5976,'tr','SatÄ±ÅŸ Kategori DÃ¼zenle',0),(215105,5976,'pl','Edycja kategorii sprzedaÅ¼y',0),(215106,5976,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð² Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(215107,5976,'ur','Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(215108,5976,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(215109,5976,'vi','Cáº­p Nháº­t thá»ƒ loáº¡i bÃ¡n hÃ ng',0),(215110,5976,'af','VerkoopskategoriÃ« Opdateer',0),(215111,5976,'ro','Editare categorie vÃ¢nzÄƒri',0),(215112,5976,'et','Edit mÃ¼Ã¼k kategooria',0),(215113,5976,'si','Urejanje prodajnega kategorije',0),(215114,5976,'ba','Mengedit kategori penjualan',0),(215115,5976,'nl','Verkoop rubriek bewerken',0),(215116,5976,'fi','Muokkaa myynnin',0),(215117,5976,'no','Rediger salgs kategori',0),(215118,5976,'da','Redigere salgskategori',0),(215119,5976,'ko','íŒë§¤ ì¹´í…Œê³ ë¦¬ íŽ¸ì§‘',0),(215120,5976,'he','×¢×“×›×•×Ÿ ×§×˜×’×•×¨×™×ª ×ž×›×™×¨×•×ª',0),(215121,5976,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(215122,5976,'zh','é”€å”®ç±»æ›´æ–°\r\n',0),(215123,5976,'sv','Redigera fÃ¶rsÃ¤ljningskategori',0),(215124,5976,'it','Modificare la categoria Sales',0),(215125,5976,'tl','',0),(215126,5976,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(215127,5976,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(215128,5976,'ms','Mengedit kategori jualan',0),(215129,5976,'ar','ØªØ­Ø¯ÙŠØ« ØªØµÙ†ÙŠÙ Ù…Ø¨ÙŠØ¹Ø§Øª',0),(215130,5976,'fr','Modifier la catÃ©gorie de ventes',0),(215131,5976,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®æ›´æ–°',0),(215132,5976,'pt','Editar Categoria vendas',0),(215133,5976,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(215134,5976,'es','CategorÃ­a de Ventas Actualizar',0),(215135,5976,'de','Sales-Kategorie bearbeiten',0),(215136,5976,'en','Edit Sales Category',0),(215137,5977,'is','',0),(215138,5977,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´ ',0),(215139,5977,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´ ',0),(215140,5977,'tr','Yeni satÄ±ÅŸ kategorisi',0),(215141,5977,'pl','Nowa kategoria sprzedaÅ¼y',0),(215142,5977,'bg','ÐÐ¾Ð²Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(215143,5977,'ur','Ù†Ø¦ÛŒ ÙØ±ÙˆØ®Øª Ø²Ù…Ø±Û',0),(215144,5977,'sr','ÐÐ¾Ð²Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(215145,5977,'vi','ThÃªm Thá»ƒ loáº¡i bÃ¡n hÃ ng',0),(215146,5977,'af','Verkope Kategorie Byvoeg',0),(215147,5977,'ro','VÃ¢nzÄƒri categorie nouÄƒ',0),(215148,5977,'et','Uus mÃ¼Ã¼k kategooria',0),(215149,5977,'si','Nova prodajna Kategorija',0),(215150,5977,'ba','Kategori penjualan baru',0),(215151,5977,'nl','Nieuwe verkoop categorie',0),(215152,5977,'fi','Uusi myynti luokka',0),(215153,5977,'no','Ny salgs kategori',0),(215154,5977,'da','Nye salgskategori',0),(215155,5977,'ko','ìƒˆë¡œìš´ íŒë§¤ ì¹´í…Œê³ ë¦¬',0),(215156,5977,'he','×”×•×¡×£ ×§×˜×’×•×¨×™×ª ×ž×›×™×¨×•×ª',0),(215157,5977,'el','ÎÎ­Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(215158,5977,'zh','é”€å”®ç±»æ·»åŠ \r\n',0),(215159,5977,'sv','Nya fÃ¶rsÃ¤ljningskategori',0),(215160,5977,'it','Nuova categoria Sales',0),(215161,5977,'tl','',0),(215162,5977,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(215163,5977,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(215164,5977,'ms','Kategori jualan baru',0),(215165,5977,'ar','Ø¥Ø¶Ø§ÙØ© ØªØµÙ†ÙŠÙ Ù…Ø¨ÙŠØ¹Ø§Øª',0),(215166,5977,'fr','Nouvelle catÃ©gorie vente',0),(215167,5977,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®è¿½åŠ ',0),(215168,5977,'pt','Nova categoria vendas',0),(215169,5977,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(215170,5977,'es','Agregar CategorÃ­a de Ventas',0),(215171,5977,'de','Neue Sales-Kategorie',0),(215172,5977,'en','New Sales Category',0),(215173,5978,'is','',0),(215174,5978,'dr','Ø§ØµÙ„Ø§Ø­ Ù‚ÙŠÙ…Øª',0),(215175,5978,'pr','Ø§ØµÙ„Ø§Ø­ Ù‚ÙŠÙ…Øª',0),(215176,5978,'tr','S. maliyet',0),(215177,5978,'pl','Korekta kosztÃ³w',0),(215178,5978,'bg','Adj. Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(215179,5978,'ur','Adj. Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(215180,5978,'sr','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(215181,5978,'vi','Sá»­a Äá»•i Chi PhÃ­',0),(215182,5978,'af','Koste Aansuiw.',0),(215183,5978,'ro','Adj. Cost',0),(215184,5978,'et','Adj. kulu',0),(215185,5978,'si','Adj. stroÅ¡kov',0),(215186,5978,'ba','Biaya adj.',0),(215187,5978,'nl','Bn. kosten',0),(215188,5978,'fi','Adj. kustannukset',0),(215189,5978,'no','Adj. kostnader',0),(215190,5978,'da','Adj. omkostninger',0),(215191,5978,'ko','í˜•. ë¹„ìš©',0),(215192,5978,'he','(×ª\') ×¢×œ×•×ª',0),(215193,5978,'el','Adj. ÎºÏŒÏƒÏ„Î¿Ï‚',0),(215194,5978,'zh','è°ƒæ•´æˆæœ¬\r\n',0),(215195,5978,'sv','Adj. kostnad',0),(215196,5978,'it','Costo ADJ',0),(215197,5978,'tl','',0),(215198,5978,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(215199,5978,'hi','Adj. à¤²à¤¾à¤—à¤¤',0),(215200,5978,'ms','Adj. kos',0),(215201,5978,'ar','ØªÙƒÙ„ÙØ© Øµ.',0),(215202,5978,'fr','Adj. coÃ»t',0),(215203,5978,'jp','è²»ç”¨èª¿æ•´',0),(215204,5978,'pt','Adj. custo',0),(215205,5978,'ru','ADJ. ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(215206,5978,'es','Ajustar el Costo',0),(215207,5978,'de','Adj. Kosten',0),(215208,5978,'en','Adj. Cost',0),(215209,5979,'is','',0),(215210,5979,'dr','Ø§ØµÙ„Ø§Ø­ Ù…Ù‚Ø¯Ø§Ø± ÙØ§ÙƒØªÙˆØ±',0),(215211,5979,'pr','Ø§ØµÙ„Ø§Ø­ Ù…Ù‚Ø¯Ø§Ø± ÙØ§ÙƒØªÙˆØ±',0),(215212,5979,'tr','Adj.Invoice Amt',0),(215213,5979,'pl','Adj.Invoice Amt',0),(215214,5979,'bg','Adj.Invoice Amt',0),(215215,5979,'ur','Adj.Invoice Ø§Ù…Ù¹',0),(215216,5979,'sr','Ð Ð•Ð¤ . Ð’Ð°Ð» ÐÐ´Ñ˜.Ð˜Ð½Ð²Ð¾Ð¸Ñ†Ðµ.',0),(215217,5979,'vi','Sá»­a Äá»•i HÃ³a ÄÆ¡n $',0),(215218,5979,'af','Aansuiwerings Faktuur R',0),(215219,5979,'ro','Adj.Invoice Amt',0),(215220,5979,'et','Adj.Invoice Amt',0),(215221,5979,'si','Adj.Invoice Amt',0),(215222,5979,'ba','Adj.Invoice Amt',0),(215223,5979,'nl','Adj.Invoice Amt',0),(215224,5979,'fi','Adj.Invoice Amt',0),(215225,5979,'no','Adj.Invoice Amt',0),(215226,5979,'da','Adj.Invoice Amt',0),(215227,5979,'ko','Adj.Invoice Amt',0),(215228,5979,'he','Adj.Invoice Amt',0),(215229,5979,'el','Adj.Invoice Amt',0),(215230,5979,'zh','è°ƒæ•´å‘ç¥¨$\r\n',0),(215231,5979,'sv','Adj.Invoice Amt',0),(215232,5979,'it','Adj.Invoice Amt',0),(215233,5979,'tl','',0),(215234,5979,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3651;&#3609;&#3651;&#3610;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;',0),(215235,5979,'hi','Adj.Invoice Amt',0),(215236,5979,'ms','Adj.Invoice Amt',0),(215237,5979,'ar','Adj.Invoice Amt',0),(215238,5979,'fr','Adj.Invoice Amt',0),(215239,5979,'jp','è«‹æ±‚æ›¸é¡?èª¿æ•´',0),(215240,5979,'pt','Adj.Invoice Amt',0),(215241,5979,'ru','Adj.Invoice Amt',0),(215242,5979,'es','Factura Ajustada $',0),(215243,5979,'de','Adj.Invoice Amt',0),(215244,5979,'en','Adj.Invoice Amt',0),(215245,5980,'is','',0),(215246,5980,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(215247,5980,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(215248,5980,'tr','Mevduat',0),(215249,5980,'pl','Depozyty',0),(215250,5980,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(215251,5980,'ur','Ø°Ø®Ø§Ø¦Ø±',0),(215252,5980,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ðµ',0),(215253,5980,'vi','Äáº·t cá»c',0),(215254,5980,'af','Deposito\'s',0),(215255,5980,'ro','Depozite',0),(215256,5980,'et','Hoiused',0),(215257,5980,'si','Depoziti',0),(215258,5980,'ba','Deposito',0),(215259,5980,'nl','Deposito \'s',0),(215260,5980,'fi','Talletukset',0),(215261,5980,'no','Innskudd',0),(215262,5980,'da','Indskud',0),(215263,5980,'ko','ì˜ˆê¸ˆ',0),(215264,5980,'he','×¤×™×§×“×•× ×•×ª',0),(215265,5980,'el','ÎšÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚',0),(215266,5980,'zh','å­˜æ¬¾\r\n',0),(215267,5980,'sv','InsÃ¤ttningar',0),(215268,5980,'it','Depositi',0),(215269,5980,'tl','',0),(215270,5980,'th','&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;',0),(215271,5980,'hi','à¤œà¤®à¤¾',0),(215272,5980,'ms','Deposit',0),(215273,5980,'ar','Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ù„Ø£Ø¬Ù„',0),(215274,5980,'fr','DÃ©pÃ´ts',0),(215275,5980,'jp','é ?ã?‹ã‚Šé‡‘',0),(215276,5980,'pt','DepÃ³sitos',0),(215277,5980,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹',0),(215278,5980,'es','DepÃ³sitos',0),(215279,5980,'de','Einlagen',0),(215280,5980,'en','Deposits',0),(215281,5981,'is','',0),(215282,5981,'dr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡',0),(215283,5981,'pr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡',0),(215284,5981,'tr','Fulfillment SipariÅŸler yalnÄ±zca',0),(215285,5981,'pl','Realizacja zamÃ³wienia wyÅ‚Ä…cznie',0),(215286,5981,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸ÐµÑ‚Ð¾ ÑÐ°Ð¼Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(215287,5981,'ur','ØµØ±Ù ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(215288,5981,'sr','Ð¡Ð°Ð¼Ð¾ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(215289,5981,'vi','Chá»‰ ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(215290,5981,'af','Uitvoeringsbestelling Alleenlik',0),(215291,5981,'ro','ÃŽmplinirea comenzi numai',0),(215292,5981,'et','Ainult kaubatellimused',0),(215293,5981,'si','Izpolnitev naroÄila samo',0),(215294,5981,'ba','Hanya Pemenuhan Pesanan',0),(215295,5981,'nl','Vervulling bestellingen',0),(215296,5981,'fi','TÃ¤yttÃ¤minen tilauksia vain',0),(215297,5981,'no','FullfÃ¸ringen bestillinger bare',0),(215298,5981,'da','Opfyldelse ordrer kun',0),(215299,5981,'ko','í–‰ ì£¼ë¬¸ì—ë§Œ í•´ë‹¹',0),(215300,5981,'he','×ž×™×ž×•×© ×”×–×ž× ×•×ª ×‘×œ×‘×“',0),(215301,5981,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Î¼ÏŒÎ½Î¿',0),(215302,5981,'zh','åªå±¥è¡Œè®¢å•\r\n',0),(215303,5981,'sv','Uppfyllelse order endast',0),(215304,5981,'it','Evasione ordini solo',0),(215305,5981,'tl','',0),(215306,5981,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(215307,5981,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡à¤µà¤²',0),(215308,5981,'ms','Memenuhi arahan sahaja',0),(215309,5981,'ar','Ø·Ù„Ø¨ÙŠØ§Øª ÙÙ‚Ø·',0),(215310,5981,'fr','Commandes produits seulement',0),(215311,5981,'jp','å‡¦ç?†æ¸ˆæ³¨æ–‡ã?®ã?¿',0),(215312,5981,'pt','Cumprimento de ordens sÃ³',0),(215313,5981,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(215314,5981,'es','Ordenes de Cumplimiento Solamente',0),(215315,5981,'de','ErfÃ¼llung Bestellungen nur',0),(215316,5981,'en','Fulfillment Orders Only',0),(215317,5982,'is','',0),(215318,5982,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ø´Ø¯ ',0),(215319,5982,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ø´Ø¯ ',0),(215320,5982,'tr','Fatura iÅŸÃ§ilik',0),(215321,5982,'pl','Pracy zapowiadane',0),(215322,5982,'bg','Ð¢Ñ€ÑƒÐ´Ð° Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸',0),(215323,5982,'ur','Ù„ÛŒØ¨Ø± Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(215324,5982,'sr','Ð Ð°Ð´Ð° Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(215325,5982,'vi','NhÃ¢n CÃ´ng ÄÃ£ TÃ­nh',0),(215326,5982,'af','Arbeid weerspieÃ«l',0),(215327,5982,'ro','Muncii facturat',0),(215328,5982,'et','TÃ¶Ã¶jÃµudu maksustatakse',0),(215329,5982,'si','Dela, ki se zaraÄunavajo',0),(215330,5982,'ba','Tenaga kerja yang ditagih',0),(215331,5982,'nl','Arbeid gefactureerd',0),(215332,5982,'fi','TyÃ¶ laskutetaan',0),(215333,5982,'no','Arbeidskraft fakturert',0),(215334,5982,'da','Labor Billed',0),(215335,5982,'ko','ë…¸ë™ ì²­êµ¬',0),(215336,5982,'he','×”×¢×‘×•×“×” ×ž×—×•×™×‘',0),(215337,5982,'el','Î•ÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³ÎµÎ¯Ï„Î±Î¹',0),(215338,5982,'zh','åŠ³åŠ¨å¸å•\r\n',0),(215339,5982,'sv','Labor faktureras',0),(215340,5982,'it','Labor fatturati',0),(215341,5982,'tl','',0),(215342,5982,'th','&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3588;&#3656;&#3634;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(215343,5982,'hi','à¤¬à¤¿à¤² à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¶à¥à¤°à¤®',0),(215344,5982,'ms','Buruh yang dibilkan',0),(215345,5982,'ar','Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ù„ ÙÙˆØ§ØªÙŠØ±',0),(215346,5982,'fr','Travail facturÃ©',0),(215347,5982,'jp','è«‹æ±‚äººä»¶è²»',0),(215348,5982,'pt','Trabalho de bico',0),(215349,5982,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ñ‚Ñ€ÑƒÐ´Ð°',0),(215350,5982,'es','Labor Facturado',0),(215351,5982,'de','Arbeit in Rechnung gestellt',0),(215352,5982,'en','Labor Billed',0),(215353,5983,'is','',0),(215354,5983,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(215355,5983,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(215356,5983,'tr','IÅŸgÃ¼cÃ¼ maliyeti',0),(215357,5983,'pl','Koszty pracy',0),(215358,5983,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ñ‚Ñ€ÑƒÐ´',0),(215359,5983,'ur','Ù…Ø²Ø¯ÙˆØ± Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(215360,5983,'sr','Ð Ð°Ð´ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(215361,5983,'vi','Chi PhÃ­ nhÃ¢n cÃ´ng',0),(215362,5983,'af','Arbeid Koste',0),(215363,5983,'ro','Costul forÅ£ei de muncÄƒ',0),(215364,5983,'et','TÃ¶Ã¶jÃµu kulud',0),(215365,5983,'si','StroÅ¡ek dela',0),(215366,5983,'ba','Biaya tenaga kerja',0),(215367,5983,'nl','Arbeid kosten',0),(215368,5983,'fi','TyÃ¶kustannus',0),(215369,5983,'no','Ap. kostnader',0),(215370,5983,'da','Labor omkostninger',0),(215371,5983,'ko','ë…¸ë™ ë¹„ìš©',0),(215372,5983,'he','×¢×œ×•×ª ×”×¢×‘×•×“×”',0),(215373,5983,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(215374,5983,'zh','åŠ³åŠ¨åŠ›æˆæœ¬\r\n',0),(215375,5983,'sv','Arbets kostnaden',0),(215376,5983,'it','Costo manodopera',0),(215377,5983,'tl','',0),(215378,5983,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3588;&#3656;&#3634;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(215379,5983,'hi','à¤¶à¥à¤°à¤® à¤²à¤¾à¤—à¤¤',0),(215380,5983,'ms','Kos buruh',0),(215381,5983,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ø¹Ù…Ø§Ù„Ø©',0),(215382,5983,'fr','CoÃ»t du travail',0),(215383,5983,'jp','äººä»¶è²»',0),(215384,5983,'pt','Custo do trabalho',0),(215385,5983,'ru','Ð¢Ñ€ÑƒÐ´Ð¾Ð²Ñ‹Ðµ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹',0),(215386,5983,'es','Costo de Labor',0),(215387,5983,'de','Labor Kosten',0),(215388,5983,'en','Labor Cost',0),(215389,5984,'is','',0),(215390,5984,'dr','Ø³ÙˆØ¯ Ø®Ø§Ù„Øµ',0),(215391,5984,'pr','Ø³ÙˆØ¯ Ø®Ø§Ù„Øµ',0),(215392,5984,'tr','Net kar',0),(215393,5984,'pl','Zysk netto',0),(215394,5984,'bg','ÐÐµÑ‚Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(215395,5984,'ur','Ù…Ù†Ø§ÙØ¹',0),(215396,5984,'sr','ÐÐµÑ‚Ð¾ ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚',0),(215397,5984,'vi','Lá»£i nhuáº­n thuáº§n',0),(215398,5984,'af','Netto Wins',0),(215399,5984,'ro','Net Profit',0),(215400,5984,'et','Puhaskasum',0),(215401,5984,'si','ÄŒisti dobiÄek',0),(215402,5984,'ba','Laba bersih',0),(215403,5984,'nl','Nettowinst',0),(215404,5984,'fi','Tilikauden voitto',0),(215405,5984,'no','Netto overskudd',0),(215406,5984,'da','Nettoresultat',0),(215407,5984,'ko','ë‹¹ê¸° ìˆœì´ìµ',0),(215408,5984,'he','×”×¨×•×•×— ×”× ×§×™',0),(215409,5984,'el','ÎšÎ±Î¸Î±ÏÎ¬ ÎºÎ­ÏÎ´Î·',0),(215410,5984,'zh','çº¯åˆ©\r\n',0),(215411,5984,'sv','Periodens resultat',0),(215412,5984,'it','Utile netto',0),(215413,5984,'tl','',0),(215414,5984,'th','&#3585;&#3635;&#3652;&#3619;&#3626;&#3640;&#3607;&#3608;&#3636;',0),(215415,5984,'hi','à¤¶à¥à¤¦à¥à¤§ à¤²à¤¾à¤­',0),(215416,5984,'ms','Keuntungan bersih',0),(215417,5984,'ar','Ø§Ù„Ø±Ø¨Ø­ Ø§Ù„ØµØ§ÙÙŠ',0),(215418,5984,'fr','BÃ©nÃ©fice net',0),(215419,5984,'jp','ç´”åˆ©ç›Š',0),(215420,5984,'pt','Lucro lÃ­quido',0),(215421,5984,'ru','Ð§Ð¸ÑÑ‚Ð°Ñ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ',0),(215422,5984,'es','Utilidad Neta',0),(215423,5984,'de','Reingewinn',0),(215424,5984,'en','Net Profit',0),(215425,5985,'is','',0),(215426,5985,'dr','ÙÙ‚Ø·',0),(215427,5985,'pr','ÙÙ‚Ø·',0),(215428,5985,'tr','Sadece',0),(215429,5985,'pl','Tylko',0),(215430,5985,'bg','Ð¡Ð°Ð¼Ð¾',0),(215431,5985,'ur','ØµØ±Ù',0),(215432,5985,'sr','Ð¡Ð°Ð¼Ð¾',0),(215433,5985,'vi','Chá»‰',0),(215434,5985,'af','Slegs',0),(215435,5985,'ro','Numai',0),(215436,5985,'et','Ainult',0),(215437,5985,'si','Samo',0),(215438,5985,'ba','Hanya',0),(215439,5985,'nl','Alleen',0),(215440,5985,'fi','Vain',0),(215441,5985,'no','Bare',0),(215442,5985,'da','Kun',0),(215443,5985,'ko','ë§Œ',0),(215444,5985,'he','×¨×§',0),(215445,5985,'el','ÎœÏŒÎ½Î¿',0),(215446,5985,'zh','åªæœ‰\r\n',0),(215447,5985,'sv','Endast',0),(215448,5985,'it','Solo',0),(215449,5985,'tl','',0),(215450,5985,'th','&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(215451,5985,'hi','à¤•à¥‡à¤µà¤²',0),(215452,5985,'ms','Hanya',0),(215453,5985,'ar','ÙÙ‚Ø·',0),(215454,5985,'fr','Seulement',0),(215455,5985,'jp','ï½žã?®ã?¿',0),(215456,5985,'pt','SÃ³',0),(215457,5985,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾',0),(215458,5985,'es','Solo',0),(215459,5985,'de','Nur',0),(215460,5985,'en','Only',0),(215461,5986,'is','',0),(215462,5986,'dr','Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯ÙŠÚ¯Ø±',0),(215463,5986,'pr','Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯ÙŠÚ¯Ø±',0),(215464,5986,'tr','DiÄŸer fatura',0),(215465,5986,'pl','Inne zapowiadane',0),(215466,5986,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸',0),(215467,5986,'ur','Ø¯ÙˆØ³Ø±Û’ Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(215468,5986,'sr','Ð”Ñ€ÑƒÐ³Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(215469,5986,'vi','ÄÆ¡n HÃ ng Ä‘Ã£ ra hÃ³a Ä‘Æ¡n ',0),(215470,5986,'af','Ander weerspieÃ«l',0),(215471,5986,'ro','Alte facturat',0),(215472,5986,'et','Muud arved',0),(215473,5986,'si','Drugi zaraÄunavajo',0),(215474,5986,'ba','Lain ditagih',0),(215475,5986,'nl','Andere gefactureerd',0),(215476,5986,'fi','Muut laskutetaan',0),(215477,5986,'no','Andre fakturert',0),(215478,5986,'da','Andre faktureret',0),(215479,5986,'ko','ë‹¤ë¥¸ ì²­êµ¬',0),(215480,5986,'he','×”×©× ×™ ×”×—×™×•×‘',0),(215481,5986,'el','Î†Î»Î»Î¿ Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹',0),(215482,5986,'zh','å…¶ä»–å…¥è´¦\r\n',0),(215483,5986,'sv','Andra faktureras',0),(215484,5986,'it','Altro fatturati',0),(215485,5986,'tl','',0),(215486,5986,'th','&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(215487,5986,'hi','à¤…à¤¨à¥à¤¯ à¤¬à¤¿à¤²',0),(215488,5986,'ms','Lain-lain yang dibilkan',0),(215489,5986,'ar','Ø¢Ø®Ø± ÙØ§ØªÙˆØ±Ø©',0),(215490,5986,'fr','Autre facturÃ©s',0),(215491,5986,'jp','ã??ã?®ä»–è«‹æ±‚æ¸ˆ',0),(215492,5986,'pt','Outro de bico',0),(215493,5986,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(215494,5986,'es','Otro Facturado',0),(215495,5986,'de','Anderen in Rechnung gestellt',0),(215496,5986,'en','Other Billed',0),(215497,5987,'is','',0),(215498,5987,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙŠÚ¯Ø±',0),(215499,5987,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙŠÚ¯Ø±',0),(215500,5987,'tr','DiÄŸer maliyet',0),(215501,5987,'pl','Inne koszty',0),(215502,5987,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(215503,5987,'ur','Ø¯ÛŒÚ¯Ø± Ù‚ÛŒÙ…Øª',0),(215504,5987,'sr','ÐžÑÑ‚Ð°Ð»Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(215505,5987,'vi','Chi phÃ­ khÃ¡c',0),(215506,5987,'af','Ander Koste',0),(215507,5987,'ro','Alte costuri',0),(215508,5987,'et','Muud kulud',0),(215509,5987,'si','Drugih stroÅ¡kov',0),(215510,5987,'ba','Biaya lainnya',0),(215511,5987,'nl','Andere kosten',0),(215512,5987,'fi','Muut kustannukset',0),(215513,5987,'no','Andre kostnader',0),(215514,5987,'da','Andre omkostninger',0),(215515,5987,'ko','ë‹¤ë¥¸ ë¹„ìš©',0),(215516,5987,'he','×¢×œ×•×ª ××—×¨×™×',0),(215517,5987,'el','Î›Î¿Î¹Ï€Î­Ï‚ Î´Î±Ï€Î¬Î½ÎµÏ‚',0),(215518,5987,'zh','å…¶ä»–è´¹ç”¨\r\n',0),(215519,5987,'sv','Ã–vriga kostnader',0),(215520,5987,'it','Altri costi',0),(215521,5987,'tl','',0),(215522,5987,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(215523,5987,'hi','à¤…à¤¨à¥à¤¯ à¤²à¤¾à¤—à¤¤',0),(215524,5987,'ms','Lain-lain kos',0),(215525,5987,'ar','Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø£Ø®Ø±Ù‰',0),(215526,5987,'fr','Autres coÃ»ts',0),(215527,5987,'jp','ã??ã?®ä»–è²»ç”¨',0),(215528,5987,'pt','Outros custos',0),(215529,5987,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(215530,5987,'es','Otro Costo',0),(215531,5987,'de','Andere Kosten',0),(215532,5987,'en','Other Cost',0),(215533,5988,'is','',0),(215534,5988,'dr','(Ø±Ø³ÙŠØ¯Ù‡Ø§) Ø¨Ø¯ÙˆÙ† Ø¨ÛŒØ¬Ú©Ù‡Ø§',0),(215535,5988,'pr','Ø¯Ø±ÙŠØ§ÙØªÙ‡Ø§(Ø±Ø³ÙŠØ¯Ù‡Ø§) Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(215536,5988,'tr','AlÄ±ÅŸ irsaliyeleri faturalara olmadan',0),(215537,5988,'pl','Przychody bez faktur',0),(215538,5988,'bg','ÐŸÑ€Ð¸Ñ…Ð¾Ð´Ð¸ Ð±ÐµÐ· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(215539,5988,'ur','Ø±Ø³ÛŒØ¯ÛŒÚº ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ø¨ØºÛŒØ±',0),(215540,5988,'sr','ÐŸÑ€Ð¸Ð·Ð½Ð°Ð½Ð¸Ñ†Ðµ Ð±ÐµÐ· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(215541,5988,'vi','BiÃªn nháº­n khÃ´ng hÃ³a Ä‘Æ¡n',0),(215542,5988,'af','Kwitansie sonder Fakture',0),(215543,5988,'ro','ÃŽncasÄƒri fÄƒrÄƒ facturi',0),(215544,5988,'et','Ilma arvete laekumiste',0),(215545,5988,'si','Potrdila brez raÄunov',0),(215546,5988,'ba','Penerimaan tanpa faktur',0),(215547,5988,'nl','Ontvangsten zonder facturen',0),(215548,5988,'fi','Kuitit laskut ilman',0),(215549,5988,'no','Mottak uten fakturaer',0),(215550,5988,'da','IndtÃ¦gter uden fakturaer',0),(215551,5988,'ko','ì²­êµ¬ì„œ ì—†ì´ ì˜ìˆ˜ì¦',0),(215552,5988,'he','×§×‘×œ×•×ª ×—×©×‘×•× ×™×•×ª ×‘×œ×™',0),(215553,5988,'el','Î‘Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ Ï‡Ï‰ÏÎ¯Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(215554,5988,'zh','æ²¡æœ‰å‘ç¥¨æ”¶æ®\r\n',0),(215555,5988,'sv','Inleveranser utan fakturor',0),(215556,5988,'it','Entrate senza fatture',0),(215557,5988,'tl','',0),(215558,5988,'th','&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(215559,5988,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚',0),(215560,5988,'ms','Resit tanpa invois',0),(215561,5988,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ø¯ÙˆÙ† ÙÙˆØ§ØªÙŠØ±',0),(215562,5988,'fr','Recettes sans factures',0),(215563,5988,'jp','è«‹æ±‚æ›¸ã?®ã?ªã?„é ˜å?Žæ›¸',0),(215564,5988,'pt','Recibos sem facturas',0),(215565,5988,'ru','ÐšÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð±ÐµÐ· ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(215566,5988,'es','Recibos sin Facturas',0),(215567,5988,'de','Einnahmen ohne Rechnungen',0),(215568,5988,'en','Receipts without Invoices',0),(215569,5989,'is','',0),(215570,5989,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙˆØ¯Ø¯Ù‡ÙŠ',0),(215571,5989,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙˆØ¯Ø¯Ù‡ÙŠ',0),(215572,5989,'tr','KarlÄ±lÄ±k raporu',0),(215573,5989,'pl','Raport rentownoÅ›Ä‡',0),(215574,5989,'bg','Ð ÐµÐ½Ñ‚Ð°Ð±Ð¸Ð»Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð´Ð¾ÐºÐ»Ð°Ð´',0),(215575,5989,'ur','Ù…Ù†Ø§ÙØ¹ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(215576,5989,'sr','ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚Ð°Ð±Ð¸Ð»Ð½Ð¾ÑÑ‚ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(215577,5989,'vi','BÃ¡o cÃ¡o lá»£i nhuáº­n',0),(215578,5989,'af','Winsgewendheidsverslag',0),(215579,5989,'ro','Raport de rentabilitate',0),(215580,5989,'et','Kasumlikkuse aruanne',0),(215581,5989,'si','Donosnost poroÄilo',0),(215582,5989,'ba','Profitabilitas laporan',0),(215583,5989,'nl','Winstgevendheid verslag',0),(215584,5989,'fi','Kannattavuusraportti',0),(215585,5989,'no','LÃ¸nnsomhet rapport',0),(215586,5989,'da','Rentabiliteten rapport',0),(215587,5989,'ko','ìˆ˜ìµì„± ë³´ê³ ì„œ',0),(215588,5989,'he','×‘×“×•×— ×”×¨×•×•×—×™×•×ª',0),(215589,5989,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ ÎºÎµÏÎ´Î¿Ï†Î¿ÏÎ¯Î±',0),(215590,5989,'zh','æ”¶ç›Šæ€§æŠ¥å‘Š\r\n',0),(215591,5989,'sv','LÃ¶nsamhet rapport',0),(215592,5989,'it','Relazione di redditivitÃ ',0),(215593,5989,'tl','',0),(215594,5989,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3623;&#3634;&#3617;&#3652;&#3604;&#3657;&#3648;&#3611;&#3619;&#3637;&#3618;&#3610;',0),(215595,5989,'hi','à¤²à¤¾à¤­à¤ªà¥à¤°à¤¦à¤¤à¤¾ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(215596,5989,'ms','Laporan keuntungan',0),(215597,5989,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø±Ø¨Ø­ÙŠØ©',0),(215598,5989,'fr','Rapport de rentabilitÃ©',0),(215599,5989,'jp','è²©å£²å?Žç›Šæ€§ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(215600,5989,'pt','RelatÃ³rio de rentabilidade',0),(215601,5989,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ ÐŸÐ¾ Ð”Ð¾Ñ…Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸',0),(215602,5989,'es','Informe de Rentabilidad',0),(215603,5989,'de','RentabilitÃ¤t-Bericht',0),(215604,5989,'en','Profitability Report',0),(215605,5990,'is','',0),(215606,5990,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡',0),(215607,5990,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡',0),(215608,5990,'tr','Grup SeÃ§',0),(215609,5990,'pl','Wybierz grupy',0),(215610,5990,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð³Ñ€ÑƒÐ¿Ð°',0),(215611,5990,'ur','Ù…Ù†ØªØ®Ø¨ Ú¯Ø±ÙˆÙ¾',0),(215612,5990,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸ Ð³Ñ€ÑƒÐ¿Ñƒ',0),(215613,5990,'vi','Chá»n nhÃ³m',0),(215614,5990,'af','Selekteer Groep',0),(215615,5990,'ro','SelectaÅ£i Grupa',0),(215616,5990,'et','Vali rÃ¼hm',0),(215617,5990,'si','Izberi skupino',0),(215618,5990,'ba','Pilih grup',0),(215619,5990,'nl','Selecteer groep',0),(215620,5990,'fi','Valitse ryhmÃ¤',0),(215621,5990,'no','Velg Group',0),(215622,5990,'da','VÃ¦lg gruppe',0),(215623,5990,'ko','ê·¸ë£¹ ì„ íƒ',0),(215624,5990,'he','×‘×—×¨ ×§×‘×•×¦×”',0),(215625,5990,'el','ÎŸÎ¼Î¬Î´Î± Î¦Ï‰Ï„Î¿Î³ÏÎ±Ï†Î¹ÎºÎ¿Ï Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(215626,5990,'zh','é€‰æ‹©ç»„\r\n',0),(215627,5990,'sv','VÃ¤lj grupp',0),(215628,5990,'it','Seleziona gruppo',0),(215629,5990,'tl','',0),(215630,5990,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(215631,5990,'hi','à¤¸à¤®à¥‚à¤¹ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(215632,5990,'ms','Pilih Kumpulan',0),(215633,5990,'ar','Ø­Ø¯Ø¯ Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(215634,5990,'fr','SÃ©lectionner un groupe',0),(215635,5990,'jp','ã‚°ãƒ«ãƒ¼ãƒ—ã?®é?¸æŠž',0),(215636,5990,'pt','Selecionar grupo',0),(215637,5990,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð“Ñ€ÑƒÐ¿Ð¿Ñƒ',0),(215638,5990,'es','Seleccionar Grupo',0),(215639,5990,'de','Gruppe auswÃ¤hlen',0),(215640,5990,'en','Select Group',0),(215641,5991,'is','',0),(215642,5991,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´',0),(215643,5991,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´',0),(215644,5991,'tr','SatÄ±ÅŸ kategorisini seÃ§in',0),(215645,5991,'pl','Wybierz kategoriÄ™ sprzedaÅ¼y',0),(215646,5991,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ, Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(215647,5991,'ur','Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(215648,5991,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(215649,5991,'vi','Chá»n thá»ƒ loáº¡i bÃ¡n hÃ ng khÃ¡c',0),(215650,5991,'af','Verkope kategorie kies',0),(215651,5991,'ro','SelectaÅ£i categoria vanzari',0),(215652,5991,'et','Valige mÃ¼Ã¼k kategooria',0),(215653,5991,'si','Izberite kategorijo prodaje',0),(215654,5991,'ba','Pilih kategori penjualan',0),(215655,5991,'nl','Selecteer verkoop categorie',0),(215656,5991,'fi','Valitse myynti luokka',0),(215657,5991,'no','Velg salg kategori',0),(215658,5991,'da','VÃ¦lg salgskategori',0),(215659,5991,'ko','íŒë§¤ ì¹´í…Œê³ ë¦¬ ì„ íƒ',0),(215660,5991,'he','×‘×—×¨ ×§×˜×’×•×¨×™×™×ª ×ž×›×™×¨×•×ª',0),(215661,5991,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(215662,5991,'zh','é€‰æ‹©é”€å”®ç±»åˆ«ä»¥\r\n',0),(215663,5991,'sv','VÃ¤lj fÃ¶rsÃ¤ljningskategori',0),(215664,5991,'it','Selezionare la categoria Sales',0),(215665,5991,'tl','',0),(215666,5991,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(215667,5991,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(215668,5991,'ms','Pilih kategori jualan',0),(215669,5991,'ar','Ø¥Ø®ØªÙŠØ§Ø± ØªØµÙ†ÙŠÙ Ù…Ø¨ÙŠØ¹Ø§Øª Ù„Ù„ØªØ­Ø±ÙŠØ±',0),(215670,5991,'fr','SÃ©lectionnez la catÃ©gorie de ventes',0),(215671,5991,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®é?¸æŠž',0),(215672,5991,'pt','Selecione a categoria de vendas',0),(215673,5991,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(215674,5991,'es','Seleccionar CategorÃ­a de Ventas',0),(215675,5991,'de','Verkauf Kategorie auswÃ¤hlen',0),(215676,5991,'en','Select Sales Category',0),(215677,5992,'is','',0),(215678,5992,'dr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(215679,5992,'pr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(215680,5992,'tr','Sadece servis sipariÅŸleri',0),(215681,5992,'pl','Tylko zlecenia serwisowe',0),(215682,5992,'bg','Ð¡Ð°Ð¼Ð¾ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(215683,5992,'ur','Ø³Ø±ÙˆØ³ ØµØ±Ù Ú©Ø§ Ø­Ú©Ù… Ø¯Û’ Ø¯ÛŒØ§',0),(215684,5992,'sr','Ð¡Ð°Ð¼Ð¾ Ð½Ð°Ð»Ð¾Ð·Ð¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(215685,5992,'vi','Chá»‰ Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(215686,5992,'af','Diensbestellings Alleenlik',0),(215687,5992,'ro','Serviciul comenzi numai',0),(215688,5992,'et','Ainult teenusetellimused',0),(215689,5992,'si','Servisni nalogi le',0),(215690,5992,'ba','Layanan pesanan saja',0),(215691,5992,'nl','Alleen serviceorders',0),(215692,5992,'fi','Huoltotilaukset vain',0),(215693,5992,'no','Serviceordrer bare',0),(215694,5992,'da','Serviceordrer kun',0),(215695,5992,'ko','ì„œë¹„ìŠ¤ë§Œ ì£¼ë¬¸',0),(215696,5992,'he','×”×–×ž× ×•×ª ×©×¨×•×ª ×‘×œ×‘×“',0),(215697,5992,'el','Î•Î½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï… Î¼ÏŒÎ½Î¿',0),(215698,5992,'zh','æœåŠ¡è®¢å•åªæœ‰\r\n',0),(215699,5992,'sv','Serviceorder bara',0),(215700,5992,'it','Servizio ordini solo',0),(215701,5992,'tl','',0),(215702,5992,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(215703,5992,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡à¤µà¤²',0),(215704,5992,'ms','Perkhidmatan Pesanan sahaja',0),(215705,5992,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© ÙÙ‚Ø·',0),(215706,5992,'fr','Commandes services seulements',0),(215707,5992,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®ã?¿',0),(215708,5992,'pt','Ordens de serviÃ§o apenas',0),(215709,5992,'ru','Ð¡ÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(215710,5992,'es','Solo Ordenes de Servicio',0),(215711,5992,'de','ServiceauftrÃ¤ge nur',0),(215712,5992,'en','Service Orders Only',0),(215713,5993,'is','',0),(215714,5993,'dr','(Ø¯Ø±Ø¢Ù…Ø¯) Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø² ÙØ±Ù…Ø§ÛŒØ´Ø§Øª  ',0),(215715,5993,'pr','ÙƒÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ(Ø¯Ø±Ø¢Ù…Ø¯) Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª  ',0),(215716,5993,'tr','Toplam Ã¶deme emirleri kimden aldÄ±',0),(215717,5993,'pl','CaÅ‚kowitych pÅ‚atnoÅ›ci otrzymanych od zamÃ³wienia',0),(215718,5993,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(215719,5993,'ur','Ú©Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Ø§ Ø­Ú©Ù… Ø³Û’ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(215720,5993,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¸ÑÐ¿Ð»Ð°Ñ‚Ð° Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾ Ð¾Ð´ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(215721,5993,'vi','Táº¥t cáº£ tiá»n thanh toÃ¡n Ä‘Ã£ nháº­n Ä‘Æ°á»£c tá»« Ä‘Æ¡n hÃ ng nÃ y',0),(215722,5993,'af','Totale Betalings Ontvang vanaf Bestellings',0),(215723,5993,'ro','PlÄƒÅ£ile totale primite de la comenzi',0),(215724,5993,'et','Tellimused saadud maksed',0),(215725,5993,'si','Skupnih plaÄilih, prejetih od naroÄila',0),(215726,5993,'ba','Pembayaran Total yang diterima dari pesanan',0),(215727,5993,'nl','Totale betalingen ontvangen Orders',0),(215728,5993,'fi','Saatujen tilausten maksujen kokonaismÃ¤Ã¤rÃ¤',0),(215729,5993,'no','Totalt betalinger mottatt fra ordrer',0),(215730,5993,'da','Samlede betalinger modtaget fra ordrer',0),(215731,5993,'ko','ëª…ë ¹ì—ì„œ ë°›ì€ ì´ ì§€ë¶ˆ',0),(215732,5993,'he','×¡×” ×› ×ª×©×œ×•×ž×™× ×©×”×ª×§×‘×œ×• ×ž×”×–×ž× ×•×ª',0),(215733,5993,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Ï„Î± Ï€Î¿ÏƒÎ¬ Ï€Î¿Ï… Î­Î»Î±Î²Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(215734,5993,'zh','ä»Žæ”¶åˆ°çš„è®¢å•ä¸­çš„æ€»æ”¯å‡º\r\n',0),(215735,5993,'sv','Totala betalningar frÃ¥n order',0),(215736,5993,'it','Totali pagamenti ricevuti dagli ordini',0),(215737,5993,'tl','',0),(215738,5993,'th','&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3592;&#3634;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(215739,5993,'hi','à¤•à¥à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(215740,5993,'ms','Jumlah bayaran yang diterima daripada perintah',0),(215741,5993,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…ØªÙ„Ù‚Ø§Ø© Ù…Ù† Ø£ÙˆØ§Ù…Ø±',0),(215742,5993,'fr','Paiements totaux reÃ§us de commandes',0),(215743,5993,'jp','æ³¨æ–‡ã?‹ã‚‰ã?®å?—é ˜æ¸ˆå…¨æ”¯æ‰•é¡?',0),(215744,5993,'pt','Totais pagamentos recebidos de ordens',0),(215745,5993,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑƒÐ¼Ð¼Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ñ‚ Ñ€Ð°ÑÐ¿Ð¾Ñ€ÑÐ¶ÐµÐ½Ð¸Ñ',0),(215746,5993,'es','Total Pagos Recibidos de Ordenes',0),(215747,5993,'de','Insgesamt Zahlungen von Bestellungen',0),(215748,5993,'en','Total Payments Received from Orders',0),(215749,5994,'is','',0),(215750,5994,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø³ØªØ§Ù† Ø¬Ø¯ÙŠØ¯ ',0),(215751,5994,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø³ØªØ§Ù† Ø¬Ø¯ÙŠØ¯ ',0),(215752,5994,'tr','Yeni durum eklemek',0),(215753,5994,'pl','Dodawanie nowego PaÅ„stwa',0),(215754,5994,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°',0),(215755,5994,'ur','Ù†Ø¦ÛŒ Ø±ÛŒØ§Ø³Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(215756,5994,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð´Ñ€Ð¶Ð°Ð²Ðµ',0),(215757,5994,'vi','ThÃªm Tá»‰nh/ThÃ nh Phá»‘ Má»›i',0),(215758,5994,'af','Nuwe Staat (Landsgebied) Byvoeg',0),(215759,5994,'ro','Adauga noul stat',0),(215760,5994,'et','Lisa uus maakond',0),(215761,5994,'si','Dodajte novo stanje',0),(215762,5994,'ba','Tambahkan negara baru',0),(215763,5994,'nl','Nieuwe status toevoegen',0),(215764,5994,'fi','LisÃ¤Ã¤ uusi tila',0),(215765,5994,'no','Legg til ny tilstand',0),(215766,5994,'da','TilfÃ¸je nye stat',0),(215767,5994,'ko','ìƒˆ ìƒíƒœ ì¶”ê°€',0),(215768,5994,'he','×”×•×¡×£ ×ž×“×™× ×” ×—×“×©×”',0),(215769,5994,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Î¼Î­Î»Î¿Ï…Ï‚',0),(215770,5994,'zh','å¢žåŠ æ–°çš„çŠ¶æ€\r\n',0),(215771,5994,'sv','LÃ¤gg till ny stat',0),(215772,5994,'it','Aggiungi nuovo stato',0),(215773,5994,'tl','',0),(215774,5994,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3633;&#3600;',0),(215775,5994,'hi','à¤¨à¤ à¤°à¤¾à¤œà¥à¤¯ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(215776,5994,'ms','Tambah negeri yang baru',0),(215777,5994,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆÙ„Ø§ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(215778,5994,'fr','Ajouter le nouvel Ã‰tat',0),(215779,5994,'jp','æ–°ã?Ÿã?«éƒ½é?“åºœçœŒã‚’è¿½åŠ ',0),(215780,5994,'pt','Adicionar novo estado',0),(215781,5994,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ð¾Ðµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(215782,5994,'es','Agregar Nuevo Estado',0),(215783,5994,'de','HinzufÃ¼gen von neuen Staat',0),(215784,5994,'en','Add New State',0),(215785,5995,'is','',0),(215786,5995,'dr','Ø­Ø°Ù Ø§Ø³ØªØ§Ù†',0),(215787,5995,'pr','Ø­Ø°Ù Ø§Ø³ØªØ§Ù†',0),(215788,5995,'tr','Silme durumu',0),(215789,5995,'pl','UsuÅ„ PaÅ„stwa',0);
INSERT INTO `langdef` VALUES (215790,5995,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(215791,5995,'ur','Delete Ø®Ø§Ø±Ø¬Û',0),(215792,5995,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð´Ñ€Ð¶Ð°Ð²Ðµ',0),(215793,5995,'vi','XÃ³a tiá»ƒu bang',0),(215794,5995,'af','Skrap Staat (Landsgebied)',0),(215795,5995,'ro','Åžterge statul',0),(215796,5995,'et','Kustuta maakond',0),(215797,5995,'si','IzbriÅ¡i drÅ¾ava',0),(215798,5995,'ba','Hapus negara',0),(215799,5995,'nl','Frame verwijderen',0),(215800,5995,'fi','Poista tila',0),(215801,5995,'no','Slett tilstand',0),(215802,5995,'da','Slet tilstand',0),(215803,5995,'ko','ìƒíƒœ ì‚­ì œ',0),(215804,5995,'he','×ž×—×™×§×ª ×”×ž×“×™× ×”',0),(215805,5995,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î¼Î­Î»Î¿Ï…Ï‚',0),(215806,5995,'zh','åˆ é™¤å›½å®¶\r\n',0),(215807,5995,'sv','Ta bort lÃ¤ge',0),(215808,5995,'it','Cancella stato',0),(215809,5995,'tl','',0),(215810,5995,'th','&#3621;&#3610;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(215811,5995,'hi','Delete à¤°à¤¾à¤œà¥à¤¯',0),(215812,5995,'ms','Hapus Negeri',0),(215813,5995,'ar','Ø­Ø°Ù Ø§Ù„ÙˆÙ„Ø§ÙŠØ©',0),(215814,5995,'fr','Ã‰tat de la suppression',0),(215815,5995,'jp','éƒ½é?“åºœçœŒã‚’æ¶ˆåŽ»',0),(215816,5995,'pt','Estado de exclusÃ£o',0),(215817,5995,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(215818,5995,'es','Eliminar Estado',0),(215819,5995,'de','Zustand DELETE',0),(215820,5995,'en','Delete State',0),(215821,5996,'is','',0),(215822,5996,'dr','( ÙˆÙ„Ø§ÛŒØª ',0),(215823,5996,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙˆØ¶Ø¹ÙŠØª ( Ø§Ø³ØªØ§Ù†',0),(215824,5996,'tr','DÃ¼zenleme durumu',0),(215825,5996,'pl','Stan edycji',0),(215826,5996,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(215827,5996,'ur','ØªØ¯ÙˆÛŒÙ† Ø±ÛŒØ§Ø³Øª',0),(215828,5996,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð´Ñ€Ð¶Ð°Ð²Ð½Ðµ',0),(215829,5996,'vi','Sá»­a Tá»‰nh/ThÃ nh Phá»‘',0),(215830,5996,'af','Redigeer Staat (Landsgebied)',0),(215831,5996,'ro','Stare de editare',0),(215832,5996,'et','Muuda maakonda',0),(215833,5996,'si','Uredi stanje',0),(215834,5996,'ba','Edit negara',0),(215835,5996,'nl','Bewerken staat',0),(215836,5996,'fi','Muokkaa valtion',0),(215837,5996,'no','Rediger staten',0),(215838,5996,'da','Rediger stat',0),(215839,5996,'ko','íŽ¸ì§‘ ìƒíƒœ',0),(215840,5996,'he','×¢×¨×•×š ×ž×“×™× ×”',0),(215841,5996,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼Î­Î»Î¿Ï‚',0),(215842,5996,'zh','ç¼–è¾‘çŠ¶æ€\r\n',0),(215843,5996,'sv','Redigera staten',0),(215844,5996,'it','Modifica stato',0),(215845,5996,'tl','',0),(215846,5996,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(215847,5996,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤°à¤¾à¤œà¥à¤¯',0),(215848,5996,'ms','Edit Negeri',0),(215849,5996,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(215850,5996,'fr','Ã‰tat de modification',0),(215851,5996,'jp','éƒ½é?“åºœçœŒã‚’ä¿?å­˜ç·¨é›†',0),(215852,5996,'pt','Estado de ediÃ§Ã£o',0),(215853,5996,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(215854,5996,'es','Editar Estado',0),(215855,5996,'de','Bearbeitungszustand',0),(215856,5996,'en','Edit State',0),(215857,5997,'is','',0),(215858,5997,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø§Ø³ØªØ§Ù†',0),(215859,5997,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø§Ø³ØªØ§Ù†',0),(215860,5997,'tr','Durumu kaydetme',0),(215861,5997,'pl','Zapisywania stanu',0),(215862,5997,'bg','Ð¡Ð¿Ð°ÑÑÐ²Ð°Ð¼ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(215863,5997,'ur','Ø±ÛŒØ§Ø³Øª Ø¨Ú†Ø§Ù†Û’',0),(215864,5997,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð´Ñ€Ð¶Ð°Ð²Ð½Ðµ',0),(215865,5997,'vi','Sao lÆ°u tiá»ƒu bang',0),(215866,5997,'af','Stoor Staat (Landsgebied)',0),(215867,5997,'ro','Salva stat',0),(215868,5997,'et','Salvesta riigi',0),(215869,5997,'si','Shranite drÅ¾ava',0),(215870,5997,'ba','Simpan negara',0),(215871,5997,'nl','Opslaan van staat',0),(215872,5997,'fi','Paitsi juhla-',0),(215873,5997,'no','Lagre tilstand',0),(215874,5997,'da','Spar stat',0),(215875,5997,'ko','ìƒíƒœ ì €ìž¥',0),(215876,5997,'he','×œ×”×¦×™×œ ××ª ×”×ž×“×™× ×”',0),(215877,5997,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(215878,5997,'zh','ä¿å­˜çŠ¶æ€\r\n',0),(215879,5997,'sv','RÃ¤dda staten',0),(215880,5997,'it','Salvare lo stato',0),(215881,5997,'tl','',0),(215882,5997,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3626;&#3606;&#3634;&#3609;&#3632;',0),(215883,5997,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤•à¥‹ à¤¬à¤šà¤¾à¤¨à¥‡',0),(215884,5997,'ms','Simpan Negeri',0),(215885,5997,'ar','Ø¥Ù†Ù‚Ø§Ø° Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(215886,5997,'fr','Enregistrer l\'Ã‰tat',0),(215887,5997,'jp','éƒ½é?“åºœçœŒã‚’ä¿?å­˜',0),(215888,5997,'pt','Salvar o estado',0),(215889,5997,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ñ',0),(215890,5997,'es','Guardar Estado',0),(215891,5997,'de','Speichern des Zustands',0),(215892,5997,'en','Save State',0),(215893,5998,'is','',0),(215894,5998,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø§Ø³ØªØ§Ù† Ø¯ÙŠÚ¯Ø± ',0),(215895,5998,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø§Ø³ØªØ§Ù† Ø¯ÙŠÚ¯Ø± ',0),(215896,5998,'tr','BaÅŸka bir il seÃ§in',0),(215897,5998,'pl','Wybierz innego PaÅ„stwa',0),(215898,5998,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ñ€ÑƒÐ³Ð° Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°',0),(215899,5998,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± Ø±ÛŒØ§Ø³Øª Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(215900,5998,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¸ ÑÑ‚Ð°ÑšÐµ',0),(215901,5998,'vi','Lá»±a chá»n tiá»ƒu bang khÃ¡c',0),(215902,5998,'af','Kies \'n ander Staat (Landsgebied)',0),(215903,5998,'ro','SelectaÅ£i alt stat',0),(215904,5998,'et','Valige teine riik',0),(215905,5998,'si','Izberite drugo Älanico',0),(215906,5998,'ba','Pilih negara bagian lain',0),(215907,5998,'nl','Selecteer een andere staat',0),(215908,5998,'fi','Valita toisen osavaltion',0),(215909,5998,'no','Velge en annen delstat',0),(215910,5998,'da','VÃ¦lg en anden stat',0),(215911,5998,'ko','ë‹¤ë¥¸ êµ­ê°€ ì„ íƒ',0),(215912,5998,'he','×‘×—×¨ ×¢×•×“ ×ž×“×™× ×”',0),(215913,5998,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¬Î»Î»Î¿ Î¼Î­Î»Î¿Ï‚',0),(215914,5998,'zh','é€‰æ‹©å¦ä¸€ä¸ªå·ž\r\n',0),(215915,5998,'sv','VÃ¤lja en annan stat',0),(215916,5998,'it','Selezionare un altro stato',0),(215917,5998,'tl','',0),(215918,5998,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3616;&#3634;&#3614;&#3629;&#3639;&#3656;&#3609;',0),(215919,5998,'hi','à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤°à¤¾à¤œà¥à¤¯ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(215920,5998,'ms','Pilih negeri lain',0),(215921,5998,'ar','Ø§Ø®ØªØ± ÙˆÙ„Ø§ÙŠØ© Ø£Ø®Ø±Ù‰',0),(215922,5998,'fr','SÃ©lectionnez un autre Ã‰tat',0),(215923,5998,'jp','ä»–ã?®éƒ½é?“åºœçœŒã‚’é?¸ã‚“ã?§ã??ã? ã?•ã?„',0),(215924,5998,'pt','Selecione outro Estado',0),(215925,5998,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ ÑˆÑ‚Ð°Ñ‚',0),(215926,5998,'es','Seleccionar otro estado',0),(215927,5998,'de','WÃ¤hlen Sie einen anderen Status',0),(215928,5998,'en','Select another state',0),(215929,5999,'is','',0),(215930,5999,'dr','Ø§Ø³ØªØ§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù  Ø´Ø¯ ',0),(215931,5999,'pr','Ø§Ø³ØªØ§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù  Ø´Ø¯ ',0),(215932,5999,'tr','Devlet baÅŸarÄ±yla silindi',0),(215933,5999,'pl','PaÅ„stwo usuniÄ™te pomyÅ›lnie',0),(215934,5999,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²Ð°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(215935,5999,'ur','Ø±ÛŒØ§Ø³Øª Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(215936,5999,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(215937,5999,'vi','XÃ³a tiá»ƒu bang thÃ nh cÃ´ng',0),(215938,5999,'af','Staat (Landsgebied) suksesvol geskrap',0),(215939,5999,'ro','Stat eliminÄƒ cu succes',0),(215940,5999,'et','Riigi edukalt kustutatud',0),(215941,5999,'si','DrÅ¾ava uspeÅ¡no izbrisana',0),(215942,5999,'ba','Negara yang berhasil dihapus',0),(215943,5999,'nl','Staat met succes verwijderd',0),(215944,5999,'fi','Valtion poistettu',0),(215945,5999,'no','Staten slettet',0),(215946,5999,'da','Staten slettet',0),(215947,5999,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ëœ ìƒíƒœ',0),(215948,5999,'he','×”×ž×“×™× ×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(215949,5999,'el','ÎœÎ­Î»Î¿Ï…Ï‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(215950,5999,'zh','å›½å®¶å·²æˆåŠŸåˆ é™¤\r\n',0),(215951,5999,'sv','Staten raderades',0),(215952,5999,'it','Stato eliminato con successo',0),(215953,5999,'tl','',0),(215954,5999,'th','&#3621;&#3610;&#3626;&#3616;&#3634;&#3614;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(215955,5999,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤°à¤¾à¤œà¥à¤¯',0),(215956,5999,'ms','Negeri yang dihapuskan dengan jayanya',0),(215957,5999,'ar','Ø­Ø°ÙØª Ø§Ù„ÙˆÙ„Ø§ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(215958,5999,'fr','Ã‰tat supprimÃ© avec succÃ¨s',0),(215959,5999,'jp','éƒ½é?“åºœçœŒã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(215960,5999,'pt','Estado apagado com sucesso',0),(215961,5999,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(215962,5999,'es','Estado eliminado exitosamente',0),(215963,5999,'de','Staat erfolgreich gelÃ¶scht',0),(215964,5999,'en','State deleted successfully',0),(215965,6000,'is','',0),(215966,6000,'dr','Ø§Ø³ØªØ§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(215967,6000,'pr','Ø§Ø³ØªØ§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(215968,6000,'tr','Devlet baÅŸarÄ±yla kaydedildi',0),(215969,6000,'pl','Stan zapisane',0),(215970,6000,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²Ð°Ñ‚Ð°, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(215971,6000,'ur','Ø±ÛŒØ§Ø³Øª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(215972,6000,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(215973,6000,'vi','Sao lÆ°u tiá»ƒu bang thÃ nh cÃ´ng',0),(215974,6000,'af','Staat/Provinsie Suksesvol Gestoor',0),(215975,6000,'ro','Stat salvat cu succes',0),(215976,6000,'et','Maakond salvestati edukalt',0),(215977,6000,'si','DrÅ¾ava uspeÅ¡no shranjen',0),(215978,6000,'ba','Negara yang berhasil diselamatkan',0),(215979,6000,'nl','Staat succesvol opgeslagen',0),(215980,6000,'fi','Valtion tallennettu',0),(215981,6000,'no','Staten lagret',0),(215982,6000,'da','Staten gemt med succes',0),(215983,6000,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ ëœ ìƒíƒœ',0),(215984,6000,'he','×”×ž×“×™× ×” × ×©×ž×¨ ×‘×”×¦×œ×—×”',0),(215985,6000,'el','ÎšÏÎ¬Ï„Î¿Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(215986,6000,'zh','å›½å®¶ä¿å­˜æˆåŠŸ\r\n',0),(215987,6000,'sv','Staten sparats',0),(215988,6000,'it','Stato salvato con successo',0),(215989,6000,'tl','',0),(215990,6000,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3626;&#3616;&#3634;&#3614;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(215991,6000,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(215992,6000,'ms','Negeri yang berjaya disimpan',0),(215993,6000,'ar','Ø­ÙØ¸Øª Ø§Ù„ÙˆÙ„Ø§ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(215994,6000,'fr','Ã‰tat enregistrÃ© avec succÃ¨s',0),(215995,6000,'jp','éƒ½é?“åºœçœŒã?Œä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(215996,6000,'pt','Estado salvo com sucesso',0),(215997,6000,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð¾, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(215998,6000,'es','Estado guardado exitosamente',0),(215999,6000,'de','Staat erfolgreich gespeichert',0),(216000,6000,'en','State saved successfully',0),(216001,6001,'is','',0),(216002,6001,'dr','Ø§Ø³ØªØ§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(216003,6001,'pr','Ø§Ø³ØªØ§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(216004,6001,'tr','Devlet baÅŸarÄ±yla eklendi',0),(216005,6001,'pl','Stan dodany pomyÅ›lnie',0),(216006,6001,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(216007,6001,'ur','Ø±ÛŒØ§Ø³Øª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(216008,6001,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(216009,6001,'vi','ThÃªm tiá»ƒu bang thÃ nh cÃ´ng',0),(216010,6001,'af','Staat (Landsgebied) suksesvol bygevoeg',0),(216011,6001,'ro','Stat adÄƒugat cu succes',0),(216012,6001,'et','Lisatud riigi',0),(216013,6001,'si','DrÅ¾ava uspeÅ¡no dodani',0),(216014,6001,'ba','Negara yang ditambahkan berhasil',0),(216015,6001,'nl','Staat toegevoegd',0),(216016,6001,'fi','Valtion lisÃ¤Ã¤minen onnistui',0),(216017,6001,'no','Staten lagt',0),(216018,6001,'da','Staten tilfÃ¸jet',0),(216019,6001,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ìƒíƒœ',0),(216020,6001,'he','×ž×¦×‘ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(216021,6001,'el','ÎœÎ­Î»Î¿Ï‚ Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(216022,6001,'zh','å›½å·žæ·»åŠ æˆåŠŸ\r\n',0),(216023,6001,'sv','Staten lagts',0),(216024,6001,'it','Stato aggiunto con successo',0),(216025,6001,'tl','',0),(216026,6001,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(216027,6001,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(216028,6001,'ms','Negeri yang berjaya menambah',0),(216029,6001,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„ÙˆÙ„Ø§ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(216030,6001,'fr','Ã‰tat ajoutÃ© avec succÃ¨s',0),(216031,6001,'jp','éƒ½é?“åºœçœŒã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(216032,6001,'pt','Estado adicionado com sucesso',0),(216033,6001,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð¾, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(216034,6001,'es','Estado agregado exitosamente',0),(216035,6001,'de','Staat erfolgreich hinzugefÃ¼gt',0),(216036,6001,'en','State added successfully',0),(216037,6002,'is','',0),(216038,6002,'dr','UC',0),(216039,6002,'pr',' Ø§Ø³ØªØ§Ù† UC',0),(216040,6002,'tr','DEVLET',0),(216041,6002,'pl','PAÅƒSTWA',0),(216042,6002,'bg','Ð”ÐªÐ Ð–ÐÐ’Ð',0),(216043,6002,'ur','Ø­Ø§Ù„Øª',0),(216044,6002,'sr','Ð”Ð Ð–ÐÐ’Ð',0),(216045,6002,'vi','Tiá»ƒu bang',0),(216046,6002,'af','STAAT',0),(216047,6002,'ro','STAT',0),(216048,6002,'et','RIIK',0),(216049,6002,'si','DRÅ½AVA',0),(216050,6002,'ba','NEGARA',0),(216051,6002,'nl','STAAT',0),(216052,6002,'fi','VALTION',0),(216053,6002,'no','TILSTAND',0),(216054,6002,'da','STATEN',0),(216055,6002,'ko','ìƒíƒœ',0),(216056,6002,'he','×”×ž×“×™× ×”',0),(216057,6002,'el','ÎšÎ¡Î†Î¤ÎŸÎ£',0),(216058,6002,'zh','æ€\r\n',0),(216059,6002,'sv','STATEN',0),(216060,6002,'it','STATO',0),(216061,6002,'tl','',0),(216062,6002,'th','&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(216063,6002,'hi','à¤°à¤¾à¤œà¥à¤¯',0),(216064,6002,'ms','NEGERI',0),(216065,6002,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(216066,6002,'fr','Ã‰TAT',0),(216067,6002,'jp','éƒ½é?“åºœçœŒ',0),(216068,6002,'pt','ESTADO',0),(216069,6002,'ru','Ð“ÐžÐ¡Ð£Ð”ÐÐ Ð¡Ð¢Ð’Ðž',0),(216070,6002,'es','ESTADO',0),(216071,6002,'de','ZUSTAND',0),(216072,6002,'en','STATE',0),(216073,6003,'is','',0),(216074,6003,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙˆÙ„Ø§ÛŒØª',0),(216075,6003,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø³ØªØ§Ù† ',0),(216076,6003,'tr','Devlet Ekle/GÃ¼ncelle',0),(216077,6003,'pl','Dodaj/Aktualizuj stan',0),(216078,6003,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(216079,6003,'ur','Ø±ÛŒØ§Ø³Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(216080,6003,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(216081,6003,'vi','ThÃªm/Cáº­p Nháº­t Tá»‰nh, ThÃ nh Phá»‘',0),(216082,6003,'af','Staat (Landsgebied) Bygevoeg/Opdateer',0),(216083,6003,'ro','AdÄƒugaÅ£i/actualizaÅ£i stat',0),(216084,6003,'et','Maakonna lisamine/uuendamine',0),(216085,6003,'si','DrÅ¾avni Dodaj/posodobi',0),(216086,6003,'ba','Tambahkan/Perbarui negara',0),(216087,6003,'nl','Staat toevoegen/bijwerken',0),(216088,6003,'fi','Valtion lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(216089,6003,'no','Statlige Legg til/Oppdater',0),(216090,6003,'da','Statslige TilfÃ¸j/opdater',0),(216091,6003,'ko','ì£¼ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(216092,6003,'he','×”×•×¡×£/×¢×“×›×Ÿ ×ž×“×™× ×”',0),(216093,6003,'el','ÎšÏÎ±Ï„Î¹ÎºÎ® Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(216094,6003,'zh','å·žæ–°å¢ž/æ›´æ–°\r\n',0),(216095,6003,'sv','Statliga LÃ¤gg till/uppdatera',0),(216096,6003,'it','Aggiungi/Aggiorna stato',0),(216097,6003,'tl','',0),(216098,6003,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(216099,6003,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(216100,6003,'ms','Negeri Tambah/Kemaskini',0),(216101,6003,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« ÙˆÙ„Ø§ÙŠØ©',0),(216102,6003,'fr','Etat ajouter/mettre Ã  jour',0),(216103,6003,'jp','å·žã€€è¿½åŠ /æ›´æ–°',0),(216104,6003,'pt','Adicionar/actualizar estado',0),(216105,6003,'ru','Ð¨Ñ‚Ð°Ñ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(216106,6003,'es','Estado Agregar/Actualizar',0),(216107,6003,'de','Staatliche hinzufÃ¼gen/aktualisieren',0),(216108,6003,'en','State Add/Update',0),(216109,6004,'is','',0),(216110,6004,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙˆÙ„Ø§ÛŒØªÙ‡Ø§ â€“ Ø§ÙŠØ§Ù„Ø§Øª Ùˆ Ù…Ù†Ø·Ù‚Ù‡ Ù…Ø­Ù„ÙŠ',0),(216111,6004,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø³ØªØ§Ù† Ù‡Ø§ â€“ Ø§ÙŠØ§Ù„Ø§Øª Ùˆ Ù…Ù†Ø·Ù‚Ù‡ Ù…Ø­Ù„ÙŠ',0),(216112,6004,'tr','Devletler, eyalet ve yerel alanlarÄ± Ekle/GÃ¼ncelle',0),(216113,6004,'pl','Dodaj/Aktualizuj paÅ„stw, prowincji i lokalnych obszarÃ³w',0),(216114,6004,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ, Ñ‰Ð°Ñ‚Ð¸, Ð¿Ñ€Ð¾Ð²Ð¸Ð½Ñ†Ð¸Ð¸ Ð¸ Ñ€Ð°Ð¹Ð¾Ð½Ð¸',0),(216115,6004,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº Ø§Ù…Ø±ÛŒÚ©ÛØŒ ØµÙˆØ¨ÙˆÚº Ø§ÙˆØ± Ù…Ù‚Ø§Ù…ÛŒ Ø¹Ù„Ø§Ù‚Û Ø¬Ø§Øª',0),(216116,6004,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð”Ñ€Ð¶Ð°Ð²Ð°Ð¼Ð°, Ð¿Ð¾ÐºÑ€Ð°Ñ˜Ð¸Ð½Ð°Ð¼Ð° Ð¸ Ð»Ð¾ÐºÐ°Ð»Ð½Ð¸Ð¼ Ð¿Ð¾Ð´Ñ€ÑƒÑ‡Ñ˜Ð¸Ð¼Ð°',0),(216117,6004,'vi','ThÃªm/Cáº­p Nháº­t Tá»‰nh, ThÃ nh Phá»‘ & Äá»‹a PhÆ°Æ¡ng',0),(216118,6004,'af','Bygevoeg/Opdateer State (Landsgebiede), Provinsies en Plaaslike Area\'s',0),(216119,6004,'ro','AdÄƒugaÅ£i/actualizaÅ£i Statele, provincii ÅŸi zonele locale',0),(216120,6004,'et','Lisamine/uuendamine, provintsid ja kohalikud alad',0),(216121,6004,'si','Dodaj/posodobi drÅ¾ave, pokrajin in obÄin',0),(216122,6004,'ba','Menambahkan Update Serikat, propinsi dan daerah',0),(216123,6004,'nl','Staten, provincies en lokale gebieden toevoegen/bijwerken',0),(216124,6004,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤, maakuntien ja alueiden',0),(216125,6004,'no','Legg til/Oppdater, provinser og lokale omrÃ¥der',0),(216126,6004,'da','TilfÃ¸j/opdater stater, provinser og lokalomrÃ¥der',0),(216127,6004,'ko','ì¶”ê°€/ì—…ë°ì´íŠ¸ ìƒíƒœ, ì§€ë°© ë° ì§€ì—­',0),(216128,6004,'he','×”×•×¡×£/×¢×“×›×Ÿ ×ž×“×™× ×•×ª, ×ž×—×•×–×•×ª ×•××–×•×¨×™× ×ž×§×•×ž×™',0),(216129,6004,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼ÎµÎ»ÏŽÎ½, ÎµÏ€Î±ÏÏ‡Î¯ÎµÏ‚ ÎºÎ±Î¹ Ï€ÎµÏÎ¹Î¿Ï‡Î­Ï‚',0),(216130,6004,'zh','æ–°å¢ž/æ›´æ–°å›½å®¶ï¼Œçœä¸Žåœ°æ–¹\r\n',0),(216131,6004,'sv','LÃ¤gg till/uppdatera staterna, provinser och omrÃ¥den',0),(216132,6004,'it','Aggiungere o aggiornare gli Stati, province e aree locali',0),(216133,6004,'tl','',0),(216134,6004,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;,&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(216135,6004,'hi','à¤ªà¥à¤°à¤¾à¤‚à¤¤à¥‹à¤‚ à¤”à¤° à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤°à¥‹à¤‚ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤°à¤¾à¤œà¥à¤¯à¥‹à¤‚',0),(216136,6004,'ms','Tambah/Kemaskini Negeri, wilayah dan kawasan-kawasan tempatan',0),(216137,6004,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¯ÙˆÙ„ ÙˆØ§Ù„Ù…Ù‚Ø§Ø·Ø¹Ø§Øª ÙˆØ§Ù„Ù…Ù†Ø§Ø·Ù‚ Ø§Ù„Ù…Ø­Ù„ÙŠØ©',0),(216138,6004,'fr','Ajouter/mettre Ã  jour les Ã‰tats, Provinces et communes',0),(216139,6004,'jp','å·žãƒ»åœ°æ–¹ãƒ»åœ°åŸŸã?ªã?©ã?®è¿½åŠ /æ›´æ–°',0),(216140,6004,'pt','Adicionar/atualizar Estados, provÃ­ncias e territÃ³rios',0),(216141,6004,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð°, Ð¿Ñ€Ð¾Ð²Ð¸Ð½Ñ†Ð¸Ð¹ Ð¸ Ð¼ÐµÑÑ‚Ð½Ñ‹Ñ… Ñ€Ð°Ð¹Ð¾Ð½Ð¾Ð²',0),(216142,6004,'es','Agregar/Actualizar Estados, ProvÃ­ncias y Ãreas Locales',0),(216143,6004,'de','HinzufÃ¼gen/Aktualisieren Sie Staaten, Provinzen und Gemeinden',0),(216144,6004,'en','Add/Update States, Provinces and Local Areas',0),(216145,6005,'is','',0),(216146,6005,'dr','Ú†Ø§Ù¾ ØªÙ…Ø§Ù… Ú†Ùƒ Ø¯Ø± Ù„ÙŠØ³Øª ',0),(216147,6005,'pr','Ú†Ø§Ù¾ ØªÙ…Ø§Ù… Ú†Ùƒ Ø¯Ø± Ù„ÙŠØ³Øª ',0),(216148,6005,'tr','Listedeki tÃ¼m Ã§ekleri yazdÄ±rma',0),(216149,6005,'pl','Drukuj wszystkie kontrole w liÅ›cie',0),(216150,6005,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð² ÑÐ¿Ð¸ÑÑŠÐºÐ°',0),(216151,6005,'ur','ØªÙ…Ø§Ù… Ù¾Ú‘ØªØ§Ù„ ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(216152,6005,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑÐ²Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ñƒ Ð»Ð¸ÑÑ‚Ð¸',0),(216153,6005,'vi','In táº¥t cáº£ SÃ©c trong danh sÃ¡ch',0),(216154,6005,'af','Druk alle Tjeks in Lys',0),(216155,6005,'ro','ImprimaÅ£i toate controalele Ã®n lista',0),(216156,6005,'et','Prindi nimekirja kÃµikide kontrollide',0),(216157,6005,'si','Natisni vse preglede v seznam',0),(216158,6005,'ba','Mencetak cek semua dalam daftar',0),(216159,6005,'nl','Alle cheques in lijst afdrukken',0),(216160,6005,'fi','Tulostaa luettelon kaikki sekit',0),(216161,6005,'no','Skrive ut alle sjekker i listen',0),(216162,6005,'da','Udskrive alle Checks i listen',0),(216163,6005,'ko','ëª©ë¡ì—ì„œ ëª¨ë“  ê²€ì‚¬ë¥¼ ì¸ì‡„',0),(216164,6005,'he','×”×“×¤×¡ ×›×œ ×”×¦\'×§×™× ×‘×¨×©×™×ž×”',0),(216165,6005,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ ÏŒÎ»Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ ÏƒÏ„Î· Î»Î¯ÏƒÏ„Î±',0),(216166,6005,'zh','æ‰“å°æ¸…å•ä¸­çš„æ‰€æœ‰æ£€æŸ¥\r\n',0),(216167,6005,'sv','Skriva ut alla kontroller i listan',0),(216168,6005,'it','Stampare tutti i controlli elenco',0),(216169,6005,'tl','',0),(216170,6005,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3594;&#3655;&#3588;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(216171,6005,'hi','à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤¸à¤­à¥€ à¤šà¥‡à¤• à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(216172,6005,'ms','Mencetak cek semua dalam senarai',0),(216173,6005,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª ÙƒØ§ÙØ© ÙÙŠ Ù‚Ø§Ø¦Ù…Ø©',0),(216174,6005,'fr','Imprimer tous les contrÃ´les de liste',0),(216175,6005,'jp','Print all checks in list',0),(216176,6005,'pt','ImpressÃ£o de cheques todos na lista',0),(216177,6005,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð²ÑÐµ Ð§ÐµÐºÐ¸ Ð² ÑÐ¿Ð¸ÑÐºÐµ',0),(216178,6005,'es','Imprimir Todos los Cheques en la Lista',0),(216179,6005,'de','Alle PrÃ¼fungen in Liste drucken',0),(216180,6005,'en','Print all Checks in list',0),(216181,6006,'is','',0),(216182,6006,'dr','Ù‡Ù…ÙŠØ´Ù‡ ØªØ§Ø±ÙŠØ® Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ Ø§Ú¯Ø± ÙÙ‚Ø· Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(216183,6006,'pr','Ù‡Ù…ÙŠØ´Ù‡ ØªØ§Ø±ÙŠØ® Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ Ø§Ú¯Ø± ÙÙ‚Ø· Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(216184,6006,'tr','Her zaman yalnÄ±zca gÃ¶nderilmemiÅŸ ise kullanÄ±lan Tarih',0),(216185,6006,'pl','Data zawsze uÅ¼ywane, jeÅ›li tylko niewysÅ‚ane',0),(216186,6006,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð° Ð²Ð¸Ð½Ð°Ð³Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð°ÐºÐ¾ Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ ÑÐ°Ð¼Ð¾',0),(216187,6006,'ur','Ø§Ú¯Ø± ØµØ±Ù Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ ÛÙ…ÛŒØ´Û Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ø¯Û ØªØ§Ø±ÛŒØ®',0),(216188,6006,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÐºÐ¾Ñ˜Ð¸ ÑÐµ ÑƒÐ²ÐµÐº ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð°ÐºÐ¾ Ð½ÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸Ñ… ÑÐ°Ð¼Ð¾',0),(216189,6006,'vi','NgÃ y luÃ´n dÃ¹ng khi CHá»ˆ CHÆ¯A Káº¾T CHUYá»‚N',0),(216190,6006,'af','Gebruik altyd Datum met Ongeposteerd Alleenlik',0),(216191,6006,'ro','Data utilizate Ã®ntotdeauna dacÄƒ neÃ®nregistrate numai',0),(216192,6006,'et','Alati kasutada, kui konteerimata ainult kuupÃ¤ev',0),(216193,6006,'si','Datum, ki se vedno uporablja Äe neknjiÅ¾enih le',0),(216194,6006,'ba','Tanggal yang selalu digunakan jika Unposted hanya',0),(216195,6006,'nl','Datum altijd gebruikt als niet-geboekte alleen',0),(216196,6006,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤, jota kÃ¤ytetÃ¤Ã¤n aina jos kirjaamattomien vain',0),(216197,6006,'no','Datoen som alltid brukes hvis ikke-bokfÃ¸rte bare',0),(216198,6006,'da','Dato, der altid bruges hvis ikke bogfÃ¸rte kun',0),(216199,6006,'ko','í•­ìƒ ì‚¬ìš© í•˜ëŠ” ê²½ìš°ì— ê²Œì‹œ ë˜ì§€ ì•Šì€ ë‚ ì§œ',0),(216200,6006,'he','×ª××¨×™×š ×ª×ž×™×“ ×× × ×¨×©×ž×” ×¨×§',0),(216201,6006,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Ï€Î¬Î½Ï„Î± Î±Î½ Î¼Î· Î±Î½Î±ÏÏ„Î·Î¼Î­Î½ÎµÏ‚ Î¼ÏŒÎ½Î¿',0),(216202,6006,'zh','å¦‚æžœä»…æœªå‘å¸ƒæ—¥æœŸå§‹ç»ˆä½¿ç”¨',0),(216203,6006,'sv','Datum som alltid anvÃ¤nds om ej bokfÃ¶rda endast',0),(216204,6006,'it','Data sempre utilizzato se non registrate solo',0),(216205,6006,'tl','',0),(216206,6006,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3632;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;&#3648;&#3626;&#3617;&#3629;&#3648;&#3617;&#3639;&#3656;&#3629;&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3',0),(216207,6006,'hi','à¤…à¤—à¤° à¤•à¥‡à¤µà¤² Unposted à¤¹à¤®à¥‡à¤¶à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(216208,6006,'ms','Tarikh yang selalu digunakan jika Unposted hanya',0),(216209,6006,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¯Ø§Ø¦Ù…Ø§Ù‹ Ø¥Ø°Ø§ Ø§Ù„Ù…Ø±Ø­Ù„ ÙÙ‚Ø·',0),(216210,6006,'fr','Date toujours utilisÃ© si non comptabilisÃ©s seulement',0),(216211,6006,'jp','è¨ˆä¸Šã?•ã‚Œã?¦ã?„ã?ªã?„å ´å?ˆã?“ã?®æ—¥ä»˜ã‚’ä½¿ç”¨',0),(216212,6006,'pt','Data usada sempre se Unposted sÃ³',0),(216213,6006,'ru','Ð”Ð°Ñ‚Ð° Ð²ÑÐµÐ³Ð´Ð° Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ, ÐµÑÐ»Ð¸ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð½ÐµÐ¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ',0),(216214,6006,'es','Fecha siempre esta usada si No Asentado Solamente',0),(216215,6006,'de','Datum immer verwendet, wenn nur ungebuchte',0),(216216,6006,'en','Date always used if Unposted Only',0),(216217,6007,'is','',0),(216218,6007,'dr','Ù¾Ø³Øª Ø´Ø¯Ù‡  Ø·Ø¨Ù‚',0),(216219,6007,'pr','Ù¾Ø³Øª Ø´Ø¯Ù‡  Ø·Ø¨Ù‚',0),(216220,6007,'tr','YayÄ±nlanan',0),(216221,6007,'pl','WysÅ‚ana na',0),(216222,6007,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾ Ð½Ð°',0),(216223,6007,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ù¾Ø±',0),(216224,6007,'sr','ÐŸÐ¾ÑÑ‚ÐµÐ´',0),(216225,6007,'vi','Káº¿t chuyá»ƒn vÃ o',0),(216226,6007,'af','Gepos Op',0),(216227,6007,'ro','Postat pe',0),(216228,6007,'et','Postitatud',0),(216229,6007,'si','Napoten na',0),(216230,6007,'ba','Dikirim pada',0),(216231,6007,'nl','Gepost op',0),(216232,6007,'fi','LÃ¤hetetty',0),(216233,6007,'no','Postet pÃ¥',0),(216234,6007,'da','Indsendt pÃ¥',0),(216235,6007,'ko','ì— ê²Œì‹œ ë¨',0),(216236,6007,'he','×¤×•×¨×¡× ×‘',0),(216237,6007,'el','Î‘Î½Î±ÏÏ„Î®Î¸Î·ÎºÎµ ÏƒÏ„Î¹Ï‚',0),(216238,6007,'zh','å‘å¸ƒæ—¶é—´ï¼š\r\n',0),(216239,6007,'sv','Postat pÃ¥',0),(216240,6007,'it','Pubblicato su',0),(216241,6007,'tl','',0),(216242,6007,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3592;&#3634;&#3585;&#3626;&#3617;&#3640;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3617;&#3639;&#3656;&#3629;',0),(216243,6007,'hi','à¤ªà¤° à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(216244,6007,'ms','Posted On',0),(216245,6007,'ar','Ù†Ø´Ø±Øª ÙÙŠ',0),(216246,6007,'fr','PostÃ© le',0),(216247,6007,'jp','ï½žã?«è¨ˆä¸Š',0),(216248,6007,'pt','Postado em',0),(216249,6007,'ru','ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¾',0),(216250,6007,'es','Asentado En',0),(216251,6007,'de','Geschrieben am',0),(216252,6007,'en','Posted On',0),(216253,6008,'is','',0),(216254,6008,'dr','Ù¾Ø³Øª Ø´Ø¯Ù‡  Ø¯Ø± ØªØ§Ø±ÙŠØ® ',0),(216255,6008,'pr','Ù¾Ø³Øª Ø´Ø¯Ù‡  Ø¯Ø± ØªØ§Ø±ÙŠØ® ',0),(216256,6008,'tr','Tarihinde tarihinde gÃ¶nderildi.',0),(216257,6008,'pl','WysÅ‚any w dniu',0),(216258,6008,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾ Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(216259,6008,'ur','Ù…ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ù¾Ø± ØªØ§Ø±ÛŒØ®',0),(216260,6008,'sr','ÐŸÐ¾ÑÑ‚ÐµÐ´ Ð´Ð°Ñ‚ÑƒÐ¼',0),(216261,6008,'vi','Káº¿t chuyá»ƒn vÃ o ngÃ y',0),(216262,6008,'af','Gepos Op Datum',0),(216263,6008,'ro','Postat pe data',0),(216264,6008,'et','Postitatud kuupÃ¤ev',0),(216265,6008,'si','Objavljeno dne',0),(216266,6008,'ba','Diposting pada tanggal',0),(216267,6008,'nl','Gepost op datum',0),(216268,6008,'fi','LÃ¤hetetty pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(216269,6008,'no','Skrevet pÃ¥ dato',0),(216270,6008,'da','Sendt oven pÃ¥ dato',0),(216271,6008,'ko','ë‚ ì§œì— ê²Œì‹œ ë¨',0),(216272,6008,'he','×¤×•×¨×¡× ×‘×ª××¨×™×š',0),(216273,6008,'el','Î‘Î½Î±ÏÏ„Î®Î¸Î·ÎºÎµ ÏƒÏ„Î¹Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(216274,6008,'zh','å‘å¸ƒæ—¶é—´ï¼šæ—¥æœŸ\r\n',0),(216275,6008,'sv','Postat pÃ¥ datum',0),(216276,6008,'it','Inviato in data',0),(216277,6008,'tl','',0),(216278,6008,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3592;&#3634;&#3585;&#3626;&#3617;&#3640;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3617;&#3639;&#3656;&#3629;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(216279,6008,'hi','à¤ªà¤° à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(216280,6008,'ms','Dikirim pada tarikh',0),(216281,6008,'ar','Ù†Ø´Ø±Øª ÙÙŠ ØªØ§Ø±ÙŠØ®',0),(216282,6008,'fr','PostÃ© le Date',0),(216283,6008,'jp','è¨ˆä¸Šã?—ã?Ÿæ—¥',0),(216284,6008,'pt','Postado em data',0),(216285,6008,'ru','ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¾ Ð”Ð°Ñ‚Ð°',0),(216286,6008,'es','Asentado En la Fecha',0),(216287,6008,'de','Geschrieben am Datum',0),(216288,6008,'en','Posted On Date',0),(216289,6009,'is','',0),(216290,6009,'dr','Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(216291,6009,'pr','Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(216292,6009,'tr','Ä°Ã§in gÃ¶nderildi',0),(216293,6009,'pl','WysÅ‚ana do',0),(216294,6009,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾ Ð½Ð°',0),(216295,6009,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ø¨Ø·Ø±Ù',0),(216296,6009,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸ Ñƒ',0),(216297,6009,'vi','Káº¿t chuyá»ƒn tá»›i',0),(216298,6009,'af','Gepos Aan',0),(216299,6009,'ro','Postat la',0),(216300,6009,'et','Postitatud',0),(216301,6009,'si','Objavljeno v',0),(216302,6009,'ba','Diposting ke',0),(216303,6009,'nl','Geplaatst op',0),(216304,6009,'fi','LÃ¤hetetty',0),(216305,6009,'no','Lagt til',0),(216306,6009,'da','Indsendt til',0),(216307,6009,'ko','ì— ê²Œì‹œ ë¨',0),(216308,6009,'he','×¤×•×¨×¡× ×›×“×™',0),(216309,6009,'el','Î”Î·Î¼Î¿ÏƒÎ¹ÎµÏÏ„Î·ÎºÎµ ÏƒÏ„Î¿',0),(216310,6009,'zh','å‘å¸ƒåˆ°\r\n',0),(216311,6009,'sv','Postat till',0),(216312,6009,'it','Inviato a',0),(216313,6009,'tl','',0),(216314,6009,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3611;&#3618;&#3633;&#3591;',0),(216315,6009,'hi','à¤•à¥‹ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(216316,6009,'ms','Dihantar untuk',0),(216317,6009,'ar','Ø£Ø±Ø³Ù„Øª Ø¥Ù„Ù‰',0),(216318,6009,'fr','PostÃ© Ã ',0),(216319,6009,'jp','ï½žã?¸è¨ˆä¸Š',0),(216320,6009,'pt','Postado para',0),(216321,6009,'ru','ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¾ Ð²',0),(216322,6009,'es','Asentado A',0),(216323,6009,'de','Posted in',0),(216324,6009,'en','Posted To',0),(216325,6010,'is','',0),(216326,6010,'dr','Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø¨Ù‡ ØªØ§Ø±ÙŠØ® ',0),(216327,6010,'pr','Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø¨Ù‡ ØªØ§Ø±ÙŠØ® ',0),(216328,6010,'tr','BugÃ¼ne kadar YayÄ±nlanan',0),(216329,6010,'pl','WysÅ‚ana do daty',0),(216330,6010,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾ Ð´Ð°Ñ‚Ð°',0),(216331,6010,'ur','Ù…ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ø¨Ø·Ø±Ù ØªØ§Ø±ÛŒØ®',0),(216332,6010,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶Ð¸ Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(216333,6010,'vi','Káº¿t chuyá»ƒn tá»›i ngÃ y',0),(216334,6010,'af','Gepos Tot Op Datum',0),(216335,6010,'ro','Postat la data de',0),(216336,6010,'et','Sisestatud kuupÃ¤ev',0),(216337,6010,'si','Objavljeno v datum',0),(216338,6010,'ba','Dikirim tanggal',0),(216339,6010,'nl','Tot nu toe Gepost',0),(216340,6010,'fi','Saakka',0),(216341,6010,'no','Skrevet hittil',0),(216342,6010,'da','Indsendt til dato',0),(216343,6010,'ko','ë‚ ì§œì— ê²Œì‹œ ë¨',0),(216344,6010,'he','×¤×•×¨×¡× ×¢×“ ×›×”',0),(216345,6010,'el','Î”Î·Î¼Î¿ÏƒÎ¹ÎµÏÏ„Î·ÎºÎµ Î¼Î­Ï‡ÏÎ¹ ÏƒÎ®Î¼ÎµÏÎ±',0),(216346,6010,'zh','å‘å¸ƒè¿„ä»Š\r\n',0),(216347,6010,'sv','Postat till datum',0),(216348,6010,'it','Pubblicato fino ad oggi',0),(216349,6010,'tl','',0),(216350,6010,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3611;&#3618;&#3633;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(216351,6010,'hi','à¤¤à¤¿à¤¥à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(216352,6010,'ms','Dihantar kepada tarikh',0),(216353,6010,'ar','Ù†Ø´Ø±Øª Ø¨ØªØ§Ø±ÙŠØ®',0),(216354,6010,'fr','PubliÃ© Ã  ce jour',0),(216355,6010,'jp','è¨ˆä¸Šæ—¥',0),(216356,6010,'pt','Postado Ã  data',0),(216357,6010,'ru','ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¾ Ð½Ð° ÑÐµÐ³Ð¾Ð´Ð½ÑÑˆÐ½Ð¸Ð¹ Ð´ÐµÐ½ÑŒ',0),(216358,6010,'es','Asentado A Fecha',0),(216359,6010,'de','Bis heute erschienen',0),(216360,6010,'en','Posted To Date',0),(216361,6011,'is','',0),(216362,6011,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú†Ù‡ ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠÙŠ',0),(216363,6011,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú†Ù‡ ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠÙŠ',0),(216364,6011,'tr','Tarihleri kullanma',0),(216365,6011,'pl','UÅ¼ycia, ktÃ³ry',0),(216366,6011,'bg','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°, ÐºÐ¾ÑÑ‚Ð¾ Ð´Ð°Ñ‚Ð¸Ñ€Ð°',0),(216367,6011,'ur','Ø¬Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®ÛŒÚº Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(216368,6011,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° ÐºÐ¾Ñ˜Ð° Ð´Ð°Ñ‚Ð¸Ñ€Ð°',0),(216369,6011,'vi','DÃ¹ng ngÃ y nÃ o',0),(216370,6011,'af','Gebruik Watter Datums',0),(216371,6011,'ro','Utilizare care dateazÄƒ',0),(216372,6011,'et','KuupÃ¤evade kasutamine',0),(216373,6011,'si','Uporabo, ki',0),(216374,6011,'ba','Penggunaan yang',0),(216375,6011,'nl','Gebruik die dateert',0),(216376,6011,'fi','KÃ¤yttÃ¶Ã¤, joka on',0),(216377,6011,'no','Bruk som',0),(216378,6011,'da','Brug, som stammer',0),(216379,6011,'ko','ë‚ ì§œ ì‚¬ìš©',0),(216380,6011,'he','×©×™×ž×•×© ×©×‘×• ×ª××¨×™×›×™×',0),(216381,6011,'el','Î§ÏÎ®ÏƒÎ· Ï€Î¿Ï… Ï‡ÏÎ¿Î½Î¿Î»Î¿Î³ÎµÎ¯Ï„Î±Î¹',0),(216382,6011,'zh','ä½¿ç”¨å¯è¿½æº¯\r\n',0),(216383,6011,'sv','AnvÃ¤ndning som gÃ¥r',0),(216384,6011,'it','Uso che risale',0),(216385,6011,'tl','',0),(216386,6011,'th','&#3651;&#3594;&#3657;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3623;&#3633;&#3609;&#3652;&#3627;&#3609;',0),(216387,6011,'hi','à¤œà¥‹ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•à¥‹à¤‚ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(216388,6011,'ms','Penggunaan yang',0),(216389,6011,'ar','Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø°ÙŠ ÙŠØ¹ÙˆØ¯ ØªØ§Ø±ÙŠØ®Ù‡',0),(216390,6011,'fr','Utilisation qui date',0),(216391,6011,'jp','ã?©ã?®æ—¥ä»˜',0),(216392,6011,'pt','Uso que data',0),(216393,6011,'ru','ÐšÐ°ÐºÐ¸Ðµ Ð”Ð°Ñ‚Ñ‹ Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ',0),(216394,6011,'es','Usar Cuales Fechas',0),(216395,6011,'de','Verwendung der Daten',0),(216396,6011,'en','Use Which Dates',0),(216397,6012,'is','',0),(216398,6012,'dr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(216399,6012,'pr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(216400,6012,'tr','Yerine getirilmesi sipariÅŸ giriÅŸi',0),(216401,6012,'pl','Realizacji zamÃ³wieÅ„.',0),(216402,6012,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(216403,6012,'ur','ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ Ø§Ù†Ù¹Ø±ÛŒ',0),(216404,6012,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ',0),(216405,6012,'vi','Nháº­p ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(216406,6012,'af','Uitvoeringsbestelling Inskrywing',0),(216407,6012,'ro','Intrare de ordinea Ã®mplinirea',0),(216408,6012,'et','Kaubatellimuse sisestus',0),(216409,6012,'si','Izpolnitev naroÄila',0),(216410,6012,'ba','Pemenuhan Order masuk',0),(216411,6012,'nl','Vervulling orderinvoer',0),(216412,6012,'fi','TÃ¤yttÃ¤minen Tilauksen syÃ¶ttÃ¶',0),(216413,6012,'no','Oppfyllelsen bestilling',0),(216414,6012,'da','Opfyldelse ordreindtastning',0),(216415,6012,'ko','í–‰ ì£¼ë¬¸ ìž…ë ¥',0),(216416,6012,'he','×”×’×©×ž×” Order Entry',0),(216417,6012,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ·',0),(216418,6012,'zh','å±¥è¡Œè®¢å•è¾“å…¥\r\n',0),(216419,6012,'sv','Uppfyllelse orderlÃ¤ggning',0),(216420,6012,'it','Adempimento Order Entry',0),(216421,6012,'tl','',0),(216422,6012,'th','&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(216423,6012,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(216424,6012,'ms','Memenuhi perintah kemasukan',0),(216425,6012,'ar','ÙˆÙØ§Ø¡ Ø£Ù…Ø± Ø¥Ø¯Ø®Ø§Ù„',0),(216426,6012,'fr','Saisie de commande d\'exÃ©cution',0),(216427,6012,'jp','æ³¨æ–‡å…¥åŠ›ã?®å±¥è¡Œ',0),(216428,6012,'pt','Entrada de pedido de cumprimento',0),(216429,6012,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ð²Ñ…Ð¾Ð´',0),(216430,6012,'es','Entrada de Orden de Cumplimiento',0),(216431,6012,'de','ErfÃ¼llung-Auftragserfassung',0),(216432,6012,'en','Fulfillment Order Entry',0),(216433,6013,'is','',0),(216434,6013,'dr','ØªÙˆØ¶ÙŠØ­ ÙˆÙŠØ¯Ø¦ÙˆÙŠÙŠ',0),(216435,6013,'pr','ØªÙˆØ¶ÙŠØ­ ÙˆÙŠØ¯Ø¦ÙˆÙŠÙŠ',0),(216436,6013,'tr','Video aÃ§Ä±klama',0),(216437,6013,'pl','WyjaÅ›nienie wideo',0),(216438,6013,'bg','Ð’Ð¸Ð´ÐµÐ¾ Ð¾Ð±ÑÑÐ½ÐµÐ½Ð¸Ðµ',0),(216439,6013,'ur','ÙˆÛŒÚˆÛŒÙˆ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(216440,6013,'sr','Ð’Ð¸Ð´ÐµÐ¾ Ð¾Ð±Ñ˜Ð°ÑˆÑšÐµÑšÐµ',0),(216441,6013,'vi','Giáº£i thÃ­ch báº±ng Video',0),(216442,6013,'af','Video Verduideliking',0),(216443,6013,'ro','Pagina explicaÅ£ie',0),(216444,6013,'et','Video selgitus',0),(216445,6013,'si','Video pojasnilo',0),(216446,6013,'ba','Video penjelasan',0),(216447,6013,'nl','Video uitleg',0),(216448,6013,'fi','Video selitys',0),(216449,6013,'no','Video forklaring',0),(216450,6013,'da','Video forklaring',0),(216451,6013,'ko','ë¹„ë””ì˜¤ ì„¤ëª…',0),(216452,6013,'he','×•×™×“××• ×”×¡×‘×¨',0),(216453,6013,'el','Î•Î¾Î®Î³Î·ÏƒÎ· Î²Î¯Î½Ï„ÎµÎ¿',0),(216454,6013,'zh','è§†é¢‘è¯´æ˜Ž\r\n',0),(216455,6013,'sv','Video fÃ¶rklaring',0),(216456,6013,'it','Spiegazione video',0),(216457,6013,'tl','',0),(216458,6013,'th','&#3623;&#3637;&#3604;&#3637;&#3650;&#3629;&#3594;&#3637;&#3657;&#3649;&#3592;&#3591;',0),(216459,6013,'hi','à¤µà¥€à¤¡à¤¿à¤¯à¥‹ à¤µà¤¿à¤µà¤°à¤£',0),(216460,6013,'ms','Video penjelasan',0),(216461,6013,'ar','Ø´Ø±Ø­ Ø¨Ù„Ù‚Ø·Ø§Øª ÙÙŠØ¯ÙŠÙˆ',0),(216462,6013,'fr','Explication vidÃ©o',0),(216463,6013,'jp','ãƒ“ãƒ‡ã‚ªèª¬æ˜Ž',0),(216464,6013,'pt','A explicaÃ§Ã£o',0),(216465,6013,'ru','Ð’Ð¸Ð´ÐµÐ¾ Ð¾Ð±ÑŠÑÑÐ½ÐµÐ½Ð¸Ðµ',0),(216466,6013,'es','ExplicaciÃ³n de VÃ­deo',0),(216467,6013,'de','Video ErklÃ¤rung',0),(216468,6013,'en','Video Explanation',0),(216469,6014,'is','',0),(216470,6014,'dr','Ø§Ø¨Ø·Ø§Ù„ ØªØ§Ø±ÙŠØ® ',0),(216471,6014,'pr','Ø§Ø¨Ø·Ø§Ù„ ØªØ§Ø±ÙŠØ® ',0),(216472,6014,'tr','Ä°ptal tarihi',0),(216473,6014,'pl','NiewaÅ¼na data',0),(216474,6014,'bg','Ð”Ð°Ñ‚Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ',0),(216475,6014,'ur','Ú©Ø§Ù„Ø¹Ø¯Ù… ØªØ§Ø±ÛŒØ®',0),(216476,6014,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ð´Ð°Ñ‚ÑƒÐ¼',0),(216477,6014,'vi','NgÃ y há»§y',0),(216478,6014,'af','Leemte datum',0),(216479,6014,'ro','Data nule',0),(216480,6014,'et','Annulleerimise kuupÃ¤ev',0),(216481,6014,'si','Neveljaven datum',0),(216482,6014,'ba','Tanggal kosong',0),(216483,6014,'nl','VOID datum',0),(216484,6014,'fi','MitÃ¤tÃ¶innin pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(216485,6014,'no','Ugyldig dato',0),(216486,6014,'da','Ugyldig dato',0),(216487,6014,'ko','Void ë‚ ì§œ',0),(216488,6014,'he','×ª××¨×™×š ×—×œ×œ',0),(216489,6014,'el','Î†ÎºÏ…ÏÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(216490,6014,'zh','ä½œåºŸæ—¥æœŸ\r\n',0),(216491,6014,'sv','Ogiltigt datum',0),(216492,6014,'it','Date annullate',0),(216493,6014,'tl','',0),(216494,6014,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(216495,6014,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(216496,6014,'ms','Tarikh yang tidak sah',0),(216497,6014,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø§Ø·Ù„Ø©',0),(216498,6014,'fr','Sub Date',0),(216499,6014,'jp','ç ´æ£„æ—¥',0),(216500,6014,'pt','Void data',0),(216501,6014,'ru','Void Ð”Ð°Ñ‚Ð°',0),(216502,6014,'es','Anular Fecha',0),(216503,6014,'de','Void Datum',0),(216504,6014,'en','Void Date',0),(216505,6015,'is','',0),(216506,6015,'dr','(Ù¾ÙˆØ´Ø´',0),(216507,6015,'pr','Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯Ù‰(Ù¾ÙˆØ´Ø´',0),(216508,6015,'tr','KapaklarÄ±',0),(216509,6015,'pl','Obejmuje',0),(216510,6015,'bg','ÐšÐ°Ð¿Ð°Ñ†Ð¸',0),(216511,6015,'ur','ØºÙ„Ø§Ù',0),(216512,6015,'sr','Ð—Ð°ÐºÐ»Ð¾Ð½Ðµ',0),(216513,6015,'vi','BÃ¬a',0),(216514,6015,'af','Omslae',0),(216515,6015,'ro','AcoperÄƒ',0),(216516,6015,'et','Kaaned',0),(216517,6015,'si','Zajema',0),(216518,6015,'ba','Sampul',0),(216519,6015,'nl','Covers',0),(216520,6015,'fi','Kannet',0),(216521,6015,'no','Dekker',0),(216522,6015,'da','DÃ¦kker',0),(216523,6015,'ko','ì»¤ë²„',0),(216524,6015,'he','×›×¨×™×›×•×ª',0),(216525,6015,'el','ÎšÎ±Î»ÏÏˆÎµÎ¹Ï‚',0),(216526,6015,'zh','è¦†ç›–\r\n',0),(216527,6015,'sv','TÃ¤cker',0),(216528,6015,'it','Copertine',0),(216529,6015,'tl','',0),(216530,6015,'th','&#3588;&#3640;&#3657;&#3617;&#3588;&#3619;&#3629;&#3591;',0),(216531,6015,'hi','à¤•à¤µà¤°',0),(216532,6015,'ms','Meliputi',0),(216533,6015,'ar','ÙˆÙŠØºØ·ÙŠ',0),(216534,6015,'fr','Couvertures',0),(216535,6015,'jp','ã‚«ãƒ?ãƒ¼',0),(216536,6015,'pt','Capas',0),(216537,6015,'ru','ÐžÐ±Ð»Ð¾Ð¶ÐºÐ¸',0),(216538,6015,'es','Cubrir',0),(216539,6015,'de','Abdeckungen',0),(216540,6015,'en','Covers',0),(216541,6016,'is','',0),(216542,6016,'dr','(Ø§Ø² Ø·Ø±ÙŠÙ‚',0),(216543,6016,'pr','Ø³Ø±Ø§Ø³Ø±ÙŠ (Ø§Ø² Ø·Ø±ÙŠÙ‚',0),(216544,6016,'tr','AracÄ±lÄ±ÄŸÄ±yla',0),(216545,6016,'pl','Przez',0),(216546,6016,'bg','Ð§Ñ€ÐµÐ·',0),(216547,6016,'ur','Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(216548,6016,'sr','ÐšÑ€Ð¾Ð·',0),(216549,6016,'vi','Qua',0),(216550,6016,'af','Deur',0),(216551,6016,'ro','Prin',0),(216552,6016,'et','Kaudu',0),(216553,6016,'si','Skozi',0),(216554,6016,'ba','Melalui',0),(216555,6016,'nl','Door middel van',0),(216556,6016,'fi','Kautta',0),(216557,6016,'no','Gjennom',0),(216558,6016,'da','Gennem',0),(216559,6016,'ko','í†µí•´',0),(216560,6016,'he','×“×¨×š',0),(216561,6016,'el','ÎœÎ­ÏƒÏ‰',0),(216562,6016,'zh','é€šè¿‡\r\n',0),(216563,6016,'sv','Genom',0),(216564,6016,'it','Attraverso',0),(216565,6016,'tl','',0),(216566,6016,'th','&#3612;&#3656;&#3634;&#3609;&#3652;&#3611;',0),(216567,6016,'hi','à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡',0),(216568,6016,'ms','Melalui',0),(216569,6016,'ar','Ù…Ù† Ø®Ù„Ø§Ù„',0),(216570,6016,'fr','Par le biais',0),(216571,6016,'jp','ï½žã‚’é€šã?—ã?¦',0),(216572,6016,'pt','AtravÃ©s de',0),(216573,6016,'ru','Ð§ÐµÑ€ÐµÐ·',0),(216574,6016,'es','Por',0),(216575,6016,'de','Durch',0),(216576,6016,'en','Through',0),(216577,6017,'is','',0),(216578,6017,'dr','(Ø´Ù…ÙˆÙ„- Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ)   Ùˆ ØªØ§Ø±ÙŠØ® Ù…ÙˆØ¹Ø¯ Ø¨ÛŒØ¬Ú© ',0),(216579,6017,'pr','Ù†Ù…Ø§ÙŠØ´ Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ Ù¾ÙˆØ´Ø´(Ø´Ù…ÙˆÙ„- Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ)   Ùˆ ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ÙØ§ÙƒØªÙˆØ± ',0),(216580,6017,'tr','GÃ¶steri sÃ¼resi: Fatura tarihi = sonu',0),(216581,6017,'pl','PokaÅ¼ okres: Faktury Data = koniec',0),(216582,6017,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´: Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ = ÐºÑ€Ð°Ð¹',0),(216583,6017,'ur','Ø´Ùˆ Ø¯ÙˆØ±: Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… =',0),(216584,6017,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐŸÐµÑ€Ð¸Ð¾Ð´: Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ = ÐºÑ€Ð°Ñ˜',0),(216585,6017,'vi','Hiá»ƒn thá»‹ pháº¡m vi: cuá»‘i ká»³=ngÃ y hÃ³a Ä‘Æ¡n',0),(216586,6017,'af','Wys Dekking:  Periode Eindig=Datum van Faktuur',0),(216587,6017,'ro','Perioada AratÄƒ: Factura data = capÄƒt',0),(216588,6017,'et','NÃ¤ita tÃ¤htaja: Arve kuupÃ¤ev = lÃµpp',0),(216589,6017,'si','PrikaÅ¾i obdobje: Fakturirati datum = konec',0),(216590,6017,'ba','Periode Tampilkan: Faktur tanggal akhir =',0),(216591,6017,'nl','Toon de periode: Factuurdatum = einde',0),(216592,6017,'fi','NÃ¤ytÃ¤ ajanjakso: Laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ = loppu',0),(216593,6017,'no','Vis periode: Fakturadato = slutten',0),(216594,6017,'da','Vis periode: Faktura dato = slut',0),(216595,6017,'ko','ê³µì—° ê¸°ê°„: ì†¡ìž¥ ë‚ ì§œ ë =',0),(216596,6017,'he','×”×¦×’ ×ž×©×š: ×—×©×‘×•× ×™×ª ×ª××¨×™×š = ×¡×•×£',0),(216597,6017,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€ÎµÏÎ¯Î¿Î´Î¿Ï‚: Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± = Ï„Î­Î»Î¿Ï‚',0),(216598,6017,'zh','æ˜¾ç¤ºèŒƒå›´ï¼šæœŸæœ«=å‘ç¥¨æ—¥æœŸ\r\n',0),(216599,6017,'sv','Visa Period: Faktura datum = slut',0),(216600,6017,'it','Visualizza periodo: Fattura Data = fine',0),(216601,6017,'tl','',0),(216602,6017,'th','&#3649;&#3626;&#3604;&#3591;&#3594;&#3656;&#3623;&#3591;&#3588;&#3621;&#3629;&#3610;&#3588;&#3621;&#3640;&#3617;:&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604; = &#3623;&#3633;&#3609;&#3607;&#3637',0),(216603,6017,'hi','à¤¶à¥‹ à¤•à¥€ à¤…à¤µà¤§à¤¿: à¤šà¤¾à¤²à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤…à¤‚à¤¤ =',0),(216604,6017,'ms','Tempoh tayangan: Invois tarikh akhir =',0),(216605,6017,'ar','ØªØ¨ÙŠÙ† Ø§Ù„ÙØªØ±Ø©: ÙØ§ØªÙˆØ±Ø© ØªØ§Ø±ÙŠØ® = Ù†Ù‡Ø§ÙŠØ©',0),(216606,6017,'fr','Voir la pÃ©riode : Date de la facture = fin',0),(216607,6017,'jp','è¡¨ç¤ºç¯„å›²ï¼šæœŸé–“çµ‚äº†ï¼?è«‹æ±‚æ—¥',0),(216608,6017,'pt','PerÃ­odo: Fatura data = fim',0),(216609,6017,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿ÐµÑ€Ð¸Ð¾Ð´: Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð”Ð°Ñ‚Ð° = ÐºÐ¾Ð½ÐµÑ†',0),(216610,6017,'es','Desplegar Cobertura: Fecha de TÃ©rminaciÃ³n de PerÃ­odo de la Factura',0),(216611,6017,'de','Ausstellungszeit: Rechnungsdatum = Ende',0),(216612,6017,'en','Show Period: Invoice Date = End',0),(216613,6018,'is','',0),(216614,6018,'dr','(Ø´Ù…ÙˆÙ„- Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ)  Ùˆ ØªØ§Ø±ÙŠØ® Ù…ÙˆØ¹Ø¯ Ø¨ÛŒØ¬Ú© ',0),(216615,6018,'pr','Ù†Ù…Ø§ÙŠØ´ Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ Ù¾ÙˆØ´Ø´(Ø´Ù…ÙˆÙ„- Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ)  Ùˆ ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ÙØ§ÙƒØªÙˆØ± ',0),(216616,6018,'tr','GÃ¶steri sÃ¼resi: Fatura tarihi = BaÅŸlat',0),(216617,6018,'pl','PokaÅ¼ okres: Faktury Data = Start',0),(216618,6018,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´: Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð´Ð°Ñ‚Ð° = ÐÐ°Ñ‡Ð°Ð»Ð¾',0),(216619,6018,'ur','Ø´Ùˆ Ø¯ÙˆØ±: Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ® = Ø¢ØºØ§Ø²',0),(216620,6018,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐŸÐµÑ€Ð¸Ð¾Ð´: Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ = Ð¡Ñ‚Ð°Ñ€Ñ‚',0),(216621,6018,'vi','Hiá»ƒn thá»‹ pháº¡m vi: Ä‘áº§u ká»³=ngÃ y hÃ³a Ä‘Æ¡n',0),(216622,6018,'af','Wys Dekking:  Periode Begin=Datum van Faktuur',0),(216623,6018,'ro','Perioada AratÄƒ: Factura data = Start',0),(216624,6018,'et','NÃ¤ita tÃ¤htaja: Arve kuupÃ¤ev = algus',0),(216625,6018,'si','PrikaÅ¾i obdobje: Fakturirati datum = zaÄetek',0),(216626,6018,'ba','Periode Tampilkan: Faktur tanggal = mulai',0),(216627,6018,'nl','Toon de periode: Factuurdatum = Start',0),(216628,6018,'fi','NÃ¤ytÃ¤ ajanjakso: Laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ = alku',0),(216629,6018,'no','Vis periode: Fakturadato = Start',0),(216630,6018,'da','Vis periode: Faktura dato = Start',0),(216631,6018,'ko','ê³µì—° ê¸°ê°„: ì†¡ìž¥ ë‚ ì§œ = ì‹œìž‘',0),(216632,6018,'he','×”×¦×’ ×ž×©×š: ×—×©×‘×•× ×™×ª ×ª××¨×™×š = ×”×ª×—×œ×”',0),(216633,6018,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€ÎµÏÎ¯Î¿Î´Î¿Ï‚: Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± = Î­Î½Î±ÏÎ¾Î·',0),(216634,6018,'zh','æ˜¾ç¤ºèŒƒå›´ï¼šæœŸé—´å¼€å§‹=å‘ç¥¨æ—¥æœŸ\r\n',0),(216635,6018,'sv','Visa Period: Faktura datum = Start',0),(216636,6018,'it','Visualizza periodo: Fattura Data = Start',0),(216637,6018,'tl','',0),(216638,6018,'th','&#3649;&#3626;&#3604;&#3591;&#3594;&#3656;&#3623;&#3591;&#3588;&#3621;&#3629;&#3610;&#3588;&#3621;&#3640;&#3617;:&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609; = &#3623;&#3633;&#3609;&#3607',0),(216639,6018,'hi','à¤¶à¥‹ à¤•à¥€ à¤…à¤µà¤§à¤¿: à¤šà¤¾à¤²à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ =',0),(216640,6018,'ms','Tempoh tayangan: Invois tarikh = mula',0),(216641,6018,'ar','ØªØ¨ÙŠÙ† Ø§Ù„ÙØªØ±Ø©: ÙØ§ØªÙˆØ±Ø© ØªØ§Ø±ÙŠØ® = Ø§Ø¨Ø¯Ø£',0),(216642,6018,'fr','Voir la pÃ©riode : Date de la facture = Start',0),(216643,6018,'jp','è¡¨ç¤ºç¯„å›²ï¼šæœŸé–“é–‹å§‹ï¼?è«‹æ±‚æ—¥',0),(216644,6018,'pt','PerÃ­odo: Fatura data = Start',0),(216645,6018,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿ÐµÑ€Ð¸Ð¾Ð´: Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð”Ð°Ñ‚Ð° = Ð½Ð°Ñ‡Ð°Ð»Ð¾',0),(216646,6018,'es','Desplegar Cobertura: Fecha de Comienza de PerÃ­odo de la Factura',0),(216647,6018,'de','Ausstellungszeit: Rechnungsdatum = Start',0),(216648,6018,'en','Show Period: Invoice Date = Start',0),(216649,6019,'is','',0),(216650,6019,'dr','( Ø´Ù…ÙˆÙ„ ) Ø±Ø§ Ù†Ù…Ø§ÙŠØ´ Ù†Ø¯Ù‡ÙŠØ¯ ',0),(216651,6019,'pr','Ø¯ÙˆØ±Ù‡ Ù¾ÙˆØ´Ø´( Ø´Ù…ÙˆÙ„ ) Ø±Ø§ Ù†Ù…Ø§ÙŠØ´ Ù†Ø¯Ù‡ÙŠØ¯ ',0),(216652,6019,'tr','DÃ¶nem gÃ¶sterme',0),(216653,6019,'pl','Nie pokazuj okres',0),(216654,6019,'bg','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(216655,6019,'ur','Ø¯ÙˆØ± Ù…Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(216656,6019,'sr','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·ÑƒÑ˜ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(216657,6019,'vi','Äá»«ng hiá»ƒn thá»‹ pháº¡m vi thá»i ká»³',0),(216658,6019,'af','Moenie dekkingsperiode wys ',0),(216659,6019,'ro','Nu aratÄƒ perioada',0),(216660,6019,'et','Ã„ra kuva perioodi',0),(216661,6019,'si','Ne PrikaÅ¾i obdobje',0),(216662,6019,'ba','Tidak menunjukkan periode',0),(216663,6019,'nl','Periode niet weergeven',0),(216664,6019,'fi','Ã„lÃ¤ NÃ¤ytÃ¤ aika',0),(216665,6019,'no','Ikke Vis periode',0),(216666,6019,'da','Vis ikke periode',0),(216667,6019,'ko','ê¸°ê°„ì„ í‘œì‹œ í•˜ì§€ ì•ŠìŒ',0),(216668,6019,'he','×œ× ×œ×”×¦×™×’ ×ª×§×•×¤×”',0),(216669,6019,'el','Î”ÎµÎ½ Î´ÎµÎ¯Ï‡Î½Î¿Ï…Î½ Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(216670,6019,'zh','ä¿é™©æœŸå†…ä¸æ˜¾ç¤º\r\n',0),(216671,6019,'sv','Visa inte perioden',0),(216672,6019,'it','Non mostrare il periodo',0),(216673,6019,'tl','',0),(216674,6019,'th','&#3629;&#3618;&#3656;&#3634;&#3649;&#3626;&#3604;&#3591;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3588;&#3621;&#3629;&#3610;&#3588;&#3621;&#3640;&#3617;',0),(216675,6019,'hi','à¤…à¤µà¤§à¤¿ à¤¨ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(216676,6019,'ms','Jangan tunjuk tempoh',0),(216677,6019,'ar','Ù„Ø§ ØªØ¸Ù‡Ø± ÙÙŠ Ø§Ù„ÙØªØ±Ø©',0),(216678,6019,'fr','Ne pas afficher la pÃ©riode',0),(216679,6019,'jp','å¯¾è±¡æœŸé–“ã‚’è¡¨ç¤ºã?—ã?ªã?„',0),(216680,6019,'pt','NÃ£o mostrar perÃ­odo',0),(216681,6019,'ru','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(216682,6019,'es','No Desplegar PerÃ­odo de Cobertura',0),(216683,6019,'de','Zeigen Sie Zeitraum nicht',0),(216684,6019,'en','Don\'t Show Period',0),(216685,6020,'is','',0),(216686,6020,'dr','(Ù¾ÙˆØ´Ø´) Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(216687,6020,'pr','Ø¯ÙˆØ±Ù‡ Ø¨Ø±Ø±Ø³ÙŠ(Ù¾ÙˆØ´Ø´) Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(216688,6020,'tr','KarÅŸÄ±lama dÃ¶nemi dahil',0),(216689,6020,'pl','ObejmujÄ… okres zapotrzebowania',0),(216690,6020,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(216691,6020,'ur','Ú©ÙˆØ±ÛŒØ¬ Ú©Û’ Ø¯ÙˆØ± Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(216692,6020,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ Ð¿Ð¾ÐºÑ€Ð¸Ð²ÐµÐ½Ð¾ÑÑ‚ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(216693,6020,'vi','Bao gá»“m trong pháº¡m vi thá»i ká»³ ',0),(216694,6020,'af','Sluit gedekte Periode in',0),(216695,6020,'ro','Include o perioadÄƒ de acoperire',0),(216696,6020,'et','Lisada laovarude periood',0),(216697,6020,'si','VkljuÄuje pokritost obdobje',0),(216698,6020,'ba','Termasuk masa pertanggungan',0),(216699,6020,'nl','Dekkingsperiode bevatten',0),(216700,6020,'fi','Kattavuus, jona',0),(216701,6020,'no','Inkluder dekningsperioden',0),(216702,6020,'da','Omfatte Disponeringsperioden',0),(216703,6020,'ko','ë³´í—˜ ê¸°ê°„ì„ í¬í•¨',0),(216704,6020,'he','×œ×›×œ×•×œ ×ª×§×•×¤×ª ×¢×™×ª×•×“',0),(216705,6020,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Ï€ÎµÏÎ¯Î¿Î´Î¿ ÎºÎ¬Î»Ï…ÏˆÎ·',0),(216706,6020,'zh','åŒ…æ‹¬ï¼šä¿é™©æœŸå†…\r\n',0),(216707,6020,'sv','Inkludera Disponeringsperioden',0),(216708,6020,'it','Includere il periodo di copertura',0),(216709,6020,'tl','',0),(216710,6020,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3588;&#3640;&#3657;&#3617;&#3588;&#3619;&#3629;&#3591;',0),(216711,6020,'hi','à¤•à¤µà¤°à¥‡à¤œ à¤…à¤µà¤§à¤¿ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(216712,6020,'ms','Termasuk tempoh perlindungan',0),(216713,6020,'ar','ÙˆØªØ´Ù…Ù„ ÙØªØ±Ø© Ø§Ù„ØªØºØ·ÙŠØ©',0),(216714,6020,'fr','Inclure la pÃ©riode de couverture',0),(216715,6020,'jp','å¯¾è±¡æœŸé–“ã‚’å?«ã‚€',0),(216716,6020,'pt','Incluir o perÃ­odo de cobertura',0),(216717,6020,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð¿Ð¾ÐºÑ€Ñ‹Ñ‚Ð¸Ñ',0),(216718,6020,'es','Incluir PerÃ­odo de Cobertura',0),(216719,6020,'de','Enthalten Sammelbedarfsintervall',0),(216720,6020,'en','Include Coverage Period',0),(216721,6021,'is','',0),(216722,6021,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯ÙˆØ±Ù‡ ØªØ­Øª Ù¾ÙˆØ´Ø´',0),(216723,6021,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯ÙˆØ±Ù‡ ØªØ­Øª Ù¾ÙˆØ´Ø´',0),(216724,6021,'tr','KarÅŸÄ±lama dÃ¶nemi gÃ¶ster',0),(216725,6021,'pl','PokaÅ¼ zasiÄ™g okres',0),(216726,6021,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(216727,6021,'ur','Ú©ÙˆØ±ÛŒØ¬ Ø¯ÙˆØ± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(216728,6021,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾ÐºÑ€Ð¸Ð²ÐµÐ½Ð¾ÑÑ‚ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(216729,6021,'vi','Hiá»ƒn thá»‹ thá»i ká»³ bao gá»“m',0),(216730,6021,'af','Wys Dekkingsperiode',0),(216731,6021,'ro','Perioada de acoperire AratÄƒ',0),(216732,6021,'et','Kuvatakse laovarude periood',0),(216733,6021,'si','PrikaÅ¾i obdobje kritja',0),(216734,6021,'ba','Masa pertanggungan Tampilkan',0),(216735,6021,'nl','Toon dekkingsperiode',0),(216736,6021,'fi','NÃ¤ytÃ¤ Kattavuuskausi',0),(216737,6021,'no','Vis dekningsperioden',0),(216738,6021,'da','Vis Disponeringsperioden',0),(216739,6021,'ko','ë³´ê¸° ë³´í—˜ ê¸°ê°„',0),(216740,6021,'he','×”×¦×’ ××ª ×ª×§×•×¤×ª ×¢×™×ª×•×“',0),(216741,6021,'el','ÎšÎ¬Î»Ï…ÏˆÎ· Ï€ÎµÏÎ¯Î¿Î´Î¿ Î´ÎµÎ¯Ï‡Î½Î¿Ï…Î½',0),(216742,6021,'zh','æ˜¾ç¤ºæ¶µç›–æœŸ\r\n',0),(216743,6021,'sv','Visa Disponeringsperioden',0),(216744,6021,'it','Visualizza il periodo di copertura',0),(216745,6021,'tl','',0),(216746,6021,'th','&#3649;&#3626;&#3604;&#3591;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3588;&#3619;&#3629;&#3610;&#3588;&#3621;&#3640;&#3617;',0),(216747,6021,'hi','à¤¶à¥‹ à¤•à¤µà¤°à¥‡à¤œ à¤…à¤µà¤§à¤¿',0),(216748,6021,'ms','Menunjukkan tempoh perlindungan',0),(216749,6021,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙØªØ±Ø© Ø§Ù„ØªØºØ·ÙŠØ©',0),(216750,6021,'fr','Voir la pÃ©riode de couverture',0),(216751,6021,'jp','å¯¾è±¡æœŸé–“ã‚’è¡¨ç¤º',0),(216752,6021,'pt','PerÃ­odo de cobertura do programa',0),(216753,6021,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐŸÐµÑ€Ð¸Ð¾Ð´ ÐŸÐ¾ÐºÑ€Ñ‹Ñ‚Ð¸Ñ',0),(216754,6021,'es','Mostrar PerÃ­odo de Cobertura',0),(216755,6021,'de','Abdeckung Ausstellungszeit',0),(216756,6021,'en','Show Coverage Period',0),(216757,6022,'is','',0),(216758,6022,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(216759,6022,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(216760,6022,'tr','-Fatura Ã¶demeleri dahil',0),(216761,6022,'pl','ObejmujÄ… pÅ‚atnoÅ›ci na fakturze',0),(216762,6022,'bg','-Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÐµÐ»Ð½Ð¾',0),(216763,6022,'ur','ØºÛŒØ± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”',0),(216764,6022,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ ÐºÐ¾Ñ˜Ðµ Ð½Ð¸ÑÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(216765,6022,'vi','Bao gá»“m thanh toÃ¡n khÃ´ng hÃ³a Ä‘Æ¡n',0),(216766,6022,'af','Sluit nie-faktuur betalings',0),(216767,6022,'ro','Includ Non-factura plÄƒÅ£i',0),(216768,6022,'et','Kaasata arve maksed',0),(216769,6022,'si','VkljuÄujejo plaÄila brez raÄuna',0),(216770,6022,'ba','Termasuk bebas-faktur pembayaran',0),(216771,6022,'nl','Niet-factuur betalingen omvatten',0),(216772,6022,'fi','SisÃ¤llyttÃ¤Ã¤ laskun maksut',0),(216773,6022,'no','Inkludere ikke-faktura betalinger',0),(216774,6022,'da','Omfatte ikke-fakturabetalinger',0),(216775,6022,'ko','ë¹„ ì²­êµ¬ì„œ ì§€ë¶ˆì„ í¬í•¨',0),(216776,6022,'he','×›×•×œ×œ ×ª×©×œ×•×ž×™× ×œ×œ× ×—×©×‘×•× ×™×ª',0),(216777,6022,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î¼Î·-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(216778,6022,'zh','åŒ…æ‹¬éžå‘ç¥¨ä»˜æ¬¾\r\n',0),(216779,6022,'sv','Inkludera icke-faktura betalningar',0),(216780,6022,'it','Includere i pagamenti Non-fattura',0),(216781,6022,'tl','',0),(216782,6022,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3',0),(216783,6022,'hi','à¤—à¥ˆà¤°-à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(216784,6022,'ms','Termasuk bayaran invois',0),(216785,6022,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª ØºÙŠØ± Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(216786,6022,'fr','Les paiements de facture Non',0),(216787,6022,'jp','è«‹æ±‚æ›¸ã?ªã?—æ”¯æ‰•ã‚’å?«ã‚€',0),(216788,6022,'pt','Incluir pagamentos de fatura nÃ£o',0),(216789,6022,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€Ð° ÑÑ‡ÐµÑ‚Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(216790,6022,'es','Incluir Pagos No Facturados',0),(216791,6022,'de','Sind nicht-Rechnung Zahlungen',0),(216792,6022,'en','Include Non-Invoice Payments',0),(216793,6023,'is','',0),(216794,6023,'dr','-Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† ØªØ¹Ø¯ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯Ù‰',0),(216795,6023,'pr','Ø§ØµÙ„Ø§Ø­ Ú†Ùƒ Ø³ÙÙŠØ¯-Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† ØªØ¹Ø¯ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯Ù‰',0),(216796,6023,'tr','BoÅŸ stok dÃ¼zeltmesi',0),(216797,6023,'pl','Puste korekty zapasÃ³w',0),(216798,6023,'bg','ÐŸÑ€Ð°Ð·ÐµÐ½ ÑÐºÐ»Ð°Ð´ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ',0),(216799,6023,'ur','Ø®Ø§Ù„ÛŒ Ø§Ø³Ù¹Ø§Ú© Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(216800,6023,'sr','ÐŸÑ€Ð°Ð·Ð°Ð½ Ð´ÐµÐ¾Ð½Ð¸Ñ†Ð° ÐºÐ¾Ñ€ÐµÐºÑ‚Ð¸Ð²Ð½Ð¾Ð¼',0),(216801,6023,'vi','Chá»‰nh sá»­a hÃ ng SÃ©c tá»“n ',0),(216802,6023,'af','Skoon Voorraad Aansuiwering',0),(216803,6023,'ro','Ajustare stoc gol',0),(216804,6023,'et','TÃ¼hi laoseisu korrigeerimine',0),(216805,6023,'si','Prazno zalog prilagoditev',0),(216806,6023,'ba','Penyesuaian saham kosong',0),(216807,6023,'nl','Lege voorraad aanpassing',0),(216808,6023,'fi','TyhjÃ¤ varaston oikaisu',0),(216809,6023,'no','Tomt lager justering',0),(216810,6023,'da','Tom Stock justering',0),(216811,6023,'ko','ë¹ˆ ìž¬ê³  ì¡°ì •',0),(216812,6023,'he','×”×ª××ž×ª ×ž×œ××™ ×¨×™×§',0),(216813,6023,'el','ÎšÎµÎ½ÏŒ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(216814,6023,'zh','åº“å­˜è°ƒæ•´ç©ºç™½\r\n',0),(216815,6023,'sv','Tomt lager justering',0),(216816,6023,'it','Regolazione magazzino vuoto',0),(216817,6023,'tl','',0),(216818,6023,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3651;&#3609;&#3619;&#3657;&#3634;&#3609;&#3607;&#3637;&#3656;&#3623;&#3656;&#3634;&#3591;',0),(216819,6023,'hi','à¤°à¤¿à¤•à¥à¤¤ à¤¶à¥‡à¤¯à¤° à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(216820,6023,'ms','Pelarasan stok yang kosong',0),(216821,6023,'ar','ØªØ³ÙˆÙŠØ© Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ÙØ§Ø±Øº',0),(216822,6023,'fr','Ajustement de Stock vierge',0),(216823,6023,'jp','ç™½åœ°æ ªå¼?èª¿æ•´',0),(216824,6023,'pt','Ajuste de estoque em branco',0),(216825,6023,'ru','ÐŸÑƒÑÑ‚Ð¾Ð¹ Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²ÐºÐ° ÑˆÑ‚Ð¾ÐºÐ°',0),(216826,6023,'es','Ajuste de Stock Blanco',0),(216827,6023,'de','Leere Lager Anpassung',0),(216828,6023,'en','Blank Stock Adjustment',0),(216829,6024,'is','',0),(216830,6024,'dr','Ù…ÙˆÙ‚Ø¹ÙŠØª Ù…ØªÙ† Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… Ú†Ø§Ù¾ Ø±ÙˆÙŠ Ú†Ùƒ Ø³ÙÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ  ØªØºÙŠÙŠØ±ÙƒÙ†Ø¯ â€“Ø§Ø² Ø§ÙŠÙ† Ø¯Ùˆ Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ù…ÙŠØ²Ø§Ù† ÙƒØ±Ø¯Ù†  Ù…Ù†Ø§Ø³Ø¨ Ø´Ù…Ø§Ø±Ù‡ Ù…Ø³ÙŠØ± ÙŠØ§Ø¨ÙŠ Ø¨Ø§ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø§Ø³ØªÙ',0),(216831,6024,'pr','Ù…ÙˆÙ‚Ø¹ÙŠØª Ù…ØªÙ† Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… Ú†Ø§Ù¾ Ø±ÙˆÙŠ Ú†Ùƒ Ø³ÙÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ  ØªØºÙŠÙŠØ±ÙƒÙ†Ø¯ â€“Ø§Ø² Ø§ÙŠÙ† Ø¯Ùˆ Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ù…ÙŠØ²Ø§Ù† ÙƒØ±Ø¯Ù†  Ù…Ù†Ø§Ø³Ø¨ Ø´Ù…Ø§Ø±Ù‡ Ù…Ø³ÙŠØ± ÙŠØ§Ø¨ÙŠ Ø¨Ø§ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø§Ø³ØªÙ',0),(216832,6024,'tr','Metin konumlandÄ±rma aÃ§Ä±k Ã§ek stok Ã¼zerinde yazdÄ±rma sÄ±rasÄ±nda deÄŸiÅŸebilir.<br>Bu iki deÄŸer dÃ¼zgÃ¼n hizalamak iÃ§in kullanÄ±n.<br>alan ile yÃ¶nlendirme numarasÄ± simge gÃ¶sterdi<br>boÅŸ hisse senedi Ã¼zerinde.',0),(216833,6024,'pl','Tekstem pozycjonowania mogÄ… siÄ™ rÃ³Å¼niÄ‡ w przypadku drukowania na puste pole wyboru czas.<br>UÅ¼yj tych dwÃ³ch wartoÅ›ci do wÅ‚aÅ›ciwego dostosowania<br>routingu numer symbolu z obszaru wskazanego<br>na czas puste.',0),(216834,6024,'bg','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ð¾Ð½Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐºÑÑ‚ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð²Ð°Ñ€Ð¸Ñ€Ð°Ñ‚ Ð¿Ñ€Ð¸ Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð°Ð·ÐµÐ½ Ñ‡ÐµÐº ÑÑŠÑÑ‚Ð°Ð².<br>Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ‚ÐµÐ·Ð¸ Ð´Ð²Ðµ ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð²Ð½ÑÐ²Ð°Ð½Ðµ<br>Ð',0),(216835,6024,'ur','Ù¾ÙˆØ²ÛŒØ´Ù† Ù…ØªÙ† Ø®Ø§Ù„ÛŒ Ú†ÛŒÚ© Ø§Ø³Ù¹Ø§Ú© Ù¾Ø± Ú†Ú¾Ø§Ù¾ØªÛ’ ÛÙˆØ¦Û’ Ù…Ø®ØªÙ„Ù ÛÙˆ Ø³Ú©ØªÛ’ ÛÛŒÚº Û”<br>Ø§Ù† Ø¯Ùˆ Ø§Ù‚Ø¯Ø§Ø± Ù…Ù†Ø§Ø³Ø¨ Ø³ÛŒØ¯Ú¾ Ù…ÛŒÚº Ù„Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº<br>Ø±ÙˆÙ¹ Ù†Ù…Ø¨Ø± Ø¹Ù„Ø§Ù…Øª Ú©Û’ Ø¹Ù„Ø§Ù‚Û’ Ú©Û’',0),(216836,6024,'sr','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ð¾Ð½Ð¸Ñ€Ð°ÑšÐµ Ñ‚ÐµÐºÑÑ‚Ð° Ð¼Ð¾Ð³Ñƒ Ð´Ð° ÑÐµ Ñ€Ð°Ð·Ð»Ð¸ÐºÑƒÑ˜Ñƒ ÐºÐ°Ð´Ð° ÑÐµ ÑˆÑ‚Ð°Ð¼Ð¿Ð° Ð½Ð° Ð»Ð°Ð³ÐµÑ€Ñƒ Ð‘Ð»Ð°Ð½ÐºÐ¾ Ñ‡ÐµÐº.<br>ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¾Ð²Ðµ Ð´Ð²Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¾ Ð¿Ð¾Ñ€Ð°Ð²Ð½Ð°Ð²Ð°ÑšÐµ Ð½Ð°<br>Ð±Ñ',0),(216837,6024,'vi','Vá»‹ trÃ­ chá»¯ cÃ³ thá»ƒ khÃ¡c biá»‡t khi in trÃªn SÃ©c trá»‘ng. DÃ¹ng hai giÃ¡ trá»‹ nÃ y Ä‘á»ƒ cÃ¢n Ä‘á»‘i biá»ƒu tÆ°á»£ng sá»‘ trÃªn khu vá»±c Ä‘á»‹nh sáºµn trÃªn sÃ©c tráº¯ng.',0),(216838,6024,'af','Teks posisionering kan wissel wanneer druk op leÃ« merkblokkie voorraad.<br>Hierdie twee waardes gebruik om behoorlik te rig die<br>routing nommer simbool met die gebied aangedui<br>op die leÃ« voorraad.',0),(216839,6024,'ro','Textul de poziÅ£ionare pot varia la imprimarea pe stoc cec Ã®n alb.<br>UtilizaÅ£i aceste douÄƒ valori pentru a alinia corect<br>rutare simbol numÄƒrul cu zona indicate<br>pe stoc gol.',0),(216840,6024,'et','Teksti paigutus varieerub tÃ¼hje Stock printimisel.<br>Kasutada nende kahe vÃ¤Ã¤rtuse Ãµigesti joondada ka<br>Marsruudi numbrimÃ¤rki jÃ¤Ã¤ksid mÃ¤rgitud<br>tÃ¼hi Stock.',0),(216841,6024,'si','Besedilo pozicioniranje razlikujejo pri tiskanju na prazen preverjanje zaloge.<br>Uporaba teh dveh vrednosti ustrezno uskladiti z<br>usmerjanje Å¡tevilo simbol z obmoÄja navedeno<br>na prazno staleÅ¾.',0),(216842,6024,'ba','Teks positioning mungkin berbeda ketika mencetak cek kosong saham.<br>Menggunakan dua macam tipe ini untuk menyelaraskan dengan benar<br>menunjukkan simbol nomor routing dengan daerah<br>pada saham kosong.',0),(216843,6024,'nl','Positie van tekst kan variÃ«ren als u op selectievakje lege voorraad afdrukt.<br>Deze twee waarden gebruikt voor het correct uitlijnen de<br>Routering nummer symbool met het gebied aangegeven<br>op de lege voorraad.',0),(216844,6024,'fi','Tekstin sijoittaminen voi vaihdella valtakirjaa varastossa tulostettaessa.<br>NÃ¤iden kahden arvon avulla kohdistaa<br>reitityksen numero symboli alue osoittaa<br>tyhjÃ¤ varastossa.',0),(216845,6024,'no','Tekstplassering variere ved utskrift pÃ¥ tom lager.<br>Bruk disse to verdiene til riktig justere de<br>ruting tallsymbol med omrÃ¥det angitt<br>pÃ¥ tomt lager.',0),(216846,6024,'da','Tekst placering kan variere nÃ¥r du udskriver pÃ¥ blankocheck lager.<br>Brug disse to vÃ¦rdier til korrekt tilpasse de<br>routing nummer symbol pÃ¥ omrÃ¥det angivet<br>pÃ¥ Tom bÃ¸rsen.',0),(216847,6024,'ko','í…ìŠ¤íŠ¸ ìœ„ì¹˜ ë°±ì§€ ìˆ˜ í‘œ ì£¼ì‹ì— ì¸ì‡„ í•˜ëŠ” ê²½ìš° ë‹¤ë¥¼ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<br>ì´ ë‘ ê°’ì„ ì‚¬ìš© í•˜ ì—¬ ì œëŒ€ë¡œ ì •ë ¬ í•˜ëŠ”<br>ì§€ì—­ ê°€ì§„ ë¼ìš°íŒ… ë²ˆí˜¸ ê¸°í˜¸ í‘œì‹œ<br>ë¹ˆ ìž¬ê³ .',0),(216848,6024,'he','×ž×™×§×•× ×”×˜×§×¡×˜ ×¢×©×•×™ ×œ×”×©×ª× ×•×ª ×‘×¢×ª ×”×“×¤×¡×” ×¢×œ ×¦\'×§ ×¤×ª×•×ª ×ž× ×™×•×ª.<br>×œ×”×©×ª×ž×© ×©× ×™ ×¢×¨×›×™× ××œ×” ×›×“×™ ×œ×™×™×©×¨ ×›×”×œ×›×”<br>×¡×ž×œ ×ž×¡×¤×¨ × ×™×ª×•×‘ ×¢× ×”××–×•×¨ ×”×ž×¦×•×™×Ÿ<br>×¢×œ ×”×ž× ×™×” ×¨×™×§.',0),(216849,6024,'el','Î¤Î¿Ï€Î¿Î¸Î­Ï„Î·ÏƒÎ· ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î¹Î±Ï†Î­ÏÎµÎ¹ ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÎµ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î»ÎµÏ…ÎºÎ® ÎµÏ€Î¹Ï„Î±Î³Î®.<br>Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Î±Ï…Ï„Î­Ï‚ Ï„Î¹Ï‚ Î´ÏÎ¿ Ï„Î¹Î¼Î­Ï‚ Î½Î± ÎµÏ…Î¸Ï…Î³ÏÎ±Î¼Î¼Î¹ÏƒÏ„ÎµÎ¯ ',0),(216850,6024,'zh','å½“åœ¨ç©ºç™½æ”¯ç¥¨ä¸Šæ‰“å°æ—¶æ–‡æœ¬ä½ç½®å¯èƒ½å˜åŠ¨ã€‚ä½¿ç”¨æ­¤ä¸¤ä¸ªå€¼åœ¨ç©ºç™½ç¥¨æ®ä¸Šæ¥éšç€æŒ‡å®šåŒºåŸŸæ°å½“åœ°æŽ’åˆ—è·¯çº¿ç¼–å·æ ‡å¿—ã€‚',0),(216851,6024,'sv','Textplacering kan variera nÃ¤r du skriver ut pÃ¥ blank check lager.<br>AnvÃ¤nda dessa tvÃ¥ vÃ¤rden fÃ¶r att korrekt anpassa den<br>routing number symbol med omrÃ¥det anges<br>pÃ¥ tomt lager.',0),(216852,6024,'it','Posizionamento del testo puÃ² variare quando si stampa su blank check stock.<br>Utilizzare questi due valori per allineare correttamente il<br>routing simbolo di numero con l\'area indicata<br>in borsa vuota.',0),(216853,6024,'tl','',0),(216854,6024,'th','Text positioning may vary when printing on blank check stock.<br> Use these two values to properly align the<br> routing number symbol with the area indicated<br> on the blank stock.',0),(216855,6024,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤ªà¤¾à¤  à¤°à¤¿à¤•à¥à¤¤ à¤šà¥‡à¤• à¤¶à¥‡à¤¯à¤° à¤ªà¤° à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¤°à¤¤à¥‡ à¤¸à¤®à¤¯ à¤­à¤¿à¤¨à¥à¤¨ à¤¹à¥‹ à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤<br>à¤ à¥€à¤• à¤¸à¥‡ à¤¸à¤‚à¤°à¥‡à¤–à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¨ à¤¦à¥‹ à¤®',0),(216856,6024,'ms','Kedudukan teks mungkin berbeza-beza apabila percetakan stok cek kosong.<br>Gunakan kedua-dua nilai untuk menjajarkan dengan betul dalam<br>penghalaan simbol nombor dengan kawasan yang ditunjukkan<br>saham kosong.',0),(216857,6024,'ar','Ù‚Ø¯ ØªØ®ØªÙ„Ù Ø§Ù„Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ù†Øµ Ø¹Ù†Ø¯ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø¹Ù„Ù‰ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø´ÙŠÙƒØ§Ù‹ Ø¹Ù„Ù‰ Ø¨ÙŠØ§Ø¶.<br>Ø§Ø³ØªØ®Ø¯Ù… Ù‡Ø°Ù‡ Ø§Ù„Ù‚ÙŠÙ… Ø§Ø«Ù†ÙŠÙ† Ù„Ù…Ø­Ø§Ø°Ø§Ø© Ø¨Ø´ÙƒÙ„ ØµØ­ÙŠØ­<br>ÙˆØ£Ø´Ø§Ø±Øª Ø¥Ù„Ù‰ Ø§Ù„Ø±Ù…Ø² Ø±Ù‚Ù… Ø§Ù„ØªÙˆØ',0),(216858,6024,'fr','Positionnement du texte peut varier lors de l\'impression sur le stock de chÃ¨que en blanc.<br>Utilisez ces deux valeurs pour aligner correctement les<br>routage symbole numÃ©ro avec la zone indiquÃ©e<br>sur le stock vierge.',0),(216859,6024,'jp','æœªè¨˜å…¥å°?åˆ‡æ‰‹å¸³ã?«å?°åˆ·ã?™ã‚‹éš›ã?¯æ–‡ç« ã?®é…?ç½®ã?Œå¤‰ã‚?ã‚‹ã?‹ã‚‚ã?—ã‚Œã?¾ã?›ã‚“ã€‚<br>æœªè¨˜å…¥å°?åˆ‡æ‰‹å¸³ã?®æŒ‡ç¤ºã?•ã‚Œã?Ÿå ´æ‰€ã?«ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå?·è¨˜å?·ã‚’é?©åˆ‡ã?«æ•´åˆ—ã?•ã?›ã‚‹ã?Ÿã‚?ã?“ã‚Œã‚‰ï¼’ã?¤ã?®å€¤ã‚’ä½¿ç”¨ã?—ã?¦ã??ã? ã?•ã?',0),(216860,6024,'pt','Posicionamento do texto pode variar quando imprimir em estoque de cheque em branco.<br>Use esses dois valores para alinhar corretamente o<br>sÃ­mbolo de nÃºmero roteamento com a Ã¡rea indicada<br>sobre o estoque em branco.',0),(216861,6024,'ru','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ‚ÐµÐºÑÑ‚Ð° Ð¼Ð¾Ð¶ÐµÑ‚ Ð¾Ñ‚Ð»Ð¸Ñ‡Ð°Ñ‚ÑŒÑÑ Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´Ðµ Ð‘Ð»Ð°Ð½Ñˆ.<br>Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ ÑÑ‚Ð¸ Ð´Ð²Ð° Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ð¾ ÑÐ¾Ð³Ð»Ð°ÑÐ¾Ð²Ð°Ñ‚ÑŒ<br>ÑƒÐºÐ°Ð·Ñ‹Ð²Ð',0),(216862,6024,'es','ColocaciÃ³n de texto puede variar cuando Imprime en Stock de Cheques en blanco.<br>Usa estos dos valores para propiamente alinear el<br>sÃ­mbolo de numero de routing con la Ã¡rea indicada<br>en el stock en blanco',0),(216863,6024,'de','Textpositionierung variieren, beim Drucken auf leere Lager.<br>Verwenden Sie diese zwei Werte richtig ausrichten der<br>Routing Number Symbol mit dem Bereich angegeben<br>auf das leere Lager.',0),(216864,6024,'en','Text positioning may vary when printing on blank check stock.<br> Use these two values to properly align the<br> routing number symbol with the area indicated<br> on the blank stock.',0),(216865,6025,'is','',0),(216866,6025,'dr','(X)',0),(216867,6025,'pr','ØªÙ†Ø¸ÙŠÙ… Ø§ÙÙ‚ÙŠ  (X)',0),(216868,6025,'tr','Yatay (X)',0),(216869,6025,'pl','Poziomej (X)',0),(216870,6025,'bg','Ð¥Ð¾Ñ€Ð¸Ð·Ð¾Ð½Ñ‚Ð°Ð»Ð½Ð°Ñ‚Ð° (X)',0),(216871,6025,'ur','Ø§ÙÙ‚ÛŒ (X)',0),(216872,6025,'sr','Ð¥Ð¾Ñ€Ð¸Ð·Ð¾Ð½Ñ‚Ð°Ð»Ð½Ðµ (X)',0),(216873,6025,'vi','Ngang (X)',0),(216874,6025,'af','Horisontaal (X)',0),(216875,6025,'ro','Orizontale (X)',0),(216876,6025,'et','Horisontaalteljel (X)',0),(216877,6025,'si','Vodoravno (X)',0),(216878,6025,'ba','Horisontal (X)',0),(216879,6025,'nl','Horizontale (X)',0),(216880,6025,'fi','Vaaka',0),(216881,6025,'no','Horisontal (X)',0),(216882,6025,'da','Vandrette (X)',0),(216883,6025,'ko','ê°€ë¡œ (X)',0),(216884,6025,'he','×”××•×¤×§×™ (X)',0),(216885,6025,'el','ÎŸÏÎ¹Î¶ÏŒÎ½Ï„Î¹Î± (X)',0),(216886,6025,'zh','æ°´å¹³ï¼ˆXï¼‰\r\n',0),(216887,6025,'sv','VÃ¥grÃ¤t (X)',0),(216888,6025,'it','Orizzontale (X)',0),(216889,6025,'tl','',0),(216890,6025,'th','&#3605;&#3634;&#3617;&#3649;&#3609;&#3623;&#3609;&#3629;&#3609; (&#3649;&#3585;&#3609; X)',0),(216891,6025,'hi','à¤•à¥à¤·à¥ˆà¤¤à¤¿à¤œ (X)',0),(216892,6025,'ms','Mendatar (X)',0),(216893,6025,'ar','Ø§Ù„Ø£ÙÙ‚ÙŠ (Ø³)',0),(216894,6025,'fr','Horizontal (X)',0),(216895,6025,'jp','æ¨ªåž‹(X)',0),(216896,6025,'pt','Horizontal (X)',0),(216897,6025,'ru','Ð“Ð¾Ñ€Ð¸Ð·Ð¾Ð½Ñ‚Ð°Ð»ÑŒÐ½Ð°Ñ (X)',0),(216898,6025,'es','Horizontal (X)',0),(216899,6025,'de','Horizontale (X)',0),(216900,6025,'en','Horizontal (X)',0),(216901,6026,'is','',0),(216902,6026,'dr','Ø¨Ø±Ø§ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ Ù…Ø³ØªÙ‚ÙŠÙ… Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(216903,6026,'pr','Ø¨Ø±Ø§ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ Ù…Ø³ØªÙ‚ÙŠÙ… Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(216904,6026,'tr','DoÄŸrudan Ã¶deme iÃ§in gerekli',0),(216905,6026,'pl','Wymagane do bezpoÅ›redniego zÅ‚oÅ¼enia',0),(216906,6026,'bg','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸ Ð·Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(216907,6026,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ú©Û’ Ù„Ø¦Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(216908,6026,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð·Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(216909,6026,'vi','YÃªu cáº§u thanh toÃ¡n trá»±c tiáº¿p',0),(216910,6026,'af','Benodig vir direkte deposito',0),(216911,6026,'ro','Necesare pentru direct de depozit',0),(216912,6026,'et','Vajalikud panga Ã¼lekanne',0),(216913,6026,'si','Zahteva za neposredno depozit',0),(216914,6026,'ba','Diperlukan untuk deposit langsung',0),(216915,6026,'nl','Vereist voor directe storting',0),(216916,6026,'fi','Suora talletus vaaditaan',0),(216917,6026,'no','Kreves for direkte innskudd',0),(216918,6026,'da','KrÃ¦ves for direkte indbetaling',0),(216919,6026,'ko','ì§ì ‘ ìž…ê¸ˆì— í•„ìš”í•œ',0),(216920,6026,'he','×”×“×¨×•×©×™× ×¢×‘×•×¨ ×”×¤×§×“×” ×™×©×™×¨×”',0),(216921,6026,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(216922,6026,'zh','æ‰€éœ€çš„ç›´æŽ¥å­˜æ¬¾\r\n',0),(216923,6026,'sv','KrÃ¤vs fÃ¶r direkt insÃ¤ttning',0),(216924,6026,'it','Necessaria per deposito diretto',0),(216925,6026,'tl','',0),(216926,6026,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3613;&#3634;&#3585;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(216927,6026,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(216928,6026,'ms','Diperlukan untuk deposit terus',0),(216929,6026,'ar','Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© Ù„Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(216930,6026,'fr','Requis pour le dÃ©pÃ´t direct',0),(216931,6026,'jp','å?£åº§æŒ¯è¾¼ã?«å¿…è¦?',0),(216932,6026,'pt','NecessÃ¡rios para depÃ³sito direto',0),(216933,6026,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ Ð¿Ñ€ÑÐ¼Ð¾Ð³Ð¾ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(216934,6026,'es','Requerido para depÃ³sito directo',0),(216935,6026,'de','FÃ¼r direkte Einzahlung erforderlich',0),(216936,6026,'en','Required for direct deposit',0),(216937,6027,'is','',0),(216938,6027,'dr','(Y)',0),(216939,6027,'pr','ØªÙ†Ø¸ÙŠÙ… Ø¹Ù…ÙˆØ¯ÙŠ (Y)',0),(216940,6027,'tr','Dikey (Y)',0),(216941,6027,'pl','Pionowej (Y)',0),(216942,6027,'bg','Ð’ÐµÑ€Ñ‚Ð¸ÐºÐ°Ð»Ð½Ð¸ (Y)',0),(216943,6027,'ur','Ø¹Ù…ÙˆØ¯ÛŒ (Y)',0),(216944,6027,'sr','Ð’ÐµÑ€Ñ‚Ð¸ÐºÐ°Ð»Ð½Ð¸ (Y)',0),(216945,6027,'vi','Dá»c (Y)',0),(216946,6027,'af','Vertikaal (J)',0),(216947,6027,'ro','VerticalÄƒ (Y)',0),(216948,6027,'et','Vertikaalne (Y)',0),(216949,6027,'si','NavpiÄno (Y)',0),(216950,6027,'ba','Vertikal (Y)',0),(216951,6027,'nl','Verticale (Y)',0),(216952,6027,'fi','Pystysuora (Y)',0),(216953,6027,'no','Loddrett (Y)',0),(216954,6027,'da','Lodrette (Y)',0),(216955,6027,'ko','ì„¸ë¡œ (Y)',0),(216956,6027,'he','×”×× ×›×™ (Y)',0),(216957,6027,'el','ÎšÎ¬Î¸ÎµÏ„Î¿ (Y)',0),(216958,6027,'zh','åž‚ç›´ï¼ˆYï¼‰\r\n',0),(216959,6027,'sv','LodrÃ¤ta (Y)',0),(216960,6027,'it','Verticale (Y)',0),(216961,6027,'tl','',0),(216962,6027,'th','&#3649;&#3609;&#3623;&#3605;&#3633;&#3657;&#3591; (Y)',0),(216963,6027,'hi','à¤…à¤¨à¥à¤²à¤‚à¤¬ (Y)',0),(216964,6027,'ms','Menegak (Y)',0),(216965,6027,'ar','Ø§Ù„Ø±Ø£Ø³ÙŠ (Y)',0),(216966,6027,'fr','Verticale (Y)',0),(216967,6027,'jp','ç¸¦åž‹(Y)',0),(216968,6027,'pt','Vertical (Y)',0),(216969,6027,'ru','Ð’ÐµÑ€Ñ‚Ð¸ÐºÐ°Ð»ÑŒÐ½Ð¾Ð¹ (Y)',0),(216970,6027,'es','Vertical (Y)',0),(216971,6027,'de','Vertikale (Y)',0),(216972,6027,'en','Vertical (Y)',0),(216973,6028,'is','',0),(216974,6028,'dr','72/1  ÙŠÙƒ Ø§ÙŠÙ†Ú† Ù‡Ø³ØªÙ†Ø¯-Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø«Ø§Ù„ : Ø¨Ø±Ø§ÙŠ Ø­Ø±ÙƒØª Ù†Ø³Ø®Ù‡ Ú†Ø§Ù¾ÙŠ Ø¨Ù‡ Ø±Ø§Ø³Øª  Ù¾Ø§ÙŠÙŠÙ† Ø¨Ø§ ÙŠÙƒ Ú†Ù‡Ø§Ø±Ù… Ø§ÙŠÙ†Ú† Ø¹Ø¯Ø¯ Ø¨Ø±Ø§ÙŠ Ø­Ø§Ù„Øª Ø§ÙÙ‚ÙŠ 18 Ø±Ø§ Ú†Ø§Ù¾ ÙƒÙ†ÙŠØ¯ Ùˆ Ø¨Ø±Ø§ÙŠ Ø­Ø§Ù„Øª Ø¹Ù…ÙˆØ¯ÙŠ Ø¹',0),(216975,6028,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ 72/1  ÙŠÙƒ Ø§ÙŠÙ†Ú† Ù‡Ø³ØªÙ†Ø¯-Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø«Ø§Ù„ : Ø¨Ø±Ø§ÙŠ Ø­Ø±ÙƒØª Ù†Ø³Ø®Ù‡ Ú†Ø§Ù¾ÙŠ Ø¨Ù‡ Ø±Ø§Ø³Øª  Ù¾Ø§ÙŠÙŠÙ† Ø¨Ø§ ÙŠÙƒ Ú†Ù‡Ø§Ø±Ù… Ø§ÙŠÙ†Ú† Ø¹Ø¯Ø¯ Ø¨Ø±Ø§ÙŠ Ø­Ø§Ù„Øª Ø§ÙÙ‚ÙŠ 18 Ø±Ø§ Ú†Ø§Ù¾ ÙƒÙ†ÙŠØ¯ Ùˆ Ø¨Ø±Ø§ÙŠ Ø­Ø§Ù„Øª Ø¹Ù…ÙˆØ¯ÙŠ Ø¹',0),(216976,6028,'tr','1/72 inÃ§ birimleridir.<br>Ã–rneÄŸin, yazÄ±cÄ± Ã§Ä±ktÄ±sÄ± taÅŸÄ±mak iÃ§in<br>ve aÅŸaÄŸÄ± bir Ã§eyrek inÃ§ tarafÄ±ndan 18 girin.<br>yatay ve dikey iÃ§in -18.',0),(216977,6028,'pl','Jednostki sÄ… 1/72 cala.<br>Na przykÅ‚ad, aby przenieÅ›Ä‡ wydruk w prawo<br>i dÃ³Å‚ przez Ä‡wierÄ‡ cala wchodzi 18<br>poziomy i -18 w pionie.',0),(216978,6028,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð¸ ÑÐ° 1/72 Ð¾Ñ‚ Ð¸Ð½Ñ‡Ð°.<br>Ð—Ð° Ð¿Ñ€Ð¸Ð¼ÐµÑ€, Ð·Ð° Ð´Ð° Ð¿Ñ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ð¿ÐµÑ‡Ð°Ñ‚ÐºÐ° Ð½Ð° Ð´ÑÑÐ½Ð¾<br>Ð¸ Ð½Ð°Ð´Ð¾Ð»Ñƒ Ð¾Ñ‚ ÐµÐ´Ð½Ð° Ñ‡ÐµÑ‚Ð²ÑŠÑ€Ñ‚ Ð¸Ð½Ñ‡ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ 18<br>Ð·Ð° Ñ…Ð¾Ñ€Ð¸Ð·Ð¾Ð½Ñ‚Ð°Ð»Ð½Ð° Ð¸ -18 Ð·Ð° Ð²ÐµÑ',0),(216979,6028,'ur','ÛŒÙˆÙ†Ù¹ 1/72 Ø§ÛŒÚ© Ø§Ù†Ú† ÛÛ’ Û”<br>Ù¾Ø±Ù†Ù¹ Ú©Ø±Ù†Û’ Ú©Ø§ Ø­Ù‚ Ù…Ù†ØªÙ‚Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…Ø«Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ØŒ<br>Ø§ÙˆØ± Ù†ÛŒÚ†Û’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§ÛŒÚ© Ú†ÙˆØªÚ¾Ø§Ø¦ÛŒ Ø§Ù†Ú† 18 Ø¯Ø§Ø®Ù„ Û”<br>Ø§ÙÙ‚ÛŒ Ø§ÙˆØ± Ø¹Ù…ÙˆØ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ -18 Ú©Û’ Ù„',0),(216980,6028,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ ÑÑƒ 1/72 Ð¸Ð½Ñ‡Ð°.<br>ÐÐ° Ð¿Ñ€Ð¸Ð¼ÐµÑ€, Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€ÐµÐ¼ÐµÑÑ‚Ð¸Ð»Ð¸ Ð¾Ñ‚Ð¸ÑÐºÐ° Ð´ÐµÑÐ½Ðµ<br>Ð° Ð´Ð¾Ð»Ðµ Ð¿Ð¾ ÑÐ°Ð½Ñ‚Ð¸Ð¼ÐµÑ‚Ð°Ñ€ ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ 18<br>Ð·Ð° Ñ…Ð¾Ñ€Ð¸Ð·Ð¾Ð½Ñ‚Ð°Ð»Ð½Ñƒ Ð¸ -18 Ð²ÐµÑ€Ñ‚Ð¸ÐºÐ°Ð»Ð½Ð¾.',0),(216981,6028,'vi','ÄÆ¡n vá»‹ lÃ  1/72 cá»§a 1 inch. VÃ­ dá»¥, Ä‘á»ƒ Ä‘Æ°a chá»¯  sang pháº£i  vÃ  xuá»‘ng 1/4 inch nháº­p 18 ngang & -18 dá»c.',0),(216982,6028,'af','Eenhede is 1/72 van \'n duim.<br>Byvoorbeeld, uitdruk na regs skuif<br>en af deur \'n kwart duim tik 18<br>vir horisontaal en vertikaal vir-18.',0),(216983,6028,'ro','UnitÄƒÅ£ile sunt 1/72 dintr-un inch.<br>De exemplu, pentru a muta imagine imprimatÄƒ la dreapta<br>ÅŸi Ã®n jos de un sfert de inch intra 18<br>orizontalÄƒ ÅŸi-18 pentru verticale.',0),(216984,6028,'et','Ãœksused on 1/72 tolli.<br>NÃ¤iteks vÃ¤ljatrÃ¼kk liikuda paremale<br>ja alla veerand tolli sisestada 18<br>horisontaalne ja vertikaalne -18.',0),(216985,6028,'si','Enote so 1/72 inÄa.<br>Na primer, premikanje izpisa na desno<br>in dol po Äetrtino palÄni enter 18<br>za horizontalni in -18 za navpiÄno.',0),(216986,6028,'ba','Unit yang 1/72 inci.<br>Misalnya, untuk memindahkan cetakan ke kanan<br>dan turun oleh seperempat inci masukkan 18<br>horisontal dan vertikal -18.',0),(216987,6028,'nl','Eenheden zijn 1/72 inch.<br>Om bijvoorbeeld te afdruk naar rechts verplaatsen<br>en naar beneden door een kwart inch Voer 18<br>voor horizontaal en -18 voor verticaal.',0),(216988,6028,'fi','YksikÃ¶t ovat 1/72 tuumaa.<br>Voit esimerkiksi siirtÃ¤Ã¤ tulosteen oikealle<br>ja alas neljÃ¤sosa tuuman Kirjoita 18<br>vaaka-ja pystysuora-18.',0),(216989,6028,'no','Er 1/72 av en tomme.<br>For eksempel vil flytte utskriften til hÃ¸yre<br>og ned av en kvart tommen inn 18<br>for horisontal og-18 for vertikal.',0),(216990,6028,'da','Enheder er 1/72 af en tomme.<br>For eksempel, at flytte udskrift til hÃ¸jre<br>og ned med en fjerdedel tomme indtaste 18<br>for vandret og â€“ 18 for lodret.',0),(216991,6028,'ko','ë‹¨ìœ„ëŠ” 1/72 ì¸ì¹˜ìž…ë‹ˆë‹¤.<br>ì˜ˆë¥¼ ë“¤ì–´, ì¸ì‡„ë¬¼ ì˜¤ë¥¸ìª½ìœ¼ë¡œ ì´ë™<br>4 ë¶„ì˜ 1 ì¸ì¹˜ì— ì˜í•´ ì•„ëž˜ 18ë¥¼ ìž…ë ¥<br>ê°€ë¡œ ë° ì„¸ë¡œ ëŒ€ í•œ-18.',0),(216992,6028,'he','×™×—×™×“×•×ª ×”× 1/72 ×¡ ×ž.<br>×œ×“×•×’×ž×”, ×›×“×™ ×œ×”×¢×‘×™×¨ ×¤×œ×˜ ×™×ž×™× ×”<br>×œ×ž×˜×” ×¢×œ ×™×“×™ ×¡× ×˜×™×ž×˜×¨ ×”×–×Ÿ 18<br>\' ××•×¤×§×™ \': ×ª×¨×›×™×–×™ ×¢×‘×•×¨ ×× ×›×™.',0),(216993,6028,'el','ÎœÎ¿Î½Î¬Î´ÎµÏ‚ ÎµÎ¯Î½Î±Î¹ 1/72 Ï„Î·Ï‚ Î¯Î½Ï„ÏƒÎ±Ï‚.<br>Î“Î¹Î± Ï€Î±ÏÎ¬Î´ÎµÎ¹Î³Î¼Î±, Î³Î¹Î± Î½Î± Î¼ÎµÏ„Î±ÎºÎ¹Î½Î®ÏƒÎµÏ„Îµ Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€ÏÎ¿Ï‚ Ï„Î± Î´ÎµÎ¾Î¹Î¬<br>ÎºÎ±Î¹ ÎºÎ¬Ï„Ï‰ Î±Ï€ÏŒ Ï„Î¿ Î­Î½Î± Ï„Î­Ï„Î±ÏÏ„Î¿ Î¯Î½Ï„ÏƒÎ± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ 18<b',0),(216994,6028,'zh','å•ä½æ˜¯1 / 72è‹±å¯¸ã€‚ä¾‹å¦‚ï¼Œç§»åŠ¨åˆ°æ­£ç¡®çš„æ‰“å°è¾“å‡ºå’Œå‡å°‘å››åˆ†ä¹‹ä¸€è¿›å…¥æ°´å¹³18è‹±å¯¸å’Œåž‚ç›´-18ã€‚\r\n',0),(216995,6028,'sv','Enheter Ã¤r 1/72 tum.<br>Till exempel fÃ¶r att flytta utskriften till hÃ¶ger<br>och ner med en fjÃ¤rdedel tum in 18<br>fÃ¶r horisontell och -18 fÃ¶r vertikal.',0),(216996,6028,'it','Le unitÃ  sono 1/72 di pollice.<br>Ad esempio, per spostare la stampa a destra<br>e giÃ¹ da un quarto pollice inserire 18<br>per orizzontale e -18 per verticale.',0),(216997,6028,'tl','',0),(216998,6028,'th','Units are 1/72 of an inch.<br> For example, to move printout to the right<br> and down by a quarter inch enter 18<br> for horizontal and -18 for vertical.',0),(216999,6028,'hi','1/72 à¤‡à¤‚à¤š à¤•à¤¾ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚à¥¤<br>à¤ªà¥à¤°à¤¿à¤‚à¤Ÿà¤†à¤‰à¤Ÿ à¤¸à¤¹à¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤¦à¤¾à¤¹à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤,<br>à¤”à¤°',0),(217000,6028,'ms','Unit adalah 1/72 inci.<br>Contohnya, untuk mengalih cetakan ke kanan<br>dan ke bawah oleh suku inci masukkan 18<br>-18 bagi menegak dan mendatar.',0),(217001,6028,'ar','ÙˆØªØ¹ØªØ¨Ø± Ø§Ù„ÙˆØ­Ø¯Ø§Øª 1/72 Ø¨ÙˆØµØ©.<br>Ø¹Ù„Ù‰ Ø³Ø¨ÙŠÙ„ Ø§Ù„Ù…Ø«Ø§Ù„ØŒ Ù„Ù†Ù‚Ù„ Ø§Ù„Ù†Ø³Ø®Ø© Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© Ø¥Ù„Ù‰ Ø§Ù„ÙŠÙ…ÙŠÙ†<br>ÙˆØ£Ø³ÙÙ„ Ø¨Ø±Ø¨Ø¹ Ø¨ÙˆØµØ© Ø£Ø¯Ø®Ù„ 18<br>Ù„-18 Ù„Ø¹Ù…ÙˆØ¯ÙŠ ÙˆØ£ÙÙ‚ÙŠ.',0),(217002,6028,'fr','Les unitÃ©s sont 1/72e de pouce.<br>Par exemple, pour dÃ©placer l\'impression vers la droite<br>et vers le bas par un quart de pouce entrez 18<br>pour horizontal et -18 Ã  la verticale.',0),(217003,6028,'jp','å?˜ä½?ã?¯ã‚¤ãƒ³ãƒ?ã?®ï¼—ï¼’åˆ†ã?®ï¼‘ã?§ã?™<br>ä¾‹ã?ˆã?°ã€?å?°åˆ·å‡ºåŠ›ã‚’å?³ã?¨ä¸‹ã?¸ï¼‘/ï¼”ã‚¤ãƒ³ãƒ?<br>ç§»å‹•ã?™ã‚‹ã?«ã?¯æ°´å¹³ã?«18<br>åž‚ç›´ã?«18ã?¨å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„ã€‚',0),(217004,6028,'pt','As unidades sÃ£o 1/72 de uma polegada.<br>Por exemplo, para mover a cÃ³pia impressa para a direita<br>e para baixo por um quarto de polegada entre 18<br>para horizontal e -18 para vertical.',0),(217005,6028,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ñ‹ ÑÐ²Ð»ÑÑŽÑ‚ÑÑ 1/72 Ð´ÑŽÐ¹Ð¼Ð°.<br>ÐÐ°Ð¿Ñ€Ð¸Ð¼ÐµÑ€, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿ÐµÑ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚ÑŒ Ñ€Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚ÐºÑƒ Ð²Ð¿Ñ€Ð°Ð²Ð¾<br>Ð¸ Ð²Ð½Ð¸Ð· Ð¿Ð¾ Ñ‡ÐµÑ‚Ð²ÐµÑ€Ñ‚Ð¸ Ð´ÑŽÐ¹Ð¼Ð° Ð²Ð²ÐµÑÑ‚Ð¸ 18<br>Ð´Ð»Ñ Ð³Ð¾Ñ€Ð¸Ð·Ð¾Ð½Ñ‚Ð°Ð»ÑŒÐ½Ñ‹Ñ… Ð¸ -18 Ð´Ð»Ñ ',0),(217006,6028,'es','Unidades son 1/72 de una pulgada<br> Por ejemplo, para mover la salida de la impresiÃ³n a la derecha<br> y abajo por un cuarto de pulgada entra 18<br> para horizontal y -18 para vertical.',0),(217007,6028,'de','Einheiten sind 1/72 Zoll.<br>Z. B. zum Ausdruck nach rechts zu verschieben<br>und geben Sie unten durch ein Viertel Zoll 18<br>fÃ¼r horizontale und fÃ¼r vertikale-18.',0),(217008,6028,'en','Units are 1/72 of an inch.<br> For example, to move printout to the right<br> and down by a quarter inch enter 18<br> for horizontal and -18 for vertical.',0),(217009,6029,'is','',0),(217010,6029,'dr','Ù†Ø§Ù…  Ùˆ Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø³Ù…Øª Ú†Ù¾  ',0),(217011,6029,'pr','Ù†Ø§Ù…  Ùˆ Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø³Ù…Øª Ú†Ù¾  ',0),(217012,6029,'tr','Åžirket adÄ± & adres sol tarafÄ±nda',0),(217013,6029,'pl','Nazwa firmy & adresowej po lewej stronie',0),(217014,6029,'bg','Ð¤Ð¸Ñ€Ð¼Ð° & Ð°Ð´Ñ€ÐµÑ Ð½Ð° Ð»ÑÐ²Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð°',0),(217015,6029,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… & Ø¨Ø§Ø¦ÛŒÚº Ø¬Ø§Ù†Ø¨ Ø¹Ù†ÙˆØ§Ù†',0),(217016,6029,'sr','Ð˜Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸ Ð°Ð´Ñ€ÐµÑÑƒ Ð½Ð° Ð»ÐµÐ²Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸',0),(217017,6029,'vi','TÃªn cty & Ä‘á»‹a chá»‰ bÃªn trÃ¡i',0),(217018,6029,'af','Ondernemingnaam & Adres op Linkerkant',0),(217019,6029,'ro','Numele companiei & adresa de pe partea stÃ¢ngÄƒ',0),(217020,6029,'et','EttevÃµtte nimi ja aadress vasakul pool',0),(217021,6029,'si','Ime podjetja & naslov na levi strani',0),(217022,6029,'ba','Nama perusahaan & alamat kiri',0),(217023,6029,'nl','Bedrijfsnaam & adres aan linkerzijde',0),(217024,6029,'fi','Yrityksen nimi & osoite vasemmalla puolella',0),(217025,6029,'no','Firmanavn & adresse pÃ¥ venstre Side',0),(217026,6029,'da','Firmanavn & adresse pÃ¥ venstre Side',0),(217027,6029,'ko','íšŒì‚¬ ì´ë¦„ & ì™¼ìª½ì— ì£¼ì†Œ',0),(217028,6029,'he','×©× ×”×—×‘×¨×” & ×›×ª×•×‘×ª ×‘×¦×“ ×©×ž××œ',0),(217029,6029,'el','Î¤Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ & Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· ÏƒÏ„Î·Î½ Î±ÏÎ¹ÏƒÏ„ÎµÏÎ® Ï€Î»ÎµÏ…ÏÎ¬',0),(217030,6029,'zh','å…¬å¸åç§°åŠåœ°å€åœ¨å·¦ä¾§\r\n',0),(217031,6029,'sv','FÃ¶retagets namn & adress pÃ¥ vÃ¤nster sida',0),(217032,6029,'it','Nome della societÃ  & indirizzo sul lato sinistro',0),(217033,6029,'tl','',0),(217034,6029,'th','&#3594;&#3639;&#3656;&#3629;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3649;&#3621;&#3632;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3610;&#3609;&#3604;&#3657;&#3634;&#3609;&#3595;&#3657;&#3634;&#3618;',0),(217035,6029,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® & à¤¬à¤¾à¤ˆà¤‚ à¤“à¤° à¤ªà¤° à¤ªà¤¤à¤¾',0),(217036,6029,'ms','Nama Syarikat & alamat di sebelah kiri',0),(217037,6029,'ar','Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø¢Ù†Ø¯ Ø§Ù„Ø¹Ù†ÙˆØ§Ù† Ø¹Ù„Ù‰ Ø§Ù„Ø¬Ø§Ù†Ø¨ Ø§Ù„Ø£ÙŠØ³Ø±',0),(217038,6029,'fr','Nom de la sociÃ©tÃ© & adresse cÃ´tÃ© gauche',0),(217039,6029,'jp','ä¼šç¤¾å??ã?¨ä½?æ‰€ã?¯å·¦å?´ã?«ã?‚ã‚Šã?¾ã?™',0),(217040,6029,'pt','Nome da empresa & endereÃ§o do lado esquerdo',0),(217041,6029,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ & Ð°Ð´Ñ€ÐµÑ Ð½Ð° Ð»ÐµÐ²Ð¾Ð¹ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ðµ',0),(217042,6029,'es','Nombre y DirecciÃ³n de la Empresa en el Lado Izquierdo',0),(217043,6029,'de','Firmenname & Adresse auf der linken Seite',0),(217044,6029,'en','Company Name & Address on Left Side',0),(217045,6030,'is','',0),(217046,6030,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(217047,6030,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(217048,6030,'tr','Geri<br>SipariÅŸ',0),(217049,6030,'pl','PowrÃ³t do<br>ZamÃ³wienie',0),(217050,6030,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÐºÑŠÐ¼<br>ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°',0),(217051,6030,'ur','Ù¾Ø´ØªØ§Ø±Û Ø¨Ù†Ø§Ø¦ÛŒÚº<br>ØªØ±ØªÛŒØ¨',0),(217052,6030,'sr','ÐÐ°Ð·Ð°Ð´ Ð½Ð°<br>Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´',0),(217053,6030,'vi','Quay Láº¡iÄÆ¡n Äáº·t HÃ ng',0),(217054,6030,'af','Terug na<br>Bestelling',0),(217055,6030,'ro','ÃŽnapoi la<br>Comanda',0),(217056,6030,'et','Tagasi<br>Tellimuse',0),(217057,6030,'si','Nazaj na<br>Vrstni red',0),(217058,6030,'ba','Kembali ke<br>Urutan',0),(217059,6030,'nl','Terug naar<br>Bestelling',0),(217060,6030,'fi','Takaisin<br>Tilaus',0),(217061,6030,'no','Tilbake til<br>RekkefÃ¸lge',0),(217062,6030,'da','Tilbage til<br>RÃ¦kkefÃ¸lge',0),(217063,6030,'ko','ë‹¤ì‹œ<br>ìˆœì„œ',0),(217064,6030,'he','×‘×—×–×¨×”<br>×¡×“×¨',0),(217065,6030,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î¿<br>Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(217066,6030,'zh','å›žåˆ°è®¢è´­\r\n',0),(217067,6030,'sv','Tillbaka till<br>Ordning',0),(217068,6030,'it','Torna all\'ordine',0),(217069,6030,'tl','',0),(217070,6030,'th','&#3585;&#3621;&#3633;&#3610;&#3652;&#3611;&#3607;&#3637;&#3656;<br>&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(217071,6030,'hi','à¤µà¤¾à¤ªà¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤<br>à¤†à¤¦à¥‡à¤¶',0),(217072,6030,'ms','Kembali ke<br>Perintah',0),(217073,6030,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰<br>ØªØ±ØªÙŠØ¨',0),(217074,6030,'fr','Retour Ã  la<br>Ordre',0),(217075,6030,'jp','æ³¨æ–‡ã?«æˆ»ã‚‹',0),(217076,6030,'pt','Volta para<br>Ordem',0),(217077,6030,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ Ð²<br>Ð—Ð°ÐºÐ°Ð·',0),(217078,6030,'es','AtrÃ¡s para<br>Odenar',0),(217079,6030,'de','ZurÃ¼ck zu<br>Bestellung',0),(217080,6030,'en','Back to<br>Order',0),(217081,6031,'is','',0),(217082,6031,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø¬Ø³ØªØ¬Ùˆ',0),(217083,6031,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø¬Ø³ØªØ¬Ùˆ',0),(217084,6031,'tr','Geri<br>Arama',0),(217085,6031,'pl','PowrÃ³t do<br>Szukaj',0),(217086,6031,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÐºÑŠÐ¼<br>Ð¢ÑŠÑ€ÑÐµÐ½Ðµ',0),(217087,6031,'ur','Ù¾Ø´ØªØ§Ø±Û Ø¨Ù†Ø§Ø¦ÛŒÚº<br>ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(217088,6031,'sr','ÐÐ°Ð·Ð°Ð´ Ð½Ð°<br>ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð³Ð°',0),(217089,6031,'vi','Quay láº¡i tá»›iTÃ¬m',0),(217090,6031,'af','Terug na<br>Soek',0),(217091,6031,'ro','ÃŽnapoi la<br>CÄƒutare',0),(217092,6031,'et','Tagasi<br>otsingusse',0),(217093,6031,'si','Nazaj na<br>IÅ¡Äi',0),(217094,6031,'ba','Kembali ke<br>Cari',0),(217095,6031,'nl','Terug naar<br>Zoeken',0),(217096,6031,'fi','Takaisin<br>Etsi',0),(217097,6031,'no','Tilbake til<br>SÃ¸k',0),(217098,6031,'da','Tilbage til<br>SÃ¸g',0),(217099,6031,'ko','ë‹¤ì‹œ<br>ê²€ìƒ‰',0),(217100,6031,'he','×‘×—×–×¨×”<br>×—×™×¤×•×©',0),(217101,6031,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î¿<br>Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(217102,6031,'zh','å›žåˆ°æœå¯»\r\n',0),(217103,6031,'sv','Tillbaka till<br>SÃ¶k',0),(217104,6031,'it','Torna alla ricerca',0),(217105,6031,'tl','',0),(217106,6031,'th','&#3585;&#3621;&#3633;&#3610;&#3626;&#3641;&#3656;<br>&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;',0),(217107,6031,'hi','à¤µà¤¾à¤ªà¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤<br>à¤–à¥‹à¤œ',0),(217108,6031,'ms','Kembali ke<br>Cari',0),(217109,6031,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰<br>Ø§Ù„Ø¨Ø­Ø«',0),(217110,6031,'fr','Retour Ã  la<br>Rechercher',0),(217111,6031,'jp','æ¤œç´¢ã?«æˆ»ã‚‹',0),(217112,6031,'pt','Volta para<br>Pesquisa',0),(217113,6031,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ Ð²<br>ÐŸÐ¾Ð¸ÑÐº',0),(217114,6031,'es','Atras a<br>la Busqueda',0),(217115,6031,'de','ZurÃ¼ck zu<br>Suche',0),(217116,6031,'en','Back to<br>Search',0),(217117,6032,'is','',0),(217118,6032,'dr','- Ù„Ø§ÙŠÙ† Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(217119,6032,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ  Ø¢Ù†- Ù„Ø§ÙŠÙ† ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(217120,6032,'tr','Online yardÄ±m iÃ§in tÄ±klayÄ±nÄ±z.',0),(217121,6032,'pl','Kliknij tutaj, aby uzyskaÄ‡ pomoc online.',0),(217122,6032,'bg','ÐšÐ»Ð¸ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº Ð·Ð° Ð¾Ð½Ð»Ð°Ð¹Ð½ Ð¿Ð¾Ð¼Ð¾Ñ‰.',0),(217123,6032,'ur','Ø¢Ù† Ù„Ø§Ø¦Ù† Ù…Ø¯Ø¯ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº.',0),(217124,6032,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð·Ð° Ð¿Ð¾Ð¼Ð¾Ñ› Ð½Ð° Ð¼Ñ€ÐµÐ¶Ð¸.',0),(217125,6032,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ trá»£ giÃºp trá»±c tuyáº¿n',0),(217126,6032,'af','Kliek hier vir aanlynhulp.',0),(217127,6032,'ro','Clic aici pentru ajutor online',0),(217128,6032,'et','KlÃµpsa siia online abi jaoks',0),(217129,6032,'si','Kliknite tukaj za spletno pomoÄ.',0),(217130,6032,'ba','Klik disini untuk bantuan online.',0),(217131,6032,'nl','Klik hier voor on line help.',0),(217132,6032,'fi','TÃ¤Ã¤ltÃ¤ lÃ¶ydÃ¤t online-ohjeessa.',0),(217133,6032,'no','Klikk her for hjelp.',0),(217134,6032,'da','Klik her for online hjÃ¦lp.',0),(217135,6032,'ko','ì˜¨ë¼ì¸ ë„ì›€ë§ì— ëŒ€ í•œ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(217136,6032,'he','×œ×—×¥ ×›××Ÿ ×œ×§×‘×œ×ª ×¢×–×¨×” ×ž×§×•×•× ×ª.',0),(217137,6032,'el','Î Î±Ï„Î®ÏƒÏ„Îµ ÎµÎ´ÏŽ Î³Î¹Î± online Î²Î¿Î®Î¸ÎµÎ¹Î±.',0),(217138,6032,'zh','ç‚¹å‡»è¿™é‡Œåœ¨çº¿å¸®åŠ©',0),(217139,6032,'sv','Klicka hÃ¤r fÃ¶r online-hjÃ¤lp.',0),(217140,6032,'it','Clicca qui per la guida in linea.',0),(217141,6032,'tl','',0),(217142,6032,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3586;&#3629;&#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3629;&#3629;&#3609;&#3652;&#3621;&#3609;&#3',0),(217143,6032,'hi','à¤‘à¤¨à¤²à¤¾à¤‡à¤¨ à¤®à¤¦à¤¦ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚à¥¤',0),(217144,6032,'ms','Klik di sini untuk bantuan dalam talian.',0),(217145,6032,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø¹Ø¨Ø± Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª.',0),(217146,6032,'fr','Cliquez ici pour l\'aide en ligne.',0),(217147,6032,'jp','ã‚ªãƒ³ãƒ©ã‚¤ãƒ³ãƒ˜ãƒ«ãƒ—ã?¸ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(217148,6032,'pt','Clique aqui para obter ajuda online.',0),(217149,6032,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð´Ð»Ñ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ online Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸.',0),(217150,6032,'es','Click aquÃ­ para ayuda en lÃ­nea',0),(217151,6032,'de','Klicken Sie hier zur online-Hilfe.',0),(217152,6032,'en','Click here for online help.',0),(217153,6033,'is','',0),(217154,6033,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù…ØªÙ†ÙŠ â€“ Ù„ÙŠØ³Øª ÙƒØ§Ù…Ù„ÙŠ Ø§Ø² Ù…ØªÙ† Ù‡Ø§ÙŠ Ø¢Ù…ÙˆØ²Ø´ÙŠ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø±Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(217155,6033,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù…ØªÙ†ÙŠ â€“ Ù„ÙŠØ³Øª ÙƒØ§Ù…Ù„ÙŠ Ø§Ø² Ù…ØªÙ† Ù‡Ø§ÙŠ Ø¢Ù…ÙˆØ²Ø´ÙŠ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø±Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(217156,6033,'tr','Bizim tam liste-in NolaPro aÃ§Ä±klayÄ±cÄ± metinleri gÃ¶rÃ¼ntÃ¼lemek',0),(217157,6033,'pl','Zobacz naszÄ… peÅ‚nÄ… listÄ™ tekstÃ³w instruktaÅ¼owe NolaPro',0),(217158,6033,'bg','Ð Ð°Ð·Ð³Ð»ÐµÐ´Ð°Ð¹ Ð½Ð°ÑˆÐ¸Ñ‚Ðµ Ð¿ÑŠÐ»ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° NolaPro ÑƒÑ‡ÐµÐ±Ð½Ð¸ Ñ‚ÐµÐºÑÑ‚Ð¾Ð²Ðµ',0),(217159,6033,'ur','ÛÙ…Ø§Ø±ÛŒ Ù…Ú©Ù…Ù„ Ù„Ø³Ù¹Ù†Ú¯ Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ ØªØ¨ØµØ±Ø§Øª ÙØ±Ø§ÛÙ… Ù…ØªÙˆÙ† Ú©Ø§ Ù…Ù†Ø¸Ø± Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(217160,6033,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð½Ð°Ð¼ ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ñƒ Ð»Ð¸ÑÑ‚Ñƒ ÑÐ° ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð¾Ð¼ Ñ‚ÐµÐºÑÑ‚Ð¾Ð²Ð¸ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾',0),(217161,6033,'vi','Xem danh má»¥c trá»£ giÃºp NolaPro hoÃ n chá»‰nh',0),(217162,6033,'af','Besigtig ons volledige lys van NolaPro instruksionele handboeke',0),(217163,6033,'ro','Vezi noastre listÄƒ completÄƒ de texte de instruire NolaPro',0),(217164,6033,'et','Vaata meie tÃ¤ieliku nimekirja NolaPro instructional tekstid',0),(217165,6033,'si','Poglej si naÅ¡ celoten seznam NolaPro pouÄni besedil',0),(217166,6033,'ba','Lihat daftar lengkap kami naskah pengajaran NolaPro',0),(217167,6033,'nl','Bekijk onze volledige lijst van NolaPro educatieve teksten',0),(217168,6033,'fi','Katso tÃ¤ydellinen luettelo NolaPro ohjeet tekstit',0),(217169,6033,'no','Se vÃ¥r fullstendig liste over NolaPro instruksjons tekster',0),(217170,6033,'da','Se vores komplette liste over NolaPro Instruerende tekster',0),(217171,6033,'ko','NolaPro êµìœ¡ìš© í…ìŠ¤íŠ¸ì˜ ìš°ë¦¬ì˜ ì „ì²´ ëª©ë¡ ë³´ê¸°',0),(217172,6033,'he','×”×¦×’ ××ª ×”×¤×™×¨×•×˜ ×”×ž×œ× ×©×œ× ×• ×©×œ ×˜×§×¡×˜×™× ×”×“×¨×›×” NolaPro',0),(217173,6033,'el','Î”ÎµÏ‚ Î¼Î±Ï‚ Ï€Î»Î®ÏÎ· Î»Î¯ÏƒÏ„Î± Ï„Ï‰Î½ NolaPro ÎµÎºÏ€Î±Î¹Î´ÎµÏ…Ï„Î¹ÎºÎ¬ ÎºÎµÎ¯Î¼ÎµÎ½Î±',0),(217174,6033,'zh','æŸ¥çœ‹æˆ‘ä»¬çš„NolaProæ•™å­¦æ–‡æœ¬çš„å®Œæ•´åˆ—è¡¨\r\n',0),(217175,6033,'sv','Se vÃ¥r kompletta lista Ã¶ver NolaPro instruktions texter',0),(217176,6033,'it','Mostra la nostra lista completa dei testi didattici NolaPro',0),(217177,6033,'tl','',0),(217178,6033,'th','&#3604;&#3641;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3586;&#3629;&#3591;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;',0),(217179,6033,'hi','NolaPro à¤…à¤¨à¥à¤¦à¥‡à¤¶à¤¾à¤¤à¥à¤®à¤• à¤—à¥à¤°à¤‚à¤¥à¥‹à¤‚ à¤•à¥€ à¤¹à¤®à¤¾à¤°à¥€ à¤ªà¥‚à¤°à¥€ à¤¸à¥‚à¤šà¥€ à¤¦à¥‡à¤–à¥‡à¤‚',0),(217180,6033,'ms','Lihat senarai lengkap kami teks pengajaran NolaPro',0),(217181,6033,'ar','Ø¹Ø±Ø¶ Ù„Ø¯ÙŠÙ†Ø§ Ù‚Ø§Ø¦Ù…Ø© ÙƒØ§Ù…Ù„Ø© Ù…Ù† Ø§Ù„Ù†ØµÙˆØµ Ø§Ù„ØªØ¹Ù„ÙŠÙ…ÙŠØ© Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ',0),(217182,6033,'fr','Visualiser notre liste complÃ¨te des textes d\'enseignement NolaPro',0),(217183,6033,'jp','æ–‡ç« ã?§ã?®ãƒ˜ãƒ«ãƒ—',0),(217184,6033,'pt','Ver a nossa lista completa de textos instrutivos NolaPro',0),(217185,6033,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð½Ð°Ñˆ Ð¿Ð¾Ð»Ð½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº ÑƒÑ‡ÐµÐ±Ð½Ñ‹Ñ… Ñ‚ÐµÐºÑÑ‚Ð¾Ð² NolaPro',0),(217186,6033,'es','Visionar nuestra lista completa de textos instruccionales de NolaPro',0),(217187,6033,'de','Unsere komplette Liste der Artikel Lehr Texte anzeigen',0),(217188,6033,'en','View our complete listing of NolaPro instructional texts',0),(217189,6034,'is','',0),(217190,6034,'dr','24/7 ',0),(217191,6034,'pr','ÙˆÙŠØ¯Ø¦Ùˆ Ù‡Ø§ÙŠ Ø¢Ù…ÙˆØ²Ø´ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª Ø¯Ø± Ø´Ø¨ÙƒÙ‡  24/7 ',0),(217192,6034,'tr','EÄŸitim videolarÄ± kullanÄ±labilir 24/7 Web',0),(217193,6034,'pl','Filmy szkoleniowe dostÄ™pne 24/7 w Internecie',0),(217194,6034,'bg','Ð’Ð¸Ð´ÐµÐ¾ Ð¾Ð±ÑƒÑ‡ÐµÐ½Ð¸Ðµ Ñ€Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ 24/7 Ð² Ð¸Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚',0),(217195,6034,'ur','ÙˆÛŒØ¨ Ù¾Ø± ØªØ±Ø¨ÛŒØª ÙˆÛŒÚˆÛŒÙˆ Ø¯Ø³ØªÛŒØ§Ø¨ 24/7',0),(217196,6034,'sr','Ð¡Ð½Ð¸Ð¼ÐºÐµ Ð¾Ð±ÑƒÐºÐµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° 24/7 Ð½Ð° WÐµÐ±Ñƒ',0),(217197,6034,'vi','Video Ä‘Ã o táº¡o cÃ³ sáºµn trÃªn web 24/7',0),(217198,6034,'af','Opleidingsvideo\'s is 24/7 beskikbaar op die webblad',0),(217199,6034,'ro','Videoclipuri de formare disponibile 24/7 pe web',0),(217200,6034,'et','Video saadaval 24/7 veebis',0),(217201,6034,'si','Usposabljanja videos na voljo 24/7 na spletu',0),(217202,6034,'ba','Video pelatihan tersedia 24/7 di web',0),(217203,6034,'nl','Trainingsvideo\'s 24/7 beschikbaar op het web',0),(217204,6034,'fi','Koulutus videoita kÃ¤ytettÃ¤vissÃ¤ 24/7 verkossa',0),(217205,6034,'no','OpplÃ¦ringsvideoer tilgjengelig 24/7 pÃ¥ nettet',0),(217206,6034,'da','Uddannelsesvideoer tilgÃ¦ngelige 24/7 pÃ¥ nettet',0),(217207,6034,'ko','ì›¹ í›ˆë ¨ ë¹„ë””ì˜¤ ì‚¬ìš©í•  ìˆ˜ 24/7',0),(217208,6034,'he','×¡×¨×˜×•× ×™ ×”×“×¨×›×” ×–×ž×™×Ÿ 24/7 ×‘- web',0),(217209,6034,'el','Î’Î¯Î½Ï„ÎµÎ¿ ÎºÎ±Ï„Î¬ÏÏ„Î¹ÏƒÎ·Ï‚ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± 24/7 ÏƒÏ„Î¿ Î”Î¹Î±Î´Î¯ÎºÏ„Ï…Î¿',0),(217210,6034,'zh','åŸ¹è®­è§†é¢‘çš„24 / 7åœ¨ç½‘ä¸Šå¯ç”¨\r\n',0),(217211,6034,'sv','Utbildning videor tillgÃ¤nglig 24/7 pÃ¥ nÃ¤tet',0),(217212,6034,'it','Video di formazione disponibile 24/7 sul web',0),(217213,6034,'tl','',0),(217214,6034,'th','&#3623;&#3637;&#3604;&#3637;&#3650;&#3629;&#3626;&#3629;&#3609;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(217215,6034,'hi','à¤µà¥‡à¤¬ à¤ªà¤° à¤ªà¥à¤°à¤¶à¤¿à¤•à¥à¤·à¤£ à¤µà¥€à¤¡à¤¿à¤¯à¥‹ à¤‰à¤ªà¤²à¤¬à¥à¤§ 24/7',0),(217216,6034,'ms','Video latihan disediakan 24/7 di web',0),(217217,6034,'ar','Ø£Ø´Ø±Ø·Ø© ÙÙŠØ¯ÙŠÙˆ Ù„Ù„ØªØ¯Ø±ÙŠØ¨ Ù…ØªØ§Ø­Ø© 24/7 Ø¹Ù„Ù‰ Ø´Ø¨ÙƒØ© Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(217218,6034,'fr','VidÃ©os de formation disponible 24/7 sur le web',0),(217219,6034,'jp','ãƒˆãƒ¬ãƒ¼ãƒ‹ãƒ³ã‚°ãƒ“ãƒ‡ã‚ª',0),(217220,6034,'pt','VÃ­deos de treinamento disponÃ­vel 24/7 na web',0),(217221,6034,'ru','Ð£Ñ‡ÐµÐ±Ð½Ñ‹Ðµ Ð²Ð¸Ð´ÐµÐ¾ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹ 24/7 Ð² Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚Ðµ',0),(217222,6034,'es','Videos de entrenamientos disponibles 24/7 en el Web',0),(217223,6034,'de','Schulungs-Videos rund um die Uhr im Web',0),(217224,6034,'en','Training videos available 24/7 on the web',0),(217225,6035,'is','',0),(217226,6035,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ ',0),(217227,6035,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ ',0),(217228,6035,'tr','SipariÅŸ durumu seÃ§eneÄŸinin Ekle',0),(217229,6035,'pl','Dodaj opcjÄ™ Status zamÃ³wienia',0),(217230,6035,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¾Ð¿Ñ†Ð¸Ñ Ð½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(217231,6035,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ Ø­ÛŒØ«ÛŒØª Ø§Ø®ØªÛŒØ§Ø± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(217232,6035,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(217233,6035,'vi','ThÃªm TÃ¬nh tráº¡ng Ä‘Æ¡n hÃ ng',0),(217234,6035,'af','Skep Bestelling Status Opsie',0),(217235,6035,'ro','Ordinea stÄƒrii opÅ£iunea adaugÄƒ',0),(217236,6035,'et','Hooldustellimuse seisundivÃµimaluse lisamine',0),(217237,6035,'si','Red statusa moÅ¾nost Dodaj',0),(217238,6035,'ba','Menambahkan opsi Status pesanan',0),(217239,6035,'nl','Optie voor serviceorderstatus toevoegen',0),(217240,6035,'fi','Huoltotilauksen tilan vaihtoehdon lisÃ¤Ã¤minen',0),(217241,6035,'no','Alternativ for serviceordrestatus legge',0),(217242,6035,'da','Bestil statusindstilling tilfÃ¸je',0),(217243,6035,'ko','ì£¼ë¬¸ ìƒíƒœ ì˜µì…˜ ì¶”ê°€',0),(217244,6035,'he','×”××¤×©×¨×•×ª ×ž×¦×‘ ×¡×“×¨ ×œ×”×•×¡×™×£',0),(217245,6035,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(217246,6035,'zh','è®¢å•çŠ¶æ€é€‰é¡¹æ·»åŠ \r\n',0),(217247,6035,'sv','Order Status alternativet LÃ¤gg till',0),(217248,6035,'it','Aggiungi opzione Status ordine',0),(217249,6035,'tl','',0),(217250,6035,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3606;&#3634;&#3609;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(217251,6035,'hi','à¤‘à¤°à¥à¤¡à¤° à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤µà¤¿à¤•à¤²à¥à¤ª à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(217252,6035,'ms','Tambah pilihan Status pesanan',0),(217253,6035,'ar','Ø¥Ø¶Ø§ÙØ© Ø®ÙŠØ§Ø± Ø­Ø§Ù„Ø© Ø§Ù„Ù†Ø¸Ø§Ù…',0),(217254,6035,'fr','Ajouter Option Ã©tat de la commande',0),(217255,6035,'jp','æ³¨æ–‡çŠ¶æ³?ã‚ªãƒ—ã‚·ãƒ§ãƒ³è¿½åŠ ',0),(217256,6035,'pt','Adicionar opÃ§Ã£o de Status de ordem',0),(217257,6035,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð¡Ñ‚Ð°Ñ‚ÑƒÑÐ° Ð—Ð°ÐºÐ°Ð·Ð°',0),(217258,6035,'es','Status de Orden OpciÃ³n Agregar',0),(217259,6035,'de','Order Status-Option hinzufÃ¼gen',0),(217260,6035,'en','Order Status Option Add',0),(217261,6036,'is','',0),(217262,6036,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ ',0),(217263,6036,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ ',0),(217264,6036,'tr','Yeni sipariÅŸ durumu seÃ§eneÄŸinin Ekle',0),(217265,6036,'pl','Dodaj nowÄ… opcjÄ™ Status zamÃ³wienia',0),(217266,6036,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð²Ð° Ð¾Ð¿Ñ†Ð¸Ñ Ð½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(217267,6036,'ur','Ù†Ø¦Û’ Ø­Ú©Ù… Ú©ÛŒ Ø­ÛŒØ«ÛŒØª Ø§Ø®ØªÛŒØ§Ø± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(217268,6036,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(217269,6036,'vi','ThÃªm Lá»±a Chá»n Má»›i Cho TÃ¬nh Tráº¡ng ÄÆ¡n HÃ ng',0),(217270,6036,'af','Nuwe Bestel Status Opsie Byvoeg',0),(217271,6036,'ro','Adauga Noua Ordine Status opÅ£iune',0),(217272,6036,'et','Lisa uus tellimuse oleku valik',0),(217273,6036,'si','Dodajte novo naroÄilo Status moÅ¾nost',0),(217274,6036,'ba','Tambahkan opsi Status Order Baru',0),(217275,6036,'nl','Voeg nieuwe optie voor serviceorderstatus',0),(217276,6036,'fi','LisÃ¤tÃ¤ uuden huoltotilauksen tilan vaihtoehdon',0),(217277,6036,'no','Legge til nye alternativ for serviceordrestatus',0),(217278,6036,'da','TilfÃ¸j ny ordre Status mulighed',0),(217279,6036,'ko','ìƒˆë¡œìš´ ì£¼ë¬¸ ìƒíƒœ ì˜µì…˜ ì¶”ê°€',0),(217280,6036,'he','×”×•×¡×¤×ª ××¤×©×¨×•×ª ×ž×¦×‘ ×”×–×ž× ×” ×—×“×©×”',0),(217281,6036,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÎµÏ€Î¹Î»Î¿Î³Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚',0),(217282,6036,'zh','å¢žåŠ æ–°çš„è®¢å•çŠ¶æ€é€‰é¡¹\r\n',0),(217283,6036,'sv','LÃ¤gga ny Order statusalternativ',0),(217284,6036,'it','Aggiungi nuova opzione Status ordine',0),(217285,6036,'tl','',0),(217286,6036,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3606;&#3634;&#3609;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(217287,6036,'hi','à¤¨à¤ à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤µà¤¿à¤•à¤²à¥à¤ª à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(217288,6036,'ms','Tambah pilihan Status pesanan baru',0),(217289,6036,'ar','Ø¥Ø¶Ø§ÙØ© Ø®ÙŠØ§Ø± ÙˆØ¶Ø¹ ØªØ±ØªÙŠØ¨ Ø¬Ø¯ÙŠØ¯',0),(217290,6036,'fr','Ajouter la nouvelle Option de statut de commande',0),(217291,6036,'jp','æ–°è¦?æ³¨æ–‡çŠ¶æ³?ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?®è¿½åŠ ',0),(217292,6036,'pt','Adicionar nova opÃ§Ã£o de Status de ordem',0),(217293,6036,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(217294,6036,'es','Agregar Nuevo OpciÃ³n de Status de Orden',0),(217295,6036,'de','FÃ¼gen Sie neue Order-Status-Option',0),(217296,6036,'en','Add New Order Status Option',0),(217297,6037,'is','',0),(217298,6037,'dr','Ø­Ø°Ù Ú¯Ø²ÙŠÙ†Ù‡ Ø§Ø³ØªØ§Ù†',0),(217299,6037,'pr','Ø­Ø°Ù Ú¯Ø²ÙŠÙ†Ù‡ Ø§Ø³ØªØ§Ù†',0),(217300,6037,'tr','Durum seÃ§eneÄŸi silmek',0),(217301,6037,'pl','UsuÅ„ opcjÄ™ Status',0),(217302,6037,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð¾Ð¿Ñ†Ð¸Ñ Ð½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(217303,6037,'ur','Ø­Ø§Ù„Øª Ø§Ø®ØªÛŒØ§Ø± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(217304,6037,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(217305,6037,'vi','XÃ³a lá»±a chá»n tÃ¬nh tráº¡ng',0),(217306,6037,'af','Skrap Status Opsie',0),(217307,6037,'ro','ÅžtergeÅ£i stÄƒrii opÅ£iunea',0),(217308,6037,'et','Kustuta olek variant',0),(217309,6037,'si','Status moÅ¾nost brisanja',0),(217310,6037,'ba','Hapus opsi Status',0),(217311,6037,'nl','Optie voor serviceorderstatus verwijderen',0),(217312,6037,'fi','Poista tilan vaihtoehdon',0),(217313,6037,'no','Slette alternativ for serviceordrestatus',0),(217314,6037,'da','Slette statusindstilling',0),(217315,6037,'ko','ìƒíƒœ ì˜µì…˜ ì‚­ì œ',0),(217316,6037,'he','×ž×¦×‘ ××¤×©×¨×•×ª ×”×ž×—×™×§×”',0),(217317,6037,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÎµÏ€Î¹Î»Î¿Î³Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(217318,6037,'zh','åˆ é™¤çŠ¶æ€é€‰é¡¹\r\n',0),(217319,6037,'sv','Ta bort statusalternativ',0),(217320,6037,'it','Eliminare l\'opzione Status',0),(217321,6037,'tl','',0),(217322,6037,'th','&#3621;&#3610;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3606;&#3634;&#3609;&#3632;',0),(217323,6037,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(217324,6037,'ms','Menghapuskan pilihan Status',0),(217325,6037,'ar','Ø­Ø°Ù Ø§Ù„Ø®ÙŠØ§Ø± Ø­Ø§Ù„Ø©',0),(217326,6037,'fr','Supprimez l\'Option de statut',0),(217327,6037,'jp','çŠ¶æ³?ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?®æ¶ˆåŽ»',0),(217328,6037,'pt','Excluir opÃ§Ã£o de Status',0),(217329,6037,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ Status',0),(217330,6037,'es','Eliminar OpciÃ³n de Staus',0),(217331,6037,'de','Statusoption lÃ¶schen',0),(217332,6037,'en','Delete Status Option',0),(217333,6038,'is','',0),(217334,6038,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´',0),(217335,6038,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´',0),(217336,6038,'tr','SipariÅŸ durumu seÃ§eneÄŸini gÃ¼ncelleÅŸtirme',0),(217337,6038,'pl','Aktualizacja opcji stanu zamÃ³wienia',0),(217338,6038,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ð¿Ñ†Ð¸Ñ Ð·Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(217339,6038,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ Ø­ÛŒØ«ÛŒØª Ø§Ø®ØªÛŒØ§Ø± ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(217340,6038,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(217341,6038,'vi','Cáº­p Nháº­t TÃ¬nh Tráº¡ng ÄÆ¡n HÃ ng',0),(217342,6038,'af','Opdateer Bestelling Status Opsie',0),(217343,6038,'ro','Ordinea stÄƒrii opÅ£iunea Update',0),(217344,6038,'et','Tellimuse olek suvandit uuendamine',0),(217345,6038,'si','Da Status moÅ¾nost posodobitev',0),(217346,6038,'ba','Update opsi Status pesanan',0),(217347,6038,'nl','Update van de optie van de Status van bestelling',0),(217348,6038,'fi','Tilauksen tilan vaihtoehto pÃ¤ivitys',0),(217349,6038,'no','Status alternativet ordreoppdatering',0),(217350,6038,'da','Ordre Status mulighed opdatering',0),(217351,6038,'ko','ì£¼ë¬¸ ìƒíƒœ ì˜µì…˜ ì—…ë°ì´íŠ¸',0),(217352,6038,'he','×”×¡×“×¨ ×”×¡×˜×˜×•×¡ ×ž×ª×¢×“×›×Ÿ',0),(217353,6038,'el','Î”Î¹Î¬Ï„Î±Î¾Î· Update ÎµÏ€Î¹Î»Î¿Î³Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(217354,6038,'zh','è®¢å•çŠ¶æ€æ›´æ–°é€‰é¡¹\r\n',0),(217355,6038,'sv','Order Status alternativet Uppdatera',0),(217356,6038,'it','Aggiornamento di opzione stato ordine',0),(217357,6038,'tl','',0),(217358,6038,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3606;&#3634;&#3609;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(217359,6038,'hi','à¤‘à¤°à¥à¤¡à¤° à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤µà¤¿à¤•à¤²à¥à¤ª à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(217360,6038,'ms','Kemas kini pilihan Status pesanan',0),(217361,6038,'ar','Ø£Ù…Ø± ÙˆØ¶Ø¹ Ø®ÙŠØ§Ø± Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(217362,6038,'fr','Mise Ã  jour en Option commande',0),(217363,6038,'jp','æ³¨æ–‡çŠ¶æ³?ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?®æ›´æ–°',0),(217364,6038,'pt','Ordem Status opÃ§Ã£o Update',0),(217365,6038,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð¡Ñ‚Ð°Ñ‚ÑƒÑÐ° Ð—Ð°ÐºÐ°Ð·Ð°',0),(217366,6038,'es','Status de Orden OpciÃ³n Actualizar',0),(217367,6038,'de','Bestellung Status Option Update',0),(217368,6038,'en','Order Status Option Update',0),(217369,6039,'is','',0),(217370,6039,'dr','ÙˆØ§Ø­Ø¯ Ø§Ø¹Ø´Ø§Ø±',0),(217371,6039,'pr','ÙˆØ§Ø­Ø¯ Ø§Ø¹Ø´Ø§Ø±',0),(217372,6039,'tr','Birimi ondalÄ±klarÄ±',0),(217373,6039,'pl','Jednostka po przecinku',0),(217374,6039,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð´ÐµÑÐµÑ‚Ð¸Ñ‡Ð½Ð¸ Ð·Ð½Ð°Ñ†Ð¸',0),(217375,6039,'ur','ÛŒÙˆÙ†Ù¹ Ø§Ø¹Ø´Ø§Ø±ÛŒÛ’2',0),(217376,6039,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð´ÐµÑ†Ð¸Ð¼Ð°Ð»Ðµ',0),(217377,6039,'vi','ÄÆ¡n vá»‹ tháº­p phÃ¢n',0),(217378,6039,'af','Eenheid Desimale',0),(217379,6039,'ro','Unitate de zecimale',0),(217380,6039,'et','Ãœhiku kÃ¼mnendikke',0),(217381,6039,'si','Enota decimalk',0),(217382,6039,'ba','Satuan desimal',0),(217383,6039,'nl','Eenheid decimalen',0),(217384,6039,'fi','YksikÃ¶ssÃ¤ desimaaleja',0),(217385,6039,'no','Enheten desimaler',0),(217386,6039,'da','Enhed decimaler',0),(217387,6039,'ko','ë‹¨ìœ„ ì†Œìˆ˜ì ',0),(217388,6039,'he','×™×—×™×“×ª ×¡×¤×¨×•×ª ×¢×©×¨×•× ×™×•×ª',0),(217389,6039,'el','ÎœÎ¿Î½Î¬Î´Î± Î´ÎµÎºÎ±Î´Î¹ÎºÎ¬ ÏˆÎ·Ï†Î¯Î±',0),(217390,6039,'zh','å•ä½å°æ•°\r\n',0),(217391,6039,'sv','Enhet decimaler',0),(217392,6039,'it','UnitÃ  decimali',0),(217393,6039,'tl','',0),(217394,6039,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3607;&#3624;&#3609;&#3636;&#3618;&#3617;',0),(217395,6039,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¦à¤¶à¤®à¤²à¤µ',0),(217396,6039,'ms','Unit perpuluhan',0),(217397,6039,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„ÙƒØ³ÙˆØ± Ø§Ù„Ø¹Ø´Ø±ÙŠØ©',0),(217398,6039,'fr','UnitÃ© dÃ©cimales',0),(217399,6039,'jp','å°?æ•°ç‚¹ä»¥ä¸‹ã?®è¡¨ç¤ºå?˜ä½?',0),(217400,6039,'pt','Unidade decimais',0),(217401,6039,'ru','Ð”ÐµÑÑÑ‚Ð¸Ñ‡Ð½Ñ‹Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(217402,6039,'es','Decimales de Unidades',0),(217403,6039,'de','Einheit Dezimalzahlen',0),(217404,6039,'en','Unit Decimals',0),(217405,6040,'is','',0),(217406,6040,'dr','(ØªØ°ÙƒØ±) Ø¯Ø§Ø®Ù„ÙŠ',0),(217407,6040,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª (ØªØ°ÙƒØ±) Ø¯Ø§Ø®Ù„ÙŠ',0),(217408,6040,'tr','Ä°Ã§ Not',0),(217409,6040,'pl','Notatka wewnÄ™trzna',0),(217410,6040,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(217411,6040,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ù†ÙˆÙ¹',0),(217412,6040,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð½Ð° Ð¿Ð¾Ñ€ÑƒÐºÐ°',0),(217413,6040,'vi','Ghi chÃº ná»™i bá»™',0),(217414,6040,'af','Interne Nota',0),(217415,6040,'ro','NotÄƒ internÄƒ',0),(217416,6040,'et','Sisemine MÃ¤rkus',0),(217417,6040,'si','Interni opombi',0),(217418,6040,'ba','Catatan internal',0),(217419,6040,'nl','Interne nota',0),(217420,6040,'fi','SisÃ¤inen Huomautus',0),(217421,6040,'no','Intern merknad',0),(217422,6040,'da','Internt notat',0),(217423,6040,'ko','ë‚´ë¶€ ë©”ëª¨',0),(217424,6040,'he','×”×¢×¨×” ×¤× ×™×ž×™',0),(217425,6040,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÏŒ Ï…Ï€ÏŒÎ¼Î½Î·Î¼Î±',0),(217426,6040,'zh','å†…éƒ¨è¯´æ˜Ž\r\n',0),(217427,6040,'sv','Intern notering',0),(217428,6040,'it','Nota interna',0),(217429,6040,'tl','',0),(217430,6040,'th','&#3616;&#3634;&#3618;&#3651;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(217431,6040,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¨à¥‹à¤Ÿ',0),(217432,6040,'ms','Nota dalaman',0),(217433,6040,'ar','Ù…Ø°ÙƒØ±Ø© Ø¯Ø§Ø®Ù„ÙŠØ©',0),(217434,6040,'fr','Note interne',0),(217435,6040,'jp','å†…éƒ¨ãƒ¡ãƒ¢',0),(217436,6040,'pt','Nota interna',0),(217437,6040,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÑÑ Ð—Ð°Ð¼ÐµÑ‚ÐºÐ°',0),(217438,6040,'es','Nota Internal',0),(217439,6040,'de','Interne Aufzeichnung',0),(217440,6040,'en','Internal Note',0),(217441,6041,'is','',0),(217442,6041,'dr','Ø¬Ø¯ÙˆÙ„ Ù‚ÙŠÙ…Øª Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(217443,6041,'pr','Ø¬Ø¯ÙˆÙ„ Ù‚ÙŠÙ…Øª Ø¨Ø±Ø§ÙŠ Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª',0),(217444,6041,'tr','Fiyat listesi iÃ§in fiyat tablosu',0),(217445,6041,'pl','Cennik dla Cennik',0),(217446,6041,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° Ð·Ð° Ñ†ÐµÐ½Ð¾Ð²Ð°Ñ‚Ð° Ð»Ð¸ÑÑ‚Ð°',0),(217447,6041,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„Ø¦Û’ Ù…ÛŒØ²',0),(217448,6041,'sr','Ð¢Ð°Ð±ÐµÐ»Ðµ Ñ†ÐµÐ½Ð° Ð·Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(217449,6041,'vi','Báº£ng cho danh sÃ¡ch giÃ¡',0),(217450,6041,'af','Prystabel vir die Pryslys',0),(217451,6041,'ro','Pret masa pentru lista de preturi',0),(217452,6041,'et','Hinnakirja hind tabel',0),(217453,6041,'si','Cenik za cenik',0),(217454,6041,'ba','Tabel harga untuk daftar harga',0),(217455,6041,'nl','Prijstabel voor de prijslijst',0),(217456,6041,'fi','Hinnasto hinta-taulukko',0),(217457,6041,'no','Tabellen Salgspris for prislisten',0),(217458,6041,'da','Prisskema for prislisten',0),(217459,6041,'ko','ê°€ê²© ë¦¬ìŠ¤íŠ¸ì— ëŒ€ í•œ ê°€ê²© í…Œì´ë¸”',0),(217460,6041,'he','×ž×—×™×¨ ×˜×‘×œ×” ×¢×‘×•×¨ ×”×ž×—×™×¨×•×Ÿ',0),(217461,6041,'el','Î¤Î¹Î¼Î® Ï€Î¯Î½Î±ÎºÎ± Î³Î¹Î± Ï„Î¿Î½ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(217462,6041,'zh','ä»·æ ¼è¡¨ä»·æ ¼åˆ—è¡¨\r\n',0),(217463,6041,'sv','Pristabell fÃ¶r prislistan',0),(217464,6041,'it','Tabella dei prezzi per il listino prezzi',0),(217465,6041,'tl','',0),(217466,6041,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;',0),(217467,6041,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‚à¤²à¥à¤¯ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(217468,6041,'ms','Jadual harga untuk senarai harga',0),(217469,6041,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(217470,6041,'fr','Tableau des prix pour la liste de prix',0),(217471,6041,'jp','ä¾¡æ ¼ãƒªã‚¹ãƒˆã?®ä¾¡æ ¼è¡¨',0),(217472,6041,'pt','Tabela de preÃ§o para a lista de preÃ§o',0),(217473,6041,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ñ†ÐµÐ½ Ð½Ð° Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(217474,6041,'es','Tabla de Precios para la Lista de Precios',0),(217475,6041,'de','Preisstaffel fÃ¼r die Preisliste',0),(217476,6041,'en','Price Table for the Price List',0),(217477,6042,'is','',0),(217478,6042,'dr','ÙˆØ¶Ø¹ÙŠØª ÙØ¹Ù„ÙŠ',0),(217479,6042,'pr','ÙˆØ¶Ø¹ÙŠØª ÙØ¹Ù„ÙŠ',0),(217480,6042,'tr','GeÃ§erli durum',0),(217481,6042,'pl','Aktualny stan',0),(217482,6042,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(217483,6042,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø­ÛŒØ«ÛŒØª',0),(217484,6042,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(217485,6042,'vi','TÃ¬nh tráº¡ng hiá»‡n thá»i ',0),(217486,6042,'af','Huidige Status',0),(217487,6042,'ro','Stare curenta',0),(217488,6042,'et','Praegune staatus',0),(217489,6042,'si','Trenutno stanje',0),(217490,6042,'ba','Status saat ini',0),(217491,6042,'nl','Huidige Status',0),(217492,6042,'fi','Nykyinen tila',0),(217493,6042,'no','Gjeldende Status',0),(217494,6042,'da','NuvÃ¦rende Status',0),(217495,6042,'ko','í˜„ìž¬ ìƒíƒœ',0),(217496,6042,'he','×ž×¦×‘ × ×•×›×—×™',0),(217497,6042,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(217498,6042,'zh','çŽ°çŠ¶\r\n',0),(217499,6042,'sv','Nuvarande Status',0),(217500,6042,'it','Stato attuale',0),(217501,6042,'tl','',0),(217502,6042,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(217503,6042,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(217504,6042,'ms','Status semasa',0),(217505,6042,'ar','Ø§Ù„ÙˆØ¶Ø¹ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(217506,6042,'fr','Ã‰tat d\'avancement',0),(217507,6042,'jp','ç?¾åœ¨ã?®çŠ¶æ³?',0),(217508,6042,'pt','Status atual',0),(217509,6042,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(217510,6042,'es','Status Actual',0),(217511,6042,'de','Aktueller Status',0),(217512,6042,'en','Current Status',0),(217513,6043,'is','',0),(217514,6043,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø®ØµÙˆØµÙŠ',0),(217515,6043,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø®ØµÙˆØµÙŠ',0),(217516,6043,'tr','Ã–zel notlar',0),(217517,6043,'pl','Prywatne notatki',0),(217518,6043,'bg','Ð§Ð°ÑÑ‚Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(217519,6043,'ur','Ù†Ø¬ÛŒ Ù†ÙˆÙ¹',0),(217520,6043,'sr','ÐŸÑ€Ð¸Ð²Ð°Ñ‚Ð½Ð¸ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(217521,6043,'vi','Ghi chÃº riÃªng tÆ°',0),(217522,6043,'af','Privaat Notas',0),(217523,6043,'ro','Note private',0),(217524,6043,'et','Privaatsed mÃ¤rkused',0),(217525,6043,'si','Zasebni opombe',0),(217526,6043,'ba','Catatan pribadi',0),(217527,6043,'nl','Prive notities',0),(217528,6043,'fi','Yksityiset muistiinpanot',0),(217529,6043,'no','Privat notater',0),(217530,6043,'da','Private noter',0),(217531,6043,'ko','ê°œì¸ ë©”ëª¨',0),(217532,6043,'he','×¤×¨×˜×™ ×”×¢×¨×•×ª',0),(217533,6043,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï„Î¿Ï… Î¹Î´Î¹Ï‰Ï„Î¹ÎºÎ¿Ï',0),(217534,6043,'zh','ç§äººé™„æ³¨\r\n',0),(217535,6043,'sv','Privata anteckningar',0),(217536,6043,'it','Note private',0),(217537,6043,'tl','',0),(217538,6043,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3626;&#3656;&#3623;&#3609;&#3605;&#3633;&#3623;',0),(217539,6043,'hi','à¤¨à¤¿à¤œà¥€ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(217540,6043,'ms','Nota-nota peribadi',0),(217541,6043,'ar','Ø§Ù„Ù…Ø°ÙƒØ±Ø§Øª Ø§Ù„Ø®Ø§ØµØ©',0),(217542,6043,'fr','Notes privÃ©es',0),(217543,6043,'jp','ãƒ—ãƒ©ã‚¤ãƒ™ãƒ¼ãƒˆãƒ¡ãƒ¢',0),(217544,6043,'pt','Private Notes',0),(217545,6043,'ru','Ð§Ð°ÑÑ‚Ð½Ñ‹Ðµ Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(217546,6043,'es','Notas Privadas',0),(217547,6043,'de','Private Notizen',0),(217548,6043,'en','Private Notes',0),(217549,6044,'is','',0),(217550,6044,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ ',0),(217551,6044,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ ',0),(217552,6044,'tr','Hata ekleme sipariÅŸ durumu seÃ§eneÄŸinin',0),(217553,6044,'pl','BÅ‚Ä…d dodawania zamÃ³wienia stan opcji',0),(217554,6044,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½ÐµÑ‚Ð¾ Ð½Ð° Ð¾Ð¿Ñ†Ð¸Ñ Ð·Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(217555,6044,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ Ø­ÛŒØ«ÛŒØª Ø§Ø®ØªÛŒØ§Ø±',0),(217556,6044,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(217557,6044,'vi','Lá»—i khi thÃªm tÃ¬nh tráº¡ng Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(217558,6044,'af','Fout toevoeging volgorde Status opsie',0),(217559,6044,'ro','Eroare adÄƒugarea ordinea stÄƒrii opÅ£iunea',0),(217560,6044,'et','Viga lisades hooldustellimuse seisundivÃµimaluse',0),(217561,6044,'si','Napaka dodajanje nalog Status moÅ¾nost',0),(217562,6044,'ba','Kesalahan menambahkan opsi Order Status',0),(217563,6044,'nl','Fout toe te voegen optie voor serviceorderstatus',0),(217564,6044,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ huoltotilauksen tilan vaihtoehdon',0),(217565,6044,'no','Feil Ã¥ legge alternativ for serviceordrestatus',0),(217566,6044,'da','Fejl tilfÃ¸je ordre statusindstilling',0),(217567,6044,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì£¼ë¬¸ ìƒíƒœ ì˜µì…˜',0),(217568,6044,'he','×”××¤×©×¨×•×ª ×ž×¦×‘ ×¡×“×¨ ×”×•×¡×¤×ª ×”×©×’×™××”',0),(217569,6044,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ†Î¬Î»Î¼Î±',0),(217570,6044,'zh','é”™è¯¯ï¼šæ–°å¢žè®¢å•çŠ¶æ€é€‰é¡¹',0),(217571,6044,'sv','Fel att lÃ¤gga Order statusalternativ',0),(217572,6044,'it','Opzione di errore aggiungendo stato ordine',0),(217573,6044,'tl','',0),(217574,6044,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3606;&#3634;&#3609;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3',0),(217575,6044,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤•à¥à¤°à¤® à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(217576,6044,'ms','Ralat menambah perintah Status pilihan',0),(217577,6044,'ar','Ø®Ø·Ø£ Ø¥Ø¶Ø§ÙØ© Ø®ÙŠØ§Ø± Ø­Ø§Ù„Ø© Ø§Ù„Ù†Ø¸Ø§Ù…',0),(217578,6044,'fr','Erreur ajout Order Status Option',0),(217579,6044,'jp','æ³¨æ–‡çŠ¶æ³?ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(217580,6044,'pt','Erro adicionando ordem Status opÃ§Ã£o',0),(217581,6044,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚',0),(217582,6044,'es','Error Agregando OpciÃ³n de Staus de Orden',0),(217583,6044,'de','Fehler beim HinzufÃ¼gen von Order Statusoption',0),(217584,6044,'en','Error Adding Order Status Option',0),(217585,6045,'is','',0),(217586,6045,'dr','Ø´Ø±Ø­ ÙˆØ¶Ø¹ÙŠØª ',0),(217587,6045,'pr','Ø´Ø±Ø­ ÙˆØ¶Ø¹ÙŠØª ',0),(217588,6045,'tr','Durum aÃ§Ä±klamasÄ±',0),(217589,6045,'pl','Opis stanu',0),(217590,6045,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾',0),(217591,6045,'ur','Ø­ÛŒØ«ÛŒØª Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(217592,6045,'sr','ÐžÐ¿Ð¸Ñ ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(217593,6045,'vi','TÃ¬nh tráº¡ng mÃ´ táº£',0),(217594,6045,'af','Status Beskrywing',0),(217595,6045,'ro','Statut Descriere',0),(217596,6045,'et','Oleku kirjeldus',0),(217597,6045,'si','Opis stanja',0),(217598,6045,'ba','Status Keterangan',0),(217599,6045,'nl','Beschrijving van status',0),(217600,6045,'fi','Tilan kuvaus',0),(217601,6045,'no','Beskrivelse',0),(217602,6045,'da','Beskrivelse af integrationsstatus',0),(217603,6045,'ko','ìƒíƒœ ì„¤ëª…',0),(217604,6045,'he','×ª×™××•×¨ ×ž×¦×‘',0),(217605,6045,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(217606,6045,'zh','çŠ¶æ€è¯´æ˜Ž\r\n',0),(217607,6045,'sv','Status Beskrivning',0),(217608,6045,'it','Descrizione dello stato',0),(217609,6045,'tl','',0),(217610,6045,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3626;&#3606;&#3634;&#3609;&#3632;',0),(217611,6045,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤µà¤¿à¤µà¤°à¤£',0),(217612,6045,'ms','Keterangan status',0),(217613,6045,'ar','ÙˆØµÙ Ø§Ù„Ø­Ø§Ù„Ø©',0),(217614,6045,'fr','Description de l\'Ã‰tat',0),(217615,6045,'jp','çŠ¶æ³?è§£èª¬',0),(217616,6045,'pt','DescriÃ§Ã£o status',0),(217617,6045,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ñ',0),(217618,6045,'es','Status DescripciÃ³n',0),(217619,6045,'de','Statusbeschreibung',0),(217620,6045,'en','Status Description',0),(217621,6046,'is','',0),(217622,6046,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(217623,6046,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(217624,6046,'tr','Servis sipariÅŸ durumu seÃ§eneklerini',0),(217625,6046,'pl','Opcje stanu zlecenia serwisowego',0),(217626,6046,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(217627,6046,'ur','Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ø®Ø¯Ù…Øª Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(217628,6046,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(217629,6046,'vi','TÃ¬nh tráº¡ng ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(217630,6046,'af','Diensbestelling Status Opsies',0),(217631,6046,'ro','Optiuni stadiu pentru comanda de service',0),(217632,6046,'et','Hooldustellimuse seisundi valikuid',0),(217633,6046,'si','MoÅ¾nosti stanja servisnega naloga',0),(217634,6046,'ba','Pilihan Status Order Layanan',0),(217635,6046,'nl','Opties voor serviceorderstatus',0),(217636,6046,'fi','Huoltotilauksen tilan vaihtoehdosta',0),(217637,6046,'no','Alternativer for serviceordrestatus',0),(217638,6046,'da','Indstillinger for serviceordrestatus',0),(217639,6046,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ìƒíƒœ ì˜µì…˜',0),(217640,6046,'he','××¤×©×¨×•×™×•×ª ×ž×¦×‘ ×”×–×ž× ×ª ×©×™×¨×•×ª',0),(217641,6046,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚ Ï„ÎµÏ‡Î½Î¹ÎºÎ®Ï‚',0),(217642,6046,'zh','æœåŠ¡è®¢å•çŠ¶æ€é€‰é¡¹\r\n',0),(217643,6046,'sv','Alternativ fÃ¶r Status',0),(217644,6046,'it','Opzioni di stato ordine di servizio',0),(217645,6046,'tl','',0),(217646,6046,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3606;&#3634;&#3609;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(217647,6046,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(217648,6046,'ms','Pilihan Status pesanan Perkhidmatan',0),(217649,6046,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„ÙˆØ¶Ø¹ Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(217650,6046,'fr','Options de statut de commande de service',0),(217651,6046,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡çŠ¶æ³?ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(217652,6046,'pt','OpÃ§Ãµes de Status de ordem de serviÃ§o',0),(217653,6046,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð°Ð¼Ð¸ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° ÑÐµÑ€Ð²Ð¸ÑÐ½Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(217654,6046,'es','Orden de Servicio Status de Opciones',0),(217655,6046,'de','Serviceauftragsstatusoptionen',0),(217656,6046,'en','Service Order Status Options',0),(217657,6047,'is','',0),(217658,6047,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙˆØ¶Ø¹ÙŠØª Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(217659,6047,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙˆØ¶Ø¹ÙŠØª Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(217660,6047,'tr','Servis sipariÅŸlerinin durumu seÃ§enekleri',0),(217661,6047,'pl','Opcje stanu dla zleceÅ„ serwisowych',0),(217662,6047,'bg','ÐžÐ¿Ñ†Ð¸Ð¸Ñ‚Ðµ Ð½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(217663,6047,'ur','Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ø­Ø§Ù„Øª Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(217664,6047,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(217665,6047,'vi','TÃ¬nh tráº¡ng Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(217666,6047,'af','Status Opsies vir Dienste Bestelling',0),(217667,6047,'ro','OpÅ£iuni de stare pentru comenzile de Service',0),(217668,6047,'et','Hooldustellimuste valikuid',0),(217669,6047,'si','MoÅ¾nosti stanja za servisne naloge',0),(217670,6047,'ba','Pilihan status untuk layanan pesanan',0),(217671,6047,'nl','Opties voor serviceorderstatus voor serviceorders',0),(217672,6047,'fi','Tilan vaihtoehtoja huoltotilauksille',0),(217673,6047,'no','Alternativer for serviceordrer',0),(217674,6047,'da','Statusindstillinger for serviceordrer',0),(217675,6047,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ìƒíƒœ ì˜µì…˜',0),(217676,6047,'he','×ž×¦×‘ ××¤×©×¨×•×™×•×ª ×¢×‘×•×¨ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(217677,6047,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(217678,6047,'zh','æœåŠ¡è®¢å•çŠ¶æ€é€‰é¡¹\r\n',0),(217679,6047,'sv','Statusalternativen fÃ¶r serviceorder',0),(217680,6047,'it','Opzioni di stato per gli ordini di servizio',0),(217681,6047,'tl','',0),(217682,6047,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(217683,6047,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¤²à¥à¤ªà¥‹à¤‚ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(217684,6047,'ms','Pilihan status untuk pesanan Perkhidmatan',0),(217685,6047,'ar','ÙˆØ¶Ø¹ Ø®ÙŠØ§Ø±Ø§Øª Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(217686,6047,'fr','Options d\'Ã‰tat pour les commandes de Service',0),(217687,6047,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã?®çŠ¶æ³?ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(217688,6047,'pt','OpÃ§Ãµes de status para ordens de serviÃ§o',0),(217689,6047,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ñ Ð´Ð»Ñ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(217690,6047,'es','Opciones de Status para Ordenes de Servicio',0),(217691,6047,'de','Optionen fÃ¼r ServiceauftrÃ¤ge',0),(217692,6047,'en','Status Options for Service Orders',0),(217693,6048,'is','',0),(217694,6048,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆØ¬Ù‡ Ù†Ù‚Ø¯',0),(217695,6048,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆØ¬Ù‡ Ù†Ù‚Ø¯',0),(217696,6048,'tr','Nakit Ã¶deme',0),(217697,6048,'pl','W gotÃ³wce',0),(217698,6048,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð² Ð±Ñ€Ð¾Ð¹',0),(217699,6048,'ur','Ù†Ù‚Ø¯ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(217700,6048,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸Ð½ÑÐºÑƒ ÑƒÐ¿Ð»Ð°Ñ‚Ñƒ',0),(217701,6048,'vi','Thanh toÃ¡n tiá»n máº·t',0),(217702,6048,'af','Kontant Betaling',0),(217703,6048,'ro','Plata Ã®n numerar',0),(217704,6048,'et','Sularahamakse',0),(217705,6048,'si','Gotovinsko plaÄilo',0),(217706,6048,'ba','Pembayaran tunai',0),(217707,6048,'nl','Contantbetaling',0),(217708,6048,'fi','KÃ¤teismaksu',0),(217709,6048,'no','Kontantbetaling',0),(217710,6048,'da','Kontantbetaling',0),(217711,6048,'ko','í˜„ê¸ˆ ì§€ë¶ˆ',0),(217712,6048,'he','×ª×©×œ×•× ×‘×ž×–×•×ž×Ÿ',0),(217713,6048,'el','Î Î»Î·ÏÏ‰Î¼Î® Î¼ÎµÏ„ÏÎ·Ï„Î¿Î¯Ï‚',0),(217714,6048,'zh','çŽ°é‡‘ä»˜æ¬¾\r\n',0),(217715,6048,'sv','Kontantbetalning',0),(217716,6048,'it','Pagamento in contanti',0),(217717,6048,'tl','',0),(217718,6048,'th','&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;',0),(217719,6048,'hi','à¤¨à¤•à¤¦ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(217720,6048,'ms','Bayaran tunai',0),(217721,6048,'ar','Ø§Ù„Ø¯ÙØ¹ Ù†Ù‚Ø¯Ø§',0),(217722,6048,'fr','Paiement en espÃ¨ces',0),(217723,6048,'jp','ç?¾é‡‘æ”¯æ‰•ã?„',0),(217724,6048,'pt','Pagamento em dinheiro',0),(217725,6048,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ð¼Ð¸',0),(217726,6048,'es','Pago en Efectivo',0),(217727,6048,'de','Barzahlung',0),(217728,6048,'en','Cash Payment',0),(217729,6049,'is','',0),(217730,6049,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(217731,6049,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(217732,6049,'tr','Kredi kartÄ± ile Ã¶deme',0),(217733,6049,'pl','PÅ‚atnoÅ›ci kartÄ… kredytowÄ…',0),(217734,6049,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(217735,6049,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(217736,6049,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(217737,6049,'vi','Thanh ToÃ¡n Tháº» TÃ­n Dá»¥ng ',0),(217738,6049,'af','Kredietkaart Betaling',0),(217739,6049,'ro','Plata prin Card de credit',0),(217740,6049,'et','Krediitkaardiga maksmine',0),(217741,6049,'si','PlaÄilo s kreditno kartico',0),(217742,6049,'ba','Pembayaran kartu kredit',0),(217743,6049,'nl','Credit Card betaling',0),(217744,6049,'fi','Luottokortilla maksaminen',0),(217745,6049,'no','Kredittkortbetaling',0),(217746,6049,'da','Betaling med kreditkort',0),(217747,6049,'ko','ì‹ ìš© ì¹´ë“œ ê²°ì œ',0),(217748,6049,'he','×ª×©×œ×•× ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(217749,6049,'el','Î Î»Î·ÏÏ‰Î¼Î® Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(217750,6049,'zh','ä¿¡ç”¨å¡ä»˜æ¬¾\r\n',0),(217751,6049,'sv','Betalning med kreditkort',0),(217752,6049,'it','Pagamento con carta di credito',0),(217753,6049,'tl','',0),(217754,6049,'th','&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3604;&#3657;&#3623;&#3618;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(217755,6049,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(217756,6049,'ms','Pembayaran dengan kad kredit',0),(217757,6049,'ar','Ø§Ù„Ø¯ÙØ¹ Ø¨ÙˆØ§Ø³Ø·Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(217758,6049,'fr','Paiement par carte de crÃ©dit',0),(217759,6049,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰æ”¯æ‰•',0),(217760,6049,'pt','Pagamento com cartÃ£o de crÃ©dito',0),(217761,6049,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ð¾Ð¹',0),(217762,6049,'es','Tarjeta de CrÃ©dito Pago',0),(217763,6049,'de','Zahlung per Kreditkarte',0),(217764,6049,'en','Credit Card Payment',0),(217765,6050,'is','',0),(217766,6050,'dr','/ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÙŠÚ©Ù‰ Ø³Ø±Ù…Ø§ÙŠÙ‡',0),(217767,6050,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¶Ù…ÙŠÙ…Ù‡/ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÙŠÚ©Ù‰ Ø³Ø±Ù…Ø§ÙŠÙ‡',0),(217768,6050,'tr','ACH/EFT Ã¶deme',0),(217769,6050,'pl','ACH/EFT pÅ‚atnoÅ›ci',0),(217770,6050,'bg','ACH/EFT Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(217771,6050,'ur','Ø§Ú†/EFT Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(217772,6050,'sr','ÐÑ… /Ð•Ð¤Ð¢ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(217773,6050,'vi','Thanh ToÃ¡n ACH/EFT ',0),(217774,6050,'af','ACH/EFT Betaling',0),(217775,6050,'ro','ACH/EFT Plati',0),(217776,6050,'et','ACH/EFT makse',0),(217777,6050,'si','ACH/EFT plaÄilo',0),(217778,6050,'ba','Pembayaran ACH/EFT',0),(217779,6050,'nl','ACH/EFT betaling',0),(217780,6050,'fi','ACH/EFT Payment',0),(217781,6050,'no','ACH/EFT betaling',0),(217782,6050,'da','ACH/EFT betaling',0),(217783,6050,'ko','ACH/ì†¡ê¸ˆ ê²°ì œ',0),(217784,6050,'he','×”×ª×©×œ×•× ACH/EFT',0),(217785,6050,'el','Î‘Ï‡/EFT Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(217786,6050,'zh','è‡ªåŠ¨åŒ–äº¤æ˜“/ç”µæ±‡ä»˜æ¬¾',0),(217787,6050,'sv','ACH/EFT betalning',0),(217788,6050,'it','Pagamento EFT/ACH',0),(217789,6050,'tl','',0),(217790,6050,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3612;&#3656;&#3634;&#3609;&#3619;&#3632;&#3610;&#3610; ACH/EFT',0),(217791,6050,'hi','ACH/à¤ˆà¤à¤«à¤Ÿà¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(217792,6050,'ms','Bayaran men/EFT',0),(217793,6050,'ar','Ø§Ù„Ø¯ÙØ¹ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹/EFT',0),(217794,6050,'fr','Paiement ODC TEF',0),(217795,6050,'jp','ACH/EFT æ”¯æ‰•ã?„',0),(217796,6050,'pt','Pagamento de ACH/EFT',0),(217797,6050,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ACH/EFT',0),(217798,6050,'es','Pago ACH/TEF ',0),(217799,6050,'de','ACH/EFT-Zahlung',0),(217800,6050,'en','ACH/EFT Payment',0),(217801,6051,'is','',0),(217802,6051,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(217803,6051,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(217804,6051,'tr','Kredi kartÄ± ile Ã¶deme',0),(217805,6051,'pl','PÅ‚atnoÅ›ci kartÄ… kredytowÄ…',0),(217806,6051,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(217807,6051,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(217808,6051,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(217809,6051,'vi','Thanh ToÃ¡n Báº±ng Tháº» TÃ­n Dá»¥ng',0),(217810,6051,'af','Kredietkaart Betaling',0),(217811,6051,'ro','Plata prin Card de credit',0),(217812,6051,'et','Maksekaardi makse',0),(217813,6051,'si','PlaÄilo s kreditno kartico',0),(217814,6051,'ba','Pembayaran kartu kredit',0),(217815,6051,'nl','Credit Card betaling',0),(217816,6051,'fi','Luottokortilla maksaminen',0),(217817,6051,'no','Kredittkortbetaling',0),(217818,6051,'da','Betaling med kreditkort',0),(217819,6051,'ko','ì‹ ìš© ì¹´ë“œ ê²°ì œ',0),(217820,6051,'he','×ª×©×œ×•× ×‘××ž×¦×¢×•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(217821,6051,'el','Î Î»Î·ÏÏ‰Î¼Î® Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(217822,6051,'zh','ä¿¡ç”¨å¡ä»˜æ¬¾\r\n',0),(217823,6051,'sv','Betalning med kreditkort',0),(217824,6051,'it','Pagamento con carta di credito',0),(217825,6051,'tl','',0),(217826,6051,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3604;&#3657;&#3623;&#3618;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(217827,6051,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(217828,6051,'ms','Pembayaran dengan kad kredit',0),(217829,6051,'ar','Ø§Ù„Ø¯ÙØ¹ Ø¨ÙˆØ§Ø³Ø·Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(217830,6051,'fr','Paiement par carte de crÃ©dit',0),(217831,6051,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰æ”¯æ‰•ã?„',0),(217832,6051,'pt','Pagamento com cartÃ£o de crÃ©dito',0),(217833,6051,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ð¾Ð¹',0),(217834,6051,'es','Tarjeta de CrÃ©dito Pago',0),(217835,6051,'de','Zahlung per Kreditkarte',0),(217836,6051,'en','Credit Card Payment',0),(217837,6052,'is','',0),(217838,6052,'dr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ Ø­Ù‚ÙˆÙ‚',0),(217839,6052,'pr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ Ø­Ù‚ÙˆÙ‚',0),(217840,6052,'tr','Ã–deme nasÄ±l',0),(217841,6052,'pl','Jak pÅ‚aciÄ‡',0),(217842,6052,'bg','ÐžÐ±ÑŠÑ€Ð½ÐµÑ‚Ðµ ÐºÐ°Ðº',0),(217843,6052,'ur','Ø§Ø¯Ø§ Ú©ÛŒØ³Û’',0),(217844,6052,'sr','ÐžÐ±Ñ€Ð°Ñ‚Ð¸ ÐºÐ°ÐºÐ¾',0),(217845,6052,'vi','Tráº£ nhÆ° tháº¿ nÃ o',0),(217846,6052,'af','Manier waarop Betaling Geskied',0),(217847,6052,'ro','Cum plÄƒtiÅ£i',0),(217848,6052,'et','Tasulepete kuidas',0),(217849,6052,'si','PlaÄate kako',0),(217850,6052,'ba','Cara membayar',0),(217851,6052,'nl','Hoe u kunt betalen',0),(217852,6052,'fi','Maksaa miten',0),(217853,6052,'no','Betale hvordan',0),(217854,6052,'da','Betale hvordan',0),(217855,6052,'ko','ì§€ë¶ˆ ë°©ë²•',0),(217856,6052,'he','××™×š ×œ×©×œ×',0),(217857,6052,'el','Î”ÏŽÏƒÏ„Îµ Ï€ÏŽÏ‚',0),(217858,6052,'zh','å¦‚ä½•æ”¯ä»˜\r\n',0),(217859,6052,'sv','Betala hur',0),(217860,6052,'it','Come pagare',0),(217861,6052,'tl','',0),(217862,6052,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(217863,6052,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥ˆà¤¸à¥‡',0),(217864,6052,'ms','Bagaimana membayar',0),(217865,6052,'ar','ÙƒÙŠÙ Ù†Ø¯ÙØ¹',0),(217866,6052,'fr','Comment payer',0),(217867,6052,'jp','æ”¯æ‰•ã?„æ–¹æ³•',0),(217868,6052,'pt','Como pagar',0),(217869,6052,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ ÐšÐ°Ðº',0),(217870,6052,'es','CÃ³mo Pagar',0),(217871,6052,'de','Zahlen wie',0),(217872,6052,'en','Pay How',0),(217873,6053,'is','',0),(217874,6053,'dr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(217875,6053,'pr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(217876,6053,'tr','Kredi kartÄ±',0),(217877,6053,'pl','Karta kredytowa',0),(217878,6053,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(217879,6053,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ',0),(217880,6053,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(217881,6053,'vi','Tháº» TÃ­n Dá»¥ng',0),(217882,6053,'af','Kredietkaart',0),(217883,6053,'ro','Card de credit',0),(217884,6053,'et','Maksekaart',0),(217885,6053,'si','Kreditne kartice',0),(217886,6053,'ba','Kartu kredit',0),(217887,6053,'nl','Credit Card',0),(217888,6053,'fi','Luottokortti',0),(217889,6053,'no','Kredittkort',0),(217890,6053,'da','Kreditkort',0),(217891,6053,'ko','ì‹ ìš© ì¹´ë“œ',0),(217892,6053,'he','×›×¨×˜×™×¡ ××©×¨××™',0),(217893,6053,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(217894,6053,'zh','ä¿¡ç”¨å¡\r\n',0),(217895,6053,'sv','Kreditkort',0),(217896,6053,'it','Carta di credito',0),(217897,6053,'tl','',0),(217898,6053,'th','&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(217899,6053,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡',0),(217900,6053,'ms','Kad kredit',0),(217901,6053,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø¥Ø¦ØªÙ…Ø§Ù†',0),(217902,6053,'fr','Carte de crÃ©dit',0),(217903,6053,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰',0),(217904,6053,'pt','CartÃ£o de crÃ©dito',0),(217905,6053,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ ÐšÐ°Ñ€Ñ‚Ð°',0),(217906,6053,'es','Tarjeta de CrÃ©dito',0),(217907,6053,'de','Kreditkarte',0),(217908,6053,'en','Credit Card',0),(217909,6054,'is','',0),(217910,6054,'dr','EFT  Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÙŠÚ©Ù‰ Ø¯Ø§Ø±Ø§Ø¦Ù‰ ',0),(217911,6054,'pr','EFT  Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÙŠÚ©Ù‰ Ø¯Ø§Ø±Ø§Ø¦Ù‰ ',0),(217912,6054,'tr','EFT',0),(217913,6054,'pl','TRYTON',0),(217914,6054,'bg','Ð•ÐŸÐ¡',0),(217915,6054,'ur','EFT',0),(217916,6054,'sr','Ð•Ð¤Ð¢',0),(217917,6054,'vi','EFT',0),(217918,6054,'af','EFT',0),(217919,6054,'ro','EFT',0),(217920,6054,'et','EFT',0),(217921,6054,'si','EFT',0),(217922,6054,'ba','TDE',0),(217923,6054,'nl','EFT',0),(217924,6054,'fi','EFT',0),(217925,6054,'no','EFT',0),(217926,6054,'da','EFT',0),(217927,6054,'ko','ì „ìž ì†¡ê¸ˆ',0),(217928,6054,'he','EFT',0),(217929,6054,'el','EFT',0),(217930,6054,'zh','ç”µå­è½¬å¸\r\n',0),(217931,6054,'sv','EFT',0),(217932,6054,'it','EFT',0),(217933,6054,'tl','',0),(217934,6054,'th','EFT',0),(217935,6054,'hi','à¤ˆà¤à¤«à¤¼à¤Ÿà¥€',0),(217936,6054,'ms','EFT',0),(217937,6054,'ar','ØªÙ‚Ù†ÙŠØ© Ø§Ù„Ø­Ø±ÙŠØ© Ø§Ù„Ù†ÙØ³ÙŠØ©',0),(217938,6054,'fr','EFT',0),(217939,6054,'jp','EFT',0),(217940,6054,'pt','EFT',0),(217941,6054,'ru','EFT',0),(217942,6054,'es','EFT',0),(217943,6054,'de','EFT',0),(217944,6054,'en','EFT',0),(217945,6055,'is','',0),(217946,6055,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ù‡ Ø¹Ù„Øª ØªØ¶Ø§Ø¯ Ø¨Ø§ Ø´Ù…Ø§Ø±Ù‡ Ù…ÙˆØ¬ÙˆØ¯ ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(217947,6055,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ù‡ Ø¹Ù„Øª ØªØ¶Ø§Ø¯ Ø¨Ø§ Ø´Ù…Ø§Ø±Ù‡ Ù…ÙˆØ¬ÙˆØ¯ ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(217948,6055,'tr','Varolan sayÄ± ile Ã§akÄ±ÅŸma nedeniyle PO numarasÄ± deÄŸiÅŸti',0),(217949,6055,'pl','Numer PO zmianie ze wzglÄ™du na konflikt z istniejÄ…cym numerem',0),(217950,6055,'bg','PO Ñ‡Ð¸ÑÐ»Ð¾ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð¿Ð¾Ñ€Ð°Ð´Ð¸ ÐºÐ¾Ð½Ñ„Ð»Ð¸ÐºÑ‚ ÑÑŠÑ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰ Ð½Ð¾Ð¼ÐµÑ€',0),(217951,6055,'ur','Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± Ù…ÙˆØ¬ÙˆØ¯Û ØªØ¹Ø¯Ø§Ø¯ Ú©Û’ Ú©Û’ Ø³Ø§ØªÚ¾ ØªÙ†Ø§Ø²Ø¹Û Ú©ÛŒ ÙˆØ¬Û Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(217952,6055,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐÐ°Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð¾ Ð·Ð±Ð¾Ð³ ÑÑƒÐºÐ¾Ð±Ð° ÑÐ° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸Ð¼ Ð±Ñ€Ð¾Ñ˜ÐµÐ¼',0),(217953,6055,'vi','Sá»‘ Ä‘Æ¡n mua hÃ ng thay Ä‘á»•i vÃ¬ khÃ´ng tÆ°Æ¡ng thÃ­ch vá»›i sá»‘ Ä‘Ã£ cÃ³',0),(217954,6055,'af','Posbus nommer verander weens konflik met bestaande nommer',0),(217955,6055,'ro','NumÄƒrul bonului de comandÄƒ s-a schimbat din cauza conflictului cu numÄƒrul actual de',0),(217956,6055,'et','PO koodi muuta tÃµttu vastuollu olemasoleva numbri',0),(217957,6055,'si','Å tevilka NaroÄilnice spremenila zaradi spora z obstojeÄo Å¡tevilko',0),(217958,6055,'ba','Nomor PO berubah karena konflik dengan nomor yang ada',0),(217959,6055,'nl','PO-nummer gewijzigd als gevolg van conflict met bestaande nummer',0),(217960,6055,'fi','Ostotilauksen numero muuttunut ristiriidassa aiempaa numeroa',0),(217961,6055,'no','InnkjÃ¸psordrenummer endret pÃ¥ grunn av konflikt med eksisterende nummer',0),(217962,6055,'da','PO-nummer Ã¦ndret pÃ¥ grund af konflikt med eksisterende nummer',0),(217963,6055,'ko','ì£¼ë¬¸ì„œ ë²ˆí˜¸ ë³€ê²½ ê¸°ì¡´ ë²ˆí˜¸ì™€ì˜ ì¶©ëŒ',0),(217964,6055,'he','×ž×¡×¤×¨ ×”-PO ×ž×©×ª× ×” ×¢×§×‘ ×¡×›×¡×•×š ×¢× ×”×ž×¡×¤×¨ ×”×§×™×™×',0),(217965,6055,'el','Î‘Ï Î Î±ÏÎ±Î³Î³ Î¬Î»Î»Î±Î¾Îµ Î»ÏŒÎ³Ï‰ ÏƒÏÎ³ÎºÏÎ¿Ï…ÏƒÎ· Î¼Îµ Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(217966,6055,'zh','ç”±äºŽä¸ŽçŽ°æœ‰è®¢å•å·å†²çªï¼Œæ­¤è®¢å•å·ç å·²å˜æ›´\r\n',0),(217967,6055,'sv','InkÃ¶psordernummer fÃ¶rÃ¤ndrats pÃ¥ grund av konflikter med befintliga nummer',0),(217968,6055,'it','Numero PO cambiato a causa del conflitto con numero esistente',0),(217969,6055,'tl','',0),(217970,6055,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591; &#3648;&#3609;&#3639;&#3656;&#3629;&#',0),(217971,6055,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤‚à¤˜à¤°à¥à¤· à¤•à¥‡ à¤•à¤¾à¤°à¤£ à¤ªà¥‹ à¤¨à¤‚à¤¬à¤° à¤¬à¤¦à¤² à¤—à¤¯à¤¾',0),(217972,6055,'ms','Nombor PO berubah kerana konflik dengan nombor yang sedia ada',0),(217973,6055,'ar','Ø±Ù‚Ù… Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡ Ù‚Ø¯ ØªØºÙŠØ± Ø¨Ø³Ø¨Ø¨ Ø§Ù„ØµØ±Ø§Ø¹ Ù…Ø¹ Ø§Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯',0),(217974,6055,'fr','NumÃ©ro de PO changÃ© en raison de conflits avec le numÃ©ro existant',0),(217975,6055,'jp','æ—¢å­˜ã?®æ•°å­—ã?¨é‡?è¤‡ã?—ã?¦ã?„ã‚‹ç‚ºPOç•ªå?·ã‚’å¤‰æ›´ã?—ã?¾ã?—ã?Ÿ',0),(217976,6055,'pt','PO nÃºmero alterado devido a conflito com nÃºmero existente',0),(217977,6055,'ru','PO Ð½Ð¾Ð¼ÐµÑ€ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½ Ð¸Ð·-Ð·Ð° ÐºÐ¾Ð½Ñ„Ð»Ð¸ÐºÑ‚Ð° Ñ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¼ Ð½Ð¾Ð¼ÐµÑ€Ð¾Ð¼',0),(217978,6055,'es','OC NÃºmero cambiado debido a un conflicto con el nÃºmero existente',0),(217979,6055,'de','PO-Nummer geÃ¤ndert aufgrund von Konflikten mit vorhandenen Anzahl',0),(217980,6055,'en','PO Number changed due to conflict with existing number',0),(217981,6056,'is','',0),(217982,6056,'dr','Ø¹Ø¯Ù… Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(217983,6056,'pr','Ø¹Ø¯Ù… Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(217984,6056,'tr','BorÃ§lar iÃ§in hiÃ§ sonrasÄ±',0),(217985,6056,'pl','Nie ma Post do zobowiÄ…zaÅ„',0),(217986,6056,'bg','ÐÑÐ¼Ð° Ð¿Ð¾ÑÑ‚ Ð·Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(217987,6056,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ù¾ÙˆØ³Ù¹',0),(217988,6056,'sr','ÐÐµ ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶Ð¸ Ñƒ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(217989,6056,'vi','ChÆ°a káº¿t chuyá»ƒn sang Pháº£i Tráº£',0),(217990,6056,'af','Geen posterings na Uitgawes (RB)',0),(217991,6056,'ro','Nici un Post la datorii',0),(217992,6056,'et','Blackhat vÃµlad',0),(217993,6056,'si','Post, da obveznosti',0),(217994,6056,'ba','Tidak ada posting untuk hutang',0),(217995,6056,'nl','Geen Post aan schulden',0),(217996,6056,'fi','YhtÃ¤Ã¤n viestiÃ¤ Ostovelat',0),(217997,6056,'no','Ingen innlegg i leverandÃ¸rgjeld',0),(217998,6056,'da','Ingen Post til gÃ¦ld',0),(217999,6056,'ko','ì•„ë¬´ ê²Œì‹œë¬¼ ë¯¸ì§€ê¸‰ê¸ˆì„',0),(218000,6056,'he','. ××™×Ÿ ×“×•××¨ ×›×“×™ ×–×›××™×',0),(218001,6056,'el','ÎšÎ±Î¼Î¯Î± Î¸Î­ÏƒÎ· Î½Î± Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(218002,6056,'zh','æ²¡æœ‰å¯æ”¯ä»˜é‚®å¯„\r\n',0),(218003,6056,'sv','Ingen Post till leverantÃ¶rsskulder',0),(218004,6056,'it','Nessun messaggio da debiti',0),(218005,6056,'tl','',0),(218006,6056,'th','&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(218007,6056,'hi','à¤•à¥‹à¤ˆ à¤ªà¥‹à¤¸à¥à¤Ÿ Payables à¤•à¥‡ à¤²à¤¿à¤',0),(218008,6056,'ms','Tiada pos kepada pemiutang',0),(218009,6056,'ar','Ø£ÙŠ ÙˆØ¸ÙŠÙØ© Ù„Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(218010,6056,'fr','Aucun poste Ã  des comptes fournisseurs',0),(218011,6056,'jp','è²·æŽ›é‡‘ã?¨ã?—ã?¦è¨ˆä¸Šã?—ã?ªã?„',0),(218012,6056,'pt','NÃ£o hÃ¡ correio para contas a pagar',0),(218013,6056,'ru','ÐÐ¸ Ð¾Ð´Ð½Ð° Ð´Ð¾Ð»Ð¶Ð½Ð¾ÑÑ‚ÑŒ Ð´Ð»Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(218014,6056,'es','No Hay Asiento a Proveedores',0),(218015,6056,'de','Keine Post an Verbindlichkeiten',0),(218016,6056,'en','No Post to Payables',0),(218017,6057,'is','',0),(218018,6057,'dr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡ Ø³ÙØ§Ø±Ø´ Ø§Ø³Øª',0),(218019,6057,'pr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡ Ø³ÙØ§Ø±Ø´ Ø§Ø³Øª',0),(218020,6057,'tr','BaÄŸlÄ± olduÄŸu sipariÅŸ',0),(218021,6057,'pl','DoÅ‚Ä…czony jest zamÃ³wienie',0),(218022,6057,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¾ Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(218023,6057,'ur','ØªØ±ØªÛŒØ¨ Ø³Û’ Ù…Ù†Ø³Ù„Ú© ÛÛ’',0),(218024,6057,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ð°',0),(218025,6057,'vi','KÃ¨m Theo LÃ  ÄÆ¡n Äáº·t HÃ ng',0),(218026,6057,'af','Bestelling is Aangeheg',0),(218027,6057,'ro','AtaÅŸat este ordinea',0),(218028,6057,'et','Lisatud on jÃ¤rjekorras',0),(218029,6057,'si','PriloÅ¾en je naloga',0),(218030,6057,'ba','Terlampir adalah urutan',0),(218031,6057,'nl','Bijgevoegd is orde',0),(218032,6057,'fi','LiitteenÃ¤ on jÃ¤rjestyksessÃ¤',0),(218033,6057,'no','Vedlagt er ordre',0),(218034,6057,'da','VedhÃ¦ftet er ordre',0),(218035,6057,'ko','ìˆœì„œëŠ” ì²¨ë¶€',0),(218036,6057,'he','×ž×¦×•×¨×¤×ª ×”×–×ž× ×”',0),(218037,6057,'el','Î”Î¯Ï€Î»Î± Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÏƒÎµÎ¹ÏÎ¬',0),(218038,6057,'zh','éšä¿¡é™„ä¸Šè®¢å•\r\n',0),(218039,6057,'sv','Bifogat Ã¤r ordning',0),(218040,6057,'it','In allegato Ã¨ ordine',0),(218041,6057,'tl','',0),(218042,6057,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3649;&#3609;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(218043,6057,'hi','à¤¸à¤‚à¤²à¤—à¥à¤¨ à¤•à¥à¤°à¤® à¤¹à¥ˆ',0),(218044,6057,'ms','Berikut adalah perintah',0),(218045,6057,'ar','ØªÙˆÙ„ÙŠ Ù‡Ùˆ ØªØ±ØªÙŠØ¨',0),(218046,6057,'fr','AttachÃ© est arrÃªtÃ©',0),(218047,6057,'jp','æ³¨æ–‡ã‚’æ·»ä»˜ã?—ã?¾ã?—ã?Ÿ',0),(218048,6057,'pt','Em anexo Ã© ordem',0),(218049,6057,'ru','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(218050,6057,'es','Anexado es el Pedido',0),(218051,6057,'de','Angeschlossen ist die Reihenfolge',0),(218052,6057,'en','Attached is Order',0),(218053,6058,'is','',0),(218054,6058,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø³ÙØ§Ø±Ø´ ',0),(218055,6058,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø³ÙØ§Ø±Ø´ ',0),(218056,6058,'tr','E-posta sipariÅŸ',0),(218057,6058,'pl','E-mail zamÃ³wienia',0),(218058,6058,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¸Ð¼ÐµÐ¹Ð»',0),(218059,6058,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(218060,6058,'sr','ÐÐ°Ð»Ð¾Ð³ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(218061,6058,'vi','Gá»­i Email Ä‘Æ¡n Ä‘áº·t hÃ ng ',0),(218062,6058,'af','E-pos Bestelling',0),(218063,6058,'ro','Email comanda',0),(218064,6058,'et','Email tellimus',0),(218065,6058,'si','Email naloga',0),(218066,6058,'ba','Email Order',0),(218067,6058,'nl','E-mail Order',0),(218068,6058,'fi','SÃ¤hkÃ¶posti jotta',0),(218069,6058,'no','E-post bestilling',0),(218070,6058,'da','E-mail bestilling',0),(218071,6058,'ko','ì´ë©”ì¼ ì£¼ë¬¸',0),(218072,6058,'he','×¡×“×¨ ×“×•×',0),(218073,6058,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(218074,6058,'zh','ç”µé‚®è®¢è´­\r\n',0),(218075,6058,'sv','E-bestÃ¤llning',0),(218076,6058,'it','E-mail ordine',0),(218077,6058,'tl','',0),(218078,6058,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(218079,6058,'hi','à¤ˆà¤®à¥‡à¤² à¤•à¥à¤°à¤®',0),(218080,6058,'ms','E-mel perintah',0),(218081,6058,'ar','Ù†Ø¸Ø§Ù… Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(218082,6058,'fr','Commande par courriel',0),(218083,6058,'jp','Eãƒ¡ãƒ¼ãƒ«æ³¨æ–‡',0),(218084,6058,'pt','Ordem de e-mail',0),(218085,6058,'ru','Ð•mail Ð—Ð°ÐºÐ°Ð·',0),(218086,6058,'es','Email Orden',0),(218087,6058,'de','E-Mail-Bestellung',0),(218088,6058,'en','Email Order',0),(218089,6059,'is','',0),(218090,6059,'dr','ØªØ§ÙŠÙŠØ¯ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø±Ø³ÙŠØ¯Ù‡',0),(218091,6059,'pr','ØªØ§ÙŠÙŠØ¯ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø±Ø³ÙŠØ¯Ù‡',0),(218092,6059,'tr','Ä°thal AP faturalar',0),(218093,6059,'pl','AP faktury importowane',0),(218094,6059,'bg','AP Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð²Ð½Ð¾Ñ',0),(218095,6059,'ur','AP ÙˆØ¨Ø¬Ù„ÛŒ Ø¯Ø±Ø¢Ù…Ø¯',0),(218096,6059,'sr','ÐÐŸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÑƒÐ²ÐµÐ·ÐµÐ½',0),(218097,6059,'vi','Nháº­p HÃ³a ÄÆ¡n AP',0),(218098,6059,'af','RB Fakture Ingevoer',0),(218099,6059,'ro','AP facturi importate',0),(218100,6059,'et','AP arveid importida',0),(218101,6059,'si','AP raÄunov, uvoÅ¾enih',0),(218102,6059,'ba','AP faktur diimpor',0),(218103,6059,'nl','AP facturen ingevoerd',0),(218104,6059,'fi','AP-laskujen tuotu',0),(218105,6059,'no','AP-fakturaer som er importert',0),(218106,6059,'da','AP fakturaer importeret',0),(218107,6059,'ko','AP ì†¡ìž¥ ìˆ˜ìž…',0),(218108,6059,'he','×—×©×‘×•× ×™×•×ª AP ×ž×™×•×‘××™×',0),(218109,6059,'el','AP Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(218110,6059,'zh','åº”ä»˜è´¦æ¬¾è¿›å£å‘ç¥¨\r\n',0),(218111,6059,'sv','LeverantÃ¶rsreskontrafakturor importeras',0),(218112,6059,'it','AP fatture importate',0),(218113,6059,'tl','',0),(218114,6059,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(218115,6059,'hi','à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ à¤à¤ªà¥€ à¤šà¤¾à¤²à¤¾à¤¨',0),(218116,6059,'ms','Invois-invois AP yang diimport',0),(218117,6059,'ar','AP ÙÙˆØ§ØªÙŠØ± Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(218118,6059,'fr','AP factures importÃ©es',0),(218119,6059,'jp','ã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆã?—ã?ŸAPè«‹æ±‚æ›¸',0),(218120,6059,'pt','AP facturas importadas',0),(218121,6059,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ AP',0),(218122,6059,'es','CP Facturas Importadas',0),(218123,6059,'de','AP Rechnungen importiert',0),(218124,6059,'en','AP Invoices Imported',0),(218125,6060,'is','',0),(218126,6060,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒÙ„',0),(218127,6060,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ ÙƒÙ„',0),(218128,6060,'tr','Toplam Ã§alÄ±ÅŸma',0),(218129,6060,'pl','CaÅ‚kowita iloÅ›Ä‡ pracy',0),(218130,6060,'bg','ÐžÐ±Ñ‰Ð¾ Ñ‚Ñ€ÑƒÐ´',0),(218131,6060,'ur','Ú©Ù„ Ø¬Ø¨Ø±ÛŒ Ù…Ø´Ù‚Øª',0),(218132,6060,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ñ€Ð°Ð´Ð½Ð° ÑÐ½Ð°Ð³Ð°',0),(218133,6060,'vi','Tá»•ng cá»™ng nhÃ¢n cÃ´ng',0),(218134,6060,'af','Tale Arbeid',0),(218135,6060,'ro','ForÅ£ei de muncÄƒ totalÄƒ',0),(218136,6060,'et','Kokku tÃ¶Ã¶',0),(218137,6060,'si','Skupno delo',0),(218138,6060,'ba','Total tenaga kerja',0),(218139,6060,'nl','Totale arbeid',0),(218140,6060,'fi','TyÃ¶mÃ¤Ã¤rÃ¤ yhteensÃ¤',0),(218141,6060,'no','Totalantallet',0),(218142,6060,'da','Samlede arbejdsmÃ¦ngde',0),(218143,6060,'ko','ì´ ë…¸ë™',0),(218144,6060,'he','×¡×” ×› ×¢×‘×•×“×”',0),(218145,6060,'el','Î£ÏÎ½Î¿Î»Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(218146,6060,'zh','æ€»äººå·¥\r\n',0),(218147,6060,'sv','Totala arbetskraft',0),(218148,6060,'it','Ore totali',0),(218149,6060,'tl','',0),(218150,6060,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(218151,6060,'hi','à¤•à¥à¤² à¤¶à¥à¤°à¤®',0),(218152,6060,'ms','Jumlah buruh',0),(218153,6060,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø¹Ù…Ø§Ù„Ø©',0),(218154,6060,'fr','Travail total',0),(218155,6060,'jp','åŠ´åƒ?è€…ç·?æ•°',0),(218156,6060,'pt','Trabalho total',0),(218157,6060,'ru','Ð’ÑÐµÐ³Ð¾ Ñ‚Ñ€ÑƒÐ´Ð°',0),(218158,6060,'es','Total Labor',0),(218159,6060,'de','Gesamtarbeit',0),(218160,6060,'en','Total Labor',0),(218161,6061,'is','',0),(218162,6061,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø±Ø§ Ø­ÙØ¸ ÙƒÙ†ÙŠØ¯ â€“ Ù†Ø§Ù… Ù‡Ø§ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(218163,6061,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø±Ø§ Ø­ÙØ¸ ÙƒÙ†ÙŠØ¯ â€“ Ù†Ø§Ù… Ù‡Ø§ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(218164,6061,'tr','AyrÄ±ntÄ± tutmak - adlarÄ± gÃ¶sterme',0),(218165,6061,'pl','ZachowaÄ‡ szczegÃ³Å‚y - nie Pokazuj nazwy',0),(218166,6061,'bg','Ð—Ð°Ð¿Ð°Ð·Ð¸ Ð´ÐµÑ‚Ð°Ð¹Ð» - Ð½Ðµ ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð¸Ð¼ÐµÐ½Ð°Ñ‚Ð°',0),(218167,6061,'ur','ØªÙØµÛŒÙ„ Ø±Ú©Ú¾ÛŒÚº - Ù†Ø§Ù… Ù…Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(218168,6061,'sr','Ð¡Ñ‚Ð°Ð»Ð½Ð¾ Ð´ÐµÑ‚Ð°Ñ™ - Ð½Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜ Ð¸Ð¼ÐµÐ½Ð°',0),(218169,6061,'vi','Giá»¯ chi tiáº¿t - Ä‘á»«ng hiá»ƒn thá»‹ tÃªn',0),(218170,6061,'af','Behou Detail - moenie name wys',0),(218171,6061,'ro','PÄƒstraÅ£i detaliu - AratÄƒ nume',0),(218172,6061,'et','Hoida Detail - Kuva nimed',0),(218173,6061,'si','Voditi podrobno â€“ ne PokaÅ¾i imena',0),(218174,6061,'ba','Menjaga Detail - tidak menunjukkan nama',0),(218175,6061,'nl','Houd Detail - vertonen geen namen',0),(218176,6061,'fi','SÃ¤ilyttÃ¤Ã¤ yksityiskohtia - Ã„lÃ¤ NÃ¤ytÃ¤ nimet',0),(218177,6061,'no','Holde detalj - ikke Vis navn',0),(218178,6061,'da','Holde detaljer - viser ikke navne',0),(218179,6061,'ko','ì„¸ë¶€ ì‚¬í•­-ì´ë¦„ í‘œì‹œ ì•ˆ í•¨',0),(218180,6061,'he','×œ×”×©××™×¨ ×¤×¨×˜×™× - ××œ ×ª×¨××” ×©×ž×•×ª',0),(218181,6061,'el','ÎšÏÎ±Ï„Î®ÏƒÎµÎ¹ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± - Î´ÎµÎ½ Î´ÎµÎ¯Ï‡Î½Î¿Ï…Î½ Î¿Î½ÏŒÎ¼Î±Ï„Î±',0),(218182,6061,'zh','ä¿æŒå†…å®¹- ä¸æ˜¾ç¤ºå§“å\r\n',0),(218183,6061,'sv','HÃ¥ll detalj - visar inte namn',0),(218184,6061,'it','Mantenere il dettaglio - non mostrare nomi',0),(218185,6061,'tl','',0),(218186,6061,'th','&#3648;&#3585;&#3655;&#3610;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604; &#3652;&#3617;&#3656;&#3605;&#3657;&#3629;&#3591;&#3649;&#3626;&#3604;&#3591;&#3594;&#3639;&#3656;&#3629;',0),(218187,6061,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤°à¤–à¥‡à¤‚ - à¤¨à¤¾à¤® à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(218188,6061,'ms','Memastikan terperinci - menunjukkan nama-nama',0),(218189,6061,'ar','Ø§Ù„Ø§Ø­ØªÙØ§Ø¸ Ø¨Ø§Ù„ØªÙØµÙŠÙ„-Ø¹Ø¯Ù… Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø£Ø³Ù…Ø§Ø¡',0),(218190,6061,'fr','Gardez dÃ©tail - ne montrent pas de noms',0),(218191,6061,'jp','è©³ç´°ã?®ä¿?å­˜ãƒ¼å??å‰?ã?¯è¡¨ç¤ºã?—ã?ªã?„',0),(218192,6061,'pt','Manter o detalhe - nÃ£o mostrar nomes',0),(218193,6061,'ru','Ð£Ð´ÐµÑ€Ð¶Ð°Ñ‚ÑŒ Ð”ÐµÑ‚Ð°Ð»Ð¸ - Ð½Ðµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð¸Ð¼ÐµÐ½Ð°',0),(218194,6061,'es','Guardar Detalle - no muestra los nombres',0),(218195,6061,'de','Halten Sie die Detail - Namen werden nicht angezeigt',0),(218196,6061,'en','Keep Detail - do not show names',0),(218197,6062,'is','',0),(218198,6062,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø³Ø·Ø± Ø§ØµÙ„ÙŠ Ø±Ø§ Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÙŠØ¯ ',0),(218199,6062,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø³Ø·Ø± Ø§ØµÙ„ÙŠ Ø±Ø§ Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÙŠØ¯ ',0),(218200,6062,'tr','AyrÄ±ntÄ± tutmak - adlarÄ± gÃ¶ster',0),(218201,6062,'pl','ZachowaÄ‡ szczegÃ³Å‚y - PokaÅ¼ nazwy',0),(218202,6062,'bg','Ð—Ð°Ð¿Ð°Ð·Ð¸ Ð´ÐµÑ‚Ð°Ð¹Ð» - Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ½Ð°',0),(218203,6062,'ur','ØªÙØµÛŒÙ„ Ø±Ú©Ú¾ÛŒÚº - Ù†Ø§Ù… Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(218204,6062,'sr','Ð¡Ñ‚Ð°Ð»Ð½Ð¾ Ð´ÐµÑ‚Ð°Ñ™ - ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð¼ÐµÐ½Ð°',0),(218205,6062,'vi','Giá»¯ chi tiáº¿t - hiá»ƒn thá»‹ tÃªn',0),(218206,6062,'af','Behou Detail - wys name',0),(218207,6062,'ro','PÄƒstraÅ£i detaliu - AratÄƒ nume',0),(218208,6062,'et','Hoida Detail - Kuva nimed',0),(218209,6062,'si','Voditi podrobno - PokaÅ¾i imena',0),(218210,6062,'ba','Menjaga Detail - Tampilkan nama',0),(218211,6062,'nl','Houd Detail - namen weergeven',0),(218212,6062,'fi','PitÃ¤Ã¤ yksityiskohta - NÃ¤ytÃ¤ nimet',0),(218213,6062,'no','Holde detalj - Vis navn',0),(218214,6062,'da','Holde detaljer - Vis navne',0),(218215,6062,'ko','ì„¸ë¶€ ì‚¬í•­-ì´ë¦„ í‘œì‹œ',0),(218216,6062,'he','×œ×”×©××™×¨ ×¤×¨×˜×™× - ×”×¦×’ ×©×ž×•×ª',0),(218217,6062,'el','ÎšÏÎ±Ï„Î®ÏƒÎµÎ¹ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± - Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¿Î½Î¿Î¼Î¬Ï„Ï‰Î½',0),(218218,6062,'zh','ä¿æŒè¯¦æƒ… -æ˜¾ç¤ºåç§°\r\n',0),(218219,6062,'sv','HÃ¥lla detalj - Visa namn',0),(218220,6062,'it','Mantenere il dettaglio - visualizza i nomi',0),(218221,6062,'tl','',0),(218222,6062,'th','&#3648;&#3585;&#3655;&#3610;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604; &#3649;&#3626;&#3604;&#3591;&#3594;&#3639;&#3656;&#3629;',0),(218223,6062,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤°à¤–à¥‡à¤‚ - à¤¨à¤¾à¤® à¤¦à¤¿à¤–à¤¾à¤à¤',0),(218224,6062,'ms','Memastikan terperinci - menunjukkan nama-nama',0),(218225,6062,'ar','Ø§Ù„Ø§Ø­ØªÙØ§Ø¸ Ø¨Ø§Ù„ØªÙØµÙŠÙ„-Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø£Ø³Ù…Ø§Ø¡',0),(218226,6062,'fr','Gardez dÃ©tail - afficher les noms',0),(218227,6062,'jp','è©³ç´°ã?®ä¿?å­˜ãƒ¼å??å‰?ã‚’è¡¨ç¤ºã?™ã‚‹',0),(218228,6062,'pt','Manter o detalhe - mostrar nomes',0),(218229,6062,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð”ÐµÑ‚Ð°Ð»Ð¸ - Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ñ',0),(218230,6062,'es','Guardar Detalle - muestr los nombres',0),(218231,6062,'de','Halten Sie die Detail - Namen anzeigen',0),(218232,6062,'en','Keep Detail - show names',0),(218233,6063,'is','',0),(218234,6063,'dr','( Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ù†Ø±Ø® Ùˆ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(218235,6063,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø®Ù„Ø§ØµÙ‡ ( Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ù†Ø±Ø® Ùˆ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(218236,6063,'tr','En bÃ¼yÃ¼k Ã–zet (hÄ±zÄ± ve Ã§alÄ±ÅŸma gruplarÄ±)',0),(218237,6063,'pl','Maksymalnie KrÃ³tki opis (grup przez stawkÄ™ i rodzaj pracy)',0),(218238,6063,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ Ð ÐµÐ·ÑŽÐ¼Ðµ (Ð³Ñ€ÑƒÐ¿Ð¸ Ð¾Ñ‚ ÑÐºÐ¾Ñ€Ð¾ÑÑ‚Ñ‚Ð° Ð¸ Ñ‚Ð¸Ð¿Ð° Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°)',0),(218239,6063,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø®Ù„Ø§ØµÛ (Ú¯Ø±ÙˆÛÙˆÚº Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ú©Ø§Ù… Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª Ø§ÙˆØ± Ø´Ø±Ø­)',0),(218240,6063,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ñ€ÐµÐ·Ð¸Ð¼Ðµ (Ð³Ñ€ÑƒÐ¿Ðµ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð²Ð°Ð»ÑƒÑ‚Ðµ Ð¸ Ð²Ñ€ÑÑ‚Ðµ Ñ€Ð°Ð´Ð°)',0),(218241,6063,'vi','Tá»•ng sá»‘ tá»‘i Ä‘a (nhÃ³m theo giÃ¡ & loáº¡i cÃ´ng viá»‡c)',0),(218242,6063,'af','Maksimum opsomming (groepe deur tempo en tipe werk)',0),(218243,6063,'ro','Rezumat maximÄƒ (grupuri de rata ÅŸi tip de muncÄƒ)',0),(218244,6063,'et','Maksimaalne kokkuvÃµte (rÃ¼hmad mÃ¤Ã¤r ja tÃ¶Ã¶ liik)',0),(218245,6063,'si','NajveÄja Povzetek (skupine stopnja in vrsta dela)',0),(218246,6063,'ba','Maksimum ringkasan (kelompok oleh tingkat dan jenis pekerjaan)',0),(218247,6063,'nl','Maximale samenvatting (groepen door tarief en type van het werk)',0),(218248,6063,'fi','Suurin Yhteenveto (ryhmÃ¤t mÃ¤Ã¤rÃ¤ ja tyÃ¶n laji)',0),(218249,6063,'no','Maksimal Sammendrag (grupper av rate og typen arbeid)',0),(218250,6063,'da','Maksimale ResumÃ© (grupper af hastighed og type af arbejde)',0),(218251,6063,'ko','ìµœëŒ€ ìš”ì•½ (ì†ë„ ë° ìž‘ì—…ì˜ ì¢…ë¥˜ì— ì˜í•´ ê·¸ë£¹)',0),(218252,6063,'he','×¡×™×›×•× ×”×ž×¨×‘×™ (×§×‘×•×¦×•×ª ×¢×œ ×™×“×™ ×§×¦×‘ ×•××ª ×¡×•×’ ×”×¢×‘×•×“×”)',0),(218253,6063,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Î ÎµÏÎ¯Î»Î·ÏˆÎ· (Î¿Î¼Î¬Î´ÎµÏ‚ Î±Ï€ÏŒ Ï„Î¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎºÎ±Î¹ ÎµÎ¯Î´Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚)',0),(218254,6063,'zh','æœ€å¤§æ‘˜è¦ï¼ˆæŒ‰çŽ‡å’Œç±»åž‹åˆ†ç»„ï¼‰\r\n',0),(218255,6063,'sv','Maximal Sammanfattning (grupper av rÃ¤nta och typ av arbete)',0),(218256,6063,'it','Massima sintesi (gruppi di tariffa e tipo di lavoro)',0),(218257,6063,'tl','',0),(218258,6063,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604; (&#3592;&#3633;&#3604;&#3585;&#3621;&#3640;&#3656;&#3617;&#3650;&#3604;&#3618;&#3629;&#3633;&#3605;&#3619;&#3634;&#3649;&#3621;&#3632;&#3611;&#3619;&#3632;&#3648;&',0),(218259,6063,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ (à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¥€ à¤¦à¤° à¤”à¤° à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾)',0),(218260,6063,'ms','Ringkasan maksimum (Kumpulan dengan kadar dan jenis kerja)',0),(218261,6063,'ar','Ù…Ù„Ø®Øµ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ (Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø¨Ù…Ø¹Ø¯Ù„ ÙˆÙ†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„)',0),(218262,6063,'fr','RÃ©sumÃ© maximale (groupes de taux et le type de travail)',0),(218263,6063,'jp','æœ€å¤§ã‚µãƒžãƒªãƒ¼ï¼ˆæ–™é‡‘ã?¨ä½œæ¥­ã‚¿ã‚¤ãƒ—åˆ¥ã‚°ãƒ«ãƒ¼ãƒ—ï¼‰',0),(218264,6063,'pt','Resumo mÃ¡ximo (grupos por taxa e o tipo de trabalho)',0),(218265,6063,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ñ€ÐµÐ·ÑŽÐ¼Ðµ (Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹, ÑÐºÐ¾Ñ€Ð¾ÑÑ‚ÑŒ Ð¸ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹)',0),(218266,6063,'es','MÃ¡ximo ResÃºmen (grupos por tasa y tipo de trabajo',0),(218267,6063,'de','Maximale Zusammenfassung (Gruppen von Rate und Art der Arbeit)',0),(218268,6063,'en','Maximum Summary (groups by rate and type of work)',0),(218269,6064,'is','',0),(218270,6064,'dr','Ø³Ø·Ø­ Ø®Ù„Ø§ØµÙ‡ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(218271,6064,'pr','Ø³Ø·Ø­ Ø®Ù„Ø§ØµÙ‡ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(218272,6064,'tr','Servis sipariÅŸi Ã–zet dÃ¼zeyi',0),(218273,6064,'pl','Poziomie podsumowanie zamÃ³wienia usÅ‚ugi',0),(218274,6064,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð¸Ð²Ð¾',0),(218275,6064,'ur','Ø®Ø¯Ù…Øª ØªØ±ØªÛŒØ¨ Ø®Ù„Ø§ØµÛ Ø³Ø·Ø­',0),(218276,6064,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ð²Ð¾ ÑƒÑÐ»ÑƒÐ³Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(218277,6064,'vi','Tá»•ng há»£p ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(218278,6064,'af','Diensbestelling Opsommingsvlak',0),(218279,6064,'ro','Comanda rezumat la nivel de servicii',0),(218280,6064,'et','Tellimuse KokkuvÃµte teenusetaseme',0),(218281,6064,'si','Povzetek raven storitve nalog',0),(218282,6064,'ba','Tingkat layanan pesanan ringkasan',0),(218283,6064,'nl','Service Order samenvatting niveau',0),(218284,6064,'fi','Palvelutason tilauksen Yhteenveto',0),(218285,6064,'no','ServicenivÃ¥et for Sammendrag',0),(218286,6064,'da','Serviceniveau ordre oversigt',0),(218287,6064,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ìš”ì•½ ìˆ˜ì¤€',0),(218288,6064,'he','×¨×ž×ª ×©×™×¨×•×ª ×”×–×ž× ×ª ×¢×¨×¡×œ',0),(218289,6064,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ ÏƒÏÎ½Î¿ÏˆÎ·Ï‚',0),(218290,6064,'zh','æœåŠ¡è®¢å•æ±‡æ€»æ°´å¹³\r\n',0),(218291,6064,'sv','Service bestÃ¤llning Sammanfattning nivÃ¥',0),(218292,6064,'it','Livello di riepilogo ordine di servizio',0),(218293,6064,'tl','',0),(218294,6064,'th','&#3626;&#3619;&#3640;&#3611;&#3619;&#3632;&#3604;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(218295,6064,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¸à¥à¤¤à¤°',0),(218296,6064,'ms','Peringkat ringkasan arahan Perkhidmatan',0),(218297,6064,'ar','Ø®Ø¯Ù…Ø© ØªØ±ØªÙŠØ¨ Ù…Ø³ØªÙˆÙ‰ Ø§Ù„ØªÙ„Ø®ÙŠØµ',0),(218298,6064,'fr','Service commande niveau sommaire',0),(218299,6064,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã‚µãƒžãƒªãƒ¼åŸºæº–',0),(218300,6064,'pt','NÃ­vel de Resumo de ordem de serviÃ§o',0),(218301,6064,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(218302,6064,'es','Nivel de ResÃºmen de Orden de Servicio',0),(218303,6064,'de','Service Bestellung Ãœbersichtsebene',0),(218304,6064,'en','Service Order Summary Level',0),(218305,6065,'is','',0),(218306,6065,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø³ØªØ§Ù†Ú©Ø§Ø±',0),(218307,6065,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø³ØªØ§Ù†Ú©Ø§Ø±',0),(218308,6065,'tr','Alacak tutarÄ±',0),(218309,6065,'pl','Kwota kredyt',0),(218310,6065,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÑÑƒÐ¼Ð°',0),(218311,6065,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ø±Ù‚Ù…',0),(218312,6065,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(218313,6065,'vi','Sá»‘ Tiá»n TÃ­n Dá»¥ng',0),(218314,6065,'af','Kredietbedrag',0),(218315,6065,'ro','SumÄƒ credit',0),(218316,6065,'et','Krediidi summa',0),(218317,6065,'si','Znesek kredita',0),(218318,6065,'ba','Jumlah kredit',0),(218319,6065,'nl','Creditbedrag',0),(218320,6065,'fi','Kredit-summa',0),(218321,6065,'no','KreditbelÃ¸p',0),(218322,6065,'da','KreditbelÃ¸b',0),(218323,6065,'ko','ì‹ ìš© ê¸ˆì•¡',0),(218324,6065,'he','×¡×›×•× ×”×–×™×›×•×™',0),(218325,6065,'el','Î Î¿ÏƒÏŒ Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚',0),(218326,6065,'zh','ä¿¡ç”¨é¢\r\n',0),(218327,6065,'sv','Kreditbelopp',0),(218328,6065,'it','Importo del credito',0),(218329,6065,'tl','',0),(218330,6065,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(218331,6065,'hi','à¤‹à¤£ à¤°à¤¾à¤¶à¤¿',0),(218332,6065,'ms','Jumlah kredit',0),(218333,6065,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ø¯Ø§Ø¦Ù†',0),(218334,6065,'fr','Montant du crÃ©dit',0),(218335,6065,'jp','æŽ›å£²é‡‘é¡?',0),(218336,6065,'pt','Montante do crÃ©dito',0),(218337,6065,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(218338,6065,'es','Monto de CrÃ©dito',0),(218339,6065,'de','Habenbetrag',0),(218340,6065,'en','Credit Amount',0),(218341,6066,'is','',0),(218342,6066,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡ÙŠ',0),(218343,6066,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡ÙŠ',0),(218344,6066,'tr','BorÃ§ tutarÄ±',0),(218345,6066,'pl','Kwota Debet',0),(218346,6066,'bg','Ð”ÐµÐ±Ð¸Ñ‚Ð½Ð° ÑÑƒÐ¼Ð°',0),(218347,6066,'ur','ÚˆÛŒØ¨Ù¹ Ø±Ù‚Ù…',0),(218348,6066,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(218349,6066,'vi','Sá»‘ ná»£',0),(218350,6066,'af','Debietbedrag',0),(218351,6066,'ro','SumÄƒ debit',0),(218352,6066,'et','Deebetsumma',0),(218353,6066,'si','Znesek v breme',0),(218354,6066,'ba','Jumlah debit',0),(218355,6066,'nl','Debet bedrag',0),(218356,6066,'fi','Debet-summa',0),(218357,6066,'no','DebetbelÃ¸pet',0),(218358,6066,'da','DebetbelÃ¸b',0),(218359,6066,'ko','ì§ë¶ˆ ê¸ˆì•¡',0),(218360,6066,'he','×¡×›×•× ×—×™×•×‘',0),(218361,6066,'el','Î Î¿ÏƒÏŒ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(218362,6066,'zh','å€Ÿæ–¹é‡‘é¢\r\n',0),(218363,6066,'sv','Debetbelopp',0),(218364,6066,'it','Importo del debito',0),(218365,6066,'tl','',0),(218366,6066,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3648;&#3604;&#3610;&#3636;&#3605;',0),(218367,6066,'hi','à¤¡à¥‡à¤¬à¤¿à¤Ÿ à¤°à¤¾à¤¶à¤¿',0),(218368,6066,'ms','Amaun Debit',0),(218369,6066,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¯ÙŠÙ†',0),(218370,6066,'fr','DÃ©bit montant',0),(218371,6066,'jp','è² å‚µé‡‘é¡?',0),(218372,6066,'pt','Quantidade de dÃ©bito',0),(218373,6066,'ru','Ð”ÐµÐ±ÐµÑ‚ Ð¡ÑƒÐ¼Ð¼Ð°',0),(218374,6066,'es','Monto de DÃ©bito',0),(218375,6066,'de','Sollbetrag',0),(218376,6066,'en','Debit Amount',0),(218377,6067,'is','',0),(218378,6067,'dr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(218379,6067,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(218380,6067,'tr','GL hesap dosyasÄ± sÃ¼tun biÃ§imi',0),(218381,6067,'pl','GL konto formatu kolumny',0),(218382,6067,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(218383,6067,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„',0),(218384,6067,'sr','Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ ÐºÐ¾Ð»Ð¾Ð½Ðµ',0),(218385,6067,'vi','Há»“ SÆ¡ TK Sá»• CÃ¡i Tá»•ng Há»£p Theo Dáº¡ng Cá»™t',0),(218386,6067,'af','AG Rekening LÃªer Kolomformaat',0),(218387,6067,'ro','GL cont coloanei formatul de fiÅŸier',0),(218388,6067,'et','GL konto faili veeruvormingut',0),(218389,6067,'si','GL raÄun zapisa stolpec',0),(218390,6067,'ba','Format kolom GL Account File',0),(218391,6067,'nl','GL Account bestandsindeling kolom',0),(218392,6067,'fi','GL huomioon tiedostomuoto sarake',0),(218393,6067,'no','GL konto-kolonnen filformat',0),(218394,6067,'da','GL konto filformat kolonne',0),(218395,6067,'ko','GL ê³„ì • íŒŒì¼ ì—´ í˜•ì‹',0),(218396,6067,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×©×œ ×§×•×‘×¥ ×—×©×‘×•×Ÿ GL',0),(218397,6067,'el','ÎœÎ¿ÏÏ†Î® ÏƒÏ„Î®Î»Î·Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï GL',0),(218398,6067,'zh','æ€»å¸å¸æˆ·åˆ—çš„æ ¼å¼æ–‡ä»¶\r\n',0),(218399,6067,'sv','GL konto-kolumn filformatet',0),(218400,6067,'it','GL Account formato colonna',0),(218401,6067,'tl','',0),(218402,6067,'th','&#3592;&#3633;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3651;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3588;&#3629;&#3621;&#3633;&#3617;&#3',0),(218403,6067,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(218404,6067,'ms','Format kolum fail akaun GL',0),(218405,6067,'ar','Ø¨Ù†ÙŠØ© Ø®Ø§Ù†Ø§Øª Ù…Ù„Ù Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(218406,6067,'fr','Format de colonne de fichier de compte GL',0),(218407,6067,'jp','ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãƒ•ã‚¡ã‚¤ãƒ«æ¬„ã?®ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(218408,6067,'pt','Formato de coluna de arquivo de conta GL',0),(218409,6067,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ GL',0),(218410,6067,'es','Formato de Columna de File de Cuenta LM',0),(218411,6067,'de','GL-Konto-Datei-Spalten-Format',0),(218412,6067,'en','GL Account File Column Format',0),(218413,6068,'is','',0),(218414,6068,'dr','(Ø¨ÛŒÙ„Ø§Ù†Ø³Ù‡Ø§ÙŠ) Ù„ÛŒØ¬Ø±',0),(218415,6068,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ù…Ø§Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ(ØªØ±Ø§Ø²Ù‡Ø§ÙŠ) Ø¯ÙØªØ± ÙƒÙ„',0),(218416,6068,'tr','GL bakiyeleri dosyasÄ±nÄ± seÃ§in',0),(218417,6068,'pl','Wybierz plik salda GL',0),(218418,6068,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ GL ÑÐ°Ð»Ð´Ð° Ñ„Ð°Ð¹Ð»',0),(218419,6068,'ur','Ø¬ÛŒØ¬Û’ Ø¨ÛŒÙ„Ù†Ø³ Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(218420,6068,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ ÑÐ°Ð»Ð´Ð° Ð“Ð›',0),(218421,6068,'vi','Chá»n há»“ sÆ¡ sá»‘ dÆ° sá»• cÃ¡i',0),(218422,6068,'af','Selekteer AG Balanse LÃªer',0),(218423,6068,'ro','SelectaÅ£i fiÅŸierul de solduri GL',0),(218424,6068,'et','Valige GL saldode faili',0),(218425,6068,'si','Izberite datoteko bilance GL',0),(218426,6068,'ba','Pilih File saldo GL',0),(218427,6068,'nl','Selecteer GL saldi bestand',0),(218428,6068,'fi','Valitse GL saldot tiedosto',0),(218429,6068,'no','Velg GL balanserer fil',0),(218430,6068,'da','VÃ¦lg GL saldi fil',0),(218431,6068,'ko','GL ê· í˜• íŒŒì¼ ì„ íƒ',0),(218432,6068,'he','×‘×—×¨ ×§×•×‘×¥ ×™×ª×¨×•×ª GL',0),(218433,6068,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î‘ÏÏ‡ÎµÎ¯Î¿ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î± GL',0),(218434,6068,'zh','é€‰æ‹©å‰å°”ä½™é¢æ–‡ä»¶\r\n',0),(218435,6068,'sv','VÃ¤lj GL saldon fil',0),(218436,6068,'it','Selezionare File saldi GL',0),(218437,6068,'tl','',0),(218438,6068,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3615;&#3621;&#3660;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(218439,6068,'hi','à¤œà¥€à¤à¤² à¤¶à¥‡à¤· à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(218440,6068,'ms','Pilih fail baki GL',0),(218441,6068,'ar','Ø¥Ø®ØªÙŠØ§Ø± Ù…Ù„ÙÙ‘ Ø£Ø±ØµØ¯Ø© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(218442,6068,'fr','SÃ©lectionnez le fichier soldes GL',0),(218443,6068,'jp','ï¼§ï¼¬ãƒ?ãƒ©ãƒ³ã‚¹ãƒ•ã‚¡ã‚¤ãƒ«ã?®é?¸æŠž',0),(218444,6068,'pt','Selecione o arquivo de saldos GL',0),(218445,6068,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¤Ð°Ð¹Ð» Ð‘Ð°Ð»Ð°Ð½ÑÐ° Ð“Ðš',0),(218446,6068,'es','Seleccionar File de Balance de LM',0),(218447,6068,'de','GL-Salden-Datei auswÃ¤hlen',0),(218448,6068,'en','Select GL Balances File',0),(218449,6069,'is','',0),(218450,6069,'dr','2',0),(218451,6069,'pr','Ú†Ø§Ù¾ Ù‡Ø§ÙŠ Ø§ÙˆÙ„ÙŠÙ‡ Ú†Ùƒ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± â€“ Ø±ÙˆØ´   2',0),(218452,6069,'tr','Ã–nceden basÄ±lmÄ±ÅŸ onay hisse senedi tarzÄ± #2',0),(218453,6069,'pl','Nadrukiem sprawdzanie zapasÃ³w stylu #2',0),(218454,6069,'bg','ÐŸÐ¾ÑÑÐ½Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð° ÑÑ‚Ð¸Ð» #2',0),(218455,6069,'ur','Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹Ø¯ Ú†ÛŒÚ© Ø§Ø³Ù¹Ø§Ú© Ø·Ø±Ø² #2',0),(218456,6069,'sr','Ð¤Ð°Ð±Ñ€Ð¸Ñ‡ÐºÐ¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ñƒ ÑÑ‚Ð¸Ð»Ñƒ #2',0),(218457,6069,'vi','Kiá»ƒu dÃ¡ng SÃ©c in trÆ°á»›c sá»‘ 2',0),(218458,6069,'af','Vooruitgedrukte Tjek Voorraad-Styl #2',0),(218459,6069,'ro','Selectare pre-imprimate stil stoc #2',0),(218460,6069,'et','ValmistrÃ¼kitud sisse Stock-stiil #2',0),(218461,6069,'si','Nespremenljivo Äek staleÅ¾-Style #2',0),(218462,6069,'ba','Cetakan Periksa saham-gaya #2',0),(218463,6069,'nl','Voorgedrukte selectievakje Stock-Style #2',0),(218464,6069,'fi','Esipainettua uloskirjautuminen Stock-Style #2',0),(218465,6069,'no','Fortrykt av lager-stil #2',0),(218466,6069,'da','Fortrykt Check Stock-stil #2',0),(218467,6069,'ko','ì¸ì‡„ ëœ ìˆ˜ í‘œ ì£¼ì‹ ìŠ¤íƒ€ì¼ #2',0),(218468,6069,'he','×”×¡×™×ž×•×Ÿ ×ž×•×“×¤×¡ ×ž×¨××© ×ž×œ××™ ×‘×¡×’× ×•×Ÿ #2',0),(218469,6069,'el','Î ÏÎ¿Ï„Ï…Ï€Ï‰Î¼Î­Î½ÎµÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÏƒÏ„Î¹Î» #2',0),(218470,6069,'zh','é¢„å°æŸ¥çœ‹åº“å­˜é£Žæ ¼ï¼ƒ2\r\n',0),(218471,6069,'sv','FÃ¶rtryckta kontroll lager stil #2',0),(218472,6069,'it','Prestampati Check Stock-stile #2',0),(218473,6069,'tl','',0),(218474,6069,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3626;&#3605;&#3655;&#3629;&#3585;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3656;&#3629;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660; #2',0),(218475,6069,'hi','Preprinted à¤šà¥‡à¤• à¤¶à¥‡à¤¯à¤°-à¤¶à¥ˆà¤²à¥€ #2',0),(218476,6069,'ms','Pracetak semak stok-gaya #2',0),(218477,6069,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù…Ø·Ø¨ÙˆØ¹ Ø¹Ù„Ù‰ ØºØ±Ø§Ø± Ø§Ù„Ø£Ø³Ù‡Ù… #2',0),(218478,6069,'fr','ChÃ¨que prÃ©imprimÃ© Style Stock #2',0),(218479,6069,'jp','äº‹å‰?å?°åˆ·å°?åˆ‡æ‰‹ã‚¹ã‚¿ã‚¤ãƒ«ï¼’',0),(218480,6069,'pt','SeleÃ§Ã£o prÃ©-impresso Stock-estilo #2',0),(218481,6069,'ru','ÐŸÐ»Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð°Ð¿Ð°ÑÐ¾Ð² ÑÑ‚Ð¸Ð»ÑŒ #2',0),(218482,6069,'es','Estilo-Stock #2 de Cheque Preimprimido',0),(218483,6069,'de','Vorgedruckte Check Stock-Style #2',0),(218484,6069,'en','Preprinted Check Stock-Style #2',0),(218485,6070,'is','',0),(218486,6070,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ø¬Ù…ÙˆØ¹ Ø¯ÙØªØ± ÙƒÙ„ ',0),(218487,6070,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ø¬Ù…ÙˆØ¹ Ø¯ÙØªØ± ÙƒÙ„ ',0),(218488,6070,'tr','GL toplamlarÄ±nÄ± alma',0),(218489,6070,'pl','PrzywÃ³z GL sumy',0),(218490,6070,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° GL ÑÑƒÐ¼Ð¸',0),(218491,6070,'ur','Ø¬ÛŒØ¬Û’ Ù…ÛŒØ²Ø§Ù† Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(218492,6070,'sr','Ð£Ð²Ð¾Ð· Ð“Ð› Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(218493,6070,'vi','Nháº­p tá»•ng cá»™ng sá»• cÃ¡i',0),(218494,6070,'af','Invoer van AG Totale',0),(218495,6070,'ro','Import GL totaluri',0),(218496,6070,'et','Impordi GL kogusummad',0),(218497,6070,'si','Uvoz GL vsote',0),(218498,6070,'ba','Impor GL Total',0),(218499,6070,'nl','GL totalen importeren',0),(218500,6070,'fi','Tuo GL summat',0),(218501,6070,'no','Importere totalsummer GL',0),(218502,6070,'da','Importere GL totaler',0),(218503,6070,'ko','GL í•©ê³„ë¥¼ ê°€ì ¸ì˜¤ê¸°',0),(218504,6070,'he','×™×™×‘×•× GL ×¡×›×•×ž×™×',0),(218505,6070,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ ÏƒÏÎ½Î¿Î»Î± GL',0),(218506,6070,'zh','å¯¼å…¥æ€»å¸æ€»è®¡\r\n',0),(218507,6070,'sv','Importera GL totalsummor',0),(218508,6070,'it','Importare i totali GL',0),(218509,6070,'tl','',0),(218510,6070,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(218511,6070,'hi','à¤œà¥€à¤à¤² à¤¯à¥‹à¤—à¥‹à¤‚ à¤•à¥‹ à¤†à¤¯à¤¾à¤¤',0),(218512,6070,'ms','Import jumlah GL',0),(218513,6070,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ø¬Ø§Ù…ÙŠØ¹ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(218514,6070,'fr','Importation GL totaux',0),(218515,6070,'jp','ç·?å‹˜å®šå…ƒå¸³å?ˆè¨ˆã‚’å?–ã‚Šè¾¼ã‚€',0),(218516,6070,'pt','Totais de importaÃ§Ã£o GL',0),(218517,6070,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° GL',0),(218518,6070,'es','Importar Totales de LM',0),(218519,6070,'de','Import GL Summen',0),(218520,6070,'en','Import GL Totals',0),(218521,6071,'is','',0),(218522,6071,'dr','(Ø¨Ø±Ú¯Ø´Øª )Ú†Ùƒ ',0),(218523,6071,'pr','Ø¹ÙˆØ¯Øª(Ø¨Ø±Ú¯Ø´Øª )Ú†Ùƒ ',0),(218524,6071,'tr','Return Check',0),(218525,6071,'pl','PowrÃ³t do wyboru',0),(218526,6071,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ Ð½Ð° Ñ‡ÐµÐº',0),(218527,6071,'ur','Ú†ÛŒÚ© ÙˆØ§Ù¾Ø³',0),(218528,6071,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(218529,6071,'vi','HoÃ n tráº£ SÃ©c',0),(218530,6071,'af','Kyk terug',0),(218531,6071,'ro','Reveni Check',0),(218532,6071,'et','Edasi-tagasi sisse',0),(218533,6071,'si','Vrnitev potrdite',0),(218534,6071,'ba','Check kembali',0),(218535,6071,'nl','Check terug',0),(218536,6071,'fi','Takaisin sisÃ¤Ã¤n',0),(218537,6071,'no','Retur av',0),(218538,6071,'da','Returnere Check',0),(218539,6071,'ko','ë°˜í™˜ ìˆ˜ í‘œ',0),(218540,6071,'he','×œ×”×—×–×™×¨ ××ª ×”×¦\'×§',0),(218541,6071,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(218542,6071,'zh','è¿”å›žæ£€æŸ¥\r\n',0),(218543,6071,'sv','Returnera Check',0),(218544,6071,'it','Restituire l\'assegno',0),(218545,6071,'tl','',0),(218546,6071,'th','&#3648;&#3594;&#3655;&#3588;&#3605;&#3637;&#3585;&#3621;&#3633;&#3610;',0),(218547,6071,'hi','à¤šà¥‡à¤• à¤µà¤¾à¤ªà¤¸à¥€',0),(218548,6071,'ms','Semak kembali',0),(218549,6071,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø¥Ø±Ø¬Ø§Ø¹',0),(218550,6071,'fr','Retour Ã  Check',0),(218551,6071,'jp','å°?åˆ‡æ‰‹ã‚’è¿”å?´',0),(218552,6071,'pt','VerificaÃ§Ã£o de retorno',0),(218553,6071,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(218554,6071,'es','Cheque Regresado',0),(218555,6071,'de','Return Check',0),(218556,6071,'en','Return Check',0),(218557,6072,'is','',0),(218558,6072,'dr','Ú†Ùƒ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(218559,6072,'pr','Ú†Ùƒ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(218560,6072,'tr','DÃ¶ndÃ¼rÃ¼len onay',0),(218561,6072,'pl','Wyboru zwracane',0),(218562,6072,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸Ñ‚Ðµ',0),(218563,6072,'ur','Ú†ÛŒÚ© ÙˆØ§Ù¾Ø³',0),(218564,6072,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´Ð° ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾',0),(218565,6072,'vi','SÃ©c hoÃ n láº¡i',0),(218566,6072,'af','Tjek Teruggestuur',0),(218567,6072,'ro','CEC returnat',0),(218568,6072,'et','Kontrollige tagastatud',0),(218569,6072,'si','Preverite vrnjeno',0),(218570,6072,'ba','Periksa kembali',0),(218571,6072,'nl','Selectievakje geretourneerd',0),(218572,6072,'fi','Tarkista palautetut',0),(218573,6072,'no','Sjekk tilbake',0),(218574,6072,'da','Check tilbage',0),(218575,6072,'ko','ë°˜í™˜ ëœ ì²´í¬',0),(218576,6072,'he','×”×¦\'×§ ×—×–×¨',0),(218577,6072,'el','Î•Î»Î­Î³Ï‡Î¿Ï… Ï€Î¿Ï… ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ',0),(218578,6072,'zh','æ£€æŸ¥è¿”å›ž\r\n',0),(218579,6072,'sv','Kontrollera returnerade',0),(218580,6072,'it','Controllo restituito',0),(218581,6072,'tl','',0),(218582,6072,'th','&#3648;&#3594;&#3655;&#3588;&#3605;&#3637;&#3585;&#3621;&#3633;&#3610;',0),(218583,6072,'hi','à¤šà¥‡à¤• à¤²à¥Œà¤Ÿà¤¾',0),(218584,6072,'ms','Semak kembali',0),(218585,6072,'ar','Ø¹Ø§Ø¯ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(218586,6072,'fr','ChÃ¨que retournÃ©',0),(218587,6072,'jp','å°?åˆ‡æ‰‹ã?Œè¿”å?´ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(218588,6072,'pt','Cheque devolvido',0),(218589,6072,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÐ¼Ñ‹Ðµ',0),(218590,6072,'es','Cheque Devuelto',0),(218591,6072,'de','KontrollkÃ¤stchen zurÃ¼ckgegeben',0),(218592,6072,'en','Check Returned',0),(218593,6073,'is','',0),(218594,6073,'dr','Ú†Ùƒ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(218595,6073,'pr','Ú†Ùƒ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(218596,6073,'tr','DÃ¶ndÃ¼rÃ¼len onay',0),(218597,6073,'pl','Wyboru zwracane',0),(218598,6073,'bg','Ð’Ñ€ÑŠÑ‰Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(218599,6073,'ur','ÙˆØ§Ù¾Ø³ Ù„ÙˆÙ¹Û’ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(218600,6073,'sr','Ð’Ñ€Ð°Ñ›ÐµÐ½Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(218601,6073,'vi','SÃ©c Ä‘Ã£ hoÃ n tráº£',0),(218602,6073,'af','Teruggestuurde kontroleer',0),(218603,6073,'ro','CEC returnat',0),(218604,6073,'et','Tagasi vaadata',0),(218605,6073,'si','Vrne preverite',0),(218606,6073,'ba','Kembali cek',0),(218607,6073,'nl','Geretourneerde Check',0),(218608,6073,'fi','Palauttaa tarkistaa',0),(218609,6073,'no','Returnerte sjekk',0),(218610,6073,'da','Returnerede Check',0),(218611,6073,'ko','ë°˜í™˜ ëœ ì²´í¬',0),(218612,6073,'he','×”×¡×™×ž×•×Ÿ ×”×ž×•×—×–×¨',0),(218613,6073,'el','Î•Ï€Î­ÏƒÏ„ÏÎµÏˆÎµ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(218614,6073,'zh','é€€å›žæ”¯ç¥¨\r\n',0),(218615,6073,'sv','Returnerade kontroll',0),(218616,6073,'it','Controllo restituito',0),(218617,6073,'tl','',0),(218618,6073,'th','&#3648;&#3594;&#3655;&#3588;&#3605;&#3637;&#3585;&#3621;&#3633;&#3610;',0),(218619,6073,'hi','à¤œà¤¾à¤‚à¤š à¤µà¤¾à¤ªà¤¸',0),(218620,6073,'ms','Semak dikembalikan',0),(218621,6073,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ØªÙ… Ø¥Ø±Ø¬Ø§Ø¹Ù‡Ø§',0),(218622,6073,'fr','ChÃ¨que retournÃ©',0),(218623,6073,'jp','è¿”å?´ã?•ã‚Œã?Ÿå°?åˆ‡æ‰‹',0),(218624,6073,'pt','Cheque retornado',0),(218625,6073,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð½Ñ‹Ð¹ Ñ‡ÐµÐº',0),(218626,6073,'es','Cheque Regresado',0),(218627,6073,'de','ZurÃ¼ckgegebene Check',0),(218628,6073,'en','Returned Check',0),(218629,6074,'is','',0),(218630,6074,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÙŠ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¨Ø±Ú¯Ø´ØªÙŠ Ù†ÙŠØ³Øª ',0),(218631,6074,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÙŠ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¨Ø±Ú¯Ø´ØªÙŠ Ù†ÙŠØ³Øª ',0),(218632,6074,'tr','Ä°Ã§in iade olarak iÅŸaretle',0),(218633,6074,'pl','Stanie Mark jak wrÃ³ciÅ‚',0),(218634,6074,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¼Ð°Ñ€ÐºÐ° ÐºÐ°Ñ‚Ð¾ Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸',0),(218635,6074,'ur','ÙˆØ§Ù¾Ø³ÛŒ Ù¾Ø± Ù†Ø´Ø§Ù† Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(218636,6074,'sr','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÐžÐ·Ð½Ð°Ñ‡Ð¸ ÐºÐ°Ð¾ Ð²Ñ€Ð°Ñ›ÐµÐ½Ðµ',0),(218637,6074,'vi','KhÃ´ng tháº¥y Ä‘Ã¡nh dáº¥u lÃ  Ä‘Ã£ hoÃ n láº¡i',0),(218638,6074,'af','Kon merk soos teruggestuur nie',0),(218639,6074,'ro','Imposibilitatea de a marca ca a revenit',0),(218640,6074,'et','Mark tagastada ei saa',0),(218641,6074,'si','Mogli znamke kot vrnil',0),(218642,6074,'ba','Mampu Mark karena kembali',0),(218643,6074,'nl','Niet in staat om te markeren als geretourneerd',0),(218644,6074,'fi','Pystynyt Mark palautettuna',0),(218645,6074,'no','Kan ikke merke returnerte',0),(218646,6074,'da','AfskÃ¥ret fra Mark som returneres',0),(218647,6074,'ko','ë°˜í™˜ ëœ í‘œì‹œ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(218648,6074,'he','××¤×©×¨×•×ª ×œ×¡×™×ž×•×Ÿ ×›×¤×™ ×©×”×•×—×–×¨',0),(218649,6074,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· ÏƒÎ®Î¼Î±Ï„Î¿Ï‚ ÏŒÏ€Ï‰Ï‚ ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ',0),(218650,6074,'zh','æ— æ³•æ ‡è®°ä¸ºè¿”å›ž\r\n',0),(218651,6074,'sv','Det gÃ¥r inte att markera som Ã¥tervÃ¤nde',0),(218652,6074,'it','Grado di Mark come restituito',0),(218653,6074,'tl','',0),(218654,6074,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3607;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3585;&#3621;&#3633;&#3610;&#3652;&#3604;&#3657;',0),(218655,6074,'hi','à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤²à¥Œà¤Ÿà¥‡ à¤®à¤¾à¤°à¥à¤• à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(218656,6074,'ms','Dapat Mark yang kembali',0),(218657,6074,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© ÙƒÙ…Ø§ Ø¹Ø§Ø¯',0),(218658,6074,'fr','Incapable de marque tel que retournÃ©',0),(218659,6074,'jp','è¿”å?´æ¸ˆã?«ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(218660,6074,'pt','Incapaz de Mark como retornado',0),(218661,6074,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ð¾Ð¼ÐµÑ‚Ð¸Ñ‚ÑŒ ÐºÐ°Ðº Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ',0),(218662,6074,'es','No se Puede Marcar como Devuelto',0),(218663,6074,'de','Nicht in der Lage, Mark wie zurÃ¼ckgegeben',0),(218664,6074,'en','Unable to Mark as Returned',0),(218665,6075,'is','',0),(218666,6075,'dr','ØªÙÚ©ÙŠÚ©',0),(218667,6075,'pr','ØªÙÚ©ÙŠÚ©',0),(218668,6075,'tr','Break',0),(218669,6075,'pl','Przerwa',0),(218670,6075,'bg','ÐŸÑ€ÐµÐºÑŠÑÐ²Ð°Ð½Ðµ',0),(218671,6075,'ur','ØªÙˆÚ‘',0),(218672,6075,'sr','ÐŸÐ°ÑƒÐ·Ð°',0),(218673,6075,'vi','Chia',0),(218674,6075,'af','Breek',0),(218675,6075,'ro','PauzÄƒ',0),(218676,6075,'et','Murda',0),(218677,6075,'si','Break',0),(218678,6075,'ba','Istirahat',0),(218679,6075,'nl','Pauze',0),(218680,6075,'fi','Tauko',0),(218681,6075,'no','Bryte',0),(218682,6075,'da','Bryde',0),(218683,6075,'ko','íœ´ì‹',0),(218684,6075,'he','×œ×©×‘×•×¨',0),(218685,6075,'el','Î”Î¹Î¬Î»ÎµÎ¹Î¼Î¼Î±',0),(218686,6075,'zh','æ‰“ç ´\r\n',0),(218687,6075,'sv','Bryta',0),(218688,6075,'it','Pausa',0),(218689,6075,'tl','',0),(218690,6075,'th','&#3627;&#3618;&#3640;&#3604;',0),(218691,6075,'hi','à¤¤à¥‹à¤¡à¤¼',0),(218692,6075,'ms','Rehat',0),(218693,6075,'ar','ÙƒØ³Ø±',0),(218694,6075,'fr','Pause',0),(218695,6075,'jp','ä¸­æ–­',0),(218696,6075,'pt','Quebrar',0),(218697,6075,'ru','ÐŸÐµÑ€ÐµÑ€Ñ‹Ð²',0),(218698,6075,'es','Pausa',0),(218699,6075,'de','Pause',0),(218700,6075,'en','Break',0),(218701,6076,'is','',0),(218702,6076,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ± ',0),(218703,6076,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ± ',0),(218704,6076,'tr','Kaliper',0),(218705,6076,'pl','Zacisk',0),(218706,6076,'bg','Ð¨ÑƒÐ±Ð»ÐµÑ€',0),(218707,6076,'ur','ÛÙˆØªÛ’ ÛÛŒÚº',0),(218708,6076,'sr','Ð¦Ð°Ð»Ð¸Ð¿ÐµÑ€',0),(218709,6076,'vi','Com-pa',0),(218710,6076,'af','Caliper',0),(218711,6076,'ro','Caliper',0),(218712,6076,'et','Nihikuga',0),(218713,6076,'si','Kljunasto merilo',0),(218714,6076,'ba','Caliper',0),(218715,6076,'nl','Remklauw',0),(218716,6076,'fi','Paksuus',0),(218717,6076,'no','SkyvelÃ¦re',0),(218718,6076,'da','Caliper',0),(218719,6076,'ko','ìº˜ë¦¬í¼ìŠ¤',0),(218720,6076,'he','×§×œ×™×‘×¨',0),(218721,6076,'el','Î”Î±Î³ÎºÎ¬Î½Î±',0),(218722,6076,'zh','å¡å°º\r\n',0),(218723,6076,'sv','Bromsok',0),(218724,6076,'it','Pinza',0),(218725,6076,'tl','',0),(218726,6076,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;&#3623;&#3633;&#3604;&#3586;&#3609;&#3634;&#3604;',0),(218727,6076,'hi','à¤•à¥ˆà¤²à¤¿à¤ªà¤°',0),(218728,6076,'ms','Caliper',0),(218729,6076,'ar','Ù‚Ø¯Ù…Ù‡ Ø°Ø§Øª Ø§Ù„ÙˆØ±Ù†ÙŠÙ‘Ø©',0),(218730,6076,'fr','Pied Ã  coulisse',0),(218731,6076,'jp','ã‚­ãƒ£ãƒªãƒ‘ãƒ¼',0),(218732,6076,'pt','Compasso de calibre',0),(218733,6076,'ru','Ð¡ÑƒÐ¿Ð¿Ð¾Ñ€Ñ‚Ð°',0),(218734,6076,'es','Calibrador',0),(218735,6076,'de','Bremssattel',0),(218736,6076,'en','Caliper',0),(218737,6077,'is','',0),(218738,6077,'dr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ÙƒØ§Ù„Ø§ Ø¬ÙˆØ§Ø² Ø³Ø§Ø­Ù„ÙŠ',0),(218739,6077,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ÙƒØ§Ù„Ø§ Ø¬ÙˆØ§Ø² Ø³Ø§Ø­Ù„ÙŠ',0),(218740,6077,'tr','Sahil kaÄŸÄ±t Ã¶ÄŸe dosya sÃ¼tun biÃ§imi',0),(218741,6077,'pl','WybrzeÅ¼e papieru element kolumna Format pliku',0),(218742,6077,'bg','Ð‘Ñ€ÑÐ³ Ñ…Ð°Ñ€Ñ‚Ð¸Ñ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(218743,6077,'ur','Ø³Ø§Ø­Ù„ Ú©Ø§ØºØ° Ø´Û’ Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„',0),(218744,6077,'sr','ÐžÐ±Ð°Ð»Ðµ Ð¿Ð°Ð¿Ð¸Ñ€ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(218745,6077,'vi','Há»“ sÆ¡ giáº¥y Coast dáº¡ng cá»™t',0),(218746,6077,'af','Weskus papier Item kolom lÃªerformaat',0),(218747,6077,'ro','Coasta hÃ¢rtie element File Format coloane',0),(218748,6077,'et','Rannikul raamatu kirje fail veeruvormingut',0),(218749,6077,'si','Obali papir element stolpec obliko zapisa datoteke',0),(218750,6077,'ba','Pantai kertas Item File Format kolom',0),(218751,6077,'nl','Kust papier Item-bestandsindeling kolom',0),(218752,6077,'fi','Coast erÃ¤ tiedoston sarake paperikoko',0),(218753,6077,'no','Kysten papir element kolonnen filformat',0),(218754,6077,'da','Kysten papir element filformat kolonne',0),(218755,6077,'ko','í•´ì•ˆ ì¢…ì´ í•­ëª© íŒŒì¼ ì—´ í˜•ì‹',0),(218756,6077,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×§×•×‘×¥ ×©×œ ×¤×¨×™×˜ ×—×•×£-× ×™×™×¨',0),(218757,6077,'el','Î‘ÎºÏ„Î® Ï‡Î±ÏÏ„Î¯ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î¼Î¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½',0),(218758,6077,'zh','æµ·å²¸çº¸åˆ¶å“æ–‡ä»¶åˆ—æ ¼å¼\r\n',0),(218759,6077,'sv','Kusten papper objekt-kolumn filformatet',0),(218760,6077,'it','Costa carta elemento File formato colonne',0),(218761,6077,'tl','',0),(218762,6077,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3610;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(218763,6077,'hi','à¤¤à¤Ÿ à¤•à¤¾à¤—à¤œ à¤†à¤‡à¤Ÿà¤® à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(218764,6077,'ms','Pantai kertas Item lajur Format fail',0),(218765,6077,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ Ù…Ù„Ù Ø§Ù„Ø¨Ù†Ø¯ ÙˆØ±Ù‚Ø© Ø§Ù„Ø³Ø§Ø­Ù„',0),(218766,6077,'fr','CÃ´te papier Ã©lÃ©ment File Format de colonne',0),(218767,6077,'jp','Coast Paper Item File Column Format',0),(218768,6077,'pt','Costa papel Item arquivo formato de coluna',0),(218769,6077,'ru','ÐŸÐ¾Ð±ÐµÑ€ÐµÐ¶ÑŒÐµ Ð±ÑƒÐ¼Ð°Ð³Ð¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ñ„Ð°Ð¹Ð»Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð¾Ð²',0),(218770,6077,'es','FormÃ¡to de Columna del Archivo de Item de Papel Coast',0),(218771,6077,'de','KÃ¼ste Papier Element Spalte Dateiformat',0),(218772,6077,'en','Coast Paper Item File Column Format',0),(218773,6078,'is','',0),(218774,6078,'dr','(Ø­Ø¨ÙˆØ¨Ø§Øª',0),(218775,6078,'pr','Ø¯Ø§Ù†Ù‡ (Ø­Ø¨ÙˆØ¨Ø§Øª',0),(218776,6078,'tr','TahÄ±l',0),(218777,6078,'pl','Ziarna',0),(218778,6078,'bg','Ð—ÑŠÑ€Ð½Ð¾',0),(218779,6078,'ur','ØºÙ„Û',0),(218780,6078,'sr','Ð—Ñ€Ð½Ð¾',0),(218781,6078,'vi','LÃºa máº¡ch ',0),(218782,6078,'af','Graan',0),(218783,6078,'ro','Cereale',0),(218784,6078,'et','Tera',0),(218785,6078,'si','Å½ito',0),(218786,6078,'ba','Gandum',0),(218787,6078,'nl','Graan',0),(218788,6078,'fi','Viljan',0),(218789,6078,'no','Korn',0),(218790,6078,'da','Korn',0),(218791,6078,'ko','ê³¡ë¬¼',0),(218792,6078,'he','×“×’×Ÿ',0),(218793,6078,'el','Î£Î¹Ï„Î¬ÏÎ¹',0),(218794,6078,'zh','ç²®é£Ÿ\r\n',0),(218795,6078,'sv','Korn',0),(218796,6078,'it','Grano',0),(218797,6078,'tl','',0),(218798,6078,'th','&#3648;&#3617;&#3655;&#3604;&#3648;&#3591;&#3636;&#3609;',0),(218799,6078,'hi','à¤…à¤¨à¤¾à¤œ',0),(218800,6078,'ms','Bijirin',0),(218801,6078,'ar','Ø§Ù„Ø­Ø¨ÙˆØ¨',0),(218802,6078,'fr','Grain',0),(218803,6078,'jp','ã‚°ãƒ¬ã‚¤ãƒ³',0),(218804,6078,'pt','GrÃ£o',0),(218805,6078,'ru','Ð—ÐµÑ€Ð½Ð°',0),(218806,6078,'es','Grano',0),(218807,6078,'de','Korn',0),(218808,6078,'en','Grain',0),(218809,6079,'is','',0),(218810,6079,'dr','Ø§Ø±ØªÙØ§Ø¹ ',0),(218811,6079,'pr','Ø§Ø±ØªÙØ§Ø¹ ',0),(218812,6079,'tr','YÃ¼kseklik',0),(218813,6079,'pl','WysokoÅ›Ä‡',0),(218814,6079,'bg','Ð’Ð¸ÑÐ¾Ñ‡Ð¸Ð½Ð°',0),(218815,6079,'ur','Ø§ÙˆÙ†Ú†Ø§Ø¦ÛŒ',0),(218816,6079,'sr','Ð’Ð¸ÑÐ¸Ð½Ð°',0),(218817,6079,'vi','Chiá»u cao',0),(218818,6079,'af','Hoogte',0),(218819,6079,'ro','ÃŽnÄƒlÈ›ime',0),(218820,6079,'et','KÃµrgus',0),(218821,6079,'si','ViÅ¡ina',0),(218822,6079,'ba','Tinggi',0),(218823,6079,'nl','Hoogte',0),(218824,6079,'fi','Korkeus',0),(218825,6079,'no','HÃ¸yde',0),(218826,6079,'da','HÃ¸jde',0),(218827,6079,'ko','ë†’ì´',0),(218828,6079,'he','×’×•×‘×”',0),(218829,6079,'el','ÎŽÏˆÎ¿Ï‚',0),(218830,6079,'zh','é«˜åº¦\r\n',0),(218831,6079,'sv','HÃ¶jd',0),(218832,6079,'it','Altezza',0),(218833,6079,'tl','',0),(218834,6079,'th','&#3588;&#3623;&#3634;&#3617;&#3626;&#3641;&#3591;',0),(218835,6079,'hi','à¤Šà¤à¤šà¤¾à¤ˆ',0),(218836,6079,'ms','Ketinggian',0),(218837,6079,'ar','Ø§Ù„Ø¥Ø±ØªÙØ§Ø¹',0),(218838,6079,'fr','Hauteur',0),(218839,6079,'jp','é«˜ã?•',0),(218840,6079,'pt','Altura',0),(218841,6079,'ru','Ð’Ñ‹ÑÐ¾Ñ‚Ð°',0),(218842,6079,'es','Altura',0),(218843,6079,'de','HÃ¶he',0),(218844,6079,'en','Height',0),(218845,6080,'is','',0),(218846,6080,'dr','Ù„ÙŠØ³Øª Ø´ÙˆØ¯ Ø²Ù…Ø§Ù† Ø¬Ø³ØªØ¬Ùˆ ',0),(218847,6080,'pr','Ù„ÙŠØ³Øª Ø´ÙˆØ¯ Ø²Ù…Ø§Ù† Ø¬Ø³ØªØ¬Ùˆ ',0),(218848,6080,'tr','Arama listesi',0),(218849,6080,'pl','Lista podczas wyszukiwania',0),(218850,6080,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð¿Ñ€Ð¸ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(218851,6080,'ur','Ø¬Ø¨ ØªÙ„Ø§Ø´ Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(218852,6080,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(218853,6080,'vi','Danh sÃ¡ch khi tÃ¬m kiáº¿m',0),(218854,6080,'af','Lys met Soektog',0),(218855,6080,'ro','Lista atunci cÃ¢nd cautÄƒ',0),(218856,6080,'et','Loendist otsimisel',0),(218857,6080,'si','Seznam pri iskanju',0),(218858,6080,'ba','Daftar saat melakukan pencarian',0),(218859,6080,'nl','Lijst bij het zoeken',0),(218860,6080,'fi','Luettelo etsittÃ¤essÃ¤',0),(218861,6080,'no','Listen nÃ¥r du sÃ¸ker',0),(218862,6080,'da','Listen, nÃ¥r du sÃ¸ger',0),(218863,6080,'ko','ëª©ë¡ ê²€ìƒ‰',0),(218864,6080,'he','×”×¨×©×™×ž×” ×‘×¢×ª ×—×™×¤×•×©',0),(218865,6080,'el','Î›Î¯ÏƒÏ„Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(218866,6080,'zh','æœç´¢æ—¶åˆ—å‡º\r\n',0),(218867,6080,'sv','Lista nÃ¤r du sÃ¶ker',0),(218868,6080,'it','Elenco durante la ricerca',0),(218869,6080,'tl','',0),(218870,6080,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3617;&#3639;&#3656;&#3629;&#3585;&#3635;&#3621;&#3633;&#3591;&#3588;&#3657;&#3609;&#3627;&#3634;',0),(218871,6080,'hi','à¤œà¤¬ à¤–à¥‹à¤œ à¤¸à¥‚à¤šà¥€',0),(218872,6080,'ms','Senarai semasa mencari',0),(218873,6080,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¹Ù†Ø¯ Ø§Ù„Ø¨Ø­Ø«',0),(218874,6080,'fr','Liste lors de la recherche',0),(218875,6080,'jp','æ¤œç´¢ä¸­ãƒªã‚¹ãƒˆã?«ã?™ã‚‹',0),(218876,6080,'pt','Lista ao Pesquisar',0),(218877,6080,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ñ€Ð¸ Ð¿Ð¾Ð¸ÑÐºÐµ',0),(218878,6080,'es','Listar cuando Buscar',0),(218879,6080,'de','Liste bei der Suche',0),(218880,6080,'en','List when Searching',0),(218881,6081,'is','',0),(218882,6081,'dr','(ÙƒØ§ØºØ°ÙŠ) ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(218883,6081,'pr','ÙØ§ÙŠÙ„ Ù…Ù‚Ø§Ù„Ù‡ (ÙƒØ§ØºØ°ÙŠ) ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(218884,6081,'tr','KaÄŸÄ±t dosyasÄ± iÃ§eri aktarÄ±ldÄ±',0),(218885,6081,'pl','Zaimportowany plik papieru',0),(218886,6081,'bg','Ð¥Ð°Ñ€Ñ‚Ð¸Ñ Ñ„Ð°Ð¹Ð»Ð° Ð²Ð½ÐµÑÐµÐ½Ð¸',0),(218887,6081,'ur','Ú©Ø§ØºØ° Ù…Ø³Ù„ Ø¯Ø±Ø¢Ù…Ø¯',0),(218888,6081,'sr','ÐŸÐ°Ð¿Ð¸Ñ€ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ñ˜Ðµ ÑƒÐ²ÐµÐ·ÐµÐ½Ð°',0),(218889,6081,'vi','ÄÃ£ nháº­p há»“ sÆ¡ giáº¥y',0),(218890,6081,'af','PapierlÃªer Ingevoer',0),(218891,6081,'ro','HÃ¢rtie fiÅŸier importat',0),(218892,6081,'et','Paber fail on imporditud',0),(218893,6081,'si','Papir datoteke uvoÅ¾ene',0),(218894,6081,'ba','Kertas File impor',0),(218895,6081,'nl','Papier bestand geÃ¯mporteerd',0),(218896,6081,'fi','Kirja-tiedosto tuotu',0),(218897,6081,'no','Papir filen importeres',0),(218898,6081,'da','Papir fil importeres',0),(218899,6081,'ko','ê°€ì ¸ì˜¨ ì¢…ì´ íŒŒì¼',0),(218900,6081,'he','× ×™×™×¨ ×§×•×‘×¥ ×©×™×•×‘×',0),(218901,6081,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Ï‡Î±ÏÏ„Î¯ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(218902,6081,'zh','å¯¼å…¥çš„çº¸è´¨æ–‡ä»¶\r\n',0),(218903,6081,'sv','Papper-fil importeras',0),(218904,6081,'it','Carta File importati',0),(218905,6081,'tl','',0),(218906,6081,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3652;&#3615;&#3621;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(218907,6081,'hi','à¤•à¤¾à¤—à¤œ à¤«à¤¾à¤‡à¤² à¤†à¤¯à¤¾à¤¤à¤¿à¤¤',0),(218908,6081,'ms','Fail kertas yang diimport',0),(218909,6081,'ar','Ø§Ù„ÙˆØ±Ù‚Ø© Ù…Ù„Ù Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(218910,6081,'fr','Dossier papier importÃ©',0),(218911,6081,'jp','ã‚¤ãƒ³ãƒ?ãƒ¼ãƒˆã?•ã‚Œã?Ÿç´™ãƒ•ã‚¡ã‚¤ãƒ«',0),(218912,6081,'pt','Arquivo de papel importado',0),(218913,6081,'ru','Ð‘ÑƒÐ¼Ð°Ð³Ð°-Ñ„Ð°Ð¹Ð», Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹',0),(218914,6081,'es','File de Papel Importado',0),(218915,6081,'de','Papier-Datei importiert',0),(218916,6081,'en','Paper File Imported',0),(218917,6082,'is','',0),(218918,6082,'dr','Ù‚Ø·Ø¹Ø§Øª Ø¯Ø± Ø³ÙŠØ³ØªÙ… ',0),(218919,6082,'pr','Ù‚Ø·Ø¹Ø§Øª Ø¯Ø± Ø³ÙŠØ³ØªÙ… ',0),(218920,6082,'tr','ParÃ§a parÃ§a Set',0),(218921,6082,'pl','Sztuk w zestawie',0),(218922,6082,'bg','Ð‘Ñ€Ð¾Ñ Ð² ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚',0),(218923,6082,'ur','Ø³ÛŒÙ¹ Ù…ÛŒÚº Ù¹Ú©Ú‘Û’ Ù¹Ú©Ú‘Û’',0),(218924,6082,'sr','ÐšÐ¾Ð¼Ð°Ð´Ð° Ñƒ ÑÐµÑ‚Ñƒ',0),(218925,6082,'vi','Miáº¿ng trong bá»™',0),(218926,6082,'af','Stukke in Stel',0),(218927,6082,'ro','BucÄƒÅ£i Ã®n Set',0),(218928,6082,'et','Tk komplektis',0),(218929,6082,'si','Kosov v kompletu',0),(218930,6082,'ba','Potongan-potongan dalam Set',0),(218931,6082,'nl','Stukken in Set',0),(218932,6082,'fi','Kpl setti',0),(218933,6082,'no','Stykker i settet',0),(218934,6082,'da','Stykker i sÃ¦t',0),(218935,6082,'ko','ì¡°ê° ì„¸íŠ¸',0),(218936,6082,'he','×”×—×œ×§×™× ×‘×¢×¨×›×ª',0),(218937,6082,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹Î± ÏƒÏ„Î¿ ÏƒÏÎ½Î¿Î»Î¿',0),(218938,6082,'zh','ç‰‡é›†\r\n',0),(218939,6082,'sv','Bitar i Set',0),(218940,6082,'it','Pezzi in serie',0),(218941,6082,'tl','',0),(218942,6082,'th','&#3594;&#3636;&#3657;&#3609;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3594;&#3640;&#3604;',0),(218943,6082,'hi','à¤Ÿà¥à¤•à¤¡à¤¼à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ',0),(218944,6082,'ms','Keping dalam',0),(218945,6082,'ar','Ø§Ù„Ù‚Ø·Ø¹ ÙÙŠ Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(218946,6082,'fr','PiÃ¨ces en jeu',0),(218947,6082,'jp','ã‚»ãƒƒãƒˆã?®éƒ¨å“?',0),(218948,6082,'pt','PeÃ§as em conjunto',0),(218949,6082,'ru','Ð¨Ñ‚ÑƒÐº Ð² Ð½Ð°Ð±Ð¾Ñ€Ðµ',0),(218950,6082,'es','Piezas en el Juego',0),(218951,6082,'de','StÃ¼ck im Set',0),(218952,6082,'en','Pieces in Set',0),(218953,6083,'is','',0),(218954,6083,'dr','ØªÙ†Ø¸ÙŠÙ… Ú†Ø§Ù¾ Ø³Ø±ÙŠØ¹',0),(218955,6083,'pr','ØªÙ†Ø¸ÙŠÙ… Ú†Ø§Ù¾ Ø³Ø±ÙŠØ¹',0),(218956,6083,'tr','Quickprint dÃ¼zeltmesi',0),(218957,6083,'pl','QuickPrint Adj',0),(218958,6083,'bg','Quickprint Ð¿Ñ€Ð¸Ð»',0),(218959,6083,'ur','Ù‚Ø§Ú©Ù¾Ø±Ø§Ù†Ù¹ Øµ',0),(218960,6083,'sr','ÐŸÑ€Ð¸Ð´ QÑƒÐ¸Ñ†ÐºÐ¿Ñ€Ð¸Ð½Ñ‚',0),(218961,6083,'vi','Chá»‰nh sá»­a in nhanh',0),(218962,6083,'af','Quickprint Adj',0),(218963,6083,'ro','Quickprint adj.',0),(218964,6083,'et','Quickprint kohandamine',0),(218965,6083,'si','Quickprint Adj',0),(218966,6083,'ba','Quickprint Adj',0),(218967,6083,'nl','QuickPrint Adj',0),(218968,6083,'fi','Quickprint Adj',0),(218969,6083,'no','Quickprint Adj',0),(218970,6083,'da','QuickPrint Adj',0),(218971,6083,'ko','Quickprint ì¡°ì •',0),(218972,6083,'he','Quickprint ×©× ×ª×•××¨',0),(218973,6083,'el','Î£ÏÎ½Ï„Î¿Î¼Î· ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Adj',0),(218974,6083,'zh','Quickprintè°ƒèŠ‚\r\n',0),(218975,6083,'sv','QuickPrint Adj',0),(218976,6083,'it','QuickPrint Adj',0),(218977,6083,'tl','',0),(218978,6083,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3629;&#3618;&#3656;&#3634;&#3591;&#3619;&#3623;&#3604;&#3648;&#3619;&#3655;&#3623;',0),(218979,6083,'hi','Quickprint Adj',0),(218980,6083,'ms','Quickprint Adj',0),(218981,6083,'ar','Ø¶Ø¨Ø· ÙƒÙˆÙŠÙƒØ¨Ø±ÙŠÙ†Øª',0),(218982,6083,'fr','QuickPrint Adj',0),(218983,6083,'jp','Quickprint Adj',0),(218984,6083,'pt','QuickPrint Adj',0),(218985,6083,'ru','QuickPrint Adj',0),(218986,6083,'es','Ajustar  Quickprint',0),(218987,6083,'de','QuickPrint Adj',0),(218988,6083,'en','Quickprint Adj',0),(218989,6084,'is','',0),(218990,6084,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ø¬ÙˆØ§Ø² Ø³Ø§Ø­Ù„ÙŠ',0),(218991,6084,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ø¬ÙˆØ§Ø² Ø³Ø§Ø­Ù„ÙŠ',0),(218992,6084,'tr','SELECT sahil kaÄŸÄ±t dosya',0),(218993,6084,'pl','WybrzeÅ¼e wybierz plik papieru',0),(218994,6084,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÑ€Ð°Ð¹Ð±Ñ€ÐµÐ¶Ð¸Ðµ Ñ…Ð°Ñ€Ñ‚Ð¸Ñ Ñ„Ð°Ð¹Ð»',0),(218995,6084,'ur','Ù…Ù†ØªØ®Ø¨ Ø³Ø§Ø­Ù„ Ú©Ø§ØºØ° Ù…Ø³Ù„',0),(218996,6084,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð±Ð°Ð»Ðµ Ð¿Ð°Ð¿Ð¸Ñ€ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(218997,6084,'vi','Lá»±a chá»n há»“ sÆ¡ giáº¥y Coast',0),(218998,6084,'af','Kies Weskus papier lÃªer',0),(218999,6084,'ro','SelectaÅ£i coasta hÃ¢rtie fiÅŸier',0),(219000,6084,'et','Valige rannikul paber fail',0),(219001,6084,'si','Izberite obali papir datoteke',0),(219002,6084,'ba','Pilih Coast kertas File',0),(219003,6084,'nl','Selecteer kust papier bestand',0),(219004,6084,'fi','Valitse Coast paperi tiedosto',0),(219005,6084,'no','Velg kysten papir fil',0),(219006,6084,'da','VÃ¦lg kyst papir fil',0),(219007,6084,'ko','ì„ íƒ í•´ì•ˆ ì¢…ì´ íŒŒì¼',0),(219008,6084,'he','×”×—×•×¤×™× ×‘×—×¨ ×§×•×‘×¥ × ×™×™×¨',0),(219009,6084,'el','Î‘ÎºÏ„Î® ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î±ÏÏ‡ÎµÎ¯Î¿ Ï‡Î±ÏÏ„Î¯',0),(219010,6084,'zh','é€‰æ‹©æµ·å²¸æ¡£æ¡ˆæ–‡ä»¶\r\n',0),(219011,6084,'sv','VÃ¤lj kusten papper fil',0),(219012,6084,'it','File carta Costa Select',0),(219013,6084,'tl','',0),(219014,6084,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3649;&#3615;&#3657;&#3617;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3607;&#3637;&#3656;&#3621;&#3634;&#3604;&#3648;&#3629;&#3637;&#3618;&#3591;',0),(219015,6084,'hi','à¤šà¥à¤¨à¥‡à¤‚ à¤•à¥‹à¤¸à¥à¤Ÿ à¤ªà¥‡à¤ªà¤° à¤«à¤¼à¤¾à¤‡à¤²',0),(219016,6084,'ms','Pantai pilih kertas fail',0),(219017,6084,'ar','Ù…Ù„Ù ÙˆØ±Ù‚Ø© Ø­Ø¯Ø¯ Ø³Ø§Ø­Ù„',0),(219018,6084,'fr','Dossier papier Coast Select',0),(219019,6084,'jp','Select Coast Paper File',0),(219020,6084,'pt','Selecione Costa papel arquivo',0),(219021,6084,'ru','Ð¤Ð°Ð¹Ð» Ð±ÑƒÐ¼Ð°Ð³Ð¸ Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð±ÐµÑ€ÐµÐ¶ÑŒÐµ',0),(219022,6084,'es','Seleccionar File de Papel Coast',0),(219023,6084,'de','WÃ¤hlen Sie KÃ¼ste Papier Datei',0),(219024,6084,'en','Select Coast Paper File',0),(219025,6085,'is','',0),(219026,6085,'dr','ØªÙ†Ø¸ÙŠÙ…Ø§Øª',0),(219027,6085,'pr','ØªÙ†Ø¸ÙŠÙ…Ø§Øª',0),(219028,6085,'tr','Ayarlar',0),(219029,6085,'pl','Ustawienia',0),(219030,6085,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸',0),(219031,6085,'ur','Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº',0),(219032,6085,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐºÐµ',0),(219033,6085,'vi','Cháº¿ Ä‘á»™ cÃ i Ä‘áº·t',0),(219034,6085,'af','Verstellings',0),(219035,6085,'ro','SetÄƒri',0),(219036,6085,'et','Seaded',0),(219037,6085,'si','Nastavitve',0),(219038,6085,'ba','Pengaturan',0),(219039,6085,'nl','Instellingen',0),(219040,6085,'fi','Asetukset',0),(219041,6085,'no','Innstillinger',0),(219042,6085,'da','Indstillinger',0),(219043,6085,'ko','ì„¤ì •',0),(219044,6085,'he','×”×’×“×¨×•×ª',0),(219045,6085,'el','Î¡Ï…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚',0),(219046,6085,'zh','è®¾ç½®\r\n',0),(219047,6085,'sv','InstÃ¤llningar',0),(219048,6085,'it','Impostazioni',0),(219049,6085,'tl','',0),(219050,6085,'th','&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(219051,6085,'hi','à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸',0),(219052,6085,'ms','Seting',0),(219053,6085,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª',0),(219054,6085,'fr','ParamÃ¨tres',0),(219055,6085,'jp','è¨­å®š',0),(219056,6085,'pt','ConfiguraÃ§Ãµes',0),(219057,6085,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(219058,6085,'es','Configuraciones',0),(219059,6085,'de','Einstellungen',0),(219060,6085,'en','Settings',0),(219061,6086,'is','',0),(219062,6086,'dr','(ÙˆØ±Ù‚) Ø¯Ø± Ù‡Ø± ÙƒØ§Ø±ØªÙ† ',0),(219063,6086,'pr','Ø¨Ø±Ú¯Ù‡ (ÙˆØ±Ù‚) Ø¯Ø± Ù‡Ø± ÙƒØ§Ø±ØªÙ† ',0),(219064,6086,'tr','Kutu baÅŸÄ±na',0),(219065,6086,'pl','Arkusze kartonu',0),(219066,6086,'bg','Ð›Ð¸ÑÑ‚Ð° Ð² ÐºÐ°ÑˆÐ¾Ð½',0),(219067,6086,'ur','Ø§ÙˆØ±Ø§Ù‚ ÙÛŒ Ú©Ø§Ø±Ù¹Ù†',0),(219068,6086,'sr','Ð›Ð¸ÑÑ‚Ð¾Ð²Ð° Ð¿Ð¾ ÐºÐ°Ñ€Ñ‚Ð¾Ð½',0),(219069,6086,'vi','Trang má»—i thÃ¹ng carton',0),(219070,6086,'af','Velle per Karton',0),(219071,6086,'ro','Foi pe Carton',0),(219072,6086,'et','Lehte karbis',0),(219073,6086,'si','Listov na Å¡katli',0),(219074,6086,'ba','Lembar per karton',0),(219075,6086,'nl','Bladen per karton',0),(219076,6086,'fi','Arkkia laatikossa',0),(219077,6086,'no','Ark per eske',0),(219078,6086,'da','Ark pr. karton',0),(219079,6086,'ko','íŒì§€ ë‹¹ ì‹œíŠ¸',0),(219080,6086,'he','×’×™×œ×™×•× ×•×ª ×œ×›×œ ×§×¨×˜×•×Ÿ',0),(219081,6086,'el','Î¦ÏÎ»Î»Î± Î±Î½Î¬ Ï‡Î±ÏÏ„Î¿ÎºÎ¹Î²ÏŽÏ„Î¹Î¿',0),(219082,6086,'zh','è¡¨æ¯ç®±\r\n',0),(219083,6086,'sv','Ark per kartong',0),(219084,6086,'it','Fogli per scatola',0),(219085,6086,'tl','',0),(219086,6086,'th','&#3649;&#3612;&#3656;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3605;&#3656;&#3629;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(219087,6086,'hi','à¤¦à¤«à¤¼à¥à¤¤à¥€ à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¤¤à¥à¤°à¤•',0),(219088,6086,'ms','Lembaran satu kadbod',0),(219089,6086,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ù„ÙƒÙ„ ÙƒØ±ØªÙˆÙ†',0),(219090,6086,'fr','Feuilles / Carton',0),(219091,6086,'jp','ã‚«ãƒ¼ãƒˆãƒ³ã?”ã?¨ã?®ã‚·ãƒ¼ãƒˆ',0),(219092,6086,'pt','Folhas por caixa',0),(219093,6086,'ru','Ð›Ð¸ÑÑ‚Ð¾Ð² Ð² ÑƒÐ¿Ð°ÐºÐ¾Ð²ÐºÐµ',0),(219094,6086,'es','Hojas por CartÃ³n',0),(219095,6086,'de','Blatt pro Karton',0),(219096,6086,'en','Sheets per Carton',0),(219097,6087,'is','',0),(219098,6087,'dr','(ÙˆØ±Ù‚) Ø¯Ø± Ù‡Ø± Ø¨Ø³ØªÙ‡ ',0),(219099,6087,'pr','Ø¨Ø±Ú¯Ù‡ (ÙˆØ±Ù‚) Ø¯Ø± Ù‡Ø± Ø¨Ø³ØªÙ‡ ',0),(219100,6087,'tr','Paket baÅŸÄ±na',0),(219101,6087,'pl','Arkuszy w opakowaniu',0),(219102,6087,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ Ð² ÐµÐ´Ð½Ð° Ð¾Ð¿Ð°ÐºÐ¾Ð²ÐºÐ°',0),(219103,6087,'ur','Ø§ÙˆØ±Ø§Ù‚ ÙÛŒ Ù¾ÛŒÚ©ÛŒØ¬',0),(219104,6087,'sr','Ð›Ð¸ÑÑ‚Ð¾Ð²Ð° Ð¿Ð¾ Ð¿Ð°ÐºÐµÑ‚',0),(219105,6087,'vi','Trang má»—i kiá»‡n',0),(219106,6087,'af','Velle per Pakkie',0),(219107,6087,'ro','Coli per pachet',0),(219108,6087,'et','Lehtede arv pakendis',0),(219109,6087,'si','Listov na paket',0),(219110,6087,'ba','Lembar per paket',0),(219111,6087,'nl','Vellen per pakket',0),(219112,6087,'fi','Arkkeja Paketti',0),(219113,6087,'no','Ark per pakke',0),(219114,6087,'da','Ark pr. pakke',0),(219115,6087,'ko','íŒ¨í‚¤ì§€ ë‹¹ ìž¥',0),(219116,6087,'he','×’×œ×™×•× ×•×ª ×‘×—×‘×™×œ×”',0),(219117,6087,'el','Î¦ÏÎ»Î»Î± Î±Î½Î¬ Ï€Î±ÎºÎ­Ï„Î¿',0),(219118,6087,'zh','è¡¨æ¯åŒ…\r\n',0),(219119,6087,'sv','Ark per fÃ¶rpackning',0),(219120,6087,'it','Fogli per confezione',0),(219121,6087,'tl','',0),(219122,6087,'th','&#3649;&#3612;&#3656;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3605;&#3656;&#3629;&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;',0),(219123,6087,'hi','à¤ªà¥ˆà¤•à¥‡à¤œ à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¤¤à¥à¤°à¤•',0),(219124,6087,'ms','Lembaran satu pakej',0),(219125,6087,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ù„ÙƒÙ„ Ø­Ø²Ù…Ø©',0),(219126,6087,'fr','Feuilles par paquet',0),(219127,6087,'jp','ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸ã?”ã?¨ã?®ã‚·ãƒ¼ãƒˆ',0),(219128,6087,'pt','Folhas por pacote',0),(219129,6087,'ru','Ð›Ð¸ÑÑ‚Ð¾Ð² Ð² Ð¿Ð°ÐºÐµÑ‚',0),(219130,6087,'es','Hojas por Paquete',0),(219131,6087,'de','Blatt pro Paket',0),(219132,6087,'en','Sheets per Package',0),(219133,6088,'is','',0),(219134,6088,'dr','(ÙˆØ±Ù‚) Ø¯Ø± Ù‡Ø± ÙƒÙÙ‡ Ø¨Ø§Ø±Ú¯ÙŠØ±ÙŠ ',0),(219135,6088,'pr','Ø¨Ø±Ú¯Ù‡ (ÙˆØ±Ù‚) Ø¯Ø± Ù‡Ø± ÙƒÙÙ‡ Ø¨Ø§Ø±Ú¯ÙŠØ±ÙŠ \r\n Skid',0),(219136,6088,'tr','Skid baÅŸÄ±na',0),(219137,6088,'pl','Arkusze w mini',0),(219138,6088,'bg','Ð›Ð¸ÑÑ‚Ð° Ð·Ð° Ð±ÑƒÐºÑÑƒÐ²Ð°Ð½Ðµ',0),(219139,6088,'ur','Ø§ÙˆØ±Ø§Ù‚ ÙÛŒ Ù¾Ú¾Ø³Ù„Ù†Ø§',0),(219140,6088,'sr','Ð›Ð¸ÑÑ‚Ð¾Ð²Ð° Ð¿Ð¾ Ð¡ÐºÐ¸Ð´',0),(219141,6088,'vi','Trang má»—i á»‘ng giáº¥y',0),(219142,6088,'af','Velle per gly',0),(219143,6088,'ro','Foi pe mini',0),(219144,6088,'et','Lehtede arv jalastele',0),(219145,6088,'si','Listov na drsenju',0),(219146,6088,'ba','Lembar per Skid',0),(219147,6088,'nl','Vellen per Skid',0),(219148,6088,'fi','Arkkeja liukuohjattuihin',0),(219149,6088,'no','Ark per Skid',0),(219150,6088,'da','Ark pr. Skid',0),(219151,6088,'ko','ìŠ¤í‚¤ ë“œ ë‹¹ ìž¥',0),(219152,6088,'he','×’×œ×™×•× ×•×ª ×”×—×œ×§×”',0),(219153,6088,'el','Î¦ÏÎ»Î»Î± Î±Î½Î¬ Î¿Î»Î¯ÏƒÎ¸Î·ÏƒÎ·Ï‚',0),(219154,6088,'zh','æ¯æ¿\r\n',0),(219155,6088,'sv','Ark per Skid',0),(219156,6088,'it','Fogli per Skid',0),(219157,6088,'tl','',0),(219158,6088,'th','&#3649;&#3612;&#3656;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3605;&#3656;&#3629;&#3619;&#3634;&#3591;&#3648;&#3621;&#3639;&#3656;&#3629;&#3609;',0),(219159,6088,'hi','à¤¸à¥à¤•à¤¿à¤¡ à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¤¤à¥à¤°à¤•',0),(219160,6088,'ms','Lembaran satu tergelincir',0),(219161,6088,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ù„ÙƒÙ„ Ø¬Ø±Ø§ÙØ©',0),(219162,6088,'fr','Feuilles par palette',0),(219163,6088,'jp','ã‚¹ã‚­ãƒƒãƒ‰ã?”ã?¨ã?®ã‚·ãƒ¼ãƒˆ',0),(219164,6088,'pt','Folhas por Skid',0),(219165,6088,'ru','Ð›Ð¸ÑÑ‚Ð¾Ð² Ð² Ð·Ð°Ð½Ð¾Ñ',0),(219166,6088,'es','Hojas por Paleta',0),(219167,6088,'de','Bogen pro Skid',0),(219168,6088,'en','Sheets per Skid',0),(219169,6089,'is','',0),(219170,6089,'dr','Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ \r\nj',0),(219171,6089,'pr','Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ \r\nj',0),(219172,6089,'tr','Standardj',0),(219173,6089,'pl','Standardj',0),(219174,6089,'bg','Standardj',0),(219175,6089,'ur','Ø³ØªØ§Ù†Ø¯Ø¢Ø±Ø¯Ø¬',0),(219176,6089,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ñ˜',0),(219177,6089,'vi','Chuáº©nj',0),(219178,6089,'af','Standaardj',0),(219179,6089,'ro','Standardj',0),(219180,6089,'et','Standardj',0),(219181,6089,'si','Standardj',0),(219182,6089,'ba','Standardj',0),(219183,6089,'nl','Standardj',0),(219184,6089,'fi','Standardj',0),(219185,6089,'no','Standardj',0),(219186,6089,'da','Standardj',0),(219187,6089,'ko','Standardj',0),(219188,6089,'he','Standardj',0),(219189,6089,'el','Standardj',0),(219190,6089,'zh','æ ‡å‡†\r\n',0),(219191,6089,'sv','Standardj',0),(219192,6089,'it','Standardj',0),(219193,6089,'tl','',0),(219194,6089,'th','&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(219195,6089,'hi','Standardj',0),(219196,6089,'ms','Standardj',0),(219197,6089,'ar','Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯Ø¬',0),(219198,6089,'fr','Standardj',0),(219199,6089,'jp','æ¨™æº–',0),(219200,6089,'pt','Standardj',0),(219201,6089,'ru','Standardj',0),(219202,6089,'es','EstÃ¡ndar J',0),(219203,6089,'de','Standardj',0),(219204,6089,'en','Standardj',0),(219205,6090,'is','',0),(219206,6090,'dr','Ù†ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(219207,6090,'pr','Ù†ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(219208,6090,'tr','Stocktype',0),(219209,6090,'pl','Stocktype',0),(219210,6090,'bg','Stocktype',0),(219211,6090,'ur','Ø³Ù¹ÙˆÚ©Ú©ØªÛŒÙ¾ÛŒ',0),(219212,6090,'sr','Ð¡Ñ‚Ð¾Ñ†ÐºÑ‚yÐ¿Ðµ',0),(219213,6090,'vi','Loáº¡i HÃ ng tá»“n',0),(219214,6090,'af','Voorraadtipe',0),(219215,6090,'ro','Stocktype',0),(219216,6090,'et','Stocktype',0),(219217,6090,'si','Stocktype',0),(219218,6090,'ba','Stocktype',0),(219219,6090,'nl','Stocktype',0),(219220,6090,'fi','Stocktype',0),(219221,6090,'no','Stocktype',0),(219222,6090,'da','Stocktype',0),(219223,6090,'ko','Stocktype',0),(219224,6090,'he','Stocktype',0),(219225,6090,'el','Stocktype',0),(219226,6090,'zh','åº“å­˜ç±»åž‹\r\n',0),(219227,6090,'sv','Stocktype',0),(219228,6090,'it','Stocktype',0),(219229,6090,'tl','',0),(219230,6090,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(219231,6090,'hi','Stocktype',0),(219232,6090,'ms','Stocktype',0),(219233,6090,'ar','Ø³ØªÙˆÙƒØªÙŠØ¨ÙŠ',0),(219234,6090,'fr','Stocktype',0),(219235,6090,'jp','åœ¨åº«ã‚¿ã‚¤ãƒ—',0),(219236,6090,'pt','Stocktype',0),(219237,6090,'ru','Stocktype',0),(219238,6090,'es','Tipo de Stock',0),(219239,6090,'de','Stocktype',0),(219240,6090,'en','Stocktype',0),(219241,6091,'is','',0),(219242,6091,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù‡Ø´ Ù‚ÙŠÙ…Øª',0),(219243,6091,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù‡Ø´ Ù‚ÙŠÙ…Øª',0),(219244,6091,'tr','Fiyat sonlarÄ± kullanÄ±n',0),(219245,6091,'pl','UÅ¼yj ceny',0),(219246,6091,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ†ÐµÐ½Ð° Ð¿Ð¾Ñ‡Ð¸Ð²ÐºÐ¸',0),(219247,6091,'ur','Ø²ÛŒØ± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù‚ÛŒÙ…Øª Ù¹ÙˆÙ¹ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(219248,6091,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¿Ð°ÑƒÐ·Ðµ Ð·Ð° Ñ†ÐµÐ½Ñƒ',0),(219249,6091,'vi','DÃ¹ng giÃ¡ phÃ¢n chia',0),(219250,6091,'af','Gebruik prys breek',0),(219251,6091,'ro','UtilizaÅ£i pauze de pret',0),(219252,6091,'et','Kasutamise hind puruneb',0),(219253,6091,'si','Uporaba cena odmori',0),(219254,6091,'ba','Menggunakan harga istirahat',0),(219255,6091,'nl','Gebruik prijs breekt',0),(219256,6091,'fi','KÃ¤ytÃ¤ hinta taukoja',0),(219257,6091,'no','Bruk pris pauser',0),(219258,6091,'da','Bruge prisen pauser',0),(219259,6091,'ko','ê°€ê²© ë‚˜ëˆ„ê¸°ë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(219260,6091,'he','×©×™×ž×•×© ×ž×—×™×¨ ×ž×¢×‘×¨×™',0),(219261,6091,'el','Î§ÏÎ®ÏƒÎ· Î´Î¹Î±Î»ÎµÎ¯Î¼Î¼Î±Ï„Î± Ï„Ï‰Î½ Ï„Î¹Î¼ÏŽÎ½',0),(219262,6091,'zh','ä½¿ç”¨ä»·æ ¼çªç ´\r\n',0),(219263,6091,'sv','AnvÃ¤nda pris raster',0),(219264,6091,'it','Utilizzare interruzioni di prezzo',0),(219265,6091,'tl','',0),(219266,6091,'th','&#3651;&#3594;&#3657;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3627;&#3618;&#3640;&#3604;',0),(219267,6091,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤µà¤¿à¤°à¤¾à¤®à¥‹à¤‚ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(219268,6091,'ms','Penggunaan harga pecah',0),(219269,6091,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… ÙÙˆØ§ØµÙ„ Ø§Ù„Ø³Ø¹Ø±',0),(219270,6091,'fr','Utilisez des sauts de prix',0),(219271,6091,'jp','å€¤å´©ã‚Œã‚’ä½¿ç”¨',0),(219272,6091,'pt','Use quebras de preÃ§o',0),(219273,6091,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÑ€Ñ‹Ð²Ñ‹ Ð¦ÐµÐ½Ð°',0),(219274,6091,'es','Usar Descuentos de los Precios',0),(219275,6091,'de','Verwendung Preis bricht',0),(219276,6091,'en','Use Price Breaks',0),(219277,6092,'is','',0),(219278,6092,'dr','Ù†ÙˆØ¹ ÙˆØ²Ù† ',0),(219279,6092,'pr','Ù†ÙˆØ¹ ÙˆØ²Ù† ',0),(219280,6092,'tr','Weighttype',0),(219281,6092,'pl','Weighttype',0),(219282,6092,'bg','Weighttype',0),(219283,6092,'ur','ÙˆÛŒØ§Ú¯ÛÙ¹ÛŒÙ¾ÛŒ',0),(219284,6092,'sr','WÐµÐ¸Ð³Ñ…Ñ‚Ñ‚yÐ¿Ðµ',0),(219285,6092,'vi','Loáº¡i Trá»ng lÆ°á»£ng ',0),(219286,6092,'af','Gewig Tipe',0),(219287,6092,'ro','Weighttype',0),(219288,6092,'et','KaalutÃ¼Ã¼p',0),(219289,6092,'si','Weighttype',0),(219290,6092,'ba','Weighttype',0),(219291,6092,'nl','Weighttype',0),(219292,6092,'fi','Weighttype',0),(219293,6092,'no','Weighttype',0),(219294,6092,'da','Weighttype',0),(219295,6092,'ko','Weighttype',0),(219296,6092,'he','Weighttype',0),(219297,6092,'el','Weighttype',0),(219298,6092,'zh','é‡é‡åž‹\r\n',0),(219299,6092,'sv','Weighttype',0),(219300,6092,'it','Weighttype',0),(219301,6092,'tl','',0),(219302,6092,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;',0),(219303,6092,'hi','Weighttype',0),(219304,6092,'ms','Weighttype',0),(219305,6092,'ar','ÙˆÙŠØºØªÙŠØ¨ÙŠ',0),(219306,6092,'fr','Weighttype',0),(219307,6092,'jp','é‡?é‡?ã‚¿ã‚¤ãƒ—',0),(219308,6092,'pt','Weighttype',0),(219309,6092,'ru','Weighttype',0),(219310,6092,'es','Tipo de Peso',0),(219311,6092,'de','Weighttype',0),(219312,6092,'en','Weighttype',0),(219313,6093,'is','',0),(219314,6093,'dr','(Ø³Ø§Ø­Ù„ ) Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§ Ø¯Ø§Ø± ( ÙƒØ§ØºØ° â€“ Ø³ÙØªÙ‡ ) ÙØ§ÙŠÙ„Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³',0),(219315,6093,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø´ÙŠØ¨ (Ø³Ø§Ø­Ù„ ) Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§ Ø¯Ø§Ø± ( ÙƒØ§ØºØ° â€“ Ø³ÙØªÙ‡ ) ÙØ§ÙŠÙ„Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(219316,6093,'tr','Alma sahil kaÄŸÄ±t envanter dosyalarÄ±',0),(219317,6093,'pl','WybrzeÅ¼e import papieru magazynu plikÃ³w',0),(219318,6093,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ ÐºÑ€Ð°Ð¹Ð±Ñ€ÐµÐ¶Ð¸Ðµ Ñ…Ð°Ñ€Ñ‚Ð¸Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²ÐµÑ‚Ðµ',0),(219319,6093,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø³Ø§Ø­Ù„ Ú©Ø§ØºØ° Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø³Ù„ÛŒÚº',0),(219320,6093,'sr','Ð£Ð²Ð¾Ð· Ð¾Ð±Ð°Ð»Ðµ Ð¿Ð°Ð¿Ð¸Ñ€ Ð¿Ð¾Ð¿Ð¸Ñ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(219321,6093,'vi','Nháº­p Há»“ SÆ¡ hÃ ng Giáº¥y Coast ',0),(219322,6093,'af','Invoer van \"Coast\" Papier Voorraad LÃªers',0),(219323,6093,'ro','Dosarele de inventar coasta de import',0),(219324,6093,'et','Impordi rannikul pabertoimikuid varude',0),(219325,6093,'si','Uvoz obali papir inventurnih datotek',0),(219326,6093,'ba','Pantai impor kertas persediaan file',0),(219327,6093,'nl','Import kust papier voorraadbestanden',0),(219328,6093,'fi','Tuo Coast varaston asiapapereihin',0),(219329,6093,'no','Import kysten papir innholdsfiler',0),(219330,6093,'da','Import kyst papir lager filer',0),(219331,6093,'ko','ê°€ì ¸ì˜¤ê¸° ì½”ìŠ¤íŠ¸ ì¢…ì´ ìž¬ê³  íŒŒì¼',0),(219332,6093,'he','×—×•×£ ×™×™×‘×•× × ×™×™×¨ ×ž×œ××™ ×§×‘×¦×™×',0),(219333,6093,'el','Î‘ÎºÏ„Î® ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Î±ÏÏ‡ÎµÎ¯Î± Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ Ï‡Î±ÏÏ„Î¯',0),(219334,6093,'zh','å¯¼å…¥æµ·å²¸æ–‡ä»¶å­˜è´§æ¸…å•\r\n',0),(219335,6093,'sv','Importera kusten papper lager filer',0),(219336,6093,'it','File di importazione costa carta inventario',0),(219337,6093,'tl','',0),(219338,6093,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3649;&#3615;&#3657;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3592;&#3634;&#3585;&#3585;&#3619;&#3632;&#3604;&#3',0),(219339,6093,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¥‹à¤¸à¥à¤Ÿ à¤ªà¥‡à¤ªà¤° à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(219340,6093,'ms','Fail inventori kertas import Coast',0),(219341,6093,'ar','Ø³Ø§Ø­Ù„ Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙˆØ±Ù‚ Ø¬Ø±Ø¯ Ø§Ù„Ù…Ù„ÙØ§Øª',0),(219342,6093,'fr','CÃ´te de l\'importation des fichiers d\'inventaire papier',0),(219343,6093,'jp','Import Coast Paper Inventory Files',0),(219344,6093,'pt','Arquivos de estoque de papel importaÃ§Ã£o costa',0),(219345,6093,'ru','ÐŸÐ¾Ð±ÐµÑ€ÐµÐ¶ÑŒÐµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð±ÑƒÐ¼Ð°Ð³Ð¸',0),(219346,6093,'es','Importar Archivos de Inventario de Papel Coast',0),(219347,6093,'de','Import KÃ¼ste Papierakten Warenbestand',0),(219348,6093,'en','Import Coast Paper Inventory Files',0),(219349,6094,'is','',0),(219350,6094,'dr','(Ø³Ø§Ø­Ù„ ) Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§ Ø¯Ø§Ø± ( ÙƒØ§ØºØ° â€“ Ø³ÙØªÙ‡ ) ÙØ§ÙŠÙ„Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³ ÙƒÙ‡ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‚Ø§Ù„Ø¨ ',0),(219351,6094,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø´ÙŠØ¨ (Ø³Ø§Ø­Ù„ ) Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§ Ø¯Ø§Ø± ( ÙƒØ§ØºØ° â€“ Ø³ÙØªÙ‡ ) ÙØ§ÙŠÙ„Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ÙƒÙ‡ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‚Ø§Ù„Ø¨ \r\nØµØ§Ø¯Ø±Ø§Øª ÙØ±Ø§Ù†ÙƒÙ„ÙŠÙ† Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª\r\n FRANKLIN EXPORT FORMAT',0),(219352,6094,'tr','Franklin verme biÃ§imini kullanarak alma sahil kaÄŸÄ±t envanter dosyalarÄ± oluÅŸturulan',0),(219353,6094,'pl','WybrzeÅ¼e import papieru zapasÃ³w pliki generowane w formacie eksportu Franklin',0),(219354,6094,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ ÐºÑ€Ð°Ð¹Ð±Ñ€ÐµÐ¶Ð¸Ðµ Ñ…Ð°Ñ€Ñ‚Ð¸Ñ Ð·Ð°Ð¿Ð°ÑÐ¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰Ñ‚Ð° Ð½Ð° Ð¤Ñ€Ð°Ð½ÐºÐ»Ð¸Ð½ Ð¸Ð·Ð½Ð¾Ñ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(219355,6094,'ur','ÙØ±ÛŒÙ†Ú©Ù„Ù† Ø¨Ø±Ø¢Ù…Ø¯ Ú©ÛŒ ÙˆØ¶Ø¹ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ø³Ø§Ø­Ù„ Ú©Ø§ØºØ° Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø³Ù„ÛŒÚº Ú¯Ø§Ù†Ø±Ø§Ù¹ÛŒØ¯',0),(219356,6094,'sr','Ð£Ð²Ð¾Ð· Ð¾Ð±Ð°Ð»Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð°Ð¿Ð¸Ñ€Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð“ÐµÐ½ÐµÑ€Ð°Ñ‚ÐµÐ´ ÐºÐ¾Ñ€Ð¸ÑÑ‚ÐµÑ›Ð¸ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð¸Ð·Ð²Ð¾Ð·Ð° Ð¤Ñ€Ð°Ð½ÐºÐ»Ð¸Ð½',0),(219357,6094,'vi','Nháº­p Há»“ SÆ¡ hÃ ng Giáº¥y Coast DÃ¹ng Káº¿t Xuáº¥t Dáº¡ng Franklin',0),(219358,6094,'af','Invoer van \"Coast\" Papier Voorraad LÃªers gegenereer deur die gebruik van die Franklin Uitvoerformaat',0),(219359,6094,'ro','Import coasta hÃ¢rtie inventar fiÅŸierele generate folosind formatul de export Franklin',0),(219360,6094,'et','Impordi rannikul raamatu lao faile Generated Franklin-ekspordi vormingus',0),(219361,6094,'si','Uvoz obali papir zaloge datoteke izdelano z uporabo Franklin izvozne oblike',0),(219362,6094,'ba','Pantai impor kertas persediaan file Generated menggunakan format ekspor Franklin',0),(219363,6094,'nl','Import kust papier inventaris bestanden gemaakt met behulp van de exportindeling Franklin',0),(219364,6094,'fi','Tuo Coast paperi varaston tiedostoja luotu kÃ¤yttÃ¤mÃ¤llÃ¤ Franklin vientimuoto',0),(219365,6094,'no','Import kysten papir lager filer generert ved hjelp av eksportformatet Franklin',0),(219366,6094,'da','Import kyst papir lager filer dannet i Franklin eksport format',0),(219367,6094,'ko','í”„ëž­í´ë¦° ë‚´ë³´ë‚´ê¸° í˜•ì‹ì„ ì‚¬ìš© í•˜ ì—¬ ê°€ì ¸ì˜¤ê¸° ì½”ìŠ¤íŠ¸ ì¢…ì´ ìž¬ê³  íŒŒì¼ ìƒì„±',0),(219368,6094,'he','×—×•×£ ×™×™×‘×•× × ×™×™×¨ ×ž×œ××™ ×§×‘×¦×™× × ×•×¦×¨×ª ×‘××ž×¦×¢×•×ª ×ª×‘× ×™×ª ×™×™×¦×•× ×¤×¨× ×§×œ×™×Ÿ',0),(219369,6094,'el','Î‘ÎºÏ„Î® ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Ï‡Î±ÏÏ„Î¯ Î±Ï€Î¿Î³ÏÎ±Ï†Î® Generated Î±ÏÏ‡ÎµÎ¯Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Ï„Î· Î¼Î¿ÏÏ†Î® ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ Ï„Î¿Ï… Franklin',0),(219370,6094,'zh','å¯¼å…¥æµ·å²¸æ–‡ä»¶æ¸…å•æ–‡ä»¶ç”Ÿæˆä½¿ç”¨å¯Œå…°å…‹æž—å¯¼å‡ºæ ¼å¼\r\n',0),(219371,6094,'sv','Importera kusten papper lager filer genererade i Franklin export format',0),(219372,6094,'it','Importazione costa carta inventario file generato utilizzando il formato di esportazione di Franklin',0),(219373,6094,'tl','',0),(219374,6094,'th','Import Coast Paper Inventory Files Generated using the Franklin export format',0),(219375,6094,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¥‹à¤¸à¥à¤Ÿ à¤ªà¥‡à¤ªà¤° à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤œà¤¨à¤°à¥‡à¤Ÿ à¤«à¥à¤°à¥‡à¤‚à¤•à¤²à¤¿à¤¨ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°',0),(219376,6094,'ms','Import Coast kertas inventori fail Generated menggunakan format eksport Franklin',0),(219377,6094,'ar','Ø³Ø§Ø­Ù„ Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„ÙˆØ±Ù‚ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ù…Ù„ÙØ§Øª Ø§Ù„Ù…Ù†Ø´Ø£Ø© Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªÙ†Ø³ÙŠÙ‚ Ù…Ù„Ù ØªØµØ¯ÙŠØ± ÙØ±Ø§Ù†ÙƒÙ„ÙŠÙ†',0),(219378,6094,'fr','Importation cÃ´te papier inventaire fichiers gÃ©nÃ©rÃ©s en utilisant le format d\'exportation de Franklin',0),(219379,6094,'jp','Import Coast Paper Inventory Files Generated using the Franklin export format',0),(219380,6094,'pt','ImportaÃ§Ã£o Costa papel inventÃ¡rio arquivos gerados usando o formato de exportaÃ§Ã£o de Franklin',0),(219381,6094,'ru','ÐŸÐ¾Ð±ÐµÑ€ÐµÐ¶ÑŒÐµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð±ÑƒÐ¼Ð°Ð³Ð¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ñ„Ð°Ð¹Ð»Ñ‹ ÑÐ¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ðµ Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸ÐµÐ¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° Ð¤Ñ€Ð°Ð½ÐºÐ»Ð¸Ð½',0),(219382,6094,'es','Importar Archivos de Inventario de Papel Coast Generados usando el formato Franklin Export',0),(219383,6094,'de','Import KÃ¼ste Papier Inventory Dateien generiert mit dem Franklin-Export-format',0),(219384,6094,'en','Import Coast Paper Inventory Files Generated using the Franklin export format',0),(219385,6095,'is','',0),(219386,6095,'dr','Ù¾ÙŠØºØ§Ù… Ù¾ÙŠØ´ ÙØ±Ø¶ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(219387,6095,'pr','Ù¾ÙŠØºØ§Ù… Ù¾ÙŠØ´ ÙØ±Ø¶ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(219388,6095,'tr','SatÄ±nalma sipariÅŸi varsayÄ±lan ileti',0),(219389,6095,'pl','WiadomoÅ›Ä‡ zamÃ³wienia zakupu',0),(219390,6095,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ñ€ÐµÐ´ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(219391,6095,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ø·Û’ Ø´Ø¯Û Ù¾ÛŒØºØ§Ù…',0),(219392,6095,'sr','Ð˜Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ñƒ Ð¿Ð¾Ñ€ÑƒÐºÑƒ',0),(219393,6095,'vi','Máº·c Ä‘á»‹nh nháº¯n tin ÄÆ¡n Mua HÃ ng',0),(219394,6095,'af','Aankoopbestelling Verstekte Boodskaap',0),(219395,6095,'ro','CumpÄƒrare ordine implicitÄƒ mesaj',0),(219396,6095,'et','Ostu tellimuse vaikesÃµnumi',0),(219397,6095,'si','Nabavni nalog privzeto sporoÄilo',0),(219398,6095,'ba','Pembelian urutan Default pesan',0),(219399,6095,'nl','Aankoop Order standaardbericht',0),(219400,6095,'fi','Osto tilaus oletussanoman',0),(219401,6095,'no','KjÃ¸p for standardmelding',0),(219402,6095,'da','KÃ¸b Bestil standardmeddelelse',0),(219403,6095,'ko','êµ¬ë§¤ ì£¼ë¬¸ ê¸°ë³¸ ë©”ì‹œì§€',0),(219404,6095,'he','×”×•×“×¢×ª ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×”×–×ž× ×ª ×¨×›×™×©×”',0),(219405,6095,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î¼Î®Î½Ï…Î¼Î±',0),(219406,6095,'zh','é‡‡è´­è®¢å•é»˜è®¤é‚®ä»¶\r\n',0),(219407,6095,'sv','KÃ¶p ordning standardmeddelandet',0),(219408,6095,'it','Messaggio predefinito ordine di acquisto',0),(219409,6095,'tl','',0),(219410,6095,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(219411,6095,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(219412,6095,'ms','Pembelian perintah lalai mesej',0),(219413,6095,'ar','Ø§Ù„Ø±Ø³Ø§Ù„Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(219414,6095,'fr','Message de bon de commande par dÃ©faut',0),(219415,6095,'jp','ç™ºæ³¨æ›¸æ—¢å®šãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(219416,6095,'pt','Mensagem PadrÃ£o Ordem de Compra',0),(219417,6095,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(219418,6095,'es','Orden de Compra Mensaje Predeterminado',0),(219419,6095,'de','Kauf-Order-Standardnachricht',0),(219420,6095,'en','Purchase Order Default Message',0),(219421,6096,'is','',0),(219422,6096,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(219423,6096,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(219424,6096,'tr','Fatura notlar ekleme hatasÄ±',0),(219425,6096,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania notatek faktury',0),(219426,6096,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(219427,6096,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÙˆÙ¹ÙˆÚº Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(219428,6096,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(219429,6096,'vi','ThÃªm ghi chÃº hÃ³a Ä‘Æ¡n bá»‹ lá»—i',0),(219430,6096,'af','Fout met skep van Faktuurnotas',0),(219431,6096,'ro','Eroare la adÄƒugarea de note de facturÄƒ',0),(219432,6096,'et','TÃµrge arve mÃ¤rkmete lisamine',0),(219433,6096,'si','Napaka pri dodajanju opombe raÄuna',0),(219434,6096,'ba','Kesalahan menambahkan catatan faktur',0),(219435,6096,'nl','Fout factuur notities toevoegen',0),(219436,6096,'fi','Virhe laskun huomautuksille',0),(219437,6096,'no','Feil under tillegging av faktura notater',0),(219438,6096,'da','Fejl ved tilfÃ¸jelse af faktura noter',0),(219439,6096,'ko','ì†¡ìž¥ ë…¸íŠ¸ ì¶”ê°€ ì˜¤ë¥˜',0),(219440,6096,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×”×¢×¨×•×ª ×—×©×‘×•× ×™×ª',0),(219441,6096,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(219442,6096,'zh','é”™è¯¯æ·»åŠ å‘ç¥¨ç¥¨æ®',0),(219443,6096,'sv','Fel att lÃ¤gga till faktura anteckningar',0),(219444,6096,'it','Errore aggiungendo note fattura',0),(219445,6096,'tl','',0),(219446,6096,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(219447,6096,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(219448,6096,'ms','Ralat yang menambah Nota-Nota invois',0),(219449,6096,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(219450,6096,'fr','Erreur en ajoutant des informations sur la facture',0),(219451,6096,'jp','è«‹æ±‚æ›¸ãƒ¡ãƒ¢ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(219452,6096,'pt','Erro ao adicionar notas de factura',0),(219453,6096,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸ ÑÑ‡ÐµÑ‚Ð°',0),(219454,6096,'es','Error agregando notas de Facturas',0),(219455,6096,'de','Fehler beim HinzufÃ¼gen der Rechnung Notizen',0),(219456,6096,'en','Error adding Invoice notes',0),(219457,6097,'is','',0),(219458,6097,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙØ§ÙƒØªÙˆØ± ',0),(219459,6097,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙØ§ÙƒØªÙˆØ± ',0),(219460,6097,'tr','Yeni fatura Not',0),(219461,6097,'pl','Nowa notatka faktury',0),(219462,6097,'bg','ÐÐ¾Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(219463,6097,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù†Ø¦Û’ Ù†ÙˆÙ¹',0),(219464,6097,'sr','ÐÐ¾Ð²Ð° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(219465,6097,'vi','ThÃªm Ghi chÃº hÃ³a Ä‘Æ¡n',0),(219466,6097,'af','Faktuur Notas Skep',0),(219467,6097,'ro','NotÄƒ de facturÄƒ nouÄƒ',0),(219468,6097,'et','Uus arve MÃ¤rkus',0),(219469,6097,'si','Nov raÄun Opomba',0),(219470,6097,'ba','Catatan faktur baru',0),(219471,6097,'nl','Nieuwe factuur notitie',0),(219472,6097,'fi','Uusi lasku muistiinpano',0),(219473,6097,'no','Nye fakturaen Merk',0),(219474,6097,'da','Ny faktura Note',0),(219475,6097,'ko','ìƒˆ ì†¡ìž¥ ë©”ëª¨',0),(219476,6097,'he','×”×¢×¨×” ×—×©×‘×•× ×™×ª ×—×“×©×”',0),(219477,6097,'el','ÎÎ­Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(219478,6097,'zh','æ·»åŠ å‘ç¥¨è¯´æ˜Ž\r\n',0),(219479,6097,'sv','Ny faktura notering',0),(219480,6097,'it','Nuova nota fattura',0),(219481,6097,'tl','',0),(219482,6097,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(219483,6097,'hi','à¤¨à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¥‹à¤Ÿ',0),(219484,6097,'ms','Nota invois baru',0),(219485,6097,'ar',' Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(219486,6097,'fr','Nouvelle facture Note',0),(219487,6097,'jp','è«‹æ±‚æ›¸ãƒ¡ãƒ¢ã?®è¿½åŠ ',0),(219488,6097,'pt','Nova nota de fatura',0),(219489,6097,'ru','ÐÐ¾Ð²Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(219490,6097,'es','Factura Notas Agregar',0),(219491,6097,'de','Neue Rechnung Notiz',0),(219492,6097,'en','New Invoice Note',0),(219493,6098,'is','',0),(219494,6098,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(219495,6098,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(219496,6098,'tr','Fatura notlar baÅŸarÄ±yla eklendi',0),(219497,6098,'pl','Faktura notatki dodane pomyÅ›lnie',0),(219498,6098,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(219499,6098,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù†ÙˆÙ¹Ø³ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(219500,6098,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐÐ¾Ñ‚ÐµÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(219501,6098,'vi','ThÃªm Ghi chÃº hÃ³a Ä‘Æ¡n thÃ nh cÃ´ng',0),(219502,6098,'af','Faktuurnota\'s Suksesvol Geskep',0),(219503,6098,'ro','Note de facturÄƒ adÄƒugat cu succes',0),(219504,6098,'et','Arve mÃ¤rgib lisatud edukalt',0),(219505,6098,'si','RaÄun ugotavlja dodal uspeÅ¡no',0),(219506,6098,'ba','Faktur catatan ditambahkan berhasil',0),(219507,6098,'nl','Factuur notities toegevoegd',0),(219508,6098,'fi','Laskun muistiinpanojen lisÃ¤Ã¤minen onnistui',0),(219509,6098,'no','Faktura notater lagt',0),(219510,6098,'da','Faktura noter tilfÃ¸jet',0),(219511,6098,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì†¡ìž¥ ë…¸íŠ¸',0),(219512,6098,'he','×”×¢×¨×•×ª ×—×©×‘×•× ×™×ª × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(219513,6098,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(219514,6098,'zh','å‘ç¥¨è¯´æ˜Žæ·»åŠ æˆåŠŸ\r\n',0),(219515,6098,'sv','Faktura anteckningar lagts',0),(219516,6098,'it','Fattura note aggiunti con successo',0),(219517,6098,'tl','',0),(219518,6098,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(219519,6098,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(219520,6098,'ms','Nota-Nota invois yang berjaya menambah',0),(219521,6098,'ar','Ø£Ø¶ÙŠÙØª Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(219522,6098,'fr','Notes de facture ajoutÃ©s avec succÃ¨s',0),(219523,6098,'jp','è«‹æ±‚æ›¸ãƒ¡ãƒ¢ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(219524,6098,'pt','Notas de factura adicionadas com sucesso',0),(219525,6098,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¾Ñ‚Ð¼ÐµÑ‡Ð°ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(219526,6098,'es','Factura Notas Agregadas Exitosamente',0),(219527,6098,'de','Rechnung Notes erfolgreich hinzugefÃ¼gt',0),(219528,6098,'en','Invoice Notes added successfully',0),(219529,6099,'is','',0),(219530,6099,'dr','(ÙŠØ§Ø¯Ø¯Ø§Ø´Øª',0),(219531,6099,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø§Ù… Ø¨Ø±Ø§ÙŠ ØªÙˆØ¬Ù‡ (ÙŠØ§Ø¯Ø¯Ø§Ø´Øª',0),(219532,6099,'tr','Not iÃ§in seÃ§im adÄ±',0),(219533,6099,'pl','WybÃ³r nazwy dla Uwaga',0),(219534,6099,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° Ð¸Ð¼Ðµ Ð·Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(219535,6099,'ur','Ù†ÙˆÙ¹ Ú©Û’ Ù„ÛŒÛ’ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù†Ø§Ù…',0),(219536,6099,'sr','Ð˜Ð·Ð±Ð¾Ñ€ Ð¸Ð¼ÐµÐ½Ð° Ð·Ð° Ð±ÐµÐ»ÐµÑˆÐºÑƒ',0),(219537,6099,'vi','TÃªn lá»±a chá»n cho ghi chÃº',0),(219538,6099,'af','Seleksie Naam vir Nota',0),(219539,6099,'ro','Nume de selecÅ£ie pentru NotÄƒ',0),(219540,6099,'et','Valik nime MÃ¤rkus',0),(219541,6099,'si','Izbor imena za Note',0),(219542,6099,'ba','Pemilihan nama untuk catatan',0),(219543,6099,'nl','Selectie naam voor notitie',0),(219544,6099,'fi','Valinnan nimi Huomautus',0),(219545,6099,'no','Utvalg navn Merk',0),(219546,6099,'da','Valg af navn til Note',0),(219547,6099,'ko','ì°¸ê³  ì„ íƒ ì´ë¦„',0),(219548,6099,'he','×‘×—×™×¨×ª ×©× ×”×¢×¨×”',0),(219549,6099,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚ Î³Î¹Î± Ï„Î·Î½ ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(219550,6099,'zh','é€‰æ‹©åç§°çš„è¯´æ˜Ž\r\n',0),(219551,6099,'sv','Val av namn fÃ¶r anteckning',0),(219552,6099,'it','Selezione nome per nota',0),(219553,6099,'tl','',0),(219554,6099,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3594;&#3639;&#3656;&#3629;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(219555,6099,'hi','à¤¨à¥‹à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¯à¤¨ à¤¨à¤¾à¤®',0),(219556,6099,'ms','Pemilihan nama untuk Nota',0),(219557,6099,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø§Ø³Ù… Ù„Ù…Ù„Ø§Ø­Ø¸Ø©',0),(219558,6099,'fr','Nom de la sÃ©lection pour la Note',0),(219559,6099,'jp','ãƒ¡ãƒ¢ã?®å??å‰?é?¸æŠž',0),(219560,6099,'pt','Nome da seleÃ§Ã£o para nota',0),(219561,6099,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð’Ñ‹Ð±Ð¾Ñ€Ð° Ð¸Ð»Ð¸ Ð—Ð°Ð¼ÐµÑ‚ÐºÐ°',0),(219562,6099,'es','Nombre de SelecciÃ³n para Nota',0),(219563,6099,'de','Auswahlnamen fÃ¼r Note',0),(219564,6099,'en','Selection Name for Note',0),(219565,6100,'is','',0),(219566,6100,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ø¬Ø¯ÙŠØ¯ ',0),(219567,6100,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ø¬Ø¯ÙŠØ¯ ',0),(219568,6100,'tr','Yeni not ekleme',0),(219569,6100,'pl','Dodaj nowÄ… notatkÄ™',0),(219570,6100,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(219571,6100,'ur','Ù†ÛŒØ§ Ù†ÙˆÙ¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(219572,6100,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ñƒ',0),(219573,6100,'vi','ThÃªm Ghi ChÃº Má»›i',0),(219574,6100,'af','Nuwe Nota Byvoeg',0),(219575,6100,'ro','Adauga nota noua',0),(219576,6100,'et','Lisa uus mÃ¤rge',0),(219577,6100,'si','Dodaj nov zapisek',0),(219578,6100,'ba','Tambahkan catatan baru',0),(219579,6100,'nl','Nieuwe notitie toevoegen',0),(219580,6100,'fi','LisÃ¤Ã¤ uusi Huomautus',0),(219581,6100,'no','Legg til nytt notat',0),(219582,6100,'da','TilfÃ¸j ny Note',0),(219583,6100,'ko','ìƒˆ ë©”ëª¨ ì¶”ê°€',0),(219584,6100,'he','×”×•×¡×£ ×”×¢×¨×” ×—×“×©×”',0),(219585,6100,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(219586,6100,'zh','å¢žåŠ æ–°æ³¨\r\n',0),(219587,6100,'sv','LÃ¤gg till ny anteckning',0),(219588,6100,'it','Aggiungere una nuova nota',0),(219589,6100,'tl','',0),(219590,6100,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(219591,6100,'hi','à¤¨à¤¯à¤¾ à¤¨à¥‹à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(219592,6100,'ms','Menambah Nota Baharu',0),(219593,6100,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(219594,6100,'fr','Ajouter une nouvelle Note',0),(219595,6100,'jp','æ–°è¦?ãƒ¡ãƒ¢ã?®è¿½åŠ ',0),(219596,6100,'pt','Adicionar nova nota',0),(219597,6100,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²ÑƒÑŽ Ð—Ð°Ð¼ÐµÑ‚ÐºÑƒ',0),(219598,6100,'es','Agregar Nueva Nota',0),(219599,6100,'de','Neue Notiz hinzufÃ¼gen',0),(219600,6100,'en','Add New Note',0),(219601,6101,'is','',0),(219602,6101,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ ',0),(219603,6101,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ ',0),(219604,6101,'tr','NotlarÄ± silme hatasÄ±',0),(219605,6101,'pl','BÅ‚Ä…d podczas usuwania notatek',0),(219606,6101,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(219607,6101,'ur','Ù†ÙˆÙ¹ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(219608,6101,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(219609,6101,'vi','Lá»—i xÃ³a ghi chÃº',0),(219610,6101,'af','Fout met skrap van notas',0),(219611,6101,'ro','Eroare la È™tergerea notelor',0),(219612,6101,'et','TÃµrge kustutamisel mÃ¤rkmed',0),(219613,6101,'si','Napaka brisanja opombe',0),(219614,6101,'ba','Error menghapus catatan',0),(219615,6101,'nl','Fout bij het verwijderen van notities',0),(219616,6101,'fi','Virhe poistettaessa toteaa',0),(219617,6101,'no','Feil ved sletting av notater',0),(219618,6101,'da','Fejl ved sletning af noter',0),(219619,6101,'ko','ë…¸íŠ¸ ì‚­ì œ ì˜¤ë¥˜',0),(219620,6101,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”×¢×¨×•×ª',0),(219621,6101,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(219622,6101,'zh','é”™è¯¯åˆ é™¤æ³¨',0),(219623,6101,'sv','Fel ta bort anteckningar',0),(219624,6101,'it','Errore eliminazione di note',0),(219625,6101,'tl','',0),(219626,6101,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(219627,6101,'hi','à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(219628,6101,'ms','Ralat Menghapuskan Nota-Nota',0),(219629,6101,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(219630,6101,'fr','Erreur de suppression de notes',0),(219631,6101,'jp','ãƒ¡ãƒ¢ã?®æ¶ˆåŽ»ã‚¨ãƒ©ãƒ¼',0),(219632,6101,'pt','Erro ao excluir notas',0),(219633,6101,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð°Ð¼ÐµÑ‚Ð¾Ðº',0),(219634,6101,'es','Error eliminando notas',0),(219635,6101,'de','Fehler beim LÃ¶schen von Notizen',0),(219636,6101,'en','Error deleting notes',0),(219637,6102,'is','',0),(219638,6102,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(219639,6102,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(219640,6102,'tr','Hata gÃ¼ncelleme fatura notlar',0),(219641,6102,'pl','BÅ‚Ä…d aktualizacji faktury notatki',0),(219642,6102,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(219643,6102,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÙˆÙ¹',0),(219644,6102,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(219645,6102,'vi','Lá»—i cáº­p nháº­t ghi chÃº hÃ³a Ä‘Æ¡n',0),(219646,6102,'af','Fout met opdatering van faktuurnotas',0),(219647,6102,'ro','Eroare de actualizare facturÄƒ note',0),(219648,6102,'et','Viga ajakohastamine arve mÃ¤rkmed',0),(219649,6102,'si','Napaka posodabljanje raÄuna opombe',0),(219650,6102,'ba','Kesalahan update faktur catatan',0),(219651,6102,'nl','Fout bijwerken factuur notities',0),(219652,6102,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ laskun toteaa',0),(219653,6102,'no','Feil oppdatering faktura notater',0),(219654,6102,'da','Fejl opdatering faktura noter',0),(219655,6102,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì†¡ìž¥ ë…¸íŠ¸',0),(219656,6102,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×—×©×‘×•× ×™×ª ×”×¢×¨×•×ª',0),(219657,6102,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(219658,6102,'zh','é”™è¯¯æ›´æ–°å‘ç¥¨ç¥¨æ®\r\n',0),(219659,6102,'sv','Fel uppdatera fakturan anteckningar',0),(219660,6102,'it','Note di fattura aggiornamento errore',0),(219661,6102,'tl','',0),(219662,6102,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3',0),(219663,6102,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(219664,6102,'ms','Ralat pengemaskinian invois Nota-Nota',0),(219665,6102,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(219666,6102,'fr','Informations sur la facture mise Ã  jour erreur',0),(219667,6102,'jp','è«‹æ±‚æ›¸ãƒ¡ãƒ¢ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(219668,6102,'pt','Notas de factura atualizaÃ§Ã£o erro',0),(219669,6102,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(219670,6102,'es','Error actualizando notas de factura',0),(219671,6102,'de','Fehler Update Rechnung Notizen',0),(219672,6102,'en','Error updating invoice notes',0),(219673,6103,'is','',0),(219674,6103,'dr','ÙŠØ§Ø¯Ø§Ø´Øª ÙØ§ÙƒØªÙˆØ± ',0),(219675,6103,'pr','ÙŠØ§Ø¯Ø§Ø´Øª ÙØ§ÙƒØªÙˆØ± ',0),(219676,6103,'tr','Fatura Not',0),(219677,6103,'pl','Uwaga faktury',0),(219678,6103,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(219679,6103,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÙˆÙ¹',0),(219680,6103,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(219681,6103,'vi','Ghi chÃº hÃ³a Ä‘Æ¡n',0),(219682,6103,'af','Faktuur Nota',0),(219683,6103,'ro','NotÄƒ de facturÄƒ',0),(219684,6103,'et','Arve MÃ¤rkus',0),(219685,6103,'si','Opomba raÄuna',0),(219686,6103,'ba','Catatan faktur',0),(219687,6103,'nl','Factuur Opmerking',0),(219688,6103,'fi','Laskun Huomautus',0),(219689,6103,'no','Fakturaen Merk',0),(219690,6103,'da','Faktura BemÃ¦rk',0),(219691,6103,'ko','ì†¡ìž¥ ì°¸ê³ ',0),(219692,6103,'he','×”×¢×¨×ª ×—×©×‘×•× ×™×ª',0),(219693,6103,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(219694,6103,'zh','å‘ç¥¨æ³¨\r\n',0),(219695,6103,'sv','Faktura Obs',0),(219696,6103,'it','Fattura nota',0),(219697,6103,'tl','',0),(219698,6103,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(219699,6103,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¥‹à¤Ÿ',0),(219700,6103,'ms','Nota invois',0),(219701,6103,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(219702,6103,'fr','Note de la facture',0),(219703,6103,'jp','è«‹æ±‚æ›¸ãƒ¡ãƒ¢',0),(219704,6103,'pt','Nota de fatura',0),(219705,6103,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(219706,6103,'es','Nota de Factura',0),(219707,6103,'de','Rechnung-Hinweis',0),(219708,6103,'en','Invoice Note',0),(219709,6104,'is','',0),(219710,6104,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  ÙØ§ÙƒØªÙˆØ± ',0),(219711,6104,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  ÙØ§ÙƒØªÙˆØ± ',0),(219712,6104,'tr','Fatura notu DÃ¼zenle',0),(219713,6104,'pl','EdytowaÄ‡ notatkÄ™ faktury',0),(219714,6104,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(219715,6104,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÙˆÙ¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(219716,6104,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(219717,6104,'vi','Cáº­p Nháº­t Ghi ChÃº HÃ³a ÄÆ¡n',0),(219718,6104,'af','Faktuur Notas Opdateer',0),(219719,6104,'ro','Editare notÄƒ de facturÄƒ',0),(219720,6104,'et','Redigeeri arve mÃ¤rget',0),(219721,6104,'si','Urejanje raÄuna Opomba',0),(219722,6104,'ba','Mengedit catatan faktur',0),(219723,6104,'nl','Factuur notitie bewerken',0),(219724,6104,'fi','Muokkaa laskun muistiinpanoa',0),(219725,6104,'no','Redigere fakturaen Merk',0),(219726,6104,'da','Redigere faktura Note',0),(219727,6104,'ko','ì†¡ìž¥ ë©”ëª¨ íŽ¸ì§‘',0),(219728,6104,'he','×¢×¨×•×š ×”×¢×¨×” ×—×©×‘×•× ×™×ª',0),(219729,6104,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(219730,6104,'zh','å‘ç¥¨è¯´æ˜Žæ›´æ–°\r\n',0),(219731,6104,'sv','Redigera faktura Obs',0),(219732,6104,'it','Modifica nota fattura',0),(219733,6104,'tl','',0),(219734,6104,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(219735,6104,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¥‹à¤Ÿ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(219736,6104,'ms','Edit Nota invois',0),(219737,6104,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(219738,6104,'fr','Editer une facture Note',0),(219739,6104,'jp','è«‹æ±‚æ›¸ãƒ¡ãƒ¢ã?®æ›´æ–°',0),(219740,6104,'pt','Editar nota de fatura',0),(219741,6104,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð·Ð°Ð¼ÐµÑ‚ÐºÑƒ ÑÑ‡ÐµÑ‚Ð°',0),(219742,6104,'es','Factura Notas Actualizar',0),(219743,6104,'de','Rechnung Notiz bearbeiten',0),(219744,6104,'en','Edit Invoice Note',0),(219745,6105,'is','',0),(219746,6105,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(219747,6105,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(219748,6105,'tr','Fatura notlar baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(219749,6105,'pl','Faktura stwierdza pomyÅ›lnie zaktualizowana',0),(219750,6105,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸Ñ‚Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(219751,6105,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù†ÙˆÙ¹ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(219752,6105,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð±ÐµÐ»ÐµÐ¶Ð°ÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(219753,6105,'vi','Cáº­p Nháº­t Ghi ChÃº HÃ³a ÄÆ¡n thÃ nh cÃ´ng',0),(219754,6105,'af','Faktuur Notas suksesvol Opdateer',0),(219755,6105,'ro','Note de facturÄƒ actualizate cu succes',0),(219756,6105,'et','Arve mÃ¤rkuste vÃ¤rskendatud',0),(219757,6105,'si','RaÄun ugotavlja uspeÅ¡no posodobljena',0),(219758,6105,'ba','Catatan faktur yang berhasil',0),(219759,6105,'nl','Factuur notities bijgewerkt',0),(219760,6105,'fi','Laskun toteaa pÃ¤ivitetty onnistuneesti',0),(219761,6105,'no','Faktura notater oppdatert',0),(219762,6105,'da','Faktura noter opdateret',0),(219763,6105,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì†¡ìž¥ ë…¸íŠ¸',0),(219764,6105,'he','×”×¢×¨×•×ª ×—×©×‘×•× ×™×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(219765,6105,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(219766,6105,'zh','å‘ç¥¨ç¥¨æ®æˆåŠŸæ›´æ–°\r\n',0),(219767,6105,'sv','Faktura anteckningar uppdaterats',0),(219768,6105,'it','Note fattura aggiornati con successo',0),(219769,6105,'tl','',0),(219770,6105,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(219771,6105,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(219772,6105,'ms','Nota-Nota invois yang berjaya dikemas kini',0),(219773,6105,'ar','Ø­Ø¯Ù‘Ø«Øª Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(219774,6105,'fr','Notes de facture correctement mis Ã  jour',0),(219775,6105,'jp','è«‹æ±‚æ›¸ãƒ¡ãƒ¢ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(219776,6105,'pt','Notas de fatura atualizadas com sucesso',0),(219777,6105,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¾Ñ‚Ð¼ÐµÑ‡Ð°ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(219778,6105,'es','Factura notas actualizadas exitosamente',0),(219779,6105,'de','Rechnung Notizen erfolgreich aktualisiert',0),(219780,6105,'en','Invoice notes updated successfully',0),(219781,6106,'is','',0),(219782,6106,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(219783,6106,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(219784,6106,'tr','Notlar baÅŸarÄ±yla silindi',0),(219785,6106,'pl','Notatki przesâ”‚anie',0),(219786,6106,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(219787,6106,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù†ÙˆÙ¹',0),(219788,6106,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(219789,6106,'vi','XÃ³a Ghi ChÃº thÃ nh cÃ´ng',0),(219790,6106,'af','Nota\'s suksesvol geskrap',0),(219791,6106,'ro','Note eliminÄƒ cu succes',0),(219792,6106,'et','MÃ¤rkmed edukalt kustutatud',0),(219793,6106,'si','Opombe uspeÅ¡no izbrisana',0),(219794,6106,'ba','Catatan dihapus berhasil',0),(219795,6106,'nl','Notities met succes verwijderd',0),(219796,6106,'fi','Toteaa poistettu',0),(219797,6106,'no','Notater slettet',0),(219798,6106,'da','Noter slettet',0),(219799,6106,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ë…¸íŠ¸',0),(219800,6106,'he','×”×¢×¨×•×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(219801,6106,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(219802,6106,'zh','æˆåŠŸåˆ é™¤æ³¨é‡Š\r\n',0),(219803,6106,'sv','Anteckningar raderades',0),(219804,6106,'it','Note eliminati con successo',0),(219805,6106,'tl','',0),(219806,6106,'th','&#3621;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(219807,6106,'hi','à¤¨à¥‹à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(219808,6106,'ms','Nota-nota yang dihapuskan dengan jayanya',0),(219809,6106,'ar','Ø­Ø°ÙØª Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(219810,6106,'fr','Notes supprimÃ©s avec succÃ¨s',0),(219811,6106,'jp','ãƒ¡ãƒ¢ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(219812,6106,'pt','Notas apagadas com sucesso',0),(219813,6106,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(219814,6106,'es','Notas eliminadas exitosamente',0),(219815,6106,'de','Notes erfolgreich gelÃ¶scht',0),(219816,6106,'en','Notes deleted successfully',0),(219817,6107,'is','',0),(219818,6107,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ ',0),(219819,6107,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ ',0),(219820,6107,'tr','Notlar ekleme hatasÄ±',0),(219821,6107,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania notatek',0),(219822,6107,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(219823,6107,'ur','Ù†ÙˆÙ¹ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(219824,6107,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(219825,6107,'vi','ThÃªm ghi chÃº bá»‹ lá»—i',0),(219826,6107,'af','Fout met skep van notas',0),(219827,6107,'ro','Eroare la adÄƒugarea de note',0),(219828,6107,'et','TÃµrge mÃ¤rkmete lisamine',0),(219829,6107,'si','Napaka pri dodajanju opombe',0),(219830,6107,'ba','Kesalahan menambahkan catatan',0),(219831,6107,'nl','Fout notities toevoegen',0),(219832,6107,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ toteaa',0),(219833,6107,'no','Feil under tillegging av notater',0),(219834,6107,'da','Fejl ved tilfÃ¸jelse af noter',0),(219835,6107,'ko','ë…¸íŠ¸ë¥¼ ì¶”ê°€ í•˜ëŠ” ì˜¤ë¥˜',0),(219836,6107,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×”×¢×¨×•×ª',0),(219837,6107,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(219838,6107,'zh','é”™è¯¯æ·»åŠ æ³¨é‡Š',0),(219839,6107,'sv','Fel att lÃ¤gga till anteckningar',0),(219840,6107,'it','Errore aggiungendo note',0),(219841,6107,'tl','',0),(219842,6107,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;',0),(219843,6107,'hi','à¤¨à¥‹à¤Ÿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(219844,6107,'ms','Ralat yang menambah Nota-Nota',0),(219845,6107,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(219846,6107,'fr','Erreur en ajoutant des notes',0),(219847,6107,'jp','ãƒ¡ãƒ¢ã?®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(219848,6107,'pt','Erro ao adicionar notas',0),(219849,6107,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð°Ð¼ÐµÑ‚Ð¾Ðº',0),(219850,6107,'es','Error agregando notas',0),(219851,6107,'de','Fehler beim HinzufÃ¼gen von Notizen',0),(219852,6107,'en','Error adding notes',0),(219853,6108,'is','',0),(219854,6108,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(219855,6108,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(219856,6108,'tr','BaÅŸarÄ±yla eklenen notlar',0),(219857,6108,'pl','Notatki dodane pomyÅ›lnie',0),(219858,6108,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(219859,6108,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ù†ÙˆÙ¹',0),(219860,6108,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(219861,6108,'vi','ThÃªm Ghi ChÃº thÃ nh cÃ´ng',0),(219862,6108,'af','Nota\'s suksesvol geskep.',0),(219863,6108,'ro','Note adÄƒugate cu succes',0),(219864,6108,'et','Lisatud mÃ¤rkused',0),(219865,6108,'si','UspeÅ¡no dodali opombe',0),(219866,6108,'ba','Catatan ditambahkan berhasil',0),(219867,6108,'nl','Notities toegevoegd',0),(219868,6108,'fi','Muistiinpanojen lisÃ¤Ã¤minen onnistui',0),(219869,6108,'no','Merknader som ble lagt til',0),(219870,6108,'da','Noter tilfÃ¸jet',0),(219871,6108,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ë©”ëª¨',0),(219872,6108,'he','×”×¢×¨×•×ª ×”×ž×ª×•×•×¡×¤×•×ª ×‘×”×¦×œ×—×”',0),(219873,6108,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(219874,6108,'zh','æ³¨é‡Šæ·»åŠ æˆåŠŸ\r\n',0),(219875,6108,'sv','Anteckningar som lagts',0),(219876,6108,'it','Note aggiunte con successo',0),(219877,6108,'tl','',0),(219878,6108,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(219879,6108,'hi','à¤¨à¥‹à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(219880,6108,'ms','Nota-nota yang berjaya menambah',0),(219881,6108,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(219882,6108,'fr','Notes ajoutÃ©es avec succÃ¨s',0),(219883,6108,'jp','ãƒ¡ãƒ¢ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(219884,6108,'pt','Notas adicionadas com sucesso',0),(219885,6108,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(219886,6108,'es','Notas agregadas exitosamente',0),(219887,6108,'de','Notes erfolgreich hinzugefÃ¼gt',0),(219888,6108,'en','Notes added successfully',0),(219889,6109,'is','',0),(219890,6109,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(219891,6109,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(219892,6109,'tr','PO notlar ekleme',0),(219893,6109,'pl','Notatki PO',0),(219894,6109,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÑ‚Ðµ PO Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(219895,6109,'ur','Ù¾Ùˆ Ù†ÙˆÙ¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(219896,6109,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ ÐŸÐž Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(219897,6109,'vi','ThÃªm ghi chÃº Ä‘Æ¡n mua hÃ ng',0),(219898,6109,'af','AB Notas Skep',0),(219899,6109,'ro','Adauga PO note',0),(219900,6109,'et','PO mÃ¤rkmete lisamine',0),(219901,6109,'si','Dodajanje opomb PO',0),(219902,6109,'ba','Menambahkan catatan PO',0),(219903,6109,'nl','PO notities toevoegen',0),(219904,6109,'fi','PO huomautusten',0),(219905,6109,'no','Legge til PO notater',0),(219906,6109,'da','TilfÃ¸j noter, PO',0),(219907,6109,'ko','í¬ ë©”ëª¨ ì¶”ê°€',0),(219908,6109,'he','×”×•×¡×£ ×”×¢×¨×•×ª ×¤×•',0),(219909,6109,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÏ‰Î½ PO',0),(219910,6109,'zh','æ–°å¢žè®¢å•å¤‡æ³¨\r\n',0),(219911,6109,'sv','LÃ¤gga till PO anteckningar',0),(219912,6109,'it','Aggiungere note PO',0),(219913,6109,'tl','',0),(219914,6109,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(219915,6109,'hi','PO à¤¨à¥‹à¤Ÿà¥à¤¸ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(219916,6109,'ms','Tambah Nota-Nota PO',0),(219917,6109,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ø´Ø±Ø§Ø¡',0),(219918,6109,'fr','Ajouter des Notes de PO',0),(219919,6109,'jp','æ³¨æ–‡æ›¸ãƒ¡ãƒ¢ã?®è¿½åŠ ',0),(219920,6109,'pt','Adicionar notas de PO',0),(219921,6109,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸ PO',0),(219922,6109,'es','OC Notas Agregar',0),(219923,6109,'de','PO Notizen hinzufÃ¼gen',0),(219924,6109,'en','Add PO Notes',0),(219925,6110,'is','',0),(219926,6110,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(219927,6110,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(219928,6110,'tr','Notlar gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(219929,6110,'pl','BÅ‚Ä…d podczas aktualizowania notatki',0),(219930,6110,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(219931,6110,'ur','Ù†ÙˆÙ¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(219932,6110,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(219933,6110,'vi','Lá»—i cáº­p nháº­t ghi chÃº',0),(219934,6110,'af','Fout met opdatering van notas',0),(219935,6110,'ro','Eroare la actualizarea notelor',0),(219936,6110,'et','Viga ajakohastamine mÃ¤rkmed',0),(219937,6110,'si','Napaka pri posodabljanju opombe',0),(219938,6110,'ba','Kesalahan memperbarui catatan',0),(219939,6110,'nl','Fout bij het bijwerken van notities',0),(219940,6110,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ toteaa',0),(219941,6110,'no','Feil under oppdatering av notater',0),(219942,6110,'da','Fejl under opdatering af noter',0),(219943,6110,'ko','ë…¸íŠ¸ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(219944,6110,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×”×¢×¨×•×ª',0),(219945,6110,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(219946,6110,'zh','é”™è¯¯æ›´æ–°è¯´æ˜Žã€‚\r\n',0),(219947,6110,'sv','Gick inte att uppdatera anteckningar',0),(219948,6110,'it','Errore di aggiornamento note',0),(219949,6110,'tl','',0),(219950,6110,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(219951,6110,'hi','à¤¨à¥‹à¤Ÿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(219952,6110,'ms','Ralat dalam mengemas kini Nota-Nota',0),(219953,6110,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(219954,6110,'fr','Erreur mise Ã  jour des notes',0),(219955,6110,'jp','ãƒ¡ãƒ¢ã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(219956,6110,'pt','Erro ao atualizar notas',0),(219957,6110,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð°Ð¼ÐµÑ‚Ð¾Ðº',0),(219958,6110,'es','Error actualizando notas',0),(219959,6110,'de','Fehler beim Aktualisieren der Hinweise',0),(219960,6110,'en','Error updating notes',0),(219961,6111,'is','',0),(219962,6111,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(219963,6111,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(219964,6111,'tr','Notlar baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(219965,6111,'pl','Notatki pomyÅ›lnie zaktualizowana',0),(219966,6111,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸Ñ‚Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(219967,6111,'ur','Ù†ÙˆÙ¹ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(219968,6111,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(219969,6111,'vi','Ghi chÃ©p cáº­p nháº­t thÃ nh cÃ´ng',0),(219970,6111,'af','Nota\'s suksesvol opdateer',0),(219971,6111,'ro','Note actualizat cu succes',0),(219972,6111,'et','Lisades vÃ¤rskendatud',0),(219973,6111,'si','Opombe uspeÅ¡no posodobljena',0),(219974,6111,'ba','Catatan yang berhasil',0),(219975,6111,'nl','Notities bijgewerkt',0),(219976,6111,'fi','Muistiinpanojen pÃ¤ivittÃ¤minen onnistui',0),(219977,6111,'no','Notater oppdatert',0),(219978,6111,'da','Noter opdateret',0),(219979,6111,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ë…¸íŠ¸',0),(219980,6111,'he','×”×¢×¨×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(219981,6111,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(219982,6111,'zh','æˆåŠŸæ›´æ–°è¯´æ˜Ž\r\n',0),(219983,6111,'sv','Anteckningar uppdaterats',0),(219984,6111,'it','Note aggiornati con successo',0),(219985,6111,'tl','',0),(219986,6111,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(219987,6111,'hi','à¤¨à¥‹à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(219988,6111,'ms','Nota-nota yang berjaya dikemas kini',0),(219989,6111,'ar','Ø­Ø¯Ù‘Ø«Øª Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(219990,6111,'fr','Notes de mise Ã  jour avec succÃ¨s',0),(219991,6111,'jp','ãƒ¡ãƒ¢ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(219992,6111,'pt','Notas atualizadas com sucesso',0),(219993,6111,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(219994,6111,'es','Notas actualizadas exitosamente',0),(219995,6111,'de','Notizen, die erfolgreich aktualisiert',0),(219996,6111,'en','Notes updated successfully',0),(219997,6112,'is','',0),(219998,6112,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(219999,6112,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(220000,6112,'tr','PO NotlarÄ± DÃ¼zenle',0),(220001,6112,'pl','Edytuj notatki PO',0),(220002,6112,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° PO Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(220003,6112,'ur','Ù¾Ùˆ Ù†ÙˆÙ¹ÙˆÚº Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(220004,6112,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐŸÐž Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(220005,6112,'vi','Cáº­p Nháº­t Ghi ChÃº ÄÆ¡n Mua HÃ ng ',0),(220006,6112,'af','AB Notas Opdateer',0),(220007,6112,'ro','EditeazÄƒ note de PO',0),(220008,6112,'et','Muuta PO',0),(220009,6112,'si','Urejanje opomb PO',0),(220010,6112,'ba','Sunting catatan PO',0),(220011,6112,'nl','PO notities bewerken',0),(220012,6112,'fi','PO nuottien muokkaaminen',0),(220013,6112,'no','Redigere PO notater',0),(220014,6112,'da','Redigere PO noter',0),(220015,6112,'ko','í¬ ë…¸íŠ¸ íŽ¸ì§‘',0),(220016,6112,'he','×¢×¨×•×š ×”×¢×¨×•×ª ×¤×•',0),(220017,6112,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ PO',0),(220018,6112,'zh','é‡‡è´­è®¢å•æ³¨é‡Šæ›´æ–°\r\n',0),(220019,6112,'sv','Redigera PO noteringar',0),(220020,6112,'it','Modificare note PO',0),(220021,6112,'tl','',0),(220022,6112,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(220023,6112,'hi','PO à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(220024,6112,'ms','Edit PO Nota',0),(220025,6112,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ø´Ø±Ø§Ø¡',0),(220026,6112,'fr','Modifier les Notes de PO',0),(220027,6112,'jp','æ³¨æ–‡æ›¸ãƒ¡ãƒ¢ã?®æ›´æ–°',0),(220028,6112,'pt','Editar notas de PO',0),(220029,6112,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð·Ð°Ð¼ÐµÑ‚Ð¾Ðº PO',0),(220030,6112,'es','OC Notas Actualizar',0),(220031,6112,'de','PO Notizen bearbeiten',0),(220032,6112,'en','Edit PO Notes',0),(220033,6113,'is','',0),(220034,6113,'dr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ±ÙƒÙŠØ¨ ',0),(220035,6113,'pr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØªØ±ÙƒÙŠØ¨ ',0),(220036,6113,'tr','GL satÄ±ÅŸ hesabÄ± kompozisyon iÃ§in',0),(220037,6113,'pl','SprzedaÅ¼ konta GL dla skÅ‚adu',0),(220038,6113,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð·Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ',0),(220039,6113,'ur','Ø¬ÛŒØ¬Û’ Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ØªØ´Ú©ÛŒÙ„ Ú©Û’ Ù„Ø¦Û’',0),(220040,6113,'sr','Ð“Ð› ÐºÐ¾Ð½Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ˜Ñƒ',0),(220041,6113,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Doanh Thu HÃ ng BÃ¡n Theo ThÃ nh Pháº§n',0),(220042,6113,'af','AG Verkope Rekening vir Samestelling',0),(220043,6113,'ro','GL vÃ¢nzÄƒri cont pentru compoziÅ£ia',0),(220044,6113,'et','GL mÃ¼Ã¼gikontole koostis',0),(220045,6113,'si','GL prodajni raÄun za sestavo',0),(220046,6113,'ba','GL penjualan Account untuk komposisi',0),(220047,6113,'nl','GL Omzetrekening voor compositie',0),(220048,6113,'fi','GL: n myyntitilille koostumus',0),(220049,6113,'no','GL salgskontoen for komposisjon',0),(220050,6113,'da','GL salgskontoen for sammensÃ¦tning',0),(220051,6113,'ko','êµ¬ì„±ì— ëŒ€ í•œ GL íŒë§¤ ê³„ì •',0),(220052,6113,'he','GL ×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª ×¢×‘×•×¨ ×”×¨×›×‘',0),(220053,6113,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± ÏƒÏÎ½Î¸ÎµÏƒÎ·',0),(220054,6113,'zh','æ€»å¸é”€å”®æˆåˆ†\r\n',0),(220055,6113,'sv','GL fÃ¶rsÃ¤ljningskonto fÃ¶r sammansÃ¤ttning',0),(220056,6113,'it','Conto vendita GL per composizione',0),(220057,6113,'tl','',0),(220058,6113,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(220059,6113,'hi','à¤œà¥€à¤à¤² à¤°à¤šà¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤–à¤¾à¤¤à¤¾',0),(220060,6113,'ms','Akaun jualan GL untuk komposisi',0),(220061,6113,'ar','GL Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„ØªÙƒÙˆÙŠÙ†',0),(220062,6113,'fr','Ventes reprÃ©sentent GL Composition',0),(220063,6113,'jp','æ§‹æˆ?ã?®ï¼§ï¼¬è²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(220064,6113,'pt','Conta de vendas de GL para composiÃ§Ã£o',0),(220065,6113,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ GL Ð´Ð»Ñ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸',0),(220066,6113,'es','LM Cuenta de Ventas para ComposiciÃ³n',0),(220067,6113,'de','GL-Kundenkonto fÃ¼r Komposition',0),(220068,6113,'en','GL Sales Account for Composition',0),(220069,6114,'is','',0),(220070,6114,'dr',') Ø²ÙŠØ§Ø¯ ',0),(220071,6114,'pr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¬Ø²Ø¦ÙŠ) Ø²ÙŠØ§Ø¯ ',0),(220072,6114,'tr','GL Rush masraflar iÃ§in satÄ±ÅŸ hesabÄ±',0),(220073,6114,'pl','GL sprzedaÅ¼y konta do opÅ‚at Rush',0),(220074,6114,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð·Ð° Rush Ñ‚Ð°ÐºÑÐ¸',0),(220075,6114,'ur','Ø¬ÛŒØ¬Û’ Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø±Ø´ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Û’ Ù„ÛŒÛ’',0),(220076,6114,'sr','Ð“Ð› Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ñ€Ð°Ñ‡ÑƒÐ½ Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð ÑƒÑÑ…',0),(220077,6114,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Doanh Thu HÃ ng BÃ¡n cho PhÃ­ LÃ m HÃ ng Gáº¥p',0),(220078,6114,'af','AG Verkope Rekening vir Blitsheffings',0),(220079,6114,'ro','GL vÃ¢nzÄƒri cont pentru tarifele de Rush',0),(220080,6114,'et','GL mÃ¼Ã¼gikontole Rush tasud',0),(220081,6114,'si','GL prodajni raÄun za stroÅ¡ke hitenja',0),(220082,6114,'ba','GL penjualan rekening biaya Rush',0),(220083,6114,'nl','GL Omzetrekening voor Rush kosten',0),(220084,6114,'fi','GL: n myyntitilille Rush maksut',0),(220085,6114,'no','GL salgskontoen for Rush kostnader',0),(220086,6114,'da','GL salgskontoen for Rush afgifter',0),(220087,6114,'ko','ëŸ¬ì‰¬ ìš”ê¸ˆì— ëŒ€ í•œ GL íŒë§¤ ê³„ì •',0),(220088,6114,'he','GL ×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª ×¢×‘×•×¨ ×—×™×•×‘×™× ×œ×ž×”×¨',0),(220089,6114,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± Î²Î¹Î±ÏƒÏÎ½Î· Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(220090,6114,'zh','æ€»å¸é”€å”®å¿«é€Ÿæ”¶è´¹\r\n',0),(220091,6114,'sv','GL fÃ¶rsÃ¤ljningskonto fÃ¶r Rush avgifter',0),(220092,6114,'it','Conto vendita GL per spese di Rush',0),(220093,6114,'tl','',0),(220094,6114,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(220095,6114,'hi','à¤œà¥€à¤à¤² à¤°à¤¶ à¤†à¤°à¥‹à¤ªà¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤–à¤¾à¤¤à¤¾',0),(220096,6114,'ms','Akaun jualan GL untuk caj tergesa-gesa',0),(220097,6114,'ar','GL Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„Ø±Ø³ÙˆÙ… Ø±Ø§Ø´',0),(220098,6114,'fr','Ventes reprÃ©sentent GL Rush frais',0),(220099,6114,'jp','è‡³æ€¥è«‹æ±‚ã?®ï¼§ï¼¬è²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(220100,6114,'pt','Conta de vendas de GL para cargas de Rush',0),(220101,6114,'ru','GL Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸Ñ‚ÑÑ Ð¿Ð¸Ðº Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(220102,6114,'es','LM Cuenta de Ventas para Tarifas de Prisa',0),(220103,6114,'de','GL-Kundenkonto fÃ¼r Rush-GebÃ¼hren',0),(220104,6114,'en','GL Sales Account for Rush Charges',0),(220105,6115,'is','',0),(220106,6115,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù…ØªÙ† ',0),(220107,6115,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù…ØªÙ† ',0),(220108,6115,'tr','Metin dÃ¼zenleme',0),(220109,6115,'pl','Edycja tekstu',0),(220110,6115,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐºÑÑ‚',0),(220111,6115,'ur','Ù…ØªÙ† ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(220112,6115,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ‚ÐµÐºÑÑ‚Ð°',0),(220113,6115,'vi','Sá»­a Ná»™i Dung',0),(220114,6115,'af','Redigeer Teks',0),(220115,6115,'ro','Editare Text',0),(220116,6115,'et','Muuda teksti',0),(220117,6115,'si','Urejanje besedila',0),(220118,6115,'ba','Mengedit teks',0),(220119,6115,'nl','Tekst bewerken',0),(220120,6115,'fi','Muokkaa tekstiÃ¤',0),(220121,6115,'no','Redigere tekst',0),(220122,6115,'da','Rediger tekst',0),(220123,6115,'ko','í…ìŠ¤íŠ¸ íŽ¸ì§‘',0),(220124,6115,'he','×¢×¨×•×š ×˜×§×¡×˜',0),(220125,6115,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎºÎµÎ¹Î¼Î­Î½Î¿Ï…',0),(220126,6115,'zh','ç¼–è¾‘æ–‡å­—\r\n',0),(220127,6115,'sv','Redigera Text',0),(220128,6115,'it','Modificare il testo',0),(220129,6115,'tl','',0),(220130,6115,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(220131,6115,'hi','à¤ªà¤¾à¤  à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(220132,6115,'ms','Mengedit teks',0),(220133,6115,'ar','ØªØ­Ø±ÙŠØ± Ù†Ù€ØµÙ‘',0),(220134,6115,'fr','Modifier le texte',0),(220135,6115,'jp','æ–‡ç« ã‚’ç·¨é›†',0),(220136,6115,'pt','Editar texto',0),(220137,6115,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¢ÐµÐºÑÑ‚',0),(220138,6115,'es','Editar Texto',0),(220139,6115,'de','Bearbeiten von Text',0),(220140,6115,'en','Edit Text',0),(220141,6116,'is','',0),(220142,6116,'dr','ÙˆØ±ÙˆØ¯ Ù†Ø§Ù… ',0),(220143,6116,'pr','ÙˆØ±ÙˆØ¯ Ù†Ø§Ù… ',0),(220144,6116,'tr','GiriÅŸ adÄ±',0),(220145,6116,'pl','Nazwa wpisu',0),(220146,6116,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(220147,6116,'ur','Ù†Ø§Ù… Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(220148,6116,'sr','Ð˜Ð¼Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(220149,6116,'vi','Entry TÃªn',0),(220150,6116,'af','Inskrywingsnaam',0),(220151,6116,'ro','Numele intrÄƒrii',0),(220152,6116,'et','Kirje nimi',0),(220153,6116,'si','Ime vnosa',0),(220154,6116,'ba','Nama masuk',0),(220155,6116,'nl','Naam van vermelding',0),(220156,6116,'fi','Kohteen nimi',0),(220157,6116,'no','OppfÃ¸ringsnavnet',0),(220158,6116,'da','Postnavn',0),(220159,6116,'ko','í•­ëª© ì´ë¦„',0),(220160,6116,'he','×©× ×”×¢×¨×š',0),(220161,6116,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ¹ÏƒÎ·Ï‚',0),(220162,6116,'zh','æ¡ç›®åç§°',0),(220163,6116,'sv','Postnamnet',0),(220164,6116,'it','Nome della voce',0),(220165,6116,'tl','',0),(220166,6116,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(220167,6116,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(220168,6116,'ms','Masukan nama',0),(220169,6116,'ar','Ø§Ø³Ù… Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(220170,6116,'fr','Nom de l\'entrÃ©e',0),(220171,6116,'jp','ã‚¨ãƒ³ãƒˆãƒªãƒ¼å??',0),(220172,6116,'pt','Nome da entrada',0),(220173,6116,'ru','Ð˜Ð¼Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(220174,6116,'es','Nombre de Entrada',0),(220175,6116,'de','Eintragsname',0),(220176,6116,'en','Entry Name',0),(220177,6117,'is','',0),(220178,6117,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø¯Ø± ØµÙØ­Ø§Øª Ø¨Ø¹Ø¯ÙŠ ÙØ§ÙƒØªÙˆØ± Ø§ØµÙ„ÙŠ ',0),(220179,6117,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø¯Ø± ØµÙØ­Ø§Øª Ø¨Ø¹Ø¯ÙŠ ÙØ§ÙƒØªÙˆØ± Ø§ØµÙ„ÙŠ ',0),(220180,6117,'tr','Ana fatura aÅŸaÄŸÄ±daki sayfalara yazdÄ±rmak iÃ§in notlar',0),(220181,6117,'pl','Notatki do drukowania na stronach po gÅ‚Ã³wnym faktury',0),(220182,6117,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÑÐ»ÐµÐ´ Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(220183,6117,'ur','Ù†ÙˆÙ¹ Ø¨Ù†ÛŒØ§Ø¯ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ ØµÙØ­Ø§Øª Ù¾Ø± Ú†Ú¾Ø§Ù¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(220184,6117,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ð¼Ð° Ð¿Ñ€Ð°Ñ‚Ð¸ Ð³Ð»Ð°Ð²Ð½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(220185,6117,'vi','Ghi chÃº Ä‘á»ƒ in trÃªn trang sau hÃ³a Ä‘Æ¡n',0),(220186,6117,'af','Notas om te druk op blaaie wat volg op hoof faktuur',0),(220187,6117,'ro','Note pentru a imprima paginile principale facturÄƒ Ã®n urma',0),(220188,6117,'et','Lisades Prindi lehekÃ¼ljed pÃ¤rast peamised arve',0),(220189,6117,'si','Opombe za tiskanje na straneh po glavnega raÄuna',0),(220190,6117,'ba','Catatan untuk mencetak pada halaman berikut utama faktur',0),(220191,6117,'nl','Toelichting bij het afdrukken op de pagina na belangrijkste factuur',0),(220192,6117,'fi','Muistiinpanot tulostetaan sivuille tÃ¤rkein laskun',0),(220193,6117,'no','Notater pÃ¥ sidene etter viktigste faktura',0),(220194,6117,'da','Noter skal udskrives pÃ¥ sider efter vigtigste faktura',0),(220195,6117,'ko','ì£¼ìš” ì²­êµ¬ì„œë¥¼ ë‹¤ìŒ íŽ˜ì´ì§€ì— ì¸ì‡„ í•˜ë ¤ë©´ ë…¸íŠ¸',0),(220196,6117,'he','×”×¢×¨×•×ª ×›×“×™ ×œ×”×“×¤×™×¡ ×¢×œ ×“×¤×™× ×‘×¢×§×‘×•×ª ×—×©×‘×•× ×™×ª ×”×¨××©×™',0),(220197,6117,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÏ„Î¹Ï‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚ Ï€Î¿Ï… Î±ÎºÎ¿Î»Î¿Ï…Î¸Î¿ÏÎ½ Ï„Î·Î½ ÎºÏÏÎ¹Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(220198,6117,'zh','ä¸»è¦å‘ç¥¨åŽçš„é¡µä¸Šæ‰“å°å¤‡æ³¨\r\n',0),(220199,6117,'sv','Anteckningar fÃ¶r att skriva ut pÃ¥ sidor som fÃ¶ljer huvudsakliga faktura',0),(220200,6117,'it','Note per la stampa su pagine segue fattura principale',0),(220201,6117,'tl','',0),(220202,6117,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3607;&#3637;&#3656;&#3592;&#3632;&#3614;&#3636;&#3617;&#3614;&#3660;&#3610;&#3609;&#3627;&#3609;&#3657;&#3634;&#3605;&#3634;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3',0),(220203,6117,'hi','à¤¨à¥‹à¤Ÿ à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤®à¥à¤–à¥à¤¯ à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤ªà¤° à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(220204,6117,'ms','Nota-nota untuk mencetak halaman berikutan invois yang utama',0),(220205,6117,'ar','Ù…Ø°ÙƒØ±Ø§Øª Ù„Ù„Ø·Ø¨Ø§Ø¹Ø© Ø¹Ù„Ù‰ ØµÙØ­Ø§Øª Ø¨Ø¹Ø¯ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ',0),(220206,6117,'fr','Notes Ã  imprimer sur les pages qui suivent le principal facture',0),(220207,6117,'jp','ä¸»è¦?è«‹æ±‚æ›¸ã?«ç¶šã??ãƒšãƒ¼ã‚¸ã?«å?°åˆ·ã?•ã‚Œã‚‹ãƒ¡ãƒ¢',0),(220208,6117,'pt','Notas para imprimir seguir ao principal factura',0),(220209,6117,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ… Ð¿Ð¾ÑÐ»Ðµ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ ÑÑ‡ÐµÑ‚',0),(220210,6117,'es','Notas para imprimir en pÃ¡ginas siguendo la factura principal',0),(220211,6117,'de','Hinweise auf Seiten, die nach wichtigsten Rechnung drucken',0),(220212,6117,'en','Notes to print on pages following main invoice',0),(220213,6118,'is','',0),(220214,6118,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø¹Ø¯ Ø§Ø² ÙØ§ÙƒØªÙˆØ± ',0),(220215,6118,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø¹Ø¯ Ø§Ø² ÙØ§ÙƒØªÙˆØ± ',0),(220216,6118,'tr','SipariÅŸ faturasÄ± sonra',0),(220217,6118,'pl','Zeby po faktury',0),(220218,6118,'bg','Ð ÐµÐ´ ÑÐ»ÐµÐ´ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(220219,6118,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø¨Ø¹Ø¯ ØªØ±ØªÛŒØ¨',0),(220220,6118,'sr','Ð ÐµÐ´ Ð¿Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(220221,6118,'vi','Äáº·t hÃ ng sau khi ra hÃ³a Ä‘Æ¡n',0),(220222,6118,'af','Bestelling na afloop van Faktuur',0),(220223,6118,'ro','Ordine dupÄƒ factura',0),(220224,6118,'et','Tellimuse pÃ¤rast arve',0),(220225,6118,'si','Vrstni red po raÄunu',0),(220226,6118,'ba','Order setelah faktur',0),(220227,6118,'nl','Volgorde na factuur',0),(220228,6118,'fi','Tilauksen laskun',0),(220229,6118,'no','RekkefÃ¸lge etter faktura',0),(220230,6118,'da','RÃ¦kkefÃ¸lge efter faktura',0),(220231,6118,'ko','ì£¼ë¬¸ í›„ ì²­êµ¬ì„œ',0),(220232,6118,'he','×¡×“×¨ ×œ××—×¨ ×—×©×‘×•× ×™×ª',0),(220233,6118,'el','Î£ÎµÎ¹ÏÎ¬ Î¼ÎµÏ„Î¬ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(220234,6118,'zh','å‘ç¥¨åŽè®¢è´­\r\n',0),(220235,6118,'sv','Ordning efter faktura',0),(220236,6118,'it','Ordine dopo fattura',0),(220237,6118,'tl','',0),(220238,6118,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3627;&#3621;&#3633;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(220239,6118,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤†à¤¦à¥‡à¤¶',0),(220240,6118,'ms','Order selepas invois',0),(220241,6118,'ar','Ø§Ù„ØªØ±ØªÙŠØ¨ Ø¨Ø¹Ø¯ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(220242,6118,'fr','ArrÃªtÃ© aprÃ¨s la facture',0),(220243,6118,'jp','è«‹æ±‚æ›¸ç™ºè¡Œå¾Œã?®æ³¨æ–‡',0),(220244,6118,'pt','Ordem depois da factura',0),(220245,6118,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÐ»Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(220246,6118,'es','Orden despuÃ©s de la Factura',0),(220247,6118,'de','Reihenfolge nach Rechnung',0),(220248,6118,'en','Order after Invoice',0),(220249,6119,'is','',0),(220250,6119,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù…ØªÙ† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙØ§ÙƒØªÙˆØ±',0),(220251,6119,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù…ØªÙ† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙØ§ÙƒØªÙˆØ±',0),(220252,6119,'tr','Fatura not metnini dÃ¼zenle',0),(220253,6119,'pl','Edytuj tekst faktury',0),(220254,6119,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐºÑÑ‚ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(220255,6119,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÙˆÙ¹ Ù…ØªÙ† ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(220256,6119,'sr','Ð£Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ñ‚ÐµÐºÑÑ‚ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(220257,6119,'vi','Sá»­a Ghi ChÃº TrÃªn HÃ³a ÄÆ¡n',0),(220258,6119,'af','Redigeer Faktuurnota Teks',0),(220259,6119,'ro','EditaÅ£i textul notei facturÄƒ',0),(220260,6119,'et','Muuda arve mÃ¤rkusi',0),(220261,6119,'si','Uredite beleÂ¾ko raÄuna',0),(220262,6119,'ba','Mengedit teks catatan faktur',0),(220263,6119,'nl','Bewerken van de tekst van de noot van de factuur',0),(220264,6119,'fi','Muokkaa laskun huomautuksen teksti',0),(220265,6119,'no','Redigere fakturaen merknadstekst',0),(220266,6119,'da','Redigere faktura notetekst',0),(220267,6119,'ko','ì†¡ìž¥ ë©”ëª¨ í…ìŠ¤íŠ¸ íŽ¸ì§‘',0),(220268,6119,'he','×œ×¢×¨×•×š ×˜×§×¡×˜ ×”×¢×¨×” ×—×©×‘×•× ×™×ª',0),(220269,6119,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ Ï„Î·Ï‚ ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·Ï‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(220270,6119,'zh','ç¼–è¾‘å‘ç¥¨æ³¨é‡Šæ–‡æœ¬\r\n',0),(220271,6119,'sv','Redigera faktura texten',0),(220272,6119,'it','Modifica testo nota fattura',0),(220273,6119,'tl','',0),(220274,6119,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(220275,6119,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¥‹à¤Ÿ à¤ªà¤¾à¤  à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(220276,6119,'ms','Mengedit teks Nota invois',0),(220277,6119,'ar','ØªØ­Ø±ÙŠØ± Ù†Øµ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(220278,6119,'fr','Modifier le texte de Note de facture',0),(220279,6119,'jp','è«‹æ±‚æ›¸ãƒ¡ãƒ¢æ–‡ã?®ç·¨é›†',0),(220280,6119,'pt','Editar texto de nota de fatura',0),(220281,6119,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ‚ÐµÐºÑÑ‚ ÑÐ½Ð¾ÑÐºÐ¸ ÑÑ‡ÐµÑ‚Ð°',0),(220282,6119,'es','Editar Texto de Nota de Factura',0),(220283,6119,'de','Rechnung-Hinweis-Text bearbeiten',0),(220284,6119,'en','Edit Invoice Note Text',0),(220285,6120,'is','',0),(220286,6120,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù…ØªÙ† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(220287,6120,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù…ØªÙ† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(220288,6120,'tr','SatÄ±nalma sipariÅŸi not metnini dÃ¼zenle',0),(220289,6120,'pl','Edytuj tekst zamÃ³wienia zakupu',0),(220290,6120,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐºÑÑ‚ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(220291,6120,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ù†ÙˆÙ¹ Ù…ØªÙ† ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(220292,6120,'sr','Ð£Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ñ‚ÐµÐºÑÑ‚ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(220293,6120,'vi','Sá»­a Ghi ChÃº Trong ÄÆ¡n Mua HÃ ng ',0),(220294,6120,'af','Redigeer Aankoop Bestelling Nota Teks',0),(220295,6120,'ro','EditaÅ£i textul notei cumpÄƒrare ordine',0),(220296,6120,'et','Muuda ostutellimuse mÃ¤rkusi',0),(220297,6120,'si','Uredite beleÂ¾ko nabavni nalog',0),(220298,6120,'ba','Mengedit teks catatan Order Pembelian',0),(220299,6120,'nl','Bewerken van de tekst van de noot van de volgorde van de aankoop',0),(220300,6120,'fi','Muokkaa osto jÃ¤rjestyksessÃ¤ huomautuksen teksti',0),(220301,6120,'no','Redigere kjÃ¸p for teksten',0),(220302,6120,'da','Redigere KÃ¸b Bestil notetekst',0),(220303,6120,'ko','êµ¬ë§¤ ì£¼ë¬¸ ë©”ëª¨ í…ìŠ¤íŠ¸ íŽ¸ì§‘',0),(220304,6120,'he','×¢×¨×™×›×ª ×˜×§×¡×˜ ×”×”×¢×¨×” ×”×–×ž× ×ª ×¨×›×™×©×”',0),(220305,6120,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ Ï„Î·Ï‚ ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î±Î³Î¿ÏÎ¬Ï‚',0),(220306,6120,'zh','ç¼–è¾‘é‡‡è´­è®¢å•å¤‡æ³¨æ–‡å­—\r\n',0),(220307,6120,'sv','Redigera kÃ¶p ordning texten',0),(220308,6120,'it','Modifica testo nota ordine di acquisto',0),(220309,6120,'tl','',0),(220310,6120,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(220311,6120,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤¨à¥‹à¤Ÿ à¤ªà¤¾à¤  à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(220312,6120,'ms','Mengedit teks Nota pesanan pembelian',0),(220313,6120,'ar','ØªØ­Ø±ÙŠØ± Ù†Øµ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø© Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(220314,6120,'fr','Modifier le texte de Note achat ordonnance',0),(220315,6120,'jp','ç™ºæ³¨æ›¸ãƒ¡ãƒ¢æ–‡ã?®ç·¨é›†',0),(220316,6120,'pt','Editar texto de nota de ordem de compra',0),(220317,6120,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ‚ÐµÐºÑÑ‚ ÑÐ½Ð¾ÑÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(220318,6120,'es','Editar Orden de Compra Texto de Nota',0),(220319,6120,'de','Purchase Order Hinweistext bearbeiten',0),(220320,6120,'en','Edit Purchase Order Note Text',0),(220321,6121,'is','',0),(220322,6121,'dr','Ù†Ø§Ù… Ù…Ø´ØªØ±ÙŠ ',0),(220323,6121,'pr','Ù†Ø§Ù… Ù…Ø´ØªØ±ÙŠ ',0),(220324,6121,'tr','Ä°stemci adÄ±',0),(220325,6121,'pl','Nazwa klienta',0),(220326,6121,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(220327,6121,'ur','Ù†Ø§Ù… ÙˆØµÙˆÙ„ Ú©Ø§Ø±',0),(220328,6121,'sr','Ð˜Ð¼Ðµ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(220329,6121,'vi','TÃªn KhÃ¡ch hÃ ng',0),(220330,6121,'af','KliÃ«nt/Klant Naam',0),(220331,6121,'ro','Nume client',0),(220332,6121,'et','Kliendi nimi',0),(220333,6121,'si','Ime odjemalca',0),(220334,6121,'ba','Nama klien',0),(220335,6121,'nl','Clientnaam',0),(220336,6121,'fi','Asiakkaan nimi',0),(220337,6121,'no','Klientnavnet',0),(220338,6121,'da','Klientnavn',0),(220339,6121,'ko','í´ë¼ì´ì–¸íŠ¸ ì´ë¦„',0),(220340,6121,'he','×©× ×œ×§×•×—',0),(220341,6121,'el','ÎŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Î³ÏÎ¬Î¼Î¼Î±Ï„Î¿Ï‚-Ï€ÎµÎ»Î¬Ï„Î·',0),(220342,6121,'zh','å®¢æˆ·å§“å\r\n',0),(220343,6121,'sv','Klientens namn',0),(220344,6121,'it','Nome del client',0),(220345,6121,'tl','',0),(220346,6121,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3592;&#3657;&#3634;&#3591;',0),(220347,6121,'hi','à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(220348,6121,'ms','Nama pelanggan',0),(220349,6121,'ar','Ø§Ø³Ù… Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(220350,6121,'fr','Nom du client',0),(220351,6121,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆå??',0),(220352,6121,'pt','Nome do cliente',0),(220353,6121,'ru','Ð˜Ð¼Ñ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(220354,6121,'es','Cliente Nombre',0),(220355,6121,'de','Clientname',0),(220356,6121,'en','Client Name',0),(220357,6122,'is','',0),(220358,6122,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø¯Ø± ØµÙØ­Ø§Øª Ø¨Ø¹Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ØµÙ„ÙŠ',0),(220359,6122,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø¯Ø± ØµÙØ­Ø§Øª Ø¨Ø¹Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ØµÙ„ÙŠ',0),(220360,6122,'tr','Notlar ana izleyen sayfalarda yazdÄ±rmak iÃ§in satÄ±nalma sipariÅŸi',0),(220361,6122,'pl','Notatki do drukowania na stronach po gÅ‚Ã³wnym zamÃ³wienia',0),(220362,6122,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÑÐ»ÐµÐ´ Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(220363,6122,'ur','Ø§ÛÙ… Ø¯Ø±Ø¬ Ø°ÛŒÙ„ ØµÙØ­Ø§Øª Ù¾Ø± Ú†Ú¾Ø§Ù¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†ÙˆÙ¹ Ø¢Ø±ÚˆØ± Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(220364,6122,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ð¼Ð° Ð¿Ñ€Ð°Ñ‚Ð¸ Ð³Ð»Ð°Ð²Ð½Ð¸ ÐŸÐ¾Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ð°',0),(220365,6122,'vi','Ghi chÃº in sau chi tiáº¿t Ä‘Æ¡n hÃ ng chÃ­nh',0),(220366,6122,'af','Notas om te druk op blaaie wat volg op die hoof aankoopbestelling',0),(220367,6122,'ro','Note pentru a imprima paginile principale Ã®n urma comenzii',0),(220368,6122,'et','Lisades Prindi lehekÃ¼ljed pÃ¤rast peamised Ostutellimus',0),(220369,6122,'si','Opombe za tiskanje na straneh po glavni nabavni nalog',0),(220370,6122,'ba','Catatan untuk mencetak pada halaman berikut utama order pembelian',0),(220371,6122,'nl','Toelichting bij het afdrukken op de pagina na belangrijkste inkooporder',0),(220372,6122,'fi','Muistiinpanot tulostetaan sivuille tÃ¤rkein ostotilaus',0),(220373,6122,'no','Notater pÃ¥ sidene etter viktigste bestilling',0),(220374,6122,'da','Noter skal udskrives pÃ¥ sider efter vigtigste indkÃ¸bsordre',0),(220375,6122,'ko','ë‹¤ìŒ ë©”ì¸ íŽ˜ì´ì§€ì— ì¸ì‡„ í•˜ë ¤ë©´ ë…¸íŠ¸ êµ¬ë§¤ ì£¼ë¬¸',0),(220376,6122,'he','×”×¢×¨×•×ª ×›×“×™ ×œ×”×“×¤×™×¡ ×¢×œ ×“×¤×™× ×‘×¢×§×‘×•×ª ×”×¨××©×™ ×”×–×ž× ×ª ×¨×›×©',0),(220377,6122,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÏ„Î¹Ï‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚ Ï€Î¿Ï… Î±ÎºÎ¿Î»Î¿Ï…Î¸Î¿ÏÎ½ Ï„Î·Î½ ÎºÏÏÎ¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(220378,6122,'zh','ä¸»è¦é‡‡è´­è®¢å•åŽçš„é¡µä¸Šæ‰“å°å¤‡æ³¨\r\n\r\n',0),(220379,6122,'sv','Anteckningar fÃ¶r att skriva ut pÃ¥ sidor som fÃ¶ljer huvudsakliga inkÃ¶psorder',0),(220380,6122,'it','Ordine di acquisto di note da stampare sulle pagine seguenti principali',0),(220381,6122,'tl','',0),(220382,6122,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3607;&#3637;&#3656;&#3592;&#3632;&#3614;&#3636;&#3617;&#3614;&#3660;&#3610;&#3609;&#3627;&#3609;&#3657;&#3634;&#3605;&#3634;&#3617;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3',0),(220383,6122,'hi','à¤¨à¥‹à¤Ÿ à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤®à¥à¤–à¥à¤¯ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤ªà¤° à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶',0),(220384,6122,'ms','Nota-nota untuk mencetak halaman berikutan utama pembelian perintah',0),(220385,6122,'ar','Ù…Ø°ÙƒØ±Ø§Øª Ù„Ù„Ø·Ø¨Ø§Ø¹Ø© Ø¹Ù„Ù‰ ØµÙØ­Ø§Øª Ø±Ø¦ÙŠØ³ÙŠØ© ÙÙŠ Ø£Ø¹Ù‚Ø§Ø¨ Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(220386,6122,'fr','Notes Ã  imprimer sur les pages qui suivent le principal ordre d\'achat',0),(220387,6122,'jp','ãƒ¡ã‚¤ãƒ³ç™ºæ³¨ã?®å¾Œã?®ãƒšãƒ¼ã‚¸ã?«å?°åˆ·ã?™ã‚‹ãƒ¡ãƒ¢',0),(220388,6122,'pt','Ordem de compra de notas para imprimir nas pÃ¡ginas a seguir principal',0),(220389,6122,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ… Ð¿Ð¾ÑÐ»Ðµ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(220390,6122,'es','Notas para imprimir en pÃ¡ginas siguendo el pedido principal',0),(220391,6122,'de','Hinweise zum Drucken auf Seiten, die nach Haupt-Bestellung',0),(220392,6122,'en','Notes to print on pages following main purchase order',0),(220393,6123,'is','',0),(220394,6123,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø¹Ø¯ Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(220395,6123,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø¹Ø¯ Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(220396,6123,'tr','SipariÅŸ sonra PO',0),(220397,6123,'pl','Zeby po PO',0),(220398,6123,'bg','Ð ÐµÐ´ ÑÐ»ÐµÐ´ PO',0),(220399,6123,'ur','Ù¾Ùˆ Ú©Û’ Ø¨Ø¹Ø¯ ØªØ±ØªÛŒØ¨',0),(220400,6123,'sr','Ð ÐµÐ´ Ð½Ð°ÐºÐ¾Ð½ ÐŸÐž',0),(220401,6123,'vi','Äáº·t hÃ ng sau khi ra ÄÆ¡n Mua HÃ ng',0),(220402,6123,'af','Bestelling na AB',0),(220403,6123,'ro','Comanda dupa PO',0),(220404,6123,'et','Tellimuse pÃ¤rast PO',0),(220405,6123,'si','Vrstni red po PO',0),(220406,6123,'ba','Order setelah PO',0),(220407,6123,'nl','Volgorde na PO',0),(220408,6123,'fi','Sen jÃ¤lkeen PO',0),(220409,6123,'no','RekkefÃ¸lge etter PO',0),(220410,6123,'da','RÃ¦kkefÃ¸lge efter PO',0),(220411,6123,'ko','í¬ í›„ ì£¼ë¬¸',0),(220412,6123,'he','×¡×“×¨ ××—×¨×™ ×¤×•',0),(220413,6123,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ PO',0),(220414,6123,'zh','è®¢å•åŽè®¢è´­\r\n',0),(220415,6123,'sv','Ordning efter PO',0),(220416,6123,'it','Ordine dopo PO',0),(220417,6123,'tl','',0),(220418,6123,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3627;&#3621;&#3633;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(220419,6123,'hi','PO à¤¬à¤¾à¤¦ à¤†à¤¦à¥‡à¤¶',0),(220420,6123,'ms','Pesanan selepas PO',0),(220421,6123,'ar','Ø§Ù„ØªØ±ØªÙŠØ¨ Ø¨Ø¹Ø¯ Ø¨Ùˆ',0),(220422,6123,'fr','Ordonnance aprÃ¨s PO',0),(220423,6123,'jp','POã?®å¾Œã?«æ³¨æ–‡',0),(220424,6123,'pt','Ordem depois PO',0),(220425,6123,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÐ»Ðµ PO',0),(220426,6123,'es','Orden despuÃ©s del OC',0),(220427,6123,'de','Reihenfolge nach PO',0),(220428,6123,'en','Order after PO',0),(220429,6124,'is','',0),(220430,6124,'dr','Ø«Ø¨Øª ÙŠØ§Ø¯Ø¯Ø§Ø´ØªÙ‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¬Ù‡Øª Ú†Ø§Ù¾ Ø¯Ø± ØµÙØ­Ø§Øª ',0),(220431,6124,'pr','Ø«Ø¨Øª ÙŠØ§Ø¯Ø¯Ø§Ø´ØªÙ‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¬Ù‡Øª Ú†Ø§Ù¾ Ø¯Ø± ØµÙØ­Ø§Øª ',0),(220432,6124,'tr','Ana satÄ±nalma sipariÅŸi izleyen sayfalarda yazdÄ±rma iÃ§in seÃ§ilecek standart notlar girin',0),(220433,6124,'pl','WprowadÅº standardowe notatki majÄ… byÄ‡ wybrane do druku na stronach gÅ‚Ã³wnych zlecenie zakupu',0),(220434,6124,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÑÐ»ÐµÐ´ Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(220435,6124,'ur','Ø§ÛÙ… Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ø¯Ø±Ø¬ Ø°ÛŒÙ„ ØµÙØ­Ø§Øª Ù¾Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ ÛÙˆÙ†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù†ÙˆÙ¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(220436,6124,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð´Ð° Ð±ÑƒÐ´Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð° Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ð¼Ð° Ð½Ð°ÐºÐ¾Ð½ Ð³Ð»Ð°Ð²Ð½Ðµ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(220437,6124,'vi','Nháº­p ghi chÃº chuáº©n Ä‘á»ƒ in ra trÃªn nhá»¯ng trang sau ÄÆ¡n Mua HÃ ng',0),(220438,6124,'af','Voer Standaard Notas in wat gekies kan word vir uitdruk op blaaie wat volg op die hoof Aankoopbestelling',0),(220439,6124,'ro','IntroduceÅ£i Standard notiÅ£e pentru a fi selectat pentru imprimare pe paginile urmÄƒtoare principalele comenzi de cumpÄƒrare',0),(220440,6124,'et','Standard mÃ¤rkeid valitavate pÃ¤rast peamine ostutellimuse lehekÃ¼lgede',0),(220441,6124,'si','Vnesite standardni zapiske, izbranih za tiskanje na strani po glavnih nabavni nalog',0),(220442,6124,'ba','Masukkan catatan standar yang dipilih untuk cetak pada halaman berikut utama Order Pembelian',0),(220443,6124,'nl','Standaard biljetten worden geselecteerd om te worden afgedrukt op pagina\'s na belangrijkste Purchase Order ingeven',0),(220444,6124,'fi','Anna Standard huomautuksia valitaan sivuilla jÃ¤lkeen tÃ¤rkein ostotilaus',0),(220445,6124,'no','Angi Standard notater Ã¥ bli valgt for utskrift pÃ¥ sidene etter viktigste bestilling',0),(220446,6124,'da','Angiv Standard notater til vÃ¦lges til udskrivning pÃ¥ sider efter vigtigste indkÃ¸bsordre',0),(220447,6124,'ko','ì£¼ìš” êµ¬ë§¤ ì£¼ë¬¸ì„œë¥¼ ë‹¤ìŒ íŽ˜ì´ì§€ì— ì¸ì‡„ ì„ íƒ í‘œì¤€ ë©”ëª¨ ìž…ë ¥',0),(220448,6124,'he','×”×–×Ÿ ×”×¢×¨×•×ª ×¡×˜× ×“×¨×˜ ×©×™×™×‘×—×¨ ×¢×‘×•×¨ ×”×“×¤×¡×” ×¢×œ ×¢×ž×•×“×™× ×”×‘××™× ××—×¨×™ ×”×–×ž× ×ª ×”×¨×›×© ×”×¨××©×™',0),(220449,6124,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î£Ï„Î¬Î½Ï„Î±Ï ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± Î½Î± ÎµÏ€Î¹Î»ÎµÎ³Î¿ÏÎ½ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÏ„Î¹Ï‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚ Ï€Î¿Ï… Î±ÎºÎ¿Î»Î¿Ï…Î¸Î¿ÏÎ½ Ï„Î·Î½ ÎºÏÏÎ¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(220450,6124,'zh','è¾“å…¥æ‰“å°ä¸»è¦è´­ä¹°è®¢å•åŽé¡µé¢çš„æ ‡å‡†å¤‡æ³¨é€‰æ‹©',0),(220451,6124,'sv','Ange Standard anteckningar att vÃ¤ljas fÃ¶r utskrift pÃ¥ sidor som fÃ¶ljer huvudsakliga inkÃ¶psorder',0),(220452,6124,'it','Immettere note Standard per essere selezionati per stampa su pagine seguendo l\'ordine di acquisto principale',0),(220453,6124,'tl','',0),(220454,6124,'th','&#3611;&#3657;&#3629;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629; &#3649;&#3626;&#3604;&#',0),(220455,6124,'hi','à¤®à¥à¤–à¥à¤¯ à¤–à¤°à¥€à¤¦ à¤•à¥à¤°à¤® à¤•à¤¾ à¤ªà¤¾à¤²à¤¨ à¤ªà¥‡à¤œ à¤ªà¤° à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¨à¤• à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(220456,6124,'ms','Masukkan Nota-nota yang Standard untuk dipilih cetak di muka surat berikutan utama pesanan belian',0),(220457,6124,'ar','Ø¥Ø¯Ø®Ø§Ù„ \"Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©\" ØªØ­Ø¯ÙŠØ¯ Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ØµÙØ­Ø§Øª Ø§Ù„ØªØ§Ù„ÙŠØ© \"Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡\" Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(220458,6124,'fr','Entrez des Notes Standard Ã  retenir pour imprimer sur les pages qui suivent le bon de commande principal',0),(220459,6124,'jp','ä¸»è¦?ç™ºæ³¨æ›¸ã?«ç¶šã??ãƒšãƒ¼ã‚¸ã?¸å?°åˆ·ã?•ã‚Œã‚‹æ¨™æº–ãƒ¡ãƒ¢ã?®å…¥åŠ›',0),(220460,6124,'pt','Insira notas padrÃ£o a ser selecionado para impressÃ£o na pÃ¡gina seguindo a ordem de compra principal',0),(220461,6124,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð±ÑƒÐ´ÑƒÑ‚ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ñ‹ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ… Ð¿Ð¾ÑÐ»Ðµ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(220462,6124,'es','Introducir Notas EstÃ¡ndares para estar seleccionados para imprimir en PÃ¡ginas que siguen el Orden de Compra Principal',0),(220463,6124,'de','Geben Sie Standard Hinweise fÃ¼r Print-on-Seiten nach wichtigsten Bestellung ausgewÃ¤hlt werden',0),(220464,6124,'en','Enter Standard Notes to be selected for print on pages following main Purchase Order',0),(220465,6125,'is','',0),(220466,6125,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(220467,6125,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(220468,6125,'tr','Fatura notlar',0),(220469,6125,'pl','Faktury Notes',0),(220470,6125,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(220471,6125,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÙˆÙ¹',0),(220472,6125,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(220473,6125,'vi','Ghi chÃº hÃ³a Ä‘Æ¡n',0),(220474,6125,'af','Faktuur Notas',0),(220475,6125,'ro','Note de facturÄƒ',0),(220476,6125,'et','Arve mÃ¤rkmed',0),(220477,6125,'si','RaÄun opombe',0),(220478,6125,'ba','Catatan faktur',0),(220479,6125,'nl','Factuur notities',0),(220480,6125,'fi','Laskun toteaa',0),(220481,6125,'no','Faktura notater',0),(220482,6125,'da','Faktura noter',0),(220483,6125,'ko','ì†¡ìž¥ ë…¸íŠ¸',0),(220484,6125,'he','×”×¢×¨×•×ª ×—×©×‘×•× ×™×ª',0),(220485,6125,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(220486,6125,'zh','å‘ç¥¨è¯´æ˜Ž\r\n',0),(220487,6125,'sv','Faktura anteckningar',0),(220488,6125,'it','Note fattura',0),(220489,6125,'tl','',0),(220490,6125,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(220491,6125,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(220492,6125,'ms','Nota-Nota invois',0),(220493,6125,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(220494,6125,'fr','Informations sur la facture',0),(220495,6125,'jp','è«‹æ±‚æ›¸è¨˜è¼‰ãƒ¡ãƒ¢',0),(220496,6125,'pt','Notas de factura',0),(220497,6125,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(220498,6125,'es','Factura Notas',0),(220499,6125,'de','Rechnung Notizen',0),(220500,6125,'en','Invoice Notes',0),(220501,6126,'is','',0),(220502,6126,'dr','/ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(220503,6126,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  / ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(220504,6126,'tr','PO standart notlar',0),(220505,6126,'pl','PO standardowej notatki',0),(220506,6126,'bg','PO ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(220507,6126,'ur','Ù¾Ùˆ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù†ÙˆÙ¹',0),(220508,6126,'sr','ÐŸÐž ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¾Ð¼ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(220509,6126,'vi','Ghi chÃº chuáº©n ÄÆ¡n mua hÃ ng ',0),(220510,6126,'af','AB Standaard Notas',0),(220511,6126,'ro','PO note Standard',0),(220512,6126,'et','PO Standard mÃ¤rkmed',0),(220513,6126,'si','PO standardni zapiske',0),(220514,6126,'ba','Catatan standar PO',0),(220515,6126,'nl','PO standaard notities',0),(220516,6126,'fi','PO standardin muistiinpanoja',0),(220517,6126,'no','PO Standard notater',0),(220518,6126,'da','PO Standard noter',0),(220519,6126,'ko','í¬ í‘œì¤€ ë…¸íŠ¸',0),(220520,6126,'he','×”×¢×¨×•×ª ×¡×˜× ×“×¨×˜×™ ×¤×•',0),(220521,6126,'el','PO Ï€ÏÏŒÏ„Ï…Ï€Î¿ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(220522,6126,'zh','å®è§„èŒƒæ ‡æ³¨\r\n',0),(220523,6126,'sv','PO Standard anteckningar',0),(220524,6126,'it','Note Standard PO',0),(220525,6126,'tl','',0),(220526,6126,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(220527,6126,'hi','PO à¤®à¤¾à¤¨à¤• à¤¨à¥‹à¤Ÿ',0),(220528,6126,'ms','Nota-nota yang Standard PO',0),(220529,6126,'ar','Øµ. Ø¨ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(220530,6126,'fr','Notes Standard PO',0),(220531,6126,'jp','è«‹æ±‚æ›¸æ¨™æº–ãƒ¡ãƒ¢',0),(220532,6126,'pt','Notas padrÃ£o PO',0),(220533,6126,'ru','PO ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(220534,6126,'es','OC Notas EstÃ¡ndares',0),(220535,6126,'de','PO von Notes',0),(220536,6126,'en','PO Standard Notes',0),(220537,6127,'is','',0),(220538,6127,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø­Ù…Ù„ ',0),(220539,6127,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø­Ù…Ù„ ',0),(220540,6127,'tr','Gemiyi yeniden yazdÄ±rÄ±n',0),(220541,6127,'pl','Przedruk statku',0),(220542,6127,'bg','ÐŸÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ ÐºÐ¾Ñ€Ð°Ð±',0),(220543,6127,'ur','Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ Ø´Ù¾',0),(220544,6127,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð±Ñ€Ð¾Ð´',0),(220545,6127,'vi','In láº¡i chuyáº¿n hÃ ng',0),(220546,6127,'af','Herdruk Versending',0),(220547,6127,'ro','NavÄƒ de retipÄƒrire',0),(220548,6127,'et','KordustrÃ¼kk laeva',0),(220549,6127,'si','Ponatis ladje',0),(220550,6127,'ba','Mencetak ulang kapal',0),(220551,6127,'nl','Herdruk schip',0),(220552,6127,'fi','Uusintapainos aluksen',0),(220553,6127,'no','Opptrykk skipet',0),(220554,6127,'da','Genoptryk skib',0),(220555,6127,'ko','ë¬´ë‹¨ ì „ìž¬ í•¨',0),(220556,6127,'he','×œ×”×“×¤×™×¡ ×ž×—×“×© ××ª ×”×¡×¤×™× ×”',0),(220557,6127,'el','Î‘Î½Î¬Ï„Ï…Ï€Î¿ Ï€Î»Î¿Î¯Î¿',0),(220558,6127,'zh','é‡å°è£…è¿\r\n',0),(220559,6127,'sv','Nytryck fartyg',0),(220560,6127,'it','Ristampa nave',0),(220561,6127,'tl','',0),(220562,6127,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(220563,6127,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤œà¤¹à¤¾à¤œ',0),(220564,6127,'ms','Pencetakan semula kapal',0),(220565,6127,'ar','Ø·Ø¨Ø¹ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(220566,6127,'fr','Navire de rÃ©impression',0),(220567,6127,'jp','Reprint Ship',0),(220568,6127,'pt','Navio de reimpressÃ£o',0),(220569,6127,'ru','ÐŸÐµÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚ÐºÐ° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(220570,6127,'es','Reimprimir Enviar',0),(220571,6127,'de','Reprint-Schiff',0),(220572,6127,'en','Reprint Ship',0),(220573,6128,'is','',0),(220574,6128,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø§Ø³Ù†Ø§Ø¯ Ø­Ù…Ù„ ',0),(220575,6128,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø§Ø³Ù†Ø§Ø¯ Ø­Ù…Ù„ ',0),(220576,6128,'tr','Belgeleri aktarma yeniden yazdÄ±rÄ±n.',0),(220577,6128,'pl','Przedruk wysyÅ‚ka dokumentÃ³w',0),(220578,6128,'bg','ÐŸÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ¿Ð¾Ñ€Ñ‚Ð½Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(220579,6128,'ur','Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ Ú©ÛŒ Ø´Ù¾Ù†Ú¯ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(220580,6128,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ‚Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ðµ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(220581,6128,'vi','In tÃ i liá»‡u váº­n chuyá»ƒn',0),(220582,6128,'af','Herdruk Versendingsdokumente',0),(220583,6128,'ro','RetipÄƒrire documentele de transport maritim',0),(220584,6128,'et','Veodokumentidega kordustrÃ¼kk',0),(220585,6128,'si','Ponatis, dostava dokumentov',0),(220586,6128,'ba','Mencetak ulang dokumen pengiriman',0),(220587,6128,'nl','Herdruk verzending van documenten',0),(220588,6128,'fi','Tulosta lÃ¤hetysasiakirjat',0),(220589,6128,'no','Opptrykk forsendelsesdokumenter',0),(220590,6128,'da','Genoptryk forsendelsesdokumenter',0),(220591,6128,'ko','ë¬´ë‹¨ ì „ìž¬ ë¬¸ì„œ ë°œì†¡',0),(220592,6128,'he','×œ×”×“×¤×™×¡ ×ž×—×“×© ×‘×›×™×¡×•×™',0),(220593,6128,'el','Î‘Î½Î¬Ï„Ï…Ï€Î¿ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ ÎµÎ³Î³ÏÎ¬Ï†Ï‰Î½',0),(220594,6128,'zh','é‡å°è£…è¿æ–‡ä»¶\r\n',0),(220595,6128,'sv','Nytryck leveransdokument',0),(220596,6128,'it','Ristampa documenti di spedizione',0),(220597,6128,'tl','',0),(220598,6128,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(220599,6128,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼à¥‹à¤‚ à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(220600,6128,'ms','Pencetakan semula penghantaran dokumen',0),(220601,6128,'ar','Ø·Ø¨Ø¹ ÙˆØ«Ø§Ø¦Ù‚ Ø§Ù„Ø´Ø­Ù†',0),(220602,6128,'fr','RÃ©impression de Documents d\'expÃ©dition',0),(220603,6128,'jp','ç™ºé€?æ–‡æ›¸ã?®å†?å?°åˆ·',0),(220604,6128,'pt','ReimpressÃ£o de documentos de transporte',0),(220605,6128,'ru','ÐŸÐµÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚ÐºÐ° Ð¾Ñ‚Ð³Ñ€ÑƒÐ·Ð¾Ñ‡Ð½Ñ‹Ñ… Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(220606,6128,'es','Reimprimir Documentos de EnvÃ­o',0),(220607,6128,'de','Nachdruck Versanddokumente',0),(220608,6128,'en','Reprint Shipping Documents',0),(220609,6129,'is','',0),(220610,6129,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ù‚Ø§Ø¨Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ø±Ø§ÙŠ ØµÙØ­Ø§Øª Ø¨Ø¹Ø¯ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(220611,6129,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ù‚Ø§Ø¨Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ø±Ø§ÙŠ ØµÙØ­Ø§Øª Ø¨Ø¹Ø¯ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(220612,6129,'tr','SeÃ§ilebilir notlar sayfalarÄ± aÅŸaÄŸÄ±daki fatura iÃ§in',0),(220613,6129,'pl','Wyboru notatki na stronach nastÄ™pujÄ…ce faktury',0),(220614,6129,'bg','Ð˜Ð·Ð±Ð¸Ñ€Ð°ÐµÐ¼Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(220615,6129,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ù†ÙˆÙ¹ ØµÙØ­Ø§Øª Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’',0),(220616,6129,'sr','ÐœÐ¾Ð¶Ðµ ÑÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ñ‚Ð¸ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð·Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ ÑÐ»ÐµÐ´ÐµÑ›Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(220617,6129,'vi','Nhá»¯ng ghi chÃº Ä‘Ã£ chá»n cho trang sau HÃ³a Ä‘Æ¡n',0),(220618,6129,'af','Selekteerbare Notas vir blaaie wat volg op Faktuur',0),(220619,6129,'ro','Note selectabile pentru pagini urmÄƒtoarea facturÄƒ',0),(220620,6129,'et','Valitav mÃ¤rkmed pages jÃ¤rgmise arve',0),(220621,6129,'si','Izbira opombe za strani naslednje raÄuna',0),(220622,6129,'ba','Catatan dipilih untuk Halaman berikut faktur',0),(220623,6129,'nl','Selecteerbare notities voor pagina\'s volgende factuur',0),(220624,6129,'fi','Valittavissa toteaa sivuille seuraavan laskun',0),(220625,6129,'no','Valgbar notater for sider fÃ¸lgende faktura',0),(220626,6129,'da','Valgbar noter for sider fÃ¸lgende faktura',0),(220627,6129,'ko','ì„ íƒ ê°€ëŠ¥í•œ ë…¸íŠ¸ íŽ˜ì´ì§€ ë‹¤ìŒ ì†¡ìž¥ì— ëŒ€ í•œ',0),(220628,6129,'he','×”×¢×¨×•×ª × ×™×ª×Ÿ ×œ×‘×—×™×¨×” ×¢×‘×•×¨ ×”×“×¤×™× ×”×‘××™× ×—×©×‘×•× ×™×ª',0),(220629,6129,'el','Î•Ï€Î¹Î»Î­Î¾Î¹Î¼Î¿ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± ÏƒÎµÎ»Î¯Î´ÎµÏ‚ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(220630,6129,'zh','å‘ç¥¨åŽçš„é¡µé¢å¯é€‰æ³¨é‡Š\r\n',0),(220631,6129,'sv','Valbara anteckningar fÃ¶r sidorna fÃ¶ljande faktura',0),(220632,6129,'it','Note selezionabile per le pagine seguenti fattura',0),(220633,6129,'tl','',0),(220634,6129,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3604;&#3657;&#3586;&#3629;&#3591;&#3627;&#3609;&#3657;&#3634;&#3605;&#3634;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3',0),(220635,6129,'hi','à¤šà¤¯à¤¨ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤¨à¤¿à¤®à¥à¤¨ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤',0),(220636,6129,'ms','Nota-nota yang boleh dipilih untuk laman invois berikut',0),(220637,6129,'ar','ØªÙ„Ø§Ø­Ø¸ Ø§Ø®ØªÙŠØ§Ø±Ù‡Ø§ Ù„Ù„ØµÙØ­Ø§Øª \"Ø§Ù„ØªØ§Ù„ÙŠØ© Ù…Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø©\"',0),(220638,6129,'fr','Notes sÃ©lectionnables pour les pages suivantes de facture',0),(220639,6129,'jp','è«‹æ±‚æ›¸ã?«ç¶šã??ãƒšãƒ¼ã‚¸ã?«é?¸æŠžå?¯èƒ½ã?ªãƒ¡ãƒ¢',0),(220640,6129,'pt','Notas selecionÃ¡veis para pÃ¡ginas seguintes factura',0),(220641,6129,'ru','Ð’Ñ‹Ð±Ð¸Ñ€Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ Ð´Ð»Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ† ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(220642,6129,'es','Notas Seleccionadas para pÃ¡ginas Siguiendo la Factura',0),(220643,6129,'de','WÃ¤hlbare Hinweisezur Seiten folgende Rechnung',0),(220644,6129,'en','Selectable Notes for pages Following Invoice',0),(220645,6130,'is','',0),(220646,6130,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(220647,6130,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(220648,6130,'tr','Not Ana sayfa',0),(220649,6130,'pl','Uwaga Strona gÅ‚Ã³wna',0),(220650,6130,'bg','Ð“Ð»Ð°Ð²Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(220651,6130,'ur','Ø³Ø¨ Ø³Û’ Ø§ÛÙ… Ù†ÙˆÙ¹ ØµÙØ­Û',0),(220652,6130,'sr','Ð“Ð»Ð°Ð²Ð½Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(220653,6130,'vi','Ghi chÃº trang chÃ­nh',0),(220654,6130,'af','Hoofblad Nota',0),(220655,6130,'ro','Pagina principala NotÄƒ',0),(220656,6130,'et','Peamine lehekÃ¼lg mÃ¤rkme',0),(220657,6130,'si','Glavna stran Opomba',0),(220658,6130,'ba','Utama halaman catatan',0),(220659,6130,'nl','Main pagina Opmerking',0),(220660,6130,'fi','Etusivu Huomautus',0),(220661,6130,'no','Hovedsiden Merk',0),(220662,6130,'da','Main side Note',0),(220663,6130,'ko','ë©”ì¸ íŽ˜ì´ì§€ ì°¸ê³ ',0),(220664,6130,'he','×“×£ ×”×¢×¨×”',0),(220665,6130,'el','ÎšÏÏÎ¹Î± Î£ÎµÎ»Î¯Î´Î± Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(220666,6130,'zh','ä¸»é¡µæ³¨\r\n',0),(220667,6130,'sv','Huvudsidan Obs',0),(220668,6130,'it','Principale pagina nota',0),(220669,6130,'tl','',0),(220670,6130,'th','&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3649;&#3607;&#3657;&#3592;&#3619;&#3636;&#3591;',0),(220671,6130,'hi','à¤®à¥à¤–à¥à¤¯ à¤ªà¥ƒà¤·à¥à¤  à¤¨à¥‹à¤Ÿ',0),(220672,6130,'ms','Nota Laman Utama',0),(220673,6130,'ar','Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ù…Ù„Ø§Ø­Ø¸Ø©',0),(220674,6130,'fr','Page principale-Note',0),(220675,6130,'jp','ãƒ¡ã‚¤ãƒ³ãƒšãƒ¼ã‚¸ãƒ¡ãƒ¢',0),(220676,6130,'pt','Nota de pÃ¡gina principal',0),(220677,6130,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(220678,6130,'es','Nota de la PÃ¡gina Principal',0),(220679,6130,'de','Startseite-Hinweis',0),(220680,6130,'en','Main Page Note',0),(220681,6131,'is','',0),(220682,6131,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(220683,6131,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(220684,6131,'tr','SeÃ§me BorÃ§lar fatura dosya',0),(220685,6131,'pl','Plik faktury wybierz zobowiÄ…zania',0),(220686,6131,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ„Ð°Ð¹Ð»',0),(220687,6131,'ur','Ù…Ù†ØªØ®Ø¨ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ø³Ù„',0),(220688,6131,'sr','Ð˜Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(220689,6131,'vi','Lá»±a chá»n há»“ sÆ¡ hÃ³a Ä‘Æ¡n pháº£i tráº£',0),(220690,6131,'af','Selekteer Uitgawes (RB) FaktuurlÃªer',0),(220691,6131,'ro','FiÅŸier de facturÄƒ ÅŸi selectaÅ£i datorii',0),(220692,6131,'et','Valige vÃµlad arve fail',0),(220693,6131,'si','Izberite obveznosti raÄunu datoteke',0),(220694,6131,'ba','Pilih hutang faktur File',0),(220695,6131,'nl','Selecteer schulden factuur bestand',0),(220696,6131,'fi','Valitse ostojen lasku tiedosto',0),(220697,6131,'no','Velg leverandÃ¸rgjeld fakturaen filen',0),(220698,6131,'da','VÃ¦lg kreditorstyring faktura fil',0),(220699,6131,'ko','ì„ íƒ ë¯¸ì§€ê¸‰ê¸ˆ ì†¡ìž¥ íŒŒì¼',0),(220700,6131,'he','×–×›××™× ×œ×‘×—×•×¨ ×§×•×‘×¥ ×—×©×‘×•× ×™×ª',0),(220701,6131,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(220702,6131,'zh','é€‰æ‹©åº”ä»˜æ¬¾å‘ç¥¨æ–‡ä»¶\r\n',0),(220703,6131,'sv','VÃ¤lj LeverantÃ¶rsskulder Invoice File',0),(220704,6131,'it','File della fattura Selezionare debiti',0),(220705,6131,'tl','',0),(220706,6131,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3649;&#3615;&#3657;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(220707,6131,'hi','à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ Payables à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤²',0),(220708,6131,'ms','Pilih pembayaran invois fail',0),(220709,6131,'ar','Ø§Ù„Ù…Ù„Ù Ø§Ù„ÙØ§ØªÙˆØ±Ø© ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(220710,6131,'fr','SÃ©lection des comptes fournisseurs facture fichier',0),(220711,6131,'jp','æ”¯æ‰•è«‹æ±‚æ›¸ãƒ•ã‚¡ã‚¤ãƒ«ã?®é?¸æŠž',0),(220712,6131,'pt','Selecione contas a pagar fatura arquivo',0),(220713,6131,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ ÑÑ‡ÐµÑ‚Ð° Ñ„Ð°Ð¹Ð»',0),(220714,6131,'es','Seleccionar File de Facturas de Proveedores',0),(220715,6131,'de','WÃ¤hlen Sie Verbindlichkeiten Rechnungsdatei',0),(220716,6131,'en','Select Payables Invoice File',0),(220717,6132,'is','',0),(220718,6132,'dr','Ø«Ø¨Øª Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(220719,6132,'pr','Ø«Ø¨Øª Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(220720,6132,'tr','Ek saatler bu Ã§alÄ±ÅŸan iÃ§in giriÅŸ',0),(220721,6132,'pl','Dodatkowe godziny wejÅ›cia dla tego pracownika',0),(220722,6132,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ‡Ð°ÑÐ¾Ð²Ðµ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(220723,6132,'ur','Ø§Ø¶Ø§ÙÛŒ Ú¯Ú¾Ù†Ù¹Û’ Ø§Ø³ Ù…Ù„Ø§Ø²Ù… Ú©Û’ Ù„ÛŒÛ’ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(220724,6132,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸Ñ… ÑÐ°Ñ‚Ð¸ ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ð²Ð¾Ð³ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(220725,6132,'vi','Entry Giá» LÃ m Viá»‡c ThÃªm Cá»§a NhÃ¢n ViÃªn NÃ y',0),(220726,6132,'af','Addisionele Ure ingevoer vir hierdie Werknemer',0),(220727,6132,'ro','Adauga ore suplimentare pentru acest angajat',0),(220728,6132,'et','Ãœletunde kanne selle tÃ¶Ã¶taja',0),(220729,6132,'si','Dodatne ure vstop za delavÄevo',0),(220730,6132,'ba','Penambahan Lembur',0),(220731,6132,'nl','Extra uren vermelding voor deze werknemer',0),(220732,6132,'fi','LisÃ¤tunnit merkintÃ¤ tyÃ¶ntekijÃ¤lle',0),(220733,6132,'no','Ekstra timer oppfÃ¸ringen for denne medarbeideren',0),(220734,6132,'da','Ekstra timer post for denne medarbejder',0),(220735,6132,'ko','ì¶”ê°€ ì‹œê°„ì´ì´ ì§ì›ì— ëŒ€ í•œ í•­ëª©',0),(220736,6132,'he','×©×¢×•×ª × ×•×¡×¤×•×ª ×¢×¨×š ×¢×‘×•×¨ ×”×¢×•×‘×“ ×”×–×”',0),(220737,6132,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ ÏŽÏÎµÏ‚ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(220738,6132,'zh','æ­¤å“¡å·¥çš„åŠ ç­è²»\r\n',0),(220739,6132,'sv','Extra timmar fÃ¶r medarbetaren',0),(220740,6132,'it','Campo ore addizionali per questo dipendente',0),(220741,6132,'tl','',0),(220742,6132,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3648;&#3586;&#3657;&#3634;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(220743,6132,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤˜à¤‚à¤Ÿà¥‡ à¤‡à¤¸ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(220744,6132,'ms','Jam tambahan kemasukan pekerja ini',0),(220745,6132,'ar','Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ© Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„ Ù„Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ¸Ù',0),(220746,6132,'fr','Heures additionnelles d\'entrÃ©e pour cet employÃ©',0),(220747,6132,'jp','ã?“ã?®å¾“æ¥­å“¡ã?¸ã?®è¿½åŠ æ™‚é–“å…¥åŠ›',0),(220748,6132,'pt','Horas adicionais entrada para este empregado',0),(220749,6132,'ru','Ð’Ð²Ð¾Ð´ Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ð§Ð°ÑÐ¾Ð² Ð”Ð»Ñ Ð”Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(220750,6132,'es','Horas Adicionales para Este Empleado',0),(220751,6132,'de','ZusÃ¤tzliche Stunden Eintrag fÃ¼r diesen Mitarbeiter',0),(220752,6132,'en','Additional Hours Entry for This Employee',0),(220753,6133,'is','',0),(220754,6133,'dr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ ÙƒÙ…ØªØ± Ø§Ø² Ø¢Ø®Ø±ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(220755,6133,'pr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ ÙƒÙ…ØªØ± Ø§Ø² Ø¢Ø®Ø±ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(220756,6133,'tr','Onay numarasÄ± kullanÄ±lan son sayÄ±sÄ±ndan daha dÃ¼ÅŸÃ¼k',0),(220757,6133,'pl','SprawdÅº numer niÅ¼szy niÅ¼ numer ostatniej',0),(220758,6133,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ð¾-Ð¼Ð°Ð»ÑŠÐº Ð¾Ñ‚ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ Ð½Ð¾Ð¼ÐµÑ€',0),(220759,6133,'ur','Ù¾Ú‘ØªØ§Ù„ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø¢Ø®Ø±ÛŒ Ù†Ù…Ø¨Ø± Ú©Û’ Ù…Ù‚Ø§Ø¨Ù„Û’ Ú©Ù… ØªØ¹Ø¯Ø§Ø¯',0),(220760,6133,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð±Ñ€Ð¾Ñ˜ Ð¼Ð°ÑšÐ¸ Ð¾Ð´ Ð·Ð°Ð´ÑšÐ¸ Ð±Ñ€Ð¾Ñ˜ ÐºÐ¾Ñ˜Ð¸ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(220761,6133,'vi','Sá»‘ SÃ©c tháº¥p hÆ¡n sá»‘ SÃ©c cuá»‘i Ä‘Ã£ sá»­ dá»¥ng',0),(220762,6133,'af','Tjeknommer Laer as Laaste Nommer Gebruik',0),(220763,6133,'ro','Selectare numÄƒr mai mic decÃ¢t numÄƒrul ultima utilizate',0),(220764,6133,'et','VÃ¤ljaregistreerimine Number vÃ¤iksem viimasena kasutatud numbri',0),(220765,6133,'si','Potrditveno Å¡tevilko niÅ¾ji od zadnje Å¡tevnik uporablja',0),(220766,6133,'ba','Check nomor lebih rendah dari angka terakhir digunakan',0),(220767,6133,'nl','Selectievakje nummer lager is dan het laatste nummer dat wordt gebruikt',0),(220768,6133,'fi','LAN mÃ¤Ã¤rÃ¤ pienempi kuin viimeinen kÃ¤ytetty numero',0),(220769,6133,'no','Kontroller antallet lavere enn siste brukte nummer',0),(220770,6133,'da','Check nummer lavere end sidste nummer, der bruges',0),(220771,6133,'ko','í™•ì¸ ë²ˆí˜¸ë¥¼ ì‚¬ìš© í•˜ëŠ” ë§ˆì§€ë§‰ ë²ˆí˜¸ ë³´ë‹¤ ë‚®ì€',0),(220772,6133,'he','×¡×™×ž×•×Ÿ ×ž×¡×¤×¨ × ×ž×•×š ×™×•×ª×¨ ×ž××©×¨ ×ž×¡×¤×¨ ××—×¨×•×Ÿ ×‘×©×™×ž×•×©',0),(220773,6133,'el','Î•Î»Î­Î³Ï‡Î¿Ï… Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¬Ï„Ï‰ Î±Ï€ÏŒ Ï„Î¿Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹',0),(220774,6133,'zh','æ£€æŸ¥æ•°é‡åœ¨å‡å°‘ä½¿ç”¨çš„æ•°é‡æ¯”åŽ»å¹´\r\n',0),(220775,6133,'sv','Check nummer lÃ¤gre Ã¤n fÃ¶rra numret anvÃ¤nds',0),(220776,6133,'it','Controllare il numero piÃ¹ basso di ultimo numero utilizzato',0),(220777,6133,'tl','',0),(220778,6133,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&#3588;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;&#3607;&#3637;&#3656;&#3651;&#3',0),(220779,6133,'hi','à¤šà¥‡à¤• à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤¿à¤›à¤²à¥‡ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤•à¤®',0),(220780,6133,'ms','Semak nombor lebih rendah daripada nombor terakhir yang digunakan',0),(220781,6133,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø±Ù‚Ù… Ø£Ù‚Ù„ Ù…Ù† Ø±Ù‚Ù… Ø¢Ø®Ø± ÙŠØ³ØªØ®Ø¯Ù…',0),(220782,6133,'fr','VÃ©rification de numÃ©ro infÃ©rieur Ã  dernier numÃ©ro utilisÃ©',0),(220783,6133,'jp','æœ€å¾Œã?«ä½¿ç”¨ã?•ã‚Œã?Ÿæ•°å­—ã‚ˆã‚Šä½Žã?„æ•°å­—ã‚’ãƒ?ã‚§ãƒƒã‚¯ã?—ã?¦ã??ã? ã?•ã?„',0),(220784,6133,'pt','Cheque o nÃºmero mais baixo do que o Ãºltimo nÃºmero utilizado',0),(220785,6133,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð¸Ð¶Ðµ, Ñ‡ÐµÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð½Ð¾Ð¼ÐµÑ€, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ð¹',0),(220786,6133,'es','NÃºmero de Cheque MÃ¡s Bajo que el Ãšltimo que Usaba',0),(220787,6133,'de','KontrollkÃ¤stchen Nummer niedriger als letzte Zahl verwendet',0),(220788,6133,'en','Check Number Lower than Last Number Used',0),(220789,6134,'is','',0),(220790,6134,'dr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ÙƒÙ…ØªØ± Ø§Ø² Ø¢Ø®Ø±ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(220791,6134,'pr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ÙƒÙ…ØªØ± Ø§Ø² Ø¢Ø®Ø±ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(220792,6134,'tr','Kontrol numarasÄ± seÃ§ili olan alt kullanÄ±lan son No daha',0),(220793,6134,'pl','SprawdÅº wybrany numer jest niÅ¼sza niÅ¼ ostatni numer uÅ¼ywany',0),(220794,6134,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½ Ð½Ð¾Ð¼ÐµÑ€ Ðµ Ð¿Ð¾-Ð½Ð¸ÑÐºÐ° Ð¾Ñ‚ Ð¿Ð¾ÑÐ»ÐµÐ´ÐµÐ½ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ Ð½Ð¾Ð¼ÐµÑ€',0),(220795,6134,'ur','Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº Ù†Ù…Ø¨Ø± Ù…Ù†ØªØ®Ø¨ Ù„ÙˆØ¦Ø± ÛÛ’ Û” Ø¢Ø®Ø±ÛŒ Ù†Ù…Ø¨Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Ø§Ø³ Ø³Û’',0),(220796,6134,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½ Ð±Ñ€Ð¾Ñ˜ Ñ˜Ðµ Ð½Ð¸Ð¶Ðµ Ð½ÐµÐ³Ð¾ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐ¸ ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÐ½Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(220797,6134,'vi','Sá»‘ SÃ©c tháº¥p hÆ¡n sá»‘ SÃ©c cuá»‘i Ä‘Ã£ sá»­ dá»¥ng',0),(220798,6134,'af','Tjeknommer Geselekteer is Laer as Laaste Nommer Gebruik',0),(220799,6134,'ro','VerificaÅ£i numÄƒrul selectat este mai micÄƒ decÃ¢t ultimul numÄƒr utilizate',0),(220800,6134,'et','Kontrollige valitud Number on vÃ¤iksem kui viimasena kasutatud Number',0),(220801,6134,'si','Preverite Å¡tevilko izbrane niÅ¾je kot zadnja uporabljena Å¡tevilka',0),(220802,6134,'ba','Memeriksa nomor dipilih adalah lebih rendah daripada nomor terakhir digunakan',0),(220803,6134,'nl','Controleer nummer geselecteerd is lager dan het laatst gebruikt',0),(220804,6134,'fi','Tarkista numero valittu on alempi kuin viimeinen kÃ¤ytetty nro',0),(220805,6134,'no','Kontroller nummeret valgt er lavere enn siste tall brukt',0),(220806,6134,'da','Kontroller antallet valgt er lavere end sidste nummer bruges',0),(220807,6134,'ko','ì•„ëž˜ëŠ” ìˆ«ìž ì„ íƒ ë§ˆì§€ë§‰ ë²ˆí˜¸ ì‚¬ìš© ë³´ë‹¤',0),(220808,6134,'he','×œ×‘×“×•×§ ×ž×¡×¤×¨ ×©× ×‘×—×¨ ×”×•× × ×ž×•×š ×™×•×ª×¨ ×ž××©×¨ ×©×™×ž×•×© ×”×ž×¡×¤×¨ ×”××—×¨×•×Ÿ',0),(220809,6134,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î¿ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ ÎµÎ¯Î½Î±Î¹ ÎºÎ¬Ï„Ï‰ Î±Ï€ÏŒ Ï„Î·Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÏƒÎµÎ¹ÏÎ¬ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®Î¸Î·ÎºÎµ',0),(220810,6134,'zh','æ£€æŸ¥æ‰€é€‰å·ç ä½ŽäºŽæœ€åŽä½¿ç”¨çš„å·ç ',0),(220811,6134,'sv','Kontrollera antalet utvalda Ã¤r lÃ¤gre Ã¤n fÃ¶rra numret anvÃ¤nds',0),(220812,6134,'it','Controllare il numero selezionato Ã¨ inferiore rispetto l\'ultimo numero utilizzato',0),(220813,6134,'tl','',0),(220814,6134,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&#3588;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3621;&#3656;&#3',0),(220815,6134,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ à¤•à¤® à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ à¤…à¤§à¤¿à¤• à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤¿à¤›à¤²à¥‡ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(220816,6134,'ms','Semak nombor dipilih adalah lebih rendah daripada nombor terakhir digunakan',0),(220817,6134,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† \"Ø§Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ù…Ø­Ø¯Ø¯\" Ù‡Ùˆ Ø£Ù‚Ù„ Ù…Ù† \"Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø±Ù‚Ù… Ø¢Ø®Ø±\"',0),(220818,6134,'fr','VÃ©rifiez le numÃ©ro sÃ©lectionnÃ© est moins Ã©levÃ© que le dernier numÃ©ro utilisÃ©',0),(220819,6134,'jp','å°?åˆ‡æ‰‹ç•ªå?·ã?Œå‰?å›žä½¿ç”¨ã?—ã?Ÿç•ªå?·ã‚ˆã‚Šä½Žã?„ã?§ã?™',0),(220820,6134,'pt','Verifique o nÃºmero selecionado Ã© menor do que o Ãºltimo nÃºmero utilizado',0),(220821,6134,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð½Ð¸Ð¶Ðµ Ñ‡ÐµÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(220822,6134,'es','NÃºmero de Cheque Seleccionado es MÃ¡s Bajo que el Ãšltimo que Usaba',0),(220823,6134,'de','PrÃ¼fen, Anzahl selektierter niedriger ist als die letzte Zahl verwendet',0),(220824,6134,'en','Check Number Selected is Lower than Last Number Used',0),(220825,6135,'is','',0),(220826,6135,'dr','Ú†Ø´Ù… Ù¾ÙˆØ´ÙŠ Ø¯Ø± Ú†Ùƒ ÙƒØ±Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ú¯Ø°Ø§Ø±ÙŠ ',0),(220827,6135,'pr','Ú†Ø´Ù… Ù¾ÙˆØ´ÙŠ Ø¯Ø± Ú†Ùƒ ÙƒØ±Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ú¯Ø°Ø§Ø±ÙŠ ',0),(220828,6135,'tr','Onay numaralandÄ±rmayÄ± atlar',0),(220829,6135,'pl','Przeskakuje w numerowaniem',0),(220830,6135,'bg','ÐŸÑ€ÐµÑÐºÐ°Ñ‡Ð° Ð² ÑˆÐ°Ñ… Ð½Ð¾Ð¼ÐµÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(220831,6135,'ur','Ù…ÛŒÚº Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Ù†Ù…Ø¨Ø± Ú©Ø§Ø±ÛŒ Ø§Ú†Ú¾Ù„',0),(220832,6135,'sr','ÐŸÑ€ÐµÑÐºÐ°Ñ‡Ðµ Ñƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð½ÑƒÐ¼ÐµÑ€Ð¸ÑÐ°ÑšÐµ',0),(220833,6135,'vi','Bá» qua kiá»ƒm tra sá»‘',0),(220834,6135,'af','Slaan in toom nommering',0),(220835,6135,'ro','Skips Check numerotarea',0),(220836,6135,'et','Vagonetid ja tÅ¡ekkide nummerdamist',0),(220837,6135,'si','PreskoÄi v Äek Å¡tevilÄenje',0),(220838,6135,'ba','Melompat di Check penomoran',0),(220839,6135,'nl','Hiermee gaat u in het selectievakje nummering',0),(220840,6135,'fi','HyppÃ¤Ã¤ sisÃ¤Ã¤n numeroinnissa',0),(220841,6135,'no','Hopper i sjekknummerering',0),(220842,6135,'da','Springer i checknummerering',0),(220843,6135,'ko','í™•ì¸ ë²ˆí˜¸ì— ê±´ë„ˆëœë‹ˆë‹¤',0),(220844,6135,'he','×•×¦×¤×•× ×•×ª×™×” ×”×¡×™×ž×•×Ÿ ×ž×¡×¤×•×¨',0),(220845,6135,'el','ÎœÎµÏ„Î±Î²Î±Î¯Î½ÎµÎ¹ ÏƒÏ„Î·Î½ Î±ÏÎ¯Î¸Î¼Î·ÏƒÎ· ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(220846,6135,'zh','æ£€æŸ¥ç¼–å·è·³è¿‡\r\n',0),(220847,6135,'sv','Hoppar i checknumrering',0),(220848,6135,'it','Salti nella numerazione di controllo',0),(220849,6135,'tl','',0),(220850,6135,'th','&#3586;&#3657;&#3634;&#3617;&#3652;&#3611;&#3651;&#3609;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;',0),(220851,6135,'hi','à¤šà¥‡à¤• à¤•à¥à¤°à¤®à¤¾à¤‚à¤•à¤¨ à¤®à¥‡à¤‚ à¤°à¥à¤• à¤œà¤¾à¤¤à¥€',0),(220852,6135,'ms','Langkau dalam semak nombor',0),(220853,6135,'ar','ÙŠØªØ®Ø·Ù‰ ÙÙŠ ØªØ±Ù‚ÙŠÙ… Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(220854,6135,'fr','Bennes Ã  cocher numÃ©rotation',0),(220855,6135,'jp','ãƒ?ã‚§ãƒƒã‚¯ç•ªå?·ä»˜ã?‘ã?®é£›ã?°ã?—',0),(220856,6135,'pt','Ignora a verificaÃ§Ã£o de numeraÃ§Ã£o de',0),(220857,6135,'ru','Ð¡ÐºÐ¸Ð¿Ñ‹ Ð² ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½ÑƒÐ¼ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(220858,6135,'es','Saltos en NumeraciÃ³n de Cheques',0),(220859,6135,'de','Springt in Check Nummerierung',0),(220860,6135,'en','Skips in Check Numbering',0),(220861,6136,'is','',0),(220862,6136,'dr','Ù‚ÙŠÙ…Øª Ø¯Ø§Ø¯Ù† Ø¨Ù‡ ',0),(220863,6136,'pr','Ù‚ÙŠÙ…Øª Ø¯Ø§Ø¯Ù† Ø¨Ù‡ ',0),(220864,6136,'tr','Ä°Ã§in teklif',0),(220865,6136,'pl','Cytat do',0),(220866,6136,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð°',0),(220867,6136,'ur','Û²Ø±Ø³ÛŒØ¯ÛŒÚº Ø§ÙˆØ± Ø¯ÙˆØ³Ø±Û’ Ú©Ùˆ',0),(220868,6136,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð´Ð°',0),(220869,6136,'vi','BÃ¡o giÃ¡ tá»›i',0),(220870,6136,'af','Kwotasie Aan',0),(220871,6136,'ro','Citat la',0),(220872,6136,'et','Quote',0),(220873,6136,'si','Ponudba za',0),(220874,6136,'ba','Penawaran',0),(220875,6136,'nl','Quote',0),(220876,6136,'fi','Lainaan',0),(220877,6136,'no','Tilbud til',0),(220878,6136,'da','Citat til',0),(220879,6136,'ko','ì¸ìš©',0),(220880,6136,'he','×ª×¦×˜×˜',0),(220881,6136,'el','Î‘Î½Î±Ï†Î­ÏÏ‰',0),(220882,6136,'zh','å¼•è¿°åˆ°\r\n',0),(220883,6136,'sv','Citat till',0),(220884,6136,'it','Cito a',0),(220885,6136,'tl','',0),(220886,6136,'th','&#3649;&#3592;&#3657;&#3591;&#3606;&#3638;&#3591;',0),(220887,6136,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥‹à¤²à¥€',0),(220888,6136,'ms','Sebut harga untuk',0),(220889,6136,'ar','Ø§Ù‚ØªØ¨Ø³',0),(220890,6136,'fr','Cite Ã ',0),(220891,6136,'jp','ï½žã?¸ã?®è¦‹ç©?ã‚Š',0),(220892,6136,'pt','Passo a citar a',0),(220893,6136,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð°',0),(220894,6136,'es','CotizaciÃ³n A',0),(220895,6136,'de','Zu zitieren',0),(220896,6136,'en','Quote To',0),(220897,6137,'is','',0),(220898,6137,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ú†Ùƒ Ø¯Ø± Ø·ÙŠ Ø§Ø¬Ø±Ø§ Ø§Ø² Ù‚Ù„Ù… Ø§ÙØªØ§Ø¯Ù‡ Ø§Ø³Øª',0),(220899,6137,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ú†Ùƒ Ø¯Ø± Ø·ÙŠ Ø§Ø¬Ø±Ø§ Ø§Ø² Ù‚Ù„Ù… Ø§ÙØªØ§Ø¯Ù‡ Ø§Ø³Øª',0),(220900,6137,'tr','Ã‡ek numaralarÄ±nÄ± Ã§alÄ±ÅŸmasÄ± sÄ±rasÄ±nda atlandÄ±',0),(220901,6137,'pl','SprawdziÄ‡ numery pominiÄ™te podczas uruchomienia',0),(220902,6137,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð°, Ð¿Ñ€Ð¾Ð¿ÑƒÑÐ½Ð°Ñ‚Ð¸ Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(220903,6137,'ur','Ø¯ÙˆÚ‘ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ø§Ú†Ù¹ÛŒ Ú†ÛŒÚ© Ù†Ù…Ø¨Ø±Ø²',0),(220904,6137,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ðµ Ð¿Ñ€ÐµÑÐºÐ¾Ñ‡ÐµÐ½Ð° Ñ‚Ð¾ÐºÐ¾Ð¼ Ñ€Ð°Ð½',0),(220905,6137,'vi','Bá» qua sá»‘ SÃ©c khi cháº¡y',0),(220906,6137,'af','Kontroleer nommers oorgeslaan gedurende die loop',0),(220907,6137,'ro','Verifica numerele sÄƒrite Ã®n timpul executÄƒrii',0),(220908,6137,'et','TÅ¡eki numbrite vahele kÃ¤itamisel',0),(220909,6137,'si','Preverite Å¡tevilke preskoÄila med voÅ¾njo',0),(220910,6137,'ba','Nomor Check melewatkan selama menjalankan',0),(220911,6137,'nl','Selectievakje nummers overgeslagen tijdens de uitvoering',0),(220912,6137,'fi','Sekkien numeroita ohitetaan ajon aikana',0),(220913,6137,'no','Sjekknumre hoppet i lÃ¸pet av lÃ¸pe',0),(220914,6137,'da','Checknumre springes over under kÃ¸rsel',0),(220915,6137,'ko','ì²´í¬ ìˆ«ìžë¥¼ ì‹¤í–‰ í•˜ëŠ” ë™ì•ˆ ìƒëžµ',0),(220916,6137,'he','×ž×¡×¤×¨×™ ×©×™×§×™× ×”×—×¡×™×¨ ×‘×ž×”×œ×š ×”×¨×™×¦×”',0),(220917,6137,'el','Î‘ÏÎ¹Î¸Î¼Î¿ÏÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… ÎºÎ±ÏÎ±Î²Î¿ÎºÏÏÎ·Ï‚ ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î¬ÏÎºÎµÎ¹Î± Ï„Î·Ï‚ ÎµÎºÏ„Î­Î»ÎµÏƒÎ·Ï‚',0),(220918,6137,'zh','æ£€æŸ¥å·ç è¿è¡ŒæœŸé—´è·³è¿‡\r\n',0),(220919,6137,'sv','Checknummer som hoppat under kÃ¶rning',0),(220920,6137,'it','Numeri di controllo ignorati durante l\'esecuzione',0),(220921,6137,'tl','',0),(220922,6137,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&#3588;&#3606;&#3641;&#3585;&#3586;&#3657;&#3634;&#3617;&#3652;&#3611;&#3651;&#3609;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3619;&#3633;&#3609;',0),(220923,6137,'hi','à¤šà¥‡à¤• à¤•à¥à¤°à¤®à¤¾à¤‚à¤• à¤šà¤²à¤¾à¤¨à¥‡ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤›à¥‹à¤¡à¤¼à¥€ à¤—à¤ˆ',0),(220924,6137,'ms','Nombor Daftar yang dilangkau semasa larian',0),(220925,6137,'ar','Ø£Ø±Ù‚Ø§Ù… Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ØªØ®Ø·ÙŠ Ø£Ø«Ù†Ø§Ø¡ Ø§Ù„ØªØ´ØºÙŠÙ„',0),(220926,6137,'fr','NumÃ©ros de chÃ¨que ignorÃ©es pendant l\'exÃ©cution',0),(220927,6137,'jp','å®Ÿæ–½ä¸­ã‚¹ã‚­ãƒƒãƒ—ã?—ã?Ÿæ•°å­—ã‚’ç¢ºèª?',0),(220928,6137,'pt','Verificar os nÃºmeros ignorados durante a execuÃ§Ã£o',0),(220929,6137,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ‡Ð¸ÑÐ»Ð° Ð¿Ñ€Ð¾Ð¿ÑƒÑ‰ÐµÐ½Ñ‹ Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ñ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(220930,6137,'es','Numeros de Cheques Omitidos Durante la Corrida',0),(220931,6137,'de','Schecknummern Ã¼bersprungen wÃ¤hrend der AusfÃ¼hrung',0),(220932,6137,'en','Check Numbers Skipped During Run',0),(220933,6138,'is','',0),(220934,6138,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ ',0),(220935,6138,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ ',0),(220936,6138,'tr','SipariÅŸ tutar',0),(220937,6138,'pl','Kwota zamÃ³wienia',0),(220938,6138,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(220939,6138,'ur','Ø¢Ø±ÚˆØ± Amt.',0),(220940,6138,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(220941,6138,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n hÃ ng',0),(220942,6138,'af','Bestelling Bedrag',0),(220943,6138,'ro','SumÄƒ de ordine',0),(220944,6138,'et','Tellimuse summa',0),(220945,6138,'si','Naloga Amt.',0),(220946,6138,'ba','Urutan Amt.',0),(220947,6138,'nl','Volgorde Amt.',0),(220948,6138,'fi','Tilauksen summa',0),(220949,6138,'no','For belÃ¸p',0),(220950,6138,'da','Bestil ufakt',0),(220951,6138,'ko','ì£¼ë¬¸ ë¦¬ì†ŒìŠ¤',0),(220952,6138,'he','Amt. ×”×¡×“×¨',0),(220953,6138,'el','Î Î¿ÏƒÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(220954,6138,'zh','è®¢å•é‡‘é¢ã€‚\r\n',0),(220955,6138,'sv','Ordning belopp',0),(220956,6138,'it','Ordine AMT.',0),(220957,6138,'tl','',0),(220958,6138,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(220959,6138,'hi','à¤•à¥à¤°à¤® Amt.',0),(220960,6138,'ms','Perintah Amt.',0),(220961,6138,'ar','ØªØ±ØªÙŠØ¨ Amt.',0),(220962,6138,'fr','Ordre IMR.',0),(220963,6138,'jp','æ³¨æ–‡é¡?',0),(220964,6138,'pt','Ordem AMT.',0),(220965,6138,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(220966,6138,'es','Monto de Orden',0),(220967,6138,'de','Bestellung Amt.',0),(220968,6138,'en','Order Amt.',0),(220969,6139,'is','',0),(220970,6139,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ù†Ø´Ø¯Ù‡ ',0),(220971,6139,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ù†Ø´Ø¯Ù‡ ',0),(220972,6139,'tr','Dolgusuz tutar',0),(220973,6139,'pl','NiewypeÅ‚nione kwota',0),(220974,6139,'bg','ÐÐµÐ·Ð°Ð¿ÑŠÐ»Ð½ÐµÐ½Ð° ÑÑƒÐ¼Ð°',0),(220975,6139,'ur','Ú©Û Ø®Ø§Ù„ÛŒ Ù¾Ú‘Û’ Amt.',0),(220976,6139,'sr','ÐÐµÐ¸ÑÐ¿ÑƒÑšÐµÐ½Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(220977,6139,'vi','Sá»‘ tiá»n chÆ°a Ä‘iá»n vÃ o',0),(220978,6139,'af','Unfilled Amt.',0),(220979,6139,'ro','SumÄƒ neumplute',0),(220980,6139,'et','TÃ¤itmata summa',0),(220981,6139,'si','Nezasedenih Amt.',0),(220982,6139,'ba','Amt. terisi',0),(220983,6139,'nl','Ongevuld Amt.',0),(220984,6139,'fi','TÃ¤yttÃ¤mÃ¤ttÃ¤ summa',0),(220985,6139,'no','Ledige belÃ¸p',0),(220986,6139,'da','Ubrugte belÃ¸b',0),(220987,6139,'ko','ì±„ì›Œì§€ì§€ ì•Šì€ ë¦¬ì†ŒìŠ¤',0),(220988,6139,'he','Amt. ×œ×œ× ×ž×™×œ×•×™',0),(220989,6139,'el','ÎšÎµÎ½Î­Ï‚ Ï€Î¿ÏƒÏŒ',0),(220990,6139,'zh','æœªå¡«å……çš„æ•°é‡',0),(220991,6139,'sv','Ofyllda belopp',0),(220992,6139,'it','AMT non riempiti.',0),(220993,6139,'tl','',0),(220994,6139,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3652;&#3617;&#3656;&#3648;&#3605;&#3655;&#3617;',0),(220995,6139,'hi','à¤¬à¤¿à¤¨à¤¾ à¤­à¤°à¥€ à¤¹à¥à¤ˆ Amt.',0),(220996,6139,'ms','Setakat Amt.',0),(220997,6139,'ar','Amt. ØºÙŠØ± Ù…Ø¹Ø¨Ø£',0),(220998,6139,'fr','Vacants IMR.',0),(220999,6139,'jp','æœªè¨˜å…¥é¡?',0),(221000,6139,'pt','AMT nÃ£o preenchidos.',0),(221001,6139,'ru','ÐÐµÐ·Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð½Ñ‹Ðµ Amt.',0),(221002,6139,'es','Cantidad No Cumplido',0),(221003,6139,'de','Amt unbesetzt.',0),(221004,6139,'en','Unfilled Amt.',0),(221005,6140,'is','',0),(221006,6140,'dr','  Ù¾ÙŠØ´ ÙØ±Ø¶ Ø±ÙˆØ´ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ',0),(221007,6140,'pr','  Ù¾ÙŠØ´ ÙØ±Ø¶ Ø±ÙˆØ´ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ',0),(221008,6140,'tr','VarsayÄ±lan sevkiyat yÃ¶ntemi',0),(221009,6140,'pl','DomyÅ›lna metoda wysyÅ‚ki',0),(221010,6140,'bg','ÐœÐµÑ‚Ð¾Ð´ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(221011,6140,'ur','Ø·Û’ Ø´Ø¯Û Ø´Ù¾Ù†Ú¯ Ø·Ø±ÛŒÙ‚Û',0),(221012,6140,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ñ‡Ð¸Ð½ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(221013,6140,'vi','PhÆ°Æ¡ng thá»©c váº­n chuyá»ƒn máº·c Ä‘á»‹nh',0),(221014,6140,'af','Verstekte Versendingsmetode',0),(221015,6140,'ro','MetodÄƒ de expediere prestabilitÄƒ',0),(221016,6140,'et','Vaikimisi tarneviis',0),(221017,6140,'si','Privzeti naÄin poÅ¡iljanja',0),(221018,6140,'ba','Metode pengiriman default',0),(221019,6140,'nl','Standaard Verzendingsmethode',0),(221020,6140,'fi','Oletuksena toimitustapa',0),(221021,6140,'no','Standard forsendelsesmÃ¥te',0),(221022,6140,'da','Standard Shipping metode',0),(221023,6140,'ko','ê¸°ë³¸ ë°°ì†¡ ë°©ë²•',0),(221024,6140,'he','×©×™×˜×ª ×”×ž×©×œ×•×— ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(221025,6140,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¼Î­Î¸Î¿Î´Î¿Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(221026,6140,'zh','é»˜è®¤è¿è¾“æ–¹å¼',0),(221027,6140,'sv','Standard leveranssÃ¤tt',0),(221028,6140,'it','Metodo di spedizione predefinita',0),(221029,6140,'tl','',0),(221030,6140,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;',0),(221031,6140,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¿à¤§à¤¿',0),(221032,6140,'ms','Kaedah penghantaran lalai',0),(221033,6140,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠØ©',0),(221034,6140,'fr','Mode de livraison par dÃ©faut',0),(221035,6140,'jp','æ—¢å®šç™ºé€?æ–¹æ³•',0),(221036,6140,'pt','MÃ©todo de envio padrÃ£o',0),(221037,6140,'ru','Ð¡Ð¿Ð¾ÑÐ¾Ð± Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(221038,6140,'es','MÃ©todo de Transporte por Defecto',0),(221039,6140,'de','Standard-Versandart',0),(221040,6140,'en','Default Shipping Method',0),(221041,6141,'is','',0),(221042,6141,'dr','ÙƒØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(221043,6141,'pr','ÙƒØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(221044,6141,'tr','SatÄ±cÄ± kodu',0),(221045,6141,'pl','Kod dostawcy',0),(221046,6141,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(221047,6141,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÙˆÚˆ',0),(221048,6141,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(221049,6141,'vi','MÃ£ NgÆ°á»i bÃ¡n',0),(221050,6141,'af','Verskaffer Kode',0),(221051,6141,'ro','Cod furnizor',0),(221052,6141,'et','Tarnija kood',0),(221053,6141,'si','Koda prodajalca',0),(221054,6141,'ba','Penjual kode',0),(221055,6141,'nl','Leverancierscode',0),(221056,6141,'fi','Toimittajakoodi',0),(221057,6141,'no','LeverandÃ¸rkode',0),(221058,6141,'da','Kreditorkoden',0),(221059,6141,'ko','ê³µê¸‰ ì—…ì²´ ì½”ë“œ',0),(221060,6141,'he','×§×•×“ ×¡×¤×§',0),(221061,6141,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(221062,6141,'zh','é”€å”®å•†ä»£ç \r\n',0),(221063,6141,'sv','LeverantÃ¶rskoden',0),(221064,6141,'it','Codice Fornitore',0),(221065,6141,'tl','',0),(221066,6141,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(221067,6141,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹à¤¡',0),(221068,6141,'ms','Kod pembekal',0),(221069,6141,'ar','Ø±Ù…Ø² Ø§Ù„Ù…ÙˆØ±Ø¯',0),(221070,6141,'fr','Code fournisseur',0),(221071,6141,'jp','æ¥­è€…ã‚³ãƒ¼ãƒ‰',0),(221072,6141,'pt','CÃ³digo de fornecedor',0),(221073,6141,'ru','ÐšÐ¾Ð´ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(221074,6141,'es','CÃ³digo de Proveedor',0),(221075,6141,'de','Herstellercode',0),(221076,6141,'en','Vendor Code',0),(221077,6142,'is','',0),(221078,6142,'dr','ÙØ§ØµÙ„Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ø¨ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ùˆ Ø¯Ø±ÙŠØ§ÙØª Ø¢Ù†',0),(221079,6142,'pr','ÙØ§ØµÙ„Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ø¨ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ùˆ Ø¯Ø±ÙŠØ§ÙØª Ø¢Ù†',0),(221080,6142,'tr','SaÄŸlama sÃ¼resi',0),(221081,6142,'pl','Czas realizacji',0),(221082,6142,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(221083,6142,'ur','ÙˆÙ‚Øª Ú©ÛŒ Ù‚ÛŒØ§Ø¯Øª',0),(221084,6142,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ñ†Ð¸ÐºÐ»ÑƒÑÐ°',0),(221085,6142,'vi','Thá»i gian dáº«n Ä‘áº§u',0),(221086,6142,'af','Voorloop tyd',0),(221087,6142,'ro','timp de pregÄƒtire',0),(221088,6142,'et','Kestus',0),(221089,6142,'si','Äasovna priprava',0),(221090,6142,'ba','Waktu pimpin',0),(221091,6142,'nl','Levertijd',0),(221092,6142,'fi','Toimitusaika',0),(221093,6142,'no','behandlingstid',0),(221094,6142,'da','TidsforlÃ¸b',0),(221095,6142,'ko','ë¦¬ë“œ íƒ€ìž„',0),(221096,6142,'he','×–×ž×Ÿ ××¡×¤×§×”',0),(221097,6142,'el','Î§ÏÏŒÎ½Î¿Ï‚ Ï€ÏÎ¿Ï€Î¿ÏÎµÏ…ÏŒÎ¼ÎµÎ½Î¿Ï…',0),(221098,6142,'zh','æå‰æœŸ\r\n',0),(221099,6142,'sv','Leveranstid',0),(221100,6142,'it','Lead time',0),(221101,6142,'tl','',0),(221102,6142,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3619;&#3629;&#3648;&#3605;&#3636;&#3617;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(221103,6142,'hi','à¤–à¤¼à¤¾à¤¸ à¤¸à¤®à¤¯',0),(221104,6142,'ms','Masa',0),(221105,6142,'ar','ÙØªØ±Ø© Ø¥Ù†ØªØ§Ø¬',0),(221106,6142,'fr','Delai',0),(221107,6142,'jp','ãƒªãƒ¼ãƒ‰æ™‚é–“',0),(221108,6142,'pt','Tempo de espera',0),(221109,6142,'ru','Ð¡Ñ€Ð¾Ðº Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(221110,6142,'es','Tiempo de AcciÃ³n',0),(221111,6142,'de','Vorlaufzeit',0),(221112,6142,'en','Lead Time',0),(221113,6143,'is','',0),(221114,6143,'dr','(Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§ Ù†Ùƒ Ø¨Ø§ÙŠØ¯ Ø­Ø°Ù Ø´ÙˆØ¯ Ù‚Ø¨Ù„ Ø§Ø² ØªØºÙŠÙŠØ± Ø§ÙŠÙ† Ø«Ø¨Øª )',0),(221115,6143,'pr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¯Ø± Ø­Ø³Ø§Ø¨ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ (Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§ Ù†Ùƒ Ø¨Ø§ÙŠØ¯ Ø­Ø°Ù Ø´ÙˆØ¯ Ù‚Ø¨Ù„ Ø§Ø² ØªØºÙŠÙŠØ± Ø§ÙŠÙ† Ø«Ø¨Øª )',0),(221116,6143,'tr','Banka Mevduat (banka mevduat bu giriÅŸ deÄŸiÅŸtirmeden Ã¶nce silmeniz gerekir) dahil',0),(221117,6143,'pl','Na Bank Deposit (naleÅ¼y usunÄ…Ä‡ przelew przed zmianÄ… tego wpisu)',0),(221118,6143,'bg','Ð’ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð² Ð±Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ (Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ñ‚Ðµ Ð±Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ð·Ð°Ð¿Ð¸Ñ)',0),(221119,6143,'ur','Ø¨ÛŒÙ†Ú© Ù…ÛŒÚº Ø¬Ù…Ø¹ Ø´Ø¯Û Ú©Ú¾Ø§ØªÛ',0),(221120,6143,'sr','Ð£ÐºÑ™ÑƒÑ‡ÐµÐ½Ðµ Ñƒ Ð±Ð°Ð½Ñ†Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° (Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ð±Ð°Ð½ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ñ€Ðµ Ð½ÐµÐ³Ð¾ ÑˆÑ‚Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð° ÑÑ‚Ð°Ð²ÐºÐ°)',0),(221121,6143,'vi','Bao Gá»“m Äáº·t Cá»c Qua NgÃ¢n HÃ ng (pháº£i xÃ³a Äáº·t Cá»c Qua NgÃ¢n HÃ ng trÆ°á»›c khi thay Ä‘á»•i entry nÃ y)',0),(221122,6143,'af','Ingesluit op Bank Deposito (moet bankdeposito skrap alvorens hierdie inskrywing verander word)',0),(221123,6143,'ro','Cont bancar inclus (trebuie sters contul bancar inainte de a modifica acest parametru)',0),(221124,6143,'et','Kantud pangahoiuste (peate kustutama pangahoiuste enne sÃµnadest)',0),(221125,6143,'si','VkljuÄeni na banÄne vloge (morate izbrisati banÄni depozit pred spreminjanjem ta vnos)',0),(221126,6143,'ba','Termasuk dalam Deposit Bank (Hapus deposit bank dahulu sebelum mengganti ini)',0),(221127,6143,'nl','Opgenomen op bankstorting (moet bankstorting verwijderen voordat u deze ingang)',0),(221128,6143,'fi','Mukana Bank Deposit (poistamalla pankkitalletus aiemmin ailahteleminen nyt kuluva kohta)',0),(221129,6143,'no','Inkludert pÃ¥ bankinnskudd (mÃ¥ slette bankinnskudd fÃ¸r du endrer denne oppfÃ¸ringen)',0),(221130,6143,'da','Inkluderet pÃ¥ Bank depositum (skal slette bankindbetaling fÃ¸r du Ã¦ndrer denne lÃ¸sning)',0),(221131,6143,'ko','ì€í–‰ ì˜ˆê¸ˆ (ì€í–‰ ì˜ˆê¸ˆì´ì´ í•­ëª©ì„ ë³€ê²½ í•˜ê¸° ì „ì— ì‚­ì œ í•´ì•¼ í•©ë‹ˆë‹¤)ì— í¬í•¨',0),(221132,6143,'he','×›×œ×•×œ×™× ×‘ ×‘×¤×§×“×•×Ÿ ×‘×‘× ×§ (×¢×œ×™×š ×œ×ž×—×•×§ ×‘×¤×§×“×•×Ÿ ×‘×‘× ×§ ×œ×¤× ×™ ×©×™× ×•×™ ×”×¤×•×¡×˜ ×”×–×”)',0),(221133,6143,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î·Î½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÎµ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ (Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ® ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Î±Î»Î»Î±Î³Î® Î±Ï…Ï„Î® Î· ÎµÎ³Î³ÏÎ±Ï†Î®)',0),(221134,6143,'zh','åŒ…æ‹¬é“¶è¡Œå­˜æ¬¾ï¼ˆå¿…é¡»åˆ é™¤ï¼Œç„¶åŽå†æ›´æ”¹æ­¤é¡¹é“¶è¡Œå­˜æ¬¾ï¼‰\r\n',0),(221135,6143,'sv','IngÃ¥r pÃ¥ BankinsÃ¤ttning (mÃ¥ste ta bort bankinsÃ¤ttning innan du Ã¤ndrar den hÃ¤r posten)',0),(221136,6143,'it','Incluso nel deposito bancario (Ã¨ necessario cancellare il deposito bancario prima di modificare questa casella)',0),(221137,6143,'tl','',0),(221138,6143,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619; (&#3605;&#3657;&#3629;&#3591;&#3621;&#3610;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&',0),(221139,6143,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ (à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤‡à¤¸ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾) à¤ªà¤° à¤¶à¤¾à¤®à¤¿à¤²',0),(221140,6143,'ms','Termasuk Deposit Bank (mesti menghapuskan bank deposit sebelum menukar entri ini)',0),(221141,6143,'ar','ÙˆØ´Ù…Ù„Øª Ø¹Ù„Ù‰ \"Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©\" (ÙŠØ¬Ø¨ Ø­Ø°Ù Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ© Ù‚Ø¨Ù„ ØªØºÙŠÙŠØ± Ù‡Ø°Ø§ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„)',0),(221142,6143,'fr','AjoutÃ© au DÃ©pot de Banque (doit supprimer le dÃ©pot de banque avant de changer cette entrÃ©e)',0),(221143,6143,'jp','éŠ€è¡Œé ?é‡‘ã?«å?«ã‚?ã‚‹ï¼ˆã?“ã?®å…¥åŠ›ã‚’å¤‰æ›´ã?™ã‚‹å‰?ã?«éŠ€è¡Œé ?é‡‘ã‚’æ¶ˆåŽ»ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“ï¼‰',0),(221144,6143,'pt','IncluÃ­do no depÃ³sito bancÃ¡rio (exclua depÃ³sito bancÃ¡rio antes de alterar esta entrada)',0),(221145,6143,'ru','ÐÐ° Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ (Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚, Ð¿Ñ€ÐµÐ¶Ð´Ðµ Ñ‡ÐµÐ¼ Ð¸Ð·Ð¼ÐµÐ½ÑÑ‚ÑŒ ÑÑ‚Ñƒ Ð·Ð°Ð¿Ð¸ÑÑŒ)',0),(221146,6143,'es','Incluido en el DepÃ³sito Bancario (debe borrar depÃ³sito antes de cambiar la entrada)',0),(221147,6143,'de','Aufgenommen am Bankdepot (mÃ¼ssen Bankdepot lÃ¶schen, bevor Sie diesen Eintrag Ã¤ndern)',0),(221148,6143,'en','Included on Bank Deposit (must delete bank deposit before changing this entry)',0),(221149,6144,'is','',0),(221150,6144,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(221151,6144,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(221152,6144,'tr','Fatura Ã¶deme',0),(221153,6144,'pl','Bill pÅ‚atnoÅ›ci',0),(221154,6144,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(221155,6144,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(221156,6144,'sr','ÐÐ°Ð¿Ð»Ð°Ñ‚Ðµ',0),(221157,6144,'vi','Thanh ToÃ¡n HÃ³a ÄÆ¡n',0),(221158,6144,'af','Rekening Betaling',0),(221159,6144,'ro','Factura de platÄƒ',0),(221160,6144,'et','Arve makse',0),(221161,6144,'si','ObraÄun plaÄil',0),(221162,6144,'ba','Pembayaran tagihan',0),(221163,6144,'nl','Factuur betaling',0),(221164,6144,'fi','Laskun maksu',0),(221165,6144,'no','Bill betalingen',0),(221166,6144,'da','Bill betaling',0),(221167,6144,'ko','ë¹Œ ì§€ë¶ˆ',0),(221168,6144,'he','×ª×©×œ×•× ×—×©×‘×•×Ÿ',0),(221169,6144,'el','Î•Î¾ÏŒÏ†Î»Î·ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(221170,6144,'zh','ç¼´è´¹æœåŠ¡\r\n',0),(221171,6144,'sv','Bill betalning',0),(221172,6144,'it','Pagamento fattura',0),(221173,6144,'tl','',0),(221174,6144,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3610;&#3636;&#3621;',0),(221175,6144,'hi','à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(221176,6144,'ms','Pembayaran bil',0),(221177,6144,'ar','Ø¯ÙØ¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(221178,6144,'fr','Paiement de facture',0),(221179,6144,'jp','è«‹æ±‚æ›¸æ”¯æ‰•',0),(221180,6144,'pt','Pagamento de contas',0),(221181,6144,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(221182,6144,'es','Factura Pago',0),(221183,6144,'de','-Ãœberweisungen',0),(221184,6144,'en','Bill Payment',0),(221185,6145,'is','',0),(221186,6145,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ø®Ø±ÙŠØ¯Ø§Ø±',0),(221187,6145,'pr','Ø³Ù¾Ø±Ø¯Ù‡(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ø®Ø±ÙŠØ¯Ø§Ø±',0),(221188,6145,'tr','Cutomer mevduat',0),(221189,6145,'pl','Depozyt cutomer',0),(221190,6145,'bg','Ð¡ÑŠÐ³Ð»Ð°ÑÑƒÐ²Ð°Ð½Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(221191,6145,'ur','Ú©ÙˆÙ¹Ù…Ø§Ø± ÚˆÙ¾Ø§Ø²Ù¹',0),(221192,6145,'sr','Ð¦ÑƒÑ‚Ð¾Ð¼ÐµÑ€ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(221193,6145,'vi','Äáº·t cá»c cá»§a KhÃ¡ch hÃ ng',0),(221194,6145,'af','Klant / KliÃ«nt Deposito',0),(221195,6145,'ro','Depozit de clienti',0),(221196,6145,'et','Cutomer tagatisraha',0),(221197,6145,'si','Depozit cutomer',0),(221198,6145,'ba','Cutomer Deposit',0),(221199,6145,'nl','Cutomer storting',0),(221200,6145,'fi','Cutomer talletus',0),(221201,6145,'no','Cutomer innskudd',0),(221202,6145,'da','Kunde depositum',0),(221203,6145,'ko','Cutomer ì˜ˆê¸ˆ',0),(221204,6145,'he','Cutomer ×”×¤×§×“×”',0),(221205,6145,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· cutomer',0),(221206,6145,'zh','å®¢æˆ·æˆåŠŸåˆ é™¤\r\n',0),(221207,6145,'sv','Cutomer insÃ¤ttning',0),(221208,6145,'it','Deposito di cutomer',0),(221209,6145,'tl','',0),(221210,6145,'th','&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(221211,6145,'hi','Cutomer à¤œà¤®à¤¾',0),(221212,6145,'ms','Cutomer Deposit',0),(221213,6145,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Cutomer',0),(221214,6145,'fr','Cutomer dÃ©pÃ´t',0),(221215,6145,'jp','é¡§å®¢é ?ã‚Šé‡‘',0),(221216,6145,'pt','DepÃ³sito cutomer',0),(221217,6145,'ru','Cutomer Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(221218,6145,'es','Cliente DepÃ³sito',0),(221219,6145,'de','Cutomer Einzahlung',0),(221220,6145,'en','Cutomer Deposit',0),(221221,6146,'is','',0),(221222,6146,'dr','Ù…Ø³ØªÙ‚ÙŠÙ…Ø§ Ø¯Ø± Ø¯ÙØªØ± ÙƒÙ„ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(221223,6146,'pr','Ù…Ø³ØªÙ‚ÙŠÙ…Ø§ Ø¯Ø± Ø¯ÙØªØ± ÙƒÙ„ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(221224,6146,'tr','DoÄŸrudan genel muhasebe girilen',0),(221225,6146,'pl','Wprowadzone bezpoÅ›rednio w ksiÄ™dze',0),(221226,6146,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¾ Ð² ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´Ð½Ð°Ñ‚Ð° ÐºÐ½Ð¸Ð³Ð°',0),(221227,6146,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(221228,6146,'sr','Ð£Ð½ÐµÑ‚Ð¸ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¾ Ñƒ Ð³Ð»Ð°Ð²Ð½Ñƒ ÐºÑšÐ¸Ð³Ñƒ',0),(221229,6146,'vi','Nháº­p Tháº³ng VÃ o Sá»• CÃ¡i Tá»•ng Há»£p',0),(221230,6146,'af','Direk ingevoer binne die Algemene Grootboek',0),(221231,6146,'ro','A intrat direct Ã®n contabilitate',0),(221232,6146,'et','Sisestatud pearaamatusse',0),(221233,6146,'si','Vnesene neposredno v glavno knjigo',0),(221234,6146,'ba','Masuk langsung ke General Ledger',0),(221235,6146,'nl','Die rechtstreeks in het grootboek worden ingevoerd',0),(221236,6146,'fi','Suoraan General Ledger',0),(221237,6146,'no','Skrevet direkte inn i finans',0),(221238,6146,'da','Indtastes direkte i Finans',0),(221239,6146,'ko','ì¼ë°˜ íšŒê³„ ìž¥ë¶€ì— ì§ì ‘ ìž…ë ¥ í•œ',0),(221240,6146,'he','×”×ž×•×–× ×™× ×™×©×™×¨×•×ª ×œ×ª×•×š ×”×¡×¤×¨ ×”×¨××©×™',0),(221241,6146,'el','Î¤Î­Î¸Î·ÎºÎµ Î¬Î¼ÎµÏƒÎ± ÏƒÎµ Î³ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®',0),(221242,6146,'zh','ç›´æŽ¥è¾“å…¥åˆ°æ€»å¸\r\n',0),(221243,6146,'sv','Anges direkt i redovisningen',0),(221244,6146,'it','Entrato direttamente in contabilitÃ  generale',0),(221245,6146,'tl','',0),(221246,6146,'th','&#3606;&#3641;&#3585;&#3611;&#3657;&#3629;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(221247,6146,'hi','à¤¸à¥€à¤§à¥‡ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤®à¥‡à¤‚ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(221248,6146,'ms','Masukkan terus ke dalam Lejar Am',0),(221249,6146,'ar','ÙŠØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ Ù…Ø¨Ø§Ø´Ø±Ø© Ø¥Ù„Ù‰ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(221250,6146,'fr','EntrÃ© directement en comptabilitÃ© gÃ©nÃ©rale',0),(221251,6146,'jp','ç·?å‹˜å®šå…ƒå¸³ã?¸ç›´æŽ¥å…¥åŠ›ã?•ã‚Œã?Ÿ',0),(221252,6146,'pt','Entrou diretamente em razÃƒ Â£ o',0),(221253,6146,'ru','Ð’Ð²ÐµÐ´ÐµÐ½Ð¾ ÐÐµÐ¿Ð¾ÑÑ€ÐµÐ´ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ Ð² Ð“Ð»Ð°Ð²Ð½ÑƒÑŽ ÐšÐ½Ð¸Ð³Ñƒ',0),(221254,6146,'es','Entrada Directamente en el Libro Mayor',0),(221255,6146,'de','Direkt in der Finanzbuchhaltung eingegeben',0),(221256,6146,'en','Entered Directly into General Ledger',0),(221257,6147,'is','',0),(221258,6147,'dr','Ø±Ø³ÙŠØ¯  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(221259,6147,'pr','Ø±Ø³ÙŠØ¯  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(221260,6147,'tr','Stok giriÅŸi',0),(221261,6147,'pl','Magazynowe',0),(221262,6147,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ° Ð·Ð° ÑÐºÐ»Ð°Ð´',0),(221263,6147,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø±Ø³ÛŒØ¯',0),(221264,6147,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ñ†Ð°',0),(221265,6147,'vi','BiÃªn Nháº­n HÃ ng',0),(221266,6147,'af','Voorraad ontvangs',0),(221267,6147,'ro','Primirea de inventar',0),(221268,6147,'et','Lao sissetulek',0),(221269,6147,'si','Prejem zaloge',0),(221270,6147,'ba','Penerimaan persediaan',0),(221271,6147,'nl','Voorraad ontvangstbewijs',0),(221272,6147,'fi','Vastaanotto varastoon',0),(221273,6147,'no','Lagermottak',0),(221274,6147,'da','Lagertilgang',0),(221275,6147,'ko','ìž¬ê³  ì˜ìˆ˜ì¦',0),(221276,6147,'he','×§×‘×œ×ª ×ž×œ××™',0),(221277,6147,'el','Î Î±ÏÎ±Î»Î±Î²Î® Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(221278,6147,'zh','åº“å­˜æ”¶æ®\r\n',0),(221279,6147,'sv','Lagerinleverans',0),(221280,6147,'it','Inventario ricevuta',0),(221281,6147,'tl','',0),(221282,6147,'th','&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(221283,6147,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤°à¤¸à¥€à¤¦',0),(221284,6147,'ms','Inventori resit',0),(221285,6147,'ar','Ø¥ÙŠØµØ§Ù„ Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(221286,6147,'fr','RÃ©ception de l\'inventaire',0),(221287,6147,'jp','åœ¨åº«é ˜å?Žæ›¸',0),(221288,6147,'pt','Recibo de inventÃ¡rio',0),(221289,6147,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ðµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(221290,6147,'es','Recibo de Inventario',0),(221291,6147,'de','Lagerzugang',0),(221292,6147,'en','Inventory Receipt',0),(221293,6148,'is','',0),(221294,6148,'dr','(ÙˆØ±ÙˆØ¯',0),(221295,6148,'pr','ÙØ§ÙƒØªÙˆØ± Ø«Ø¨Øª(ÙˆØ±ÙˆØ¯',0),(221296,6148,'tr','Fatura giriÅŸi',0),(221297,6148,'pl','Wpis faktury',0),(221298,6148,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(221299,6148,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(221300,6148,'sr','Ð¡Ñ‚Ð°Ð²ÐºÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(221301,6148,'vi','Nháº­p HÃ³a ÄÆ¡n',0),(221302,6148,'af','Faktuur Inskrywing',0),(221303,6148,'ro','Inregistrare factura',0),(221304,6148,'et','Arve kande',0),(221305,6148,'si','Vnos raÄuna',0),(221306,6148,'ba','Faktur masuk',0),(221307,6148,'nl','Factuurpost',0),(221308,6148,'fi','Laskusta',0),(221309,6148,'no','Faktura oppfÃ¸ring',0),(221310,6148,'da','Fakturapost',0),(221311,6148,'ko','ì†¡ìž¥ í•­ëª©',0),(221312,6148,'he','×›× ×™×¡×” ×—×©×‘×•× ×™×ª',0),(221313,6148,'el','Î•Î³Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(221314,6148,'zh','å‘ç¥¨æ¡ç›®\r\n',0),(221315,6148,'sv','Fakturatransaktionen',0),(221316,6148,'it','Voce della fattura',0),(221317,6148,'tl','',0),(221318,6148,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(221319,6148,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(221320,6148,'ms','Kemasukan invois',0),(221321,6148,'ar','Ø¥Ø¯Ø®Ø§Ù„ ÙØ§ØªÙˆØ±Ø©',0),(221322,6148,'fr','Saisie des factures',0),(221323,6148,'jp','è«‹æ±‚æ›¸å…¥åŠ›',0),(221324,6148,'pt','Entrada de fatura',0),(221325,6148,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ ÑÑ‡ÐµÑ‚Ð°',0),(221326,6148,'es','Entrada de Factura',0),(221327,6148,'de','Rechnungserfassung',0),(221328,6148,'en','Invoice Entry',0),(221329,6149,'is','',0),(221330,6149,'dr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(221331,6149,'pr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(221332,6149,'tr','Fatura Ã¶deme',0),(221333,6149,'pl','PÅ‚atnoÅ›ci faktury',0),(221334,6149,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(221335,6149,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(221336,6149,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(221337,6149,'vi','Thanh toÃ¡n hÃ³a Ä‘Æ¡n',0),(221338,6149,'af','Faktuur Betaling',0),(221339,6149,'ro','Plata facturii',0),(221340,6149,'et','Arve makse',0),(221341,6149,'si','PlaÄilo raÄuna',0),(221342,6149,'ba','Pembayaran tagihan',0),(221343,6149,'nl','Factuur betaling',0),(221344,6149,'fi','Laskun maksu',0),(221345,6149,'no','Fakturabetalingen',0),(221346,6149,'da','Fakturabetaling',0),(221347,6149,'ko','ì†¡ìž¥ ì§€ë¶ˆ',0),(221348,6149,'he','×ª×©×œ×•× ×—×©×‘×•× ×™×ª',0),(221349,6149,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(221350,6149,'zh','å‘ç¥¨ä»˜æ¬¾\r\n',0),(221351,6149,'sv','Fakturabetalning',0),(221352,6149,'it','Pagamento fattura',0),(221353,6149,'tl','',0),(221354,6149,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(221355,6149,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(221356,6149,'ms','Pembayaran invois',0),(221357,6149,'ar','Ø¯ÙØ¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(221358,6149,'fr','Paiement de facture',0),(221359,6149,'jp','è«‹æ±‚æ›¸æ”¯æ‰•',0),(221360,6149,'pt','Pagamento de fatura',0),(221361,6149,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð°',0),(221362,6149,'es','Pago de Factura',0),(221363,6149,'de','Rechnung Zahlung',0),(221364,6149,'en','Invoice Payment',0),(221365,6150,'is','',0),(221366,6150,'dr','Ú†Ùƒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(221367,6150,'pr','Ú†Ùƒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(221368,6150,'tr','MaaÅŸ Ã§eki',0),(221369,6150,'pl','SprawdÅº listy pÅ‚ac',0),(221370,6150,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(221371,6150,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(221372,6150,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(221373,6150,'vi','SÃ©c Tráº£ LÆ°Æ¡ng',0),(221374,6150,'af','Loonroltjek',0),(221375,6150,'ro','Salarizare Check',0),(221376,6150,'et','Palga sisse',0),(221377,6150,'si','Preverite plaÄilna lista',0),(221378,6150,'ba','Penggajian Check',0),(221379,6150,'nl','Payroll Check',0),(221380,6150,'fi','Palkanlaskennan uloskirjautuminen',0),(221381,6150,'no','LÃ¸nn sjekk',0),(221382,6150,'da','LÃ¸n Check',0),(221383,6150,'ko','ê¸‰ì—¬ í™•ì¸',0),(221384,6150,'he','×¦\'×§ ×”×ž×©×›×•×¨×ª',0),(221385,6150,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(221386,6150,'zh','å·¥èµ„æ”¯ç¥¨\r\n',0),(221387,6150,'sv','LÃ¶nelistan kontrollera',0),(221388,6150,'it','Controllo sui salari',0),(221389,6150,'tl','',0),(221390,6150,'th','&#3648;&#3594;&#3655;&#3588;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(221391,6150,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤šà¥‡à¤•',0),(221392,6150,'ms','Semak gaji',0),(221393,6150,'ar','ØµÙƒ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(221394,6150,'fr','ChÃ¨que de paie',0),(221395,6150,'jp','çµ¦ä¸Žå°?åˆ‡æ‰‹',0),(221396,6150,'pt','SeleÃ§Ã£o de folha de pagamento',0),(221397,6150,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(221398,6150,'es','Cheque de NÃ³mina',0),(221399,6150,'de','Payroll-Check',0),(221400,6150,'en','Payroll Check',0),(221401,6151,'is','',0),(221402,6151,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ù„ÛŒØ³Øª Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡',0),(221403,6151,'pr','Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ (Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(221404,6151,'tr','Bordro vergi Ã¶deme onay',0),(221405,6151,'pl','PÅ‚ace podatku wpÅ‚aty wyboru',0),(221406,6151,'bg','Ð¢Ð Ð— Ð´Ð°Ð½ÑŠÑ‡Ð½Ð°Ñ‚Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ‡ÐµÐº',0),(221407,6151,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù¹ÛŒÚ©Ø³ Ø¬Ù…Ø¹ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(221408,6151,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ',0),(221409,6151,'vi','SÃ©c tráº£ trÆ°á»›c thuáº¿ lÆ°Æ¡ng',0),(221410,6151,'af','Loonrol Belasting Deposito Tjeks',0),(221411,6151,'ro','Salarizare fiscalÄƒ depozit a verifica',0),(221412,6151,'et','Palgafondi maksu tagatisraha sisse',0),(221413,6151,'si','IzplaÄane plaÄe davek vloga Äek',0),(221414,6151,'ba','Penggajian pajak Deposit Check',0),(221415,6151,'nl','Payroll belastingen storting Check',0),(221416,6151,'fi','Palkanlaskennan vero Internet LAN',0),(221417,6151,'no','LÃ¸nn skatt innskudd sjekk',0),(221418,6151,'da','Payroll Tax Deposit Check',0),(221419,6151,'ko','ê¸‰ì—¬ ì„¸ê¸ˆ ìž…ê¸ˆ í™•ì¸',0),(221420,6151,'he','×”×ž×—××ª ×¤×™×§×“×•×Ÿ ×ž×¡',0),(221421,6151,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î± Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Ï‡Ï‰',0),(221422,6151,'zh','å·¥èµ„ç¨ŽæŒ‰é‡‘æ”¯ç¥¨\r\n',0),(221423,6151,'sv','LÃ¶n skatt insÃ¤ttning kontroll',0),(221424,6151,'it','Check di deposito fiscale sui salari',0),(221425,6151,'tl','',0),(221426,6151,'th','&#3648;&#3594;&#3655;&#3588;&#3613;&#3634;&#3585;&#3588;&#3656;&#3634;&#3616;&#3634;&#3625;&#3637;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(221427,6151,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤Ÿà¥ˆà¤•à¥à¤¸ à¤œà¤®à¤¾ à¤šà¥‡à¤•',0),(221428,6151,'ms','Senarai gaji cukai Deposit cek',0),(221429,6151,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø¥ÙŠØ¯Ø§Ø¹ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(221430,6151,'fr','Paie impÃ´t dÃ©pÃ´t Check',0),(221431,6151,'jp','çµ¦ä¸Žç¨Žé ?é‡‘å°?åˆ‡æ‰‹',0),(221432,6151,'pt','Folha de pagamento imposto depÃ³sito cheque',0),(221433,6151,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ Ñ‡ÐµÐº',0),(221434,6151,'es','Cheque de DepÃ³sito de Impuesto de NÃ³mina',0),(221435,6151,'de','Abrechnung Kaution Steuercheck',0),(221436,6151,'en','Payroll Tax Deposit Check',0),(221437,6152,'is','',0),(221438,6152,'dr','Ø§ÙŠÙ† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø±Ø§ Ù¾Ø³Øª Ù†ÙƒÙ†ÙŠØ¯ ',0),(221439,6152,'pr','Ø§ÙŠÙ† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø±Ø§ Ù¾Ø³Øª Ù†ÙƒÙ†ÙŠØ¯ ',0),(221440,6152,'tr','Bu fiÅŸ unpost',0),(221441,6152,'pl','Unpost niniejszego zaÅ‚Ä…cznika',0),(221442,6152,'bg','Unpost Ñ‚Ð¾Ð·Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(221443,6152,'ur','ÛŒÛ ÙˆØ§Ø¤Ú†Ø± Ø§Ù†Ù¾ÙˆØ³Ù¹',0),(221444,6152,'sr','ÐŸÐ¾Ð²ÑƒÐ¸Ðµ Ð¾Ð²Ð°Ñ˜ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(221445,6152,'vi','KhÃ´ng káº¿t chuyá»ƒn phiáº¿u nÃ y',0),(221446,6152,'af','Onbondel hierdie Bewysstukke ',0),(221447,6152,'ro','Unpost acest Voucher',0),(221448,6152,'et','Unpost KÃ¤esolev leht',0),(221449,6152,'si','Unpost tega kupona',0),(221450,6152,'ba','Unpost Voucher ini',0),(221451,6152,'nl','Unpost deze Voucher',0),(221452,6152,'fi','Unpost TÃ¤mÃ¤ tosite',0),(221453,6152,'no','Unpost dette bilaget',0),(221454,6152,'da','Unpost denne kupon',0),(221455,6152,'ko','ì´ ë°”ìš°ì²˜ë¥¼ unpost',0),(221456,6152,'he','Unpost ×©×•×‘×¨ ×–×”',0),(221457,6152,'el','Unpost Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(221458,6152,'zh','ä¸å‘å¸ƒæ­¤åˆ¸\r\n',0),(221459,6152,'sv','Unpost denna verifikation',0),(221460,6152,'it','Unpost questo Voucher',0),(221461,6152,'tl','',0),(221462,6152,'th','&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3609;&#3637;&#3657;',0),(221463,6152,'hi','à¤‡à¤¸ à¤µà¤¾à¤‰à¤šà¤° unpost',0),(221464,6152,'ms','Unpost baucar ini',0),(221465,6152,'ar','Ø£ÙˆÙ†Ø¨ÙˆØ³Øª Ù‡Ø°Ø§ Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(221466,6152,'fr','Unpost ce bon',0),(221467,6152,'jp','ã?“ã?®ä¼?ç¥¨ã‚’æœªè¨ˆä¸Šã?«ã?™ã‚‹',0),(221468,6152,'pt','Unpost este Voucher',0),(221469,6152,'ru','Unpost ÑÑ‚Ð¾Ñ‚ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(221470,6152,'es','No Asentar este Voucher',0),(221471,6152,'de','Unpost dieser Gutschein',0),(221472,6152,'en','Unpost this Voucher',0),(221473,6153,'is','',0),(221474,6153,'dr','ÙØ§ÙƒØªÙˆØ± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(221475,6153,'pr','ÙØ§ÙƒØªÙˆØ± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(221476,6153,'tr','SatÄ±cÄ± faturasÄ±',0),(221477,6153,'pl','Faktura od dostawcy',0),(221478,6153,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(221479,6153,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§Ù†ÙˆØ§Ø¦Ø³',0),(221480,6153,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(221481,6153,'vi','HÃ³a Ä‘Æ¡n NgÆ°á»i bÃ¡n',0),(221482,6153,'af','Verskaffer Faktuur',0),(221483,6153,'ro','FacturÄƒ de furnizor',0),(221484,6153,'et','Tarnija arve',0),(221485,6153,'si','RaÄun dobavitelja',0),(221486,6153,'ba','Penjual faktur',0),(221487,6153,'nl','Factuur van de leverancier',0),(221488,6153,'fi','Toimittajalasku',0),(221489,6153,'no','LeverandÃ¸rfaktura',0),(221490,6153,'da','Kreditorfaktura',0),(221491,6153,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ',0),(221492,6153,'he','×—×©×‘×•× ×™×ª ×¡×¤×§',0),(221493,6153,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(221494,6153,'zh','ä¾›åº”å•†å‘ç¥¨\r\n',0),(221495,6153,'sv','LeverantÃ¶rsfaktura',0),(221496,6153,'it','Fattura fornitore',0),(221497,6153,'tl','',0),(221498,6153,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(221499,6153,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸',0),(221500,6153,'ms','Invois pembekal',0),(221501,6153,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(221502,6153,'fr','Facture fournisseur',0),(221503,6153,'jp','æ¥­è€…è«‹æ±‚æ›¸',0),(221504,6153,'pt','Factura de fornecedor',0),(221505,6153,'ru','ÐÐ°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(221506,6153,'es','Proveedor Factura',0),(221507,6153,'de','Kreditorenrechnung',0),(221508,6153,'en','Vendor Invoice',0),(221509,6154,'is','',0),(221510,6154,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(221511,6154,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ',0),(221512,6154,'tr','FiÅŸ detay',0),(221513,6154,'pl','ZaÅ‚Ä…cznik szczegÃ³Å‚y',0),(221514,6154,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð´ÐµÑ‚Ð°Ð¹Ð»',0),(221515,6154,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ ØªÙØµÛŒÙ„',0),(221516,6154,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð´ÐµÑ‚Ð°Ñ™',0),(221517,6154,'vi','Chi tiáº¿t phiáº¿u',0),(221518,6154,'af','Bewysstuk Detail',0),(221519,6154,'ro','Voucher detaliu',0),(221520,6154,'et','VautÅ¡eri andmed',0),(221521,6154,'si','Voucher podrobnosti',0),(221522,6154,'ba','Voucher Detail',0),(221523,6154,'nl','Waardebon Detail',0),(221524,6154,'fi','Tositteen tiedot',0),(221525,6154,'no','Bilag detaljer',0),(221526,6154,'da','Voucher detaljer',0),(221527,6154,'ko','ë°”ìš°ì²˜ ì„¸ë¶€ ì‚¬í•­',0),(221528,6154,'he','×¤×™×¨×•×˜ ×©×•×‘×¨',0),(221529,6154,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(221530,6154,'zh','å‡­å•è¯¦ç»†\r\n',0),(221531,6154,'sv','Verifikationen detalj',0),(221532,6154,'it','Dettaglio buono',0),(221533,6154,'tl','',0),(221534,6154,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(221535,6154,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(221536,6154,'ms','Terperinci baucar',0),(221537,6154,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(221538,6154,'fr','Bon dÃ©tail',0),(221539,6154,'jp','ä¼?ç¥¨è©³ç´°',0),(221540,6154,'pt','Detalhe de voucher',0),(221541,6154,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(221542,6154,'es','Detalle de Voucher',0),(221543,6154,'de','Gutschein Details',0),(221544,6154,'en','Voucher Detail',0),(221545,6155,'is','',0),(221546,6155,'dr','Ø¨Ø¯ÙˆÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(221547,6155,'pr','Ø¨Ø¯ÙˆÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(221548,6155,'tr','PO',0),(221549,6155,'pl','Bez PO',0),(221550,6155,'bg','Ð‘ÐµÐ· PO',0),(221551,6155,'ur','Ø¨ØºÛŒØ± Ù¾Ùˆ',0),(221552,6155,'sr','Ð‘ÐµÐ· ÐŸÐž',0),(221553,6155,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n mua hÃ ng',0),(221554,6155,'af','Sonder AB',0),(221555,6155,'ro','Fara PO',0),(221556,6155,'et','*Ilma PO-ta',0),(221557,6155,'si','Brez PO',0),(221558,6155,'ba','Tanpa PO',0),(221559,6155,'nl','Zonder PO',0),(221560,6155,'fi','Ilman PO',0),(221561,6155,'no','Uten PO',0),(221562,6155,'da','Uden PO',0),(221563,6155,'ko','í¬ ì—†ì´',0),(221564,6155,'he','×œ×œ× ×¤×•',0),(221565,6155,'el','Î§Ï‰ÏÎ¯Ï‚ PO',0),(221566,6155,'zh','æ²¡æœ‰è®¢å•\r\n',0),(221567,6155,'sv','Utan PO',0),(221568,6155,'it','Senza PO',0),(221569,6155,'tl','',0),(221570,6155,'th','&#3650;&#3604;&#3618;&#3611;&#3619;&#3634;&#3624;&#3592;&#3634;&#3585;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(221571,6155,'hi','PO à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾',0),(221572,6155,'ms','Tanpa PO',0),(221573,6155,'ar','Ø¯ÙˆÙ† Ø¨Ùˆ',0),(221574,6155,'fr','Sans PO',0),(221575,6155,'jp','æ³¨æ–‡æ›¸ã?ªã?—ã?§',0),(221576,6155,'pt','Sem PO',0),(221577,6155,'ru','Ð‘ÐµÐ· PO',0),(221578,6155,'es','Sin OC',0),(221579,6155,'de','Ohne PO',0),(221580,6155,'en','Without PO',0),(221581,6156,'is','',0),(221582,6156,'dr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø±   Ø¨Ù„Ù‡',0),(221583,6156,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø±   Ø¨Ù„Ù‡',0),(221584,6156,'tr','EÄŸer Evet onay',0),(221585,6156,'pl','SprawdÅº, czy tak',0),(221586,6156,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ð»Ð¸ Ð´Ð°',0),(221587,6156,'ur','Ø§Ú¯Ø± ÛØ§ÚºØŒ ØªÙˆ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(221588,6156,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð´Ð° Ð»Ð¸ Ð´Ð°',0),(221589,6156,'vi','ÄÃ¡nh dáº¥u náº¿u cÃ³',0),(221590,6156,'af','Merk indien ja',0),(221591,6156,'ro','VerificaÅ£i dacÄƒ da',0),(221592,6156,'et','Kontrollige, kas Jah',0),(221593,6156,'si','Preverite, Äe ja',0),(221594,6156,'ba','Periksa apakah ya',0),(221595,6156,'nl','Controleer of Ja',0),(221596,6156,'fi','Tarkista kyllÃ¤',0),(221597,6156,'no','Sjekk Hvis ja',0),(221598,6156,'da','Check Hvis ja',0),(221599,6156,'ko','ê·¸ë ‡ë‹¤ë©´ í™•ì¸',0),(221600,6156,'he','×‘×—×¨ ×× ×›×Ÿ',0),(221601,6156,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î±Î½ Î½Î±Î¹',0),(221602,6156,'zh','æ£€æŸ¥æ˜¯å¦æœ‰\r\n',0),(221603,6156,'sv','Kontrollera om ja',0),(221604,6156,'it','Controllare se sÃ¬',0),(221605,6156,'tl','',0),(221606,6156,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3606;&#3657;&#3634;&#3651;&#3594;&#3656;',0),(221607,6156,'hi','à¤¯à¤¦à¤¿ à¤¹à¤¾à¤, à¤¤à¥‹ à¤šà¥‡à¤•',0),(221608,6156,'ms','Semak jika Ya',0),(221609,6156,'ar','Ù…Ø¹Ø±ÙØ© Ù…Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù† Ù†Ø¹Ù…',0),(221610,6156,'fr','Cocher si oui',0),(221611,6156,'jp','ã‚¤ã‚¨ã‚¹ã?ªã‚‰ãƒ?ã‚§ãƒƒã‚¯ã?—ã?¦ã??ã? ã?•ã?„',0),(221612,6156,'pt','Verificar se o Sim',0),(221613,6156,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÐµÑÐ»Ð¸ Ð´Ð°',0),(221614,6156,'es','Comprobar si es Si',0),(221615,6156,'de','ÃœberprÃ¼fen Sie, ob ja',0),(221616,6156,'en','Check if yes',0),(221617,6157,'is','',0),(221618,6157,'dr','ÙÙ‚Ø· Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ Ø§Ú¯Ø± Ù…Ø§Ù„ÙŠØ§Øª  Ø¨Ø± Ø¢Ø¯Ø±Ø³ Ø­Ù…Ù„ Ø§Ø³Øª',0),(221619,6157,'pr','ÙÙ‚Ø· Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ Ø§Ú¯Ø± Ù…Ø§Ù„ÙŠØ§Øª  Ø¨Ø± Ø¢Ø¯Ø±Ø³ Ø­Ù…Ù„ Ø§Ø³Øª',0),(221620,6157,'tr','Sadece adrese gemide vergi EÄŸer kullanÄ±lmÄ±ÅŸ.',0),(221621,6157,'pl','UÅ¼ywana tylko, jeÅ›li opodatkowania na adresu dostawy.',0),(221622,6157,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¾Ð±Ð»Ð°Ð³Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð¾ Ð°Ð´Ñ€ÐµÑ.',0),(221623,6157,'ur','ØµØ±Ù Ø§Ú¯Ø± Ù¾ØªÛ Ú©Û’ Ù„Ø¦Û’ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ù¾Ø± Ø¹Ø§Ø¦Ø¯ Ú©Ø±ØªÛ’ ØªÚ¾Û’ Û”',0),(221624,6157,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð½Ð°Ð¿Ð¾Ñ€Ð½Ð¾ Ð½Ð° Ð±Ñ€Ð¾Ð´Ñƒ Ð½Ð° Ð°Ð´Ñ€ÐµÑÑƒ.',0),(221625,6157,'vi','Chá»‰ sá»­ dá»¥ng khi cÃ³ Ä‘á»‹a chá»‰ chuyá»ƒn hÃ ng',0),(221626,6157,'af','Slegs gebruik indien belasbaar op versend aan adresse.',0),(221627,6157,'ro','UtilizatÄƒ numai dacÄƒ impoziteze pe nava la adresa.',0),(221628,6157,'et','Kasutada ainult kui maksustada kuhu saata.',0),(221629,6157,'si','Uporablja samo Äe obdavÄitev na ladji na naslov.',0),(221630,6157,'ba','Hanya digunakan jika pajak pada kapal ke alamat.',0),(221631,6157,'nl','Alleen gebruikt als belasten op schip aan te pakken.',0),(221632,6157,'fi','KÃ¤yttÃ¤Ã¤ vain, jos verotus on toim.asiakk.',0),(221633,6157,'no','Brukes bare hvis beskatte pÃ¥ forsendelsesadresse.',0),(221634,6157,'da','Kun bruges hvis beskatning pÃ¥ leveringsadresse.',0),(221635,6157,'ko','ë°°ì†¡ ì£¼ì†Œì— ë¶€ë‹´ ìŠ¤ëŸ¬ìš´ ê²½ìš°ì— ì‚¬ìš© í•©ë‹ˆë‹¤.',0),(221636,6157,'he','×‘×©×™×ž×•×© ×¨×§ ×× ×ž×›×‘×™×“ ×¢×œ ×”×¡×¤×™× ×” ×œ×›×ª×•×‘×ª.',0),(221637,6157,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î¼ÏŒÎ½Î¿ ÎµÎ¬Î½ Î· Ï†Î¿ÏÎ¿Î»ÏŒÎ³Î·ÏƒÎ· Î³Î¹Î± Ï€Î»Î¿Î¯Î¿ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·.',0),(221638,6157,'zh','ä»…æ”¶è´§åœ°å€å¾ç¨Žæ—¶ä½¿ç”¨\r\n',0),(221639,6157,'sv','Endast anvÃ¤ndas om beskattning pÃ¥ fraktadress.',0),(221640,6157,'it','Utilizzato solo se la tassazione sulla spedizione all\'indirizzo.',0),(221641,6157,'tl','',0),(221642,6157,'th','&#3651;&#3594;&#3657;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3617;&#3637;&#3585;&#3634;&#3619;&#3588;&#3636;&#3604;&#3616;&#3634;&#3625;&#3637;&#3651;&#3609;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3607;&#3637;&#3',0),(221643,6157,'hi','à¤•à¥‡à¤µà¤² à¤…à¤—à¤° à¤ªà¤¤à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤ªà¤° à¤šà¥à¤‚à¤—à¥€ à¤•à¤¾ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾à¥¤',0),(221644,6157,'ms','Hanya digunakan jika sukar kapal ke alamat.',0),(221645,6157,'ar','Ø¥Ù„Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù†Øª Ù‡Ù†Ø§Ùƒ Ø¶Ø±Ø§Ø¦Ø¨ Ø¹Ù„Ù‰ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù†.',0),(221646,6157,'fr','UtilisÃ© uniquement si la taxation sur le navire Ã  l\'adresse.',0),(221647,6157,'jp','é…?é€?å…ˆä½?æ‰€ã?¸èª²ç¨Žã?®å ´å?ˆã?®ã?¿ä½¿ç”¨',0),(221648,6157,'pt','Usado somente se tributar na nave para endereÃ§o.',0),(221649,6157,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»Ðµ Ð¿Ð¾ Ð°Ð´Ñ€ÐµÑÑƒ.',0),(221650,6157,'es','Solo usado si impone impuestos basado en la direcciÃ³n de enviar-a',0),(221651,6157,'de','Nur verwendet, wenn auf Zustelladresse zu besteuern.',0),(221652,6157,'en','Only used if taxing on ship to address.',0),(221653,6158,'is','',0),(221654,6158,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø­Ù…Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ ',0),(221655,6158,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø­Ù…Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ ',0),(221656,6158,'tr','Vergi sevk yeri adresi',0),(221657,6158,'pl','Adres dostawy podatku',0),(221658,6158,'bg','Ð”Ð°Ð½ÑŠÑ‡ÐµÐ½ Ð°Ð´Ñ€ÐµÑ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(221659,6158,'ur','Ù¾ØªÛ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Ùˆ Ù¹ÛŒÚ©Ø³',0),(221660,6158,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð°Ð´Ñ€ÐµÑÑƒ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(221661,6158,'vi','Thuáº¿ chuyá»ƒn Ä‘áº¿n Ä‘á»‹a chá»‰',0),(221662,6158,'af','Belasting skip-adres',0),(221663,6158,'ro','Taxe livrare-la adresa',0),(221664,6158,'et','Makse saaja aadress',0),(221665,6158,'si','Davka naslov',0),(221666,6158,'ba','Pajak kapal-untuk alamat',0),(221667,6158,'nl','Fiscale verzendadres',0),(221668,6158,'fi','Vero Toimitusasiakkaan osoite',0),(221669,6158,'no','-Lever til-adresse',0),(221670,6158,'da','Skat leveringsadresse',0),(221671,6158,'ko','ì„¸ê¸ˆ ë°°ì†¡ ì£¼ì†Œ',0),(221672,6158,'he','×›×ª×•×‘×ª ×œ×ž×©×œ×•×— ×ž×¡',0),(221673,6158,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Ï†ÏŒÏÎ¿Ï…',0),(221674,6158,'zh','ç¨ŽåŠ¡èˆ°åœ°å€\r\n',0),(221675,6158,'sv','Skatt leveransadress',0),(221676,6158,'it','Indirizzo fiscale',0),(221677,6158,'tl','',0),(221678,6158,'th','&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;',0),(221679,6158,'hi','à¤ªà¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(221680,6158,'ms','Cukai kapal alamat',0),(221681,6158,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù†',0),(221682,6158,'fr','ImpÃ´t-adresse d\'expÃ©dition',0),(221683,6158,'jp','é…?é€?å…ˆä½?æ‰€ã?¸èª²ç¨Ž',0),(221684,6158,'pt','EndereÃ§o de envio-a imposto',0),(221685,6158,'ru','ÐÐ´Ñ€ÐµÑ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹',0),(221686,6158,'es','Impuesto DirecciÃ³n de Enviar-a',0),(221687,6158,'de','Steuer Lieferadresse',0),(221688,6158,'en','Tax Ship-to Address',0),(221689,6159,'is','',0),(221690,6159,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙŠ',0),(221691,6159,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙŠ',0),(221692,6159,'tr','Ek Ã¼cret',0),(221693,6159,'pl','Za dodatkowÄ… opÅ‚atÄ…',0),(221694,6159,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(221695,6159,'ur','Ø§Ø¶Ø§ÙÛŒ Ú†Ø§Ø±Ø¬',0),(221696,6159,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(221697,6159,'vi','PhÃ­ Cá»™ng ThÃªm',0),(221698,6159,'af','Addisionele Heffing',0),(221699,6159,'ro','Cheltuiala aditionala',0),(221700,6159,'et','Lisatasu eest',0),(221701,6159,'si','DoplaÄila',0),(221702,6159,'ba','Biaya Tambahan',0),(221703,6159,'nl','Extra kosten',0),(221704,6159,'fi','LisÃ¤maksu',0),(221705,6159,'no','Tilleggsavgift',0),(221706,6159,'da','Ekstra gebyr',0),(221707,6159,'ko','ì¶”ê°€ ìš”ê¸ˆ',0),(221708,6159,'he','×—×™×•×‘ × ×•×¡×£',0),(221709,6159,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(221710,6159,'zh','é™„åŠ è´¹\r\n',0),(221711,6159,'sv','Ytterligare avgift',0),(221712,6159,'it','Aliquota addizionale',0),(221713,6159,'tl','',0),(221714,6159,'th','&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(221715,6159,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(221716,6159,'ms','Caj tambahan',0),(221717,6159,'ar','Ø±Ø³Ù… Ø¥Ø¶Ø§ÙÙŠ',0),(221718,6159,'fr','Charge SupplÃ©mentaire',0),(221719,6159,'jp','è¿½åŠ æ–™é‡‘',0),(221720,6159,'pt','Custo adicional',0),(221721,6159,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(221722,6159,'es','Cargo Adicional',0),(221723,6159,'de','ZusÃ¤tzliche GebÃ¼hr',0),(221724,6159,'en','Additional Charge',0),(221725,6160,'is','',0),(221726,6160,'dr','Ø´Ø±Ø­ Ø§Ø¶Ø§ÙÙŠ',0),(221727,6160,'pr','Ø´Ø±Ø­ Ø§Ø¶Ø§ÙÙŠ',0),(221728,6160,'tr','Ek aÃ§Ä±klama',0),(221729,6160,'pl','Dodatkowy opis',0),(221730,6160,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(221731,6160,'ur','Ø§Ø¶Ø§ÙÛŒ Ø¨ÛŒØ§Ù†',0),(221732,6160,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ð¾Ð¿Ð¸Ñ',0),(221733,6160,'vi','Diá»…n Giáº£i ThÃªm',0),(221734,6160,'af','Addisionele Beskrywing',0),(221735,6160,'ro','Descriere aditionala',0),(221736,6160,'et','TÃ¤iendav kirjeldus',0),(221737,6160,'si','Dodatni opis',0),(221738,6160,'ba','Keterangan Tambahan',0),(221739,6160,'nl','Extra omschrijving',0),(221740,6160,'fi','LisÃ¤kuvaus',0),(221741,6160,'no','Tilleggsbeskrivelse',0),(221742,6160,'da','Yderligere beskrivelse',0),(221743,6160,'ko','ì¶”ê°€ ì„¤ëª…',0),(221744,6160,'he','×ª××•×¨ × ×•×¡×£',0),(221745,6160,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(221746,6160,'zh','é™„åŠ è¯´æ˜Ž\r\n',0),(221747,6160,'sv','Ytterligare beskrivning',0),(221748,6160,'it','Descrizione aggiuntiva',0),(221749,6160,'tl','',0),(221750,6160,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(221751,6160,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤µà¤¿à¤µà¤°à¤£',0),(221752,6160,'ms','Keterangan tambahan',0),(221753,6160,'ar','ÙˆØµÙ Ø¥Ø¶Ø§ÙÙŠ',0),(221754,6160,'fr','Description Additionelle',0),(221755,6160,'jp','è¿½åŠ èª¬æ˜Ž',0),(221756,6160,'pt','DescriÃ§Ã£o adicional',0),(221757,6160,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(221758,6160,'es','DescripciÃ³n Adicional',0),(221759,6160,'de','ZusÃ¤tzliche Beschreibung',0),(221760,6160,'en','Additional Description',0),(221761,6161,'is','',0),(221762,6161,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(221763,6161,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(221764,6161,'tr','Ä°zleme numarasÄ±',0),(221765,6161,'pl','Numery Å›ledzenia',0),(221766,6161,'bg','ÐÐ¾Ð¼ÐµÑ€Ð°Ñ‚Ð° Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð°',0),(221767,6161,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ù†Ù…Ø¨Ø±',0),(221768,6161,'sr','Ð‘Ñ€Ð¾Ñ˜ÐµÐ²Ðµ Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ',0),(221769,6161,'vi','DÃ² tÃ¬m sá»‘',0),(221770,6161,'af','Spoor Nommers',0),(221771,6161,'ro','Numere de urmÄƒrire',0),(221772,6161,'et','JÃ¤litamisnumbreid',0),(221773,6161,'si','Å tevilke sledenja',0),(221774,6161,'ba','Nomor pelacakan',0),(221775,6161,'nl','Tracking-nummers',0),(221776,6161,'fi','Seurantanumeroiden',0),(221777,6161,'no','Sporingsnumre',0),(221778,6161,'da','Sporingsnumre',0),(221779,6161,'ko','ì¶”ì  ë²ˆí˜¸',0),(221780,6161,'he','×ž×¡×¤×¨×™ ×ž×¢×§×‘',0),(221781,6161,'el','Î™Ï‡Î½Î·Î»Î±ÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î±Ï‚ ÎµÎ¯Î´Î¿Ï…Ï‚',0),(221782,6161,'zh','è¿½è¸ªå·ç \r\n',0),(221783,6161,'sv','UppfÃ¶ljningsnummer',0),(221784,6161,'it','Numeri di registrazione',0),(221785,6161,'tl','',0),(221786,6161,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(221787,6161,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(221788,6161,'ms','Tracking nombor',0),(221789,6161,'ar','Ø£Ø±Ù‚Ø§Ù… Ø§Ù„ØªØ¹Ù‚Ø¨',0),(221790,6161,'fr','NumÃ©ros de suivi',0),(221791,6161,'jp','ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°ç•ªå?·',0),(221792,6161,'pt','Os nÃºmeros de rastreamento',0),(221793,6161,'ru','ÐÐ¾Ð¼ÐµÑ€Ð° Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(221794,6161,'es','NÃºmeros de Rastreo',0),(221795,6161,'de','Tracking-Nummern',0),(221796,6161,'en','Tracking Numbers',0),(221797,6162,'is','',0),(221798,6162,'dr','Ø¬Ø³Ù†Ø¬ÙˆÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø±',0),(221799,6162,'pr','Ø¬Ø³Ù†Ø¬ÙˆÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø±',0),(221800,6162,'tr','MÃ¼ÅŸteri arama bilgileri',0),(221801,6162,'pl','Szukaj informacji o klientach',0),(221802,6162,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(221803,6162,'ur','Ú¯Ø§ÛÚ© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(221804,6162,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ñƒ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(221805,6162,'vi','TÃ¬m ThÃ´ng tin khÃ¡ch hÃ ng',0),(221806,6162,'af','KliÃ«nt/Klant Gesoeke Inligting',0),(221807,6162,'ro','Clientul cautÄƒ informaÅ£ii',0),(221808,6162,'et','Otsi kliendiinfo',0),(221809,6162,'si','Iskanje podatkov o strankah',0),(221810,6162,'ba','Cari informasi pelanggan',0),(221811,6162,'nl','Klanten zoekinformatie',0),(221812,6162,'fi','Etsi asiakastiedot',0),(221813,6162,'no','SÃ¸k kundeinformasjon',0),(221814,6162,'da','SÃ¸geoplysninger, som kunde',0),(221815,6162,'ko','ê³ ê° ê²€ìƒ‰ ì •ë³´',0),(221816,6162,'he','×—×™×¤×•×© ×ž×™×“×¢ ×¢×œ ×œ×§×•×—×•×ª',0),(221817,6162,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(221818,6162,'zh','ç”¨æˆ·æŸ¥è¯¢ä¿¡æ¯\r\n',0),(221819,6162,'sv','SÃ¶k kundinformation',0),(221820,6162,'it','Ricerca informazioni cliente',0),(221821,6162,'tl','',0),(221822,6162,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(221823,6162,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤–à¥‹à¤œ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(221824,6162,'ms','Maklumat Cari pelanggan',0),(221825,6162,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(221826,6162,'fr','Recherche d\'Information client',0),(221827,6162,'jp','é¡§å®¢æ¤œç´¢æƒ…å ±',0),(221828,6162,'pt','InformaÃ§Ãµes de pesquisa do cliente',0),(221829,6162,'ru','ÐŸÐ¾Ð¸ÑÐº Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ðž ÐšÐ»Ð¸ÐµÐ½Ñ‚Ðµ',0),(221830,6162,'es','Cliente InformaciÃ³n de Busqueda',0),(221831,6162,'de','Suche Kundeninformationen',0),(221832,6162,'en','Customer Search Information',0),(221833,6163,'is','',0),(221834,6163,'dr','Ø«Ø¨Øª Ø¨Ø®Ø´ ÙŠØ§ ØªÙ…Ø§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ù†Ø§Ø®ØªÙ‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ',0),(221835,6163,'pr','Ø«Ø¨Øª Ø¨Ø®Ø´ ÙŠØ§ ØªÙ…Ø§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ù†Ø§Ø®ØªÙ‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ',0),(221836,6163,'tr','KÄ±smÄ±nÄ± veya tamamÄ±nÄ± bilinen herhangi bir bilgi girin. Arama iÃ§in',0),(221837,6163,'pl','WprowadÅº czÄ™Å›Ä‡ lub caÅ‚oÅ›Ä‡ wszelkie znane informacje. do wyszukiwania',0),(221838,6163,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ†ÑÐ»Ð¾Ñ‚Ð¾ Ð¸Ð»Ð¸ Ñ‡Ð°ÑÑ‚ Ð¾Ñ‚ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¸Ð·Ð²ÐµÑÑ‚Ð½Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ. Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(221839,6163,'ur','Ø­ØµÛ ÛŒØ§ ØªÙ…Ø§Ù… Ú©Ø³ÛŒ Ù…Ø¹Ø±ÙˆÙ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û” Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(221840,6163,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð´ÐµÐ¾ Ð¸Ð»Ð¸ ÑÐ²Ðµ Ð¿Ð¾Ð·Ð½Ð°Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ. Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(221841,6163,'vi','Nháº­p 1 pháº§n hay táº¥t cáº£ nhá»¯ng thÃ´ng tin Ä‘Ã£ biáº¿t Ä‘á»ƒ tÃ¬m',0),(221842,6163,'af','Voer gedeelte of alle bekende inligting vir die soektog in',0),(221843,6163,'ro','IntroduceÅ£i o parte sau toate orice informaÅ£ii cunoscute. pentru cÄƒutare',0),(221844,6163,'et','Sisestage osa vÃµi kogu teadaoleva info. Otsing',0),(221845,6163,'si','Vnesite del ali vse vse znane informacije. za iskanje',0),(221846,6163,'ba','Masukkan sebagian atau semua info dikenal. untuk pencarian',0),(221847,6163,'nl','Voer deel of het geheel van alle bekende info. voor zoeken',0),(221848,6163,'fi','SyÃ¶tÃ¤ kaikki tunnetut tiedot kokonaan tai osittain. haku',0),(221849,6163,'no','Angi deler av eller hele noen kjente info. for sÃ¸k',0),(221850,6163,'da','Indtast hele eller dele af nogen kendte info. til sÃ¸gning',0),(221851,6163,'ko','ì–´ë–¤ ì•Œë ¤ì§„ ì •ë³´ì˜ ì „ë¶€ ë˜ëŠ” ì¼ë¶€ë¥¼ ìž…ë ¥ í•©ë‹ˆë‹¤. ê²€ìƒ‰ì— ëŒ€ í•œ',0),(221852,6163,'he','×”×–×Ÿ ×‘×—×œ×§ ××• ×›×œ ×ž×™×“×¢ ×”×™×“×•×¢. ×œ×—×™×¤×•×©',0),(221853,6163,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼Î­ÏÎ¿Ï‚ Î® Ï„Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï„Ï‰Î½ Ï„Ï…Ï‡ÏŒÎ½ Î³Î½Ï‰ÏƒÏ„Î­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚. Î³Î¹Î± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(221854,6163,'zh','è¾“å…¥ä»»ä½•å·²çŸ¥æˆ–å…¨éƒ¨ä¿¡æ¯ç”¨äºŽæœç´¢',0),(221855,6163,'sv','Ange hela eller delar av nÃ¥gon kÃ¤nd information. fÃ¶r sÃ¶kning',0),(221856,6163,'it','Immettere tutto o parte del qualsiasi info noto. per la ricerca',0),(221857,6163,'tl','',0),(221858,6163,'th','&#3651;&#3626;&#3656;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;&#3627;&#3619;&#3639;&#3629;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3586;&#3629;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3619;&#3641;&#3657; &#',0),(221859,6163,'hi','à¤­à¤¾à¤— à¤¯à¤¾ à¤¸à¤­à¥€ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤œà¥à¤žà¤¾à¤¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ',0),(221860,6163,'ms','Masukkan sebahagian atau mana-mana maklumat yang diketahui. untuk carian',0),(221861,6163,'ar','Ø§Ø¯Ø®Ù„ Ø£ÙŠÙ‘Ø§ Ù…Ù† ( Ø£Ùˆ ÙƒÙ„Ù‘ ) Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ§Ù„ÙŠØ© Ù„Ù„Ø¨Ø­Ù€Ø«',0),(221862,6163,'fr','Entrez tout ou partie de nâ€™importe quelle information connue. pour la recherche',0),(221863,6163,'jp','æ¤œç´¢ã?®ã?Ÿã‚?ã?«ã‚?ã?‹ã?£ã?¦ã?„ã‚‹æƒ…å ±ã‚’å…¨ã?¦ã‚‚ã?—ã??ã?¯ä¸€éƒ¨å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(221864,6163,'pt','Digite parte ou a totalidade de qualquer informaÃ§Ã£o conhecida. para a pesquisa',0),(221865,6163,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ñ‡Ð°ÑÑ‚ÑŒ Ð»ÑŽÐ±Ð¾Ð¹ Ð¸Ð·Ð²ÐµÑÑ‚Ð½Ð¾Ð¹ Ð¸Ð½Ñ„Ð¾. Ð´Ð»Ñ Ð¿Ð¾Ð¸ÑÐºÐ°',0),(221866,6163,'es','Introducir parte o todo de la informaciÃ³n conocida para la busqueda',0),(221867,6163,'de','Geben Sie alle bekannten Informationen ganz oder teilweise. fÃ¼r die Suche',0),(221868,6163,'en','Enter part or all of any known info. for search',0),(221869,6164,'is','',0),(221870,6164,'dr','ÙƒØ¯ Ù¾Ø³ØªÙŠ',0),(221871,6164,'pr','ÙƒØ¯ Ù¾Ø³ØªÙŠ',0),(221872,6164,'tr','Posta Kodu',0),(221873,6164,'pl','Kod pocztowy',0),(221874,6164,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(221875,6164,'ur','Ø¹Ù„Ø§Ù‚Ø§Ø¦ Ù†Ù…Ø¨Ø±',0),(221876,6164,'sr','Ð¿Ð¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(221877,6164,'vi','MÃ£ Zip',0),(221878,6164,'af','Poskode',0),(221879,6164,'ro','cod postal',0),(221880,6164,'et','Postiindeks',0),(221881,6164,'si','poÅ¡tna Å¡tevilka',0),(221882,6164,'ba','Kode pos',0),(221883,6164,'nl','Postcode',0),(221884,6164,'fi','Postinumero',0),(221885,6164,'no','postnummer',0),(221886,6164,'da','Postnummer',0),(221887,6164,'ko','ìš°íŽ¸ ë²ˆí˜¸',0),(221888,6164,'he','×ž×™×§×•×“',0),(221889,6164,'el','Î¤Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(221890,6164,'zh','é‚®æ”¿ç¼–ç ',0),(221891,6164,'sv','Postnummer',0),(221892,6164,'it','Codice postale',0),(221893,6164,'tl','',0),(221894,6164,'th','&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;',0),(221895,6164,'hi','à¤œà¤¼à¤¿à¤ª à¤•à¥‹à¤¡',0),(221896,6164,'ms','poskod',0),(221897,6164,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(221898,6164,'fr','Code postal',0),(221899,6164,'jp','éƒµä¾¿ç•ªå?·',0),(221900,6164,'pt','CÃ³digo Postal',0),(221901,6164,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ Ð¸Ð½Ð´ÐµÐºÑ',0),(221902,6164,'es','CÃ³digo Zip',0),(221903,6164,'de','PLZ',0),(221904,6164,'en','Zip Code',0),(221905,6165,'is','',0),(221906,6165,'dr','Ú†Ùƒ Ù‡Ù…Ù‡',0),(221907,6165,'pr','Ú†Ùƒ Ù‡Ù…Ù‡',0),(221908,6165,'tr','TÃ¼m kontrol',0),(221909,6165,'pl','SprawdÅº wszystkie',0),(221910,6165,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸',0),(221911,6165,'ur','ØªÙ…Ø§Ù… Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(221912,6165,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ²Ðµ',0),(221913,6165,'vi','ÄÃ¡nh dáº¥u táº¥t cáº£',0),(221914,6165,'af','Merk alles',0),(221915,6165,'ro','Verifica toate',0),(221916,6165,'et','Kontrollida kÃµiki',0),(221917,6165,'si','Preverite vse',0),(221918,6165,'ba','Memeriksa semua',0),(221919,6165,'nl','Controleer alle',0),(221920,6165,'fi','Tarkista kaikki',0),(221921,6165,'no','Sjekk alle',0),(221922,6165,'da','Kontrollere alle',0),(221923,6165,'ko','ëª¨ë‘ í™•ì¸',0),(221924,6165,'he','×¡×ž×Ÿ ××ª ×›×œ',0),(221925,6165,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÏŒÎ»ÎµÏ‚',0),(221926,6165,'zh','æ£€æŸ¥æ‰€æœ‰\r\n',0),(221927,6165,'sv','Kontrollera alla',0),(221928,6165,'it','Controllare tutti',0),(221929,6165,'tl','',0),(221930,6165,'th','&#3648;&#3594;&#3655;&#3588;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(221931,6165,'hi','à¤¸à¤­à¥€ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(221932,6165,'ms','Semak semua',0),(221933,6165,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† ÙƒØ§ÙØ©',0),(221934,6165,'fr','Cochez toutes les',0),(221935,6165,'jp','å…¨ã?¦ã‚’ç¢ºèª?',0),(221936,6165,'pt','Verificar todos os',0),(221937,6165,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð²ÑÐµ',0),(221938,6165,'es','Chequear Todo',0),(221939,6165,'de','ÃœberprÃ¼fen Sie alle',0),(221940,6165,'en','Check All',0),(221941,6166,'is','',0),(221942,6166,'dr','ÙØ§ÙŠÙ„ ',0),(221943,6166,'pr','ÙØ§ÙŠÙ„ ',0),(221944,6166,'tr','Dosya',0),(221945,6166,'pl','Plik',0),(221946,6166,'bg','Ð¤Ð°Ð¹Ð»',0),(221947,6166,'ur','Ù…Ø³Ù„',0),(221948,6166,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(221949,6166,'vi','Há»“ sÆ¡',0),(221950,6166,'af','LÃªer',0),(221951,6166,'ro','FiÅŸier',0),(221952,6166,'et','Fail',0),(221953,6166,'si','Datoteke',0),(221954,6166,'ba','File',0),(221955,6166,'nl','Bestand',0),(221956,6166,'fi','Tiedosto',0),(221957,6166,'no','Filen',0),(221958,6166,'da','Fil',0),(221959,6166,'ko','íŒŒì¼',0),(221960,6166,'he','×§×•×‘×¥',0),(221961,6166,'el','Î‘ÏÏ‡ÎµÎ¯Î¿',0),(221962,6166,'zh','æ–‡ä»¶\r\n',0),(221963,6166,'sv','Fil',0),(221964,6166,'it','File',0),(221965,6166,'tl','',0),(221966,6166,'th','&#3652;&#3615;&#3621;&#3660;',0),(221967,6166,'hi','à¤«à¤¼à¤¾à¤‡à¤²',0),(221968,6166,'ms','Fail',0),(221969,6166,'ar','Ø§Ù„Ù…Ù„Ù',0),(221970,6166,'fr','Fichier',0),(221971,6166,'jp','ãƒ•ã‚¡ã‚¤ãƒ«',0),(221972,6166,'pt','Arquivo',0),(221973,6166,'ru','Ð¤Ð°Ð¹Ð»',0),(221974,6166,'es','Archivo',0),(221975,6166,'de','Datei',0),(221976,6166,'en','File',0),(221977,6167,'is','',0),(221978,6167,'dr','ÙØ§ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(221979,6167,'pr','ÙØ§ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(221980,6167,'tr','Dosyalar baÅŸarÄ±yla silindi.',0),(221981,6167,'pl','Pliki usuniÄ™te pomyÅ›lnie.',0),(221982,6167,'bg','Ð¤Ð°Ð¹Ð»Ð¾Ð²Ðµ, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(221983,6167,'ur','Ù…Ø³Ù„ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ ÛÛ’ Û”',0),(221984,6167,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(221985,6167,'vi','XÃ³a Há»“ sÆ¡ thÃ nh cÃ´ng',0),(221986,6167,'af','LÃªers suksesvol geskrap.',0),(221987,6167,'ro','Dosar ÅŸters cu succes.',0),(221988,6167,'et','Failid edukalt kustutatud.',0),(221989,6167,'si','Pila izbrisati uspeÅ¡no.',0),(221990,6167,'ba','File dihapus berhasil.',0),(221991,6167,'nl','Bestanden met succes verwijderd.',0),(221992,6167,'fi','Tiedostot poistettu.',0),(221993,6167,'no','Filer slettet.',0),(221994,6167,'da','Filer slettet.',0),(221995,6167,'ko','íŒŒì¼ì´ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(221996,6167,'he','.×”×§×‘×¦×™× × ×ž×—×§×• ×‘×”×¦×œ×—×”',0),(221997,6167,'el','Î‘ÏÏ‡ÎµÎ¯Î± Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚.',0),(221998,6167,'zh','æ–‡ä»¶åˆ é™¤æˆåŠŸã€‚\r\n',0),(221999,6167,'sv','Filer som tagits bort.',0),(222000,6167,'it','File eliminati con successo.',0),(222001,6167,'tl','',0),(222002,6167,'th','&#3621;&#3610;&#3649;&#3615;&#3657;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(222003,6167,'hi','à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¥€à¥¤',0),(222004,6167,'ms','Fail-fail yang dihapuskan dengan jayanya.',0),(222005,6167,'ar','Ø­Ø°ÙØª Ø§Ù„Ù…Ù„ÙØ§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(222006,6167,'fr','Fichiers supprimÃ©s avec succÃ¨s.',0),(222007,6167,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(222008,6167,'pt','Arquivos excluÃ­dos com Ãªxito.',0),(222009,6167,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹.',0),(222010,6167,'es','Files eliminados exitosamente',0),(222011,6167,'de','Dateien erfolgreich gelÃ¶scht.',0),(222012,6167,'en','Files deleted successfully.',0),(222013,6168,'is','',0),(222014,6168,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù†Ø¯ ',0),(222015,6168,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù†Ø¯ ',0),(222016,6168,'tr','YÃ¼klenen dosyalar',0),(222017,6168,'pl','Pliki przesÅ‚ane',0),(222018,6168,'bg','ÐšÐ°Ñ‡ÐµÐ½Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(222019,6168,'ur','Ù…Ø³Ù„ÛŒÚº Ø§Ø¨ Ù„ÙˆÚˆ',0),(222020,6168,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ð¸Ñ… Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(222021,6168,'vi','Táº£i Há»“ sÆ¡',0),(222022,6168,'af','LÃªers Opgelaai',0),(222023,6168,'ro','FiÅŸierele Ã®ncÄƒrcate',0),(222024,6168,'et','Faile Ã¼les laadida',0),(222025,6168,'si','Datoteke naloÅ¾ili',0),(222026,6168,'ba','File upload',0),(222027,6168,'nl','Bestanden geupload',0),(222028,6168,'fi','Ladatut tiedostot',0),(222029,6168,'no','Filer lastet opp',0),(222030,6168,'da','Filer uploadet',0),(222031,6168,'ko','íŒŒì¼ ì—…ë¡œë“œ',0),(222032,6168,'he','×”×§×‘×¦×™× ×”×ž×•×¢×œ×™×',0),(222033,6168,'el','Î‘ÏÏ‡ÎµÎ¯Î± Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Î½ÎµÎ²Î¬ÏƒÎµÎ¹',0),(222034,6168,'zh','æ–‡ä»¶ä¸Šä¼ \r\n',0),(222035,6168,'sv','Uppladdade filer',0),(222036,6168,'it','File caricati',0),(222037,6168,'tl','',0),(222038,6168,'th','&#3629;&#3633;&#3614;&#3650;&#3627;&#3621;&#3604;&#3652;&#3615;&#3621;&#3660;',0),(222039,6168,'hi','à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¥€ à¤—à¤ˆ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(222040,6168,'ms','Fail-fail yang dimuat naik',0),(222041,6168,'ar','Ø­Ù…Ù‘Ù„Øª Ø§Ù„Ù…Ù„ÙØ§Øª',0),(222042,6168,'fr','Fichiers tÃ©lÃ©chargÃ©s',0),(222043,6168,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?Œã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(222044,6168,'pt','Arquivos enviados',0),(222045,6168,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ Ð—Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ñ‹',0),(222046,6168,'es','Files Subidos',0),(222047,6168,'de','Hochgeladene Dateien',0),(222048,6168,'en','Files Uploaded',0),(222049,6169,'is','',0),(222050,6169,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®  Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù†Ø¯',0),(222051,6169,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ®  Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù†Ø¯',0),(222052,6169,'tr','BugÃ¼ne kadar yÃ¼klenen dosyalar',0),(222053,6169,'pl','Pliki przesÅ‚ane do tej pory',0),(222054,6169,'bg','Ð¤Ð°Ð¹Ð»Ð¾Ð²ÐµÑ‚Ðµ, ÐºÐ°Ñ‡ÐµÐ½Ð¸ Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(222055,6169,'ur','Ù…Ø³Ù„ÙˆÚº Ú©Û’ Ù„ÛŒÛ’ ØªØ§Ø±ÛŒØ® Ù…ÛŒÚº Ø§Ù¾ Ù„ÙˆÚˆ ÛÙˆØªÛŒ',0),(222056,6169,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð° Ð´Ð°Ñ‚ÑƒÐ¼',0),(222057,6169,'vi','Táº£i Há»“ sÆ¡ Ä‘áº¿n ngÃ y',0),(222058,6169,'af','LÃªers tot op Datum Opgelaai',0),(222059,6169,'ro','FiÅŸierele Ã®ncÄƒrcate la data',0),(222060,6169,'et','Faile Ã¼les laadida kuupÃ¤ev',0),(222061,6169,'si','Datoteke naloÅ¾ili na datum',0),(222062,6169,'ba','File upload to-Date',0),(222063,6169,'nl','Bestanden geÃ¼pload naar datum',0),(222064,6169,'fi','Tiedostoja ladataan pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(222065,6169,'no','Filer lastet opp til dato',0),(222066,6169,'da','Filer, der uploades til dato',0),(222067,6169,'ko','ë‚ ì§œì— ì—…ë¡œë“œ ëœ íŒŒì¼',0),(222068,6169,'he','×§×‘×¦×™× ×©×”×•×¢×œ×• ×¢×“ ×›×”',0),(222069,6169,'el','Î‘ÏÏ‡ÎµÎ¯Î± Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Î½ÎµÎ²Î¬ÏƒÎµÎ¹ Î¼Î­Ï‡ÏÎ¹ ÏƒÎ®Î¼ÎµÏÎ±',0),(222070,6169,'zh','æ–‡ä»¶ä¸Šä¼ åˆ°æ—¥æœŸ\r\n',0),(222071,6169,'sv','Filer som laddas upp till datum',0),(222072,6169,'it','File caricati data',0),(222073,6169,'tl','',0),(222074,6169,'th','&#3629;&#3633;&#3614;&#3650;&#3627;&#3621;&#3604;&#3652;&#3615;&#3621;&#3660; &#3603; &#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(222075,6169,'hi','à¤¤à¤¿à¤¥à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¥€ à¤—à¤ˆ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(222076,6169,'ms','Fail-fail yang dimuat naik ke tarikh',0),(222077,6169,'ar','Ø§Ù„Ù…Ù„ÙØ§Øª Ø§Ù„Ù…Ø­Ù…Ù‘Ù„Ø© Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†  ',0),(222078,6169,'fr','Fichiers tÃ©lÃ©chargÃ©s Ã  ce jour',0),(222079,6169,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?Œæœ€æ–°ã?«ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(222080,6169,'pt','Arquivos enviados atÃ© Ã  data',0),(222081,6169,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ Ð—Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ñ‹ Ð¿Ð¾ Ð”Ð°Ñ‚Ðµ',0),(222082,6169,'es','Files Subidos a la Fecha',0),(222083,6169,'de','Bisher hochgeladenen Dateien',0),(222084,6169,'en','Files Uploaded to Date',0),(222085,6170,'is','',0),(222086,6170,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ Ø¨Ø§ Ø®Ø·Ø§Ù‡Ø§',0),(222087,6170,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ Ø¨Ø§ Ø®Ø·Ø§Ù‡Ø§',0),(222088,6170,'tr','HatalÄ± dosyalar',0),(222089,6170,'pl','Pliki z bÅ‚Ä™dami',0),(222090,6170,'bg','Ð¤Ð°Ð¹Ð»Ð¾Ð²Ðµ Ñ Ð³Ñ€ÐµÑˆÐºÐ¸',0),(222091,6170,'ur','Ù†Ù‚Ø§Ø¦Øµ Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ø³Ù„ÛŒÚº',0),(222092,6170,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÑÐ° Ð³Ñ€ÐµÑˆÐºÐ°Ð¼Ð°',0),(222093,6170,'vi','Há»“ sÆ¡ cÃ³ lá»—i',0),(222094,6170,'af','LÃªers met Foute',0),(222095,6170,'ro','FiÅŸiere cu erori',0),(222096,6170,'et','Failid on tÃµrgetega',0),(222097,6170,'si','Datoteke z napakami',0),(222098,6170,'ba','File dengan kesalahan',0),(222099,6170,'nl','Bestanden met fouten',0),(222100,6170,'fi','VirheitÃ¤ sisÃ¤ltÃ¤vÃ¤t tiedostot',0),(222101,6170,'no','Filer med feil',0),(222102,6170,'da','Filer med fejl',0),(222103,6170,'ko','ì˜¤ë¥˜ íŒŒì¼',0),(222104,6170,'he','×§×‘×¦×™× ×¢× ×©×’×™××•×ª',0),(222105,6170,'el','Î‘ÏÏ‡ÎµÎ¯Î± Î¼Îµ Î»Î¬Î¸Î·',0),(222106,6170,'zh','æ–‡ä»¶é”™è¯¯\r\n',0),(222107,6170,'sv','Filer med fel',0),(222108,6170,'it','File con errori',0),(222109,6170,'tl','',0),(222110,6170,'th','&#3652;&#3615;&#3621;&#3660;&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(222111,6170,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤µà¤¾à¤²à¥€ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(222112,6170,'ms','Fail dengan ralat',0),(222113,6170,'ar','Ù…Ù„ÙØ§Øª ØªØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ Ø£Ø®Ø·Ø§Ø¡',0),(222114,6170,'fr','Fichiers avec Erreurs',0),(222115,6170,'jp','ã‚¨ãƒ©ãƒ¼ãƒ•ã‚¡ã‚¤ãƒ«',0),(222116,6170,'pt','Arquivos com erros',0),(222117,6170,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ Ñ ÐžÑˆÐ¸Ð±ÐºÐ°Ð¼Ð¸',0),(222118,6170,'es','Files con errores',0),(222119,6170,'de','Dateien mit Fehlern',0),(222120,6170,'en','Files with Errors',0),(222121,6171,'is','',0),(222122,6171,'dr','Ù…Ø­Ø¯ÙˆØ¯',0),(222123,6171,'pr','Ù…Ø­Ø¯ÙˆØ¯',0),(222124,6171,'tr','SÄ±nÄ±rÄ±',0),(222125,6171,'pl','SpÃ³Å‚ka z ograniczonÄ… odpowiedzialnoÅ›ciÄ…',0),(222126,6171,'bg','Ð“Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(222127,6171,'ur','Ø­Ø¯',0),(222128,6171,'sr','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÑšÐµ',0),(222129,6171,'vi','Giá»›i háº¡n',0),(222130,6171,'af','Limiet',0),(222131,6171,'ro','LimitÄƒ',0),(222132,6171,'et','Piir',0),(222133,6171,'si','Omejitev',0),(222134,6171,'ba','Batas',0),(222135,6171,'nl','Limiet',0),(222136,6171,'fi','Raja',0),(222137,6171,'no','Grense',0),(222138,6171,'da','GrÃ¦nse',0),(222139,6171,'ko','ì œí•œ',0),(222140,6171,'he','×ž×’×‘×œ×”',0),(222141,6171,'el','ÎŒÏÎ¹Î¿',0),(222142,6171,'zh','é™é¢\r\n',0),(222143,6171,'sv','GrÃ¤ns',0),(222144,6171,'it','Limite',0),(222145,6171,'tl','',0),(222146,6171,'th','&#3592;&#3635;&#3585;&#3633;&#3604;',0),(222147,6171,'hi','à¤¸à¥€à¤®à¤¾',0),(222148,6171,'ms','Had',0),(222149,6171,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰',0),(222150,6171,'fr','Limite',0),(222151,6171,'jp','é™?åº¦',0),(222152,6171,'pt','Limite',0),(222153,6171,'ru','ÐŸÑ€ÐµÐ´ÐµÐ»',0),(222154,6171,'es','Limitar',0),(222155,6171,'de','Grenzwert',0),(222156,6171,'en','Limit',0),(222157,6172,'is','',0),(222158,6172,'dr','Ù‡ÙŠÚ† ÙØ§ÙŠÙ„ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(222159,6172,'pr','Ù‡ÙŠÚ† ÙØ§ÙŠÙ„ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(222160,6172,'tr','HiÃ§bir dosya seÃ§ilmedi.',0),(222161,6172,'pl','Å»adne pliki nie zostaÅ‚y wybrane.',0),(222162,6172,'bg','ÐÑÐ¼Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ ÑÐ° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸.',0),(222163,6172,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø³Ù„ÛŒÚº Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ Ú¯ÛŒØ§ ØªÚ¾Ø§ Û”',0),(222164,6172,'sr','ÐÐµÐ¼Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð¸ÑÑƒ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ.',0),(222165,6172,'vi','ChÆ°a chá»n há»“ sÆ¡',0),(222166,6172,'af','Geen LÃªers was geselekteer',0),(222167,6172,'ro','FiÅŸiere nu au fost selectate.',0),(222168,6172,'et','Faile pole valitud.',0),(222169,6172,'si','Ni datotek so bili izbrani.',0),(222170,6172,'ba','File tidak dipilih.',0),(222171,6172,'nl','Geen bestanden zijn geselecteerd.',0),(222172,6172,'fi','YhtÃ¤Ã¤n tiedostoa ei valittu.',0),(222173,6172,'no','Ingen filer er merket.',0),(222174,6172,'da','Ingen filer blev valgt.',0),(222175,6172,'ko','íŒŒì¼ì´ ì„ íƒ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(222176,6172,'he','.×œ× × ×‘×—×¨×• ×©×•× ×§×‘×¦×™×',0),(222177,6172,'el','Î¤Î± Î±ÏÏ‡ÎµÎ¯Î± Î´ÎµÎ½ ÎµÏ€ÎµÎ»Î­Î³Î·ÏƒÎ±Î½.',0),(222178,6172,'zh','æ²¡æœ‰æ–‡ä»¶è¢«é€‰ä¸­ã€‚\r\n',0),(222179,6172,'sv','Inga filer valdes.',0),(222180,6172,'it','Nessun file sono stato selezionato.',0),(222181,6172,'tl','',0),(222182,6172,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3615;&#3621;&#3660;',0),(222183,6172,'hi','à¤•à¥‹à¤ˆ à¤«à¤¼à¤¾à¤‡à¤² à¤šà¤¯à¤¨à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¥à¥‡à¥¤',0),(222184,6172,'ms','Tiada fail telah dipilih.',0),(222185,6172,'ar','ØªÙ… ØªØ­Ø¯ÙŠØ¯ Ø£ÙŠØ© Ù…Ù„ÙØ§Øª.',0),(222186,6172,'fr','Aucun fichier sÃ©lectionnÃ©.',0),(222187,6172,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?Œé?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(222188,6172,'pt','NÃ£o hÃ¡ arquivos foram selecionados.',0),(222189,6172,'ru','ÐÐµÑ‚ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ñ„Ð°Ð¹Ð»Ð¾Ð².',0),(222190,6172,'es','No se seleccionaron unos files',0),(222191,6172,'de','Keine Dateien ausgewÃ¤hlt wurden.',0),(222192,6172,'en','No files were selected.',0),(222193,6173,'is','',0),(222194,6173,'dr','/ Ø¢Ù¾Ù„ÙˆØ¯ / Ø­Ø°Ù ',0),(222195,6173,'pr','Ù†Ù…Ø§ÙŠØ´ / Ø¢Ù¾Ù„ÙˆØ¯ / Ø­Ø°Ù ',0),(222196,6173,'tr','GÃ¶rÃ¼nÃ¼m/Upload/Sil',0),(222197,6173,'pl','Widok/Upload/Delete',0),(222198,6173,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´/ÐºÐ°Ñ‡Ð²Ð°Ð½Ðµ/Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(222199,6173,'ur','Ù…Ù†Ø¸Ø±/Ø§Ù¾ Ù„ÙˆÚˆ/Ø­Ø°Ù Ú©Ø±ÛŒÚº Û”',0),(222200,6173,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·/Ð£Ð¿Ð»Ð¾Ð°Ð´/Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸',0),(222201,6173,'vi','Xem/táº£i/xÃ³a',0),(222202,6173,'af','Besigtig/Oplaai/Skrap',0),(222203,6173,'ro','Vezi/Ã®ncÄƒrcare/sterge',0),(222204,6173,'et','Vaata/Uuenda/Kustuta',0),(222205,6173,'si','Brisanje/View/Upload',0),(222206,6173,'ba','Lihat/Upload/menghapus',0),(222207,6173,'nl','Weergave/uploaden/verwijderen',0),(222208,6173,'fi','NÃ¤ytÃ¤, Lataa tai poistaa',0),(222209,6173,'no','Vise/laste opp/slette',0),(222210,6173,'da','Se/Upload/slet',0),(222211,6173,'ko','ë³´ê¸°/ì—…ë¡œë“œ/ì‚­ì œ',0),(222212,6173,'he','×”×¦×’/×˜×¢×™× ×”/×ž×—×§',0),(222213,6173,'el','Î ÏÎ¿Î²Î¿Î»Î®/Upload/Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(222214,6173,'zh','æŸ¥çœ‹/ä¸Šä¼ /åˆ é™¤\r\n',0),(222215,6173,'sv','Visa/ladda upp/ta bort',0),(222216,6173,'it','Vista/Upload/elimina',0),(222217,6173,'tl','',0),(222218,6173,'th','&#3649;&#3626;&#3604;&#3591;/&#3629;&#3633;&#3614;&#3650;&#3627;&#3621;&#3604;/&#3621;&#3610;',0),(222219,6173,'hi','à¤¦à¥ƒà¤¶à¥à¤¯/à¤…à¤ªà¤²à¥‹à¤¡/à¤¹à¤Ÿà¤¾à¤à¤',0),(222220,6173,'ms','Lihat/Upload/Hapus',0),(222221,6173,'ar','Ø¹Ø±Ø¶/ØªØ­Ù…ÙŠÙ„/Ø­Ø°Ù',0),(222222,6173,'fr','Consulter/tÃ©lÃ©charger/supprimer',0),(222223,6173,'jp','è¡¨ç¤º/ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰/æ¶ˆåŽ»',0),(222224,6173,'pt','Visualizar/Upload/excluir',0),(222225,6173,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ð—Ð°Ð³Ñ€ÑƒÐ·ÐºÐ°/Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ',0),(222226,6173,'es','Ver/Subir/Eliminar',0),(222227,6173,'de','Anzeigen/Upload/lÃ¶schen',0),(222228,6173,'en','View/Upload/Delete',0),(222229,6174,'is','',0),(222230,6174,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² Ø¢Ù¾Ù„ÙˆØ¯ ÙŠÙƒÙŠ Ø¯ÙŠÚ¯Ø± Ø§Ø² Ø¢Ù† Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ ',0),(222231,6174,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² Ø¢Ù¾Ù„ÙˆØ¯ ÙŠÙƒÙŠ Ø¯ÙŠÚ¯Ø± Ø§Ø² Ø¢Ù† Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ ',0),(222232,6174,'tr','Yeni bir yÃ¼klemeden Ã¶nce dosyayÄ± silmeniz gerekir.',0),(222233,6174,'pl','Plik naleÅ¼y usunÄ…Ä‡ przed przesÅ‚aniem na nowÄ….',0),(222234,6174,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð»Ð° Ð¿Ñ€ÐµÐ´Ð¸ ÐºÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð².',0),(222235,6174,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù†ÛŒØ§ Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ø§ÛŒÚ© Ù…Ø³Ù„ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’ Û”',0),(222236,6174,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð¿Ñ€Ðµ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ð°ÑšÐ° Ð½Ð¾Ð²Ð¾Ð³.',0),(222237,6174,'vi','Báº¡n pháº£i xÃ³a 1 há»“ sÆ¡ trÆ°á»›c khi táº£i cÃ¡i má»›i',0),(222238,6174,'af','U moet \'n LÃªER uitwis voordat u \'n nuwe EEN op kan laai.',0),(222239,6174,'ro','Trebuie sÄƒ ÅŸtergeÅ£i un fiÅŸier Ã®nainte de a Ã®ncÄƒrca unul nou',0),(222240,6174,'et','Pead dokumendi enne kustutama, kui lisad uue',0),(222241,6174,'si','Morate izbrisati datoteke pred nalaganjem novega.',0),(222242,6174,'ba','Anda harus menghapus file sebelum meng-upload yang baru.',0),(222243,6174,'nl','Voor het uploaden van een nieuwe transactie moet u een bestand verwijderen.',0),(222244,6174,'fi','Tiedosto on poistettava ennen lÃ¤hettÃ¤mistÃ¤ uuteen.',0),(222245,6174,'no','Du mÃ¥ slette en fil fÃ¸r du laster opp en ny.',0),(222246,6174,'da','Du skal slette en fil fÃ¸r du uploader et nyt.',0),(222247,6174,'ko','ìƒˆë¡œìš´ í•˜ë‚˜ë¥¼ ì—…ë¡œë“œ í•˜ê¸° ì „ì— íŒŒì¼ì„ ì‚­ì œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(222248,6174,'he','×¢×œ×™×š ×œ×ž×—×•×§ ××ª ×§×•×‘×¥ ×œ×¤× ×™ ×˜×¢×™× ×” ×—×“×©×”.',0),(222249,6174,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î· Î¼ÎµÏ„Î±Ï†ÏŒÏÏ„Ï‰ÏƒÎ· Î­Î½Î± ÎºÎ±Î¹Î½Î¿ÏÏÎ³Î¹Î¿.',0),(222250,6174,'zh','æ‚¨å¿…é¡»åœ¨ä¸Šä¼ ä¸€ä¸ªæ–°æ–‡ä»¶å‰å…ˆåˆ é™¤ä¸€ä¸ªã€‚\r\n',0),(222251,6174,'sv','Du mÃ¥ste ta bort en fil innan du lÃ¤gger upp en ny.',0),(222252,6174,'it','Ãˆ necessario eliminare un file prima di caricare una nuova.',0),(222253,6174,'tl','',0),(222254,6174,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3621;&#3610;&#3652;&#3615;&#3621;&#3660;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3629;&#3633;&#3614;&#3650;&#3627;&#3621;&#3604;&#3588;&#3619;&#3633;&#3657;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(222255,6174,'hi','à¤†à¤ª à¤à¤• à¤¨à¤¯à¤¾ à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤•à¥‹à¤ˆ à¤«à¤¼à¤¾à¤‡à¤² à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(222256,6174,'ms','Anda mesti menghapuskan fail sebelum meng-upload yang baru.',0),(222257,6174,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø­Ø°Ù Ù…Ù„ÙÙ‘ Ù‚Ø¨Ù„ ØªØ­Ù…ÙŠÙ„ Ø¢Ø®Ø± Ø¬Ø¯ÙŠØ¯',0),(222258,6174,'fr','Vous devez supprimer un fichier avant de tÃ©lÃ©charger un nouveau.',0),(222259,6174,'jp','æ–°è¦?ã‚‚ã?®ã‚’ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã?™ã‚‹å‰?ã?«æ¶ˆåŽ»ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(222260,6174,'pt','VocÃª deve excluir um arquivo antes de enviar um novo.',0),(222261,6174,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» Ð¿ÐµÑ€ÐµÐ´ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¾Ð¹ Ð½Ð¾Ð²Ð¾Ð³Ð¾.',0),(222262,6174,'es','Debe borrar el archivo antes de cargar uno nuevo.',0),(222263,6174,'de','Sie mÃ¼ssen eine Datei lÃ¶schen, vor dem Hochladen einer neuen.',0),(222264,6174,'en','You must delete a file before uploading a new one.',0),(222265,6175,'is','',0),(222266,6175,'dr','Ù‡ÙŠÚ† Ù…Ø´Ø®ØµØ§Øª ÙØ§ÙŠÙ„ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(222267,6175,'pr','Ù‡ÙŠÚ† Ù…Ø´Ø®ØµØ§Øª ÙØ§ÙŠÙ„ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(222268,6175,'tr','HiÃ§bir dosya tanÄ±mÄ± henÃ¼z belirlenmedi.',0),(222269,6175,'pl','Nie definicji pliku jest ustawiony.',0),(222270,6175,'bg','ÐÑÐ¼Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐ½.',0),(222271,6175,'ur','Ù…Ø³Ù„ Ú©ÛŒ Ú©ÙˆØ¦ÛŒ ØªØ¹Ø±ÛŒÙ Ù…Ù‚Ø±Ø± Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(222272,6175,'sr','ÐÐµÐ¼Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½.',0),(222273,6175,'vi','ChÆ°a Ä‘áº·t Ä‘á»‹nh nghÄ©a há»“ sÆ¡',0),(222274,6175,'af','Geen LÃªerdefinisie was gestel.',0),(222275,6175,'ro','O definiÅ£ie de fiÅŸier a fost stabilit.',0),(222276,6175,'et','MÃ¤Ã¤ratlemata faili seada.',0),(222277,6175,'si','Nobena datoteka opredelitev je bila nastavljena.',0),(222278,6175,'ba','Tidak ada file definisi telah ditetapkan.',0),(222279,6175,'nl','Geen bestandsdefinitie is vastgesteld.',0),(222280,6175,'fi','Ole tiedoston mÃ¤Ã¤ritelmÃ¤Ã¤ ei ole asetettu.',0),(222281,6175,'no','Ingen definisjon er angitt.',0),(222282,6175,'da','Ingen fil definition er angivet.',0),(222283,6175,'ko','íŒŒì¼ ì •ì˜ ì„¤ì • ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(222284,6175,'he','×”×’×“×¨×ª ×§×•×‘×¥ ×œ× ×”×•×’×“×¨.',0),(222285,6175,'el','ÎšÎ±Î½Î­Î½Î±Ï‚ Î¿ÏÎ¹ÏƒÎ¼ÏŒÏ‚ Î±ÏÏ‡ÎµÎ¯Î¿ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯.',0),(222286,6175,'zh','æ–‡ä»¶çš„å®šä¹‰è¿˜æ²¡æœ‰è®¾ç½®ã€‚\r\n',0),(222287,6175,'sv','Ingen fildefinition har stÃ¤llts in.',0),(222288,6175,'it','Nessuna definizione di file Ã¨ stata impostata.',0),(222289,6175,'tl','',0),(222290,6175,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3652;&#3615;&#3621;&#3660;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3652;&#3623;&#3657;&#3649;&#3621;&#3657;&#3623;',0),(222291,6175,'hi','à¤•à¥‹à¤ˆ à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(222292,6175,'ms','Tiada fail definisi telah ditetapkan.',0),(222293,6175,'ar','ÙˆÙ‚Ø¯ ØªÙ… ØªØ¹ÙŠÙŠÙ† Ø£ÙŠ Ù…Ù„Ù ØªØ¹Ø±ÙŠÙ.',0),(222294,6175,'fr','Aucune dÃ©finition de fichier n\'a Ã©tÃ© crÃ©Ã©e.',0),(222295,6175,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?®å®šç¾©ã?Œè¨­å®šã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(222296,6175,'pt','NÃ£o hÃ¡ definiÃ§Ã£o de arquivo tiver sido definida.',0),(222297,6175,'ru','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ñ„Ð°Ð¹Ð»Ð° Ð½Ðµ Ð±Ñ‹Ð»Ð¾ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾.',0),(222298,6175,'es','No se configurÃ³ una definiciÃ³n del file',0),(222299,6175,'de','Keine Dateidefinition wurde festgelegt.',0),(222300,6175,'en','No file definition has been set.',0),(222301,6176,'is','',0),(222302,6176,'dr',' Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ù‡Ø§',0),(222303,6176,'pr',' Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ù‡Ø§',0),(222304,6176,'tr','YÃ¼kleme dosyalarÄ±',0),(222305,6176,'pl','PrzesyÅ‚anie plikÃ³w',0),(222306,6176,'bg','ÐšÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(222307,6176,'ur','Ù…Ø³Ù„ÛŒÚº Ø§Ø¨ Ù„ÙˆÚˆ',0),(222308,6176,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(222309,6176,'vi','Táº£i há»“ sÆ¡',0),(222310,6176,'af','Opdateer LÃªers',0),(222311,6176,'ro','ÃŽncÄƒrca fiÅŸiere',0),(222312,6176,'et','Faile Ã¼les laadida',0),(222313,6176,'si','Nalaganje datotek',0),(222314,6176,'ba','Meng-upload file',0),(222315,6176,'nl','Bestanden uploaden',0),(222316,6176,'fi','Lataa tiedostoja',0),(222317,6176,'no','Laste opp filer',0),(222318,6176,'da','Uploade filer',0),(222319,6176,'ko','íŒŒì¼ì„ ì—…ë¡œë“œ',0),(222320,6176,'he','×”×¢×œ×” ×§×‘×¦×™×',0),(222321,6176,'el','Î‘Î½ÎµÎ²Î¬ÏƒÎµÏ„Îµ Î±ÏÏ‡ÎµÎ¯Î±',0),(222322,6176,'zh','ä¸Šä¼ æ–‡ä»¶\r\n',0),(222323,6176,'sv','Ladda upp filer',0),(222324,6176,'it','Caricare i file',0),(222325,6176,'tl','',0),(222326,6176,'th','&#3629;&#3633;&#3614;&#3650;&#3627;&#3621;&#3604;&#3652;&#3615;&#3621;&#3660;',0),(222327,6176,'hi','à¤«à¤¾à¤‡à¤²à¥‡à¤‚ à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(222328,6176,'ms','Muat naik fail',0),(222329,6176,'ar','ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ù…Ù„ÙØ§Øª',0),(222330,6176,'fr','TÃ©lÃ©charger des fichiers',0),(222331,6176,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã?®ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰',0),(222332,6176,'pt','Upload de arquivos',0),(222333,6176,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ð¤Ð°Ð¹Ð»Ñ‹',0),(222334,6176,'es','Subir Files',0),(222335,6176,'de','Hochladen von Dateien',0),(222336,6176,'en','Upload Files',0),(222337,6177,'is','',0),(222338,6177,'dr','ØªØ§ÙŠÙŠØ¯ Ø§ØµÙ„Ø§Ø­',0),(222339,6177,'pr','ØªØ§ÙŠÙŠØ¯ Ø§ØµÙ„Ø§Ø­',0),(222340,6177,'tr','AP ayarlama',0),(222341,6177,'pl','Regulacja AP',0),(222342,6177,'bg','AP ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ',0),(222343,6177,'ur','AP Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(222344,6177,'sr','ÐÐŸ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(222345,6177,'vi','Äiá»u Chá»‰nh AP ',0),(222346,6177,'af','RB Aansuiwerings',0),(222347,6177,'ro','AP de ajustare',0),(222348,6177,'et','AP korrigeerimine',0),(222349,6177,'si','AP prilagoditev',0),(222350,6177,'ba','AP penyesuaian',0),(222351,6177,'nl','AP aanpassing',0),(222352,6177,'fi','AP sÃ¤Ã¤tÃ¶',0),(222353,6177,'no','AP justering',0),(222354,6177,'da','AP justering',0),(222355,6177,'ko','Ap = ì—°í•© ë‰´ìŠ¤ ì¡°ì •',0),(222356,6177,'he','×”×ª××ž×ª AP',0),(222357,6177,'el','Î¡ÏÎ¸Î¼Î¹ÏƒÎ· Î±Ï€',0),(222358,6177,'zh','åº”ä»˜è´¦æ¬¾è°ƒæ•´\r\n',0),(222359,6177,'sv','AP justering',0),(222360,6177,'it','Regolazione di AP',0),(222361,6177,'tl','',0),(222362,6177,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(222363,6177,'hi','à¤à¤ªà¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(222364,6177,'ms','AP pelarasan',0),(222365,6177,'ar','AP Ø§Ù„ØªÙƒÙŠÙ',0),(222366,6177,'fr','Ajustement de l\'AP',0),(222367,6177,'jp','APèª¿æ•´',0),(222368,6177,'pt','Ajuste de AP',0),(222369,6177,'ru','Ð ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²ÐºÐ° AP',0),(222370,6177,'es','CP Ajuste',0),(222371,6177,'de','AP-Anpassung',0),(222372,6177,'en','AP Adjustment',0),(222373,6178,'is','',0),(222374,6178,'dr','(Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ) Ø¯Ø± Ù‡Ø± Ø¯ÙˆØ±Ù‡ Ù…Ø¹Ø§Ø´(Ù¾Ø±Ø¯Ø§Ø®Øª)',0),(222375,6178,'pr','Ù…Ù‚Ø¯Ø§Ø± (Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ) Ø¯Ø± Ù‡Ø± Ø¯ÙˆØ±Ù‡ Ø­Ù‚ÙˆÙ‚(Ù¾Ø±Ø¯Ø§Ø®Øª)',0),(222376,6178,'tr','AMT.per Ã¶deme dÃ¶nemi',0),(222377,6178,'pl','Okresie rozliczeniowym Amt.per',0),(222378,6178,'bg','Amt.per Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(222379,6178,'ur','Amt.per Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¯Øª',0),(222380,6178,'sr','ÐÐœÐ¢ .ÐŸÐµÑ€ Ð¿Ð»Ð°Ñ‚Ðµ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(222381,6178,'vi','Sá»‘ Tiá»n Má»—i Ká»³ Thanh ToÃ¡n',0),(222382,6178,'af','Bedr. per Loonperiode',0),(222383,6178,'ro','PerioadÄƒ de platÄƒ AMT.per',0),(222384,6178,'et','Amt.per makseperioodi',0),(222385,6178,'si','Amt.per plaÄi',0),(222386,6178,'ba','Amt.per membayar periode',0),(222387,6178,'nl','Amt.per betalen periode',0),(222388,6178,'fi','AMT.per maksaa aika',0),(222389,6178,'no','Amt.per lÃ¸nnsperioden',0),(222390,6178,'da','Amt.per lÃ¸nperiode',0),(222391,6178,'ko','Amt.per ì§€ë¶ˆ ê¸°ê°„',0),(222392,6178,'he','×ª×§×•×¤×ª ×”×ª×©×œ×•× Amt.per',0),(222393,6178,'el','AMT.per Î¼Î¹ÏƒÎ¸Î¿Î´Î¿Ï„Î¹ÎºÎ®Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(222394,6178,'zh','æ¯ä»½é‡‘é¢æ”¯ä»˜æœŸ\r\n',0),(222395,6178,'sv','AMT.per lÃ¶neperiod',0),(222396,6178,'it','Periodo di paga AMT.per',0),(222397,6178,'tl','',0),(222398,6178,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3656;&#3629;&#3591;&#3623;&#3604;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;',0),(222399,6178,'hi','Amt.per à¤ªà¥‡ à¤…à¤µà¤§à¤¿',0),(222400,6178,'ms','Tempoh pembayaran gaji AMT.per',0),(222401,6178,'ar','ÙØªØ±Ø© Ø§Ù„Ø¯ÙØ¹ Amt.per',0),(222402,6178,'fr','PÃ©riode de paie AMT.per',0),(222403,6178,'jp','æ”¯æ‰•æœŸé–“ã?”ã?¨ã?®ç·?é¡?',0),(222404,6178,'pt','PerÃ­odo de pagamento AMT.per',0),(222405,6178,'ru','AMT.per Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(222406,6178,'es','Cant. por PerÃ­odo de Pago',0),(222407,6178,'de','Amt.per Arbeitsentgelt',0),(222408,6178,'en','Amt.per Pay Period',0),(222409,6179,'is','',0),(222410,6179,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù†Ø±Ø® Ø«Ø§Ø¨Øª ÙƒØ§Ø±ÙØ±Ù…Ø§',0),(222411,6179,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù†Ø±Ø® Ø«Ø§Ø¨Øª ÙƒØ§Ø±ÙØ±Ù…Ø§',0),(222412,6179,'tr','Ä°ÅŸveren depozito tutarÄ±',0),(222413,6179,'pl','Pracodawca zryczaÅ‚towana kwota',0),(222414,6179,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»ÑÑ‚ Ñ„Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ð° ÑÑƒÐ¼Ð°',0),(222415,6179,'ur','Ø¢Ø¬Ø± ÙÙ„ÛŒÙ¹ Ø±ÛŒÙ¹ Ø±Ù‚Ù…',0),(222416,6179,'sr','ÐŸÐ¾ÑÐ»Ð¾Ð´Ð°Ð²Ð°Ñ† Ð¿Ð°ÑƒÑˆÐ°Ð»Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(222417,6179,'vi','GiÃ¡ NhÃ¢n viÃªn pháº³ng',0),(222418,6179,'af','Werkgewer Vaste Tarief Bedrag',0),(222419,6179,'ro','Angajator suma forfetarÄƒ',0),(222420,6179,'et','TÃ¶Ã¶andja kindel summa',0),(222421,6179,'si','Delodajalec pavÅ¡alnega zneska',0),(222422,6179,'ba','Majikan harga rata-rata jumlah',0),(222423,6179,'nl','Werkgever forfaitaire bedrag',0),(222424,6179,'fi','TyÃ¶nantajan kiinteÃ¤ mÃ¤Ã¤rÃ¤',0),(222425,6179,'no','Arbeidsgiver Flat Rate belÃ¸p',0),(222426,6179,'da','Arbejdsgiveren faste belÃ¸b',0),(222427,6179,'ko','ê³ ìš©ì£¼ ì •ì•¡ì œ ê¸ˆì•¡',0),(222428,6179,'he','×›×ž×•×ª ×ª×¢×¨×™×£ ×”×ž×¢×¡×™×§',0),(222429,6179,'el','Î•ÏÎ³Î¿Î´ÏŒÏ„Î· ÎºÎ±Ï„Î„Î±Ï€Î¿ÎºÎ¿Ï€Î® Ï€Î¿ÏƒÎ¿Ï',0),(222430,6179,'zh','é›‡ä¸»å›ºå®šçŽ‡é‡‘é¢\r\n',0),(222431,6179,'sv','Arbetsgivaren schablonmÃ¤ssiga belopp',0),(222432,6179,'it','Datore di lavoro importo forfettario',0),(222433,6179,'tl','',0),(222434,6179,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3591;&#3607;&#3637;&#3656;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3592;&#3657;&#3634;&#3591;',0),(222435,6179,'hi','à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤«à¥à¤²à¥ˆà¤Ÿ à¤¦à¤° à¤°à¤¾à¤¶à¤¿',0),(222436,6179,'ms','Jumlah kadar rata majikan',0),(222437,6179,'ar','ØµØ§Ø­Ø¨ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¹Ø¯Ù„ Ø§Ù„Ø«Ø§Ø¨Øª',0),(222438,6179,'fr','Montant forfaitaire employeur',0),(222439,6179,'jp','é›‡ç”¨ä¸»å®šé¡?æ–™é‡‘é¡?',0),(222440,6179,'pt','Quantidade de taxa fixa do empregador',0),(222441,6179,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ñ„Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð°Ñ ÑÑ‚Ð°Ð²ÐºÐ° Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»Ñ',0),(222442,6179,'es','Empleado Monto de Tasa Fija',0),(222443,6179,'de','Arbeitgeber Pauschalbetrag',0),(222444,6179,'en','Employer Flat Rate Amount',0),(222445,6180,'is','',0),(222446,6180,'dr','Ø¯Ø±ØµØ¯ ÙƒØ§Ø±ÙØ±Ù…Ø§ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…Ø³Ø§Ø¨Ù‚Ø§Øª ',0),(222447,6180,'pr','Ø¯Ø±ØµØ¯ ÙƒØ§Ø±ÙØ±Ù…Ø§ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…Ø³Ø§Ø¨Ù‚Ø§Øª ',0),(222448,6180,'tr','Ä°ÅŸveren yÃ¼zde (ek maÃ§lar)',0),(222449,6180,'pl','Procent pracodawcy (oprÃ³cz meczÃ³w)',0),(222450,6180,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»ÑÑ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° (Ð² Ð´Ð¾Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ ÐºÑŠÐ¼ ÐºÐ¸Ð±Ñ€Ð¸Ñ‚)',0),(222451,6180,'ur','Ø¢Ø¬Ø± ÙÛŒØµØ¯ (Ú©Û’ Ø¹Ù„Ø§ÙˆÛ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº)',0),(222452,6180,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ð¿Ð¾ÑÐ»Ð¾Ð´Ð°Ð²Ð°Ñ† (Ð¿Ð¾Ñ€ÐµÐ´ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ°)',0),(222453,6180,'vi','% chá»§ cty (bÃªn cáº¡nh tráº£ tÆ°Æ¡ng á»©ng sá»‘ tiá»n nhÃ¢n viÃªn tráº£)',0),(222454,6180,'af','Werkgewer Persentasie (buiten gelyksoortige)',0),(222455,6180,'ro','Angajator la sutÄƒ (Ã®n afarÄƒ de meciuri)',0),(222456,6180,'et','TÃ¶Ã¶andja protsent (lisaks vastet)',0),(222457,6180,'si','Delodajalec odstotkov (poleg tekem)',0),(222458,6180,'ba','Majikan persen (selain yang sesuai)',0),(222459,6180,'nl','Werkgever procent (naast wedstrijden)',0),(222460,6180,'fi','TyÃ¶nantajan prosenttia (lisÃ¤ksi ottelua)',0),(222461,6180,'no','Arbeidsgiver prosent (i tillegg til kamper)',0),(222462,6180,'da','Arbejdsgiveren procent (ud over kampe)',0),(222463,6180,'ko','(ê²½ê¸°) ì´ì™¸ì—ë„ ê³ ìš©ì£¼ %',0),(222464,6180,'he','×”×ž×¢×¡×™×§ ××—×•×–×™× (×‘× ×•×¡×£ ×”×ª××ž×•×ª)',0),(222465,6180,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï„Î¿Ï… ÎµÏÎ³Î¿Î´ÏŒÏ„Î· (ÎµÎºÏ„ÏŒÏ‚ Î±Ï€ÏŒ Î±Î³ÏŽÎ½ÎµÏ‚)',0),(222466,6180,'zh','é›‡ä¸»ç™¾åˆ†æ¯”ï¼ˆé™¤åŒ¹é…ï¼‰\r\n',0),(222467,6180,'sv','Arbetsgivaren procent (utÃ¶ver matcher)',0),(222468,6180,'it','Datore di lavoro per cento (oltre a partite)',0),(222469,6180,'tl','',0),(222470,6180,'th','&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3586;&#3629;&#3591;&#3609;&#3634;&#3618;&#3592;&#3657;&#3634;&#3591;(&#3626;&#3656;&#3623;&#3609;&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3627;&#3657;&#3648;&#3586;&#3657;&#3634;&#3585;&#3633;&#3609;)',0),(222471,6180,'hi','à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ (à¤…à¤²à¤¾à¤µà¤¾ à¤®à¥ˆà¤š)',0),(222472,6180,'ms','Peratus majikan (selain perlawanan)',0),(222473,6180,'ar','Ø±Ø¨ Ø§Ù„Ø¹Ù…Ù„ ÙÙŠ Ø§Ù„Ù…Ø§Ø¦Ø© (Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ù…Ø¨Ø§Ø±ÙŠØ§Øª)',0),(222474,6180,'fr','Employeur pour cent (en plus des matches)',0),(222475,6180,'jp','Employer Percent (in addition to matches)',0),(222476,6180,'pt','Por cento do empregador (alÃ©m de jogos)',0),(222477,6180,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»ÑŒ % (Ð¿Ð¾Ð¼Ð¸Ð¼Ð¾ Ð¼Ð°Ñ‚Ñ‡ÐµÐ¹)',0),(222478,6180,'es','Empleado Porcentaje (ademÃ¡s a las emparejas)',0),(222479,6180,'de','Prozent der Arbeitgeber (zusÃ¤tzlich zu Treffern)',0),(222480,6180,'en','Employer Percent (in addition to matches)',0),(222481,6181,'is','',0),(222482,6181,'dr','Ø§Ø² Ø¨Ø§Ù„Ø§ ØªØ§ Ø¯Ø±ØµØ¯ ',0),(222483,6181,'pr','Ø§Ø² Ø¨Ø§Ù„Ø§ ØªØ§ Ø¯Ø±ØµØ¯ ',0),(222484,6181,'tr','YukarÄ±daki kadar yÃ¼zde',0),(222485,6181,'pl','Z gÃ³ry do procent',0),(222486,6181,'bg','ÐžÑ‚ Ð³Ð¾Ñ€Ðµ Ð´Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(222487,6181,'ur','Ø§ÙˆÙ¾Ø± Ø³Û’ ÙÛŒ ØµØ¯ ØªÚ©',0),(222488,6181,'sr','ÐžÐ´Ð¾Ð·Ð³Ð¾ Ð´Ð¾ %',0),(222489,6181,'vi','Tá»« trÃªn Ä‘áº¿n %',0),(222490,6181,'af','Van bo tot persent',0),(222491,6181,'ro','De sus pÃ¢nÄƒ la sutÄƒ',0),(222492,6181,'et','Ãœlevalt kuni protsenti',0),(222493,6181,'si','Od zgoraj do odstotkov',0),(222494,6181,'ba','Dari atas ke persen',0),(222495,6181,'nl','Van boven tot procent',0),(222496,6181,'fi','YlhÃ¤Ã¤ltÃ¤ jopa prosenttia',0),(222497,6181,'no','Ovenfra til prosent',0),(222498,6181,'da','Ovenfra op til procent',0),(222499,6181,'ko','ìœ„ì—ì„œ %ê¹Œì§€',0),(222500,6181,'he','×ž×œ×ž×¢×œ×” ×¢×“ ××—×•×–',0),(222501,6181,'el','Î‘Ï€ÏŒ Ï€Î¬Î½Ï‰ Î¼Î­Ï‡ÏÎ¹ Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(222502,6181,'zh','ä»Žä»¥ä¸Šé«˜è¾¾ç™¾åˆ†æ¯”\r\n',0),(222503,6181,'sv','FrÃ¥n ovan till procent',0),(222504,6181,'it','Dall\'alto fino a per cento',0),(222505,6181,'tl','',0),(222506,6181,'th','&#3592;&#3634;&#3585;&#3586;&#3657;&#3634;&#3591;&#3610;&#3609;&#3586;&#3638;&#3657;&#3609;&#3606;&#3638;&#3591;&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;',0),(222507,6181,'hi','à¤Šà¤ªà¤° à¤¸à¥‡ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¤à¤•',0),(222508,6181,'ms','Dari atas sehingga peratus',0),(222509,6181,'ar','Ù…Ù† Ø£Ø¹Ù„Ø§Ù‡ Ø­ØªÙ‰ Ø§Ù„Ù…Ø¦Ø©',0),(222510,6181,'fr','D\'en haut jusqu\'Ã  %',0),(222511,6181,'jp','From Above up to Percent',0),(222512,6181,'pt','De cima atÃ© por cento',0),(222513,6181,'ru','Ð¡Ð²ÐµÑ€Ñ…Ñƒ Ð´Ð¾ %',0),(222514,6181,'es','De Arriba hasta Porcento',0),(222515,6181,'de','Von oben bis zu Prozent',0),(222516,6181,'en','From Above up to Percent',0),(222517,6182,'is','',0),(222518,6182,'dr','Ø¯Ø±ØµØ¯ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ÙƒØ§Ø±Ù…Ù†Ø¯',0),(222519,6182,'pr','Ø¯Ø±ØµØ¯ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ÙƒØ§Ø±Ù…Ù†Ø¯',0),(222520,6182,'tr','Ä°ÅŸveren tarafÄ±ndan bahisler yÃ¼zde',0),(222521,6182,'pl','Procent dopasowane przez pracodawcÄ™',0),(222522,6182,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°, ÑÑŠÐ¿Ñ€Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð¾Ñ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»',0),(222523,6182,'ur','Ø¢Ø¬Ø± Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ø´Ø§Ø¨Û ÙÛŒØµØ¯',0),(222524,6182,'sr','ÐŸÐ¾ÑÑ‚Ð¾ ÑÐµ Ð¿Ð¾ÐºÐ»Ð°Ð¿Ð°Ñ˜Ñƒ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð¸Ð½Ð²ÐµÑÑ‚Ð¸Ñ‚Ð¾Ñ€Ð°',0),(222525,6182,'vi','Pháº§n trÄƒm Cty thanh toÃ¡n',0),(222526,6182,'af','Persentasie Gelyke deur Werkgewer',0),(222527,6182,'ro','La sutÄƒ egalatÄƒ de angajatorului',0),(222528,6182,'et','VÃ¤ljatÃ¶Ã¶tamisega, tÃ¶Ã¶andja protsent',0),(222529,6182,'si','Odstotkov, pokrite z delodajalcem',0),(222530,6182,'ba','Persen dicocokkan oleh majikan',0),(222531,6182,'nl','Procent geÃ«venaard door werkgever',0),(222532,6182,'fi','Prosenttia hyvÃ¤ksytty tyÃ¶nantaja',0),(222533,6182,'no','Prosent med arbeidsgiver',0),(222534,6182,'da','Procent modsvares af arbejdsgiver',0),(222535,6182,'ko','ê³ ìš©ì£¼ì— ì˜í•´ ì¼ì¹˜ %',0),(222536,6182,'he','××—×•×– ×ž×ª××™×ž×™× ×¢×œ ×™×“×™ ×”×ž×¢×¡×™×§',0),(222537,6182,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï„Î¿ ÏƒÏÎ½Î¿Î»Î¿ ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÎ½ÎµÏ„Î±Î¹ Î±Ï€ÏŒ Ï„Î¿Î½ ÎµÏÎ³Î¿Î´ÏŒÏ„Î·',0),(222538,6182,'zh','é›‡ä¸»åŒ¹é…ç™¾åˆ†æ¯”\r\n',0),(222539,6182,'sv','Procent som matchas av arbetsgivare',0),(222540,6182,'it','Per cento rilevate dal datore di lavoro',0),(222541,6182,'tl','',0),(222542,6182,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3592;&#3633;&#3610;&#3588;&#3641;&#3656;&#3650;&#3604;&#3618;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(222543,6182,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤®à¤¿à¤²à¤¾à¤¨',0),(222544,6182,'ms','Peratus yang dipadankan oleh majikan',0),(222545,6182,'ar','ÙÙŠ Ø§Ù„Ù…Ø¦Ø© ÙŠÙ‚Ø§Ø¨Ù„Ù‡Ø§ ØµØ§Ø­Ø¨ Ø§Ù„Ø¹Ù…Ù„',0),(222546,6182,'fr','% Mis en correspondance par l\'employeur',0),(222547,6182,'jp','é›‡ç”¨ä¸»åˆ¥ä¸€è‡´æ¯”çŽ‡',0),(222548,6182,'pt','Por cento correspondido pelo empregador',0),(222549,6182,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¿Ð¾Ð´ÐºÑ€ÐµÐ¿Ð»ÐµÐ½Ñ‹ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»Ñ',0),(222550,6182,'es','Porcentaje Emparejado por el PatrÃ³n',0),(222551,6182,'de','Prozent durch Arbeitgeber abgestimmt',0),(222552,6182,'en','Percent Matched by Employer',0),(222553,6183,'is','',0),(222554,6183,'dr','Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù† Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(222555,6183,'pr','Ø¨Ù‡ Ù…ÙŠØ²Ø§Ù† Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(222556,6183,'tr','Ã‡alÄ±ÅŸanlarÄ±n yÃ¼zde kadar',0),(222557,6183,'pl','Do pracownika procent',0),(222558,6183,'bg','Ð”Ð¾ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» %',0),(222559,6183,'ur','Ù…Ù„Ø§Ø²Ù… ÙÛŒØµØ¯ ØªÚ©',0),(222560,6183,'sr','Ð—Ð°Ð²Ð¸ÑÐ¸ Ð¾Ð´ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… %',0),(222561,6183,'vi','LÃªn tá»›i % nhÃ¢n viÃªn',0),(222562,6183,'af','Tot en met Werknemer Persentasie',0),(222563,6183,'ro','La angajat %',0),(222564,6183,'et','Kuni tÃ¶Ã¶taja protsent',0),(222565,6183,'si','Do odstotkov zaposlenih',0),(222566,6183,'ba','Hingga persen karyawan',0),(222567,6183,'nl','Tot werknemer procent',0),(222568,6183,'fi','Jopa tyÃ¶ntekijÃ¤n prosenttia',0),(222569,6183,'no','Til ansatte prosent',0),(222570,6183,'da','Op til medarbejder procent',0),(222571,6183,'ko','ì§ì› %ê¹Œì§€',0),(222572,6183,'he','×¢×“ ××—×•×– ×¢×•×‘×“',0),(222573,6183,'el','ÎœÎ­Ï‡ÏÎ¹ Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(222574,6183,'zh','å¤šè¾¾é›‡å‘˜ç™¾åˆ†æ¯”\r\n',0),(222575,6183,'sv','Upp till anstÃ¤lld procent',0),(222576,6183,'it','Fino a per cento dei dipendenti',0),(222577,6183,'tl','',0),(222578,6183,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3609;&#3605;&#3660;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;',0),(222579,6183,'hi','à¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(222580,6183,'ms','Sehingga peratus pekerja',0),(222581,6183,'ar','Ù…Ø§ ÙŠØµÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ù…ÙˆØ¸Ù Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(222582,6183,'fr','Pour cent de l\'employÃ©',0),(222583,6183,'jp','å¾“æ¥­å“¡æ¯”çŽ‡ã?¾ã?§',0),(222584,6183,'pt','AtÃ© o empregado por cento',0),(222585,6183,'ru','Ð”Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(222586,6183,'es','Hasta Porcentaje de Empleados',0),(222587,6183,'de','Bis zu Prozent der Mitarbeiter',0),(222588,6183,'en','Up to Employee Percent',0),(222589,6184,'is','',0),(222590,6184,'dr','2',0),(222591,6184,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ù…Ø¹Ø§ÙÙŠØª   2',0),(222592,6184,'tr','2 muafiyet tutarÄ±',0),(222593,6184,'pl','Kwota zwolnienia 2',0),(222594,6184,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ 2',0),(222595,6184,'ur','Ø±Ù‚Ù… Ø§Ø³ØªØ«Ù†Ø§Ø¡ 2 Ú©Û’ Ù„Ø¦Û’',0),(222596,6184,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¾ Ð¸Ð·ÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ 2',0),(222597,6184,'vi','Sá»‘ Tiá»n Miá»…n Trá»« Láº§n 2',0),(222598,6184,'af','Bedrag vir Vrystelling 2',0),(222599,6184,'ro','Suma de scutire 2',0),(222600,6184,'et','Summa maksuvabastuse 2',0),(222601,6184,'si','Znesek za oprostitev 2',0),(222602,6184,'ba','Jumlah pembebasan 2',0),(222603,6184,'nl','Bedrag voor vrijstelling 2',0),(222604,6184,'fi','MyÃ¶nnettÃ¤vÃ¤n poikkeuksen 2',0),(222605,6184,'no','BelÃ¸pet for fritak 2',0),(222606,6184,'da','BelÃ¸bet for fritagelsen 2',0),(222607,6184,'ko','2 ë©´ì œ ê¸ˆì•¡',0),(222608,6184,'he','×”×¡×›×•× ×”×¤×˜×•×¨ 2',0),(222609,6184,'el','Î Î¿ÏƒÏŒ Î±Ï€Î±Î»Î»Î±Î³Î®Ï‚ 2',0),(222610,6184,'zh','è±å…é‡‘é¢2\r\n',0),(222611,6184,'sv','Beloppet fÃ¶r undantag 2',0),(222612,6184,'it','Importo per esenzione 2',0),(222613,6184,'tl','',0),(222614,6184,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609; 2',0),(222615,6184,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤›à¥‚à¤Ÿ 2',0),(222616,6184,'ms','Amaun pengecualian 2',0),(222617,6184,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ 2',0),(222618,6184,'fr','Montant d\'Exemption 2',0),(222619,6184,'jp','æŽ§é™¤ï¼’ã?®ç·?é¡?',0),(222620,6184,'pt','Quantidade de isenÃ§Ã£o 2',0),(222621,6184,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ 2',0),(222622,6184,'es','Cantidad para ExenciÃ³n 2',0),(222623,6184,'de','Betrag fÃ¼r die Befreiung 2',0),(222624,6184,'en','Amount for Exemption 2',0),(222625,6185,'is','',0),(222626,6185,'dr','3',0),(222627,6185,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ù…Ø¹Ø§ÙÙŠØª 3',0),(222628,6185,'tr','3 muafiyet tutarÄ±',0),(222629,6185,'pl','Kwota zwolnienia 3',0),(222630,6185,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ 3',0),(222631,6185,'ur','Ø±Ù‚Ù… Ø§Ø³ØªØ«Ù†Ø§Ø¡ 3 Ú©Û’ Ù„Ø¦Û’',0),(222632,6185,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¾ Ð¸Ð·ÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ 3',0),(222633,6185,'vi','Sá»‘ Tiá»n Miá»…n Trá»« Láº§n 3',0),(222634,6185,'af','Bedrag vir Vrystelling 3',0),(222635,6185,'ro','Suma de scutire 3',0),(222636,6185,'et','Summa maksuvabastuse 3',0),(222637,6185,'si','Znesek za oprostitev 3',0),(222638,6185,'ba','Jumlah pembebasan 3',0),(222639,6185,'nl','Bedrag voor vrijstelling 3',0),(222640,6185,'fi','MyÃ¶nnettÃ¤vÃ¤n poikkeuksen 3',0),(222641,6185,'no','BelÃ¸pet for fritak 3',0),(222642,6185,'da','BelÃ¸bet for fritagelsen 3',0),(222643,6185,'ko','3 ë©´ì œ ê¸ˆì•¡',0),(222644,6185,'he','×”×¡×›×•× ×”×¤×˜×•×¨ 3',0),(222645,6185,'el','Î Î¿ÏƒÏŒ Î±Ï€Î±Î»Î»Î±Î³Î®Ï‚ 3',0),(222646,6185,'zh','è±å…é‡‘é¢3\r\n',0),(222647,6185,'sv','Beloppet fÃ¶r undantag 3',0),(222648,6185,'it','Importo per esenzione 3',0),(222649,6185,'tl','',0),(222650,6185,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609; 3',0),(222651,6185,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤›à¥‚à¤Ÿ 3',0),(222652,6185,'ms','Amaun pengecualian 3',0),(222653,6185,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ 3',0),(222654,6185,'fr','Montant d\'Exemption 3',0),(222655,6185,'jp','æŽ§é™¤ï¼“ã?®ç·?é¡?',0),(222656,6185,'pt','Quantidade de isenÃ§Ã£o 3',0),(222657,6185,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð´Ð»Ñ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ 3',0),(222658,6185,'es','Cantidad para ExenciÃ³n 3',0),(222659,6185,'de','Betrag fÃ¼r die Befreiung 3',0),(222660,6185,'en','Amount for Exemption 3',0),(222661,6186,'is','',0),(222662,6186,'dr','3',0),(222663,6186,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ù…Ø¹Ø§ÙÙŠØª Ø¨ÙŠØ´ Ø§Ø² 3',0),(222664,6186,'tr','Muafiyet baÅŸÄ±na miktar Ã¼zerinden 3',0),(222665,6186,'pl','Kwota zwolnienia ponad 3',0),(222666,6186,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð°Ð´ 3',0),(222667,6186,'ur','3 Ø³Û’ Ø²Ø§Ø¦Ø¯ Ø±Ù‚Ù… Ø§Ø³ØªØ«Ù†Ø§Ø¡ ÙÛŒ',0),(222668,6186,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾ Ð¸Ð·ÑƒÐ·ÐµÑ›Ñƒ Ð¿Ñ€ÐµÐºÐ¾ 3',0),(222669,6186,'vi','Sá»‘ Tiá»n Má»™t Láº§n Miá»ƒn Trá»« TrÃªn 3',0),(222670,6186,'af','Bedrag PER Vrystelling meer as 3',0),(222671,6186,'ro','Suma la scutire peste 3',0),(222672,6186,'et','Summa maksuvabastuse kohta Ã¼le 3',0),(222673,6186,'si','Znesek na oprostitev veÄ kot 3',0),(222674,6186,'ba','Jumlah PER pembebasan lebih dari 3',0),(222675,6186,'nl','Bedrag PER vrijstelling meer dan 3',0),(222676,6186,'fi','Vapautuksen mÃ¤Ã¤rÃ¤ yli 3',0),(222677,6186,'no','BelÃ¸p PER fritak over 3',0),(222678,6186,'da','BelÃ¸b pr. undtagelse over 3',0),(222679,6186,'ko','ì´ìƒ 3 ë©´ì œ ë‹¹ ê¸ˆì•¡',0),(222680,6186,'he','×¡×›×•× ×œ×¤×™ ×¤×˜×•×¨ ×ž×¢×œ 3',0),(222681,6186,'el','Î Î¿ÏƒÏŒ Î±Î½Î¬ Î±Ï€Î±Î»Î»Î±Î³Î® Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ 3',0),(222682,6186,'zh','æ¯è¶…è¿‡3é¡¹è±å…é¢\r\n',0),(222683,6186,'sv','Belopp PER befrielse Ã¶ver 3',0),(222684,6186,'it','Importo PER esenzione oltre 3',0),(222685,6186,'tl','',0),(222686,6186,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3607;&#3637;&#3656;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634; 3',0),(222687,6186,'hi','à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿ à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• 3',0),(222688,6186,'ms','Jumlah satu pengecualian lebih 3',0),(222689,6186,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù„ÙƒÙ„ Ø¥Ø¹ÙØ§Ø¡ Ø£ÙƒØ«Ø± Ù…Ù† 3',0),(222690,6186,'fr','Montant par Exemption plus 3',0),(222691,6186,'jp','æŽ§é™¤ï¼“ä»¥ä¸Šã?”ã?¨ã?®ç·?é¡?',0),(222692,6186,'pt','Quantidade por isenÃ§Ã£o de mais de 3',0),(222693,6186,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ 3',0),(222694,6186,'es','Cantidad por ExenciÃ³n mÃ¡s que 3',0),(222695,6186,'de','Betrag pro Freistellung Ã¼ber 3',0),(222696,6186,'en','Amount PER Exemption over 3',0),(222697,6187,'is','',0),(222698,6187,'dr','2',0),(222699,6187,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ Ù…Ø¹Ø§ÙÙŠØª  2',0),(222700,6187,'tr','Muafiyet 2 kredi',0),(222701,6187,'pl','Kredyt na zwolnienie 2',0),(222702,6187,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ 2',0),(222703,6187,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ø§Ø³ØªØ«Ù†Ø§Ø¡ 2 Ú©Û’ Ù„ÛŒÛ’',0),(222704,6187,'sr','Ð—Ð°ÑÐ»ÑƒÐ³Ðµ Ð·Ð° Ð¾ÑÐ»Ð¾Ð±Ð¾Ñ’ÐµÑšÐµ 2',0),(222705,6187,'vi','TÃ­n Dá»¥ng Cho Miá»…n Trá»« 2',0),(222706,6187,'af','Krediet vir Vrystelling 2',0),(222707,6187,'ro','Credit pentru scutirea 2',0),(222708,6187,'et','Krediidi vabastamise 2',0),(222709,6187,'si','Kredit za oprostitev 2',0),(222710,6187,'ba','Kredit untuk pembebasan 2',0),(222711,6187,'nl','Krediet voor vrijstelling 2',0),(222712,6187,'fi','Luotto poikkeusta 2',0),(222713,6187,'no','Ã†ren for fritak 2',0),(222714,6187,'da','Ã†ren for fritagelse 2',0),(222715,6187,'ko','ë©´ì œ 2 ì‹ ìš©',0),(222716,6187,'he','×§×¨×“×™×˜ ×¢×œ ×¤×˜×•×¨ 2',0),(222717,6187,'el','Î Î¯ÏƒÏ„Ï‰ÏƒÎ· Î³Î¹Î± Î±Ï€Î±Î»Î»Î±Î³Î® 2',0),(222718,6187,'zh','ä¿¡ç”¨è±å…2\r\n',0),(222719,6187,'sv','Kredit fÃ¶r undantag 2',0),(222720,6187,'it','Credito per esenzione 2',0),(222721,6187,'tl','',0),(222722,6187,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609; 2 ',0),(222723,6187,'hi','à¤›à¥‚à¤Ÿ 2 à¤•à¥‡ à¤²à¤¿à¤ à¤‹à¤£',0),(222724,6187,'ms','Kredit untuk pengecualian 2',0),(222725,6187,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù„Ù„Ø¥Ø¹ÙØ§Ø¡ 2',0),(222726,6187,'fr','CrÃ©dit pour Exemption 2',0),(222727,6187,'jp','æŽ§é™¤ï¼’ã?®è²¸ä»˜',0),(222728,6187,'pt','CrÃ©dito de isenÃ§Ã£o 2',0),(222729,6187,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð´Ð»Ñ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ 2',0),(222730,6187,'es','CrÃ©dito para ExenciÃ³n 2',0),(222731,6187,'de','Kredit fÃ¼r die Befreiung 2',0),(222732,6187,'en','Credit for Exemption 2',0),(222733,6188,'is','',0),(222734,6188,'dr','3',0),(222735,6188,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ  Ù…Ø¹Ø§ÙÙŠØª 3',0),(222736,6188,'tr','Muafiyet 3 kredi',0),(222737,6188,'pl','Kredyt na zwolnienie 3',0),(222738,6188,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ 3',0),(222739,6188,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ø§Ø³ØªØ«Ù†Ø§Ø¡ 3',0),(222740,6188,'sr','Ð—Ð°ÑÐ»ÑƒÐ³Ðµ Ð·Ð° Ð¾ÑÐ»Ð¾Ð±Ð¾Ñ’ÐµÑšÐµ 3',0),(222741,6188,'vi','TÃ­n Dá»¥ng Cho Miá»…n Trá»« 3',0),(222742,6188,'af','Krediet vir Vrystelling 3',0),(222743,6188,'ro','Credit pentru scutirea 3',0),(222744,6188,'et','Krediidi vabastamise 3',0),(222745,6188,'si','Kredit za oprostitev 3',0),(222746,6188,'ba','Kredit untuk pembebasan 3',0),(222747,6188,'nl','Krediet voor vrijstelling 3',0),(222748,6188,'fi','Luotto poikkeusta 3',0),(222749,6188,'no','Ã†ren for fritak 3',0),(222750,6188,'da','Ã†ren for fritagelse 3',0),(222751,6188,'ko','3 ë©´ì œì— ëŒ€ í•œ ì‹ ìš©',0),(222752,6188,'he','×§×¨×“×™×˜ ×¢×œ ×¤×˜×•×¨ 3',0),(222753,6188,'el','Î Î¯ÏƒÏ„Ï‰ÏƒÎ· Î³Î¹Î± Î±Ï€Î±Î»Î»Î±Î³Î® 3',0),(222754,6188,'zh','ä¿¡ç”¨è±å…3\r\n',0),(222755,6188,'sv','Kredit fÃ¶r undantag 3',0),(222756,6188,'it','Credito per esenzione 3',0),(222757,6188,'tl','',0),(222758,6188,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609; 3 ',0),(222759,6188,'hi','à¤²à¤¿à¤ à¤›à¥‚à¤Ÿ 3 à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(222760,6188,'ms','Kredit untuk pengecualian 3',0),(222761,6188,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù„Ø¥Ø¹ÙØ§Ø¡ 3',0),(222762,6188,'fr','CrÃ©dit de dÃ©rogation 3',0),(222763,6188,'jp','æŽ§é™¤ï¼“ã?®è²¸ä»˜',0),(222764,6188,'pt','CrÃ©dito de isenÃ§Ã£o 3',0),(222765,6188,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð´Ð»Ñ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ 3',0),(222766,6188,'es','CrÃ©dito para ExenciÃ³n 3',0),(222767,6188,'de','Kredit fÃ¼r die Befreiung 3',0),(222768,6188,'en','Credit for Exemption 3',0),(222769,6189,'is','',0),(222770,6189,'dr','3',0),(222771,6189,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ù‡Ø±  Ù…Ø¹Ø§ÙÙŠØª Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ù„Ø§ØªØ±  3',0),(222772,6189,'tr','Muafiyet Ã¼zerinde 3 kredi',0),(222773,6189,'pl','Kredyt za zwolnienie ponad 3',0),(222774,6189,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð°Ð´ 3',0),(222775,6189,'ur','Ù¾Ø± 3 ÙÛŒ Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ú©Ø±ÛŒÚˆÙ¹',0),(222776,6189,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾ Ð¸Ð·ÑƒÐ·ÐµÑ›Ñƒ Ð¿Ñ€ÐµÐºÐ¾ 3',0),(222777,6189,'vi','TÃ­n Dá»¥ng Má»—i Láº§n Miá»…n Trá»« Cho hÆ¡n 3',0),(222778,6189,'af','Krediet PER Vrystelling meer as 3',0),(222779,6189,'ro','Credit PER scutirea peste 3',0),(222780,6189,'et','Krediidi eest vabastamise Ã¼le 3',0),(222781,6189,'si','Kredit na oprostitev veÄ kot 3',0),(222782,6189,'ba','Kredit PER pembebasan lebih dari 3',0),(222783,6189,'nl','Krediet PER vrijstelling meer dan 3',0),(222784,6189,'fi','Credit PER vapautusta yli 3',0),(222785,6189,'no','Kreditt PER fritak over 3',0),(222786,6189,'da','Credit pr. undtagelse over 3',0),(222787,6189,'ko','ì´ìƒ 3 ë©´ì œ ë‹¹ ì‹ ìš©',0),(222788,6189,'he','×§×¨×“×™×˜ ×œ×›×œ ×¤×˜×•×¨ ×ž×¢×œ 3',0),(222789,6189,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Î±Î½Î¬ Î±Ï€Î±Î»Î»Î±Î³Î® Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ 3',0),(222790,6189,'zh','æ¯è¶…è¿‡3ä¿¡ç”¨è±å…\r\n',0),(222791,6189,'sv','Kredit PER befrielse Ã¶ver 3',0),(222792,6189,'it','Credito per ogni esenzione oltre 3',0),(222793,6189,'tl','',0),(222794,6189,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3607;&#3637;&#3656;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634; 3',0),(222795,6189,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤›à¥‚à¤Ÿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• 3 à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(222796,6189,'ms','Kredit satu pengecualian lebih 3',0),(222797,6189,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„ÙˆØ§Ø­Ø¯Ø© ÙˆØ¥Ø¹ÙØ§Ø¡ Ø£ÙƒØ«Ø± Ù…Ù† 3',0),(222798,6189,'fr','CrÃ©dit par Exemption plus 3',0),(222799,6189,'jp','æŽ§é™¤ï¼“ä»¥ä¸Šã?®è²¸ä»˜',0),(222800,6189,'pt','CrÃ©dito por isenÃ§Ã£o de mais de 3',0),(222801,6189,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ 3',0),(222802,6189,'es','CrÃ©dito POR ExenciÃ³n para mÃ¡s de 3',0),(222803,6189,'de','Kredit pro Freistellung Ã¼ber 3',0),(222804,6189,'en','Credit PER Exemption over 3',0),(222805,6190,'is','',0),(222806,6190,'dr','Ø§Ù„Ø­Ø§Ù‚ÙŠ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ ØªØ§Ù‡Ù„ ',0),(222807,6190,'pr','Ø§Ù„Ø­Ø§Ù‚ÙŠ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ ØªØ§Ù‡Ù„ ',0),(222808,6190,'tr','MÃ¼ÅŸterek dosyalama evlendi',0),(222809,6190,'pl','Å»onaty zÅ‚oÅ¼enia wspÃ³lnego',0),(222810,6190,'bg','Ð–ÐµÐ½ÐµÐ½ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ ÑÑŠÐ²Ð¼ÐµÑÑ‚Ð½Ð¸',0),(222811,6190,'ur','Ø´Ø§Ø¯ÛŒ Ú©ÛŒ Ù…Ø´ØªØ±Ú©Û Ø¯Ø§Ø®Ù„',0),(222812,6190,'sr','Ð£Ð´Ð°Ð»Ð° ÑÐµ Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð·Ð°Ñ˜ÐµÐ´Ð½Ð¸Ñ‡ÐºÐ¾Ð³',0),(222813,6190,'vi','Ná»™p há»“ sÆ¡ cÆ°á»›i chung',0),(222814,6190,'af','Getroud indiening van gesamentlike',0),(222815,6190,'ro','CÄƒsÄƒtorit cu depunerea comune',0),(222816,6190,'et','Abielus, esitades Ã¼hise',0),(222817,6190,'si','PoroÄen vloÅ¾itve skupne',0),(222818,6190,'ba','Menikah pengajuan bersama',0),(222819,6190,'nl','Gehuwd met gezamenlijke indiening',0),(222820,6190,'fi','Naimisissa arkistointi yhdessÃ¤',0),(222821,6190,'no','Gift innlevering felles',0),(222822,6190,'da','Giftede sig med indgivelse af fÃ¦lles',0),(222823,6190,'ko','ê³µë™ ì‹ ê³  ê²°í˜¼',0),(222824,6190,'he','× ×©×•×™ ×”×’×©×ª ×ž×©×•×ª×¤×ª',0),(222825,6190,'el','Î Î±Î½Ï„ÏÎµÏÏ„Î·ÎºÎµ Î±ÏÏ‡ÎµÎ¹Î¿Î¸Î­Ï„Î·ÏƒÎ· ÎºÎ¿Î¹Î½Î®',0),(222826,6190,'zh','å·²å©šè”åˆç”³æŠ¥\r\n',0),(222827,6190,'sv','Gift arkivering gemensamma',0),(222828,6190,'it','SposÃ² deposito congiunto',0),(222829,6190,'tl','',0),(222830,6190,'th','&#3652;&#3615;&#3621;&#3660;&#3649;&#3605;&#3656;&#3591;&#3591;&#3634;&#3609;&#3649;&#3621;&#3657;&#3623;&#3629;&#3618;&#3641;&#3656;&#3604;&#3657;&#3623;&#3618;&#3585;&#3633;&#3609;',0),(222831,6190,'hi','à¤µà¤¿à¤µà¤¾à¤¹à¤¿à¤¤ à¤œà¥‹à¤¡à¤¼à¥‹à¤‚ à¤¦à¤¾à¤–à¤¿à¤²',0),(222832,6190,'ms','Berkahwin memfailkan bersama',0),(222833,6190,'ar','Ù…ØªØ²ÙˆØ¬/Ù…ØªØ²ÙˆØ¬Ø©',0),(222834,6190,'fr','MariÃ© Ã  dÃ©pÃ´t mixte',0),(222835,6190,'jp','å…±æœ‰ã?§è¨˜å…¥ã?™ã‚‹æ—¢å©š',0),(222836,6190,'pt','Casou-se com apresentaÃ§Ã£o conjunta',0),(222837,6190,'ru','Ð–ÐµÐ½Ð°Ñ‚ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ ÑÐ¾Ð²Ð¼ÐµÑÑ‚Ð½Ð¾Ð³Ð¾',0),(222838,6190,'es','Casado Declarando Junto',0),(222839,6190,'de','Verheiratet, gemeinsame Einreichung',0),(222840,6190,'en','Married Filing Joint',0),(222841,6191,'is','',0),(222842,6191,'dr','ØªÙÙƒÙŠÙƒ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ ØªØ§Ù‡Ù„',0),(222843,6191,'pr','ØªÙÙƒÙŠÙƒ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ ØªØ§Ù‡Ù„',0),(222844,6191,'tr','AyrÄ± dosyalama evlendi',0),(222845,6191,'pl','Å»onaty zÅ‚oÅ¼enia oddzielnego',0),(222846,6191,'bg','Ð–ÐµÐ½ÐµÐ½ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚Ð´ÐµÐ»Ð½Ð¾',0),(222847,6191,'ur','Ø´Ø§Ø¯ÛŒ Ú©ÛŒ Ø§Ù„Ú¯ Ø§Ù„Ú¯ Ø¯Ø§Ø®Ù„',0),(222848,6191,'sr','Ð£Ð´Ð°Ð»Ð° ÑÐµ Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð¾Ð´Ð²Ð¾Ñ˜ÐµÐ½Ðµ',0),(222849,6191,'vi','Ná»™p há»“ sÆ¡ cÆ°á»›i riÃªng',0),(222850,6191,'af','Getroud Liasering Apart',0),(222851,6191,'ro','CÄƒsÄƒtorit cu depunerea separat',0),(222852,6191,'et','Abielus, esitades eraldi',0),(222853,6191,'si','PoroÄen, vloÅ¾itev loÄeno',0),(222854,6191,'ba','Menikah pengajuan terpisah',0),(222855,6191,'nl','Gehuwd met indienen van afzonderlijke',0),(222856,6191,'fi','Naimisissa arkistointi erilliseen',0),(222857,6191,'no','Gift innlevering separat',0),(222858,6191,'da','Gift indgive separat',0),(222859,6191,'ko','ë³„ë„ ì œì¶œ ê²°í˜¼',0),(222860,6191,'he','× ×©×•×™ ×”×’×©×ª × ×¤×¨×“×™×',0),(222861,6191,'el','Î Î±Î½Ï„ÏÎµÏÏ„Î·ÎºÎµ Î±ÏÏ‡ÎµÎ¹Î¿Î¸Î­Ï„Î·ÏƒÎ· Î¾ÎµÏ‡Ï‰ÏÎ¹ÏƒÏ„ÏŒ',0),(222862,6191,'zh','å·²å©šå•ç‹¬ç”³æŠ¥\r\n',0),(222863,6191,'sv','Gift arkivering separat',0),(222864,6191,'it','SposÃ² deposito separato',0),(222865,6191,'tl','',0),(222866,6191,'th','&#3652;&#3615;&#3621;&#3660;&#3649;&#3605;&#3656;&#3591;&#3591;&#3634;&#3609;&#3649;&#3621;&#3657;&#3623;&#3629;&#3618;&#3641;&#3656;&#3604;&#3657;&#3623;&#3618;&#3585;&#3633;&#3609;',0),(222867,6191,'hi','à¤¶à¤¾à¤¦à¥€ à¤…à¤²à¤— à¤¦à¤¾à¤–à¤¿à¤²',0),(222868,6191,'ms','Berkahwin memfailkan berasingan',0),(222869,6191,'ar','Ù…Ø·Ù„Ù‘Ù‚/Ù…Ø¸Ù„Ù‘Ù‚Ø©',0),(222870,6191,'fr','Ã‰poux faisant des dÃ©clarations sÃ©parÃ©es',0),(222871,6191,'jp','åˆ†é›¢ã?§è¨˜å…¥ã?™ã‚‹æ—¢å©š',0),(222872,6191,'pt','Casou-se com apresentaÃ§Ã£o separada',0),(222873,6191,'ru','Ð–ÐµÐ½Ð°Ñ‚ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ Ð¾Ñ‚Ð´ÐµÐ»ÑŒÐ½Ñ‹Ñ…',0),(222874,6191,'es','Casado Declarando Separado',0),(222875,6191,'de','Verheiratet, Separate Ablage',0),(222876,6191,'en','Married Filing Separate',0),(222877,6192,'is','',0),(222878,6192,'dr','Ù…Ø¨Ù„Øº Ú†Ùƒ',0),(222879,6192,'pr','Ù…Ø¨Ù„Øº Ú†Ùƒ',0),(222880,6192,'tr','Kontrol edin',0),(222881,6192,'pl','Kwota czeku',0),(222882,6192,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÑƒÐ¼Ð°',0),(222883,6192,'ur','Ø±Ù‚Ù… Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(222884,6192,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(222885,6192,'vi','Sá»‘ tiá»n trÃªn SÃ©c',0),(222886,6192,'af','Tjeks Bedrag',0),(222887,6192,'ro','VerificaÅ£i suma',0),(222888,6192,'et','Kontrollige summa',0),(222889,6192,'si','Preverite koliÄino',0),(222890,6192,'ba','Memeriksa jumlah',0),(222891,6192,'nl','Selectievakje bedrag',0),(222892,6192,'fi','Tarkista summa',0),(222893,6192,'no','Sjekken belÃ¸p',0),(222894,6192,'da','Check belÃ¸b',0),(222895,6192,'ko','ê¸ˆì•¡ í™•ì¸',0),(222896,6192,'he','×¡×›×•× ×¦\'×§',0),(222897,6192,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î¿ Ï€Î¿ÏƒÏŒ',0),(222898,6192,'zh','æ”¯ç¥¨é‡‘é¢\r\n',0),(222899,6192,'sv','Kontrollera mycket',0),(222900,6192,'it','Controllare la quantitÃ ',0),(222901,6192,'tl','',0),(222902,6192,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3594;&#3655;&#3588;',0),(222903,6192,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(222904,6192,'ms','Menyemak jumlah',0),(222905,6192,'ar','Ù…Ø¨Ù„Øº Ø§Ù„ØµÙƒÙ‘',0),(222906,6192,'fr','Montant du chÃ¨que',0),(222907,6192,'jp','å°?åˆ‡æ‰‹ã?®ç·?é¡?',0),(222908,6192,'pt','Verificar a quantidade',0),(222909,6192,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ñ‡ÐµÐºÐ°',0),(222910,6192,'es','Cheque Monto',0),(222911,6192,'de','Scheckbetrag',0),(222912,6192,'en','Check Amount',0),(222913,6193,'is','',0),(222914,6193,'dr','Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ ',0),(222915,6193,'pr','Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ ',0),(222916,6193,'tr','NumarasÄ±',0),(222917,6193,'pl','Od numeru',0),(222918,6193,'bg','ÐžÑ‚ Ð½Ð¾Ð¼ÐµÑ€',0),(222919,6193,'ur','Ù†Ù…Ø¨Ø± Ø³Û’',0),(222920,6193,'sr','ÐžÐ´ Ð±Ñ€Ð¾Ñ˜Ð°',0),(222921,6193,'vi','Tá»« sá»‘',0),(222922,6193,'af','Vanaf Nommer',0),(222923,6193,'ro','Din numÄƒrul',0),(222924,6193,'et','Alates numbrist',0),(222925,6193,'si','Iz Å¡tevila',0),(222926,6193,'ba','Dari nomor',0),(222927,6193,'nl','Vanaf nummer',0),(222928,6193,'fi','Numero',0),(222929,6193,'no','Fra nummer',0),(222930,6193,'da','Fra antallet',0),(222931,6193,'ko','ë²ˆí˜¸ì—ì„œ',0),(222932,6193,'he','×ž×ž×¡×¤×¨',0),(222933,6193,'el','Î‘Ï€ÏŒ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ',0),(222934,6193,'zh','ä»Žæ•°å­—\r\n',0),(222935,6193,'sv','FrÃ¥n nummer',0),(222936,6193,'it','Dal numero',0),(222937,6193,'tl','',0),(222938,6193,'th','&#3592;&#3634;&#3585;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;',0),(222939,6193,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‡',0),(222940,6193,'ms','Daripada nombor',0),(222941,6193,'ar','Ù…Ù† Ø¹Ø¯Ø¯',0),(222942,6193,'fr','De nombre',0),(222943,6193,'jp','æ•°å­—ã?‹ã‚‰',0),(222944,6193,'pt','Do nÃºmero',0),(222945,6193,'ru','Ð¡ ÐÐ¾Ð¼ÐµÑ€Ð°',0),(222946,6193,'es','Del NÃºmero',0),(222947,6193,'de','Von Zahl',0),(222948,6193,'en','From Number',0),(222949,6194,'is','',0),(222950,6194,'dr','ØªØ§Ø±ÙŠØ® Ù„ØºÙˆ Ø´Ø¯ ',0),(222951,6194,'pr','ØªØ§Ø±ÙŠØ® Ù„ØºÙˆ Ø´Ø¯ ',0),(222952,6194,'tr','Ä°ptal tarihi',0),(222953,6194,'pl','Data anulowania',0),(222954,6194,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ',0),(222955,6194,'ur','ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(222956,6194,'sr','Ð¡Ð°ÑÑ‚Ð°Ð½Ð°Ðº Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½',0),(222957,6194,'vi','NgÃ y há»§y',0),(222958,6194,'af','Datum Gekanselleer',0),(222959,6194,'ro','Data anulate',0),(222960,6194,'et','TÃ¼histatud kuupÃ¤ev',0),(222961,6194,'si','Datum odpovedan',0),(222962,6194,'ba','Tanggal yang dibatalkan',0),(222963,6194,'nl','Datum geannuleerd',0),(222964,6194,'fi','PÃ¤ivÃ¤ peruttu',0),(222965,6194,'no','Dato avbrutt',0),(222966,6194,'da','Dato aflyst',0),(222967,6194,'ko','ì·¨ì†Œ ë‚ ì§œ',0),(222968,6194,'he','×ª××¨×™×š ×‘×™×˜×•×œ',0),(222969,6194,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎ±Î½',0),(222970,6194,'zh','å–æ¶ˆæ—¥æœŸ\r\n',0),(222971,6194,'sv','Datum instÃ¤llt',0),(222972,6194,'it','Data annullata',0),(222973,6194,'tl','',0),(222974,6194,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(222975,6194,'hi','à¤°à¤¦à¥à¤¦à¤•à¤°à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(222976,6194,'ms','Tarikh yang dibatalkan',0),(222977,6194,'ar','ØªØ§Ø±ÙŠØ® Ø¥Ù„ØºØ§Ø¡',0),(222978,6194,'fr','Date annulÃ©e',0),(222979,6194,'jp','æ—¥ä»˜ã?Œã‚­ãƒ£ãƒ³ã‚»ãƒ«ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(222980,6194,'pt','Encontro cancelado',0),(222981,6194,'ru','Ð”Ð°Ñ‚Ð° ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð°',0),(222982,6194,'es','Fecha Cancelada',0),(222983,6194,'de','Termin abgesagt',0),(222984,6194,'en','Date Cancelled',0),(222985,6195,'is','',0),(222986,6195,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ ',0),(222987,6195,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ ',0),(222988,6195,'tr','DÃ¶nemin bitiÅŸ tarihi',0),(222989,6195,'pl','Data zakoÅ„czenia okresu',0),(222990,6195,'bg','Ð”Ð°Ñ‚Ð° ÐºÑ€Ð°Ð¹ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(222991,6195,'ur','Ø§Ø®ØªØªØ§Ù… Ø¯ÙˆØ± Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(222992,6195,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(222993,6195,'vi','NgÃ y cuá»‘i ká»³',0),(222994,6195,'af','Einde-van-periode Datum',0),(222995,6195,'ro','Data de sfÃ¢rÅŸit a perioadei',0),(222996,6195,'et','Perioodi lÃµpu kuupÃ¤ev',0),(222997,6195,'si','Datum konca obdobja',0),(222998,6195,'ba','Tanggal akhir waktu',0),(222999,6195,'nl','Datum van het einde van de periode',0),(223000,6195,'fi','Tilikauden lopussa pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(223001,6195,'no','End-of-perioden dato',0),(223002,6195,'da','Slutningen af perioden dato',0),(223003,6195,'ko','ê¸°ê°„ ë ë‚ ì§œ',0),(223004,6195,'he','×ª××¨×™×š ×¡×™×•× ×©×œ ×ª×§×•×¤×ª',0),(223005,6195,'el','Î¤Î­Î»Î¿Ï‚ Ï„Î·Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï… Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(223006,6195,'zh','ç»“æŸå‘¨æœŸæ—¥æœŸ',0),(223007,6195,'sv','Slutet av perioden datum',0),(223008,6195,'it','Data di fine del periodo',0),(223009,6195,'tl','',0),(223010,6195,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;&#3586;&#3629;&#3591;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(223011,6195,'hi','à¤…à¤‚à¤¤-à¤•à¥€-à¤…à¤µà¤§à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(223012,6195,'ms','Tarikh akhir zaman',0),(223013,6195,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©',0),(223014,6195,'fr','Date de fin de pÃ©riode',0),(223015,6195,'jp','æœŸé–“æœ€çµ‚æ—¥ã?«æ—¥ä»˜',0),(223016,6195,'pt','Data de fim de perÃ­odo',0),(223017,6195,'ru','ÐšÐ¾Ð½ÐµÑ†-Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð”Ð°Ñ‚Ð°',0),(223018,6195,'es','Fecha de Fin del PerÃ­odo',0),(223019,6195,'de','Ende der Periode Datum',0),(223020,6195,'en','End-of-period Date',0),(223021,6196,'is','',0),(223022,6196,'dr','Prior Closings',0),(223023,6196,'pr','Prior Closings',0),(223024,6196,'tr','Ã–nceki KapanÄ±ÅŸ sÃ¶zcÃ¼kleri',0),(223025,6196,'pl','WczeÅ›niejszego zamkniÄ™cia',0),(223026,6196,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð·Ð°Ñ‚Ð²Ð°Ñ€ÑÐ½Ð¸Ñ',0),(223027,6196,'ur','Ù¾ÛŒØ´Ú¯ÛŒ Ø¨Ù†Ø¯Ø´',0),(223028,6196,'sr','Ð˜Ð³ÑƒÐ¼Ð°Ð½ ÐºÑ€Ð¸Ñ‚Ð¸Ð·Ð¸Ñ€Ð°Ð»Ð¸',0),(223029,6196,'vi','KhÃ³a sá»• trÆ°á»›c',0),(223030,6196,'af','Vooraf Closings',0),(223031,6196,'ro','Inchideri prealabilÄƒ',0),(223032,6196,'et','Enne sulgemist',0),(223033,6196,'si','Predhodno zapiranj',0),(223034,6196,'ba','Penutupan sebelumnya',0),(223035,6196,'nl','Voorafgaande sluitingen',0),(223036,6196,'fi','Ennen sulkemiset',0),(223037,6196,'no','Tidligere nedleggelser',0),(223038,6196,'da','ForudgÃ¥ende hvilestykker',0),(223039,6196,'ko','ì‚¬ì „ ì¢…ê²°',0),(223040,6196,'he','×¡×’×™×¨×•×ª ×ž×•×§×“×ž×ª',0),(223041,6196,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· ÎºÎ»ÎµÎ¹ÏƒÎ¯Î¼Î±Ï„Î±',0),(223042,6196,'zh','å…ˆå‰ç»“ç®—\r\n',0),(223043,6196,'sv','Tidigare avslut',0),(223044,6196,'it','Chiusure preventiva',0),(223045,6196,'tl','',0),(223046,6196,'th','&#3585;&#3634;&#3619;&#3611;&#3636;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3617;&#3637;&#3617;&#3634;&#3585;&#3656;&#3629;&#3609;',0),(223047,6196,'hi','à¤ªà¥‚à¤°à¥à¤µ Closings',0),(223048,6196,'ms','Ditutup terlebih dahulu',0),(223049,6196,'ar','Ø¥ØºÙ„Ø§Ù‚ Ø³Ø§Ø¨Ù‚',0),(223050,6196,'fr','Fermetures antÃ©rieures',0),(223051,6196,'jp','é–‰ã‚?å‰?ã?®',0),(223052,6196,'pt','Fechamentos prÃ©vios',0),(223053,6196,'ru','Ð”Ð¾ Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¸Ñ',0),(223054,6196,'es','Cerradas Anteriores',0),(223055,6196,'de','Vorherige SchlieÃŸungen',0),(223056,6196,'en','Prior Closings',0),(223057,6197,'is','',0),(223058,6197,'dr','Ú†Ù‡ ÙƒØ³ÙŠ ',0),(223059,6197,'pr','Ú†Ù‡ ÙƒØ³ÙŠ ',0),(223060,6197,'tr','Kim',0),(223061,6197,'pl','Kto',0),(223062,6197,'bg','ÐšÐ¾Ð¹',0),(223063,6197,'ur','Ú©ÙˆÙ†',0),(223064,6197,'sr','ÐšÐ¾',0),(223065,6197,'vi','Ai',0),(223066,6197,'af','Wie',0),(223067,6197,'ro','Care',0),(223068,6197,'et','Kes',0),(223069,6197,'si','kdo',0),(223070,6197,'ba','Siapa',0),(223071,6197,'nl','Die',0),(223072,6197,'fi','Kuka',0),(223073,6197,'no','hvem',0),(223074,6197,'da','Hvem',0),(223075,6197,'ko','ëˆ„ê°€',0),(223076,6197,'he','×ž×™',0),(223077,6197,'el','Î Î¿Î¹Î¿Ï‚',0),(223078,6197,'zh','è°\r\n',0),(223079,6197,'sv','Vem',0),(223080,6197,'it','Chi',0),(223081,6197,'tl','',0),(223082,6197,'th','&#3651;&#3588;&#3619;',0),(223083,6197,'hi','à¤•à¥Œà¤¨',0),(223084,6197,'ms','Yang',0),(223085,6197,'ar','Ù…Ù†Ø¸Ù…Ø© Ø§Ù„ØµØ­Ø© Ø§Ù„Ø¹Ø§Ù„Ù…ÙŠØ©',0),(223086,6197,'fr','Qui',0),(223087,6197,'jp','èª°',0),(223088,6197,'pt','Quem',0),(223089,6197,'ru','ÐšÑ‚Ð¾',0),(223090,6197,'es','Quien',0),(223091,6197,'de','Wer',0),(223092,6197,'en','Who',0),(223093,6198,'is','',0),(223094,6198,'dr','Bad Date   ØªØ§Ø±ÙŠØ®  Ù„Ø§ ÙˆØµÙˆÙ„',0),(223095,6198,'pr','Bad Date   ØªØ§Ø±ÙŠØ®  Ù„Ø§ ÙˆØµÙˆÙ„',0),(223096,6198,'tr','KÃ¶tÃ¼ tarihi',0),(223097,6198,'pl','ZÅ‚y dzieÅ„',0),(223098,6198,'bg','Ð›Ð¾Ñˆ Ð´Ð°Ñ‚Ð°',0),(223099,6198,'ur','Ø¨Ø±Ø§ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(223100,6198,'sr','Ð›Ð¾Ñˆ Ð´Ð°Ñ‚ÑƒÐ¼',0),(223101,6198,'vi','NgÃ y xáº¥u',0),(223102,6198,'af','Slegte Datum',0),(223103,6198,'ro','Data de rÄƒu',0),(223104,6198,'et','Vigane kuupÎ£ev',0),(223105,6198,'si','Slab dan',0),(223106,6198,'ba','Tanggal buruk',0),(223107,6198,'nl','Slechte datum',0),(223108,6198,'fi','Huono pÃ¤ivÃ¤',0),(223109,6198,'no','Dato',0),(223110,6198,'da','DÃ¥rlig dato',0),(223111,6198,'ko','ë‚˜ìœ ë‚ ì§œ',0),(223112,6198,'he','×¤×’×™×©×” ×¨×¢×”',0),(223113,6198,'el','ÎšÎ±ÎºÎ® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(223114,6198,'zh','é”™è¯¯çš„æ—¥æœŸ\r\n',0),(223115,6198,'sv','Bad Date',0),(223116,6198,'it','Data errata',0),(223117,6198,'tl','',0),(223118,6198,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3612;&#3636;&#3604;',0),(223119,6198,'hi','à¤¬à¥à¤°à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(223120,6198,'ms','Tarikh',0),(223121,6198,'ar','ØªØ§Ø±ÙŠØ® Ø³ÙŠØ¦Ø©',0),(223122,6198,'fr','Mauvaise Date',0),(223123,6198,'jp','ä¸?å½“unreasonable',0),(223124,6198,'pt','Encontro ruim',0),(223125,6198,'ru','Bad Ð”Ð°Ñ‚Ð°',0),(223126,6198,'es','Deuda Perida',0),(223127,6198,'de','Schlechten Tag',0),(223128,6198,'en','Bad Date',0),(223129,6199,'is','',0),(223130,6199,'dr','Ù‡ÙŠÚ† Ø¨Ø±Ú¯Ø´ØªÙŠ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(223131,6199,'pr','Ù‡ÙŠÚ† Ø¨Ø±Ú¯Ø´ØªÙŠ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(223132,6199,'tr','HiÃ§bir iade kabul',0),(223133,6199,'pl','Nie zwraca akceptowane',0),(223134,6199,'bg','ÐÐµ Ð²Ñ€ÑŠÑ‰Ð° Ð¿Ñ€Ð¸ÐµÑ‚Ð¸',0),(223135,6199,'ur','Ú©ÙˆØ¦ÛŒ ÙˆØ§Ù¾Ø³ Ù‚Ø¨ÙˆÙ„ Ú©Ø± Ù„ÛŒØ§',0),(223136,6199,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÐ·Ð²Ñ€Ð°Ñ‚Ð¸Ð¾ Ñ˜Ðµ Ð¿Ñ€Ð¸Ñ…Ð²Ð°Ñ‚Ð¸Ð¾',0),(223137,6199,'vi','KhÃ´ng cÃ³ hoÃ n tráº£ Ä‘Æ°á»£c cháº¥p thuáº­n',0),(223138,6199,'af','Geen Retoere Aanvaar',0),(223139,6199,'ro','Nu Ã®ntoarce acceptate',0),(223140,6199,'et','No annab vastu',0),(223141,6199,'si','Ne vrne sprejeta',0),(223142,6199,'ba','Kembali tidak diterima',0),(223143,6199,'nl','Geen teruggaven aanvaard',0),(223144,6199,'fi','Palautuksia hyvÃ¤ksytty',0),(223145,6199,'no','Ingen retur godtas',0),(223146,6199,'da','Ingen returnerer accepteret',0),(223147,6199,'ko','ì•„ë‹ˆ ë°˜í™˜ í—ˆìš©',0),(223148,6199,'he','. ××™×Ÿ ×”×—×–×¨×•×ª ×”×ª×§×‘×œ×”',0),(223149,6199,'el','Î”ÎµÎ½ ÎµÏ€Î¹ÏƒÏ„ÏÎ­Ï†ÎµÎ¹ Î±Ï€Î¿Î´ÎµÎºÏ„Î®',0),(223150,6199,'zh','ä¸æŽ¥å—é€€è´§\r\n',0),(223151,6199,'sv','Inga Returer accepteras',0),(223152,6199,'it','Non torna accettato',0),(223153,6199,'tl','',0),(223154,6199,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3618;&#3629;&#3617;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;',0),(223155,6199,'hi','à¤•à¥‹à¤ˆ à¤°à¤¿à¤Ÿà¤°à¥à¤¨ à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤¿à¤ à¤œà¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(223156,6199,'ms','Tiada pulangan yang diterima',0),(223157,6199,'ar','Ù„Ø§ ÙŠÙ‚Ø¨Ù„ Ø§Ù„Ù…Ø±Ø¯ÙˆØ¯Ø§Øª',0),(223158,6199,'fr','Aucun retour acceptÃ©',0),(223159,6199,'jp','è¿”å“?ä¸?å?¯',0),(223160,6199,'pt','Sem DevoluÃ§Ãµes aceitadas',0),(223161,6199,'ru','ÐÐµ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÑ‚ Ð¿Ñ€Ð¸Ð½ÑÑ‚Ð¾',0),(223162,6199,'es','No se Aceptaron Declaraciones de Impuestos',0),(223163,6199,'de','Keine RÃ¼cksendungen akzeptiert',0),(223164,6199,'en','No Returns Accepted',0),(223165,6200,'is','',0),(223166,6200,'dr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(223167,6200,'pr','Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(223168,6200,'tr','MaaÅŸ Ã¶denecek',0),(223169,6200,'pl','Wynagrodzenia wypÅ‚acane',0),(223170,6200,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸',0),(223171,6200,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(223172,6200,'sr','ÐŸÐ»Ð°Ñ‚Ðµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(223173,6200,'vi','Báº£ng LÆ°Æ¡ng Pháº£i Tráº£',0),(223174,6200,'af','Loonrool Betaalbaar',0),(223175,6200,'ro','Salarii plÄƒtit',0),(223176,6200,'et','TÃ¶Ã¶tasu makstakse',0),(223177,6200,'si','IzplaÄane plaÄe plaÄa',0),(223178,6200,'ba','Penggajian hutang',0),(223179,6200,'nl','Loonlijst te betalen',0),(223180,6200,'fi','Palkka maksetaan',0),(223181,6200,'no','LÃ¸nn betales',0),(223182,6200,'da','LÃ¸n skal betales',0),(223183,6200,'ko','ê¸‰ì—¬ ì§€ê¸‰',0),(223184,6200,'he','×œ×ª×©×œ×•× ×ž×©×›×•×¨×•×ª',0),(223185,6200,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Ï€Î»Î·ÏÏ‰Ï„Î­Î±',0),(223186,6200,'zh','åº”ä»˜è–ªèµ„\r\n',0),(223187,6200,'sv','LÃ¶n betalas',0),(223188,6200,'it','Pagabile in libro paga',0),(223189,6200,'tl','',0),(223190,6200,'th','&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(223191,6200,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤¦à¥‡à¤¯',0),(223192,6200,'ms','Gaji yang perlu dibayar',0),(223193,6200,'ar','Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(223194,6200,'fr','Salaires Ã  payer',0),(223195,6200,'jp','çµ¦ä¸Žæ”¯æ‰•',0),(223196,6200,'pt','SalÃ¡rios a pagar',0),(223197,6200,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‚Ðµ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(223198,6200,'es','NÃ³mina por Pagar',0),(223199,6200,'de','Abrechnung zahlbar',0),(223200,6200,'en','Payroll Payable',0),(223201,6201,'is','',0),(223202,6201,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø¯ÙˆØ±Ù‡ Ù¾Ø§ÙŠØ§Ù†ÙŠ Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ â€“Ø¨Ø±Ø§ÙŠ Ù…Ù‚Ø¯Ø§Ø± Ú†Ùƒ Ø§Ø² ØªØ§Ø±ÙŠØ® Ú†Ùƒ Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ â€“ ØªÙ…Ø§Ù… Ø«Ø¨Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ø±Ø³ÙŠ ØªØ§Ø±ÙŠØ® Ø§Ø±Ø³Ø§Ù„ Ø´ÙˆÙ†Ø¯',0),(223203,6201,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø¯ÙˆØ±Ù‡ Ù¾Ø§ÙŠØ§Ù†ÙŠ Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ â€“Ø¨Ø±Ø§ÙŠ Ù…Ù‚Ø¯Ø§Ø± Ú†Ùƒ Ø§Ø² ØªØ§Ø±ÙŠØ® Ú†Ùƒ Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ â€“ ØªÙ…Ø§Ù… Ø«Ø¨Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ø±Ø³ÙŠ ØªØ§Ø±ÙŠØ® Ø§Ø±Ø³Ø§Ù„ Ø´ÙˆÙ†Ø¯',0),(223204,6201,'tr','DÃ¶nem bitiÅŸ tarihi iÃ§in mesaj<br><small>(gider iÃ§in--onay tarihi iÃ§in onay tutarÄ± kullanÄ±n)<br>(denetlenmeyen - tarihi kontrol etmek iÃ§in tÃ¼m giriÅŸleri deftere)</small>',0),(223205,6201,'pl','Post do daty zakoÅ„czenia okresu<br><small>(na koszt--uÅ¼yÄ‡ Data wyboru iloÅ›ci)<br>(zaznaczone - wszystkie wpisy post do sprawdzenia daty)</small>',0),(223206,6201,'bg','ÐŸÐ¾ÑÑ‚ Ð´Ð¾ ÐºÑ€Ð°Ñ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð´Ð°Ñ‚Ð°<br><small>(Ð·Ð° ÑÐ¼ÐµÑ‚ÐºÐ°--Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°Ñ‚Ð°, Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÑƒÐ¼Ð°)<br>(Ð½ÐµÑ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½ - Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ð¾ÑÑ‚ Ð´Ð° Ð¿Ñ€Ð¾Ð²Ðµ',0),(223207,6201,'ur','Ø¹Ø±ØµÛ Ø§Ø®ØªØªØ§Ù… ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº<br><small>(Ø®Ø±Ú†Û’ Ú©Û’ Ù„Ø¦Û’ ÛŒØ¹Ù†ÛŒ Ú†ÛŒÚ© Ø§Ù† ØªØ§Ø±ÛŒØ® Ú†ÛŒÚ© Ú©ÛŒ Ø±Ù‚Ù… Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº)<br>(ØºÛŒØ± Ù¾Ú‘ØªØ§Ù„ Ø´Ø¯Û - ØªØ§Ø±ÛŒØ® Ú†ÛŒÚ© Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ØªÙ…Ø§Ù… ',0),(223208,6201,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶Ð¸ Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° ÐºÑ€Ð°Ñ˜ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°<br><small>(Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ--ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¸Ð·Ð½Ð¾Ñ)<br>(ÐÐµÐ¿Ñ€Ð¾Ð²Ñ˜ÐµÑ€ÐµÐ½Ð¸ - ÑÐ²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð²Ñ˜Ð',0),(223209,6201,'vi','Káº¿t chuyá»ƒn cho ngÃ y cuá»‘i ká»³ (vá»›i chi phÃ­ -- dÃ¹ng ngÃ y cho sá»‘ tiá»n trÃªn SÃ©c))(bá» dáº¥u - táº¥t cáº£ cÃ¡c bÃºt toÃ¡n káº¿t chuyá»ƒn tá»›i ngÃ y ra SÃ©c)',0),(223210,6201,'af','Pos aan tydperk Einddatum<br><small>(vir uitgawe - gebruik check datum vir kontrole bedrag)<br>(ongemerk - alle inskrywings pos kontroleer datum)</small>',0),(223211,6201,'ro','Post la data de sfÃ¢rÅŸit perioadÄƒ<br><small>(pentru cheltuieli--utiliza data de selectare pentru a verifica suma)<br>(nebifatÄƒ - toate intrÄƒrile post verifica data)</small>',0),(223212,6201,'et','Post lÃµppkuupÃ¤ev<br><small>(kulul--kasutada kontrolli kuupÃ¤eva sisse summa)<br>(mÃ¤rkimata - kÃµiki kandeid konteerida kontrolli kuupÃ¤ev)</small>',0),(223213,6201,'si','Post, da konÄni datum obdobja<br><small>(za stroÅ¡ke--potrdite datum uporabite za preveri znesek)<br>(Nepreverjeni - vse postavke post preverite datum)</small>',0),(223214,6201,'ba','Posting untuk tanggal akhir periode<br><small>(biaya--menggunakan tanggal check untuk jumlah check)<br>(dicentang - semua entri posting untuk memeriksa tanggal)</small>',0),(223215,6201,'nl','Post naar einde van de periode datum<br><small>(voor kosten--gebruiken selectievakje datum voor selectievakje bedrag)<br>(ongecontroleerde - alle inzendingen post om te controleren datum)</small>',0),(223216,6201,'fi','Post kauden pÃ¤Ã¤ttymispÃ¤ivÃ¤<br><small>(kustannuksella--KÃ¤ytÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ tarkistaa mÃ¤Ã¤rÃ¤)<br>(ei valintaa - kaikki tapahtumat kirjataan tarkistuspÃ¤ivÃ¤)</small>',0),(223217,6201,'no','Innlegget periodens sluttdato<br><small>(for utgift - brukes av dato for sjekk belÃ¸p)<br>(merket - alle stolpe for Ã¥ kontrollere dato)</small>',0),(223218,6201,'da','IndlÃ¦g til slutdato<br><small>(for regning--brug checkens dato for check belÃ¸b)<br>(ukontrolleret - alle poster post for at kontrollere dato)</small>',0),(223219,6201,'ko','ê¸°ê°„ ë ë‚ ì§œ ê²Œì‹œë¬¼<br><small>(ë¹„ìš©-ì— ëŒ€ í•œ ì‚¬ìš© ê²€ì‚¬ ë‚ ì§œ í™•ì¸ ê¸ˆì•¡ì— ëŒ€ í•œ)<br>(ì„ íƒ ì·¨ì†Œ-ëª¨ë“  í•­ëª© ê²Œì‹œ ë‚ ì§œ í™•ì¸)</small>',0),(223220,6201,'he','×¤×•×¡×˜ ×¢×œ ×ª××¨×™×š ×¡×™×•× ×©×œ ×ª×§×•×¤×ª<br><small>(×¢×‘×•×¨ ×”×•×¦××•×ª - ×”×©×ª×ž×© ×”×¡×™×ž×•×Ÿ ×ª××¨×™×š ×‘×¡×›×•× ×”×¦\'×§)<br>(×‘×“×•×§ - ×¢×¨×›×™ ×›×œ ×¤×•×¡×˜ ×›×“×™ ×œ×‘×“×•×§ ×ª××¨×™×š)</small>',0),(223221,6201,'el','Î˜Î­ÏƒÎ· Î½Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…<br><small>(Î³Î¹Î± Î´Î±Ï€Î¬Î½Î·--Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… Î³Î¹Î± Î­Î»ÎµÎ³Ï‡Î¿ Ï€Î¿ÏƒÏŒ)<br>(Î±Î½ÎµÎ¾Î­Î»ÎµÎ³ÎºÏ„Î· - ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµ',0),(223222,6201,'zh','å‘å¸ƒåˆ°æ—¶æœŸçš„ç»“æŸæ—¥æœŸï¼ˆè´¹ç”¨- ä½¿ç”¨æ”¯ç¥¨çš„é‡‘é¢ä¸ºæ£€æŸ¥æ—¥æœŸï¼‰ï¼ˆæœªç»æ£€æŸ¥çš„- æ‰€æœ‰æ¡ç›®å‘å¸ƒåˆ°æ£€æŸ¥æ—¥æœŸï¼‰\r\n',0),(223223,6201,'sv','Post till slutdatum<br><small>(fÃ¶r utgift--anvÃ¤nda kontrollera datum fÃ¶r kontrollera belopp)<br>(omarkerad - alla ska bokfÃ¶ras om du vill kontrollera datum)</small>',0),(223224,6201,'it','Post per data di fine periodo<br><small>(spesa - utilizzare data check per controllare quantitÃ )<br>(incontrollato - posta di tutte le voci per verificare la data)</small>',0),(223225,6201,'tl','',0),(223226,6201,'th','Post to Period End Date<br><small>(for expense -- use check date for check amount)<br>(unchecked - all entries post to check date)</small>',0),(223227,6201,'hi','à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤…à¤‚à¤¤ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿ<br><small>(à¤•à¥‡ à¤²à¤¿à¤ à¤µà¥à¤¯à¤¯ - à¤šà¥‡à¤• à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¥‡à¤• à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚)<br>',0),(223228,6201,'ms','Pos ke tarikh tamat tempoh<br><small>(bagi perbelanjaan--gunakan tarikh semak semak jumlah)<br>(berdaftar - semua entri post untuk menyemak tarikh)</small>',0),(223229,6201,'ar','ÙˆØ¸ÙŠÙØ© Ù„ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©<br><small>(Ù„Ù„Ù…ØµØ±ÙˆÙØ§Øª-Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù„Ù…Ù‚Ø¯Ø§Ø± Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±)<br>(Ø¯ÙˆÙ† Ø±Ø§Ø¯Ø¹-ØªØ±Ø­ÙŠÙ„ ÙƒØ§ÙØ© Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† ØªØ§Ø±ÙŠØ®)</small>',0),(223230,6201,'fr','Poste Ã  la Date de fin de pÃ©riode<br><small>(pour frais--utiliser date de chÃ¨que pour le montant du chÃ¨que)<br>(case non cochÃ©e - toutes les entrÃ©es aprÃ¨s pour vÃ©rifier la date)</small>',0),(223231,6201,'jp','æœŸé–“çµ‚äº†æ—¥ã‚’è¨ˆä¸Š<br><small>ï¼ˆè²»ç”¨ã?®ã?Ÿã‚?ã?«--è«‹æ±‚é¡?ã?«ã?¯è«‹æ±‚æ”¯æ‰•ã?„æ—¥ã‚’ä½¿ç”¨ï¼‰<br>ï¼ˆæœªãƒ?ã‚§ãƒƒã‚¯ãƒ¼å…¨ã?¦ã?®å…¥åŠ›ã‚’è«‹æ±‚æ”¯æ‰•æ—¥ã?«è¨ˆä¸Šï¼‰</small>',0),(223232,6201,'pt','Post a data de fim do perÃ­odo<br><small>(para a despesa..--usar data de verificaÃ§Ã£o para verificar a quantidade)<br>(nÃ£o verificado - todas as entradas do post para verificar a data)</small>',0),(223233,6201,'ru','ÐŸÐ¾ÑÑ‚ Ð´Ð»Ñ Ð´Ð°Ñ‚Ñ‹ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°<br><small>(Ð·Ð° ÑÑ‡ÐµÑ‚--Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½ÑƒÑŽ Ð´Ð°Ñ‚Ñƒ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ ÑÑƒÐ¼Ð¼Ñ‹)<br>(Ñ„Ð»Ð°Ð¶Ð¾Ðº ÑÐ½ÑÑ‚ - Ð²ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ð¾ÑÑ‚ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ',0),(223234,6201,'es','Asentar a Fecha de TÃ©rminaciÃ³n<br><chico>(para gasto -- uar fecha de cheque para monto de cheque)<br>(no checado - todas las entradas asentan a la fecha del cheque)</chico>',0),(223235,6201,'de','Post an Abschnittenddatum<br><small>(fÃ¼r Kosten--verwenden Sie KontrollkÃ¤stchen Datum fÃ¼r Scheckbetrag)<br>(unmarkiert - alle EintrÃ¤ge zu verÃ¶ffentlichen, um zu Ã¼berprÃ¼fen, Datum)</small>',0),(223236,6201,'en','Post to Period End Date<br><small>(for expense -- use check date for check amount)<br>(unchecked - all entries post to check date)</small>',0),(223237,6202,'is','',0),(223238,6202,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(223239,6202,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(223240,6202,'tr','Yeni kiÅŸi ekle',0),(223241,6202,'pl','Dodaj nowy kontakt',0),(223242,6202,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223243,6202,'ur','Ù†ÛŒØ§ Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(223244,6202,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð°',0),(223245,6202,'vi','ThÃªm LiÃªn Há»‡ Má»›i',0),(223246,6202,'af','Nuwe Kontak Byvoeg',0),(223247,6202,'ro','Adauga contact nou',0),(223248,6202,'et','Lisa uus kontakt',0),(223249,6202,'si','Dodaj nov stik',0),(223250,6202,'ba','Tambahkan kontak baru',0),(223251,6202,'nl','Nieuwe contactpersoon toevoegen',0),(223252,6202,'fi','LisÃ¤Ã¤ uusi yhteystieto',0),(223253,6202,'no','Legg til ny kontakt',0),(223254,6202,'da','TilfÃ¸j ny kontakt',0),(223255,6202,'ko','ìƒˆ ì—°ë½ì²˜ ì¶”ê°€',0),(223256,6202,'he','×”×•×¡×£ ××™×© ×§×©×¨ ×—×“×©',0),(223257,6202,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏ€Î±Ï†Î®Ï‚',0),(223258,6202,'zh','å¢žåŠ æ–°çš„è”ç³»äºº\r\n',0),(223259,6202,'sv','LÃ¤gg till ny kontakt',0),(223260,6202,'it','Aggiungi nuovo contatto',0),(223261,6202,'tl','',0),(223262,6202,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(223263,6202,'hi','à¤¨à¤¯à¤¾ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(223264,6202,'ms','Tambah kenalan baru',0),(223265,6202,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥ØªØµØ§Ù„ Ø¬Ø¯ÙŠØ¯',0),(223266,6202,'fr','Ajouter Nouveau Contact',0),(223267,6202,'jp','æ–°è¦?é€£çµ¡å…ˆã?®è¿½åŠ ',0),(223268,6202,'pt','Adicionar novo contacto',0),(223269,6202,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223270,6202,'es','Agregar Nuevo Contacto',0),(223271,6202,'de','Neuen Kontakt hinzufÃ¼gen',0),(223272,6202,'en','Add New Contact',0),(223273,6203,'is','',0),(223274,6203,'dr','Ø¢Ø¯Ø±Ø³ ',0),(223275,6203,'pr','Ø¢Ø¯Ø±Ø³ ',0),(223276,6203,'tr','Adres',0),(223277,6203,'pl','Adres',0),(223278,6203,'bg','ÐÐ´Ñ€ÐµÑ',0),(223279,6203,'ur','Ù¾ØªØ§',0),(223280,6203,'sr','ÐÐ´Ñ€ÐµÑÐ°',0),(223281,6203,'vi','Äá»‹a chá»‰',0),(223282,6203,'af','Adres',0),(223283,6203,'ro','Adresa',0),(223284,6203,'et','Aadress',0),(223285,6203,'si','Naslov',0),(223286,6203,'ba','Alamat',0),(223287,6203,'nl','Adres',0),(223288,6203,'fi','Osoite',0),(223289,6203,'no','Adresse',0),(223290,6203,'da','Adresse',0),(223291,6203,'ko','ì£¼ì†Œ',0),(223292,6203,'he','×›×ª×•×‘×ª',0),(223293,6203,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(223294,6203,'zh','åœ°å€\r\n',0),(223295,6203,'sv','Adress',0),(223296,6203,'it','Indirizzo',0),(223297,6203,'tl','',0),(223298,6203,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(223299,6203,'hi','à¤ªà¤¤à¥‡',0),(223300,6203,'ms','Alamat',0),(223301,6203,'ar','Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(223302,6203,'fr','Adresse',0),(223303,6203,'jp','ä½?æ‰€',0),(223304,6203,'pt','EndereÃ§o',0),(223305,6203,'ru','ÐÐ´Ñ€ÐµÑ',0),(223306,6203,'es','DirecciÃ³n',0),(223307,6203,'de','Adresse',0),(223308,6203,'en','Address',0),(223309,6204,'is','',0),(223310,6204,'dr','Ø¢Ø¯Ø±Ø³ Ø¨Ù‡ ØµÙˆØ±Øª Ù†Ø²ÙˆÙ„ÙŠ',0),(223311,6204,'pr','Ø¢Ø¯Ø±Ø³ Ø¨Ù‡ ØµÙˆØ±Øª Ù†Ø²ÙˆÙ„ÙŠ',0),(223312,6204,'tr','DESC adresi.',0),(223313,6204,'pl','Adres Desc.',0),(223314,6204,'bg','ÐÐ´Ñ€ÐµÑ Ð½Ð¸Ð·Ñ….',0),(223315,6204,'ur','Ø¯ÛŒØ³Ú© Ù¾ØªØ§ ÛÛ’ Û”',0),(223316,6204,'sr','ÐÐ´Ñ€ÐµÑÐ° Ð”ÐµÑÑ†.',0),(223317,6204,'vi','Diá»…n giáº£i Äá»‹a chá»‰ ',0),(223318,6204,'af','Adres Beskr.',0),(223319,6204,'ro','Adresa Desc.',0),(223320,6204,'et','Aadress Desc.',0),(223321,6204,'si','Naslov Desc.',0),(223322,6204,'ba','Alamat Za.',0),(223323,6204,'nl','Adres Desc.',0),(223324,6204,'fi','Osoite Desc.',0),(223325,6204,'no','Adresse Desc.',0),(223326,6204,'da','Adresse Desc.',0),(223327,6204,'ko','Desc ì£¼ì†Œ.',0),(223328,6204,'he','.×ª××•×¨ ×›×ª×•×‘×ª',0),(223329,6204,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Desc.',0),(223330,6204,'zh','åœ°å€å›¾ç¤ºã€‚\r\n',0),(223331,6204,'sv','Adress Desc.',0),(223332,6204,'it','Indirizzo Desc.',0),(223333,6204,'tl','',0),(223334,6204,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(223335,6204,'hi','Desc à¤•à¥‹ à¤¸à¤‚à¤¬à¥‹à¤§à¤¿à¤¤à¥¤',0),(223336,6204,'ms','Alamat Desc.',0),(223337,6204,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(223338,6204,'fr','Adresse Desc.',0),(223339,6204,'jp','ä½?æ‰€è¨˜è¿°',0),(223340,6204,'pt','EndereÃ§o Desc.',0),(223341,6204,'ru','ÐžÐ¿Ð¸Ñ. ÐÐ´Ñ€ÐµÑÐ°',0),(223342,6204,'es','DireccciÃ³n Desc.',0),(223343,6204,'de','Adresse Desc.',0),(223344,6204,'en','Address Desc.',0),(223345,6205,'is','',0),(223346,6205,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ØªÙ…Ø§Ø³',0),(223347,6205,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ØªÙ…Ø§Ø³',0),(223348,6205,'tr','KiÅŸi notlarÄ±',0),(223349,6205,'pl','Notatki o kontaktach',0),(223350,6205,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223351,6205,'ur','Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯ Ù†ÙˆÙ¹',0),(223352,6205,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(223353,6205,'vi','Ghi chÃº liÃªn há»‡',0),(223354,6205,'af','Kontak Notas',0),(223355,6205,'ro','Note de contact',0),(223356,6205,'et','KontaktimÃ¤rkmed',0),(223357,6205,'si','Kontaktne opombe',0),(223358,6205,'ba','Catatan kontak',0),(223359,6205,'nl','Contact notities',0),(223360,6205,'fi','YhteyshenkilÃ¶n muistiinpanot',0),(223361,6205,'no','Kontaktnotater',0),(223362,6205,'da','Kontakt noter',0),(223363,6205,'ko','ì—°ë½ì²˜ ë…¸íŠ¸',0),(223364,6205,'he','×”×¢×¨×•×ª ××™×© ×§×©×¨',0),(223365,6205,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ ÎµÏ€Î±Ï†ÏŽÎ½',0),(223366,6205,'zh','è”ç³»ç¥¨æ®\r\n',0),(223367,6205,'sv','Kontaktanteckningar',0),(223368,6205,'it','Note contatti',0),(223369,6205,'tl','',0),(223370,6205,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(223371,6205,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤¨à¥‹à¤Ÿà¥à¤¸',0),(223372,6205,'ms','Nota-Nota berhubung',0),(223373,6205,'ar','Ø§Ù„Ø¨ÙŠØ§Ù†',0),(223374,6205,'fr','Contact Notes',0),(223375,6205,'jp','é€£çµ¡å…ˆãƒ¡ãƒ¢',0),(223376,6205,'pt','Contatos notas',0),(223377,6205,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð°',0),(223378,6205,'es','Notas de Contactos',0),(223379,6205,'de','Kontakt Hinweise',0),(223380,6205,'en','Contact Notes',0),(223381,6206,'is','',0),(223382,6206,'dr','Ø§ÙŠÙ…ÙŠÙ„ ØªÙ…Ø§Ø³',0),(223383,6206,'pr','Ø§ÙŠÙ…ÙŠÙ„ ØªÙ…Ø§Ø³',0),(223384,6206,'tr','E-posta',0),(223385,6206,'pl','Adres e-mail',0),(223386,6206,'bg','Ð˜Ð¼ÐµÐ¹Ð»',0),(223387,6206,'ur','Ø§ÛŒ Ù…ÛŒÙ„',0),(223388,6206,'sr','Ð•-Ð¿Ð¾ÑˆÑ‚Ð°',0),(223389,6206,'vi','Email ',0),(223390,6206,'af','E-pos',0),(223391,6206,'ro','E-mail',0),(223392,6206,'et','E-mail',0),(223393,6206,'si','Email',0),(223394,6206,'ba','Email',0),(223395,6206,'nl','E-mail',0),(223396,6206,'fi','SÃ¤hkÃ¶posti',0),(223397,6206,'no','E-post',0),(223398,6206,'da','E-mail',0),(223399,6206,'ko','ë©”ì¼ ì£¼ì†Œ',0),(223400,6206,'he','×“×•×\"×œ',0),(223401,6206,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(223402,6206,'zh','ç”µé‚®\r\n',0),(223403,6206,'sv','E-post',0),(223404,6206,'it','Posta elettronica',0),(223405,6206,'tl','',0),(223406,6206,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(223407,6206,'hi','à¤ˆà¤®à¥‡à¤²',0),(223408,6206,'ms','E-mel',0),(223409,6206,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(223410,6206,'fr','Courriel',0),(223411,6206,'jp','ï¼¥ãƒ¡ãƒ¼ãƒ«',0),(223412,6206,'pt','Email',0),(223413,6206,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(223414,6206,'es','Email',0),(223415,6206,'de','E-Mail',0),(223416,6206,'en','Email',0),(223417,6207,'is','',0),(223418,6207,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ ØµÙˆØ±Øª Ù†Ø²ÙˆÙ„ÙŠ ',0),(223419,6207,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ ØµÙˆØ±Øª Ù†Ø²ÙˆÙ„ÙŠ ',0),(223420,6207,'tr','E-posta Desc.',0),(223421,6207,'pl','E-mail Desc.',0),(223422,6207,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð½Ð¸Ð·Ñ….',0),(223423,6207,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø¯ÛŒØ³Ú© Û”',0),(223424,6207,'sr','Ð•Ð¼Ð°Ð¸Ð» Ð”ÐµÑÑ†.',0),(223425,6207,'vi','MÃ´ Táº£ Email',0),(223426,6207,'af','E-pos Beskr.',0),(223427,6207,'ro','E-mail Desc.',0),(223428,6207,'et','E-posti Desc.',0),(223429,6207,'si','Email Desc.',0),(223430,6207,'ba','Email Desc.',0),(223431,6207,'nl','E-mail Desc.',0),(223432,6207,'fi','SÃ¤hkÃ¶postin kuvaus.',0),(223433,6207,'no','E-Desc.',0),(223434,6207,'da','E-mail Desc.',0),(223435,6207,'ko','ì´ë©”ì¼ Descìž…ë‹ˆë‹¤.',0),(223436,6207,'he','.×ª××•×¨ ×“×•×\"×œ',0),(223437,6207,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Desc.',0),(223438,6207,'zh','ç”µå­é‚®ä»¶å›¾ç¤ºã€‚\r\n',0),(223439,6207,'sv','E-Desc.',0),(223440,6207,'it','E-mail Desc.',0),(223441,6207,'tl','',0),(223442,6207,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(223443,6207,'hi','à¤ˆà¤®à¥‡à¤² Desc.',0),(223444,6207,'ms','E-mel Desc.',0),(223445,6207,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(223446,6207,'fr','Desc. du courriel',0),(223447,6207,'jp','ï¼¥ãƒ¡ãƒ¼ãƒ«è¨˜è¿°',0),(223448,6207,'pt','E-mail Desc.',0),(223449,6207,'ru','Email ÐžÐ¿Ð¸Ñ.',0),(223450,6207,'es','Email Desc.',0),(223451,6207,'de','E-Mail Desc.',0),(223452,6207,'en','Email Desc.',0),(223453,6208,'is','',0),(223454,6208,'dr','ØªÙ„ÙÙ† ØªÙ…Ø§ Ø³ Ø¨Ù‡ ØµÙˆØ±Øª Ù†Ø²ÙˆÙ„ÙŠ ',0),(223455,6208,'pr','ØªÙ„ÙÙ† ØªÙ…Ø§ Ø³ Ø¨Ù‡ ØµÙˆØ±Øª Ù†Ø²ÙˆÙ„ÙŠ ',0),(223456,6208,'tr','Telefon Desc.',0),(223457,6208,'pl','Telefon Desc.',0),(223458,6208,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ Ð½Ð¸Ð·Ñ….',0),(223459,6208,'ur','ÙÙˆÙ† Ø¯ÛŒØ³Ú© Û”',0),(223460,6208,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ Ð”ÐµÑÑ†.',0),(223461,6208,'vi','Diá»…n giáº£i Phone',0),(223462,6208,'af','Telefoon Beskr.',0),(223463,6208,'ro','Telefon Desc.',0),(223464,6208,'et','Telefoni kirjeldus',0),(223465,6208,'si','Telefon Desc.',0),(223466,6208,'ba','Desc telepon.',0),(223467,6208,'nl','Telefoon Desc.',0),(223468,6208,'fi','Puhelimen kuvaus.',0),(223469,6208,'no','Telefon Desc.',0),(223470,6208,'da','Telefon Desc.',0),(223471,6208,'ko','ì „í™” Descìž…ë‹ˆë‹¤.',0),(223472,6208,'he','.×ª××•×¨ ×˜×œ×¤×•×Ÿ',0),(223473,6208,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ Desc.',0),(223474,6208,'zh','è”ç³»ç”µè¯å›¾ç¤º\r\n',0),(223475,6208,'sv','Telefon Desc.',0),(223476,6208,'it','Telefono Desc.',0),(223477,6208,'tl','',0),(223478,6208,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(223479,6208,'hi','à¤«à¥‹à¤¨ Desc.',0),(223480,6208,'ms','Desc telefon.',0),(223481,6208,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ù‡Ø§ØªÙ',0),(223482,6208,'fr','TÃ©lÃ©phone Desc.',0),(223483,6208,'jp','é›»è©±ç•ªå?·è¨˜è¿°',0),(223484,6208,'pt','Telefone Desc.',0),(223485,6208,'ru','ÐžÐ¿Ð¸Ñ. Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(223486,6208,'es','TelÃ©fono Desc.',0),(223487,6208,'de','Telefon Desc.',0),(223488,6208,'en','Phone Desc.',0),(223489,6209,'is','',0),(223490,6209,'dr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(223491,6209,'pr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(223492,6209,'tr','BaÄŸlantÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(223493,6209,'pl','Kontakt pomyÅ›lnie zaktualizowana.',0),(223494,6209,'bg','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(223495,6209,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº Û”',0),(223496,6209,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(223497,6209,'vi','Äá»‹a Chá»‰ LiÃªn Há»‡ Cáº­p Nháº­t ThÃ nh CÃ´ng',0),(223498,6209,'af','Kontak suksesvol opdateer.',0),(223499,6209,'ro','Contact actualizat cu succes.',0),(223500,6209,'et','Kontakti vÃ¤rskendamine Ãµnnestus.',0),(223501,6209,'si','Stik uspeÅ¡no posodobljena.',0),(223502,6209,'ba','Hubungi diperbarui berhasil.',0),(223503,6209,'nl','Contactpersoon bijgewerkt.',0),(223504,6209,'fi','Yhteystiedot pÃ¤ivitetty.',0),(223505,6209,'no','Kontakt oppdatert.',0),(223506,6209,'da','Kontakt opdateret.',0),(223507,6209,'ko','ì—°ë½ì²˜ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(223508,6209,'he','.××™×© ×§×©×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(223509,6209,'el','Î•Ï€Î±Ï†Î® ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(223510,6209,'zh','è”ç³»æ›´æ–°æˆåŠŸã€‚\r\n',0),(223511,6209,'sv','Kontakt uppdaterades.',0),(223512,6209,'it','Contatto aggiornato con successo.',0),(223513,6209,'tl','',0),(223514,6209,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(223515,6209,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(223516,6209,'ms','Kenalan berjaya dikemas kini.',0),(223517,6209,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ø¥ØªØµØ§Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(223518,6209,'fr','Contact mise Ã  jour avec succÃ¨s.',0),(223519,6209,'jp','é€£çµ¡å…ˆã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(223520,6209,'pt','Contato atualizado com Ãªxito.',0),(223521,6209,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½.',0),(223522,6209,'es','Contacto actualizado exitosamente',0),(223523,6209,'de','Kontakt erfolgreich aktualisiert.',0),(223524,6209,'en','Contact updated successfully.',0),(223525,6210,'is','',0),(223526,6210,'dr','Ø­Ø°Ù Ø¢Ø¯Ø±Ø³ ',0),(223527,6210,'pr','Ø­Ø°Ù Ø¢Ø¯Ø±Ø³ ',0),(223528,6210,'tr','Adresini Sil',0),(223529,6210,'pl','UsuÅ„ adres',0),(223530,6210,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð°Ð´Ñ€ÐµÑ',0),(223531,6210,'ur','Ù¾ØªÛ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(223532,6210,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð°Ð´Ñ€ÐµÑÑƒ',0),(223533,6210,'vi','XÃ³a Ä‘á»‹a chá»‰',0),(223534,6210,'af','Skrap Adres',0),(223535,6210,'ro','ÅžtergeÅ£i adresa',0),(223536,6210,'et','Kustuta aadress',0),(223537,6210,'si','Izbrisati naslov',0),(223538,6210,'ba','Menghapus alamat',0),(223539,6210,'nl','Adres verwijderen',0),(223540,6210,'fi','Poista osoite',0),(223541,6210,'no','Slette adresse',0),(223542,6210,'da','Slette adresse',0),(223543,6210,'ko','ì£¼ì†Œ ì‚­ì œ',0),(223544,6210,'he','×ž×—×§ ×›×ª×•×‘×ª',0),(223545,6210,'el','Î”Î™Î‘Î“Î¡Î‘Î¦Î— Î”Î™Î•Î¥Î˜Î¥ÎÎ£Î—Î£',0),(223546,6210,'zh','åˆ é™¤åœ°å€',0),(223547,6210,'sv','Ta bort adress',0),(223548,6210,'it','Eliminare indirizzo',0),(223549,6210,'tl','',0),(223550,6210,'th','&#3621;&#3610;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(223551,6210,'hi','à¤ªà¤¤à¥‡ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(223552,6210,'ms','Menghapuskan alamat',0),(223553,6210,'ar','Ø­Ø°Ù Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(223554,6210,'fr','Supprimer adresse',0),(223555,6210,'jp','ä½?æ‰€ã?®æ¶ˆåŽ»',0),(223556,6210,'pt','Excluir endereÃ§o',0),(223557,6210,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÐÐ´Ñ€ÐµÑ',0),(223558,6210,'es','Eliminar DirecciÃ³n',0),(223559,6210,'de','Adresse lÃ¶schen',0),(223560,6210,'en','Delete Address',0),(223561,6211,'is','',0),(223562,6211,'dr','Ø­Ø°Ù Ø§ÙŠÙ…ÙŠÙ„ ',0),(223563,6211,'pr','Ø­Ø°Ù Ø§ÙŠÙ…ÙŠÙ„ ',0),(223564,6211,'tr','E-posta silme',0),(223565,6211,'pl','UsunÄ…Ä‡ wiadomoÅ›ci E-mail',0),(223566,6211,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð»',0),(223567,6211,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(223568,6211,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(223569,6211,'vi','XÃ³a Email',0),(223570,6211,'af','Skrap E-pos',0),(223571,6211,'ro','Åžterge E-mail',0),(223572,6211,'et','Kustuta e-mail',0),(223573,6211,'si','Izbrisati Email',0),(223574,6211,'ba','Hapus Email',0),(223575,6211,'nl','E-mail verwijderen',0),(223576,6211,'fi','Poista sÃ¤hkÃ¶posti',0),(223577,6211,'no','Slette e-post',0),(223578,6211,'da','Slette E-mail',0),(223579,6211,'ko','ì´ë©”ì¼ ì‚­ì œ',0),(223580,6211,'he','×ž×—×§ ×“×•×\"×œ',0),(223581,6211,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Email',0),(223582,6211,'zh','åˆ é™¤ç”µå­é‚®ä»¶\r\n',0),(223583,6211,'sv','Ta bort e-post',0),(223584,6211,'it','Eliminare Email',0),(223585,6211,'tl','',0),(223586,6211,'th','&#3621;&#3610;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(223587,6211,'hi','à¤ˆà¤®à¥‡à¤² à¤•à¥‹ à¤¨à¤·à¥à¤Ÿ',0),(223588,6211,'ms','Menghapuskan e-mel',0),(223589,6211,'ar','Ø­Ø°Ù Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(223590,6211,'fr','Supprimer le courriel',0),(223591,6211,'jp','ï¼¥ãƒ¡ãƒ¼ãƒ«ã?®æ¶ˆåŽ»',0),(223592,6211,'pt','Excluir E-mail',0),(223593,6211,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Email',0),(223594,6211,'es','Eliminar Email',0),(223595,6211,'de','E-Mail lÃ¶schen',0),(223596,6211,'en','Delete Email',0),(223597,6212,'is','',0),(223598,6212,'dr','Ø­Ø°Ù ØªÙ„ÙÙ† ',0),(223599,6212,'pr','Ø­Ø°Ù ØªÙ„ÙÙ† ',0),(223600,6212,'tr','Telefon silin',0),(223601,6212,'pl','UsunÄ…Ä‡ telefon',0),(223602,6212,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(223603,6212,'ur','ÙÙˆÙ† Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(223604,6212,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(223605,6212,'vi','XÃ³a Phone',0),(223606,6212,'af','Skrap Telefoon',0),(223607,6212,'ro','Sterge telefonul',0),(223608,6212,'et','Kustuta telefon',0),(223609,6212,'si','Izbrisati telefon',0),(223610,6212,'ba','Menghapus telepon',0),(223611,6212,'nl','Telefoon verwijderen',0),(223612,6212,'fi','Poistaa puhelimen',0),(223613,6212,'no','Slette telefon',0),(223614,6212,'da','Slet telefon',0),(223615,6212,'ko','ì „í™”ë¥¼ ì‚­ì œ',0),(223616,6212,'he','×ž×—×§ ×˜×œ×¤×•×Ÿ',0),(223617,6212,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ Ï„Î·Î»Î­Ï†Ï‰Î½Î¿',0),(223618,6212,'zh','åˆ é™¤ç”µè¯\r\n',0),(223619,6212,'sv','Ta bort telefonen',0),(223620,6212,'it','Eliminare il telefono',0),(223621,6212,'tl','',0),(223622,6212,'th','&#3621;&#3610;&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(223623,6212,'hi','à¤«à¤¼à¥‹à¤¨ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(223624,6212,'ms','Padam telefon',0),(223625,6212,'ar','Ø­Ø°Ù Ø§Ù„Ù‡Ø§ØªÙ',0),(223626,6212,'fr','Supprimer le tÃ©lÃ©phone',0),(223627,6212,'jp','é›»è©±ç•ªå?·ã?®æ¶ˆåŽ»',0),(223628,6212,'pt','Excluir telefone',0),(223629,6212,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€',0),(223630,6212,'es','Eliminar TelÃ©fono',0),(223631,6212,'de','Telefon lÃ¶schen',0),(223632,6212,'en','Delete Phone',0),(223633,6213,'is','',0),(223634,6213,'dr','Ù†Ø§Ù… ',0),(223635,6213,'pr','Ù†Ø§Ù… ',0),(223636,6213,'tr','Ä°lk ad',0),(223637,6213,'pl','ImiÄ™',0),(223638,6213,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ Ð¸Ð¼Ðµ',0),(223639,6213,'ur','Ù¾ÛÙ„Ø§ Ù†Ø§Ù…',0),(223640,6213,'sr','ÐŸÑ€Ð²Ð¾ Ð¸Ð¼Ðµ',0),(223641,6213,'vi','TÃªn Äáº§u tiÃªn',0),(223642,6213,'af','Voornaam',0),(223643,6213,'ro','Prenume',0),(223644,6213,'et','Eesnimi',0),(223645,6213,'si','Ime',0),(223646,6213,'ba','Nama pertama',0),(223647,6213,'nl','Voornaam',0),(223648,6213,'fi','Etunimi',0),(223649,6213,'no','Fornavn',0),(223650,6213,'da','Fornavn',0),(223651,6213,'ko','ì²« ë²ˆì§¸ ì´ë¦„',0),(223652,6213,'he','×©× ×¤×¨×˜×™',0),(223653,6213,'el','ÎŒÎ½Î¿Î¼Î±',0),(223654,6213,'zh','åå­—\r\n',0),(223655,6213,'sv','FÃ¶rnamn',0),(223656,6213,'it','Nome',0),(223657,6213,'tl','',0),(223658,6213,'th','&#3594;&#3639;&#3656;&#3629;&#3649;&#3619;&#3585;',0),(223659,6213,'hi','à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤®',0),(223660,6213,'ms','Nama pertama',0),(223661,6213,'ar','Ø§Ù„Ø¥Ø³Ù… Ø§Ù„Ø£ÙˆÙ„',0),(223662,6213,'fr','PrÃ©nom',0),(223663,6213,'jp','å??',0),(223664,6213,'pt','Primeiro nome',0),(223665,6213,'ru','Ð˜Ð¼Ñ',0),(223666,6213,'es','Nombre Primero',0),(223667,6213,'de','Vorname',0),(223668,6213,'en','First Name',0),(223669,6214,'is','',0),(223670,6214,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ ØªÙ…Ø§Ø³ ',0),(223671,6214,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ ØªÙ…Ø§Ø³ ',0),(223672,6214,'tr','Genel iletiÅŸim bilgileri',0),(223673,6214,'pl','Informacje ogÃ³lne kontakt',0),(223674,6214,'bg','ÐžÐ±Ñ‰ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(223675,6214,'ur','Ø¬Ù†Ø±Ù„ Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(223676,6214,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(223677,6214,'vi','ThÃ´ng tin liÃªn há»‡ chung',0),(223678,6214,'af','Algemene Kontakbesonderhede',0),(223679,6214,'ro','General Contact informaÅ£ii',0),(223680,6214,'et','Ãœldised kontaktandmed',0),(223681,6214,'si','SploÅ¡ni Kontakt',0),(223682,6214,'ba','Informasi kontak Umum',0),(223683,6214,'nl','Algemene Contact informatie',0),(223684,6214,'fi','Yleiset yhteystiedot',0),(223685,6214,'no','General kontaktinformasjon',0),(223686,6214,'da','Generelle kontaktoplysninger',0),(223687,6214,'ko','ì¼ë°˜ ì—°ë½ì²˜ ì •ë³´',0),(223688,6214,'he','×ž×™×“×¢ ×›×œ×œ×™ ×©×œ ××™×© ×§×©×¨',0),(223689,6214,'el','Î“ÎµÎ½Î¹ÎºÎ® Î•Ï€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(223690,6214,'zh','ä¸€èˆ¬è”ç³»ä¿¡æ¯\r\n',0),(223691,6214,'sv','AllmÃ¤nna kontaktuppgifter',0),(223692,6214,'it','Informazioni di contatto generale',0),(223693,6214,'tl','',0),(223694,6214,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3651;&#3609;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(223695,6214,'hi','à¤œà¤¨à¤°à¤² à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¤¨à¥‡ à¤¸à¤‚à¤¬à¤‚à¤§à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(223696,6214,'ms','Maklumat orang hubungan umum',0),(223697,6214,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¥ØªØµØ§Ù„ Ø§Ù„Ø¹Ø§Ù…Ø©',0),(223698,6214,'fr','Informations de Contact gÃ©nÃ©ral',0),(223699,6214,'jp','ä¸€èˆ¬é€£çµ¡å…ˆæƒ…å ±',0),(223700,6214,'pt','InformaÃ§Ãµes de contacto geral',0),(223701,6214,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð°Ñ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð°Ñ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(223702,6214,'es','InformaciÃ³n General de Contacto',0),(223703,6214,'de','Allgemeine Kontaktinformationen',0),(223704,6214,'en','General Contact Information',0),(223705,6215,'is','',0),(223706,6215,'dr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ ',0),(223707,6215,'pr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ ',0),(223708,6215,'tr','SoyadÄ±',0),(223709,6215,'pl','Nazwisko',0),(223710,6215,'bg','Ð¤Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(223711,6215,'ur','Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù…',0),(223712,6215,'sr','ÐŸÑ€ÐµÐ·Ð¸Ð¼Ðµ',0),(223713,6215,'vi','Há»',0),(223714,6215,'af','Van',0),(223715,6215,'ro','Numele de familie',0),(223716,6215,'et','Perekonnanimi',0),(223717,6215,'si','Priimek',0),(223718,6215,'ba','Nama belakang',0),(223719,6215,'nl','Achternaam',0),(223720,6215,'fi','Sukunimi',0),(223721,6215,'no','Etternavn',0),(223722,6215,'da','Efternavn',0),(223723,6215,'ko','ë§ˆì§€ë§‰ ì´ë¦„',0),(223724,6215,'he','×©× ×ž×©×¤×—×”',0),(223725,6215,'el','Î•Ï€ÏŽÎ½Ï…Î¼Î¿',0),(223726,6215,'zh','å§“\r\n',0),(223727,6215,'sv','Efternamn',0),(223728,6215,'it','Cognome',0),(223729,6215,'tl','',0),(223730,6215,'th','&#3609;&#3634;&#3617;&#3626;&#3585;&#3640;&#3621;',0),(223731,6215,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤®',0),(223732,6215,'ms','Nama bapa/keluarga',0),(223733,6215,'ar','Ø§Ù„Ù„Ù‚Ø¨',0),(223734,6215,'fr','Nom de famille',0),(223735,6215,'jp','å§“',0),(223736,6215,'pt','Ãšltimo nome',0),(223737,6215,'ru','Ð¤Ð°Ð¼Ð¸Ð»Ð¼Ð¸Ñ',0),(223738,6215,'es','Apellido',0),(223739,6215,'de','Nachname',0),(223740,6215,'en','Last Name',0),(223741,6216,'is','',0),(223742,6216,'dr','ØªÙ…Ø§Ø³ Ø¬Ø¯ÙŠØ¯ ',0),(223743,6216,'pr','ØªÙ…Ø§Ø³ Ø¬Ø¯ÙŠØ¯ ',0),(223744,6216,'tr','Yeni kiÅŸi',0),(223745,6216,'pl','Nowy kontakt',0),(223746,6216,'bg','ÐÐ¾Ð² ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223747,6216,'ur','Ù†ÛŒØ§ Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯',0),(223748,6216,'sr','ÐÐ¾Ð²Ð¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223749,6216,'vi','LiÃªn há»‡ má»›i',0),(223750,6216,'af','Nuwe Kontak',0),(223751,6216,'ro','PersoanÄƒ de Contact nouÄƒ',0),(223752,6216,'et','Uus kontakt',0),(223753,6216,'si','Nov stik',0),(223754,6216,'ba','Kontak baru',0),(223755,6216,'nl','Nieuw contact',0),(223756,6216,'fi','Uusi yhteystieto',0),(223757,6216,'no','Ny kontakt',0),(223758,6216,'da','Ny kontakt',0),(223759,6216,'ko','ìƒˆ ì—°ë½ì²˜',0),(223760,6216,'he','××™×© ×§×©×¨ ×—×“×©',0),(223761,6216,'el','ÎÎ­Î± ÎµÏ€Î±Ï†Î®',0),(223762,6216,'zh','æ–°çš„è”ç³»äºº\r\n',0),(223763,6216,'sv','Ny kontakt',0),(223764,6216,'it','Nuovo contatto',0),(223765,6216,'tl','',0),(223766,6216,'th','&#3605;&#3636;&#3629;&#3605;&#3656;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(223767,6216,'hi','à¤¨à¤¯à¤¾ à¤¸à¤‚à¤ªà¤°à¥à¤•',0),(223768,6216,'ms','Kenalan baru',0),(223769,6216,'ar','Ø¥ØªØµØ§Ù„ Ø¬Ø¯ÙŠØ¯',0),(223770,6216,'fr','Nouveau Contact',0),(223771,6216,'jp','æ–°è¦?é€£çµ¡å…ˆ',0),(223772,6216,'pt','Novo contato',0),(223773,6216,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223774,6216,'es','Nuevo Contacto',0),(223775,6216,'de','Neuen Kontakt',0),(223776,6216,'en','New Contact',0),(223777,6217,'is','',0),(223778,6217,'dr','Ø§Ù†ØªØ®Ø§Ø¨  ØªÙ…Ø§Ø³',0),(223779,6217,'pr','Ø§Ù†ØªØ®Ø§Ø¨  ØªÙ…Ø§Ø³',0),(223780,6217,'tr','KiÅŸi SeÃ§',0),(223781,6217,'pl','Wybierz kontakt',0),(223782,6217,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223783,6217,'ur','Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(223784,6217,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223785,6217,'vi','Chá»n liÃªn há»‡',0),(223786,6217,'af','Kies Kontak',0),(223787,6217,'ro','SelectaÅ£i contactul',0),(223788,6217,'et','Valige kontakt',0),(223789,6217,'si','Izberite stik',0),(223790,6217,'ba','Pilih kontak',0),(223791,6217,'nl','Selecteer contactpersoon',0),(223792,6217,'fi','Valitse kontakti',0),(223793,6217,'no','Velg kontakt',0),(223794,6217,'da','VÃ¦lg kontakt',0),(223795,6217,'ko','ì—°ë½ì²˜ ì„ íƒ',0),(223796,6217,'he','×‘×—×¨ ××™×© ×§×©×¨',0),(223797,6217,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎµÏ€Î±Ï†Î®',0),(223798,6217,'zh','é€‰æ‹©è”ç³»äºº\r\n',0),(223799,6217,'sv','VÃ¤lj kontakt',0),(223800,6217,'it','Selezionare il contatto',0),(223801,6217,'tl','',0),(223802,6217,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(223803,6217,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(223804,6217,'ms','Pilih orang hubungan',0),(223805,6217,'ar','Ø¥Ø®ØªØ± Ø§Ù„Ø¥ØªØµØ§Ù„',0),(223806,6217,'fr','SÃ©lectionnez Contact',0),(223807,6217,'jp','é€£çµ¡å…ˆã?®é?¸æŠž',0),(223808,6217,'pt','Selecione o contato',0),(223809,6217,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223810,6217,'es','Seleccionar Contacto',0),(223811,6217,'de','WÃ¤hlen Sie Kontakt',0),(223812,6217,'en','Select Contact',0),(223813,6218,'is','',0),(223814,6218,'dr','Ù‡ÙŠÚ† Ø¬Ø¯ÙˆÙ„ Ø§Ø·Ù„Ø§Ø¹Ø§ØªÙŠ Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(223815,6218,'pr','Ù‡ÙŠÚ† Ø¬Ø¯ÙˆÙ„ Ø§Ø·Ù„Ø§Ø¹Ø§ØªÙŠ Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(223816,6218,'tr','HiÃ§bir tablo bilgi verilmiÅŸtir.',0),(223817,6218,'pl','Brak informacji w tabeli podano.',0),(223818,6218,'bg','ÐÑÐ¼Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ, Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° Ðµ Ð´Ð°Ð´ÐµÐ½Ð°.',0),(223819,6218,'ur','Ú©ÙˆØ¦ÛŒ Ø¬Ø¯ÙˆÙ„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù†ÛÛŒÚº Ø¯ÛŒ Ú¯Ø¦ÛŒ ÛÛ’ Û”',0),(223820,6218,'sr','ÐÐµÐ¼Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð·Ð° ÑÑ‚Ð¾ Ñ˜Ðµ Ð´Ð¾Ð±Ð¸Ð¾.',0),(223821,6218,'vi','ChÆ°a chá»n báº£ng ThÃ´ng Tin',0),(223822,6218,'af','Geen tabelinligting is gegee.',0),(223823,6218,'ro','S-a dat nici o informaÅ£ii de masÄƒ.',0),(223824,6218,'et','Esitatud ei tabeli info.',0),(223825,6218,'si','Nobena tabela info je bila dana.',0),(223826,6218,'ba','Ada meja informasi telah diberikan.',0),(223827,6218,'nl','Geen info tabel heeft gekregen.',0),(223828,6218,'fi','Ei taulukon tietoja ei ole annettu.',0),(223829,6218,'no','Ingen tabell info har fÃ¥tt.',0),(223830,6218,'da','Ingen tabel info har fÃ¥et.',0),(223831,6218,'ko','ì•„ë‹ˆ í…Œì´ë¸” ì •ë³´ëŠ” ì£¼ì–´ì¡Œë‹¤.',0),(223832,6218,'he','××™×Ÿ ×ž×™×“×¢ ×‘×˜×‘×œ×” ×©× ×™×ª× ×”.',0),(223833,6218,'el','ÎˆÏ‡ÎµÎ¹ Î´Î¿Î¸ÎµÎ¯ ÎºÎ±Î¼Î¯Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯Î± Ï€Î¯Î½Î±ÎºÎ±.',0),(223834,6218,'zh','æ²¡æœ‰èµ‹äºˆè¡¨ä¿¡æ¯ã€‚\r\n',0),(223835,6218,'sv','Ingen tabell information har givits.',0),(223836,6218,'it','Nessuna tabella info Ã¨ stato dato.',0),(223837,6218,'tl','',0),(223838,6218,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3605;&#3634;&#3619;&#3634;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3651;&#3627;&#3657;',0),(223839,6218,'hi','à¤•à¥‹à¤ˆ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¥€ à¤—à¤ˆ à¤¹à¥ˆà¥¤',0),(223840,6218,'ms','Maklumat Jadual tidak diberi.',0),(223841,6218,'ar','ÙˆÙ‚Ø¯ Ø£Ø¹Ø·ÙŠØª Ù„Ø§ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¬Ø¯ÙˆÙ„.',0),(223842,6218,'fr','Aucune information de table n\'a Ã©tÃ© donnÃ©e.',0),(223843,6218,'jp','è¡¨æƒ…å ±ã?Œã?‚ã‚Šã?¾ã?›ã‚“',0),(223844,6218,'pt','Nenhuma informaÃ§Ã£o da tabela foi dada.',0),(223845,6218,'ru','ÐÐµÑ‚ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð±Ñ‹Ð»Ð¾ Ð´Ð°Ð½Ð¾.',0),(223846,6218,'es','No ha sido dado ninguna informaciÃ³n de tabla',0),(223847,6218,'de','Kein Tisch-Info wurde gegeben.',0),(223848,6218,'en','No table info has been given.',0),(223849,6219,'is','',0),(223850,6219,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ ',0),(223851,6219,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ ',0),(223852,6219,'tr','Ä°lgili kiÅŸi bilgilerini gÃ¼ncelleme',0),(223853,6219,'pl','ZaktualizowaÄ‡ dane kontaktowe',0),(223854,6219,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(223855,6219,'ur','Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(223856,6219,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñƒ',0),(223857,6219,'vi','Cáº­p Nháº­t ThÃ´ng Tin LiÃªn Láº¡c',0),(223858,6219,'af','Opdateer van Kontak Inligting',0),(223859,6219,'ro','Actualizare informaÅ£ii de Contact',0),(223860,6219,'et','Update kontaktinfo',0),(223861,6219,'si','Posodobite kontaktne informacije',0),(223862,6219,'ba','Memperbarui Info kontak',0),(223863,6219,'nl','Contact Info bijwerken',0),(223864,6219,'fi','PÃ¤ivitÃ¤ yhteystiedot',0),(223865,6219,'no','Oppdatere kontaktinformasjon',0),(223866,6219,'da','Opdatere kontakt Info',0),(223867,6219,'ko','ì—°ë½ì²˜ ì •ë³´ ì—…ë°ì´íŠ¸',0),(223868,6219,'he','×¢×“×›×Ÿ ×¤×¨×˜×™ ××™×© ×§×©×¨',0),(223869,6219,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î•Ï€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±',0),(223870,6219,'zh','æ›´æ–°è”ç³»äººä¿¡æ¯\r\n',0),(223871,6219,'sv','Uppdatera kontaktinfo',0),(223872,6219,'it','Aggiornare le informazioni di contatto',0),(223873,6219,'tl','',0),(223874,6219,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(223875,6219,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(223876,6219,'ms','Kemaskini Maklumat',0),(223877,6219,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„',0),(223878,6219,'fr','Mise Ã  jour Info Contact',0),(223879,6219,'jp','é€£çµ¡å…ˆæƒ…å ±ã?®æ›´æ–°',0),(223880,6219,'pt','Atualizar informaÃ§Ãµes de contato',0),(223881,6219,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½ÑƒÑŽ Ð˜Ð½Ñ„Ð¾',0),(223882,6219,'es','Actualizar Info d Contactos',0),(223883,6219,'de','Update Kontakt Info',0),(223884,6219,'en','Update Contact Info',0),(223885,6220,'is','',0),(223886,6220,'dr','Ø¢Ø¯Ø±Ø³ ØªÙ…Ø§Ø³',0),(223887,6220,'pr','Ø¢Ø¯Ø±Ø³ ØªÙ…Ø§Ø³',0),(223888,6220,'tr','Ä°letiÅŸim adresleri',0),(223889,6220,'pl','Adresy kontaktowe',0),(223890,6220,'bg','ÐÐ´Ñ€ÐµÑÐ¸ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223891,6220,'ur','Ø±Ø§Ø¨Ø·Û’ Ú©Û’ Ù¾ØªÛ’',0),(223892,6220,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð°Ð´Ñ€ÐµÑÐµ',0),(223893,6220,'vi','Äá»‹a chá»‰ liÃªn há»‡',0),(223894,6220,'af','Kontak Adres',0),(223895,6220,'ro','Adresele de contact',0),(223896,6220,'et','Aadressid',0),(223897,6220,'si','Kontaktni naslovi',0),(223898,6220,'ba','Alamat kontak',0),(223899,6220,'nl','Contact adressen',0),(223900,6220,'fi','Yhteystiedot',0),(223901,6220,'no','Kontaktadresser',0),(223902,6220,'da','Kontakt-adresser',0),(223903,6220,'ko','ì—°ë½ì²˜ ì£¼ì†Œ',0),(223904,6220,'he','×›×ª×•×‘×ª ××™×© ×§×©×¨',0),(223905,6220,'el','Î”Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚ ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚',0),(223906,6220,'zh','è”ç³»åœ°å€\r\n',0),(223907,6220,'sv','Kontaktadresser',0),(223908,6220,'it','Indirizzi di contatto',0),(223909,6220,'tl','',0),(223910,6220,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(223911,6220,'hi','à¤ªà¤¤à¥‡ à¤¸à¥‡ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚',0),(223912,6220,'ms','Hubungi alamat',0),(223913,6220,'ar','Ø¹Ù†Ø§ÙˆÙŠÙ† Ø§Ù„Ø¥ØªØµØ§Ù„',0),(223914,6220,'fr','Adresses de contact',0),(223915,6220,'jp','é€£çµ¡å…ˆä½?æ‰€',0),(223916,6220,'pt','EndereÃ§os de contato',0),(223917,6220,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ñ‹Ð¹ ÐÐ´Ñ€ÐµÑ',0),(223918,6220,'es','DirecciÃ³n de Contacto',0),(223919,6220,'de','Kontaktadressen',0),(223920,6220,'en','Contact Addresses',0),(223921,6221,'is','',0),(223922,6221,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ù‡Ø§ÙŠ ØªÙ…Ø§Ø³',0),(223923,6221,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ù‡Ø§ÙŠ ØªÙ…Ø§Ø³',0),(223924,6221,'tr','Ä°lgili kiÅŸi e-postalarÄ±',0),(223925,6221,'pl','Kontakt e-maile',0),(223926,6221,'bg','Ð•Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ð¿Ð¾Ñ‰Ð° Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223927,6221,'ur','Ø§ÛŒ Ù…ÛŒÙ„Ø² Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº',0),(223928,6221,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ðµ-Ð¼Ð°Ð¸Ð»Ð¾Ð²Ðµ',0),(223929,6221,'vi','LiÃªn Há»‡ Email',0),(223930,6221,'af','Kontak E-pos',0),(223931,6221,'ro','Mesajele de poÅŸtÄƒ electronicÄƒ de contact',0),(223932,6221,'et','Ãœhendust vÃµtta e-kirju',0),(223933,6221,'si','Kontaktna e-poÅ¡to',0),(223934,6221,'ba','Email kontak',0),(223935,6221,'nl','Contact E-mails',0),(223936,6221,'fi','Yhteystiedot sÃ¤hkÃ¶postit',0),(223937,6221,'no','Kontakt e-post',0),(223938,6221,'da','Kontakt E-mails',0),(223939,6221,'ko','ì—°ë½ì²˜ ì´ë©”ì¼',0),(223940,6221,'he','.×›×ª×•×‘×•×ª ×“×•×\"×œ ×©×œ ××™×© ×§×©×¨',0),(223941,6221,'el','E-mail Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚ ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚ Ï€Î¿Ï…',0),(223942,6221,'zh','è”ç³»ç”µå­é‚®ä»¶\r\n',0),(223943,6221,'sv','Kontakta e-post',0),(223944,6221,'it','Contatto email',0),(223945,6221,'tl','',0),(223946,6221,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(223947,6221,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤ˆà¤®à¥‡à¤²',0),(223948,6221,'ms','Hubungi e-mel',0),(223949,6221,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¥ØªØµØ§Ù„',0),(223950,6221,'fr','Courriels du contact',0),(223951,6221,'jp','é€£çµ¡å…ˆï¼¥ãƒ¡ãƒ¼ãƒ«',0),(223952,6221,'pt','E-mails de contato',0),(223953,6221,'ru','Ð¡Ð²ÑÐ·Ð°Ñ‚ÑŒÑÑ Ñ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(223954,6221,'es','Comunicarse con Emails',0),(223955,6221,'de','Kontakt-e-Mails',0),(223956,6221,'en','Contact Emails',0),(223957,6222,'is','',0),(223958,6222,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÙŠ ØªÙ„ÙÙ† ØªÙ…Ø§Ø³ ',0),(223959,6222,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÙŠ ØªÙ„ÙÙ† ØªÙ…Ø§Ø³ ',0),(223960,6222,'tr','Ä°lgili kiÅŸi telefon numaralarÄ±',0),(223961,6222,'pl','Telefony kontaktowe',0),(223962,6222,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(223963,6222,'ur','Ø±Ø§Ø¨Ø·Û ÙÙˆÙ† Ù†Ù…Ø¨Ø±',0),(223964,6222,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ð¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð°',0),(223965,6222,'vi','Sá»‘ Phone liÃªn há»‡',0),(223966,6222,'af','Kontak Foonnommers',0),(223967,6222,'ro','Numere de telefon de contact',0),(223968,6222,'et','Kontakttelefoninumbrid',0),(223969,6222,'si','Kontaktne telefonske Å¡tevilke',0),(223970,6222,'ba','Kontak nomor telepon',0),(223971,6222,'nl','Contact telefoonnummers',0),(223972,6222,'fi','Kontaktin puhnrot',0),(223973,6222,'no','Kontakt telefonnumre',0),(223974,6222,'da','Kontakt telefonnumre',0),(223975,6222,'ko','ì—°ë½ì²˜ ì „í™” ë²ˆí˜¸',0),(223976,6222,'he','×ž×¡×¤×¨×™ ×˜×œ×¤×•×Ÿ ×©×œ ××™×© ×§×©×¨',0),(223977,6222,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î± ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚',0),(223978,6222,'zh','è”ç³»ç”µè¯å·ç \r\n',0),(223979,6222,'sv','Kontaktnummer telefon',0),(223980,6222,'it','Numeri di telefono di contatto',0),(223981,6222,'tl','',0),(223982,6222,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(223983,6222,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤«à¥‹à¤¨ à¤¨à¤‚à¤¬à¤°',0),(223984,6222,'ms','Nombor telefon perhubungan',0),(223985,6222,'ar','Ø£Ø±Ù‚Ø§Ù… Ù‡ÙˆØ§ØªÙ Ø§Ù„Ø¥ØªØµØ§Ù„',0),(223986,6222,'fr','NumÃ©ros de tÃ©lÃ©phone de contact',0),(223987,6222,'jp','é€£çµ¡å…ˆé›»è©±ç•ªå?·',0),(223988,6222,'pt','NÃºmeros de telefone de contacto',0),(223989,6222,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ñ‹Ðµ ÐÐ¾Ð¼ÐµÑ€Ð° Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð¾Ð²',0),(223990,6222,'es','NÃºmeros Telefonicos de Contactos',0),(223991,6222,'de','Kontakt-Telefonnummern',0),(223992,6222,'en','Contact Phone Numbers',0),(223993,6223,'is','',0),(223994,6223,'dr','Ø¯ÙŠÚ¯Ø± ØªÙ…Ø§Ø³Ù‡Ø§',0),(223995,6223,'pr','Ø¯ÙŠÚ¯Ø± ØªÙ…Ø§Ø³Ù‡Ø§',0),(223996,6223,'tr','DiÄŸer kiÅŸiler',0),(223997,6223,'pl','Inne kontakty',0),(223998,6223,'bg','Ð”Ñ€ÑƒÐ³Ð¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(223999,6223,'ur','Ø¯ÛŒÚ¯Ø± Ø±Ø§Ø¨Ø·Û Ø§ÙØ±Ø§Ø¯',0),(224000,6223,'sr','ÐžÑÑ‚Ð°Ð»Ð¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(224001,6223,'vi','LiÃªn há»‡ khÃ¡c',0),(224002,6223,'af','Ander Kontakte',0),(224003,6223,'ro','Alte contacte',0),(224004,6223,'et','Muud kontaktid',0),(224005,6223,'si','Drugi stiki',0),(224006,6223,'ba','Kontak lainnya',0),(224007,6223,'nl','Andere contactpersonen',0),(224008,6223,'fi','Muut yhteystiedot',0),(224009,6223,'no','Andre kontakter',0),(224010,6223,'da','Andre kontaktpersoner',0),(224011,6223,'ko','ë‹¤ë¥¸ ì—°ë½ì²˜',0),(224012,6223,'he','×× ×©×™ ×§×©×¨ ××—×¨×™×',0),(224013,6223,'el','Î†Î»Î»ÎµÏ‚ ÎµÏ€Î±Ï†Î­Ï‚',0),(224014,6223,'zh','å…¶ä»–è”ç³»äºº\r\n',0),(224015,6223,'sv','Andra kontakter',0),(224016,6223,'it','Altri contatti',0),(224017,6223,'tl','',0),(224018,6223,'th','&#3594;&#3656;&#3629;&#3591;&#3607;&#3634;&#3591;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3629;&#3639;&#3656;&#3609;',0),(224019,6223,'hi','à¤…à¤¨à¥à¤¯ à¤¸à¤‚à¤ªà¤°à¥à¤•',0),(224020,6223,'ms','Orang hubungan lain',0),(224021,6223,'ar','Ø¥ØªØµØ§Ù„Ø§Øª Ø£Ø®Ø±Ù‰',0),(224022,6223,'fr','Autres Contacts',0),(224023,6223,'jp','ä»–ã?®é€£çµ¡å…ˆ',0),(224024,6223,'pt','Outros contatos',0),(224025,6223,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñ‹',0),(224026,6223,'es','Otros Contratos',0),(224027,6223,'de','Weitere Kontakte',0),(224028,6223,'en','Other Contacts',0),(224029,6224,'is','',0),(224030,6224,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ ',0),(224031,6224,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ ',0),(224032,6224,'tr','Ä°letiÅŸim bilgileri',0),(224033,6224,'pl','Informacje kontaktowe',0),(224034,6224,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(224035,6224,'ur','Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(224036,6224,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð˜Ð½Ñ„Ð¾',0),(224037,6224,'vi','ThÃ´ng tin liÃªn há»‡',0),(224038,6224,'af','Kontak Inligting',0),(224039,6224,'ro','InformaÅ£ii de contact',0),(224040,6224,'et','Kontaktinfo',0),(224041,6224,'si','Kontaktne informacije',0),(224042,6224,'ba','Info kontak',0),(224043,6224,'nl','Info van het contact',0),(224044,6224,'fi','Yhteystiedot',0),(224045,6224,'no','Kontaktinformasjon',0),(224046,6224,'da','Kontakt Info',0),(224047,6224,'ko','ì—°ë½ì²˜ ì •ë³´',0),(224048,6224,'he','×ž×™×“×¢ ×œ×™×¦×™×¨×ª ×§×©×¨',0),(224049,6224,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚',0),(224050,6224,'zh','è”ç³»æ–¹å¼\r\n',0),(224051,6224,'sv','Kontakt information',0),(224052,6224,'it','Contatto Info',0),(224053,6224,'tl','',0),(224054,6224,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(224055,6224,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(224056,6224,'ms','Maklumat untuk dihubungi',0),(224057,6224,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¥ØªØµØ§Ù„',0),(224058,6224,'fr','L\'information de contact',0),(224059,6224,'jp','é€£çµ¡å…ˆæƒ…å ±',0),(224060,6224,'pt','InformaÃ§Ã£o de contato',0),(224061,6224,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð°Ñ Ð˜Ð½Ñ„Ð¾',0),(224062,6224,'es','Info de Contactos',0),(224063,6224,'de','Kontakt Info',0),(224064,6224,'en','Contact Info',0),(224065,6225,'is','',0),(224066,6225,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ Ø§Ø¶Ø§ÙÙŠ',0),(224067,6225,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ Ø§Ø¶Ø§ÙÙŠ',0),(224068,6225,'tr','Ek iletiÅŸim bilgileri',0),(224069,6225,'pl','Dodatkowe dane kontaktowe',0),(224070,6225,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(224071,6225,'ur','Ø§Ø¶Ø§ÙÛŒ Ø±Ø§Ø¨Ø·Û Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(224072,6225,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð˜Ð½Ñ„Ð¾',0),(224073,6225,'vi','ThÃ´ng Tin LiÃªn Láº¡c Cá»™ng ThÃªm',0),(224074,6225,'af','Addisionele Kontak Inligting',0),(224075,6225,'ro','Info contact aditional',0),(224076,6225,'et','TÃ¤iendav kontaktinfo',0),(224077,6225,'si','Dodatne kontaktne informacije',0),(224078,6225,'ba','Tambahan Info Kontak',0),(224079,6225,'nl','Extra Contact Info',0),(224080,6225,'fi','LisÃ¤tietoja',0),(224081,6225,'no','Mer informasjon',0),(224082,6225,'da','Yderligere kontakt Info',0),(224083,6225,'ko','ì¶”ê°€ ì—°ë½ì²˜ ì •ë³´',0),(224084,6225,'he','×ž×™×“×¢ × ×•×¡×£ ×©×œ ××™×© ×§×©×¨',0),(224085,6225,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚',0),(224086,6225,'zh','æ›´è¯¦ç»†çš„è”ç³»ä¿¡æ¯\r\n',0),(224087,6225,'sv','Ytterligare kontaktinformation',0),(224088,6225,'it','Dati contatto addizionali',0),(224089,6225,'tl','',0),(224090,6225,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(224091,6225,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(224092,6225,'ms','Maklumat tambahan',0),(224093,6225,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¥ØªØµØ§Ù„ Ø¥Ø¶Ø§ÙÙŠØ©',0),(224094,6225,'fr','Contact Additionelle',0),(224095,6225,'jp','è¿½åŠ é€£çµ¡å…ˆæƒ…å ±',0),(224096,6225,'pt','InformaÃ§Ãµes adicionais de contato',0),(224097,6225,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð°Ñ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(224098,6225,'es','Info Adicional de Contacto',0),(224099,6225,'de','ZusÃ¤tzliche Kontaktinformationen',0),(224100,6225,'en','Additional Contact Info',0),(224101,6226,'is','',0),(224102,6226,'dr','Ø¢Ø³ÙŠØ¨ Ø¯ÙŠØ¯Ù‡ ',0),(224103,6226,'pr','Ø¢Ø³ÙŠØ¨ Ø¯ÙŠØ¯Ù‡ ',0),(224104,6226,'tr','HasarlÄ±',0),(224105,6226,'pl','Uszkodzony',0),(224106,6226,'bg','ÐŸÐ¾Ð²Ñ€ÐµÐ´ÐµÐ½',0),(224107,6226,'ur','Ú©Ùˆ Ù†Ù‚ØµØ§Ù† Ù¾ÛÙ†Ú†Ø§',0),(224108,6226,'sr','ÐžÑˆÑ‚ÐµÑ›ÐµÐ½',0),(224109,6226,'vi','HÆ° há»ng',0),(224110,6226,'af','Beskadig',0),(224111,6226,'ro','Deteriorate',0),(224112,6226,'et','Kahjustatud',0),(224113,6226,'si','PoÅ¡kodovana',0),(224114,6226,'ba','Rusak',0),(224115,6226,'nl','Beschadigd',0),(224116,6226,'fi','Vaurioitunut',0),(224117,6226,'no','Skadet',0),(224118,6226,'da','Beskadiget',0),(224119,6226,'ko','ì†ìƒ',0),(224120,6226,'he','×¤×’×•×',0),(224121,6226,'el','ÎšÎ±Ï„ÎµÏƒÏ„ÏÎ±Î¼Î¼Î­Î½Î¿',0),(224122,6226,'zh','æŸå\r\n',0),(224123,6226,'sv','Skadad',0),(224124,6226,'it','Danneggiato',0),(224125,6226,'tl','',0),(224126,6226,'th','&#3648;&#3611;&#3655;&#3609;&#3629;&#3633;&#3609;&#3605;&#3619;&#3634;&#3618;',0),(224127,6226,'hi','à¤•à¥à¤·à¤¤à¤¿à¤—à¥à¤°à¤¸à¥à¤¤',0),(224128,6226,'ms','Rosak',0),(224129,6226,'ar','Ø£Ø¶Ø±Ø§Ø±',0),(224130,6226,'fr','EndommagÃ©',0),(224131,6226,'jp','æ??å‚·',0),(224132,6226,'pt','Danificado',0),(224133,6226,'ru','ÐŸÐ¾Ð²Ñ€ÐµÐ¶Ð´ÐµÐ½',0),(224134,6226,'es','DaÃ±ado',0),(224135,6226,'de','BeschÃ¤digt',0),(224136,6226,'en','Damaged',0),(224137,6227,'is','',0),(224138,6227,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø®Ø³Ø§Ø±Øª Ø¯ÙŠØ¯Ù‡ ',0),(224139,6227,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø®Ø³Ø§Ø±Øª Ø¯ÙŠØ¯Ù‡ ',0),(224140,6227,'tr','Hasar miktarÄ±',0),(224141,6227,'pl','IloÅ›Ä‡ uszkodzonych',0),(224142,6227,'bg','ÐšÐ¾Ð» Ð¿Ð¾Ð²Ñ€ÐµÐ´ÐµÐ½',0),(224143,6227,'ur','Qty. Ú©Ùˆ Ù†Ù‚ØµØ§Ù† Ù¾ÛÙ†Ú†Ø§',0),(224144,6227,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜Ðµ Ð¾ÑˆÑ‚ÐµÑ›ÐµÐ½',0),(224145,6227,'vi','Sá»‘ lÆ°á»£ng há»ng',0),(224146,6227,'af','Hoev. Beskadig',0),(224147,6227,'ro','Cant. deteriorate',0),(224148,6227,'et','Kahjustunud kogus',0),(224149,6227,'si','KoliÄina poÅ¡kodovanih',0),(224150,6227,'ba','Qty. rusak',0),(224151,6227,'nl','Aantal beschadigd',0),(224152,6227,'fi','MÃ¤Ã¤rÃ¤ vaurioitunut',0),(224153,6227,'no','Antall skadet',0),(224154,6227,'da','Antal beskadiget',0),(224155,6227,'ko','ì†ìƒ ëœ ìˆ˜ëŸ‰',0),(224156,6227,'he','×›×ž×•×ª ×¤×’×•×',0),(224157,6227,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎºÎ±Ï„ÎµÏƒÏ„ÏÎ±Î¼Î¼Î­Î½Î¿',0),(224158,6227,'zh','æ•°é‡ã€‚æŸå\r\n',0),(224159,6227,'sv','Ant. skadad',0),(224160,6227,'it','QtÃ  danneggiato',0),(224161,6227,'tl','',0),(224162,6227,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3648;&#3626;&#3637;&#3618;&#3627;&#3634;&#3618;',0),(224163,6227,'hi','à¤•à¥à¤·à¤¤à¤¿à¤—à¥à¤°à¤¸à¥à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(224164,6227,'ms','Qty. rosak',0),(224165,6227,'ar','Qty. Ø§Ù„ØªØ§Ù„ÙØ©',0),(224166,6227,'fr','QtÃ© endommagÃ©',0),(224167,6227,'jp','ç ´æ??æ•°é‡?',0),(224168,6227,'pt','Qtd. danificado',0),(224169,6227,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð¿Ð¾Ð²Ñ€ÐµÐ¶Ð´ÐµÐ½',0),(224170,6227,'es','Cant. Danada',0),(224171,6227,'de','Menge beschÃ¤digt',0),(224172,6227,'en','Qty. Damaged',0),(224173,6228,'is','',0),(224174,6228,'dr','ÙƒØ¯ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(224175,6228,'pr','ÙƒØ¯ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(224176,6228,'tr','MÃ¼ÅŸteri kodu',0),(224177,6228,'pl','Kod klienta',0),(224178,6228,'bg','ÐšÐ¾Ð´ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(224179,6228,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆÚˆ',0),(224180,6228,'sr','Ð¨Ð¸Ñ„Ñ€Ñƒ ÐºÑƒÐ¿Ñ†Ð°',0),(224181,6228,'vi','MÃ£ KhÃ¡ch hÃ ng',0),(224182,6228,'af','Klant / KliÃ«nt kode',0),(224183,6228,'ro','Cod client',0),(224184,6228,'et','Kliendi kood',0),(224185,6228,'si','Å ifra kupca',0),(224186,6228,'ba','Kode pelanggan',0),(224187,6228,'nl','Klantcode',0),(224188,6228,'fi','Asiakkaan koodi',0),(224189,6228,'no','Kunden koden',0),(224190,6228,'da','Kunde kode',0),(224191,6228,'ko','ê³ ê° ì½”ë“œ',0),(224192,6228,'he','×§×•×“ ×œ×§×•×—',0),(224193,6228,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(224194,6228,'zh','å®¢æˆ·ç¼–å·\r\n',0),(224195,6228,'sv','Kund koden',0),(224196,6228,'it','Codice cliente',0),(224197,6228,'tl','',0),(224198,6228,'th','&#3619;&#3627;&#3633;&#3626;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(224199,6228,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹à¤¡',0),(224200,6228,'ms','Baca kod',0),(224201,6228,'ar','Ø±Ù…Ø² Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(224202,6228,'fr','Code client',0),(224203,6228,'jp','é¡§å®¢ã‚³ãƒ¼ãƒ‰',0),(224204,6228,'pt','CÃ³digo do cliente',0),(224205,6228,'ru','ÐšÐ¾Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(224206,6228,'es','Cliente CÃ³digo de',0),(224207,6228,'de','Kundencode',0),(224208,6228,'en','Customer Code',0),(224209,6229,'is','',0),(224210,6229,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙˆØ¯',0),(224211,6229,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙˆØ¯',0),(224212,6229,'tr','KÃ¢r',0),(224213,6229,'pl','PokaÅ¼ zysku',0),(224214,6229,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(224215,6229,'ur','Ù…Ù†Ø§ÙØ¹ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(224216,6229,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚',0),(224217,6229,'vi','Hiá»ƒn thá»‹ lá»£i nhuáº­n',0),(224218,6229,'af','Wys Wins',0),(224219,6229,'ro','AratÄƒ Profit',0),(224220,6229,'et','NÃ¤ita kasum',0),(224221,6229,'si','PokaÅ¾i dobiÄek',0),(224222,6229,'ba','Menunjukkan keuntungan',0),(224223,6229,'nl','Winst laten zien',0),(224224,6229,'fi','NÃ¤ytÃ¤ tulos',0),(224225,6229,'no','Vis profitt',0),(224226,6229,'da','Vis Profit',0),(224227,6229,'ko','ì‡¼ ì´ìµ',0),(224228,6229,'he','×”×¦×’ ×¨×•×•×—',0),(224229,6229,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎºÎ­ÏÎ´Î¿Ï…Ï‚',0),(224230,6229,'zh','æ˜¾ç¤ºç›ˆåˆ©\r\n',0),(224231,6229,'sv','Visa vinst',0),(224232,6229,'it','Visualizza profitto',0),(224233,6229,'tl','',0),(224234,6229,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3635;&#3652;&#3619;',0),(224235,6229,'hi','à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¾à¤­',0),(224236,6229,'ms','Menunjukkan keuntungan',0),(224237,6229,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø±Ø¨Ø­',0),(224238,6229,'fr','Spectacle bÃ©nÃ©fice',0),(224239,6229,'jp','åˆ©ç›Šã?®è¡¨ç¤º',0),(224240,6229,'pt','Mostrar lucro',0),(224241,6229,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ',0),(224242,6229,'es','Mostrar Utilidad',0),(224243,6229,'de','Karte-Gewinn',0),(224244,6229,'en','Show Profit',0),(224245,6230,'is','',0),(224246,6230,'dr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(224247,6230,'pr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(224248,6230,'tr','NasÄ±l iÅŸlenir',0),(224249,6230,'pl','Przetworzone jak',0),(224250,6230,'bg','ÐŸÑ€ÐµÑ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ ÐºÐ°Ðº',0),(224251,6230,'ur','Ú©Ø³ Ø·Ø±Ø­ Ú©ÛŒ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ',0),(224252,6230,'sr','ÐžÐ±Ñ€Ð°Ñ’ÐµÐ½Ð° ÐºÐ°ÐºÐ¾',0),(224253,6230,'vi','Xá»­ lÃ½ nhÆ° tháº¿ nÃ o',0),(224254,6230,'af','Hoe Moet Prosessering Gedoen Word',0),(224255,6230,'ro','Prelucrate cum',0),(224256,6230,'et','Kuidas tÃ¶Ã¶delda',0),(224257,6230,'si','Kako obdelati',0),(224258,6230,'ba','Diproses bagaimana',0),(224259,6230,'nl','Hoe verwerkt',0),(224260,6230,'fi','Miten kÃ¤sitellÃ¤',0),(224261,6230,'no','Behandlet hvordan',0),(224262,6230,'da','Behandlet hvordan',0),(224263,6230,'ko','ì–´ë–»ê²Œ ì²˜ë¦¬',0),(224264,6230,'he','×ž×¢×•×‘×“?',0),(224265,6230,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏŽÏ‚',0),(224266,6230,'zh','å¦‚ä½•å¤„ç†\r\n',0),(224267,6230,'sv','Hur bearbetas',0),(224268,6230,'it','Trattati come',0),(224269,6230,'tl','',0),(224270,6230,'th','&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3619;',0),(224271,6230,'hi','à¤•à¥ˆà¤¸à¥‡ à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤',0),(224272,6230,'ms','Diproses bagaimana',0),(224273,6230,'ar','ÙƒÙŠÙÙŠØ© Ù…Ø¹Ø§Ù„Ø¬Ø©',0),(224274,6230,'fr','TraitÃ©s comment',0),(224275,6230,'jp','å‡¦ç?†æ–¹æ³•',0),(224276,6230,'pt','Processado como',0),(224277,6230,'ru','ÐžÐ±Ñ€Ð°Ð±Ð°Ñ‚Ñ‹Ð²Ð°ÑŽÑ‚ÑÑ ÐºÐ°Ðº',0),(224278,6230,'es','Como Procesado',0),(224279,6230,'de','Wie verarbeitet',0),(224280,6230,'en','Processed How',0),(224281,6231,'is','',0),(224282,6231,'dr','WxL Ø¹Ø±Ø¶  * Ø·ÙˆÙ„',0),(224283,6231,'pr','WxL Ø¹Ø±Ø¶  * Ø·ÙˆÙ„',0),(224284,6231,'tr','WxL',0),(224285,6231,'pl','WxL',0),(224286,6231,'bg','WxL',0),(224287,6231,'ur','ÙˆÚ©Ø³Ù„',0),(224288,6231,'sr','WxÐ›',0),(224289,6231,'vi','WxL',0),(224290,6231,'af','WxL',0),(224291,6231,'ro','W X L',0),(224292,6231,'et','Wxl',0),(224293,6231,'si','WxL',0),(224294,6231,'ba','WxL',0),(224295,6231,'nl','WxL',0),(224296,6231,'fi','WxL',0),(224297,6231,'no','WxL',0),(224298,6231,'da','Bxl',0),(224299,6231,'ko','WxL',0),(224300,6231,'he','WxL',0),(224301,6231,'el','WxL',0),(224302,6231,'zh','å®½ x é•¿\r\n',0),(224303,6231,'sv','WxL',0),(224304,6231,'it','WxL',0),(224305,6231,'tl','',0),(224306,6231,'th','WxL',0),(224307,6231,'hi','WxL',0),(224308,6231,'ms','WxL',0),(224309,6231,'ar','ÙˆÙƒØ³Ù„',0),(224310,6231,'fr','Lxl',0),(224311,6231,'jp','WxL',0),(224312,6231,'pt','WxL',0),(224313,6231,'ru','WxL',0),(224314,6231,'es','WxL',0),(224315,6231,'de','BXL',0),(224316,6231,'en','WxL',0),(224317,6232,'is','',0),(224318,6232,'dr','Ø¨Ø¯ÙˆÙ† Ú†Ø§Ù¾  ',0),(224319,6232,'pr','Ø¨Ø¯ÙˆÙ† Ú†Ø§Ù¾  ',0),(224320,6232,'tr','Karakterler\'i',0),(224321,6232,'pl','Drukowa',0),(224322,6232,'bg','Nonprint',0),(224323,6232,'ur','Ù†ÙˆÙ†Ù¾Ø±ÛŒÙ†Ù¹',0),(224324,6232,'sr','ÐÐµÐ¼Ð¾Ð³ÑƒÑ›',0),(224325,6232,'vi','ChÆ°a in',0),(224326,6232,'af','Nonprint',0),(224327,6232,'ro','Nonprint',0),(224328,6232,'et','Poolitatakse',0),(224329,6232,'si','Nonprint',0),(224330,6232,'ba','Nonprint',0),(224331,6232,'nl','Alineamarke',0),(224332,6232,'fi','Nonprint',0),(224333,6232,'no','Sektorinndel',0),(224334,6232,'da','Nonprint',0),(224335,6232,'ko','Nonprint',0),(224336,6232,'he','×œ× ×ž×•×“×¤×¡×™×',0),(224337,6232,'el','Î‘Î´ÏÎ½Î±Ï„Î· ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(224338,6232,'zh','éžå°åˆ·\r\n',0),(224339,6232,'sv','Omtag',0),(224340,6232,'it','Tradu',0),(224341,6232,'tl','',0),(224342,6232,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(224343,6232,'hi','Nonprint',0),(224344,6232,'ms','Nonprint',0),(224345,6232,'ar','Ù†ÙˆÙ†Ø¨Ø±ÙŠÙ†Øª',0),(224346,6232,'fr','Automat',0),(224347,6232,'jp','é?žå?°åˆ·',0),(224348,6232,'pt','MÃ­vel',0),(224349,6232,'ru','Nonprint',0),(224350,6232,'es','No imprimir',0),(224351,6232,'de','Rechtschrei',0),(224352,6232,'en','Non-print',0),(224353,6233,'is','',0),(224354,6233,'dr','Ù†Ø§Ù… Ø´Ø±ÙƒØª Ùˆ Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø³Ù…Øª Ø±Ø§Ø³Øª  Ø¨Ø§ Ù„ÙˆÚ¯Ùˆ',0),(224355,6233,'pr','Ù†Ø§Ù… Ø´Ø±ÙƒØª Ùˆ Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø³Ù…Øª Ø±Ø§Ø³Øª  Ø¨Ø§ Ù„ÙˆÚ¯Ùˆ',0),(224356,6233,'tr','Åžirket adÄ± & adresi ile Logo saÄŸ tarafÄ±nda',0),(224357,6233,'pl','Nazwa firmy & adres po prawej stronie z Logo',0),(224358,6233,'bg','Ð¤Ð¸Ñ€Ð¼Ð° & Ð°Ð´Ñ€ÐµÑ Ð½Ð° Ð´ÑÑÐ½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð° Ñ Ð»Ð¾Ð³Ð¾',0),(224359,6233,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… & Ø¯Ø§Ø¦ÛŒÚº Ø¬Ø§Ù†Ø¨ Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ) Ú©Û’ Ø³Ø§ØªÚ¾ Ù¾ØªØ§',0),(224360,6233,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð°Ð´Ñ€ÐµÑÑƒ ÑÐ° Ð´ÐµÑÐ½Ðµ ÑÑ‚Ñ€Ð°Ð½Ðµ ÑÐ° Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿Ð¾Ð¼',0),(224361,6233,'vi','TÃªn cty & Ä‘á»‹a chá»‰ bÃªn pháº£i vá»›i \r\nLogo',0),(224362,6233,'af','Ondernemingnaam & Adres op Regterkant met Embleem',0),(224363,6233,'ro','Numele companiei & adresa de pe partea dreapta cu logo-ul',0),(224364,6233,'et','EttevÃµtte nimi ja aadress paremal pool koos logoga',0),(224365,6233,'si','Ime podjetja & naslov na desni strani z logotipom',0),(224366,6233,'ba','Nama perusahaan & alamat di sisi kanan dengan Logo',0),(224367,6233,'nl','Bedrijfsnaam & adres aan rechterkant met Logo',0),(224368,6233,'fi','Yrityksen nimi & osoite oikealla puolella logolla',0),(224369,6233,'no','Firmanavn & adresse hÃ¸yre med Logo',0),(224370,6233,'da','Firmanavn & adresse pÃ¥ hÃ¸jre Side med Logo',0),(224371,6233,'ko','íšŒì‚¬ ì´ë¦„ & ë¡œê³ ì™€ í•¨ê»˜ ì˜¤ë¥¸ìª½ì— ì£¼ì†Œ',0),(224372,6233,'he','×©× ×”×—×‘×¨×” & ×›×ª×•×‘×ª ×‘×¦×“ ×™×ž×™×Ÿ ×¢× ×œ×•×’×•',0),(224373,6233,'el','Î¤Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ & Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· ÏƒÏ„Î· Î´ÎµÎ¾Î¹Î¬ Ï€Î»ÎµÏ…ÏÎ¬ Î¼Îµ Î»Î¿Î³ÏŒÏ„Ï…Ï€Î¿',0),(224374,6233,'zh','å…¬å¸åç§°åŠåœ°å€åœ¨å³è¾¹ä¸Žæ ‡å¿—ä¸€èµ·\r\n',0),(224375,6233,'sv','FÃ¶retagets namn & adress pÃ¥ hÃ¶ger sida med logotyp',0),(224376,6233,'it','Nome della societÃ  & indirizzo sul lato destro con Logo',0),(224377,6233,'tl','',0),(224378,6233,'th','&#3594;&#3639;&#3656;&#3629;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3649;&#3621;&#3632;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3610;&#3609;&#3604;&#3657;&#3634;&#3609;&#3586;&#3623;&#3634;&#3614;&#3619;&#3657;&#3629;&#3617;&#3604;&#3657;&#3',0),(224379,6233,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® & à¤²à¥‹à¤—à¥‹ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤¹à¥€ à¤ªà¤•à¥à¤· à¤ªà¤° à¤ªà¤¤à¤¾',0),(224380,6233,'ms','Nama Syarikat & alamat pada sisi kanan dengan Logo',0),(224381,6233,'ar','Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø¢Ù†Ø¯ Ø§Ù„Ø¹Ù†ÙˆØ§Ù† Ø¹Ù„Ù‰ Ø§Ù„Ø¬Ø§Ù†Ø¨ Ø§Ù„Ø£ÙŠÙ…Ù† Ù…Ø¹ Ø§Ù„Ø´Ø¹Ø§Ø±',0),(224382,6233,'fr','Nom de la sociÃ©tÃ© & adresse cÃ´tÃ© droit avec Logo',0),(224383,6233,'jp','ä¼šç¤¾ã?®å??å‰?ã?¨ä½?æ‰€ã‚’ãƒ­ã‚´ã?®å?³å?´ã?«è¡¨ç¤º',0),(224384,6233,'pt','Nome da empresa & endereÃ§o do lado direito com logotipo',0),(224385,6233,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ & Ð°Ð´Ñ€ÐµÑ Ð½Ð° Ð¿Ñ€Ð°Ð²Ð¾Ð¹ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ðµ Ñ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿Ð¾Ð¼',0),(224386,6233,'es','Nombre y DirecciÃ³n de la Empresa en el Lado Derecho con Logo',0),(224387,6233,'de','Firmenname & Adresse auf der rechten Seite mit Logo',0),(224388,6233,'en','Company Name & Address on Right Side with Logo',0),(224389,6234,'is','',0),(224390,6234,'dr','Ø§ØµÙ„ÙŠ',0),(224391,6234,'pr','Ø§ØµÙ„ÙŠ',0),(224392,6234,'tr','Ana',0),(224393,6234,'pl','GÅ‚Ã³wne',0),(224394,6234,'bg','ÐžÑÐ½Ð¾Ð²Ð½Ð¸',0),(224395,6234,'ur','Ø³Ø¨ Ø³Û’ Ø§ÛÙ…',0),(224396,6234,'sr','Ð“Ð»Ð°Ð²Ð½Ð°',0),(224397,6234,'vi','ChÃ­nh',0),(224398,6234,'af','Hoof',0),(224399,6234,'ro','Pagina principalÄƒ',0),(224400,6234,'et','Esilehele',0),(224401,6234,'si','Glavni',0),(224402,6234,'ba','Utama',0),(224403,6234,'nl','Main',0),(224404,6234,'fi','PÃ¤Ã¤sivu',0),(224405,6234,'no','Main',0),(224406,6234,'da','Main',0),(224407,6234,'ko','ë©”ì¸',0),(224408,6234,'he','×¨××©×™',0),(224409,6234,'el','ÎšÏÏÎ¹Î±',0),(224410,6234,'zh','ä¸»è¦\r\n',0),(224411,6234,'sv','Main',0),(224412,6234,'it','Main',0),(224413,6234,'tl','',0),(224414,6234,'th','&#3627;&#3621;&#3633;&#3585;',0),(224415,6234,'hi','à¤®à¥‡à¤¨',0),(224416,6234,'ms','Utama',0),(224417,6234,'ar','Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(224418,6234,'fr','Main',0),(224419,6234,'jp','ãƒ¡ã‚¤ãƒ³',0),(224420,6234,'pt','Main',0),(224421,6234,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ',0),(224422,6234,'es','Principal',0),(224423,6234,'de','Main',0),(224424,6234,'en','Main',0),(224425,6235,'is','',0),(224426,6235,'dr','(Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù… ) Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(224427,6235,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³Ù‡Ø§Ù…(Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ) Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(224428,6235,'tr','Nonprint hisse senedi iÅŸlemi',0),(224429,6235,'pl','Nonprint czas procesu',0),(224430,6235,'bg','Nonprint Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(224431,6235,'ur','Ù†ÙˆÙ†Ù¾Ø±ÛŒÙ†Ù¹ Ø§Ø³Ù¹Ø§Ú© Ø¹Ù…Ù„',0),(224432,6235,'sr','ÐÐ¾Ð½Ð¿Ñ€Ð¸Ð½Ñ‚ Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(224433,6235,'vi','Xá»­ lÃ½ hÃ ng tá»“n khÃ´ng in',0),(224434,6235,'af','Ongedrukte Voorraad Proses',0),(224435,6235,'ro','Procesul nonprint de stoc',0),(224436,6235,'et','Nonprint Stock protsess',0),(224437,6235,'si','Nonprint zalog proces',0),(224438,6235,'ba','Proses saham nonprint',0),(224439,6235,'nl','Nonprint voorraad proces',0),(224440,6235,'fi','Nonprint varastossa prosessi',0),(224441,6235,'no','Nonprint lager prosessen',0),(224442,6235,'da','Nonprint Stock proces',0),(224443,6235,'ko','Nonprint ìž¬ê³  í”„ë¡œì„¸ìŠ¤',0),(224444,6235,'he','×ª×”×œ×™×š ×ž× ×™×•×ª nonprint',0),(224445,6235,'el','Nonprint Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±',0),(224446,6235,'zh','éžå°åˆ·è‚¡ç¥¨è¿‡ç¨‹\r\n',0),(224447,6235,'sv','Nonprint lager Process',0),(224448,6235,'it','Processo di magazzino nonprint',0),(224449,6235,'tl','',0),(224450,6235,'th','&#3652;&#3617;&#3656;&#3614;&#3636;&#3617;&#3614;&#3660;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(224451,6235,'hi','Nonprint à¤¸à¥à¤Ÿà¥‰à¤• à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾',0),(224452,6235,'ms','Proses saham nonprint',0),(224453,6235,'ar','Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ø£Ø³Ù‡Ù… Ù†ÙˆÙ†Ø¨Ø±ÙŠÙ†Øª',0),(224454,6235,'fr','Emporte-piÃ¨ce processus Stock',0),(224455,6235,'jp','é?žå?°åˆ·åœ¨åº«é?Žç¨‹',0),(224456,6235,'pt','Processo de estoque vinco',0),(224457,6235,'ru','Nonprint Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð¿Ñ€Ð¾Ñ†ÐµÑÑ',0),(224458,6235,'es','No Imprimir Proceso de Stock',0),(224459,6235,'de','Nonprint hat Prozess',0),(224460,6235,'en','Non-print Stock Process',0),(224461,6236,'is','',0),(224462,6236,'dr','Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(224463,6236,'pr','Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(224464,6236,'tr','Non-basÄ±lmamÄ±ÅŸ',0),(224465,6236,'pl','Nie drukowane',0),(224466,6236,'bg','Ð¡Ñ‚Ð°Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(224467,6236,'ur','ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û',0),(224468,6236,'sr','ÐšÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜Ñƒ',0),(224469,6236,'vi','KhÃ´ng in',0),(224470,6236,'af','Nie-uitgedrukte',0),(224471,6236,'ro','Non-imprimate',0),(224472,6236,'et','Non-trÃ¼kitud',0),(224473,6236,'si','Non-natisnjeno',0),(224474,6236,'ba','Dicetak bebas',0),(224475,6236,'nl','Niet bedrukt',0),(224476,6236,'fi','Ei painettu',0),(224477,6236,'no','Ikke-trykt',0),(224478,6236,'da','Ikke-trykte',0),(224479,6236,'ko','ë¹„ ì¸ì‡„',0),(224480,6236,'he','×ž×•×“×¤×¡ ×œ×œ×',0),(224481,6236,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î¼Î·',0),(224482,6236,'zh','éžæ‰“å°\r\n',0),(224483,6236,'sv','Icke-tryckta',0),(224484,6236,'it','Non-stampato',0),(224485,6236,'tl','',0),(224486,6236,'th','&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(224487,6236,'hi','à¤—à¥ˆà¤°-à¤®à¥à¤¦à¥à¤°à¤¿à¤¤',0),(224488,6236,'ms','Bercetak-bebas',0),(224489,6236,'ar','Ø¹Ø¯Ù… Ø·Ø¨Ø§Ø¹Ø©',0),(224490,6236,'fr','Non-imprimÃ©',0),(224491,6236,'jp','é?žå?°åˆ·ã?®',0),(224492,6236,'pt','Non-impresso',0),(224493,6236,'ru','Non Ð¿ÐµÑ‡Ð°Ñ‚Ð½Ñ‹Ð¹',0),(224494,6236,'es','No Imprimido',0),(224495,6236,'de','Nicht gedruckt',0),(224496,6236,'en','Non-printed',0),(224497,6237,'is','',0),(224498,6237,'dr','(ØªØ¹Ø¯ÙŠÙ„',0),(224499,6237,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ØµÙ„Ø§Ø­ (ØªØ¹Ø¯ÙŠÙ„',0),(224500,6237,'tr','FarkÄ± dÃ¼zeltmesi tutarÄ±.',0),(224501,6237,'pl','Kwota korekty',0),(224502,6237,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ',0),(224503,6237,'ur','Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ø±Ù‚Ù…',0),(224504,6237,'sr','Ð˜Ð·Ð½Ð¾Ñ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(224505,6237,'vi','Sá»‘ LÆ°á»£ng Sá»­a Äá»•i',0),(224506,6237,'af','Bedrag Reggestel',0),(224507,6237,'ro','Ajustare sumÄƒ',0),(224508,6237,'et','Korrigeerimise summa',0),(224509,6237,'si','Popravek zneska',0),(224510,6237,'ba','Penyesuaian jumlah',0),(224511,6237,'nl','Bedrag van de aanpassing',0),(224512,6237,'fi','Oikaisun',0),(224513,6237,'no','JusteringsbelÃ¸p',0),(224514,6237,'da','ReguleringsbelÃ¸b',0),(224515,6237,'ko','ì¡°ì • ê¸ˆì•¡',0),(224516,6237,'he','×¡×›×•× ×”×ª××ž×ª',0),(224517,6237,'el','Î Î¿ÏƒÏŒ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚',0),(224518,6237,'zh','è°ƒæ•´æ•°é‡\r\n',0),(224519,6237,'sv','Justeringsbelopp',0),(224520,6237,'it','Importo di rettifica',0),(224521,6237,'tl','',0),(224522,6237,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(224523,6237,'hi','à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤°à¤¾à¤¶à¤¿',0),(224524,6237,'ms','Jumlah pelarasan',0),(224525,6237,'ar','Ù…Ø¨Ù„Øº Ø§Ù„ØªØ³ÙˆÙŠØ©',0),(224526,6237,'fr','Montant de lâ€™ajustement',0),(224527,6237,'jp','èª¿æ•´é¡?',0),(224528,6237,'pt','Quantidade de ajuste',0),(224529,6237,'ru','ÐšÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ° ÑÑƒÐ¼Ð¼Ñ‹',0),(224530,6237,'es','Monto del Ajuste',0),(224531,6237,'de','Anpassungsbetrag',0),(224532,6237,'en','Adjustment Amount',0),(224533,6238,'is','',0),(224534,6238,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(224535,6238,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(224536,6238,'tr','baÅŸarÄ±yla oluÅŸturuldu',0),(224537,6238,'pl','zostaÅ‚ utworzony pomyÅ›lnie',0),(224538,6238,'bg','ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(224539,6238,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ ØªÛŒØ§Ø±',0),(224540,6238,'sr','ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°',0),(224541,6238,'vi','táº¡o thÃ nh cÃ´ng',0),(224542,6238,'af','suksesvol geskep',0),(224543,6238,'ro','creat cu succes',0),(224544,6238,'et','loomine Ãµnnestus',0),(224545,6238,'si','uspeÅ¡no ustvarjen',0),(224546,6238,'ba','dibuat dengan sukses',0),(224547,6238,'nl','met succes gemaakt',0),(224548,6238,'fi','luotu',0),(224549,6238,'no','opprettet',0),(224550,6238,'da','oprettet',0),(224551,6238,'ko','ì„±ê³µì ìœ¼ë¡œ ë§Œë“ ',0),(224552,6238,'he','× ×•×¦×¨×• ×‘×”×¦×œ×—×”',0),(224553,6238,'el','Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(224554,6238,'zh','åˆ›å»ºæˆåŠŸ\r\n',0),(224555,6238,'sv','har skapats',0),(224556,6238,'it','creato con successo',0),(224557,6238,'tl','',0),(224558,6238,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(224559,6238,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(224560,6238,'ms','berjaya dicipta',0),(224561,6238,'ar','Ø£Ù†Ø´ÙŠØ¡ Ø¨Ù†Ø¬Ø§Ø­',0),(224562,6238,'fr','crÃ©Ã© avec succÃ¨s',0),(224563,6238,'jp','ä½œæˆ?ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(224564,6238,'pt','criado com sucesso',0),(224565,6238,'ru','ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½',0),(224566,6238,'es','Creado exitosamente',0),(224567,6238,'de','wurde erfolgreich erstellt.',0),(224568,6238,'en','created successfully',0),(224569,6239,'is','',0),(224570,6239,'dr','ØªØ§Ø±ÙŠØ® ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØºÙŠÙŠØ± ÙŠØ§ÙØªÙ‡ Ø§Ø²',0),(224571,6239,'pr','ØªØ§Ø±ÙŠØ® ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØºÙŠÙŠØ± ÙŠØ§ÙØªÙ‡ Ø§Ø²',0),(224572,6239,'tr','DeÄŸiÅŸtirilen fatura tarihinden itibaren:',0),(224573,6239,'pl','Zmiany daty ustawy z:',0),(224574,6239,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð° Ð±Ð¸Ð» Ð´Ð°Ñ‚Ð° Ð¾Ñ‚:',0),(224575,6239,'ur','Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ø´Ø¯Û Ø¨Ù„ ØªØ§Ø±ÛŒØ®:',0),(224576,6239,'sr','Ð˜Ð·Ð¼ÐµÑšÐµÐ½Ð¸ Ð‘Ð¸Ð» Ð´Ð°Ñ‚ÑƒÐ¼ Ð¾Ð´:',0),(224577,6239,'vi','Thay Ä‘á»•i ngÃ y thanh toÃ¡n tá»«:',0),(224578,6239,'af','Veranderde Wetsontwerp datum vanaf:',0),(224579,6239,'ro','Modificat de lege data din:',0),(224580,6239,'et','Muudetud arve tÃ¤htaeg alates:',0),(224581,6239,'si','Bill datum spremembe od:',0),(224582,6239,'ba','Tanggal tagihan berubah dari:',0),(224583,6239,'nl','Gewijzigde Bill dateren uit:',0),(224584,6239,'fi','Muuttunut laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤:',0),(224585,6239,'no','Endrede Bill dato fra:',0),(224586,6239,'da','Ã†ndrede Bill dato fra:',0),(224587,6239,'ko','ë³€ê²½ ëœ ë¹Œ ë‚ ì§œ:',0),(224588,6239,'he','×ª××¨×™×š ×”×—×©×‘×•×Ÿ ×”×©×ª× ×” ×ž:',0),(224589,6239,'el','Î†Î»Î»Î±Î¾Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€ÏŒ:',0),(224590,6239,'zh','æ›´æ”¹å¸å•æ—¥æœŸä»Žï¼š\r\n',0),(224591,6239,'sv','Ã„ndrat Bill datum frÃ¥n:',0),(224592,6239,'it','Cambiato Bill data da:',0),(224593,6239,'tl','',0),(224594,6239,'th','&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3623;&#3633;&#3609;&#3592;&#3634;&#3585;:',0),(224595,6239,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¥‡ à¤¬à¤¿à¤² à¤¦à¤¿à¤¨à¤¾à¤‚à¤•:',0),(224596,6239,'ms','Tarikh bil berubah dari:',0),(224597,6239,'ar','ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ® Ø³Ù†Ø¯ Ù…Ù†:',0),(224598,6239,'fr','Changement Date de facturation de :',0),(224599,6239,'jp','æ”¯æ‰•æ—¥ã?Œã?“ã?®æ—¥ã?‹ã‚‰å¤‰æ›´ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(224600,6239,'pt','Alterada data da factura de:',0),(224601,6239,'ru','Ð”Ð°Ñ‚Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð¾Ñ‚:',0),(224602,6239,'es','Cambiado la Fecha de FacturaciÃ³n De:',0),(224603,6239,'de','GeÃ¤nderte Rechnung Datum aus:',0),(224604,6239,'en','Changed Bill Date From:',0),(224605,6240,'is','',0),(224606,6240,'dr','ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ±  ØªØºÙŠÙŠØ± ÙŠØ§ÙØªÙ‡ Ø§Ø²',0),(224607,6240,'pr','ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ±  ØªØºÙŠÙŠØ± ÙŠØ§ÙØªÙ‡ Ø§Ø²',0),(224608,6240,'tr','Fatura tarihinden itibaren deÄŸiÅŸti',0),(224609,6240,'pl','Zmianie daty faktury z',0),(224610,6240,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¾Ñ‚',0),(224611,6240,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(224612,6240,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸Ð»Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸Ð·',0),(224613,6240,'vi','Thay Ä‘á»•i ngÃ y hÃ³a Ä‘Æ¡n tá»«',0),(224614,6240,'af','Verander Faktuur Datums Vanaf',0),(224615,6240,'ro','Schimbat data facturii la',0),(224616,6240,'et','Muutunud arve kuupÃ¤evast alates',0),(224617,6240,'si','Spremenili datum raÄuna iz',0),(224618,6240,'ba','Mengubah tanggal faktur dari',0),(224619,6240,'nl','Factuurdatum van gewijzigd',0),(224620,6240,'fi','Muuttaa laskutuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(224621,6240,'no','Endret fakturadatoen fra',0),(224622,6240,'da','Ã†ndret fakturadatoen fra',0),(224623,6240,'ko','ì†¡ìž¥ ë‚ ì§œ ë³€ê²½',0),(224624,6240,'he','×ª××¨×™×š ×—×©×‘×•× ×™×ª ×ž×ª×•×š ×©×™× ×”',0),(224625,6240,'el','Î†Î»Î»Î±Î¾Îµ Î±Ï€ÏŒ Î—Î¼/Î½Î¯Î± Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(224626,6240,'zh','æ›´æ”¹å‘ç¥¨æ—¥æœŸä»Ž\r\n',0),(224627,6240,'sv','Ã„ndrade fakturadatum frÃ¥n',0),(224628,6240,'it','Cambiato la data della fattura da',0),(224629,6240,'tl','',0),(224630,6240,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3652;&#3604;&#3657;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3634;&#3585;',0),(224631,6240,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¸à¥‡ à¤¬à¤¦à¤²à¤¾',0),(224632,6240,'ms','Menukar tarikh invois dari',0),(224633,6240,'ar','ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù…Ù†',0),(224634,6240,'fr','ChangÃ© la Date de la facture de',0),(224635,6240,'jp','ï½žã?‹ã‚‰è«‹æ±‚æ—¥ã‚’å¤‰æ›´ã?—ã?¾ã?—ã?Ÿ',0),(224636,6240,'pt','Mudou a data da factura de',0),(224637,6240,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ð»Ð°ÑÑŒ Ð´Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð¾Ñ‚',0),(224638,6240,'es','Cambiado la Fecha de la Factura De',0),(224639,6240,'de','GeÃ¤ndert von Rechnungsdatum',0),(224640,6240,'en','Changed Invoice Date From',0),(224641,6241,'is','',0),(224642,6241,'dr','Ù‡Ù…Ù‡ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ â€“ Ø¨Ø¯ÙˆÙ† ØªÙÙƒÙŠÙƒ',0),(224643,6241,'pr','Ù‡Ù…Ù‡ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ â€“ Ø¨Ø¯ÙˆÙ† ØªÙÙƒÙŠÙƒ',0),(224644,6241,'tr','TÃ¼m Kategoriler - hiÃ§bir ayrÄ±m',0),(224645,6241,'pl','Wszystkie kategorie - nie separacji',0),(224646,6241,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ - Ñ€Ð°Ð·Ð´ÑÐ»Ð°',0),(224647,6241,'ur','ØªÙ…Ø§Ù… Ø²Ù…Ø±Û’ - Ú©ÙˆØ¦ÛŒ Ø¹Ù„ÛŒØ­Ø¯Ú¯ÛŒ',0),(224648,6241,'sr','Ð¡Ð²Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ - Ð½ÐµÐ¼Ð° Ñ€Ð°Ð·Ð»Ð¸ÐºÐµ',0),(224649,6241,'vi','Táº¥t Cáº£ CÃ¡c PhÃ¢n Loáº¡i - KhÃ´ng PhÃ¢n Ra',0),(224650,6241,'af','Alle Kategorie - Geen Onderskeid',0),(224651,6241,'ro','Toate categoriile - nici o separare',0),(224652,6241,'et','KÃµik kategooriad - mitte eraldatuse',0),(224653,6241,'si','Vse kategorije - nobenega loÄevanja',0),(224654,6241,'ba','Semua Kategori - Tanpa Separasi',0),(224655,6241,'nl','Alle categorieÃ«n - geen scheiding',0),(224656,6241,'fi','Kaikki tuoteryhmÃ¤t - erottamisen',0),(224657,6241,'no','Alle kategorier - ingen separasjon',0),(224658,6241,'da','Alle kategorier - ingen adskillelse',0),(224659,6241,'ko','ëª¨ë“  ì¢…ë¥˜-ë¶„ë¦¬',0),(224660,6241,'he','×›×œ ×”×§×˜×’×•×¨×™×•×ª - ××™×Ÿ ×”×¤×¨×“×”',0),(224661,6241,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ - Î´Î¹Î±Ï‡Ï‰ÏÎ¹ÏƒÎ¼ÏŒÏ‚ Î´ÎµÎ½',0),(224662,6241,'zh','æ‰€æœ‰ç±»åˆ« -æ²¡æœ‰åˆ†ç¦»\r\n',0),(224663,6241,'sv','Alla kategorier - ingen Separation',0),(224664,6241,'it','Tutte le categorie - nessuna separazione',0),(224665,6241,'tl','',0),(224666,6241,'th','&#3627;&#3617;&#3623;&#3604;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;-&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3649;&#3610;&#3656;&#3591;&#3649;&#3618;&#3585;',0),(224667,6241,'hi','à¤¸à¤­à¥€ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ - à¤•à¥‹à¤ˆ à¤œà¥à¤¦à¤¾à¤ˆ',0),(224668,6241,'ms','Semua kategori - pemisahan tidak',0),(224669,6241,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„ØªØµÙ†ÙŠÙØ§Øª-Ù„Ø§ ÙØµÙ„',0),(224670,6241,'fr','Toutes les catÃ©gories - pas de sÃ©paration',0),(224671,6241,'jp','å…¨ã?¦ã?®ã‚«ãƒ†ã‚´ãƒªãƒ¼ï¼?åˆ†é¡žã?ªã?—',0),(224672,6241,'pt','Todas as categorias - sem separaÃ§Ã£o',0),(224673,6241,'ru','Ð’ÑÐµ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ - Ð‘ÐµÐ· Ð Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ',0),(224674,6241,'es','Todas la CategorÃ­as - No SeparaciÃ³n',0),(224675,6241,'de','Alle Kategorien - keine Trennung',0),(224676,6241,'en','All Categories - No Separation',0),(224677,6242,'is','',0),(224678,6242,'dr','Ù‡Ù…Ù‡ â€“ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¨Ø§ Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´ ',0),(224679,6242,'pr','Ù‡Ù…Ù‡ â€“ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¨Ø§ Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´ ',0),(224680,6242,'tr','TÃ¼m yayÄ±nlar-satÄ±ÅŸ kategoriye gÃ¶re grupla',0),(224681,6242,'pl','Wszystkie - Grupa kategorii sprzedaÅ¼y',0),(224682,6242,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ - Ð³Ñ€ÑƒÐ¿Ð° Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(224683,6242,'ur','-Ú¯Ø±ÙˆÙ¾ Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªÙ…Ø§Ù…',0),(224684,6242,'sr','Ð¡Ð²Ðµ - Ð³Ñ€ÑƒÐ¿Ðµ Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸',0),(224685,6242,'vi','Táº¥t Cáº£ - PhÃ¢n NhÃ³m Theo Loáº¡i Sales',0),(224686,6242,'af','Almal - Groep per Verkoopskategorie',0),(224687,6242,'ro','Toate - grup de categoria vanzari',0),(224688,6242,'et','KÃµik - kontserni mÃ¼Ã¼k kategooria jÃ¤rgi',0),(224689,6242,'si','Vse - skupina po prodaji kategoriji',0),(224690,6242,'ba','Semua - grup dengan penjualan Kategori',0),(224691,6242,'nl','Alle - verkoop categorie groeperen',0),(224692,6242,'fi','Kaikki - ryhmÃ¤n myyntiluokittain',0),(224693,6242,'no','Alle - gruppen av salg kategorien',0),(224694,6242,'da','Alle - grupper efter salgskategori',0),(224695,6242,'ko','ëª¨ë‘-íŒë§¤ ì¹´í…Œê³ ë¦¬ ê·¸ë£¹',0),(224696,6242,'he','×›×œ - ×§×‘×¥ ×œ×¤×™ ×§×˜×’×•×¨×™×” ×ž×›×™×¨×•×ª',0),(224697,6242,'el','ÎŒÎ»Î± - Î¿Î¼Î±Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· ÎºÎ±Ï„Î¬ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(224698,6242,'zh','å…¨éƒ¨ -æŒ‰é”€å”®ç±»åˆ«åˆ†ç»„\r\n',0),(224699,6242,'sv','Alla - grupp av fÃ¶rsÃ¤ljningskategori',0),(224700,6242,'it','Tutti - gruppo di categoria Sales',0),(224701,6242,'tl','',0),(224702,6242,'th','&#3607;&#3640;&#3585;&#3585;&#3621;&#3640;&#3656;&#3617;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3621;&#3635;&#3604;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(224703,6242,'hi','à¤¸à¤¬ - à¤¸à¤®à¥‚à¤¹ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(224704,6242,'ms','Semua - Kumpulan mengikut kategori jualan',0),(224705,6242,'ar','Ø§Ù„Ø¬Ù…ÙŠØ¹--Ù…Ø¬Ù…ÙˆØ¹Ø© Ù…Ù† ÙØ¦Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(224706,6242,'fr','Tous - Grouper par catÃ©gorie vente',0),(224707,6242,'jp','å…¨ã?¦ï¼?ã‚»ãƒ¼ãƒ«ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼åˆ¥ã‚°ãƒ«ãƒ¼ãƒ—',0),(224708,6242,'pt','Todos - grupo por categoria vendas',0),(224709,6242,'ru','Ð’ÑÐµ - Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð¿Ð¾ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(224710,6242,'es','Todas - CategorÃ­a de Grupo por Ventas',0),(224711,6242,'de','All - Gruppe nach Verkauf Kategorie',0),(224712,6242,'en','All - Group by Sales Category',0),(224713,6243,'is','',0),(224714,6243,'dr','Ù‚Ø§Ù„Ø¨ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª',0),(224715,6243,'pr','Ù‚Ø§Ù„Ø¨ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª',0),(224716,6243,'tr','AÃ§Ä±klama biÃ§imi',0),(224717,6243,'pl','Format instrukcji',0),(224718,6243,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(224719,6243,'ur','Ø¨ÛŒØ§Ù† ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(224720,6243,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(224721,6243,'vi','Dáº¡ng Sao kÃª',0),(224722,6243,'af','Staatformaat',0),(224723,6243,'ro','DeclaraÅ£ie Format',0),(224724,6243,'et','VÃ¤ljavÃµtte formaat',0),(224725,6243,'si','Izjava Format',0),(224726,6243,'ba','Pernyataan Format',0),(224727,6243,'nl','Verklaring van het formaat',0),(224728,6243,'fi','Lausunnon muodossa',0),(224729,6243,'no','Uttalelse-Format',0),(224730,6243,'da','ErklÃ¦ring Format',0),(224731,6243,'ko','ë¬¸ í˜•ì‹',0),(224732,6243,'he','×”×¦×”×¨×” ×ª×‘× ×™×ª',0),(224733,6243,'el','Î”Î®Î»Ï‰ÏƒÎ· Î¼Î¿ÏÏ†Î®',0),(224734,6243,'zh','å£°æ˜Žæ ¼å¼\r\n',0),(224735,6243,'sv','Uttalande Format',0),(224736,6243,'it','Istruzione formato',0),(224737,6243,'tl','',0),(224738,6243,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(224739,6243,'hi','à¤¬à¤¯à¤¾à¤¨ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(224740,6243,'ms','Format penyata',0),(224741,6243,'ar','Ø´ÙƒÙ„ Ø¨ÙŠØ§Ù†',0),(224742,6243,'fr','Format de dÃ©claration',0),(224743,6243,'jp','æ˜Žç´°æ›¸ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(224744,6243,'pt','Formato da instruÃ§Ã£o',0),(224745,6243,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(224746,6243,'es','Formato de DeclaraciÃ³n',0),(224747,6243,'de','Anweisung Format',0),(224748,6243,'en','Statement Format',0),(224749,6244,'is','',0),(224750,6244,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡',0),(224751,6244,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡',0),(224752,6244,'tr','Ekstre dÃ¶nemi baÅŸlangÄ±Ã§ tarihi',0),(224753,6244,'pl','Data rozpoczÄ™cia okresu instrukcja',0),(224754,6244,'bg','Ð˜Ð·ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(224755,6244,'ur','Ø¨ÛŒØ§Ù† Ú©Û’ Ø¯ÙˆØ± Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(224756,6244,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(224757,6244,'vi','NgÃ y báº¯t Ä‘áº§u cá»§a ká»³ Sao kÃª',0),(224758,6244,'af','Staat Periode Begin Datum',0),(224759,6244,'ro','DeclaraÅ£ie Ã®ncepe perioada data',0),(224760,6244,'et','VÃ¤ljavÃµtte alguskuupÃ¤ev',0),(224761,6244,'si','Izjava obdobje zaÄetni datum',0),(224762,6244,'ba','Pernyataan periode mulai tanggal',0),(224763,6244,'nl','Verklaring periode begindatum',0),(224764,6244,'fi','Lausunto kauden aloituspÃ¤ivÃ¤',0),(224765,6244,'no','Perioden begynner Utdragsdato',0),(224766,6244,'da','Perioden begynder Kontoudtogsdato',0),(224767,6244,'ko','ë¬¸ ê¸°ê°„ ì‹œìž‘ ë‚ ì§œ',0),(224768,6244,'he','×ª××¨×™×š ×‘×’×™×Ÿ ×ª×§×•×¤×ª ×”×¦×”×¨×”',0),(224769,6244,'el','Î”Î®Î»Ï‰ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚ Î­Î½Î±ÏÎ¾Î·Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(224770,6244,'zh','å£°æ˜Žæ—¶æœŸçš„å¼€å§‹æ—¥æœŸ\r\n',0),(224771,6244,'sv','Datum fÃ¶r perioden bÃ¶rjar',0),(224772,6244,'it','Data inizio periodo di istruzione',0),(224773,6244,'tl','',0),(224774,6244,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3594;&#3656;&#3623;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(224775,6244,'hi','à¤¬à¤¯à¤¾à¤¨ à¤…à¤µà¤§à¤¿ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(224776,6244,'ms','Tarikh tempoh mulakan penyata',0),(224777,6244,'ar','Ø¨ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„ÙØªØ±Ø©',0),(224778,6244,'fr','Date de dÃ©but de pÃ©riode de relevÃ©',0),(224779,6244,'jp','æ˜Žç´°æ›¸æœŸé–“é–‹å§‹æ—¥',0),(224780,6244,'pt','Data de inÃ­cio de perÃ­odo de declaraÃ§Ã£o',0),(224781,6244,'ru','ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ð°Ñ Ð”Ð°Ñ‚Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´Ð° Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(224782,6244,'es','PerÃ­odo de DeclaraciÃ³n Fecha de Inicio',0),(224783,6244,'de','Zeitraum Begin Auszugsdatum',0),(224784,6244,'en','Statement Period Begin Date',0),(224785,6245,'is','',0),(224786,6245,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡',0),(224787,6245,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡',0),(224788,6245,'tr','Ekstre dÃ¶nemi bitiÅŸ tarihi',0),(224789,6245,'pl','Data koÅ„cowa okresu instrukcja',0),(224790,6245,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐºÑ€Ð°Ð¹ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(224791,6245,'ur','ØªØ§Ø±ÛŒØ® Ø¨ÛŒØ§Ù† Ø¹Ø±ØµÛ Ø§Ø®ØªØªØ§Ù…',0),(224792,6245,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸Ð·Ð²Ð¾Ð´Ð° ÐºÑ€Ð°Ñ˜ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(224793,6245,'vi','NgÃ y cuá»‘i cá»§a ká»³ Sao kÃª',0),(224794,6245,'af','Staat Periode End Datum',0),(224795,6245,'ro','Data de sfÃ¢rÅŸit perioadÄƒ declaraÅ£ie',0),(224796,6245,'et','VÃ¤ljavÃµtte lÃµppkuupÃ¤ev',0),(224797,6245,'si','Izjava konÄni datum obdobja',0),(224798,6245,'ba','Tanggal periode akhir pernyataan',0),(224799,6245,'nl','Einde van de periode Afschriftdatum',0),(224800,6245,'fi','Lausunto pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(224801,6245,'no','Periodens slutt Utdragsdato',0),(224802,6245,'da','ErklÃ¦ring slutdato',0),(224803,6245,'ko','ë¬¸ ê¸°ê°„ ì¢…ë£Œ ë‚ ì§œ',0),(224804,6245,'he','×ª××¨×™×š ×¡×™×•× ×©×œ ×ª×§×•×¤×ª ×”×¦×”×¨×”',0),(224805,6245,'el','Î”Î®Î»Ï‰ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î· Ï„Î·Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(224806,6245,'zh','å£°æ˜Žæ—¶æœŸçš„ç»“æŸæ—¥æœŸ\r\n',0),(224807,6245,'sv','Uttalande slutdatum',0),(224808,6245,'it','Data di fine periodo di istruzione',0),(224809,6245,'tl','',0),(224810,6245,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3594;&#3656;&#3623;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(224811,6245,'hi','à¤¬à¤¯à¤¾à¤¨ à¤…à¤µà¤§à¤¿ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(224812,6245,'ms','Tarikh tamat tempoh penyata',0),(224813,6245,'ar','Ø¨ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©',0),(224814,6245,'fr','Date de fin de pÃ©riode de relevÃ©',0),(224815,6245,'jp','æ˜Žç´°æ›¸æœŸé–“çµ‚äº†æ—¥',0),(224816,6245,'pt','Data de fim do perÃ­odo de declaraÃ§Ã£o',0),(224817,6245,'ru','ÐšÐ¾Ð½ÐµÑ‡Ð½Ð°Ñ Ð”Ð°Ñ‚Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´Ð° Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(224818,6245,'es','PerÃ­odo de DeclaraciÃ³n Fecha de TerminaciÃ³n',0),(224819,6245,'de','Auszugsdatum Periodenende',0),(224820,6245,'en','Statement Period End Date',0),(224821,6246,'is','',0),(224822,6246,'dr','(ØªÚ©Øª)  Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(224823,6246,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ú¯Ø²ÙŠÙ†Ù‡ Ù…Ø¬ÙˆØ² Ø¹Ø¨ÙˆØ± (Ø¨Ù„ÙŠØ·)  ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(224824,6246,'tr','Bilet almak gÃ¶rmek iÃ§in tÄ±klayÄ±n',0),(224825,6246,'pl','Kliknij, aby wyÅ›wietliÄ‡ wybierz bilet',0),(224826,6246,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð±Ð¸Ð»ÐµÑ‚',0),(224827,6246,'ur','Ù¹Ú©Ù¹ Ù„ÛŒÙ†Û’ Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(224828,6246,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ ÐžÐ´Ð°Ð±ÐµÑ€Ð¸ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(224829,6246,'vi','Nháº¥n Ä‘á»ƒ xem VÃ© nháº­n hÃ ng',0),(224830,6246,'af','Klik om te kies kaartjie bekyk',0),(224831,6246,'ro','Click pentru a alege bilet',0),(224832,6246,'et','Vali Piletite vaatamiseks klÃµpsake',0),(224833,6246,'si','Kliknite za ogled Pick vozovnice',0),(224834,6246,'ba','Klik untuk melihat mengambil tiket',0),(224835,6246,'nl','Klik om te bekijken Pick Ticket',0),(224836,6246,'fi','Klikkaa nÃ¤hdÃ¤ksesi valita lippu',0),(224837,6246,'no','Klikk for Ã¥ vise plukke billett',0),(224838,6246,'da','Klik her for at se samle billet',0),(224839,6246,'ko','í´ë¦­ í•˜ ì—¬ ì„ íƒ í‹°ì¼“ ë³´ê¸°',0),(224840,6246,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’ ×›×¨×˜×™×¡ ×‘×•×—×¨',0),(224841,6246,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï€Î¬ÏÎµÎ¹ ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(224842,6246,'zh','ç‚¹å‡»æŸ¥çœ‹ç¥¨æ®\r\n',0),(224843,6246,'sv','Klicka fÃ¶r att Visa plocka biljett',0),(224844,6246,'it','Clicca per visualizzare il biglietto Pick',0),(224845,6246,'tl','',0),(224846,6246,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3605;&#3633;&#3659;&#3623;',0),(224847,6246,'hi','à¤Ÿà¤¿à¤•à¤Ÿ à¤²à¥‡à¤¨à¥‡ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(224848,6246,'ms','Klik untuk lihat Pilih Tiket',0),(224849,6246,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ø¹Ø±Ø¶ \"Ø§Ù„ØªØ°Ø§ÙƒØ± Ø¨ÙŠÙƒ\"',0),(224850,6246,'fr','Cliquer ici pour voir le billet de Pick',0),(224851,6246,'jp','é?¸æŠžãƒ?ã‚±ãƒƒãƒˆã‚’è¡¨ç¤ºã?™ã‚‹ã?«ã?¯ã?“ã?“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(224852,6246,'pt','Clique para ver os bilhetes de escolher',0),(224853,6246,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚',0),(224854,6246,'es','Click para Ver Boleto de SelecciÃ³n',0),(224855,6246,'de','Klicken Sie Ticket wÃ¤hlen an',0),(224856,6246,'en','Click to view Pick Ticket',0),(224857,6247,'is','',0),(224858,6247,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø³ÙØ§Ø±Ø´',0),(224859,6247,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø³ÙØ§Ø±Ø´',0),(224860,6247,'tr','SipariÅŸteki maddeler',0),(224861,6247,'pl','Elementy na zamÃ³wienie',0),(224862,6247,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(224863,6247,'ur','Ø¢Ø±ÚˆØ± Ù¾Ø± Ø§Ø´ÛŒØ§',0),(224864,6247,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ñƒ Ð½Ð°Ð»Ð¾Ð³Ñƒ',0),(224865,6247,'vi','Máº·t hÃ ng cá»§a Ä‘Æ¡n Ä‘áº·t hÃ ng ',0),(224866,6247,'af','Items op Bestelling',0),(224867,6247,'ro','Punctele de pe ordinea',0),(224868,6247,'et','Kaubad tellimusel',0),(224869,6247,'si','Artikli v nalogu',0),(224870,6247,'ba','Item dalam pesanan',0),(224871,6247,'nl','Artikelen op Order',0),(224872,6247,'fi','Tilauksen nimikkeet',0),(224873,6247,'no','Varer i ordre',0),(224874,6247,'da','Bestilte varer',0),(224875,6247,'ko','ì£¼ë¬¸ í•­ëª©',0),(224876,6247,'he','×¤×¨×™×˜×™× ×‘×”×–×ž× ×”',0),(224877,6247,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(224878,6247,'zh','è®¢å•ä¸Šçš„é¡¹ç›®\r\n',0),(224879,6247,'sv','Artiklarna som bestÃ¤lls',0),(224880,6247,'it','Articoli su ordine',0),(224881,6247,'tl','',0),(224882,6247,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(224883,6247,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤Ÿà¤¿à¤•à¤Ÿ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤šà¤¾à¤°',0),(224884,6247,'ms','Item pada pesanan',0),(224885,6247,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± ÙÙŠ ØªØ±ØªÙŠØ¨',0),(224886,6247,'fr','Articles sur commande',0),(224887,6247,'jp','æ³¨æ–‡ã?®å“?ç›®',0),(224888,6247,'pt','Itens na ordem',0),(224889,6247,'ru','Ð¢Ð¾Ð²Ð°Ñ€ Ð² Ð—Ð°ÐºÐ°Ð·Ðµ',0),(224890,6247,'es','Items en Orden',0),(224891,6247,'de','Artikel auf Bestellung',0),(224892,6247,'en','Items on Order',0),(224893,6248,'is','',0),(224894,6248,'dr','/ ØªÙØµÛŒÙ„ ',0),(224895,6248,'pr','ÙƒØ¯ ÙƒØ§Ù„Ø§ / Ø´Ø±Ø­',0),(224896,6248,'tr','Madde kodu / aÃ§Ä±klama',0),(224897,6248,'pl','Pozycja kod / opis',0),(224898,6248,'bg','ÐšÐ¾Ð´ Ð½Ð° ÑÑ‚Ð¾ÐºÐ°Ñ‚Ð° / Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(224899,6248,'ur','Ø´Û’ Ú©ÙˆÚˆ / Ø¨ÛŒØ§Ù†',0),(224900,6248,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð¨Ð¸Ñ„Ñ€Ð° / Ð¾Ð¿Ð¸Ñ',0),(224901,6248,'vi','MÃ£ hÃ ng / MÃ´ táº£',0),(224902,6248,'af','Itemkode / Beskrywing',0),(224903,6248,'ro','Element cod / descriere',0),(224904,6248,'et','Tootekood/kirjeldus',0),(224905,6248,'si','Postavka kodo / opis',0),(224906,6248,'ba','Kode barang / Keterangan',0),(224907,6248,'nl','Artikelcode / beschrijving',0),(224908,6248,'fi','Nimikekoodi / kuvaus',0),(224909,6248,'no','Varekode / beskrivelse',0),(224910,6248,'da','Punkt kode / beskrivelse',0),(224911,6248,'ko','ì½”ë“œ / ì„¤ëª…',0),(224912,6248,'he','×§×•×“ / ×ª×™××•×¨ ×¤×¨×™×˜',0),(224913,6248,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Î·Î½ ÎºÏŽÎ´Î¹ÎºÎ± / Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(224914,6248,'zh','äº§å“ä»£ç /æè¿°\r\n',0),(224915,6248,'sv','Artikelkod / Beskrivning',0),(224916,6248,'it','Codice articolo / Descrizione',0),(224917,6248,'tl','',0),(224918,6248,'th','&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;/&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(224919,6248,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ / à¤µà¤¿à¤µà¤°à¤£',0),(224920,6248,'ms','Kod perkara / keterangan',0),(224921,6248,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ù…Ø¯ÙˆÙ†Ø©/Ø§Ù„ÙˆØµÙ',0),(224922,6248,'fr','Code article / Description',0),(224923,6248,'jp','å“?ç›®ã‚³ãƒ¼ãƒ‰/èª¬æ˜Ž',0),(224924,6248,'pt','CÃ³digo do artigo / descriÃ§Ã£o',0),(224925,6248,'ru','ÐšÐ¾Ð´ Ð¢Ð¾Ð²Ð°Ñ€Ð° / ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(224926,6248,'es','Item CÃ³digo / Descripcion',0),(224927,6248,'de','Artikelcode / Beschreibung',0),(224928,6248,'en','Item Code / Description',0),(224929,6249,'is','',0),(224930,6249,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù„ÙŠØ·  Ø¨Ø±Ø§ÙŠ ',0),(224931,6249,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù„ÙŠØ·  Ø¨Ø±Ø§ÙŠ ',0),(224932,6249,'tr','Bilet iÃ§in SeÃ§',0),(224933,6249,'pl','Wybierz bilet',0),(224934,6249,'bg','Ð’Ð·ÐµÐ¼ÐµÑ‚Ðµ Ð±Ð¸Ð»ÐµÑ‚ Ð·Ð°',0),(224935,6249,'ur','Ù¹Ú©Ù¹ Ú©Û’ Ù„Ø¦Û’ Ú†Ù†ÛŒÚº',0),(224936,6249,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸ ÐºÐ°Ñ€Ñ‚Ñƒ Ð·Ð°',0),(224937,6249,'vi','Chá»n phiáº¿u cho',0),(224938,6249,'af','Kaartjie vir tel',0),(224939,6249,'ro','Alege biletul pentru',0),(224940,6249,'et','Vali pilet',0),(224941,6249,'si','Pick vozovnice za',0),(224942,6249,'ba','Pilih tiket untuk',0),(224943,6249,'nl','Kies Ticket voor',0),(224944,6249,'fi','Valitse lippu',0),(224945,6249,'no','Plukke billett',0),(224946,6249,'da','VÃ¦lg billet til',0),(224947,6249,'ko','í‹°ì¼“ì„ ì„ íƒí•˜ì‹œì˜¤',0),(224948,6249,'he','×œ×‘×—×•×¨ ×›×¨×˜×™×¡',0),(224949,6249,'el','Î Î¬ÏÎµÎ¹ ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿ Î³Î¹Î±',0),(224950,6249,'zh','é€‰æ‹©æœºç¥¨\r\n',0),(224951,6249,'sv','Plocka biljett fÃ¶r',0),(224952,6249,'it','Scegliere il biglietto per',0),(224953,6249,'tl','',0),(224954,6249,'th','&#3648;&#3585;&#3655;&#3610;&#3605;&#3633;&#3659;&#3623;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(224955,6249,'hi','à¤Ÿà¤¿à¤•à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ à¤¾à¤“',0),(224956,6249,'ms','Pilih tiket untuk',0),(224957,6249,'ar','Ø­Ø¬Ø² Ø§Ù„ØªØ°Ø§ÙƒØ± Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(224958,6249,'fr','Prendre des billets pour',0),(224959,6249,'jp','ï½žã?®é?¸æŠžãƒ?ã‚±ãƒƒãƒˆ',0),(224960,6249,'pt','Pegue o bilhete para',0),(224961,6249,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚',0),(224962,6249,'es','Boleto de SelecciÃ³npara',0),(224963,6249,'de','WÃ¤hlen Sie Ticket fÃ¼r',0),(224964,6249,'en','Pick Ticket for',0),(224965,6250,'is','',0),(224966,6250,'dr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡  ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª  Ø´Ù…Ø§ Ø§Ø³Øª',0),(224967,6250,'pr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡  ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª  Ø´Ù…Ø§ Ø§Ø³Øª',0),(224968,6250,'tr','Ekli cevabÄ±n bu.',0),(224969,6250,'pl','DoÅ‚Ä…czony jest TwojÄ… wypowiedÅº',0),(224970,6250,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¾ Ðµ Ð’Ð°ÑˆÐµÑ‚Ð¾ Ð¸Ð·ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(224971,6250,'ur','Ø¢Ù¾ Ú©Û’ Ø¨ÛŒØ§Ù† Ø³Û’ Ù…Ù†Ø³Ù„Ú© ÛÛ’',0),(224972,6250,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ Ñ˜Ðµ Ñ‚Ð²Ð¾Ñ˜Ð° Ð¸Ð·Ñ˜Ð°Ð²Ð°',0),(224973,6250,'vi','KÃ¨m Theo lÃ  Báº£ng CÃ´ng Ná»£ cá»§a báº¡n',0),(224974,6250,'af','Aangeheg is u Staat',0),(224975,6250,'ro','AtaÅŸat este declaraÅ£ia dumneavoastrÄƒ',0),(224976,6250,'et','Lisatud on teie avaldus',0),(224977,6250,'si','PriloÅ¾en je svojo izjavo',0),(224978,6250,'ba','Terlampir adalah pernyataan Anda',0),(224979,6250,'nl','Bijgevoegd is uw verklaring',0),(224980,6250,'fi','LiitteenÃ¤ on tiliotteessa',0),(224981,6250,'no','Vedlagt er kontoutskriften',0),(224982,6250,'da','VedhÃ¦ftet er din erklÃ¦ring',0),(224983,6250,'ko','ì²¨ë¶€ ë‚´ì—­ì´ìž…ë‹ˆë‹¤.',0),(224984,6250,'he','×ž×¦×•×¨×¤×ª ×”×”×¦×”×¨×” ×©×œ×š',0),(224985,6250,'el','Î£Ï…Î½Î·Î¼Î¼Î­Î½Î¿ ÎµÎ¯Î½Î±Î¹ Î· Î´Î®Î»Ï‰ÏƒÎ® ÏƒÎ±Ï‚',0),(224986,6250,'zh','é™„ä¸Šæ‚¨çš„å£°æ˜Ž\r\n',0),(224987,6250,'sv','Bifogat Ã¤r ert uttalande',0),(224988,6250,'it','La sua dichiarazione Ã¨ allegata',0),(224989,6250,'tl','',0),(224990,6250,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3649;&#3609;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(224991,6250,'hi','à¤…à¤ªà¤¨à¥‡ à¤¬à¤¯à¤¾à¤¨ à¤¸à¥‡ à¤œà¥à¤¡à¤¼à¥€ à¤¹à¥ˆ',0),(224992,6250,'ms','Berikut adalah penyata anda',0),(224993,6250,'ar','Ø§Ù„Ù…Ø±ÙÙ‚Ø© Ù‡ÙŠ Ø§Ù„Ø¹Ø¨Ø§Ø±Ø© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(224994,6250,'fr','AttachÃ© est votre relevÃ©',0),(224995,6250,'jp','æ˜Žç´°ã‚’æ·»ä»˜ã?—ã?¾ã?—ã?Ÿ',0),(224996,6250,'pt','Em anexo estÃ¡ o seu depoimento',0),(224997,6250,'ru','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ Ð²Ð°ÑˆÐµ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(224998,6250,'es','Anexado es su Estado de Cuenta',0),(224999,6250,'de','Ihre Aussage ist beigefÃ¼gt',0),(225000,6250,'en','Attached is your Statement',0),(225001,6251,'is','',0),(225002,6251,'dr','Ù…Ø§Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ',0),(225003,6251,'pr','Ù…Ø§Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ',0),(225004,6251,'tr','Dengesi iÃ§in',0),(225005,6251,'pl','Bilans',0),(225006,6251,'bg','Ð‘Ð°Ð»Ð°Ð½Ñ Ð·Ð°',0),(225007,6251,'ur','ØªÙˆØ§Ø²Ù† Ú©Û’ Ù„Ø¦Û’',0),(225008,6251,'sr','Ð¡Ð°Ð»Ð´Ð¾ Ð·Ð°',0),(225009,6251,'vi','Sá»‘ dÆ° cho',0),(225010,6251,'af','Balans Vir',0),(225011,6251,'ro','Echilibru pentru',0),(225012,6251,'et','Saldo:',0),(225013,6251,'si','Bilanca za',0),(225014,6251,'ba','Saldo untuk',0),(225015,6251,'nl','Balans voor',0),(225016,6251,'fi','Saldo',0),(225017,6251,'no','Saldoen For',0),(225018,6251,'da','Balance For',0),(225019,6251,'ko','ì— ëŒ€ í•œ ê· í˜•',0),(225020,6251,'he','×ž××–×Ÿ ×¢×‘×•×¨',0),(225021,6251,'el','Î™ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± Î³Î¹Î±',0),(225022,6251,'zh','ä½™é¢\r\n',0),(225023,6251,'sv','Balans fÃ¶r',0),(225024,6251,'it','Equilibrio per',0),(225025,6251,'tl','',0),(225026,6251,'th','&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(225027,6251,'hi','à¤¶à¥‡à¤· à¤•à¥‡ à¤²à¤¿à¤',0),(225028,6251,'ms','Baki bagi',0),(225029,6251,'ar','Ø§Ù„Ø±ØµÙŠØ¯',0),(225030,6251,'fr','Balance pour',0),(225031,6251,'jp','ï½žã?®å·®é¡?',0),(225032,6251,'pt','EquilÃ­brio para',0),(225033,6251,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ Ð”Ð»Ñ',0),(225034,6251,'es','Balance Para',0),(225035,6251,'de','Balance fÃ¼r',0),(225036,6251,'en','Balance For',0),(225037,6252,'is','',0),(225038,6252,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª  ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(225039,6252,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª  ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(225040,6252,'tr','AÃ§Ä±klamasÄ±nÄ± gÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klatÄ±n',0),(225041,6252,'pl','Kliknij, aby wyÅ›wietliÄ‡ instrukcja',0),(225042,6252,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(225043,6252,'ur','Ø¨ÛŒØ§Ù† Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(225044,6252,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(225045,6252,'vi','Nháº¥n Ä‘á»ƒ xem sao kÃª',0),(225046,6252,'af','Kliek om te Staat te besigtig',0),(225047,6252,'ro','Click pentru a vizualiza declaraÅ£ie',0),(225048,6252,'et','VÃ¤ljavÃµtte kuvamiseks klÃµpsake',0),(225049,6252,'si','Kliknite za ogled izjave',0),(225050,6252,'ba','Klik untuk melihat pernyataan',0),(225051,6252,'nl','Klik om te bekijken verklaring',0),(225052,6252,'fi','Klikkaa nÃ¤hdÃ¤ksesi ilmoitus',0),(225053,6252,'no','Klikk for Ã¥ vise uttalelse',0),(225054,6252,'da','Klik her for at se erklÃ¦ring',0),(225055,6252,'ko','ê³„ì‚° ì„œë¥¼ ë³´ë ¤ë©´ í´ë¦­',0),(225056,6252,'he','×œ×—×¥ ×œ×”×¦×’×ª ×”×¦×”×¨×”',0),(225057,6252,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î· Î´Î®Î»Ï‰ÏƒÎ·',0),(225058,6252,'zh','ç‚¹å‡»æŸ¥çœ‹è¯´æ˜Ž\r\n',0),(225059,6252,'sv','Klicka fÃ¶r att Visa uttalande',0),(225060,6252,'it','Clicca per visualizzare la dichiarazione',0),(225061,6252,'tl','',0),(225062,6252,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(225063,6252,'hi','à¤•à¤¥à¤¨ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(225064,6252,'ms','Klik untuk melihat kenyataan',0),(225065,6252,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ø¹Ø±Ø¶ Ø¨ÙŠØ§Ù†',0),(225066,6252,'fr','Cliquer ici pour voir la dÃ©claration',0),(225067,6252,'jp','æ˜Žç´°ã‚’è¦‹ã‚‹',0),(225068,6252,'pt','Clique para ver a declaraÃ§Ã£o',0),(225069,6252,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(225070,6252,'es','Click para Ver DeclaraciÃ³n',0),(225071,6252,'de','Hier klicken, um die Anweisung anzeigen',0),(225072,6252,'en','Click to view Statement',0),(225073,6253,'is','',0),(225074,6253,'dr','Ø§ÙŠÙ…ÙŠÙ„ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª',0),(225075,6253,'pr','Ø§ÙŠÙ…ÙŠÙ„ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª',0),(225076,6253,'tr','E-posta bildirimi',0),(225077,6253,'pl','Poczta elektroniczna instrukcja',0),(225078,6253,'bg','Email Ð´ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ',0),(225079,6253,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(225080,6253,'sr','Ð•Ð¼Ð°Ð¸Ð» Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(225081,6253,'vi','BÃ¡o cÃ¡o Email',0),(225082,6253,'af','E-pos Staat',0),(225083,6253,'ro','DeclaraÅ£ie de e-mail',0),(225084,6253,'et','Saada vÃ¤ljavÃµte e-postiga',0),(225085,6253,'si','Email izjavo',0),(225086,6253,'ba','Laporan email',0),(225087,6253,'nl','E verklaring',0),(225088,6253,'fi','Email ilmoitus',0),(225089,6253,'no','E-uttalelse',0),(225090,6253,'da','E-mail erklÃ¦ring',0),(225091,6253,'ko','ì´ë©”ì¼ ë¬¸ì˜',0),(225092,6253,'he','×”×¦×”×¨×ª ×“×•×\"×œ',0),(225093,6253,'el','Î”Î®Î»Ï‰ÏƒÎ· Ï„Î¿Ï… Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(225094,6253,'zh','ç”µå­é‚®ä»¶å£°æ˜Ž\r\n',0),(225095,6253,'sv','E-post uttalande',0),(225096,6253,'it','Posta elettronica istruzione',0),(225097,6253,'tl','',0),(225098,6253,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(225099,6253,'hi','à¤ˆà¤®à¥‡à¤² à¤¬à¤¯à¤¾à¤¨',0),(225100,6253,'ms','Penyata e-mel',0),(225101,6253,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(225102,6253,'fr','DÃ©claration de courriel',0),(225103,6253,'jp','æ˜Žç´°ã‚’Eãƒ¡ãƒ¼ãƒ«',0),(225104,6253,'pt','DeclaraÃ§Ã£o de e-mail',0),(225105,6253,'ru','Ð’Ñ‹Ð¿Ð¸ÑÐºÐ° Ð¿Ð¾ Email',0),(225106,6253,'es','Email DeclaraciÃ³n',0),(225107,6253,'de','E-Mail-Anweisung',0),(225108,6253,'en','Email Statement',0),(225109,6254,'is','',0),(225110,6254,'dr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡',0),(225111,6254,'pr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡',0),(225112,6254,'tr','KapalÄ±',0),(225113,6254,'pl','ZamkniÄ™te',0),(225114,6254,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾',0),(225115,6254,'ur','Ø¨Ù†Ø¯',0),(225116,6254,'sr','ÐžÐ³Ñ€Ð°Ñ’ÐµÐ½Ð¸',0),(225117,6254,'vi','ÄÃ­nh kÃ¨m',0),(225118,6254,'af','Ingeslote',0),(225119,6254,'ro','ÃŽnchise',0),(225120,6254,'et','Suletud',0),(225121,6254,'si','Zaprti',0),(225122,6254,'ba','Tertutup',0),(225123,6254,'nl','Ingesloten',0),(225124,6254,'fi','Suljettu',0),(225125,6254,'no','Vedlagt',0),(225126,6254,'da','Lukket',0),(225127,6254,'ko','ë™ë´‰',0),(225128,6254,'he','×œ×ž×›×ª×‘',0),(225129,6254,'el','ÎšÎ»ÎµÎ¹ÏƒÏ„ÏŒ',0),(225130,6254,'zh','å°é—­å¼\r\n',0),(225131,6254,'sv','Bifogat',0),(225132,6254,'it','Racchiuso',0),(225133,6254,'tl','',0),(225134,6254,'th','&#3621;&#3657;&#3629;&#3617;&#3619;&#3629;&#3610;',0),(225135,6254,'hi','à¤¸à¤‚à¤²à¤—à¥à¤¨',0),(225136,6254,'ms','Disertakan',0),(225137,6254,'ar','Ø§Ù„Ù…ØºÙ„Ù‚Ø©',0),(225138,6254,'fr','Clos',0),(225139,6254,'jp','å?Œå°?',0),(225140,6254,'pt','Fechado',0),(225141,6254,'ru','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ',0),(225142,6254,'es','Incluido',0),(225143,6254,'de','Eingeschlossen',0),(225144,6254,'en','Enclosed',0),(225145,6255,'is','',0),(225146,6255,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡ ',0),(225147,6255,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡ ',0),(225148,6255,'tr','Bu dÃ¶nemde Ã¶denen',0),(225149,6255,'pl','WypÅ‚acane tego okresu',0),(225150,6255,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ Ñ‚Ð¾Ð·Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(225151,6255,'ur','Ø§Ø³ Ø¯ÙˆØ± Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(225152,6255,'sr','ÐžÐ²Ð°Ñ˜ ÐŸÐµÑ€Ð¸Ð¾Ð´ Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(225153,6255,'vi','Tráº£ ká»³ nÃ y',0),(225154,6255,'af','Betaal in Hierdie Periode',0),(225155,6255,'ro','PlÄƒtit aceastÄƒ perioadÄƒ',0),(225156,6255,'et','Sellel perioodil makstakse',0),(225157,6255,'si','PlaÄa to obdobje',0),(225158,6255,'ba','Dibayar periode ini',0),(225159,6255,'nl','Deze periode betaald',0),(225160,6255,'fi','Maksettu tÃ¤nÃ¤ aikana',0),(225161,6255,'no','Betalt for denne perioden',0),(225162,6255,'da','Betalt denne periode',0),(225163,6255,'ko','ì´ ì‹œëŒ€ë¥¼ ì§€ë¶ˆ',0),(225164,6255,'he','×©×™×œ×ž×ª×™ ××ª ×”×ª×§×•×¤×” ×”×–××ª',0),(225165,6255,'el','Î‘Ï…Ï„Î® Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿ Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹',0),(225166,6255,'zh','è¿™æœŸé—´æ”¯ä»˜\r\n',0),(225167,6255,'sv','Betalat denna Period',0),(225168,6255,'it','Pagato questo periodo',0),(225169,6255,'tl','',0),(225170,6255,'th','&#3592;&#3656;&#3634;&#3618;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3609;&#3637;&#3657;',0),(225171,6255,'hi','à¤‡à¤¸ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(225172,6255,'ms','Dibayar tempoh ini',0),(225173,6255,'ar','Ø¯ÙØ¹Øª Ù‡Ø°Ù‡ Ø§Ù„ÙØªØ±Ø©',0),(225174,6255,'fr','PayÃ© cette pÃ©riode',0),(225175,6255,'jp','ã?“ã?®æœŸé–“ã?®æ”¯æ‰•',0),(225176,6255,'pt','Pago neste perÃ­odo',0),(225177,6255,'ru','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ð» ÑÑ‚Ð¾Ñ‚ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(225178,6255,'es','Pagado este PerÃ­odo',0),(225179,6255,'de','Diesem Zeitraum bezahlt',0),(225180,6255,'en','Paid this Period',0),(225181,6256,'is','',0),(225182,6256,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(225183,6256,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(225184,6256,'tr','Ã–denen toplam',0),(225185,6256,'pl','PÅ‚atne razem',0),(225186,6256,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(225187,6256,'ur','ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ Ú©Ù„',0),(225188,6256,'sr','ÐŸÐ»Ð°Ñ›ÐµÐ½Ð¸ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(225189,6256,'vi','Tá»•ng cá»™ng tráº£',0),(225190,6256,'af','Betaalde Totaal',0),(225191,6256,'ro','PlÄƒtit Total',0),(225192,6256,'et','Makstud kogusumma',0),(225193,6256,'si','Skupaj plaÄano',0),(225194,6256,'ba','Total dibayar',0),(225195,6256,'nl','Betaalde totaal',0),(225196,6256,'fi','Maksettu yhteensÃ¤',0),(225197,6256,'no','Betalte totalt',0),(225198,6256,'da','Betalt alt',0),(225199,6256,'ko','ìœ ë£Œ ì´',0),(225200,6256,'he','×©×™×œ× ×¡×”\"×›',0),(225201,6256,'el','ÎšÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(225202,6256,'zh','æ”¯ä»˜çš„æ€»\r\n',0),(225203,6256,'sv','Betalt totalt',0),(225204,6256,'it','Totale pagato',0),(225205,6256,'tl','',0),(225206,6256,'th','&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(225207,6256,'hi','à¤•à¥à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(225208,6256,'ms','Jumlah yang dibayar',0),(225209,6256,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(225210,6256,'fr','Total payÃ©',0),(225211,6256,'jp','æ”¯æ‰•ç·?é¡?',0),(225212,6256,'pt','Total pago',0),(225213,6256,'ru','ÐŸÐ»Ð°Ñ‚Ð½Ñ‹Ðµ Ð²ÑÐµÐ³Ð¾',0),(225214,6256,'es','Pagado Total',0),(225215,6256,'de','Bezahlte insgesamt',0),(225216,6256,'en','Paid Total',0),(225217,6257,'is','',0),(225218,6257,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ',0),(225219,6257,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ',0),(225220,6257,'tr','Deyim',0),(225221,6257,'pl','Instrukcja',0),(225222,6257,'bg','Ð”ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ',0),(225223,6257,'ur','Ø¨ÛŒØ§Ù†',0),(225224,6257,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð°',0),(225225,6257,'vi','Sao kÃª',0),(225226,6257,'af','Staat',0),(225227,6257,'ro','DeclaraÅ£ie',0),(225228,6257,'et','VÃ¤ljavÃµte',0),(225229,6257,'si','Izjava',0),(225230,6257,'ba','Pernyataan',0),(225231,6257,'nl','Verklaring',0),(225232,6257,'fi','Lausunto',0),(225233,6257,'no','Setningen',0),(225234,6257,'da','ErklÃ¦ring',0),(225235,6257,'ko','ë¬¸',0),(225236,6257,'he','×”×¦×”×¨×”',0),(225237,6257,'el','Î”Î®Î»Ï‰ÏƒÎ·',0),(225238,6257,'zh','å£°æ˜Ž\r\n',0),(225239,6257,'sv','Uttalande',0),(225240,6257,'it','Istruzione',0),(225241,6257,'tl','',0),(225242,6257,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(225243,6257,'hi','à¤¬à¤¯à¤¾à¤¨',0),(225244,6257,'ms','Penyata',0),(225245,6257,'ar','Ø¨ÙŠØ§Ù†',0),(225246,6257,'fr','DÃ©claration',0),(225247,6257,'jp','æ˜Žç´°',0),(225248,6257,'pt','DeclaraÃ§Ã£o',0),(225249,6257,'ru','Ð’Ñ‹Ð¿Ð¸ÑÐºÐ°',0),(225250,6257,'es','DeclaraciÃ³n',0),(225251,6257,'de','Anweisung',0),(225252,6257,'en','Statement',0),(225253,6258,'is','',0),(225254,6258,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø±Ø§ÙŠ',0),(225255,6258,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø±Ø§ÙŠ',0),(225256,6258,'tr','Deyim iÃ§in',0),(225257,6258,'pl','Instrukcja dla',0),(225258,6258,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð°',0),(225259,6258,'ur','Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(225260,6258,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð·Ð°',0),(225261,6258,'vi','Sao kÃª cho ',0),(225262,6258,'af','State vir',0),(225263,6258,'ro','DeclaraÅ£ie pentru',0),(225264,6258,'et','VÃ¤ljavÃµte',0),(225265,6258,'si','Izjava za',0),(225266,6258,'ba','Pernyataan untuk',0),(225267,6258,'nl','Verklaring voor',0),(225268,6258,'fi','Lausuma',0),(225269,6258,'no','Setningen for',0),(225270,6258,'da','RedegÃ¸relse for',0),(225271,6258,'ko','ëŒ€ í•œ ë¬¸',0),(225272,6258,'he','×”×¦×”×¨×” ×¢×‘×•×¨',0),(225273,6258,'el','Î”Î®Î»Ï‰ÏƒÎ· Î³Î¹Î±',0),(225274,6258,'zh','çš„å£°æ˜Ž\r\n',0),(225275,6258,'sv','RedogÃ¶relse fÃ¶r',0),(225276,6258,'it','Istruzione per',0),(225277,6258,'tl','',0),(225278,6258,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(225279,6258,'hi','à¤¬à¤¯à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤',0),(225280,6258,'ms','Penyata bagi',0),(225281,6258,'ar','Ø¨ÙŠØ§Ù† Ø¹Ù†',0),(225282,6258,'fr','DÃ©claration pour',0),(225283,6258,'jp','æ˜Žç´°',0),(225284,6258,'pt','InstruÃ§Ã£o para',0),(225285,6258,'ru','Ð’Ñ‹Ð¿Ð¸ÑÐºÐ° Ð´Ð»Ñ',0),(225286,6258,'es','DeclaraciÃ³n para',0),(225287,6258,'de','Anweisung fÃ¼r',0),(225288,6258,'en','Statement for',0),(225289,6259,'is','',0),(225290,6259,'dr','Ø¨Ø±Ø§ÙŠ Ø­Ø±ÙˆÙ Ø¨Ø²Ø±Ú¯',0),(225291,6259,'pr','Ø¨Ø±Ø§ÙŠ Ø­Ø±ÙˆÙ Ø¨Ø²Ø±Ú¯',0),(225292,6259,'tr','Hedef',0),(225293,6259,'pl','DO',0),(225294,6259,'bg','Ð”Ð',0),(225295,6259,'ur','Ú©Ø±Ù†Ø§',0),(225296,6259,'sr','Ð”Ð',0),(225297,6259,'vi','Tá»›i',0),(225298,6259,'af','AAN',0),(225299,6259,'ro','PENTRU A',0),(225300,6259,'et','ET',0),(225301,6259,'si','ZA',0),(225302,6259,'ba','UNTUK',0),(225303,6259,'nl','Aan',0),(225304,6259,'fi','JOTTA',0),(225305,6259,'no','TIL',0),(225306,6259,'da','TIL',0),(225307,6259,'ko','ë°›ëŠ” ì‚¬ëžŒ',0),(225308,6259,'he','××œ',0),(225309,6259,'el','ÎÎ‘',0),(225310,6259,'zh','å¯¹\r\n',0),(225311,6259,'sv','TILL',0),(225312,6259,'it','A',0),(225313,6259,'tl','',0),(225314,6259,'th','&#3606;&#3638;&#3591;',0),(225315,6259,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(225316,6259,'ms','UNTUK',0),(225317,6259,'ar','Ø¥Ù„Ù‰',0),(225318,6259,'fr','Ã€',0),(225319,6259,'jp','ï½žã?¸',0),(225320,6259,'pt','Para',0),(225321,6259,'ru','ÐšÐ¾Ð¼Ñƒ',0),(225322,6259,'es','A',0),(225323,6259,'de','An',0),(225324,6259,'en','TO',0),(225325,6260,'is','',0),(225326,6260,'dr','Ø®Ù„Ø§ØµÙ‡ ÙƒØ±Ø¯Ù† Ø¨Ù‡ ',0),(225327,6260,'pr','Ø®Ù„Ø§ØµÙ‡ ÙƒØ±Ø¯Ù† Ø¨Ù‡ ',0),(225328,6260,'tr','Ä°Ã§in Ã¶zetlemek',0),(225329,6260,'pl','PodsumowujÄ…c do',0),(225330,6260,'bg','ÐžÐ±Ð¾Ð±Ñ‰Ð°Ð²Ð°Ð½Ðµ Ð½Ð°',0),(225331,6260,'ur','Ø®Ù„Ø§ØµÛ Ú©Ø±Ù†Ø§',0),(225332,6260,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°ÑšÐµ Ð´Ð°',0),(225333,6260,'vi','Tá»•ng káº¿t tá»›i',0),(225334,6260,'af','Som om te',0),(225335,6260,'ro','Rezuma la',0),(225336,6260,'et','KokkuvÃµtet teha, andmeÃ¼ksuste',0),(225337,6260,'si','Povzeti',0),(225338,6260,'ba','Meringkas untuk',0),(225339,6260,'nl','Samenvatten naar',0),(225340,6260,'fi','Yhteenvedon',0),(225341,6260,'no','Summere',0),(225342,6260,'da','Opsummere til',0),(225343,6260,'ko','ìš”ì•½',0),(225344,6260,'he','×œ×¡×›× ××œ',0),(225345,6260,'el','Î£Ï…Î½Î¿ÏˆÎ¯ÏƒÏ„Îµ Î½Î±',0),(225346,6260,'zh','æ±‡æ€»åˆ°\r\n',0),(225347,6260,'sv','Sammanfatta att',0),(225348,6260,'it','Riassumere per',0),(225349,6260,'tl','',0),(225350,6260,'th','&#3626;&#3619;&#3640;&#3611;&#3652;&#3611;&#3626;&#3641;&#3656;',0),(225351,6260,'hi','à¤•à¥‹ à¤¸à¤‚à¤•à¥à¤·à¥‡à¤ª à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤ à¤•à¤°à¤¨à¤¾',0),(225352,6260,'ms','Merumuskan untuk',0),(225353,6260,'ar','Ø§Ù„ØªÙ„Ø®ÙŠØµ Ø¥Ù„Ù‰',0),(225354,6260,'fr','RÃ©sumer Ã ',0),(225355,6260,'jp','é›†è¨ˆ',0),(225356,6260,'pt','Resumir a',0),(225357,6260,'ru','ÐžÐ±Ð¾Ð±Ñ‰Ð¸Ñ‚ÑŒ',0),(225358,6260,'es','Sumarizar A',0),(225359,6260,'de','Zusammenfassen',0),(225360,6260,'en','Summarize To',0),(225361,6261,'is','',0),(225362,6261,'dr','- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225363,6261,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225364,6261,'tr','SatÄ±cÄ±-aracÄ±sÄ± ekleme',0),(225365,6261,'pl','Dodawanie dostawcy Agent',0),(225366,6261,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº-Ð°Ð³ÐµÐ½Ñ‚',0),(225367,6261,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û-Ø§ÛŒØ¬Ù†Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(225368,6261,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°-ÐÐ³ÐµÐ½Ñ‚',0),(225369,6261,'vi','ThÃªm NgÆ°á»i bÃ¡n-Ä‘áº¡i lÃ½',0),(225370,6261,'af','Verkoper-Agent voeg',0),(225371,6261,'ro','Adauga Agent de furnizor',0),(225372,6261,'et','Vendor-Agent Add',0),(225373,6261,'si','Dodaj prodajalca-zastopnika',0),(225374,6261,'ba','Agen Penjual-Tambahkan',0),(225375,6261,'nl','Leverancier-Agent toevoegen',0),(225376,6261,'fi','Toimittaja-agentti lisÃ¤Ã¤',0),(225377,6261,'no','LeverandÃ¸r-Agent legge',0),(225378,6261,'da','Kreditor-Agent tilfÃ¸je',0),(225379,6261,'ko','ê³µê¸‰ ì—…ì²´-ì—ì´ì „íŠ¸ ì¶”ê°€',0),(225380,6261,'he','×”×•×¡×£ ×¡×¤×§-×¡×•×›×Ÿ',0),(225381,6261,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®-Î±Î½Ï„Î¹Ï€ÏÎ¿ÏƒÏŽÏ€Î¿Ï…',0),(225382,6261,'zh','é”€å”®å•†ä»£ç†æ·»åŠ \r\n',0),(225383,6261,'sv','LeverantÃ¶r-Agent lÃ¤gga',0),(225384,6261,'it','Venditore-Agente aggiungere',0),(225385,6261,'tl','',0),(225386,6261,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3586;&#3634;&#3618;',0),(225387,6261,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾-à¤à¤œà¥‡à¤‚à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(225388,6261,'ms','Ejen penjual-Tambah',0),(225389,6261,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…ÙˆØ±Ø¯ Ø¹Ø§Ù…Ù„',0),(225390,6261,'fr','Ajouter du vendeur-Agent',0),(225391,6261,'jp','æ¥­è€…ãƒ¼ä»²ä»‹è€…ã?Œè¿½åŠ ',0),(225392,6261,'pt','Adicionar o fornecedor-agente',0),(225393,6261,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°-ÐÐ³ÐµÐ½Ñ‚Ð°',0),(225394,6261,'es','Proveedor-Agente Agregar',0),(225395,6261,'de','Kreditor-Agent hinzufÃ¼gen',0),(225396,6261,'en','Vendor-Agent Add',0),(225397,6262,'is','',0),(225398,6262,'dr','- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯ ',0),(225399,6262,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯ ',0),(225400,6262,'tr','SatÄ±cÄ±-Agent deÄŸil eklendi',0),(225401,6262,'pl','Sprzedawca Agent nie dodaÅ‚',0),(225402,6262,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº-Ð°Ð³ÐµÐ½Ñ‚ Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¾',0),(225403,6262,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û-Ø§ÛŒØ¬Ù†Ù¹ Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©ÛŒØ§',0),(225404,6262,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ -ÐÐ³ÐµÐ½Ñ‚ Ð½Ðµ Ð´Ð¾Ð´Ð°Ñ˜Ñƒ',0),(225405,6262,'vi','KhÃ´ng thÃªm NgÆ°á»i bÃ¡n-Ä‘áº¡i lÃ½',0),(225406,6262,'af','Verkoper-Agent bygevoeg nie',0),(225407,6262,'ro','Distribuitor-agentul nu a adÄƒugat',0),(225408,6262,'et','Hankija-Agent ei lisata',0),(225409,6262,'si','Prodajalec-Agent ne doda',0),(225410,6262,'ba','Penjual-agen tidak ditambahkan',0),(225411,6262,'nl','Leverancier-Agent niet toegevoegd',0),(225412,6262,'fi','Toimittaja-agentti ei lisÃ¤tÃ¤',0),(225413,6262,'no','LeverandÃ¸r-Agent ikke lagt',0),(225414,6262,'da','Kreditor-Agent ikke tilfÃ¸jet',0),(225415,6262,'ko','ê³µê¸‰ ì—…ì²´-ì—ì´ì „íŠ¸ ì¶”ê°€ ë˜ì§€',0),(225416,6262,'he','×œ× ×”×•×¡×™×£ ×”×¡×•×›×Ÿ ×”×¡×¤×§',0),(225417,6262,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®-Agent Î´ÎµÎ½ Ï€ÏÎ¿ÏƒÏ„Î¯Î¸ÎµÏ„Î±Î¹',0),(225418,6262,'zh','é”€å”®å•†ä»£ç†ä¸æ·»åŠ \r\n',0),(225419,6262,'sv','LeverantÃ¶r-Agent inte lagt till',0),(225420,6262,'it','Venditore-agente non aggiunto',0),(225421,6262,'tl','',0),(225422,6262,'th','&#3652;&#3617;&#3656;&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3586;&#3634;&#3618;',0),(225423,6262,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾-à¤à¤œà¥‡à¤‚à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(225424,6262,'ms','Penjual-ejen yang tidak ditambah',0),(225425,6262,'ar','Ù„Ù… ØªØªÙ… Ø¥Ø¶Ø§ÙØ© ÙˆÙƒÙŠÙ„ Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(225426,6262,'fr','Vendeur-Agent ne pas ajoutÃ©',0),(225427,6262,'jp','æ¥­è€…ãƒ¼ä»²ä»‹è€…ã?Œè¿½åŠ ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(225428,6262,'pt','Fornecedor-agente nÃ£o adicionado',0),(225429,6262,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº-ÐÐ³ÐµÐ½Ñ‚ ÐÐµ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(225430,6262,'es','Proveedor-Agente No Agregado',0),(225431,6262,'de','Kreditor-Agent nicht hinzugefÃ¼gt',0),(225432,6262,'en','Vendor-Agent Not Added',0),(225433,6263,'is','',0),(225434,6263,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225435,6263,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225436,6263,'tr','Ajan sayÄ±sÄ±',0),(225437,6263,'pl','Numer agenta',0),(225438,6263,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð°Ð³ÐµÐ½Ñ‚',0),(225439,6263,'ur','Ø§ÛŒØ¬Ù†Ù¹ Ù†Ù…Ø¨Ø±',0),(225440,6263,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(225441,6263,'vi','Sá»‘ Äáº¡i LÃ½',0),(225442,6263,'af','Agent Nommer',0),(225443,6263,'ro','NumÄƒr agent',0),(225444,6263,'et','Maksja kood',0),(225445,6263,'si','Agent Å¡tevilnih',0),(225446,6263,'ba','Nomor agen',0),(225447,6263,'nl','Agent nummer',0),(225448,6263,'fi','Agentti numero',0),(225449,6263,'no','Agent nummer',0),(225450,6263,'da','Agent nummer',0),(225451,6263,'ko','ì—ì´ì „íŠ¸ ìˆ˜',0),(225452,6263,'he','×ž×¡×¤×¨ ×¡×•×›×Ÿ',0),(225453,6263,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€ÏÎ¬ÎºÏ„Î¿ÏÎ±',0),(225454,6263,'zh','ä»£ç†å·\r\n',0),(225455,6263,'sv','Agent nummer',0),(225456,6263,'it','Agente numero',0),(225457,6263,'tl','',0),(225458,6263,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3586;&#3629;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(225459,6263,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ à¤¨à¤‚à¤¬à¤°',0),(225460,6263,'ms','Bilangan ejen',0),(225461,6263,'ar','Ø±Ù‚Ù… Ø§Ù„ÙˆÙƒÙŠÙ„',0),(225462,6263,'fr','NumÃ©ro de l\'agent',0),(225463,6263,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆç•ªå?·',0),(225464,6263,'pt','NÃºmero de agente',0),(225465,6263,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(225466,6263,'es','Agente NÃºmero',0),(225467,6263,'de','Agent-Anzahl',0),(225468,6263,'en','Agent Number',0),(225469,6264,'is','',0),(225470,6264,'dr','- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225471,6264,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225472,6264,'tr','SatÄ±cÄ±-Ajan gÃ¼ncelleÅŸtirme',0),(225473,6264,'pl','Sprzedawca agenta aktualizacji',0),(225474,6264,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº-Ð°Ð³ÐµÐ½Ñ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(225475,6264,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û-Ø§ÛŒØ¬Ù†Ù¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(225476,6264,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°-ÐÐ³ÐµÐ½Ñ‚',0),(225477,6264,'vi','Cáº­p Nháº­t Äáº¡i LÃ½-NgÆ°á»i bÃ¡n ',0),(225478,6264,'af','Verskaffer-Agent Opdateer',0),(225479,6264,'ro','Update Agent de furnizor',0),(225480,6264,'et','Hankija-agendi vÃ¤rskendus',0),(225481,6264,'si','Prodajalec-Agent posodobitev',0),(225482,6264,'ba','Agen Penjual-Update',0),(225483,6264,'nl','Leverancier-Agent Update',0),(225484,6264,'fi','Toimittajan edustaja pÃ¤ivitys',0),(225485,6264,'no','LeverandÃ¸r-Agent oppdatering',0),(225486,6264,'da','Kreditor-Agent opdatering',0),(225487,6264,'ko','ê³µê¸‰ ì—…ì²´-ì—ì´ì „íŠ¸ ì—…ë°ì´íŠ¸',0),(225488,6264,'he','×¢×“×›×•×Ÿ ×”×¡×•×›×Ÿ ×”×¡×¤×§',0),(225489,6264,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®-Î±Î½Ï„Î¹Ï€ÏÎ¿ÏƒÏŽÏ€Î¿Ï…',0),(225490,6264,'zh','é”€å”®å•†çš„ä»£ç†æ›´æ–°\r\n',0),(225491,6264,'sv','LeverantÃ¶r-Agent uppdatering',0),(225492,6264,'it','Venditore-agente di aggiornamento',0),(225493,6264,'tl','',0),(225494,6264,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3586;&#3634;&#3618;',0),(225495,6264,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾-à¤à¤œà¥‡à¤‚à¤Ÿ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(225496,6264,'ms','Ejen penjual-Kemaskini',0),(225497,6264,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆØ±Ø¯ Ø¹Ø§Ù…Ù„',0),(225498,6264,'fr','Mise Ã  jour du vendeur-Agent',0),(225499,6264,'jp','æ¥­è€…ãƒ¼ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã?®æ›´æ–°',0),(225500,6264,'pt','AtualizaÃ§Ã£o de fornecedor-agente',0),(225501,6264,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°-ÐÐ³ÐµÐ½Ñ‚Ð°',0),(225502,6264,'es','Proveedor-Agente Actualizar',0),(225503,6264,'de','Kreditor-Agent Update',0),(225504,6264,'en','Vendor-Agent Update',0),(225505,6265,'is','',0),(225506,6265,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225507,6265,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225508,6265,'tr','AracÄ±sÄ± KÄ±mlÄ±ÄŸÄ±',0),(225509,6265,'pl','Identyfikator agenta',0),(225510,6265,'bg','Ð˜Ð” Ð·Ð° Ð°Ð³ÐµÐ½Ñ‚',0),(225511,6265,'ur','Ø§ÛŒØ¬Ù†Ù¹ Ø´Ù†Ø§Ø®Øª',0),(225512,6265,'sr','Ð˜Ð” Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(225513,6265,'vi','ID Äáº¡i LÃ½',0),(225514,6265,'af','Agent ID',0),(225515,6265,'ro','Agent ID',0),(225516,6265,'et','Esindaja ID',0),(225517,6265,'si','Agent ID',0),(225518,6265,'ba','Agen ID',0),(225519,6265,'nl','Agent ID',0),(225520,6265,'fi','Matkatoimiston tunnus',0),(225521,6265,'no','Agent-ID',0),(225522,6265,'da','Agent-ID',0),(225523,6265,'ko','ì—ì´ì „íŠ¸ ID',0),(225524,6265,'he','×”×¡×•×›×Ÿ ×ž×–×”×”',0),(225525,6265,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î±',0),(225526,6265,'zh','ä»£ç†ID\r\n',0),(225527,6265,'sv','Agent-ID',0),(225528,6265,'it','ID agente',0),(225529,6265,'tl','',0),(225530,6265,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3586;&#3629;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(225531,6265,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ ID',0),(225532,6265,'ms','Ejen ID',0),(225533,6265,'ar','Ù…Ø¹Ø±Ù Ø¹Ø§Ù…Ù„',0),(225534,6265,'fr','ID d\'agent',0),(225535,6265,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆID',0),(225536,6265,'pt','Agente ID',0),(225537,6265,'ru','ID Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(225538,6265,'es','Agente ID',0),(225539,6265,'de','Agent-ID',0),(225540,6265,'en','Agent ID',0),(225541,6266,'is','',0),(225542,6266,'dr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ÙƒØ¯Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(225543,6266,'pr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ÙƒØ¯Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(225544,6266,'tr','Ajan ne satÄ±cÄ± iÃ§in',0),(225545,6266,'pl','Agent dla tego sprzedawcy',0),(225546,6266,'bg','ÐÐ³ÐµÐ½Ñ‚ Ð·Ð° ÐºÐ°ÐºÑŠÐ² Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(225547,6266,'ur','Ú©ÛŒØ§ ÙˆÛŒÙ†ÚˆØ± Ú©Û’ Ø§ÛŒØ¬Ù†Ù¹',0),(225548,6266,'sr','ÐÐ³ÐµÐ½Ñ‚ Ð·Ð° ÐºÐ¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(225549,6266,'vi','Äáº¡i LÃ½ cho NgÆ°á»i BÃ¡n NÃ o',0),(225550,6266,'af','Agent vir Watter Verskaffer',0),(225551,6266,'ro','Agent pentru ce furnizor',0),(225552,6266,'et','Mida hankija esindaja',0),(225553,6266,'si','Zastopnik za kaj dobavitelja',0),(225554,6266,'ba','Agen Penjual apa',0),(225555,6266,'nl','Agent voor welke leverancier',0),(225556,6266,'fi','MitÃ¤ myyjÃ¤ agentti',0),(225557,6266,'no','Agent for hvilken leverandÃ¸r',0),(225558,6266,'da','Agent for hvilken kreditor',0),(225559,6266,'ko','ì–´ë–¤ ê³µê¸‰ ì—…ì²´ì— ëŒ€ í•œ ì—ì´ì „íŠ¸',0),(225560,6266,'he','×¡×•×›×Ÿ ×¢×‘×•×¨ ××™×–×” ×¡×¤×§',0),(225561,6266,'el','Î Î±ÏÎ¬Î³Î¿Î½Ï„Î± Î³Î¹Î± Ï€Î¿Î¹Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(225562,6266,'zh','ä»£ç†ä¾›åº”å•†\r\n',0),(225563,6266,'sv','Agent fÃ¶r vilken leverantÃ¶r',0),(225564,6266,'it','Agente per il quale fornitore',0),(225565,6266,'tl','',0),(225566,6266,'th','&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3636;&#3656;&#3591;&#3607;&#3637;&#3656;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(225567,6266,'hi','à¤•à¥à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤œà¥‡à¤‚à¤Ÿ',0),(225568,6266,'ms','Agent penjual apa',0),(225569,6266,'ar','Ø¹Ø§Ù…Ù„ Ù„Ù…ÙˆØ±Ø¯ Ù…Ø§',0),(225570,6266,'fr','Agent pour quel fournisseur',0),(225571,6266,'jp','ã?©ã?®æ¥­è€…ã?®ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆ',0),(225572,6266,'pt','Agente para o fornecedor',0),(225573,6266,'ru','ÐÐ³ÐµÐ½Ñ‚ Ð´Ð»Ñ ÐºÐ°ÐºÐ¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(225574,6266,'es','Agente para Cual Proveedor',0),(225575,6266,'de','Agent fÃ¼r welche Anbieter',0),(225576,6266,'en','Agent for What Vendor',0),(225577,6267,'is','',0),(225578,6267,'dr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ÙƒØ¯Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(225579,6267,'pr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ÙƒØ¯Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(225580,6267,'tr','Ajan ne satÄ±cÄ± Bayi',0),(225581,6267,'pl','Agent dla co sprzedawca handlowiec',0),(225582,6267,'bg','ÐÐ³ÐµÐ½Ñ‚ Ð·Ð° ÐºÐ°ÐºÑŠÐ² Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº-Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¾Ñ€',0),(225583,6267,'ur','Ø§ÛŒØ¬Ù†Ù¹ Ú©ÛŒØ§ ÙˆÛŒÙ†ÚˆØ± Ø±ÛŒ Ø³ÛŒÙ„Ø±',0),(225584,6267,'sr','ÐÐ³ÐµÐ½Ñ‚ Ð·Ð° ÐºÐ¾Ñ˜Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð ÐµÑÐµÐ»Ð»ÐµÑ€',0),(225585,6267,'vi','Äáº¡i LÃ½ cho NgÆ°á»i BÃ¡n NÃ o-NhÃ  PhÃ¢n Phá»‘i NÃ o',0),(225586,6267,'af','Agent vir watter ondernemer-herverkoper',0),(225587,6267,'ro','Agent pentru ce furnizor-distribuitor',0),(225588,6267,'et','Mida tarnija-edasimÃ¼Ã¼ja agent',0),(225589,6267,'si','Zastopnik za kaj dobavitelj-prodajalec',0),(225590,6267,'ba','Agen untuk apa Vendor-Reseller',0),(225591,6267,'nl','Agent voor welke leverancier-Reseller',0),(225592,6267,'fi','MitÃ¤ toimittaja-jÃ¤lleenmyyjÃ¤ agentti',0),(225593,6267,'no','Agent for hvilken leverandÃ¸r-forhandler',0),(225594,6267,'da','Agent for hvilken kreditor-forhandler',0),(225595,6267,'ko','ì–´ë–¤ ê³µê¸‰ ì—…ì²´-ëŒ€ë¦¬ì ì— ëŒ€ í•œ ì—ì´ì „íŠ¸',0),(225596,6267,'he','×¡×•×›×Ÿ ×¢×‘×•×¨ ××™×–×” ×”×¡×¤×§-×ž×©×•×•×§',0),(225597,6267,'el','Î Î±ÏÎ¬Î³Î¿Î½Ï„Î± Î³Î¹Î± Ï„Î¹ Ï€Ï‰Î»Î·Ï„Î®-Î¼ÎµÏ„Î±Ï€Ï‰Î»Î·Ï„Î®',0),(225598,6267,'zh','ä»£ç†ä¾›åº”å•†ç»é”€å•†\r\n',0),(225599,6267,'sv','Agent fÃ¶r vilken leverantÃ¶r-Ã¥terfÃ¶rsÃ¤ljare',0),(225600,6267,'it','Agente per il quale fornitore-rivenditore',0),(225601,6267,'tl','',0),(225602,6267,'th','&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3636;&#3656;&#3591;&#3607;&#3637;&#3656;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3586;&#3634;&#3618;',0),(225603,6267,'hi','à¤•à¥à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤¨à¤°à¥à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤œà¥‡à¤‚à¤Ÿ',0),(225604,6267,'ms','Agent penjual-penjual apa',0),(225605,6267,'ar','ÙˆÙƒÙŠÙ„ Ù„Ù…Ø§ Ø§Ù„Ø¨Ø§Ø¦Ø¹-Ù…ÙˆØ²Ø¹',0),(225606,6267,'fr','Agent pour quel fournisseur-revendeur',0),(225607,6267,'jp','ã?©ã?®æ¥­è€…ãƒ¼å†?è²©å£²æ¥­è€…ã?®ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆ',0),(225608,6267,'pt','Agente para o fornecedor-revendedor',0),(225609,6267,'ru','ÐÐ³ÐµÐ½Ñ‚ Ð´Ð»Ñ ÐºÐ°ÐºÐ¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¿Ð¾ÑÑ€ÐµÐ´Ð½Ð¸ÐºÐ°',0),(225610,6267,'es','Agente para Que Proveedor-Revendedor',0),(225611,6267,'de','Agent fÃ¼r welche Hersteller-HÃ¤ndler',0),(225612,6267,'en','Agent for What Vendor-Reseller',0),(225613,6268,'is','',0),(225614,6268,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225615,6268,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225616,6268,'tr','Ajan bilgi',0),(225617,6268,'pl','Agenta informacji',0),(225618,6268,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð°Ð³ÐµÐ½Ñ‚',0),(225619,6268,'ur','Ø§ÛŒØ¬Ù†Ù¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(225620,6268,'sr','ÐÐ³ÐµÐ½Ñ‚ Ð˜Ð½Ñ„Ð¾',0),(225621,6268,'vi','ThÃ´ng Tin Äáº¡i LÃ½',0),(225622,6268,'af','Agent Inligting',0),(225623,6268,'ro','Agent de informaÅ£ii',0),(225624,6268,'et','Kasutajaagendi teave',0),(225625,6268,'si','Agent Info',0),(225626,6268,'ba','Agen Info',0),(225627,6268,'nl','Agent Info',0),(225628,6268,'fi','Agentin tiedot',0),(225629,6268,'no','Agent Info',0),(225630,6268,'da','Agent Info',0),(225631,6268,'ko','ì—ì´ì „íŠ¸ ì •ë³´',0),(225632,6268,'he','nhsg xufi',0),(225633,6268,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¬ÎºÏ„Î¿ÏÎ±',0),(225634,6268,'zh','ä»£ç†ä¿¡æ¯\r\n',0),(225635,6268,'sv','Agent information',0),(225636,6268,'it','Info agente',0),(225637,6268,'tl','',0),(225638,6268,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(225639,6268,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(225640,6268,'ms','Info ejen',0),(225641,6268,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ÙˆÙƒÙŠÙ„',0),(225642,6268,'fr','Info agent',0),(225643,6268,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆæƒ…å ±',0),(225644,6268,'pt','InformaÃ§Ã£o de agente',0),(225645,6268,'ru','ÐÐ³ÐµÐ½Ñ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(225646,6268,'es','Agente Info',0),(225647,6268,'de','Agent-Info',0),(225648,6268,'en','Agent Info',0),(225649,6269,'is','',0),(225650,6269,'dr','( Ø®Ø±Ø¯Ù‡ ÙØ±ÙˆØ´',0),(225651,6269,'pr','ÙƒØ§Ù…Ù„ ÙƒÙ†ÙŠØ¯ ÙÙ‚Ø· Ø§Ú¯Ø± ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡ ( Ø®Ø±Ø¯Ù‡ ÙØ±ÙˆØ´',0),(225652,6269,'tr','EÄŸer sadece iÃ§inde doldurmak Bayi',0),(225653,6269,'pl','WypeÅ‚niÄ‡ tylko jeÅ›li sprzedawcy',0),(225654,6269,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ñ€Ð¸ÑÐµÐ»ÑŠÑ€',0),(225655,6269,'ur','Ø§Ú¯Ø± ØªÙˆ ØµØ±Ù Ù…ÛŒÚº Ø¨Ú¾Ø±Ù†Û’ Ø±ÛŒ Ø³ÛŒÙ„Ø±',0),(225656,6269,'sr','ÐŸÐ¾Ð¿ÑƒÐ½Ð¸Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð ÐµÑÐµÐ»Ð»ÐµÑ€',0),(225657,6269,'vi','Chá»‰ Äiá»n náº¿u lÃ  ngÆ°á»i bÃ¡n sá»‰',0),(225658,6269,'af','Vul in SLEGS indien Herverkoper',0),(225659,6269,'ro','CompletaÅ£i doar dacÄƒ Reseller',0),(225660,6269,'et','TÃ¤ita ainult juhul, kui edasimÃ¼Ã¼ja',0),(225661,6269,'si','Izpolnite samo, Äe preprodajalec',0),(225662,6269,'ba','Mengisi hanya jika Reseller',0),(225663,6269,'nl','Vul alleen als Reseller',0),(225664,6269,'fi','TÃ¤ytÃ¤ vain, jos jÃ¤lleenmyyjÃ¤',0),(225665,6269,'no','Fylles bare ut hvis forhandler',0),(225666,6269,'da','Udfyldes kun hvis forhandler',0),(225667,6269,'ko','ê²½ìš°ì— ì±„ìš°ê¸° ëŒ€ë¦¬ì ',0),(225668,6269,'he','×œ×ž×œ× ×¨×§ ×× ×”×ž×©×•×•×§',0),(225669,6269,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏŽÏƒÏ„Îµ Î¼ÏŒÎ½Î¿ Î±Î½ Î¼ÎµÏ„Î±Ï€Ï‰Î»Î·Ï„Î®',0),(225670,6269,'zh','ä»…ä»…åœ¨è½¬å”®å•†ä¸­å¡«å†™\r\n',0),(225671,6269,'sv','Fyll i bara om Ã¥terfÃ¶rsÃ¤ljare',0),(225672,6269,'it','Compilare solo se rivenditore',0),(225673,6269,'tl','',0),(225674,6269,'th','&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;&#3648;&#3617;&#3639;&#3656;&#3629;&#3617;&#3637;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3',0),(225675,6269,'hi','à¤¯à¤¦à¤¿ à¤•à¥‡à¤µà¤² à¤®à¥‡à¤‚ à¤­à¤° à¤ªà¥à¤¨à¤°à¥à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(225676,6269,'ms','Masukkan sahaja jika Reseller',0),(225677,6269,'ar','Ù…Ù„Ø¡ ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† Ù…ÙˆØ²Ø¹',0),(225678,6269,'fr','Remplir seulement si revendeur',0),(225679,6269,'jp','ã‚‚ã?—å†?è²©å£²æ¥­è€…ã?®å ´å?ˆã?®ã?¿è¨˜å…¥',0),(225680,6269,'pt','Preencha apenas se revendedor',0),(225681,6269,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚Ðµ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ñ€ÐµÑÐµÐ»Ð»ÐµÑ€',0),(225682,6269,'es','Llenar solo si es Reproveedor',0),(225683,6269,'de','NUR ausfÃ¼llen, wenn Reseller',0),(225684,6269,'en','Fill in ONLY if Reseller',0),(225685,6270,'is','',0),(225686,6270,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø§Ø¨Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(225687,6270,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø§Ø¨Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(225688,6270,'tr','DÃ¼z komisyon tutarÄ±',0),(225689,6270,'pl','PÅ‚aski Komisji kwoty',0),(225690,6270,'bg','ÐŸÐ»Ð¾ÑÐºÐ¸ ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° ÑÑƒÐ¼Ð°',0),(225691,6270,'ur','ÙÙ„ÛŒÙ¹ Ú©Ù…ÛŒØ´Ù† Ø±Ù‚Ù…',0),(225692,6270,'sr','Ð Ð°Ð²Ð½Ð° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(225693,6270,'vi','Sá»‘ tiá»n hoa há»“ng 1 giÃ¡',0),(225694,6270,'af','Vaste Kommissie Bedrag',0),(225695,6270,'ro','Suma de plat Comisiei',0),(225696,6270,'et','Korter komisjonitasu summa',0),(225697,6270,'si','Ravno Komisija znesek',0),(225698,6270,'ba','Jumlah Komisi datar',0),(225699,6270,'nl','Platte Commissie bedrag',0),(225700,6270,'fi','Tasainen provision mÃ¤Ã¤rÃ¤',0),(225701,6270,'no','Flat provisjonsbelÃ¸pet',0),(225702,6270,'da','Flad provisionsbelÃ¸bet',0),(225703,6270,'ko','í”Œëž« ìˆ˜ìˆ˜ë£Œ ê¸ˆì•¡',0),(225704,6270,'he','×¡×›×•× ×”×¢×ž×œ×•×ª ×©×˜×•×—',0),(225705,6270,'el','Î•Ï€Î¯Ï€ÎµÎ´Î· Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Ï€Î¿ÏƒÏŒ',0),(225706,6270,'zh','å›ºå®šä½£é‡‘æ•°é¢\r\n',0),(225707,6270,'sv','Platt provisionsbeloppet',0),(225708,6270,'it','Importo Commissione piana',0),(225709,6270,'tl','',0),(225710,6270,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(225711,6270,'hi','à¤«à¥à¤²à¥ˆà¤Ÿ à¤•à¤®à¥€à¤¶à¤¨ à¤°à¤¾à¤¶à¤¿',0),(225712,6270,'ms','Jumlah komisen yang rata',0),(225713,6270,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¹Ù…ÙˆÙ„Ø© Ù…Ø³Ø·Ø­',0),(225714,6270,'fr','Montant de Commission plat',0),(225715,6270,'jp','å?‡ä¸€æ‰‹æ•°æ–™é¡?',0),(225716,6270,'pt','Quantidade de ComissÃ£o plana',0),(225717,6270,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð»Ð¾ÑÐºÐ¸Ñ… ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(225718,6270,'es','Monto de ComisiÃ³n Fija',0),(225719,6270,'de','Flache Provisionsbetrag',0),(225720,6270,'en','Flat Commission Amount',0),(225721,6271,'is','',0),(225722,6271,'dr','Ø¯Ø±ØµØ¯ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(225723,6271,'pr','Ø¯Ø±ØµØ¯ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(225724,6271,'tr','YÃ¼zde Komisyonu',0),(225725,6271,'pl','Procent Komisji',0),(225726,6271,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ',0),(225727,6271,'ur','ÙÛŒØµØ¯ Ú©Ù…ÛŒØ´Ù†',0),(225728,6271,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ðµ',0),(225729,6271,'vi','Pháº§n trÄƒm hoa há»“ng',0),(225730,6271,'af','Persent Kommissie',0),(225731,6271,'ro','Comisia la sutÄƒ',0),(225732,6271,'et','Protsenti komisjoni',0),(225733,6271,'si','Odstotek provizije',0),(225734,6271,'ba','Persentase komisi',0),(225735,6271,'nl','Percentage Commissie',0),(225736,6271,'fi','Prosenttia komission',0),(225737,6271,'no','Prosent kommisjonen',0),(225738,6271,'da','Procent Kommissionen',0),(225739,6271,'ko','% ìœ„ì›íšŒ',0),(225740,6271,'he','××—×•×– ×¢×ž×œ×”',0),(225741,6271,'el','Î Î¿ÏƒÎ¿ÏƒÏ„Î¹Î±Î¯Î± Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹Î±',0),(225742,6271,'zh','ä½£é‡‘ç™¾åˆ†æ¯”\r\n',0),(225743,6271,'sv','Procent kommissionen',0),(225744,6271,'it','Commissione percentuale',0),(225745,6271,'tl','',0),(225746,6271,'th','&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;',0),(225747,6271,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¤®à¥€à¤¶à¤¨',0),(225748,6271,'ms','Peratus komisen',0),(225749,6271,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù„Ù„Ø¹Ù…ÙˆÙ„Ø©',0),(225750,6271,'fr','Pourcentage Commission',0),(225751,6271,'jp','æ‰‹æ•°æ–™åˆ©çŽ‡',0),(225752,6271,'pt','ComissÃ£o por cento',0),(225753,6271,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(225754,6271,'es','Porciento de ComisiÃ³n',0),(225755,6271,'de','Prozent Kommission',0),(225756,6271,'en','Percent Commission',0),(225757,6272,'is','',0),(225758,6272,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ÙØ±ÙˆØ´ ',0),(225759,6272,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ÙØ±ÙˆØ´ ',0),(225760,6272,'tr','SatÄ±cÄ± aracÄ± veri girin/gÃ¼ncelleme',0),(225761,6272,'pl','WprowadÅº/aktualizacji dostawcy danych agenta',0),(225762,6272,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð°Ð³ÐµÐ½Ñ‚ Ð´Ð°Ð½Ð½Ð¸',0),(225763,6272,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§ÛŒØ¬Ù†Ù¹ Ú©ÙˆØ§Ø¦Ù Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(225764,6272,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÐÐ³ÐµÐ½Ñ‚ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(225765,6272,'vi','Nháº­p/Cáº­p Nháº­t Dá»¯ Liá»‡u Cá»§a Äáº¡i LÃ½',0),(225766,6272,'af','Invoer/Opdateer Verskaffer Agent Data',0),(225767,6272,'ro','IntroduceÅ£i/actualizare date de Agent furnizor',0),(225768,6272,'et','Hankija esindaja andmete sisestamine/ajakohastamine',0),(225769,6272,'si','Vnos/posodobitev dobavitelja Agent podatkov',0),(225770,6272,'ba','Masukkan/Update Data Agen Penjual',0),(225771,6272,'nl','Leverancier Agent gegevens invoeren/bijwerken',0),(225772,6272,'fi','PÃ¤ivittÃ¤minen agentti toimittajatietojen',0),(225773,6272,'no','Angi/Oppdater Agent leverandÃ¸rdata',0),(225774,6272,'da','Indtaste/opdatere kreditordata Agent',0),(225775,6272,'ko','ê³µê¸‰ ì—…ì²´ ì—ì´ì „íŠ¸ ë°ì´í„° ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(225776,6272,'he','×”×›× ×¡/×¢×“×›×Ÿ × ×ª×•× ×™ ×¡×•×›×Ÿ ×¡×¤×§',0),(225777,6272,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(225778,6272,'zh','è¾“å…¥/æ›´æ–°å–æ–¹ä»£ç†æ•°æ®',0),(225779,6272,'sv','Ange/Uppdatera Agent leverantÃ¶rsdata',0),(225780,6272,'it','Inserisci/Aggiorna dati agente fornitore',0),(225781,6272,'tl','',0),(225782,6272,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(225783,6272,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤à¤œà¥‡à¤‚à¤Ÿ à¤¡à¥‡à¤Ÿà¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(225784,6272,'ms','Masukkan/kemas kini Data ejen penjual.',0),(225785,6272,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙˆØ±Ø¯ Ø¹Ø§Ù…Ù„',0),(225786,6272,'fr','Entrez/mise Ã  jour des donnÃ©es de lâ€™Agent du vendeur',0),(225787,6272,'jp','æ¥­è€…ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆãƒ‡ãƒ¼ã‚¿ã?®å…¥åŠ›/æ›´æ–°',0),(225788,6272,'pt','Inserir/atualizar dados de agente vendedor',0),(225789,6272,'ru','Ð’Ð²Ð¾Ð´/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð°Ð³ÐµÐ½Ñ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(225790,6272,'es','Introducir/Actualizar Datos de Agente de Proveedor',0),(225791,6272,'de','Geben Sie/Update Agent Lieferantendaten',0),(225792,6272,'en','Enter/Update Vendor Agent Data',0),(225793,6273,'is','',0),(225794,6273,'dr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ù‡Ø§ ÙŠØ§ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯Ø§Ù† ',0),(225795,6273,'pr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª Ù‡Ø§ ÙŠØ§ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯Ø§Ù† ',0),(225796,6273,'tr','Listeleri veya satÄ±cÄ± ajanlarÄ±n etiketleri yazdÄ±rma',0),(225797,6273,'pl','Drukowanie listy lub etykiet dostawcy-agentÃ³w',0),(225798,6273,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ Ð¸Ð»Ð¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°-Ð°Ð³ÐµÐ½Ñ‚Ð¸',0),(225799,6273,'ur','ÙÛØ±Ø³Øª ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û-Ø§ÛŒØ¬Ù†Ù¹ÙˆÚº Ú©Û’ Ù„ÛŒØ¨Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(225800,6273,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð¸Ð»Ð¸ Ð¾Ð·Ð½Ð°ÐºÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð°Ð³ÐµÐ½Ð°Ñ‚Ð°',0),(225801,6273,'vi','Danh sÃ¡ch in hay nhÃ£n ngÆ°á»i bÃ¡n-Ä‘áº¡i lÃ½',0),(225802,6273,'af','Druk Lys of Etikette van Verskaffer-Agente',0),(225803,6273,'ro','Liste de imprimare sau etichete de furnizor-agenti',0),(225804,6273,'et','Nimekirjade printimiseks vÃµi esindajate hankija Sildid',0),(225805,6273,'si','Tiskanje seznamov ali oznake za prodajalca-zastopnika',0),(225806,6273,'ba','Mencetak daftar atau label dari Vendor-agen',0),(225807,6273,'nl','Afdrukken van lijsten of etiketten van leverancier-Agents',0),(225808,6273,'fi','Luettelon tulostamiseen tai tarroja toimittajan aineiden',0),(225809,6273,'no','Skrive ut lister eller etiketter av leverandÃ¸r-agenter',0),(225810,6273,'da','Udskrive lister eller i etiketter til kreditor-agenter',0),(225811,6273,'ko','ëª©ë¡ ë˜ëŠ” ì—ì´ì „íŠ¸ ê³µê¸‰ ì—…ì²´ì˜ ë ˆì´ë¸” ì¸ì‡„',0),(225812,6273,'he','×”×“×¤×¡ ×¨×©×™×ž×•×ª ××• ×ª×•×•×™×•×ª ×©×œ ×”×¡×¤×§-×¡×•×›× ×™×',0),(225813,6273,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎºÎ±Ï„Î±Î»ÏŒÎ³Ï‰Î½ Î® ÎµÏ„Î¹ÎºÎ­Ï„ÎµÏ‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®-Ï€ÏÎ¬ÎºÏ„Î¿ÏÎµÏ‚',0),(225814,6273,'zh','æ‰“å°æ¸…å•æˆ–é”€å”®å•†-ä»£ç†å•†æ ‡ç­¾\r\n',0),(225815,6273,'sv','Skriva ut listor eller etiketter fÃ¶r leverantÃ¶r-Agents',0),(225816,6273,'it','Stampa elenchi o etichette di Vendor-agenti',0),(225817,6273,'tl','',0),(225818,6273,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3619;&#3639;&#3629;&#3593;&#3621;&#3634;&#3585;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;-&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(225819,6273,'hi','à¤¸à¥‚à¤šà¤¿à¤¯à¥‹à¤‚ à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾-à¤à¤œà¥‡à¤‚à¤Ÿà¥‹à¤‚ à¤•à¥‡ à¤²à¥‡à¤¬à¤² à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(225820,6273,'ms','Mencetak senarai atau label ejen penjual.',0),(225821,6273,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚ÙˆØ§Ø¦Ù… Ø£Ùˆ ØªØ³Ù…ÙŠØ§Øª Ù„Ù„Ø¨Ø§Ø¦Ø¹-ÙˆÙƒÙ„Ø§Ø¡',0),(225822,6273,'fr','Imprimer des listes ou des Ã©tiquettes du fournisseur-Agents',0),(225823,6273,'jp','æ¥­è€…ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã?®ãƒªã‚¹ãƒˆ/ãƒ©ãƒ™ãƒ«å?°åˆ·',0),(225824,6273,'pt','Listas de impressÃ£o ou rÃ³tulos de fornecedor-agentes',0),(225825,6273,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐºÐ¾Ð² Ð¸Ð»Ð¸ Ð½Ð°ÐºÐ»ÐµÐµÐº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð°Ð³ÐµÐ½Ñ‚Ð¾Ð²',0),(225826,6273,'es','Imprimir Listas o Etiquetas de Proveedores- Agentes',0),(225827,6273,'de','Drucken von Listen oder Etiketten Hersteller-Agenten',0),(225828,6273,'en','Print Lists or Labels of Vendor-Agents',0),(225829,6274,'is','',0),(225830,6274,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  ÙØ±ÙˆØ´Ù†Ø¯Ù‡- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225831,6274,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  ÙØ±ÙˆØ´Ù†Ø¯Ù‡- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(225832,6274,'tr','SatÄ±cÄ±-Ajan Ekle/GÃ¼ncelle',0),(225833,6274,'pl','Dostawcy Agent Dodaj/Aktualizuj',0),(225834,6274,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº-Ð°Ð³ÐµÐ½Ñ‚ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(225835,6274,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û-Ø§ÛŒØ¬Ù†Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(225836,6274,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡-ÐÐ³ÐµÐ½Ñ‚/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(225837,6274,'vi','ThÃªm/cáº­p nháº­t NgÆ°á»i bÃ¡n-Ä‘áº¡i lÃ½',0),(225838,6274,'af','Verkoper-Agent voeg/opdatering',0),(225839,6274,'ro','Agenti furnizori adauga/actualizeaza',0),(225840,6274,'et','Hankija-Agent lisamine/uuendamine',0),(225841,6274,'si','Prodajalec-Agent Dodaj/posodobi',0),(225842,6274,'ba','Agen Penjual-Tambahkan/Perbarui',0),(225843,6274,'nl','Leverancier-Agent toevoegen/bijwerken',0),(225844,6274,'fi','Toimittaja-agentti lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(225845,6274,'no','LeverandÃ¸r-Agent/Oppdater',0),(225846,6274,'da','Kreditor-Agent TilfÃ¸j/opdater',0),(225847,6274,'ko','ê³µê¸‰ ì—…ì²´-ì—ì´ì „íŠ¸ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(225848,6274,'he','. ×”×¡×•×›×Ÿ ×”×¡×¤×§ ×”×•×¡×£/×¢×“×›×Ÿ',0),(225849,6274,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®-Î±Î½Ï„Î¹Ï€ÏÎ¿ÏƒÏŽÏ€Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(225850,6274,'zh','é”€å”®å•†ä»£ç†æ–°å¢ž/æ›´æ–°\r\n',0),(225851,6274,'sv','LeverantÃ¶r-Agent LÃ¤gg till/uppdatera',0),(225852,6274,'it','Venditore-Agente aggiungere/aggiornare',0),(225853,6274,'tl','',0),(225854,6274,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3586;&#3634;&#3618;',0),(225855,6274,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾-à¤à¤œà¥‡à¤‚à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(225856,6274,'ms','Ejen penjual-Tambah/Kemaskini',0),(225857,6274,'ar','ÙˆÙƒÙŠÙ„ Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(225858,6274,'fr','Vendeur-Agent ajouter/mettre Ã  jour',0),(225859,6274,'jp','æ¥­è€…ãƒ¼ä»²ä»‹è€…ã€€è¿½åŠ /æ›´æ–°',0),(225860,6274,'pt','Fornecedor-agente adicionar/atualizar',0),(225861,6274,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº-ÐÐ³ÐµÐ½Ñ‚ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(225862,6274,'es','Proveedor-Agente- Agregar/Actualizar',0),(225863,6274,'de','Kreditor-Agent hinzufÃ¼gen/aktualisieren',0),(225864,6274,'en','Vendor-Agent Add/Update',0),(225865,6275,'is','',0),(225866,6275,'dr','/ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§',0),(225867,6275,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ â€“ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡  Ù„ÙŠØ³Øª Ù‡Ø§ / Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§',0),(225868,6275,'tr','SatÄ±cÄ±-Ajan listeleri/etiketleri',0),(225869,6275,'pl','Sprzedawca Agent list/etykiety',0),(225870,6275,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº-Ð°Ð³ÐµÐ½Ñ‚ ÑÐ¿Ð¸ÑÑŠÑ†Ð¸/ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(225871,6275,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û-Ø§ÛŒØ¬Ù†Ù¹ Ú©ÛŒ ÙÛØ±Ø³Øª/Ù„ÛŒØ¨Ù„',0),(225872,6275,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ -ÐÐ³ÐµÐ½Ñ‚ Ð»Ð¸ÑÑ‚Ðµ/Ð¾Ð·Ð½Ð°ÐºÐµ',0),(225873,6275,'vi','Danh sÃ¡ch NgÆ°á»i bÃ¡n-Ä‘áº¡i lÃ½/NhÃ£n',0),(225874,6275,'af','Verskaffer-Agent Lyste/Ettikette',0),(225875,6275,'ro','Distribuitor-agentul liste/Etichete',0),(225876,6275,'et','Hankija-Agent nimekirjad/Sildid',0),(225877,6275,'si','Prodajalec-Agent seznamov/nalepke',0),(225878,6275,'ba','Agen Penjual-daftar/label',0),(225879,6275,'nl','Leverancier-Agent lijsten/Labels',0),(225880,6275,'fi','Toimittaja-agentti luetteloita ja merkinnÃ¤t',0),(225881,6275,'no','LeverandÃ¸r-Agent lister/etiketter',0),(225882,6275,'da','Kreditor-Agent lister/etiketter',0),(225883,6275,'ko','ê³µê¸‰ ì—…ì²´-ì—ì´ì „íŠ¸ ëª©ë¡/ë ˆì´ë¸”',0),(225884,6275,'he','. ×”×¡×•×›×Ÿ ×”×¡×¤×§ ×¨×©×™×ž×•×ª/×ª×•×•×™×•×ª',0),(225885,6275,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½-Agent/Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚',0),(225886,6275,'zh','å–æ–¹ä»£ç†åˆ—è¡¨/æ ‡ç­¾\r\n\r\nå–æ–¹ä»£ç†åˆ—è¡¨/æ ‡ç­¾\r\n\r\nå–æ–¹ä»£ç†åˆ—è¡¨/æ ‡ç­¾\r\n\r\nå–æ–¹ä»£ç†åˆ—è¡¨/æ ‡ç­¾\r\n\r\nå–æ–¹ä»£ç†åˆ—è¡¨/æ ‡ç­¾\r\n\r\nå–æ–¹ä»£ç†åˆ—è¡¨/æ ‡ç­¾\r\n\r\nå–æ–¹ä»£ç†åˆ—è¡¨/æ ‡ç­¾\r\n',0),(225887,6275,'sv','LeverantÃ¶r-Agent listor/etiketter',0),(225888,6275,'it','Venditore-Agente liste/etichette',0),(225889,6275,'tl','',0),(225890,6275,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;/&#3593;&#3621;&#3634;&#3585;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;-&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(225891,6275,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾-à¤à¤œà¥‡à¤‚à¤Ÿ à¤¸à¥‚à¤šà¥€/à¤²à¥‡à¤¬à¤²',0),(225892,6275,'ms','Ejen penjual-senarai/label',0),(225893,6275,'ar','ÙˆÙƒÙŠÙ„ Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ù‚ÙˆØ§Ø¦Ù…/ØªØ³Ù…ÙŠØ§Øª',0),(225894,6275,'fr','Vendeur-Agent listes/Ã©tiquettes',0),(225895,6275,'jp','æ¥­è€…-ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã?®ãƒªã‚¹ãƒˆ/ãƒ©ãƒ™ãƒ«',0),(225896,6275,'pt','Fornecedor-agente listas/rÃ³tulos',0),(225897,6275,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð°Ð³ÐµÐ½Ñ‚ ÑÐ¿Ð¸ÑÐºÐ¸/ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸',0),(225898,6275,'es','Proveedor-Agente Listas/Etiquetas',0),(225899,6275,'de','Kreditor-Agent Listen/Etiketten',0),(225900,6275,'en','Vendor-Agent Lists/Labels',0),(225901,6276,'is','',0),(225902,6276,'dr','Ø³Ø§ÙŠØª Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ù‡ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(225903,6276,'pr','Ø³Ø§ÙŠØª Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ù‡ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(225904,6276,'tr','Ajan mevcuttur ve HavaalanÄ± Valet veri yÃ¶netim',0),(225905,6276,'pl','Strona agenta i administracji lotniska Valet danych',0),(225906,6276,'bg','ÐÐ³ÐµÐ½Ñ‚ ÑÐ°Ð¹Ñ‚ Ð¸ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð»ÐµÑ‚Ð¸Ñ‰Ðµ Valet Ð´Ð°Ð½Ð½Ð¸',0),(225907,6276,'ur','Ø§ÛŒØ¬Ù†Ù¹ Ø³Ø§Ø¦Ù¹ Ø§ÙˆØ± ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ø®Ø¯Ù…ØªÚ¯Ø§Ø± Ú©ÙˆØ§Ø¦Ù Ú©Û’ Ø§Ù†ØªØ¸Ø§Ù…',0),(225908,6276,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð°Ð³ÐµÐ½Ñ‚Ð° Ð¸ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ð° Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÑÐ¾Ð±Ð°Ñ€ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(225909,6276,'vi','Website cá»§a Äáº¡i LÃ½ & Quáº£n Trá»‹ Dá»¯ Liá»‡u Cá»§a SÃ¢n Bay',0),(225910,6276,'af','Agent werf en Administrasie van lughawe Valet Data',0),(225911,6276,'ro','Agent de Site ÅŸi administrarea datelor de Valet Airport',0),(225912,6276,'et','Agent saidi ja Administration lennujaama toapoiss andmete',0),(225913,6276,'si','Agent mesto in uprava letaliÅ¡Äa sluga podatkov',0),(225914,6276,'ba','Agen situs dan administrasi Bandara Valet data',0),(225915,6276,'nl','Agent Site en het beheer van luchthaven Valet gegevens',0),(225916,6276,'fi','Agentti sivuston ja hallinnon Airport VIP tiedot',0),(225917,6276,'no','Agent nettstedet og administrasjon av flyplassen betjent Data',0),(225918,6276,'da','Agent Site og Administration af lufthavnen kammertjener Data',0),(225919,6276,'ko','ì—ì´ì „íŠ¸ ì‚¬ì´íŠ¸ ë° ê³µí•­ ì£¼ì°¨ ëŒ€ í–‰ ë°ì´í„°ì˜ ê´€ë¦¬',0),(225920,6276,'he','×”×¡×•×›×Ÿ ×‘××ª×¨, ×ž×™× ×”×œ ×”×ª×¢×•×¤×” ×”×ž×©×¨×ª × ×ª×•× ×™×',0),(225921,6276,'el','Î Î±ÏÎ¬Î³Î¿Î½Ï„Î± Site ÎºÎ±Î¹ Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î¼Îµ Ï€Î±ÏÎºÎ±Î´ÏŒÏÎ¿ Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿',0),(225922,6276,'zh','ä»£ç†ç«™ç‚¹å’Œæœºåœºå®¢æœæ•°æ®ç®¡ç†\r\n',0),(225923,6276,'sv','Agent webbplats och administrationen Airport BetjÃ¤nad data',0),(225924,6276,'it','Sito dell\'agente e l\'amministrazione di dati di servizio aeroporto',0),(225925,6276,'tl','',0),(225926,6276,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3586;&#3629;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3592;&#3629;&#3',0),(225927,6276,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ à¤¸à¤¾à¤‡à¤Ÿ à¤”à¤° à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤µà¥‰à¤²à¥‡à¤Ÿ à¤¡à¥‡à¤Ÿà¤¾ à¤•à¤¾ à¤ªà¥à¤°à¤¶à¤¾à¤¸à¤¨',0),(225928,6276,'ms','Pentadbiran data Valet Lapangan Terbang dan lokasi agen',0),(225929,6276,'ar','Ù…ÙˆÙ‚Ø¹ Ø§Ù„ÙˆÙƒÙŠÙ„ ÙˆØ¥Ø¯Ø§Ø±Ø© Ù…Ø·Ø§Ø± ØµÙ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(225930,6276,'fr','Site de lâ€™agent et lâ€™Administration dâ€™aÃ©roport Valet donnÃ©es',0),(225931,6276,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã‚µã‚¤ãƒˆã?¨ç©ºæ¸¯ä¿‚å“¡ãƒ‡ãƒ¼ã‚¿ã?®ç®¡ç?†',0),(225932,6276,'pt','Site do agente e administraÃ§Ã£o de dados de Valet Aeroporto',0),(225933,6276,'ru','Ð¡Ð°Ð¹Ñ‚ Ð°Ð³ÐµÐ½Ñ‚Ð° Ð¸ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð°ÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð¾Ð±Ð¸Ð»ÐµÐ¹ ÑÐ»ÑƒÐ¶Ð°Ñ‰Ð¸Ð¼ Ð³Ð¾ÑÑ‚Ð¸Ð½Ð¸Ñ†Ñ‹',0),(225934,6276,'es','Sitio de Agente y AdministraciÃ³n de los Datos de Valet de Aeropuerto',0),(225935,6276,'de','Agent-Website und die Verwaltung der Airport Valet Daten',0),(225936,6276,'en','Agent Site and Administration of Airport Valet Data',0),(225937,6277,'is','',0),(225938,6277,'dr','ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(225939,6277,'pr','ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(225940,6277,'tr','HavaalanÄ±',0),(225941,6277,'pl','Lotnisko',0),(225942,6277,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ',0),(225943,6277,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’',0),(225944,6277,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼',0),(225945,6277,'vi','SÃ¢n Bay',0),(225946,6277,'af','Lughawe',0),(225947,6277,'ro','Aeroport',0),(225948,6277,'et','Lennujaama',0),(225949,6277,'si','LetaliÅ¡Äe',0),(225950,6277,'ba','Bandara',0),(225951,6277,'nl','Luchthaven',0),(225952,6277,'fi','LentokenttÃ¤',0),(225953,6277,'no','Lufthavn',0),(225954,6277,'da','Lufthavn',0),(225955,6277,'ko','ê³µí•­',0),(225956,6277,'he','×©×“×” ×ª×¢×•×¤×”',0),(225957,6277,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿',0),(225958,6277,'zh','æœºåœº\r\n',0),(225959,6277,'sv','Flygplats',0),(225960,6277,'it','Aeroporto',0),(225961,6277,'tl','',0),(225962,6277,'th','&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(225963,6277,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¤¾',0),(225964,6277,'ms','Lapangan Terbang',0),(225965,6277,'ar','Ù…Ø·Ø§Ø±',0),(225966,6277,'fr','AÃ©roport',0),(225967,6277,'jp','ç©ºæ¸¯',0),(225968,6277,'pt','Aeroporto',0),(225969,6277,'ru','ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚',0),(225970,6277,'es','Aeropuerto',0),(225971,6277,'de','Flughafen',0),(225972,6277,'en','Airport',0),(225973,6278,'is','',0),(225974,6278,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù…ÛŒØ¯Ø§Ù† Ù‡ÙˆØ§ÛŒÛŒ',0),(225975,6278,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(225976,6278,'tr','Hava alanlarÄ± Ekle/GÃ¼ncelle',0),(225977,6278,'pl','Porty lotnicze Dodaj/Aktualizuj',0),(225978,6278,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(225979,6278,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(225980,6278,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼Ð¸/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(225981,6278,'vi','ThÃªm/Cáº­p Nháº­t SÃ¢n Bay',0),(225982,6278,'af','Lughawens Byvoeg/Opdateer',0),(225983,6278,'ro','Adauga/Actualizeaza aeroporturi',0),(225984,6278,'et','Lennujaamade lisamine/uuendamine',0),(225985,6278,'si','LetaliÅ¡Äih Dodaj/posodobi',0),(225986,6278,'ba','Bandara Tambahkan/Perbarui',0),(225987,6278,'nl','Luchthavens toevoegen/bijwerken',0),(225988,6278,'fi','LentokentÃ¤t lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(225989,6278,'no','Flyplasser/Oppdater',0),(225990,6278,'da','Lufthavne TilfÃ¸j/opdater',0),(225991,6278,'ko','ê³µí•­ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(225992,6278,'he','× ×ž×œ×™ ×ª×¢×•×¤×” ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(225993,6278,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(225994,6278,'zh','å¢žåŠ /æ›´æ–°æœºåœº\r\n',0),(225995,6278,'sv','Flygplatser LÃ¤gg till/uppdatera',0),(225996,6278,'it','Aeroporti aggiungere/aggiornare',0),(225997,6278,'tl','',0),(225998,6278,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(225999,6278,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‹à¤‚ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(226000,6278,'ms','Lapangan Terbang di tambah/Kemaskini',0),(226001,6278,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø·Ø§Ø±Ø§Øª',0),(226002,6278,'fr','AÃ©roports ajouter/mettre Ã  jour',0),(226003,6278,'jp','ç©ºæ¸¯ã?®è¿½åŠ /æ›´æ–°',0),(226004,6278,'pt','Adicionar/atualizar de aeroportos',0),(226005,6278,'ru','ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ñ‹ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(226006,6278,'es','Aeropuertos Agregar/Actualizar',0),(226007,6278,'de','FlughÃ¤fen hinzufÃ¼gen/aktualisieren',0),(226008,6278,'en','Airports Add/Update',0),(226009,6279,'is','',0),(226010,6279,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯Ù‡Ø§ÙŠ  Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226011,6279,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯Ù‡Ø§ÙŠ  Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226012,6279,'tr','HavaalanÄ± otopark Ã¼cretleri',0),(226013,6279,'pl','OpÅ‚aty za Parking Lotnisko',0),(226014,6279,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Ð¿Ð°Ñ€ÐºÐ¸Ð½Ð³ Ñ‚Ð°ÐºÑÐ¸',0),(226015,6279,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ Ù¾Ø§Ø±Ú©Ù†Ú¯ ÙÛŒØ³',0),(226016,6279,'sr','ÐÐ°Ð´Ð¾ÐºÐ½Ð°Ð´Ðµ Ð·Ð° Ð¿Ð°Ñ€ÐºÐ¸Ñ€Ð°ÑšÐµ Ð½Ð° Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼Ñƒ',0),(226017,6279,'vi','PhÃ­ Gá»­i Xe SÃ¢n Bay',0),(226018,6279,'af','Lughawe parkering gelde',0),(226019,6279,'ro','Taxe de parcare aeroport',0),(226020,6279,'et','Lennujaama parkimise eest',0),(226021,6279,'si','LetaliÅ¡Äe parkirnine',0),(226022,6279,'ba','Biaya parkir Bandara',0),(226023,6279,'nl','Luchthaven parkeertarieven',0),(226024,6279,'fi','Airport pysÃ¤kÃ¶intimaksut',0),(226025,6279,'no','Flyplass parkeringsavgifter',0),(226026,6279,'da','Lufthavnen parkeringsafgifter',0),(226027,6279,'ko','ê³µí•­ ì£¼ì°¨ ìš”ê¸ˆ',0),(226028,6279,'he','×“×ž×™ ×—× ×™×” ×”×ª×¢×•×¤×”',0),(226029,6279,'el','Î‘ÎµÏÎ¿Î»Î¹Î¼ÎµÎ½Î¹ÎºÏŽÎ½ Ï„ÎµÎ»ÏŽÎ½ ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚',0),(226030,6279,'zh','æœºåœºåœè½¦è´¹\r\n',0),(226031,6279,'sv','Flygplatsen parkeringsavgifter',0),(226032,6279,'it','Tasse di parcheggio Aeroporto',0),(226033,6279,'tl','',0),(226034,6279,'th','&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3592;&#3629;&#3604;&#3619;&#3606;&#3607;&#3637;&#3656;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226035,6279,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¤¾ à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¶à¥à¤²à¥à¤•',0),(226036,6279,'ms','Bayaran letak kereta Lapangan Terbang',0),(226037,6279,'ar','Ø±Ø³ÙˆÙ… ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª ÙÙŠ Ù…Ø·Ø§Ø±',0),(226038,6279,'fr','Frais de stationnement d\'aÃ©roport',0),(226039,6279,'jp','ç©ºæ¸¯é§?è»Šå ´æ–™',0),(226040,6279,'pt','Taxas de estacionamento de aeroporto',0),(226041,6279,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÑƒ Ð°ÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226042,6279,'es','Aeropuerto Cuotas de Estacionamiento',0),(226043,6279,'de','Flughafen ParkgebÃ¼hren',0),(226044,6279,'en','Airport Parking Fees',0),(226045,6280,'is','',0),(226046,6280,'dr','Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226047,6280,'pr','Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226048,6280,'tr','HavaalanÄ± Hizmetleri',0),(226049,6280,'pl','Lotnisko',0),(226050,6280,'bg','Ð£ÑÐ»ÑƒÐ³Ð¸-Ð»ÐµÑ‚Ð¸Ñ‰Ðµ',0),(226051,6280,'ur','Ø§ÛŒØ¦Ø± Ù¾ÙˆØ±Ù¹ Ø³Ø±ÙˆØ³Ø²',0),(226052,6280,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÑƒÑÐ»ÑƒÐ³Ðµ',0),(226053,6280,'vi','CÃ¡c Dá»‹ch Vá»¥ SÃ¢n Bay',0),(226054,6280,'af','Lughawe Dienste',0),(226055,6280,'ro','Servicii de aeroport',0),(226056,6280,'et','Lennujaama teenused',0),(226057,6280,'si','LetaliÅ¡kih storitev',0),(226058,6280,'ba','Layanan Bandara',0),(226059,6280,'nl','Luchthavendiensten',0),(226060,6280,'fi','Airport Services',0),(226061,6280,'no','Flyplass tjenester',0),(226062,6280,'da','Airport Services',0),(226063,6280,'ko','ê³µí•­ ì„œë¹„ìŠ¤',0),(226064,6280,'he','×©×¨×•×ª×™ ×©×“×” ×ª×¢×•×¤×”',0),(226065,6280,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Ï…Ï€Î·ÏÎµÏƒÎ¯ÎµÏ‚',0),(226066,6280,'zh','æœºåœºæœåŠ¡\r\n',0),(226067,6280,'sv','FlygplatstjÃ¤nster',0),(226068,6280,'it','Servizi aeroportuali',0),(226069,6280,'tl','',0),(226070,6280,'th','&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226071,6280,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤¸à¥‡à¤µà¤¾à¤à¤‚',0),(226072,6280,'ms','Perkhidmatan Lapangan Terbang',0),(226073,6280,'ar','Ø®Ø¯Ù…Ø§Øª Ø§Ù„Ù…Ø·Ø§Ø±',0),(226074,6280,'fr','Services aÃ©roportuaires',0),(226075,6280,'jp','ç©ºæ¸¯ã‚µãƒ¼ãƒ“ã‚¹',0),(226076,6280,'pt','ServiÃ§os de aeroporto',0),(226077,6280,'ru','Ð£ÑÐ»ÑƒÐ³Ð¸ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226078,6280,'es','Aeropuerto Servicios',0),(226079,6280,'de','Flughafendienste',0),(226080,6280,'en','Airport Services',0),(226081,6281,'is','',0),(226082,6281,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226083,6281,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226084,6281,'tr','HavaalanÄ± Hizmetleri Ã¼cretleri',0),(226085,6281,'pl','Port lotniczy usÅ‚ugi opÅ‚aty',0),(226086,6281,'bg','Ð£ÑÐ»ÑƒÐ³Ð¸ Ð½Ð° Ð»ÐµÑ‚Ð¸Ñ‰Ðµ Ñ‚Ð°ÐºÑÐ¸',0),(226087,6281,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ú©ÛŒ ÙÛŒØ³ Ú©ÛŒ Ø®Ø¯Ù…Ø§Øª',0),(226088,6281,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÑƒÑÐ»ÑƒÐ³Ðµ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ',0),(226089,6281,'vi','PhÃ­ Dá»‹ch Vá»¥ SÃ¢n Bay',0),(226090,6281,'af','Lughawe Dienste Fooie',0),(226091,6281,'ro','Aeroportul servicii Taxe de',0),(226092,6281,'et','Lennujaama teenuste tasud',0),(226093,6281,'si','LetaliÅ¡Äe storitev pristojbine',0),(226094,6281,'ba','Airport Layanan biaya',0),(226095,6281,'nl','Luchthaven diensten vergoedingen',0),(226096,6281,'fi','LentokenttÃ¤kuljetus Palvelut palkkiot',0),(226097,6281,'no','Flyplass tjenester avgifter',0),(226098,6281,'da','Lufthavn service gebyrer',0),(226099,6281,'ko','ê³µí•­ ì„œë¹„ìŠ¤ ìˆ˜ìˆ˜ë£Œ',0),(226100,6281,'he','× ×ž×œ ×”×ª×¢×•×¤×” ×©×™×¨×•×ª×™ ×©×›×¨',0),(226101,6281,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Ï…Ï€Î·ÏÎµÏƒÎ¯ÎµÏ‚ Ï„Î­Î»Î·',0),(226102,6281,'zh','æœºåœºæœåŠ¡è´¹\r\n',0),(226103,6281,'sv','Flygplats tjÃ¤nster avgifter',0),(226104,6281,'it','Aeroporto servizi tasse',0),(226105,6281,'tl','',0),(226106,6281,'th','&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226107,6281,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¤¾ à¤«à¥€à¤¸ à¤¸à¥‡à¤µà¤¾à¤à¤‚',0),(226108,6281,'ms','Yuran Perkhidmatan Lapangan Terbang',0),(226109,6281,'ar','Ù…Ø·Ø§Ø± Ø±Ø³ÙˆÙ… Ø§Ù„Ø®Ø¯Ù…Ø§Øª',0),(226110,6281,'fr','Frais de Services AÃ©roport',0),(226111,6281,'jp','ç©ºæ¸¯ã‚µãƒ¼ãƒ“ã‚¹æ–™',0),(226112,6281,'pt','Taxas de serviÃ§os do Aeroporto',0),(226113,6281,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ ÑƒÑÐ»ÑƒÐ³ Ð°ÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226114,6281,'es','Aeropuerto Servicios Cuotas',0),(226115,6281,'de','Flughafen Service GebÃ¼hren',0),(226116,6281,'en','Airport Services Fees',0),(226117,6282,'is','',0),(226118,6282,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø¯Ù…Ù‡ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226119,6282,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø¯Ù…Ù‡ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226120,6282,'tr','HavaalanÄ± Valet Kur',0),(226121,6282,'pl','Port lotniczy parkingowego instalacji',0),(226122,6282,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Valet Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(226123,6282,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ Ø®Ø¯Ù…ØªÚ¯Ø§Ø± Ø³ÛŒÙ¹ Ø§Ù¾',0),(226124,6282,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÑÐ¾Ð±Ð°Ñ€ Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼',0),(226125,6282,'vi','Setup SÃ¢n Bay Valet',0),(226126,6282,'af','Lughawe Valet opstelling',0),(226127,6282,'ro','Aeroportul Valet Setup',0),(226128,6282,'et','Lennujaama toapoiss seadistamine',0),(226129,6282,'si','LetaliÅ¡Äe sluga Setup',0),(226130,6282,'ba','Bandara Valet Setup',0),(226131,6282,'nl','Luchthaven Valet Setup',0),(226132,6282,'fi','Airport langaton asennus',0),(226133,6282,'no','Flyplassen betjent oppsett',0),(226134,6282,'da','Lufthavnen kammertjener Setup',0),(226135,6282,'ko','ê³µí•­ ì£¼ì°¨ ëŒ€ í–‰ ì„¤ì¹˜',0),(226136,6282,'he','× ×ž×œ ×”×ª×¢×•×¤×” ×©×™×¨×•×ª ×”×”×ª×§× ×”',0),(226137,6282,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Î¼Îµ Ï€Î±ÏÎºÎ±Î´ÏŒÏÎ¿ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(226138,6282,'zh','æœºåœºä»£å®¢å®‰è£…\r\n',0),(226139,6282,'sv','Flygplatsen BetjÃ¤nad Setup',0),(226140,6282,'it','Aeroporto Valet Setup',0),(226141,6282,'tl','',0),(226142,6282,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3592;&#3629;&#3604;&#3619;&#3606;&#3586;&#3629;&#3591;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226143,6282,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤¸à¥‡à¤µà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(226144,6282,'ms','Lapangan Terbang Valet persediaan',0),(226145,6282,'ar','Ù…Ø·Ø§Ø± ØµÙ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(226146,6282,'fr','AÃ©roport Valet Setup',0),(226147,6282,'jp','ç©ºæ¸¯ä¿‚å“¡è¨­å®š',0),(226148,6282,'pt','InstalaÃ§Ã£o de estacionamento de aeroporto',0),(226149,6282,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð°Ð²Ñ‚Ð¾Ð¼Ð¾Ð±Ð¸Ð»ÐµÐ¹ ÑÐ»ÑƒÐ¶Ð°Ñ‰Ð¸Ð¼ Ð³Ð¾ÑÑ‚Ð¸Ð½Ð¸Ñ†Ñ‹ Ð°ÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226150,6282,'es','Aeropuerto ConfiguraciÃ³n de Valet',0),(226151,6282,'de','Flughafen Valet Setup',0),(226152,6282,'en','Airport Valet Setup',0),(226153,6283,'is','',0),(226154,6283,'dr','Ø¨Ø±ÙˆÙŠØ¯  Ø¨Ù‡ Ø³Ø§ÙŠØª Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(226155,6283,'pr','Ø¨Ø±ÙˆÙŠØ¯  Ø¨Ù‡ Ø³Ø§ÙŠØª Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(226156,6283,'tr','Ajan sitesine gidin',0),(226157,6283,'pl','PrzejdÅº do witryny Agent',0),(226158,6283,'bg','ÐžÑ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð° ÑÐ°Ð¹Ñ‚Ð° Ð½Ð° Ð°Ð³ÐµÐ½Ñ‚',0),(226159,6283,'ur','Ø¬Ø§Ø¦ÛŒÚº Ø¨Ø·Ø±Ù Ø§ÛŒØ¬Ù†Ù¹ Ú©ÛŒ Ø³Ø§Ø¦Ù¹',0),(226160,6283,'sr','Ð˜Ð´Ð¸Ñ‚Ðµ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(226161,6283,'vi','Äáº¿n trang Ä‘áº¡i lÃ½',0),(226162,6283,'af','Gaan na Agent webwerf',0),(226163,6283,'ro','Du-te la site-ul de Agent',0),(226164,6283,'et','Mine Agent saidi',0),(226165,6283,'si','Pojdi na stran Agent',0),(226166,6283,'ba','Pergi ke situs agen',0),(226167,6283,'nl','Ga naar Agent Site',0),(226168,6283,'fi','Agentti-sivustosta',0),(226169,6283,'no','GÃ¥ til Agent nettsted',0),(226170,6283,'da','GÃ¥ til Agent Site',0),(226171,6283,'ko','ì—ì´ì „íŠ¸ ì‚¬ì´íŠ¸ì—ê°€ ì„œ',0),(226172,6283,'he','×¢×‘×•×¨ ×œ××ª×¨ ×¡×•×›×Ÿ',0),(226173,6283,'el','ÎœÎµÏ„Î±Î²ÎµÎ¯Ï„Îµ ÏƒÏ„Î·Î½ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Ï„Î¿Ï… Ï€ÏÎ¬ÎºÏ„Î¿ÏÎ±',0),(226174,6283,'zh','è½¬åˆ°ä»£ç†ç«™ç‚¹\r\n',0),(226175,6283,'sv','GÃ¥ till webbplatsen fÃ¶r Agent',0),(226176,6283,'it','Vai al sito di agente',0),(226177,6283,'tl','',0),(226178,6283,'th','&#3652;&#3611;&#3618;&#3633;&#3591;&#3613;&#3633;&#3656;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(226179,6283,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤° à¤œà¤¾à¤à¤',0),(226180,6283,'ms','Pergi ke laman web agen',0),(226181,6283,'ar','Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ Ø§Ù„ÙˆÙƒÙŠÙ„',0),(226182,6283,'fr','AccÃ©dez au Site de l\'Agent',0),(226183,6283,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã?®ã‚µã‚¤ãƒˆã?¸ç§»å‹•',0),(226184,6283,'pt','Ir para o Site do agente',0),(226185,6283,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ð½Ð° ÑÐ°Ð¹Ñ‚ Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(226186,6283,'es','Ir al Sitio de Agente',0),(226187,6283,'de','Gehen Sie zu Agentstandort',0),(226188,6283,'en','Go to Agent Site',0),(226189,6284,'is','',0),(226190,6284,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø¯Ù…Ø§Øª Ùˆ Ù†Ø±Ø® Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ù‡ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226191,6284,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø¯Ù…Ø§Øª Ùˆ Ù†Ø±Ø® Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ù‡ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226192,6284,'tr','KurulumlarÄ± HavaalanÄ± vale hizmetleri ve oranlarÄ±',0),(226193,6284,'pl','Konfiguracje dla lotniska usÅ‚ugi parkingowego i cena',0),(226194,6284,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð·Ð° Ð»ÐµÑ‚Ð¸Ñ‰Ðµ ÐºÐ°Ð¼ÐµÑ€Ð¸ÐµÑ€ÑÐºÐ¸ ÑƒÑÐ»ÑƒÐ³Ð¸ Ð¸ Ñ†ÐµÐ½Ð¸',0),(226195,6284,'ur','Ø³ÛŒÙ¹Ùˆ ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ø®Ø¯Ù…ØªÚ¯Ø§Ø± Ø®Ø¯Ù…Ø§Øª Ø§ÙˆØ± Ø´Ø±Ø­ Ú©Û’ Ù„Ø¦Û’',0),(226196,6284,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐ° Ð·Ð° Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÑÐ¾Ð±Ð°Ñ€ ÑƒÑÐ»ÑƒÐ³Ð° Ð¸ ÑÑ‚Ð¾Ð¿Ðµ',0),(226197,6284,'vi','Setup cho dá»‹ch vá»¥ Ä‘áº­u xe sÃ¢n bay & giÃ¡',0),(226198,6284,'af','Opstellings vir Lughawe Lakeidienste en -Tariewe',0),(226199,6284,'ro','Setari pentru Aeroportul Valet servicii si tarife',0),(226200,6284,'et','Seadistusi lennujaama toapoiss teenused ja hinnad',0),(226201,6284,'si','Setups za letaliÅ¡Äe sluga storitve in stopenj',0),(226202,6284,'ba','Setup untuk layanan Valet bandara dan harga',0),(226203,6284,'nl','Setups voor luchthaven Valet Services en tarieven',0),(226204,6284,'fi','Asetelmia Airport pysÃ¤kÃ¶intipalveluja ja hinnat',0),(226205,6284,'no','Oppsett for flyplassen betjent tjenester og priser',0),(226206,6284,'da','OpsÃ¦tninger til lufthavnen parkeringsservice og priser',0),(226207,6284,'ko','ê³µí•­ ì£¼ì°¨ ëŒ€ í–‰ ì„œë¹„ìŠ¤ ë° ì†ë„ ì„¤ì •',0),(226208,6284,'he','×›×™×•×•× ×•× ×™× ×¢×‘×•×¨ × ×ž×œ ×”×ª×¢×•×¤×” ×”×ž×©×¨×ª ×©×™×¨×•×ª×™× ×•×ª×¢×¨×™×¤×™×',0),(226209,6284,'el','Î¡Ï…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î¹Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯ÎµÏ‚ ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚ Ï„Î¿Ï… Î±ÎµÏÎ¿Î»Î¹Î¼Î­Î½Î± ÎºÎ±Î¹ Ï„Î± Ï€Î¿ÏƒÎ¿ÏƒÏ„Î¬',0),(226210,6284,'zh','è®¾ç½®ä¸ºæœºåœºä»£å®¢æœåŠ¡å’Œä»·æ ¼\r\n',0),(226211,6284,'sv','InstÃ¤llningar fÃ¶r Airport betjÃ¤nt tjÃ¤nster och priser',0),(226212,6284,'it','Configurazioni per aeroporto cameriere servizi e tariffe',0),(226213,6284,'tl','',0),(226214,6284,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;&#3607;&#3637;&#3656;&#3619;&#3633;&#3610;&#3651;&#3594;&#3657;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3',0),(226215,6284,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤¸à¥‡à¤µà¤• à¤¸à¥‡à¤µà¤¾à¤“à¤‚ à¤”à¤° à¤¦à¤°à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ setups',0),(226216,6284,'ms','Setups Perkhidmatan Valet Lapangan Terbang dan kadar',0),(226217,6284,'ar','Ø§Ù„Ø£Ø¬Ù‡Ø²Ø© Ù„Ù„Ù…Ø·Ø§Ø± Ø±ÙƒÙ† Ø®Ø¯Ù…Ø§Øª ÙˆØ£Ø³Ø¹Ø§Ø±',0),(226218,6284,'fr','Configurations pour aÃ©roport Valet Services et tarifs',0),(226219,6284,'jp','ç©ºæ¸¯ä¿‚å“¡ã‚µãƒ¼ãƒ“ã‚¹ã?¨æ–™é‡‘ã?®è¨­å®š',0),(226220,6284,'pt','InstalaÃ§Ãµes para serviÃ§os de Valet aeroporto e taxas',0),(226221,6284,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð´Ð»Ñ ÑÐ»ÑƒÐ¶Ð± Ð°ÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð¾Ð±Ð¸Ð»ÐµÐ¹ ÑÐ»ÑƒÐ¶Ð°Ñ‰Ð¸Ð¼ Ð³Ð¾ÑÑ‚Ð¸Ð½Ð¸Ñ†Ñ‹ Ð¸ Ñ†ÐµÐ½Ñ‹',0),(226222,6284,'es','Configuraciones para Servicios de Valet de Aeropuerto y Tarifas',0),(226223,6284,'de','-Setups fÃ¼r Airport Valet Service und Preise',0),(226224,6284,'en','Setups for Airport Valet Services and Rates',0),(226225,6285,'is','',0),(226226,6285,'dr','ÙƒØ¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226227,6285,'pr','ÙƒØ¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226228,6285,'tr','HavaalanÄ± Kodu',0),(226229,6285,'pl','Kod lotniska',0),(226230,6285,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ ÐºÐ¾Ð´',0),(226231,6285,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ú©ÙˆÚˆ',0),(226232,6285,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ Ð¨Ð¸Ñ„Ñ€Ð°',0),(226233,6285,'vi','MÃ£ Sá»‘ SÃ¢n Bay',0),(226234,6285,'af','Lughawe Kode',0),(226235,6285,'ro','Codul aeroportului',0),(226236,6285,'et','Lennujaama kood',0),(226237,6285,'si','Koda letaliÅ¡Äa',0),(226238,6285,'ba','Kode Bandara',0),(226239,6285,'nl','Luchthavencode',0),(226240,6285,'fi','LentokenttÃ¤koodi',0),(226241,6285,'no','Flyplasskode',0),(226242,6285,'da','Lufthavnskode',0),(226243,6285,'ko','ê³µí•­ ì½”ë“œ',0),(226244,6285,'he','×§×•×“ ×©×“×” ×ª×¢×•×¤×”',0),(226245,6285,'el','ÎšÏŽÎ´Î¹ÎºÎ±Ï‚ Î±ÎµÏÎ¿Î»Î¹Î¼Î­Î½Ï‰Î½',0),(226246,6285,'zh','æœºåœºä»£ç \r\n',0),(226247,6285,'sv','Flygplatsen kodifierar',0),(226248,6285,'it','Codice aeroporto',0),(226249,6285,'tl','',0),(226250,6285,'th','&#3619;&#3627;&#3633;&#3626;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226251,6285,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¤¾ à¤•à¥‹à¤¡',0),(226252,6285,'ms','Kod Lapangan Terbang',0),(226253,6285,'ar','Ø±Ù…Ø² Ø§Ù„Ù…Ø·Ø§Ø±',0),(226254,6285,'fr','Code d\'aÃ©roport',0),(226255,6285,'jp','ç©ºæ¸¯ã‚³ãƒ¼ãƒ‰',0),(226256,6285,'pt','CÃ³digo de aeroporto',0),(226257,6285,'ru','ÐšÐ¾Ð´ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226258,6285,'es','Aeropuerto CÃ³digo',0),(226259,6285,'de','Flughafencode',0),(226260,6285,'en','Airport Code',0),(226261,6286,'is','',0),(226262,6286,'dr','ÙƒØ¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(226263,6286,'pr','ÙƒØ¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(226264,6286,'tr','Kodu zaten var.',0),(226265,6286,'pl','Kod lotniska juÅ¼ istnieje',0),(226266,6286,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ ÐºÐ¾Ð´ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(226267,6286,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ú©ÙˆÚˆ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(226268,6286,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ Ð¨Ð¸Ñ„Ñ€Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(226269,6286,'vi','MÃ£ Sá»‘ SÃ¢n Bay ÄÃ£ Tá»“n Táº¡i',0),(226270,6286,'af','Lughawe Kode Bestaan Alreeds',0),(226271,6286,'ro','Codul aeroportului existÄƒ deja',0),(226272,6286,'et','Lennujaama kood on juba olemas',0),(226273,6286,'si','Kodo letaliÅ¡Äa Å¾e obstaja',0),(226274,6286,'ba','Kode Bandara sudah ada',0),(226275,6286,'nl','Luchthavencode bestaat al',0),(226276,6286,'fi','LentokenttÃ¤koodi on kÃ¤ytÃ¶ssÃ¤',0),(226277,6286,'no','Flyplasskode finnes allerede',0),(226278,6286,'da','Lufthavnskode findes allerede',0),(226279,6286,'ko','ì´ë¯¸ ê³µí•­ ì½”ë“œ',0),(226280,6286,'he','×§×•×“ × ×ž×œ ×”×ª×¢×•×¤×” ×›×‘×¨ ×§×™×™×',0),(226281,6286,'el','ÎšÏŽÎ´Î¹ÎºÎ±Ï‚ Î±ÎµÏÎ¿Î»Î¹Î¼Î­Î½Ï‰Î½ Ï€Î¿Ï… Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(226282,6286,'zh','æœºåœºä»£ç å·²å­˜åœ¨\r\n',0),(226283,6286,'sv','Flygplatsen kodifierar finns redan',0),(226284,6286,'it','Codice aeroporto esiste giÃ ',0),(226285,6286,'tl','',0),(226286,6286,'th','&#3619;&#3627;&#3633;&#3626;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(226287,6286,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¤¾ à¤•à¥‹à¤¡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(226288,6286,'ms','Kod Lapangan Terbang telah wujud',0),(226289,6286,'ar','Ø±Ù…Ø² Ø§Ù„Ù…Ø·Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(226290,6286,'fr','Code aÃ©roport existe dÃ©jÃ ',0),(226291,6286,'jp','ç©ºæ¸¯ã‚³ãƒ¼ãƒ‰ã?Œæ—¢ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(226292,6286,'pt','CÃ³digo de aeroporto jÃ¡ existe',0),(226293,6286,'ru','ÐšÐ¾Ð´ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð° Ð£Ð¶Ðµ Ð¡Ð¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ÑÑ',0),(226294,6286,'es','Aeropuerto CÃ³digo Ya Existe',0),(226295,6286,'de','Flughafencode ist bereits vorhanden.',0),(226296,6286,'en','Airport Code Already Exists',0),(226297,6287,'is','',0),(226298,6287,'dr','Ù†Ø§Ù… ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226299,6287,'pr','Ù†Ø§Ù… ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226300,6287,'tr','HavalimanÄ± adÄ±',0),(226301,6287,'pl','Nazwa lotniska',0),(226302,6287,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Ð¸Ð¼Ðµ',0),(226303,6287,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ú©Ø§ Ù†Ø§Ù…',0),(226304,6287,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ Ð¸Ð¼Ðµ',0),(226305,6287,'vi','TÃªn SÃ¢n Bay',0),(226306,6287,'af','Lughawe Naam',0),(226307,6287,'ro','Numele aeroportului',0),(226308,6287,'et','Lennujaama nimi',0),(226309,6287,'si','Ime letaliÅ¡Äa',0),(226310,6287,'ba','Nama Bandara',0),(226311,6287,'nl','Luchthaven naam',0),(226312,6287,'fi','LentokentÃ¤n nimi',0),(226313,6287,'no','Flyplassen navn',0),(226314,6287,'da','Lufthavnens navn',0),(226315,6287,'ko','ê³µí•­ ì´ë¦„',0),(226316,6287,'he','×©×ž×• ×ž×©×“×” ×”×ª×¢×•×¤×”',0),(226317,6287,'el','ÎŒÎ½Î¿Î¼Î± Î±ÎµÏÎ¿Î´ÏÎ¿Î¼Î¯Î¿Ï…',0),(226318,6287,'zh','æœºåœºåç§°\r\n',0),(226319,6287,'sv','Flygplatsen namn',0),(226320,6287,'it','Nome aeroporto',0),(226321,6287,'tl','',0),(226322,6287,'th','&#3594;&#3639;&#3656;&#3629;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226323,6287,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤•à¤¾ à¤¨à¤¾à¤®',0),(226324,6287,'ms','Nama Lapangan Terbang',0),(226325,6287,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…Ø·Ø§Ø±',0),(226326,6287,'fr','Nom de l\'aÃ©roport',0),(226327,6287,'jp','ç©ºæ¸¯å??',0),(226328,6287,'pt','Nome do Aeroporto',0),(226329,6287,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226330,6287,'es','Aeropuerto Nombre',0),(226331,6287,'de','Name des Flughafens',0),(226332,6287,'en','Airport Name',0),(226333,6288,'is','',0),(226334,6288,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226335,6288,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226336,6288,'tr','HavalimanÄ± gÃ¼ncelleme',0),(226337,6288,'pl','Port lotniczy aktualizacji',0),(226338,6288,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(226339,6288,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(226340,6288,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(226341,6288,'vi','Cáº­p Nháº­t SÃ¢n Bay',0),(226342,6288,'af','Lughawe Opdateer',0),(226343,6288,'ro','Aeroportul Update',0),(226344,6288,'et','Lennujaama Update',0),(226345,6288,'si','Posodobitev letaliÅ¡Äa',0),(226346,6288,'ba','Bandara Update',0),(226347,6288,'nl','Luchthaven Update',0),(226348,6288,'fi','Airport pÃ¤ivitys',0),(226349,6288,'no','Flyplassen oppdatering',0),(226350,6288,'da','Lufthavnen opdatering',0),(226351,6288,'ko','ê³µí•­ ì—…ë°ì´íŠ¸',0),(226352,6288,'he','×¢×“×›×•×Ÿ ×©×“×” ×”×ª×¢×•×¤×”',0),(226353,6288,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(226354,6288,'zh','æœºåœºæ›´æ–°\r\n',0),(226355,6288,'sv','Flygplatsen uppdatering',0),(226356,6288,'it','Aggiornamento aeroporto',0),(226357,6288,'tl','',0),(226358,6288,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226359,6288,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(226360,6288,'ms','Kemaskini Lapangan Terbang',0),(226361,6288,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø·Ø§Ø±',0),(226362,6288,'fr','Mise Ã  jour de l\'aÃ©roport',0),(226363,6288,'jp','ç©ºæ¸¯ã?®æ›´æ–°',0),(226364,6288,'pt','AtualizaÃ§Ã£o do Aeroporto',0),(226365,6288,'ru','ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(226366,6288,'es','Aeropuerto Actualizar',0),(226367,6288,'de','Flughafen-Update',0),(226368,6288,'en','Airport Update',0),(226369,6289,'is','',0),(226370,6289,'dr','( Ø³Ø§Ø¨Ù‚Ù‡ ) Ø¯ÙŠÚ¯Ø±',0),(226371,6289,'pr','Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª ( Ø³Ø§Ø¨Ù‚Ù‡ ) Ø¯ÙŠÚ¯Ø±',0),(226372,6289,'tr','BaÅŸka bir kayÄ±t iÃ§in',0),(226373,6289,'pl','Kolejny rekord',0),(226374,6289,'bg','Ð—Ð° Ð´Ñ€ÑƒÐ³ Ð·Ð°Ð¿Ð¸Ñ',0),(226375,6289,'ur','Ú©Ø³ÛŒ Ø¯ÙˆØ³Ø±ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Û’ Ù„ÛŒÛ’',0),(226376,6289,'sr','Ð—Ð° Ð´Ñ€ÑƒÐ³Ð¸ Ð·Ð°Ð¿Ð¸Ñ',0),(226377,6289,'vi','Cho há»“ sÆ¡ khÃ¡c',0),(226378,6289,'af','Vir \'n ander Rekord',0),(226379,6289,'ro','Pentru un alt Record',0),(226380,6289,'et','MÃµne muu kirjega',0),(226381,6289,'si','Za drug zapis',0),(226382,6289,'ba','Catatan lain',0),(226383,6289,'nl','Voor een andere Record',0),(226384,6289,'fi','Toisen tietueen',0),(226385,6289,'no','For en annen posten',0),(226386,6289,'da','For en anden post',0),(226387,6289,'ko','ë‹¤ë¥¸ ë ˆì½”ë“œì— ëŒ€ í•œ',0),(226388,6289,'he','×¢×•×“ ×©×™×.',0),(226389,6289,'el','Î“Î¹Î± Î¼Î¹Î± Î¬Î»Î»Î· ÎµÎ³Î³ÏÎ±Ï†Î®',0),(226390,6289,'zh','å¯¹äºŽå¦ä¸€æ¡è®°å½•\r\n',0),(226391,6289,'sv','FÃ¶r en annan post',0),(226392,6289,'it','Per un altro Record',0),(226393,6289,'tl','',0),(226394,6289,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3629;&#3633;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(226395,6289,'hi','à¤à¤• à¤”à¤° à¤°à¤¿à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤²à¤¿à¤',0),(226396,6289,'ms','Untuk rekod',0),(226397,6289,'ar','Ù„Ø³Ø¬Ù„ Ø¢Ø®Ø±',0),(226398,6289,'fr','Pour un autre enregistrement',0),(226399,6289,'jp','ä»–ã?®è¨˜éŒ²',0),(226400,6289,'pt','Para outro registro',0),(226401,6289,'ru','Ð”Ð»Ñ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(226402,6289,'es','Para otro Record',0),(226403,6289,'de','FÃ¼r einen anderen Datensatz',0),(226404,6289,'en','For another Record',0),(226405,6290,'is','',0),(226406,6290,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226407,6290,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226408,6290,'tr','HavaalanÄ± Ekle',0),(226409,6290,'pl','Port lotniczy dodaÄ‡',0),(226410,6290,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»ÐµÑ‚Ð¸Ñ‰Ðµ',0),(226411,6290,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(226412,6290,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼',0),(226413,6290,'vi','ThÃªm SÃ¢n Bay',0),(226414,6290,'af','Lughawe Byvoeg',0),(226415,6290,'ro','Adauga aeroport',0),(226416,6290,'et','Lennujaama lisamine',0),(226417,6290,'si','Dodaj Airport',0),(226418,6290,'ba','Bandara menambahkan',0),(226419,6290,'nl','Luchthaven toevoegen',0),(226420,6290,'fi','Airport lisÃ¤Ã¤',0),(226421,6290,'no','Flyplassen legge',0),(226422,6290,'da','Lufthavnen tilfÃ¸je',0),(226423,6290,'ko','ê³µí•­ ì¶”ê°€',0),(226424,6290,'he','×”×•×¡×£ ×©×“×” ×”×ª×¢×•×¤×”',0),(226425,6290,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î±ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿',0),(226426,6290,'zh','å¢žåŠ æœºåœº\r\n',0),(226427,6290,'sv','Flygplatsen lÃ¤gga till',0),(226428,6290,'it','Aggiungi aeroporto',0),(226429,6290,'tl','',0),(226430,6290,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226431,6290,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(226432,6290,'ms','Lapangan Terbang Tambah',0),(226433,6290,'ar','Ø£Ø¶Ù Ù…Ø·Ø§Ø±',0),(226434,6290,'fr','Ajouter aÃ©roport',0),(226435,6290,'jp','ç©ºæ¸¯ã?®è¿½åŠ ',0),(226436,6290,'pt','Adicionar o aeroporto',0),(226437,6290,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚',0),(226438,6290,'es','Aeropuerto Agregar',0),(226439,6290,'de','Flughafen hinzufÃ¼gen',0),(226440,6290,'en','Airport Add',0),(226441,6291,'is','',0),(226442,6291,'dr','ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(226443,6291,'pr','ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(226444,6291,'tr','Zaten HavaalanÄ±',0),(226445,6291,'pl','Lotnisko juÅ¼ istnieje',0),(226446,6291,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(226447,6291,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(226448,6291,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(226449,6291,'vi','SÃ¢n Bay ÄÃ£ Tá»“n Táº¡i',0),(226450,6291,'af','Lughawe Bestaan Alreeds',0),(226451,6291,'ro','Aeroportul existÄƒ deja',0),(226452,6291,'et','Lennujaam on juba olemas',0),(226453,6291,'si','LetaliÅ¡Äa Å¾e obstaja',0),(226454,6291,'ba','Bandara sudah ada',0),(226455,6291,'nl','Luchthaven bestaat al',0),(226456,6291,'fi','LentokenttÃ¤ on jo olemassa',0),(226457,6291,'no','Flyplassen finnes allerede',0),(226458,6291,'da','Lufthavn findes allerede',0),(226459,6291,'ko','ì´ë¯¸ ì¡´ìž¬ í•˜ëŠ” ê³µí•­',0),(226460,6291,'he','× ×ž×œ ×”×ª×¢×•×¤×” ×›×‘×¨ ×§×™×™×',0),(226461,6291,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(226462,6291,'zh','æœºåœºå·²å­˜åœ¨\r\n',0),(226463,6291,'sv','Flygplats finns redan',0),(226464,6291,'it','Aeroporto esiste giÃ ',0),(226465,6291,'tl','',0),(226466,6291,'th','&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(226467,6291,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(226468,6291,'ms','Lapangan Terbang sudah sedia wujud',0),(226469,6291,'ar','Ø§Ù„Ù…Ø·Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(226470,6291,'fr','AÃ©roport existe dÃ©jÃ ',0),(226471,6291,'jp','ç©ºæ¸¯ã?Œæ—¢ã?«å­˜åœ¨ã?—ã?¾ã?™',0),(226472,6291,'pt','Aeroporto jÃ¡ existe',0),(226473,6291,'ru','ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚ Ð£Ð¶Ðµ Ð¡Ð¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ÑŒÑÑ',0),(226474,6291,'es','Aeropuerto Ya Existe',0),(226475,6291,'de','Flughafen ist bereits vorhanden.',0),(226476,6291,'en','Airport Already Exists',0),(226477,6292,'is','',0),(226478,6292,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226479,6292,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226480,6292,'tr','HavaalanÄ± ekleme hatasÄ±',0),(226481,6292,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania Lotnisko',0),(226482,6292,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»ÐµÑ‚Ð¸Ñ‰Ðµ',0),(226483,6292,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(226484,6292,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼',0),(226485,6292,'vi','ThÃªm sÃ¢n bay bá»‹ lá»—i',0),(226486,6292,'af','Fout voeg lughawe',0),(226487,6292,'ro','Eroare la adÄƒugarea Airport',0),(226488,6292,'et','Viga lisades Airport',0),(226489,6292,'si','Napaka pri dodajanju Airport',0),(226490,6292,'ba','Kesalahan menambahkan Bandara',0),(226491,6292,'nl','Fout toe te voegen luchthaven',0),(226492,6292,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ Airport',0),(226493,6292,'no','Feil under tillegging av Airport',0),(226494,6292,'da','Fejl ved tilfÃ¸jelse af lufthavn',0),(226495,6292,'ko','ê³µí•­ ì¶”ê°€ ì˜¤ë¥˜',0),(226496,6292,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×©×“×” ×”×ª×¢×•×¤×”',0),(226497,6292,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿',0),(226498,6292,'zh','é”™è¯¯æ·»åŠ æœºåœº\r\n',0),(226499,6292,'sv','Fel att lÃ¤gga till flygplatsen',0),(226500,6292,'it','Errore aggiungendo aeroporto',0),(226501,6292,'tl','',0),(226502,6292,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226503,6292,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(226504,6292,'ms','Ralat menambah Lapangan Terbang',0),(226505,6292,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…Ø·Ø§Ø±',0),(226506,6292,'fr','Erreur ajout d\'aÃ©roport',0),(226507,6292,'jp','ç©ºæ¸¯ã?Œè¿½åŠ ã?§ã??ã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(226508,6292,'pt','Erro ao adicionar Aeroporto',0),(226509,6292,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226510,6292,'es','Error Agregando Aeropuerto',0),(226511,6292,'de','Fehler beim HinzufÃ¼gen des Flughafen',0),(226512,6292,'en','Error adding Airport',0),(226513,6293,'is','',0),(226514,6293,'dr','Ú¯Ø±ÙˆÙ‡ Ø®Ø¯Ù…Ø§Øª',0),(226515,6293,'pr','Ú¯Ø±ÙˆÙ‡ Ø®Ø¯Ù…Ø§Øª',0),(226516,6293,'tr','Servis kategorisi',0),(226517,6293,'pl','Kategoria usÅ‚ugi',0),(226518,6293,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÑƒÑÐ»ÑƒÐ³Ð°',0),(226519,6293,'ur','Ø®Ø¯Ù…Øª Ø²Ù…Ø±Û',0),(226520,6293,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° ÑƒÑÐ»ÑƒÐ³Ðµ',0),(226521,6293,'vi','Thá»ƒ loáº¡i dá»‹ch vá»¥',0),(226522,6293,'af','Dienskategorie',0),(226523,6293,'ro','Serviciu categorie',0),(226524,6293,'et','Teenuse kategooria',0),(226525,6293,'si','Kategorije storitev',0),(226526,6293,'ba','Kategori Jasa',0),(226527,6293,'nl','Servicecategorie',0),(226528,6293,'fi','Palvelun pÃ¤Ã¤luokka',0),(226529,6293,'no','Servicekategorien',0),(226530,6293,'da','Ydelsesart',0),(226531,6293,'ko','ì„œë¹„ìŠ¤ ë²”ì£¼',0),(226532,6293,'he','×§×˜×’×•×¨×™×™×ª',0),(226533,6293,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(226534,6293,'zh','æœåŠ¡ç±»åˆ«\r\n',0),(226535,6293,'sv','TjÃ¤nstekategori',0),(226536,6293,'it','Categoria di servizio',0),(226537,6293,'tl','',0),(226538,6293,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(226539,6293,'hi','à¤¸à¥‡à¤µà¤¾ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(226540,6293,'ms','Kategori Perkhidmatan',0),(226541,6293,'ar','ØªØµÙ†ÙŠÙ Ø§Ù„Ø®Ø¯Ù…Ø§Øª',0),(226542,6293,'fr','CatÃ©gorie de service',0),(226543,6293,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(226544,6293,'pt','Categoria de serviÃ§o',0),(226545,6293,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(226546,6293,'es','CategorÃ­a de Servicios',0),(226547,6293,'de','Service-Kategorie',0),(226548,6293,'en','Service Category',0),(226549,6294,'is','',0),(226550,6294,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226551,6294,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226552,6294,'tr','HavaalanÄ± Servisi tÃ¼r gÃ¼ncelleÅŸtirme',0),(226553,6294,'pl','Port lotniczy usÅ‚ugi typu Update',0),(226554,6294,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ ÑÐ»ÑƒÐ¶Ð±Ð° Ð²Ð¸Ð´ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(226555,6294,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ø³Ø±ÙˆØ³ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(226556,6294,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÑÐµÑ€Ð²Ð¸Ñ Ñ‚Ð¸Ð¿ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(226557,6294,'vi','Cáº­p Nháº­t Loáº¡i Dá»‹ch Vá»¥ SÃ¢n Bay',0),(226558,6294,'af','Lughawe Dienste Tipe Opdateer',0),(226559,6294,'ro','Aeroportul serviciul de tip Update',0),(226560,6294,'et','Lennujaama teenuse tÃ¼Ã¼p vÃ¤rskendamine',0),(226561,6294,'si','LetaliÅ¡Äe storitev tipa posodobitev',0),(226562,6294,'ba','Bandara layanan jenis Update',0),(226563,6294,'nl','Luchthaven Service Type Update',0),(226564,6294,'fi','Airport Service tyypin pÃ¤ivitys',0),(226565,6294,'no','Flyplassen Service Type oppdatering',0),(226566,6294,'da','Lufthavn Service Type opdatering',0),(226567,6294,'ko','ê³µí•­ ì„œë¹„ìŠ¤ í˜•ì‹ ì—…ë°ì´íŠ¸',0),(226568,6294,'he','× ×ž×œ ×”×ª×¢×•×¤×” ×©×™×¨×•×ª ×¡×•×’ ×¢×“×›×•×Ÿ',0),(226569,6294,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Ï…Ï€Î·ÏÎµÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï… ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(226570,6294,'zh','æœºåœºæœåŠ¡ç±»åˆ«æ›´æ–°\r\n',0),(226571,6294,'sv','Flygplatsen Service typ uppdatering',0),(226572,6294,'it','Aeroporto servizio tipo aggiornamento',0),(226573,6294,'tl','',0),(226574,6294,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226575,6294,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(226576,6294,'ms','Kemaskini jenis perkhidmatan Lapangan Terbang',0),(226577,6294,'ar','ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø© Ø§Ù„Ù…Ø·Ø§Ø±',0),(226578,6294,'fr','Mise Ã  jour du Type de Service des aÃ©roport',0),(226579,6294,'jp','ç©ºæ¸¯ã‚µãƒ¼ãƒ“ã‚¹ã‚¿ã‚¤ãƒ—ã?®æ›´æ–°',0),(226580,6294,'pt','AtualizaÃ§Ã£o de tipo de serviÃ§o de aeroporto',0),(226581,6294,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿Ñ‹ Ð£ÑÐ»ÑƒÐ³ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226582,6294,'es','Aeropuerto Tipo de Servicios Actualizar',0),(226583,6294,'de','Flughafen-Service-Typ-Update',0),(226584,6294,'en','Airport Service Type Update',0),(226585,6295,'is','',0),(226586,6295,'dr','ÙØ¹Ø§Ù„ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ØŸ',0),(226587,6295,'pr','ÙØ¹Ø§Ù„ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ØŸ',0),(226588,6295,'tr','Bu HavaalanÄ± iÃ§in etkin mi?',0),(226589,6295,'pl','Aktywna dla tego lotniska?',0),(226590,6295,'bg','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð·Ð° Ñ‚Ð¾Ð²Ð° Ð»ÐµÑ‚Ð¸Ñ‰Ðµ?',0),(226591,6295,'ur','Ø§Ø³ ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ú©Û’ Ù„ÛŒÛ’ Ø²ÛŒØ± Ø¹Ù…Ù„ØŸ',0),(226592,6295,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð° Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼?',0),(226593,6295,'vi','KÃ­ch Hoáº¡t SÃ¢n Bay nÃ y?',0),(226594,6295,'af','Aktief vir hierdie Lughawe?',0),(226595,6295,'ro','Activ pentru acest Aeroport?',0),(226596,6295,'et','Aktiivne selles Airport?',0),(226597,6295,'si','Dejanje za to letaliÅ¡Äe?',0),(226598,6295,'ba','Aktif untuk Airport ini?',0),(226599,6295,'nl','Actief voor deze luchthaven?',0),(226600,6295,'fi','Aktiivinen tÃ¤ssÃ¤ Airport?',0),(226601,6295,'no','Aktiv for denne flyplassen?',0),(226602,6295,'da','Aktiv for denne lufthavn?',0),(226603,6295,'ko','ì´ ê³µí•­ì— ëŒ€ í•œ í™œì„±?',0),(226604,6295,'he','×¤×¢×™×œ ×¢×‘×•×¨ × ×ž×œ ×”×ª×¢×•×¤×” ×”×–×”?',0),(226605,6295,'el','Î•Î½ÎµÏÎ³ÏŒ Î³Î¹Î± Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Î±ÎµÏÎ¿Î»Î¹Î¼Î­Î½Î±;',0),(226606,6295,'zh','æ´»è·ƒé€™å€‹ç«™\r\n',0),(226607,6295,'sv','Aktiv fÃ¶r denna flygplats?',0),(226608,6295,'it','Attivo per questo aeroporto?',0),(226609,6295,'tl','',0),(226610,6295,'th','&#3607;&#3635;&#3591;&#3634;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;&#3609;&#3637;&#3657;',0),(226611,6295,'hi','à¤‡à¤¸ à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤•à¥à¤°à¤¿à¤¯?',0),(226612,6295,'ms','Aktif untuk Lapangan Terbang ini?',0),(226613,6295,'ar','Ø§Ù„Ù†Ø´Ø·Ø© Ù„Ù‡Ø°Ø§ Ø§Ù„Ù…Ø·Ø§Ø±ØŸ',0),(226614,6295,'fr','Actif pour cet aÃ©roport?',0),(226615,6295,'jp','ã?“ã?®ç©ºæ¸¯ã‚’æœ‰åŠ¹ã?«ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(226616,6295,'pt','Ativo para este aeroporto?',0),(226617,6295,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ð¼ Ð´Ð»Ñ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð°ÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°?',0),(226618,6295,'es','Â¿Activar para este Aeropuerto?',0),(226619,6295,'de','FÃ¼r diesen Flughafen aktiv?',0),(226620,6295,'en','Active for this Airport?',0),(226621,6296,'is','',0),(226622,6296,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226623,6296,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226624,6296,'tr','HavaalanÄ± Hizmetleri gÃ¼ncelleÅŸtirme',0),(226625,6296,'pl','Port lotniczy usÅ‚ugi aktualizacji',0),(226626,6296,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(226627,6296,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ Ú©ÛŒ Ø®Ø¯Ù…Ø§Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(226628,6296,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÑƒÑÐ»ÑƒÐ³Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(226629,6296,'vi','CÃ¢p Nháº­t Dá»‹ch Vá»¥ SÃ¢n Bay',0),(226630,6296,'af','Lughawe Dienste Opdateer',0),(226631,6296,'ro','Aeroportul servicii actualizare',0),(226632,6296,'et','Lennujaama teenuste vÃ¤rskendamine',0),(226633,6296,'si','Posodobitev letaliÅ¡ke storitve',0),(226634,6296,'ba','Bandara Layanan Update',0),(226635,6296,'nl','Luchthaven diensten Update',0),(226636,6296,'fi','Airport Services-pÃ¤ivitys',0),(226637,6296,'no','Flyplass tjenester oppdatering',0),(226638,6296,'da','Airport Services opdatering',0),(226639,6296,'ko','ê³µí•­ ì„œë¹„ìŠ¤ ì—…ë°ì´íŠ¸',0),(226640,6296,'he','× ×ž×œ ×”×ª×¢×•×¤×” ×©×™×¨×•×ª×™ ×¢×“×›×•×Ÿ',0),(226641,6296,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Ï…Ï€Î·ÏÎµÏƒÎ¯ÎµÏ‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(226642,6296,'zh','æœºåœºæœåŠ¡æ›´æ–°\r\n',0),(226643,6296,'sv','Airport Services-uppdateringen',0),(226644,6296,'it','Aggiornamento servizi aeroporto',0),(226645,6296,'tl','',0),(226646,6296,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226647,6296,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¤¾ à¤¸à¥‡à¤µà¤¾à¤à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(226648,6296,'ms','Kemaskini Perkhidmatan Lapangan Terbang',0),(226649,6296,'ar','ØªØ­Ø¯ÙŠØ« Ø®Ø¯Ù…Ø§Øª Ø§Ù„Ù…Ø·Ø§Ø±',0),(226650,6296,'fr','AÃ©roport Services Update',0),(226651,6296,'jp','ç©ºæ¸¯ã‚µãƒ¼ãƒ“ã‚¹ã?®æ›´æ–°',0),(226652,6296,'pt','AtualizaÃ§Ã£o de serviÃ§os do Aeroporto',0),(226653,6296,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð£ÑÐ»ÑƒÐ³Ð¸ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226654,6296,'es','Aeropuerto Servicios Actualizar',0),(226655,6296,'de','Flughafen-Services-Update',0),(226656,6296,'en','Airport Services Update',0),(226657,6297,'is','',0),(226658,6297,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226659,6297,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226660,6297,'tr','HavaalanÄ± Servisi Kategori gÃ¼ncelleÅŸtirme',0),(226661,6297,'pl','Port lotniczy usÅ‚ugi kategorii aktualizacji',0),(226662,6297,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(226663,6297,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ø³Ø±ÙˆØ³ Ø§Ù¾ ÚˆÛŒÙ¹ Ø²Ù…Ø±Û',0),(226664,6297,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÑƒÑÐ»ÑƒÐ³Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(226665,6297,'vi','CÃ¢p Nháº­p PhÃ¢n Loáº¡i Dá»‹ch Vá»¥ SÃ¢n Bay',0),(226666,6297,'af','Lughawe Dienste Kategorie Opdateer',0),(226667,6297,'ro','Aeroportul serviciu categorie Update',0),(226668,6297,'et','Lennujaama teenuse kategooria Update',0),(226669,6297,'si','LetaliÅ¡Äa kategorije storitev posodabljanja',0),(226670,6297,'ba','Bandara Layanan kategori Update',0),(226671,6297,'nl','Luchthaven Service categorie Update',0),(226672,6297,'fi','Airport Service luokka pÃ¤ivitys',0),(226673,6297,'no','Oppdateringen for flyplassen Service kategori',0),(226674,6297,'da','Lufthavn Service kategori opdatering',0),(226675,6297,'ko','ê³µí•­ ì„œë¹„ìŠ¤ ì¹´í…Œê³ ë¦¬ ì—…ë°ì´íŠ¸',0),(226676,6297,'he','× ×ž×œ ×”×ª×¢×•×¤×” ×©×™×¨×•×ª ×§×˜×’×•×¨×™×” ×¢×“×›×•×Ÿ',0),(226677,6297,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Ï…Ï€Î·ÏÎµÏƒÎ¯Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(226678,6297,'zh','æœºåœºæœåŠ¡ç±»åˆ«æ›´æ–°\r\n',0),(226679,6297,'sv','Flygplatsen Service kategori uppdatering',0),(226680,6297,'it','Aeroporto servizio categoria aggiornamento',0),(226681,6297,'tl','',0),(226682,6297,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3635;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226683,6297,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤¸à¥‡à¤µà¤¾ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(226684,6297,'ms','Kemaskini kategori perkhidmatan Lapangan Terbang',0),(226685,6297,'ar','ØªØ­Ø¯ÙŠØ« ÙØ¦Ø© Ø®Ø¯Ù…Ø© Ø§Ù„Ù…Ø·Ø§Ø±',0),(226686,6297,'fr','Mise Ã  jour de Airport Service catÃ©gorie',0),(226687,6297,'jp','ç©ºæ¸¯ã‚µãƒ¼ãƒ“ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼ã?®æ›´æ–°',0),(226688,6297,'pt','ActualizaÃ§Ã£o de categoria de serviÃ§o de aeroporto',0),(226689,6297,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð£ÑÐ»ÑƒÐ³ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226690,6297,'es','Aeropuerto Servicio ActualizaciÃ³n de CategorÃ­a',0),(226691,6297,'de','Flughafen-Service-Kategorie-Update',0),(226692,6297,'en','Airport Service Category Update',0),(226693,6298,'is','',0),(226694,6298,'dr','Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226695,6298,'pr','Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226696,6298,'tr','HavaalanÄ± Servisi',0),(226697,6298,'pl','Lotnisko',0),(226698,6298,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(226699,6298,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ø³Ø±ÙˆØ³',0),(226700,6298,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÑÐµÑ€Ð²Ð¸Ñ',0),(226701,6298,'vi','Dá»‹ch Vá»¥ SÃ¢n Bay',0),(226702,6298,'af','Lughawe Diens',0),(226703,6298,'ro','La aeroport',0),(226704,6298,'et','Lennujaama',0),(226705,6298,'si','Prevoz',0),(226706,6298,'ba','Bandara',0),(226707,6298,'nl','Pendeldienst naar het vliegveld',0),(226708,6298,'fi','LentokenttÃ¤kuljetus',0),(226709,6298,'no','Flyplassen',0),(226710,6298,'da','Airport-tjenesten',0),(226711,6298,'ko','ê³µí•­ ì„œë¹„ìŠ¤',0),(226712,6298,'he','×—×‘×¨×ª ×”×¡×¢×•×ª',0),(226713,6298,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿',0),(226714,6298,'zh','æœºåœºæœåŠ¡\r\n',0),(226715,6298,'sv','Flygplatsen',0),(226716,6298,'it','Servizio aeroporto',0),(226717,6298,'tl','',0),(226718,6298,'th','&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226719,6298,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤¸à¥‡à¤µà¤¾',0),(226720,6298,'ms','Perkhidmatan Lapangan Terbang',0),(226721,6298,'ar','Ø®Ø¯Ù…Ø© Ø§Ù„Ù…Ø·Ø§Ø±',0),(226722,6298,'fr','Service de l\'aÃ©roport',0),(226723,6298,'jp','ç©ºæ¸¯ã‚µãƒ¼ãƒ“ã‚¹',0),(226724,6298,'pt','ServiÃ§o de aeroporto',0),(226725,6298,'ru','Ð£ÑÐ»ÑƒÐ³Ð° ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226726,6298,'es','Aeropuerto Servicio',0),(226727,6298,'de','Flughafen-Service',0),(226728,6298,'en','Airport Service',0),(226729,6299,'is','',0),(226730,6299,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226731,6299,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226732,6299,'tr','HavaalanÄ± Hizmetleri Ekle',0),(226733,6299,'pl','DodaÄ‡ Lotnisko',0),(226734,6299,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð¸-Ð»ÐµÑ‚Ð¸Ñ‰Ðµ',0),(226735,6299,'ur','Ø§ÛŒØ¦Ø± Ù¾ÙˆØ±Ù¹ Ø³Ø±ÙˆØ³Ø² Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(226736,6299,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑƒÑÐ»ÑƒÐ³Ðµ Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼',0),(226737,6299,'vi','ThÃªm CÃ¡c Dá»‹ch Vá»¥ SÃ¢n Bay',0),(226738,6299,'af','Voeg Lughawe Dienste by',0),(226739,6299,'ro','Adauga servicii de aeroport',0),(226740,6299,'et','Lennujaama teenuste lisamine',0),(226741,6299,'si','Dodaj letaliÅ¡kih storitev',0),(226742,6299,'ba','Tambahkan layanan bandara',0),(226743,6299,'nl','Luchthavendiensten toevoegen',0),(226744,6299,'fi','Airport Services lisÃ¤Ã¤',0),(226745,6299,'no','Flyplass tjenester legge',0),(226746,6299,'da','Airport Services tilfÃ¸je',0),(226747,6299,'ko','ê³µí•­ ì„œë¹„ìŠ¤ ì¶”ê°€',0),(226748,6299,'he','×©×™×¨×•×ª×™ ×”×ª×¢×•×¤×” ×œ×”×•×¡×™×£',0),(226749,6299,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Ï…Ï€Î·ÏÎµÏƒÎ¯ÎµÏ‚ ÏƒÏ…Î¼Î²Î¬Î»Î»Î¿Ï…Î½',0),(226750,6299,'zh','æœºåœºæœåŠ¡æ·»åŠ \r\n',0),(226751,6299,'sv','TjÃ¤nsterna fÃ¶r flygplats',0),(226752,6299,'it','Aggiungere servizi aeroportuali',0),(226753,6299,'tl','',0),(226754,6299,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226755,6299,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¤¾ à¤¸à¥‡à¤µà¤¾à¤à¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(226756,6299,'ms','Tambah Perkhidmatan Lapangan Terbang',0),(226757,6299,'ar','Ø¥Ø¶Ø§ÙØ© Ø®Ø¯Ù…Ø§Øª Ø§Ù„Ù…Ø·Ø§Ø±',0),(226758,6299,'fr','Ajoutent des Services aÃ©roportuaires',0),(226759,6299,'jp','ç©ºæ¸¯ã‚µãƒ¼ãƒ“ã‚¹ã?®è¿½åŠ ',0),(226760,6299,'pt','Adicionar serviÃ§os de aeroporto',0),(226761,6299,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð£ÑÐ»ÑƒÐ³Ð¸ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226762,6299,'es','Aeropuerto Servicios Agregar',0),(226763,6299,'de','Flughafendienste hinzufÃ¼gen',0),(226764,6299,'en','Airport Services Add',0),(226765,6300,'is','',0),(226766,6300,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226767,6300,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226768,6300,'tr','HavaalanÄ± hizmet kategorileri',0),(226769,6300,'pl','Kategorie usÅ‚ug lotniska',0),(226770,6300,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸Ñ‚Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(226771,6300,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ø³Ø±ÙˆØ³ Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(226772,6300,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÑÐµÑ€Ð²Ð¸Ñ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(226773,6300,'vi','CÃ¡c LÄ©nh Vá»¥c Dá»‹ch Vá»¥ SÃ¢n Bay',0),(226774,6300,'af','Lughawe Diens KategoriÃ«',0),(226775,6300,'ro','Categorii de servicii de aeroport',0),(226776,6300,'et','Lennujaama teenuste kategooriad',0),(226777,6300,'si','LetaliÅ¡Äa kategorije storitev',0),(226778,6300,'ba','Kategori Layanan Bandara',0),(226779,6300,'nl','Luchthaven-servicecategorieÃ«n',0),(226780,6300,'fi','Airport Service Categories',0),(226781,6300,'no','Flyplassen servicekategorier',0),(226782,6300,'da','Lufthavn Service kategorier',0),(226783,6300,'ko','ê³µí•­ ì„œë¹„ìŠ¤ ì¹´í…Œê³ ë¦¬',0),(226784,6300,'he','×§×˜×’×•×¨×™×•×ª ×©×™×¨×•×ª ×œ× ×ž×œ ×”×ª×¢×•×¤×”',0),(226785,6300,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½ Î±ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿',0),(226786,6300,'zh','æœºåœºæœåŠ¡ç±»åˆ«\r\n',0),(226787,6300,'sv','Flygplatsen tjÃ¤nstekategorier',0),(226788,6300,'it','Categorie di servizio aeroporto',0),(226789,6300,'tl','',0),(226790,6300,'th','&#3621;&#3635;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226791,6300,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤¸à¥‡à¤µà¤¾ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(226792,6300,'ms','Kategori Perkhidmatan Lapangan Terbang',0),(226793,6300,'ar','ÙØ¦Ø§Øª Ø§Ù„Ø®Ø¯Ù…Ø© ÙÙŠ Ø§Ù„Ù…Ø·Ø§Ø±',0),(226794,6300,'fr','CatÃ©gories de services d\'aÃ©roport',0),(226795,6300,'jp','ç©ºæ¸¯ã‚µãƒ¼ãƒ“ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(226796,6300,'pt','Categorias de serviÃ§o do Aeroporto',0),(226797,6300,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð£ÑÐ»ÑƒÐ³ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226798,6300,'es','Aeropuerto CatedorÃ­as de Servicios',0),(226799,6300,'de','Flughafen-Service-Kategorien',0),(226800,6300,'en','Airport Service Categories',0),(226801,6301,'is','',0),(226802,6301,'dr','Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226803,6301,'pr','Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226804,6301,'tr','HavaalanÄ± hizmet tÃ¼rleri',0),(226805,6301,'pl','Port lotniczy typÃ³w usÅ‚ug',0),(226806,6301,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(226807,6301,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ø³Ø±ÙˆØ³ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(226808,6301,'sr','Ð’Ñ€ÑÑ‚Ðµ Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(226809,6301,'vi','Loáº¡i Dá»‹ch Vu SÃ¢n Bay',0),(226810,6301,'af','Lughawe Dienste Tipes',0),(226811,6301,'ro','Tipuri de servicii de aeroport',0),(226812,6301,'et','Lennujaama teenistuse liigid',0),(226813,6301,'si','Vrste servisnih Airport',0),(226814,6301,'ba','Tipe-tipe layanan bandara',0),(226815,6301,'nl','Luchthaven servicetypen',0),(226816,6301,'fi','Airport palvelutyypit',0),(226817,6301,'no','Flyplass-tjenestetypene',0),(226818,6301,'da','Lufthavn servicetyper',0),(226819,6301,'ko','ê³µí•­ ì„œë¹„ìŠ¤ ì¢…ë¥˜',0),(226820,6301,'he','×¡×•×’×™ ×”×©×™×¨×•×ª×™× ×œ×©×“×” ×”×ª×¢×•×¤×”',0),(226821,6301,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Ï„ÏÏ€Î¿Ï…Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚',0),(226822,6301,'zh','æœºåœºæœåŠ¡ç±»åž‹\r\n',0),(226823,6301,'sv','Airport servicetyper',0),(226824,6301,'it','Tipi di servizio aeroporto',0),(226825,6301,'tl','',0),(226826,6301,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226827,6301,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(226828,6301,'ms','Jenis-jenis perkhidmatan Lapangan Terbang',0),(226829,6301,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø© Ø§Ù„Ù…Ø·Ø§Ø±',0),(226830,6301,'fr','Types de services d\'aÃ©roport',0),(226831,6301,'jp','ç©ºæ¸¯ã‚µãƒ¼ãƒ“ã‚¹ã‚¿ã‚¤ãƒ—',0),(226832,6301,'pt','Tipos de serviÃ§o de aeroporto',0),(226833,6301,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð£ÑÐ»ÑƒÐ³ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226834,6301,'es','Aeropuerto Tipos de Servicio',0),(226835,6301,'de','Flughafen-Service-Typen',0),(226836,6301,'en','Airport Service Types',0),(226837,6302,'is','',0),(226838,6302,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª ',0),(226839,6302,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª ',0),(226840,6302,'tr','Hizmet kategorileri',0),(226841,6302,'pl','Kategorie usÅ‚ug',0),(226842,6302,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸Ñ‚Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(226843,6302,'ur','Ø®Ø¯Ù…Øª Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(226844,6302,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ ÑƒÑÐ»ÑƒÐ³Ð°',0),(226845,6302,'vi','Thá»ƒ loáº¡i Dá»‹ch vá»¥',0),(226846,6302,'af','DienskategoriÃ«',0),(226847,6302,'ro','Categorii de service',0),(226848,6302,'et','Teenuste kategooriad',0),(226849,6302,'si','Kategorije storitev',0),(226850,6302,'ba','Kategori Layanan',0),(226851,6302,'nl','ServicecategorieÃ«n',0),(226852,6302,'fi','Palveluluokat',0),(226853,6302,'no','Servicekategorier',0),(226854,6302,'da','Ydelsesarter',0),(226855,6302,'ko','ì„œë¹„ìŠ¤ ì¹´í…Œê³ ë¦¬',0),(226856,6302,'he','×§×˜×’×•×¨×™×•×ª ×©×¨×•×ª',0),(226857,6302,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½',0),(226858,6302,'zh','æœåŠ¡ç±»åˆ«\r\n',0),(226859,6302,'sv','TjÃ¤nstekategorier',0),(226860,6302,'it','Categorie di servizio',0),(226861,6302,'tl','',0),(226862,6302,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(226863,6302,'hi','à¤¸à¥‡à¤µà¤¾ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(226864,6302,'ms','Kategori Perkhidmatan',0),(226865,6302,'ar','ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„Ø®Ø¯Ù…Ø§Øª',0),(226866,6302,'fr','CatÃ©gories de services',0),(226867,6302,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(226868,6302,'pt','Categorias de serviÃ§os',0),(226869,6302,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð¾Ð²',0),(226870,6302,'es','CategorÃ­as de Servicios',0),(226871,6302,'de','Leistungskategorien',0),(226872,6302,'en','Service Categories',0),(226873,6303,'is','',0),(226874,6303,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø«Ø§Ø¨Øª ÙƒØ§Ø±Ù…Ø²Ø¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226875,6303,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø«Ø§Ø¨Øª ÙƒØ§Ø±Ù…Ø²Ø¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(226876,6303,'tr','HavaalanÄ± Ã¼creti dÃ¼z Ã¼cret',0),(226877,6303,'pl','Port lotniczy opÅ‚ata pÅ‚aski',0),(226878,6303,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ð½Ð° Ñ‚Ð°ÐºÑÐ° Ñ„Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(226879,6303,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ú©ÛŒ ÙÛŒØ³ ÙÙ„ÛŒÙ¹ Ú†Ø§Ø±Ø¬',0),(226880,6303,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ Ð½Ð°ÐºÐ½Ð°Ð´Ð° Ð¿Ð°ÑƒÑˆÐ°Ð»Ð½Ð° Ð½Ð°ÐºÐ½Ð°Ð´Ð°',0),(226881,6303,'vi','PhÃ­ SÃ¢n Bay Má»™t Láº§n',0),(226882,6303,'af','Lughawe fooi plat las',0),(226883,6303,'ro','Taxa de plat taxa aeroport',0),(226884,6303,'et','Lennujaama tasu kindla suurusega tasu',0),(226885,6303,'si','LetaliÅ¡ka pristojbina stanovanje pristojbina',0),(226886,6303,'ba','Bandara JOCS datar',0),(226887,6303,'nl','Luchthaven vergoeding vaste toeslag',0),(226888,6303,'fi','Airport maksun kiinteÃ¤n maksun',0),(226889,6303,'no','Flyplass avgift Flat avgift',0),(226890,6303,'da','Lufthavn gebyr engangspris',0),(226891,6303,'ko','ê³µí•­ ìˆ˜ìˆ˜ë£Œ í”Œëž« ìš”ê¸ˆ',0),(226892,6303,'he','× ×ž×œ ×”×ª×¢×•×¤×” ×“×ž×™ ×©×˜×•×—',0),(226893,6303,'el','Î‘ÎµÏÎ¿Î»Î¹Î¼ÎµÎ½Î¹ÎºÏŒ Ï„Î­Î»Î¿Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î· Ï„Î­Î»Î¿Ï‚',0),(226894,6303,'zh','æœºåœºè´¹å›ºå®šæ”¶è´¹\r\n',0),(226895,6303,'sv','Flygplatsen avgift fast avgift',0),(226896,6303,'it','Aeroporto tassa piana carica',0),(226897,6303,'tl','',0),(226898,6303,'th','&#3585;&#3634;&#3619;&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3605;&#3633;&#3657;&#3591;&#3621;&#3635;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(226899,6303,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¤¾ à¤¶à¥à¤²à¥à¤• à¤«à¥à¤²à¥ˆà¤Ÿ à¤¶à¥à¤²à¥à¤•',0),(226900,6303,'ms','Caj rata bayaran Lapangan Terbang',0),(226901,6303,'ar','Ù…Ø·Ø§Ø± Ø±Ø³ÙˆÙ… Ø´Ø­Ù† Ù…Ø³Ø·Ø­Ø©',0),(226902,6303,'fr','Forfait de frais aÃ©roport',0),(226903,6303,'jp','ç©ºæ¸¯æ–™å?‡ä¸€æ–™é‡‘',0),(226904,6303,'pt','Aeroporto taxa plana',0),(226905,6303,'ru','ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð° Ð¿Ð»Ð°Ñ‚Ñƒ Ð¿Ð»Ð¾ÑÐºÐ¾Ð¹ Ð·Ð°Ñ€ÑÐ´',0),(226906,6303,'es','Aeropuerto Carga de Cuota Fija',0),(226907,6303,'de','Flughafen GebÃ¼hr PauschalgebÃ¼hr',0),(226908,6303,'en','Airport Fee Flat Charge',0),(226909,6304,'is','',0),(226910,6304,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ø²Ø¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226911,6304,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ø²Ø¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(226912,6304,'tr','HavaalanÄ± Ã¼creti yÃ¼zde ÅŸarj',0),(226913,6304,'pl','Port lotniczy procent opÅ‚aty',0),(226914,6304,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ð½Ð° Ñ‚Ð°ÐºÑÐ° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ñ‚Ð°ÐºÑÐ°',0),(226915,6304,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ú©ÛŒ ÙÛŒØ³ ÙÛŒ ØµØ¯ Ú†Ø§Ø±Ø¬',0),(226916,6304,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ Ð½Ð°ÐºÐ½Ð°Ð´Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(226917,6304,'vi','% PhÃ­ SÃ¢n Bay',0),(226918,6304,'af','Lughawe fooi persentasie gelaai',0),(226919,6304,'ro','Aeroport taxa taxa la sutÄƒ',0),(226920,6304,'et','Lennujaama tasu protsent',0),(226921,6304,'si','LetaliÅ¡ka pristojbina odstotkov pristojbina',0),(226922,6304,'ba','Bandara JOCS persen',0),(226923,6304,'nl','Luchthaven vergoeding percentage kosten',0),(226924,6304,'fi','Airport maksu prosenttia ilmaiseksi',0),(226925,6304,'no','Flyplass avgift prosent avgift',0),(226926,6304,'da','Lufthavn gebyr procent afgift',0),(226927,6304,'ko','ê³µí•­ ìˆ˜ìˆ˜ë£Œ % ì¶©ì „',0),(226928,6304,'he','× ×ž×œ ×”×ª×¢×•×¤×” ×“×ž×™ ××—×•×–',0),(226929,6304,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(226930,6304,'zh','æœºåœºè´¹çš„ç™¾åˆ†ä¹‹\r\n',0),(226931,6304,'sv','Flygplatsavgift avgift procent',0),(226932,6304,'it','Aeroporto supplemento minimo percentuale',0),(226933,6304,'tl','',0),(226934,6304,'th','&#3585;&#3634;&#3619;&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;',0),(226935,6304,'hi','à¤à¤¯à¤°à¤ªà¥‹à¤°à¥à¤Ÿ à¤¶à¥à¤²à¥à¤• à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¶à¥à¤²à¥à¤•',0),(226936,6304,'ms','Caj peratus bayaran Lapangan Terbang',0),(226937,6304,'ar','Ù…Ù‚Ø§Ø¨Ù„ Ù†Ø³Ø¨Ø© Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ø·Ø§Ø±',0),(226938,6304,'fr','AÃ©roport le plus pratique frais de pourcentage',0),(226939,6304,'jp','ç©ºæ¸¯æ–™å‰²å?ˆæ–™é‡‘',0),(226940,6304,'pt','Taxa de porcentagem de taxa aeroportuÃ¡ria',0),(226941,6304,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¹ Ð°ÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(226942,6304,'es','Porcentaje de Cuota Fija para TarÃ­fa del Aeropuerto ',0),(226943,6304,'de','Prozentuale FlughafengebÃ¼hr',0),(226944,6304,'en','Airport Fee Percent Charge',0),(226945,6305,'is','',0),(226946,6305,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯',0),(226947,6305,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯',0),(226948,6305,'tr','Otopark Ã¼cretleri',0),(226949,6305,'pl','OpÅ‚aty za parkowanie',0),(226950,6305,'bg','Ð¢Ð°ÐºÑÐ¸ Ð·Ð° Ð¿Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(226951,6305,'ur','Ù¾Ø§Ø±Ú©Ù†Ú¯ ÙÛŒØ³',0),(226952,6305,'sr','ÐÐ°Ð´Ð¾ÐºÐ½Ð°Ð´Ðµ Ð·Ð° Ð¿Ð°Ñ€ÐºÐ¸Ñ€Ð°ÑšÐµ',0),(226953,6305,'vi','PhÃ­ Ä‘áº­u xe',0),(226954,6305,'af','Parkeergelde',0),(226955,6305,'ro','Taxele de parcare',0),(226956,6305,'et','Parkimise eest',0),(226957,6305,'si','Parkirnine',0),(226958,6305,'ba','Biaya parkir',0),(226959,6305,'nl','Parkeertarieven',0),(226960,6305,'fi','PysÃ¤kÃ¶intimaksut',0),(226961,6305,'no','Parkeringsavgifter',0),(226962,6305,'da','Parkeringsafgifter',0),(226963,6305,'ko','ì£¼ì°¨ ìš”ê¸ˆ',0),(226964,6305,'he','×“×ž×™ ×”×—× ×™×”',0),(226965,6305,'el','Î¤ÎµÎ»ÏŽÎ½ ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚',0),(226966,6305,'zh','åœè½¦è´¹\r\n',0),(226967,6305,'sv','Parkeringsavgifter',0),(226968,6305,'it','Tasse di parcheggio',0),(226969,6305,'tl','',0),(226970,6305,'th','&#3588;&#3656;&#3634;&#3592;&#3629;&#3604;&#3619;&#3606;',0),(226971,6305,'hi','à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¶à¥à¤²à¥à¤•',0),(226972,6305,'ms','Kadar bayaran letak kereta',0),(226973,6305,'ar','Ø±Ø³ÙˆÙ… ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª',0),(226974,6305,'fr','Frais de stationnement',0),(226975,6305,'jp','é§?è»Šå ´æ–™',0),(226976,6305,'pt','Taxas de estacionamento',0),(226977,6305,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÑƒ',0),(226978,6305,'es','Cuotas Para Estacionar',0),(226979,6305,'de','ParkgebÃ¼hren',0),(226980,6305,'en','Parking Fees',0),(226981,6306,'is','',0),(226982,6306,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª ',0),(226983,6306,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª ',0),(226984,6306,'tr','Servis Ã¼cretleri',0),(226985,6306,'pl','OpÅ‚at za usÅ‚ugi',0),(226986,6306,'bg','Ð¢Ð°ÐºÑÐ¸ Ð·Ð° ÑƒÑÐ»ÑƒÐ³Ð¸',0),(226987,6306,'ur','Ø³Ø±ÙˆØ³ ÙÛŒØ³',0),(226988,6306,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(226989,6306,'vi','PhÃ­ Dá»‹ch vá»¥',0),(226990,6306,'af','Diensfooie',0),(226991,6306,'ro','Tarife servicii',0),(226992,6306,'et','Teenustasud',0),(226993,6306,'si','Pristojbine za storitve',0),(226994,6306,'ba','Biaya layanan',0),(226995,6306,'nl','Servicekosten',0),(226996,6306,'fi','Palvelumaksut',0),(226997,6306,'no','Avgifter',0),(226998,6306,'da','Serviceafgifter',0),(226999,6306,'ko','ì„œë¹„ìŠ¤ ìš”ê¸ˆ',0),(227000,6306,'he','××’×¨×•×ª ×©×¨×•×ª',0),(227001,6306,'el','Î¥Î Î—Î¡Î•Î£Î™Î©Î',0),(227002,6306,'zh','æœåŠ¡è´¹\r\n',0),(227003,6306,'sv','Serviceavgifter',0),(227004,6306,'it','Tasse di servizio',0),(227005,6306,'tl','',0),(227006,6306,'th','&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(227007,6306,'hi','à¤¸à¥‡à¤µà¤¾ à¤¶à¥à¤²à¥à¤•',0),(227008,6306,'ms','Bayaran Perkhidmatan',0),(227009,6306,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø®Ø¯Ù…Ø©',0),(227010,6306,'fr','Frais de service',0),(227011,6306,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ–™',0),(227012,6306,'pt','Taxas de serviÃ§o',0),(227013,6306,'ru','ÐŸÐ»Ð°Ñ‚Ñ‹ Ð·Ð° ÑƒÑÐ»ÑƒÐ³Ð¸',0),(227014,6306,'es','Hoorarios de Servicios',0),(227015,6306,'de','Service-GebÃ¼hren',0),(227016,6306,'en','Service Fees',0),(227017,6307,'is','',0),(227018,6307,'dr','ØªØ§ÙŠÙŠØ¯ ',0),(227019,6307,'pr','ØªØ§ÙŠÙŠØ¯ ',0),(227020,6307,'tr','Onay',0),(227021,6307,'pl','Potwierdzenie',0),(227022,6307,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(227023,6307,'ur','ØªØµØ¯ÛŒÙ‚',0),(227024,6307,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð°',0),(227025,6307,'vi','XÃ¡c Nháº­n',0),(227026,6307,'af','Bevestiging',0),(227027,6307,'ro','Confirmare',0),(227028,6307,'et','Kinnitus',0),(227029,6307,'si','Potrditev',0),(227030,6307,'ba','Konfirmasi',0),(227031,6307,'nl','Bevestiging',0),(227032,6307,'fi','Vahvistus',0),(227033,6307,'no','Bekreftelse',0),(227034,6307,'da','BekrÃ¦ftelse',0),(227035,6307,'ko','í™•ì¸',0),(227036,6307,'he','××™×©×•×¨',0),(227037,6307,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·',0),(227038,6307,'zh','ç¡®è®¤\r\n',0),(227039,6307,'sv','BekrÃ¤ftelse',0),(227040,6307,'it','Conferma',0),(227041,6307,'tl','',0),(227042,6307,'th','&#3585;&#3634;&#3619;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(227043,6307,'hi','à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£',0),(227044,6307,'ms','Pengesahan',0),(227045,6307,'ar','Ø§Ù„ØªØ£ÙƒÙŠØ¯',0),(227046,6307,'fr','Confirmation',0),(227047,6307,'jp','ç¢ºèª?',0),(227048,6307,'pt','ConfirmaÃ§Ã£o',0),(227049,6307,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(227050,6307,'es','ConfirmaciÃ³n',0),(227051,6307,'de','BestÃ¤tigung',0),(227052,6307,'en','Confirmation',0),(227053,6308,'is','',0),(227054,6308,'dr','ØªØ§ÙŠÙŠØ¯ Ø§ÙŠÙ…ÙŠÙ„',0),(227055,6308,'pr','ØªØ§ÙŠÙŠØ¯ Ø§ÙŠÙ…ÙŠÙ„',0),(227056,6308,'tr','Onay e-postasÄ±',0),(227057,6308,'pl','Email z potwierdzeniem',0),(227058,6308,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð·Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(227059,6308,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚',0),(227060,6308,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(227061,6308,'vi','Email xÃ¡c nháº­n',0),(227062,6308,'af','E-pos Bevestiging',0),(227063,6308,'ro','E-mail de confirmare',0),(227064,6308,'et','E-maili kinnitamine',0),(227065,6308,'si','Potrditev e-poÅ¡te',0),(227066,6308,'ba','Konfirmasi email',0),(227067,6308,'nl','E-mailbevestiging',0),(227068,6308,'fi','SÃ¤hkÃ¶postivahvistus',0),(227069,6308,'no','Bekreftelsen',0),(227070,6308,'da','E-mail-bekrÃ¦ftelse',0),(227071,6308,'ko','ì´ë©”ì¼ í™•ì¸',0),(227072,6308,'he','××™×ž×•×ª ×“×•×\"×œ',0),(227073,6308,'el','Email ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·Ï‚',0),(227074,6308,'zh','ç”µå­é‚®ä»¶ç¡®è®¤\r\n',0),(227075,6308,'sv','E-postbekrÃ¤ftelse',0),(227076,6308,'it','Email di conferma',0),(227077,6308,'tl','',0),(227078,6308,'th','&#3585;&#3634;&#3619;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(227079,6308,'hi','à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ à¤ˆà¤®à¥‡à¤²',0),(227080,6308,'ms','E-mel pengesahan',0),(227081,6308,'ar','ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(227082,6308,'fr','Email de Confirmation',0),(227083,6308,'jp','Eãƒ¡ãƒ¼ãƒ«ç¢ºèª?',0),(227084,6308,'pt','ConfirmaÃ§Ã£o de e-mail',0),(227085,6308,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Email',0),(227086,6308,'es','Email ConfirmaciÃ³n',0),(227087,6308,'de','E-Mail-BestÃ¤tigung',0),(227088,6308,'en','Email Confirmation',0),(227089,6309,'is','',0),(227090,6309,'dr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡   ØªØ§ÙŠÙŠØ¯  Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø§Ø³Øª',0),(227091,6309,'pr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡   ØªØ§ÙŠÙŠØ¯  Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø§Ø³Øª',0),(227092,6309,'tr','BaÄŸlÄ± olduÄŸu sipariÅŸ onayÄ±',0),(227093,6309,'pl','DoÅ‚Ä…czony jest potwierdzenie zamÃ³wienia',0),(227094,6309,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¾ Ðµ Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(227095,6309,'ur','Ø¢Ù¾ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ø³Û’ Ù…Ù†Ø³Ù„Ú© ÛÛ’',0),(227096,6309,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ Ñ˜Ðµ Ñ‚Ð²Ð¾Ñ˜Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(227097,6309,'vi','KÃ¨m Theo lÃ  BiÃªn Nháº­n ÄÆ¡n Äáº·t HÃ ng Cá»§a Báº¡n',0),(227098,6309,'af','Aangeheg is u Bestellingsbevestiging',0),(227099,6309,'ro','AtaÅŸat este confirmarea comenzii',0),(227100,6309,'et','Lisatud on teie tellimuse kinnitus',0),(227101,6309,'si','PriloÅ¾en je vaÅ¡e potrditve naroÄila',0),(227102,6309,'ba','Terlampir adalah konfirmasi pesanan Anda',0),(227103,6309,'nl','Bijgevoegd is de bevestiging van uw bestelling',0),(227104,6309,'fi','LiitteenÃ¤ on tilausvahvistus',0),(227105,6309,'no','Vedlagt er bestillingsbekreftelsen',0),(227106,6309,'da','VedhÃ¦ftet er din ordrebekrÃ¦ftelse',0),(227107,6309,'ko','ì£¼ë¬¸ í™•ì¸ì€ ì²¨ë¶€',0),(227108,6309,'he','×ž×¦×•×¨×¤×ª ××™×©×•×¨ ×”×”×–×ž× ×” ×©×œ×š',0),(227109,6309,'el','Î£Ï…Î½Î·Î¼Î¼Î­Î½Î¿ ÎµÎ¯Î½Î±Î¹ Î· ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏƒÎ±Ï‚',0),(227110,6309,'zh','éšä¿¡é™„ä¸Šæ‚¨çš„è®¢å•ç¡®è®¤\r\n',0),(227111,6309,'sv','Bifogat Ã¤r din orderbekrÃ¤ftelse',0),(227112,6309,'it','Ãˆ allegata la conferma d\'ordine',0),(227113,6309,'tl','',0),(227114,6309,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3649;&#3621;&#3657;&#3623;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3649;&#3609;&#3610;&#3649;&#3',0),(227115,6309,'hi','à¤¸à¤‚à¤²à¤—à¥à¤¨ à¤¹à¥ˆ à¤…à¤ªà¤¨à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿',0),(227116,6309,'ms','Berikut adalah pengesahan pesanan anda',0),(227117,6309,'ar','ÙŠØ¹Ù„Ù‚ Ù‡Ùˆ \"ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø·Ù„Ø¨\" Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(227118,6309,'fr','AttachÃ© est votre Confirmation de commande',0),(227119,6309,'jp','æ³¨æ–‡ç¢ºèª?ã‚’æ·»ä»˜ã?—ã?¾ã?—ã?Ÿ',0),(227120,6309,'pt','Em anexo Ã© a confirmaÃ§Ã£o',0),(227121,6309,'ru','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(227122,6309,'es','Anexado es su Pedido de ConfirmaciÃ³n',0),(227123,6309,'de','Angeschlossen ist die AuftragsbestÃ¤tigung',0),(227124,6309,'en','Attached is your Order Confirmation',0),(227125,6310,'is','',0),(227126,6310,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´  ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(227127,6310,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´  ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(227128,6310,'tr','GÃ¶rÃ¼nÃ¼mÃ¼nde sipariÅŸ onayÄ± iÃ§in tÄ±klayÄ±n',0),(227129,6310,'pl','Kliknij, aby widok potwierdzenia zamÃ³wienia',0),(227130,6310,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¸Ð·Ð³Ð»ÐµÐ´Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(227131,6310,'ur','Ù…Ù†Ø¸Ø± ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(227132,6310,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð· ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(227133,6310,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ xem XÃ¡c Nháº­n ÄÆ¡n Äáº·t hÃ ng',0),(227134,6310,'af','Kliek om te Bestelling Bevestiging te Besigtig',0),(227135,6310,'ro','Click pentru confirmarea de comanda Vezi',0),(227136,6310,'et','KlÃµpsake vaate Tellimuse kinnitus',0),(227137,6310,'si','Kliknite za potrditev naloga pogled',0),(227138,6310,'ba','Klik untuk lihat konfirmasi Order',0),(227139,6310,'nl','Klik om de bevestiging van de bestelling van de weergave',0),(227140,6310,'fi','Valitse NÃ¤ytÃ¤ vahvistus',0),(227141,6310,'no','Klikk for Ã¥ se ordrebekreftelsen',0),(227142,6310,'da','Klik for at se ordrebekrÃ¦ftelse',0),(227143,6310,'ko','ë³´ê¸° ì£¼ë¬¸ í™•ì¸ì„ í´ë¦­ í•©ë‹ˆë‹¤',0),(227144,6310,'he','×œ×—×¥ ×¢×œ ×”×¦×’ ××™×©×•×¨ ×”×–×ž× ×”',0),(227145,6310,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(227146,6310,'zh','ç‚¹å‡»æŸ¥çœ‹è®¢å•ç¡®è®¤\r\n',0),(227147,6310,'sv','Klicka fÃ¶r att Visa orderbekrÃ¤ftelse',0),(227148,6310,'it','Clicca per vedere conferma ordine',0),(227149,6310,'tl','',0),(227150,6310,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3651;&#3610;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(227151,6310,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(227152,6310,'ms','Klik untuk lihat perintah pengesahan',0),(227153,6310,'ar','Ø£Ù†Ù‚Ø± Ù„Ø¹Ø±Ø¶ ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(227154,6310,'fr','Cliquez pour afficher la Confirmation de commande',0),(227155,6310,'jp','æ³¨æ–‡ç¢ºèª?ã‚’è¦‹ã‚‹',0),(227156,6310,'pt','Clique para confirmaÃ§Ã£o de pedido de vista',0),(227157,6310,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð´Ð»Ñ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ Ð—Ð°ÐºÐ°Ð·Ð°',0),(227158,6310,'es','Click para Ver la ConfirmaciÃ³n de Pedido',0),(227159,6310,'de','Klicken Sie auf Ansicht-AuftragsbestÃ¤tigung',0),(227160,6310,'en','Click to View Order Confirmation',0),(227161,6311,'is','',0),(227162,6311,'dr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´',0),(227163,6311,'pr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´',0),(227164,6311,'tr','SipariÅŸ teyidi',0),(227165,6311,'pl','Potwierdzenie zamÃ³wienia',0),(227166,6311,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(227167,6311,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚',0),(227168,6311,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(227169,6311,'vi','XÃ¡c nháº­n Ä‘Æ¡n hÃ ng',0),(227170,6311,'af','Bestellig Bevestiging',0),(227171,6311,'ro','Confirmarea comenzii',0),(227172,6311,'et','Tellimuse kinnitus',0),(227173,6311,'si','Potrditev naloga',0),(227174,6311,'ba','Konfirmasi order',0),(227175,6311,'nl','Bevestiging van de bestelling',0),(227176,6311,'fi','Tilauksen vahvistus',0),(227177,6311,'no','Ordrebekreftelsen',0),(227178,6311,'da','OrdrebekrÃ¦ftelse',0),(227179,6311,'ko','ì£¼ë¬¸ í™•ì¸',0),(227180,6311,'he','××™×©×•×¨ ×”×–×ž× ×”',0),(227181,6311,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(227182,6311,'zh','è®¢å•ç¡®è®¤\r\n',0),(227183,6311,'sv','OrderbekrÃ¤ftelse',0),(227184,6311,'it','Conferma d\'ordine',0),(227185,6311,'tl','',0),(227186,6311,'th','&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(227187,6311,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿',0),(227188,6311,'ms','Perintah pengesahan',0),(227189,6311,'ar','ØªØ§ÙƒÙŠØ¯ Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(227190,6311,'fr','Confirmation de commande',0),(227191,6311,'jp','æ³¨æ–‡ç¢ºèª?',0),(227192,6311,'pt','ConfirmaÃ§Ã£o da ordem',0),(227193,6311,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ð°',0),(227194,6311,'es','ConfirmaciÃ³n del Orden',0),(227195,6311,'de','AuftragsbestÃ¤tigung',0),(227196,6311,'en','Order Confirmation',0),(227197,6312,'is','',0),(227198,6312,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙˆØ§Ø­Ø¯ Ø³ÙØ§Ø±Ø´',0),(227199,6312,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙˆØ§Ø­Ø¯ Ø³ÙØ§Ø±Ø´',0),(227200,6312,'tr','SipariÅŸ birimi boyutu',0),(227201,6312,'pl','Rozmiar jednostki ZamÃ³wienie',0),(227202,6312,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(227203,6312,'ur','ØªØ±ØªÛŒØ¨ ÛŒÙˆÙ†Ù¹ Ø³Ø§Ø¦Ø²',0),(227204,6312,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(227205,6312,'vi','KÃ­ch cá»¡ ÄÆ¡n vá»‹ Ä‘áº·t hÃ ng',0),(227206,6312,'af','Bestellings Eenheidgrootte',0),(227207,6312,'ro','Dimensiunea unitÄƒÈ›ii de comandÄƒ',0),(227208,6312,'et','Tellimuse Ã¼hiku suuruse',0),(227209,6312,'si','Red velikost enote',0),(227210,6312,'ba','Ukuran Unit pesanan',0),(227211,6312,'nl','Eenheid ordergrootte',0),(227212,6312,'fi','Tilauksen koon',0),(227213,6312,'no','Bestill stÃ¸rrelse',0),(227214,6312,'da','Bestil enhed stÃ¸rrelse',0),(227215,6312,'ko','ì£¼ë¬¸ ë‹¨ìœ„ í¬ê¸°',0),(227216,6312,'he','×¡×“×¨ ×’×•×“×œ ×™×—×™×“×ª',0),(227217,6312,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Î¼Î¿Î½Î¬Î´Î±Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(227218,6312,'zh','è®¢è´­å•ä½å¤§å°\r\n',0),(227219,6312,'sv','BestÃ¤ll storlek',0),(227220,6312,'it','Dimensioni unitÃ  di ordine',0),(227221,6312,'tl','',0),(227222,6312,'th','&#3586;&#3609;&#3634;&#3604;&#3627;&#3609;&#3656;&#3623;&#3618;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(227223,6312,'hi','à¤•à¥à¤°à¤® à¤‡à¤•à¤¾à¤ˆ à¤†à¤•à¤¾à¤°',0),(227224,6312,'ms','Saiz Unit perintah',0),(227225,6312,'ar','Ø­Ø¬Ù… ÙˆØ­Ø¯Ø© Ø§Ù„Ù†Ø¸Ø§Ù…',0),(227226,6312,'fr','Taille d\'unitÃ© de commande',0),(227227,6312,'jp','æ³¨æ–‡å?˜ä¾¡ã‚µã‚¤ã‚º',0),(227228,6312,'pt','Tamanho da unidade de ordem',0),(227229,6312,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(227230,6312,'es','TamaÃ±o de Unidad de Orden',0),(227231,6312,'de','Bestellung-EinheitsgrÃ¶ÃŸe',0),(227232,6312,'en','Order Unit Size',0),(227233,6313,'is','',0),(227234,6313,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(227235,6313,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(227236,6313,'tr','Fiyat birimi boyutu',0),(227237,6313,'pl','Cena jednostki wielkoÅ›ci',0),(227238,6313,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð½Ð° Ñ†ÐµÐ½Ð°',0),(227239,6313,'ur','Ù‚ÛŒÙ…Øª ÛŒÙˆÙ†Ù¹ Ø³Ø§Ø¦Ø²',0),(227240,6313,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ñ†ÐµÐ½Ðµ',0),(227241,6313,'vi','Cá»¡ ÄÆ¡n vá»‹ giÃ¡',0),(227242,6313,'af','Pryseenheidsgrootte',0),(227243,6313,'ro','Dimensiunea unitÄƒÈ›ii de pret',0),(227244,6313,'et','Hind Ã¼hiku suuruse',0),(227245,6313,'si','Cena enote velikosti',0),(227246,6313,'ba','Ukuran Unit harga',0),(227247,6313,'nl','Prijs eenheid grootte',0),(227248,6313,'fi','Hinta koon',0),(227249,6313,'no','StÃ¸rrelsen pÃ¥ Price',0),(227250,6313,'da','Pris enhed stÃ¸rrelse',0),(227251,6313,'ko','ê°€ê²© ë‹¨ìœ„ í¬ê¸°',0),(227252,6313,'he','×’×•×“×œ ×™×—×™×“×ª ×ž×—×™×¨',0),(227253,6313,'el','Î¤Î¹Î¼Î® Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(227254,6313,'zh','ä»·æ ¼å•ä½å°ºå¯¸\r\n',0),(227255,6313,'sv','Pris storlek',0),(227256,6313,'it','Dimensioni unitÃ  di prezzo',0),(227257,6313,'tl','',0),(227258,6313,'th','&#3586;&#3609;&#3634;&#3604;&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(227259,6313,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤•à¤¾à¤ˆ à¤†à¤•à¤¾à¤°',0),(227260,6313,'ms','Saiz Unit harga',0),(227261,6313,'ar','Ø­Ø¬Ù… ÙˆØ­Ø¯Ø© Ø§Ù„Ø³Ø¹Ø±',0),(227262,6313,'fr','Prix unitÃ© taille',0),(227263,6313,'jp','ä¾¡æ ¼å?˜ä¾¡ã‚µã‚¤ã‚º',0),(227264,6313,'pt','Tamanho da unidade de preÃ§o',0),(227265,6313,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¦ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(227266,6313,'es','TamaÃ±o de la Unidad de Precio ',0),(227267,6313,'de','Preis-EinheitsgrÃ¶ÃŸe',0),(227268,6313,'en','Price Unit Size',0),(227269,6314,'is','',0),(227270,6314,'dr','Ù…ÙˆØ¬ÙˆØ¯',0),(227271,6314,'pr','Ù…ÙˆØ¬ÙˆØ¯',0),(227272,6314,'tr','KullanÄ±labilir',0),(227273,6314,'pl','DostÄ™pne',0),(227274,6314,'bg','Ð Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(227275,6314,'ur','Ø¯Ø³ØªÛŒØ§Ø¨',0),(227276,6314,'sr','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸',0),(227277,6314,'vi','CÃ³ Sáºµn',0),(227278,6314,'af','Beskikbaar',0),(227279,6314,'ro','Disponibil',0),(227280,6314,'et','Saadaval',0),(227281,6314,'si','Na voljo',0),(227282,6314,'ba','Tersedia',0),(227283,6314,'nl','Beschikbaar',0),(227284,6314,'fi','Saatavilla',0),(227285,6314,'no','Tilgjengelig',0),(227286,6314,'da','RÃ¥dighed',0),(227287,6314,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ”',0),(227288,6314,'he','×–×ž×™× ×™×',0),(227289,6314,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î±',0),(227290,6314,'zh','å¯ç”¨\r\n',0),(227291,6314,'sv','TillgÃ¤ngliga',0),(227292,6314,'it','Disponibile',0),(227293,6314,'tl','',0),(227294,6314,'th','&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;',0),(227295,6314,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(227296,6314,'ms','Disediakan',0),(227297,6314,'ar','Ù…ØªØ§Ø­',0),(227298,6314,'fr','Disponible',0),(227299,6314,'jp','å…¥æ‰‹å?¯èƒ½',0),(227300,6314,'pt','DisponÃ­vel',0),(227301,6314,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾',0),(227302,6314,'es','Disponible',0),(227303,6314,'de','VerfÃ¼gbar',0),(227304,6314,'en','Available',0),(227305,6315,'is','',0),(227306,6315,'dr','(Ù…ÙØ§Ø¯) Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(227307,6315,'pr','Ø¨Ù‡Ø±Ù‡ (Ø³ÙˆØ¯) Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(227308,6315,'tr','Ä°lgi nedeniyle',0),(227309,6315,'pl','NaleÅ¼ne odsetki',0),(227310,6315,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð¼Ð° Ð»Ð¸Ñ…Ð²Ð°',0),(227311,6315,'ur','Ø³ÙˆØ¯ Ú©ÛŒ ÙˆØ¬Û Ø³Û’',0),(227312,6315,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ð° Ñ‚ÐµÑ€Ð¼Ð¸Ð½',0),(227313,6315,'vi','LÃ£i suáº¥t Ä‘áº¿n háº¡n',0),(227314,6315,'af','Rente Verskuldig',0),(227315,6315,'ro','Dobanda spre plata',0),(227316,6315,'et','Viivise tÃ¤htaeg',0),(227317,6315,'si','Zapadle obresti',0),(227318,6315,'ba','Bunga karena',0),(227319,6315,'nl','Verschuldigde rente',0),(227320,6315,'fi','ErÃ¤Ã¤ntyneet korot',0),(227321,6315,'no','Renter',0),(227322,6315,'da','Forfaldne renter',0),(227323,6315,'ko','ì¸í•´ ê´€ì‹¬',0),(227324,6315,'he','×¨×™×‘×™×ª ×‘×©×œ',0),(227325,6315,'el','Î¤ÏŒÎºÎ¿Ï…Ï‚',0),(227326,6315,'zh','åˆ°æœŸåˆ©æ¯\r\n',0),(227327,6315,'sv','RÃ¤nta',0),(227328,6315,'it','Interessi dovuti',0),(227329,6315,'tl','',0),(227330,6315,'th','&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3607;&#3637;&#3656;&#3588;&#3623;&#3619;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(227331,6315,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¬à¥à¤¯à¤¾à¤œ',0),(227332,6315,'ms','Faedah yang dikenakan',0),(227333,6315,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(227334,6315,'fr','IntÃ©rÃªts dus',0),(227335,6315,'jp','æ”¯æ‰•åˆ©æ?¯',0),(227336,6315,'pt','Juros devidos',0),(227337,6315,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ñ‚Ð°ÑŽÑ‰Ð¸ÐµÑÑ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(227338,6315,'es','InterÃ©ses Vencidos',0),(227339,6315,'de','FÃ¤llige Zinsen',0),(227340,6315,'en','Interest Due',0),(227341,6316,'is','',0),(227342,6316,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ù…Ø§Ù†Ø¯Ù‡ Ø­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(227343,6316,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ù…Ø§Ù†Ø¯Ù‡ Ø­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(227344,6316,'tr','MÃ¼ÅŸteri Bakiye geÃ§miÅŸi',0),(227345,6316,'pl','Historia saldo nabywcy',0),(227346,6316,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° ÑÐ°Ð»Ð´Ð¾ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(227347,6316,'ur','Ú©Ø³Ù¹Ù…Ø± ØªÙˆØ§Ø²Ù† Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(227348,6316,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° ÑÐ°Ð»Ð´Ð¾ ÐºÑƒÐ¿Ñ†Ð°',0),(227349,6316,'vi','Lá»‹ch sá»­ sá»‘ dÆ° KhÃ¡ch hÃ ng',0),(227350,6316,'af','Klant / KliÃ«nt Balans Geskiedenis',0),(227351,6316,'ro','Istoric balanta client',0),(227352,6316,'et','Kliendi saldo ajalugu',0),(227353,6316,'si','Zgodovina saldo kupca',0),(227354,6316,'ba','Sejarah saldo pelanggan',0),(227355,6316,'nl','Evenwicht klantgeschiedenis',0),(227356,6316,'fi','Asiakkaan saldo historia',0),(227357,6316,'no','Balanse kundehistorikk',0),(227358,6316,'da','Kunde Balance historie',0),(227359,6316,'ko','ê³ ê° ê· í˜• ì—­ì‚¬',0),(227360,6316,'he','×”×¡×˜×•×¨×™×™×ª ×ž××–×Ÿ ×œ×§×•×—',0),(227361,6316,'el','Î ÎµÎ»Î¬Ï„Î· Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(227362,6316,'zh','å®¢æˆ·ä½™é¢åŽ†å²\r\n',0),(227363,6316,'sv','Balans kundhistorik',0),(227364,6316,'it','Storia di equilibrio di cliente',0),(227365,6316,'tl','',0),(227366,6316,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(227367,6316,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(227368,6316,'ms','Baca baki sejarah',0),(227369,6316,'ar','Ø­Ø±ÙƒØ© Ø±ØµÙŠØ¯ Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(227370,6316,'fr','Historique du solde client',0),(227371,6316,'jp','é¡§å®¢ãƒ?ãƒ©ãƒ³ã‚¹å±¥æ­´',0),(227372,6316,'pt','HistÃ³rico de saldo de cliente',0),(227373,6316,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð‘Ð°Ð»Ð°Ð½ÑÐ° ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(227374,6316,'es','Cliente Historia de Balance',0),(227375,6316,'de','Balance Kundenhistorie',0),(227376,6316,'en','Customer Balance History',0),(227377,6317,'is','',0),(227378,6317,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ¹Ø§Ù„ÙŠØª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(227379,6317,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ¹Ø§Ù„ÙŠØª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(227380,6317,'tr','MÃ¼ÅŸteri aktivite geÃ§miÅŸ',0),(227381,6317,'pl','Historia dziaÅ‚alnoÅ›ci klienta',0),(227382,6317,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(227383,6317,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(227384,6317,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(227385,6317,'vi','Lá»‹ch sá»­ hoáº¡t Ä‘á»™ng cá»§a KhÃ¡ch hÃ ng',0),(227386,6317,'af','Klant/KliÃ«nt Aktiwiteitsgeskiedenis',0),(227387,6317,'ro','Istoric activitate client',0),(227388,6317,'et','Kliendi tegevuste ajalugu',0),(227389,6317,'si','Kupec marljivost zgodovina',0),(227390,6317,'ba','Pelanggan aktivitas sejarah',0),(227391,6317,'nl','Klant activiteitsgeschiedenis',0),(227392,6317,'fi','Asiakas aktiivisuus historia',0),(227393,6317,'no','Kunden aktivitetslogg',0),(227394,6317,'da','Kunde aktivitet historie',0),(227395,6317,'ko','ê³ ê° í™œë™ ì—­ì‚¬',0),(227396,6317,'he','×”×¡×˜×•×¨×™×™×ª ×¤×¢×™×œ×•×ª ×œ×§×•×—',0),(227397,6317,'el','Î™ÏƒÏ„Î¿ÏÎ¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(227398,6317,'zh','å®¢æˆ·æ´»åŠ¨åŽ†å²\r\n',0),(227399,6317,'sv','Kundens verksamhet historia',0),(227400,6317,'it','Cronologia attivitÃ  cliente',0),(227401,6317,'tl','',0),(227402,6317,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(227403,6317,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(227404,6317,'ms','Sejarah aktiviti pelanggan',0),(227405,6317,'ar','ØªØ§Ø±ÙŠØ® Ù†Ø´Ø§Ø· Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(227406,6317,'fr','Historique de l\'activitÃ© client',0),(227407,6317,'jp','é¡§å®¢æ´»å‹•å±¥æ­´',0),(227408,6317,'pt','HistÃ³rico de atividade do cliente',0),(227409,6317,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(227410,6317,'es','Historia de Actividad de Cliente',0),(227411,6317,'de','AktivitÃ¤t Kundenhistorie',0),(227412,6317,'en','Customer Activity History',0),(227413,6318,'is','',0),(227414,6318,'dr','(Ù‚Ø³Ø·',0),(227415,6318,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª (Ù‚Ø³Ø·',0),(227416,6318,'tr','Ã–deme',0),(227417,6318,'pl','PÅ‚atnoÅ›ci',0),(227418,6318,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ',0),(227419,6318,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(227420,6318,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ°',0),(227421,6318,'vi','Thanh ToÃ¡n',0),(227422,6318,'af','Betaling',0),(227423,6318,'ro','Plata',0),(227424,6318,'et','Makse',0),(227425,6318,'si','PlaÄilo',0),(227426,6318,'ba','Pembayaran',0),(227427,6318,'nl','Betaling',0),(227428,6318,'fi','Maksu',0),(227429,6318,'no','Betaling',0),(227430,6318,'da','Betaling',0),(227431,6318,'ko','ì§€ë¶ˆ',0),(227432,6318,'he','×ª×©×œ×•×',0),(227433,6318,'el','Î Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(227434,6318,'zh','ä»˜æ¬¾\r\n',0),(227435,6318,'sv','Betalning',0),(227436,6318,'it','Pagamento',0),(227437,6318,'tl','',0),(227438,6318,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(227439,6318,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(227440,6318,'ms','Pembayaran',0),(227441,6318,'ar','Ø§Ù„Ø¯ÙØ¹',0),(227442,6318,'fr','Paiement',0),(227443,6318,'jp','æ”¯æ‰•ã?„',0),(227444,6318,'pt','Pagamento',0),(227445,6318,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð°',0),(227446,6318,'es','Pago',0),(227447,6318,'de','Zahlung',0),(227448,6318,'en','Payment',0),(227449,6319,'is','',0),(227450,6319,'dr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ÙŠØ§ ÙØ§ÙƒØªÙˆØ±',0),(227451,6319,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ÙŠØ§ ÙØ§ÙƒØªÙˆØ±',0),(227452,6319,'tr','FiÅŸ ya da fatura',0),(227453,6319,'pl','Kupon lub faktury',0),(227454,6319,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¸Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(227455,6319,'ur','ÙˆØ§Ø¤Ú†Ø± ÛŒØ§ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(227456,6319,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¸Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(227457,6319,'vi','Phiáº¿u hay hÃ³a Ä‘Æ¡n',0),(227458,6319,'af','Bewysstuk of Faktuur',0),(227459,6319,'ro','Bon sau facturÄƒ',0),(227460,6319,'et','VautÅ¡eri vÃµi arve',0),(227461,6319,'si','Voucher ali raÄuna',0),(227462,6319,'ba','Voucher atau faktur',0),(227463,6319,'nl','Bon of factuur',0),(227464,6319,'fi','Kuitti tai lasku',0),(227465,6319,'no','Bilaget eller faktura',0),(227466,6319,'da','Voucher eller faktura',0),(227467,6319,'ko','ë°”ìš°ì²˜ ë˜ëŠ” ì†¡ìž¥',0),(227468,6319,'he','×”×©×•×‘×¨ ××• ×—×©×‘×•× ×™×ª',0),(227469,6319,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(227470,6319,'zh','å‡­å•æˆ–å‘ç¥¨\r\n',0),(227471,6319,'sv','Verifikationen eller faktura',0),(227472,6319,'it','Voucher o fattura',0),(227473,6319,'tl','',0),(227474,6319,'th','&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3627;&#3619;&#3639;&#3629;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(227475,6319,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¯à¤¾ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸',0),(227476,6319,'ms','Baucer atau invois',0),(227477,6319,'ar','Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø£Ùˆ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(227478,6319,'fr','Facture ou bon de',0),(227479,6319,'jp','ä¼?ç¥¨ã‚‚ã?—ã??ã?¯è«‹æ±‚æ›¸',0),(227480,6319,'pt','Comprovante ou nota fiscal',0),(227481,6319,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¸Ð»Ð¸ ÑÑ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(227482,6319,'es','Voucher o Factura',0),(227483,6319,'de','Gutschein oder Rechnung',0),(227484,6319,'en','Voucher or Invoice',0),(227485,6320,'is','',0),(227486,6320,'dr','Ø¬Ù…Ø¹ ÙØ§ÙƒØªÙˆØ±',0),(227487,6320,'pr','Ø¬Ù…Ø¹ ÙØ§ÙƒØªÙˆØ±',0),(227488,6320,'tr','Fatura<br>Toplam',0),(227489,6320,'pl','Faktury<br>OgÃ³Å‚em',0),(227490,6320,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°<br>ÐžÐ±Ñ‰Ð¾',0),(227491,6320,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³<br>Ú©Ù„ ØªØ¹Ø¯Ø§Ø¯',0),(227492,6320,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ<br>Ð£ÐºÑƒÐ¿Ð½Ð¾',0),(227493,6320,'vi','Tá»•ng cá»™nghÃ³a Ä‘Æ¡n ',0),(227494,6320,'af','Faktuur<br>Totaal',0),(227495,6320,'ro','FacturÄƒ<br>Total',0),(227496,6320,'et','Arve<br>Kokku',0),(227497,6320,'si','RaÄuna<br>Skupaj',0),(227498,6320,'ba','Faktur<br>Total',0),(227499,6320,'nl','Factuur<br>Totaal',0),(227500,6320,'fi','Laskun<br>YhteensÃ¤',0),(227501,6320,'no','Faktura<br>Totalt',0),(227502,6320,'da','Faktura<br>I alt',0),(227503,6320,'ko','ì†¡ìž¥<br>ì´',0),(227504,6320,'he','×—×©×‘×•× ×™×ª<br>×¡×”',0),(227505,6320,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿<br>Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬',0),(227506,6320,'zh','å‘ç¥¨æ±‡æ€»\r\n',0),(227507,6320,'sv','Faktura<br>Totalt',0),(227508,6320,'it','Fattura<br>Totale',0),(227509,6320,'tl','',0),(227510,6320,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(227511,6320,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸<br>à¤•à¥à¤²',0),(227512,6320,'ms','Invois<br>Jumlah keseluruhan',0),(227513,6320,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø©<br>Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹',0),(227514,6320,'fr','Facture<br>Total',0),(227515,6320,'jp','è«‹æ±‚æ›¸<br>ç·?é¡?',0),(227516,6320,'pt','Fatura<br>Total',0),(227517,6320,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°<br>Ð˜Ñ‚Ð¾Ð³Ð¾',0),(227518,6320,'es','Factura<br>Total',0),(227519,6320,'de','Rechnung<br>Gesamt',0),(227520,6320,'en','Invoice<br>Total',0),(227521,6321,'is','',0),(227522,6321,'dr','HDR',0),(227523,6321,'pr',' Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø¯Ù…Ø§ØªHDR\r\n',0),(227524,6321,'tr','Hizmet<br>Åžarj',0),(227525,6321,'pl','UsÅ‚ugi<br>BezpÅ‚atnie',0),(227526,6321,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð·<br>Ð¢Ð°ÐºÑÐ°',0),(227527,6321,'ur','Ø®Ø¯Ù…Øª<br>Ø§Ù„Ø²Ø§Ù…',0),(227528,6321,'sr','Ð¡ÐµÑ€Ð²Ð¸Ñ<br>ÐŸÑƒÑšÐµÑšÐµ',0),(227529,6321,'vi','Dá»‹ch vá»¥PhÃ­',0),(227530,6321,'af','Diens<br>Fooie',0),(227531,6321,'ro','Serviciu<br>Taxa',0),(227532,6321,'et','Teenus<br>Tasu',0),(227533,6321,'si','Storitev<br>BrezplaÄno',0),(227534,6321,'ba','Layanan<br>Biaya',0),(227535,6321,'nl','Service<br>Gratis',0),(227536,6321,'fi','Palvelu<br>Ilmaiseksi',0),(227537,6321,'no','Service<br>Gratis',0),(227538,6321,'da','Service<br>Afgift',0),(227539,6321,'ko','ì„œë¹„ìŠ¤<br>ì¶©ì „',0),(227540,6321,'he','×©×™×¨×•×ª<br>×ª×©×œ×•×',0),(227541,6321,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î±<br>Î§ÏÎ­Ï‰ÏƒÎ·',0),(227542,6321,'zh','æ”¶è´¹æœåŠ¡\r\n',0),(227543,6321,'sv','Service<br>Avgift',0),(227544,6321,'it','Servizio<br>Carica',0),(227545,6321,'tl','',0),(227546,6321,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(227547,6321,'hi','à¤¸à¥‡à¤µà¤¾<br>à¤ªà¥à¤°à¤­à¤¾à¤°à¥€',0),(227548,6321,'ms','Perkhidmatan<br>Caj',0),(227549,6321,'ar','Ø®Ø¯Ù…Ø©<br>Ø§Ù„ØªÙ‡Ù…Ø©',0),(227550,6321,'fr','Service<br>Frais',0),(227551,6321,'jp','ã‚µãƒ¼ãƒ“ã‚¹<br>æ–™é‡‘',0),(227552,6321,'pt','ServiÃ§o<br>Carga',0),(227553,6321,'ru','Ð£ÑÐ»ÑƒÐ³Ð¸<br>Ð—Ð°Ñ€ÑÐ´',0),(227554,6321,'es','Servicio<br>Cargo',0),(227555,6321,'de','Service<br>Kostenlos',0),(227556,6321,'en','Service<br>Charge',0),(227557,6322,'is','',0),(227558,6322,'dr','(Ø¨Ù‡Ø±Ù‡',0),(227559,6322,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙˆØ¯ (Ø¨Ù‡Ø±Ù‡',0),(227560,6322,'tr','Toplam<br>Faiz',0),(227561,6322,'pl','OgÃ³Å‚em<br>Zainteresowanie',0),(227562,6322,'bg','ÐžÐ±Ñ‰Ð¾<br>Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ',0),(227563,6322,'ur','Ú©Ù„ ØªØ¹Ø¯Ø§Ø¯<br>Ø³ÙˆØ¯',0),(227564,6322,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾<br>ÐšÐ°Ð¼Ð°Ñ‚Ð°',0),(227565,6322,'vi','Tá»•ng cá»™nglÃ£i xuáº¥t',0),(227566,6322,'af','Totale<br>Rente',0),(227567,6322,'ro','Total<br>Interes',0),(227568,6322,'et','Kokku<br>Huvi',0),(227569,6322,'si','Skupaj<br>Obresti',0),(227570,6322,'ba','Total<br>Bunga',0),(227571,6322,'nl','Totaal<br>Belang',0),(227572,6322,'fi','YhteensÃ¤<br>Korko',0),(227573,6322,'no','Totalt<br>Interesse',0),(227574,6322,'da','I alt<br>Interesse',0),(227575,6322,'ko','ì´<br>ê´€ì‹¬',0),(227576,6322,'he','×¡×”<br>×¨×™×‘×™×ª',0),(227577,6322,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬<br>Î•Î½Î´Î¹Î±Ï†Î­ÏÎ¿Î½',0),(227578,6322,'zh','æ€»è®¡åˆ©æ¯\r\n',0),(227579,6322,'sv','Totalt<br>Intresse',0),(227580,6322,'it','Totale<br>Interesse',0),(227581,6322,'tl','',0),(227582,6322,'th','&#3612;&#3621;&#3619;&#3623;&#3617;<br>&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;',0),(227583,6322,'hi','à¤•à¥à¤²<br>à¤¬à¥à¤¯à¤¾à¤œ',0),(227584,6322,'ms','Jumlah keseluruhan<br>Faedah',0),(227585,6322,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(227586,6322,'fr','Total<br>IntÃ©rÃªt',0),(227587,6322,'jp','ç·?é¡?<br>åˆ©å­?',0),(227588,6322,'pt','Total<br>Interesse',0),(227589,6322,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾<br>Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ',0),(227590,6322,'es','InterÃ©s<be>Total',0),(227591,6322,'de','Gesamt<br>Interesse',0),(227592,6322,'en','Total<br>Interest',0),(227593,6323,'is','',0),(227594,6323,'dr','Ø¨Ù‡Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(227595,6323,'pr','Ø¨Ù‡Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(227596,6323,'tr','Yeni<br>Faiz',0),(227597,6323,'pl','Nowy<br>Zainteresowanie',0),(227598,6323,'bg','ÐÐ¾Ð²<br>Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ',0),(227599,6323,'ur','Ù†ÛŒØ§<br>Ø³ÙˆØ¯',0),(227600,6323,'sr','ÐÐ¾Ð²Ð¸<br>ÐšÐ°Ð¼Ð°Ñ‚Ð°',0),(227601,6323,'vi','LÃ£i suáº¥tmá»›i',0),(227602,6323,'af','Nuwe<br>Rente',0),(227603,6323,'ro','Noi<br>Interes',0),(227604,6323,'et','Uus<br>viivis',0),(227605,6323,'si','Nove<br>Obresti',0),(227606,6323,'ba','Baru<br>Bunga',0),(227607,6323,'nl','Nieuw<br>Belang',0),(227608,6323,'fi','Uusi<br>Korko',0),(227609,6323,'no','Nye<br>Interesse',0),(227610,6323,'da','Nye<br>Interesse',0),(227611,6323,'ko','ìƒˆë¡œìš´ ë‚´ìš©<br>ê´€ì‹¬',0),(227612,6323,'he','×—×“×©<br>×¨×™×‘×™×ª',0),(227613,6323,'el','ÎÎ­Î±<br>Î•Î½Î´Î¹Î±Ï†Î­ÏÎ¿Î½',0),(227614,6323,'zh','æ–°çš„åˆ©æ¯\r\n',0),(227615,6323,'sv','Nya<br>Intresse',0),(227616,6323,'it','Nuovo<br>Interesse',0),(227617,6323,'tl','',0),(227618,6323,'th','&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618; <br> &#3651;&#3627;&#3617;&#3656;',0),(227619,6323,'hi','à¤¨à¤ˆ<br>à¤¬à¥à¤¯à¤¾à¤œ',0),(227620,6323,'ms','Baru<br>Faedah',0),(227621,6323,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(227622,6323,'fr','Nouveau<br>IntÃ©rÃªt',0),(227623,6323,'jp','æ–°è¦?<br>åˆ©å­?',0),(227624,6323,'pt','Novo<br>Interesse',0),(227625,6323,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸<br>Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ',0),(227626,6323,'es','Nuevo<br>InterÃ©s',0),(227627,6323,'de','Neu<br>Interesse',0),(227628,6323,'en','New<br>Interest',0),(227629,6324,'is','',0),(227630,6324,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(227631,6324,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(227632,6324,'tr','Yeni bir seÃ§enek ekleme',0),(227633,6324,'pl','Dodaj nowÄ… opcjÄ™',0),(227634,6324,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð²Ð° Ð¾Ð¿Ñ†Ð¸Ñ',0),(227635,6324,'ur','Ù†ÛŒØ§ Ø¢Ù¾Ø´Ù† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(227636,6324,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸Ñ… Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(227637,6324,'vi','ThÃªm Lá»±a Chá»n Má»›i',0),(227638,6324,'af','Nuwe Opsie Byvoeg',0),(227639,6324,'ro','Adauga optiune noua',0),(227640,6324,'et','Lisa uus valik',0),(227641,6324,'si','Dodajte novo moÅ¾nost',0),(227642,6324,'ba','Tambahkan opsi baru',0),(227643,6324,'nl','Voeg nieuwe optie',0),(227644,6324,'fi','LisÃ¤Ã¤ uusi vaihtoehto',0),(227645,6324,'no','Legg nye alternativet',0),(227646,6324,'da','TilfÃ¸je nye indstilling',0),(227647,6324,'ko','ìƒˆë¡œìš´ ì˜µì…˜ ì¶”ê°€',0),(227648,6324,'he','×”×•×¡×£ ××¤×©×¨×•×ª ×—×“×©×”',0),(227649,6324,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÎµÏ€Î¹Î»Î¿Î³Î®',0),(227650,6324,'zh','å¢žåŠ æ–°çš„é€‰é¡¹\r\n',0),(227651,6324,'sv','LÃ¤gg till nya alternativ',0),(227652,6324,'it','Aggiungi nuova opzione',0),(227653,6324,'tl','',0),(227654,6324,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(227655,6324,'hi','à¤¨à¤ à¤µà¤¿à¤•à¤²à¥à¤ª à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(227656,6324,'ms','Tambah pilihan baru',0),(227657,6324,'ar','Ø¥Ø¶Ø§ÙØ© Ø®ÙŠØ§Ø± Ø¬Ø¯ÙŠØ¯',0),(227658,6324,'fr','Ajouter Nouvelle Option',0),(227659,6324,'jp','æ–°è¦?ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?®è¿½åŠ ',0),(227660,6324,'pt','Adicionar nova opÃ§Ã£o',0),(227661,6324,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€',0),(227662,6324,'es','Agregar Nueva OpciÃ³n',0),(227663,6324,'de','FÃ¼gen Sie neue Option',0),(227664,6324,'en','Add New Option',0),(227665,6325,'is','',0),(227666,6325,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(227667,6325,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(227668,6325,'tr','Yeni seÃ§enek grubu ekleme',0),(227669,6325,'pl','Dodaj nowe grupy opcji',0),(227670,6325,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð¾Ñ‚ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(227671,6325,'ur','Ù†ÛŒØ§ Ø¢Ù¾Ø´Ù† Ú¯Ø±ÙˆÙ¾ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(227672,6325,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ Ð³Ñ€ÑƒÐ¿Ñƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(227673,6325,'vi','ThÃªm NhÃ³m Lá»±a Chá»n Má»›i',0),(227674,6325,'af','Nuwe Opsie Groepe Byvoeg',0),(227675,6325,'ro','Adauga nouÄƒ opÅ£iune grup',0),(227676,6325,'et','Lisa uus valikute grupp',0),(227677,6325,'si','Dodaj novo skupino moÅ¾nosti',0),(227678,6325,'ba','Tambahkan pilihan grup baru',0),(227679,6325,'nl','Nieuwe optie groep toevoegen',0),(227680,6325,'fi','LisÃ¤Ã¤ uusi vaihtoehto ryhmÃ¤',0),(227681,6325,'no','Legg til ny gruppe',0),(227682,6325,'da','TilfÃ¸je nye gruppeboks',0),(227683,6325,'ko','ìƒˆë¡œìš´ ì˜µì…˜ ê·¸ë£¹ì— ì¶”ê°€',0),(227684,6325,'he','×”×•×¡×£ ×§×‘×•×¦×ª ××¤×©×¨×•×™×•×ª ×—×“×©×”',0),(227685,6325,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î¿Î¼Î¬Î´Î± ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(227686,6325,'zh','å¢žåŠ æ–°çš„é€‰é¡¹ç»„\r\n',0),(227687,6325,'sv','LÃ¤gg till nya gruppruta',0),(227688,6325,'it','Aggiungi nuovo gruppo di opzioni',0),(227689,6325,'tl','',0),(227690,6325,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(227691,6325,'hi','à¤¨à¤ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(227692,6325,'ms','Tambah Kumpulan pilihan baru',0),(227693,6325,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø© Ø®ÙŠØ§Ø±Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(227694,6325,'fr','Ajouter le nouveau groupe d\'options',0),(227695,6325,'jp','æ–°è¦?ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚°ãƒ«ãƒ¼ãƒ—ã?®è¿½åŠ ',0),(227696,6325,'pt','Adicionar novo grupo de opÃ§Ã£o',0),(227697,6325,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð³Ñ€ÑƒÐ¿Ð¿Ñƒ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð²',0),(227698,6325,'es','Agregar Nueva OpciÃ³n de Grupo',0),(227699,6325,'de','Neue Option Gruppe hinzufÃ¼gen',0),(227700,6325,'en','Add New Option Group',0),(227701,6326,'is','',0),(227702,6326,'dr','Checkbox   Ú©Ø§Ø¯Ø± Ú†Ùƒ',0),(227703,6326,'pr','Checkbox   Ú©Ø§Ø¯Ø± Ú†Ùƒ',0),(227704,6326,'tr','Onay kutusu',0),(227705,6326,'pl','Pole wyboru',0),(227706,6326,'bg','ÐšÐ²Ð°Ð´Ñ€Ð°Ñ‚Ñ‡Ðµ Ð·Ð° Ð¾Ñ‚Ð¼ÐµÑ‚ÐºÐ°',0),(227707,6326,'ur','Ù¾Ú‘ØªØ§Ù„ Ø®Ø§Ù†Û',0),(227708,6326,'sr','ÐŸÐ¾Ñ™Ðµ Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(227709,6326,'vi','Há»™p Ä‘Ã¡nh dáº¥u',0),(227710,6326,'af','Merkblokkie',0),(227711,6326,'ro','CasetÄƒ de selectare',0),(227712,6326,'et','Ruut',0),(227713,6326,'si','ÄŒekovna knjiÅ¾ica',0),(227714,6326,'ba','Kotak centang',0),(227715,6326,'nl','Checkbox',0),(227716,6326,'fi','Valintaruutu',0),(227717,6326,'no','Avmerkingsboksen',0),(227718,6326,'da','Afkrydsningsfeltet',0),(227719,6326,'ko','í™•ì¸ëž€',0),(227720,6326,'he','×ª×™×‘×ª ×¡×™×ž×•×Ÿ',0),(227721,6326,'el','Î Î»Î±Î¯ÏƒÎ¹Î¿ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(227722,6326,'zh','å¤é€‰æ¡†\r\n',0),(227723,6326,'sv','Kryssrutan',0),(227724,6326,'it','Casella di controllo',0),(227725,6326,'tl','',0),(227726,6326,'th','Checkbox',0),(227727,6326,'hi','à¤šà¥‡à¤• à¤¬à¥‰à¤•à¥à¤¸',0),(227728,6326,'ms','Kotak semak',0),(227729,6326,'ar','Ø®Ø§Ù†Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(227730,6326,'fr','Case Ã  cocher',0),(227731,6326,'jp','ãƒ?ã‚§ãƒƒã‚¯ãƒœãƒƒã‚¯ã‚¹',0),(227732,6326,'pt','Caixa de seleÃ§Ã£o',0),(227733,6326,'ru','Ð¤Ð»Ð°Ð¶Ð¾Ðº',0),(227734,6326,'es','Casilla de SelecciÃ³n',0),(227735,6326,'de','CheckBox',0),(227736,6326,'en','Checkbox',0),(227737,6327,'is','',0),(227738,6327,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø± ÙˆØ§Ø­Ø¯  ÙØ±ÙˆØ´',0),(227739,6327,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø± ÙˆØ§Ø­Ø¯  ÙØ±ÙˆØ´',0),(227740,6327,'tr','SatÄ±ÅŸ birimi cinsinden maliyet',0),(227741,6327,'pl','Koszt na jednostkÄ™ sprzedaÅ¼y',0),(227742,6327,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(227743,6327,'ur','Ø³ÛŒÙ„Ø² ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(227744,6327,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(227745,6327,'vi','GiÃ¡ thÃ nh 1 Ä‘Æ¡n vá»‹ bÃ¡n',0),(227746,6327,'af','Koste Per eenheid van verkope',0),(227747,6327,'ro','Costul pe unitate de vÃ¢nzare',0),(227748,6327,'et','MÃ¼Ã¼giÃ¼ksuse-pealt',0),(227749,6327,'si','StroÅ¡ek na enoto prodaje',0),(227750,6327,'ba','Biaya Per Unit penjualan',0),(227751,6327,'nl','Kosten Per verkoop eenheid',0),(227752,6327,'fi','Hinta myyntiyksikkÃ¶Ã¤ kohden',0),(227753,6327,'no','Kostnad Per salgsenhet',0),(227754,6327,'da','Omkostning pr. salgsenhed',0),(227755,6327,'ko','íŒë§¤ ë‹¨ìœ„ ë‹¹ ë¹„ìš©',0),(227756,6327,'he','×¢×œ×•×ª ×œ×™×—×™×“×ª ×ž×›×™×¨×•×ª',0),(227757,6327,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(227758,6327,'zh','æ¯ä¸ªé”€å”®å•ä½æˆæœ¬\r\n',0),(227759,6327,'sv','Kostnad Per fÃ¶rsÃ¤ljningsenhet',0),(227760,6327,'it','Costo Per unitÃ  di vendita',0),(227761,6327,'tl','',0),(227762,6327,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3634;&#3618;',0),(227763,6327,'hi','à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤‡à¤•à¤¾à¤ˆ',0),(227764,6327,'ms','Kos seunit jualan',0),(227765,6327,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø© Ù…Ø¨ÙŠØ¹Ø§Øª',0),(227766,6327,'fr','CoÃ»t par unitÃ© de vente',0),(227767,6327,'jp','è²©å£²å?˜ä¾¡ã?”ã?¨ã?®',0),(227768,6327,'pt','Custo por unidade de vendas',0),(227769,6327,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(227770,6327,'es','Costo Por Unidad de Venta',0),(227771,6327,'de','Kosten pro Verkaufseinheit',0),(227772,6327,'en','Cost Per Sales Unit',0),(227773,6328,'is','',0),(227774,6328,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ ',0),(227775,6328,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ ',0),(227776,6328,'tr','GeÃ§erli seÃ§enekler',0),(227777,6328,'pl','BieÅ¼Ä…ce opcje',0),(227778,6328,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(227779,6328,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(227780,6328,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(227781,6328,'vi','Lá»±a chá»n hiá»‡n thá»i ',0),(227782,6328,'af','Huidige Opsies',0),(227783,6328,'ro','OpÅ£iunile de curent',0),(227784,6328,'et','Praegused Valikud',0),(227785,6328,'si','Trenutne moÅ¾nosti',0),(227786,6328,'ba','Arus pilihan',0),(227787,6328,'nl','Huidige opties',0),(227788,6328,'fi','Nykyisiin asetuksiin',0),(227789,6328,'no','Gjeldende alternativer',0),(227790,6328,'da','Aktuelle indstillinger',0),(227791,6328,'ko','í˜„ìž¬ ì˜µì…˜',0),(227792,6328,'he','××¤×©×¨×•×™×•×ª ×”× ×•×›×—×™',0),(227793,6328,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎµÏ‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(227794,6328,'zh','å½“å‰é€‰é¡¹\r\n',0),(227795,6328,'sv','Aktuella alternativ',0),(227796,6328,'it','Opzioni correnti',0),(227797,6328,'tl','',0),(227798,6328,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(227799,6328,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(227800,6328,'ms','Pilihan semasa',0),(227801,6328,'ar','Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(227802,6328,'fr','Options en cours',0),(227803,6328,'jp','ç?¾åœ¨ã?®ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(227804,6328,'pt','OpÃ§Ãµes atuais',0),(227805,6328,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹',0),(227806,6328,'es','Opciones Actuales',0),(227807,6328,'de','Aktuellen Optionen',0),(227808,6328,'en','Current Options',0),(227809,6329,'is','',0),(227810,6329,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø§ÙŠØ¯ Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡  Ø­Ø¯Ø§Ù‚Ù„ ØªØ§ Ø­Ø¯Ø§ÙƒØ«Ø±  Ø¨Ø§Ø´Ø¯ ',0),(227811,6329,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø§ÙŠØ¯ Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡  Ø­Ø¯Ø§Ù‚Ù„ ØªØ§ Ø­Ø¯Ø§ÙƒØ«Ø±  Ø¨Ø§Ø´Ø¯ ',0),(227812,6329,'tr','VarsayÄ±lan min max AralÄ±k iÃ§inde olmalÄ±dÄ±r.',0),(227813,6329,'pl','DomyÅ›lna musi byÄ‡ min do max zakres.',0),(227814,6329,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð² Ð¼Ð¸Ð½ ÐœÐ°ÐºÑ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½.',0),(227815,6329,'ur','Ø·Û’ Ø´Ø¯Û Ú©Ù… Ø§Ø² Ú©Ù… Ú©Û’ Ù„Ø¦Û’ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø­Ø¯ Ù…ÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ Û”',0),(227816,6329,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¼Ð¾Ñ€Ð° Ñƒ Ð¼Ð¸Ð½ Ð¼Ð°x Ð¾Ð¿ÑÐµÐ³.',0),(227817,6329,'vi','Máº·c Ä‘á»‹nh pháº£i trong pháº¡m vi tá»‘i thiá»ƒu & tá»‘i Ä‘a',0),(227818,6329,'af','Verstek moet word in die min om max-reeks.',0),(227819,6329,'ro','Implicit trebuie sÄƒ fie Ã®n min la max gamÄƒ.',0),(227820,6329,'et','Vaikimisi peab olema min max vahemikus.',0),(227821,6329,'si','Privzeto mora biti v min max obsegu.',0),(227822,6329,'ba','Standar harus di min untuk kisaran max.',0),(227823,6329,'nl','Standaard moet worden in de min naar max bereik.',0),(227824,6329,'fi','Oletusarvon on oltava min max ala.',0),(227825,6329,'no','Standard mÃ¥ vÃ¦re i min maks omrÃ¥det.',0),(227826,6329,'da','Standard skal vÃ¦re i min til max vifte.',0),(227827,6329,'ko','ê¸°ë³¸ ìµœì†Œ ìµœëŒ€ ë²”ìœ„ì— ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(227828,6329,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×—×™×™×‘×ª ×œ×”×™×•×ª ×‘×“×§×•×ª ×œ×˜×•×•×— ×ž×¨×‘×™.',0),(227829,6329,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¼Î·Î½ Ï„Î¿ Î· ÏƒÎµÎ¹ÏÎ¬ max.',0),(227830,6329,'zh','é»˜è®¤å€¼å¿…é¡»åœ¨æœ€å°åˆ°æœ€å¤§èŒƒå›´å†…',0),(227831,6329,'sv','Standard mÃ¥ste vara i min till max rÃ¤ckvidd.',0),(227832,6329,'it','Predefinita deve essere nel min a fondoscala.',0),(227833,6329,'tl','',0),(227834,6329,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3605;&#3657;&#3629;&#3591;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3588;&#3656;&#3634;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;-&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(227835,6329,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¥€à¤®à¤¾ à¤•à¥‹ à¤®à¤¿à¤¨ à¤®à¥‡à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(227836,6329,'ms','Lalai mestilah min ke max pelbagai.',0),(227837,6329,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ ÙÙŠ Ø¯Ù‚ÙŠÙ‚Ø© Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© ÙƒØ­Ø¯ Ø£Ù‚ØµÙ‰.',0),(227838,6329,'fr','Par dÃ©faut doit Ãªtre dans le min Ã  portÃ©e maximale.',0),(227839,6329,'jp','æ—¢å®šã?®æ•°å€¤ã?¯æœ€å°?ã?‹ã‚‰æœ€å¤§ã?®ç¯„å›²ã?®æ•°å€¤ã?§ã?ªã??ã?¦ã?¯ã?ªã‚Šã?¾ã?›ã‚“',0),(227840,6329,'pt','PadrÃ£o deve ser o min de intervalo mÃ¡ximo.',0),(227841,6329,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð¼Ð¸Ð½ ÐœÐ°ÐºÑ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½.',0),(227842,6329,'es','El Defecto debe ser in el rango entre min y max',0),(227843,6329,'de','Standard muss die min max an.',0),(227844,6329,'en','Default must be in the min to max range.',0),(227845,6330,'is','',0),(227846,6330,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ ',0),(227847,6330,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ ',0),(227848,6330,'tr','VarsayÄ±lan seÃ§enek grubu iÃ§in',0),(227849,6330,'pl','Opcja domyÅ›lna dla grupy',0),(227850,6330,'bg','ÐžÐ¿Ñ†Ð¸ÑÑ‚Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(227851,6330,'ur','Ú¯Ø±ÙˆÙ¾ Ú©Û’ Ø·Û’ Ø´Ø¯Û Ø§Ø®ØªÛŒØ§Ø±',0),(227852,6330,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ð³Ñ€ÑƒÐ¿Ñƒ',0),(227853,6330,'vi','Lá»±a chá»n Máº·c Ä‘á»‹nh cho nhÃ³m',0),(227854,6330,'af','Verstekte Opsie Vir Groep',0),(227855,6330,'ro','OpÅ£iunea implicitÄƒ pentru grup',0),(227856,6330,'et','Vaikimisi grupp',0),(227857,6330,'si','Privzeta moÅ¾nost za skupine',0),(227858,6330,'ba','Opsi default untuk kelompok',0),(227859,6330,'nl','Standaardoptie voor groep',0),(227860,6330,'fi','Oletusvaihtoehto ryhmÃ¤',0),(227861,6330,'no','Standardalternativet For gruppen',0),(227862,6330,'da','Standardindstillingen For gruppen',0),(227863,6330,'ko','ê·¸ë£¹ì— ëŒ€ í•œ ê¸°ë³¸ ì˜µì…˜',0),(227864,6330,'he','××¤×©×¨×•×ª ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×‘×•×¨ ×§×‘×•×¦×”',0),(227865,6330,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï„Î¹Î¼Î® Î³Î¹Î± Ï„Î·Î½ Î¿Î¼Î¬Î´Î±',0),(227866,6330,'zh','é»˜è®¤é€‰é¡¹ç»„\r\n',0),(227867,6330,'sv','Standardalternativet fÃ¶r grupp',0),(227868,6330,'it','Opzione predefinita per gruppo',0),(227869,6330,'tl','',0),(227870,6330,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3586;&#3629;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(227871,6330,'hi','à¤¸à¤®à¥‚à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(227872,6330,'ms','Pilihan lalai untuk Kumpulan',0),(227873,6330,'ar','Ø§Ù„Ø®ÙŠØ§Ø± Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(227874,6330,'fr','Option par dÃ©faut pour le groupe',0),(227875,6330,'jp','ã‚°ãƒ«ãƒ¼ãƒ—ã?®æ—¢å®šã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(227876,6330,'pt','OpÃ§Ã£o padrÃ£o para o grupo',0),(227877,6330,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(227878,6330,'es','OpciÃ³n por Defecto para el Grupo',0),(227879,6330,'de','Standardoption fÃ¼r Gruppe',0),(227880,6330,'en','Default Option For Group',0),(227881,6331,'is','',0),(227882,6331,'dr','( Ø±Ø§ÙŠÚ¯Ø§Ù† ',0),(227883,6331,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ù…Ù‚Ø¯Ø§Ø± Ø§Ú¯Ø±  Ù…Ø³ØªÙ‚Ù„ ( Ø±Ø§ÙŠÚ¯Ø§Ù† ',0),(227884,6331,'tr','VarsayÄ±lan miktar ise baÄŸÄ±msÄ±z',0),(227885,6331,'pl','DomyÅ›lnie jeÅ›li iloÅ›Ä‡ niezaleÅ¼nych',0),(227886,6331,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð°ÐºÐ¾ Ð½ÐµÐ·Ð°Ð²Ð¸ÑÐ¸Ð¼Ð¸',0),(227887,6331,'ur','Ø·Û’ Ø´Ø¯Û Ù‚ÛŒ Ø§Ú¯Ø± Ø¢Ø²Ø§Ø¯',0),(227888,6331,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° ÐšÐ¾Ð» Ð°ÐºÐ¾ Ð½ÐµÐ·Ð°Ð²Ð¸ÑÐ½Ð¸',0),(227889,6331,'vi','Sá»‘ lÆ°á»£ng máº·c Ä‘á»‹nh náº¿u Äá»™c láº­p',0),(227890,6331,'af','Verstekte Hoev. Indien Onafahanklik',0),(227891,6331,'ro','Independent de cantit dacÄƒ implicit',0),(227892,6331,'et','Vaike kogus kui sÃµltumatu',0),(227893,6331,'si','Privzeta koliÄina Äe neodvisni',0),(227894,6331,'ba','Default jika Qty independen',0),(227895,6331,'nl','Standaard Qty als zelfstandige',0),(227896,6331,'fi','Oletus mÃ¤Ã¤rÃ¤ jos riippumaton',0),(227897,6331,'no','Standard antall hvis uavhengig',0),(227898,6331,'da','Standard Qty hvis uafhÃ¦ngige',0),(227899,6331,'ko','ê¸°ë³¸ ìˆ˜ëŸ‰ ê²½ìš° ë…ë¦½',0),(227900,6331,'he','×‘×¨×™×¨×ª ×ž×—×“×œ ×× ×›×ž×•×ª ×¢×¦×ž××™×ª',0),(227901,6331,'el','Î‘Î½ÎµÎ¾Î¬ÏÏ„Î·Ï„Î± Î±Î½ Qty Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î®',0),(227902,6331,'zh','å¦‚æžœç‹¬ç«‹é»˜è®¤æ•°é‡\r\n',0),(227903,6331,'sv','Standard Kvt om oberoende',0),(227904,6331,'it','Predefinito se Qty indipendente',0),(227905,6331,'tl','',0),(227906,6331,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3627;&#3634;&#3585;&#3652;&#3617;&#3656;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591;&#3585;&#3633;&#3609;',0),(227907,6331,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤…à¤—à¤° à¤¸à¥à¤µà¤¤à¤‚à¤¤à¥à¤°',0),(227908,6331,'ms','Bukan bebas jika Qty lalai',0),(227909,6331,'ar','Ø§Ù„ÙƒÙ…ÙŠÙ‘Ø© Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠØ© - Ø¥Ù† ÙƒØ§Ù†Øª Ù…Ø³ØªÙ‚Ù„Ù‘Ø©',0),(227910,6331,'fr','Par dÃ©faut If Qty indÃ©pendant',0),(227911,6331,'jp','ç‹¬ç«‹ã?®å ´å?ˆã?®æ—¢å®šæ•°é‡?',0),(227912,6331,'pt','Independente de se Qty do padrÃ£o',0),(227913,6331,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÐµÑÐ»Ð¸ ÐšÐ¾Ð»-Ð²Ð¾ Ð½ÐµÐ·Ð°Ð²Ð¸ÑÐ¸Ð¼Ñ‹Ñ…',0),(227914,6331,'es','Cantidad por Defecto si es Independiente',0),(227915,6331,'de','Standard Qty If unabhÃ¤ngig',0),(227916,6331,'en','Default Qty If Independent',0),(227917,6332,'is','',0),(227918,6332,'dr','( Ù…ØªØ¹Ù„Ù‚  ',0),(227919,6332,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø± ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ  Ø§Ú¯Ø±  Ù…Ø´Ù…ÙˆÙ„ ( Ù…ØªØ¹Ù„Ù‚  ',0),(227920,6332,'tr','Her ana madde varsa baÄŸÄ±mlÄ± varsayÄ±lan miktar',0),(227921,6332,'pl','DomyÅ›lna iloÅ›Ä‡ za gÅ‚Ã³wny element, jeÅ¼eli jest to zaleÅ¼ne od',0),(227922,6332,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ð³Ð»Ð°Ð²Ð½Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð°ÐºÐ¾ Ð·Ð°Ð²Ð¸ÑÐ¸Ð¼Ð¸',0),(227923,6332,'ur','Ø·Û’ Ø´Ø¯Û Ù‚ÛŒ Ø¨Ù†ÛŒØ§Ø¯ÛŒ Ø´Û’ ØªÙˆ Ù…Ø­ØªØ§Ø¬ ÙÛŒ',0),(227924,6332,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° ÐšÐ¾Ð» Ð¿Ð¾ Ð³Ð»Ð°Ð²Ð½Ð¾Ð¼ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ñƒ Ð°ÐºÐ¾ Ð·Ð°Ð²Ð¸ÑÐ½Ðµ',0),(227925,6332,'vi','Sá»‘ lÆ°á»£ng máº·c Ä‘á»‹nh má»—i máº·t hÃ ng chÃ­nh náº¿u phá»¥ láº­p',0),(227926,6332,'af','Verstekte Hoev Per Hoof Item indien Onafhanklik',0),(227927,6332,'ro','Implicit cantitate Per articol principal dacÄƒ dependente',0),(227928,6332,'et','Vaike kogus peamine kauba kui Ã¼lalpeetava kohta',0),(227929,6332,'si','Privzeta koliÄina na glavni element, Äe je odvisna',0),(227930,6332,'ba','Default Qty Per Item utama jika tergantung',0),(227931,6332,'nl','Standaard aantal Per belangrijkste Item als afhankelijke',0),(227932,6332,'fi','Oletus mÃ¤Ã¤rÃ¤ Per pÃ¤Ã¤asia jos riippuvainen',0),(227933,6332,'no','Standard antall Per viktigste element hvis avhengige',0),(227934,6332,'da','Standard Qty Per hovedemnet hvis afhÃ¦ngige',0),(227935,6332,'ko','ì˜ì¡´ í•˜ëŠ” ê²½ìš° ì£¼ìš” í•­ëª© ë‹¹ ê¸°ë³¸ ìˆ˜ëŸ‰',0),(227936,6332,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×›×ž×•×ª ×œ×›×œ ×¤×¨×™×˜ ×”×¨××©×™ ×× ×ª×œ×•×™×™×',0),(227937,6332,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Î½Î¬ ÎºÏÏÎ¹Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÎ¬Î½ ÎµÎ¾Î±ÏÏ„ÏŽÎ½Ï„Î±Î¹ Î±Ï€ÏŒ',0),(227938,6332,'zh','å¦‚æžœä¾èµ–é»˜è®¤æ¯ä¸»è¥é¡¹ç›®çš„æ•°é‡\r\n',0),(227939,6332,'sv','Standard antal Per huvudfrÃ¥ga om beroende',0),(227940,6332,'it','Qty predefinito per ogni elemento principale se dipendente',0),(227941,6332,'tl','',0),(227942,6332,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3605;&#3656;&#3629;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3621;&#3633;&#3585; &#3626;&#3640;&#3604;&#3649;&#3621;&#3657;&#',0),(227943,6332,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤®à¥à¤–à¥à¤¯ à¤†à¤‡à¤Ÿà¤® à¤…à¤—à¤° à¤†à¤¶à¥à¤°à¤¿à¤¤',0),(227944,6332,'ms','Qty lalai satu perkara yang utama jika bergantung',0),(227945,6332,'ar','Ø§Ù„ÙƒÙ…ÙŠÙ‘Ø© Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠØ© Ù„ÙƒÙ„ ØµÙ†Ù Ø±Ø¦ÙŠØ³ÙŠ',0),(227946,6332,'fr','QtÃ© par dÃ©faut par principale article si dÃ©pendants',0),(227947,6332,'jp','å¾“å±žã?®å ´å?ˆã?®ä¸»è¦?å“?ç›®ã?”ã?¨ã?®æ—¢å®šæ•°é‡?',0),(227948,6332,'pt','Qtde de padrÃ£o por Item principal se dependente',0),(227949,6332,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð² Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð•ÑÐ»Ð¸ Ð·Ð°Ð²Ð¸ÑÐ¸Ð¼Ñ‹Ðµ',0),(227950,6332,'es','Cantidad por Defecto por Item Principal si es Dependente',0),(227951,6332,'de','Standard-Menge pro Hauptsache wenn abhÃ¤ngige',0),(227952,6332,'en','Default Qty Per Main Item If Dependent',0),(227953,6333,'is','',0),(227954,6333,'dr','ÙˆØ§Ø¨Ø³ØªÙ‡ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø± ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(227955,6333,'pr','ÙˆØ§Ø¨Ø³ØªÙ‡ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø± ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(227956,6333,'tr','BaÄŸÄ±mlÄ± ana madde miktarÄ± iÃ§in',0),(227957,6333,'pl','W zaleÅ¼noÅ›ci od iloÅ›Ä‡ gÅ‚Ã³wny element',0),(227958,6333,'bg','Ð—Ð°Ð²Ð¸ÑÐ¸ Ð¾Ñ‚ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ð³Ð»Ð°Ð²Ð½Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(227959,6333,'ur','Ø§ØµÙ„ Ø´Û’ Ù‚ÛŒ Ù¾Ø± Ø§Ù†Ø­ØµØ§Ø±',0),(227960,6333,'sr','Ð—Ð°Ð²Ð¸ÑÐ½Ðµ Ð½Ð° Ð³Ð»Ð°Ð²Ð½Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ ÐšÐ¾Ð».',0),(227961,6333,'vi','Phá»¥ thuá»™c vÃ o sá»‘ lÆ°á»£ng hÃ ng chÃ­nh',0),(227962,6333,'af','Afhanklike op Hoofitem Hoev',0),(227963,6333,'ro','Depinde de cantitate element principal',0),(227964,6333,'et','Peamine kauba kogus sÃµltub',0),(227965,6333,'si','Odvisna koliÄina glavni element',0),(227966,6333,'ba','Bergantung pada Item utama Qty',0),(227967,6333,'nl','Afhankelijk van aantal van de belangrijkste Item',0),(227968,6333,'fi','TÃ¤rkeimpÃ¤nÃ¤ mÃ¤Ã¤rÃ¤ riippuu',0),(227969,6333,'no','Avhengig av viktigste elementet Ant',0),(227970,6333,'da','AfhÃ¦ngig af hovedemnet Qty',0),(227971,6333,'ko','ì£¼ìš” í•­ëª© ìˆ˜ëŸ‰ì— ë”°ë¼ ë‹¤ë¦„',0),(227972,6333,'he','×ª×œ×•×™ ×¢×œ ×›×ž×•×ª ×”×¤×¨×™×˜ ×”×¢×™×§×¨×™',0),(227973,6333,'el','Î•Î¾Î±ÏÏ„ÏŽÎ¼ÎµÎ½Î¿ Î±Ï€ÏŒ Ï„Î¿ ÎºÏÏÎ¹Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Qty',0),(227974,6333,'zh','ä¾èµ–äºŽä¸»è¦é¡¹ç›®æ•°é‡\r\n',0),(227975,6333,'sv','Beroende pÃ¥ huvudpunkten Kvt',0),(227976,6333,'it','Dipendente dalla quantitÃ  dell\'oggetto principale',0),(227977,6333,'tl','',0),(227978,6333,'th','&#3586;&#3638;&#3657;&#3609;&#3629;&#3618;&#3641;&#3656;&#3585;&#3633;&#3610;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3621;&#3633;&#3585;',0),(227979,6333,'hi','à¤®à¥à¤–à¥à¤¯ à¤†à¤‡à¤Ÿà¤® à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¤° à¤¨à¤¿à¤°à¥à¤­à¤°',0),(227980,6333,'ms','Bergantung kepada Qty perkara utama',0),(227981,6333,'ar','ÙŠØ¹ØªÙ…Ø¯ Ø¹Ù„Ù‰ ÙƒÙ…Ù‘ÙŠØ© Ø§Ù„ØµÙ‘Ù†Ù Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ ØŸ',0),(227982,6333,'fr','DÃ©pend de la quantitÃ© principale',0),(227983,6333,'jp','ä¸»è¦?å“?ç›®æ•°é‡?æ¬¡ç¬¬',0),(227984,6333,'pt','Dependente do principal Item Qtd',0),(227985,6333,'ru','Ð’ Ð·Ð°Ð²Ð¸ÑÐ¸Ð¼Ð¾ÑÑ‚Ð¸ Ð¾Ñ‚ ÐšÐ¾Ð»-Ð²Ð¾ Ð¾ÑÐ½Ð¾Ð²Ð½Ñ‹Ñ… ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(227986,6333,'es','Dependiente de Cantidad de Item Principal',0),(227987,6333,'de','AbhÃ¤ngig von Hauptsache Qty',0),(227988,6333,'en','Dependent On Main Item Qty',0),(227989,6334,'is','',0),(227990,6334,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(227991,6334,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(227992,6334,'tr','DÃ¼zenleme seÃ§enekleri',0),(227993,6334,'pl','Edytuj opcje',0),(227994,6334,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ð¿Ñ†Ð¸Ð¸',0),(227995,6334,'ur','Ø§Ø®ØªÛŒØ§Ø±Ø§Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(227996,6334,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(227997,6334,'vi','Sá»­a Lá»±a Chá»n',0),(227998,6334,'af','Redigeer Opsies',0),(227999,6334,'ro','EditaÅ£i opÅ£iunile',0),(228000,6334,'et','Redigeeri vÃµimalusi',0),(228001,6334,'si','Uredi moÅ¾nosti',0),(228002,6334,'ba','Edit pilihan',0),(228003,6334,'nl','Opties voor het bewerken',0),(228004,6334,'fi','Muokkaa asetuksia',0),(228005,6334,'no','Redigere alternativer',0),(228006,6334,'da','Redigere indstillinger',0),(228007,6334,'ko','ì˜µì…˜ íŽ¸ì§‘',0),(228008,6334,'he','×¢×¨×•×š ××©×¨×•×™×•×ª',0),(228009,6334,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(228010,6334,'zh','ç¼–è¾‘é€‰é¡¹\r\n',0),(228011,6334,'sv','Redigera alternativ',0),(228012,6334,'it','Modificare le opzioni',0),(228013,6334,'tl','',0),(228014,6334,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(228015,6334,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(228016,6334,'ms','Opsyen Edit',0),(228017,6334,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª',0),(228018,6334,'fr','Modifier les Options',0),(228019,6334,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?®ç·¨é›†',0),(228020,6334,'pt','Editar opÃ§Ãµes',0),(228021,6334,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹',0),(228022,6334,'es','Editar Opciones',0),(228023,6334,'de','Optionen bearbeiten',0),(228024,6334,'en','Edit Options',0),(228025,6335,'is','',0),(228026,6335,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(228027,6335,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(228028,6335,'tr','SeÃ§enek grubunu DÃ¼zenle',0),(228029,6335,'pl','Grupa opcji Edytuj',0),(228030,6335,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€',0),(228031,6335,'ur','ØªØ¯ÙˆÛŒÙ† Ø§Ø®ØªÛŒØ§Ø± Ú¯Ø±ÙˆÙ¾',0),(228032,6335,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð³Ñ€ÑƒÐ¿Ñƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(228033,6335,'vi','Sá»­a NhÃ³m Lá»±a Chá»n',0),(228034,6335,'af','Redigeer Opsiegroepe',0),(228035,6335,'ro','Grupul de opÈ›iuni editare',0),(228036,6335,'et','Muuda suvandirÃ¼hma',0),(228037,6335,'si','Skupino moÅ¾nosti urejanje',0),(228038,6335,'ba','Edit pilihan grup',0),(228039,6335,'nl','Groep van de optie bewerken',0),(228040,6335,'fi','Muokkaa vaihtoehtoryhmÃ¤Ã¤n',0),(228041,6335,'no','Rediger gruppe',0),(228042,6335,'da','Rediger gruppeboks.',0),(228043,6335,'ko','íŽ¸ì§‘ ì˜µì…˜ ê·¸ë£¹',0),(228044,6335,'he','×§×‘×•×¦×ª ××¤×©×¨×•×™×•×ª ×¢×¨×™×›×”',0),(228045,6335,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¿Î¼Î¬Î´Î± ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(228046,6335,'zh','ç¼–è¾‘é€‰é¡¹ç»„\r\n',0),(228047,6335,'sv','Redigera alternativ grupp',0),(228048,6335,'it','Gruppo di opzioni di modifica',0),(228049,6335,'tl','',0),(228050,6335,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(228051,6335,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤®à¥‚à¤¹',0),(228052,6335,'ms','Kumpulan opsyen Edit',0),(228053,6335,'ar','ØªØ­Ø±ÙŠØ± Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª',0),(228054,6335,'fr','Modifier un groupe Option',0),(228055,6335,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚°ãƒ«ãƒ¼ãƒ—ã?®ç·¨é›†',0),(228056,6335,'pt','Grupo de opÃ§Ãµes de ediÃ§Ã£o',0),(228057,6335,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð¿ÐµÑ€ÐµÐºÐ»ÑŽÑ‡Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(228058,6335,'es','Editar Grupo de Opciones',0),(228059,6335,'de','Option Gruppe bearbeiten',0),(228060,6335,'en','Edit Option Group',0),(228061,6336,'is','',0),(228062,6336,'dr','Ù¾ÙŠØ¯Ø§ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§ ',0),(228063,6336,'pr','Ù¾ÙŠØ¯Ø§ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§ ',0),(228064,6336,'tr','Ã–ÄŸesini bulun',0),(228065,6336,'pl','ZnajdÅº element',0),(228066,6336,'bg','ÐÐ°Ð¼ÐµÑ€Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(228067,6336,'ur','Ø´Û’ ÚˆÚ¾ÙˆÙ†ÚˆÛŒÚº',0),(228068,6336,'sr','ÐŸÑ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(228069,6336,'vi','TÃ¬m HÃ ng',0),(228070,6336,'af','Vind Item',0),(228071,6336,'ro','GÄƒsi elementul',0),(228072,6336,'et','Leia toode',0),(228073,6336,'si','PoiÅ¡Äi artikel',0),(228074,6336,'ba','Menemukan Item',0),(228075,6336,'nl','Item zoeken',0),(228076,6336,'fi','Etsi kohde',0),(228077,6336,'no','Finn elementet',0),(228078,6336,'da','Find varen',0),(228079,6336,'ko','í•­ëª© ì°¾ê¸°',0),(228080,6336,'he','×œ×ž×¦×•× ×¤×¨×™×˜',0),(228081,6336,'el','Î’ÏÎµÎ¯Ï„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(228082,6336,'zh','æŸ¥æ‰¾é¡¹ç›®\r\n',0),(228083,6336,'sv','Hitta objekt',0),(228084,6336,'it','Trovare l\'elemento',0),(228085,6336,'tl','',0),(228086,6336,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(228087,6336,'hi','à¤†à¤‡à¤Ÿà¤® à¤¢à¥‚à¤à¤¢à¥‡à¤‚',0),(228088,6336,'ms','Mencari Item',0),(228089,6336,'ar','Ø¥ÙŠØ¬Ø§Ø¯ Ø§Ù„ØµÙ†Ù',0),(228090,6336,'fr','Trouver le point',0),(228091,6336,'jp','å“?ç›®ã?®æ¤œç´¢',0),(228092,6336,'pt','Encontrar o Item',0),(228093,6336,'ru','ÐÐ°Ð¹Ñ‚Ð¸ Ð¿ÑƒÐ½ÐºÑ‚',0),(228094,6336,'es','Buscar Item',0),(228095,6336,'de','Element gefunden',0),(228096,6336,'en','Find Item',0),(228097,6337,'is','',0),(228098,6337,'dr','Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(228099,6337,'pr','Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(228100,6337,'tr','Madde seÃ§enek grubu baÅŸarÄ±yla kaydedildi',0),(228101,6337,'pl','Element grupa opcji zapisane',0),(228102,6337,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ Ð³Ñ€ÑƒÐ¿Ð° Ð¾Ð¿Ñ†Ð¸Ð¸, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(228103,6337,'ur','Ø´Û’ Ø§Ø®ØªÛŒØ§Ø± Ú¯Ø±ÙˆÙ¾ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(228104,6337,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° ÑÑ‚Ð°Ð²ÐºÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(228105,6337,'vi','NhÃ³m hÃ ng sao lÆ°u thÃ nh cÃ´ng',0),(228106,6337,'af','Item Opsie Groep suksesvol Gestoor',0),(228107,6337,'ro','Grupul articol salvat cu succes',0),(228108,6337,'et','Salvestatud kirje suvandirÃ¼hma',0),(228109,6337,'si','Skupina artikla moÅ¾nosti uspeÅ¡no shranjen',0),(228110,6337,'ba','Item pilihan grup disimpan berhasil',0),(228111,6337,'nl','Object groepsvak succesvol opgeslagen',0),(228112,6337,'fi','Nimikkeen vaihtoehtoryhmÃ¤n tallennettu',0),(228113,6337,'no','Varegruppe alternativet lagret',0),(228114,6337,'da','Varegruppe indstilling gemt med succes',0),(228115,6337,'ko','í•­ëª© ì˜µì…˜ ê·¸ë£¹ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(228116,6337,'he','×§×‘×•×¦×ª ××¤×©×¨×•×™×•×ª ×¤×¨×™×˜ × ×©×ž×¨ ×‘×”×¦×œ×—×”',0),(228117,6337,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¼Î¹Î±Ï‚ Î¿Î¼Î¬Î´Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(228118,6337,'zh','é¡¹ç›®é€‰æ‹©é›†å›¢å·²æˆåŠŸä¿å­˜\r\n',0),(228119,6337,'sv','Alternativet artikelgrupp sparats',0),(228120,6337,'it','Gruppo di opzione elementi salvati con successo',0),(228121,6337,'tl','',0),(228122,6337,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3649;&#3621;&#3657;&#3623;',0),(228123,6337,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(228124,6337,'ms','Item opsyen Kumpulan berjaya disimpan',0),(228125,6337,'ar','Ø­ÙØ¸Øª Ù…Ø¬Ù…ÙˆØ¹Ø© Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(228126,6337,'fr','Groupe d\'options point enregistrÃ© avec succÃ¨s',0),(228127,6337,'jp','å“?ç›®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚°ãƒ«ãƒ¼ãƒ—ã?Œä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(228128,6337,'pt','Grupo de opÃ§Ã£o item salvo com sucesso',0),(228129,6337,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð² ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(228130,6337,'es','Grupo de Opciones de Item Guardados Exitosamente',0),(228131,6337,'de','Artikelgruppe Option erfolgreich gespeichert',0),(228132,6337,'en','Item Option Group Saved Successfully',0),(228133,6338,'is','',0),(228134,6338,'dr','Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(228135,6338,'pr','Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(228136,6338,'tr','Madde seÃ§eneÄŸini baÅŸarÄ±yla kaydedildi',0),(228137,6338,'pl','Element opcji zapisane',0),(228138,6338,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ð¿Ñ†Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(228139,6338,'ur','Ø´Û’ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø± Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(228140,6338,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½ \"ÐÑ€Ñ‚Ð¸ÐºÐ°Ð»\"',0),(228141,6338,'vi','HÃ ng sao lÆ°u thÃ nh cÃ´ng',0),(228142,6338,'af','Item Opsie suksesvol Gestoor',0),(228143,6338,'ro','OpÅ£iunea articol salvat cu succes',0),(228144,6338,'et','Kirje vÃµimalus edukalt salvestatud',0),(228145,6338,'si','MoÅ¾nost artikel uspeÅ¡no shranjen',0),(228146,6338,'ba','Pilihan item disimpan berhasil',0),(228147,6338,'nl','Item optie succesvol opgeslagen',0),(228148,6338,'fi','Nimike-vaihtoehto tallennus onnistui',0),(228149,6338,'no','Alternativ lagret',0),(228150,6338,'da','Vare indstilling gemt med succes',0),(228151,6338,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•­ëª© ì˜µì…˜',0),(228152,6338,'he','×”××¤×©×¨×•×ª ×¤×¨×™×˜ × ×©×ž×¨ ×‘×”×¦×œ×—×”',0),(228153,6338,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(228154,6338,'zh','é¡¹ç›®é€‰æ‹©ä¿å­˜æˆåŠŸ\r\n',0),(228155,6338,'sv','Objektet alternativ sparats',0),(228156,6338,'it','Opzione elemento salvato correttamente',0),(228157,6338,'tl','',0),(228158,6338,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3',0),(228159,6338,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¤²à¥à¤ª',0),(228160,6338,'ms','Pilihan item yang berjaya disimpan',0),(228161,6338,'ar','Ø­ÙØ¸ Ø®ÙŠØ§Ø± Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(228162,6338,'fr','Option point enregistrÃ©e avec succÃ¨s',0),(228163,6338,'jp','å“?ç›®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?Œä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(228164,6338,'pt','OpÃ§Ã£o de item com sucesso',0),(228165,6338,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(228166,6338,'es','OpciÃ³n de Item Guardado Exitosamente',0),(228167,6338,'de','Option \"Element\" erfolgreich gespeichert',0),(228168,6338,'en','Item Option Saved Successfully',0),(228169,6339,'is','',0),(228170,6339,'dr','Ø§Ù„Ø²Ø§Ù…ÙŠ ',0),(228171,6339,'pr','Ø§Ù„Ø²Ø§Ù…ÙŠ ',0),(228172,6339,'tr','Zorunlu',0),(228173,6339,'pl','ObowiÄ…zkowe',0),(228174,6339,'bg','Ð—Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸',0),(228175,6339,'ur','Ù„Ø§Ø²Ù…ÛŒ',0),(228176,6339,'sr','ÐžÐ±Ð°Ð²ÐµÐ·Ð½Ð°',0),(228177,6339,'vi','Báº¯t buá»™c',0),(228178,6339,'af','Verpligte',0),(228179,6339,'ro','Obligatorii',0),(228180,6339,'et','Kohustuslik',0),(228181,6339,'si','Obvezno',0),(228182,6339,'ba','Wajib',0),(228183,6339,'nl','Verplichte',0),(228184,6339,'fi','Pakollinen',0),(228185,6339,'no','Obligatorisk',0),(228186,6339,'da','Obligatorisk',0),(228187,6339,'ko','í•„ìˆ˜',0),(228188,6339,'he','×—×•×‘×”',0),(228189,6339,'el','Î¥Ï€Î¿Ï‡ÏÎµÏ‰Ï„Î¹ÎºÎ®',0),(228190,6339,'zh','å¼ºåˆ¶æ€§\r\n',0),(228191,6339,'sv','Obligatoriska',0),(228192,6339,'it','Obbligatorio',0),(228193,6339,'tl','',0),(228194,6339,'th','&#3612;&#3641;&#3657;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3617;&#3629;&#3610;&#3629;&#3635;&#3609;&#3634;&#3592;',0),(228195,6339,'hi','à¤…à¤¨à¤¿à¤µà¤¾à¤°à¥à¤¯',0),(228196,6339,'ms','Mandatori',0),(228197,6339,'ar','Ø¥Ù„Ø²Ø§Ù…ÙŠ',0),(228198,6339,'fr','Obligatoire',0),(228199,6339,'jp','å¿…é ˆ',0),(228200,6339,'pt','ObrigatÃ³rio',0),(228201,6339,'ru','ÐžÐ±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ',0),(228202,6339,'es','Obligatorio',0),(228203,6339,'de','Obligatorisch',0),(228204,6339,'en','Mandatory',0),(228205,6340,'is','',0),(228206,6340,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø¨Ø§ÙŠØ¯ Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ÙŠØ§ Ù…Ø³Ø§ÙˆÙŠ Ø¨Ø§ Ø­Ø¯Ø§Ù‚Ù„ Ø¨Ø§Ø´Ø¯ ',0),(228207,6340,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø¨Ø§ÙŠØ¯ Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ÙŠØ§ Ù…Ø³Ø§ÙˆÙŠ Ø¨Ø§ Ø­Ø¯Ø§Ù‚Ù„ Ø¨Ø§Ø´Ø¯ ',0),(228208,6340,'tr','Max, min ya da daha bÃ¼yÃ¼k olmalÄ±dÄ±r.',0),(228209,6340,'pl','Max musi byÄ‡ wiÄ™ksza lub rÃ³wna min.',0),(228210,6340,'bg','ÐœÐ°ÐºÑ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ð¾-Ð³Ð¾Ð»ÑÐ¼ Ð¸Ð»Ð¸ Ñ€Ð°Ð²ÐµÐ½ Ð½Ð° Ð¼Ð¸Ð½.',0),(228211,6340,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ÛŒØ§ Ú©Ù… Ø§Ø² Ú©Ù… Ø¨Ø±Ø§Ø¨Ø± ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒÛ’ Û”',0),(228212,6340,'sr','ÐœÐ°x Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð²ÐµÑ›Ð¸ Ð¸Ð»Ð¸ Ñ˜ÐµÐ´Ð½Ð°Ðº Ð¼Ð¸Ð½.',0),(228213,6340,'vi','Tá»‘i Ä‘a pháº£i lá»›n hÆ¡n hoáº·c báº±ng tá»‘i thiá»ƒu',0),(228214,6340,'af','Max moet groter as of gelyk aan min wees.',0),(228215,6340,'ro','Max trebuie sÄƒ fie mai mare sau egal cu min.',0),(228216,6340,'et','Max peab olema min vÃµi suurem.',0),(228217,6340,'si','Max mora biti veÄji ali enak min.',0),(228218,6340,'ba','Max harus lebih besar dari atau sama dengan min.',0),(228219,6340,'nl','Max moet groter dan of gelijk aan min.',0),(228220,6340,'fi','Max on oltava vÃ¤hintÃ¤Ã¤n min.',0),(228221,6340,'no','Max mÃ¥ vÃ¦re stÃ¸rre enn eller lik min.',0),(228222,6340,'da','Max skal vÃ¦re stÃ¸rre end eller lig med min.',0),(228223,6340,'ko','MaxëŠ” min ë³´ë‹¤ í¬ê±°ë‚˜ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(228224,6340,'he','×ž×§×¡ ×—×™×™×‘ ×œ×”×™×•×ª ×’×“×•×œ ××• ×©×•×•×” ×œ×“×§×•×ª.',0),(228225,6340,'el','Max Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼ÎµÎ³Î±Î»ÏÏ„ÎµÏÎ· Î® Î¯ÏƒÎ· Î¼Îµ Î»ÎµÏ€Ï„Î¬.',0),(228226,6340,'zh','æœ€å¤§å€¼å¿…é¡»å¤§äºŽæˆ–ç­‰äºŽæœ€å°å€¼ã€‚\r\n',0),(228227,6340,'sv','Max mÃ¥ste vara stÃ¶rre Ã¤n eller lika med min.',0),(228228,6340,'it','Max deve essere maggiore o uguale a min.',0),(228229,6340,'tl','',0),(228230,6340,'th','&#3626;&#3641;&#3591;&#3607;&#3637;&#3656;&#3626;&#3640;&#3604;&#3605;&#3657;&#3629;&#3591;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3627;&#3619;&#3639;&#3629;&#3648;&#3607;&#3656;&#3634;&#3585;&#3633;&#3610;&#3609;&#3657;&#3629;&#3618;&#3607;&#3',0),(228231,6340,'hi','à¤®à¥ˆà¤•à¥à¤¸ à¤¸à¥‡ à¤¬à¤¡à¤¼à¤¾ à¤¯à¤¾ à¤¬à¤°à¤¾à¤¬à¤° à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(228232,6340,'ms','Max mesti lebih besar daripada atau sama dengan min.',0),(228233,6340,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ø£ÙƒØ¨Ø± Ù…Ù† Ø£Ùˆ ÙŠØ³Ø§ÙˆÙŠ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰.',0),(228234,6340,'fr','Max doit Ãªtre supÃ©rieure ou Ã©gale Ã  min.',0),(228235,6340,'jp','æœ€å¤§æ•°ã?¯æœ€å°‘æ•°ã?¨å?Œã?˜ã?‹ã??ã‚Œä»¥ä¸Šã?«ã?—ã?¦ä¸‹ã?•ã?„',0),(228236,6340,'pt','Max deve ser maior ou igual a min.',0),(228237,6340,'ru','ÐœÐ°ÐºÑ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð±Ð¾Ð»ÑŒÑˆÐµ Ð¸Ð»Ð¸ Ñ€Ð°Ð²Ð½Ð° Ð¼Ð¸Ð½.',0),(228238,6340,'es','Max debe ser mÃ¡s grande que o igual al min.',0),(228239,6340,'de','Max muss grÃ¶ÃŸer als oder gleich min sein.',0),(228240,6340,'en','Max must be greater than or equal to min.',0),(228241,6341,'is','',0),(228242,6341,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ù‚Ø¯Ø§Ø± ',0),(228243,6341,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù…Ù‚Ø¯Ø§Ø± ',0),(228244,6341,'tr','Maksimum miktar',0),(228245,6341,'pl','Max iloÅ›Ä‡',0),(228246,6341,'bg','ÐœÐ°ÐºÑ ÐºÐ¾Ð»',0),(228247,6341,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù‚ÛŒ',0),(228248,6341,'sr','ÐœÐ°x , ÐšÐ¾Ð».',0),(228249,6341,'vi','Sá»‘ lÆ°á»£ng tá»‘i Ä‘a',0),(228250,6341,'af','Maks. Hoev.',0),(228251,6341,'ro','Max cantit',0),(228252,6341,'et','Max kogus',0),(228253,6341,'si','Max kol',0),(228254,6341,'ba','Max Qty',0),(228255,6341,'nl','Max aantal',0),(228256,6341,'fi','Max mÃ¤Ã¤rÃ¤',0),(228257,6341,'no','Max antall',0),(228258,6341,'da','Max antal',0),(228259,6341,'ko','ìµœëŒ€ ìˆ˜ëŸ‰',0),(228260,6341,'he','×›×ž×•×ª ×©×œ ×ž×§×¡',0),(228261,6341,'el','Max Qty',0),(228262,6341,'zh','æœ€å¤§æ•°é‡\r\n',0),(228263,6341,'sv','Max antal',0),(228264,6341,'it','Max Qty',0),(228265,6341,'tl','',0),(228266,6341,'th','&#3588;&#3640;&#3603;&#3616;&#3634;&#3614;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(228267,6341,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(228268,6341,'ms','Max Qty',0),(228269,6341,'ar','Ø£Ù‚ØµÙ‰ ÙƒÙ…Ù‘ÙŠØ© Ù„Ù„Ø·Ù„Ø¨ÙŠØ©',0),(228270,6341,'fr','QtÃ© Max',0),(228271,6341,'jp','æœ€å¤§æ•°é‡?',0),(228272,6341,'pt','Max Qty',0),(228273,6341,'ru','ÐœÐ°ÐºÑ ÐšÐ¾Ð»-Ð²Ð¾',0),(228274,6341,'es','Max Cant.',0),(228275,6341,'de','Max Qty',0),(228276,6341,'en','Max Qty',0),(228277,6342,'is','',0),(228278,6342,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ù…Ù‚Ø¯Ø§Ø± ',0),(228279,6342,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ù…Ù‚Ø¯Ø§Ø± ',0),(228280,6342,'tr','En az miktar',0),(228281,6342,'pl','IloÅ›Ä‡ min',0),(228282,6342,'bg','ÐœÐ¸Ð½ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(228283,6342,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ù‚ÛŒ',0),(228284,6342,'sr','ÐœÐ¸Ð½ ÐšÐ¾Ð».',0),(228285,6342,'vi','Sá»‘ lÆ°á»£ng Tá»‘i thiá»ƒu',0),(228286,6342,'af','Min. Hoev.',0),(228287,6342,'ro','Min cantitate',0),(228288,6342,'et','Min kogus',0),(228289,6342,'si','KoliÄina min',0),(228290,6342,'ba','Min Qty',0),(228291,6342,'nl','Min aantal',0),(228292,6342,'fi','Min mÃ¤Ã¤rÃ¤',0),(228293,6342,'no','Min antall',0),(228294,6342,'da','Min. antal',0),(228295,6342,'ko','ìµœì†Œ ìˆ˜ëŸ‰',0),(228296,6342,'he','×›×ž×•×ª ×“×§×•×ª',0),(228297,6342,'el','Min Qty',0),(228298,6342,'zh','æœ€å°æ•°é‡\r\n',0),(228299,6342,'sv','Min antal',0),(228300,6342,'it','Qty min',0),(228301,6342,'tl','',0),(228302,6342,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(228303,6342,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(228304,6342,'ms','Min Qty',0),(228305,6342,'ar','Ø£Ø¯Ù†Ù‰ ÙƒÙ…Ù‘ÙŠØ© Ù„Ù„Ø·Ù„Ø¨ÙŠØ©',0),(228306,6342,'fr','QtÃ© min',0),(228307,6342,'jp','æœ€å°?æ•°é‡?',0),(228308,6342,'pt','Qtde min',0),(228309,6342,'ru','ÐœÐ¸Ð½ ÐšÐ¾Ð»-Ð²Ð¾',0),(228310,6342,'es','Min Cant',0),(228311,6342,'de','Min Qty',0),(228312,6342,'en','Min Qty',0),(228313,6343,'is','',0),(228314,6343,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(228315,6343,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(228316,6343,'tr','Yeni bir seÃ§enek',0),(228317,6343,'pl','Nowa opcja',0),(228318,6343,'bg','ÐÐ¾Ð²Ð° Ð¾Ð¿Ñ†Ð¸Ñ',0),(228319,6343,'ur','Ù†ÛŒØ§ Ø¢Ù¾Ø´Ù†',0),(228320,6343,'sr','ÐÐ¾Ð²Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(228321,6343,'vi','Lá»±a chá»n má»›i',0),(228322,6343,'af','Nuwe Opsie',0),(228323,6343,'ro','Noua opÅ£iune',0),(228324,6343,'et','Uus valik',0),(228325,6343,'si','Nova moÅ¾nost',0),(228326,6343,'ba','Opsi baru',0),(228327,6343,'nl','Nieuwe optie',0),(228328,6343,'fi','Uusi vaihtoehto',0),(228329,6343,'no','Nytt alternativ',0),(228330,6343,'da','Ny mulighed',0),(228331,6343,'ko','ìƒˆë¡œìš´ ì˜µì…˜',0),(228332,6343,'he','××¤×©×¨×•×ª ×—×“×©×”',0),(228333,6343,'el','ÎÎ­Î± ÎµÏ€Î¹Î»Î¿Î³Î®',0),(228334,6343,'zh','æ–°é€‰é¡¹\r\n',0),(228335,6343,'sv','Nya alternativ',0),(228336,6343,'it','Nuova opzione',0),(228337,6343,'tl','',0),(228338,6343,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3651;&#3627;&#3617;&#3656;',0),(228339,6343,'hi','à¤¨à¤ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(228340,6343,'ms','Pilihan baru',0),(228341,6343,'ar','Ø®ÙŠØ§Ø± Ø¬Ø¯ÙŠØ¯',0),(228342,6343,'fr','Nouvelle Option',0),(228343,6343,'jp','æ–°è¦?ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(228344,6343,'pt','Nova opÃ§Ã£o',0),(228345,6343,'ru','ÐÐ¾Ð²Ð°Ñ Ð¾Ð¿Ñ†Ð¸Ñ',0),(228346,6343,'es','Nueva OpciÃ³n',0),(228347,6343,'de','Neue Option',0),(228348,6343,'en','New Option',0),(228349,6344,'is','',0),(228350,6344,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯ Ø§Ø² ÙƒÙ¾ÙŠ ',0),(228351,6344,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ø¬Ø¯ÙŠØ¯ Ø§Ø² ÙƒÙ¾ÙŠ ',0),(228352,6344,'tr','Yeni seÃ§me hakkÄ±--dan Kopyala',0),(228353,6344,'pl','Nowa opcja z kopii',0),(228354,6344,'bg','ÐÐ¾Ð²Ð° Ð¾Ð¿Ñ†Ð¸Ñ Ð¾Ñ‚ ÐºÐ¾Ð¿Ð¸Ðµ',0),(228355,6344,'ur','Ù†Ù‚Ù„ Ø³Û’ Ù†ÛŒØ§ Ø¢Ù¾Ø´Ù†',0),(228356,6344,'sr','ÐÐ¾Ð²Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð¸Ð· ÐºÐ¾Ð¿Ð¸Ñ˜Ðµ',0),(228357,6344,'vi','Lá»±a chá»n má»›i tá»« sao chÃ©p',0),(228358,6344,'af','Nuwe opsie uit kopie',0),(228359,6344,'ro','Noua opÅ£iune de copie',0),(228360,6344,'et','Uus vÃµimalus koopia',0),(228361,6344,'si','Nova moÅ¾nost iz kopije',0),(228362,6344,'ba','Pilihan baru dari Copy',0),(228363,6344,'nl','Nieuwe optie van kopie',0),(228364,6344,'fi','Uusi vaihtoehto kopiosta',0),(228365,6344,'no','Nytt alternativ fra kopi',0),(228366,6344,'da','Ny mulighed fra kopi',0),(228367,6344,'ko','ë³µì‚¬ë³¸ì—ì„œ ìƒˆ ì˜µì…˜',0),(228368,6344,'he','××¤×©×¨×•×ª ×—×“×©×” ×ž×¢×•×ª×§',0),(228369,6344,'el','ÎÎ­Î± ÎµÏ€Î¹Î»Î¿Î³Î® Î±Ï€ÏŒ Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿',0),(228370,6344,'zh','æ¥è‡ªå¤åˆ¶çš„æ–°é€‰æ‹©\r\n',0),(228371,6344,'sv','Nytt alternativ frÃ¥n kopia',0),(228372,6344,'it','Nuova opzione di copia',0),(228373,6344,'tl','',0),(228374,6344,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3651;&#3627;&#3617;&#3656;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;',0),(228375,6344,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¸à¥‡ à¤¨à¤ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(228376,6344,'ms','Pilihan baru dari salinan',0),(228377,6344,'ar','Ù†Ø³Ø®Ø© Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ø®ÙŠØ§Ø± Ø¥Ù„Ù‰ Ø¢Ø®Ø± Ø¬Ø¯ÙŠØ¯',0),(228378,6344,'fr','Nouvelle Option de copie',0),(228379,6344,'jp','ã‚³ãƒ”ãƒ¼ã?‹ã‚‰ã?®æ–°è¦?ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(228380,6344,'pt','Nova opÃ§Ã£o de cÃ³pia',0),(228381,6344,'ru','ÐÐ¾Ð²Ð°Ñ Ð¾Ð¿Ñ†Ð¸Ñ Ð¸Ð· ÐºÐ¾Ð¿Ð¸Ð¸',0),(228382,6344,'es','Nueva OpciÃ³n De CÃ³pia',0),(228383,6344,'de','Neue Option von Kopie',0),(228384,6344,'en','New Option From Copy',0),(228385,6345,'is','',0),(228386,6345,'dr','Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯ Ú¯Ø²ÙŠÙ†Ù‡',0),(228387,6345,'pr','Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯ Ú¯Ø²ÙŠÙ†Ù‡',0),(228388,6345,'tr','Yeni seÃ§enek grubu',0),(228389,6345,'pl','Nowe grupy opcji',0),(228390,6345,'bg','ÐÐ¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð¾Ñ‚ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(228391,6345,'ur','Ù†ÛŒØ§ Ø¢Ù¾Ø´Ù† Ú¯Ø±ÙˆÙ¾',0),(228392,6345,'sr','ÐÐ¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(228393,6345,'vi','NhÃ³m Lá»±a chá»n má»›i',0),(228394,6345,'af','Nuwe Opsie Groep',0),(228395,6345,'ro','Noul grup de opÈ›iuni',0),(228396,6345,'et','Uus suvandirÃ¼hma',0),(228397,6345,'si','Nova moÅ¾nost skupine',0),(228398,6345,'ba','Kelompok baru pilihan',0),(228399,6345,'nl','Nieuwe optie groep',0),(228400,6345,'fi','Uuden asetusryhmÃ¤n nimi',0),(228401,6345,'no','Ny gruppe',0),(228402,6345,'da','Nye gruppeboks',0),(228403,6345,'ko','ìƒˆë¡œìš´ ì˜µì…˜ ê·¸ë£¹',0),(228404,6345,'he','×§×‘×•×¦×ª ××¤×©×¨×•×™×•×ª ×—×“×©×•×ª',0),(228405,6345,'el','ÎÎ­Î± Î¿Î¼Î¬Î´Î± ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(228406,6345,'zh','æ–°é€‰é¡¹ç»„\r\n',0),(228407,6345,'sv','Nya gruppruta',0),(228408,6345,'it','Nuovo gruppo di opzioni',0),(228409,6345,'tl','',0),(228410,6345,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3651;&#3627;&#3617;&#3656;',0),(228411,6345,'hi','à¤¨à¤ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤®à¥‚à¤¹',0),(228412,6345,'ms','Kumpulan opsyen baru',0),(228413,6345,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø®ÙŠØ§Ø±Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(228414,6345,'fr','Nouveau groupe d\'options',0),(228415,6345,'jp','æ–°è¦?ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚°ãƒ«ãƒ¼ãƒ—',0),(228416,6345,'pt','Nova opÃ§Ã£o de grupo',0),(228417,6345,'ru','ÐÐ¾Ð²Ð°Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ð° Ð¿ÐµÑ€ÐµÐºÐ»ÑŽÑ‡Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(228418,6345,'es','Nuevo Grupo de Opciones',0),(228419,6345,'de','Neue Option-Gruppe',0),(228420,6345,'en','New Option Group',0),(228421,6346,'is','',0),(228422,6346,'dr','ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(228423,6346,'pr','ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(228424,6346,'tr','Nontaxable',0),(228425,6346,'pl','Operacji nieopodatkowanych',0),(228426,6346,'bg','Nontaxable',0),(228427,6346,'ur','Ù†ÙˆÙ†ØªÚ¯Ø²ÛŒØ¨Ù„ÛŒ',0),(228428,6346,'sr','ÐÐµÐ¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸Ñ…',0),(228429,6346,'vi','KhÃ´ng chá»‹u thuáº¿',0),(228430,6346,'af','Nie-Belasbaar',0),(228431,6346,'ro','Nontaxable',0),(228432,6346,'et','Mittemaksustatav',0),(228433,6346,'si','Nontaxable',0),(228434,6346,'ba','Nontaxable',0),(228435,6346,'nl','Nontaxable',0),(228436,6346,'fi','Nontaxable',0),(228437,6346,'no','Nontaxable',0),(228438,6346,'da','Ej',0),(228439,6346,'ko','Nontaxable',0),(228440,6346,'he','Nontaxable',0),(228441,6346,'el','Nontaxable',0),(228442,6346,'zh','å…ç¨Ž\r\n',0),(228443,6346,'sv','Nontaxable',0),(228444,6346,'it','Nontaxable',0),(228445,6346,'tl','',0),(228446,6346,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;',0),(228447,6346,'hi','Nontaxable',0),(228448,6346,'ms','Nontaxable',0),(228449,6346,'ar','Ù†ÙˆÙ†ØªØ§ÙƒØ³Ø§Ø¨Ù„',0),(228450,6346,'fr','Non taxable',0),(228451,6346,'jp','é?žèª²ç¨Žå¯¾è±¡',0),(228452,6346,'pt','Nontaxable',0),(228453,6346,'ru','Nontaxable',0),(228454,6346,'es','No Imponible',0),(228455,6346,'de','Nontaxable',0),(228456,6346,'en','Nontaxable',0),(228457,6347,'is','',0),(228458,6347,'dr','Ø¨Ø¯ÙˆÙ† Ú¯Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(228459,6347,'pr','Ø¨Ø¯ÙˆÙ† Ú¯Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(228460,6347,'tr','Yuvarlama',0),(228461,6347,'pl','ZaokrÄ…glanie nie',0),(228462,6347,'bg','ÐÑÐ¼Ð° Ð·Ð°ÐºÑ€ÑŠÐ³Ð»ÐµÐ½Ð¸Ðµ',0),(228463,6347,'ur','Ú©ÙˆØ¦ÛŒ Ù¾Ú©Ú‘ Ø¯Ú¾Ú©Ú‘',0),(228464,6347,'sr','Ð‘ÐµÐ· Ð·Ð°Ð¾ÐºÑ€ÑƒÐ¶Ð¸Ð²Ð°ÑšÐ°',0),(228465,6347,'vi','KhÃ´ng lÃ m trÃ²n',0),(228466,6347,'af','Geen Afronding',0),(228467,6347,'ro','Nici o rotunjire',0),(228468,6347,'et','No Ã¼mardamine',0),(228469,6347,'si','Brez zaokroÅ¾evanja',0),(228470,6347,'ba','Tak ada pembulatan',0),(228471,6347,'nl','Geen afronding',0),(228472,6347,'fi','Ei pyÃ¶ristystÃ¤',0),(228473,6347,'no','Ingen avrunding',0),(228474,6347,'da','Ingen afrunding',0),(228475,6347,'ko','ì—†ìŒ ë°˜ì˜¬ë¦¼',0),(228476,6347,'he','××™×Ÿ ×¢×™×’×•×œ',0),(228477,6347,'el','Î§Ï‰ÏÎ¯Ï‚ ÏƒÏ„ÏÎ¿Î³Î³Ï…Î»Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(228478,6347,'zh','æ²¡æœ‰èˆå…¥\r\n',0),(228479,6347,'sv','Ingen avrundning',0),(228480,6347,'it','Nessun arrotondamento',0),(228481,6347,'tl','',0),(228482,6347,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3588;&#3623;&#3634;&#3617;&#3594;&#3633;&#3604;&#3648;&#3592;&#3609;',0),(228483,6347,'hi','à¤•à¥‹à¤ˆ à¤˜à¥à¤®à¤¾à¤µ',0),(228484,6347,'ms','Tidak dibundarkan',0),(228485,6347,'ar','Ø£ÙŠ ØªÙ‚Ø±ÙŠØ¨',0),(228486,6347,'fr','Pas d\'arrondi',0),(228487,6347,'jp','æ¦‚æ•°ã?«ã?—ã?ªã?„',0),(228488,6347,'pt','Sem arredondamento',0),(228489,6347,'ru','ÐÐ¸ÐºÐ°ÐºÐ¾Ð³Ð¾ Ð¾ÐºÑ€ÑƒÐ³Ð»ÐµÐ½Ð¸Ñ',0),(228490,6347,'es','No hay Redondeo',0),(228491,6347,'de','Keine Rundung',0),(228492,6347,'en','No Rounding',0),(228493,6348,'is','',0),(228494,6348,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ú¯Ø±ÙˆÙ‡ ',0),(228495,6348,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ú¯Ø±ÙˆÙ‡ ',0),(228496,6348,'tr','SeÃ§enek grubu',0),(228497,6348,'pl','Grupa opcji',0),(228498,6348,'bg','Ð“Ñ€ÑƒÐ¿Ð° Ð¾Ð¿Ñ†Ð¸Ð¸',0),(228499,6348,'ur','Ø§Ø®ØªÛŒØ§Ø± Ú¯Ø±ÙˆÙ¾',0),(228500,6348,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(228501,6348,'vi','NhÃ³m Lá»±a chá»n',0),(228502,6348,'af','Opsie Groep',0),(228503,6348,'ro','Grup de opÈ›iuni',0),(228504,6348,'et','SuvandirÃ¼hma',0),(228505,6348,'si','MoÅ¾nost skupine',0),(228506,6348,'ba','Pilihan grup',0),(228507,6348,'nl','Groepsvak',0),(228508,6348,'fi','VaihtoehtoryhmÃ¤',0),(228509,6348,'no','Alternativgruppe',0),(228510,6348,'da','Gruppeboks',0),(228511,6348,'ko','ì˜µì…˜ ê·¸ë£¹',0),(228512,6348,'he','×§×‘×•×¦×ª ××¤×©×¨×•×™×•×ª',0),(228513,6348,'el','ÎŸÎ¼Î¬Î´Î± ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(228514,6348,'zh','é€‰é¡¹ç»„\r\n',0),(228515,6348,'sv','Gruppruta',0),(228516,6348,'it','Gruppo di opzioni',0),(228517,6348,'tl','',0),(228518,6348,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(228519,6348,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤®à¥‚à¤¹',0),(228520,6348,'ms','Opsyen Kumpulan',0),(228521,6348,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª',0),(228522,6348,'fr','Groupe d\'options',0),(228523,6348,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚°ãƒ«ãƒ¼ãƒ—',0),(228524,6348,'pt','Grupo de opÃ§Ãµes',0),(228525,6348,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð¿ÐµÑ€ÐµÐºÐ»ÑŽÑ‡Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(228526,6348,'es','Grupo de Opciones',0),(228527,6348,'de','Optionsgruppe',0),(228528,6348,'en','Option Group',0),(228529,6349,'is','',0),(228530,6349,'dr','ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(228531,6349,'pr','ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(228532,6349,'tr','Birim fiyat',0),(228533,6349,'pl','Ceny jednostki',0),(228534,6349,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(228535,6349,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(228536,6349,'sr','Ð¦ÐµÐ½Ðµ Ñƒ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(228537,6349,'vi','ÄÆ¡n vá»‹ giÃ¡',0),(228538,6349,'af','Pryseenheid',0),(228539,6349,'ro','Unitatea de tarifare',0),(228540,6349,'et','Hindade Ã¼hik',0),(228541,6349,'si','Cene enote',0),(228542,6349,'ba','Harga Unit',0),(228543,6349,'nl','Prijzen eenheid',0),(228544,6349,'fi','Hinnoittelu yksikkÃ¶',0),(228545,6349,'no','Priser enhet',0),(228546,6349,'da','PrissÃ¦tning enhed',0),(228547,6349,'ko','ê°€ê²© ë‹¨ìœ„',0),(228548,6349,'he','×ª×ž×—×•×¨ ×™×—×™×“×”',0),(228549,6349,'el','ÎœÎ¿Î½Î¬Î´Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(228550,6349,'zh','è®¡ä»·å•ä½\r\n',0),(228551,6349,'sv','PrissÃ¤ttning enhet',0),(228552,6349,'it','Prezzi unitÃ ',0),(228553,6349,'tl','',0),(228554,6349,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;',0),(228555,6349,'hi','à¤‡à¤•à¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(228556,6349,'ms','Harga Unit',0),(228557,6349,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(228558,6349,'fr','UnitÃ© de tarification',0),(228559,6349,'jp','ä¾¡æ ¼è¨­å®šå?˜ä½?',0),(228560,6349,'pt','Unidade de preÃ§os',0),(228561,6349,'ru','Ð¦ÐµÐ½Ð¾Ð²Ð°Ñ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(228562,6349,'es','Unidad de FijaciÃ³n de Precios',0),(228563,6349,'de','Preise Einheit',0),(228564,6349,'en','Pricing Unit',0),(228565,6350,'is','',0),(228566,6350,'dr','Ù…Ù‚Ø¯Ø§Ø± Ú¯Ø±Ø¯ Ø´Ø¯Ù‡ ',0),(228567,6350,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú¯Ø±Ø¯ Ø´Ø¯Ù‡ ',0),(228568,6350,'tr','Miktar yuvarlama',0),(228569,6350,'pl','IloÅ›Ä‡ zaokrÄ…glania',0),(228570,6350,'bg','ÐšÐ¾Ð»-Ð²Ð¾ Ð·Ð° Ð·Ð°ÐºÑ€ÑŠÐ³Ð»ÑÐ²Ð°Ð½Ðµ',0),(228571,6350,'ur','Ù‚ÛŒ Ù¾Ú©Ú‘ Ø¯Ú¾Ú©Ú‘',0),(228572,6350,'sr','Ð—Ð°Ð¾ÐºÑ€ÑƒÐ¶Ð¸Ð²Ð°ÑšÐµ ÐšÐ¾Ð».',0),(228573,6350,'vi','Sá»‘ lÆ°á»£ng tÃ­nh trÃ²n',0),(228574,6350,'af','Hoev. Afronding',0),(228575,6350,'ro','Cantit rotunjire',0),(228576,6350,'et','Kogus Ã¼mardamine',0),(228577,6350,'si','KoliÄina zaokroÅ¾evanja',0),(228578,6350,'ba','Qty pembulatan',0),(228579,6350,'nl','Aantal afronding',0),(228580,6350,'fi','MÃ¤Ã¤rÃ¤ pyÃ¶ristys',0),(228581,6350,'no','Antall avrunding',0),(228582,6350,'da','Antal afrunding',0),(228583,6350,'ko','Qty ë°˜ì˜¬ë¦¼',0),(228584,6350,'he','×›×ž×•×ª ×©×œ ×¢×™×’×•×œ',0),(228585,6350,'el','Î£Ï„ÏÎ¿Î³Î³Ï…Î»Î¿Ï€Î¿Î¯Î·ÏƒÎ· Qty',0),(228586,6350,'zh','æ•°é‡å››èˆäº”å…¥\r\n',0),(228587,6350,'sv','Antal avrundning',0),(228588,6350,'it','Arrotondamento Qty',0),(228589,6350,'tl','',0),(228590,6350,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3617;&#3634;',0),(228591,6350,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤—à¥‹à¤²à¤¾à¤ˆ',0),(228592,6350,'ms','Qty dibundarkan',0),(228593,6350,'ar','Qty Ø§Ù„ØªÙ‚Ø±ÙŠØ¨',0),(228594,6350,'fr','Qty arrondi',0),(228595,6350,'jp','æ¦‚æ•°é‡?',0),(228596,6350,'pt','Qtde de arredondamento',0),(228597,6350,'ru','Qty Ð¾ÐºÑ€ÑƒÐ³Ð»ÐµÐ½Ð¸Ñ',0),(228598,6350,'es','Cant. Redondeo',0),(228599,6350,'de','Qty Rundung',0),(228600,6350,'en','Qty Rounding',0),(228601,6351,'is','',0),(228602,6351,'dr','Ù¾ÙŠØ§Ù… Ø±Ø§Ø¯ÙŠÙˆÙŠÙŠ',0),(228603,6351,'pr','Ù¾ÙŠØ§Ù… Ø±Ø§Ø¯ÙŠÙˆÙŠÙŠ',0),(228604,6351,'tr','Radyo',0),(228605,6351,'pl','Radia',0),(228606,6351,'bg','Ð Ð°Ð´Ð¸Ð¾',0),(228607,6351,'ur','Ø±ÛŒÚˆÛŒÙˆ',0),(228608,6351,'sr','Ð Ð°Ð´Ð¸Ð¾',0),(228609,6351,'vi','Radio',0),(228610,6351,'af','Radio',0),(228611,6351,'ro','Radio',0),(228612,6351,'et','Raadio',0),(228613,6351,'si','Radio',0),(228614,6351,'ba','Radio',0),(228615,6351,'nl','Radio',0),(228616,6351,'fi','Radio',0),(228617,6351,'no','Radio',0),(228618,6351,'da','Radio',0),(228619,6351,'ko','ë¼ë””ì˜¤',0),(228620,6351,'he','×¨×“×™×•',0),(228621,6351,'el','Î¡Î±Î´Î¹ÏŒÏ†Ï‰Î½Î¿',0),(228622,6351,'zh','ç”µå°\r\n',0),(228623,6351,'sv','Radio',0),(228624,6351,'it','Radio',0),(228625,6351,'tl','',0),(228626,6351,'th','Radio',0),(228627,6351,'hi','à¤°à¥‡à¤¡à¤¿à¤¯à¥‹',0),(228628,6351,'ms','Radio',0),(228629,6351,'ar','Ø±Ø§Ø¯ÙŠÙˆ',0),(228630,6351,'fr','Radio',0),(228631,6351,'jp','ãƒ©ã‚¸ã‚ª',0),(228632,6351,'pt','RÃ¡dio',0),(228633,6351,'ru','Ð Ð°Ð´Ð¸Ð¾',0),(228634,6351,'es','Radio',0),(228635,6351,'de','Radio',0),(228636,6351,'en','Radio',0),(228637,6352,'is','',0),(228638,6352,'dr','Ø­Ø°Ù ÙƒØ§Ù„Ø§ ',0),(228639,6352,'pr','Ø­Ø°Ù ÙƒØ§Ù„Ø§ ',0),(228640,6352,'tr','Ã–ÄŸeyi KaldÄ±r',0),(228641,6352,'pl','UsuÅ„ element',0),(228642,6352,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(228643,6352,'ur','Ø´Û’ ÛÙ¹Ø§Ø¦ÛŒÚº',0),(228644,6352,'sr','Ð£ÐºÐ»Ð¾Ð½Ð¸ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(228645,6352,'vi','Bá» hÃ ng',0),(228646,6352,'af','Verwyder Item',0),(228647,6352,'ro','EliminaÅ£i elementul',0),(228648,6352,'et','Eemalda Ã¼ksus',0),(228649,6352,'si','Odstranite element',0),(228650,6352,'ba','Menghapus Item',0),(228651,6352,'nl','Item verwijderen',0),(228652,6352,'fi','Poista kohde',0),(228653,6352,'no','Fjern',0),(228654,6352,'da','Fjern vare',0),(228655,6352,'ko','í•­ëª©ì„ ì œê±°',0),(228656,6352,'he','×”×¡×¨ ×¤×¨×™×˜',0),(228657,6352,'el','ÎšÎ±Ï„Î¬ÏÎ³Î·ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(228658,6352,'zh','ç§»é™¤é¡¹ç›®\r\n',0),(228659,6352,'sv','Ta bort objekt',0),(228660,6352,'it','Rimuovere l\'elemento',0),(228661,6352,'tl','',0),(228662,6352,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(228663,6352,'hi','à¤†à¤‡à¤Ÿà¤® à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚',0),(228664,6352,'ms','Alih Keluar Item',0),(228665,6352,'ar','Ø¥Ø²Ø§Ù„Ø© Ø§Ù„ØµÙ†Ù',0),(228666,6352,'fr','Supprimer Ã©lÃ©ment',0),(228667,6352,'jp','å“?ç›®ã?®',0),(228668,6352,'pt','Remover Item',0),(228669,6352,'ru','Ð£Ð±Ñ€Ð°Ñ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€',0),(228670,6352,'es','Eliminar Item',0),(228671,6352,'de','Element entfernen',0),(228672,6352,'en','Remove Item',0),(228673,6353,'is','',0),(228674,6353,'dr','Ú¯Ø±Ø¯ Ú©Ø±Ø¯Ù† Ú©Ø§Ù‡Ø´Ù‰ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„',0),(228675,6353,'pr','Ú¯Ø±Ø¯ Ú©Ø±Ø¯Ù† Ú©Ø§Ù‡Ø´Ù‰ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„',0),(228676,6353,'tr','Yuvarlak aÅŸaÄŸÄ± tÃ¼m miktar',0),(228677,6353,'pl','OkrÄ…gÅ‚e do caÅ‚a iloÅ›Ä‡',0),(228678,6353,'bg','ÐšÑ€ÑŠÐ³ Ð´Ð¾ Ñ†ÑÐ»Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(228679,6353,'ur','Ù¾ÙˆØ±Û’ Ù‚ÛŒ Ù†ÛŒÚ†Û’ Ú¯ÙˆÙ„',0),(228680,6353,'sr','ÐžÐºÑ€ÑƒÐ³Ð»Ðµ Ð´Ð¾ Ñ†ÐµÐ»Ð° ÐšÐ¾Ð».',0),(228681,6353,'vi','LÃ m trÃ²n xuá»‘ng cho toÃ n bá»™ sá»‘ lÆ°á»£ng',0),(228682,6353,'af','Afrond Tot Heel Hoev.',0),(228683,6353,'ro','Runda la Ã®ntreaga cantitate',0),(228684,6353,'et','Voorus alla kogu kogus',0),(228685,6353,'si','Okrogle do cela kol',0),(228686,6353,'ba','Putaran ke seluruh Qty',0),(228687,6353,'nl','Ronde tot hele Qty',0),(228688,6353,'fi','PyÃ¶reÃ¤ alas koko mÃ¤Ã¤rÃ¤',0),(228689,6353,'no','Runde ned hele antall',0),(228690,6353,'da','Runde ned til hele Qty',0),(228691,6353,'ko','ì „ì²´ ìˆ˜ëŸ‰ìœ¼ë¡œ ë¼ìš´ë“œ',0),(228692,6353,'he','×¢×’×•×œ ×¢×“ ×›×ž×•×ª ×©×œ ×›×œ',0),(228693,6353,'el','Î“ÏÏÎ¿ ÎºÎ¬Ï„Ï‰ Î¿Î»ÏŒÎºÎ»Î·ÏÎ¿ Qty',0),(228694,6353,'zh','èˆå…¥åˆ°æ•´æ•°é‡\r\n',0),(228695,6353,'sv','Runda ner till hela Kvt',0),(228696,6353,'it','Arrotondamento al intero Qty',0),(228697,6353,'tl','',0),(228698,6353,'th','&#3627;&#3617;&#3640;&#3609;&#3621;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3588;&#3619;&#3610;&#3606;&#3657;&#3623;&#3609;',0),(228699,6353,'hi','à¤¦à¥Œà¤° à¤ªà¥‚à¤°à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡',0),(228700,6353,'ms','Pusingan ke seluruh Qty',0),(228701,6353,'ar','Ø¬ÙˆÙ„Ø© ÙˆØµÙˆÙ„Ø§Ù‹ Ø¥Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ© ÙƒÙ„Ù‡Ø§',0),(228702,6353,'fr','Rond vers le bas pour toute quantitÃ©',0),(228703,6353,'jp','ã?™ã?¹ã?¦ã?®æ•°é‡?ã‚’åˆ‡ã‚Šæ?¨ã?¦',0),(228704,6353,'pt','Rodada atÃ© todo Qty',0),(228705,6353,'ru','Ð Ð°ÑƒÐ½Ð´ Ð²Ð½Ð¸Ð· Ð²ÐµÑÑŒ ÐšÐ¾Ð»',0),(228706,6353,'es','Redondear Abajo A Una Cantidad Entero',0),(228707,6353,'de','Runde auf ganze Menge:',0),(228708,6353,'en','Round Down To Whole Qty',0),(228709,6354,'is','',0),(228710,6354,'dr','Ú¯Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§ÙØ²Ø§ÙŠØ´ÙŠ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„',0),(228711,6354,'pr','Ú¯Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§ÙØ²Ø§ÙŠØ´ÙŠ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„',0),(228712,6354,'tr','TÃ¼m miktar kadar yuvarlak',0),(228713,6354,'pl','OkrÄ…gÅ‚e do caÅ‚a iloÅ›Ä‡',0),(228714,6354,'bg','ÐšÑ€ÑŠÐ³Ð»Ð¸ Ð´Ð¾ Ñ†ÑÐ»Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(228715,6354,'ur','Ù¾ÙˆØ±Û’ Ù‚ÛŒ ØªÚ© Ú¯ÙˆÙ„',0),(228716,6354,'sr','ÐžÐºÑ€ÑƒÐ³Ð»Ðµ Ð´Ð¾ Ñ†ÐµÐ»Ð° ÐšÐ¾Ð».',0),(228717,6354,'vi','LÃ m trÃ²n lÃªn cho toÃ n bá»™ sá»‘ lÆ°á»£ng',0),(228718,6354,'af','Oprond Tot Heel Hoev.',0),(228719,6354,'ro','Rotunde de pÃ¢nÄƒ la Ã®ntreaga cantitate',0),(228720,6354,'et','Ringi, kuni kogu kogus',0),(228721,6354,'si','Okrogle do cela kol',0),(228722,6354,'ba','Putaran ke seluruh Qty',0),(228723,6354,'nl','Ronde tot hele Qty',0),(228724,6354,'fi','PyÃ¶ristÃ¤Ã¤ ylÃ¶spÃ¤in koko mÃ¤Ã¤rÃ¤',0),(228725,6354,'no','Runde opp hele antall',0),(228726,6354,'da','Runde op til hele Qty',0),(228727,6354,'ko','ì „ì²´ ìˆ˜ëŸ‰ê¹Œì§€ ë¼ìš´ë“œ',0),(228728,6354,'he','×¢×’×•×œ ×¢×“ ×›×ž×•×ª ×©×œ ×›×œ',0),(228729,6354,'el','Î“ÏÏÎ¿ Î¼Î­Ï‡ÏÎ¹ Î¿Î»ÏŒÎºÎ»Î·ÏÎ¿ Qty',0),(228730,6354,'zh','å››èˆäº”å…¥åˆ°å…¨ä½“æ•°é‡\r\n',0),(228731,6354,'sv','Runda upp till hela Kvt',0),(228732,6354,'it','Tondo fino a intero Qty',0),(228733,6354,'tl','',0),(228734,6354,'th','&#3627;&#3617;&#3640;&#3609;&#3586;&#3638;&#3657;&#3609;&#3652;&#3611;&#3626;&#3641;&#3656;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3588;&#3619;&#3610;&#3606;&#3657;&#3623;&#3609;',0),(228735,6354,'hi','à¤ªà¥‚à¤°à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¤à¤• à¤¦à¥Œà¤°',0),(228736,6354,'ms','Pusingan sehingga seluruh Qty',0),(228737,6354,'ar','Ø¬ÙˆÙ„Ø© Ø­ØªÙ‰ Ø§Ù„ÙƒÙ…ÙŠØ© ÙƒÙ„Ù‡Ø§',0),(228738,6354,'fr','Rond jusqu\'Ã  toute quantitÃ©',0),(228739,6354,'jp','ã?™ã?¹ã?¦ã?®æ•°é‡?ã‚’åˆ‡ã‚Šä¸Šã?’',0),(228740,6354,'pt','Rodada atÃ© todo Qty',0),(228741,6354,'ru','Ð Ð°ÑƒÐ½Ð´ Ð´Ð¾ Ð²ÑÐµÐ³Ð¾ ÑˆÑ‚',0),(228742,6354,'es','Redondear Arriba A Una Cantidad Entero',0),(228743,6354,'de','Runde bis zu ganzen Qty',0),(228744,6354,'en','Round Up To Whole Qty',0),(228745,6355,'is','',0),(228746,6355,'dr','ÙˆØ§Ø­Ø¯ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(228747,6355,'pr','ÙˆØ§Ø­Ø¯ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(228748,6355,'tr','Fiyat birimi baÅŸÄ±na satÄ±ÅŸ birimleri',0),(228749,6355,'pl','Jednostki sprzedaÅ¼y, cenÄ™ jednostkowÄ…',0),(228750,6355,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð°',0),(228751,6355,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù‚ÛŒÙ…Øª ÙØ±ÙˆØ®Øª ÛŒÙˆÙ†Ù¹Ø³',0),(228752,6355,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ñ†ÐµÐ½Ð°',0),(228753,6355,'vi','ÄÆ¡n vá»‹ bÃ¡n hÃ ng má»—i Ä‘Æ¡n vá»‹ giÃ¡',0),(228754,6355,'af','Verkoopseenhede Per Pryseenheid',0),(228755,6355,'ro','VÃ¢nzÄƒri de unitÄƒÅ£i Per unitate de pret',0),(228756,6355,'et','MÃ¼Ã¼giÃ¼hikute hinnaÃ¼hiku kohta',0),(228757,6355,'si','Prodajnih enot po ceni',0),(228758,6355,'ba','Penjualan unit Per harga Unit',0),(228759,6355,'nl','Verkoop eenheden Per prijs eenheid',0),(228760,6355,'fi','MyyntiyksikÃ¶iden hintayksikkÃ¶Ã¤ kohti',0),(228761,6355,'no','Salgsenheter Per prisenhet',0),(228762,6355,'da','Salgsenheder pr. prisenhed',0),(228763,6355,'ko','ê°€ê²© ë‹¨ìœ„ ë‹¹ íŒë§¤ ë‹¨ìœ„',0),(228764,6355,'he','×ž×›×™×¨×•×ª ×™×—×™×“×•×ª ×œ×›×œ ×™×—×™×“×ª ×ž×—×™×¨',0),(228765,6355,'el','ÎœÎ¿Î½Î¬Î´ÎµÏ‚ Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Ï„Î¹Î¼Î® Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(228766,6355,'zh','æ¯é”€å”®å•ä½ä»·æ ¼å•ä½\r\n',0),(228767,6355,'sv','FÃ¶rsÃ¤ljningsenheter Per prisenhet',0),(228768,6355,'it','UnitÃ  di vendita prezzo unitario',0),(228769,6355,'tl','',0),(228770,6355,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3634;&#3618;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(228771,6355,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤•à¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(228772,6355,'ms','Unit jualan seunit harga',0),(228773,6355,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø© Ø³Ø¹Ø±',0),(228774,6355,'fr','UnitÃ©s de vente par le prix d\'unitÃ©',0),(228775,6355,'jp','ä¾¡æ ¼å?˜ä½?ã?”ã?¨ã?®è²©å£²å?˜ä½?',0),(228776,6355,'pt','Unidades de vendas, preÃ§o unitÃ¡rio',0),(228777,6355,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ† Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ Ñ†ÐµÐ½Ñ‹',0),(228778,6355,'es','Unidades de Ventas Por Unidad de Precio',0),(228779,6355,'de','Verkaufseinheiten pro Preiseinheit',0),(228780,6355,'en','Sales Units Per Price Unit',0),(228781,6356,'is','',0),(228782,6356,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø²ÙŠÙ†Ù‡ ',0),(228783,6356,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø²ÙŠÙ†Ù‡ ',0),(228784,6356,'tr','SeÃ§eneÄŸi seÃ§in',0),(228785,6356,'pl','Wybierz opcjÄ™',0),(228786,6356,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ñ',0),(228787,6356,'ur','ÙˆÛ Ø§Ø®ØªÛŒØ§Ø± Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(228788,6356,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ',0),(228789,6356,'vi','Chá»n lá»±a chá»n',0),(228790,6356,'af','Kies opsie',0),(228791,6356,'ro','SelectaÅ£i opÅ£iunea',0),(228792,6356,'et','Valige variant',0),(228793,6356,'si','Izberite moÅ¾nost',0),(228794,6356,'ba','Pilih opsi',0),(228795,6356,'nl','Selecteer optie',0),(228796,6356,'fi','Valitse vaihtoehto',0),(228797,6356,'no','Velg alternativet',0),(228798,6356,'da','VÃ¦lg indstilling',0),(228799,6356,'ko','ì˜µì…˜ ì„ íƒ',0),(228800,6356,'he','×‘×—×¨ ××¤×©×¨×•×ª',0),(228801,6356,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î®',0),(228802,6356,'zh','é€‰æ‹©é€‰é¡¹\r\n',0),(228803,6356,'sv','VÃ¤lj alternativet',0),(228804,6356,'it','Selezionare l\'opzione',0),(228805,6356,'tl','',0),(228806,6356,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(228807,6356,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(228808,6356,'ms','Pilih opsyen',0),(228809,6356,'ar','Ø­Ø¯Ù‘Ø¯ Ø§Ù„Ø®ÙŠØ§Ø±',0),(228810,6356,'fr','SÃ©lectionnez l\'Option',0),(228811,6356,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?®é?¸æŠž',0),(228812,6356,'pt','Selecione a opÃ§Ã£o',0),(228813,6356,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚',0),(228814,6356,'es','Seleccionar OpciÃ³n',0),(228815,6356,'de','WÃ¤hlen Sie Option',0),(228816,6356,'en','Select Option',0),(228817,6357,'is','',0),(228818,6357,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡ ',0),(228819,6357,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡ ',0),(228820,6357,'tr','Grup SeÃ§ seÃ§eneÄŸi',0),(228821,6357,'pl','Wybierz opcjÄ™ Grupa',0),(228822,6357,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð³Ñ€ÑƒÐ¿Ð° Ð¾Ñ‚ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(228823,6357,'ur','Ù…Ù†ØªØ®Ø¨ Ø§Ø®ØªÛŒØ§Ø± Ú¯Ø±ÙˆÙ¾',0),(228824,6357,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð³Ñ€ÑƒÐ¿Ñƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(228825,6357,'vi','Chá»n nhÃ³m lá»±a chá»n',0),(228826,6357,'af','Selekteer Opsie Groep',0),(228827,6357,'ro','SelectaÅ£i opÅ£iunea de grup',0),(228828,6357,'et','Valige suvand Kontserni',0),(228829,6357,'si','Izberite moÅ¾nost skupine',0),(228830,6357,'ba','Pilih pilihan grup',0),(228831,6357,'nl','Selecteer optie groep',0),(228832,6357,'fi','Valitse vaihtoehtoryhmÃ¤',0),(228833,6357,'no','Velg gruppe',0),(228834,6357,'da','Marker indstillingsgruppe',0),(228835,6357,'ko','ì˜µì…˜ ê·¸ë£¹ ì„ íƒ',0),(228836,6357,'he','×‘×—×¨ ×‘××¤×©×¨×•×ª ×§×‘×•×¦×ª',0),(228837,6357,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¿Î¼Î¬Î´Î± ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(228838,6357,'zh','é€‰æ‹©é€‰é¡¹ç»„\r\n',0),(228839,6357,'sv','VÃ¤lj alternativet grupp',0),(228840,6357,'it','Selezionare opzione gruppo',0),(228841,6357,'tl','',0),(228842,6357,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(228843,6357,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤®à¥‚à¤¹ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(228844,6357,'ms','Pilih pilihan Kumpulan',0),(228845,6357,'ar','Ø­Ø¯Ù‘Ø¯ Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª',0),(228846,6357,'fr','SÃ©lectionnez Option Group',0),(228847,6357,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚°ãƒ«ãƒ¼ãƒ—ã?®é?¸æŠž',0),(228848,6357,'pt','Selecionar opÃ§Ã£o de grupo',0),(228849,6357,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ Ð“Ñ€ÑƒÐ¿Ð¿Ð°',0),(228850,6357,'es','Seleccionar Grupo de Opciones',0),(228851,6357,'de','Option Gruppe auswÃ¤hlen',0),(228852,6357,'en','Select Option Group',0),(228853,6358,'is','',0),(228854,6358,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù„Ø§ ',0),(228855,6358,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù„Ø§ ',0),(228856,6358,'tr','Ã–ÄŸesini kullanma',0),(228857,6358,'pl','UÅ¼yj elementu',0),(228858,6358,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(228859,6358,'ur','Ø´Û’ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(228860,6358,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(228861,6358,'vi','Sá»­ dá»¥ng hÃ ng',0),(228862,6358,'af','Gebruik Item',0),(228863,6358,'ro','UtilizaÅ£i element',0),(228864,6358,'et','Kasutusega kauba',0),(228865,6358,'si','Uporabite element',0),(228866,6358,'ba','Menggunakan Item',0),(228867,6358,'nl','Opdracht',0),(228868,6358,'fi','KÃ¤ytÃ¤',0),(228869,6358,'no','Bruk',0),(228870,6358,'da','Brug elementet',0),(228871,6358,'ko','í•­ëª©ì„ ì‚¬ìš© í•˜ ì—¬',0),(228872,6358,'he','×”×©×ª×ž×© ×‘×¤×¨×™×˜',0),(228873,6358,'el','Î•Î¯Î´Î¿Ï‚ Ï‡ÏÎ®ÏƒÎ·Ï‚',0),(228874,6358,'zh','ä½¿ç”¨é¡¹ç›®\r\n',0),(228875,6358,'sv','AnvÃ¤ndningsomrÃ¥den',0),(228876,6358,'it','Utilizzare l\'elemento',0),(228877,6358,'tl','',0),(228878,6358,'th','&#3651;&#3594;&#3657;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(228879,6358,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(228880,6358,'ms','Menggunakan Item',0),(228881,6358,'ar','Ø¥Ø³ØªØ®Ø¯Ù… Ø§Ù„ØµÙ‘Ù†Ù',0),(228882,6358,'fr','Utilisez l\'Ã©lÃ©ment',0),(228883,6358,'jp','ä½¿ç”¨å“?ç›®',0),(228884,6358,'pt','Use o Item',0),(228885,6358,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€',0),(228886,6358,'es','Usar Item',0),(228887,6358,'de','Verwenden Sie',0),(228888,6358,'en','Use Item',0),(228889,6359,'is','',0),(228890,6359,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ù„Ø§',0),(228891,6359,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ù„Ø§',0),(228892,6359,'tr','Ã–ÄŸe bilgisi kullanma',0),(228893,6359,'pl','UÅ¼yj elementu informacji',0),(228894,6359,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(228895,6359,'ur','Ø´Û’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(228896,6359,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÑƒ Ð˜Ð½Ñ„Ð¾',0),(228897,6359,'vi','Sá»­ dung ThÃ´ng Tin hÃ ng',0),(228898,6359,'af','Gebruik Item Inligting',0),(228899,6359,'ro','UtilizaÅ£i element Info',0),(228900,6359,'et','Kasutada kauba Info',0),(228901,6359,'si','Uporabite element Info',0),(228902,6359,'ba','Menggunakan Item Info',0),(228903,6359,'nl','Item Info gebruiken',0),(228904,6359,'fi','KÃ¤ytÃ¤ kohteen tiedot',0),(228905,6359,'no','Bruke elementet Info',0),(228906,6359,'da','Brug elementet Info',0),(228907,6359,'ko','í•­ëª© ì •ë³´ë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(228908,6359,'he','×”×©×ª×ž×© ×‘×¤×¨×™×˜ ×¤×¨×˜×™',0),(228909,6359,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(228910,6359,'zh','ä½¿ç”¨é¡¹ç›®ä¿¡æ¯\r\n',0),(228911,6359,'sv','AnvÃ¤nd objektet Info',0),(228912,6359,'it','Utilizzare la voce Info',0),(228913,6359,'tl','',0),(228914,6359,'th','&#3651;&#3594;&#3657;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(228915,6359,'hi','à¤†à¤‡à¤Ÿà¤® à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(228916,6359,'ms','Penggunaan butiran maklumat',0),(228917,6359,'ar','Ø¥Ø³ØªØ®Ø¯Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØµÙ‘Ù†Ù',0),(228918,6359,'fr','Utilisation du point Info',0),(228919,6359,'jp','ä½¿ç”¨å“?ç›®æƒ…å ±',0),(228920,6359,'pt','Use a informaÃ§Ã£o do Item',0),(228921,6359,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ðž Ð¢Ð¾Ð²Ð°Ñ€Ðµ',0),(228922,6359,'es','Usar Info de Item',0),(228923,6359,'de','Verwenden Sie Element-Info',0),(228924,6359,'en','Use Item Info',0),(228925,6360,'is','',0),(228926,6360,'dr','Ù…Ù‚Ø¯Ø§Ø±  Ø¨Ø§ÙŠØ¯ Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø­Ø¯Ø§Ù‚Ù„ â€“ Ø­Ø¯Ø§ÙƒØ«Ø± Ø¨Ø§Ø´Ø¯ ',0),(228927,6360,'pr','Ù…Ù‚Ø¯Ø§Ø±  Ø¨Ø§ÙŠØ¯ Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø­Ø¯Ø§Ù‚Ù„ â€“ Ø­Ø¯Ø§ÙƒØ«Ø± Ø¨Ø§Ø´Ø¯ ',0),(228928,6360,'tr','DeÄŸer min-max aralÄ±ÄŸÄ±nda olmalÄ±dÄ±r.',0),(228929,6360,'pl','WartoÅ›Ä‡ musi byÄ‡ w zakresie min-max.',0),(228930,6360,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð² Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð° Ð¼Ð¸Ð½.-ÐœÐ°ÐºÑ.',0),(228931,6360,'ur','Ù‚Ø¯Ø± Ú©Ù… Ø§Ø² Ú©Ù…-Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…ÛŒÚº Ù†ÛÛŒÚº ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒÛ’ Û”',0),(228932,6360,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ñƒ Ð¾Ð¿ÑÐµÐ³Ñƒ Ð¾Ð´ Ð¼Ð¸Ð½-Ð¼Ð°x.',0),(228933,6360,'vi','GiÃ¡ trá»‹ pháº£i trong pháº¡m vi tá»‘i thiá»ƒu - tá»‘i Ä‘a',0),(228934,6360,'af','Waarde moet wees in die min-max reeks.',0),(228935,6360,'ro','Valoarea trebuie sÄƒ fie Ã®n intervalul de min-max.',0),(228936,6360,'et','VÃ¤Ã¤rtus peab olema vahemikus min-max.',0),(228937,6360,'si','Vrednost mora biti v obmoÄju min-max.',0),(228938,6360,'ba','Nilai harus dalam kisaran min-max.',0),(228939,6360,'nl','Waarde moet liggen in het bereik min-max.',0),(228940,6360,'fi','Arvon on oltava min-max-alueella.',0),(228941,6360,'no','Verdien mÃ¥ vÃ¦re i min-maks omrÃ¥det.',0),(228942,6360,'da','VÃ¦rdien skal vÃ¦re i min-max interval.',0),(228943,6360,'ko','ê°’ì€ ìµœì†Œ-ìµœëŒ€ ë²”ìœ„ì— ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(228944,6360,'he','×”×¢×¨×š ×—×™×™×‘ ×œ×”×™×•×ª ×‘×˜×•×•×— min-max.',0),(228945,6360,'el','Î¤Î¹Î¼Î® Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÏƒÏ„Î·Î½ Ï€ÎµÏÎ¹Î¿Ï‡Î® min-max.',0),(228946,6360,'zh','å€¼å¿…é¡»åœ¨æœ€å°åˆ°æœ€å¤§èŒƒå›´å†…ã€‚\r\n',0),(228947,6360,'sv','VÃ¤rdet mÃ¥ste vara i intervallet min-max.',0),(228948,6360,'it','Valore deve essere nel range min-max.',0),(228949,6360,'tl','',0),(228950,6360,'th','&#3588;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3594;&#3656;&#3623;&#3591;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;-&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(228951,6360,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤®à¤¿à¤¨-à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¥€à¤®à¤¾ à¤®à¥‡à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(228952,6360,'ms','Nilai mestilah dalam julat min-max.',0),(228953,6360,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙƒÙˆÙ† Ø§Ù„Ù‚ÙŠÙ…Ø© ÙÙŠ Ø­Ø¯ÙˆØ¯ Ø¯Ù‚ÙŠÙ‚Ø©-Ù…Ø§ÙƒØ³.',0),(228954,6360,'fr','Valeur doit Ãªtre dans la fourchette mini-maxi.',0),(228955,6360,'jp','ä¾¡å€¤ã?¯æœ€ä½Žã?‹ã‚‰æœ€é«˜ã?®ç¯„å›²å†…ã?§ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(228956,6360,'pt','Valor deve estar no intervalo mÃ­n-mÃ¡x.',0),(228957,6360,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ð² Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ðµ min-max.',0),(228958,6360,'es','Valor debe estar en el rango de min-max',0),(228959,6360,'de','Wert muss im Bereich von min-Max.',0),(228960,6360,'en','Value must be in the min-max range.',0),(228961,6361,'is','',0),(228962,6361,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(228963,6361,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(228964,6361,'tr','Bir ad girmeniz gerekir.',0),(228965,6361,'pl','NaleÅ¼y wprowadziÄ‡ nazwÄ™.',0),(228966,6361,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ.',0),(228967,6361,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§ÛŒÚ© Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’ Û”',0),(228968,6361,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð¼Ðµ.',0),(228969,6361,'vi','Báº¡n pháº£i nháº­p 1 tÃªn',0),(228970,6361,'af','U moet \'n naam invoer',0),(228971,6361,'ro','Trebuie sa introduceti un nume',0),(228972,6361,'et','Te peate sisestama nime',0),(228973,6361,'si','Vnesti morate ime.',0),(228974,6361,'ba','Anda harus memasukkan nama.',0),(228975,6361,'nl','U moet een naam invoeren.',0),(228976,6361,'fi','Kirjoita nimi.',0),(228977,6361,'no','Du mÃ¥ angi et navn.',0),(228978,6361,'da','Du skal angive et navn.',0),(228979,6361,'ko','ì´ë¦„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(228980,6361,'he','×¢×œ×™×š ×œ×”×›× ×™×¡ ×©×',0),(228981,6361,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î±.',0),(228982,6361,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªåç§°ã€‚\r\n',0),(228983,6361,'sv','Du mÃ¥ste ange ett namn.',0),(228984,6361,'it','Ãˆ necessario immettere un nome.',0),(228985,6361,'tl','',0),(228986,6361,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3619;&#3629;&#3585;&#3594;&#3639;&#3656;&#3629;',0),(228987,6361,'hi','à¤†à¤ª à¤à¤• à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(228988,6361,'ms','Anda harus masukkan nama.',0),(228989,6361,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ¯Ø®Ù„ Ø¥Ø³Ù…Ø§',0),(228990,6361,'fr','Vous devez entrer un nom.',0),(228991,6361,'jp','å??å‰?ã‚’å…¥åŠ›ã?—ã?¦ã??ã? ã?•ã?„',0),(228992,6361,'pt','VocÃª deve digitar um nome.',0),(228993,6361,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ.',0),(228994,6361,'es','Debe introducir un nombre',0),(228995,6361,'de','Sie mÃ¼ssen einen Namen eingeben.',0),(228996,6361,'en','You must enter a name.',0),(228997,6362,'is','',0),(228998,6362,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡',0),(228999,6362,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡',0),(229000,6362,'tr','Ajan arama',0),(229001,6362,'pl','Agenta wyszukiwania',0),(229002,6362,'bg','ÐÐ³ÐµÐ½Ñ‚ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(229003,6362,'ur','Ø§ÛŒØ¬Ù†Ù¹ Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(229004,6362,'sr','ÐÐ³ÐµÐ½Ñ‚Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(229005,6362,'vi','TÃ¬m Äáº¡i LÃ½',0),(229006,6362,'af','Agent opsoek',0),(229007,6362,'ro','Agent de cÄƒutare',0),(229008,6362,'et','Agent otsing',0),(229009,6362,'si','Agent za iskanje',0),(229010,6362,'ba','Agen Lookup',0),(229011,6362,'nl','Agent Lookup',0),(229012,6362,'fi','Agentti haku',0),(229013,6362,'no','Agent oppslag',0),(229014,6362,'da','Agent opslag',0),(229015,6362,'ko','ì—ì´ì „íŠ¸ ì¡°íšŒ',0),(229016,6362,'he','×—×™×¤×•×© ×¡×•×›×Ÿ',0),(229017,6362,'el','Î ÏÎ¬ÎºÏ„Î¿ÏÎ±Ï‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(229018,6362,'zh','ä»£ç†æŸ¥è¯¢\r\n',0),(229019,6362,'sv','Agent-sÃ¶kning',0),(229020,6362,'it','Ricerca agente',0),(229021,6362,'tl','',0),(229022,6362,'th','&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;&#3627;&#3634;',0),(229023,6362,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ à¤²à¥à¤•à¤…à¤ª',0),(229024,6362,'ms','Carian ejen',0),(229025,6362,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† ÙˆÙƒÙŠÙ„',0),(229026,6362,'fr','Recherche d\'agent',0),(229027,6362,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆå?‚ç…§',0),(229028,6362,'pt','Agente pesquisa',0),(229029,6362,'ru','ÐŸÐ¾Ð¸ÑÐº Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(229030,6362,'es','Agente Buscar',0),(229031,6362,'de','Agent-Lookup',0),(229032,6362,'en','Agent Lookup',0),(229033,6363,'is','',0),(229034,6363,'dr','Ù†Ø§Ù… Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡',0),(229035,6363,'pr','Ù†Ø§Ù… Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡',0),(229036,6363,'tr','AracÄ± adÄ±',0),(229037,6363,'pl','ImiÄ™ i nazwisko peÅ‚nomocnika',0),(229038,6363,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð°Ð³ÐµÐ½Ñ‚',0),(229039,6363,'ur','Ø§ÛŒØ¬Ù†Ù¹ Ú©Ø§ Ù†Ø§Ù…',0),(229040,6363,'sr','Ð˜Ð¼Ðµ Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(229041,6363,'vi','TÃªn Äáº¡i LÃ½',0),(229042,6363,'af','Agent Naam',0),(229043,6363,'ro','Agent de nume',0),(229044,6363,'et','Maksja nimi',0),(229045,6363,'si','Agent ime',0),(229046,6363,'ba','Nama agen',0),(229047,6363,'nl','Agent naam',0),(229048,6363,'fi','Agentin nimi',0),(229049,6363,'no','Agentnavn',0),(229050,6363,'da','Agent navn',0),(229051,6363,'ko','ì—ì´ì „íŠ¸ ì´ë¦„',0),(229052,6363,'he','×©× ×¡×•×›×Ÿ',0),(229053,6363,'el','ÎŸÎ½Î¿Î¼Î±ÏƒÎ¯Î± ÏƒÏ…Î½Ï„Î·ÏÎ·Ï„Î®',0),(229054,6363,'zh','ä»£ç†åç§°\r\n',0),(229055,6363,'sv','Agent namn',0),(229056,6363,'it','Nome agente',0),(229057,6363,'tl','',0),(229058,6363,'th','&#3594;&#3639;&#3656;&#3629;&#3586;&#3629;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(229059,6363,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(229060,6363,'ms','Nama ejen',0),(229061,6363,'ar','Ø¥Ø³Ù… Ø§Ù„ÙˆÙƒÙŠÙ„',0),(229062,6363,'fr','Nom de l\'agent',0),(229063,6363,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆå??',0),(229064,6363,'pt','Nome do agente',0),(229065,6363,'ru','Ð˜Ð¼Ñ Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(229066,6363,'es','Agente Nombre',0),(229067,6363,'de','Agentname',0),(229068,6363,'en','Agent Name',0),(229069,6364,'is','',0),(229070,6364,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(229071,6364,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(229072,6364,'tr','SatÄ±cÄ± arama bilgileri',0),(229073,6364,'pl','Dostawcy wyszukiwania informacji',0),(229074,6364,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(229075,6364,'ur','ÙˆÛŒÙ†ÚˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªÙ„Ø§Ø´',0),(229076,6364,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°',0),(229077,6364,'vi','ThÃ´ng Tin tÃ¬m ngÆ°á»i bÃ¡n',0),(229078,6364,'af','Verskaffer Soektog Inligting',0),(229079,6364,'ro','InformaÅ£ii de cÄƒutare furnizor',0),(229080,6364,'et','Otsi hankijateabe',0),(229081,6364,'si','Prodajalec iskanje informacij',0),(229082,6364,'ba','Cari informasi vendor',0),(229083,6364,'nl','Leverancier zoekinformatie',0),(229084,6364,'fi','Toimittajatietojen hakeminen',0),(229085,6364,'no','SÃ¸k leverandÃ¸rinformasjon',0),(229086,6364,'da','SÃ¸g kreditoroplysninger',0),(229087,6364,'ko','ê³µê¸‰ ì—…ì²´ ê²€ìƒ‰ ì •ë³´',0),(229088,6364,'he','×¡×¤×§ ×—×™×¤×•×© ×ž×™×“×¢',0),(229089,6364,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(229090,6364,'zh','ä¾›åº”å•†æœç´¢ä¿¡æ¯\r\n',0),(229091,6364,'sv','SÃ¶k leverantÃ¶rsinformation',0),(229092,6364,'it','Informazioni di ricerca fornitore',0),(229093,6364,'tl','',0),(229094,6364,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(229095,6364,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤–à¥‹à¤œ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(229096,6364,'ms','Pembekal carian maklumat',0),(229097,6364,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ù…ÙˆØ±Ø¯',0),(229098,6364,'fr','Informations de recherche de fournisseur',0),(229099,6364,'jp','æ¥­è€…æ¤œç´¢æƒ…å ±',0),(229100,6364,'pt','Fornecedor de informaÃ§Ãµes de pesquisa',0),(229101,6364,'ru','ÐŸÐ¾Ð¸ÑÐº Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(229102,6364,'es','Proveedor InformaciÃ³n de Busqueda',0),(229103,6364,'de','Suche Herstellerinformationen',0),(229104,6364,'en','Vendor Search Information',0),(229105,6365,'is','',0),(229106,6365,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(229107,6365,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(229108,6365,'tr','SatÄ±cÄ± arama',0),(229109,6365,'pl','Dostawcy wyszukiwania',0),(229110,6365,'bg','Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(229111,6365,'ur','ÙˆÛŒÙ†ÚˆØ± Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(229112,6365,'sr','Ð—Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(229113,6365,'vi','TÃ¬m NgÆ°á»i bÃ¡n',0),(229114,6365,'af','Handelaar opsoek',0),(229115,6365,'ro','CÄƒutare distribuitor',0),(229116,6365,'et','MÃ¼Ã¼ja otsing',0),(229117,6365,'si','Iskanje dobavitelja',0),(229118,6365,'ba','Penjual Lookup',0),(229119,6365,'nl','Leverancier zoeken',0),(229120,6365,'fi','Toimittajan valinta',0),(229121,6365,'no','LeverandÃ¸ren oppslag',0),(229122,6365,'da','Kreditor opslag',0),(229123,6365,'ko','ê³µê¸‰ ì—…ì²´ ì¡°íšŒ',0),(229124,6365,'he','×—×™×¤×•×© ×¡×¤×§',0),(229125,6365,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½',0),(229126,6365,'zh','ä¾›åº”å•†æŸ¥æ‰¾\r\n',0),(229127,6365,'sv','LeverantÃ¶r-sÃ¶kning',0),(229128,6365,'it','Ricerca fornitore',0),(229129,6365,'tl','',0),(229130,6365,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(229131,6365,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤²à¥à¤•à¤…à¤ª',0),(229132,6365,'ms','Penjual Lookup',0),(229133,6365,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ù…ÙˆØ±Ø¯',0),(229134,6365,'fr','Recherche de fournisseur',0),(229135,6365,'jp','æ¥­è€…å?‚ç…§',0),(229136,6365,'pt','Pesquisa de fornecedores',0),(229137,6365,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(229138,6365,'es','Proveedor Busqueda ',0),(229139,6365,'de','Kreditor-Lookup',0),(229140,6365,'en','Vendor Lookup',0),(229141,6366,'is','',0),(229142,6366,'dr','Ø´Ø±Ø­ ÙƒØ§Ù„Ø§ ÙŠØ§ ÙƒØ¯ ',0),(229143,6366,'pr','Ø´Ø±Ø­ ÙƒØ§Ù„Ø§ ÙŠØ§ ÙƒØ¯ ',0),(229144,6366,'tr','Ã–ÄŸe aÃ§Ä±klamasÄ± veya kodu',0),(229145,6366,'pl','Opis przedmiotu lub kod',0),(229146,6366,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð° Ð¸Ð»Ð¸ ÐºÐ¾Ð´Ð°',0),(229147,6366,'ur','Ø´Û’ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª ÛŒØ§ Ú©ÙˆÚˆ',0),(229148,6366,'sr','ÐžÐ¿Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¸Ð»Ð¸ Ð¨Ð¸Ñ„Ñ€Ð°',0),(229149,6366,'vi','MÃ´ táº£ hÃ ng hay MÃ£',0),(229150,6366,'af','Item Beskrywing of Kode',0),(229151,6366,'ro','Descriere element sau codul',0),(229152,6366,'et','Toote kirjeldus vÃµi kood',0),(229153,6366,'si','Opis artikla ali kodo',0),(229154,6366,'ba','Deskripsi item atau kode',0),(229155,6366,'nl','Objectbeschrijving uitbreiden of Code',0),(229156,6366,'fi','Kohteen kuvaus tai koodi',0),(229157,6366,'no','Varebeskrivelsen eller kode',0),(229158,6366,'da','Varebeskrivelse eller kode',0),(229159,6366,'ko','í•­ëª© ì„¤ëª… ë˜ëŠ” ì½”ë“œ',0),(229160,6366,'he','×§×•×“ ××• ×ª×™××•×¨ ×¤×¨×™×˜',0),(229161,6366,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î® ÎºÏŽÎ´Î¹ÎºÎ±',0),(229162,6366,'zh','é¡¹ç›®è¯´æ˜Žæˆ–ä»£ç \r\n',0),(229163,6366,'sv','Beskrivning eller kod',0),(229164,6366,'it','Codice o Descrizione articolo',0),(229165,6366,'tl','',0),(229166,6366,'th','&#3619;&#3627;&#3633;&#3626; &#3627;&#3619;&#3639;&#3629; &#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(229167,6366,'hi','à¤®à¤¦ à¤µà¤¿à¤µà¤°à¤£ à¤¯à¤¾ à¤•à¥‹à¤¡',0),(229168,6366,'ms','Keterangan item atau kod',0),(229169,6366,'ar','Ø¨ÙŠÙ€Ø§Ù† Ø£Ùˆ Ø±Ù…Ø² Ø§Ù„ØµÙ†Ù',0),(229170,6366,'fr','Description de l\'objet ou de Code',0),(229171,6366,'jp','å“?ç›®å??å?ˆã?¯ã‚³ãƒ¼ãƒ‰',0),(229172,6366,'pt','CÃ³digo ou descriÃ§Ã£o do item',0),(229173,6366,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ð° Ð¸Ð»Ð¸ ÐšÐ¾Ð´',0),(229174,6366,'es','Item Nombre o CÃ³digo',0),(229175,6366,'de','Artikelbeschreibung oder Code',0),(229176,6366,'en','Item Description or Code',0),(229177,6367,'is','',0),(229178,6367,'dr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§ ',0),(229179,6367,'pr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§ ',0),(229180,6367,'tr','Madde arama bilgilerini girin',0),(229181,6367,'pl','WprowadÅº element wyszukiwania informacji',0),(229182,6367,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(229183,6367,'ur','Ø´Û’ ØªÙ„Ø§Ø´ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(229184,6367,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÑƒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(229185,6367,'vi','Nháº­p thÃ´ng tin dá»¯ liá»‡u hÃ ng',0),(229186,6367,'af','Voer Inligting vir Gesoekte Items in',0),(229187,6367,'ro','IntroduceÅ£i elementul CÄƒutaÅ£i informaÅ£ii',0),(229188,6367,'et','Otsi teabe sisestamine',0),(229189,6367,'si','Vnesite element iskanje informacij',0),(229190,6367,'ba','Masukkan Item pencarian informasi',0),(229191,6367,'nl','Voer Item zoekinformatie',0),(229192,6367,'fi','Kirjoita nimike tietojen hakeminen',0),(229193,6367,'no','Angi sÃ¸keinformasjon',0),(229194,6367,'da','Angiv sÃ¸geoplysninger',0),(229195,6367,'ko','í•­ëª© ê²€ìƒ‰ ì •ë³´ ìž…ë ¥',0),(229196,6367,'he','×”×–×Ÿ ×¤×¨×™×˜ ×—×™×¤×•×© ×ž×™×“×¢',0),(229197,6367,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(229198,6367,'zh','è¾“å…¥äº§å“æœç´¢ä¿¡æ¯',0),(229199,6367,'sv','Ange objekt sÃ¶kinformation',0),(229200,6367,'it','Inserisci elemento Cerca informazioni',0),(229201,6367,'tl','',0),(229202,6367,'th','&#3611;&#3657;&#3629;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(229203,6367,'hi','à¤†à¤‡à¤Ÿà¤® à¤–à¥‹à¤œ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(229204,6367,'ms','Masukkan carian maklumat Item',0),(229205,6367,'ar','Ø£Ø¯Ø®Ù„ Ø¹Ù†ØµØ± Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(229206,6367,'fr','Entrez point recherche dâ€™Information',0),(229207,6367,'jp','å“?ç›®æ¤œç´¢æƒ…å ±ã?®å…¥åŠ›',0),(229208,6367,'pt','Artigo inserir informaÃ§Ãµes de pesquisa',0),(229209,6367,'ru','Ð’Ð²ÐµÑÑ‚Ð¸ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ ÐŸÐ¾Ð¸ÑÐºÐ° Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(229210,6367,'es','Introducir InformaciÃ³n de Busqueda del Item',0),(229211,6367,'de','Geben Sie Artikel Suche Informationen',0),(229212,6367,'en','Enter Item Search Information',0),(229213,6368,'is','',0),(229214,6368,'dr','Ú¯Ø±ÙˆÙ‡ ÙƒÙ„ÙŠ',0),(229215,6368,'pr','Ú¯Ø±ÙˆÙ‡ ÙƒÙ„ÙŠ',0),(229216,6368,'tr','Genel kategori',0),(229217,6368,'pl','Kategoria ogÃ³lna',0),(229218,6368,'bg','ÐžÐ±Ñ‰Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(229219,6368,'ur','Ø¬Ù†Ø±Ù„ Ø²Ù…Ø±Û',0),(229220,6368,'sr','ÐžÐ¿ÑˆÑ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(229221,6368,'vi','Thá»ƒ loáº¡i chung',0),(229222,6368,'af','Algemene Kategorie',0),(229223,6368,'ro','General categorie',0),(229224,6368,'et','Ãœldine kategooria',0),(229225,6368,'si','SploÅ¡ne kategorije',0),(229226,6368,'ba','General Category',0),(229227,6368,'nl','Algemene categorie',0),(229228,6368,'fi','Yleinen luokka',0),(229229,6368,'no','Generell kategori',0),(229230,6368,'da','Generelle kategori',0),(229231,6368,'ko','ì¼ë°˜ ë²”ì£¼',0),(229232,6368,'he','×§×˜×’×•×¨×™×” ×›×œ×œ×™',0),(229233,6368,'el','Î“ÎµÎ½Î¹ÎºÎ® ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(229234,6368,'zh','æ™®é€šç±»\r\n',0),(229235,6368,'sv','AllmÃ¤nna kategori',0),(229236,6368,'it','Categoria generale',0),(229237,6368,'tl','',0),(229238,6368,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(229239,6368,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(229240,6368,'ms','Kategori umum',0),(229241,6368,'ar','Ø§Ù„ÙØ¦Ø© Ø§Ù„Ø¹Ø§Ù…Ø©',0),(229242,6368,'fr','GENERAUX',0),(229243,6368,'jp','ä¸€èˆ¬ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(229244,6368,'pt','Categoria geral',0),(229245,6368,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð°Ñ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(229246,6368,'es','CategorÃ­a General',0),(229247,6368,'de','Kategorie Allgemein',0),(229248,6368,'en','General Category',0),(229249,6369,'is','',0),(229250,6369,'dr','ÙƒØ§Ù„Ø§ÙŠ ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(229251,6369,'pr','ÙƒØ§Ù„Ø§ÙŠ ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(229252,6369,'tr','AlÄ±ÅŸveriÅŸ sepeti madde',0),(229253,6369,'pl','Zakupy koszyka towaru',0),(229254,6369,'bg','ÐŸÐ°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ ÐºÐ¾ÑˆÐ½Ð¸Ñ†Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(229255,6369,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ø´Û’',0),(229256,6369,'sr','ÐšÑƒÐ¿Ð¾Ð²Ð¸Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ†Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(229257,6369,'vi','HÃ ng HÃ³a Cá»§a Giá» HÃ ng',0),(229258,6369,'af','Winkeltrollie Item',0),(229259,6369,'ro','Element de coÅŸ de cumpÄƒrÄƒturi',0),(229260,6369,'et','Shopping ostukorvi Ã¼ksus',0),(229261,6369,'si','Nakupovalni voziÄek element',0),(229262,6369,'ba','Item keranjang belanja',0),(229263,6369,'nl','Shopping Cart Item',0),(229264,6369,'fi','Shopping Cart kohde',0),(229265,6369,'no','Shopping Cart element',0),(229266,6369,'da','Shopping Cart vare',0),(229267,6369,'ko','ì‡¼í•‘ ì¹´íŠ¸ í•­ëª©',0),(229268,6369,'he','×¤×¨×™×˜ ×¢×’×œ×ª ×§× ×™×•×ª',0),(229269,6369,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÎ±Î»Î¬Î¸Î¹ Î±Î³Î¿ÏÏŽÎ½',0),(229270,6369,'zh','è´­ç‰©è½¦ä¸­ç‰©å“\r\n',0),(229271,6369,'sv','Shopping Cart objekt',0),(229272,6369,'it','Shopping Cart Item',0),(229273,6369,'tl','',0),(229274,6369,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3606;&#3648;&#3586;&#3655;&#3609;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(229275,6369,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤†à¤‡à¤Ÿà¤®',0),(229276,6369,'ms','Shopping Cart Item',0),(229277,6369,'ar','ØµÙ†Ù Ø³Ù„Ù‘Ø© Ø§Ù„ØªØ³ÙˆÙ‘Ù‚',0),(229278,6369,'fr','Shopping Cart point',0),(229279,6369,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°ã‚«ãƒ¼ãƒˆå“?ç›®',0),(229280,6369,'pt','Item do carrinho de compras',0),(229281,6369,'ru','Ð¢Ð¾Ñ€Ð³Ð¾Ð²Ñ‹Ðµ ÐºÐ¾Ñ€Ð·Ð¸Ð½Ñ‹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(229282,6369,'es','Carrito de Compras Item',0),(229283,6369,'de','Shopping Cart-Element',0),(229284,6369,'en','Shopping Cart Item',0),(229285,6370,'is','',0),(229286,6370,'dr','Ú¯Ø²ÙŠÙ†Ø´ Ø¢Ø²Ø§Ø¯ ØªÙ…Ø§Ù… Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø±Ø§ Ù†Ø´Ø§Ù† Ø®ÙˆØ§Ù‡Ø¯ Ø¯Ø§Ø¯ ',0),(229287,6370,'pr','Ú¯Ø²ÙŠÙ†Ø´ Ø¢Ø²Ø§Ø¯ ØªÙ…Ø§Ù… Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø±Ø§ Ù†Ø´Ø§Ù† Ø®ÙˆØ§Ù‡Ø¯ Ø¯Ø§Ø¯ ',0),(229288,6370,'tr','AÃ§Ä±k seÃ§im tÃ¼m tarih aralÄ±klarÄ±nÄ± gÃ¶sterir',0),(229289,6370,'pl','WybÃ³r otwarty pokaÅ¼e siÄ™ z Wszystkie zakresy dat',0),(229290,6370,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½ Ð¸Ð·Ð±Ð¾Ñ€ Ñ‰Ðµ Ð¿Ð¾ÐºÐ°Ð¶Ðµ Ð¾Ñ‚ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸ Ð½Ð° Ð²Ð°Ð»Ð¸Ð´Ð½Ð¾ÑÑ‚',0),(229291,6370,'ur','Ú©Ú¾Ù„ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©ÛŒ ØªÙ…Ø§Ù… Ø­Ø¯ÙˆØ¯ Ø³Û’ Ø¯Ú©Ú¾Ø§Ø¦Û’ Ú¯Ø§',0),(229292,6370,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð° ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ˜Ð° Ñ›Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ð¸Ð· ÑÐ²Ð¸Ñ… Ð¾Ð¿ÑÐµÐ³Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(229293,6370,'vi','Má»Ÿ lá»±a chá»n sáº½ hiá»ƒn thá»‹ táº¥t cáº£ pháº¡m vi dá»¯ liá»‡u',0),(229294,6370,'af','Oop seleksie sal wys vanuit alle datumreekse',0),(229295,6370,'ro','Deschis de selecÅ£ie va arÄƒta la toate gamele de data',0),(229296,6370,'et','Avatud valik nÃ¤itab kÃµiki KuupÃ¤evavahemikud',0),(229297,6370,'si','Odprt izbor bo pokazal iz vseh intervalov datuma',0),(229298,6370,'ba','Buka pilihan akan menunjukkan dari semua rentang tanggal',0),(229299,6370,'nl','Open selectie zal tonen uit alle periodes',0),(229300,6370,'fi','Avaa valinta nÃ¤yttÃ¤Ã¤ kaikki pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤vÃ¤lit',0),(229301,6370,'no','Ã…pne valg vises fra alle datoperioder',0),(229302,6370,'da','Ã…ben udvÃ¦lgelse vil vise fra alle datointervaller',0),(229303,6370,'ko','ì—´ê¸° ì„ íƒ ëª¨ë“  ë‚ ì§œ ë²”ìœ„ì—ì„œ í‘œì‹œ ë©ë‹ˆë‹¤.',0),(229304,6370,'he','×”×‘×—×™×¨×” ×¤×ª×•×— ×™×¨××” ×ž×˜×•×•×—×™ ×ª××¨×™×š ×›×œ',0),(229305,6370,'el','Î‘Î½Î¿Î¹ÎºÏ„Î®Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚ Î¸Î± Î´ÎµÎ¯Î¾ÎµÎ¹ Î±Ï€ÏŒ ÏŒÎ»Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½',0),(229306,6370,'zh','å¼€æ”¾é€‰é¡¹å°†ä¼šæ˜¾ç¤ºåœ¨æ‰€æœ‰çš„æ—¥æœŸèŒƒå›´ä¸­\r\n',0),(229307,6370,'sv','Ã–ppna val visas frÃ¥n alla datumintervall',0),(229308,6370,'it','Selezione aperta mostrerÃ  da tutti gli intervalli di date',0),(229309,6370,'tl','',0),(229310,6370,'th','&#3648;&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3592;&#3632;&#3649;&#3626;&#3604;&#3591;&#3592;&#3634;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3',0),(229311,6370,'hi','à¤–à¥à¤²à¤¾ à¤šà¤¯à¤¨ à¤¸à¤­à¥€ à¤¤à¤¿à¤¥à¤¿ à¤¸à¥€à¤®à¤¾à¤“à¤‚ à¤¸à¥‡ à¤¦à¤¿à¤–à¤¾ à¤¦à¥‡à¤‚à¤—à¥‡',0),(229312,6370,'ms','Pemilihan terbuka akan menunjukkan dari semua julat tarikh',0),(229313,6370,'ar','Ø³ÙˆÙ ØªØ¸Ù‡Ø± Ø§Ø®ØªÙŠØ§Ø± Ù…ÙØªÙˆØ­Ø© Ù…Ù† Ø¬Ù…ÙŠØ¹ Ù†Ø·Ø§Ù‚Ø§Øª ØªØ§Ø±ÙŠØ®',0),(229314,6370,'fr','Ouvrir la sÃ©lection montrera de toutes les plages de dates',0),(229315,6370,'jp','å…¨ã?¦ã?®ãƒ‡ãƒ¼ã‚¿ç¯„å›²ã?‹ã‚‰ã‚ªãƒ¼ãƒ—ãƒ³é?¸æŠžè‚¢ã‚’è¡¨ç¤ºã?•ã?›ã‚‹',0),(229316,6370,'pt','Aberta seleÃ§Ã£o mostrarÃ¡ todos os intervalos de data',0),(229317,6370,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ð¹ Ð¾Ñ‚Ð±Ð¾Ñ€ Ð¿Ð¾ÐºÐ°Ð¶ÐµÑ‚ Ð¾Ñ‚ Ð²ÑÐµÑ… Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð¾Ð² Ð´Ð°Ñ‚',0),(229318,6370,'es','SelecciÃ³n abierta mostrarÃ¡ desde todos los rangos de la fecha',0),(229319,6370,'de','GeÃ¶ffnet wird von allen Datumsbereiche gefunden',0),(229320,6370,'en','Open selection will show from all date ranges',0),(229321,6371,'is','',0),(229322,6371,'dr','- Ù†Ø§Ù… Ù‡Ø§ÙŠ ÙˆØ§Ø­Ø¯ Ù…Ø´Ø§Ø¨Ù‡ Ù‡Ø³ØªÙ†Ø¯ Ø§Ù…Ø§ ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ù…Ø´Ø§Ø¨Ù‡ Ù†ÙŠØ³Øª .Ø¢ÙŠØ§ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÙŠØ¯ ØŸ',0),(229323,6371,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ù‡Ø³ØªÙ†Ø¯ Ø§Ù…Ø§ Ù†Ø³Ø¨Øª Ù‡Ø§ Ø®ÙŠØ±- Ù†Ø§Ù… Ù‡Ø§ÙŠ ÙˆØ§Ø­Ø¯ Ù…Ø´Ø§Ø¨Ù‡ Ù‡Ø³ØªÙ†Ø¯ Ø§Ù…Ø§ ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª Ù…Ø´Ø§Ø¨Ù‡ Ù†ÙŠØ³Øª .Ø¢ÙŠØ§ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÙŠØ¯ ØŸ',0),(229324,6371,'tr','Birim adlarÄ± aynÄ±, ancak fiyat birimi baÅŸÄ±na kullanÄ±m tutarlarÄ±nÄ± 1 deÄŸil.  Devam etmek istiyor musunuz?',0),(229325,6371,'pl','Nazwy jednostki sÄ… takie same, ale zwyczaj przedmiot(y) jednostkowa cena nie jest 1.  Czy chcesz kontynuowaÄ‡?',0),(229326,6371,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð¼ÐµÐ½Ð°Ñ‚Ð° ÑÐ° ÑÑŠÑ‰Ð¸Ñ‚Ðµ, Ð½Ð¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° ÑƒÑ‡Ð°ÑÑ‚ÑŠÐºÐ° ÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð° Ð½Ðµ Ðµ 1.  Ð˜ÑÐºÐ°Ñ‚Ðµ Ð»Ð¸ Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸Ñ‚Ðµ?',0),(229327,6371,'ur','ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù… Ø§ÛŒÚ© ÛÛŒ Ø±ÛÛ’ ÛÛŒÚºØŒ Ù„ÛŒÚ©Ù† Ø§Ø³ØªØ¹Ù…Ø§Ù„ Unit(s) ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù‚ÛŒÙ…Øª 1 Ù†ÛÛŒÚº ÛÛ’ Û”  Ú©ÛŒØ§ Ø¢Ù¾ Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(229328,6371,'sr','Ð˜Ð¼ÐµÐ½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° ÑÑƒ Ð¸ÑÑ‚Ð¸, Ð°Ð»Ð¸ Ñ˜Ðµ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ñ†ÐµÐ½Ð° Ð½Ð¸Ñ˜Ðµ 1.  Ð”Ð° Ð»Ð¸ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ?',0),(229329,6371,'vi','TÃªn Ä‘Æ¡n vá»‹ giá»‘ng nhau nhÆ°ng Ä‘Æ¡n vá»‹ sá»­ dá»¥ng má»—i Ä‘Æ¡n vá»‹ giÃ¡ chÆ°a pháº£i 1. Tiáº¿p tá»¥c?',0),(229330,6371,'af','Eenheidname is dieselfde, maar die Gebruikte Eenheid(hede) per Pryseenheid is nie\r\n1.  Wil u voortgaan?',0),(229331,6371,'ro','Nume de unitatea sunt aceleaÅŸi, dar unitÄƒÅ£ile de utilizare per unitate de pret nu este 1.  DoriÅ£i sÄƒ continuaÅ£i?',0),(229332,6371,'et','Ãœksuse nimed kattuvad, kuid kasutus Ã¼hik(UT) hind Ã¼hiku kohta ei ole 1.  Kas soovite jÃ¤tkata?',0),(229333,6371,'si','Imena enote so enake, vendar uporaba enot na enoto cena ni 1.  Ali Å¾elite nadaljevati?',0),(229334,6371,'ba','Nama unit yang sama, tetapi penggunaan nasabah per Unit harga tidak 1.  Apakah Anda ingin melanjutkan?',0),(229335,6371,'nl','Namen van eenheden zijn hetzelfde, maar de per prijs eenheid/eenheden in gebruik is niet 1.  Wilt u doorgaan?',0),(229336,6371,'fi','YksikkÃ¶ nimet ovat samat, mutta kÃ¤yttÃ¶ infrastruktuurilaitteiden hintayksikkÃ¶Ã¤ kohden ei ole 1.  Haluatko jatkaa?',0),(229337,6371,'no','Enhetsnavn er de samme, men bruk Unit(s) per enhet er ikke 1.  Vil du fortsette?',0),(229338,6371,'da','Enhed navne er de samme, men brug infrastrukturudstyr pr. prisenhed er ikke 1.  Vil du fortsÃ¦tte?',0),(229339,6371,'ko','ë‹¨ìœ„ ì´ë¦„ì€ ë™ì¼ í•˜ì§€ë§Œ, ê°€ê²© ë‹¨ìœ„ ë‹¹ ì‚¬ìš© ëœ ìž¥ì¹˜ëŠ” 1.  ê³„ì† í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(229340,6371,'he','×™×—×™×“×ª ×©×ž×•×ª ×–×”×™×, ××‘×œ Unit(s) ×”×©×™×ž×•×© ×‘×›×œ ×ž×—×™×¨ ×™×—×™×“×” ×”×•× ×œ× 1.  ×”×× ×‘×¨×¦×•× ×š ×œ×”×ž×©×™×š?',0),(229341,6371,'el','ÎœÎ¿Î½Î¬Î´Î± Î¿Î½ÏŒÎ¼Î±Ï„Î± ÎµÎ¯Î½Î±Î¹ Ï„Î± Î¯Î´Î¹Î±, Î±Î»Î»Î¬ Î· Ï‡ÏÎ®ÏƒÎ· Î¼Î¿Î½Î¬Î´Î±Ï‚(-Ï‰Î½) Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Ï„Î¹Î¼Î® Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ 1.  Î˜Î­Î»ÎµÏ„Îµ Î½Î± ÏƒÏ…Î½ÎµÏ‡Î¯ÏƒÎµÏ„Îµ;',0),(229342,6371,'zh','å•ä½åç§°ç›¸åŒï¼Œä½†ä½¿ç”¨å•ä½ï¼ˆç§’sï¼‰æ¯å•ä½ä»·æ ¼ä¸æ˜¯1ã€‚ä½ è¦ç»§ç»­å—ï¼Ÿ\r\n',0),(229343,6371,'sv','Har samma enhet namn, men de koncernfÃ¶retag som anvÃ¤ndning per prisenhet Ã¤r inte 1.  Vill du fortsÃ¤tta?',0),(229344,6371,'it','Nomi delle unitÃ  sono gli stessi, ma l\'utilizzo di unitÃ  prezzo unitario non Ã¨ 1.  Si desidera continuare?',0),(229345,6371,'tl','',0),(229346,6371,'th','Unit names are the same, but the Usage Unit(s) per Price Unit is not 1.  Do you want to continue?',0),(229347,6371,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¾à¤® à¤¸à¤®à¤¾à¤¨ à¤¹à¥ˆà¤‚, à¤²à¥‡à¤•à¤¿à¤¨ à¤•à¥€à¤®à¤¤ à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿ à¤‰à¤ªà¤¯à¥‹à¤— à¤°à¤¾à¤¯ 1 à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤  à¤•à¥à¤¯à¤¾ à¤†à¤ª à¤œà¤¾à¤°à¥€ à¤°à¤–à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(229348,6371,'ms','Nama-nama unit yang sama, tetapi penggunaan Unit(s) seunit harga tidak 1.  Adakah anda mahu meneruskan?',0),(229349,6371,'ar','Ø£Ø³Ù…Ø§Ø¡ ÙˆØ­Ø¯Ø© Ù‡ÙŠ Ù†ÙØ³Ù‡Ø§ØŒ ÙˆÙ„ÙƒÙ† Ø§Ø³ØªØ®Ø¯Ø§Ù… ÙˆØ­Ø¯Ø© (Ù‚) ÙƒÙ„ \"ÙˆØ­Ø¯Ø© Ø§Ù„Ø³Ø¹Ø±\" Ù„ÙŠØ³ Ù‡Ùˆ 1.  Ù‡Ù„ ØªØ±ÙŠØ¯ Ø§Ù„Ø§Ø³ØªÙ…Ø±Ø§Ø±ØŸ',0),(229350,6371,'fr','Les noms des unitÃ©s sont les mÃªmes, mais l\'unitÃ©(s) d\'utilisation par prix d\'unitÃ© n\'est pas 1. Voulez-vous continuer?',0),(229351,6371,'jp','å?˜ä½?å??ã?¯ä¸€ç·’ã?§ã?™ã?Œã€?ä¾¡æ ¼å?˜ä½?ã?”ã?¨ã?®ä½¿ç”¨å?˜ä½?ã?Œï¼‘ã?§ã?¯ã?‚ã‚Šã?¾ã?›ã‚“ã€‚ç¶šã?‘ã?¾ã?™ã?‹ï¼Ÿ',0),(229352,6371,'pt','Unidade nomes sÃ£o os mesmos, mas o uso de aparelho (s) preÃ§o unitÃ¡rio nÃ£o Ã© 1.  VocÃª quer continuar?',0),(229353,6371,'ru','ÐŸÐ¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð¸Ð¼ÐµÐ½Ð° Ð¾Ð´Ð¸Ð½Ð°ÐºÐ¾Ð²Ñ‹, Ð½Ð¾ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑˆÑ‚. Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ Ñ†ÐµÐ½Ñ‹ Ð½Ðµ ÑÐ²Ð»ÑÐµÑ‚ÑÑ 1.  Ð’Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÑŒ?',0),(229354,6371,'es','Nombres de unidades son lo mismo, pero la (s) unidad (es) por Unidad de Precio no es 1. Â¿Quiere continuar?',0),(229355,6371,'de','Einheitennamen sind die gleichen, aber die Verwendung Stck pro Preiseinheit ist nicht 1.  MÃ¶chten Sie fortfahren?',0),(229356,6371,'en','Unit names are the same, but the Usage Unit(s) per Price Unit is not 1.  Do you want to continue?',0),(229357,6372,'is','',0),(229358,6372,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(229359,6372,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(229360,6372,'tr','SeÃ§enek Ekle/GÃ¼ncelle',0),(229361,6372,'pl','Dodaj/Aktualizuj opcje',0),(229362,6372,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ð¿Ñ†Ð¸Ð¸',0),(229363,6372,'ur','Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(229364,6372,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(229365,6372,'vi','ThÃªm/Cáº­p Nháº­t Lá»±a Chá»n',0),(229366,6372,'af','Opsies Byvoeg/Redigeer ',0),(229367,6372,'ro','AdÄƒugaÅ£i/actualizaÅ£i opÅ£iunile',0),(229368,6372,'et','Lisa/vÃ¤rskenda Valikud',0),(229369,6372,'si','Dodaj/posodobi moÅ¾nosti',0),(229370,6372,'ba','Tambahkan/Perbarui opsi',0),(229371,6372,'nl','Opties toevoegen/bijwerken',0),(229372,6372,'fi','LisÃ¤Ã¤/PÃ¤ivitÃ¤ asetukset',0),(229373,6372,'no','Legg til/Oppdater alternativer',0),(229374,6372,'da','TilfÃ¸j/opdater indstillinger',0),(229375,6372,'ko','ì¶”ê°€ ì—…ë°ì´íŠ¸ ì˜µì…˜',0),(229376,6372,'he','×”×•×¡×£/×¢×“×›×Ÿ ××¤×©×¨×•×™×•×ª',0),(229377,6372,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(229378,6372,'zh','å¢žåŠ /æ›´æ–°é€‰é¡¹\r\n',0),(229379,6372,'sv','LÃ¤gg till/uppdatera alternativ',0),(229380,6372,'it','Aggiungere o aggiornare le opzioni',0),(229381,6372,'tl','',0),(229382,6372,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(229383,6372,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(229384,6372,'ms','Tambah/Kemaskini pilihan',0),(229385,6372,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª',0),(229386,6372,'fr','Ajouter/mettre Ã  jour des Options',0),(229387,6372,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?®è¿½åŠ /æ›´æ–°',0),(229388,6372,'pt','Adicionar/atualizar opÃ§Ãµes',0),(229389,6372,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹',0),(229390,6372,'es','Agregar/Actualizar Opciones',0),(229391,6372,'de','Optionen hinzufÃ¼gen/aktualisieren',0),(229392,6372,'en','Add/Update Options',0),(229393,6373,'is','',0),(229394,6373,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ ',0),(229395,6373,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ ',0),(229396,6373,'tr','Madde seÃ§enek gruplarÄ±',0),(229397,6373,'pl','Pozycja grupy opcji',0),(229398,6373,'bg','Ð“Ñ€ÑƒÐ¿Ð¸ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð° Ð¾Ð¿Ñ†Ð¸Ñ',0),(229399,6373,'ur','Ø´Û’ Ø§Ø®ØªÛŒØ§Ø± Ú¯Ø±ÙˆÙ¾',0),(229400,6373,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ð° Ð³Ñ€ÑƒÐ¿Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(229401,6373,'vi','NhÃ³m lá»±a chá»n hÃ ng',0),(229402,6373,'af','Item Opsie Groepe',0),(229403,6373,'ro','Grupe de articole de opÅ£iune',0),(229404,6373,'et','Toodete valikugrupid',0),(229405,6373,'si','MoÅ¾nost skupine artiklov',0),(229406,6373,'ba','Item Option Groups',0),(229407,6373,'nl','Optie artikelgroepen',0),(229408,6373,'fi','Vaihtoehto nimikeryhmÃ¤t',0),(229409,6373,'no','Alternativet varegrupper',0),(229410,6373,'da','Indstilling varegrupper',0),(229411,6373,'ko','í•­ëª© ì˜µì…˜ ê·¸ë£¹',0),(229412,6373,'he','×§×‘×•×¦×•×ª ××¤×©×¨×•×™×•×ª ×¤×¨×™×˜',0),(229413,6373,'el','Î•Ï€Î¹Î»Î¿Î³Î® Î¿Î¼Î¬Î´ÎµÏ‚ ÎµÎ¹Î´ÏŽÎ½',0),(229414,6373,'zh','é¡¹ç›®é€‰é¡¹ç»„\r\n',0),(229415,6373,'sv','Alternativet artikelgrupper',0),(229416,6373,'it','Elemento opzione gruppi',0),(229417,6373,'tl','',0),(229418,6373,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(229419,6373,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¥‡ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(229420,6373,'ms','Item opsyen Kumpulan',0),(229421,6373,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„ØµÙ†Ù',0),(229422,6373,'fr','Ã‰lÃ©ment Option groupes',0),(229423,6373,'jp','å“?ç›®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚°ãƒ«ãƒ¼ãƒ—',0),(229424,6373,'pt','Item opÃ§Ã£o grupos',0),(229425,6373,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð² ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(229426,6373,'es','Item Grupos de Opciones',0),(229427,6373,'de','Option Artikelgruppen',0),(229428,6373,'en','Item Option Groups',0),(229429,6374,'is','',0),(229430,6374,'dr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨  Ø¯ÙØªØ± ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ø±Ø§ÙŠ Ù…Ù‚Ø¯Ø§Ø± ',0),(229431,6374,'pr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨  Ø¯ÙØªØ± ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ø±Ø§ÙŠ Ù…Ù‚Ø¯Ø§Ø± ',0),(229432,6374,'tr','Miktar iÃ§in seÃ§ilen hiÃ§bir GL hesabÄ±',0),(229433,6374,'pl','Nie konta GL wybranego na kwotÄ™',0),(229434,6374,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð½Ðµ GL, Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð·Ð° ÑÑƒÐ¼Ð°',0),(229435,6374,'ur','Ø±Ù‚Ù… Ú©Û’ Ù„Ø¦Û’ Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(229436,6374,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð·Ð° Ð“Ð› Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½ Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(229437,6374,'vi','ChÆ°a Chá»n TK Sá»• CÃ¡i Tá»•ng Há»£p',0),(229438,6374,'af','Geen AG Rekening Gekies vir Bedrag',0),(229439,6374,'ro','Nici un cont de GL selectate pentru suma',0),(229440,6374,'et','Nr summa valitud pearaamatukontole',0),(229441,6374,'si','RaÄun ne GL, izbran za znesek',0),(229442,6374,'ba','No akun GL yang dipilih untuk jumlah',0),(229443,6374,'nl','Geen GL Account geselecteerd voor bedrag',0),(229444,6374,'fi','GL huomioon valittu summa',0),(229445,6374,'no','Ingen GL-kontoen som er valgt for belÃ¸p',0),(229446,6374,'da','Ingen GL konto valgt for belÃ¸b',0),(229447,6374,'ko','GL ê³„ì • ê¸ˆì•¡ ì„ íƒ',0),(229448,6374,'he','××™×Ÿ ×—×©×‘×•×Ÿ GL ×©× ×‘×—×¨ ×¢×‘×•×¨ ×›×ž×•×ª',0),(229449,6374,'el','Î”ÎµÎ½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹ Î³Î¹Î± Ï„Î¿ Ï€Î¿ÏƒÏŒ',0),(229450,6374,'zh','æ²¡æœ‰å·²é€‰çš„æ€»å¸å¸æˆ·çš„é‡‘é¢\r\n',0),(229451,6374,'sv','Ingen GL-konto som valts fÃ¶r belopp',0),(229452,6374,'it','Nessun conto GL selezionato per quantitÃ ',0),(229453,6374,'tl','',0),(229454,6374,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3586;&#3629;&#3591;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(229455,6374,'hi','à¤•à¥‹à¤ˆ GL à¤–à¤¾à¤¤à¥‡ à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¯à¤¨à¤¿à¤¤',0),(229456,6374,'ms','Tiada akaun GL yang dipilih untuk jumlah',0),(229457,6374,'ar','Ø­Ø³Ø§Ø¨ GL Ù„Ø§ ØªØ­Ø¯ÙŠØ¯ Ù„Ù„Ù…Ø¨Ù„Øº',0),(229458,6374,'fr','Aucun compte GL sÃ©lectionnÃ© pour montant',0),(229459,6374,'jp','ã?“ã?®é‡‘é¡?ã?®ç·?å‹˜å®šå…ƒå¸³ã?Œé?¸æŠžã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(229460,6374,'pt','Nenhuma conta GL selecionada por quantidade',0),(229461,6374,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð½Ðµ GL, Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð´Ð»Ñ ÑÑƒÐ¼Ð¼Ñ‹',0),(229462,6374,'es','No se SeleccionÃ³ una Cuenta LM para el Monto',0),(229463,6374,'de','Kein Hauptbuchkonto fÃ¼r Betrag ausgewÃ¤hlt',0),(229464,6374,'en','No GL Account Selected for Amount',0),(229465,6375,'is','',0),(229466,6375,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(229467,6375,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(229468,6375,'tr','GL hesaplarÄ±na girilip deÄŸil!',0),(229469,6375,'pl','Nie wprowadzono GL kont!',0),(229470,6375,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð½Ðµ ÑÐ° Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸!',0),(229471,6375,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú©Ùˆ Ø¯Ø§Ø®Ù„ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’!',0),(229472,6375,'sr','ÐšÐ¾Ð½Ñ‚Ð° Ð“Ð› Ð½Ð¸Ñ˜Ðµ ÑƒÐ½ÐµÑ‚Ð¾!',0),(229473,6375,'vi','ChÆ°a Nháº­p TK Sá»• CÃ¡i Tá»•ng Há»£p! ',0),(229474,6375,'af','AG Rekeninge Is Nog Nie Ingevoer!',0),(229475,6375,'ro','GL conturi nu au fost introduse!',0),(229476,6375,'et','GL kontod ei ole kantud!',0),(229477,6375,'si','GL raÄunov ni bil vknjiÅ¾en!',0),(229478,6375,'ba','GL account tidak telah dimasukkan!',0),(229479,6375,'nl','GL-Accounts zijn niet ingevoerd!',0),(229480,6375,'fi','GL tilit eivÃ¤t ole tulleet!',0),(229481,6375,'no','GL-kontoer er ikke angitt!',0),(229482,6375,'da','GL konti er ikke blevet angivet!',0),(229483,6375,'ko','GL ê³„ì • ìž…ë ¥ í•˜ì§€ ì•Šì•˜ìŠµë‹ˆë‹¤!',0),(229484,6375,'he','GL ×”×—×©×‘×•× ×•×ª ×œ× ×”×•×–× ×•!',0),(229485,6375,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î³/Î» Î´ÎµÎ½ Î­Ï‡Î¿Ï…Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¸ÎµÎ¯!',0),(229486,6375,'zh','æ€»å¸å¸æˆ·æ²¡æœ‰å¡«å†™ï¼\r\n',0),(229487,6375,'sv','GL-konton har inte angetts!',0),(229488,6375,'it','Conti di contabilitÃ  generale non sono stati inseriti!',0),(229489,6375,'tl','',0),(229490,6375,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(229491,6375,'hi','GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤¦à¤°à¥à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ!',0),(229492,6375,'ms','GL akaun telah dipersetujui!',0),(229493,6375,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ù„Ù… ØªØ¯Ø®Ù„ Ø¨Ø¹Ø¯',0),(229494,6375,'fr','GLG nâ€™ont pas Ã©tÃ© entrÃ©sÂ !',0),(229495,6375,'jp','ç·?å‹˜å®šå…ƒå¸³ã?Œå…¥åŠ›ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(229496,6375,'pt','Contas GL nÃ£o foram inseridas!',0),(229497,6375,'ru','ÐÐµ Ð±Ñ‹Ð»Ð¸ Ð²Ð²ÐµÐ´ÐµÐ½Ñ‹ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ GL!',0),(229498,6375,'es','Cuentas de LM No Se Ingresaron',0),(229499,6375,'de','GL-Konten wurden nicht eingegeben!',0),(229500,6375,'en','GL Accounts Have Not Been Entered!',0),(229501,6376,'is','',0),(229502,6376,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªÙˆØ¶ÙŠØ­Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ ',0),(229503,6376,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªÙˆØ¶ÙŠØ­Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ ',0),(229504,6376,'tr','VeritabanÄ± AÃ§Ä±klama DÃ¼zenle',0),(229505,6376,'pl','Edycja bazy danych wyjaÅ›nienia',0),(229506,6376,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¾Ð±ÑÑÐ½ÐµÐ½Ð¸Ñ',0),(229507,6376,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ ÙˆØ¶Ø§Ø­Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(229508,6376,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¾Ð±Ñ˜Ð°ÑˆÑšÐµÑšÐ°',0),(229509,6376,'vi','Chá»‰nh Sá»­a Diá»…n Giáº£i Trong Dá»¯ Liá»‡u',0),(229510,6376,'af','Redigeer Databasis Verduidelikings',0),(229511,6376,'ro','Edita baza de date explicaÅ£ii',0),(229512,6376,'et','Muuda andmebaasi seletusi',0),(229513,6376,'si','Uredite zbirko podatkov pojasnila',0),(229514,6376,'ba','Mengedit Database penjelasan',0),(229515,6376,'nl','Database uitleg bewerken',0),(229516,6376,'fi','Muokkaa tietokannan selityksiÃ¤',0),(229517,6376,'no','Redigere databasen forklaringer',0),(229518,6376,'da','Rediger Database forklaringer',0),(229519,6376,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì„¤ëª… íŽ¸ì§‘',0),(229520,6376,'he','×¢×¨×•×š ×”×¡×‘×¨ ×ž×¡×“ × ×ª×•× ×™×',0),(229521,6376,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ ÎµÏ€ÎµÎ¾Î·Î³Î®ÏƒÎµÎ¹Ï‚ Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(229522,6376,'zh','ç¼–è¾‘æ•°æ®åº“çš„è¯´æ˜Ž\r\n',0),(229523,6376,'sv','Redigera databasen fÃ¶rklaringar',0),(229524,6376,'it','Modificare il Database spiegazioni',0),(229525,6376,'tl','',0),(229526,6376,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(229527,6376,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥à¤ªà¤·à¥à¤Ÿà¥€à¤•à¤°à¤£ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(229528,6376,'ms','Edit penjelasan pangkalan data',0),(229529,6376,'ar','ØªØ­Ø±ÙŠØ± ØªÙˆØ¶ÙŠØ­Ø§Øª Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(229530,6376,'fr','Modifier la base de donnÃ©es des explications',0),(229531,6376,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹èª¬æ˜Žã?®ç·¨é›†',0),(229532,6376,'pt','Editar banco de dados explicaÃ§Ãµes',0),(229533,6376,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐžÐ±ÑŠÑÑÐ½ÐµÐ½Ð¸Ðµ Ð‘Ð°Ð·Ñ‹ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(229534,6376,'es','Editar Explicaciones de la Base de Datos',0),(229535,6376,'de','Bearbeiten von Datenbank-ErklÃ¤rungen',0),(229536,6376,'en','Edit Database Explanations',0),(229537,6377,'is','',0),(229538,6377,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø±Ø§ÙŠ Ø¬Ø¯ÙˆÙ„ ',0),(229539,6377,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø±Ø§ÙŠ Ø¬Ø¯ÙˆÙ„ ',0),(229540,6377,'tr','Tablo iÃ§in bilgileri dÃ¼zenleme',0),(229541,6377,'pl','EdytowaÄ‡ informacje o tabeli',0),(229542,6377,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(229543,6377,'ur','Ø¬Ø¯ÙˆÙ„ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(229544,6377,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð·Ð° ÑÑ‚Ð¾Ð»Ð¾Ð¼',0),(229545,6377,'vi','Sá»­a ThÃ´ng Tin Trong Báº£ng',0),(229546,6377,'af','Redigeer Inligting vir Tabel',0),(229547,6377,'ro','EditaÅ£i informaÅ£ii pentru masÄƒ',0),(229548,6377,'et','Tabeli andmete muutmine',0),(229549,6377,'si','Urejanje podatkov za tabelo',0),(229550,6377,'ba','Mengedit informasi tabel',0),(229551,6377,'nl','Gegevens voor tabel bewerken',0),(229552,6377,'fi','Muokkaa tietoja taulukossa',0),(229553,6377,'no','Redigere informasjon for tabell',0),(229554,6377,'da','Redigere oplysninger for tabel',0),(229555,6377,'ko','í…Œì´ë¸”ì— ëŒ€ í•œ ì •ë³´ íŽ¸ì§‘',0),(229556,6377,'he','×¢×¨×™×›×ª ×ž×™×“×¢ ×¢×‘×•×¨ ×˜×‘×œ×”',0),(229557,6377,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î¿Î½ Ï€Î¯Î½Î±ÎºÎ±',0),(229558,6377,'zh','ç¼–è¾‘è¡¨ä¿¡æ¯\r\n',0),(229559,6377,'sv','Redigera Information fÃ¶r tabell',0),(229560,6377,'it','Modificare le informazioni per la tabella',0),(229561,6377,'tl','',0),(229562,6377,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;',0),(229563,6377,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(229564,6377,'ms','Edit maklumat Jadual',0),(229565,6377,'ar','ØªØ­Ø±ÙŠØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(229566,6377,'fr','Modifier les informations de Table',0),(229567,6377,'jp','è¡¨ã?®æƒ…å ±ã‚’ç·¨é›†ã?™ã‚‹',0),(229568,6377,'pt','Editar informaÃ§Ãµes de tabela',0),(229569,6377,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð´Ð»Ñ Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(229570,6377,'es','Editar InformaciÃ³n para la Tabla',0),(229571,6377,'de','Informationen fÃ¼r Tabelle bearbeiten',0),(229572,6377,'en','Edit Information for Table',0),(229573,6378,'is','',0),(229574,6378,'dr','ÙÙŠÙ„Ø¯ ',0),(229575,6378,'pr','ÙÙŠÙ„Ø¯ ',0),(229576,6378,'tr','Alan',0),(229577,6378,'pl','Pole',0),(229578,6378,'bg','ÐŸÐ¾Ð»Ðµ',0),(229579,6378,'ur','Ù‚Ø·Ø¹Û',0),(229580,6378,'sr','ÐŸÐ¾Ñ™Ðµ',0),(229581,6378,'vi','TrÆ°á»ng',0),(229582,6378,'af','Veld',0),(229583,6378,'ro','CÃ¢mp',0),(229584,6378,'et','VÃ¤li',0),(229585,6378,'si','Polje',0),(229586,6378,'ba','Bidang',0),(229587,6378,'nl','Veld',0),(229588,6378,'fi','KenttÃ¤',0),(229589,6378,'no','Feltet',0),(229590,6378,'da','Felt',0),(229591,6378,'ko','í•„ë“œ',0),(229592,6378,'he','×©×“×”',0),(229593,6378,'el','Î ÎµÎ´Î¯Î¿',0),(229594,6378,'zh','å­—æ®µ\r\n',0),(229595,6378,'sv','FÃ¤ltet',0),(229596,6378,'it','Campo',0),(229597,6378,'tl','',0),(229598,6378,'th','&#3615;&#3636;&#3621;&#3604;&#3660;',0),(229599,6378,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡',0),(229600,6378,'ms','Bidang',0),(229601,6378,'ar','Ø§Ù„Ø­Ù‚Ù„',0),(229602,6378,'fr','Champ',0),(229603,6378,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(229604,6378,'pt','Campo',0),(229605,6378,'ru','ÐŸÐ¾Ð»Ðµ',0),(229606,6378,'es','Campo',0),(229607,6378,'de','Feld',0),(229608,6378,'en','Field',0),(229609,6379,'is','',0),(229610,6379,'dr','Ø¯Ø±Ø§Ø²Ø§ÙŠ ÙÙŠÙ„Ø¯ ',0),(229611,6379,'pr','Ø¯Ø±Ø§Ø²Ø§ÙŠ ÙÙŠÙ„Ø¯ ',0),(229612,6379,'tr','Alan uzunluÄŸu',0),(229613,6379,'pl','DÅ‚ugoÅ›Ä‡ pola',0),(229614,6379,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð½Ð° Ð½Ð° Ð¿Ð¾Ð»Ðµ',0),(229615,6379,'ur','Ù…ÛŒØ¯Ø§Ù† Ú©ÛŒ Ù„Ù…Ø¨Ø§Ø¦ÛŒ',0),(229616,6379,'sr','Ð”ÑƒÐ¶Ð¸Ð½Ð° Ð¿Ð¾Ñ™Ð°',0),(229617,6379,'vi','Chiá»u dÃ i TrÆ°á»ng',0),(229618,6379,'af','Veld Lengte',0),(229619,6379,'ro','Domeniul lungime',0),(229620,6379,'et','VÃ¤lja pikkus',0),(229621,6379,'si','DolÅ¾ina polja',0),(229622,6379,'ba','Bidang panjang',0),(229623,6379,'nl','Veldlengte',0),(229624,6379,'fi','KenttÃ¤pituus',0),(229625,6379,'no','Feltlengden',0),(229626,6379,'da','FeltlÃ¦ngde',0),(229627,6379,'ko','í•„ë“œ ê¸¸ì´',0),(229628,6379,'he','××•×¨×š ×©×“×”',0),(229629,6379,'el','Î¤Î¿ Î¼Î®ÎºÎ¿Ï‚ Ï€ÎµÎ´Î¯Î¿Ï…',0),(229630,6379,'zh','å­—æ®µé•¿åº¦\r\n',0),(229631,6379,'sv','BanlÃ¤ngd',0),(229632,6379,'it','Lunghezza di campo',0),(229633,6379,'tl','',0),(229634,6379,'th','&#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623;&#3586;&#3629;&#3591;&#3615;&#3636;&#3621;&#3604;&#3660;',0),(229635,6379,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤²à¤®à¥à¤¬à¤¾à¤ˆ',0),(229636,6379,'ms','Padang panjang',0),(229637,6379,'ar','Ø·ÙˆÙ„ Ø§Ù„Ø­Ù‚Ù„',0),(229638,6379,'fr','Longueur de piste',0),(229639,6379,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ç¯„å›²',0),(229640,6379,'pt','Tamanho do campo',0),(229641,6379,'ru','Ð”Ð»Ð¸Ð½Ð° Ð¿Ð¾Ð»Ñ',0),(229642,6379,'es','Largo de Campo',0),(229643,6379,'de','FeldlÃ¤nge',0),(229644,6379,'en','Field Length',0),(229645,6380,'is','',0),(229646,6380,'dr','Ù†Ø§Ù… ÙÙŠÙ„Ø¯ ',0),(229647,6380,'pr','Ù†Ø§Ù… ÙÙŠÙ„Ø¯ ',0),(229648,6380,'tr','Alan adÄ±',0),(229649,6380,'pl','Nazwa pola',0),(229650,6380,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¿Ð¾Ð»Ðµ',0),(229651,6380,'ur','Ù†Ø§Ù… Ù‚Ø·Ø¹Û',0),(229652,6380,'sr','Ð˜Ð¼Ðµ Ð¿Ð¾Ñ™Ð°',0),(229653,6380,'vi','TÃªn TrÆ°á»ng',0),(229654,6380,'af','Veldnaam',0),(229655,6380,'ro','Numele de cÃ¢mp',0),(229656,6380,'et','VÃ¤lja nimi',0),(229657,6380,'si','Ime polja',0),(229658,6380,'ba','Nama Field',0),(229659,6380,'nl','Veldnaam',0),(229660,6380,'fi','KenttÃ¤nimi',0),(229661,6380,'no','Feltnavn',0),(229662,6380,'da','Feltnavnet',0),(229663,6380,'ko','í•„ë“œ ì´ë¦„',0),(229664,6380,'he','×©× ×”×©×“×”',0),(229665,6380,'el','ÎŒÎ½Î¿Î¼Î± Ï€ÎµÎ´Î¯Î¿Ï…',0),(229666,6380,'zh','å­—æ®µåç§°\r\n',0),(229667,6380,'sv','FÃ¤ltnamn',0),(229668,6380,'it','Nome del campo',0),(229669,6380,'tl','',0),(229670,6380,'th','&#3594;&#3639;&#3656;&#3629;&#3615;&#3636;&#3621;&#3604;&#3660;',0),(229671,6380,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤¨à¤¾à¤®',0),(229672,6380,'ms','Nama Field',0),(229673,6380,'ar','Ø¥Ø³Ù… Ø§Ù„Ø­Ù‚Ù„',0),(229674,6380,'fr','Nom de domaine',0),(229675,6380,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰å??',0),(229676,6380,'pt','Nome do campo',0),(229677,6380,'ru','Ð˜Ð¼Ñ Ð¿Ð¾Ð»Ñ',0),(229678,6380,'es','Nombre de Campo',0),(229679,6380,'de','Feldname',0),(229680,6380,'en','Field Name',0),(229681,6381,'is','',0),(229682,6381,'dr','Ù†ÙˆØ¹ ÙÙŠÙ„Ø¯ ',0),(229683,6381,'pr','Ù†ÙˆØ¹ ÙÙŠÙ„Ø¯ ',0),(229684,6381,'tr','Alan tÃ¼rÃ¼',0),(229685,6381,'pl','Typ pola',0),(229686,6381,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð¿Ð¾Ð»Ðµ',0),(229687,6381,'ur','Ù‚Ø·Ø¹Û Ù‚Ø³Ù…',0),(229688,6381,'sr','Ð¢Ð¸Ð¿ Ð¿Ð¾Ñ™Ð°',0),(229689,6381,'vi','Loáº¡i TrÆ°á»ng',0),(229690,6381,'af','Veld Tipe',0),(229691,6381,'ro','Tipul de cÃ¢mp',0),(229692,6381,'et','VÃ¤lja tÃ¼Ã¼p',0),(229693,6381,'si','Vrsta polja',0),(229694,6381,'ba','Tipe Field',0),(229695,6381,'nl','Veldtype',0),(229696,6381,'fi','KenttÃ¤tyyppi',0),(229697,6381,'no','Felttype',0),(229698,6381,'da','Felttypen',0),(229699,6381,'ko','í•„ë“œ í˜•ì‹',0),(229700,6381,'he','×¡×•×’ ×©×“×”',0),(229701,6381,'el','Î¤ÏÏ€Î¿Ï‚ Ï€ÎµÎ´Î¯Î¿Ï…',0),(229702,6381,'zh','å­—æ®µç±»åž‹\r\n',0),(229703,6381,'sv','FÃ¤lttyp',0),(229704,6381,'it','Tipo di campo',0),(229705,6381,'tl','',0),(229706,6381,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3615;&#3636;&#3621;&#3604;&#3660;',0),(229707,6381,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(229708,6381,'ms','Jenis bidang',0),(229709,6381,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø­Ù‚Ù„',0),(229710,6381,'fr','Type de champ',0),(229711,6381,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚¿ã‚¤ãƒ—',0),(229712,6381,'pt','Tipo de campo',0),(229713,6381,'ru','Ð¢Ð¸Ð¿ Ð¿Ð¾Ð»Ñ',0),(229714,6381,'es','Tipo de Campo',0),(229715,6381,'de','Feldtyp',0),(229716,6381,'en','Field Type',0),(229717,6382,'is','',0),(229718,6382,'dr','Ù†ÙƒØ§Øª ÙƒÙ„ÙŠØ¯ÙŠ Ø¯Ø±ÙƒØ¯Ø§Ù… Ø¬Ø¯ÙˆÙ„ ',0),(229719,6382,'pr','Ù†ÙƒØ§Øª ÙƒÙ„ÙŠØ¯ÙŠ Ø¯Ø±ÙƒØ¯Ø§Ù… Ø¬Ø¯ÙˆÙ„ ',0),(229720,6382,'tr','Hangi tablo iÃ§in anahtar noktalar',0),(229721,6382,'pl','Kluczowe punkty do tabeli',0),(229722,6382,'bg','ÐšÐ»ÑŽÑ‡Ð¾Ð²Ð¸ Ñ‚Ð¾Ñ‡ÐºÐ¸ ÐºÑŠÐ¼ ÐºÐ¾Ñ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(229723,6382,'ur','Ú©Ù„ÛŒØ¯ÛŒ Ù†Ú©Ø§Øª Ø¬Ùˆ Ù…ÛŒØ²',0),(229724,6382,'sr','ÐšÑ™ÑƒÑ‡ ÑƒÐºÐ°Ð·ÑƒÑ˜Ðµ Ð½Ð° ÐºÐ¾Ñ˜Ð° Ñ‚Ð°Ð±ÐµÐ»Ð°',0),(229725,6382,'vi','Äiá»ƒm chÃ­nh cho báº£ng nÃ o',0),(229726,6382,'af','Sleutelpunte na Watter Tabel',0),(229727,6382,'ro','Puncte cheie la care masa',0),(229728,6382,'et','PÃµhipunktid mille tabelisse',0),(229729,6382,'si','KljuÄne toÄke za katero tabelo',0),(229730,6382,'ba','Kunci poin untuk menentukan Table',0),(229731,6382,'nl','Zeer belangrijke punten aan welke tabel',0),(229732,6382,'fi','Avainkohdat mihin tauluun kohdistus',0),(229733,6382,'no','Viktige punkter som tabell',0),(229734,6382,'da','NÃ¸glepunkter til hvilken tabel',0),(229735,6382,'ko','í…Œì´ë¸” í•˜ í‚¤ í¬ì¸íŠ¸',0),(229736,6382,'he','× ×§×•×“×•×ª ×ž×¤×ª×— ×”×˜×‘×œ×”',0),(229737,6382,'el','Î¤Î± Ï€Î¹Î¿ Î£Î—ÎœÎ‘ÎÎ¤Î™ÎšÎ‘ Î£Î—ÎœÎ•Î™Î‘ Ï€Î¿Ï… Ï„ÏÎ±Ï€Î­Î¶Î¹',0),(229738,6382,'zh','å“ªä¸ªè¡¨çš„è¦ç‚¹\r\n',0),(229739,6382,'sv','NyckelfrÃ¥gor till vilken tabell',0),(229740,6382,'it','Punti chiave a quale tabella',0),(229741,6382,'tl','',0),(229742,6382,'th','&#3592;&#3640;&#3604;&#3626;&#3635;&#3588;&#3633;&#3597;&#3626;&#3641;&#3656;&#3605;&#3634;&#3619;&#3634;&#3591;&#3629;&#3633;&#3609;&#3652;&#3627;&#3609;',0),(229743,6382,'hi','à¤œà¥‹ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤‚à¤œà¥€ à¤…à¤‚à¤•',0),(229744,6382,'ms','Perkara penting untuk meja-meja yang',0),(229745,6382,'ar','Ø§Ù„Ù†Ù‚Ø§Ø· Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ù„Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø°ÙŠ',0),(229746,6382,'fr','Points clÃ©s Ã  quelle Table',0),(229747,6382,'jp','ã‚­ãƒ¼ã?¯ã?©ã?®è¡¨ã‚’æŒ‡ã?—ã?¾ã?™ã?‹ï¼Ÿ',0),(229748,6382,'pt','Pontos-chave para qual tabela',0),(229749,6382,'ru','ÐšÐ»ÑŽÑ‡ÐµÐ²Ñ‹Ðµ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ñ‹ Ð² ÐºÐ°ÐºÑƒÑŽ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñƒ',0),(229750,6382,'es','Puntos Cruciales a Cual Tabla',0),(229751,6382,'de','Wichtige Punkte, welche Tabelle',0),(229752,6382,'en','Key Points to Which Table',0),(229753,6383,'is','',0),(229754,6383,'dr','Ù†ÙˆØ¹ ÙƒÙ„ÙŠØ¯ ',0),(229755,6383,'pr','Ù†ÙˆØ¹ ÙƒÙ„ÙŠØ¯ ',0),(229756,6383,'tr','Anahtar tÃ¼rÃ¼ ise (anahtar)',0),(229757,6383,'pl','Typ klucza (JeÅ›li klucz)',0),(229758,6383,'bg','ÐšÐ»ÑŽÑ‡ Ñ‚Ð¸Ð¿ (Ð°ÐºÐ¾ Ðµ ÐºÐ»ÑŽÑ‡)',0),(229759,6383,'ur','Ú©Ù„ÛŒØ¯ Ù‚Ø³Ù… Ø§Ú¯Ø± (Ø§ÛÙ…)',0),(229760,6383,'sr','Ð¢Ð¸Ð¿ ÐºÑ™ÑƒÑ‡Ð° (Ð°ÐºÐ¾ Ñ˜Ðµ ÐºÑ™ÑƒÑ‡Ð½Ð¸)',0),(229761,6383,'vi','Loáº¡i chÃ­nh (náº¿u chá»§ yáº¿u)',0),(229762,6383,'af','Sleutel tipe (as sleutel)',0),(229763,6383,'ro','Tip cheie (Ã®n cazul Ã®n care cheie)',0),(229764,6383,'et','VÃµtme tÃ¼Ã¼p (kui see on oluline)',0),(229765,6383,'si','KljuÄ tipa (Äe je kljuÄ)',0),(229766,6383,'ba','Jenis kunci (jika kunci)',0),(229767,6383,'nl','Type sleutel en Type (als sleutel)',0),(229768,6383,'fi','Avaimen laji (Jos avain)',0),(229769,6383,'no','Key Type (hvis nÃ¸kkel)',0),(229770,6383,'da','Key Type (hvis nÃ¸glen)',0),(229771,6383,'ko','í‚¤ ìœ í˜• (í•´ë‹¹ ë˜ëŠ” ê²½ìš° í‚¤)',0),(229772,6383,'he','×¡×•×’ ×ž×¤×ª×— (×× ×ž×¤×ª×—)',0),(229773,6383,'el','Î•Î¯Î´Î¿Ï‚ ÎºÎ»ÎµÎ¹Î´Î¯ (Î±Î½ Ï„Î¿ ÎºÎ»ÎµÎ¹Î´Î¯)',0),(229774,6383,'zh','é‡ç‚¹ç±»åˆ«ï¼ˆå¦‚é‡ç‚¹ï¼‰\r\n',0),(229775,6383,'sv','Key Type (om nyckel)',0),(229776,6383,'it','Tipo di chiave (se chiave)',0),(229777,6383,'tl','',0),(229778,6383,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3585;&#3640;&#3597;&#3649;&#3592;',0),(229779,6383,'hi','à¤•à¥à¤‚à¤œà¥€ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¯à¤¦à¤¿ (à¤ªà¥à¤°à¤®à¥à¤–)',0),(229780,6383,'ms','Jenis kunci (jika utama)',0),(229781,6383,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù…ÙØªØ§Ø­ (Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ù…ÙØªØ§Ø­)',0),(229782,6383,'fr','Type de clÃ© (s\'il y a clÃ©s)',0),(229783,6383,'jp','ã‚­ãƒ¼ã‚¿ã‚¤ãƒ—ï¼ˆã‚‚ã?—ã‚­ãƒ¼ã?ªã‚‰ï¼‰',0),(229784,6383,'pt','Tipo de chave (se chave)',0),(229785,6383,'ru','Ð¢Ð¸Ð¿ ÐºÐ»ÑŽÑ‡Ð° (ÐµÑÐ»Ð¸ ÐºÐ»ÑŽÑ‡)',0),(229786,6383,'es','CarÃ¡cter Clave (si clave)',0),(229787,6383,'de','SchlÃ¼sseltyp (falls SchlÃ¼ssel)',0),(229788,6383,'en','Key Type (if key)',0),(229789,6384,'is','',0),(229790,6384,'dr','Ø¬Ø¯ÙˆÙ„',0),(229791,6384,'pr','Ø¬Ø¯ÙˆÙ„',0),(229792,6384,'tr','Tablo',0),(229793,6384,'pl','Tabela',0),(229794,6384,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(229795,6384,'ur','Ø¬Ø¯ÙˆÙ„',0),(229796,6384,'sr','Ð¢Ð°Ð±ÐµÐ»Ð°',0),(229797,6384,'vi','Báº£ng',0),(229798,6384,'af','Tabel',0),(229799,6384,'ro','Tabela',0),(229800,6384,'et','Tabel',0),(229801,6384,'si','Tabela',0),(229802,6384,'ba','Tabel',0),(229803,6384,'nl','Tabel',0),(229804,6384,'fi','Taulukko',0),(229805,6384,'no','Tabell',0),(229806,6384,'da','Tabel',0),(229807,6384,'ko','í…Œì´ë¸”',0),(229808,6384,'he','×˜×‘×œ×”',0),(229809,6384,'el','Î Î¯Î½Î±ÎºÎ±Ï‚',0),(229810,6384,'zh','è¡¨\r\n',0),(229811,6384,'sv','Tabell',0),(229812,6384,'it','Tabella',0),(229813,6384,'tl','',0),(229814,6384,'th','&#3605;&#3634;&#3619;&#3634;&#3591;',0),(229815,6384,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(229816,6384,'ms','Jadual',0),(229817,6384,'ar','Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(229818,6384,'fr','Table',0),(229819,6384,'jp','è¡¨',0),(229820,6384,'pt','Tabela',0),(229821,6384,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(229822,6384,'es','Tabla',0),(229823,6384,'de','Tabelle',0),(229824,6384,'en','Table',0),(229825,6385,'is','',0),(229826,6385,'dr',' Ø¬Ø¯ÙˆÙ„ Ù†Ø§Ù… ',0),(229827,6385,'pr',' Ø¬Ø¯ÙˆÙ„ Ù†Ø§Ù… ',0),(229828,6385,'tr','Tablo adÄ±',0),(229829,6385,'pl','Nazwa tabeli',0),(229830,6385,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(229831,6385,'ur','Ø¬Ø¯ÙˆÙ„ Ú©Ø§ Ù†Ø§Ù…',0),(229832,6385,'sr','Ð˜Ð¼Ðµ Ñ‚Ð°Ð±ÐµÐ»Ðµ',0),(229833,6385,'vi','TÃªn báº£ng',0),(229834,6385,'af','Tabelnaam',0),(229835,6385,'ro','Nume tabel',0),(229836,6385,'et','Tabeli nimi',0),(229837,6385,'si','Ime tabele',0),(229838,6385,'ba','Nama tabel',0),(229839,6385,'nl','Tabelnaam',0),(229840,6385,'fi','Taulukkonimi',0),(229841,6385,'no','Tabellnavn',0),(229842,6385,'da','Tabelnavn',0),(229843,6385,'ko','í…Œì´ë¸” ì´ë¦„',0),(229844,6385,'he','×©× ×”×˜×‘×œ×”',0),(229845,6385,'el','ÎŒÎ½Î¿Î¼Î± Ï€Î¯Î½Î±ÎºÎ±',0),(229846,6385,'zh','è¡¨å\r\n',0),(229847,6385,'sv','Tabellnamnet',0),(229848,6385,'it','Nome della tabella',0),(229849,6385,'tl','',0),(229850,6385,'th','&#3594;&#3639;&#3656;&#3629;&#3605;&#3634;&#3619;&#3634;&#3591;',0),(229851,6385,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¨à¤¾à¤®',0),(229852,6385,'ms','Nama Jadual',0),(229853,6385,'ar','Ø¥Ø³Ù… Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(229854,6385,'fr','Nom de la table',0),(229855,6385,'jp','è¡¨å??',0),(229856,6385,'pt','Nome da tabela',0),(229857,6385,'ru','Ð˜Ð¼Ñ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(229858,6385,'es','Nombre de tabla',0),(229859,6385,'de','Tabellenname',0),(229860,6385,'en','Table Name',0),(229861,6386,'is','',0),(229862,6386,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¬Ø§Ø²',0),(229863,6386,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¬Ø§Ø²',0),(229864,6386,'tr','Ä°zin verilen deÄŸerler',0),(229865,6386,'pl','WartoÅ›ci dopuszczalne',0),(229866,6386,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ‚Ðµ ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸',0),(229867,6386,'ur','Ù‚Ø¯Ø±ÙˆÚº Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª',0),(229868,6386,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(229869,6386,'vi','GiÃ¡ trá»‹ cho phÃ©p',0),(229870,6386,'af','Waardes Toegelaat',0),(229871,6386,'ro','Valorile permise',0),(229872,6386,'et','Lubatud vÃ¤Ã¤rtused',0),(229873,6386,'si','Dovoljene vrednosti',0),(229874,6386,'ba','Nilai-nilai yang diperbolehkan',0),(229875,6386,'nl','Toegestane waarden',0),(229876,6386,'fi','Arvot ovat sallittuja',0),(229877,6386,'no','Verdier er tillatt',0),(229878,6386,'da','VÃ¦rdier tilladt',0),(229879,6386,'ko','í—ˆìš© ë˜ëŠ” ê°’',0),(229880,6386,'he','×¢×¨×›×™× ×ž×•×ª×¨×™×',0),(229881,6386,'el','Î•Ï€Î¹Ï„ÏÎµÏ€ÏŒÎ¼ÎµÎ½ÎµÏ‚ Ï„Î¹Î¼Î­Ï‚',0),(229882,6386,'zh','å…è®¸çš„å€¼\r\n',0),(229883,6386,'sv','VÃ¤rden som tillÃ¥ts',0),(229884,6386,'it','Valori ammessi',0),(229885,6386,'tl','',0),(229886,6386,'th','&#3588;&#3656;&#3634;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(229887,6386,'hi','à¤®à¥‚à¤²à¥à¤¯à¥‹à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(229888,6386,'ms','Nilai-nilai yang dibenarkan',0),(229889,6386,'ar','Ø§Ù„Ù‚ÙŠÙ… Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡Ø§',0),(229890,6386,'fr','Valeurs autorisÃ©es',0),(229891,6386,'jp','è¨±å?¯ä¾¡å€¤',0),(229892,6386,'pt','Valores permitidos',0),(229893,6386,'ru','Ð”Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(229894,6386,'es','Valores Permitidos',0),(229895,6386,'de','ZulÃ¤ssigen Werte',0),(229896,6386,'en','Values Allowed',0),(229897,6387,'is','',0),(229898,6387,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø±Ø§ÙŠ Ø¬Ø¯ÙˆÙ„ ',0),(229899,6387,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø±Ø§ÙŠ Ø¬Ø¯ÙˆÙ„ ',0),(229900,6387,'tr','Tablo iÃ§in bilgi',0),(229901,6387,'pl','Informacje dla tabela',0),(229902,6387,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(229903,6387,'ur','Ø¬Ø¯ÙˆÙ„ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(229904,6387,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð·Ð° ÑÑ‚Ð¾Ð»Ð¾Ð¼',0),(229905,6387,'vi','ThÃ´ng Tin cho báº£ng',0),(229906,6387,'af','Inligting vir Tabel',0),(229907,6387,'ro','InformaÅ£ii pentru masÄƒ',0),(229908,6387,'et','Tabeli teave',0),(229909,6387,'si','Podatke za tabelo',0),(229910,6387,'ba','Informasi untuk tabel',0),(229911,6387,'nl','Gegevens voor tabel',0),(229912,6387,'fi','Taulukon tiedot',0),(229913,6387,'no','Informasjon for tabell',0),(229914,6387,'da','Information til tabel',0),(229915,6387,'ko','í…Œì´ë¸”ì— ëŒ€ í•œ ì •ë³´',0),(229916,6387,'he','×ž×™×“×¢ ×¢×œ ×”×©×•×œ×—×Ÿ',0),(229917,6387,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î¿Î½ Ï€Î¯Î½Î±ÎºÎ±',0),(229918,6387,'zh','ä¿¡æ¯è¡¨\r\n',0),(229919,6387,'sv','Information fÃ¶r tabell',0),(229920,6387,'it','Informazioni su tabella',0),(229921,6387,'tl','',0),(229922,6387,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3605;&#3634;&#3619;&#3634;&#3591;',0),(229923,6387,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(229924,6387,'ms','Maklumat Jadual',0),(229925,6387,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(229926,6387,'fr','Informations de la Table',0),(229927,6387,'jp','è¡¨ã?®æƒ…å ±',0),(229928,6387,'pt','InformaÃ§Ãµes para tabela',0),(229929,6387,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð»Ñ Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(229930,6387,'es','InformaciÃ³n para Tabla',0),(229931,6387,'de','Informationen fÃ¼r Tabelle',0),(229932,6387,'en','Information for Table',0),(229933,6388,'is','',0),(229934,6388,'dr','Ù„ÙŠØ³Øª ØªÙˆØ¶ÙŠØ­Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(229935,6388,'pr','Ù„ÙŠØ³Øª ØªÙˆØ¶ÙŠØ­Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(229936,6388,'tr','Listeyi veritabanÄ± aÃ§Ä±klamalar',0),(229937,6388,'pl','Lista baz danych wyjaÅ›nienia',0),(229938,6388,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¾Ð±ÑÑÐ½ÐµÐ½Ð¸Ñ',0),(229939,6388,'ur','ÙÛØ±Ø³Øª ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(229940,6388,'sr','ÐžÐ±Ñ˜Ð°ÑˆÑšÐµÑšÐ° Ð·Ð° Ð±Ð°Ð·Ñƒ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð»Ð¸ÑÑ‚Ðµ',0),(229941,6388,'vi','Danh sÃ¡ch giáº£i thÃ­ch cá»§a dá»¯ liá»‡u',0),(229942,6388,'af','Lys Databasis Verduidelikings',0),(229943,6388,'ro','ListÄƒ de date explicaÅ£ii',0),(229944,6388,'et','Loendi andmebaasi selgitused',0),(229945,6388,'si','Seznam bazi pojasnila',0),(229946,6388,'ba','Daftar Database penjelasan',0),(229947,6388,'nl','Lijst Database uitleg',0),(229948,6388,'fi','Luettelo tietokannan selityksiÃ¤',0),(229949,6388,'no','Liste Database forklaringer',0),(229950,6388,'da','Listen Database forklaringer',0),(229951,6388,'ko','ëª©ë¡ ë°ì´í„°ë² ì´ìŠ¤ ì„¤ëª…',0),(229952,6388,'he','×¨×©×™×ž×ª ×ž×¡×“ ×”× ×ª×•× ×™× ×”×¡×‘×¨×™×',0),(229953,6388,'el','Î›Î¯ÏƒÏ„Î± Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ ÎµÎ¾Î·Î³Î®ÏƒÎµÎ¹Ï‚',0),(229954,6388,'zh','æ•°æ®åº“åˆ—è¡¨è¯´æ˜Ž\r\n',0),(229955,6388,'sv','Lista databas fÃ¶rklaringar',0),(229956,6388,'it','Elenco Database spiegazioni',0),(229957,6388,'tl','',0),(229958,6388,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(229959,6388,'hi','à¤¸à¥‚à¤šà¥€ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥à¤ªà¤·à¥à¤Ÿà¥€à¤•à¤°à¤£',0),(229960,6388,'ms','Senarai pangkalan data penerangan',0),(229961,6388,'ar','Ø³Ø±Ø¯ ØªÙˆØ¶ÙŠØ­Ø§Øª Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(229962,6388,'fr','Ã‰numÃ©rer les explications de la base de donnÃ©es',0),(229963,6388,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã?®èª¬æ˜Žã‚’ãƒªã‚¹ãƒˆã?«ã?™ã‚‹',0),(229964,6388,'pt','ExplicaÃ§Ãµes do banco de dados de lista',0),(229965,6388,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¾Ð±ÑŠÑÑÐ½ÐµÐ½Ð¸Ð¹',0),(229966,6388,'es','Listar Explicaciones de Base de Datos',0),(229967,6388,'de','Liste Datenbank ErklÃ¤rungen',0),(229968,6388,'en','List Database Explanations',0),(229969,6389,'is','',0),(229970,6389,'dr','Ø´Ø±Ø­ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(229971,6389,'pr','Ø´Ø±Ø­ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(229972,6389,'tr','VeritabanÄ± aÃ§Ä±klama',0),(229973,6389,'pl','WyjaÅ›nienie bazy danych',0),(229974,6389,'bg','ÐžÐ±ÑÑÐ½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(229975,6389,'ur','ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(229976,6389,'sr','ÐžÐ±Ñ˜Ð°ÑˆÑšÐµÑšÐµ Ð·Ð° Ð±Ð°Ð·Ñƒ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(229977,6389,'vi','Giáº£i thÃ­ch dá»¯ liá»‡u',0),(229978,6389,'af','Databasis Verduideliking',0),(229979,6389,'ro','Baza de date explicaÅ£ie',0),(229980,6389,'et','Andmebaasi seletus',0),(229981,6389,'si','Razlaga zbirke podatkov',0),(229982,6389,'ba','Penjelasan database',0),(229983,6389,'nl','Database uitleg',0),(229984,6389,'fi','Tietokannan kuvaus',0),(229985,6389,'no','Databasen forklaring',0),(229986,6389,'da','Database forklaring',0),(229987,6389,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì„¤ëª…',0),(229988,6389,'he','×”×¡×‘×¨ ×ž×¡×“ × ×ª×•× ×™×',0),(229989,6389,'el','Î•Î¾Î®Î³Î·ÏƒÎ· Ï„Î·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(229990,6389,'zh','æ•°æ®åº“çš„è¯´æ˜Ž\r\n',0),(229991,6389,'sv','Databasen fÃ¶rklaring',0),(229992,6389,'it','Spiegazione del database',0),(229993,6389,'tl','',0),(229994,6389,'th','&#3585;&#3634;&#3619;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(229995,6389,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤µà¤¿à¤µà¤°à¤£',0),(229996,6389,'ms','Penjelasan pangkalan data',0),(229997,6389,'ar','ØªÙˆØ¶ÙŠØ­ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(229998,6389,'fr','Explication de la base de donnÃ©es',0),(229999,6389,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹èª¬æ˜Ž',0),(230000,6389,'pt','ExplicaÃ§Ã£o de banco de dados',0),(230001,6389,'ru','ÐžÐ±ÑŠÑÑÐ½ÐµÐ½Ð¸Ðµ Ð‘Ð°Ð·Ñ‹ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(230002,6389,'es','ExplicaciÃ³n de Base de Datos',0),(230003,6389,'de','Datenbank-ErklÃ¤rung',0),(230004,6389,'en','Database Explanation',0),(230005,6390,'is','',0),(230006,6390,'dr','Ø§Ú¯Ø± Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± â€“ Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡ÙŠ Ø¨Ø§ÙŠØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯',0),(230007,6390,'pr','Ø§Ú¯Ø± Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± â€“ Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡ÙŠ Ø¨Ø§ÙŠØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯',0),(230008,6390,'tr','kredi, borÃ§ amt olmalÄ±dÄ±r eÄŸer 0',0),(230009,6390,'pl','JeÅ›li kredytowej, debetowej UrzÄ…d powinien byÄ‡ 0',0),(230010,6390,'bg','ÐÐºÐ¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°, Ð´ÐµÐ±Ð¸Ñ‚Ð½Ð° amt Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ 0',0),(230011,6390,'ur','Ø§Ú¯Ø± Ú©Ø±ÛŒÚˆÙ¹ØŒ ÚˆÛŒØ¨Ù¹ Ø§Ù…Ù¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛØ¦Û’ 0',0),(230012,6390,'sr','Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° , Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð°Ð¼Ñ‚ Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° 0',0),(230013,6390,'vi','náº¿u ghi cÃ³, sá»‘ ná»£ pháº£i báº±ng 0',0),(230014,6390,'af','indien krediet, moet debietbedrag 0 wees',0),(230015,6390,'ro','DacÄƒ de credit, debit amt ar trebui sÄƒ fie 0',0),(230016,6390,'et','Kui krediit, deebet amt peaks olema 0',0),(230017,6390,'si','ÄŒe kreditno, debetno amt mora biti 0',0),(230018,6390,'ba','Jika kredit, debet amt harus 0',0),(230019,6390,'nl','Indien Credit, debet bedrag moet 0 zijn',0),(230020,6390,'fi','Jos luotto, maksukortti amt olisi 0',0),(230021,6390,'no','Hvis kreditt, debet amt bÃ¸r vÃ¦re 0',0),(230022,6390,'da','Hvis kredit, debet amt bÃ¸r vÃ¦re 0',0),(230023,6390,'ko','ì‹ ìš©, ì§ë¶ˆ amt í•´ì•¼ 0',0),(230024,6390,'he','×× ××©×¨××™, ×—×™×•×‘ amt ×¦×¨×™×š ×œ×”×™×•×ª 0',0),(230025,6390,'el','Î•Î¬Î½ Î· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®, Ï‡ÏÎµÏ‰ÏƒÏ„Î¹ÎºÎ® amt Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ 0',0),(230026,6390,'zh','å¦‚æžœæœ‰ä¿¡ç”¨ï¼Œå€Ÿè®°é‡‘é¢åº”ä¸º0\r\n',0),(230027,6390,'sv','om kreditkort, betalkort amt bÃ¶r vara 0',0),(230028,6390,'it','Se il credito, addebito amt dovrebbe essere 0',0),(230029,6390,'tl','',0),(230030,6390,'th','&#3606;&#3657;&#3634;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;, &#3618;&#3629;&#3604;&#3648;&#3604;&#3610;&#3636;&#3605;&#3588;&#3623;&#3619;&#3592;&#3632;&#3648;&#3611;&#3655;&#3609;&#3624;&#3641;&#3609;&#3618;&#3660;',0),(230031,6390,'hi','à¤¯à¤¦à¤¿ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ, à¤¡à¥‡à¤¬à¤¿à¤Ÿ amt à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤ 0',0),(230032,6390,'ms','Jika kredit, debit amt harus 0',0),(230033,6390,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ø®ØµÙ… Ø§Ù„ØªÙˆÙ†Ø³ÙŠÙŠÙ† Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†ØŒ ÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ÙŠÙƒÙˆÙ† 0',0),(230034,6390,'fr','Si crÃ©dit, dÃ©bit amt devrait Ãªtre 0',0),(230035,6390,'jp','ã‚‚ã?—è²¸ä»˜ã?ªã‚‰ã€?å€Ÿæ–¹é¡?ã?¯0ã?§ã?ªã?‘ã‚Œã?°ã?„ã?‘ã?¾ã?›ã‚“',0),(230036,6390,'pt','se crÃ©dito, dÃ©bito amt deve ser 0',0),(230037,6390,'ru','Ð•ÑÐ»Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚, Ð´ÐµÐ±ÐµÑ‚ amt Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ 0',0),(230038,6390,'es','Si crÃ©dito, monto de dÃ©bito debe ser 0',0),(230039,6390,'de','Wenn Kredit-, Debit Amt wÃ¤re 0',0),(230040,6390,'en','if credit, debit amt should be 0',0),(230041,6391,'is','',0),(230042,6391,'dr','- Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± Ø¨Ø§ÙŠØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(230043,6391,'pr','Ø§Ú¯Ø± Ø¨Ø¯Ù‡ÙƒØ§Ø±- Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± Ø¨Ø§ÙŠØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(230044,6391,'tr','borÃ§, kredi amt olmalÄ±dÄ±r eÄŸer 0',0),(230045,6391,'pl','JeÅ›li dÅ‚ug, kredyt UrzÄ…d powinien byÄ‡ 0',0),(230046,6391,'bg','ÐÐºÐ¾ Ð´ÑŠÐ»Ð³, ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ amt Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ 0',0),(230047,6391,'ur','Ø§Ú¯Ø± Ù‚Ø±Ø¶ØŒ Ú©Ø±ÛŒÚˆÙ¹ Ø§Ù…Ù¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛØ¦Û’ 0',0),(230048,6391,'sr','Ð´ÑƒÐ³Ð° , ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ Ð°Ð¼Ñ‚ Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° 0',0),(230049,6391,'vi','náº¿u ghi ná»£, sá»‘ cÃ³ pháº£i báº±ng 0',0),(230050,6391,'af','indien debiet, moet kredietbedrag 0 wees',0),(230051,6391,'ro','DacÄƒ datoria, credit amt ar trebui sÄƒ fie 0',0),(230052,6391,'et','Kui vÃµlg, krediidi amt peaks olema 0',0),(230053,6391,'si','ÄŒe dolga, kreditne amt mora biti 0',0),(230054,6391,'ba','Jika utang, kredit amt harus 0',0),(230055,6391,'nl','Indien debet, credit bedrag moet 0 zijn',0),(230056,6391,'fi','Jos velka, luotto amt olisi 0',0),(230057,6391,'no','Hvis gjeld, kreditt amt bÃ¸r vÃ¦re 0',0),(230058,6391,'da','Hvis gÃ¦ld, credit amt bÃ¸r vÃ¦re 0',0),(230059,6391,'ko','ë§Œì•½ ë¶€ì±„, ì‹ ìš© amt ì´ì–´ì•¼ í•œë‹¤ 0',0),(230060,6391,'he','×× ×”×—×•×‘, ××©×¨××™ amt ×¦×¨×™×š ×œ×”×™×•×ª 0',0),(230061,6391,'el','Î‘Î½ Ï‡ÏÎ­Î¿Ï…Ï‚, Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® amt Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ 0',0),(230062,6391,'zh','å¦‚æžœæœ‰å€ºåŠ¡ï¼Œä¿¡ç”¨æ•°é‡çš„åº”è¯¥æ˜¯0\r\n',0),(230063,6391,'sv','om skuld, kredit amt bÃ¶r vara 0',0),(230064,6391,'it','Se il debito, credito amt dovrebbe essere 0',0),(230065,6391,'tl','',0),(230066,6391,'th','&#3606;&#3657;&#3634;&#3648;&#3604;&#3610;&#3636;&#3605;, &#3618;&#3629;&#3604;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3588;&#3623;&#3619;&#3592;&#3632;&#3648;&#3611;&#3655;&#3609;&#3624;&#3641;&#3609;&#3618;&#3660;',0),(230067,6391,'hi','à¤¯à¤¦à¤¿ à¤‹à¤£, à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ amt à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤ 0',0),(230068,6391,'ms','Jika hutang, amt kredit harus 0',0),(230069,6391,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ù‚Ø¶Ø§Ø© Ø§Ù„ØªÙˆÙ†Ø³ÙŠÙŠÙ† Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ø¯ÙŠÙˆÙ†ØŒ ÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ÙŠÙƒÙˆÙ† 0',0),(230070,6391,'fr','Si la dette, crÃ©dit amt devrait Ãªtre 0',0),(230071,6391,'jp','ã‚‚ã?—å€Ÿæ–¹ã?ªã‚‰ã€?è²¸ä»˜é¡?ã?¯ï¼?ã?§ã?ªã?‘ã‚Œã?°ã?„ã?‘ã?¾ã?›ã‚“',0),(230072,6391,'pt','se dÃ­vida, crÃ©dito amt deve ser 0',0),(230073,6391,'ru','Ð•ÑÐ»Ð¸ Ð´Ð¾Ð»Ð³, ÐºÑ€ÐµÐ´Ð¸Ñ‚ amt Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ 0',0),(230074,6391,'es','Si dÃ©bito, monto de crÃ©dito debe ser 0',0),(230075,6391,'de','Wenn Schulden, Kredit Amt wÃ¤re 0',0),(230076,6391,'en','if debt, credit amt should be 0',0),(230077,6392,'is','',0),(230078,6392,'dr','Ø¨Ø§ÙŠØ¯ Ø¯Ù‚ÙŠÙ‚Ø§ Ù…Ø§Ù†Ù†Ø¯ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ù†Ø§Ù…Ú¯Ø°Ø§Ø±ÙŠ Ø´ÙˆØ¯ ',0),(230079,6392,'pr','Ø¨Ø§ÙŠØ¯ Ø¯Ù‚ÙŠÙ‚Ø§ Ù…Ø§Ù†Ù†Ø¯ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ù†Ø§Ù…Ú¯Ø°Ø§Ø±ÙŠ Ø´ÙˆØ¯ ',0),(230080,6392,'tr','adlandÄ±rÄ±lmÄ±ÅŸ tam olarak varolan GL hesabÄ± gerekir',0),(230081,6392,'pl','naleÅ¼y o nazwie dokÅ‚adnie jak istniejÄ…ce konto GL',0),(230082,6392,'bg','Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ðµ Ñ‚Ð¾Ñ‡Ð½Ð¾ ÐºÐ°Ñ‚Ð¾ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(230083,6392,'ur','Ù†Ø§Ù… Ù¹Ú¾ÛŒÚ© Ø·ÙˆØ± Ù¾Ø± Ù…ÙˆØ¬ÙˆØ¯Û Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú†Ø§ÛÛŒÛ’',0),(230084,6392,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° ÑÐµ Ð·Ð¾Ð²Ðµ ÑƒÐ¿Ñ€Ð°Ð²Ð¾ ÐºÐ°Ð¾ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð“Ð›',0),(230085,6392,'vi','pháº£i Ä‘Æ°a chÃ­nh xÃ¡c tÃªn nhÆ° TK sá»• cÃ¡i hiá»‡n thá»i',0),(230086,6392,'af','moet presies dieselfde noem as bestaande AG Rekening',0),(230087,6392,'ro','trebuie numit cont exact ca existent GL',0),(230088,6392,'et','peab nimega tÃ¤pselt olemasolevate pearaamatukontole',0),(230089,6392,'si','mora imenovan toÄno kot obstojeÄi raÄun GL',0),(230090,6392,'ba','harus bernama persis seperti GL akun',0),(230091,6392,'nl','benoemde precies zo bestaande GL rekening moet',0),(230092,6392,'fi','on nimetty juuri nykyisen Kirjanpitotilin pÃ¤Ã¤tilin',0),(230093,6392,'no','mÃ¥ navngitt akkurat som eksisterende gi-konto',0),(230094,6392,'da','skal navngivne prÃ¦cis som eksisterende GL konto',0),(230095,6392,'ko','ë°˜ë“œì‹œ ì •í™• í•˜ ê²Œ ê¸°ì¡´ì˜ GL ê³„ì • ì´ë¼ëŠ”',0),(230096,6392,'he','×—×•×‘×” ×‘×©× ×”×—×©×‘×•×Ÿ GL ×‘×“×™×•×§ ×›×ž×• ×”×§×™×™×',0),(230097,6392,'el','Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿Î½Î¿Î¼Î¬Î¶ÎµÏ„Î±Î¹ Î±ÎºÏÎ¹Î²ÏŽÏ‚ Ï‰Ï‚ Ï…Ï†Î¹ÏƒÏ„Î¬Î¼ÎµÎ½Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(230098,6392,'zh','å‘½åä¸ºçŽ°æœ‰GLå¸æˆ·å¿…é¡»å‡†ç¡®\r\n',0),(230099,6392,'sv','mÃ¥ste namngivna exakt lika befintligt GL-konto',0),(230100,6392,'it','deve il nome Account GL esattamente come esistente',0),(230101,6392,'tl','',0),(230102,6392,'th','&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3594;&#3639;&#3656;&#3629;&#3605;&#3619;&#3591;&#3585;&#3633;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3',0),(230103,6392,'hi','à¤¨à¤¾à¤®à¤¾à¤‚à¤•à¤¿à¤¤ à¤µà¤¾à¤¸à¥à¤¤à¤µ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ GL à¤–à¤¾à¤¤à¤¾ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(230104,6392,'ms','mesti nama akaun GL yang betul-betul seperti sedia ada',0),(230105,6392,'ar','ÙŠØ¬Ø¨ Ø­Ø³Ø§Ø¨ GL Ø¨Ø§Ù„Ø¶Ø¨Ø· ÙƒÙ…Ø§ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ø³Ù…Ø§Ø©',0),(230106,6392,'fr','moÃ»t nommÃ© exactement comme existant compte GL',0),(230107,6392,'jp','å­˜åœ¨ã?™ã‚‹ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã?¨å?Œä¸€ã?®å??å‰?ã‚’ã?¤ã?‘ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(230108,6392,'pt','deve nomeado conta exatamente como existente de GL',0),(230109,6392,'ru','Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ñ‚Ð¾Ñ‡Ð½Ð¾ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… GL ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ñ Ð¸Ð¼ÐµÐ½ÐµÐ¼',0),(230110,6392,'es','Se debe nombrar exactamente como Cuenta LM existente',0),(230111,6392,'de','muss mit dem Namen genau wie vorhandene Hauptbuchkonto',0),(230112,6392,'en','must named exactly as existing GL Account',0),(230113,6393,'is','',0),(230114,6393,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ†',0),(230115,6393,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ†',0),(230116,6393,'tr','Ort.',0),(230117,6393,'pl','Åšr.',0),(230118,6393,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð°',0),(230119,6393,'ur','Avg.',0),(230120,6393,'sr','ÐŸÐ¾Ð»Ð°Ð·Ð¸ÑˆÑ‚Ðµ',0),(230121,6393,'vi','Trung BÃ¬nh',0),(230122,6393,'af','Gemidd.',0),(230123,6393,'ro','AVG.',0),(230124,6393,'et','Keskm.',0),(230125,6393,'si','AVG.',0),(230126,6393,'ba','Rata-rata',0),(230127,6393,'nl','Gem.',0),(230128,6393,'fi','Keskim.',0),(230129,6393,'no','Gj.snitt.',0),(230130,6393,'da','AVG.',0),(230131,6393,'ko','í‰ê· ',0),(230132,6393,'he','Avg.',0),(230133,6393,'el','Îœ.Î¿.',0),(230134,6393,'zh','å¹³å‡ã€‚\r\n',0),(230135,6393,'sv','AVG.',0),(230136,6393,'it','AVG.',0),(230137,6393,'tl','',0),(230138,6393,'th','&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;',0),(230139,6393,'hi','à¤”à¤¸à¤¤',0),(230140,6393,'ms','Purata',0),(230141,6393,'ar','Ù…ØªÙˆØ³Ø·.',0),(230142,6393,'fr','Moy.',0),(230143,6393,'jp','å¹³å?‡',0),(230144,6393,'pt','AVG.',0),(230145,6393,'ru','AVG.',0),(230146,6393,'es','Prom.',0),(230147,6393,'de','AVG.',0),(230148,6393,'en','Avg.',0),(230149,6394,'is','',0),(230150,6394,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ ',0),(230151,6394,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ ',0),(230152,6394,'tr','MÃ¼ÅŸteri iÃ§in madde geÃ§miÅŸi',0),(230153,6394,'pl','Historia towaru nabywcy dla',0),(230154,6394,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð·Ð°',0),(230155,6394,'ur','Ú©Ø³Ù¹Ù…Ø± Ø´Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(230156,6394,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑƒÐ¿Ñ†Ð° Ð·Ð°',0),(230157,6394,'vi','Lá»‹ch sá»­ hÃ ng cá»§a khÃ¡ch hÃ ng cho',0),(230158,6394,'af','Klant / KliÃ«nt Itemgeskiedenis vir',0),(230159,6394,'ro','Client articol istorie pentru',0),(230160,6394,'et','Kliendi kauba ajalugu',0),(230161,6394,'si','Zgodovina artikla kupcu za',0),(230162,6394,'ba','Sejarah Item pelanggan untuk',0),(230163,6394,'nl','Item klantgeschiedenis voor',0);
INSERT INTO `langdef` VALUES (230164,6394,'fi','Asiakkaan kohteen historia',0),(230165,6394,'no','Kundehistorikk element For',0),(230166,6394,'da','Kunde vare historie For',0),(230167,6394,'ko','ê³ ê°ì— ëŒ€ í•œ í•­ëª© ê¸°ë¡',0),(230168,6394,'he','×œ×§×•×—×•×ª ×”×™×¡×˜×•×¨×™×™×ª ×¤×¨×™×˜ ×¢×‘×•×¨',0),(230169,6394,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· Î³Î¹Î±',0),(230170,6394,'zh','å®¢æˆ·é¡¹ç›®åŽ†å²è®°å½•\r\n',0),(230171,6394,'sv','Kunden objektet historia fÃ¶r',0),(230172,6394,'it','Cliente elemento storia per',0),(230173,6394,'tl','',0),(230174,6394,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3607;&#3635;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;',0),(230175,6394,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤‡à¤Ÿà¤® à¤•à¤¾ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(230176,6394,'ms','Baca Item sejarah bagi',0),(230177,6394,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(230178,6394,'fr','Client historique d\'Ã©lÃ©ment pour',0),(230179,6394,'jp','é¡§å®¢å“?ç›®å±¥æ­´',0),(230180,6394,'pt','HistÃ³rico de Item do cliente para',0),(230181,6394,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¢Ð¾Ð²Ð°Ñ€Ð° ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð”Ð»Ñ',0),(230182,6394,'es','Cliente Historia de Items Para',0),(230183,6394,'de','Versionsgeschichte fÃ¼r Kunden',0),(230184,6394,'en','Customer Item History For',0),(230185,6395,'is','',0),(230186,6395,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø±Ø§ÙŠ ',0),(230187,6395,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø±Ø§ÙŠ ',0),(230188,6395,'tr','MÃ¼ÅŸteri iÃ§in sipariÅŸ geÃ§miÅŸi',0),(230189,6395,'pl','Historia zamÃ³wienia klienta',0),(230190,6395,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸Ñ‚Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð·Ð°',0),(230191,6395,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(230192,6395,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° ÐºÑƒÐ¿Ñ†Ð° Ð·Ð°',0),(230193,6395,'vi','Lá»‹ch sá»­ Ä‘Æ¡n Ä‘áº·t hÃ ng cá»§a khÃ¡ch hÃ ng cho',0),(230194,6395,'af','Klant / KliÃ«nt Bestellingsgeskiedenis vir',0),(230195,6395,'ro','Istoric comandÄƒ client pentru',0),(230196,6395,'et','Kliendi tellimuse ajalugu',0),(230197,6395,'si','Zgodovino naroÄil kupcev',0),(230198,6395,'ba','Sejarah pesanan pelanggan untuk',0),(230199,6395,'nl','Geschiedenis van de bestelling van de klant voor',0),(230200,6395,'fi','Asiakkaan tilaushistoriaa varten',0),(230201,6395,'no','Kundens ordrehistorikk for',0),(230202,6395,'da','Kundens ordrehistorik for',0),(230203,6395,'ko','ê³ ê° ì£¼ë¬¸ ë‚´ì—­ì— ëŒ€ í•œ',0),(230204,6395,'he','×”×™×¡×˜×•×¨×™×™×ª ×”×”×–×ž× ×•×ª ×œ×œ×§×•×— ×¢×‘×•×¨',0),(230205,6395,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î³Î¹Î±',0),(230206,6395,'zh','å²çš„å®¢æˆ·è®¢å•\r\n',0),(230207,6395,'sv','Kundens orderhistorik fÃ¶r',0),(230208,6395,'it','Storico ordini cliente per',0),(230209,6395,'tl','',0),(230210,6395,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(230211,6395,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤†à¤¦à¥‡à¤¶ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(230212,6395,'ms','Baca sejarah perintah bagi',0),(230213,6395,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(230214,6395,'fr','Historique des commandes client pour',0),(230215,6395,'jp','é¡§å®¢æ³¨æ–‡å±¥æ­´',0),(230216,6395,'pt','HistÃ³rico de ordens do cliente para',0),(230217,6395,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð—Ð°ÐºÐ°Ð·Ð¾Ð² ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð´Ð»Ñ',0),(230218,6395,'es','Cliente Historia de Pedidos para',0),(230219,6395,'de','Kunden-Bestellungen fÃ¼r',0),(230220,6395,'en','Customer Order History for',0),(230221,6396,'is','',0),(230222,6396,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯Ø§Ø± ÙƒØ§Ù„Ø§  Ø¨Ø±Ø§ÙŠ ',0),(230223,6396,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯Ø§Ø± ÙƒØ§Ù„Ø§  Ø¨Ø±Ø§ÙŠ ',0),(230224,6396,'tr','Madde mÃ¼ÅŸteri sipariÅŸ geÃ§miÅŸi',0),(230225,6396,'pl','Element historii zamÃ³wieÅ„ klienta dla',0),(230226,6396,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¥Ñ€Ð¾Ð½Ð¾Ð»Ð¾Ð³Ð¸Ñ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð·Ð°',0),(230227,6396,'ur','Ø´Û’ Ú©Ø³Ù¹Ù…Ø± Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(230228,6396,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑƒÐ¿Ñ†Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(230229,6396,'vi','Lá»‹ch sá»­ hÃ ng khÃ¡ch Ä‘áº·t cho',0),(230230,6396,'af','Item Klant/KliÃ«nt Bestellingsgeskiedenis Vir',0),(230231,6396,'ro','Elementul client istoricul comenzilor pentru',0),(230232,6396,'et','Kauba kliendi tellimuste ajalugu',0),(230233,6396,'si','Element zgodovine naroÄil strank za',0),(230234,6396,'ba','Sejarah pesanan pelanggan item untuk',0),(230235,6396,'nl','Object de geschiedenis van de bestelling van de klant voor',0),(230236,6396,'fi','Nimikkeen asiakkaan tilaushistoriaa varten',0),(230237,6396,'no','Elementet kundens ordrehistorikk For',0),(230238,6396,'da','Vare kunde ordrehistorik For',0),(230239,6396,'ko','í•­ëª©ì— ëŒ€ í•œ ê³ ê° ì£¼ë¬¸ ë‚´ì—­',0),(230240,6396,'he','×¤×¨×™×˜ ××”×•×‘ ×”×™×¡×˜×•×¨×™×™×ª ×”×”×–×ž× ×•×ª ×¢×‘×•×¨',0),(230241,6396,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³Î¹Î±',0),(230242,6396,'zh','é¡¹ç›®å®¢æˆ·è®¢å•åŽ†å²è®°å½•\r\n',0),(230243,6396,'sv','Objektet kundens orderhistorik fÃ¶r',0),(230244,6396,'it','Cronologia dell\'ordine cliente elemento per',0),(230245,6396,'tl','',0),(230246,6396,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(230247,6396,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤†à¤¦à¥‡à¤¶ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(230248,6396,'ms','Sejarah perintah Baca item bagi',0),(230249,6396,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„ØªØ§Ø±ÙŠØ® Ø£Ù…Ø± Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(230250,6396,'fr','Historique des commandes client point pour',0),(230251,6396,'jp','ï½žã?®å“?ç›®é¡§å®¢æ³¨æ–‡å±¥æ­´',0),(230252,6396,'pt','Item histÃ³rico de ordens do cliente para',0),(230253,6396,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð´Ð»Ñ',0),(230254,6396,'es','Item Cliente Historia de Ordenes Para',0),(230255,6396,'de','Kunden bestellen Versionsgeschichte fÃ¼r',0),(230256,6396,'en','Item Customer Order History For',0),(230257,6397,'is','',0),(230258,6397,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(230259,6397,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(230260,6397,'tr','Bir B2B satÄ±cÄ± kullanÄ±cÄ± listeleri ekleme',0),(230261,6397,'pl','Dodaj listy uÅ¼ytkownikÃ³w dostawcy B2B',0),(230262,6397,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° B2B Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(230263,6397,'ur','B2B ÙˆÛŒÙ†ÚˆØ± ØµØ§Ø±ÙÛŒÙ† Ú©ÛŒ ÙÛØ±Ø³Øª Ù…ÛŒÚº Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(230264,6397,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð‘2Ð‘ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(230265,6397,'vi','ThÃªm Danh SÃ¡ch NgÆ°á»i Sá»­ Dá»¥ng cá»§a NgÆ°á»i BÃ¡n B2B ',0),(230266,6397,'af','Lyste van B2B Verskafer Gebruikers Byvoeg',0),(230267,6397,'ro','Adauga listele utilizatorilor B2B Furnizori ',0),(230268,6397,'et','Lisa B2B hankijate nimekirju',0),(230269,6397,'si','Dodajte sezname B2B dobavitelja uporabnikov',0),(230270,6397,'ba','Tambah daftar untuk pemasok B2B',0),(230271,6397,'nl','Lijsten van B2B leverancier gebruikers toevoegen',0),(230272,6397,'fi','LisÃ¤tÃ¤ luetteloita B2B toimittajan kÃ¤yttÃ¤jien',0),(230273,6397,'no','Legge til lister med B2B leverandÃ¸r brukere',0),(230274,6397,'da','TilfÃ¸je lister over B2B kreditor brugere',0),(230275,6397,'ko','B2B ê³µê¸‰ ì—…ì²´ ì‚¬ìš©ìžì˜ ëª©ë¡ì„ ì¶”ê°€í•©ë‹ˆë‹¤',0),(230276,6397,'he','×œ×”×•×¡×™×£ ×¨×©×™×ž×•×ª ×©×œ ×ž×©×ª×ž×©×™× ×”×¡×¤×§ B2B',0),(230277,6397,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¹Ï‚ Î»Î¯ÏƒÏ„ÎµÏ‚ Ï„Ï‰Î½ B2B Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½',0),(230278,6397,'zh','ç”¨æˆ·å¢žåŠ çš„ä¼ä¸šå¯¹ä¼ä¸šå®¢æˆ·\r\nä¾›åº”å•†åå•\r\n',0),(230279,6397,'sv','LÃ¤gga till listor med B2B leverantÃ¶r anvÃ¤ndare',0),(230280,6397,'it','Aggiungere liste di utenti fornitore B2B',0),(230281,6397,'tl','',0),(230282,6397,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609; B2B',0),(230283,6397,'hi','B2B à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(230284,6397,'ms','Tambah senarai pengguna penjual B2B',0),(230285,6397,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ù…ÙˆØ±Ø¯ B2B',0),(230286,6397,'fr','Ajouter listes d\'Usagers de Fournisseurs B2B',0),(230287,6397,'jp','ï¼¢ï¼’ï¼¢æ¥­è€…ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®ãƒªã‚¹ãƒˆè¿½åŠ ',0),(230288,6397,'pt','Adicionar listas de usuÃ¡rios de fornecedor B2B',0),(230289,6397,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡Ð¿Ð¸ÑÐºÐ¸ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ B2B',0),(230290,6397,'es','Agregar Listas de Usuarios de Proveedores B2B',0),(230291,6397,'de','FÃ¼gen Sie Benutzerlisten B2B Hersteller',0),(230292,6397,'en','Add Lists of B2B Vendor Users',0),(230293,6398,'is','',0),(230294,6398,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(230295,6398,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(230296,6398,'tr','B2B mÃ¼ÅŸteri kullanÄ±cÄ±lar listeleri ekleme',0),(230297,6398,'pl','Dodaj listy uÅ¼ytkownikÃ³w klienta B2B',0),(230298,6398,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° B2B ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(230299,6398,'ur','B2B Ú¯Ø§ÛÚ© ØµØ§Ø±ÙÛŒÙ† Ú©ÛŒ ÙÛØ±Ø³Øª Ù…ÛŒÚº Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(230300,6398,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð‘2Ð‘ ÐºÑƒÐ¿Ñ†Ð°',0),(230301,6398,'vi','ThÃªm Danh SÃ¡ch NgÆ°á»i Sá»­ Dá»¥ng cá»§a KhÃ¡ch HÃ ng B2B',0),(230302,6398,'af','Lyste van B2B KliÃ«nte/Klante Gebruikers Byvoeg',0),(230303,6398,'ro','Adauga listele utilizatorilor B2B Clienti',0),(230304,6398,'et','Lisa B2B klientide nimekirju',0),(230305,6398,'si','Dodajte sezname B2B kupcev uporabnikov',0),(230306,6398,'ba','Tambah daftar untuk pelanggan B2B',0),(230307,6398,'nl','Lijsten van B2B klant gebruikers toevoegen',0),(230308,6398,'fi','LisÃ¤tÃ¤ luetteloita B2B asiakkaan kÃ¤yttÃ¤jien',0),(230309,6398,'no','Legge til lister med B2B kunden brukere',0),(230310,6398,'da','TilfÃ¸je lister over B2B kunde brugere',0),(230311,6398,'ko','B2B ê³ ê° ì‚¬ìš©ìžì˜ ëª©ë¡ì„ ì¶”ê°€í•©ë‹ˆë‹¤',0),(230312,6398,'he','×œ×”×•×¡×™×£ ×¨×©×™×ž×•×ª ×©×œ ×ž×©×ª×ž×©×™× ×œ×§×•×—×•×ª B2B',0),(230313,6398,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¹Ï‚ Î»Î¯ÏƒÏ„ÎµÏ‚ Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½ Ï€ÎµÎ»Î¬Ï„Î·Ï‚ B2B',0),(230314,6398,'zh','ç”¨æˆ·å¢žåŠ çš„å¤–éƒ¨ä¼ä¸šå¯¹ä¼ä¸šå®¢æˆ·åå•\r\n',0),(230315,6398,'sv','LÃ¤gga till listor med B2B kund anvÃ¤ndare',0),(230316,6398,'it','Aggiungere liste di utenti di cliente B2B',0),(230317,6398,'tl','',0),(230318,6398,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609; B2B',0),(230319,6398,'hi','B2B à¤—à¥à¤°à¤¾à¤¹à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(230320,6398,'ms','Tambah senarai pengguna pelanggan B2B',0),(230321,6398,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚ÙˆØ§Ø¦Ù… Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ø¹Ù…ÙŠÙ„ B2B',0),(230322,6398,'fr','Ajouter listes d\'Usagers de Client Externe B2B',0),(230323,6398,'jp','ï¼¢ï¼’ï¼¢é¡§å®¢ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®ãƒªã‚¹ãƒˆè¿½åŠ ',0),(230324,6398,'pt','Adicionar listas de usuÃ¡rios do cliente B2B',0),(230325,6398,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡Ð¿Ð¸ÑÐºÐ¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ B2B',0),(230326,6398,'es','Agregar Listas de Usuarios de Clientes B2B',0),(230327,6398,'de','FÃ¼gen Sie Listen von B2B-Kunden',0),(230328,6398,'en','Add Lists of B2B Customer Users',0),(230329,6399,'is','',0),(230330,6399,'dr','B2B Ø³Ø§ÙŠØª   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(230331,6399,'pr','B2B Ø³Ø§ÙŠØª   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(230332,6399,'tr','B2B sitesi',0),(230333,6399,'pl','B2B witryny',0),(230334,6399,'bg','B2B ÑÐ°Ð¹Ñ‚',0),(230335,6399,'ur','B2B Ø³Ø§Ø¦Ù¹',0),(230336,6399,'sr','Ð‘2Ð‘ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(230337,6399,'vi','Trang B2B',0),(230338,6399,'af','B2B werf',0),(230339,6399,'ro','Site-ul B2B',0),(230340,6399,'et','B2B leht',0),(230341,6399,'si','B2B spletno stran',0),(230342,6399,'ba','Situs B2B',0),(230343,6399,'nl','B2B Site',0),(230344,6399,'fi','B2B sivusto',0),(230345,6399,'no','B2B webomrÃ¥de',0),(230346,6399,'da','B2B Site',0),(230347,6399,'ko','B2B ì‚¬ì´íŠ¸',0),(230348,6399,'he','××ª×¨ B2B',0),(230349,6399,'el','B2B Site',0),(230350,6399,'zh','B2Bç½‘ç«™\r\n',0),(230351,6399,'sv','B2B webbplats',0),(230352,6399,'it','Sito azienda B2B',0),(230353,6399,'tl','',0),(230354,6399,'th','&#3604;&#3657;&#3634;&#3609; B2B',0),(230355,6399,'hi','B2B à¤¸à¤¾à¤‡à¤Ÿ',0),(230356,6399,'ms','Laman web B2B',0),(230357,6399,'ar','Ù…ÙˆÙ‚Ø¹ Ø´Ø±ÙƒØ§Ø¡ Ø§Ù„ØªØ¹Ø§Ù…Ù„',0),(230358,6399,'fr','Site B2B',0),(230359,6399,'jp','B2B ã‚µã‚¤ãƒˆ',0),(230360,6399,'pt','Site de B2B',0),(230361,6399,'ru','Ð¡Ð°Ð¹Ñ‚ B2B',0),(230362,6399,'es','N2N Sitio',0),(230363,6399,'de','B2B-Website',0),(230364,6399,'en','B2B Site',0),(230365,6400,'is','',0),(230366,6400,'dr','ÙˆØ±ÙˆØ¯ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(230367,6400,'pr','ÙˆØ±ÙˆØ¯ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø®Ø±ÙŠØ¯Ø§Ø± ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(230368,6400,'tr','MÃ¼ÅŸteri B2B giriÅŸ kullanÄ±cÄ±lar',0),(230369,6400,'pl','Klienta B2B logowania uÅ¼ytkownikÃ³w',0),(230370,6400,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ B2B Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(230371,6400,'ur','Ú©Ø³Ù¹Ù…Ø± B2B Ù„Ø§Ú¯ Ø§Ù† ØµØ§Ø±ÙÛŒÙ†',0),(230372,6400,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð‘2Ð‘ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(230373,6400,'vi','NgÆ°á»i Sá»­ Dá»¥ng Cá»§a KhÃ¡ch HÃ ng B2B ÄÄƒng Nháº­p',0),(230374,6400,'af','Klant/KliÃ«nt B2B Aangetekende Gebruikers',0),(230375,6400,'ro','Utilizatori client cu logare B2B',0),(230376,6400,'et','B2B klientide kasutajanimed',0),(230377,6400,'si','Kupec B2B prepriÄevalnost uporabnik',0),(230378,6400,'ba','Pelanggan B2B Login pengguna',0),(230379,6400,'nl','Gebruikers van Customer B2B Login',0),(230380,6400,'fi','Asiakkaan B2B Login kÃ¤yttÃ¤jÃ¤',0),(230381,6400,'no','Kunden B2B logikk brukere',0),(230382,6400,'da','Kunde B2B Login brugere',0),(230383,6400,'ko','ê³ ê° B2B ë¡œê·¸ì¸ ì‚¬ìš©ìž',0),(230384,6400,'he','×œ×§×•×—×•×ª B2B ×›× ×™×¡×” ×œ×ž×©×ª×ž×©×™×',0),(230385,6400,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ B2B ÏƒÏÎ½Î´ÎµÏƒÎ· Ï‡ÏÎ®ÏƒÏ„ÏŽÎ½',0),(230386,6400,'zh','å®¢æˆ·å•†ä¸šå¯¹å•†ä¸šç™»å½•ç”¨æˆ·\r\n',0),(230387,6400,'sv','Kunden B2B inloggning anvÃ¤ndare',0),(230388,6400,'it','Cliente B2B Login utenti',0),(230389,6400,'tl','',0),(230390,6400,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657; B2B &#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(230391,6400,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• B2B à¤²à¥‰à¤—à¤¿à¤¨ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(230392,6400,'ms','Pelanggan B2B Login pengguna',0),(230393,6400,'ar','Ù…Ø³ØªØ®Ø¯Ù…Ùˆ Ø§Ù„Ø²Ø¨ÙˆÙ† - Ø´Ø±ÙƒØ§Ø¡ Ø§Ù„ØªØ¹Ø§Ù…Ù„',0),(230394,6400,'fr','Client B2B connexion utilisateurs',0),(230395,6400,'jp','é¡§å®¢B2Bãƒ­ã‚°ã‚¤ãƒ³ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(230396,6400,'pt','UsuÃ¡rios de logon do cliente B2B',0),(230397,6400,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ B2B Ð»Ð¾Ð³Ð¸Ð½ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(230398,6400,'es','Cliente N2N Usuarios de Login',0),(230399,6400,'de','B2B Login Kunden',0),(230400,6400,'en','Customer B2B Login Users',0),(230401,6401,'is','',0),(230402,6401,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(230403,6401,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(230404,6401,'tr','MÃ¼ÅŸteri sipariÅŸ geÃ§miÅŸi',0),(230405,6401,'pl','HistoriÄ™ zamÃ³wieÅ„ klienta',0),(230406,6401,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(230407,6401,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(230408,6401,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(230409,6401,'vi','Lá»‹ch sá»­ Ä‘Æ¡n Ä‘áº·t hÃ ng cá»§a khÃ¡ch hÃ ng',0),(230410,6401,'af','Klant / KliÃ«nt Bestellingsgeskiedenis',0),(230411,6401,'ro','Istoric de comandÄƒ client',0),(230412,6401,'et','Kliendi tellimuste ajalugu',0),(230413,6401,'si','Zgodovino naroÄil kupcev',0),(230414,6401,'ba','Sejarah pesanan pelanggan',0),(230415,6401,'nl','Klant bestelgeschiedenis',0),(230416,6401,'fi','Asiakkaan tilaushistoriaa',0),(230417,6401,'no','Kundens ordrehistorikk',0),(230418,6401,'da','Kundens ordrehistorik',0),(230419,6401,'ko','ê³ ê° ì£¼ë¬¸ ë‚´ì—­',0),(230420,6401,'he','×”×™×¡×˜×•×¨×™×™×ª ×”×”×–×ž× ×•×ª ×œ×œ×§×•×—',0),(230421,6401,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(230422,6401,'zh','å®¢æˆ·è®¢å•åŽ†å²\r\n',0),(230423,6401,'sv','Kundens orderhistorik',0),(230424,6401,'it','Storico ordini cliente',0),(230425,6401,'tl','',0),(230426,6401,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(230427,6401,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤†à¤¦à¥‡à¤¶ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(230428,6401,'ms','Baca sejarah perintah',0),(230429,6401,'ar','Ø­Ø±ÙƒØ© Ø·Ù„Ø¨ÙŠØ§Øª Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(230430,6401,'fr','Historique des commandes client',0),(230431,6401,'jp','é¡§å®¢æ³¨æ–‡å±¥æ­´',0),(230432,6401,'pt','HistÃ³rico de pedidos do cliente',0),(230433,6401,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð—Ð°ÐºÐ°Ð·Ð¾Ð² ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(230434,6401,'es','Cliente Historia de Pedidos',0),(230435,6401,'de','Kunden-Bestellungen',0),(230436,6401,'en','Customer Order History',0),(230437,6402,'is','',0),(230438,6402,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§',0),(230439,6402,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§',0),(230440,6402,'tr','Madde sipariÅŸ geÃ§miÅŸi',0),(230441,6402,'pl','Element historii zamÃ³wieÅ„',0),(230442,6402,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸Ñ‚Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(230443,6402,'ur','Ø´Û’ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(230444,6402,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(230445,6402,'vi','Lá»‹ch sá»­ Ä‘áº·t hÃ ng',0),(230446,6402,'af','Item Bestelling Geskiedenis',0),(230447,6402,'ro','Istoric de comandÄƒ element',0),(230448,6402,'et','Kauba tellimuste ajalugu',0),(230449,6402,'si','Element zgodovine naroÄil',0),(230450,6402,'ba','Sejarah Orde item',0),(230451,6402,'nl','Item bestelgeschiedenis',0),(230452,6402,'fi','Nimikkeen tilaushistoria',0),(230453,6402,'no','Elementet ordrehistorikk',0),(230454,6402,'da','Vare ordreoversigten',0),(230455,6402,'ko','í•­ëª© ìˆœì„œ ì—­ì‚¬',0),(230456,6402,'he','×”×¡×˜×•×¨×™×™×ª ×”×–×ž× ×ª ×¤×¨×™×˜',0),(230457,6402,'el','Î£ÎµÎ¹ÏÎ¬ Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(230458,6402,'zh','é¡¹ç›®è®¢å•åŽ†å²è®°å½•\r\n',0),(230459,6402,'sv','Objektet orderhistorik',0),(230460,6402,'it','Cronologia ordine elemento',0),(230461,6402,'tl','',0),(230462,6402,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(230463,6402,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥à¤°à¤® à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(230464,6402,'ms','Item pesanan sejarah',0),(230465,6402,'ar','Ø§Ù„Ø¨Ù†Ø¯ ØªØ±ØªÙŠØ¨ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(230466,6402,'fr','Point historique des commandes',0),(230467,6402,'jp','å“?ç›®æ³¨æ–‡å±¥æ­´',0),(230468,6402,'pt','HistÃ³rico de ordem do item',0),(230469,6402,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð—Ð°ÐºÐ°Ð·Ð° Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(230470,6402,'es','Historia de Item Ordenes ',0),(230471,6402,'de','Element-Bestellhistorie',0),(230472,6402,'en','Item Order History',0),(230473,6403,'is','',0),(230474,6403,'dr','Ø§ØµÙ„Ø§Ø­ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(230475,6403,'pr','Ø§ØµÙ„Ø§Ø­ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(230476,6403,'tr','B2B sitesi bilgilerini deÄŸiÅŸtirme',0),(230477,6403,'pl','Modyfikowanie informacji o stronie B2B',0),(230478,6403,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° B2B ÑÐ°Ð¹Ñ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(230479,6403,'ur','B2B Ø³Ø§Ø¦Ù¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ… Ú©Ø±ÛŒÚº',0),(230480,6403,'sr','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð‘2Ð‘',0),(230481,6403,'vi','ThÃ´ng Tin chá»‰nh sá»­a trang B2B',0),(230482,6403,'af','Wysig B2B Terrein Inligting',0),(230483,6403,'ro','Modifica informaÅ£iile din site-ul B2B',0),(230484,6403,'et','Muuda B2B lehe infot',0),(230485,6403,'si','Spremenite informacije o B2B spletno stran',0),(230486,6403,'ba','Memodifikasi informasi situs B2B',0),(230487,6403,'nl','B2B sitegegevens wijzigen',0),(230488,6403,'fi','Muokkaa B2B paikkatietoja',0),(230489,6403,'no','Endre B2B omrÃ¥deinformasjon',0),(230490,6403,'da','Ã†ndre B2B Site Information',0),(230491,6403,'ko','B2B ì‚¬ì´íŠ¸ ì •ë³´ ìˆ˜ì •',0),(230492,6403,'he','×œ×©× ×•×ª ×ž×™×“×¢ ××•×“×•×ª ××ª×¨ B2B',0),(230493,6403,'el','Î¤ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï„Î¿Ï… Site B2B',0),(230494,6403,'zh','ä¿®æ”¹ä¼ä¸šå¯¹ä¼ä¸šç½‘ç«™ä¿¡æ¯\r\n',0),(230495,6403,'sv','Ã„ndra Information om B2B webbplats',0),(230496,6403,'it','Modificare le informazioni del sito B2B',0),(230497,6403,'tl','',0),(230498,6403,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591; B2B',0),(230499,6403,'hi','B2B à¤¸à¤¾à¤‡à¤Ÿ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(230500,6403,'ms','Mengubah suai maklumat tapak B2B',0),(230501,6403,'ar','ØªØºÙŠÙŠØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÙˆÙ‚Ø¹ Ø´Ø±ÙƒØ§Ø¡ Ø§Ù„ØªØ¹Ø§Ù…Ù„',0),(230502,6403,'fr','Modifier les informations du Site B2B',0),(230503,6403,'jp','B2Bã‚µã‚¤ãƒˆæƒ…å ±ã‚’ä¿®æ­£ã?™ã‚‹',0),(230504,6403,'pt','Modificar as informaÃ§Ãµes do Site B2B',0),(230505,6403,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ ÑÐ°Ð¹Ñ‚Ð° B2B',0),(230506,6403,'es','Modificar N2N InformaciÃ³n de Sitio',0),(230507,6403,'de','Ã„ndern B2B Site-Informationen',0),(230508,6403,'en','Modify B2B Site Information',0),(230509,6404,'is','',0),(230510,6404,'dr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡  ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(230511,6404,'pr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡  ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(230512,6404,'tr','SatÄ±cÄ± B2B giriÅŸ kullanÄ±cÄ±lar',0),(230513,6404,'pl','Dostawcy B2B logowania uÅ¼ytkownikÃ³w',0),(230514,6404,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº B2B Ð²Ñ…Ð¾Ð´ Ð·Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(230515,6404,'ur','ÙˆÛŒÙ†ÚˆØ± B2B Ù„Ø§Ú¯ Ø§Ù† ØµØ§Ø±ÙÛŒÙ†',0),(230516,6404,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð‘2Ð‘ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(230517,6404,'vi','TÃªn ÄÄƒng Nháº­p NgÆ°á»i BÃ¡n B2B',0),(230518,6404,'af','Verskaffer B2B Aantekening vir Gebruikers',0),(230519,6404,'ro','Utilizatori furnizori cu logare B2B',0),(230520,6404,'et','Hankija B2B Login kasutajad',0),(230521,6404,'si','Prodajalec B2B prepriÄevalnost uporabnik',0),(230522,6404,'ba','Penjual B2B Login pengguna',0),(230523,6404,'nl','Leverancier B2B Login gebruikers',0),(230524,6404,'fi','Toimittajien B2B Login kÃ¤yttÃ¤jÃ¤',0),(230525,6404,'no','LeverandÃ¸ren B2B logikk brukere',0),(230526,6404,'da','Forhandler B2B Login brugere',0),(230527,6404,'ko','ê³µê¸‰ ì—…ì²´ B2B ë¡œê·¸ì¸ ì‚¬ìš©ìž',0),(230528,6404,'he','×”×¡×¤×§ B2B ×›× ×™×¡×” ×œ×ž×©×ª×ž×©×™×',0),(230529,6404,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ B2B ÎµÎ¯ÏƒÎ¿Î´Î¿Ï‚ Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½',0),(230530,6404,'zh','ä¾›åº”å•†çš„å•†ä¸šå¯¹å•†ä¸šç™»å½•ç”¨æˆ·\r\n',0),(230531,6404,'sv','LeverantÃ¶rsanvÃ¤ndare B2B inloggning',0),(230532,6404,'it','Utenti fornitore B2B Login',0),(230533,6404,'tl','',0),(230534,6404,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618; B2B &#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(230535,6404,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ B2B à¤²à¥‰à¤—à¤¿à¤¨ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(230536,6404,'ms','Penjual B2B Login pengguna',0),(230537,6404,'ar','Ù…Ø³ØªØ®Ø¯Ù…Ùˆ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ - Ø´Ø±ÙƒØ§Ø¡ Ø§Ù„ØªØ¹Ø§Ù…Ù„',0),(230538,6404,'fr','Vendeur B2B connexion utilisateurs',0),(230539,6404,'jp','æ¥­è€…B2Bãƒ­ã‚°ã‚¤ãƒ³ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(230540,6404,'pt','UsuÃ¡rios de Login do fornecedor B2B',0),(230541,6404,'ru','Ð—Ð°Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸ B2B',0),(230542,6404,'es','Proveedor N2N Login Usuarios',0),(230543,6404,'de','Anbieter B2B Login Benutzer',0),(230544,6404,'en','Vendor B2B Login Users',0),(230545,6405,'is','',0),(230546,6405,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(230547,6405,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(230548,6405,'tr','Ã–ÄŸe seÃ§enekleri',0),(230549,6405,'pl','Opcje elementu',0),(230550,6405,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(230551,6405,'ur','Ø´Û’ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(230552,6405,'sr','Ð¡Ñ‚Ð°Ð²ÐºÑƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(230553,6405,'vi','Lá»±a chá»n hÃ ng',0),(230554,6405,'af','Item Opsies',0),(230555,6405,'ro','Elementul opÅ£iuni',0),(230556,6405,'et','Toote valikud',0),(230557,6405,'si','Element moÅ¾nosti',0),(230558,6405,'ba','Pilihan item',0),(230559,6405,'nl','Itemopties',0),(230560,6405,'fi','Kohteen asetukset',0),(230561,6405,'no','Elementet alternativer',0),(230562,6405,'da','Elementet indstillinger',0),(230563,6405,'ko','í•­ëª© ì˜µì…˜',0),(230564,6405,'he','××¤×©×¨×•×™×•×ª ×¤×¨×™×˜',0),(230565,6405,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(230566,6405,'zh','é¡¹ç›®é€‰é¡¹\r\n',0),(230567,6405,'sv','Objektalternativ',0),(230568,6405,'it','Elemento opzioni',0),(230569,6405,'tl','',0),(230570,6405,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(230571,6405,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¤²à¥à¤ª',0),(230572,6405,'ms','Pilihan',0),(230573,6405,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„ØµÙ†Ù',0),(230574,6405,'fr','Options de l\'Ã©lÃ©ment',0),(230575,6405,'jp','å“?ç›®ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(230576,6405,'pt','OpÃ§Ãµes de item',0),(230577,6405,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(230578,6405,'es','Item Opciones',0),(230579,6405,'de','Unter Options',0),(230580,6405,'en','Item Options',0),(230581,6406,'is','',0),(230582,6406,'dr','ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ Ø´Ø±ÙƒØª ',0),(230583,6406,'pr','ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ Ø´Ø±ÙƒØª ',0),(230584,6406,'tr','Ecom ÅŸirketi olarak ayarla',0),(230585,6406,'pl','Ustaw jako Ecom firmy',0),(230586,6406,'bg','Ð—Ð°Ð´Ð°Ð¹ ÐºÐ°Ñ‚Ð¾ Ñ„Ð¸Ñ€Ð¼Ð° Ð˜ÐºÐ¾Ð¼',0),(230587,6406,'ur','Ø§ÛŒÚ©Ø§ÙˆÙ… Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(230588,6406,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ ÐºÐ°Ð¾ Ð•Ñ†Ð¾Ð¼ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(230589,6406,'vi','Cty cho Giá» HÃ ng',0),(230590,6406,'af','Stel as Ecom maatskappy',0),(230591,6406,'ro','SetaÅ£i ca Ecom companie',0),(230592,6406,'et','MÃ¤Ã¤ra Ecom ettevÃµttena',0),(230593,6406,'si','Nastavi kot Ecom podjetje',0),(230594,6406,'ba','Ditetapkan sebagai perusahaan Ecom',0),(230595,6406,'nl','Instellen als Ecom bedrijf',0),(230596,6406,'fi','Aseta Ecom yritys',0),(230597,6406,'no','Angi som Ecom selskap',0),(230598,6406,'da','Angiv som Ecom selskab',0),(230599,6406,'ko','Ecom íšŒì‚¬ë¡œ ì„¤ì •',0),(230600,6406,'he','×œ×”×’×“×™×¨ ×›×—×‘×¨×” Ecom',0),(230601,6406,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ Ï‰Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Ecom',0),(230602,6406,'zh','å…¬å¸è´­ç‰©è½¦\r\n',0),(230603,6406,'sv','Ange som Ecom fÃ¶retag',0),(230604,6406,'it','Impostare come azienda Ecom',0),(230605,6406,'tl','',0),(230606,6406,'th','&#3619;&#3606;&#3648;&#3586;&#3655;&#3609;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(230607,6406,'hi','à¤•à¤¹à¤¤à¥‡ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(230608,6406,'ms','Set sebagai syarikat Ecom',0),(230609,6406,'ar','ØªØ¹ÙŠÙŠÙ† ÙƒØ´Ø±ÙƒØ© Ecom',0),(230610,6406,'fr','DÃ©finir comme sociÃ©tÃ© Ecom',0),(230611,6406,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°ã‚«ãƒ¼ãƒˆã?®ä¼šç¤¾',0),(230612,6406,'pt','Definida como empresa Ecom',0),(230613,6406,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° ÐºÐ°Ðº ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð­ÐšÐžÐœ',0),(230614,6406,'es','Empresa para Carrito de Compras',0),(230615,6406,'de','Legen Sie als Ecom-Unternehmen',0),(230616,6406,'en','Set as Ecom Company',0),(230617,6407,'is','',0),(230618,6407,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡ Ø¬Ù†Ø³ ',0),(230619,6407,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ ',0),(230620,6407,'tr','Madde seÃ§enek grubu Ekle/GÃ¼ncelle',0),(230621,6407,'pl','Element grupa opcji Dodaj/Aktualizuj',0),(230622,6407,'bg','Ð“Ñ€ÑƒÐ¿Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð° Ð¾Ð¿Ñ†Ð¸ÑÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(230623,6407,'ur','Ø´Û’ Ø§Ø®ØªÛŒØ§Ø± Ú¯Ø±ÙˆÙ¾ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(230624,6407,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ð° Ð³Ñ€ÑƒÐ¿Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(230625,6407,'vi','ThÃªm/Cáº­p Nháº­t NhÃ³m Danh Má»¥c',0),(230626,6407,'af','Skep/Opdateer Item Opsie Groep',0),(230627,6407,'ro','Grupa de articole de opÅ£iune adaugÄƒ/actualizeazÄƒ',0),(230628,6407,'et','Ãœksuse suvandite rÃ¼hma lisamine/uuendamine',0),(230629,6407,'si','Skupina artikla moÅ¾nost Dodaj/posodobi',0),(230630,6407,'ba','Item pilihan grup Tambahkan/Perbarui',0),(230631,6407,'nl','Object groepsvak toevoegen/bijwerken',0),(230632,6407,'fi','Nimikkeen vaihtoehtoryhmÃ¤Ã¤n lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(230633,6407,'no','Varegruppe i alternativet Legg til/Oppdater',0),(230634,6407,'da','Vare gruppeboks tilfÃ¸jer/opdatering',0),(230635,6407,'ko','í•­ëª© ì˜µì…˜ ê·¸ë£¹ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(230636,6407,'he','×§×‘×•×¦×ª ×”×¤×¨×™×˜ ×”×•×¡×¤×”/×¢×“×›×•×Ÿ',0),(230637,6407,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¼Î¹Î±Ï‚ Î¿Î¼Î¬Î´Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(230638,6407,'zh','é¡¹ç›®é€‰æ‹©é›†å›¢æ–°å¢ž/æ›´æ–°\r\n',0),(230639,6407,'sv','Artikelgrupp alternativet LÃ¤gg till/uppdatera',0),(230640,6407,'it','Aggiungere/aggiornare un elemento opzione gruppo',0),(230641,6407,'tl','',0),(230642,6407,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&',0),(230643,6407,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤®à¥‚à¤¹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(230644,6407,'ms','Item opsyen Kumpulan Tambah/Kemaskini',0),(230645,6407,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù…Ø¬Ù…ÙˆØ¹Ø© Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„ØµÙ†Ù',0),(230646,6407,'fr','Groupe d\'Ã©lÃ©ments Option ajouter/mettre Ã  jour',0),(230647,6407,'jp','å“?ç›®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚°ãƒ«ãƒ¼ãƒ—ã?®è¿½åŠ /æ›´æ–°',0),(230648,6407,'pt','Grupo de opÃ§Ãµes do item Adicionar/atualizar',0),(230649,6407,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð¿ÐµÑ€ÐµÐºÐ»ÑŽÑ‡Ð°Ñ‚ÐµÐ»ÐµÐ¹ Ð¿ÑƒÐ½ÐºÑ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(230650,6407,'es','Item Grupo de Opciones Agregar/Actualizar',0),(230651,6407,'de','Artikelgruppe Option hinzufÃ¼gen/aktualisieren',0),(230652,6407,'en','Item Option Group Add/Update',0),(230653,6408,'is','',0),(230654,6408,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(230655,6408,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(230656,6408,'tr','Madde seÃ§enek gruplarÄ± baÅŸarÄ±yla kaydedildi.',0),(230657,6408,'pl','Pozycja grupy opcji zapisane pomyÅ›lnie.',0),(230658,6408,'bg','Ð“Ñ€ÑƒÐ¿Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð¾Ð¿Ñ†Ð¸Ñ Ð·Ð° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(230659,6408,'ur','Ø´Û’ Ø§Ø®ØªÛŒØ§Ø± Ú¯Ø±ÙˆÙ¾ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ ÛÛ’ Û”',0),(230660,6408,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° ÑÑ‚Ð°Ð²ÐºÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½.',0),(230661,6408,'vi','NhÃ³m lá»±a chá»n hÃ ng sao lÆ°u thÃ nh cÃ´ng',0),(230662,6408,'af','Item Opsie Groepe suksesvol gestoor.',0),(230663,6408,'ro','Element opÅ£iunea grupuri salvat cu succes.',0),(230664,6408,'et','Toodete valikugrupid salvestati edukalt',0),(230665,6408,'si','MoÅ¾nost skupine artiklov uspeÅ¡no shranjen.',0),(230666,6408,'ba','Item pilihan kelompok berhasil diselamatkan.',0),(230667,6408,'nl','Optie artikelgroepen met succes opgeslagen.',0),(230668,6408,'fi','NimikeryhmÃ¤t vaihtoehto tallennus onnistui.',0),(230669,6408,'no','Elementet alternativgrupper lagret.',0),(230670,6408,'da','Vare gruppebokse gemt med succes.',0),(230671,6408,'ko','í•­ëª© ì˜µì…˜ ê·¸ë£¹ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•©ë‹ˆë‹¤.',0),(230672,6408,'he','×§×‘×•×¦×•×ª ××¤×©×¨×•×™×•×ª ×¤×¨×™×˜ × ×©×ž×¨ ×‘×”×¦×œ×—×”.',0),(230673,6408,'el','ÎŸÎ¼Î¬Î´ÎµÏ‚ ÎµÏ€Î¹Î»Î¿Î³Î® ÎµÎ¹Î´ÏŽÎ½ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(230674,6408,'zh','é¡¹ç›®é€‰é¡¹ç»„å·²æˆåŠŸä¿å­˜ã€‚\r\n',0),(230675,6408,'sv','Alternativet artikelgrupper sparats.',0),(230676,6408,'it','Gruppi di opzione elementi salvati con successo.',0),(230677,6408,'tl','',0),(230678,6408,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(230679,6408,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤®à¥‚à¤¹à¥‹à¤‚à¥¤',0),(230680,6408,'ms','Item opsyen Kumpulan berjaya disimpan.',0),(230681,6408,'ar','Ø­ÙØ¸Øª Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„ØµÙ†Ù Ø¨Ù†Ø¬Ø§Ø­',0),(230682,6408,'fr','Groupes d\'options point enregistrÃ©s avec succÃ¨s.',0),(230683,6408,'jp','å“?ç›®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚°ãƒ«ãƒ¼ãƒ—ã?Œä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(230684,6408,'pt','Grupos de opÃ§Ã£o de itens salvos com sucesso.',0),(230685,6408,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹.',0),(230686,6408,'es','Grupos de Opciones de Item Guardados Exitosamente',0),(230687,6408,'de','Option Artikelgruppen wurde erfolgreich gespeichert.',0),(230688,6408,'en','Item option groups saved successfully.',0),(230689,6409,'is','',0),(230690,6409,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ',0),(230691,6409,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ',0),(230692,6409,'tr','SeÃ§enekleri iÃ§in',0),(230693,6409,'pl','Opcje dla',0),(230694,6409,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð°',0),(230695,6409,'ur','Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ú©Û’ Ù„ÛŒÛ’',0),(230696,6409,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ð·Ð°',0),(230697,6409,'vi','Lá»±a chá»n cho',0),(230698,6409,'af','Opsies vir',0),(230699,6409,'ro','OpÅ£iuni pentru',0),(230700,6409,'et','VÃµimalused',0),(230701,6409,'si','MoÅ¾nosti za',0),(230702,6409,'ba','Pilihan untuk',0),(230703,6409,'nl','Opties voor',0),(230704,6409,'fi','Asetukset',0),(230705,6409,'no','Alternativer for',0),(230706,6409,'da','Indstillinger for',0),(230707,6409,'ko','ì— ëŒ€ í•œ ì˜µì…˜',0),(230708,6409,'he','××¤×©×¨×•×™×•×ª ×¢×‘×•×¨',0),(230709,6409,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ Î³Î¹Î±',0),(230710,6409,'zh','é€‰é¡¹\r\n',0),(230711,6409,'sv','Alternativ fÃ¶r',0),(230712,6409,'it','Opzioni per',0),(230713,6409,'tl','',0),(230714,6409,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(230715,6409,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(230716,6409,'ms','Opsyen untuk',0),(230717,6409,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ù€',0),(230718,6409,'fr','Options pour',0),(230719,6409,'jp','ï½žã?®ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(230720,6409,'pt','OpÃ§Ãµes para',0),(230721,6409,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð´Ð»Ñ',0),(230722,6409,'es','Opciones para',0),(230723,6409,'de','Optionen fÃ¼r',0),(230724,6409,'en','Options for',0),(230725,6410,'is','',0),(230726,6410,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¬Ù†Ø³Ù‡Ø§ ',0),(230727,6410,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙØ²ÙˆØ¯Ù†  / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(230728,6410,'tr','BileÅŸen ekleme/gÃ¼ncelleme seÃ§enekleri',0),(230729,6410,'pl','Opcje dla elementÃ³w Dodaj/Aktualizuj',0),(230730,6410,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(230731,6410,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(230732,6410,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(230733,6410,'vi','Lá»±a Chá»n cho má»¥c ThÃªm/Cáº­p Nháº­t',0),(230734,6410,'af','Opsies vir Items Skep/Opdateer',0),(230735,6410,'ro','OpÅ£iuni pentru elemente AdÄƒugaÅ£i/actualizaÅ£i',0),(230736,6410,'et','VÃµimalusi Ã¼ksuste lisamine/uuendamine',0),(230737,6410,'si','MoÅ¾nosti za elemente Dodaj/posodobi',0),(230738,6410,'ba','Pilihan untuk item Tambahkan/Perbarui',0),(230739,6410,'nl','Opties voor Items toevoegen/bijwerken',0),(230740,6410,'fi','Vaihtoehtoja lisÃ¤tÃ¤ kohteita pÃ¤ivittÃ¤Ã¤',0),(230741,6410,'no','Alternativer for elementer/Oppdater',0),(230742,6410,'da','Indstillinger for varer TilfÃ¸j/opdater',0),(230743,6410,'ko','í•­ëª© ì¶”ê°€/ì—…ë°ì´íŠ¸ ì˜µì…˜',0),(230744,6410,'he','××¤×©×¨×•×™×•×ª ×¢×‘×•×¨ ×¤×¨×™×˜×™× ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(230745,6410,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ Î³Î¹Î± Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(230746,6410,'zh','æ–°å¢ž/æ›´æ–°é¡¹ç›®é€‰é¡¹\r\n',0),(230747,6410,'sv','Alternativ fÃ¶r att lÃ¤gga till objekt/uppdatera',0),(230748,6410,'it','Opzioni per aggiungere o aggiornare gli elementi',0),(230749,6410,'tl','',0),(230750,6410,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(230751,6410,'hi','à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(230752,6410,'ms','Pilihan untuk menambah item/Kemaskini',0),(230753,6410,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(230754,6410,'fr','Options pour les Ã©lÃ©ments ajouter/mettre Ã  jour',0),(230755,6410,'jp','å“?ç›®ã?®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã?®è¿½åŠ /æ›´æ–°',0),(230756,6410,'pt','OpÃ§Ãµes para itens adicionar/atualizar',0),(230757,6410,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð´Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(230758,6410,'es','Opciones para Items Agregar/Actualizar',0),(230759,6410,'de','Optionen fÃ¼r Elemente hinzufÃ¼gen/aktualisieren',0),(230760,6410,'en','Options for Items Add/Update',0),(230761,6411,'is','',0),(230762,6411,'dr','ÙƒØ¯ ÙƒØ§Ù„Ø§ â€“ Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ù„Ø§',0),(230763,6411,'pr','ÙƒØ¯ ÙƒØ§Ù„Ø§ â€“ Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ù„Ø§',0),(230764,6411,'tr','Madde kodu - Ã¶ÄŸesi kimliÄŸi',0),(230765,6411,'pl','Kod towaru - identyfikator elementu',0),(230766,6411,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» - Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(230767,6411,'ur','Ø´Û’ Ú©ÙˆÚˆ - Ø´Û’ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(230768,6411,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° - Ð˜Ð” ÑÑ‚Ð°Ð²ÐºÐµ',0),(230769,6411,'vi','MÃ£ HÃ ng - ID HÃ ng',0),(230770,6411,'af','Itemkode - Item ID',0),(230771,6411,'ro','Cod articol - ID element',0),(230772,6411,'et','Tootekood - Toote ID',0),(230773,6411,'si','Å ifra artikla - ID elementa',0),(230774,6411,'ba','Kode barang - barang ID',0),(230775,6411,'nl','Object Code - Item-ID',0),(230776,6411,'fi','Nimikekoodi - Tuotteen tunnus',0),(230777,6411,'no','Varekode - IDen',0),(230778,6411,'da','Varekode - emne-ID\'ET',0),(230779,6411,'ko','í•­ëª© ì½”ë“œ-í•­ëª© ID',0),(230780,6411,'he','×§×•×“ ×¤×¨×™×˜ - ×ž×–×”×” ×¤×¨×™×˜',0),(230781,6411,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ - Î¸Î­ÏƒÎ· ID',0),(230782,6411,'zh','ç‰©å“ä»£ç  -ç‰©å“ID\r\n',0),(230783,6411,'sv','Artikelkod - objekt-ID',0),(230784,6411,'it','Codice articolo - Item ID',0),(230785,6411,'tl','',0),(230786,6411,'th','&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; - &#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(230787,6411,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ - à¤†à¤‡à¤Ÿà¤® ID',0),(230788,6411,'ms','Kod item - Item ID',0),(230789,6411,'ar','ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù-Ù…Ø¹Ø±Ù Ø§Ù„Ø¹Ù†ØµØ±',0),(230790,6411,'fr','Code d\'article - ID de l\'Ã©lÃ©ment',0),(230791,6411,'jp','å“?ç›®ã‚³ãƒ¼ãƒ‰ãƒ¼å“?ç›®ID',0),(230792,6411,'pt','CÃ³digo do artigo - Item ID',0),(230793,6411,'ru','ÐšÐ¾Ð´ Ð¢Ð¾Ð²Ð°Ñ€Ð° - ID Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(230794,6411,'es','Item CÃ³digo - Item ID',0),(230795,6411,'de','Artikelcode - Element-ID',0),(230796,6411,'en','Item Code - Item ID',0),(230797,6412,'is','',0),(230798,6412,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ú¯Ø²ÙŠÙ†Ù‡ Ø¬Ù†Ø³ ',0),(230799,6412,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ ',0),(230800,6412,'tr','Madde seÃ§eneÄŸini ekleyin/gÃ¼ncelleyin',0),(230801,6412,'pl','Element opcji Dodaj/Aktualizuj',0),(230802,6412,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Ð¾Ð¿Ñ†Ð¸ÑÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(230803,6412,'ur','Ø´Û’ Ø§Ø®ØªÛŒØ§Ø± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(230804,6412,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(230805,6412,'vi','ThÃªm/Cáº­p Nháº­t NhÃ³m Danh Má»¥c',0),(230806,6412,'af','Skep/Opdateer Item Opsie',0),(230807,6412,'ro','OpÅ£iune Adauga/actualizare',0),(230808,6412,'et','Kauba valik lisamine/uuendamine',0),(230809,6412,'si','Element moÅ¾nost Dodaj/posodobi',0),(230810,6412,'ba','Item pilihan menambahkan Update',0),(230811,6412,'nl','Item optie toevoegen/bijwerken',0),(230812,6412,'fi','Nimikkeen vaihtoehto LisÃ¤Ã¤/pÃ¤ivitÃ¤',0),(230813,6412,'no','Elementet alternativet Legg til/Oppdater',0),(230814,6412,'da','Vare indstillingen TilfÃ¸j/opdater',0),(230815,6412,'ko','í•­ëª© ì¶”ê°€/ì—…ë°ì´íŠ¸ ì˜µì…˜',0),(230816,6412,'he','×”×•×¡×£/×¢×“×›×Ÿ ××¤×©×¨×•×ª ×¤×¨×™×˜',0),(230817,6412,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(230818,6412,'zh','é¡¹ç›®é€‰æ‹©æ–°å¢ž/æ›´æ–°\r\n',0),(230819,6412,'sv','Artikeln alternativet LÃ¤gg till/uppdatera',0),(230820,6412,'it','Elemento opzione aggiungere/aggiornare',0),(230821,6412,'tl','',0),(230822,6412,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(230823,6412,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¤²à¥à¤ª à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(230824,6412,'ms','Item pilihan Tambah/Kemaskini',0),(230825,6412,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø®ÙŠØ§Ø± ØµÙ†Ù',0),(230826,6412,'fr','Ã‰lÃ©ment Option ajouter/mettre Ã  jour',0),(230827,6412,'jp','å“?ç›®ã‚³ãƒ¼ãƒ‰ã?®è¿½åŠ /æ›´æ–°',0),(230828,6412,'pt','Item opÃ§Ã£o Adicionar/atualizar',0),(230829,6412,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ Ð¿ÑƒÐ½ÐºÑ‚ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(230830,6412,'es','Item OpciÃ³n Agregar/Actualizar',0),(230831,6412,'de','Element Option hinzufÃ¼gen/aktualisieren',0),(230832,6412,'en','Item Option Add/Update',0),(230833,6413,'is','',0),(230834,6413,'dr','Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ¯ ',0),(230835,6413,'pr','Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ¯ ',0),(230836,6413,'tr','SeÃ§enek kodu',0),(230837,6413,'pl','Opcja kodu',0),(230838,6413,'bg','ÐžÐ¿Ñ†Ð¸Ñ ÐºÐ¾Ð´',0),(230839,6413,'ur','Ø§Ø®ØªÛŒØ§Ø± Ø¶Ø§Ø¨Ø·Û',0),(230840,6413,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ð° Ð¨Ð¸Ñ„Ñ€Ð°',0),(230841,6413,'vi','MÃ£ Lá»±a chá»n',0),(230842,6413,'af','Opsie Kode',0),(230843,6413,'ro','OpÅ£iunea de cod',0),(230844,6413,'et','Variandi tÃ¤his',0),(230845,6413,'si','MoÅ¾nost kodo',0),(230846,6413,'ba','Kode pilihan',0),(230847,6413,'nl','Optiecode',0),(230848,6413,'fi','Vaihtoehto koodi',0),(230849,6413,'no','Alternativkode',0),(230850,6413,'da','Indstillingskoden',0),(230851,6413,'ko','ì˜µì…˜ ì½”ë“œ',0),(230852,6413,'he','×§×•×“ ××¤×©×¨×•×ª',0),(230853,6413,'el','ÎšÏ‰Î´Î¹ÎºÏŒ ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚',0),(230854,6413,'zh','é€‰é¡¹ä»£ç \r\n',0),(230855,6413,'sv','Alternativkod',0),(230856,6413,'it','Codice opzione',0),(230857,6413,'tl','',0),(230858,6413,'th','&#3619;&#3627;&#3633;&#3626;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(230859,6413,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¥‹à¤¡',0),(230860,6413,'ms','Kod opsyen',0),(230861,6413,'ar','Ø±Ù…Ø² Ø§Ù„Ø®ÙŠØ§Ø±',0),(230862,6413,'fr','Option Code',0),(230863,6413,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚³ãƒ¼ãƒ‰',0),(230864,6413,'pt','CÃ³digo de opÃ§Ã£o',0),(230865,6413,'ru','ÐšÐ¾Ð´ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð°',0),(230866,6413,'es','CÃ³digo de OpciÃ³n',0),(230867,6413,'de','Optionscode',0),(230868,6413,'en','Option Code',0),(230869,6414,'is','',0),(230870,6414,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(230871,6414,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(230872,6414,'tr','MÃ¼ÅŸterinin satÄ±n alma geÃ§miÅŸi',0),(230873,6414,'pl','Historia zakupÃ³w klienta',0),(230874,6414,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(230875,6414,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(230876,6414,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ñƒ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ðµ ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(230877,6414,'vi','Lá»‹ch sá»­ mua cá»§a KhÃ¡ch hÃ ng',0),(230878,6414,'af','Klant / KliÃ«nt Aankoopgeskiedenis',0),(230879,6414,'ro','Istoria de cumpÄƒrare client',0),(230880,6414,'et','Kliendi ostuajalugu',0),(230881,6414,'si','Zgodovini nakupov kupca',0),(230882,6414,'ba','Sejarah pembelian pelanggan',0),(230883,6414,'nl','Klant aankoopgeschiedenis',0),(230884,6414,'fi','Asiakas ostohistoriaan',0),(230885,6414,'no','Kundens kjÃ¸pshistorikk',0),(230886,6414,'da','Kundens kÃ¸bshistorik',0),(230887,6414,'ko','ê³ ê° êµ¬ë§¤ ë‚´ì—­',0),(230888,6414,'he','×”×™×¡×˜×•×¨×™×™×ª ×¨×›×™×©×•×ª ×œ×§×•×—',0),(230889,6414,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î±Î³Î¿ÏÏŽÎ½ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(230890,6414,'zh','å®¢æˆ·è´­ä¹°çš„åŽ†å²\r\n',0),(230891,6414,'sv','Kunden inkÃ¶pshistorik',0),(230892,6414,'it','Storico degli acquisti del cliente',0),(230893,6414,'tl','',0),(230894,6414,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(230895,6414,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥€ à¤–à¤°à¥€à¤¦ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(230896,6414,'ms','Sejarah pembelian pelanggan',0),(230897,6414,'ar','ØªØ§Ø±ÙŠØ® Ø´Ø±Ø§Ø¡ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(230898,6414,'fr','Client historique d\'achat',0),(230899,6414,'jp','é¡§å®¢è³¼è²·å±¥æ­´',0),(230900,6414,'pt','HistÃ³rico de compras do cliente',0),(230901,6414,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ ÐŸÐ¾ÐºÑƒÐ¿Ð¾Ðº ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(230902,6414,'es','Cliente Historia de Compras',0),(230903,6414,'de','Kundenhistorie kaufen',0),(230904,6414,'en','Customer Purchase History',0),(230905,6415,'is','',0),(230906,6415,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯ ÙƒØ§Ù„Ø§ ',0),(230907,6415,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯ ÙƒØ§Ù„Ø§ ',0),(230908,6415,'tr','Maddenin satÄ±nalma geÃ§miÅŸi',0),(230909,6415,'pl','Element historii zakupÃ³w',0),(230910,6415,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(230911,6415,'ur','Ø´Û’ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(230912,6415,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(230913,6415,'vi','Lá»‹ch sá»­ mua hÃ ng',0),(230914,6415,'af','Item Aankoopgeskiedenis',0),(230915,6415,'ro','Element cumpÄƒrare istorie',0),(230916,6415,'et','Toodete ostuajalugu',0),(230917,6415,'si','Nakup zgodovino elementa',0),(230918,6415,'ba','Sejarah pembelian barang',0),(230919,6415,'nl','Item aankoopgeschiedenis',0),(230920,6415,'fi','Kohteen Purchase History',0),(230921,6415,'no','Elementet kjÃ¸pshistorikk',0),(230922,6415,'da','Vare kÃ¸bsoversigt',0),(230923,6415,'ko','í•­ëª© êµ¬ìž… ë‚´ì—­',0),(230924,6415,'he','×”×™×¡×˜×•×¨×™×™×ª ×¨×›×™×©×•×ª ×¤×¨×™×˜',0),(230925,6415,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î±Î³Î¿ÏÏŽÎ½',0),(230926,6415,'zh','äº§å“å®šè´­åŽ†å²',0),(230927,6415,'sv','Objektet inkÃ¶pshistorik',0),(230928,6415,'it','Elemento Cronologia acquisti',0),(230929,6415,'tl','',0),(230930,6415,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(230931,6415,'hi','à¤†à¤‡à¤Ÿà¤® à¤–à¤°à¥€à¤¦ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(230932,6415,'ms','Sejarah pembelian barang',0),(230933,6415,'ar','Ø­Ø±ÙƒØ© Ù…Ø´ØªØ±ÙŠØ§Øª Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(230934,6415,'fr','Point historique des achats',0),(230935,6415,'jp','å“?ç›®è³¼è²·å±¥æ­´',0),(230936,6415,'pt','HistÃ³rico de compra de itens',0),(230937,6415,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ ÐŸÐ¾ÐºÑƒÐ¿Ð¾Ðº Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(230938,6415,'es','Item Historia de Compras',0),(230939,6415,'de','Artikel-Einkaufsstatistik',0),(230940,6415,'en','Item Purchase History',0),(230941,6416,'is','',0),(230942,6416,'dr','Ø¢ÙŠØ§ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø³Øª ØŸ',0),(230943,6416,'pr','Ø¢ÙŠØ§ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø³Øª ØŸ',0),(230944,6416,'tr','Navlun vergiye tabi mi?',0),(230945,6416,'pl','Czy opodatkowaniu towarÃ³w?',0),(230946,6416,'bg','Ð• Ñ‚Ð¾Ð²Ð°Ñ€ÐµÐ½ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾?',0),(230947,6416,'ur','Ø³Ø§Ù…Ø§Ù† Ù¾Ø± Ù¹ÛŒÚ©Ø³ Ø¹Ø§Ø¦Ø¯ ÛÙˆØªØ§ ÛÛ’ØŸ',0),(230948,6416,'sr','Ð”Ð° Ð»Ð¸ Ñ˜Ðµ Ñ‚ÐµÑ€ÐµÑ‚Ð½Ð¸ Ð¿Ð»Ð°Ð¶Ð°?',0),(230949,6416,'vi','CÆ°á»›c váº­n chuyá»ƒn cÃ³ chá»‹u thuáº¿?',0),(230950,6416,'af','Is vrag belasbare?',0),(230951,6416,'ro','Este marfÄƒ impozabile?',0),(230952,6416,'et','On kauba maksustatav?',0),(230953,6416,'si','Je davÄni zavezanec tovora?',0),(230954,6416,'ba','Apakah barang kena pajak?',0),(230955,6416,'nl','Vracht belastingplichtige is?',0),(230956,6416,'fi','On tavaraliikenteen verovelvollinen?',0),(230957,6416,'no','Er frakt skattepliktig?',0),(230958,6416,'da','Der er gods skattepligtigt?',0),(230959,6416,'ko','í™”ë¬¼ ê³¼ì„¸ëŠ”?',0),(230960,6416,'he','×”×× ×”×•×‘×œ×” ×—×™×™×‘ ×‘×ž×¡?',0),(230961,6416,'el','Î•Î¯Î½Î±Î¹ Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ Ï„Î¿Ï… Ï†Î¿ÏÏ„Î¯Î¿Ï…;',0),(230962,6416,'zh','æ˜¯è´§è¿å¾ç¨Žï¼Ÿ\r\n',0),(230963,6416,'sv','Ã„r frakt beskattningsbara?',0),(230964,6416,'it','Ãˆ il trasporto passivo?',0),(230965,6416,'tl','',0),(230966,6416,'th','&#3648;&#3611;&#3655;&#3609;&#3616;&#3634;&#3625;&#3637;&#3588;&#3656;&#3634;&#3586;&#3609;&#3626;&#3656;&#3591;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(230967,6416,'hi','à¤®à¤¾à¤² à¤¢à¥à¤²à¤¾à¤ˆ à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤¹à¥ˆ?',0),(230968,6416,'ms','Adalah dikenakan cukai barang?',0),(230969,6416,'ar','ÙŠØªÙ… Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©ØŸ',0),(230970,6416,'fr','Est-il imposable de fret ?',0),(230971,6416,'jp','é?‹è³ƒã?¯èª²ç¨Žå¯¾è±¡ã?§ã?™ã?‹ï¼Ÿ',0),(230972,6416,'pt','Ã‰ tributÃ¡vel de frete?',0),(230973,6416,'ru','Ð­Ñ‚Ð¾ Ð³Ñ€ÑƒÐ·Ð¾Ð²Ñ‹Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼?',0),(230974,6416,'es','Es Flete Imponible',0),(230975,6416,'de','Ist Fracht steuerpflichtig?',0),(230976,6416,'en','Is Freight Taxable?',0),(230977,6417,'is','',0),(230978,6417,'dr','Ú†Ùƒ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡  Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(230979,6417,'pr','Ú†Ùƒ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡  Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(230980,6417,'tr','Zaten bu dÃ¶neme ait yazÄ±lÄ± Ã§alÄ±ÅŸan onay',0),(230981,6417,'pl','Wyboru pracownika juÅ¼ napisane w tym okresie',0),(230982,6417,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð²ÐµÑ‡Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(230983,6417,'ur','Ø§Ø³ Ø¹Ø±ØµÛ Ú©Û’ Ù„ÛŒÛ’ Ù¾ÛÙ„Û’ ÛÛŒ Ø³Û’ Ù„Ú©Ú¾ÛŒ Ù…Ù„Ø§Ø²Ù… Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(230984,6417,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð²ÐµÑ› Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð° Ð·Ð° Ð¾Ð²Ð°Ñ˜ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(230985,6417,'vi','SÃ©c nhÃ¢n viÃªn cho ká»³ nÃ y Ä‘Ã£ viáº¿t',0),(230986,6417,'af','Werknemer Loonrol reeds geskryf vir hierdie Periode',0),(230987,6417,'ro','Selectare angajat deja scris pentru aceastÄƒ perioadÄƒ',0),(230988,6417,'et','TÃ¶Ã¶taja vÃ¤ljaregistreerimine juba kirjutanud selle perioodi jaoks',0),(230989,6417,'si','Zaposlenega Äek Å¾e napisal za to obdobje',0),(230990,6417,'ba','Check karyawan yang sudah ditulis untuk periode ini',0),(230991,6417,'nl','Werknemer Check al geschreven voor deze periode',0),(230992,6417,'fi','TyÃ¶ntekijÃ¤n sisÃ¤Ã¤n jo kirjoittanut tÃ¤lle kaudelle',0),(230993,6417,'no','Ansatt av allerede skrevet for denne perioden',0),(230994,6417,'da','Medarbejder Check allerede skrevet i denne periode',0),(230995,6417,'ko','ì´ ê¸°ê°„ì— ëŒ€ í•œ ì´ë¯¸ ìž‘ì„± ëœ ì§ì› í™•ì¸',0),(230996,6417,'he','×”×¡×™×ž×•×Ÿ ×”×¢×•×‘×“ ×›×‘×¨ × ×›×ª×‘ ×¢×‘×•×¨ ×ª×§×•×¤×” ×–×•',0),(230997,6417,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î®Î´Î· Î³ÏÎ¬ÏˆÎµÎ¹ Î³Î¹Î± Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(230998,6417,'zh','å‘˜å·¥æ£€æŸ¥å·²ç»åœ¨è¿™æ®µæ—¶é—´å†™å¥½\r\n',0),(230999,6417,'sv','AnstÃ¤lld kontrollera redan skrivit fÃ¶r denna Period',0),(231000,6417,'it','Controllo dipendente giÃ  scritto per questo periodo',0),(231001,6417,'tl','',0),(231002,6417,'th','&#3648;&#3594;&#3655;&#3588;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3614;&#3619;&#3657;&#3629;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3609;&#3637;&#3657;',0),(231003,6417,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤šà¥‡à¤• à¤ªà¤¹à¤²à¥‡ à¤¹à¥€ à¤‡à¤¸ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¿à¤–à¤¾',0),(231004,6417,'ms','Daftar pekerja yang sudah ditulis selama ini',0),(231005,6417,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù…ÙˆØ¸Ù Ù…ÙƒØªÙˆØ¨Ø© Ù…Ø³Ø¨Ù‚Ø§Ù‹ Ù„Ù‡Ø°Ù‡ Ø§Ù„ÙØªØ±Ø©',0),(231006,6417,'fr','ChÃ¨que employÃ© dÃ©jÃ  Ã©crit pour cette pÃ©riode',0),(231007,6417,'jp','å¾“æ¥­å“¡å°?åˆ‡æ‰‹ã?¯ã?“ã?®æœŸé–“ã?«ã?™ã?§ã?«æ›¸ã??è¾¼ã?¾ã‚Œã?¦ã?„ã?¾ã?™',0),(231008,6417,'pt','SeleÃ§Ã£o de empregado jÃ¡ escrita para este perÃ­odo',0),(231009,6417,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° ÑƒÐ¶Ðµ Ð¿Ð¸ÑÐ°Ð» Ð·Ð° ÑÑ‚Ð¾Ñ‚ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(231010,6417,'es','Cheque de Empleado ya elaborado para este perÃ­odo',0),(231011,6417,'de','Mitarbeiter-Check, die bereits fÃ¼r diesen Zeitraum geschrieben',0),(231012,6417,'en','Employee Check already written for this Period',0),(231013,6418,'is','',0),(231014,6418,'dr','Ø¨Ø§ÙŠØ¯ Ú†Ùƒ Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†Ø¬Ø§Ù… ØªØºÙŠÙŠØ±Ø§Øª Ø¨Ø§Ø·Ù„ ÙƒÙ†ÙŠØ¯ ',0),(231015,6418,'pr','Ø¨Ø§ÙŠØ¯ Ú†Ùƒ Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†Ø¬Ø§Ù… ØªØºÙŠÙŠØ±Ø§Øª Ø¨Ø§Ø·Ù„ ÙƒÙ†ÙŠØ¯ ',0),(231016,6418,'tr','DeÄŸiÅŸiklik yapmadan Ã¶nce Ã§eki geÃ§ersiz kÄ±lmak gerekir',0),(231017,6418,'pl','Musi uniewaÅ¼niÄ‡ sprawdziÄ‡ przed dokonaniem zmiany',0),(231018,6418,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ñ‚Ðµ Ñ‡ÐµÐº Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(231019,6418,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ú©Ø±Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ú†ÛŒÚ© ØµÙØ± Ú†Ø§ÛÛŒÛ’',0),(231020,6418,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ñ‡ÐµÐº Ð¿Ñ€Ðµ Ð²Ñ€ÑˆÐµÑšÐ° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(231021,6418,'vi','Pháº£i há»§y SÃ©c trÆ°á»›c khi thay Ä‘á»•i',0),(231022,6418,'af','Moet Kontroleer voordat veranderinge Void',0),(231023,6418,'ro','Trebuie sÄƒ anulaÅ£i CEC Ã®nainte de a face modificÄƒri',0),(231024,6418,'et','Peab TÃ¼hista tÅ¡ekk enne muudatuste tegemist',0),(231025,6418,'si','Mora Razveljavi Äek pred spremembami',0),(231026,6418,'ba','Harus membatalkan Check sebelum membuat perubahan',0),(231027,6418,'nl','Cheque voordat u wijzigingen aanbrengt moet vernietigen',0),(231028,6418,'fi','On MitÃ¤tÃ¶i sekki ennen muutosten',0),(231029,6418,'no','MÃ¥ kansellere sjekk fÃ¸r du gjÃ¸r endringer',0),(231030,6418,'da','Skal annullere Check fÃ¸r du foretager Ã¦ndringer',0),(231031,6418,'ko','ë³€ê²½ í•˜ê¸° ì „ì— ê²€ì‚¬ë¥¼ ë¬´íš¨í™” í•´ì•¼ í•©ë‹ˆë‹¤.',0),(231032,6418,'he','×¢×œ×™×š ×œ×‘×˜×œ ××ª ×¡×™×ž×•×Ÿ ×œ×¤× ×™ ×‘×™×¦×•×¢ ×©×™× ×•×™×™×',0),(231033,6418,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î±ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ ÎµÏ€Î¹Ï„Î±Î³Î® Ï€ÏÎ¹Î½ ÎºÎ¬Î½ÎµÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚',0),(231034,6418,'zh','è¿›è¡Œæ›´æ”¹ä¹‹å‰å¿…é¡»æ£€æŸ¥æ— æ•ˆ\r\n',0),(231035,6418,'sv','MÃ¥ste annullera checken innan du gÃ¶r Ã¤ndringar',0),(231036,6418,'it','Deve invalidare l\'assegno prima di apportare modifiche',0),(231037,6418,'tl','',0),(231038,6418,'th','&#3605;&#3657;&#3629;&#3591;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3594;&#3655;&#3588;&#3585;&#3656;&#3629;&#3609;&#3607;&#3635;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(231039,6418,'hi','à¤šà¥‡à¤• à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(231040,6418,'ms','Mesti membatalkan semak sebelum membuat perubahan',0),(231041,6418,'ar','ÙŠØ¬Ø¨ Ø¥ÙØ±Ø§Øº Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù‚Ø¨Ù„ Ø¥Ø¬Ø±Ø§Ø¡ Ø£ÙŠØ© ØªØºÙŠÙŠØ±Ø§Øª',0),(231042,6418,'fr','Doit invalider le chÃ¨que avant d\'effectuer les changements',0),(231043,6418,'jp','å¤‰æ›´ã?™ã‚‹å‰?ã?«å°?åˆ‡æ‰‹ã‚’ç ´æ£„ã?—ã?ªã??ã?¦ã?¯ã?„ã?‘ã?¾ã?›ã‚“',0),(231044,6418,'pt','Deve anular a seleÃ§Ã£o antes de fazer alteraÃ§Ãµes',0),(231045,6418,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ‡ÐµÐº Ð¿ÐµÑ€ÐµÐ´ Ð²Ð½ÐµÑÐµÐ½Ð¸ÐµÐ¼ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(231046,6418,'es','Debe Anular Cheque antes que Hacer Cambios',0),(231047,6418,'de','Muss Void Check bevor Ã„nderungen',0),(231048,6418,'en','Must Void Check before Making Changes',0),(231049,6419,'is','',0),(231050,6419,'dr','B2BÚ¯Ø±Ø§ÙÙŠÙƒ Ø³Ø§ÙŠØª  ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(231051,6419,'pr','B2BÚ¯Ø±Ø§ÙÙŠÙƒ Ø³Ø§ÙŠØª  ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(231052,6419,'tr','B2B sitesi grafik',0),(231053,6419,'pl','Grafika strony B2B',0),(231054,6419,'bg','B2B ÑÐ°Ð¹Ñ‚ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(231055,6419,'ur','B2B Ø³Ø§Ø¦Ù¹ Ú¯Ø±Ø§ÙÚ©Ø³',0),(231056,6419,'sr','Ð‘2Ð‘ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(231057,6419,'vi','Äá»“ Há»a Trang B2B',0),(231058,6419,'af','B2B Webwerf Grafika',0),(231059,6419,'ro','Grafica site-ului B2B',0),(231060,6419,'et','B2B lehe graafika',0),(231061,6419,'si','B2B spletno stran grafike',0),(231062,6419,'ba','Situs B2B grafis',0),(231063,6419,'nl','B2B Site Graphics',0),(231064,6419,'fi','B2B sivuston grafiikkaa',0),(231065,6419,'no','B2B Site grafikk',0),(231066,6419,'da','B2B Site grafik',0),(231067,6419,'ko','B2B ì‚¬ì´íŠ¸ ê·¸ëž˜í”½',0),(231068,6419,'he','B2B ×œ××ª×¨ ×’×¨×¤×™×§×”',0),(231069,6419,'el','B2B Site Î³ÏÎ±Ï†Î¹ÎºÏŽÎ½',0),(231070,6419,'zh','å•†ä¸šå¯¹å•†ä¸šç½‘ç«™çš„å›¾å½¢\r\n',0),(231071,6419,'sv','B2B webbplats grafik',0),(231072,6419,'it','Grafica sito azienda B2B',0),(231073,6419,'tl','',0),(231074,6419,'th','&#3604;&#3657;&#3634;&#3609;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588; B2B',0),(231075,6419,'hi','B2B à¤¸à¤¾à¤‡à¤Ÿ à¤—à¥à¤°à¤¾à¤«à¤¿à¤•à¥à¤¸',0),(231076,6419,'ms','Grafik Laman web B2B',0),(231077,6419,'ar','Ø±Ø³ÙˆÙ…Ø§Øª Ù…ÙˆÙ‚Ø¹ Ø´Ø±ÙƒØ§Ø¡ Ø§Ù„ØªØ¹Ø§Ù…Ù„',0),(231078,6419,'fr','Graphisme du Site B2B',0),(231079,6419,'jp','B2Bã‚µã‚¤ãƒˆã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯',0),(231080,6419,'pt','B2B Site grÃ¡ficos',0),(231081,6419,'ru','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ð¡Ð°Ð¹Ñ‚Ð° B2B',0),(231082,6419,'es','N2N GrÃ¡ficos de Sitio',0),(231083,6419,'de','B2B Website Grafiken',0),(231084,6419,'en','B2B Site Graphics',0),(231085,6420,'is','',0),(231086,6420,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø®Ø±ÙŠØ¯Ø§Ø±  ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(231087,6420,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø®Ø±ÙŠØ¯Ø§Ø±  ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(231088,6420,'tr','MÃ¼ÅŸteri B2B kullanÄ±cÄ± gÃ¼ncelleÅŸtirme',0),(231089,6420,'pl','Klienta B2B uÅ¼ytkownika aktualizacji',0),(231090,6420,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ B2B Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(231091,6420,'ur','Ú©Ø³Ù¹Ù…Ø± B2B ØµØ§Ø±Ù ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(231092,6420,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð‘2Ð‘ ÐºÑƒÐ¿Ñ†Ð°',0),(231093,6420,'vi','Cáº­p Nháº­t NgÆ°á»i Sá»­ Dá»¥ng Cá»§a KhÃ¡ch HÃ ng B2B',0),(231094,6420,'af','Klant / KliÃ«nt B2B Gebruiker Opdateer',0),(231095,6420,'ro','Client B2B utilizator Update',0),(231096,6420,'et','B2B klientide kasutajate uuendamine',0),(231097,6420,'si','Modernizirati uporabnik B2B kupca',0),(231098,6420,'ba','Pelanggan B2B pengguna Update',0),(231099,6420,'nl','Klant B2B gebruiker Update',0),(231100,6420,'fi','Asiakkaan B2B User-pÃ¤ivitys',0),(231101,6420,'no','Kunden B2B bruker oppdateringen',0),(231102,6420,'da','Kunde B2B bruger Update',0),(231103,6420,'ko','ê³ ê° B2B ì‚¬ìš©ìž ì—…ë°ì´íŠ¸',0),(231104,6420,'he','×¢×“×›×•×Ÿ ×”×ž×©×ª×ž×© B2B ×œ×§×•×—×•×ª',0),(231105,6420,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ B2B Ï‡ÏÎ®ÏƒÏ„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(231106,6420,'zh','å®¢æˆ·çš„å•†ä¸šå¯¹å•†ä¸šç”¨æˆ·æ›´æ–°\r\n',0),(231107,6420,'sv','Kunden B2B anvÃ¤ndaren uppdatera',0),(231108,6420,'it','Aggiornamento utente di cliente B2B',0),(231109,6420,'tl','',0),(231110,6420,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657; B2B',0),(231111,6420,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• B2B à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(231112,6420,'ms','Pelanggan B2B pengguna Kemaskini',0),(231113,6420,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ø²Ø¨ÙˆÙ† - Ø´Ø±ÙƒØ§Ø¡ Ø§Ù„ØªØ¹Ø§Ù…Ù„',0),(231114,6420,'fr','Mise Ã  jour de l\'utilisateur client B2B',0),(231115,6420,'jp','é¡§å®¢B2Bãƒ¦ãƒ¼ã‚¶ãƒ¼æ›´æ–°',0),(231116,6420,'pt','AtualizaÃ§Ã£o de usuÃ¡rio do cliente B2B',0),(231117,6420,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ B2B',0),(231118,6420,'es','Cliente N2N ActualizaciÃ³n de Usuario',0),(231119,6420,'de','Kunde B2B Benutzer Update',0),(231120,6420,'en','Customer B2B User Update',0),(231121,6421,'is','',0),(231122,6421,'dr','Ø­Ø°Ù Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø± Ø§Ø² Ø¯Ø³ØªØ±Ø³ÙŠ ØªØ¬Ø§Ø±Øª  Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(231123,6421,'pr','Ø­Ø°Ù Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø± Ø§Ø² Ø¯Ø³ØªØ±Ø³ÙŠ ØªØ¬Ø§Ø±Øª  Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(231124,6421,'tr','B2B giriÅŸ--dan bu kullanÄ±cÄ± Sil',0),(231125,6421,'pl','UsunÄ…Ä‡ tego uÅ¼ytkownika z dostÄ™pu B2B',0),(231126,6421,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð¾Ñ‚ B2B Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(231127,6421,'ur','B2B Ø±Ø³Ø§Ø¦ÛŒ Ø³Û’ Ø§Ø³ ØµØ§Ø±Ù Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(231128,6421,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¾Ð²Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¸Ð· Ð‘2Ð‘ ÐÑ†Ñ†ÐµÑÑ',0),(231129,6421,'vi','XÃ³a NgÆ°á»i Sá»­ Dá»¥ng nÃ y khá»i danh sÃ¡ch truy cáº­p B2B',0),(231130,6421,'af','Skrap hierdie Gebruiker vanaf B2B Toegang',0),(231131,6421,'ro','ÅžtergeÅ£i acest utilizator la B2B acces',0),(231132,6421,'et','Kustuta see kasutaja B2B ligipÃ¤Ã¤sust',0),(231133,6421,'si','IzbriÅ¡ite ta uporabnik B2B dostop',0),(231134,6421,'ba','Menghapus pengguna dari akses B2B',0),(231135,6421,'nl','Delete This User van B2B toegang',0),(231136,6421,'fi','Poistaa tÃ¤mÃ¤n kÃ¤yttÃ¤jÃ¤n B2B Accessista',0),(231137,6421,'no','Slette denne brukeren fra B2B tilgang',0),(231138,6421,'da','Slet denne bruger fra B2B adgang',0),(231139,6421,'ko','B2B ì•¡ì„¸ìŠ¤ì—ì„œì´ ì‚¬ìš©ìžë¥¼ ì‚­ì œ',0),(231140,6421,'he','×ž×—×™×§×ª ×ž×©×ª×ž×© ×–×” ×’×™×©×” B2B',0),(231141,6421,'el','Î”Î™Î‘Î“Î¡Î‘Î¨Î•Î¤Î• Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï‡ÏÎ®ÏƒÏ„Î· Î±Ï€ÏŒ Ï„Î·Î½ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· B2B',0),(231142,6421,'zh','åˆ é™¤è¯¥ç”¨æˆ·ä»Žå•†ä¸šå¯¹å•†ä¸šè®¿é—®\r\n',0),(231143,6421,'sv','Ta bort anvÃ¤ndaren frÃ¥n B2B tillgÃ¥ng',0),(231144,6421,'it','Cancella questo utente dall\'accesso B2B',0),(231145,6421,'tl','',0),(231146,6421,'th','&#3621;&#3610;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3609;&#3637;&#3657;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621; B2B',0),(231147,6421,'hi','B2B Access à¤¸à¥‡ à¤‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(231148,6421,'ms','Hapuskan pengguna ini daripada akses B2B',0),(231149,6421,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù…Ù† Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ B2B',0),(231150,6421,'fr','Supprimer cet utilisateur d\'accÃ¨s B2B',0),(231151,6421,'jp','ã?“ã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’B2Bã‚¢ã‚¯ã‚»ã‚¹ã?‹ã‚‰æ¶ˆåŽ»',0),(231152,6421,'pt','Apagar este usuÃ¡rio de acesso B2B',0),(231153,6421,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð”Ð¾Ð¿ÑƒÑÐº Ð”Ð°Ð½Ð½Ð¾Ð³Ð¾ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ðš B2B',0),(231154,6421,'es','Eliminar este Usuario de Acceso a N2N',0),(231155,6421,'de','Dieser Benutzer aus B2B-Zugang lÃ¶schen',0),(231156,6421,'en','Delete This User from B2B Access',0),(231157,6422,'is','',0),(231158,6422,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ø¨Ø± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø³ÙŠØ³ØªÙ… ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(231159,6422,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ø¨Ø± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø³ÙŠØ³ØªÙ… ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(231160,6422,'tr','SatÄ±cÄ± B2B kullanÄ±cÄ± gÃ¼ncelleÅŸtirme',0),(231161,6422,'pl','Aktualizacja uÅ¼ytkownika dostawcy B2B',0),(231162,6422,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº B2B Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(231163,6422,'ur','ÙˆÛŒÙ†ÚˆØ± B2B ØµØ§Ø±Ù ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(231164,6422,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð‘2Ð‘ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(231165,6422,'vi','Cáº­p Nháº­t NgÆ°á»i BÃ¡n B2B',0),(231166,6422,'af','Verskaffer B2B Gebruiker Opdatering',0),(231167,6422,'ro','Furnizor B2B utilizator actualizare',0),(231168,6422,'et','Hankija B2B kasutaja vÃ¤rskendus',0),(231169,6422,'si','Modernizirati uporabnik B2B dobavitelja',0),(231170,6422,'ba','Penjual B2B pengguna Update',0),(231171,6422,'nl','Update voor B2B leverancier',0),(231172,6422,'fi','Toimittajien B2B User-pÃ¤ivitys',0),(231173,6422,'no','LeverandÃ¸ren B2B bruker oppdateringen',0),(231174,6422,'da','Forhandler B2B bruger Update',0),(231175,6422,'ko','ê³µê¸‰ ì—…ì²´ B2B ì‚¬ìš©ìž ì—…ë°ì´íŠ¸',0),(231176,6422,'he','×”×¡×¤×§ B2B ×ž×©×ª×ž×© ×¢×“×›×•×Ÿ',0),(231177,6422,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ B2B Ï‡ÏÎ®ÏƒÏ„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(231178,6422,'zh','ä¾›åº”å•†çš„B2Bç”¨æˆ·æ›´æ–°\r\n',0),(231179,6422,'sv','LeverantÃ¶r B2B anvÃ¤ndaren uppdatering',0),(231180,6422,'it','Aggiornamento utente del fornitore B2B',0),(231181,6422,'tl','',0),(231182,6422,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618; B2B',0),(231183,6422,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ B2B à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(231184,6422,'ms','Penjual B2B pengguna Kemaskini',0),(231185,6422,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø³ØªØ®Ø¯Ù…ÙŠ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ - Ø´Ø±ÙƒØ§Ø¡ Ø§Ù„ØªØ¹Ø§Ù…Ù„',0),(231186,6422,'fr','Mise Ã  jour de lâ€™utilisateur du vendeur B2B',0),(231187,6422,'jp','æ¥­è€…B2Bãƒ¦ãƒ¼ã‚¶ãƒ¼æ›´æ–°',0),(231188,6422,'pt','AtualizaÃ§Ã£o do usuÃ¡rio fornecedor B2B',0),(231189,6422,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ B2B',0),(231190,6422,'es','Proveedor N2N Usuario Actualizar',0),(231191,6422,'de','Anbieter B2B Benutzer Update',0),(231192,6422,'en','Vendor B2B User Update',0),(231193,6423,'is','',0),(231194,6423,'dr','Ú†Ø§Ù¾ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø§ ÙƒØ¯Ù‡Ø§ÙŠ Ø·ÙˆÙ„Ø§Ù†ÙŠ ÙƒØ§Ù„Ø§',0),(231195,6423,'pr','Ú†Ø§Ù¾ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¨Ø§ ÙƒØ¯Ù‡Ø§ÙŠ Ø·ÙˆÙ„Ø§Ù†ÙŠ ÙƒØ§Ù„Ø§',0),(231196,6423,'tr','UZUN madde kodlarÄ± ile standart yazdÄ±rma',0),(231197,6423,'pl','Standardowe drukowanie z pozycji dÅ‚ugich kodÃ³w',0),(231198,6423,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ð¿ÐµÑ‡Ð°Ñ‚ Ñ Ð´ÑŠÐ»ÑŠÐ³ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÐ¾Ð´Ð¾Ð²Ðµ',0),(231199,6423,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø·ÙˆÛŒÙ„ Ø´Û’ Ú©ÙˆÚˆØ² Ú©Û’ Ø³Ø§ØªÚ¾',0),(231200,6423,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ ÐŸÑ€Ð¸Ð½Ñ‚ ÑÐ° ÑˆÐ¸Ñ„Ñ€Ð°Ð¼Ð° Ð´ÑƒÐ³Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(231201,6423,'vi','In chuáº©n vá»›i mÃ£ hÃ ng dÃ i',0),(231202,6423,'af','Standaard Uitdruk vir LANG Itemkodes',0),(231203,6423,'ro','Imprimare standard cu coduri de lung articol',0),(231204,6423,'et','Standard prindi pikk kauba koodid',0),(231205,6423,'si','Standard tiskanja z dolgo reÄ zbornik',0),(231206,6423,'ba','Standar cetak dengan kode panjang Item',0),(231207,6423,'nl','Standaard afdrukken met lange Item Codes',0),(231208,6423,'fi','Standardin tulostaa pitkÃ¤n nimikekoodit',0),(231209,6423,'no','Standard utskrift med lang varekoder',0),(231210,6423,'da','Standard Print med lange varekoder',0),(231211,6423,'ko','ê¸´ í•­ëª© ì½”ë“œì™€ í‘œì¤€ ì¸ì‡„',0),(231212,6423,'he','×”×“×¤×¡×” ×¡×˜× ×“×¨×˜×™ ×¢× ×§×•×“×™ ×¤×¨×™×˜ ××¨×•×š',0),(231213,6423,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î¼Îµ ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚ ÎµÎ¹Î´ÏŽÎ½ Î¼Î±ÎºÏÎ¬',0),(231214,6423,'zh','æ ‡å‡†é•¿é¡¹ç›®ä»£ç æ‰“å°\r\n',0),(231215,6423,'sv','Standard Print med lÃ¥ng artikelkoder',0),(231216,6423,'it','Stampa standard con codici articolo lungo',0),(231217,6423,'tl','',0),(231218,6423,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3649;&#3610;&#3610;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3604;&#3657;&#3623;&#3618;&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3610;&#3610;&#3618;&#3634;&#3623;',0),(231219,6423,'hi','à¤²à¤¾à¤‚à¤— à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤®à¤¾à¤¨à¤• à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(231220,6423,'ms','Standard cetakan dengan kod-kod Item yang panjang',0),(231221,6423,'ar','Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ù…Ø¹ Ø±Ù…ÙˆØ² Ø§Ù„Ø¨Ù†Ø¯ Ø·ÙˆÙŠÙ„Ø©',0),(231222,6423,'fr','Impression standard avec Codes LONG point',0),(231223,6423,'jp','é•·ã?„å“?ç›®ã‚³ãƒ¼ãƒ‰ã‚’ä½¿ç”¨ã?—ã?Ÿæ¨™æº–å?°åˆ·',0),(231224,6423,'pt','ImpressÃ£o PadrÃ£o com CÃ³digo de Item LONGO',0),(231225,6423,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð°Ñ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ñ Ð´Ð»Ð¸Ð½Ð¾Ð¹ ÐºÐ¾Ð´Ð¾Ð²',0),(231226,6423,'es','Imprimir EstÃ¡ndar con CÃ³digos LARGOS de los Items',0),(231227,6423,'de','Standard Druck mit langen Leistungsnummern',0),(231228,6423,'en','Standard Print with LONG Item Codes',0),(231229,6424,'is','',0),(231230,6424,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(231231,6424,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(231232,6424,'tr','VarsayÄ±lan stok GL ACCT\'dir',0),(231233,6424,'pl','DomyÅ›lnie spis GL Acct.',0),(231234,6424,'bg','ÐÐ° ÑÐºÐ»Ð°Ð´Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ GL ÐŸÐ ',0),(231235,6424,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¬ÛŒØ¬Û’ Acct.',0),(231236,6424,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð“Ð› ÐÑ†Ñ†Ñ‚.',0),(231237,6424,'vi','TK hÃ ng hÃ³a Sá»• CÃ¡i Tá»•ng Há»£p Máº·c Äá»‹nh',0),(231238,6424,'af','Verstekte Voorraad AG Rek.',0),(231239,6424,'ro','Implicit inventar GL Acct.',0),(231240,6424,'et','Lao GL Acct.',0),(231241,6424,'si','Privzete inventure GL Acct.',0),(231242,6424,'ba','Default persediaan GL Acct.',0),(231243,6424,'nl','Standaardinventaris GL Acct.',0),(231244,6424,'fi','Oletusarvoinen varaston GL Acct.',0),(231245,6424,'no','Standardinnholdslisten GL Acct.',0),(231246,6424,'da','Standard lageret GL Acct.',0),(231247,6424,'ko','ê¸°ë³¸ ì¸ë²¤í† ë¦¬ GL Acct.',0),(231248,6424,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×ž×œ××™ GL Acct.',0),(231249,6424,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î±Ï€Î¿Î³ÏÎ±Ï†Î® GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï.',0),(231250,6424,'zh','é»˜è®¤åº“å­˜æ€»å¸ä¼šè®¡',0),(231251,6424,'sv','Standard inventering GL Acct.',0),(231252,6424,'it','Inventario predefinito GL acct.',0),(231253,6424,'tl','',0),(231254,6424,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3',0),(231255,6424,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥‚à¤šà¥€ GL Acct.',0),(231256,6424,'ms','Inventori lalai GL Acct.',0),(231257,6424,'ar','Ø§Ù„Ø¬Ø±Ø¯ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù„Ø­Ø³Ø§Ø¨ GL',0),(231258,6424,'fr','Par dÃ©faut l\'inventaire GL ACCT.',0),(231259,6424,'jp','æ—¢å®šåœ¨åº«ï¼§ï¼¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(231260,6424,'pt','InventÃ¡rio padrÃ£o envÃ­ GL',0),(231261,6424,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ GL Acct.',0),(231262,6424,'es','Cuenta LM de Inventario por Defecto',0),(231263,6424,'de','Standardinventurmethode GL acct.',0),(231264,6424,'en','Default Inventory GL Acct.',0),(231265,6425,'is','',0),(231266,6425,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(231267,6425,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(231268,6425,'tr','Ä°ÅŸ emri #',0),(231269,6425,'pl','KolejnoÅ›Ä‡ prac #',0),(231270,6425,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° #',0),(231271,6425,'ur','Ú©Ø§Ù… ØªØ±ØªÛŒØ¨ #',0),(231272,6425,'sr','Ð Ð°Ð´ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ #',0),(231273,6425,'vi','ÄÆ¡n hÃ ng cÃ´ng viá»‡c sá»‘',0),(231274,6425,'af','Werksbestelling#',0),(231275,6425,'ro','Lucra ordin #',0),(231276,6425,'et','TÃ¶Ã¶ kÃ¤sk',0),(231277,6425,'si','Delo nalog #',0),(231278,6425,'ba','Kerja Order #',0),(231279,6425,'nl','Werk bestelling #',0),(231280,6425,'fi','TyÃ¶ jÃ¤rjestyksessÃ¤ #',0),(231281,6425,'no','Arbeidet ordre #',0),(231282,6425,'da','Arbejde orden #',0),(231283,6425,'ko','ìž‘ì—… ìˆœì„œ #',0),(231284,6425,'he','×¡×“×¨ ×”×¢×‘×•×“×” #',0),(231285,6425,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± #',0),(231286,6425,'zh','å·¥ä½œå•ï¼ƒ\r\n',0),(231287,6425,'sv','Arbete bestÃ¤llningen #',0),(231288,6425,'it','Ordine di lavoro #',0),(231289,6425,'tl','',0),(231290,6425,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3591;&#3634;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(231291,6425,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤†à¤¦à¥‡à¤¶ #',0),(231292,6425,'ms','Kerja-kerja pesanan #',0),(231293,6425,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù…Ù„ #',0),(231294,6425,'fr','Ordre de travail #',0),(231295,6425,'jp','ä½œæ¥­æ³¨æ–‡ç•ªå?·',0),(231296,6425,'pt','Ordem de trabalho #',0),(231297,6425,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°ÐºÐ°Ð· #',0),(231298,6425,'es','Orden de trabajo #',0),(231299,6425,'de','Arbeit Bestellnummer',0),(231300,6425,'en','Work Order#',0),(231301,6426,'is','',0),(231302,6426,'dr','( ØªØ¹Ø¯Ø§Ø¯',0),(231303,6426,'pr','Ø­Ø°Ù Ù‡Ù…Ù‡ Ø´Ù…Ø§Ø±Ø´ Ù‡Ø§ ( ØªØ¹Ø¯Ø§Ø¯',0),(231304,6426,'tr','TÃ¼m sayaÃ§larÄ± silmek',0),(231305,6426,'pl','UsuÅ„ wszystkie liczniki',0),(231306,6426,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð±Ñ€Ð¾Ð¸',0),(231307,6426,'ur','ØªÙ…Ø§Ù… Ø´Ù…Ø§Ø± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(231308,6426,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ ÑÐ²Ð¸Ñ… Ñ‚Ð°Ñ‡Ð°ÐºÐ°',0),(231309,6426,'vi','XÃ³a táº¥t cáº£ Ä‘áº¿m',0),(231310,6426,'af','Skrap all Tellings',0),(231311,6426,'ro','ÅžtergeÅ£i toate capetele de acuzare',0),(231312,6426,'et','Kustuta kÃµik loeb',0),(231313,6426,'si','Izbrisati vsi grofovstvo',0),(231314,6426,'ba','Menghapus semua penting',0),(231315,6426,'nl','Verwijderen van alle punten',0),(231316,6426,'fi','Poista kaikki lasketaan',0),(231317,6426,'no','Slette alle punkter',0),(231318,6426,'da','Slet alle tÃ¦ller',0),(231319,6426,'ko','ëª¨ë“  ì¡°ì‚¬ ì‚­ì œ',0),(231320,6426,'he','×œ×ž×—×•×§ ×‘×›×œ ×”×¡×¢×™×¤×™×',0),(231321,6426,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î±ÏÎ¹Î¸Î¼Î®ÏƒÎµÎ¹Ï‚',0),(231322,6426,'zh','åˆ é™¤æ‰€æœ‰è®¡æ•°\r\n',0),(231323,6426,'sv','Ta bort alla rÃ¤knar',0),(231324,6426,'it','Eliminare tutti i conteggi',0),(231325,6426,'tl','',0),(231326,6426,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3609;&#3633;&#3610;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(231327,6426,'hi','à¤¸à¤¬ à¤®à¤¾à¤¯à¤¨à¥‡ à¤°à¤–à¤¤à¤¾ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(231328,6426,'ms','Menghapuskan semua tuduhan',0),(231329,6426,'ar','Ø­Ø°Ù Ø¬Ù…ÙŠØ¹ Ø§Ù„ØªÙ‡Ù… Ø§Ù„Ù…ÙˆØ¬Ù‡Ø© Ø¥Ù„ÙŠÙ‡',0),(231330,6426,'fr','Supprimer tous les chefs d\'accusation',0),(231331,6426,'jp','å…¨ã?¦ã?®ã‚«ã‚¦ãƒ³ãƒˆã‚’æ¶ˆåŽ»',0),(231332,6426,'pt','Excluir todas as acusaÃ§Ãµes',0),(231333,6426,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð²ÑÐµ ÑÑ‡ÐµÑ‚Ñ‡Ð¸ÐºÐ¸',0),(231334,6426,'es','Eliminar Todo los Conteos',0),(231335,6426,'de','LÃ¶schen von allen Anklagepunkten',0),(231336,6426,'en','Delete all Counts',0),(231337,6427,'is','',0),(231338,6427,'dr','/ Ù‚ÙŠÙ…Øª',0),(231339,6427,'pr','Ù…Ù‚Ø¯Ø§Ø± / Ù‚ÙŠÙ…Øª',0),(231340,6427,'tr','Miktar / fiyat',0),(231341,6427,'pl','IloÅ›Ä‡ / cena',0),(231342,6427,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ / Ñ†ÐµÐ½Ð°',0),(231343,6427,'ur','Ù‚ÛŒ / Ù‚ÛŒÙ…Øª',0),(231344,6427,'sr','ÐšÐ¾Ð» / Ñ†ÐµÐ½Ð°',0),(231345,6427,'vi','Sá»‘ lÆ°á»£ng/giÃ¡ ',0),(231346,6427,'af','Hoev. / Prys',0),(231347,6427,'ro','Cantitate / Pret',0),(231348,6427,'et','Kogus/Hind',0),(231349,6427,'si','KoliÄina / cena',0),(231350,6427,'ba','Qty / harga',0),(231351,6427,'nl','Aantal / prijs',0),(231352,6427,'fi','MÃ¤Ã¤rÃ¤ / hinta',0),(231353,6427,'no','Antall / pris',0),(231354,6427,'da','Antal / pris',0),(231355,6427,'ko','ìˆ˜ëŸ‰ / ê°€ê²©',0),(231356,6427,'he','×›×ž×•×ª / ×ž×—×™×¨',0),(231357,6427,'el','Qty / Ï„Î¹Î¼Î®',0),(231358,6427,'zh','æ•°é‡/ä»·æ ¼\r\n',0),(231359,6427,'sv','Antal / pris',0),(231360,6427,'it','Q. tÃ  / prezzo',0),(231361,6427,'tl','',0),(231362,6427,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;/&#3619;&#3634;&#3588;&#3634;',0),(231363,6427,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ / à¤®à¥‚à¤²à¥à¤¯',0),(231364,6427,'ms','Qty / harga',0),(231365,6427,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© / Ø§Ù„Ø³Ø¹Ø±',0),(231366,6427,'fr','Qty / Prix',0),(231367,6427,'jp','æ•°é‡?/ä¾¡æ ¼',0),(231368,6427,'pt','Qty / preÃ§o',0),(231369,6427,'ru','ÐšÐ¾Ð»-Ð²Ð¾ / Ð¦ÐµÐ½Ð°',0),(231370,6427,'es','Cant. / Precio',0),(231371,6427,'de','Menge / Preis',0),(231372,6427,'en','Qty / Price',0),(231373,6428,'is','',0),(231374,6428,'dr','2',0),(231375,6428,'pr','Ú†Ø§Ù¾ Ø§ÙˆÙ„ÙŠÙ‡ Ú¯Ø²ÙŠÙ†Ù‡     2',0),(231376,6428,'tr','Preprint seÃ§enek 2',0),(231377,6428,'pl','Preprint opcja 2',0),(231378,6428,'bg','ÐŸÑ€ÐµÐ´Ð¿ÐµÑ‡Ð°Ñ‚ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ 2',0),(231379,6428,'ur','Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ Ø§Ø®ØªÛŒØ§Ø± 2',0),(231380,6428,'sr','2 . Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð¿Ñ€ÐµÐ¿Ñ€Ð¸Ð½Ñ‚',0),(231381,6428,'vi','Lá»±a chá»n báº£n trÆ°á»›c khi in 2',0),(231382,6428,'af','Vooruitdruk Opsie 2',0),(231383,6428,'ro','Manuscrise opÅ£iunea 2',0),(231384,6428,'et','Asuvad avaldamiseelsetes variant 2',0),(231385,6428,'si','Preprint moÅ¾nost 2',0),(231386,6428,'ba','Preprint opsi 2',0),(231387,6428,'nl','Preprint optie 2',0),(231388,6428,'fi','PrePrint vaihtoehto 2',0),(231389,6428,'no','Konferansedokument alternativ 2',0),(231390,6428,'da','Preprint mulighed 2',0),(231391,6428,'ko','ë…¼ë¬¸ ì˜µì…˜ 2',0),(231392,6428,'he','Preprint ××¤×©×¨×•×ª 2',0),(231393,6428,'el','Î ÏÎ¿-Î´Î¿ÎºÎ¯Î¼Î¹Î¿ ÎµÏ€Î¹Î»Î¿Î³Î® 2',0),(231394,6428,'zh','é¢„å°æœ¬é€‰é¡¹2\r\n',0),(231395,6428,'sv','Preprint alternativ 2',0),(231396,6428,'it','Prestampa opzione 2',0),(231397,6428,'tl','',0),(231398,6428,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660; 2',0),(231399,6428,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª 2 preprint',0),(231400,6428,'ms','Preprint pilihan 2',0),(231401,6428,'ar','ÙˆØ±Ù‚Ø© Ø§Ù„Ø®ÙŠØ§Ø± 2',0),(231402,6428,'fr','Nous inclurons Option 2',0),(231403,6428,'jp','äº‹å‰?å?°åˆ·ã‚ªãƒ—ã‚·ãƒ§ãƒ³ï¼’',0),(231404,6428,'pt','Preprint opÃ§Ã£o 2',0),(231405,6428,'ru','Ð˜ÐŸÐœ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ 2',0),(231406,6428,'es','Preimprimir OpciÃ³n 2',0),(231407,6428,'de','Preprint Option 2',0),(231408,6428,'en','Preprint Option 2',0),(231409,6429,'is','',0),(231410,6429,'dr','Ø§Ø¹ØªØ¨Ø§Ø± Ø¨Ù‡ ÙƒØ§Ø± Ø¨Ø±Ø¯Ù‡ Ø´Ø¯Ù‡',0),(231411,6429,'pr','Ø§Ø¹ØªØ¨Ø§Ø± Ø¨Ù‡ ÙƒØ§Ø± Ø¨Ø±Ø¯Ù‡ Ø´Ø¯Ù‡',0),(231412,6429,'tr','Uygulanan kredi',0),(231413,6429,'pl','KredytÃ³w',0),(231414,6429,'bg','ÐŸÑ€ÐµÐ¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(231415,6429,'ur','Ú©Ø±ÛŒÚˆÛŒÙ¹Ø³ Ú©Ø§ Ø§Ø·Ù„Ø§Ù‚',0),(231416,6429,'sr','Ð¨Ð¿Ð¸Ñ†Ð° Ð¿Ñ€Ð¸Ð¼ÐµÑšÐµÐ½Ðµ',0),(231417,6429,'vi','Ãp Dá»¥ng TÃ­n Dá»¥ng',0),(231418,6429,'af','Krediete Aangewend',0),(231419,6429,'ro','Credite aplicate',0),(231420,6429,'et','Taotletud krediiti',0),(231421,6429,'si','Kredite, ki se uporabljajo',0),(231422,6429,'ba','Kredit yang diterapkan',0),(231423,6429,'nl','Kredieten toegepast',0),(231424,6429,'fi','Hyvitykset',0),(231425,6429,'no','Kredittene som er innvilget',0),(231426,6429,'da','Kreditter anvendes',0),(231427,6429,'ko','í¬ë ˆë”§ ì ìš©',0),(231428,6429,'he','×§×¨×“×™×˜×™× ×—×œ×”',0),(231429,6429,'el','Î•Ï†Î±ÏÎ¼Î¿Î³Î®Ï‚ Ï€Î¹ÏƒÏ„ÏŽÏƒÎµÏ‰Î½',0),(231430,6429,'zh','åº”ç”¨ä¿¡ç”¨\r\n',0),(231431,6429,'sv','Krediter tillÃ¤mpas',0),(231432,6429,'it','Crediti applicati',0),(231433,6429,'tl','',0),(231434,6429,'th','&#3586;&#3629;&#3626;&#3617;&#3633;&#3588;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(231435,6429,'hi','à¤à¤ªà¥à¤²à¤¾à¤‡à¤¡ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿà¥à¤¸',0),(231436,6429,'ms','Kredit yang digunakan',0),(231437,6429,'ar','Ø¯Ø§Ø¦Ù†Ø©',0),(231438,6429,'fr','CrÃ©dits appliquÃ©es',0),(231439,6429,'jp','é?©ç”¨è²¸ä»˜',0),(231440,6429,'pt','CrÃ©ditos aplicados',0),(231441,6429,'ru','Ð—Ð°Ñ‡Ñ‚ÐµÐ½Ð½Ñ‹Ðµ',0),(231442,6429,'es','CrÃ©ditos Aplicados',0),(231443,6429,'de','Credits angewendet',0),(231444,6429,'en','Credits Applied',0),(231445,6430,'is','',0),(231446,6430,'dr','Ø§Ø¹ØªØ¨Ø§Ø± Ø¨ÙƒØ§Ø± Ø¨Ø±Ø¯Ù‡ Ø´Ø¯Ù‡',0),(231447,6430,'pr','Ø§Ø¹ØªØ¨Ø§Ø± Ø¨ÙƒØ§Ø± Ø¨Ø±Ø¯Ù‡ Ø´Ø¯Ù‡',0),(231448,6430,'tr','Kredi uygulanÄ±r',0),(231449,6430,'pl','Wnioskowany kredyt',0),(231450,6430,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°',0),(231451,6430,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§ Ø§Ø·Ù„Ø§Ù‚',0),(231452,6430,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð¿Ñ€Ð¸Ð¼ÐµÑšÐµÐ½Ðµ',0),(231453,6430,'vi','Ãp Dá»¥ng TÃ­n Dá»¥ng',0),(231454,6430,'af','Krediet Aangewend',0),(231455,6430,'ro','Aplicate de credit',0),(231456,6430,'et','Rakendada krediidi',0),(231457,6430,'si','Uporabljati kredita',0),(231458,6430,'ba','Kredit yang diterapkan',0),(231459,6430,'nl','Krediet dat wordt toegepast',0),(231460,6430,'fi','Hyvitys',0),(231461,6430,'no','Kreditt som innvilges',0),(231462,6430,'da','Credit anvendes',0),(231463,6430,'ko','ì‹ ìš© ì ìš©',0),(231464,6430,'he','××©×¨××™ ×œ×”×—×™×œ',0),(231465,6430,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎµÏ†Î±ÏÎ¼ÏŒÎ¶Î¿Î½Ï„Î±Î¹',0),(231466,6430,'zh','ä¿¡ç”¨åº”ç”¨\r\n',0),(231467,6430,'sv','Kredit tillÃ¤mpas',0),(231468,6430,'it','Credito applicato',0),(231469,6430,'tl','',0),(231470,6430,'th','&#3586;&#3629;&#3626;&#3617;&#3633;&#3588;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(231471,6430,'hi','à¤à¤ªà¥à¤²à¤¾à¤‡à¤¡ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(231472,6430,'ms','Kredit yang digunakan',0),(231473,6430,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(231474,6430,'fr','CrÃ©dit appliquÃ©',0),(231475,6430,'jp','é?©ç”¨è²¸ä»˜',0),(231476,6430,'pt','CrÃ©dito aplicado',0),(231477,6430,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÑÐµÑ‚ÑÑ',0),(231478,6430,'es','CrÃ©dito Apicado',0),(231479,6430,'de','Gutschrift',0),(231480,6430,'en','Credit Applied',0),(231481,6431,'is','',0),(231482,6431,'dr','Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯',0),(231483,6431,'pr','Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯',0),(231484,6431,'tr','Uygulanan fazla Ã¶deme',0),(231485,6431,'pl','NadpÅ‚aty stosowane',0),(231486,6431,'bg','ÐÐ°Ð´Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸',0),(231487,6431,'ur','Ù„Ú¯Ø§Ø¦ÛŒ Ú¯Ø¦ÛŒ Ø§ÙˆÙˆØ±Ù¾ÛŒÙ…Ø§Ù†Ù¹',0),(231488,6431,'sr','ÐŸÑ€ÐµÐºÐ¾Ð¼ÐµÑ€Ð½Ñƒ Ð¿Ñ€Ð¸Ð¼ÐµÑšÐµÐ½Ðµ',0),(231489,6431,'vi','Ãp dá»¥ng tráº£ quÃ¡',0),(231490,6431,'af','Oorbetaling Toegepas',0),(231491,6431,'ro','SumÄƒ suplimentarÄƒ aplicatÄƒ',0),(231492,6431,'et','Enammaksed rakendatud',0),(231493,6431,'si','PreplaÄilo, uporablja',0),(231494,6431,'ba','Kelebihan yang diterapkan',0),(231495,6431,'nl','Overbetaling toegepast',0),(231496,6431,'fi','Liikaa soveltaa',0),(231497,6431,'no','Overbetalingen brukt',0),(231498,6431,'da','Overbetaling anvendes',0),(231499,6431,'ko','Overpayment ì ìš©',0),(231500,6431,'he','×ª×©×œ×•× ×™×ª×¨ ×—×œ×”',0),(231501,6431,'el','Î‘Ï‡ÏÎµÏ‰ÏƒÏ„Î®Ï„Ï‰Ï‚ ÎºÎ±Ï„Î±Î²Î»Î·Î¸Î­Î½Ï„Î¿Ï‚ ÎµÏ†Î±ÏÎ¼ÏŒÎ¶ÎµÏ„Î±Î¹',0),(231502,6431,'zh','å¤šç¼´çš„åº”ç”¨\r\n',0),(231503,6431,'sv','Ã–verbetalning tillÃ¤mpas',0),(231504,6431,'it','Eccedenza applicata',0),(231505,6431,'tl','',0),(231506,6431,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3585;&#3636;&#3609;&#3585;&#3623;&#3656;&#3634;&#3606;&#3641;&#3585;&#3651;&#3594;&#3657;',0),(231507,6431,'hi','à¤à¤ªà¥à¤²à¤¾à¤‡à¤¡ overpayment',0),(231508,6431,'ms','Berlebihan yang digunakan',0),(231509,6431,'ar','Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© Ø¨Ø§Ù„Ø²ÙŠØ§Ø¯Ø© Ø§Ù„Ù…Ø·Ø¨Ù‚Ø©',0),(231510,6431,'fr','Trop-perÃ§u appliquÃ©e',0),(231511,6431,'jp','é?©ç”¨é?Žèª¤ç´?é‡‘',0),(231512,6431,'pt','Sobrepaga aplicada',0),(231513,6431,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½ÑÐµÑ‚ÑÑ Ð¿ÐµÑ€ÐµÐ¿Ð»Ð°Ñ‚Ñ‹',0),(231514,6431,'es','Pago Excesivo Aplicado',0),(231515,6431,'de','Ãœberzahlung angewendet',0),(231516,6431,'en','Overpayment Applied',0),(231517,6432,'is','',0),(231518,6432,'dr','Ù…Ø¯Øª Ø°Ø®ÙŠØ±Ù‡',0),(231519,6432,'pr','Ù…Ø¯Øª Ø°Ø®ÙŠØ±Ù‡',0),(231520,6432,'tr','Ã–nbellek sÃ¼resi',0),(231521,6432,'pl','DÅ‚ugoÅ›Ä‡ buforu',0),(231522,6432,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð½Ð° Ð½Ð° ÐºÐµÑˆÐ°',0),(231523,6432,'ur','Ú©ÛŒØ³Û Ù„Ù…Ø¨Ø§Ø¦ÛŒ',0),(231524,6432,'sr','Ð”ÑƒÐ¶Ð¸Ð½Ð° ÐºÐµÑˆ',0),(231525,6432,'vi','Chiá»u dÃ i bá»™ nhá»›',0),(231526,6432,'af','Kas lengte',0),(231527,6432,'ro','Cache-ul lungime',0),(231528,6432,'et','VahemÃ¤lu pikkus',0),(231529,6432,'si','DolÅ¾ina predpomnilnika',0),(231530,6432,'ba','Cache panjang',0),(231531,6432,'nl','Cache lengte',0),(231532,6432,'fi','VÃ¤limuistin pituus',0),(231533,6432,'no','Cache lengde',0),(231534,6432,'da','Cache lÃ¦ngde',0),(231535,6432,'ko','ìºì‹œ ê¸¸ì´',0),(231536,6432,'he','××•×¨×š ×ž×˜×ž×•×Ÿ',0),(231537,6432,'el','ÎœÎ®ÎºÎ¿Ï‚ cache',0),(231538,6432,'zh','ç¼“å­˜é•¿åº¦\r\n',0),(231539,6432,'sv','Cache lÃ¤ngd',0),(231540,6432,'it','Lunghezza della cache',0),(231541,6432,'tl','',0),(231542,6432,'th','&#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623;&#3607;&#3637;&#3656;&#3648;&#3585;&#3655;&#3610;&#3586;&#3629;&#3591;',0),(231543,6432,'hi','à¤•à¥ˆà¤¶ à¤²à¤‚à¤¬à¤¾à¤ˆ',0),(231544,6432,'ms','Panjang cache',0),(231545,6432,'ar','Ø·ÙˆÙ„ Ø°Ø§ÙƒØ±Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ† Ø§Ù„Ù…Ø¤Ù‚Øª',0),(231546,6432,'fr','Longueur de cache',0),(231547,6432,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥æœŸé–“',0),(231548,6432,'pt','Comprimento de cache',0),(231549,6432,'ru','Ð”Ð»Ð¸Ð½Ð° ÐºÑÑˆÐ°',0),(231550,6432,'es','TamaÃ±o de Cache',0),(231551,6432,'de','Cache-LÃ¤nge',0),(231552,6432,'en','Cache Length',0),(231553,6433,'is','',0),(231554,6433,'dr','Ù…Ø¯Øª Ø°Ø®ÙŠØ±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(231555,6433,'pr','Ù…Ø¯Øª Ø°Ø®ÙŠØ±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(231556,6433,'tr','Ã–nbellek uzunluklarÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi.',0),(231557,6433,'pl','PamiÄ™ci podrÄ™cznej dÅ‚ugoÅ›ci pomyÅ›lnie zaktualizowana.',0),(231558,6433,'bg','ÐšÐµÑˆ Ð´ÑŠÐ»Ð¶Ð¸Ð½Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(231559,6433,'ur','Ù„Ù…Ø¨Ø§Ø¦ÛŒ Ú©ÛŒØ³Û Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ Û”',0),(231560,6433,'sr','ÐšÐµÑˆ Ð´ÑƒÐ¶Ð¸Ð½Ðµ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(231561,6433,'vi','Äá»™ dÃ i bá»™ nhá»› cáº­p nháº­t thÃ nh cÃ´ng',0),(231562,6433,'af','Kasgeheue lengtes suksesvol opgedateer.',0),(231563,6433,'ro','Lungimi de cache-ul actualizat cu succes.',0),(231564,6433,'et','VahemÃ¤lu pikkused vÃ¤rskendamine Ãµnnestus.',0),(231565,6433,'si','Predpomnilnik dolÅ¾in uspeÅ¡no posodobljena.',0),(231566,6433,'ba','Cache panjang diperbarui berhasil.',0),(231567,6433,'nl','Cache lengtes bijgewerkt.',0),(231568,6433,'fi','VÃ¤limuistin pituudet pÃ¤ivitettiin onnistuneesti.',0),(231569,6433,'no','Cache lengder oppdatert.',0),(231570,6433,'da','Cache lÃ¦ngder opdateret.',0),(231571,6433,'ko','ìºì‹œ ê¸¸ì´ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(231572,6433,'he','×ž×˜×ž×•×Ÿ ××•×¨×›×™ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”.',0),(231573,6433,'el','ÎœÎ®ÎºÎ· cache ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(231574,6433,'zh','ç¼“å­˜é•¿åº¦æ›´æ–°æˆåŠŸ',0),(231575,6433,'sv','Cache lÃ¤ngder uppdaterats.',0),(231576,6433,'it','Lunghezze di cache aggiornate con successo.',0),(231577,6433,'tl','',0),(231578,6433,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623;&#3607;&#3637;&#3656;&#3648;&#3585;&#3655;&#3610;&#3586;&#3629;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(231579,6433,'hi','à¤•à¥ˆà¤¶ à¤²à¤‚à¤¬à¤¾à¤ˆ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾à¥¤',0),(231580,6433,'ms','Cache panjang berjaya dikemas kini.',0),(231581,6433,'ar','Ø£Ø·ÙˆØ§Ù„ Ø°Ø§ÙƒØ±Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ† Ø§Ù„Ù…Ø¤Ù‚Øª ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­.',0),(231582,6433,'fr','Longueurs de cache mis Ã  jour avec succÃ¨s.',0),(231583,6433,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥æœŸé–“ã?Œæ›´æ–°ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(231584,6433,'pt','Comprimentos de cache atualizados com Ãªxito.',0),(231585,6433,'ru','ÐšÑÑˆ Ð´Ð»Ð¸Ð½Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹.',0),(231586,6433,'es','TamaÃ±os de Cache Actualizados Exitosamente',0),(231587,6433,'de','Cache-LÃ¤ngen, die erfolgreich aktualisiert.',0),(231588,6433,'en','Cache Lengths updated successfully.',0),(231589,6434,'is','',0),(231590,6434,'dr','Ø¢Ø®Ø±ÙŠÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯Ù‡ ',0),(231591,6434,'pr','Ø¢Ø®Ø±ÙŠÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯Ù‡ ',0),(231592,6434,'tr','Son GÃ¼ncellenme Tarihi',0),(231593,6434,'pl','Ostatnia aktualizacja',0),(231594,6434,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(231595,6434,'ur','Ø¢Ø®Ø±ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(231596,6434,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿ÑƒÑ‚ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¾',0),(231597,6434,'vi','Láº§n Cáº­p Nháº­t Cuá»‘i',0),(231598,6434,'af','Laaste Opdatering',0),(231599,6434,'ro','Ultima actualizare',0),(231600,6434,'et','Viimati uuendatud',0),(231601,6434,'si','Zadnja posodobitev',0),(231602,6434,'ba','Terakhir Diperbarui',0),(231603,6434,'nl','Laatst bijgewerkt',0),(231604,6434,'fi','Viimeksi pÃ¤ivitetty',0),(231605,6434,'no','Sist oppdatert',0),(231606,6434,'da','Sidst opdateret',0),(231607,6434,'ko','ë§ˆì§€ë§‰ ì—…ë°ì´íŠ¸',0),(231608,6434,'he','×¢×“×›×•×Ÿ ××—×¨×•×Ÿ:',0),(231609,6434,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(231610,6434,'zh','æœ€åŽæ›´æ–°\r\n',0),(231611,6434,'sv','Senast uppdaterad',0),(231612,6434,'it','Ultimo aggiornamento',0),(231613,6434,'tl','',0),(231614,6434,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(231615,6434,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(231616,6434,'ms','Tarikh Akhir Kemaskini',0),(231617,6434,'ar','Ø¢Ø®Ø± ØªØ­Ø¯ÙŠØ«',0),(231618,6434,'fr','DerniÃ¨re mise Ã  jour',0),(231619,6434,'jp','æœ€çµ‚æ›´æ–°æ—¥',0),(231620,6434,'pt','Ultima atualizaÃ§Ã£o',0),(231621,6434,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(231622,6434,'es','Ãšltima Vez Actualizada',0),(231623,6434,'de','Datenstand',0),(231624,6434,'en','Last Updated',0),(231625,6435,'is','',0),(231626,6435,'dr','Ø¯Ù‚ÙŠÙ‚Ù‡ ',0),(231627,6435,'pr','Ø¯Ù‚ÙŠÙ‚Ù‡ ',0),(231628,6435,'tr','Dakika',0),(231629,6435,'pl','Minut',0),(231630,6435,'bg','ÐœÐ¸Ð½ÑƒÑ‚Ð¸',0),(231631,6435,'ur','Ù…Ù†Ù¹',0),(231632,6435,'sr','ÐœÐ¸Ð½ÑƒÑ‚Ð°',0),(231633,6435,'vi','PhÃºt',0),(231634,6435,'af','Minute',0),(231635,6435,'ro','Minute',0),(231636,6435,'et','Minutit',0),(231637,6435,'si','Minut',0),(231638,6435,'ba','Menit',0),(231639,6435,'nl','Minuten',0),(231640,6435,'fi','Minuuttia',0),(231641,6435,'no','Minutter',0),(231642,6435,'da','Minutter',0),(231643,6435,'ko','ë¶„',0),(231644,6435,'he','×“×§×•×ª',0),(231645,6435,'el','Î›ÎµÏ€Ï„Î¬',0),(231646,6435,'zh','åˆ†é’Ÿ\r\n',0),(231647,6435,'sv','Minuter',0),(231648,6435,'it','Minuti',0),(231649,6435,'tl','',0),(231650,6435,'th','&#3609;&#3634;&#3607;&#3637;',0),(231651,6435,'hi','à¤®à¤¿à¤¨à¤Ÿ',0),(231652,6435,'ms','Minit',0),(231653,6435,'ar','Ø¯Ù‚ÙŠÙ‚Ø©',0),(231654,6435,'fr','Minutes',0),(231655,6435,'jp','è¨˜éŒ²',0),(231656,6435,'pt','Minutos',0),(231657,6435,'ru','ÐœÐ¸Ð½ÑƒÑ‚Ñ‹',0),(231658,6435,'es','Minutos',0),(231659,6435,'de','Minuten',0),(231660,6435,'en','Minutes',0),(231661,6436,'is','',0),(231662,6436,'dr','ØªÙ†Ø¸ÙŠÙ… Ú¯Ø²Ø§Ø±Ø´ Ø²Ù…Ø§Ù† Ù‡Ø§ÙŠ Ø°Ø®ÙŠØ±Ù‡',0),(231663,6436,'pr','ØªÙ†Ø¸ÙŠÙ… Ú¯Ø²Ø§Ø±Ø´ Ø²Ù…Ø§Ù† Ù‡Ø§ÙŠ Ø°Ø®ÙŠØ±Ù‡',0),(231664,6436,'tr','Ana rapor Ã¶nbellek kez ayarla',0),(231665,6436,'pl','Zestaw Strona gÅ‚Ã³wna raport pamiÄ™ci podrÄ™cznej razy',0),(231666,6436,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð´Ð¾ÐºÐ»Ð°Ð´ ÐºÐµÑˆ Ð¿ÑŠÑ‚Ð¸',0),(231667,6436,'ur','ÛÙˆÙ… Ù¾ÛŒØ¬ Ø±Ù¾ÙˆØ±Ù¹ Ú©ÛŒØ³Û Ø§ÙˆÙ‚Ø§Øª Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(231668,6436,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÐºÐµÑˆ Ð¿ÑƒÑ‚Ð°',0),(231669,6436,'vi','Chá»n thá»i gian cho bÃ¡o cÃ¡o bá»™ nhá»› trang chá»§',0),(231670,6436,'af','Stel Tuisblad Verslag Bergingstye',0),(231671,6436,'ro','SetaÅ£i pagina de pornire raportul Cache ori',0),(231672,6436,'et','MÃ¤Ã¤ra kodulehele aruande vahemÃ¤lu korda',0),(231673,6436,'si','Nastavite domaÄo stran poroÄilo predpomnilnika krat',0),(231674,6436,'ba','Mengatur Homepage laporan Cache kali',0),(231675,6436,'nl','Homepage verslag Cache tijd instellen',0),(231676,6436,'fi','Aseta Kotisivu raportti vÃ¤limuisti',0),(231677,6436,'no','Angi hjemmeside rapporten Cache',0),(231678,6436,'da','Indstille hjemmeside rapport Cache gange',0),(231679,6436,'ko','í™ˆíŽ˜ì´ì§€ ë³´ê³ ì„œ ìºì‹œ ì‹œê°„ ì„¤ì •',0),(231680,6436,'he','×”×’×“×¨×ª ×“×£ ×”×‘×™×ª ×— ×ž×˜×ž×•×Ÿ ×¤×¢×ž×™×',0),(231681,6436,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ ÎºÏÏÎ¹Î± ÏƒÎµÎ»Î¯Î´Î± Î­ÎºÎ¸ÎµÏƒÎ· Cache Ï†Î¿ÏÎ­Ï‚',0),(231682,6436,'zh','è®¾ä¸ºé¦–é¡µæŠ¥è¡¨ç¼“å­˜æ—¶æŠ¥\r\n',0),(231683,6436,'sv','Ange hemsida rapport Cache gÃ¥nger',0),(231684,6436,'it','Impostare la Homepage Report Cache volte',0),(231685,6436,'tl','',0),(231686,6436,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3650;&#3630;&#3617;&#3648;&#3614;&#3592;&#3648;&#3623;&#3621;&#3634;&#3627;&#3609;&#3656;&#3623;&#3618;&#3588;&#3623;&#3634;&#3617;&#3592;&#3635;&#3649;&#3588;&#3594;',0),(231687,6436,'hi','à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤®à¤ªà¥‡à¤œ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¥ˆà¤¶ à¤¬à¤¾à¤°',0),(231688,6436,'ms','Set Laman utama laporan Cache Times',0),(231689,6436,'ar','ØªØ¹ÙŠÙŠÙ† Ø£ÙˆÙ‚Ø§Øª Ø°Ø§ÙƒØ±Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ† Ø§Ù„Ù…Ø¤Ù‚Øª Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ù„Ù„ØªÙ‚Ø±ÙŠØ±',0),(231690,6436,'fr','DÃ©finir la page d\'accueil rapport Cache fois',0),(231691,6436,'jp','ãƒ›ãƒ¼ãƒ ãƒšãƒ¼ã‚¸ä¿?å­˜å›žæ•°ã?®è¨­å®š',0),(231692,6436,'pt','Definir Homepage relatÃ³rio Cache vezes',0),(231693,6436,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð´Ð¾Ð¼Ð°ÑˆÐ½ÑŽÑŽ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° ÐºÑÑˆ Ñ€Ð°Ð·Ð°',0),(231694,6436,'es','Configurar PÃ¡gina Hogar Informe Tiempos de CachÃ©',0),(231695,6436,'de','Homepage-Bericht-Cache-Zeiten festlegen',0),(231696,6436,'en','Set Homepage Report Cache Times',0),(231697,6437,'is','',0),(231698,6437,'dr','Ù…Ø®ÙÙŠ Ø³Ø§Ø²ÙŠ Ú¯Ø²Ø§Ø±Ø´ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(231699,6437,'pr','Ù…Ø®ÙÙŠ Ø³Ø§Ø²ÙŠ Ú¯Ø²Ø§Ø±Ø´ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(231700,6437,'tr','Ana rapor Ã¶nbelleÄŸe alma',0),(231701,6437,'pl','Strona gÅ‚Ã³wna raport buforowanie',0),(231702,6437,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð´Ð¾ÐºÐ»Ð°Ð´ ÐºÐµÑˆÐ¸Ñ€Ð°Ð½Ðµ',0),(231703,6437,'ur','ÛÙˆÙ… Ù¾ÛŒØ¬ Ø±Ù¾ÙˆØ±Ù¹ Ú©ÛŒØ³Û Ú©Ø§Ø±ÛŒ',0),(231704,6437,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð° ÐºÐµÑˆÐ¸Ñ€Ð°ÑšÐµ',0),(231705,6437,'vi','BÃ¡o CÃ¡o Bá»™ Nhá»› Trang Chá»§',0),(231706,6437,'af','Tuisblad Verslag Agtervolging',0),(231707,6437,'ro','Pagina de pornire raportul cache',0),(231708,6437,'et','KodulehekÃ¼lg aruande vahemÃ¤llu',0),(231709,6437,'si','PoroÄilo domaÄo stran Caching',0),(231710,6437,'ba','Homepage laporan Caching',0),(231711,6437,'nl','Homepage verslag Caching',0),(231712,6437,'fi','Kotisivu raportin tallentaminen vÃ¤limuistiin',0),(231713,6437,'no','Hjemmesiden rapporten hurtigbufring',0),(231714,6437,'da','Hjemmeside rapport cachelagring',0),(231715,6437,'ko','í™ˆíŽ˜ì´ì§€ ë³´ê³ ì„œ ìºì‹±',0),(231716,6437,'he','×“×£ ×”×‘×™×ª ×— ×‘×ž×˜×ž×•×Ÿ',0),(231717,6437,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î± Î­ÎºÎ¸ÎµÏƒÎ· Ï€ÏÎ¿ÏƒÏ‰ÏÎ¹Î½Î®Ï‚ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·Ï‚',0),(231718,6437,'zh','é¦–é¡µæŠ¥è¡¨ç¼“å­˜\r\n',0),(231719,6437,'sv','Hemsida rapport cachelagring',0),(231720,6437,'it','Homepage Report nella cache',0),(231721,6437,'tl','',0),(231722,6437,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3648;&#3585;&#3655;&#3610;&#3627;&#3609;&#3657;&#3634;&#3649;&#3619;&#3585;',0),(231723,6437,'hi','à¤®à¥à¤–à¤ªà¥ƒà¤·à¥à¤  à¤•à¥ˆà¤¶à¤¿à¤‚à¤— à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(231724,6437,'ms','Laporan Laman web cache',0),(231725,6437,'ar','Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ®Ø²ÙŠÙ† Ø§Ù„Ù…Ø¤Ù‚Øª',0),(231726,6437,'fr','Page d\'accueil rapport de mise en cache',0),(231727,6437,'jp','ãƒ›ãƒ¼ãƒ ãƒšãƒ¼ã‚¸ãƒ¬ãƒ?ãƒ¼ãƒˆã‚­ãƒ£ãƒƒã‚·ãƒ³ã‚°',0),(231728,6437,'pt','RelatÃ³rio de homepage cache',0),(231729,6437,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐºÑÑˆÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(231730,6437,'es','Caching de Informe de PÃ¡gina Casa',0),(231731,6437,'de','Homepage Berichtszwischenspeicherungs',0),(231732,6437,'en','Homepage Report Caching',0),(231733,6438,'is','',0),(231734,6438,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± ÙƒØ§Ø±Ù…Ù†Ø¯',0),(231735,6438,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± ÙƒØ§Ø±Ù…Ù†Ø¯',0),(231736,6438,'tr','Son Ã§alÄ±ÅŸan deÄŸerlendirmeden edinildi',0),(231737,6438,'pl','Najnowsze Opinie pracownikÃ³w',0),(231738,6438,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¾Ñ‚Ð·Ð¸Ð²Ð°',0),(231739,6438,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø­Ø§Ù„ÛŒÛ Ø¬Ø§Ø¦Ø²Û',0),(231740,6438,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ñ€ÐµÑ†ÐµÐ½Ð·Ð¸Ñ˜Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(231741,6438,'vi','ÄÃ¡nh giÃ¡ nhÃ¢n viÃªn gáº§n Ä‘Ã¢y ',0),(231742,6438,'af','Onlangse Werknemers Oorsig',0),(231743,6438,'ro','Recent angajatul clienÅ£ilor',0),(231744,6438,'et','Hiljutised tÃ¶Ã¶tajate iseloomustused',0),(231745,6438,'si','Nedavni pregledi zaposlenih',0),(231746,6438,'ba','Terakhir karyawan ulasan',0),(231747,6438,'nl','De nieuwste werknemer Reviews',0),(231748,6438,'fi','Uusimmat tyÃ¶ntekijÃ¤n arvostelut',0),(231749,6438,'no','Siste Medarbeiderevalueringer',0),(231750,6438,'da','Seneste medarbejder anmeldelser',0),(231751,6438,'ko','ìµœê·¼ ì§ì› ë¦¬ë·°',0),(231752,6438,'he','×‘×™×§×•×¨×•×ª ××—×¨×•× ×•×ª ×©×œ ×”×¢×•×‘×“',0),(231753,6438,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚ ÏƒÏ‡ÏŒÎ»Î¹Î±',0),(231754,6438,'zh','æœ€è¿‘çš„å‘˜å·¥è¯„è®º\r\n',0),(231755,6438,'sv','Senaste medarbetare recensioner',0),(231756,6438,'it','Recensioni recenti dipendente',0),(231757,6438,'tl','',0),(231758,6438,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(231759,6438,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾à¤à¤',0),(231760,6438,'ms','Hari pekerja Ulasan',0),(231761,6438,'ar','ØªÙ‚ÙŠÙŠÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ† Ø§Ù„Ø­Ø¯ÙŠØ«Ø©',0),(231762,6438,'fr','Ã‰tudes rÃ©centes d\'employÃ©',0),(231763,6438,'jp','æœ€è¿‘ã?®å¾“æ¥­å“¡è©•ä¾¡',0),(231764,6438,'pt','ComentÃ¡rios recentes de empregado',0),(231765,6438,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¾Ñ‚Ð·Ñ‹Ð²Ñ‹ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(231766,6438,'es','Revisiones de Empleados Recientes',0),(231767,6438,'de','Aktuelle Mitarbeiterbewertungen',0),(231768,6438,'en','Recent Employee Reviews',0),(231769,6439,'is','',0),(231770,6439,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ØºÙŠØ±  Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø±Ø§ Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯ ',0),(231771,6439,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ØºÙŠØ±  Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø±Ø§ Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯ ',0),(231772,6439,'tr','Stok Ã¶ÄŸeler iÃ§erir',0),(231773,6439,'pl','ObejmujÄ… zapasÃ³w-',0),(231774,6439,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð°-ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(231775,6439,'ur','ØºÛŒØ± Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ù…ÛŒÚº Ø´Ø§Ù…Ù„',0),(231776,6439,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ ÐºÐ¾Ñ˜Ð¸ Ð½Ð¸ÑÑƒ Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(231777,6439,'vi','Bao gá»“m hÃ ng khÃ´ng trong kho',0),(231778,6439,'af','Sluit nie-voorraad Items',0),(231779,6439,'ro','Include elemente Non-inventar',0),(231780,6439,'et','Hulka laokaupade',0),(231781,6439,'si','So-zaloge artiklov',0),(231782,6439,'ba','Termasuk bebas-persediaan barang',0),(231783,6439,'nl','Opnemen van niet-voorraadartikelen',0),(231784,6439,'fi','SisÃ¤ltÃ¤Ã¤ ei-varastotuotteiden',0),(231785,6439,'no','Inkluder ikke-beholdningsvarer',0),(231786,6439,'da','Omfatte ikke lagervarer',0),(231787,6439,'ko','ë¹„-ì¸ë²¤í† ë¦¬ í•­ëª© í¬í•¨',0),(231788,6439,'he','×›×œ×•×œ ×¤×¨×™×˜×™× ×©××™× × ×ž×œ××™',0),(231789,6439,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ ÎµÎ¯Î´Î· Î¼Î·-Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(231790,6439,'zh','åŒ…æ‹¬éžåº“å­˜é¡¹ç›®\r\n',0),(231791,6439,'sv','Inkludera icke-lagerartiklar',0),(231792,6439,'it','Includono articoli Non a magazzino',0),(231793,6439,'tl','',0),(231794,6439,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3626;&#3605;&#3655;&#3629;&#3585;',0),(231795,6439,'hi','à¤—à¥ˆà¤°-à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(231796,6439,'ms','Termasuk barangan bebas-inventori',0),(231797,6439,'ar','ÙˆØªØ´Ù…Ù„ Ø¨Ù†ÙˆØ¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(231798,6439,'fr','Inclure les articles hors stocks',0),(231799,6439,'jp','é?žåœ¨åº«å“?ç›®ã‚‚å?«ã‚?ã‚‹',0),(231800,6439,'pt','Incluir itens nÃ£o-inventÃ¡rio',0),(231801,6439,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÐ½ÐºÐ»Ð°Ñ‚ÑƒÑ€Ñ‹',0),(231802,6439,'es','Incluir Items No Inventario',0),(231803,6439,'de','Sind nicht-Lagerartikel',0),(231804,6439,'en','Include Non-Inventory Items',0),(231805,6440,'is','',0),(231806,6440,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ù†Ø´Ø¯Ù‡ ',0),(231807,6440,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ù†Ø´Ø¯Ù‡ ',0),(231808,6440,'tr','Sigara faturalanan Ã¶deme raporu',0),(231809,6440,'pl','Raport pÅ‚atnoÅ›ci nie zafakturowana',0),(231810,6440,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(231811,6440,'ur','ØºÛŒØ± Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(231812,6440,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÐºÐ¾Ñ˜Ð¸ Ð½Ð¸ÑÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð¸ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(231813,6440,'vi','BÃ¡o cÃ¡o thanh toÃ¡n khÃ´ng hÃ³a Ä‘Æ¡n',0),(231814,6440,'af','Nie Gefaktureerde Betalingsverslag',0),(231815,6440,'ro','Raport de plÄƒÅ£i non facturate',0),(231816,6440,'et','Mitte arveldatud maksete aruanne',0),(231817,6440,'si','PoroÄilo niso fakturirani plaÄila',0),(231818,6440,'ba','Pembayaran tagihan bebas laporan',0),(231819,6440,'nl','Niet-gefactureerde betalingen verslag',0),(231820,6440,'fi','Ei laskutettu maksuraportti',0),(231821,6440,'no','Ikke fakturerte betalinger rapport',0),(231822,6440,'da','Ikke fakturerede betalinger rapport',0),(231823,6440,'ko','ë¹„ ì²­êµ¬ì„œ ì§€ë¶ˆ ë³´ê³ ì„œ',0),(231824,6440,'he','×“×•×— ×ª×©×œ×•×ž×™× ×©××™× × ×©×—×•×™×‘×”',0),(231825,6440,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î¼Î· Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î¿ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(231826,6440,'zh','ä¸å¼€å…·å‘ç¥¨çš„æ”¶æ”¯æŠ¥å‘Š\r\n',0),(231827,6440,'sv','Icke fakturerade betalningar rapport',0),(231828,6440,'it','Relazione di pagamenti non fatturate',0),(231829,6440,'tl','',0),(231830,6440,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(231831,6440,'hi','à¤—à¥ˆà¤° à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¤¿à¤ à¤—à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(231832,6440,'ms','Laporan pembayaran invois bebas',0),(231833,6440,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…Ø¨Ø§Ù„Øº ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(231834,6440,'fr','Rapport de paiements non facturÃ©es',0),(231835,6440,'jp','æœªè«‹æ±‚æ”¯æ‰•ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(231836,6440,'pt','RelatÃ³rio de pagamentos nÃ£o facturado',0),(231837,6440,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð½Ðµ Ð¿Ñ€ÐµÐ´ÑŠÑÐ²Ð»ÐµÐ½Ð½Ñ‹Ñ… Ðº Ð¾Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(231838,6440,'es','Informe de Pagos No Facturados',0),(231839,6440,'de','Nicht fakturierte Zahlungen Bericht',0),(231840,6440,'en','Non Invoiced Payments Report',0),(231841,6441,'is','',0),(231842,6441,'dr','Ù…Ù‚ØµØ¯ ',0),(231843,6441,'pr','Ù…Ù‚ØµØ¯ ',0),(231844,6441,'tr','Hedef',0),(231845,6441,'pl','Przeznaczenia',0),(231846,6441,'bg','ÐœÐµÑÑ‚Ð¾Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(231847,6441,'ur','Ù…Ù‚ØµÙˆØ¯',0),(231848,6441,'sr','ÐžÐ´Ñ€ÐµÐ´Ð¸ÑˆÑ‚Ðµ',0),(231849,6441,'vi','Äiá»ƒm Ä‘áº¿n',0),(231850,6441,'af','Bestemming',0),(231851,6441,'ro','Destinatie',0),(231852,6441,'et','Sihtkoht',0),(231853,6441,'si','Destinacijo',0),(231854,6441,'ba','Tujuan',0),(231855,6441,'nl','Bestemming',0),(231856,6441,'fi','Kohde',0),(231857,6441,'no','Destinasjon',0),(231858,6441,'da','Destination',0),(231859,6441,'ko','ëŒ€ìƒ',0),(231860,6441,'he','×™×¢×“',0),(231861,6441,'el','Î ÏÎ¿Î¿ÏÎ¹ÏƒÎ¼Î¿Ï',0),(231862,6441,'zh','ç›®çš„åœ°\r\n',0),(231863,6441,'sv','Destination',0),(231864,6441,'it','Destinazione',0),(231865,6441,'tl','',0),(231866,6441,'th','&#3611;&#3621;&#3634;&#3618;&#3607;&#3634;&#3591;',0),(231867,6441,'hi','à¤—à¤‚à¤¤à¤µà¥à¤¯',0),(231868,6441,'ms','Destinasi',0),(231869,6441,'ar','Ø§Ù„ÙˆØ¬Ù‡Ø©',0),(231870,6441,'fr','Destination',0),(231871,6441,'jp','ç›®çš„åœ°',0),(231872,6441,'pt','Destino',0),(231873,6441,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(231874,6441,'es','DestinaciÃ³n',0),(231875,6441,'de','Ziel',0),(231876,6441,'en','Destination',0),(231877,6442,'is','',0),(231878,6442,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(231879,6442,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(231880,6442,'tr','Ä°zleme bilgileri',0),(231881,6442,'pl','Åšledzenia informacji',0),(231882,6442,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(231883,6442,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(231884,6442,'sr','ÐŸÐ¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ ÐºÑ€ÐµÑ‚Ð°ÑšÑƒ',0),(231885,6442,'vi','TÃ¬m kiáº¿m ThÃ´ng Tin',0),(231886,6442,'af','Sporingsinligting',0),(231887,6442,'ro','InformaÅ£ii de urmÄƒrire',0),(231888,6442,'et','JÃ¤lgimise Info',0),(231889,6442,'si','Sledenje Info',0),(231890,6442,'ba','Pelacakan Info',0),(231891,6442,'nl','Tracking Info',0),(231892,6442,'fi','Seurantatiedot',0),(231893,6442,'no','Sporing Info',0),(231894,6442,'da','Sporing Info',0),(231895,6442,'ko','ì¶”ì  ì •ë³´',0),(231896,6442,'he','×ž×¢×§×‘ ××—×¨ ×¤×¨×˜×™',0),(231897,6442,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚',0),(231898,6442,'zh','è·Ÿè¸ªä¿¡æ¯\r\n',0),(231899,6442,'sv','SpÃ¥ra information',0),(231900,6442,'it','Rilevamento delle informazioni',0),(231901,6442,'tl','',0),(231902,6442,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(231903,6442,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(231904,6442,'ms','Maklumat Runut',0),(231905,6442,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ¹Ù‚Ø¨',0),(231906,6442,'fr','D\'informations de suivi',0),(231907,6442,'jp','ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°æƒ…å ±',0),(231908,6442,'pt','InformaÃ§Ã£o de rastreamento',0),(231909,6442,'ru','ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸',0),(231910,6442,'es','Info de Rastreo',0),(231911,6442,'de','Tracking-Info',0),(231912,6442,'en','Tracking Info',0),(231913,6443,'is','',0),(231914,6443,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³Ø±ÙŠØ¹ ÙƒØ§Ù„Ø§',0),(231915,6443,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³Ø±ÙŠØ¹ ÙƒØ§Ù„Ø§',0),(231916,6443,'tr','HÄ±zlÄ± Ã¼rÃ¼n arama',0),(231917,6443,'pl','Pozycja szybkiego wyszukiwania',0),(231918,6443,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ Ð±ÑŠÑ€Ð·Ð¾ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(231919,6443,'ur','ÙÙˆØ±ÛŒ Ø´Û’ Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(231920,6443,'sr','Ð‘Ñ€Ð·Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(231921,6443,'vi','TÃ¬m hÃ ng nhanh',0),(231922,6443,'af','Snel Item Opsporing',0),(231923,6443,'ro','Element rapide Lookup',0),(231924,6443,'et','Toote kiirotsing',0),(231925,6443,'si','Element hitro iskanje',0),(231926,6443,'ba','Cepat Item Lookup',0),(231927,6443,'nl','Snelle Item Lookup',0),(231928,6443,'fi','Quick nimikkeen haku',0),(231929,6443,'no','Rask Vareoppslaget',0),(231930,6443,'da','Hurtig Vareopslaget',0),(231931,6443,'ko','ë¹ ë¥¸ í•­ëª© ì¡°íšŒ',0),(231932,6443,'he','×‘×“×™×§×ª ×¤×¨×™×˜ ×ž×”×™×¨×”',0),(231933,6443,'el','Î“ÏÎ®Î³Î¿ÏÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(231934,6443,'zh','å¿«é€ŸæŸ¥æ‰¾é¡¹ç›®\r\n',0),(231935,6443,'sv','Snabb ArtikelsÃ¶kningen',0),(231936,6443,'it','Ricerca rapida elemento',0),(231937,6443,'tl','',0),(231938,6443,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3633;&#3609;&#3607;&#3637;',0),(231939,6443,'hi','à¤¤à¥à¤µà¤°à¤¿à¤¤ à¤†à¤‡à¤Ÿà¤® à¤²à¥à¤•à¤…à¤ª',0),(231940,6443,'ms','Lookup cepat Item',0),(231941,6443,'ar','Ø¨Ø­Ø« Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ø³Ø±ÙŠØ¹',0),(231942,6443,'fr','Point rapide recherche',0),(231943,6443,'jp','ã‚¯ã‚¤ãƒƒã‚¯å“?ç›®æ¤œç´¢',0),(231944,6443,'pt','Pesquisa rÃ¡pida de Item',0),(231945,6443,'ru','Ð‘Ñ‹ÑÑ‚Ñ€Ñ‹Ð¹ ÐŸÐ¾Ð¸ÑÐº Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(231946,6443,'es','Busqueda Rapida del Item',0),(231947,6443,'de','Schnelle Artikel Suche',0),(231948,6443,'en','Quick Item Lookup',0),(231949,6444,'is','',0),(231950,6444,'dr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø±Ø§Ù‡',0),(231951,6444,'pr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø±Ø§Ù‡',0),(231952,6444,'tr','SipariÅŸ Ã¼zerine',0),(231953,6444,'pl','Na zamÃ³wienie',0),(231954,6444,'bg','ÐŸÐ¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(231955,6444,'ur','Ø­Ú©Ù…',0),(231956,6444,'sr','ÐÐ° Ð½Ð°Ð»Ð¾Ð³Ñƒ',0),(231957,6444,'vi','Äang Ä‘áº·t hÃ ng',0),(231958,6444,'af','Op Bestelling',0),(231959,6444,'ro','Comanda',0),(231960,6444,'et','Tellimusel',0),(231961,6444,'si','Po naroÄilu',0),(231962,6444,'ba','Pesanan',0),(231963,6444,'nl','Op bestelling',0),(231964,6444,'fi','Tilauksessa',0),(231965,6444,'no','PÃ¥ bestilling',0),(231966,6444,'da','PÃ¥ ordre',0),(231967,6444,'ko','ì£¼ë¬¸ì—',0),(231968,6444,'he','×‘×”×–×ž× ×”',0),(231969,6444,'el','Î£Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(231970,6444,'zh','è®¢è´­\r\n',0),(231971,6444,'sv','PÃ¥ bestÃ¤llning',0),(231972,6444,'it','Su ordine',0),(231973,6444,'tl','',0),(231974,6444,'th','&#3610;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(231975,6444,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¤°',0),(231976,6444,'ms','Dengan arahan',0),(231977,6444,'ar','ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(231978,6444,'fr','Sur commande',0),(231979,6444,'jp','æ³¨æ–‡ä¸Š',0),(231980,6444,'pt','Na ordem',0),(231981,6444,'ru','ÐÐ° Ð·Ð°ÐºÐ°Ð·',0),(231982,6444,'es','En Orden',0),(231983,6444,'de','Auf Bestellung',0),(231984,6444,'en','On Order',0),(231985,6445,'is','',0),(231986,6445,'dr','.',0),(231987,6445,'pr','Ù…ÙˆØ¬ÙˆØ¯.',0),(231988,6445,'tr','BoÅŸuna.',0),(231989,6445,'pl','Rezultatu.',0),(231990,6445,'bg','Ð£ÑÐ¿ÐµÑ….',0),(231991,6445,'ur','Ø³Ú©Ùˆ Û”',0),(231992,6445,'sr','Ð Ð°ÑÐ¿Ð¾Ð».',0),(231993,6445,'vi','CÃ³ Sáºµn',0),(231994,6445,'af','Beskikb.',0),(231995,6445,'ro','Disp.',0),(231996,6445,'et','Kasutada.',0),(231997,6445,'si','Uspeha.',0),(231998,6445,'ba','Memanfaatkan.',0),(231999,6445,'nl','Baten.',0),(232000,6445,'fi','KÃ¤yttÃ¤Ã¤.',0),(232001,6445,'no','Tilgj.',0),(232002,6445,'da','Nytte.',0),(232003,6445,'ko','ì†Œìš©ìž…ë‹ˆë‹¤.',0),(232004,6445,'he','×”×•×¢×™×œ.',0),(232005,6445,'el','Î”Î¹Î±Î¸.',0),(232006,6445,'zh','æ•ˆç”¨\r\n',0),(232007,6445,'sv','Utnyttja.',0),(232008,6445,'it','Disp.',0),(232009,6445,'tl','',0),(232010,6445,'th','&#3611;&#3619;&#3632;&#3650;&#3618;&#3594;&#3609;&#3660;',0),(232011,6445,'hi','à¤²à¤¾à¤­ à¤²à¥‡à¥¤',0),(232012,6445,'ms','Sia-sia.',0),(232013,6445,'ar','Ø¬Ø¯ÙˆÙ‰.',0),(232014,6445,'fr','DISP.',0),(232015,6445,'jp','å…¥æ‰‹å?¯èƒ½',0),(232016,6445,'pt','Disp.',0),(232017,6445,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾',0),(232018,6445,'es','Disp.',0),(232019,6445,'de','Anspruch zu nehmen.',0),(232020,6445,'en','Avail.',0),(232021,6446,'is','',0),(232022,6446,'dr','ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(232023,6446,'pr','ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(232024,6446,'tr','TaahhÃ¼t.',0),(232025,6446,'pl','Zatwierdzanie.',0),(232026,6446,'bg','Ð¡Ðµ Ð°Ð½Ð³Ð°Ð¶Ð¸Ñ€Ð°Ñ‚.',0),(232027,6446,'ur','Ø§Ø±ØªÚ©Ø§Ø¨.',0),(232028,6446,'sr','Ð˜Ð·Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐµ.',0),(232029,6446,'vi','Cam káº¿t',0),(232030,6446,'af','Pleeg.',0),(232031,6446,'ro','Angajam.',0),(232032,6446,'et','Toime.',0),(232033,6446,'si','Zavezati.',0),(232034,6446,'ba','Komit.',0),(232035,6446,'nl','Commit.',0),(232036,6446,'fi','Sitoutua.',0),(232037,6446,'no','UtfÃ¸ring.',0),(232038,6446,'da','BegÃ¥.',0),(232039,6446,'ko','ì»¤ë°‹ìž…ë‹ˆë‹¤.',0),(232040,6446,'he','×¤×¢×•×œ×ª commit.',0),(232041,6446,'el','Commit.',0),(232042,6446,'zh','æäº¤ã€‚\r\n',0),(232043,6446,'sv','BegÃ¥.',0),(232044,6446,'it','Commettere.',0),(232045,6446,'tl','',0),(232046,6446,'th','&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;',0),(232047,6446,'hi','à¤¸à¤‚à¤•à¤²à¥à¤ª à¤²à¥‡à¤‚à¥¤',0),(232048,6446,'ms','Mengikat janji.',0),(232049,6446,'ar','Ø§Ø±ØªÙƒØ§Ø¨.',0),(232050,6446,'fr','Commettre.',0),(232051,6446,'jp','çµ‚äº†',0),(232052,6446,'pt','Comprometa-se.',0),(232053,6446,'ru','Ð¤Ð¸ÐºÑÐ°Ñ†Ð¸Ð¸.',0),(232054,6446,'es','Comprometir',0),(232055,6446,'de','Verpflichten.',0),(232056,6446,'en','Commit.',0),(232057,6447,'is','',0),(232058,6447,'dr','Ù…ÙˆØ¬ÙˆØ¯',0),(232059,6447,'pr','Ù…ÙˆØ¬ÙˆØ¯',0),(232060,6447,'tr','Eldeki',0),(232061,6447,'pl','Na rÄ™kÄ™',0),(232062,6447,'bg','ÐÐ° Ñ€ÑŠÐºÐ°',0),(232063,6447,'ur','Ù¾Ø± ÛØ§ØªÚ¾',0),(232064,6447,'sr','ÐÐ° Ñ€ÑƒÑ†Ð¸',0),(232065,6447,'vi','CÃ³ sáºµn',0),(232066,6447,'af','Aan-Hand',0),(232067,6447,'ro','Pe-o parte',0),(232068,6447,'et','Vaba',0),(232069,6447,'si','Na roko',0),(232070,6447,'ba','Di tangan',0),(232071,6447,'nl','Op de Hand',0),(232072,6447,'fi','Varasto',0),(232073,6447,'no','Lagerbeholdning',0),(232074,6447,'da','Disponibel lagerbeholdning',0),(232075,6447,'ko','ì— ì†',0),(232076,6447,'he','×¢×œ-×™×“',0),(232077,6447,'el','Î£Ï„Î· Î´Î¹Î¬Î¸ÎµÏƒÎ® ÏƒÎ±Ï‚',0),(232078,6447,'zh','çŽ°æœ‰\r\n',0),(232079,6447,'sv','Till hands',0),(232080,6447,'it','A portata di mano',0),(232081,6447,'tl','',0),(232082,6447,'th','&#3607;&#3637;&#3656;&#3606;&#3639;&#3629;&#3629;&#3618;&#3641;&#3656;',0),(232083,6447,'hi','à¤ªà¤° à¤¹à¤¾à¤¥',0),(232084,6447,'ms','Atas tangan',0),(232085,6447,'ar','ÙÙŠ Ø§Ù„ÙŠØ¯',0),(232086,6447,'fr','Ã€ portÃ©e de main',0),(232087,6447,'jp','æ‰‹æŒ?ã?¡',0),(232088,6447,'pt','Ã€ mÃ£o',0),(232089,6447,'ru','ÐÐ° Ñ€ÑƒÐºÑƒ',0),(232090,6447,'es','Disponble',0),(232091,6447,'de','Auf die Hand',0),(232092,6447,'en','On-Hand',0),(232093,6448,'is','',0),(232094,6448,'dr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø±Ø§Ù‡ ',0),(232095,6448,'pr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø±Ø§Ù‡ ',0),(232096,6448,'tr','SipariÅŸ Ã¼zerine',0),(232097,6448,'pl','Na zamÃ³wienie',0),(232098,6448,'bg','ÐŸÐ¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(232099,6448,'ur','Ø­Ú©Ù…',0),(232100,6448,'sr','ÐÐ° Ð½Ð°Ð»Ð¾Ð³Ñƒ',0),(232101,6448,'vi','Äang Ä‘áº·t hÃ ng',0),(232102,6448,'af','Op Bestelling',0),(232103,6448,'ro','Comanda',0),(232104,6448,'et','Tellimusel',0),(232105,6448,'si','Po naroÄilu',0),(232106,6448,'ba','Pesanan',0),(232107,6448,'nl','Op bestelling',0),(232108,6448,'fi','Tilauksessa',0),(232109,6448,'no','PÃ¥ bestilling',0),(232110,6448,'da','PÃ¥ ordre',0),(232111,6448,'ko','ì£¼ë¬¸ì—',0),(232112,6448,'he','×‘×”×–×ž× ×”',0),(232113,6448,'el','Î£Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(232114,6448,'zh','è®¢è´­\r\n',0),(232115,6448,'sv','PÃ¥ bestÃ¤llning',0),(232116,6448,'it','Su ordine',0),(232117,6448,'tl','',0),(232118,6448,'th','&#3610;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(232119,6448,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¤°',0),(232120,6448,'ms','Dengan arahan',0),(232121,6448,'ar','ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(232122,6448,'fr','Sur commande',0),(232123,6448,'jp','æ³¨æ–‡ä¸Š',0),(232124,6448,'pt','Na ordem',0),(232125,6448,'ru','ÐÐ° Ð·Ð°ÐºÐ°Ð·',0),(232126,6448,'es','En Orden',0),(232127,6448,'de','Auf Bestellung',0),(232128,6448,'en','On Order',0),(232129,6449,'is','',0),(232130,6449,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(232131,6449,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(232132,6449,'tr','Komisyon gideri',0),(232133,6449,'pl','Koszt Komisji',0),(232134,6449,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(232135,6449,'ur','Ú©Ù…ÛŒØ´Ù† Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(232136,6449,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð°',0),(232137,6449,'vi','Chi phÃ­ hoa há»“ng',0),(232138,6449,'af','Kommissie Uitgawe',0),(232139,6449,'ro','Comisia cheltuieli',0),(232140,6449,'et','Teenustasu kulu',0),(232141,6449,'si','Komisija raÄun',0),(232142,6449,'ba','Biaya komisi',0),(232143,6449,'nl','Commissie kosten',0),(232144,6449,'fi','Komission kustannuksella',0),(232145,6449,'no','Kommisjonen bekostning',0),(232146,6449,'da','Kommissionen udgift',0),(232147,6449,'ko','ìˆ˜ìˆ˜ë£Œ ë¹„ìš©',0),(232148,6449,'he','×”×•×¦××•×ª ×¢×ž×œ×”',0),(232149,6449,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Î´Î±Ï€Î¬Î½Î·',0),(232150,6449,'zh','ä½£é‡‘æ”¯å‡º\r\n',0),(232151,6449,'sv','Kommissionen bekostnad',0),(232152,6449,'it','Spese di Commissione',0),(232153,6449,'tl','',0),(232154,6449,'th','&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(232155,6449,'hi','à¤†à¤¯à¥‹à¤— à¤µà¥à¤¯à¤¯',0),(232156,6449,'ms','Perbelanjaan Suruhanjaya',0),(232157,6449,'ar','Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø¹Ù…ÙˆÙ„Ø§Øª',0),(232158,6449,'fr','Frais de Commission',0),(232159,6449,'jp','ã‚³ãƒŸãƒƒã‚·ãƒ§ãƒ³è²»ç”¨',0),(232160,6449,'pt','Despesa de ComissÃ£o',0),(232161,6449,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¾Ð½Ð½Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(232162,6449,'es','Gastos de Comisiones',0),(232163,6449,'de','Und Provisionen',0),(232164,6449,'en','Commission Expense',0),(232165,6450,'is','',0),(232166,6450,'dr','Ø­Ù‚ÙˆÙ‚ Ù…Ø§Ù‡ÙŠØ§Ù†Ù‡ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡',0),(232167,6450,'pr','Ø­Ù‚ÙˆÙ‚ Ù…Ø§Ù‡ÙŠØ§Ù†Ù‡ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡',0),(232168,6450,'tr','Ajan Ã¶demek',0),(232169,6450,'pl','ZapÅ‚aciÄ‡ Agent',0),(232170,6450,'bg','ÐŸÐ»Ð°Ñ‚Ð¸ Ð°Ð³ÐµÐ½Ñ‚',0),(232171,6450,'ur','Ø§ÛŒØ¬Ù†Ù¹ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(232172,6450,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ ÐÐ³ÐµÐ½Ñ‚',0),(232173,6450,'vi','Äáº¡i lÃ½ tráº£ tiá»n',0),(232174,6450,'af','Besoldiging Agent',0),(232175,6450,'ro','PlÄƒteascÄƒ agentul',0),(232176,6450,'et','Maksma Agent',0),(232177,6450,'si','PlaÄati Agent',0),(232178,6450,'ba','Membayar agen',0),(232179,6450,'nl','Agent betalen',0),(232180,6450,'fi','Maksu agentti',0),(232181,6450,'no','Betale Agent',0),(232182,6450,'da','Betale Agent',0),(232183,6450,'ko','ì—ì´ì „íŠ¸ë¥¼ ì§€ë¶ˆ',0),(232184,6450,'he','×œ×©×œ× ×œ×¡×•×›×Ÿ',0),(232185,6450,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Ï€ÏÎ¬ÎºÏ„Î¿ÏÎ±',0),(232186,6450,'zh','æ”¯ä»˜ä»£ç†\r\n',0),(232187,6450,'sv','Betala Agent',0),(232188,6450,'it','Pagare l\'agente',0),(232189,6450,'tl','',0),(232190,6450,'th','&#3592;&#3656;&#3634;&#3618;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(232191,6450,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(232192,6450,'ms','Membayar ejen',0),(232193,6450,'ar','Ø¯ÙØ¹ ÙˆÙƒÙŠÙ„',0),(232194,6450,'fr','Payer l\'Agent',0),(232195,6450,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã?¸ã?®æ”¯æ‰•ã?„',0),(232196,6450,'pt','Agente de pagar',0),(232197,6450,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð°Ð³ÐµÐ½Ñ‚',0),(232198,6450,'es','Agente de Pago',0),(232199,6450,'de','Agent zu zahlen',0),(232200,6450,'en','Pay Agent',0),(232201,6451,'is','',0),(232202,6451,'dr','Ù†Ù…Ø§ÙŠØ´ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ ',0),(232203,6451,'pr','Ù†Ù…Ø§ÙŠØ´ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ ',0),(232204,6451,'tr','GÃ¶rÃ¼nÃ¼m faturalarÄ±',0),(232205,6451,'pl','Widok rachunki',0),(232206,6451,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(232207,6451,'ur','Ù…Ù†Ø¸Ø± Ú©Û’ Ø¨Ù„',0),(232208,6451,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(232209,6451,'vi','Xem HÃ³a ÄÆ¡n',0),(232210,6451,'af','Besigtig Rekeninge',0),(232211,6451,'ro','Vezi facturi',0),(232212,6451,'et','Kuva arved',0),(232213,6451,'si','RaÄuni pogled',0),(232214,6451,'ba','Lihat tagihan',0),(232215,6451,'nl','Weergave rekeningen',0),(232216,6451,'fi','NÃ¤ytÃ¤ tuoterakenteet',0),(232217,6451,'no','Vis regninger',0),(232218,6451,'da','Se regninger',0),(232219,6451,'ko','ë³´ê¸° ê³„ì‚° ì„œ',0),(232220,6451,'he','×ª×¦×•×’×ª ×—×©×‘×•× ×•×ª',0),(232221,6451,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(232222,6451,'zh','æŸ¥çœ‹å¸å•\r\n',0),(232223,6451,'sv','Visa rÃ¤kningar',0),(232224,6451,'it','Visualizzazione bollette',0),(232225,6451,'tl','',0),(232226,6451,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(232227,6451,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤•à¥‡ à¤¬à¤¿à¤²',0),(232228,6451,'ms','Paparan bil',0),(232229,6451,'ar','Ø¹Ø±Ø¶ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(232230,6451,'fr','Vue factures',0),(232231,6451,'jp','è«‹æ±‚æ›¸ã?®è¡¨ç¤º',0),(232232,6451,'pt','Contas de exibiÃ§Ã£o',0),(232233,6451,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÑ‡ÐµÑ‚Ð°',0),(232234,6451,'es','Visionar Recibos',0),(232235,6451,'de','Anzeigen-Rechnungen',0),(232236,6451,'en','View Bills',0),(232237,6452,'is','',0),(232238,6452,'dr','Ø­Ù‚ÙˆÙ‚ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(232239,6452,'pr','Ø­Ù‚ÙˆÙ‚ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(232240,6452,'tr','SatÄ±cÄ±ya Ã¶deme',0),(232241,6452,'pl','ZapÅ‚aciÄ‡ dostawcy',0),(232242,6452,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(232243,6452,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§Ø¯Ø§',0),(232244,6452,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(232245,6452,'vi','Tráº£ ngÆ°á»i bÃ¡n',0),(232246,6452,'af','Betaal Verskaffer',0),(232247,6452,'ro','Plata furnizor',0),(232248,6452,'et','Hankija',0),(232249,6452,'si','PlaÄati prodajalcu',0),(232250,6452,'ba','Membayar Vendor',0),(232251,6452,'nl','Verkoper betalen',0),(232252,6452,'fi','Toimittajan maksu',0),(232253,6452,'no','Betale leverandÃ¸ren',0),(232254,6452,'da','Betale kreditor',0),(232255,6452,'ko','ê³µê¸‰ ì—…ì²´ ì§€ë¶ˆ',0),(232256,6452,'he','×œ×©×œ× ×œ×¡×¤×§',0),(232257,6452,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(232258,6452,'zh','æ”¯ä»˜ä¾›åº”å•†\r\n',0),(232259,6452,'sv','Betala leverantÃ¶ren',0),(232260,6452,'it','Pagare il fornitore',0),(232261,6452,'tl','',0),(232262,6452,'th','&#3592;&#3656;&#3634;&#3618;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(232263,6452,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(232264,6452,'ms','Membayar Penjual',0),(232265,6452,'ar','Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(232266,6452,'fr','RÃ©munÃ©ration du vendeur',0),(232267,6452,'jp','æ¥­è€…ã?¸ã?®æ”¯æ‰•ã?„',0),(232268,6452,'pt','Pagar fornecedores',0),(232269,6452,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(232270,6452,'es','Pagar Proveedor',0),(232271,6452,'de','Kreditor bezahlen',0),(232272,6452,'en','Pay Vendor',0),(232273,6453,'is','',0),(232274,6453,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù‚ÙˆÙ‚ Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(232275,6453,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù‚ÙˆÙ‚ Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(232276,6453,'tr','EriÅŸim haklarÄ± gÃ¼ncelleÅŸtirme iÅŸlemi baÅŸarÄ±sÄ±z oldu',0),(232277,6453,'pl','DostÄ™p do praw aktualizacja nie powiodÅ‚a siÄ™',0),(232278,6453,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð°Ð²Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(232279,6453,'ur','Ø¢Ù¾ Ú©Ùˆ ÛŒÛ Ø³ÛÙˆÙ„Øª Ù…ÛŒØ³Ø± Ù†ÛÛŒÚº',0),(232280,6453,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ñ€Ð°Ð²Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(232281,6453,'vi','Cáº­p Nháº­t PhÃ¢n Quyá»n tháº¥t báº¡i',0),(232282,6453,'af','Opgradering van Toegangsregte het Gefaal.',0),(232283,6453,'ro','Actualizare Drepturi de Acces Esuata ',0),(232284,6453,'et','JuurdepÃ¤Ã¤su Ãµiguste vÃ¤rskendamine nurjus',0),(232285,6453,'si','Dostop do pravic ni mogoÄe posodobiti',0),(232286,6453,'ba','Pembaruan Hak Penggunaan Gagal',0),(232287,6453,'nl','Toegang tot rechten-Update mislukt',0),(232288,6453,'fi','Access oikeuksien pÃ¤ivitys epÃ¤onnistui',0),(232289,6453,'no','Access Rights oppdatering mislyktes',0),(232290,6453,'da','Adgang rettigheder opdatering mislykkedes',0),(232291,6453,'ko','ì•¡ì„¸ìŠ¤ ê¶Œí•œ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(232292,6453,'he','×¢×“×›×•×Ÿ ×–×›×•×™×•×ª ×”×’×™×©×” × ×›×©×œ×”',0),(232293,6453,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î´Î¹ÎºÎ±Î¹Ï‰Î¼Î¬Ï„Ï‰Î½ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(232294,6453,'zh','æœ€æ–°é€²å…¥æ¬Šå¤±è´¥\r\n',0),(232295,6453,'sv','Uppdatera fÃ¤lt fÃ¶r anvÃ¤ndarrÃ¤ttigheter',0),(232296,6453,'it','Aggiornamento diritti d\'accesso fallito',0),(232297,6453,'tl','',0),(232298,6453,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3627;&#3657;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(232299,6453,'hi','à¤ªà¤¹à¥à¤à¤š à¤…à¤§à¤¿à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(232300,6453,'ms','Kemas-kini hak akses yang gagal',0),(232301,6453,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø­Ù‚ÙˆÙ‚ Ø§Ù„ÙˆØµÙˆÙ„',0),(232302,6453,'fr','Ã‰chec de Mise Ã  Jour des Droits d\'AccÃ¨s',0),(232303,6453,'jp','ã‚¢ã‚¯ã‚»ã‚¹æ¨©æ›´æ–°ã?«å¤±æ•—ã?—ã?¾ã?—ã?Ÿ',0),(232304,6453,'pt','AtualizaÃ§Ã£o de direitos de acesso falhada',0),(232305,6453,'ru','Ð¡Ð±Ð¾Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð°Ð² Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°',0),(232306,6453,'es','ActualizaciÃ³n de Derechos de Acceso FallÃ³',0),(232307,6453,'de','Zugriffsrechte konnten nicht aktualisiert werden',0),(232308,6453,'en','Access Rights Update Failed',0),(232309,6454,'is','',0),(232310,6454,'dr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø­Ù…Ù„',0),(232311,6454,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø­Ù…Ù„',0),(232312,6454,'tr','Tahmini kargo',0),(232313,6454,'pl','WysyÅ‚ka szacunek',0),(232314,6454,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(232315,6454,'ur','ØªØ®Ù…ÛŒÙ†Û Ø´Ù¾Ù†Ú¯',0),(232316,6454,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(232317,6454,'vi','Dá»± trÃ¹ váº­n chuyá»ƒn',0),(232318,6454,'af','Versending Kosteberaming',0),(232319,6454,'ro','Estimare de transport maritim',0),(232320,6454,'et','Shipping hinnang',0),(232321,6454,'si','Dostava ocena',0),(232322,6454,'ba','Pengiriman perkiraan',0),(232323,6454,'nl','Verzending schatting',0),(232324,6454,'fi','Merenkulku arvio',0),(232325,6454,'no','Frakt anslag',0),(232326,6454,'da','Forsendelse skÃ¸n',0),(232327,6454,'ko','ë°°ì†¡ ê²¬ì ',0),(232328,6454,'he','×ž×©×œ×•×— ×”×¢×¨×›×”',0),(232329,6454,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ·',0),(232330,6454,'zh','è´§è¿ä»·æ ¼ä¼°è®¡\r\n',0),(232331,6454,'sv','Frakt uppskattning',0),(232332,6454,'it','Stima di spedizione',0),(232333,6454,'tl','',0),(232334,6454,'th','&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(232335,6454,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤¨à¥Œà¤µà¤¹à¤¨',0),(232336,6454,'ms','Penghantaran anggaran',0),(232337,6454,'ar','ØªÙ‚Ø¯ÙŠØ± Ø§Ù„Ø´Ø­Ù†',0),(232338,6454,'fr','Estimation d\'expÃ©dition',0),(232339,6454,'jp','ç™ºé€?è¦‹ç©?ã‚Š',0),(232340,6454,'pt','Estimativa de envio',0),(232341,6454,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑÐ¼ÐµÑ‚Ð°',0),(232342,6454,'es','EstimaciÃ³n de Transporte',0),(232343,6454,'de','Versand SchÃ¤tzung',0),(232344,6454,'en','Shipping Estimate',0),(232345,6455,'is','',0),(232346,6455,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(232347,6455,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(232348,6455,'tr','Onaylanmayan sipariÅŸ vermeyen bulundu',0),(232349,6455,'pl','Nie potwierdzone zamÃ³wienia Znalezione',0),(232350,6455,'bg','ÐÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(232351,6455,'ur','Ú©ÙˆØ¦ÛŒ ØºÛŒØ± Ù…ØµØ¯Ù‚Û Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…Ù„Û’',0),(232352,6455,'sr','ÐÐµÐ¼Ð° Ð½ÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð¸Ð¼ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(232353,6455,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n hÃ ng chÆ°a xÃ¡c nháº­n',0),(232354,6455,'af','Geen Onbevestigde Bestellings Gevind',0),(232355,6455,'ro','Comenzi neconfirmate gÄƒsit',0),(232356,6455,'et','Kinnitamata tellimusi ei leitud',0),(232357,6455,'si','Brez nepotrjenih naroÄil naÅ¡el',0),(232358,6455,'ba','Tidak ada order yang belum dikonfirmasi ditemukan',0),(232359,6455,'nl','Geen onbevestigde Orders gevonden',0),(232360,6455,'fi','Ei vahvistamaton tilauksista',0),(232361,6455,'no','Ingen ubekreftede ordrer funnet',0),(232362,6455,'da','Ingen ubekrÃ¦ftede ordrer fundet',0),(232363,6455,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” ë¯¸í™•ì¸ëœ ì£¼ë¬¸',0),(232364,6455,'he','×¤×§×•×“×•×ª ×©×œ× ××•×©×¨×• × ×ž×¦××•',0),(232365,6455,'el','Î”ÎµÎ½ Î¼Î· ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹Ï‰Î¼Î­Î½ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(232366,6455,'zh','æ²¡æœ‰å‘çŽ°æœªç»è¯å®žçš„è®¢å•\r\n',0),(232367,6455,'sv','Inga obekrÃ¤ftade order hittade',0),(232368,6455,'it','Senza ordini non confermati trovati',0),(232369,6455,'tl','',0),(232370,6455,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(232371,6455,'hi','à¤•à¥‹à¤ˆ à¤…à¤ªà¥à¤·à¥à¤Ÿ à¤‘à¤°à¥à¤¡à¤°à¥à¤¸ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(232372,6455,'ms','Tiada pesanan belum disahkan yang ditemui',0),(232373,6455,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙˆØ§Ù…Ø± ØºÙŠØ± Ù…Ø¤ÙƒØ¯Ø© Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(232374,6455,'fr','Aucune commande non confirmÃ©e trouvÃ©',0),(232375,6455,'jp','æœªç¢ºèª?æ³¨æ–‡ã?¯è¦‹ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(232376,6455,'pt','NÃ£o hÃ¡ ordens nÃ£o confirmados encontrados',0),(232377,6455,'ru','ÐÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(232378,6455,'es','No se Encontraron Ordenes No Confirmados',0),(232379,6455,'de','Keine unbestÃ¤tigte AuftrÃ¤ge gefunden',0),(232380,6455,'en','No Unconfirmed Orders Found',0),(232381,6456,'is','',0),(232382,6456,'dr','Ø³Ù¾Ø±Ø¯Ù‡ Ø§Ø¶Ø§ÙÙŠ ',0),(232383,6456,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ø§Ø¶Ø§ÙÙŠ ',0),(232384,6456,'tr','Ek teminat',0),(232385,6456,'pl','Dodatkowy depozyt',0),(232386,6456,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(232387,6456,'ur','Ø§Ø¶Ø§ÙÛŒ Ø¬Ù…Ø¹',0),(232388,6456,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(232389,6456,'vi','Ná»£ Cá»™ng ThÃªm',0),(232390,6456,'af','Addisionele Deposito',0),(232391,6456,'ro','Depozit aditional',0),(232392,6456,'et','TÃ¤iendava tagatisraha',0),(232393,6456,'si','Dodatnem depozitu',0),(232394,6456,'ba','Simpanan Tambahan',0),(232395,6456,'nl','Aanvullend deposito',0),(232396,6456,'fi','Takuumaksu',0),(232397,6456,'no','Ekstra innskudd',0),(232398,6456,'da','Ekstra indbetaling',0),(232399,6456,'ko','ì¶”ê°€ ìž…ê¸ˆ',0),(232400,6456,'he','×¤×§×“×•×Ÿ × ×•×¡×£',0),(232401,6456,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏ‰Î¼Î±Ï„Î¹ÎºÎ® ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(232402,6456,'zh','é¢å¤–çš„å­˜æ¬¾\r\n',0),(232403,6456,'sv','Extra deposition',0),(232404,6456,'it','Deposito aggiuntivo',0),(232405,6456,'tl','',0),(232406,6456,'th','&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(232407,6456,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤œà¤®à¤¾',0),(232408,6456,'ms','Deposit tambahan',0),(232409,6456,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø¥Ø¶Ø§ÙÙŠØ©',0),(232410,6456,'fr','DÃ©pÃ´t SupplÃ©mentaire',0),(232411,6456,'jp','è¿½åŠ é ?ã‚Šé‡‘',0),(232412,6456,'pt','DepÃ³sito adicional',0),(232413,6456,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(232414,6456,'es','DepÃ³sito Adicional',0),(232415,6456,'de','ZusÃ¤tzliche Einzahlung',0),(232416,6456,'en','Additional Deposit',0),(232417,6457,'is','',0),(232418,6457,'dr','Ø´ØºÙ„ Ù‚Ø¨Ù„Ø§ Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(232419,6457,'pr','Ø´ØºÙ„ Ù‚Ø¨Ù„Ø§ Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(232420,6457,'tr','Zaten kaydedilmiÅŸ iÅŸ',0),(232421,6457,'pl','Zadanie juÅ¼ zapisane',0),(232422,6457,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð²ÐµÑ‡Ðµ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸',0),(232423,6457,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ù…Ø­ÙÙˆØ¸ Ù…Ù„Ø§Ø²Ù…Øª',0),(232424,6457,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ Ð²ÐµÑ› ÑÐ¿Ð°ÑÐ¸Ð¾',0),(232425,6457,'vi','cÃ´ng viá»‡c Ä‘Ã£ sao lÆ°u',0),(232426,6457,'af','Projek Alreeds Gestoor',0),(232427,6457,'ro','Job deja salvate',0),(232428,6457,'et','TÃ¶Ã¶ juba salvestatud',0),(232429,6457,'si','Delo, ki so Å¾e shranjene',0),(232430,6457,'ba','Pekerjaan sudah disimpan',0),(232431,6457,'nl','Baan al opgeslagen',0),(232432,6457,'fi','TyÃ¶ on jo tallennettu',0),(232433,6457,'no','Jobben allerede lagret',0),(232434,6457,'da','Job allerede er gemt',0),(232435,6457,'ko','ì´ë¯¸ ì €ìž¥ ëœ ìž‘ì—…',0),(232436,6457,'he','×”×¢×‘×•×“×” ×›×‘×¨ ×”×¦×™×œ.',0),(232437,6457,'el','Î”Î¿Ï…Î»ÎµÎ¹Î¬ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î®Î´Î· Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯',0),(232438,6457,'zh','å·¥ä½œå·²ç»ä¿å­˜\r\n',0),(232439,6457,'sv','Jobb redan sparat',0),(232440,6457,'it','Lavoro giÃ  salvato',0),(232441,6457,'tl','',0),(232442,6457,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3591;&#3634;&#3609;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(232443,6457,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¸à¤¹à¥‡à¤œà¥€ à¤—à¤ˆ à¤¨à¥Œà¤•à¤°à¥€',0),(232444,6457,'ms','Kerja yang telah disimpan',0),(232445,6457,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø¨Ø§Ù„ÙØ¹Ù„ Ø¨Ø­ÙØ¸',0),(232446,6457,'fr','Emploi dÃ©jÃ  sauvÃ©',0),(232447,6457,'jp','ä½œæ¥­ã?¯ã?™ã?§ã?«ä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(232448,6457,'pt','Trabalho jÃ¡ salvou',0),(232449,6457,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° ÑƒÐ¶Ðµ ÑÐ¿Ð°Ñ',0),(232450,6457,'es','Trabajo Ya Guardado',0),(232451,6457,'de','Job bereits gespeichert',0),(232452,6457,'en','Job Already Saved',0),(232453,6458,'is','',0),(232454,6458,'dr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª  Ø³ÙØ§Ø±Ø´  Ø³Ù¾Ø±Ø¯Ù‡ ',0),(232455,6458,'pr','Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª  Ø³ÙØ§Ø±Ø´  Ø³Ù¾Ø±Ø¯Ù‡ ',0),(232456,6458,'tr','Fiyat listesi sÄ±rasÄ±nÄ± mevduat',0),(232457,6458,'pl','ZÅ‚oÅ¼enia zamÃ³wienia Cennik',0),(232458,6458,'bg','Ð¦ÐµÐ½Ð¾Ñ€Ð°Ð·Ð¿Ð¸Ñ Ð·Ð°ÑÐ²ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(232459,6458,'ur','Ù¾Ø±Ø§Ú©Ø§Ù„Ø§Ø³Ù¹ Ø¢Ø±ÚˆØ± Ø¬Ù…Ø¹',0),(232460,6458,'sr','Ð¦Ñ˜ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(232461,6458,'vi','Báº£ng tiá»n cá»c cho Ä‘Æ¡n hÃ ng',0),(232462,6458,'af','Pricelist te orde deposito',0),(232463,6458,'ro','Lista de preÅ£uri ordinea depozit',0),(232464,6458,'et','Hinnakiri tellimuse tagatisraha',0),(232465,6458,'si','Cenik naroÄilo depozita',0),(232466,6458,'ba','Pricelist Order Deposit',0),(232467,6458,'nl','Prijslijst volgorde storting',0),(232468,6458,'fi','Hinnasto jotta talletus',0),(232469,6458,'no','Prisliste for innskudd',0),(232470,6458,'da','Prisliste for indbetaling',0),(232471,6458,'ko','ê°€ê²©í‘œ ì£¼ë¬¸ ìž…ê¸ˆ',0),(232472,6458,'he','×ž×—×™×¨×•×Ÿ ×¦×• ×”×¤×§×“×”',0),(232473,6458,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î´Î¹Î±Ï„Î±Î³Î® ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(232474,6458,'zh','ä»·ç›®è¡¨è®¢è´­å­˜æ¬¾\r\n',0),(232475,6458,'sv','Prislista fÃ¶r insÃ¤ttning',0),(232476,6458,'it','Deposito Listino prezzi ordine',0),(232477,6458,'tl','',0),(232478,6458,'th','&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3619;&#3634;&#3588;&#3634;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(232479,6458,'hi','Pricelist à¤•à¥‡ à¤²à¤¿à¤ à¤‘à¤°à¥à¤¡à¤° à¤œà¤®à¤¾',0),(232480,6458,'ms','Perintah senarai Deposit',0),(232481,6458,'ar','Ø¥ÙŠØ¯Ø§Ø¹ ØªØ±ØªÙŠØ¨ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(232482,6458,'fr','DÃ©pÃ´t de l\'ordre de la liste de prix',0),(232483,6458,'jp','ä¾¡æ ¼è¡¨æ³¨æ–‡é ?ã‚Šé‡‘',0),(232484,6458,'pt','DepÃ³sito de ordem de lista de preÃ§os',0),(232485,6458,'ru','ÐŸÑ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ Ð·Ð°ÐºÐ°Ð· Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(232486,6458,'es','Lista de Precios DepÃ³sito de Orden',0),(232487,6458,'de','Preisliste Bestellung Anzahlung',0),(232488,6458,'en','Pricelist Order Deposit',0),(232489,6459,'is','',0),(232490,6459,'dr','(Ø³Ù¾Ø±Ø¯Ù‡)Ù‚Ø¨Ù„ÙŠ',0),(232491,6459,'pr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª(Ø³Ù¾Ø±Ø¯Ù‡)Ù‚Ø¨Ù„ÙŠ',0),(232492,6459,'tr','Ã–nceki mevduat',0),(232493,6459,'pl','Uprzedniego depozytu',0),(232494,6459,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(232495,6459,'ur','Ù¾ÛŒØ´Ú¯ÛŒ Ø¬Ù…Ø¹',0),(232496,6459,'sr','Ð˜Ð³ÑƒÐ¼Ð°Ð½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(232497,6459,'vi','Äáº·t cá»c trÆ°á»›c',0),(232498,6459,'af','Vorige Deposito',0),(232499,6459,'ro','Depozit prealabilÄƒ',0),(232500,6459,'et','Varasemate hoiuste',0),(232501,6459,'si','Predhodnega pologa',0),(232502,6459,'ba','Deposit terlebih dahulu',0),(232503,6459,'nl','Voorafgaande storting',0),(232504,6459,'fi','Ennen talletusta',0),(232505,6459,'no','Tidligere innskudd',0),(232506,6459,'da','ForudgÃ¥ende depositum',0),(232507,6459,'ko','ì‚¬ì „ ìž…ê¸ˆ',0),(232508,6459,'he','×”×¤×§×“×” ×ž×¨××©',0),(232509,6459,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(232510,6459,'zh','å…ˆå‰å­˜æ¬¾\r\n',0),(232511,6459,'sv','FÃ¶re insÃ¤ttning',0),(232512,6459,'it','Previo deposito',0),(232513,6459,'tl','',0),(232514,6459,'th','&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3607;&#3637;&#3656;&#3617;&#3637;&#3617;&#3634;&#3585;&#3656;&#3629;&#3609;',0),(232515,6459,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤œà¤®à¤¾',0),(232516,6459,'ms','Deposit terlebih dahulu',0),(232517,6459,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ø³Ø¨Ù‚',0),(232518,6459,'fr','DÃ©pÃ´t prÃ©alable',0),(232519,6459,'jp','äº‹å‰?é ?ã‚Šé‡‘',0),(232520,6459,'pt','DepÃ³sito prÃ©vio',0),(232521,6459,'ru','Ð Ð°Ð½ÐµÐµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(232522,6459,'es','DepÃ³sitos Anteriores',0),(232523,6459,'de','Vorherige Einzahlung',0),(232524,6459,'en','Prior Deposit',0),(232525,6460,'is','',0),(232526,6460,'dr','ØªØ§Ø±ÙŠØ® Ø«Ø¨Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§ÙˆÙ„ÙŠÙ‡',0),(232527,6460,'pr','ØªØ§Ø±ÙŠØ® Ø«Ø¨Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§ÙˆÙ„ÙŠÙ‡',0),(232528,6460,'tr','Begin teklif giriÅŸinin tarihi',0),(232529,6460,'pl','Data wpisu cytat rozp.',0),(232530,6460,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð°',0),(232531,6460,'ur','Ø¢ØºØ§Ø² Ø§Ù‚ØªØ¨Ø§Ø³ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(232532,6460,'sr','ÐžÐ·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° ÑƒÐ½Ð¾Ñ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(232533,6460,'vi','NgÃ y Báº¯t Äáº§u Nháº­p BÃ¡o GiÃ¡',0),(232534,6460,'af','Begin Kwotasie Inskrywingsdatum',0),(232535,6460,'ro','Data de intrare Ã®ncepe citat',0),(232536,6460,'et','Hinnapakkumise kande alguskuupÃ¤ev',0),(232537,6460,'si','Datum zaÄetka ponudbe Begin',0),(232538,6460,'ba','Tanggal entri Mulailah kutipan',0),(232539,6460,'nl','Begin citaat post datum',0),(232540,6460,'fi','Aloita tarjouksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(232541,6460,'no','Start tilbud oppfÃ¸ringsdatoen',0),(232542,6460,'da','Begynd citat tilmeldningsfrist',0),(232543,6460,'ko','ì‹œìž‘ ì¸ìš© í•­ëª© ë‚ ì§œ',0),(232544,6460,'he','×ª××¨×™×š ×›× ×™×¡×” ×”×¦×¢×ª ×ž×—×™×¨ ×‘×’×™×Ÿ',0),(232545,6460,'el','ÎžÎµÎºÎ¹Î½Î®ÏƒÏ„Îµ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(232546,6460,'zh','æŠ¥ä»·è¾“å…¥å¼€å§‹æ—¥æœŸ\r\n',0),(232547,6460,'sv','BÃ¶rja offert datumet',0),(232548,6460,'it','Data Entry di Begin citazione',0),(232549,6460,'tl','',0),(232550,6460,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3611;&#3657;&#3629;&#3609;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(232551,6460,'hi','à¤¶à¥à¤°à¥‚ à¤¬à¥‹à¤²à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(232552,6460,'ms','Tarikh kemasukan Quote mulakan',0),(232553,6460,'ar','ØªØ§Ø±ÙŠØ® Ø¯Ø®ÙˆÙ„ Ø§Ù‚ØªØ¨Ø³ Ø§Ù„Ø¨Ø¯Ø¡',0),(232554,6460,'fr','Begin citation Date de l\'entrÃ©e',0),(232555,6460,'jp','è¦‹ç©?ã‚Šå…¥åŠ›é–‹å§‹æ—¥',0),(232556,6460,'pt','Data de entrada do Begin citaÃ§Ã£o',0),(232557,6460,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹ Ð”Ð°Ñ‚Ð° Ð²ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ',0),(232558,6460,'es','Inicio de la Fecha de Entrada de CotizaciÃ³n',0),(232559,6460,'de','BEGIN Zitat Eintrag vom',0),(232560,6460,'en','Begin Quote Entry Date',0),(232561,6461,'is','',0),(232562,6461,'dr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø«Ø¨Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(232563,6461,'pr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø«Ø¨Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(232564,6461,'tr','Son teklif giriÅŸinin tarihi',0),(232565,6461,'pl','Data dodania oferty koniec',0),(232566,6461,'bg','ÐšÑ€Ð°Ð¹ Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð°',0),(232567,6461,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø§Ù‚ØªØ¨Ø§Ø³ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(232568,6461,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð° Ð¿Ð¾Ð½ÑƒÐ´Ð° Ð·Ð° ÐºÑ€Ð°Ñ˜',0),(232569,6461,'vi','NgÃ y Káº¿t ThÃºc Nháº­p BÃ¡o GiÃ¡',0),(232570,6461,'af','End Kwotasie-inskrywing Datum',0),(232571,6461,'ro','Data de intrÄƒrii sfÃ¢rÅŸitul citat',0),(232572,6461,'et','Hinnapakkumise kirjet lÃµppkuupÃ¤ev',0),(232573,6461,'si','Vnos datuma konca ponudbe',0),(232574,6461,'ba','Tanggal entri akhir kutipan',0),(232575,6461,'nl','Einde citaat post datum',0),(232576,6461,'fi','Lainaus tapahtuman pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(232577,6461,'no','Tilbud posten dato',0),(232578,6461,'da','Ende tilbud tilmeldningsfrist',0),(232579,6461,'ko','ìµœì¢… ê²¬ì  í•­ëª© ë‚ ì§œ',0),(232580,6461,'he','×ª××¨×™×š ×›× ×™×¡×” ×¡×•×£ ×¦×™×˜×•×˜',0),(232581,6461,'el','Î¤Î­Î»Î¿Ï‚ Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(232582,6461,'zh','ç»“æŸæŠ¥ä»·å½•å…¥æ—¥æœŸ',0),(232583,6461,'sv','Slut citat bloggpostens datum',0),(232584,6461,'it','Data Entry di fine citazione',0),(232585,6461,'tl','',0),(232586,6461,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3611;&#3657;&#3629;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(232587,6461,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(232588,6461,'ms','Tarikh kemasukan akhir Quote',0),(232589,6461,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³ ØªØ§Ø±ÙŠØ® Ø¯Ø®ÙˆÙ„',0),(232590,6461,'fr','Fin citation Date de l\'entrÃ©e',0),(232591,6461,'jp','è¦‹ç©?ã‚Šå…¥åŠ›çµ‚äº†æ—¥',0),(232592,6461,'pt','Data de entrada de citaÃ§Ã£o final',0),(232593,6461,'ru','Ð”Ð°Ñ‚Ð° Ð²Ñ…Ð¾Ð´Ð° ÐºÐ¾Ð½ÐµÑ† Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(232594,6461,'es','Fecha Final de Entrada de CotizaciÃ³n',0),(232595,6461,'de','Ende Zitat Eintrag vom',0),(232596,6461,'en','End Quote Entry Date',0),(232597,6462,'is','',0),(232598,6462,'dr','Ù„ÙŠØ³Øª Ú†Ø§Ù¾ ',0),(232599,6462,'pr','Ù„ÙŠØ³Øª Ú†Ø§Ù¾ ',0),(232600,6462,'tr','BasÄ±mevi listesi',0),(232601,6462,'pl','Drukarnia listy',0),(232602,6462,'bg','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ€Ð¸Ñ‚Ðµ ÑÐ¿Ð¸ÑÑŠÐº',0),(232603,6462,'ur','Ù¾Ø±Ø§Ù†Ù¹Ø´ÙˆÙ¾ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(232604,6462,'sr','ÐŸÑ€Ð¸Ð½Ñ‚ÑÑ…Ð¾Ð¿ Ð»Ð¸ÑÑ‚Ð°',0),(232605,6462,'vi','Danh sÃ¡ch shop in',0),(232606,6462,'af','Printshop lys',0),(232607,6462,'ro','Printshop lista',0),(232608,6462,'et','TrÃ¼kikojale loend',0),(232609,6462,'si','Tiskanje seznama',0),(232610,6462,'ba','Daftar Printshop',0),(232611,6462,'nl','PrintShop lijst',0),(232612,6462,'fi','Painotalon luettelo',0),(232613,6462,'no','Trykkeriets liste',0),(232614,6462,'da','Printshop liste',0),(232615,6462,'ko','Printshop ëª©ë¡',0),(232616,6462,'he','×¨×©×™×ž×ª ×”×™×™×¢×•×¥',0),(232617,6462,'el','Î¤Ï…Ï€Î¿Î³ÏÎ±Ï†ÎµÎ¯Î¿Ï… Î»Î¯ÏƒÏ„Î±',0),(232618,6462,'zh','æ‰“å°åº—åå•\r\n',0),(232619,6462,'sv','Tryckeriet lista',0),(232620,6462,'it','PrintShop elenco',0),(232621,6462,'tl','',0),(232622,6462,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3657;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(232623,6462,'hi','Printshop à¤¸à¥‚à¤šà¥€',0),(232624,6462,'ms','Senarai Printshop',0),(232625,6462,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ø·Ø¨Ø¹Ø©',0),(232626,6462,'fr','PrintShop liste',0),(232627,6462,'jp','å?°åˆ·åº—ãƒªã‚¹ãƒˆ',0),(232628,6462,'pt','Lista de tipografia',0),(232629,6462,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ñ‚Ð¸Ð¿Ð¾Ð³Ñ€Ð°Ñ„Ð¸Ð¸',0),(232630,6462,'es','Lista de Printshop',0),(232631,6462,'de','PrintShop-Liste',0),(232632,6462,'en','Printshop List',0),(232633,6463,'is','',0),(232634,6463,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø·Ø¨Ù‚ Ø­Ø¬Ù… Ø®Ø±ÙŠØ¯',0),(232635,6463,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø·Ø¨Ù‚ Ø­Ø¬Ù… Ø®Ø±ÙŠØ¯',0),(232636,6463,'tr','MÃ¼ÅŸteriler tarafÄ±ndan birim',0),(232637,6463,'pl','Klienci objÄ™toÅ›ci',0),(232638,6463,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð¾Ð±ÐµÐ¼Ð½Ð¸',0),(232639,6463,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø­Ø¬Ù… Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(232640,6463,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸ Ð¿Ð¾ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½Ñƒ',0),(232641,6463,'vi','KhÃ¡ch hÃ ng theo khá»‘i lÆ°á»£ng',0),(232642,6463,'af','Klante / KliÃ«nte per Volume',0),(232643,6463,'ro','ClienÅ£ii de volum',0),(232644,6463,'et','Hotelli mahuprotsentides',0),(232645,6463,'si','Stranke po prostornini',0),(232646,6463,'ba','Pelanggan dengan Volume',0),(232647,6463,'nl','Klanten door Volume',0),(232648,6463,'fi','Asiakkaiden mÃ¤Ã¤rÃ¤',0),(232649,6463,'no','Kunder av volumet',0),(232650,6463,'da','Kunder af volumen',0),(232651,6463,'ko','ë³¼ë¥¨ìœ¼ë¡œ ê³ ê°',0),(232652,6463,'he','×”×œ×§×•×—×•×ª ×œ×¤×™ × ×¤×—',0),(232653,6463,'el','ÎŸÎ¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï„Î¿Ï… ÏŒÎ³ÎºÎ¿Ï…',0),(232654,6463,'zh','å®¢æˆ·çš„æ•°é‡\r\n',0),(232655,6463,'sv','Kunder av volym',0),(232656,6463,'it','Clienti di Volume',0),(232657,6463,'tl','',0),(232658,6463,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(232659,6463,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(232660,6463,'ms','Pelanggan mengikut jumlah',0),(232661,6463,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…Ù† Ø­ÙŠØ« Ø§Ù„Ø­Ø¬Ù…',0),(232662,6463,'fr','Clients en Volume',0),(232663,6463,'jp','å£²è²·é«˜åˆ¥é¡§å®¢',0),(232664,6463,'pt','Clientes por Volume',0),(232665,6463,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ð¾ Ð¾Ð±ÑŠÐµÐ¼Ñƒ',0),(232666,6463,'es','Clientes por VolÃºmen',0),(232667,6463,'de','Kunden, die nach Volumen',0),(232668,6463,'en','Customers by Volume',0),(232669,6464,'is','',0),(232670,6464,'dr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  Ø·Ø¨Ù‚ Ù…Ù‚Ø¯Ø§Ø±',0),(232671,6464,'pr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  Ø·Ø¨Ù‚ Ù…Ù‚Ø¯Ø§Ø±',0),(232672,6464,'tr','GÃ¶rÃ¼nÃ¼m mÃ¼ÅŸteriler tarafÄ±ndan birim',0),(232673,6464,'pl','Widok klientÃ³w objÄ™toÅ›ci',0),(232674,6464,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸ Ð¿Ð¾ Ð¾Ð±ÐµÐ¼',0),(232675,6464,'ur','Ù…Ù†Ø¸Ø± Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø­Ø¬Ù… Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(232676,6464,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸ Ð¿Ð¾ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½Ñƒ',0),(232677,6464,'vi','Xem khÃ¡ch hÃ ng qua khá»‘i lÆ°á»£ng',0),(232678,6464,'af','Besig KliÃ«nt/Klant per Volume',0),(232679,6464,'ro','Vezi clienÅ£ii de volum',0),(232680,6464,'et','Vaade hotelli mahuprotsentides',0),(232681,6464,'si','Pogled stranke po prostornini',0),(232682,6464,'ba','Lihat pelanggan dengan Volume',0),(232683,6464,'nl','Weergave klanten door Volume',0),(232684,6464,'fi','NÃ¤ytÃ¤ asiakkaat tilavuus',0),(232685,6464,'no','Vis kundene volumprosent',0),(232686,6464,'da','Se kunder volumen',0),(232687,6464,'ko','ë³¼ë¥¨ ë³´ê¸° ê³ ê°',0),(232688,6464,'he','×ª×¦×•×’×” ×”×œ×§×•×—×•×ª ×œ×¤×™ × ×¤×—',0),(232689,6464,'el','ÎŸÎ¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î¬Ï€Î¿ÏˆÎ· Ï„Î¿Ï… ÏŒÎ³ÎºÎ¿Ï…',0),(232690,6464,'zh','æŒ‰é‡æŸ¥çœ‹å®¢æˆ·\r\n',0),(232691,6464,'sv','Visa kunder av volym',0),(232692,6464,'it','Visualizzazione clienti di Volume',0),(232693,6464,'tl','',0),(232694,6464,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(232695,6464,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(232696,6464,'ms','Lihat pelanggan mengikut jumlah',0),(232697,6464,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…Ù† Ø­ÙŠØ« Ø§Ù„Ø­Ø¬Ù…',0),(232698,6464,'fr','Avis clients en Volume',0),(232699,6464,'jp','å£²è²·é«˜åˆ¥é¡§å®¢ã?®è¡¨ç¤º',0),(232700,6464,'pt','Vista clientes por Volume',0),(232701,6464,'ru','ÐœÐ½ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ð¾ Ð¾Ð±ÑŠÐµÐ¼Ñƒ',0),(232702,6464,'es','Visionar Clientes por VolÃºmen',0),(232703,6464,'de','Ansicht Kunden Volumenprozent',0),(232704,6464,'en','View Customers by Volume',0),(232705,6465,'is','',0),(232706,6465,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø·Ø¨Ù‚ ÙØ±ÙˆØ´ ',0),(232707,6465,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø·Ø¨Ù‚ ÙØ±ÙˆØ´ ',0),(232708,6465,'tr','MÃ¼ÅŸteriler tarafÄ±ndan satÄ±ÅŸ',0),(232709,6465,'pl','Klienci przy sprzedaÅ¼y',0),(232710,6465,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(232711,6465,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø³ÛŒÙ„Ø²',0),(232712,6465,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸ Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¸',0),(232713,6465,'vi','KhÃ¡ch hÃ ng bÃªn bÃ¡n hÃ ng',0),(232714,6465,'af','Klante/KliÃ«nte volgens Verkope',0),(232715,6465,'ro','Clienti dupa vanzari',0),(232716,6465,'et','Hotelli mÃ¼Ã¼k',0),(232717,6465,'si','Stranke s prodajo',0),(232718,6465,'ba','Pelanggan dengan penjualan',0),(232719,6465,'nl','Klanten door verkoop',0),(232720,6465,'fi','Asiakkaat myynti',0),(232721,6465,'no','Kundene etter salg',0),(232722,6465,'da','Kunder af salg',0),(232723,6465,'ko','íŒë§¤ì— ì˜í•´ ê³ ê°',0),(232724,6465,'he','×œ×§×•×—×•×ª ×œ×¤×™ ×ž×›×™×¨×•×ª',0),(232725,6465,'el','ÎŸÎ¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï„Î¿Ï…/Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(232726,6465,'zh','å®¢æˆ·çš„é”€å”®\r\n',0),(232727,6465,'sv','Kunder av fÃ¶rsÃ¤ljning',0),(232728,6465,'it','Clienti di vendite',0),(232729,6465,'tl','',0),(232730,6465,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(232731,6465,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(232732,6465,'ms','Pelanggan oleh jualan',0),(232733,6465,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…Ù† Ù…Ø¨ÙŠØ¹Ø§Øª',0),(232734,6465,'fr','Clients de ventes',0),(232735,6465,'jp','è²©å£²é †ã?®é¡§å®¢ãƒªã‚¹ãƒˆ',0),(232736,6465,'pt','Clientes por vendas',0),(232737,6465,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹ Ð¿Ð¾ ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð°Ð¼',0),(232738,6465,'es','Clientes por Ventas',0),(232739,6465,'de','Kunden, die durch den Verkauf',0),(232740,6465,'en','Customers by Sales',0),(232741,6466,'is','',0),(232742,6466,'dr','Ù‡Ù…Ù‡ ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¶Ø±ÙˆØ±ÙŠ Ù‡Ø³ØªÙ†Ø¯',0),(232743,6466,'pr','Ù‡Ù…Ù‡ ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¶Ø±ÙˆØ±ÙŠ Ù‡Ø³ØªÙ†Ø¯',0),(232744,6466,'tr','Gerekli tÃ¼m alanlarÄ±',0),(232745,6466,'pl','Wszystkie pola wymagane',0),(232746,6466,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° ÑÐ° Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸',0),(232747,6466,'ur','ØªÙ…Ø§Ù… Ù‚Ø·Ø¹Ø§Øª Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(232748,6466,'sr','Ð¡Ð²Ð° Ð¿Ð¾Ñ™Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð°',0),(232749,6466,'vi','Táº¥t Cáº£ CÃ¡c TrÆ°á»ng YÃªu Cáº§u',0),(232750,6466,'af','Alle Velde Benodig',0),(232751,6466,'ro','Toate cÃ¢mpurile necesare',0),(232752,6466,'et','NÃµutavad vÃ¤ljad',0),(232753,6466,'si','Vsa polja, ki zahteva',0),(232754,6466,'ba','Semua kolom wajib diisi',0),(232755,6466,'nl','Alle verplichte velden',0),(232756,6466,'fi','Kaikki kentÃ¤t on tÃ¤ytettÃ¤vÃ¤',0),(232757,6466,'no','Alle feltene som er obligatoriske',0),(232758,6466,'da','Alle felter krÃ¦ves',0),(232759,6466,'ko','í•„ìš”í•œ ëª¨ë“  ë¶„ì•¼',0),(232760,6466,'he','×›×œ ×”×©×“×•×ª × ×“×¨×©×™×',0),(232761,6466,'el','ÎŒÎ»Î± Ï„Î± Ï€ÎµÎ´Î¯Î± Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹',0),(232762,6466,'zh','å¿…é¡»å¡«å†™æ‰€æœ‰å­—æ®µ\r\n',0),(232763,6466,'sv','Alla obligatoriska fÃ¤lt',0),(232764,6466,'it','Tutti i campi richiesti',0),(232765,6466,'tl','',0),(232766,6466,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3615;&#3636;&#3621;&#3604;&#3660;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(232767,6466,'hi','à¤¸à¤­à¥€ à¤†à¤µà¤¶à¥à¤¯à¤• à¤«à¤¼à¥€à¤²à¥à¤¡',0),(232768,6466,'ms','Semua bidang yang diperlukan',0),(232769,6466,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(232770,6466,'fr','Tous les champs requis',0),(232771,6466,'jp','ã?™ã?¹ã?¦ã?®å¿…è¦?ã?ªãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(232772,6466,'pt','Todos os campos obrigatÃ³rios',0),(232773,6466,'ru','Ð’ÑÐµ Ð¿Ð¾Ð»Ñ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹',0),(232774,6466,'es','Todos los Campos Requeridos',0),(232775,6466,'de','Alle Felder mÃ¼ssen ausgefÃ¼llt werden',0),(232776,6466,'en','All Fields Required',0),(232777,6467,'is','',0),(232778,6467,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø±Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø¨Ù†Ø§ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†ÙƒÙ†ÙŠØ¯ ',0),(232779,6467,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø±Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø¨Ù†Ø§ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†ÙƒÙ†ÙŠØ¯ ',0),(232780,6467,'tr','SipariÅŸ numarasÄ±, fatura numarasÄ± iÃ§in temel olarak kullanmayÄ±n',0),(232781,6467,'pl','Nie naleÅ¼y uÅ¼ywaÄ‡ numeru zamÃ³wienia jako podstawa dla numeru faktury',0),(232782,6467,'bg','ÐÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° ÐºÐ°Ñ‚Ð¾ Ð¾ÑÐ½Ð¾Ð²Ð° Ð·Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(232783,6467,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù†Û Ú©Ø±ÛŒÚº',0),(232784,6467,'sr','ÐÐµÐ¼Ð¾Ñ˜Ñ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° ÐºÐ°Ð¾ Ð¾ÑÐ½Ð¾Ð²Ð° Ð·Ð° Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(232785,6467,'vi','KhÃ´ng dÃ¹ng sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng nhÆ° lÃ  ná»n cho sá»‘ HÃ³a Ä‘Æ¡n',0),(232786,6467,'af','Moenie Bestelnommer gebruik as Basis vir Faktuurnommer',0),(232787,6467,'ro','Nu utilizaÅ£i numÄƒrul de ordine ca bazÄƒ pentru numÄƒrul facturii',0),(232788,6467,'et','Ã„rge kasutage jÃ¤rjekorranumbri alusel arvenumber',0),(232789,6467,'si','Ne uporabljajte zaporedno Å¡tevilko kot podlaga za Å¡tevilko raÄuna',0),(232790,6467,'ba','Jangan gunakan nomor pesanan sebagai dasar untuk faktur jumlah',0),(232791,6467,'nl','Gebruik geen ordernummer als Basis voor factuurnummer',0),(232792,6467,'fi','Ã„lÃ¤ kÃ¤ytÃ¤ tilausnumeron perusteella laskunumero',0),(232793,6467,'no','Ikke bruk ordrenummer som grunnlag for fakturanummer',0),(232794,6467,'da','Brug ikke ordrenummer som grundlag for fakturanummeret',0),(232795,6467,'ko','ì†¡ìž¥ ë²ˆí˜¸ì— ëŒ€ í•œ ê¸°ì¤€ìœ¼ë¡œ ì£¼ë¬¸ ë²ˆí˜¸ ì‚¬ìš© í•˜ì§€ ë§ˆì‹­ì‹œì˜¤',0),(232796,6467,'he','××œ ×ª×©×ª×ž×© ×ž×¡×¤×¨ ×”×–×ž× ×” ×›×‘×¡×™×¡ ×¢×‘×•×¨ ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(232797,6467,'el','ÎœÎ·Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï‰Ï‚ Î²Î¬ÏƒÎ· Î³Î¹Î± Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(232798,6467,'zh','ä¸è¦ç”¨è®¢å•å·ä½œä¸ºå‘ç¥¨å·åŸºç¡€\r\n',0),(232799,6467,'sv','AnvÃ¤nd inte ordernummer som grund fÃ¶r fakturanummer',0),(232800,6467,'it','Non utilizzare il numero d\'ordine come base per numero fattura',0),(232801,6467,'tl','',0),(232802,6467,'th','&#3629;&#3618;&#3656;&#3634;&#3651;&#3594;&#3657;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3634;&#3617;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609; &#3586;&#',0),(232803,6467,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤§à¤¾à¤° à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤‰à¤ªà¤¯à¥‹à¤— à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¤¤à¥‡',0),(232804,6467,'ms','Jangan gunakan nombor pesanan sebagai asas nombor invois',0),(232805,6467,'ar','Ù„Ø§ ØªØ³ØªØ®Ø¯Ù… \"Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨\" ÙƒØ£Ø³Ø§Ø³ \"Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©\"',0),(232806,6467,'fr','N\'utilisez pas de numÃ©ro de commande comme base pour le numÃ©ro de facture',0),(232807,6467,'jp','è«‹æ±‚æ›¸ç•ªå?·ã?«æ³¨æ–‡ç•ªå?·ã‚’ãƒ™ãƒ¼ã‚¹ã?¨ã?—ã?¦ä½¿ç”¨ã?—ã?ªã?„ã?§ä¸‹ã?•ã?„',0),(232808,6467,'pt','NÃ£o use NÃºmero de Ordem como Base de NÃºmero de Fatura',0),(232809,6467,'ru','ÐÐµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð° Ð² ÐºÐ°Ñ‡ÐµÑÑ‚Ð²Ðµ Ð¾ÑÐ½Ð¾Ð²Ñ‹ Ð´Ð»Ñ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(232810,6467,'es','No usa Numero de Pedido como base para el NÃºmero de Factura',0),(232811,6467,'de','Verwenden Sie keine Bestellnummer als Grundlage fÃ¼r Rechnungsnummer',0),(232812,6467,'en','Do Not use Order Number as Basis for Invoice Number',0),(232813,6468,'is','',0),(232814,6468,'dr','Ø´Ø±ÙˆØ¹ Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø­Ø³Ø§Ø¨ ',0),(232815,6468,'pr','Ø´Ø±ÙˆØ¹ Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø­Ø³Ø§Ø¨ ',0),(232816,6468,'tr','Hesap aralÄ±ÄŸÄ± baÅŸlangÄ±Ã§',0),(232817,6468,'pl','PoczÄ…tkowy zakres kont',0),(232818,6468,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ ÐÐ°Ñ‡Ð°Ð»Ð¾',0),(232819,6468,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ø­Ø¯ Ø´Ø±ÙˆØ¹',0),(232820,6468,'sr','ÐžÐ·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð¾Ð¿ÑÐµÐ³',0),(232821,6468,'vi','Pháº¡m Vi TK Báº¯t Äáº§u',0),(232822,6468,'af','Rekeningreeks begin',0),(232823,6468,'ro','Contul incepe de la',0),(232824,6468,'et','Konto valik algus',0),(232825,6468,'si','RaÄun obsega zaÄetek',0),(232826,6468,'ba','Rentang Akun Awal',0),(232827,6468,'nl','Rekeningreeks Begin',0),(232828,6468,'fi','Tilien alkaa',0),(232829,6468,'no','Kontointervall begynner',0),(232830,6468,'da','Kontointerval Begin',0),(232831,6468,'ko','ê³„ì • ë²”ìœ„ ì‹œìž‘',0),(232832,6468,'he','×‘×’×™×Ÿ ×—×©×‘×•×Ÿ ×˜×•×•×—',0),(232833,6468,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î•ÏÏÎ¿Ï‚',0),(232834,6468,'zh','å¸æˆ·èŒƒå›´é–‹å§‹\r\n',0),(232835,6468,'sv','Kontointervall Begin',0),(232836,6468,'it','Intervallo di conti Begin',0),(232837,6468,'tl','',0),(232838,6468,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(232839,6468,'hi','à¤–à¤¾à¤¤à¤¾ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¶à¥à¤°à¥‚',0),(232840,6468,'ms','Mulakan pelbagai akaun',0),(232841,6468,'ar','Ø¨Ø¯Ø¡ Ù†Ø·Ø§Ù‚ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(232842,6468,'fr','DÃ©but de la plage de compte',0),(232843,6468,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç¯„å›²å§‹ã‚?',0),(232844,6468,'pt','Begin conta gama',0),(232845,6468,'ru','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ ÑÑ‡ÐµÑ‚Ð° Begin',0),(232846,6468,'es','Inicio de Rango de Cuenta',0),(232847,6468,'de','Kontobereich Begin',0),(232848,6468,'en','Account Range Begin',0),(232849,6469,'is','',0),(232850,6469,'dr','Ù¾Ø§ÙŠØ§Ù† Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø­Ø³Ø§Ø¨',0),(232851,6469,'pr','Ù¾Ø§ÙŠØ§Ù† Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø­Ø³Ø§Ø¨',0),(232852,6469,'tr','Hesap aralÄ±ÄŸÄ± sonu',0),(232853,6469,'pl','Koniec zakresu konta',0),(232854,6469,'bg','ÐšÑ€Ð°Ð¹ Ð½Ð° Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð° Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(232855,6469,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ø§Ø®ØªØªØ§Ù… Ú©Ø±ÛŒÚº',0),(232856,6469,'sr','ÐšÑ€Ð°Ñ˜ Ð¾Ð¿ÑÐµÐ³Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(232857,6469,'vi','Pháº¡m Vi TK Káº¿t ThÃºc',0),(232858,6469,'af','Rekeningreeks eindig',0),(232859,6469,'ro','Contul se termina la',0),(232860,6469,'et','Konto dimensioonivahemiku lÃµpp',0),(232861,6469,'si','Konec raÄun obsega',0),(232862,6469,'ba','Rentang Akun Akhir',0),(232863,6469,'nl','Rekeningreeks einde',0),(232864,6469,'fi','Huomioon loppu',0),(232865,6469,'no','Kontointervall slutten',0),(232866,6469,'da','Kontointerval ende',0),(232867,6469,'ko','ê³„ì • ë²”ìœ„ ë',0),(232868,6469,'he','×§×¦×” ×”×˜×•×•×— ×—×©×‘×•×Ÿ',0),(232869,6469,'el','Î¤Î­Î»Î¿Ï‚ ÏƒÎµÎ¹ÏÎ¬ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(232870,6469,'zh','å¸æˆ·èŒƒå›´ç»“æŸ\r\n',0),(232871,6469,'sv','Kontointervall slutet',0),(232872,6469,'it','Conto gamma fine',0),(232873,6469,'tl','',0),(232874,6469,'th','&#3594;&#3656;&#3623;&#3591;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3586;&#3629;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(232875,6469,'hi','à¤–à¤¾à¤¤à¤¾ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤…à¤‚à¤¤',0),(232876,6469,'ms','Pelbagai akaun akhir',0),(232877,6469,'ar','Ø¥Ù†ØªÙ‡Ø§Ø¡ Ù†Ø·Ø§Ù‚ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(232878,6469,'fr','Fin de la plage de compte',0),(232879,6469,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç¯„å›²çµ‚äº†',0),(232880,6469,'pt','Gama de conta final',0),(232881,6469,'ru','ÐšÐ¾Ð½ÐµÑ† Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð° ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(232882,6469,'es','Fin de Rango de Cuenta',0),(232883,6469,'de','Konto Bereichsende',0),(232884,6469,'en','Account Range End',0),(232885,6470,'is','',0),(232886,6470,'dr','Ù…Ø¨Ø§Ù„Øº ÙƒÙ„ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… ØµÙØ­Ø§Øª',0),(232887,6470,'pr','Ù…Ø¨Ø§Ù„Øº ÙƒÙ„ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… ØµÙØ­Ø§Øª',0),(232888,6470,'tr','TÃ¼m sayfalar iÃ§in genel toplamlarÄ±',0),(232889,6470,'pl','Sumy dla wszystkich stron',0),(232890,6470,'bg','ÐžÐ±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸ Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(232891,6470,'ur','ØªÙ…Ø§Ù… ØµÙØ­Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ú¯Ø±ÛŒÙ†Úˆ Ù…ÛŒØ²Ø§Ù†',0),(232892,6470,'sr','Ð¡Ð²ÐµÑƒÐºÑƒÐ¿Ð½Ð¸Ñ… Ð·Ð° ÑÐ²Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(232893,6470,'vi','Tá»•ng cá»™ng cho táº¥t cáº£ cÃ¡c trang',0),(232894,6470,'af','Groot Totale vir Alle Bladsye',0),(232895,6470,'ro','Totaluri pentru toate paginile',0),(232896,6470,'et','KÃµik lehekÃ¼ljed Ã¼ldkokkuvÃµtted',0),(232897,6470,'si','Vsote za vse strani',0),(232898,6470,'ba','Grand total untuk semua halaman',0),(232899,6470,'nl','Eindtotalen voor alle pagina \'s',0),(232900,6470,'fi','Loppusummien kaikki sivut',0),(232901,6470,'no','Totalsummer for alle sider',0),(232902,6470,'da','Hovedtotaler for alle sider',0),(232903,6470,'ko','ëª¨ë“  íŽ˜ì´ì§€ì— ëŒ€ í•œ ì´í•©ê³„',0),(232904,6470,'he','×¡×›×•×ž×™× ×›×•×œ×œ×™× ×¢×‘×•×¨ ×›×œ ×”×“×¤×™×',0),(232905,6470,'el','Î‘Î¸ÏÎ¿Î¯ÏƒÎ¼Î±Ï„Î± Î³Î¹Î± ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚',0),(232906,6470,'zh','æ€»è®¡æ‰€æœ‰é¡µé¢\r\n',0),(232907,6470,'sv','Totalsummor fÃ¶r alla sidor',0),(232908,6470,'it','Totali complessivi per tutte le pagine',0),(232909,6470,'tl','',0),(232910,6470,'th','&#3618;&#3629;&#3604;&#3648;&#3591;&#3636;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3607;&#3640;&#3585;&#3627;&#3609;&#3657;&#3634;',0),(232911,6470,'hi','à¤¸à¤­à¥€ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¹à¤¾à¤¯à¥‹à¤—',0),(232912,6470,'ms','Grand jumlah bagi semua halaman',0),(232913,6470,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹ Ø§Ù„ÙƒÙ„ÙŠØ© Ù„ÙƒÙ„ Ø§Ù„ØµÙØ­Ø§Øª',0),(232914,6470,'fr','Totaux gÃ©nÃ©raux pour toutes les Pages',0),(232915,6470,'jp','å…¨ãƒšãƒ¼ã‚¸ã?®å?ˆè¨ˆ',0),(232916,6470,'pt','Totais gerais para todas as pÃ¡ginas',0),(232917,6470,'ru','ÐžÐ±Ñ‰Ð¸Ðµ Ð¸Ñ‚Ð¾Ð³Ð¸ Ð´Ð»Ñ Ð²ÑÐµÑ… ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†',0),(232918,6470,'es','Grandes Totales para Todas las PÃ¡ginas',0),(232919,6470,'de','Das Gesamtergebnis fÃ¼r alle Seiten',0),(232920,6470,'en','Grand Totals for All Pages',0),(232921,6471,'is','',0),(232922,6471,'dr','Ù…Ø¨Ø§Ù„Øº ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØµÙØ­Ù‡',0),(232923,6471,'pr','Ù…Ø¨Ø§Ù„Øº ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØµÙØ­Ù‡',0),(232924,6471,'tr','Bu sayfa iÃ§in genel toplam',0),(232925,6471,'pl','Sumy na tej stronie',0),(232926,6471,'bg','ÐžÐ±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(232927,6471,'ur','Ø§Ø³ ØµÙØ­Û Ú©Û’ Ù„ÛŒÛ’ Ú¯Ø±ÛŒÙ†Úˆ Ù…ÛŒØ²Ø§Ù†',0),(232928,6471,'sr','Ð¡Ð²ÐµÑƒÐºÑƒÐ¿Ð½Ð¸Ñ… Ð·Ð° Ð¾Ð²Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(232929,6471,'vi','Tá»•ng cá»™ng cho trang nÃ y',0),(232930,6471,'af','Groot Totale vir Hierdie Blad',0),(232931,6471,'ro','Totaluri pentru aceastÄƒ paginÄƒ',0),(232932,6471,'et','Selle lehe Ã¼ldkokkuvÃµtted',0),(232933,6471,'si','Vsote za to stran',0),(232934,6471,'ba','Grand total untuk Halaman ini',0),(232935,6471,'nl','Eindtotalen voor deze pagina',0),(232936,6471,'fi','Loppusummien sivua',0),(232937,6471,'no','Totalsummer for denne siden',0),(232938,6471,'da','Hovedtotaler for denne side',0),(232939,6471,'ko','ì´ íŽ˜ì´ì§€ì— ëŒ€ í•œ ì´í•©ê³„',0),(232940,6471,'he','×¡×›×•×ž×™× ×›×•×œ×œ×™× ×¢×‘×•×¨ ×“×£ ×–×”',0),(232941,6471,'el','Î‘Î¸ÏÎ¿Î¯ÏƒÎ¼Î±Ï„Î± Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ»Î¯Î´Î±',0),(232942,6471,'zh','æ€»è®¡æ­¤é¡µ\r\n',0),(232943,6471,'sv','Totalsummor fÃ¶r denna sida',0),(232944,6471,'it','Totali complessivi per questa pagina',0),(232945,6471,'tl','',0),(232946,6471,'th','&#3618;&#3629;&#3604;&#3648;&#3591;&#3636;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3627;&#3609;&#3657;&#3634;&#3609;&#3637;&#3657;',0),(232947,6471,'hi','à¤‡à¤¸ à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¹à¤¾à¤¯à¥‹à¤—',0),(232948,6471,'ms','Grand jumlah bagi Laman ini',0),(232949,6471,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹ Ø§Ù„ÙƒÙ„ÙŠØ© Ù„Ù‡Ø°Ù‡ Ø§Ù„ØµÙØ­Ø©',0),(232950,6471,'fr','Totaux gÃ©nÃ©raux pour cette Page',0),(232951,6471,'jp','ã?“ã?®ãƒšãƒ¼ã‚¸ã?®å?ˆè¨ˆ',0),(232952,6471,'pt','Totais gerais para esta pÃ¡gina',0),(232953,6471,'ru','ÐžÐ±Ñ‰Ð¸Ðµ Ð¸Ñ‚Ð¾Ð³Ð¸ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹',0),(232954,6471,'es','Grandes Totales para Esta PÃ¡gina',0),(232955,6471,'de','Gesamtergebnisse fÃ¼r diese Seite',0),(232956,6471,'en','Grand Totals for This Page',0),(232957,6472,'is','',0),(232958,6472,'dr','Ú¯Ø±ÙˆÙ‡ÙŠ ',0),(232959,6472,'pr','Ú¯Ø±ÙˆÙ‡ÙŠ ',0),(232960,6472,'tr','Grupta',0),(232961,6472,'pl','W grupie',0),(232962,6472,'bg','Ð’ Ð³Ñ€ÑƒÐ¿Ð°',0),(232963,6472,'ur','Ú¯Ø±ÙˆÙ¾ Ù…ÛŒÚº',0),(232964,6472,'sr','Ð£ Ð³Ñ€ÑƒÐ¿Ð¸',0),(232965,6472,'vi','Trong nhÃ³m',0),(232966,6472,'af','In Groep',0),(232967,6472,'ro','ÃŽn Grupa',0),(232968,6472,'et','RÃ¼hmas',0),(232969,6472,'si','V skupini',0),(232970,6472,'ba','Dalam kelompok',0),(232971,6472,'nl','In groep',0),(232972,6472,'fi','RyhmÃ¤ssÃ¤',0),(232973,6472,'no','I gruppen',0),(232974,6472,'da','I gruppen',0),(232975,6472,'ko','ê·¸ë£¹ì—ì„œ',0),(232976,6472,'he','×‘×§×‘×•×¦×”',0),(232977,6472,'el','Î£Ï„Î·Î½ Î¿Î¼Î¬Î´Î±',0),(232978,6472,'zh','åœ¨ç»„å†…\r\n',0),(232979,6472,'sv','I grupp',0),(232980,6472,'it','Nel gruppo',0),(232981,6472,'tl','',0),(232982,6472,'th','&#3651;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(232983,6472,'hi','à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚',0),(232984,6472,'ms','Dalam Kumpulan',0),(232985,6472,'ar','ÙÙŠ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(232986,6472,'fr','Dans le groupe',0),(232987,6472,'jp','ã‚°ãƒ«ãƒ¼ãƒ—',0),(232988,6472,'pt','Em grupo',0),(232989,6472,'ru','Ð’ Ð³Ñ€ÑƒÐ¿Ð¿Ðµ',0),(232990,6472,'es','En Grupo',0),(232991,6472,'de','In Gruppe',0),(232992,6472,'en','In Group',0),(232993,6473,'is','',0),(232994,6473,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… ØµÙØ­Ø§Øª ',0),(232995,6473,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… ØµÙØ­Ø§Øª ',0),(232996,6473,'tr','TÃ¼m sayfalar iÃ§in toplamlarÄ±',0),(232997,6473,'pl','Sumy dla wszystkich stron',0),(232998,6473,'bg','ÐžÐ±Ñ‰Ð¸Ñ‚Ðµ ÑÑƒÐ¼Ð¸ Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(232999,6473,'ur','ØªÙ…Ø§Ù… ØµÙØ­Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ù…ÛŒØ²Ø§Ù†',0),(233000,6473,'sr','Ð£ÐºÑƒÐ¿Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° ÑÐ²Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(233001,6473,'vi','Tá»•ng cá»™ng cho táº¥t cáº£ cÃ¡c trang',0),(233002,6473,'af','Totale vir alle bladsye',0),(233003,6473,'ro','Totaluri pentru toate paginile',0),(233004,6473,'et','KokkuvÃµtted kÃµik lehekÃ¼ljed',0),(233005,6473,'si','Vsote za vse strani',0),(233006,6473,'ba','Total untuk semua halaman',0),(233007,6473,'nl','Totalen voor alle pagina \'s',0),(233008,6473,'fi','Kokonaissummat kaikki sivut',0),(233009,6473,'no','Totalene for alle sider',0),(233010,6473,'da','Totalerne for alle sider',0),(233011,6473,'ko','ëª¨ë“  íŽ˜ì´ì§€ì— ëŒ€ í•œ',0),(233012,6473,'he','×¡×›×•×ž×™× ×›×•×œ×œ×™× ×¢×‘×•×¨ ×›×œ ×”×“×¤×™×',0),(233013,6473,'el','Î£ÏÎ½Î¿Î»Î± Î³Î¹Î± ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚',0),(233014,6473,'zh','æ€»è®¡æ‰€æœ‰ç½‘é¡µ\r\n',0),(233015,6473,'sv','Summorna fÃ¶r alla sidor',0),(233016,6473,'it','Totali per tutte le pagine',0),(233017,6473,'tl','',0),(233018,6473,'th','&#3627;&#3609;&#3657;&#3634;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(233019,6473,'hi','à¤¸à¤­à¥€ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‹à¤—',0),(233020,6473,'ms','Jumlah untuk semua halaman',0),(233021,6473,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ù„ÙƒÙ„ Ø§Ù„ØµÙØ­Ø§Øª',0),(233022,6473,'fr','Totaux pour toutes les Pages',0),(233023,6473,'jp','å…¨ãƒšãƒ¼ã‚¸ã?®å?ˆè¨ˆ',0),(233024,6473,'pt','Totais de todas as pÃ¡ginas',0),(233025,6473,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ Ð´Ð»Ñ Ð²ÑÐµÑ… ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†',0),(233026,6473,'es','Totales para Todas las PÃ¡ginas',0),(233027,6473,'de','Summen fÃ¼r alle Seiten',0),(233028,6473,'en','Totals for All Pages',0),(233029,6474,'is','',0),(233030,6474,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØµÙØ­Ù‡',0),(233031,6474,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ØµÙØ­Ù‡',0),(233032,6474,'tr','Bu sayfa iÃ§in toplamlarÄ±',0),(233033,6474,'pl','Sumy na tej stronie',0),(233034,6474,'bg','Ð¡ÑƒÐ¼Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(233035,6474,'ur','Ø§Ø³ ØµÙØ­Û Ú©Û’ Ù„ÛŒÛ’ Ù…ÛŒØ²Ø§Ù†',0),(233036,6474,'sr','Ð—Ð±Ð¸Ñ€Ð¾Ð²Ð¸ Ð·Ð° Ð¾Ð²Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(233037,6474,'vi','Tá»•ng cá»™ng cho trang nÃ y',0),(233038,6474,'af','Totale vir hierdie bladsy',0),(233039,6474,'ro','Totaluri pentru aceastÄƒ paginÄƒ',0),(233040,6474,'et','Selle lehe kokkuvÃµtteid',0),(233041,6474,'si','Vsote za to stran',0),(233042,6474,'ba','Total untuk Halaman ini',0),(233043,6474,'nl','Totalen voor deze pagina',0),(233044,6474,'fi','Kokonaissummat sivua',0),(233045,6474,'no','Totalene for denne siden',0),(233046,6474,'da','Totaler for denne side',0),(233047,6474,'ko','ì´ íŽ˜ì´ì§€ì— ëŒ€ í•œ',0),(233048,6474,'he','×¡×›×•×ž×™× ×¢×‘×•×¨ ×“×£ ×–×”',0),(233049,6474,'el','Î£ÏÎ½Î¿Î»Î± Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ»Î¯Î´Î±',0),(233050,6474,'zh','æ€»è®¡æ­¤é¡µ\r\n',0),(233051,6474,'sv','Summor fÃ¶r denna sida',0),(233052,6474,'it','Totali per questa pagina',0),(233053,6474,'tl','',0),(233054,6474,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3627;&#3609;&#3657;&#3634;&#3609;&#3637;&#3657;',0),(233055,6474,'hi','à¤‡à¤¸ à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‹à¤—',0),(233056,6474,'ms','Jumlah bagi Laman ini',0),(233057,6474,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ù„Ù‡Ø°Ù‡ Ø§Ù„ØµÙØ­Ø©',0),(233058,6474,'fr','Totaux pour cette page',0),(233059,6474,'jp','ã?“ã?®ãƒšãƒ¼ã‚¸ã?®å?ˆè¨ˆ',0),(233060,6474,'pt','Totais para esta pÃ¡gina',0),(233061,6474,'ru','ÐŸÐ¾Ð´Ñ‹Ñ‚Ð¾Ð³ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹',0),(233062,6474,'es','Totales para Esta pÃ¡gina',0),(233063,6474,'de','Gesamtwerte fÃ¼r diese Seite',0),(233064,6474,'en','Totals for This page',0),(233065,6475,'is','',0),(233066,6475,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÙŠÚ©Ù‰ Ø¯Ø§Ø±Ø§Ø¦Ù‰ ÙŠØ§ Ø¶Ù…ÙŠÙ…Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª â€“Ù†Ù‡ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ú†Ùƒ',0),(233067,6475,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÙŠÚ©Ù‰ Ø¯Ø§Ø±Ø§Ø¦Ù‰ ÙŠØ§ Ø¶Ù…ÙŠÙ…Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª â€“Ù†Ù‡ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ú†Ùƒ',0),(233068,6475,'tr','EFT ya da Ã¶deme ACH--A onay',0),(233069,6475,'pl','EFT lub pÅ‚atnoÅ›ci ACH--nie sprawdziÄ‡',0),(233070,6475,'bg','Ð•ÐŸÐ¡ Ð¸Ð»Ð¸ ACH Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ--Ð½Ðµ ÐŸÐ ÐžÐ’Ð•Ð Ð¯Ð’Ð',0),(233071,6475,'ur','EFT ÛŒØ§ Ø§Ú† Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ â€“ Ù†ÛÛŒÚº Ø§ÛŒÚ© Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(233072,6475,'sr','Ð•Ð¤Ð¢ Ð¸Ð»Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° ÐÑ…--Ð½Ðµ ÐŸÐ ÐžÐ’Ð•Ð ÐÐ’Ð Ð',0),(233073,6475,'vi','THANH TOÃN QUA ACH HAY EFT -- KHÃ”NG PHáº¢I SÃ‰C',0),(233074,6475,'af','EFT of ACH betaling - A kontroleer nie',0),(233075,6475,'ro','EFT sau plata ACH--nu A verifica',0),(233076,6475,'et','EFT vÃµi ACH tasumise--A MÃ„RKIMATA',0),(233077,6475,'si','EFT ali plaÄilne ACH--ne ÄŒEK',0),(233078,6475,'ba','TDE atau pembayaran ACH--tidak memeriksa',0),(233079,6475,'nl','EFT- of ACH betaling--NOT A CHECK',0),(233080,6475,'fi','EFT tai ACH maksu--ei tarkista',0),(233081,6475,'no','EFT eller ACH betaling - ikke en sjekk',0),(233082,6475,'da','ACH betaling--ikke en CHECK eller elektronisk PENGEOVERFÃ˜RSEL',0),(233083,6475,'ko','ì „ìž ì†¡ê¸ˆ ë˜ëŠ” ACH ì§€ë¶ˆ-A í™•ì¸ í•˜ì§€',0),(233084,6475,'he','EFT ××• ×ª×©×œ×•× ACH--A ×‘×•×“×§',0),(233085,6475,'el','EFT Î® Ï€Î»Î·ÏÏ‰Î¼Î® Î‘Î“Î£--A Î•Î›ÎˆÎ“Î§Î•Î™',0),(233086,6475,'zh','ç”µæ±‡æˆ–è‡ªåŠ¨äº¤æ˜“æ‰€çš„ä»˜æ¬¾æ–¹å¼ -ä¸æ˜¯æ”¯ç¥¨\r\n',0),(233087,6475,'sv','EFT eller ACH betalning--inte A kolla',0),(233088,6475,'it','EFT o pagamento ACH - non A controllare',0),(233089,6475,'tl','',0),(233090,6475,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3649;&#3610;&#3610; EFT or ACH -- &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3592;&#3656;&#3634;&#3618;&#3648;&#3611;&#3655;&#3609;&#3648;&#3594;&#3655;&#',0),(233091,6475,'hi','à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤¯à¤¾ ACH à¤­à¥à¤—à¤¤à¤¾à¤¨ - A à¤•à¥€ à¤œà¤¾à¤‚à¤š à¤¨à¤¹à¥€à¤‚',0),(233092,6475,'ms','EFT atau bayaran men--tidak A menyemak',0),(233093,6475,'ar','ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø£Ù…ÙˆØ§Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø£Ùˆ Ø§Ù„Ø¯ÙØ¹ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹-Ù„Ø§ ØªØ­Ù‚Ù‚ A',0),(233094,6475,'fr','EFT ou ACH paiement--pas A vÃ©rifier',0),(233095,6475,'jp','ï¼¥ï¼¦ï¼´ã?‹ï¼¡ï¼£ï¼¨æ”¯æ‰•ã?„ãƒ¼å°?åˆ‡æ‰‹ã?§ã?¯ã?ªã?„',0),(233096,6475,'pt','EFT ou pagamento de ACH..--nÃ£o A verificar',0),(233097,6475,'ru','EFT Ð¸Ð»Ð¸ ACH Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹--Ð½Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÑ‚ÑŒ',0),(233098,6475,'es','EFT o ACH PAGO -- NO ES CHEQUE',0),(233099,6475,'de','EFT oder ACH Zahlung--A nicht Ã¼berprÃ¼fen',0),(233100,6475,'en','EFT or ACH PAYMENT -- NOT A CHECK',0),(233101,6476,'is','',0),(233102,6476,'dr','**ÙŠÙƒ Ú†Ùƒ Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª **',0),(233103,6476,'pr','**ÙŠÙƒ Ú†Ùƒ Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª **',0),(233104,6476,'tr','** DEÄžÄ°L BÄ°R GEÃ‡ERLÄ° ONAY **',0),(233105,6476,'pl','** NIE PRAWIDÅOWEGO WYBORU **',0),(233106,6476,'bg','** ÐÐ• Ð’ÐÐ›Ð˜Ð”Ð•Ð ÐŸÐ ÐžÐ’Ð•Ð ÐšÐ **',0),(233107,6476,'ur','* * Ù†ÛÛŒÚº Ø§ÛŒÚ© Ø¬Ø§Ø¦Ø² Ú†ÛŒÚ© Ú©Ø±ÛŒÚº * * *',0),(233108,6476,'sr','** ÐÐ• ÐÐ Ð’ÐÐ–Ð•Ð‹Ð£ ÐŸÐžÐ¢Ð’Ð Ð”Ð£ **',0),(233109,6476,'vi','**KHÃ”NG PHáº¢I SÃ‰C CÃ“ HIá»†U Lá»°C**',0),(233110,6476,'af','**NIE \'n GELDIGE TJEK**',0),(233111,6476,'ro','** NU UN VALID CHECK **',0),(233112,6476,'et','** EI OMA KEHTIVAT SISSE **',0),(233113,6476,'si','** NE A VELJAVEN POTRDITE **',0),(233114,6476,'ba','** TIDAK SAH CHECK **',0),(233115,6476,'nl','** NIET EEN GELDIGE SELECTIEVAKJE **',0),(233116,6476,'fi','** EI VOIMASSA ULOSKIRJAUTUMINEN **',0),(233117,6476,'no','** IKKE EN GYLDIG SJEKK **',0),(233118,6476,'da','** IKKE EN GYLDIG CHECK **',0),(233119,6476,'ko','* * í•˜ì§€ëŠ” ìœ íš¨í•œ í™•ì¸ * *',0),(233120,6476,'he','* * ×œ× ×—×•×§×™ ×”×¡×™×ž×•×Ÿ * *',0),(233121,6476,'el','** Î”Î•Î ÎœÎ™Î‘ ÎˆÎ“ÎšÎ¥Î¡Î— Î•Î›ÎˆÎ“Î§ÎŸÎ¥ **',0),(233122,6476,'zh','**ä¸æ˜¯ä¸€ä¸ªæœ‰æ•ˆçš„æ”¯ç¥¨**\r\n',0),(233123,6476,'sv','** INTE EN GILTIG CHECK **',0),(233124,6476,'it','* * NON UN VALIDO CONTROLLO * *',0),(233125,6476,'tl','',0),(233126,6476,'th','**NOT A VALID CHECK**',0),(233127,6476,'hi','* * à¤¨à¤¹à¥€à¤‚ à¤à¤• à¤®à¤¾à¤¨à¥à¤¯ à¤šà¥‡à¤• * *',0),(233128,6476,'ms','** TIDAK YANG SAH DAFTAR **',0),(233129,6476,'ar','* * Ù„Ø§ ØµØ§Ù„Ø­ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± * *',0),(233130,6476,'fr','** PAS UN CHÃˆQUE VALIDE **',0),(233131,6476,'jp','**æœ‰åŠ¹ã?ªå°?åˆ‡æ‰‹ã?§ã?¯ã?‚ã‚Šã?¾ã?›ã‚“**',0),(233132,6476,'pt','* * NÃƒO UM CHEQUE VÃLIDO *',0),(233133,6476,'ru','** ÐÐ• Ð”Ð•Ð™Ð¡Ð¢Ð’Ð£Ð•Ð¢ CHECK **',0),(233134,6476,'es','**NO ES CHEQUE VÃLIDO**',0),(233135,6476,'de','** KEINE GÃœLTIGE PRÃœFUNG **',0),(233136,6476,'en','**NOT A VALID CHECK**',0),(233137,6477,'is','',0),(233138,6477,'dr','Ø²Ù…Ø§Ù† Ø´Ø±ÙˆØ¹',0),(233139,6477,'pr','Ø²Ù…Ø§Ù† Ø´Ø±ÙˆØ¹',0),(233140,6477,'tr','BaÅŸlama zamanÄ±',0),(233141,6477,'pl','Czas zaczÄ…Ä‡',0),(233142,6477,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾',0),(233143,6477,'ur','ÙˆÙ‚Øª Ø¢ØºØ§Ø²',0),(233144,6477,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(233145,6477,'vi','Thá»i gian báº¯t Ä‘áº§u',0),(233146,6477,'af','Aanvangstyd',0),(233147,6477,'ro','ÃŽncepe timp',0),(233148,6477,'et','Algab aeg',0),(233149,6477,'si','ZaÄetni Äas',0),(233150,6477,'ba','Waktu mulai',0),(233151,6477,'nl','Begin tijd',0),(233152,6477,'fi','Alkamisaika',0),(233153,6477,'no','Starttiden',0),(233154,6477,'da','Begynde tid',0),(233155,6477,'ko','ì‹œìž‘ ì‹œê°„',0),(233156,6477,'he','×–×ž×Ÿ ×”×ª×—×œ×”',0),(233157,6477,'el','ÎÏÎ±Ï‚ Î­Î½Î±ÏÎ¾Î·Ï‚',0),(233158,6477,'zh','å¼€å§‹æ—¶é—´\r\n',0),(233159,6477,'sv','Starttid',0),(233160,6477,'it','Tempo di iniziare',0),(233161,6477,'tl','',0),(233162,6477,'th','&#3648;&#3623;&#3621;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(233163,6477,'hi','à¤¸à¤®à¤¯ à¤¶à¥à¤°à¥‚',0),(233164,6477,'ms','Mula masa',0),(233165,6477,'ar','ÙˆÙ‚Øª Ø§Ù„Ø¨Ø¯Ø¡',0),(233166,6477,'fr','Heure de dÃ©but',0),(233167,6477,'jp','é–‹å§‹æ™‚é–“',0),(233168,6477,'pt','Tempo inicial',0),(233169,6477,'ru','Ð’Ñ€ÐµÐ¼Ñ ÐÐ°Ñ‡Ð°Ð»Ð°',0),(233170,6477,'es','Tiempo de Inicio',0),(233171,6477,'de','Anfangszeit',0),(233172,6477,'en','Begin Time',0),(233173,6478,'is','',0),(233174,6478,'dr','Ø²Ù…Ø§Ù† Ù¾Ø§ÙŠØ§Ù†  ',0),(233175,6478,'pr','Ø²Ù…Ø§Ù† Ù¾Ø§ÙŠØ§Ù†  ',0),(233176,6478,'tr','BitiÅŸ saati',0),(233177,6478,'pl','Czas zakoÅ„czenia',0),(233178,6478,'bg','ÐšÑ€Ð°ÐµÐ½ Ñ‡Ð°Ñ',0),(233179,6478,'ur','Ø¹Ø±ØµÛ Ø§Ø®ØªØªØ§Ù…',0),(233180,6478,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(233181,6478,'vi','Thá»i gian káº¿t thÃºc',0),(233182,6478,'af','End Tyd',0),(233183,6478,'ro','Ora de terminare',0),(233184,6478,'et','LÃµpuaeg',0),(233185,6478,'si','KonÄni Äas',0),(233186,6478,'ba','Akhir zaman',0),(233187,6478,'nl','Eindtijd',0),(233188,6478,'fi','PÃ¤Ã¤ttymisaika',0),(233189,6478,'no','Sluttidspunkt',0),(233190,6478,'da','Sluttid',0),(233191,6478,'ko','ì¢…ë£Œ ì‹œê°„',0),(233192,6478,'he','×–×ž×Ÿ ×¡×™×•×',0),(233193,6478,'el','ÎÏÎ± Î»Î®Î¾Î·Ï‚',0),(233194,6478,'zh','ç»“æŸæ—¶é—´',0),(233195,6478,'sv','Sluttid',0),(233196,6478,'it','Ora di fine',0),(233197,6478,'tl','',0),(233198,6478,'th','&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(233199,6478,'hi','à¤…à¤‚à¤¤ à¤¸à¤®à¤¯',0),(233200,6478,'ms','Masa tamat',0),(233201,6478,'ar','ÙˆÙ‚Øª Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(233202,6478,'fr','Heure de fin',0),(233203,6478,'jp','çµ‚äº†æ™‚é–“',0),(233204,6478,'pt','Tempo do fim',0),(233205,6478,'ru','Ð’Ñ€ÐµÐ¼Ñ ÐžÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(233206,6478,'es','Tiempo Final',0),(233207,6478,'de','Endzeit',0),(233208,6478,'en','End Time',0),(233209,6479,'is','',0),(233210,6479,'dr','Ø­Ø¯Ø§Ù‚Ù„',0),(233211,6479,'pr','Ø­Ø¯Ø§Ù‚Ù„',0),(233212,6479,'tr','Dk:',0),(233213,6479,'pl','Min:',0),(233214,6479,'bg','ÐœÐ¸Ð½:',0),(233215,6479,'ur','Ú©Ù… Ø§Ø² Ú©Ù… ÛÛ’ Û”',0),(233216,6479,'sr','ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼:',0),(233217,6479,'vi','Tá»‘i thiá»ƒu',0),(233218,6479,'af','Min:',0),(233219,6479,'ro','Min:',0),(233220,6479,'et','Min:',0),(233221,6479,'si','Min:',0),(233222,6479,'ba','Min:',0),(233223,6479,'nl','Min:',0),(233224,6479,'fi','Min:',0),(233225,6479,'no','Min:',0),(233226,6479,'da','Min:',0),(233227,6479,'ko','ë¶„ìž…ë‹ˆë‹¤.',0),(233228,6479,'he','Min:',0),(233229,6479,'el','Min:',0),(233230,6479,'zh','æœ€å°',0),(233231,6479,'sv','Min:',0),(233232,6479,'it','Min:',0),(233233,6479,'tl','',0),(233234,6479,'th','&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(233235,6479,'hi','à¤®à¤¿à¤¨à¥¤',0),(233236,6479,'ms','Min:',0),(233237,6479,'ar','Ø¯Ù‚ÙŠÙ‚Ø©.',0),(233238,6479,'fr','Min:',0),(233239,6479,'jp','æœ€å°?',0),(233240,6479,'pt','Min:',0),(233241,6479,'ru','ÐœÐ¸Ð½.',0),(233242,6479,'es','Min:',0),(233243,6479,'de','Min:',0),(233244,6479,'en','Min:',0),(233245,6480,'is','',0),(233246,6480,'dr','/ Ø§ØµÙ„Ø§Ø­  ÛŒÙˆØ²Ø± Ø¯ÙŠÚ¯Ø±',0),(233247,6480,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø±Ø¨Ø± Ø¯ÙŠÚ¯Ø±',0),(233248,6480,'tr','BaÅŸka bir kullanÄ±cÄ± Ekle/DÃ¼zenle',0),(233249,6480,'pl','Dodawanie/edycja innego uÅ¼ytkownika',0),(233250,6480,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(233251,6480,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/Ú©Ø³ÛŒ Ø§ÙˆØ± ØµØ§Ø±Ù ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(233252,6480,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð´Ñ€ÑƒÐ³Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(233253,6480,'vi','ThÃªm/Sá»­a NgÆ°á»i Sá»­ Dá»¥ng KhÃ¡c',0),(233254,6480,'af','Gebruiker Byvoeg/Redigeer',0),(233255,6480,'ro','Adauga/Modifica alt utilizator',0),(233256,6480,'et','Lisa/Muuda uus kasutaja',0),(233257,6480,'si','Dodaj/Uredi drug uporabnik',0),(233258,6480,'ba','Menambah/mengedit pengguna lain',0),(233259,6480,'nl','Een andere gebruiker toevoegen/bewerken',0),(233260,6480,'fi','LisÃ¤Ã¤ tai Muokkaa toinen kÃ¤yttÃ¤jÃ¤',0),(233261,6480,'no','Legge til eller redigere en annen bruker',0),(233262,6480,'da','TilfÃ¸je eller redigere en anden bruger',0),(233263,6480,'ko','ë‹¤ë¥¸ ì‚¬ìš©ìžë¥¼ ì¶”ê°€/íŽ¸ì§‘',0),(233264,6480,'he','×”×•×¡×£/×¢×¨×•×š ×ž×©×ª×ž×© × ×•×¡×£',0),(233265,6480,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÎ½ÏŒÏ‚ Î¬Î»Î»Î¿Ï… Ï‡ÏÎ®ÏƒÏ„Î·',0),(233266,6480,'zh','å¢žåŠ /ç¼–è¾‘å…¶ä»–ç”¨æˆ·\r\n',0),(233267,6480,'sv','LÃ¤gg till/redigera en annan anvÃ¤ndare',0),(233268,6480,'it','Aggiungere o modificare un altro utente',0),(233269,6480,'tl','',0),(233270,6480,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3629;&#3639;&#3656;&#3609;',0),(233271,6480,'hi','à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(233272,6480,'ms','Tambah/Edit pengguna lain',0),(233273,6480,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ù…Ø³ØªØ®Ø¯Ù… Ø¢Ø®Ø±',0),(233274,6480,'fr','Ajouter/Modifier un Autre UsagÃ©',0),(233275,6480,'jp','ä»–ã?®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®è¿½åŠ /ç·¨é›†',0),(233276,6480,'pt','Adicionar/editar outro usuÃ¡rio',0),(233277,6480,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð³Ð¾ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(233278,6480,'es','Agregar/Editar Otro Usuario',0),(233279,6480,'de','Ein anderer Benutzer hinzufÃ¼gen/bearbeiten',0),(233280,6480,'en','Add/Edit Another User',0),(233281,6481,'is','',0),(233282,6481,'dr','Ù…Ø¬Ø§Ø² Ù†ÙŠØ³Øª ',0),(233283,6481,'pr','Ù…Ø¬Ø§Ø² Ù†ÙŠØ³Øª ',0),(233284,6481,'tr','Yetkili deÄŸil',0),(233285,6481,'pl','Nie dozwolone',0),(233286,6481,'bg','ÐÐµ ÑÐ° Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸',0),(233287,6481,'ur','Ù…Ø¬Ø§Ø² Ù†ÛÛŒÚº',0),(233288,6481,'sr','ÐÐ¸Ñ˜Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¾',0),(233289,6481,'vi','KhÃ´ng cÃ³ quyá»n',0),(233290,6481,'af','Nie Gemagtig',0),(233291,6481,'ro','Nu sunt autorizate',0),(233292,6481,'et','Ei ole lubatud',0),(233293,6481,'si','Ne dovoli',0),(233294,6481,'ba','Tidak diizinkan',0),(233295,6481,'nl','Niet toegestaan',0),(233296,6481,'fi','Ei saa',0),(233297,6481,'no','Ikke godkjent',0),(233298,6481,'da','Ikke godkendt',0),(233299,6481,'ko','ê¶Œí•œì´ ì—†ìŠµë‹ˆë‹¤.',0),(233300,6481,'he','×œ× ×ž×•×¨×©×”',0),(233301,6481,'el','Î”ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(233302,6481,'zh','æœªç»æŽˆæƒ\r\n',0),(233303,6481,'sv','Inte auktoriserad',0),(233304,6481,'it','Non autorizzato',0),(233305,6481,'tl','',0),(233306,6481,'th','&#3652;&#3617;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(233307,6481,'hi','à¤…à¤§à¤¿à¤•à¥ƒà¤¤ à¤¨à¤¹à¥€à¤‚',0),(233308,6481,'ms','Tidak dibenarkan',0),(233309,6481,'ar','ØºÙŠØ± Ù…Ø®ÙˆÙ‘Ù„',0),(233310,6481,'fr','Non autorisÃ©',0),(233311,6481,'jp','æ‰¿èª?ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(233312,6481,'pt','NÃ£o autorizado',0),(233313,6481,'ru','ÐÐµ Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾',0),(233314,6481,'es','No Autorizado',0),(233315,6481,'de','Nicht autorisierte',0),(233316,6481,'en','Not Authorized',0),(233317,6482,'is','',0),(233318,6482,'dr','ØªØ§ÙŠÙŠØ¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(233319,6482,'pr','ØªØ§ÙŠÙŠØ¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(233320,6482,'tr','Ã–n onayÄ±',0),(233321,6482,'pl','Potwierdzenie wstÄ™pnego',0),(233322,6482,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(233323,6482,'ur','Ù¾Ø±ÛŒ Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚',0),(233324,6482,'sr','ÐŸÑ€ÐµÐ´-Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð°',0),(233325,6482,'vi','XÃ¡c nháº­n trÆ°á»›c',0),(233326,6482,'af','Pre-bevestiging',0),(233327,6482,'ro','Pre-confirmare',0),(233328,6482,'et','Eelnev kinnitamine',0),(233329,6482,'si','Pre-potrditev',0),(233330,6482,'ba','Pra-konfirmasi',0),(233331,6482,'nl','Pre bevestiging',0),(233332,6482,'fi','Ennen vahvistusta',0),(233333,6482,'no','FÃ¸r bekreftelse',0),(233334,6482,'da','FÃ¸r bekrÃ¦ftelse',0),(233335,6482,'ko','ì‚¬ì „ í™•ì¸',0),(233336,6482,'he','××™×©×•×¨ ×ž×¨××©',0),(233337,6482,'el','Î ÏÎ¿-ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·',0),(233338,6482,'zh','å‰ç¡®è®¤\r\n',0),(233339,6482,'sv','FÃ¶re bekrÃ¤ftelse',0),(233340,6482,'it','Pre-conferma',0),(233341,6482,'tl','',0),(233342,6482,'th','&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(233343,6482,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£',0),(233344,6482,'ms','Sebelum pengesahan',0),(233345,6482,'ar','ØªØ£ÙƒÙŠØ¯ Ù…Ø§ Ù‚Ø¨Ù„',0),(233346,6482,'fr','PrÃ©-confirmation',0),(233347,6482,'jp','äº‹å‰?ç¢ºèª?',0),(233348,6482,'pt','PrÃ©-confirmaÃ§Ã£o',0),(233349,6482,'ru','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(233350,6482,'es','Pre-ConfirmaciÃ³n',0),(233351,6482,'de','Vor BestÃ¤tigung',0),(233352,6482,'en','Pre-Confirmation',0),(233353,6483,'is','',0),(233354,6483,'dr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(233355,6483,'pr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(233356,6483,'tr','EÅŸleÅŸen hiÃ§bir alÄ±mlarÄ± bulundu',0),(233357,6483,'pl','Nie pasujÄ…ce zakupy Znalezione',0),(233358,6483,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(233359,6483,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø³ÙˆØ¯ÙˆÚº Ù¾Ø§ÛŒØ§',0),(233360,6483,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð½Ð°Ð±Ð°Ð²ÐºÐ¸ Ð½Ð°ÑˆÐ°Ð¾',0),(233361,6483,'vi','KhÃ´ng tÃ¬m tháº¥y mua hÃ ng phÃ¹ há»£p',0),(233362,6483,'af','Geen Soorgelyke Aankope Gevind',0),(233363,6483,'ro','Nicio potrivire achiziÅ£ii gÄƒsit',0),(233364,6483,'et','Ei leidnud vastavaid ostud',0),(233365,6483,'si','Brez ujemanja nakupi naÅ¡el',0),(233366,6483,'ba','Pembelian tidak cocok ditemukan',0),(233367,6483,'nl','Geen overeenkomende aankopen gevonden',0),(233368,6483,'fi','MitÃ¤Ã¤n vastaavia ostaa lÃ¶ytyi',0),(233369,6483,'no','Ingen samsvarende KjÃ¸p funnet',0),(233370,6483,'da','Ingen matchende KÃ¸b fundet',0),(233371,6483,'ko','ë°œê²¬ ì—†ìŒ ì¼ì¹˜ êµ¬ë§¤',0),(233372,6483,'he','×œ× × ×ž×¦××• ×¨×›×™×©×•×ª ×ª×•××ž×•×ª',0),(233373,6483,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Î±Î³Î¿ÏÎ­Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(233374,6483,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„é‡‡è´­\r\n',0),(233375,6483,'sv','Inga matchande inkÃ¶p hittade',0),(233376,6483,'it','Nessuna corrispondenza acquisti trovati',0),(233377,6483,'tl','',0),(233378,6483,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(233379,6483,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤–à¤°à¥€à¤¦ à¤ªà¤¾à¤¯à¤¾',0),(233380,6483,'ms','Pembelian tiada padanan ditemui',0),(233381,6483,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ø´ØªØ±ÙŠØ§Øª Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(233382,6483,'fr','Aucun achat correspondant trouvÃ©',0),(233383,6483,'jp','ä¸€è‡´ã?™ã‚‹è³¼è²·ç‰©ã?Œã?¿ã?¤ã?‹ã‚Šã?¾ã?›ã‚“ã?§ã?—ã?Ÿ',0),(233384,6483,'pt','Sem compras correspondentes encontradas',0),(233385,6483,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(233386,6483,'es','No se encontraron compras emparejadas',0),(233387,6483,'de','Keine passenden EinkÃ¤ufe gefunden',0),(233388,6483,'en','No Matching Purchases Found',0),(233389,6484,'is','',0),(233390,6484,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯ ',0),(233391,6484,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯ ',0),(233392,6484,'tr','SatÄ±n alma geÃ§miÅŸi',0),(233393,6484,'pl','Historia zakupÃ³w',0),(233394,6484,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(233395,6484,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(233396,6484,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(233397,6484,'vi','Lá»‹ch sá»­ mua',0),(233398,6484,'af','Aankoopgeskiedenis',0),(233399,6484,'ro','Istoricul achiziÅ£iilor',0),(233400,6484,'et','Ostude ajalugu',0),(233401,6484,'si','Zgodovina nakupa',0),(233402,6484,'ba','Sejarah pembelian',0),(233403,6484,'nl','Overzicht van vorige aankopen',0),(233404,6484,'fi','Aiemmat ostokset',0),(233405,6484,'no','KjÃ¸pshistorikk',0),(233406,6484,'da','KÃ¸b historie',0),(233407,6484,'ko','êµ¬ë§¤ ë‚´ì—­',0),(233408,6484,'he','×”×¡×˜×•×¨×™×™×ª ×¨×›×™×©×”',0),(233409,6484,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î±Î³Î¿ÏÏŽÎ½',0),(233410,6484,'zh','è´­ä¹°è®°å½•\r\n',0),(233411,6484,'sv','KÃ¶p historia',0),(233412,6484,'it','Cronologia acquisti',0),(233413,6484,'tl','',0),(233414,6484,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(233415,6484,'hi','à¤–à¤°à¥€à¤¦à¥€ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(233416,6484,'ms','Sejarah pembelian',0),(233417,6484,'ar','Ø­Ø±ÙƒØ© Ø§Ù„Ù…Ø´ØªØ±ÙŠØ§Øª',0),(233418,6484,'fr','Historique des achats',0),(233419,6484,'jp','è³¼è²·å±¥æ­´',0),(233420,6484,'pt','HistÃ³rico de compras',0),(233421,6484,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº',0),(233422,6484,'es','Historia de Compras',0),(233423,6484,'de','Erwerbsdatum',0),(233424,6484,'en','Purchase History',0),(233425,6485,'is','',0),(233426,6485,'dr','ÙŠØ§ ØªØ§Ø±ÙŠØ® Ø®Ø¯Ù…Ø§Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ø¯Ù‡  Ø§Ø³Øª ',0),(233427,6485,'pr','ÙŠØ§ ØªØ§Ø±ÙŠØ® Ø®Ø¯Ù…Ø§Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ø¯Ù‡  Ø§Ø³Øª ',0),(233428,6485,'tr','veya talep tarihi hizmeti',0),(233429,6485,'pl','lub Data Service, zgÅ‚oszony',0),(233430,6485,'bg','Ð¸Ð»Ð¸ Ð¸ÑÐºÐ°Ð½Ð°Ñ‚Ð° ÑƒÑÐ»ÑƒÐ³Ð° Ð¸ Ð´Ð°Ñ‚Ð°',0),(233431,6485,'ur','ÛŒØ§ Ø®Ø¯Ù…Øª Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(233432,6485,'sr','Ð¸Ð»Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ ÑÐµÑ€Ð²Ð¸ÑÐ° Ð·Ð°Ñ‚Ñ€Ð°Ð¶Ð¸Ð¾',0),(233433,6485,'vi','hay ngÃ y dá»‹ch vá»¥ yÃªu cáº§u',0),(233434,6485,'af','of Datum wat Diens Verlang Word',0),(233435,6485,'ro','sau data serviciul solicitat',0),(233436,6485,'et','vÃµi kuupÃ¤eva teenusest',0),(233437,6485,'si','ali zahtevano storitev datum',0),(233438,6485,'ba','atau tanggal layanan yang diminta',0),(233439,6485,'nl','of datum gevraagde dienst',0),(233440,6485,'fi','tai pyytÃ¤Ã¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(233441,6485,'no','eller datoen tjenesten forespurt',0),(233442,6485,'da','eller dato tjeneste anmodet om',0),(233443,6485,'ko','ë˜ëŠ” ì„œë¹„ìŠ¤ ìš”ì²­ ë‚ ì§œ',0),(233444,6485,'he','××• ×©×™×¨×•×ª ×”×ª××¨×™×š ×”×ž×‘×•×§×©',0),(233445,6485,'el','Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï…Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î¿Ï… Î¶Î·Ï„ÎµÎ¯Ï„Î±Î¹',0),(233446,6485,'zh','æˆ–æœ€æ–°çš„æœåŠ¡è¯·æ±‚\r\n',0),(233447,6485,'sv','eller datum begÃ¤rda tjÃ¤nsten',0),(233448,6485,'it','o data servizio richiesto',0),(233449,6485,'tl','',0),(233450,6485,'th','&#3627;&#3619;&#3639;&#3629;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(233451,6485,'hi','à¤¯à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¥‡à¤µà¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤•à¤¿à¤¯à¤¾',0),(233452,6485,'ms','atau perkhidmatan tarikh yang diminta',0),(233453,6485,'ar','Ø£Ùˆ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø®Ø¯Ù…Ø© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(233454,6485,'fr','ou Date Service demandÃ©',0),(233455,6485,'jp','ã‚‚ã?—ã??ã?¯ã‚µãƒ¼ãƒ“ã‚¹ãƒªã‚¯ã‚¨ã‚¹ãƒˆæ—¥',0),(233456,6485,'pt','ou serviÃ§o data solicitada',0),(233457,6485,'ru','Ð¸Ð»Ð¸ Ð”Ð°Ñ‚Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(233458,6485,'es','o Fecha en que SolicitÃ³ el Servicio',0),(233459,6485,'de','oder gewÃ¼nschten Datum-Dienst',0),(233460,6485,'en','or Date Service Requested',0),(233461,6486,'is','',0),(233462,6486,'dr','/ Ø§ØµÙ„Ø§Ø­  ÛŒÙˆØ²Ø±',0),(233463,6486,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø±Ø¨Ø±',0),(233464,6486,'tr','KullanÄ±cÄ± Ekle/DÃ¼zenle',0),(233465,6486,'pl','Dodawanie/edycja uÅ¼ytkownikÃ³w',0),(233466,6486,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(233467,6486,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØµØ§Ø±ÙÛŒÙ† ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(233468,6486,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(233469,6486,'vi','ThÃªm/Sá»­a NgÆ°á»i Sá»­ Dá»¥ng',0),(233470,6486,'af','Gebruikers Byvoeg/Redigeer',0),(233471,6486,'ro','Adauga/Modifica Utilizatori',0),(233472,6486,'et','Lisa/Muuda kasutajaid',0),(233473,6486,'si','Dodaj/Uredi uporabnikov',0),(233474,6486,'ba','Menambah/mengedit pengguna',0),(233475,6486,'nl','Gebruikers toevoegen/bewerken',0),(233476,6486,'fi','LisÃ¤Ã¤ tai Muokkaa kÃ¤yttÃ¤jiÃ¤',0),(233477,6486,'no','Legge til eller redigere brukere',0),(233478,6486,'da','TilfÃ¸j/Rediger brugere',0),(233479,6486,'ko','ì‚¬ìš©ìž ì¶”ê°€/íŽ¸ì§‘',0),(233480,6486,'he','×”×•×¡×£/×¢×¨×•×š ×ž×©×ª×ž×©×™×',0),(233481,6486,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(233482,6486,'zh','å¢žåŠ /ç¼–è¾‘ç”¨æˆ·\r\n',0),(233483,6486,'sv','LÃ¤gg till/Redigera anvÃ¤ndare',0),(233484,6486,'it','Aggiungere o modificare gli utenti',0),(233485,6486,'tl','',0),(233486,6486,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(233487,6486,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(233488,6486,'ms','Tambah/Edit pengguna',0),(233489,6486,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(233490,6486,'fr','Ajouter/Modifier UsagÃ©s',0),(233491,6486,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã?®è¿½åŠ /ç·¨é›†',0),(233492,6486,'pt','Adicionar/editar usuÃ¡rios',0),(233493,6486,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(233494,6486,'es','Agregar/Editar Usuarios',0),(233495,6486,'de','HinzufÃ¼gen/Bearbeiten von Benutzern',0),(233496,6486,'en','Add/Edit Users',0),(233497,6487,'is','',0),(233498,6487,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø®Ø¯Ù…Ø§Øª ',0),(233499,6487,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø®Ø¯Ù…Ø§Øª ',0),(233500,6487,'tr','Hizmet isteÄŸi',0),(233501,6487,'pl','Å»Ä…dania obsÅ‚ugi',0),(233502,6487,'bg','Ð—Ð°ÑÐ²ÐºÐ° Ð·Ð° ÑƒÑÐ»ÑƒÐ³Ð°',0),(233503,6487,'ur','Ø³Ø±ÙˆØ³ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(233504,6487,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° ÑƒÑÐ»ÑƒÐ³Ñƒ',0),(233505,6487,'vi','YÃªu cáº§u dá»‹ch vá»¥',0),(233506,6487,'af','Versoek Diens',0),(233507,6487,'ro','Cererea de servicii',0),(233508,6487,'et','Teenuse taotlus',0),(233509,6487,'si','Zahteva storitve',0),(233510,6487,'ba','Permintaan layanan',0),(233511,6487,'nl','Serviceaanvraag',0),(233512,6487,'fi','PalvelupyyntÃ¶',0),(233513,6487,'no','ForespÃ¸rsel om',0),(233514,6487,'da','Serviceanmodning',0),(233515,6487,'ko','ì„œë¹„ìŠ¤ ìš”ì²­',0),(233516,6487,'he','×”×¤× ×™×” ×œ×©×™×¨×•×ª:',0),(233517,6487,'el','Î‘Î¯Ï„Î·ÏƒÎ· Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚',0),(233518,6487,'zh','æœåŠ¡è¯·æ±‚\r\n',0),(233519,6487,'sv','ServicefÃ¶rfrÃ¥gan',0),(233520,6487,'it','Richiesta di servizio',0),(233521,6487,'tl','',0),(233522,6487,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(233523,6487,'hi','à¤¸à¥‡à¤µà¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(233524,6487,'ms','Permintaan Perkhidmatan',0),(233525,6487,'ar','Ø·Ù„Ø¨ Ø®Ø¯Ù…Ø©',0),(233526,6487,'fr','Demande de service',0),(233527,6487,'jp','ã‚µãƒ¼ãƒ“ã‚¹ãƒªã‚¯ã‚¨ã‚¹ãƒˆ',0),(233528,6487,'pt','SolicitaÃ§Ã£o de serviÃ§o',0),(233529,6487,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(233530,6487,'es','Pedido de Servicio',0),(233531,6487,'de','Service-Anfrage',0),(233532,6487,'en','Service Request',0),(233533,6488,'is','',0),(233534,6488,'dr','Ø¬Ù‡Øª ØªØ§ÙŠÙŠØ¯ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(233535,6488,'pr','Ø¬Ù‡Øª ØªØ§ÙŠÙŠØ¯ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(233536,6488,'tr','Onaylamak iÃ§in tÄ±klayÄ±n',0),(233537,6488,'pl','Kliknij, aby potwierdziÄ‡',0),(233538,6488,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´Ð¸Ñ‚Ðµ',0),(233539,6488,'ur','ØªØµØ¯ÛŒÙ‚ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(233540,6488,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ð»Ð¸',0),(233541,6488,'vi','Nháº¥n Ä‘á»ƒ xÃ¡c nháº­n',0),(233542,6488,'af','Kliek om te Bevestig',0),(233543,6488,'ro','FaceÅ£i clic pentru a confirma',0),(233544,6488,'et','Kinnitamiseks klÃµpsa',0),(233545,6488,'si','Kliknite, Äe Å¾elite potrditi',0),(233546,6488,'ba','Klik untuk mengkonfirmasi',0),(233547,6488,'nl','Klik om dit te bevestigen',0),(233548,6488,'fi','Valitse vahvistuksen',0),(233549,6488,'no','Klikk for Ã¥ bekrefte',0),(233550,6488,'da','Klik for at bekrÃ¦fte',0),(233551,6488,'ko','í™•ì¸ì„ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(233552,6488,'he','×œ×—×¥ ×¢×œ ×›×“×™ ×œ××©×¨',0),(233553,6488,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎµÏ„Îµ',0),(233554,6488,'zh','ç‚¹å‡»ç¡®è®¤\r\n',0),(233555,6488,'sv','Klicka fÃ¶r att bekrÃ¤fta',0),(233556,6488,'it','Fare clic per confermare',0),(233557,6488,'tl','',0),(233558,6488,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(233559,6488,'hi','à¤¯à¤¹ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(233560,6488,'ms','Klik untuk mengesahkan',0),(233561,6488,'ar','Ø£Ù†Ù‚Ø± Ù„Ù„ØªØ£ÙƒÙŠØ¯',0),(233562,6488,'fr','Cliquez ici pour confirmer',0),(233563,6488,'jp','ç¢ºèª?ã?™ã‚‹ã?«ã?¯ã‚¯ãƒªãƒƒã‚¯ã?—ã?¦ä¸‹ã?•ã?„',0),(233564,6488,'pt','Clique para confirmar',0),(233565,6488,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ',0),(233566,6488,'es','Click para Confirmar',0),(233567,6488,'de','Hier klicken, um zu bestÃ¤tigen',0),(233568,6488,'en','Click to Confirm',0),(233569,6489,'is','',0),(233570,6489,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ÙƒØ§Ø±Ø¨Ø±Ø§Ù† ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(233571,6489,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ÙƒØ§Ø±Ø¨Ø±Ø§Ù† ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(233572,6489,'tr','B2B kullanÄ±cÄ±lar tarafÄ±ndan girilen DoÄŸrulanmayan sipariÅŸleri listesi',0),(233573,6489,'pl','Wykaz niepotwierdzone zamÃ³wienia umieszczane przez uÅ¼ytkownikÃ³w B2B',0),(233574,6489,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð½ÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸ Ð¾Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ B2B',0),(233575,6489,'ur','ØºÛŒØ± Ù…ØµØ¯Ù‚Û Ø§Ø­Ú©Ø§Ù…Ø§Øª B2B ØµØ§Ø±ÙÛŒÙ† Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¯Ø§Ø®Ù„ Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(233576,6489,'sr','Ð›Ð¸ÑÑ‚Ðµ Ð½ÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð¸Ð¼ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° ÑƒÐ½ÐµÑ‚Ð° Ð‘2Ð‘ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸',0),(233577,6489,'vi','Danh SÃ¡ch Nhá»¯ng ÄÆ¡n HÃ ng ChÆ°a XÃ¡c Nháº­n Do NgÆ°á»i Sá»­ Dá»¥ng Cá»§a KhÃ¡ch HÃ ng B2B',0),(233578,6489,'af','Lys van Bevestigde Bestellings Ingevoer deur B2B Gebruikers',0),(233579,6489,'ro','Liste de comenzi neconfirmate introduse de utilizatori B2B',0),(233580,6489,'et','Kinnitamata korralduste B2B kasutajate nimekirjad',0),(233581,6489,'si','Seznami nepotrjenih naroÄil, ki jih B2B uporabnike',0),(233582,6489,'ba','Daftar Pesanan dari pengguna B2B yang belum dikonfirmasi',0),(233583,6489,'nl','Lijsten met onbevestigde bestellingen die door B2B gebruikers ingevoerd',0),(233584,6489,'fi','Luettelo vahvistamaton tilaukset B2B kÃ¤yttÃ¤jien syÃ¶ttÃ¤miÃ¤',0),(233585,6489,'no','Lister over ubekreftede ordrer B2B brukerne',0),(233586,6489,'da','Lister over ubekrÃ¦ftede ordrer indtastet af B2B brugere',0),(233587,6489,'ko','B2B ì‚¬ìš©ìžê°€ ìž…ë ¥ í•œ ë¯¸í™•ì¸ëœ ì£¼ë¬¸ ëª©ë¡',0),(233588,6489,'he','×¨×©×™×ž×•×ª ×©×œ ×¤×§×•×“×•×ª ×©×œ× ××•×©×¨×• ×©×”×•×–×Ÿ ×¢×œ ×™×“×™ ×ž×©×ª×ž×©×™× B2B',0),(233589,6489,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ Ï„Ï‰Î½ Î¼Î· ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹Ï‰Î¼Î­Î½ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ B2B',0),(233590,6489,'zh','å•†ä¸šå¯¹å•†ä¸šç”¨æˆ·è¾“å…¥æœªç¡®è®¤è®¢å•åˆ—è¡¨\r\n',0),(233591,6489,'sv','Listor av obekrÃ¤ftade order anges av B2B-anvÃ¤ndare',0),(233592,6489,'it','Elenchi degli ordini non confermati immessi dagli utenti B2B',0),(233593,6489,'tl','',0),(233594,6489,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3611;&#3657;&#3629;&#3',0),(233595,6489,'hi','à¤…à¤ªà¥à¤·à¥à¤Ÿ B2B à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤ à¤—à¤ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(233596,6489,'ms','Senarai pesanan belum disahkan yang dimasukkan oleh pengguna B2B',0),(233597,6489,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø£ÙˆØ§Ù…Ø± ØºÙŠØ± Ù…Ø¤ÙƒØ¯Ø© ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ Ù…Ù† Ù‚Ø¨Ù„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† B2B',0),(233598,6489,'fr','Listes des commandes non confirmÃ©es saisies par les internautes de B2B',0),(233599,6489,'jp','B2Bãƒ¦ãƒ¼ã‚¶ãƒ¼ã?«ã‚ˆã‚Šå…¥åŠ›ã?•ã‚Œã?¦æœªç¢ºèª?æ³¨æ–‡ã?®ãƒªã‚¹ãƒˆ',0),(233600,6489,'pt','Listas de pedidos nÃ£o confirmados inseridos pelos usuÃ¡rios B2B',0),(233601,6489,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ ÐÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð² Ð’Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ðµ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑÐ¼Ð¸ B2B',0),(233602,6489,'es','Listas de Ordenes no Confirmados Entrados por usuarios de N2N',0),(233603,6489,'de','Liste der unbestÃ¤tigten B2B Benutzer eingegebenen AuftrÃ¤ge',0),(233604,6489,'en','Lists of Unconfirmed Orders Entered by B2B Users',0),(233605,6490,'is','',0),(233606,6490,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡ Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(233607,6490,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡ Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(233608,6490,'tr','B2B sitesi Fulfillment sipariÅŸler izin ver',0),(233609,6490,'pl','UmoÅ¼liwienia realizacji zamÃ³wienia na stronie B2B',0),(233610,6490,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»ÑÐ²Ð°Ñ‚ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð° B2B ÑÐ°Ð¹Ñ‚',0),(233611,6490,'ur','B2B Ø³Ø§Ø¦Ù¹ Ù¾Ø± Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(233612,6490,'sr','ÐžÐ¼Ð¾Ð³ÑƒÑ›Ð¸Ñ‚Ð¸ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð‘2Ð‘',0),(233613,6490,'vi','Cho PhÃ©p ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i TrÃªn Trang B2B',0),(233614,6490,'af','Laat Uitvoeringsbestelling op B2B Perseel toe',0),(233615,6490,'ro','Permite realizarea comenzi pe site-ul B2B',0),(233616,6490,'et','Luba kaubatellimused B2B lehel',0),(233617,6490,'si','OmogoÄi izpolnitev naroÄila na B2B strani',0),(233618,6490,'ba','Mengijinkan Pemenuhan Pesanan pada situs B2B',0),(233619,6490,'nl','Vervulling Orders op B2B Site toestaan',0),(233620,6490,'fi','Sallia tÃ¤yttÃ¤minen tilausten B2B pÃ¤Ã¤llÃ¤',0),(233621,6490,'no','Tillate fullfÃ¸ringen bestillinger pÃ¥ B2B webomrÃ¥de',0),(233622,6490,'da','Giver mulighed for Fulfillment ordrer pÃ¥ B2B Site',0),(233623,6490,'ko','B2B ì‚¬ì´íŠ¸ì—ì´ í–‰ ëª…ë ¹ì„ í—ˆìš©í•©ë‹ˆë‹¤',0),(233624,6490,'he','×œ××¤×©×¨ ×ž×™×ž×•×© ×”×–×ž× ×•×ª ×‘××ª×¨ B2B',0),(233625,6490,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î·Î½ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÏƒÏ„Î¿ Ï‡ÏŽÏÎ¿ Ï„Î¿Ï… B2B',0),(233626,6490,'zh','å…è®¸åœ¨ä¼ä¸šå¯¹ä¼ä¸šç«™ç‚¹å±¥è¡Œè®¢å•\r\n',0),(233627,6490,'sv','TillÃ¥ta uppfyllelse order pÃ¥ B2B webbplats',0),(233628,6490,'it','Consentire l\'evasione ordini sul sito B2B',0),(233629,6490,'tl','',0),(233630,6490,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3610;&#3619;&#3619;&#3621;&#3641;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;&#3586;&#3629;&#3591; B2B',0),(233631,6490,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ B2B à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤° à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(233632,6490,'ms','Membenarkan memenuhi pesanan lokasi B2B',0),(233633,6490,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ù„ÙˆÙØ§Ø¡ Ø¨Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø¹Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ B2B',0),(233634,6490,'fr','Permettre des ordres sur le Site B2B',0),(233635,6490,'jp','ï¼¢ï¼’ï¼¢ã‚µã‚¤ãƒˆä¸Šã?®æ³¨æ–‡å±¥è¡Œã‚’è¨±å?¯ã?™ã‚‹',0),(233636,6490,'pt','Permitir o ordens de cumprimento no Site B2B',0),(233637,6490,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð° ÑÐ°Ð¹Ñ‚Ðµ B2B',0),(233638,6490,'es','Permitir Ordenes de Cumplimiento en Sitio de N2N',0),(233639,6490,'de','Fulfillment-Bestellungen B2B Site zulassen',0),(233640,6490,'en','Allow Fulfillment Orders on B2B Site',0),(233641,6491,'is','',0),(233642,6491,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(233643,6491,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(233644,6491,'tr','Servis sipariÅŸlerini B2B sitesi Ã¼zerinde izin ver',0),(233645,6491,'pl','PozwalajÄ… zamÃ³wienia usÅ‚ugi na stronie B2B',0),(233646,6491,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð· Ð½Ð° B2B ÑÐ°Ð¹Ñ‚',0),(233647,6491,'ur','B2B Ø³Ø§Ø¦Ù¹ Ù¾Ø± Ø®Ø¯Ù…Øª Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(233648,6491,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð‘2Ð‘',0),(233649,6491,'vi','Cho PhÃ©p ÄÆ¡n Äáº·t HÃ ng Dá»‹ch Vá»¥ TrÃªn Trang B2B',0),(233650,6491,'af','Laat Diensbestellings toe op B2B Perseel',0),(233651,6491,'ro','Permite comenzi de Service pe site-ul B2B',0),(233652,6491,'et','Luba hooldustellimuste B2B kohapeal',0),(233653,6491,'si','OmogoÄajo servisnih nalogov na B2B strani',0),(233654,6491,'ba','Mengijinkan Pesanan Jasa pada situs B2B',0),(233655,6491,'nl','Serviceorders op B2B Site toestaan',0),(233656,6491,'fi','Salli huoltotilaukset B2B pÃ¤Ã¤llÃ¤',0),(233657,6491,'no','Tillate serviceordrer pÃ¥ B2B nettsted',0),(233658,6491,'da','Tillad serviceordrer pÃ¥ B2B Site',0),(233659,6491,'ko','B2B ì‚¬ì´íŠ¸ì— ì„œë¹„ìŠ¤ ì£¼ë¬¸ í—ˆìš©',0),(233660,6491,'he','××¤×©×¨ ×”×–×ž× ×•×ª ×©×™×¨×•×ª ×‘××ª×¨ B2B',0),(233661,6491,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î¹Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï… ÏƒÏ„Î¿ Ï‡ÏŽÏÎ¿ Ï„Ï‰Î½ B2B',0),(233662,6491,'zh','å…è®¸åœ¨ä¼ä¸šå¯¹ä¼ä¸šç«™ç‚¹æœåŠ¡\r\n',0),(233663,6491,'sv','TillÃ¥t serviceorder pÃ¥ B2B webbplats',0),(233664,6491,'it','Consentire gli ordini di servizio sul sito B2B',0),(233665,6491,'tl','',0),(233666,6491,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591; B2B',0),(233667,6491,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ B2B à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤° à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(233668,6491,'ms','Membenarkan pesanan Perkhidmatan lokasi B2B',0),(233669,6491,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© ÙÙŠ Ù…ÙˆÙ‚Ø¹ B2B',0),(233670,6491,'fr','Permettre aux commandes de Service sur le Site B2B',0),(233671,6491,'jp','ï¼¢ï¼’ï¼¢ã‚µã‚¤ãƒˆä¸Šã?®ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã‚’è¨±å?¯ã?™ã‚‹',0),(233672,6491,'pt','Permitir que as ordens de serviÃ§o B2B site',0),(233673,6491,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ ÑÐ»ÑƒÐ¶Ð±Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð° ÑÐ°Ð¹Ñ‚Ðµ B2B',0),(233674,6491,'es','Permitir Ordenes de Servicio en el Sitio de N2N',0),(233675,6491,'de','ServiceauftrÃ¤ge auf B2B-Website zu ermÃ¶glichen',0),(233676,6491,'en','Allow Service Orders on B2B Site',0),(233677,6492,'is','',0),(233678,6492,'dr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´',0),(233679,6492,'pr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´',0),(233680,6492,'tr','SipariÅŸ teyit',0),(233681,6492,'pl','Potwierdzenie zamÃ³wienia',0),(233682,6492,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(233683,6492,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚',0),(233684,6492,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ñ’ÑƒÑ˜ÑƒÑ›Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(233685,6492,'vi','Äang XÃ¡c Nháº­n ÄÆ¡n Äáº·t HÃ ng',0),(233686,6492,'af','Bevestig Bestelling',0),(233687,6492,'ro','Confirmarea comenzii',0),(233688,6492,'et','Kinnitades jÃ¤rjekorras',0),(233689,6492,'si','Potrjuje vrstni red',0),(233690,6492,'ba','Urutan mengkonfirmasikan',0),(233691,6492,'nl','Bevestiging van bestelling',0),(233692,6492,'fi','Vahvistaa jÃ¤rjestyksen',0),(233693,6492,'no','Bekrefter bestillingen',0),(233694,6492,'da','BekrÃ¦fter ordren',0),(233695,6492,'ko','ì£¼ë¬¸ í™•ì¸',0),(233696,6492,'he','××™×©×•×¨ ×”×–×ž× ×”',0),(233697,6492,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(233698,6492,'zh','ç¡®è®¤è®¢è´­\r\n',0),(233699,6492,'sv','BekrÃ¤fta Order',0),(233700,6492,'it','Conferma ordine',0),(233701,6492,'tl','',0),(233702,6492,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(233703,6492,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿',0),(233704,6492,'ms','Mengesahkan perintah',0),(233705,6492,'ar','ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(233706,6492,'fr','Confirmation de commande',0),(233707,6492,'jp','æ³¨æ–‡ã?®ç¢ºèª?ä¸­',0),(233708,6492,'pt','Confirmando a ordem',0),(233709,6492,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ð°',0),(233710,6492,'es','Confirmando Pedido',0),(233711,6492,'de','Bestellung bestÃ¤tigen',0),(233712,6492,'en','Confirming Order',0),(233713,6493,'is','',0),(233714,6493,'dr','(Ù…Ø¬ÙˆØ²) Ø®Ø¯Ù…Ø§Øª ',0),(233715,6493,'pr','Ø¨Ù„ÙŠØ· (Ù…Ø¬ÙˆØ²) Ø®Ø¯Ù…Ø§Øª ',0),(233716,6493,'tr','Hizmet bileti',0),(233717,6493,'pl','Bilet usÅ‚ugi',0),(233718,6493,'bg','Ð£ÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ð±Ð¸Ð»ÐµÑ‚',0),(233719,6493,'ur','Ø³Ø±ÙˆØ³ Ú©ÛŒ Ù¹Ú©Ù¹',0),(233720,6493,'sr','ÐšÐ°Ñ€Ñ‚Ð° ÑÐµÑ€Ð²Ð¸ÑÐ°',0),(233721,6493,'vi','VÃ© dá»‹ch vá»¥',0),(233722,6493,'af','Diens Kaartjie',0),(233723,6493,'ro','Serviciu de vÃ¢nzare bilete',0),(233724,6493,'et','Piletite mÃ¼Ã¼gipunkt',0),(233725,6493,'si','Storitveno vstopnico',0),(233726,6493,'ba','Layanan Tiket',0),(233727,6493,'nl','Serviceticket',0),(233728,6493,'fi','Palvelun lippu',0),(233729,6493,'no','Tjenestebillett',0),(233730,6493,'da','Service billet',0),(233731,6493,'ko','ì„œë¹„ìŠ¤ í‹°ì¼“',0),(233732,6493,'he','×©×™×¨×•×ª ×”×–×ž× ×ª ×›×¨×˜×™×¡×™×',0),(233733,6493,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± ÎµÎ¹ÏƒÎ¹Ï„Î·ÏÎ¯Ï‰Î½',0),(233734,6493,'zh','æœåŠ¡ç¥¨è¯\r\n',0),(233735,6493,'sv','TjÃ¤nstbiljett',0),(233736,6493,'it','Servizio Ticket',0),(233737,6493,'tl','',0),(233738,6493,'th','&#3605;&#3633;&#3659;&#3623;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(233739,6493,'hi','à¤¸à¥‡à¤µà¤¾ à¤Ÿà¤¿à¤•à¤Ÿ',0),(233740,6493,'ms','Perkhidmatan Tiket.',0),(233741,6493,'ar','ØªØ°ÙƒØ±Ø© Ø§Ù„Ø®Ø¯Ù…Ø©',0),(233742,6493,'fr','Ticket de service',0),(233743,6493,'jp','ã‚µãƒ¼ãƒ“ã‚¹ãƒ?ã‚±ãƒƒãƒˆ',0),(233744,6493,'pt','TÃ­quete de serviÃ§o',0),(233745,6493,'ru','Ð‘Ð¸Ð»ÐµÑ‚ ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(233746,6493,'es','Boleto de Servicio',0),(233747,6493,'de','Service-Ticket',0),(233748,6493,'en','Service Ticket',0),(233749,6494,'is','',0),(233750,6494,'dr','Ø³Ø·Ø­ Ø¯Ø³ØªØ±Ø³ÙŠ',0),(233751,6494,'pr','Ø³Ø·Ø­ Ø¯Ø³ØªØ±Ø³ÙŠ',0),(233752,6494,'tr','EriÅŸim dÃ¼zeyi',0),(233753,6494,'pl','Poziom dostÄ™pu',0),(233754,6494,'bg','ÐÐ¸Ð²Ð¾ Ð½Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(233755,6494,'ur','Ù¾Ú¾Ù†Ú† Ú©Ø§ Ø°Ø±ÛŒØ¹Û',0),(233756,6494,'sr','ÐÐ¸Ð²Ð¾ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð°',0),(233757,6494,'vi','Cáº¥p Äá»™ Truy Cáº­p',0),(233758,6494,'af','Toegangsvlak',0),(233759,6494,'ro','Nivel de acces',0),(233760,6494,'et','LigipÃ¤Ã¤su tase',0),(233761,6494,'si','Raven dostopa',0),(233762,6494,'ba','Level Penggunaan',0),(233763,6494,'nl','Toegangsniveau',0),(233764,6494,'fi','KÃ¤yttÃ¶oikeustaso',0),(233765,6494,'no','TilgangsnivÃ¥',0),(233766,6494,'da','Adgangsniveau',0),(233767,6494,'ko','ì•¡ì„¸ìŠ¤ ìˆ˜ì¤€',0),(233768,6494,'he','×¨×ž×ª ×’×™×©×”',0),(233769,6494,'el','Î•Ï€Î¯Ï€ÎµÎ´Î¿ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(233770,6494,'zh','é€²å…¥ç¨‹åº¦',0),(233771,6494,'sv','Ã…tkomstnivÃ¥',0),(233772,6494,'it','Livello di Accesso',0),(233773,6494,'tl','',0),(233774,6494,'th','à¸£à¸°à¸”à¸±à¸šà¸à¸²à¸£à¸­à¸™à¸¸à¸à¸²à¸•',0),(233775,6494,'hi','à¤ªà¤¹à¥à¤à¤š à¤¸à¥à¤¤à¤°',0),(233776,6494,'ms','Tahap capaian',0),(233777,6494,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„ÙˆØµÙˆÙ„',0),(233778,6494,'fr','Niveau d\'accÃ¨s',0),(233779,6494,'jp','ã‚¢ã‚¯ã‚»ã‚¹ãƒ¬ãƒ™ãƒ«',0),(233780,6494,'pt','NÃ­vel de acesso',0),(233781,6494,'ru','Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°',0),(233782,6494,'es','Nivel de Acceso',0),(233783,6494,'de','Zugriffsstufe',0),(233784,6494,'en','Access Level',0),(233785,6495,'is','',0),(233786,6495,'dr','Ø¢ÙŠØ§ Ø§ÙŠÙ† ÙŠÙƒ Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ Ø§Ø³Øª ØŸ',0),(233787,6495,'pr','Ø¢ÙŠØ§ Ø§ÙŠÙ† ÙŠÙƒ Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ Ø§Ø³Øª ØŸ',0),(233788,6495,'tr','Bu bir ajans mÄ±?',0),(233789,6495,'pl','Jest to Agencja?',0),(233790,6495,'bg','Ð¢Ð¾Ð²Ð° Ðµ ÐµÐ´Ð½Ð° Ð°Ð³ÐµÐ½Ñ†Ð¸Ñ?',0),(233791,6495,'ur','ÛŒÛ Ø§ÛŒÚ© Ø§ÛŒØ¬Ù†Ø³ÛŒ ÛÛ’ØŸ',0),(233792,6495,'sr','Ð”Ð° Ð»Ð¸ Ñ˜Ðµ Ð¾Ð²Ð¾ Ñƒ Ð°Ð³ÐµÐ½Ñ†Ð¸Ñ˜Ð¸?',0),(233793,6495,'vi','CÃ³ pháº£i lÃ  Äáº¡i lÃ½ nÃ y?',0),(233794,6495,'af','Is Dit \'n Agentskap?',0),(233795,6495,'ro','Aceasta este o agentie?',0),(233796,6495,'et','On see amet?',0),(233797,6495,'si','Je to agencija?',0),(233798,6495,'ba','Ini adalah agen?',0),(233799,6495,'nl','Is dit een agentschap?',0),(233800,6495,'fi','Onko tÃ¤mÃ¤ virasto?',0),(233801,6495,'no','Er dette et byrÃ¥?',0),(233802,6495,'da','Er dette et agentur?',0),(233803,6495,'ko','ì´ ê¸°ê´€ ì¸ê°€ìš”?',0),(233804,6495,'he','? ×”×× ×–×” ×¡×•×›× ×•×ª',0),(233805,6495,'el','Î ÏÏŒÎºÎµÎ¹Ï„Î±Î¹ Î³Î¹Î± Î­Î½Î±Î½ Î¿ÏÎ³Î±Î½Î¹ÏƒÎ¼ÏŒ;',0),(233806,6495,'zh','è¿™æ˜¯ä¸€å¤„ï¼Ÿ\r\n',0),(233807,6495,'sv','Ã„r detta en byrÃ¥?',0),(233808,6495,'it','Si tratta di un\'agenzia?',0),(233809,6495,'tl','',0),(233810,6495,'th','&#3648;&#3611;&#3655;&#3609;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(233811,6495,'hi','à¤¯à¤¹ à¤à¤• à¤à¤œà¥‡à¤‚à¤¸à¥€ à¤¹à¥ˆ?',0),(233812,6495,'ms','Adakah ini sebuah agensi?',0),(233813,6495,'ar','Ù‡Ø°Ø§ Ù‡Ùˆ Ø¥Ø­Ø¯Ù‰ Ø§Ù„ÙˆÙƒØ§Ù„Ø§ØªØŸ',0),(233814,6495,'fr','Est-ce une Agence ?',0),(233815,6495,'jp','ã?“ã‚Œã?¯ä»£ç?†åº—ã?§ã?™ã?‹ï¼Ÿ',0),(233816,6495,'pt','Isto Ã© uma agÃªncia?',0),(233817,6495,'ru','Ð­Ñ‚Ð¾ Ð°Ð³ÐµÐ½Ñ‚ÑÑ‚Ð²Ð¾?',0),(233818,6495,'es','Â¿Es Este una Agencia?',0),(233819,6495,'de','Ist das eine Agentur?',0),(233820,6495,'en','Is This an Agency?',0),(233821,6496,'is','',0),(233822,6496,'dr','/ Ø¶Ù…ÙŠÙ…Ù‡',0),(233823,6496,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÙŠÚ©Ù‰ Ø¯Ø§Ø±Ø§Ø¦Ù‰/ Ø¶Ù…ÙŠÙ…Ù‡',0),(233824,6496,'tr','EFT/ACH',0),(233825,6496,'pl','EFT/ACH',0),(233826,6496,'bg','EFT/ÐCH',0),(233827,6496,'ur','EFT/Ø§Ú†',0),(233828,6496,'sr','Ð•Ð¤Ð¢/ÐÐ¥',0),(233829,6496,'vi','EFT/ACH',0),(233830,6496,'af','EFT/ACH',0),(233831,6496,'ro','EFT/ACH',0),(233832,6496,'et','EFT/ACH',0),(233833,6496,'si','EFT/ACH',0),(233834,6496,'ba','TDE ACH',0),(233835,6496,'nl','EFT/ACH',0),(233836,6496,'fi','EFT/ACH',0),(233837,6496,'no','EFT/ACH',0),(233838,6496,'da','EFT/ACH',0),(233839,6496,'ko','ì†¡ê¸ˆ/í¬',0),(233840,6496,'he','EFT/ACH',0),(233841,6496,'el','EFT/ACH',0),(233842,6496,'zh','ç”µæ±‡/ è‡ªåŠ¨äº¤æ˜“æ‰€\r\n',0),(233843,6496,'sv','EFT/ACH',0),(233844,6496,'it','EFT/ACH',0),(233845,6496,'tl','',0),(233846,6496,'th','EFT/ACH',0),(233847,6496,'hi','à¤ˆà¤à¤«à¤¼à¤Ÿà¥€/ACH',0),(233848,6496,'ms','EFT/MEN',0),(233849,6496,'ar','EFT/Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(233850,6496,'fr','EFT/ACH',0),(233851,6496,'jp','EFT/ACH',0),(233852,6496,'pt','EFT/ACH',0),(233853,6496,'ru','EFT/ACH',0),(233854,6496,'es','EFT/ACH',0),(233855,6496,'de','EFT/ACH',0),(233856,6496,'en','EFT/ACH',0),(233857,6497,'is','',0),(233858,6497,'dr','Ø«Ø¨Øª  Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(233859,6497,'pr','Ø«Ø¨Øª  Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(233860,6497,'tr','Ã–deme kaydÄ±',0),(233861,6497,'pl','PÅ‚atnoÅ›ci',0),(233862,6497,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð·Ð°Ð¿Ð¸Ñ',0),(233863,6497,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(233864,6497,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ð·Ð°Ð¿Ð¸Ñ',0),(233865,6497,'vi','Há»“ sÆ¡ Thanh ToÃ¡n',0),(233866,6497,'af','Betaling Rekord',0),(233867,6497,'ro','Record de platÄƒ',0),(233868,6497,'et','Makse kirje',0),(233869,6497,'si','PlaÄilo zapis',0),(233870,6497,'ba','Catatan pembayaran',0),(233871,6497,'nl','Betaling Record',0),(233872,6497,'fi','Maksujen',0),(233873,6497,'no','Betalingspostfil',0),(233874,6497,'da','Betalingspost',0),(233875,6497,'ko','ì§€ë¶ˆ ê¸°ë¡',0),(233876,6497,'he','×¨×©×•×ž×ª ×ª×©×œ×•×',0),(233877,6497,'el','Î¤Î¿ Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î±Ï€Î¿Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(233878,6497,'zh','ä»˜æ¬¾è®°å½•\r\n',0),(233879,6497,'sv','Betalningsposten',0),(233880,6497,'it','Pagamento Record',0),(233881,6497,'tl','',0),(233882,6497,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(233883,6497,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡',0),(233884,6497,'ms','Rekod bayaran',0),(233885,6497,'ar','Ø³Ø¬Ù„ Ø§Ù„Ø¯ÙØ¹',0),(233886,6497,'fr','Enregistrement de paiement',0),(233887,6497,'jp','æ”¯æ‰•ã?„è¨˜éŒ²',0),(233888,6497,'pt','Registro de pagamento',0),(233889,6497,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ Ð¾Ð± Ð¾Ð¿Ð»Ð°Ñ‚Ðµ',0),(233890,6497,'es','Record de Pagos',0),(233891,6497,'de','Zahlungsmoral',0),(233892,6497,'en','Payment Record',0),(233893,6498,'is','',0),(233894,6498,'dr','Ú†Ø§Ù¾ Ù‡Ù…Ù‡ Ø¯Ø± Ù„ÙŠØ³Øª ',0),(233895,6498,'pr','Ú†Ø§Ù¾ Ù‡Ù…Ù‡ Ø¯Ø± Ù„ÙŠØ³Øª ',0),(233896,6498,'tr','Listede tÃ¼mÃ¼nÃ¼ bas',0),(233897,6498,'pl','Drukuj wszystkie liÅ›cie',0),(233898,6498,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð² ÑÐ¿Ð¸ÑÑŠÐºÐ°',0),(233899,6498,'ur','ÙÛØ±Ø³Øª Ù…ÛŒÚº Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø³Ø¨',0),(233900,6498,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑÐ²Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(233901,6498,'vi','In táº¥t cáº£ trong danh sÃ¡ch',0),(233902,6498,'af','Druk Alles in Lys',0),(233903,6498,'ro','Imprimare tot Ã®n lista',0),(233904,6498,'et','Prindi kÃµik loendis',0),(233905,6498,'si','Natisni vse v seznam',0),(233906,6498,'ba','Cetak semua dalam daftar',0),(233907,6498,'nl','Print All In lijst',0),(233908,6498,'fi','Tulosta kaikki luettelossa',0),(233909,6498,'no','Skriv ut alt i listen',0),(233910,6498,'da','Print alle i listen',0),(233911,6498,'ko','ëª©ë¡ì—ì„œ ì¸ì‡„ ëª¨ë“ ',0),(233912,6498,'he','×”×“×¤×¡×ª ×›×œ ×‘×¨×©×™×ž×”',0),(233913,6498,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ ÏŒÎ»Î± ÏƒÎµ Î»Î¯ÏƒÏ„Î±',0),(233914,6498,'zh','æ‰€æœ‰æˆåˆ—æ‰“å°\r\n',0),(233915,6498,'sv','Skriv ut allt i listan',0),(233916,6498,'it','Stampa tutto In elenco',0),(233917,6498,'tl','',0),(233918,6498,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(233919,6498,'hi','à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤¸à¤¬',0),(233920,6498,'ms','Cetak semua dalam senarai',0),(233921,6498,'ar','Ø·Ø¨Ø§Ø¹Ø© ÙƒÙ„ ÙÙŠ Ù‚Ø§Ø¦Ù…Ø©',0),(233922,6498,'fr','Imprimer tout en liste',0),(233923,6498,'jp','ãƒªã‚¹ãƒˆå†…ã?®å…¨ã?¦ã‚’å?°åˆ·',0),(233924,6498,'pt','Imprimir tudo em lista',0),(233925,6498,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð’ÑÑ‘ Ð² Ð¡Ð¿Ð¸ÑÐºÐµ',0),(233926,6498,'es','Imprimir Todos en la Lista',0),(233927,6498,'de','Print All In Liste',0),(233928,6498,'en','Print All In List',0),(233929,6499,'is','',0),(233930,6499,'dr','-  Ø¨Ø¯ÙˆÙ† Ú†Ùƒ ',0),(233931,6499,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ -  Ø¨Ø¯ÙˆÙ† Ú†Ùƒ ',0),(233932,6499,'tr','NAKÄ°T Ã–DEME - ONAY',0),(233933,6499,'pl','W GOTÃ“WCE - NIE SPRAWDZAÅEM',0),(233934,6499,'bg','ÐŸÐ›ÐÐ©ÐÐÐ• Ð’ Ð‘Ð ÐžÐ™ - ÐÐ• ÐŸÐ ÐžÐ’Ð•Ð Ð¯Ð’Ð',0),(233935,6499,'ur','Ù†Ù‚Ø¯ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù‚Ù… â€“ Ù†ÛÛŒÚº Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(233936,6499,'sr','Ð“ÐžÐ¢ÐžÐ’Ð˜ÐÐ¡ÐšÐ£ Ð£ÐŸÐ›ÐÐ¢Ð£ - ÐÐ• Ð’Ð˜Ð”Ð˜',0),(233937,6499,'vi','TRáº¢ Báº°NG TIá»€N Máº¶T - KHÃ”NG SÃ‰C',0),(233938,6499,'af','KONTANT BETALING - NIE \'n TJEK',0),(233939,6499,'ro','PLATA ÃŽN NUMERAR - NU VERIFICA',0),(233940,6499,'et','SULARAHAS - KONTROLLI',0),(233941,6499,'si','GOTOVINSKO PLAÄŒILO - NE PREVERITE',0),(233942,6499,'ba','PEMBAYARAN TUNAI - TIDAK MEMERIKSA',0),(233943,6499,'nl','CONTANTBETALING - NIET CONTROLEREN',0),(233944,6499,'fi','KÃ„TEISMAKSU - TARKISTA',0),(233945,6499,'no','KONTANTBETALING - IKKE SJEKKE',0),(233946,6499,'da','KONTANTBETALING - IKKE TJEKKE',0),(233947,6499,'ko','í˜„ê¸ˆ ê²°ì œ-í™•ì¸ í•˜ì§€',0),(233948,6499,'he','×ª×©×œ×•× ×‘×ž×–×•×ž×Ÿ - ×‘×•×“×§',0),(233949,6499,'el','Î Î›Î—Î¡Î©ÎœÎ‰ Î£Î• ÎœÎ•Î¤Î¡Î—Î¤Î† - Î•Î›ÎˆÎ“Î§Î•Î™',0),(233950,6499,'zh','çŽ°é‡‘ä»˜æ¬¾ -ä¸æ£€æŸ¥\r\n',0),(233951,6499,'sv','KONTANTBETALNING - INTE KONTROLLERA',0),(233952,6499,'it','PAGAMENTO IN CONTANTI - NON CONTROLLARE',0),(233953,6499,'tl','',0),(233954,6499,'th','&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604; - &#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3594;&#3655;&#3588;',0),(233955,6499,'hi','à¤¨à¤•à¤¦ à¤­à¥à¤—à¤¤à¤¾à¤¨ - à¤¨à¤¹à¥€à¤‚ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(233956,6499,'ms','PEMBAYARAN SECARA TUNAI - TIDAK MENYEMAK',0),(233957,6499,'ar','Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù†Ù‚Ø¯ÙŠ--Ù„Ù… ØªØ­Ù‚Ù‚',0),(233958,6499,'fr','PAIEMENT EN ESPÃˆCES - PAS VÃ‰RIFIER',0),(233959,6499,'jp','ç?¾é‡‘æ”¯æ‰•ãƒ¼å°?åˆ‡æ‰‹ã?§ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(233960,6499,'pt','PAGAMENTO EM DINHEIRO - NÃƒO VERIFICA',0),(233961,6499,'ru','ÐžÐŸÐ›ÐÐ¢Ð ÐÐÐ›Ð˜Ð§ÐÐ«ÐœÐ˜ - ÐÐ• ÐŸÐ ÐžÐ’Ð•Ð Ð¯Ð¢Ð¬',0),(233962,6499,'es','PAGO EN EFECTIVO - NO CHEQUE',0),(233963,6499,'de','BARZAHLUNG - NICHT ÃœBERPRÃœFEN',0),(233964,6499,'en','CASH PAYMENT - NOT CHECK',0),(233965,6500,'is','',0),(233966,6500,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ â€“ Ù†Ù‡ Ú†Ùƒ ',0),(233967,6500,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ â€“ Ù†Ù‡ Ú†Ùƒ ',0),(233968,6500,'tr','KREDÄ° KARTI Ä°LE Ã–DEME - ONAY',0),(233969,6500,'pl','PÅATNOÅšCI KARTÄ„ KREDYTOWÄ„ - NIE SPRAWDZAÅEM',0),(233970,6500,'bg','ÐŸÐ›ÐÐ©ÐÐÐ• Ð¡ ÐšÐ Ð•Ð”Ð˜Ð¢ÐÐ ÐšÐÐ Ð¢Ð - ÐÐ• ÐŸÐ ÐžÐ’Ð•Ð Ð¯Ð’Ð',0),(233971,6500,'ur','-Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù†ÛÛŒÚº Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(233972,6500,'sr','ÐŸÐ›ÐÐ‹ÐÐŠÐ• ÐšÐ Ð•Ð”Ð˜Ð¢ÐÐžÐœ ÐšÐÐ Ð¢Ð˜Ð¦ÐžÐœ - ÐÐ• Ð’Ð˜Ð”Ð˜',0),(233973,6500,'vi','Thanh ToÃ¡n Báº±ng Tháº» TÃ­n Dá»¥ng - KhÃ´ng SÃ©c',0),(233974,6500,'af','KREDIETKAARTBETALING - NIE GEMERK',0),(233975,6500,'ro','PLATA CU CREDIT CARD - NU VERIFICA',0),(233976,6500,'et','Krediitkaardi makse - KONTROLLIMATA',0),(233977,6500,'si','PLAÄŒILO S KREDITNO KARTICO - PREVERI',0),(233978,6500,'ba','PEMBAYARAN KARTU KREDIT - TIDAK MEMERIKSA',0),(233979,6500,'nl','CREDIT CARD BETALING - NIET CONTROLEREN',0),(233980,6500,'fi','LUOTTOKORTILLA MAKSAMINEN - TARKISTA',0),(233981,6500,'no','KREDITTKORTBETALING - IKKE SJEKKE',0),(233982,6500,'da','BETALING MED KREDITKORT - IKKE TJEKKE',0),(233983,6500,'ko','ì‹ ìš© ì¹´ë“œ ê²°ì œ-í™•ì¸ í•˜ì§€',0),(233984,6500,'he','×ª×©×œ×•× ×‘××ž×¦×¢×•×ª ×›×¨×˜×™×¡ ××©×¨××™ - ×œ× ×‘×•×“×§',0),(233985,6500,'el','Î Î›Î—Î¡Î©ÎœÎ‰ ÎœÎ• Î Î™Î£Î¤Î©Î¤Î™ÎšÎ‰ ÎšÎ†Î¡Î¤Î‘ - Î”Î•Î Î•Î›ÎˆÎ“Î§Î•Î™',0),(233986,6500,'zh','ä¿¡ç”¨å¡ä»˜æ¬¾-éžæ”¯ç¥¨\r\n',0),(233987,6500,'sv','KORTBETALNING - INTE KONTROLLERA',0),(233988,6500,'it','PAGAMENTO CON CARTA DI CREDITO - NON CONTROLLARE',0),(233989,6500,'tl','',0),(233990,6500,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3604;&#3657;&#3623;&#3618;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605; &#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3594;&#3655;&#3588;',0),(233991,6500,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤­à¥à¤—à¤¤à¤¾à¤¨ - à¤¨à¤¹à¥€à¤‚ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(233992,6500,'ms','PEMBAYARAN DENGAN KAD KREDIT - TIDAK MENYEMAK',0),(233993,6500,'ar','Ø§Ù„Ø¯ÙØ¹ Ø¨ÙˆØ§Ø³Ø·Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†--Ù„Ù… ØªØ­Ù‚Ù‚',0),(233994,6500,'fr','PAIEMENT PAR CARTE DE CRÃ‰DIT - PAS VÃ‰RIFIER',0),(233995,6500,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚«ãƒ¼ãƒ‰æ”¯æ‰•ãƒ¼å°?åˆ‡æ‰‹ã?§ã?¯ã?‚ã‚Šã?¾ã?›ã‚“',0),(233996,6500,'pt','PAGAMENTO COM CARTÃƒO DE CRÃ‰DITO - NÃƒO VERIFICA',0),(233997,6500,'ru','ÐžÐŸÐ›ÐÐ¢Ð ÐšÐ Ð•Ð”Ð˜Ð¢ÐÐžÐ™ ÐšÐÐ Ð¢ÐžÐ™ - ÐÐ• ÐŸÐ ÐžÐ’Ð•Ð Ð¯Ð¢Ð¬',0),(233998,6500,'es','PAGO DE TARJETA DE CREDITO, NO CHEQUE',0),(233999,6500,'de','ZAHLUNG MIT KREDITKARTE - NICHT ÃœBERPRÃœFEN',0),(234000,6500,'en','CREDIT CARD PAYMENT - NOT CHECK',0),(234001,6501,'is','',0),(234002,6501,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠÙ†Ùƒ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø«Ø¨Øª ',0),(234003,6501,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠÙ†Ùƒ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø«Ø¨Øª ',0),(234004,6501,'tr','BaÄŸlantÄ± Ekle',0),(234005,6501,'pl','DodaÄ‡ Link',0),(234006,6501,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²Ñ€ÑŠÐ·ÐºÐ°',0),(234007,6501,'ur','Ø±Ø¨Ø· Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(234008,6501,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²ÐµÐ·Ðµ',0),(234009,6501,'vi','ThÃªm ÄÆ°á»ng Dáº«n',0),(234010,6501,'af','Skakel Byvoeg',0),(234011,6501,'ro','Adauga link',0),(234012,6501,'et','Lingi lisamine',0),(234013,6501,'si','Dodaj povezavo',0),(234014,6501,'ba','Tambahkan Link',0),(234015,6501,'nl','Voeg Link toe',0),(234016,6501,'fi','LisÃ¤Ã¤ linkki',0),(234017,6501,'no','Legge til kobling',0),(234018,6501,'da','TilfÃ¸j Link',0),(234019,6501,'ko','ë§í¬ ì¶”ê°€',0),(234020,6501,'he','×”×•×¡×£ ×§×™×©×•×¨',0),(234021,6501,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÏƒÏÎ½Î´ÎµÏƒÎ¼Î¿',0),(234022,6501,'zh','å¢žåŠ é“¾æŽ¥\r\n',0),(234023,6501,'sv','LÃ¤gg till lÃ¤nk',0),(234024,6501,'it','Aggiungi Link',0),(234025,6501,'tl','',0),(234026,6501,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3621;&#3636;&#3591;&#3588;&#3660;',0),(234027,6501,'hi','à¤²à¤¿à¤‚à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(234028,6501,'ms','Tambah pautan',0),(234029,6501,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ø±ØªØ¨Ø§Ø·',0),(234030,6501,'fr','Ajouter Lien ',0),(234031,6501,'jp','ãƒªãƒ³ã‚¯ã?®è¿½åŠ ',0),(234032,6501,'pt','Adicionar Link',0),(234033,6501,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡ÑÑ‹Ð»ÐºÑƒ',0),(234034,6501,'es','Agregar Enlace',0),(234035,6501,'de','Link hinzufÃ¼gen',0),(234036,6501,'en','Add Link',0),(234037,6502,'is','',0),(234038,6502,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠÙ†Ùƒ Ø¬Ø¯ÙŠØ¯ ',0),(234039,6502,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠÙ†Ùƒ Ø¬Ø¯ÙŠØ¯ ',0),(234040,6502,'tr','Yeni baÄŸlantÄ± ekle',0),(234041,6502,'pl','DodaÄ‡ nowy Link',0),(234042,6502,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð²Ñ€ÑŠÐ·ÐºÐ°',0),(234043,6502,'ur','Ù†Ø¦Û’ Ø±Ø¨Ø· Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(234044,6502,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ Ð²ÐµÐ·Ñƒ',0),(234045,6502,'vi','ThÃªm ÄÆ°á»ng Dáº«n Má»›i',0),(234046,6502,'af','Nuwe Skakel Byvoeg',0),(234047,6502,'ro','Adauga link nou',0),(234048,6502,'et','Lisa uus link',0),(234049,6502,'si','Dodajte novo povezavo',0),(234050,6502,'ba','Menambahkan Link baru',0),(234051,6502,'nl','Nieuwe koppeling toevoegen',0),(234052,6502,'fi','LisÃ¤Ã¤ uusi linkki',0),(234053,6502,'no','Legge til ny kobling',0),(234054,6502,'da','TilfÃ¸j nyt Link',0),(234055,6502,'ko','ìƒˆ ë§í¬ë¥¼ ì¶”ê°€',0),(234056,6502,'he','×”×•×¡×£ ×§×™×©×•×¨ ×—×“×©',0),(234057,6502,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(234058,6502,'zh','å¢žåŠ æ–°çš„é“¾æŽ¥\r\n',0),(234059,6502,'sv','LÃ¤gg till ny lÃ¤nk',0),(234060,6502,'it','Aggiungere nuovo Link',0),(234061,6502,'tl','',0),(234062,6502,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3621;&#3636;&#3591;&#3588;&#3660;',0),(234063,6502,'hi','à¤¨à¤ˆ à¤²à¤¿à¤‚à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(234064,6502,'ms','Tambah pautan baru',0),(234065,6502,'ar','Ø¥Ø¶Ø§ÙØ© Ø±Ø§Ø¨Ø· Ø¬Ø¯ÙŠØ¯',0),(234066,6502,'fr','Ajouter le nouveau lien',0),(234067,6502,'jp','æ–°è¦?ãƒªãƒ³ã‚¯ã?®è¿½åŠ ',0),(234068,6502,'pt','Adicionar novo Link',0),(234069,6502,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²ÑƒÑŽ Ð¡ÑÑ‹Ð»ÐºÑƒ',0),(234070,6502,'es','Agregar Nuevo Enlace',0),(234071,6502,'de','Neuen Link hinzufÃ¼gen',0),(234072,6502,'en','Add New Link',0),(234073,6503,'is','',0),(234074,6503,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù„ÙŠÙ†Ùƒ Ø¯ÙŠÚ¯Ø±',0),(234075,6503,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù„ÙŠÙ†Ùƒ Ø¯ÙŠÚ¯Ø±',0),(234076,6503,'tr','BaÅŸka bir baÄŸlantÄ± DÃ¼zenle',0),(234077,6503,'pl','Inny Link Edytuj',0),(234078,6503,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð° Ð²Ñ€ÑŠÐ·ÐºÐ°',0),(234079,6503,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± Ø±Ø¨Ø· ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(234080,6503,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð½ÐµÐºÑƒ Ð´Ñ€ÑƒÐ³Ñƒ Ð²ÐµÐ·Ñƒ',0),(234081,6503,'vi','Sá»­a ÄÆ°á»ng Dáº«n KhÃ¡c',0),(234082,6503,'af','Rediger \'n Ander Skakel',0),(234083,6503,'ro','EditaÅ£i un alt Link',0),(234084,6503,'et','Redigeeri, teine',0),(234085,6503,'si','Uredite drugo povezavo',0),(234086,6503,'ba','Mengedit Link lain',0),(234087,6503,'nl','Een andere koppeling bewerken',0),(234088,6503,'fi','Muokkaa toinen linkki',0),(234089,6503,'no','Redigere en kobling',0),(234090,6503,'da','Redigere en anden Link',0),(234091,6503,'ko','ë‹¤ë¥¸ ë§í¬ë¥¼ íŽ¸ì§‘',0),(234092,6503,'he','×¢×¨×•×š ×§×™×©×•×¨ × ×•×¡×£',0),(234093,6503,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î¼Î¹Î± Î¬Î»Î»Î· ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(234094,6503,'zh','ç¼–è¾‘å¦ä¸€ä¸ªé“¾æŽ¥\r\n',0),(234095,6503,'sv','Redigera en annan lÃ¤nk',0),(234096,6503,'it','Modificare un altro Link',0),(234097,6503,'tl','',0),(234098,6503,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3648;&#3594;&#3639;&#3656;&#3629;&#3617;&#3605;&#3656;&#3629;&#3629;&#3639;&#3656;&#3609;',0),(234099,6503,'hi','à¤…à¤¨à¥à¤¯ à¤²à¤¿à¤‚à¤• à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(234100,6503,'ms','Edit pautan lain',0),(234101,6503,'ar','ØªØ­Ø±ÙŠØ± Ø±Ø§Ø¨Ø· Ø¢Ø®Ø±',0),(234102,6503,'fr','Modifier un autre lien',0),(234103,6503,'jp','ä»–ã?®ãƒªãƒ³ã‚¯ã?®ç·¨é›†',0),(234104,6503,'pt','Editar um outro Link',0),(234105,6503,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³ÑƒÑŽ Ð¡ÑÑ‹Ð»ÐºÑƒ',0),(234106,6503,'es','Editar Otro Enlace',0),(234107,6503,'de','Ein weiterer Link bearbeiten',0),(234108,6503,'en','Edit Another Link',0),(234109,6504,'is','',0),(234110,6504,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù„ÙŠÙ†Ùƒ ',0),(234111,6504,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù„ÙŠÙ†Ùƒ ',0),(234112,6504,'tr','BaÄŸlantÄ±yÄ± DÃ¼zenle',0),(234113,6504,'pl','Edytuj Link',0),(234114,6504,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ñ€ÑŠÐ·ÐºÐ°',0),(234115,6504,'ur','Ø±Ø¨Ø· ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(234116,6504,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð²ÐµÐ·Ðµ',0),(234117,6504,'vi','Sá»­a ÄÆ°á»ng Dáº«n',0),(234118,6504,'af','Redigeer Skakel',0),(234119,6504,'ro','Modifica Link',0),(234120,6504,'et','Muuda linki',0),(234121,6504,'si','Uredi povezave',0),(234122,6504,'ba','Mengedit Link',0),(234123,6504,'nl','Koppeling bewerken',0),(234124,6504,'fi','Muokkaa linkkiÃ¤',0),(234125,6504,'no','Rediger kobling',0),(234126,6504,'da','Rediger Link',0),(234127,6504,'ko','ë§í¬ íŽ¸ì§‘',0),(234128,6504,'he','×¢×¨×•×š ×§×™×©×•×¨',0),(234129,6504,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î· ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(234130,6504,'zh','ç¼–è¾‘é“¾æŽ¥\r\n',0),(234131,6504,'sv','Redigera lÃ¤nk',0),(234132,6504,'it','Modifica Link',0),(234133,6504,'tl','',0),(234134,6504,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3648;&#3594;&#3639;&#3656;&#3629;&#3617;&#3605;&#3656;&#3629;',0),(234135,6504,'hi','à¤²à¤¿à¤‚à¤• à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(234136,6504,'ms','Edit pautan',0),(234137,6504,'ar','ØªØ­Ø±ÙŠØ± Ø±Ø§Ø¨Ø·',0),(234138,6504,'fr','Modifier lien',0),(234139,6504,'jp','ãƒªãƒ³ã‚¯ã?®ç·¨é›†',0),(234140,6504,'pt','Editar Link',0),(234141,6504,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡ÑÑ‹Ð»ÐºÑƒ',0),(234142,6504,'es','Editar Enlace',0),(234143,6504,'de','Link bearbeiten',0),(234144,6504,'en','Edit Link',0),(234145,6505,'is','',0),(234146,6505,'dr','Ù„ÙŠÙ†Ùƒ ',0),(234147,6505,'pr','Ù„ÙŠÙ†Ùƒ ',0),(234148,6505,'tr','BaÄŸlantÄ±',0),(234149,6505,'pl','Link',0),(234150,6505,'bg','Ð’Ñ€ÑŠÐ·ÐºÐ°',0),(234151,6505,'ur','Ø±Ø¨Ø·',0),(234152,6505,'sr','Ð’ÐµÐ·Ð°',0),(234153,6505,'vi','ÄÆ°á»ng Dáº«n',0),(234154,6505,'af','Skakel',0),(234155,6505,'ro','Link-ul',0),(234156,6505,'et','Link',0),(234157,6505,'si','Povezava',0),(234158,6505,'ba','Link',0),(234159,6505,'nl','Koppeling',0),(234160,6505,'fi','Linkki',0),(234161,6505,'no','Kobling',0),(234162,6505,'da','Link',0),(234163,6505,'ko','ë§í¬',0),(234164,6505,'he','×§×™×©×•×¨',0),(234165,6505,'el','Î£ÏÎ½Î´ÎµÏƒÎ·',0),(234166,6505,'zh','é“¾æŽ¥\r\n',0),(234167,6505,'sv','LÃ¤nk',0),(234168,6505,'it','Collegamento',0),(234169,6505,'tl','',0),(234170,6505,'th','&#3621;&#3636;&#3591;&#3588;&#3660;',0),(234171,6505,'hi','à¤²à¤¿à¤‚à¤•',0),(234172,6505,'ms','Pautan',0),(234173,6505,'ar','Ø±Ø§Ø¨Ø·',0),(234174,6505,'fr','Lien',0),(234175,6505,'jp','ãƒªãƒ³ã‚¯',0),(234176,6505,'pt','Link',0),(234177,6505,'ru','Ð¡ÑÑ‹Ð»ÐºÐ°',0),(234178,6505,'es','Enlace',0),(234179,6505,'de','Link',0),(234180,6505,'en','Link',0),(234181,6506,'is','',0),(234182,6506,'dr','Ù„ÙŠÙ†Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(234183,6506,'pr','Ù„ÙŠÙ†Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(234184,6506,'tr','BaÄŸlantÄ± baÅŸarÄ±yla eklendi',0),(234185,6506,'pl','Link dodany pomyÅ›lnie',0),(234186,6506,'bg','Ð’Ñ€ÑŠÐ·ÐºÐ° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(234187,6506,'ur','Ø±Ø¨Ø· Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(234188,6506,'sr','Ð’ÐµÐ·Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(234189,6506,'vi','ThÃªm ÄÆ°á»ng Dáº«n ThÃ nh CÃ´ng',0),(234190,6506,'af','Skakel suksesvol bygevoeg',0),(234191,6506,'ro','Link adaugat cu succes',0),(234192,6506,'et','Lisatud link',0),(234193,6506,'si','Povezava uspeÅ¡no dodani',0),(234194,6506,'ba','Link ditambahkan berhasil',0),(234195,6506,'nl','Link met succes toegevoegd',0),(234196,6506,'fi','Linkin lisÃ¤Ã¤minen onnistui',0),(234197,6506,'no','Koblingen ble lagt til',0),(234198,6506,'da','Link tilfÃ¸jet',0),(234199,6506,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ë§í¬',0),(234200,6506,'he','×§×™×©×•×¨ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(234201,6506,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(234202,6506,'zh','é“¾æŽ¥æ·»åŠ æˆåŠŸ\r\n',0),(234203,6506,'sv','LÃ¤nk till',0),(234204,6506,'it','Link aggiunto con successo',0),(234205,6506,'tl','',0),(234206,6506,'th','&#3621;&#3636;&#3591;&#3588;&#3660;&#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(234207,6506,'hi','à¤²à¤¿à¤‚à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(234208,6506,'ms','Link yang berjaya menambah',0),(234209,6506,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ø±Ø§Ø¨Ø· Ø¨Ù†Ø¬Ø§Ø­',0),(234210,6506,'fr','Lien ajoutÃ© avec succÃ¨s',0),(234211,6506,'jp','ãƒªãƒ³ã‚¯ã?Œè¿½åŠ ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(234212,6506,'pt','Link adicionado com sucesso',0),(234213,6506,'ru','Ð¡ÑÑ‹Ð»ÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(234214,6506,'es','Enlace agregado exitosamente',0),(234215,6506,'de','Link erfolgreich hinzugefÃ¼gt',0),(234216,6506,'en','Link added successfully',0),(234217,6507,'is','',0),(234218,6507,'dr','Ù„ÙŠÙ†Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(234219,6507,'pr','Ù„ÙŠÙ†Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(234220,6507,'tr','BaÄŸlantÄ± baÅŸarÄ±yla kaydedildi',0),(234221,6507,'pl','ÅÄ…cza zapisane',0),(234222,6507,'bg','Ð’Ñ€ÑŠÐ·ÐºÐ°, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(234223,6507,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ù„Ù†Ú©',0),(234224,6507,'sr','Ð’ÐµÐ·Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(234225,6507,'vi','Sao LÆ°u ÄÆ°á»ng Dáº«n thÃ nh cÃ´ng',0),(234226,6507,'af','Skakel suksesvol Gestoor',0),(234227,6507,'ro','Link-ul salvat cu succes',0),(234228,6507,'et','Link salvestati edukalt',0),(234229,6507,'si','Povezava uspeÅ¡no shranjen',0),(234230,6507,'ba','Link yang berhasil diselamatkan',0),(234231,6507,'nl','URI met success verwijderd',0),(234232,6507,'fi','Linkki tallennettu',0),(234233,6507,'no','Link lagret',0),(234234,6507,'da','Link gemt med succes',0),(234235,6507,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ ë§í¬',0),(234236,6507,'he','×”×§×™×©×•×¨ × ×©×ž×¨ ×‘×”×¦×œ×—×”',0),(234237,6507,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(234238,6507,'zh','é“¾æŽ¥ä¿å­˜æˆåŠŸ\r\n',0),(234239,6507,'sv','LÃ¤nk sparats',0),(234240,6507,'it','Link salvato correttamente',0),(234241,6507,'tl','',0),(234242,6507,'th','&#3621;&#3636;&#3591;&#3588;&#3660;&#3606;&#3641;&#3585;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(234243,6507,'hi','à¤²à¤¿à¤‚à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(234244,6507,'ms','Link yang berjaya disimpan',0),(234245,6507,'ar','Ø­ÙØ¸ Ø§Ù„Ø±Ø§Ø¨Ø· Ø¨Ù†Ø¬Ø§Ø­',0),(234246,6507,'fr','Lien enregistrÃ© avec succÃ¨s',0),(234247,6507,'jp','ãƒªãƒ³ã‚¯ã?Œä¿?å­˜ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(234248,6507,'pt','Link com sucesso',0),(234249,6507,'ru','Ð¡ÑÑ‹Ð»ÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð°',0),(234250,6507,'es','Enlace guardado exitosamente',0),(234251,6507,'de','Link erfolgreich gespeichert',0),(234252,6507,'en','Link saved successfully',0),(234253,6508,'is','',0),(234254,6508,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÙŠÙ†Ùƒ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(234255,6508,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÙŠÙ†Ùƒ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(234256,6508,'tr','BaÄŸlantÄ±yÄ± dÃ¼zenlemek iÃ§in seÃ§in',0),(234257,6508,'pl','Wybierz Link do edycji',0),(234258,6508,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð²Ñ€ÑŠÐ·ÐºÐ° Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(234259,6508,'ur','Ø±Ø¨Ø· ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(234260,6508,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð²ÐµÐ·Ñƒ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(234261,6508,'vi','Chá»n ÄÆ°á»ng Dáº«n Äá»ƒ Sá»­a',0),(234262,6508,'af','Selekteer Skakel om te Redigeer',0),(234263,6508,'ro','SelectaÅ£i link-ul pentru a edita',0),(234264,6508,'et','Valige lingi redigeerimine',0),(234265,6508,'si','Izberite povezavo za urejanje',0),(234266,6508,'ba','Pilih Link untuk mengedit',0),(234267,6508,'nl','Selecteer koppeling om te bewerken',0),(234268,6508,'fi','Valitsemalla linkin voit muokata',0),(234269,6508,'no','Velg koblingen for Ã¥ redigere',0),(234270,6508,'da','VÃ¦lg hyperlink for at redigere',0),(234271,6508,'ko','íŽ¸ì§‘ ë§í¬ë¥¼ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(234272,6508,'he','×‘×—×¨ ×§×™×©×•×¨ ×œ×¢×¨×™×›×ª',0),(234273,6508,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ ÏƒÏÎ½Î´ÎµÏƒÎ¼Î¿ Î³Î¹Î± Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(234274,6508,'zh','é€‰æ‹©é“¾æŽ¥åˆ°ç¼–è¾‘\r\n',0),(234275,6508,'sv','VÃ¤lj lÃ¤nk till redigera',0),(234276,6508,'it','Selezionare il Link per modificare',0),(234277,6508,'tl','',0),(234278,6508,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3621;&#3636;&#3591;&#3588;&#3660;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(234279,6508,'hi','à¤²à¤¿à¤‚à¤• à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(234280,6508,'ms','Pilih pautan untuk mengedit',0),(234281,6508,'ar','Ø¥Ø®ØªÙŠØ§Ø± Ø±Ø§Ø¨Ø· Ù„Ù„ØªØ­Ø±ÙŠØ±',0),(234282,6508,'fr','SÃ©lectionnez le lien pour modifier',0),(234283,6508,'jp','ç·¨é›†ã?™ã‚‹ãƒªãƒ³ã‚¯ã‚’é?¸æŠž',0),(234284,6508,'pt','Selecione o Link para editar',0),(234285,6508,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¡ÑÑ‹Ð»ÐºÑƒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(234286,6508,'es','Seleccionar Enlace para Editar',0),(234287,6508,'de','WÃ¤hlen Sie bearbeiten',0),(234288,6508,'en','Select Link to Edit',0),(234289,6509,'is','',0),(234290,6509,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª',0),(234291,6509,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª',0),(234292,6509,'tr','Internet\'te URL',0),(234293,6509,'pl','Internetowy adres URL',0),(234294,6509,'bg','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚ URL',0),(234295,6509,'ur','Ø§Ù†Ù¹Ø±Ù†ÛŒÙ¹ URL',0),(234296,6509,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚ Ð£Ð Ð›',0),(234297,6509,'vi','ÄÆ°á»ng dáº«n Internet',0),(234298,6509,'af','Internet BA (\"URL\")',0),(234299,6509,'ro','URL-ul de Internet',0),(234300,6509,'et','URL',0),(234301,6509,'si','Internet URL',0),(234302,6509,'ba','Internet URL',0),(234303,6509,'nl','Internet-URL',0),(234304,6509,'fi','URL-osoite',0),(234305,6509,'no','Internett-adresse',0),(234306,6509,'da','Internet URL',0),(234307,6509,'ko','ì¸í„°ë„· URL',0),(234308,6509,'he','×›×ª×•×‘×ª ××™× ×˜×¨× ×˜',0),(234309,6509,'el','Internet URL',0),(234310,6509,'zh','äº’è”ç½‘ç½‘å€\r\n',0),(234311,6509,'sv','Internet-URL',0),(234312,6509,'it','URL di Internet',0),(234313,6509,'tl','',0),(234314,6509,'th','Internet URL',0),(234315,6509,'hi','à¤‡à¤‚à¤Ÿà¤°à¤¨à¥‡à¤Ÿ à¤¯à¥‚à¤†à¤°à¤à¤²',0),(234316,6509,'ms','Internet URL',0),(234317,6509,'ar','URL Ø¹Ù„Ù‰ Ø¥Ù†ØªØ±Ù†Øª',0),(234318,6509,'fr','URL Internet',0),(234319,6509,'jp','ã‚¤ãƒ³ã‚¿ãƒ¼ãƒ?ãƒƒãƒˆURL',0),(234320,6509,'pt','URL da Internet',0),(234321,6509,'ru','URL-Ð°Ð´Ñ€ÐµÑ Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚',0),(234322,6509,'es','URL de Internet',0),(234323,6509,'de','Internet-URL',0),(234324,6509,'en','Internet URL',0),(234325,6510,'is','',0),(234326,6510,'dr','Ù„ÙŠÙ†Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(234327,6510,'pr','Ù„ÙŠÙ†Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(234328,6510,'tr','BaÄŸlantÄ± baÅŸarÄ±yla silindi',0),(234329,6510,'pl','Link usuniÄ™ty',0),(234330,6510,'bg','Ð›Ð¸Ð½Ðº Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(234331,6510,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù„Ù†Ú©',0),(234332,6510,'sr','Ð’ÐµÐ·Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(234333,6510,'vi','XÃ³a ÄÆ°á»ng Dáº«n ThÃ nh CÃ´ng',0),(234334,6510,'af','Skakel suksesvol geskrap',0),(234335,6510,'ro','Link ÅŸters cu succes',0),(234336,6510,'et','Edukalt kustutatud link',0),(234337,6510,'si','Povezava uspeÅ¡no izbrisana',0),(234338,6510,'ba','Link dihapus berhasil',0),(234339,6510,'nl','Link met succes verwijderd',0),(234340,6510,'fi','Linkki poistettu',0),(234341,6510,'no','Linken ble slettet',0),(234342,6510,'da','Link slettet',0),(234343,6510,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ë§í¬',0),(234344,6510,'he','×§×™×©×•×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(234345,6510,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(234346,6510,'zh','é“¾æŽ¥å·²æˆåŠŸåˆ é™¤\r\n',0),(234347,6510,'sv','LÃ¤nk raderades',0),(234348,6510,'it','Link cancellato con successo',0),(234349,6510,'tl','',0),(234350,6510,'th','&#3621;&#3636;&#3591;&#3588;&#3660;&#3606;&#3641;&#3585;&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(234351,6510,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤²à¤¿à¤‚à¤•',0),(234352,6510,'ms','Pautan dihapuskan dengan jayanya',0),(234353,6510,'ar','Ø­Ø°Ù Ø§Ù„Ø±Ø§Ø¨Ø· Ø¨Ù†Ø¬Ø§Ø­',0),(234354,6510,'fr','Lien supprimÃ© avec succÃ¨s',0),(234355,6510,'jp','ãƒªãƒ³ã‚¯ã?Œæ¶ˆåŽ»ã?•ã‚Œã?¾ã?—ã?Ÿ',0),(234356,6510,'pt','Link excluÃ­do com Ãªxito',0),(234357,6510,'ru','Ð¡ÑÑ‹Ð»ÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð°',0),(234358,6510,'es','Enlace eliminado exitosamente',0),(234359,6510,'de','Link erfolgreich gelÃ¶scht',0),(234360,6510,'en','Link deleted successfully',0),(234361,6511,'is','',0),(234362,6511,'dr','Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ ',0),(234363,6511,'pr','Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ ',0),(234364,6511,'tr','Varolan baÄŸlantÄ±lar',0),(234365,6511,'pl','IstniejÄ…ce Å‚Ä…cza',0),(234366,6511,'bg','Ð¡ÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ Ð²Ñ€ÑŠÐ·ÐºÐ¸',0),(234367,6511,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø±ÙˆØ§Ø¨Ø·',0),(234368,6511,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð²ÐµÐ·Ðµ',0),(234369,6511,'vi','ÄÆ°á»ng Dáº«n Hiá»‡n Táº¡i',0),(234370,6511,'af','Bestaande Skakels',0),(234371,6511,'ro','Link-uri existente',0),(234372,6511,'et','Olemasolevaid sidemeid',0),(234373,6511,'si','ObstojeÄe povezave',0),(234374,6511,'ba','Tautan yang ada',0),(234375,6511,'nl','Bestaande koppelingen',0),(234376,6511,'fi','Olemassa olevat linkit',0),(234377,6511,'no','Eksisterende koblinger',0),(234378,6511,'da','Eksisterende kÃ¦der',0),(234379,6511,'ko','ê¸°ì¡´ ë§í¬',0),(234380,6511,'he','×§×™×©×•×¨×™× ×§×™×™×ž×™×',0),(234381,6511,'el','Î¥Ï€Î±ÏÏ‡ÏŒÎ½Ï„Ï‰Î½ ÏƒÏ…Î½Î´Î­ÏƒÎµÏ‰Î½',0),(234382,6511,'zh','çŽ°æœ‰é“¾æŽ¥\r\n',0),(234383,6511,'sv','Befintliga lÃ¤nkar',0),(234384,6511,'it','Collegamenti esistenti',0),(234385,6511,'tl','',0),(234386,6511,'th','&#3621;&#3636;&#3591;&#3588;&#3660;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;',0),(234387,6511,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤²à¤¿à¤‚à¤•',0),(234388,6511,'ms','Pautan yang sedia ada',0),(234389,6511,'ar','Ø§Ù„Ø±ÙˆØ§Ø¨Ø· Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø© Ù…Ø³Ø¨Ù‚Ø§',0),(234390,6511,'fr','Liens existants',0),(234391,6511,'jp','å­˜åœ¨ã?™ã‚‹ãƒªãƒ³ã‚¯',0),(234392,6511,'pt','LigaÃ§Ãµes existentes',0),(234393,6511,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð¡ÑÑ‹Ð»ÐºÐ¸',0),(234394,6511,'es','Enlaces Existentes',0),(234395,6511,'de','Vorhandene VerknÃ¼pfungen',0),(234396,6511,'en','Existing Links',0),(234397,6512,'is','',0),(234398,6512,'dr','Ù‡ÙŠÚ† Ù„ÙŠÙ†ÙƒÙŠ ØªØ§ÙƒÙ†ÙˆÙ† ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ ',0),(234399,6512,'pr','Ù‡ÙŠÚ† Ù„ÙŠÙ†ÙƒÙŠ ØªØ§ÙƒÙ†ÙˆÙ† ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ ',0),(234400,6512,'tr','HenÃ¼z o takÄ±lÄ± hiÃ§bir baÄŸlantÄ±larÄ±',0),(234401,6512,'pl','Dodaje siÄ™ jeszcze nie linki',0),(234402,6512,'bg','ÐÑÐ¼Ð° Ð²Ñ€ÑŠÐ·ÐºÐ¸ Ð²ÑÐµ Ð¾Ñ‰Ðµ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½',0),(234403,6512,'ur','Ø§Ø¨Ú¾ÛŒ ØªÚ© Ú©ÙˆØ¦ÛŒ Ø±ÙˆØ§Ø¨Ø· Ø¯Ø§Ø®Ù„ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(234404,6512,'sr','ÐÐµÐ¼Ð° Ð²ÐµÐ·Ðµ, Ð¸Ð¿Ð°Ðº ÑƒÐ¼ÐµÑ‚Ð½ÑƒÑ‚',0),(234405,6512,'vi','KhÃ´ng cÃ³ ÄÆ°á»ng Dáº«n chÃ¨n vÃ o',0),(234406,6512,'af','Geen skakels nog ingevoeg',0),(234407,6512,'ro','Link-uri fÄƒrÄƒ Ã®ncÄƒ inserate',0),(234408,6512,'et','Puuduvad sidemed veel lisada',0),(234409,6512,'si','Ni povezav Å¡e Vstavi',0),(234410,6512,'ba','Tidak ada link belum dimasukkan',0),(234411,6512,'nl','Geen Links nog ingevoegd',0),(234412,6512,'fi','LinkkejÃ¤ ei ole vielÃ¤ lisÃ¤tty',0),(234413,6512,'no','Ingen koblinger ennÃ¥ satt inn',0),(234414,6512,'da','Ingen Links endnu indsat',0),(234415,6512,'ko','ë§í¬ ì•„ì§ ì‚½ìž…',0),(234416,6512,'he','××™×Ÿ ×§×™×©×•×¨×™× ×›×‘×¨ ×ž×•×›× ×¡',0),(234417,6512,'el','Î”ÎµÎ½ ÏƒÏ…Î½Î´Î­ÏƒÎµÎ¹Ï‚ Î±ÎºÏŒÎ¼Î· ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯',0),(234418,6512,'zh','è¿˜æ²¡æœ‰æ’å…¥é“¾æŽ¥\r\n',0),(234419,6512,'sv','Inga lÃ¤nkar Ã¤nnu infÃ¶ras',0),(234420,6512,'it','Nessun link inserito ancora.',0),(234421,6512,'tl','',0),(234422,6512,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3621;&#3636;&#3591;&#3588;&#3660;&#3651;&#3609;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(234423,6512,'hi','à¤•à¥‹à¤ˆ à¤²à¤¿à¤‚à¤• à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤…à¤­à¥€ à¤¤à¤•',0),(234424,6512,'ms','Pautan tidak lagi dimasukkan',0),(234425,6512,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ù„Ø§ Ø±ÙˆØ§Ø¨Ø· Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(234426,6512,'fr','Aucuns liens encore n\'insÃ©rÃ©',0),(234427,6512,'jp','ãƒªãƒ³ã‚¯ã?Œã?¾ã? ä¸€ã?¤ã‚‚æŒ¿å…¥ã?•ã‚Œã?¦ã?„ã?¾ã?›ã‚“',0),(234428,6512,'pt','NÃ£o hÃ¡ Links ainda inserido',0),(234429,6512,'ru','ÐŸÐ¾ÐºÐ° ÐÐµÑ‚ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹Ñ… Ð¡ÑÑ‹Ð»Ð¾Ðº',0),(234430,6512,'es','Ya No Hay Enlaces Insertados',0),(234431,6512,'de','Keine Links noch eingefÃ¼gt',0),(234432,6512,'en','No Links Yet Inserted',0),(234433,6513,'is','',0),(234434,6513,'dr','Ù†Ø§Ù… Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ ',0),(234435,6513,'pr','Ù†Ø§Ù… Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ ',0),(234436,6513,'tr','Ajans adÄ±',0),(234437,6513,'pl','Nazwa agencji',0),(234438,6513,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐÐ³ÐµÐ½Ñ†Ð¸ÑÑ‚Ð°',0),(234439,6513,'ur','Ø§ÛŒØ¬Ù†Ø³ÛŒ Ú©Ø§ Ù†Ø§Ù…',0),(234440,6513,'sr','ÐÐ³ÐµÐ½Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ð¸Ð¼Ðµ',0),(234441,6513,'vi','TÃªn Äáº¡i LÃ½',0),(234442,6513,'af','Agentskapnaam',0),(234443,6513,'ro','Nume de agentie',0),(234444,6513,'et','Asutuse nimi',0),(234445,6513,'si','Ime agencije',0),(234446,6513,'ba','Nama lembaga',0),(234447,6513,'nl','Agentschap naam',0),(234448,6513,'fi','Viraston nimi',0),(234449,6513,'no','Etat navn',0),(234450,6513,'da','Agenturets navn',0),(234451,6513,'ko','ê¸°ê´€ ì´ë¦„',0),(234452,6513,'he','×©× ×”×¡×•×›× ×•×ª:',0),(234453,6513,'el','ÎŒÎ½Î¿Î¼Î± Î¿ÏÎ³Î±Î½Î¹ÏƒÎ¼Î¿Ï',0),(234454,6513,'zh','è¡ŒéŠ·æœºæž„åç§°\r\n',0),(234455,6513,'sv','ByrÃ¥ns namn',0),(234456,6513,'it','Nome agenzia',0),(234457,6513,'tl','',0),(234458,6513,'th','&#3594;&#3639;&#3656;&#3629;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(234459,6513,'hi','à¤à¤œà¥‡à¤‚à¤¸à¥€ à¤•à¤¾ à¤¨à¤¾à¤®',0),(234460,6513,'ms','Nama agensi',0),(234461,6513,'ar','Ø±Ù‚Ù… Ø§Ù„ÙˆÙƒØ§Ù„Ø©',0),(234462,6513,'fr','Nom de l\'Agence',0),(234463,6513,'jp','ä»£ç?†åº—å??',0),(234464,6513,'pt','Nome da AgÃªncia',0),(234465,6513,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð°Ð³ÐµÐ½Ñ‚ÑÑ‚Ð²Ð°',0),(234466,6513,'es','Nombre de Agencia',0),(234467,6513,'de','Name der Agentur',0),(234468,6513,'en','Agency Name',0),(234469,6514,'is','',0),(234470,6514,'dr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(234471,6514,'pr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(234472,6514,'tr','Ajan',0),(234473,6514,'pl','Agenta',0),(234474,6514,'bg','ÐÐ³ÐµÐ½Ñ‚',0),(234475,6514,'ur','Ø§ÛŒØ¬Ù†Ù¹',0),(234476,6514,'sr','ÐÐ³ÐµÐ½Ñ‚Ðµ',0),(234477,6514,'vi','Äáº¡i LÃ½',0),(234478,6514,'af','Agent',0),(234479,6514,'ro','Agent',0),(234480,6514,'et','Agent',0),(234481,6514,'si','Agent',0),(234482,6514,'ba','Agen',0),(234483,6514,'nl','Agent',0),(234484,6514,'fi','Agentti',0),(234485,6514,'no','Agent',0),(234486,6514,'da','Agent',0),(234487,6514,'ko','ì—ì´ì „íŠ¸',0),(234488,6514,'he','×”×¡×•×›×Ÿ',0),(234489,6514,'el','Î ÏÎ¬ÎºÏ„Î¿ÏÎ±Ï‚',0),(234490,6514,'zh','ä»£ç†\r\n',0),(234491,6514,'sv','Agent',0),(234492,6514,'it','Agente',0),(234493,6514,'tl','',0),(234494,6514,'th','&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(234495,6514,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ',0),(234496,6514,'ms','Ejen',0),(234497,6514,'ar','Ø§Ù„ÙˆÙƒÙŠÙ„',0),(234498,6514,'fr','Agent',0),(234499,6514,'jp','ä»£ç?†åº—',0),(234500,6514,'pt','Agente',0),(234501,6514,'ru','ÐÐ³ÐµÐ½Ñ‚',0),(234502,6514,'es','Agente',0),(234503,6514,'de','Agent',0),(234504,6514,'en','Agent',0),(234505,6515,'is','',0),(234506,6515,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ',0),(234507,6515,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø¨Ø±Ø§ÙŠ',0),(234508,6515,'tr','FaturalarÄ± & Ã¶demeler iÃ§in',0),(234509,6515,'pl','Rachunki & pÅ‚atnoÅ›ci dla',0),(234510,6515,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ & Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð·Ð°',0),(234511,6515,'ur','Ø¨Ù„ & Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Û’ Ù„ÛŒÛ’',0),(234512,6515,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ Ð¸ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð·Ð°',0),(234513,6515,'vi','HÃ³a ÄÆ¡n & Thanh ToÃ¡n cho',0),(234514,6515,'af','Rekeninge & Betalings vir',0),(234515,6515,'ro','Facturile & plÄƒÅ£i pentru',0),(234516,6515,'et','Arved ja maksed:',0),(234517,6515,'si','Menice & plaÄila za',0),(234518,6515,'ba','Tagihan & pembayaran untuk',0),(234519,6515,'nl','Rekeningen & betalingen voor',0),(234520,6515,'fi','Laskut & maksut',0),(234521,6515,'no','Regninger & betalinger for',0),(234522,6515,'da','Regninger & betalinger for',0),(234523,6515,'ko','ì§€í &ì— ëŒ€ í•œ ì§€ë¶ˆ',0),(234524,6515,'he','×—×©×‘×•× ×•×ª ×•×ª×©×œ×•×ž×™× ×¢×‘×•×¨',0),(234525,6515,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ & Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î³Î¹Î±',0),(234526,6515,'zh','æ¡ä¾‹è‰æ¡ˆåŠä»˜æ¬¾çš„\r\n',0),(234527,6515,'sv','RÃ¤kningar & betalningar fÃ¶r',0),(234528,6515,'it','Bollette & pagamenti per',0),(234529,6515,'tl','',0),(234530,6515,'th','&#3623;&#3634;&#3591;&#3610;&#3636;&#3621;&#3649;&#3621;&#3632;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(234531,6515,'hi','à¤¬à¤¿à¤² & à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(234532,6515,'ms','Bil & pembayaran bagi',0),(234533,6515,'ar','ÙÙˆØ§ØªÙŠØ± Ø¢Ù†Ø¯ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¹Ù†',0),(234534,6515,'fr','Projets de loi & de paiements pour',0),(234535,6515,'jp','ï½žã?®è«‹æ±‚æ›¸ã?¨æ”¯æ‰•ã?„',0),(234536,6515,'pt','Contas & pagamentos para',0),(234537,6515,'ru','Ð—Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ñ‹ & Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð·Ð°',0),(234538,6515,'es','Facturas y Pagos para',0),(234539,6515,'de','Rechnungen & Zahlungen fÃ¼r',0),(234540,6515,'en','Bills & Payments for',0),(234541,6516,'is','',0),(234542,6516,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(234543,6516,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(234544,6516,'tr','Ã–deme raporu',0),(234545,6516,'pl','Raport pÅ‚atnoÅ›ci',0),(234546,6516,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(234547,6516,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(234548,6516,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(234549,6516,'vi','BÃ¡o CÃ¡o Thanh ToÃ¡n',0),(234550,6516,'af','Betalingsverslag',0),(234551,6516,'ro','Raport de platÄƒ',0),(234552,6516,'et','Aruanne',0),(234553,6516,'si','PlaÄilo poroÄilo',0),(234554,6516,'ba','Laporan pembayaran',0),(234555,6516,'nl','Betaling verslag',0),(234556,6516,'fi','Maksuraportti',0),(234557,6516,'no','Betaling rapport',0),(234558,6516,'da','Betaling rapport',0),(234559,6516,'ko','ì§€ë¶ˆ ë³´ê³ ì„œ',0),(234560,6516,'he','×“×•×— ×ª×©×œ×•×',0),(234561,6516,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î·Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(234562,6516,'zh','ä»˜æ¬¾æŠ¥å‘Š\r\n',0),(234563,6516,'sv','Betalning rapport',0),(234564,6516,'it','Rapporto di pagamento',0),(234565,6516,'tl','',0),(234566,6516,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(234567,6516,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(234568,6516,'ms','Laporan pembayaran',0),(234569,6516,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø³Ø¯Ø§Ø¯',0),(234570,6516,'fr','Rapport de paiement',0),(234571,6516,'jp','æ”¯æ‰•ãƒ¬ãƒ?ãƒ¼ãƒˆ',0),(234572,6516,'pt','RelatÃ³rio de pagamento',0),(234573,6516,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐžÑ‚Ñ‡ÐµÑ‚',0),(234574,6516,'es','Informe de Pagos',0),(234575,6516,'de','Zahlung-Bericht',0),(234576,6516,'en','Payment Report',0),(234577,6517,'is','',0),(234578,6517,'dr','ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(234579,6517,'pr','ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(234580,6517,'tr','SatÄ±nalma sipariÅŸ durumu',0),(234581,6517,'pl','Stan zamÃ³wienia zakupu',0),(234582,6517,'bg','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(234583,6517,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(234584,6517,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ',0),(234585,6517,'vi','TÃ¬nh tráº¡ng ÄÆ¡n Mua HÃ ng',0),(234586,6517,'af','Aankoopbestelling Status',0),(234587,6517,'ro','Stare de comandÄƒ cumpÄƒrare',0),(234588,6517,'et','Ostu tellimuse olek',0),(234589,6517,'si','Stanje naroÄilnice',0),(234590,6517,'ba','Status Order Pembelian',0),(234591,6517,'nl','Aankoop orderstatus',0),(234592,6517,'fi','Ostotilauksen tila',0),(234593,6517,'no','KjÃ¸p bestillingsstatus',0),(234594,6517,'da','KÃ¸b ordrestatus',0),(234595,6517,'ko','êµ¬ë§¤ ì£¼ë¬¸ í˜„í™©',0),(234596,6517,'he','×ž×¦×‘ ×”×–×ž× ×ª ×¨×›×™×©×”',0),(234597,6517,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î±Î³Î¿ÏÎ¬Ï‚',0),(234598,6517,'zh','é‡‡è´­è®¢å•çŠ¶æ€\r\n',0),(234599,6517,'sv','KÃ¶p orderstatus',0),(234600,6517,'it','Stato dell\'ordine acquisto',0),(234601,6517,'tl','',0),(234602,6517,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(234603,6517,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(234604,6517,'ms','Status pesanan pembelian',0),(234605,6517,'ar','Ø­Ø§Ù„Ø© Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(234606,6517,'fr','Statut de commande d\'achat',0),(234607,6517,'jp','ç™ºæ³¨æ›¸çŠ¶æ³?',0),(234608,6517,'pt','Status de ordem de compra',0),(234609,6517,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°ÐºÐ°Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(234610,6517,'es','Status de Orden de Compra',0),(234611,6517,'de','Kauf-Bestellstatus',0),(234612,6517,'en','Purchase Order Status',0),(234613,6518,'is','',0),(234614,6518,'dr','Ø§Ø±Ø³Ø§Ù„  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(234615,6518,'pr','Ø§Ø±Ø³Ø§Ù„  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(234616,6518,'tr','Gemi PO',0),(234617,6518,'pl','Statek PO',0),(234618,6518,'bg','ÐšÐ¾Ñ€Ð°Ð± PO',0),(234619,6518,'ur','Ø¬ÛØ§Ø² Ù¾Ùˆ',0),(234620,6518,'sr','Ð‘Ñ€Ð¾Ð´ ÐŸÐž',0),(234621,6518,'vi','ÄÆ¡n mua hÃ ng váº­n chuyá»ƒn',0),(234622,6518,'af','Versend AB',0),(234623,6518,'ro','Nava PO',0),(234624,6518,'et','Laeva PO',0),(234625,6518,'si','Ladja PO',0),(234626,6518,'ba','Kapal PO',0),(234627,6518,'nl','Schip PO',0),(234628,6518,'fi','Aluksen PO',0),(234629,6518,'no','Skipet PO',0),(234630,6518,'da','Skibet PO',0),(234631,6518,'ko','ë°° í¬',0),(234632,6518,'he','×”×¡×¤×™× ×” ×¤×•',0),(234633,6518,'el','Î Î»Î¿Î¯Î¿ PO',0),(234634,6518,'zh','èˆ¹èˆ¶è®¢å•\r\n',0),(234635,6518,'sv','Skeppet PO',0),(234636,6518,'it','Nave PO',0),(234637,6518,'tl','',0),(234638,6518,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(234639,6518,'hi','à¤œà¤¹à¤¾à¤œ à¤ªà¥‹',0),(234640,6518,'ms','Kapal PO',0),(234641,6518,'ar','Ø³ÙÙŠÙ†Ø© Ø¨Ùˆ',0),(234642,6518,'fr','Navire PO',0),(234643,6518,'jp','ç™ºé€?æ³¨æ–‡æ›¸',0),(234644,6518,'pt','Nave PO',0),(234645,6518,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ PO',0),(234646,6518,'es','Enviar OC',0),(234647,6518,'de','Schiff PO',0),(234648,6518,'en','Ship PO',0),(234649,6519,'is','',0),(234650,6519,'dr','Ø§Ø±Ø³Ø§Ù„  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙŠØ§ Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(234651,6519,'pr','Ø§Ø±Ø³Ø§Ù„  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙŠØ§ Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(234652,6519,'tr','PO gemi veya notlar ekleme',0),(234653,6519,'pl','Statek PO lub dodaÄ‡ notatki',0),(234654,6519,'bg','PO Ð·Ð° Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(234655,6519,'ur','Ù¾Ùˆ Ø¬ÛØ§Ø² ÛŒØ§ Ù†ÙˆÙ¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(234656,6519,'sr','Ð‘Ñ€Ð¾Ð´ ÐŸÐž Ð¸Ð»Ð¸ Ð´Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(234657,6519,'vi','ÄÆ¡n mua hÃ ng váº­n chuyá»ƒn hay thÃªm ghi chÃº',0),(234658,6519,'af','Versend AB of Notas Byvoeg',0),(234659,6519,'ro','Nava PO sau adÄƒuga note',0),(234660,6519,'et','Laeva PO vÃµi lisada mÃ¤rkmeid',0),(234661,6519,'si','Ladja PO ali dodajanje opomb',0),(234662,6519,'ba','Kapal PO atau menambahkan catatan',0),(234663,6519,'nl','PO van het schip of notities toevoegen',0),(234664,6519,'fi','Aluksen PO tai lisÃ¤tÃ¤ muistiinpanoja',0),(234665,6519,'no','Skipet PO eller sammenlegge notater',0),(234666,6519,'da','Skibet PO eller tilfÃ¸je noter',0),(234667,6519,'ko','í¬ ë°° ë˜ëŠ” ë©”ëª¨ ì¶”ê°€',0),(234668,6519,'he','×”×¡×¤×™× ×” PO ××• ×œ×”×•×¡×™×£ ×”×¢×¨×•×ª',0),(234669,6519,'el','Î Î»Î¿Î¯Î¿ PO Î® Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(234670,6519,'zh','èˆ¹èˆ¶POæˆ–æ·»åŠ å¤‡æ³¨\r\n',0),(234671,6519,'sv','Fartyg PO eller lÃ¤gga till anteckningar',0),(234672,6519,'it','Nave PO o aggiungere note',0),(234673,6519,'tl','',0),(234674,6519,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3649;&#3621;&#3632;&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(234675,6519,'hi','à¤ªà¥€à¤“ à¤œà¤¹à¤¾à¤œ à¤¯à¤¾ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(234676,6519,'ms','Kapal PO atau menambah Nota-Nota',0),(234677,6519,'ar','Ø³ÙÙŠÙ†Ø© Ø¨Ùˆ Ø£Ùˆ Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(234678,6519,'fr','ExpÃ©dier PO ou ajouter des Notes',0),(234679,6519,'jp','ç™ºé€?æ³¨æ–‡æ›¸ã‚‚ã?—ã??ã?¯è¿½åŠ ãƒ¡ãƒ¢',0),(234680,6519,'pt','Navio PO ou adicionar notas',0),(234681,6519,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ PO Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÑÑ‚ÑŒ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(234682,6519,'es','Enviar OC o Agregar Notas',0),(234683,6519,'de','Versand von PO oder Notizen hinzufÃ¼gen',0),(234684,6519,'en','Ship PO or Add Notes',0),(234685,6520,'is','',0),(234686,6520,'dr','/ Ø¢Ù¾Ø¯ÛŒØª  ',0),(234687,6520,'pr','Ù„ÙŠÙ†Ùƒ  Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ',0),(234688,6520,'tr','BaÄŸlantÄ± yeni/DÃ¼zenle',0),(234689,6520,'pl','Nowe Å‚Ä…cze/edycja',0),(234690,6520,'bg','ÐÐ¾Ð²Ð° Ð²Ñ€ÑŠÐ·ÐºÐ°/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(234691,6520,'ur','Ù†Ø¦Û’ Ø±Ø¨Ø·/ØªØ¯ÙˆÛŒÙ†',0),(234692,6520,'sr','Ð’ÐµÐ·Ð° ÑÐ° Ð½Ð¾Ð²Ð¸Ð¼/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(234693,6520,'vi','ThÃªm/Cáº­p Nháº­t ÄÆ°á»ng Dáº«n',0),(234694,6520,'af','Skakel Byvoeg/Opdateer',0),(234695,6520,'ro','Link Adauga/Actualizeaza',0),(234696,6520,'et','Link uus/Muuda',0),(234697,6520,'si','Povezava novega/Uredi',0),(234698,6520,'ba','Link baru/Edit',0),(234699,6520,'nl','URI Toevoegen/Bijwerken',0),(234700,6520,'fi','Uusi linkki/Muokkaa',0),(234701,6520,'no','Koblingen ny/Rediger',0),(234702,6520,'da','Link nyt/Rediger',0),(234703,6520,'ko','ì—°ê²° ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘',0),(234704,6520,'he','×”×•×¡×£/×¢×“×›×Ÿ ×§×™×©×•×¨',0),(234705,6520,'el','ÎÎ­Î± ÏƒÏÎ½Î´ÎµÏƒÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(234706,6520,'zh','é“¾æŽ¥æ·»åŠ /æ›´æ–°\r\n',0),(234707,6520,'sv','Ny lÃ¤nk/redigera',0),(234708,6520,'it','Collegamento nuovo/modifica',0),(234709,6520,'tl','',0),(234710,6520,'th','&#3621;&#3636;&#3591;&#3588;&#3660; &#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(234711,6520,'hi','à¤¨à¤ˆ à¤²à¤¿à¤‚à¤•/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(234712,6520,'ms','Link baru/Edit',0),(234713,6520,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø±Ø§Ø¨Ø·',0),(234714,6520,'fr','Nouveau lien/modifier',0),(234715,6520,'jp','ãƒªãƒ³ã‚¯ã€€è¿½åŠ /æ›´æ–°',0),(234716,6520,'pt','Novo link/editar',0),(234717,6520,'ru','Ð¡ÑÑ‹Ð»ÐºÐ° Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(234718,6520,'es','Enlazar Agregar/Actualizar',0),(234719,6520,'de','Link neu/bearbeiten',0),(234720,6520,'en','Link New/Edit',0),(234721,6521,'is','',0),(234722,6521,'dr','Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ù†ÙˆØ§Ø± Ù…Ù†Ùˆ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø³Ø§ÙŠØª Ù‡Ø§ÙŠ Ø®Ø§Ø±Ø¬ÙŠ ÙƒÙ†ØªØ±Ù„ Ù…ÙŠ ÙƒÙ†Ø¯ ',0),(234723,6521,'pr','Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ù†ÙˆØ§Ø± Ù…Ù†Ùˆ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø³Ø§ÙŠØª Ù‡Ø§ÙŠ Ø®Ø§Ø±Ø¬ÙŠ ÙƒÙ†ØªØ±Ù„ Ù…ÙŠ ÙƒÙ†Ø¯ ',0),(234724,6521,'tr','DÄ±ÅŸ sitelere denetimleri menÃ¼ Ã§ubuÄŸu baÄŸlantÄ±larÄ±',0),(234725,6521,'pl','Formanty pasek Menu linki do stron zewnÄ™trznych',0),(234726,6521,'bg','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð¸ Ð½Ð° Ð»ÐµÐ½Ñ‚Ð°Ñ‚Ð° Ð²Ñ€ÑŠÐ·ÐºÐ¸ ÐºÑŠÐ¼ Ð²ÑŠÐ½ÑˆÐ½Ð¸ ÑÐ°Ð¹Ñ‚Ð¾Ð²Ðµ',0),(234727,6521,'ur','Ø¨ÛŒØ±ÙˆÙ†ÛŒ Ø³Ø§Ø¦Ù¹Ø³ Ø³Û’ Ø±Ø§Ø¨Ø·Û: Ú©Ù†Ù¹Ø±ÙˆÙ„ Ù…ÛŒÙ†ÛŒÙˆ Ø¨Ø§Ø±',0),(234728,6521,'sr','Ð¢Ñ€Ð°ÐºÐ° ÑÐ° Ð¼ÐµÐ½Ð¸Ñ˜Ð¸Ð¼Ð° ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð° Ð²ÐµÐ·Ðµ ÐºÐ° ÑÐ¿Ð¾Ñ™Ð½Ð¸Ð¼ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°Ð¼Ð°',0),(234729,6521,'vi','Kiá»ƒm SoÃ¡t ÄÆ°á»ng Dáº«n Thanh TrÃ¬nh ÄÆ¡n Tá»›i Trang BÃªn NgoÃ i',0),(234730,6521,'af','Kontroles kieslysbalk skakels na eksterne werwe',0),(234731,6521,'ro','Controale Meniu Bar link-uri cÄƒtre site-uri externe',0),(234732,6521,'et','Kontrolli menÃ¼Ã¼riba linke teistele veebisaitidele',0),(234733,6521,'si','Menijski kontrolniki povezave na zunanja spletiÅ¡Äa',0),(234734,6521,'ba','Kontrol Menu Bar link ke situs eksternal',0),(234735,6521,'nl','Besturingselementen menubalk Links naar externe Sites',0),(234736,6521,'fi','Tarkistus-valikkorivi linkkejÃ¤ ulkopuolisiin sivustoihin',0),(234737,6521,'no','Kontroller menylinjen lenker til eksterne nettsteder',0),(234738,6521,'da','Kontroller menuen Bar Links til eksterne websteder',0),(234739,6521,'ko','ì™¸ë¶€ ì‚¬ì´íŠ¸ì— ëŒ€ í•œ ì»¨íŠ¸ë¡¤ ë©”ë‰´ ëª¨ìŒ ë§í¬',0),(234740,6521,'he','×¤×§×“×™ ×”×ª×¤×¨×™×˜×™× ×§×™×©×•×¨×™× ×œ××ª×¨×™× ×—×™×¦×•× ×™×™×',0),(234741,6521,'el','Î“ÏÎ±Î¼Î¼Î® Î¼ÎµÎ½Î¿Ï ÎµÎ»Î­Î³Ï‡Ï‰Î½ Î´Î¹Î±ÏƒÏ…Î½Î´Î­ÏƒÎµÎ¹Ï‚ Î¼Îµ ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÎ­Ï‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚',0),(234742,6521,'zh','æŽ§åˆ¶èœå•æ é“¾æŽ¥åˆ°å¤–éƒ¨ç½‘ç«™\r\n',0),(234743,6521,'sv','Kontroller menyraden lÃ¤nkar till externa webbplatser',0),(234744,6521,'it','Controlli Menu barra collegamenti a siti esterni',0),(234745,6521,'tl','',0),(234746,6521,'th','&#3588;&#3623;&#3610;&#3588;&#3640;&#3617;&#3648;&#3617;&#3609;&#3641;&#3621;&#3636;&#3591;&#3588;&#3660;&#3626;&#3641;&#3656;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585;',0),(234747,6521,'hi','à¤¬à¤¾à¤¹à¤°à¥€ à¤¸à¤¾à¤‡à¤Ÿà¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤¯à¤‚à¤¤à¥à¤°à¤£ à¤®à¥‡à¤¨à¥‚ à¤ªà¤Ÿà¥à¤Ÿà¥€ à¤²à¤¿à¤‚à¤•à¥à¤¸',0),(234748,6521,'ms','Kawalan Menu Bar pautan ke tapak Luaran',0),(234749,6521,'ar','Ø¹Ù†Ø§ØµØ± ØªØ­ÙƒÙ… Ø´Ø±ÙŠØ· Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© ÙˆØµÙ„Ø§Øª Ù„Ù…ÙˆØ§Ù‚Ø¹ Ø®Ø§Ø±Ø¬ÙŠØ©',0),(234750,6521,'fr','Barre de Menu de contrÃ´les des liens vers des Sites externes',0),(234751,6521,'jp','å¤–éƒ¨ã‚µã‚¤ãƒˆã?¸ã?®ãƒ¡ãƒ‹ãƒ¥ãƒ¼ãƒ?ãƒ¼ãƒªãƒ³ã‚¯ã?®è¦?åˆ¶',0),(234752,6521,'pt','Controles de barra de Menu Links para Sites externos',0),(234753,6521,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð¼ÐµÐ½ÑŽ ÑÑÑ‹Ð»ÐºÐ¸ Ð½Ð° Ð²Ð½ÐµÑˆÐ½Ð¸Ðµ ÑÐ°Ð¹Ñ‚Ñ‹',0),(234754,6521,'es','Controla Enlaces a Barra de MenÃº a Sitios Externales',0),(234755,6521,'de','Steuerelemente-MenÃ¼leiste Links zu externen Seiten',0),(234756,6521,'en','Controls Menu Bar Links to External Sites',0),(234757,6522,'is','',0),(234758,6522,'dr','Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø®Ø§Ø±Ø¬ÙŠ ',0),(234759,6522,'pr','Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø®Ø§Ø±Ø¬ÙŠ ',0),(234760,6522,'tr','DÄ±ÅŸ baÄŸlantÄ±lar',0),(234761,6522,'pl','Linki zewnÄ™trzne',0),(234762,6522,'bg','Ð’ÑŠÐ½ÑˆÐ½Ð¸ Ð²Ñ€ÑŠÐ·ÐºÐ¸',0),(234763,6522,'ur','Ø¨ÛŒØ±ÙˆÙ†ÛŒ Ø±ÙˆØ§Ø¨Ø·',0),(234764,6522,'sr','Ð›Ð¸Ð½ÐºÐ¾Ð²Ð¸',0),(234765,6522,'vi','ÄÆ°á»ng Dáº«n NgoÃ i',0),(234766,6522,'af','Eksterne Skakels',0),(234767,6522,'ro','Link-uri externe',0),(234768,6522,'et','VÃ¤lislingid',0),(234769,6522,'si','Zunanje povezave',0),(234770,6522,'ba','Pranala luar',0),(234771,6522,'nl','Externe Links',0),(234772,6522,'fi','Aiheesta muualla',0),(234773,6522,'no','Eksterne lenker',0),(234774,6522,'da','Eksterne Links',0),(234775,6522,'ko','ì™¸ë¶€ ë§í¬',0),(234776,6522,'he','×§×™×©×•×¨×™× ×—×™×¦×•× ×™×™×',0),(234777,6522,'el','Î•Î¾Ï‰Ï„ÎµÏÎ¹ÎºÎ¿Î¯ ÏƒÏÎ½Î´ÎµÏƒÎ¼Î¿Î¹',0),(234778,6522,'zh','å¤–éƒ¨é“¾æŽ¥\r\n',0),(234779,6522,'sv','Externa lÃ¤nkar',0),(234780,6522,'it','Link esterni',0),(234781,6522,'tl','',0),(234782,6522,'th','&#3621;&#3636;&#3591;&#3588;&#3660;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585;',0),(234783,6522,'hi','à¤¬à¤¾à¤¹à¤°à¥€ à¤•à¤¡à¤¼à¤¿à¤¯à¤¾à¤',0),(234784,6522,'ms','Pautan luar',0),(234785,6522,'ar','Ø±ÙˆØ§Ø¨Ø· Ø®Ø§Ø±Ø¬ÙŠØ©',0),(234786,6522,'fr','Liens externes',0),(234787,6522,'jp','å¤–éƒ¨ã?¸ã?®ãƒªãƒ³ã‚¯',0),(234788,6522,'pt','Links externos',0),(234789,6522,'ru','Ð’Ð½ÐµÑˆÐ½Ð¸Ðµ Ð¡ÑÑ‹Ð»ÐºÐ¸',0),(234790,6522,'es','Enlaces Externales',0),(234791,6522,'de','Externe Links',0),(234792,6522,'en','External Links',0),(234793,6523,'is','',0),(234794,6523,'dr','Ù„ÙŠÙ†Ùƒ Ù‡Ø§ ',0),(234795,6523,'pr','Ù„ÙŠÙ†Ùƒ Ù‡Ø§ ',0),(234796,6523,'tr','Linkler',0),(234797,6523,'pl','Linki',0),(234798,6523,'bg','Ð’Ñ€ÑŠÐ·ÐºÐ¸',0),(234799,6523,'ur','Ù„Ù†Ú©Ø³',0),(234800,6523,'sr','Ð’ÐµÐ·Ðµ',0),(234801,6523,'vi','CÃ¡c ÄÆ°á»ng Dáº«n',0),(234802,6523,'af','Skakels',0),(234803,6523,'ro','Linkuri',0),(234804,6523,'et','Lingid',0),(234805,6523,'si','Povezave',0),(234806,6523,'ba','Link',0),(234807,6523,'nl','Koppelingen',0),(234808,6523,'fi','Linkit',0),(234809,6523,'no','Koblinger',0),(234810,6523,'da','Links',0),(234811,6523,'ko','ë§í¬',0),(234812,6523,'he','×§×™×©×•×¨×™×',0),(234813,6523,'el','Î£Ï…Î½Î´Î­ÏƒÎµÎ¹Ï‚',0),(234814,6523,'zh','é“¾æŽ¥\r\n',0),(234815,6523,'sv','LÃ¤nkar',0),(234816,6523,'it','Link',0),(234817,6523,'tl','',0),(234818,6523,'th','&#3621;&#3636;&#3591;&#3588;&#3660;',0),(234819,6523,'hi','à¤•à¤¡à¤¼à¤¿à¤¯à¤¾à¤',0),(234820,6523,'ms','Pautan',0),(234821,6523,'ar','Ø§Ù„Ø±ÙˆØ§Ø¨Ø·',0),(234822,6523,'fr','Liens',0),(234823,6523,'jp','æœªä½¿ç”¨',0),(234824,6523,'pt','Links',0),(234825,6523,'ru','Ð¡ÑÑ‹Ð»ÐºÐ¸',0),(234826,6523,'es','Enlaces',0),(234827,6523,'de','Links',0),(234828,6523,'en','Links',0),(234829,6524,'is','',0),(234830,6524,'dr','/ Ú†Ø§Ù¾  Ú¯Ø±Ø§ÙÙ‡Ø§ÙŠ Ù…Ø¬Ù…ÙˆØ¹ÙˆÚ†Ù‡ Ø§ÙŠ Ø§Ø² Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù„ÛŒØ¬Ø± ',0),(234831,6524,'pr','Ø§ÙŠØ¬Ø§Ø¯  / Ú†Ø§Ù¾  Ù†Ù…ÙˆØ¯Ø§Ø±Ù‡Ø§ÙŠ ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ Ø§Ø² Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(234832,6524,'tr','Pasta grafikleri GL verilerinden oluÅŸturma/YazdÄ±r',0),(234833,6524,'pl','Tworzenie/drukowania wykresÃ³w koÅ‚owych z GL danych',0),(234834,6524,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ/Ð¿ÐµÑ‡Ð°Ñ‚ ÐºÑ€ÑŠÐ³Ð¾Ð²Ð¸ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¸ Ð¾Ñ‚ GL Ð´Ð°Ð½Ð½Ð¸',0),(234835,6524,'ur','ØªØ®Ù„ÛŒÙ‚/Ù¾Ø§Ø¦ÛŒ Ú†Ø§Ø±Ù¹ Ø³Û’ Ø¬ÛŒØ¬Û’ Ú©ÙˆØ§Ø¦Ù Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(234836,6524,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ /ÐŸÑ€Ð¸Ð½Ñ‚ ÐºÑ€ÑƒÐ¶Ð½Ð¸ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ¾Ð½Ð¸ Ð¸Ð· Ð“Ð› Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(234837,6524,'vi','Táº¡o/In Biá»ƒu Ä‘á»“ dáº¡ng á»‘ng tá»« dá»¯ liá»‡u sá»• cÃ¡i',0),(234838,6524,'af','Skep/Uitdruk van Sirkeldiagram Grafieke vanuit AG Data',0),(234839,6524,'ro','CreaÅ£i/imprimare diagrame plÄƒcintÄƒ din GL date',0),(234840,6524,'et','Sektordiagrammide GL andmete loomine/Prindi',0),(234841,6524,'si','Ustvarjanje/Print Tortni grafikoni iz GL podatkov',0),(234842,6524,'ba','Membuat/cetak Pie Chart dari GL Data',0),(234843,6524,'nl','Cirkeldiagrammen van GL gegevens maken/afdrukken',0),(234844,6524,'fi','Luo tai tulosta piirakkakuvioita GL tiedoista',0),(234845,6524,'no','Opprette/Print sektordiagrammer fra GL Data',0),(234846,6524,'da','Oprette/Print cirkeldiagrammer fra GL Data',0),(234847,6524,'ko','GL ë°ì´í„°ì—ì„œ ì›í˜• ì°¨íŠ¸ ë§Œë“¤ê¸°/ì¸ì‡„',0),(234848,6524,'he','×¦×•×¨/×”×“×¤×¡×” ×ª×¨×©×™×ž×™ ×¢×•×’×” ×ž× ×ª×•× ×™× GL',0),(234849,6524,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î³ÏÎ±Ï†Î®Î¼Î±Ï„Î± Ï€Î¯Ï„Î±Ï‚ Î±Ï€ÏŒ Î´ÎµÎ´Î¿Î¼Î­Î½Î± GL',0),(234850,6524,'zh','ä»Žæ€»å¸æ•°æ®ä¸­åˆ›å»º/æ‰“å°é¥¼å›¾æ•°æ®\r\n',0),(234851,6524,'sv','Skapa/skriva ut cirkeldiagram frÃ¥n GL Data',0),(234852,6524,'it','Creare/stampa di grafici a torta da dati GL',0),(234853,6524,'tl','',0),(234854,6524,'th','&#3626;&#3619;&#3657;&#3634;&#3591;/&#3614;&#3636;&#3617;&#3614;&#3660;&#3649;&#3612;&#3609;&#3616;&#3641;&#3617;&#3636;&#3623;&#3591;&#3585;&#3621;&#3617;&#3592;&#3634;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3633;&#3597;&#3594;&#3637;&#',0),(234855,6524,'hi','à¤œà¥€à¤à¤² à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¥‡ à¤ªà¤¾à¤‡ à¤šà¤¾à¤°à¥à¤Ÿ à¤¬à¤¨à¤¾à¤à¤/à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(234856,6524,'ms','Mencipta/Cetak Carta pai dari GL Data',0),(234857,6524,'ar','Ø¥Ù†Ø´Ø§Ø¡/Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù…Ø®Ø·Ø·Ø§Øª Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠØ© Ù…Ù† Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª GL',0),(234858,6524,'fr','CrÃ©er/imprimer des graphiques de donnÃ©es GL',0),(234859,6524,'jp','GLãƒ‡ãƒ¼ã‚¿ã?‹ã‚‰ã?®ãƒ‘ã‚¤ãƒ?ãƒ£ãƒ¼ãƒˆã‚’ä½œæˆ?/å?°åˆ·',0),(234860,6524,'pt','Criar/imprimir grÃ¡ficos de dados GL',0),(234861,6524,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¼Ñ‹ Ð¸Ð· Ð´Ð°Ð½Ð½Ñ‹Ñ… GL',0),(234862,6524,'es','Crear/Imprimir GrÃ¡ficos Circulares de Datos de LM',0),(234863,6524,'de','Kreisdiagramme aus GL Daten erstellen/drucken',0),(234864,6524,'en','Create/Print Pie Charts from GL Data',0),(234865,6525,'is','',0),(234866,6525,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ØµÙ„ÙŠ ',0),(234867,6525,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ØµÙ„ÙŠ ',0),(234868,6525,'tr','Ãœst satÄ±cÄ±',0),(234869,6525,'pl','NadrzÄ™dnego dostawcy',0),(234870,6525,'bg','Ð Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(234871,6525,'ur','ÙˆØ§Ù„Ø¯ÛŒÙ† ÙØ±ÙˆØ´Ù†Ø¯Û',0),(234872,6525,'sr','ÐÐ°Ð´Ñ€ÐµÑ’ÐµÐ½Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(234873,6525,'vi','NgÆ°á»i bÃ¡n cha máº¹',0),(234874,6525,'af','Ouer handelaar',0),(234875,6525,'ro','Furnizor de mamÄƒ',0),(234876,6525,'et','Vanem mÃ¼Ã¼ja',0),(234877,6525,'si','StarÅ¡ev dobavitelja',0),(234878,6525,'ba','Orangtua Vendor',0),(234879,6525,'nl','Bovenliggende leverancier',0),(234880,6525,'fi','Vanhempi toimittaja',0),(234881,6525,'no','Overordnet leverandÃ¸r',0),(234882,6525,'da','Overordnede leverandÃ¸r',0),(234883,6525,'ko','ë¶€ëª¨ ê³µê¸‰ ì—…ì²´',0),(234884,6525,'he','×”××‘ ×”×¡×¤×§',0),(234885,6525,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¿Ï… Î³Î¿Î½Î­Î±',0),(234886,6525,'zh','æ¯ä½“ä¾›åº”å•†\r\n',0),(234887,6525,'sv','Ã–verordnade leverantÃ¶ren',0),(234888,6525,'it','Fornitore del genitore',0),(234889,6525,'tl','',0),(234890,6525,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3627;&#3621;&#3633;&#3585;',0),(234891,6525,'hi','à¤ªà¥ˆà¤°à¥‡à¤‚à¤Ÿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(234892,6525,'ms','Penjual induk',0),(234893,6525,'ar','Ø¨Ø§Ø¦Ø¹ Ø§Ù„Ø£ØµÙ„',0),(234894,6525,'fr','Fournisseur de parent',0),(234895,6525,'jp','è¦ªæ¥­è€…',0),(234896,6525,'pt','Fornecedor de pai',0),(234897,6525,'ru','Ð Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ð¹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº',0),(234898,6525,'es','Proveedor Maestro',0),(234899,6525,'de','Ãœbergeordnete Anbieter',0),(234900,6525,'en','Parent Vendor',0),(234901,6526,'is','',0),(234902,6526,'dr','Ø·Ø¨Ù‚ â€“ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´   Ù„ÙŠØ³Øª Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(234903,6526,'pr','Ø·Ø¨Ù‚ â€“ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´   Ù„ÙŠØ³Øª Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(234904,6526,'tr','Ekrandaki liste satÄ±cÄ±-Agent',0),(234905,6526,'pl','Na ekranie Lista dostawcÃ³w Agent',0),(234906,6526,'bg','Ð•ÐºÑ€Ð°Ð½Ð½Ð°Ñ‚Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº-Ð°Ð³ÐµÐ½Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº',0),(234907,6526,'ur','Ø¢Ù† Ø³Ú©Ø±ÛŒÙ† ÙØ±ÙˆØ´Ù†Ø¯Û-Ø§ÛŒØ¬Ù†Ù¹ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(234908,6526,'sr','ÐÐ° ÐµÐºÑ€Ð°Ð½Ñƒ Ð»Ð¸ÑÑ‚Ñƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°-ÐÐ³ÐµÐ½Ñ‚',0),(234909,6526,'vi','Danh sÃ¡ch Ä‘áº¡i lÃ½ trÃªn mÃ n hÃ¬nh ngÆ°á»i bÃ¡n',0),(234910,6526,'af','Skerm Verskaffer-Agent Lys',0),(234911,6526,'ro','Pe ecran lista Vendor-Agent',0),(234912,6526,'et','Ekraanil hankija-Agent nimekirja',0),(234913,6526,'si','Na zaslonu seznam prodajalca-zastopnika',0),(234914,6526,'ba','Layar daftar Vendor-agen',0),(234915,6526,'nl','Op het scherm lijst leverancier-Agent',0),(234916,6526,'fi','NÃ¤ytÃ¶n toimittaja-Agent listaa',0),(234917,6526,'no','PÃ¥ skjermen liste leverandÃ¸r-Agent',0),(234918,6526,'da','PÃ¥ skÃ¦rmen liste kreditor-Agent',0),(234919,6526,'ko','ê³µê¸‰ ì—…ì²´-ì—ì´ì „íŠ¸ ëª©ë¡ í™”ë©´',0),(234920,6526,'he','×¢×œ ×”×ž×¡×š ×¨×©×™×ž×” ×©×œ ×¡×¤×§×™×-×¡×•×›×Ÿ',0),(234921,6526,'el','Î£Ï„Î·Î½ Î¿Î¸ÏŒÎ½Î· Î»Î¯ÏƒÏ„Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½-Agent',0),(234922,6526,'zh','å±å¹•ä¸Šçš„é”€å”®å•†-ä»£ç†å•†åå½•\r\n',0),(234923,6526,'sv','PÃ¥ skÃ¤rmen lista leverantÃ¶r-Agent',0),(234924,6526,'it','Sullo schermo riportate di Vendor-agente',0),(234925,6526,'tl','',0),(234926,6526,'th','&#3610;&#3609;&#3627;&#3609;&#3657;&#3634;&#3592;&#3629;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;-&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(234927,6526,'hi','à¤‘à¤¨-à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾-à¤à¤œà¥‡à¤‚à¤Ÿ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(234928,6526,'ms','Pada skrin Senarai ejen Penjual-',0),(234929,6526,'ar','Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø§Ø´Ø© Ù‚Ø§Ø¦Ù…Ø© ÙˆÙƒÙŠÙ„ Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(234930,6526,'fr','Sur lâ€™Ã©cran Liste fournisseur-Agent',0),(234931,6526,'jp','ç”»é?¢ä¸Šæ¥­è€…ãƒ¼ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆãƒªã‚¹ãƒˆ',0),(234932,6526,'pt','Na tela lista de fornecedor-agente',0),(234933,6526,'ru','ÐÐ° ÑÐºÑ€Ð°Ð½Ðµ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð°Ð³ÐµÐ½Ñ‚',0),(234934,6526,'es','Lista de Proveedores-Agentes En Pantalla',0),(234935,6526,'de','Kreditor-Agent auflisten auf dem Bildschirm',0),(234936,6526,'en','On-Screen Vendor-Agent List',0),(234937,6527,'is','',0),(234938,6527,'dr','Ø§ÙŠÙ† Ù„ÙŠÙ†Ùƒ ÙŠÙƒ Ù„ÙŠØ³Øª Ø§Ø²Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø´Ù…Ø§ Ø±Ø§ Ø±ÙˆÙŠ ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†Ø¯',0),(234939,6527,'pr','Ø§ÙŠÙ† Ù„ÙŠÙ†Ùƒ ÙŠÙƒ Ù„ÙŠØ³Øª Ø§Ø²Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø´Ù…Ø§ Ø±Ø§ Ø±ÙˆÙŠ ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†Ø¯',0),(234940,6527,'tr','Bu baÄŸlantÄ±yÄ± oluÅŸturur bir ekran satÄ±cÄ± ajanlarÄ±n listesi.',0),(234941,6527,'pl','Generuje ten link na ekranie listÄ™ agentÃ³w dostawcy.',0),(234942,6527,'bg','Ð¢Ð°Ð·Ð¸ Ð²Ñ€ÑŠÐ·ÐºÐ° ÑÑŠÐ·Ð´Ð°Ð²Ð° ÐµÐºÑ€Ð°Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð°Ð³ÐµÐ½Ñ‚Ð¸.',0),(234943,6527,'ur','Ø§Ø³ Ø±Ø¨Ø· Ù¾ÛŒØ¯Ø§ Ú©Ø±ØªØ§ ÛÛ’ Ø§ÛŒÚ© Ø¢Ù† Ø³Ú©Ø±ÛŒÙ† Ø¢Ù¾ ÙˆÛŒÙ†ÚˆØ± Ø§ÛŒØ¬Ù†Ù¹ÙˆÚº Ú©ÛŒ ÙÛØ±Ø³Øª Û”',0),(234944,6527,'sr','ÐžÐ²Ð° Ð²ÐµÐ·Ð° ÑÑ‚Ð²Ð°Ñ€Ð° ÑÐµ Ð½Ð° ÐµÐºÑ€Ð°Ð½Ñƒ Ð»Ð¸ÑÑ‚Ñƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð°Ð³ÐµÐ½Ñ‚Ð¸.',0),(234945,6527,'vi','ÄÆ°á»ng dáº«n táº¡o trÃªn danh sÃ¡ch mÃ n hÃ¬nh cá»§a Ä‘áº¡i lÃ½ ngÆ°á»i bÃ¡n cá»§a báº¡n',0),(234946,6527,'af','Hierdie skakel genereer \'n skermsleutelbord lys van jou handelaar agente.',0),(234947,6527,'ro','Acest link genereazÄƒ o pe ecran vÄƒ agenÈ›ilor de furnizor.',0),(234948,6527,'et','See link genereerib on ekraanil hankija ainete loetelu.',0),(234949,6527,'si','Ta povezava ustvarja je na zaslonu seznam dobaviteljev dejavnikov.',0),(234950,6527,'ba','Link ini menghasilkan layar daftar agen-agen penjual Anda.',0),(234951,6527,'nl','Deze link genereert een op het scherm lijst van agenten van uw leverancier.',0),(234952,6527,'fi','TÃ¤mÃ¤ linkki tuottaa nÃ¤ytÃ¶n toimittaja tekijÃ¶iden luettelossa.',0),(234953,6527,'no','Denne koblingen genererer en skjermen liste over din leverandÃ¸r agenter.',0),(234954,6527,'da','Dette link genererer en on-screen liste over din kreditor agenter.',0),(234955,6527,'ko','ì´ ë§í¬ë¥¼ ìƒì„± í•œ í™”ë©´ ê³µê¸‰ ì—…ì²´ ìš”ì›ì˜ ëª©ë¡.',0),(234956,6527,'he','×§×™×©×•×¨ ×–×” ×™×•×¦×¨ ×”×ž×¡×š ×¨×©×™×ž×ª ×”×¡×•×›× ×™× ×”×¡×¤×§ ×©×œ×š.',0),(234957,6527,'el','Î‘Ï…Ï„Î® Î· ÏƒÏÎ½Î´ÎµÏƒÎ· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯ Î¼Î¹Î± Î¿Î¸ÏŒÎ½Î· Î»Î¯ÏƒÏ„Î± ÏƒÎ±Ï‚ Ï€ÏÎ¬ÎºÏ„Î¿ÏÎµÏ‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®.',0),(234958,6527,'zh','æ­¤é“¾æŽ¥ç”Ÿæˆä¸€ä¸ªé¡µé¢ä¸Šçš„æ‚¨çš„ä¾›åº”å•†ä»£ç†åå•ã€‚',0),(234959,6527,'sv','Denna lÃ¤nk genererar en pÃ¥ skÃ¤rmen lista Ã¶ver din leverantÃ¶r agenter.',0),(234960,6527,'it','Questo link genera sullo schermo elenco dei vostri agenti di fornitore.',0),(234961,6527,'tl','',0),(234962,6527,'th','&#3649;&#3626;&#3604;&#3591;&#3621;&#3636;&#3591;&#3588;&#3660;&#3610;&#3609;&#3592;&#3629;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3586;&#3634;&#3618;',0),(234963,6527,'hi','à¤‡à¤¸ à¤²à¤¿à¤‚à¤• à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤à¤• à¤‘à¤¨-à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤…à¤ªà¤¨à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤à¤œà¥‡à¤‚à¤Ÿà¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€à¥¤',0),(234964,6527,'ms','Pautan ini menjana satu skrin Senarai ejen penjual anda.',0),(234965,6527,'ar','ÙŠÙˆÙ„Ø¯ Ù‡Ø°Ø§ Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø· Ø§Ù„Ø´Ø§Ø´Ø© Ù‚Ø§Ø¦Ù…Ø© ÙˆÙƒÙ„Ø§Ø¡ Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ.',0),(234966,6527,'fr','Ce lien gÃ©nÃ¨re lâ€™un Ã  lâ€™Ã©cran la liste de vos agents du vendeur.',0),(234967,6527,'jp','ã?“ã?®ãƒªãƒ³ã‚¯ã?¯æ¥­è€…ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã?®ç”»é?¢ä¸Šãƒªã‚¹ãƒˆã‚’ä½œã‚Šã?¾ã?™',0),(234968,6527,'pt','Este link gera na tela lista de seus agentes de fornecedor.',0),(234969,6527,'ru','Ð­Ñ‚Ð° ÑÑÑ‹Ð»ÐºÐ° ÑÐ¾Ð·Ð´Ð°ÐµÑ‚ Ð½Ð° ÑÐºÑ€Ð°Ð½Ðµ ÑÐ¿Ð¸ÑÐ¾Ðº Ð°Ð³ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°.',0),(234970,6527,'es','Este enlace genera una lista en pantalla de sus agentes Proveedores',0),(234971,6527,'de','Diesen Link erzeugt ein on-Screen-Liste Ihrer Hersteller-Agenten.',0),(234972,6527,'en','This link generates an on-screen list of your vendor agents.',0),(234973,6528,'is','',0),(234974,6528,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ â€“ ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡',0),(234975,6528,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ â€“ ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡',0),(234976,6528,'tr','Bill Ekle - BaÅŸlangÄ±Ã§ bakiyesi',0),(234977,6528,'pl','Bill dodaÄ‡ - poczÄ…tek rÃ³wnowagi',0),(234978,6528,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±Ð¸Ð» - Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½Ñ',0),(234979,6528,'ur','Ø¨Ù„ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº - Ø¢ØºØ§Ø² ØªÙˆØ§Ø²Ù†',0),(234980,6528,'sr','Ð‘Ð¸Ð» Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐµ - ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(234981,6528,'vi','ThÃªm HÃ³a ÄÆ¡n - Sá»‘ DÆ° Äáº§u Ká»³',0),(234982,6528,'af','Wetsontwerp voeg - begin balans',0),(234983,6528,'ro','Adauga Bill - Ã®nceputul echilibru',0),(234984,6528,'et','Bill lisada - alguse saldo',0),(234985,6528,'si','Zakona dodati - zaÄetek ravnovesje',0),(234986,6528,'ba','Bill menambahkan - saldo awal',0),(234987,6528,'nl','Bill toevoegen - beginsaldo',0),(234988,6528,'fi','Bill lisÃ¤tÃ¤ - alkusaldo',0),(234989,6528,'no','Bill Add - startsaldo',0),(234990,6528,'da','Bill tilfÃ¸je - startsaldo',0),(234991,6528,'ko','ë¹Œ ì¶”ê°€-ì²˜ìŒ ê· í˜•',0),(234992,6528,'he','×”×•×¡×¤×ª ×—×©×‘×•×Ÿ - ×ž××–×Ÿ ×”×ª×—×œ×ª×™',0),(234993,6528,'el','Bill ÎµÎ¾Î¹ÏƒÎ¿ÏÏÎ¿Ï€ÎµÎ¯ - Î±ÏÏ‡Î®',0),(234994,6528,'zh','å¸å•æ–°å¢ž -ç»“ä½™åˆæœŸ\r\n',0),(234995,6528,'sv','Bill lÃ¤gga - ingÃ¥ende saldo',0),(234996,6528,'it','Aggiungi Bill - saldo iniziale',0),(234997,6528,'tl','',0),(234998,6528,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3636;&#3621; &#3651;&#3609;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604;',0),(234999,6528,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ - à¤¶à¥à¤°à¥à¤†à¤¤ à¤¸à¤‚à¤¤à¥à¤²à¤¨',0),(235000,6528,'ms','Tambah Bill - baki awal',0),(235001,6528,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ù…ÙˆØ±Ù‘Ø¯ - Ø±ØµÙŠØ¯ Ø¥ÙØªØªØ§Ø­ÙŠ',0),(235002,6528,'fr','Projet de loi ajoute - solde d\'ouverture',0),(235003,6528,'jp','è«‹æ±‚æ›¸ã?®è¿½åŠ ãƒ¼ç²¾ç®—é–‹å§‹',0),(235004,6528,'pt','Bill adicionar - inÃ­cio equilÃ­brio',0),(235005,6528,'ru','Ð‘Ð¸Ð»Ð» Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ - Ð½Ð°Ñ‡Ð°Ð»Ðµ Ð±Ð°Ð»Ð°Ð½Ñ',0),(235006,6528,'es','Agregar Factura - Saldo de Inicio',0),(235007,6528,'de','Bill hinzufÃ¼gen - Anfangssaldo',0),(235008,6528,'en','Bill Add - Beginning Balance',0),(235009,6529,'is','',0),(235010,6529,'dr','Ø³Ø±ÙŠ ØµÙ†Ø¹ØªÙŠ',0),(235011,6529,'pr','Ø³Ø±ÙŠ ØµÙ†Ø¹ØªÙŠ',0),(235012,6529,'tr','Sanat Kur',0),(235013,6529,'pl','Sztuka instalacji',0),(235014,6529,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¸Ð·ÐºÑƒÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(235015,6529,'ur','Ø¢Ø±Ù¹ Ø³ÛŒÙ¹ Ø§Ù¾',0),(235016,6529,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÐÑ€Ñ‚',0),(235017,6529,'vi','Thiáº¿t Káº¿ Setup',0),(235018,6529,'af','Kuns Opstelling',0),(235019,6529,'ro','Arta Setup',0),(235020,6529,'et','Art seadistamine',0),(235021,6529,'si','Art Setup',0),(235022,6529,'ba','Seni Setup',0),(235023,6529,'nl','Art Setup',0),(235024,6529,'fi','Art asennus',0),(235025,6529,'no','Art oppsett',0),(235026,6529,'da','Kunst installation',0),(235027,6529,'ko','ì•„íŠ¸ ì„¤ì¹˜',0),(235028,6529,'he','×”×’×“×¨×ª ×”××ž× ×•×ª',0),(235029,6529,'el','Î¤Î­Ï‡Î½Î· ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(235030,6529,'zh','è‰ºæœ¯è®¾ç½®\r\n',0),(235031,6529,'sv','Konst installation',0),(235032,6529,'it','Installazione d\'arte',0),(235033,6529,'tl','',0),(235034,6529,'th','&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3591;&#3634;&#3609;&#3624;&#3636;&#3621;&#3611;&#3632;',0),(235035,6529,'hi','à¤•à¤²à¤¾ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(235036,6529,'ms','Persediaan seni',0),(235037,6529,'ar','ÙÙ† Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(235038,6529,'fr','Installation d\'art',0),(235039,6529,'jp','ã‚¢ãƒ¼ãƒˆè¨­å®š',0),(235040,6529,'pt','InstalaÃ§Ã£o de arte',0),(235041,6529,'ru','ÐÑ€Ñ‚ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(235042,6529,'es','Arte ConfiguaciÃ³n',0),(235043,6529,'de','Kunst-Setup',0),(235044,6529,'en','Art Setup',0),(235045,6530,'is','',0),(235046,6530,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¯ÙˆØ¨Ø§Ø±Ù‡',0),(235047,6530,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¯ÙˆØ¨Ø§Ø±Ù‡',0),(235048,6530,'tr','DBL onay',0),(235049,6530,'pl','DBL wyboru',0),(235050,6530,'bg','DBL Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(235051,6530,'ur','Ø¯Ø¨Ù„ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(235052,6530,'sr','Ð”Ð±Ð» Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(235053,6530,'vi','SÃ©c Dbl',0),(235054,6530,'af','Dbl kontroleer',0),(235055,6530,'ro','Verificare DBL',0),(235056,6530,'et','DBL sisse',0),(235057,6530,'si','Dbl potrdite',0),(235058,6530,'ba','DBL Check',0),(235059,6530,'nl','Dbl Check',0),(235060,6530,'fi','DBL uloskirjautuminen',0),(235061,6530,'no','Dbl sjekk',0),(235062,6530,'da','Dbl Check',0),(235063,6530,'ko','ë”ë¸” ì²´í¬',0),(235064,6530,'he','×”×¡×™×ž×•×Ÿ ×›×¤×•×œ×”',0),(235065,6530,'el','Dbl ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(235066,6530,'zh','åŒé‡æ£€æŸ¥\r\n',0),(235067,6530,'sv','Dbl Check',0),(235068,6530,'it','DBL Check',0),(235069,6530,'tl','',0),(235070,6530,'th','Dbl Check',0),(235071,6530,'hi','Dbl à¤šà¥‡à¤•',0),(235072,6530,'ms','Semak dbl',0),(235073,6530,'ar','Dbl Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(235074,6530,'fr','DBL Check',0),(235075,6530,'jp','å†?ç¢ºèª?',0),(235076,6530,'pt','DBL Check',0),(235077,6530,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° DBL',0),(235078,6530,'es','Verificar dos Veces',0),(235079,6530,'de','DBL Check',0),(235080,6530,'en','Dbl Check',0),(235081,6531,'is','',0),(235082,6531,'dr','Ø­ÙØ§Ø±Ù‰',0),(235083,6531,'pr','Ø­ÙØ§Ø±Ù‰',0),(235084,6531,'tr','Sondaj',0),(235085,6531,'pl','Wiercenia',0),(235086,6531,'bg','ÐŸÑ€Ð¾Ð±Ð¸Ð²Ð°Ð½Ðµ',0),(235087,6531,'ur','ÚˆØ±Ù„Ù†Ú¯',0),(235088,6531,'sr','Ð‘ÑƒÑˆÐµÑšÐµ',0),(235089,6531,'vi','Khoan',0),(235090,6531,'af','Boor',0),(235091,6531,'ro','Foraj',0),(235092,6531,'et','Puurimine',0),(235093,6531,'si','Vrtanje',0),(235094,6531,'ba','Pengeboran',0),(235095,6531,'nl','Boren',0),(235096,6531,'fi','Poraus',0),(235097,6531,'no','Boring',0),(235098,6531,'da','Boring',0),(235099,6531,'ko','ë“œë¦´ë§',0),(235100,6531,'he','×§×™×“×•×—',0),(235101,6531,'el','Î“ÎµÏ‰Ï„ÏÎ®ÏƒÎµÏ‰Î½',0),(235102,6531,'zh','é’»äº•\r\n',0),(235103,6531,'sv','Borrning',0),(235104,6531,'it','Foratura',0),(235105,6531,'tl','',0),(235106,6531,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3648;&#3592;&#3634;&#3632;',0),(235107,6531,'hi','à¤¡à¥à¤°à¤¿à¤²à¤¿à¤‚à¤—',0),(235108,6531,'ms','Penggerudian',0),(235109,6531,'ar','Ø§Ù„Ø­ÙØ±',0),(235110,6531,'fr','Forage',0),(235111,6531,'jp','ç©´ã?‚ã?‘',0),(235112,6531,'pt','De perfuraÃ§Ã£o',0),(235113,6531,'ru','Ð‘ÑƒÑ€ÐµÐ½Ð¸Ðµ',0),(235114,6531,'es','PerforaciÃ³n',0),(235115,6531,'de','Bohren',0),(235116,6531,'en','Drilling',0),(235117,6532,'is','',0),(235118,6532,'dr','Ú†Ø³Ø¨Ø§Ù†Ø¯Ù† ',0),(235119,6532,'pr','Ú†Ø³Ø¨Ø§Ù†Ø¯Ù† ',0),(235120,6532,'tr','YapÄ±ÅŸtÄ±rma',0),(235121,6532,'pl','Klejenie',0),(235122,6532,'bg','Ð—Ð°Ð»ÐµÐ¿Ð²Ð°Ð½Ðµ',0),(235123,6532,'ur','Ú¯Ù„ÙˆØ§Ù†Ú¯',0),(235124,6532,'sr','Ð—Ð°Ð»ÐµÐ¿Ð¸Ð¼',0),(235125,6532,'vi','DÃ¡n',0),(235126,6532,'af','Plak',0),(235127,6532,'ro','Lipire',0),(235128,6532,'et','Liimimine',0),(235129,6532,'si','Lepljenje',0),(235130,6532,'ba','Menempelkan',0),(235131,6532,'nl','Lijmen',0),(235132,6532,'fi','Liimaus',0),(235133,6532,'no','Lime',0),(235134,6532,'da','Limning',0),(235135,6532,'ko','ì ‘ì°©',0),(235136,6532,'he','×”×“×‘×§×”',0),(235137,6532,'el','ÎšÏŒÎ»Î»Î·Î¼Î±',0),(235138,6532,'zh','èƒ¶åˆ\r\n',0),(235139,6532,'sv','Limning',0),(235140,6532,'it','Incollaggio',0),(235141,6532,'tl','',0),(235142,6532,'th','&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;',0),(235143,6532,'hi','Gluing',0),(235144,6532,'ms','Gluing',0),(235145,6532,'ar','Ø§Ù„Ø§Ù„ØªØµØ§Ù‚',0),(235146,6532,'fr','Collage',0),(235147,6532,'jp','ã?®ã‚Šä»˜ã?‘',0),(235148,6532,'pt','Colagem',0),(235149,6532,'ru','ÐŸÑ€Ð¸ÐºÐ»ÐµÐ¸Ð²Ð°Ð½Ð¸Ðµ',0),(235150,6532,'es','Pegando',0),(235151,6532,'de','Kleben',0),(235152,6532,'en','Gluing',0),(235153,6533,'is','',0),(235154,6533,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø³ØªÙ‡ Ù‡Ø§ÙŠ',0),(235155,6533,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø³ØªÙ‡ Ù‡Ø§ÙŠ',0),(235156,6533,'tr','Nr. paketleri',0),(235157,6533,'pl','Pakiety nr.',0),(235158,6533,'bg','Nr. Ð¿Ð°ÐºÐµÑ‚Ð¸',0),(235159,6533,'ur','Ù¾ÛŒÚ© Ø§ÛŒÙ† Ø¢Ø± Û”',0),(235160,6533,'sr','ÐŸÐ°ÐºÐµÑ‚Ð¸ Ð½Ñ€.',0),(235161,6533,'vi','Sá»‘ kiá»‡n',0),(235162,6533,'af','Nr. pakke',0),(235163,6533,'ro','Pachete de nr.',0),(235164,6533,'et','Nr. pakendis',0),(235165,6533,'si','Nr. paketi',0),(235166,6533,'ba','Nr. paket',0),(235167,6533,'nl','Nr. Packs',0),(235168,6533,'fi','Nr. pakkauksissa',0),(235169,6533,'no','Nr. pakker',0),(235170,6533,'da','Nr. Packs',0),(235171,6533,'ko','Nrìž…ë‹ˆë‹¤. íŒ©',0),(235172,6533,'he','Nr. ×—×‘×™×œ×•×ª',0),(235173,6533,'el','NR. Ï€Î±ÎºÎ­Ï„Î±',0),(235174,6533,'zh','ä¸Šåˆåæ—¶åäº”åˆ†ã€‚åŒ…\r\n',0),(235175,6533,'sv','Nr. fÃ¶rpackningar',0),(235176,6533,'it','Confezioni Nr.',0),(235177,6533,'tl','',0),(235178,6533,'th','&#3609;&#3633;&#3610;&#3592;&#3635;&#3609;&#3623;&#3609;&#3627;&#3656;&#3629;',0),(235179,6533,'hi','Nr. à¤ªà¥ˆà¤•à¥à¤¸',0),(235180,6533,'ms','NR. pek',0),(235181,6533,'ar','Ø­Ø²Ù… nr.',0),(235182,6533,'fr','Packs Nr.',0),(235183,6533,'jp','ãƒ‘ãƒƒã‚¯æ•°',0),(235184,6533,'pt','Pacotes de NR.',0),(235185,6533,'ru','Nr. Ð¿Ð°ÐºÐµÑ‚Ñ‹',0),(235186,6533,'es','Nmro. de Paquetes',0),(235187,6533,'de','Nr. Packs',0),(235188,6533,'en','Nr. Packs',0),(235189,6534,'is','',0),(235190,6534,'dr','(Ø¬Ù…Ø¹ Ø´ÙˆÙ†Ø¯Ù‡',0),(235191,6534,'pr','ÙƒÙ¾Ù‡(Ø§Ù†Ø¨Ø§Ø´ØªÙ‡',0),(235192,6534,'tr','KazÄ±k',0),(235193,6534,'pl','Pale',0),(235194,6534,'bg','ÐŸÐ¸Ð»Ð¾Ñ‚Ð¸',0),(235195,6534,'ur','ÚˆÚ¾ÛŒØ±',0),(235196,6534,'sr','Ð“Ð¾Ð¼Ð¸Ð»Ðµ',0),(235197,6534,'vi','Má»™t chá»“ng',0),(235198,6534,'af','Hopies',0),(235199,6534,'ro','PiloÅ£i',0),(235200,6534,'et','Vaiad',0),(235201,6534,'si','Piloti',0),(235202,6534,'ba','Tumpukan',0),(235203,6534,'nl','Stapels',0),(235204,6534,'fi','Paalut',0),(235205,6534,'no','Hauger',0),(235206,6534,'da','Bunker',0),(235207,6534,'ko','ë”ë¯¸',0),(235208,6534,'he','×¢×¨×™×ž×•×ª',0),(235209,6534,'el','Î£Ï‰ÏÎ¿ÏÏ‚',0),(235210,6534,'zh','æ¡©\r\n',0),(235211,6534,'sv','PÃ¥lar',0),(235212,6534,'it','Pali',0),(235213,6534,'tl','',0),(235214,6534,'th','Piles',0),(235215,6534,'hi','à¤¬à¤µà¤¾à¤¸à¥€à¤°',0),(235216,6534,'ms','Buasir',0),(235217,6534,'ar','Ø£ÙƒÙˆØ§Ù…',0),(235218,6534,'fr','Pieux',0),(235219,6534,'jp','ãƒ‘ã‚¤ãƒ«',0),(235220,6534,'pt','Pilhas',0),(235221,6534,'ru','Ð¡Ð²Ð°Ð¸',0),(235222,6534,'es','Pilas',0),(235223,6534,'de','PfÃ¤hle',0),(235224,6534,'en','Piles',0),(235225,6535,'is','',0),(235226,6535,'dr','Ù†Ù…ÙˆÙ†Ù‡ Ù‡Ø§',0),(235227,6535,'pr','Ù†Ù…ÙˆÙ†Ù‡ Ù‡Ø§',0),(235228,6535,'tr','Ã–rnekleri',0),(235229,6535,'pl','PrÃ³bki',0),(235230,6535,'bg','ÐŸÑ€Ð¾Ð±Ð¸',0),(235231,6535,'ur','Ù†Ù…ÙˆÙ†Û',0),(235232,6535,'sr','Ð£Ð·Ð¾Ñ€Ñ†Ð¸',0),(235233,6535,'vi','VÃ­ dá»¥',0),(235234,6535,'af','Voorbeelde',0),(235235,6535,'ro','Probe',0),(235236,6535,'et','Proovid',0),(235237,6535,'si','Vzorci',0),(235238,6535,'ba','Sampel',0),(235239,6535,'nl','Monsters',0),(235240,6535,'fi','NÃ¤ytteet',0),(235241,6535,'no','PrÃ¸ver',0),(235242,6535,'da','PrÃ¸ver',0),(235243,6535,'ko','ìƒ˜í”Œ',0),(235244,6535,'he','×“×•×’×ž××•×ª',0),(235245,6535,'el','Î”ÎµÎ¯Î³Î¼Î±Ï„Î±',0),(235246,6535,'zh','æ ·å“\r\n',0),(235247,6535,'sv','Prover',0),(235248,6535,'it','Campioni',0),(235249,6535,'tl','',0),(235250,6535,'th','&#3605;&#3633;&#3623;&#3629;&#3618;&#3656;&#3634;&#3591;',0),(235251,6535,'hi','à¤¨à¤®à¥‚à¤¨à¥‡',0),(235252,6535,'ms','Sampel',0),(235253,6535,'ar','Ø¹ÙŠÙ†Ø§Øª',0),(235254,6535,'fr','Ã‰chantillons',0),(235255,6535,'jp','ã‚µãƒ³ãƒ—ãƒ«',0),(235256,6535,'pt','Amostras',0),(235257,6535,'ru','ÐžÐ±Ñ€Ð°Ð·Ñ†Ñ‹',0),(235258,6535,'es','Muestras',0),(235259,6535,'de','Proben',0),(235260,6535,'en','Samples',0),(235261,6536,'is','',0),(235262,6536,'dr','Ù¾ÙŠÚ†ÙŠØ¯Ù† ',0),(235263,6536,'pr','Ù¾ÙŠÚ†ÙŠØ¯Ù† ',0),(235264,6536,'tr','Sarma',0),(235265,6536,'pl','Zawijanie',0),(235266,6536,'bg','ÐžÐ±Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ',0),(235267,6536,'ur','Ù„ÙØ§Ù Ú©Ø§Ø±ÛŒ',0),(235268,6536,'sr','ÐŸÑ€ÐµÐ»Ð°Ð¼Ð°ÑšÐµ',0),(235269,6536,'vi','GÃ³i',0),(235270,6536,'af','Wikkel',0),(235271,6536,'ro','Incadrare',0),(235272,6536,'et','Pakend',0),(235273,6536,'si','Zavijanje',0),(235274,6536,'ba','Pembungkus',0),(235275,6536,'nl','Tekstterugloop',0),(235276,6536,'fi','Rivitys',0),(235277,6536,'no','Innpakning',0),(235278,6536,'da','Indpakning',0),(235279,6536,'ko','ì¤„ ë°”ê¿ˆ',0),(235280,6536,'he','×¢×˜×™×¤×”',0),(235281,6536,'el','Î£Ï…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î±',0),(235282,6536,'zh','åŒ…è£…\r\n',0),(235283,6536,'sv','Inslagning',0),(235284,6536,'it','Avvolgimento',0),(235285,6536,'tl','',0),(235286,6536,'th','&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3627;&#3656;&#3629;',0),(235287,6536,'hi','à¤°à¥ˆà¤ªà¤¿à¤‚à¤—',0),(235288,6536,'ms','Bungkusan',0),(235289,6536,'ar','Ø§Ù„ØªÙØ§Ù',0),(235290,6536,'fr','Emballage',0),(235291,6536,'jp','åŒ…è£…',0),(235292,6536,'pt','Envolvimento',0),(235293,6536,'ru','Ð£Ð¿Ð°ÐºÐ¾Ð²ÐºÐ°',0),(235294,6536,'es','Envasado',0),(235295,6536,'de','Verpackung',0),(235296,6536,'en','Wrapping',0),(235297,6537,'is','',0),(235298,6537,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡',0),(235299,6537,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡',0),(235300,6537,'tr','BaÅŸlangÄ±Ã§ bakiyesi faturalarÄ±',0),(235301,6537,'pl','PoczÄ…tku salda rachunkÃ³w',0),(235302,6537,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½Ñ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(235303,6537,'ur','Ø¢ØºØ§Ø² ØªÙˆØ§Ø²Ù† Ú©Û’ Ø¨Ù„',0),(235304,6537,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº ÑÐ°Ð»Ð´Ð¾ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(235305,6537,'vi','Sá»‘ DÆ° Äáº§u Ká»³ Cá»§a HÃ³a ÄÆ¡n',0),(235306,6537,'af','Rekeninge Beginbalans',0),(235307,6537,'ro','Facturile de echilibru Ã®nceputul',0),(235308,6537,'et','Alguses saldo arved',0),(235309,6537,'si','ZaÄetku ravnovesje menice',0),(235310,6537,'ba','Tagihan saldo awal',0),(235311,6537,'nl','Begin Saldo rekeningen',0),(235312,6537,'fi','Alussa tasapaino laskut',0),(235313,6537,'no','Begynnelsen balanse regninger',0),(235314,6537,'da','Begyndelsen Balance regninger',0),(235315,6537,'ko','ì‹œìž‘ ìž”ì•¡ ì²­êµ¬ì„œ',0),(235316,6537,'he','×‘×”×ª×—×œ×” ×™×ª×¨×ª ×”×—×©×‘×•× ×•×ª',0),(235317,6537,'el','Î‘ÏÏ‡Î® Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(235318,6537,'zh','æœŸåˆç»“ä½™å¸å•\r\n',0),(235319,6537,'sv','BÃ¶rjan balans rÃ¤kningar',0),(235320,6537,'it','Inizio saldo fatture',0),(235321,6537,'tl','',0),(235322,6537,'th','&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3618;&#3585;&#3617;&#3634;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604;',0),(235323,6537,'hi','à¤¶à¥à¤°à¥à¤†à¤¤ à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤¬à¤¿à¤²',0),(235324,6537,'ms','Baki awal bil-bil',0),(235325,6537,'ar','Ø¨Ø¯Ø§ÙŠØ© ØªÙˆØ§Ø²Ù† ÙÙˆØ§ØªÙŠØ±',0),(235326,6537,'fr','Facture de solde dÃ©but',0),(235327,6537,'jp','ç²¾ç®—é–‹å§‹è«‹æ±‚æ›¸',0),(235328,6537,'pt','InÃ­cio contas de equilÃ­brio',0),(235329,6537,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð±Ð°Ð»Ð°Ð½Ñ ÑÑ‡ÐµÑ‚Ð°',0),(235330,6537,'es','Facturas de Saldos de Inicio',0),(235331,6537,'de','Anfang Balance Rechnungen',0),(235332,6537,'en','Beginning Balance Bills',0),(235333,6538,'is','',0),(235334,6538,'dr','Ø«Ø¨Øª ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§',0),(235335,6538,'pr','Ø«Ø¨Øª ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÙŠÙ‡ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§',0),(235336,6538,'tr','BaÅŸlangÄ±Ã§ bakiyesi satÄ±cÄ± faturalarÄ± girin',0),(235337,6538,'pl','WprowadÅº poczÄ…tek salda dostawcy rachunki',0),(235338,6538,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½Ñ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(235339,6538,'ur','Ø¢ØºØ§Ø² ØªÙˆØ§Ø²Ù† ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(235340,6538,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð¾Ñ‡ÐµÑ‚Ð°Ðº ÑÐ°Ð»Ð´Ð¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(235341,6538,'vi','Nháº­p Sá»‘ DÆ° Äáº§u ká»³ cho hÃ³a Ä‘Æ¡n ngÆ°á»i bÃ¡n',0),(235342,6538,'af','Invoer van Verskafferrekeninge Beginbalans',0),(235343,6538,'ro','IntroduceÅ£i Ã®nceputul sold furnizor facturi',0),(235344,6538,'et','Sisestage algsaldo tarnija arvetele',0),(235345,6538,'si','Vnesite zaÄetek saldo dobavitelja menice',0),(235346,6538,'ba','Masukkan awal saldo Vendor tagihan',0),(235347,6538,'nl','Begin evenwicht leverancier facturen invoeren',0),(235348,6538,'fi','Kirjoita alussa tasapaino toimittajan laskut',0),(235349,6538,'no','Angi begynnelsen balanse leverandÃ¸r regninger',0),(235350,6538,'da','Angiv starten Balance kreditor regninger',0),(235351,6538,'ko','ì²˜ìŒ ê· í˜• ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œë¥¼ ìž…ë ¥',0),(235352,6538,'he','×”×–×Ÿ ×”×”×ª×—×œ×” ×œ××™×–×•×Ÿ ×”×¡×¤×§ ×©×˜×¨×•×ª',0),(235353,6538,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î±ÏÏ‡Î® Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¿Ï… Î”Î—ÎœÎŸÎ£Î™ÎŸÎ¥',0),(235354,6538,'zh','è¾“å…¥æœŸåˆå–æ–¹å¸å•',0),(235355,6538,'sv','Ange bÃ¶rjan balans leverantÃ¶r rÃ¤kningar',0),(235356,6538,'it','Immettere inizio saldo pagamenti fornitore',0),(235357,6538,'tl','',0),(235358,6538,'th','&#3611;&#3657;&#3629;&#3609;&#3618;&#3629;&#3604;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3592;&#3634;&#3585;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3605;&#3657;&#3609;&#3591;&#3623;&#3',0),(235359,6538,'hi','à¤¶à¥à¤°à¥à¤†à¤¤ à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(235360,6538,'ms','Masukkan bil-bil Vendor baki awal',0),(235361,6538,'ar','Ø¥Ø¯Ø®Ø§Ù„ ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙˆØ±Ø¯ Ø±ØµÙŠØ¯ Ø¨Ø¯Ø§ÙŠØ©',0),(235362,6538,'fr','Entrez le dÃ©but solde fournisseur factures',0),(235363,6538,'jp','ç²¾ç®—é–‹å§‹æ¥­è€…è«‹æ±‚æ›¸ã?®å…¥åŠ›',0),(235364,6538,'pt','Digite o inÃ­cio saldo contas de fornecedor',0),(235365,6538,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð¾ ÑÐ°Ð»ÑŒÐ´Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(235366,6538,'es','Ingresar Saldos de Inicio de Recibos de Proveedor',0),(235367,6538,'de','Geben Sie Anfang Balance Lieferanten Rechnungen',0),(235368,6538,'en','Enter Beginning Balance Vendor Bills',0),(235369,6539,'is','',0),(235370,6539,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø²Ø¨Ø§Ù† Ø¨Ø±Ø§ÙŠ Ø´Ø±ÙƒØª ',0),(235371,6539,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø²Ø¨Ø§Ù† Ø¨Ø±Ø§ÙŠ Ø´Ø±ÙƒØª ',0),(235372,6539,'tr','Åžirket iÃ§in diller gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(235373,6539,'pl','BÅ‚Ä…d podczas aktualizowania jÄ™zykÃ³w dla firmy',0),(235374,6539,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ·Ð¸Ñ†Ð¸ Ð·Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(235375,6539,'ur','Ø²Ø¨Ø§Ù†ÙˆÚº Ú©ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„Ø¦Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(235376,6539,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ˜ÐµÐ·Ð¸ÐºÐ° Ð·Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(235377,6539,'vi','Cáº­p nháº­t ngÃ´n ngá»¯ cho cty bá»‹ lá»—i',0),(235378,6539,'af','Fout met Opdatering van Taal vir Onderneming',0),(235379,6539,'ro','Eroare la actualizarea limbi pentru companie',0),(235380,6539,'et','EttevÃµtte keeleseadete uuendamisel tekkis viga',0),(235381,6539,'si','Napaka pri posodabljanju jezikov za podjetja',0),(235382,6539,'ba','Kesalahan memperbarui bahasa untuk perusahaan',0),(235383,6539,'nl','Fout bij het bijwerken van talen voor bedrijf',0),(235384,6539,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ kielet yrityksen',0),(235385,6539,'no','Feil under oppdatering av sprÃ¥k for selskap',0),(235386,6539,'da','Fejl under opdatering af sprog for virksomheden',0),(235387,6539,'ko','íšŒì‚¬ì— ëŒ€ í•œ ì–¸ì–´ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(235388,6539,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×©×¤×•×ª ×¢×‘×•×¨ ×”×—×‘×¨×”',0),(235389,6539,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Î³Î»Ï‰ÏƒÏƒÏŽÎ½ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(235390,6539,'zh','é”™è¯¯æ›´æ–°ä¸ºå…¬å¸è¯­è¨€\r\n',0),(235391,6539,'sv','Gick inte att uppdatera sprÃ¥k fÃ¶r fÃ¶retag',0),(235392,6539,'it','Errore di aggiornamento lingue per azienda',0),(235393,6539,'tl','',0),(235394,6539,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3616;&#3634;&#3625;&#3634;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(235395,6539,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¤¾à¤·à¤¾à¤à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(235396,6539,'ms','Ralat dalam mengemas kini Bahasa untuk Syarikat',0),(235397,6539,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù„ØºØ§Øª Ù„Ù„Ø´Ø±ÙƒØ©',0),(235398,6539,'fr','Erreur de mise Ã  jour pour les langues du sociÃ©tÃ©',0),(235399,6539,'jp','ä¼šç¤¾ç”¨è¨€èªžã?®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(235400,6539,'pt','Erro ao atualizar idiomas para empresa',0),(235401,6539,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¯Ð·Ñ‹ÐºÐ¾Ð² Ð´Ð»Ñ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ ',0),(235402,6539,'es','Error Actualizando Idiomas para la empresa',0),(235403,6539,'de','Fehler beim Aktualisieren der Sprachen fÃ¼r Unternehmen',0),(235404,6539,'en','Error Updating Languages for Company',0),(235405,6540,'is','',0),(235406,6540,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø²Ø¨Ø§Ù† Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(235407,6540,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø²Ø¨Ø§Ù† Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(235408,6540,'tr','KullanÄ±cÄ± dil seÃ§imi',0),(235409,6540,'pl','WybÃ³r jÄ™zyka uÅ¼ytkownika',0),(235410,6540,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° ÐµÐ·Ð¸Ðº Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ',0),(235411,6540,'ur','ØµØ§Ø±Ù Ú©ÛŒ Ø²Ø¨Ø§Ù† Ú©Û’ Ø§Ù†ØªØ®Ø§Ø¨',0),(235412,6540,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸ Ñ˜ÐµÐ·Ð¸Ðº Ð¸Ð·Ð±Ð¾Ñ€Ð°',0),(235413,6540,'vi','Chá»n NgÃ´n Ngá»¯ Äá»ƒ Nháº­p Dá»¯ Liá»‡u',0),(235414,6540,'af','Kies Taal vir Data Inskrywings',0),(235415,6540,'ro','Selectati limba pentru introducerea informatiilor',0),(235416,6540,'et','Vali keel andmete sisestamiseks',0),(235417,6540,'si','Uporabnik jezik izbira',0),(235418,6540,'ba','Pilihan bahasa pengguna',0),(235419,6540,'nl','Taal gebruikersopties',0),(235420,6540,'fi','KÃ¤yttÃ¤jÃ¤n kielet',0),(235421,6540,'no','Brukerens sprÃ¥k valg',0),(235422,6540,'da','Bruger sprog valg',0),(235423,6540,'ko','ì‚¬ìš©ìž ì–¸ì–´ ì„ íƒ',0),(235424,6540,'he','×”×ž×©×ª×ž×© ××¤×©×¨×•×™×•×ª ×©×¤×”',0),(235425,6540,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ Î³Î»ÏŽÏƒÏƒÎ± Ï‡ÏÎ®ÏƒÏ„Î·',0),(235426,6540,'zh','é€‰æ‹©æ•°æ®è¾“å…¥è¯­è¨€\r\n',0),(235427,6540,'sv','AnvÃ¤ndaren sprÃ¥kval',0),(235428,6540,'it','Scelte di lingua dell\'utente',0),(235429,6540,'tl','',0),(235430,6540,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3616;&#3634;&#3625;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(235431,6540,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤­à¤¾à¤·à¤¾ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(235432,6540,'ms','Pilihan bahasa pengguna',0),(235433,6540,'ar','Ø§Ø®ØªØ± Ù„ØºØ§Øª Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(235434,6540,'fr','SÃ©lectionnez les langues pour la saisie des donnÃ©es',0),(235435,6540,'jp','ãƒ‡ãƒ¼ã‚¿å…¥åŠ›ã?®è¨€èªžé?¸æŠž',0),(235436,6540,'pt','OpÃ§Ãµes de idioma do usuÃ¡rio',0),(235437,6540,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¯Ð·Ñ‹ÐºÐ¸ Ð”Ð»Ñ Ð’Ð²Ð¾Ð´Ð° Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(235438,6540,'es','Seleccionar Idiomas para la Entrada de Datos',0),(235439,6540,'de','Benutzer-Sprachwahl',0),(235440,6540,'en','User Language Choices',0),(235441,6541,'is','',0),(235442,6541,'dr','Ø«Ø¨Øª Ø¯Ø±Ø¢Ù…Ø¯',0),(235443,6541,'pr','Ø«Ø¨Øª Ø¯Ø±Ø¢Ù…Ø¯',0),(235444,6541,'tr','Gelir giriÅŸi',0),(235445,6541,'pl','PrzychodÃ³w wpis',0),(235446,6541,'bg','ÐŸÑ€Ð¸Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð¸Ñ',0),(235447,6541,'ur','Ø±ÛŒÙˆÙ†ÛŒÙˆ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(235448,6541,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(235449,6541,'vi','Nháº­p Doanh Thu',0),(235450,6541,'af','Inkomste Inskrywing',0),(235451,6541,'ro','Venituri de intrare',0),(235452,6541,'et','Kanne tulude',0),(235453,6541,'si','Vnos prihodka',0),(235454,6541,'ba','Pendapatan entri',0),(235455,6541,'nl','Inkomsten Entry',0),(235456,6541,'fi','Tulo merkintÃ¤',0),(235457,6541,'no','Inntekter oppfÃ¸ring',0),(235458,6541,'da','IndtÃ¦gter adgang',0),(235459,6541,'ko','ìˆ˜ìµ í•­ëª©',0),(235460,6541,'he','×¢×¨×š ×¤×“×™×•×Ÿ',0),(235461,6541,'el','Î•Î³Î³ÏÎ±Ï†Î® ÎµÏƒÏŒÎ´Ï‰Î½',0),(235462,6541,'zh','æ”¶å…¥æ¡ç›®\r\n',0),(235463,6541,'sv','IntÃ¤kter intrÃ¤de',0),(235464,6541,'it','Reddito entrata',0),(235465,6541,'tl','',0),(235466,6541,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;',0),(235467,6541,'hi','à¤°à¤¾à¤œà¤¸à¥à¤µ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(235468,6541,'ms','Hasil kemasukan',0),(235469,6541,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª',0),(235470,6541,'fr','Recettes entrÃ©e',0),(235471,6541,'jp','å?Žç›Šè¨˜å¸³',0),(235472,6541,'pt','Receita entrada',0),(235473,6541,'ru','Ð”Ð¾Ñ…Ð¾Ð´Ñ‹ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(235474,6541,'es','Entrada de Renta',0),(235475,6541,'de','Einnahmen-Eintrag',0),(235476,6541,'en','Revenue Entry',0),(235477,6542,'is','',0),(235478,6542,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ  Ø³ÙˆØ¯ Ùˆ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(235479,6542,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ  Ø³ÙˆØ¯ Ùˆ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ ',0),(235480,6542,'tr','Kar/maliyet merkezlerini ayarlamak',0),(235481,6542,'pl','DefiniowaÄ‡ centra zyskÃ³w/kosztÃ³w',0),(235482,6542,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ñ‚ Ñ†ÐµÐ½Ñ‚Ñ€Ð¾Ð²Ðµ Ð·Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°/Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(235483,6542,'ur','Ù…Ù†Ø§ÙØ¹/Ù‚ÛŒÙ…Øª Ù…Ø±Ø§Ú©Ø² Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(235484,6542,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ñ†ÐµÐ½Ñ‚Ð°Ñ€Ð° Ð´Ð¾Ð±Ð¸Ñ‚/Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(235485,6542,'vi','Setup lá»£i nhuáº­n/Cst Centers',0),(235486,6542,'af','Opstelling van Wins/Koste Sentrums',0),(235487,6542,'ro','Parametriza centrele de Profit/Cost',0),(235488,6542,'et','Saate seadistada kasumist kulukeskuste',0),(235489,6542,'si','Nastavite centrih dobiÄek/stroÅ¡ki',0),(235490,6542,'ba','Mendirikan keuntungan biaya Pusat',0),(235491,6542,'nl','Winst/Kostenplaats instellen',0),(235492,6542,'fi','MÃ¤Ã¤ritÃ¤ kustannus keskukset',0),(235493,6542,'no','Definere fortjeneste/kostsentre',0),(235494,6542,'da','OpsÃ¦tning af overskud/omkostningssteder',0),(235495,6542,'ko','ìˆ˜ìµ/ë¹„ìš© ì„¼í„° ì„¤ì •',0),(235496,6542,'he','×”×’×“×¨×ª ×ž×¨×›×–×™ ×¨×•×•×—/×¢×œ×•×ª',0),(235497,6542,'el','ÎŸÏÎ¯ÏƒÎµÏ„Îµ ÎºÎ­Î½Ï„ÏÎ± ÎºÏŒÏƒÏ„Î¿Ï…Ï‚-Î±Ï€Î¿Ï„ÎµÎ»ÎµÏƒÎ¼Î¬Ï„Ï‰Î½',0),(235498,6542,'zh','å®‰è£…åˆ©æ¶¦/æˆæœ¬ä¸­å¿ƒ\r\n',0),(235499,6542,'sv','StÃ¤ll in vinst/kostnadsstÃ¤llen',0),(235500,6542,'it','Istituire centri di costo/profitto',0),(235501,6542,'tl','',0),(235502,6542,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3635;&#3652;&#3619;/&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;',0),(235503,6542,'hi','à¤²à¤¾à¤­/à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤¨à¥à¤¦à¥à¤°à¥‹à¤‚ à¤•à¥‹ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(235504,6542,'ms','Menubuhkan Pusat-pusat keuntungan/kos',0),(235505,6542,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ \"Ù…Ø±Ø§ÙƒØ²\" Ø§Ù„Ø±Ø¨Ø­ ÙˆØ§Ù„ØªÙƒÙ„ÙØ©',0),(235506,6542,'fr','Mettre en place des centres de coÃ»ts/bÃ©nÃ©fices',0),(235507,6542,'jp','Profit/Cost Center ã?®ã‚»ã‚¿ãƒƒãƒ—',0),(235508,6542,'pt','Definir centros de custo/lucro',0),(235509,6542,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ñ‹ Ñ†ÐµÐ½Ñ‚Ñ€Ñ‹ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸ Ð¸ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(235510,6542,'es','Configurar Centros de Utilidad/Costo',0),(235511,6542,'de','Gewinn/Kostenstellen einrichten',0),(235512,6542,'en','Set up Profit/Cost Centers',0),(235513,6543,'is','',0),(235514,6543,'dr',': ØªÙ†Ø¸ÙŠÙ… Ø«Ø¨Øª Ø§Ø² Ø±Ø¯ÙŠÙ Ù‡Ø§ / Ø³ØªÙˆÙ† Ù‡Ø§ ',0),(235515,6543,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø¯Ø±Ø¢Ù…Ø¯ : ØªÙ†Ø¸ÙŠÙ… Ø«Ø¨Øª Ø§Ø² Ø±Ø¯ÙŠÙ Ù‡Ø§ / Ø³ØªÙˆÙ† Ù‡Ø§ ',0),(235516,6543,'tr','GiriÅŸ formu satÄ±rlarÄ±/sÃ¼tunlarÄ± Kur',0),(235517,6543,'pl','Ustawienie wpisu formularza wiersze/kolumny',0),(235518,6543,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ Ñ„Ð¾Ñ€Ð¼Ð° Ñ€ÐµÐ´Ð¾Ð²Ðµ/ÐºÐ¾Ð»Ð¾Ð½Ð¸',0),(235519,6543,'ur','Ø¯Ø§Ø®Ù„Û ÙØ§Ø±Ù… ØµÙÛŒÚº/Ú©Ø§Ù„Ù… Ø³ÛŒÙ¹ Ø§Ù¾',0),(235520,6543,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÑƒÐ½Ð¾Ñ Ð¾Ð±Ñ€Ð°ÑÑ†Ð° Ñ€ÐµÐ´Ð¾Ð²Ðµ/ÐºÐ¾Ð»Ð¾Ð½Ðµ',0),(235521,6543,'vi','Setup máº«u nháº­p dÃ²ng/cá»™t',0),(235522,6543,'af','Opstel inskrywing vorm rye/kolomme',0),(235523,6543,'ro','Configurare intrare forma rÃ¢nduri/coloane',0),(235524,6543,'et','Seadista kande vormi read/veerud',0),(235525,6543,'si','Setup vnos obrazca vrstice/stolpce',0),(235526,6543,'ba','Setup entri bentuk baris/kolom',0),(235527,6543,'nl','Post formulier rijen/kolommen instellen',0),(235528,6543,'fi','Setup merkintÃ¤ lomakkeen rivit/sarakkeet',0),(235529,6543,'no','Sette inn skjemaet rader/kolonner',0),(235530,6543,'da','Setup Entry Form rÃ¦kker/kolonner',0),(235531,6543,'ko','í•­ëª© ì–‘ì‹ í–‰/ì—´ ì„¤ì •',0),(235532,6543,'he','×”×’×“×¨×ª ×›× ×™×¡×” ×œ×˜×•×¤×¡ ×©×•×¨×•×ª/×¢×ž×•×“×•×ª',0),(235533,6543,'el','Setup ÎµÎ³Î³ÏÎ±Ï†Î® Î¼Î¿ÏÏ†Î® Î³ÏÎ±Î¼Î¼ÏŽÎ½/ÏƒÏ„Î·Î»ÏŽÎ½',0),(235534,6543,'zh','è®¾ç½®æŠ¥åè¡¨è¡Œ/åˆ—\r\n',0),(235535,6543,'sv','Setup post formulÃ¤ret rader/kolumner',0),(235536,6543,'it','Configurazione Entry Form righe/colonne',0),(235537,6543,'tl','',0),(235538,6543,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3649;&#3610;&#3610;&#3615;&#3629;&#3619;&#3660;&#3617; &#3649;&#3606;&#3623;/&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;',0),(235539,6543,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤«à¤¼à¥‰à¤°à¥à¤® à¤ªà¤‚à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤/à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(235540,6543,'ms','Persediaan kemasukan borang baris/lajur',0),(235541,6543,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø¥Ø¯Ø®Ø§Ù„ Ù†Ù…ÙˆØ°Ø¬ Ø§Ù„ØµÙÙˆÙ/Ø§Ù„Ø£Ø¹Ù…Ø¯Ø©',0),(235542,6543,'fr','Configurer l\'entrÃ©e forme lignes/colonnes',0),(235543,6543,'jp','Setup Entry Form Rows/Columns',0),(235544,6543,'pt','InstalaÃ§Ã£o de linhas/colunas do formulÃ¡rio de entrada',0),(235545,6543,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ Ñ„Ð¾Ñ€Ð¼Ñ‹ ÑÑ‚Ñ€Ð¾ÐºÐ¸/ÑÑ‚Ð¾Ð»Ð±Ñ†Ñ‹',0),(235546,6543,'es','Configurar Formulario de Entrada Filas/Columnas',0),(235547,6543,'de','Einrichten Sie Eintrag Formular Zeilen/Spalten',0),(235548,6543,'en','Setup Entry Form Rows/Columns',0),(235549,6544,'is','',0),(235550,6544,'dr',': ØªÙ†Ø¸ÙŠÙ… Ø«Ø¨Øª Ø¯Ø± Ø®Ø§Ù†Ù‡ Ù‡Ø§ÙŠ ØµÙØ­Ù‡',0),(235551,6544,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø¨Ø±Ú¯Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±Ø¢Ù…Ø¯ : ØªÙ†Ø¸ÙŠÙ… Ø«Ø¨Øª Ø¯Ø± Ø®Ø§Ù†Ù‡ Ù‡Ø§ÙŠ ØµÙØ­Ù‡',0),(235552,6544,'tr','GiriÅŸ sayfasÄ± hÃ¼creleri kurulum',0),(235553,6544,'pl','Ustawienie wejÅ›cie komÃ³rki arkusza',0),(235554,6544,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ Ð»Ð¸ÑÑ‚ ÐºÐ»ÐµÑ‚ÐºÐ¸',0),(235555,6544,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ ÙˆØ±Ù‚ Ø³ÛŒÙ„ Ø³ÛŒÙ¹ Ø§Ù¾',0),(235556,6544,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð»Ð¸ÑÑ‚ Ñ›ÐµÐ»Ð¸Ñ˜Ðµ',0),(235557,6544,'vi','Táº¡o Trang ',0),(235558,6544,'af','Opstel inskrywing vel selle',0),(235559,6544,'ro','Celule de foaie de intrare de configurare',0),(235560,6544,'et','Seadista kande lehe rakkude',0),(235561,6544,'si','Setup vnos stanja celic',0),(235562,6544,'ba','Setup entri lembar sel',0),(235563,6544,'nl','Entry blad cellen instellen',0),(235564,6544,'fi','MÃ¤Ã¤ritÃ¤ taulukon solut',0),(235565,6544,'no','Sette inn celler',0),(235566,6544,'da','Setup post ark celler',0),(235567,6544,'ko','ì—”íŠ¸ë¦¬ ì‹œíŠ¸ ì…€ ì„¤ì •',0),(235568,6544,'he','×”×’×“×¨×ª ×¢×¨×š ×’×™×œ×™×•×Ÿ ×ª××™×',0),(235569,6544,'el','Setup ÎµÎ³Î³ÏÎ±Ï†Î® Ï†ÏÎ»Î»Î¿ ÎºÏÏ„Ï„Î±ÏÎ±',0),(235570,6544,'zh','å®‰è£…ç¨‹åºè¿›å…¥ç»†èƒžè¡¨\r\n',0),(235571,6544,'sv','Setup intrÃ¤de tÃ¤cker celler',0),(235572,6544,'it','Impostare la voce foglio cellule',0),(235573,6544,'tl','',0),(235574,6544,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3648;&#3595;&#3621;&#3621;&#3660;&#3649;&#3612;&#3656;&#3609;&#3591;&#3634;&#3609;',0),(235575,6544,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤ªà¤¤à¥à¤°à¤• à¤•à¤•à¥à¤·',0),(235576,6544,'ms','Persediaan kemasukan kira-kira sel',0),(235577,6544,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø®Ù„Ø§ÙŠØ§ ÙˆØ±Ù‚Ø© Ø¯Ø®ÙˆÙ„',0),(235578,6544,'fr','Configurer des cellules de feuille d\'entrÃ©e',0),(235579,6544,'jp','Setup Entry Sheet Cells',0),(235580,6544,'pt','InstalaÃ§Ã£o de cÃ©lulas de folha de entrada',0),(235581,6544,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÑÑ‡ÐµÐµÐº Ð»Ð¸ÑÑ‚Ð° Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(235582,6544,'es','Configurar Celulas de Hojas de Entrada',0),(235583,6544,'de','Einrichten Eintrag Blatt Zellen',0),(235584,6544,'en','Setup Entry Sheet Cells',0),(235585,6545,'is','',0),(235586,6545,'dr','Ù†ØµØ¨ Ø³ÙŠØ³ØªÙ… ØªÙˆÙ„ÙŠØ¯ Ø§Ù†Ø¹Ø·Ø§Ù Ù¾Ø°ÙŠØ±\r\n FMS',0),(235587,6545,'pr','Ù†ØµØ¨ Ø³ÙŠØ³ØªÙ… ØªÙˆÙ„ÙŠØ¯ Ø§Ù†Ø¹Ø·Ø§Ù Ù¾Ø°ÙŠØ±\r\n FMS',0),(235588,6545,'tr','FMS kurulumu',0),(235589,6545,'pl','Ustawienie FMS',0),(235590,6545,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° FMS',0),(235591,6545,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ ÙˆØ²Ø±Ø§Ø¡ Ø®Ø§Ø±Ø¬Û Ù†Û’ Ù…Ø¹Ø´ÛŒØª',0),(235592,6545,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¤ÐœÐ¡',0),(235593,6545,'vi','Setup FMS',0),(235594,6545,'af','FMS opstel',0),(235595,6545,'ro','Configurare FMS',0),(235596,6545,'et','Setup FMS',0),(235597,6545,'si','Setup FMS',0),(235598,6545,'ba','Setup FMS',0),(235599,6545,'nl','Setup FMS',0),(235600,6545,'fi','MÃ¤Ã¤ritÃ¤ HenkilÃ¶stÃ¶hallinto',0),(235601,6545,'no','Installasjonsprogrammet FMS',0),(235602,6545,'da','Setup FMS',0),(235603,6545,'ko','FMSë¥¼ ì„¤ì¹˜',0),(235604,6545,'he','×”×’×“×¨×ª FMS',0),(235605,6545,'el','ÎŸÏÎ³Î¬Î½Ï‰ÏƒÎ· FMS',0),(235606,6545,'zh','FMSçš„å®‰è£…\r\n',0),(235607,6545,'sv','Setup FMS',0),(235608,6545,'it','Installazione FMS',0),(235609,6545,'tl','',0),(235610,6545,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634; FMS',0),(235611,6545,'hi','à¤à¤«à¤à¤®à¤à¤¸ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(235612,6545,'ms','Persediaan FMS',0),(235613,6545,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙƒØªØ¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠ Ù„Ù„Ù‡Ø¬Ø±Ø©',0),(235614,6545,'fr','Programme d\'installation FMS',0),(235615,6545,'jp','FMSã‚»ã‚¿ãƒƒãƒ—',0),(235616,6545,'pt','InstalaÃ§Ã£o do FMS',0),(235617,6545,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ FMS',0),(235618,6545,'es','Configurar FMS',0),(235619,6545,'de','Setup FMS',0),(235620,6545,'en','Setup FMS',0),(235621,6546,'is','',0),(235622,6546,'dr','Ø¨Ø±Ú¯  Ø«Ø¨Øª ØµÙ†Ø¹Øª\r\n',0),(235623,6546,'pr','Ø¨Ø±Ú¯  Ø«Ø¨Øª ØµÙ†Ø¹Øª\r\n',0),(235624,6546,'tr','AR girdi sayfasÄ±',0),(235625,6546,'pl','Arkusz do wprowadzania AR',0),(235626,6546,'bg','AR Ð·Ð°Ð¿Ð¸Ñ Ð»Ð¸ÑÑ‚',0),(235627,6546,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†Ø¯Ø±Ø§Ø¬ ÙˆØ±Ù‚',0),(235628,6546,'sr','ÐÐ  ÑƒÐ»Ð°Ð·Ð½Ð¸ Ð»Ð¸ÑÑ‚',0),(235629,6546,'vi','Nháº­p TK Pháº£i Thu',0),(235630,6546,'af','AR inskrywing vel',0),(235631,6546,'ro','Foaie de intrare AR',0),(235632,6546,'et','AR kanne leht',0),(235633,6546,'si','AR vnos stanja',0),(235634,6546,'ba','AR entri lembar',0),(235635,6546,'nl','AR-gegevensinvoerblad',0),(235636,6546,'fi','AR merkintÃ¤ arkki',0),(235637,6546,'no','AR oppfÃ¸ringstabell',0),(235638,6546,'da','AR indtastningsark',0),(235639,6546,'ko','ì•„ì¹¸ì†Œ í•­ëª© ì‹œíŠ¸',0),(235640,6546,'he','×’×œ×™×•×Ÿ ×”×–× ×” AR',0),(235641,6546,'el','Î¦ÏÎ»Î»Î¿ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÏ‰Î½ AR',0),(235642,6546,'zh','æŠ¥åè¡¨é“\r\n',0),(235643,6546,'sv','AR analysblad',0),(235644,6546,'it','Foglio di entrata di AR',0),(235645,6546,'tl','',0),(235646,6546,'th','&#3585;&#3619;&#3629;&#3585;&#3619;&#3634;&#3618;&#3594;&#3639;&#3656;&#3629;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3651;&#3609;&#3594;&#3637;&#3626;',0),(235647,6546,'hi','AR à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤ªà¤¤à¥à¤°à¤•',0),(235648,6546,'ms','Kira-kira masuk AR',0),(235649,6546,'ar','ÙˆØ±Ù‚Ø© Ø¯Ø®ÙˆÙ„ AR',0),(235650,6546,'fr','Feuille d\'entrÃ©e AR',0),(235651,6546,'jp','AR Entry Sheet',0),(235652,6546,'pt','Planilha de entrada de AR',0),(235653,6546,'ru','Ð›Ð¸ÑÑ‚ Ð²Ð²Ð¾Ð´Ð° AR',0),(235654,6546,'es','CC Hoja de Entrada',0),(235655,6546,'de','AR-Erfassungsblatt',0),(235656,6546,'en','AR Entry Sheet',0),(235657,6547,'is','',0),(235658,6547,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù…ØªØºÙŠÙŠØ± Ù‡Ø§',0),(235659,6547,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù…ØªØºÙŠÙŠØ± Ù‡Ø§',0),(235660,6547,'tr','Kurulum deÄŸiÅŸkenleri',0),(235661,6547,'pl','Ustawienie zmiennych',0),(235662,6547,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð»Ð¸Ð²Ð¸',0),(235663,6547,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ù…ØªØºÛŒØ±Ø§Øª',0),(235664,6547,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð²Ð°Ñ€Ð¸Ñ˜Ð°Ð±Ð»Ð¸',0),(235665,6547,'vi','Setup biáº¿n Ä‘á»•i',0),(235666,6547,'af','Opstel van veranderlikes',0),(235667,6547,'ro','Configurare variabile',0),(235668,6547,'et','Seadistus muutujate',0),(235669,6547,'si','Nastavitev spremenljivke',0),(235670,6547,'ba','Variabel konfigurasi',0),(235671,6547,'nl','Setup variabelen',0),(235672,6547,'fi','MÃ¤Ã¤ritÃ¤ muuttujat',0),(235673,6547,'no','Installasjonsprogrammet variabler',0),(235674,6547,'da','OpsÃ¦tning af variabler',0),(235675,6547,'ko','ì„¤ì • ë³€ìˆ˜',0),(235676,6547,'he','×”×’×“×¨×ª ×”×ž×©×ª× ×™×',0),(235677,6547,'el','ÎœÎµÏ„Î±Î²Î»Î·Ï„Î­Ï‚ Ï„Î·Ï‚ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(235678,6547,'zh','è®¾ç½®å˜é‡\r\n',0),(235679,6547,'sv','Setup variabler',0),(235680,6547,'it','Variabili di configurazione',0),(235681,6547,'tl','',0),(235682,6547,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3605;&#3633;&#3623;&#3649;&#3611;&#3619;',0),(235683,6547,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤šà¤°',0),(235684,6547,'ms','Persediaan pembolehubah',0),(235685,6547,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ù…ØªØºÙŠØ±Ø§Øª',0),(235686,6547,'fr','Variables de configuration',0),(235687,6547,'jp','Setup Variables',0),(235688,6547,'pt','VariÃ¡veis de configuraÃ§Ã£o',0),(235689,6547,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÐ½Ð½Ñ‹Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(235690,6547,'es','Variables de ConfiguraciÃ³n',0),(235691,6547,'de','Setup-Variablen',0),(235692,6547,'en','Setup Variables',0),(235693,6548,'is','',0),(235694,6548,'dr','TED Ú¯Ø²Ø§Ø±Ø´',0),(235695,6548,'pr','TED Ú¯Ø²Ø§Ø±Ø´',0),(235696,6548,'tr','TED raporu',0),(235697,6548,'pl','TED raportu',0),(235698,6548,'bg','Ð¢ÐµÐ´ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(235699,6548,'ur','TED Ø±Ù¾ÙˆØ±Ù¹',0),(235700,6548,'sr','Ð¢Ð•Ð” Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(235701,6548,'vi','BÃ¡o cÃ¡o TED',0),(235702,6548,'af','TED verslag',0),(235703,6548,'ro','TED raport',0),(235704,6548,'et','TED aruanne',0),(235705,6548,'si','TED poroÄilo',0),(235706,6548,'ba','TED laporan',0),(235707,6548,'nl','TED verslag',0),(235708,6548,'fi','TED raportti',0),(235709,6548,'no','TED rapport',0),(235710,6548,'da','TED rapport',0),(235711,6548,'ko','í…Œë“œ ë³´ê³ ì„œ',0),(235712,6548,'he','×—. ×˜×“',0),(235713,6548,'el','TED Î­ÎºÎ¸ÎµÏƒÎ·',0),(235714,6548,'zh','TEDçš„æŠ¥å‘Š\r\n',0),(235715,6548,'sv','TED rapport',0),(235716,6548,'it','Relazione di TED',0),(235717,6548,'tl','',0),(235718,6548,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; TED',0),(235719,6548,'hi','à¤Ÿà¥‡à¤¡ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(235720,6548,'ms','TED Laporan',0),(235721,6548,'ar','ØªÙ‚Ø±ÙŠØ± ØªÙŠØ¯',0),(235722,6548,'fr','Rapport de TED',0),(235723,6548,'jp','TED Report',0),(235724,6548,'pt','RelatÃ³rio de TED',0),(235725,6548,'ru','Ð¢ÐµÐ´ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(235726,6548,'es','Informe TED',0),(235727,6548,'de','TED-Bericht',0),(235728,6548,'en','TED Report',0),(235729,6549,'is','',0),(235730,6549,'dr','ØµÙØ­Ù‡ Ø«Ø¨Øª Ø¯Ø³ØªÙ…Ø²Ø¯',0),(235731,6549,'pr','ØµÙØ­Ù‡ Ø«Ø¨Øª Ø¯Ø³ØªÙ…Ø²Ø¯',0),(235732,6549,'tr','Ãœcret giriÅŸi sayfasÄ±',0),(235733,6549,'pl','Arkusz pÅ‚ac wprowadzania',0),(235734,6549,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð¸Ñ Ð»Ð¸ÑÑ‚',0),(235735,6549,'ur','Ù…Ù†ÛŒ Ù…Ù… ÙˆÛŒØ¬ Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ ÙˆØ±Ù‚',0),(235736,6549,'sr','ÐŸÐ»Ð°Ñ‚Ð° ÑƒÐ»Ð°Ð·Ð½Ð¸ Ð»Ð¸ÑÑ‚',0),(235737,6549,'vi','Nháº­p LÆ°Æ¡ng',0),(235738,6549,'af','Besoldiging Inskrywings Vel',0),(235739,6549,'ro','Foaie de intrare salariul',0),(235740,6549,'et','Palga sisestusleht',0),(235741,6549,'si','PlaÄ vnos stanja',0),(235742,6549,'ba','Upah entri lembar',0),(235743,6549,'nl','Loon-gegevensinvoerblad',0),(235744,6549,'fi','Palkkojen merkintÃ¤ arkki',0),(235745,6549,'no','LÃ¸nns-oppfÃ¸ringstabell',0),(235746,6549,'da','LÃ¸n indtastningsark',0),(235747,6549,'ko','ìž„ê¸ˆ í•­ëª© ì‹œíŠ¸',0),(235748,6549,'he','×’×œ×™×•×Ÿ ×”×–× ×” ×©×›×¨',0),(235749,6549,'el','Î¦ÏÎ»Î»Î¿ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÏ‰Î½ Î¼Î¹ÏƒÎ¸ÏŒ',0),(235750,6549,'zh','å·¥èµ„è¡¨æ¡ç›®\r\n',0),(235751,6549,'sv','LÃ¶n analysblad',0),(235752,6549,'it','Salario voce foglio',0),(235753,6549,'tl','',0),(235754,6549,'th','&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;',0),(235755,6549,'hi','à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤ªà¤¤à¥à¤°à¤•',0),(235756,6549,'ms','Kira-kira kemasukan gaji',0),(235757,6549,'ar','ÙˆØ±Ù‚Ø© Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø£Ø¬ÙˆØ±',0),(235758,6549,'fr','Feuille d\'entrÃ©e de salaire',0),(235759,6549,'jp','Wage Entry Sheet',0),(235760,6549,'pt','Planilha de entrada de salÃ¡rio',0),(235761,6549,'ru','Ð›Ð¸ÑÑ‚ Ð²Ð²Ð¾Ð´Ð° Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(235762,6549,'es','Hoja de Entrada de Sueldos',0),(235763,6549,'de','Lohn Erfassungsblatt',0),(235764,6549,'en','Wage Entry Sheet',0),(235765,6550,'is','',0),(235766,6550,'dr','(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†Ùƒ',0),(235767,6550,'pr','Ø§ÙØ²ÙˆØ¯Ù†  Ù¾Ø±Ø¯Ø§Ø®Øª(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†Ùƒ',0),(235768,6550,'tr','Ã–deme Ã§ek hesabÄ± ekleme',0),(235769,6550,'pl','DodaÄ‡ konto bankowe pÅ‚atnoÅ›Ä‡',0),(235770,6550,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(235771,6550,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(235772,6550,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(235773,6550,'vi','ThÃªm TK Kiá»ƒm Tra Thanh ToÃ¡n',0),(235774,6550,'af','Uitbetalings Tjekrekening Bygevoeg',0),(235775,6550,'ro','Adauga cont de verificare platÄƒ',0),(235776,6550,'et','Maksmine kontroll konto lisamine',0),(235777,6550,'si','Dodamo tekoÄi raÄun plaÄilne',0),(235778,6550,'ba','Menambahkan rekening pembayaran',0),(235779,6550,'nl','Betaling betaalrekening toevoegen',0),(235780,6550,'fi','Maksun pankkitililtÃ¤si lisÃ¤Ã¤',0),(235781,6550,'no','Betaling brukskonto legge',0),(235782,6550,'da','Betaling checkkonto tilfÃ¸je',0),(235783,6550,'ko','ì§€ë¶ˆ ë‹¹ì¢Œ ê³„ì • ì¶”ê°€',0),(235784,6550,'he','×œ×”×•×¡×™×£ ×ª×©×œ×•× ×—×©×‘×•×Ÿ ×‘× ×§',0),(235785,6550,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(235786,6550,'zh','ä»˜æ¬¾æ”¯ç¥¨å¸æˆ·æ·»åŠ \r\n',0),(235787,6550,'sv','Betalning checkkonto lÃ¤gga till',0),(235788,6550,'it','Aggiungi pagamento conto corrente',0),(235789,6550,'tl','',0),(235790,6550,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3594;&#3655;&#3588;',0),(235791,6550,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤šà¥‡à¤•à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(235792,6550,'ms','Menambah akaun semakan pembayaran',0),(235793,6550,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨ Ø§Ù„ØªØ­Ù‚Ù‚ Ø§Ù„Ø¯ÙØ¹',0),(235794,6550,'fr','Ajouter compte de chÃ¨que de paiement',0),(235795,6550,'jp','ãŠæ”¯æ‰•ã„å£åº§ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(235796,6550,'pt','Adicionar conta de pagamento',0),(235797,6550,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(235798,6550,'es','Cuenta Bancaria de Cheques de Pago Agregar',0),(235799,6550,'de','Zahlung-Girokonto hinzufÃ¼gen',0),(235800,6550,'en','Payment Checking Account Add',0),(235801,6551,'is','',0),(235802,6551,'dr','(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†Ùƒ',0),(235803,6551,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†Ùƒ',0),(235804,6551,'tr','Ã–deme Ã§ek hesabÄ± GÃ¼ncelleÅŸtir',0),(235805,6551,'pl','PÅ‚atnoÅ›ci konto czekowe aktualizacji',0),(235806,6551,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(235807,6551,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(235808,6551,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(235809,6551,'vi','Cáº­p Nháº­t TK Kiá»ƒm Tra Thanh ToÃ¡n',0),(235810,6551,'af','Uitbetalings Tjekrekening Opdatering',0),(235811,6551,'ro','Plata cont de verificare Update',0),(235812,6551,'et','Makse pangakonto Update',0),(235813,6551,'si','PlaÄilo raÄuna posodobitev',0),(235814,6551,'ba','Pembayaran rekening Update',0),(235815,6551,'nl','Betaling betaalrekening Update',0),(235816,6551,'fi','Maksun pankkitililtÃ¤si pÃ¤ivitys',0),(235817,6551,'no','Betaling brukskonto oppdatering',0),(235818,6551,'da','Betaling checkkonto opdatering',0),(235819,6551,'ko','ì§€ë¶ˆ ë‹¹ì¢Œ ê³„ì • ì—…ë°ì´íŠ¸',0),(235820,6551,'he','×¢×“×›×•×Ÿ ×—×©×‘×•×Ÿ ×‘× ×§ ×œ×ª×©×œ×•×',0),(235821,6551,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(235822,6551,'zh','ä»˜æ¬¾æ”¯ç¥¨å¸æˆ·æ›´æ–°\r\n',0),(235823,6551,'sv','Betalning checkkonto uppdatering',0),(235824,6551,'it','Pagamento conto corrente aggiornamento',0),(235825,6551,'tl','',0),(235826,6551,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(235827,6551,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤šà¥‡à¤•à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(235828,6551,'ms','Pembayaran akaun memeriksa Kemaskini',0),(235829,6551,'ar','Ø¯ÙØ¹ Ø­Ø³Ø§Ø¨ Ø§Ù„ØªØ­Ù‚Ù‚ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(235830,6551,'fr','Mise Ã  jour de paiement sur le compte courant',0),(235831,6551,'jp','æ”¯æ‰•ã®å½“åº§é é‡‘å£åº§ã®æ›´æ–°',0),(235832,6551,'pt','AtualizaÃ§Ã£o de conta Ã  ordem de pagamento',0),(235833,6551,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚ÐµÐºÑƒÑ‰ÐµÐ³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ñ…',0),(235834,6551,'es','Cuenta Bancaria de Cheques de Pago Actualizar',0),(235835,6551,'de','Zahlung-Girokonto-Update',0),(235836,6551,'en','Payment Checking Account Update',0),(235837,6552,'is','',0),(235838,6552,'dr','.',0),(235839,6552,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ  Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ§ÙŠÙŠØ¯ Ø´ÙˆÙ†Ø¯.',0),(235840,6552,'tr','FaturalarÄ± Ã¶deme Ã¶nce onay',0),(235841,6552,'pl','Rachunki muszÄ… byÄ‡ wstÄ™pnie zatwierdzone przed dokonaniem pÅ‚atnoÅ›ci',0),(235842,6552,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(235843,6552,'ur','Ø¨Ù„ÙˆÚº Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø³Û’ Ù¾ÛÙ„Û’ Ù¾Ø±ÛŒØ§Ù¾Ù¾Ø±ÙˆØ¯ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(235844,6552,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ñ€Ð°Ð½Ð¸Ñ˜Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¾ Ð¿Ñ€Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(235845,6552,'vi','HÃ³a ÄÆ¡n Pháº£i ÄÆ°á»£c Duyá»‡t TrÆ°á»›c Khi Thanh ToÃ¡n',0),(235846,6552,'af','Rekeninge Moet Vooraf-goedgekeur Wees, Alvorens Betaling sal Geskied',0),(235847,6552,'ro','Facturile trebuie sÄƒ fie PreApproved Ã®nainte de plata',0),(235848,6552,'et','Arved peavad eelnevalt heaks enne makse',0),(235849,6552,'si','RaÄune morajo PreApproved pred plaÄilom',0),(235850,6552,'ba','Tagihan harus PreApproved sebelum pembayaran',0),(235851,6552,'nl','Facturen moeten vÃ³Ã³r betaling worden PreApproved',0),(235852,6552,'fi','Laskut on hyvÃ¤ksyttyjÃ¤ maksamiselle',0),(235853,6552,'no','Regninger mÃ¥ vÃ¦re forhÃ¥ndsgodkjent fÃ¸r betaling',0),(235854,6552,'da','Regninger skal vÃ¦re forhÃ¥ndsgodkendte fÃ¸r betaling',0),(235855,6552,'ko','ì²­êµ¬ì„œë¥¼ ì§€ë¶ˆ í•˜ê¸° ì „ì— í•˜ì…¨ë‚˜ìš” í•´ì•¼ í•©ë‹ˆë‹¤.',0),(235856,6552,'he','×—×©×‘×•× ×•×ª ×—×™×™×‘×™× ×œ×”×™×•×ª ××•×©×¨×” ×œ×¤× ×™ ×”×ª×©×œ×•×',0),(235857,6552,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€ÏÎ¿ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯ Ï€ÏÎ¹Î½ Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î®',0),(235858,6552,'zh','ç¥¨æ®ä»˜æ¬¾å‰å¿…é¡»é¢„å…ˆæ ¸å‡†\r\n',0),(235859,6552,'sv','RÃ¤kningar mÃ¥ste vara PreApproved innan betalning',0),(235860,6552,'it','Le fatture devono essere PreApproved prima del pagamento',0),(235861,6552,'tl','',0),(235862,6552,'th','&#3610;&#3636;&#3621;&#3605;&#3657;&#3629;&#3591;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3585;&#3656;&#3629;&#3609;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(235863,6552,'hi','à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ PreApproved à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(235864,6552,'ms','Rang undang-undang mesti PreApproved sebelum pembayaran',0),(235865,6552,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ­ØªÙˆÙŠ Ù…Ø´Ø§Ø±ÙŠØ¹ Ø§Ù„Ù‚ÙˆØ§Ù†ÙŠÙ† Ù‚Ø¨Ù„ Ø§Ù„Ø¯ÙØ¹',0),(235866,6552,'fr','Projets de loi doivent Ãªtre approuvÃ©s au prÃ©alable avant le paiement',0),(235867,6552,'jp','æ‰‹å½¢ã¯ã€æ”¯æ‰•å‰ã«äº‹å‰ã«æ‰¿èªã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(235868,6552,'pt','As contas devem ser prÃ©-aprovado antes do pagamento',0),(235869,6552,'ru','Ð—Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð·Ð°Ñ€Ð°Ð½ÐµÐµ Ð¿ÐµÑ€ÐµÐ´ Ð¾Ð¿Ð»Ð°Ñ‚Ð¾Ð¹',0),(235870,6552,'es','Facturas Debe Ser PreAprobadas Antes Que Pagar',0),(235871,6552,'de','Rechnungen mÃ¼ssen vor Zahlung PreApproved',0),(235872,6552,'en','Bills Must Be PreApproved Before Payment',0),(235873,6553,'is','',0),(235874,6553,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª',0),(235875,6553,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª',0),(235876,6553,'tr','VarsayÄ±lan Ã¶deme ÅŸartlarÄ±',0),(235877,6553,'pl','DomyÅ›lnie warunki pÅ‚atnoÅ›ci',0),(235878,6553,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(235879,6553,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø·',0),(235880,6553,'sr','Ð£ÑÐ»Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð·Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸',0),(235881,6553,'vi','Äiá»u khoáº£n thanh toÃ¡n Máº·c Ä‘á»‹nh',0),(235882,6553,'af','Verstekte Betalingsterme',0),(235883,6553,'ro','Conditiile de plata implicite',0),(235884,6553,'et','Vaikimisi maksetingimused',0),(235885,6553,'si','Privzeto PlaÄilni pogoji',0),(235886,6553,'ba','Syarat-syarat pembayaran default',0),(235887,6553,'nl','Standaard betalingsvoorwaarden',0),(235888,6553,'fi','Oletuksena maksuehdot',0),(235889,6553,'no','Standard betalingsbetingelser',0),(235890,6553,'da','Standardbetalingsbetingelser',0),(235891,6553,'ko','ê¸°ë³¸ ì§€ë¶ˆ ì¡°ê±´',0),(235892,6553,'he','×ª× ××™ ×ª×©×œ×•× ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(235893,6553,'el','Î ÏÎ¿ÎµÏ€Î¹Î» ÏŒÏÎ¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(235894,6553,'zh','é»˜è®¤æ”¯ä»˜æ¡æ¬¾\r\n',0),(235895,6553,'sv','Standard betalningsvillkor',0),(235896,6553,'it','Termini di pagamento predefinito',0),(235897,6553,'tl','',0),(235898,6553,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3586;&#3657;&#3629;&#3605;&#3585;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(235899,6553,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(235900,6553,'ms','Terma pembayaran lalai',0),(235901,6553,'ar','Ø´Ø±ÙˆØ· Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(235902,6553,'fr','Conditions de paiement par dÃ©faut',0),(235903,6553,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆæ”¯æ‰•æ¡ä»¶',0),(235904,6553,'pt','CondiÃ§Ãµes de pagamento padrÃ£o',0),(235905,6553,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(235906,6553,'es','TÃ©rminos de Pago por Defecto',0),(235907,6553,'de','Standard-Zahlungsbedingungen',0),(235908,6553,'en','Default Payment Terms',0),(235909,6554,'is','',0),(235910,6554,'dr','ÙÙ‚Ø· Ø§Ú¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ù‚Ø¨Ù„ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø§Ø¹Ù…Ø§Ù„ Ø´ÙˆØ¯',0),(235911,6554,'pr','ÙÙ‚Ø· Ø§Ú¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ù‚Ø¨Ù„ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø§Ø¹Ù…Ø§Ù„ Ø´ÙˆØ¯',0),(235912,6554,'tr','Sadece geÃ§erlidir Pre-Approving Ã¶deme',0),(235913,6554,'pl','Ma zastosowanie tylko jeÅ›li Pre-Approving pÅ‚atnoÅ›ci',0),(235914,6554,'bg','Ð¡Ðµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð° ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Pre-Approving Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(235915,6554,'ur','Ø§Ú¯Ø± ØµØ±Ù Ù„Ú¯Ø§ØªØ§ ÛÛ’ Pre-Approving Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(235916,6554,'sr','ÐŸÑ€Ð¸Ð¼ÐµÑšÑƒÑ˜Ðµ ÑÐµ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÐŸÑ€Ðµ-ÐÐ¿Ð¿Ñ€Ð¾Ð²Ð¸Ð½Ð³ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(235917,6554,'vi','Chá»‰ Ã¡p dá»¥ng khi thanh toÃ¡n Ä‘Ã£ duyá»‡t trÆ°á»›c',0),(235918,6554,'af','Slegs Toegepas as \'n Vooraf Goedgekeurde Betaling',0),(235919,6554,'ro','Se aplicÄƒ numai dacÄƒ Pre-Approving de platÄƒ',0),(235920,6554,'et','Kehtib ainult siis, kui Pre-Approving makse',0),(235921,6554,'si','Velja samo, Äe Pre-Approving plaÄila',0),(235922,6554,'ba','Hanya berlaku jika pembayaran Pre-Approving',0),(235923,6554,'nl','Alleen van toepassing als Pre-Approving betaling',0),(235924,6554,'fi','Sovelletaan vain, jos Pre-Approving maksu',0),(235925,6554,'no','Gjelder bare hvis Pre-Approving betaling',0),(235926,6554,'da','GÃ¦lder kun, hvis Pre-Approving betaling',0),(235927,6554,'ko','ê²½ìš°ì— ì ìš© Pre-Approving ì§€ë¶ˆ',0),(235928,6554,'he','×—×œ ×¨×§ ×× ×”×ª×©×œ×•× Pre-Approving',0),(235929,6554,'el','Î™ÏƒÏ‡ÏÎµÎ¹ Î¼ÏŒÎ½Î¿ Î±Î½ Pre-Approving Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(235930,6554,'zh','åªé€‚ç”¨äºŽé¢„å…ˆæ ¸å‡†çš„ä»˜æ¬¾\r\n',0),(235931,6554,'sv','GÃ¤ller endast om Pre-Approving betalning',0),(235932,6554,'it','Si applica solo se il pagamento Pre-Approving',0),(235933,6554,'tl','',0),(235934,6554,'th','&#3626;&#3617;&#3633;&#3588;&#3619;&#3648;&#3617;&#3639;&#3656;&#3629;&#3617;&#3637;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3',0),(235935,6554,'hi','à¤•à¥‡à¤µà¤² à¤²à¤¾à¤—à¥‚ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤¯à¤¦à¤¿ Pre-Approving à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(235936,6554,'ms','Hanya dikenakan jika pembayaran Pre-Approving',0),(235937,6554,'ar','Ù„Ø§ ÙŠÙ†Ø·Ø¨Ù‚ Ø¥Ù„Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù† \"Ø§Ù„Ø¯ÙØ¹ Ø¨Ø±ÙŠØ§Ø¨Ø±ÙˆÙÙŠÙ†Ø¬\"',0),(235938,6554,'fr','S\'applique uniquement si paiement Pre-Approving',0),(235939,6554,'jp','å ´åˆã«ã®ã¿ Pre-Approving æ”¯æ‰•ã„',0),(235940,6554,'pt','SÃ³ se aplica se o pagamento Pre-Approving',0),(235941,6554,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½ÑÐµÑ‚ÑÑ, Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Pre-Approving Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(235942,6554,'es','Solo Aplica si el Pago es Pre-Aprobado',0),(235943,6554,'de','Gilt nur, wenn Pre-Approving Zahlung',0),(235944,6554,'en','Only Applies if Pre-Approving Payment',0),(235945,6555,'is','',0),(235946,6555,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø§Ù†Ù‚Ø·Ø§Ø¹ ØªØ§ÙŠÙŠØ¯  ',0),(235947,6555,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø§Ù†Ù‚Ø·Ø§Ø¹ ØªØ§ÙŠÙŠØ¯  ',0),(235948,6555,'tr','Kesme onay tarihi kullan',0),(235949,6555,'pl','UÅ¼yj daty zatwierdzenia odciÄ™cia',0),(235950,6555,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Cutoff Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð´Ð°Ñ‚Ð°',0),(235951,6555,'ur','ÙØ±ÛŒÙ… Cutoff Ù…Ù†Ø¸ÙˆØ±ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(235952,6555,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð³Ñ€Ð°Ð½Ð¸Ñ‡Ð½Ñƒ Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐ° Ð´Ð°Ñ‚ÑƒÐ¼',0),(235953,6555,'vi','DÃ¹ng ngÃ y cháº¥p thuáº­n',0),(235954,6555,'af','Gebruik Afsny Goedkeuringsdatum',0),(235955,6555,'ro','UtilizaÅ£i data aprobÄƒrii Cutoff',0),(235956,6555,'et','Kasutage tarneseisak kinnitamise kuupÃ¤ev',0),(235957,6555,'si','Uporabite Cutoff odobritev datum',0),(235958,6555,'ba','Menggunakan tanggal Cutoff persetujuan',0),(235959,6555,'nl','Cutoff goedkeuring datum gebruiken',0),(235960,6555,'fi','KÃ¤yttÃ¤Ã¤ sulku hyvÃ¤ksymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(235961,6555,'no','Bruke Cutoff godkjenning',0),(235962,6555,'da','Bruge Cutoff godkendelse dato',0),(235963,6555,'ko','ìŠ¹ì¸ ë§ˆê° ë‚ ì§œë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(235964,6555,'he','×”×©×ª×ž×© ×‘×ª××¨×™×š ××™×©×•×¨ ×—×™×ª×•×š',0),(235965,6555,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÎºÎ¿Ï€Î®Ï‚ Î­Î³ÎºÏÎ¹ÏƒÎ·',0),(235966,6555,'zh','ä½¿ç”¨æ‰¹å‡†æ—¥æœŸæˆªæ­¢\r\n',0),(235967,6555,'sv','AnvÃ¤nda Cutoff godkÃ¤nnandedatum',0),(235968,6555,'it','Utilizzare la data di approvazione di taglio',0),(235969,6555,'tl','',0),(235970,6555,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3594;&#3657;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(235971,6555,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‡ à¤•à¤Ÿà¤‘à¤«à¤¼ à¤¤à¤¿à¤¥à¤¿ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(235972,6555,'ms','Gunakan tarikh tamat tempoh kelulusan',0),(235973,6555,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø§Ø³ØªÙ‚Ø·Ø§Ø¹',0),(235974,6555,'fr','Utiliser la Date d\'approbation de coupure',0),(235975,6555,'jp','ã‚«ãƒƒãƒˆã‚ªãƒ•æ‰¿èªæ—¥ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(235976,6555,'pt','Use Data de AprovaÃ§Ã£o de Atalho',0),(235977,6555,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð”Ð°Ñ‚Ð° Ð¾Ñ‚ÑÐµÑ‡ÐºÐ¸ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(235978,6555,'es','Usar Fecha de AprobaciÃ³n de Corte',0),(235979,6555,'de','Cutoff Genehmigungsdatum verwenden',0),(235980,6555,'en','Use Cutoff Approval Date',0),(235981,6556,'is','',0),(235982,6556,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾ÙŠØ´ Ø§Ø² ØªØ§ÙŠÙŠØ¯ ',0),(235983,6556,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾ÙŠØ´ Ø§Ø² ØªØ§ÙŠÙŠØ¯ ',0),(235984,6556,'tr','KullanÄ±m Ã¶ncesi onay tarihi',0),(235985,6556,'pl','UÅ¼yj daty wstÄ™pnego zatwierdzenia',0),(235986,6556,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð´Ð°Ñ‚Ð°',0),(235987,6556,'ur','Ù¾Ø±ÛŒ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(235988,6556,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÐ´-Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(235989,6556,'vi','DÃ¹ng ngÃ y cháº¥p thuáº­n trÆ°á»›c',0),(235990,6556,'af','Gebruik Voorafgoedgekeurde Datum',0),(235991,6556,'ro','Utilizarea pre-aprobare data',0),(235992,6556,'et','Kasutada eelneva kinnitamise kuupÃ¤ev',0),(235993,6556,'si','Datum predhodne odobritve uporabe',0),(235994,6556,'ba','Gunakan pra-persetujuan tanggal',0),(235995,6556,'nl','Gebruik pre-goedkeuring datum',0),(235996,6556,'fi','KÃ¤yttÃ¤Ã¤ ennalta-hyvÃ¤ksyntÃ¤',0),(235997,6556,'no','Bruk forhÃ¥ndsgodkjenning dato',0),(235998,6556,'da','Bruge forhÃ¥ndsgodkendelse dato',0),(235999,6556,'ko','ì‚¬ì „ ìŠ¹ì¸ ë‚ ì§œ ì‚¬ìš©',0),(236000,6556,'he','×ª××¨×™×š ××™×©×•×¨ ×©×™×ž×•×©',0),(236001,6556,'el','Î§ÏÎ®ÏƒÎ· Ï€ÏÎ¿-Î­Î³ÎºÏÎ¹ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(236002,6556,'zh','ä½¿ç”¨é¢„å‡†æ—¥æœŸ\r\n',0),(236003,6556,'sv','AnvÃ¤nda godkÃ¤nnande fÃ¶re datum',0),(236004,6556,'it','Utilizzare la data di pre-approvazione',0),(236005,6556,'tl','',0),(236006,6556,'th','&#3651;&#3594;&#3657;&#3585;&#3656;&#3629;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(236007,6556,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤¸à¥à¤µà¥€à¤•à¥ƒà¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(236008,6556,'ms','Tarikh kelulusan pra penggunaan',0),(236009,6556,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø§Ù„Ù…Ø³Ø¨Ù‚Ø©',0),(236010,6556,'fr','Utiliser la Date de l\'approbation prÃ©alable',0),(236011,6556,'jp','äº‹å‰æ‰¿èªã®æ—¥ä»˜ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(236012,6556,'pt','Use Data de PrÃ©-AprovaÃ§Ã£o',0),(236013,6556,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð”Ð°Ñ‚Ð°',0),(236014,6556,'es','Usar Fecha de Pre AprobaciÃ³n',0),(236015,6556,'de','Vorabgenehmigung Nutzungstermin',0),(236016,6556,'en','Use Pre-Approval Date',0),(236017,6557,'is','',0),(236018,6557,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾ÙŠØ´ Ø§Ø² ØªØ§ÙŠÙŠØ¯ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØªØ§Ø±ÙŠØ® Ú†Ùƒ',0),(236019,6557,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾ÙŠØ´ Ø§Ø² ØªØ§ÙŠÙŠØ¯ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØªØ§Ø±ÙŠØ® Ú†Ùƒ',0),(236020,6557,'tr','Ã–n OnayÄ± Tarih onay tarihi olarak kullanÄ±n',0),(236021,6557,'pl','UÅ¼yj daty wstÄ™pne zatwierdzenie wyboru daty',0),(236022,6557,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð´Ð°Ñ‚Ð° ÐºÐ°Ñ‚Ð¾ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°Ñ‚Ð°',0),(236023,6557,'ur','Ù¾Ø±ÛŒ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ ØªØ§Ø±ÛŒØ® Ú†ÛŒÚ© Ø§Ù† ØªØ§Ø±ÛŒØ® Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Û”',0),(236024,6557,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´-Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ Ð´Ð°Ñ‚ÑƒÐ¼ ÐºÐ°Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(236025,6557,'vi','DÃ¹ng ngÃ y duyá»‡t trÆ°á»›c lÃ m ngÃ y SÃ©c',0),(236026,6557,'af','Gebruik Voorafgoedgekeurde Datum as Kontrole Datum',0),(236027,6557,'ro','Utilizarea pre-aprobare data ca data de Check',0),(236028,6557,'et','Kasutada eelneva heakskiitmise kuupÃ¤eva kontrolli kuupÃ¤ev',0),(236029,6557,'si','Datum predhodne odobritve uporabe kot potrdite datum',0),(236030,6557,'ba','Gunakan pra-persetujuan tanggal sebagai tanggal Check',0),(236031,6557,'nl','Gebruik pre-goedkeuring datum als selectievakje datum',0),(236032,6557,'fi','KÃ¤yttÃ¤Ã¤ ennakkohyvÃ¤ksyntÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(236033,6557,'no','Bruk forhÃ¥ndsgodkjenning dato som kontrolldatoen',0),(236034,6557,'da','Bruge forhÃ¥ndsgodkendelse dato som checkens dato',0),(236035,6557,'ko','ì‚¬ì „ ìŠ¹ì¸ ë‚ ì§œ í™•ì¸ ë‚ ì§œ ì‚¬ìš©',0),(236036,6557,'he','×”×©×ª×ž×© ×‘×ª××¨×™×š ×©×œ×¤× ×™ ×”××™×©×•×¨ ×›×ª××¨×™×š ×¡×™×ž×•×Ÿ',0),(236037,6557,'el','Î§ÏÎ®ÏƒÎ· Ï€ÏÎ¿-Î­Î³ÎºÏÎ¹ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(236038,6557,'zh','ä½¿ç”¨é¢„å‡†æ—¥æœŸä½œä¸ºæ”¯ç¥¨æ—¥æœŸ\r\n',0),(236039,6557,'sv','AnvÃ¤nds fÃ¶re godkÃ¤nnande som kontrollera datum',0),(236040,6557,'it','Utilizzare pre-approvazione data come Data Check',0),(236041,6557,'tl','',0),(236042,6557,'th','&#3651;&#3594;&#3657;&#3585;&#3656;&#3629;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3648;&#3611;&#3655;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;',0),(236043,6557,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤¸à¥à¤µà¥€à¤•à¥ƒà¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤šà¥‡à¤• à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(236044,6557,'ms','Tarikh kelulusan pra digunakan sebagai tarikh Daftar',0),(236045,6557,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø§Ù„Ù…Ø³Ø¨Ù‚Ø© Ø¹Ù„Ù‰ ØªØ§Ø±ÙŠØ® ÙƒØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(236046,6557,'fr','Utiliser une approbation prÃ©alable Date comme Date de Check',0),(236047,6557,'jp','äº‹å‰æ‰¿èªã®æ—¥ä»˜ãƒã‚§ãƒƒã‚¯ã®æ—¥ä»˜ã¨ã—ã¦ä½¿ç”¨ã—ã¾ã™ã€‚',0),(236048,6557,'pt','Use Data de PrÃ©-AprovaÃ§Ã£o como Data de VerificaÃ§Ã£o',0),(236049,6557,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð´Ð°Ñ‚Ñƒ ÐºÐ°Ðº Ð´Ð°Ñ‚Ñƒ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(236050,6557,'es','Usar Fecha de Pre AprobaciÃ³n como Fecha de Cheque',0),(236051,6557,'de','Vorabgenehmigung Nutzungstermin als Check-Datum',0),(236052,6557,'en','Use Pre-Approval Date as Check Date',0),(236053,6558,'is','',0),(236054,6558,'dr','ÙƒØ¯ Ú¯Ø±ÙˆÙ‡ ',0),(236055,6558,'pr','ÙƒØ¯ Ú¯Ø±ÙˆÙ‡ ',0),(236056,6558,'tr','Grup kodu',0),(236057,6558,'pl','Kod grupy',0),(236058,6558,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(236059,6558,'ur','Ú¯Ø±ÙˆÙ¾ Ú©ÙˆÚˆ',0),(236060,6558,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð³Ñ€ÑƒÐ¿Ðµ',0),(236061,6558,'vi','MÃ£ nhÃ³m',0),(236062,6558,'af','Groepkode',0),(236063,6558,'ro','Cod grup',0),(236064,6558,'et','Grupi kood',0),(236065,6558,'si','Å ifra skupine',0),(236066,6558,'ba','Kode grup',0),(236067,6558,'nl','Groepscode',0),(236068,6558,'fi','Koodi',0),(236069,6558,'no','Koden',0),(236070,6558,'da','Gruppekoden',0),(236071,6558,'ko','ê·¸ë£¹ ì½”ë“œ',0),(236072,6558,'he','×§×‘×•×¦×ª ×§×•×“',0),(236073,6558,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î¿Î¼Î¬Î´Î±Ï‚',0),(236074,6558,'zh','ç»„ä»£ç \r\n',0),(236075,6558,'sv','Kod',0),(236076,6558,'it','Codice gruppo',0),(236077,6558,'tl','',0),(236078,6558,'th','&#3619;&#3627;&#3633;&#3626;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(236079,6558,'hi','à¤¸à¤®à¥‚à¤¹ à¤•à¥‹à¤¡',0),(236080,6558,'ms','Kod Kumpulan',0),(236081,6558,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ©',0),(236082,6558,'fr','Code de groupe',0),(236083,6558,'jp','ã‚°ãƒ«ãƒ¼ãƒ— ã‚³ãƒ¼ãƒ‰',0),(236084,6558,'pt','CÃ³digo de grupo',0),(236085,6558,'ru','ÐšÐ¾Ð´ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(236086,6558,'es','CÃ³digo de Grupo',0),(236087,6558,'de','Gruppencode',0),(236088,6558,'en','Group Code',0),(236089,6559,'is','',0),(236090,6559,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(236091,6559,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(236092,6559,'tr','Vendoe gruplarÄ± ekleyin',0),(236093,6559,'pl','Dodaj grupy Vendoe',0),(236094,6559,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Vendoe Ð³Ñ€ÑƒÐ¿Ð¸',0),(236095,6559,'ur','ÙˆØ§Ù†Ø¯ÙˆØ§ Ú¯Ø±ÙˆÙ¾ÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(236096,6559,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ðµ Ð’ÐµÐ½Ð´Ð¾Ðµ',0),(236097,6559,'vi','ThÃªm NhÃ³m NgÆ°á»i bÃ¡n',0),(236098,6559,'af','Verskaffer Groepe Skep',0),(236099,6559,'ro','Adauga Vendoe grupuri',0),(236100,6559,'et','Vendoe SÃµprade lisamine',0),(236101,6559,'si','Vendoe skupine dodali',0),(236102,6559,'ba','Vendoe kelompok menambahkan',0),(236103,6559,'nl','Vendoe groepen toevoegen',0),(236104,6559,'fi','Vendoe ryhmien lisÃ¤Ã¤minen',0),(236105,6559,'no','Vendoe grupper legge',0),(236106,6559,'da','Vendoe grupper tilfÃ¸je',0),(236107,6559,'ko','Vendoe ê·¸ë£¹ ì¶”ê°€',0),(236108,6559,'he','×”×•×¡×£ ×§×‘×•×¦×•×ª ×¡×¤×§',0),(236109,6559,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¿Î¼Î¬Î´ÎµÏ‚ Vendoe',0),(236110,6559,'zh','ä¾›åº”å•†ç»„æ·»åŠ \r\n',0),(236111,6559,'sv','Vendoe grupper lÃ¤gga',0),(236112,6559,'it','Vendoe gruppi aggiungere',0),(236113,6559,'tl','',0),(236114,6559,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(236115,6559,'hi','Vendoe à¤¸à¤®à¥‚à¤¹ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(236116,6559,'ms','Tambah Kumpulan Vendoe',0),(236117,6559,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø§Øª ÙÙŠÙ†Ø¯Ùˆ',0),(236118,6559,'fr','Ajouter des groupes de Vendoe',0),(236119,6559,'jp','Vendoe ã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(236120,6559,'pt','Adicionar grupos vendoe',0),(236121,6559,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð“Ñ€ÑƒÐ¿Ð¿Ñƒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(236122,6559,'es','Proveedor Grupos Agregar',0),(236123,6559,'de','Vendoe Gruppen hinzufÃ¼gen',0),(236124,6559,'en','Vendoe Groups Add',0),(236125,6560,'is','',0),(236126,6560,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯ ',0),(236127,6560,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯ ',0),(236128,6560,'tr','Yeni Grup Ekle',0),(236129,6560,'pl','Dodaj nowÄ… grupÄ™',0),(236130,6560,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(236131,6560,'ur','Ù†ÛŒØ§ Ú¯Ø±ÙˆÙ¾ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(236132,6560,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð³Ñ€ÑƒÐ¿Ðµ',0),(236133,6560,'vi','ThÃªm NhÃ³m Má»›i',0),(236134,6560,'af','Nuwe Groep Byvoeg',0),(236135,6560,'ro','Adauga Grup nou',0),(236136,6560,'et','Lisa uus grupp',0),(236137,6560,'si','Dodaj novo skupino',0),(236138,6560,'ba','Menambahkan grup baru',0),(236139,6560,'nl','Nieuwe groep toevoegen',0),(236140,6560,'fi','LisÃ¤Ã¤ uusi ryhmÃ¤',0),(236141,6560,'no','Legge til ny gruppe',0),(236142,6560,'da','TilfÃ¸j ny gruppe',0),(236143,6560,'ko','ìƒˆ ê·¸ë£¹ ì¶”ê°€',0),(236144,6560,'he','×”×•×¡×£ ×§×‘×•×¦×” ×—×“×©×”',0),(236145,6560,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î±Ï‚ Î¿Î¼Î¬Î´Î±Ï‚',0),(236146,6560,'zh','å¢žåŠ æ–°ç»„\r\n',0),(236147,6560,'sv','LÃ¤gg till ny grupp',0),(236148,6560,'it','Aggiungi nuovo gruppo',0),(236149,6560,'tl','',0),(236150,6560,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(236151,6560,'hi','à¤¨à¤¯à¤¾ à¤¸à¤®à¥‚à¤¹ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(236152,6560,'ms','Tambah Kumpulan baru',0),(236153,6560,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(236154,6560,'fr','Ajouter le nouveau groupe',0),(236155,6560,'jp','æ–°ã—ã„ã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(236156,6560,'pt','Adicionar novo grupo',0),(236157,6560,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð³Ñ€ÑƒÐ¿Ð¿Ñƒ',0),(236158,6560,'es','Agregar Nuevo Grupo',0),(236159,6560,'de','Neue Gruppe hinzufÃ¼gen',0),(236160,6560,'en','Add New Group',0),(236161,6561,'is','',0),(236162,6561,'dr','Ø­Ø°Ù Ú¯Ø±ÙˆÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(236163,6561,'pr','Ø­Ø°Ù Ú¯Ø±ÙˆÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(236164,6561,'tr','MÃ¼ÅŸteri grubu sil',0),(236165,6561,'pl','Usuwanie grupy klientÃ³w',0),(236166,6561,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(236167,6561,'ur','Ú©Ø³Ù¹Ù…Ø± Ú¯Ø±ÙˆÙ¾ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(236168,6561,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð³Ñ€ÑƒÐ¿Ñƒ ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(236169,6561,'vi','XÃ³a nhÃ³m khÃ¡ch hÃ ng',0),(236170,6561,'af','Skrap Klant / KliÃ«nt Groep',0),(236171,6561,'ro','Grup de client ÅŸtergere',0),(236172,6561,'et','Kustuta kliendigrupp',0),(236173,6561,'si','Brisanje skupine kupca',0),(236174,6561,'ba','Hapus kelompok pelanggan',0),(236175,6561,'nl','Klant groep verwijderen',0),(236176,6561,'fi','Poista asiakkaan ryhmÃ¤',0),(236177,6561,'no','Slett kundegruppe',0),(236178,6561,'da','Slet kunde gruppe',0),(236179,6561,'ko','ê³ ê° ê·¸ë£¹ ì‚­ì œ',0),(236180,6561,'he','×ž×—×§ ×œ×œ×§×•×— ×§×‘×•×¦×”',0),(236181,6561,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î¿Î¼Î¬Î´Î±Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(236182,6561,'zh','åˆ é™¤å®¢æˆ·ç¾¤\r\n',0),(236183,6561,'sv','Ta bort kundgrupp',0),(236184,6561,'it','Elimina gruppo cliente',0),(236185,6561,'tl','',0),(236186,6561,'th','&#3621;&#3610;&#3585;&#3621;&#3640;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(236187,6561,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹ à¤¹à¤Ÿà¤¾à¤à¤',0),(236188,6561,'ms','Hapus pelanggan Kumpulan',0),(236189,6561,'ar','Ø­Ø°Ù Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(236190,6561,'fr','Supprimer le groupe client',0),(236191,6561,'jp','é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—ã®å‰Šé™¤',0),(236192,6561,'pt','Excluir grupo de cliente',0),(236193,6561,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(236194,6561,'es','Eliminar Grupo de Clientes',0),(236195,6561,'de','Kunden-Gruppe lÃ¶schen',0),(236196,6561,'en','Delete Customer Group',0),(236197,6562,'is','',0),(236198,6562,'dr','Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(236199,6562,'pr','Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(236200,6562,'tr','SatÄ±cÄ± grubu',0),(236201,6562,'pl','Grupa dostawcÃ³w',0),(236202,6562,'bg','Ð“Ñ€ÑƒÐ¿Ð° Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(236203,6562,'ur','ÙˆÛŒÙ†ÚˆØ± Ú¯Ø±ÙˆÙ¾',0),(236204,6562,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(236205,6562,'vi','NhÃ³m NgÆ°á»i bÃ¡n',0),(236206,6562,'af','Verskaffer Groep',0),(236207,6562,'ro','Furnizor de grup',0),(236208,6562,'et','Tarnija grupp',0),(236209,6562,'si','Skupine dobavitelja',0),(236210,6562,'ba','Penjual grup',0),(236211,6562,'nl','Leverancier groep',0),(236212,6562,'fi','ToimittajaryhmÃ¤',0),(236213,6562,'no','LeverandÃ¸rgruppe',0),(236214,6562,'da','Kreditorgruppe',0),(236215,6562,'ko','ê³µê¸‰ ì—…ì²´ ê·¸ë£¹',0),(236216,6562,'he','×§×‘×•×¦×ª ×¡×¤×§',0),(236217,6562,'el','ÎŸÎ¼Î¬Î´Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½',0),(236218,6562,'zh','ä¾›åº”å•†ç»„\r\n',0),(236219,6562,'sv','LeverantÃ¶rsgrupp',0),(236220,6562,'it','Gruppo di fornitori',0),(236221,6562,'tl','',0),(236222,6562,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(236223,6562,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¤®à¥‚à¤¹',0),(236224,6562,'ms','Kumpulan Penjual',0),(236225,6562,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ù…ÙˆØ±Ø¯',0),(236226,6562,'fr','Groupe de fournisseurs',0),(236227,6562,'jp','ä»•å…¥å…ˆã‚°ãƒ«ãƒ¼ãƒ—',0),(236228,6562,'pt','Grupo de fornecedor',0),(236229,6562,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(236230,6562,'es','Proveedor Grupo',0),(236231,6562,'de','Kreditorengruppe',0),(236232,6562,'en','Vendor Group',0),(236233,6563,'is','',0),(236234,6563,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(236235,6563,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(236236,6563,'tr','SatÄ±cÄ± grubu gÃ¼ncelle',0),(236237,6563,'pl','Dostawcy grupy aktualizacji',0),(236238,6563,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð³Ñ€ÑƒÐ¿Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(236239,6563,'ur','ÙˆÛŒÙ†ÚˆØ± Ú¯Ø±ÙˆÙ¾ÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(236240,6563,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(236241,6563,'vi','Cáº­p Nháº­t NhÃ³m NgÆ°á»i BÃ¡n',0),(236242,6563,'af','Verskaffer Groepe Opdateer',0),(236243,6563,'ro','Actualizare de grupuri de furnizor',0),(236244,6563,'et','Hankija sÃµprade vÃ¤rskendus',0),(236245,6563,'si','Posodobitev skupine dobavitelja',0),(236246,6563,'ba','Penjual grup Update',0),(236247,6563,'nl','Leverancier groepen Update',0),(236248,6563,'fi','Toimittajan ryhmÃ¤t pÃ¤ivitys',0),(236249,6563,'no','LeverandÃ¸ren grupper oppdatering',0),(236250,6563,'da','Kreditor grupper opdatering',0),(236251,6563,'ko','ê³µê¸‰ ì—…ì²´ ê·¸ë£¹ ì—…ë°ì´íŠ¸',0),(236252,6563,'he','×¢×“×›×•×Ÿ ×§×‘×•×¦×•×ª ×¡×¤×§×™×',0),(236253,6563,'el','ÎŸÎ¼Î¬Î´ÎµÏ‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(236254,6563,'zh','ä¾›åº”å•†ç»„æ›´æ–°\r\n',0),(236255,6563,'sv','LeverantÃ¶r fÃ¶r uppdatering',0),(236256,6563,'it','Aggiornamento gruppi del fornitore',0),(236257,6563,'tl','',0),(236258,6563,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(236259,6563,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¤®à¥‚à¤¹ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(236260,6563,'ms','Update Kumpulan Penjual',0),(236261,6563,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ†',0),(236262,6563,'fr','Mise Ã  jour des groupes de fournisseurs',0),(236263,6563,'jp','ä»•å…¥å…ˆã‚°ãƒ«ãƒ¼ãƒ—ã®æ›´æ–°',0),(236264,6563,'pt','AtualizaÃ§Ã£o de grupos de fornecedores',0),(236265,6563,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(236266,6563,'es','Proveedor Grupos Actualizar',0),(236267,6563,'de','Anbieter-Gruppen-Update',0),(236268,6563,'en','Vendor Groups Update',0),(236269,6564,'is','',0),(236270,6564,'dr','(ÙƒØ§Ù‡Ø´ Ù…Ø§Ù„ÙŠØ§ØªÙŠ) Ø¯Ø± Ø­Ø³Ø§Ø¨ Ù‡Ø§',0),(236271,6564,'pr','Ø§Ø¹Ù…Ø§Ù„ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ù…Ø§Ù„ÙŠØ§ØªÙŠ(ÙƒØ§Ù‡Ø´ Ù…Ø§Ù„ÙŠØ§ØªÙŠ) Ø¯Ø± Ø­Ø³Ø§Ø¨ Ù‡Ø§',0),(236272,6564,'tr','Vergi Kredisi miktarlarÄ± ile geÃ§erlidir',0),(236273,6564,'pl','Zastosowanie ulgi podatkowej do kwoty',0),(236274,6564,'bg','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°Ñ‚ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸ Ð·Ð° ÑÑƒÐ¼Ð¸',0),(236275,6564,'ur','Ù¹ÛŒÚ©Ø³ Ú©Ø±ÛŒÚˆÙ¹Ø³ Ú©Û’ Ù„ÛŒÛ’ Ø±Ù‚ÙˆÙ… Ù„Ú¯Ø§Ø¦ÛŒÚº Û”',0),(236276,6564,'sr','ÐŸÑ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÐµÑÐºÐ¸Ñ… ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð° Ð¸Ð·Ð½Ð¾ÑÐ¸',0),(236277,6564,'vi','á»¨ng Dá»¥ng HoÃ£n Thuáº¿ cho Sá»‘ Tiá»n',0),(236278,6564,'af','Staan Belastingkrediete aan Bedrae toe',0),(236279,6564,'ro','Creditele fiscale se aplicÄƒ sumelor',0),(236280,6564,'et','Kohaldada maksu summad',0),(236281,6564,'si','Veljajo davÄne olajÅ¡ave za zneske',0),(236282,6564,'ba','Menerapkan kredit pajak untuk jumlah',0),(236283,6564,'nl','Fiscaal verrekenbare tegoeden van toepassing op bedragen',0),(236284,6564,'fi','Sovelletaan verohelpotukset',0),(236285,6564,'no','Bruke skattekreditter belÃ¸p',0),(236286,6564,'da','GÃ¦lde skattefradrag for belÃ¸b',0),(236287,6564,'ko','ê¸ˆì•¡ì„ ì„¸ ì•¡ ê³µì œë¥¼ ì ìš©',0),(236288,6564,'he','×œ×”×—×™×œ ×–×™×›×•×™×™ ×ž×¡ ×¢×œ ×›×ž×•×™×•×ª',0),(236289,6564,'el','Î•Ï†Î±ÏÎ¼Î¿Î³Î® Ï†ÏŒÏÎ¿Ï… ÏƒÏ„Î± Ï€Î¿ÏƒÎ¬',0),(236290,6564,'zh','ç”³è¯·ç¨Žæ”¶æŠµå…é‡‘é¢\r\n',0),(236291,6564,'sv','SkattelÃ¤ttnad tillÃ¤mpas pÃ¥ belopp',0),(236292,6564,'it','Applicare i crediti d\'imposta per gli importi',0),(236293,6564,'tl','',0),(236294,6564,'th','&#3651;&#3594;&#3657;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3616;&#3634;&#3625;&#3637;&#3651;&#3609;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(236295,6564,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(236296,6564,'ms','Menggunakan kredit cukai kepada jumlah',0),(236297,6564,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø¥Ø¹ÙØ§Ø¡Ø§Øª Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ© Ù„Ù„Ù…Ø¨Ø§Ù„Øº',0),(236298,6564,'fr','Appliquer des crÃ©dits d\'impÃ´t aux montants',0),(236299,6564,'jp','ç¨Žé¡æŽ§é™¤ã®é‡‘é¡ã«é©ç”¨ã—ã¾ã™ã€‚',0),(236300,6564,'pt','CrÃ©ditos fiscais aplicam-se aos montantes',0),(236301,6564,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½ÑÑŽÑ‚ÑÑ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð»ÑŒÐ³Ð¾Ñ‚Ñ‹ Ð´Ð»Ñ ÑÑƒÐ¼Ð¼',0),(236302,6564,'es','Aplicar CrÃ©ditos de Impuestos a las Cantidades',0),(236303,6564,'de','Steuergutschriften fÃ¼r BetrÃ¤ge gelten',0),(236304,6564,'en','Apply Tax Credits to Amounts',0),(236305,6565,'is','',0),(236306,6565,'dr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ø¨Ù„Ù‡ ',0),(236307,6565,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ø¨Ù„Ù‡ ',0),(236308,6565,'tr','EÄŸer Evet onay',0),(236309,6565,'pl','SprawdÅº, czy tak',0),(236310,6565,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ð»Ð¸ Ð´Ð°',0),(236311,6565,'ur','Ø§Ú¯Ø± ÛØ§ÚºØŒ ØªÙˆ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(236312,6565,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð´Ð° Ð»Ð¸ Ð´Ð°',0),(236313,6565,'vi','ÄÃ¡nh dáº¥u náº¿u cÃ³',0),(236314,6565,'af','Merk indien Ja',0),(236315,6565,'ro','VerificaÅ£i dacÄƒ da',0),(236316,6565,'et','Kontrollige, kas Jah',0),(236317,6565,'si','Preverite, Äe ja',0),(236318,6565,'ba','Periksa apakah ya',0),(236319,6565,'nl','Controleer of Ja',0),(236320,6565,'fi','Tarkista kyllÃ¤',0),(236321,6565,'no','Sjekk Hvis ja',0),(236322,6565,'da','Check Hvis ja',0),(236323,6565,'ko','ê·¸ë ‡ë‹¤ë©´ í™•ì¸',0),(236324,6565,'he','×¡×ž×Ÿ ×× ×›×Ÿ',0),(236325,6565,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î±Î½ Î½Î±Î¹',0),(236326,6565,'zh','æ£€æŸ¥æ˜¯å¦æœ‰\r\n',0),(236327,6565,'sv','Kontrollera om ja',0),(236328,6565,'it','Controllare se sÃ¬',0),(236329,6565,'tl','',0),(236330,6565,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3617;&#3639;&#3656;&#3629;&#3651;&#3594;&#3656;',0),(236331,6565,'hi','à¤¯à¤¦à¤¿ à¤¹à¤¾à¤, à¤¤à¥‹ à¤šà¥‡à¤•',0),(236332,6565,'ms','Semak jika Ya',0),(236333,6565,'ar','Ù…Ø¹Ø±ÙØ© Ù…Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù† Ù†Ø¹Ù…',0),(236334,6565,'fr','Cocher si oui',0),(236335,6565,'jp','ã¯ã„ã®å ´åˆãƒã‚§ãƒƒã‚¯',0),(236336,6565,'pt','Verificar se o Sim',0),(236337,6565,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÐµÑÐ»Ð¸ Ð”Ð°',0),(236338,6565,'es','Checar si es Si',0),(236339,6565,'de','ÃœberprÃ¼fen Sie, ob ja',0),(236340,6565,'en','Check if Yes',0),(236341,6566,'is','',0),(236342,6566,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ø«Ø¨Øª ',0),(236343,6566,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø«Ø¨Øª ',0),(236344,6566,'tr','Bu girdiyi silmek',0),(236345,6566,'pl','UsuÅ„ ten wpis',0),(236346,6566,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð·Ð°Ð¿Ð¸Ñ',0),(236347,6566,'ur','ÛŒÛ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(236348,6566,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(236349,6566,'vi','XÃ³a Entry nÃ y',0),(236350,6566,'af','Skrap hierdie Inskrywing',0),(236351,6566,'ro','È˜tergeÈ›i aceastÄƒ intrare',0),(236352,6566,'et','Selle kirje kustutamiseks',0),(236353,6566,'si','Izbrisati ta vnos',0),(236354,6566,'ba','Menghapus entri ini',0),(236355,6566,'nl','Verwijder deze vermelding',0),(236356,6566,'fi','Poista tÃ¤mÃ¤ tietue',0),(236357,6566,'no','Slette denne oppfÃ¸ringen',0),(236358,6566,'da','Slet denne post',0),(236359,6566,'ko','ì´ í•­ëª©ì„ ì‚­ì œ',0),(236360,6566,'he','×œ×ž×—×•×§ ××ª ×”×¤×•×¡×˜ ×”×–×”',0),(236361,6566,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Ï„Î¿ Î»Î®Î¼Î¼Î±',0),(236362,6566,'zh','åˆ é™¤æ­¤è®°å½•\r\n',0),(236363,6566,'sv','Ta bort denna post',0),(236364,6566,'it','Eliminare questa voce',0),(236365,6566,'tl','',0),(236366,6566,'th','&#3621;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3609;&#3637;&#3657;',0),(236367,6566,'hi','à¤‡à¤¸ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(236368,6566,'ms','Padam entri ini',0),(236369,6566,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(236370,6566,'fr','Supprimer cette rubrique',0),(236371,6566,'jp','ã“ã®ã‚¨ãƒ³ãƒˆãƒªã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(236372,6566,'pt','Apagar esta entrada',0),(236373,6566,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(236374,6566,'es','Eliminar Esta Entrada',0),(236375,6566,'de','LÃ¶schen Sie diesen Eintrag',0),(236376,6566,'en','Delete This Entry',0),(236377,6567,'is','',0),(236378,6567,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø§Ø¨Øª â€“ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ù†Ø¨Ø§Ø±Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯  Ù…ÙˆØ§Ø¯ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±Ø§ÙŠØ·',0),(236379,6567,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø§Ø¨Øª â€“ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ù†Ø¨Ø§Ø±Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯  Ù…ÙˆØ§Ø¯ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±Ø§ÙŠØ·',0),(236380,6567,'tr','Sabit bir tutar yeniden stoklama bu durumda dÃ¶ndÃ¼ÄŸÃ¼nde Ã¼cret',0),(236381,6567,'pl','PÅ‚aski Restock kwota opÅ‚aty zwracane w ten stan',0),(236382,6567,'bg','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ð° ÑÑƒÐ¼Ð°-Ð¿Ñ€ÐµÐ·Ð°Ð¿Ð°ÑÑÐ²Ð°Ð¼ Ñ‚Ð°ÐºÑÐ° ÐºÐ¾Ð³Ð°Ñ‚Ð¾ ÑÐµ Ð²ÑŠÑ€Ð½Ð° Ð² Ñ‚Ð¾Ð²Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(236383,6567,'ur','ÙÙ„ÛŒÙ¹ Ú©ÛŒ Ø±Ù‚Ù… Ø±ÛŒØ³Ù¹ÙˆÚ© Ø§Ø³ Ø­Ø§Ù„Øª Ù…ÛŒÚº ÙˆØ§Ù¾Ø³ Ù„ÙˆÙ¹Û’ ØªÙˆ ÙÛŒØ³',0),(236384,6567,'sr','Ð Ð°Ð²Ð°Ð½ Ð¸Ð·Ð½Ð¾Ñ Ð½Ð°Ð¿Ð»Ð°Ñ›Ð¸Ð²Ð°ÑšÐµ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ ÐºÐ°Ð´Ð° ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾ Ñƒ Ð¾Ð²Ð¾Ð¼ ÑÑ‚Ð°ÑšÑƒ',0),(236385,6567,'vi','PhÃ­ nháº­p láº¡i kho khi quay láº¡i tÃ¬nh tráº¡ng nÃ y',0),(236386,6567,'af','Plat bedrag-Restock fooi wanneer teruggekeer in hierdie toestand',0),(236387,6567,'ro','Apartament taxÄƒ de restocare suma atunci cÃ¢nd s-a Ã®ntors Ã®n aceastÄƒ stare',0),(236388,6567,'et','Kindla summa tÃ¤iendab tasu kui tagasi see tingimus',0),(236389,6567,'si','Ravno znesek-pokrijete ko vrnil v to stanje',0),(236390,6567,'ba','Rata biaya memperlengkapi jumlah ketika kembali dalam kondisi ini',0),(236391,6567,'nl','Platte bedrag-herbevoorradingstoeslag toen terugkwam in deze voorwaarde',0),(236392,6567,'fi','Tasainen mÃ¤Ã¤rÃ¤-tÃ¤ydennysmaksun palattuaan tÃ¤mÃ¤ ehto',0),(236393,6567,'no','Flat belÃ¸p-returgebyr da tilbake i denne tilstand',0),(236394,6567,'da','Fast belÃ¸b-reklamationsgebyret gebyr nÃ¥r returneret i denne tilstand',0),(236395,6567,'ko','ì´ ìƒíƒœì—ì„œ ë°˜í™˜ ë  ë•Œ í‰ë©´ ê¸ˆì•¡ ìƒˆë¡œ ì‚¬ë“¤ ìˆ˜ìˆ˜ë£Œ',0),(236396,6567,'he','×œ×ž×œ× ×›×ž×•×ª ×©×›×¨ ×“×™×¨×” ×›××©×¨ ×—×–×¨ ×‘×ž×¦×‘ ×”×–×”',0),(236397,6567,'el','Î Î¿ÏƒÏŒ-ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î•Ï†Î¬Ï€Î±Î¾Ï„Î­Î»Î¿Ï‚ ÏŒÏ„Î±Î½ ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ ÏƒÎµ Î±Ï…Ï„ÏŒ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(236398,6567,'zh','å›ºå®šæ•°é‡ï¼Œè¿›è´§è´¹å¦‚æžœåœ¨è¿™ç§æƒ…å†µä¸‹è¿”å›ž\r\n',0),(236399,6567,'sv','Platt belopp-Ã¥teranskaffningsavgift nÃ¤r Ã¥tervÃ¤nde i detta skick',0),(236400,6567,'it','Tariffa flat di quantitÃ -rifornimento scorte quando tornÃ² in questa condizione',0),(236401,6567,'tl','',0),(236402,6567,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3648;&#3605;&#3636;&#3617;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;&#3605;&#3634;&#3617;&#3',0),(236403,6567,'hi','à¤«à¥à¤²à¥ˆà¤Ÿ à¤°à¤¾à¤¶à¤¿ à¤«à¤¿à¤° à¤¸à¥‡ à¤‡à¤•à¤Ÿà¥à¤ à¤¾ à¤•à¤°à¤¨à¤¾ à¤¶à¥à¤²à¥à¤• à¤œà¤¬ à¤‡à¤¸ à¤¹à¤¾à¤²à¤¤ à¤®à¥‡à¤‚ à¤²à¥Œà¤Ÿ à¤†à¤',0),(236404,6567,'ms','Kos Jumlah-Restock tetap apabila kembali dalam keadaan ini',0),(236405,6567,'ar','Ø±Ø³Ù… Ø¥Ø¹Ø§Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ† (Ù…Ø¨Ù„Øº Ù…Ù‚Ø·ÙˆØ¹) - Ø¹Ù†Ø¯ Ø¥Ø±Ø¬Ø§Ø¹ Ø§Ù„Ù…Ø±Ø¯ÙˆØ¯Ø§Øª ÙÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ø­Ø§Ù„Ø©',0),(236406,6567,'fr','Montant-\"restocker\" forfait retour en cet Ã‰tat',0),(236407,6567,'jp','ã“ã®æ¡ä»¶ã§è¿”ã•ã‚Œã‚‹ã¨ããƒ•ãƒ©ãƒƒãƒˆã®é‡‘é¡è£œå……æ–™',0),(236408,6567,'pt','Taxa fixa de quantidade-Restock quando voltou na condiÃ§Ã£o deste',0),(236409,6567,'ru','ÐŸÐ»Ð¾ÑÐºÐ¸Ðµ ÑÑƒÐ¼Ð¼Ð°-Ð¿Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚Ð° ÐºÐ¾Ð³Ð´Ð° Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ Ð² ÑÑ‚Ð¾Ð¼ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ð¸',0),(236410,6567,'es','Cuota Fija de Cantidad-Reabastecer cuando Retornado en Esta CondiciÃ³n',0),(236411,6567,'de','Pauschale Betrag-Bestandserinnerung wenn in dieser Zustand zurÃ¼ckgegeben',0),(236412,6567,'en','Flat Amount-Restock Fee when Returned in This Condition',0),(236413,6568,'is','',0),(236414,6568,'dr','Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ø²Ø¯  ØªØ¬Ø¯ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±Ø§ÙŠØ·',0),(236415,6568,'pr','Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ø²Ø¯  ØªØ¬Ø¯ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±Ø§ÙŠØ·',0),(236416,6568,'tr','Ne zaman bu durumda iade Ã¼creti yÃ¼zde eksikleri tamamlamak',0),(236417,6568,'pl','Procent odnawiania opÅ‚atÄ™ wrÃ³ciÅ‚ w tym stanie',0),(236418,6568,'bg','% ÐŸÑ€ÐµÐ·Ð°Ð¿Ð°ÑÑÐ²Ð°Ð¼ Ñ‚Ð°ÐºÑÐ°, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ ÑÐµ Ð²ÑŠÑ€Ð½Ð° Ð² Ñ‚Ð¾Ð²Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(236419,6568,'ur','Ø§Ø³ ØµÙˆØ±Øª Ù…ÛŒÚº ÙˆØ§Ù¾Ø³ Ù„ÙˆÙ¹Û’ ØªÙˆ ÙÛŒØ³ ÙÛŒ ØµØ¯ Ø±ÛŒØ³Ù¹ÙˆÚ©',0),(236420,6568,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ñƒ Ð·Ð° ÐºÐ°Ð´Ð° ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾ Ñƒ Ð¾Ð²Ð°ÐºÐ²Ð¾Ð¼ ÑÑ‚Ð°ÑšÑƒ Ð¾Ð±Ð½Ð°Ð²Ñ™Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾ÑÑ‚Ð¾',0),(236421,6568,'vi','% phÃ­ nháº­p kho láº¡i khi trá»Ÿ láº¡i lá»±a chá»n nÃ y',0),(236422,6568,'af','Persent Restock fooi wanneer teruggekeer in hierdie toestand',0),(236423,6568,'ro','La sutÄƒ repopula taxa de cÃ¢nd a revenit Ã®n aceastÄƒ stare',0),(236424,6568,'et','% TÃ¤iendab tasu, kui selles seisundis tagasi',0),(236425,6568,'si','Odstotkov obnovo pristojbino, ko se vrne v ta pogoj',0),(236426,6568,'ba','Persen biaya ketika kembali dalam kondisi ini memperlengkapi',0),(236427,6568,'nl','Procent Voorraadbericht vergoeding toen terugkwam in deze toestand',0),(236428,6568,'fi','Prosenttia tÃ¤ydentÃ¤minen maksu palattuaan tÃ¤mÃ¤ ehto',0),(236429,6568,'no','Prosent Restock gebyr nÃ¥r i denne tilstanden',0),(236430,6568,'da','Procent genpÃ¥fyldning gebyr nÃ¥r returneret i denne betingelse',0),(236431,6568,'ko','% ìƒˆë¡œ ì‚¬ë“¤ì´ ë‹¤ ìš”ê¸ˆì´ì´ ìƒíƒœì—ì„œ ë°˜í™˜ í•˜ëŠ” ê²½ìš°',0),(236432,6568,'he','××—×•×– ×œ×ž×œ× ×“×ž×™ ×—×–×¨ ×‘×ž×¦×‘ ×”×–×”',0),(236433,6568,'el','Î¤Î­Î»Î¿Ï‚, ÏŒÏ„Î±Î½ ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ ÏƒÎµ Î±Ï…Ï„Î® Ï„Î·Î½ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· \"Î±Î½Î±Î½Î­Ï‰ÏƒÎ· Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ\"',0),(236434,6568,'zh','åœ¨è¿™ç§æƒ…å†µä¸‹è¿”å›žæ—¶çš„é‡æ–°è¿›è´§è´¹ç”¨ç™¾åˆ†æ¯”\r\n',0),(236435,6568,'sv','Procent fÃ¶rnya avgift nÃ¤r Ã¥tervÃ¤nde i detta tillstÃ¥nd',0),(236436,6568,'it','Per cento rifornire tassa quando tornÃ² in questa condizione',0),(236437,6568,'tl','',0),(236438,6568,'th','Percent Restock Fee When Returned in This Condition',0),(236439,6568,'hi','à¤œà¤¬ à¤‡à¤¸ à¤¹à¤¾à¤²à¤¤ à¤®à¥‡à¤‚ à¤²à¥Œà¤Ÿ à¤—à¤¯à¤¾ à¤¶à¥à¤²à¥à¤• à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤«à¤¿à¤° à¤¸à¥‡ à¤‡à¤•à¤Ÿà¥à¤ à¤¾ à¤•à¤°à¤¨à¤¾',0),(236440,6568,'ms','Peratus Restock bayaran apabila kembali dalam keadaan ini',0),(236441,6568,'ar','Ø±Ø³Ù… Ø¥Ø¹Ø§Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ† (Ù†Ø³Ø¨Ø© Ù…Ø¦ÙˆÙŠØ©) - Ø¹Ù†Ø¯ Ø¥Ø±Ø¬Ø§Ø¹ Ø§Ù„Ù…Ø±Ø¯ÙˆØ¯Ø§Øª ÙÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ø­Ø§Ù„Ø©',0),(236442,6568,'fr','Pour cent repeupler les frais de retour dans cette Condition',0),(236443,6568,'jp','ï¼… è£œå……æ–™ã“ã®æ¡ä»¶ã§è¿”ã•ã‚Œã‚‹ã¨ã',0),(236444,6568,'pt','Por cento reabastecer taxa quando retornou nesta condiÃ§Ã£o',0),(236445,6568,'ru','% ÐŸÐ¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚Ð° ÐºÐ¾Ð³Ð´Ð° Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ Ð² ÑÑ‚Ð¾Ð¼ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ð¸',0),(236446,6568,'es','Porciento de Cargo para Restock Cuand Devuelto en Esta CondiciÃ³n',0),(236447,6568,'de','Prozent AuffÃ¼llen GebÃ¼hr wenn in diesem Zustand zurÃ¼ckgegeben',0),(236448,6568,'en','Percent Restock Fee When Returned in This Condition',0),(236449,6569,'is','',0),(236450,6569,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø³Ø§Ø±Øª Ø¯ÙŠØ¯Ù‡ Ù‡Ø§ ÙˆÙ‚ØªÙŠ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±Ø§ÙŠØ· ',0),(236451,6569,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø®Ø³Ø§Ø±Øª Ø¯ÙŠØ¯Ù‡ Ù‡Ø§ ÙˆÙ‚ØªÙŠ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±Ø§ÙŠØ· ',0),(236452,6569,'tr','Ne zaman bu durumda iade sonrasÄ± hasar iÃ§in',0),(236453,6569,'pl','Do postu uszkodzone, gdy wrÃ³ciÅ‚ w tym stanie',0),(236454,6569,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð² Ð¿Ð¾Ð²Ñ€ÐµÐ´ÐµÐ½Ð¸, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ ÑÐµ Ð²ÑŠÑ€Ð½Ð° Ð² Ñ‚Ð¾Ð²Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(236455,6569,'ur','Ù¾ÙˆØ³Ù¹ Ú©Ùˆ Ø¶Ø±Ø± Ú©Ùˆ Ø§Ø³ Ø­Ø§Ù„Øª Ù…ÛŒÚº ÙˆØ§Ù¾Ø³ Ù„ÙˆÙ¹Û’ ØªÙˆ',0),(236456,6569,'sr','ÐžÐ±Ñ˜Ð°Ð²Ð¸ Ð½Ð° Ð¾ÑˆÑ‚ÐµÑ›ÐµÐ½ ÐºÐ°Ð´ ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾ Ñƒ Ð¾Ð²Ð°ÐºÐ²Ð¾Ð¼ ÑÑ‚Ð°ÑšÑƒ',0),(236457,6569,'vi','Nguy hiá»ƒm khi quay láº¡i Ä‘iá»u kiá»‡n nÃ y',0),(236458,6569,'af','Pos na Beskadigde Wanneer Terugontvang in Hierdie Toestand',0),(236459,6569,'ro','Post a deteriorat atunci cÃ¢nd s-a Ã®ntors Ã®n aceastÄƒ stare',0),(236460,6569,'et','Post-kahjustatud kui tagasi see tingimus',0),(236461,6569,'si','Post za poÅ¡kodovano, ko se vrne v ta pogoj',0),(236462,6569,'ba','Kirim ke rusak ketika kembali dalam kondisi ini',0),(236463,6569,'nl','Post te beschadigd toen terugkwam in deze toestand',0),(236464,6569,'fi','Viesti kuin tÃ¤mÃ¤ ehto Palattuaan',0),(236465,6569,'no','Innlegg til skadet da i denne tilstanden',0),(236466,6569,'da','IndlÃ¦g til beskadiget da vendte tilbage i denne betingelse',0),(236467,6569,'ko','ì´ ìƒíƒœì—ì„œ ë°˜í™˜ ë  ë•Œ ì†ìƒì— ê²Œì‹œë¬¼',0),(236468,6569,'he','×¤×•×¡×˜ ×¢×œ × ×™×–×•×§×™× ×›××©×¨ ×—×–×¨ ×‘×ž×¦×‘ ×”×–×”',0),(236469,6569,'el','ÎœÎµÏ„Î¬ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎºÎ±Ï„Î±ÏƒÏ„ÏÎ±Ï†ÎµÎ¯ ÏŒÏ„Î±Î½ ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ ÏƒÎµ Î±Ï…Ï„Î® Ï„Î·Î½ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(236470,6569,'zh','åœ¨è¿™ç§æƒ…å†µä¸‹è¿”å›žæ—¶å‘å¸ƒåˆ°æŸå\r\n',0),(236471,6569,'sv','InlÃ¤gget att skadad nÃ¤r Ã¥tervÃ¤nde i detta tillstÃ¥nd',0),(236472,6569,'it','Registra per danneggiato quando tornÃ² in questa condizione',0),(236473,6569,'tl','',0),(236474,6569,'th','&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3606;&#3641;&#3585;&#3607;&#3635;&#3651;&#3627;&#3657;&#3648;&#3626;&#3637;&#3618;&#3627;&#3634;&#3618;&#3648;&#3617;&#3639;&#3656;&#3629;&#3585;&#3621;&#3633;&#3',0),(236475,6569,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¥à¤·à¤¤à¤¿à¤—à¥à¤°à¤¸à¥à¤¤ à¤¹à¥‹ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¬ à¤‡à¤¸ à¤¹à¤¾à¤²à¤¤ à¤®à¥‡à¤‚ à¤²à¥Œà¤Ÿ à¤†à¤',0),(236476,6569,'ms','Pos ke rosak apabila kembali dalam keadaan ini',0),(236477,6569,'ar','Ø§Ù„ØªØ±Ø­ÙŠÙ„ Ø¥Ù„Ù‰ Ø­Ø³Ø§Ø¨ Ø§Ù„ØªØ§Ù„Ù - Ø¹Ù†Ø¯ Ø¥Ø±Ø¬Ø§Ø¹ Ø§Ù„Ù…Ø±Ø¯ÙˆØ¯Ø§Øª ÙÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ø­Ø§Ù„Ø©',0),(236478,6569,'fr','Post Ã  endommagÃ© quand revint dans cette Condition',0),(236479,6569,'jp','ã“ã®æ¡ä»¶ã§è¿”ã•ã‚Œã‚‹ã¨ãã«ç ´æã—ã¦ã„ã‚‹ãƒã‚¹ãƒˆ',0),(236480,6569,'pt','Post a danificada quando retornou nesta condiÃ§Ã£o',0),(236481,6569,'ru','ÐŸÐ¾ÑÑ‚ Ð´Ð»Ñ Ð¿Ð¾Ð²Ñ€ÐµÐ¶Ð´ÐµÐ½, ÐºÐ¾Ð³Ð´Ð° Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ Ð² ÑÑ‚Ð¾Ð¼ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ð¸',0),(236482,6569,'es','Asentar a DaÃ±ado Cuando se Devuelva en esta condiciÃ³n',0),(236483,6569,'de','Beitrag zu beschÃ¤digt, wenn in diesem Zustand zurÃ¼ckgegeben',0),(236484,6569,'en','Post to Damaged When Returned in This Condition',0),(236485,6570,'is','',0),(236486,6570,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ ÙƒØ¯Ø§Ù… Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(236487,6570,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ ÙƒØ¯Ø§Ù… Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(236488,6570,'tr','Ne GL hesabÄ±na mesaj',0),(236489,6570,'pl','Po co konto GL',0),(236490,6570,'bg','ÐŸÐ¾ÑÑ‚ ÐºÐ°ÐºÐ²Ð¾ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(236491,6570,'ur','Ú©ÛŒØ§ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ùˆ Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº',0),(236492,6570,'sr','ÐŸÐ¾ÑÑ‚ Ð½Ð° ÐºÐ¾Ñ˜Ð¸ ÐºÐ¾Ð½Ñ‚Ð¾ Ð“Ð›',0),(236493,6570,'vi','Káº¿t Chuyá»ƒn VÃ o TK Sá»• CÃ¡i Tá»•ng Há»£p NÃ o',0),(236494,6570,'af','Pos Na Watter AG Rekening',0),(236495,6570,'ro','Post ce contul GL',0),(236496,6570,'et','Postitus mida GL kontole',0),(236497,6570,'si','Post kaj GL raÄun',0),(236498,6570,'ba','Posting ke Account GL apa',0),(236499,6570,'nl','Post naar wat GL-Account',0),(236500,6570,'fi','Post mitÃ¤ GL tili',0),(236501,6570,'no','Innlegg hva GL-kontoen',0),(236502,6570,'da','Post til hvad GL konto',0),(236503,6570,'ko','ì–´ë–¤ GL ê³„ì • ê²Œì‹œë¬¼',0),(236504,6570,'he','×¤×•×¡×˜ ×¢×œ ××™×–×” ×—×©×‘×•×Ÿ GL',0),(236505,6570,'el','Î˜Î­ÏƒÎ· Î½Î± Ï„Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(236506,6570,'zh','å‘å¸ƒåˆ°ä»€ä¹ˆæ€»å¸å¸æˆ·\r\n',0),(236507,6570,'sv','Post till vad GL-konto',0),(236508,6570,'it','Post a quale Account GL',0),(236509,6570,'tl','',0),(236510,6570,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3634;&#3591;&#3626;&#3636;&#3656;&#3591;',0),(236511,6570,'hi','à¤•à¥à¤¯à¤¾ à¤–à¤¾à¤¤à¥‡ à¤®à¥‡à¤‚ GL à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(236512,6570,'ms','Pos ke akaun GL apa',0),(236513,6570,'ar','ÙˆØ¸ÙŠÙØ© Ù„Ù…Ø§ Ù‡Ùˆ Ø­Ø³Ø§Ø¨ GL',0),(236514,6570,'fr','Post Ã  quel compte GL',0),(236515,6570,'jp','ã©ã®ã‚ˆã†ãª GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ãƒã‚¹ãƒˆ',0),(236516,6570,'pt','Post para qual conta GL',0),(236517,6570,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾ÑÑ‚ÑŒ, Ð½Ð° ÐºÐ°ÐºÐ¾Ð¹ ÑÑ‡ÐµÑ‚ GL',0),(236518,6570,'es','Asentar A Cual Cuenta de LM',0),(236519,6570,'de','Post was GL-Konto',0),(236520,6570,'en','Post To What GL Account',0),(236521,6571,'is','',0),(236522,6571,'dr','Ø§Ù‚Ø¯Ø§Ù…Ø§Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(236523,6571,'pr','Ø§Ù‚Ø¯Ø§Ù…Ø§Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(236524,6571,'tr','RMA eylemleri',0),(236525,6571,'pl','RMA dziaÅ‚ania',0),(236526,6571,'bg','Ð Ð¡Ðž Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(236527,6571,'ur','Ø±Ù… Ú©Û’ Ø§Ø¹Ù…Ø§Ù„',0),(236528,6571,'sr','ÐžÐ¿Ñ Ñ€Ð°Ð´ÑšÐµ',0),(236529,6571,'vi','Hoáº¡t Ä‘á»™ng RMA',0),(236530,6571,'af','RMA aksies',0),(236531,6571,'ro','RMA acÅ£iuni',0),(236532,6571,'et','RMA toimingud',0),(236533,6571,'si','RMA dejanja',0),(236534,6571,'ba','Tindakan RMA',0),(236535,6571,'nl','RMA acties',0),(236536,6571,'fi','RMA toiminnot',0),(236537,6571,'no','RMA handlinger',0),(236538,6571,'da','RMA handlinger',0),(236539,6571,'ko','RMA ìž‘ì—…',0),(236540,6571,'he','×¤×¢×•×œ×•×ª RMA',0),(236541,6571,'el','RMA Î´ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(236542,6571,'zh','è¿”å›žå•†å“æŽˆæƒçš„è¡ŒåŠ¨\r\n',0),(236543,6571,'sv','RMA Ã¥tgÃ¤rder',0),(236544,6571,'it','Azioni di RMA',0),(236545,6571,'tl','',0),(236546,6571,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619; RMA',0),(236547,6571,'hi','RMA à¤•à¥à¤°à¤¿à¤¯à¤¾à¤à¤',0),(236548,6571,'ms','RMA tindakan',0),(236549,6571,'ar','Ø¹Ù…Ù„ÙŠØ§Øª Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(236550,6571,'fr','Actions de RMA',0),(236551,6571,'jp','RMA ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(236552,6571,'pt','AÃ§Ãµes de RMA',0),(236553,6571,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ RMA',0),(236554,6571,'es','RMA Acciones',0),(236555,6571,'de','RMA-Aktionen',0),(236556,6571,'en','RMA Actions',0),(236557,6572,'is','',0),(236558,6572,'dr','Ù†Ø§Ù… ÙØ¹Ø§Ù„ÙŠØª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(236559,6572,'pr','Ù†Ø§Ù… ÙØ¹Ø§Ù„ÙŠØª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(236560,6572,'tr','RMA eylem adÄ±',0),(236561,6572,'pl','Nazwa akcji RMA',0),(236562,6572,'bg','Ð˜Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð Ð¡Ðž',0),(236563,6572,'ur','Ù†Ø§Ù… Ø¹Ù…Ù„ Ø±Ù…',0),(236564,6572,'sr','Ð˜Ð¼Ðµ ÐžÐŸÐ¡ Ñ€Ð°Ð´ÑšÐµ',0),(236565,6572,'vi','TÃªn Hoáº¡t Ä‘á»™ng RMA',0),(236566,6572,'af','\"RMA\" Aksienaam',0),(236567,6572,'ro','Numele de acÅ£iune RMA',0),(236568,6572,'et','RMA toimingu nimi',0),(236569,6572,'si','Ime dejanja RMA',0),(236570,6572,'ba','Nama Action RMA',0),(236571,6572,'nl','RMA actienaam',0),(236572,6572,'fi','RMA toiminnon nimi',0),(236573,6572,'no','RMA Handlingsnavn',0),(236574,6572,'da','RMA handlingsnavn',0),(236575,6572,'ko','RMA ë™ìž‘ ì´ë¦„',0),(236576,6572,'he','×©× ×”×¤×¢×•×œ×” RMA',0),(236577,6572,'el','ÎŒÎ½Î¿Î¼Î± ÎµÎ½Î­ÏÎ³ÎµÎ¹Î±Ï‚ RMA',0),(236578,6572,'zh','è¿”å›žå•†å“æŽˆæƒåŠ¨ä½œåç§°\r\n',0),(236579,6572,'sv','RMA Ã¥tgÃ¤rdens namn',0),(236580,6572,'it','Nome azione RMA',0),(236581,6572,'tl','',0),(236582,6572,'th','&#3594;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619; RMA',0),(236583,6572,'hi','RMA à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤•à¤¾ à¤¨à¤¾à¤®',0),(236584,6572,'ms','RMA tindakan nama',0),(236585,6572,'ar','Ø¥Ø³Ù… Ø¹Ù…Ù„ÙŠØ© Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(236586,6572,'fr','Nom de l\'Action RMA',0),(236587,6572,'jp','RMA ã‚¢ã‚¯ã‚·ãƒ§ãƒ³å',0),(236588,6572,'pt','Nome da aÃ§Ã£o de RMA',0),(236589,6572,'ru','Ð˜Ð¼Ñ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ RMA',0),(236590,6572,'es','RMA Nombre de AcciÃ³n',0),(236591,6572,'de','Name der RMA-Aktion',0),(236592,6572,'en','RMA Action Name',0),(236593,6573,'is','',0),(236594,6573,'dr','Ø´Ø±Ø§ÙŠØ· Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(236595,6573,'pr','Ø´Ø±Ø§ÙŠØ· Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(236596,6573,'tr','RMA koÅŸullarÄ±',0),(236597,6573,'pl','Warunki RMA',0),(236598,6573,'bg','Ð Ð¡Ðž ÑƒÑÐ»Ð¾Ð²Ð¸Ñ',0),(236599,6573,'ur','Ø±Ù… Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø·',0),(236600,6573,'sr','ÐžÐ¿Ñ ÑƒÑÐ»Ð¾Ð²Ð¸',0),(236601,6573,'vi','Äiá»u kiá»‡n RMA',0),(236602,6573,'af','RMA voorwaardes',0),(236603,6573,'ro','RMA condiÅ£iile',0),(236604,6573,'et','RMA tingimused',0),(236605,6573,'si','RMA pogoji',0),(236606,6573,'ba','Kondisi RMA',0),(236607,6573,'nl','Voorwaarden van de RMA',0),(236608,6573,'fi','RMA edellytykset',0),(236609,6573,'no','RMA forhold',0),(236610,6573,'da','RMA betingelser',0),(236611,6573,'ko','ë°˜í’ˆ ì¡°ê±´',0),(236612,6573,'he','×ª× ××™× RMA',0),(236613,6573,'el','RMA ÏƒÏ…Î½Î¸Î®ÎºÎµÏ‚',0),(236614,6573,'zh','è¿”å›žå•†å“æŽˆæƒæ¡ä»¶\r\n',0),(236615,6573,'sv','RMA villkor',0),(236616,6573,'it','Condizioni RMA',0),(236617,6573,'tl','',0),(236618,6573,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586; RMA',0),(236619,6573,'hi','RMA à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(236620,6573,'ms','Syarat-syarat RMA',0),(236621,6573,'ar','Ø­Ø§Ù„Ø§Øª Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(236622,6573,'fr','Conditions RMA',0),(236623,6573,'jp','RMA çŠ¶æ³',0),(236624,6573,'pt','CondiÃ§Ãµes RMA',0),(236625,6573,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ RMA',0),(236626,6573,'es','RMA Condiciones',0),(236627,6573,'de','RMA Bedingungen',0),(236628,6573,'en','RMA Conditions',0),(236629,6574,'is','',0),(236630,6574,'dr','Ù†Ø§Ù… Ø´Ø±Ø§ÙŠØ· Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(236631,6574,'pr','Ù†Ø§Ù… Ø´Ø±Ø§ÙŠØ· Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(236632,6574,'tr','RMA durumu adÄ±',0),(236633,6574,'pl','Nazwa stanu RMA',0),(236634,6574,'bg','Ð Ð¡Ðž ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð¸Ð¼Ðµ',0),(236635,6574,'ur','Ø±Ù… Ø´Ø±Ø· Ù†Ø§Ù…',0),(236636,6574,'sr','Ð˜Ð¼Ðµ ÐžÐŸÐ¡ ÑÑ‚Ð°ÑšÐµ',0),(236637,6574,'vi','TÃªn Äiá»u kiá»‡n RMA',0),(236638,6574,'af','RMA toestand naam',0),(236639,6574,'ro','Numele de afecÅ£iune RMA',0),(236640,6574,'et','Tagastatud kauba seisundi nimi',0),(236641,6574,'si','RMA pogoj ime',0),(236642,6574,'ba','RMA kondisi nama',0),(236643,6574,'nl','De naam van de voorwaarde van de RMA',0),(236644,6574,'fi','RMA ehdon nimi',0),(236645,6574,'no','RMA betingelsesnavn',0),(236646,6574,'da','RMA betingelsesnavn',0),(236647,6574,'ko','RMA ìƒíƒœ ì´ë¦„',0),(236648,6574,'he','×©× ×”×ª× ××™ RMA',0),(236649,6574,'el','RMA ÏŒÏÎ¿Ï‚ ÏŒÎ½Î¿Î¼Î±',0),(236650,6574,'zh','è¿”å›žå•†å“æŽˆæƒæ¡ä»¶åç§°\r\n',0),(236651,6574,'sv','RMA villkorsnamn',0),(236652,6574,'it','Nome condizione RMA',0),(236653,6574,'tl','',0),(236654,6574,'th','&#3594;&#3639;&#3656;&#3629;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586; RMA',0),(236655,6574,'hi','RMA à¤¹à¤¾à¤²à¤¤ à¤¨à¤¾à¤®',0),(236656,6574,'ms','RMA keadaan nama',0),(236657,6574,'ar','Ø¥Ø³Ù… Ø­Ø§Ù„Ø© Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(236658,6574,'fr','Nom de Condition RMA',0),(236659,6574,'jp','RMA æ¡ä»¶å',0),(236660,6574,'pt','Nome da condiÃ§Ã£o de RMA',0),(236661,6574,'ru','Ð˜Ð¼Ñ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ RMA',0),(236662,6574,'es','RMA Nombre de CondiciÃ³n',0),(236663,6574,'de','RMA-Bedingungsname',0),(236664,6574,'en','RMA Condition Name',0),(236665,6575,'is','',0),(236666,6575,'dr','Ø´Ø±Ø­ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ  Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ  ',0),(236667,6575,'pr','Ø´Ø±Ø­ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ  Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ  ',0),(236668,6575,'tr','RMA kredi aÃ§Ä±klamasÄ±',0),(236669,6575,'pl','RMA kredytowe opis',0),(236670,6575,'bg','Ð Ð¡Ðž ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(236671,6575,'ur','Ø±Ù… Ú©Ø±ÛŒÚˆÙ¹ ØªØµØ±ÛŒØ­',0),(236672,6575,'sr','ÐžÐ¿Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ Ð¾Ð¿Ð¸Ñ',0),(236673,6575,'vi','MÃ´ Táº£ TÃ­n Dá»¥ng RMA',0),(236674,6575,'af','RMA krediet Beskrywing',0),(236675,6575,'ro','Descriere de Credit RMA',0),(236676,6575,'et','RMA krediidi kirjeldus',0),(236677,6575,'si','RMA kreditne opis',0),(236678,6575,'ba','Deskripsi Credit RMA',0),(236679,6575,'nl','RMA Credit beschrijving',0),(236680,6575,'fi','RMA luotto kuvaus',0),(236681,6575,'no','RMA kreditt beskrivelse',0),(236682,6575,'da','RMA kredit beskrivelse',0),(236683,6575,'ko','RMA ì‹ ìš© ì„¤ëª…',0),(236684,6575,'he','×ª×™××•×¨ ××©×¨××™ RMA',0),(236685,6575,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚ RMA',0),(236686,6575,'zh','è¿”å›žå•†å“æŽˆæƒä¿¡ç”¨è¯´æ˜Ž\r\n',0),(236687,6575,'sv','RMA kredit Beskrivning',0),(236688,6575,'it','RMA credito Descrizione',0),(236689,6575,'tl','',0),(236690,6575,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605; RMA',0),(236691,6575,'hi','RMA à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤µà¤¿à¤µà¤°à¤£',0),(236692,6575,'ms','RMA kredit keterangan',0),(236693,6575,'ar','ÙˆØµÙ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ø¬ÙŠØ´ Ø§Ù„Ù…Ù„ÙƒÙŠ Ø§Ù„Ù…ØºØ±Ø¨ÙŠ',0),(236694,6575,'fr','Description de crÃ©dit RMA',0),(236695,6575,'jp','RMA ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã®èª¬æ˜Ž',0),(236696,6575,'pt','DescriÃ§Ã£o de crÃ©dito RMA',0),(236697,6575,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ RMA',0),(236698,6575,'es','RMA DescripciÃ³n de CrÃ©dito',0),(236699,6575,'de','RMA-Credit-Beschreibung',0),(236700,6575,'en','RMA Credit Description',0),(236701,6576,'is','',0),(236702,6576,'dr','Ø´Ø±Ø­ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(236703,6576,'pr','Ø´Ø±Ø­ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(236704,6576,'tr','RMA kredi aÃ§Ä±klamasÄ±',0),(236705,6576,'pl','RMA kredytowe opis',0),(236706,6576,'bg','Ð Ð¡Ðž ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(236707,6576,'ur','Ø±Ù… Ú©Ø±ÛŒÚˆÙ¹ ØªØµØ±ÛŒØ­',0),(236708,6576,'sr','ÐžÐ¿Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ Ð¾Ð¿Ð¸Ñ',0),(236709,6576,'vi','MÃ´ Táº£ TÃ­n Dá»¥ng RMA',0),(236710,6576,'af','RMA krediet Beskrywing',0),(236711,6576,'ro','Descriere de Credit RMA',0),(236712,6576,'et','RMA krediidi kirjeldus',0),(236713,6576,'si','RMA kreditne opis',0),(236714,6576,'ba','Deskripsi Credit RMA',0),(236715,6576,'nl','RMA Credit beschrijving',0),(236716,6576,'fi','RMA luotto kuvaus',0),(236717,6576,'no','RMA kreditt beskrivelse',0),(236718,6576,'da','RMA kredit beskrivelse',0),(236719,6576,'ko','RMA ì‹ ìš© ì„¤ëª…',0),(236720,6576,'he','×ª×™××•×¨ ××©×¨××™ RMA',0),(236721,6576,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚ RMA',0),(236722,6576,'zh','è¿”å›žå•†å“æŽˆæƒä¿¡ç”¨è¯´æ˜Ž\r\n',0),(236723,6576,'sv','RMA kredit Beskrivning',0),(236724,6576,'it','RMA credito Descrizione',0),(236725,6576,'tl','',0),(236726,6576,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605; RMA',0),(236727,6576,'hi','RMA à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤µà¤¿à¤µà¤°à¤£',0),(236728,6576,'ms','RMA kredit keterangan',0),(236729,6576,'ar','ÙˆØµÙ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ø¬ÙŠØ´ Ø§Ù„Ù…Ù„ÙƒÙŠ Ø§Ù„Ù…ØºØ±Ø¨ÙŠ',0),(236730,6576,'fr','Description de crÃ©dit RMA',0),(236731,6576,'jp','RMA ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã®èª¬æ˜Ž',0),(236732,6576,'pt','DescriÃ§Ã£o de crÃ©dito RMA',0),(236733,6576,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ RMA',0),(236734,6576,'es','RMA DescripciÃ³n de CrÃ©dito',0),(236735,6576,'de','RMA-Credit-Beschreibung',0),(236736,6576,'en','RMA Credit Description',0),(236737,6577,'is','',0),(236738,6577,'dr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ù…Ø®ØªÙ„Ù Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡\r\n',0),(236739,6577,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ù…Ø®ØªÙ„Ù Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡\r\n',0),(236740,6577,'tr','RMA Ã§eÅŸitli krediler',0),(236741,6577,'pl','RMA rÃ³Å¼ne kredyty',0),(236742,6577,'bg','Ð Ð¡Ðž Ð Ð°Ð·Ð½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸',0),(236743,6577,'ur','Ø±Ù… Ù…ØªÙØ±Ù‚ Ú©Ø±ÛŒÚˆÙ¹',0),(236744,6577,'sr','ÐžÐ¿Ñ ÐœÐ¸ÑÑ† ÑˆÐ¿Ð¸Ñ†Ð°',0),(236745,6577,'vi','TÃ­n Dá»¥ng RMA Phá»¥',0),(236746,6577,'af','RMA Misc krediete',0),(236747,6577,'ro','RMA diverse credite',0),(236748,6577,'et','RMA Varia krediiti',0),(236749,6577,'si','RMA Misc krediti',0),(236750,6577,'ba','RMA Misc kredit',0),(236751,6577,'nl','RMA Misc Credits',0),(236752,6577,'fi','RMA Muut luotot',0),(236753,6577,'no','RMA diverse studiepoeng',0),(236754,6577,'da','RMA Misc Credits',0),(236755,6577,'ko','RMA ê¸°íƒ€ í•™ì ',0),(236756,6577,'he','RMA Misc ×§×¨×“×™×˜×™×',0),(236757,6577,'el','RMA Misc Ï€Î¹ÏƒÏ„ÏŽÏƒÎµÎ¹Ï‚',0),(236758,6577,'zh','å•†å“é€€è´§æŽˆæƒæ‚é¡¹ä¿¡ç”¨\r\n',0),(236759,6577,'sv','RMA Misc krediter',0),(236760,6577,'it','RMA Misc crediti',0),(236761,6577,'tl','',0),(236762,6577,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604; RMA ',0),(236763,6577,'hi','RMA à¤µà¤¿à¤µà¤¿à¤§ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿà¥à¤¸',0),(236764,6577,'ms','RMA Misc kredit',0),(236765,6577,'ar','Ø§Ù„Ø¬ÙŠØ´ Ø§Ù„Ù…Ù„ÙƒÙŠ Ø§Ù„Ù…ØºØ±Ø¨ÙŠ Ù…ØªÙØ±Ù‚Ø§Øª Ø§Ø¦ØªÙ…Ø§Ù†Ø§Øª',0),(236766,6577,'fr','RMA Misc crÃ©dits',0),(236767,6577,'jp','RMA ãã®ä»–ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ',0),(236768,6577,'pt','RMA Misc crÃ©ditos',0),(236769,6577,'ru','RMA Ð Ð°Ð·Ð½Ð¾Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ñ‹',0),(236770,6577,'es','RMA CrÃ©ditos MiscelÃ¡nea',0),(236771,6577,'de','RMA-Misc-Credits',0),(236772,6577,'en','RMA Misc Credits',0),(236773,6578,'is','',0),(236774,6578,'dr','Ø¯Ù„Ø§ÙŠÙ„ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(236775,6578,'pr','Ø¯Ù„Ø§ÙŠÙ„ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(236776,6578,'tr','RMA nedenleri',0),(236777,6578,'pl','PowodÃ³w RMA',0),(236778,6578,'bg','Ð Ð¡Ðž Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð¸',0),(236779,6578,'ur','Ø±Ù… Ú©ÛŒ ÙˆØ¬ÙˆÛØ§Øª',0),(236780,6578,'sr','ÐžÐ¿Ñ Ñ€Ð°Ð·Ð»Ð¾Ð³Ðµ',0),(236781,6578,'vi','NguyÃªn nhÃ¢n RMA',0),(236782,6578,'af','RMA redes',0),(236783,6578,'ro','RMA motive',0),(236784,6578,'et','Tagastuse pÃµhjused',0),(236785,6578,'si','RMA razlogov',0),(236786,6578,'ba','Alasan RMA',0),(236787,6578,'nl','RMA redenen',0),(236788,6578,'fi','RMA syistÃ¤',0),(236789,6578,'no','RMA grunner',0),(236790,6578,'da','RMA grunde',0),(236791,6578,'ko','RMA ì´ìœ ',0),(236792,6578,'he','×¡×™×‘×•×ª RMA',0),(236793,6578,'el','RMA Î»ÏŒÎ³Î¿Ï…Ï‚',0),(236794,6578,'zh','è¿”å›žå•†å“æŽˆæƒçš„åŽŸå› \r\n',0),(236795,6578,'sv','RMA skÃ¤l',0),(236796,6578,'it','Motivi RMA',0),(236797,6578,'tl','',0),(236798,6578,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621; RMA ',0),(236799,6578,'hi','RMA à¤•à¤¾à¤°à¤£à¥‹à¤‚',0),(236800,6578,'ms','Sebab-sebab RMA',0),(236801,6578,'ar','Ø£Ø³Ø¨Ø§Ø¨ Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(236802,6578,'fr','Raisons RMA',0),(236803,6578,'jp','RMA ã®ç†ç”±',0),(236804,6578,'pt','RazÃµes RMA',0),(236805,6578,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ñ‹ RMA',0),(236806,6578,'es','RMA RazÃ³nes',0),(236807,6578,'de','RMA-GrÃ¼nde',0),(236808,6578,'en','RMA Reasons',0),(236809,6579,'is','',0),(236810,6579,'dr','Ù†Ø§Ù… Ø¯Ù„ÙŠÙ„ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(236811,6579,'pr','Ù†Ø§Ù… Ø¯Ù„ÙŠÙ„ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(236812,6579,'tr','RMA nedeni adÄ±',0),(236813,6579,'pl','RMA powodu nazwa',0),(236814,6579,'bg','Ð Ð¡Ðž Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð° Ð¸Ð¼Ðµ',0),(236815,6579,'ur','Ø±Ù… Ú©ÛŒ ÙˆØ¬Û Ù†Ø§Ù…',0),(236816,6579,'sr','Ð˜Ð¼Ðµ ÐžÐŸÐ¡ Ñ€Ð°Ð·Ð»Ð¾Ð³',0),(236817,6579,'vi','TÃªn NguyÃªn nhÃ¢n RMA',0),(236818,6579,'af','RMA rede naam',0),(236819,6579,'ro','Numele de motiv RMA',0),(236820,6579,'et','Tagastuse pÃµhjus nimi',0),(236821,6579,'si','Ime razloga RMA',0),(236822,6579,'ba','Nama alasan RMA',0),(236823,6579,'nl','RMA reden naam',0),(236824,6579,'fi','RMA syy nimi',0),(236825,6579,'no','RMA Ã¥rsak navnet',0),(236826,6579,'da','RMA Ã¥rsag navn',0),(236827,6579,'ko','RMA ì´ìœ  ì´ë¦„',0),(236828,6579,'he','×©× ×¡×™×‘×” RMA',0),(236829,6579,'el','RMA Î»ÏŒÎ³Î¿ ÏŒÎ½Î¿Î¼Î±',0),(236830,6579,'zh','è¿”å›žå•†å“æŽˆæƒåŽŸå› åç§°\r\n',0),(236831,6579,'sv','RMA anledning namn',0),(236832,6579,'it','Nome motivo RMA',0),(236833,6579,'tl','',0),(236834,6579,'th','&#3594;&#3639;&#3656;&#3629;&#3648;&#3627;&#3605;&#3640;&#3612;&#3621; RMA ',0),(236835,6579,'hi','RMA à¤•à¤¾à¤°à¤£ à¤•à¥‡ à¤¨à¤¾à¤®',0),(236836,6579,'ms','RMA sebab nama',0),(236837,6579,'ar','Ø¥Ø³Ù… Ø³Ø¨Ø¨ Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(236838,6579,'fr','RMA raison nom',0),(236839,6579,'jp','RMA ç†ç”±å',0),(236840,6579,'pt','Nome de razÃ£o RMA',0),(236841,6579,'ru','Ð˜Ð¼Ñ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ñ‹ RMA',0),(236842,6579,'es','RMA Nombre de RazÃ³n',0),(236843,6579,'de','RMA Grund Name',0),(236844,6579,'en','RMA Reason Name',0),(236845,6580,'is','',0),(236846,6580,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(236847,6580,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(236848,6580,'tr','RMA kurulumlarÄ±',0),(236849,6580,'pl','Konfiguracje RMA',0),(236850,6580,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð½Ð° Ð Ð¡Ðž',0),(236851,6580,'ur','Ø±Ù… Ø³ÛŒÙ¹Ùˆ',0),(236852,6580,'sr','ÐžÐ¿Ñ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐ°',0),(236853,6580,'vi','Setup RMA',0),(236854,6580,'af','RMA Setups',0),(236855,6580,'ro','RMA setari',0),(236856,6580,'et','RMA seadistused',0),(236857,6580,'si','RMA postavitve',0),(236858,6580,'ba','Setup RMA',0),(236859,6580,'nl','RMA Setups',0),(236860,6580,'fi','RMA asetelmia',0),(236861,6580,'no','RMA oppsett',0),(236862,6580,'da','RMA opsÃ¦tninger',0),(236863,6580,'ko','RMA ì„¤ì •',0),(236864,6580,'he','×›×™×•×•× ×•× ×™ RMA',0),(236865,6580,'el','RMA ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚',0),(236866,6580,'zh','è¿”å›žå•†å“æŽˆæƒè®¾ç½®\r\n',0),(236867,6580,'sv','RMA uppstÃ¤llningar',0),(236868,6580,'it','Configurazioni RMA',0),(236869,6580,'tl','',0),(236870,6580,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634; RMA ',0),(236871,6580,'hi','RMA Setups',0),(236872,6580,'ms','RMA Setups',0),(236873,6580,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(236874,6580,'fr','Configurations RMA',0),(236875,6580,'jp','RMA ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(236876,6580,'pt','RMA Setups',0),(236877,6580,'ru','RMA ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¾Ðº',0),(236878,6580,'es','RMA Configuraciones',0),(236879,6580,'de','RMA-Setups',0),(236880,6580,'en','RMA Setups',0),(236881,6581,'is','',0),(236882,6581,'dr','Ø§ÙŠÙ† Ø¹Ù…Ù„ Ø¨Ø§Ø¹Ø« Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(236883,6581,'pr','Ø§ÙŠÙ† Ø¹Ù…Ù„ Ø¨Ø§Ø¹Ø« Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(236884,6581,'tr','Bu eylem, oluÅŸturulacak yeni bir dÃ¼zen neden olur',0),(236885,6581,'pl','Ta akcja spowoduje nowego zamÃ³wienia ma byÄ‡ generowany',0),(236886,6581,'bg','Ð¢Ð¾Ð²Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ñ‰Ðµ Ð´Ð¾Ð²ÐµÐ´Ðµ Ð´Ð¾ Ð½Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð´Ð° ÑÐµ Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°',0),(236887,6581,'ur','ÛŒÛ Ø¹Ù…Ù„ Ø¨Ù†Ø§Ø¦ÛŒ Ø¬Ø§Ø¦Û’ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ù†Ø¦Û’ Ø¢Ø±ÚˆØ± Ú©Ø§ Ø³Ø¨Ø¨ Ø¨Ù† Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(236888,6581,'sr','ÐžÐ²Ð° Ñ€Ð°Ð´ÑšÐ°, Ð¸Ð·Ð°Ð·Ð²Ð°Ñ‚ Ñ›ÐµÑˆ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ',0),(236889,6581,'vi','HÃ nh Ä‘á»™ng nÃ y sáº½ táº¡o ra má»™t Ä‘Æ¡n hÃ ng má»›i',0),(236890,6581,'af','Sal Hierdie Aksie Veroorsaak dat \'n Nuwe Bestelling Gegenereer Word',0),(236891,6581,'ro','Va cauza aceasta actiune o noua comanda care trebuie generata',0),(236892,6581,'et','Selle operatsiooni tulemusena genereeritakse uus tellimus',0),(236893,6581,'si','To dejanje bo povzroÄilo novega reda, ki bodo nastajali',0),(236894,6581,'ba','Akan tindakan ini menyebabkan Orde Baru yang akan dihasilkan',0),(236895,6581,'nl','Deze actie zal veroorzaken een nieuwe orde moeten worden gegenereerd',0),(236896,6581,'fi','TÃ¤mÃ¤ toiminta aiheuttaa uusi tilaus luodaan',0),(236897,6581,'no','Denne handlingen vil fÃ¸re til en ny rekkefÃ¸lge genereres',0),(236898,6581,'da','Denne handling vil medfÃ¸re en ny ordre skal genereres',0),(236899,6581,'ko','ì´ ì´ë ‡ê²Œ ìƒì„± ë˜ëŠ” ìƒˆë¡œìš´ ì§ˆì„œë¥¼ ë°œìƒí•  ê²ƒìž…ë‹ˆë‹¤',0),(236900,6581,'he','×¤×¢×•×œ×” ×–×• ×ª×’×¨×•× ×¡×“×¨ ×—×“×© ×©×™×•×•×¦×¨',0),(236901,6581,'el','Î‘Ï…Ï„Î® Î· Î´ÏÎ¬ÏƒÎ·, Ï€Î¿Ï… Î¸Î± Ï€ÏÎ¿ÎºÎ±Î»Î­ÏƒÎµÎ¹ Î¼Î¹Î± Î½Î­Î± Ï„Î¬Î¾Î· Ï€Î¿Ï… Î¸Î± Ï€Î±ÏÎ±Ï‡Î¸Î¿ÏÎ½',0),(236902,6581,'zh','æ­¤åŠ¨ä½œä¼šäº§ç”Ÿä¸€ä¸ªæ–°çš„è®¢å•å¾—ä»¥è¢«åˆ›å»º\r\n',0),(236903,6581,'sv','Denna Ã¥tgÃ¤rd kommer att leda en ny Order ska genereras',0),(236904,6581,'it','Questa azione provocherÃ  un nuovo ordine essere generato',0),(236905,6581,'tl','',0),(236906,6581,'th','&#3585;&#3634;&#3619;&#3585;&#3619;&#3632;&#3607;&#3635;&#3609;&#3637;&#3657;&#3607;&#3635;&#3651;&#3627;&#3657;&#3648;&#3585;&#3636;&#3604;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3',0),(236907,6581,'hi','à¤¯à¤¹ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤¨à¤ˆ à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾ à¤•à¥‡ à¤•à¤¾à¤°à¤£ à¤¹à¥‹à¤—à¤¾',0),(236908,6581,'ms','Akan tindakan ini menyebabkan pesanan baru dihasilkan',0),(236909,6581,'ar','Ø³ÙˆÙ ÙŠØ¤Ø¯ÙŠ Ù‡Ø°Ø§ Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡ Ø¥Ù„Ù‰ Ù†Ø¸Ø§Ù… Ø¬Ø¯ÙŠØ¯ ÙŠÙƒÙˆÙ† ÙˆÙ„Ø¯Øª',0),(236910,6581,'fr','Cette Action provoquera un nouvel ordre d\'Ãªtre gÃ©nÃ©rÃ©s',0),(236911,6581,'jp','ã“ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã«ã‚ˆã‚Šç”Ÿæˆã•ã‚Œã‚‹æ–°ã—ã„é †åº',0),(236912,6581,'pt','Esta aÃ§Ã£o farÃ¡ com que uma nova ordem a ser gerado',0),(236913,6581,'ru','Ð‘ÑƒÐ´ÐµÑ‚ Ð›Ð¸ Ð”Ð°Ð½Ð½Ð¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÐžÐ·Ð½Ð°Ñ‡Ð°Ñ‚ÑŒ Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ ÐÐ¾Ð²Ð¾Ð³Ð¾ Ð—Ð°ÐºÐ°Ð·Ð°',0),(236914,6581,'es','Â¿Esta acciÃ³n se CausarÃ¡ que se GenerarÃ¡ Un Nuevo Orden?',0),(236915,6581,'de','Bewirkt, dass diese Aktion eine neue Bestellung erzeugt werden',0),(236916,6581,'en','Will This Action Cause A New Order To Be Generated',0),(236917,6582,'is','',0),(236918,6582,'dr','Ù…ÙˆÙÙ‚ÙŠØª ',0),(236919,6582,'pr','Ù…ÙˆÙÙ‚ÙŠØª ',0),(236920,6582,'tr','BaÅŸarÄ±',0),(236921,6582,'pl','Sukces',0),(236922,6582,'bg','Ð£ÑÐ¿ÐµÑ…',0),(236923,6582,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ',0),(236924,6582,'sr','Ð£ÑÐ¿ÐµÑ…',0),(236925,6582,'vi','ThÃ nh cÃ´ng',0),(236926,6582,'af','Sukses',0),(236927,6582,'ro','Succes',0),(236928,6582,'et','Edu',0),(236929,6582,'si','Uspeh',0),(236930,6582,'ba','Sukses',0),(236931,6582,'nl','Succes',0),(236932,6582,'fi','Menestys',0),(236933,6582,'no','Suksess',0),(236934,6582,'da','Succes',0),(236935,6582,'ko','ì„±ê³µ',0),(236936,6582,'he','×”×¦×œ×—×”',0),(236937,6582,'el','Î•Ï€Î¹Ï„Ï…Ï‡Î¯Î±',0),(236938,6582,'zh','æˆåŠŸ\r\n',0),(236939,6582,'sv','FramgÃ¥ng',0),(236940,6582,'it','Successo',0),(236941,6582,'tl','',0),(236942,6582,'th','&#3588;&#3623;&#3634;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(236943,6582,'hi','à¤¸à¤«à¤²à¤¤à¤¾',0),(236944,6582,'ms','Kejayaan',0),(236945,6582,'ar','Ø§Ù„Ù†Ø¬Ø§Ø­',0),(236946,6582,'fr','SuccÃ¨s',0),(236947,6582,'jp','æˆåŠŸ',0),(236948,6582,'pt','Sucesso',0),(236949,6582,'ru','Ð£ÑÐ¿ÐµÑ…',0),(236950,6582,'es','Ã‰xito',0),(236951,6582,'de','Erfolg',0),(236952,6582,'en','Success',0),(236953,6583,'is','',0),(236954,6583,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ú¯Ø²Ø§Ø±Ø´Ø§Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(236955,6583,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ú¯Ø²Ø§Ø±Ø´Ø§Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(236956,6583,'tr','B2B sitesi komisyonlarÄ± raporlarÄ± izin ver',0),(236957,6583,'pl','UmoÅ¼liwiajÄ… Komisji sprawozdania na stronie B2B',0),(236958,6583,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð½Ð° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¸Ñ‚Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸ Ð½Ð° B2B ÑÐ°Ð¹Ñ‚',0),(236959,6583,'ur','B2B Ø³Ø§Ø¦Ù¹ Ù¾Ø± Ú©Ù…ÛŒØ´Ù†ÙˆÚº Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ÙˆÚº Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(236960,6583,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð¿Ñ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ð°Ð¼Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ Ð¾ Ð‘2Ð‘ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(236961,6583,'vi','Cho PhÃ©p BÃ¡o CÃ¡o Hoa Há»“ng TrÃªn Trang B2B',0),(236962,6583,'af','Laat Kommissie Verslae op B2B Werf Toe',0),(236963,6583,'ro','Permite rapoarte de comisioane de pe site-ul B2B',0),(236964,6583,'et','Luba vahendustasu aruanded B2B lehel',0),(236965,6583,'si','OmogoÄajo poroÄila komisij na B2B strani',0),(236966,6583,'ba','Memungkinkan Komisi laporan situs B2B',0),(236967,6583,'nl','Commissies verslagen over B2B Site toestaan',0),(236968,6583,'fi','Salli palkkiot raportteja B2B pÃ¤Ã¤llÃ¤',0),(236969,6583,'no','Tillate provisjoner rapporter pÃ¥ B2B nettsted',0),(236970,6583,'da','Tillad provisioner rapporter pÃ¥ B2B Site',0),(236971,6583,'ko','B2B ì‚¬ì´íŠ¸ì— ìœ„ì›íšŒ ë³´ê³ ì„œ',0),(236972,6583,'he','×œ××¤×©×¨ ×“×•×—×•×ª ×¢×ž×œ×•×ª ×‘××ª×¨ B2B',0),(236973,6583,'el','Î•Ï€Î¹Ï„ÏÎ­ÏˆÎµÎ¹ Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ ÏƒÏ„Î¿ Ï‡ÏŽÏÎ¿ Ï„Î¿Ï… B2B',0),(236974,6583,'zh','å…è®¸å§”å‘˜ä¼šå¯¹ä¼ä¸šå¯¹ä¼ä¸šç«™ç‚¹çš„æŠ¥å‘Š\r\n',0),(236975,6583,'sv','LÃ¥ta provisioner rapporter pÃ¥ B2B webbplats',0),(236976,6583,'it','Permettono rapporti di commissioni sul sito B2B',0),(236977,6583,'tl','',0),(236978,6583,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3605;&#3594;&#3633;&#3656;&#3609;&#3586;&#3629;&#3591;&#3604;&#3657;&#3634;&#3609; B2B',0),(236979,6583,'hi','B2B à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤° à¤†à¤¯à¥‹à¤—à¥‹à¤‚ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(236980,6583,'ms','Membenarkan laporan komisen lokasi B2B',0),(236981,6583,'ar','ØªØ³Ù…Ø­ ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„Ù„Ø¬Ø§Ù† Ø¹Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ B2B',0),(236982,6583,'fr','Autoriser les rapports de Commissions sur le Site B2B',0),(236983,6583,'jp','B2B ã‚µã‚¤ãƒˆã®ä»»å‹™ãƒ¬ãƒãƒ¼ãƒˆã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(236984,6583,'pt','Permitir relatÃ³rios de comissÃµes no Site B2B',0),(236985,6583,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¹ Ð¾ Ð½Ð° ÑÐ°Ð¹Ñ‚Ðµ B2B',0),(236986,6583,'es','Permitir Informes de Comisones en el Sitio de N2N',0),(236987,6583,'de','Berichte der Kommissionen auf B2B-Website ermÃ¶glichen',0),(236988,6583,'en','Allow Commissions Reports on B2B Site',0),(236989,6584,'is','',0),(236990,6584,'dr','Ø¢ÙŠØ§ ÙƒÙ…ÙŠØ³ÙŠÙˆ Ù† Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø·Ø¨Ù‚ Ù†Ø§Ø­ÙŠÙ‡ Ù‡Ø³ØªÙ†Ø¯ØŸ',0),(236991,6584,'pr','Ø¢ÙŠØ§ ÙƒÙ…ÙŠØ³ÙŠÙˆ Ù† Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø·Ø¨Ù‚ Ù†Ø§Ø­ÙŠÙ‡ Ù‡Ø³ØªÙ†Ø¯ØŸ',0),(236992,6584,'tr','SatÄ±ÅŸ komisyonlarÄ± bÃ¶lgesi tabanlÄ±dÄ±r',0),(236993,6584,'pl','SÄ… oparte na terytorium prowizji sprzedaÅ¼y',0),(236994,6584,'bg','Ð¡Ð° Ð±Ð°Ð·Ð¸Ñ€Ð°Ð½Ð¸ Ð½Ð° Ñ‚ÐµÑ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(236995,6584,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ú©Ù…ÛŒØ´Ù†ÙˆÚº Ú©Û’ Ø¹Ù„Ø§Ù‚Û’ Ù…ÛŒÚº Ù…Ù‚ÛŒÙ… ÛÛŒÚº',0),(236996,6584,'sr','Ð¡Ñƒ Ð·Ð°ÑÐ½Ð¾Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ð°Ð¼Ð° Ñ‚ÐµÑ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(236997,6584,'vi','Hoa Há»“ng BÃ¡n HÃ ng Dá»±a TrÃªn Khu Vá»±c',0),(236998,6584,'af','Is Verkope-Kommissie Terrein-Gebasseerd',0),(236999,6584,'ro','Sunt bazate pe teritoriul de comisioane de vÃ¢nzare',0),(237000,6584,'et','On mÃ¼Ã¼gi vahendustasude territooriumi baasil',0),(237001,6584,'si','Temeljijo na ozemlju provizije prodaje',0),(237002,6584,'ba','Wilayah komisi penjualan-based',0),(237003,6584,'nl','Zijn commissies verkooprayon gebaseerde',0),(237004,6584,'fi','Perustuvat palkkiot Myyntialue',0),(237005,6584,'no','Provisjoner salgsomrÃ¥de basert-',0),(237006,6584,'da','Er salgsdistrikt provision-baserede',0),(237007,6584,'ko','íŒë§¤ ìˆ˜ìˆ˜ë£Œ ì˜í†  ê¸°ë°˜',0),(237008,6584,'he','×”× ×ž×‘×•×¡×¡×™-××–×•×¨ ×¢×ž×œ×•×ª ×ž×›×™×¨×•×ª',0),(237009,6584,'el','Î’Î±ÏƒÎ¯Î¶Î¿Î½Ï„Î±Î¹ ÏƒÎµ Î­Î´Î±Ï†Î¿Ï‚ Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(237010,6584,'zh','é”€å”®ä½£é‡‘æ˜¯å¦ä»¥é¢†åŸŸä¸ºåŸºç¡€ï¼Ÿ',0),(237011,6584,'sv','FÃ¶rsÃ¤ljning provisioner territorium baserade-',0),(237012,6584,'it','Sono basati sul territorio di commissioni di vendita',0),(237013,6584,'tl','',0),(237014,6584,'th','&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;&#3586;&#3638;&#3657;&#3609;&#3629;&#3618;&#3641;&#3656;&#3607;&#3637;&#3656;&#3648;&#3586;&#3605;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;',0),(237015,6584,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤†à¤¯à¥‹à¤—à¥‹à¤‚ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤ªà¤° à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤¹à¥ˆà¤‚',0),(237016,6584,'ms','Adalah berasaskan Wilayah komisen jualan',0),(237017,6584,'ar','ØªØ¹ØªÙ…Ø¯ Ø¹Ù„Ù‰ Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø£Ø±Ø§Ø¶ÙŠ Ø§Ù„Ù„Ø¬Ø§Ù†',0),(237018,6584,'fr','Sont axÃ©s sur le territoire de Commissions de vente',0),(237019,6584,'jp','è²©å£²æ‰‹æ•°æ–™é ˜åœŸãƒ™ãƒ¼ã‚¹',0),(237020,6584,'pt','Baseiam-se em territÃ³rio de comissÃµes de vendas',0),(237021,6584,'ru','ÐžÑÐ½Ð¾Ð²Ð°Ð½Ñ‹ Ð½Ð° Ñ‚ÐµÑ€Ñ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¹',0),(237022,6584,'es','Â¿Comisiones de Ventas se Base en Territorio?',0),(237023,6584,'de','Basieren auf einem Verkaufsgebiet Kommissionen',0),(237024,6584,'en','Are Sales Commissions Territory-Based',0),(237025,6585,'is','',0),(237026,6585,'dr','.',0),(237027,6585,'pr','ÙØ±Ø¶ ÙƒÙ†ÙŠØ¯ ÙƒÙ‡ Ù‡Ø± ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù…  Ø§Ù†ÙˆØ§Ø¹ Ù…Ø§Ù„ÙŠØ§Øª  Ùˆ ØªÙ…Ø§Ù… Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª  ÙŠØ§ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ø§Ø³Øª.',0),(237028,6585,'tr','Her Ã¶ÄŸenin vergiye tabi veya mÃ¼ÅŸteri iÃ§in tÃ¼m vergiler iÃ§in NonTaxable olduÄŸunu',0),(237029,6585,'pl','ZakÅ‚adam, Å¼e kaÅ¼dy element jest podatnikiem lub operacji nieopodatkowanych wszystkie podatki dla klienta',0),(237030,6585,'bg','ÐŸÐ¾ÐµÐ¼Ð°Ð¼ Ð²ÑÐµÐºÐ¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ðµ Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð° Ð¸Ð»Ð¸ NonTaxable Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(237031,6585,'ur','ÙØ±Ø¶ Ø¹Ø§Ø¦Ø¯ ÛŒØ§ Ù†ÙˆÙ†ØªÚ¯Ø²ÛŒØ¨Ù„ÛŒ Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù„ÛŒÛ’ ØªÙ…Ø§Ù… Ù¹ÛŒÚ©Ø³ Ú©Û’ Ù„Ø¦Û’ ÛØ± Ø´Û’ ÛÛ’',0),(237032,6585,'sr','Ð”Ð° Ð¿Ñ€ÐµÑ‚Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ð¼Ð¾ Ð´Ð° Ñ˜Ðµ ÑÐ²Ð°ÐºÐ¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð¿Ð»Ð°Ð¶Ð° Ð¸Ð»Ð¸ Ð½ÐµÐ¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸Ñ… Ð·Ð° ÑÐ²Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ðµ Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(237033,6585,'vi','Giáº£ Äá»‹nh Tá»«ng Má»¥c CÃ³ Thuáº¿ Hoáº·c KhÃ´ng Thuáº¿ Ä‘á»‘i vá»›i Táº¥t Cáº£ CÃ¡c Loáº¡i Thuáº¿ cho KhÃ¡ch HÃ ng',0),(237034,6585,'af','Veronderstel dat elke Item Belasbaar of Nie-Belasbaar vir Alle Belastings vir Klant / KliÃ«nt',0),(237035,6585,'ro','Presupune cÄƒ fiecare element este impozabila sau NonTaxable pentru toate taxele pentru client',0),(237036,6585,'et','Eeldame iga kirje on maksustatav vÃµi kÃµiki makse kliendi NonTaxable',0),(237037,6585,'si','Prevzeti vsak element je davÄni zavezanec ali NonTaxable za vse davke za kupca',0),(237038,6585,'ba','Menganggap setiap Item pajak atau NonTaxable untuk semua pajak untuk pelanggan',0),(237039,6585,'nl','Neem aan dat elk Item is belastingplichtige of NonTaxable voor alle belastingen voor klant',0),(237040,6585,'fi','Kunkin nimikkeen on verovelvollinen tai NonTaxable veroista asiakkaan',0),(237041,6585,'no','Anta at hver vare er skattepliktig eller NonTaxable for alle avgifter for kunde',0),(237042,6585,'da','Antage hver vare er momspligtig eller ej for alle afgifter for kunde',0),(237043,6585,'ko','ê° í•­ëª©ì€ ê³¼ì„¸ ë˜ëŠ” NonTaxable ê³ ê°ì— ëŒ€ í•œ ëª¨ë“  ì„¸ê¸ˆì— ëŒ€ í•œ ê°€ì •',0),(237044,6585,'he','×ž× ×™×—×™× ×©×›×œ ×¤×¨×™×˜ ×”×•× ×—×™×™×‘ ×‘×ž×¡ ××• NonTaxable ×¢×‘×•×¨ ×›×œ ×”×ž×™×¡×™× ×¢×‘×•×¨ ×œ×§×•×—',0),(237045,6585,'el','Î¥Ï€Î¿Î¸Î­ÏƒÎ¿Ï…Î¼Îµ ÏŒÏ„Î¹ ÎºÎ¬Î¸Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÎ¯Î½Î±Î¹ Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ Î® NonTaxable Î³Î¹Î± ÏŒÎ»Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ Ï†ÏŒÏÎ¿Ï…Ï‚ Î³Î¹Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(237046,6585,'zh','å‡è®¾æ¯ä¸ªç‰©å“åœ¨å®¢æˆ·çš„æ‰€æœ‰ç¨Žæ”¶ä¸­å¾ç¨Žæˆ–å…ç¨Ž\r\n',0),(237047,6585,'sv','Anta att varje objekt Ã¤r skattepliktiga eller NonTaxable fÃ¶r alla skatter fÃ¶r kund',0),(237048,6585,'it','Assumere che ogni elemento Ã¨ soggetto passivo o NonTaxable tutte le tasse per il cliente',0),(237049,6585,'tl','',0),(237050,6585,'th','&#3626;&#3617;&#3617;&#3640;&#3605;&#3636;&#3623;&#3656;&#3634;&#3649;&#3605;&#3656;&#3621;&#3632;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;&#3627;&#3619;&#3639;&#3629;&#3611;&#3621;&#3629;&#3',0),(237051,6585,'hi','à¤®à¤¾à¤¨ à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤•à¤°à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ NonTaxable à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤®à¤¦ à¤¹à¥ˆ',0),(237052,6585,'ms','Menganggap setiap Item yang dikenakan cukai atau NonTaxable bagi semua cukai untuk pelanggan',0),(237053,6585,'ar','ØªØ­Ù…Ù„ ÙƒÙ„ ØµÙ†Ù Ù‡Ùˆ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ø£Ùˆ Ù†ÙˆÙ†ØªØ§ÙƒØ³Ø§Ø¨Ù„ \"Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨\" Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(237054,6585,'fr','Supposons que chaque Ã©lÃ©ment est Taxable ou non taxable pour les Taxes pour le client',0),(237055,6585,'jp','å„é …ç›®ã¯éžèª²ç¨Žã¾ãŸã¯éžèª²ç¨Žã®é¡§å®¢ã®ãŸã‚ã®ã™ã¹ã¦ã®ç¨Žé‡‘ã‚’å‰æã¨ã—ã¦ã„ã¾ã™ã€‚',0),(237056,6585,'pt','Supor que cada Item Ã© tributÃ¡vel ou NonTaxable para todas as taxas para o cliente',0),(237057,6585,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ð»Ð¾Ð¶Ð¸Ð¼, Ñ‡Ñ‚Ð¾ ÐºÐ°Ð¶Ð´Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼ Ð¸Ð»Ð¸ NonTaxable Ð´Ð»Ñ Ð²ÑÐµÑ… Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ð´Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(237058,6585,'es','Asumir que cada Item es Imponible o No Imponible para Todos los Impuestos de Cliente',0),(237059,6585,'de','Nehme an jedes Element Steuerpflichtige oder NonTaxable fÃ¼r alle Steuern fÃ¼r Kunden',0),(237060,6585,'en','Assume each Item is Taxable or Nontaxable for All Taxes for Customer',0),(237061,6586,'is','',0),(237062,6586,'dr','.',0),(237063,6586,'pr','Ù…Ø±Ø§Ù‚Ø¨ Ø¨Ø§Ø´ÙŠØ¯ ÙƒÙ‡ ØªØºÙŠÙŠØ± Ø±ÙˆØ´ Ø¨Ø¹Ø¯ Ø§Ø² Ø«Ø¨Øª ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ùˆ Ø³ÙØ§Ø±Ø´Ø§ØªÙŠ ÙƒÙ‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ùˆ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ø±Ø§ Ø¨Ù‡Ù… Ø¨Ø±ÙŠØ²Ø¯.',0),(237064,6586,'tr','Dikkatli deÄŸiÅŸtirme yÃ¶ntemi sonra fatura ve sipariÅŸler (vergi raporlarÄ± ve faturalarÄ± karÄ±ÅŸÄ±klÄ±k) girmiÅŸ olmak',0),(237065,6586,'pl','ByÄ‡ ostroÅ¼nym Metoda zmiany po faktury i zlecenia juÅ¼ wprowadzone (moÅ¼e nieÅ‚ad w gÃ³rze raporty podatkowe i faktury)',0),(237066,6586,'bg','Ð‘ÑŠÐ´Ð° Ð³Ñ€Ð¸Ð¶Ð»Ð¸Ð² Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð¼ÐµÑ‚Ð¾Ð´ ÑÐ»ÐµÐ´ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð²ÐµÑ‡Ðµ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½ (Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ð±ÑŠÑ€ÐºÐ²Ð°Ð¼ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸ Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸)',0),(237067,6586,'ur','Ù…Ø­ØªØ§Ø· Ø·Ø±ÛŒÙ‚Û ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ø¨Ø¹Ø¯ ÙˆØ¨Ø¬Ù„ÛŒ Ø§ÙˆØ± Ø§Ø­Ú©Ø§Ù…Ø§Øª (Ù¹ÛŒÚ©Ø³ Ø±Ù¾ÙˆØ±Ù¹ÛŒÚº Ø§ÙˆØ± ÙˆØ¨Ø¬Ù„ÛŒ Ú©Ùˆ Ú¯Ú‘Ø¨Ú‘ ÛÙˆ) Ù¾ÛÙ„Û’ ÛÛŒ Ø¯Ø§Ø®Ù„ ÛÙˆ',0),(237068,6586,'sr','Ð‘Ð¸Ñ‚Ð¸ Ð¾Ð¿Ñ€ÐµÐ·Ð°Ð½ Ð½Ð°Ñ‡Ð¸Ð½ Ð¼ÐµÑšÐ° Ð½Ð°ÐºÐ¾Ð½ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° Ñ˜Ðµ Ð²ÐµÑ› ÑƒÑˆÐ»Ð° (ÐœÐ¾Ð¶Ð´Ð° Ð·Ð°Ð±Ñ€Ñ™Ð°Ñ‚Ð¸ Ð¾ Ð¿Ð¾Ñ€ÐµÐ·Ñƒ Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ)',0),(237069,6586,'vi','ChÃº Ã½ khi muá»‘n thay Ä‘á»•i phÆ°Æ¡ng thá»©c sau khi HÃ³a ÄÆ¡n & ÄÆ¡n Äáº·t HÃ ng ÄÃ£ cáº­p nháº­t (bÃ¡o cÃ¡o thuáº¿ & hÃ³a Ä‘Æ¡n cÃ³ thá»ƒ bá»‹ sai)',0),(237070,6586,'af','Wees Versigtig om \'n METODE te verander nadat Fakture en Bestellings ingevoer is (Belastingverslae en Fakture MAG dalk geraak word)',0),(237071,6586,'ro','Fi atent schimbarea metodei dupÄƒ facturile ÅŸi ordinele intrat deja (poate Ã®ncurcÃ£turÃ£ sus rapoartele fiscale si facturile)',0),(237072,6586,'et','Olla ettevaatlik muutmise meetod pÃ¤rast arvete ja tellimusi juba sisestatud (vÃµib segi ajama maksuaruandeid ja arved)',0),(237073,6586,'si','Biti previdni spreminjanje metode po raÄunih in naroÄila Å¾e vpisana (lahko RaÅ¡Äerupati davÄnih poroÄil in raÄuni)',0),(237074,6586,'ba','Hati-hati saat penggantian setelah pembuatan Faktur dan Pesanan dapat menyebabkan kekacauan pada Laporan Pajak dan Faktur',0),(237075,6586,'nl','Voorzichtig wijzigen methode worden na facturen en Orders al ingevoerd (kan verknoeien belasting verslagen en facturen)',0),(237076,6586,'fi','Olla varovainen muuttamalla laskuja ja tilauksia jo tullut (voi sotkea veroraporteissa ja laskut)',0),(237077,6586,'no','VÃ¦re forsiktig endre metoden etter fakturaer og ordre allerede angitt (kan lage-rapporter og fakturaer)',0),(237078,6586,'da','VÃ¦re forsigtig skiftende metode efter fakturaer og ordrer allerede indtastet (kan rode op momsrapporter og fakturaer)',0),(237079,6586,'ko','ì¸ë³´ì´ìŠ¤ ë° ì£¼ë¬¸ì„ ì´ë¯¸ (ì„¸ê¸ˆ ë³´ê³ ì„œ ë° ì²­êµ¬ì„œë¥¼ ë§ì¹  ìˆ˜ ìžˆìŠµë‹ˆë‹¤) ìž…ë ¥ í›„ ì£¼ì˜ ë³€ê²½ ë©”ì„œë“œë¥¼ ìˆ˜',0),(237080,6586,'he','×œ×”×™×•×ª ×–×”×™×¨ ×©×™× ×•×™ ×©×™×˜×ª ××—×¨×™ ×—×©×‘×•× ×™×•×ª, ×”×–×ž× ×•×ª ×›×‘×¨ × ×›× ×¡×• (×¢×œ×•×œ ×œ×”×¨×•×¡ ××ª ×”×ž×¡ ×“×•×—×•×ª ×•×—×©×‘×•× ×™×•×ª)',0),(237081,6586,'el','ÎÎ± ÎµÎ¯ÏƒÏ„Îµ Ï€ÏÎ¿ÏƒÎµÎºÏ„Î¹ÎºÎ¿Î¯ Î±Î»Î»Î±Î³Î® Î¼ÎµÎ¸ÏŒÎ´Î¿Ï… Î¼ÎµÏ„Î¬ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎºÎ±Î¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î®Î´Î· ÎµÎ¹ÏƒÎ­Î»Î¸ÎµÎ¹ (Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Î²ÏÏ‰Î¼Î¯ÏƒÎ¿Ï…Î½ ÎµÏ€Î¬Î½Ï‰ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ­Ï‚ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ ÎºÎ±Î¹ Ï„Î¹Î¼Î¿',0),(237082,6586,'zh','å‘ç¥¨å’Œè®¢å•å·²ç»ç­¾è®¢åŽè¯·è°¨æ…Žæ”¹å˜æ–¹æ³•ï¼ˆå¯èƒ½ä¼šå¼„é”™ç¨ŽåŠ¡æŠ¥å‘Šå’Œå‘ç¥¨ï¼‰\r\n',0),(237083,6586,'sv','Vara noga med att Ã¤ndra metod efter fakturor och bestÃ¤llningar redan angett (kan rÃ¶ra upp skatterapporter och fakturor)',0),(237084,6586,'it','Essere attenti cambiando metodo dopo le fatture e gli ordini giÃ  inseriti (puÃ² rovinare il report fiscali e fatture)',0),(237085,6586,'tl','',0),(237086,6586,'th','Be Careful Changing Method after Invoices and Orders Already Entered (may mess up tax reports and invoices)',0),(237087,6586,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤”à¤° à¤†à¤¦à¥‡à¤¶ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ (à¤Ÿà¥ˆà¤•à¥à¤¸ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥‹à¤‚ à¤”à¤° à¤šà¤¾à¤²à¤¾à¤¨ à¤Šà¤ªà¤° à¤—à¤¡à¤¼à¤¬à¤¡à¤¼ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚) à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¤¾à¤µà¤§à¤¾',0),(237088,6586,'ms','Menjadi kaedah menukar berhati-hati selepas invois dan pesanan memasukkan (mungkin kucar-kacir laporan cukai dan invois)',0),(237089,6586,'ar','Ø£Ù† \"Ø£Ø³Ù„ÙˆØ¨ ØªØºÙŠÙŠØ± Ø¯Ù‚ÙŠÙ‚\" Ø¨Ø¹Ø¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ± ÙˆØ£ÙˆØ§Ù…Ø± Ø¯Ø®Ù„Øª Ø¨Ø§Ù„ÙØ¹Ù„ (ÙˆÙ‚Ø¯ Ø®Ø¨Ø· ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ ÙˆØ§Ù„ÙÙˆØ§ØªÙŠØ±)',0),(237090,6586,'fr','ÃŠtre prudent mÃ©thode de modification aprÃ¨s les factures et commandes dÃ©jÃ  entrÃ© (peut gÃ¢cher Ã‰tats fiscaux et factures)',0),(237091,6586,'jp','è«‹æ±‚æ›¸ã¨æ³¨æ–‡ã¯ã™ã§ã« ï¼ˆç¨Žãƒ¬ãƒãƒ¼ãƒˆã¨è«‹æ±‚æ›¸ã‚’å°ç„¡ã—ã«å¯èƒ½æ€§ãŒã‚ã‚Šã¾ã™) ã‚’å…¥åŠ›ã—ãŸå¾Œæ³¨æ„ã‚’å¤‰æ›´ã™ã‚‹æ–¹æ³•ã§ã‚ã‚Šã¾ã™ã€‚',0),(237092,6586,'pt','Ser cuidadoso mÃ©todo mudando depois de faturas e ordens jÃ¡ entrou (pode estragar relatÃ³rios fiscais e faturas)',0),(237093,6586,'ru','Ð‘Ñ‹Ñ‚ÑŒ Ð¾ÑÑ‚Ð¾Ñ€Ð¾Ð¶Ð½Ñ‹Ð¼ Ð¼ÐµÐ½ÑÐµÑ‚ÑÑ Ð¼ÐµÑ‚Ð¾Ð´Ð¾Ð¼ Ð¿Ð¾ÑÐ»Ðµ ÑÑ‡ÐµÑ‚Ð° Ð¸ Ð·Ð°ÐºÐ°Ð·Ñ‹ ÑƒÐ¶Ðµ (Ð¼Ð¾Ð¶ÐµÑ‚ Ð¸ÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ‚ÑŒ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ñ… Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¾Ð² Ð¸ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€)',0),(237094,6586,'es','Cuidado Cambiando el MÃ©todo despuÃ©s de Entar Facturas y Pedidos (puede arruinar los informes de Impuestos)',0),(237095,6586,'de','Werden Sie vorsichtig Ã¤ndern-Methode nach Rechnungen und Bestellungen bereits eingetragen (kann Steuerberichte und Rechnungen durcheinander)',0),(237096,6586,'en','Be Careful Changing Method after Invoices and Orders Already Entered (may mess up tax reports and invoices)',0),(237097,6587,'is','',0),(237098,6587,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‚Ø§Ù„Ø¨ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ',0),(237099,6587,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‚Ø§Ù„Ø¨ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ',0),(237100,6587,'tr','VarsayÄ±lan aÃ§Ä±klama biÃ§imi',0),(237101,6587,'pl','DomyÅ›lny Format instrukcja',0),(237102,6587,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(237103,6587,'ur','Ø·Û’ Ø´Ø¯Û Ø¨ÛŒØ§Ù† ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(237104,6587,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(237105,6587,'vi','Dáº¡ng sao kÃª Máº·c Ä‘á»‹nh',0),(237106,6587,'af','Verstekte Staatformaat',0),(237107,6587,'ro','Formatul implicit de declaraÅ£ie',0),(237108,6587,'et','Aruande vaikevormingu',0),(237109,6587,'si','Privzeto obliko izjavo',0),(237110,6587,'ba','Format pernyataan default',0),(237111,6587,'nl','Verklaring standaardindeling',0),(237112,6587,'fi','Lausunto oletusmuoto',0),(237113,6587,'no','Standardformatet uttalelse',0),(237114,6587,'da','Standard sÃ¦tningen Format',0),(237115,6587,'ko','ê¸°ë³¸ ë¬¸ í˜•ì‹',0),(237116,6587,'he','×ª×‘× ×™×ª ×“×•×— ×‘×¨×™×¨×ª ×”×ž×—×“×œ',0),(237117,6587,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¼Î¿ÏÏ†Î® Î´Î®Î»Ï‰ÏƒÎ·',0),(237118,6587,'zh','é»˜è®¤è¯­å¥æ ¼å¼\r\n',0),(237119,6587,'sv','Standardformatet uttalande',0),(237120,6587,'it','Formato di istruzione default',0),(237121,6587,'tl','',0),(237122,6587,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(237123,6587,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤•à¥‡ à¤¬à¤¯à¤¾à¤¨',0),(237124,6587,'ms','Format penyata lalai',0),(237125,6587,'ar','Ø§Ù„ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†',0),(237126,6587,'fr','Format de dÃ©claration par dÃ©faut',0),(237127,6587,'jp','æ—¢å®šã®ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã®å½¢å¼',0),(237128,6587,'pt','Formato de AfirmaÃ§Ã£o PadrÃ£o',0),(237129,6587,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(237130,6587,'es','Formato de DeclaraciÃ³n por Defecto',0),(237131,6587,'de','Anweisung Standardformat',0),(237132,6587,'en','Default Statement Format',0),(237133,6588,'is','',0),(237134,6588,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ø§Ø¹Ù…Ø§Ù„ Ø®ÙˆØ¯ÙƒØ§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø±Ø§ Ø¯Ø± ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù‚Ø¯ÙŠÙ…ÙŠ Ù†Ø¯Ù‡ÙŠØ¯ ',0),(237135,6588,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ø§Ø¹Ù…Ø§Ù„ Ø®ÙˆØ¯ÙƒØ§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø±Ø§ Ø¯Ø± ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù‚Ø¯ÙŠÙ…ÙŠ Ù†Ø¯Ù‡ÙŠØ¯ ',0),(237136,6588,'tr','En eski fatura Ã¶demeleri otomatik uygulama yapmak',0),(237137,6588,'pl','Czy nie stosuje siÄ™ do Auto pÅ‚atnoÅ›ci do najstarszej faktury',0),(237138,6588,'bg','Ð”Ð° Ð½Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ ÐºÑŠÐ¼ Ð½Ð°Ð¹-ÑÑ‚Ð°Ñ€Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(237139,6588,'ur','Ù†Û Ø®ÙˆØ¯ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø³Ø¨ Ø³Û’ Ù¾Ø±Ø§Ù†ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Ø±ØªÛ’ ÛÛŒÚº',0),(237140,6588,'sr','Ð”Ð° Ð½Ð¸Ñ˜Ðµ ÐÑƒÑ‚Ð¾-ÐŸÑ€Ð¸Ð¼ÐµÐ½Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð½Ð°Ñ˜ÑÑ‚Ð°Ñ€Ð¸Ñ˜Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð°',0),(237141,6588,'vi','Äá»«ng Ã¡p dá»¥ng thanh toÃ¡n tá»± Ä‘á»™ng cho hÃ³a Ä‘Æ¡n lÃ¢u nháº¥t',0),(237142,6588,'af','Moenie Betalings Self-Toeskryf aan die Oudste Fakture Nie',0),(237143,6588,'ro','Face nu se aplicÄƒ Auto plÄƒÅ£i pentru facturile mai vechi',0),(237144,6588,'et','Kas Auto kohaldatakse maksete vanim arved',0),(237145,6588,'si','Delati ne uporablja Auto plaÄila za najstarejÅ¡i raÄunov',0),(237146,6588,'ba','Lakukan pembayaran yang tidak Auto-berlaku untuk faktur tertua',0),(237147,6588,'nl','Niet automatisch toepassen betalingen doen oudste facturen',0),(237148,6588,'fi','TehdÃ¤ Auto sovelletaan maksuja vanhin laskuihin',0),(237149,6588,'no','GjÃ¸r ikke bilen-sÃ¸ke betalinger til eldste fakturaer',0),(237150,6588,'da','GÃ¸r ikke Auto-gÃ¦lder betalinger til Ã¦ldste fakturaer',0),(237151,6588,'ko','ì˜¤ëž˜ ëœ ì†¡ìž¥ ìžë™ ì ìš© ì§€ë¶ˆ í•˜ì§€ ë§ˆì‹­ì‹œì˜¤',0),(237152,6588,'he','×œ×¢×©×•×ª ×ª×©×œ×•×ž×™× ××•×˜×•×ž×˜×™-×”×—×œ×ª ×œ× ×—×©×‘×•× ×™×•×ª ×”×¢×ª×™×§',0),(237153,6588,'el','Î”ÎµÎ½ Auto-ÎµÏ†Î±ÏÎ¼Î¿Î³Î® Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½ Î½Î± Ï€Î±Î»Î±Î¹ÏŒÏ„ÎµÏÎ¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(237154,6588,'zh','ä¸è¦è‡ªåŠ¨åº”ç”¨ä»˜æ¬¾åˆ°æœ€æ—§å‘ç¥¨\r\n',0),(237155,6588,'sv','GÃ¶r inte Auto-applicera betalningar till Ã¤ldsta fakturor',0),(237156,6588,'it','Fare pagamenti non Auto-applicare alle fatture piÃ¹ antiche',0),(237157,6588,'tl','',0),(237158,6588,'th','&#3652;&#3617;&#3656;&#3651;&#3594;&#3657;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;&#3585;&#3633;&#3610;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3',0),(237159,6588,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¬à¤¸à¥‡ à¤ªà¥à¤°à¤¾à¤¨à¤¾ à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤‘à¤Ÿà¥‹ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(237160,6588,'ms','Lakukan tidak Auto-memohon bayaran untuk invois yang paling lama',0),(237161,6588,'ar','Ù‡Ù„ Ù„Ø§ ÙŠÙ†Ø·Ø¨Ù‚ Ø¹Ù„Ù‰ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¨Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø£Ù‚Ø¯Ù…',0),(237162,6588,'fr','Faire pas imputer automatiquement les paiements de factures plus anciennes',0),(237163,6588,'jp','æœ€å¤ã®è«‹æ±‚æ›¸ã«ãªã„è‡ªå‹•é©ç”¨ã®æ”¯æ‰•ã„ã‚’è¡Œã†',0),(237164,6588,'pt','NÃ£o Auto-aplique Pagamentos Ã s Faturas Mais Antigas',0),(237165,6588,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð½Ðµ Ð°Ð²Ñ‚Ð¾ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ Ð´Ð»Ñ ÑÑ‚Ð°Ñ€Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(237166,6588,'es','No Auto-Aplicar Pagos a las Facturas Antiguas',0),(237167,6588,'de','Ã„lteste Rechnungen nicht automatisch zugewiesene Zahlungen antun',0),(237168,6588,'en','Do Not Auto-Apply Payments to Oldest Invoices',0),(237169,6589,'is','',0),(237170,6589,'dr','Ú†Ú¯ÙˆÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§ØªÙ‡Ø§ Ø¯Ø± ÙØ§ÙƒØªÙˆØ± Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø§Ø¹Ù…Ø§Ù„ Ø´ÙˆØ¯ ØŸ',0),(237171,6589,'pr','Ú†Ú¯ÙˆÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§ØªÙ‡Ø§ Ø¯Ø± ÙØ§ÙƒØªÙˆØ± Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø§Ø¹Ù…Ø§Ù„ Ø´ÙˆØ¯ ØŸ',0),(237172,6589,'tr','NasÄ±l fatura Ã¶ÄŸeleri sipariÅŸ vergi uygulanÄ±r',0),(237173,6589,'pl','Jak stosowaÄ‡ podatkÃ³w na fakturze kolejnoÅ›Ä‡ elementÃ³w',0),(237174,6589,'bg','ÐšÐ°Ðº Ð´Ð° ÐºÐ°Ð½Ð´Ð¸Ð´Ð°Ñ‚ÑÑ‚Ð²Ð°Ð¼Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð²ÑŠÑ€Ñ…Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(237175,6589,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ø§Ø´ÛŒØ§Ø¡ Ù¾Ø± Ù¹ÛŒÚ©Ø³ Ù„Ø§Ú¯Ùˆ Ú©Ø±Ù†Û’ Ú©Ø§ Ø·Ø±ÛŒÙ‚Û',0),(237176,6589,'sr','ÐšÐ°ÐºÐ¾ Ð´Ð° ÑÐµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ð¼ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(237177,6589,'vi','LÃ m tháº¿ nÃ o Ä‘á»ƒ tÃ­nh thuáº¿ máº·t hÃ ng trÃªn hÃ³a Ä‘Æ¡n ',0),(237178,6589,'af','Hoe om Belasting Toe te voeg op Faktuur Bestellingsitems',0),(237179,6589,'ro','Cum se aplicÄƒ impozitelor pe elemente de comanda facturÄƒ',0),(237180,6589,'et','Kuidas taotleda makse arve kaupade tellimiseks',0),(237181,6589,'si','Kako uporabljati davkov na raÄun razvrÅ¡Äanje elementov',0),(237182,6589,'ba','Bagaimana menerapkan pajak pada faktur pesanan item',0),(237183,6589,'nl','Hoe toe te passen belasting op factuur artikelen bestellen',0),(237184,6589,'fi','Osaa soveltaa veroa laskun tilaa nimikkeet',0),(237185,6589,'no','Hvordan sÃ¸ke skatt pÃ¥ fakturaen bestille varer',0),(237186,6589,'da','Hvordan man kan anvende afgifter pÃ¥ fakturaen bestille varer',0),(237187,6589,'ko','ì†¡ìž¥ ì£¼ë¬¸ í•­ëª©ì— ëŒ€ í•œ ì„¸ê¸ˆì„ ì ìš© í•˜ëŠ” ë°©ë²•',0),(237188,6589,'he','××•×¤×Ÿ ×”×”×—×œ×” ×©×œ ×ž×¡×™× ×¢×œ ×—×©×‘×•× ×™×ª ×œ×”×–×ž×™×Ÿ ×¤×¨×™×˜×™×',0),(237189,6589,'el','Î ÏŽÏ‚ Î½Î± Ï…Ï€Î¿Î²Î¬Î»ÎµÏ„Îµ Î±Î¯Ï„Î·ÏƒÎ· Ï†ÏŒÏÎ¿Î¹ ÎµÏ€Î¯ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(237190,6589,'zh','å¦‚ä½•ç”³è¯·ç¨ŽåŠ¡å‘ç¥¨è®¢å•é¡¹ç›®\r\n',0),(237191,6589,'sv','Hur man tillÃ¤mpar skatter pÃ¥ fakturan bestÃ¤lla artiklar',0),(237192,6589,'it','Come applicare le tasse sulla fattura ordinare articoli',0),(237193,6589,'tl','',0),(237194,6589,'th','&#3623;&#3636;&#3608;&#3637;&#3651;&#3594;&#3657;&#3616;&#3634;&#3625;&#3637;&#3651;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3',0),(237195,6589,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤†à¤¦à¥‡à¤¶ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤ªà¤° à¤•à¤°à¥‹à¤‚ à¤•à¥‹ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥ˆà¤¸à¥‡',0),(237196,6589,'ms','Bagaimana untuk memohon cukai invois pesanan barangan',0),(237197,6589,'ar','ÙƒÙŠÙÙŠØ© ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø© ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(237198,6589,'fr','Comment appliquer des Taxes sur l\'ordre de facturation',0),(237199,6589,'jp','è«‹æ±‚æ›¸ã®ç™ºæ³¨ã®å“ç›®ã«å¯¾ã™ã‚‹ç¨Žã‚’é©ç”¨ã™ã‚‹æ–¹æ³•',0),(237200,6589,'pt','Como aplicar impostos sobre itens de ordem da fatura',0),(237201,6589,'ru','ÐšÐ°Ðº Ð¿Ð¾Ð´Ð°Ñ‚ÑŒ Ð½Ð°Ð»Ð¾Ð³Ð¸ Ð½Ð° ÑÑ‡ÐµÑ‚ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(237202,6589,'es','CÃ³mo Aplicar Impuestos en Items de Orden de Factura',0),(237203,6589,'de','Steuern auf Bestellung Rechnungspositionen Bewerbungsinfos',0),(237204,6589,'en','How to Apply Taxes on Invoice Order Items',0),(237205,6590,'is','',0),(237206,6590,'dr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ÙŠ ØªØ§ÙƒÙ†ÙˆÙ†',0),(237207,6590,'pr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ÙŠ ØªØ§ÙƒÙ†ÙˆÙ†',0),(237208,6590,'tr','HiÃ§ satÄ±ÅŸ vergi yok',0),(237209,6590,'pl','Nigdy nie podatek',0),(237210,6590,'bg','Ð‘ÐµÐ· Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð½ÑÐºÐ¾Ð³Ð°',0),(237211,6590,'ur','Ú©Ø¨Ú¾ÛŒ Ú©ÙˆØ¦ÛŒ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³',0),(237212,6590,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ðµ Ð¸ÐºÐ°Ð´Ð°',0),(237213,6590,'vi','Thuáº¿ bÃ¡n hÃ ng khÃ´ng cÃ³',0),(237214,6590,'af','Geen Verkoopsbelasting Gevind',0),(237215,6590,'ro','Nici o taxa la vÃ¢nzÄƒri vreodatÄƒ',0),(237216,6590,'et','Kunagi pole kÃ¤ibemaksu',0),(237217,6590,'si','Ne prodaje davki vedno',0),(237218,6590,'ba','Pajak penjualan tidak pernah',0),(237219,6590,'nl','Ooit geen belastingen op de verkoop',0),(237220,6590,'fi','Koskaan ei ole arvonlisÃ¤verot',0),(237221,6590,'no','Ingen merverdiavgift noensinne',0),(237222,6590,'da','Ingen moms nogensinde',0),(237223,6590,'ko','ì´ì œê¹Œì§€ ì•„ë¬´ íŒë§¤ ì„¸ê¸ˆ',0),(237224,6590,'he','××™×Ÿ ×ž×¢ ×ž ××™ ×¤×¢×',0),(237225,6590,'el','Î Î¿Ï„Î­ Î´ÎµÎ½ Ï†ÏŒÏÎ¿Ï…Ï‚ ÎµÏ€Î¯ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(237226,6590,'zh','ä»Žæ²¡æœ‰é”€å”®ç¨Ž\r\n',0),(237227,6590,'sv','Ingen moms nÃ¥gonsin',0),(237228,6590,'it','Mai nessun tasse di vendita',0),(237229,6590,'tl','',0),(237230,6590,'th','&#3652;&#3617;&#3656;&#3648;&#3588;&#3618;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(237231,6590,'hi','à¤•à¤­à¥€ à¤•à¥‹à¤ˆ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥‹à¤‚',0),(237232,6590,'ms','Cukai jualan tidak pernah',0),(237233,6590,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù…Ù† Ø£ÙŠ ÙˆÙ‚Øª Ù…Ø¶Ù‰',0),(237234,6590,'fr','Aucune taxe de vente jamais',0),(237235,6590,'jp','ã“ã‚Œã¾ã§ã«ãªã„ã®å£²ä¸Šç¨Ž',0),(237236,6590,'pt','Nunca nenhum imposto de vendas',0),(237237,6590,'ru','Ð‘ÐµÐ· Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð½Ð¸ÐºÐ¾Ð³Ð´Ð°',0),(237238,6590,'es','No hay IVA Nunca',0),(237239,6590,'de','Keine Umsatzsteuer je',0),(237240,6590,'en','No Sales Taxes Ever',0),(237241,6591,'is','',0),(237242,6591,'dr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚ Ø¢Ø¯Ø±Ø³',0),(237243,6591,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚ Ø¢Ø¯Ø±Ø³',0),(237244,6591,'tr','SipariÅŸ adresi',0),(237245,6591,'pl','ZamÃ³wienia przez adres',0),(237246,6591,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¿Ð¾ Ð°Ð´Ñ€ÐµÑ',0),(237247,6591,'ur','Ù¾ØªÛ’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¢Ø±ÚˆØ±',0),(237248,6591,'sr','ÐžÑ€Ð´ÐµÑ€ Ð‘y Ð°Ð´Ñ€ÐµÑÐ°',0),(237249,6591,'vi','Äáº·t hÃ ng theo Ä‘á»‹a chá»‰',0),(237250,6591,'af','Bestel Deur Aksie',0),(237251,6591,'ro','ComandÄƒ pe adresa',0),(237252,6591,'et','Tellimuse aadress',0),(237253,6591,'si','Vrstnem redu po naslovu',0),(237254,6591,'ba','Diurutkan sesuai alamat',0),(237255,6591,'nl','Order By adres',0),(237256,6591,'fi','Jotta osoite',0),(237257,6591,'no','Bestill ved adresse',0),(237258,6591,'da','RÃ¦kkefÃ¸lge af adresse',0),(237259,6591,'ko','ì£¼ì†Œ ìˆœì„œ',0),(237260,6591,'he','×¡×“×¨ ×œ×¤×™ ×›×ª×•×‘×ª',0),(237261,6591,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Ï€ÏŒ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(237262,6591,'zh','æŒ‰åœ°å€æŽ’åº\r\n',0),(237263,6591,'sv','BestÃ¤llning av adress',0),(237264,6591,'it','Ordine di indirizzo',0),(237265,6591,'tl','',0),(237266,6591,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3650;&#3604;&#3618;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(237267,6591,'hi','à¤ªà¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¥à¤°à¤®',0),(237268,6591,'ms','Perintah mengikut alamat',0),(237269,6591,'ar','Ø§Ù„ØªØ±ØªÙŠØ¨ Ø­Ø³Ø¨ Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(237270,6591,'fr','Commande par adresse',0),(237271,6591,'jp','ã‚¢ãƒ‰ãƒ¬ã‚¹é †',0),(237272,6591,'pt','Ordem por endereÃ§o',0),(237273,6591,'ru','Ð—Ð°ÐºÐ°Ð· ÐŸÐ¾ ÐÐ´Ñ€ÐµÑÑƒ',0),(237274,6591,'es','Ordenar Por DirecciÃ³n',0),(237275,6591,'de','Bestellung per Adresse',0),(237276,6591,'en','Order By Address',0),(237277,6592,'is','',0),(237278,6592,'dr','Ø¨Ø®Ø´ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ ÙˆØ±ÙˆØ¯ÙŠ Ù‡Ø§\r\n WalkIns',0),(237279,6592,'pr','Ø¨Ø®Ø´ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ ÙˆØ±ÙˆØ¯ÙŠ Ù‡Ø§\r\n WalkIns',0),(237280,6592,'tr','SatÄ±ÅŸ vergisi taslaÄŸÄ± iÃ§in Walk-Ins',0),(237281,6592,'pl','Dzielnicy podatek od sprzedaÅ¼y dla walk-in',0),(237282,6592,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´ÐºÐ° Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(237283,6592,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø¶Ù„Ø¹ Walk-Ins Ú©Û’ Ù„Ø¦Û’',0),(237284,6592,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° Ð¾ÐºÑ€ÑƒÐ³ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð·Ð° Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´',0),(237285,6592,'vi','Quáº­n thuáº¿ bÃ¡n hÃ ng cho khÃ¡ch vÃ£ng lai',0),(237286,6592,'af','Verkope belasting distrik vir Walk-Ins',0),(237287,6592,'ro','VÃ¢nzÄƒri fiscale District pentru Walk-in-uri',0),(237288,6592,'et','MÃ¼Ã¼gi maksu linnaosa Walk-ins',0),(237289,6592,'si','Prodaja davka District na sprehod-ins',0),(237290,6592,'ba','Distrik pajak penjualan untuk Walk In',0),(237291,6592,'nl','Verkoopregio belasting voor Walk-Ins',0),(237292,6592,'fi','Myynti veropiiri vaeltajat',0),(237293,6592,'no','Salg skatt distriktet pÃ¥ Walk-Ins',0),(237294,6592,'da','Salg skat distrikt for Walk-Ins',0),(237295,6592,'ko','ê±° ëŒ€ í•œ íŒë§¤ ì„¸ê¸ˆ ì§€êµ¬',0),(237296,6592,'he','×ž×—×•×– ×ž×¡ ×ž×›×™×¨×•×ª ×¢×‘×•×¨ ××•×¨×—×™×',0),(237297,6592,'el','Î ÎµÏÎ¹Î¿Ï‡Î® Ï†ÏŒÏÎ¿Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³Î¹Î± Ï„Î± Ï€ÏŒÎ´Î¹Î±-ins',0),(237298,6592,'zh','å…¥å£çš„é”€å”®ç¨ŽåŒº\r\n',0),(237299,6592,'sv','SÃ¤ljdistrikt skatt fÃ¶r Walk-Ins',0),(237300,6592,'it','Sales Tax distretto per walk-in',0),(237301,6592,'tl','',0),(237302,6592,'th','&#3648;&#3586;&#3605;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3648;&#3604;&#3636;&#3609;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;&#3648;&#3629;&#3591;',0),(237303,6592,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤œà¤¿à¤²à¤¾ Walk-Ins à¤•à¥‡ à¤²à¤¿à¤',0),(237304,6592,'ms','Daerah cukai jualan bagi Walk-Ins',0),(237305,6592,'ar','Ù…Ù‚Ø§Ø·Ø¹Ø© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„Ù†Ù„Ù‚Ø§Ù‡',0),(237306,6592,'fr','District de taxe de ventes pour Walk-ins',0),(237307,6592,'jp','ã©ã‚“ã¡ã‚ƒã‚“é¨’ãŽã®å–¶æ¥­ç¨Ž',0),(237308,6592,'pt','Distrito de imposto sobre vendas para walk-ins',0),(237309,6592,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹ Ñ€Ð°Ð¹Ð¾Ð½Ð° Ð´Ð»Ñ Ð¿Ñ€Ð¸ÑˆÐµÐ»ÑŒÑ†Ñ‹',0),(237310,6592,'es','Distrito de IVA para WalkIns',0),(237311,6592,'de','Sales Tax Bezirk fÃ¼r Walk-Ins',0),(237312,6592,'en','Sales Tax District for Walk-Ins',0),(237313,6593,'is','',0),(237314,6593,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø§ÙŠÙ†ÙƒÙ‡ Ú†Ù‡ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¨Ù‡ Ù‡Ø± ÙƒØ§Ù„Ø§ Ø§Ø¹Ù…Ø§Ù„ Ø´ÙˆØ¯ ',0),(237315,6593,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø§ÙŠÙ†ÙƒÙ‡ Ú†Ù‡ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¨Ù‡ Ù‡Ø± ÙƒØ§Ù„Ø§ Ø§Ø¹Ù…Ø§Ù„ Ø´ÙˆØ¯ ',0),(237316,6593,'tr','Vergi her Ã¶ÄŸe iÃ§in geÃ§erli olan seÃ§in',0),(237317,6593,'pl','Wybierz, ktÃ³re stosuje siÄ™ do kaÅ¼dej pozycji podatki',0),(237318,6593,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸ ÑÐµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°Ñ‚ ÐºÑŠÐ¼ Ð²ÑÐµÐºÐ¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(237319,6593,'ur','Ø¬Ùˆ ÛØ± Ø´Û’ Ú©Ùˆ Ù¹ÛŒÚ©Ø³ Ù„Ú¯Ø§Ø¦ÛŒÚº Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(237320,6593,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ¾Ñ˜Ðµ ÑÐµ Ð¿Ñ€Ð¸Ð¼ÐµÑšÑƒÑ˜Ñƒ Ð½Ð° ÑÐ²Ð°ÐºÑƒ ÑÑ‚Ð°Ð²ÐºÑƒ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(237321,6593,'vi','Chá»n thuáº¿ Ã¡p dá»¥ng cho tá»«ng hÃ ng',0),(237322,6593,'af','Kies Watter Belastings is van toepassing op Elke Item',0),(237323,6593,'ro','SelectaÅ£i care impozitele se aplicÄƒ fiecÄƒrui element',0),(237324,6593,'et','Valige igale kohaldatavate maksude',0),(237325,6593,'si','Izberite, kateri davki, ki se uporablja za vsak element',0),(237326,6593,'ba','Pilih mana pajak berlaku untuk setiap Item',0),(237327,6593,'nl','Selecteren welke belastingen van toepassing op elk Item',0),(237328,6593,'fi','Valitse, mitkÃ¤ verot sovelletaan jokaiseen',0),(237329,6593,'no','Velge hvilke avgifter gjelder for hvert element',0),(237330,6593,'da','VÃ¦lg, hvilken skatter gÃ¦lder for hver vare',0),(237331,6593,'ko','ì„¸ê¸ˆì€ ê° í•­ëª©ì— ì ìš©ì„ ì„ íƒí•©ë‹ˆë‹¤',0),(237332,6593,'he','×œ×‘×—×•×¨ ××™×–×” ×ž×™×¡×™× ×—×œ×™× ×¢×œ ×›×œ ×¤×¨×™×˜',0),(237333,6593,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€Î¿Ï… Ï„Î¿Ï…Ï‚ Ï†ÏŒÏÎ¿Ï…Ï‚ Ï€Î¿Ï… Î¹ÏƒÏ‡ÏÎ¿Ï…Î½ Î³Î¹Î± ÎºÎ¬Î¸Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(237334,6593,'zh','é€‰æ‹©å“ªäº›ç¨Žé€‚ç”¨äºŽæ¯ä¸ªé¡¹ç›®\r\n',0),(237335,6593,'sv','VÃ¤lj vilka skatter tillÃ¤mpas pÃ¥ varje objekt',0),(237336,6593,'it','Selezionare quale tasse si applicano a ogni elemento',0),(237337,6593,'tl','',0),(237338,6593,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3616;&#3634;&#3625;&#3637;&#3595;&#3638;&#3656;&#3591;&#3651;&#3594;&#3657;&#3585;&#3633;&#3610;&#3649;&#3605;&#3656;&#3621;&#3632;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(237339,6593,'hi','à¤œà¥‹ à¤•à¤°à¥‹à¤‚ à¤•à¥‹ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤†à¤‡à¤Ÿà¤® à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(237340,6593,'ms','Pilih mana cukai dikenakan untuk setiap Item',0),(237341,6593,'ar','Ø­Ø¯Ø¯ ÙÙŠÙ‡Ø§ ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø¹Ù„Ù‰ ÙƒÙ„ Ø¹Ù†ØµØ±',0),(237342,6593,'fr','SÃ©lectionner les Taxes s\'appliquent Ã  chaque Ã©lÃ©ment',0),(237343,6593,'jp','ç¨Žé‡‘ã‚’é©ç”¨ã™ã‚‹å„ã‚¢ã‚¤ãƒ†ãƒ ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(237344,6593,'pt','Selecione quais impostos se aplicam a cada Item',0),(237345,6593,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ, ÐºÐ°ÐºÐ¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¸ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ðº ÐºÐ°Ð¶Ð´Ð¾Ð¼Ñƒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñƒ',0),(237346,6593,'es','Seleccionar Cuales Impuestos Aplican A Cada item',0),(237347,6593,'de','WÃ¤hlen Sie die Steuern auf jedes Element anwenden',0),(237348,6593,'en','Select Which Taxes Apply To Each Item',0),(237349,6594,'is','',0),(237350,6594,'dr','Ù†Ù…Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙˆØ§Ø­Ø¯ Ùˆ  Ù…Ù‚Ø¯Ø§Ø± Ù‚ÙŠÙ…Øª',0),(237351,6594,'pr','Ù†Ù…Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙˆØ§Ø­Ø¯ Ùˆ  Ù…Ù‚Ø¯Ø§Ø± Ù‚ÙŠÙ…Øª',0),(237352,6594,'tr','GÃ¶steri birim fiyat ve fiyat miktar',0),(237353,6594,'pl','PokaÅ¼ ceny jednostkowej i ceny iloÅ›Ä‡',0),(237354,6594,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð•Ð´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð° Ð¸ Ñ†ÐµÐ½Ð° ÐºÐ¾Ð»',0),(237355,6594,'ur','Ø´Ùˆ Ú©Û’ ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø§ÙˆØ± Ù‚ÛŒÙ…Øª Ù‚ÛŒ',0),(237356,6594,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð° Ð¸ Ñ†ÐµÐ½Ð° ÐšÐ¾Ð».',0),(237357,6594,'vi','Hiá»ƒn thá»‹ Ä‘Æ¡n vá»‹ giÃ¡ & sá»‘ lÆ°á»£ng giÃ¡',0),(237358,6594,'af','Wys Eenheidsprys en Prys Hoev.',0),(237359,6594,'ro','AratÄƒ preÅ£ul unitar ÅŸi cantitate Pret',0),(237360,6594,'et','NÃ¤ita Ã¼hikuhind ja kogus hind',0),(237361,6594,'si','KaÅ¾ejo na enoto in cena kol.',0),(237362,6594,'ba','Tampilkan harga satuan dan harga Qty',0),(237363,6594,'nl','Toon prijs per eenheid en hoeveelheid van de prijs',0),(237364,6594,'fi','NÃ¤ytÃ¤ yksikkÃ¶hinnan ja hinta mÃ¤Ã¤rÃ¤',0),(237365,6594,'no','Vis enhetsprisen og pris Ant',0),(237366,6594,'da','Vis enhedspris og pris Qty',0),(237367,6594,'ko','í‘œì‹œ ë‹¨ìœ„ ê°€ê²© ë° ê°€ê²© ìˆ˜ëŸ‰',0),(237368,6594,'he','×”×¦×’ ×ž×—×™×¨ ×™×—×™×“×”, ×ž×—×™×¨ ×›×ž×•×ª',0),(237369,6594,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î¹Î¼Î® Î¼Î¿Î½Î¬Î´Î±Ï‚ ÎºÎ±Î¹ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï„Î¹Î¼Î®',0),(237370,6594,'zh','æ˜¾ç¤ºå•ä»·å’Œä»·æ ¼æ•°é‡\r\n',0),(237371,6594,'sv','Visa a-pris och pris antal',0),(237372,6594,'it','Visualizza prezzo unitario e prezzo Qty',0),(237373,6594,'tl','',0),(237374,6594,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3588;&#3634;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3649;&#3621;&#3632;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3619;&#3634;&#3588;&#3634;',0),(237375,6594,'hi','à¤¶à¥‹ à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤®à¥‚à¤²à¥à¤¯ à¤”à¤° à¤®à¥‚à¤²à¥à¤¯ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(237376,6594,'ms','Harga Unit Papar dan Qty harga',0),(237377,6594,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙˆØ­Ø¯Ø© Ø§Ù„Ø³Ø¹Ø± ÙˆØ§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø³Ø¹Ø±',0),(237378,6594,'fr','Prix unitaire de spectacle et prix QtÃ©',0),(237379,6594,'jp','ã‚·ãƒ§ãƒ¼ã®å˜ä¾¡ã¨ä¾¡æ ¼æ•°é‡',0),(237380,6594,'pt','Visualizar unidade preÃ§o e Qtde preÃ§o',0),(237381,6594,'ru','Ð¨Ð¾Ñƒ Ñ†ÐµÐ½Ð° Ð¸ ÐšÐ¾Ð»-Ð²Ð¾ Ð¦ÐµÐ½Ð°',0),(237382,6594,'es','Mostrar Precio de Unidad Y Precio de Cantidad',0),(237383,6594,'de','Karte-Einzelpreis und Preis Qty',0),(237384,6594,'en','Show Unit Price And Price Qty',0),(237385,6595,'is','',0),(237386,6595,'dr','Ù‚Ø§Ù„Ø¨ Ø³Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(237387,6595,'pr','Ù‚Ø§Ù„Ø¨ Ø³Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(237388,6595,'tr','BasitleÅŸtirilmiÅŸ biÃ§imi',0),(237389,6595,'pl','Uproszczony Format',0),(237390,6595,'bg','ÐžÐ¿Ñ€Ð¾ÑÑ‚ÐµÐ½ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(237391,6595,'ur','Ø³Ø§Ø¯Û ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(237392,6595,'sr','ÐŸÐ¾Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð¾Ð¼ Ð¾Ð±Ð»Ð¸ÐºÑƒ',0),(237393,6595,'vi','Dáº¡ng lÆ°á»£c giáº£n',0),(237394,6595,'af','Vereenvoudigde formaat',0),(237395,6595,'ro','Simplificat Format',0),(237396,6595,'et','Lihtsustatud kujul',0),(237397,6595,'si','Poenostavljeni obliki',0),(237398,6595,'ba','Format sederhana',0),(237399,6595,'nl','Vereenvoudigde vorm',0),(237400,6595,'fi','Yksinkertaistetussa muodossa',0),(237401,6595,'no','Forenklet Format',0),(237402,6595,'da','Forenklet Format',0),(237403,6595,'ko','ë‹¨ìˆœëœ í˜•ì‹',0),(237404,6595,'he','×ª×‘× ×™×ª ×¤×©×•×˜×”',0),(237405,6595,'el','Î‘Ï€Î»Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î· Î¼Î¿ÏÏ†Î®',0),(237406,6595,'zh','ç®€åŒ–æ ¼å¼\r\n',0),(237407,6595,'sv','FÃ¶renklat Format',0),(237408,6595,'it','Formato semplificato',0),(237409,6595,'tl','',0),(237410,6595,'th','&#3592;&#3633;&#3604;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3651;&#3627;&#3657;&#3591;&#3656;&#3634;&#3618;&#3586;&#3638;&#3657;&#3609;',0),(237411,6595,'hi','à¤¸à¤°à¤²à¥€à¤•à¥ƒà¤¤ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(237412,6595,'ms','Format ringkas',0),(237413,6595,'ar','Ø§Ù„Ø´ÙƒÙ„ Ø§Ù„Ù…Ø¨Ø³Ø·',0),(237414,6595,'fr','Format simplifiÃ©',0),(237415,6595,'jp','å˜ç´”åŒ–ã•ã‚ŒãŸå½¢å¼',0),(237416,6595,'pt','Formato simplificado',0),(237417,6595,'ru','Ð£Ð¿Ñ€Ð¾Ñ‰ÐµÐ½Ð½Ñ‹Ð¹ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(237418,6595,'es','Formato Simplificado',0),(237419,6595,'de','Vereinfachten Format',0),(237420,6595,'en','Simplified Format',0),(237421,6596,'is','',0),(237422,6596,'dr','Ù‚Ø§Ù„Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(237423,6596,'pr','Ù‚Ø§Ù„Ø¨ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(237424,6596,'tr','Standart biÃ§im',0),(237425,6596,'pl','Standardowy Format',0),(237426,6596,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(237427,6596,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(237428,6596,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(237429,6596,'vi','Dáº¡ng chuáº©n',0),(237430,6596,'af','Standaard Formaat',0),(237431,6596,'ro','Formatul standard',0),(237432,6596,'et','Vormikohase',0),(237433,6596,'si','Standardno obliko',0),(237434,6596,'ba','Format standar',0),(237435,6596,'nl','Standaardformaat',0),(237436,6596,'fi','Esitystapa',0),(237437,6596,'no','Standardformat',0),(237438,6596,'da','Standard Format',0),(237439,6596,'ko','í‘œì¤€ í˜•ì‹',0),(237440,6596,'he','×ª×‘× ×™×ª ×¡×˜× ×“×¨×˜×™×ª',0),(237441,6596,'el','Î¤Ï…Ï€Î¹ÎºÎ® Î¼Î¿ÏÏ†Î®',0),(237442,6596,'zh','æ ‡å‡†æ ¼å¼\r\n',0),(237443,6596,'sv','Standardformat',0),(237444,6596,'it','Formato standard',0),(237445,6596,'tl','',0),(237446,6596,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(237447,6596,'hi','à¤®à¤¾à¤¨à¤• à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª',0),(237448,6596,'ms','Standard Format',0),(237449,6596,'ar','ØªÙ†Ø³ÙŠÙ‚ Ù‚ÙŠØ§Ø³ÙŠ',0),(237450,6596,'fr','Format standard',0),(237451,6596,'jp','æ¨™æº–ã®æ›¸å¼æŒ‡å®š',0),(237452,6596,'pt','Formato padrÃ£o',0),(237453,6596,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(237454,6596,'es','Formato EstÃ¡ndar',0),(237455,6596,'de','Standardformat',0),(237456,6596,'en','Standard Format',0),(237457,6597,'is','',0),(237458,6597,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ú†Ù‡ ÙƒØ³ÙŠ',0),(237459,6597,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ú†Ù‡ ÙƒØ³ÙŠ',0),(237460,6597,'tr','Kim vergi',0),(237461,6597,'pl','Podatku, ktÃ³ry',0),(237462,6597,'bg','ÐšÐ¾Ð¹ Ð´Ð°Ð½ÑŠÐº',0),(237463,6597,'ur','Ø¬Ùˆ Ù¹ÛŒÚ©Ø³',0),(237464,6597,'sr','ÐŸÐ¾Ñ€ÐµÐ·Ð° ÐºÐ¾Ñ˜Ð¸',0),(237465,6597,'vi','ÄÃ¡nh Thuáº¿ ai',0),(237466,6597,'af','Belasting wat',0),(237467,6597,'ro','Fiscale care',0),(237468,6597,'et','KÃ¤ibemaks, kes',0),(237469,6597,'si','Davek, ki',0),(237470,6597,'ba','Pajak yang',0),(237471,6597,'nl','Belasting die',0),(237472,6597,'fi','Vero joka',0),(237473,6597,'no','Skatt som',0),(237474,6597,'da','Skat der',0),(237475,6597,'ko','ëˆ„ê°€ ì„¸ê¸ˆ',0),(237476,6597,'he','×ž×¡ ×ž×™',0),(237477,6597,'el','Î¦ÏŒÏÎ¿Ï… Ï€Î¿Ï…',0),(237478,6597,'zh','æ”¶è°çš„ç¨Ž\r\n',0),(237479,6597,'sv','Skatt som',0),(237480,6597,'it','Fiscali che',0),(237481,6597,'tl','',0),(237482,6597,'th','&#3616;&#3634;&#3625;&#3637;&#3586;&#3629;&#3591;&#3651;&#3588;&#3619;',0),(237483,6597,'hi','à¤œà¥‹ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(237484,6597,'ms','Cukai yang',0),(237485,6597,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø°ÙŠÙ†',0),(237486,6597,'fr','L\'impÃ´t qui',0),(237487,6597,'jp','ç¨Žã®äºº',0),(237488,6597,'pt','Fiscais que',0),(237489,6597,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ ÐºÑ‚Ð¾',0),(237490,6597,'es','Gravar Impuestos a Quien',0),(237491,6597,'de','Steuer, die',0),(237492,6597,'en','Tax Who',0),(237493,6598,'is','',0),(237494,6598,'dr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ù†Ø¨Ø§Ø± Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯',0),(237495,6598,'pr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ù†Ø¨Ø§Ø± Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯',0),(237496,6598,'tr','Yeniden stoklama Ã¼cretleri iÃ§in birim adÄ±',0),(237497,6598,'pl','Nazwa jednostki na Restock opÅ‚aty',0),(237498,6598,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð° Ð¿Ñ€ÐµÐ·Ð°Ð¿Ð°ÑÑÐ²Ð°Ð¼ Ñ‚Ð°ÐºÑÐ¸',0),(237499,6598,'ur','Ø±ÛŒØ³Ù¹ÙˆÚ© ÙÛŒØ³ Ú©Û’ Ù„Ø¦Û’ ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù…',0),(237500,6598,'sr','Ð˜Ð¼Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð·Ð° Ð¾Ð±Ð½Ð°Ð²Ñ™Ð°ÑšÐµ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ',0),(237501,6598,'vi','TÃªn ÄÆ¡n vá»‹ cho phÃ­ lÆ°u kho láº¡i',0),(237502,6598,'af','Eenheidsnaam Vir Hervoorraadopname Fooie',0),(237503,6598,'ro','Nume de unitatea pentru taxe de restocare',0),(237504,6598,'et','Ãœhiku nimi kaubatagastusmaksu tasud',0),(237505,6598,'si','Ime enote za stroÅ¡ke obnovitve zalog',0),(237506,6598,'ba','Nama unit biaya memperlengkapi',0),(237507,6598,'nl','Naam van de eenheid voor opnieuw bevoorraden vergoedingen',0),(237508,6598,'fi','YksikÃ¶n nimi tÃ¤ydentÃ¤Ã¤ lisÃ¤maksujen',0),(237509,6598,'no','Navn For Restock avgifter',0),(237510,6598,'da','Enhed navn For reklamationsgebyret gebyrer',0),(237511,6598,'ko','ìƒˆë¡œ ì‚¬ë“¤ ìˆ˜ìˆ˜ë£Œì— ëŒ€ í•œ ìž¥ì¹˜ ì´ë¦„',0),(237512,6598,'he','×©× ×™×—×™×“×” ×¢×‘×•×¨ ×“×ž×™ ×œ×ž×œ×',0),(237513,6598,'el','ÎŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î±Ï‚ Î³Î¹Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Ï„Î­Î»Î·',0),(237514,6598,'zh','è¿›è´§è´¹ç”¨å•ä½åç§°\r\n',0),(237515,6598,'sv','Enhetens namn fÃ¶r fÃ¶rnya avgifter',0),(237516,6598,'it','Nome dell\'unitÃ  per le spese di rifornimento scorte',0),(237517,6598,'tl','',0),(237518,6598,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3648;&#3626;&#3637;&#3618;&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3626;&#3605;&#3655;&#3629;&#3585;&#3651;&#3627;&#3617;&#3656;',0),(237519,6598,'hi','à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤¨à¤¾à¤® à¤«à¤¿à¤° à¤¸à¥‡ à¤‡à¤•à¤Ÿà¥à¤ à¤¾ à¤•à¤°à¤¨à¤¾ à¤¶à¥à¤²à¥à¤• à¤•à¥‡ à¤²à¤¿à¤',0),(237520,6598,'ms','Nama unit untuk Restock yuran',0),(237521,6598,'ar','Ø§Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø© Ù„Ø±Ø³ÙˆÙ… ØªØ®Ø²ÙŠÙ†',0),(237522,6598,'fr','Nom de l\'unitÃ© pour les frais de restockage',0),(237523,6598,'jp','å†å…¥è·æ‰‹æ•°æ–™ã®ãƒ¦ãƒ‹ãƒƒãƒˆå',0),(237524,6598,'pt','Nome da unidade para Restock taxas',0),(237525,6598,'ru','Ð˜Ð¼Ñ ÑƒÑÑ‚Ñ€Ð¾Ð¹ÑÑ‚Ð²Ð° Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ',0),(237526,6598,'es','Nombre de Unidad para Cuotas de Restock',0),(237527,6598,'de','GerÃ¤tename fÃ¼r Bestandserinnerung GebÃ¼hren',0),(237528,6598,'en','Unit Name For Restock Fees',0),(237529,6599,'is','',0),(237530,6599,'dr','Ø­Ø³Ø§Ø¨ Ù†ÙˆØ¹ Ø¨Ø¯Ù‡ÙŠ ',0),(237531,6599,'pr','Ø­Ø³Ø§Ø¨ Ù†ÙˆØ¹ Ø¨Ø¯Ù‡ÙŠ ',0),(237532,6599,'tr','YÃ¼kÃ¼mlÃ¼lÃ¼k tÃ¼rÃ¼ hesabÄ±',0),(237533,6599,'pl','OdpowiedzialnoÅ›Ä‡ typu konta',0),(237534,6599,'bg','ÐžÑ‚Ð³Ð¾Ð²Ð¾Ñ€Ð½Ð¾ÑÑ‚ Ñ‚Ð¸Ð¿ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(237535,6599,'ur','Ø°Ù…Û Ø¯Ø§Ø±ÛŒ Ù‚Ø³Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(237536,6599,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð¿Ð°ÑÐ¸Ð²Ðµ Ñ‚Ð¸Ð¿',0),(237537,6599,'vi','Loáº¡i TK CÃ´ng Ná»£',0),(237538,6599,'af','Laste Tipe Rekening',0),(237539,6599,'ro','Cont de tipul de rÄƒspundere',0),(237540,6599,'et','Kohustise liik konto',0),(237541,6599,'si','Vrsta konta obveznosti',0),(237542,6599,'ba','Kewajiban jenis rekening',0),(237543,6599,'nl','Aansprakelijkheid Type Account',0),(237544,6599,'fi','Tyyppi velkatili',0),(237545,6599,'no','Type gjeldskonto',0),(237546,6599,'da','Erstatningsansvar Type konto',0),(237547,6599,'ko','ì±…ìž„ ìœ í˜• ê³„ì •',0),(237548,6599,'he','×—×©×‘×•×Ÿ ×¡×•×’ ×‘××—×¨×™×•×ª',0),(237549,6599,'el','Î¤ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÎµÏ€Î¹Î²Î¬ÏÏ…Î½ÏƒÎ·Ï‚',0),(237550,6599,'zh','è´£ä»»ç±»åž‹çš„å¸æˆ·\r\n',0),(237551,6599,'sv','Typ skuldkonto',0),(237552,6599,'it','ResponsabilitÃ  tipo conto',0),(237553,6599,'tl','',0),(237554,6599,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3633;&#3597;&#3594;&#3637;&#3627;&#3609;&#3637;&#3657;&#3626;&#3636;&#3609;',0),(237555,6599,'hi','à¤¦à¥‡à¤¯à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤–à¤¾à¤¤à¥‡',0),(237556,6599,'ms','Akaun jenis liabiliti',0),(237557,6599,'ar','Ø­Ø³Ø§Ø¨ Ù†ÙˆØ¹ Ø§Ù„Ù…Ø³Ø¤ÙˆÙ„ÙŠØ©',0),(237558,6599,'fr','Compte de Type passif',0),(237559,6599,'jp','è² å‚µå‹˜å®šã‚¿ã‚¤ãƒ—',0),(237560,6599,'pt','Conta do tipo de responsabilidade',0),(237561,6599,'ru','Ð¡Ñ‡ÐµÑ‚ Ñ‚Ð¸Ð¿Ð° Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(237562,6599,'es','Tipo de Cuenta de ObligaciÃ³n',0),(237563,6599,'de','Typ Passivkonto',0),(237564,6599,'en','Liability Type Account',0),(237565,6600,'is','',0),(237566,6600,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯Ù‡Ø§ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯',0),(237567,6600,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯Ù‡Ø§ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯',0),(237568,6600,'tr','Eksikleri tamamlamak Ã¼cret',0),(237569,6600,'pl','Odnawiania opÅ‚aty',0),(237570,6600,'bg','ÐŸÑ€ÐµÐ·Ð°Ð¿Ð°ÑÑÐ²Ð°Ð¼ Ñ‚Ð°ÐºÑÐ¸',0),(237571,6600,'ur','ÙÛŒØ³ Ø±ÛŒØ³Ù¹ÙˆÚ©',0),(237572,6600,'sr','ÐŸÐ° Ð¾Ð½Ð´Ð° Ð¸Ð·Ð²Ð°Ð´Ð¸Ñ‚Ðµ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ',0),(237573,6600,'vi','PhÃ­ nháº­p láº¡i hÃ ng vÃ o kho',0),(237574,6600,'af','Restock gelde',0),(237575,6600,'ro','Repopula taxe',0),(237576,6600,'et','TÃ¤iendab tasu',0),(237577,6600,'si','Obnovo pristojbine',0),(237578,6600,'ba','Memperlengkapi biaya',0),(237579,6600,'nl','Voorraadbericht vergoedingen',0),(237580,6600,'fi','TÃ¤ydentÃ¤minen maksuja',0),(237581,6600,'no','Restock avgifter',0),(237582,6600,'da','GenpÃ¥fyldning gebyrer',0),(237583,6600,'ko','ìš”ê¸ˆ ìƒˆë¡œ ì‚¬ë“¤ì´ ë‹¤',0),(237584,6600,'he','×œ×ž×œ× ×¢×ž×œ×•×ª',0),(237585,6600,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ· Ï„Î­Î»Î·',0),(237586,6600,'zh','é‡æ–°è¿›è´§è´¹ç”¨\r\n',0),(237587,6600,'sv','FÃ¶rnya avgifter',0),(237588,6600,'it','Rifornire le tasse',0),(237589,6600,'tl','',0),(237590,6600,'th','&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3626;&#3605;&#3658;&#3629;&#3585;&#3651;&#3627;&#3617;&#3656;',0),(237591,6600,'hi','à¤«à¤¿à¤° à¤¸à¥‡ à¤‡à¤•à¤Ÿà¥à¤ à¤¾ à¤•à¤°à¤¨à¤¾ à¤¶à¥à¤²à¥à¤•',0),(237592,6600,'ms','Restock yuran',0),(237593,6600,'ar','Ø±Ø³ÙˆÙ… Ø¥Ø¹Ø§Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†',0),(237594,6600,'fr','Frais de rÃ©approvisionnement',0),(237595,6600,'jp','æ‰‹æ•°æ–™ã‚’å†å…¥è·ã—ã¾ã™ã€‚',0),(237596,6600,'pt','Reabastecer as taxas',0),(237597,6600,'ru','ÐŸÐ¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(237598,6600,'es','Tarifas de Reabastecer',0),(237599,6600,'de','AuffÃ¼llen von GebÃ¼hren',0),(237600,6600,'en','Restock Fees',0),(237601,6601,'is','',0),(237602,6601,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(237603,6601,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(237604,6601,'tr','MÃ¼ÅŸteri grubu ekleme',0),(237605,6601,'pl','DodaÄ‡ grupy klientÃ³w',0),(237606,6601,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(237607,6601,'ur','Ú©Ø³Ù¹Ù…Ø± Ú¯Ø±ÙˆÙ¾ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(237608,6601,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ðµ ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(237609,6601,'vi','ThÃªm NhÃ³m KhÃ¡ch hÃ ng',0),(237610,6601,'af','Voeg Klant / KliÃ«nt Groepe By',0),(237611,6601,'ro','Adauga grup de client',0),(237612,6601,'et','Lisa kliendigruppe',0),(237613,6601,'si','Dodajte skupine kupca',0),(237614,6601,'ba','Tambahkan kelompok pelanggan',0),(237615,6601,'nl','Klant groep toevoegen',0),(237616,6601,'fi','LisÃ¤Ã¤ asiakasryhmÃ¤',0),(237617,6601,'no','Legge til kundegruppe',0),(237618,6601,'da','TilfÃ¸je debitorgruppe',0),(237619,6601,'ko','ê³ ê° ê·¸ë£¹ ì¶”ê°€',0),(237620,6601,'he','×”×•×¡×£ ×§×‘×•×¦×ª ×œ×§×•×—×•×ª',0),(237621,6601,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ Î¿Î¼Î¬Î´Î± Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(237622,6601,'zh','æ–°å¢žå®¢æˆ·ç¾¤ä½“\r\n',0),(237623,6601,'sv','LÃ¤gg till kundgruppen',0),(237624,6601,'it','Aggiungere il gruppo di clienti',0),(237625,6601,'tl','',0),(237626,6601,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(237627,6601,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(237628,6601,'ms','Tambah Kumpulan pelanggan',0),(237629,6601,'ar','Ø¥Ø¶Ø§ÙØ© ÙØ¦Ø§Øª Ø²Ø¨Ø§Ø¦Ù†',0),(237630,6601,'fr','Ajouter groupe client',0),(237631,6601,'jp','é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(237632,6601,'pt','Adicionar grupo de cliente',0),(237633,6601,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(237634,6601,'es','Agregar Grupos de Clientes',0),(237635,6601,'de','Kundengruppe hinzufÃ¼gen',0),(237636,6601,'en','Add Customer Group',0),(237637,6602,'is','',0),(237638,6602,'dr','Ú¯Ø±ÙˆÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(237639,6602,'pr','Ú¯Ø±ÙˆÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(237640,6602,'tr','MÃ¼ÅŸteri grubu',0),(237641,6602,'pl','Grupy odbiorcÃ³w',0),(237642,6602,'bg','Ð“Ñ€ÑƒÐ¿Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(237643,6602,'ur','Ú©Ø³Ù¹Ù…Ø± Ú¯Ø±ÙˆÙ¾',0),(237644,6602,'sr','Ð“Ñ€ÑƒÐ¿Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(237645,6602,'vi','NhÃ³m KhÃ¡ch hÃ ng',0),(237646,6602,'af','Klant / KliÃ«nt Groep',0),(237647,6602,'ro','Grup de client',0),(237648,6602,'et','Kliendigrupp',0),(237649,6602,'si','Skupina strank',0),(237650,6602,'ba','Kelompok pelanggan',0),(237651,6602,'nl','Klantgroep',0),(237652,6602,'fi','AsiakasryhmÃ¤',0),(237653,6602,'no','Kundegruppe',0),(237654,6602,'da','Debitorgruppe',0),(237655,6602,'ko','ê³ ê° ê·¸ë£¹',0),(237656,6602,'he','×§×‘×•×¦×ª ×œ×œ×§×•×—',0),(237657,6602,'el','ÎŸÎ¼Î¬Î´Î± Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(237658,6602,'zh','å®¢æˆ·ç¾¤\r\n',0),(237659,6602,'sv','Kundgruppen',0),(237660,6602,'it','Gruppo di clienti',0),(237661,6602,'tl','',0),(237662,6602,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(237663,6602,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹',0),(237664,6602,'ms','Kumpulan pelanggan',0),(237665,6602,'ar','ÙØ¦Ø© Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(237666,6602,'fr','Groupe client',0),(237667,6602,'jp','é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—',0),(237668,6602,'pt','Grupo de clientes',0),(237669,6602,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(237670,6602,'es','Cliente Grupo',0),(237671,6602,'de','Kundengruppe',0),(237672,6602,'en','Customer Group',0),(237673,6603,'is','',0),(237674,6603,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(237675,6603,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(237676,6603,'tr','MÃ¼ÅŸteri Grubu DÃ¼zenle',0),(237677,6603,'pl','Edytuj grupy klientÃ³w',0),(237678,6603,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(237679,6603,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Ø³Ù¹Ù…Ø± Ú¯Ø±ÙˆÙ¾',0),(237680,6603,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(237681,6603,'vi','Cáº­p Nháº­t NhÃ³m KhÃ¡ch HÃ ng',0),(237682,6603,'af','Klant / KliÃ«nt Groepe Opdatering',0),(237683,6603,'ro','Grup de client editare',0),(237684,6603,'et','Kliendigruppide uuendamine',0),(237685,6603,'si','Uredi skupina kupca',0),(237686,6603,'ba','Edit kelompok pelanggan',0),(237687,6603,'nl','Klant groep bewerken',0),(237688,6603,'fi','Muokkaa asiakasryhmÃ¤',0),(237689,6603,'no','Rediger kundegruppe',0),(237690,6603,'da','Rediger kunde gruppe',0),(237691,6603,'ko','ê³ ê° ê·¸ë£¹ íŽ¸ì§‘',0),(237692,6603,'he','×§×‘×•×¦×ª ×”×œ×§×•×— ×¢×¨×™×›×”',0),(237693,6603,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¿Î¼Î¬Î´Î± Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(237694,6603,'zh','å®¢æˆ·ç¾¤ä½“æ›´æ–°\r\n',0),(237695,6603,'sv','Redigera kundgrupp',0),(237696,6603,'it','Modifica gruppo cliente',0),(237697,6603,'tl','',0),(237698,6603,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(237699,6603,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(237700,6603,'ms','Edit pelanggan Kumpulan',0),(237701,6603,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(237702,6603,'fr','Modifier un groupe client',0),(237703,6603,'jp','é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—ã®ç·¨é›†',0),(237704,6603,'pt','Editar grupo de cliente',0),(237705,6603,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(237706,6603,'es','Grupos de Clientes Actualizar',0),(237707,6603,'de','Kundengruppe bearbeiten',0),(237708,6603,'en','Edit Customer Group',0),(237709,6604,'is','',0),(237710,6604,'dr','ØªØ¹ÙŠÙŠÙ† Ù‚Ù„Ù…Ø±Ùˆ',0),(237711,6604,'pr','ØªØ¹ÙŠÙŠÙ† Ù‚Ù„Ù…Ø±Ùˆ',0),(237712,6604,'tr','BÃ¶lge ata',0),(237713,6604,'pl','Przypis.',0),(237714,6604,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÑ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ',0),(237715,6604,'ur','ØªÙÙˆÛŒØ¶ Ø¹Ù„Ø§Ù‚Û',0),(237716,6604,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ñ‚ÐµÑ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(237717,6604,'vi','Chá»‰ Äá»‹nh Khu Vá»±c',0),(237718,6604,'af','Opdra gebied',0),(237719,6604,'ro','Aloca pe teritoriul',0),(237720,6604,'et','MÃ¤Ã¤ra piirkond',0),(237721,6604,'si','Dodelitev obmoÄja',0),(237722,6604,'ba','Menetapkan wilayah',0),(237723,6604,'nl','Rayon toewijzen',0),(237724,6604,'fi','MÃ¤Ã¤ritÃ¤ alue',0),(237725,6604,'no','Tilordne territorium',0),(237726,6604,'da','Tildel omrÃ¥de',0),(237727,6604,'ko','í• ë‹¹ ì˜ì—­',0),(237728,6604,'he','×”×§×¦××ª ×©×˜×—',0),(237729,6604,'el','Î•ÎºÏ‡ÏŽÏÎ·ÏƒÎ· Î­Î´Î±Ï†Î¿Ï‚',0),(237730,6604,'zh','æŒ‡å®šé¢†åŸŸ\r\n',0),(237731,6604,'sv','Tilldela territorium',0),(237732,6604,'it','Territorio Assign',0),(237733,6604,'tl','',0),(237734,6604,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3629;&#3634;&#3603;&#3634;&#3648;&#3586;&#3605;',0),(237735,6604,'hi','à¤Ÿà¥‡à¤°à¥€à¤Ÿà¤°à¥€ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(237736,6604,'ms','Berikan Wilayah',0),(237737,6604,'ar','ØªØ¹ÙŠÙŠÙ† Ù…Ù†Ø·Ù‚Ø©',0),(237738,6604,'fr','Territoire de l\'ayant-droit',0),(237739,6604,'jp','æ‹…å½“åœ°åŸŸã®å‰²ã‚Šå½“ã¦',0),(237740,6604,'pt','TerritÃ³rio de atribuir',0),(237741,6604,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ñ‚ÐµÑ€Ñ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ð¸',0),(237742,6604,'es','Asignar Territorio',0),(237743,6604,'de','Assign-Gebiet',0),(237744,6604,'en','Assign Territory',0),(237745,6605,'is','',0),(237746,6605,'dr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(237747,6605,'pr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(237748,6605,'tr','GL hesap girdi yok',0),(237749,6605,'pl','Nie konta GL wszedÅ‚',0),(237750,6605,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ðµ GL',0),(237751,6605,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(237752,6605,'sr','ÐÐµÐ¼Ð° Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½ ÑƒÑˆÐ°Ð¾',0),(237753,6605,'vi','ChÆ°a Nháº­p TK Sá»• CÃ¡i Tá»•ng Há»£p',0),(237754,6605,'af','Geen AG Rekening Ingevoer',0),(237755,6605,'ro','Nici un cont de GL intrat',0),(237756,6605,'et','Pearaamatu kontot pole sisestatud',0),(237757,6605,'si','RaÄun ne GL, vstopil',0),(237758,6605,'ba','No akun GL masuk',0),(237759,6605,'nl','Geen GL Account ingevoerd',0),(237760,6605,'fi','GL huomioon tuli',0),(237761,6605,'no','Ingen GL konto angitt',0),(237762,6605,'da','Ingen GL konto indtastet',0),(237763,6605,'ko','ìž…ë ¥ í•œ GL ê³„ì • ì—†ìŒ',0),(237764,6605,'he','××™×Ÿ ×—×©×‘×•×Ÿ GL × ×›× ×¡×•',0),(237765,6605,'el','Î”ÎµÎ½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Ï€Î¿Ï… Ï„Î­Î¸Î·ÎºÎµ',0),(237766,6605,'zh','æ²¡æœ‰è¾“å…¥çš„æ€»å¸å¸æˆ·\r\n',0),(237767,6605,'sv','Ingen GL konto anges',0),(237768,6605,'it','Nessun Account GL entrato',0),(237769,6605,'tl','',0),(237770,6605,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3611;&#3657;&#3629;&#3609;',0),(237771,6605,'hi','à¤•à¥‹à¤ˆ GL à¤–à¤¾à¤¤à¥‡ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(237772,6605,'ms','Tiada akaun GL yang memasuki',0),(237773,6605,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø­Ø³Ø§Ø¨ GL Ø¯Ø®Ù„Øª',0),(237774,6605,'fr','Aucun compte GL entrÃ©',0),(237775,6605,'jp','å…¥åŠ›ã•ã‚ŒãŸ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(237776,6605,'pt','Nenhuma conta GL entrada',0),(237777,6605,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð½Ðµ GL Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»',0),(237778,6605,'es','No se entrÃ³ una cuenta LM',0),(237779,6605,'de','Kein Hauptbuchkonto eingegeben',0),(237780,6605,'en','No GL Account Entered',0),(237781,6606,'is','',0),(237782,6606,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(237783,6606,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(237784,6606,'tr','Kredi kartÄ± iÅŸlem kurulumu',0),(237785,6606,'pl','Ustawienia karty kredytowej przetwarzania',0),(237786,6606,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(237787,6606,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ø³ÛŒÙ¹ Ø§Ù¾',0),(237788,6606,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð¾Ð±Ñ€Ð°Ð´Ð° ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(237789,6606,'vi','Setup Xá»­ LÃ½ Tháº» TÃ­n Dá»¥ng',0),(237790,6606,'af','Kredietkaart Proseserings Opstelling',0),(237791,6606,'ro','Setup de prelucrare a cardului de credit',0),(237792,6606,'et','Krediitkaart tÃ¶Ã¶tlemine seadistamine',0),(237793,6606,'si','Kreditne kartice za obdelavo Setup',0),(237794,6606,'ba','Setup pemrosesan kartu kredit',0),(237795,6606,'nl','Credit Card Processing Setup',0),(237796,6606,'fi','Credit Card Processing asetukset',0),(237797,6606,'no','Kredittkortbehandling oppsett',0),(237798,6606,'da','OpsÃ¦tning af kreditkort forarbejdning',0),(237799,6606,'ko','ì‹ ìš© ì¹´ë“œ ì²˜ë¦¬ ì„¤ì •',0),(237800,6606,'he','×¢×™×‘×•×“ ×›×¨×˜×™×¡ ×”××©×¨××™ ×ª×•×›× ×™×ª ×”×”×ª×§× ×”',0),(237801,6606,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(237802,6606,'zh','ä¿¡ç”¨å¡å¤„ç†è®¾ç½®\r\n',0),(237803,6606,'sv','Kreditkort bearbetning Setup',0),(237804,6606,'it','Installazione di elaborazione della carta di credito',0),(237805,6606,'tl','',0),(237806,6606,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(237807,6606,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(237808,6606,'ms','Persediaan pemprosesan kad kredit',0),(237809,6606,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ØªØ¬Ù‡ÙŠØ²',0),(237810,6606,'fr','Installation de traitement des cartes de crÃ©dit',0),(237811,6606,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®å‡¦ç†ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(237812,6606,'pt','InstalaÃ§Ã£o de processamento de cartÃ£o de crÃ©dito',0),(237813,6606,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÐžÐ±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐšÐ°Ñ€Ñ‚',0),(237814,6606,'es','Tarjeta de CrÃ©dito Procedimiento de ConfiguraciÃ³n',0),(237815,6606,'de','Credit Card Processing-Setup',0),(237816,6606,'en','Credit Card Processing Setup',0),(237817,6607,'is','',0),(237818,6607,'dr','(Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) Ø¨Ø± Ø¬Ù‡Øª Ø¨Ø±Ù‚Ø³Ù…Øª',0),(237819,6607,'pr','Ù…Ù‚Ø¯Ø§Ø±  Ø¨Ø± Ø¯Ù‚ÙŠÙ‚Ù‡ (Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) Ø¨Ø± Ø¬Ù‡Øª Ø¨Ø±Ù‚Ø³Ù…Øª',0),(237820,6607,'tr','M yan baÅŸÄ±na bÃ¶lÃ¼m baÅŸÄ±na baÅŸÄ±na miktar',0),(237821,6607,'pl','Kwota M po kaÅ¼dej stronie na czÄ™Å›ci',0),(237822,6607,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ðœ Ð²ÑÑÐºÐ° ÑÑ‚Ñ€Ð°Ð½Ð° Ð½Ð° Ñ‡Ð°ÑÑ‚',0),(237823,6607,'ur','Ø±Ù‚Ù… M Ø­ØµÛ ÙÛŒ Ø·Ø±Ù ÙÛŒ ÙÛŒ',0),(237824,6607,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾ Ðœ Ð½Ð° Ñ˜ÐµÐ´Ð½Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸ Ð¿Ð¾ ÑÐµÐ³Ð¼ÐµÐ½Ñ‚Ð¸Ð¼Ð°',0),(237825,6607,'vi','Sá»‘ Tiá»n má»™t M má»™t Máº·t má»™t Pháº§n',0),(237826,6607,'af','Bedrag per M per Kant per Onderdeel',0),(237827,6607,'ro','Suma per M pe fiecare parte pe o parte',0),(237828,6607,'et','M kummalgi kÃ¼ljel Ã¼he osa kohta',0),(237829,6607,'si','Znesek na M na vsaki strani na del',0),(237830,6607,'ba','Jumlah per M per sisi per bagian',0),(237831,6607,'nl','Bedrag per M per kant per deel',0),(237832,6607,'fi','Kohden metriÃ¤ per osa',0),(237833,6607,'no','BelÃ¸p per M per Side per del',0),(237834,6607,'da','BelÃ¸b pr. M pr. Side pr. del',0),(237835,6607,'ko','ì¸¡ë©´ ë¶€ë¶„ ë‹¹ ë‹¹ M ë‹¹ ê¸ˆì•¡',0),(237836,6607,'he','×¡×›×•× ×œ×¤×™ ×– ×‘×›×œ ×¦×“ ×œ×›×œ ×—×œ×§',0),(237837,6607,'el','Î Î¿ÏƒÏŒ Î±Î½Î¬ M Î±Î½Î¬ Ï€Î»ÎµÏ…ÏÎ¬ Î±Î½Î¬ Î¼Î­ÏÎ¿Ï‚',0),(237838,6607,'zh','é‡‘é¢/æœˆ/è¾¹/éƒ¨åˆ†\r\n',0),(237839,6607,'sv','Belopp per M per sida per del',0),(237840,6607,'it','Importo per M per lato per ogni parte',0),(237841,6607,'tl','',0),(237842,6607,'th','&#3592;&#3635;&#3609;&#3623;&#3609;/M/&#3604;&#3657;&#3634;&#3609;/&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(237843,6607,'hi','à¤­à¤¾à¤— à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¤•à¥à¤· à¤ªà¥à¤°à¤¤à¤¿ à¤®à¥€à¤Ÿà¤° à¤ªà¥à¤°à¤¤à¤¿ à¤°à¤¾à¤¶à¤¿',0),(237844,6607,'ms','Jumlah satu M setiap sisi setiap bahagian',0),(237845,6607,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù„ÙƒÙ„ Ù…ØªØ± Ù…ÙƒØ¹Ø¨ ÙÙŠ Ø§Ù„Ø¬Ø§Ù†Ø¨ Ø§Ù„ÙˆØ§Ø­Ø¯ Ø¬Ø²Ø¡',0),(237846,6607,'fr','Montant par M de chaque cÃ´tÃ© par partie',0),(237847,6607,'jp','éƒ¨å“ 1 å€‹ã‚ãŸã‚Š 1 M ã‚ãŸã‚Šã®é‡‘é¡',0),(237848,6607,'pt','Quantidade por M cada lado por parte',0),(237849,6607,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð° Ðœ Ð² ÐºÐ°Ð¶Ð´ÑƒÑŽ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñƒ Ð·Ð° Ñ‡Ð°ÑÑ‚ÑŒ',0),(237850,6607,'es','Cantidad por M por Lado por Parte',0),(237851,6607,'de','Betrag pro M SeitenlÃ¤nge pro Teil',0),(237852,6607,'en','Amount per M per Side per Part',0),(237853,6608,'is','',0),(237854,6608,'dr','Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(237855,6608,'pr','Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(237856,6608,'tr','Mali baÅŸlangÄ±Ã§ ay baÅŸarÄ±yla deÄŸiÅŸtirildi',0),(237857,6608,'pl','MiesiÄ…c obrachunkowy zmieniÅ‚ pomyÅ›lnie',0),(237858,6608,'bg','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð¸ ÐÐ°Ñ‡Ð°Ð»ÐµÐ½ Ð¼ÐµÑÐµÑ† Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(237859,6608,'ur','Ù…Ø§Ù„ÛŒ Ø´Ø±ÙˆØ¹ Ù…ÛÛŒÙ†Û Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(237860,6608,'sr','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð¸ Ð¿Ð¾Ñ‡ÐµÑ‚Ð°Ðº Ð¼ÐµÑÐµÑ†Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½',0),(237861,6608,'vi','Thay thÃ¡ng báº¯t Ä‘áº§u nÄƒm tÃ i chÃ­nh thÃ nh cÃ´ng',0),(237862,6608,'af','Fisiese Aanvangsmaand is Suksesvol Verander',0),(237863,6608,'ro','Fiscale Ã®ncepe luna schimbat cu succes',0),(237864,6608,'et','Muudetud eelarve alguskuu',0),(237865,6608,'si','ZaÄetni poslovni mesec uspeÅ¡no',0),(237866,6608,'ba','Fiskal awal bulan berhasil diubah',0),(237867,6608,'nl','Fiscale Start maand met succes gewijzigd',0),(237868,6608,'fi','Tilikauden alkamiskuukausi muutettu',0),(237869,6608,'no','StartmÃ¥ned for endret',0),(237870,6608,'da','Finanspolitiske Start mÃ¥ned skiftede med succes',0),(237871,6608,'ko','íšŒê³„ ì—°ë„ ì‹œìž‘ ë‹¬ ì„±ê³µì ìœ¼ë¡œ ë³€ê²½',0),(237872,6608,'he','×—×•×“×© ×”×ª×—×œ×” ×”×›×¡×¤×™× ×”×©×ª× ×” ×‘×”×¦×œ×—×”',0),(237873,6608,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Î±ÏÏ‡Î® Î¼Î®Î½Î± Î¬Î»Î»Î±Î¾Îµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(237874,6608,'zh','è´¢æ”¿å¼€å§‹æœˆä»½æˆåŠŸæ›´æ”¹\r\n',0),(237875,6608,'sv','RÃ¤kenskapsÃ¥rets startmÃ¥nad Ã¤ndrade framgÃ¥ngsrikt',0),(237876,6608,'it','Fiscale inizio mese cambiato con successo',0),(237877,6608,'tl','',0),(237878,6608,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3607;&#3634;&#3591;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;&#3626;&#3635;&#3648;&#3',0),(237879,6608,'hi','à¤°à¤¾à¤œà¤•à¥‹à¤·à¥€à¤¯ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤®à¤¾à¤¹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¦à¤² à¤—à¤¯à¤¾',0),(237880,6608,'ms','Bulan mula fiskal yang berjaya diubah',0),(237881,6608,'ar','ØºÙŠÙ‘Ø± Ø´Ù‡Ø± Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(237882,6608,'fr','Fiscale dÃ©but mois changÃ© avec succÃ¨s',0),(237883,6608,'jp','æ­£å¸¸ã«å¤‰æ›´ã•ã‚ŒãŸå¹´åº¦ã®é–‹å§‹æœˆ',0),(237884,6608,'pt','MÃªs de inÃ­cio fiscal alterado com sucesso',0),(237885,6608,'ru','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ ÑÑ‚Ð°Ñ€Ñ‚ Ð¼ÐµÑÑÑ† ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½',0),(237886,6608,'es','Mes de Inicio Fiscal Cambiado Exitosamente',0),(237887,6608,'de','Steuerliche Startmonat erfolgreich geÃ¤ndert',0),(237888,6608,'en','Fiscal Start Month Changed Successfully',0),(237889,6609,'is','',0),(237890,6609,'dr','ØªÙ†Ø¸ÙŠÙ… Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ ',0),(237891,6609,'pr','ØªÙ†Ø¸ÙŠÙ… Ù…Ø§Ù‡ Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ ',0),(237892,6609,'tr','Mali baÅŸlangÄ±Ã§ ayÄ±nÄ± ayarlama',0),(237893,6609,'pl','UstawiÄ‡ miesiÄ…c obrachunkowy',0),(237894,6609,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð¾ ÐÐ°Ñ‡Ð°Ð»ÐµÐ½ Ð¼ÐµÑÐµÑ†',0),(237895,6609,'ur','Ù…Ø§Ù„ÛŒ Ø´Ø±ÙˆØ¹ Ù…ÛÛŒÙ†Û Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(237896,6609,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð¸ Ð¿Ð¾Ñ‡ÐµÑ‚Ð°Ðº Ð¼ÐµÑÐµÑ†Ð°',0),(237897,6609,'vi','Äáº·t thÃ¡ng báº¯t Ä‘áº§u tÃ i chÃ­nh',0),(237898,6609,'af','Stel Fisiese Begin Maand',0),(237899,6609,'ro','Set Start fiscale luna',0),(237900,6609,'et','MÃ¤Ã¤rata eelarve alguskuu',0),(237901,6609,'si','Nastavite zaÄetni poslovni mesec',0),(237902,6609,'ba','Mengatur fiskal awal bulan',0),(237903,6609,'nl','Fiscale Start maand instellen',0),(237904,6609,'fi','MÃ¤Ã¤ritÃ¤ tilikauden alkamiskuukausi',0),(237905,6609,'no','Angi StartmÃ¥ned',0),(237906,6609,'da','SÃ¦t finanspolitiske Start mÃ¥ned',0),(237907,6609,'ko','íšŒê³„ ì‹œìž‘ ì›” ì„¤ì •',0),(237908,6609,'he','×¢×¨×›×ª ×”×ª×—×œ×” ×”×›×¡×¤×™× ×‘×—×•×“×©',0),(237909,6609,'el','ÎˆÎ½Î±ÏÎ¾Î· ÏƒÏÎ½Î¿Î»Î¿ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½ Î¼Î®Î½Î±',0),(237910,6609,'zh','è®¾ç½®è´¢æ”¿å¼€å§‹æœˆä»½\r\n',0),(237911,6609,'sv','Ange rÃ¤kenskapsÃ¥rets startmÃ¥nad',0),(237912,6609,'it','Impostare inizio fiscale mese',0),(237913,6609,'tl','',0),(237914,6609,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3604;&#3639;&#3629;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3586;&#3629;&#3591;&#3611;&#3637;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(237915,6609,'hi','à¤°à¤¾à¤œà¤•à¥‹à¤·à¥€à¤¯ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤®à¤¾à¤¹ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(237916,6609,'ms','Menetapkan bulan mula fiskal',0),(237917,6609,'ar','ØªØ­Ø¯ÙŠØ¯ Ø£ÙˆÙ„ Ø´Ù‡Ø± ÙÙŠ  Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(237918,6609,'fr','DÃ©finition fiscale du premier mois',0),(237919,6609,'jp','å¹´åº¦ã®é–‹å§‹æœˆã‚’è¨­å®šã—ã¾ã™ã€‚',0),(237920,6609,'pt','Conjunto Fiscal iniciar mÃªs',0),(237921,6609,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ñ„Ð¸ÑÐºÐ°Ð»ÑŒÐ½Ñ‹Ñ… Ð½Ð°Ñ‡Ð°Ð»Ð¾ Ð¼ÐµÑÑÑ†Ð°',0),(237922,6609,'es','Configurar Mes Inicial del Ejercicio Fiscal',0),(237923,6609,'de','Steuerliche Startmonat festlegen',0),(237924,6609,'en','Set Fiscal Start Month',0),(237925,6610,'is','',0),(237926,6610,'dr','Ø«Ø¨Øª Ù‚ÙŠÙ…Øª  ÙŠØ§ Ù…Ù‚Ø¯Ø§ Ø± ÙØ±ÙˆØ´  Ùˆ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø¯ÙŠÚ¯Ø± ',0),(237927,6610,'pr','Ø«Ø¨Øª Ù‚ÙŠÙ…Øª  ÙŠØ§ Ù…Ù‚Ø¯Ø§ Ø± ÙØ±ÙˆØ´  Ùˆ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø¯ÙŠÚ¯Ø± ',0),(237928,6610,'tr','Fiyat girin veya satmak miktar ve diÄŸer hesaplar',0),(237929,6610,'pl','Podaj cenÄ™ sprzedaÄ‡ iloÅ›ci lub obliczyÄ‡ inne',0),(237930,6610,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ†ÐµÐ½Ð° Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð´Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¸ ÑÐµ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð° Ð´Ñ€ÑƒÐ³Ð¸',0),(237931,6610,'ur','Ù‚ÛŒÙ…Øª Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº ÛŒØ§ ÙØ±ÙˆØ®Øª Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ø§ÙˆØ± Ø¯ÙˆØ³Ø±Û’ Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(237932,6610,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ñ†ÐµÐ½Ñƒ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ‚Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¸ Ð´Ñ€ÑƒÐ³Ðµ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚Ðµ',0),(237933,6610,'vi','Nháº­p giÃ¡ hay sá»‘ lÆ°á»£ng bÃ¡n & tÃ­nh toÃ¡n khÃ¡c',0),(237934,6610,'af','Voer Prys of Verkoopshoeveelheid in en Bereken Ander',0),(237935,6610,'ro','IntroduceÅ£i preÅ£ul sau vinde cantitatea È™i se calculeazÄƒ alte',0),(237936,6610,'et','Sisestage hinna vÃµi koguse mÃ¼Ã¼miseks ja arvutada teiste',0),(237937,6610,'si','Vnesite ceno ali proda koliÄino in izraÄun drugih',0),(237938,6610,'ba','Masukkan harga atau menjual kuantitas dan menghitung lain',0),(237939,6610,'nl','Voer prijs of verkoophoeveelheid en andere berekenen',0),(237940,6610,'fi','SyÃ¶tÃ¤ hinta tai myydÃ¤ mÃ¤Ã¤rÃ¤ ja Laske muut',0),(237941,6610,'no','Angi pris eller selge antallet og beregne andre',0),(237942,6610,'da','Angiv prisen eller sÃ¦lge mÃ¦ngde og beregne andre',0),(237943,6610,'ko','ìž…ë ¥ í•˜ëŠ” ê°€ê²© ë˜ëŠ” ìˆ˜ëŸ‰ì„ íŒë§¤ í•˜ ê³  ë‹¤ë¥¸ ê³„ì‚°',0),(237944,6610,'he','×”×–×Ÿ ×ž×—×™×¨ ××• ×œ×ž×›×•×¨ ×›×ž×•×ª ×•×œ×—×©×‘ ××ª ×”×©× ×™',0),(237945,6610,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î¹Î¼Î® Î® Ï€Ï‰Î»Î¿ÏÎ½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎºÎ±Î¹ Ï…Ï€Î¿Î»Î¿Î³Î¹',0),(237946,6610,'zh','è¾“å…¥ä»·æ ¼æˆ–é”€å”®æ•°é‡å¹¶è®¡ç®—å…¶ä»–\r\n',0),(237947,6610,'sv','Ange pris eller sÃ¤lja kvantitet och berÃ¤kna andra',0),(237948,6610,'it','Inserire prezzo o vendere quantitÃ  e calcolare altri',0),(237949,6610,'tl','',0),(237950,6610,'th','&#3611;&#3657;&#3629;&#3609;&#3619;&#3634;&#3588;&#3634;&#3627;&#3619;&#3639;&#3629;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3634;&#3618;&#3649;&#3621;&#3632;&#3588;&#3635;&#3609;&#3623;&#3603;&#3626;&#3656;&#3623;&#3609;&#3605;&#3656;&#3634;&#3',0),(237951,6610,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‹ à¤¬à¥‡à¤šà¤¨à¥‡ à¤”à¤° à¤¦à¥‚à¤¸à¤°à¥‡ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(237952,6610,'ms','Masukkan harga atau menjual kuantiti dan mengira lain',0),(237953,6610,'ar','Ø£Ø¯Ø®Ù„ Ø³Ø¹Ø± Ø£Ùˆ Ø¨ÙŠØ¹ Ø§Ù„ÙƒÙ…ÙŠØ© ÙˆØ­Ø³Ø§Ø¨ Ø¢Ø®Ø±',0),(237954,6610,'fr','Entrez le prix ou vendre quantitÃ© et calculer lâ€™autre',0),(237955,6610,'jp','ä¾¡æ ¼ã‚’å…¥åŠ›ã—ã¦è²©å£²æ•°é‡ã‚„ãã®ä»–ã®è¨ˆç®—',0),(237956,6610,'pt','Digite o preÃ§o ou vender quantidade e calcular outros',0),(237957,6610,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ñƒ Ð¸Ð»Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ð¸ Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð´Ñ€ÑƒÐ³Ð¸Ðµ',0),(237958,6610,'es','Introducir Precio o Cantidad de Venta y Calcular Otro',0),(237959,6610,'de','Geben Sie Preis oder Menge verkaufen und andere berechnen',0),(237960,6610,'en','Enter Price or Sell Quantity and Calculate Other',0),(237961,6611,'is','',0),(237962,6611,'dr','Ø«Ø¨Øª Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´  Ø§Ù…Ø§ Ù†Ù…Ø§ÙŠØ´ Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´',0),(237963,6611,'pr','Ø«Ø¨Øª Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´  Ø§Ù…Ø§ Ù†Ù…Ø§ÙŠØ´ Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´',0),(237964,6611,'tr','Ama gÃ¶rÃ¼ntÃ¼ SatÄ±yoruz miktar Fiyat miktarÄ± girin',0),(237965,6611,'pl','WprowadÅº iloÅ›Ä‡ cena ale iloÅ›Ä‡ sprzedajÄ… wyÅ›wietlacz',0),(237966,6611,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° Ñ†ÐµÐ½Ð° Ð½Ð¾ Ð´Ð¸ÑÐ¿Ð»ÐµÑ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(237967,6611,'ur','ÚˆØ³Ù¾Ù„Û’ Ø¨ÛŒÚ†ÛŒÚº Ù…Ù‚Ø¯Ø§Ø± Ù„ÛŒÚ©Ù† Ù‚ÛŒÙ…Øª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(237968,6611,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ Ñ†ÐµÐ½Ñƒ Ð°Ð»Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð· ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(237969,6611,'vi','Nháº­p sá»‘ lÆ°á»£ng giÃ¡ nhÆ°ng hiá»ƒn thá»‹ sá»‘ lÆ°á»£ng bÃ¡n',0),(237970,6611,'af','Voer Prys Hoeveelheid in maar Wys Verkoopshoeveelheid',0),(237971,6611,'ro','IntroduceÅ£i cantitate pret dar cantitatea de Vindem Display',0),(237972,6611,'et','Hind kogus aga ekraan mÃ¼Ã¼a kogus',0),(237973,6611,'si','Vnesite koliÄino ceno ampak prikaz prodaja koliÄina',0),(237974,6611,'ba','Masukkan jumlah harga tetapi kuantitas Jual tampilan',0),(237975,6611,'nl','Voer aantal in prijs maar Display verkopen hoeveelheid',0),(237976,6611,'fi','Hinta mÃ¤Ã¤rÃ¤ mutta nÃ¤yttÃ¶ myydÃ¤ mÃ¤Ã¤rÃ¤',0),(237977,6611,'no','Angi pris men skjermen selge antall',0),(237978,6611,'da','Angiv pris mÃ¦ngde men Display sÃ¦lge mÃ¦ngde',0),(237979,6611,'ko','í•˜ì§€ë§Œ ë””ìŠ¤í”Œë ˆì´ íŒë§¤ ìˆ˜ëŸ‰ ê°€ê²© ìˆ˜ëŸ‰ ìž…ë ¥',0),(237980,6611,'he','×”×–×Ÿ ×›×ž×•×ª ×ž×—×™×¨ ××‘×œ ×”×ª×¦×•×’×” ×œ×ž×›×•×¨ ×›×ž×•×ª',0),(237981,6611,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï„Î¹Î¼Î® Î±Î»Î»Î¬ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Ï‰Î»Î¿ÏÎ½ Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·',0),(237982,6611,'zh','è¾“å…¥ä»·æ ¼æ•°é‡ï¼Œä½†æ˜¾ç¤ºé”€å”®æ•°é‡',0),(237983,6611,'sv','Ange pris kvantitet men displayen sÃ¤lja kvantiteten',0),(237984,6611,'it','Immettere la quantitÃ  di prezzo ma Display vendere quantitÃ ',0),(237985,6611,'tl','',0),(237986,6611,'th','&#3611;&#3657;&#3629;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3619;&#3634;&#3588;&#3634;&#3649;&#3605;&#3656;&#3649;&#3626;&#3604;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3634;&#3618;',0),(237987,6611,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤¬à¥‡à¤šà¥‡à¤‚ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤²à¥‡à¤•à¤¿à¤¨ à¤®à¥‚à¤²à¥à¤¯ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(237988,6611,'ms','Masukkan kuantiti harga tetapi paparan jual kuantiti',0),(237989,6611,'ar','Ø£Ø¯Ø®Ù„ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø³Ø¹Ø± Ù„ÙƒÙ† Ø¹Ø±Ø¶ Ø¨ÙŠØ¹ ÙƒÙ…ÙŠØ©',0),(237990,6611,'fr','Entrer la quantitÃ© de prix mais affichage vendre quantitÃ©',0),(237991,6611,'jp','ãƒ‡ã‚£ã‚¹ãƒ—ãƒ¬ã‚¤è²©å£²æ•°é‡ã€ä¾¡æ ¼æ•°é‡ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(237992,6611,'pt','Digite quantidade de preÃ§o, mas a quantidade de venda de Display',0),(237993,6611,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ†ÐµÐ½Ð° Ð½Ð¾ Ð´Ð¸ÑÐ¿Ð»ÐµÐ¹ Ð¿Ñ€Ð¾Ð´Ð°Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(237994,6611,'es','Introducir Cantidad de Precio pero Desplega la Cantidad de Venta',0),(237995,6611,'de','Geben Sie Preis Menge aber Anzeige verkaufen QuantitÃ¤t',0),(237996,6611,'en','Enter Price Quantity but Display Sell Quantity',0),(237997,6612,'is','',0),(237998,6612,'dr','Ø«Ø¨Øª Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´  ÙÙ‚Ø· ',0),(237999,6612,'pr','Ø«Ø¨Øª Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´  ÙÙ‚Ø· ',0),(238000,6612,'tr','Fiyat miktarÄ± sadece girin',0),(238001,6612,'pl','WprowadÅº iloÅ›Ä‡ cena tylko',0),(238002,6612,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° Ñ†ÐµÐ½Ð° ÑÐ°Ð¼Ð¾',0),(238003,6612,'ur','ØµØ±Ù Ù‚ÛŒÙ…Øª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(238004,6612,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ñ†ÐµÐ½Ñƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑÐ°Ð¼Ð¾',0),(238005,6612,'vi','Chá»‰ Nháº­p sá»‘ lÆ°á»£ng giÃ¡ ',0),(238006,6612,'af','Voer prys hoeveelheid slegs',0),(238007,6612,'ro','IntroduceÅ£i cantitate preÅ£ numai',0),(238008,6612,'et','Hind kogus ainult',0),(238009,6612,'si','Vnesete ceno koliÄino le',0),(238010,6612,'ba','Masukkan jumlah harga',0),(238011,6612,'nl','Voer aantal in prijs alleen',0),(238012,6612,'fi','Anna hinta-mÃ¤Ã¤rÃ¤',0),(238013,6612,'no','Angi pris bare',0),(238014,6612,'da','Angiv antal, pris kun',0),(238015,6612,'ko','ê°€ê²© ìˆ˜ëŸ‰ë§Œ ìž…ë ¥',0),(238016,6612,'he','×”×–×Ÿ ×›×ž×•×ª ×ž×—×™×¨ ×‘×œ×‘×“',0),(238017,6612,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï„Î¹Î¼Î® Î¼ÏŒÎ½Î¿',0),(238018,6612,'zh','åªè¾“å…¥ä»·æ ¼æ•°é‡',0),(238019,6612,'sv','Ange pris kvantitet endast',0),(238020,6612,'it','Inserire prezzo quantitÃ  solo',0),(238021,6612,'tl','',0),(238022,6612,'th','&#3611;&#3657;&#3629;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3619;&#3634;&#3588;&#3634;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(238023,6612,'hi','à¤•à¥‡à¤µà¤² à¤®à¥‚à¤²à¥à¤¯ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(238024,6612,'ms','Masukkan kuantiti harga sahaja',0),(238025,6612,'ar','Ø£Ø¯Ø®Ù„ Ø³Ø¹Ø± Ø§Ù„ÙƒÙ…ÙŠØ© ÙÙ‚Ø·',0),(238026,6612,'fr','Entrer la quantitÃ© de prix seulement',0),(238027,6612,'jp','ä¾¡æ ¼æ•°é‡ã®ã¿ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(238028,6612,'pt','Digite a quantidade de preÃ§o apenas',0),(238029,6612,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ†ÐµÐ½Ð° Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(238030,6612,'es','Introducir Cantidad de Precio Solamente',0),(238031,6612,'de','Geben Sie nur die Menge Preis',0),(238032,6612,'en','Enter Price Quantity Only',0),(238033,6613,'is','',0),(238034,6613,'dr','Ø«Ø¨Øª Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ø§Ù…Ø§ Ù†Ù…Ø§ÙŠØ´ Ù…Ù‚Ø¯Ø§Ø± Ù‚ÙŠÙ…Øª ',0),(238035,6613,'pr','Ø«Ø¨Øª Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ø§Ù…Ø§ Ù†Ù…Ø§ÙŠØ´ Ù…Ù‚Ø¯Ø§Ø± Ù‚ÙŠÙ…Øª ',0),(238036,6613,'tr','Ama gÃ¶rÃ¼ntÃ¼ fiyat miktar satÄ±ÅŸ miktarÄ± girin',0),(238037,6613,'pl','WprowadÅº iloÅ›Ä‡ sprzedajÄ…, ale wyÅ›wietlacz cena iloÅ›Ä‡',0),(238038,6613,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð¾ Ð´Ð¸ÑÐ¿Ð»ÐµÑ Ñ†ÐµÐ½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(238039,6613,'ur','ÚˆØ³Ù¾Ù„Û’ Ù‚ÛŒÙ…Øª Ù…Ù‚Ø¯Ø§Ø± Ù„ÛŒÚ©Ù† ÙØ±ÙˆØ®Øª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(238040,6613,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°Ð»Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð· Ñ†ÐµÐ½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(238041,6613,'vi','Nháº­p sá»‘ lÆ°á»£ng bÃ¡n nhÆ°ng hiá»ƒn thá»‹ sá»‘ lÆ°á»£ng giÃ¡',0),(238042,6613,'af','Voer Slegs Verkoopte Hoeveelheid in, Maar Wys Pryshoeveelheid',0),(238043,6613,'ro','IntroduceÅ£i cantitate Vindem dar cantitatea de pret Display',0),(238044,6613,'et','MÃ¼Ã¼a kogus aga ekraani hind kogus',0),(238045,6613,'si','Vnesite koliÄino prodaja ampak prikaz cen koliÄina',0),(238046,6613,'ba','Masukkan Jual kuantitas tetapi tampilan harga jumlah',0),(238047,6613,'nl','Voer het aantal verkopen maar Display prijs hoeveelheid',0),(238048,6613,'fi','SyÃ¶tÃ¤ myydÃ¤ mÃ¤Ã¤rÃ¤ mutta nÃ¤yttÃ¶ hinta mÃ¤Ã¤rÃ¤',0),(238049,6613,'no','Angi selger men Display prisen antall',0),(238050,6613,'da','Angiv sÃ¦lge mÃ¦ngde men Display pris mÃ¦ngde',0),(238051,6613,'ko','ë””ìŠ¤í”Œë ˆì´ ê°€ê²© ìˆ˜ëŸ‰ë§Œ íŒë§¤ ìˆ˜ëŸ‰ì„ ìž…ë ¥',0),(238052,6613,'he','×”×–×Ÿ ×›×ž×•×ª ×œ×ž×›×•×¨ ××‘×œ ×”×ª×¦×•×’×” ×ž×—×™×¨ ×”×›×ž×•×ª',0),(238053,6613,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚ Î±Î»Î»Î¬ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï„Î¹Î¼Î® Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·',0),(238054,6613,'zh','è¾“å…¥é”€å”®é‡ï¼Œä½†æ˜¾ç¤ºä»·æ ¼æ•°é‡',0),(238055,6613,'sv','Ange sÃ¤lja kvantitet men Display pris kvantitet',0),(238056,6613,'it','Immettere quantitÃ  di vendere ma Display prezzo quantitÃ ',0),(238057,6613,'tl','',0),(238058,6613,'th','&#3611;&#3657;&#3629;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3634;&#3618;&#3649;&#3605;&#3656;&#3649;&#3626;&#3604;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3619;&#3634;&#3588;&#3634;',0),(238059,6613,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤®à¥‚à¤²à¥à¤¯ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤²à¥‡à¤•à¤¿à¤¨ à¤¬à¥‡à¤šà¤¨à¥‡ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(238060,6613,'ms','Masukkan kuantiti menjual tetapi paparan harga kuantiti',0),(238061,6613,'ar','Ø£Ø¯Ø®Ù„ ÙƒÙ…ÙŠØ© Ø¨ÙŠØ¹ Ù„ÙƒÙ† Ø¹Ø±Ø¶ Ø³Ø¹Ø± Ø§Ù„ÙƒÙ…ÙŠØ©',0),(238062,6613,'fr','Entrer la quantitÃ© de vendre mais affichage prix quantitÃ©',0),(238063,6613,'jp','è¡¨ç¤ºä¾¡æ ¼æ•°é‡ã€è²©å£²æ•°é‡ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(238064,6613,'pt','Insira a quantidade vendemos mas Display preÃ§o quantidade',0),(238065,6613,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ‚ÑŒ Ð½Ð¾ Ð´Ð¸ÑÐ¿Ð»ÐµÐ¹ Ñ†ÐµÐ½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(238066,6613,'es','Introducir Cantidad de Venta pero Desplega la Cantidad de Precio',0),(238067,6613,'de','Geben Sie verkaufen Menge aber Display Preis Menge',0),(238068,6613,'en','Enter Sell Quantity but Display Price Quantity',0),(238069,6614,'is','',0),(238070,6614,'dr','ÙÙ‚Ø· Ø«Ø¨Øª Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ ',0),(238071,6614,'pr','ÙÙ‚Ø· Ø«Ø¨Øª Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ ',0),(238072,6614,'tr','SatÄ±ÅŸ miktarÄ± sadece girin',0),(238073,6614,'pl','WprowadÅº iloÅ›Ä‡ sprzedajÄ… tylko',0),(238074,6614,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ°Ð¼Ð¾',0),(238075,6614,'ur','ØµØ±Ù ÙØ±ÙˆØ®Øª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(238076,6614,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ ÑÐ°Ð¼Ð¾',0),(238077,6614,'vi','Chá»‰ Nháº­p sá»‘ lÆ°á»£ng bÃ¡n',0),(238078,6614,'af','Voer Slegs Verkoopte Hoeveelheid in',0),(238079,6614,'ro','IntroduceÅ£i cantitate Vindem numai',0),(238080,6614,'et','MÃ¼Ã¼a kogus ainult',0),(238081,6614,'si','Vnesite koliÄino prodaja samo',0),(238082,6614,'ba','Masukkan jumlah Jual',0),(238083,6614,'nl','Voer aantal in verkopen alleen',0),(238084,6614,'fi','SyÃ¶tÃ¤ myydÃ¤ mÃ¤Ã¤rÃ¤ vain',0),(238085,6614,'no','Angi selger bare',0),(238086,6614,'da','Angiv sÃ¦lge mÃ¦ngde kun',0),(238087,6614,'ko','íŒë§¤ ìˆ˜ëŸ‰ë§Œ ìž…ë ¥',0),(238088,6614,'he','×”×–×Ÿ ×›×ž×•×ª ×ž×•×›×¨×™× ×‘×œ×‘×“',0),(238089,6614,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Ï‰Î»Î¿ÏÎ½ Î¼ÏŒÎ½Î¿',0),(238090,6614,'zh','åªè¾“å…¥ä¾›åº”é‡',0),(238091,6614,'sv','Ange sÃ¤lja kvantiteten bara',0),(238092,6614,'it','Immettere la quantitÃ  di vendere solo',0),(238093,6614,'tl','',0),(238094,6614,'th','&#3611;&#3657;&#3629;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3634;&#3618;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(238095,6614,'hi','à¤•à¥‡à¤µà¤² à¤¬à¥‡à¤šà¤¨à¥‡ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(238096,6614,'ms','Masukkan kuantiti menjual hanya',0),(238097,6614,'ar','Ø£Ø¯Ø®Ù„ ÙƒÙ…ÙŠØ© Ø¨ÙŠØ¹ ÙÙ‚Ø·',0),(238098,6614,'fr','Entrer la quantitÃ© de vendre seulement',0),(238099,6614,'jp','è²©å£²æ•°é‡ã®ã¿ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(238100,6614,'pt','Insira a quantidade vendemos somente',0),(238101,6614,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(238102,6614,'es','Introducir Cantidad de Venta Solamente',0),(238103,6614,'de','Geben Sie nur die Menge verkaufen',0),(238104,6614,'en','Enter Sell Quantity Only',0),(238105,6615,'is','',0),(238106,6615,'dr','ÙƒØ¯Ø§Ù… Ø«Ø¨Øª Ù…Ù‚Ø¯Ø§Ø± ',0),(238107,6615,'pr','ÙƒØ¯Ø§Ù… Ø«Ø¨Øª Ù…Ù‚Ø¯Ø§Ø± ',0),(238108,6615,'tr','Hangi giriÅŸ miktarÄ±',0),(238109,6615,'pl','KtÃ³ra iloÅ›Ä‡ wpisu',0),(238110,6615,'bg','ÐšÐ¾Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(238111,6615,'ur','Ø¬Ø³ Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(238112,6615,'sr','ÐšÐ¾Ñ˜Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¸Ð· ÑÑ‚Ð°Ð²ÐºÐµ',0),(238113,6615,'vi','Sá»‘ LÆ°á»£ng Entry NÃ o',0),(238114,6615,'af','Watter Invoerhoeveelheid',0),(238115,6615,'ro','Care cantitatea de intrare',0),(238116,6615,'et','*Which Entry Quantity',0),(238117,6615,'si','Katera koliÄina v postavki',0),(238118,6615,'ba','Jumlah entri yang',0),(238119,6615,'nl','Welke hoeveelheid post',0),(238120,6615,'fi','MikÃ¤ mÃ¤Ã¤rÃ¤',0),(238121,6615,'no','Hvilken posten antall',0),(238122,6615,'da','Hvilken post mÃ¦ngde',0),(238123,6615,'ko','ì–´ëŠ í•­ëª© ìˆ˜ëŸ‰',0),(238124,6615,'he','××™×–×• ×›×ž×•×ª ×›× ×™×¡×”',0),(238125,6615,'el','Î Î¿Î¹Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(238126,6615,'zh','å“ªä¸€ä¸ªæ¡ç›®æ•°é‡\r\n',0),(238127,6615,'sv','Vilken transaktionen kvantitet',0),(238128,6615,'it','Quale quantitÃ  di voce',0),(238129,6615,'tl','',0),(238130,6615,'th','&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(238131,6615,'hi','à¤•à¥Œà¤¨ à¤¸à¤¾ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(238132,6615,'ms','Kuantiti entri yang',0),(238133,6615,'ar','Ø£ÙŠ Ø¥Ø¯Ø®Ø§Ù„ ÙƒÙ…ÙŠØ©',0),(238134,6615,'fr','Quelle quantitÃ© entrÃ©e',0),(238135,6615,'jp','ã©ã®ã‚¨ãƒ³ãƒˆãƒªã®é‡',0),(238136,6615,'pt','Qual quantidade de entrada',0),(238137,6615,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ñ… Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(238138,6615,'es','Cantidad de Cual Entrada',0),(238139,6615,'de','Welche Menge Eintrag',0),(238140,6615,'en','Which Entry Quantity',0),(238141,6616,'is','',0),(238142,6616,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø­Ø°Ù Ø´Ø¯Ù‡ Ù‡Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(238143,6616,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø­Ø°Ù Ø´Ø¯Ù‡ Ù‡Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(238144,6616,'tr','SilinmiÅŸ Gizle\'yi tÄ±klatÄ±n',0),(238145,6616,'pl','Kliknij, aby ukryÄ‡ usuniÄ™te',0),(238146,6616,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° ÑÐºÑ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸',0),(238147,6616,'ur','Ø­Ø°Ù Ú©Û’ Ù„ÛŒÛ’ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(238148,6616,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(238149,6616,'vi','Nháº¥n Ä‘á»ƒ giáº¥u xÃ³a',0),(238150,6616,'af','Kliek om Geskrapte te Verberg',0),(238151,6616,'ro','FaceÅ£i clic pentru a ascunde ÅŸters',0),(238152,6616,'et','Kustutatute peitmiseks klÃµpsa',0),(238153,6616,'si','Kliknite, Äe Å¾elite skriti, izbrisati',0),(238154,6616,'ba','Klik untuk menyembunyikan dihapus',0),(238155,6616,'nl','Klik op verbergen verwijderd',0),(238156,6616,'fi','Valitse Piilota poistetut',0),(238157,6616,'no','Klikk for Ã¥ skjule slettet',0),(238158,6616,'da','Klik for at skjule slettede',0),(238159,6616,'ko','ìˆ¨ê¸°ê¸° ì‚­ì œë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(238160,6616,'he','×œ×—×¥ ×›×“×™ ×œ×”×¡×ª×™×¨ ×©× ×ž×—×§×•',0),(238161,6616,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î±Ï€ÏŒÎºÏÏ…ÏˆÎ· Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯',0),(238162,6616,'zh','ç‚¹å‡»éšè—åˆ é™¤\r\n',0),(238163,6616,'sv','Klicka fÃ¶r att dÃ¶lja bort',0),(238164,6616,'it','Fare clic su Nascondi eliminato',0),(238165,6616,'tl','',0),(238166,6616,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3595;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(238167,6616,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤›à¥à¤ªà¤¾à¤à¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(238168,6616,'ms','Klik untuk Sembunyikan yang dihapuskan',0),(238169,6616,'ar','Ø£Ù†Ù‚Ø± Ù„Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ù…Ø­Ø°ÙˆÙØ§Øª',0),(238170,6616,'fr','Cliquez sur Masquer supprimÃ©',0),(238171,6616,'jp','éžè¡¨ç¤ºã®å‰Šé™¤ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(238172,6616,'pt','Clique para ocultar eliminado',0),(238173,6616,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð£Ð´Ð°Ð»ÐµÐ½Ð½Ð¾Ðµ ',0),(238174,6616,'es','Click para Esconder Eliminado',0),(238175,6616,'de','Klicken Sie auf Ausblenden gelÃ¶scht',0),(238176,6616,'en','Click to Hide Deleted',0),(238177,6617,'is','',0),(238178,6617,'dr','Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ Ø­Ø°Ù Ø´Ø¯Ù‡ Ù‡Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(238179,6617,'pr','Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ Ø­Ø°Ù Ø´Ø¯Ù‡ Ù‡Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(238180,6617,'tr','SilinmiÅŸ gÃ¶stermek iÃ§in tÄ±klatÄ±n',0),(238181,6617,'pl','Kliknij na PokaÅ¼ usuniÄ™te',0),(238182,6617,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸',0),(238183,6617,'ur','Ø´Ùˆ Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(238184,6617,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(238185,6617,'vi','Nháº¥n Ä‘á»ƒ hiá»ƒn thá»‹ Há»§y',0),(238186,6617,'af','Kliek om Geskrapte te Wys ',0),(238187,6617,'ro','FaceÅ£i clic pe show ÅŸters',0),(238188,6617,'et','Kustutatute nÃ¤itamiseks klÃµpsa',0),(238189,6617,'si','Kliknite za prikaz Ärta',0),(238190,6617,'ba','Klik untuk Tampilkan dihapus',0),(238191,6617,'nl','Klik op naar Show verwijderd',0),(238192,6617,'fi','Valitse NÃ¤ytÃ¤ poistetut',0),(238193,6617,'no','Klikk Vis slettet',0),(238194,6617,'da','Klik for at vise slettet',0),(238195,6617,'ko','ì‚­ì œ í‘œì‹œë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(238196,6617,'he','×œ×—×¥ ×›×“×™ ×œ×ž×—×•×§',0),(238197,6617,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î½Î± Î´ÎµÎ¯Ï„Îµ Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯',0),(238198,6617,'zh','ç‚¹å‡»æ˜¾ç¤ºå·²åˆ é™¤\r\n',0),(238199,6617,'sv','Klicka fÃ¶r att visa bort',0),(238200,6617,'it','Clicca per mostrare elementi cancellati',0),(238201,6617,'tl','',0),(238202,6617,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3621;&#3610;',0),(238203,6617,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤¶à¥‹ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(238204,6617,'ms','Klik untuk Papar yang dihapuskan',0),(238205,6617,'ar','Ø§Ù†Ù‚Ø± Ù„Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù…Ø­Ø°ÙˆÙØ§Øª',0),(238206,6617,'fr','Cliquer pour voir la supprimÃ©',0),(238207,6617,'jp','å‰Šé™¤ã™ã‚‹] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(238208,6617,'pt','Clique para visualizar eliminado',0),(238209,6617,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð£Ð´Ð°Ð»ÐµÐ½Ð½Ð¾Ðµ ',0),(238210,6617,'es','Click para Mostrar los Eliminados',0),(238211,6617,'de','Klicken Sie auf die Karte gelÃ¶scht',0),(238212,6617,'en','Click to Show Deleted',0),(238213,6618,'is','',0),(238214,6618,'dr','ØªÙ…Ø§Ù… Ø±Ø¯ÙŠÙ Ù‡Ø§ Ø¨Ø§ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¯Ø§Ø±Ù†Ø¯ ',0),(238215,6618,'pr','ØªÙ…Ø§Ù… Ø±Ø¯ÙŠÙ Ù‡Ø§ Ø¨Ø§ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¯Ø§Ø±Ù†Ø¯ ',0),(238216,6618,'tr','Veri iÃ§eren tÃ¼m satÄ±rlarÄ± seÃ§ili GL hesabÄ±nÄ±z var',0),(238217,6618,'pl','Nie wszystkie wiersze z danymi ma konto GL wybrane',0),(238218,6618,'bg','ÐÐµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ€ÐµÐ´Ð¾Ð²Ðµ Ñ Ð´Ð°Ð½Ð½Ð¸ Ð¸Ð¼Ð°Ñ‚ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ Ð°ÐºÐ°ÑƒÐ½Ñ‚ GL',0),(238219,6618,'ur','Ú©ÙˆØ§Ø¦Ù ØªÙ…Ø§Ù… ØµÙÛŒÚº Ù…Ù†ØªØ®Ø¨ Ù¾Ø§Ø³ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ ÛÛ’ Û”',0),(238220,6618,'sr','ÐÐ¸ÑÑƒ ÑÐ²Ð¸ Ñ€ÐµÐ´Ð¾Ð²Ð¸ ÑÐ° Ð¿Ð¾Ð´Ð°Ñ†Ð¸Ð¼Ð° Ð¸Ð¼Ð°Ñ˜Ñƒ Ð“Ð› Ð½Ð°Ð»Ð¾Ð³Ð° ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½',0),(238221,6618,'vi','KhÃ´ng pháº£i táº¥t cáº£ cÃ¡c dÃ²ng dá»¯ liá»‡u cÃ³ TK Sá»• CÃ¡i Tá»•ng Há»£p Ä‘Ã£ Ä‘Æ°á»£c chá»n',0),(238222,6618,'af','Nie alle Rye Met Data Het \'n AG Rekening Gekies',0),(238223,6618,'ro','Nu toate rÃ¢ndurile cu date au un cont de GL selectate',0),(238224,6618,'et','KÃµik read andmetega on valitud pearaamatukontole',0),(238225,6618,'si','Vse vrstice s podatki so GL raÄun izbrana',0),(238226,6618,'ba','Tidak semua baris dengan Data memiliki Account GL dipilih',0),(238227,6618,'nl','Niet alle rijen met gegevens hebt een GL-Account geselecteerd',0),(238228,6618,'fi','Ei kaikkien rivien tiedot on Kirjanpitotilin pÃ¤Ã¤tilin valitun',0),(238229,6618,'no','Ikke alle radene som har en GL-kontoen som er valgt',0),(238230,6618,'da','Ikke alle rÃ¦kker med Data har en GL konto valgt',0),(238231,6618,'ko','ë°ì´í„°ê°€ ì—†ëŠ” ëª¨ë“  í–‰ ìžˆëŠ” GL ê³„ì • ì„ íƒ',0),(238232,6618,'he','×œ× ×›×œ ×”×©×•×¨×•×ª ×¢× × ×ª×•× ×™× ×™×© ×—×©×‘×•×Ÿ GL ×©× ×‘×—×¨×•',0),(238233,6618,'el','Î”ÎµÎ½ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î³ÏÎ±Î¼Î¼Î­Ï‚ Î¼Îµ Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± Î­Ï‡Î¿Ï…Î½ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(238234,6618,'zh','éžæ‰€æœ‰æ•°æ®åˆ—éƒ½æœ‰ä¸€ä¸ªå·²é€‰çš„æ€»å¸å¸æˆ·\r\n',0),(238235,6618,'sv','Inte alla rader med Data har en GL-konto som valts',0),(238236,6618,'it','Non tutte le righe con dati dispone di un Account GL selezionato',0),(238237,6618,'tl','',0),(238238,6618,'th','&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3649;&#3606;&#3623;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3617;&#3637;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3',0),(238239,6618,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¨à¤¹à¥€à¤‚ à¤¸à¤­à¥€ à¤ªà¤‚à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤ à¤à¤• GL à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ',0),(238240,6618,'ms','Tidak semua baris dengan Data mempunyai akaun GL yang dipilih',0),(238241,6618,'ar','Ù„ÙŠØ³Øª ÙƒØ§ÙØ© Ø§Ù„ØµÙÙˆÙ Ù…Ø¹ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ù„Ø¯ÙŠÙƒ Ø­Ø³Ø§Ø¨ GL Ù…Ø®ØªØ§Ø±Ø©',0),(238242,6618,'fr','Pas de toutes les lignes contenant des donnÃ©es de compte GL sÃ©lectionnÃ©',0),(238243,6618,'jp','ãƒ‡ãƒ¼ã‚¿ã‚’æŒã¤ã™ã¹ã¦ã®è¡Œã¯é¸æŠžã•ã‚ŒãŸ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’æŒã£ã¦ã„ã¾ã™ã€‚',0),(238244,6618,'pt','NÃ£o todas as linhas com dados tem uma conta GL selecionada',0),(238245,6618,'ru','ÐÐµ Ð²ÑÐµ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ñ Ð´Ð°Ð½Ð½Ñ‹Ð¼Ð¸ Ñƒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ GL',0),(238246,6618,'es','No Todas Las Filas Con Datos Tienen Una Cuenta LM Seleccionada',0),(238247,6618,'de','Nicht alle Zeilen mit Daten haben ein GL-Konto ausgewÃ¤hlt',0),(238248,6618,'en','Not All Rows With Data Have a GL Account Selected',0),(238249,6619,'is','',0),(238250,6619,'dr','Ø­Ù‚ÙˆÙ‚ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ',0),(238251,6619,'pr','Ø­Ù‚ÙˆÙ‚ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¯Ø±Ù…Ø§Ù†ÙŠ Ø¯ÙˆÙ„ØªÙŠ',0),(238252,6619,'tr','FICA vergiye tabi Ã¶deme',0),(238253,6619,'pl','FICA opodatkowaniu pÅ‚ac',0),(238254,6619,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ FICA Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾',0),(238255,6619,'ur','ÙØ§Ú©ÛŒ Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ ØªÙ†Ø®ÙˆØ§Û',0),(238256,6619,'sr','ÐžÐ”Ð Ð•Ð¡ÐšÐ£ Ð¿Ð»Ð°Ð¶Ð° Ð¿Ð»Ð°Ñ‚Ñƒ',0),(238257,6619,'vi','Thanh toÃ¡n thuáº¿ báº£o hiá»ƒm xÃ£ há»™i',0),(238258,6619,'af','FICA belasbare betaal',0),(238259,6619,'ro','FICA impozabile plata',0),(238260,6619,'et','FICA maksustatav tÃ¶Ã¶tasu',0),(238261,6619,'si','FICA davÄni zavezanec plaÄati',0),(238262,6619,'ba','Membayar pajak FICA',0),(238263,6619,'nl','FICA belastbare loon',0),(238264,6619,'fi','FICA veron maksu',0),(238265,6619,'no','FICA skattepliktig lÃ¸nn',0),(238266,6619,'da','FICA skattepligtige lÃ¸n',0),(238267,6619,'ko','FICA ê³¼ì„¸ ì§€ë¶ˆ',0),(238268,6619,'he','×œ×©×œ× ×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™ ×—×™×™×‘ ×‘×ž×¡',0),(238269,6619,'el','Î£Î¥ÎœÎ’ÎŸÎ¥Î›Î‰ Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½',0),(238270,6619,'zh','è”é‚¦ä¿é™©æåŠ©æ¡ä¾‹æ”¯ä»˜åº”ç¨Ž\r\n',0),(238271,6619,'sv','FICA beskattningsbara lÃ¶n',0),(238272,6619,'it','Retribuzione imponibile di FICA',0),(238273,6619,'tl','',0),(238274,6619,'th','&#3616;&#3634;&#3625;&#3637;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3592;&#3656;&#3634;&#3618;&#3585;&#3629;&#3591;&#3607;&#3640;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;',0),(238275,6619,'hi','FICA à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨',0),(238276,6619,'ms','Membayar cukai FICA',0),(238277,6619,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ù…Ø­ÙƒÙ…ÙŠ',0),(238278,6619,'fr','RÃ©munÃ©ration imposable FICA',0),(238279,6619,'jp','FICA ã®èª²ç¨Žçµ¦ä¸Ž',0),(238280,6619,'pt','Pagamento FICA sujeito passivo',0),(238281,6619,'ru','FICA Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð¾Ð³Ð¾ Ð²Ð¾Ð·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(238282,6619,'es','FICA Impuesto Pagable',0),(238283,6619,'de','FICA Steuerpflichtigen Lohn',0),(238284,6619,'en','FICA Taxable Pay',0),(238285,6620,'is','',0),(238286,6620,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡  ÙƒØ³Ø±ÙŠ',0),(238287,6620,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡  ÙƒØ³Ø±ÙŠ',0),(238288,6620,'tr','Yeni bir kesinti grubu',0),(238289,6620,'pl','Nowa grupa odliczenia',0),(238290,6620,'bg','ÐÐ¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð·Ð° Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(238291,6620,'ur','Ù†ÛŒØ§ ÛÙˆÙ†Û’Ùˆ Ú¯Ø±ÙˆÙ¾',0),(238292,6620,'sr','ÐÐ¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð°',0),(238293,6620,'vi','ThÃªm NhÃ³m Giáº£m trá»«',0),(238294,6620,'af','Nuwe aftrekking groep',0),(238295,6620,'ro','Noul grup de deducere',0),(238296,6620,'et','Uue mahaarvamist rÃ¼hma',0),(238297,6620,'si','Novi odbitek skupine',0),(238298,6620,'ba','Grup pemotongan baru',0),(238299,6620,'nl','Nieuwe aftrek groep',0),(238300,6620,'fi','Uusi vÃ¤hennys ryhmÃ¤',0),(238301,6620,'no','Ny fradrag gruppe',0),(238302,6620,'da','Nye fradrag gruppe',0),(238303,6620,'ko','ìƒˆë¡œìš´ ê³µì œ ê·¸ë£¹',0),(238304,6620,'he','×§×‘×•×¦×ª × ×™×›×•×™ ×—×“×©×”',0),(238305,6620,'el','ÎÎ­Î± Î¿Î¼Î¬Î´Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(238306,6620,'zh','æ‰£é™¤ç»„åœ°å€\r\n',0),(238307,6620,'sv','Nya avdrag grupp',0),(238308,6620,'it','Nuovo gruppo di deduzione',0),(238309,6620,'tl','',0),(238310,6620,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3611;&#3655;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(238311,6620,'hi','à¤¨à¤ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(238312,6620,'ms','Kumpulan potongan baru',0),(238313,6620,'ar','ÙØ±ÙŠÙ‚ Ø®ØµÙ… Ø¬Ø¯ÙŠØ¯',0),(238314,6620,'fr','Nouveau groupe de dÃ©duction',0),(238315,6620,'jp','æ–°ã—ã„æŽ§é™¤ã‚°ãƒ«ãƒ¼ãƒ—',0),(238316,6620,'pt','Novo grupo de deduÃ§Ã£o',0),(238317,6620,'ru','ÐÐ¾Ð²Ð°Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ð° Ð²Ñ‹Ñ‡ÐµÑ‚',0),(238318,6620,'es','Grupo de Deducciones Agregar',0),(238319,6620,'de','Neue Gruppe zum Abzug',0),(238320,6620,'en','New Deduction Group',0),(238321,6621,'is','',0),(238322,6621,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡  ÙƒØ³Ø±ÙŠ',0),(238323,6621,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡  ÙƒØ³Ø±ÙŠ',0),(238324,6621,'tr','Kesinti grubu DÃ¼zenle',0),(238325,6621,'pl','Edytuj grupÄ™ odliczenia',0),(238326,6621,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð·Ð° Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(238327,6621,'ur','ØªØ¯ÙˆÛŒÙ† ÛÙˆÙ†Û’Ùˆ Ú¯Ø±ÙˆÙ¾',0),(238328,6621,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ðµ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð°',0),(238329,6621,'vi','Cáº­p Nháº­t NhÃ³m Giáº£m Trá»«',0),(238330,6621,'af','Redigeer aftrekking groep',0),(238331,6621,'ro','Grup de deducere editare',0),(238332,6621,'et','RÃ¼hma redigeerimine mahaarvamine',0),(238333,6621,'si','Urejanje odbitek skupine',0),(238334,6621,'ba','Edit pengurangan Group',0),(238335,6621,'nl','Aftrek groep bewerken',0),(238336,6621,'fi','Muokkaa vÃ¤hennys ryhmÃ¤Ã¤',0),(238337,6621,'no','Rediger fradrag gruppe',0),(238338,6621,'da','Rediger fradrag gruppe',0),(238339,6621,'ko','ê³µì œ ê·¸ë£¹ íŽ¸ì§‘',0),(238340,6621,'he','×§×‘×•×¦×ª × ×™×›×•×™ ×¢×¨×™×›×”',0),(238341,6621,'el','ÎŸÎ¼Î¬Î´Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(238342,6621,'zh','æ‰£é™¤ç»„æ›´æ–°\r\n',0),(238343,6621,'sv','Redigera avdrag grupp',0),(238344,6621,'it','Modifica gruppo deduzione',0),(238345,6621,'tl','',0),(238346,6621,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3627;&#3633;&#3585;&#3648;&#3611;&#3655;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(238347,6621,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(238348,6621,'ms','Edit potongan Kumpulan',0),(238349,6621,'ar','ØªØ­Ø±ÙŠØ± Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø®ØµÙ…',0),(238350,6621,'fr','DÃ©duction pour modifier un groupe',0),(238351,6621,'jp','æŽ§é™¤ [ã‚°ãƒ«ãƒ¼ãƒ—ã®ç·¨é›†',0),(238352,6621,'pt','Editar grupo de deduÃ§Ã£o',0),(238353,6621,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð³Ñ€ÑƒÐ¿Ð¿Ñƒ Ð²Ñ‹Ñ‡ÐµÑ‚',0),(238354,6621,'es','Grupo de Deducciones Actualizar',0),(238355,6621,'de','Abzug Gruppe bearbeiten',0),(238356,6621,'en','Edit Deduction Group',0),(238357,6622,'is','',0),(238358,6622,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯Ù‰ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(238359,6622,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯Ù‰ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(238360,6622,'tr','GÃ¶zden geÃ§irme derecelendirme Ã¶lÃ§eÄŸi ekleme',0),(238361,6622,'pl','Dodaj recenzjÄ™ ocena skali',0),(238362,6622,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³Ð¾Ð²Ð° ÑÐºÐ°Ð»Ð°',0),(238363,6622,'ur','Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©Û’ Ù¾ÛŒÙ…Ø§Ù†Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(238364,6622,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ ÑÐºÐ°Ð»Ðµ',0),(238365,6622,'vi','ThÃªm thang Ä‘Ã¡nh giÃ¡ ',0),(238366,6622,'af','Hersiening takseringskaal voeg',0),(238367,6622,'ro','Adauga scarÄƒ de Rating de revizuire',0),(238368,6622,'et','Review Reiting skaalal lisamine',0),(238369,6622,'si','Pregled Rating lestvico dodati',0),(238370,6622,'ba','Tambahkan skala Rating Tinjauan',0),(238371,6622,'nl','Beoordeling Rating Scale toevoegen',0),(238372,6622,'fi','Review Arviointiasteikko lisÃ¤Ã¤',0),(238373,6622,'no','Gjennomgang vurderingsskala legge',0),(238374,6622,'da','Anmeldelse bedÃ¸mmelsesskala tilfÃ¸je',0),(238375,6622,'ko','ê²€í†  í‰ê°€ ì²™ë„ ì¶”ê°€',0),(238376,6622,'he','×¡×•×œ× ×“×™×¨×•×’ ×¡×§×™×¨×” ×”×•×¡×£',0),(238377,6622,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· ÎºÎ»Î¯Î¼Î±ÎºÎ± Î´Î¹Î±Î²Î¬Î¸Î¼Î¹ÏƒÎ·Ï‚',0),(238378,6622,'zh','å®¡æŸ¥è¯„å®šé‡è¡¨æ·»åŠ \r\n',0),(238379,6622,'sv','Ã–versyn skala lÃ¤gga till',0),(238380,6622,'it','Scala di Rating recensione Aggiungi',0),(238381,6622,'tl','',0),(238382,6622,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3626;&#3648;&#3585;&#3621;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;',0),(238383,6622,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¸à¥à¤•à¥‡à¤² à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(238384,6622,'ms','Skala penilaian kajian menambah',0),(238385,6622,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù‚ÙŠØ§Ø³ Ø§Ù„ØªØµÙ†ÙŠÙ Ø§Ø³ØªØ¹Ø±Ø§Ø¶',0),(238386,6622,'fr','Ã‰chelle de cotation examen ajouter',0),(238387,6622,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼è©•ä¾¡å°ºåº¦ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(238388,6622,'pt','Escala de avaliaÃ§Ã£o de revisÃ£o adicionar',0),(238389,6622,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±Ð·Ð¾Ñ€ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³Ð¾Ð²Ð°Ñ ÑˆÐºÐ°Ð»Ð°',0),(238390,6622,'es','Revisar Escala de EvaluaciÃ³n Agregar',0),(238391,6622,'de','Test-Rating-Skala hinzufÃ¼gen',0),(238392,6622,'en','Review Rating Scale Add',0),(238393,6623,'is','',0),(238394,6623,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯Ù‰ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(238395,6623,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù…Ù‚ÙŠØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯Ù‰ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(238396,6623,'tr','Derecelendirme Ã¶lÃ§eÄŸi gÃ¼ncelleÅŸtirmeyi gÃ¶zden geÃ§irin',0),(238397,6623,'pl','PrzeglÄ…d ocena skali aktualizacji',0),(238398,6623,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ð¼Ð°Ñ‰Ð°Ð± Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(238399,6623,'ur','Ù¾ÛŒÙ…Ø§Ù†Û’ Ù¾Ø± ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(238400,6623,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ñ€ÐµÑ˜Ñ‚Ð¸Ð½Ð³ ÑÐºÐ°Ð»Ðµ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(238401,6623,'vi','Cáº­p Nháº­t Má»©c ÄÃ¡nh GiÃ¡ BÃ¬nh Duyá»‡t',0),(238402,6623,'af','Hersien gradering skaal bywerking',0),(238403,6623,'ro','Revizuirea Rating scarÄƒ Update',0),(238404,6623,'et','Review hinnang skaalal Update',0),(238405,6623,'si','Pregled Rating Scale posodobitev',0),(238406,6623,'ba','Meninjau Rating skala Update',0),(238407,6623,'nl','Bekijk Rating schaal Update',0),(238408,6623,'fi','Arvostelu Rating Scale pÃ¤ivitys',0),(238409,6623,'no','Se gjennom vurdering skala oppdatering',0),(238410,6623,'da','Anmeld Rating Scale opdatering',0),(238411,6623,'ko','ë“±ê¸‰ ê·œëª¨ ì—…ë°ì´íŠ¸ ê²€í† ',0),(238412,6623,'he','×¡×§×™×¨×ª ×“×™×¨×•×’ ×¢×“×›×•×Ÿ ×¡×•×œ×',0),(238413,6623,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Î²Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± ÎºÎ»Î¯Î¼Î±ÎºÎ± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(238414,6623,'zh','å®¡æŸ¥è¯„å®šé‡è¡¨æ›´æ–°\r\n',0),(238415,6623,'sv','Granska betyg skalan uppdatering',0),(238416,6623,'it','Revisione aggiornamento della scala di valutazione',0),(238417,6623,'tl','',0),(238418,6623,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3626;&#3648;&#3585;&#3621;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3629;&#3633;&#3609;&#3604;&#3633;&#3610;',0),(238419,6623,'hi','à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¸à¥à¤•à¥‡à¤² à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(238420,6623,'ms','Menyemak pengkadaran skala Kemaskini',0),(238421,6623,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶ ØªØµÙ†ÙŠÙ Ù…Ù‚ÙŠØ§Ø³ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(238422,6623,'fr','Revue mise Ã  jour du barÃ¨me de notation',0),(238423,6623,'jp','è©•ä¾¡ã‚¹ã‚±ãƒ¼ãƒ«ã®æ›´æ–°ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(238424,6623,'pt','RevisÃ£o de atualizaÃ§Ã£o da escala de classificaÃ§Ã£o',0),(238425,6623,'ru','ÐžÐ±Ð·Ð¾Ñ€, Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³ ÑˆÐºÐ°Ð»Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(238426,6623,'es','Revisar Escala de EvaluaciÃ³n Actualizar',0),(238427,6623,'de','ÃœberprÃ¼fen Sie Rating Scale Update',0),(238428,6623,'en','Review Rating Scale Update',0),(238429,6624,'is','',0),(238430,6624,'dr','Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(238431,6624,'pr','Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(238432,6624,'tr','Servis sipariÅŸi maliyetlerini',0),(238433,6624,'pl','Do kosztÃ³w zamÃ³wienia',0),(238434,6624,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(238435,6624,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©Û’ Ù„Ø¦Û’',0),(238436,6624,'sr','Ð—Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ ÑÐµÑ€Ð²Ð¸ÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(238437,6624,'vi','Cho giÃ¡ thÃ nh Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥',0),(238438,6624,'af','Vir Diens Bestelling Koste',0),(238439,6624,'ro','Pentru costurile de comandÄƒ Service',0),(238440,6624,'et','Teenuse tellimuse kulud',0),(238441,6624,'si','Za naroÄilo stroÅ¡ke servisa',0),(238442,6624,'ba','Biaya layanan pesanan',0),(238443,6624,'nl','Voor servicekosten voor de Order',0),(238444,6624,'fi','Palvelun tilaus kustannuksia',0),(238445,6624,'no','For bestilling servicekostnader',0),(238446,6624,'da','For serviceomkostninger',0),(238447,6624,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ë¹„ìš©ì— ëŒ€ í•œ',0),(238448,6624,'he','×¢×‘×•×¨ ×¢×œ×•×™×•×ª ×”×–×ž× ×ª ×©×™×¨×•×ª',0),(238449,6624,'el','Î“Î¹Î± Ï„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ Ï„Î·Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ Î³Î¹Î±',0),(238450,6624,'zh','å¯¹äºŽæœåŠ¡è®¢å•æˆæœ¬\r\n',0),(238451,6624,'sv','FÃ¶r bestÃ¤llning servicekostnader',0),(238452,6624,'it','Per i costi di ordine di servizio',0),(238453,6624,'tl','',0),(238454,6624,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(238455,6624,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¤¤ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(238456,6624,'ms','Bagi kos pesanan Perkhidmatan',0),(238457,6624,'ar','Ù„ØªÙƒØ§Ù„ÙŠÙ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(238458,6624,'fr','Pour les coÃ»ts de commande de Service',0),(238459,6624,'jp','ã‚µãƒ¼ãƒ“ã‚¹æŒ‡å›³ã®åŽŸä¾¡ã®',0),(238460,6624,'pt','Para os custos de ordem de serviÃ§o',0),(238461,6624,'ru','Ð”Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(238462,6624,'es','Para Costos de Ordenes de Servicio',0),(238463,6624,'de','Service Bestellung Kosten',0),(238464,6624,'en','For Service Order Costs',0),(238465,6625,'is','',0),(238466,6625,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø¯ÙˆØ±Ù‡ Ù¾Ø§ÙŠØ§Ù†ÙŠ',0),(238467,6625,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø¯ÙˆØ±Ù‡ Ù¾Ø§ÙŠØ§Ù†ÙŠ',0),(238468,6625,'tr','DÃ¶nem bitiÅŸ tarihi iÃ§in mesaj',0),(238469,6625,'pl','Post do daty zakoÅ„czenia okresu',0),(238470,6625,'bg','ÐŸÐ¾ÑÑ‚ Ð´Ð¾ ÐºÑ€Ð°Ñ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð´Ð°Ñ‚Ð°',0),(238471,6625,'ur','Ø¹Ø±ØµÛ Ø§Ø®ØªØªØ§Ù… ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº',0),(238472,6625,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶Ð¸ Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° ÐºÑ€Ð°Ñ˜ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(238473,6625,'vi','Káº¿t chuyá»ƒn tá»›i ngÃ y cuá»‘i cá»§a ká»³',0),(238474,6625,'af','Pos na Periode End Datum',0),(238475,6625,'ro','Post la data de sfÃ¢rÅŸit perioadÄƒ',0),(238476,6625,'et','Post lÃµppkuupÃ¤ev',0),(238477,6625,'si','Post, da konÄni datum obdobja',0),(238478,6625,'ba','Posting untuk tanggal akhir periode',0),(238479,6625,'nl','Post naar einde van de periode datum',0),(238480,6625,'fi','Post kauden pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(238481,6625,'no','Innlegget periodens sluttdato',0),(238482,6625,'da','IndlÃ¦g til slutdato',0),(238483,6625,'ko','ê¸°ê°„ ë ë‚ ì§œ ê²Œì‹œë¬¼',0),(238484,6625,'he','×¤×•×¡×˜ ×¢×œ ×ª××¨×™×š ×¡×™×•× ×©×œ ×ª×§×•×¤×ª',0),(238485,6625,'el','Î˜Î­ÏƒÎ· Î½Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(238486,6625,'zh','é‚®æ”¿æ—¶æœŸçš„ç»“æŸæ—¥æœŸ\r\n',0),(238487,6625,'sv','Post till slutdatum',0),(238488,6625,'it','Post per data di fine periodo',0),(238489,6625,'tl','',0),(238490,6625,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3611;&#3618;&#3633;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(238491,6625,'hi','à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤…à¤‚à¤¤ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(238492,6625,'ms','Pos ke tarikh tamat tempoh',0),(238493,6625,'ar','ÙˆØ¸ÙŠÙØ© Ù„ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©',0),(238494,6625,'fr','Poste Ã  la Date de fin de pÃ©riode',0),(238495,6625,'jp','æœŸé–“ã®çµ‚äº†æ—¥ã«æŠ•ç¨¿',0),(238496,6625,'pt','Post a data de fim do perÃ­odo',0),(238497,6625,'ru','ÐŸÐ¾ÑÑ‚ Ð´Ð»Ñ Ð´Ð°Ñ‚Ñ‹ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(238498,6625,'es','Asentar a Fecha de TÃ©rminaciÃ³n del PerÃ­odo',0),(238499,6625,'de','Post an Abschnittenddatum',0),(238500,6625,'en','Post to Period End Date',0),(238501,6626,'is','',0),(238502,6626,'dr','W2 ØªÙ†Ø¸ÙŠÙ… Ø¬Ù‡Øª Ø²Ù…Ø§Ù† Ú†Ø§Ù¾ ',0),(238503,6626,'pr','W2 ØªÙ†Ø¸ÙŠÙ… Ø¬Ù‡Øª Ø²Ù…Ø§Ù† Ú†Ø§Ù¾ ',0),(238504,6626,'tr','W-2 tarafÄ± yazdÄ±rma zaman ayarlama',0),(238505,6626,'pl','W-2 dostosowanie po stronie podczas drukowania',0),(238506,6626,'bg','W-2 ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹Ñ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð° Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚',0),(238507,6626,'ur','W-2 Ø¬Ø¨ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ Ø·Ø±Ù Ù…Ø·Ø§Ø¨Ù‚ Ú©Ø±ÛŒÚº',0),(238508,6626,'sr','W -2 Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ð¸Ñ‚Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸ ÐºÐ°Ð´Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ðµ',0),(238509,6626,'vi','W2 chá»‰nh sá»­a máº·t khi in',0),(238510,6626,'af','W-2 Verstel kant wanneer druk',0),(238511,6626,'ro','W-2 AjustaÅ£i secundare atunci cÃ¢nd imprimare',0),(238512,6626,'et','*W2 Adjust Side When Print',0),(238513,6626,'si','W-2 prilagodite strani, ko tiskanja',0),(238514,6626,'ba','W-2 menyesuaikan Side saat cetak',0),(238515,6626,'nl','W-2 aanpassen naast wanneer Print',0),(238516,6626,'fi','W-2 sÃ¤Ã¤tÃ¤Ã¤ puolella, kun tulosta',0),(238517,6626,'no','W-2 justere Side nÃ¥r utskrift',0),(238518,6626,'da','W-2 Juster Side nÃ¥r Print',0),(238519,6626,'ko','W-2 ì¡°ì • ì¸¡ë©´ ì¸ì‡„ ë  ë•Œ',0),(238520,6626,'he','W-2 ×œ×”×ª××™× ××ª ×”×¦×“ ×‘×¢×ª ×”×“×¤×¡×”',0),(238521,6626,'el','W-2 Ï€ÏÎ¿ÏƒÎ±ÏÎ¼ÏŒÏƒÎµÏ„Îµ Ï€Î»ÎµÏ…ÏÎ¬ ÏŒÏ„Î±Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(238522,6626,'zh','æ‰“å°æ—¶W2è°ƒæ•´ä¸€é¢\r\n',0),(238523,6626,'sv','W-2 Anpassa sida nÃ¤r Print',0),(238524,6626,'it','W-2 regolare di lato quando stampa',0),(238525,6626,'tl','',0),(238526,6626,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3604;&#3657;&#3634;&#3609;&#3586;&#3629;&#3591; W2 &#3648;&#3617;&#3639;&#3656;&#3629;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(238527,6626,'hi','W-2 à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤œà¤¬ à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥€ à¤“à¤°',0),(238528,6626,'ms','W-2 laras sampingan apabila cetakan',0),(238529,6626,'ar','Ø«-2 Ø¶Ø¨Ø· Ø§Ù„Ø¬Ø§Ù†Ø¨ Ø¹Ù†Ø¯ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(238530,6626,'fr','W-2 ajuster cÃ´tÃ© quand impression',0),(238531,6626,'jp','W 2 å°åˆ·å´ã‚’èª¿æ•´ã—ã¾ã™ã€‚',0),(238532,6626,'pt','W-2 ajuste lateral quando imprimir',0),(238533,6626,'ru','W-2 Ð¾Ñ‚Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹ Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(238534,6626,'es','W-2 Ajuste el Lado cuando Imprimir',0),(238535,6626,'de','W-2 einstellen Seite beim Drucken',0),(238536,6626,'en','W-2 Adjust Side When Print',0),(238537,6627,'is','',0),(238538,6627,'dr','W2 ØªÙ†Ø¸ÙŠÙ… Ø¨Ø§Ù„Ø§ Ø²Ù…Ø§Ù† Ú†Ø§Ù¾',0),(238539,6627,'pr','W2 ØªÙ†Ø¸ÙŠÙ… Ø¨Ø§Ù„Ø§ Ø²Ù…Ø§Ù† Ú†Ø§Ù¾',0),(238540,6627,'tr','W-2 Ã¼st baskÄ± zaman ayarlama',0),(238541,6627,'pl','W-2 dostosowanie Top podczas drukowania',0),(238542,6627,'bg','W-2 Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¾Ñ‚Ð³Ð¾Ñ€Ðµ Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚',0),(238543,6627,'ur','W-2 Ø§ÙˆÙ¾Ø± Ø¬Ø¨ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(238544,6627,'sr','W -2 Ð¿Ð¾Ð´ÐµÑÐ¸ Ð³Ð¾Ñ€Ðµ ÐºÐ°Ð´Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ðµ',0),(238545,6627,'vi','W2 chá»‰nh sá»­a pháº§n trÃªn khi in',0),(238546,6627,'af','W-2 pas bo wanneer druk',0),(238547,6627,'ro','W-2 AjustaÅ£i sus atunci cÃ¢nd imprimare',0),(238548,6627,'et','*W2 Adjust Top When Print',0),(238549,6627,'si','W-2 prilagodite vrh pri tiskalnega',0),(238550,6627,'ba','W-2 menyesuaikan atas ketika cetak',0),(238551,6627,'nl','W-2 aanpassen Top wanneer afdrukken',0),(238552,6627,'fi','W-2 ylÃ¶s kun tulosta',0),(238553,6627,'no','W-2 justere topp nÃ¥r utskrift',0),(238554,6627,'da','W-2 Juster Top nÃ¥r Print',0),(238555,6627,'ko','W-2 ìƒë‹¨ ì¸ì‡„ ë•Œ ì¡°ì •',0),(238556,6627,'he','W-2 ×œ×”×ª××™× ×”×¢×œ×™×•×Ÿ ×‘×¢×ª ×”×“×¤×¡×”',0),(238557,6627,'el','W-2 Î¡Ï…Î¸Î¼Î¯ÏƒÏ„Îµ ÎºÎ¿ÏÏ…Ï†Î® ÏŒÏ„Î±Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(238558,6627,'zh','æ‰“å°æ—¶W2è°ƒæ•´é¡¶éƒ¨\r\n',0),(238559,6627,'sv','W-2 justera topp nÃ¤r Print',0),(238560,6627,'it','W-2 regolare Top quando stampa',0),(238561,6627,'tl','',0),(238562,6627,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3604;&#3657;&#3634;&#3609;&#3610;&#3609;&#3586;&#3629;&#3591; W2 &#3648;&#3617;&#3639;&#3656;&#3629;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(238563,6627,'hi','W-2 à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤œà¤¬ à¤®à¥à¤¦à¥à¤°à¤£ à¤¶à¥€à¤°à¥à¤·',0),(238564,6627,'ms','W-2 laras atas apabila cetakan',0),(238565,6627,'ar','Ø«-2 Ø¶Ø¨Ø· Ø£Ø¹Ù„Ù‰ Ø¹Ù†Ø¯ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(238566,6627,'fr','W-2 ajuster haut quand impression',0),(238567,6627,'jp','W 2 èª¿æ•´æ™‚å°åˆ·ãƒˆãƒƒãƒ—',0),(238568,6627,'pt','W-2 Ajuste superior quando imprimir',0),(238569,6627,'ru','W-2 Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Top Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(238570,6627,'es','W-2 Ajuste la Cabeza cuando Imprimir',0),(238571,6627,'de','W-2 einstellen oben beim Drucken',0),(238572,6627,'en','W-2 Adjust Top When Print',0),(238573,6628,'is','',0),(238574,6628,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(238575,6628,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(238576,6628,'tr','Yeni Ã¶deme tipi',0),(238577,6628,'pl','Nowy typ pÅ‚acy',0),(238578,6628,'bg','ÐÐ¾Ð² Ñ‚Ð¸Ð¿ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(238579,6628,'ur','Ù†Ø¦ÛŒ ØªÙ†Ø®ÙˆØ§Û Ù‚Ø³Ù…',0),(238580,6628,'sr','ÐÐ¾Ð²Ð¸ Ñ‚Ð¸Ð¿ Ð¿Ð»Ð°Ñ‚Ðµ',0),(238581,6628,'vi','ThÃªm Loáº¡i thanh toÃ¡n',0),(238582,6628,'af','Betaal Tipe Byvoeg',0),(238583,6628,'ro','Noul tip de plata',0),(238584,6628,'et','Uus tasutÃ¼Ã¼p',0),(238585,6628,'si','Nova vrsta plaÄila',0),(238586,6628,'ba','Tipe membayar baru',0),(238587,6628,'nl','Nieuwe Pay-Type',0),(238588,6628,'fi','Uusi maksulaji',0),(238589,6628,'no','Nye lÃ¸nnstype',0),(238590,6628,'da','Ny lÃ¸nart',0),(238591,6628,'ko','ìƒˆë¡œìš´ ì§€ë¶ˆ ìœ í˜•',0),(238592,6628,'he','×¡×•×’ ×”×©×›×¨ ×”×—×“×©',0),(238593,6628,'el','ÎÎ­Î¿Ï‚ Ï„ÏÏ€Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(238594,6628,'zh','æ”¯ä»˜ç±»åž‹æ·»åŠ \r\n',0),(238595,6628,'sv','Nya lÃ¶netyp',0),(238596,6628,'it','Nuovo tipo di retribuzione',0),(238597,6628,'tl','',0),(238598,6628,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(238599,6628,'hi','à¤¨à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(238600,6628,'ms','Jenis gaji baru',0),(238601,6628,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(238602,6628,'fr','Nouveau Type de paiement',0),(238603,6628,'jp','æ–°ã—ã„æ”¯æ‰•ã‚¿ã‚¤ãƒ—',0),(238604,6628,'pt','Novo tipo de pagamento',0),(238605,6628,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(238606,6628,'es','Agregar Tipo de Pago',0),(238607,6628,'de','Neue Lohnart',0),(238608,6628,'en','New Pay Type',0),(238609,6629,'is','',0),(238610,6629,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(238611,6629,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(238612,6629,'tr','Ã–deme tipi DÃ¼zenle',0),(238613,6629,'pl','EdytowaÄ‡ typ pÅ‚acy',0),(238614,6629,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(238615,6629,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(238616,6629,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ‚Ð¸Ð¿ Ð¿Ð»Ð°Ñ‚Ðµ',0),(238617,6629,'vi','Cáº­p Nháº­t Loáº¡i LÆ°Æ¡ng',0),(238618,6629,'af','Betaal Tipe Opdateer',0),(238619,6629,'ro','Editare tip de plata',0),(238620,6629,'et','Muuda tasu tÃ¼Ã¼p',0),(238621,6629,'si','Uredite plaÄilo vrsto',0),(238622,6629,'ba','Mengedit membayar jenis',0),(238623,6629,'nl','Pay Type bewerken',0),(238624,6629,'fi','Muokkaa maksulaji',0),(238625,6629,'no','Redigere lÃ¸nnstype',0),(238626,6629,'da','Redigere lÃ¸nart',0),(238627,6629,'ko','ì§€ë¶ˆ í˜•ì‹ íŽ¸ì§‘',0),(238628,6629,'he','×¢×¨×•×š ×¡×•×’ ×”×©×›×¨',0),(238629,6629,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï… Pay',0),(238630,6629,'zh','æ”¯ä»˜ç±»åž‹æ›´æ–°\r\n',0),(238631,6629,'sv','Redigera lÃ¶netyp',0),(238632,6629,'it','Modificare il tipo di retribuzione',0),(238633,6629,'tl','',0),(238634,6629,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(238635,6629,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(238636,6629,'ms','Edit jenis gaji',0),(238637,6629,'ar','ØªØ­Ø±ÙŠØ± Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹',0),(238638,6629,'fr','Modifier le Type de paiement',0),(238639,6629,'jp','æ”¯æ‰•ã‚¿ã‚¤ãƒ—ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(238640,6629,'pt','Editar o tipo de pagamento',0),(238641,6629,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(238642,6629,'es','Tipo de Pago Actualizar',0),(238643,6629,'de','Bearbeiten Sie die Zahlungsart',0),(238644,6629,'en','Edit Pay Type',0),(238645,6630,'is','',0),(238646,6630,'dr','12 Ø·Ø±Ø­ ÙˆØ§Ø¬Ø¯ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù…',0),(238647,6630,'pr','Ú©Ø§Ø¯Ø± 12 Ø·Ø±Ø­ ÙˆØ§Ø¬Ø¯ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù…',0),(238648,6630,'tr','Kutu 12 nitelikli Plan',0),(238649,6630,'pl','Pole 12 wykwalifikowanych Plan',0),(238650,6630,'bg','ÐšÐ»ÐµÑ‚ÐºÐ° 12 ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð»Ð°Ð½',0),(238651,6630,'ur','Ø§ÛÙ„ Ø®Ø§Ù†Û 12 Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(238652,6630,'sr','12 ÐºÑƒÑ‚Ð¸Ñ˜Ð° ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¸Ñ… ÐŸÐ»Ð°Ð½',0),(238653,6630,'vi','Káº¿ hoáº¡ch Ä‘áº¡t chuáº©n há»™p 12',0),(238654,6630,'af','Posbus 12 gekwalifiseerde Plan',0),(238655,6630,'ro','Rubrica 12 calificat Plan',0),(238656,6630,'et','Lahter 12 kvalifitseeritud plaan',0),(238657,6630,'si','Polje 12 kvalificirano naÄrt',0),(238658,6630,'ba','12 kotak berkualitas rencana',0),(238659,6630,'nl','Vak 12 gekwalificeerde Plan',0),(238660,6630,'fi','Laatikko 12 pÃ¤tevÃ¤ suunnitelma',0),(238661,6630,'no','Boks 12 kvalifisert Plan',0),(238662,6630,'da','Boks 12 kvalificeret Plan',0),(238663,6630,'ko','ìƒìž 12 ìžê²©ëœ ê³„íš',0),(238664,6630,'he','×ª×•×›× ×™×ª ×ž×•×¡×ž×š ×ª×™×‘×ª 12',0),(238665,6630,'el','Î•Î¹Î´Î¹ÎºÎ® ÏƒÏ‡Î­Î´Î¹Î¿ ÎºÎ¿Ï…Ï„Î¯ 12',0),(238666,6630,'zh','æ¡†12åˆæ ¼è®¡åˆ’\r\n',0),(238667,6630,'sv','Ruta 12 kvalificerad Plan',0),(238668,6630,'it','Scatola 12 piano qualificato',0),(238669,6630,'tl','',0),(238670,6630,'th','&#3585;&#3621;&#3656;&#3629;&#3591; 12 &#3649;&#3612;&#3609;&#3612;&#3656;&#3634;&#3609;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;',0),(238671,6630,'hi','à¤¬à¥‰à¤•à¥à¤¸ 12 à¤¯à¥‹à¤—à¥à¤¯ à¤¯à¥‹à¤œà¤¨à¤¾',0),(238672,6630,'ms','Kotak 12 layak pelan',0),(238673,6630,'ar','Ø®Ø·Ø© 12 Ø®Ø§Ù†Ø© Ø§Ù„Ù…Ø¤Ù‡Ù„ÙŠÙ†',0),(238674,6630,'fr','EncadrÃ© 12 Plan qualifiÃ©',0),(238675,6630,'jp','ãƒœãƒƒã‚¯ã‚¹ 12 é™å®šãƒ—ãƒ©ãƒ³',0),(238676,6630,'pt','Caixa 12 plano qualificado',0),(238677,6630,'ru','Ð’ÑÑ‚Ð°Ð²ÐºÐ° 12 ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð¿Ð»Ð°Ð½',0),(238678,6630,'es','Caja 12 Plan Calificado',0),(238679,6630,'de','Feld 12 qualifizierte Plan',0),(238680,6630,'en','Box 12 Qualified Plan',0),(238681,6631,'is','',0),(238682,6631,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ø¹Ø¨Ù‡ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÙŠ Ø¯Ø±  Ú†Ø§Ù¾\r\nW2',0),(238683,6631,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ø¹Ø¨Ù‡ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÙŠ Ø¯Ø±  Ú†Ø§Ù¾\r\nW2',0),(238684,6631,'tr','W-2 baskÄ± Ã¼zerine emeklilik kutuyu iÅŸaretleyin',0),(238685,6631,'pl','Pole wyboru emerytury na wydruku W-2',0),(238686,6631,'bg','ÐŸÐµÐ½ÑÐ¸Ð¾Ð½Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ²Ð°Ð´Ñ€Ð°Ñ‚Ñ‡ÐµÑ‚Ð¾ Ð¿ÐµÑ‡Ð°Ñ‚ W-2',0),(238687,6631,'ur','W-2 Ú†Ú¾Ø§Ù¾ÛŒÚº Ù¾Ø± Ø±ÛŒÙ¹Ø§Ø¦Ø±Ù…Ù†Ù¹ Ø®Ø§Ù†Û Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(238688,6631,'sr','ÐŸÐµÐ½Ð·Ð¸Ñ˜Ð° Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð½Ð° W-2 ÐŸÑ€Ð¸Ð½Ñ‚',0),(238689,6631,'vi','ÄÃ¡nh dáº¥u vÃ o há»™p nghá»‰ hÆ°u trÃªn pháº§n in W2',0),(238690,6631,'af','Merk Aftree Boksie op W2 Druk',0),(238691,6631,'ro','Pensionare caseta de selectare imprimare W-2',0),(238692,6631,'et','W-2 Prindi pensionile ruut',0),(238693,6631,'si','Upokojitev, potrdili polje Natisni W-2',0),(238694,6631,'ba','Centang kotak pensiun di cetak W-2',0),(238695,6631,'nl','Selectievakje pensionering op W-2 afdrukken',0),(238696,6631,'fi','ElÃ¤kkeelle valintaruutu W-2 tulosta',0),(238697,6631,'no','Avmerkingsboksen pensjon W-2 utskrift',0),(238698,6631,'da','Pensionering afkrydsningsfeltet pÃ¥ W-2 Print',0),(238699,6631,'ko','W-2 ì¸ì‡„ì—ì„œ í™•ì¸ëž€ ì€í‡´',0),(238700,6631,'he','×ª×™×‘×ª ×”×¡×™×ž×•×Ÿ ×¤×¨×™×©×” ×¢×œ ×”×“×¤×¡×” W-2',0),(238701,6631,'el','Î¤Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ ÎµÎ»Î­Î³Ï‡Î¿Ï… ÏƒÏ…Î½Ï„Î±Î¾Î¹Î¿Î´ÏŒÏ„Î·ÏƒÎ·Ï‚ ÏƒÎµ W-2 ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(238702,6631,'zh','æ£€æŸ¥W2é€€ä¼‘ç›’å°åˆ·\r\n',0),(238703,6631,'sv','Kryssrutan pensionering pÃ¥ W-2 ut',0),(238704,6631,'it','Pensione casella di controllo stampa W-2',0),(238705,6631,'tl','',0),(238706,6631,'th','Check Retirement Box on W2 Print',0),(238707,6631,'hi','W-2 à¤®à¥à¤¦à¥à¤°à¤£ à¤ªà¤° à¤¸à¥‡à¤µà¤¾à¤¨à¤¿à¤µà¥ƒà¤¤à¥à¤¤à¤¿ à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(238708,6631,'ms','Persaraan kotak di cetak W-2',0),(238709,6631,'ar','Ø®Ø§Ù†Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ØªÙ‚Ø§Ø¹Ø¯ Ø¹Ù„Ù‰ Ø·Ø¨Ø§Ø¹Ø© Ø«-2',0),(238710,6631,'fr','Retraite case Ã  cocher Imprimer W-2',0),(238711,6631,'jp','é€€è·ã§ãƒã‚§ãƒƒã‚¯ ãƒœãƒƒã‚¯ã‚¹ W 2 å°åˆ·',0),(238712,6631,'pt','Caixa de seleÃ§Ã£o aposentadoria Print W-2',0),(238713,6631,'ru','Ð¤Ð»Ð°Ð¶Ð¾Ðº Ð¿ÐµÐ½ÑÐ¸ÑŽ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ W-2',0),(238714,6631,'es','Marcar Caja de jubilaciÃ³n en ImpresiÃ³n de W2',0),(238715,6631,'de','Ruhestand KontrollkÃ¤stchen auf W-2-Print',0),(238716,6631,'en','Check Retirement Box on W-2 Print',0),(238717,6632,'is','',0),(238718,6632,'dr','W2 ',0),(238719,6632,'pr','Ø§Ú¯Ø± Ù†Ø§Ù…Ù‡ Ø·Ø±Ø­ ÙˆØ§Ø¬Ø¯ Ø´Ø±Ø§ÙŠØ· Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾  W2 ',0),(238720,6632,'tr','EÄŸer planÄ± harfi W-2 baskÄ± iÃ§in nitelikli',0),(238721,6632,'pl','JeÅ›li kwalifikacje list Plan do druku W-2',0),(238722,6632,'bg','ÐÐºÐ¾ ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð»Ð°Ð½ Ð¿Ð¸ÑÐ¼Ð¾ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ W-2',0),(238723,6632,'ur','Ø§Ú¯Ø± Ù…Ù†ØµÙˆØ¨Û Ø­Ø±Ù W-2 Ú©ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ§Ù„ÛŒÙØ§Ø¦ÛŒ',0),(238724,6632,'sr','ÐÐºÐ¾ ÐŸÐ»Ð°Ð½ Ð¿Ð¸ÑÐ¼Ð¾ ÑÐµ ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸ÐºÐ¾Ð²Ð°Ð»Ð° Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ W-2',0),(238725,6632,'vi','Náº¿u káº¿ hoáº¡ch Ä‘áº¡t thÆ° cho in W2',0),(238726,6632,'af','As gekwalifiseerde Plan brief vir W-2 druk',0),(238727,6632,'ro','DacÄƒ calificat Plan scrisoare pentru imprimare W-2',0),(238728,6632,'et','Kui kvalifitseeritud plaani kirja W-2 printimine',0),(238729,6632,'si','ÄŒe upraviÄene naÄrt Ärka W-2 Print',0),(238730,6632,'ba','Jika rencana surat yang memenuhi syarat untuk cetak W-2',0),(238731,6632,'nl','Als gekwalificeerd Plan brief voor W-2 afdrukken',0),(238732,6632,'fi','Jos suunnitelma kirjeen kelpuutettu W-2 tulosta',0),(238733,6632,'no','Hvis kvalifisert Plan brev for W-2 utskrift',0),(238734,6632,'da','Hvis kvalificeret Plan brev til W-2 Print',0),(238735,6632,'ko','ê³„íš íŽ¸ì§€ W 2 ì¸ì‡„ì— ëŒ€ í•œ ìžê²©ì„ ê°–ì¶˜ ê²½ìš°',0),(238736,6632,'he','×× ×ž×•×¡×ž×š ×ª×•×›× ×™×ª ×ž×›×ª×‘ ×œ×”×“×¤×¡×” W-2',0),(238737,6632,'el','Î‘Î½ ÎµÎ¹Î´Î¹ÎºÎ® ÎµÏ€Î¹ÏƒÏ„Î¿Î»Î® ÏƒÏ‡Î­Î´Î¹Î¿ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· W-2',0),(238738,6632,'zh','å¦‚æžœå¯¹è¥¿äºŒçŽ¯åˆæ ¼è®¡åˆ’ä¹¦æ‰“å°\r\n',0),(238739,6632,'sv','Om kvalificerad Plan brev fÃ¶r W-2 Tryck',0),(238740,6632,'it','Se qualificato piano di lettera per la stampa di W-2',0),(238741,6632,'tl','',0),(238742,6632,'th','If Qualified Plan Letter for W2 Print',0),(238743,6632,'hi','à¤¯à¤¦à¤¿ à¤¯à¥‹à¤œà¤¨à¤¾ à¤ªà¤¤à¥à¤° à¤•à¥‡ à¤²à¤¿à¤ W-2 à¤®à¥à¤¦à¥à¤°à¤£ à¤¯à¥‹à¤—à¥à¤¯',0),(238744,6632,'ms','Jika layak Surat pelan cetak W-2',0),(238745,6632,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ù…Ø¤Ù‡Ù„Ø§Ù‹ Ø®Ø·Ø© Ø§Ù„Ø±Ø³Ø§Ù„Ø© Ù„Ù„Ø·Ø¨Ø§Ø¹Ø© Ø«-2',0),(238746,6632,'fr','S\'il est qualifiÃ© de Plan lettre pour l\'impression de W-2',0),(238747,6632,'jp','è¨ˆç”»ã®æ‰‹ç´™ W 2 å°åˆ·ã®ä¿®é£¾ã•ã‚Œã¦ã„ã‚‹å ´åˆ',0),(238748,6632,'pt','Se qualificado plano carta para impressÃ£o de W-2',0),(238749,6632,'ru','Ð•ÑÐ»Ð¸ Ð¿Ð»Ð°Ð½ Ð¿Ð¸ÑÑŒÐ¼Ð° Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ W-2',0),(238750,6632,'es','Si Carta de Plan Calificado para Imprimir el W2',0),(238751,6632,'de','Ob Plan Brief fÃ¼r die W-2-Print geeignet',0),(238752,6632,'en','If Qualified Plan Letter for W-2 Print',0),(238753,6633,'is','',0),(238754,6633,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ ',0),(238755,6633,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ ',0),(238756,6633,'tr','GL hesabÄ± eksik',0),(238757,6633,'pl','Brak konta GL',0),(238758,6633,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(238759,6633,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ ØºØ§Ø¦Ø¨',0),(238760,6633,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(238761,6633,'vi','Thiáº¿u TK Sá»• CÃ¡i Tá»•ng Há»£p \r\n',0),(238762,6633,'af','\"Missing\" AG Rekening',0),(238763,6633,'ro','Lipsesc GL cont',0),(238764,6633,'et','Pearaamatu konto puudub',0),(238765,6633,'si','ManjkajoÄi raÄun GL',0),(238766,6633,'ba','Hilang GL Account',0),(238767,6633,'nl','Ontbrekende GL Account',0),(238768,6633,'fi','GL tili puuttuu',0),(238769,6633,'no','Manglende gi-konto',0),(238770,6633,'da','Mangler GL konto',0),(238771,6633,'ko','ëˆ„ë½ ëœ GL ê³„ì •',0),(238772,6633,'he','×—×¡×¨ ×—×©×‘×•×Ÿ GL',0),(238773,6633,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Ï€Î¿Ï… Î»ÎµÎ¯Ï€Î¿Ï…Î½',0),(238774,6633,'zh','ç¼ºå°‘æ€»å¸å¸æˆ·\r\n',0),(238775,6633,'sv','Saknade GL konto',0),(238776,6633,'it','Manca GL Account',0),(238777,6633,'tl','',0),(238778,6633,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3627;&#3634;&#3618;&#3652;&#3611;',0),(238779,6633,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§',0),(238780,6633,'ms','Hilang GL akaun',0),(238781,6633,'ar','Ø­Ø³Ø§Ø¨ GL Ù…ÙÙ‚ÙˆØ¯',0),(238782,6633,'fr','Manque de compte GL',0),(238783,6633,'jp','è¡Œæ–¹ä¸æ˜Žã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(238784,6633,'pt','Falta conta GL',0),(238785,6633,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ GL',0),(238786,6633,'es','Falta Cuenta LM',0),(238787,6633,'de','Fehlende Sako',0),(238788,6633,'en','Missing GL Account',0),(238789,6634,'is','',0),(238790,6634,'dr','Ø¬Ø¨Ø±Ø§Ù† Ø®Ø³Ø§Ø±Øª ÙƒØ§Ø±Ú¯Ø±Ø§Ù† ',0),(238791,6634,'pr','Ø¬Ø¨Ø±Ø§Ù† Ø®Ø³Ø§Ø±Øª ÙƒØ§Ø±Ú¯Ø±Ø§Ù† ',0),(238792,6634,'tr','Ä°ÅŸÃ§i tazminat',0),(238793,6634,'pl','Wynagrodzenie pracownikÃ³w',0),(238794,6634,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ†Ð¸Ñ‚Ðµ Ð¾Ð±ÐµÐ·Ñ‰ÐµÑ‚ÐµÐ½Ð¸Ðµ',0),(238795,6634,'ur','Ú©Ø§Ø±Ú©Ù†Ø§Ù† Ú©Ø§ Ù…Ø¹Ø§ÙˆØ¶Û',0),(238796,6634,'sr','ÐšÐ¾Ð¼Ð¿ÐµÐ½Ð·Ð°Ñ†Ð¸Ñ˜Ð° Ñ€Ð°Ð´Ð½Ð¸ÐºÐ°',0),(238797,6634,'vi','LÆ°Æ¡ng CÃ´ng nhÃ¢n',0),(238798,6634,'af','Vergoedingskommisaris',0),(238799,6634,'ro','LucrÄƒtorilor despÄƒgubiri',0),(238800,6634,'et','Kompensatsioon tÃ¶Ã¶lisele',0),(238801,6634,'si','Delavcev odÅ¡kodnina',0),(238802,6634,'ba','Kompensasi pekerja',0),(238803,6634,'nl','Arbeiderscompensatie',0),(238804,6634,'fi','TyÃ¶ntekijÃ¤t korvaukset',0),(238805,6634,'no','Arbeidstakere kompensasjon',0),(238806,6634,'da','Workers Compensation',0),(238807,6634,'ko','ë…¸ë™ìž ë³´ìƒ',0),(238808,6634,'he','×¤×™×¦×•×™ ×œ×¢×•×‘×“×™×',0),(238809,6634,'el','Î‘Ï€Î¿Î¶Î·Î¼Î¯Ï‰ÏƒÎ· Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(238810,6634,'zh','å·¥äººèµ”å¿\r\n',0),(238811,6634,'sv','Workers Compensation',0),(238812,6634,'it','Compensazione degli operai',0),(238813,6634,'tl','',0),(238814,6634,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;&#3594;&#3604;&#3648;&#3594;&#3618;',0),(238815,6634,'hi','à¤¶à¥à¤°à¤®à¤¿à¤• à¤®à¥à¤†à¤µà¤œà¤¾',0),(238816,6634,'ms','Pampasan pekerja',0),(238817,6634,'ar','ØªØ¹ÙˆÙŠØ¶ Ø§Ù„Ø¹Ù…Ø§Ù„',0),(238818,6634,'fr','Workers Compensation',0),(238819,6634,'jp','åŠ´åƒè€…ã®è£œå„Ÿ',0),(238820,6634,'pt','CompensaÃ§Ã£o dos trabalhadores',0),(238821,6634,'ru','ÐšÐ¾Ð¼Ð¿ÐµÐ½ÑÐ°Ñ†Ð¸Ð¸ Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ñ…',0),(238822,6634,'es','CompesaciÃ³n de Trabajadores',0),(238823,6634,'de','Workers Compensation',0),(238824,6634,'en','Workers Compensation',0),(238825,6635,'is','',0),(238826,6635,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø¨Ø¯ÙˆÙ† Ù…Ø¹Ø§ÙÙŠØª ',0),(238827,6635,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø¨Ø¯ÙˆÙ† Ù…Ø¹Ø§ÙÙŠØª ',0),(238828,6635,'tr','HayÄ±r muafiyet tutarÄ±',0),(238829,6635,'pl','Kwota zwolnienia nie',0),(238830,6635,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° Ð½Ð¸ÐºÐ°ÐºÐ²Ð¾ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ',0),(238831,6635,'ur','Ø±Ù‚Ù… Ú©ÙˆØ¦ÛŒ Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ú©Û’ Ù„Ø¦Û’',0),(238832,6635,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° Ð½ÐµÐ¼Ð° Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(238833,6635,'vi','Sá»‘ Tiá»n KhÃ´ng Miá»ƒn Trá»«',0),(238834,6635,'af','Bedrag vir Geen Vrystelling',0),(238835,6635,'ro','Suma de nici o scutire',0),(238836,6635,'et','Summa pole erand',0),(238837,6635,'si','Znesek za oprostitev',0),(238838,6635,'ba','Jumlah pembebasan tidak',0),(238839,6635,'nl','Bedrag voor geen enkele vrijstelling',0),(238840,6635,'fi','MyÃ¶nnettÃ¤vÃ¤n vapautuksen',0),(238841,6635,'no','BelÃ¸pet for ingen unntak',0),(238842,6635,'da','BelÃ¸b for ingen undtagelse',0),(238843,6635,'ko','ì•„ë¬´ ë©´ì œ ê¸ˆì•¡',0),(238844,6635,'he','×”×¡×›×•× ×”×¤×˜×•×¨ ××™×Ÿ',0),(238845,6635,'el','Î Î¿ÏƒÏŒ Î´ÎµÎ½ Î‘Î Î‘Î›Î›Î‘Î“Î—Î£',0),(238846,6635,'zh','ä¸å…ç¨Žé‡‘é¢\r\n',0),(238847,6635,'sv','Belopp fÃ¶r skattebefrielse',0),(238848,6635,'it','QuantitÃ  di nessuna esenzione',0),(238849,6635,'tl','',0),(238850,6635,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;',0),(238851,6635,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤›à¥‚à¤Ÿ',0),(238852,6635,'ms','Amaun pengecualian tidak',0),(238853,6635,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù„Ù„Ø§ Ø¥Ø¹ÙØ§Ø¡',0),(238854,6635,'fr','Montant pour aucune Exemption',0),(238855,6635,'jp','å…é™¤ãªã—ã®é‡‘é¡',0),(238856,6635,'pt','Quantidade de nenhuma isenÃ§Ã£o',0),(238857,6635,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð´Ð»Ñ Ð½Ðµ Ð¸ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ',0),(238858,6635,'es','Cantidad para No ExenciÃ³n ',0),(238859,6635,'de','Betrag fÃ¼r keine Befreiung',0),(238860,6635,'en','Amount for No Exemption',0),(238861,6636,'is','',0),(238862,6636,'dr','Ú¯Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ù„Ø§Ø±Ù‡Ø§',0),(238863,6636,'pr','Ú¯Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ù„Ø§Ø±Ù‡Ø§',0),(238864,6636,'tr','Yuvarlak vergi dolar',0),(238865,6636,'pl','CaÅ‚y podatek dolarÃ³w',0),(238866,6636,'bg','ÐšÑ€ÑŠÐ³Ð»Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð´Ð¾Ð»Ð°Ñ€Ð°',0),(238867,6636,'ur','Ú¯ÙˆÙ„ Ù¹ÛŒÚ©Ø³ ÚˆØ§Ù„Ø±',0),(238868,6636,'sr','ÐžÐºÑ€ÑƒÐ³Ð»Ð° Ð¾Ð´ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(238869,6636,'vi','LÃ m trÃ²n tiá»n thuáº¿ Dola',0),(238870,6636,'af','Ronde belasting Dollars',0),(238871,6636,'ro','Runda taxa de dolari',0),(238872,6636,'et','Vooru maksu dollarit',0),(238873,6636,'si','Krog davÄnih dolarjev',0),(238874,6636,'ba','Dolar pajak bulat',0),(238875,6636,'nl','Ronde belastingsdollars',0),(238876,6636,'fi','PyÃ¶reÃ¤ vero dollaria',0),(238877,6636,'no','Runde skattepenger',0),(238878,6636,'da','Runde skattekroner',0),(238879,6636,'ko','ë¼ìš´ë“œ ì„¸ê¸ˆ',0),(238880,6636,'he','×”×ž×™×¡×™× ×¢×’×•×œ',0),(238881,6636,'el','Î“ÏÏÎ¿ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ¬ Î´Î¿Î»Î¬ÏÎ¹Î¬',0),(238882,6636,'zh','å›žåˆç¨Žæ¬¾\r\n',0),(238883,6636,'sv','Runda skattepengar',0),(238884,6636,'it','Circolare fiscale dollari',0),(238885,6636,'tl','',0),(238886,6636,'th','&#3619;&#3629;&#3610;&#3648;&#3591;&#3636;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(238887,6636,'hi','à¤—à¥‹à¤² à¤•à¤° à¤¡à¥‰à¤²à¤°',0),(238888,6636,'ms','Wang cukai pusingan',0),(238889,6636,'ar','Ø¯ÙˆÙ„Ø§Ø± Ø¶Ø±ÙŠØ¨Ø© Ø¬ÙˆÙ„Ø©',0),(238890,6636,'fr','Argent des contribuables rond',0),(238891,6636,'jp','å††å½¢ç¨Žãƒ‰ãƒ«',0),(238892,6636,'pt','Rodada de impostos',0),(238893,6636,'ru','ÐšÑ€ÑƒÐ³Ð»Ñ‹Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð´Ð¾Ð»Ð»Ð°Ñ€Ñ‹',0),(238894,6636,'es','Redondear DÃ³lares de Impuesto',0),(238895,6636,'de','Runde Steuergelder',0),(238896,6636,'en','Round Tax Dollars',0),(238897,6637,'is','',0),(238898,6637,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(238899,6637,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(238900,6637,'tr','Vergi tÃ¼rÃ¼ Ekle',0),(238901,6637,'pl','DodaÄ‡ typ podatku',0),(238902,6637,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð´Ð°Ð½ÑŠÐº',0),(238903,6637,'ur','Ù¹ÛŒÚ©Ø³ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(238904,6637,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÑÑ‚Ð° ÐŸÐ”Ð’-Ð°',0),(238905,6637,'vi','ThÃªm Loáº¡i thuáº¿',0),(238906,6637,'af','Belastingtipe Skep',0),(238907,6637,'ro','Adauga fiscale tip',0),(238908,6637,'et','Maksu liigi lisamine',0),(238909,6637,'si','Dodaj izstavljenih',0),(238910,6637,'ba','Menambahkan jenis pajak',0),(238911,6637,'nl','Fiscale Type toevoegen',0),(238912,6637,'fi','ALV-tyyppi lisÃ¤Ã¤',0),(238913,6637,'no','Skatt Type legge',0),(238914,6637,'da','Skat Type tilfÃ¸je',0),(238915,6637,'ko','ì„¸ê¸ˆ ìœ í˜• ì¶”ê°€',0),(238916,6637,'he','×”×•×¡×£ ×¡×•×’ ×ž×¡',0),(238917,6637,'el','Î¤ÏÏ€Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ',0),(238918,6637,'zh','æ–°å¢žç¨Žç§\r\n',0),(238919,6637,'sv','Skatt typ lÃ¤gga till',0),(238920,6637,'it','Aggiungi tipo di tassa',0),(238921,6637,'tl','',0),(238922,6637,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;',0),(238923,6637,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(238924,6637,'ms','Tambah jenis cukai',0),(238925,6637,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø¶Ø±ÙŠØ¨Ø©',0),(238926,6637,'fr','Type de taxe ajouter',0),(238927,6637,'jp','ç¨Žã®ç¨®é¡žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(238928,6637,'pt','Adicionar o tipo de imposto',0),(238929,6637,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿ ÐÐ°Ð»Ð¾Ð³Ð°',0),(238930,6637,'es','Tipo de Impuesto Agregar',0),(238931,6637,'de','Steuerart hinzufÃ¼gen',0),(238932,6637,'en','Tax Type Add',0),(238933,6638,'is','',0),(238934,6638,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¢Ø®Ø±ÙŠÙ† Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ',0),(238935,6638,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¢Ø®Ø±ÙŠÙ† Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ',0),(238936,6638,'tr','Son GÃ¼ncellenme Tarihi raporu',0),(238937,6638,'pl','Ostatnia aktualizacja raportu',0),(238938,6638,'bg','Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½',0),(238939,6638,'ur','Ø¢Ø®Ø±ÛŒ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(238940,6638,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿ÑƒÑ‚ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¾',0),(238941,6638,'vi','BÃ¡o CÃ¡o Cáº­p Nháº­t Láº§n Cuá»‘i',0),(238942,6638,'af','Verslag Laas Opdateer',0),(238943,6638,'ro','Raport ultima actualizare',0),(238944,6638,'et','Aruannet viimati uuendatud',0),(238945,6638,'si','Nazadnje posodobljeno poroÄilo',0),(238946,6638,'ba','Laporan terakhir diperbarui',0),(238947,6638,'nl','Verslag voor het laatst bijgewerkt',0),(238948,6638,'fi','Viimeksi pÃ¤ivitetty raportti',0),(238949,6638,'no','Rapporten sist oppdatert',0),(238950,6638,'da','BetÃ¦nkningen sidst opdateret',0),(238951,6638,'ko','ë³´ê³ ì„œë¥¼ ë§ˆì§€ë§‰ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(238952,6638,'he','×“×• ×— ×¢×“×›×•×Ÿ ××—×¨×•×Ÿ',0),(238953,6638,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(238954,6638,'zh','æŠ¥å‘Šçš„æœ€åŽæ›´æ–°\r\n',0),(238955,6638,'sv','Rapport senast uppdaterad',0),(238956,6638,'it','Relazione ultimo aggiornata',0),(238957,6638,'tl','',0),(238958,6638,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(238959,6638,'hi','à¤ªà¤¿à¤›à¤²à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¤à¤¿à¤¥à¤¿: à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(238960,6638,'ms','Laporan yang dikemaskini',0),(238961,6638,'ar','ØªÙ‚Ø±ÙŠØ± Ø¢Ø®Ø± ØªØ­Ø¯ÙŠØ«',0),(238962,6638,'fr','Rapport mis Ã  jour',0),(238963,6638,'jp','æœ€å¾Œã«æ›´æ–°ã•ã‚ŒãŸãƒ¬ãƒãƒ¼ãƒˆ',0),(238964,6638,'pt','Ãšltima atualizado de relatÃ³rio',0),(238965,6638,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐžÑ‚Ñ‡ÐµÑ‚Ð°',0),(238966,6638,'es','Ultima ActualizaciÃ³n del Informe',0),(238967,6638,'de','Bericht Datenstand',0),(238968,6638,'en','Report Last Updated',0),(238969,6639,'is','',0),(238970,6639,'dr','Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø®ÙˆØ¯ Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§ ',0),(238971,6639,'pr','Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø®ÙˆØ¯ Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§ ',0),(238972,6639,'tr','Burada hesap eriÅŸim',0),(238973,6639,'pl','DostÄ™p do konta tutaj',0),(238974,6639,'bg','Ð”Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ð²Ð°ÑˆÐ¸Ñ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ñ‚ÑƒÐº',0),(238975,6639,'ur','Ø§Ù†Ù¾Ø§ Ù†ÙˆÙ„Ø§ Ù¾Ø±Ùˆ Ø§Ú©Ø§ÙˆÙ†Ù¹ Ø§Ú©Ø³Ø³ Ú©Ø±ÛŒÚº',0),(238976,6639,'sr','ÐŸÑ€Ð¸ÑÑ‚ÑƒÐ¿Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ð¼ Ð½Ð°Ð»Ð¾Ð³Ñƒ Ð¾Ð²Ð´Ðµ',0),(238977,6639,'vi','Truy Cáº­p TK NolaPro Táº¡i ÄÃ¢y',0),(238978,6639,'af','Kry Hier Toegang tot u NolaPro Rekening.',0),(238979,6639,'ro','Acceseaza contul tau NolaPro aici',0),(238980,6639,'et','Sisene oma kontole',0),(238981,6639,'si','Postranski vaÅ¡ raÄun tukaj',0),(238982,6639,'ba','Gunakan Akun NolaPro Anda Disini',0),(238983,6639,'nl','Toegang tot uw Account hier',0),(238984,6639,'fi','TiliÃ¤si tÃ¤ssÃ¤',0),(238985,6639,'no','FÃ¥ tilgang til kontoen her',0),(238986,6639,'da','FÃ¥ adgang til din konto her',0),(238987,6639,'ko','ì—¬ê¸°ì— ê·€í•˜ì˜ ê³„ì •ì— ì•¡ì„¸ìŠ¤',0),(238988,6639,'he','×œ×’×©×ª ×œ×—×©×‘×•×Ÿ ×©×œ×š ×›××Ÿ',0),(238989,6639,'el','Î£Ï…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ ÏƒÏ„Î¿Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÎ±Ï‚ ÎµÎ´ÏŽ',0),(238990,6639,'zh','é€²å…¥ä½ çš„NolaProå¸æˆ·',0),(238991,6639,'sv','Ã…tkomst till ditt konto hÃ¤r',0),(238992,6639,'it','Accedi al tuo profilo NolaPro qui',0),(238993,6639,'tl','',0),(238994,6639,'th','à¹€à¸‚à¹‰à¸²à¹ƒà¸Šà¹‰à¸Šà¸·à¹ˆà¸­à¸šà¸±à¸à¸Šà¸µà¹‚à¸™à¸¥à¸²à¹‚à¸›à¸£à¸„à¸­à¸¡à¸‚à¸­à¸‡à¸„à¸¸à¸“à¸•à¸£à¸‡à¸™à¸µà¹‰',0),(238995,6639,'hi','à¤¯à¤¹à¤¾à¤ à¤…à¤ªà¤¨à¥‡ à¤–à¤¾à¤¤à¥‡ à¤¤à¤• à¤ªà¤¹à¥à¤à¤šà¥‡à¤‚',0),(238996,6639,'ms','Akses akaun anda di sini',0),(238997,6639,'ar','Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù‡Ù†Ø§',0),(238998,6639,'fr','AccÃ©der Ã  votre Compte NolaPro Ici ',0),(238999,6639,'jp','ã“ã“ã«ã‚ãªãŸã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã¸ã®ã‚¢ã‚¯ã‚»ã‚¹ã—ã¾ã™ã€‚',0),(239000,6639,'pt','Acessar a sua conta aqui',0),(239001,6639,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿ Ðº Ð²Ð°ÑˆÐµÐ¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(239002,6639,'es','Accesa a su Cuenta Nolapro AquÃ­',0),(239003,6639,'de','Zugang zum NolaPro Konto',0),(239004,6639,'en','Access Your Account Here',0),(239005,6640,'is','',0),(239006,6640,'dr','ÙˆÙŠÚ˜Ú¯ÙŠ Ø±Ù…Ø² Ú¯Ø°Ø§Ø±ÙŠ ',0),(239007,6640,'pr','ÙˆÙŠÚ˜Ú¯ÙŠ Ø±Ù…Ø² Ú¯Ø°Ø§Ø±ÙŠ ',0),(239008,6640,'tr','Karakter kodlamasÄ±',0),(239009,6640,'pl','Kodowanie znakÃ³w',0),(239010,6640,'bg','ÐšÐ¾Ð´Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð½Ð°Ñ†Ð¸',0),(239011,6640,'ur','Ú©Ø±ÛŒÚ©Ù¹Ø± Ø¶Ø§Ø¨Ø·Û Ø¨Ù†Ø¯ÛŒ',0),(239012,6640,'sr','ÐšÐ¾Ð´Ð¸Ñ€Ð°ÑšÐµ Ð·Ð½Ð°ÐºÐ¾Ð²Ð°',0),(239013,6640,'vi','KÃ½ tá»± mÃ£ hÃ³a',0),(239014,6640,'af','Karakterkodering',0),(239015,6640,'ro','Codificare caractere',0),(239016,6640,'et','MÃ¤rkide kodeering',0),(239017,6640,'si','Kodiranje znakov',0),(239018,6640,'ba','Pengkodean karakter',0),(239019,6640,'nl','Tekencodering',0),(239020,6640,'fi','Merkkien koodaus',0),(239021,6640,'no','Tegnkoding',0),(239022,6640,'da','TegnsÃ¦t',0),(239023,6640,'ko','ë¬¸ìž ì¸ì½”ë”©',0),(239024,6640,'he','×§×™×“×•×“ ×ª×•×•×™×',0),(239025,6640,'el','ÎšÏ‰Î´Î¹ÎºÎ¿Ï€Î¿Î¯Î·ÏƒÎ· Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÏ‰Î½',0),(239026,6640,'zh','å­—ç¬¦ç¼–ç \r\n',0),(239027,6640,'sv','Teckenkodning',0),(239028,6640,'it','Codifica dei caratteri',0),(239029,6640,'tl','',0),(239030,6640,'th','&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3619;&#3627;&#3633;&#3626;&#3629;&#3633;&#3585;&#3625;&#3619;',0),(239031,6640,'hi','à¤µà¤°à¥à¤£ à¤•à¥‚à¤Ÿà¤¬à¤¨à¥à¤§à¤¨',0),(239032,6640,'ms','Pengekodan aksara',0),(239033,6640,'ar','ØªØ±Ù…ÙŠØ² Ø§Ù„Ø£Ø­Ø±Ù',0),(239034,6640,'fr','Codage de caractÃ¨res',0),(239035,6640,'jp','æ–‡å­—ã‚¨ãƒ³ã‚³ãƒ¼ãƒ‡ã‚£ãƒ³ã‚°',0),(239036,6640,'pt','CodificaÃ§Ã£o de caracteres',0),(239037,6640,'ru','ÐšÐ¾Ð´Ð¸Ñ€Ð¾Ð²ÐºÐ° ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¾Ð²',0),(239038,6640,'es','CodificaciÃ³n de CÃ¡racter',0),(239039,6640,'de','Zeichencodierung',0),(239040,6640,'en','Character Encoding',0),(239041,6641,'is','',0),(239042,6641,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ú¯ÙˆØ§Ù‡ÙŠ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø±Ø§ Ø¯Ø±ÙŠØ§ÙØª ÙƒÙ†ÙŠØ¯',0),(239043,6641,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ú¯ÙˆØ§Ù‡ÙŠ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø±Ø§ Ø¯Ø±ÙŠØ§ÙØª ÙƒÙ†ÙŠØ¯',0),(239044,6641,'tr','NolaEZ lisans almak iÃ§in tÄ±klayÄ±nÄ±z',0),(239045,6641,'pl','Kliknij tutaj, aby uzyskaÄ‡ licencjÄ™ NolaEZ',0),(239046,6641,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸ Ð»Ð¸Ñ†ÐµÐ½Ð·Ð° ÑÐ¸ NolaEZ',0),(239047,6641,'ur','Ø§Ù¾Ù†Ø§ Ù†Ø§ÙˆÙ„Ø§ÛŒØ² Ù„Ø§Ø¦Ø³Ù†Ø³ Ø­Ø§ØµÙ„ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(239048,6641,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð´Ð° ÑÐµ ÐÐ¾Ð»Ð°Ð•Ð— Ð´Ð¾Ð·Ð²Ð¾Ð»Ñƒ',0),(239049,6641,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ láº¥y giáº¥y phÃ©p NolaEZ',0),(239050,6641,'af','Kliek Hier om u NolaEZ Lisensie te Verkry',0),(239051,6641,'ro','Click aici pentru a obÅ£ine licenÅ£Äƒ NolaEZ',0),(239052,6641,'et','Vajuta siia, et oma NolaEZ litsents',0),(239053,6641,'si','Kliknite tukaj za Get NolaEZ licenco',0),(239054,6641,'ba','Klik di sini untuk mendapatkan lisensi NolaEZ Anda',0),(239055,6641,'nl','Klik hier om te krijgen uw NolaEZ-licentie',0),(239056,6641,'fi','Klikkaa tÃ¤stÃ¤ saadaksesi kÃ¤yttÃ¶oikeuden NolaEZ',0),(239057,6641,'no','Klikk her for Ã¥ fÃ¥ NolaEZ lisensen',0),(239058,6641,'da','Klik her for at fÃ¥ din NolaEZ licens',0),(239059,6641,'ko','NolaEZ ë¼ì´ì„¼ìŠ¤ ì–»ì„ í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­í•©ë‹ˆë‹¤',0),(239060,6641,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×§×‘×œ ××ª ×”×¨×©×™×•×Ÿ NolaEZ ×©×œ×š',0),(239061,6641,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Ï€Î¬ÏÎµÏ„Îµ Ï„Î·Î½ Î¬Î´ÎµÎ¹Î± Ï‡ÏÎ®ÏƒÎ·Ï‚ Ï„Î¿Ï… NolaEZ',0),(239062,6641,'zh','ç‚¹å‡»è¿™é‡ŒèŽ·å–æ‚¨çš„NolaEZè®¸å¯è¯\r\n',0),(239063,6641,'sv','Klicka hÃ¤r fÃ¶r att fÃ¥ din NolaEZ licens',0),(239064,6641,'it','Clicca qui per ottenere la licenza di NolaEZ',0),(239065,6641,'tl','',0),(239066,6641,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641; NolaEZ License &#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(239067,6641,'hi','à¤¯à¤¹à¤¾à¤ à¤…à¤ªà¤¨à¥‡ NolaEZ à¤²à¤¾à¤‡à¤¸à¥‡à¤‚à¤¸ à¤ªà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(239068,6641,'ms','Klik di sini untuk dapatkan lesen NolaEZ anda',0),(239069,6641,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„ØªØ±Ø®ÙŠØµ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù†ÙˆÙ„Ø§ÙŠØ²',0),(239070,6641,'fr','Cliquez ici pour obtenir votre licence NolaEZ',0),(239071,6641,'jp','ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦å–å¾— NolaEZ ãƒ©ã‚¤ã‚»ãƒ³ã‚¹',0),(239072,6641,'pt','Clique aqui para obter sua licenÃ§a de NolaEZ',0),(239073,6641,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð¡ÑŽÐ´Ð° Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð²Ð°ÑˆÑƒ Ð›Ð¸Ñ†ÐµÐ½Ð·Ð¸ÑŽ NolaEZ',0),(239074,6641,'es','Click AquÃ­ para Agarrar su Licencia de NolaEZ',0),(239075,6641,'de','Klicken Sie hier, um Get Ihre NolaEZ-Lizenz',0),(239076,6641,'en','Click Here to Get your NolaEZ License',0),(239077,6642,'is','',0),(239078,6642,'dr','Ø«Ø¨Øª Ø³Ø±ÙŠ Ù…Ø¬ÙˆØ²Ù‡Ø§ÙŠ Ø´Ù…Ø§ Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§ ',0),(239079,6642,'pr','Ø«Ø¨Øª Ø³Ø±ÙŠ Ù…Ø¬ÙˆØ²Ù‡Ø§ÙŠ Ø´Ù…Ø§ Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§ ',0),(239080,6642,'tr','Lisans dizeyi buraya girin',0),(239081,6642,'pl','Wpisz tutaj swÃ³j ciÄ…g licencji',0),(239082,6642,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ Ð»Ð¸Ñ†ÐµÐ½Ð· Ð½Ð¸Ð· Ñ‚ÑƒÐº',0),(239083,6642,'ur','ÛŒÛØ§Úº Ø§Ù¾Ù†Û’ Ù„Ø§Ø¦Ø³Ù†Ø³ Ø³Ù„Ú© Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(239084,6642,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð²Ð°ÑˆÑƒ Ð½Ð¸ÑÐºÑƒ Ð·Ð° Ð»Ð¸Ñ†ÐµÐ½Ñ†Ñƒ',0),(239085,6642,'vi','Nháº­p dÃ¢y giáº¥y phÃ©p cá»§a báº¡n á»Ÿ Ä‘Ã¢y',0),(239086,6642,'af','Tik jou lisensie tou hier',0),(239087,6642,'ro','IntroduceÅ£i ÅŸirul licenta aici',0),(239088,6642,'et','Sisestage oma litsentsi String siin',0),(239089,6642,'si','Nastopiti vaÅ¡ dati dovoljenje niz tukaj',0),(239090,6642,'ba','Masukkan String lisensi Anda di sini',0),(239091,6642,'nl','Voer hier uw licentie-tekenreeks',0),(239092,6642,'fi','SyÃ¶tÃ¤ lisenssi merkkijono tÃ¤Ã¤llÃ¤',0),(239093,6642,'no','Angi lisens strengen her',0),(239094,6642,'da','Indtast din licens streng her',0),(239095,6642,'ko','ì—¬ê¸°ì— ë¼ì´ì„¼ìŠ¤ ë¬¸ìžì—´ ìž…ë ¥',0),(239096,6642,'he','×”×–×Ÿ ×ž×—×¨×•×–×ª ×”×¨×©×™×•×Ÿ ×©×œ×š ×›××Ÿ',0),(239097,6642,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î· ÏƒÏ…Î¼Î²Î¿Î»Î¿ÏƒÎµÎ¹ÏÎ¬ Î¬Î´ÎµÎ¹Î± ÏƒÎ±Ï‚ ÎµÎ´ÏŽ',0),(239098,6642,'zh','åœ¨è¿™é‡Œè¾“å…¥æ‚¨çš„è®¸å¯è¯å­—ç¬¦ä¸²',0),(239099,6642,'sv','Ange din licens-strÃ¤ng hÃ¤r',0),(239100,6642,'it','Immettere la stringa di licenza qui',0),(239101,6642,'tl','',0),(239102,6642,'th','Enter Your License String Here',0),(239103,6642,'hi','à¤¯à¤¹à¤¾à¤ à¤†à¤ªà¤•à¥‡ à¤²à¤¾à¤¯à¤¸à¥‡à¤‚à¤¸ à¤¸à¥à¤Ÿà¥à¤°à¤¿à¤‚à¤— à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(239104,6642,'ms','Masukkan rentetan lesen anda di sini',0),(239105,6642,'ar','Ø£Ø¯Ø®Ù„ Ø³Ù„Ø³Ù„Ø© Ø§Ù„ØªØ±Ø®ÙŠØµ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù‡Ù†Ø§',0),(239106,6642,'fr','Entrez ici votre chaÃ®ne de licence',0),(239107,6642,'jp','ã“ã“ã«ã‚ãªãŸã®ãƒ©ã‚¤ã‚»ãƒ³ã‚¹æ–‡å­—åˆ—ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(239108,6642,'pt','Insira sua String de licenÃ§a aqui',0),(239109,6642,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÑ‚Ñ€Ð¾ÐºÑƒ Ð»Ð¸Ñ†ÐµÐ½Ð·Ð¸Ð¸',0),(239110,6642,'es','Introducir su Serie de CarÃ¡cteres de Licencia Aqui',0),(239111,6642,'de','Geben Sie hier Ihre Lizenzzeichenfolge',0),(239112,6642,'en','Enter Your License String Here',0),(239113,6643,'is','',0),(239114,6643,'dr','Ø¢ÙŠØ§ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÙŠØ§Ù„ Ø¯Ø³ØªÙŠ Ø¯Ø§Ø±Ø¯ ',0),(239115,6643,'pr','Ø¢ÙŠØ§ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÙŠØ§Ù„ Ø¯Ø³ØªÙŠ Ø¯Ø§Ø±Ø¯ ',0),(239116,6643,'tr','NolaEZ seri numaranÄ±zÄ± kullanÄ±ÅŸlÄ± olmasÄ±',0),(239117,6643,'pl','Ma numer seryjny NolaEZ przydatne',0),(239118,6643,'bg','Ð˜Ð¼Ð° ÑÐ¸ ÑƒÐ´Ð¾Ð±Ð½Ð° NolaEZ ÑÐµÑ€Ð¸ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(239119,6643,'ur','Ø¢Ù¾ Ù†Ø§ÙˆÙ„Ø§ÛŒØ² Ø³ÛŒØ±ÛŒÙ„ Ù†Ù…Ø¨Ø± Ú©Û’ ÛØ§ØªÚ¾ ÛÛ’',0),(239120,6643,'sr','Ð¢Ð²Ð¾Ñ˜ ÐÐ¾Ð»Ð°Ð•Ð— ÑÐµÑ€Ð¸Ñ˜ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¸ Ñ€ÑƒÑ†Ð¸',0),(239121,6643,'vi','HÃ£y láº¥y sá»‘ seri cho NolaEZ cá»§a báº¡n sáºµn sÃ ng',0),(239122,6643,'af','Hou u NolaEZ Reeksnommer Gereed',0),(239123,6643,'ro','Au numÄƒrul dumneavoastrÄƒ de serie NolaEZ la Ã®ndemÃ¢nÄƒ',0),(239124,6643,'et','Oma NolaEZ seerianumber on mugav',0),(239125,6643,'si','So vaÅ¡e NolaEZ serijska Å¡tevilka priroÄen',0),(239126,6643,'ba','Memiliki nomor seri NolaEZ berguna',0),(239127,6643,'nl','Hebben uw NolaEZ serienummer handig',0),(239128,6643,'fi','On NolaEZ sarjanumero kÃ¤sillÃ¤',0),(239129,6643,'no','Har NolaEZ serienummeret hendig',0),(239130,6643,'da','Har din NolaEZ serienummer Handy',0),(239131,6643,'ko','NolaEZ ì¼ë ¨ ë²ˆí˜¸',0),(239132,6643,'he','×™×© ×œ×™ ××ª ×”×ž×¡×¤×¨ ×”×¡×™×“×•×¨×™ NolaEZ ×©×™×ž×•×©×™',0),(239133,6643,'el','Î£Î±Ï‚ NolaEZ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ Ï€ÏÎ±ÎºÏ„Î¹ÎºÏŒ',0),(239134,6643,'zh','æœ‰ä½ çš„åºåˆ—å·æ‰‹æŒNolaEZ\r\n',0),(239135,6643,'sv','Har din NolaEZ fÃ¶ljetong antalen hÃ¤ndig',0),(239136,6643,'it','Avere il numero di serie NolaEZ pratico',0),(239137,6643,'tl','',0),(239138,6643,'th','Have Your NolaEZ Serial Number Handy',0),(239139,6643,'hi','à¤…à¤ªà¤¨à¥‡ NolaEZ à¤¸à¥€à¤°à¤¿à¤¯à¤² à¤¨à¤‚à¤¬à¤° à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¹à¥ˆ',0),(239140,6643,'ms','Mempunyai nombor siri NolaEZ yang berguna',0),(239141,6643,'ar','ÙŠÙƒÙˆÙ† Ø§Ù„Ø±Ù‚Ù… Ø§Ù„ØªØ³Ù„Ø³Ù„ÙŠ Ù†ÙˆÙ„Ø§ÙŠØ² ÙŠØ¯ÙˆÙŠØ©',0),(239142,6643,'fr','Votre numÃ©ro de sÃ©rie de NolaEZ pratique',0),(239143,6643,'jp','NolaEZ ã®ã‚·ãƒªã‚¢ãƒ«ç•ªå·ã‚’ãŠæ‰‹å…ƒ',0),(239144,6643,'pt','Tenho o seu nÃºmero de sÃ©rie de NolaEZ Ã  mÃ£o',0),(239145,6643,'ru','Ð˜Ð¼ÐµÑ‚ÑŒ Ð¿Ð¾Ð´ Ñ€ÑƒÐºÐ¾Ð¹ NolaEZ ÑÐµÑ€Ð¸Ð¹Ð½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(239146,6643,'es','Tenga en Mano su NÃºmero Serial de NolaEZ',0),(239147,6643,'de','Haben Sie Ihre NolaEZ Seriennummer Handy',0),(239148,6643,'en','Have Your NolaEZ Serial Number Handy',0),(239149,6644,'is','',0),(239150,6644,'dr','Ú¯ÙˆØ§Ù‡ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(239151,6644,'pr','Ú¯ÙˆØ§Ù‡ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(239152,6644,'tr','Lisans veritabanÄ± bilgileri',0),(239153,6644,'pl','Baza danych informacji o licencji',0),(239154,6644,'bg','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð»Ð¸Ñ†ÐµÐ½Ð·Ð°',0),(239155,6644,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù„Ø§Ø¦ÛŒØ³Ù†Ø³ Ú©ÙˆØ§Ø¦ÙÛŒÛ',0),(239156,6644,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð»Ð¸Ñ†ÐµÐ½Ñ†Ð¸ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(239157,6644,'vi','ThÃ´ng tin vá» giáº¥y phÃ©p cá»§a dá»¯ liá»‡u',0),(239158,6644,'af','Databasis Lisensie Inligting',0),(239159,6644,'ro','InformaÅ£ii de bazÄƒ de date a da un permis',0),(239160,6644,'et','Andmebaasi Litsentsiteave',0),(239161,6644,'si','Informacije o licenci zbirke podatkov',0),(239162,6644,'ba','Informasi Database lisensi',0),(239163,6644,'nl','Informatie over de Database licentie',0),(239164,6644,'fi','Tietokannan kÃ¤yttÃ¶oikeustiedot',0),(239165,6644,'no','Databasen lisensinformasjon',0),(239166,6644,'da','Licens databaseoplysninger',0),(239167,6644,'ko','ë¼ì´ì„¼ìŠ¤ ë°ì´í„°ë² ì´ìŠ¤ ì •ë³´',0),(239168,6644,'he','×ž×™×“×¢ ××•×“×•×ª ×ž×¡×“ × ×ª×•× ×™× ×¨×©×™×•×Ÿ',0),(239169,6644,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î±Î´ÎµÎ¹ÏŽÎ½',0),(239170,6644,'zh','è®¸å¯è¯æ•°æ®åº“ä¿¡æ¯\r\n',0),(239171,6644,'sv','Licens databasinformation',0),(239172,6644,'it','Licenza Database informazioni',0),(239173,6644,'tl','',0),(239174,6644,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3610;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3586;&#3629;&#3591;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(239175,6644,'hi','à¤²à¤¾à¤¯à¤¸à¥‡à¤‚à¤¸ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(239176,6644,'ms','Maklumat pangkalan data lesen',0),(239177,6644,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ØªØ±Ø®ÙŠØµ',0),(239178,6644,'fr','Informations de base de donnÃ©es de licence',0),(239179,6644,'jp','ãƒ©ã‚¤ã‚»ãƒ³ã‚¹ ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹æƒ…å ±',0),(239180,6644,'pt','InformaÃ§Ãµes do banco de dados de licenÃ§a',0),(239181,6644,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð±Ð°Ð·Ðµ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð»Ð¸Ñ†ÐµÐ½Ð·Ð¸Ð¸',0),(239182,6644,'es','InformaciÃ³n de Base de Datos de Licencia',0),(239183,6644,'de','Lizenz-Datenbank-Informationen',0),(239184,6644,'en','License Database Information',0),(239185,6645,'is','',0),(239186,6645,'dr','(Ù…Ø¹Ù…ÙˆÙ„',0),(239187,6645,'pr','Ù†Ù…ÙˆÙ†Ù‡ Ù…ÙƒØ§Ù† Ù‡Ø§ÙŠ (Ù…Ø¹Ù…ÙˆÙ„',0),(239188,6645,'tr','Tipik Mekanlar',0),(239189,6645,'pl','Typowe lokalizacje',0),(239190,6645,'bg','Ð¢Ð¸Ð¿Ð¸Ñ‡Ð½Ð¸ Ð¼ÐµÑÑ‚Ð°',0),(239191,6645,'ur','Ø¹Ø§Ù… Ù…Ù‚Ø§Ù…Ø§Øª',0),(239192,6645,'sr','Ð¢Ð¸Ð¿Ð¸Ñ‡Ð½Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(239193,6645,'vi','Vá»‹ trÃ­ tiÃªu biá»ƒu',0),(239194,6645,'af','Tipiese Ligging',0),(239195,6645,'ro','Tipic locatii',0),(239196,6645,'et','TÃ¼Ã¼piline asukohad',0),(239197,6645,'si','TipiÄna mesta',0),(239198,6645,'ba','Lokasi khas',0),(239199,6645,'nl','Standaard locatie',0),(239200,6645,'fi','TyypillisiÃ¤ kerÃ¤yspaikkoja',0),(239201,6645,'no','Typisk plasseringene',0),(239202,6645,'da','Typiske steder',0),(239203,6645,'ko','ì „í˜•ì ì¸ ìœ„ì¹˜',0),(239204,6645,'he','×ž×™×§×•×ž×™× ×˜×™×¤×•×¡×™×™×',0),(239205,6645,'el','Î¤Ï…Ï€Î¹ÎºÎ­Ï‚ Î¸Î­ÏƒÎµÎ¹Ï‚',0),(239206,6645,'zh','å…¸åž‹ä½ç½®\r\n',0),(239207,6645,'sv','Typiska platser',0),(239208,6645,'it','Luoghi tipici',0),(239209,6645,'tl','',0),(239210,6645,'th','&#3605;&#3633;&#3623;&#3629;&#3618;&#3656;&#3634;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(239211,6645,'hi','à¤ à¥‡à¤  à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚',0),(239212,6645,'ms','Lokasi-lokasi yang biasa',0),(239213,6645,'ar','Ù…ÙˆØ§Ù‚Ø¹ Ù†Ù…ÙˆØ°Ø¬ÙŠØ©',0),(239214,6645,'fr','Endroits typiques',0),(239215,6645,'jp','å…¸åž‹çš„ãªä½ç½®',0),(239216,6645,'pt','LocalizaÃ§Ãµes tÃ­picas',0),(239217,6645,'ru','Ð¢Ð¸Ð¿Ð¸Ñ‡Ð½Ñ‹Ðµ Ð¼ÐµÑÑ‚Ð°',0),(239218,6645,'es','Ubicaciones TÃ­picos',0),(239219,6645,'de','Typische Standorte',0),(239220,6645,'en','Typical Locations',0),(239221,6646,'is','',0),(239222,6646,'dr','ØªØ§ÙŠÙŠØ¯ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª',0),(239223,6646,'pr','ØªØ§ÙŠÙŠØ¯ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª',0),(239224,6646,'tr','Ä°Ã§in Ã¶deme faturalarÄ± Onayla',0),(239225,6646,'pl','Zatwierdza rachunki dla pÅ‚atnoÅ›ci',0),(239226,6646,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÐ²Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(239227,6646,'ur','Ø¨Ù„ÙˆÚº Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†Ø¸ÙˆØ±ÛŒ',0),(239228,6646,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð¸Ñ‚Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ',0),(239229,6646,'vi','Cháº¥p Thuáº­n HÃ³a ÄÆ¡n Ä‘á»ƒ Thanh ToÃ¡n',0),(239230,6646,'af','Rekeninge vir Betaling Goedkeur',0),(239231,6646,'ro','AprobÄƒ facturile pentru plata',0),(239232,6646,'et','Kinnitada kooslused makse',0),(239233,6646,'si','Odobri raÄune za plaÄilo',0),(239234,6646,'ba','Menyetujui tagihan pembayaran',0),(239235,6646,'nl','Rekeningen goedkeuren voor betaling',0),(239236,6646,'fi','HyvÃ¤ksy laskujen maksamisesta',0),(239237,6646,'no','Godkjenne regninger for betaling',0),(239238,6646,'da','Godkende regninger til betaling',0),(239239,6646,'ko','ì§€ë¶ˆì— ëŒ€ í•œ ë²•ì•ˆì„ ìŠ¹ì¸',0),(239240,6646,'he','×œ××©×¨ ××ª ×”×—×©×‘×•× ×•×ª ×œ×ª×©×œ×•×',0),(239241,6646,'el','Î•Î³ÎºÏÎ¯Î½ÎµÎ¹ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(239242,6646,'zh','ä»˜æ¬¾æ‰¹å‡†è´¦å•\r\n',0),(239243,6646,'sv','GodkÃ¤nna rÃ¤kningar fÃ¶r betalning',0),(239244,6646,'it','Approvare le bollette per il pagamento',0),(239245,6646,'tl','',0),(239246,6646,'th','&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3604;&#3657;&#3623;&#3618;&#3605;&#3633;&#3659;&#3623;&#3648;&#3591;&#3636;&#3609;',0),(239247,6646,'hi','à¤¬à¤¿à¤²à¥‹à¤‚ à¤•à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨',0),(239248,6646,'ms','Meluluskan rang undang-undang bagi pembayaran',0),(239249,6646,'ar','Ø§Ù„ØªØµØ¯ÙŠÙ‚ Ø¹Ù„Ù‰ Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ† Ù„Ù„Ø³Ø¯Ø§Ø¯',0),(239250,6646,'fr','Approuver les factures de paiement',0),(239251,6646,'jp','æ”¯æ‰•ã„ã®ãŸã‚ã®æ³•æ¡ˆã‚’æ‰¿èªã—ã¾ã™ã€‚',0),(239252,6646,'pt','Aprovar as contas para pagamento',0),(239253,6646,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(239254,6646,'es','Aprobar Facturas para Pagar',0),(239255,6646,'de','Genehmigen Rechnungen zur Zahlung',0),(239256,6646,'en','Approve Bills for Payment',0),(239257,6647,'is','',0),(239258,6647,'dr','ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ â€“Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ  Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÙŠÙˆØ³Øª Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÙŠÚ© Ù¾ÙˆÙ„ ÙÙ‚Ø· ÙŠØ±Ø§ÙŠ Ù…Ø¹Ø±Ù Ù‡Ø³ØªÙ†Ø¯ ',0),(239259,6647,'pr','ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ â€“Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ  Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÙŠÙˆØ³Øª Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÙŠÚ© Ù¾ÙˆÙ„ ÙÙ‚Ø· ÙŠØ±Ø§ÙŠ Ù…Ø¹Ø±Ù Ù‡Ø³ØªÙ†Ø¯ ',0),(239260,6647,'tr','<b>YalnÄ±zca baÅŸvuru</b> iÃ§in kredi kartÄ±, ACH ve EFT seÃ§imler vardÄ±r',0),(239261,6647,'pl','Karta kredytowa, ACH i EFT wybory sÄ… tylko w celach <b>informacyjnych</b>',0),(239262,6647,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°, ÐÐšÐš Ð¸ EFT ÑÐ° ÑÐ°Ð¼Ð¾ Ð·Ð° <b>ÑÐ¿Ñ€Ð°Ð²ÐºÐ°</b>',0),(239263,6647,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±ÚˆØŒ Ø§Ú† Ø§ÙˆØ± EFT Ø±Ø§Ø³ØªÛ’ Ú©Û’ Ù„Ø¦Û’ <b>ØµØ±Ù Ø­ÙˆØ§Ù„Û</b> ÛÛŒÚº Û”',0),(239264,6647,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ \",\" ÐÑ… \"Ð¸\" Ð•Ð¤Ð¢ Ð¸Ð·Ð±Ð¾Ñ€Ð¸ ÑÑƒ Ð·Ð° <b>Ñ€ÐµÑ„ÐµÑ€ÐµÐ½Ñ†Ñƒ ÑÐ°Ð¼Ð¾</b>',0),(239265,6647,'vi','Lá»±a Chá»n Thanh ToÃ¡n Báº±ng Tháº» TÃ­n Dá»¥ng, ACH & EFT chá»‰ dÃ¹ng tham kháº£o',0),(239266,6647,'af','Kredietkaart, ACH en EFT keuses is slegs vir <b>verwysingsdoeleindes</b>',0),(239267,6647,'ro','Card de credit, ACH ÅŸi EFT alegerile sunt numai pentru <b>referinÅ£Äƒ</b>',0),(239268,6647,'et','Krediitkaardi, ACH ja EFT valikuid on mÃµeldud <b>kasutamiseks ainult</b>',0),(239269,6647,'si','Kreditne kartice, ACH in EFT izbire so samo za <b>referenco</b>',0),(239270,6647,'ba','Pilihan kartu kredit, ACH dan TDE adalah untuk <b>referensi saja</b>',0),(239271,6647,'nl','Creditcard, ACH en EFT keuzes zijn alleen ter <b>referentie</b>',0),(239272,6647,'fi','Luottokortti, ACH ja EFT valintoja ovat <b>viitteellisiÃ¤</b>',0),(239273,6647,'no','Kredittkort, ACH og EFT er bare for <b>Referanse</b>',0),(239274,6647,'da','Kreditkort, ACH og EFT valg er kun til <b>reference</b>',0),(239275,6647,'ko','ì‹ ìš© ì¹´ë“œ, ACH ë° ì†¡ê¸ˆ ì„ íƒì€ <b>ë‹¨ì§€</b> ì°¸ì¡°ìš©',0),(239276,6647,'he','××¤×©×¨×•×™×•×ª ×›×¨×˜×™×¡ ××©×¨××™, ACH ×•- EFT ×ž×©×ž×©×™× ×œ×ž×˜×¨×•×ª <b>×¢×™×•×Ÿ ×‘×œ×‘×“</b>',0),(239277,6647,'el','ACH, Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÎºÎ±Î¹ EFT ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ ÎµÎ¯Î½Î±Î¹ Î³Î¹Î± <b>Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ Î¼ÏŒÎ½Î¿</b>',0),(239278,6647,'zh','ä¿¡ç”¨å¡ï¼Œç”µå­è½¬å¸ä»˜æ¬¾å’Œè‡ªåŠ¨äº¤æ¢æ‰€é€‰æ‹©ä»…ä¾›å‚è€ƒ\r\n',0),(239279,6647,'sv','Kreditkort, ACH och EFT val Ã¤r endast fÃ¶r <b>referens</b>',0),(239280,6647,'it','Carta di credito, ACH ed EFT scelte sono solo di <b>riferimento</b>',0),(239281,6647,'tl','',0),(239282,6647,'th','&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;,&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632; ACH &#3649;&#3621;&#3632; EFT &#3626;&#3635;&#3627;&#3619;&#3633;&#3610',0),(239283,6647,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡, ACH à¤”à¤° à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤µà¤¿à¤•à¤²à¥à¤ª <b>à¤•à¥‡à¤µà¤² à¤¸à¤‚à¤¦à¤°à¥à¤­</b> à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚',0),(239284,6647,'ms','Pilihan kad kredit, men dan EFT adalah untuk <b>rujukan sahaja</b>',0),(239285,6647,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†ØŒ ÙˆÙ…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ØŒ ÙˆØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø£Ù…ÙˆØ§Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ <b>Ù…Ø±Ø¬Ø¹ ÙÙ‚Ø·</b>',0),(239286,6647,'fr','Choix de carte de crÃ©dit, ACH et EFT sont pour la <b>rÃ©fÃ©rence seulement</b>',0),(239287,6647,'jp','ACHã€ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã€éŠ€è¡Œå£åº§æŒ¯è¾¼ã®é¸æŠžè‚¢ã¯<b>å‚è€ƒ</b>ç”¨ã§ã™ã€‚',0),(239288,6647,'pt','CartÃ£o de crÃ©dito, ACH e EFT escolhas sÃ£o apenas para <b>referÃªncia</b>',0),(239289,6647,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹, ACH Ð¸ EFT Ð¿Ñ€Ð¸Ð²ÐµÐ´ÐµÐ½Ñ‹ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ <b>ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸</b>',0),(239290,6647,'es','Tarjeta de CrÃ©dito, Seleccioes de Pagos de ACH y EFT son para Referencia Solamente',0),(239291,6647,'de','Kreditkarte, ACH und EFT Entscheidungen werden <b>nur</b> zu Referenzzwecken',0),(239292,6647,'en','Credit Card, ACH and EFT choices are for <b>reference only</b>',0),(239293,6648,'is','',0),(239294,6648,'dr','ØªØ§Ø±ÙŠØ® Ø¬Ù‡Øª  Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(239295,6648,'pr','ØªØ§Ø±ÙŠØ® Ø¬Ù‡Øª  Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(239296,6648,'tr','Ã–deme tarihi',0),(239297,6648,'pl','Data pÅ‚atnoÅ›ci',0),(239298,6648,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(239299,6648,'ur','ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(239300,6648,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(239301,6648,'vi','NgÃ y thanh toÃ¡n',0),(239302,6648,'af','Datum om te Betaal',0),(239303,6648,'ro','Data de platÄƒ',0),(239304,6648,'et','Makse kuupÃ¤ev',0),(239305,6648,'si','Datum plaÄila',0),(239306,6648,'ba','Tanggal untuk membayar',0),(239307,6648,'nl','Datum te betalen',0),(239308,6648,'fi','MennessÃ¤ maksu',0),(239309,6648,'no','Dato for betaling',0),(239310,6648,'da','Dato til lÃ¸n',0),(239311,6648,'ko','ì§€ë¶ˆ ë‚ ì§œ',0),(239312,6648,'he','×ª××¨×™×š ×ª×©×œ×•×',0),(239313,6648,'el','Î£Î®Î¼ÎµÏÎ± Î½Î± Ï€Î»Î·ÏÏŽÏƒÎµÎ¹',0),(239314,6648,'zh','æ”¯ä»˜æ—¥æœŸ\r\n',0),(239315,6648,'sv','Datum att betala',0),(239316,6648,'it','Data a pagamento',0),(239317,6648,'tl','',0),(239318,6648,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;',0),(239319,6648,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(239320,6648,'ms','Tarikh bayar',0),(239321,6648,'ar','ÙˆØ­ØªÙ‰ Ø§Ù„Ø¢Ù† Ù„Ø¯ÙØ¹',0),(239322,6648,'fr','Jour de paye',0),(239323,6648,'jp','æ”¯æ‰•æ—¥ä»˜ã—ã¾ã™ã€‚',0),(239324,6648,'pt','Data de pagamento',0),(239325,6648,'ru','Ð”Ð°Ñ‚Ð° ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(239326,6648,'es','Fecha para Pagar',0),(239327,6648,'de','Datum zu zahlen',0),(239328,6648,'en','Date to Pay',0),(239329,6649,'is','',0),(239330,6649,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ ØªØ§Ø±ÙŠØ®  Ø­Ù‚ÙˆÙ‚ ',0),(239331,6649,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ ØªØ§Ø±ÙŠØ®  Ø­Ù‚ÙˆÙ‚ ',0),(239332,6649,'tr','VarsayÄ±lan Ã¶deme tarihi',0),(239333,6649,'pl','DomyÅ›lna data pÅ‚atnoÅ›ci',0),(239334,6649,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(239335,6649,'ur','Ø·Û’ Ø´Ø¯Û ØªÙ†Ø®ÙˆØ§Û ØªØ§Ø±ÛŒØ®',0),(239336,6649,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ñ‚Ðµ',0),(239337,6649,'vi','NgÃ y thanh toÃ¡n Máº·c Ä‘á»‹nh',0),(239338,6649,'af','Verstekte Betaaldatum',0),(239339,6649,'ro','Data de plata implicite',0),(239340,6649,'et','Vaikimisi makse kuupÃ¤ev',0),(239341,6649,'si','Privzeti datum plaÄila',0),(239342,6649,'ba','Tanggal bayar standar',0),(239343,6649,'nl','Pay standaarddatum',0),(239344,6649,'fi','Maksu oletuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(239345,6649,'no','Betal standarddatoen',0),(239346,6649,'da','Standard lÃ¸ndato',0),(239347,6649,'ko','ê¸°ë³¸ ì§€ë¶ˆ ë‚ ì§œ',0),(239348,6649,'he','×ª××¨×™×š ×ª×©×œ×•× ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(239349,6649,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(239350,6649,'zh','é»˜è®¤çš„ä»˜æ¬¾æ—¥æœŸ\r\n',0),(239351,6649,'sv','Standarddatumet lÃ¶n',0),(239352,6649,'it','Data di pagamento predefinita',0),(239353,6649,'tl','',0),(239354,6649,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;',0),(239355,6649,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿',0),(239356,6649,'ms','Tarikh gaji lalai',0),(239357,6649,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(239358,6649,'fr','Date de paiement par dÃ©faut',0),(239359,6649,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã®ãŠæ”¯æ‰•ã„æœŸé™',0),(239360,6649,'pt','Data de pagamento padrÃ£o',0),(239361,6649,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(239362,6649,'es','Fecha de Pago por Defecto',0),(239363,6649,'de','Pay Standarddatum',0),(239364,6649,'en','Default Pay Date',0),(239365,6650,'is','',0),(239366,6650,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ù‡Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(239367,6650,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ù‡Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(239368,6650,'tr','DÃ¼zen Ã¶denmemiÅŸ onayladÄ±',0),(239369,6650,'pl','Edycja nieodpÅ‚atnego zatwierdzone',0),(239370,6650,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½ÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸',0),(239371,6650,'ur','ØªØ¯ÙˆÛŒÙ† Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(239372,6650,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½ÐµÐ¿Ð»Ð°Ñ›ÐµÐ½Ð¸Ñ… Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ð¾',0),(239373,6650,'vi','Sá»­a Cháº¥p Thuáº­n KhÃ´ng Thanh ToÃ¡n',0),(239374,6650,'af','Redigeer Onbetaald Goedgekeur',0),(239375,6650,'ro','Editare neplÄƒtite aprobat',0),(239376,6650,'et','Redigeeri tasumata heaks',0),(239377,6650,'si','Urejanje neplaÄano odobri',0),(239378,6650,'ba','Edit belum dibayar disetujui',0),(239379,6650,'nl','Bewerken onbetaalde goedgekeurd',0),(239380,6650,'fi','Muokkaa palkaton hyvÃ¤ksytty',0),(239381,6650,'no','Rediger ubetalte godkjent',0),(239382,6650,'da','Rediger ubetalte godkendt',0),(239383,6650,'ko','ë¬´ë£Œ íŽ¸ì§‘ ìŠ¹ì¸',0),(239384,6650,'he','×¢×¨×™×›×ª ×“×•×—×•×ª ××•×©×¨×”',0),(239385,6650,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎºÎ±Ï„Î±Î²Î¿Î»Î® ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯',0),(239386,6650,'zh','ç¼–è¾‘æœªä»˜æ ¸å‡†\r\n',0),(239387,6650,'sv','Redigera obetalda godkÃ¤nd',0),(239388,6650,'it','Modifica non retribuito approvato',0),(239389,6650,'tl','',0),(239390,6650,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(239391,6650,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤…à¤µà¥ˆà¤¤à¤¨à¤¿à¤• à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥€',0),(239392,6650,'ms','Edit tanpa gaji yang diluluskan',0),(239393,6650,'ar','ØªØ­Ø±ÙŠØ± ØºÙŠØ± Ø§Ù„Ù…Ø³Ø¯Ø¯Ø© ÙˆØ§ÙÙ‚',0),(239394,6650,'fr','Edit non rÃ©munÃ©rÃ© approuvÃ©',0),(239395,6650,'jp','ç·¨é›†ã®æœªæ‰•ã„ã®æ‰¿èª',0),(239396,6650,'pt','Editar nÃ£o remunerado aprovado',0),(239397,6650,'ru','ÐŸÑ€Ð°Ð²ÐºÐ° Ð½ÐµÐ²Ñ‹Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ð»',0),(239398,6650,'es','Editar No Pagado Aprobado',0),(239399,6650,'de','Bearbeiten unbezahlte genehmigt',0),(239400,6650,'en','Edit Unpaid Approved',0),(239401,6651,'is','',0),(239402,6651,'dr','Ø¨Ù‡Ø±Ù‡ Ø§Ø¶Ø§ÙÙŠ ',0),(239403,6651,'pr','Ø¨Ù‡Ø±Ù‡ Ø§Ø¶Ø§ÙÙŠ ',0),(239404,6651,'tr','Ä°lave faiz',0),(239405,6651,'pl','Dodatkowe odsetki',0),(239406,6651,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð»Ð¸Ñ…Ð²Ð¸',0),(239407,6651,'ur','Ø§Ø¶Ø§ÙÛŒ Ø¯Ù„Ú†Ø³Ù¾ÛŒ',0),(239408,6651,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð° ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(239409,6651,'vi','LÃ£i xuáº¥t thÃªm',0),(239410,6651,'af','Bykomende Rente',0),(239411,6651,'ro','Suplimentare de interes',0),(239412,6651,'et','Eest intressi',0),(239413,6651,'si','Dodatnih obresti',0),(239414,6651,'ba','Tambahan menarik',0),(239415,6651,'nl','Extra belang',0),(239416,6651,'fi','HerÃ¤ttÃ¤Ã¤ kiinnostusta',0),(239417,6651,'no','Ekstra interesse',0),(239418,6651,'da','Ekstra interesse',0),(239419,6651,'ko','ì¶”ê°€ ê´€ì‹¬',0),(239420,6651,'he','×¢× ×™×™×Ÿ × ×•×¡×£',0),(239421,6651,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½',0),(239422,6651,'zh','é¢å¤–åˆ©æ¯\r\n',0),(239423,6651,'sv','Extra intresse',0),(239424,6651,'it','Interesse supplementare',0),(239425,6651,'tl','',0),(239426,6651,'th','&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(239427,6651,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¬à¥à¤¯à¤¾à¤œ',0),(239428,6651,'ms','Faedah tambahan',0),(239429,6651,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(239430,6651,'fr','IntÃ©rÃªt supplÃ©mentaire',0),(239431,6651,'jp','ä½™åˆ†ãªåˆ©ç›Š',0),(239432,6651,'pt','Interesse extra',0),(239433,6651,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(239434,6651,'es','Extra InterÃ©ses',0),(239435,6651,'de','ZusÃ¤tzliches Interesse',0),(239436,6651,'en','Extra Interest',0),(239437,6652,'is','',0),(239438,6652,'dr','Ù†Ú¯Ù‡Ø¯Ø§Ø´ØªÙ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(239439,6652,'pr','Ù†Ú¯Ù‡Ø¯Ø§Ø´ØªÙ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(239440,6652,'tr','Bill tutun',0),(239441,6652,'pl','PosiadaÄ‡ rachunek',0),(239442,6652,'bg','Ð”ÑŠÑ€Ð¶Ð°Ñ‚ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(239443,6652,'ur','Ø¨Ù„ Ù…Ù†Ø¹Ù‚Ø¯',0),(239444,6652,'sr','Ð”Ñ€Ð¶Ð¸Ñ‚Ðµ Ð‘Ð¸Ð»',0),(239445,6652,'vi','Giá»¯ hÃ³a Ä‘Æ¡n',0),(239446,6652,'af','Wetsontwerp hou',0),(239447,6652,'ro','Å¢ineÅ£i Bill',0),(239448,6652,'et','Hoidke Bill',0),(239449,6652,'si','Imajo Bill',0),(239450,6652,'ba','Memegang Bill',0),(239451,6652,'nl','Houd Bill',0),(239452,6652,'fi','PidÃ¤ lasku',0),(239453,6652,'no','Hold Bill',0),(239454,6652,'da','Hold Bill',0),(239455,6652,'ko','ë¹Œ ë¶™',0),(239456,6652,'he','×œ×”×—×–×™×§ ××ª ×‘×™×œ',0),(239457,6652,'el','ÎšÏÎ±Ï„Î®ÏƒÏ„Îµ Ï„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(239458,6652,'zh','å¸å•ä¿æŒ\r\n',0),(239459,6652,'sv','HÃ¥lla Bill',0),(239460,6652,'it','Tenere Bill',0),(239461,6652,'tl','',0),(239462,6652,'th','&#3610;&#3636;&#3621;&#3607;&#3637;&#3656;&#3606;&#3639;&#3629;',0),(239463,6652,'hi','à¤¬à¤¿à¤² à¤ªà¤•à¤¡à¤¼',0),(239464,6652,'ms','Mengadakan Rang undang-undang',0),(239465,6652,'ar','Ø¹Ù‚Ø¯ Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ†',0),(239466,6652,'fr','Tenir Bill',0),(239467,6652,'jp','æ³•æ¡ˆã‚’ä¿æŒã—ã¾ã™ã€‚',0),(239468,6652,'pt','Segure o Bill',0),(239469,6652,'ru','Ð£Ð´ÐµÑ€Ð¶Ð¸Ð²Ð°Ð¹Ñ‚Ðµ Ð‘Ð¸Ð»Ð»',0),(239470,6652,'es','Guardar Recibo',0),(239471,6652,'de','Bill zu halten',0),(239472,6652,'en','Hold Bill',0),(239473,6653,'is','',0),(239474,6653,'dr','Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(239475,6653,'pr','Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(239476,6653,'tr','Fatura vade tarihi kullanmak iÃ§in alanÄ± boÅŸ bÄ±rakÄ±n',0),(239477,6653,'pl','Pozostaw puste, aby uÅ¼yÄ‡ ustawy termin',0),(239478,6653,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð·Ð° Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð±Ð¸Ð» ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(239479,6653,'ur','Ø¨Ù„ Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(239480,6653,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð‘Ð¸Ð» ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(239481,6653,'vi','Äá»ƒ trá»‘ng Ä‘á»ƒ sá»­ dá»¥ng ngÃ y Ä‘áº¿n háº¡n ra hÃ³a Ä‘Æ¡n',0),(239482,6653,'af','Laat blanko Wetsontwerp verskuldigde datum te gebruik',0),(239483,6653,'ro','LÄƒsaÅ£i necompletat pentru a utiliza data de lege util',0),(239484,6653,'et','JÃ¤tke tÃ¼hjaks kasutada arve tÃ¤htaeg',0),(239485,6653,'si','Pustite prazno uporabite datum zapadlosti Bill',0),(239486,6653,'ba','Biarkan kosong untuk menggunakan tanggal jatuh tempo Bill',0),(239487,6653,'nl','Leave Blank to Bill einddatum gebruiken',0),(239488,6653,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi, jos haluat kÃ¤yttÃ¤Ã¤ laskun erÃ¤pÃ¤ivÃ¤',0),(239489,6653,'no','Bruke Bill forfallsdato er tomt',0),(239490,6653,'da','Lad stÃ¥ tomt for at bruge Bill forfaldsdato',0),(239491,6653,'ko','ë¹Œ ê¸°í•œì´ ì‚¬ìš© í•˜ë ¤ë©´ ë¹„ì›Œ ë‘¡ë‹ˆë‹¤',0),(239492,6653,'he','×”×©××¨ ××•×ª×• ×¨×™×§ ×›×“×™ ×œ×”×©×ª×ž×© ×ª××¨×™×š ×™×¢×“ ×‘×™×œ',0),(239493,6653,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ Î³Î¹Î± Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï€ÏÎ¿Î¸ÎµÏƒÎ¼Î¯Î±',0),(239494,6653,'zh','ç•™ç©ºåˆ°ä½¿ç”¨å¸å•æˆªæ­¢æ—¥æœŸ\r\n',0),(239495,6653,'sv','LÃ¤mna tomt fÃ¶r att anvÃ¤nda Bill fÃ¶rfallodatum',0),(239496,6653,'it','Lasciare vuoto per utilizzare la data di scadenza di Bill',0),(239497,6653,'tl','',0),(239498,6653,'th','&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3610;&#3636;&#3621;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(239499,6653,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¿à¤¥à¤¿ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚',0),(239500,6653,'ms','Tinggalkan tempat kosong untuk menggunakan tarikh akhir Rang undang-undang',0),(239501,6653,'ar','Ø§ØªØ±Ùƒ Ø§Ù„Ù…Ø³Ø§Ø­Ø© ÙØ§Ø±ØºØ© Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªØ§Ø±ÙŠØ® Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(239502,6653,'fr','Laissez vide pour utiliser la Date d\'Ã©chÃ©ance de la facture',0),(239503,6653,'jp','è«‹æ±‚æ›¸ã®æœŸé™ã‚’ä½¿ç”¨ã™ã‚‹ç©ºç™½ã®ã¾ã¾ã«',0),(239504,6653,'pt','Deixe em branco para usar a data de vencimento de Bill',0),(239505,6653,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð‘Ð¸Ð»Ð» ÑÑ€Ð¾Ðº',0),(239506,6653,'es','Dejar en Blanco para Usar Fecha de Vencimiento de Recibo',0),(239507,6653,'de','Freilassen Sie RechnungsfÃ¤lligkeit verwenden',0),(239508,6653,'en','Leave Blank to Use Bill Due Date',0),(239509,6654,'is','',0),(239510,6654,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø®ÙˆØ¯ÙƒØ§Ø±ÙŠ Ø§ØªÙØ§Ù‚ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø§ÙØªØ§Ø¯ ',0),(239511,6654,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø®ÙˆØ¯ÙƒØ§Ø±ÙŠ Ø§ØªÙØ§Ù‚ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø§ÙØªØ§Ø¯ ',0),(239512,6654,'tr','Otomatik iÅŸlem gerÃ§ekleÅŸecek',0),(239513,6654,'pl','Nie automatycznego przetwarzania odbÄ™dzie siÄ™',0),(239514,6654,'bg','ÐÑÐ¼Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ñ‰Ðµ ÑÐµ Ð¿Ñ€Ð¾Ð²ÐµÐ´Ðµ',0),(239515,6654,'ur','Ú©ÙˆØ¦ÛŒ Ø®ÙˆØ¯Ú©Ø§Ø± Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù…Ù†Ø¹Ù‚Ø¯ ÛÙˆ Ú¯ÛŒ',0),(239516,6654,'sr','ÐÐµÐ¼Ð° Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÑƒ Ð¾Ð±Ñ€Ð°Ð´Ñƒ Ð¾Ð´Ñ€Ð¶Ð°Ñ›Ðµ ÑÐµ',0),(239517,6654,'vi','KhÃ´ng cÃ³ xá»­ lÃ½ tá»± Ä‘á»™ng',0),(239518,6654,'af','Geen Outomatiese Prosessering Sal Plaasvind',0),(239519,6654,'ro','Nici o prelucrare automatÄƒ va avea loc',0),(239520,6654,'et','Automaatne tÃ¶Ã¶tlemine toimub',0),(239521,6654,'si','Ni Avtomatizirana obdelava bo potekala',0),(239522,6654,'ba','Pemrosesan otomatis tidak akan berlangsung',0),(239523,6654,'nl','Geen automatische verwerking zal plaatsvinden',0),(239524,6654,'fi','SÃ¤hkÃ¶inen asiointi tapahtuu',0),(239525,6654,'no','Ingen automatisk behandling vil foregÃ¥',0),(239526,6654,'da','Ingen automatisk behandling finder sted',0),(239527,6654,'ko','ì•„ë‹ˆ ìžë™ ì²˜ë¦¬ê°€ ì—´ë¦°ë‹¤',0),(239528,6654,'he','×¢×™×‘×•×“ ××•×˜×•×ž×˜×™ ×œ× ×™×ª×§×™×™×',0),(239529,6654,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î´ÎµÎ½ Î¸Î± Ï€ÏÎ±Î³Î¼Î±Ï„Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯',0),(239530,6654,'zh','æ²¡æœ‰å‘ç”Ÿè‡ªåŠ¨å¤„ç†\r\n',0),(239531,6654,'sv','Ingen automatisk bearbetning kommer att Ã¤ga rum',0),(239532,6654,'it','Nessuna elaborazione automatica avrÃ  luogo',0),(239533,6654,'tl','',0),(239534,6654,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;&#3607;&#3637;&#3656;&#3592;&#3632;&#3651;&#3594;&#3657;&#3614;&#3639;&#3657;&#3609;&#3607;&#3',0),(239535,6654,'hi','à¤•à¥‹à¤ˆ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤œà¤—à¤¹ à¤¨à¤¹à¥€à¤‚ à¤²à¥‡ à¤œà¤¾à¤à¤—à¤¾',0),(239536,6654,'ms','Pemprosesan automatik tidak akan berlaku',0),(239537,6654,'ar','Ø³ÙˆÙ ØªØ¬Ø±ÙŠ Ù„Ø§ Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠØ©',0),(239538,6654,'fr','Aucun traitement automatique n\'aura lieu',0),(239539,6654,'jp','è‡ªå‹•å‡¦ç†ã¯è¡Œã‚ã‚Œã¾ã›ã‚“',0),(239540,6654,'pt','Nenhum processamento automÃ¡tico ocorrerÃ¡',0),(239541,6654,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ°Ñ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ðµ Ð±ÑƒÐ´ÐµÑ‚ Ð¸Ð¼ÐµÑ‚ÑŒ Ð¼ÐµÑÑ‚Ð¾',0),(239542,6654,'es','No Tener Lugar Procesos Automaticos',0),(239543,6654,'de','Keine automatische Verarbeitung statt findet',0),(239544,6654,'en','No automatic processing will take place',0),(239545,6655,'is','',0),(239546,6655,'dr','(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ)  ÙˆÙ‚ØªÙŠ  Ø§ØµÙ„Ø§Ø­  Ù…ÙŠ Ø´ÙˆØ¯',0),(239547,6655,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ)  ÙˆÙ‚ØªÙŠ  ÙˆÙŠØ±Ø§ÙŠØ´ Ù…ÙŠ Ø´ÙˆØ¯',0),(239548,6655,'tr','Ã–deme tarihi ne zaman',0),(239549,6655,'pl','Daty pÅ‚atnoÅ›ci, podczas edycji',0),(239550,6655,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(239551,6655,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ ÙˆÙ‚Øª Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(239552,6655,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐ°',0),(239553,6655,'vi','NgÃ y Thanh ToÃ¡n Khi Chá»‰nh Sá»­a',0),(239554,6655,'af','Betalingdatum met Redigering',0),(239555,6655,'ro','Plata data la editarea',0),(239556,6655,'et','Makse kuupÃ¤ev, mil toimetamine',0),(239557,6655,'si','Datum plaÄila pri urejanju',0),(239558,6655,'ba','Pembayaran tanggal saat mengedit',0),(239559,6655,'nl','Betaling datum bij het bewerken',0),(239560,6655,'fi','MaksupÃ¤ivÃ¤Ã¤ muokattaessa',0),(239561,6655,'no','Betaling dato nÃ¥r du redigerer',0),(239562,6655,'da','Betaling dato ved redigering',0),(239563,6655,'ko','ê²°ì œ ë‚ ì§œë¥¼ íŽ¸ì§‘í•  ë•Œ',0),(239564,6655,'he','×ª××¨×™×š ×”×ª×©×œ×•× ×‘×¢×ª ×¢×¨×™×›×ª',0),(239565,6655,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(239566,6655,'zh','ç¼–è¾‘æ—¶çš„ä»˜æ¬¾æ—¥æœŸ\r\n',0),(239567,6655,'sv','Betalning datum nÃ¤r du redigerar',0),(239568,6655,'it','Pagamento quando modifica data',0),(239569,6655,'tl','',0),(239570,6655,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3648;&#3617;&#3639;&#3656;&#3629;&#3617;&#3637;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(239571,6655,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤œà¤¬ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(239572,6655,'ms','Pembayaran tarikh saat mengedit',0),(239573,6655,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹ Ø¹Ù†Ø¯ ØªØ­Ø±ÙŠØ±',0),(239574,6655,'fr','Date de paiement lors de l\'Ã©dition',0),(239575,6655,'jp','æ”¯æ‰•ã„æ—¥ä»˜ã‚’ç·¨é›†ã™ã‚‹ã¨ã',0),(239576,6655,'pt','Data de pagamento ao editar',0),(239577,6655,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ñ€Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ð¸',0),(239578,6655,'es','Fecha de Pago Cuando Editando',0),(239579,6655,'de','Zahlung Datum beim Bearbeiten',0),(239580,6655,'en','Payment Date When Editing',0),(239581,6656,'is','',0),(239582,6656,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ù‚ÙˆÙ‚',0),(239583,6656,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ù‚ÙˆÙ‚',0),(239584,6656,'tr','Ã–deme tutarÄ±',0),(239585,6656,'pl','ZapÅ‚aty kwoty',0),(239586,6656,'bg','ÐŸÐ»Ð°Ñ‚Ð¸ ÑÑƒÐ¼Ð°',0),(239587,6656,'ur','Ø±Ù‚Ù… Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(239588,6656,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(239589,6656,'vi','Sá»‘ tiá»n tráº£',0),(239590,6656,'af','Besoldiging Bedrag',0),(239591,6656,'ro','PlÄƒteascÄƒ suma',0),(239592,6656,'et','Maksma',0),(239593,6656,'si','PlaÄati znesek',0),(239594,6656,'ba','Membayar jumlah',0),(239595,6656,'nl','Betalen bedrag',0),(239596,6656,'fi','Maksettava summa',0),(239597,6656,'no','Betale belÃ¸p',0),(239598,6656,'da','Betale belÃ¸b',0),(239599,6656,'ko','ê¸ˆì•¡ì„ ì§€ë¶ˆ',0),(239600,6656,'he','×œ×©×œ× ×¡×›×•×',0),(239601,6656,'el','ÎšÎ±Ï„Î±Î²Î¬Î»ÎµÎ¹ Ï€Î¿ÏƒÏŒ',0),(239602,6656,'zh','æ”¯ä»˜æ•°é¢\r\n',0),(239603,6656,'sv','Betala belopp',0),(239604,6656,'it','Pagare l\'importo',0),(239605,6656,'tl','',0),(239606,6656,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3592;&#3656;&#3634;&#3618;',0),(239607,6656,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(239608,6656,'ms','Membayar amaun yang',0),(239609,6656,'ar','Ø¯ÙØ¹ Ø§Ù„Ù…Ø¨Ù„Øº',0),(239610,6656,'fr','Payer le montant',0),(239611,6656,'jp','é‡‘é¡ã‚’æ”¯æ‰•ã†',0),(239612,6656,'pt','Pagar o montante',0),(239613,6656,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ ÑÑƒÐ¼Ð¼Ñƒ',0),(239614,6656,'es','Monto de Pago',0),(239615,6656,'de','Betrag zu entrichten',0),(239616,6656,'en','Pay Amount',0),(239617,6657,'is','',0),(239618,6657,'dr','Ø­Ù‚ÙˆÙ‚ ØªÙˆØ³Ø·',0),(239619,6657,'pr','Ø­Ù‚ÙˆÙ‚ ØªÙˆØ³Ø·',0),(239620,6657,'tr','Ã–deme',0),(239621,6657,'pl','ZapÅ‚aty przez',0),(239622,6657,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¾Ñ‚',0),(239623,6657,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø¯Ø§',0),(239624,6657,'sr','Ð”Ð° Ð¿Ð»Ð°Ñ‚Ð¸',0),(239625,6657,'vi','Tráº£ bá»Ÿi',0),(239626,6657,'af','Betaal Deur',0),(239627,6657,'ro','Platiti prin',0),(239628,6657,'et','Maksta',0),(239629,6657,'si','PlaÄati po',0),(239630,6657,'ba','Membayar dengan',0),(239631,6657,'nl','Betalen door',0),(239632,6657,'fi','Maksaa',0),(239633,6657,'no','Betale med',0),(239634,6657,'da','Betale af',0),(239635,6657,'ko','í•˜ ì—¬ ì§€ë¶ˆ',0),(239636,6657,'he','×œ×©×œ× ×¢×œ ×™×“×™',0),(239637,6657,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Î±Ï€ÏŒ',0),(239638,6657,'zh','æ”¯ä»˜æ–¹å¼\r\n',0),(239639,6657,'sv','Betala med',0),(239640,6657,'it','Pagare con',0),(239641,6657,'tl','',0),(239642,6657,'th','&#3592;&#3656;&#3634;&#3618;&#3650;&#3604;&#3618;',0),(239643,6657,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(239644,6657,'ms','Membayar dengan',0),(239645,6657,'ar','Ø§Ù„Ø¯ÙØ¹ Ø¨ÙˆØ§Ø³Ø·Ø©',0),(239646,6657,'fr','Payer par',0),(239647,6657,'jp','ãŠæ”¯æ‰•ã„',0),(239648,6657,'pt','Pagar por',0),(239649,6657,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ',0),(239650,6657,'es','Pagar Por',0),(239651,6657,'de','Bezahlen per',0),(239652,6657,'en','Pay By',0),(239653,6658,'is','',0),(239654,6658,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(239655,6658,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(239656,6658,'tr','Beklemeye yalnÄ±zca gÃ¶ster',0),(239657,6658,'pl','PokaÅ¼ zawieszone tylko',0),(239658,6658,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ ÑÐ°Ð¼Ð¾',0),(239659,6658,'ur','ÛÙˆÙ„Úˆ Ù¾Ø± ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(239660,6658,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(239661,6658,'vi','Chá»‰ Hiá»ƒn thá»‹ Ä‘ang táº¡m ngÆ°ng',0),(239662,6658,'af','Wys slegs op hou',0),(239663,6658,'ro','AratÄƒ doar pe \"hold\"',0),(239664,6658,'et','Kuva ainult ootel',0),(239665,6658,'si','KaÅ¾ejo na Äakanju le',0),(239666,6658,'ba','Tampilkan ditahan hanya',0),(239667,6658,'nl','Alleen weergeven in de wachtstand',0),(239668,6658,'fi','NÃ¤ytÃ¤ vain pidossa',0),(239669,6658,'no','Vis pÃ¥ vent bare',0),(239670,6658,'da','Vis pÃ¥ Hold kun',0),(239671,6658,'ko','ë³´ë¥˜ë§Œ í‘œì‹œ',0),(239672,6658,'he','×”×¦×’ ×¨×§ ×‘×”×ž×ª× ×”',0),(239673,6658,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÎµ Î±Î½Î±Î¼Î¿Î½Î® Î¼ÏŒÎ½Î¿',0),(239674,6658,'zh','ä»…æ˜¾ç¤ºåœ¨æŒæœ‰\r\n',0),(239675,6658,'sv','Visa pÃ¥ hÃ¥ll endast',0),(239676,6658,'it','Visualizza solo in attesa',0),(239677,6658,'tl','',0),(239678,6658,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3617;&#3639;&#3629;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(239679,6658,'hi','à¤¸à¤¿à¤°à¥à¤« à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤•à¤¡à¤¼ à¤ªà¤°',0),(239680,6658,'ms','Menunjukkan penahanan sahaja',0),(239681,6658,'ar','Ø¥Ø¸Ù‡Ø§Ø± ØªØ¹Ù„ÙŠÙ‚ ÙÙ‚Ø·',0),(239682,6658,'fr','Afficher uniquement en attente',0),(239683,6658,'jp','ãƒ›ãƒ¼ãƒ«ãƒ‰ã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(239684,6658,'pt','Mostrar apenas em espera',0),(239685,6658,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(239686,6658,'es','Mostrar En Espera Solo',0),(239687,6658,'de','Nur auf Hold anzeigen',0),(239688,6658,'en','Show On Hold Only',0),(239689,6659,'is','',0),(239690,6659,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ Ø¯Ø± Ù…Ù‚Ø§Ø¯ÙŠØ± Ø¯Ø±Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(239691,6659,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ Ø¯Ø± Ù…Ù‚Ø§Ø¯ÙŠØ± Ø¯Ø±Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(239692,6659,'tr','Toplam tutun tutarlarÄ±n dÄ±ÅŸarÄ±da tutar.',0),(239693,6659,'pl','Sumie wyklucza na zawieszone kwoty',0),(239694,6659,'bg','ÐžÐ±Ñ‰Ð¾ Ð¸Ð·ÐºÐ»ÑŽÑ‡Ð²Ð° Ð·Ð°Ð´Ñ€ÑŠÐ¶Ñ‚Ðµ ÑÑƒÐ¼Ð¸',0),(239695,6659,'ur','Ú©Ù„ ÛÙˆÙ„Úˆ Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø± Ø®Ø§Ø±Ø¬ Ú©Ø±Ø¯ÛŒØªØ§ Û”',0),(239696,6659,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¸ÑÐºÑ™ÑƒÑ‡ÑƒÑ˜Ðµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð¸Ð·Ð½Ð¾ÑÐ¸',0),(239697,6659,'vi','Tá»•ng cá»™ng khÃ´ng bao gá»“m sá»‘ tiá»n Ä‘ang treo',0),(239698,6659,'af','Totaal sluit op hou bedrae',0),(239699,6659,'ro','Exclude total sume de apÄƒsat',0),(239700,6659,'et','Kokku ei hÃµlma hoidke summad',0),(239701,6659,'si','Skupno izkljuÄuje na Äakanju zneskov',0),(239702,6659,'ba','Total mengecualikan pada memegang jumlah',0),(239703,6659,'nl','Totaal sluit op Hold bedragen',0),(239704,6659,'fi','PitÃ¤Ã¤ mÃ¤Ã¤riÃ¤ ei sisÃ¤lly kokonaismÃ¤Ã¤rÃ¤Ã¤n',0),(239705,6659,'no','Totalt utelukker pÃ¥ Hold belÃ¸p',0),(239706,6659,'da','Total udelukker pÃ¥ Hold belÃ¸b',0),(239707,6659,'ko','ì´ ë³´ìœ  ê¸ˆì•¡ì—ì„œ ì œì™¸',0),(239708,6659,'he','×¡×” ×› ×›×•×œ×œ ×¢×œ ×œ×”×—×–×™×§ ×›×ž×•×™×•×ª',0),(239709,6659,'el','Î‘Ï€ÏŒ Ï„Î¿ ÏƒÏÎ½Î¿Î»Î¿ ÎµÎ¾Î±Î¹ÏÎ¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Ï€Î¿ÏƒÎ¬ Ï€Î¿Ï… ÎºÎ±Ï„Î­Ï‡Î¿Ï…Î½',0),(239710,6659,'zh','æ€»é‡‘é¢ä¸åŒ…æ‹¬å°±ä¿ç•™\r\n',0),(239711,6659,'sv','Totalt omfattar inte pÃ¥ hÃ¥ll belopp',0),(239712,6659,'it','Totale esclusi importi Hold',0),(239713,6659,'tl','',0),(239714,6659,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3619;&#3623;&#3617;&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;',0),(239715,6659,'hi','à¤•à¥à¤² à¤ªà¤° à¤¹à¥‹à¤²à¥à¤¡ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¶à¤¾à¤®à¤¿à¤² à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(239716,6659,'ms','Jumlah keseluruhan tidak termasuk jumlah pegangan',0),(239717,6659,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ ÙŠØ³ØªØ«Ù†ÙŠ Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(239718,6659,'fr','Total exclut les montants de la cale',0),(239719,6659,'jp','åˆè¨ˆã¯ä¿ç•™é¡ã‚’é™¤ã',0),(239720,6659,'pt','Total exclui na preensÃ£o quantidades',0),(239721,6659,'ru','Ð’ÑÐµÐ³Ð¾ Ð¸ÑÐºÐ»ÑŽÑ‡Ð°ÐµÑ‚ Ð½Ð° ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ðµ ÑÑƒÐ¼Ð¼',0),(239722,6659,'es','Total Excluye Cantidades en Espera',0),(239723,6659,'de','Insgesamt schlieÃŸt auf Hold',0),(239724,6659,'en','Total Excludes On Hold Amounts',0),(239725,6660,'is','',0),(239726,6660,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(239727,6660,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(239728,6660,'tr','Fatura numarasÄ± zaten var',0),(239729,6660,'pl','Numer faktury juÅ¼ istnieje',0),(239730,6660,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(239731,6660,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(239732,6660,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(239733,6660,'vi','HÃ³a Ä‘Æ¡n sá»‘ Ä‘Ã£ cÃ³',0),(239734,6660,'af','Faktuur Nommer Bestaan Alreeds',0),(239735,6660,'ro','NumÄƒrul facturii existÄƒ deja',0),(239736,6660,'et','Arve number on juba olemas',0),(239737,6660,'si','Å tevilka raÄuna Å¾e obstaja',0),(239738,6660,'ba','Faktur jumlah sudah ada',0),(239739,6660,'nl','Factuurnummer bestaat al',0),(239740,6660,'fi','Laskunumero on jo olemassa',0),(239741,6660,'no','Fakturanummeret finnes allerede',0),(239742,6660,'da','Fakturanummeret findes allerede',0),(239743,6660,'ko','ì†¡ìž¥ ë²ˆí˜¸ëŠ” ì´ë¯¸ ì¡´ìž¬',0),(239744,6660,'he','×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª ×›×‘×¨ ×§×™×™×',0),(239745,6660,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(239746,6660,'zh','å‘ç¥¨å·ç å·²å­˜åœ¨\r\n',0),(239747,6660,'sv','Fakturanummer finns redan',0),(239748,6660,'it','Numero fattura esiste giÃ ',0),(239749,6660,'tl','',0),(239750,6660,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;',0),(239751,6660,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(239752,6660,'ms','Nombor invois telah wujud',0),(239753,6660,'ar','Ø±Ù‚Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(239754,6660,'fr','NumÃ©ro de facture existe dÃ©jÃ ',0),(239755,6660,'jp','è«‹æ±‚æ›¸ç•ªå·ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™',0),(239756,6660,'pt','NÃºmero da nota fiscal jÃ¡ existe',0),(239757,6660,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¡Ñ‡ÐµÑ‚Ð° Ð£Ð¶Ðµ Ð˜Ð¼ÐµÐµÑ‚ÑÑ',0),(239758,6660,'es','NÃºmero de Factura Ya Existe',0),(239759,6660,'de','Rechnungsnummer ist bereits vorhanden.',0),(239760,6660,'en','Invoice Number Already Exists',0),(239761,6661,'is','',0),(239762,6661,'dr','Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(239763,6661,'pr','Ù„ÙŠØ³Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(239764,6661,'tr','BorÃ§lar listesi',0),(239765,6661,'pl','Lista zobowiÄ…zaÅ„',0),(239766,6661,'bg','Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ ÐºÑŠÐ¼ ÑÐ¿Ð¸ÑÑŠÐº',0),(239767,6661,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(239768,6661,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð»Ð¸ÑÑ‚Ð°',0),(239769,6661,'vi','Danh SÃ¡ch Pháº£i Tráº£',0),(239770,6661,'af','Uitgawes (RB) Lys',0),(239771,6661,'ro','Lista de datorii',0),(239772,6661,'et','Tasumata arved',0),(239773,6661,'si','Seznam obveznosti',0),(239774,6661,'ba','Daftar hutang',0),(239775,6661,'nl','Lijst van de schulden',0),(239776,6661,'fi','Ostojen luettelo',0),(239777,6661,'no','LeverandÃ¸rgjeld liste',0),(239778,6661,'da','Kreditorstyring liste',0),(239779,6661,'ko','ë¯¸ì§€ê¸‰ê¸ˆ ëª©ë¡',0),(239780,6661,'he','×¨×©×™×ž×ª ×–×›××™×',0),(239781,6661,'el','Î›Î¯ÏƒÏ„Î± Ï…Ï€Î¿Ï‡ÏÎµÏŽÏƒÎµÏ‰Î½',0),(239782,6661,'zh','åº”ä»˜åå•\r\n',0),(239783,6661,'sv','LeverantÃ¶rsskulder lista',0),(239784,6661,'it','Elenco di debiti',0),(239785,6661,'tl','',0),(239786,6661,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(239787,6661,'hi','Payables à¤¸à¥‚à¤šà¥€',0),(239788,6661,'ms','Senarai pemiutang',0),(239789,6661,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹',0),(239790,6661,'fr','Liste des comptes fournisseurs',0),(239791,6661,'jp','è²·æŽ›é‡‘ä¸€è¦§',0),(239792,6661,'pt','Lista de contas a pagar',0),(239793,6661,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(239794,6661,'es','Lista de Cuentas por pagar',0),(239795,6661,'de','Verbindlichkeiten-Liste',0),(239796,6661,'en','Payables List',0),(239797,6662,'is','',0),(239798,6662,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚ ',0),(239799,6662,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚ ',0),(239800,6662,'tr','Bekleyen POS',0),(239801,6662,'pl','Toku POS',0),(239802,6662,'bg','Ð§Ð°ÐºÐ°Ñ‰ POS',0),(239803,6662,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù†',0),(239804,6662,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ ÐŸÐžÐ¡',0),(239805,6662,'vi','Äá»‹a Ä‘iá»ƒm bÃ¡n hÃ ng Ä‘ang treo',0),(239806,6662,'af','Afwagtende PVV',0),(239807,6662,'ro','ÃŽn aÅŸteptarea POS',0),(239808,6662,'et','Ootel POS',0),(239809,6662,'si','ÄŒakajoÄe POS',0),(239810,6662,'ba','POS tertunda',0),(239811,6662,'nl','In behandeling POS',0),(239812,6662,'fi','Odottava POS',0),(239813,6662,'no','Ventende POS',0),(239814,6662,'da','Ventende POS',0),(239815,6662,'ko','ë³´ë¥˜ ì¤‘ì¸ POS',0),(239816,6662,'he','POS ×ª×œ×•×™ ×•×¢×•×ž×“',0),(239817,6662,'el','Î Î©Î£ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î±',0),(239818,6662,'zh','å¾…åŠžé”€å”®ç‚¹\r\n',0),(239819,6662,'sv','VÃ¤ntande POS',0),(239820,6662,'it','POS in sospeso',0),(239821,6662,'tl','',0),(239822,6662,'th','&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;&#3607;&#3637;&#3656;&#3592;&#3640;&#3604;&#3586;&#3634;&#3618;',0),(239823,6662,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ POS',0),(239824,6662,'ms','POS belum selesai',0),(239825,6662,'ar','Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ù…Ø¹Ù„Ù‚',0),(239826,6662,'fr','POS en attente',0),(239827,6662,'jp','ä¿ç•™ä¸­ã® POS',0),(239828,6662,'pt','POS pendente',0),(239829,6662,'ru','ÐžÐ¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ POS',0),(239830,6662,'es','PDV Pendiente',0),(239831,6662,'de','Ausstehende POS',0),(239832,6662,'en','Pending POS',0),(239833,6663,'is','',0),(239834,6663,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚',0),(239835,6663,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚',0),(239836,6663,'tr','Bekleyen PO toplamlarÄ±',0),(239837,6663,'pl','Sumy czasu PO',0),(239838,6663,'bg','Ð§Ð°ÐºÐ°Ñ‰ PO ÑÑƒÐ¼Ð¸',0),(239839,6663,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ù¾Ùˆ Ù…ÛŒØ²Ø§Ù†',0),(239840,6663,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ ÐŸÐž Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(239841,6663,'vi','Tá»•ng cá»™ng ÄÆ¡n mua hÃ ng Ä‘ang treo',0),(239842,6663,'af','Afwagtend AB Totale',0),(239843,6663,'ro','ÃŽn aÅŸteptarea PO totaluri',0),(239844,6663,'et','Ootel PO kogusummad',0),(239845,6663,'si','Teku PO vsote',0),(239846,6663,'ba','Total tertunda PO',0),(239847,6663,'nl','In behandeling PO totalen',0),(239848,6663,'fi','Odottava PO summat',0),(239849,6663,'no','Ventende PO totaler',0),(239850,6663,'da','Ventende PO totaler',0),(239851,6663,'ko','ë³´ë¥˜ ì¤‘ì¸ í¬ í•©ê³„',0),(239852,6663,'he','×¤×• ×ž×ž×ª×™× ×•×ª ×¡×›×•×ž×™×',0),(239853,6663,'el','Î£Îµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± PO ÏƒÏÎ½Î¿Î»Î±',0),(239854,6663,'zh','å¾…å¤„ç†è®¢å•æ±‡æ€»\r\n',0),(239855,6663,'sv','VÃ¤ntande PO summor',0),(239856,6663,'it','PO in sospeso totali',0),(239857,6663,'tl','',0),(239858,6663,'th','&#3619;&#3623;&#3617;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(239859,6663,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤ªà¥‹ à¤¯à¥‹à¤—',0),(239860,6663,'ms','PO belum selesai jumlah',0),(239861,6663,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ùˆ Ù…Ø¹Ù„Ù‚Ø©',0),(239862,6663,'fr','Totaux de PO en attente',0),(239863,6663,'jp','ä¿ç•™ä¸­ã®æ³¨æ–‡ã®åˆè¨ˆ',0),(239864,6663,'pt','PO pendente totais',0),(239865,6663,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ Ð´Ð¾ PO',0),(239866,6663,'es','Totales de OC Pendientes',0),(239867,6663,'de','Ausstehenden PO Summen',0),(239868,6663,'en','Pending PO Totals',0),(239869,6664,'is','',0),(239870,6664,'dr','Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ Ø§Ù…Ø§ Ù‡Ù†ÙˆØ² Ø¯Ø± Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù†ÙŠØ³Øª',0),(239871,6664,'pr','Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ Ø§Ù…Ø§ Ù‡Ù†ÙˆØ² Ø¯Ø± Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù†ÙŠØ³Øª',0),(239872,6664,'tr','DeÄŸil BorÃ§lar henÃ¼z teslim alÄ±nmayan POS',0),(239873,6664,'pl','POS otrzymaÅ‚ jeszcze, ale nie w zobowiÄ…zania',0),(239874,6664,'bg','POS Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð» Ð½Ð¾ Ð½Ðµ Ð² Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ Ð²ÑÐµ Ð¾Ñ‰Ðµ',0),(239875,6664,'ur','Ù¾ÙˆØ²ÛŒØ´Ù† Ù…ÛŒÚº Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ù„ÛŒÚ©Ù† Ø§Ø¨Ú¾ÛŒ ØªÚ© Ù…ÙˆØµÙˆÙ„',0),(239876,6664,'sr','ÐŸÐžÐ¡ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð°Ð»Ð¸ Ð½Ðµ Ð¸ Ñƒ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ñ˜Ð¾Ñˆ',0),(239877,6664,'vi','ÄÃ£ Nháº­n ÄÆ¡n Mua HÃ ng NhÆ°ng ChÆ°a Nháº­p VÃ o Pháº£i Tráº£',0),(239878,6664,'af','Ontvang deur PVV maar Nog Nie in Uitgawes (RB)',0),(239879,6664,'ro','POS a primit Ã®ncÄƒ dar nu Ã®n datorii',0),(239880,6664,'et','Kuid mitte vÃµlad veel kÃ¤tte saanud POS',0),(239881,6664,'si','POS prejela, vendar ne v obveznosti Å¡e',0),(239882,6664,'ba','POS menerima tetapi tidak dalam hutang belum',0),(239883,6664,'nl','POS nog niet ontvangen maar niet In schulden',0),(239884,6664,'fi','POS saanut mutta ei velat vielÃ¤',0),(239885,6664,'no','POS mottatt, men ikke i gjeld ennÃ¥',0),(239886,6664,'da','POS modtaget men ikke i gÃ¦ld endnu',0),(239887,6664,'ko','ì•„ë‹Œ ë¯¸ì§€ê¸‰ê¸ˆ í•˜ì§€ë§Œ ì•„ì§ ë°›ì€ POS',0),(239888,6664,'he','POS ×”×ª×§×‘×œ ××‘×œ ×œ× ×–×›××™× ×¢×“×™×™×Ÿ',0),(239889,6664,'el','Î Î©Î£ Î½Î± Î»Î¬Î²ÎµÎ¹ Î±ÎºÏŒÎ¼Î± Î±Î»Î»Î¬ ÏŒÏ‡Î¹ ÏƒÎµ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(239890,6664,'zh','é”€å”®ç‚¹å·²æ”¶åˆ°ä½†å°šæœªæ”¯ä»˜\r\n',0),(239891,6664,'sv','POS mottagen men inte i leverantÃ¶rsskulder Ã¤nnu',0),(239892,6664,'it','Ancora ricevuto ma non nei debiti POS',0),(239893,6664,'tl','',0),(239894,6664,'th','&#3606;&#3641;&#3585;&#3619;&#3633;&#3610;&#3607;&#3637;&#3656;&#3592;&#3640;&#3604;&#3586;&#3634;&#3618;&#3649;&#3605;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(239895,6664,'hi','POS à¤¨à¤¹à¥€à¤‚ à¤®à¥‡à¤‚ Payables à¤²à¥‡à¤•à¤¿à¤¨ à¤…à¤¬ à¤¤à¤• à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(239896,6664,'ms','POS diterima tetapi tidak berbayar lagi',0),(239897,6664,'ar','ØªÙ„Ù‚ÙŠ Ù„ÙƒÙ† Ù„ÙŠØ³ ÙÙŠ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹ Ø¨Ø¹Ø¯ Ø§Ù„Ø¨ÙŠØ¹',0),(239898,6664,'fr','POS encore reÃ§u mais pas en comptes crÃ©diteurs',0),(239899,6664,'jp','ã¾ã å—ä¿¡ã—ã¦ã„ãªã„å‚µå‹™ãŒ POS',0),(239900,6664,'pt','POS ainda recebidas mas nÃ£o em contas a pagar',0),(239901,6664,'ru','POS, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¾ Ð½Ð¾ Ð½Ðµ Ð² ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(239902,6664,'es','PDV Recibido pero ya no esta en los Cuentas por Pagar',0),(239903,6664,'de','POS, die aber nicht In Verbindlichkeiten noch erhalten',0),(239904,6664,'en','POS Received but Not In Payables Yet',0),(239905,6665,'is','',0),(239906,6665,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(239907,6665,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(239908,6665,'tr','AlÄ±nan PO toplamlarÄ±',0),(239909,6665,'pl','Sumy otrzymanych PO',0),(239910,6665,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ PO ÑÑƒÐ¼Ð¸',0),(239911,6665,'ur','Ù…ÙˆØµÙˆÙ„Û Ù¾Ùˆ Ù…ÛŒØ²Ø§Ù†',0),(239912,6665,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ ÐŸÐž Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(239913,6665,'vi','Tá»•ng sá»‘ Ä‘Æ¡n mua hÃ ng Ä‘Ã£ nháº­n',0),(239914,6665,'af','Ontvangde AB Totale',0),(239915,6665,'ro','Primit PO totaluri',0),(239916,6665,'et','VastuvÃµetud PO kogusummad',0),(239917,6665,'si','PO prejetih vsotah',0),(239918,6665,'ba','Total PO diterima',0),(239919,6665,'nl','Ontvangen PO totalen',0),(239920,6665,'fi','Sai PO summat',0),(239921,6665,'no','Mottatte PO totaler',0),(239922,6665,'da','Modtagne PO totaler',0),(239923,6665,'ko','ë°›ì€ í¬ í•©ê³„',0),(239924,6665,'he','×¡×›×•×ž×™× ×©×”×ª×§×‘×œ×• ×¤×•',0),(239925,6665,'el','ÎˆÎ»Î±Î²Îµ PO ÏƒÏÎ½Î¿Î»Î±',0),(239926,6665,'zh','æ”¶åˆ°è®¢å•æ±‡æ€»\r\n',0),(239927,6665,'sv','Mottagna PO summor',0),(239928,6665,'it','Totali ricevuti PO',0),(239929,6665,'tl','',0),(239930,6665,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(239931,6665,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤ªà¥‹ à¤¯à¥‹à¤—',0),(239932,6665,'ms','Jumlah diterima PO',0),(239933,6665,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù„Ù…ØªÙ„Ù‚Ø§Ø© PO',0),(239934,6665,'fr','Totaux reÃ§us PO',0),(239935,6665,'jp','å—ä¿¡ã—ãŸ PO åˆè¨ˆ',0),(239936,6665,'pt','Totais recebidos PO',0),(239937,6665,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ… PO',0),(239938,6665,'es','Totales de OCs Recibidos',0),(239939,6665,'de','Empfangene PO Summen',0),(239940,6665,'en','Received PO Totals',0),(239941,6666,'is','',0),(239942,6666,'dr','(Ù…Ù†ØªØ¸Ø±',0),(239943,6666,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚(Ù…Ù†ØªØ¸Ø±',0),(239944,6666,'tr','POs gÃ¶ster',0),(239945,6666,'pl','PokaÅ¼ toku POs',0),(239946,6666,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‡Ð°ÐºÐ°Ñ‰Ð¸Ñ‚Ðµ POs',0),(239947,6666,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§ Ù¾ÙˆØ²ÛŒØ´Ù† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(239948,6666,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ ÐŸÐžÑ',0),(239949,6666,'vi','Chá»‰ Hiá»ƒn thá»‹ Ä‘Æ¡n mua hÃ ng Ä‘ang treo',0),(239950,6666,'af','Wys Afwagtende ABs',0),(239951,6666,'ro','AratÄƒ Ã®n aÅŸteptarea POs',0),(239952,6666,'et','NÃ¤ita kuni POs',0),(239953,6666,'si','PokaÅ¾i ÄakajoÄe POs',0),(239954,6666,'ba','Tampilkan tertunda POs',0),(239955,6666,'nl','Toon in afwachting van POs',0),(239956,6666,'fi','Osoittavat kunnes POs',0),(239957,6666,'no','Vis ventende POs',0),(239958,6666,'da','Vis afventende POs',0),(239959,6666,'ko','POs ë³´ë¥˜ í‘œì‹œ',0),(239960,6666,'he','×œ×”×¦×™×’ ×ž×ž×ª×™× ×™× POs',0),(239961,6666,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î® POs',0),(239962,6666,'zh','æ˜¾ç¤ºå¾…å®šé‡‡è´­è®¢å•\r\n',0),(239963,6666,'sv','Visa pÃ¥gÃ¥ende POs',0),(239964,6666,'it','Visualizza in attesa di POs',0),(239965,6666,'tl','',0),(239966,6666,'th','&#3649;&#3626;&#3604;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(239967,6666,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(239968,6666,'ms','Menunjukkan sementara menunggu POs',0),(239969,6666,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù†ØªØ¸Ø§Ø±Ø§ Ù„Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹',0),(239970,6666,'fr','Voir l\'Ã©tablissement dans l\'attente de POs',0),(239971,6666,'jp','ä¿ç•™ä¸­ã® POs è¡¨ç¤ºã—ã¾ã™ã€‚',0),(239972,6666,'pt','Mostrar pendente POs',0),(239973,6666,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð´Ð¾ POs',0),(239974,6666,'es','Mostrar OCs Pendientes',0),(239975,6666,'de','Zeigen bis POs',0),(239976,6666,'en','Show Pending POs',0),(239977,6667,'is','',0),(239978,6667,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ù†Ù‡ Ù‡Ù†ÙˆØ² Ø¯Ø± ØªØ§ÙŠÙŠØ¯\r\n AP',0),(239979,6667,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ù†Ù‡ Ù‡Ù†ÙˆØ² Ø¯Ø± ØªØ§ÙŠÙŠØ¯\r\n AP',0),(239980,6667,'tr','AlÄ±nan POs, henÃ¼z AP iÃ§inde gÃ¶ster',0),(239981,6667,'pl','PokaÅ¼ otrzymane POs nie jeszcze w AP',0),(239982,6667,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ POs Ð²ÑÐµ Ð¾Ñ‰Ðµ Ð² AP',0),(239983,6667,'ur','Ù…ÙˆØµÙˆÙ„Û Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø§Ø¨Ú¾ÛŒ Ù†ÛÛŒÚº AP Ù…ÛŒÚº Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(239984,6667,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ ÐŸÐžÑ Ñ˜Ð¾Ñˆ Ð½Ð¸Ñ˜Ðµ Ñƒ ÐÐŸ',0),(239985,6667,'vi','Hiá»ƒn thá»‹ Ä‘Æ¡n mua hÃ ng Ä‘Ã£ nháº­n nhÆ°ng chÆ°a Ã¡p dá»¥ng',0),(239986,6667,'af','Wys Onvangde AB\'s Nog Nie In RB',0),(239987,6667,'ro','AratÄƒ primite POs Ã®ncÄƒ Ã®n AP',0),(239988,6667,'et','NÃ¤idata saabunud POs veel AP',0),(239989,6667,'si','PokaÅ¾i prejetih POs Å¡e ni v AP',0),(239990,6667,'ba','Tampilkan POs diterima belum di AP',0),(239991,6667,'nl','Nog niet ontvangen POs In AP weergeven',0),(239992,6667,'fi','NÃ¤ytÃ¤ vastaanotetut POs ei vielÃ¤ AP',0),(239993,6667,'no','Vise mottatte POs ikke AP',0),(239994,6667,'da','Vis modtagne POs endnu ikke i AP',0),(239995,6667,'ko','APì—ì„œ ë°›ì€ POsë¥¼ ì•„ì§ ë³´ì—¬',0),(239996,6667,'he','×”×¦×’ POs ×”×ª×§×‘×œ×• ×¢×“×™×™×Ÿ ×œ× ×‘- AP',0),(239997,6667,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î­Î»Î±Î²Îµ Î Î©Î£ Î´ÎµÎ½ ÏƒÎµ AP',0),(239998,6667,'zh','æ˜¾ç¤ºæœªåœ¨åº”ä»˜è´¦æ¬¾ä¸Šçš„æ”¶åˆ°çš„è®¢å•\r\n',0),(239999,6667,'sv','Visa mottagna POs Ã¤nnu inte i AP',0),(240000,6667,'it','Visualizza ricevuta POs non ancora In AP',0),(240001,6667,'tl','',0),(240002,6667,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3648;&#3',0),(240003,6667,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ POs à¤¨à¤¹à¥€à¤‚ à¤…à¤­à¥€ à¤¤à¤• à¤®à¥‡à¤‚ à¤à¤ªà¥€ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(240004,6667,'ms','Tunjuk POs diterima belum lagi dalam AP',0),(240005,6667,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ ØªÙ„Ù‚ÙŠ Ù„Ù… ÙŠØªÙ… Ø¨Ø¹Ø¯ ÙÙŠ ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(240006,6667,'fr','Montrer POs reÃ§us non encore en AP',0),(240007,6667,'jp','Ap é€šä¿¡ã§å—ä¿¡ã—ãŸ POs ã‚’ã¾ã è¡¨ç¤ºã—ã¾ã™ã€‚',0),(240008,6667,'pt','Mostrar POs recebidos ainda nÃ£o em AP',0),(240009,6667,'ru','Ð•Ñ‰Ðµ Ð½Ðµ Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ POs Ð² AP',0),(240010,6667,'es','Mostrar OCs Recibidos Que Ya No Estan En CP',0),(240011,6667,'de','Empfangene POs noch nicht In LD anzeigen',0),(240012,6667,'en','Show Received POs Not Yet In AP',0),(240013,6668,'is','',0),(240014,6668,'dr','- Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ù‡Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ù†ÙƒÙ†ÙŠØ¯',0),(240015,6668,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù‡Ù…Ù‡ Ø±Ø§ Ø¨Ø§Ø² ÙƒÙ†ÙŠØ¯- Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ù‡Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ù†ÙƒÙ†ÙŠØ¯',0),(240016,6668,'tr','TÃ¼m aÃ§Ä±k gÃ¶rmek iÃ§in tarih aralÄ±klarÄ±nÄ± seÃ§meyin',0),(240017,6668,'pl','Aby zobaczyÄ‡ wszystkie otwarte, nie wybierz zakresy dat',0),(240018,6668,'bg','Ð—Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸, Ð½Ðµ Ð¸Ð·Ð±Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð²Ð°Ð»Ð¸Ð´Ð½Ð¾ÑÑ‚',0),(240019,6668,'ur','ØªÙ…Ø§Ù… Ú©Ú¾Ù„ÛŒ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ØŒ ØªØ§Ø±ÛŒØ® Ø­Ø¯ÙˆØ¯ Ø§Ø·Ù„Ø§Ù‚ Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº',0),(240020,6668,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð²Ð¸Ð´ÐµÐ»Ð¸ ÑÐ²Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾, Ð½ÐµÐ¼Ð¾Ñ˜Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ð¸ Ð¸Ð·Ð±Ð¾Ñ€ Ð¾Ð¿ÑÐµÐ³Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(240021,6668,'vi','Äá»ƒ xem táº¥t cáº£ Má»Ÿ, Ä‘á»«ng chá»n pháº¡m vi ngÃ y',0),(240022,6668,'af','Om all Oop te sien, moenie datumreeks selekteer',0),(240023,6668,'ro','Pentru a vedea toate deschise, selectaÅ£i intervale datÄƒ',0),(240024,6668,'et','KÃµik avatud vaatamiseks valige KuupÃ¤evavahemikud',0),(240025,6668,'si','ÄŒe Å¾elite videti vse odprto, ne izberite datumov',0),(240026,6668,'ba','Untuk melihat semua terbuka, tidak memilih rentang tanggal',0),(240027,6668,'nl','Om te zien alle Open, Schakel niet datumbereiken',0),(240028,6668,'fi','NÃ¤hdÃ¤ksesi kaikki avoinna, valitse pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤vÃ¤lit',0),(240029,6668,'no','Hvis du vil se alle Ã¥pne, ikke Velg datoperioder',0),(240030,6668,'da','For at se alle Ã¥bne, ikke VÃ¦lg datointervaller',0),(240031,6668,'ko','ëª¨ë“  ì—´ì„ ë³´ë ¤ë©´, ë‚ ì§œ ë²”ìœ„ë¥¼ ì„ íƒ í•˜ì§€ ë§ˆì‹­ì‹œì˜¤',0),(240032,6668,'he','×›×“×™ ×œ×¨××•×ª ××ª ×›×œ ×¤×ª×—, ××œ ×ª×‘×—×¨ ×˜×•×•×—×™ ×ª××¨×™×›×™×',0),(240033,6668,'el','Î“Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ ÏŒÎ»Î± Î±Î½Î¿Î¹ÎºÏ„ÏŒÏ‚, Î¼Î·Î½ ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½',0),(240034,6668,'zh','è¦æŸ¥çœ‹æ‰€æœ‰æ‰“å¼€ï¼Œä¸è¦é€‰æ‹©æ—¥æœŸèŒƒå›´\r\n',0),(240035,6668,'sv','Om du vill se alla Ã¶ppna, inte VÃ¤lj datumintervall',0),(240036,6668,'it','Per vedere tutte aperte, non selezionare intervalli di date',0),(240037,6668,'tl','',0),(240038,6668,'th','&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3648;&#3611;&#3636;&#3604;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604; &#3652;&#3617;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3594;&#3656;&#3623;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(240039,6668,'hi','à¤¸à¤­à¥€ à¤–à¥à¤²à¥€ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤¨ à¤•à¤°à¥‡à¤‚',0),(240040,6668,'ms','Untuk melihat semua terbuka, tidak memilih julat tarikh',0),(240041,6668,'ar','Ù„Ù…Ø´Ø§Ù‡Ø¯Ø© ÙƒØ§ÙØ© Ù…ÙØªÙˆØ­Ø©ØŒ Ù„Ø§ ØªÙ‚Ù… Ø¨ØªØ­Ø¯ÙŠØ¯ Ù†Ø·Ø§Ù‚Ø§Øª ØªØ§Ø±ÙŠØ®',0),(240042,6668,'fr','Pour voir toutes les ouvertes, ne sÃ©lectionnez pas de plages de dates',0),(240043,6668,'jp','ã™ã¹ã¦ã®ã‚ªãƒ¼ãƒ—ãƒ³çŠ¶æ…‹ã‚’è¡¨ç¤ºã™ã‚‹ã«ã¯ã€æ—¥ä»˜ç¯„å›²ã‚’é¸æŠžã—ãªã„ã§ãã ã•ã„ã€‚',0),(240044,6668,'pt','Para ver todas abertas, nÃ£o selecione intervalos de data',0),(240045,6668,'ru','Ð”Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð²ÑÐµÑ… ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ…, Ð½Ðµ Ð²Ñ‹Ð±Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ñ‹Ðµ Ñ€Ð°Ð¼ÐºÐ¸',0),(240046,6668,'es','Para ve todos Abiertos, no seleccionar rangos de fechas',0),(240047,6668,'de','Um alle offenen anzuzeigen, wÃ¤hlen Sie keine Datumsbereiche',0),(240048,6668,'en','To see all Open, do not select date ranges',0),(240049,6669,'is','',0),(240050,6669,'dr','Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(240051,6669,'pr','Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(240052,6669,'tr','GÃ¼ncelliÄŸi',0),(240053,6669,'pl','Jak z',0),(240054,6669,'bg','ÐšÐ°Ñ‚Ð¾ Ð¾Ñ‚',0),(240055,6669,'ur','Ú©Û’ Ø·ÙˆØ± Ù¾Ø±',0),(240056,6669,'sr','ÐšÐ°Ð¾ Ð¾Ð´',0),(240057,6669,'vi','NhÆ° cá»§a',0),(240058,6669,'af','Soos Op',0),(240059,6669,'ro','Ca de',0),(240060,6669,'et','Seisuga',0),(240061,6669,'si','Kot od',0),(240062,6669,'ba','Sebagai',0),(240063,6669,'nl','Als van',0),(240064,6669,'fi','Alkaen',0),(240065,6669,'no','Som',0),(240066,6669,'da','Som af',0),(240067,6669,'ko','ë¡œ',0),(240068,6669,'he','×›×ž×• ×©×œ',0),(240069,6669,'el','Î©Ï‚ Ï„Î·Ï‚',0),(240070,6669,'zh','æˆªè‡³\r\n',0),(240071,6669,'sv','Som av',0),(240072,6669,'it','Come di',0),(240073,6669,'tl','',0),(240074,6669,'th','&#3648;&#3611;&#3655;&#3609;&#3586;&#3629;&#3591;',0),(240075,6669,'hi','à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚',0),(240076,6669,'ms','Sebagai kawan',0),(240077,6669,'ar','Ø¥Ø¹ØªØ¨Ø§Ø±Ø§ Ù…Ù†',0),(240078,6669,'fr','Ã€ compter du',0),(240079,6669,'jp','ã¨ã—ã¦',0),(240080,6669,'pt','A partir de',0),(240081,6669,'ru','ÐŸÐ¾ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸ÑŽ Ð½Ð°',0),(240082,6669,'es','Desde',0),(240083,6669,'de','Als der',0),(240084,6669,'en','As Of',0),(240085,6670,'is','',0),(240086,6670,'dr','(Ù„ÙŠØ³Øª Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡',0),(240087,6670,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø§Ø² Ù‚Ø¨Ù„ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ (Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(240088,6670,'tr','Ã–nceden faturalarÄ± Onayla',0),(240089,6670,'pl','ZatwierdÅº wstÄ™pnie rachunki',0),(240090,6670,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(240091,6670,'ur','Ù¾Ø±ÛŒ Ú©Û’ Ø¨Ù„ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ',0),(240092,6670,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ñ‚Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(240093,6670,'vi','HÃ³a ÄÆ¡n ÄÃ£ Cháº¥p Thuáº­n TrÆ°á»›c',0),(240094,6670,'af','Vooraf-Goedkeurde Rekeninge',0),(240095,6670,'ro','Pre-aproba facturile',0),(240096,6670,'et','Eelnevalt kinnitada arveid',0),(240097,6670,'si','Pre-odobri menice',0),(240098,6670,'ba','Pra-menyetujui tagihan',0),(240099,6670,'nl','Vooraf goedkeuring van rekeningen',0),(240100,6670,'fi','Ennalta hyvÃ¤ksy laskut',0),(240101,6670,'no','Pre-godkjenne regninger',0),(240102,6670,'da','ForhÃ¥nd godkende regninger',0),(240103,6670,'ko','ì‚¬ì „ ë²•ì•ˆ ìŠ¹ì¸',0),(240104,6670,'he','×ž×¨××© ×œ××©×¨ ××ª ×”×—×©×‘×•× ×•×ª',0),(240105,6670,'el','Î ÏÎ¿-ÎµÎ³ÎºÏÎ¯Î½ÎµÎ¹ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(240106,6670,'zh','é¢„å…ˆæ ¸å‡†å¸å•\r\n\r\n\r\né¢„å…ˆæ ¸å‡†æ³•æ¡ˆ\r\né¢„å…ˆæ ¸å‡†æ³•æ¡ˆ\r\né¢„å…ˆæ ¸å‡†æ³•æ¡ˆ\r\n\r\n',0),(240107,6670,'sv','FÃ¶rvÃ¤g godkÃ¤nna rÃ¤kningar',0),(240108,6670,'it','Pre-approvare le bollette',0),(240109,6670,'tl','',0),(240110,6670,'th','&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3648;&#3626;&#3637;&#3618;&#3585;&#3656;&#3629;&#3609;',0),(240111,6670,'hi','à¤ªà¥‚à¤°à¥à¤µ-à¤µà¤¿à¤§à¥‡à¤¯à¤•à¥‹à¤‚ à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€',0),(240112,6670,'ms','Sebelum meluluskan rang undang-undang',0),(240113,6670,'ar','Ù‚Ø¨Ù„ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ù…Ø´Ø§Ø±ÙŠØ¹ Ø§Ù„Ù‚ÙˆØ§Ù†ÙŠÙ†',0),(240114,6670,'fr','PrÃ©approuver des factures',0),(240115,6670,'jp','äº‹å‰ã«æ‰¿èªã™ã‚‹æ‰‹å½¢',0),(240116,6670,'pt','PrÃ©-aprovar as contas',0),(240117,6670,'ru','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¾Ð²',0),(240118,6670,'es','Recibos Pre Aprobados',0),(240119,6670,'de','Rechnungen im Voraus genehmigt',0),(240120,6670,'en','Pre-Approve Bills',0),(240121,6671,'is','',0),(240122,6671,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(240123,6671,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(240124,6671,'tr','Yazmak iÃ§in denetimlerini Ã¶nceden onaylanmÄ±ÅŸ',0),(240125,6671,'pl','Napisz kontroli zatwierdzone',0),(240126,6671,'bg','ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð·Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½',0),(240127,6671,'ur','Ú©Û’ Ù„Ø¦Û’ Ú†ÛŒÚ© Ù„Ú©Ú¾Ù†Û’ Ø³Û’ Ù¾ÛÙ„Û’ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(240128,6671,'sr','ÐŸÐ¸ÑÐ°ÑšÐµ Ñ‡ÐµÐºÐ¾Ð²Ð° Ð½Ð° Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ñ‚Ð¸',0),(240129,6671,'vi','Viáº¿t SÃ©c Ä‘á»ƒ duyá»‡t trÆ°á»›c',0),(240130,6671,'af','Skryf Tjeks Vir die wat Voorafgoedgekeur is',0),(240131,6671,'ro','Scrie controalelor pentru pre-aprobate',0),(240132,6671,'et','*Write Checks For PreApproved',0),(240133,6671,'si','PiÅ¡ejo pregledov za predhodno odobrene',0),(240134,6671,'ba','Menulis cek untuk pra-disetujui',0),(240135,6671,'nl','Schrijven van controles voor vooraf',0),(240136,6671,'fi','Kirjoittaa tarkistaa valmiiksi hyvÃ¤ksytty',0),(240137,6671,'no','Skrive sjekker For pre-godkjent',0),(240138,6671,'da','Skrive Checks For forhÃ¥ndsgodkendt',0),(240139,6671,'ko','ìž‘ì„± í•œ ì‚¬ì „ ìŠ¹ì¸',0),(240140,6671,'he','×œ×›×ª×•×‘ ×¦\'×§×™× ×¢×‘×•×¨ ×ž××•×©×¨×™× ×ž×¨××©',0),(240141,6671,'el','Î“ÏÎ¬Ï†Ï‰ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Î³Î¹Î± Ï€ÏÎ¿-ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯',0),(240142,6671,'zh','é¢„å…ˆæ ¸å‡†çš„å†™æ”¯ç¥¨\r\n',0),(240143,6671,'sv','Skriver kontroller fÃ¶r lÃ¥nelÃ¶fte',0),(240144,6671,'it','Scrivere assegni per pre-approvato',0),(240145,6671,'tl','',0),(240146,6671,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;',0),(240147,6671,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡ à¤•à¥‡ à¤ªà¥‚à¤°à¥à¤µ-à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤',0),(240148,6671,'ms','Menulis cek untuk pra-lulus',0),(240149,6671,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ù…Ø³Ø¨Ù‚Ø©',0),(240150,6671,'fr','Ã‰crire des contrÃ´les pour prÃ©-approuvÃ©s',0),(240151,6671,'jp','å°åˆ‡æ‰‹ã®äº‹å‰æ‰¿èª',0),(240152,6671,'pt','Cheques para pre-aprovado',0),(240153,6671,'ru','Ð’Ñ‹Ð¿Ð¸ÑÑ‹Ð²Ð°Ñ‚ÑŒ Ñ‡ÐµÐºÐ¸ Ð½Ð° Ð·Ð°Ñ€Ð°Ð½ÐµÐµ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ñ…',0),(240154,6671,'es','Escriba cheques para PreAprobado',0),(240155,6671,'de','Schreiben Ã¼berprÃ¼ft vorab genehmigt',0),(240156,6671,'en','Write Checks For Pre-Approved',0),(240157,6672,'is','',0),(240158,6672,'dr','Ù‡Ù…Ù‡ ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ø·Ø±ÙŠÙ‚',0),(240159,6672,'pr','Ù‡Ù…Ù‡ ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ø·Ø±ÙŠÙ‚',0),(240160,6672,'tr','TÃ¼m Ã¶deme tarihleri arasÄ±nda',0),(240161,6672,'pl','Wszystkie terminy pÅ‚atnoÅ›ci za poÅ›rednictwem',0),(240162,6672,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ð°Ñ‚Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ñ‡Ñ€ÐµÐ·',0),(240163,6672,'ur','ØªÙ…Ø§Ù… Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(240164,6672,'sr','Ð¡Ð²Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° ÐºÑ€Ð¾Ð·',0),(240165,6672,'vi','Táº¥t Cáº£ NgÃ y Thanh ToÃ¡n Qua',0),(240166,6672,'af','Alle Betalings Datums Regdeur',0),(240167,6672,'ro','Toate datele de platÄƒ prin',0),(240168,6672,'et','KÃµik lepingus kokkulepitud kaudu',0),(240169,6672,'si','Vsi datumi plaÄila prek',0),(240170,6672,'ba','Semua tanggal pembayaran melalui',0),(240171,6672,'nl','Alle betalingsdatums via',0),(240172,6672,'fi','Kaikki maksupÃ¤ivÃ¤t kautta',0),(240173,6672,'no','Alle betalingsterminene gjennom',0),(240174,6672,'da','Alle betalingsdatoer gennem',0),(240175,6672,'ko','í†µí•´ ëª¨ë“  ì§€ë¶ˆ ë‚ ì§œ',0),(240176,6672,'he','×›×œ ×ª××¨×™×›×™ ×ª×©×œ×•× ×“×¨×š',0),(240177,6672,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î¼Î­ÏƒÏ‰',0),(240178,6672,'zh','æ‰€æœ‰çš„ä»˜æ¬¾æ—¥æœŸé€šè¿‡\r\n',0),(240179,6672,'sv','Alla betalningsdatum genom',0),(240180,6672,'it','Tutte le date di pagamento attraverso',0),(240181,6672,'tl','',0),(240182,6672,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3636;&#3657;&#3609;',0),(240183,6672,'hi','à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤¸à¤­à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(240184,6672,'ms','Semua tarikh pembayaran melalui',0),(240185,6672,'ar','Ø¬Ù…ÙŠØ¹ Ù…ÙˆØ§Ø¹ÙŠØ¯ Ø§Ù„Ø¯ÙØ¹ Ù…Ù† Ø®Ù„Ø§Ù„',0),(240186,6672,'fr','Toutes les Dates de paiement par l\'intermÃ©diaire',0),(240187,6672,'jp','ã™ã¹ã¦ã®ãŠæ”¯æ‰•ã„æ—¥ã¾ã§',0),(240188,6672,'pt','Todas as datas de pagamento atravÃ©s de',0),(240189,6672,'ru','Ð’ÑÐµ Ð´Ð°Ñ‚Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ñ‡ÐµÑ€ÐµÐ·',0),(240190,6672,'es','Todas las Fechas de Pago Por',0),(240191,6672,'de','Alle Zahlungstermine durch',0),(240192,6672,'en','All Payment Dates Through',0),(240193,6673,'is','',0),(240194,6673,'dr','Ù…Ø¨Ù„Øº ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(240195,6673,'pr','Ù…Ø¨Ù„Øº ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(240196,6673,'tr','Onaylanan tutarÄ±',0),(240197,6673,'pl','Zatwierdzona kwota',0),(240198,6673,'bg','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(240199,6673,'ur','Ù…Ù†Ø¸ÙˆØ± Ø´Ø¯Û Ø±Ù‚Ù…',0),(240200,6673,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(240201,6673,'vi','Sá»‘ Tiá»n Cháº¥p Thuáº­n',0),(240202,6673,'af','Goedgekeurde Bedrag',0),(240203,6673,'ro','Suma autorizatÄƒ',0),(240204,6673,'et','Kinnitatud summa',0),(240205,6673,'si','Odobreni znesek',0),(240206,6673,'ba','Jumlah yang disetujui',0),(240207,6673,'nl','Goedgekeurde bedrag',0),(240208,6673,'fi','HyvÃ¤ksytty tukimÃ¤Ã¤rÃ¤',0),(240209,6673,'no','Godkjent belÃ¸p',0),(240210,6673,'da','Godkendt belÃ¸b',0),(240211,6673,'ko','ìŠ¹ì¸ëœ ê¸ˆì•¡',0),(240212,6673,'he','×”×¡×›×•× ×©××•×©×¨',0),(240213,6673,'el','Î•Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Ï€Î¿ÏƒÏŒ',0),(240214,6673,'zh','æ ¸å‡†é‡‘é¢\r\n',0),(240215,6673,'sv','GodkÃ¤nda beloppet',0),(240216,6673,'it','Importo approvato',0),(240217,6673,'tl','',0),(240218,6673,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(240219,6673,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤°à¤¾à¤¶à¤¿',0),(240220,6673,'ms','Jumlah diluluskan',0),(240221,6673,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¹ØªÙ…Ø¯',0),(240222,6673,'fr','Montant approuvÃ©',0),(240223,6673,'jp','æ‰¿èªé‡‘é¡',0),(240224,6673,'pt','Quantidade aprovada',0),(240225,6673,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(240226,6673,'es','Aprobado Cantidad',0),(240227,6673,'de','Genehmigten Betrag',0),(240228,6673,'en','Approved Amount',0),(240229,6674,'is','',0),(240230,6674,'dr','(ØªÙ†Ø²ÙŠÙ„) ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(240231,6674,'pr','Ø¨Ù‡Ø±Ù‡ (ØªÙ†Ø²ÙŠÙ„) ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(240232,6674,'tr','Onaylanan faiz',0),(240233,6674,'pl','Zatwierdzone zainteresowania',0),(240234,6674,'bg','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ‚Ðµ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(240235,6674,'ur','Ù…Ù†Ø¸ÙˆØ± Ø´Ø¯Û Ø³ÙˆØ¯',0),(240236,6674,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ðµ ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(240237,6674,'vi','LÃ£i Suáº¥t Cháº¥p Thuáº­n',0),(240238,6674,'af','Goedgekeurde Rente',0),(240239,6674,'ro','Aprobat de interes',0),(240240,6674,'et','Heakskiidetud huvi',0),(240241,6674,'si','Pomena odobrene',0),(240242,6674,'ba','Disetujui bunga',0),(240243,6674,'nl','Goedgekeurde belang',0),(240244,6674,'fi','HyvÃ¤ksytyn etua',0),(240245,6674,'no','Godkjent interesse',0),(240246,6674,'da','Godkendte interesse',0),(240247,6674,'ko','ìŠ¹ì¸ëœ ê´€ì‹¬',0),(240248,6674,'he','×¢× ×™×™×Ÿ ×©××•×©×¨×•',0),(240249,6674,'el','Î•Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½',0),(240250,6674,'zh','æ ¸å‡†åˆ©æ¯\r\n',0),(240251,6674,'sv','GodkÃ¤nda intresse',0),(240252,6674,'it','Riconosciuti di interesse',0),(240253,6674,'tl','',0),(240254,6674,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;',0),(240255,6674,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤¬à¥à¤¯à¤¾à¤œ',0),(240256,6674,'ms','Faedah yang diluluskan',0),(240257,6674,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(240258,6674,'fr','IntÃ©rÃªt approuvÃ©',0),(240259,6674,'jp','æ‰¿èªã•ã‚ŒãŸèˆˆå‘³',0),(240260,6674,'pt','Interesse aprovado',0),(240261,6674,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(240262,6674,'es','Aprobado InterÃ©s',0),(240263,6674,'de','Zugelassenen Interesse',0),(240264,6674,'en','Approved Interest',0),(240265,6675,'is','',0),(240266,6675,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª ÙÙ‚Ø· Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(240267,6675,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª ÙÙ‚Ø· Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(240268,6675,'tr','Sadece eski maaÅŸÄ±yla denetleyin',0),(240269,6675,'pl','SprawdziÄ‡ zapÅ‚aciÄ‡ na stare tylko',0),(240270,6675,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ñ€Ð¸ ÑÐ°Ð¼Ð¾',0),(240271,6675,'ur','Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº Ú©Û Ù¾Ø±Ø§Ù†Û’ Ù¾Ø± ØªÙ†Ø®ÙˆØ§Û ØµØ±Ù',0),(240272,6675,'sr','Ð¡Ð°Ð¼Ð¾ ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð° Ð¿Ð»Ð°Ñ‚Ðµ Ð½Ð° ÑÑ‚Ð°Ñ€Ð¾Ñ˜',0),(240273,6675,'vi','ÄÃ¡nh dáº¥u Ä‘á»ƒ thanh toÃ¡n trÃªn cÅ©',0),(240274,6675,'af','Kontroleer net te betaal op die ou',0),(240275,6675,'ro','Verifica plata pe vechi numai',0),(240276,6675,'et','Kontrollige vana maksma ainult',0),(240277,6675,'si','Preverite plaÄilo na stari le',0),(240278,6675,'ba','Periksa untuk membayar pada tua hanya',0),(240279,6675,'nl','Check om te betalen op oude alleen',0),(240280,6675,'fi','Tarkista maksu vanha vain',0),(240281,6675,'no','Sjekk Ã¥ betale pÃ¥ gamle bare',0),(240282,6675,'da','Check til at betale pÃ¥ gamle kun',0),(240283,6675,'ko','ë§Œ ì„¸ì— ì§€ë¶ˆ í™•ì¸',0),(240284,6675,'he','×‘×“×•×§ ×›×“×™ ×œ×©×œ× ×¢×œ ×–×§× ×” ×‘×œ×‘×“',0),(240285,6675,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î³Î¹Î± Î½Î± Ï€Î»Î·ÏÏŽÏƒÎµÎ¹ ÏƒÎµ Ï€Î±Î»Î¹ÏŒ Î¼ÏŒÎ½Î¿',0),(240286,6675,'zh','æ”¯ç¥¨æ”¯ä»˜ï¼Œåªæœ‰æ—§\r\n',0),(240287,6675,'sv','Kontrollera att betala pÃ¥ gamla endast',0),(240288,6675,'it','Verifica a Pay sul vecchio solo',0),(240289,6675,'tl','',0),(240290,6675,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3627;&#3609;&#3637;&#3657;&#3626;&#3636;&#3609;&#3648;&#3585;&#3656;&#3634;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(240291,6675,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥à¤°à¤¾à¤¨à¥‡ à¤ªà¤° à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(240292,6675,'ms','Semakan bayar pada lama sahaja',0),(240293,6675,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø£Ø¬Ø± Ø¹Ù„Ù‰ Ø§Ù„Ù‚Ø¯ÙŠÙ… ÙÙ‚Ø·',0),(240294,6675,'fr','VÃ©rifier uniquement Ã  la rÃ©munÃ©ration Ã  l\'ancienne',0),(240295,6675,'jp','å¤ã„ãŠæ”¯æ‰•ã„ãƒã‚§ãƒƒã‚¯ã®ã¿',0),(240296,6675,'pt','Verificar apenas para pagar no velho',0),(240297,6675,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð¿Ð¾ ÑÑ‚Ð°Ñ€Ñ‹Ð¼ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(240298,6675,'es','Chequear para Pagar el Antiguo Solamente',0),(240299,6675,'de','Nur zu zahlen auf alten Ã¼berprÃ¼fen',0),(240300,6675,'en','Check to Pay on Old Only',0),(240301,6676,'is','',0),(240302,6676,'dr','Ø§Ú¯Ø± Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†ÙƒÙŠ ',0),(240303,6676,'pr','Ø§Ú¯Ø± Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†ÙƒÙŠ ',0),(240304,6676,'tr','EÄŸer Ã§ek hesabÄ±',0),(240305,6676,'pl','JeÅ›li sprawdzanie konta',0),(240306,6676,'bg','ÐÐºÐ¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(240307,6676,'ur','Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Ø§Ú¯Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(240308,6676,'sr','ÐÐºÐ¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ñ€Ð°Ñ‡ÑƒÐ½',0),(240309,6676,'vi','Náº¿u TK SÃ©c',0),(240310,6676,'af','Indien Tjekrekening',0),(240311,6676,'ro','DacÄƒ verificaÅ£i contul',0),(240312,6676,'et','Kui vaadata konto',0),(240313,6676,'si','ÄŒe preverite raÄun',0),(240314,6676,'ba','Jika memeriksa Account',0),(240315,6676,'nl','Als controleren rekening',0),(240316,6676,'fi','Jos Tarkista',0),(240317,6676,'no','Hvis Sjekk kontoen',0),(240318,6676,'da','Hvis Check konto',0),(240319,6676,'ko','ë§Œì•½ í™•ì¸ ê³„ì •',0),(240320,6676,'he','×‘×“×•×§ ×× ×—×©×‘×•×Ÿ',0),(240321,6676,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î±Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï.',0),(240322,6676,'zh','å¦‚æžœæŸ¥è¯¢è´¦æˆ·\r\n',0),(240323,6676,'sv','Om kontrollera konto',0),(240324,6676,'it','Se verifica Account',0),(240325,6676,'tl','',0),(240326,6676,'th','&#3606;&#3657;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3594;&#3655;&#3588;',0),(240327,6676,'hi','à¤¯à¤¦à¤¿ à¤œà¤¾à¤à¤š à¤–à¤¾à¤¤à¥‡',0),(240328,6676,'ms','Jika Semak akaun',0),(240329,6676,'ar','Ø¥Ø°Ø§ ØªØ­Ù‚Ù‚ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(240330,6676,'fr','Si VÃ©rifiez l\'on tient compte',0),(240331,6676,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ç¢ºèª',0),(240332,6676,'pt','Se verifique a conta',0),(240333,6676,'ru','Ð•ÑÐ»Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚',0),(240334,6676,'es','Si Cuenta de Cheques',0),(240335,6676,'de','Wenn Check berÃ¼cksichtigen',0),(240336,6676,'en','If Check Account',0),(240337,6677,'is','',0),(240338,6677,'dr','(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†Ùƒ  ',0),(240339,6677,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†Ùƒ  ',0),(240340,6677,'tr','Ã–deme Ã§ek hesabÄ±',0),(240341,6677,'pl','Rachunku czekowego',0),(240342,6677,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(240343,6677,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹',0),(240344,6677,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(240345,6677,'vi','TK Kiá»ƒm Tra Thanh ToÃ¡n',0),(240346,6677,'af','Uitbetaling Tjekrekening',0),(240347,6677,'ro','Cont de verificare platÄƒ',0),(240348,6677,'et','Makse pangakonto',0),(240349,6677,'si','TekoÄi raÄun plaÄilne',0),(240350,6677,'ba','Rekening pembayaran',0),(240351,6677,'nl','Betaling betaalrekening',0),(240352,6677,'fi','Maksun pankkitililtÃ¤si',0),(240353,6677,'no','Betaling brukskonto',0),(240354,6677,'da','Betaling checkkonto',0),(240355,6677,'ko','ê²°ì œ ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(240356,6677,'he','×ª×©×œ×•× ×—×©×‘×•×Ÿ ×‘× ×§',0),(240357,6677,'el','Î¤ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(240358,6677,'zh','ä»˜æ¬¾æ£€æŸ¥å¸æˆ·\r\n',0),(240359,6677,'sv','Betalning lÃ¶nekonto',0),(240360,6677,'it','Pagamento conto corrente',0),(240361,6677,'tl','',0),(240362,6677,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3594;&#3655;&#3588;',0),(240363,6677,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(240364,6677,'ms','Bayaran memeriksa akaun',0),(240365,6677,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø¯ÙØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(240366,6677,'fr','Compte de chÃ¨que de paiement',0),(240367,6677,'jp','ãŠæ”¯æ‰•ã„ã®å½“åº§é é‡‘å£åº§',0),(240368,6677,'pt','Conta de pagamento',0),(240369,6677,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð°',0),(240370,6677,'es','Cuenta Bancaria de Cheques de Pago',0),(240371,6677,'de','Zahlung-Girokonto',0),(240372,6677,'en','Payment Checking Account',0),(240373,6678,'is','',0),(240374,6678,'dr','(Ù…Ø¹Ø§Ø´',0),(240375,6678,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª(Ø­Ù‚ÙˆÙ‚',0),(240376,6678,'tr','Toplam Ã¶deme',0),(240377,6678,'pl','CaÅ‚kowita zapÅ‚aciÄ‡',0),(240378,6678,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(240379,6678,'ur','Ú©Ù„ ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ù„ÛŒÛ’',0),(240380,6678,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(240381,6678,'vi','Tá»•ng cá»™ng Ä‘á»ƒ tráº£',0),(240382,6678,'af','Totaal Betaalbaar',0),(240383,6678,'ro','TotalÄƒ de la plata',0),(240384,6678,'et','TÃ¶Ã¶tasu kokku',0),(240385,6678,'si','Skupaj za plaÄilo',0),(240386,6678,'ba','Total untuk membayar',0),(240387,6678,'nl','Totaal te betalen',0),(240388,6678,'fi','YhteensÃ¤ maksu',0),(240389,6678,'no','Samlet lÃ¸nn',0),(240390,6678,'da','Samlede lÃ¸n',0),(240391,6678,'ko','ì´ ì§€ë¶ˆ',0),(240392,6678,'he','×¡×” ×› ×ª×©×œ×•×',0),(240393,6678,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Î½Î± Ï€Î»Î·ÏÏŽÏƒÎµÎ¹',0),(240394,6678,'zh','å…±æ”¯ä»˜\r\n',0),(240395,6678,'sv','Totalt att betala',0),(240396,6678,'it','Totale a pagare',0),(240397,6678,'tl','',0),(240398,6678,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(240399,6678,'hi','à¤•à¥à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(240400,6678,'ms','Jumlah bayar',0),(240401,6678,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ© Ù„Ù„Ø£Ø¬ÙˆØ±',0),(240402,6678,'fr','Total Ã  payer',0),(240403,6678,'jp','æ”¯æ‰•åˆè¨ˆ',0),(240404,6678,'pt','Total a pagar',0),(240405,6678,'ru','Ð’ÑÐµÐ³Ð¾ Ðº Ð¾Ð¿Ð»Ð°Ñ‚Ðµ',0),(240406,6678,'es','Total para Pagar',0),(240407,6678,'de','Insgesamt zu zahlen',0),(240408,6678,'en','Total To Pay',0),(240409,6679,'is','',0),(240410,6679,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ø§Ú¯Ø± Ø¨Ø±Ø±Ø³ÙŠ Ø´Ø¯ ',0),(240411,6679,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ø§Ú¯Ø± Ø¨Ø±Ø±Ø³ÙŠ Ø´Ø¯ ',0),(240412,6679,'tr','Ã–deme tarihi kontrol varsa gÃ¶z ardÄ± eder',0),(240413,6679,'pl','Zignoruje data pÅ‚atnoÅ›ci, jeÅ›li zaznaczone',0),(240414,6679,'bg','Ð©Ðµ Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, Ð°ÐºÐ¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(240415,6679,'ur','Ø§Ú¯Ø± ØªÙˆ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ù†Ø¸Ø±Ø§Ù†Ø¯Ø§Ø² Ú©Ø± Ø¯Û’ Ú¯Ø§',0),(240416,6679,'sr','Ð‹Ðµ Ð·Ð°Ð½ÐµÐ¼Ð°Ñ€Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð°ÐºÐ¾ Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾',0),(240417,6679,'vi','Bá» qua ngÃ y thanh toÃ¡n náº¿u Ä‘Ã¡nh dáº¥u',0),(240418,6679,'af','Sal Betalingsdatum Ignoreer Indien Gemerk is',0),(240419,6679,'ro','Va ignora data plÄƒÅ£ii dacÄƒ verificat',0),(240420,6679,'et','Kui mÃ¤rgitud, eirab maksekuupÃ¤eva',0),(240421,6679,'si','Datum plaÄila bo prezreti, Äe preverijo',0),(240422,6679,'ba','Akan mengabaikan tanggal pembayaran jika dicentang',0),(240423,6679,'nl','Datum van betaling zal negeren als gecontroleerd',0),(240424,6679,'fi','Ohittaa maksupÃ¤ivÃ¤, jos valittu',0),(240425,6679,'no','Ignorerer betalingsdatoen hvis merket',0),(240426,6679,'da','Vil ignorere betalingsdato, hvis markeret',0),(240427,6679,'ko','ì²´í¬ ì§€ë¶ˆ ë‚ ì§œë¥¼ ë¬´ì‹œ í•©ë‹ˆë‹¤.',0),(240428,6679,'he','×™×ª×¢×œ× ×ª××¨×™×š ×”×ª×©×œ×•× ×× ×‘×“×§×ª',0),(240429,6679,'el','Î˜Î± Î±Î³Î½Î¿Î®ÏƒÎµÎ¹ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚, Î±Î½ ÎµÎ»Î­Î³Ï‡ÎµÏ„Î±Î¹',0),(240430,6679,'zh','å¦‚æžœé€‰ä¸­ï¼Œå°†å¿½ç•¥ä»˜æ¬¾æ—¥æœŸ\r\n',0),(240431,6679,'sv','Att ignorera betalningsdatum om markerad',0),(240432,6679,'it','IgnorerÃ  la data di pagamento se controllato',0),(240433,6679,'tl','',0),(240434,6679,'th','&#3592;&#3632;&#3621;&#3632;&#3607;&#3636;&#3657;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3606;&#3657;&#3634;&#3617;&#3637;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3',0),(240435,6679,'hi','à¤¯à¤¦à¤¿ à¤šà¥‡à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿ à¤ªà¤° à¤§à¥à¤¯à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤¦à¥‡à¤—à¤¾',0),(240436,6679,'ms','Akan mengabaikan tarikh pembayaran jika disemak',0),(240437,6679,'ar','Ø³ÙŠØªÙ… ØªØ¬Ø§Ù‡Ù„ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹ Ø¥Ø°Ø§ Ø±Ø§Ø¬Ø¹Øª',0),(240438,6679,'fr','Ignorera la Date de paiement s\'il est activÃ©',0),(240439,6679,'jp','ã‚ªãƒ³ã«ã—ãŸå ´åˆã®æ”¯æ‰•æ—¥ã¯ç„¡è¦–ã•ã‚Œã¾ã™ã€‚',0),(240440,6679,'pt','IrÃ¡ ignorar a data de pagamento, se verificado',0),(240441,6679,'ru','Ð‘ÑƒÐ´ÐµÑ‚ Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ð°Ñ‚Ñ‹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°, ÐµÑÐ»Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(240442,6679,'es','Se IgnorarÃ¡ Fecha de Pago Si Marcado',0),(240443,6679,'de','Zahlungsdatum ignoriert wenn aktiviert',0),(240444,6679,'en','Will Ignore Payment Date If Checked',0),(240445,6680,'is','',0),(240446,6680,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø§ÙˆÙ„ÙŠÙ‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§',0),(240447,6680,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø§ÙˆÙ„ÙŠÙ‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§',0),(240448,6680,'tr','Ã–nceden onaylanmÄ±ÅŸ faturalar iÃ§in Ã§ekler yazmak',0),(240449,6680,'pl','KsiÄ…Å¼eczkÄ… dla wstÄ™pnie zatwierdzonych rachunki',0),(240450,6680,'bg','ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð·Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(240451,6680,'ur','Ù¾ÛŒØ´Ú¯ÛŒ Ù…Ù†Ø¸ÙˆØ± Ø´Ø¯Û Ø¨ÙÙ„ Ú©Û’ Ù„ÛŒÛ’ Ø¢Ù¾ Ú†ÛŒÚ© Ù„Ú©Ú¾',0),(240452,6680,'sr','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð·Ð° Ð¿Ñ€ÐµÐ»Ð¸Ð¼Ð¸Ð½Ð°Ñ€Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ… Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(240453,6680,'vi','Viáº¿t SÃ©c Cho HÃ³a ÄÆ¡n ÄÃ£ Cháº¥p Thuáº­n trÆ°á»›c',0),(240454,6680,'af','Skryf Tjeks Vir Voorafgoedgekeurde \"Bills\"',0),(240455,6680,'ro','Scrie controalelor pentru facturile de pre-aprobate',0),(240456,6680,'et','*Write Checks For PreApproved Bills',0),(240457,6680,'si','PiÅ¡ejo pregledov za predhodno odobrene raÄune',0),(240458,6680,'ba','Menulis cek untuk tagihan pra-disetujui',0),(240459,6680,'nl','Controles schrijven voor pre-goedgekeurde rekeningen',0),(240460,6680,'fi','Kirjoittaa tarkistaa etukÃ¤teen hyvÃ¤ksytyt laskut',0),(240461,6680,'no','Skrive For forhÃ¥ndsgodkjente regninger',0),(240462,6680,'da','Skrive Checks For pre-godkendte regninger',0),(240463,6680,'ko','ì‚¬ì „ ìŠ¹ì¸ ëœ ë²•ì•ˆì— ëŒ€ í•œ ê²€ì‚¬ë¥¼ ìž‘ì„±',0),(240464,6680,'he','×œ×›×ª×•×‘ ×¦\'×§×™× ×¢×œ ×”×—×©×‘×•× ×•×ª ×©××•×©×¨×• ×ž×¨××©',0),(240465,6680,'el','Î“ÏÎ¬Ï†Ï‰ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Î³Î¹Î± Ï€ÏÎ¿ÎµÎ³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(240466,6680,'zh','ä¸ºé¢„å…ˆæ ¸å‡†çš„å¸å•å†™å‘ç¥¨\r\n',0),(240467,6680,'sv','Skriv kontroller fÃ¶r lÃ¥nelÃ¶fte rÃ¤kningar',0),(240468,6680,'it','Scrivere assegni per bollette pre-approvate',0),(240469,6680,'tl','',0),(240470,6680,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3',0),(240471,6680,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤¬à¤¿à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¨à¥‡',0),(240472,6680,'ms','Menulis cek untuk bil-bil yang diluluskan terlebih dahulu',0),(240473,6680,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª Ù„Ù…Ø´Ø§Ø±ÙŠØ¹ Ø§Ù„Ù‚ÙˆØ§Ù†ÙŠÙ† Ø§Ù„Ù…ÙˆØ§ÙÙ‚ Ø¹Ù„ÙŠÙ‡Ø§ Ù…Ø³Ø¨Ù‚Ø§Ù‹',0),(240474,6680,'fr','Ã‰crire des chÃ¨ques pour les projets de loi approuvÃ©s au prÃ©alable',0),(240475,6680,'jp','äº‹å‰ã«æ‰¿èªã•ã‚ŒãŸæ‰‹å½¢ã®ãŸã‚ã®å°åˆ‡æ‰‹ã‚’æ›¸ã',0),(240476,6680,'pt','Cheques por notas de pre-aprovadas',0),(240477,6680,'ru','Ð’Ñ‹Ð¿Ð¸ÑÑ‹Ð²Ð°Ñ‚ÑŒ Ñ‡ÐµÐºÐ¸ Ð½Ð° Ð·Ð°Ñ€Ð°Ð½ÐµÐµ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¾Ð²',0),(240478,6680,'es','Escriba cheques para Facturas PreAprobadas',0),(240479,6680,'de','PrÃ¼fungen fÃ¼r vorab zugelassenen Rechnungen schreiben',0),(240480,6680,'en','Write Checks For Pre-Approved Bills',0),(240481,6681,'is','',0),(240482,6681,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¨Ø§Ø² Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(240483,6681,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¨Ø§Ø² Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(240484,6681,'tr','EÅŸleÅŸen hiÃ§bir aÃ§Ä±k faturalar buldum',0),(240485,6681,'pl','Nie pasujÄ…ce rachunki otwarte znaleÅºÄ‡',0),(240486,6681,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸',0),(240487,6681,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ú©Ú¾Ù„ÛŒ Ø¨Ù„ Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(240488,6681,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ, Ð½Ð°ÑˆÐ°Ð¾',0),(240489,6681,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ³a Ä‘Æ¡n má»Ÿ phÃ¹ há»£p ',0),(240490,6681,'af','Geen Gepasde Oop Rekeninge Gevind',0),(240491,6681,'ro','Nicio potrivire facturile deschis gÄƒsit',0),(240492,6681,'et','Ole vastavaid avatud arved leitud',0),(240493,6681,'si','Ni ujemajoÄih odprte raÄune, naÅ¡el',0),(240494,6681,'ba','Tagihan terbuka tidak cocok ditemukan',0),(240495,6681,'nl','Geen overeenkomende Open rekeningen gevonden',0),(240496,6681,'fi','Ei vastaavia avoimet laskut lÃ¶ytyi',0),(240497,6681,'no','Ingen samsvarende Ã¥pne regninger funnet',0),(240498,6681,'da','Ingen matchende Ã¥ben regninger fundet',0),(240499,6681,'ko','ì•„ë‹ˆ ì¼ì¹˜ ì˜¤í”ˆ ì§€í ë°œê²¬',0),(240500,6681,'he','×‘×œ×™ ×—×©×‘×•× ×•×ª ×¤×ª×•×—×™× ×ª×•××ž×•×ª × ×ž×¦××•',0),(240501,6681,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Î±Î½Î¿Î¹ÎºÏ„Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(240502,6681,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„å¼€æ”¾å¸å•\r\n',0),(240503,6681,'sv','Inga matchande Ã¶ppna rÃ¤kningar hittade',0),(240504,6681,'it','No bollette aperte corrispondente trovate',0),(240505,6681,'tl','',0),(240506,6681,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(240507,6681,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤“à¤ªà¤¨ à¤¬à¤¿à¤² à¤®à¤¿à¤²à¤¾',0),(240508,6681,'ms','Bil terbuka tiada padanan ditemui',0),(240509,6681,'ar','Ù„Ø§ ÙÙˆØ§ØªÙŠØ± Ù…ÙØªÙˆØ­Ø© Ù…Ø·Ø§Ø¨Ù‚Ø© ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(240510,6681,'fr','Aucune facture ouverte correspondant trouvÃ©',0),(240511,6681,'jp','è¦‹ã¤ã‹ã£ãŸä¸€è‡´ã™ã‚‹ã‚ªãƒ¼ãƒ—ãƒ³ä»£ã¯ã‹ã‹ã‚Šã¾ã›ã‚“',0),(240512,6681,'pt','Sem contas abertas correspondentes encontradas',0),(240513,6681,'ru','ÐÐµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð° Ð½Ð°ÑˆÐ»Ð¸',0),(240514,6681,'es','No se Encontraron Recibos Abiertos Emparejados',0),(240515,6681,'de','Keine passenden offenen Rechnungen gefunden',0),(240516,6681,'en','No Matching Open Bills Found',0),(240517,6682,'is','',0),(240518,6682,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø¯Ù‡ÙŠ ',0),(240519,6682,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø¯Ù‡ÙŠ ',0),(240520,6682,'tr','Alacak tutarÄ±',0),(240521,6682,'pl','NaleÅ¼nÄ… kwotÄ™',0),(240522,6682,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð¼Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(240523,6682,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ¬Û Ø³Û’',0),(240524,6682,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð´ÑƒÐ³Ð°',0),(240525,6682,'vi','Sá»‘ Tiá»n Äáº¿n Háº¡n',0),(240526,6682,'af','Bedrag Verskuldig',0),(240527,6682,'ro','Suma datoratÄƒ',0),(240528,6682,'et','Saadaolev summa',0),(240529,6682,'si','Dolgovani znesek',0),(240530,6682,'ba','Jumlah jatuh tempo',0),(240531,6682,'nl','Verschuldigde bedrag',0),(240532,6682,'fi','Laskun summa',0),(240533,6682,'no','BelÃ¸pet',0),(240534,6682,'da','Forfaldent belÃ¸b',0),(240535,6682,'ko','ë¯¸ë‚© ê¸ˆì•¡',0),(240536,6682,'he','×¡×›×•× ×œ×—×™×•×‘',0),(240537,6682,'el','ÎŸÏ†ÎµÎ¹Î»ÏŒÎ¼ÎµÎ½Î¿ Ï€Î¿ÏƒÏŒ',0),(240538,6682,'zh','åº”ä»˜é‡‘é¢\r\n',0),(240539,6682,'sv','FÃ¶rfallet belopp',0),(240540,6682,'it','Importo dovuto',0),(240541,6682,'tl','',0),(240542,6682,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(240543,6682,'hi','à¤¦à¥‡à¤¯ à¤°à¤¾à¤¶à¤¿',0),(240544,6682,'ms','Jumlah terhutang',0),(240545,6682,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚',0),(240546,6682,'fr','Montant dÃ»',0),(240547,6682,'jp','æ”¯æ‰•é‡‘é¡',0),(240548,6682,'pt','Montante devido',0),(240549,6682,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ñ‚Ð°ÑŽÑ‰Ð°ÑÑÑ ÑÑƒÐ¼Ð¼Ð°',0),(240550,6682,'es','Cantidad Debida',0),(240551,6682,'de','FÃ¤lligen Betrag',0),(240552,6682,'en','Amount Due',0),(240553,6683,'is','',0),(240554,6683,'dr','(Ù…Ø¨Ù†Ø§) Ø¯Ø± Ú†Ù‡ ØªØ§Ø±ÙŠØ®ÙŠ',0),(240555,6683,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù¾Ø§ÙŠÙ‡(Ù…Ø¨Ù†Ø§) Ø¯Ø± Ú†Ù‡ ØªØ§Ø±ÙŠØ®ÙŠ',0),(240556,6683,'tr','Hangi tarihte temel raporu',0),(240557,6683,'pl','Raport podstawowy, czyli w dniu',0),(240558,6683,'bg','ÐžÑÐ½Ð¾Ð²Ð½Ð¸Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð½Ð° ÐºÐ¾Ñ Ð´Ð°Ñ‚Ð°',0),(240559,6683,'ur','Ø¬Ø³ ØªØ§Ø±ÛŒØ® Ù¾Ø± Ø¨ÛŒØ³ Ø±Ù¾ÙˆØ±Ù¹',0),(240560,6683,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(240561,6683,'vi','BÃ¡o cÃ¡o dá»±a trÃªn ngÃ y nÃ o',0),(240562,6683,'af','Basisverslag op Watter Datum',0),(240563,6683,'ro','Baza raportul pe care data',0),(240564,6683,'et','Baasi aruande kuupÃ¤ev',0),(240565,6683,'si','Osnovno poroÄilo o kateri datum',0),(240566,6683,'ba','Dasar laporan pada tanggal yang',0),(240567,6683,'nl','Basis verslag over welke datum',0),(240568,6683,'fi','Pohjana oleva raportti jolloin',0),(240569,6683,'no','Base rapport om hvilken dato',0),(240570,6683,'da','Base rapport datoen',0),(240571,6683,'ko','ì–´ëŠ ë‚ ì§œì— ëŒ€ í•œ ê¸°ë³¸ ë³´ê³ ì„œ',0),(240572,6683,'he','×“×•×— ×”×‘×¡×™×¡ ×‘×ª××¨×™×š ×©×‘×•',0),(240573,6683,'el','Î’Î¬ÏƒÎ· Î­ÎºÎ¸ÎµÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î¿Ï€Î¿Î¯Î±',0),(240574,6683,'zh','ç›¸åº”æŠ¥å‘Šçš„æ—¥æœŸ\r\n',0),(240575,6683,'sv','Grundrapporten pÃ¥ vilket datum',0),(240576,6683,'it','Report di base data alla quale',0),(240577,6683,'tl','',0),(240578,6683,'th','&#3600;&#3634;&#3609;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(240579,6683,'hi','à¤®à¥‚à¤² à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¤¿à¤¸ à¤¤à¤¿à¤¥à¤¿ à¤ªà¤°',0),(240580,6683,'ms','Asas laporan pada tarikh yang',0),(240581,6683,'ar','Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø£Ø³Ø§Ø³ÙŠ Ù‡Ùˆ Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø°ÙŠ',0),(240582,6683,'fr','Rapport de base sur la Date Ã  laquelle',0),(240583,6683,'jp','ã©ã®æ—¥ã«åŸºæœ¬ãƒ¬ãƒãƒ¼ãƒˆ',0),(240584,6683,'pt','RelatÃ³rio base, data em que',0),(240585,6683,'ru','Ð‘Ð°Ð·Ð¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð½Ð° Ð´Ð°Ñ‚Ñƒ',0),(240586,6683,'es','Base Informe de en que Fecha',0),(240587,6683,'de','Basisbericht auf welches Datum',0),(240588,6683,'en','Base Report on Which Date',0),(240589,6684,'is','',0),(240590,6684,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù… Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(240591,6684,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù… Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(240592,6684,'tr','Nakit gereksinimlerini raporu',0),(240593,6684,'pl','Raport kasowy wymagania',0),(240594,6684,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¸ Ð¿Ð°Ñ€Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(240595,6684,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©ÛŒ Ø¶Ø±ÙˆØ±ÛŒØ§Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(240596,6684,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð¸ Ð±Ð»Ð°Ð³Ð°Ñ˜Ð½Ðµ',0),(240597,6684,'vi','BÃ¡o cÃ¡o yÃªu cáº§u tiá»n máº·t',0),(240598,6684,'af','Kontant \"Voorskrif/Behoefte/Eis\" Verslag',0),(240599,6684,'ro','Raport de cerinÅ£ele de numerar',0),(240600,6684,'et','NÃµuded Sularahaaruanne',0),(240601,6684,'si','Denarne zahteve poroÄila',0),(240602,6684,'ba','Tunai persyaratan Report',0),(240603,6684,'nl','Cash eisen verslag',0),(240604,6684,'fi','Cash vaatimukset raportti',0),(240605,6684,'no','Cash krav rapport',0),(240606,6684,'da','Cash krav rapport',0),(240607,6684,'ko','í˜„ê¸ˆ ìš”êµ¬ ì‚¬í•­ ë³´ê³ ì„œ',0),(240608,6684,'he','×“×•×— ×“×¨×™×©×•×ª ×ž×–×•×ž× ×™×',0),(240609,6684,'el','ÎœÎµÏ„ÏÎ·Ï„Î¬ Î±Ï€Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ Î­ÎºÎ¸ÎµÏƒÎ·',0),(240610,6684,'zh','çŽ°é‡‘éœ€æ±‚æŠ¥å‘Š\r\n',0),(240611,6684,'sv','Kontanter krav rapport',0),(240612,6684,'it','Relazione di cassa requisiti',0),(240613,6684,'tl','',0),(240614,6684,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;',0),(240615,6684,'hi','à¤¨à¤•à¤¦ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾à¤à¤ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(240616,6684,'ms','Laporan keperluan Wang Tunai',0),(240617,6684,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…ØªØ·Ù„Ø¨Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(240618,6684,'fr','Rapport de besoins de trÃ©sorerie',0),(240619,6684,'jp','ç¾é‡‘è¦ä»¶ãƒ¬ãƒãƒ¼ãƒˆ',0),(240620,6684,'pt','RelatÃ³rio de exigÃªncias de dinheiro',0),(240621,6684,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ð¹',0),(240622,6684,'es','Informe de Requerimientos de Efectivo',0),(240623,6684,'de','Bargeld Bericht',0),(240624,6684,'en','Cash Requirements Report',0),(240625,6685,'is','',0),(240626,6685,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ú¯Ø²Ø§Ø±Ø´ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù… Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(240627,6685,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ú¯Ø²Ø§Ø±Ø´ Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù… Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(240628,6685,'tr','Nakit gereksinimlerini rapor ayrÄ±ntÄ±larÄ±',0),(240629,6685,'pl','SzczegÃ³Å‚y wymagaÅ„ gotÃ³wki',0),(240630,6685,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð´Ð°Ð½Ð½Ð¸ Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ð¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(240631,6685,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©ÛŒ Ø¶Ø±ÙˆØ±ÛŒØ§Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(240632,6685,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ð° Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ° Ð±Ð»Ð°Ð³Ð°Ñ˜Ð½Ðµ',0),(240633,6685,'vi','BÃ¡o cÃ¡o yÃªu cáº§u tiá»n máº·t chi tiáº¿t',0),(240634,6685,'af','Kontant \"Voorskrif/Behoefte/Eis\" Verslag Details',0),(240635,6685,'ro','Numerar cerinÅ£ele raport detalii',0),(240636,6685,'et','Raha nÃµudeid aruande Ã¼ksikasjad',0),(240637,6685,'si','Podrobnosti o zahtevah poroÄilo denarnih',0),(240638,6685,'ba','Tunai persyaratan Report rincian',0),(240639,6685,'nl','Cash eisen verslag Details',0),(240640,6685,'fi','Cash vaatimukset raportin tiedot',0),(240641,6685,'no','Cash krav rapportdetaljer',0),(240642,6685,'da','Cash krav rapportdetaljer',0),(240643,6685,'ko','í˜„ê¸ˆ ìš”êµ¬ ì‚¬í•­ ë³´ê³ ì„œ ì •ë³´',0),(240644,6685,'he','×¤×¨×˜×™ ×“×•×— ×“×¨×™×©×•×ª ×ž×–×•×ž× ×™×',0),(240645,6685,'el','ÎœÎµÏ„ÏÎ·Ï„Î¬ Î±Ï€Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ Î­ÎºÎ¸ÎµÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(240646,6685,'zh','çŽ°é‡‘éœ€æ±‚æŠ¥å‘Šè¯¦ç»†èµ„æ–™\r\n',0),(240647,6685,'sv','Kontanter krav rapportdetaljer',0),(240648,6685,'it','Cassa Requisiti Report dettagli',0),(240649,6685,'tl','',0),(240650,6685,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;',0),(240651,6685,'hi','à¤¨à¤•à¤¦ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾à¤à¤ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤µà¤¿à¤µà¤°à¤£',0),(240652,6685,'ms','Butir-butir laporan keperluan Wang Tunai',0),(240653,6685,'ar','ØªÙØ§ØµÙŠÙ„ ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…ØªØ·Ù„Ø¨Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(240654,6685,'fr','TrÃ©sorerie exigences rapport DÃ©tails',0),(240655,6685,'jp','ç¾é‡‘è¦ä»¶ãƒ¬ãƒãƒ¼ãƒˆã®è©³ç´°',0),(240656,6685,'pt','Detalhes de relatÃ³rio de exigÃªncias de dinheiro',0),(240657,6685,'ru','Ð¡Ð²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾Ð± Ð¾Ñ‚Ñ‡ÐµÑ‚Ðµ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ð¹',0),(240658,6685,'es','Requerimientos de Efectivo Reportar Detalles',0),(240659,6685,'de','Bargeld Anforderungen Berichtdetails',0),(240660,6685,'en','Cash Requirements Report Details',0),(240661,6686,'is','',0),(240662,6686,'dr','Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ØªØ§ÙŠÙŠØ¯ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(240663,6686,'pr','Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ ØªØ§ÙŠÙŠØ¯ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(240664,6686,'tr','Onay iÃ§in tÄ±klatÄ±n',0),(240665,6686,'pl','Kliknij, aby edytowaÄ‡ zatwierdzenia',0),(240666,6686,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(240667,6686,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(240668,6686,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÑ€ÐµÐ´Ð¸Ð»Ð¸ Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐ°',0),(240669,6686,'vi','Nháº¥n VÃ o Äá»ƒ Sá»­a Cháº¥p Thuáº­n',0),(240670,6686,'af','Kliek om Goedkeuring te Redigeer',0),(240671,6686,'ro','FaceÅ£i clic pentru a edita aprobare',0),(240672,6686,'et','Muutke kinnitamine',0),(240673,6686,'si','Kliknite, Äe Å¾elite urediti odobritve',0),(240674,6686,'ba','Klik untuk Edit persetujuan',0),(240675,6686,'nl','Klik om te bewerken van goedkeuring',0),(240676,6686,'fi','Valitsemalla tÃ¤mÃ¤n voit muokata hyvÃ¤ksyntÃ¤',0),(240677,6686,'no','Klikk for Ã¥ redigere godkjenning',0),(240678,6686,'da','Klik for at redigere godkendelse',0),(240679,6686,'ko','ìŠ¹ì¸ì„ íŽ¸ì§‘ í•˜ë ¤ë©´ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(240680,6686,'he','×œ×—×¥ ×›×“×™ ×œ×¢×¨×•×š ××™×©×•×¨',0),(240681,6686,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ·',0),(240682,6686,'zh','ç‚¹å‡»ç¼–è¾‘å®¡æ‰¹\r\n',0),(240683,6686,'sv','Klicka fÃ¶r att Ã¤ndra godkÃ¤nnande',0),(240684,6686,'it','Fare clic per modificare l\'approvazione',0),(240685,6686,'tl','',0),(240686,6686,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(240687,6686,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(240688,6686,'ms','Klik untuk Edit kelulusan',0),(240689,6686,'ar','Ø§Ù†Ù‚Ø± Ù„ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø©',0),(240690,6686,'fr','Cliquez sur pour modifier l\'approbation',0),(240691,6686,'jp','æ‰¿èªã‚’ç·¨é›†ã™ã‚‹] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(240692,6686,'pt','Clique para editar a aprovaÃ§Ã£o',0),(240693,6686,'ru','Ð©ÐµÐ»ÐºÐ½Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(240694,6686,'es','Click para la Aprobacion de Editar',0),(240695,6686,'de','Hier klicken, um die Genehmigung zu bearbeiten',0),(240696,6686,'en','Click to Edit Approval',0),(240697,6687,'is','',0),(240698,6687,'dr','Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨ ',0),(240699,6687,'pr','Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨ ',0),(240700,6687,'tr','Hesap iÃ§in',0),(240701,6687,'pl','Dla konta',0),(240702,6687,'bg','Ð—Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(240703,6687,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù„ÛŒÛ’',0),(240704,6687,'sr','Ð—Ð° Ð½Ð°Ð»Ð¾Ð³',0),(240705,6687,'vi','Cho TK',0),(240706,6687,'af','Vir Rekening',0),(240707,6687,'ro','Pentru cont',0),(240708,6687,'et','Konto',0),(240709,6687,'si','Za raÄun',0),(240710,6687,'ba','Untuk Account',0),(240711,6687,'nl','Voor Account',0),(240712,6687,'fi','Tilin',0),(240713,6687,'no','Konto',0),(240714,6687,'da','For konto',0),(240715,6687,'ko','ê³„ì •ì— ëŒ€ í•œ',0),(240716,6687,'he','×¢×‘×•×¨ ×—×©×‘×•×Ÿ',0),(240717,6687,'el','Î“Î¹Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(240718,6687,'zh','å¯¹äºŽå¸æˆ·\r\n',0),(240719,6687,'sv','FÃ¶r konto',0),(240720,6687,'it','Per conto',0),(240721,6687,'tl','',0),(240722,6687,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(240723,6687,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(240724,6687,'ms','Untuk akaun',0),(240725,6687,'ar','Ù„Ø­Ø³Ø§Ø¨',0),(240726,6687,'fr','Pour le compte',0),(240727,6687,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®',0),(240728,6687,'pt','Por conta',0),(240729,6687,'ru','Ð”Ð»Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(240730,6687,'es','Para Cuenta',0),(240731,6687,'de','FÃ¼r Konto',0),(240732,6687,'en','For Account',0),(240733,6688,'is','',0),(240734,6688,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±ÙŠØ²ÙŠ Ø´Ø¯Ù‡',0),(240735,6688,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±ÙŠØ²ÙŠ Ø´Ø¯Ù‡',0),(240736,6688,'tr','Planlanan Ã¶deme tarihi',0),(240737,6688,'pl','Data planowanej pÅ‚atnoÅ›ci',0),(240738,6688,'bg','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð°Ñ‚Ð°',0),(240739,6688,'ur','Ù…Ø¬ÙˆØ²Û Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(240740,6688,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ð½Ð¸Ñ€Ð°Ð½Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(240741,6688,'vi','NgÃ y thanh toÃ¡n dÆ° kiáº¿n',0),(240742,6688,'af','Beplande Betalingsdatum',0),(240743,6688,'ro','Data platii planificate',0),(240744,6688,'et','Planeeritud maksekuupÃ¤ev',0),(240745,6688,'si','Datum naÄrtovanega plaÄila',0),(240746,6688,'ba','Tanggal pembayaran direncanakan',0),(240747,6688,'nl','Geplande betalingsdatum',0),(240748,6688,'fi','Suunniteltu maksupÃ¤ivÃ¤',0),(240749,6688,'no','Planlagt betalingsdato',0),(240750,6688,'da','Planlagt betalingsdato',0),(240751,6688,'ko','ê³„íš ëœ ì§€ë¶ˆ ë‚ ì§œ',0),(240752,6688,'he','×ª××¨×™×š ×ª×©×œ×•× ×ž×ª×•×›× ×Ÿ',0),(240753,6688,'el','Î—Î¼/Î½Î¯Î± ÎµÎ¾ÏŒÏ†Î»Î·ÏƒÎ·Ï‚ Ï€ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÎ¼Î­Î½Î·',0),(240754,6688,'zh','è®¡åˆ’ä»˜æ¬¾æ—¥æœŸ\r\n',0),(240755,6688,'sv','Planerade betalningsdatum',0),(240756,6688,'it','Data di pagamento prevista',0),(240757,6688,'tl','',0),(240758,6688,'th','&#3623;&#3634;&#3591;&#3649;&#3612;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(240759,6688,'hi','à¤¨à¤¿à¤¯à¥‹à¤œà¤¿à¤¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(240760,6688,'ms','Tarikh pembayaran yang dirancang',0),(240761,6688,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø®Ø·Ø·Ø©',0),(240762,6688,'fr','Date de paiement prÃ©vue',0),(240763,6688,'jp','æ”¯æ‰•ã„äºˆå®šæ—¥',0),(240764,6688,'pt','Data prevista de pagamento',0),(240765,6688,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð»Ð°Ð½Ð¸Ñ€ÑƒÐµÐ¼Ð¾Ð¹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(240766,6688,'es','Fecha de Pago Planeado',0),(240767,6688,'de','Geplante Zahlungsdatum',0),(240768,6688,'en','Planned Payment Date',0),(240769,6689,'is','',0),(240770,6689,'dr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø³Ø±Ø§Ø³Ø± Ù‡ÙØªÙ‡ ',0),(240771,6689,'pr','Ø´Ø±ÙƒØª Ù¾Ø³Øª Ø¢Ù…Ø±ÙŠÙƒØ§ÙŠÙŠ Ø³Ø±Ø§Ø³Ø± Ù‡ÙØªÙ‡ ',0),(240772,6689,'tr','Hafta yukarÄ±',0),(240773,6689,'pl','SiÄ™ przez tydzieÅ„',0),(240774,6689,'bg','ÐÐ°Ð³Ð¾Ñ€Ðµ Ð¿Ñ€ÐµÐ· ÑÐµÐ´Ð¼Ð¸Ñ†Ð°Ñ‚Ð°',0),(240775,6689,'ur','Ø¨Ø§Ù„Ø§ Thru ÛÙØªÛ',0),(240776,6689,'sr','Ð“Ð¾Ñ€Ðµ Ð´Ð¾ Ð½ÐµÐ´ÐµÑ™Ðµ',0),(240777,6689,'vi','LÃªn qua tuáº§n',0),(240778,6689,'af','UP deur middel van die Week',0),(240779,6689,'ro','PÃ¢nÄƒ prin intermediul sÄƒptÄƒmÃ¢nÄƒ',0),(240780,6689,'et','Ãœles lÃ¤bi nÃ¤dala',0),(240781,6689,'si','Gor skozi teden',0),(240782,6689,'ba','Naik melalui minggu',0),(240783,6689,'nl','Omhoog Thru b-l Week',0),(240784,6689,'fi','Jopa lÃ¤pi viikon',0),(240785,6689,'no','Opp gjennom uken',0),(240786,6689,'da','Op igennem uge',0),(240787,6689,'ko','1 ì£¼ì¼ì„ í†µí•´ ìµœëŒ€',0),(240788,6689,'he','×œ×ž×¢×œ×” Thru ×‘×©×‘×•×¢',0),(240789,6689,'el','Î•Ï€Î¬Î½Ï‰ Î¼Î­ÏƒÏ‰ ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(240790,6689,'zh','é€è¿‡å‘¨\r\n',0),(240791,6689,'sv','Upp igenom veckan',0),(240792,6689,'it','Fino a settimana',0),(240793,6689,'tl','',0),(240794,6689,'th','Up Thru Week',0),(240795,6689,'hi','à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤Šà¤ªà¤°',0),(240796,6689,'ms','Up Thru minggu',0),(240797,6689,'ar','ÙŠØµÙ„ Ø®Ù„Ø§Ù„ Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹',0),(240798,6689,'fr','Vers le haut par le biais de la semaine',0),(240799,6689,'jp','é€±ã‚’é€šã˜ã¦ã‚¢ãƒƒãƒ—',0),(240800,6689,'pt','Acima atravÃ©s da semana',0),(240801,6689,'ru','Ð’Ð²ÐµÑ€Ñ… Ñ‡ÐµÑ€ÐµÐ· Ð½ÐµÐ´ÐµÐ»ÑŽ',0),(240802,6689,'es','Por la Semana',0),(240803,6689,'de','Oben durch die Woche',0),(240804,6689,'en','Up Thru Week',0),(240805,6690,'is','',0),(240806,6690,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(240807,6690,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(240808,6690,'tr','Son kullanma tarihi',0),(240809,6690,'pl','Przy odpowiednim terminie',0),(240810,6690,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹ÐºÐ¸ Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(240811,6690,'ur','Ù…Ù‚Ø±Ø±Û Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(240812,6690,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚ÐµÑ›Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(240813,6690,'vi','DÃ¹ng ngÃ y Ä‘áº¿n háº¡n',0),(240814,6690,'af','Gebruik Verskuldigde Datum',0),(240815,6690,'ro','Ajutorul cuvenit data',0),(240816,6690,'et','Kasutades Due Date',0),(240817,6690,'si','Z obveznim datumom',0),(240818,6690,'ba','Menggunakan Due Date',0),(240819,6690,'nl','Met behulp van Due datum',0),(240820,6690,'fi','KÃ¤yttÃ¤mÃ¤llÃ¤ asianmukaisesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(240821,6690,'no','Bruke grunn dato',0),(240822,6690,'da','Ved hjÃ¦lp af behÃ¸rig dato',0),(240823,6690,'ko','ì •ë‹¹ ë²•ì„ ì‚¬ìš© í•˜ ì—¬ ë‚ ì§œ',0),(240824,6690,'he','×”×©×™×ž×•×© ×”×”×•×’×Ÿ ×ª××¨×™×š',0),(240825,6690,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(240826,6690,'zh','ä½¿ç”¨æˆªæ­¢æ—¥æœŸ\r\n',0),(240827,6690,'sv','AnvÃ¤nda Due Date',0),(240828,6690,'it','Utilizzando Due Date',0),(240829,6690,'tl','',0),(240830,6690,'th','&#3650;&#3604;&#3618;&#3651;&#3594;&#3657;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(240831,6690,'hi','à¤¨à¤¿à¤¯à¤¤ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤•à¥‡ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(240832,6690,'ms','Menggunakan habis tempoh tarikh',0),(240833,6690,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø£ØµÙˆÙ„ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(240834,6690,'fr','Ã€ l\'aide de Due Date',0),(240835,6690,'jp','æœŸé™ã‚’ä½¿ç”¨ã—ã¦æ—¥ä»˜',0),(240836,6690,'pt','Usando Due Date',0),(240837,6690,'ru','Ð¡ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ Ð½Ð°Ð´Ð»ÐµÐ¶Ð°Ñ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹',0),(240838,6690,'es','Usando Fecha Debida',0),(240839,6690,'de','Mit Due Date',0),(240840,6690,'en','Using Due Date',0),(240841,6691,'is','',0),(240842,6691,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª',0),(240843,6691,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª',0),(240844,6691,'tr','Ã–deme tarihi kullanma',0),(240845,6691,'pl','Przy uÅ¼yciu data pÅ‚atnoÅ›ci',0),(240846,6691,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(240847,6691,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(240848,6691,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(240849,6691,'vi','DÃ¹ng ngÃ y thanh toÃ¡n',0),(240850,6691,'af','Gebruik Betaal Datum',0),(240851,6691,'ro','Folosind data platii',0),(240852,6691,'et','Kasutades maksekuupÃ¤ev',0),(240853,6691,'si','Z uporabo datum plaÄila',0),(240854,6691,'ba','Menggunakan tanggal pembayaran',0),(240855,6691,'nl','Met behulp van betalingsdatum',0),(240856,6691,'fi','KÃ¤yttÃ¤mÃ¤llÃ¤ maksupÃ¤ivÃ¤',0),(240857,6691,'no','Bruke betalingsdatoen',0),(240858,6691,'da','Ved hjÃ¦lp af betalingsdato',0),(240859,6691,'ko','ì§€ë¶ˆ ë‚ ì§œë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(240860,6691,'he','×‘××ž×¦×¢×•×ª ×ª××¨×™×š ×”×ª×©×œ×•×',0),(240861,6691,'el','Î§ÏÎ®ÏƒÎ· Î—Î¼/Î½Î¯Î± ÎµÎ¾ÏŒÏ†Î»Î·ÏƒÎ·Ï‚',0),(240862,6691,'zh','ä½¿ç”¨ä»˜æ¬¾æ—¥æœŸ\r\n',0),(240863,6691,'sv','Med hjÃ¤lp av betalningsdatum',0),(240864,6691,'it','Utilizzando la data di pagamento',0),(240865,6691,'tl','',0),(240866,6691,'th','&#3650;&#3604;&#3618;&#3651;&#3594;&#3657;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(240867,6691,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°',0),(240868,6691,'ms','Menggunakan tarikh pembayaran',0),(240869,6691,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹',0),(240870,6691,'fr','Ã€ l\'aide de la Date de paiement',0),(240871,6691,'jp','æ”¯æ‰•æ—¥ã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(240872,6691,'pt','Usando a data de pagamento',0),(240873,6691,'ru','Ð¡ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ Ð”Ð°Ñ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(240874,6691,'es','Usando Fecha de Pago',0),(240875,6691,'de','Zahlung Datum',0),(240876,6691,'en','Using Payment Date',0),(240877,6692,'is','',0),(240878,6692,'dr','Ø´Ø±ÙˆØ¹ Ù‡ÙØªÙ‡ ',0),(240879,6692,'pr','Ø´Ø±ÙˆØ¹ Ù‡ÙØªÙ‡ ',0),(240880,6692,'tr','Hafta baÅŸlangÄ±Ã§',0),(240881,6692,'pl','PoczÄ…tek tygodnia',0),(240882,6692,'bg','Ð¡ÐµÐ´Ð¼Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð°',0),(240883,6692,'ur','ÛÙØªÛ Ø´Ø±ÙˆØ¹',0),(240884,6692,'sr','ÐžÐ·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð½ÐµÐ´ÐµÑ™Ðµ',0),(240885,6692,'vi','Báº¯t Ä‘áº§u tuáº§n',0),(240886,6692,'af','Week Begin',0),(240887,6692,'ro','Inceput de saptamana',0),(240888,6692,'et','NÃ¤dal algab',0),(240889,6692,'si','ZaÄetek tedna',0),(240890,6692,'ba','Mulai minggu',0),(240891,6692,'nl','Begin van de week',0),(240892,6692,'fi','Viikko alkaa',0),(240893,6692,'no','Uken begynner',0),(240894,6692,'da','Uge begynder',0),(240895,6692,'ko','ì£¼ ì‹œìž‘',0),(240896,6692,'he','×©×‘×•×¢ ×‘×’×™×Ÿ',0),(240897,6692,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Ï„Î·Î½ ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(240898,6692,'zh','å‘¨å¼€å§‹\r\n',0),(240899,6692,'sv','Veckan bÃ¶rjar',0),(240900,6692,'it','Inizio di settimana',0),(240901,6692,'tl','',0),(240902,6692,'th','&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(240903,6692,'hi','à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤¶à¥à¤°à¥‚',0),(240904,6692,'ms','Mulakan minggu',0),(240905,6692,'ar','ØªØ¨Ø¯Ø£ Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹',0),(240906,6692,'fr','DÃ©but de la semaine',0),(240907,6692,'jp','é€±é–‹å§‹',0),(240908,6692,'pt','InÃ­cio de semana',0),(240909,6692,'ru','ÐÐµÐ´ÐµÐ»Ñ ÐÐ°Ñ‡Ð¸Ð½Ð°ÐµÑ‚ÑÑ',0),(240910,6692,'es','Principio de Semana',0),(240911,6692,'de','Woche beginnen',0),(240912,6692,'en','Week Begin',0),(240913,6693,'is','',0),(240914,6693,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ù‡ÙØªÙ‡ ',0),(240915,6693,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ù‡ÙØªÙ‡ ',0),(240916,6693,'tr','Hafta baÅŸlangÄ±Ã§ tarihleri',0),(240917,6693,'pl','PoczÄ…tek tygodnia daty',0),(240918,6693,'bg','Ð¡ÐµÐ´Ð¼Ð¸Ñ†Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð´Ð°Ñ‚Ð¸',0),(240919,6693,'ur','ÛÙØªÛ’ Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(240920,6693,'sr','Ð”Ð°Ñ‚ÑƒÐ¼Ð¸ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð½ÐµÐ´ÐµÑ™Ðµ',0),(240921,6693,'vi','NgÃ y Báº¯t Ä‘áº§u tuáº§n',0),(240922,6693,'af','Week Begin Datums',0),(240923,6693,'ro','Datele de inceput de saptamana',0),(240924,6693,'et','NÃ¤dala alguskuupÃ¤evad',0),(240925,6693,'si','Teden zaÄetek datumi',0),(240926,6693,'ba','Minggu mulai tanggal',0),(240927,6693,'nl','Week beginnen dateert',0),(240928,6693,'fi','Viikko alkaa pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(240929,6693,'no','Uken begynner datoer',0),(240930,6693,'da','Uge Begin stammer',0),(240931,6693,'ko','ì£¼ ì‹œìž‘ ë‚ ì§œ',0),(240932,6693,'he','×©×‘×•×¢ ×‘×’×™×Ÿ ×ª××¨×™×›×™×',0),(240933,6693,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Ï„Î·Î½ ÎµÎ²Î´Î¿Î¼Î¬Î´Î± Ï‡ÏÎ¿Î½Î¿Î»Î¿Î³ÎµÎ¯Ï„Î±Î¹',0),(240934,6693,'zh','æœ¬å‘¨å¼€å§‹æ—¥æœŸ\r\n',0),(240935,6693,'sv','Veckan bÃ¶rjar datum',0),(240936,6693,'it','Date di inizio settimana',0),(240937,6693,'tl','',0),(240938,6693,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(240939,6693,'hi','à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤¶à¥à¤°à¥‚ à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤',0),(240940,6693,'ms','Mulakan minggu tarikh',0),(240941,6693,'ar','ØªÙˆØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹',0),(240942,6693,'fr','Date de dÃ©but de la semaine',0),(240943,6693,'jp','é€±ã®é–‹å§‹æ—¥ã—ã¾ã™ã€‚',0),(240944,6693,'pt','Data de inÃ­cio de semana',0),(240945,6693,'ru','Ð”Ð°Ñ‚Ñ‹ ÐÐ°Ñ‡Ð°Ð»Ð° ÐÐµÐ´ÐµÐ»Ð¸',0),(240946,6693,'es','Fechas de Comienza de Semana',0),(240947,6693,'de','Termine Woche beginnen',0),(240948,6693,'en','Week Begin Dates',0),(240949,6694,'is','',0),(240950,6694,'dr','- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(240951,6694,'pr','Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡- Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(240952,6694,'tr','SatÄ±cÄ± Ajan listesi',0),(240953,6694,'pl','Lista dostawcÃ³w agenta',0),(240954,6694,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð°Ð³ÐµÐ½Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº',0),(240955,6694,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§ÛŒØ¬Ù†Ù¹ ÙÛØ±Ø³Øª',0),(240956,6694,'sr','ÐÐ³ÐµÐ½Ñ‚ Ð»Ð¸ÑÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(240957,6694,'vi','Danh sÃ¡ch NgÆ°á»i bÃ¡n-Ä‘áº¡i lÃ½',0),(240958,6694,'af','Handelaar Agent lys',0),(240959,6694,'ro','ListÄƒ de Agent furnizor',0),(240960,6694,'et','Vendor Agent List',0),(240961,6694,'si','Seznam dobaviteljev Agent',0),(240962,6694,'ba','Daftar Agen Penjual',0),(240963,6694,'nl','Agent leveranciersoverzicht',0),(240964,6694,'fi','Toimittajan agentin luettelo',0),(240965,6694,'no','Agent leverandÃ¸roversikten',0),(240966,6694,'da','Agent kreditorliste',0),(240967,6694,'ko','ê³µê¸‰ ì—…ì²´ ì—ì´ì „íŠ¸ ëª©ë¡',0),(240968,6694,'he','×¨×©×™×ž×ª ×©×œ ×”×¡×•×›×Ÿ',0),(240969,6694,'el','Î›Î¯ÏƒÏ„Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½ Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î±',0),(240970,6694,'zh','é”€å”®å•†ä»£ç†åå•\r\n',0),(240971,6694,'sv','Agent leverantÃ¶rslista',0),(240972,6694,'it','Elenco agente fornitore',0),(240973,6694,'tl','',0),(240974,6694,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3586;&#3634;&#3618;',0),(240975,6694,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤à¤œà¥‡à¤‚à¤Ÿ à¤¸à¥‚à¤šà¥€',0),(240976,6694,'ms','Senarai ejen penjual.',0),(240977,6694,'ar','Ù‚Ø§Ø¦Ù…Ø© ÙˆÙƒÙŠÙ„ Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(240978,6694,'fr','Liste des agents du vendeur',0),(240979,6694,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆ ãƒ» ãƒ™ãƒ³ãƒ€ãƒ¼ ãƒ» ãƒªã‚¹ãƒˆ',0),(240980,6694,'pt','Lista de agente vendedor',0),(240981,6694,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² ÐÐ³ÐµÐ½Ñ‚Ð¾Ð²',0),(240982,6694,'es','Lista de Proveedores-Agentes',0),(240983,6694,'de','Agent Lieferantenliste',0),(240984,6694,'en','Vendor Agent List',0),(240985,6695,'is','',0),(240986,6695,'dr','Ù…Ø¹Ø±Ù',0),(240987,6695,'pr','Ù…Ø¹Ø±Ù',0),(240988,6695,'tr','ÃœrÃ¼n kodu',0),(240989,6695,'pl','Ref',0),(240990,6695,'bg','Ref',0),(240991,6695,'ur','Ù…Ø§Ø®ÙˆØ°',0),(240992,6695,'sr','Ð Ð•Ð¤',0),(240993,6695,'vi','Tham kháº£o',0),(240994,6695,'af','Verw',0),(240995,6695,'ro','Ref',0),(240996,6695,'et','REF',0),(240997,6695,'si','Ref',0),(240998,6695,'ba','REF',0),(240999,6695,'nl','Ref',0),(241000,6695,'fi','REF',0),(241001,6695,'no','REF',0),(241002,6695,'da','Ref',0),(241003,6695,'ko','Ref',0),(241004,6695,'he','Ref',0),(241005,6695,'el','REF',0),(241006,6695,'zh','å‚è€ƒ\r\n',0),(241007,6695,'sv','Ref',0),(241008,6695,'it','Rif',0),(241009,6695,'tl','',0),(241010,6695,'th','&#3629;&#3657;&#3634;&#3591;&#3629;&#3636;&#3591;',0),(241011,6695,'hi','à¤°à¥‡à¤«à¤°à¥€',0),(241012,6695,'ms','REF',0),(241013,6695,'ar','Ref',0),(241014,6695,'fr','RÃ©f',0),(241015,6695,'jp','Ref',0),(241016,6695,'pt','Ref',0),(241017,6695,'ru','Ref',0),(241018,6695,'es','Ref.',0),(241019,6695,'de','Ref',0),(241020,6695,'en','Ref',0),(241021,6696,'is','',0),(241022,6696,'dr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(241023,6696,'pr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(241024,6696,'tr','Girilen hiÃ§bir GL satÄ±ÅŸ hesabÄ±',0),(241025,6696,'pl','SprzedaÅ¼ konta nie GL wszedÅ‚',0),(241026,6696,'bg','GL Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸',0),(241027,6696,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ø¬ÛŒØ¬Û’ Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(241028,6696,'sr','ÐÐµÐ¼Ð° Ð“Ð› Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð° ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ ÑƒÐ½ÐµÑ‚',0),(241029,6696,'vi','ChÆ°a Nháº­p TK Sá»• CÃ¡i Tá»•ng Há»£p Doanh Thu BÃ¡n HÃ ng',0),(241030,6696,'af','Geen AG Verkoperekening is Ingevoer',0),(241031,6696,'ro','Nici un cont de vÃ¢nzare GL intrat',0),(241032,6696,'et','No GL mÃ¼Ã¼gikontole kanda',0),(241033,6696,'si','GL prodaje nikakor ne vnese',0),(241034,6696,'ba','No akun GL penjualan yang masuk',0),(241035,6696,'nl','Geen GL omzetrekening ingevoerd',0),(241036,6696,'fi','GL myynti huomioon tuli',0),(241037,6696,'no','Ingen GL salgskontoen angitt',0),(241038,6696,'da','Ingen GL salgskontoen indtastet',0),(241039,6696,'ko','ìž…ë ¥ í•œ GL íŒë§¤ ê³„ì • ì—†ìŒ',0),(241040,6696,'he','××™×Ÿ ×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª GL × ×›× ×¡×•',0),(241041,6696,'el','Î”ÎµÎ½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€Î¿Ï… Ï„Î­Î¸Î·ÎºÎµ',0),(241042,6696,'zh','æ²¡æœ‰è¾“å…¥çš„æ€»å¸é”€å”®å¸æˆ·\r\n',0),(241043,6696,'sv','Ingen GL fÃ¶rsÃ¤ljningskontot som anges',0),(241044,6696,'it','Nessun conto vendita GL entrata',0),(241045,6696,'tl','',0),(241046,6696,'th','&#3652;&#3617;&#3656;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3611;&#3657;&#3629;&#3609;',0),(241047,6696,'hi','à¤•à¥‹à¤ˆ GL à¤µà¤¿à¤•à¥à¤°à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾',0),(241048,6696,'ms','Tiada akaun jualan GL yang memasuki',0),(241049,6696,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª GL Ø¯Ø®Ù„Øª',0),(241050,6696,'fr','Aucun compte de vente GL entrÃ©',0),(241051,6696,'jp','å…¥åŠ›ã—ãŸãªã„ GL è²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(241052,6696,'pt','Nenhuma conta de vendas de GL entrada',0),(241053,6696,'ru','GL Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð½Ðµ Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»',0),(241054,6696,'es','No se entrÃ³ una cuenta LM de ventas',0),(241055,6696,'de','Kein Verkauf Hauptbuchkonto eingegeben',0),(241056,6696,'en','No GL Sales Account Entered',0),(241057,6697,'is','',0),(241058,6697,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø±Øª',0),(241059,6697,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø±Øª',0),(241060,6697,'tr','Kart tÃ¼rÃ¼',0),(241061,6697,'pl','Typ karty',0),(241062,6697,'bg','Ð¢Ð¸Ð¿ ÐºÐ°Ñ€Ñ‚Ð°',0),(241063,6697,'ur','Ú©Ø§Ø±Úˆ Ú©ÛŒ Ù‚Ø³Ù…',0),(241064,6697,'sr','Ð¢Ð¸Ð¿ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(241065,6697,'vi','Loáº¡i tháº»',0),(241066,6697,'af','Kaart Tipe',0),(241067,6697,'ro','Tipul de card',0),(241068,6697,'et','Kaardi tÃ¼Ã¼p',0),(241069,6697,'si','Vrsta kartice',0),(241070,6697,'ba','Jenis kartu',0),(241071,6697,'nl','Kaarttype',0),(241072,6697,'fi','Korttityyppi',0),(241073,6697,'no','Korttype',0),(241074,6697,'da','Korttypen',0),(241075,6697,'ko','ì¹´ë“œ ì¢…ë¥˜',0),(241076,6697,'he','×¡×•×’ ×›×¨×˜×™×¡',0),(241077,6697,'el','Î¤ÏÏ€Î¿Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(241078,6697,'zh','å¡ç±»åž‹\r\n',0),(241079,6697,'sv','Korttyp',0),(241080,6697,'it','Tipo di carta',0),(241081,6697,'tl','',0),(241082,6697,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3633;&#3605;&#3619;',0),(241083,6697,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(241084,6697,'ms','Jenis kad',0),(241085,6697,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(241086,6697,'fr','Type de carte',0),(241087,6697,'jp','ã‚«ãƒ¼ãƒ‰ã®ç¨®é¡ž',0),(241088,6697,'pt','Tipo de cartÃ£o',0),(241089,6697,'ru','Ð¢Ð¸Ð¿ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(241090,6697,'es','Tarjeta Tipo',0),(241091,6697,'de','Kartentyp',0),(241092,6697,'en','Card Type',0),(241093,6698,'is','',0),(241094,6698,'dr','Ø³ØªÙˆÙ† Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´',0),(241095,6698,'pr','Ø³ØªÙˆÙ† Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´',0),(241096,6698,'tr','SÃ¼tunlarÄ± gÃ¶rÃ¼ntÃ¼lemek iÃ§in',0),(241097,6698,'pl','Kolumny do wyÅ›wietlenia',0),(241098,6698,'bg','ÐšÐ¾Ð»Ð¾Ð½Ð¸ Ð·Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ',0),(241099,6698,'ur','Ø¯Ú©Ú¾Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ø§Ù„Ù…',0),(241100,6698,'sr','ÐšÐ¾Ð»Ð¾Ð½Ðµ Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·',0),(241101,6698,'vi','Máº§u hiá»ƒn thá»‹',0),(241102,6698,'af','Kolomme om te Wys ',0),(241103,6698,'ro','Coloane pentru a afiÅŸa',0),(241104,6698,'et','Veergude kuvamine',0),(241105,6698,'si','Stolpci za prikaz',0),(241106,6698,'ba','Kolom untuk tampilan',0),(241107,6698,'nl','Kolommen weer te geven',0),(241108,6698,'fi','NÃ¤ytettÃ¤vÃ¤t sarakkeet',0),(241109,6698,'no','Kolonner som skal vises',0),(241110,6698,'da','Kolonner til visning',0),(241111,6698,'ko','í‘œì‹œ ì—´',0),(241112,6698,'he','×¢×ž×•×“×•×ª ×œ×ª×¦×•×’×”',0),(241113,6698,'el','Î£Ï„Î®Î»ÎµÏ‚ ÏƒÏ„Î·Î½ Î¿Î¸ÏŒÎ½Î·',0),(241114,6698,'zh','è¦æ˜¾ç¤ºçš„åˆ—\r\n',0),(241115,6698,'sv','Kolumner som ska visas',0),(241116,6698,'it','Colonne da visualizzare',0),(241117,6698,'tl','',0),(241118,6698,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3611;&#3655;&#3609;&#3649;&#3606;&#3623;',0),(241119,6698,'hi','à¤¸à¥à¤¤à¤‚à¤­ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(241120,6698,'ms','Ruangan untuk paparan',0),(241121,6698,'ar','Ø§Ù„Ø£Ø¹Ù…Ø¯Ø© Ø§Ù„Ù…Ø±Ø§Ø¯ Ø¹Ø±Ø¶Ù‡Ø§',0),(241122,6698,'fr','Colonnes d\'affichage',0),(241123,6698,'jp','è¡¨ç¤ºã™ã‚‹åˆ—',0),(241124,6698,'pt','Colunas para exibir',0),(241125,6698,'ru','Ð¡Ñ‚Ð¾Ð»Ð±Ñ†Ñ‹ Ð´Ð»Ñ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(241126,6698,'es','Columnas para Desplegar',0),(241127,6698,'de','Spalten zur Anzeige',0),(241128,6698,'en','Columns to Display',0),(241129,6699,'is','',0),(241130,6699,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(241131,6699,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(241132,6699,'tr','Kredi kartÄ± iÅŸlem raporu',0),(241133,6699,'pl','Raport transakcji karty kredytowej',0),(241134,6699,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° ÑÐ´ÐµÐ»ÐºÐ° Ð´Ð¾ÐºÐ»Ð°Ð´',0),(241135,6699,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(241136,6699,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(241137,6699,'vi','BÃ¡o CÃ¡o Giao Dá»‹ch Tháº» TÃ­n Dá»¥ng',0),(241138,6699,'af','Kredietkaart Transaksie Verslag',0),(241139,6699,'ro','Card de credit Transaction raport',0),(241140,6699,'et','Krediitkaardi tehingute aruanne',0),(241141,6699,'si','Kreditne kartice posla poroÄilo',0),(241142,6699,'ba','Laporan transaksi kartu kredit',0),(241143,6699,'nl','Credit Card transactie verslag',0),(241144,6699,'fi','Luottokortin tapahtumaraportin',0),(241145,6699,'no','Kredittkort transaksjon rapporten',0),(241146,6699,'da','Kreditkort transaktioner rapport',0),(241147,6699,'ko','ì‹ ìš© ì¹´ë“œ íŠ¸ëžœìž­ì…˜ ë³´ê³ ì„œ',0),(241148,6699,'he','×“×•×— ×ª× ×•×¢×” ×›×¨×˜×™×¡ ××©×¨××™',0),(241149,6699,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Î­ÎºÎ¸ÎµÏƒÎ·',0),(241150,6699,'zh','ä¿¡ç”¨å¡äº¤æ˜“æŠ¥å‘Š\r\n',0),(241151,6699,'sv','Kreditkort transaktionsrapport',0),(241152,6699,'it','Relazione di transazione di carta di credito',0),(241153,6699,'tl','',0),(241154,6699,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(241155,6699,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(241156,6699,'ms','Laporan transaksi kad kredit',0),(241157,6699,'ar','ØªÙ‚Ø±ÙŠØ± Ø¹Ù† Ù…Ø¹Ø§Ù…Ù„Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(241158,6699,'fr','Rapport de Transaction de carte de crÃ©dit',0),(241159,6699,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ãƒ¬ãƒãƒ¼ãƒˆ',0),(241160,6699,'pt','RelatÃ³rio de transaÃ§Ãµes de cartÃ£o de crÃ©dito',0),(241161,6699,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ ÐžÐ± ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸ÑÑ… Ð¡ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¼Ð¸ ÐšÐ°Ñ€Ñ‚Ð°Ð¼Ð¸',0),(241162,6699,'es','Tarjeta de CrÃ©dito Informe de Transacciones',0),(241163,6699,'de','Credit Card Transaction Report',0),(241164,6699,'en','Credit Card Transaction Report',0),(241165,6700,'is','',0),(241166,6700,'dr','ÙÙŠÙ„ØªØ±Ù‡Ø§ÙŠ Ú¯Ø²Ø§Ø±Ø´ ',0),(241167,6700,'pr','ÙÙŠÙ„ØªØ±Ù‡Ø§ÙŠ Ú¯Ø²Ø§Ø±Ø´ ',0),(241168,6700,'tr','Rapor filtreleri',0),(241169,6700,'pl','Filtry raportu',0),(241170,6700,'bg','Ð¤Ð¸Ð»Ñ‚Ñ€Ð¸ Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(241171,6700,'ur','ÙÙ„Ù¹Ø± Ø±Ù¾ÙˆØ±Ù¹',0),(241172,6700,'sr','Ð¤Ð¸Ð»Ñ‚ÐµÑ€Ð¸ Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(241173,6700,'vi','Lá»c BÃ¡o cÃ¡o ',0),(241174,6700,'af','Verslag Filters',0),(241175,6700,'ro','Filtre raport',0),(241176,6700,'et','Aruande filtrid',0),(241177,6700,'si','Filtri poroÄila',0),(241178,6700,'ba','Filter laporan',0),(241179,6700,'nl','Rapportfilters',0),(241180,6700,'fi','Raporttisuodattimet',0),(241181,6700,'no','Rapportfiltre',0),(241182,6700,'da','Rapportfiltre',0),(241183,6700,'ko','ë³´ê³ ì„œ í•„í„°',0),(241184,6700,'he','×ž×¡× × ×™ ×“×•×—×•×ª',0),(241185,6700,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï†Î¯Î»Ï„ÏÎ±',0),(241186,6700,'zh','æŠ¥å‘Šè¿‡æ»¤å™¨\r\n',0),(241187,6700,'sv','Rapportfilter',0),(241188,6700,'it','Filtri rapporto',0),(241189,6700,'tl','',0),(241190,6700,'th','&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(241191,6700,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤°',0),(241192,6700,'ms','Penapis Laporan',0),(241193,6700,'ar','Ù…Ø±Ø´Ù‘Ø­Ø§Øª Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(241194,6700,'fr','Filtres de rapport',0),(241195,6700,'jp','ãƒ¬ãƒãƒ¼ãƒˆã®ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼',0),(241196,6700,'pt','Filtros de relatÃ³rio',0),(241197,6700,'ru','Ð¤Ð¸Ð»ÑŒÑ‚Ñ€Ñ‹ ÐžÑ‚Ñ‡ÐµÑ‚Ð°',0),(241198,6700,'es','Filtros de Informes',0),(241199,6700,'de','Berichtsfilter',0),(241200,6700,'en','Report Filters',0),(241201,6701,'is','',0),(241202,6701,'dr','Ù‡ÙŠÚ† Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ±ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(241203,6701,'pr','Ù‡ÙŠÚ† Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ±ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(241204,6701,'tr','SeÃ§ili hiÃ§bir fatura ÅŸartlarÄ±',0),(241205,6701,'pl','Nie faktury warunki wybranego',0),(241206,6701,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(241207,6701,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø·',0),(241208,6701,'sr','ÐÐµÐ¼Ð° ÑƒÑÐ»Ð¾Ð²Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(241209,6701,'vi','ChÆ°a chá»n má»¥c hÃ³a Ä‘Æ¡n',0),(241210,6701,'af','Geen faktuur terme gekies',0),(241211,6701,'ro','Nu termeni de facturÄƒ selectate',0),(241212,6701,'et','Valitud arve termineid',0),(241213,6701,'si','Ne pogoje raÄuna, izbrana',0),(241214,6701,'ba','Tidak ada istilah faktur yang dipilih',0),(241215,6701,'nl','Geen factuur termen geselecteerd',0),(241216,6701,'fi','Ei laskun ehtojen valittu',0),(241217,6701,'no','Ingen faktureringsvilkÃ¥r valgt',0),(241218,6701,'da','Ingen faktura vilkÃ¥r valgt',0),(241219,6701,'ko','ì•„ë‹ˆ ì²­êµ¬ì„œ ìš©ì–´ ì„ ì •',0),(241220,6701,'he','××™×Ÿ ×ª× ××™ ×”×—×©×‘×•× ×™×ª ×©× ×‘×—×¨×”',0),(241221,6701,'el','Î”ÎµÎ½ Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(241222,6701,'zh','æ²¡æœ‰é€‰ä¸­çš„å‘ç¥¨æ¡æ¬¾\r\n',0),(241223,6701,'sv','Ingen faktura termer valts',0),(241224,6701,'it','Nessun termine fattura selezionato',0),(241225,6701,'tl','',0),(241226,6701,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(241227,6701,'hi','à¤•à¥‹à¤ˆ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤šà¤¯à¤¨à¤¿à¤¤',0),(241228,6701,'ms','Tiada syarat invois yang dipilih',0),(241229,6701,'ar','Ù„Ù… ØªØ®ØªØ± Ø£ÙŠ Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(241230,6701,'fr','Aucune termes de facture choisis',0),(241231,6701,'jp','é¸æŠžã—ãŸè«‹æ±‚æ›¸æ¡ä»¶ãŒãªã„ã§ã™ã€‚',0),(241232,6701,'pt','NÃ£o hÃ¡ termos de factura selecionados',0),(241233,6701,'ru','Ð‘ÐµÐ· ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð° Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(241234,6701,'es','No se seleccionaron los TÃ©rminos de las Facturas',0),(241235,6701,'de','Keine Rechnung-Begriffe ausgewÃ¤hlt',0),(241236,6701,'en','No Invoice Terms Selected',0),(241237,6702,'is','',0),(241238,6702,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(241239,6702,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(241240,6702,'tr','SMM hesabÄ±',0),(241241,6702,'pl','Konto KWS',0),(241242,6702,'bg','ÐžÐ¡ÐŸ ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð°',0),(241243,6702,'ur','Ú©Ø§ÙˆÚ¯Ø³ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(241244,6702,'sr','Ð¢ÐŸÐ  Ñ€Ð°Ñ‡ÑƒÐ½',0),(241245,6702,'vi','TK giÃ¡ thÃ nh hÃ ng bÃ¡n',0),(241246,6702,'af','KVV Rekening',0),(241247,6702,'ro','Cont CBV',0),(241248,6702,'et','OMAHINNA konto',0),(241249,6702,'si','Konto porabe',0),(241250,6702,'ba','RODA Account',0),(241251,6702,'nl','KPV-rekening',0),(241252,6702,'fi','Myytyjen tuotteiden kustannusten tili',0),(241253,6702,'no','Lagerforbrukskonto',0),(241254,6702,'da','Vareforbrugskontoen',0),(241255,6702,'ko','ë§¤ì¶œ ì›ê°€ ê³„ì •',0),(241256,6702,'he','×—×©×‘×•×Ÿ ×ª×•×¨×™×›×ž ×ª×•×œ×¢',0),(241257,6702,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î Î©Î›Î—Î˜ÎˆÎÎ¤Î©Î',0),(241258,6702,'zh','é”€å”®æˆæœ¬å¸æˆ·\r\n',0),(241259,6702,'sv','KSV',0),(241260,6702,'it','INGRANAGGI conto',0),(241261,6702,'tl','',0),(241262,6702,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3634;&#3618;',0),(241263,6702,'hi','COGS à¤–à¤¾à¤¤à¥‡',0),(241264,6702,'ms','Salah satu alat akaun',0),(241265,6702,'ar','Ø­Ø³Ø§Ø¨ ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(241266,6702,'fr','CMV compte',0),(241267,6702,'jp','COGS ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(241268,6702,'pt','Conta de COGS',0),(241269,6702,'ru','Ð—Ð£Ð‘Ð¦Ð« ÑÑ‡ÐµÑ‚Ð°',0),(241270,6702,'es','Cuenta COGS',0),(241271,6702,'de','ZahnrÃ¤der-Konto',0),(241272,6702,'en','COGS Account',0),(241273,6703,'is','',0),(241274,6703,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(241275,6703,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(241276,6703,'tr','SMM TutarÄ±',0),(241277,6703,'pl','Kwota KWS',0),(241278,6703,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° ÐžÐ¡ÐŸ',0),(241279,6703,'ur','Ú©Ø§ÙˆÚ¯Ø³ Ù…Ù‚Ø¯Ø§Ø±',0),(241280,6703,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¢ÐŸÐ ',0),(241281,6703,'vi','GiÃ¡ thÃ nh hÃ ng bÃ¡n',0),(241282,6703,'af','RATTE bedrag',0),(241283,6703,'ro','SumÄƒ CBV',0),(241284,6703,'et','OMAHINNA summa',0),(241285,6703,'si','Znesek porabe',0),(241286,6703,'ba','Jumlah roda',0),(241287,6703,'nl','KPV-bedrag',0),(241288,6703,'fi','Myytyjen tuotteiden kustannukset',0),(241289,6703,'no','VareforbruksbelÃ¸p',0),(241290,6703,'da','ForbrugsbelÃ¸b',0),(241291,6703,'ko','í†±ë‹ˆ ê¸ˆì•¡',0),(241292,6703,'he','×›×ž×•×ª ×”×—×•×–×™×',0),(241293,6703,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï€Ï‰Î»Î·Î¸Î­Î½Ï„Ï‰Î½',0),(241294,6703,'zh','é”€å”®æˆæœ¬é‡‘é¢\r\n',0),(241295,6703,'sv','KSV-belopp',0),(241296,6703,'it','QuantitÃ  di ingranaggi',0),(241297,6703,'tl','',0),(241298,6703,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3634;&#3618;',0),(241299,6703,'hi','COGS à¤°à¤¾à¤¶à¤¿',0),(241300,6703,'ms','Salah satu alat jumlah',0),(241301,6703,'ar','Ù‚ÙŠÙ…Ø© ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(241302,6703,'fr','Montant CPV',0),(241303,6703,'jp','COGS é‡',0),(241304,6703,'pt','Quantidade de engrenagens',0),(241305,6703,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¡ÐµÐ±ÐµÑÑ‚',0),(241306,6703,'es','Monto COGS',0),(241307,6703,'de','Lagerverbrauchsbetrag',0),(241308,6703,'en','COGS Amount',0),(241309,6704,'is','',0),(241310,6704,'dr','Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(241311,6704,'pr','Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(241312,6704,'tr','Stok hesabÄ±',0),(241313,6704,'pl','Konto zapasÃ³w',0),(241314,6704,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(241315,6704,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(241316,6704,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(241317,6704,'vi','TK HÃ ng HÃ³a',0),(241318,6704,'af','Voorraadrekening',0),(241319,6704,'ro','Cont Inventar',0),(241320,6704,'et','Laokonto',0),(241321,6704,'si','Konto zaloge',0),(241322,6704,'ba','Persediaan Account',0),(241323,6704,'nl','Voorraadrekening',0),(241324,6704,'fi','Varastotilin',0),(241325,6704,'no','Lagerkontoen',0),(241326,6704,'da','Lagerkontoen',0),(241327,6704,'ko','ìž¬ê³  ê³„ì •',0),(241328,6704,'he','×—×©×‘×•×Ÿ ×ž×œ××™',0),(241329,6704,'el','Î›Î¿Î³. Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(241330,6704,'zh','åº“å­˜å¸å·',0),(241331,6704,'sv','Lagerkontot',0),(241332,6704,'it','Conto di inventario',0),(241333,6704,'tl','',0),(241334,6704,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(241335,6704,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤–à¤¾à¤¤à¥‡',0),(241336,6704,'ms','Akaun inventori',0),(241337,6704,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(241338,6704,'fr','L\'inventaire compte',0),(241339,6704,'jp','åœ¨åº«å‹˜å®š',0),(241340,6704,'pt','Conta de estoque',0),(241341,6704,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°',0),(241342,6704,'es','Cuenta de Inventario',0),(241343,6704,'de','Lagerkonto',0),(241344,6704,'en','Inventory Account',0),(241345,6705,'is','',0),(241346,6705,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(241347,6705,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(241348,6705,'tr','Stok GL hesabÄ±',0),(241349,6705,'pl','Konto zapasÃ³w GL',0),(241350,6705,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð·Ð°Ð¿Ð°ÑÐ¸ GL',0),(241351,6705,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(241352,6705,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð“Ð›',0),(241353,6705,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p HÃ ng HÃ³a',0),(241354,6705,'af','Voorraad AG Rekening',0),(241355,6705,'ro','Contul de GL stocuri',0),(241356,6705,'et','Varude pearaamatukontole',0),(241357,6705,'si','Konto zaloge GL',0),(241358,6705,'ba','Persediaan GL Account',0),(241359,6705,'nl','GL voorraadrekening',0),(241360,6705,'fi','GL varastotilin',0),(241361,6705,'no','GL lagerkontoen',0),(241362,6705,'da','GL lagerkontoen',0),(241363,6705,'ko','ìž¬ê³  GL ê³„ì •',0),(241364,6705,'he','×ž×œ××™ GL ×—×©×‘×•×Ÿ',0),(241365,6705,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(241366,6705,'zh','åº“å­˜æ€»å¸å¸æˆ·\r\n',0),(241367,6705,'sv','GL lagerkontot',0),(241368,6705,'it','Inventario GL Account',0),(241369,6705,'tl','',0),(241370,6705,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(241371,6705,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ GL à¤–à¤¾à¤¤à¥‡',0),(241372,6705,'ms','Inventori GL akaun',0),(241373,6705,'ar','Ø­Ø³Ø§Ø¨ Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(241374,6705,'fr','Compte GL en stock',0),(241375,6705,'jp','åœ¨åº« GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(241376,6705,'pt','Conta de estoque GL',0),(241377,6705,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ GL',0),(241378,6705,'es','Cuenta LM de Inventario',0),(241379,6705,'de','GL Lagerkonto',0),(241380,6705,'en','Inventory GL Account',0),(241381,6706,'is','',0),(241382,6706,'dr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(241383,6706,'pr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(241384,6706,'tr','Sevk',0),(241385,6706,'pl','WysÅ‚ane do',0),(241386,6706,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð´Ð¾',0),(241387,6706,'ur','Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(241388,6706,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸',0),(241389,6706,'vi','Chuyá»ƒn Ä‘áº¿n',0),(241390,6706,'af','Versend Na',0),(241391,6706,'ro','Expediate',0),(241392,6706,'et','Veetud',0),(241393,6706,'si','Odpremljeno v',0),(241394,6706,'ba','Dikirim ke',0),(241395,6706,'nl','Verzonden naar',0),(241396,6706,'fi','Toimitetaan',0),(241397,6706,'no','Sendt til',0),(241398,6706,'da','Sendt til',0),(241399,6706,'ko','ë°°ì†¡',0),(241400,6706,'he','×œ×ž×©×œ×•×—',0),(241401,6706,'el','Î‘Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ ÏƒÎµ',0),(241402,6706,'zh','é€å¾€\r\n',0),(241403,6706,'sv','Levereras till',0),(241404,6706,'it','Spedito a',0),(241405,6706,'tl','',0),(241406,6706,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;',0),(241407,6706,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(241408,6706,'ms','Dihantar ke',0),(241409,6706,'ar','ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ø¥Ù„Ù‰',0),(241410,6706,'fr','ExpÃ©diÃ© Ã ',0),(241411,6706,'jp','ã‚’å‡ºè·',0),(241412,6706,'pt','Enviado para',0),(241413,6706,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð²',0),(241414,6706,'es','Enviado A',0),(241415,6706,'de','Versandt',0),(241416,6706,'en','Shipped To',0),(241417,6707,'is','',0),(241418,6707,'dr','Ø­Ù…Ù„ Ø§Ø² Ù…Ø­Ù„ ',0),(241419,6707,'pr','Ø­Ù…Ù„ Ø§Ø² Ù…Ø­Ù„ ',0),(241420,6707,'tr','Konumdan sevk',0),(241421,6707,'pl','Statek z lokalizacji',0),(241422,6707,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð¾Ñ‚ Ð¼ÑÑÑ‚Ð¾',0),(241423,6707,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø³Û’ Ø¬ÛØ§Ø²',0),(241424,6707,'sr','Ð‘Ñ€Ð¾Ð´ ÑÐ° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(241425,6707,'vi','Chuyá»ƒn tá»« vá»‹ trÃ­',0),(241426,6707,'af','Versending vanaf Plek',0),(241427,6707,'ro','NavÄƒ de locaÅ£ie',0),(241428,6707,'et','Laeva asukoht',0),(241429,6707,'si','Ladja iz lokacije',0),(241430,6707,'ba','Kapal dari lokasi',0),(241431,6707,'nl','Schip van locatie',0),(241432,6707,'fi','Aluksen sijainnista',0),(241433,6707,'no','Skip fra plasseringen',0),(241434,6707,'da','Skib fra placering',0),(241435,6707,'ko','ìœ„ì¹˜ì—ì„œ ë°°',0),(241436,6707,'he','×”×¡×¤×™× ×” ×ž×”×ž×™×§×•×',0),(241437,6707,'el','Î Î»Î¿Î¯Î¿ Î±Ï€ÏŒ Ï„Î·Î½ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(241438,6707,'zh','å‘è´§ä½ç½®\r\n',0),(241439,6707,'sv','Fartyg frÃ¥n plats',0),(241440,6707,'it','Nave da posizione',0),(241441,6707,'tl','',0),(241442,6707,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3592;&#3634;&#3585;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(241443,6707,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¥‡ à¤œà¤¹à¤¾à¤œ',0),(241444,6707,'ms','Kapal dari lokasi',0),(241445,6707,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù…Ù† Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(241446,6707,'fr','Bateau de Location',0),(241447,6707,'jp','å ´æ‰€ã‹ã‚‰å‡ºè·ã—ã¾ã™ã€‚',0),(241448,6707,'pt','O navio de localizaÃ§Ã£o',0),(241449,6707,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¸Ð· Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(241450,6707,'es','Ubicaciones de Enviar De',0),(241451,6707,'de','Schiff aus Lage',0),(241452,6707,'en','Ship From Location',0),(241453,6708,'is','',0),(241454,6708,'dr','! Ø§ÙŠØ¬Ø§Ø¯ ØªØºÙŠÙŠØ±Ø§Øª Ø²ÙŠØ± Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ø§Ø¹Ø« Ù…Ø´Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø´ÙˆØ¯ Ù…Ú¯Ø± Ø§ÙŠÙ†ÙƒÙ‡ Ø´Ù…Ø§ Ù…Ø·Ù…Ø¦Ù† Ø¨Ø§Ø´ÙŠØ¯ Ø´Ù…Ø§ Ù…ÙŠ Ø¯Ø§Ù†ÙŠØ¯ ÙƒÙ‡ Ú†Ù‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ',0),(241455,6708,'pr','Ø§Ø®Ø·Ø§Ø± ! Ø§ÙŠØ¬Ø§Ø¯ ØªØºÙŠÙŠØ±Ø§Øª Ø²ÙŠØ± Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ø§Ø¹Ø« Ù…Ø´ÙƒÙ„Ø§Øª Ø´ÙˆØ¯ Ù…Ú¯Ø± Ø§ÙŠÙ†ÙƒÙ‡ Ø´Ù…Ø§ Ù…Ø·Ù…Ø¦Ù† Ø¨Ø§Ø´ÙŠØ¯ Ø´Ù…Ø§ Ù…ÙŠ Ø¯Ø§Ù†ÙŠØ¯ ÙƒÙ‡ Ú†Ù‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ',0),(241456,6708,'tr','UyarÄ±!! Biliyor musun ne yapÄ±yorsun emin olmadÄ±ÄŸÄ±nÄ±z deÄŸiÅŸikliklerine aÅŸaÄŸÄ±daki sorunlara neden olabilir!',0),(241457,6708,'pl','OstrzeÅ¼enie! Podejmowania zmian poniÅ¼ej moÅ¼e powodowaÄ‡ problemy, jeÅ›li nie jesteÅ› pewien, Å¼e wiesz, co robisz!',0),(241458,6708,'bg','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ! ÐžÑÑŠÑ‰ÐµÑÑ‚Ð²ÑÐ²Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€ÐµÐ´Ð¸Ð·Ð²Ð¸ÐºÐ° Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð¸, Ð°ÐºÐ¾ Ð½Ðµ ÑÑ‚Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸, Ñ‡Ðµ Ð·Ð½Ð°ÐµÑ‚Ðµ ÐºÐ°ÐºÐ²Ð¾ Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ!',0),(241459,6708,'ur','Ø®Ø¨Ø±Ø¯Ø§Ø± Ú©Ø± Ø±ÛØ§ ÛÛ’!! Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø¬Ø§Ù†ØªÛ’ ÛÛŒÚº Ú©Û Ø¢Ù¾ Ú©ÛŒØ§ Ú©Ø± Ø±ÛÛ’ ÛÛŒÚº Ø¬Ø¨ ØªÚ© Ú©Û Ø³Ø§Ø²ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ù…Ø³Ø§Ø¦Ù„ Ù¾ÛŒØ¯Ø§ ÛÙˆ Ø³Ú©ØªÛ’!',0),(241460,6708,'sr','Ð£Ð¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ!! ÐŸÑ€Ð°Ð²Ñ™ÐµÑšÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ð¼Ð¾Ð¶Ðµ Ð¸Ð·Ð°Ð·Ð²Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ðµ, Ð¾ÑÐ¸Ð¼ Ð°ÐºÐ¾ ÑÑ‚Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ð·Ð½Ð°Ñ‚Ðµ Ð´Ð° Ñ‚Ð¾ Ñ€Ð°Ð´Ð¸Ñ‚Ðµ!',0),(241461,6708,'vi','Cáº£nh bÃ¡o!! Thay Ä‘á»•i dÆ°á»›i nÃ y cÃ³ thá»ƒ cÃ³ váº¥n Ä‘á» trá»« phi báº¡n biáº¿t báº¡n Ä‘ang lÃ m gÃ¬!',0),(241462,6708,'af','Waarskuwing!! Maak veranderinge hieronder kon nie probleme veroorsaak nie tensy jy is seker jy weet wat jy doen!',0),(241463,6708,'ro','Avertisment! A face schimbÄƒri mai jos ar putea provoca probleme dacÄƒ nu eÅŸti sigur cÄƒ ÅŸtiÅ£i ceea ce faci!',0),(241464,6708,'et','Hoiatus! Muudatuste tegemine vÃµib tekitada probleeme tÃ¶Ã¶s. JÃ¤tka ainult juhul kui Te olete kindel, et teate mida teete!',0),(241465,6708,'si','Opozorilo! Izdelava sprememb spodaj lahko povzroÄi teÅ¾ave, razen Äe ste prepriÄani, da veste, kaj poÄnete!',0),(241466,6708,'ba','Peringatan!! Membuat perubahan di bawah ini dapat menyebabkan masalah kecuali Anda yakin Anda tahu apa yang Anda lakukan!',0),(241467,6708,'nl','Waarschuwing! Maken wijzigingen hieronder kunnen dat problemen veroorzaken tenzij u bent zeker dat je weet wat je doet!',0),(241468,6708,'fi','Varoitus! Alla muuttaminen saattaa aiheuttaa ongelmia, jos olet varma, ettÃ¤ tiedÃ¤t mitÃ¤ olet tekemÃ¤ssÃ¤!',0),(241469,6708,'no','Advarsel! GjÃ¸r endringene nedenfor kan forÃ¥rsake problemer uten at du vet hva du gjÃ¸r!',0),(241470,6708,'da','Advarsel!! GÃ¸r Ã¦ndringer nedenfor kan forÃ¥rsage problemer, medmindre du er sikker pÃ¥ du ved hvad du laver!',0),(241471,6708,'ko','ê²½ê³ ! ë‹¹ì‹ ì´ ë­˜ ì•Œê³  í™•ì‹¤ í•˜ì§€ ì•Šìœ¼ë©´ ì•„ëž˜ ë§Œë“¤ê¸° ë³€ê²½ ë¬¸ì œë¥¼ ì¼ìœ¼í‚¬ ìˆ˜!',0),(241472,6708,'he','××–×”×¨×”!! ×¢×¨×™×›×ª ×©×™× ×•×™×™× ×©×œ×”×œ×Ÿ ×¢×©×•×™×™× ×œ×’×¨×•× ×œ×‘×¢×™×•×ª, ××œ× ×× ×›×Ÿ ××ª×” ×‘×˜×•×— ×©××ª×” ×™×•×“×¢ ×ž×” ××ª×” ×¢×•×©×”!',0),(241473,6708,'el','Î ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·! Î Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î¿Î¹ Î±Î»Î»Î±Î³Î­Ï‚ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Ï€ÏÎ¿ÎºÎ±Î»Î­ÏƒÎµÎ¹ Ï„Î± Ï€ÏÎ¿Î²Î»Î®Î¼Î±Ï„Î± ÎµÎ¬Î½ Î´ÎµÎ½ ÎµÎ¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¾Î­ÏÎµÏ„Îµ Ï„Î¹ ÎºÎ¬Î½ÎµÏ„Îµ!',0),(241474,6708,'zh','è­¦å‘Šï¼ï¼è¿›è¡Œä¸‹é¢çš„æ›´æ”¹ä¼šé€ æˆé—®é¢˜ï¼Œé™¤éžä½ ç¡®ä¿¡ä½ çŸ¥é“è‡ªå·±åœ¨åšä»€ä¹ˆï¼\r\n',0),(241475,6708,'sv','Varning! GÃ¶ra Ã¤ndringar nedan kan orsaka problem om du inte Ã¤r sÃ¤ker pÃ¥ att du vet vad du gÃ¶r!',0),(241476,6708,'it','Attenzione!! Modifiche della sottostante potrebbero causare problemi se non siete sicuri di che sapere cosa stai facendo!',0),(241477,6708,'tl','',0),(241478,6708,'th','Warning!! Making changes below could cause problems unless you are sure you know what you are doing!',0),(241479,6708,'hi','à¤šà¥‡à¤¤à¤¾à¤µà¤¨à¥€!! à¤œà¤¬ à¤¤à¤• à¤†à¤ª à¤¯à¤•à¥€à¤¨ à¤¹à¥ˆ à¤•à¤¿ à¤¤à¥à¤®à¥à¤¹à¥‡à¤‚ à¤ªà¤¤à¤¾ à¤¹à¥ˆ à¤¤à¥à¤® à¤•à¥à¤¯à¤¾ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤¬à¤¨à¤¾à¤¨à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¨à¥€à¤šà¥‡ à¤¸à¤®à¤¸à¥à¤¯à¤¾à¤“à¤‚ à¤•à¤¾ à¤•à¤¾à¤',0),(241480,6708,'ms','Amaran!! Membuat perubahan di bawah boleh menyebabkan masalah melainkan anda pasti anda tahu apa yang anda lakukan!',0),(241481,6708,'ar','ØªØ­Ø°ÙŠØ±!! Ø¥Ø¬Ø±Ø§Ø¡ ØªØºÙŠÙŠØ±Ø§Øª Ø£Ø¯Ù†Ø§Ù‡ ÙŠÙ…ÙƒÙ† Ø£Ù† ÙŠØ³Ø¨Ø¨ Ù…Ø´Ø§ÙƒÙ„ Ø¥Ù„Ø§ Ø¥Ø°Ø§ ÙƒÙ†Øª Ù…ØªØ£ÙƒØ¯Ø§Ù‹ Ù…Ù† Ø£Ù†Ùƒ ØªØ¹Ø±Ù Ù…Ø§ ØªÙ‚ÙˆÙ…ÙˆÙ† Ø¨Ù‡!',0),(241482,6708,'fr','Mise en garde!! Visant Ã  modifier ci-dessous pourrait poser des problÃ¨mes Ã  moins que vous Ãªtes sÃ»r que vous savez ce que vous faites !',0),(241483,6708,'jp','è­¦å‘Š ï¼ã‚ãªãŸã¯ã‚ãªãŸãŒä½•ã‚’ã‚„ã£ã¦ã„ã‚‹çŸ¥ã£ã¦ã„ã‚‹ã“ã¨ã‚’ç¢ºèªã—ãªã„é™ã‚Šã€ä»¥ä¸‹ã®å¤‰æ›´ã‚’è¡Œã†å•é¡Œã‚’å¼•ãèµ·ã“ã™å¯èƒ½æ€§ ï¼',0),(241484,6708,'pt','Aviso!!!! Fazer alteraÃ§Ãµes abaixo podem causar problemas se nÃ£o tiver a certeza que vocÃª sabe o que estÃ¡ fazendo!',0),(241485,6708,'ru','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ!! Ð’Ð½ÐµÑÐµÐ½Ð¸Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹ Ð½Ð¸Ð¶Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð²Ñ‹Ð·Ð²Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ñ‹, ÐµÑÐ»Ð¸ Ð²Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ð·Ð½Ð°ÐµÑ‚Ðµ, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ð´ÐµÐ»Ð°ÐµÑ‚Ðµ!',0),(241486,6708,'es','Aviso!! Haciendo cambios abajo podrÃ­a causar problemas hasta que esta seguro que sabe que esta haciendo',0),(241487,6708,'de','Warnung!! Machen Ã„nderungen unten kÃ¶nnte Probleme verursachen, es sei denn, Sie sicher, dass du weiÃŸt sind, was du tust!',0),(241488,6708,'en','Warning!! Making changes below could cause problems unless you are sure you know what you are doing!',0),(241489,6709,'is','',0),(241490,6709,'dr','( Ù…ÙØ§Ø¯)- ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ø§Ø«Ø§Ø«Ù‡ â€“ Ø¬Ø¯ÙŠØ¯ ÙƒØ±Ø¯Ù† ØµÙØ­Ù‡ ',0),(241491,6709,'pr','Ø®Ø·Ø§ Ø¨Ø§ Ø¨Ù‡Ø±Ù‡ ( Ø³ÙˆØ¯)- ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ø§Ø«Ø§Ø«Ù‡ â€“ Ø¬Ø¯ÙŠØ¯ ÙƒØ±Ø¯Ù† ØµÙØ­Ù‡ ',0),(241492,6709,'tr','Faiz dÃ¼zeltme dosyalarÄ±, yenileme ekran hata',0),(241493,6709,'pl','BÅ‚Ä…d z ustalania odsetek plikÃ³w, odÅ›wieÅ¼anie ekranu',0),(241494,6709,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ñ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ Ð½Ð° Ñ„Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ñ…Ð²ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚, Ð¾Ð±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐµÐºÑ€Ð°Ð½Ð°',0),(241495,6709,'ur','Ù†Ù‚Øµ ÙØ§Ø¦Ù„ÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾ Ø³ÙˆØ¯ ÙÚ©Ø³Ù†Ú¯ØŒ Ø³Ú©Ø±ÛŒÙ† ØªØ§Ø²Û Ú©Ø±ÛŒÚº',0),(241496,6709,'sr','Ð“Ñ€ÐµÑˆÐºÐ° ÑÐ° ÐºÐ°Ð¼Ð°Ñ‚Ð°-Ð¿Ð¾Ð¿Ñ€Ð°Ð²Ñ™Ð°Ð¼ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ, Ð¾ÑÐ²ÐµÐ¶Ð°Ð²Ð°ÑšÐ° ÐµÐºÑ€Ð°Ð½Ð°',0),(241497,6709,'vi','Lá»—i khi Ä‘á»‹nh lÃ£i suáº¥t, lÃ m má»›i mÃ n hÃ¬nh',0),(241498,6709,'af','Fout begaan met Rente-RegstellingslÃªers, Verfris Skerm',0),(241499,6709,'ro','Eroare cu fixare Ã®n interes Files, ecran de reÃ®mprospÄƒtare',0),(241500,6709,'et','TÃµrge failidega intressi VÃ¤rskenda saal',0),(241501,6709,'si','Napake z datotekami, doloÄitve obrestne mere, osveÅ¾evanja zaslona',0),(241502,6709,'ba','Kesalahan dengan bunga-memperbaiki file, Refresh layar',0),(241503,6709,'nl','Fout met rentevaststelling bestanden, vernieuwen scherm',0),(241504,6709,'fi','Virhe etua vahvistamisesta tiedostoja, PÃ¤ivitÃ¤ nÃ¤yttÃ¶',0),(241505,6709,'no','Feil med interesse-festing filer, fornye skjermen',0),(241506,6709,'da','Fejl med rentefastsÃ¦ttelse filer, Opdater skÃ¦rm',0),(241507,6709,'ko','ê´€ì‹¬ì„ ê³ ì • íŒŒì¼, í™”ë©´ ìƒˆë¡œ ê³ ì¹¨ ì˜¤ë¥˜',0),(241508,6709,'he','×©×’×™××” ×¢× ×¨×™×‘×™×ª-×ª×™×§×•×Ÿ ×§×‘×¦×™×, ×¨×¢× ×•×Ÿ ×”×ž×¡×š',0),(241509,6709,'el','Î£Ï†Î¬Î»Î¼Î± Î¼Îµ Î±ÏÏ‡ÎµÎ¯Î± ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼Î¿Ï Ï„Î¿Ï… Ï„ÏŒÎºÎ¿Ï…, Î±Î½Î±Î½Î­Ï‰ÏƒÎ·Ï‚ Î¿Î¸ÏŒÎ½Î·Ï‚',0),(241510,6709,'zh','åˆ©æ¯å›ºå®šæ–‡ä»¶é”™è¯¯ï¼Œåˆ·æ–°å±å¹•\r\n',0),(241511,6709,'sv','Fel med faststÃ¤llande av rÃ¤nta filer, uppdatera skÃ¤rmen',0),(241512,6709,'it','Errore con file di interesse-fissaggio, Refresh dello schermo',0),(241513,6709,'tl','',0),(241514,6709,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3633;&#3610;&#3652;&#3615;&#3621;&#3660;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3588;&#3591;&#3607;&#3637;&#3656;,&#3619;&#3637;&#3648;&#3615;&#3619;&#3594;&#3627;&#3609;&#3657;&#',0),(241515,6709,'hi','à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚, à¤¬à¥à¤¯à¤¾à¤œ-à¤«à¤¿à¤•à¥à¤¸à¤¿à¤‚à¤—, à¤¤à¤¾à¤œà¤¼à¤¾ à¤•à¤°à¥‡à¤‚ à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(241516,6709,'ms','Ralat dengan faedah-menetapkan fail, segar semula skrin',0),(241517,6709,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(241518,6709,'fr','Erreur avec fichiers fixant l\'intÃ©rÃªt, rafraÃ®chissement Ã©cran',0),(241519,6709,'jp','åˆ©å­ã‚’ä¿®æ­£ã™ã‚‹ãƒ•ã‚¡ã‚¤ãƒ«ã¨ã€ç”»é¢ã®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(241520,6709,'pt','Erro com interesse de fixaÃ§Ã£o de arquivos, atualizaÃ§Ã£o de tela',0),(241521,6709,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ñ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑÐ¾Ð¼ Ñ„Ð¸ÐºÑÐ°Ñ†Ð¸Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð², Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÐºÑ€Ð°Ð½',0),(241522,6709,'es','Error Con InterÃ©ses-Arreglando Archivos, Refrescar Pantalla\r\n',0),(241523,6709,'de','Fehler mit Interesse-reparieren-Dateien, Bildschirm aktualisieren',0),(241524,6709,'en','Error With Interest-Fixing Files, Refresh Screen',0),(241525,6710,'is','',0),(241526,6710,'dr','ÙƒÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(241527,6710,'pr','ÙƒÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(241528,6710,'tr','Toplam Ã¶denen',0),(241529,6710,'pl','ÅÄ…cznie wypÅ‚aconych',0),(241530,6710,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(241531,6710,'ur','Ú©Ù„ ØªÙ†Ø®ÙˆØ§Û',0),(241532,6710,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(241533,6710,'vi','Tá»•ng cá»™ng tráº£',0),(241534,6710,'af','Totaal Uitbetaal',0),(241535,6710,'ro','Total plÄƒtit',0),(241536,6710,'et','Kokku tasuda',0),(241537,6710,'si','Skupaj plaÄano',0),(241538,6710,'ba','Total yang dibayarkan',0),(241539,6710,'nl','Totaal betaald',0),(241540,6710,'fi','Maksettu yht.',0),(241541,6710,'no','Totalt antall betalte',0),(241542,6710,'da','Alt betalt',0),(241543,6710,'ko','ì´ ì§€ë¶ˆ',0),(241544,6710,'he','×¡×” ×› ×©×™×œ×',0),(241545,6710,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬, ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹',0),(241546,6710,'zh','æ€»ä»˜æ¸…çš„\r\n',0),(241547,6710,'sv','Totalt betalade',0),(241548,6710,'it','Totale pagato',0),(241549,6710,'tl','',0),(241550,6710,'th','&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(241551,6710,'hi','à¤•à¥à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(241552,6710,'ms','Jumlah yang dibayar',0),(241553,6710,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(241554,6710,'fr','Total payÃ©',0),(241555,6710,'jp','æ‰•ã„ã®æ”¯æ‰•ç·é¡',0),(241556,6710,'pt','Total pago',0),(241557,6710,'ru','Ð’ÑÐµÐ³Ð¾ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ð¸Ð»Ð¸',0),(241558,6710,'es','Total Pagado',0),(241559,6710,'de','Gesamtbetrag',0),(241560,6710,'en','Total Paid',0),(241561,6711,'is','',0),(241562,6711,'dr','(Ù…ØªØ¹Ù„Ù‚Ù‡)',0),(241563,6711,'pr','Ø¨Ù‡Ø±Ù‡ Ø¬Ù…Ø¹ Ø´Ø¯Ù‡(Ù…ØªØ¹Ù„Ù‚Ù‡)',0),(241564,6711,'tr','Tahakkuk eden faizi',0),(241565,6711,'pl','NarosÅ‚e odsetki',0),(241566,6711,'bg','ÐÐ°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ Ð»Ð¸Ñ…Ð²Ð¸',0),(241567,6711,'ur','ØªÙ…Ø§Ù… ÛÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ø³ÙˆØ¯',0),(241568,6711,'sr','ÐÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ð¼Ð°Ñ‚Ðµ',0),(241569,6711,'vi','LÃ£i Suáº¥t Cá»™ng Láº¡i',0),(241570,6711,'af','Opgeloopte Rente',0),(241571,6711,'ro','Dobanzi acumulate',0),(241572,6711,'et','Laekunud intressid',0),(241573,6711,'si','ObraÄunane obresti',0),(241574,6711,'ba','Bunga Bertambah',0),(241575,6711,'nl','Rente',0),(241576,6711,'fi','Kertyneet korot',0),(241577,6711,'no','PÃ¥lÃ¸pte renter',0),(241578,6711,'da','PÃ¥lÃ¸bne renter',0),(241579,6711,'ko','ë°œìƒ í•œ ì´ìž',0),(241580,6711,'he','×¨×™×‘×™×ª × ×¦×‘×¨×ª',0),(241581,6711,'el','Î”ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Î¿Î¹ Ï„ÏŒÎºÎ¿Î¹',0),(241582,6711,'zh','åº”è®¡åˆ©æ¯\r\n',0),(241583,6711,'sv','Upplupen rÃ¤nta',0),(241584,6711,'it','Interessi maturati',0),(241585,6711,'tl','',0),(241586,6711,'th','&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3588;&#3591;&#3588;&#3657;&#3634;&#3591;',0),(241587,6711,'hi','à¤ªà¥à¤°à¥‹à¤¦à¥à¤­à¥‚à¤¤ à¤¬à¥à¤¯à¤¾à¤œ',0),(241588,6711,'ms','Faedah terakru',0),(241589,6711,'ar','Ø±Ø¨Ø§ - Ø²Ù‚ÙˆÙ…',0),(241590,6711,'fr','IntÃ©rÃªt AccumulÃ©e',0),(241591,6711,'jp','æœªåŽåˆ©æ¯',0),(241592,6711,'pt','Juros acumulados',0),(241593,6711,'ru','ÐÐ°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(241594,6711,'es','InterÃ©s Acumulados ',0),(241595,6711,'de','Aufgelaufenen Zinsen',0),(241596,6711,'en','Accrued Interest',0),(241597,6712,'is','',0),(241598,6712,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡Ø±Ù‡',0),(241599,6712,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡Ø±Ù‡',0),(241600,6712,'tr','Hata faiz ekleme',0),(241601,6712,'pl','BÅ‚Ä…d dodajÄ…c odsetki',0),(241602,6712,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»Ð¸Ñ…Ð²Ð°',0),(241603,6712,'ur','Ù†Ù‚Øµ Ø¯Ù„Ú†Ø³Ù¾ÛŒ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(241604,6712,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° ÐºÐ°Ð¼Ð°Ñ‚Ðµ',0),(241605,6712,'vi','ThÃªm lÃ£i xuáº¥t bá»‹ lá»—i',0),(241606,6712,'af','Fout byvoeging van rente',0),(241607,6712,'ro','Eroare adÄƒugarea dobÃ¢nzii',0),(241608,6712,'et','Viivise lisamisel tekkis viga',0),(241609,6712,'si','Napaka dodajanje obresti',0),(241610,6712,'ba','Kesalahan menambahkan bunga',0),(241611,6712,'nl','Fout toe te voegen belang',0),(241612,6712,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ etu',0),(241613,6712,'no','Feil Ã¥ legge interesse',0),(241614,6712,'da','Fejl tilfÃ¸jer interesse',0),(241615,6712,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê´€ì‹¬',0),(241616,6712,'he','×©×’×™××” ×”×•×¡×¤×ª ×¨×™×‘×™×ª',0),(241617,6712,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½',0),(241618,6712,'zh','é”™è¯¯æ·»åŠ åˆ©æ¯\r\n',0),(241619,6712,'sv','Fel att lÃ¤gga intresse',0),(241620,6712,'it','Errore aggiungendo interesse',0),(241621,6712,'tl','',0),(241622,6712,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;',0),(241623,6712,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¬à¥à¤¯à¤¾à¤œ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(241624,6712,'ms','Ralat menambah faedah',0),(241625,6712,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(241626,6712,'fr','Erreur ajout d\'intÃ©rÃªt',0),(241627,6712,'jp','ã‚¨ãƒ©ãƒ¼ã®è¿½åŠ åˆ©å­',0),(241628,6712,'pt','Erro adicionando interesse',0),(241629,6712,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(241630,6712,'es','Error Agregando Intereses',0),(241631,6712,'de','Fehler HinzufÃ¼gen von Interesse',0),(241632,6712,'en','Error Adding Interest',0),(241633,6713,'is','',0),(241634,6713,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø«Ø¨Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(241635,6713,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø«Ø¨Øª Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(241636,6713,'tr','Hata gÃ¼ncelleme bilgi iÅŸlem kaydÄ±',0),(241637,6713,'pl','BÅ‚Ä…d aktualizacji CC rekordu transakcjÄ™',0),(241638,6713,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ CC ÑÐ´ÐµÐ»ÐºÐ° Ð·Ð°Ð¿Ð¸Ñ',0),(241639,6713,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ CC Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(241640,6713,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð·Ð°Ð¿Ð¸Ñ Ð¦Ð¦ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(241641,6713,'vi','Lá»—i cáº­p nháº­t sao chÃ©p giao dá»‹ch',0),(241642,6713,'af','Fout Outobywerking CC transaksie rekord',0),(241643,6713,'ro','Eroare de actualizare CC tranzactie Record',0),(241644,6713,'et','Viga ajakohastamine CC tehingute loetelu',0),(241645,6713,'si','Posodabljanje zapisa o napaki transakcije CC',0),(241646,6713,'ba','Kesalahan update CC transaksi catatan',0),(241647,6713,'nl','Fout bijwerken CC transactie Record',0),(241648,6713,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ CC tapahtuman tietue',0),(241649,6713,'no','Oppdatere CC transaksjonen feilposten',0),(241650,6713,'da','Fejl opdatering CC transaktionsposten',0),(241651,6713,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ CC íŠ¸ëžœìž­ì…˜ ê¸°ë¡',0),(241652,6713,'he','×¨×©×•×ž×ª ×¢×¡×§×ª ×¢×•×ª×§ ×œ×™×“×™×¢×” ×”×ž×¢×“×›× ×ª ×”×©×’×™××”',0),(241653,6713,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î® ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚ CC',0),(241654,6713,'zh','é”™è¯¯æ›´æ–°ä½£é‡‘æˆäº¤è®°å½•',0),(241655,6713,'sv','Fel uppdatering CC transaktionsregister',0),(241656,6713,'it','Errore aggiornamento CC transazione Record',0),(241657,6713,'tl','',0),(241658,6713,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3609;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3',0),(241659,6713,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ CC à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡',0),(241660,6713,'ms','Ralat pengemaskinian rekod urus niaga CC',0),(241661,6713,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø³Ø¬Ù„ Ø§Ù„Ø­Ø±ÙƒØ© CC',0),(241662,6713,'fr','Erreur mise Ã  jour CC Transaction Record',0),(241663,6713,'jp','ã‚¨ãƒ©ãƒ¼æ›´æ–° CC ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ãƒ¬ã‚³ãƒ¼ãƒ‰',0),(241664,6713,'pt','Registro de transaÃ§Ã£o CC atualizaÃ§Ã£o erro',0),(241665,6713,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ CC',0),(241666,6713,'es','Error Actualizando CC Record de Transacciones',0),(241667,6713,'de','Fehler Update CC-Transaktions-Record',0),(241668,6713,'en','Error Updating CC Transaction Record',0),(241669,6714,'is','',0),(241670,6714,'dr','(Ù…ÙØ§Ø¯) Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´Ø¯',0),(241671,6714,'pr','Ø¨Ù‡Ø±Ù‡ (Ø³ÙˆØ¯) Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´Ø¯',0),(241672,6714,'tr','Faiz dahil',0),(241673,6714,'pl','Odsetki zawarte',0),(241674,6714,'bg','Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚',0),(241675,6714,'ur','Ø³ÙˆØ¯ Ø´Ø§Ù…Ù„ ØªÚ¾Û’',0),(241676,6714,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ðµ ÑÑƒ ÑƒÐºÑ™ÑƒÑ‡ÐµÐ½Ðµ',0),(241677,6714,'vi','LÃ£i suáº¥t bao gá»“m',0),(241678,6714,'af','Rente Ingesluit',0),(241679,6714,'ro','Interes incluse',0),(241680,6714,'et','Huvides lisada',0),(241681,6714,'si','Obresti, ki so vkljuÄeni',0),(241682,6714,'ba','Bunga termasuk',0),(241683,6714,'nl','Belang opgenomen',0),(241684,6714,'fi','SisÃ¤ltyvÃ¤llÃ¤',0),(241685,6714,'no','Interesse inkludert',0),(241686,6714,'da','Interesse inkluderet',0),(241687,6714,'ko','ì´ìž í¬í•¨',0),(241688,6714,'he','×”×¨×™×‘×™×ª ×›×œ×•×œ×”',0),(241689,6714,'el','Î¤ÏŒÎºÏ‰Î½ Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹',0),(241690,6714,'zh','åŒ…æ‹¬åˆ©æ¯\r\n',0),(241691,6714,'sv','Intresse ingÃ¥r',0),(241692,6714,'it','Interesse inclusi',0),(241693,6714,'tl','',0),(241694,6714,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;',0),(241695,6714,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤¶à¤¾à¤®à¤¿à¤²',0),(241696,6714,'ms','Faedah termasuk',0),(241697,6714,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(241698,6714,'fr','IntÃ©rÃªts inclus',0),(241699,6714,'jp','é–¢å¿ƒãŒå«ã¾ã‚Œã¦ã„ã¾ã™',0),(241700,6714,'pt','Juros incluÃ­dos',0),(241701,6714,'ru','Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹',0),(241702,6714,'es','InterÃ©ses Incluidos',0),(241703,6714,'de','Interesse aufgenommen',0),(241704,6714,'en','Interest Included',0),(241705,6715,'is','',0),(241706,6715,'dr','ÙÙ‚Ø· Ù†Ø´Ø§Ù† Ø¯Ù‡ÙŠØ¯ Ø§Ú¯Ø± Ø¨ÙŠØ´ØªØ± Ø§Ø²    Ø±ÙˆØ²   ',0),(241707,6715,'pr','ÙÙ‚Ø· Ù†Ø´Ø§Ù† Ø¯Ù‡ÙŠØ¯ Ø§Ú¯Ø± Ø¨ÙŠØ´ØªØ± Ø§Ø²    Ø±ÙˆØ²   ',0),(241708,6715,'tr','Xx gÃ¼n eÄŸer gÃ¶stermek',0),(241709,6715,'pl','PokaÅ¼ tylko, jeÅ›li w ciÄ…gu xx dni',0),(241710,6715,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ñ‚ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¿Ñ€ÐµÐ· xx Ð´Ð½Ð¸',0),(241711,6715,'ur','Xx Ø¯Ù† ØªÙˆ Ù¾Ø± ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(241712,6715,'sr','ÐˆÐµÐ´Ð¸Ð½Ð° ÐµÐ¼Ð¸ÑÐ¸Ñ˜Ð° Ð°ÐºÐ¾ Ñ˜Ðµ Ñ‚Ð¾ÐºÐ¾Ð¼ xx Ð´Ð°Ð½Ð°',0),(241713,6715,'vi','Chá»‰ hiá»ƒn thá»‹ náº¿u quÃ¡ xx ngÃ y',0),(241714,6715,'af','Wys Alleenlik indien Ouer As xx Dae',0),(241715,6715,'ro','AratÄƒ doar dacÄƒ peste xx zile',0),(241716,6715,'et','Kuva ainult kui Ã¼le xx pÃ¤evad',0),(241717,6715,'si','KaÅ¾ejo le, Äe v dneh xx',0),(241718,6715,'ba','Tampilkan hanya jika selama hari xx',0),(241719,6715,'nl','Enige Show als Over xx dagen',0),(241720,6715,'fi','NÃ¤yttÃ¤Ã¤ vain jos yli xx pÃ¤ivÃ¤Ã¤',0),(241721,6715,'no','Bare Vis hvis Over xx dager',0),(241722,6715,'da','Kun vise hvis Over xx dage',0),(241723,6715,'ko','Xx ì¼ ë™ì•ˆ ê²½ìš°ì— í‘œì‹œ',0),(241724,6715,'he','×”×¦×’ ×¨×§ ×× ×‘×™×ž×™× xx',0),(241725,6715,'el','Î”ÎµÎ¯Ï‡Î½Î¿Ï…Î½ Î¼ÏŒÎ½Î¿ Î±Î½ Î³Î¹Î± xx Î·Î¼Î­ÏÎµÏ‚',0),(241726,6715,'zh','åªæ˜¾ç¤ºå¦‚æžœè¶…è¿‡xxå¤©\r\n',0),(241727,6715,'sv','Bara Visa om Ã¶ver xx dagar',0),(241728,6715,'it','Visualizza solo se sopra xx giorni',0),(241729,6715,'tl','',0),(241730,6715,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604; xx &#3623;&#3633;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(241731,6715,'hi','Xx à¤¦à¤¿à¤¨à¥‹à¤‚ à¤…à¤—à¤° à¤•à¥‡à¤µà¤² à¤¶à¥‹',0),(241732,6715,'ms','Hanya menunjukkan jika sejak hari xx',0),(241733,6715,'ar','ØªØ¸Ù‡Ø± ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† Ø¹Ù„Ù‰ Ù…Ø¯Ù‰ Ø§Ù„Ø£ÙŠØ§Ù… Ø§Ù„Ø¹Ø´Ø±ÙŠÙ†',0),(241734,6715,'fr','Seul spectacle en cas de dÃ©passement xx jours',0),(241735,6715,'jp','Xx æ—¥ã«ã‚ãŸã‚‹å ´åˆã®å”¯ä¸€ã®ã‚·ãƒ§ãƒ¼',0),(241736,6715,'pt','Apenas mostram se mais de xx dias',0),(241737,6715,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ xx Ð”Ð½ÐµÐ¹',0),(241738,6715,'es','Solo Muestra si MÃ¡s de xx DÃ­as',0),(241739,6715,'de','Nur zeigen wenn Ã¼ber Xx Tage',0),(241740,6715,'en','Only Show if Over xx Days',0),(241741,6716,'is','',0),(241742,6716,'dr','Ù…Ù‚Ø§Ø¯ÙŠØ± Ø´Ø§Ù…Ù„ Ø¨Ù‡Ø±Ù‡ Ø¬Ù…Ø¹ Ø´Ø¯Ù‡ Ù†ÙŠØ³Øª ',0),(241743,6716,'pr','Ù…Ù‚Ø§Ø¯ÙŠØ± Ø´Ø§Ù…Ù„ Ø¨Ù‡Ø±Ù‡ Ø¬Ù…Ø¹ Ø´Ø¯Ù‡ Ù†ÙŠØ³Øª ',0),(241744,6716,'tr','Tahakkuk eden faiz tutarlarÄ±nÄ± iÃ§ermez',0),(241745,6716,'pl','Kwoty nie obejmujÄ… naliczonych odsetek',0),(241746,6716,'bg','Ð¡ÑƒÐ¼Ð¸Ñ‚Ðµ Ð½Ðµ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ Ð»Ð¸Ñ…Ð²Ð¸',0),(241747,6716,'ur','Ù…Ù‚Ø¯Ø§Ø± ØªÙ…Ø§Ù… ÛÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ø³ÙˆØ¯ Ø´Ø§Ù…Ù„ Ù†Û Ú©Ø±ÛŒÚº Û”',0),(241748,6716,'sr','Ð˜Ð·Ð½Ð¾ÑÐ¸ Ð½Ðµ ÑƒÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ð¼Ð°Ñ‚Ðµ',0),(241749,6716,'vi','Sá»‘ LÆ°á»£ng KHÃ”NG BAO Gá»’M Trong LÃ£i Suáº¥t Tá»•ng Cá»™ng',0),(241750,6716,'af','Bedrae Sluit NIE Opgeloopte Rente In NIE',0),(241751,6716,'ro','Sumele nu includ dobÃ¢nda',0),(241752,6716,'et','Summad ei sisalda kogunenud intressi',0),(241753,6716,'si','Zneski ne vkljuÄujejo obresti',0),(241754,6716,'ba','Jumlah tidak termasuk bunga akrual',0),(241755,6716,'nl','Bedragen bevatten geen rente',0),(241756,6716,'fi','Lukuun eivÃ¤t sisÃ¤lly kertyneet korot',0),(241757,6716,'no','BelÃ¸pene inkluderer ikke pÃ¥lÃ¸pte renter',0),(241758,6716,'da','BelÃ¸b, der omfatter ikke pÃ¥lÃ¸bne renter',0),(241759,6716,'ko','ê¸ˆì•¡ ë¯¸ì§€ê¸‰ëœ ì´ìžë¥¼ í¬í•¨ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(241760,6716,'he','×”×¡×›×•×ž×™× ××™× × ×›×•×œ×œ×™× ×¨×™×‘×™×ª',0),(241761,6716,'el','Î Î¿ÏƒÎ¬ Î´ÎµÎ½ Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï„Î¿Ï…Ï‚ Î´ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Î¿Ï…Ï‚ Ï„ÏŒÎºÎ¿Ï…Ï‚',0),(241762,6716,'zh','é‡‘é¢ä¸åŒ…æ‹¬åº”è®¡åˆ©æ¯\r\n',0),(241763,6716,'sv','Belopp exklusive upplupen rÃ¤nta',0),(241764,6716,'it','Gli importi non comprendono gli interessi maturati',0),(241765,6716,'tl','',0),(241766,6716,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3619;&#3623;&#3617;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;&#3588;&#3657;&#3634;&#3591;&#3592;&#3656;&#3634;&#3618;',0),(241767,6716,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¥‹à¤¦à¥à¤­à¥‚à¤¤ à¤¬à¥à¤¯à¤¾à¤œ à¤¶à¤¾à¤®à¤¿à¤² à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¤‚',0),(241768,6716,'ms','Jumlah tidak termasuk faedah terakru',0),(241769,6716,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(241770,6716,'fr','Montants n\'incluent pas les intÃ©rÃªts courus',0),(241771,6716,'jp','é‡‘é¡ã¯ã€æœªåŽåˆ©æ¯é¡ã‚’å«ã‚ãªã„ã§ãã ã•ã„ã€‚',0),(241772,6716,'pt','Montantes nÃ£o incluem juros acumulados',0),(241773,6716,'ru','Ð¡ÑƒÐ¼Ð¼Ñ‹ Ð½Ðµ Ð²ÐºÐ»ÑŽÑ‡Ð°ÑŽÑ‚ Ð² ÑÐµÐ±Ñ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(241774,6716,'es','Cantidades NO Incluye InterÃ©ses Acumulados',0),(241775,6716,'de','Aufgelaufenen Zinsen von BetrÃ¤gen nicht enthalten.',0),(241776,6716,'en','Amounts Do NOT Include Accrued Interest',0),(241777,6717,'is','',0),(241778,6717,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø±ÙˆØ²Ù‡Ø§ Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø­Ù‚ÙˆÙ‚',0),(241779,6717,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø±ÙˆØ²Ù‡Ø§ Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø­Ù‚ÙˆÙ‚',0),(241780,6717,'tr','Ã–deme iÃ§in ortalama gÃ¼n',0),(241781,6717,'pl','Åšrednia liczba dni zapÅ‚aciÄ‡',0),(241782,6717,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð° Ð´Ð½Ð¸, Ð·Ð° Ð´Ð° Ð¿Ð»Ð°Ñ‚Ð¸',0),(241783,6717,'ur','Ø§ÙˆØ³Ø· Ø¯Ù† Ø§Ø¯Ø§ Ú©Ø±Ù†Ø§',0),(241784,6717,'sr','ÐŸÑ€Ð¾ÑÐµÑ‡Ð½Ð° Ð´Ð°Ð½Ð° Ð´Ð° Ð¿Ð»Ð°Ñ‚Ðµ',0),(241785,6717,'vi','NgÃ y Trung BÃ¬nh Tráº£ LÆ°Æ¡ng',0),(241786,6717,'af','Gemiddelde dae te betaal',0),(241787,6717,'ro','Medie de zile la plata',0),(241788,6717,'et','Keskmiselt pÃ¤evi maksmiseni',0),(241789,6717,'si','PovpreÄno dni za plaÄilo',0),(241790,6717,'ba','Rata-rata hari bayar',0),(241791,6717,'nl','Gemiddelde dagen te betalen',0),(241792,6717,'fi','Keskiarvo pÃ¤ivÃ¤Ã¤ maksu',0),(241793,6717,'no','Gjennomsnittlig dager Ã¥ betale',0),(241794,6717,'da','Gennemsnitlige dage til at betale',0),(241795,6717,'ko','í‰ê·  ì¼ ì§€ë¶ˆ',0),(241796,6717,'he','×ž×ž×•×¦×¢ ×™×ž×™× ×œ×©×œ×',0),(241797,6717,'el','ÎœÎ­ÏƒÎµÏ‚ Î·Î¼Î­ÏÎµÏ‚ Î½Î± Ï€Î»Î·ÏÏŽÏƒÎµÎ¹',0),(241798,6717,'zh','å¹³å‡å¤©æ•°æ”¯ä»˜\r\n',0),(241799,6717,'sv','Genomsnittliga dagar att betala',0),(241800,6717,'it','Media giorni di paga',0),(241801,6717,'tl','',0),(241802,6717,'th','&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3592;&#3656;&#3634;&#3618;&#3605;&#3656;&#3629;&#3623;&#3633;&#3609;',0),(241803,6717,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤”à¤¸à¤¤ à¤¦à¤¿à¤¨',0),(241804,6717,'ms','Purata hari untuk membayar',0),(241805,6717,'ar','Ù…ØªÙˆØ³Ø· Ø£ÙŠØ§Ù… Ù„Ù„Ø¯ÙØ¹',0),(241806,6717,'fr','Jours moyens de paiement',0),(241807,6717,'jp','ãŠæ”¯æ‰•ã„ã®å¹³å‡æ—¥æ•°',0),(241808,6717,'pt','MÃ©dia de dias para pagar',0),(241809,6717,'ru','Ð¡Ñ€ÐµÐ´Ð½ÐµÐµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð½ÐµÐ¹ Ð´Ð¾ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(241810,6717,'es','DÃ­as Promedias para Pagar',0),(241811,6717,'de','Durchschnittliche Tage bezahlen',0),(241812,6717,'en','Average Days to Pay',0),(241813,6718,'is','',0),(241814,6718,'dr','Ø§ÙˆÙ„ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(241815,6718,'pr','Ø§ÙˆÙ„ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(241816,6718,'tr','Ä°lk fatura',0),(241817,6718,'pl','Pierwsza faktura',0),(241818,6718,'bg','ÐŸÑŠÑ€Ð²Ð°Ñ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(241819,6718,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(241820,6718,'sr','ÐŸÑ€Ð²Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(241821,6718,'vi','HÃ³a Ä‘Æ¡n Äáº§u tiÃªn',0),(241822,6718,'af','Eerste Faktuur',0),(241823,6718,'ro','Prima factura',0),(241824,6718,'et','Esimene arve',0),(241825,6718,'si','Prvi raÄun',0),(241826,6718,'ba','Faktur pertama',0),(241827,6718,'nl','Eerste factuur',0),(241828,6718,'fi','EnsimmÃ¤isen laskun',0),(241829,6718,'no','FÃ¸rste faktura',0),(241830,6718,'da','FÃ¸rste faktura',0),(241831,6718,'ko','ì²« ë²ˆì§¸ ì¸ë³´ì´ìŠ¤',0),(241832,6718,'he','×”×—×©×‘×•× ×™×ª ×”×¨××©×•× ×”',0),(241833,6718,'el','Î ÏÏŽÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹ÏŒ ÏƒÎ±Ï‚',0),(241834,6718,'zh','ç¬¬ä¸€å¼ å‘ç¥¨\r\n',0),(241835,6718,'sv','FÃ¶rsta fakturan',0),(241836,6718,'it','Prima fattura',0),(241837,6718,'tl','',0),(241838,6718,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3621;&#3635;&#3604;&#3633;&#3610;&#3649;&#3619;&#3585;',0),(241839,6718,'hi','à¤ªà¤¹à¤²à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(241840,6718,'ms','Invois yang pertama',0),(241841,6718,'ar','Ø£ÙˆÙ„ Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨',0),(241842,6718,'fr','PremiÃ¨re facture',0),(241843,6718,'jp','åˆå›žã”è«‹æ±‚',0),(241844,6718,'pt','Primeira fatura',0),(241845,6718,'ru','ÐŸÐµÑ€Ð²Ñ‹Ð¹ Ð¡Ñ‡ÐµÑ‚',0),(241846,6718,'es','Factura Primera',0),(241847,6718,'de','Ersten Rechnung',0),(241848,6718,'en','First Invoice',0),(241849,6719,'is','',0),(241850,6719,'dr','Ø¬Ø¯ÙŠØ¯ØªØ±ÙŠÙ† ÙØ§ÙƒØªÙˆØ±',0),(241851,6719,'pr','Ø¬Ø¯ÙŠØ¯ØªØ±ÙŠÙ† ÙØ§ÙƒØªÙˆØ±',0),(241852,6719,'tr','En son faturanÄ±n',0),(241853,6719,'pl','Najnowsze faktury',0),(241854,6719,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(241855,6719,'ur','ØªØ§Ø²Û ØªØ±ÛŒÙ† Ø§Ù†ÙˆØ§Ø¦Ø³',0),(241856,6719,'sr','ÐÐ°Ñ˜Ð½Ð¾Ð²Ð¸Ñ˜Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(241857,6719,'vi','HÃ³a Ä‘Æ¡n gáº§n nháº¥t',0),(241858,6719,'af','Nuutste Faktuur',0),(241859,6719,'ro','Ultima factura',0),(241860,6719,'et','Viimane arve',0),(241861,6719,'si','NajnovejÅ¡e raÄuna',0),(241862,6719,'ba','Faktur terbaru',0),(241863,6719,'nl','Laatste factuur',0),(241864,6719,'fi','Uusimman laskun',0),(241865,6719,'no','Siste faktura',0),(241866,6719,'da','Seneste faktura',0),(241867,6719,'ko','ìµœì‹  ì¸ë³´ì´ìŠ¤',0),(241868,6719,'he','×—×©×‘×•× ×™×ª ×”××—×¨×•× ×”',0),(241869,6719,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(241870,6719,'zh','æœ€æ–°å‘ç¥¨\r\n',0),(241871,6719,'sv','Senaste faktura',0),(241872,6719,'it','Ultima fattura',0),(241873,6719,'tl','',0),(241874,6719,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(241875,6719,'hi','à¤¨à¤µà¥€à¤¨à¤¤à¤® à¤šà¤¾à¤²à¤¾à¤¨',0),(241876,6719,'ms','Invois Tempahan',0),(241877,6719,'ar','Ø¢Ø®Ø± Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨',0),(241878,6719,'fr','DerniÃ¨re facture',0),(241879,6719,'jp','æœ€æ–°ã®è«‹æ±‚',0),(241880,6719,'pt','Ãšltima fatura',0),(241881,6719,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(241882,6719,'es','Factura MÃ¡s Reciente',0),(241883,6719,'de','Letzten Rechnung verrechnet',0),(241884,6719,'en','Latest Invoice',0),(241885,6720,'is','',0),(241886,6720,'dr','Ø¬Ø¯ÙŠØ¯ØªØ±ÙŠÙ† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(241887,6720,'pr','Ø¬Ø¯ÙŠØ¯ØªØ±ÙŠÙ† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(241888,6720,'tr','Son Ã¶demenin',0),(241889,6720,'pl','Ostatniej pÅ‚atnoÅ›ci',0),(241890,6720,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(241891,6720,'ur','ØªØ§Ø²Û ØªØ±ÛŒÙ† Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(241892,6720,'sr','ÐÐ°Ñ˜Ð½Ð¾Ð²Ð¸Ñ˜Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(241893,6720,'vi','Thanh toÃ¡n gáº§n nháº¥t',0),(241894,6720,'af','Nuutste Betaling',0),(241895,6720,'ro','Ultima platÄƒ',0),(241896,6720,'et','Viimane makse',0),(241897,6720,'si','Zadnje plaÄilo',0),(241898,6720,'ba','Pembayaran',0),(241899,6720,'nl','Laatste betaling',0),(241900,6720,'fi','Uusimman maksun',0),(241901,6720,'no','Siste betaling',0),(241902,6720,'da','Seneste betaling',0),(241903,6720,'ko','ìµœì‹  ì§€ë¶ˆ',0),(241904,6720,'he','×”×ª×©×œ×•× ×”××—×¨×•×Ÿ',0),(241905,6720,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®',0),(241906,6720,'zh','æœ€æ–°ä»˜æ¬¾\r\n',0),(241907,6720,'sv','Senaste betalning',0),(241908,6720,'it','Ultimo pagamento',0),(241909,6720,'tl','',0),(241910,6720,'th','&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(241911,6720,'hi','à¤¨à¤µà¥€à¤¨à¤¤à¤® à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(241912,6720,'ms','Bayaran Tempahan',0),(241913,6720,'ar','Ø¢Ø®Ø± Ø¯ÙØ¹Ø©',0),(241914,6720,'fr','Dernier paiement',0),(241915,6720,'jp','æœ€æ–°ã®æ”¯æ‰•ã„',0),(241916,6720,'pt','Ãšltimo pagamento',0),(241917,6720,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(241918,6720,'es','Pago MÃ¡s Reciente',0),(241919,6720,'de','Neueste Zahlung',0),(241920,6720,'en','Latest Payment',0),(241921,6721,'is','',0),(241922,6721,'dr','Ø¨Ø¯Ù‡ÙŠ Ù‚Ø¨Ù„ÙŠ',0),(241923,6721,'pr','Ø¨Ø¯Ù‡ÙŠ Ù‚Ø¨Ù„ÙŠ',0),(241924,6721,'tr','Vadesi geÃ§miÅŸ',0),(241925,6721,'pl','ZadÅ‚uÅ¼one',0),(241926,6721,'bg','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸',0),(241927,6721,'ur','Ù…Ø§Ø¶ÛŒ Ú©Û’ Ù…Ù‚Ø±Ø±Û',0),(241928,6721,'sr','Ð˜ÑÑ‚ÐµÐºÐ»Ðµ',0),(241929,6721,'vi','QuÃ¡ háº¡n',0),(241930,6721,'af','Verby die vervaldatum',0),(241931,6721,'ro','Trecut datorate',0),(241932,6721,'et','TÃ¤htaja Ã¼letanud',0),(241933,6721,'si','Pretekle zapadle',0),(241934,6721,'ba','Tagihan yang jatuh tempo',0),(241935,6721,'nl','Achterstallig',0),(241936,6721,'fi','ErÃ¤Ã¤ntyneet',0),(241937,6721,'no','Forfalt',0),(241938,6721,'da','Forfaldne',0),(241939,6721,'ko','ê¸°í•œì´ ì§€ë‚œ',0),(241940,6721,'he','×‘×¢×‘×¨ ×‘×©×œ',0),(241941,6721,'el','ÎšÎ±Î¸Ï…ÏƒÏ„Î­ÏÎ·ÏƒÎ·',0),(241942,6721,'zh','é€¾æœŸ\r\n',0),(241943,6721,'sv','FÃ¶rfallna',0),(241944,6721,'it','Scadute',0),(241945,6721,'tl','',0),(241946,6721,'th','&#3594;&#3656;&#3623;&#3591;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634;',0),(241947,6721,'hi','à¤…à¤¤à¥€à¤¤ à¤•à¥‡ à¤•à¤¾à¤°à¤£',0),(241948,6721,'ms','Lepas habis tempoh',0),(241949,6721,'ar','Ø§Ù„Ù…ØªØ£Ø®Ø±',0),(241950,6721,'fr','En souffrance',0),(241951,6721,'jp','å»¶æ»ž',0),(241952,6721,'pt','Vencidas',0),(241953,6721,'ru','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ',0),(241954,6721,'es','Impago',0),(241955,6721,'de','ÃœberfÃ¤llig',0),(241956,6721,'en','Past Due',0),(241957,6722,'is','',0),(241958,6722,'dr','Ø´Ø±ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(241959,6722,'pr','Ø´Ø±ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(241960,6722,'tr','Ã–deme baÅŸlamak',0),(241961,6722,'pl','RozpoczÄ…Ä‡ pÅ‚atnoÅ›ci',0),(241962,6722,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(241963,6722,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø´Ø±ÙˆØ¹',0),(241964,6722,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(241965,6722,'vi','Báº¯t Ä‘áº§u thanh toÃ¡n',0),(241966,6722,'af','Begin Betaling',0),(241967,6722,'ro','ÃŽncepe plata',0),(241968,6722,'et','Alusta makset',0),(241969,6722,'si','ZaÄeti plaÄilo',0),(241970,6722,'ba','Mulai pembayaran',0),(241971,6722,'nl','Begin betaling',0),(241972,6722,'fi','Alkaa maksun',0),(241973,6722,'no','Starte betaling',0),(241974,6722,'da','Starte udbetaling',0),(241975,6722,'ko','ê²°ì œ ì‹œìž‘',0),(241976,6722,'he','×ª×©×œ×•× ×‘×’×™×Ÿ',0),(241977,6722,'el','ÎˆÎ½Î±ÏÎ¾Î· Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(241978,6722,'zh','å¼€å§‹ä»˜æ¬¾\r\n',0),(241979,6722,'sv','BÃ¶rja betalning',0),(241980,6722,'it','Iniziare a pagamento',0),(241981,6722,'tl','',0),(241982,6722,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(241983,6722,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¥à¤°à¥‚ à¤¹à¥‹',0),(241984,6722,'ms','Memulakan pembayaran',0),(241985,6722,'ar','Ø§Ù„Ø¨Ø¯Ø¡ Ø¨Ø§Ù„Ø¯ÙØ¹',0),(241986,6722,'fr','Commencer le paiement',0),(241987,6722,'jp','æ”¯çµ¦ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(241988,6722,'pt','Iniciar o pagamento',0),(241989,6722,'ru','ÐÐ°Ñ‡Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(241990,6722,'es','Iniciar Pago',0),(241991,6722,'de','BEGIN Zahlung',0),(241992,6722,'en','Begin Payment',0),(241993,6723,'is','',0),(241994,6723,'dr','Ù¾Ø§ÙŠØ§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª',0),(241995,6723,'pr','Ù¾Ø§ÙŠØ§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª',0),(241996,6723,'tr','Son Ã¶deme',0),(241997,6723,'pl','Koniec pÅ‚atnoÅ›ci',0),(241998,6723,'bg','ÐšÑ€Ð°Ð¹ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(241999,6723,'ur','Ø¢Ø®Ø± Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(242000,6723,'sr','ÐšÑ€Ð°Ñ˜ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(242001,6723,'vi','Káº¿t thÃºc thanh toÃ¡n',0),(242002,6723,'af','Finale Betaling',0),(242003,6723,'ro','SfÃ¢rÅŸitul de platÄƒ',0),(242004,6723,'et','LÃµpuks makse',0),(242005,6723,'si','Namen plaÄila',0),(242006,6723,'ba','Pembayaran akhir',0),(242007,6723,'nl','Einde betaling',0),(242008,6723,'fi','Lopulta maksu',0),(242009,6723,'no','Slutten betaling',0),(242010,6723,'da','Ende betaling',0),(242011,6723,'ko','ìµœì¢… ê²°ì œ',0),(242012,6723,'he','×”×ª×©×œ×•× ×§×¦×”',0),(242013,6723,'el','Î¤Î­Î»Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(242014,6723,'zh','ç»“ä»˜',0),(242015,6723,'sv','Slutet betalning',0),(242016,6723,'it','Termine di pagamento',0),(242017,6723,'tl','',0),(242018,6723,'th','&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(242019,6723,'hi','à¤…à¤‚à¤¤ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(242020,6723,'ms','Pembayaran akhir',0),(242021,6723,'ar','Ø§Ù„Ø¯ÙØ¹ Ù†Ù‡Ø§ÙŠØ©',0),(242022,6723,'fr','Paiement fin',0),(242023,6723,'jp','æœ€å¾Œã®ãŠæ”¯æ‰•ã„',0),(242024,6723,'pt','Pagamento final',0),(242025,6723,'ru','ÐšÐ¾Ð½ÐµÑ† Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(242026,6723,'es','Pago Final',0),(242027,6723,'de','Ende Bezahlung',0),(242028,6723,'en','End Payment',0),(242029,6724,'is','',0),(242030,6724,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(242031,6724,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(242032,6724,'tr','SatÄ±ÅŸ temsilcisi seÃ§in',0),(242033,6724,'pl','Wybierz sprzedawca',0),(242034,6724,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(242035,6724,'ur','Ù¾Ø±Ø³Ù† Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(242036,6724,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(242037,6724,'vi','Chá»n nhÃ¢n viÃªn kinh doanh',0),(242038,6724,'af','Selekteer Verkoopspersoneel',0),(242039,6724,'ro','SelectaÅ£i vÃ¢nzÄƒri',0),(242040,6724,'et','Vali mÃ¼Ã¼gimees',0),(242041,6724,'si','Izberite prodajalca',0),(242042,6724,'ba','Pilih Penjual',0),(242043,6724,'nl','Selecteer verkoper',0),(242044,6724,'fi','Valitse myyjÃ¤',0),(242045,6724,'no','Velg selger',0),(242046,6724,'da','VÃ¦lg sÃ¦lger',0),(242047,6724,'ko','ì˜ì—… ì‚¬ì› ì„ íƒ',0),(242048,6724,'he','×‘×—×¨ ××™×© ×ž×›×™×¨×•×ª',0),(242049,6724,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€Ï‰Î»Î·Ï„Î®',0),(242050,6724,'zh','é€‰æ‹©åº—å‘˜\r\n',0),(242051,6724,'sv','Markera sÃ¤ljare',0),(242052,6724,'it','Selezionare agente',0),(242053,6724,'tl','',0),(242054,6724,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(242055,6724,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯à¤•à¤°à¥à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(242056,6724,'ms','Pilih jurujual',0),(242057,6724,'ar','Ø­Ø¯Ø¯ Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(242058,6724,'fr','SÃ©lectionnez vendeur',0),(242059,6724,'jp','å–¶æ¥­æ‹…å½“è€…ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(242060,6724,'pt','Selecione o vendedor',0),(242061,6724,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(242062,6724,'es','Seleccionar Vendedor',0),(242063,6724,'de','WÃ¤hlen Sie VerkÃ¤ufer',0),(242064,6724,'en','Select Salesperson',0),(242065,6725,'is','',0),(242066,6725,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(242067,6725,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(242068,6725,'tr','Hizmet Rep seÃ§in',0),(242069,6725,'pl','Wybierz usÅ‚ugi Rep',0),(242070,6725,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»',0),(242071,6725,'ur','Ø¬Ù…ÛÙˆØ±ÛŒÛ Ø®Ø¯Ù…Øª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(242072,6725,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ‚ÐµÑ€Ð°',0),(242073,6725,'vi','Chá»n ngÆ°á»i phá»¥c vá»¥',0),(242074,6725,'af','Kies Diens Verteenwoordiger',0),(242075,6725,'ro','SelectaÅ£i serviciul Rep',0),(242076,6725,'et','Valige teenuse Rep',0),(242077,6725,'si','Izberite storitev Rep',0),(242078,6725,'ba','Pilih Service Rep',0),(242079,6725,'nl','Selecteer Service Rep',0),(242080,6725,'fi','Valitse edustaja',0),(242081,6725,'no','Velg Service Rep',0),(242082,6725,'da','VÃ¦lg Service Rep',0),(242083,6725,'ko','ì„œë¹„ìŠ¤ ë‹´ë‹¹ìž ì„ íƒ',0),(242084,6725,'he','×‘×—×¨ × ×¦×™×’ ×©×™×¨×•×ª',0),(242085,6725,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï…Ï†Î¬ÏƒÎ¼Î±Ï„ÏŒÏ‚ ÏƒÎ±Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±',0),(242086,6725,'zh','é€‰æ‹©æœåŠ¡ä»£è¡¨\r\n',0),(242087,6725,'sv','VÃ¤lj tjÃ¤nst Rep',0),(242088,6725,'it','Selezionare il servizio Rep',0),(242089,6725,'tl','',0),(242090,6725,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(242091,6725,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(242092,6725,'ms','Pilih wakil Perkhidmatan',0),(242093,6725,'ar','Ø­Ø¯Ø¯ Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ø®Ø¯Ù…Ø©',0),(242094,6725,'fr','SÃ©lectionnez Service Rep',0),(242095,6725,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ‹…å½“è€…ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(242096,6725,'pt','Selecione o representante de serviÃ§o',0),(242097,6725,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Rep',0),(242098,6725,'es','Seleccionar Reresentante de Servicio',0),(242099,6725,'de','WÃ¤hlen Sie Service Rep',0),(242100,6725,'en','Select Service Rep',0),(242101,6726,'is','',0),(242102,6726,'dr','ÙÙ‚Ø· Ù…Ø¬Ù…ÙˆØ¹ ',0),(242103,6726,'pr','ÙÙ‚Ø· Ù…Ø¬Ù…ÙˆØ¹ ',0),(242104,6726,'tr','YalnÄ±zca toplam',0),(242105,6726,'pl','ÅÄ…cznie tylko',0),(242106,6726,'bg','ÐžÐ±Ñ‰Ð¾ ÑÐ°Ð¼Ð¾',0),(242107,6726,'ur','ØµØ±Ù Ú©Ù„',0),(242108,6726,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÑÐ°Ð¼Ð¾',0),(242109,6726,'vi','Chá»‰ Tá»•ng cá»™ng ',0),(242110,6726,'af','Totale Alleenlik',0),(242111,6726,'ro','Total numai',0),(242112,6726,'et','Kokku ainult',0),(242113,6726,'si','Skupaj samo',0),(242114,6726,'ba','Total hanya',0),(242115,6726,'nl','Totaal alleen',0),(242116,6726,'fi','Vain summa',0),(242117,6726,'no','Totalt bare',0),(242118,6726,'da','Alt kun',0),(242119,6726,'ko','ì´ë§Œ',0),(242120,6726,'he','×¡×” ×› ×¨×§',0),(242121,6726,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î¼ÏŒÎ½Î¿',0),(242122,6726,'zh','æ€»å…±åªæœ‰\r\n',0),(242123,6726,'sv','Totalt endast',0),(242124,6726,'it','Totale solo',0),(242125,6726,'tl','',0),(242126,6726,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3612;&#3621;&#3619;&#3623;&#3617;',0),(242127,6726,'hi','à¤•à¥à¤² à¤•à¥‡à¤µà¤²',0),(242128,6726,'ms','Jumlah keseluruhan hanya',0),(242129,6726,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ ÙÙ‚Ø·',0),(242130,6726,'fr','Total seulement',0),(242131,6726,'jp','åˆè¨ˆã®ã¿',0),(242132,6726,'pt','Total apenas',0),(242133,6726,'ru','Ð’ÑÐµÐ³Ð¾ Ð»Ð¸ÑˆÑŒ',0),(242134,6726,'es','Solo Total',0),(242135,6726,'de','Insgesamt nur',0),(242136,6726,'en','Total Only',0),(242137,6727,'is','',0),(242138,6727,'dr','Ù†Ù…Ø§ÙŠØ´ â€“ Ú†Ø§Ù¾ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù‡Ø§',0),(242139,6727,'pr','Ù†Ù…Ø§ÙŠØ´ â€“ Ú†Ø§Ù¾ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù‡Ø§',0),(242140,6727,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ yazdÄ±rma deyimleri',0),(242141,6727,'pl','Widok Print instrukcji',0),(242142,6727,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(242143,6727,'ur','Ù…Ù†Ø¸Ø± Ú†Ú¾Ø§Ù¾ÛŒÚº Ø¨ÛŒØ§Ù†Ø§Øª',0),(242144,6727,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· -ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(242145,6727,'vi','Xem-In sao kÃª',0),(242146,6727,'af','Besigtig-Druk State',0),(242147,6727,'ro','Vezi-imprimare declaraÅ£ii',0),(242148,6727,'et','Vaata-Prindi vÃ¤ljavÃµtteid',0),(242149,6727,'si','Pogled Print izjave',0),(242150,6727,'ba','Lihat-Cetak laporan',0),(242151,6727,'nl','Weergave-Print verklaringen',0),(242152,6727,'fi','NÃ¤ytÃ¤ Tulosta tiliotteet',0),(242153,6727,'no','Vis-Print uttalelser',0),(242154,6727,'da','Se-Print udtalelser',0),(242155,6727,'ko','ë³´ê¸° ì¸ì‡„ ë¬¸ì˜',0),(242156,6727,'he','×”×¦×’-×”×“×¤×¡ ×”×¦×”×¨×•×ª',0),(242157,6727,'el','Î”Î·Î»ÏŽÏƒÎµÎ¹Ï‚ View-Print',0),(242158,6727,'zh','æŸ¥çœ‹-æ‰“å°è¯­å¥\r\n',0),(242159,6727,'sv','Visa-Print uttalanden',0),(242160,6727,'it','Vista Print dichiarazioni',0),(242161,6727,'tl','',0),(242162,6727,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;-&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(242163,6727,'hi','à¤¦à¥‡à¤–à¥‡à¤‚-à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤¬à¤¯à¤¾à¤¨',0),(242164,6727,'ms','Paparan cetak penyata',0),(242165,6727,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø·Ø±ÙŠÙ‚Ø© Ø¹Ø±Ø¶ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(242166,6727,'fr','Visualiser-imprimer des dÃ©clarations',0),(242167,6727,'jp','è¡¨ç¤ºå°åˆ·ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆ',0),(242168,6727,'pt','InstruÃ§Ãµes Print-vista',0),(242169,6727,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€-ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(242170,6727,'es','Visionar-Imprimir Declaraciones',0),(242171,6727,'de','View-Print-Anweisungen',0),(242172,6727,'en','View/Print Statements',0),(242173,6728,'is','',0),(242174,6728,'dr','Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(242175,6728,'pr','Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(242176,6728,'tr','SatÄ±cÄ± iÃ§in',0),(242177,6728,'pl','Dla sprzedawcy',0),(242178,6728,'bg','Ð—Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(242179,6728,'ur','Ú©Û’ Ù„Ø¦Û’ Ø¨Ù†Ø§Ú©Ø±',0),(242180,6728,'sr','Ð—Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(242181,6728,'vi','Cho nhÃ¢n viÃªn kinh doanh',0),(242182,6728,'af','Vir verkoopspersoon',0),(242183,6728,'ro','Pentru vanzator',0),(242184,6728,'et','MÃ¼Ã¼ja kohta',0),(242185,6728,'si','Za prodajalec',0),(242186,6728,'ba','Untuk Penjual',0),(242187,6728,'nl','Voor verkoper',0),(242188,6728,'fi','MyyjittÃ¤in',0),(242189,6728,'no','For selger',0),(242190,6728,'da','For sÃ¦lger',0),(242191,6728,'ko','ì„¸ì¼ì¦ˆ ë§¨ì— ëŒ€ í•œ',0),(242192,6728,'he','×¢×‘×•×¨ ×¡×•×›×Ÿ ×ž×›×™×¨×•×ª',0),(242193,6728,'el','Î“Î¹Î± Ï€Ï‰Î»Î·Ï„Î®Ï‚',0),(242194,6728,'zh','å¯¹äºŽæŽ¨é”€å‘˜\r\n',0),(242195,6728,'sv','FÃ¶r sÃ¤ljare',0),(242196,6728,'it','Per venditore',0),(242197,6728,'tl','',0),(242198,6728,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(242199,6728,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤',0),(242200,6728,'ms','Bagi jurujual',0),(242201,6728,'ar','Ù„Ø¨Ø§Ø¦Ø¹',0),(242202,6728,'fr','Pour le vendeur',0),(242203,6728,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³ã®',0),(242204,6728,'pt','Para vendedor',0),(242205,6728,'ru','Ð”Ð»Ñ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(242206,6728,'es','Para Proveedor',0),(242207,6728,'de','FÃ¼r VerkÃ¤ufer',0),(242208,6728,'en','For Salesman',0),(242209,6729,'is','',0),(242210,6729,'dr','Ø¨Ø±Ø§ÙŠ Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(242211,6729,'pr','Ø¨Ø±Ø§ÙŠ Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(242212,6729,'tr','Hizmet Rep iÃ§in',0),(242213,6729,'pl','Dla usÅ‚ugi Rep',0),(242214,6729,'bg','Ð—Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»',0),(242215,6729,'ur','Ø®Ø¯Ù…Øª Ø¬Ù…ÛÙˆØ±ÛŒÛ Ú©Û’ Ù„Ø¦Û’',0),(242216,6729,'sr','Ð—Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ‚ÐµÑ€Ð°',0),(242217,6729,'vi','Cho Ä‘áº¡i diá»‡n dá»‹ch vá»¥',0),(242218,6729,'af','Vir Diens Verteenwoordiger',0),(242219,6729,'ro','Pentru Service Rep',0),(242220,6729,'et','Teenuse Rep',0),(242221,6729,'si','Za Rep storitve',0),(242222,6729,'ba','Untuk Service Rep',0),(242223,6729,'nl','Voor Service Rep',0),(242224,6729,'fi','Asepalvelus ripsi',0),(242225,6729,'no','For Service Rep',0),(242226,6729,'da','For Service Rep',0),(242227,6729,'ko','ì„œë¹„ìŠ¤ ë‹´ë‹¹ìžì— ëŒ€ í•œ',0),(242228,6729,'he','×¢×‘×•×¨ × ×¦×™×’ ×©×™×¨×•×ª',0),(242229,6729,'el','Î“Î¹Î± Ï„Î¿ ÏÏ†Î±ÏƒÎ¼Î± ÎµÎ¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ·Ï‚',0),(242230,6729,'zh','å¯¹äºŽæœåŠ¡ä»£è¡¨\r\n',0),(242231,6729,'sv','FÃ¶r tjÃ¤nst Rep',0),(242232,6729,'it','Per servizio Rep',0),(242233,6729,'tl','',0),(242234,6729,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3586;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(242235,6729,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿',0),(242236,6729,'ms','Untuk wakil Perkhidmatan',0),(242237,6729,'ar','Ù„Ù…Ù†Ø¯ÙˆØ¨ Ø®Ø¯Ù…Ø©',0),(242238,6729,'fr','Pour le reprÃ©sentant de Service',0),(242239,6729,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ‹…å½“è€…ç”¨',0),(242240,6729,'pt','Para o representante de serviÃ§o',0),(242241,6729,'ru','Ð”Ð»Ñ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Rep',0),(242242,6729,'es','Para Rep de Servicios',0),(242243,6729,'de','FÃ¼r Service-Rep',0),(242244,6729,'en','For Service Rep',0),(242245,6730,'is','',0),(242246,6730,'dr','(Ù…Ø´ØºÙˆÙ„',0),(242247,6730,'pr','Ù…Ø¹ÙˆÙ‚ Ùˆ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡ (Ù…Ø´ØºÙˆÙ„',0),(242248,6730,'tr','Beklemede veya alÄ±nan',0),(242249,6730,'pl','OczekujÄ…ce lub podjÄ™te',0),(242250,6730,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ð¸Ð»Ð¸ Ð²Ð·ÐµÑ‚Ð¸',0),(242251,6730,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ ÛŒØ§ Ù„ÛŒØ§',0),(242252,6730,'sr','ÐÐ° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð¸Ð»Ð¸ Ð´Ð° Ð½Ð¾ÑÐ¸Ð¼',0),(242253,6730,'vi','Äang treo hay Ä‘Ã£ láº¥y',0),(242254,6730,'af','Afwagtend of Geneem',0),(242255,6730,'ro','ÃŽn aÈ™teptare sau luate',0),(242256,6730,'et','Ootel vÃµi vÃµetud',0),(242257,6730,'si','ÄŒakajoÄe ali sprejeti',0),(242258,6730,'ba','Tertunda atau diambil',0),(242259,6730,'nl','Lopende of genomen',0),(242260,6730,'fi','VireillÃ¤ tai otettu',0),(242261,6730,'no','Ventende eller tatt',0),(242262,6730,'da','Ventende eller taget',0),(242263,6730,'ko','ë³´ë¥˜ ì¤‘ ë˜ëŠ” ì´¬ì˜',0),(242264,6730,'he','×ž×ž×ª×™× ×•×ª ××• × ×œ×§×—',0),(242265,6730,'el','Î£Îµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± Î® Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹',0),(242266,6730,'zh','å¾…åŠžæˆ–é‡‡å–\r\n',0),(242267,6730,'sv','VÃ¤ntande eller tas',0),(242268,6730,'it','In sospeso o presi',0),(242269,6730,'tl','',0),(242270,6730,'th','&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;&#3627;&#3619;&#3639;&#3629;&#3652;&#3604;&#3657;&#3607;&#3635;&#3652;&#3611;&#3649;&#3621;&#3657;&#3623;',0),(242271,6730,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¯à¤¾ à¤²à¤¿à¤¯à¤¾',0),(242272,6730,'ms','Belum selesai atau diambil',0),(242273,6730,'ar','Ù…Ø¹Ù„Ù‚Ø© Ø£Ùˆ Ø§Ù„Ù…ØªØ®Ø°Ø©',0),(242274,6730,'fr','En attente ou prises',0),(242275,6730,'jp','ä¿ç•™ä¸­ã¾ãŸã¯æ’®å½±',0),(242276,6730,'pt','Pendente ou tomadas',0),(242277,6730,'ru','ÐžÑ‚Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ðµ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¸Ð½ÑÑ‚Ñ‹Ñ…',0),(242278,6730,'es','Pendiente o Tomado',0),(242279,6730,'de','Ausstehende oder genommen',0),(242280,6730,'en','Pending or Taken',0),(242281,6731,'is','',0),(242282,6731,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø«Ø§Ø¨Øª',0),(242283,6731,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø«Ø§Ø¨Øª',0),(242284,6731,'tr','Belirli bir satÄ±ÅŸ temsilcisi',0),(242285,6731,'pl','SzczegÃ³lnych sprzedawcy',0),(242286,6731,'bg','ÐšÐ¾Ð½ÐºÑ€ÐµÑ‚ÐµÐ½ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(242287,6731,'ur','Ù…Ø®ØµÙˆØµ Ù¾Ø±Ø³Ù†',0),(242288,6731,'sr','ÐžÐ´Ñ€ÐµÑ’ÐµÐ½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(242289,6731,'vi','NhÃ¢n viÃªn kinh doanh cá»¥ thá»ƒ',0),(242290,6731,'af','Spesifieke Verkoopspersoon',0),(242291,6731,'ro','Specifice de vÃ¢nzÄƒri',0),(242292,6731,'et','Kindel mÃ¼Ã¼gimees',0),(242293,6731,'si','DoloÄenega prodajalca',0),(242294,6731,'ba','Penjual tertentu',0),(242295,6731,'nl','Specifieke verkoper',0),(242296,6731,'fi','Tietyn myyjÃ¤n',0),(242297,6731,'no','Bestemt selger',0),(242298,6731,'da','Bestemt sÃ¦lger',0),(242299,6731,'ko','íŠ¹ì • íŒë§¤ì›',0),(242300,6731,'he','××™×© ×ž×›×™×¨×•×ª ×ž×¡×•×™×',0),(242301,6731,'el','Î£Ï…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Ï€Ï‰Î»Î·Ï„Î®',0),(242302,6731,'zh','å…·ä½“çš„é”€å”®äººå‘˜\r\n',0),(242303,6731,'sv','SÃ¤rskilda sÃ¤ljare',0),(242304,6731,'it','Agente specifico',0),(242305,6731,'tl','',0),(242306,6731,'th','&#3619;&#3632;&#3610;&#3640;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(242307,6731,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿',0),(242308,6731,'ms','Jurujual yang tertentu',0),(242309,6731,'ar','Ù…Ù†Ø¯ÙˆØ¨ Ù…Ø¨ÙŠØ¹Ø§Øª Ù…Ø­Ø¯Ø¯Ø©',0),(242310,6731,'fr','Vendeur spÃ©cifique',0),(242311,6731,'jp','ç‰¹å®šã®å–¶æ¥­æ‹…å½“è€…',0),(242312,6731,'pt','Vendedor especÃ­fico',0),(242313,6731,'ru','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ñ‹Ð¹ ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(242314,6731,'es','Vendedor EspecÃ­fico',0),(242315,6731,'de','Bestimmten VerkÃ¤ufer',0),(242316,6731,'en','Specific Salesperson',0),(242317,6732,'is','',0),(242318,6732,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø«Ø§Ø¨Øª',0),(242319,6732,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø«Ø§Ø¨Øª',0),(242320,6732,'tr','Ã–zel hizmet Rep',0),(242321,6732,'pl','SzczegÃ³lne usÅ‚ugi Rep',0),(242322,6732,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ð¸ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»',0),(242323,6732,'ur','Ù…Ø®ØµÙˆØµ Ø®Ø¯Ù…Øª Ø¬Ù…ÛÙˆØ±ÛŒÛ',0),(242324,6732,'sr','Ð¡Ð¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ‚ÐµÑ€Ð°',0),(242325,6732,'vi','NhÃ¢n viÃªn dá»‹ch vá»¥ cá»¥ thá»ƒ',0),(242326,6732,'af','Spesifieke Diens Verteenwoordiger',0),(242327,6732,'ro','Rep de servicii specifice',0),(242328,6732,'et','Konkreetse teenuse Rep',0),(242329,6732,'si','Posebne storitve Rep',0),(242330,6732,'ba','Perwakilan layanan khusus',0),(242331,6732,'nl','Specifieke Service Rep',0),(242332,6732,'fi','Erityinen edustaja',0),(242333,6732,'no','Spesifikke Service Rep',0),(242334,6732,'da','Specifikke Service Rep',0),(242335,6732,'ko','íŠ¹ì • ì„œë¹„ìŠ¤ ë‹´ë‹¹ìž',0),(242336,6732,'he','× ×¦×™×’ ×©×™×¨×•×ª ×¡×¤×¦×™×¤×™',0),(242337,6732,'el','Î•Î¹Î´Î¹ÎºÏŒ ÏÏ†Î±ÏƒÎ¼Î± ÎµÎ¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ·Ï‚',0),(242338,6732,'zh','å…·ä½“æœåŠ¡ä»£è¡¨\r\n',0),(242339,6732,'sv','Specifika tjÃ¤nst Rep',0),(242340,6732,'it','Specifico servizio Rep',0),(242341,6732,'tl','',0),(242342,6732,'th','&#3619;&#3632;&#3610;&#3640;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3586;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(242343,6732,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿',0),(242344,6732,'ms','Wakil Perkhidmatan khusus',0),(242345,6732,'ar','Ù…Ù†Ø¯ÙˆØ¨ Ø®Ø¯Ù…Ø© Ù…Ø­Ø¯Ø¯Ø©',0),(242346,6732,'fr','ReprÃ©sentant de Service spÃ©cifiques',0),(242347,6732,'jp','ç‰¹å®šã®ã‚µãƒ¼ãƒ“ã‚¹æ‹…å½“è€…',0),(242348,6732,'pt','Representante de serviÃ§o especÃ­fico',0),(242349,6732,'ru','ÐšÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ñ‹Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸ Ñ€ÐµÑÐ¿',0),(242350,6732,'es','Rep. de Servicio EspecÃ­fico',0),(242351,6732,'de','Spezifische Service Rep',0),(242352,6732,'en','Specific Service Rep',0),(242353,6733,'is','',0),(242354,6733,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø²Ù…Ø§Ù† ØªØºÙŠÙŠØ±  Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§',0),(242355,6733,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø²Ù…Ø§Ù† ØªØºÙŠÙŠØ±  Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§',0),(242356,6733,'tr','SMM miktarÄ± sipariÅŸ Ã¶ÄŸe iÃ§in deÄŸiÅŸtirmek zaman kontrol',0),(242357,6733,'pl','Sprawdzanie kÃ³Å‚ zÄ™batych, zmieniajÄ…c iloÅ›Ä‡ na zamÃ³wienie',0),(242358,6733,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¦ÐŸÐŸ Ð¿Ñ€Ð¸ ÑÐ¼ÑÐ½Ð° Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(242359,6733,'ur','Ú©Ø§ÙˆÚ¯Ø³ Ù…ÛŒÚº Ù…Ù‚Ø¯Ø§Ø± ØªØ±ØªÛŒØ¨ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Ø§ Ø¬Ø¨ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Û”',0),(242360,6733,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¢ÐŸÐ  Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¼ÐµÑšÐ°ÑšÐ° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(242361,6733,'vi','Kiá»ƒm tra giÃ¡ thÃ nh hÃ ng bÃ¡n khi thay Ä‘á»•i sá»‘ lÆ°á»£ng Ä‘áº·t hÃ ng',0),(242362,6733,'af','Merk COGS Wanneer Hoeveelheid vir Bestellingsitem Verander',0),(242363,6733,'ro','Verifica CBV atunci cÃ¢nd schimbÄƒ cantitatea pentru ordin elementul',0),(242364,6733,'et','Kontrollige OMAHINNAD toredatele kogus vahetamisel',0),(242365,6733,'si','Preverite VZVODI, ko spreminja koliÄina za naroÄilo artiklov',0),(242366,6733,'ba','Memeriksa roda ketika mengubah kuantitas untuk memesan Item',0),(242367,6733,'nl','KPV controleren bij het wijzigen van de hoeveelheid voor bestelling Item',0),(242368,6733,'fi','Tarkistaa hampaat, kun tilauksen nimikkeen mÃ¤Ã¤rÃ¤n muuttamisesta',0),(242369,6733,'no','Sjekk COGS nÃ¥r endre antallet for ordreelement',0),(242370,6733,'da','Tjekke tÃ¦nder, nÃ¥r du Ã¦ndrer mÃ¦ngden for ordrevare',0),(242371,6733,'ko','ì£¼ë¬¸ í•­ëª©ì— ëŒ€ í•œ ìˆ˜ëŸ‰ì„ ë³€ê²½ í•˜ëŠ” ê²½ìš° ë§¤ì¶œ ì›ê°€ í™•ì¸',0),(242372,6733,'he','×‘×“×•×§ ××ª ×’×œ×’×œ×™ ×”×©×™× ×™×™× ×‘×¢×ª ×©×™× ×•×™ ×›×ž×•×ª ×¢×‘×•×¨ ×¤×¨×™×˜ ×¡×“×¨',0),(242373,6733,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î Î©Î›Î—Î˜ÎˆÎÎ¤Î©Î ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î»Î»Î±Î³Î® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±Ï‚, Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(242374,6733,'zh','å½“æ›´æ”¹è®¢å•é¡¹ç›®æ•°é‡æ£€æŸ¥é”€å”®æˆæœ¬æ—¶\r\n',0),(242375,6733,'sv','Kontrollera KSV nÃ¤r du Ã¤ndrar kvantiteten fÃ¶r artikeln pÃ¥ i ordern',0),(242376,6733,'it','Controllo ingranaggi quando si cambia la quantitÃ  per elemento di ordine',0),(242377,6733,'tl','',0),(242378,6733,'th','Check COGS When Changing Quantity for Order Item',0),(242379,6733,'hi','COGS à¤•à¥à¤°à¤® à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¬à¤¦à¤²à¤¤à¥‡ à¤¸à¤®à¤¯ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(242380,6733,'ms','Semak salah satu alat apabila menukar kuantiti bagi Item pesanan',0),(242381,6733,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ØªØ±ÙˆØ³ Ø¹Ù†Ø¯ ØªØºÙŠÙŠØ± Ø§Ù„ÙƒÙ…ÙŠØ© Ù„ØµÙ†Ù Ø£Ù…Ø±',0),(242382,6733,'fr','VÃ©rifier les dents lorsque vous modifiez la quantitÃ© pour Ã©lÃ©ment de commande',0),(242383,6733,'jp','å—æ³¨å“ç›®ã®æ•°é‡ã‚’å¤‰æ›´ã™ã‚‹ã¨ãã«ã‚³ã‚°ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(242384,6733,'pt','SeleÃ§Ã£o COGS ao mudar a quantidade para o Item da ordem',0),(242385,6733,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð²Ð¸Ð½Ñ‚Ð¸ÐºÐ¸, Ð¿Ñ€Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(242386,6733,'es','Chequear COGS Cuando Cambiando la Cantidad por Item de Pedido',0),(242387,6733,'de','COGS zu Ã¼berprÃ¼fen, wenn die Menge fÃ¼r Bestellposition Ã¤ndern',0),(242388,6733,'en','Check COGS When Changing Quantity for Order Item',0),(242389,6734,'is','',0),(242390,6734,'dr','ÙŠØ§  ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø®Ø· ÙƒØ§Ù„Ø§',0),(242391,6734,'pr','ÙŠØ§  ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø®Ø· ÙƒØ§Ù„Ø§',0),(242392,6734,'tr','Ya da kalem notlarÄ±',0),(242393,6734,'pl','Lub pozycji Notes',0),(242394,6734,'bg','Ð˜Ð»Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(242395,6734,'ur','ÛŒØ§ Ù„Ø§Ø¦Ù† Ø´Û’ Ù†ÙˆÙ¹',0),(242396,6734,'sr','Ð˜Ð»Ð¸ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(242397,6734,'vi','hay Ghi chÃº dÃ²ng hÃ ng',0),(242398,6734,'af','Of Lynitem Nota\'s',0),(242399,6734,'ro','Sau notele de element rÃ¢nd',0),(242400,6734,'et','VÃµi Ã¼ksuse mÃ¤rkmed',0),(242401,6734,'si','Ali postavko opombe',0),(242402,6734,'ba','Atau catatan Item baris',0),(242403,6734,'nl','Of regelitem notities',0),(242404,6734,'fi','Tai rivinimikkeen muistiinpanoja',0),(242405,6734,'no','Eller linje',0),(242406,6734,'da','Eller linjeelement noter',0),(242407,6734,'ko','ë˜ëŠ” í’ˆëª© ë©”ëª¨',0),(242408,6734,'he','××• ×¤×¨×™×˜ ×©×•×¨×” ×”×¢×¨×•×ª',0),(242409,6734,'el','Î‰ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(242410,6734,'zh','æˆ–è¡Œé¡¹ç›®è¯´æ˜Ž\r\n',0),(242411,6734,'sv','Eller radartikel anteckningar',0),(242412,6734,'it','O linea voce note',0),(242413,6734,'tl','',0),(242414,6734,'th','&#3627;&#3619;&#3639;&#3629;&#3648;&#3626;&#3657;&#3609;&#3649;&#3610;&#3656;&#3591;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(242415,6734,'hi','à¤¯à¤¾ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤¨à¥‹à¤Ÿà¥à¤¸',0),(242416,6734,'ms','Atau Nota barang talian',0),(242417,6734,'ar','Ø£Ùˆ Ø¨Ù†Ø¯ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(242418,6734,'fr','Ou rubrique Notes',0),(242419,6734,'jp','ã¾ãŸã¯ãƒ©ã‚¤ãƒ³é …ç›®ã®ãƒ¡ãƒ¢',0),(242420,6734,'pt','Ou notas de Item de linha',0),(242421,6734,'ru','Ð˜Ð»Ð¸ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(242422,6734,'es','O Notas de Item de Linea',0),(242423,6734,'de','Oder Positionszeile Notes',0),(242424,6734,'en','Or Line Item Notes',0),(242425,6735,'is','',0),(242426,6735,'dr','Ø§Ø¹Ù„Ø§Ù… Ø­Ù…Ù„ ',0),(242427,6735,'pr','Ø§Ø¹Ù„Ø§Ù… Ø­Ù…Ù„ ',0),(242428,6735,'tr','Gemi bildirim',0),(242429,6735,'pl','Powiadomienia statku',0),(242430,6735,'bg','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð°',0),(242431,6735,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹',0),(242432,6735,'sr','ÐžÐ±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµ Ð¾ Ð±Ñ€Ð¾Ð´Ñƒ',0),(242433,6735,'vi','ThÃ´ng bÃ¡o chuyá»ƒn hÃ ng',0),(242434,6735,'af','Versend Kennisgewing',0),(242435,6735,'ro','NavÄƒ de notificare',0),(242436,6735,'et','Laevade teatamine',0),(242437,6735,'si','Ladja obvestila',0),(242438,6735,'ba','Kapal pemberitahuan',0),(242439,6735,'nl','Schip kennisgeving',0),(242440,6735,'fi','Alukselta ilmoituksen',0),(242441,6735,'no','Sende melding',0),(242442,6735,'da','Skibet anmeldelse',0),(242443,6735,'ko','ë°° ì•Œë¦¼',0),(242444,6735,'he','×”×•×“×¢×” ×¢×œ ×”×¡×¤×™× ×”',0),(242445,6735,'el','ÎšÎ¿Î¹Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï€Î»Î¿Î¯Î¿',0),(242446,6735,'zh','è¿é€é€šçŸ¥\r\n',0),(242447,6735,'sv','Fartyget anmÃ¤lan',0),(242448,6735,'it','Notifica di nave',0),(242449,6735,'tl','',0),(242450,6735,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(242451,6735,'hi','à¤œà¤¹à¤¾à¤œ à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾',0),(242452,6735,'ms','Pemberitahuan kapal',0),(242453,6735,'ar','Ø¥Ø¹Ù„Ø§Ù… Ø§Ù„Ø³ÙÙ†',0),(242454,6735,'fr','Notification de navire',0),(242455,6735,'jp','å‡ºè·é€šçŸ¥',0),(242456,6735,'pt','NotificaÃ§Ã£o de navio',0),(242457,6735,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(242458,6735,'es','Enviar NotificaciÃ³n',0),(242459,6735,'de','Schiff-Benachrichtigung',0),(242460,6735,'en','Ship Notification',0),(242461,6736,'is','',0),(242462,6736,'dr','ØªØ®ÙÙŠÙ  Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯Ù‡ ',0),(242463,6736,'pr','ØªØ®ÙÙŠÙ  Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯Ù‡ ',0),(242464,6736,'tr','Uygulanan indirim',0),(242465,6736,'pl','ObniÅ¼ka',0),(242466,6736,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ°Ñ‚Ð°, Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð°',0),(242467,6736,'ur','Ø±Ø¹Ø§ÛŒØª Ú©Ø§ Ø§Ø·Ù„Ø§Ù‚',0),(242468,6736,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚Ð° Ð¿Ñ€Ð¸Ð¼ÐµÑšÐµÐ½Ð¾Ð³',0),(242469,6736,'vi','Ãp dá»¥ng Chiáº¿t kháº¥u',0),(242470,6736,'af','Korting Toegepas',0),(242471,6736,'ro','Discount aplicat',0),(242472,6736,'et','Soodustust kohaldada',0),(242473,6736,'si','Popust uporabljajo',0),(242474,6736,'ba','Diskon diterapkan',0),(242475,6736,'nl','Korting wordt toegepast',0),(242476,6736,'fi','Sovellettu alennus',0),(242477,6736,'no','Rabatt brukes',0),(242478,6736,'da','Rabat, der anvendes',0),(242479,6736,'ko','í• ì¸ ì ìš©',0),(242480,6736,'he','×”× ×—×” ×”×ž×•×—×œ×ª',0),(242481,6736,'el','Î ÏÎ¿ÎµÎ¾ÏŒÏ†Î»Î·ÏƒÎ·Ï‚',0),(242482,6736,'zh','æŠ˜æ‰£åº”ç”¨\r\n',0),(242483,6736,'sv','Rabatt tillÃ¤mpas',0),(242484,6736,'it','Sconto applicato',0),(242485,6736,'tl','',0),(242486,6736,'th','&#3651;&#3594;&#3657;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3649;&#3621;&#3657;&#3623;',0),(242487,6736,'hi','à¤›à¥‚à¤Ÿ à¤²à¤¾à¤—à¥‚ à¤•à¤¿à¤¯à¤¾',0),(242488,6736,'ms','Diskaun yang digunakan',0),(242489,6736,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø®ØµÙ…',0),(242490,6736,'fr','Escompte appliquÃ©',0),(242491,6736,'jp','å‰²å¼•ã‚’é©ç”¨',0),(242492,6736,'pt','Desconto aplicado',0),(242493,6736,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÑÐµÑ‚ÑÑ',0),(242494,6736,'es','Descuento Aplicado',0),(242495,6736,'de','Rabatt angewendet',0),(242496,6736,'en','Discount Applied',0),(242497,6737,'is','',0),(242498,6737,'dr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡',0),(242499,6737,'pr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡',0),(242500,6737,'tr','Ä°ade',0),(242501,6737,'pl','ZwrÃ³cone',0),(242502,6737,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°',0),(242503,6737,'ur','ÙˆØ§Ù¾Ø³ Ú©Ø± Ø¯ÛŒ Ø¬Ø§Û“Ú¯ÛŒ',0),(242504,6737,'sr','Ð’Ñ€Ð°Ñ‚Ð¸',0),(242505,6737,'vi','ÄÃ£ HoÃ n láº¡i',0),(242506,6737,'af','Terugbetaal',0),(242507,6737,'ro','Rambursate',0),(242508,6737,'et','Tagastati',0),(242509,6737,'si','Povrnejo',0),(242510,6737,'ba','Dikembalikan',0),(242511,6737,'nl','Terugbetaald',0),(242512,6737,'fi','Palautetaan',0),(242513,6737,'no','Refundert',0),(242514,6737,'da','Refunderet',0),(242515,6737,'ko','í™˜ë¶ˆ',0),(242516,6737,'he','×”×—×–×¨',0),(242517,6737,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ­Ï†ÎµÏ„Î±Î¹',0),(242518,6737,'zh','é€€æ¬¾\r\n',0),(242519,6737,'sv','Ã…terbetalas',0),(242520,6737,'it','Rimborsato',0),(242521,6737,'tl','',0),(242522,6737,'th','&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;&#3651;&#3627;&#3657;',0),(242523,6737,'hi','à¤µà¤¾à¤ªà¤¸ à¤•à¤¿à¤¯à¤¾',0),(242524,6737,'ms','Dibayar balik',0),(242525,6737,'ar','Ø±Ø¯Ù‡Ø§',0),(242526,6737,'fr','RemboursÃ©',0),(242527,6737,'jp','æ‰•ã„æˆ»ã—',0),(242528,6737,'pt','Reembolsado',0),(242529,6737,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÑ‚ÑÑ',0),(242530,6737,'es','Rehacer Reembolsado',0),(242531,6737,'de','Erstattet',0),(242532,6737,'en','Refunded',0),(242533,6738,'is','',0),(242534,6738,'dr','Ú†Ùƒ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(242535,6738,'pr','Ú†Ùƒ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(242536,6738,'tr','Geri Ã¶deme onay',0),(242537,6738,'pl','Czeku',0),(242538,6738,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð¿Ñ€Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(242539,6738,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©Û’ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(242540,6738,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°',0),(242541,6738,'vi','HoÃ n tráº£ SÃ©c',0),(242542,6738,'af','Terugbetaling kontroleer',0),(242543,6738,'ro','Restituire verifica',0),(242544,6738,'et','Toetuse sisse',0),(242545,6738,'si','Nadomestila potrdite',0),(242546,6738,'ba','Mengembalikan Check',0),(242547,6738,'nl','Restitutie Check',0),(242548,6738,'fi','Hyvityksen sekki',0),(242549,6738,'no','Tilbakebetaling av',0),(242550,6738,'da','Refusion Check',0),(242551,6738,'ko','í™˜ë¶ˆ í™•ì¸',0),(242552,6738,'he','×”×—×–×¨ ×¦\'×§',0),(242553,6738,'el','Î¥Ï€Î¿Î´ÎµÎ¯Î¾ÎµÏ„Îµ',0),(242554,6738,'zh','é€€æ¬¾æ”¯ç¥¨\r\n',0),(242555,6738,'sv','Kontrollera att Ã¥terbetala',0),(242556,6738,'it','Assegno di rimborso',0),(242557,6738,'tl','',0),(242558,6738,'th','&#3648;&#3594;&#3655;&#3588;&#3607;&#3637;&#3656;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;&#3651;&#3627;&#3657;',0),(242559,6738,'hi','à¤šà¥‡à¤• à¤µà¤¾à¤ªà¤¸à¥€',0),(242560,6738,'ms','Cek bayaran balik',0),(242561,6738,'ar','Ø±Ø¯ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(242562,6738,'fr','ChÃ¨que de remboursement',0),(242563,6738,'jp','æ‰•ã„æˆ»ã—ã®ãƒã‚§ãƒƒã‚¯',0),(242564,6738,'pt','Cheque de reembolso',0),(242565,6738,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð¾Ð¼',0),(242566,6738,'es','Cheque de Reembolso',0),(242567,6738,'de','RÃ¼ckerstattungsforderung',0),(242568,6738,'en','Refund Check',0),(242569,6739,'is','',0),(242570,6739,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ù…Ø§ ',0),(242571,6739,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ù…Ø§ ',0),(242572,6739,'tr','Bizim sipariÅŸ numarasÄ±',0),(242573,6739,'pl','Nasz numer zamÃ³wienia',0),(242574,6739,'bg','ÐÐ°ÑˆÐ¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(242575,6739,'ur','ÛÙ…Ø§Ø±Ø§ Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø±',0),(242576,6739,'sr','ÐÐ°Ñˆ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(242577,6739,'vi','Sá»‘ ÄÆ¡n hÃ ng cá»§a chÃºng tÃ´i',0),(242578,6739,'af','Ons Bestelling Nommer',0),(242579,6739,'ro','Nostru numÄƒrul de ordine',0),(242580,6739,'et','Meie tellimuse kood',0),(242581,6739,'si','NaÅ¡a Å¡tevilka naloga',0),(242582,6739,'ba','Nomor pesanan kami',0),(242583,6739,'nl','Onze ordernummer',0),(242584,6739,'fi','Tilauksen numero',0),(242585,6739,'no','VÃ¥re ordrenummer',0),(242586,6739,'da','Vores ordrenummer',0),(242587,6739,'ko','ìš°ë¦¬ì˜ ì£¼ë¬¸ ë²ˆí˜¸',0),(242588,6739,'he','×ž×¡×¤×¨ ×”×”×–×ž× ×” ×©×œ× ×•',0),(242589,6739,'el','ÎœÎ±Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(242590,6739,'zh','æˆ‘ä»¬çš„è®¢å•å·\r\n',0),(242591,6739,'sv','VÃ¥rt ordernummer',0),(242592,6739,'it','Il nostro numero d\'ordine',0),(242593,6739,'tl','',0),(242594,6739,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3614;&#3623;&#3585;&#3648;&#3619;&#3634;',0),(242595,6739,'hi','à¤¹à¤®à¤¾à¤°à¥‡ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(242596,6739,'ms','Nombor pesanan kami',0),(242597,6739,'ar','Ù„Ø¯ÙŠÙ†Ø§ Ø¹Ø¯Ø¯ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(242598,6739,'fr','Notre numÃ©ro de commande',0),(242599,6739,'jp','å¼Šç¤¾æ³¨æ–‡ç•ªå·',0),(242600,6739,'pt','Nosso nÃºmero de ordem',0),(242601,6739,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐÐ°ÑˆÐµÐ³Ð¾ Ð—Ð°ÐºÐ°Ð·Ð°',0),(242602,6739,'es','Nuestro NÃºmero de Orden',0),(242603,6739,'de','Unsere Bestellnummer',0),(242604,6739,'en','Our Order Number',0),(242605,6740,'is','',0),(242606,6740,'dr','RepØªØ¹Ù…ÙŠØ±Ø§Øª ',0),(242607,6740,'pr','RepØªØ¹Ù…ÙŠØ±Ø§Øª ',0),(242608,6740,'tr','Rep',0),(242609,6740,'pl','Rep',0),(242610,6740,'bg','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»',0),(242611,6740,'ur','Ø¬Ù…ÛÙˆØ±ÛŒÛ',0),(242612,6740,'sr','Ð ÐµÐ¿ÑƒÑ‚Ð°Ñ†Ð¸Ñ˜Ð°',0),(242613,6740,'vi','Äáº¡i diá»‡n',0),(242614,6740,'af','Verteenwoordiger',0),(242615,6740,'ro','Rep',0),(242616,6740,'et','Rep',0),(242617,6740,'si','Rep',0),(242618,6740,'ba','Rep',0),(242619,6740,'nl','Rep',0),(242620,6740,'fi','Rep',0),(242621,6740,'no','Rep',0),(242622,6740,'da','Rep',0),(242623,6740,'ko','ë‹´ë‹¹ìž',0),(242624,6740,'he','× ×¦×™×’',0),(242625,6740,'el','Rep',0),(242626,6740,'zh','ä»£è¡¨\r\n',0),(242627,6740,'sv','Rep',0),(242628,6740,'it','Rep',0),(242629,6740,'tl','',0),(242630,6740,'th','&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3586;&#3634;&#3618;',0),(242631,6740,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿',0),(242632,6740,'ms','Wakil',0),(242633,6740,'ar','Ù…Ù†Ø¯ÙˆØ¨',0),(242634,6740,'fr','REP',0),(242635,6740,'jp','æ‹…å½“è€…',0),(242636,6740,'pt','Rep',0),(242637,6740,'ru','REP',0),(242638,6740,'es','Repetir',0),(242639,6740,'de','Rep',0),(242640,6740,'en','Rep',0),(242641,6741,'is','',0),(242642,6741,'dr','Ø±Ø³ÙŠØ¯ ÙØ±ÙˆØ´ ',0),(242643,6741,'pr','Ø±Ø³ÙŠØ¯ ÙØ±ÙˆØ´ ',0),(242644,6741,'tr','SatÄ±ÅŸ makbuzu',0),(242645,6741,'pl','Paragonem sprzedaÅ¼y',0),(242646,6741,'bg','ÐšÐ°ÑÐ¾Ð²Ð°',0),(242647,6741,'ur','Ø³ÛŒÙ„Ø² Ø±Ø³ÛŒØ¯',0),(242648,6741,'sr','Ð£Ð»Ð°Ð·Ð½Ðµ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ñ†Ðµ',0),(242649,6741,'vi','BiÃªn nháº­n bÃ¡n hÃ ng',0),(242650,6741,'af','Verkoopskwitansie',0),(242651,6741,'ro','VÃ¢nzÄƒri primire',0),(242652,6741,'et','MÃ¼Ã¼gikviitung',0),(242653,6741,'si','Prodajno prejema',0),(242654,6741,'ba','Struk',0),(242655,6741,'nl','Aankoopbon',0),(242656,6741,'fi','Kuitti',0),(242657,6741,'no','Salgskvittering',0),(242658,6741,'da','Salgskvittering',0),(242659,6741,'ko','íŒë§¤ ì˜ìˆ˜ì¦',0),(242660,6741,'he','×—×©×‘×•× ×™×ª ×”×§× ×™×™×”',0),(242661,6741,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î»Î¹Î±Î½Î¹ÎºÎ®Ï‚ Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(242662,6741,'zh','é”€å”®æ”¶æ®\r\n',0),(242663,6741,'sv','Kvittot',0),(242664,6741,'it','Scontrino',0),(242665,6741,'tl','',0),(242666,6741,'th','&#3629;&#3629;&#3585;&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(242667,6741,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤°à¤¸à¥€à¤¦',0),(242668,6741,'ms','Resit pembelian',0),(242669,6741,'ar','Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(242670,6741,'fr','ReÃ§u de vente',0),(242671,6741,'jp','è²©å£²ã®é ˜åŽæ›¸',0),(242672,6741,'pt','Recibo de venda',0),(242673,6741,'ru','ÐšÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸',0),(242674,6741,'es','Recibo de Ventas',0),(242675,6741,'de','Beleg',0),(242676,6741,'en','Sales Receipt',0),(242677,6742,'is','',0),(242678,6742,'dr','_Ø­Ù…Ù„ Ø¨Ù‡_ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(242679,6742,'pr','Ù‡ÙŠÚ† Ø¢Ø¯Ø±Ø³ _Ø­Ù…Ù„ Ø¨Ù‡_ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(242680,6742,'tr','ShipTo adresi bulunamadÄ±',0),(242681,6742,'pl','Nie znaleziono adresÃ³w ShipTo',0),(242682,6742,'bg','ÐÐµ Ðµ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚ ShipTo Ð°Ð´Ñ€ÐµÑ',0),(242683,6742,'ur','Ú©ÙˆØ¦ÛŒ Ø´Ø§Ù¾Ù¹Ùˆ Ù¾ØªØ§ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(242684,6742,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° Ð°Ð´Ñ€ÐµÑÐ° ÐŸÑ€Ð¸Ð¼Ð°Ð¾Ñ† Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(242685,6742,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘á»‹a chá»‰ chuyá»ƒn hÃ ng',0),(242686,6742,'af','Geen VersendAan Adresse Gevind',0),(242687,6742,'ro','Nici o adresÄƒ de ShipTo gÄƒsit',0),(242688,6742,'et','Ãœhtegi ShipTo aadressi',0),(242689,6742,'si','Naslova ShipTo, najdemo',0),(242690,6742,'ba','Alamat ShipTo tidak ditemukan',0),(242691,6742,'nl','Geen ShipTo adres gevonden',0),(242692,6742,'fi','ShipTo osoitetta ei lÃ¶ydy',0),(242693,6742,'no','Ingen ShipTo postadresser',0),(242694,6742,'da','Ingen ShipTo adresse fundet',0),(242695,6742,'ko','ë°œê²¬ ShipTo ì£¼ì†Œ ì—†ìŒ',0),(242696,6742,'he','×œ× × ×ž×¦××” ×›×ª×•×‘×ª ×©×¢×•×–×‘×ª',0),(242697,6742,'el','Î”ÎµÎ½ ÎµÎ½Ï„Î¿Ï€Î¯ÏƒÏ„Î·ÎºÎµ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· ShipTo',0),(242698,6742,'zh','æ²¡æœ‰å‘çŽ°æ”¶è´§åœ°å€\r\n',0),(242699,6742,'sv','Ingen ShipTo-adress som finns',0),(242700,6742,'it','Nessun indirizzo ShipTo trovato',0),(242701,6742,'tl','',0),(242702,6742,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3606;&#3638;&#3591;',0),(242703,6742,'hi','à¤•à¥‹à¤ˆ ShipTo à¤ªà¤¤à¤¾ à¤®à¤¿à¤²à¤¾',0),(242704,6742,'ms','Tiada alamat ShipTo yang mendapati',0),(242705,6742,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù† Ø´ÙŠØªÙˆ',0),(242706,6742,'fr','Aucune adresse ShipTo trouvÃ©e',0),(242707,6742,'jp','ShipTo ã‚¢ãƒ‰ãƒ¬ã‚¹ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(242708,6742,'pt','Sem endereÃ§o ShipTo encontrado',0),(242709,6742,'ru','ÐÐ´Ñ€ÐµÑ ShipTo, Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(242710,6742,'es','No se EncontrÃ³ una DirecciÃ³n de Enviar-A',0),(242711,6742,'de','Keine ShipTo-Adresse gefunden',0),(242712,6742,'en','No ShipTo Address Found',0),(242713,6743,'is','',0),(242714,6743,'dr','ÙƒØ¯ Ù…Ø¬Ø§Ø² ',0),(242715,6743,'pr','ÙƒØ¯ Ù…Ø¬Ø§Ø² ',0),(242716,6743,'tr','Yetki kodu',0),(242717,6743,'pl','Kod autoryzacji',0),(242718,6743,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ ÐºÐ¾Ð´',0),(242719,6743,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Û’ Ú©ÙˆÚˆ',0),(242720,6743,'sr','ÐÑƒÑ‚Ð¾Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(242721,6743,'vi','MÃ£ Sá»‘ Quyá»n',0),(242722,6743,'af','Magtigingskode',0),(242723,6743,'ro','Cod de autorizare',0),(242724,6743,'et','Kood',0),(242725,6743,'si','Dovoljenje zbornik',0),(242726,6743,'ba','Kode otorisasi',0),(242727,6743,'nl','Authorisatiecode',0),(242728,6743,'fi','Lupa ilmaista koodikielellÃ¤',0),(242729,6743,'no','Autorisasjonen koden',0),(242730,6743,'da','Autorisationskode',0),(242731,6743,'ko','ì¸ì¦ ì½”ë“œ',0),(242732,6743,'he','×§×•×“ ××™×©×•×¨',0),(242733,6743,'el','ÎšÏ‰Î´Î¹ÎºÏŒ ÎµÎ¾Î¿Ï…ÏƒÎ¹Î¿Î´ÏŒÏ„Î·ÏƒÎ·Ï‚',0),(242734,6743,'zh','æŽˆæƒç \r\n',0),(242735,6743,'sv','BehÃ¶righetskod',0),(242736,6743,'it','Codice di autorizzazione',0),(242737,6743,'tl','',0),(242738,6743,'th','&#3619;&#3627;&#3633;&#3626;&#3651;&#3609;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(242739,6743,'hi','à¤ªà¥à¤°à¤¾à¤§à¤¿à¤•à¤°à¤£ à¤•à¥‹à¤¡',0),(242740,6743,'ms','Kod kebenaran',0),(242741,6743,'ar','Ø±Ù…Ø² Ø§Ù„ØªØ®ÙˆÙŠÙ„',0),(242742,6743,'fr','Code d\'autorisation',0),(242743,6743,'jp','èªè¨¼ã‚³ãƒ¼ãƒ‰',0),(242744,6743,'pt','CÃ³digo de autorizaÃ§Ã£o',0),(242745,6743,'ru','ÐšÐ¾Ð´ ÐÐ²Ñ‚Ð¾Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(242746,6743,'es','CÃ³digo de AutorizaciÃ³n',0),(242747,6743,'de','Autorisierungscode',0),(242748,6743,'en','Authorization Code',0),(242749,6744,'is','',0),(242750,6744,'dr','Ø§Ú¯Ø± ÙƒØ¯ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(242751,6744,'pr','Ø§Ú¯Ø± ÙƒØ¯ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(242752,6744,'tr','EÄŸer CC kart kodu',0),(242753,6744,'pl','JeÅ›li kod karty CC',0),(242754,6744,'bg','ÐÐºÐ¾ ÐºÐ¾Ð´ÑŠÑ‚ Ð·Ð° CC',0),(242755,6744,'ur','Ø§Ú¯Ø± CC Ú©Ø§Ø±Úˆ Ú©ÙˆÚˆ',0),(242756,6744,'sr','ÐÐºÐ¾ Ð¨Ð¸Ñ„Ñ€Ð° Ð¦Ð¦ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(242757,6744,'vi','Náº¿u sao chep MÃ£ tháº»',0),(242758,6744,'af','Indien KK Kaartkode',0),(242759,6744,'ro','DacÄƒ codul de Card CC',0),(242760,6744,'et','Kui koopia kaardi kood',0),(242761,6744,'si','ÄŒe kodo kartice CC',0),(242762,6744,'ba','Jika kode kartu CC',0),(242763,6744,'nl','Als CC kaart Code',0),(242764,6744,'fi','Jos CC kortin koodi',0),(242765,6744,'no','Hvis CC kort kode',0),(242766,6744,'da','Hvis CC kort kode',0),(242767,6744,'ko','ë§Œì•½ CC ì¹´ë“œ ì½”ë“œ',0),(242768,6744,'he','×× ×§×•×“ ×›×¨×˜×™×¡ CC',0),(242769,6744,'el','Î•Î¬Î½ ÎºÎ¬ÏÏ„Î± ÎºÏ‰Î´Î¹ÎºÎ¿Ï CC',0),(242770,6744,'zh','å¦‚æžœä¿¡ç”¨å¡ä»£ç \r\n',0),(242771,6744,'sv','Om CC kort kod',0),(242772,6744,'it','Se CC codice Card',0),(242773,6744,'tl','',0),(242774,6744,'th','&#3606;&#3657;&#3634;&#3626;&#3635;&#3648;&#3609;&#3634;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3610;&#3633;&#3605;&#3619;',0),(242775,6744,'hi','à¤…à¤—à¤° CC à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‹à¤¡',0),(242776,6744,'ms','Jika kod Kad CC',0),(242777,6744,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø±Ù…Ø² Ø¨Ø·Ø§Ù‚Ø© CC',0),(242778,6744,'fr','Si CC Carte Code',0),(242779,6744,'jp','å ´åˆ CC ã‚«ãƒ¼ãƒ‰ ã‚³ãƒ¼ãƒ‰',0),(242780,6744,'pt','Se CC cÃ³digo de cartÃ£o',0),(242781,6744,'ru','Ð•ÑÐ»Ð¸ ÐºÐ¾Ð´ ÐºÐ°Ñ€Ñ‚Ñ‹ CC',0),(242782,6744,'es','Si CC CÃ³digo de Tarjeta',0),(242783,6744,'de','Wenn CC Card Code',0),(242784,6744,'en','If CC Card Code',0),(242785,6745,'is','',0),(242786,6745,'dr','Ø§Ú¯Ø± Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(242787,6745,'pr','Ø§Ú¯Ø± Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(242788,6745,'tr','EÄŸer gerekli',0),(242789,6745,'pl','JeÅ›li jest to wymagane',0),(242790,6745,'bg','ÐÐºÐ¾ Ðµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾',0),(242791,6745,'ur','Ø§Ú¯Ø± Ø¶Ø±ÙˆØ±Øª ÛÙˆ ØªÙˆ',0),(242792,6745,'sr','ÐÐºÐ¾ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾',0),(242793,6745,'vi','Náº¿u yÃªu cáº§u',0),(242794,6745,'af','Indien Benodig',0),(242795,6745,'ro','DacÄƒ este necesar',0),(242796,6745,'et','Kui on nÃµutav',0),(242797,6745,'si','ÄŒe zahtevati',0),(242798,6745,'ba','Jika diperlukan',0),(242799,6745,'nl','Indien nodig',0),(242800,6745,'fi','Tarvittaessa',0),(242801,6745,'no','Hvis nÃ¸dvendig',0),(242802,6745,'da','Hvis det krÃ¦ves',0),(242803,6745,'ko','í•„ìš”í•œ ê²½ìš°',0),(242804,6745,'he','×× × ×“×¨×©',0),(242805,6745,'el','Î‘Î½ Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(242806,6745,'zh','å¦‚æžœéœ€è¦\r\n',0),(242807,6745,'sv','Om det krÃ¤vs',0),(242808,6745,'it','Se richiesto',0),(242809,6745,'tl','',0),(242810,6745,'th','&#3606;&#3657;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(242811,6745,'hi','à¤¯à¤¦à¤¿ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(242812,6745,'ms','Jika perlu',0),(242813,6745,'ar','Ø¥Ø°Ø§ Ù„Ø²Ù… Ø§Ù„Ø£Ù…Ø±',0),(242814,6745,'fr','Si nÃ©cessaire',0),(242815,6745,'jp','å¿…è¦ãªå ´åˆ',0),(242816,6745,'pt','Se for necessÃ¡rio',0),(242817,6745,'ru','Ð•ÑÐ»Ð¸ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ',0),(242818,6745,'es','If se Requiere',0),(242819,6745,'de','Bei Bedarf',0),(242820,6745,'en','If Required',0),(242821,6746,'is','',0),(242822,6746,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨ÙŠØ´ Ø§Ø² Ø­Ø¯ Ù…Ø¬Ø§Ø² Ø§Ø³Øª ',0),(242823,6746,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨ÙŠØ´ Ø§Ø² Ø­Ø¯ Ù…Ø¬Ø§Ø² Ø§Ø³Øª ',0),(242824,6746,'tr','Yetkili daha yÃ¼ksek miktardÄ±r',0),(242825,6746,'pl','Kwota jest wyÅ¼sza niÅ¼ autoryzowane',0),(242826,6746,'bg','Ð¡ÑƒÐ¼Ð°Ñ‚Ð° Ðµ Ð¿Ð¾-Ð²Ð¸ÑÐ¾ÐºÐ¾ Ð¾Ñ‚ Ð¾Ñ‚Ð¾Ñ€Ð¸Ð·Ð¸Ñ€Ð°Ð½',0),(242827,6746,'ur','Ø§Ø¹Ù„ÛŒÙ° Ù…Ø³ØªÙ†Ø¯ Ø³Ø±Ø¬ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø±Ù‚Ù… ÛÛ’',0),(242828,6746,'sr','Ð˜Ð·Ð½Ð¾Ñ Ñ˜Ðµ Ð²Ð¸ÑÐ¾ÐºÐ¾ Ð¾Ð´ ÐÑƒÑ‚Ñ…Ð¾Ñ€Ð¸Ð·ÐµÐ´',0),(242829,6746,'vi','Sá»‘ Tiá»n Cao HÆ¡n Quyá»n ÄÆ°á»£c Duyá»‡t',0),(242830,6746,'af','Bedrag is HoÃ«r as wat Gemagtig is',0),(242831,6746,'ro','Suma este superior decÃ¢t autorizat',0),(242832,6746,'et','Summa on kÃµrgem kui lubatud',0),(242833,6746,'si','Znesek je viÅ¡je kot pooblaÅ¡Äeni',0),(242834,6746,'ba','Jumlah yang lebih tinggi dari resmi',0),(242835,6746,'nl','Bedrag is hoger dan toegelaten',0),(242836,6746,'fi','MÃ¤Ã¤rÃ¤ on korkea kuin valtuutettu',0),(242837,6746,'no','BelÃ¸pet er hÃ¸yere enn godkjente',0),(242838,6746,'da','BelÃ¸b er hÃ¸jere end autoriseret',0),(242839,6746,'ko','ê¸ˆì•¡ì€ ê¶Œí•œ ë³´ë‹¤ ë†’ì€',0),(242840,6746,'he','×”×›×ž×•×ª ×”×™× ×’×‘×•×”×” ×ž ×ž×•×¨×©×”',0),(242841,6746,'el','Î Î¿ÏƒÏŒ ÎµÎ¯Î½Î±Î¹ Î±Î½ÏŽÏ„ÎµÏÎ· Î±Ï€ÏŒ ÎµÎ¾Î¿Ï…ÏƒÎ¹Î¿Î´Î¿Ï„Î·Î¼Î­Î½Î¿',0),(242842,6746,'zh','é‡‘é¢å¤§äºŽè¢«æŽˆæƒ\r\n',0),(242843,6746,'sv','Beloppet Ã¤r hÃ¶gre Ã¤n auktoriserade',0),(242844,6746,'it','Importo Ã¨ superiore rispetto a autorizzato',0),(242845,6746,'tl','',0),(242846,6746,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3626;&#3641;&#3591;&#3648;&#3585;&#3636;&#3609;&#3585;&#3623;&#3656;&#3634;&#3607;&#3637;&#3656;&#3592;&#3632;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(242847,6746,'hi','à¤…à¤§à¤¿à¤•à¥ƒà¤¤ à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾ à¤‰à¤šà¥à¤š à¤°à¤¾à¤¶à¤¿ à¤¹à¥ˆ',0),(242848,6746,'ms','Adalah jumlah tinggi daripada dibenarkan',0),(242849,6746,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø£ÙƒØ¨Ø± Ù…Ù† Ø§Ù„ØªØ®ÙˆÙŠÙ„',0),(242850,6746,'fr','Montant est supÃ©rieur Ã  agrÃ©Ã©',0),(242851,6746,'jp','é‡ãŒæ‰¿èªã•ã‚Œã¦ã„ã‚‹ä»¥ä¸Šã§ã™ã€‚',0),(242852,6746,'pt','Quantidade Ã© superior do que o autorizado',0),(242853,6746,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÐ¾ÑÑ‚Ð°Ð²Ð»ÑÐµÑ‚ Ð²Ñ‹ÑÑˆÐµÐµ Ñ‡ÐµÐ¼ ÑƒÐ¿Ð¾Ð»Ð½Ð¾Ð¼Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ð¼',0),(242854,6746,'es','Cantidad es mÃ¡s Grande que Autorizada',0),(242855,6746,'de','Betrag ist hÃ¶her als autorisierte',0),(242856,6746,'en','Amount is Higher than Authorized',0),(242857,6747,'is','',0),(242858,6747,'dr','(Ø¶Ø¨Ø·) ØªØ¹ÙˆÛŒÙ‚ Ù†ÙŠØ³Øª',0),(242859,6747,'pr','Ù‚Ø§Ø¯Ø±Ø¨Ù‡ Ø§Ù†Ø¬Ø§Ù… ØªØµØ±Ù (Ø¶Ø¨Ø·) Ù…Ø¹ÙˆÙ‚ Ù†ÙŠØ³Øª',0),(242860,6747,'tr','Geciken yakalama yapamaz',0),(242861,6747,'pl','Nie opÃ³Åºnione przechwytywania',0),(242862,6747,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ Ð·Ð°Ð±Ð°Ð²ÐµÐ½Ð¾ ÑƒÐ»Ð°Ð²ÑÐ½Ðµ',0),(242863,6747,'ur','ØªØ§Ø®ÛŒØ± Ù¾Ø± Ù‚Ø¨Ø¶Û Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(242864,6747,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð¾Ð´Ð³Ð¾Ñ’ÐµÐ½Ð¾ Ñ…Ð²Ð°Ñ‚Ð°ÑšÐµ',0),(242865,6747,'vi','KhÃ´ng thá»ƒ ghi nháº­n sau',0),(242866,6747,'af','Nie Instaat om Vertraagde Datavaslegging te Doen',0),(242867,6747,'ro','Nu pot face Ã®ntÃ¢rziatÄƒ de captare',0),(242868,6747,'et','Hilinenud lÃ¼Ã¼a ei saa',0),(242869,6747,'si','Ne morem narediti zakasnitvijo zajem',0),(242870,6747,'ba','Tidak menangkap tertunda',0),(242871,6747,'nl','Niet vertraagde Capture',0),(242872,6747,'fi','Ei viivÃ¤stynyt kaapata',0),(242873,6747,'no','Ikke forsinket fange',0),(242874,6747,'da','Ikke forsinkede fange',0),(242875,6747,'ko','ì§€ì—°ëœ ìº¡ì²˜ë¥¼ í•  ìˆ˜ ì—†ì–´',0),(242876,6747,'he','×œ× ×™×›×•×œ ×œ×¢×©×•×ª ××ª ×œ×›×™×“×ª ×©××™×—×¨×•',0),(242877,6747,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ¼Îµ Î½Î± ÎºÎ¬Î½Î¿Ï…Î¼Îµ Ï„Î·Î½ ÎºÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ·Î¼Î­Î½Î· ÏƒÏÎ»Î»Î·ÏˆÎ·',0),(242878,6747,'zh','æ— æ³•å»¶è¿Ÿæ•èŽ·ã€‚\r\n',0),(242879,6747,'sv','Kan inte gÃ¶ra fÃ¶rdrÃ¶jd Capture',0),(242880,6747,'it','Non Ã¨ possibile acquisizione ritardata',0),(242881,6747,'tl','',0),(242882,6747,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3592;&#3633;&#3610;&#3621;&#3656;&#3634;&#3594;&#3657;&#3634;',0),(242883,6747,'hi','à¤µà¤¿à¤²à¤‚à¤¬à¤¿à¤¤ à¤•à¥ˆà¤ªà¥à¤šà¤° à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(242884,6747,'ms','Tidak dapat tangkap kelewatan',0),(242885,6747,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„ØªÙ‚Ø§Ø· ØªØ£Ø®Ø±',0),(242886,6747,'fr','Ne peut pas faire de Capture diffÃ©rÃ©e',0),(242887,6747,'jp','é…å»¶ã‚­ãƒ£ãƒ—ãƒãƒ£ã‚’è¡Œã†ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(242888,6747,'pt','NÃ£o posso fazer captura de atrasada',0),(242889,6747,'ru','ÐÐµ Ð·Ð°Ð´ÐµÑ€Ð¶ÐºÐ° Ð·Ð°Ñ…Ð²Ð°Ñ‚Ð°',0),(242890,6747,'es','No se puede hacer Captura Postergada',0),(242891,6747,'de','VerzÃ¶gerte Aufnahme geht nicht',0),(242892,6747,'en','Cannot Do Delayed Capture',0),(242893,6748,'is','',0),(242894,6748,'dr','Ø®Ø·Ø§ ÙŠ  ÙƒØ¯ ',0),(242895,6748,'pr','Ø®Ø·Ø§ ÙŠ  ÙƒØ¯ ',0),(242896,6748,'tr','Hata kodu',0),(242897,6748,'pl','Kod bÅ‚Ä™du',0),(242898,6748,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð³Ñ€ÐµÑˆÐºÐ°',0),(242899,6748,'ur','Ù†Ù‚Øµ Ú©ÙˆÚˆ',0),(242900,6748,'sr','ÐšÃ´Ð´ Ð³Ñ€ÐµÑˆÐºÐµ',0),(242901,6748,'vi','MÃ£ lá»—i',0),(242902,6748,'af','Foutkode',0),(242903,6748,'ro','Cod de eroare',0),(242904,6748,'et','TÃµrkekood',0),(242905,6748,'si','Koda napake',0),(242906,6748,'ba','Kode kesalahan',0),(242907,6748,'nl','Foutcode',0),(242908,6748,'fi','Virhekoodi',0),(242909,6748,'no','Feilkode',0),(242910,6748,'da','Fejlkode',0),(242911,6748,'ko','ì˜¤ë¥˜ ì½”ë“œ',0),(242912,6748,'he','×§×•×“ ×©×’×™××”',0),(242913,6748,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚',0),(242914,6748,'zh','é”™è¯¯ä»£ç ',0),(242915,6748,'sv','Felkod',0),(242916,6748,'it','Codice di errore',0),(242917,6748,'tl','',0),(242918,6748,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3619;&#3627;&#3633;&#3626;',0),(242919,6748,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹à¤¡',0),(242920,6748,'ms','Kod ralat',0),(242921,6748,'ar','Ø±Ù…Ø² Ø§Ù„Ø®Ø·Ø£',0),(242922,6748,'fr','Code d\'erreur',0),(242923,6748,'jp','ã‚¨ãƒ©ãƒ¼ ã‚³ãƒ¼ãƒ‰',0),(242924,6748,'pt','CÃ³digo de erro',0),(242925,6748,'ru','ÐšÐ¾Ð´ Ð¾ÑˆÐ¸Ð±ÐºÐ¸',0),(242926,6748,'es','CÃ³digo de Error',0),(242927,6748,'de','Fehlercode',0),(242928,6748,'en','Error Code',0),(242929,6749,'is','',0),(242930,6749,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§ØµÙ„ÙŠ ',0),(242931,6749,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ØµÙ„ÙŠ ',0),(242932,6749,'tr','Ä°lk tutar',0),(242933,6749,'pl','Kwota pierwotna',0),(242934,6749,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° ÑÑƒÐ¼Ð°',0),(242935,6749,'ur','Ø§ØµÙ„ Ø±Ù‚Ù…',0),(242936,6749,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(242937,6749,'vi','Sá»‘ tiá»n gá»‘c',0),(242938,6749,'af','Oorspronklike Bedrag',0),(242939,6749,'ro','Suma originalÄƒ',0),(242940,6749,'et','Algse summa',0),(242941,6749,'si','Prvotni znesek',0),(242942,6749,'ba','Jumlah asli',0),(242943,6749,'nl','Oorspronkelijke bedrag',0),(242944,6749,'fi','AlkuperÃ¤inen summa',0),(242945,6749,'no','Opprinnelige belÃ¸pet',0),(242946,6749,'da','Oprindelige belÃ¸b',0),(242947,6749,'ko','ì›ëž˜ ê¸ˆì•¡',0),(242948,6749,'he','×¡×›×•× ×ž×§×•×¨×™',0),(242949,6749,'el','Î‘ÏÏ‡Î¹ÎºÏŒ Ï€Î¿ÏƒÏŒ',0),(242950,6749,'zh','åŽŸå§‹é‡‘é¢\r\n',0),(242951,6749,'sv','Ursprungligt belopp',0),(242952,6749,'it','Importo originario',0),(242953,6749,'tl','',0),(242954,6749,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3657;&#3609;&#3593;&#3610;&#3633;&#3610;',0),(242955,6749,'hi','à¤®à¥‚à¤² à¤°à¤¾à¤¶à¤¿',0),(242956,6749,'ms','Amaun asal',0),(242957,6749,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ø£ØµÙ„ÙŠ',0),(242958,6749,'fr','Montant initial',0),(242959,6749,'jp','å…ƒã®é‡',0),(242960,6749,'pt','Quantidade original',0),(242961,6749,'ru','ÐŸÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(242962,6749,'es','Monto Original',0),(242963,6749,'de','Ursprungsbetrag',0),(242964,6749,'en','Original Amount',0),(242965,6750,'is','',0),(242966,6750,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø§ØµÙ„ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(242967,6750,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø§ØµÙ„ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(242968,6750,'tr','Ã–zgÃ¼n iÅŸlem kimliÄŸi',0),(242969,6750,'pl','Oryginalny identyfikator transakcji',0),(242970,6750,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÐµÐ½ Ð˜Ð” Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(242971,6750,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø§ØµÙ„ Ø´Ù†Ø§Ø®Øª',0),(242972,6750,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ Ð˜Ð” Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(242973,6750,'vi','ID giao dá»‹ch gá»‘c',0),(242974,6750,'af','Oorspronklike Transaksie ID',0),(242975,6750,'ro','Original Transaction ID',0),(242976,6750,'et','Algse kande ID',0),(242977,6750,'si','Izvirni ID posla',0),(242978,6750,'ba','Asli ID transaksi',0),(242979,6750,'nl','Oorspronkelijke transactie-ID',0),(242980,6750,'fi','AlkuperÃ¤inen Tapahtumatunnus',0),(242981,6750,'no','Opprinnelige transaksjons-ID',0),(242982,6750,'da','Oprindelige transaktions-ID',0),(242983,6750,'ko','ì›ëž˜ íŠ¸ëžœìž­ì…˜ ID',0),(242984,6750,'he','×ž×–×”×” ×ª× ×•×¢×” ×”×ž×§×•×¨×™',0),(242985,6750,'el','Î‘ÏÏ‡Î¹ÎºÏŒ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(242986,6750,'zh','åŽŸå§‹äº¤æ˜“ç¼–å·\r\n',0),(242987,6750,'sv','Ursprungliga transaktions-ID',0),(242988,6750,'it','ID transazione originale',0),(242989,6750,'tl','',0),(242990,6750,'th','&#3648;&#3621;&#3586;&#3627;&#3617;&#3634;&#3618;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3604;&#3633;&#3657;&#3591;&#3648;&#3604;&#3636;&#3617;',0),(242991,6750,'hi','à¤®à¥‚à¤² à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤†à¤ˆà¤¡à¥€',0),(242992,6750,'ms','ID transaksi asal',0),(242993,6750,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø© Ø§Ù„Ø£ØµÙ„ÙŠØ©',0),(242994,6750,'fr','ID de la Transaction originale',0),(242995,6750,'jp','å…ƒã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã® ID',0),(242996,6750,'pt','ID da transaÃ§Ã£o original',0),(242997,6750,'ru','Ð˜ÑÑ…Ð¾Ð´Ð½Ñ‹Ð¹ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(242998,6750,'es','Original TransacciÃ³n ID',0),(242999,6750,'de','Original Transaktions-ID',0),(243000,6750,'en','Original Transaction ID',0),(243001,6751,'is','',0),(243002,6751,'dr','(Ù…ØªÙˆÙ‚Ù ',0),(243003,6751,'pr','Ù‚Ø¨Ù„Ø§ ØªØµØ±Ù Ø´Ø¯Ù‡(Ù…ØªÙˆÙ‚Ù ',0),(243004,6751,'tr','Daha Ã¶nce yakalanan',0),(243005,6751,'pl','WczeÅ›niej',0),(243006,6751,'bg','Ð‘Ð¸Ð»Ð¸ Ð·Ð°Ð»Ð¾Ð²ÐµÐ½Ð¸',0),(243007,6751,'ur','Ù‚Ø¨Ù„ Ø§Ø²ÛŒÚº Ù¾Ø± Ù‚Ø¨Ø¶Û Ú©Ø± Ù„ÛŒØ§',0),(243008,6751,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾ Ð·Ð°Ñ€Ð¾Ð±Ð¸Ð»Ð¸',0),(243009,6751,'vi','Ghi nháº­n trÆ°á»›c',0),(243010,6751,'af','Vorige Datavaslegging',0),(243011,6751,'ro','Anterior capturat',0),(243012,6751,'et','Eelnevalt pildistatud',0),(243013,6751,'si','Prej ujeli',0),(243014,6751,'ba','Sebelumnya ditangkap',0),(243015,6751,'nl','Eerder gevangen',0),(243016,6751,'fi','Aiemmin kiinni',0),(243017,6751,'no','Tidligere fanget',0),(243018,6751,'da','Tidligere fanget',0),(243019,6751,'ko','ì´ì „ ì ë ¹',0),(243020,6751,'he','×‘×¢×‘×¨ × ×ª×¤×¡',0),(243021,6751,'el','Î ÏÎ¿Î·Î³Î¿Ï…Î¼Î­Î½Ï‰Ï‚ ÏƒÏ…Î½Î­Î»Î±Î²Îµ',0),(243022,6751,'zh','ä»¥å‰æ•èŽ·\r\n',0),(243023,6751,'sv','Tidigare fÃ¥ngade',0),(243024,6751,'it','Precedentemente catturato',0),(243025,6751,'tl','',0),(243026,6751,'th','&#3585;&#3634;&#3619;&#3648;&#3585;&#3655;&#3610;&#3616;&#3634;&#3614;&#3649;&#3605;&#3656;&#3585;&#3656;&#3629;&#3609;',0),(243027,6751,'hi','à¤ªà¤¹à¤²à¥‡ à¤•à¤¬à¥à¤œà¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾',0),(243028,6751,'ms','Sebelum ini ditangkap',0),(243029,6751,'ar','Ø§Ø³ØªÙˆÙ„Øª Ø³Ø§Ø¨Ù‚Ø§',0),(243030,6751,'fr','PrÃ©cÃ©demment capturÃ©',0),(243031,6751,'jp','ä»¥å‰ã‚­ãƒ£ãƒ—ãƒãƒ£',0),(243032,6751,'pt','Anteriormente capturado',0),(243033,6751,'ru','Ð Ð°Ð½ÐµÐµ Ð·Ð°Ñ…Ð²Ð°Ñ‚Ð¸Ð»Ð¸',0),(243034,6751,'es','Previamente Capturado',0),(243035,6751,'de','Zuvor erfasst',0),(243036,6751,'en','Previously Captured',0),(243037,6752,'is','',0),(243038,6752,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ù‡Ù†Ø¯Ù‡',0),(243039,6752,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ù‡Ù†Ø¯Ù‡',0),(243040,6752,'tr','Hareket tutarÄ±nÄ± azaltmaya',0),(243041,6752,'pl','Zmniejszenie kwoty transakcji',0),(243042,6752,'bg','ÐÐ°Ð¼Ð°Ð»ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(243043,6752,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ù…ÛŒÚº Ú©Ù…ÛŒ',0),(243044,6752,'sr','Ð¡Ð¼Ð°ÑšÐµÑšÐµ Ð¸Ð·Ð½Ð¾Ñ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(243045,6752,'vi','Giáº£m sá»‘ tiá»n giao dá»‹ch',0),(243046,6752,'af','Vermindering van transaksie bedrag',0),(243047,6752,'ro','Reducerea sumei tranzactiei',0),(243048,6752,'et','Kande summa vÃ¤hendamine',0),(243049,6752,'si','SkrÄljiv znesek transakcije',0),(243050,6752,'ba','Mengurangi jumlah transaksi',0),(243051,6752,'nl','Vermindering van de transactie',0),(243052,6752,'fi','Tapahtuman mÃ¤Ã¤rÃ¤',0),(243053,6752,'no','Redusere transaksjonsbelÃ¸pet',0),(243054,6752,'da','Reduktion af transaktionsbelÃ¸bet',0),(243055,6752,'ko','ê±°ëž˜ ê¸ˆì•¡ ê°ì†Œ',0),(243056,6752,'he','×”×¤×—×ª×ª ×¡×›×•× ×”×ª× ×•×¢×”',0),(243057,6752,'el','Î¤Î· Î¼ÎµÎ¯Ï‰ÏƒÎ· Ï„Î¿Ï… Ï€Î¿ÏƒÎ¿Ï Ï„Î·Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(243058,6752,'zh','å‡å°‘äº¤æ˜“é‡‘é¢\r\n',0),(243059,6752,'sv','Att minska transaktionsbeloppet',0),(243060,6752,'it','Riducendo l\'importo della transazione',0),(243061,6752,'tl','',0),(243062,6752,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3621;&#3604;&#3621;&#3591;',0),(243063,6752,'hi','à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤°à¤¾à¤¶à¤¿ à¤•à¥‹ à¤•à¤® à¤•à¤°à¤¨à¥‡',0),(243064,6752,'ms','Mengurangkan jumlah transaksi',0),(243065,6752,'ar','ØªØ®ÙÙŠØ¶ Ù…Ø¨Ù„Øº Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(243066,6752,'fr','RÃ©duire le montant de la Transaction',0),(243067,6752,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã®é‡ã‚’æ¸›ã‚‰ã™',0),(243068,6752,'pt','Reduzindo a quantidade de transaÃ§Ãµes',0),(243069,6752,'ru','Ð£Ð¼ÐµÐ½ÑŒÑˆÐµÐ½Ð¸Ðµ ÑÑƒÐ¼Ð¼Ñ‹ ÑÐ´ÐµÐ»ÐºÐ¸',0),(243070,6752,'es','Reduciendo Monto de la TransacciÃ³n',0),(243071,6752,'de','Verringerung der Transaktionsbetrag',0),(243072,6752,'en','Reducing Transaction Amount',0),(243073,6753,'is','',0),(243074,6753,'dr','Ø§ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(243075,6753,'pr','Ø§ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(243076,6753,'tr','Bu iÅŸlem',0),(243077,6753,'pl','Tej transakcji',0),(243078,6753,'bg','Ð¢Ð°Ð·Ð¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(243079,6753,'ur','Ø§Ø³ Ù„ÛŒÙ† Ø¯ÛŒÙ†',0),(243080,6753,'sr','ÐžÐ²Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(243081,6753,'vi','Giao dá»‹ch nÃ y',0),(243082,6753,'af','Hierdie Transaksie',0),(243083,6753,'ro','Aceasta tranzactie',0),(243084,6753,'et','Selle tehingu',0),(243085,6753,'si','To transakcijo',0),(243086,6753,'ba','Transaksi ini',0),(243087,6753,'nl','Deze transactie',0),(243088,6753,'fi','TÃ¤mÃ¤n tapahtuman',0),(243089,6753,'no','Denne transaksjonen',0),(243090,6753,'da','Denne transaktion',0),(243091,6753,'ko','ì´ íŠ¸ëžœìž­ì…˜',0),(243092,6753,'he','×ª× ×•×¢×” ×–×•',0),(243093,6753,'el','Î‘Ï…Ï„Î® Î· ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®',0),(243094,6753,'zh','è¿™é¡¹äº¤æ˜“\r\n',0),(243095,6753,'sv','Denna transaktion',0),(243096,6753,'it','Questa transazione',0),(243097,6753,'tl','',0),(243098,6753,'th','&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(243099,6753,'hi','à¤‡à¤¸ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨',0),(243100,6753,'ms','Urusniaga ini',0),(243101,6753,'ar','Ù‡Ø°Ù‡ Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(243102,6753,'fr','Cette Transaction',0),(243103,6753,'jp','ã“ã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³',0),(243104,6753,'pt','Esta transaÃ§Ã£o',0),(243105,6753,'ru','Ð­Ñ‚Ð° ÑÐ´ÐµÐ»ÐºÐ°',0),(243106,6753,'es','Esta TransacciÃ³n',0),(243107,6753,'de','Diese Transaktion',0),(243108,6753,'en','This Transaction',0),(243109,6754,'is','',0),(243110,6754,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(243111,6754,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(243112,6754,'tr','DoÄŸrulanmamÄ±ÅŸ sipariÅŸler',0),(243113,6754,'pl','Niepotwierdzone zamÃ³wienia',0),(243114,6754,'bg','ÐÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(243115,6754,'ur','ØºÛŒØ± Ù…ØµØ¯Ù‚Û Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(243116,6754,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð½ÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ðµ',0),(243117,6754,'vi','ÄÆ¡n hÃ ng chÆ°a xÃ¡c nháº­n',0),(243118,6754,'af','Bestellings Onbevestig',0),(243119,6754,'ro','Comenzi neconfirmate',0),(243120,6754,'et','Kinnitamata korralduste',0),(243121,6754,'si','Nepotrjenih naroÄil',0),(243122,6754,'ba','Pesanan yang belum dikonfirmasi',0),(243123,6754,'nl','Onbevestigde bestellingen',0),(243124,6754,'fi','Tilaukset vahvistamaton',0),(243125,6754,'no','Bestillinger ubekreftet',0),(243126,6754,'da','Ordrer ubekrÃ¦ftet',0),(243127,6754,'ko','ì£¼ë¬¸ ë¯¸í™•ì¸',0),(243128,6754,'he','×”×–×ž× ×•×ª ×©×œ× ××•×ž×ª×•',0),(243129,6754,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Î½ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰Ï„ÎµÏ‚',0),(243130,6754,'zh','è®¢å•æœªç¡®è®¤\r\n',0),(243131,6754,'sv','Order ej bekrÃ¤ftad',0),(243132,6754,'it','Ordini non confermati',0),(243133,6754,'tl','',0),(243134,6754,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(243135,6754,'hi','à¤…à¤ªà¥à¤·à¥à¤Ÿ à¤†à¤¦à¥‡à¤¶',0),(243136,6754,'ms','Perintah-perintah yang belum disahkan',0),(243137,6754,'ar','Ø£ÙˆØ§Ù…Ø± ØºÙŠØ± Ù…Ø¤ÙƒØ¯Ø©',0),(243138,6754,'fr','Commandes non confirmÃ©es',0),(243139,6754,'jp','æœªç¢ºèªã®æ³¨æ–‡',0),(243140,6754,'pt','Pedidos nÃ£o confirmados',0),(243141,6754,'ru','ÐÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(243142,6754,'es','Pedidos No Confirmados',0),(243143,6754,'de','Bestellungen, die nicht bestÃ¤tigt',0),(243144,6754,'en','Orders Unconfirmed',0),(243145,6755,'is','',0),(243146,6755,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±ÙƒØ§Ù„Ø§  ',0),(243147,6755,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±ÙƒØ§Ù„Ø§  ',0),(243148,6755,'tr','MÃ¼ÅŸteri Ã¶ÄŸesi geÃ§miÅŸi',0),(243149,6755,'pl','Historia towaru nabywcy',0),(243150,6755,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(243151,6755,'ur','Ú©Ø³Ù¹Ù…Ø± Ø´Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(243152,6755,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑƒÐ¿Ñ†Ð°',0),(243153,6755,'vi','Lá»‹ch sá»­ hÃ ng cá»§a khÃ¡ch hÃ ng',0),(243154,6755,'af','Klant / KliÃ«nt Itemgeskiedenis',0),(243155,6755,'ro','Istoric articol client',0),(243156,6755,'et','Kliendi toodete ajalugu',0),(243157,6755,'si','Zgodovina artikla kupcu',0),(243158,6755,'ba','Sejarah Item pelanggan',0),(243159,6755,'nl','Item klantgeschiedenis',0),(243160,6755,'fi','Nimikkeen Asiakashistoria',0),(243161,6755,'no','Elementet kundehistorikk',0),(243162,6755,'da','Kunde vare historie',0),(243163,6755,'ko','ê³ ê° í•­ëª© ê¸°ë¡',0),(243164,6755,'he','×œ×§×•×—×•×ª ×¤×¨×™×˜ ×”×™×¡×˜×•×¨×™×”',0),(243165,6755,'el','Î ÎµÎ»Î¬Ï„Î· Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(243166,6755,'zh','å®¢æˆ·äº§å“åŽ†å²',0),(243167,6755,'sv','Kunden objektet historia',0),(243168,6755,'it','Cliente elemento storia',0),(243169,6755,'tl','',0),(243170,6755,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3607;&#3635;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(243171,6755,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¤¦ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(243172,6755,'ms','Baca Item sejarah',0),(243173,6755,'ar','Ù…Ø­ÙÙˆØ¸Ø§Øª Ø¹Ù†ØµØ± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(243174,6755,'fr','Client historique de l\'Ã©lÃ©ment',0),(243175,6755,'jp','ã‚«ã‚¹ã‚¿ãƒžãƒ¼é …ç›®ã®å±¥æ­´',0),(243176,6755,'pt','HistÃ³rico de Item do cliente',0),(243177,6755,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¢Ð¾Ð²Ð°Ñ€Ð° ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(243178,6755,'es','Cliente Historia de Items',0),(243179,6755,'de','Element Kundenhistorie',0),(243180,6755,'en','Customer Item History',0),(243181,6756,'is','',0),(243182,6756,'dr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ Ùˆ Ù…Ø§Ù„ÙŠØ§Øª ',0),(243183,6756,'pr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ Ùˆ Ù…Ø§Ù„ÙŠØ§Øª ',0),(243184,6756,'tr','Kargo ve vergi hariÃ§',0),(243185,6756,'pl','Z wyÅ‚Ä…czeniem wysyÅ‚ki oraz podatku',0),(243186,6756,'bg','Ð¡ Ð¸Ð·ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð¸ Ð´Ð°Ð½ÑŠÐº',0),(243187,6756,'ur','Ø´Ù¾Ù†Ú¯ Ø§ÙˆØ± Ù¹ÛŒÚ©Ø³ Ú©Ùˆ Ú†Ú¾ÙˆÚ‘ Ú©Ø±',0),(243188,6756,'sr','Ð˜ÑÐºÑ™ÑƒÑ‡ÑƒÑ˜ÑƒÑ›Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð¸ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(243189,6756,'vi','KhÃ´ng bao gá»“m váº­n chuyá»ƒn & thuáº¿',0),(243190,6756,'af','Versending en Belasting Uitgesluit',0),(243191,6756,'ro','Exclusiv de transport maritim ÅŸi fiscale',0),(243192,6756,'et','VÃ¤lja arvatud tarnehind ja maksud',0),(243193,6756,'si','Razen ladijski promet in davÄne',0),(243194,6756,'ba','Termasuk pengiriman dan pajak',0),(243195,6756,'nl','Exclusief verzendkosten en BTW',0),(243196,6756,'fi','Ilman toimituskuluja ja veroja',0),(243197,6756,'no','Ekskludert frakt og avgifter',0),(243198,6756,'da','Ekskl forsendelse og skat',0),(243199,6756,'ko','ë°°ì†¡ ë° ì„¸ê¸ˆ ì œì™¸',0),(243200,6756,'he','×œ× ×›×•×œ×œ ×ž×©×œ×•×— ×•×ž×¡',0),(243201,6756,'el','Î•ÎºÏ„ÏŒÏ‚ Î±Ï€ÏŒ Î½Î±Ï…Ï„Î¹Î»Î¯Î± ÎºÎ±Î¹ Ï†ÏŒÏÎ¿Ï…',0),(243202,6756,'zh','ä¸åŒ…æ‹¬è¿è´¹å’Œç¨Žè´¹\r\n',0),(243203,6756,'sv','Exklusive frakt och moms',0),(243204,6756,'it','Escluso spedizione e tasse',0),(243205,6756,'tl','',0),(243206,6756,'th','&#3652;&#3617;&#3656;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3632;&#3616;&#3634;&#3625;&#3637;',0),(243207,6756,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤”à¤° à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥‹ à¤›à¥‹à¤¡à¤¼à¤•à¤°',0),(243208,6756,'ms','Tidak termasuk penghantaran dan cukai',0),(243209,6756,'ar','Ø¨Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ ÙˆØ§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(243210,6756,'fr','Ã€ l\'exclusion d\'expÃ©dition ni les taxes',0),(243211,6756,'jp','é€æ–™ã¨ç¨Žé‡‘ã‚’é™¤ã',0),(243212,6756,'pt','Excluindo transporte e impostos',0),(243213,6756,'ru','Ð‘ÐµÐ· ÑƒÑ‡ÐµÑ‚Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(243214,6756,'es','Excluir Transporte y Impuesto',0),(243215,6756,'de','Ohne Versandkosten und Steuern',0),(243216,6756,'en','Excluding Shipping and Tax',0),(243217,6757,'is','',0),(243218,6757,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(243219,6757,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(243220,6757,'tr','Ä°ÅŸÃ§i toplam',0),(243221,6757,'pl','Robocizna Å‚Ä…cznie',0),(243222,6757,'bg','Ð¢Ñ€ÑƒÐ´Ð° Ð¾Ð±Ñ‰Ð¾',0),(243223,6757,'ur','Ù…Ø²Ø¯ÙˆØ± Ú©ÛŒ Ú©Ù„',0),(243224,6757,'sr','Ð Ð°Ð´ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(243225,6757,'vi','Tá»•ng cá»™ng NhÃ¢n cÃ´ng',0),(243226,6757,'af','Totale Arbeid',0),(243227,6757,'ro','Total muncii',0),(243228,6757,'et','Labor kokku',0),(243229,6757,'si','Vse delo',0),(243230,6757,'ba','Total tenaga kerja',0),(243231,6757,'nl','Arbeid totaal',0),(243232,6757,'fi','TyÃ¶mÃ¤Ã¤rÃ¤ yhteensÃ¤',0),(243233,6757,'no','Ap. totalt',0),(243234,6757,'da','Labor alt',0),(243235,6757,'ko','ë…¸ë™ ì´',0),(243236,6757,'he','×¡×”\"×› ×¢×‘×•×“×”',0),(243237,6757,'el','Î£ÏÎ½Î¿Î»Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(243238,6757,'zh','åŠ³åŠ¨åŠ›æ€»äº§\r\n',0),(243239,6757,'sv','Labor totalt',0),(243240,6757,'it','Totale manodopera',0),(243241,6757,'tl','',0),(243242,6757,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;',0),(243243,6757,'hi','à¤¶à¥à¤°à¤® à¤•à¥à¤²',0),(243244,6757,'ms','Jumlah buruh',0),(243245,6757,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ù„',0),(243246,6757,'fr','Total Labor',0),(243247,6757,'jp','åŠ´åƒã®åˆè¨ˆ',0),(243248,6757,'pt','Total do trabalho',0),(243249,6757,'ru','Ð¢Ñ€ÑƒÐ´Ð° Ð²ÑÐµÐ³Ð¾',0),(243250,6757,'es','Labor Total',0),(243251,6757,'de','Labor gesamt',0),(243252,6757,'en','Labor Total',0),(243253,6758,'is','',0),(243254,6758,'dr','Ø³ÙŠØ§Ù‡',0),(243255,6758,'pr','Ø³ÙŠØ§Ù‡',0),(243256,6758,'tr','Siyah',0),(243257,6758,'pl','Czarny',0),(243258,6758,'bg','Ð§ÐµÑ€Ð½Ð¾',0),(243259,6758,'ur','Ø³ÛŒØ§Û',0),(243260,6758,'sr','Ð¦Ñ€Ð½Ð¸',0),(243261,6758,'vi','Äen',0),(243262,6758,'af','Swart',0),(243263,6758,'ro','Negru',0),(243264,6758,'et','Must',0),(243265,6758,'si','Black',0),(243266,6758,'ba','Hitam',0),(243267,6758,'nl','Black',0),(243268,6758,'fi','Musta',0),(243269,6758,'no','Svart',0),(243270,6758,'da','Sort',0),(243271,6758,'ko','ë¸”ëž™',0),(243272,6758,'he','×©×—×•×¨',0),(243273,6758,'el','ÎœÎ±ÏÏÎ¿',0),(243274,6758,'zh','é»‘è‰²\r\n',0),(243275,6758,'sv','Svart',0),(243276,6758,'it','Nero',0),(243277,6758,'tl','',0),(243278,6758,'th','&#3626;&#3637;&#3604;&#3635;',0),(243279,6758,'hi','à¤¬à¥à¤²à¥ˆà¤•',0),(243280,6758,'ms','Hitam',0),(243281,6758,'ar','Ø£Ø³ÙˆØ¯',0),(243282,6758,'fr','Black',0),(243283,6758,'jp','ãƒ–ãƒ©ãƒƒã‚¯',0),(243284,6758,'pt','Preto',0),(243285,6758,'ru','Ð§ÐµÑ€Ð½Ñ‹Ð¹',0),(243286,6758,'es','Negro',0),(243287,6758,'de','Schwarz',0),(243288,6758,'en','Black',0),(243289,6759,'is','',0),(243290,6759,'dr','Ø®ÙŠØ±',0),(243291,6759,'pr','Ø®ÙŠØ±',0),(243292,6759,'tr','DeÄŸil',0),(243293,6759,'pl','Nie',0),(243294,6759,'bg','ÐÐµ',0),(243295,6759,'ur','Ù†ÛÛŒÚº',0),(243296,6759,'sr','ÐÐµ',0),(243297,6759,'vi','KhÃ´ng',0),(243298,6759,'af','Nie',0),(243299,6759,'ro','Nu',0),(243300,6759,'et','Ei',0),(243301,6759,'si','Ne',0),(243302,6759,'ba','Tidak',0),(243303,6759,'nl','Niet',0),(243304,6759,'fi','Ei',0),(243305,6759,'no','Ikke',0),(243306,6759,'da','Ikke',0),(243307,6759,'ko','í•˜ì§€',0),(243308,6759,'he','. ×œ×',0),(243309,6759,'el','Î”ÎµÎ½',0),(243310,6759,'zh','å¦\r\n',0),(243311,6759,'sv','Inte',0),(243312,6759,'it','Non',0),(243313,6759,'tl','',0),(243314,6759,'th','&#3652;&#3617;&#3656;',0),(243315,6759,'hi','à¤¨à¤¹à¥€à¤‚',0),(243316,6759,'ms','Tidak',0),(243317,6759,'ar','Ù„Ø§',0),(243318,6759,'fr','Pas',0),(243319,6759,'jp','ãªã„',0),(243320,6759,'pt','NÃ£o',0),(243321,6759,'ru','ÐÐµ',0),(243322,6759,'es','No',0),(243323,6759,'de','Nicht',0),(243324,6759,'en','Not',0),(243325,6760,'is','',0),(243326,6760,'dr','ÙÙ‚Ø· ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(243327,6760,'pr','ÙÙ‚Ø· ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(243328,6760,'tr','YalnÄ±zca tamamlanmÄ±ÅŸ',0),(243329,6760,'pl','Tylko zakoÅ„czone',0),(243330,6760,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ ÑÐ°Ð¼Ð¾',0),(243331,6760,'ur','ØµØ±Ù Ù…Ú©Ù…Ù„',0),(243332,6760,'sr','Ð¡Ð°Ð¼Ð¾ Ð·Ð°Ð²Ñ€ÑˆÐ¸',0),(243333,6760,'vi','Chá»‰ hoÃ n thÃ nh',0),(243334,6760,'af','Slegs Voltooi',0),(243335,6760,'ro','Finalizat doar',0),(243336,6760,'et','Ainult lÃµpetatud',0),(243337,6760,'si','DokonÄano le',0),(243338,6760,'ba','Selesai hanya',0),(243339,6760,'nl','Alleen voltooid',0),(243340,6760,'fi','Valmis vain',0),(243341,6760,'no','FullfÃ¸rt bare',0),(243342,6760,'da','Afsluttet kun',0),(243343,6760,'ko','ë§Œ ì™„ë£Œ',0),(243344,6760,'he','×”×•×©×œ×ž×” ×¨×§',0),(243345,6760,'el','ÎŸÎ»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ Î¼ÏŒÎ½Î¿',0),(243346,6760,'zh','ä»…å®Œæˆ\r\n',0),(243347,6760,'sv','Avslutade endast',0),(243348,6760,'it','Completato solo',0),(243349,6760,'tl','',0),(243350,6760,'th','&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(243351,6760,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥‚à¤°à¥à¤£',0),(243352,6760,'ms','Selesai sahaja',0),(243353,6760,'ar','Ø£ÙƒÙ…Ù„Øª ÙÙ‚Ø·',0),(243354,6760,'fr','TerminÃ© seulement',0),(243355,6760,'jp','ã®ã¿å®Œæˆå“',0),(243356,6760,'pt','ConcluÃ­do apenas',0),(243357,6760,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¾ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(243358,6760,'es','Completados Solo',0),(243359,6760,'de','Nur abgeschlossen',0),(243360,6760,'en','Completed Only',0),(243361,6761,'is','',0),(243362,6761,'dr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(243363,6761,'pr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(243364,6761,'tr','EÅŸleÅŸen hiÃ§bir RMAs bulundu',0),(243365,6761,'pl','Nie pasujÄ…ce RMAs Znalezione',0),(243366,6761,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ RMAs Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(243367,6761,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø±Ù…ÛØ³ Ù¾Ø§ÛŒØ§',0),(243368,6761,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð ÐœÐÑ Ð½Ð°ÑˆÐ»Ð¸',0),(243369,6761,'vi','KhÃ´ng tÃ¬m tháº¥y RMA phÃ¹ há»£p',0),(243370,6761,'af','Geen passende RMAs gevind',0),(243371,6761,'ro','Nicio potrivire RMAs gÄƒsit',0),(243372,6761,'et','Ei leidnud vastavaid RMAs',0),(243373,6761,'si','Brez ustreznega RMAs naÅ¡el',0),(243374,6761,'ba','RMAs tidak cocok ditemukan',0),(243375,6761,'nl','Geen overeenkomende RMAs gevonden',0),(243376,6761,'fi','Ei vastaavia RMAs lÃ¶ytyi',0),(243377,6761,'no','Ingen samsvarende RMAs funnet',0),(243378,6761,'da','Ingen matchende RMAs fundet',0),(243379,6761,'ko','ì•„ë‹ˆ ì¼ì¹˜ RMAs ë°œê²¬',0),(243380,6761,'he','××™×Ÿ RMAs ×ª×•××ž×•×ª × ×ž×¦××•',0),(243381,6761,'el','Î”ÎµÎ½ ÎµÎ½Ï„Î¿Ï€Î¯ÏƒÏ„Î·ÎºÎ±Î½ RMAs Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(243382,6761,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„é€€è´§æŽˆæƒ\r\n',0),(243383,6761,'sv','Inga matchande RMA hittade',0),(243384,6761,'it','Nessun RMA corrispondente trovate',0),(243385,6761,'tl','',0),(243386,6761,'th','&#3652;&#3617;&#3656;&#3614;&#3610; RMAs ',0),(243387,6761,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ RMAs à¤ªà¤¾à¤¯à¤¾',0),(243388,6761,'ms','RMAs tiada padanan ditemui',0),(243389,6761,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ù…Ø¨ÙŠØ¹Ø§Øª Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(243390,6761,'fr','Aucun RMA correspondant trouvÃ©',0),(243391,6761,'jp','ãªã„ä¸€è‡´ã™ã‚‹ Rma ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(243392,6761,'pt','Nenhuma correspondÃªncia RMAs encontrados',0),(243393,6761,'ru','ÐÐµ ÑÐ¾Ð²Ð¿Ð°Ð´Ð°ÑŽÑ‰Ð¸Ðµ Ð·Ð°ÑÐ²ÐºÐ¸ RMA Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(243394,6761,'es','No se Encontraron RMAs Emparejados',0),(243395,6761,'de','Keine passenden RMAs gefunden',0),(243396,6761,'en','No Matching RMAs Found',0),(243397,6762,'is','',0),(243398,6762,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(243399,6762,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(243400,6762,'tr','AlÄ±nan miktar',0),(243401,6762,'pl','IloÅ›Ä‡ odebranych',0),(243402,6762,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(243403,6762,'ur','Ù…ÙˆØµÙˆÙ„Û Ù‚ÛŒ',0),(243404,6762,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ ÐšÐ¾Ð».',0),(243405,6762,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ nháº­n',0),(243406,6762,'af','Ontvangde Hoev.',0),(243407,6762,'ro','Cantit primite',0),(243408,6762,'et','VastuvÃµetud kogus',0),(243409,6762,'si','KoliÄina prejete',0),(243410,6762,'ba','Diterima Qty',0),(243411,6762,'nl','Ontvangen aantal',0),(243412,6762,'fi','Vastaanotettu mÃ¤Ã¤rÃ¤',0),(243413,6762,'no','Mottatt antall',0),(243414,6762,'da','Modtagne antal',0),(243415,6762,'ko','ë°›ì€ ìˆ˜ëŸ‰',0),(243416,6762,'he','×›×ž×•×ª ×©×”×ª×§×‘×œ×”',0),(243417,6762,'el','ÎˆÎ»Î±Î²Îµ Qty',0),(243418,6762,'zh','æ”¶åˆ°çš„æ•°é‡\r\n',0),(243419,6762,'sv','Mottagna Kvt',0),(243420,6762,'it','Qty ricevuti',0),(243421,6762,'tl','',0),(243422,6762,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(243423,6762,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(243424,6762,'ms','Qty diterima',0),(243425,6762,'ar','Ø§Ù„ÙƒÙ…Ù‘ÙŠØ© Ø§Ù„Ù…Ø³ØªÙ„Ù…Ø©',0),(243426,6762,'fr','QuantitÃ© reÃ§ue',0),(243427,6762,'jp','å—ä¿¡ã—ãŸæ•°é‡',0),(243428,6762,'pt','Qty recebido',0),(243429,6762,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ð¾Ðµ ÐšÐ¾Ð»-Ð²Ð¾',0),(243430,6762,'es','Cant. Recibida',0),(243431,6762,'de','Erhaltene Anz',0),(243432,6762,'en','Received Qty',0),(243433,6763,'is','',0),(243434,6763,'dr','ÙƒØ¯ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(243435,6763,'pr','ÙƒØ¯ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(243436,6763,'tr','RMA',0),(243437,6763,'pl','RMA',0),(243438,6763,'bg','Ð Ð¡Ðž',0),(243439,6763,'ur','Ø±Ù…',0),(243440,6763,'sr','ÐžÐŸÐ¡',0),(243441,6763,'vi','RMA',0),(243442,6763,'af','RMA',0),(243443,6763,'ro','RMA',0),(243444,6763,'et','RMA',0),(243445,6763,'si','RMA',0),(243446,6763,'ba','RMA',0),(243447,6763,'nl','RMA',0),(243448,6763,'fi','RMA',0),(243449,6763,'no','RMA',0),(243450,6763,'da','RMA',0),(243451,6763,'ko','RMA',0),(243452,6763,'he','RMA',0),(243453,6763,'el','RMA',0),(243454,6763,'zh','è¿”å›žå•†å“æŽˆæƒ\r\n',0),(243455,6763,'sv','RMA',0),(243456,6763,'it','RMA',0),(243457,6763,'tl','',0),(243458,6763,'th','RMA',0),(243459,6763,'hi','RMA',0),(243460,6763,'ms','RMA',0),(243461,6763,'ar','Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(243462,6763,'fr','RMA',0),(243463,6763,'jp','RMA',0),(243464,6763,'pt','RMA',0),(243465,6763,'ru','RMA',0),(243466,6763,'es','RMA',0),(243467,6763,'de','RMA',0),(243468,6763,'en','RMA',0),(243469,6764,'is','',0),(243470,6764,'dr','ØªØ§Ø±ÙŠØ® Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(243471,6764,'pr','ØªØ§Ø±ÙŠØ® Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(243472,6764,'tr','RMA tarihi',0),(243473,6764,'pl','Data RMA',0),(243474,6764,'bg','Ð Ð¡Ðž Ð´Ð°Ñ‚Ð°',0),(243475,6764,'ur','Ø±Ù… Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(243476,6764,'sr','ÐžÐ¿Ñ Ð´Ð°Ñ‚ÑƒÐ¼',0),(243477,6764,'vi','NgÃ y RMA',0),(243478,6764,'af','RMA datum',0),(243479,6764,'ro','RMA data',0),(243480,6764,'et','Tagastuse kuupÃ¤ev',0),(243481,6764,'si','RMA datum',0),(243482,6764,'ba','Tanggal RMA',0),(243483,6764,'nl','RMA datum',0),(243484,6764,'fi','RMA pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(243485,6764,'no','RMA dato',0),(243486,6764,'da','RMA dato',0),(243487,6764,'ko','RMA ë‚ ì§œ',0),(243488,6764,'he','×ª××¨×™×š RMA',0),(243489,6764,'el','RMA Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(243490,6764,'zh','è¿”å›žå•†å“æŽˆæƒæ—¥æœŸ\r\n',0),(243491,6764,'sv','RMA datum',0),(243492,6764,'it','RMA data',0),(243493,6764,'tl','',0),(243494,6764,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656; RMA',0),(243495,6764,'hi','RMA à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(243496,6764,'ms','RMA tarikh',0),(243497,6764,'ar','ØªØ§Ø±ÙŠØ® Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(243498,6764,'fr','Date RMA',0),(243499,6764,'jp','RMA ã®æ—¥ä»˜',0),(243500,6764,'pt','Data RMA',0),(243501,6764,'ru','Ð”Ð°Ñ‚Ð° RMA',0),(243502,6764,'es','RMA Fecha',0),(243503,6764,'de','RMA-Datum',0),(243504,6764,'en','RMA Date',0),(243505,6765,'is','',0),(243506,6765,'dr','Ù„ÙŠØ³Øª Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(243507,6765,'pr','Ù„ÙŠØ³Øª Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(243508,6765,'tr','RMA listesi',0),(243509,6765,'pl','Lista RMA',0),(243510,6765,'bg','Ð Ð¡Ðž ÑÐ¿Ð¸ÑÑŠÐº',0),(243511,6765,'ur','Ø±Ù… Ú©ÛŒ ÙÛØ±Ø³Øª',0),(243512,6765,'sr','ÐžÐ¿Ñ Ð»Ð¸ÑÑ‚Ð°',0),(243513,6765,'vi','Danh sÃ¡ch RMA',0),(243514,6765,'af','RMA lys',0),(243515,6765,'ro','RMA lista',0),(243516,6765,'et','RMA nimekiri',0),(243517,6765,'si','RMA seznam',0),(243518,6765,'ba','Daftar RMA',0),(243519,6765,'nl','RMA lijst',0),(243520,6765,'fi','RMA luettelo',0),(243521,6765,'no','RMA-listen',0),(243522,6765,'da','RMA liste',0),(243523,6765,'ko','RMA ëª©ë¡',0),(243524,6765,'he','×¨×©×™×ž×ª RMA',0),(243525,6765,'el','RMA Î»Î¯ÏƒÏ„Î±',0),(243526,6765,'zh','è¿”å›žå•†å“æŽˆæƒåˆ—è¡¨\r\n',0),(243527,6765,'sv','RMA lista',0),(243528,6765,'it','Elenco RMA',0),(243529,6765,'tl','',0),(243530,6765,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; RMA ',0),(243531,6765,'hi','RMA à¤¸à¥‚à¤šà¥€',0),(243532,6765,'ms','RMA senarai',0),(243533,6765,'ar','Ù‚Ø§Ø¦Ù…Ø© Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(243534,6765,'fr','Liste RMA',0),(243535,6765,'jp','RMA ã®ãƒªã‚¹ãƒˆ',0),(243536,6765,'pt','Lista RMA',0),(243537,6765,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº RMA',0),(243538,6765,'es','RMA Lista',0),(243539,6765,'de','RMA-Liste',0),(243540,6765,'en','RMA List',0),(243541,6766,'is','',0),(243542,6766,'dr','Ù„ÙŠØ³Øª Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ø§ÙŠ',0),(243543,6766,'pr','Ù„ÙŠØ³Øª Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ø§ÙŠ',0),(243544,6766,'tr','RMA listesi iÃ§in',0),(243545,6766,'pl','Lista RMA',0),(243546,6766,'bg','Ð Ð¡Ðž ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð°',0),(243547,6766,'ur','Ø±Ù… Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’',0),(243548,6766,'sr','ÐžÐ¿Ñ Ð»Ð¸ÑÑ‚Ðµ Ð·Ð°',0),(243549,6766,'vi','Danh sÃ¡ch RMA cho',0),(243550,6766,'af','RMA lys vir',0),(243551,6766,'ro','Lista RMA pentru',0),(243552,6766,'et','RMA Nimekiri',0),(243553,6766,'si','RMA seznam za',0),(243554,6766,'ba','Daftar RMA',0),(243555,6766,'nl','RMA lijst voor',0),(243556,6766,'fi','RMA luettelo',0),(243557,6766,'no','RMA-listen For',0),(243558,6766,'da','RMA liste For',0),(243559,6766,'ko','ëŒ€ í•œ RMA ëª©ë¡',0),(243560,6766,'he','×¨×©×™×ž×ª RMA',0),(243561,6766,'el','RMA Î»Î¯ÏƒÏ„Î± Î³Î¹Î±',0),(243562,6766,'zh','è¿”å›žå•†å“æŽˆæƒæ¸…å•\r\n',0),(243563,6766,'sv','RMA listan fÃ¶r',0),(243564,6766,'it','Elenco RMA per',0),(243565,6766,'tl','',0),(243566,6766,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; RMA &#3648;&#3614;&#3639;&#3656;&#3629;',0),(243567,6766,'hi','RMA à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(243568,6766,'ms','RMA senarai untuk',0),(243569,6766,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬ÙŠØ´ Ø§Ù„Ù…Ù„ÙƒÙŠ Ø§Ù„Ù…ØºØ±Ø¨ÙŠ',0),(243570,6766,'fr','Liste RMA pour',0),(243571,6766,'jp','RMA ã®ãƒªã‚¹ãƒˆ',0),(243572,6766,'pt','Lista RMA para',0),(243573,6766,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº RMA Ð´Ð»Ñ',0),(243574,6766,'es','RMA Lista Para',0),(243575,6766,'de','RMA-Liste fÃ¼r',0),(243576,6766,'en','RMA List For',0),(243577,6767,'is','',0),(243578,6767,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(243579,6767,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(243580,6767,'tr','Madde iade numarasÄ±',0),(243581,6767,'pl','Numer RMA',0),(243582,6767,'bg','RMA Ð½Ð¾Ð¼ÐµÑ€',0),(243583,6767,'ur','Ø±Ù… Ù†Ù…Ø¨Ø±',0),(243584,6767,'sr','ÐžÐ¿Ñ Ð±Ñ€Ð¾Ñ˜',0),(243585,6767,'vi','Sá»‘ RMA',0),(243586,6767,'af','RMA nommer',0),(243587,6767,'ro','NumÄƒrul RMA',0),(243588,6767,'et','Tagastatud kauba kood',0),(243589,6767,'si','NapiÅ¡ite Å¡tevilko RMA',0),(243590,6767,'ba','Nomor RMA',0),(243591,6767,'nl','RMA-nummer',0),(243592,6767,'fi','RMA-numero',0),(243593,6767,'no','RMA-nummer',0),(243594,6767,'da','RMA-nummer',0),(243595,6767,'ko','RMA ë²ˆí˜¸',0),(243596,6767,'he','×ž×¡×¤×¨ RMA',0),(243597,6767,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ RMA',0),(243598,6767,'zh','å•†å“é€€è´§æŽˆæƒå·ç \r\n',0),(243599,6767,'sv','RMA-nummer',0),(243600,6767,'it','Numero RMA',0),(243601,6767,'tl','',0),(243602,6767,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586; RMA ',0),(243603,6767,'hi','RMA à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(243604,6767,'ms','RMA nombor',0),(243605,6767,'ar','Ø±Ù‚Ù… Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(243606,6767,'fr','NumÃ©ro de RMA',0),(243607,6767,'jp','RMA ç•ªå·',0),(243608,6767,'pt','NÃºmero de RMA',0),(243609,6767,'ru','ÐÐ¾Ð¼ÐµÑ€ RMA',0),(243610,6767,'es','RMA NÃºmero',0),(243611,6767,'de','RMA-Nummer',0),(243612,6767,'en','RMA Number',0),(243613,6768,'is','',0),(243614,6768,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(243615,6768,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(243616,6768,'tr','RMA Mkt.',0),(243617,6768,'pl','IloÅ›Ä‡ RMA',0),(243618,6768,'bg','Ð Ð¡Ðž ÐºÐ¾Ð»',0),(243619,6768,'ur','Ø±Ù… Ù‚ÛŒ',0),(243620,6768,'sr','ÐžÐ¿Ñ , ÐšÐ¾Ð».',0),(243621,6768,'vi','Sá»‘ lÆ°á»£ng RMA',0),(243622,6768,'af','\"RMA\" Hoev.',0),(243623,6768,'ro','RMA cantit',0),(243624,6768,'et','Tagastatud kauba kogus',0),(243625,6768,'si','RMA kol',0),(243626,6768,'ba','RMA Qty',0),(243627,6768,'nl','RMA Qty',0),(243628,6768,'fi','RMA mÃ¤Ã¤rÃ¤',0),(243629,6768,'no','RMA Ant',0),(243630,6768,'da','RMA Qty',0),(243631,6768,'ko','RMA ìˆ˜ëŸ‰',0),(243632,6768,'he','×›×ž×•×ª RMA',0),(243633,6768,'el','RMA Qty',0),(243634,6768,'zh','è¿”å›žå•†å“æŽˆæƒæ•°é‡\r\n',0),(243635,6768,'sv','RMA Kvt',0),(243636,6768,'it','RMA Qty',0),(243637,6768,'tl','',0),(243638,6768,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603; RMA ',0),(243639,6768,'hi','RMA à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(243640,6768,'ms','RMA Qty',0),(243641,6768,'ar','ÙƒÙ…Ù‘ÙŠÙ‘Ø© Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(243642,6768,'fr','QtÃ© RMA',0),(243643,6768,'jp','RMA ã®æ•°é‡',0),(243644,6768,'pt','Qtde RMA',0),(243645,6768,'ru','RMA Qty',0),(243646,6768,'es','RMA Cant.',0),(243647,6768,'de','RMA Qty',0),(243648,6768,'en','RMA Qty',0),(243649,6769,'is','',0),(243650,6769,'dr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡  Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø´Ù…Ø§ Ø§Ø³Øª',0),(243651,6769,'pr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡  Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø´Ù…Ø§ Ø§Ø³Øª',0),(243652,6769,'tr','BaÄŸlÄ± olduÄŸunu Your alÄ±ntÄ±',0),(243653,6769,'pl','DoÅ‚Ä…czony jest twÃ³j cytat',0),(243654,6769,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¾ Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(243655,6769,'ur','Ø§Ù¾Ù†Ø§ Ø§Ù‚ØªØ¨Ø§Ø³ ÛÛ’ Ù…Ù†Ø³Ù„Ú©',0),(243656,6769,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ Ñ˜Ðµ Ð²Ð°ÑˆÐ° Ð¿Ð¾Ð½ÑƒÐ´Ð°',0),(243657,6769,'vi','KÃ¨m Theo lÃ  Báº£ng BÃ¡o GiÃ¡ Cá»§a Báº¡n',0),(243658,6769,'af','U Kwotasie is Aangeheg',0),(243659,6769,'ro','AtaÅŸat este citat dumneavoastrÄƒ',0),(243660,6769,'et','Lisatud on teie tsitaat',0),(243661,6769,'si','PriloÅ¾en je vaÅ¡a ponudba',0),(243662,6769,'ba','Terlampir adalah kutipan Anda',0),(243663,6769,'nl','Bijgevoegd is uw citeren',0),(243664,6769,'fi','LiitteenÃ¤ on Your lainata',0),(243665,6769,'no','Vedlagt er ditt tilbud',0),(243666,6769,'da','VedhÃ¦ftet er dit citat',0),(243667,6769,'ko','ë‹¹ì‹ ì˜ ì¸ìš©ì€ ì²¨ë¶€',0),(243668,6769,'he','×ž×¦×•×¨×¤×ª ×”×¦×¢×ª ×ž×—×™×¨ ×©×œ×š',0),(243669,6769,'el','Î£Ï…Î½Î·Î¼Î¼Î­Î½Î¿ ÎµÎ¯Î½Î±Î¹ Î½Î± ÏƒÎ±Ï‚ Ï€Î±ÏÎ±Î¸Î­ÏƒÏ‰',0),(243670,6769,'zh','éšä¿¡é™„ä¸Šæ‚¨çš„æŠ¥ä»·\r\n',0),(243671,6769,'sv','Bifogat Ã¤r din offert',0),(243672,6769,'it','In allegato Ã¨ citare il tuo',0),(243673,6769,'tl','',0),(243674,6769,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3649;&#3609;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(243675,6769,'hi','à¤¸à¥‡ à¤œà¥à¤¡à¤¼à¥€ à¤†à¤ªà¤•à¥€ à¤¬à¥‹à¤²à¥€ à¤¹à¥ˆ',0),(243676,6769,'ms','Berikut adalah sebut harga anda',0),(243677,6769,'ar','Ù…Ø±ÙÙ‚ Ø¹Ø±Ø¶Ùƒ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(243678,6769,'fr','AttachÃ© est votre cite',0),(243679,6769,'jp','æ·»ä»˜ã‚ãªãŸã®å¼•ç”¨ã§ã™ã€‚',0),(243680,6769,'pt','Em anexo Ã© citar seu',0),(243681,6769,'ru','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ Ð²Ð°ÑˆÐ° Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(243682,6769,'es','Anexado es su CotizaciÃ³n',0),(243683,6769,'de','Angeschlossen ist Ihr Zitat',0),(243684,6769,'en','Attached is Your Quote',0),(243685,6770,'is','',0),(243686,6770,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(243687,6770,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(243688,6770,'tr','Sevk irsaliyesi',0),(243689,6770,'pl','WysyÅ‚ka',0),(243690,6770,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(243691,6770,'ur','Ú©Ú¾ÛŒÙ¾',0),(243692,6770,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(243693,6770,'vi','Chuyáº¿n HÃ ng',0),(243694,6770,'af','Besending',0),(243695,6770,'ro','Expediere',0),(243696,6770,'et','Saadetise',0),(243697,6770,'si','Dobavnice',0),(243698,6770,'ba','Pengiriman',0),(243699,6770,'nl','Verzending',0),(243700,6770,'fi','Toimitus',0),(243701,6770,'no','Forsendelse',0),(243702,6770,'da','Forsendelse',0),(243703,6770,'ko','ì„ ì ',0),(243704,6770,'he','×ž×©×œ×•×—',0),(243705,6770,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(243706,6770,'zh','è£…è¿\r\n',0),(243707,6770,'sv','Transport',0),(243708,6770,'it','Spedizione',0),(243709,6770,'tl','',0),(243710,6770,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(243711,6770,'hi','à¤²à¤¦à¤¾à¤¨',0),(243712,6770,'ms','Penghantaran',0),(243713,6770,'ar','Ø§Ù„Ø´Ø­Ù†Ø©',0),(243714,6770,'fr','ExpÃ©dition',0),(243715,6770,'jp','å‡ºè·',0),(243716,6770,'pt','ExpediÃ§Ã£o',0),(243717,6770,'ru','ÐžÑ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(243718,6770,'es','EnvÃ­o',0),(243719,6770,'de','Versand',0),(243720,6770,'en','Shipment',0),(243721,6771,'is','',0),(243722,6771,'dr','(Ù…ÙØ§Ø¯',0),(243723,6771,'pr','Ø§Ø±Ø²Ø´(Ø³ÙˆØ¯',0),(243724,6771,'tr','BoÅŸuna',0),(243725,6771,'pl','SkorzystaÄ‡',0),(243726,6771,'bg','Ð£ÑÐ¿ÐµÑ…',0),(243727,6771,'ur','ÙØ§Ø¦Ø¯Û',0),(243728,6771,'sr','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¾ÑÑ‚',0),(243729,6771,'vi','CÃ³ Sáºµn',0),(243730,6771,'af','Beskikb',0),(243731,6771,'ro','Folos',0),(243732,6771,'et','Kasutada',0),(243733,6771,'si','Uspeha',0),(243734,6771,'ba','Memanfaatkan',0),(243735,6771,'nl','Gebruik',0),(243736,6771,'fi','KÃ¤yttÃ¤Ã¤',0),(243737,6771,'no','Benytte',0),(243738,6771,'da','Nytte',0),(243739,6771,'ko','ì†Œìš©',0),(243740,6771,'he','×”×•×¢×™×œ',0),(243741,6771,'el','Î”Î¹Î±Î¸',0),(243742,6771,'zh','æ•ˆç”¨\r\n',0),(243743,6771,'sv','Utnyttja',0),(243744,6771,'it','Approfitta',0),(243745,6771,'tl','',0),(243746,6771,'th','&#3611;&#3619;&#3632;&#3650;&#3618;&#3594;&#3609;&#3660;',0),(243747,6771,'hi','à¤²à¤¾à¤­ à¤²à¥‡',0),(243748,6771,'ms','Sia-sia',0),(243749,6771,'ar','Ø§Ù„Ø§Ø³ØªÙØ§Ø¯Ø©',0),(243750,6771,'fr','Dispo',0),(243751,6771,'jp','å½¹ã«ç«‹ã¤',0),(243752,6771,'pt','Sucesso',0),(243753,6771,'ru','ÐŸÐ¾Ð¼Ð¾Ð³Ð»Ð¾',0),(243754,6771,'es','Aprovechar',0),(243755,6771,'de','Erfolg',0),(243756,6771,'en','Avail',0),(243757,6772,'is','',0),(243758,6772,'dr','Ø§Ú¯Ø± ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆÙ†Ø¯ â€“ Ø¨Ø§ÙŠØ¯ Ù‡Ù…Ú†Ù†ÙŠÙ† ØªØ¹Ø¯Ø§Ø¯ÙŠ Ø§Ø² Ù…Ø¹ÙŠØ§Ø±Ù‡Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(243759,6772,'pr','Ø§Ú¯Ø± ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆÙ†Ø¯ â€“ Ø¨Ø§ÙŠØ¯ Ù‡Ù…Ú†Ù†ÙŠÙ† ØªØ¹Ø¯Ø§Ø¯ÙŠ Ø§Ø² Ù…Ø¹ÙŠØ§Ø±Ù‡Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(243760,6772,'tr','TÃ¼m sipariÅŸler-Must seÃ§erek de bazÄ± diÄŸer arama Ã¶lÃ§Ã¼tlerini girerseniz',0),(243761,6772,'pl','JeÅ¼eli wybranie wszystkich zamÃ³wieÅ„ musi takÅ¼e niektÃ³re inne kryteria wyszukiwania',0),(243762,6772,'bg','ÐÐºÐ¾ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸-Ñ‚Ñ€ÑÐ±Ð²Ð° ÑÑŠÑ‰Ð¾ Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½ÑÐºÐ¾Ð¸ Ð´Ñ€ÑƒÐ³Ð¸ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ð¸ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(243763,6772,'ur','Ø§Ú¯Ø± ØªÙ…Ø§Ù… Ø¶Ø±ÙˆØ±ÛŒ Ø§Ø­Ú©Ø§Ù… Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ú©Û’ Ø¨Ú¾ÛŒ Ú©Ú†Ú¾ Ø¯ÛŒÚ¯Ø± ØªÙ„Ø§Ø´ Ú©Ø³ÙˆÙ¹ÛŒ Ø¯Ø§Ø®Ù„',0),(243764,6772,'sr','ÐÐºÐ¾ Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ²Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ-Ð¾Ð²Ð°Ñ˜ Ð¼Ð¾Ñ€Ð° Ñ‚Ð°ÐºÐ¾Ñ’Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð½ÐµÐºÐµ Ð´Ñ€ÑƒÐ³Ðµ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ñ˜ÑƒÐ¼Ðµ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(243765,6772,'vi','Náº¿u chá»n táº¥t cáº£ Ä‘Æ¡n Ä‘áº·t hÃ ng pháº£i nháº­p má»™t sá»‘ tiÃªu chÃ­ tÃ¬m kiáº¿m',0),(243766,6772,'af','Indien Alle Bestellings gekies word - Moet daar ook ander Soek Kriteria ingevoer word',0),(243767,6772,'ro','DacÄƒ selectÃ¢nd toate ordinele-trebuie sÄƒ introduceÅ£i, de asemenea, unele alte criterii de cÄƒutare',0),(243768,6772,'et','Kui valite kÃµik tellimused-Must sisestada ka mÃµned muud otsingukriteeriumid',0),(243769,6772,'si','ÄŒe izberete vse naloge treba vnesti tudi nekatere druge iskalne kriterije',0),(243770,6772,'ba','Jika Memilih Semua Pesanan-Harus Dimasukkan beberapa kriteria pencarian',0),(243771,6772,'nl','Als ook sommige andere zoekcriteria selecteren alle Orders moet invoeren',0),(243772,6772,'fi','Jos valitset kaikki tilaukset on myÃ¶s muut hakuehdot',0),(243773,6772,'no','Hvis merke alle ordrer-mÃ¥ ogsÃ¥ angi noen andre sÃ¸kekriterier',0),(243774,6772,'da','Hvis du vÃ¦lger alle ordrer-skal ogsÃ¥ angive nogle andre sÃ¸gekriterier',0),(243775,6772,'ko','ë‹¤ë¥¸ ê²€ìƒ‰ ì¡°ê±´ì„ ìž…ë ¥ ë˜í•œ ëª¨ë“  ì£¼ë¬¸ í•´ì•¼ ì„ íƒ',0),(243776,6772,'he','×× ×’× ×‘×—×™×¨×ª ×›×œ ×”×–×ž× ×•×ª-×—×•×‘×” ×œ×”×–×™×Ÿ ×§×¨×™×˜×¨×™×•× ×™× ×—×™×¤×•×© ××—×¨×™×',0),(243777,6772,'el','Î•Î¬Î½ Î· ÎµÏ€Î¹Î»Î¿Î³Î® ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚-Ï€ÏÎ­Ï€ÎµÎ¹ ÎµÏ€Î¯ÏƒÎ·Ï‚ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ ÎºÎ¬Ï€Î¿Î¹Î± Î¬Î»Î»Î± ÎºÏÎ¹Ï„Î®ÏÎ¹Î± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(243778,6772,'zh','å¦‚æžœé€‰æ‹©æ‰€æœ‰è®¢å•ï¼Œè¿˜å¿…é¡»è¾“å…¥ä¸€äº›å…¶ä»–æœç´¢æ ‡å‡†\r\n',0),(243779,6772,'sv','Om du vÃ¤ljer alla bestÃ¤llningar-mÃ¥ste Ã¤ven vissa andra sÃ¶kkriterier',0),(243780,6772,'it','Se selezionando tutti gli ordini-deve inserire anche alcuni altri criteri di ricerca',0),(243781,6772,'tl','',0),(243782,6772,'th','If Selecting All Orders-Must Also Enter Some Other Search Criteria',0),(243783,6772,'hi','à¤¸à¤­à¥€ à¤†à¤¦à¥‡à¤¶-à¤¹à¥‹à¤—à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤­à¥€ à¤•à¥à¤› à¤…à¤¨à¥à¤¯ à¤–à¥‹à¤œ à¤®à¤¾à¤ªà¤¦à¤‚à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(243784,6772,'ms','Jika memilih semua pesanan mestilah juga memasukkan beberapa kriteria carian lain',0),(243785,6772,'ar','Ø¥Ø°Ø§ Ø§Ø®ØªØ±Øª ÙƒÙ„Ù‘ Ø§Ù„Ø·Ù„Ø¨ÙŠØ§Øª ØŒ ÙÙ„Ø§ Ø¨Ø¯Ù‘ Ø£ÙŠØ¶Ø§ Ù…Ù† Ø¥Ø¯Ø®Ø§Ù„ Ø¨Ø¹Ø¶ Ù…Ø¹Ø§ÙŠÙŠØ± Ø§Ù„Ø¨Ø­Ø« Ø§Ù„Ø£Ø®Ø±Ù‰',0),(243786,6772,'fr','Si la sÃ©lection de toutes les commandes doivent Ã©galement saisir dâ€™autres critÃ¨res de recherche',0),(243787,6772,'jp','ãã®ä»–ã®æ¤œç´¢æ¡ä»¶ã‚’å…¥åŠ›ã‚‚ã™ã¹ã¦æ³¨æ–‡å¿…è¦ãŒã‚ã‚Šã¾ã™ã‚’é¸æŠžã™ã‚‹å ´åˆ',0),(243788,6772,'pt','Se seleccionar todos os pedidos-deve tambÃ©m inserir alguns outros critÃ©rios de pesquisa',0),(243789,6772,'ru','Ð•ÑÐ»Ð¸ Ð’Ñ‹Ð±Ð¸Ñ€Ð°ÑŽÑ‚ÑÑ Ð’ÑÐµ Ð—Ð°ÐºÐ°Ð·Ñ‹-ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð’Ð²ÐµÑÑ‚Ð¸ Ð”Ñ€ÑƒÐ³Ð¾Ð¹ ÐšÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ð¹ ÐŸÐ¾Ð¸ÑÐºÐ°',0),(243790,6772,'es','Si Selecciona Todos los Ordenes-Debe Introducir Algunos Otros Criterios de Busqueda',0),(243791,6772,'de','Wenn alle Bestellungen-muss die Auswahl auch einige andere Suchkriterien eingeben',0),(243792,6772,'en','If Selecting All Orders-Must Also Enter Some Other Search Criteria',0),(243793,6773,'is','',0),(243794,6773,'dr','Opt  Ú¯Ø²ÙŠÙ†Ù‡ ',0),(243795,6773,'pr','Opt  Ú¯Ø²ÙŠÙ†Ù‡ ',0),(243796,6773,'tr','Opt',0),(243797,6773,'pl','WybraÄ‡',0),(243798,6773,'bg','ÐžÑ‚ÐºÐ°Ð¶ÐµÑ‚Ðµ',0),(243799,6773,'ur','Ø¢Ù¾Ù¹ Ø¢Ø¤Ù¹',0),(243800,6773,'sr','ÐžÐ´Ð»ÑƒÑ‡ÑƒÑ˜Ñƒ',0),(243801,6773,'vi','Pháº£i',0),(243802,6773,'af','Kies',0),(243803,6773,'ro','Opta',0),(243804,6773,'et','Valida, kas',0),(243805,6773,'si','Opt',0),(243806,6773,'ba','Memilih',0),(243807,6773,'nl','Opt',0),(243808,6773,'fi','Valita',0),(243809,6773,'no','Velge',0),(243810,6773,'da','Opt',0),(243811,6773,'ko','ì„ íƒ',0),(243812,6773,'he','×œ×‘×—×•×¨',0),(243813,6773,'el','Î•Ï€Î¹Î»Î­Î¾Î¿Ï…Î½',0),(243814,6773,'zh','é€‰æ‹©\r\n',0),(243815,6773,'sv','Opt',0),(243816,6773,'it','Optare',0),(243817,6773,'tl','',0),(243818,6773,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(243819,6773,'hi','à¤‘à¤ªà¥à¤Ÿ',0),(243820,6773,'ms','Memilih',0),(243821,6773,'ar','ØªØ®ØªØ§Ø±',0),(243822,6773,'fr','Opt',0),(243823,6773,'jp','é¸ã¶',0),(243824,6773,'pt','Opt',0),(243825,6773,'ru','ÐžÐŸÐ¢',0),(243826,6773,'es','Optar',0),(243827,6773,'de','Opt',0),(243828,6773,'en','Opt',0),(243829,6774,'is','',0),(243830,6774,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(243831,6774,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ ',0),(243832,6774,'tr','Ä°hale tutarÄ±',0),(243833,6774,'pl','IloÅ›Ä‡ produktu wyraÅ¼onÄ… w',0),(243834,6774,'bg','ÐžÑ„ÐµÑ€Ð¸Ñ€Ð°Ð½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(243835,6774,'ur','Ø·Ø±Ø­ Ø¯Ù„Ú©Ø´ Ø±Ù‚Ù…',0),(243836,6774,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾Ð´Ð½ÐµÐ¾',0),(243837,6774,'vi','Sá»‘ Tiá»n Äá» Nghá»‹',0),(243838,6774,'af','Bedrag Aangebied',0),(243839,6774,'ro','SumÄƒ ofertatÄƒ',0),(243840,6774,'et','Pakutav summa',0),(243841,6774,'si','Razpisano koliÄino',0),(243842,6774,'ba','Jumlah ditenderkan',0),(243843,6774,'nl','Bedrag in het bod ingebracht',0),(243844,6774,'fi','Tarjottu mÃ¤Ã¤rÃ¤',0),(243845,6774,'no','BelÃ¸pet tilbudt',0),(243846,6774,'da','Tilbudte belÃ¸b',0),(243847,6774,'ko','ìœ„íƒ ê¸ˆì•¡',0),(243848,6774,'he','×›×ž×•×ª ×”×’×©×ª',0),(243849,6774,'el','Î ÏÎ¿ÏƒÏ†ÎµÏÏŒÎ¼ÎµÎ½Î¿ Ï€Î¿ÏƒÏŒ',0),(243850,6774,'zh','æ‰¿æŠ•é‡‘é¢\r\n',0),(243851,6774,'sv','Beloppet inlÃ¤mnade',0),(243852,6774,'it','Importo offerto',0),(243853,6774,'tl','',0),(243854,6774,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3651;&#3610;&#3611;&#3619;&#3632;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3618;&#3639;&#3656;&#3609;',0),(243855,6774,'hi','à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤ à¤°à¤¾à¤¶à¤¿',0),(243856,6774,'ms','Amaun yang ditender',0),(243857,6774,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø¹Ø·Ø§Ø¡Ø§Øª',0),(243858,6774,'fr','Montant offert',0),(243859,6774,'jp','çµ¦ä»˜é¡',0),(243860,6774,'pt','Montante proposto',0),(243861,6774,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ñ‚Ð¾Ñ€Ð³Ð¸',0),(243862,6774,'es','Cantidad Presentado',0),(243863,6774,'de','Betrag ausgeschrieben',0),(243864,6774,'en','Amount Tendered',0),(243865,6775,'is','',0),(243866,6775,'dr','ØªØºÙŠÙŠØ± Ø¨Ø¯Ù‡ÙŠ',0),(243867,6775,'pr','ØªØºÙŠÙŠØ± Ø¨Ø¯Ù‡ÙŠ',0),(243868,6775,'tr','Son deÄŸiÅŸtirme',0),(243869,6775,'pl','Zmiany ze wzglÄ™du',0),(243870,6775,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶',0),(243871,6775,'ur','ÙˆØ§Ø¬Ø¨ Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(243872,6775,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸',0),(243873,6775,'vi','Thay Ä‘á»•i ká»³ háº¡n',0),(243874,6775,'af','Kleingeld Verskuldig',0),(243875,6775,'ro','Schimba cuvenit',0),(243876,6775,'et','TÃ¤htaja muutmiseks',0),(243877,6775,'si','Spremembo zapadlosti',0),(243878,6775,'ba','Mengubah Due',0),(243879,6775,'nl','Due wijzigen',0),(243880,6775,'fi','Muuttaa asianmukaisesti',0),(243881,6775,'no','Endre forfallsdato',0),(243882,6775,'da','Ã†ndre Due',0),(243883,6775,'ko','ê¸°í•œ ë³€ê²½',0),(243884,6775,'he','×¢×•×“×£',0),(243885,6775,'el','Î‘Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î· Î´Î­Î¿Ï…ÏƒÎ±',0),(243886,6775,'zh','æ”¹å˜æˆªæ­¢\r\n',0),(243887,6775,'sv','Ã„ndra fÃ¶rfallodatum',0),(243888,6775,'it','Cambiare dovuta',0),(243889,6775,'tl','',0),(243890,6775,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3623;&#3633;&#3609;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(243891,6775,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¬à¤¦à¤²',0),(243892,6775,'ms','Tukar habis tempoh',0),(243893,6775,'ar','ØªØºÙŠÙŠØ± Ø§Ù„ÙˆØ§Ø¬Ø¨',0),(243894,6775,'fr','Changer rÃ©guliÃ¨re',0),(243895,6775,'jp','æœŸé™ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(243896,6775,'pt','Alterar vencimento',0),(243897,6775,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÐ²Ð¾Ðµ',0),(243898,6775,'es','Cambiar Fecha de Vencimiento',0),(243899,6775,'de','Due Ã¤ndern',0),(243900,6775,'en','Change Due',0),(243901,6776,'is','',0),(243902,6776,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù‡Ø²ÙŠÙ†Ù‡',0),(243903,6776,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù‡Ø²ÙŠÙ†Ù‡',0),(243904,6776,'tr','Ãœcret tutarÄ±',0),(243905,6776,'pl','Kwota opÅ‚aty',0),(243906,6776,'bg','Ð¡ÑƒÐ¼Ð°Ñ‚Ð° Ñ‚Ð°ÐºÑÐ°',0),(243907,6776,'ur','Ú†Ø§Ø±Ø¬ Ø±Ù‚Ù…',0),(243908,6776,'sr','Ð˜Ð·Ð½Ð¾Ñ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(243909,6776,'vi','Sá»‘ tiá»n phÃ­',0),(243910,6776,'af','Bedrag Gehef',0),(243911,6776,'ro','Suma taxei',0),(243912,6776,'et','Tasu summa',0),(243913,6776,'si','Zneska stroÅ¡ka',0),(243914,6776,'ba','Jumlah biaya',0),(243915,6776,'nl','Toeslagbedrag',0),(243916,6776,'fi','Kulujen summa',0),(243917,6776,'no','BelÃ¸p',0),(243918,6776,'da','GebyrbelÃ¸bet',0),(243919,6776,'ko','ì¶©ì „ ê¸ˆì•¡',0),(243920,6776,'he','×¡×›×•× ×—×™×•×‘',0),(243921,6776,'el','Î Î¿ÏƒÏŒ ÎµÏ€Î¹Î²Î¬ÏÏ…Î½ÏƒÎ·Ï‚',0),(243922,6776,'zh','æ”¶è´¹é‡‘é¢\r\n',0),(243923,6776,'sv','Avgift belopp',0),(243924,6776,'it','QuantitÃ  di carica',0),(243925,6776,'tl','',0),(243926,6776,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(243927,6776,'hi','à¤¶à¥à¤²à¥à¤• à¤°à¤¾à¤¶à¤¿',0),(243928,6776,'ms','Jumlah caj',0),(243929,6776,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ',0),(243930,6776,'fr','Montant frais',0),(243931,6776,'jp','è«‹æ±‚é¡',0),(243932,6776,'pt','Quantidade de carga',0),(243933,6776,'ru','Ð¡ÑƒÐ¼Ð¼Ñƒ',0),(243934,6776,'es','Cargar Cantidad',0),(243935,6776,'de','Zu-/ Abschlagsbetrag',0),(243936,6776,'en','Charge Amount',0),(243937,6777,'is','',0),(243938,6777,'dr','Ø¨Ø§Ø¬Ù‡ ÙØ±ÙˆØ´',0),(243939,6777,'pr','Ø¨Ø§Ø¬Ù‡ ÙØ±ÙˆØ´',0),(243940,6777,'tr','SayaÃ§ SatÄ±lÄ±k',0),(243941,6777,'pl','Sprzedam licznik',0),(243942,6777,'bg','Ð‘Ñ€Ð¾ÑÑ‡ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°',0),(243943,6777,'ur','Ú©Ø§Ø¤Ù†Ù¹Ø± Ú©Û’ Ù„ÙŠØ¦Û’',0),(243944,6777,'sr','Ð‘Ñ€Ð¾Ñ˜Ð°Ñ‡ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(243945,6777,'vi','Doanh sá»‘ tá»« quáº§y',0),(243946,6777,'af','Toonbank Verkope',0),(243947,6777,'ro','Contra vÃ¢nzare',0),(243948,6777,'et','Counter MÃ¼Ã¼k',0),(243949,6777,'si','Å tevec prodajo',0),(243950,6777,'ba','Counter Penjualan',0),(243951,6777,'nl','Balie',0),(243952,6777,'fi','Counter myynti',0),(243953,6777,'no','Counter salg',0),(243954,6777,'da','Counter salg',0),(243955,6777,'ko','ì¹´ìš´í„° íŒë§¤',0),(243956,6777,'he','×ž×•× ×” ×œ×ž×›×™×¨×”',0),(243957,6777,'el','ÎœÎµÏ„ÏÎ·Ï„Î®Ï‚ Ï€ÏŽÎ»Î·ÏƒÎ·',0),(243958,6777,'zh','æŸœå°é”€å”®\r\n',0),(243959,6777,'sv','Counter fÃ¶rsÃ¤ljning',0),(243960,6777,'it','Banco vendita',0),(243961,6777,'tl','',0),(243962,6777,'th','&#3648;&#3588;&#3634;&#3609;&#3660;&#3648;&#3605;&#3629;&#3619;&#3660;&#3586;&#3634;&#3618;',0),(243963,6777,'hi','à¤•à¤¾à¤‰à¤‚à¤Ÿà¤° à¤¬à¤¿à¤•à¥à¤°à¥€',0),(243964,6777,'ms','Kaunter jualan',0),(243965,6777,'ar','Ø¨ÙŠØ¹ Ø§Ù„Ø¹Ø¯Ø§Ø¯',0),(243966,6777,'fr','Vente de comptoir',0),(243967,6777,'jp','ã‚«ã‚¦ãƒ³ã‚¿ãƒ¼è²©å£²',0),(243968,6777,'pt','Venda balcÃ£o',0),(243969,6777,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° ÑÑ‡ÐµÑ‚Ñ‡Ð¸ÐºÐ¾Ð²',0),(243970,6777,'es','Venta en Tienda',0),(243971,6777,'de','Verkauf',0),(243972,6777,'en','Counter Sale',0),(243973,6778,'is','',0),(243974,6778,'dr','Ø¢Ø¯Ø±Ø³ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(243975,6778,'pr','Ø¢Ø¯Ø±Ø³ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(243976,6778,'tr','MÃ¼ÅŸteri adresi',0),(243977,6778,'pl','Adres klienta',0),(243978,6778,'bg','ÐÐ´Ñ€ÐµÑÐ¸ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(243979,6778,'ur','Ú©Ø³Ù¹Ù…Ø± Ù¾ØªÛ',0),(243980,6778,'sr','ÐÐ´Ñ€ÐµÑÐ° ÐºÑƒÐ¿Ñ†Ð°',0),(243981,6778,'vi','Äá»‹a chá»‰ KhÃ¡ch hÃ ng',0),(243982,6778,'af','Klant/KliÃ«nt Adres',0),(243983,6778,'ro','Adresa clientului',0),(243984,6778,'et','Kliendi aadress',0),(243985,6778,'si','Naslov stranke',0),(243986,6778,'ba','Alamat pelanggan',0),(243987,6778,'nl','Adres van de klant',0),(243988,6778,'fi','Asiakkaan osoite',0),(243989,6778,'no','Kundeadresse',0),(243990,6778,'da','Kundeadresse',0),(243991,6778,'ko','ê³ ê° ì£¼ì†Œ',0),(243992,6778,'he','×›×ª×•×‘×ª ×œ×§×•×—',0),(243993,6778,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Ï€ÎµÎ»Î¬Ï„Î·',0),(243994,6778,'zh','å®¢æˆ·åœ°å€\r\n',0),(243995,6778,'sv','Kundens adress',0),(243996,6778,'it','Indirizzo del cliente',0),(243997,6778,'tl','',0),(243998,6778,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(243999,6778,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤¤à¥‡',0),(244000,6778,'ms','Alamat pelanggan',0),(244001,6778,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(244002,6778,'fr','Adresse du client',0),(244003,6778,'jp','é¡§å®¢ã®ä½æ‰€',0),(244004,6778,'pt','EndereÃ§o do cliente',0),(244005,6778,'ru','ÐÐ´Ñ€ÐµÑ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(244006,6778,'es','Cliente DirecciÃ³n',0),(244007,6778,'de','Kundenadresse',0),(244008,6778,'en','Customer Address',0),(244009,6779,'is','',0),(244010,6779,'dr','Ø´Ù‡Ø± Ø®Ø±ÙŠØ¯Ø§Ø±',0),(244011,6779,'pr','Ø´Ù‡Ø± Ø®Ø±ÙŠØ¯Ø§Ø±',0),(244012,6779,'tr','MÃ¼ÅŸteri ÅŸehir',0),(244013,6779,'pl','Miasto odbiorcy',0),(244014,6779,'bg','Ð“Ñ€Ð°Ð´ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(244015,6779,'ur','Ú©Ø³Ù¹Ù…Ø± Ø´ÛØ±',0),(244016,6779,'sr','Ð“Ñ€Ð°Ð´ ÐºÑƒÐ¿Ñ†Ð°',0),(244017,6779,'vi','ThÃ nh phá»‘ KhÃ¡ch hÃ ng',0),(244018,6779,'af','Klant / KliÃ«nt Plek',0),(244019,6779,'ro','Client City',0),(244020,6779,'et','Kliendi City',0),(244021,6779,'si','Mesto kupca',0),(244022,6779,'ba','Pelanggan City',0),(244023,6779,'nl','Klant stad',0),(244024,6779,'fi','Asiakkaan kaupunki',0),(244025,6779,'no','Kunden byen',0),(244026,6779,'da','Kunde City',0),(244027,6779,'ko','ê³ ê° ì‹œ',0),(244028,6779,'he','×¢×™×¨ ×œ×§×•×—',0),(244029,6779,'el','Î ÏŒÎ»Î· Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(244030,6779,'zh','å®¢æˆ·åŸŽå¸‚\r\n',0),(244031,6779,'sv','Kunden City',0),(244032,6779,'it','CittÃ  del cliente',0),(244033,6779,'tl','',0),(244034,6779,'th','&#3648;&#3617;&#3639;&#3629;&#3591;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(244035,6779,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¶à¤¹à¤°',0),(244036,6779,'ms','Bandar pelanggan',0),(244037,6779,'ar','Ù…Ø¯ÙŠÙ†Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(244038,6779,'fr','Ville client',0),(244039,6779,'jp','é¡§å®¢ã®éƒ½å¸‚',0),(244040,6779,'pt','Cidade do cliente',0),(244041,6779,'ru','Ð“Ð¾Ñ€Ð¾Ð´ Ð·Ð°ÐºÐ°Ð·Ñ‡Ð¸ÐºÐ°',0),(244042,6779,'es','Cliente Ciudad',0),(244043,6779,'de','Ort fÃ¼r Kunden',0),(244044,6779,'en','Customer City',0),(244045,6780,'is','',0),(244046,6780,'dr','( ÙˆÙ„Ø§ÛŒØª) Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(244047,6780,'pr','ÙˆØ¶Ø¹ÙŠØª ( Ø§Ø³ØªØ§Ù† ) Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(244048,6780,'tr','MÃ¼ÅŸteri durumu',0),(244049,6780,'pl','PaÅ„stwa klientÃ³w',0),(244050,6780,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(244051,6780,'ur','Ú©Ø³Ù¹Ù…Ø± Ø±ÛŒØ§Ø³Øª',0),(244052,6780,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(244053,6780,'vi','Tiá»ƒu bang cá»§a KhÃ¡ch hÃ ng',0),(244054,6780,'af','KliÃªnt/Klant Staat (Landsgebied)',0),(244055,6780,'ro','Stat de client',0),(244056,6780,'et','Kliendi riik',0),(244057,6780,'si','DrÅ¾ava kupca',0),(244058,6780,'ba','Negara pelanggan',0),(244059,6780,'nl','Klant staat',0),(244060,6780,'fi','Asiakkaan tila',0),(244061,6780,'no','Kunden staten',0),(244062,6780,'da','Kunde stat',0),(244063,6780,'ko','ê³ ê° ìƒíƒœ',0),(244064,6780,'he','×ž×“×™× ×ª ×œ×§×•×—',0),(244065,6780,'el','ÎœÎ­Î»Î¿Ï‚ Ï„Î·Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(244066,6780,'zh','å®¢æˆ·çŠ¶æ€\r\n',0),(244067,6780,'sv','Kunden tillstÃ¥nd',0),(244068,6780,'it','Stato del cliente',0),(244069,6780,'tl','',0),(244070,6780,'th','&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(244071,6780,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¾à¤œà¥à¤¯',0),(244072,6780,'ms','Baca Negeri',0),(244073,6780,'ar','Ø¯ÙˆÙ„Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(244074,6780,'fr','Ã‰tat du client',0),(244075,6780,'jp','é¡§å®¢ã®çŠ¶æ…‹',0),(244076,6780,'pt','Estado do cliente',0),(244077,6780,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(244078,6780,'es','Cliente Estado',0),(244079,6780,'de','Kundenstatus',0),(244080,6780,'en','Customer State',0),(244081,6781,'is','',0),(244082,6781,'dr','ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(244083,6781,'pr','ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(244084,6781,'tr','MÃ¼ÅŸteri ZIP',0),(244085,6781,'pl','Klient pocztowy',0),(244086,6781,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(244087,6781,'ur','Ú©Ø³Ù¹Ù…Ø± Ø²Ù¾',0),(244088,6781,'sr','Ð—Ð¸Ð¿ ÐºÑƒÐ¿Ñ†Ð°',0),(244089,6781,'vi','MÃ£ Zip khÃ¡ch hÃ ng',0),(244090,6781,'af','Klant / KliÃ«nt Poskode',0),(244091,6781,'ro','Client Zip',0),(244092,6781,'et','Kliendi postiindeks',0),(244093,6781,'si','Stranka Zip',0),(244094,6781,'ba','Pelanggan Zip',0),(244095,6781,'nl','Klant Zip',0),(244096,6781,'fi','Asiakkaan Zip',0),(244097,6781,'no','Kunden Zip',0),(244098,6781,'da','Kunde Zip',0),(244099,6781,'ko','ê³ ê° ìš°íŽ¸',0),(244100,6781,'he','×ž×™×§×•×“ ×œ×§×•×—',0),(244101,6781,'el','Zip Ï€ÎµÎ»Î¬Ï„Î·',0),(244102,6781,'zh','å®¢æˆ·é‚®ç¼–\r\n',0),(244103,6781,'sv','Kunden Zip',0),(244104,6781,'it','Codice postale cliente',0),(244105,6781,'tl','',0),(244106,6781,'th','&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(244107,6781,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¼à¤¿à¤ª',0),(244108,6781,'ms','Baca Zip',0),(244109,6781,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(244110,6781,'fr','Client Zip',0),(244111,6781,'jp','é¡§å®¢ã®éƒµä¾¿ç•ªå·',0),(244112,6781,'pt','Cliente Zip',0),(244113,6781,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(244114,6781,'es','Cliente CÃ³digo Postal',0),(244115,6781,'de','Kunde Zip',0),(244116,6781,'en','Customer Zip',0),(244117,6782,'is','',0),(244118,6782,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø°Ø®ÙŠØ±Ù‡  ÙƒØ±Ø¯Ù† ',0),(244119,6782,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø°Ø®ÙŠØ±Ù‡  ÙƒØ±Ø¯Ù† ',0),(244120,6782,'tr','Kaydetme sÄ±rasÄ±nda hata oluÅŸtu',0),(244121,6782,'pl','BÅ‚Ä…d podczas zapisywania',0),(244122,6782,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(244123,6782,'ur','Ù†Ù‚Øµ Ø¯ÙˆØ±Ø§Ù† Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(244124,6782,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ ÑÐ¿Ð°ÑÐ¸Ñ‚Ð¸',0),(244125,6782,'vi','Lá»—i khi sao lÆ°u',0),(244126,6782,'af','Fout tydens stoor',0),(244127,6782,'ro','Eroare Ã®n timpul salva',0),(244128,6782,'et','Salvestamise ajal ilmnes viga',0),(244129,6782,'si','Napaka med shranite',0),(244130,6782,'ba','Error selama menyimpan',0),(244131,6782,'nl','Fout tijdens opslaan',0),(244132,6782,'fi','Virhe aikana Tallenna',0),(244133,6782,'no','Feil under Lagre',0),(244134,6782,'da','Fejl under Gem',0),(244135,6782,'ko','ì €ìž¥ í•˜ëŠ” ë™ì•ˆ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(244136,6782,'he','×©×’×™××” ×‘×ž×”×œ×š ×”×©×ž×™×¨×”',0),(244137,6782,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·',0),(244138,6782,'zh','åœ¨ä¿å­˜æ—¶å‡ºé”™',0),(244139,6782,'sv','Fel vid spara',0),(244140,6782,'it','Errore durante salvare',0),(244141,6782,'tl','',0),(244142,6782,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;',0),(244143,6782,'hi','à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(244144,6782,'ms','Ralat semasa Menyimpan',0),(244145,6782,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸',0),(244146,6782,'fr','Erreur lors de l\'enregistrer',0),(244147,6782,'jp','ä¿å­˜ä¸­ã«ã‚¨ãƒ©ãƒ¼ã§ã™ã€‚',0),(244148,6782,'pt','Erro ao salvar',0),(244149,6782,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸',0),(244150,6782,'es','Error Durante Guardar',0),(244151,6782,'de','Fehler beim Speichern',0),(244152,6782,'en','Error During Save',0),(244153,6783,'is','',0),(244154,6783,'dr','Ø­Ø±Ø§Ø¬ Ø¬Ø¯ÙŠØ¯ ',0),(244155,6783,'pr','Ø­Ø±Ø§Ø¬ Ø¬Ø¯ÙŠØ¯ ',0),(244156,6783,'tr','Yeni satÄ±ÅŸ',0),(244157,6783,'pl','SprzedaÅ¼ nowych',0),(244158,6783,'bg','ÐÐ¾Ð²Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(244159,6783,'ur','Ù†Ø¦ÛŒ ÙØ±ÙˆØ®Øª',0),(244160,6783,'sr','ÐÐ¾Ð²Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(244161,6783,'vi','Sale má»›i',0),(244162,6783,'af','Nuwe Verkope',0),(244163,6783,'ro','Nou de vÃ¢nzare',0),(244164,6783,'et','Uus mÃ¼Ã¼k',0),(244165,6783,'si','Prodajo novih',0),(244166,6783,'ba','Baru dijual',0),(244167,6783,'nl','Nieuwe verkoop',0),(244168,6783,'fi','Uusi myynti',0),(244169,6783,'no','Nye salg',0),(244170,6783,'da','Nye salg',0),(244171,6783,'ko','ìƒˆë¡œìš´ íŒë§¤',0),(244172,6783,'he','×ž×›×™×¨×” ×—×“×©×”',0),(244173,6783,'el','ÎÎ­Î± Ï€ÏŽÎ»Î·ÏƒÎ·',0),(244174,6783,'zh','æ–°çš„é”€å”®\r\n',0),(244175,6783,'sv','Ny fÃ¶rsÃ¤ljning',0),(244176,6783,'it','Nuova vendita',0),(244177,6783,'tl','',0),(244178,6783,'th','&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;&#3651;&#3627;&#3617;&#3656;',0),(244179,6783,'hi','à¤¨à¤ˆ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(244180,6783,'ms','Jualan baru',0),(244181,6783,'ar','Ø¨ÙŠØ¹ Ø¬Ø¯ÙŠØ¯Ø©',0),(244182,6783,'fr','Nouvelle vente',0),(244183,6783,'jp','æ–°ç™ºå£²',0),(244184,6783,'pt','Venda nova',0),(244185,6783,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°',0),(244186,6783,'es','Nueva Venta',0),(244187,6783,'de','Neuverkauf',0),(244188,6783,'en','New Sale',0),(244189,6784,'is','',0),(244190,6784,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ù†Ø¶Ù…Ø§Ù… Ù…Ø§Ù„ÙŠØ§Øª ',0),(244191,6784,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ù†Ø¶Ù…Ø§Ù… Ù…Ø§Ù„ÙŠØ§Øª ',0),(244192,6784,'tr','SipariÅŸ toplamÄ±nÄ±n KDV dahil',0),(244193,6784,'pl','Suma zamÃ³wienia, w tym podatku',0),(244194,6784,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸',0),(244195,6784,'ur','Ù†Ø¸Ù… Ú©ÛŒ Ú©Ù„ Ù¹ÛŒÚ©Ø³ Ù…ÛŒÚº Ø´Ø§Ù…Ù„',0),(244196,6784,'sr','Ð ÐµÐ´ ÑƒÐºÑƒÐ¿Ð½Ð¾, ÑƒÐºÑ™ÑƒÑ‡ÑƒÑ˜ÑƒÑ›Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(244197,6784,'vi','Tá»•ng cá»™ng Ä‘Æ¡n hÃ ng bao gá»“m thuáº¿',0),(244198,6784,'af','Bestellingstotaal Insluitende Belasting',0),(244199,6784,'ro','Total comanda inclusiv fiscale',0),(244200,6784,'et','Tellimuse kogusumma koos kÃ¤ibemaksuga',0),(244201,6784,'si','Nalog skupaj z DDV',0),(244202,6784,'ba','Urutan Total termasuk pajak',0),(244203,6784,'nl','Ordertotaal incl. BTW',0),(244204,6784,'fi','Tilauksen summan veroineen',0),(244205,6784,'no','Bestillingstotalen inkludert mva',0),(244206,6784,'da','Bestil alt inklusive moms',0),(244207,6784,'ko','ì£¼ë¬¸ ì´ ì„¸ê¸ˆ í¬í•¨',0),(244208,6784,'he','×¡×”\"×› ×›×•×œ×œ ×ž×¡',0),(244209,6784,'el','ÎŸÎ»Î¹ÎºÏŒ Ï€Î¿ÏƒÏŒ Î¦Î Î‘',0),(244210,6784,'zh','è®¢å•æ€»é¢å«ç¨Ž\r\n',0),(244211,6784,'sv','Ordersumman inklusive moms',0),(244212,6784,'it','Totale ordine IVA inclusa',0),(244213,6784,'tl','',0),(244214,6784,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3619;&#3623;&#3617;&#3616;&#3634;&#3625;&#3637;',0),(244215,6784,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥à¤² à¤•à¤° à¤¸à¤¹à¤¿à¤¤',0),(244216,6784,'ms','Jumlah pesanan yang termasuk cukai',0),(244217,6784,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø·Ù„Ø¨ÙŠØ© Ø¨Ù…Ø§ ÙÙŠ Ø°Ù„Ùƒ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(244218,6784,'fr','Total de la commande TTC',0),(244219,6784,'jp','æ³¨æ–‡ã®åˆè¨ˆãŒç¨Žè¾¼',0),(244220,6784,'pt','Total do pedido incluindo IVA',0),(244221,6784,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð°ÐºÐ°Ð·Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð°Ñ Ð½Ð°Ð»Ð¾Ð³',0),(244222,6784,'es','Orden Total Incluyendo Impuesto',0),(244223,6784,'de','Auftragssumme inkl. MwSt.',0),(244224,6784,'en','Order Total Including Tax',0),(244225,6785,'is','',0),(244226,6785,'dr','ÙŠØ§  Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ ÙŠØ§ ÙˆÙŠØ±Ø§ÙŠØ´ Ø¨Ø¹Ø¯ Ø§Ø² Ø¬Ø³ØªØ¬Ùˆ ',0),(244227,6785,'pr','ÙŠØ§  Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ ÙŠØ§ ÙˆÙŠØ±Ø§ÙŠØ´ Ø¨Ø¹Ø¯ Ø§Ø² Ø¬Ø³ØªØ¬Ùˆ ',0),(244228,6785,'tr','Yeni mÃ¼ÅŸteri bilgileri ya da arama sonra DÃ¼zenle',0),(244229,6785,'pl','Lub nowe informacje o klientach lub edytowaÄ‡ po wyszukiwania',0),(244230,6785,'bg','Ð˜Ð»Ð¸ Ð½Ð¾Ð²Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ ÑÐ»ÐµÐ´ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(244231,6785,'ur','ÛŒØ§ Ù†Ø¦Û’ Ú¯Ø§ÛÚ© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ÛŒØ§ ØªØ±Ù…ÛŒÙ… Ú©Û’ Ø¨Ø¹Ø¯ Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(244232,6785,'sr','Ð˜Ð»Ð¸ Ð½Ð¾Ð²Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐºÑƒÐ¿Ñ†Ñƒ Ð¸Ð»Ð¸ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð°ÐºÐ¾Ð½ Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐ°',0),(244233,6785,'vi','hoáº·c thÃ´ng tin khÃ¡ch hÃ ng má»›i hoáº·c sá»­a sau khi tÃ¬m',0),(244234,6785,'af','Of Nuwe KliÃ«nt/Klant Inligting Of Redigeer Na Opsoek',0),(244235,6785,'ro','Sau informatii despre clienti noi sau editare dupÄƒ cÄƒutare',0),(244236,6785,'et','VÃµi uue kliendi andmed vÃµi Redigeeri pÃ¤rast otsing',0),(244237,6785,'si','Ali nove informacije kupca ali Uredi po iskanje',0),(244238,6785,'ba','Atau informasi pelanggan baru atau mengedit setelah Lookup',0),(244239,6785,'nl','Of nieuwe klantgegevens of bewerken na Lookup',0),(244240,6785,'fi','Uuden asiakkaan tietoja tai Muokkaa jÃ¤lkeen haku',0),(244241,6785,'no','Eller ny kundeinformasjon eller redigere etter oppslag',0),(244242,6785,'da','Eller nye kundeoplysninger eller Rediger efter opslag',0),(244243,6785,'ko','ìƒˆë¡œìš´ ê³ ê° ì •ë³´ ë˜ëŠ” ì¡°íšŒ í›„ íŽ¸ì§‘',0),(244244,6785,'he','×ž×™×“×¢ ××•×“×•×ª ×œ×§×•×—×•×ª ×—×“×©×™× ××• ×¢×¨×™×›×” ×œ××—×¨ ×‘×“×™×§×ª ×ž×™×“×¢',0),(244245,6785,'el','Î‰ Î½Î­ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÎµÎ»Î¬Ï„Î· Î® ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼ÎµÏ„Î¬ Ï„Î·Î½ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(244246,6785,'zh','æˆ–æ–°çš„å®¢æˆ·ä¿¡æ¯æˆ–æŸ¥æ‰¾åŽç¼–è¾‘\r\n',0),(244247,6785,'sv','Eller ny kundinformation eller redigera efter sÃ¶kning',0),(244248,6785,'it','O nuove informazioni sui clienti o modifica dopo Lookup',0),(244249,6785,'tl','',0),(244250,6785,'th','&#3627;&#3619;&#3639;&#3629;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3651;&#3627;&#3617;&#3656; &#3627;&#3619;&#3639;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#',0),(244251,6785,'hi','à¤¯à¤¾ à¤¨à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¯à¤¾ à¤²à¥à¤•à¤…à¤ª à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(244252,6785,'ms','Atau maklumat pelanggan baru atau mengedit selepas Lookup',0),(244253,6785,'ar','Ø£Ùˆ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø¬Ø¯ÙŠØ¯Ø© Ø£Ùˆ ØªØ­Ø±ÙŠØ± Ø¨Ø¹Ø¯ Ø¨Ø­Ø«',0),(244254,6785,'fr','Ou nouvelles informations client ou Edit aprÃ¨s recherche',0),(244255,6785,'jp','æ–°è¦é¡§å®¢ã®æƒ…å ±ã‚„æ¤œç´¢å¾Œã®ç·¨é›†',0),(244256,6785,'pt','Novo informaÃ§Ãµes de cliente ou editar depois da pesquisa',0),(244257,6785,'ru','Ð˜Ð»Ð¸ Ð½Ð¾Ð²ÑƒÑŽ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°Ñ… Ð¸Ð»Ð¸ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð¾ÑÐ»Ðµ Ð¿Ð¾Ð´ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(244258,6785,'es','O InformaciÃ³n de Nuevo Cliente O Editar DepuÃ©s de Buscar',0),(244259,6785,'de','Oder neue Kundeninformationen oder bearbeiten nach Suche',0),(244260,6785,'en','Or New Customer Information Or Edit After Lookup',0),(244261,6786,'is','',0),(244262,6786,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(244263,6786,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(244264,6786,'tr','Kredi kartÄ± ile Ã¶deme',0),(244265,6786,'pl','KartÄ… kredytowÄ…',0),(244266,6786,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(244267,6786,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(244268,6786,'sr','ÐŸÐ»Ð°Ñ‚Ð¸Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(244269,6786,'vi','Thanh ToÃ¡n Báº±ng Tháº» TÃ­n Dá»¥ng',0),(244270,6786,'af','Betaal Per Kredietkaart',0),(244271,6786,'ro','PlÄƒtit prin Card de Credit',0),(244272,6786,'et','Maksta krediitkaardiga',0),(244273,6786,'si','PlaÄa s kreditno kartico',0),(244274,6786,'ba','Dibayar dengan kartu kredit',0),(244275,6786,'nl','Per creditcard betaald',0),(244276,6786,'fi','Maksaa luottokortilla',0),(244277,6786,'no','Betalt med kredittkort',0),(244278,6786,'da','Betalt med kreditkort',0),(244279,6786,'ko','ì‹ ìš© ì¹´ë“œë¡œ ì§€ë¶ˆ',0),(244280,6786,'he','×©×•×œ× ×¢\"×™ ×›×¨×˜×™×¡ ××©×¨××™',0),(244281,6786,'el','ÎšÎ±Ï„Î±Î²Î»Î·Î¸ÎµÎ¯ Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(244282,6786,'zh','ä¿¡ç”¨å¡æ”¯ä»˜\r\n',0),(244283,6786,'sv','Betalas med kreditkort',0),(244284,6786,'it','Pagato con carta di credito',0),(244285,6786,'tl','',0),(244286,6786,'th','&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;&#3650;&#3604;&#3618;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(244287,6786,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(244288,6786,'ms','Dibayar dengan kad kredit',0),(244289,6786,'ar','ØªØ¯ÙØ¹ Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(244290,6786,'fr','Paiement par carte de crÃ©dit',0),(244291,6786,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã§æ”¯æ‰•ã†',0),(244292,6786,'pt','Pago com cartÃ£o de crÃ©dito',0),(244293,6786,'ru','ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð¾ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ð¾Ð¹',0),(244294,6786,'es','Pagado Por Tarjeta de CrÃ©dito',0),(244295,6786,'de','Mit Kreditkarte bezahlt',0),(244296,6786,'en','Paid By Credit Card',0),(244297,6787,'is','',0),(244298,6787,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§ Ù¾ÙˆÙ„ Ù†Ù‚Ø¯ ',0),(244299,6787,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§ Ù¾ÙˆÙ„ Ù†Ù‚Ø¯ ',0),(244300,6787,'tr','Ã–denen para',0),(244301,6787,'pl','WypÅ‚acone w gotÃ³wce',0);
INSERT INTO `langdef` VALUES (244302,6787,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½ Ð¿Ð°Ñ€Ð¸',0),(244303,6787,'ur','ØªÙ†Ø®ÙˆØ§Û Ù†Ù‚Ø¯',0),(244304,6787,'sr','ÐŸÐ»Ð°Ñ‚Ð¸Ð¾ Ñƒ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ð¸',0),(244305,6787,'vi','Tráº£ tiá»n máº·t',0),(244306,6787,'af','Kontant Betaal',0),(244307,6787,'ro','Numerar plÄƒtite',0),(244308,6787,'et','Makstud raha',0),(244309,6787,'si','IzplaÄa v gotovini',0),(244310,6787,'ba','Dibayar tunai',0),(244311,6787,'nl','Betaalde Cash',0),(244312,6787,'fi','Maksettava kÃ¤teisellÃ¤',0),(244313,6787,'no','Betalt penger',0),(244314,6787,'da','Betalt kontant',0),(244315,6787,'ko','ìœ ë£Œ í˜„ê¸ˆ',0),(244316,6787,'he','×©×™×œ× ×‘×ž×–×•×ž×Ÿ',0),(244317,6787,'el','ÎšÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ Î¼ÎµÏ„ÏÎ·Ï„Î¬',0),(244318,6787,'zh','çŽ°é‡‘æ”¯ä»˜\r\n',0),(244319,6787,'sv','Betalas kontant',0),(244320,6787,'it','Pagamento in contanti',0),(244321,6787,'tl','',0),(244322,6787,'th','&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;&#3649;&#3621;&#3657;&#3623;',0),(244323,6787,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤•à¤¦',0),(244324,6787,'ms','Wang Tunai yang dibayar',0),(244325,6787,'ar','Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(244326,6787,'fr','PayÃ© Cash',0),(244327,6787,'jp','æœ‰æ–™ç¾é‡‘',0),(244328,6787,'pt','Pagou em dinheiro',0),(244329,6787,'ru','ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ð¼Ð¸',0),(244330,6787,'es','Pagado en Efectivo',0),(244331,6787,'de','Bar bezahlt',0),(244332,6787,'en','Paid Cash',0),(244333,6788,'is','',0),(244334,6788,'dr','Ú†Ùƒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(244335,6788,'pr','Ú†Ùƒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(244336,6788,'tr','Ãœcretli onay',0),(244337,6788,'pl','PÅ‚atne wyboru',0),(244338,6788,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(244339,6788,'ur','ØªÙ†Ø®ÙˆØ§Û Ú©Ø§ Ú†ÛŒÚ©',0),(244340,6788,'sr','ÐŸÐ»Ð°Ñ›ÐµÐ½Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(244341,6788,'vi','SÃ©c Ä‘Ã£ thanh toÃ¡n',0),(244342,6788,'af','Betaalde Tjek',0),(244343,6788,'ro','Verifica plÄƒtite',0),(244344,6788,'et','Paide sisse',0),(244345,6788,'si','PlaÄa Äek',0),(244346,6788,'ba','Dibayar Check',0),(244347,6788,'nl','Betaalde Check',0),(244348,6788,'fi','Maksetun sekin',0),(244349,6788,'no','Betalt av',0),(244350,6788,'da','Betalt Check',0),(244351,6788,'ko','ìœ ë£Œ í™•ì¸',0),(244352,6788,'he','×©×™×œ× ×‘×¦\'×§',0),(244353,6788,'el','Î•Î»Î­Î³Ï‡Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹',0),(244354,6788,'zh','ä»˜æ¬¾æ”¯ç¥¨\r\n',0),(244355,6788,'sv','Betald Check',0),(244356,6788,'it','Pagamento assegno',0),(244357,6788,'tl','',0),(244358,6788,'th','&#3592;&#3656;&#3634;&#3618;&#3648;&#3594;&#3655;&#3588;',0),(244359,6788,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤šà¥‡à¤•',0),(244360,6788,'ms','Cek yang dibayar',0),(244361,6788,'ar','Ø§Ù„ØµÙƒ Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(244362,6788,'fr','ChÃ¨que payÃ©',0),(244363,6788,'jp','æœ‰æ–™ãƒã‚§ãƒƒã‚¯',0),(244364,6788,'pt','Cheque pago',0),(244365,6788,'ru','ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ð¹ Ñ‡ÐµÐº',0),(244366,6788,'es','Pagado por Cheque',0),(244367,6788,'de','Bezahlte Check',0),(244368,6788,'en','Paid Check',0),(244369,6789,'is','',0),(244370,6789,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ Ú©Ø§Ù„Ø§',0),(244371,6789,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ Ú©Ø§Ù„Ø§',0),(244372,6789,'tr','SatÄ±ÅŸ vergisi',0),(244373,6789,'pl','Podatek od sprzedaÅ¼y',0),(244374,6789,'bg','Ð”Ð°Ð½ÑŠÐº Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(244375,6789,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³',0),(244376,6789,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(244377,6789,'vi','Thuáº¿ bÃ¡n hÃ ng',0),(244378,6789,'af','Verkoopsbelasting',0),(244379,6789,'ro','Taxa-vanzari',0),(244380,6789,'et','KÃ¤ibemaks',0),(244381,6789,'si','Prodajni davek',0),(244382,6789,'ba','Pajak penjualan',0),(244383,6789,'nl','Sales Tax',0),(244384,6789,'fi','ArvonlisÃ¤vero',0),(244385,6789,'no','Merverdiavgift',0),(244386,6789,'da','Moms',0),(244387,6789,'ko','íŒë§¤ ì„¸ê¸ˆ',0),(244388,6789,'he','×ž×¡ ×ž×›×™×¨×•×ª',0),(244389,6789,'el','Î¦ÏŒÏÎ¿Ï‚ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(244390,6789,'zh','é”€å”®ç¨Ž\r\n',0),(244391,6789,'sv','Moms',0),(244392,6789,'it','Imposta sulle vendite',0),(244393,6789,'tl','',0),(244394,6789,'th','&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(244395,6789,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°',0),(244396,6789,'ms','Cukai jualan',0),(244397,6789,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(244398,6789,'fr','Taxe de vente',0),(244399,6789,'jp','å£²ä¸Šç¨Ž',0),(244400,6789,'pt','Imposto sobre vendas',0),(244401,6789,'ru','ÐÐ°Ð»Ð¾Ð³ Ð¡ ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(244402,6789,'es','IVA',0),(244403,6789,'de','Umsatzsteuer',0),(244404,6789,'en','Sales Tax',0),(244405,6790,'is','',0),(244406,6790,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ÙØ¹Ù„ÙŠ',0),(244407,6790,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ÙØ¹Ù„ÙŠ',0),(244408,6790,'tr','Varolan mÃ¼ÅŸteri arama',0),(244409,6790,'pl','Szukaj klientem',0),(244410,6790,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(244411,6790,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ú¯Ø§ÛÚ© ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(244412,6790,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸Ñ… ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(244413,6790,'vi','TÃ¬m kiáº¿m khÃ¡ch hÃ ng hiá»‡n táº¡i',0),(244414,6790,'af','Soek Bestaande KliÃ«nt/Klant',0),(244415,6790,'ro','Client existent de cÄƒutare',0),(244416,6790,'et','Otsi olemasolevat klienti',0),(244417,6790,'si','Iskanje obstojeÄih strank',0),(244418,6790,'ba','Pelanggan Existing Cari',0),(244419,6790,'nl','Bestaande klant zoeken',0),(244420,6790,'fi','Etsi olemassa oleva asiakas',0),(244421,6790,'no','SÃ¸k etter kunde',0),(244422,6790,'da','SÃ¸g efter eksisterende kunde',0),(244423,6790,'ko','ê¸°ì¡´ ê³ ê° ê²€ìƒ‰',0),(244424,6790,'he','×—×¤×© ×œ×§×•×— ×§×™×™×',0),(244425,6790,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Ï…Ï€Î¬ÏÏ‡Ï‰Î½ Ï€ÎµÎ»Î¬Ï„Î·Ï‚',0),(244426,6790,'zh','æœç´¢çŽ°æœ‰å®¢æˆ·\r\n',0),(244427,6790,'sv','SÃ¶k befintlig kund',0),(244428,6790,'it','Ricerca cliente esistente',0),(244429,6790,'tl','',0),(244430,6790,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(244431,6790,'hi','à¤–à¥‹à¤œ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(244432,6790,'ms','Mencari pelanggan sedia ada',0),(244433,6790,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø­Ø§Ù„ÙŠÙŠÙ†',0),(244434,6790,'fr','Recherche client existant',0),(244435,6790,'jp','æ—¢å­˜ã®é¡§å®¢ã‚’æ¤œç´¢ã—ã¾ã™ã€‚',0),(244436,6790,'pt','Pesquisa cliente existente',0),(244437,6790,'ru','ÐŸÐ¾Ð¸ÑÐº ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(244438,6790,'es','Buscar Cliente Existente',0),(244439,6790,'de','Suche Bestandskunde',0),(244440,6790,'en','Search Existing Customer',0),(244441,6791,'is','',0),(244442,6791,'dr','ÙƒØ¯ ØªØ§ÙŠÙŠØ¯ Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(244443,6791,'pr','ÙƒØ¯ ØªØ§ÙŠÙŠØ¯ Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(244444,6791,'tr','Hareket onay kodu',0),(244445,6791,'pl','Kod identyfikacyjny transakcji',0),(244446,6791,'bg','ÐšÐ¾Ð´ Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð½Ð° ÑÐ´ÐµÐ»ÐºÐ°Ñ‚Ð°',0),(244447,6791,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Ø§ Ú©ÙˆÚˆ',0),(244448,6791,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐ° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð°',0),(244449,6791,'vi','MÃ£ cáº¥p quyá»n Giao dá»‹ch ',0),(244450,6791,'af','Transaksie Goedkeuringskode',0),(244451,6791,'ro','Aprobare tranzacÅ£ie cod',0),(244452,6791,'et','Tehingu kinnitamise kood',0),(244453,6791,'si','Kodo za odobritev transakcije',0),(244454,6791,'ba','Kode persetujuan transaksi',0),(244455,6791,'nl','De Code van de goedkeuring van de transactie',0),(244456,6791,'fi','Tapahtuman hyvÃ¤ksyntÃ¤ koodi',0),(244457,6791,'no','Transaksjonskode for godkjenning',0),(244458,6791,'da','Transaktionen godkendelseskode',0),(244459,6791,'ko','ê±°ëž˜ ìŠ¹ì¸ ì½”ë“œ',0),(244460,6791,'he','×§×•×“ ××™×©×•×¨ ×¢×¡×§×”',0),(244461,6791,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚ Ï„Î·Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(244462,6791,'zh','æ‰¹å‡†äº¤æ˜“ä»£ç \r\n',0),(244463,6791,'sv','Transaktionskoden fÃ¶r godkÃ¤nnande',0),(244464,6791,'it','Codice di approvazione di transazione',0),(244465,6791,'tl','',0),(244466,6791,'th','&#3619;&#3627;&#3633;&#3626;&#3585;&#3634;&#3619;&#3607;&#3635;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(244467,6791,'hi','à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‹à¤¡',0),(244468,6791,'ms','Kod kelulusan urus niaga',0),(244469,6791,'ar','Ø±Ù…Ø² Ø§Ù„ØªØµØ¯ÙŠÙ‚ Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(244470,6791,'fr','Code d\'homologation de transaction',0),(244471,6791,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã®æ‰¿èªã‚³ãƒ¼ãƒ‰',0),(244472,6791,'pt','CÃ³digo de homologaÃ§Ã£o de transaÃ§Ã£o',0),(244473,6791,'ru','ÐšÐ¾Ð´ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹',0),(244474,6791,'es','CÃ³digo de AprobaciÃ³n de la TransacciÃ³n',0),(244475,6791,'de','Genehmigung Transaktionscode',0),(244476,6791,'en','Transaction Approval Code',0),(244477,6792,'is','',0),(244478,6792,'dr','(Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(244479,6792,'pr','Ù…Ù…ÙŠØ²ÙŠ(Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ',0),(244480,6792,'tr','DoÄŸrulama',0),(244481,6792,'pl','Weryfikacja',0),(244482,6792,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(244483,6792,'ur','ØªØµØ¯ÛŒÙ‚',0),(244484,6792,'sr','Ð’ÐµÑ€Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(244485,6792,'vi','XÃ¡c minh',0),(244486,6792,'af','Verifiseer',0),(244487,6792,'ro','Verificarea',0),(244488,6792,'et','Kontrollimine',0),(244489,6792,'si','Preverjanje',0),(244490,6792,'ba','Verifikasi',0),(244491,6792,'nl','Verificatie',0),(244492,6792,'fi','Todentaminen',0),(244493,6792,'no','Bekreftelse',0),(244494,6792,'da','Verifikation',0),(244495,6792,'ko','í™•ì¸',0),(244496,6792,'he','××™×ž×•×ª',0),(244497,6792,'el','Î•Ï€Î±Î»Î®Î¸ÎµÏ…ÏƒÎ·',0),(244498,6792,'zh','éªŒè¯\r\n',0),(244499,6792,'sv','Kontroll',0),(244500,6792,'it','Verifica',0),(244501,6792,'tl','',0),(244502,6792,'th','&#3585;&#3634;&#3619;&#3614;&#3636;&#3626;&#3641;&#3592;&#3609;&#3660;&#3588;&#3623;&#3634;&#3617;&#3592;&#3619;&#3636;&#3591;',0),(244503,6792,'hi','à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¨',0),(244504,6792,'ms','Pengesahan',0),(244505,6792,'ar','Ø§Ù„ØªØ­Ù‚Ù‚',0),(244506,6792,'fr','VÃ©rification',0),(244507,6792,'jp','æ¤œè¨¼',0),(244508,6792,'pt','VerificaÃ§Ã£o',0),(244509,6792,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(244510,6792,'es','VerificaciÃ³n',0),(244511,6792,'de','ÃœberprÃ¼fung',0),(244512,6792,'en','Verification',0),(244513,6793,'is','',0),(244514,6793,'dr','ÙØ¹Ø§Ù„ÙŠØª Ù…ÙˆØ±Ø¯ Ø§Ù†ØªØ¸Ø§Ø±',0),(244515,6793,'pr','ÙØ¹Ø§Ù„ÙŠØª Ù…ÙˆØ±Ø¯ Ø§Ù†ØªØ¸Ø§Ø±',0),(244516,6793,'tr','Beklenen eylem',0),(244517,6793,'pl','DziaÅ‚anie przewiduje',0),(244518,6793,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÑÐµ Ð¾Ñ‡Ð°ÐºÐ²Ð°',0),(244519,6793,'ur','Ø¹Ù…Ù„ Ú©ÛŒ ØªÙˆÙ‚Ø¹',0),(244520,6793,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ð¾Ñ‡ÐµÐºÑƒÑ˜Ðµ',0),(244521,6793,'vi','HÃ nh Äá»™ng Dá»± ÄoÃ¡n TrÆ°á»›c',0),(244522,6793,'af','Aksie Verwag',0),(244523,6793,'ro','Actiune asteptata',0),(244524,6793,'et','Meetme eeldatav',0),(244525,6793,'si','Dejanje, ki se priÄakuje',0),(244526,6793,'ba','Memerlukan tindakan',0),(244527,6793,'nl','Actie verwacht',0),(244528,6793,'fi','Odotettu toiminta',0),(244529,6793,'no','Handlingen forventet',0),(244530,6793,'da','Handling forventes',0),(244531,6793,'ko','ìž‘ì—… ì˜ˆìƒ',0),(244532,6793,'he','×¤×¢×•×œ×” ×¦×¤×•×™',0),(244533,6793,'el','Î•Î½Î­ÏÎ³ÎµÎ¹ÎµÏ‚ Ï€Î¿Ï… Î±Î½Î±ÂµÎ­Î½Î¿Î½Ï„Î±Î¹',0),(244534,6793,'zh','é æœŸåŠ¨ä½œ\r\n',0),(244535,6793,'sv','Ã…tgÃ¤rder fÃ¶rvÃ¤ntas',0),(244536,6793,'it','Azione richiesta',0),(244537,6793,'tl','',0),(244538,6793,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3588;&#3634;&#3604;&#3627;&#3623;&#3633;&#3591;',0),(244539,6793,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤•à¥€ à¤‰à¤®à¥à¤®à¥€à¤¦',0),(244540,6793,'ms','Tindakan yang dijangka',0),(244541,6793,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ù…ØªÙˆÙ‚Ø¹',0),(244542,6793,'fr','Action Attendu',0),(244543,6793,'jp','è¡Œå‹•æœŸå¾…',0),(244544,6793,'pt','AÃ§Ã£o esperada',0),(244545,6793,'ru','ÐžÐ¶Ð¸Ð´Ð°ÐµÐ¼Ð¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(244546,6793,'es','AcciÃ³n Prevista',0),(244547,6793,'de','Aktion erwartet',0),(244548,6793,'en','Action Expected',0),(244549,6794,'is','',0),(244550,6794,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(244551,6794,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(244552,6794,'tr','RMA oluÅŸturun',0),(244553,6794,'pl','Utworzenia RMA',0),(244554,6794,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð Ð¡Ðž',0),(244555,6794,'ur','Ø±Ù… Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(244556,6794,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ ÐžÐŸÐ¡',0),(244557,6794,'vi','Táº¡o RMA',0),(244558,6794,'af','Skep RMA',0),(244559,6794,'ro','Crea RMA',0),(244560,6794,'et','Loo RMA',0),(244561,6794,'si','Ustvarite RMA',0),(244562,6794,'ba','Membuat RMA',0),(244563,6794,'nl','RMA maken',0),(244564,6794,'fi','Luo RMA',0),(244565,6794,'no','Opprette RMA',0),(244566,6794,'da','Opret RMA',0),(244567,6794,'ko','RMAë¥¼ ìž‘ì„±',0),(244568,6794,'he','×œ×™×¦×•×¨ RMA',0),(244569,6794,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± RMA',0),(244570,6794,'zh','åˆ›å»ºæ–°é€€è´§æŽˆæƒ\r\n',0),(244571,6794,'sv','Skapa RMA',0),(244572,6794,'it','Creare RMA',0),(244573,6794,'tl','',0),(244574,6794,'th','&#3626;&#3619;&#3657;&#3634;&#3591; RMA',0),(244575,6794,'hi','RMA à¤¬à¤¨à¤¾à¤à¤',0),(244576,6794,'ms','Mencipta RMA',0),(244577,6794,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ù…Ø¨ÙŠØ¹Ø§Øª',0),(244578,6794,'fr','CrÃ©er des RMA',0),(244579,6794,'jp','RMA ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(244580,6794,'pt','Criar RMA',0),(244581,6794,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ RMA',0),(244582,6794,'es','Crear RMA',0),(244583,6794,'de','RMA erstellen',0),(244584,6794,'en','Create RMA',0),(244585,6795,'is','',0),(244586,6795,'dr','-Ù„Ø§ÙŠÙ† Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡',0),(244587,6795,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ù‡ ØµÙˆØ±Øª Ø¢Ù†-Ù„Ø§ÙŠÙ† Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡',0),(244588,6795,'tr','HiÃ§bir eylem OnLine seÃ§ildi',0),(244589,6795,'pl','Nie wybrano OnLine',0),(244590,6795,'bg','ÐÐµ Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½ Ð¾Ð½Ð»Ð°Ð¹Ð½',0),(244591,6795,'ur','Ú©ÙˆØ¦ÛŒ Ø¹Ù…Ù„ Ø¢Ù† Ù„Ø§Ø¦Ù† Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(244592,6795,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð° Ñ˜Ðµ Ð½Ð° Ð¼Ñ€ÐµÐ¶Ð¸',0),(244593,6795,'vi','ChÆ°a chá»n hÃ nh Ä‘á»™ng trá»±c tuyáº¿n',0),(244594,6795,'af','Geen aksie is aanlyn gekies',0),(244595,6795,'ro','Nicio acÅ£iune nu a fost selectat OnLine',0),(244596,6795,'et','Ãœhtegi toimingut pole valitud OnLine',0),(244597,6795,'si','Noben ukrep je bil izbran OnLine',0),(244598,6795,'ba','Tidak ada tindakan telah dipilih secara OnLine',0),(244599,6795,'nl','Geen actie is OnLine geselecteerd',0),(244600,6795,'fi','MitÃ¤Ã¤n ei ole valittu verkossa',0),(244601,6795,'no','Ingen handling er valgt OnLine',0),(244602,6795,'da','Ingen handling er blevet udvalgt OnLine',0),(244603,6795,'ko','ì¡°ì¹˜ê°€ ì˜¨ë¼ì¸ ì„ ì • ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(244604,6795,'he','×œ×œ× ×¤×¢×•×œ×” × ×‘×—×¨×” ×‘××™× ×˜×¨× ×˜',0),(244605,6795,'el','ÎˆÏ‡ÎµÎ¹ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ ÎºÎ±Î¼Î¯Î± Î´ÏÎ¬ÏƒÎ· ÏƒÎµ Î±Ï€ÎµÏ…Î¸ÎµÎ¯Î±Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(244606,6795,'zh','æ²¡æœ‰è¡ŒåŠ¨åœ¨çº¿è¢«é€‰ä¸º\r\n',0),(244607,6795,'sv','Ingen Ã¥tgÃ¤rd har valts OnLine',0),(244608,6795,'it','Nessuna azione Ã¨ stata selezionata OnLine',0),(244609,6795,'tl','',0),(244610,6795,'th','&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3648;&#3621;&#3639;&#3629;&#3585;&#3629;&#3629;&#3609;&#3652;&#3621;&#3609;&#3660;',0),(244611,6795,'hi','à¤•à¥‹à¤ˆ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤‘à¤¨à¤²à¤¾à¤‡à¤¨ à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(244612,6795,'ms','Tiada tindakan telah dipilih dalam talian',0),(244613,6795,'ar','ØªÙ… Ø§Ø®ØªÙŠØ§Ø± Ù„Ø§ Ø¹Ù…Ù„ Ø¹Ù„Ù‰ Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(244614,6795,'fr','Aucune Action n\'a Ã©tÃ© sÃ©lectionnÃ©e en ligne',0),(244615,6795,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ãŒã‚ªãƒ³ãƒ©ã‚¤ãƒ³é¸æŠžã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(244616,6795,'pt','Nenhuma aÃ§Ã£o foi selecionada on-line',0),(244617,6795,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ OnLine ÐÐµ Ð‘Ñ‹Ð»Ð¾ Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð¾',0),(244618,6795,'es','No se SeleccionÃ³ una AcciÃ³n en Linea',0),(244619,6795,'de','Keine Aktion ist OnLine ausgewÃ¤hlt worden',0),(244620,6795,'en','No Action Has Been Selected OnLine',0),(244621,6796,'is','',0),(244622,6796,'dr','-Ù„Ø§ÙŠÙ† Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(244623,6796,'pr','Ù‡ÙŠÚ† Ø¯Ù„ÙŠÙ„ÙŠ Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ ØµÙˆØ±Øª Ø¢Ù†-Ù„Ø§ÙŠÙ† Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(244624,6796,'tr','DÃ¶nÃ¼ÅŸ sebepsiz satÄ±rÄ±na girilen',0),(244625,6796,'pl','Nie ma powodu powrotu zostaÅ‚o wpisane na linii',0),(244626,6796,'bg','ÐÑÐ¼Ð° Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð²Ñ€ÑŠÑ‰Ð°Ð½ÐµÑ‚Ð¾ Ðµ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½ Ð² Ñ€ÐµÐ´Ð°',0),(244627,6796,'ur','ÙˆØ§Ù¾Ø³ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ ÙˆØ¬Û Ù„Ø§Ø¦Ù† Ù¾Ø± Ø¯Ø§Ø®Ù„ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(244628,6796,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ð·Ð»Ð¾Ð³Ð° Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚Ð°Ðº Ñ˜Ðµ ÑƒÐ½ÐµÑ‚Ð¾ Ñƒ Ñ€ÐµÐ´',0),(244629,6796,'vi','LÃ½ do hoÃ n tráº£ chÆ°a Ä‘Æ°á»£c nháº­p vÃ o ',0),(244630,6796,'af','Geen rede vir terugkeer op lyn ingeskryf is',0),(244631,6796,'ro','Nici un motiv pentru returnare a fost Ã®nscrisÄƒ pe linia',0),(244632,6796,'et','Mingit tagastamise pÃµhjus reale sisestatud',0),(244633,6796,'si','Nobenega razloga za vrnitev je vnesena na spletu',0),(244634,6796,'ba','Tidak ada alasan untuk kembali telah memasuki jalur',0),(244635,6796,'nl','Geen reden voor terugzending is ingevoerd op de regel',0),(244636,6796,'fi','MitÃ¤Ã¤n syytÃ¤ palauttaminen ei ole syÃ¶tetty rivin',0),(244637,6796,'no','Ingen grunn til at avkastningen ikke er angitt i linjen',0),(244638,6796,'da','Ingen grund til at vende tilbage ikke er angivet pÃ¥ linjen',0),(244639,6796,'ko','ë°˜í™˜ì„ ìœ„í•œ ì´ìœ ê°€ ë¼ì¸ì— ìž…ë ¥ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(244640,6796,'he','××™×Ÿ ×¡×™×‘×” ×œ×—×–×•×¨ ×”×•×–×Ÿ ×‘×©×•×¨×”',0),(244641,6796,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î»ÏŒÎ³Î¿Ï‚ Î³Î¹Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î­Ï‡ÎµÎ¹ ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯ ÏƒÏ„Î·Î½ Î³ÏÎ±Î¼Î¼Î®',0),(244642,6796,'zh','æ²¡æœ‰åŽŸå› ï¼Œå› ä¸ºé€€å›žå·²è¢«åœ¨çº¿è¾“å…¥\r\n',0),(244643,6796,'sv','NÃ¥gon anledning fÃ¶r Ã¥tergÃ¥ng har angetts pÃ¥ raden',0),(244644,6796,'it','Nessun motivo per il ritorno Ã¨ stato immesso in linea',0),(244645,6796,'tl','',0),(244646,6796,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3629;&#3629;&#3',0),(244647,6796,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤•à¤¾à¤°à¤£ à¤¨à¤¹à¥€à¤‚ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤ªà¤° à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(244648,6796,'ms','Ada sebab untuk kembali dimasukkan dalam talian',0),(244649,6796,'ar','ØªÙ… Ø¥Ø¯Ø®Ø§Ù„ Ø£ÙŠ Ø³Ø¨Ø¨ Ù„Ù„Ø¹ÙˆØ¯Ø© Ø¹Ù„Ù‰ Ø§Ù„Ø®Ø·',0),(244650,6796,'fr','Aucune raison pour le retour n\'a Ã©tÃ© inscrit Ã  la ligne',0),(244651,6796,'jp','è¡Œã«è¿”å“ç†ç”±ãŒå…¥åŠ›ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(244652,6796,'pt','NÃ£o hÃ¡ razÃ£o para o retorno foi inserido na linha',0),(244653,6796,'ru','ÐÐ¸ÐºÐ°ÐºÐ¸Ñ… Ð¾ÑÐ½Ð¾Ð²Ð°Ð½Ð¸Ð¹ Ð´Ð»Ñ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ñ Ð±Ñ‹Ð» Ð²Ð²ÐµÐ´ÐµÐ½ Ð½Ð° Ð»Ð¸Ð½Ð¸Ð¸',0),(244654,6796,'es','No hay Causa para la DevoluciÃ³n se EntrÃ³ En Linea',0),(244655,6796,'de','Kein Grund fÃ¼r die RÃ¼cksendung wurde in Zeile eingegeben',0),(244656,6796,'en','No Reason for Return Has Been Entered On Line',0),(244657,6797,'is','',0),(244658,6797,'dr','Ù‡ÙŠÚ† Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(244659,6797,'pr','Ù‡ÙŠÚ† Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(244660,6797,'tr','HiÃ§bir sevkiyat bulundu',0),(244661,6797,'pl','Brak wydania Znalezione',0),(244662,6797,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð¸Ñ‚Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(244663,6797,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ú¾ÛŒÙ¾ Ù¾Ø§ÛŒØ§',0),(244664,6797,'sr','ÐÐµÐ¼Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð½Ð°ÑˆÐ°Ð¾',0),(244665,6797,'vi','KhÃ´ng tÃ¬m tháº¥y chuyáº¿n hÃ ng',0),(244666,6797,'af','Geen Versending Gevind',0),(244667,6797,'ro','Nici o expediere gÄƒsit',0),(244668,6797,'et','Leitud saatmata',0),(244669,6797,'si','Brez dobave naÅ¡el',0),(244670,6797,'ba','Tidak ada pengiriman yang ditemukan',0),(244671,6797,'nl','Geen verzending gevonden',0),(244672,6797,'fi','Ei lÃ¤hetys lÃ¶ytyi',0),(244673,6797,'no','Ingen levering funnet',0),(244674,6797,'da','Ingen forsendelse fundet',0),(244675,6797,'ko','ì•„ë‹ˆ ì„ ì  ë°œê²¬',0),(244676,6797,'he','×ž×©×œ×•×— × ×ž×¦××•',0),(244677,6797,'el','ÎšÎ±Î¼Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Ï€Î¿Ï… Î²ÏÎ¯ÏƒÎºÎµÏ„Î±Î¹',0),(244678,6797,'zh','æ²¡æœ‰æ‰¾åˆ°è´§ç‰©\r\n',0),(244679,6797,'sv','Avfallstransporter hittade',0),(244680,6797,'it','Nessuna spedizione trovata',0),(244681,6797,'tl','',0),(244682,6797,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(244683,6797,'hi','à¤•à¥‹à¤ˆ à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤ªà¤¾à¤¯à¤¾',0),(244684,6797,'ms','Tiada penghantaran yang dijumpai',0),(244685,6797,'ar','Ø§Ù„Ø´Ø­Ù†Ø© Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(244686,6797,'fr','Aucune expÃ©dition trouvÃ©e',0),(244687,6797,'jp','ã„ã„ãˆå‡ºè·ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(244688,6797,'pt','Nenhuma expediÃ§Ã£o encontrou',0),(244689,6797,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(244690,6797,'es','No se EncontrÃ³ una EnvÃ­o',0),(244691,6797,'de','Keine Sendung gefunden',0),(244692,6797,'en','No Shipment Found',0),(244693,6798,'is','',0),(244694,6798,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ ÙƒÙ…ØªØ± Ø§Ø² ØµÙØ± Ø§Ø³Øª',0),(244695,6798,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ ÙƒÙ…ØªØ± Ø§Ø² ØµÙØ± Ø§Ø³Øª',0),(244696,6798,'tr','Girilen miktar olduÄŸu kÃ¼Ã§Ã¼ktÃ¼r sÄ±fÄ±r',0),(244697,6798,'pl','IloÅ›Ä‡ wprowadzona jest mniej niÅ¼ Zero',0),(244698,6798,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ðµ Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¾Ñ‚ Ð½ÑƒÐ»Ð°',0),(244699,6798,'ur','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø§Ø®Ù„ ÛÛ’ Ø³Û’ Ú©Ù… ØµÙØ±',0),(244700,6798,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑƒÐ½ÐµÑ‚Ð° Ð¼Ð°ÑšÐ¸ Ð¾Ð´ Ð½ÑƒÐ»Ðµ',0),(244701,6798,'vi','Sá»‘ lÆ°á»£ng nháº­p vÃ o Ã­t hÆ¡n Zero',0),(244702,6798,'af','Hoeveelheid ingetik Is minder Zero',0),(244703,6798,'ro','Cantitatea introdusÄƒ este mai micÄƒ decÃ¢t Zero',0),(244704,6798,'et','Sisestatud kogus on vÃ¤iksem kui null',0),(244705,6798,'si','Vpisana koliÄina je manjÅ¡a od niÄ',0),(244706,6798,'ba','Kuantitas masuk kurang dari nol',0),(244707,6798,'nl','Aantal hebt ingevoerd Is kleiner dan nul',0),(244708,6798,'fi','SyÃ¶tetty mÃ¤Ã¤rÃ¤ on pienempi kuin nolla',0),(244709,6798,'no','Antallet som er angitt er mindre enn null',0),(244710,6798,'da','Angivne antal er mindre end nul',0),(244711,6798,'ko','ìˆ˜ëŸ‰ ìž…ë ¥ 0 ë³´ë‹¤ ìž‘ì€',0),(244712,6798,'he','×›×ž×•×ª ×©×”×•×–× ×” ×ž××¤×¡',0),(244713,6798,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Ï„Î­Î¸Î·ÎºÎµ ÎµÎ¯Î½Î±Î¹ Î¼Î¹ÎºÏÏŒÏ„ÎµÏÎ¿ Ï„Î¿Ï… Î¼Î·Î´ÎµÎ½ÏŒÏ‚',0),(244714,6798,'zh','è¾“å…¥çš„æ•°é‡å°äºŽé›¶\r\n',0),(244715,6798,'sv','Det angivna antalet Ã¤r mindre Ã¤n noll',0),(244716,6798,'it','QuantitÃ  immessa Ã¨ minore di Zero',0),(244717,6798,'tl','',0),(244718,6798,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3611;&#3657;&#3629;&#3609;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;&#3624;&#3641;&#3609;&#3618;&#3660;',0),(244719,6798,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ à¤¶à¥‚à¤¨à¥à¤¯ à¤¸à¥‡ à¤­à¥€ à¤•à¤®',0),(244720,6798,'ms','Kuantiti yang dimasukkan adalah kurang daripada sifar',0),(244721,6798,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¯Ø®Ù„Ø© Ø£Ù‚Ù„ Ù…Ù† Ø§Ù„ØµÙØ±',0),(244722,6798,'fr','QuantitÃ© entrÃ©e est infÃ©rieur Ã  zÃ©ro',0),(244723,6798,'jp','å…¥åŠ›ã•ã‚ŒãŸæ•°é‡ãŒ 0 æœªæº€ã§ã™ã€‚',0),(244724,6798,'pt','Quantidade entrou Ã© menor que Zero',0),(244725,6798,'ru','Ð’Ð²ÐµÐ´ÐµÐ½Ð½Ð¾Ðµ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐœÐµÐ½ÑŒÑˆÐµ ÐÑƒÐ»Ñ',0),(244726,6798,'es','Cantidad Entrada Es Menos Que Cero',0),(244727,6798,'de','Eingegebene Menge ist kleiner als 0 (null)',0),(244728,6798,'en','Quantity Entered Is Less Than Zero',0),(244729,6799,'is','',0),(244730,6799,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„ Ø´Ø¯Ù‡ ÙƒÙ…ØªØ± Ø§Ø²  Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ù‚Ø¨Ù„ÙŠ',0),(244731,6799,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„ Ø´Ø¯Ù‡ ÙƒÙ…ØªØ± Ø§Ø²  Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ù‚Ø¨Ù„ÙŠ',0),(244732,6799,'tr','Girilen miktarÄ± daha az Ã¶nceki RMAs sevk edilen miktar daha fazla olduÄŸunu',0),(244733,6799,'pl','IloÅ›Ä‡ wprowadzona jest wiÄ™cej niÅ¼ iloÅ›Ä‡ wysÅ‚anych mniej przed RMAs',0),(244734,6799,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¿Ñ€ÐµÐ´Ð¸ RMAs',0),(244735,6799,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±Ø¯Û ØªØ¹Ø¯Ø§Ø¯ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù…Ù‚Ø¯Ø§Ø± Ù…ÛŒÚº Ú©Ù… Ù¾ÛŒØ´Ú¯ÛŒ Ø±Ù…ÛØ³ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ ÛÛ’ Û”',0),(244736,6799,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑƒÐ½ÐµÑ‚Ð° Ñ˜Ðµ Ð²Ð¸ÑˆÐµ Ð½ÐµÐ³Ð¾ ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¼Ð°ÑšÐµ Ð¸Ð³ÑƒÐ¼Ð°Ð½ Ð ÐœÐÑ',0),(244737,6799,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ nháº­p nhiá»u hÆ¡n sá»‘ lÆ°á»£ng Ä‘Ã£ chuyá»ƒn trá»« Ä‘i RMA trÆ°á»›c',0),(244738,6799,'af','Hoeveelheid ingetik Is meer as die hoeveelheid Shipped minder vooraf RMAs',0),(244739,6799,'ro','Cantitatea introdusÄƒ este mai mult decÃ¢t cantitatea livratÄƒ mai puÅ£in RMAs prealabilÄƒ',0),(244740,6799,'et','Sisestatud kogus jaguks rohkem, kui vÃ¤hem eelneva RMAs lÃ¤hetatud kogus',0),(244741,6799,'si','Vpisana koliÄina je veÄ kot manj predhodnega RMAs dobavljena koliÄina',0),(244742,6799,'ba','Kuantitas yang dimasukkan adalah lebih daripada jumlah dikirimkan kurang RMAs sebelumnya',0),(244743,6799,'nl','Aantal hebt ingevoerd Is meer dan verzonden aantal minder voorafgaande RMAs',0),(244744,6799,'fi','SyÃ¶tetty mÃ¤Ã¤rÃ¤ on enemmÃ¤n kuin vÃ¤hemmÃ¤n ennen RMAs toimitettu mÃ¤Ã¤rÃ¤',0),(244745,6799,'no','Antallet som er angitt er mer enn antall sendt mindre tidligere RMAs',0),(244746,6799,'da','Angivne antal er mere end leveret mindre forudgÃ¥ende RMAs',0),(244747,6799,'ko','ìˆ˜ëŸ‰ ìž…ë ¥ ë³´ë‹¤ëŠ” ë” ë§Žì€ ìˆ˜ëŸ‰ ì ì€ ì‚¬ì „ Rma ë°œì†¡',0),(244748,6799,'he','×›×ž×•×ª × ×›× ×¡ ×”×•× ×™×•×ª×¨ ×ž××©×¨ ×”×›×ž×•×ª ×©× ×©×œ×—×• ×¤×—×•×ª RMAs ×ž×•×§×“×ž×ª',0),(244749,6799,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³Î±Ï„Îµ ÎµÎ¯Î½Î±Î¹ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ ÏŒ, Ï„Î¹ Î»Î¹Î³ÏŒÏ„ÎµÏÎ¿ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· RMAs \"Î‘Ï€ÎµÏƒÏ„Î±Î»Î¼Î­Î½Î· Î Î¿ÏƒÏŒÏ„Î·Ï„Î±\"',0),(244750,6799,'zh','è¾“å…¥çš„æ•°é‡æ¯”å‘è´§æ•°é‡å¤šï¼Œæ¯”å…ˆå‰é€€è´§æŽˆæƒå°‘\r\n',0),(244751,6799,'sv','Det angivna antalet Ã¤r mer Ã¤n Utlevererat antal mindre tidigare RMA',0),(244752,6799,'it','QuantitÃ  immessa Ã¨ piÃ¹ che la quantitÃ  spedita meno RMAs preventiva',0),(244753,6799,'tl','',0),(244754,6799,'th','Quantity Entered Is More Than Quantity Shipped Less Prior RMAs',0),(244755,6799,'hi','à¤…à¤§à¤¿à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤® à¤ªà¥‚à¤°à¥à¤µ RMAs à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ',0),(244756,6799,'ms','Kuantiti yang dimasukkan adalah lebih daripada kuantiti yang dihantar kurang RMAs terlebih dahulu',0),(244757,6799,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¯Ø®Ù„Ø© Ø£ÙƒØ«Ø± Ù…Ù† Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ø£Ù‚Ù„ RMAs Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(244758,6799,'fr','QuantitÃ© entrÃ©e est plus que la quantitÃ© expÃ©diÃ©e moins RMAs prÃ©alables',0),(244759,6799,'jp','å…¥åŠ›ã•ã‚ŒãŸæ•°é‡ã‚ˆã‚Šã‚‚å°‘ãªã„äº‹å‰ Rma å‡ºè·æ•°é‡ãŒ',0),(244760,6799,'pt','Entrado a quantidade Ã© mais do que a quantidade enviada menos RMAs prÃ©vias',0),(244761,6799,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»-ÑÑ‚Ð¾ Ð±Ð¾Ð»ÑŒÑˆÐµ, Ñ‡ÐµÐ¼ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÑÐµÑ‚ÑÑ Ð¼ÐµÐ½ÑŒÑˆÐµ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð¹ Ð·Ð°ÑÐ²ÐºÐ¸ RMA',0),(244762,6799,'es','Cantidad Entrada Es MÃ¡s Que la Cantidad Enviada Menos RMAs Anteriores',0),(244763,6799,'de','Eingegebene Menge ist mehr als die Menge weniger vorherige RMAs geliefert',0),(244764,6799,'en','Quantity Entered Is More Than Quantity Shipped Less Prior RMAs',0),(244765,6800,'is','',0),(244766,6800,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ù‚Ø¨Ù„ÙŠ',0),(244767,6800,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ù‚Ø¨Ù„ÙŠ',0),(244768,6800,'tr','Miktar Ã¶nceden RMA',0),(244769,6800,'pl','IloÅ›Ä‡ wczeÅ›niejszych RMA',0),(244770,6800,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð Ð¡Ðž',0),(244771,6800,'ur','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÛŒØ´Ú¯ÛŒ Ø±Ù…',0),(244772,6800,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¸Ð³ÑƒÐ¼Ð°Ð½ ÐžÐŸÐ¡',0),(244773,6800,'vi','Sá»‘ lÆ°á»£ng trÆ°á»›c RMA',0),(244774,6800,'af','Hoeveelheid vooraf RMA',0),(244775,6800,'ro','Cantitatea RMA prealabilÄƒ',0),(244776,6800,'et','Kogus eelneva RMA',0),(244777,6800,'si','KoliÄina predhodnega RMA',0),(244778,6800,'ba','Kuantitas sebelumnya RMA',0),(244779,6800,'nl','Hoeveelheid voorafgaande RMA',0),(244780,6800,'fi','MÃ¤Ã¤rÃ¤ ennen RMA',0),(244781,6800,'no','Antallet tidligere RMA',0),(244782,6800,'da','MÃ¦ngde forudgÃ¥ende RMA',0),(244783,6800,'ko','ìˆ˜ëŸ‰ ì‚¬ì „ RMA',0),(244784,6800,'he','×›×ž×•×ª RMA ×ž×•×§×“×ž×ª',0),(244785,6800,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· RMA Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(244786,6800,'zh','æ•°é‡ä¼˜å…ˆé€€è´§æŽˆæƒ\r\n',0),(244787,6800,'sv','Kvantitet fÃ¶re RMA',0),(244788,6800,'it','QuantitÃ  precedente RMA',0),(244789,6800,'tl','',0),(244790,6800,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603; RMA &#3607;&#3637;&#3656;&#3617;&#3637;&#3617;&#3634;&#3585;&#3656;&#3629;&#3609;',0),(244791,6800,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥‚à¤°à¥à¤µ RMA',0),(244792,6800,'ms','Kuantiti RMA terlebih dahulu',0),(244793,6800,'ar','Ø§Ù„ÙƒÙ…Ù‘ÙŠÙ‘Ø© Ù‚Ø¨Ù„ Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(244794,6800,'fr','QuantitÃ© prÃ©alable RMA',0),(244795,6800,'jp','æ•°é‡äº‹å‰ RMA',0),(244796,6800,'pt','Quantidade prÃ©via RMA',0),(244797,6800,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ñ… RMA',0),(244798,6800,'es','Cantidad RMA Anterior',0),(244799,6800,'de','Menge vorheriger RMA',0),(244800,6800,'en','Quantity Prior RMA',0),(244801,6801,'is','',0),(244802,6801,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§ÙŠÙ† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(244803,6801,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ÙŠÙ† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(244804,6801,'tr','Miktar bu RMA',0),(244805,6801,'pl','IloÅ›Ä‡ ta RMA',0),(244806,6801,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ‚Ð¾Ð²Ð° RMA',0),(244807,6801,'ur','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ Ø±Ù…',0),(244808,6801,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¾Ð²Ð¾Ð³ ÐžÐŸÐ¡',0),(244809,6801,'vi','Sá»‘ lÆ°á»£ng RMA nÃ y',0),(244810,6801,'af','Hoeveelheid hierdie RMA',0),(244811,6801,'ro','Cantitatea aceasta RMA',0),(244812,6801,'et','Kogus sellel RMA',0),(244813,6801,'si','KoliÄina tega RMA',0),(244814,6801,'ba','Kuantitas RMA ini',0),(244815,6801,'nl','Hoeveelheid dit RMA',0),(244816,6801,'fi','MÃ¤Ã¤rÃ¤ tÃ¤hÃ¤n RMA',0),(244817,6801,'no','Antall denne RMA',0),(244818,6801,'da','MÃ¦ngde denne RMA',0),(244819,6801,'ko','ìˆ˜ëŸ‰ì´ì´ RMA',0),(244820,6801,'he','×›×ž×•×ª ×–×• RMA',0),(244821,6801,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Ï…Ï„Î® RMA',0),(244822,6801,'zh','è¿™ä¸ªé€€è´§æŽˆæƒæ•°é‡\r\n',0),(244823,6801,'sv','Kvantitet denna RMA',0),(244824,6801,'it','QuantitÃ  questo RMA',0),(244825,6801,'tl','',0),(244826,6801,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603; RMA &#3609;&#3637;&#3657;',0),(244827,6801,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤‡à¤¸ RMA',0),(244828,6801,'ms','Kuantiti RMA ini',0),(244829,6801,'ar','ÙƒÙ…ÙŠØ© Ù‡Ø°Ø§ Ø§Ù„Ø¬ÙŠØ´ Ø§Ù„Ù…Ù„ÙƒÙŠ Ø§Ù„Ù…ØºØ±Ø¨ÙŠ',0),(244830,6801,'fr','QuantitÃ© ce RMA',0),(244831,6801,'jp','é‡ã“ã® RMA',0),(244832,6801,'pt','Quantidade esta RMA',0),(244833,6801,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÑ‚Ð¾Ð¹ RMA',0),(244834,6801,'es','Cantidad Esta RMA',0),(244835,6801,'de','Menge dieser RMA',0),(244836,6801,'en','Quantity This RMA',0),(244837,6802,'is','',0),(244838,6802,'dr','Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª ',0),(244839,6802,'pr','Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª ',0),(244840,6802,'tr','Ä°ade nedeni',0),(244841,6802,'pl','Przyczyna zwrotu',0),(244842,6802,'bg','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ',0),(244843,6802,'ur','ÙˆØ§Ù¾Ø³ÛŒ Ú©ÛŒ ÙˆØ¬Û',0),(244844,6802,'sr','Ð Ð°Ð·Ð»Ð¾Ð³ Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚Ð°Ðº',0),(244845,6802,'vi','NguyÃªn nhÃ¢n hoÃ n láº¡i',0),(244846,6802,'af','Rede vir terugkeer',0),(244847,6802,'ro','Motiv pentru returnare',0),(244848,6802,'et','Tagastamise pÃµhjus',0),(244849,6802,'si','Razlog za vrnitev',0),(244850,6802,'ba','Alasan untuk kembali',0),(244851,6802,'nl','Reden voor terugzending',0),(244852,6802,'fi','Palauttamisen syy',0),(244853,6802,'no','Grunn for retur',0),(244854,6802,'da','Ã…rsag til returnering',0),(244855,6802,'ko','ë°˜í™˜ì„ ìœ„í•œ ì´ìœ ',0),(244856,6802,'he','×¡×™×‘×ª ×”×”×—×–×¨×”',0),(244857,6802,'el','Î›ÏŒÎ³Î¿ Î³Î¹Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(244858,6802,'zh','è¿”å›žçš„åŽŸå› \r\n',0),(244859,6802,'sv','Orsak till Ã¥tersÃ¤ndande',0),(244860,6802,'it','Motivo della restituzione',0),(244861,6802,'tl','',0),(244862,6802,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3621;&#3633;&#3610;&#3617;&#3634;',0),(244863,6802,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾à¤°à¤£',0),(244864,6802,'ms','Sebab pulangan',0),(244865,6802,'ar','Ø³Ø¨Ø¨ Ø¥Ø±Ø¬Ø§Ø¹ Ø§Ù„Ù…Ø±Ø¯ÙˆØ¯Ø§Øª',0),(244866,6802,'fr','Motif de retour',0),(244867,6802,'jp','è¿”å“ã®ç†ç”±',0),(244868,6802,'pt','Motivo da devoluÃ§Ã£o',0),(244869,6802,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð°',0),(244870,6802,'es','RazÃ³n para DevoluciÃ³n',0),(244871,6802,'de','Grund fÃ¼r die RÃ¼cksendung',0),(244872,6802,'en','Reason for Return',0),(244873,6803,'is','',0),(244874,6803,'dr','ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† ',0),(244875,6803,'pr','ÙƒØ§Ù„Ø§ÙŠ Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† ',0),(244876,6803,'tr','DeÄŸiÅŸtirilen madde',0),(244877,6803,'pl','Wymiana towaru',0),(244878,6803,'bg','ÐŸÐ¾Ð´Ð¼ÑÐ½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(244879,6803,'ur','Ù…ØªØ¨Ø§Ø¯Ù„ Ø´Û’',0),(244880,6803,'sr','Ð—Ð°Ð¼ÐµÐ½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(244881,6803,'vi','HÃ ng thay tháº¿',0),(244882,6803,'af','Vervangingsitem',0),(244883,6803,'ro','ÃŽnlocuire element',0),(244884,6803,'et','Asendamine kirje',0),(244885,6803,'si','Zamenjava artikla',0),(244886,6803,'ba','Penggantian Item',0),(244887,6803,'nl','Vervangend artikel',0),(244888,6803,'fi','Korvaava nimike',0),(244889,6803,'no','Erstatningsvaren',0),(244890,6803,'da','Udskiftningsvaren',0),(244891,6803,'ko','ëŒ€ì²´ í•­ëª©',0),(244892,6803,'he','×”×—×œ×¤×ª ×¤×¨×™×˜',0),(244893,6803,'el','Î•Î¯Î´Î¿Ï‚ Î±Î½Ï„Î¹ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(244894,6803,'zh','æ›´æ¢é¡¹ç›®\r\n',0),(244895,6803,'sv','ErsÃ¤ttningsartikeln',0),(244896,6803,'it','Articolo sostitutivo',0),(244897,6803,'tl','',0),(244898,6803,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3604;&#3649;&#3607;&#3609;',0),(244899,6803,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¸à¥à¤¥à¤¾à¤ªà¤¨ à¤†à¤‡à¤Ÿà¤®',0),(244900,6803,'ms','Penggantian Item',0),(244901,6803,'ar','Ø§Ù„ØµÙ†Ù Ø§Ù„Ø¨Ø¯ÙŠÙ„',0),(244902,6803,'fr','Article de remplacement',0),(244903,6803,'jp','äº¤æ›ç”¨ã‚¢ã‚¤ãƒ†ãƒ ',0),(244904,6803,'pt','Item de substituiÃ§Ã£o',0),(244905,6803,'ru','Ð—Ð°Ð¼ÐµÐ½Ð° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(244906,6803,'es','Item de Reemplazo',0),(244907,6803,'de','Austauschartikel',0),(244908,6803,'en','Replacement Item',0),(244909,6804,'is','',0),(244910,6804,'dr','Ù†Ø§Ù…ÙˆÙÙ‚',0),(244911,6804,'pr','Ù†Ø§Ù…ÙˆÙÙ‚',0),(244912,6804,'tr','BaÅŸarÄ±sÄ±z',0),(244913,6804,'pl','Nieudane',0),(244914,6804,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐµÐ½',0),(244915,6804,'ur','Ù†Ø§Ú©Ø§Ù…',0),(244916,6804,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð°',0),(244917,6804,'vi','KhÃ´ng thÃ nh cÃ´ng',0),(244918,6804,'af','Onsuksesvol',0),(244919,6804,'ro','NereuÅŸitÄƒ',0),(244920,6804,'et','EbaÃµnnestus',0),(244921,6804,'si','NeuspeÅ¡na',0),(244922,6804,'ba','Gagal',0),(244923,6804,'nl','Mislukte',0),(244924,6804,'fi','EpÃ¤onnistunut',0),(244925,6804,'no','Mislykket',0),(244926,6804,'da','Mislykket',0),(244927,6804,'ko','ì‹¤íŒ¨ í•œ',0),(244928,6804,'he','×œ× ×ž×•×¦×œ×—',0),(244929,6804,'el','Î‘Î½ÎµÏ€Î¹Ï„Ï…Ï‡Î®Ï‚',0),(244930,6804,'zh','ä¸æˆåŠŸ\r\n',0),(244931,6804,'sv','Misslyckade',0),(244932,6804,'it','Infruttuoso',0),(244933,6804,'tl','',0),(244934,6804,'th','&#3652;&#3617;&#3656;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(244935,6804,'hi','à¤…à¤¸à¤«à¤²',0),(244936,6804,'ms','Tidak berjaya',0),(244937,6804,'ar','ØºÙŠØ± Ù†Ø§Ø¬Ø­Ø©',0),(244938,6804,'fr','Infructueuse',0),(244939,6804,'jp','å¤±æ•—ã—ã¾ã—ãŸã€‚',0),(244940,6804,'pt','Sem sucesso',0),(244941,6804,'ru','ÐÐµÑƒÐ´Ð°Ñ‡Ð½Ð¾Ð¹',0),(244942,6804,'es','Infructuoso',0),(244943,6804,'de','Erfolglos',0),(244944,6804,'en','Unsuccessful',0),(244945,6805,'is','',0),(244946,6805,'dr','ÙØ¹Ø§Ù„ÙŠØª Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(244947,6805,'pr','ÙØ¹Ø§Ù„ÙŠØª Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(244948,6805,'tr','Eylem Take iÃ§in',0),(244949,6805,'pl','DziaÅ‚ania do podjÄ™cia',0),(244950,6805,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð´Ð° Ð¿Ñ€ÐµÐ´Ð¿Ñ€Ð¸ÐµÐ¼ÐµÑ‚Ðµ',0),(244951,6805,'ur','Ø§ÛŒÚ©Ø´Ù† Ù„ÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’',0),(244952,6805,'sr','ÐÐºÑ†Ð¸Ñ˜Ñƒ Ð·Ð° ÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ',0),(244953,6805,'vi','Tiáº¿n HÃ nh HÃ nh Äá»™ng ',0),(244954,6805,'af','Neem Aksie',0),(244955,6805,'ro','Actiune de intreprins',0),(244956,6805,'et','Take Action',0),(244957,6805,'si','Dejanje zavzeti',0),(244958,6805,'ba','Tindakan yang akan dibuat',0),(244959,6805,'nl','Actie te nemen',0),(244960,6805,'fi','Suoritettava toiminto',0),(244961,6805,'no','Ã… ta',0),(244962,6805,'da','Indsats for at tage',0),(244963,6805,'ko','ì•¡ì…˜ ë°›ì•„',0),(244964,6805,'he','×¤×¢×•×œ×” ×œ×‘×¦×¢',0),(244965,6805,'el','Î”ÏÎ¬ÏƒÎ· Î³Î¹Î± Î½Î± Î»Î¬Î²ÎµÎ¹',0),(244966,6805,'zh','é‡‡å–åŠ¨ä½œ\r\n',0),(244967,6805,'sv','Ã…tgÃ¤rder fÃ¶r att ta',0),(244968,6805,'it','Azione da prendere',0),(244969,6805,'tl','',0),(244970,6805,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3592;&#3632;&#3651;&#3594;&#3657;',0),(244971,6805,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤²à¥‡ à¤²à¥‹ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(244972,6805,'ms','Tindakan untuk mengambil',0),(244973,6805,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø¹Ù„Ù‰ Ø§ØªØ®Ø§Ø°',0),(244974,6805,'fr','Action a Prendre',0),(244975,6805,'jp','å®Ÿè¡Œã™ã‚‹å‡¦ç†',0),(244976,6805,'pt','AÃ§Ã£o a tomar',0),(244977,6805,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð´Ð»Ñ Ð˜ÑÐ¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(244978,6805,'es','AcciÃ³n a Tomar',0),(244979,6805,'de','Aktion zu nehmen',0),(244980,6805,'en','Action to Take',0),(244981,6806,'is','',0),(244982,6806,'dr','Ø´Ø±Ø§ÙŠØ· ',0),(244983,6806,'pr','Ø´Ø±Ø§ÙŠØ· ',0),(244984,6806,'tr','KoÅŸul',0),(244985,6806,'pl','Warunek',0),(244986,6806,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(244987,6806,'ur','Ø­Ø§Ù„Øª',0),(244988,6806,'sr','Ð¡Ñ‚Ð°ÑšÐµ',0),(244989,6806,'vi','Äiá»u kiá»‡n',0),(244990,6806,'af','Voorwaarde',0),(244991,6806,'ro','CondiÅ£ie',0),(244992,6806,'et','Tingimus',0),(244993,6806,'si','Pogoj',0),(244994,6806,'ba','Kondisi',0),(244995,6806,'nl','Voorwaarde',0),(244996,6806,'fi','Ehto',0),(244997,6806,'no','Tilstand',0),(244998,6806,'da','Betingelse',0),(244999,6806,'ko','ì¡°ê±´',0),(245000,6806,'he','×ª× ××™',0),(245001,6806,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(245002,6806,'zh','æ¡ä»¶\r\n',0),(245003,6806,'sv','Villkor',0),(245004,6806,'it','Condizione',0),(245005,6806,'tl','',0),(245006,6806,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;',0),(245007,6806,'hi','à¤¹à¤¾à¤²à¤¤',0),(245008,6806,'ms','Keadaan',0),(245009,6806,'ar','Ø§Ù„Ø´Ø±Ø·',0),(245010,6806,'fr','Condition',0),(245011,6806,'jp','æ¡ä»¶',0),(245012,6806,'pt','CondiÃ§Ã£o',0),(245013,6806,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ðµ',0),(245014,6806,'es','CondiciÃ³n',0),(245015,6806,'de','Zustand',0),(245016,6806,'en','Condition',0),(245017,6807,'is','',0),(245018,6807,'dr','Ø±Ø¯Ù‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ',0),(245019,6807,'pr','Ø±Ø¯Ù‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ',0),(245020,6807,'tr','Kredi sÄ±nÄ±fÄ±',0),(245021,6807,'pl','Klasy kredytowej',0),(245022,6807,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ»Ð°Ñ',0),(245023,6807,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ù„Ø§Ø³',0),(245024,6807,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ»Ð°ÑÐµ',0),(245025,6807,'vi','Háº¡n Má»©c TÃ­n Dá»¥ng',0),(245026,6807,'af','Krediet Klasifikasie',0),(245027,6807,'ro','Clasa de credit',0),(245028,6807,'et','Krediiti klassis',0),(245029,6807,'si','Kreditne razred',0),(245030,6807,'ba','Kelas kredit',0),(245031,6807,'nl','Krediet-klasse',0),(245032,6807,'fi','Luotto luokan',0),(245033,6807,'no','Kreditt klasse',0),(245034,6807,'da','Kredit klasse',0),(245035,6807,'ko','ì‹ ìš© í´ëž˜ìŠ¤',0),(245036,6807,'he','×ž×—×œ×§×ª ××©×¨××™',0),(245037,6807,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ¿Ï',0),(245038,6807,'zh','ä¿¡ç”¨ç­‰çº§\r\n',0),(245039,6807,'sv','Kredit klass',0),(245040,6807,'it','Classe di credito',0),(245041,6807,'tl','',0),(245042,6807,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(245043,6807,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤µà¤°à¥à¤—',0),(245044,6807,'ms','Kelas kredit',0),(245045,6807,'ar','ÙØ¦Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(245046,6807,'fr','Classe de crÃ©dit',0),(245047,6807,'jp','ä¿¡ç”¨ã®ã‚¯ãƒ©ã‚¹',0),(245048,6807,'pt','Classe de crÃ©dito',0),(245049,6807,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¹ ÐºÐ»Ð°ÑÑ',0),(245050,6807,'es','Clase de CrÃ©dito',0),(245051,6807,'de','Kredit-Klasse',0),(245052,6807,'en','Credit Class',0),(245053,6808,'is','',0),(245054,6808,'dr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(245055,6808,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(245056,6808,'tr','RMA numarasÄ± iÃ§in kredi',0),(245057,6808,'pl','Kredyt dla numeru RMA',0),(245058,6808,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° RMA Ð½Ð¾Ð¼ÐµÑ€',0),(245059,6808,'ur','Ø±Ù… Ù†Ù…Ø¨Ø± Ú©Û’ Ù„Ø¦Û’ Ú©Ø±ÛŒÚˆÙ¹',0),(245060,6808,'sr','Ð—Ð°ÑÐ»ÑƒÐ³Ðµ Ð·Ð° ÐžÐŸÐ¡ Ð±Ñ€Ð¾Ñ˜',0),(245061,6808,'vi','TÃ­n Dá»¥ng Cho Sá»‘ RMA',0),(245062,6808,'af','Krediet vir RMA nommer',0),(245063,6808,'ro','Credit pentru numÄƒrul RMA',0),(245064,6808,'et','Krediidi RMA kood',0),(245065,6808,'si','Kredit za napiÅ¡ite Å¡tevilko RMA',0),(245066,6808,'ba','Kredit untuk nomor RMA',0),(245067,6808,'nl','Krediet voor RMA-nummer',0),(245068,6808,'fi','Kunnian RMA-numero',0),(245069,6808,'no','Ã†ren for autorisasjonsreturnummeret',0),(245070,6808,'da','Kredit til RMA-nummer',0),(245071,6808,'ko','RMA ë²ˆí˜¸ë¥¼ ì‹ ìš©',0),(245072,6808,'he','×§×¨×“×™×˜ ×¢×œ ×ž×¡×¤×¨ RMA',0),(245073,6808,'el','Î Î¯ÏƒÏ„Ï‰ÏƒÎ· Î³Î¹Î± Î±ÏÎ¹Î¸Î¼ÏŒ RMA',0),(245074,6808,'zh','ä¿¡ç”¨é€€è´§æŽˆæƒå·ç \r\n',0),(245075,6808,'sv','Kredit fÃ¶r RMA-nummer',0),(245076,6808,'it','Credito per il numero RMA',0),(245077,6808,'tl','',0),(245078,6808,'th','&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586; RMA',0),(245079,6808,'hi','RMA à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤‹à¤£',0),(245080,6808,'ms','Kredit untuk nombor RMA',0),(245081,6808,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù„Ø±Ù‚Ù… RMA',0),(245082,6808,'fr','CrÃ©dit pour numÃ©ro RMA',0),(245083,6808,'jp','RMA ç•ªå·ã®ãŸã‚ã®ä¿¡ç”¨',0),(245084,6808,'pt','CrÃ©dito para um nÃºmero de RMA',0),(245085,6808,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€ RMA',0),(245086,6808,'es','CrÃ©dito para NÃºmero de RMA',0),(245087,6808,'de','Kredit fÃ¼r RMA-Nummer',0),(245088,6808,'en','Credit for RMA Number',0),(245089,6809,'is','',0),(245090,6809,'dr','( Ø·Ù„Ø¨ ) Ù…Ø®ØªÙ„Ù ',0),(245091,6809,'pr','Ø´Ø±Ø­ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ ( Ø·Ù„Ø¨ ) Ù…Ø®ØªÙ„Ù ',0),(245092,6809,'tr','AÃ§Ä±klama Ã§eÅŸitli kredi',0),(245093,6809,'pl','Opis Misc kredytu',0),(245094,6809,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð Ð°Ð·Ð½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(245095,6809,'ur','ØªØµØ±ÛŒØ­ Ù…ØªÙØ±Ù‚ Ú©Ø±ÛŒÚˆÙ¹',0),(245096,6809,'sr','ÐžÐ¿Ð¸Ñ ÐœÐ¸ÑÑ† ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ',0),(245097,6809,'vi','MÃ´ táº£ cÃ¡c khoáº£n tÃ­n dá»¥ng phá»¥',0),(245098,6809,'af','Beskrywing Allerl. Krediet',0),(245099,6809,'ro','Descriere Misc Credit',0),(245100,6809,'et','Kirjeldus Varia krediidi',0),(245101,6809,'si','Opis Misc kreditne',0),(245102,6809,'ba','Deskripsi Misc kredit',0),(245103,6809,'nl','Beschrijving Misc krediet',0),(245104,6809,'fi','Kuvaus muut luotto',0),(245105,6809,'no','Beskrivelse Misc kreditt',0),(245106,6809,'da','Beskrivelse Misc kredit',0),(245107,6809,'ko','ì„¤ëª… ê¸°íƒ€ ì‹ ìš©',0),(245108,6809,'he','×ª×™××•×¨/×”×•×¨××•×ª ×©×•× ×•×ª ××©×¨××™',0),(245109,6809,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚ Misc',0),(245110,6809,'zh','æ‚é¡¹ä¿¡ç”¨è¯´æ˜Ž\r\n',0),(245111,6809,'sv','Beskrivning Misc kredit',0),(245112,6809,'it','Descrizione Misc credito',0),(245113,6809,'tl','',0),(245114,6809,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;',0),(245115,6809,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤µà¤¿à¤µà¤¿à¤§ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(245116,6809,'ms','Keterangan Misc kredit',0),(245117,6809,'ar','ÙˆØµÙ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù…ØªÙØ±Ù‚Ø§Øª',0),(245118,6809,'fr','Description Misc crÃ©dit',0),(245119,6809,'jp','èª¬æ˜Žãã®ä»–ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ',0),(245120,6809,'pt','DescriÃ§Ã£o Misc crÃ©dito',0),(245121,6809,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð Ð°Ð·Ð½Ð¾Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(245122,6809,'es','DescripciÃ³n Misc CrÃ©dito',0),(245123,6809,'de','Beschreibung-Misc-Kredit',0),(245124,6809,'en','Description Misc Credit',0),(245125,6810,'is','',0),(245126,6810,'dr','Ø§Ø² Ø³ÙØ§Ø±Ø´ ',0),(245127,6810,'pr','Ø§Ø² Ø³ÙØ§Ø±Ø´ ',0),(245128,6810,'tr','SipariÅŸ',0),(245129,6810,'pl','Od zamÃ³wienia',0),(245130,6810,'bg','ÐžÑ‚ Ñ€ÐµÐ´',0),(245131,6810,'ur','ØªØ±ØªÛŒØ¨ Ø³Û’',0),(245132,6810,'sr','Ð˜Ð· Ð½Ð°Ð»Ð¾Ð³Ð°',0),(245133,6810,'vi','Tá»« Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(245134,6810,'af','Vanaf Bestelling',0),(245135,6810,'ro','La comanda',0),(245136,6810,'et','Tellimusest',0),(245137,6810,'si','Iz naloga',0),(245138,6810,'ba','Urutan',0),(245139,6810,'nl','Van bestelling',0),(245140,6810,'fi','Tilauksesta',0),(245141,6810,'no','Fra ordre',0),(245142,6810,'da','Fra ordre',0),(245143,6810,'ko','ìˆœì„œì—ì„œ',0),(245144,6810,'he','×ž×”×–×ž× ×”',0),(245145,6810,'el','Î‘Ï€ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(245146,6810,'zh','ä»Žè®¢å•\r\n',0),(245147,6810,'sv','FrÃ¥n bestÃ¤llning',0),(245148,6810,'it','Dall\'ordine',0),(245149,6810,'tl','',0),(245150,6810,'th','&#3592;&#3634;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(245151,6810,'hi','à¤•à¥à¤°à¤® à¤¸à¥‡',0),(245152,6810,'ms','Dari perintah',0),(245153,6810,'ar','Ù…Ù† Ø£Ù…Ø±',0),(245154,6810,'fr','De l\'ordre',0),(245155,6810,'jp','æ³¨æ–‡ã‹ã‚‰',0),(245156,6810,'pt','De ordem',0),(245157,6810,'ru','Ð˜Ð· Ð—Ð°ÐºÐ°Ð·Ð°',0),(245158,6810,'es','Del Orden',0),(245159,6810,'de','Aus Auftrag',0),(245160,6810,'en','From Order',0),(245161,6811,'is','',0),(245162,6811,'dr','ØµØ§Ø¯Ø± Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(245163,6811,'pr','ØµØ§Ø¯Ø± Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(245164,6811,'tr','SipariÅŸ numarasÄ± iÃ§in verilen',0),(245165,6811,'pl','Wydane dla numeru porzÄ…dkowego',0),(245166,6811,'bg','Ð—Ð° Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(245167,6811,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ù†Ù…Ø¨Ø± Ø¬Ø§Ø±ÛŒ',0),(245168,6811,'sr','Ð˜Ð·Ð´Ð°Ñ‚Ð¸ Ð·Ð° Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(245169,6811,'vi','PhÃ¡t hÃ nh cho Ä‘Æ¡n Ä‘áº·t hÃ ng sá»‘',0),(245170,6811,'af','Uitgereik vir Bestelnommer',0),(245171,6811,'ro','Emis pentru numÄƒrul de ordine',0),(245172,6811,'et','Antud jÃ¤rjekorranumber',0),(245173,6811,'si','Izdano za zaporedno Å¡tevilko',0),(245174,6811,'ba','Mengeluarkan nomor pesanan',0),(245175,6811,'nl','Afgegeven voor ordernummer',0),(245176,6811,'fi','Annettu numero',0),(245177,6811,'no','Utstedt for bestillingsnummer',0),(245178,6811,'da','Udstedt for lÃ¸benummer',0),(245179,6811,'ko','ì£¼ë¬¸ ë²ˆí˜¸ì— ëŒ€ í•œ ë°œê¸‰',0),(245180,6811,'he','×”×•× ×¤×§ ×¢×‘×•×¨ ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(245181,6811,'el','Î Î¿Ï… ÎµÎºÎ´Î¯Î´Î¿Î½Ï„Î±Î¹ Î³Î¹Î± Ï„Î¿Î½ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(245182,6811,'zh','å‘å‡ºè®¢å•ç¼–å·\r\n',0),(245183,6811,'sv','UtfÃ¤rdas fÃ¶r ordernummer',0),(245184,6811,'it','Emessi per numero di ordine',0),(245185,6811,'tl','',0),(245186,6811,'th','&#3611;&#3619;&#3632;&#3648;&#3604;&#3655;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(245187,6811,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤°à¥€ à¤•à¤¿à¤ à¤—à¤',0),(245188,6811,'ms','Dikeluarkan bagi nombor pesanan',0),(245189,6811,'ar','Ø£ØµØ¯Ø± Ù„Ø£Ù…Ø± Ø¹Ø¯Ø¯',0),(245190,6811,'fr','PubliÃ© le numÃ©ro d\'ordre',0),(245191,6811,'jp','æ³¨æ–‡ç•ªå·ã®ç™ºè¡Œ',0),(245192,6811,'pt','Emitido para o nÃºmero de ordem',0),(245193,6811,'ru','ÐÐ° Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(245194,6811,'es','Emitido por NÃºmero del Orden',0),(245195,6811,'de','Bestellnummer ausgestellt',0),(245196,6811,'en','Issued for Order Number',0),(245197,6812,'is','',0),(245198,6812,'dr','Ø¢ÙŠØ§ Ø§ÙŠÙ† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø§ÙƒÙ†ÙˆÙ†  ÙƒØ§Ù…Ù„ Ø§Ø³Øª ØŸ',0),(245199,6812,'pr','Ø¢ÙŠØ§ Ø§ÙŠÙ† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø§ÙƒÙ†ÙˆÙ†  ÙƒØ§Ù…Ù„ Ø§Ø³Øª ØŸ',0),(245200,6812,'tr','RMA Åžimdi tam bu',0),(245201,6812,'pl','To teraz kompletna RMA',0),(245202,6812,'bg','Ð¢Ð¾Ð²Ð° Ð»Ð¸ Ðµ ÑÐµÐ³Ð° Ð¿ÑŠÐ»Ð½Ð°Ñ‚Ð° Ð Ð¡Ðž',0),(245203,6812,'ur','ÛŒÛ Ø±Ù… Ø§Ø¨ Ù…Ú©Ù…Ù„ ÛÛ’',0),(245204,6812,'sr','Ð”Ð° Ð»Ð¸ Ñ˜Ðµ Ð¾Ð²Ð¾ ÐžÐŸÐ¡ ÑÐ°Ð´ Ð¿Ð¾Ñ‚Ð¿ÑƒÐ½Ð¸',0),(245205,6812,'vi','RMA nÃ y Ä‘Ã£ hoÃ n thÃ nh?',0),(245206,6812,'af','Is dit RMA nou voltooi',0),(245207,6812,'ro','Acest lucru este acum complet RMA',0),(245208,6812,'et','See on nÃ¼Ã¼d tÃ¤ielik RMA',0),(245209,6812,'si','Je to RMA zdaj popolna',0),(245210,6812,'ba','Apakah ini RMA sekarang lengkap',0),(245211,6812,'nl','Is dit RMA nu compleet',0),(245212,6812,'fi','Onko tÃ¤mÃ¤ RMA nyt valmis',0),(245213,6812,'no','Er dette RMA nÃ¥ fullstendig',0),(245214,6812,'da','Er dette RMA nu komplet',0),(245215,6812,'ko','ì´ê²ƒì´ RMA ì´ì œ ì™„ë£Œ',0),(245216,6812,'he','? ×”×× ×–×” RMA ×ž×œ××” ×¢×›×©×™×•',0),(245217,6812,'el','Î‘Ï…Ï„ÏŒ ÎµÎ¯Î½Î±Î¹ Ï„ÏŽÏÎ± Ï€Î»Î®ÏÎ·Ï‚ RMA',0),(245218,6812,'zh','è¿™é€€è´§æŽˆæƒå·²ç»å®Œæˆï¼Ÿ\r\n',0),(245219,6812,'sv','Ã„r detta RMA nu komplett',0),(245220,6812,'it','Questo Ã¨ ora completa di RMA',0),(245221,6812,'tl','',0),(245222,6812,'th','RMA &#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;&#3651;&#3609;&#3586;&#3603;&#3632;&#3609;&#3637;&#3657;',0),(245223,6812,'hi','à¤‡à¤¸ RMA à¤…à¤¬ à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(245224,6812,'ms','Adakah ini RMA kini lengkap',0),(245225,6812,'ar','Ù‡Ø°Ø§ Ù‡Ùˆ Ø§Ù„Ø¬ÙŠØ´ Ø§Ù„Ù…Ù„ÙƒÙŠ Ø§Ù„Ù…ØºØ±Ø¨ÙŠ ÙƒØ§Ù…Ù„Ø© Ø§Ù„Ø¢Ù†',0),(245226,6812,'fr','Est-ce RMA maintenant complÃ¨te',0),(245227,6812,'jp','ã“ã‚Œã¯ä»Šå®Œå…¨ãª RMA ã§ã™ã€‚',0),(245228,6812,'pt','Isto Ã© RMA completa agora',0),(245229,6812,'ru','Ð­Ñ‚Ð¾ Ñ‚ÐµÐ¿ÐµÑ€ÑŒ Ð¿Ð¾Ð»Ð½Ð¾Ðµ RMA',0),(245230,6812,'es','Â¿Es Este RMA Ahora Completo?',0),(245231,6812,'de','Ist das RMA jetzt vollstÃ¤ndig',0),(245232,6812,'en','Is This RMA Now Complete',0),(245233,6813,'is','',0),(245234,6813,'dr','ÙƒØ§Ù„Ø§ Ø¨Ø±Ú¯Ø´Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯ ',0),(245235,6813,'pr','ÙƒØ§Ù„Ø§ Ø¨Ø±Ú¯Ø´Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯ ',0),(245236,6813,'tr','Madde iade',0),(245237,6813,'pl','Element faktycznie wrÃ³ciÅ‚',0),(245238,6813,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð² ÑÑŠÑ‰Ð½Ð¾ÑÑ‚ Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ',0),(245239,6813,'ur','Ø´Û’ Ø¯Ø±Ø§ØµÙ„ Ù„ÙˆÙ¹ Ø¢Ø¦Û’',0),(245240,6813,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ Ð·Ð°Ð¿Ñ€Ð°Ð²Ð¾ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾',0),(245241,6813,'vi','HÃ ng Ä‘Ã£ hoÃ n láº¡i ',0),(245242,6813,'af','Items Werklik Teruggestuur',0),(245243,6813,'ro','Element, de fapt s-a Ã®ntors',0),(245244,6813,'et','Kaup tegelikult tagastatud',0),(245245,6813,'si','Element dejansko vrnil',0),(245246,6813,'ba','Item benar-benar kembali',0),(245247,6813,'nl','Object eigenlijk geretourneerd',0),(245248,6813,'fi','Tuotteen todella palanneet',0),(245249,6813,'no','Elementet returnert',0),(245250,6813,'da','Varen faktisk returneres',0),(245251,6813,'ko','í•­ëª©ì´ ì‹¤ì œë¡œ ë°˜í™˜',0),(245252,6813,'he','×¤×¨×™×˜ ×œ×ž×¢×©×” ×—×–×¨',0),(245253,6813,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÏ€Î¹ÏƒÏ„ÏÎ¬Ï†Î·ÎºÎ±Î½',0),(245254,6813,'zh','å®žé™…è¿”å›žé¡¹ç›®\r\n',0),(245255,6813,'sv','Artikeln faktiskt Ã¥tervÃ¤nt',0),(245256,6813,'it','Elemento effettivamente restituiti',0),(245257,6813,'tl','',0),(245258,6813,'th','&#3585;&#3634;&#3619;&#3585;&#3621;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3588;&#3621;&#3639;&#3656;&#3629;&#3609;&#3652;&#3627;&#3623;',0),(245259,6813,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¾à¤¸à¥à¤¤à¤µ à¤®à¥‡à¤‚ à¤²à¥Œà¤Ÿà¥‡',0),(245260,6813,'ms','Perkara benar-benar kembali',0),(245261,6813,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø¹Ø§Ø¯ ÙØ¹Ù„Ø§',0),(245262,6813,'fr','Article effectivement retournÃ©',0),(245263,6813,'jp','å®Ÿéš›ã«è¿”ã•ã‚Œã‚‹é …ç›®',0),(245264,6813,'pt','Item realmente retornadas.',0),(245265,6813,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð²ÐµÑ€Ð½ÑƒÐ»Ð¸ÑÑŒ',0),(245266,6813,'es','Item Actualmente REtornado',0),(245267,6813,'de','Element tatsÃ¤chlich zurÃ¼ckgegeben',0),(245268,6813,'en','Item Actually Returned',0),(245269,6814,'is','',0),(245270,6814,'dr','_Ù„Ø§ÙŠÙ† Ø§Ù†ØªØ®Ø§Ø¨  Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(245271,6814,'pr','Ù‡ÙŠÚ† Ø´Ø±Ø·ÙŠ Ø¨Ø·ÙˆØ± Ø¢Ù†_Ù„Ø§ÙŠÙ† Ø§Ù†ØªØ®Ø§Ø¨  Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(245272,6814,'tr','HiÃ§bir koÅŸul OnLine seÃ§ildi',0),(245273,6814,'pl','Stan nie zostaÅ‚ wybrany OnLine',0),(245274,6814,'bg','ÐÑÐ¼Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ðµ Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½ Ð¾Ð½Ð»Ð°Ð¹Ð½',0),(245275,6814,'ur','Ú©ÙˆØ¦ÛŒ Ø´Ø±Ø· Ø¢Ù† Ù„Ø§Ø¦Ù† Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(245276,6814,'sr','Ð¡Ñ‚Ð°ÑšÑƒ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð° Ñ˜Ðµ Ð½Ð° Ð¼Ñ€ÐµÐ¶Ð¸',0),(245277,6814,'vi','ChÆ°a chá»n Ä‘iá»u kiá»‡n nÃ o trá»±c tuyáº¿n',0),(245278,6814,'af','Geen toestand is aanlyn gekies',0),(245279,6814,'ro','Nici o condiÅ£ie a fost selectat OnLine',0),(245280,6814,'et','Ãœkski tingimus on valitud OnLine',0),(245281,6814,'si','Ni pogoj, je bil izbran OnLine',0),(245282,6814,'ba','Ada kondisi telah dipilih secara OnLine',0),(245283,6814,'nl','Geen voorwaarde is OnLine geselecteerd',0),(245284,6814,'fi','Ole edellytys ei ole valittu verkossa',0),(245285,6814,'no','Ingen betingelse er valgt OnLine',0),(245286,6814,'da','Ingen tilstand er valgt OnLine',0),(245287,6814,'ko','ì˜¨ë¼ì¸ ì„ íƒ ì¡°ê±´ ì—†ìŒ',0),(245288,6814,'he','×œ× ×‘×ž×¦×‘ × ×‘×—×¨ ×‘××™× ×˜×¨× ×˜',0),(245289,6814,'el','ÎšÎ±Î¼Î¯Î± Ï€ÎµÏÎ¯Ï€Ï„Ï‰ÏƒÎ· Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ ÏƒÎµ Î±Ï€ÎµÏ…Î¸ÎµÎ¯Î±Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(245290,6814,'zh','æ²¡æœ‰åœ¨çº¿é€‰å®šçš„æ¡ä»¶\r\n',0),(245291,6814,'sv','Inga villkor har valts OnLine',0),(245292,6814,'it','Nessuna condizione Ã¨ stato selezionato OnLine',0),(245293,6814,'tl','',0),(245294,6814,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3648;&#3621;&#3639;&#3629;&#3585;&#3629;&#3629;&#3609;&#3652;&#3621;&#3609;&#3660;',0),(245295,6814,'hi','à¤•à¥‹à¤ˆ à¤¶à¤°à¥à¤¤ à¤‘à¤¨à¤²à¤¾à¤‡à¤¨ à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(245296,6814,'ms','Tiada sebarang syarat telah dipilih dalam talian',0),(245297,6814,'ar','ØªÙ… Ø§Ø®ØªÙŠØ§Ø± Ø£ÙŠ Ø´Ø±Ø· Ø¹Ù„Ù‰ Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(245298,6814,'fr','Aucune Condition n\'a Ã©tÃ© sÃ©lectionnÃ©e en ligne',0),(245299,6814,'jp','çŠ¶æ…‹ãŒã‚ªãƒ³ãƒ©ã‚¤ãƒ³é¸æŠžã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(245300,6814,'pt','Nenhuma condiÃ§Ã£o foi selecionada on-line',0),(245301,6814,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ðµ Ð½Ðµ Ð±Ñ‹Ð» Ð²Ñ‹Ð±Ñ€Ð°Ð½ Ð¾Ð½Ð»Ð°Ð¹Ð½',0),(245302,6814,'es','Ninguna CondiciÃ³n HabÃ­a Sido Seleccionada en Linea',0),(245303,6814,'de','Keine Bedingung hat OnLine ausgewÃ¤hlt wurde',0),(245304,6814,'en','No Condition Has Been Selected OnLine',0),(245305,6815,'is','',0),(245306,6815,'dr','Ú†Ø§Ù¾ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(245307,6815,'pr','Ú†Ø§Ù¾ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(245308,6815,'tr','Kredi YazdÄ±r',0),(245309,6815,'pl','Drukowanie kredytu',0),(245310,6815,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(245311,6815,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(245312,6815,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ',0),(245313,6815,'vi','In tÃ­n dá»¥ng',0),(245314,6815,'af','Druk Krediet',0),(245315,6815,'ro','Imprimare Credit',0),(245316,6815,'et','Prindi krediidi',0),(245317,6815,'si','Natisnete kreditne',0),(245318,6815,'ba','Mencetak kredit',0),(245319,6815,'nl','Print Credit',0),(245320,6815,'fi','Tulostetaanko hyvityksen',0),(245321,6815,'no','Skrive ut kredittgrense',0),(245322,6815,'da','Udskrive kredit',0),(245323,6815,'ko','ì¸ì‡„ ì‹ ìš©',0),(245324,6815,'he','×”×“×¤×¡ ××©×¨××™',0),(245325,6815,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ¬',0),(245326,6815,'zh','æ‰“å°ä¿¡ç”¨\r\n',0),(245327,6815,'sv','Skriva ut kredit',0),(245328,6815,'it','Stampa credito',0),(245329,6815,'tl','',0),(245330,6815,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(245331,6815,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(245332,6815,'ms','Cetak kredit',0),(245333,6815,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(245334,6815,'fr','CrÃ©dit d\'impression',0),(245335,6815,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(245336,6815,'pt','CrÃ©dito de impressÃ£o',0),(245337,6815,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(245338,6815,'es','CrÃ©dito de Imprenta',0),(245339,6815,'de','Kredit zu drucken',0),(245340,6815,'en','Print Credit',0),(245341,6816,'is','',0),(245342,6816,'dr','(Ù…Ø¬ÙˆØ²) Ø§Ù†ØªØ®Ø§Ø¨ Ùˆ ÙŠØ§  ØªØ§ÙŠÙŠØ¯ ',0),(245343,6816,'pr','Ú†Ø§Ù¾ Ø¨Ù„ÙŠØ·(Ù…Ø¬ÙˆØ²) Ø§Ù†ØªØ®Ø§Ø¨ Ùˆ ÙŠØ§  ØªØ§ÙŠÙŠØ¯ ',0),(245344,6816,'tr','YazÄ±cÄ± SeÃ§ bilet ve/veya onayÄ±',0),(245345,6816,'pl','Druku odbioru biletÃ³w i/lub potwierdzenie',0),(245346,6816,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð±Ð¸Ð»ÐµÑ‚ Ð¸/Ð¸Ð»Ð¸ Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(245347,6816,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù¹Ú©Ù¹ Ø§ÙˆØ±/ÛŒØ§ ØªØµØ¯ÛŒÙ‚',0),(245348,6816,'sr','ÐšÐ°Ñ€Ñ‚Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ° Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐ° Ð¸/Ð¸Ð»Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð°',0),(245349,6816,'vi','In vÃ© vÃ /hay xÃ¡c nháº­n',0),(245350,6816,'af','Druk Pick kaartjie en/of bevestiging',0),(245351,6816,'ro','Bilet de imprimare murÄƒturi ÅŸi/sau confirmarea',0),(245352,6816,'et','Prindi noppimine Piletite ja/vÃµi kinnituse',0),(245353,6816,'si','Tiskanje Pick vozovnice in/ali potrditev',0),(245354,6816,'ba','Pilih cetak tiket dan/atau konfirmasi',0),(245355,6816,'nl','Print Pick Ticket en/of bevestiging',0),(245356,6816,'fi','Tulosta poiminta ja/tai vahvistus',0),(245357,6816,'no','Skriv ut Plukk billett og/eller bekreftelse',0),(245358,6816,'da','Udskriv pluk billetten og/eller bekrÃ¦ftelse',0),(245359,6816,'ko','ì¸ì‡„ ì„ íƒ í‹°ì¼“ ë°/ë˜ëŠ” í™•ì¸',0),(245360,6816,'he','×œ×‘×—×•×¨ ×œ×”×“×¤×™×¡ ××ª ×”×›×¨×˜×™×¡ ×•/××• ××™×©×•×¨',0),(245361,6816,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿ Î®/ÎºÎ±Î¹ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·',0),(245362,6816,'zh','æ‰“å°é€‰æ‹©çš„æœºç¥¨å’Œ/æˆ–ç¡®è®¤\r\n',0),(245363,6816,'sv','Skriv ut plocka biljett eller bekrÃ¤ftelse',0),(245364,6816,'it','Pick stampa biglietto e/o conferma',0),(245365,6816,'tl','',0),(245366,6816,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3605;&#3633;&#3659;&#3623;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3649;&#3621;&#3657;&#3623; &#3649;&#3621;&#3632;/&#3627;&#3619;&#3639;&#3629;&#3585;&#3634;&#3619;&#3618;&#3639;&#3609;&#3618;&#3633;&',0),(245367,6816,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤‰à¤ à¤¾à¤“ à¤Ÿà¤¿à¤•à¤Ÿ à¤”à¤°/à¤¯à¤¾ à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£',0),(245368,6816,'ms','Memilih cetakan tiket dan/atau pengesahan',0),(245369,6816,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ØªØ°Ø§ÙƒØ± Ùˆ/Ø£Ùˆ ØªØ£ÙƒÙŠØ¯',0),(245370,6816,'fr','Billet choix impression et/ou Confirmation',0),(245371,6816,'jp','å°åˆ·ãƒ”ãƒƒã‚¯ ãƒã‚±ãƒƒãƒˆ ï¼ ç¢ºèªç•ªå·',0),(245372,6816,'pt','Escolha imprimir bilhetes e/ou confirmaÃ§Ã£o',0),(245373,6816,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð¸ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚ Ð¸/Ð¸Ð»Ð¸ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(245374,6816,'es','Imprimir Boleto de SelecciÃ³n y/o la ConfirmaciÃ³n',0),(245375,6816,'de','Print Pick Ticket bzw. BestÃ¤tigung',0),(245376,6816,'en','Print Pick Ticket and/or Confirmation',0),(245377,6817,'is','',0),(245378,6817,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ ÙƒÙ…ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¬Ø§Ø² Ø§Ø³Øª',0),(245379,6817,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ ÙƒÙ…ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¬Ø§Ø² Ø§Ø³Øª',0),(245380,6817,'tr','Girilen miktar izin verilenden daha azdÄ±r',0),(245381,6817,'pl','IloÅ›Ä‡ wprowadzona jest mniejsza niÅ¼ dozwolone',0),(245382,6817,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ðµ Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¾Ñ‚ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾Ñ‚Ð¾',0),(245383,6817,'ur','Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø³Û’ Ú©Ù… Ù…Ù‚Ø¯Ø§Ø± Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ ÛÛ’',0),(245384,6817,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑƒÐ½ÐµÑ‚Ð° Ñ˜Ðµ Ð¼Ð°ÑšÐ¸ Ð½ÐµÐ³Ð¾ ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(245385,6817,'vi','Sá»‘ lÆ°á»£ng nháº­p vÃ o Ã­t hÆ¡n cho phÃ©p',0),(245386,6817,'af','Hoeveelheid ingetik Is minder as toegelaat',0),(245387,6817,'ro','Cantitatea introdusÄƒ este mai micÄƒ decÃ¢t permis',0),(245388,6817,'et','Sisestatud kogus on vÃ¤iksem kui lubatud',0),(245389,6817,'si','Vnesena koliÄina, manjÅ¡a od dovoljene',0),(245390,6817,'ba','Kuantitas memasuki berjarak kurang dari diperbolehkan',0),(245391,6817,'nl','Aantal hebt ingevoerd Is minder dan toegestaan',0),(245392,6817,'fi','SyÃ¶tetty mÃ¤Ã¤rÃ¤ on pienempi kuin sallittu',0),(245393,6817,'no','Antallet som er angitt er mindre enn tillatt',0),(245394,6817,'da','Angivne antal er mindre end tilladt',0),(245395,6817,'ko','ìˆ˜ëŸ‰ ìž…ë ¥ í•œ í—ˆìš© í•˜ëŠ” ê²ƒ ë³´ë‹¤ëŠ”',0),(245396,6817,'he','×›×ž×•×ª × ×›× ×¡ ×”×•× ×¤×—×•×ª ×ž×”×ž×•×ª×¨',0),(245397,6817,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Ï„Î­Î¸Î·ÎºÎµ ÎµÎ¯Î½Î±Î¹ Î¼Î¹ÎºÏÏŒÏ„ÎµÏÎ· Î±Ï€ÏŒ ÏŒ, Ï„Î¹ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(245398,6817,'zh','è¾“å…¥çš„æ•°é‡å°‘äºŽå…è®¸å€¼\r\n',0),(245399,6817,'sv','Det angivna antalet Ã¤r mindre Ã¤n tillÃ¥tet',0),(245400,6817,'it','QuantitÃ  immessa Ã¨ inferiore a quella consentita',0),(245401,6817,'tl','',0),(245402,6817,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3611;&#3657;&#3629;&#3609;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3',0),(245403,6817,'hi','à¤¸à¥‡ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€ à¤•à¤® à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ',0),(245404,6817,'ms','Kuantiti yang dimasukkan adalah kurang daripada yang dibenarkan',0),(245405,6817,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¯Ø®Ù„Ø© Ø£Ù‚Ù„ Ù…Ù† Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(245406,6817,'fr','QuantitÃ© entrÃ©e est infÃ©rieure Ã  permis',0),(245407,6817,'jp','å…¥åŠ›ã•ã‚ŒãŸæ•°é‡ã‚ˆã‚Šã‚‚å°ã•ã„è¨±å¯',0),(245408,6817,'pt','Entrado a quantidade Ã© menor do que o permitido',0),(245409,6817,'ru','Ð’Ð²ÐµÐ´ÐµÐ½Ð½Ð¾Ðµ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐœÐµÐ½ÑŒÑˆÐµ Ð”Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð¾Ð³Ð¾',0),(245410,6817,'es','Cantidad Entrada Es Menos Que Permitida',0),(245411,6817,'de','Eingegebene Menge ist kleiner als erlaubt',0),(245412,6817,'en','Quantity Entered Is Less Than Allowed',0),(245413,6818,'is','',0),(245414,6818,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ¸Ø§Ø± Ø§Ø³Øª',0),(245415,6818,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨ÙŠØ´ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ¸Ø§Ø± Ø§Ø³Øª',0),(245416,6818,'tr','Girilen miktarÄ±n beklenen miktar fazla olmasÄ±',0),(245417,6818,'pl','IloÅ›Ä‡ wprowadzona jest wiÄ™ksza niÅ¼ iloÅ›Ä‡ oczekuje',0),(245418,6818,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(245419,6818,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±Ø¯Û ØªØ¹Ø¯Ø§Ø¯ Ù…Ù‚Ø¯Ø§Ø± ØªÙˆÙ‚Ø¹ Ø³Û’ Ø²ÛŒØ§Ø¯Û ÛÛ’ Û”',0),(245420,6818,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑƒÐ½ÐµÑ‚Ð° Ñ˜Ðµ Ð²Ð¸ÑˆÐµ Ð¾Ð´ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ Ð¾Ñ‡ÐµÐºÑƒÑ˜Ðµ',0),(245421,6818,'vi','Sá»‘ lÆ°á»£ng nháº­p vÃ o nhiá»u hÆ¡n mong Ä‘á»£i ',0),(245422,6818,'af','Hoeveelheid ingetik Is meer as die hoeveelheid verwag',0),(245423,6818,'ro','Cantitatea introdusÄƒ este mai mult decÃ¢t cantitatea de aÅŸteptat',0),(245424,6818,'et','Sisestatud kogus on suurem kui eeldatav kogus',0),(245425,6818,'si','Vpisana koliÄina je veÄ kot koliÄina priÄakuje',0),(245426,6818,'ba','Kuantitas yang dimasukkan adalah lebih dari jumlah yang diharapkan',0),(245427,6818,'nl','Aantal hebt ingevoerd Is meer dan hoeveelheid verwacht',0),(245428,6818,'fi','SyÃ¶tetty mÃ¤Ã¤rÃ¤ on enemmÃ¤n kuin odotettavissa mÃ¤Ã¤rÃ¤',0),(245429,6818,'no','Antallet som er angitt er mer enn antallet forventet',0),(245430,6818,'da','Angivne antal er stÃ¸rre end antallet forventes',0),(245431,6818,'ko','ìˆ˜ëŸ‰ ìž…ë ¥ ë³´ë‹¤ëŠ” ë” ë§Žì€ ì˜ˆìƒ ìˆ˜ëŸ‰',0),(245432,6818,'he','×›×ž×•×ª × ×›× ×¡ ×”×•× ×™×•×ª×¨ ×ž××©×¨ ×”×›×ž×•×ª ×¦×¤×•×™',0),(245433,6818,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Ï„Î­Î¸Î·ÎºÎµ ÎµÎ¯Î½Î±Î¹ ÎºÎ¬Ï„Î¹ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Î±Î½Î±Î¼Î­Î½ÎµÏ„Î±Î¹',0),(245434,6818,'zh','è¾“å…¥çš„æ•°é‡æ¯”é¢„æœŸçš„æ•°é‡å¤š\r\n',0),(245435,6818,'sv','Det angivna antalet Ã¤r mer Ã¤n vÃ¤ntat',0),(245436,6818,'it','QuantitÃ  immessa Ã¨ piÃ¹ quantitativo previsto',0),(245437,6818,'tl','',0),(245438,6818,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3611;&#3657;&#3629;&#3609;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3588;&#3',0),(245439,6818,'hi','à¤…à¤ªà¥‡à¤•à¥à¤·à¤¿à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ',0),(245440,6818,'ms','Kuantiti yang dimasukkan adalah lebih daripada kuantiti yang dijangka',0),(245441,6818,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¯Ø®Ù„Ø© Ø£ÙƒØ«Ø± Ù…Ù† Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ØªÙˆÙ‚Ø¹Ø©',0),(245442,6818,'fr','QuantitÃ© entrÃ©e est plus que la quantitÃ© prÃ©vue',0),(245443,6818,'jp','å…¥åŠ›ã•ã‚ŒãŸæ•°é‡ãŒæœŸå¾…ã•ã‚Œã‚‹é‡ä»¥ä¸Š',0),(245444,6818,'pt','Entrado a quantidade Ã© mais do que a quantidade esperada',0),(245445,6818,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð» ÑÑ‚Ð¾ Ð±Ð¾Ð»ÑŒÑˆÐµ, Ñ‡ÐµÐ¼ Ð¾Ð¶Ð¸Ð´Ð°ÐµÐ¼Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(245446,6818,'es','Cantidad Entrada Es MÃ¡s Que la Cantidad Esperada',0),(245447,6818,'de','Eingegebene Menge ist mehr als QuantitÃ¤t erwartet',0),(245448,6818,'en','Quantity Entered Is More Than Quantity Expected',0),(245449,6819,'is','',0),(245450,6819,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø·Ø¨Ù‚ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(245451,6819,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø·Ø¨Ù‚ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(245452,6819,'tr','RMA miktarÄ±',0),(245453,6819,'pl','IloÅ›Ä‡ na RMA',0),(245454,6819,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ð Ð¡Ðž',0),(245455,6819,'ur','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø± Ø±Ù…',0),(245456,6819,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñƒ ÐžÐŸÐ¡',0),(245457,6819,'vi','Sá»‘ lÆ°á»£ng trÃªn RMA',0),(245458,6819,'af','Hoeveelheid op RMA',0),(245459,6819,'ro','Cantitatea pe RMA',0),(245460,6819,'et','Tagastatud kauba kogus',0),(245461,6819,'si','KoliÄina na RMA',0),(245462,6819,'ba','Kuantitas pada RMA',0),(245463,6819,'nl','Aantal op RMA',0),(245464,6819,'fi','MÃ¤Ã¤rÃ¤ RMA',0),(245465,6819,'no','Antallet pÃ¥ RMA',0),(245466,6819,'da','Salgsklare RMA',0),(245467,6819,'ko','RMAì— ìˆ˜ëŸ‰',0),(245468,6819,'he','×›×ž×•×ª RMA',0),(245469,6819,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î³Î¹Î± RMA',0),(245470,6819,'zh','é€€è´§æŽˆæƒæ•°é‡\r\n',0),(245471,6819,'sv','Kvantiteten pÃ¥ RMA',0),(245472,6819,'it','QuantitÃ  di RMA',0),(245473,6819,'tl','',0),(245474,6819,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3651;&#3609; RMA',0),(245475,6819,'hi','RMA à¤ªà¤° à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(245476,6819,'ms','Kuantiti pada RMA',0),(245477,6819,'ar','ÙƒÙ…Ù‘ÙŠÙ‘Ø© Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(245478,6819,'fr','QuantitÃ© sur RAM',0),(245479,6819,'jp','RMA ã®æ•°é‡',0),(245480,6819,'pt','Quantidade no RMA',0),(245481,6819,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° RMA',0),(245482,6819,'es','Cantidad en RMA',0),(245483,6819,'de','Menge Ã¼ber RMA',0),(245484,6819,'en','Quantity on RMA',0),(245485,6820,'is','',0),(245486,6820,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ†ÙŠ ÙŠØ§ Ø§Ø±Ø³Ø§Ù„ Ù…Ø¬Ø¯Ø¯',0),(245487,6820,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ†ÙŠ ÙŠØ§ Ø§Ø±Ø³Ø§Ù„ Ù…Ø¬Ø¯Ø¯',0),(245488,6820,'tr','MiktarÄ± deÄŸiÅŸtirmek veya yeniden gÃ¶nderme',0),(245489,6820,'pl','IloÅ›Ä‡ do zastÄ…pienia lub wysÅ‚aÄ‡',0),(245490,6820,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, Ð·Ð° Ð´Ð° Ð·Ð°Ð¼ÐµÐ½Ð¸ Ð¸Ð»Ð¸ Ð´Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾',0),(245491,6820,'ur','Ø¨Ø¯Ù„ Ø¯ÛŒÚº ÛŒØ§ Ù¾Ú¾Ø± Ø¨Ú¾ÛŒØ¬ÛŒÚº Ú©Ø±Ù†Û’ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(245492,6820,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÐºÐ¾Ñ˜Ð° Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° Ð·Ð°Ð¼ÐµÐ½Ð¸ Ð¸Ð»Ð¸ Ð¿Ð¾Ð½Ð¾Ð²Ð½Ð¾ ÑÐ»Ð°ÑšÐµ',0),(245493,6820,'vi','Sá»‘ lÆ°á»£ng Ä‘á»ƒ thay tháº¿ hay gá»­i láº¡i',0),(245494,6820,'af','Hoeveelheid om te Vervang of weer te Stuur',0),(245495,6820,'ro','Cantitatea sÄƒ Ã®nlocuiascÄƒ sau sÄƒ retrimiteÅ£i',0),(245496,6820,'et','Kogusest asendada vÃµi uuesti',0),(245497,6820,'si','KoliÄina za zamenjavo ali poslati',0),(245498,6820,'ba','Kuantitas untuk mengganti atau mengirim ulang',0),(245499,6820,'nl','Hoeveelheid te vervangen of te verzenden',0),(245500,6820,'fi','MÃ¤Ã¤rÃ¤ korvata tai lÃ¤hettÃ¤Ã¤',0),(245501,6820,'no','Antall som skal erstatte eller sende',0),(245502,6820,'da','Antal, der skal erstatte eller gensende',0),(245503,6820,'ko','êµì²´ í•˜ê±°ë‚˜ ë‹¤ì‹œ ìˆ˜ëŸ‰',0),(245504,6820,'he','×›×ž×•×ª ×œ×”×—×œ×™×£ ××• ×œ×©×œ×•×— ×©×•×‘',0),(245505,6820,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î½Î± Î±Î½Ï„Î¹ÎºÎ±Ï„Î±ÏƒÏ„Î®ÏƒÎµÎ¹ Î® Î½Î± Î¾Î±Î½Î±ÏƒÏ„ÎµÎ¯Î»ÎµÏ„Îµ',0),(245506,6820,'zh','æ›´æ¢æˆ–é‡æ–°å‘é€æ•°é‡\r\n',0),(245507,6820,'sv','Kvantitet fÃ¶r att ersÃ¤tta eller skicka',0),(245508,6820,'it','QuantitÃ  di sostituire o inviare nuovamente',0),(245509,6820,'tl','',0),(245510,6820,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3627;&#3619;&#3639;&#3629;&#3626;&#3656;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(245511,6820,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥€ à¤œà¤—à¤¹ à¤¯à¤¾ à¤«à¤¿à¤° à¤¸à¥‡ à¤­à¥‡à¤œà¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(245512,6820,'ms','Kuantiti untuk mengganti atau hantar',0),(245513,6820,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ø³ØªØ¨Ø¯Ø§Ù„ Ø£Ùˆ Ø¥Ø¹Ø§Ø¯Ø© Ø¥Ø±Ø³Ø§Ù„',0),(245514,6820,'fr','QuantitÃ© Ã  remplacer ou Ã  renvoyer',0),(245515,6820,'jp','äº¤æ›ã¾ãŸã¯å†é€ä¿¡ã™ã‚‹é‡',0),(245516,6820,'pt','Quantidade para substituir ou reenviar',0),(245517,6820,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð»Ñ Ð·Ð°Ð¼ÐµÐ½Ñ‹ Ð¸Ð»Ð¸ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾Ð¹ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(245518,6820,'es','Cantidad para Reemplazar o Reenviar',0),(245519,6820,'de','Menge zu ersetzen oder zu senden',0),(245520,6820,'en','Quantity to Replace or Resend',0),(245521,6821,'is','',0),(245522,6821,'dr','Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(245523,6821,'pr','Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(245524,6821,'tr','BugÃ¼ne kadar alÄ±nan',0),(245525,6821,'pl','Otrzymane do tej pory',0),(245526,6821,'bg','Ð”Ð¾ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð°',0),(245527,6821,'ur','ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ù…ÙˆØµÙˆÙ„',0),(245528,6821,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ð° Ð½Ð° Ð´Ð°Ñ‚ÑƒÐ¼',0),(245529,6821,'vi','Nháº­n tá»›i ngÃ y',0),(245530,6821,'af','Ontvang tot datum',0),(245531,6821,'ro','Primit la data de',0),(245532,6821,'et','Seni saadud',0),(245533,6821,'si','Prejetih do tega datuma',0),(245534,6821,'ba','Diterima ke tanggal',0),(245535,6821,'nl','Ontvangen tot nu toe',0),(245536,6821,'fi','Toistaiseksi',0),(245537,6821,'no','Mottatt dato',0),(245538,6821,'da','Modtaget til dato',0),(245539,6821,'ko','ë°›ì€ ë‚ ì§œ',0),(245540,6821,'he','×”×ª×§×‘×œ ×¢×“ ×›×”',0),(245541,6821,'el','ÎœÎ­Ï‡ÏÎ¹ ÏƒÏ„Î¹Î³Î¼Î®Ï‚',0),(245542,6821,'zh','è¿„ä»Šæ”¶åˆ°çš„\r\n',0),(245543,6821,'sv','FÃ¥tt hittills',0),(245544,6821,'it','Ricevuto ad oggi',0),(245545,6821,'tl','',0),(245546,6821,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3652;&#3611;&#3618;&#3633;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(245547,6821,'hi','à¤¤à¤¿à¤¥à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(245548,6821,'ms','Diterima sehingga kini',0),(245549,6821,'ar','ÙˆØªÙ„Ù‚Ù‰ Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(245550,6821,'fr','ReÃ§us Ã  ce jour',0),(245551,6821,'jp','æ—¥ä»˜ã‚’å—ä¿¡ã—ã¾ã—ãŸã€‚',0),(245552,6821,'pt','Recebido atÃ© Ã  data',0),(245553,6821,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ðº Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐ¼Ñƒ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(245554,6821,'es','Recibido a la Fecha',0),(245555,6821,'de','Bis heute erhalten',0),(245556,6821,'en','Received to Date',0),(245557,6822,'is','',0),(245558,6822,'dr','Ø¯Ø±ÙŠØ§ÙØª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(245559,6822,'pr','Ø¯Ø±ÙŠØ§ÙØª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(245560,6822,'tr','RMA alÄ±rsÄ±nÄ±z',0),(245561,6822,'pl','OtrzymaÄ‡ RMA',0),(245562,6822,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð Ð¡Ðž',0),(245563,6822,'ur','Ø±Ù… ÙˆØµÙˆÙ„ Ú©Ø±ÛŒÚº',0),(245564,6822,'sr','ÐŸÑ€Ð¸Ð¼Ð°ÑšÐµ ÐžÐŸÐ¡',0),(245565,6822,'vi','Nháº­n RMA',0),(245566,6822,'af','Ontvang RMA',0),(245567,6822,'ro','Primi RMA',0),(245568,6822,'et','Saada RMA',0),(245569,6822,'si','Prejeli RMA',0),(245570,6822,'ba','Menerima RMA',0),(245571,6822,'nl','Ontvangen RMA',0),(245572,6822,'fi','Saat RMA',0),(245573,6822,'no','Motta RMA',0),(245574,6822,'da','Modtage RMA',0),(245575,6822,'ko','RMAë¥¼ ë°›ì„',0),(245576,6822,'he','×œ×§×‘×œ RMA',0),(245577,6822,'el','Î›Î¬Î²ÎµÏ„Îµ RMA',0),(245578,6822,'zh','æŽ¥æ”¶é€€è´§æŽˆæƒ\r\n',0),(245579,6822,'sv','FÃ¥ RMA',0),(245580,6822,'it','Ricevere RMA',0),(245581,6822,'tl','',0),(245582,6822,'th','&#3619;&#3633;&#3610; RMA',0),(245583,6822,'hi','RMA à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(245584,6822,'ms','Terima RMA',0),(245585,6822,'ar','Ø¥Ø³ØªÙ„Ø§Ù… Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(245586,6822,'fr','Recevoir le RMA',0),(245587,6822,'jp','RMA ã‚’å—ä¿¡ã—ã¾ã™ã€‚',0),(245588,6822,'pt','Receber RMA',0),(245589,6822,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ RMA',0),(245590,6822,'es','Recibir RMA',0),(245591,6822,'de','RMA zu erhalten',0),(245592,6822,'en','Receive RMA',0),(245593,6823,'is','',0),(245594,6823,'dr','Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† Ø­Ù…Ù„ Ù…Ø¬Ø¯Ø¯ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(245595,6823,'pr','Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† Ø­Ù…Ù„ Ù…Ø¬Ø¯Ø¯ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(245596,6823,'tr','Madde iÃ§in yedek Reship',0),(245597,6823,'pl','Reship wymiana elementu',0),(245598,6823,'bg','Ð—Ð°Ð¼ÑÐ½Ð° Reship Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(245599,6823,'ur','Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…ØªØ¨Ø§Ø¯Ù„ Ø±ÛŒØ´Ø§Ù¾',0),(245600,6823,'sr','Ð ÐµÑÑ…Ð¸Ð¿ Ð·Ð°Ð¼ÐµÐ½Ñƒ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»',0),(245601,6823,'vi','Chuyá»ƒn hÃ ng thay tháº¿ cho hÃ ng',0),(245602,6823,'af','Vervanging Hersend Vir Item',0),(245603,6823,'ro','ÃŽnlocuirea rambursÄƒm pentru articol',0),(245604,6823,'et','Asendamine Reship kauba',0),(245605,6823,'si','Zamenjavo Reship za artikel',0),(245606,6823,'ba','Penggantian Reship untuk Item',0),(245607,6823,'nl','Vervanging reglementen voor object',0),(245608,6823,'fi','Korvaaminen Reship kohteelle',0),(245609,6823,'no','Erstatning Reship For varen',0),(245610,6823,'da','Udskiftning videreforsendelse til vare',0),(245611,6823,'ko','ëŒ€ì²´ í•­ëª©ì— ëŒ€ í•œ ìž¬ë°œì†¡',0),(245612,6823,'he','×”×—×œ×¤×ª Reship ×¢×‘×•×¨ ×¤×¨×™×˜',0),(245613,6823,'el','Î Î±ÏÎ±Î´Î¿Î¸Î­Î½Ï„Î± Î±Î½Ï„Î¹ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(245614,6823,'zh','æ›¿æ¢é¡¹ç›®é‡è¿\r\n',0),(245615,6823,'sv','ErsÃ¤ttare vidarebefordra fÃ¶r artikeln',0),(245616,6823,'it','Sostituzione rimbarcare per voce',0),(245617,6823,'tl','',0),(245618,6823,'th','&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3651;&#3627;&#3617;&#3656;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(245619,6823,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¤à¤¿à¤¸à¥à¤¥à¤¾à¤ªà¤¨ Reship',0),(245620,6823,'ms','Reship gantian bagi Item',0),(245621,6823,'ar','Ø§Ø³ØªØ¨Ø¯Ø§Ù„ Reship Ù„Ù„Ø¨Ù†Ø¯',0),(245622,6823,'fr','Remplacement rÃ©expÃ©dier pour Ã©lÃ©ment',0),(245623,6823,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®äº¤æ› Reship',0),(245624,6823,'pt','Reship de substituiÃ§Ã£o por Item',0),(245625,6823,'ru','Ð—Ð°Ð¼ÐµÐ½Ð° Ð¿ÐµÑ€ÐµÐ°Ð´Ñ€ÐµÑÐ¾Ð²ÐºÑƒ Ð´Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(245626,6823,'es','Reemplazo de Reenviar para Item',0),(245627,6823,'de','Ersatz-reshipping fÃ¼r Artikel',0),(245628,6823,'en','Replacement Reship For Item',0),(245629,6824,'is','',0),(245630,6824,'dr','Ø§Ø±Ø³Ø§Ù„ Ù…Ø¬Ø¯Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(245631,6824,'pr','Ø§Ø±Ø³Ø§Ù„ Ù…Ø¬Ø¯Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(245632,6824,'tr','Yedek RMA numarasÄ± yeniden gÃ¶nder',0),(245633,6824,'pl','Ponownie numer RMA wymiany',0),(245634,6824,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¿Ð¾Ð´Ð¼ÑÐ½Ð° RMA Ð½Ð¾Ð¼ÐµÑ€',0),(245635,6824,'ur','Ù…ØªØ¨Ø§Ø¯Ù„ Ø±Ù… Ù†Ù…Ø¨Ø± Ù¾Ú¾Ø± Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(245636,6824,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð½Ð¾ ÑÐ»Ð°ÑšÐµ Ð·Ð°Ð¼ÐµÐ½Ð° ÐžÐŸÐ¡ Ð±Ñ€Ð¾Ñ˜',0),(245637,6824,'vi','Gá»­i láº¡i sá»‘ RMA thay tháº¿',0),(245638,6824,'af','Herstuur Vervangings \"RMA\" Nommer',0),(245639,6824,'ro','Retrimite numÄƒrul RMA Ã®nlocuire',0),(245640,6824,'et','Uuesti asendamine tagastatud kauba kood',0),(245641,6824,'si','Poslati nadomestno Å¡tevilko RMA',0),(245642,6824,'ba','Mengirim nomor RMA penggantian',0),(245643,6824,'nl','Verzenden vervanging RMA-nummer',0),(245644,6824,'fi','LÃ¤hettÃ¤Ã¤ korvaava RMA-numero',0),(245645,6824,'no','Nytt erstatning RMA-nummer',0),(245646,6824,'da','Gensend udskiftning RMA nummer',0),(245647,6824,'ko','ëŒ€ì²´ RMA ë²ˆí˜¸ë¥¼ ìž¬ì „ì†¡',0),(245648,6824,'he','×©×œ×— ×ž×—×“×© ×ž×¡×¤×¨ RMA ×—×œ×•×¤×™',0),(245649,6824,'el','ÎžÎ±Î½Î±ÏƒÏ„ÎµÎ¯Î»ÎµÎ¹ Î±ÏÎ¹Î¸Î¼ÏŒ RMA Î±Î½Ï„Î¹ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(245650,6824,'zh','é‡å‘æ›´æ¢é€€è´§æŽˆæƒå·ç \r\n',0),(245651,6824,'sv','Skicka ersÃ¤ttare RMA-nummer',0),(245652,6824,'it','Inviare nuovamente il numero RMA sostituzione',0),(245653,6824,'tl','',0),(245654,6824,'th','&#3626;&#3656;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586; RMA &#3607;&#3637;&#3656;&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(245655,6824,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¸à¥à¤¥à¤¾à¤ªà¤¨ RMA à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¥à¤¨: à¤­à¥‡à¤œà¥‡à¤‚',0),(245656,6824,'ms','Hantar nombor RMA penggantian',0),(245657,6824,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø¥Ø±Ø³Ø§Ù„ Ø±Ù‚Ù… RMA Ø§Ù„Ø§Ø³ØªØ¨Ø¯Ø§Ù„',0),(245658,6824,'fr','Renvoyer le numÃ©ro de RMA de remplacement',0),(245659,6824,'jp','äº¤æ›ç”¨ RMA ç•ªå·ã‚’å†é€ã—ã¾ã™ã€‚',0),(245660,6824,'pt','Reenviar o nÃºmero de RMA de substituiÃ§Ã£o',0),(245661,6824,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ RMA Ð·Ð°Ð¼ÐµÐ½Ñ‹',0),(245662,6824,'es','Remandar NÃºmero de sustituciÃ³n de RMA',0),(245663,6824,'de','Ersatz-RMA-Nummer zurÃ¼cksenden',0),(245664,6824,'en','Resend Replacement RMA Number',0),(245665,6825,'is','',0),(245666,6825,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ù†Ø¨Ø§Ø±Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯',0),(245667,6825,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ù†Ø¨Ø§Ø±Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯',0),(245668,6825,'tr','Restocking Ã¼creti',0),(245669,6825,'pl','OpÅ‚ata za zwrot towaru',0),(245670,6825,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°ÐºÑÐ°Ñ‚Ð°',0),(245671,6825,'ur','Ø±ÛŒØ³Ù¹Ø§Ú©Ø§Ù†Ú¯ ÙÛŒØ³',0),(245672,6825,'sr','ÐžÐ±Ð½Ð°Ð²Ñ™Ð°Ð¼ Ð·Ð°Ð»Ð¸Ñ…Ðµ Ð½Ð°ÐºÐ½Ð°Ð´Ð°',0),(245673,6825,'vi','PhÃ­ nháº­p láº¡i hÃ ng vÃ o kho',0),(245674,6825,'af','Restocking fooi',0),(245675,6825,'ro','Taxa de repopulare',0),(245676,6825,'et','Tagastustasu',0),(245677,6825,'si','Obnavljanje pristojbina',0),(245678,6825,'ba','Restocking biaya',0),(245679,6825,'nl','Restocking Fee',0),(245680,6825,'fi','Istutuksia maksu',0),(245681,6825,'no','Forsendelsesomkostningene',0),(245682,6825,'da','GenindsÃ¦tning gebyr',0),(245683,6825,'ko','Restocking ìš”ê¸ˆ',0),(245684,6825,'he','Restocking ×“×ž×™',0),(245685,6825,'el','Î•Î Î™Î£Î¤Î¡Î•Î¨Î•Î¤Î•',0),(245686,6825,'zh','é‡æ–°è¿›è´§è´¹\r\n',0),(245687,6825,'sv','UtsÃ¤ttning avgift',0),(245688,6825,'it','Tassa rimettente',0),(245689,6825,'tl','',0),(245690,6825,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3605;&#3629;&#3610;&#3626;&#3609;&#3629;&#3591;',0),(245691,6825,'hi','à¤¶à¥à¤²à¥à¤• à¤¹à¤«à¥à¤¤à¥‡ à¤¤à¤• à¤šà¤²à¥€',0),(245692,6825,'ms','Yuran penstokan',0),(245693,6825,'ar','Ø±Ø³ÙˆÙ… Ø¥Ø¹Ø§Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†',0),(245694,6825,'fr','Frais de restockage',0),(245695,6825,'jp','è¿”å“æ‰‹æ•°æ–™',0),(245696,6825,'pt','Taxa de repovoamento',0),(245697,6825,'ru','ÐŸÐ¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(245698,6825,'es','Tarifa de Reabastecer',0),(245699,6825,'de','AbzÃ¼glich einer BearbeitungsgebÃ¼hr',0),(245700,6825,'en','Restocking Fee',0),(245701,6826,'is','',0),(245702,6826,'dr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(245703,6826,'pr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(245704,6826,'tr','RMA',0),(245705,6826,'pl','RMA',0),(245706,6826,'bg','Ð Ð¡Ðž',0),(245707,6826,'ur','Ø±Ù…',0),(245708,6826,'sr','ÐžÐŸÐ¡',0),(245709,6826,'vi','RMA',0),(245710,6826,'af','RMA',0),(245711,6826,'ro','RMA',0),(245712,6826,'et','RMA',0),(245713,6826,'si','RMA',0),(245714,6826,'ba','RMA',0),(245715,6826,'nl','RMA',0),(245716,6826,'fi','RMA',0),(245717,6826,'no','RMA',0),(245718,6826,'da','RMA',0),(245719,6826,'ko','RMA',0),(245720,6826,'he','RMA',0),(245721,6826,'el','RMA',0),(245722,6826,'zh','è¿”å›žå•†å“æŽˆæƒ\r\n',0),(245723,6826,'sv','RMA',0),(245724,6826,'it','RMA',0),(245725,6826,'tl','',0),(245726,6826,'th','RMA',0),(245727,6826,'hi','RMA',0),(245728,6826,'ms','RMA',0),(245729,6826,'ar','Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(245730,6826,'fr','RMA',0),(245731,6826,'jp','RMA',0),(245732,6826,'pt','RMA',0),(245733,6826,'ru','RMA',0),(245734,6826,'es','RMA',0),(245735,6826,'de','RMA',0),(245736,6826,'en','RMA',0),(245737,6827,'is','',0),(245738,6827,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…ÙˆØ§ÙÙ‚Øª Ù†Ø§Ù…Ù‡ Ù†Ø³Ø¨Øª Ø¨Ù‡ Ø¨Ø±Ú¯Ø´Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(245739,6827,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…ÙˆØ§ÙÙ‚Øª Ù†Ø§Ù…Ù‡ Ù†Ø³Ø¨Øª Ø¨Ù‡ Ø¨Ø±Ú¯Ø´Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(245740,6827,'tr','GÃ¶rÃ¼nÃ¼m RMAs',0),(245741,6827,'pl','Widok RMAs',0),(245742,6827,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ RMAs',0),(245743,6827,'ur','Ù…Ù†Ø¸Ø± Ø±Ù…ÛØ³',0),(245744,6827,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð ÐœÐÑ',0),(245745,6827,'vi','Xem RMAs',0),(245746,6827,'af','Bekyk RMAs',0),(245747,6827,'ro','Vezi RMAs',0),(245748,6827,'et','Vaata RMA-d',0),(245749,6827,'si','Pogled RMAs',0),(245750,6827,'ba','Lihat RMAs',0),(245751,6827,'nl','Weergave RMAs',0),(245752,6827,'fi','Katso RMAs',0),(245753,6827,'no','Vis RMAs',0),(245754,6827,'da','Se RMAs',0),(245755,6827,'ko','ë³´ê¸° Rma',0),(245756,6827,'he','×ª×¦×•×’×ª RMAs',0),(245757,6827,'el','Î ÏÎ¿Î²Î¿Î»Î® RMAs',0),(245758,6827,'zh','æŸ¥çœ‹é€€è´§æŽˆæƒ\r\n',0),(245759,6827,'sv','Visa RMA',0),(245760,6827,'it','Vista RMAs',0),(245761,6827,'tl','',0),(245762,6827,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; RMAs',0),(245763,6827,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ RMAs',0),(245764,6827,'ms','View RMAs',0),(245765,6827,'ar','Ø¹Ø±Ø¶ Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(245766,6827,'fr','Vue RMA',0),(245767,6827,'jp','Rma ãƒ“ãƒ¥ãƒ¼',0),(245768,6827,'pt','RMAs de exibiÃ§Ã£o',0),(245769,6827,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð·Ð°ÑÐ²ÐºÐ¸ RMA',0),(245770,6827,'es','Visionar RMAs',0),(245771,6827,'de','View RMAs',0),(245772,6827,'en','View RMAs',0),(245773,6828,'is','',0),(245774,6828,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(245775,6828,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(245776,6828,'tr','RMA DÃ¼zenle',0),(245777,6828,'pl','Edytuj RMA',0),(245778,6828,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð Ð¡Ðž',0),(245779,6828,'ur','Ø±Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(245780,6828,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐžÐŸÐ¡',0),(245781,6828,'vi','Sá»­a RMA',0),(245782,6828,'af','Redigeer RMA',0),(245783,6828,'ro','Editare RMA',0),(245784,6828,'et','Redigeerige tagastatud kauba',0),(245785,6828,'si','Urejanje RMA',0),(245786,6828,'ba','Mengedit RMA',0),(245787,6828,'nl','RMA bewerken',0),(245788,6828,'fi','Muokkaa RMA',0),(245789,6828,'no','Redigere RMA',0),(245790,6828,'da','Redigere RMA',0),(245791,6828,'ko','RMAë¥¼ íŽ¸ì§‘',0),(245792,6828,'he','×¢×¨×™×›×ª RMA',0),(245793,6828,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ RMA',0),(245794,6828,'zh','ç¼–è¾‘é€€è´§æŽˆæƒ\r\n',0),(245795,6828,'sv','Redigera RMA',0),(245796,6828,'it','Modifica RMA',0),(245797,6828,'tl','',0),(245798,6828,'th','&#3649;&#3585;&#3657;&#3652;&#3586; RMA',0),(245799,6828,'hi','RMA à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(245800,6828,'ms','Edit RMA',0),(245801,6828,'ar','ØªØ­Ø±ÙŠØ± Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(245802,6828,'fr','Edit RMA',0),(245803,6828,'jp','RMA ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(245804,6828,'pt','Editar RMA',0),(245805,6828,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ RMA',0),(245806,6828,'es','Editar RMA',0),(245807,6828,'de','Bearbeiten von RMA',0),(245808,6828,'en','Edit RMA',0),(245809,6829,'is','',0),(245810,6829,'dr','(Ú¯Ø±ÙˆÙ‡',0),(245811,6829,'pr','ÙƒÙ„Ø§Ø³(Ú¯Ø±ÙˆÙ‡',0),(245812,6829,'tr','SÄ±nÄ±f',0),(245813,6829,'pl','Klasa',0),(245814,6829,'bg','ÐšÐ»Ð°Ñ',0),(245815,6829,'ur','ØµÙ†Ù',0),(245816,6829,'sr','ÐšÐ»Ð°ÑÐ°',0),(245817,6829,'vi','PhÃ¢n loáº¡i',0),(245818,6829,'af','Kasifikasie',0),(245819,6829,'ro','Clasa',0),(245820,6829,'et','Klass',0),(245821,6829,'si','Razred',0),(245822,6829,'ba','Kelas',0),(245823,6829,'nl','Klasse',0),(245824,6829,'fi','Luokan',0),(245825,6829,'no','Klassen',0),(245826,6829,'da','Klasse',0),(245827,6829,'ko','í´ëž˜ìŠ¤',0),(245828,6829,'he','×ž×—×œ×§×”',0),(245829,6829,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(245830,6829,'zh','ç±»\r\n',0),(245831,6829,'sv','Klass',0),(245832,6829,'it','Classe',0),(245833,6829,'tl','',0),(245834,6829,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;',0),(245835,6829,'hi','à¤•à¤•à¥à¤·à¤¾',0),(245836,6829,'ms','Kelas',0),(245837,6829,'ar','Ø§Ù„ÙØ¦Ø©',0),(245838,6829,'fr','Classe',0),(245839,6829,'jp','ã‚¯ãƒ©ã‚¹',0),(245840,6829,'pt','Classe',0),(245841,6829,'ru','ÐšÐ»Ð°ÑÑ',0),(245842,6829,'es','Clase',0),(245843,6829,'de','Klasse',0),(245844,6829,'en','Class',0),(245845,6830,'is','',0),(245846,6830,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(245847,6830,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(245848,6830,'tr','Yeni RMA oluÅŸturun',0),(245849,6830,'pl','Tworzenie nowych RMA',0),(245850,6830,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð Ð¡Ðž',0),(245851,6830,'ur','Ù†Ø¦Û’ Ø±Ù… Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(245852,6830,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ ÐžÐŸÐ¡',0),(245853,6830,'vi','Táº¡o má»›i RMA',0),(245854,6830,'af','Skep nuwe RMA',0),(245855,6830,'ro','CreaÅ£i noi RMA',0),(245856,6830,'et','Loo uus RMA',0),(245857,6830,'si','Ustvarite nov RMA',0),(245858,6830,'ba','Buat baru RMA',0),(245859,6830,'nl','Maak nieuwe RMA',0),(245860,6830,'fi','Luo uusi RMA',0),(245861,6830,'no','Opprette nye RMA',0),(245862,6830,'da','Oprette nye RMA',0),(245863,6830,'ko','ìƒˆë¡œìš´ RMAë¥¼ ìž‘ì„±',0),(245864,6830,'he','×œ×™×¦×•×¨ RMA ×—×“×©',0),(245865,6830,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î½Î­Î± RMA',0),(245866,6830,'zh','åˆ›å»ºæ–°é€€è´§æŽˆæƒ\r\n',0),(245867,6830,'sv','Skapa nya RMA',0),(245868,6830,'it','Creare nuovo RMA',0),(245869,6830,'tl','',0),(245870,6830,'th','&#3626;&#3619;&#3657;&#3634;&#3591; RMA ',0),(245871,6830,'hi','à¤¨à¤ˆ RMA à¤¬à¤¨à¤¾à¤à¤',0),(245872,6830,'ms','Mencipta RMA baru',0),(245873,6830,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ù…Ø¨ÙŠØ¹Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(245874,6830,'fr','CrÃ©er nouveau RMA',0),(245875,6830,'jp','æ–°ã—ã„ RMA ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(245876,6830,'pt','Criar novo RMA',0),(245877,6830,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð½Ð¾Ð²Ñ‹Ñ… RMA',0),(245878,6830,'es','Crear Nuevo RMA',0),(245879,6830,'de','Erstellen neuer RMA',0),(245880,6830,'en','Create New RMA',0),(245881,6831,'is','',0),(245882,6831,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ ',0),(245883,6831,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ ',0),(245884,6831,'tr','Ä°lave Ã¼cretler',0),(245885,6831,'pl','Dodatkowe opÅ‚aty',0),(245886,6831,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(245887,6831,'ur','Ø§Ø¶Ø§ÙÛŒ Ú†Ø§Ø±Ø¬Ø²',0),(245888,6831,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(245889,6831,'vi','PhÃ­ thÃªm',0),(245890,6831,'af','Bykomende Heffings',0),(245891,6831,'ro','Taxe suplimentare',0),(245892,6831,'et','Lisatasud',0),(245893,6831,'si','DoplaÄila',0),(245894,6831,'ba','Biaya tambahan',0),(245895,6831,'nl','Extra kosten',0),(245896,6831,'fi','LisÃ¤maksut',0),(245897,6831,'no','Ekstra kostnader',0),(245898,6831,'da','Ekstra gebyrer',0),(245899,6831,'ko','ì¶”ê°€ ìš”ê¸ˆ',0),(245900,6831,'he','×—×™×•×‘×™× × ×•×¡×¤×™×',0),(245901,6831,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(245902,6831,'zh','é¢å¤–è´¹ç”¨\r\n',0),(245903,6831,'sv','Extra avgifter',0),(245904,6831,'it','Spese extra',0),(245905,6831,'tl','',0),(245906,6831,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(245907,6831,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(245908,6831,'ms','Caj-caj tambahan',0),(245909,6831,'ar','Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ©',0),(245910,6831,'fr','Frais supplÃ©mentaires',0),(245911,6831,'jp','è¿½åŠ æ–™é‡‘',0),(245912,6831,'pt','Custos extras',0),(245913,6831,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÐ±Ð¾Ñ€Ñ‹',0),(245914,6831,'es','Cargos Extras',0),(245915,6831,'de','Gegen GebÃ¼hr',0),(245916,6831,'en','Extra Charges',0),(245917,6832,'is','',0),(245918,6832,'dr','Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(245919,6832,'pr','Ø±Ø¯ÙŠÙ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(245920,6832,'tr','SatÄ±r Ã¶ÄŸesi iÃ§inde sevkiyat',0),(245921,6832,'pl','Pozycje w przesyÅ‚ce',0),(245922,6832,'bg','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ð¸Ñ‚Ðµ Ð² Ð¿Ñ€Ð°Ñ‚ÐºÐ°Ñ‚Ð°',0),(245923,6832,'ur','Ú©Ú¾ÛŒÙ¾ Ù…ÛŒÚº Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§Ø¡',0),(245924,6832,'sr','Ð ÐµÐ´Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ†Ð¸',0),(245925,6832,'vi','DÃ²ng kÃª hÃ ng trong chuyáº¿n hÃ ng',0),(245926,6832,'af','Lynitems in Versending',0),(245927,6832,'ro','Articolele de linie din livrarea',0),(245928,6832,'et','Read tarnes',0),(245929,6832,'si','Postavke v dobavnico',0),(245930,6832,'ba','Item baris dalam pengiriman',0),(245931,6832,'nl','Regelitems in verzending',0),(245932,6832,'fi','Rivikohtien toimituksen',0),(245933,6832,'no','Linjeelementene i forsendelsen',0),(245934,6832,'da','Linjeelementer i forsendelse',0),(245935,6832,'ko','ë°œì†¡ë¬¼ì—ì„œì˜ í’ˆëª©',0),(245936,6832,'he','×¤×¨×™×˜×™ ×”×©×•×¨×” ×‘×ž×©×œ×•×—',0),(245937,6832,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ„Î·Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(245938,6832,'zh','è¿è¾“è¡Œé¡¹ç›®\r\n',0),(245939,6832,'sv','Radartiklarna i leveransen',0),(245940,6832,'it','Elementi di riga nella spedizione',0),(245941,6832,'tl','',0),(245942,6832,'th','&#3626;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(245943,6832,'hi','à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤®à¥‡à¤‚ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(245944,6832,'ms','Laluan item dalam penghantaran',0),(245945,6832,'ar','Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø³Ø·Ø± ÙÙŠ Ø§Ù„Ø´Ø­Ù†',0),(245946,6832,'fr','Lignes de facturation lors de l\'expÃ©dition',0),(245947,6832,'jp','è²¨ç‰©ã®å“ç›®',0),(245948,6832,'pt','Itens de linha no carregamento',0),(245949,6832,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(245950,6832,'es','Items de LÃ­nea en el EnvÃ­o',0),(245951,6832,'de','Einzelposten im Versand',0),(245952,6832,'en','Line Items in Shipment',0),(245953,6833,'is','',0),(245954,6833,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(245955,6833,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(245956,6833,'tr','Miktar RMA',0),(245957,6833,'pl','IloÅ›Ä‡ RMA',0),(245958,6833,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð Ð¡Ðž',0),(245959,6833,'ur','Ù…Ù‚Ø¯Ø§Ø± Ø±Ù…',0),(245960,6833,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÐžÐŸÐ¡',0),(245961,6833,'vi','Sá»‘ lÆ°á»£ng RMA',0),(245962,6833,'af','Hoeveelheid RMA',0),(245963,6833,'ro','Cantitatea RMA',0),(245964,6833,'et','Kogus RMA',0),(245965,6833,'si','KoliÄina RMA',0),(245966,6833,'ba','Kuantitas RMA',0),(245967,6833,'nl','Hoeveelheid RMA',0),(245968,6833,'fi','MÃ¤Ã¤rÃ¤ RMA',0),(245969,6833,'no','Antall RMA',0),(245970,6833,'da','MÃ¦ngde RMA',0),(245971,6833,'ko','ìˆ˜ëŸ‰ RMA',0),(245972,6833,'he','×›×ž×•×ª RMA',0),(245973,6833,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± RMA',0),(245974,6833,'zh','é€€è´§æŽˆæƒæ•°é‡\r\n',0),(245975,6833,'sv','Kvantitet RMA',0),(245976,6833,'it','QuantitÃ  RMA',0),(245977,6833,'tl','',0),(245978,6833,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603; RMA',0),(245979,6833,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ RMA',0),(245980,6833,'ms','Kuantiti RMA',0),(245981,6833,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø¬ÙŠØ´ Ø§Ù„Ù…Ù„ÙƒÙŠ Ø§Ù„Ù…ØºØ±Ø¨ÙŠ',0),(245982,6833,'fr','QuantitÃ© RMA',0),(245983,6833,'jp','RMA ã®é‡',0),(245984,6833,'pt','Quantidade RMA',0),(245985,6833,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ RMA',0),(245986,6833,'es','Cantidad RMA',0),(245987,6833,'de','Menge RMA',0),(245988,6833,'en','Quantity RMA',0),(245989,6834,'is','',0),(245990,6834,'dr','Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§Ù‡Ø§ Ø·Ø¨Ù‚ Ø§ÙŠÙ† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(245991,6834,'pr','Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§Ù‡Ø§ Ø·Ø¨Ù‚ Ø§ÙŠÙ† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(245992,6834,'tr','Bu RMA Ã¶ÄŸeleri alma',0),(245993,6834,'pl','OtrzymujÄ… elementy na tym RMA',0),(245994,6834,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð½Ð° Ñ‚Ð¾Ð²Ð° RMA',0),(245995,6834,'ur','Ø§Ø³ Ø±Ù… Ù¾Ø± Ø§Ø´ÛŒØ§ ÙˆØµÙˆÙ„ Ú©Ø±ÛŒÚº',0),(245996,6834,'sr','ÐŸÑ€Ð¸Ð¼Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ð½Ð° Ð¾Ð²Ð°Ñ˜ ÐžÐŸÐ¡',0),(245997,6834,'vi','Nháº­n hÃ ng trong RMA nÃ y',0),(245998,6834,'af','Ontvang Items op Hierdie \"RMA\"',0),(245999,6834,'ro','Primi elemente pe acest RMA',0),(246000,6834,'et','Saate Ã¼ksused selles RMA',0),(246001,6834,'si','Prejmite elemente na to RMA',0),(246002,6834,'ba','Menerima item pada RMA ini',0),(246003,6834,'nl','Artikelen op dit RMA ontvangen',0),(246004,6834,'fi','Vastaanota nimikkeet tÃ¤mÃ¤ RMA',0),(246005,6834,'no','Motta varene pÃ¥ denne RMA',0),(246006,6834,'da','Modtage varer pÃ¥ denne RMA',0),(246007,6834,'ko','ì´ RMAì— í•­ëª©ì„ ë°›ì„',0),(246008,6834,'he','×ž×§×‘×œ×™× ×¢×œ ×–×” RMA ×¤×¨×™×˜×™×',0),(246009,6834,'el','Î›Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ RMA',0),(246010,6834,'zh','æŽ¥æ”¶æœ‰å…³æ­¤é€€è´§æŽˆæƒé¡¹ç›®\r\n',0),(246011,6834,'sv','Ta emot objekt pÃ¥ denna RMA',0),(246012,6834,'it','Ricevi gli articoli su questo RMA',0),(246013,6834,'tl','',0),(246014,6834,'th','&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3609; RMA &#3609;&#3637;&#3657;',0),(246015,6834,'hi','à¤‡à¤¸ RMA à¤ªà¤° à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(246016,6834,'ms','Menerima item pada RMA ini',0),(246017,6834,'ar','Ø¥Ø³ØªÙ„Ø§Ù… Ø£ØµÙ†Ø§Ù Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(246018,6834,'fr','Recevoir des articles sur ce RMA',0),(246019,6834,'jp','ã“ã® RMA ä¸Šã®ã‚¢ã‚¤ãƒ†ãƒ ãŒè¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(246020,6834,'pt','Receber artigos sobre esta RMA',0),(246021,6834,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð½Ð° ÑÑ‚Ð¾Ð¼ RMA',0),(246022,6834,'es','Recibir Items En Esta RMA',0),(246023,6834,'de','Artikel Ã¼ber diese RMA erhalten',0),(246024,6834,'en','Receive Items On This RMA',0),(246025,6835,'is','',0),(246026,6835,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(246027,6835,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(246028,6835,'tr','Sevk irsaliyesi numarasÄ±',0),(246029,6835,'pl','Identyfikator wysyÅ‚ki',0),(246030,6835,'bg','Ð˜Ð” Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(246031,6835,'ur','Ú©Ú¾ÛŒÙ¾ Ø´Ù†Ø§Ø®Øª',0),(246032,6835,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð˜Ð”',0),(246033,6835,'vi','ID chuyáº¿n hÃ ng',0),(246034,6835,'af','Besending ID',0),(246035,6835,'ro','ID de expediere',0),(246036,6835,'et','Saadetise ID',0),(246037,6835,'si','ID dobavnice',0),(246038,6835,'ba','Pengiriman ID',0),(246039,6835,'nl','Verzending ID',0),(246040,6835,'fi','LÃ¤hetyksen tunnus',0),(246041,6835,'no','Forsendelses-IDen',0),(246042,6835,'da','Forsendelse-ID',0),(246043,6835,'ko','ì„ ì  ID',0),(246044,6835,'he','×ž×–×”×” ×ž×©×œ×•×—',0),(246045,6835,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ID',0),(246046,6835,'zh','è£…è¿æ ‡è¯†\r\n',0),(246047,6835,'sv','FÃ¶rsÃ¤ndelse-ID',0),(246048,6835,'it','ID di spedizione',0),(246049,6835,'tl','',0),(246050,6835,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(246051,6835,'hi','à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ ID',0),(246052,6835,'ms','ID penghantaran',0),(246053,6835,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ø´Ø­Ù†Ø©',0),(246054,6835,'fr','ID de l\'expÃ©dition',0),(246055,6835,'jp','å‡ºè· ID',0),(246056,6835,'pt','ID de expediÃ§Ã£o',0),(246057,6835,'ru','ÐšÐžÐ” Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(246058,6835,'es','ID de EnvÃ­os',0),(246059,6835,'de','Versand-ID',0),(246060,6835,'en','Shipment ID',0),(246061,6836,'is','',0),(246062,6836,'dr','Ø°Ø®ÙŠØ±Ù‡  Ùˆ  ØªØ§ÙŠÙŠØ¯ ',0),(246063,6836,'pr','Ø°Ø®ÙŠØ±Ù‡  Ùˆ  ØªØ§ÙŠÙŠØ¯ ',0),(246064,6836,'tr','Kaydetmek ve onaylamak',0),(246065,6836,'pl','Zapisz i potwierdziÄ‡',0),(246066,6836,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð¸ Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´Ð¸',0),(246067,6836,'ur','Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº Ø§ÙˆØ± ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(246068,6836,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ',0),(246069,6836,'vi','Sao lÆ°u vÃ  xÃ¡c nháº­n',0),(246070,6836,'af','Stoor en Bevestig',0),(246071,6836,'ro','Salva ÅŸi de a confirma',0),(246072,6836,'et','Salvesta ja kinnita',0),(246073,6836,'si','Shranjevanje in potrditev',0),(246074,6836,'ba','Simpan dan mengkonfirmasi',0),(246075,6836,'nl','Opslaan en bevestigen',0),(246076,6836,'fi','Tallenna ja vahvistaa',0),(246077,6836,'no','Lagre og Bekreft',0),(246078,6836,'da','Gemme og bekrÃ¦fte',0),(246079,6836,'ko','ì €ìž¥ í•˜ ê³  í™•ì¸',0),(246080,6836,'he','×œ×©×ž×•×¨ ×•××©×¨',0),(246081,6836,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ ÎºÎ±Î¹ Î½Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎµÎ¹',0),(246082,6836,'zh','ä¿å­˜å¹¶ç¡®è®¤\r\n',0),(246083,6836,'sv','Spara och bekrÃ¤fta',0),(246084,6836,'it','Salvare e confermare',0),(246085,6836,'tl','',0),(246086,6836,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3649;&#3621;&#3632;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(246087,6836,'hi','à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤”à¤° à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(246088,6836,'ms','Simpan dan mengesahkan',0),(246089,6836,'ar','Ø§Ù„Ø­ÙØ¸ Ùˆ Ø§Ù„ØªØ£ÙƒÙŠØ¯',0),(246090,6836,'fr','Enregistrer et confirmer',0),(246091,6836,'jp','ä¿å­˜ã—ã€ç¢ºèª',0),(246092,6836,'pt','Salvar e confirmar',0),(246093,6836,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¸ ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ',0),(246094,6836,'es','Guardar y Confirmar',0),(246095,6836,'de','Speichern und bestÃ¤tigen',0),(246096,6836,'en','Save and Confirm',0),(246097,6837,'is','',0),(246098,6837,'dr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(246099,6837,'pr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(246100,6837,'tr','Bu sÄ±rada unconfirmed',0),(246101,6837,'pl','Ta kolejnoÅ›Ä‡ jest niepotwierdzone',0),(246102,6837,'bg','Ð¢Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ðµ Ð½ÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð°',0),(246103,6837,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Ùˆ ØºÛŒØ± Ù…ØµØ¯Ù‚Û ÛÛ’',0),(246104,6837,'sr','ÐžÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ð° Ñ˜Ðµ Ð½ÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð¸Ð¼',0),(246105,6837,'vi','ÄÆ¡n hÃ ng nÃ y chÆ°a xÃ¡c nháº­n',0),(246106,6837,'af','Hierdie Bestelling Is Onbevestig',0),(246107,6837,'ro','Aceasta ordine este neconfirmate',0),(246108,6837,'et','Tellimus on kinnitamata',0),(246109,6837,'si','Ta naloga je nepotrjenih',0),(246110,6837,'ba','Urutan ini belum dikonfirmasi',0),(246111,6837,'nl','Deze volgorde Is niet bevestigd',0),(246112,6837,'fi','TÃ¤mÃ¤ jÃ¤rjestys on vahvistamaton',0),(246113,6837,'no','Denne rekkefÃ¸lgen er ubekreftet',0),(246114,6837,'da','Denne rÃ¦kkefÃ¸lge er ubekrÃ¦ftede',0),(246115,6837,'ko','ì´ ìˆœì„œëŠ” í™•ì¸',0),(246116,6837,'he','×¡×“×¨ ×–×” ×”×•× ×œ× ×ž××•×©×¨',0),(246117,6837,'el','Î— ÏƒÎµÎ¹ÏÎ¬ Î±Ï…Ï„Î® ÎµÎ¯Î½Î±Î¹ Î±Î½ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰Ï„ÎµÏ‚',0),(246118,6837,'zh','æ­¤è®¢å•æœªç¡®è®¤\r\n',0),(246119,6837,'sv','Denna ordning Ã¤r obekrÃ¤ftade',0),(246120,6837,'it','Questo ordine Ã¨ confermato',0),(246121,6837,'tl','',0),(246122,6837,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3636;&#3657;&#3629;&#3609;&#3637;&#3657;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(246123,6837,'hi','à¤¯à¤¹ à¤•à¥à¤°à¤® à¤…à¤ªà¥à¤·à¥à¤Ÿ à¤¹à¥ˆ',0),(246124,6837,'ms','Perintah ini yang belum disahkan',0),(246125,6837,'ar','Ù‡Ø°Ù‡ Ø§Ù„Ø·Ù„Ø¨ÙŠØ© ØºÙŠØ± Ù…Ø¤ÙƒÙ‘Ø¯Ø©',0),(246126,6837,'fr','Cet ordre n\'est pas confirmÃ©',0),(246127,6837,'jp','ã“ã®é †åºã¯ç¢ºèªã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(246128,6837,'pt','Esta ordem Ã© confirmada',0),(246129,6837,'ru','Ð”Ð°Ð½Ð½Ñ‹Ð¹ Ð—Ð°ÐºÐ°Ð· ÐÐµ ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½',0),(246130,6837,'es','Este Orden No Es Confirmado',0),(246131,6837,'de','Diese Reihenfolge ist nicht bestÃ¤tigt',0),(246132,6837,'en','This Order Is Unconfirmed',0),(246133,6838,'is','',0),(246134,6838,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ§ÙƒØªÙˆØ± ',0),(246135,6838,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ§ÙƒØªÙˆØ± ',0),(246136,6838,'tr','Fatura Amt',0),(246137,6838,'pl','Amt faktury',0),(246138,6838,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Amt',0),(246139,6838,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ù…Ù¹',0),(246140,6838,'sr','Ð Ð•Ð¤ . Ð’Ð°Ð» Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ.',0),(246141,6838,'vi','Sá»‘ tiá»n HÃ³a Ä‘Æ¡n',0),(246142,6838,'af','Faktuur Amt',0),(246143,6838,'ro','AMT factura',0),(246144,6838,'et','Arve Amt',0),(246145,6838,'si','RaÄuna Amt',0),(246146,6838,'ba','Faktur Amt',0),(246147,6838,'nl','Factuur Amt',0),(246148,6838,'fi','Laskun Amt',0),(246149,6838,'no','Faktura Amt',0),(246150,6838,'da','Faktura Amt',0),(246151,6838,'ko','ì†¡ìž¥ Amt',0),(246152,6838,'he','×¡×›×•× ×—×©×‘×•× ×™×ª',0),(246153,6838,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³Î¿ÏÎ¼ÎµÎ½Î¿ Ï€Î¿ÏƒÏŒ',0),(246154,6838,'zh','å‘ç¥¨é‡‘é¢\r\n',0),(246155,6838,'sv','Faktura Amt',0),(246156,6838,'it','Fattura Amt',0),(246157,6838,'tl','',0),(246158,6838,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(246159,6838,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ Amt',0),(246160,6838,'ms','Amt invois',0),(246161,6838,'ar','Ù…Ø¨Ù„Øº Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(246162,6838,'fr','Amt facture',0),(246163,6838,'jp','è«‹æ±‚æ›¸ã® Amt',0),(246164,6838,'pt','Factura Amt',0),(246165,6838,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Amt',0),(246166,6838,'es','Monto de Factura',0),(246167,6838,'de','Rechnung-Amt',0),(246168,6838,'en','Invoice Amt',0),(246169,6839,'is','',0),(246170,6839,'dr','90 Ø±ÙˆØ²',0),(246171,6839,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² 90 Ø±ÙˆØ²',0),(246172,6839,'tr','90 gÃ¼n iÃ§inde',0),(246173,6839,'pl','Ponad 90 dni',0),(246174,6839,'bg','ÐÐ°Ð´ 90 Ð´Ð½Ð¸',0),(246175,6839,'ur','90 Ø¯Ù† Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(246176,6839,'sr','ÐŸÑ€ÐµÐºÐ¾ 90 Ð´Ð°Ð½Ð°',0),(246177,6839,'vi','QuÃ¡ 90 ngÃ y',0),(246178,6839,'af','Meer As 90 Dae',0),(246179,6839,'ro','Peste 90 de zile',0),(246180,6839,'et','Rohkem kui 90 pÃ¤eva',0),(246181,6839,'si','VeÄ kot 90 dni',0),(246182,6839,'ba','Lebih dari 90 hari',0),(246183,6839,'nl','Meer dan 90 dagen',0),(246184,6839,'fi','Yli 90 pÃ¤ivÃ¤Ã¤',0),(246185,6839,'no','Over 90 dager',0),(246186,6839,'da','Over 90 dage',0),(246187,6839,'ko','90 ì¼ ì´ìƒ',0),(246188,6839,'he','×ž×¢×œ 90 ×™×•×',0),(246189,6839,'el','Î Î¬Î½Ï‰ Î±Ï€ÏŒ 90 Î·Î¼Î­ÏÎµÏ‚',0),(246190,6839,'zh','è¶…è¿‡90å¤©\r\n',0),(246191,6839,'sv','Ã–ver 90 dagar',0),(246192,6839,'it','Oltre 90 giorni',0),(246193,6839,'tl','',0),(246194,6839,'th','&#3648;&#3585;&#3636;&#3609; 90 &#3623;&#3633;&#3609;',0),(246195,6839,'hi','90 à¤¦à¤¿à¤¨ à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(246196,6839,'ms','Lebih daripada 90 hari',0),(246197,6839,'ar','Ø£ÙƒØ«Ø± Ù…Ù† 90 ÙŠÙˆÙ…Ø§',0),(246198,6839,'fr','Plus de 90 jours',0),(246199,6839,'jp','90 æ—¥é–“',0),(246200,6839,'pt','Mais de 90 dias',0),(246201,6839,'ru','Ð‘Ð¾Ð»ÐµÐµ 90 Ð”Ð½ÐµÐ¹',0),(246202,6839,'es','MÃ¡s Que 90 DÃ­as',0),(246203,6839,'de','Mehr als 90 Tagen',0),(246204,6839,'en','Over 90 Days',0),(246205,6840,'is','',0),(246206,6840,'dr','(Ù…ÙØ§Ø¯) Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(246207,6840,'pr','Ø¨Ù‡Ø±Ù‡ (Ø³ÙˆØ¯) Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(246208,6840,'tr','Eklenen faiz',0),(246209,6840,'pl','Odsetki dodane',0),(246210,6840,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÐ½Ð°Ñ‚Ð° Ð»Ð¸Ñ…Ð²Ð°',0),(246211,6840,'ur','Ø³ÙˆØ¯ Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(246212,6840,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ð° Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð¾',0),(246213,6840,'vi','ThÃªm LÃ£i suáº¥t',0),(246214,6840,'af','Rente Bygevoeg',0),(246215,6840,'ro','Interesul adÄƒugat',0),(246216,6840,'et','Viivis lisatud',0),(246217,6840,'si','Dodane obresti',0),(246218,6840,'ba','Bunga yang ditambahkan',0),(246219,6840,'nl','Belang toegevoegd',0),(246220,6840,'fi','LisÃ¤tyn koron',0),(246221,6840,'no','Rente som legges',0),(246222,6840,'da','Interesse tilfÃ¸jet',0),(246223,6840,'ko','ì¶”ê°€ ê´€ì‹¬',0),(246224,6840,'he','×¢× ×™×™×Ÿ × ×•×¡×£',0),(246225,6840,'el','Î ÏÎ¿ÏƒÏ„Î¹Î¸Î­Î¼ÎµÎ½Î¿Ï‚ Ï„ÏŒÎºÎ¿Ï‚',0),(246226,6840,'zh','åˆ©æ¯å¢žåŠ \r\n',0),(246227,6840,'sv','Lades till',0),(246228,6840,'it','Interesse aggiunto',0),(246229,6840,'tl','',0),(246230,6840,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3604;&#3629;&#3585;&#3648;&#3610;&#3637;&#3657;&#3618;',0),(246231,6840,'hi','à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤¬à¥à¤¯à¤¾à¤œ',0),(246232,6840,'ms','Faedah yang ditambah',0),(246233,6840,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(246234,6840,'fr','IntÃ©rÃªt ajoutÃ©',0),(246235,6840,'jp','åˆ©å­ã‚’è¿½åŠ ',0),(246236,6840,'pt','Juros adicionados',0),(246237,6840,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(246238,6840,'es','InterÃ©ses Agregados',0),(246239,6840,'de','Interesse hinzugefÃ¼gt',0),(246240,6840,'en','Interest Added',0),(246241,6841,'is','',0),(246242,6841,'dr','Ù…Ø§Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(246243,6841,'pr','Ù…Ø§Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(246244,6841,'tr','Yeni bakiye',0),(246245,6841,'pl','New Balance',0),(246246,6841,'bg','ÐÐ¾Ð² Ð±Ð°Ð»Ð°Ð½Ñ',0),(246247,6841,'ur','Ù†ÛŒØ§ ØªÙˆØ§Ø²Ù†',0),(246248,6841,'sr','ÐÐ¾Ð²Ð¸ Ð±Ð°Ð»Ð°Ð½Ñ',0),(246249,6841,'vi','DÆ° ná»£ má»›i',0),(246250,6841,'af','Nuwe Balans',0),(246251,6841,'ro','Nou echilibru',0),(246252,6841,'et','Uus tasakaal',0),(246253,6841,'si','Novo stanje',0),(246254,6841,'ba','New Balance',0),(246255,6841,'nl','Nieuw evenwicht',0),(246256,6841,'fi','New Balance',0),(246257,6841,'no','Ny saldo',0),(246258,6841,'da','New Balance',0),(246259,6841,'ko','ìƒˆë¡œìš´ ê· í˜•',0),(246260,6841,'he','×ž××–×Ÿ ×—×“×©',0),(246261,6841,'el','ÎÎ­Î± Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±',0),(246262,6841,'zh','æ–°çš„ç»“ä½™\r\n',0),(246263,6841,'sv','Ny balans',0),(246264,6841,'it','Nuovo equilibrio',0),(246265,6841,'tl','',0),(246266,6841,'th','&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(246267,6841,'hi','à¤¨à¤ˆ à¤¶à¥‡à¤·',0),(246268,6841,'ms','Baki baru',0),(246269,6841,'ar','Ø±ØµÙŠØ¯ Ø¬Ø¯ÙŠØ¯',0),(246270,6841,'fr','New Balance',0),(246271,6841,'jp','ãƒ‹ãƒ¥ãƒ¼ ãƒãƒ©ãƒ³ã‚¹',0),(246272,6841,'pt','New Balance',0),(246273,6841,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð‘Ð°Ð»Ð°Ð½Ñ',0),(246274,6841,'es','Nuevo Balance',0),(246275,6841,'de','New Balance',0),(246276,6841,'en','New Balance',0),(246277,6842,'is','',0),(246278,6842,'dr','Ù…Ø§Ù†Ø¯Ù‡ Ø§ÙˆÙ„ÙŠÙ‡',0),(246279,6842,'pr','Ù…Ø§Ù†Ø¯Ù‡ Ø§ÙˆÙ„ÙŠÙ‡',0),(246280,6842,'tr','Ã–nceki bakiye',0),(246281,6842,'pl','WczeÅ›niejsze rÃ³wnowagi',0),(246282,6842,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð±Ð°Ð»Ð°Ð½Ñ',0),(246283,6842,'ur','Ù¾ÛŒØ´Ú¯ÛŒ ØªÙˆØ§Ø²Ù†',0),(246284,6842,'sr','Ð˜Ð³ÑƒÐ¼Ð°Ð½ ÑÐ°Ð»Ð´Ð¾',0),(246285,6842,'vi','Sá»‘ dÆ° trÆ°á»›c',0),(246286,6842,'af','Vorige Balans',0),(246287,6842,'ro','Echilibru prealabilÄƒ',0),(246288,6842,'et','Eelneva tasakaal',0),(246289,6842,'si','Predhodna bilanca',0),(246290,6842,'ba','Sebelumnya keseimbangan',0),(246291,6842,'nl','Voorafgaande evenwicht',0),(246292,6842,'fi','Ennen tasapaino',0),(246293,6842,'no','Tidligere balanse',0),(246294,6842,'da','ForudgÃ¥ende Balance',0),(246295,6842,'ko','ì´ì „ ìž”ì•¡',0),(246296,6842,'he','×ž××–×Ÿ ×§×•×“×',0),(246297,6842,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±',0),(246298,6842,'zh','å…ˆå‰ä½™é¢\r\n',0),(246299,6842,'sv','Tidigare balans',0),(246300,6842,'it','Saldo precedente',0),(246301,6842,'tl','',0),(246302,6842,'th','&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3617;&#3634;&#3585;&#3656;&#3629;&#3609;',0),(246303,6842,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤¸à¤‚à¤¤à¥à¤²à¤¨',0),(246304,6842,'ms','Kira-kira terlebih dahulu',0),(246305,6842,'ar','Ø±ØµÙŠØ¯ Ù…Ø³Ø¨Ù‚',0),(246306,6842,'fr','Solde antÃ©rieur',0),(246307,6842,'jp','äº‹å‰ã®ãƒãƒ©ãƒ³ã‚¹',0),(246308,6842,'pt','Saldo anterior',0),(246309,6842,'ru','Ð Ð°Ð½ÐµÐµ Ð±Ð°Ð»Ð°Ð½Ñ',0),(246310,6842,'es','Balance Anterior',0),(246311,6842,'de','Vorherige Balance',0),(246312,6842,'en','Prior Balance',0),(246313,6843,'is','',0),(246314,6843,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙƒÙ…ÙŠØ³ÙˆÙ† Ù…Ø³Ø¦ÙˆÙ„ Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ  ',0),(246315,6843,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙƒÙ…ÙŠØ³ÙˆÙ† Ù…Ø³Ø¦ÙˆÙ„ Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯ÙŠ  ',0),(246316,6843,'tr','Ajan ajans Komisyonu raporu',0),(246317,6843,'pl','Agent agencji sprawozdanie Komisji',0),(246318,6843,'bg','ÐÐ³ÐµÐ½Ñ‚ ÐÐ³ÐµÐ½Ñ†Ð¸ÑÑ‚Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð´Ð¾ÐºÐ»Ð°Ð´',0),(246319,6843,'ur','Ø§ÛŒØ¬Ù†Ù¹ Ø§ÛŒØ¬Ù†Ø³ÛŒ Ú©ÛŒ Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(246320,6843,'sr','ÐÐ³ÐµÐ½Ñ‚ Ð°Ð³ÐµÐ½Ñ†Ð¸Ñ˜Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ðµ',0),(246321,6843,'vi','BÃ¡o CÃ¡o Hoa Há»“ng Äáº¡i LÃ½ Cá»§a Äáº¡i LÃ½',0),(246322,6843,'af','Agent Agentskap Kommissie Verslag',0),(246323,6843,'ro','Raport al Comisiei agent AgenÅ£iei',0),(246324,6843,'et','Esindaja amet komisjoni aruanne',0),(246325,6843,'si','PoroÄilo Komisije agencija agent',0),(246326,6843,'ba','Laporan Komisi agen agen',0),(246327,6843,'nl','Verslag van de Commissie van de agent Agentschap',0),(246328,6843,'fi','Agentti virasto komission kertomus',0),(246329,6843,'no','Agent Agency Kommisjonens rapport',0),(246330,6843,'da','Agent agenturet kommissionsrapport',0),(246331,6843,'ko','ì—ì´ì „íŠ¸ ê¸°ê´€ ìœ„ì›íšŒ ë³´ê³ ì„œ',0),(246332,6843,'he','×“×• ×— ×•×¢×“×ª ×¡×•×›×Ÿ ×”×¡×•×›× ×•×ª',0),(246333,6843,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î·Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®Ï‚ Ï„Î¿Ï… Ï€ÏÎ¬ÎºÏ„Î¿ÏÎ± Î¿ÏÎ³Î±Î½Î¹ÏƒÎ¼ÏŒÏ‚',0),(246334,6843,'zh','è¡ŒéŠ·æœºæž„ä½£é‡‘çš„å ±å‘Š\r\n',0),(246335,6843,'sv','Agent Agency kommissionens rapport',0),(246336,6843,'it','Relazione della Commissione agente agenzia',0),(246337,6843,'tl','',0),(246338,6843,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;&#3586;&#3629;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(246339,6843,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ à¤à¤œà¥‡à¤‚à¤¸à¥€ à¤•à¤®à¥€à¤¶à¤¨ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(246340,6843,'ms','Laporan Suruhanjaya ejen agensi',0),(246341,6843,'ar','ØªÙ‚Ø±ÙŠØ± Ù„Ø¬Ù†Ø© ÙˆÙƒØ§Ù„Ø© Ø§Ù„ÙˆÙƒÙŠÙ„',0),(246342,6843,'fr','Rapport de la Commission dâ€™Agence agent',0),(246343,6843,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆæ©Ÿé–¢å§”å“¡ä¼šå ±å‘Šæ›¸',0),(246344,6843,'pt','RelatÃ³rio de ComissÃ£o de agente AgÃªncia',0),(246345,6843,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ð°Ð³ÐµÐ½Ñ‚Ð° Ð°Ð³ÐµÐ½Ñ‚ÑÑ‚Ð²Ð°',0),(246346,6843,'es','Informe de Agencia de la ComisiÃ³n del Agente',0),(246347,6843,'de','Bericht der Kommission Agent Agentur',0),(246348,6843,'en','Agent Agency Commission Report',0),(246349,6844,'is','',0),(246350,6844,'dr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ø¬Ù…Ø¹ Ú©Ù„',0),(246351,6844,'pr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ø¬Ù…Ø¹ Ú©Ù„',0),(246352,6844,'tr','Tam toplam',0),(246353,6844,'pl','PeÅ‚na suma',0),(246354,6844,'bg','ÐŸÑŠÐ»Ð½Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(246355,6844,'ur','Ú©Ù„ Ù…Ú©Ù…Ù„',0),(246356,6844,'sr','ÐšÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð° ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(246357,6844,'vi','Tá»•ng sá»‘ hoÃ n thÃ nh',0),(246358,6844,'af','Voltooide Totaal',0),(246359,6844,'ro','Complet Total',0),(246360,6844,'et','TÃ¤ielik kokku',0),(246361,6844,'si','Popolna skupaj',0),(246362,6844,'ba','Total lengkap',0),(246363,6844,'nl','Volledige totaal',0),(246364,6844,'fi','Totaalista',0),(246365,6844,'no','Komplett totalt',0),(246366,6844,'da','Komplet alt',0),(246367,6844,'ko','ì™„ì „ í•œ ì´',0),(246368,6844,'he','×œ×”×©×œ×™× ××ª ×¡×š',0),(246369,6844,'el','Î Î»Î®ÏÎµÏ‚ ÏƒÏÎ½Î¿Î»Î¿',0),(246370,6844,'zh','å®Œæˆæ€»é¢\r\n',0),(246371,6844,'sv','Komplett totalt',0),(246372,6844,'it','Totale completa',0),(246373,6844,'tl','',0),(246374,6844,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(246375,6844,'hi','à¤•à¥à¤² à¤ªà¥‚à¤°à¥à¤£ à¤•à¤°à¥‡à¤‚',0),(246376,6844,'ms','Melengkapkan jumlah',0),(246377,6844,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© ÙƒØ§Ù…Ù„Ø©',0),(246378,6844,'fr','Total complet',0),(246379,6844,'jp','å…¨ä½“ã®åˆè¨ˆ',0),(246380,6844,'pt','Total completa',0),(246381,6844,'ru','ÐŸÐ¾Ð»Ð½Ñ‹Ð¹ Ð²ÑÐµÐ³Ð¾',0),(246382,6844,'es','Completar Total',0),(246383,6844,'de','Komplette Total',0),(246384,6844,'en','Complete Total',0),(246385,6845,'is','',0),(246386,6845,'dr','ÙƒÙ„ Ø¨Ø§Ø²',0),(246387,6845,'pr','ÙƒÙ„ Ø¨Ø§Ø²',0),(246388,6845,'tr','AÃ§Ä±k toplam',0),(246389,6845,'pl','OtwÃ³rz Å‚Ä…cznie',0),(246390,6845,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾ Ð¾Ð±Ñ‰Ð¾',0),(246391,6845,'ur','Ú©Ú¾Ù„ÛŒ Ú©Ù„',0),(246392,6845,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(246393,6845,'vi','Má»Ÿ tÃ´ng sá»‘',0),(246394,6845,'af','Openingstotaal',0),(246395,6845,'ro','Deschis Total',0),(246396,6845,'et','Avatud kokku',0),(246397,6845,'si','Open skupno',0),(246398,6845,'ba','Total terbuka',0),(246399,6845,'nl','Open totaal',0),(246400,6845,'fi','Avoinna yhteensÃ¤',0),(246401,6845,'no','Ã…pne totalt',0),(246402,6845,'da','Open Total',0),(246403,6845,'ko','ì—´ê¸° ì´',0),(246404,6845,'he','×¡×š ×”×›×œ ×¤×ª×•×—',0),(246405,6845,'el','Î‘Î½Î¿Î¹Ï‡Ï„ÏŒ ÏƒÏÎ½Î¿Î»Î¿',0),(246406,6845,'zh','æ‰“å¼€æ€»è®¡\r\n',0),(246407,6845,'sv','Ã–ppna totalt',0),(246408,6845,'it','Totale aperta',0),(246409,6845,'tl','',0),(246410,6845,'th','&#3648;&#3611;&#3636;&#3604;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(246411,6845,'hi','à¤–à¥à¤²à¤¾ à¤•à¥à¤²',0),(246412,6845,'ms','Jumlah terbuka',0),(246413,6845,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ù…ÙØªÙˆØ­Ø©',0),(246414,6845,'fr','Total ouvert',0),(246415,6845,'jp','é–‹ã„ã¦ã„ã‚‹åˆè¨ˆ',0),(246416,6845,'pt','Total aberto',0),(246417,6845,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ð¹ Ð²ÑÐµÐ³Ð¾',0),(246418,6845,'es','Total Abierto',0),(246419,6845,'de','Offene gesamt',0),(246420,6845,'en','Open Total',0),(246421,6846,'is','',0),(246422,6846,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(246423,6846,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(246424,6846,'tr','Zaten kullanÄ±mda',0),(246425,6846,'pl','JuÅ¼ w uÅ¼yciu',0),(246426,6846,'bg','Ð’ÐµÑ‡Ðµ Ð² ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(246427,6846,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù…ÛŒÚº',0),(246428,6846,'sr','Ð’ÐµÑ› Ñƒ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸',0),(246429,6846,'vi','ÄÃ£ Ä‘Æ°a vÃ o sá»­ dá»¥ng',0),(246430,6846,'af','Alreeds in Gebruik',0),(246431,6846,'ro','Deja Ã®n uz',0),(246432,6846,'et','Juba kasutusel',0),(246433,6846,'si','Å½e v uporabi',0),(246434,6846,'ba','Sudah di gunakan',0),(246435,6846,'nl','Reeds in gebruik',0),(246436,6846,'fi','KÃ¤ytÃ¶ssÃ¤',0),(246437,6846,'no','Allerede i bruk',0),(246438,6846,'da','Allerede i brug',0),(246439,6846,'ko','ì´ë¯¸ ì‚¬ìš© ì¤‘ì¸',0),(246440,6846,'he','×›×‘×¨ ×‘×©×™×ž×•×©',0),(246441,6846,'el','Î‰Î´Î· ÏƒÎµ Ï‡ÏÎ®ÏƒÎ·',0),(246442,6846,'zh','å·²åœ¨ä½¿ç”¨\r\n',0),(246443,6846,'sv','Redan i bruk',0),(246444,6846,'it','GiÃ  in uso',0),(246445,6846,'tl','',0),(246446,6846,'th','&#3614;&#3619;&#3657;&#3629;&#3617;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(246447,6846,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‰à¤ªà¤¯à¥‹à¤— à¤®à¥‡à¤‚',0),(246448,6846,'ms','Sudah ada dalam penggunaan',0),(246449,6846,'ar','Ù‚ÙŠØ¯ Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¨Ø§Ù„ÙØ¹Ù„',0),(246450,6846,'fr','DÃ©jÃ  en cours d\'utilisation',0),(246451,6846,'jp','æ—¢ã«ä½¿ç”¨ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(246452,6846,'pt','JÃ¡ em uso',0),(246453,6846,'ru','Ð£Ð¶Ðµ Ð² ÑÐºÑÐ¿Ð»ÑƒÐ°Ñ‚Ð°Ñ†Ð¸Ð¸',0),(246454,6846,'es','Ya en Uso',0),(246455,6846,'de','Bereits im Einsatz',0),(246456,6846,'en','Already in Use',0),(246457,6847,'is','',0),(246458,6847,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¨Ø±Ø§ÙŠ ÙƒØ¯ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯',0),(246459,6847,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¨Ø±Ø§ÙŠ ÙƒØ¯ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯',0),(246460,6847,'tr','Varolan madde kodunu kontrol',0),(246461,6847,'pl','Weryfikacja pod kÄ…tem istniejÄ…cy kod towaru',0),(246462,6847,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰ ÐºÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(246463,6847,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø´Û’ Ø¶Ø§Ø¨Ø·Û Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(246464,6847,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ñƒ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(246465,6847,'vi','Kiá»ƒm tra mÃ£ hÃ ng hiá»‡n táº¡i',0),(246466,6847,'af','Nagaan vir Bestaande Itemkode',0),(246467,6847,'ro','Verificarea pentru existente cod articol',0),(246468,6847,'et','Kontrollin olemasoleva kirje kood',0),(246469,6847,'si','Preverjanje za obstojeÄo kodo artikla',0),(246470,6847,'ba','Memeriksa kode Item yang ada',0),(246471,6847,'nl','Controleren op bestaande Artikelcode',0),(246472,6847,'fi','Tarkistaa nykyisen nimikkeen koodi',0),(246473,6847,'no','SÃ¸ker etter eksisterende Varekode',0),(246474,6847,'da','Kontrol for eksisterende varekode',0),(246475,6847,'ko','ê¸°ì¡´ í•­ëª© ì½”ë“œ í™•ì¸',0),(246476,6847,'he','×‘×“×™×§×ª ×§×•×“ ×¤×¨×™×˜ ×§×™×™×',0),(246477,6847,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ Î³Î¹Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± ÎºÏŽÎ´Î¹ÎºÎ± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(246478,6847,'zh','æ£€æŸ¥çŽ°æœ‰é¡¹ç›®ä»£ç \r\n',0),(246479,6847,'sv','Kontroll av befintliga Artikelkod',0),(246480,6847,'it','Verifica codice esistente',0),(246481,6847,'tl','',0),(246482,6847,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(246483,6847,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š',0),(246484,6847,'ms','Menyemak kod barang sedia ada',0),(246485,6847,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø© ÙÙŠ Ø§Ù„Ø¨Ù†Ø¯',0),(246486,6847,'fr','Recherche de Code d\'Ã©lÃ©ment existant',0),(246487,6847,'jp','æ—¢å­˜ã®ã‚¢ã‚¤ãƒ†ãƒ ã®ã‚³ãƒ¼ãƒ‰ã®ãƒã‚§ãƒƒã‚¯',0),(246488,6847,'pt','VerificaÃ§Ã£o de cÃ³digo de Item existente',0),(246489,6847,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð´Ð»Ñ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÐµÐ³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÐºÐ¾Ð´Ð°',0),(246490,6847,'es','Cheqando para CÃ³digo de Item Existente',0),(246491,6847,'de','ÃœberprÃ¼fung auf vorhandene Artikelcode',0),(246492,6847,'en','Checking for Existing Item Code',0),(246493,6848,'is','',0),(246494,6848,'dr','Ù‚Ø¨ÙˆÙ„ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(246495,6848,'pr','Ù‚Ø¨ÙˆÙ„ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(246496,6848,'tr','Madde kodu kullanmak iÃ§in OK',0),(246497,6848,'pl','OK, aby uÅ¼ywaÄ‡ kod towaru',0),(246498,6848,'bg','ÐžÐš, Ð·Ð° Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ ÐºÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(246499,6848,'ur','Ù¹Ú¾ÛŒÚ© ÛÛ’ Ø´Û’ Ú©ÙˆÚˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(246500,6848,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(246501,6848,'vi','OK Ä‘á»ƒ sá»­ dá»¥ng mÃ£ hÃ ng nÃ y',0),(246502,6848,'af','OK om Itemkode te Gebruik',0),(246503,6848,'ro','OK pentru a folosi cod articol',0),(246504,6848,'et','OK, et kasutada kauba kood',0),(246505,6848,'si','OK rabiti Å ifra artikla',0),(246506,6848,'ba','OK untuk menggunakan kode barang',0),(246507,6848,'nl','Klik op OK om object Code gebruiken',0),(246508,6848,'fi','Sopii kÃ¤ytettÃ¤vÃ¤ nimikkeen koodi',0),(246509,6848,'no','OK Ã¥ bruke varekoden',0),(246510,6848,'da','OK at bruge varekode',0),(246511,6848,'ko','í•­ëª© ì½”ë“œë¥¼ ì‚¬ìš© í•˜ ì—¬ í™•ì¸',0),(246512,6848,'he','×‘×¨×¦×•× ×š ×œ×”×©×ª×ž×© ×§×•×“ ×¤×¨×™×˜',0),(246513,6848,'el','Î•Î½Ï„Î¬Î¾ÎµÎ¹ Î³Î¹Î± Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚',0),(246514,6848,'zh','ç¡®å®šä½¿ç”¨é¡¹ç›®ä»£ç \r\n',0),(246515,6848,'sv','OK att anvÃ¤nda Artikelkod',0),(246516,6848,'it','OK per utilizzare il codice articolo',0),(246517,6848,'tl','',0),(246518,6848,'th','&#3605;&#3585;&#3621;&#3591;&#3651;&#3627;&#3657;&#3651;&#3594;&#3657;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3627;&#3633;&#3626;',0),(246519,6848,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ à¥€à¤• à¤¹à¥ˆ',0),(246520,6848,'ms','OK untuk menggunakan kod Item',0),(246521,6848,'ar','Ù…ÙˆØ§ÙÙ‚ Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù',0),(246522,6848,'fr','OK pour utiliser le Code article',0),(246523,6848,'jp','é …ç›®ã‚³ãƒ¼ãƒ‰ã‚’ä½¿ç”¨ã—ã¦ [ok] ã‚’',0),(246524,6848,'pt','OK para usar o cÃ³digo do Item',0),(246525,6848,'ru','OK, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(246526,6848,'es','OK para Usar CÃ³digo de Item',0),(246527,6848,'de','OK zum Item-Code verwenden',0),(246528,6848,'en','OK to Use Item Code',0),(246529,6849,'is','',0),(246530,6849,'dr','Ú†Ùƒ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ ',0),(246531,6849,'pr','Ú†Ùƒ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ ',0),(246532,6849,'tr','GeÃ§ersiz Ã§ek',0),(246533,6849,'pl','Czek uniewaÅ¼niony',0),(246534,6849,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ð¸Ñ Ñ‡ÐµÐº',0),(246535,6849,'ur','ÙˆÙˆØ§ÚˆÛŒØ¯ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(246536,6849,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½Ð¸ Ñ‡ÐµÐº',0),(246537,6849,'vi','XÃ³a SÃ©c',0),(246538,6849,'af','Ontlaste kontroleer',0),(246539,6849,'ro','CEC anulat',0),(246540,6849,'et','Annulleeri kviitung',0),(246541,6849,'si','Razveljavljeni Äek',0),(246542,6849,'ba','Voided Check',0),(246543,6849,'nl','Vernietigde Check',0),(246544,6849,'fi','MitÃ¤tÃ¶idyn sekin',0),(246545,6849,'no','Kansellert sjekk',0),(246546,6849,'da','Annullerede Check',0),(246547,6849,'ko','ë¬´íš¨í™” ì²´í¬',0),(246548,6849,'he','×”×¡×™×ž×•×Ÿ ×©×ª×•×§×¤×Ÿ ×‘×•×˜×œ',0),(246549,6849,'el','Î‘ÎºÏ…ÏÏ‰Î¼Î­Î½Î·Ï‚ ÎµÏ€Î¹Ï„Î±Î³Î®Ï‚',0),(246550,6849,'zh','æ— æ•ˆæ£€æŸ¥\r\n',0),(246551,6849,'sv','Annullerade checken',0),(246552,6849,'it','Escreta Check',0),(246553,6849,'tl','',0),(246554,6849,'th','&#3648;&#3594;&#3655;&#3588;&#3606;&#3641;&#3585;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(246555,6849,'hi','Voided à¤šà¥‡à¤•',0),(246556,6849,'ms','Semak voided',0),(246557,6849,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù…Ù„ØºØ§Ø©',0),(246558,6849,'fr','ChÃ¨que annulÃ©',0),(246559,6849,'jp','ç„¡åŠ¹ã«ã•ã‚ŒãŸãƒã‚§ãƒƒã‚¯',0),(246560,6849,'pt','SeleÃ§Ã£o anulada',0),(246561,6849,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(246562,6849,'es','Cheque Anulado',0),(246563,6849,'de','Storniertes Check',0),(246564,6849,'en','Voided Check',0),(246565,6850,'is','',0),(246566,6850,'dr','(Ù…Ù‚Ø¯Ø§Ø±) Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(246567,6850,'pr','Ø´Ù…Ø§Ø±Ø´(Ù…Ù‚Ø¯Ø§Ø±) Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(246568,6850,'tr','SilinmiÅŸ sayar',0),(246569,6850,'pl','Liczy usuniÄ™te',0),(246570,6850,'bg','Ð‘Ñ€Ð¾Ð¹ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸',0),(246571,6850,'ur','Ø­Ø°Ù Ø´Ø¯Û Ø´Ù…Ø§Ø±',0),(246572,6850,'sr','Ð‘Ñ€Ð¾Ñ˜Ð¸ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(246573,6850,'vi','XÃ³a Ä‘áº¿m',0),(246574,6850,'af','Tellings Geskrap',0),(246575,6850,'ro','ConteazÄƒ ÅŸters',0),(246576,6850,'et','Loeb kustutatud',0),(246577,6850,'si','Å teje Ärta',0),(246578,6850,'ba','Hitungan dihapus',0),(246579,6850,'nl','Graven verwijderd',0),(246580,6850,'fi','Laskee poistettu',0),(246581,6850,'no','Teller slettet',0),(246582,6850,'da','TÃ¦ller slettet',0),(246583,6850,'ko','ê³„ì‚° ì‚­ì œ',0),(246584,6850,'he','×¢×‘×™×¨×•×ª ×©× ×ž×—×§×•',0),(246585,6850,'el','ÎœÎµÏ„ÏÎ¬ÎµÎ¹ Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯',0),(246586,6850,'zh','è®¡æ•°åˆ é™¤\r\n',0),(246587,6850,'sv','RÃ¤knas bort',0),(246588,6850,'it','Conteggi eliminati',0),(246589,6850,'tl','',0),(246590,6850,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3609;&#3633;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(246591,6850,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤•à¤¾à¤‰à¤‚à¤Ÿà¥à¤¸',0),(246592,6850,'ms','Tuduhan yang dihapuskan',0),(246593,6850,'ar','Ø­Ø°Ù Ø­Ø³Ø§Ø¨',0),(246594,6850,'fr','Compte supprimÃ©',0),(246595,6850,'jp','å‰Šé™¤å›žæ•°',0),(246596,6850,'pt','Contagens eliminadas',0),(246597,6850,'ru','Ð¡Ñ‡ÐµÑ‚Ñ‡Ð¸ÐºÐ¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(246598,6850,'es','Conteos Eliminados',0),(246599,6850,'de','Grafen gelÃ¶scht',0),(246600,6850,'en','Counts Deleted',0),(246601,6851,'is','',0),(246602,6851,'dr','Ù…Ø¨Ù„Øº ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(246603,6851,'pr','Ù…Ø¨Ù„Øº ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(246604,6851,'tr','Komisyon tutarÄ±',0),(246605,6851,'pl','Komisji kwoty',0),(246606,6851,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° ÑÑƒÐ¼Ð°',0),(246607,6851,'ur','Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ø±Ù‚Ù…',0),(246608,6851,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(246609,6851,'vi','Sá»‘ tiá»n hoa há»“ng',0),(246610,6851,'af','Kommissie Bedrag',0),(246611,6851,'ro','Comisiei suma',0),(246612,6851,'et','Komisjonitasu summa',0),(246613,6851,'si','Komisija znesek',0),(246614,6851,'ba','Jumlah komisi',0),(246615,6851,'nl','Commissie bedrag',0),(246616,6851,'fi','Provision mÃ¤Ã¤rÃ¤',0),(246617,6851,'no','ProvisjonsbelÃ¸pet',0),(246618,6851,'da','ProvisionsbelÃ¸bet',0),(246619,6851,'ko','ìˆ˜ìˆ˜ë£Œ ê¸ˆì•¡',0),(246620,6851,'he','×¡×›×•× ×”×¢×ž×œ×•×ª',0),(246621,6851,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Ï€Î¿ÏƒÏŒ',0),(246622,6851,'zh','ä½£é‡‘æ•°é¢\r\n',0),(246623,6851,'sv','Kommissionen belopp',0),(246624,6851,'it','Importo della Commissione',0),(246625,6851,'tl','',0),(246626,6851,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(246627,6851,'hi','à¤•à¤®à¥€à¤¶à¤¨ à¤°à¤¾à¤¶à¤¿',0),(246628,6851,'ms','Jumlah komisen',0),(246629,6851,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¹Ù…ÙˆÙ„Ø©',0),(246630,6851,'fr','Montant de la Commission',0),(246631,6851,'jp','ã‚³ãƒŸãƒƒã‚·ãƒ§ãƒ³é‡‘é¡',0),(246632,6851,'pt','Quantidade de ComissÃ£o',0),(246633,6851,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(246634,6851,'es','Monto de ComisiÃ³n',0),(246635,6851,'de','Provisionsbetrag',0),(246636,6851,'en','Commission Amount',0),(246637,6852,'is','',0),(246638,6852,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(246639,6852,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(246640,6852,'tr','Komisyon raporu',0),(246641,6852,'pl','Sprawozdanie Komisji',0),(246642,6852,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(246643,6852,'ur','Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(246644,6852,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ðµ',0),(246645,6852,'vi','BÃ¡o cÃ¡o hoa há»“ng',0),(246646,6852,'af','Kommissie Verslag',0),(246647,6852,'ro','Raportul Comisiei',0),(246648,6852,'et','Komisjoni aruanne',0),(246649,6852,'si','PoroÄilo Komisije',0),(246650,6852,'ba','Laporan Komisi',0),(246651,6852,'nl','Verslag van de Commissie',0),(246652,6852,'fi','Komission kertomus',0),(246653,6852,'no','Kommisjonens rapport',0),(246654,6852,'da','Rapport fra Kommissionen',0),(246655,6852,'ko','ìœ„ì›íšŒ ë³´ê³ ì„œ',0),(246656,6852,'he','×“×• ×— ×•×¢×“×ª',0),(246657,6852,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î·Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®Ï‚',0),(246658,6852,'zh','å§”å‘˜ä¼šçš„æŠ¥å‘Š\r\n',0),(246659,6852,'sv','Rapport frÃ¥n kommissionen',0),(246660,6852,'it','Relazione della Commissione',0),(246661,6852,'tl','',0),(246662,6852,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(246663,6852,'hi','à¤†à¤¯à¥‹à¤— à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(246664,6852,'ms','Laporan Suruhanjaya',0),(246665,6852,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù„Ø¬Ù†Ø©',0),(246666,6852,'fr','Rapport de la Commission',0),(246667,6852,'jp','å§”å“¡ä¼šå ±å‘Šæ›¸',0),(246668,6852,'pt','RelatÃ³rio da ComissÃ£o',0),(246669,6852,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ ÐšÐ¾Ð¼Ð¼Ð¸ÑÑÐ¸Ð¸',0),(246670,6852,'es','ComisiÃ³n Informe',0),(246671,6852,'de','Bericht der Kommission',0),(246672,6852,'en','Commission Report',0),(246673,6853,'is','',0),(246674,6853,'dr','ÙƒØ¯ Ù¾Ø³ØªÙŠ ØªØ­ÙˆÙŠÙ„ ',0),(246675,6853,'pr','ÙƒØ¯ Ù¾Ø³ØªÙŠ ØªØ­ÙˆÙŠÙ„ ',0),(246676,6853,'tr','Teslimat ZIP',0),(246677,6853,'pl','Dostawy Zip',0),(246678,6853,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Zip',0),(246679,6853,'ur','Ø­ÙˆØ§Ù„Ú¯ÛŒ Ø²Ù¾',0),(246680,6853,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð° Ð—Ð¸Ð¿',0),(246681,6853,'vi','MÃ£ Zip giao hÃ ng',0),(246682,6853,'af','Afleweringsposkode',0),(246683,6853,'ro','Livrare Zip',0),(246684,6853,'et','Kohaletoimetamise Zip',0),(246685,6853,'si','Dostava Zip',0),(246686,6853,'ba','Zip pengiriman',0),(246687,6853,'nl','Levering Zip',0),(246688,6853,'fi','Toimitus Zip',0),(246689,6853,'no','Levering Zip',0),(246690,6853,'da','Leveringen Zip',0),(246691,6853,'ko','ë°°ë‹¬ ìš°íŽ¸',0),(246692,6853,'he','Zip ×ž×©×œ×•×—',0),(246693,6853,'el','Î Î±ÏÎ¬Î´Î¿ÏƒÎ· Zip',0),(246694,6853,'zh','äº¤è´§é‚®ç¼–\r\n',0),(246695,6853,'sv','Leverans Zip',0),(246696,6853,'it','Codice postale spedizione',0),(246697,6853,'tl','',0),(246698,6853,'th','&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;\n',0),(246699,6853,'hi','à¤µà¤¿à¤¤à¤°à¤£ à¤œà¤¼à¤¿à¤ª',0),(246700,6853,'ms','Penghantaran pos',0),(246701,6853,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(246702,6853,'fr','Livraison Zip',0),(246703,6853,'jp','éƒµä¾¿é…é”',0),(246704,6853,'pt','Entrega Zip',0),(246705,6853,'ru','Ð˜Ð½Ð´ÐµÐºÑ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(246706,6853,'es','CÃ³digo Postal de Entrega',0),(246707,6853,'de','Lieferung Zip',0),(246708,6853,'en','Delivery Zip',0),(246709,6854,'is','',0),(246710,6854,'dr','Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ ',0),(246711,6854,'pr','Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ ',0),(246712,6854,'tr','DÃ¶nem iÃ§in',0),(246713,6854,'pl','W okresie',0),(246714,6854,'bg','Ð—Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(246715,6854,'ur','Ø¹Ø±ØµÛ',0),(246716,6854,'sr','Ð—Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(246717,6854,'vi','Tá»« thá»i ká»³',0),(246718,6854,'af','Vir die Periode',0),(246719,6854,'ro','Pentru perioada',0),(246720,6854,'et','Perioodi',0),(246721,6854,'si','Za obdobje',0),(246722,6854,'ba','Untuk periode',0),(246723,6854,'nl','Voor de periode',0),(246724,6854,'fi','Kauden',0),(246725,6854,'no','For perioden',0),(246726,6854,'da','For perioden',0),(246727,6854,'ko','ê¸°ê°„ì— ëŒ€ í•œ',0),(246728,6854,'he','×¢×‘×•×¨ ×”×ª×§×•×¤×”',0),(246729,6854,'el','Î“Î¹Î± Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(246730,6854,'zh','æœŸå†…\r\n',0),(246731,6854,'sv','FÃ¶r perioden',0),(246732,6854,'it','Per il periodo',0),(246733,6854,'tl','',0),(246734,6854,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(246735,6854,'hi','à¤•à¥€ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤',0),(246736,6854,'ms','Bagi tempoh',0),(246737,6854,'ar','Ù„Ù„ÙØªØ±Ø©',0),(246738,6854,'fr','Pour la pÃ©riode',0),(246739,6854,'jp','æœŸé–“',0),(246740,6854,'pt','Para o perÃ­odo',0),(246741,6854,'ru','Ð”Ð»Ñ ÐŸÐµÑ€Ð¸Ð¾Ð´Ð°',0),(246742,6854,'es','Para el PerÃ­odo',0),(246743,6854,'de','FÃ¼r den Zeitraum',0),(246744,6854,'en','For the Period',0),(246745,6855,'is','',0),(246746,6855,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(246747,6855,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(246748,6855,'tr','Alma tarihi',0),(246749,6855,'pl','Data importu',0),(246750,6855,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(246751,6855,'ur','ØªØ§Ø±ÛŒØ® Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(246752,6855,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÑƒÐ²Ð¾Ð·Ð°',0),(246753,6855,'vi','Nháº­p ngÃ y',0),(246754,6855,'af','Ingevoerde Datum',0),(246755,6855,'ro','Data de import',0),(246756,6855,'et','Impordi kuupÃ¤ev',0),(246757,6855,'si','Datum uvoza',0),(246758,6855,'ba','Impor tanggal',0),(246759,6855,'nl','Invoer datum',0),(246760,6855,'fi','Importointi pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(246761,6855,'no','Importdata',0),(246762,6855,'da','Importere dato',0),(246763,6855,'ko','ë‚ ì§œ ê°€ì ¸ì˜¤ê¸°',0),(246764,6855,'he','×ª××¨×™×š ×”×™×™×‘×•×',0),(246765,6855,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(246766,6855,'zh','å¯¼å…¥æ—¥æœŸ\r\n',0),(246767,6855,'sv','Importera datum',0),(246768,6855,'it','Data di importazione',0),(246769,6855,'tl','',0),(246770,6855,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(246771,6855,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(246772,6855,'ms','Tarikh import',0),(246773,6855,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(246774,6855,'fr','Date de l\'importation',0),(246775,6855,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆæ—¥ä»˜',0),(246776,6855,'pt','Data da importaÃ§Ã£o',0),(246777,6855,'ru','Ð”Ð°Ñ‚Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(246778,6855,'es','Importar Fecha',0),(246779,6855,'de','Import Datum',0),(246780,6855,'en','Import Date',0),(246781,6856,'is','',0),(246782,6856,'dr','Ù‡ÙŠÚ† ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(246783,6856,'pr','Ù‡ÙŠÚ† ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(246784,6856,'tr','Bulunan iÃ§in bir komisyon yok',0),(246785,6856,'pl','Bez prowizji, Znalezione',0),(246786,6856,'bg','Ð‘ÐµÐ· ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(246787,6856,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ù…ÛŒØ´Ù†ÙˆÚº Ù¾Ø§ÛŒØ§',0),(246788,6856,'sr','ÐÐµÐ¼Ð° Ð²ÐµÐ·Ð°, Ð½Ð°ÑˆÐ°Ð¾',0),(246789,6856,'vi','KhÃ´ng tÃ¬m tháº¥y hoa há»“ng',0),(246790,6856,'af','Geen Kommissies Gevind',0),(246791,6856,'ro','Nu comisioane gÄƒsit',0),(246792,6856,'et','Ei leidnud komisjonitasud',0),(246793,6856,'si','Brez provizije, najti',0),(246794,6856,'ba','Tidak ada komisi yang ditemukan',0),(246795,6856,'nl','Geen commissies gevonden',0),(246796,6856,'fi','Ei provisioita lÃ¶ytyi',0),(246797,6856,'no','Ingen provisjon funnet',0),(246798,6856,'da','Ingen provision fundet',0),(246799,6856,'ko','ì•„ë‹ˆ ìˆ˜ìˆ˜ë£Œë¥¼ ë°œê²¬',0),(246800,6856,'he','×œ× × ×ž×¦××• ×¢×ž×œ×•×ª',0),(246801,6856,'el','Î”ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ¿Ï€ÏŽÎ½ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(246802,6856,'zh','æœªå‘çŽ°ä½£é‡‘',0),(246803,6856,'sv','Inga provisioner hittade',0),(246804,6856,'it','Nessuna Commissione trovata',0),(246805,6856,'tl','',0),(246806,6856,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(246807,6856,'hi','à¤¨à¤¹à¥€à¤‚ à¤†à¤¯à¥‹à¤—à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(246808,6856,'ms','Tiada komisen yang didapati',0),(246809,6856,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¹Ù…ÙˆÙ„Ø§Øª',0),(246810,6856,'fr','Pas trouvÃ©es de Commissions',0),(246811,6856,'jp','ã‚³ãƒŸãƒƒã‚·ãƒ§ãƒ³ãªã—ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(246812,6856,'pt','Sem comissÃµes encontradas',0),(246813,6856,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(246814,6856,'es','No se EncontrÃ³ Comisiones',0),(246815,6856,'de','Keine Kommissionen gefunden',0),(246816,6856,'en','No Commissions Found',0),(246817,6857,'is','',0),(246818,6857,'dr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(246819,6857,'pr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(246820,6857,'tr','SeÃ§ili hiÃ§bir satÄ±cÄ±lar',0),(246821,6857,'pl','Nie dostawcÃ³w wybranych',0),(246822,6857,'bg','ÐÑÐ¼Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð¸Ð·Ð±Ñ€Ð°Ð½',0),(246823,6857,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº',0),(246824,6857,'sr','ÐÐµÐ¼Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(246825,6857,'vi','ChÆ°a chá»n ngÆ°á»i bÃ¡n',0),(246826,6857,'af','Geen Verskaffers Gekies',0),(246827,6857,'ro','Nu vÃ¢nzÄƒtorii selectate',0),(246828,6857,'et','Tarnijaid ei ole valitud',0),(246829,6857,'si','Ne ponudniki, izbrani',0),(246830,6857,'ba','Tidak ada vendor yang dipilih',0),(246831,6857,'nl','Geen leveranciers geselecteerd',0),(246832,6857,'fi','Ei toimittajat valittu',0),(246833,6857,'no','Ingen leverandÃ¸rer valgt',0),(246834,6857,'da','Ingen leverandÃ¸rer valgt',0),(246835,6857,'ko','ì•„ë‹ˆ ê³µê¸‰ ì—…ì²´ ì„ ì •',0),(246836,6857,'he','××™×Ÿ ×¡×¤×§×™× ×©× ×‘×—×¨×•',0),(246837,6857,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ Ï€Ï‰Î»Î·Ï„Î­Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯',0),(246838,6857,'zh','æ²¡æœ‰é€‰å®šçš„ä¾›åº”å•†\r\n',0),(246839,6857,'sv','Inga leverantÃ¶rer valt',0),(246840,6857,'it','Nessun fornitori selezionati',0),(246841,6857,'tl','',0),(246842,6857,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(246843,6857,'hi','à¤•à¥‹à¤ˆ à¤šà¤¯à¤¨à¤¿à¤¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(246844,6857,'ms','Tiada pembekal yang dipilih',0),(246845,6857,'ar','Ù„Ù… ÙŠØ®ØªØ± Ø£ÙŠ Ù…ÙˆØ±Ù‘Ø¯',0),(246846,6857,'fr','Aucun fournisseurs sÃ©lectionnÃ©s',0),(246847,6857,'jp','é¸æŠžã—ãŸãƒ™ãƒ³ãƒ€ãƒ¼ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(246848,6857,'pt','NÃ£o hÃ¡ fornecedores selecionados',0),(246849,6857,'ru','ÐÐµÑ‚ Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(246850,6857,'es','No se Seleccionaron Proveedores',0),(246851,6857,'de','Keine ausgewÃ¤hlten Anbieter',0),(246852,6857,'en','No Vendors Selected',0),(246853,6858,'is','',0),(246854,6858,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ ',0),(246855,6858,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ ',0),(246856,6858,'tr','SipariÅŸ Amt',0),(246857,6858,'pl','Amt zamÃ³wienia',0),(246858,6858,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Amt',0),(246859,6858,'ur','ØªØ±ØªÛŒØ¨ Ø§Ù…Ù¹',0),(246860,6858,'sr','Ð Ð•Ð¤ . Ð’Ð°Ð» Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ.',0),(246861,6858,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n hÃ ng',0),(246862,6858,'af','Bestelling Bedrag',0),(246863,6858,'ro','Ordinul Amt',0),(246864,6858,'et','Tellimuse Amt',0),(246865,6858,'si','Naloga Amt',0),(246866,6858,'ba','Urutan Amt',0),(246867,6858,'nl','Volgorde Amt',0),(246868,6858,'fi','Jotta Amt',0),(246869,6858,'no','Bestill Amt',0),(246870,6858,'da','Bestil Amt',0),(246871,6858,'ko','ì£¼ë¬¸ Amt',0),(246872,6858,'he','×¡×“×¨ Amt',0),(246873,6858,'el','Î£ÎµÎ¹ÏÎ¬ Amt',0),(246874,6858,'zh','è®¢å•é‡‘é¢\r\n',0),(246875,6858,'sv','Ordning Amt',0),(246876,6858,'it','Ordine Amt',0),(246877,6858,'tl','',0),(246878,6858,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(246879,6858,'hi','à¤•à¥à¤°à¤® Amt',0),(246880,6858,'ms','Amt perintah',0),(246881,6858,'ar','Ø£Ù…Ø± Ø§Ù„Ù‚Ø¶Ø§Ø© Ø§Ù„ØªÙˆÙ†Ø³ÙŠÙŠÙ†',0),(246882,6858,'fr','Ordre Amt',0),(246883,6858,'jp','é †åº Amt',0),(246884,6858,'pt','Ordem Amt',0),(246885,6858,'ru','Ð—Ð°ÐºÐ°Ð· Amt',0),(246886,6858,'es','Monto de Orden',0),(246887,6858,'de','Bestellung-Amt',0),(246888,6858,'en','Order Amt',0),(246889,6859,'is','',0),(246890,6859,'dr','Ø­Ù‚ÙˆÙ‚ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ù‡Ø§',0),(246891,6859,'pr','Ø­Ù‚ÙˆÙ‚ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ù‡Ø§',0),(246892,6859,'tr','Komisyon Ã¶demek',0),(246893,6859,'pl','PÅ‚acÄ… prowizje',0),(246894,6859,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸',0),(246895,6859,'ur','Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(246896,6859,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ðµ',0),(246897,6859,'vi','Tráº£ hoa há»“ng',0),(246898,6859,'af','Betaal Kommissies',0),(246899,6859,'ro','PlÄƒti comisioane',0),(246900,6859,'et','Maksta komisjonitasusid',0),(246901,6859,'si','PlaÄilo komisij',0),(246902,6859,'ba','Membayar komisi',0),(246903,6859,'nl','Betalen commissies',0),(246904,6859,'fi','Maksaa provisiot',0),(246905,6859,'no','Betal provisjon',0),(246906,6859,'da','Betale provision',0),(246907,6859,'ko','ìˆ˜ìˆ˜ë£Œë¥¼ ì§€ë¶ˆ í•´ì•¼',0),(246908,6859,'he','×ž×©×œ×ž×™× ×¢×ž×œ×•×ª',0),(246909,6859,'el','Î Î»Î·ÏÏŽÎ½ÎµÏ„Îµ Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚',0),(246910,6859,'zh','æ”¯ä»˜ä½£é‡‘\r\n',0),(246911,6859,'sv','Betala provisioner',0),(246912,6859,'it','Pagare commissioni',0),(246913,6859,'tl','',0),(246914,6859,'th','&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(246915,6859,'hi','à¤†à¤¯à¥‹à¤—à¥‹à¤‚ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(246916,6859,'ms','Membayar komisen',0),(246917,6859,'ar','Ø¯ÙØ¹ Ø§Ù„Ø¹Ù…ÙˆÙ„Ø§Øª',0),(246918,6859,'fr','Payer des Commissions',0),(246919,6859,'jp','æ‰‹æ•°æ–™ã‚’æ”¯æ‰•ã†',0),(246920,6859,'pt','Pagar comissÃµes',0),(246921,6859,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ñƒ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¹',0),(246922,6859,'es','Comisiones de Pagos',0),(246923,6859,'de','Zahlen Provisionen',0),(246924,6859,'en','Pay Commissions',0),(246925,6860,'is','',0),(246926,6860,'dr','Ú†Ø§Ù¾ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ù¾ÙŠÙˆØ³Øª Ù‡Ø§ ',0),(246927,6860,'pr','Ú†Ø§Ù¾ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ù¾ÙŠÙˆØ³Øª Ù‡Ø§ ',0),(246928,6860,'tr','TÃ¼m ortaklar iÃ§in baskÄ± PDF',0),(246929,6860,'pl','Druk PDF dla wszystkich oddziaÅ‚Ã³w',0),(246930,6860,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° PDF Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ„Ð¸Ð»Ð¸Ð°Ð»Ð¸',0),(246931,6860,'ur','Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ Ú©Û’ Ù„Ø¦Û’ Ø³Û’ Ù…Ù„Ø­Ù‚ ØªÙ…Ø§Ù… Ú¯Ø±ÙˆÙ¾ÙˆÚº Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(246932,6860,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐŸÐ”Ð¤ Ð·Ð° ÑÐ²Ðµ Ð¾Ð³Ñ€Ð°Ð½ÐºÐµ',0),(246933,6860,'vi','In theo dáº¡ng PDF cho táº¥t cáº£ chi nhÃ¡nh',0),(246934,6860,'af','Druk die PDF vir alle affiliasies',0),(246935,6860,'ro','Imprimare PDF pentru toate filialele',0),(246936,6860,'et','Prindi PDF kÃµigile partneritele',0),(246937,6860,'si','Tiskanje PDF za vse podruÅ¾nice',0),(246938,6860,'ba','Mencetak PDF untuk semua afiliasi',0),(246939,6860,'nl','PDF-bestand afdrukken voor alle filialen',0),(246940,6860,'fi','PDF-tiedoston tulostaminen kumppaneille',0),(246941,6860,'no','Skrive ut PDF for alle agenter',0),(246942,6860,'da','Print PDF for alle datterselskaber',0),(246943,6860,'ko','ëª¨ë“  ê³„ì—´ì‚¬ì— ëŒ€ í•œ PDFë¥¼ ì¸ì‡„',0),(246944,6860,'he','×”×“×¤×¡ ×ž×¡×ž×š PDF ×œ×›×œ ×”×©×•×ª×¤×™×',0),(246945,6860,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ PDF Î³Î¹Î± ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î¸Ï…Î³Î±Ï„ÏÎ¹ÎºÎ­Ï‚',0),(246946,6860,'zh','æ‰€æœ‰åˆ†æ”¯æœºæž„çš„PDFæ‰“å°\r\n',0),(246947,6860,'sv','Skriv ut PDF fÃ¶r alla Affiliates',0),(246948,6860,'it','Stampa PDF per tutti gli affiliati',0),(246949,6860,'tl','',0),(246950,6860,'th','&#3614;&#3636;&#3617;&#3614;&#3660; PDF &#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3607;&#3640;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3651;&#3609;&#3648;&#3588;&#3619;&#3639;&#3629;',0),(246951,6860,'hi','à¤¸à¤­à¥€ à¤¸à¤¹à¤¯à¥‹à¤—à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ PDF',0),(246952,6860,'ms','Cetakkan PDF untuk semua ahli gabungan',0),(246953,6860,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚ÙˆØ§Øª Ø§Ù„Ø¯ÙØ§Ø¹ Ø§Ù„Ø´Ø¹Ø¨ÙŠ Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„ÙØ±ÙˆØ¹',0),(246954,6860,'fr','Imprimer des PDF pour tous les affiliÃ©s',0),(246955,6860,'jp','ã™ã¹ã¦ã®ã‚¢ãƒ•ã‚£ãƒª ã‚¨ã‚¤ãƒˆã® pdf ãƒ•ã‚¡ã‚¤ãƒ«ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(246956,6860,'pt','Imprimir PDF para todos os afiliados',0),(246957,6860,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ PDF Ð´Ð»Ñ Ð²ÑÐµÑ… Ñ„Ð¸Ð»Ð¸Ð°Ð»Ð¾Ð²',0),(246958,6860,'es','Imprimir PDF para Todos los Afiliados',0),(246959,6860,'de','Drucken PDF fÃ¼r alle Affiliates',0),(246960,6860,'en','Print PDF for All Affiliates',0),(246961,6861,'is','',0),(246962,6861,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(246963,6861,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(246964,6861,'tr','SatÄ±cÄ±',0),(246965,6861,'pl','Sprzedawca',0),(246966,6861,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ‡',0),(246967,6861,'ur','Ø¨ÛŒÚ†Ù†Û’ ÙˆØ§Ù„Û’',0),(246968,6861,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(246969,6861,'vi','NgÆ°á»i bÃ¡n',0),(246970,6861,'af','Verkoper',0),(246971,6861,'ro','VÃ¢nzÄƒtor',0),(246972,6861,'et','MÃ¼Ã¼ja',0),(246973,6861,'si','Prodajalec',0),(246974,6861,'ba','Penjual',0),(246975,6861,'nl','Verkoper',0),(246976,6861,'fi','MyyjÃ¤',0),(246977,6861,'no','Selger',0),(246978,6861,'da','SÃ¦lger',0),(246979,6861,'ko','íŒë§¤ìž',0),(246980,6861,'he','×ž×•×›×¨',0),(246981,6861,'el','Î Ï‰Î»Î·Ï„Î®',0),(246982,6861,'zh','å–å®¶\r\n',0),(246983,6861,'sv','SÃ¤ljaren',0),(246984,6861,'it','Venditore',0),(246985,6861,'tl','',0),(246986,6861,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(246987,6861,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(246988,6861,'ms','Penjual',0),(246989,6861,'ar','Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(246990,6861,'fr','Vendeur',0),(246991,6861,'jp','å£²ã‚Šæ‰‹',0),(246992,6861,'pt','Vendedor',0),(246993,6861,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(246994,6861,'es','Proveedor',0),(246995,6861,'de','VerkÃ¤ufer',0),(246996,6861,'en','Seller',0),(246997,6862,'is','',0),(246998,6862,'dr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ ',0),(246999,6862,'pr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ ',0),(247000,6862,'tr','Mevcut dÃ¼zeni sil',0),(247001,6862,'pl','Usuwanie istniejÄ…cego zlecenia/zamÃ³wienia',0),(247002,6862,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(247003,6862,'ur','Ù…ÙˆØ¬ÙˆØ¯Û ØªØ±ØªÛŒØ¨ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(247004,6862,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(247005,6862,'vi','XÃ³a ÄÆ¡n Äáº·t HÃ ng Hiá»‡n CÃ³',0),(247006,6862,'af','Skrap Bestaande Bestelling',0),(247007,6862,'ro','ÅžtergeÅ£i ordinea existentÄƒ',0),(247008,6862,'et','Kustuta olemasolev tellimus',0),(247009,6862,'si','IzbriÅ¡ite obstojeÄe naroÄilo',0),(247010,6862,'ba','Menghapus susunan',0),(247011,6862,'nl','Bestaande Order verwijderen',0),(247012,6862,'fi','Poistaa olemassa olevan tilauksen',0),(247013,6862,'no','Slette eksisterende ordre',0),(247014,6862,'da','Slet eksisterende ordre',0),(247015,6862,'ko','ê¸°ì¡´ ì£¼ë¬¸ì„ ì‚­ì œí•©ë‹ˆë‹¤',0),(247016,6862,'he','×œ×ž×—×•×§ ××ª ×”×¡×“×¨ ×”×§×™×™×',0),(247017,6862,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Ï„Î·Î½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎ± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(247018,6862,'zh','åˆ é™¤çŽ°æœ‰è®¢å•\r\n',0),(247019,6862,'sv','Ta bort befintlig Order',0),(247020,6862,'it','Eliminare l\'ordine esistente',0),(247021,6862,'tl','',0),(247022,6862,'th','&#3621;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(247023,6862,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(247024,6862,'ms','Padam perintah sedia ada',0),(247025,6862,'ar','Ø­Ø°Ù Ø§Ù„Ø·Ù„Ø¨ÙŠØ© Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(247026,6862,'fr','Supprimer l\'ordre existant',0),(247027,6862,'jp','æ—¢å­˜ã®æ³¨æ–‡ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(247028,6862,'pt','Excluir a ordem existente',0),(247029,6862,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ Ð—Ð°ÐºÐ°Ð·',0),(247030,6862,'es','Eliminar Pedido Existente',0),(247031,6862,'de','LÃ¶schen bestehenden Auftrag',0),(247032,6862,'en','Delete Existing Order',0),(247033,6863,'is','',0),(247034,6863,'dr','Ù‡Ù…Ù‡ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙŠÙƒÙŠ ÙƒÙ†ÙŠØ¯ ',0),(247035,6863,'pr','Ù‡Ù…Ù‡ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙŠÙƒÙŠ ÙƒÙ†ÙŠØ¯ ',0),(247036,6863,'tr','Her sipariÅŸ iÃ§in birleÅŸtirin',0),(247037,6863,'pl','PoÅ‚Ä…czyÄ‡ wszystko na zamÃ³wienie',0),(247038,6863,'bg','ÐšÐ¾Ð¼Ð±Ð¸Ð½Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(247039,6863,'ur','Ø³Ø¨ Ú©ÛŒÙ„Ø¦Û’ Ø¢Ø±ÚˆØ± Ú©Ø§ Ø§Ù…ØªØ²Ø§Ø¬ Ú©Ø±ÛŒÚº',0),(247040,6863,'sr','ÐšÐ¾Ð¼Ð±Ð¸Ð½Ð¾Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(247041,6863,'vi','Gá»™p Táº¥t Cáº£ ÄÆ¡n Äáº·t HÃ ng',0),(247042,6863,'af','Kombineer Alles vir Bestelling',0),(247043,6863,'ro','Combina toate pentru comanda',0),(247044,6863,'et','Kombineeri kÃµik tellimuse puhul',0),(247045,6863,'si','ZdruÅ¾ite vse za naroÄilo',0),(247046,6863,'ba','Menggabungkan semua untuk Order',0),(247047,6863,'nl','Combineren alle voor Order',0),(247048,6863,'fi','YhdistÃ¤ kaikki jÃ¤rjestyksessÃ¤',0),(247049,6863,'no','Kombinere for ordre',0),(247050,6863,'da','Kombinere alle for rÃ¦kkefÃ¸lge',0),(247051,6863,'ko','ëª¨ë“  ì£¼ë¬¸ì— ëŒ€ í•œ ê²°í•©',0),(247052,6863,'he','×œ×©×œ×‘ ×”×›×œ ×¢×‘×•×¨ ×”×–×ž× ×”',0),(247053,6863,'el','Î£Ï…Î½Î´Ï…Î¬ÏƒÏ„Îµ ÏŒÎ»Î± Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(247054,6863,'zh','ä¸ºè®¢å•ç»“åˆæ‰€æœ‰\r\n',0),(247055,6863,'sv','Kombinera alla fÃ¶r bestÃ¤llning',0),(247056,6863,'it','Combinare tutti per ordine',0),(247057,6863,'tl','',0),(247058,6863,'th','&#3619;&#3623;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(247059,6863,'hi','à¤¸à¤­à¥€ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¤ à¤¬à¤‚à¤§à¤¨',0),(247060,6863,'ms','Menggabungkan semua untuk pesanan',0),(247061,6863,'ar','Ø§Ù„Ø¬Ù…Ø¹ Ø¨ÙŠÙ† Ø¬Ù…ÙŠØ¹ Ù„Ù„Ù†Ø¸Ø§Ù…',0),(247062,6863,'fr','Combiner tous pour commander',0),(247063,6863,'jp','æ³¨æ–‡ã®ã™ã¹ã¦ã‚’çµ„ã¿åˆã‚ã›ã‚‹',0),(247064,6863,'pt','Combinar tudo por ordem',0),(247065,6863,'ru','ÐžÐ±ÑŠÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(247066,6863,'es','Combinar Todo para el Pedido',0),(247067,6863,'de','Kombinieren Sie alle fÃ¼r die Bestellung',0),(247068,6863,'en','Combine All for Order',0),(247069,6864,'is','',0),(247070,6864,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø§Ø¹Ù„Ø§Ù… Ø­Ù…Ù„',0),(247071,6864,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø§Ø¹Ù„Ø§Ù… Ø­Ù…Ù„',0),(247072,6864,'tr','E-posta gemi uyarÄ±',0),(247073,6864,'pl','E-mail powiadomienia statku',0),(247074,6864,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ Ð¿Ð¾ Ð¸Ð¼ÐµÐ¹Ð»',0),(247075,6864,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø¬ÛØ§Ø² Ù†ÙˆÙ¹Ø³',0),(247076,6864,'sr','Ð•Ð¼Ð°Ð¸Ð» Ð±Ñ€Ð¾Ð´ Ð½Ð°Ñ˜Ð°Ð²Ðµ',0),(247077,6864,'vi','Email thÃ´ng bÃ¡o váº­n chuyá»ƒn',0),(247078,6864,'af','E-pos Versendingsnota\'s',0),(247079,6864,'ro','Notificare de livrare e-mail',0),(247080,6864,'et','E-posti laeva teates',0),(247081,6864,'si','Obvestilo email ladje',0),(247082,6864,'ba','Email pemberitahuan kapal',0),(247083,6864,'nl','E schip aankondiging',0),(247084,6864,'fi','Aluksen ilmoituksen sÃ¤hkÃ¶postilla',0),(247085,6864,'no','E-leveringsmelding',0),(247086,6864,'da','E-mail skib varsel',0),(247087,6864,'ko','ì´ë©”ì¼ ì„ ë°• ì£¼ì˜ ì‚¬í•­',0),(247088,6864,'he','×©×™× ×œ×‘ ×”×¡×¤×™× ×” ×“×•×',0),(247089,6864,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï€Î»Î¿Î¯Î¿',0),(247090,6864,'zh','ç”µå­é‚®ä»¶å‘è´§é€šçŸ¥\r\n',0),(247091,6864,'sv','E-Ship meddelande',0),(247092,6864,'it','Avviso nave e-mail',0),(247093,6864,'tl','',0),(247094,6864,'th','&#3649;&#3592;&#3657;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(247095,6864,'hi','à¤ˆà¤®à¥‡à¤² à¤œà¤¹à¤¾à¤œ à¤¨à¥‹à¤Ÿà¤¿à¤¸',0),(247096,6864,'ms','E-mel kapal notis',0),(247097,6864,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø³ÙÙŠÙ†Ø© Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(247098,6864,'fr','Avis de navire par courriel',0),(247099,6864,'jp','èˆ¹ã®é›»å­ãƒ¡ãƒ¼ãƒ«é€šçŸ¥',0),(247100,6864,'pt','E-mail aviso de navio',0),(247101,6864,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(247102,6864,'es','Email NotificaciÃ³n de EnvÃ­o',0),(247103,6864,'de','E-Mail Schiff und Datenschutz',0),(247104,6864,'en','Email Ship Notice',0),(247105,6865,'is','',0),(247106,6865,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø§Ø¹Ù„Ø§Ù… Ø­Ù…Ù„',0),(247107,6865,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø§Ø¹Ù„Ø§Ù… Ø­Ù…Ù„',0),(247108,6865,'tr','E-posta gemi bildirimi',0),(247109,6865,'pl','Powiadomienia e-mail statku',0),(247110,6865,'bg','Ð£Ð²ÐµÐ´Ð¾Ð¼ÑÐ²Ð°Ð½Ðµ Ð¿Ð¾ Ð¸Ð¼ÐµÐ¹Ð» ÐºÐ¾Ñ€Ð°Ð±',0),(247111,6865,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹ Ø¬ÛØ§Ø²',0),(247112,6865,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐ° ÑÐ° Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµÐ¼ Ð±Ñ€Ð¾Ð´',0),(247113,6865,'vi','Email thÃ´ng bÃ¡o chuyáº¿n hÃ ng',0),(247114,6865,'af','E-pos Versendingskennisgewings',0),(247115,6865,'ro','Notificare de livrare e-mail',0),(247116,6865,'et','Saada tarne kohta teade e-postiga',0),(247117,6865,'si','Email obvestilo za ladje',0),(247118,6865,'ba','Notifikasi email kapal',0),(247119,6865,'nl','E schip kennisgeving',0),(247120,6865,'fi','Laivan sÃ¤hkÃ¶postimuistutus',0),(247121,6865,'no','Skipet varsel',0),(247122,6865,'da','E-mail-meddelelser i skib',0),(247123,6865,'ko','ì´ë©”ì¼ ì„ ë°• ì•Œë¦¼',0),(247124,6865,'he','×”×•×“×¢×ª ×“×•×\"×œ ×”×¡×¤×™× ×”',0),(247125,6865,'el','Î Î»Î¿Î¯Î¿ ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(247126,6865,'zh','ç”µå­é‚®ä»¶å‘è´§é€šçŸ¥\r\n',0),(247127,6865,'sv','Ã„mnesbevakning fartyg',0),(247128,6865,'it','Email di notifica di nave',0),(247129,6865,'tl','',0),(247130,6865,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(247131,6865,'hi','à¤ˆà¤®à¥‡à¤² à¤œà¤¹à¤¾à¤œ à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾',0),(247132,6865,'ms','Pemberitahuan kapal e-mel',0),(247133,6865,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ø´Ø¹Ø§Ø±Ø§ Ø¨Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(247134,6865,'fr','Avis de navire par courriel',0),(247135,6865,'jp','èˆ¹ã®ãƒ¡ãƒ¼ãƒ«é€šçŸ¥',0),(247136,6865,'pt','E-mail de notificaÃ§Ã£o de navio',0),(247137,6865,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(247138,6865,'es','Email NotificaciÃ³n de EnvÃ­o',0),(247139,6865,'de','E-Mail-Benachrichtigung fÃ¼r Schiff',0),(247140,6865,'en','Email Ship Notification',0),(247141,6866,'is','',0),(247142,6866,'dr','Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(247143,6866,'pr','Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(247144,6866,'tr','Saat iÃ§in',0),(247145,6866,'pl','Na godzinÄ™',0),(247146,6866,'bg','Ð—Ð° Ñ‡Ð°Ñ',0),(247147,6866,'ur','ÙÛŒ Ú¯Ú¾Ù†Ù¹Û',0),(247148,6866,'sr','ÐŸÐ¾ ÑÐ°Ñ‚Ñƒ',0),(247149,6866,'vi','Má»—i giá»',0),(247150,6866,'af','Per Uur',0),(247151,6866,'ro','Pe orÄƒ',0),(247152,6866,'et','Tund',0),(247153,6866,'si','Na uro',0),(247154,6866,'ba','Per jam',0),(247155,6866,'nl','Per uur',0),(247156,6866,'fi','Tunnissa',0),(247157,6866,'no','Per time',0),(247158,6866,'da','Pr. time',0),(247159,6866,'ko','ì‹œê°„ ë‹¹',0),(247160,6866,'he','×œ×›×œ ×©×¢×”',0),(247161,6866,'el','Î‘Î½Î¬ ÏŽÏÎ±',0),(247162,6866,'zh','æ¯å°æ—¶\r\n',0),(247163,6866,'sv','Per timme',0),(247164,6866,'it','All\'ora',0),(247165,6866,'tl','',0),(247166,6866,'th','&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(247167,6866,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾',0),(247168,6866,'ms','Setiap jam',0),(247169,6866,'ar','ÙƒÙ„ Ø³Ø§Ø¹Ø©',0),(247170,6866,'fr','Ã€ l\'heure',0),(247171,6866,'jp','1 æ™‚é–“ã‚ãŸã‚Š',0),(247172,6866,'pt','Por hora',0),(247173,6866,'ru','Ð’ Ñ‡Ð°Ñ',0),(247174,6866,'es','Por Hora',0),(247175,6866,'de','Pro Stunde',0),(247176,6866,'en','Per Hour',0),(247177,6867,'is','',0),(247178,6867,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† ØªÙ…Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ø§ÙŠÙ…ÙŠÙ„ Ù‡Ø§ÙŠ ØªÙŠÚ© Ø²Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(247179,6867,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† ØªÙ…Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ø§ÙŠÙ…ÙŠÙ„ Ù‡Ø§ÙŠ ØªÙŠÚ© Ø²Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(247180,6867,'tr','Onay iÅŸareti e-postalar gÃ¶ndermek tÃ¼m grup',0),(247181,6867,'pl','WyÅ›lij caÅ‚Ä… grupÄ™ zaznaczone wiadomoÅ›ci',0),(247182,6867,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ñ†ÑÐ»Ð°Ñ‚Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð¾Ñ‚ Ð¾Ñ‚Ð¼ÐµÑ‚Ð½Ð°Ñ‚Ð¾ Ð¸Ð¼ÐµÐ¹Ð»Ð¸',0),(247183,6867,'ur','Ø¨Ú¾ÛŒØ¬ÛŒÚº Ù¾ÙˆØ±Û’ Ú¯Ø±ÙˆÙ¾ Ú†ÛŒÚ©Ù…Ø¢Ø±Ú© Ú©ÛŒ Ø§ÛŒ Ù…ÛŒÙ„Ø² Ú©ÛŒ',0),(247184,6867,'sr','Ð• -Ð¿Ð¾Ñ€ÑƒÐºÐµ ÑÐ»Ð°ÑšÐµ Ñ†ÐµÐ»Ñƒ Ð³Ñ€ÑƒÐ¿Ñƒ Ð½Ð°Ð»Ð°Ð·Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð½Ð¸ Ð·Ð½Ð°Ðº',0),(247185,6867,'vi','Gá»­i Email Ä‘áº¿n toÃ n bá»™ nhá»¯ng Email Ä‘Ã£ Ä‘Ã¡nh dáº¥u',0),(247186,6867,'af','Stuur Hele Groep Gemerkte E-posse',0),(247187,6867,'ro','Trimite Ã®ntregul grup de e-mailuri selectat',0),(247188,6867,'et','Saada kogu grupi algdokumendil kirju',0),(247189,6867,'si','PoÅ¡lji celotno skupino Checkmarked e-poÅ¡te',0),(247190,6867,'ba','Kirim seluruh kelompok email Checkmarked',0),(247191,6867,'nl','Kunnen er nog vraagregels E-mails verzenden hele groep',0),(247192,6867,'fi','LÃ¤hetÃ¤ koko konsernin lÃ¤hdeasiakirjalle sÃ¤hkÃ¶posteja',0),(247193,6867,'no','Send hele gruppen av lokasjonsoppsettsverdiene Emails',0),(247194,6867,'da','Send hele gruppen af markeret Emails',0),(247195,6867,'ko','ì²´í¬ ì´ë©”ì¼ì˜ ì†¡ì‹  ì „ì²´ ê·¸ë£¹',0),(247196,6867,'he','×©×œ×— ×§×‘×•×¦×” ×©×œ×ž×” ×©×œ ×ž×™×™×œ×™× ×¢× ×¡×™×ž×Ÿ ×‘×™×§×•×¨×ª',0),(247197,6867,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î¿Î»ÏŒÎºÎ»Î·ÏÎ· Î¿Î¼Î¬Î´Î± Ï„Î¿Ï… ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(247198,6867,'zh','å‹¾é€‰ç”µå­é‚®ä»¶å‘é€æ•´ä¸ªç¾¤ç»„\r\n',0),(247199,6867,'sv','Skicka hela gruppen av planeringsmotorn e-post',0),(247200,6867,'it','Intero gruppo di trasmissione di messaggi di posta elettronica contrassegnato',0),(247201,6867,'tl','',0),(247202,6867,'th','&#3626;&#3656;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3586;&#3629;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3607;&#3637;&#3656;&#3607;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3',0),(247203,6867,'hi','à¤­à¥‡à¤œà¥‡à¤‚ Checkmarked à¤ˆà¤®à¥‡à¤² à¤•à¤¾ à¤¸à¤‚à¤ªà¥‚à¤°à¥à¤£ à¤¸à¤®à¥‚à¤¹',0),(247204,6867,'ms','Hantar seluruh Kumpulan e-mel Checkmarked',0),(247205,6867,'ar','Ø¥Ø±Ø³Ø§Ù„ Ù…Ø¬Ù…ÙˆØ¹Ø© ÙƒØ§Ù…Ù„Ø© Ù…Ù† Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ ØªØ´ÙŠÙƒÙ…Ø§Ø±ÙƒÙŠØ¯',0),(247206,6867,'fr','Groupe de tout envoi de courriels cochÃ©',0),(247207,6867,'jp','ãƒã‚§ãƒƒã‚¯ ãƒžãƒ¼ã‚¯ã®ä»˜ã„ãŸãƒ¡ãƒ¼ãƒ«ã®é€ä¿¡å…¨ä½“ã‚°ãƒ«ãƒ¼ãƒ—',0),(247208,6867,'pt','Grupo de todo o envio de E-mails Ã©',0),(247209,6867,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²ÐºÐ° Ð²ÑÐµÐ¹ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ð¿Ð¸ÑÐµÐ¼',0),(247210,6867,'es','Enviar Grupo Entero de Emails Marcados',0),(247211,6867,'de','Send gesamte Gruppe markiert e-Mails',0),(247212,6867,'en','Send Entire Group of Checkmarked Emails',0),(247213,6868,'is','',0),(247214,6868,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø²Ù…Ø§Ù† Ø¯Ø±ÙŠØ§ÙØª Ùˆ ÙØ±Ø¢ÙˆØ±ÙŠ Ùˆ Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ ',0),(247215,6868,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø²Ù…Ø§Ù† Ø¯Ø±ÙŠØ§ÙØª Ùˆ ÙØ±Ø¢ÙˆØ±ÙŠ Ùˆ Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ ',0),(247216,6868,'tr','Ortalama Turnaround(Days)',0),(247217,6868,'pl','Åšrednia Turnaround(Days)',0),(247218,6868,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð¾ Turnaround(Days)',0),(247219,6868,'ur','Ø§ÙˆØ³Ø· Turnaround(Days)',0),(247220,6868,'sr','ÐŸÑ€Ð¾ÑÐµÑ‡Ð½Ð° Ð¢ÑƒÑ€Ð½Ð°Ñ€Ð¾ÑƒÐ½Ð´(Ð”Ð°yÑ)',0),(247221,6868,'vi','VÃ²ng Quay Trung BÃ¬nh (NgÃ y)',0),(247222,6868,'af','Gemiddelde Turnaround(Days)',0),(247223,6868,'ro','Medii Turnaround(Days)',0),(247224,6868,'et','Keskmine Turnaround(Days)',0),(247225,6868,'si','PovpreÄna Turnaround(Days)',0),(247226,6868,'ba','Rata-rata Turnaround(Days)',0),(247227,6868,'nl','Gemiddelde Turnaround(Days)',0),(247228,6868,'fi','KeskimÃ¤Ã¤rÃ¤inen Turnaround(Days)',0),(247229,6868,'no','Gjennomsnittlig Turnaround(Days)',0),(247230,6868,'da','Gennemsnitlige Turnaround(Days)',0),(247231,6868,'ko','í‰ê·  Turnaround(Days)',0),(247232,6868,'he','Turnaround(Days) ×”×ž×ž×•×¦×¢',0),(247233,6868,'el','ÎœÎ­ÏƒÎ· Turnaround(Days)',0),(247234,6868,'zh','å¹³å‡å‘¨è½¬ï¼ˆå¤©ï¼‰\r\n',0),(247235,6868,'sv','Genomsnittlig Turnaround(Days)',0),(247236,6868,'it','Turnaround(Days) media',0),(247237,6868,'tl','',0),(247238,6868,'th','&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3592;&#3635;&#3609;&#3623;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3632;&#3627;&#3617;&#3640;&#3609;&#3652;&#3611;&#3652;&#3604;&#3657;',0),(247239,6868,'hi','à¤”à¤¸à¤¤ Turnaround(Days)',0),(247240,6868,'ms','Purata Turnaround(Days)',0),(247241,6868,'ar','Turnaround(Days) Ù…ØªÙˆØ³Ø·',0),(247242,6868,'fr','Turnaround(Days) moyen',0),(247243,6868,'jp','å¹³å‡ Turnaround(Days)',0),(247244,6868,'pt','Turnaround(Days) mÃ©dia',0),(247245,6868,'ru','Ð¡Ñ€ÐµÐ´Ð½ÑÑ Turnaround(Days)',0),(247246,6868,'es','Tiempo Promedio de Respuesta (DÃ­as)',0),(247247,6868,'de','Durchschnittliche Turnaround(Days)',0),(247248,6868,'en','Average Turnaround(Days)',0),(247249,6869,'is','',0),(247250,6869,'dr','Ø¨Ø¯ÙˆÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(247251,6869,'pr','Ø¨Ø¯ÙˆÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(247252,6869,'tr','E-posta adresi yok',0),(247253,6869,'pl','Bez adresu E-mail',0),(247254,6869,'bg','ÐÑÐ¼Ð° Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ',0),(247255,6869,'ur','Ú©ÙˆØ¦ÛŒ Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÛŒÚˆØ±ÛŒØ³',0),(247256,6869,'sr','ÐÐµÐ¼Ð° Ð°Ð´Ñ€ÐµÑÐµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(247257,6869,'vi','KhÃ´ng cÃ³ Ä‘á»‹a chá»‰ Email',0),(247258,6869,'af','Geen E-posadress',0),(247259,6869,'ro','Nici o adresÄƒ de E-mail',0),(247260,6869,'et','E-maili aadressi ei ole',0),(247261,6869,'si','Ne Email ogovor',0),(247262,6869,'ba','Alamat Email tidak',0),(247263,6869,'nl','Geen e-mailadres',0),(247264,6869,'fi','Ei sÃ¤hkÃ¶postiosoitetta',0),(247265,6869,'no','Ingen e-postadresse',0),(247266,6869,'da','Ingen E-mail-adresse',0),(247267,6869,'ko','ì „ìž ë©”ì¼ ì£¼ì†Œ ì—†ìŒ',0),(247268,6869,'he','××™×Ÿ ×›×ª×•×‘×ª ×“×•×\"×œ',0),(247269,6869,'el','Î”ÎµÎ½ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(247270,6869,'zh','æ²¡æœ‰ç”µå­é‚®ä»¶åœ°å€\r\n',0),(247271,6869,'sv','Ingen e-postadress',0),(247272,6869,'it','Nessun indirizzo Email',0),(247273,6869,'tl','',0),(247274,6869,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(247275,6869,'hi','à¤•à¥‹à¤ˆ à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¤¾',0),(247276,6869,'ms','Tiada alamat e-mel',0),(247277,6869,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø¹Ù†ÙˆØ§Ù† Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(247278,6869,'fr','Aucune adresse de courriel',0),(247279,6869,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(247280,6869,'pt','Nenhum endereÃ§o de E-mail',0),(247281,6869,'ru','ÐÐµÑ‚ Email ÐÐ´Ñ€ÐµÑÐ°',0),(247282,6869,'es','No Hay DireccciÃ³n de Email',0),(247283,6869,'de','Keine E-Mail-Adresse',0),(247284,6869,'en','No Email Address',0),(247285,6870,'is','',0),(247286,6870,'dr','Ù‡ÙŠÚ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(247287,6870,'pr','Ù‡ÙŠÚ† Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(247288,6870,'tr','Sigara sÃ¶zleri',0),(247289,6870,'pl','Nie podane',0),(247290,6870,'bg','ÐÐµ Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°',0),(247291,6870,'ur','ØºÛŒØ± Ú©Û’ Ø­ÙˆØ§Ù„Û’ Ø³Û’',0),(247292,6870,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½Ðµ Ð¿Ñ€ÐµÐ½Ð¾ÑÐ¸',0),(247293,6870,'vi','ChÆ°a bÃ¡o giÃ¡',0),(247294,6870,'af','Geen Gekwoteer',0),(247295,6870,'ro','Citat non',0),(247296,6870,'et','Mitte kommenteeritud',0),(247297,6870,'si','Ne kotirajo',0),(247298,6870,'ba','Dikutip bebas',0),(247299,6870,'nl','Niet genoteerd',0),(247300,6870,'fi','Ei mainittu',0),(247301,6870,'no','Ikke oppgitt',0),(247302,6870,'da','Ikke bÃ¸rsnoterede',0),(247303,6870,'ko','ë¹„ ì¸ìš©',0),(247304,6870,'he','×ž×¦×•×˜×˜ ×©××™× ×',0),(247305,6870,'el','ÎœÎ· ÎµÎ¹ÏƒÎ·Î³Î¼Î­Î½ÎµÏ‚',0),(247306,6870,'zh','éžæŠ¥ä»·\r\n',0),(247307,6870,'sv','Icke noterade',0),(247308,6870,'it','Non citato',0),(247309,6870,'tl','',0),(247310,6870,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(247311,6870,'hi','à¤—à¥ˆà¤° à¤‰à¤¦à¥à¤§à¥ƒà¤¤',0),(247312,6870,'ms','Disebut bebas',0),(247313,6870,'ar','ÙˆÙ†Ù‚Ù„Øª Ø¹Ù†',0),(247314,6870,'fr','Non citÃ©',0),(247315,6870,'jp','éžå¼•ç”¨',0),(247316,6870,'pt','NÃ£o citado',0),(247317,6870,'ru','ÐÐµ ÑƒÐºÐ°Ð·Ð°Ð½Ñ‹',0),(247318,6870,'es','No Cotizado',0),(247319,6870,'de','Nicht zitiert',0),(247320,6870,'en','Non Quoted',0),(247321,6871,'is','',0),(247322,6871,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…Ø§',0),(247323,6871,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…Ø§',0),(247324,6871,'tr','Bizim teklif',0),(247325,6871,'pl','Nasza oferta',0),(247326,6871,'bg','ÐÐ°ÑˆÐ°Ñ‚Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(247327,6871,'ur','ÛÙ…Ø§Ø±Û’ Ø§Ù‚ØªØ¨Ø§Ø³',0),(247328,6871,'sr','ÐÐ°Ð¼ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(247329,6871,'vi','BÃ¡o giÃ¡ cá»§a chÃºng tÃ´i',0),(247330,6871,'af','Ons Kwotasie',0),(247331,6871,'ro','Oferta noastra',0),(247332,6871,'et','Meie pakkumine',0),(247333,6871,'si','NaÅ¡o ponudbo',0),(247334,6871,'ba','Penawaran kami',0),(247335,6871,'nl','Onze offerte',0),(247336,6871,'fi','Tarjouksen',0),(247337,6871,'no','VÃ¥re tilbud',0),(247338,6871,'da','Vores tilbud',0),(247339,6871,'ko','ìš°ë¦¬ì˜ ê²¬ì ',0),(247340,6871,'he','×”×¦×¢×ª ×”×ž×—×™×¨ ×©×œ× ×•',0),(247341,6871,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î¼Î±Ï‚',0),(247342,6871,'zh','æˆ‘ä»¬çš„æŠ¥ä»·\r\n',0),(247343,6871,'sv','VÃ¥r offert',0),(247344,6871,'it','Il nostro preventivo',0),(247345,6871,'tl','',0),(247346,6871,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3614;&#3623;&#3585;&#3648;&#3619;&#3634;',0),(247347,6871,'hi','à¤¹à¤®à¤¾à¤°à¥€ à¤¬à¥‹à¤²à¥€',0),(247348,6871,'ms','Kami Quote',0),(247349,6871,'ar','Ø¹Ø±Ø¶Ù†Ø§ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(247350,6871,'fr','Notre devis',0),(247351,6871,'jp','ç§ã©ã‚‚ã®è¦‹ç©ã‚‚ã‚Šæ›¸',0),(247352,6871,'pt','Nossa citaÃ§Ã£o',0),(247353,6871,'ru','ÐÐ°ÑˆÐ° Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(247354,6871,'es','Nuestra CotizaciÃ³n',0),(247355,6871,'de','Unser Angebot',0),(247356,6871,'en','Our Quote',0),(247357,6872,'is','',0),(247358,6872,'dr','(Ø§Ø¬Ø²Ø§Ø¡',0),(247359,6872,'pr','Ø¨Ø¹Ù„Ø§ÙˆÙ‡ ØªØ±ÙƒÙŠØ¨ (Ø§Ø¬Ø²Ø§Ø¡',0),(247360,6872,'tr','ArtÄ± kompozisyon',0),(247361,6872,'pl','Oraz skÅ‚ad',0),(247362,6872,'bg','ÐŸÐ»ÑŽÑ ÑÑŠÑÑ‚Ð°Ð²',0),(247363,6872,'ur','Ù¾Ù„Ø³ Ø³Ø§Ø®Øª',0),(247364,6872,'sr','ÐŸÐ»ÑƒÑ ÑÐ°ÑÑ‚Ð°Ð²',0),(247365,6872,'vi','Cá»™ng thÃ nh pháº§n',0),(247366,6872,'af','Plus samestelling',0),(247367,6872,'ro','Plus compoziÅ£ia',0),(247368,6872,'et','Pluss koosseis',0),(247369,6872,'si','Plus sestava',0),(247370,6872,'ba','Ditambah komposisi',0),(247371,6872,'nl','Plus samenstelling',0),(247372,6872,'fi','Plus koostumus',0),(247373,6872,'no','Pluss sammensetning',0),(247374,6872,'da','Plus sammensÃ¦tning',0),(247375,6872,'ko','í”ŒëŸ¬ìŠ¤ êµ¬ì„±',0),(247376,6872,'he','×¤×œ×•×¡ ×”×¨×›×‘',0),(247377,6872,'el','Î£Ï…Î½ ÏƒÏÎ½Î¸ÎµÏƒÎ·',0),(247378,6872,'zh','åŠ æˆåˆ†\r\n',0),(247379,6872,'sv','Plus sammansÃ¤ttning',0),(247380,6872,'it','Oltre a composizione',0),(247381,6872,'tl','',0),(247382,6872,'th','&#3604;&#3657;&#3623;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3586;&#3638;&#3657;&#3609;',0),(247383,6872,'hi','à¤ªà¥à¤²à¤¸ à¤°à¤šà¤¨à¤¾',0),(247384,6872,'ms','Plus komposisi',0),(247385,6872,'ar','Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ ØªÙƒÙˆÙŠÙ†',0),(247386,6872,'fr','Et Composition',0),(247387,6872,'jp','ãƒ—ãƒ©ã‚¹çµ„æˆ',0),(247388,6872,'pt','AlÃ©m de composiÃ§Ã£o',0),(247389,6872,'ru','ÐŸÐ»ÑŽÑ ÑÐ¾ÑÑ‚Ð°Ð²',0),(247390,6872,'es','MÃ¡s ComposiciÃ³n',0),(247391,6872,'de','Plus Zusammensetzung',0),(247392,6872,'en','Plus Composition',0),(247393,6873,'is','',0),(247394,6873,'dr','Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ø­Ù…Ù„ ØªØ®Ù…ÙŠÙ†ÙŠ',0),(247395,6873,'pr','Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ø­Ù…Ù„ ØªØ®Ù…ÙŠÙ†ÙŠ',0),(247396,6873,'tr','ArtÄ± Est nakliye',0),(247397,6873,'pl','Plus koszty przesyÅ‚ki Est',0),(247398,6873,'bg','ÐŸÐ»ÑŽÑ Est Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(247399,6873,'ur','Ù¾Ù„Ø³ Est Ø´Ù¾Ù†Ú¯',0),(247400,6873,'sr','ÐŸÐ»ÑƒÑ Ð•ÑÑ‚ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(247401,6873,'vi','ThÃªm dá»± trá»« váº­n chuyá»ƒn',0),(247402,6873,'af','Plus Est gestuur',0),(247403,6873,'ro','Plus de transport maritim de Est',0),(247404,6873,'et','Pluss Est laevandus',0),(247405,6873,'si','Plus odprema Est',0),(247406,6873,'ba','Ditambah pengiriman Est',0),(247407,6873,'nl','Plus Est verzending',0),(247408,6873,'fi','Plus Est toimitus',0),(247409,6873,'no','Pluss Est frakt',0),(247410,6873,'da','Plus Est forsendelse',0),(247411,6873,'ko','Est ë°°ì†¡ë¹„',0),(247412,6873,'he','×‘×ª×•×¡×¤×ª ×ž×©×œ×•×— Est',0),(247413,6873,'el','Î£Ï…Î½ Ï„Î± Î­Î¾Î¿Î´Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Est',0),(247414,6873,'zh','åŠ ä¸Šé¢„è®¡è£…è¿\r\n',0),(247415,6873,'sv','Plus Est frakt',0),(247416,6873,'it','PiÃ¹ spese di spedizione Est',0),(247417,6873,'tl','',0),(247418,6873,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3610;&#3623;&#3585;',0),(247419,6873,'hi','à¤ªà¥à¤²à¤¸ Est à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(247420,6873,'ms','Plus perkapalan Est',0),(247421,6873,'ar','Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø§Ù„Ø´Ø­Ù† Est',0),(247422,6873,'fr','Frais de Port Est',0),(247423,6873,'jp','ç±³å›½æ±éƒ¨æ¨™æº–æ™‚åˆ»ã®é€æ–™ãƒ—ãƒ©ã‚¹',0),(247424,6873,'pt','Mais frete de Est',0),(247425,6873,'ru','ÐŸÐ»ÑŽÑ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Est',0),(247426,6873,'es','MÃ¡s Flete estimado',0),(247427,6873,'de','Plus Est Versand',0),(247428,6873,'en','Plus Est Shipping',0),(247429,6874,'is','',0),(247430,6874,'dr','M',0),(247431,6874,'pr','Ù‚ÙŠÙ…Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ M',0),(247432,6874,'tr','Fiyat M',0),(247433,6874,'pl','Cena M',0),(247434,6874,'bg','Ð¦ÐµÐ½Ð° Ðœ',0),(247435,6874,'ur','Ù‚ÛŒÙ…Øª M',0),(247436,6874,'sr','Ð¦ÐµÐ½Ð° Ðœ',0),(247437,6874,'vi','GiÃ¡ M',0),(247438,6874,'af','Prys M',0),(247439,6874,'ro','Pret M',0),(247440,6874,'et','Hind M',0),(247441,6874,'si','Cena M',0),(247442,6874,'ba','Harga M',0),(247443,6874,'nl','Prijs M',0),(247444,6874,'fi','Hinta M',0),(247445,6874,'no','Pris M',0),(247446,6874,'da','Pris M',0),(247447,6874,'ko','ê°€ê²© M',0),(247448,6874,'he','×ž×—×™×¨ M',0),(247449,6874,'el','Î¤Î¹Î¼Î® M',0),(247450,6874,'zh','ä»·æ ¼æ¯åƒ\r\n',0),(247451,6874,'sv','Pris M',0),(247452,6874,'it','Prezzo M',0),(247453,6874,'tl','',0),(247454,6874,'th','&#3619;&#3634;&#3588;&#3634; M',0),(247455,6874,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤®à¥€',0),(247456,6874,'ms','Harga M',0),(247457,6874,'ar','Ø§Ù„Ø³Ø¹Ø± Ù…',0),(247458,6874,'fr','Prix M',0),(247459,6874,'jp','ä¾¡æ ¼ M',0),(247460,6874,'pt','PreÃ§o M',0),(247461,6874,'ru','Ð¦ÐµÐ½Ð° Ðœ',0),(247462,6874,'es','Precio M',0),(247463,6874,'de','Preis M',0),(247464,6874,'en','Price M',0),(247465,6875,'is','',0),(247466,6875,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ù…ÙˆØ¹',0),(247467,6875,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ù…ÙˆØ¹',0),(247468,6875,'tr','Toplam baskÄ±',0),(247469,6875,'pl','Drukowania Å‚Ä…cznie',0),(247470,6875,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(247471,6875,'ur','Ú©Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(247472,6875,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(247473,6875,'vi','Tá»•ng cá»™ng in ',0),(247474,6875,'af','Druk Totaal',0),(247475,6875,'ro','Imprimare Total',0),(247476,6875,'et','Prindi kogusumma',0),(247477,6875,'si','Tiskanje skupaj',0),(247478,6875,'ba','Mencetak Total',0),(247479,6875,'nl','Totaal afdrukken',0),(247480,6875,'fi','Tulosta',0),(247481,6875,'no','Skrive ut Total',0),(247482,6875,'da','Udskrive alt',0),(247483,6875,'ko','ì´ ì¸ì‡„',0),(247484,6875,'he','×”×“×¤×¡ ×¡×”',0),(247485,6875,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(247486,6875,'zh','æ‰“å°æ€»è®¡\r\n',0),(247487,6875,'sv','Skriva ut totalt',0),(247488,6875,'it','Stampa totale',0),(247489,6875,'tl','',0),(247490,6875,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(247491,6875,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¥à¤²',0),(247492,6875,'ms','Jumlah cetakan',0),(247493,6875,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(247494,6875,'fr','Imprimer au Total',0),(247495,6875,'jp','å°åˆ·ã®åˆè¨ˆ',0),(247496,6875,'pt','ImpressÃ£o Total',0),(247497,6875,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð²ÑÐµÐ³Ð¾',0),(247498,6875,'es','Total de ImpresiÃ³n',0),(247499,6875,'de','Drucken Total',0),(247500,6875,'en','Print Total',0),(247501,6876,'is','',0),(247502,6876,'dr','Turnaround Time Ø²Ù…Ø§Ù† Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª Ø¬Ù†Ø³ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ù…Ø¬Ø¯Ø¯ Ø¢Ù†Ù‡Ø§ (Ø¨Ø±Ú¯Ø´Øª',0),(247503,6876,'pr','Turnaround Time Ø²Ù…Ø§Ù† Ø¨ÙŠÙ† Ø¯Ø±ÙŠØ§ÙØª ÙƒØ§Ù„Ø§ ØªØ§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ùˆ Ø­Ù…Ù„ Ù…Ø¬Ø¯Ø¯ Ø¢Ù†Ù‡Ø§ (Ø¨Ø±Ú¯Ø´Øª',0),(247504,6876,'tr','GerÃ§ekleÅŸtirme sÃ¼resi',0),(247505,6876,'pl','Czas realizacji',0),(247506,6876,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(247507,6876,'ur','ÙˆÙ‚Øª Ù¾ÛŒØ´',0),(247508,6876,'sr','Ð Ð¾ÐºÐ¾Ð²Ðµ',0),(247509,6876,'vi','Thá»i gian vÃ²ng quay',0),(247510,6876,'af','Omdraaityd',0),(247511,6876,'ro','Timp de rÄƒspuns',0),(247512,6876,'et','TÃ¶Ã¶tsÃ¼kkel',0),(247513,6876,'si','ÄŒas obtoka',0),(247514,6876,'ba','Waktu pengembalian',0),(247515,6876,'nl','Doorlooptijd',0),(247516,6876,'fi','LÃ¤pimenoaika',0),(247517,6876,'no','Behandlingstid',0),(247518,6876,'da','Ekspeditionstid',0),(247519,6876,'ko','ì²˜ë¦¬ ì‹œê°„',0),(247520,6876,'he','×–×ž×Ÿ ××¡×¤×§×”',0),(247521,6876,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½Î¿Ï‚ Ï‡ÏÏŒÎ½Î¿Ï‚',0),(247522,6876,'zh','å‘¨è½¬æ—¶é—´\r\n',0),(247523,6876,'sv','HandlÃ¤ggningstid',0),(247524,6876,'it','Tempo di consegna',0),(247525,6876,'tl','',0),(247526,6876,'th','&#3648;&#3623;&#3621;&#3634;&#3585;&#3634;&#3619;&#3627;&#3617;&#3640;&#3609;&#3619;&#3629;&#3610;',0),(247527,6876,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¤¾ à¤¸à¤®à¤¯',0),(247528,6876,'ms','Masa pusingan',0),(247529,6876,'ar','Ø§Ù„ÙØªØ±Ø© Ø§Ù„Ø²Ù…Ù†ÙŠØ©',0),(247530,6876,'fr','DÃ©lai d\'exÃ©cution',0),(247531,6876,'jp','ã‚¿ãƒ¼ãƒ³ã‚¢ãƒ©ã‚¦ãƒ³ãƒ‰ ã‚¿ã‚¤ãƒ ',0),(247532,6876,'pt','Tempo de retorno',0),(247533,6876,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð¾Ð±Ð¾Ñ€Ð¾Ñ‚Ð°',0),(247534,6876,'es','Tiempo de Servicio de Respuesta',0),(247535,6876,'de','Bearbeitungszeit',0),(247536,6876,'en','Turnaround Time',0),(247537,6877,'is','',0),(247538,6877,'dr','Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø¢Ø¯Ø±Ø³ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(247539,6877,'pr','Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø¢Ø¯Ø±Ø³ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(247540,6877,'tr','HayÄ±r adresi bulunamadÄ±',0),(247541,6877,'pl','Nie znaleziono z adresu',0),(247542,6877,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð¾Ñ‚ Ð°Ð´Ñ€ÐµÑ',0),(247543,6877,'ur','Ú©ÙˆØ¦ÛŒ Ù¾ØªØ§ Ù†ÛÛŒÚº Ù…Ù„Ø§ Ø³Û’',0),(247544,6877,'sr','ÐÐµ Ð¸Ð· Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° Ð°Ð´Ñ€ÐµÑÐ°',0),(247545,6877,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘á»‹a chá»‰ tá»«',0),(247546,6877,'af','Van adres nie gevind nie',0),(247547,6877,'ro','Nici o adresÄƒ de gÄƒsit',0),(247548,6877,'et','Nr aadressilt leitud',0),(247549,6877,'si','Ne iz naslova naÅ¡el',0),(247550,6877,'ba','Tidak ada dari alamat yang ditemukan',0),(247551,6877,'nl','Geen verzendadres gevonden',0),(247552,6877,'fi','N osoite lÃ¶ytyy',0),(247553,6877,'no','Ingen avsenderadresse funnet',0),(247554,6877,'da','Nej fra adressen findes',0),(247555,6877,'ko','ì£¼ì†Œì—ì„œ ë” ë°œê²¬',0),(247556,6877,'he','×œ× ×ž×Ÿ × ×ž×¦××” ×›×ª×•×‘×ª',0),(247557,6877,'el','ÎŒÏ‡Î¹ Î±Ï€ÏŒ Ï„Î·Î½ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(247558,6877,'zh','æ”¶ä»¶äººåœ°å€æ²¡æœ‰æ‰¾åˆ°\r\n',0),(247559,6877,'sv','Nej frÃ¥n adress som finns',0),(247560,6877,'it','No dall\'indirizzo trovato',0),(247561,6877,'tl','',0),(247562,6877,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3612;&#3641;&#3657;&#3626;&#3656;&#3591;',0),(247563,6877,'hi','à¤•à¥‹à¤ˆ à¤ªà¤¤à¥‡ à¤¸à¥‡ à¤ªà¤¾à¤¯à¤¾',0),(247564,6877,'ms','Bil daripada alamat yang ditemui',0),(247565,6877,'ar','Ù„Ø§ Ù…Ù† Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù†',0),(247566,6877,'fr','Pas d\'adresse trouvÃ©e',0),(247567,6877,'jp','ã‚¢ãƒ‰ãƒ¬ã‚¹ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(247568,6877,'pt','NÃ£o de endereÃ§o encontrado',0),(247569,6877,'ru','ÐÐµÑ‚ Ð¾Ñ‚ Ð°Ð´Ñ€ÐµÑÐ°',0),(247570,6877,'es','No se EncontrÃ³ DirecciÃ³n De',0),(247571,6877,'de','Nein von Adresse gefunden',0),(247572,6877,'en','No From Address Found',0),(247573,6878,'is','',0),(247574,6878,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø¢Ø¯Ø±Ø³',0),(247575,6878,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø¢Ø¯Ø±Ø³',0),(247576,6878,'tr','Adresi DÃ¼zenle',0),(247577,6878,'pl','Edytuj adres',0),(247578,6878,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚ Ð°Ð´Ñ€ÐµÑ',0),(247579,6878,'ur','Ø³Û’ Ù¾ØªØ§ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(247580,6878,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÑÐ° Ð°Ð´Ñ€ÐµÑÐµ',0),(247581,6878,'vi','Sá»­a Tá»« Äá»‹a Chá»‰',0),(247582,6878,'af','Redigeer adres van',0),(247583,6878,'ro','Editare la adresa',0),(247584,6878,'et','Redigeeri aadressi',0),(247585,6878,'si','Urejanje iz naslova',0),(247586,6878,'ba','Edit dari alamat',0),(247587,6878,'nl','Verzendadres bewerken',0),(247588,6878,'fi','Muokkaa osoite',0),(247589,6878,'no','Redigere fra adressen',0),(247590,6878,'da','Rediger fra adresse',0),(247591,6878,'ko','ì£¼ì†Œ íŽ¸ì§‘',0),(247592,6878,'he','×¢×¨×™×›×ª ×›×ª×•×‘×ª',0),(247593,6878,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Ï€ÏŒ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(247594,6878,'zh','ä»Žåœ°å€ç¼–è¾‘\r\n',0),(247595,6878,'sv','Redigera frÃ¥n adress',0),(247596,6878,'it','Modifica indirizzo',0),(247597,6878,'tl','',0),(247598,6878,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3592;&#3634;&#3585;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(247599,6878,'hi','à¤¸à¥‡ à¤ªà¤¤à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(247600,6878,'ms','Edit dari alamat',0),(247601,6878,'ar','ØªØ­Ø±ÙŠØ± Ù…Ù† Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(247602,6878,'fr','Modification de l\'adresse',0),(247603,6878,'jp','ã‚¢ãƒ‰ãƒ¬ã‚¹ã‹ã‚‰ç·¨é›†ã—ã¾ã™ã€‚',0),(247604,6878,'pt','Editar de endereÃ§o',0),(247605,6878,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡ ÐÐ´Ñ€ÐµÑÐ°',0),(247606,6878,'es','Editar DirecciÃ³n de Enviador',0),(247607,6878,'de','Bearbeiten von Adresse',0),(247608,6878,'en','Edit From Address',0),(247609,6879,'is','',0),(247610,6879,'dr','( Ù‚Ø¨ÙˆÙ„- Ø´Ù…Ø§Ø±Ù‡ Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„',0),(247611,6879,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø³Ù¾Ø§Ø³Ú¯Ø²Ø§Ø±ÙŠ( Ù‚Ø¨ÙˆÙ„- Ø´Ù…Ø§Ø±Ù‡ Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„',0),(247612,6879,'tr','E-posta bildirim',0),(247613,6879,'pl','Potwierdzenie e-mail',0),(247614,6879,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð¿Ñ€Ð¸Ð·Ð½Ð°Ð½Ð¸Ðµ',0),(247615,6879,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø¦Û’',0),(247616,6879,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(247617,6879,'vi','XÃ¡c nháº­n Email',0),(247618,6879,'af','E-pos Erkening',0),(247619,6879,'ro','Confirmare e-mail',0),(247620,6879,'et','E-post kinnitus',0),(247621,6879,'si','Potrditev email',0),(247622,6879,'ba','Email pengakuan',0),(247623,6879,'nl','E-mail bevestiging',0),(247624,6879,'fi','SÃ¤hkÃ¶postitse kuittaus',0),(247625,6879,'no','E-post bekreftelse',0),(247626,6879,'da','E-mail bekrÃ¦ftelse',0),(247627,6879,'ko','ì´ë©”ì¼ ìˆ˜ì‹  í™•ì¸',0),(247628,6879,'he','×“×•× ×œ ××™×©×•×¨',0),(247629,6879,'el','Î‘Î½Î±Î³Î½ÏŽÏÎ¹ÏƒÎ· Ï„Î¿Ï… Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(247630,6879,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€ç»™\r\n',0),(247631,6879,'sv','E-post bekrÃ¤ftelse',0),(247632,6879,'it','Conferma e-mail',0),(247633,6879,'tl','',0),(247634,6879,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3607;&#3637;&#3656;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;',0),(247635,6879,'hi','à¤ˆà¤®à¥‡à¤² à¤°à¤¸à¥€à¤¦',0),(247636,6879,'ms','Pemberitahuan e-mel',0),(247637,6879,'ar','Ø¥Ø¹Ù„Ø§Ù… Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(247638,6879,'fr','AccusÃ© de rÃ©ception de courriel',0),(247639,6879,'jp','ãƒ¡ãƒ¼ãƒ«ã‚’ç¢ºèª',0),(247640,6879,'pt','ConfirmaÃ§Ã£o de e-mail',0),(247641,6879,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(247642,6879,'es','Email Reconocimiento',0),(247643,6879,'de','E-Mail-BestÃ¤tigung',0),(247644,6879,'en','Email Acknowledgment',0),(247645,6880,'is','',0),(247646,6880,'dr','_Ø­Ù…Ù„ Ø¨Ù‡ .._',0),(247647,6880,'pr','Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ Ù‡Ù…Ø§Ù†Ù†Ø¯ Ø®Ø±ÙŠØ¯Ø§Ø± Ùˆ _Ø­Ù…Ù„ Ø¨Ù‡ .._',0),(247648,6880,'tr','Yeni sipariÅŸ aynÄ± mÃ¼ÅŸteri ve gemiye',0),(247649,6880,'pl','Nowe zamÃ³wienia samego klienta i statek',0),(247650,6880,'bg','ÐÐ¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°-ÐµÐ´Ð¸Ð½ Ð¸ ÑÑŠÑ‰ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(247651,6880,'ur','Ù†Ø¦Û’ Ø­Ú©Ù… Ø§Ø³ÛŒ Ú¯Ø§ÛÚ© Ø§ÙˆØ± Ú©Ø´ØªÛŒ Ù¾Ø±',0),(247652,6880,'sr','ÐÐ¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³-Ð¸ÑÑ‚Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð° Ð¸ Ð´Ð° Ð±Ñ€Ð¾Ð´',0),(247653,6880,'vi','ÄÆ¡n Ä‘áº·t hÃ ng má»›i-cÃ¹ng 1 khÃ¡ch hÃ ng & Ä‘á»‹a chá»‰ giao hÃ ng',0),(247654,6880,'af','Nuwe Bestellings-Dieselfde Klant/KliÃ«nt en Versend Aan',0),(247655,6880,'ro','Noua ordine-acelaÅŸi client ÅŸi nava pentru a',0),(247656,6880,'et','Uus tellimus - sama klient ja tarneaadress',0),(247657,6880,'si','Nova naloga-isto stranko in ladja',0),(247658,6880,'ba','Pelanggan sama Orde Baru dan kapal untuk',0),(247659,6880,'nl','Nieuwe Order-hetzelfde klant- en schip',0),(247660,6880,'fi','Uusi tilaus samaa asiakasta ja aluksen',0),(247661,6880,'no','Nye ordre-samme kunde- og skip',0),(247662,6880,'da','Ny ordre-samme kunde og skib',0),(247663,6880,'ko','ìƒˆë¡œìš´ ì£¼ë¬¸ ê°™ì€ ê³ ê° ë° ë°°ë¥¼',0),(247664,6880,'he','×œ×§×•×— ×ž××•×ª×• ×¡×“×¨ ×—×“×© ×•×”×›×ª×•×‘×ª ×œ×ž×©×œ×•×—',0),(247665,6880,'el','ÎÎ­Î± ÏƒÎµÎ¹ÏÎ¬-Î¯Î´Î¹Î¿ Ï€ÎµÎ»Î¬Ï„Î· ÎºÎ±Î¹ Ï„Î¿ Ï€Î»Î¿Î¯Î¿ Î½Î±',0),(247666,6880,'zh','æ–°è®¢å•-ç›¸åŒçš„å®¢æˆ·å’Œæ”¶è´§åœ°\r\n',0),(247667,6880,'sv','Ny Order-samma kund och fartyg',0),(247668,6880,'it','Nuovo ordine-stesso cliente e nave a',0),(247669,6880,'tl','',0),(247670,6880,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3619;&#3634;&#3618;&#3648;&#3604;&#3636;&#3617;&#3649;&#3621;&#3632;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;',0),(247671,6880,'hi','à¤¨à¤ à¤†à¤¦à¥‡à¤¶ à¤à¤• à¤¹à¥€ à¤—à¥à¤°à¤¾à¤¹à¤• à¤”à¤° à¤œà¤¹à¤¾à¤œ à¤•à¥‹',0),(247672,6880,'ms','Baca sama perintah yang baru dan kapal',0),(247673,6880,'ar','Ø·Ù„Ø¨ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø© - Ù†ÙØ³ Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(247674,6880,'fr','Nouveau client de mÃªme ordre et navire Ã ',0),(247675,6880,'jp','æ–°ã—ã„é †åº-åŒã˜é¡§å®¢ã¨é¡§å®¢ã¸ã®èˆ¹',0),(247676,6880,'pt','Novo ordem-mesmo cliente e navio para',0),(247677,6880,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¶Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(247678,6880,'es','Nuevo Pedido-Mismo Cliente y DestinaciÃ³n',0),(247679,6880,'de','Bestellung-gleichen Neukunde und Schiff',0),(247680,6880,'en','New Order-Same Customer and Ship To',0),(247681,6881,'is','',0),(247682,6881,'dr','Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙŠÙƒØ³Ø§Ù†',0),(247683,6881,'pr','Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙŠÙƒØ³Ø§Ù†',0),(247684,6881,'tr','AynÄ± yeni sipariÅŸ bilgisi',0),(247685,6881,'pl','Nowe zamÃ³wienia samej informacji',0),(247686,6881,'bg','ÐÐ¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑÑŠÑ‰Ð°Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(247687,6881,'ur','Ú©Û Ø§Ø³ÛŒ Ù†Ø¦ÛŒ Ø¢Ø±ÚˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(247688,6881,'sr','ÐÐ¾Ð²Ð¾ Ð½Ð°Ñ€ÐµÐ´Ð¸ Ð¸ÑÑ‚Ð¾ Ð˜Ð½Ñ„Ð¾',0),(247689,6881,'vi','ÄÆ¡n Ä‘áº·t hÃ ng má»›i cÃ¹ng thÃ´ng tin',0),(247690,6881,'af','Nuwe Bestellings Dieselfde Inligting',0),(247691,6881,'ro','Noua ordine aceleaÅŸi informaÅ£ii',0),(247692,6881,'et','Uus tellimus, sama info',0),(247693,6881,'si','Novo, da isto Info',0),(247694,6881,'ba','Baru memesan sama Info',0),(247695,6881,'nl','Nieuwe bestellen hetzelfde Info',0),(247696,6881,'fi','Uusi jÃ¤rjestys sama Info',0),(247697,6881,'no','Ny bestilling samme Info',0),(247698,6881,'da','Nye bestille samme Info',0),(247699,6881,'ko','ìƒˆë¡œìš´ ê°™ì€ ì£¼ë¬¸ ì •ë³´',0),(247700,6881,'he','×—×“×© ×œ×”×–×ž×™×Ÿ ××ª ××•×ª×• ×ž×™×“×¢',0),(247701,6881,'el','ÎÎ­Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î¯Î´Î¹Î¿ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(247702,6881,'zh','ä¿¡æ¯ç›¸åŒçš„æ–°è®¢å•\r\n',0),(247703,6881,'sv','Nytt bestÃ¤lla samma information',0),(247704,6881,'it','Nuovo ordine stesso Info',0),(247705,6881,'tl','',0),(247706,6881,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3604;&#3636;&#3617;',0),(247707,6881,'hi','à¤‰à¤¸à¥€ à¤•à¥‡ à¤¨à¤ à¤†à¤¦à¥‡à¤¶ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(247708,6881,'ms','Baru perintah sama Info',0),(247709,6881,'ar','Ø¬Ø¯ÙŠØ¯ Ù…Ù† Ø£Ø¬Ù„ Ù†ÙØ³ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(247710,6881,'fr','Nouvel ordre mÃªme Info',0),(247711,6881,'jp','æ–°ã—ã„é †åºåŒã˜æƒ…å ±',0),(247712,6881,'pt','Nova ordem mesma informaÃ§Ã£o',0),(247713,6881,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð—Ð°ÐºÐ°Ð· Ð¡ Ð¢Ð°ÐºÐ¾Ð¹ Ð˜Ð½Ñ„Ð¾',0),(247714,6881,'es','Nuevo Pedido Mismo Info',0),(247715,6881,'de','Neu bestellen Sie gleiche Info',0),(247716,6881,'en','New Order Same Info',0),(247717,6882,'is','',0),(247718,6882,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡ Ù¾Ø± ',0),(247719,6882,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡ Ù¾Ø± ',0),(247720,6882,'tr','Mkt dolu kutu baÅŸÄ±na',0),(247721,6882,'pl','IloÅ›Ä‡ w kartonie peÅ‚ne',0),(247722,6882,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° Ð¿ÑŠÐ»Ð½Ð° ÐºÑƒÑ‚Ð¸Ñ',0),(247723,6882,'ur','Ù…Ú©Ù…Ù„ Ø®Ø§Ù†Û ÙÛŒ Ù‚ÛŒ',0),(247724,6882,'sr','ÐšÐ¾Ð» Ð¿Ð¾ Ð¿ÑƒÐ½Ñƒ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ',0),(247725,6882,'vi','Sá»‘ lÆ°á»£ng má»—i há»™p Ä‘áº§y',0),(247726,6882,'af','Hoev. per Vol Boks',0),(247727,6882,'ro','Cantitate pe cutie complet',0),(247728,6882,'et','Tk tÃ¤is karbis',0),(247729,6882,'si','KoliÄina na polno Å¡katlo',0),(247730,6882,'ba','Qty per kotak penuh',0),(247731,6882,'nl','Aantal per volledige doos',0),(247732,6882,'fi','MÃ¤Ã¤rÃ¤ per koko laatikko',0),(247733,6882,'no','Antall per Full eske',0),(247734,6882,'da','Antal pr. fulde boks',0),(247735,6882,'ko','ì „ì²´ ìƒìž ë‹¹ ìˆ˜ëŸ‰',0),(247736,6882,'he','×›×ž×•×ª ×¢×‘×•×“×” ×ž×œ×',0),(247737,6882,'el','Qty Î±Î½Î¬ Ï€Î»Î®ÏÎ· ÎºÎ¿Ï…Ï„Î¯',0),(247738,6882,'zh','æ•°é‡æ¯æ»¡ç®±\r\n',0),(247739,6882,'sv','Antal per Full lÃ¥da',0),(247740,6882,'it','QtÃ  per confezione completa',0),(247741,6882,'tl','',0),(247742,6882,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3605;&#3656;&#3629;&#3585;&#3621;&#3656;&#3629;&#3591;&#3648;&#3605;&#3655;&#3617;',0),(247743,6882,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¥‚à¤°à¥à¤£ à¤¬à¥‰à¤•à¥à¤¸',0),(247744,6882,'ms','Qty satu Peti yang penuh',0),(247745,6882,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© ÙƒÙ„ Ù…Ø±Ø¨Ø¹ ÙƒØ§Ù…Ù„',0),(247746,6882,'fr','QuantitÃ© par boÃ®te pleine',0),(247747,6882,'jp','å®Œå…¨ç®±ã‚ãŸã‚Šå€‹æ•°',0),(247748,6882,'pt','Qtd. por caixa completa',0),(247749,6882,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð² Ð¿Ð¾Ð»Ð½Ñ‹Ð¹ ÑÑ‰Ð¸Ðº',0),(247750,6882,'es','Cant. por Caja Llena',0),(247751,6882,'de','Menge pro volle Schachtel',0),(247752,6882,'en','Qty per Full Box',0),(247753,6883,'is','',0),(247754,6883,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø³ÙØ§Ø±Ø´ ',0),(247755,6883,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ Ø³ÙØ§Ø±Ø´ ',0),(247756,6883,'tr','Yeni baskÄ± sipariÅŸi',0),(247757,6883,'pl','Drukuj ponownie zamÃ³wienia',0),(247758,6883,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ',0),(247759,6883,'ur','Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(247760,6883,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(247761,6883,'vi','In láº¡i ÄÆ¡n hÃ ng ',0),(247762,6883,'af','Herdruk Bestelling',0),(247763,6883,'ro','ImprimaÅ£i din nou comanda',0),(247764,6883,'et','KordustrÃ¼kk jÃ¤rjekorras',0),(247765,6883,'si','Ponatis nalog',0),(247766,6883,'ba','Order cetak ulang',0),(247767,6883,'nl','Herdruk volgorde',0),(247768,6883,'fi','Uusintapainos jÃ¤rjestyksessÃ¤',0),(247769,6883,'no','Opptrykk rekkefÃ¸lge',0),(247770,6883,'da','Genoptryk rÃ¦kkefÃ¸lge',0),(247771,6883,'ko','ë¬´ë‹¨ ì „ìž¬ ìˆœì„œ',0),(247772,6883,'he','×¡×“×¨ ×”×“×¤×¡×” ×ž×—×“×©',0),(247773,6883,'el','Î— Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î½Î±Ï„ÏÏ€Ï‰Î½',0),(247774,6883,'zh','é‡å°è®¢å•\r\n',0),(247775,6883,'sv','Nytryck ordning',0),(247776,6883,'it','Ordine di ristampa',0),(247777,6883,'tl','',0),(247778,6883,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(247779,6883,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤®',0),(247780,6883,'ms','Pencetakan semula perintah',0),(247781,6883,'ar','Ø·Ø¨Ø¹ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(247782,6883,'fr','Ordre de rÃ©impression',0),(247783,6883,'jp','å¾©åˆ»é †åº',0),(247784,6883,'pt','Ordem de reimpressÃ£o',0),(247785,6883,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·Ð°',0),(247786,6883,'es','Orden de Reimprimir',0),(247787,6883,'de','Reprint Order',0),(247788,6883,'en','Reprint Order',0),(247789,6884,'is','',0),(247790,6884,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† ',0),(247791,6884,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† ',0),(247792,6884,'tr','Alma sÄ±rasÄ±nda hata oluÅŸtu',0),(247793,6884,'pl','BÅ‚Ä…d podczas pobierania',0),(247794,6884,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ',0),(247795,6884,'ur','Ø¨Ø§Ø²ÛŒØ§ÙØª Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ',0),(247796,6884,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ',0),(247797,6884,'vi','Lá»—i khi truy váº¥n',0),(247798,6884,'af','Fout tydens onttrek',0),(247799,6884,'ro','Eroare de preluare',0),(247800,6884,'et','Too ilmnes tÃµrge',0),(247801,6884,'si','Napaka med reÅ¡itev',0),(247802,6884,'ba','Error selama mengambil',0),(247803,6884,'nl','Fout tijdens ophalen',0),(247804,6884,'fi','Virhe aikana Hae',0),(247805,6884,'no','Feil under gjenoppretting',0),(247806,6884,'da','Fejl under Hent',0),(247807,6884,'ko','ê²€ìƒ‰ ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤',0),(247808,6884,'he','×©×’×™××” ×‘×¢×ª ××—×–×•×¨',0),(247809,6884,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ·',0),(247810,6884,'zh','æ£€ç´¢è¿‡ç¨‹ä¸­å‡ºçŽ°é”™è¯¯\r\n',0),(247811,6884,'sv','Fel vid hÃ¤mtning',0),(247812,6884,'it','Errore durante il recupero',0),(247813,6884,'tl','',0),(247814,6884,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3615;&#3639;&#3657;&#3609;&#3615;&#3641;',0),(247815,6884,'hi','à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(247816,6884,'ms','Ralat semasa mendapatkan semula',0),(247817,6884,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯',0),(247818,6884,'fr','Erreur lors de la rÃ©cupÃ©ration',0),(247819,6884,'jp','å–å¾—ä¸­ã®ã‚¨ãƒ©ãƒ¼',0),(247820,6884,'pt','Erro durante a recuperaÃ§Ã£o',0),(247821,6884,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ñ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ñ',0),(247822,6884,'es','Error Durante Recuperar',0),(247823,6884,'de','Fehler beim Abrufen',0),(247824,6884,'en','Error During Retrieve',0),(247825,6885,'is','',0),(247826,6885,'dr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ø­Ù…Ù„  Ù‡Ù…Ø±Ø§Ù‡ ÙŠØ§ Ù‚Ø¨Ù„ Ø§Ø² ',0),(247827,6885,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ø­Ù…Ù„  Ù‡Ù…Ø±Ø§Ù‡ ÙŠØ§ Ù‚Ø¨Ù„ Ø§Ø² ',0),(247828,6885,'tr','Veya daha Ã¶nce gemiye tahmini',0),(247829,6885,'pl','Szacuje siÄ™, statek na lub przed',0),(247830,6885,'bg','ÐžÑ†ÐµÐ½ÑÐ²Ð° Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð° Ð½Ð° Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐ´Ð¸',0),(247831,6885,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ù¾Ø± ÛŒØ§ Ø§Ø³ Ø³Û’ Ù¾ÛÙ„Û’ Ø§Ù†Ø¯Ø§Ø²Û Ù„Ú¯Ø§ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(247832,6885,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÑƒÑ˜Ðµ ÑÐµ Ð´Ð° Ð±Ñ€Ð¾Ð´ Ð¸Ð»Ð¸ Ð¿Ñ€Ðµ',0),(247833,6885,'vi','Dá»± trÃ¹ váº­n chuyá»ƒn trÆ°á»›c hay vÃ o ngÃ y',0),(247834,6885,'af','Geskatte na Versend op of Voor',0),(247835,6885,'ro','EstimatÄƒ a navei sau Ã®nainte',0),(247836,6885,'et','Eeldatav laeva vÃµi varasem',0),(247837,6885,'si','Ocenjuje se, da ladje na ali pred',0),(247838,6885,'ba','Diperkirakan kapal pada atau sebelum',0),(247839,6885,'nl','Naar schatting schip op of vÃ³Ã³r',0),(247840,6885,'fi','Arvioitu aluksen tai ennen',0),(247841,6885,'no','AnslÃ¥tt til skipet pÃ¥ eller fÃ¸r',0),(247842,6885,'da','AnslÃ¥et til skib pÃ¥ eller fÃ¸r',0),(247843,6885,'ko','ë˜ëŠ” ê·¸ ì´ì „ì— ìš°ì£¼ì„ ìœ¼ë¡œ ì¶”ì •',0),(247844,6885,'he','×ž×¢×¨×™×›×™× ×›×™ ×”×¡×¤×™× ×” ××• ×œ×¤× ×™×•',0),(247845,6885,'el','Î•ÎºÏ„Î¹Î¼Î¬Ï„Î±Î¹ ÏŒÏ„Î¹ Ï€Î»Î¿Î¯Î¿ ÎºÎ±Ï„Î¬ Î® Ï€ÏÎ¹Î½ Î±Ï€ÏŒ',0),(247846,6885,'zh','ä¼°è®¡å‘è´§æˆ–ä¹‹å‰\r\n',0),(247847,6885,'sv','Uppskattas till fartyget pÃ¥ eller fÃ¶re',0),(247848,6885,'it','Stimato alla nave prima o',0),(247849,6885,'tl','',0),(247850,6885,'th','&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3585;&#3634;&#3619;&#3652;&#3611;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3627;&#3619;&#3639;&#3629;&#3585;&#3656;&#3629;&#3609;',0),(247851,6885,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤ªà¤° à¤¯à¤¾ à¤‰à¤¸à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤•à¤¾ à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(247852,6885,'ms','Dianggarkan kapal pada atau sebelum',0),(247853,6885,'ar','ÙˆÙŠÙ‚Ø¯Ø± Ù„Ù„Ø³ÙÙŠÙ†Ø© ÙÙŠ Ø£Ùˆ Ù‚Ø¨Ù„',0),(247854,6885,'fr','EstimÃ© Ã  expÃ©dier, l\'ou avant',0),(247855,6885,'jp','ã¾ãŸã¯å‰ã«èˆ¹ã‚’æŽ¨å®š',0),(247856,6885,'pt','Estima-se que o navio em ou antes de',0),(247857,6885,'ru','ÐŸÐ¾ Ð¾Ñ†ÐµÐ½ÐºÐ°Ð¼ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¸Ð»Ð¸ Ð´Ð¾',0),(247858,6885,'es','Estimado Enviar en o antes de',0),(247859,6885,'de','SchÃ¤tzungsweise Schiff am oder vor',0),(247860,6885,'en','Estimated to Ship on or Before',0),(247861,6886,'is','',0),(247862,6886,'dr','Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ Ø³ÙØ§Ø±Ø´',0),(247863,6886,'pr','Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ Ø³ÙØ§Ø±Ø´',0),(247864,6886,'tr','SÄ±ra bildirimi',0),(247865,6886,'pl','Potwierdzenie zamÃ³wienia',0),(247866,6886,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(247867,6886,'ur','Ù†Ø¸Ù… Ú©Ø¦Û’',0),(247868,6886,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(247869,6886,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ xÃ¡c nháº­n',0),(247870,6886,'af','Bestelling Erkening',0),(247871,6886,'ro','Confirmare comandÄƒ',0),(247872,6886,'et','Tellimuse kinnitus',0),(247873,6886,'si','Priznanje red',0),(247874,6886,'ba','Urutan pengakuan',0),(247875,6886,'nl','Bevestiging van de bestelling',0),(247876,6886,'fi','Tilauksen vahvistus',0),(247877,6886,'no','For bekreftelse',0),(247878,6886,'da','Ordre bekrÃ¦ftelse',0),(247879,6886,'ko','ì£¼ë¬¸ ìŠ¹ì¸',0),(247880,6886,'he','××™×©×•×¨ ×”×–×ž× ×”',0),(247881,6886,'el','Î£ÎµÎ¹ÏÎ¬ Î±Î½Î±Î³Î½ÏŽÏÎ¹ÏƒÎ·',0),(247882,6886,'zh','è®¢å•ç¡®è®¤\r\n',0),(247883,6886,'sv','Ordning bekrÃ¤ftelsen',0),(247884,6886,'it','Riconoscimento di ordine',0),(247885,6886,'tl','',0),(247886,6886,'th','&#3585;&#3634;&#3619;&#3649;&#3626;&#3604;&#3591;&#3623;&#3656;&#3634;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(247887,6886,'hi','à¤†à¤¦à¥‡à¤¶ à¤°à¤¸à¥€à¤¦',0),(247888,6886,'ms','Perintah pengesahan',0),(247889,6886,'ar','Ø§Ø¹ØªØ±Ø§Ù Ø§Ù„Ù†Ø¸Ø§Ù…',0),(247890,6886,'fr','AccusÃ© de rÃ©ception de commande',0),(247891,6886,'jp','æ³¨æ–‡è«‹ã‘',0),(247892,6886,'pt','ConfirmaÃ§Ã£o de ordem',0),(247893,6886,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(247894,6886,'es','Reconocimiento de Orden',0),(247895,6886,'de','AuftragsbestÃ¤tigung',0),(247896,6886,'en','Order Acknowledgment',0),(247897,6887,'is','',0),(247898,6887,'dr','Ø³ÙØ§Ø±Ø´ ÙØ¹Ø§Ù„ Ù†ÙŠØ³Øª',0),(247899,6887,'pr','Ø³ÙØ§Ø±Ø´ ÙØ¹Ø§Ù„ Ù†ÙŠØ³Øª',0),(247900,6887,'tr','DÃ¼zen bulunamadÄ±',0),(247901,6887,'pl','ZamÃ³wienia nie znaleziono',0),(247902,6887,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(247903,6887,'ur','Ø¢Ø±ÚˆØ± Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(247904,6887,'sr','ÐÐ°Ð»Ð¾Ð³ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(247905,6887,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n hÃ ng',0),(247906,6887,'af','Bestelling Nie Gevind',0),(247907,6887,'ro','Comanda nu s-a gasit',0),(247908,6887,'et','Tellimusi ei leitud',0),(247909,6887,'si','Reda, ni mogoÄe najti',0),(247910,6887,'ba','Urutan tidak ditemukan',0),(247911,6887,'nl','Volgorde niet gevonden',0),(247912,6887,'fi','Jotta ei lÃ¶ydy',0),(247913,6887,'no','Ordre ikke funnet',0),(247914,6887,'da','Ordre blev ikke fundet',0),(247915,6887,'ko','ìˆœì„œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(247916,6887,'he','×”×”×–×ž× ×” ×œ× × ×ž×¦××”',0),(247917,6887,'el','Î•Î½Ï„Î¿Î»Î® Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(247918,6887,'zh','æœªæ‰¾åˆ°è®¢å•\r\n',0),(247919,6887,'sv','Ordning hittades inte',0),(247920,6887,'it','Ordine non trovato',0),(247921,6887,'tl','',0),(247922,6887,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(247923,6887,'hi','à¤•à¥à¤°à¤® à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(247924,6887,'ms','Perintah yang tidak dijumpai',0),(247925,6887,'ar','Ø§Ù„Ø·Ù„Ø¨ÙŠØ© ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(247926,6887,'fr','Commande introuvable',0),(247927,6887,'jp','æ³¨æ–‡ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(247928,6887,'pt','Ordem nÃ£o encontrado',0),(247929,6887,'ru','Ð—Ð°ÐºÐ°Ð· ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½',0),(247930,6887,'es','No se EncontrÃ³ el Orden',0),(247931,6887,'de','Bestellung nicht gefunden',0),(247932,6887,'en','Order Not Found',0),(247933,6888,'is','',0),(247934,6888,'dr','(ÙˆØ¸ÙŠÙÙ‡) Ù…Ø§',0),(247935,6888,'pr','Ø´ØºÙ„(ÙˆØ¸ÙŠÙÙ‡) Ù…Ø§',0),(247936,6888,'tr','Bizim iÅŸimiz',0),(247937,6888,'pl','Nasza praca',0),(247938,6888,'bg','ÐÐ°ÑˆÐ°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(247939,6888,'ur','ÛÙ…Ø§Ø±Ø§ Ú©Ø§Ù…',0),(247940,6888,'sr','ÐÐ°Ñˆ Ð¿Ð¾ÑÐ°Ð¾',0),(247941,6888,'vi','Job cá»§a chÃºng tÃ´i',0),(247942,6888,'af','Ons Kontruksiewerk',0),(247943,6888,'ro','Treaba noastrÄƒ',0),(247944,6888,'et','Meie tÃ¶Ã¶',0),(247945,6888,'si','NaÅ¡e delo',0),(247946,6888,'ba','Pekerjaan kami',0),(247947,6888,'nl','Onze taak',0),(247948,6888,'fi','TehtÃ¤vÃ¤mme',0),(247949,6888,'no','VÃ¥r jobb',0),(247950,6888,'da','Vores Job',0),(247951,6888,'ko','ìš°ë¦¬ê°€ í•  ì¼',0),(247952,6888,'he','×”×¢×‘×•×“×” ×©×œ× ×•',0),(247953,6888,'el','Î”Î¿Ï…Î»ÎµÎ¹Î¬ Î¼Î±Ï‚',0),(247954,6888,'zh','æˆ‘ä»¬çš„å·¥ä½œ\r\n',0),(247955,6888,'sv','VÃ¥rt jobb',0),(247956,6888,'it','Il nostro lavoro',0),(247957,6888,'tl','',0),(247958,6888,'th','&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3623;&#3585;&#3648;&#3619;&#3634;',0),(247959,6888,'hi','à¤¹à¤®à¤¾à¤°à¤¾ à¤•à¤¾à¤®',0),(247960,6888,'ms','Kerja kami',0),(247961,6888,'ar','Ù…Ù‡Ù…ØªÙ†Ø§',0),(247962,6888,'fr','Notre mÃ©tier',0),(247963,6888,'jp','ç§ãŸã¡ã®ä»•äº‹',0),(247964,6888,'pt','Nosso trabalho',0),(247965,6888,'ru','ÐÐ°ÑˆÐ° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(247966,6888,'es','Nuestro Trabajo',0),(247967,6888,'de','Unsere Aufgabe',0),(247968,6888,'en','Our Job',0),(247969,6889,'is','',0),(247970,6889,'dr','Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ø­Ù…Ù„',0),(247971,6889,'pr','Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ø­Ù…Ù„',0),(247972,6889,'tr','ArtÄ± nakliye',0),(247973,6889,'pl','Plus koszty przesyÅ‚ki',0),(247974,6889,'bg','ÐŸÐ»ÑŽÑ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(247975,6889,'ur','Ù¾Ù„Ø³ Ø´Ù¾Ù†Ú¯',0),(247976,6889,'sr','ÐŸÐ»ÑƒÑ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(247977,6889,'vi','ThÃªm váº­n chuyá»ƒn',0),(247978,6889,'af','Plus Versending',0),(247979,6889,'ro','Plus de transport maritim',0),(247980,6889,'et','Pluss saatmiskulud',0),(247981,6889,'si','Plus odprema',0),(247982,6889,'ba','Ditambah biaya pengiriman',0),(247983,6889,'nl','Exclusief verzendkosten',0),(247984,6889,'fi','Plus postituskulut',0),(247985,6889,'no','Pluss frakt',0),(247986,6889,'da','Plus forsendelse',0),(247987,6889,'ko','ë°°ì†¡ë¹„',0),(247988,6889,'he','×‘×ª×•×¡×¤×ª ×ž×©×œ×•×—',0),(247989,6889,'el','Î£Ï…Î½ Ï„Î± Î­Î¾Î¿Î´Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(247990,6889,'zh','åŠ ä¸Šè¿è´¹\r\n',0),(247991,6889,'sv','Plus frakt',0),(247992,6889,'it','PiÃ¹ spese di spedizione',0),(247993,6889,'tl','',0),(247994,6889,'th','&#3610;&#3623;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(247995,6889,'hi','à¤ªà¥à¤²à¤¸ à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(247996,6889,'ms','Termasuk penghantaran',0),(247997,6889,'ar','Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø§Ù„Ø´Ø­Ù†',0),(247998,6889,'fr','Frais de port',0),(247999,6889,'jp','ãƒ—ãƒ©ã‚¹é€æ–™',0),(248000,6889,'pt','Mais frete',0),(248001,6889,'ru','ÐŸÐ»ÑŽÑ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(248002,6889,'es','MÃ¡s Flete',0),(248003,6889,'de','Zzgl. Versandkosten.',0),(248004,6889,'en','Plus Shipping',0),(248005,6890,'is','',0),(248006,6890,'dr','Ø§ÙŠÙ…ÙŠÙ„ ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾',0),(248007,6890,'pr','Ø§ÙŠÙ…ÙŠÙ„ ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾',0),(248008,6890,'tr','BaskÄ± sipariÅŸ onay e-posta',0),(248009,6890,'pl','Drukowanie E-mail potwierdzenie zamÃ³wienia',0),(248010,6890,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¸Ð¼ÐµÐ¹Ð»',0),(248011,6890,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¢Ø±ÚˆØ± Ú©Ø¦Û’ Ø§ÛŒ Ù…ÛŒÙ„',0),(248012,6890,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ñ€Ð¸Ð·Ð½Ð°ÑšÐµ Ð•Ð¼Ð°Ð¸Ð»',0),(248013,6890,'vi','Email xÃ¡c nháº­n Ä‘Æ¡n hÃ ng in',0),(248014,6890,'af','Druk Bestelerkenings E-pos',0),(248015,6890,'ro','Imprimare ordinea confirmare E-mail',0),(248016,6890,'et','Printimise tellimuse kinnituse e-posti',0),(248017,6890,'si','Tiskanje nalog potrditev Email',0),(248018,6890,'ba','Percetakan Order pengakuan Email',0),(248019,6890,'nl','Afdrukken Order bevestiging E-mail',0),(248020,6890,'fi','Tulostuksen tilauksen kuittauksen sÃ¤hkÃ¶postitse',0),(248021,6890,'no','Utskrift rekkefÃ¸lge bekreftelse e-post',0),(248022,6890,'da','Udskrive ordre bekrÃ¦ftelse E-mail',0),(248023,6890,'ko','ì¸ì‡„ ì£¼ë¬¸ ìŠ¹ì¸ ì´ë©”ì¼',0),(248024,6890,'he','×”×“×¤×¡×ª ×”×–×ž× ×” ×•×™×“×•×¢ ×“×•×',0),(248025,6890,'el','Email ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(248026,6890,'zh','æ‰“å°è®¢å•ç¡®è®¤ç”µå­é‚®ä»¶\r\n',0),(248027,6890,'sv','Utskrift bestÃ¤llning bekrÃ¤ftelse e-post',0),(248028,6890,'it','Email di conferma ordine stampa',0),(248029,6890,'tl','',0),(248030,6890,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3592;&#3634;&#3585;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(248031,6890,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤°à¤¸à¥€à¤¦ à¤ˆà¤®à¥‡à¤²',0),(248032,6890,'ms','Percetakan perintah pengesahan e-mel',0),(248033,6890,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø£Ù…Ø± Ø¥Ø¹Ù„Ø§Ù… Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(248034,6890,'fr','Impression ordre accusÃ© de rÃ©ception Email',0),(248035,6890,'jp','å°åˆ·æ³¨æ–‡ç¢ºèªãƒ¡ãƒ¼ãƒ«',0),(248036,6890,'pt','E-mail de confirmaÃ§Ã£o de ordem de impressÃ£o',0),(248037,6890,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð° Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(248038,6890,'es','Email de Reconocimiento de Orden de Imprenta',0),(248039,6890,'de','Drucken Auftrag BestÃ¤tigung E-Mail',0),(248040,6890,'en','Printing Order Acknowledgment Email',0),(248041,6891,'is','',0),(248042,6891,'dr','-Ø´Ù…Ø§Ø±Ù‡ Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ ( Ø³Ù¾Ø§Ø³Ú¯Ø²Ø§Ø±ÙŠ',0),(248043,6891,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† ØªØ§ÙŠÙŠØ¯-Ø´Ù…Ø§Ø±Ù‡ Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ ( Ø³Ù¾Ø§Ø³Ú¯Ø²Ø§Ø±ÙŠ',0),(248044,6891,'tr','Bildirim GÃ¶nder',0),(248045,6891,'pl','WyÅ›lij potwierdzenie',0),(248046,6891,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(248047,6891,'ur','Ú©Ø¦Û’ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(248048,6891,'sr','Ð¡Ð»Ð°ÑšÐµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð°',0),(248049,6891,'vi','Gá»­i xÃ¡c nháº­n',0),(248050,6891,'af','Stuur Erkening',0),(248051,6891,'ro','Trimite confirmare',0),(248052,6891,'et','Saada kinnitus',0),(248053,6891,'si','PoÅ¡lji potrditev',0),(248054,6891,'ba','Kirim pengakuan',0),(248055,6891,'nl','Bevestiging verzenden',0),(248056,6891,'fi','LÃ¤hetÃ¤ kuittaus',0),(248057,6891,'no','Sende bekreftelse',0),(248058,6891,'da','Send kvittering',0),(248059,6891,'ko','ìŠ¹ì¸ì„ ë³´ë‚¼í•©ë‹ˆë‹¤',0),(248060,6891,'he','×©×œ×— ××™×©×•×¨',0),(248061,6891,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Ï„Î·Î½ Î±Î½Î±Î³Î½ÏŽÏÎ¹ÏƒÎ·',0),(248062,6891,'zh','å‘é€ç¡®è®¤\r\n',0),(248063,6891,'sv','Skicka bekrÃ¤ftelse',0),(248064,6891,'it','Inviare riconoscimento',0),(248065,6891,'tl','',0),(248066,6891,'th','&#3626;&#3656;&#3591;&#3651;&#3610;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;',0),(248067,6891,'hi','à¤°à¤¸à¥€à¤¦ à¤­à¥‡à¤œà¤¨à¥‡',0),(248068,6891,'ms','Menghantar Akuan',0),(248069,6891,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¥Ù‚Ø±Ø§Ø± Ø¨Ø§Ù„Ø¥Ø¹Ù„Ø§Ù…',0),(248070,6891,'fr','Envoyer l\'accusÃ© de rÃ©ception',0),(248071,6891,'jp','å—ä¿¡ç¢ºèªã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(248072,6891,'pt','Enviar confirmaÃ§Ã£o',0),(248073,6891,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(248074,6891,'es','Enviar Reconocimiento',0),(248075,6891,'de','BestÃ¤tigung senden',0),(248076,6891,'en','Send Acknowledgment',0),(248077,6892,'is','',0),(248078,6892,'dr','Ø­Ù…Ù„ Ø¨Ù‡ ',0),(248079,6892,'pr','Ø­Ù…Ù„ Ø¨Ù‡ ',0),(248080,6892,'tr','Nakliye',0),(248081,6892,'pl','WysyÅ‚ka do',0),(248082,6892,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð¾',0),(248083,6892,'ur','Ø¬ÛØ§Ø² Ø±Ø§Ù†ÛŒ Ú©Ø±Ù†Ø§',0),(248084,6892,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð·Ð°',0),(248085,6892,'vi','Chuyá»ƒn Ä‘áº¿n',0),(248086,6892,'af','Versending Na',0),(248087,6892,'ro','De transport maritim la',0),(248088,6892,'et','Laevandus',0),(248089,6892,'si','Dostava za',0),(248090,6892,'ba','Pengiriman ke',0),(248091,6892,'nl','Verzending naar',0),(248092,6892,'fi','Toimitus',0),(248093,6892,'no','Frakt til',0),(248094,6892,'da','Forsendelse til',0),(248095,6892,'ko','ë°°ì†¡',0),(248096,6892,'he','×ž×©×œ×•×— ×œ×›×œ',0),(248097,6892,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ',0),(248098,6892,'zh','æ”¶è´§åœ°\r\n',0),(248099,6892,'sv','Frakt till',0),(248100,6892,'it','Spedizione in Italia',0),(248101,6892,'tl','',0),(248102,6892,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;',0),(248103,6892,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¥‡ à¤²à¤¿à¤',0),(248104,6892,'ms','Penghantaran ke',0),(248105,6892,'ar','Ø§Ù„Ø´Ø­Ù† Ø¥Ù„Ù‰',0),(248106,6892,'fr','Livraison Ã ',0),(248107,6892,'jp','å‡ºè·',0),(248108,6892,'pt','Frete para',0),(248109,6892,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð²',0),(248110,6892,'es','Transportando A',0),(248111,6892,'de','BefÃ¶rderung der Frachten in',0),(248112,6892,'en','Shipping To',0),(248113,6893,'is','',0),(248114,6893,'dr','. Ù…Ø§ Ø§Ø² Ø¯Ø§Ø¯Ùˆ Ø³ØªØ¯  Ø´Ù…Ø§ Ù‚Ø¯Ø±Ø¯Ø§Ù†ÙŠ Ù…ÙŠ ÙƒÙ†ÙŠÙ…',0),(248115,6893,'pr','Ø¨Ø§Ø¨Øª Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ù…ØªØ´ÙƒØ±ÙŠÙ…. Ù…Ø§ Ø§Ø² Ø¯Ø§Ø¯Ùˆ Ø³ØªØ¯  Ø´Ù…Ø§ Ù‚Ø¯Ø±Ø¯Ø§Ù†ÙŠ Ù…ÙŠ ÙƒÙ†ÙŠÙ…',0),(248116,6893,'tr','SipariÅŸiniz iÃ§in teÅŸekkÃ¼rler.  Ä°ÅŸinizi takdir ediyoruz.',0),(248117,6893,'pl','DziÄ™kujÄ™ za Twoje zamÃ³wienie.  DziÄ™kujemy firmie.',0),(248118,6893,'bg','Ð‘Ð»Ð°Ð³Ð¾Ð´Ð°Ñ€Ð¸Ð¼ Ð²Ð¸ Ð·Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°.  ÐÐ¸Ðµ Ñ†ÐµÐ½Ð¸Ð¼ Ð²Ð°ÑˆÐ¸Ñ Ð±Ð¸Ð·Ð½ÐµÑ.',0),(248119,6893,'ur','Ø¢Ù¾ Ú©Û’ Ø­Ú©Ù… Ú©Û’ Ù„Ø¦Û’ Ø¢Ù¾ Ú©Ø§ Ø´Ú©Ø±ÛŒÛ.  ÛÙ…ÛŒÚº Ø§Ù¾Ù†Û’ Ú©Ø§Ø±ÙˆØ¨Ø§Ø± Ú©ÛŒ ØªØ¹Ø±ÛŒÙ Ú©Ø±ØªÛ’ ÛÛŒÚº.',0),(248120,6893,'sr','Ð¥Ð²Ð°Ð»Ð° Ñ‚Ð¸ Ð·Ð° Ñ‚Ð²Ð¾Ñ˜ Ñ€ÐµÐ´.  Ð¦ÐµÐ½Ð¸Ð¼Ð¾ Ñ‚Ð²Ð¾Ñ˜ Ð¿Ð¾ÑÐ°Ð¾.',0),(248121,6893,'vi','CÃ¡m Æ¡n Ä‘Ã£ Ä‘áº·t hÃ ng. ChÃºng tÃ´i trÃ¢n trá»ng á»§ng há»™ cá»§a báº¡n',0),(248122,6893,'af','Dankie vir u bestelling. Ons waardeer u besigheid.',0),(248123,6893,'ro','VÄƒ mulÅ£umim pentru comanda dvs.  Apreciem afacerea ta.',0),(248124,6893,'et','TÃ¤nan teid teie tellimuse.  Me hindame oma Ã¤ri.',0),(248125,6893,'si','Hvala za vaÅ¡e naroÄilo.  Cenimo vaÅ¡e podjetje.',0),(248126,6893,'ba','Terima kasih atas pesanan Anda.  Kami menghargai bisnis Anda.',0),(248127,6893,'nl','Dank u voor uw bestelling.  Wij waarderen uw bedrijf.',0),(248128,6893,'fi','Kiitos tilauksesi.  Arvostamme liiketoimintaasi.',0),(248129,6893,'no','Takk for din bestilling.  Vi verdsette din firmaet.',0),(248130,6893,'da','Tak for din bestilling.  Vi vÃ¦rdsÃ¦tter din virksomhed.',0),(248131,6893,'ko','ì£¼ë¬¸ ì£¼ì…”ì„œ ê°ì‚¬ í•©ë‹ˆë‹¤.  ìš°ë¦¬ëŠ” ê·€í•˜ì˜ ë¹„ì¦ˆë‹ˆìŠ¤ë¥¼ ì£¼ì…”ì„œ ê°ì‚¬í•©ë‹ˆë‹¤.',0),(248132,6893,'he','×ª×•×“×” ×¢×œ ×”×–×ž× ×ª×š.  ×× ×—× ×• ×ž×¢×¨×™×›×™× ××ª ×”×¢×¡×§×™× ×©×œ×š',0),(248133,6893,'el','Î£Î±Ï‚ ÎµÏ…Ï‡Î±ÏÎ¹ÏƒÏ„ÏŽ Î³Î¹Î± Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÎ±Ï‚.  Î•ÎºÏ„Î¹Î¼Î¿ÏÎ¼Îµ Ï„Î·Î½ ÎµÏ€Î¹Ï‡ÎµÎ¯ÏÎ·ÏƒÎ® ÏƒÎ±Ï‚.',0),(248134,6893,'zh','è°¢è°¢æ‚¨çš„è®¢å•ã€‚æˆ‘ä»¬æ„Ÿè°¢æ‚¨çš„ä¸šåŠ¡ã€‚\r\n',0),(248135,6893,'sv','Tack fÃ¶r din bestÃ¤llning.  Vi uppskattar ditt fÃ¶retag.',0),(248136,6893,'it','Grazie per il vostro ordine.  Apprezziamo il vostro business.',0),(248137,6893,'tl','',0),(248138,6893,'th','&#3586;&#3629;&#3610;&#3588;&#3640;&#3603;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603; &#3648;&#3619;&#3634;&#3586;&#3629;&#3586;&#3629;&#3610;&#',0),(248139,6893,'hi','à¤†à¤ª à¤…à¤ªà¤¨à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤§à¤¨à¥à¤¯à¤µà¤¾à¤¦à¥¤  à¤¹à¤® à¤†à¤ªà¤•à¥‡ à¤µà¥à¤¯à¤µà¤¸à¤¾à¤¯ à¤•à¥€ à¤¸à¤°à¤¾à¤¹à¤¨à¤¾ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(248140,6893,'ms','Terima kasih kerana pesanan anda.  Kami menghargai perniagaan anda.',0),(248141,6893,'ar','Ø´ÙƒØ±Ø§ Ù„Ùƒ Ø¹Ù„Ù‰ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ.  ÙˆÙ†Ø­Ù† Ù†Ù‚Ø¯Ø± Ø¹Ù…Ù„Ùƒ.',0),(248142,6893,'fr','Je vous remercie pour votre commande.  Nous vous remercions de votre entreprise.',0),(248143,6893,'jp','ã”æ³¨æ–‡ã„ãŸã ãã€ã‚ã‚ŠãŒã¨ã†ã”ã–ã„ã¾ã™ã€‚ã‚ãªãŸã®ãƒ“ã‚¸ãƒã‚¹ã‚’é«˜ãè©•ä¾¡ã—ã¾ã™ã€‚',0),(248144,6893,'pt','Obrigado por sua ordem.  NÃ³s apreciamos seu negÃ³cio.',0),(248145,6893,'ru','Ð¡Ð¿Ð°ÑÐ¸Ð±Ð¾ Ð²Ð°Ð¼ Ð·Ð° Ð²Ð°Ñˆ Ð·Ð°ÐºÐ°Ð·.  ÐœÑ‹ Ñ†ÐµÐ½Ð¸Ð¼ Ð²Ð°Ñˆ Ð±Ð¸Ð·Ð½ÐµÑ.',0),(248146,6893,'es','Gracias a usted para su orden. Apreciamos su comercio',0),(248147,6893,'de','Vielen Dank fÃ¼r Ihre Bestellung.  Wir schÃ¤tzen Ihr GeschÃ¤ft.',0),(248148,6893,'en','Thank you for your order.  We appreciate your business.',0),(248149,6894,'is','',0),(248150,6894,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„ ',0),(248151,6894,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„ ',0),(248152,6894,'tr','Toplam miktar',0),(248153,6894,'pl','CaÅ‚kowita iloÅ›Ä‡',0),(248154,6894,'bg','ÐžÐ±Ñ‰Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(248155,6894,'ur','Ú©Ù„ ØªØ¹Ø¯Ø§Ø¯',0),(248156,6894,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(248157,6894,'vi','Tá»•ng cá»™ng sá»‘ lÆ°á»£ng',0),(248158,6894,'af','Totale Hoeveelheid',0),(248159,6894,'ro','Cantitatea totalÄƒ',0),(248160,6894,'et','Kogus kokku',0),(248161,6894,'si','Skupna koliÄina',0),(248162,6894,'ba','Jumlah total',0),(248163,6894,'nl','Totale hoeveelheid',0),(248164,6894,'fi','KokonaismÃ¤Ã¤rÃ¤',0),(248165,6894,'no','Totalt antall',0),(248166,6894,'da','Samlet mÃ¦ngde',0),(248167,6894,'ko','ì´ ìˆ˜ëŸ‰',0),(248168,6894,'he','×¡×” ×› ×›×ž×•×ª',0),(248169,6894,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(248170,6894,'zh','æ€»é‡\r\n',0),(248171,6894,'sv','Totala kvantitet',0),(248172,6894,'it','QuantitÃ  totale',0),(248173,6894,'tl','',0),(248174,6894,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(248175,6894,'hi','à¤•à¥à¤² à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(248176,6894,'ms','Kuantiti jumlah',0),(248177,6894,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(248178,6894,'fr','QuantitÃ© totale',0),(248179,6894,'jp','åˆè¨ˆæ•°é‡',0),(248180,6894,'pt','Quantidade total',0),(248181,6894,'ru','ÐžÐ±Ñ‰ÐµÐµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(248182,6894,'es','Cantidad Total',0),(248183,6894,'de','Gesamtmenge',0),(248184,6894,'en','Total Quantity',0),(248185,6895,'is','',0),(248186,6895,'dr','Ø±ÙˆÙŠ Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø¬Ù‡Øª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø¨Ø³ØªÙ‡ Ø®ÙˆØ¯ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(248187,6895,'pr','Ø±ÙˆÙŠ Ø´Ù…Ø§Ø±Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø¬Ù‡Øª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø¨Ø³ØªÙ‡ Ø®ÙˆØ¯ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(248188,6895,'tr','Paket izleme numarasÄ±nÄ± izlemek iÃ§in tÄ±klayÄ±n',0),(248189,6895,'pl','Kliknij na numer przesyÅ‚ki do utworu pakiet',0),(248190,6895,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€, Ð·Ð° Ð´Ð° ÑÐ»ÐµÐ´Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ Ð¿Ð°ÐºÐµÑ‚',0),(248191,6895,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ù†Ù…Ø¨Ø± Ù¹Ø±ÛŒÚ© Ú©Ø±Ù†Û’ Ù¾Ø± Ø¢Ù¾ Ú©Û’ Ù¾ÛŒÚ©ÛŒØ¬ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(248192,6895,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð±Ñ€Ð¾Ñ˜ Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ Ð½Ð° Ð¿ÑƒÑ‚Ñƒ Ð²Ð°ÑˆÐµÐ³ Ð¿Ð°ÐºÐµÑ‚Ð°',0),(248193,6895,'vi','Nháº¥n vÃ o Sá»‘ dÃ² tÃ¬m Ä‘á»ƒ tÃ¬m kiá»‡n hÃ ng cá»§a báº¡n',0),(248194,6895,'af','Kliek op Sporingsnommer om jou pakket te Op te Spoor',0),(248195,6895,'ro','FaceÅ£i clic pe numÄƒrul de urmÄƒrire pentru a urmÄƒri pachetul',0),(248196,6895,'et','Kliki pala jÃ¤litamisnumber komplekt',0),(248197,6895,'si','Kliknite na sledenje Å¡tevilko tir vaÅ¡ paket',0),(248198,6895,'ba','Klik pada nomor pelacakan untuk melacak paket Anda',0),(248199,6895,'nl','Klik op volgnummer naar Track uw pakket',0),(248200,6895,'fi','Valitse seurantanumero seurata pakettisi',0),(248201,6895,'no','Klikk pÃ¥ sporingsnummer til spor pakken',0),(248202,6895,'da','Klik pÃ¥ Tracking nummer til spor din pakke',0),(248203,6895,'ko','ê·€í•˜ì˜ íŒ¨í‚¤ì§€ ì¶”ì  ì¶”ì  ë²ˆí˜¸ë¥¼ í´ë¦­',0),(248204,6895,'he','×œ×—×¥ ×¢×œ ×ž×¡×¤×¨ ×ž×¢×§×‘ ×›×“×™ ×œ×¢×§×•×‘ ××—×¨ ×”×—×‘×™×œ×” ×©×œ×š',0),(248205,6895,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ· Î±ÏÎ¹Î¸Î¼ÏŒ ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ ÏƒÎ±Ï‚ Ï€Î±ÎºÎ­Ï„Î¿',0),(248206,6895,'zh','ç‚¹å‡»è¿½è¸ªå·ç ä»¥è¿½è¸ªæ‚¨çš„åŒ…è£¹\r\n',0),(248207,6895,'sv','Klicka pÃ¥ uppfÃ¶ljningsnummer att spÃ¥ra ditt paket',0),(248208,6895,'it','Fare clic sul numero di Tracking per pista il pacchetto',0),(248209,6895,'tl','',0),(248210,6895,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3648;&#3614;&#3639;&#3656;&#3629;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3610;&#3619;&#3619;&#3592;&#3640;&#3',0),(248211,6895,'hi','à¤…à¤ªà¤¨à¥‡ à¤ªà¥ˆà¤•à¥‡à¤œ à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤Ÿà¥à¤°à¥ˆà¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(248212,6895,'ms','Klik pada nombor Tracking ke trek pakej anda',0),(248213,6895,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„Ø­Ø²Ù…Ø© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ Ø¹Ù„Ù‰ \"Ø±Ù‚Ù… Ø§Ù„ØªØªØ¨Ø¹\" Ù„Ù„Ù…Ø³Ø§Ø±',0),(248214,6895,'fr','Cliquez sur le numÃ©ro de suivi de piste votre paquet',0),(248215,6895,'jp','ã‚ãªãŸã®ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸ã®ãƒˆãƒ©ãƒƒã‚¯ã«è¿½è·¡ç•ªå·ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(248216,6895,'pt','Clique no nÃºmero de rastreamento para a faixa de seu pacote',0),(248217,6895,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° Ñ‚Ñ€ÐµÐº Ð½Ð¾Ð¼ÐµÑ€ Ð´Ð»Ñ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð²Ð°ÑˆÐµÐ³Ð¾ Ð¿Ð°ÐºÐµÑ‚Ð°',0),(248218,6895,'es','Click sobre el NÃºmero de Seguimiento para Rastrear su Paquete',0),(248219,6895,'de','Klicken Sie auf Tracking Nummer Songtext Ihr Paket',0),(248220,6895,'en','Click on Tracking Number to Track your Package',0),(248221,6896,'is','',0),(248222,6896,'dr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ ',0),(248223,6896,'pr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ ',0),(248224,6896,'tr','Ãœzerinde sevk',0),(248225,6896,'pl','ZostaÅ‚ wysÅ‚any na',0),(248226,6896,'bg','Ð• ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð° Ð½Ð°',0),(248227,6896,'ur','Ù¾Ø± Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(248228,6896,'sr','ÐˆÐµ Ð¸Ð·Ð²Ñ€ÑˆÐµÐ½ Ð½Ð°',0),(248229,6896,'vi','ÄÃ£ váº­n chuyá»ƒn vÃ o',0),(248230,6896,'af','Is Versend Op',0),(248231,6896,'ro','A fost expediat pe',0),(248232,6896,'et','Olevat lÃ¤hetatud',0),(248233,6896,'si','Je dobavljena na',0),(248234,6896,'ba','Telah dikirimkan pada',0),(248235,6896,'nl','Is verzonden op',0),(248236,6896,'fi','On toimitettu',0),(248237,6896,'no','Er levert pÃ¥',0),(248238,6896,'da','Er blevet sendt pÃ¥',0),(248239,6896,'ko','ì— ì¶œí•˜ í•˜ ê³  ìžˆë‹¤',0),(248240,6896,'he','× ×©×œ×— ×‘-',0),(248241,6896,'el','ÎˆÏ‡ÎµÎ¹ Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯ ÏƒÏ„Î¿',0),(248242,6896,'zh','å·²è£…ä¸Š\r\n',0),(248243,6896,'sv','Har levererats pÃ¥',0),(248244,6896,'it','Ãˆ stato spedito su',0),(248245,6896,'tl','',0),(248246,6896,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(248247,6896,'hi','à¤ªà¤° à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(248248,6896,'ms','Telah dihantar pada',0),(248249,6896,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ ÙÙŠ',0),(248250,6896,'fr','A Ã©tÃ© livrÃ© sur',0),(248251,6896,'jp','ã‚’åŒæ¢±ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(248252,6896,'pt','Foi enviada em',0),(248253,6896,'ru','Ð‘Ñ‹Ð» Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½ Ð½Ð°',0),(248254,6896,'es','Ha Sido Enviado En',0),(248255,6896,'de','Hat sich auf ausgeliefert',0),(248256,6896,'en','Has Been Shipped On',0),(248257,6897,'is','',0),(248258,6897,'dr','Ø§Ø¹Ù„Ø§Ù… Ø³ÙØ§Ø±Ø´ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(248259,6897,'pr','Ø§Ø¹Ù„Ø§Ù… Ø³ÙØ§Ø±Ø´ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(248260,6897,'tr','SipariÅŸ sevkiyat bildirimi',0),(248261,6897,'pl','Powiadomienie o dostawie zamÃ³wienia',0),(248262,6897,'bg','Ð˜Ð·Ð²ÐµÑÑ‚Ð¸Ðµ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(248263,6897,'ur','ØªØ±ØªÛŒØ¨ Ú©Ú¾ÛŒÙ¾ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹',0),(248264,6897,'sr','ÐžÐ±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµ Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ†Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(248265,6897,'vi','ThÃ´ng bÃ¡o Ä‘Æ¡n hÃ ng Ä‘Ã£ chuyá»ƒn',0),(248266,6897,'af','Bestelling Versendingskennisgewing',0),(248267,6897,'ro','Notificarea de livrare comanda',0),(248268,6897,'et','Tellimuse lÃ¤hetusteatis',0),(248269,6897,'si','Obvestilo o dobavnici nalog',0),(248270,6897,'ba','Pesanan pengiriman pemberitahuan',0),(248271,6897,'nl','Volgorde verzendbericht',0),(248272,6897,'fi','Jotta toimitusilmoitus',0),(248273,6897,'no','Bestill leveringsmelding',0),(248274,6897,'da','Bestil leverancenotifikation',0),(248275,6897,'ko','ì£¼ë¬¸ ë°°ì†¡ ì•Œë¦¼',0),(248276,6897,'he','×”×–×ž× ×ª ×ž×©×œ×•×— ×”×”×•×“×¢×•×ª',0),(248277,6897,'el','ÎšÎ¿Î¹Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(248278,6897,'zh','è®¢å•å‡ºè´§é€šçŸ¥\r\n',0),(248279,6897,'sv','Ordning leveransmeddelande',0),(248280,6897,'it','Notifica di spedizione ordine',0),(248281,6897,'tl','',0),(248282,6897,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(248283,6897,'hi','à¤‘à¤°à¥à¤¡à¤° à¤ªà¥‹à¤¤à¤²à¤¦à¤¾à¤¨ à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾',0),(248284,6897,'ms','Pemberitahuan penghantaran pesanan',0),(248285,6897,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø´Ø­Ù† Ø§Ù„Ù†Ø¸Ø§Ù…',0),(248286,6897,'fr','Notification de livraison de commande',0),(248287,6897,'jp','æ³¨æ–‡ã®å‡ºè·é€šçŸ¥',0),(248288,6897,'pt','NotificaÃ§Ã£o de envio de ordem',0),(248289,6897,'ru','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð± Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(248290,6897,'es','Orden NotificaciÃ³n de EnvÃ­o',0),(248291,6897,'de','Bestellung Versand-Benachrichtigung',0),(248292,6897,'en','Order Shipment Notification',0),(248293,6898,'is','',0),(248294,6898,'dr','(ØªØ°ÙƒØ±Ø§Øª) Ø§Ø¹Ù„Ø§Ù… ',0),(248295,6898,'pr','ÙØ±Ø³ØªØ§Ø¯Ù†(ØªØ°ÙƒØ±Ø§Øª) Ø§Ø¹Ù„Ø§Ù… ',0),(248296,6898,'tr','Bildirim GÃ¶nder',0),(248297,6898,'pl','WyÅ›lij zgÅ‚oszenie',0),(248298,6898,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(248299,6898,'ur','Ø§Ø·Ù„Ø§Ø¹ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(248300,6898,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð¾Ð±Ð°Ð²Ð¸Ñ˜ÐµÑÑ‚Ð¸',0),(248301,6898,'vi','Gá»­i thÃ´ng bÃ¡o',0),(248302,6898,'af','Stuur Kennisgewing',0),(248303,6898,'ro','Trimite notificarea',0),(248304,6898,'et','Saada teade',0),(248305,6898,'si','PoÅ¡lji obvestilo',0),(248306,6898,'ba','Kirim pemberitahuan',0),(248307,6898,'nl','Melding verzenden',0),(248308,6898,'fi','LÃ¤hetÃ¤ ilmoitus',0),(248309,6898,'no','Sende melding',0),(248310,6898,'da','Send meddelelse',0),(248311,6898,'ko','ì•Œë¦¼ ë³´ë‚´ê¸°',0),(248312,6898,'he','×©×œ×— ×”×•×“×¢×”',0),(248313,6898,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚',0),(248314,6898,'zh','å‘é€é€šçŸ¥\r\n',0),(248315,6898,'sv','Skicka anmÃ¤lan',0),(248316,6898,'it','Inviare la notifica',0),(248317,6898,'tl','',0),(248318,6898,'th','&#3626;&#3656;&#3591;&#3611;&#3619;&#3632;&#3585;&#3634;&#3624;',0),(248319,6898,'hi','à¤¸à¥‚à¤šà¤¨à¤¾ à¤­à¥‡à¤œà¥‡à¤‚',0),(248320,6898,'ms','Menghantar makluman',0),(248321,6898,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¥Ø´Ø¹Ø§Ø±',0),(248322,6898,'fr','Envoyer une Notification',0),(248323,6898,'jp','é€šçŸ¥ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(248324,6898,'pt','Enviar notificaÃ§Ã£o',0),(248325,6898,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ',0),(248326,6898,'es','Enviar NotificaciÃ³n',0),(248327,6898,'de','Benachrichtigung senden',0),(248328,6898,'en','Send Notification',0),(248329,6899,'is','',0),(248330,6899,'dr','ØªØ§Ø±ÙŠØ® Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(248331,6899,'pr','ØªØ§Ø±ÙŠØ® Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(248332,6899,'tr','Sevk irsaliyesi tarihi',0),(248333,6899,'pl','Data wydania',0),(248334,6899,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(248335,6899,'ur','ØªØ±Ø³ÛŒÙ„ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(248336,6899,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(248337,6899,'vi','NgÃ y chuyá»ƒn',0),(248338,6899,'af','Besendingsdatum',0),(248339,6899,'ro','Transporturile data',0),(248340,6899,'et','Veo kuupÃ¤ev',0),(248341,6899,'si','Datum poÅ¡iljke',0),(248342,6899,'ba','Tanggal pengiriman',0),(248343,6899,'nl','Zendingen datum',0),(248344,6899,'fi','Siirtojen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(248345,6899,'no','Forsendelser dato',0),(248346,6899,'da','Forsendelser dato',0),(248347,6899,'ko','ë°°ì†¡ ë‚ ì§œ',0),(248348,6899,'he','×ª××¨×™×š ×ž×©×œ×•×—×™×',0),(248349,6899,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»ÏŽÎ½',0),(248350,6899,'zh','å‘è´§æ—¥æœŸ\r\n',0),(248351,6899,'sv','Transporter datum',0),(248352,6899,'it','Date spedizioni',0),(248353,6899,'tl','',0),(248354,6899,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(248355,6899,'hi','à¤²à¤¦à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(248356,6899,'ms','Tarikh penghantaran',0),(248357,6899,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø´Ø­Ù†',0),(248358,6899,'fr','Date d\'envois',0),(248359,6899,'jp','å‡ºè·æ—¥ä»˜',0),(248360,6899,'pt','Data de embarques',0),(248361,6899,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(248362,6899,'es','Fecha de EnvÃ­os',0),(248363,6899,'de','Versand-Datum',0),(248364,6899,'en','Shipments Date',0),(248365,6900,'is','',0),(248366,6900,'dr','Ø§Ø¹Ù„Ø§Ù… Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(248367,6900,'pr','Ø§Ø¹Ù„Ø§Ù… Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(248368,6900,'tr','Sevkiyat bildirimi',0),(248369,6900,'pl','Powiadomienie o dostawie',0),(248370,6900,'bg','Ð˜Ð·Ð²ÐµÑÑ‚Ð¸Ðµ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(248371,6900,'ur','Ú©Ú¾ÛŒÙ¾ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹',0),(248372,6900,'sr','ÐžÐ±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµ Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ†Ð¸',0),(248373,6900,'vi','ThÃ´ng bÃ¡o chuyá»ƒn hÃ ng',0),(248374,6900,'af','Besendingskennisgewings',0),(248375,6900,'ro','Notificarea de livrare',0),(248376,6900,'et','LÃ¤hetusteatis',0),(248377,6900,'si','Obvestilo o dobavnici',0),(248378,6900,'ba','Pemberitahuan pengiriman',0),(248379,6900,'nl','Verzendbericht',0),(248380,6900,'fi','Toimitusilmoitus',0),(248381,6900,'no','Melding om levering',0),(248382,6900,'da','Leverancenotifikation',0),(248383,6900,'ko','ì„ ì  í†µì§€',0),(248384,6900,'he','×ž×©×œ×•×— ×”×”×•×“×¢×•×ª',0),(248385,6900,'el','Î”ÏÎ¿Î¼Î¿Î»Î¿Î³Î·Î¸ÎµÎ¯',0),(248386,6900,'zh','è£…è¿é€šçŸ¥\r\n',0),(248387,6900,'sv','Leveransmeddelande',0),(248388,6900,'it','Notifica di spedizione',0),(248389,6900,'tl','',0),(248390,6900,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(248391,6900,'hi','à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾',0),(248392,6900,'ms','Penghantaran notis',0),(248393,6900,'ar','Ø¥Ø®Ø·Ø§Ø± Ø§Ù„Ø´Ø­Ù†',0),(248394,6900,'fr','Notification d\'expÃ©dition',0),(248395,6900,'jp','å‡ºè·é€šçŸ¥',0),(248396,6900,'pt','NotificaÃ§Ã£o de remessa',0),(248397,6900,'ru','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð± Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐµ',0),(248398,6900,'es','NotificaciÃ³n de EnvÃ­o',0),(248399,6900,'de','Versand-Benachrichtigung',0),(248400,6900,'en','Shipment Notification',0),(248401,6901,'is','',0),(248402,6901,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ù‡Ø³ØªÙ†Ø¯ ',0),(248403,6901,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ù‡Ø³ØªÙ†Ø¯ ',0),(248404,6901,'tr','Ä°zleme numaralarÄ± vardÄ±r',0),(248405,6901,'pl','Numery identyfikacyjne sÄ…',0),(248406,6901,'bg','ÐÐ¾Ð¼ÐµÑ€Ð°Ñ‚Ð° Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ ÑÐ°',0),(248407,6901,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ø´Ø¯Û Ù†Ù…Ø¨Ø± ÛÛŒÚº',0),(248408,6901,'sr','Ð¡Ñƒ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ð¸ Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ',0),(248409,6901,'vi','Sá»‘ dÃ² tÃ¬m lÃ ',0),(248410,6901,'af','Die Sporingsnommers Is',0),(248411,6901,'ro','Numerele de urmÄƒrire sunt',0),(248412,6901,'et','JÃ¤lgimise numbrid on',0),(248413,6901,'si','Å tevilke sledenja so',0),(248414,6901,'ba','Nomor pelacakan',0),(248415,6901,'nl','De volgnummers zijn',0),(248416,6901,'fi','Seurantanumerot ovat',0),(248417,6901,'no','Sporing tallene er',0),(248418,6901,'da','Sporingsnumrene er',0),(248419,6901,'ko','ì¶”ì  ë²ˆí˜¸ëŠ”',0),(248420,6901,'he','×”×ž×¡×¤×¨×™× ×ž×¢×§×‘',0),(248421,6901,'el','Î•Î¯Î½Î±Î¹ Î¿Î¹ Î±ÏÎ¹Î¸Î¼Î¿Î¯ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚',0),(248422,6901,'zh','è¿½è¸ªå·ç æ˜¯\r\n',0),(248423,6901,'sv','UppfÃ¶ljningsnumren Ã¤r',0),(248424,6901,'it','Sono i numeri di Tracking',0),(248425,6901,'tl','',0),(248426,6901,'th','&#3627;&#3617;&#3634;&#3648;&#3621;&#3586;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3588;&#3639;&#3629;',0),(248427,6901,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤¨à¤‚à¤¬à¤° à¤¹à¥ˆà¤‚',0),(248428,6901,'ms','Nombor Tracking akan',0),(248429,6901,'ar','Ø£Ø±Ù‚Ø§Ù… Ø§Ù„ØªØ¹Ù‚Ø¨',0),(248430,6901,'fr','Les numÃ©ros de suivi sont',0),(248431,6901,'jp','è¿½è·¡ç•ªå·ã¯',0),(248432,6901,'pt','SÃ£o os nÃºmeros de rastreamento',0),(248433,6901,'ru','ÐÐ¾Ð¼ÐµÑ€Ð° Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(248434,6901,'es','Los NÃºmeros de Rastreo Son',0),(248435,6901,'de','Die Trackingnummern sind',0),(248436,6901,'en','The Tracking Numbers Are',0),(248437,6902,'is','',0),(248438,6902,'dr','Ú¯Ø±ÙˆÙ‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(248439,6902,'pr','Ú¯Ø±ÙˆÙ‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(248440,6902,'tr','ParÃ§a baÅŸÄ± iÅŸ grubu',0),(248441,6902,'pl','Grupy pracy akordowej',0),(248442,6902,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ð³Ñ€ÑƒÐ¿Ð°',0),(248443,6902,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ú¯Ø±ÙˆÙ¾',0),(248444,6902,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(248445,6902,'vi','NhÃ³m lÃ m khoÃ¡n',0),(248446,6902,'af','Stukwerk Groep',0),(248447,6902,'ro','Acord grup',0),(248448,6902,'et','TÃ¼kitÃ¶Ã¶grupi',0),(248449,6902,'si','Akord skupine',0),(248450,6902,'ba','Kelompok piecework',0),(248451,6902,'nl','Stukloon groep',0),(248452,6902,'fi','UrakkaryhmÃ¤n',0),(248453,6902,'no','StykkavlÃ¸nningsgruppen',0),(248454,6902,'da','Akkordgruppe',0),(248455,6902,'ko','Piecework ê·¸ë£¹',0),(248456,6902,'he','×§×‘×•×¦×ª ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(248457,6902,'el','ÎŸÎ¼Î¬Î´Î± ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(248458,6902,'zh','è®¡ä»¶ç»„\r\n',0),(248459,6902,'sv','Ackordgruppen',0),(248460,6902,'it','Gruppo di lavoro a cottimo',0),(248461,6902,'tl','',0),(248462,6902,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3619;&#3633;&#3610;&#3591;&#3634;&#3609;&#3648;&#3611;&#3655;&#3609;&#3619;&#3634;&#3618;&#3594;&#3636;&#3657;&#3609;',0),(248463,6902,'hi','Piecework à¤¸à¤®à¥‚à¤¹',0),(248464,6902,'ms','Kumpulan piecework',0),(248465,6902,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(248466,6902,'fr','Groupe de travail Ã  la piÃ¨ce',0),(248467,6902,'jp','å‡ºæ¥é«˜æ‰•ã„ã‚°ãƒ«ãƒ¼ãƒ—',0),(248468,6902,'pt','Grupo de trabalho por tarefa',0),(248469,6902,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½ÑƒÑŽ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(248470,6902,'es','Grupo de Trabajo por Pieza',0),(248471,6902,'de','Akkordgruppe',0),(248472,6902,'en','Piecework Group',0),(248473,6903,'is','',0),(248474,6903,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø§Ø±Ø¬ÙŠ',0),(248475,6903,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø§Ø±Ø¬ÙŠ',0),(248476,6903,'tr','DÄ±ÅŸ sipariÅŸini gÃ¶ster',0),(248477,6903,'pl','PokaÅ¼ na zlecenia zewnÄ™trzne',0),(248478,6903,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð½Ð° Ð²ÑŠÐ½ÑˆÐ½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(248479,6903,'ur','Ø®Ø§Ø±Ø¬ÛŒ ØªØ±ØªÛŒØ¨ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(248480,6903,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð° ÑÐ¿Ð¾Ñ™Ð½Ð¸ Ñ€ÐµÐ´',0),(248481,6903,'vi','Thá»ƒ hiá»‡n trÃªn Ä‘Æ¡n hÃ ng ngoÃ i',0),(248482,6903,'af','Wys Op Eksterne Bestelling',0),(248483,6903,'ro','AratÄƒ comanda de externe',0),(248484,6903,'et','Kuva vÃ¤lise tellimusel',0),(248485,6903,'si','PrikaÅ¾i na zunanjih nalog',0),(248486,6903,'ba','Lihat urutan eksternal',0),(248487,6903,'nl','Toon op externe volgorde',0),(248488,6903,'fi','NÃ¤ytÃ¤ ulkoiset tilauksesta',0),(248489,6903,'no','Vis pÃ¥ ekstern rekkefÃ¸lge',0),(248490,6903,'da','Vis pÃ¥ eksterne rÃ¦kkefÃ¸lge',0),(248491,6903,'ko','ì™¸ë¶€ ìˆœì„œì— í‘œì‹œ',0),(248492,6903,'he','×”×¦×’ ×‘×”×–×ž× ×” ×—×™×¦×•× ×™×ª',0),(248493,6903,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÏ„Î·Î½ ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÎ® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(248494,6903,'zh','æ˜¾ç¤ºåœ¨å¤–éƒ¨è®¢å•\r\n',0),(248495,6903,'sv','Visa pÃ¥ yttre ordning',0),(248496,6903,'it','Visualizza ordine esterno',0),(248497,6903,'tl','',0),(248498,6903,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(248499,6903,'hi','à¤¬à¤¾à¤¹à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(248500,6903,'ms','Menunjukkan di luar perintah',0),(248501,6903,'ar','ÙˆØªØ¸Ù‡Ø± Ø¹Ù„Ù‰ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø®Ø§Ø±Ø¬ÙŠ',0),(248502,6903,'fr','Montrer sur commande externe',0),(248503,6903,'jp','å¤–éƒ¨ã®é †ã§è¡¨ç¤ºã—ã¾ã™ã€‚',0),(248504,6903,'pt','Mostrar na ordem externa',0),(248505,6903,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð’Ð¾ Ð’Ð½ÐµÑˆÐ½ÐµÐ¼ Ð—Ð°ÐºÐ°Ð·Ðµ',0),(248506,6903,'es','Mostrar En Orden External',0),(248507,6903,'de','Auf externe Bestellung anzeigen',0),(248508,6903,'en','Show On External Order',0),(248509,6904,'is','',0),(248510,6904,'dr','Ù†Ù…Ø§ÙŠØ´ Ø·Ø¨Ù‚ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø®Ø§Ø±Ø¬ÙŠ',0),(248511,6904,'pr','Ù†Ù…Ø§ÙŠØ´ Ø·Ø¨Ù‚ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø®Ø§Ø±Ø¬ÙŠ',0),(248512,6904,'tr','DÄ±ÅŸ teklifi gÃ¶ster',0),(248513,6904,'pl','PokaÅ¼ na zewnÄ™trznych cytat',0),(248514,6904,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð½Ð° Ð²ÑŠÐ½ÑˆÐ½Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(248515,6904,'ur','Ø®Ø§Ø±Ø¬ÛŒ Ø§Ù‚ØªØ¨Ø§Ø³ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(248516,6904,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð° ÑÐ¿Ð¾Ñ™Ð½Ð¸ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(248517,6904,'vi','Chá»‰ Hiá»ƒn thá»‹ bÃ¡o giÃ¡ ngoÃ i',0),(248518,6904,'af','Wys Op Eksterne Kwotasie',0),(248519,6904,'ro','AratÄƒ pe extern citat',0),(248520,6904,'et','Kuva vÃ¤lise Quote',0),(248521,6904,'si','PrikaÅ¾i na zunanjih citat',0),(248522,6904,'ba','Lihat kutipan eksternal',0),(248523,6904,'nl','Toon op externe offerte',0),(248524,6904,'fi','NÃ¤ytÃ¤ ulkoiset Quote',0),(248525,6904,'no','Vis pÃ¥ eksterne tilbud',0),(248526,6904,'da','Vis pÃ¥ eksterne tilbud',0),(248527,6904,'ko','ì™¸ë¶€ ë”°ì˜´í‘œì— í‘œì‹œ',0),(248528,6904,'he','×”×¦×’ ×‘×”×¦×¢×ª ×ž×—×™×¨ ×—×™×¦×•× ×™×ª',0),(248529,6904,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÎµ ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÎ® Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(248530,6904,'zh','æ˜¾ç¤ºåœ¨å¯¹å¤–æŠ¥ä»·\r\n',0),(248531,6904,'sv','Visa pÃ¥ externa citat',0),(248532,6904,'it','Visualizza sulla citazione esterno',0),(248533,6904,'tl','',0),(248534,6904,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3616;&#3634;&#3618;&#3609;&#3629;&#3585;',0),(248535,6904,'hi','à¤¬à¤¾à¤¹à¥à¤¯ à¤¬à¥‹à¤²à¥€ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(248536,6904,'ms','Tunjuk luar petikan',0),(248537,6904,'ar','ÙˆØªØ¸Ù‡Ø± ÙÙŠ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø®Ø§Ø±Ø¬ÙŠØ©',0),(248538,6904,'fr','Montrer sur devis externe',0),(248539,6904,'jp','å¤–éƒ¨è¦‹ç©ã‚‚ã‚Šã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(248540,6904,'pt','Mostrar na citaÃ§Ã£o externa',0),(248541,6904,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½Ð° Ð²Ð½ÐµÑˆÐ½Ð¸Ñ… Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(248542,6904,'es','Mostrar En CotizaciÃ³n External',0),(248543,6904,'de','Auf externe Angebot anzeigen',0),(248544,6904,'en','Show On External Quote',0),(248545,6905,'is','',0),(248546,6905,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø®Ù„ÙŠ',0),(248547,6905,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø®Ù„ÙŠ',0),(248548,6905,'tr','Ä°Ã§ sipariÅŸini gÃ¶ster',0),(248549,6905,'pl','PokaÅ¼ na wewnÄ™trzny porzÄ…dek',0),(248550,6905,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð½Ð° Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸Ñ Ñ€ÐµÐ´',0),(248551,6905,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ ØªØ±ØªÛŒØ¨ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(248552,6905,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð° ÑƒÐ½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐµÐ³ ÑƒÑ€ÐµÑ’ÐµÑšÐ°',0),(248553,6905,'vi','Thá»ƒ hiá»‡n trÃªn Ä‘Æ¡n hÃ ng ná»™i bá»™',0),(248554,6905,'af','Wys Op Interne Bestelling',0),(248555,6905,'ro','AratÄƒ pe comanda interna',0),(248556,6905,'et','Kuva sisemine jÃ¤rjestus',0),(248557,6905,'si','PrikaÅ¾i na notranji vrstni red',0),(248558,6905,'ba','Lihat Internal Order',0),(248559,6905,'nl','Toon op interne orde',0),(248560,6905,'fi','SisÃ¤isen jÃ¤rjestyksen nÃ¤yttÃ¤minen',0),(248561,6905,'no','Vis pÃ¥ innbyrdes rekkefÃ¸lge',0),(248562,6905,'da','Vis pÃ¥ indre orden',0),(248563,6905,'ko','ë‚´ë¶€ ìˆœì„œì— í‘œì‹œ',0),(248564,6905,'he','×”×¦×’ ×‘×”×–×ž× ×” ×¤× ×™×ž×™×ª',0),(248565,6905,'el','Î”ÎµÎ¯Î¾ÎµÎ¹ Ï„Î·Î½ ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® Ï„Î¬Î¾Î·',0),(248566,6905,'zh','æ˜¾ç¤ºåœ¨å†…éƒ¨è®¢å•\r\n',0),(248567,6905,'sv','Visa pÃ¥ inre ordning',0),(248568,6905,'it','Visualizza su ordine interno',0),(248569,6905,'tl','',0),(248570,6905,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3616;&#3634;&#3618;&#3651;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(248571,6905,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤•à¥à¤°à¤® à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(248572,6905,'ms','Tunjuk perintah dalaman',0),(248573,6905,'ar','ÙˆØªØ¸Ù‡Ø± ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠ',0),(248574,6905,'fr','Voir l\'Ã©tablissement sur l\'ordre interne',0),(248575,6905,'jp','å†…éƒ¨é †åºã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(248576,6905,'pt','Mostrar na ordem interna',0),(248577,6905,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð’Ð¾ Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÐµÐ¼ Ð—Ð°ÐºÐ°Ð·Ðµ',0),(248578,6905,'es','Mostrar En Orden Internal',0),(248579,6905,'de','Auf Innenauftrag anzeigen',0),(248580,6905,'en','Show On Internal Order',0),(248581,6906,'is','',0),(248582,6906,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¯Ø§Ø®Ù„ÙŠ',0),(248583,6906,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¯Ø§Ø®Ù„ÙŠ',0),(248584,6906,'tr','Dahili teklifi gÃ¶ster',0),(248585,6906,'pl','PokaÅ¼ na wewnÄ™trzne cytat',0),(248586,6906,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð½Ð° Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸Ñ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(248587,6906,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ø§Ù‚ØªØ¨Ø§Ø³ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(248588,6906,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð° ÑƒÐ½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(248589,6906,'vi','Chá»‰ Hiá»ƒn thá»‹ bÃ¡o giÃ¡ ná»™i bá»™',0),(248590,6906,'af','Wys Op Interne Kwotasie',0),(248591,6906,'ro','AratÄƒ pe citat interne',0),(248592,6906,'et','Kuva sisemised tsitaat',0),(248593,6906,'si','KaÅ¾ejo na notranjo ponudbo',0),(248594,6906,'ba','Lihat Internal kutipan',0),(248595,6906,'nl','Toon op interne citaat',0),(248596,6906,'fi','NÃ¤ytÃ¤ sisÃ¤iset Quote',0),(248597,6906,'no','Vis pÃ¥ interne tilbud',0),(248598,6906,'da','Vis pÃ¥ interne tilbud',0),(248599,6906,'ko','ë‚´ë¶€ ë”°ì˜´í‘œì— í‘œì‹œ',0),(248600,6906,'he','×”×¦×’ ×‘×”×¦×¢×ª ×ž×—×™×¨ ×¤× ×™×ž×™×ª',0),(248601,6906,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÎµ ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(248602,6906,'zh','æ˜¾ç¤ºåœ¨å†…éƒ¨æŠ¥ä»·\r\n',0),(248603,6906,'sv','Visa pÃ¥ inre citat',0),(248604,6906,'it','Visualizza sulla citazione interna',0),(248605,6906,'tl','',0),(248606,6906,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3616;&#3634;&#3618;&#3651;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3',0),(248607,6906,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¬à¥‹à¤²à¥€ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(248608,6906,'ms','Tunjuk Quote dalaman',0),(248609,6906,'ar','ÙˆØªØ¸Ù‡Ø± ÙÙŠ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(248610,6906,'fr','Montrer sur devis interne',0),(248611,6906,'jp','å†…éƒ¨ã®è¦‹ç©ã‚‚ã‚Šã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(248612,6906,'pt','Mostrar na citaÃ§Ã£o interna',0),(248613,6906,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½Ð° Ð²Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÐµÐ¹ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(248614,6906,'es','Mostrar En CotizaciÃ³n Internal',0),(248615,6906,'de','Auf interne Angebot anzeigen',0),(248616,6906,'en','Show On Internal Quote',0),(248617,6907,'is','',0),(248618,6907,'dr','ÙØ±Ù… ÙˆØ§Ù‚Ø¹ÙŠ',0),(248619,6907,'pr','ÙØ±Ù… ÙˆØ§Ù‚Ø¹ÙŠ',0),(248620,6907,'tr','GerÃ§ek',0),(248621,6907,'pl','Rzeczywiste z',0),(248622,6907,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ñ‚',0),(248623,6907,'ur','Ø§ØµÙ„ Ø³Û’',0),(248624,6907,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð¸ Ð¸Ð·',0),(248625,6907,'vi','Thá»±c Táº¿ Tá»«',0),(248626,6907,'af','Werklik Vanaf',0),(248627,6907,'ro','Actual de la',0),(248628,6907,'et','Tegeliku',0),(248629,6907,'si','Dejansko iz',0),(248630,6907,'ba','Aktual dari',0),(248631,6907,'nl','Werkelijke van',0),(248632,6907,'fi','Toteutuneet',0),(248633,6907,'no','Faktisk',0),(248634,6907,'da','Selve fra',0),(248635,6907,'ko','ì‹¤ì œ',0),(248636,6907,'he','×‘×¤×•×¢×œ ×ž',0),(248637,6907,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® Î±Ï€ÏŒ',0),(248638,6907,'zh','ä»Žå®žé™…\r\n',0),(248639,6907,'sv','Faktiska frÃ¥n',0),(248640,6907,'it','Effettivo da',0),(248641,6907,'tl','',0),(248642,6907,'th','&#3607;&#3637;&#3656;&#3617;&#3634;&#3605;&#3634;&#3617;&#3592;&#3619;&#3636;&#3591;',0),(248643,6907,'hi','à¤¸à¥‡ à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤•',0),(248644,6907,'ms','Sebenar dari',0),(248645,6907,'ar','Ø§Ù„ÙØ¹Ù„ÙŠØ© Ù…Ù†',0),(248646,6907,'fr','De rÃ©elles\r\n',0),(248647,6907,'jp','å®Ÿéš›ã‹ã‚‰',0),(248648,6907,'pt','Real de',0),(248649,6907,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ñ… Ð¾Ñ‚',0),(248650,6907,'es','Actual Desde',0),(248651,6907,'de','Vom tatsÃ¤chlichen',0),(248652,6907,'en','Actual From',0),(248653,6908,'is','',0),(248654,6908,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ù¾ÙŠØ´ ÙØ±Ø¶  Ø§Ø² ',0),(248655,6908,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ù¾ÙŠØ´ ÙØ±Ø¶  Ø§Ø² ',0),(248656,6908,'tr','VarsayÄ±lan mÃ¼ÅŸteriden',0),(248657,6908,'pl','DomyÅ›lnie klient z',0),(248658,6908,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¾Ñ‚',0),(248659,6908,'ur','Ø·Û’ Ø´Ø¯Û Ú¯Ø§ÛÚ© Ø³Û’',0),(248660,6908,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð·',0),(248661,6908,'vi','KhÃ¡ch hÃ ng Máº·c Ä‘á»‹nh tá»«',0),(248662,6908,'af','Verstekte KliÃ«nt / Klant Vanaf',0),(248663,6908,'ro','Client implicit de',0),(248664,6908,'et','Vaikimisi kliendi jaoks',0),(248665,6908,'si','Privzetega kupca iz',0),(248666,6908,'ba','Default pelanggan dari',0),(248667,6908,'nl','Standaard klant van',0),(248668,6908,'fi','Oletuksena asiakasta',0),(248669,6908,'no','Standard kunde fra',0),(248670,6908,'da','Standardkunde fra',0),(248671,6908,'ko','ê¸°ë³¸ ê³ ê°',0),(248672,6908,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×”×œ×§×•×— ×ž×Ÿ',0),(248673,6908,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Ï€ÎµÎ»Î¬Ï„Î· Î±Ï€ÏŒ',0),(248674,6908,'zh','é»˜è®¤å®¢æˆ·ä»Ž\r\n',0),(248675,6908,'sv','Standardkund frÃ¥n',0),(248676,6908,'it','Cliente predefinito da',0),(248677,6908,'tl','',0),(248678,6908,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3592;&#3634;&#3585;',0),(248679,6908,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤°à¥‚à¤ª à¤¸à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(248680,6908,'ms','Pelanggan lalai daripada',0),(248681,6908,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù…Ù†',0),(248682,6908,'fr','Client par dÃ©faut de',0),(248683,6908,'jp','æ—¢å®šã®é¡§å®¢ã‹ã‚‰',0),(248684,6908,'pt','Cliente padrÃ£o de',0),(248685,6908,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¾Ñ‚',0),(248686,6908,'es','Cliente por Defecto De',0),(248687,6908,'de','Standard-Kunden aus',0),(248688,6908,'en','Default Customer From',0),(248689,6909,'is','',0),(248690,6909,'dr','Ø§Ø² Ø¢Ø¯Ø±Ø³',0),(248691,6909,'pr','Ø§Ø² Ø¢Ø¯Ø±Ø³',0),(248692,6909,'tr','Kimden adresi',0),(248693,6909,'pl','Z adresu',0),(248694,6909,'bg','ÐžÑ‚ Ð°Ð´Ñ€ÐµÑ',0),(248695,6909,'ur','Ù¾ØªÛ’ Ø³Û’',0),(248696,6909,'sr','Ð¡Ð° Ð°Ð´Ñ€ÐµÑÐµ',0),(248697,6909,'vi','Tá»« Ä‘á»‹a chá»‰',0),(248698,6909,'af','Vanaf Adres',0),(248699,6909,'ro','La adresa',0),(248700,6909,'et','Aadressilt',0),(248701,6909,'si','Iz naslova',0),(248702,6909,'ba','Dari alamat',0),(248703,6909,'nl','Verzendadres',0),(248704,6909,'fi','Osoite',0),(248705,6909,'no','Fra adresse',0),(248706,6909,'da','Fra adresse',0),(248707,6909,'ko','ì£¼ì†Œì—ì„œ',0),(248708,6909,'he','×ž×›×ª×•×‘×ª',0),(248709,6909,'el','Î‘Ï€ÏŒ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(248710,6909,'zh','ä»Žåœ°å€\r\n',0),(248711,6909,'sv','FrÃ¥n adress',0),(248712,6909,'it','Dall\'indirizzo',0),(248713,6909,'tl','',0),(248714,6909,'th','&#3592;&#3634;&#3585;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(248715,6909,'hi','à¤ªà¤¤à¥‡ à¤¸à¥‡',0),(248716,6909,'ms','Daripada alamat',0),(248717,6909,'ar','Ù…Ù† Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(248718,6909,'fr','De l\'adresse',0),(248719,6909,'jp','ã‚¢ãƒ‰ãƒ¬ã‚¹ã‹ã‚‰',0),(248720,6909,'pt','De endereÃ§o',0),(248721,6909,'ru','Ð¡ ÐÐ´Ñ€ÐµÑÐ°',0),(248722,6909,'es','De la DirecciÃ³n',0),(248723,6909,'de','Von Adresse',0),(248724,6909,'en','From Address',0),(248725,6910,'is','',0),(248726,6910,'dr','Ø§Ø² Ø´Ù‡Ø± ',0),(248727,6910,'pr','Ø§Ø² Ø´Ù‡Ø± ',0),(248728,6910,'tr','Åžehirden',0),(248729,6910,'pl','Z miasta',0),(248730,6910,'bg','ÐžÑ‚ Ð³Ñ€Ð°Ð´',0),(248731,6910,'ur','Ø´ÛØ± Ø³Û’',0),(248732,6910,'sr','Ð˜Ð· Ð³Ñ€Ð°Ð´Ð°',0),(248733,6910,'vi','Tá»« thÃ nh phá»‘',0),(248734,6910,'af','Vanaf Dorp/Stad',0),(248735,6910,'ro','La City',0),(248736,6910,'et','Linnast',0),(248737,6910,'si','Iz mesta',0),(248738,6910,'ba','Dari kota',0),(248739,6910,'nl','Uit stad',0),(248740,6910,'fi','City',0),(248741,6910,'no','Fra byen',0),(248742,6910,'da','Fra byen',0),(248743,6910,'ko','ë„ì‹œì—ì„œ',0),(248744,6910,'he','×ž×¢×™×¨',0),(248745,6910,'el','Î‘Ï€ÏŒ Ï„Î·Î½ Ï€ÏŒÎ»Î·',0),(248746,6910,'zh','ä»Žå¸‚\r\n',0),(248747,6910,'sv','FrÃ¥n City',0),(248748,6910,'it','Da cittÃ ',0),(248749,6910,'tl','',0),(248750,6910,'th','&#3592;&#3634;&#3585;&#3648;&#3617;&#3639;&#3629;&#3591;',0),(248751,6910,'hi','à¤¶à¤¹à¤° à¤¸à¥‡',0),(248752,6910,'ms','Dari bandar',0),(248753,6910,'ar','Ù…Ù† Ù…Ø¯ÙŠÙ†Ø©',0),(248754,6910,'fr','De la ville',0),(248755,6910,'jp','å¸‚å†…ã‹ã‚‰',0),(248756,6910,'pt','Da cidade',0),(248757,6910,'ru','Ð˜Ð· Ð“Ð¾Ñ€Ð¾Ð´Ð°',0),(248758,6910,'es','Desde la Ciudad',0),(248759,6910,'de','Von der Stadt',0),(248760,6910,'en','From City',0),(248761,6911,'is','',0),(248762,6911,'dr','Ø§Ø² Ù†Ø§Ù… ',0),(248763,6911,'pr','Ø§Ø² Ù†Ø§Ù… ',0),(248764,6911,'tr','AdÄ±ndan',0),(248765,6911,'pl','Od nazwy',0),(248766,6911,'bg','ÐžÑ‚ Ð¸Ð¼Ðµ',0),(248767,6911,'ur','Ù†Ø§Ù… Ø³Û’',0),(248768,6911,'sr','Ð˜Ð· Ð¸Ð¼ÐµÐ½Ð°',0),(248769,6911,'vi','Tá»« tÃªn',0),(248770,6911,'af','Vanaf Naam',0),(248771,6911,'ro','Din numele',0),(248772,6911,'et','Nimi:',0),(248773,6911,'si','Iz imena',0),(248774,6911,'ba','Dari nama',0),(248775,6911,'nl','Van naam',0),(248776,6911,'fi','Nimi',0),(248777,6911,'no','Fra navn',0),(248778,6911,'da','Fra navn',0),(248779,6911,'ko','ì´ë¦„ì—ì„œ',0),(248780,6911,'he','×ž×©×',0),(248781,6911,'el','Î‘Ï€ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(248782,6911,'zh','ä»Žåç§°\r\n',0),(248783,6911,'sv','FrÃ¥n namn',0),(248784,6911,'it','Dal nome',0),(248785,6911,'tl','',0),(248786,6911,'th','&#3592;&#3634;&#3585;&#3594;&#3639;&#3656;&#3629;',0),(248787,6911,'hi','à¤¨à¤¾à¤® à¤¸à¥‡',0),(248788,6911,'ms','Dari nama',0),(248789,6911,'ar','Ù…Ù† Ø§Ù„Ø§Ø³Ù…',0),(248790,6911,'fr','De nom',0),(248791,6911,'jp','åå‰ã‹ã‚‰',0),(248792,6911,'pt','De nome',0),(248793,6911,'ru','ÐžÑ‚ Ð¸Ð¼ÐµÐ½Ð¸',0),(248794,6911,'es','Del Nombre',0),(248795,6911,'de','Von Namen',0),(248796,6911,'en','From Name',0),(248797,6912,'is','',0),(248798,6912,'dr','Ø§Ø² Ø§Ø³ØªØ§Ù† ',0),(248799,6912,'pr','Ø§Ø² Ø§Ø³ØªØ§Ù† ',0),(248800,6912,'tr','Devletten',0),(248801,6912,'pl','Od PaÅ„stwa',0),(248802,6912,'bg','ÐžÑ‚ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°Ñ‚Ð°',0),(248803,6912,'ur','Ø±ÛŒØ§Ø³Øª Ø³Û’',0),(248804,6912,'sr','Ð˜Ð· ÑÑ‚Ð°ÑšÐ°',0),(248805,6912,'vi','Tá»« tiá»ƒu bang',0),(248806,6912,'af','Vanaf Staat (Landsgebied)',0),(248807,6912,'ro','La stat',0),(248808,6912,'et','Riigilt',0),(248809,6912,'si','Iz drÅ¾ave',0),(248810,6912,'ba','Dari negara',0),(248811,6912,'nl','Uit staat',0),(248812,6912,'fi','Valtion',0),(248813,6912,'no','Fra staten',0),(248814,6912,'da','Fra staten',0),(248815,6912,'ko','ìƒíƒœì—ì„œ',0),(248816,6912,'he','×ž×ž×¦×‘',0),(248817,6912,'el','Î‘Ï€ÏŒ Ï„Î¿ Î¼Î­Î»Î¿Ï‚',0),(248818,6912,'zh','ä»Žå·ž\r\n',0),(248819,6912,'sv','FrÃ¥n staten',0),(248820,6912,'it','Dallo stato',0),(248821,6912,'tl','',0),(248822,6912,'th','&#3592;&#3634;&#3585;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(248823,6912,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¸à¥‡',0),(248824,6912,'ms','Dari Negeri',0),(248825,6912,'ar','Ù…Ù† Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(248826,6912,'fr','De l\'Ã‰tat',0),(248827,6912,'jp','çŠ¶æ…‹ã‹ã‚‰',0),(248828,6912,'pt','Do estado',0),(248829,6912,'ru','ÐžÑ‚ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð°',0),(248830,6912,'es','De Estado',0),(248831,6912,'de','Vom Zustand',0),(248832,6912,'en','From State',0),(248833,6913,'is','',0),(248834,6913,'dr','(ÙØ´Ø±Ø¯Ù‡- Ú©ÙˆØ¯Ù¾Ø³ØªÙŠ',0),(248835,6913,'pr','Ø§Ø² ÙØ§ÙŠÙ„ Ø²ÙŠÙ¾ (ÙØ´Ø±Ø¯Ù‡- ÙƒØ¯Ù¾Ø³ØªÙŠ',0),(248836,6913,'tr','Zip',0),(248837,6913,'pl','Z Zip',0),(248838,6913,'bg','ÐžÑ‚ Ñ†Ð¸Ð¿',0),(248839,6913,'ur','Ø²Ù¾ Ø³Û’',0),(248840,6913,'sr','Ð˜Ð· Ð—Ð¸Ð¿',0),(248841,6913,'vi','Tá»« Zip',0),(248842,6913,'af','Vanaf Poskode',0),(248843,6913,'ro','La Zip',0),(248844,6913,'et','ZIP',0),(248845,6913,'si','Iz Zip',0),(248846,6913,'ba','Dari Zip',0),(248847,6913,'nl','Van Zip',0),(248848,6913,'fi','Zip',0),(248849,6913,'no','Fra Zip',0),(248850,6913,'da','Fra Zip',0),(248851,6913,'ko','ìš°íŽ¸ ë²ˆí˜¸ì—ì„œ',0),(248852,6913,'he','×ž- Zip',0),(248853,6913,'el','Î‘Ï€ÏŒ Zip',0),(248854,6913,'zh','ä»Žé‚®ç¼–\r\n',0),(248855,6913,'sv','FrÃ¥n Zip',0),(248856,6913,'it','Da Zip',0),(248857,6913,'tl','',0),(248858,6913,'th','&#3592;&#3634;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3610;&#3637;&#3610;&#3629;&#3633;&#3604;',0),(248859,6913,'hi','à¤œà¤¼à¤¿à¤ª à¤¸à¥‡',0),(248860,6913,'ms','Dari Zip',0),(248861,6913,'ar','Ù…Ù† Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(248862,6913,'fr','Zip',0),(248863,6913,'jp','Zip ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰',0),(248864,6913,'pt','De Zip',0),(248865,6913,'ru','Ð˜Ð· Zip',0),(248866,6913,'es','Del CÃ³digo Postal',0),(248867,6913,'de','Von Zip',0),(248868,6913,'en','From Zip',0),(248869,6914,'is','',0),(248870,6914,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„ Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(248871,6914,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„ Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(248872,6914,'tr','GeÃ§ersiz iÅŸ numarasÄ±',0),(248873,6914,'pl','NieprawidÅ‚owe zadanie numer',0),(248874,6914,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(248875,6914,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ú©Ø§Ù… Ù†Ù…Ø¨Ø±',0),(248876,6914,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(248877,6914,'vi','Sá»‘ Job vÃ´ hiá»‡u',0),(248878,6914,'af','Ongeldige Werkstuknommer',0),(248879,6914,'ro','NumÄƒr invalid Job',0),(248880,6914,'et','Sobimatu tÃ¶Ã¶ Number',0),(248881,6914,'si','Å tevilka neveljavna projekta',0),(248882,6914,'ba','Nomer tidak valid pekerjaan',0),(248883,6914,'nl','Ongeldige projectnummer',0),(248884,6914,'fi','Virheellinen projektinumero',0),(248885,6914,'no','Ugyldig jobbnummer',0),(248886,6914,'da','Ugyldig jobnummer',0),(248887,6914,'ko','ìž˜ëª» ëœ ìž‘ì—… ë²ˆí˜¸',0),(248888,6914,'he','×ž×¡×¤×¨ ×œ× ×—×•×§×™ ×”×¢×‘×•×“×”',0),(248889,6914,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ·',0),(248890,6914,'zh','æ— æ•ˆçš„èŒä½ç¼–å·\r\n',0),(248891,6914,'sv','Ogiltig jobbnummer',0),(248892,6914,'it','Numero di lavoro valido',0),(248893,6914,'tl','',0),(248894,6914,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3591;&#3634;&#3609;&#3651;&#3594;&#3657;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;',0),(248895,6914,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(248896,6914,'ms','Jumlah pekerjaan yang tidak sah',0),(248897,6914,'ar','Ø±Ù‚Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ© ØºÙŠØ± ØµØ§Ù„Ø­Ø©',0),(248898,6914,'fr','NumÃ©ro d\'emploi non valide',0),(248899,6914,'jp','ç„¡åŠ¹ãªã‚¸ãƒ§ãƒ–ç•ªå·',0),(248900,6914,'pt','NÃºmero invÃ¡lido de emprego',0),(248901,6914,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(248902,6914,'es','InvÃ¡lido NÃºmero de Trabajo',0),(248903,6914,'de','UngÃ¼ltige Jobnummer',0),(248904,6914,'en','Invalid Job Number',0),(248905,6915,'is','',0),(248906,6915,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§',0),(248907,6915,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§',0),(248908,6915,'tr','VarsayÄ±lanlarÄ± kullan',0),(248909,6915,'pl','UÅ¼yj ustawieÅ„ domyÅ›lnych',0),(248910,6915,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸Ñ‚Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(248911,6915,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(248912,6915,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð·Ð°Ð´Ð°Ð½Ð¾',0),(248913,6915,'vi','DÃ¹ng máº·c Ä‘á»‹nh',0),(248914,6915,'af','Gebruik verstek',0),(248915,6915,'ro','UtilizaÅ£i setÄƒrile implicite',0),(248916,6915,'et','Kasuta vaikesÃ¤tteid',0),(248917,6915,'si','Uporabi privzete nastavitve',0),(248918,6915,'ba','Gunakan default',0),(248919,6915,'nl','Standaardwaarden gebruiken',0),(248920,6915,'fi','KÃ¤ytÃ¤ oletusarvoja',0),(248921,6915,'no','Bruk standard',0),(248922,6915,'da','Brug standardindstillinger',0),(248923,6915,'ko','ê¸°ë³¸ê°’ì„ ì‚¬ìš© í•˜ ì—¬',0),(248924,6915,'he','×”×©×ª×ž×© ×‘×‘×¨×™×¨×•×ª ×ž×—×“×œ',0),(248925,6915,'el','Î§ÏÎ®ÏƒÎ· Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(248926,6915,'zh','ä½¿ç”¨é»˜è®¤å€¼\r\n',0),(248927,6915,'sv','AnvÃ¤nd fÃ¶rval',0),(248928,6915,'it','Utilizzare le impostazioni predefinite',0),(248929,6915,'tl','',0),(248930,6915,'th','&#3651;&#3594;&#3657;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(248931,6915,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(248932,6915,'ms','Guna lalai',0),(248933,6915,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(248934,6915,'fr','Utilisez les valeurs par dÃ©faut',0),(248935,6915,'jp','æ—¢å®šå€¤ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(248936,6915,'pt','Usar padrÃµes',0),(248937,6915,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(248938,6915,'es','Usar Predeterminados',0),(248939,6915,'de','Standardwerte verwenden',0),(248940,6915,'en','Use Defaults',0),(248941,6916,'is','',0),(248942,6916,'dr','ØªØºÙŠÙŠØ± Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡',0),(248943,6916,'pr','ØªØºÙŠÙŠØ± Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡',0),(248944,6916,'tr','Kutu baÅŸÄ±na Mkt. DeÄŸiÅŸtir',0),(248945,6916,'pl','ZmieniÄ‡ iloÅ›Ä‡ w kartonie',0),(248946,6916,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° ÐºÑƒÑ‚Ð¸Ñ',0),(248947,6916,'ur','Ø®Ø§Ù†Û ÙÛŒ Ù‚ÛŒ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(248948,6916,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ ÐšÐ¾Ð». Ð¿Ð¾ ÐºÑƒÑ‚Ð¸Ñ˜Ð¸',0),(248949,6916,'vi','Thay Ä‘á»•i sá»‘ lÆ°á»£ng má»—i há»™p',0),(248950,6916,'af','Verander Hoev. Per Boks',0),(248951,6916,'ro','Modificare cantitate pe cutie',0),(248952,6916,'et','Muuda tk karbis',0),(248953,6916,'si','Spremeni kol na Å¡katlo',0),(248954,6916,'ba','Mengubah Qty Per kotak',0),(248955,6916,'nl','Wijzigen van aantal Per doos',0),(248956,6916,'fi','Muuta mÃ¤Ã¤rÃ¤ Per laatikko',0),(248957,6916,'no','Endre antall Per boks',0),(248958,6916,'da','Ã†ndre antal pr. kasse',0),(248959,6916,'ko','ìƒìž ë‹¹ ìˆ˜ëŸ‰ ë³€ê²½',0),(248960,6916,'he','×©×™× ×•×™ ×›×ž×•×ª ×œ××¨×’×–',0),(248961,6916,'el','Î‘Î»Î»Î±Î³Î® Qty Î±Î½Î¬ ÎºÎ¹Î²ÏŽÏ„Î¹Î¿',0),(248962,6916,'zh','æ¯ç›’æ•°é‡å˜åŒ–\r\n',0),(248963,6916,'sv','Ã„ndra antal Per lÃ¥da',0),(248964,6916,'it','Cambiare Qty Per scatola',0),(248965,6916,'tl','',0),(248966,6916,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3605;&#3656;&#3629;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(248967,6916,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤¬à¥‰à¤•à¥à¤¸',0),(248968,6916,'ms','Menukar Qty satu Peti',0),(248969,6916,'ar','ØªØºÙŠÙŠØ± Ø§Ù„ÙƒÙ…ÙŠØ© ÙƒÙ„ Ù…Ø±Ø¨Ø¹',0),(248970,6916,'fr','Modifier la quantitÃ© par boÃ®te',0),(248971,6916,'jp','ç®±ã‚ãŸã‚Šå€‹æ•°ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(248972,6916,'pt','Alterar Qtd. por caixa',0),(248973,6916,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐšÐ¾Ð»-Ð²Ð¾ Ð’ ÐšÐ¾Ñ€Ð¾Ð±ÐºÐµ',0),(248974,6916,'es','Cambiar Cantidad por Caja',0),(248975,6916,'de','Ã„ndern der Menge pro Karton',0),(248976,6916,'en','Change Qty Per Box',0),(248977,6917,'is','',0),(248978,6917,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡ ',0),(248979,6917,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡ ',0),(248980,6917,'tr','Kutu baÅŸÄ±na miktar',0),(248981,6917,'pl','IloÅ›Ä‡ w kartonie',0),(248982,6917,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° ÐºÑƒÑ‚Ð¸Ñ',0),(248983,6917,'ur','Ø®Ø§Ù†Û ÙÛŒ Ù‚ÛŒ',0),(248984,6917,'sr','ÐšÐ¾Ð» Ð¿Ð¾ ÐºÑƒÑ‚Ð¸Ñ˜Ð¸',0),(248985,6917,'vi','Sá»‘ lÆ°á»£ng má»—i há»™p',0),(248986,6917,'af','Hoev. per Boks',0),(248987,6917,'ro','Cantitate pe cutie',0),(248988,6917,'et','Tk karbis',0),(248989,6917,'si','KoliÄina v kartonu',0),(248990,6917,'ba','Qty per kotak',0),(248991,6917,'nl','Aantal per doos',0),(248992,6917,'fi','MÃ¤Ã¤rÃ¤ per laatikko',0),(248993,6917,'no','Antall per boks',0),(248994,6917,'da','Antal pr. kasse',0),(248995,6917,'ko','ìƒìž ë‹¹ ìˆ˜ëŸ‰',0),(248996,6917,'he','×›×ž×•×ª ×œ××¨×’×–',0),(248997,6917,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Î½Î¬ ÎºÎ¿Ï…Ï„Î¯',0),(248998,6917,'zh','æ¯ç›’æ•°é‡\r\n',0),(248999,6917,'sv','Antal per lÃ¥da',0),(249000,6917,'it','Qty per scatola',0),(249001,6917,'tl','',0),(249002,6917,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3605;&#3656;&#3629;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(249003,6917,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤¬à¥‰à¤•à¥à¤¸',0),(249004,6917,'ms','Qty satu Peti',0),(249005,6917,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© ÙƒÙ„ Ù…Ø±Ø¨Ø¹',0),(249006,6917,'fr','QuantitÃ© par boÃ®te',0),(249007,6917,'jp','ç®±ã‚ãŸã‚Šå€‹æ•°',0),(249008,6917,'pt','Qtd. por caixa',0),(249009,6917,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð² ÐºÐ¾Ñ€Ð¾Ð±ÐºÐµ',0),(249010,6917,'es','Cant. por Caja',0),(249011,6917,'de','Menge pro Karton',0),(249012,6917,'en','Qty per Box',0),(249013,6918,'is','',0),(249014,6918,'dr','Ø­Ø°Ù Ø§ÙŠÙ†  Ø³ÙØ§Ø±Ø´ ',0),(249015,6918,'pr','Ø­Ø°Ù Ø§ÙŠÙ†  Ø³ÙØ§Ø±Ø´ ',0),(249016,6918,'tr','Bu sipariÅŸi sil',0),(249017,6918,'pl','UsuÅ„ ten porzÄ…dek',0),(249018,6918,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(249019,6918,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(249020,6918,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ñ€ÐµÐ´',0),(249021,6918,'vi','XÃ³a ÄÆ¡n Äáº·t HÃ ng nÃ y',0),(249022,6918,'af','Skrap hierdie Bestelling',0),(249023,6918,'ro','ÅžtergeÅ£i aceastÄƒ comandÄƒ',0),(249024,6918,'et','Kustuta selles jÃ¤rjekorras',0),(249025,6918,'si','IzbriÅ¡ete ta nalog',0),(249026,6918,'ba','Menghapus pesanan ini',0),(249027,6918,'nl','Deze Order verwijderen',0),(249028,6918,'fi','Poistaa luokan',0),(249029,6918,'no','Slette denne rekkefÃ¸lgen',0),(249030,6918,'da','Slet denne rÃ¦kkefÃ¸lge',0),(249031,6918,'ko','ì´ ìˆœì„œë¥¼ ì‚­ì œ',0),(249032,6918,'he','×ž×—×™×§×ª ×”×–×ž× ×” ×–×•',0),(249033,6918,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(249034,6918,'zh','åˆ é™¤è¿™æ¡å‘½ä»¤\r\n',0),(249035,6918,'sv','Ta bort denna ordning',0),(249036,6918,'it','Eliminare questo ordine',0),(249037,6918,'tl','',0),(249038,6918,'th','&#3621;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;',0),(249039,6918,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(249040,6918,'ms','Padam Perintah ini',0),(249041,6918,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(249042,6918,'fr','Pour supprimer cette commande',0),(249043,6918,'jp','ã“ã®æ³¨æ–‡ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(249044,6918,'pt','Excluir esta ordem',0),(249045,6918,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ð¹ Ð—Ð°ÐºÐ°Ð·',0),(249046,6918,'es','Eliminar este Orden',0),(249047,6918,'de','Dieser Auftrag lÃ¶schen',0),(249048,6918,'en','Delete This Order',0),(249049,6919,'is','',0),(249050,6919,'dr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(249051,6919,'pr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(249052,6919,'tr','EST sevk tarihi',0),(249053,6919,'pl','Data wysyÅ‚ki Est',0),(249054,6919,'bg','EST ÐºÐ¾Ñ€Ð°Ð±Ð° Ð´Ð°Ñ‚Ð°',0),(249055,6919,'ur','Est Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(249056,6919,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ðµ ÐµÑÑ‚',0),(249057,6919,'vi','Dá»± trÃ¹ ngÃ y váº­n chuyá»ƒn ',0),(249058,6919,'af','Est skip datum',0),(249059,6919,'ro','DatÄƒ navÄƒ de Est',0),(249060,6919,'et','Hinnanguline tarnekuupÃ¤ev',0),(249061,6919,'si','EST ladja datum',0),(249062,6919,'ba','Est kapal tanggal',0),(249063,6919,'nl','Est verzenddatum',0),(249064,6919,'fi','Est lÃ¤hetyspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(249065,6919,'no','EST forsendelsesdato',0),(249066,6919,'da','EST afsendelsesdato',0),(249067,6919,'ko','Est ë°°ì†¡ì¼',0),(249068,6919,'he','×ª××¨×™×š ×ž×©×œ×•×— Est',0),(249069,6919,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ EST',0),(249070,6919,'zh','é¢„è®¡äº¤è´§æ—¥æœŸ\r\n',0),(249071,6919,'sv','Est transportdatum',0),(249072,6919,'it','Data di spedizione est',0),(249073,6919,'tl','',0),(249074,6919,'th','&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;',0),(249075,6919,'hi','Est à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(249076,6919,'ms','Tarikh kapal Est',0),(249077,6919,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø³ÙÙŠÙ†Ø© Est',0),(249078,6919,'fr','Date d\'expÃ©dition est',0),(249079,6919,'jp','äºˆå®šå‡ºè·æ—¥',0),(249080,6919,'pt','Data de envio do est',0),(249081,6919,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸ EST',0),(249082,6919,'es','Est Fecha de EnvÃ­o',0),(249083,6919,'de','EST Lieferdatum',0),(249084,6919,'en','Est Ship Date',0),(249085,6920,'is','',0),(249086,6920,'dr','Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ Ø³ÙØ§Ø±Ø´ ',0),(249087,6920,'pr','Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ Ø³ÙØ§Ø±Ø´ ',0),(249088,6920,'tr','SipariÅŸ Ackn',0),(249089,6920,'pl','ZamÃ³wienia Ackn',0),(249090,6920,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ackn',0),(249091,6920,'ur','Ø¢Ø±ÚˆØ± Ø§Ú©Ú©Ù†',0),(249092,6920,'sr','ÐÐ°Ð»Ð¾Ð³ ÐÑ†ÐºÐ½',0),(249093,6920,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ xÃ¡c nháº­n',0),(249094,6920,'af','Bestelling Erkening',0),(249095,6920,'ro','Ordinul Ackn',0),(249096,6920,'et','Tellimuse Ackn',0),(249097,6920,'si','Vrstni red Ackn',0),(249098,6920,'ba','Urutan Ackn',0),(249099,6920,'nl','Orde Ackn',0),(249100,6920,'fi','Tilauksen Ackn',0),(249101,6920,'no','Bestille Ackn',0),(249102,6920,'da','Bestil Ackn',0),(249103,6920,'ko','ì£¼ë¬¸ Ackn',0),(249104,6920,'he','Ackn ×”×¡×“×¨',0),(249105,6920,'el','Î£ÎµÎ¹ÏÎ¬ Ackn',0),(249106,6920,'zh','è®¢å•ç¡®è®¤\r\n',0),(249107,6920,'sv','Ordning kvit',0),(249108,6920,'it','Conferme di ordine',0),(249109,6920,'tl','',0),(249110,6920,'th','&#3585;&#3634;&#3619;&#3649;&#3626;&#3604;&#3591;&#3623;&#3656;&#3634;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(249111,6920,'hi','à¤•à¥à¤°à¤® Ackn',0),(249112,6920,'ms','Perintah Ackn',0),(249113,6920,'ar','ØªØ±ØªÙŠØ¨ Ø£ÙƒÙ†',0),(249114,6920,'fr','Ordre Ackn',0),(249115,6920,'jp','æ³¨æ–‡ã”äº†æ‰¿',0),(249116,6920,'pt','Ordem Ackn',0),(249117,6920,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ackn',0),(249118,6920,'es','Recon. de Orden',0),(249119,6920,'de','Ordnung Ackn',0),(249120,6920,'en','Order Ackn',0),(249121,6921,'is','',0),(249122,6921,'dr','(ØªØ§ÙŠÙŠØ¯) Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ ÙØ±Ù…Ø§ÛŒØ´ ',0),(249123,6921,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡(ØªØ§ÙŠÙŠØ¯) Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ Ø³ÙØ§Ø±Ø´ ',0),(249124,6921,'tr','SÄ±ra bildirimi gÃ¶nder',0),(249125,6921,'pl','WyÅ›lij potwierdzenie zamÃ³wienia',0),(249126,6921,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(249127,6921,'ur','Ù†Ø¸Ù… Ú©Ø¦Û’ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(249128,6921,'sr','Ð¡Ð»Ð°ÑšÐµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(249129,6921,'vi','Gá»­i xÃ¡c nháº­n Ä‘Æ¡n hÃ ng',0),(249130,6921,'af','Stuur Bestellingserkening',0),(249131,6921,'ro','Trimite comanda confirmare',0),(249132,6921,'et','Saada Tellimuse kinnitus',0),(249133,6921,'si','PoÅ¡lji potrditev naloga',0),(249134,6921,'ba','Mengirim pesanan pengakuan',0),(249135,6921,'nl','Order bevestiging verzenden',0),(249136,6921,'fi','LÃ¤hetÃ¤ tilauksen vahvistus',0),(249137,6921,'no','Sende ordren bekreftelse',0),(249138,6921,'da','Send ordre bekrÃ¦ftelse',0),(249139,6921,'ko','ì£¼ë¬¸ ìŠ¹ì¸ì„ ë³´ë‚¼í•©ë‹ˆë‹¤',0),(249140,6921,'he','×©×œ×— ××™×©×•×¨ ×”×–×ž× ×”',0),(249141,6921,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î±Î½Î±Î³Î½ÏŽÏÎ¹ÏƒÎ·',0),(249142,6921,'zh','å‘é€è®¢å•ç¡®è®¤\r\n',0),(249143,6921,'sv','Skicka Order bekrÃ¤ftelse',0),(249144,6921,'it','Inviare ordine riconoscimento',0),(249145,6921,'tl','',0),(249146,6921,'th','&#3626;&#3656;&#3591;&#3651;&#3610;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(249147,6921,'hi','à¤†à¤¦à¥‡à¤¶ à¤°à¤¸à¥€à¤¦ à¤­à¥‡à¤œ',0),(249148,6921,'ms','Hantar pengesahan pesanan',0),(249149,6921,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¥Ø¹Ù„Ø§Ù… ØªØ±ØªÙŠØ¨',0),(249150,6921,'fr','Envoyer l\'accusÃ© de rÃ©ception de commande',0),(249151,6921,'jp','æ³¨æ–‡ã®å—ä¿¡ç¢ºèªã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(249152,6921,'pt','Enviar confirmaÃ§Ã£o de ordem',0),(249153,6921,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(249154,6921,'es','Enviar Orden de Reconocimiento',0),(249155,6921,'de','AuftragsbestÃ¤tigung senden',0),(249156,6921,'en','Send Order Acknowledgment',0),(249157,6922,'is','',0),(249158,6922,'dr','ÙƒÙ¾ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(249159,6922,'pr','ÙƒÙ¾ÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(249160,6922,'tr','AlÄ±ntÄ± Kopyala',0),(249161,6922,'pl','SkopiowaÄ‡ cytat',0),(249162,6922,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(249163,6922,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(249164,6922,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(249165,6922,'vi','Sao chÃ©p bÃ¡o giÃ¡',0),(249166,6922,'af','Kopieer aanhaling',0),(249167,6922,'ro','Copia citat',0),(249168,6922,'et','Kopeerige tsitaat',0),(249169,6922,'si','Ulitek citat',0),(249170,6922,'ba','Menyalin kutipan',0),(249171,6922,'nl','Offerte kopiÃ«ren',0),(249172,6922,'fi','Kopioi tarjous',0),(249173,6922,'no','Kopiere tilbud',0),(249174,6922,'da','Kopiere tilbud',0),(249175,6922,'ko','ê²¬ì ì„ ë³µì‚¬',0),(249176,6922,'he','×§×™×‘×œ×ª×™ ×”×¦×¢×ª ×ž×—×™×¨',0),(249177,6922,'el','Î‘Î½Ï„Î¹Î³ÏÎ¬ÏˆÏ„Îµ Ï„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(249178,6922,'zh','å¤åˆ¶æŠ¥ä»·\r\n',0),(249179,6922,'sv','Kopiera offert',0),(249180,6922,'it','Copiare la citazione',0),(249181,6922,'tl','',0),(249182,6922,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(249183,6922,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(249184,6922,'ms','Menyalin petikan',0),(249185,6922,'ar','Ù†Ø³Ø® Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(249186,6922,'fr','Copiez la citation',0),(249187,6922,'jp','å¼•ç”¨ã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(249188,6922,'pt','Copiar a citaÃ§Ã£o',0),(249189,6922,'ru','Ð¡ÐºÐ¾Ð¿Ð¸Ñ€ÑƒÐ¹Ñ‚Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñƒ',0),(249190,6922,'es','Copiar CotizaciÃ³n',0),(249191,6922,'de','Zitat kopieren',0),(249192,6922,'en','Copy Quote',0),(249193,6923,'is','',0),(249194,6923,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø´ØºÙ„',0),(249195,6923,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø´ØºÙ„',0),(249196,6923,'tr','Ä°ÅŸi DÃ¼zenle',0),(249197,6923,'pl','EdytowaÄ‡ zadania',0),(249198,6923,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(249199,6923,'ur','Ú©Ø§Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(249200,6923,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð·Ð°Ð´Ð°Ñ‚ÐºÐ°',0),(249201,6923,'vi','Sá»­a Job',0),(249202,6923,'af','Redigeer Werkstuk',0),(249203,6923,'ro','Editare Job',0),(249204,6923,'et','Saate redigeerida tÃ¶Ã¶d',0),(249205,6923,'si','Urejanje delovnih mest',0),(249206,6923,'ba','Mengedit pekerjaan',0),(249207,6923,'nl','Job bewerken',0),(249208,6923,'fi','Muokkaa tyÃ¶tÃ¤',0),(249209,6923,'no','Redigere jobb',0),(249210,6923,'da','Redigere Job',0),(249211,6923,'ko','ìž‘ì—… íŽ¸ì§‘',0),(249212,6923,'he','×¢×¨×•×š ×¢×‘×•×“×”',0),(249213,6923,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(249214,6923,'zh','ç¼–è¾‘å·¥ä½œ\r\n',0),(249215,6923,'sv','Redigera jobb',0),(249216,6923,'it','Modifica lavoro',0),(249217,6923,'tl','',0),(249218,6923,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3591;&#3634;&#3609;',0),(249219,6923,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(249220,6923,'ms','Edit kerja',0),(249221,6923,'ar','ØªØ­Ø±ÙŠØ± Ù…Ù‡Ù…Ø©',0),(249222,6923,'fr','Modifier le travail',0),(249223,6923,'jp','ã‚¸ãƒ§ãƒ–ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(249224,6923,'pt','Editar trabalho',0),(249225,6923,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(249226,6923,'es','Editar Trabajo',0),(249227,6923,'de','Auftrag bearbeiten',0),(249228,6923,'en','Edit Job',0),(249229,6924,'is','',0),(249230,6924,'dr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ ÙŠØ§ ÙƒÙ¾ÙŠ Ø´ØºÙ„',0),(249231,6924,'pr','Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ ÙŠØ§ ÙƒÙ¾ÙŠ Ø´ØºÙ„',0),(249232,6924,'tr','Yeni baskÄ± veya kopyalama iÅŸini',0),(249233,6924,'pl','Przedruk lub kopiowanie pracy',0),(249234,6924,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð¸Ð»Ð¸ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ',0),(249235,6924,'ur','Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ ÛŒØ§ Ù†Ù‚Ù„ Ú©Ø§Ù…',0),(249236,6924,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¸Ð»Ð¸ ÐºÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾ÑÐ»Ð°',0),(249237,6924,'vi','In láº¡i hay copy Job',0),(249238,6924,'af','Herdruk of KopiÃ«er Werkstuk',0),(249239,6924,'ro','ImprimaÅ£i sau copie Job',0),(249240,6924,'et','KordustrÃ¼kk vÃµi koopia tÃ¶Ã¶koht',0),(249241,6924,'si','Ponatis ali kopiranje',0),(249242,6924,'ba','Cetak ulang atau Copy pekerjaan',0),(249243,6924,'nl','Herdruk of kopie baan',0),(249244,6924,'fi','Tulosta tai Kopioi projekti',0),(249245,6924,'no','Nytt eller kopieringsjobber',0),(249246,6924,'da','Genoptryk eller kopieringsjob',0),(249247,6924,'ko','ë¬´ë‹¨ ì „ìž¬ ë˜ëŠ” ë³µì‚¬ ìž‘ì—…',0),(249248,6924,'he','×”×“×¤×¡×” ×ž×—×“×© ××• ×”×¢×ª×§ ××ª ×”×¢×‘×•×“×”',0),(249249,6924,'el','Î‘Î½Î±Ï„ÏÏ€Ï‰ÏƒÎ· Î® Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(249250,6924,'zh','é‡å°æˆ–å¤åˆ¶å·¥ä½œ\r\n',0),(249251,6924,'sv','Nytryck eller kopieringsjobb',0),(249252,6924,'it','Ristampa o copia lavoro',0),(249253,6924,'tl','',0),(249254,6924,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;&#3627;&#3619;&#3639;&#3629;&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3591;&#3634;&#3609;',0),(249255,6924,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£ à¤¯à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¨à¥Œà¤•à¤°à¥€',0),(249256,6924,'ms','Dicetak semula atau salinan kerja',0),(249257,6924,'ar','Ø·Ø¨Ø¹ Ø£Ùˆ Ù†Ø³Ø® Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(249258,6924,'fr','RÃ©impression ou travail de copie',0),(249259,6924,'jp','å¾©åˆ»ç‰ˆã¾ãŸã¯ã‚³ãƒ”ãƒ¼ ãƒ» ã‚¸ãƒ§ãƒ–',0),(249260,6924,'pt','ReproduÃ§Ã£o ou trabalho de cÃ³pia',0),(249261,6924,'ru','ÐŸÐµÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚ÐºÐ° Ð¸Ð»Ð¸ ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(249262,6924,'es','Reimprimir O Copiar el Trabajo',0),(249263,6924,'de','Nachdruck oder Kopierauftrag',0),(249264,6924,'en','Reprint Or Copy Job',0),(249265,6925,'is','',0),(249266,6925,'dr','(ØªØ§ÙŠÙŠØ¯) Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(249267,6925,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡(ØªØ§ÙŠÙŠØ¯) Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(249268,6925,'tr','Sevkiyat bildirimi gÃ¶nder',0),(249269,6925,'pl','WyÅ›lij potwierdzenie wysyÅ‚ki',0),(249270,6925,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ñ€Ð°Ñ‚ÐºÐ°Ñ‚Ð°',0),(249271,6925,'ur','Ú©Ú¾ÛŒÙ¾ Ú©Ø¦Û’ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(249272,6925,'sr','Ð¡Ð»Ð°ÑšÐµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(249273,6925,'vi','Gá»­i xÃ¡c nháº­n chuyáº¿n hÃ ng',0),(249274,6925,'af','Stuur Versendingserkening',0),(249275,6925,'ro','Trimite confirmare de livrare',0),(249276,6925,'et','Saada saadetis kinnitus',0),(249277,6925,'si','PoÅ¡lji potrditev poÅ¡iljke',0),(249278,6925,'ba','Kirim pengiriman pengakuan',0),(249279,6925,'nl','Verzending bevestiging verzenden',0),(249280,6925,'fi','LÃ¤hetÃ¤ lÃ¤hetyksen vahvistus',0),(249281,6925,'no','Send levering bekreftelse',0),(249282,6925,'da','Send forsendelse kvittering',0),(249283,6925,'ko','ì„ ì  ìŠ¹ì¸ì„ ë³´ë‚¼í•©ë‹ˆë‹¤',0),(249284,6925,'he','×©×œ×— ××™×©×•×¨ ×”×ž×©×œ×•×—',0),(249285,6925,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(249286,6925,'zh','å‘é€å‘è´§ç¡®è®¤\r\n',0),(249287,6925,'sv','Skicka leverans bekrÃ¤ftelse',0),(249288,6925,'it','Inviare la conferma di spedizione',0),(249289,6925,'tl','',0),(249290,6925,'th','&#3626;&#3656;&#3591;&#3651;&#3610;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(249291,6925,'hi','à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤ªà¤¾à¤µà¤¤à¥€ à¤­à¥‡à¤œà¥‡à¤‚',0),(249292,6925,'ms','Menghantar Akuan penghantaran',0),(249293,6925,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø´Ø­Ù†Ø© Ø§Ù„Ø¥Ù‚Ø±Ø§Ø± Ø¨Ø§Ù„Ø¥Ø¹Ù„Ø§Ù…',0),(249294,6925,'fr','Envoyer l\'accusÃ© de rÃ©ception expÃ©dition',0),(249295,6925,'jp','å‡ºè·ç¢ºèªã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(249296,6925,'pt','Enviar confirmaÃ§Ã£o de embarque',0),(249297,6925,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(249298,6925,'es','Enviar Reconocimiento de EnvÃ­o',0),(249299,6925,'de','Versand BestÃ¤tigung senden',0),(249300,6925,'en','Send Shipment Acknowledgment',0),(249301,6926,'is','',0),(249302,6926,'dr','ØªØ§ÙŠÙŠØ¯ Ø­Ù…Ù„',0),(249303,6926,'pr','ØªØ§ÙŠÙŠØ¯ Ø­Ù…Ù„',0),(249304,6926,'tr','Gemi Ackn',0),(249305,6926,'pl','Statek Ackn',0),(249306,6926,'bg','ÐšÐ¾Ñ€Ð°Ð± Ackn',0),(249307,6926,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ø§Ú©Ú©Ù†',0),(249308,6926,'sr','ÐÑ†ÐºÐ½ Ð±Ñ€Ð¾Ð´',0),(249309,6926,'vi','XÃ¡c nháº­n váº­n chuyá»ƒn ',0),(249310,6926,'af','Versend Erkening',0),(249311,6926,'ro','NavÄƒ Ackn',0),(249312,6926,'et','Laeva Ackn',0),(249313,6926,'si','Ackn ladja',0),(249314,6926,'ba','Kapal Ackn',0),(249315,6926,'nl','Schip Ackn',0),(249316,6926,'fi','Aluksen Ackn',0),(249317,6926,'no','Sende Ackn',0),(249318,6926,'da','Skibet Ackn',0),(249319,6926,'ko','ë°° Ackn',0),(249320,6926,'he','×”×¡×¤×™× ×” Ackn',0),(249321,6926,'el','Ackn Ï€Î»Î¿Î¯Î¿',0),(249322,6926,'zh','åŒæ„è¿é€\r\n',0),(249323,6926,'sv','Fartyget kvit',0),(249324,6926,'it','Conferme di nave',0),(249325,6926,'tl','',0),(249326,6926,'th','&#3651;&#3610;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(249327,6926,'hi','à¤œà¤¹à¤¾à¤œ Ackn',0),(249328,6926,'ms','Kapal Ackn',0),(249329,6926,'ar','Ø£ÙƒÙ† Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(249330,6926,'fr','Navire Ackn',0),(249331,6926,'jp','èˆ¹ã”äº†æ‰¿',0),(249332,6926,'pt','Navio Ackn',0),(249333,6926,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ackn',0),(249334,6926,'es','Recon. de EnvÃ­o',0),(249335,6926,'de','Schiff Ackn',0),(249336,6926,'en','Ship Ackn',0),(249337,6927,'is','',0),(249338,6927,'dr','Ú¯Ø±ÙˆÙ‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(249339,6927,'pr','Ú¯Ø±ÙˆÙ‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø§ Ø§ÙŠÙ† Ù†Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(249340,6927,'tr','ParÃ§a baÅŸÄ± iÅŸ grubu, bu isimde zaten',0),(249341,6927,'pl','JuÅ¼ przez to nazwa grupy pracy akordowej',0),(249342,6927,'bg','Ð’ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð¿Ð°Ñ€Ñ‡Ðµ Ð³Ñ€ÑƒÐ¿Ð° Ñ Ñ‚Ð¾Ð²Ð° Ð¸Ð¼Ðµ',0),(249343,6927,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ú¯Ø±ÙˆÙ¾ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø³ Ú©Ø§ Ù†Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(249344,6927,'sr','Ð—Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð³Ñ€ÑƒÐ¿Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð¿Ð¾Ð´ Ñ‚Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼',0),(249345,6927,'vi','TÃªn NhÃ³m lÃ m khoÃ¡n Ä‘Ã£ tá»“n táº¡i ',0),(249346,6927,'af','Stukswerk Groep Bestaan Alreeds Met Daardie Naam',0),(249347,6927,'ro','Acord grup existÄƒ deja cÄƒ numele de',0),(249348,6927,'et','TÃ¼kitÃ¶Ã¶grupi juba olemas nimega',0),(249349,6927,'si','S tem imenom Å¾e obstaja skupina akord',0),(249350,6927,'ba','Piecework kelompok sudah ada menurut nama',0),(249351,6927,'nl','Met die naam bestaat al stukloon groep',0),(249352,6927,'fi','UrakkaryhmÃ¤n on jo samanniminen',0),(249353,6927,'no','Akkordgruppe finnes allerede med det navnet',0),(249354,6927,'da','Akkordgruppe findes allerede med navnet',0),(249355,6927,'ko','Piecework ê·¸ë£¹ì€ í•´ë‹¹ ì´ë¦„ìœ¼ë¡œ ì´ë¯¸ ì¡´ìž¬',0),(249356,6927,'he','×§×‘×•×¦×ª ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª ×›×‘×¨ ×§×™×™× ×‘×©× ×”×–×”',0),(249357,6927,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ Î¿Î¼Î¬Î´Î± Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(249358,6927,'zh','è®¡ä»¶å·¥ä½œç»„å·²ç»å­˜åœ¨è¯¥åç§°\r\n',0),(249359,6927,'sv','Ackordgrupp finns redan med det namnet',0),(249360,6927,'it','Gruppo di lavoro a cottimo esiste giÃ  con quel nome',0),(249361,6927,'tl','',0),(249362,6927,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3619;&#3633;&#3610;&#3591;&#3634;&#3609;&#3648;&#3611;&#3655;&#3609;&#3619;&#3634;&#3618;&#3594;&#3636;&#3657;&#3609;&#3617;&#3637;&#3594;&#3639;&#3656;&#3629;&#3629;&#3618;&#3',0),(249363,6927,'hi','Piecework à¤¸à¤®à¥‚à¤¹ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‰à¤¸ à¤¨à¤¾à¤® à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(249364,6927,'ms','Kumpulan piecework telah wujud dengan nama itu',0),(249365,6927,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹ Ø¨Ù‡Ø°Ø§ Ø§Ù„Ø§Ø³Ù…',0),(249366,6927,'fr','Groupe de travail Ã  la piÃ¨ce existe dÃ©jÃ  sous ce nom',0),(249367,6927,'jp','å‡ºæ¥é«˜æ‰•ã„ã‚°ãƒ«ãƒ¼ãƒ—ã¯ãã®åå‰ã§æ—¢ã«å­˜åœ¨ã—ã¾ã™',0),(249368,6927,'pt','Grupo de trabalho por tarefa jÃ¡ existe com esse nome',0),(249369,6927,'ru','Ð¡ Ñ‚Ð°ÐºÐ¸Ð¼ Ð¸Ð¼ÐµÐ½ÐµÐ¼ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð³Ñ€ÑƒÐ¿Ð¿Ð° ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(249370,6927,'es','Grupo de Trabajo por Pieza Ya Existe Por Este Nombre',0),(249371,6927,'de','Akkordgruppe ist mit diesem Namen bereits vorhanden.',0),(249372,6927,'en','Piecework Group Already Exists By That Name',0),(249373,6928,'is','',0),(249374,6928,'dr','Black IMP   Ù…Ø´ÙƒÙŠ (ØªØ¯Ø§Ø®Ù„ Ù¾Ø±Ø¯Ø§Ø²Ø´Ú¯Ø± Ù¾ÙŠØºØ§Ù… ',0),(249375,6928,'pr','Black IMP   Ù…Ø´ÙƒÙŠ (ØªØ¯Ø§Ø®Ù„ Ù¾Ø±Ø¯Ø§Ø²Ø´Ú¯Ø± Ù¾ÙŠØºØ§Ù… ',0),(249376,6928,'tr','Siyah kÃ¼Ã§Ã¼k ÅŸeytan',0),(249377,6928,'pl','Czarny IMP',0),(249378,6928,'bg','Ð§ÐµÑ€ÐµÐ½ Ð˜ÐœÐŸ',0),(249379,6928,'ur','Ø³ÛŒØ§Û Ø§ÛÙ…',0),(249380,6928,'sr','Ð¦Ñ€Ð½Ð¸ Ð‘ÐÐ£Ðš',0),(249381,6928,'vi','IMP Ä‘en',0),(249382,6928,'af','Swart IMP',0),(249383,6928,'ro','IULIA negru',0),(249384,6928,'et','Must IMP',0),(249385,6928,'si','ÄŒrna IMP',0),(249386,6928,'ba','IMP hitam',0),(249387,6928,'nl','Zwarte IMP',0),(249388,6928,'fi','Musta IMP',0),(249389,6928,'no','Svart IMP',0),(249390,6928,'da','Sort IMP',0),(249391,6928,'ko','í‘ì¸ ê¼¬ë§ˆ ë„ê¹¨ë¹„',0),(249392,6928,'he','IMP ×©×—×•×¨',0),(249393,6928,'el','ÎœÎ±ÏÏÎ¿ IMP',0),(249394,6928,'zh','é»‘è‰²ä¼ä¸šä¿¡æ¯åŒ–ç®¡ç†å¹³å°\r\n',0),(249395,6928,'sv','Svart IMP',0),(249396,6928,'it','IMP nero',0),(249397,6928,'tl','',0),(249398,6928,'th','&#3626;&#3637;&#3604;&#3635; IMP',0),(249399,6928,'hi','à¤•à¤¾à¤²à¤¾ à¤›à¥‹à¤Ÿà¤¾ à¤¸à¤¾ à¤­à¥‚à¤¤',0),(249400,6928,'ms','IMP hitam',0),(249401,6928,'ar','Ø¹ÙØ±ÙŠØª Ø£Ø³ÙˆØ¯',0),(249402,6928,'fr','IMP noir',0),(249403,6928,'jp','é»’ã‚¤ãƒ³ãƒ—',0),(249404,6928,'pt','IMP preto',0),(249405,6928,'ru','Ð§ÐµÑ€Ð½Ñ‹Ð¹ Ð˜ÐœÐŸ',0),(249406,6928,'es','Negro IMP',0),(249407,6928,'de','Schwarz IMP',0),(249408,6928,'en','Black IMP',0),(249409,6929,'is','',0),(249410,6929,'dr','Ø±Ù†Ú¯\r\n IMP',0),(249411,6929,'pr','Ø±Ù†Ú¯\r\n IMP',0),(249412,6929,'tr','Renkli kÃ¼Ã§Ã¼k ÅŸeytan',0),(249413,6929,'pl','Kolor IMP',0),(249414,6929,'bg','Ð¦Ð²ÑÑ‚ Ð˜ÐœÐŸ',0),(249415,6929,'ur','Ø±Ù†Ú¯ Ø§ÛÙ…',0),(249416,6929,'sr','Ð‘Ð¾Ñ˜Ð° Ð‘ÐÐ£Ðš',0),(249417,6929,'vi','Máº§u IMP',0),(249418,6929,'af','Kleur IMP',0),(249419,6929,'ro','Culoare IMP',0),(249420,6929,'et','VÃ¤rvi IMP',0),(249421,6929,'si','Barva IMP',0),(249422,6929,'ba','Warna IMP',0),(249423,6929,'nl','Kleur IMP',0),(249424,6929,'fi','VÃ¤ri IMP',0),(249425,6929,'no','Farge IMP',0),(249426,6929,'da','Farve IMP',0),(249427,6929,'ko','ìƒ‰ìƒ ê¼¬ë§ˆ ë„ê¹¨ë¹„',0),(249428,6929,'he','×¦×‘×¢ IMP',0),(249429,6929,'el','Î§ÏÏŽÎ¼Î± IMP',0),(249430,6929,'zh','é¢œè‰²æŽ¥å£ä¿¡æ¯ç®¡ç†\r\n',0),(249431,6929,'sv','FÃ¤rg IMP',0),(249432,6929,'it','Colore IMP',0),(249433,6929,'tl','',0),(249434,6929,'th','&#3626;&#3637; IMP',0),(249435,6929,'hi','à¤°à¤‚à¤— à¤›à¥‹à¤Ÿà¤¾ à¤¸à¤¾ à¤­à¥‚à¤¤',0),(249436,6929,'ms','Warna IMP',0),(249437,6929,'ar','Ù„ÙˆÙ† Ø§Ù„ÙˆØ¬ÙˆØ¯ Ø§Ù„Ø¹Ø³ÙƒØ±ÙŠ Ø§Ù„Ø¯ÙˆÙ„ÙŠ',0),(249438,6929,'fr','Couleur IMP',0),(249439,6929,'jp','IMP ã®è‰²',0),(249440,6929,'pt','Cor IMP',0),(249441,6929,'ru','Ð¦Ð²ÐµÑ‚ Ð˜ÐœÐŸ',0),(249442,6929,'es','Color IMP',0),(249443,6929,'de','Farbe IMP',0),(249444,6929,'en','Color IMP',0),(249445,6930,'is','',0),(249446,6930,'dr','Ú†Ù†Ø¯ Ø±Ù†Ú¯ÙŠ\r\n IMP',0),(249447,6930,'pr','Ú†Ù†Ø¯ Ø±Ù†Ú¯ÙŠ\r\n IMP',0),(249448,6930,'tr','Ã‡ok renkli kÃ¼Ã§Ã¼k ÅŸeytan',0),(249449,6930,'pl','Wielokolorowe IMP',0),(249450,6930,'bg','ÐœÐ½Ð¾Ð³Ð¾Ñ†Ð²ÐµÑ‚Ð½Ð¸ Ð˜ÐœÐŸ',0),(249451,6930,'ur','Ú©Ø«ÛŒØ± Ø±Ù†Ú¯ Ø§ÛÙ…',0),(249452,6930,'sr','Ð‘ÐÐ£Ðš Ð²Ð¸ÑˆÐµ Ð±Ð¾Ñ˜Ð°',0),(249453,6930,'vi','Äa máº§u IMP',0),(249454,6930,'af','Multi kleur IMP',0),(249455,6930,'ro','Multi-culoare IMP',0),(249456,6930,'et','Multi vÃ¤rvi IMP',0),(249457,6930,'si','Multi-barvne IMP',0),(249458,6930,'ba','Multi-warna IMP',0),(249459,6930,'nl','Multi kleur IMP',0),(249460,6930,'fi','MonivÃ¤rinen IMP',0),(249461,6930,'no','Multi-farge IMP',0),(249462,6930,'da','Multi-farve IMP',0),(249463,6930,'ko','ë‹¤ ìƒ‰ ê¼¬ë§ˆ ë„ê¹¨ë¹„',0),(249464,6930,'he','×¦×‘×¢ ×¨×‘ IMP',0),(249465,6930,'el','Î Î¿Î»Î»Î±Ï€Î»ÏŽÎ½ Ï‡ÏÏŽÎ¼Î± IMP',0),(249466,6930,'zh','å¤šè‰²æŽ¥å£ä¿¡æ¯ç®¡ç†\r\n',0),(249467,6930,'sv','FlerfÃ¤rgade IMP',0),(249468,6930,'it','IMP di multi-colore',0),(249469,6930,'tl','',0),(249470,6930,'th','&#3627;&#3621;&#3634;&#3618;&#3626;&#3637; IMP',0),(249471,6930,'hi','à¤¬à¤¹à¥ à¤°à¤‚à¤— à¤›à¥‹à¤Ÿà¤¾ à¤¸à¤¾ à¤­à¥‚à¤¤',0),(249472,6930,'ms','IMP pelbagai warna',0),(249473,6930,'ar','Ø¹ÙØ±ÙŠØª Ù…ØªØ¹Ø¯Ø¯ Ø§Ù„Ø£Ù„ÙˆØ§Ù†',0),(249474,6930,'fr','Multicolore IMP',0),(249475,6930,'jp','ãƒžãƒ«ãƒã‚«ãƒ©ãƒ¼ ã‚¤ãƒ³ãƒ—',0),(249476,6930,'pt','Multi-Color IMP',0),(249477,6930,'ru','ÐœÐ½Ð¾Ð³Ð¾Ñ†Ð²ÐµÑ‚Ð½Ñ‹Ðµ Ð˜ÐœÐŸ',0),(249478,6930,'es','IMP Multi-color',0),(249479,6930,'de','Multi-Color-IMP',0),(249480,6930,'en','Multi-Color IMP',0),(249481,6931,'is','',0),(249482,6931,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(249483,6931,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(249484,6931,'tr','NR sipariÅŸler',0),(249485,6931,'pl','NR zamÃ³wienia',0),(249486,6931,'bg','NR Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(249487,6931,'ur','Ø§ÛŒÙ† Ø¢Ø± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(249488,6931,'sr','ÐÐ  Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(249489,6931,'vi','NR Ä‘Æ¡n hÃ ng',0),(249490,6931,'af','NO Bestellings',0),(249491,6931,'ro','NR ordine',0),(249492,6931,'et','NR tellimused',0),(249493,6931,'si','NR naroÄila',0),(249494,6931,'ba','NR pesanan',0),(249495,6931,'nl','NR Orders',0),(249496,6931,'fi','NR tilaukset',0),(249497,6931,'no','NR ordrer',0),(249498,6931,'da','NR ordrer',0),(249499,6931,'ko','NR ì£¼ë¬¸',0),(249500,6931,'he','×”×–×ž× ×•×ª ×¢ × ',0),(249501,6931,'el','NR Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(249502,6931,'zh','ä¸Šåˆåæ—¶åäº”åˆ†è®¢å•\r\n',0),(249503,6931,'sv','NR order',0),(249504,6931,'it','NR ordini',0),(249505,6931,'tl','',0),(249506,6931,'th','&#3609;&#3633;&#3610;&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(249507,6931,'hi','à¤à¤¨. à¤†à¤°. à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(249508,6931,'ms','Perintah-perintah NR',0),(249509,6931,'ar','Ø£ÙˆØ§Ù…Ø± NR',0),(249510,6931,'fr','Ordres NR',0),(249511,6931,'jp','NR ã®æ³¨æ–‡',0),(249512,6931,'pt','Ordens NR',0),(249513,6931,'ru','NR Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(249514,6931,'es','Nmro. de Ordenes',0),(249515,6931,'de','NR-Bestellungen',0),(249516,6931,'en','NR Orders',0),(249517,6932,'is','',0),(249518,6932,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙƒØ§Ø± Ù…Ø¹ÙˆÙ‚',0),(249519,6932,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙƒØ§Ø± Ù…Ø¹ÙˆÙ‚',0),(249520,6932,'tr','Bekleyen Ã§alÄ±ÅŸma raporu',0),(249521,6932,'pl','Raport czasu pracy',0),(249522,6932,'bg','Ð Ð°Ð±Ð¾Ñ‚ÑÑ‚ Ñ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(249523,6932,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Ø§Ù… Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(249524,6932,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ñ€Ð°Ð´Ñƒ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(249525,6932,'vi','BÃ¡o cÃ¡o cÃ´ng viá»‡c táº¡m ngÆ°ng',0),(249526,6932,'af','Afwagtende Werksverslag',0),(249527,6932,'ro','Raport de muncÄƒ Ã®n curs',0),(249528,6932,'et','Ootel tÃ¶Ã¶ aruanne',0),(249529,6932,'si','Delo v ÄakajoÄa poroÄilo',0),(249530,6932,'ba','Laporan pekerjaan tertunda',0),(249531,6932,'nl','Rapport in behandeling werk',0),(249532,6932,'fi','Odottava tyÃ¶raportin',0),(249533,6932,'no','Ventende arbeid rapport',0),(249534,6932,'da','Ventende arbejde rapport',0),(249535,6932,'ko','ë³´ë¥˜ ì¤‘ì¸ ìž‘ì—… ë³´ê³ ì„œ',0),(249536,6932,'he','×“×•×— ×¢×‘×•×“×” ×ž×ž×ª×™× ×”',0),(249537,6932,'el','Î•ÎºÎºÏÎµÎ¼Î®Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î± Î­ÎºÎ¸ÎµÏƒÎ·',0),(249538,6932,'zh','å¾…åŠžå·¥ä½œæŠ¥å‘Š\r\n',0),(249539,6932,'sv','PÃ¥gÃ¥ende Arbetsrapport',0),(249540,6932,'it','Rapporto di lavoro in sospeso',0),(249541,6932,'tl','',0),(249542,6932,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(249543,6932,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤•à¤¾à¤°à¥à¤¯ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(249544,6932,'ms','Laporan kerja-kerja yang belum selesai',0),(249545,6932,'ar','ØªÙ‚Ø±ÙŠØ± Ø£Ø¹Ù…Ø§Ù„ Ù…Ø¹Ù„Ù‚Ø©',0),(249546,6932,'fr','Rapport sur le travail en attente',0),(249547,6932,'jp','ä¿ç•™ä¸­ã®ä½œæ¥­ãƒ¬ãƒãƒ¼ãƒˆ',0),(249548,6932,'pt','RelatÃ³rio de trabalho pendente',0),(249549,6932,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ðž Ð Ð°Ð±Ð¾Ñ‚Ðµ Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(249550,6932,'es','Informe de Trabajo Pendiente',0),(249551,6932,'de','Bericht Ã¼ber die anstehende Arbeit',0),(249552,6932,'en','Pending Work Report',0),(249553,6933,'is','',0),(249554,6933,'dr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ',0),(249555,6933,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ',0),(249556,6933,'tr','SÄ±ralama',0),(249557,6933,'pl','Sortowanie',0),(249558,6933,'bg','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(249559,6933,'ur','Ú†Ú¾Ø§Ù†Ù¹',0),(249560,6933,'sr','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°ÑšÐµ',0),(249561,6933,'vi','Sáº¯p xáº¿p',0),(249562,6933,'af','Sorteer',0),(249563,6933,'ro','Sortare',0),(249564,6933,'et','Sortimine',0),(249565,6933,'si','Razvrsti',0),(249566,6933,'ba','Urutkan',0),(249567,6933,'nl','Sorteer',0),(249568,6933,'fi','Lajittele',0),(249569,6933,'no','Sorter',0),(249570,6933,'da','Sorter',0),(249571,6933,'ko','ì •ë ¬',0),(249572,6933,'he','×ž×™×•×Ÿ',0),(249573,6933,'el','Î•Î¯Î´Î¿Ï‚',0),(249574,6933,'zh','åˆ†ç±»\r\n',0),(249575,6933,'sv','Sortera',0),(249576,6933,'it','Ordinamento',0),(249577,6933,'tl','',0),(249578,6933,'th','&#3649;&#3610;&#3656;&#3591;&#3594;&#3609;&#3636;&#3604;',0),(249579,6933,'hi','à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(249580,6933,'ms','Susun',0),(249581,6933,'ar','Ø§Ù„ÙØ±Ø²',0),(249582,6933,'fr','Tri',0),(249583,6933,'jp','ä¸¦ã¹æ›¿ãˆ',0),(249584,6933,'pt','Tipo',0),(249585,6933,'ru','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ°',0),(249586,6933,'es','Sortear',0),(249587,6933,'de','Art',0),(249588,6933,'en','Sort',0),(249589,6934,'is','',0),(249590,6934,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡',0),(249591,6934,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡',0),(249592,6934,'tr','Kutu baÅŸÄ±na sayÄ±',0),(249593,6934,'pl','Liczba w kartonie',0),(249594,6934,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÐºÑƒÑ‚Ð¸Ñ',0),(249595,6934,'ur','Ù†Ù…Ø¨Ø± Ú©Û’ Ø¨Ø§Ú©Ø³ ÙÛŒ',0),(249596,6934,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ð¾ ÐºÑƒÑ‚Ð¸Ñ˜Ð¸',0),(249597,6934,'vi','Sá»‘ má»—i há»™p',0),(249598,6934,'af','Aantal per Boks',0),(249599,6934,'ro','NumÄƒr pe cutie',0),(249600,6934,'et','Numbri karbis',0),(249601,6934,'si','Å tevilka v kartonu',0),(249602,6934,'ba','Jumlah per kotak',0),(249603,6934,'nl','Aantal per doos',0),(249604,6934,'fi','MÃ¤Ã¤rÃ¤ per laatikko',0),(249605,6934,'no','Antall per boks',0),(249606,6934,'da','Antal pr. kasse',0),(249607,6934,'ko','ìˆ˜ ìƒìž ë‹¹',0),(249608,6934,'he','×ž×¡×¤×¨ ×œ××¨×’×–',0),(249609,6934,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Î½Î¬ ÎºÎ¿Ï…Ï„Î¯',0),(249610,6934,'zh','æ¯ç›’æ•°é‡\r\n',0),(249611,6934,'sv','Antal per lÃ¥da',0),(249612,6934,'it','Numero per scatola',0),(249613,6934,'tl','',0),(249614,6934,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3656;&#3629;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(249615,6934,'hi','à¤¨à¤‚à¤¬à¤° à¤ªà¥à¤°à¤¤à¤¿ à¤¬à¥‰à¤•à¥à¤¸',0),(249616,6934,'ms','Nombor satu Peti',0),(249617,6934,'ar','Ø¹Ø¯Ø¯ ÙÙŠ Ø§Ù„Ù…Ø±Ø¨Ø¹',0),(249618,6934,'fr','Nombre par boÃ®te',0),(249619,6934,'jp','ãƒœãƒƒã‚¯ã‚¹ã‚ãŸã‚Šã®æ•°',0),(249620,6934,'pt','NÃºmero por caixa',0),(249621,6934,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð² ÐºÐ¾Ñ€Ð¾Ð±ÐºÐµ',0),(249622,6934,'es','NÃºmero por Caja',0),(249623,6934,'de','Anzahl pro Packung',0),(249624,6934,'en','Number per Box',0),(249625,6935,'is','',0),(249626,6935,'dr','ØªØ¹Ø¯Ø§Ø¯  Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡ ',0),(249627,6935,'pr','ØªØ¹Ø¯Ø§Ø¯  Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡ ',0),(249628,6935,'tr','Kutu baÅŸÄ±na NUM',0),(249629,6935,'pl','Liczba w kartonie',0),(249630,6935,'bg','NUM ÐºÑƒÑ‚Ð¸Ñ',0),(249631,6935,'ur','Ø®Ø§Ù†Û ÙÛŒ Num',0),(249632,6935,'sr','ÐÐ£Ðœ Ð¿Ð¾ ÐºÑƒÑ‚Ð¸Ñ˜Ð¸',0),(249633,6935,'vi','Sá»‘ má»—i há»™p',0),(249634,6935,'af','NUM per boks',0),(249635,6935,'ro','Num pe cutie',0),(249636,6935,'et','NUM karbis',0),(249637,6935,'si','NUM kartonu',0),(249638,6935,'ba','Num per kotak',0),(249639,6935,'nl','Num per doos',0),(249640,6935,'fi','NUM per laatikko',0),(249641,6935,'no','NUM per boks',0),(249642,6935,'da','NUM pr kasse',0),(249643,6935,'ko','ìƒìž ë‹¹ Num',0),(249644,6935,'he','Num ×œ××¨×’×–',0),(249645,6935,'el','NUM Î±Î½Î¬ ÎºÎ¹Î²ÏŽÏ„Î¹Î¿',0),(249646,6935,'zh','æ¯ç›’æ•°ç›®\r\n',0),(249647,6935,'sv','NUM per lÃ¥da',0),(249648,6935,'it','NUM per scatola',0),(249649,6935,'tl','',0),(249650,6935,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3605;&#3656;&#3629;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(249651,6935,'hi','Num à¤ªà¥à¤°à¤¤à¤¿ à¤¬à¥‰à¤•à¥à¤¸',0),(249652,6935,'ms','NUM satu Peti',0),(249653,6935,'ar','Num ÙƒÙ„ Ù…Ø±Ø¨Ø¹',0),(249654,6935,'fr','Num par boÃ®te',0),(249655,6935,'jp','Num 1 ç®±',0),(249656,6935,'pt','Por caixa',0),(249657,6935,'ru','NUM Ð² ÐºÐ¾Ñ€Ð¾Ð±ÐºÐµ',0),(249658,6935,'es','Num. por Caja',0),(249659,6935,'de','NUM pro Box',0),(249660,6935,'en','Num per Box',0),(249661,6936,'is','',0),(249662,6936,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(249663,6936,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(249664,6936,'tr','Buraya tÄ±klayÄ±n',0),(249665,6936,'pl','Kliknij tutaj',0),(249666,6936,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð°',0),(249667,6936,'ur','ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(249668,6936,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ',0),(249669,6936,'vi','Nháº¥n vÃ o Ä‘Ã¢y',0),(249670,6936,'af','Kliek Hier',0),(249671,6936,'ro','FaceÅ£i clic aici',0),(249672,6936,'et','Kliki siia',0),(249673,6936,'si','Kliknite tukaj',0),(249674,6936,'ba','Klik di sini',0),(249675,6936,'nl','Klik hier',0),(249676,6936,'fi','Klikkaa tÃ¤stÃ¤',0),(249677,6936,'no','Klikk her',0),(249678,6936,'da','Klik her',0),(249679,6936,'ko','ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì„¸ìš”',0),(249680,6936,'he','×œ×—×¥ ×›××Ÿ',0),(249681,6936,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ',0),(249682,6936,'zh','ç‚¹å‡»è¿™é‡Œ\r\n',0),(249683,6936,'sv','Klicka hÃ¤r',0),(249684,6936,'it','Clicca qui',0),(249685,6936,'tl','',0),(249686,6936,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;',0),(249687,6936,'hi','à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(249688,6936,'ms','Klik di sini',0),(249689,6936,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§',0),(249690,6936,'fr','Cliquez ici',0),(249691,6936,'jp','ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™ã€‚',0),(249692,6936,'pt','Clique aqui',0),(249693,6936,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ',0),(249694,6936,'es','Click AquÃ­',0),(249695,6936,'de','Klicken Sie hier',0),(249696,6936,'en','Click Here',0),(249697,6937,'is','',0),(249698,6937,'dr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ø§ØªÙˆÙ…Ø§ØªÙŠÙƒ Ø¨Ù‡ Ø¬Ù„Ùˆ Ø­Ø±ÙƒØª Ù†ÙƒØ±Ø¯ÙŠØ¯',0),(249699,6937,'pr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ø§ØªÙˆÙ…Ø§ØªÙŠÙƒ Ø¨Ù‡ Ø¬Ù„Ùˆ Ø­Ø±ÙƒØª Ù†ÙƒØ±Ø¯ÙŠØ¯',0),(249700,6937,'tr','EÄŸer otomatik olarak iletilen deÄŸil,',0),(249701,6937,'pl','JeÅ›li nie sÄ… automatycznie przekazywane,',0),(249702,6937,'bg','ÐÐºÐ¾ Ð’Ð¸Ðµ Ð½Ðµ ÑÑ‚Ðµ Ð¿Ñ€ÐµÐ¿Ñ€Ð°Ñ‰Ð°Ñ‚ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾,',0),(249703,6937,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ Ø¢Ú¯Û’ Ù†ÛÛŒÚº ÛÙˆØªÛ’ ÛÛŒÚºØŒ',0),(249704,6937,'sr','ÐÐºÐ¾ Ñ‚Ð¸ Ð½Ð¸ÑÑƒ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´Ð¸Ñ‚Ð¸,',0),(249705,6937,'vi','Báº¡n sáº½ Ä‘Æ°á»£c tá»± Ä‘á»™ng thÃªm vÃ o danh sÃ¡ch',0),(249706,6937,'af','U sal outomaties na \'n lys aangestuur word.',0),(249707,6937,'ro','Ar trebui sÄƒ fie transmise Ã®n mod automat pentru a lista',0),(249708,6937,'et','Kui Teid ei suunatud automaatselt,',0),(249709,6937,'si','ÄŒe niste samodejno posredovano,',0),(249710,6937,'ba','Jika Anda tidak secara otomatis diteruskan,',0),(249711,6937,'nl','Als u zijn niet automatisch doorgestuurd,',0),(249712,6937,'fi','Jos ei automaattisesti vÃ¤litetÃ¤,',0),(249713,6937,'no','Hvis du ikke automatisk videresendt,',0),(249714,6937,'da','Hvis du ikke automatisk videresendt,',0),(249715,6937,'ko','ë‹¹ì‹ ì€ ìžë™ìœ¼ë¡œ ì „ë‹¬ ë˜ì§€ ì•Šìœ¼ë©´',0),(249716,6937,'he','×× ××ª×” ×œ× ×œ× ×ž×¢× ×™× ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™,',0),(249717,6937,'el','Î•Î¬Î½ ÏƒÎ±Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î± Î´Î¹Î±Î²Î¹Î²Î±ÏƒÎ¼Î­Î½Î¿Ï‚,',0),(249718,6937,'zh','ä½ åº”è¯¥è‡ªåŠ¨è¢«è½¬å‘åˆ°åˆ—è¡¨',0),(249719,6937,'sv','Om du inte automatiskt vidarebefordras,',0),(249720,6937,'it','Se non sei automaticamente reindirizzato, ',0),(249721,6937,'tl','',0),(249722,6937,'th','You should be automatically be forwarded to list',0),(249723,6937,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤—à¥à¤°à¥‡à¤·à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚,',0),(249724,6937,'ms','Jika anda tidak secara automatik dikemukakan,',0),(249725,6937,'ar','Ø¥Ø°Ø§ Ù„Ù… ÙŠØªÙ… ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¥Ø¹Ø§Ø¯Ø© ØªÙˆØ¬ÙŠÙ‡ØŒ',0),(249726,6937,'fr','Si vous n\'Ãªtes pas automatiquement redirigÃ©,',0),(249727,6937,'jp','è‡ªå‹•çš„ã«è»¢é€ã•ã‚Œã¦ã„ãªã„ã™ã‚‹å ´åˆ',0),(249728,6937,'pt','Se vocÃª nÃ£o Ã© automaticamente encaminhada,',0),(249729,6937,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð½Ðµ Ð¿ÐµÑ€ÐµÑÑ‹Ð»Ð°ÑŽÑ‚ÑÑ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸,',0),(249730,6937,'es','Debe ser automÃ¡ticamente reenviado a la lista',0),(249731,6937,'de','Wenn Sie nicht automatisch weitergeleitet werden nicht,',0),(249732,6937,'en','If you aren\'t automatically forwarded,',0),(249733,6938,'is','',0),(249734,6938,'dr','Ø´Ø±Ø­ Ù†Ø§Ø¯Ø±Ø³Øª ',0),(249735,6938,'pr','Ø´Ø±Ø­ Ù†Ø§Ø¯Ø±Ø³Øª ',0),(249736,6938,'tr','AÃ§Ä±klama geÃ§ersiz',0),(249737,6938,'pl','NieprawidÅ‚owy opis',0),(249738,6938,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(249739,6938,'ur','ØªØµØ±ÛŒØ­ Ù†Ø§Ø¬Ø§Ø¦Ø²',0),(249740,6938,'sr','ÐžÐ¿Ð¸Ñ Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð¸',0),(249741,6938,'vi','MÃ´ táº£ vÃ´ hiá»‡u',0),(249742,6938,'af','Beskrywing Ongeldig',0),(249743,6938,'ro','Descriere nevalidÄƒ',0),(249744,6938,'et','Vigane kirjeldus',0),(249745,6938,'si','Neveljaven opis',0),(249746,6938,'ba','Deskripsi valid',0),(249747,6938,'nl','Beschrijving ongeldig',0),(249748,6938,'fi','Kuvaus virheellinen',0),(249749,6938,'no','Beskrivelse ugyldig',0),(249750,6938,'da','Beskrivelse ugyldig',0),(249751,6938,'ko','ìž˜ëª» ëœ ì„¤ëª…',0),(249752,6938,'he','×ª×™××•×¨ ×—×•×§×™',0),(249753,6938,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(249754,6938,'zh','è¯´æ˜Žæ— æ•ˆ\r\n',0),(249755,6938,'sv','Beskrivning ogiltig',0),(249756,6938,'it','Descrizione invalido',0),(249757,6938,'tl','',0),(249758,6938,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(249759,6938,'hi','à¤µà¤°à¥à¤£à¤¨ à¤…à¤®à¤¾à¤¨à¥à¤¯',0),(249760,6938,'ms','Penerangan tidak sah',0),(249761,6938,'ar','Ø§Ù„ÙˆØµÙ ØµØ­ÙŠØ­',0),(249762,6938,'fr','Description non valide',0),(249763,6938,'jp','èª¬æ˜ŽãŒç„¡åŠ¹ã§ã™ã€‚',0),(249764,6938,'pt','DescriÃ§Ã£o invÃ¡lida',0),(249765,6938,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð¾Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(249766,6938,'es','DescripciÃ³n InvÃ¡lida',0),(249767,6938,'de','Beschreibung ungÃ¼ltig',0),(249768,6938,'en','Description Invalid',0),(249769,6939,'is','',0),(249770,6939,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ù„Ø§ØµÙ‡ Ø³Ø·Ø­ Ø¯ÙØªØ± ÙƒÙ„ ',0),(249771,6939,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ù„Ø§ØµÙ‡ Ø³Ø·Ø­ Ø¯ÙØªØ± ÙƒÙ„ ',0),(249772,6939,'tr','Yeni GL Ã–zet dÃ¼zeyi',0),(249773,6939,'pl','Nowy poziom podsumowanie GL',0),(249774,6939,'bg','ÐÐ¾Ð²Ð°Ñ‚Ð° GL Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð¸Ð²Ð¾',0),(249775,6939,'ur','Ù†Ø¦ÛŒ Ø¬ÛŒØ¬Û’ Ø®Ù„Ø§ØµÛ Ø³Ø·Ø­',0),(249776,6939,'sr','ÐÐ¾Ð²Ð¸ Ð½Ð¸Ð²Ð¾ Ð“Ð› Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ°',0),(249777,6939,'vi','ThÃªm Cáº¥p Báº­c Tá»•ng Há»£p Sá»• CÃ¡i Tá»•ng Há»£p',0),(249778,6939,'af','Algemene Grootboek Opsommingvlak Skep',0),(249779,6939,'ro','Nou nivel Rezumat GL',0),(249780,6939,'et','Uus GL kokkuvÃµtlik tase',0),(249781,6939,'si','Novo GL Povzetek raven',0),(249782,6939,'ba','Tingkat baru GL ringkasan',0),(249783,6939,'nl','Nieuwe GL overzichtsniveau',0),(249784,6939,'fi','Uusi GL yhteenvetotehtÃ¤vÃ¤-taso',0),(249785,6939,'no','Nytt GL Sammendrag nivÃ¥',0),(249786,6939,'da','Nye GL sammenfattende niveau',0),(249787,6939,'ko','ìƒˆë¡œìš´ GL ìš”ì•½ ìˆ˜ì¤€',0),(249788,6939,'he','×¨×ž×” ×—×“×©×” ×©×œ ×¡×™×›×•× GL',0),(249789,6939,'el','ÎÎ­Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ ÏƒÏÎ½Î¿ÏˆÎ·Ï‚ GL',0),(249790,6939,'zh','æ–°å¢žæ€»å¸æ±‡æ€»çº§åˆ«\r\n',0),(249791,6939,'sv','Ny GL Sammanfattning nivÃ¥',0),(249792,6939,'it','Nuovo livello riepilogo GL',0),(249793,6939,'tl','',0),(249794,6939,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3632;&#3604;&#3633;&#3610;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(249795,6939,'hi','à¤¨à¤ˆ GL à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¸à¥à¤¤à¤°',0),(249796,6939,'ms','Peringkat rumusan GL baru',0),(249797,6939,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø³ØªÙˆÙ‰ ØªÙ„Ø®ÙŠØµ Ø§Ù„Ø¥Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(249798,6939,'fr','Nouvelle GL niveau sommaire',0),(249799,6939,'jp','æ–°ã—ã„ GL æ¦‚è¦ãƒ¬ãƒ™ãƒ«',0),(249800,6939,'pt','Novo nÃ­vel de Resumo de GL',0),(249801,6939,'ru','ÐÐ¾Ð²Ñ‹Ð¹ GL Ñ€ÐµÐ·ÑŽÐ¼Ðµ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ',0),(249802,6939,'es','Agregar Nivel de ResÃºmen del Libro Mayor',0),(249803,6939,'de','Neue GL Ãœbersichtsebene',0),(249804,6939,'en','New GL Summary Level',0),(249805,6940,'is','',0),(249806,6940,'dr','Ø´Ø±Ø­ Ø®Ù„Ø§ØµÙ‡ Ø³Ø·Ø­ ',0),(249807,6940,'pr','Ø´Ø±Ø­ Ø®Ù„Ø§ØµÙ‡ Ø³Ø·Ø­ ',0),(249808,6940,'tr','Ã–zet dÃ¼zeyi aÃ§Ä±klamasÄ±',0),(249809,6940,'pl','SkrÃ³cony opis poziomu',0),(249810,6940,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½Ð¾ Ð½Ð¸Ð²Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(249811,6940,'ur','Ø®Ù„Ø§ØµÛ Ø³Ø·Ø­ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(249812,6940,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°ÑšÐµ Ð¾Ð¿Ð¸Ñ Ð½Ð¸Ð²Ð¾Ð°',0),(249813,6940,'vi','Tá»•ng há»£p theo má»©c mÃ´ táº£',0),(249814,6940,'af','Opsommingsvlak Beskrywing',0),(249815,6940,'ro','Descriere sumarÄƒ Level',0),(249816,6940,'et','KokkuvÃµtlik kirjeldus',0),(249817,6940,'si','Ravni Povzetek',0),(249818,6940,'ba','Ringkasan Level Deskripsi',0),(249819,6940,'nl','Beknopte niveau beschrijving',0),(249820,6940,'fi','Tason kuvaus',0),(249821,6940,'no','NivÃ¥ Sammendrag',0),(249822,6940,'da','Sammenfattende niveau beskrivelse',0),(249823,6940,'ko','ìš”ì•½ ìˆ˜ì¤€ ì„¤ëª…',0),(249824,6940,'he','×ª×™××•×¨ ×¨×ž×ª ×¡×™×›×•×',0),(249825,6940,'el','Î£Ï…Î½Î¿Ï€Ï„Î¹ÎºÎ® Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎµÏ€Î¹Ï€Î­Î´Î¿Ï…',0),(249826,6940,'zh','æ‘˜è¦çº§åˆ«æè¿°\r\n',0),(249827,6940,'sv','Sammanfattande beskrivning av nivÃ¥',0),(249828,6940,'it','Descrizione sommaria di livello',0),(249829,6940,'tl','',0),(249830,6940,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3632;&#3604;&#3633;&#3610;&#3650;&#3604;&#3618;&#3626;&#3619;&#3640;&#3611;',0),(249831,6940,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¸à¥à¤¤à¤° à¤•à¥‡ à¤µà¤¿à¤µà¤°à¤£',0),(249832,6940,'ms','Ringkasan penerangan peringkat',0),(249833,6940,'ar','Ø¨ÙŠØ§Ù† Ù…Ø³ØªÙˆÙ‰ Ø§Ù„ØªÙ„Ø®ÙŠØµ',0),(249834,6940,'fr','Description Sommaire de niveau',0),(249835,6940,'jp','ãƒ¬ãƒ™ãƒ«ã«é–¢ã™ã‚‹èª¬æ˜Žã®è¦ç´„',0),(249836,6940,'pt','DescriÃ§Ã£o sumÃ¡ria do nÃ­vel',0),(249837,6940,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑƒÑ€Ð¾Ð²Ð½Ñ',0),(249838,6940,'es','DescripciÃ³n de Nivel de ResÃºmen',0),(249839,6940,'de','Zusammenfassende Beschreibung',0),(249840,6940,'en','Summary Level Description',0),(249841,6941,'is','',0),(249842,6941,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®Ù„Ø§ØµÙ‡ Ø³Ø·Ø­ Ø¯ÙØªØ± ÙƒÙ„',0),(249843,6941,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®Ù„Ø§ØµÙ‡ Ø³Ø·Ø­ Ø¯ÙØªØ± ÙƒÙ„',0),(249844,6941,'tr','GL Ã¶zet dÃ¼zeyini DÃ¼zenle',0),(249845,6941,'pl','Edytuj podsumowanie poziomu GL',0),(249846,6941,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° GL Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð¸Ð²Ð¾',0),(249847,6941,'ur','Ø¬ÛŒØ¬Û’ Ø®Ù„Ø§ØµÛ Ø³Ø·Ø­ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(249848,6941,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð“Ð› Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ° Ð½Ð¸Ð²Ð¾',0),(249849,6941,'vi','Cáº­p Nháº­t Má»©c Tá»•ng Há»£p Sá»• CÃ¡i Tá»•ng Há»£p',0),(249850,6941,'af','Algemene Grootboek Opsommingvlak Opdateer',0),(249851,6941,'ro','Editare nivel Rezumat GL',0),(249852,6941,'et','Redigeeri GL kokkuvÃµtlik tase',0),(249853,6941,'si','Urejanje povzetka ravni GL',0),(249854,6941,'ba','Mengedit GL ringkasan tingkat',0),(249855,6941,'nl','GL overzichtsniveau bewerken',0),(249856,6941,'fi','Muokkaa GL yhteenvetotehtÃ¤vÃ¤-taso',0),(249857,6941,'no','Redigere GL Sammendrag nivÃ¥',0),(249858,6941,'da','Redigere GL sammenfattende niveau',0),(249859,6941,'ko','GL ìš”ì•½ ìˆ˜ì¤€ íŽ¸ì§‘',0),(249860,6941,'he','×¢×¨×™×›×ª ×¨×ž×ª ×¡×™×›×•× GL',0),(249861,6941,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏÎ½Î¿ÏˆÎ·Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ GL',0),(249862,6941,'zh','æ€»å¸æ±‡æ€»çº§åˆ«æ›´æ–°\r\n',0),(249863,6941,'sv','Redigera GL Sammanfattning nivÃ¥',0),(249864,6941,'it','Modifica livello riepilogo GL',0),(249865,6941,'tl','',0),(249866,6941,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3632;&#3604;&#3633;&#3610;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(249867,6941,'hi','à¤œà¥€à¤à¤² à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¸à¥à¤¤à¤° à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(249868,6941,'ms','Edit GL rumusan peringkat',0),(249869,6941,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø³ØªÙˆÙ‰ ØªÙ„Ø®ÙŠØµ Ø§Ù„Ø¥Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(249870,6941,'fr','Modifier le niveau sommaire GL',0),(249871,6941,'jp','GL ã®æ¦‚è¦ãƒ¬ãƒ™ãƒ«ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(249872,6941,'pt','Editar Resumo nÃ­vel GL',0),(249873,6941,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ GL',0),(249874,6941,'es','Actualizar el Nivel de Resumen del Libro Mayor ',0),(249875,6941,'de','GL Ãœbersichtsebene bearbeiten',0),(249876,6941,'en','Edit GL Summary Level',0),(249877,6942,'is','',0),(249878,6942,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø­Ø°Ù Ø´Ø¯Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(249879,6942,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø­Ø°Ù Ø´Ø¯Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(249880,6942,'tr','Silinen hesaplar gizlemek iÃ§in tÄ±klatÄ±n',0),(249881,6942,'pl','Kliknij, aby ukryÄ‡ konta usuniÄ™te',0),(249882,6942,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð´Ð° ÑÐºÑ€Ð¸ÐµÑ‚Ðµ Ð˜Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸',0),(249883,6942,'ur','Ù…Ù¹Ø§Ø¦Û’ Ú¯Ø¦Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ÛŒÚº Ú†Ú¾Ù¾Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(249884,6942,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑÐ°ÐºÑ€Ð¸Ð»Ð¸ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(249885,6942,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ Giáº¥u Nhá»¯ng TK ÄÃ£ XÃ³a',0),(249886,6942,'af','Kliek om Geskrapte Rekeninge te Verberg',0),(249887,6942,'ro','FaceÅ£i clic pentru a ascunde conturile ÅŸterse',0),(249888,6942,'et','Kustutatud kontode peitmiseks klÃµpsa',0),(249889,6942,'si','Kliknite, Äe Å¾elite skriti Izbrisani raÄuni',0),(249890,6942,'ba','Klik untuk menyembunyikan account dihapus',0),(249891,6942,'nl','Klik om te verbergen van verwijderde Accounts',0),(249892,6942,'fi','Piilota poistetut tilit napsauttamalla',0),(249893,6942,'no','Klikk for Ã¥ skjule slettede kontoer',0),(249894,6942,'da','Klik for at skjule slettede konti',0),(249895,6942,'ko','ì‚­ì œ ëœ ê³„ì • ìˆ¨ê¸°ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(249896,6942,'he','×œ×—×¥ ×›×“×™ ×œ×”×¡×ª×™×¨ ×—×©×‘×•× ×•×ª × ×ž×—×§×•',0),(249897,6942,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î±Ï€Î¿ÎºÏÏÏˆÎµÏ„Îµ Î´Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(249898,6942,'zh','ç‚¹å‡»éšè—åˆ é™¤çš„å¸æˆ·\r\n',0),(249899,6942,'sv','Klicka fÃ¶r att dÃ¶lja borttagna konton',0),(249900,6942,'it','Fare clic per nascondere l\'account cancellato',0),(249901,6942,'tl','',0),(249902,6942,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3595;&#3656;&#3629;&#3617;&#3585;&#3634;&#3619;&#3621;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(249903,6942,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‹ à¤›à¥à¤ªà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(249904,6942,'ms','Klik untuk menyembunyikan akaun dihapuskan',0),(249905,6942,'ar','Ø§Ù†Ù‚Ø± Ù„Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø­Ø°ÙˆÙØ©',0),(249906,6942,'fr','Cliquez ici pour masquer les comptes supprimÃ©s',0),(249907,6942,'jp','å‰Šé™¤ã—ãŸã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’éžè¡¨ç¤ºã«ã™ã‚‹] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(249908,6942,'pt','Clique para esconder contas deletadas',0),(249909,6942,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐºÑ€Ñ‹Ñ‚ÑŒ Ð£Ð´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ñ‹',0),(249910,6942,'es','Click para Esconder Cuentas Eliminadas',0),(249911,6942,'de','Hier klicken, um gelÃ¶schte Benutzerkonten ausblenden',0),(249912,6942,'en','Click to Hide Deleted Accounts',0),(249913,6943,'is','',0),(249914,6943,'dr','Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø­Ø°Ù Ø´Ø¯Ù‡ Ù‡Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(249915,6943,'pr','Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø­Ø°Ù Ø´Ø¯Ù‡ Ù‡Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(249916,6943,'tr','Silinen hesaplar gÃ¶stermek iÃ§in tÄ±klatÄ±n',0),(249917,6943,'pl','Kliknij, aby pokazaÄ‡ konta usuniÄ™te',0),(249918,6943,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¿Ð¾ÐºÐ°Ð¶Ðµ Ð˜Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸',0),(249919,6943,'ur','Ø­Ø°Ù Ø´Ø¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(249920,6943,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(249921,6943,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ Hiá»ƒn Thá»‹ Nhá»¯ng TK ÄÃ£ XÃ³a',0),(249922,6943,'af','Kliek om Geskrapte Rekeninge te Wys ',0),(249923,6943,'ro','Clic pentru afiÅŸare conturile ÅŸterse',0),(249924,6943,'et','Kustutatud kontode nÃ¤itamiseks klÃµpsa',0),(249925,6943,'si','Kliknite za prikaz Izbrisani raÄuni',0),(249926,6943,'ba','Klik untuk menampilkan akun dihapus',0),(249927,6943,'nl','Klik om te tonen verwijderde Accounts',0),(249928,6943,'fi','NÃ¤ytÃ¤ Poistetut tilit napsauttamalla',0),(249929,6943,'no','Klikk for Ã¥ vise slettede kontoer',0),(249930,6943,'da','Klik for at vise slettede konti',0),(249931,6943,'ko','ì‚­ì œ ëœ ê³„ì •ì— ë³´ì—¬ í´ë¦­',0),(249932,6943,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’ ××ª ×—×©×‘×•× ×•×ª × ×ž×—×§×•',0),(249933,6943,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Î¾ÎµÎ¹ Î´Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(249934,6943,'zh','ç‚¹å‡»å³å¯æ˜¾ç¤ºåˆ é™¤çš„å¸æˆ·\r\n',0),(249935,6943,'sv','Klicka fÃ¶r att Visa borttagna konton',0),(249936,6943,'it','Clicca per cancellare account cancellati',0),(249937,6943,'tl','',0),(249938,6943,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3649;&#3626;&#3604;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3621;&#3610;',0),(249939,6943,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‹ à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(249940,6943,'ms','Klik untuk menunjukkan akaun dihapuskan',0),(249941,6943,'ar','Ø§Ù†Ù‚Ø± Ù„Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø­Ø°ÙˆÙØ©',0),(249942,6943,'fr','Cliquez pour afficher les comptes supprimÃ©s',0),(249943,6943,'jp','å‰Šé™¤ã—ãŸã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¡¨ç¤ºã™ã‚‹ã«ã¯ã€] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(249944,6943,'pt','Clique para mostrar contas deletadas',0),(249945,6943,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð£Ð´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ñ‹',0),(249946,6943,'es','Click para Mostrar Cuentas Eliminadas',0),(249947,6943,'de','Hier klicken, um die gelÃ¶schte Konten anzeigen',0),(249948,6943,'en','Click To Show Deleted Accounts',0),(249949,6944,'is','',0),(249950,6944,'dr','Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(249951,6944,'pr','Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(249952,6944,'tr','Standart',0),(249953,6944,'pl','Standardowe',0),(249954,6944,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚',0),(249955,6944,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ',0),(249956,6944,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¾',0),(249957,6944,'vi','Chuáº©n',0),(249958,6944,'af','Standaard',0),(249959,6944,'ro','Standard',0),(249960,6944,'et','Standard',0),(249961,6944,'si','Standard',0),(249962,6944,'ba','Standar',0),(249963,6944,'nl','Standaard',0),(249964,6944,'fi','Standardi',0),(249965,6944,'no','Standard',0),(249966,6944,'da','Standard',0),(249967,6944,'ko','í‘œì¤€',0),(249968,6944,'he','×¡×˜× ×“×¨×˜×™',0),(249969,6944,'el','Î ÏÏŒÏ„Ï…Ï€Î¿',0),(249970,6944,'zh','æ ‡å‡†\r\n',0),(249971,6944,'sv','Standard',0),(249972,6944,'it','Standard',0),(249973,6944,'tl','',0),(249974,6944,'th','&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(249975,6944,'hi','à¤®à¤¾à¤¨à¤•',0),(249976,6944,'ms','Standard',0),(249977,6944,'ar','Ù‚Ø¨Ø§Ø³ÙŠ',0),(249978,6944,'fr','Norme',0),(249979,6944,'jp','æ¨™æº–',0),(249980,6944,'pt','PadrÃ£o',0),(249981,6944,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚',0),(249982,6944,'es','EstÃ¡ndar',0),(249983,6944,'de','Standard',0),(249984,6944,'en','Standard',0),(249985,6945,'is','',0),(249986,6945,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(249987,6945,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„',0),(249988,6945,'tr','YÄ±l iÃ§in toplamlarÄ±',0),(249989,6945,'pl','Podsumowania za rok',0),(249990,6945,'bg','ÐžÐ±Ñ‰Ð¸Ñ‚Ðµ ÑÑƒÐ¼Ð¸ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(249991,6945,'ur','Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ Ù…ÛŒØ²Ø§Ù†',0),(249992,6945,'sr','Ð—Ð±Ð¸Ñ€Ð¾Ð²Ð¸ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(249993,6945,'vi','Tá»•ng cá»™ng cho nÄƒm',0),(249994,6945,'af','Totale vir Jaar',0),(249995,6945,'ro','Totaluri pentru anul',0),(249996,6945,'et','Aasta kokkuvÃµtted',0),(249997,6945,'si','Vsote za leto',0),(249998,6945,'ba','Total untuk tahun',0),(249999,6945,'nl','Totalen voor jaar',0),(250000,6945,'fi','KokonaismÃ¤Ã¤rÃ¤t vuoden',0),(250001,6945,'no','Totalene For Ã¥r',0),(250002,6945,'da','Totaler For Ã¥r',0),(250003,6945,'ko','ë…„ í•©ê³„',0),(250004,6945,'he','×¡×›×•×ž×™× ×¢×‘×•×¨ ×©× ×”',0),(250005,6945,'el','Î£ÏÎ½Î¿Î»Î± Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚',0),(250006,6945,'zh','æ€»è®¡å¹´\r\n',0),(250007,6945,'sv','Summor fÃ¶r Ã¥r',0),(250008,6945,'it','Totali per anno',0),(250009,6945,'tl','',0),(250010,6945,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3611;&#3637;',0),(250011,6945,'hi','à¤¸à¤¾à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‹à¤—',0),(250012,6945,'ms','Jumlah bagi tahun',0),(250013,6945,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ø³Ù†Ø©',0),(250014,6945,'fr','Totaux pour l\'annÃ©e',0),(250015,6945,'jp','å¹´ã®åˆè¨ˆ',0),(250016,6945,'pt','Totais por ano',0),(250017,6945,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ Ð·Ð° Ð³Ð¾Ð´',0),(250018,6945,'es','Totales Para el AÃ±o',0),(250019,6945,'de','Summen fÃ¼r das Jahr',0),(250020,6945,'en','Totals For Year',0),(250021,6946,'is','',0),(250022,6946,'dr','Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯  Ø¯Ø§Ø±Ø¯',0),(250023,6946,'pr','Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯  Ø¯Ø§Ø±Ø¯',0),(250024,6946,'tr','Maliyet merkezi zaten var',0),(250025,6946,'pl','MPK juÅ¼ istnieje',0),(250026,6946,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(250027,6946,'ur','Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ú©Ø² Ù…ÛŒÚº Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(250028,6946,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(250029,6946,'vi','Cost Center Ä‘Ã£ tá»“n táº¡i',0),(250030,6946,'af','Koste Sentrum Bestaan Alreeds.',0),(250031,6946,'ro','Centrul de cost existÄƒ deja',0),(250032,6946,'et','Kulukeskuse juba olemas',0),(250033,6946,'si','StroÅ¡kovno srediÅ¡Äe Å¾e obstaja',0),(250034,6946,'ba','Biaya pusat sudah ada',0),(250035,6946,'nl','Kostenplaats bestaat al',0),(250036,6946,'fi','Kustannuspaikka on jo olemassa',0),(250037,6946,'no','Kostsenter finnes allerede',0),(250038,6946,'da','Omkostningssted findes allerede',0),(250039,6946,'ko','ë¹„ìš© ì„¼í„° ì´ë¯¸',0),(250040,6946,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª ×›×‘×¨ ×§×™×™×',0),(250041,6946,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Ï„Î¿ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(250042,6946,'zh','æˆæœ¬ä¸­å¿ƒå·²å­˜åœ¨\r\n',0),(250043,6946,'sv','KostnadsstÃ¤lle finns redan',0),(250044,6946,'it','Centro di costo esiste giÃ ',0),(250045,6946,'tl','',0),(250046,6946,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(250047,6946,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(250048,6946,'ms','Pusat kos telah wujud',0),(250049,6946,'ar','Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ© Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§',0),(250050,6946,'fr','Centre de coÃ»t existe dÃ©jÃ ',0),(250051,6946,'jp','ã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™',0),(250052,6946,'pt','Centro de custo jÃ¡ existe',0),(250053,6946,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(250054,6946,'es','Centro de Costos Ya Existe',0),(250055,6946,'de','Kostenstelle ist bereits vorhanden.',0),(250056,6946,'en','Cost Center already exists',0),(250057,6947,'is','',0),(250058,6947,'dr','Ø´Ø±Ø­ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡',0),(250059,6947,'pr','Ø´Ø±Ø­ Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡',0),(250060,6947,'tr','Maliyet merkezi aÃ§Ä±klamasÄ±',0),(250061,6947,'pl','Opis MPK',0),(250062,6947,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(250063,6947,'ur','Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ú©Ø² Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(250064,6947,'sr','ÐžÐ¿Ð¸Ñ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(250065,6947,'vi','MÃ´ táº£ Cost Center',0),(250066,6947,'af','Koste Sentrum Beskrywing',0),(250067,6947,'ro','Descriere centrul de cost',0),(250068,6947,'et','Kulukeskuse kirjeldus',0),(250069,6947,'si','StroÅ¡kovno srediÅ¡Äe opis',0),(250070,6947,'ba','Deskripsi biaya Pusat',0),(250071,6947,'nl','Kostenplaats beschrijving',0),(250072,6947,'fi','Kustannuspaikka kuvaus',0),(250073,6947,'no','Kostsenter beskrivelse',0),(250074,6947,'da','Omkostningssted beskrivelse',0),(250075,6947,'ko','ë¹„ìš© ì„¼í„° ì„¤ëª…',0),(250076,6947,'he','×ª×™××•×¨ ×ž×¨×›×– ×¢×œ×•×™×•×ª',0),(250077,6947,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(250078,6947,'zh','æˆæœ¬ä¸­å¿ƒçš„è¯´æ˜Ž\r\n',0),(250079,6947,'sv','KostnadsstÃ¤lle Beskrivning',0),(250080,6947,'it','Descrizione del centro di costo',0),(250081,6947,'tl','',0),(250082,6947,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;',0),(250083,6947,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤¨à¥à¤¦à¥à¤° à¤µà¤¿à¤µà¤°à¤£',0),(250084,6947,'ms','Description/kawalan pusat kos',0),(250085,6947,'ar','Ø¨ÙŠØ§Ù† Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(250086,6947,'fr','Description de centre de coÃ»t',0),(250087,6947,'jp','ã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼ã®èª¬æ˜Ž',0),(250088,6947,'pt','DescriÃ§Ã£o de centro de custo',0),(250089,6947,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ñ†ÐµÐ½Ñ‚Ñ€Ð° Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(250090,6947,'es','Centro de Costos DescripciÃ³n',0),(250091,6947,'de','Kostenstelle Beschreibung',0),(250092,6947,'en','Cost Center Description',0),(250093,6948,'is','',0),(250094,6948,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(250095,6948,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(250096,6948,'tr','Yeni GL maliyet merkezi',0),(250097,6948,'pl','Nowe GL MPK',0),(250098,6948,'bg','ÐÐ¾Ð² Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð½Ð° GL',0),(250099,6948,'ur','Ù†Ø¦Û’ Ø¬ÛŒØ¬Û’ Ù„Ø§Ú¯Øª Ø³ÛŒÙ†Ù¹Ø±',0),(250100,6948,'sr','ÐÐ¾Ð²Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð“Ð›',0),(250101,6948,'vi','ThÃªm Cost Center Sá»• CÃ¡i Tá»•ng Há»£p',0),(250102,6948,'af','Skep Algemene Grootboek Koste Sentrum ',0),(250103,6948,'ro','Noul centru de Cost GL',0),(250104,6948,'et','Uus GL Kulukeskus',0),(250105,6948,'si','Novi GL stroÅ¡kovno srediÅ¡Äe',0),(250106,6948,'ba','Baru GL biaya Pusat',0),(250107,6948,'nl','Nieuwe GL kostenplaats',0),(250108,6948,'fi','Uusi GL kustannuspaikka',0),(250109,6948,'no','Nye GL kostsenter',0),(250110,6948,'da','Nye GL omkostningssted',0),(250111,6948,'ko','ìƒˆë¡œìš´ GL ë¹„ìš© ì„¼í„°',0),(250112,6948,'he','×ž×¨×›×– ×—×“×© ×©×œ ×¢×œ×•×ª GL',0),(250113,6948,'el','ÎÎ­Î¿ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ GL',0),(250114,6948,'zh','æ·»åŠ æ€»å¸æˆæœ¬ä¸­å¿ƒåœ°å€\r\n',0),(250115,6948,'sv','Nya GL kostnadsstÃ¤lle',0),(250116,6948,'it','Nuovo centro di costo GL',0),(250117,6948,'tl','',0),(250118,6948,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(250119,6948,'hi','à¤¨à¤ˆ GL à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(250120,6948,'ms','Pusat kos GL baru',0),(250121,6948,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(250122,6948,'fr','Nouveau centre de coÃ»t GL',0),(250123,6948,'jp','æ–°ã—ã„ GL ã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼',0),(250124,6948,'pt','Novo centro de custo GL',0),(250125,6948,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ†ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ GL',0),(250126,6948,'es','Agregar Centro de Costos de Libro Mayor',0),(250127,6948,'de','Neue GL-Kostenstelle',0),(250128,6948,'en','New GL Cost Center',0),(250129,6949,'is','',0),(250130,6949,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(250131,6949,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(250132,6949,'tr','GL maliyet merkezi dÃ¼zenleme',0),(250133,6949,'pl','Edytuj GL MPK',0),(250134,6949,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° GL Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(250135,6949,'ur','Ø¬ÛŒØ¬Û’ Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø² Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(250136,6949,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð“Ð›',0),(250137,6949,'vi','Cáº­p Nháº­t Cost Center Sá»• CÃ¡i Tá»•ng Há»£p',0),(250138,6949,'af','Opdatering van Algemene Grootboek Koste Sentrum',0),(250139,6949,'ro','Editare centru de Cost GL',0),(250140,6949,'et','Redigeeri GL Kulukeskus',0),(250141,6949,'si','Urejanje GL stroÅ¡kovno srediÅ¡Äe',0),(250142,6949,'ba','Mengedit GL biaya Pusat',0),(250143,6949,'nl','GL kostenplaats bewerken',0),(250144,6949,'fi','Muokkaa GL kustannuspaikka',0),(250145,6949,'no','Redigere GL kostsenter',0),(250146,6949,'da','Redigere GL omkostningssted',0),(250147,6949,'ko','GL ë¹„ìš© ì„¼í„° íŽ¸ì§‘',0),(250148,6949,'he','×¢×¨×™×›×ª ×ž×¨×›×– ×¢×œ×•×™×•×ª GL',0),(250149,6949,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ GL',0),(250150,6949,'zh','æ€»å¸æˆæœ¬ä¸­å¿ƒæ›´æ–°\r\n',0),(250151,6949,'sv','Redigera GL kostnadsstÃ¤lle',0),(250152,6949,'it','Modifica centro di costo GL',0),(250153,6949,'tl','',0),(250154,6949,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(250155,6949,'hi','à¤œà¥€à¤à¤² à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(250156,6949,'ms','Edit Pusat kos GL',0),(250157,6949,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(250158,6949,'fr','Modifier le centre de coÃ»t GL',0),(250159,6949,'jp','GL ã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(250160,6949,'pt','Editar GL de centro de custo',0),(250161,6949,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ GL',0),(250162,6949,'es','Actualizar Centro de Costos de Libro Mayor',0),(250163,6949,'de','GL-Kostenstelle bearbeiten',0),(250164,6949,'en','Edit GL Cost Center',0),(250165,6950,'is','',0),(250166,6950,'dr','Ù†Ù…ÙˆØ¯Ø§Ø±Ù‡Ø§ÙŠ ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ',0),(250167,6950,'pr','Ù†Ù…ÙˆØ¯Ø§Ø±Ù‡Ø§ÙŠ ÙƒÙ„ÙˆÚ†Ù‡ Ø§ÙŠ',0),(250168,6950,'tr','Pasta grafikler',0),(250169,6950,'pl','Wykresy koÅ‚owe',0),(250170,6950,'bg','ÐšÑ€ÑŠÐ³Ð¾Ð²Ð¸Ñ‚Ðµ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¸',0),(250171,6950,'ur','Ù¾Ø§Ø¦ÛŒ Ú†Ø§Ø±Ù¹',0),(250172,6950,'sr','ÐšÑ€ÑƒÐ¶Ð½Ð¸ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ¾Ð½Ð¸',0),(250173,6950,'vi','Biá»ƒu Ä‘á»“ dáº¡ng á»‘ng',0),(250174,6950,'af','Sirkeldiagram Grafieke',0),(250175,6950,'ro','Diagrame plÄƒcintÄƒ',0),(250176,6950,'et','Sektordiagrammis saab',0),(250177,6950,'si','Tortni grafikoni',0),(250178,6950,'ba','Diagram lingkaran',0),(250179,6950,'nl','Cirkeldiagrammen',0),(250180,6950,'fi','YmpyrÃ¤kaavio',0),(250181,6950,'no','Sektordiagrammer',0),(250182,6950,'da','Cirkeldiagrammer',0),(250183,6950,'ko','ì›í˜• ì°¨íŠ¸',0),(250184,6950,'he','×ª×¨×©×™×ž×™ ×¢×•×’×”',0),(250185,6950,'el','Î“ÏÎ±Ï†Î®Î¼Î±Ï„Î± Ï€Î¯Ï„Î±Ï‚',0),(250186,6950,'zh','é¥¼å›¾\r\n',0),(250187,6950,'sv','Cirkeldiagram',0),(250188,6950,'it','Grafici a torta',0),(250189,6950,'tl','',0),(250190,6950,'th','&#3649;&#3612;&#3609;&#3616;&#3641;&#3617;&#3636;&#3623;&#3591;&#3585;&#3621;&#3617;',0),(250191,6950,'hi','à¤ªà¤¾à¤‡ à¤šà¤¾à¤°à¥à¤Ÿà¥à¤¸',0),(250192,6950,'ms','Carta pai',0),(250193,6950,'ar','Ø§Ù„Ù…Ø®Ø·Ù‘Ù‘Ø·Ø§Øª Ø§Ù„Ø¯Ø§Ø¦Ø±ÙŠØ©',0),(250194,6950,'fr','Camemberts',0),(250195,6950,'jp','å††ã‚°ãƒ©ãƒ•',0),(250196,6950,'pt','GrÃ¡ficos de pizza',0),(250197,6950,'ru','ÐšÑ€ÑƒÐ³Ð¾Ð²Ñ‹Ðµ Ð´Ð¸Ð°Ð³Ñ€Ð°Ð¼Ð¼Ñ‹',0),(250198,6950,'es','GrÃ¡ficos Circulares',0),(250199,6950,'de','Kreisdiagramme',0),(250200,6950,'en','Pie Charts',0),(250201,6951,'is','',0),(250202,6951,'dr','Net Change',0),(250203,6951,'pr','Net Change',0),(250204,6951,'tr','Net deÄŸiÅŸim',0),(250205,6951,'pl','Obroty netto',0),(250206,6951,'bg','ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð¸',0),(250207,6951,'ur','Ù†ÛŒÙ¹ ÙˆØ±Ú© ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(250208,6951,'sr','ÐŸÑ€Ð¾Ð¼ÐµÑ‚',0),(250209,6951,'vi','Thay Ä‘á»•i thuáº§n',0),(250210,6951,'af','Net Verandering',0),(250211,6951,'ro','Sold',0),(250212,6951,'et','Muutus',0),(250213,6951,'si','Neto sprememba',0),(250214,6951,'ba','Perubahan bersih',0),(250215,6951,'nl','Mutatie',0),(250216,6951,'fi','Nettomuutos',0),(250217,6951,'no','Bevegelse',0),(250218,6951,'da','NettoÃ¦ndring',0),(250219,6951,'ko','Net ë³€ê²½',0),(250220,6951,'he','×©×™× ×•×™ × ×˜×•',0),(250221,6951,'el','ÎšÎ¯Î½Î·ÏƒÎ· Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(250222,6951,'zh','å˜åŠ¨å‡€å€¼\r\n',0),(250223,6951,'sv','NettofÃ¶rÃ¤ndring',0),(250224,6951,'it','Variazione netta',0),(250225,6951,'tl','',0),(250226,6951,'th','&#3648;&#3591;&#3636;&#3609;&#3607;&#3629;&#3609;&#3626;&#3640;&#3607;&#3608;&#3636;',0),(250227,6951,'hi','à¤¨à¤¿à¤µà¤² à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(250228,6951,'ms','Perubahan bersih',0),(250229,6951,'ar','ØµØ§ÙÙŠ Ø§Ù„ØªØºÙŠØ±',0),(250230,6951,'fr','Variation nette',0),(250231,6951,'jp','ç´”å¤‰åŒ–',0),(250232,6951,'pt','VariaÃ§Ã£o lÃ­quida',0),(250233,6951,'ru','Ð§Ð¸ÑÑ‚Ð¾Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(250234,6951,'es','Cambio Neto',0),(250235,6951,'de','Zahlungswirksame VerÃ¤nderung',0),(250236,6951,'en','Net Change',0),(250237,6952,'is','',0),(250238,6952,'dr','(ÙˆÙŠÚ˜Ù‡)Ù„ÛŒØ¬Ø± ',0),(250239,6952,'pr','Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø«Ø§Ø¨Øª(ÙˆÙŠÚ˜Ù‡)Ø¯ÙØªØ± ÙƒÙ„ ',0),(250240,6952,'tr','Belirli GL maliyet merkezi',0),(250241,6952,'pl','SzczegÃ³lne GL MPK',0),(250242,6952,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð½Ð° ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ð¸ GL',0),(250243,6952,'ur','Ù…Ø®ØµÙˆØµ Ø¬ÛŒØ¬Û’ Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø²',0),(250244,6952,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ðµ Ð“Ð›',0),(250245,6952,'vi','Cost center cá»¥ thá»ƒ cá»§a sá»• cÃ¡i tá»•ng há»£p',0),(250246,6952,'af','Spesifieke AG Koste Sentrum',0),(250247,6952,'ro','Centrul de Cost specifice GL',0),(250248,6952,'et','Konkreetse GL Kulukeskus',0),(250249,6952,'si','Posebne GL stroÅ¡kovno srediÅ¡Äe',0),(250250,6952,'ba','Spesifik GL biaya Pusat',0),(250251,6952,'nl','Specifieke GL kostenplaats',0),(250252,6952,'fi','ErityisiÃ¤ GL kustannuspaikka',0),(250253,6952,'no','Bestemt GL kostsenter',0),(250254,6952,'da','Specifikke GL omkostningssted',0),(250255,6952,'ko','íŠ¹ì • GL ë¹„ìš© ì„¼í„°',0),(250256,6952,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª ×¡×¤×¦×™×¤×™×•×ª GL',0),(250257,6952,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Ï‰Î½, GL',0),(250258,6952,'zh','å…·ä½“çš„æ€»å¸æˆæœ¬ä¸­å¿ƒ\r\n',0),(250259,6952,'sv','SÃ¤rskilda GL kostnadsstÃ¤lle',0),(250260,6952,'it','Centro di costo specifico GL',0),(250261,6952,'tl','',0),(250262,6952,'th','&#3619;&#3632;&#3610;&#3640;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(250263,6952,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ GL à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(250264,6952,'ms','Pusat kos tertentu GL',0),(250265,6952,'ar','Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© Ø£Ø³ØªØ§Ø° Ø¹Ø§Ù… Ù…Ø­Ø¯Ø¯',0),(250266,6952,'fr','Centre de coÃ»ts spÃ©cifique GL',0),(250267,6952,'jp','ç‰¹å®šã® GL ã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼',0),(250268,6952,'pt','Centro de custo especÃ­fico GL',0),(250269,6952,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ñ‹Ñ… GL',0),(250270,6952,'es','Centro de Costos de LM EspecÃ­fico',0),(250271,6952,'de','Spezifische GL-Kostenstelle',0),(250272,6952,'en','Specific GL Cost Center',0),(250273,6953,'is','',0),(250274,6953,'dr','Ø´Ø§Ù…Ù„ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡',0),(250275,6953,'pr','Ø´Ø§Ù…Ù„ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡',0),(250276,6953,'tr','Deftere nakledilmemiÅŸ girdileri iÃ§erir',0),(250277,6953,'pl','Zawiera wpisy niezaksiÄ™gowana',0),(250278,6953,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(250279,6953,'ur','Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(250280,6953,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ðµ Ð½ÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(250281,6953,'vi','Bao gá»“m bÃºt toÃ¡n chÆ°a káº¿t chuyá»ƒn',0),(250282,6953,'af','Sluit Ongeposteerde Inskrywings In',0),(250283,6953,'ro','Include intrÄƒrile de neÃ®nregistrate',0),(250284,6953,'et','Sisaldab sisestamata kanded',0),(250285,6953,'si','VkljuÄuje neknjiÅ¾enih postavke',0),(250286,6953,'ba','Termasuk Unposted entri',0),(250287,6953,'nl','Bevat niet-doorgevoerde vermeldingen',0),(250288,6953,'fi','SisÃ¤ltÃ¤Ã¤ kirjaamattomat tapahtumat',0),(250289,6953,'no','Inneholder oppfÃ¸ringer',0),(250290,6953,'da','Omfatter ikke-bogfÃ¸rte poster',0),(250291,6953,'ko','ê²Œì‹œ ë˜ì§€ ì•Šì€ í•­ëª©ì„ í¬í•¨',0),(250292,6953,'he','×”×›×•×œ×œ ×¢×¨×›×™× ×©×œ× × ×¨×©×ž×•',0),(250293,6953,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Î¼Î· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(250294,6953,'zh','åŒ…æ‹¬æœªé‚®å¯„æ¡ç›®\r\n',0),(250295,6953,'sv','InnehÃ¥ller bokfÃ¶rda transaktioner',0),(250296,6953,'it','Include voci registrate',0),(250297,6953,'tl','',0),(250298,6953,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(250299,6953,'hi','Unposted à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(250300,6953,'ms','Termasuk entri Unposted',0),(250301,6953,'ar','ØªØªØ¶Ù…Ù† Ø¥Ø¯Ø®Ø§Ù„Ø§Øª ØºÙŠØ± Ø§Ù„Ù…Ù†Ø´ÙˆØ±Ø©',0),(250302,6953,'fr','Inclut les entrÃ©es non validÃ©es',0),(250303,6953,'jp','æœªé€ä¿¡ã®ã‚¨ãƒ³ãƒˆãƒªãŒå«ã¾ã‚Œã¦ã„ã¾ã™',0),(250304,6953,'pt','Inclui entradas nÃ£o lanÃ§adas',0),(250305,6953,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°ÐµÑ‚ Ð² ÑÐµÐ±Ñ Ð½ÐµÐ¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(250306,6953,'es','Incluyen Entradas No Asentados',0),(250307,6953,'de','Beinhaltet nicht',0),(250308,6953,'en','Includes Unposted Entries',0),(250309,6954,'is','',0),(250310,6954,'dr','Ø®Ù„Ø§ØµÙ‡ Ø³Ø·Ø­ ',0),(250311,6954,'pr','Ø®Ù„Ø§ØµÙ‡ Ø³Ø·Ø­ ',0),(250312,6954,'tr','Ã–zet dÃ¼zeyi',0),(250313,6954,'pl','Podsumowanie poziomu',0),(250314,6954,'bg','Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð¸Ð²Ð¾',0),(250315,6954,'ur','Ø®Ù„Ø§ØµÛ Ø³Ø·Ø­',0),(250316,6954,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ð²Ð¾',0),(250317,6954,'vi','Má»©c Tá»•ng káº¿t',0),(250318,6954,'af','Opsommingsvlak',0),(250319,6954,'ro','Nivel de sintezÄƒ',0),(250320,6954,'et','KokkuvÃµtlik tase',0),(250321,6954,'si','Povzetek ravni',0),(250322,6954,'ba','Ringkasan tingkat',0),(250323,6954,'nl','Overzichtsniveau',0),(250324,6954,'fi','YhteenvetotehtÃ¤vÃ¤-taso',0),(250325,6954,'no','Sammendrag nivÃ¥',0),(250326,6954,'da','Sammenfattende niveau',0),(250327,6954,'ko','ìš”ì•½ ìˆ˜ì¤€',0),(250328,6954,'he','×¨×ž×ª ×¡×™×›×•×',0),(250329,6954,'el','Î•Ï€Î¯Ï€ÎµÎ´Î¿ ÏƒÏÎ½Î¿ÏˆÎ·Ï‚',0),(250330,6954,'zh','æ‘˜è¦çº§åˆ«\r\n',0),(250331,6954,'sv','Sammanfattning nivÃ¥',0),(250332,6954,'it','Livello Riepilogo',0),(250333,6954,'tl','',0),(250334,6954,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3650;&#3604;&#3618;&#3626;&#3619;&#3640;&#3611;',0),(250335,6954,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¸à¥à¤¤à¤°',0),(250336,6954,'ms','Ringkasan peringkat',0),(250337,6954,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„ØªÙ„Ø®ÙŠØµ',0),(250338,6954,'fr','Niveau sommaire',0),(250339,6954,'jp','é›†è¨ˆãƒ¬ãƒ™ãƒ«',0),(250340,6954,'pt','NÃ­vel de resumo',0),(250341,6954,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ',0),(250342,6954,'es','Nivel de ResÃºmen',0),(250343,6954,'de','Zusammenfassung-Ebene',0),(250344,6954,'en','Summary Level',0),(250345,6955,'is','',0),(250346,6955,'dr','Ø¨Ø±Ú¯Ù‡ ØªØ±Ø§Ø² Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ Ø¬Ø²Ø¡ Ø¨Ù‡ Ø¬Ø²Ø¡',0),(250347,6955,'pr','Ø¨Ø±Ú¯Ù‡ ØªØ±Ø§Ø² Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ Ø¬Ø²Ø¡ Ø¨Ù‡ Ø¬Ø²Ø¡',0),(250348,6955,'tr','BilanÃ§o - detaylÄ± deneme',0),(250349,6955,'pl','Bilans - prÃ³ba SzczegÃ³Å‚owa',0),(250350,6955,'bg','Ð‘Ð°Ð»Ð°Ð½Ñ - Ð¿Ð¾Ð´Ñ€Ð¾Ð±ÐµÐ½ Ð¿Ñ€Ð¾Ð±ÐµÐ½',0),(250351,6955,'ur','Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ - ØªÙØµÛŒÙ„ÛŒ Ù…Ù‚Ø¯Ù…Û’ Ú©ÛŒ Ø³Ù…Ø§Ø¹Øª',0),(250352,6955,'sr','Ð‘Ð¸Ð»Ð°Ð½Ñ ÑÑ‚Ð°ÑšÐ° - Ð´ÐµÑ‚Ð°Ñ™Ð½Ðµ ÑÑƒÑ’ÐµÑšÐµ',0),(250353,6955,'vi','Trang Chi tiáº¿t DÆ° ná»£ thá»­',0),(250354,6955,'af','Gedetailleerde Proefbalansstaat',0),(250355,6955,'ro','BilanÅ£ul - studiu detaliat',0),(250356,6955,'et','Bilanss - Ã¼ksikasjalik uuring',0),(250357,6955,'si','Bilanca stanja - podrobne sojenja',0),(250358,6955,'ba','Neraca - rinci Trial',0),(250359,6955,'nl','Balans - gedetailleerde proces',0),(250360,6955,'fi','Tase - yksityiskohtaiset oikeudenkÃ¤ynti',0),(250361,6955,'no','Balanse - detaljert prÃ¸veversjon',0),(250362,6955,'da','Balancen - detaljerede retssag',0),(250363,6955,'ko','ëŒ€ì°¨ ëŒ€ì¡°í‘œ-ìƒì„¸í•œ ìž¬íŒ',0),(250364,6955,'he','×ž××–×Ÿ - ×ž×©×¤×˜ ×ž×¤×•×¨×˜',0),(250365,6955,'el','Î™ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ - Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¯Ï‚ Î´Î¯ÎºÎ·',0),(250366,6955,'zh','è¯¦ç»†çš„è¯•éªŒèµ„äº§è´Ÿå€ºè¡¨\r\n',0),(250367,6955,'sv','BalansrÃ¤kning - detaljerad rÃ¤ttegÃ¥ng',0),(250368,6955,'it','Stato patrimoniale - prova dettagliata',0),(250369,6955,'tl','',0),(250370,6955,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3607;&#3635;&#3585;&#3634;&#3619;&#3591;&#3610;&#3607;&#3604;&#3621;&#3629;&#3591;',0),(250371,6955,'hi','à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ - à¤µà¤¿à¤¸à¥à¤¤à¥ƒà¤¤ à¤ªà¤°à¥€à¤•à¥à¤·à¤£',0),(250372,6955,'ms','Lembaran imbangan - perbicaraan yang terperinci',0),(250373,6955,'ar','Ù…ÙŠØ²Ø§Ù† Ø§Ù„Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ù…ÙØµÙ‘Ù„',0),(250374,6955,'fr','Bilan - essai dÃ©taillÃ©',0),(250375,6955,'jp','ãƒãƒ©ãƒ³ã‚¹ ã‚·ãƒ¼ãƒˆ - è©³ç´°ãªè©¦é¨“',0),(250376,6955,'pt','BalanÃ§o - julgamento detalhado',0),(250377,6955,'ru','Ð‘Ð°Ð»Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚ - Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾Ð³Ð¾ Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(250378,6955,'es','Balance de ComprobaciÃ³n Detallada',0),(250379,6955,'de','Bilanz - detaillierte Studie',0),(250380,6955,'en','Balance Sheet - Detailed Trial',0),(250381,6956,'is','',0),(250382,6956,'dr','( Ù¾Ø§ÙŠØ§Ù† Ø¨ÛŒÙ„Ø§Ù†Ø³',0),(250383,6956,'pr','ØªÙƒÙ…ÙŠÙ„ ØªØ±Ø§Ø² ( Ù¾Ø§ÙŠØ§Ù† ØªØ±Ø§Ø²',0),(250384,6956,'tr','Sonunda denge',0),(250385,6956,'pl','Salda koÅ„cowego',0),(250386,6956,'bg','ÐšÑ€Ð°Ð¹ Ð±Ð°Ð»Ð°Ð½Ñ',0),(250387,6956,'ur','Ø¢Ø®Ø± ØªÙˆØ§Ø²Ù†',0),(250388,6956,'sr','Ð¡Ð°Ð»Ð´Ð¾ Ð½Ð° ÐºÑ€Ð°Ñ˜Ñƒ',0),(250389,6956,'vi','Sá»‘ dÆ° cuá»‘i',0),(250390,6956,'af','End Balans',0),(250391,6956,'ro','Sold final',0),(250392,6956,'et','LÃµpu saldo',0),(250393,6956,'si','KonÄni saldo',0),(250394,6956,'ba','Saldo akhir',0),(250395,6956,'nl','Einde evenwicht',0),(250396,6956,'fi','Vuoden saldo',0),(250397,6956,'no','Slutten balanse',0),(250398,6956,'da','Ende Balance',0),(250399,6956,'ko','ìµœì¢… ìž”ì•¡',0),(250400,6956,'he','×¡×•×£ ××™×–×•×Ÿ',0),(250401,6956,'el','Î¤Î­Î»Î¿Ï‚ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±',0),(250402,6956,'zh','å¹´æœ«ä½™é¢',0),(250403,6956,'sv','Slutet balans',0),(250404,6956,'it','Saldo di fine',0),(250405,6956,'tl','',0),(250406,6956,'th','&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3626;&#3636;&#3657;&#3609;&#3591;&#3623;&#3604;',0),(250407,6956,'hi','à¤…à¤‚à¤¤ à¤¸à¤‚à¤¤à¥à¤²à¤¨',0),(250408,6956,'ms','Baki akhir',0),(250409,6956,'ar','Ø±ØµÙŠØ¯ Ù†Ù‡Ø§ÙŠØ©',0),(250410,6956,'fr','Solde fin',0),(250411,6956,'jp','æœŸæœ«æ®‹é«˜',0),(250412,6956,'pt','Saldo final',0),(250413,6956,'ru','ÐšÐ¾Ð½ÐµÑ‡Ð½Ð¾Ðµ ÑÐ°Ð»ÑŒÐ´Ð¾',0),(250414,6956,'es','Saldo Final',0),(250415,6956,'de','Endsaldo',0),(250416,6956,'en','End Balance',0),(250417,6957,'is','',0),(250418,6957,'dr','Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(250419,6957,'pr','Ù…Ø±ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(250420,6957,'tr','GL maliyet merkezi',0),(250421,6957,'pl','GL MPK',0),(250422,6957,'bg','GL Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(250423,6957,'ur','Ø¬ÛŒØ¬Û’ Ù„Ø§Ú¯Øª Ù…Ø±Ú©Ø²',0),(250424,6957,'sr','Ð“Ð› Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ÑÐºÑƒ',0),(250425,6957,'vi','Cost Center Sá»• CÃ¡i Tá»•ng Há»£p',0),(250426,6957,'af','AG Koste Sentrum',0),(250427,6957,'ro','Centrul de Cost GL',0),(250428,6957,'et','GL Kulukeskus',0),(250429,6957,'si','GL stroÅ¡kovno srediÅ¡Äe',0),(250430,6957,'ba','GL biaya Pusat',0),(250431,6957,'nl','GL kostenplaats',0),(250432,6957,'fi','GL kustannuspaikka',0),(250433,6957,'no','GL kostsenter',0),(250434,6957,'da','GL omkostningssted',0),(250435,6957,'ko','GL ë¹„ìš© ì„¼í„°',0),(250436,6957,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª GL',0),(250437,6957,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ GL',0),(250438,6957,'zh','æ€»å¸æˆæœ¬ä¸­å¿ƒ\r\n',0),(250439,6957,'sv','GL kostnadsstÃ¤lle',0),(250440,6957,'it','Centro di costo GL',0),(250441,6957,'tl','',0),(250442,6957,'th','&#3624;&#3641;&#3609;&#3618;&#3660;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(250443,6957,'hi','à¤œà¥€à¤à¤² à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(250444,6957,'ms','Pusat kos GL',0),(250445,6957,'ar','Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(250446,6957,'fr','Centre de coÃ»t GL',0),(250447,6957,'jp','GL ã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼',0),(250448,6957,'pt','Centro de custo GL',0),(250449,6957,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ GL',0),(250450,6957,'es','LM Centro de Costos',0),(250451,6957,'de','GL-Kostenstelle',0),(250452,6957,'en','GL Cost Center',0),(250453,6958,'is','',0),(250454,6958,'dr','Ø´Ø§Ù…Ù„ ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ø¨Ø§ Ù‡Ù…',0),(250455,6958,'pr','Ø´Ø§Ù…Ù„ ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ø¨Ø§ Ù‡Ù…',0),(250456,6958,'tr','Birlikte tÃ¼m ÅŸirketlerin dahil',0),(250457,6958,'pl','ObejmujÄ… wszystkie przedsiÄ™biorstwa razem',0),(250458,6958,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ„Ð¸Ñ€Ð¼Ð¸ Ð·Ð°ÐµÐ´Ð½Ð¾',0),(250459,6958,'ur','ØªÙ…Ø§Ù… Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ú©Ùˆ Ø§ÛŒÚ© Ø¯ÙˆØ³Ø±Û’ Ú©Û’ Ø³Ø§ØªÚ¾ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(250460,6958,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÑÐ²Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð·Ð°Ñ˜ÐµÐ´Ð½Ð¾',0),(250461,6958,'vi','Bao gá»“m táº¥t cáº£ cÃ¡c cty',0),(250462,6958,'af','Sluit Alle Ondernemings Tesame In',0),(250463,6958,'ro','Include toate companiile Ã®mpreunÄƒ',0),(250464,6958,'et','Lisada kÃµigile ettevÃµtetele kokku',0),(250465,6958,'si','VkljuÄuje vsa podjetja skupaj',0),(250466,6958,'ba','Termasuk semua perusahaan bersama-sama',0),(250467,6958,'nl','Tevens alle bedrijven samen',0),(250468,6958,'fi','SisÃ¤ltÃ¤Ã¤ kaikkien yritysten yhdessÃ¤',0),(250469,6958,'no','Inkluder alle selskaper sammen',0),(250470,6958,'da','Omfatte alle regnskaber sammen',0),(250471,6958,'ko','ëª¨ë“  íšŒì‚¬ë¥¼ í•¨ê»˜ í¬í•¨',0),(250472,6958,'he','× ×ž× ×•×ª ×—×‘×¨×•×ª ×”×›×œ ×‘×™×—×“',0),(250473,6958,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚ ÏŒÎ»Î± Î¼Î±Î¶Î¯',0),(250474,6958,'zh','åŒ…æ‹¬æ‰€æœ‰å…¬å¸ä¸€èµ·\r\n',0),(250475,6958,'sv','Inkludera alla fÃ¶retag tillsammans',0),(250476,6958,'it','Includono tutte le aziende insieme',0),(250477,6958,'tl','',0),(250478,6958,'th','&#3619;&#3623;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3607;&#3640;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3648;&#3586;&#3657;&#3634;&#3604;&#3657;&#3623;&#3618;&#3585;&#3633;&#3609;',0),(250479,6958,'hi','à¤¸à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤à¤• à¤¸à¤¾à¤¥ à¤¶à¤¾à¤®à¤¿à¤²',0),(250480,6958,'ms','Termasuk syarikat-syarikat semua bersama-sama',0),(250481,6958,'ar','ÙˆØªØ´Ù…Ù„ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´Ø±ÙƒØ§Øª Ù…Ø¹Ø§',0),(250482,6958,'fr','Inclure toutes les entreprises ensemble',0),(250483,6958,'jp','ä¸€ç·’ã«ã™ã¹ã¦ã®ä¼æ¥­ãŒå«ã¾ã‚Œã¾ã™',0),(250484,6958,'pt','Incluem todas as empresas juntas',0),(250485,6958,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð’ÑÐµ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð’Ð¼ÐµÑÑ‚Ðµ',0),(250486,6958,'es','Incluir Todas las Empresas Juntas',0),(250487,6958,'de','Alle Mandanten zusammen gehÃ¶ren',0),(250488,6958,'en','Include All Companies Together',0),(250489,6959,'is','',0),(250490,6959,'dr','ØªÙ†Ù‡Ø§ Ø²Ù…Ø§Ù†ÙŠ ÙƒØ§Ø± Ù…ÙŠ ÙƒÙ†Ø¯ Ø§Ú¯Ø± ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ ÙŠÙƒØ³Ø§Ù† Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ù†Ø¯ ',0),(250491,6959,'pr','ØªÙ†Ù‡Ø§ Ø²Ù…Ø§Ù†ÙŠ ÙƒØ§Ø± Ù…ÙŠ ÙƒÙ†Ø¯ Ø§Ú¯Ø± ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ Ø³Ø§Ù„ Ù…Ø§Ù„ÙŠ ÙŠÙƒØ³Ø§Ù† Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ù†Ø¯ ',0),(250492,6959,'tr','<small>TÃ¼m ÅŸirketlere aynÄ± mali yÄ±l varsa sadece Ã§alÄ±ÅŸÄ±r</small>',0),(250493,6959,'pl','<small>DziaÅ‚a tylko, jeÅ›li wszystkie przedsiÄ™biorstwa majÄ… tego samego roku obrachunkowego</small>',0),(250494,6959,'bg','<small>Ð Ð°Ð±Ð¾Ñ‚Ð¸ ÑÐ°Ð¼Ð¾, Ð°ÐºÐ¾ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ñ€ÑƒÐ¶ÐµÑÑ‚Ð²Ð° Ð¸Ð¼Ð°Ñ‚ ÑÑŠÑ‰Ð°Ñ‚Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°</small>',0),(250495,6959,'ur','<small>Ø§Ú¯Ø± ØªÙ…Ø§Ù… Ú©Ù…Ù¾Ù†ÛŒØ§Úº Ø§Ø³ÛŒ Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ ØµØ±Ù Ú©Ø§Ù… Ú©Ø±ØªØ§ ÛÛ’</small>',0),(250496,6959,'sr','<small>Ð Ð°Ð´Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÑÐ²Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸Ð¼Ð°Ñ˜Ñƒ Ð¸ÑÑ‚Ð¸ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ</small>',0),(250497,6959,'vi','Chá»‰ lÃ m Ä‘Æ°á»£c khi táº¥t cáº£ cty cÃ³ cÃ¹ng nÄƒm tÃ i chÃ­nh',0),(250498,6959,'af','Werk Slegs as Alle Ondernemings Dieselfde Fisiese Jaar Het',0),(250499,6959,'ro','<small>FuncÅ£ioneazÄƒ numai Ã®n cazul Ã®n care toate companiile au acelasi an Fiscal</small>',0),(250500,6959,'et','<small>TÃ¶Ã¶tab ainult siis kui kÃµik ettevÃµtted peavad sama majandusaasta</small>',0),(250501,6959,'si','<small>Deluje le, Äe vse druÅ¾be imajo istega poslovnega leta</small>',0),(250502,6959,'ba','<small>Hanya bekerja jika semua perusahaan mempunyai tahun fiskal yang sama</small>',0),(250503,6959,'nl','<small>Werkt alleen als alle bedrijven hebben dezelfde fiscale jaar</small>',0),(250504,6959,'fi','<small>Toimii vain, jos kaikki yritykset ovat samalla tilikaudella</small>',0),(250505,6959,'no','<small>Fungerer bare hvis alle bedrifter har samme regnskapsÃ¥r</small>',0),(250506,6959,'da','<small>Virker kun, hvis alle virksomheder har samme regnskabsÃ¥r</small>',0),(250507,6959,'ko','<small>ëª¨ë“  íšŒì‚¬ëŠ” ë™ì¼í•œ íšŒê³„ ì—°ë„ì˜ ê²½ìš°ì— ìž‘ë™</small>',0),(250508,6959,'he','<small>×¢×•×‘×“ ×¨×§ ×× ×›×œ ×”×—×‘×¨×•×ª ×™×© ×‘××•×ª×” ×©× ×ª ×›×¡×¤×™×</small>',0),(250509,6959,'el','<small>Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³ÎµÎ¯ Î¼ÏŒÎ½Î¿ ÎµÎ¬Î½ ÏŒÎ»ÎµÏ‚ Î¿Î¹ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Î­Ï‡Î¿Ï…Î½ Ï„Î¿ Î¯Î´Î¹Î¿ Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚</small>',0),(250510,6959,'zh','åªæœ‰å½“æ‰€æœ‰å…¬å¸æœ‰åŒä¸€è´¢å¹´æ—¶å·¥ä½œ\r\n',0),(250511,6959,'sv','<small>Fungerar bara om alla fÃ¶retag har samma rÃ¤kenskapsÃ¥r</small>',0),(250512,6959,'it','<small>Funziona solo se tutte le aziende hanno stesso anno fiscale</small>',0),(250513,6959,'tl','',0),(250514,6959,'th','&#3607;&#3635;&#3591;&#3634;&#3609;&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3607;&#3640;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3617;&#3637;&#3611;&#3637;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3',0),(250515,6959,'hi','<small>à¤¯à¤¦à¤¿ à¤¸à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¤¾à¤‚ à¤à¤• à¤¹à¥€ à¤µà¤¿à¤¤à¥à¤¤à¥€à¤¯ à¤µà¤°à¥à¤· à¤•à¥‡à¤µà¤² à¤•à¤¾à¤® à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ</small>',0),(250516,6959,'ms','<small>Hanya bekerja jika semua syarikat yang mempunyai tahun fiskal yang sama</small>',0),(250517,6959,'ar','<small>ÙŠØ¹Ù…Ù„ ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø¯Ù‰ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´Ø±ÙƒØ§Øª Ù†ÙØ³ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ©</small>',0),(250518,6959,'fr','<small>Ne fonctionne que si toutes les sociÃ©tÃ©s ont le mÃªme exercice</small>',0),(250519,6959,'jp','<small>ã™ã¹ã¦ã®ä¼æ¥­ãŒåŒä¸€å¹´åº¦ã§ã‚ã‚‹å ´åˆã®ã¿å‹•ä½œã—ã¾ã™</small>',0),(250520,6959,'pt','<small>SÃ³ funciona se todas as empresas tÃªm o mesmo ano Fiscal</small>',0),(250521,6959,'ru','<small>Ð Ð°Ð±Ð¾Ñ‚Ð°ÐµÑ‚ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð²ÑÐµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð¼ÐµÑŽÑ‚ Ð¶Ðµ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´</small>',0),(250522,6959,'es','Solo Funciona si Todas las Empresas Tienen El Mismo Ejercicio Fiscal',0),(250523,6959,'de','<small>Funktioniert nur, wenn alle Unternehmen eines GeschÃ¤ftsjahres haben</small>',0),(250524,6959,'en','<small>Only Works if All Companies Have Same Fiscal Year</small>',0),(250525,6960,'is','',0),(250526,6960,'dr','Ø±Ø³ÙŠØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(250527,6960,'pr','Ø±Ø³ÙŠØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(250528,6960,'tr','Maliyet bilgisi',0),(250529,6960,'pl','Koszty odbioru',0),(250530,6960,'bg','Ð¦ÐµÐ½Ð° Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ°',0),(250531,6960,'ur','Ù„Ø§Ú¯Øª Ø±Ø³ÛŒØ¯',0),(250532,6960,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð°',0),(250533,6960,'vi','BiÃªn nháº­n giÃ¡ thÃ nh',0),(250534,6960,'af','Koste ontvangs',0),(250535,6960,'ro','Primirea cost',0),(250536,6960,'et','Kulude saamise',0),(250537,6960,'si','StroÅ¡ek prevzema',0),(250538,6960,'ba','Biaya penerimaan',0),(250539,6960,'nl','Kosten ontvangst',0),(250540,6960,'fi','Kustannusten kuitti',0),(250541,6960,'no','Pris bekreftelse',0),(250542,6960,'da','Omkostninger modtagelse',0),(250543,6960,'ko','ë¹„ìš©ëœ ì˜ìˆ˜ì¦',0),(250544,6960,'he','×¢×œ×•×ª ×§×‘×œ×ª',0),(250545,6960,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï€Î±ÏÎ±Î»Î±Î²Î®Ï‚',0),(250546,6960,'zh','è´¹ç”¨æ”¶æ®\r\n',0),(250547,6960,'sv','Kostnad kvitto',0),(250548,6960,'it','Costo ricezione',0),(250549,6960,'tl','',0),(250550,6960,'th','&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(250551,6960,'hi','à¤²à¤¾à¤—à¤¤ à¤°à¤¸à¥€à¤¦',0),(250552,6960,'ms','Resit kos',0),(250553,6960,'ar','Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„ØªÙƒÙ„ÙØ©',0),(250554,6960,'fr','CoÃ»t de rÃ©ception',0),(250555,6960,'jp','è²»ç”¨ã®é ˜åŽæ›¸',0),(250556,6960,'pt','Recibo de custo',0),(250557,6960,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ',0),(250558,6960,'es','Costo Recibo de',0),(250559,6960,'de','Kosten Eingang',0),(250560,6960,'en','Cost Receipt',0),(250561,6961,'is','',0),(250562,6961,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(250563,6961,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(250564,6961,'tr','Hareketleri iÃ§e aktarma',0),(250565,6961,'pl','Importowanie transakcji',0),(250566,6961,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(250567,6961,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(250568,6961,'sr','Ð£Ð²Ð¾Ð· Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(250569,6961,'vi','Nháº­p giao dá»‹ch',0),(250570,6961,'af','Invoer van Transaksies',0),(250571,6961,'ro','TranzacÅ£iile de import',0),(250572,6961,'et','Kannete importimine',0),(250573,6961,'si','Uvoz transakcij',0),(250574,6961,'ba','Impor transaksi',0),(250575,6961,'nl','Importeer transacties',0),(250576,6961,'fi','Tuo tapahtumat',0),(250577,6961,'no','Importere transaksjoner',0),(250578,6961,'da','Importtransaktioner',0),(250579,6961,'ko','ê°€ì ¸ì˜¤ê¸° ê±°ëž˜',0),(250580,6961,'he','×¢×¡×§××•×ª ×™×™×‘×•×',0),(250581,6961,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(250582,6961,'zh','å¯¼å…¥äº¤æ˜“\r\n',0),(250583,6961,'sv','Importera transaktioner',0),(250584,6961,'it','Operazioni di importazione',0),(250585,6961,'tl','',0),(250586,6961,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(250587,6961,'hi','à¤†à¤¯à¤¾à¤¤ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨',0),(250588,6961,'ms','Urus niaga import',0),(250589,6961,'ar','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(250590,6961,'fr','Transactions d\'importation',0),(250591,6961,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(250592,6961,'pt','OperaÃ§Ãµes de importaÃ§Ã£o',0),(250593,6961,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð½Ñ‹Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(250594,6961,'es','Importar Transacciones',0),(250595,6961,'de','Import-Transaktionen',0),(250596,6961,'en','Import Transactions',0),(250597,6962,'is','',0),(250598,6962,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§ ',0),(250599,6962,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§ ',0),(250600,6962,'tr','TarafÄ±ndan Ã¶denen',0),(250601,6962,'pl','WypÅ‚acane przez',0),(250602,6962,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ Ð¾Ñ‚',0),(250603,6962,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø¯Ø§ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(250604,6962,'sr','ÐŸÐ»Ð°Ñ›Ð°Ñ˜Ñƒ',0),(250605,6962,'vi','Tráº£ bá»Ÿi',0),(250606,6962,'af','Betaal Per',0),(250607,6962,'ro','PlÄƒtite de',0),(250608,6962,'et','Poolt',0),(250609,6962,'si','PlaÄa',0),(250610,6962,'ba','Dibayar oleh',0),(250611,6962,'nl','Betaald door',0),(250612,6962,'fi','Maksama',0),(250613,6962,'no','Betalt av',0),(250614,6962,'da','Betalt af',0),(250615,6962,'ko','í•˜ ì—¬ ì§€ê¸‰',0),(250616,6962,'he','×©×•×œ× ×¢×œ ×™×“×™',0),(250617,6962,'el','ÎšÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ',0),(250618,6962,'zh','æ”¯ä»˜æ‰‹æ®µ\r\n',0),(250619,6962,'sv','Betalas av',0),(250620,6962,'it','Pagato dal',0),(250621,6962,'tl','',0),(250622,6962,'th','&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;&#3650;&#3604;&#3618;',0),(250623,6962,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(250624,6962,'ms','Dibayar oleh',0),(250625,6962,'ar','Ø§Ù„ØªÙŠ ÙŠØ¯ÙØ¹Ù‡Ø§',0),(250626,6962,'fr','PayÃ© par',0),(250627,6962,'jp','ã«ã‚ˆã£ã¦æ”¯æ‰•ã‚ã‚Œã¾ã—ãŸã€‚',0),(250628,6962,'pt','Pago pelo',0),(250629,6962,'ru','ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ñ‹',0),(250630,6962,'es','Pagado Por',0),(250631,6962,'de','Gezahlten',0),(250632,6962,'en','Paid By',0),(250633,6963,'is','',0),(250634,6963,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯ Ø¨Ù‡ ',0),(250635,6963,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯ Ø¨Ù‡ ',0),(250636,6963,'tr','Ã–denen',0),(250637,6963,'pl','WypÅ‚acane',0),(250638,6963,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ Ð½Ð°',0),(250639,6963,'ur','Ø§Ø¯Ø§ Ú©Ø±Ù†Ø§',0),(250640,6963,'sr','Ð”Ð° Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(250641,6963,'vi','Tráº£ cho',0),(250642,6963,'af','Betaal Aan',0),(250643,6963,'ro','PlÄƒtit pentru a',0),(250644,6963,'et','Paide',0),(250645,6963,'si','Nameniti',0),(250646,6963,'ba','Dibayar untuk',0),(250647,6963,'nl','Besteed aan',0),(250648,6963,'fi','Maksetaan',0),(250649,6963,'no','Betalt til',0),(250650,6963,'da','Betalt til',0),(250651,6963,'ko','ì— ê²Œ ì§€ë¶ˆ',0),(250652,6963,'he','×©×™×œ× ×œ',0),(250653,6963,'el','ÎšÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ ÏƒÎµ',0),(250654,6963,'zh','ä»˜è‡³\r\n',0),(250655,6963,'sv','Betalas till',0),(250656,6963,'it','Pagato per',0),(250657,6963,'tl','',0),(250658,6963,'th','&#3592;&#3656;&#3634;&#3618;&#3606;&#3638;&#3591;',0),(250659,6963,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(250660,6963,'ms','Dibayar kepada',0),(250661,6963,'ar','ØªØ¯ÙØ¹ Ø¥Ù„Ù‰',0),(250662,6963,'fr','PayÃ© Ã ',0),(250663,6963,'jp','æ”¯æ‰•ã‚ã‚Œã‚‹',0),(250664,6963,'pt','Pago para',0),(250665,6963,'ru','Ð£Ð´ÐµÐ»ÐµÐ½Ð¾',0),(250666,6963,'es','Pagado A',0),(250667,6963,'de','Gewidmet',0),(250668,6963,'en','Paid To',0),(250669,6964,'is','',0),(250670,6964,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(250671,6964,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(250672,6964,'tr','Ä°ÅŸlem kimliÄŸi',0),(250673,6964,'pl','Identyfikator transakcji',0),(250674,6964,'bg','Ð˜Ð” Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(250675,6964,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(250676,6964,'sr','Ð˜Ð” Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(250677,6964,'vi','ID Giao dá»‹ch ',0),(250678,6964,'af','Transaksie ID',0),(250679,6964,'ro','Transaction ID',0),(250680,6964,'et','Kande ID',0),(250681,6964,'si','ID posla',0),(250682,6964,'ba','ID transaksi',0),(250683,6964,'nl','Transactie-ID',0),(250684,6964,'fi','Tapahtumatunnus',0),(250685,6964,'no','Transaksjons-ID',0),(250686,6964,'da','Transaktions-ID',0),(250687,6964,'ko','íŠ¸ëžœìž­ì…˜ ID',0),(250688,6964,'he','×ž×–×”×” ×ª× ×•×¢×”',0),(250689,6964,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(250690,6964,'zh','äº¤æ˜“å¸å·\r\n',0),(250691,6964,'sv','Transaktions-ID',0),(250692,6964,'it','ID transazione',0),(250693,6964,'tl','',0),(250694,6964,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(250695,6964,'hi','à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤†à¤ˆà¤¡à¥€',0),(250696,6964,'ms','ID transaksi',0),(250697,6964,'ar','Ù…Ø¹Ø±Ù‘Ù Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(250698,6964,'fr','ID de transaction',0),(250699,6964,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ID',0),(250700,6964,'pt','ID da transaÃ§Ã£o',0),(250701,6964,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(250702,6964,'es','ID de TransacciÃ³n',0),(250703,6964,'de','Transaktions-ID',0),(250704,6964,'en','Transaction ID',0),(250705,6965,'is','',0),(250706,6965,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„',0),(250707,6965,'pr','ØªØ§Ø±ÙŠØ® Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„',0),(250708,6965,'tr','Transfer tarihi',0),(250709,6965,'pl','Data przekazania',0),(250710,6965,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ',0),(250711,6965,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(250712,6965,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÐ½Ð¾ÑÐ°',0),(250713,6965,'vi','NgÃ y Giao dá»‹ch',0),(250714,6965,'af','Oorplasings Datum',0),(250715,6965,'ro','Data transferului',0),(250716,6965,'et','Ãœlekandmise kuupÃ¤ev',0),(250717,6965,'si','Datum prenosa',0),(250718,6965,'ba','Tanggal transfer',0),(250719,6965,'nl','Datum van overdracht',0),(250720,6965,'fi','Siirron pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(250721,6965,'no','OverfÃ¸ringsdato',0),(250722,6965,'da','OverfÃ¸rselsdato',0),(250723,6965,'ko','ì „ì†¡ ë‚ ì§œ',0),(250724,6965,'he','×ª××¨×™×š ×”×¢×‘×¨×ª',0),(250725,6965,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚',0),(250726,6965,'zh','è½¬è®©æ—¥æœŸ\r\n',0),(250727,6965,'sv','Ã–verfÃ¶ringsdatum',0),(250728,6965,'it','Data del trasferimento',0),(250729,6965,'tl','',0),(250730,6965,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(250731,6965,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(250732,6965,'ms','Tarikh pemindahan',0),(250733,6965,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ­ÙˆÙŠÙ„',0),(250734,6965,'fr','Date de transfert',0),(250735,6965,'jp','è­²æ¸¡æ—¥',0),(250736,6965,'pt','Data de transferÃªncia',0),(250737,6965,'ru','Ð”Ð°Ñ‚Ð° Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(250738,6965,'es','Fecha de Transferencia',0),(250739,6965,'de','Umbuchungsdatum',0),(250740,6965,'en','Transfer Date',0),(250741,6966,'is','',0),(250742,6966,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„',0),(250743,6966,'pr','Ù†ÙˆØ¹ Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„',0),(250744,6966,'tr','AktarÄ±m TÃ¼rÃ¼',0),(250745,6966,'pl','Typ transferu',0),(250746,6966,'bg','Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€ Ñ‚Ð¸Ð¿',0),(250747,6966,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(250748,6966,'sr','Ð¢Ð¸Ð¿ Ð¿Ñ€ÐµÐ½Ð¾ÑÐ°',0),(250749,6966,'vi','Loáº¡i Giao dá»‹ch',0),(250750,6966,'af','Oordrag Tipe',0),(250751,6966,'ro','Tip transfer',0),(250752,6966,'et','Ãœlekande tÃ¼Ã¼p',0),(250753,6966,'si','Vrsta prenosa',0),(250754,6966,'ba','Jenis mentransfer',0),(250755,6966,'nl','Overdrachttype',0),(250756,6966,'fi','Siirto tyyppi',0),(250757,6966,'no','OverfÃ¸ringstypen',0),(250758,6966,'da','OverfÃ¸rselstypen',0),(250759,6966,'ko','ì „ì†¡ ìœ í˜•',0),(250760,6966,'he','×¡×•×’ ×”×¢×‘×¨×”',0),(250761,6966,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¹ÎºÏŒ Î¼Î­ÏƒÎ¿',0),(250762,6966,'zh','è½¬ç§»ç±»åž‹\r\n',0),(250763,6966,'sv','Ã–verfÃ¶ringstyp',0),(250764,6966,'it','Tipo di trasferimento',0),(250765,6966,'tl','',0),(250766,6966,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(250767,6966,'hi','à¤…à¤‚à¤¤à¤°à¤£ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(250768,6966,'ms','Jenis pemindahan',0),(250769,6966,'ar','Ù†ÙˆØ¹ Ø§Ù„ØªØ­ÙˆÙŠÙ„',0),(250770,6966,'fr','Type de transfert',0),(250771,6966,'jp','è»¢é€ã®ç¨®é¡ž',0),(250772,6966,'pt','Tipo de transferÃªncia',0),(250773,6966,'ru','Ð¢Ð¸Ð¿ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(250774,6966,'es','Tipo de Transferencia',0),(250775,6966,'de','Transfertyp',0),(250776,6966,'en','Transfer Type',0),(250777,6967,'is','',0),(250778,6967,'dr','. Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(250779,6967,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙŠØ³Øª . Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(250780,6967,'tr','Yapamaz-e doÄŸru gÃ¼ncelleÅŸtirmek, yeniden deneyin',0),(250781,6967,'pl','Stanie aktualizacji, sprÃ³buj ponownie',0),(250782,6967,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°, Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(250783,6967,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚºØŒ Ù¾Ú¾Ø± Ú©ÙˆØ´Ø´ Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(250784,6967,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ, Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(250785,6967,'vi','KhÃ´ng thá»ƒ cáº­p nháº­t, thá»­ láº¡i',0),(250786,6967,'af','Opdatering Onmoontlik, Probeer Weer',0),(250787,6967,'ro','Imposibilitatea de a actualiza, Ã®ncercaÅ£i din nou',0),(250788,6967,'et','Ei saa vÃ¤rskendada, proovige uuesti',0),(250789,6967,'si','Ni mogoÄe posodobiti, poskusite znova',0),(250790,6967,'ba','Tidak dapat memperbarui, coba lagi',0),(250791,6967,'nl','Niet in staat om te werken, probeer het opnieuw',0),(250792,6967,'fi','Ei voi pÃ¤ivittÃ¤Ã¤, yritÃ¤ uudelleen',0),(250793,6967,'no','Kan ikke oppdatere, prÃ¸v pÃ¥ nytt',0),(250794,6967,'da','Stand til at opdatere, prÃ¸v igen',0),(250795,6967,'ko','ì—…ë°ì´íŠ¸ë¥¼ ë‹¤ì‹œ ì‹œë„ í•˜ì‹­ì‹œì˜¤ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(250796,6967,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×¢×“×›×Ÿ, × × ×¡×” ×©×•×‘',0),(250797,6967,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·, Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(250798,6967,'zh','æ— æ³•æ›´æ–°ï¼Œè¯·å†è¯•ä¸€æ¬¡\r\n',0),(250799,6967,'sv','Det gick inte att uppdatera, fÃ¶rsÃ¶k igen',0),(250800,6967,'it','Impossibile aggiornare, riprova',0),(250801,6967,'tl','',0),(250802,6967,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3652;&#3604;&#3657;, &#3621;&#3629;&#3591;&#3629;&#3633;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(250803,6967,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚, à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(250804,6967,'ms','Tidak dapat mengemaskini, cuba lagi',0),(250805,6967,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ ØªØ­Ø¯ÙŠØ«ØŒ ÙˆØ­Ø§ÙˆÙ„ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(250806,6967,'fr','Impossible de mettre Ã  jour, essayez Ã  nouveau',0),(250807,6967,'jp','æ›´æ–°ã¯ã‚’ã‚‚ã†ä¸€åº¦ã‚„ã‚Šç›´ã—ã¦ãã ã•ã„ã™ã‚‹ã«ã¯ã€ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(250808,6967,'pt','NÃ£o Ã© possÃ­vel atualizar, tente novamente',0),(250809,6967,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ, Ð¿Ð¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÐµÑ‰Ðµ Ñ€Ð°Ð·',0),(250810,6967,'es','No se Puede Actualizar, Intenta Otra Vez',0),(250811,6967,'de','Nicht in der Lage zu aktualisieren, versuchen Sie es erneut',0),(250812,6967,'en','Unable To Update, Try Again',0),(250813,6968,'is','',0),(250814,6968,'dr','(Ø¨ÛŒÙ„Ø§Ù†Ø³ Ø­Ø³Ø§Ø¨Ù‡Ø§ ',0),(250815,6968,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ØªØ±Ø§Ø²Ù‡Ø§(Ù…Ø§Ù†Ø¯Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ ',0),(250816,6968,'tr','Alma bakiyeleri',0),(250817,6968,'pl','PrzywÃ³z salda',0),(250818,6968,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ð»Ð°Ð½ÑÐ¸',0),(250819,6968,'ur','Ø¨ÛŒÙ„Ù†Ø³ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(250820,6968,'sr','Ð£Ð²Ð¾Ð· ÑÐ°Ð»Ð´Ð°',0),(250821,6968,'vi','Nháº­p báº£ng cÃ¢n Ä‘á»‘i',0),(250822,6968,'af','Invoer Balanse',0),(250823,6968,'ro','Soldurile de import',0),(250824,6968,'et','Impordi saldo',0),(250825,6968,'si','Uvozne bilance',0),(250826,6968,'ba','Impor saldo',0),(250827,6968,'nl','Importeren van saldi',0),(250828,6968,'fi','Tuo saldot',0),(250829,6968,'no','Importere saldoer',0),(250830,6968,'da','Importere saldi',0),(250831,6968,'ko','ê· í˜•ì„ ê°€ì ¸ì˜¬',0),(250832,6968,'he','×™×™×‘×•× ×™×ª×¨×•×ª',0),(250833,6968,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³ÏŽÎ½ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î±',0),(250834,6968,'zh','å¯¼å…¥ä½™é¢\r\n',0),(250835,6968,'sv','Importera saldon',0),(250836,6968,'it','Importare i saldi',0),(250837,6968,'tl','',0),(250838,6968,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(250839,6968,'hi','à¤¶à¥‡à¤· à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(250840,6968,'ms','Baki import',0),(250841,6968,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø£Ø±ØµØ¯Ø©',0),(250842,6968,'fr','Importer des soldes',0),(250843,6968,'jp','æ®‹é«˜ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(250844,6968,'pt','ImportaÃ§Ã£o de saldos',0),(250845,6968,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ°Ð»ÑŒÐ´Ð¾',0),(250846,6968,'es','Importar Balances',0),(250847,6968,'de','Import-Guthaben',0),(250848,6968,'en','Import Balances',0),(250849,6969,'is','',0),(250850,6969,'dr','ÙˆØ±ÙˆØ¯ ÙØ§ÙŠÙ„ ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡',0),(250851,6969,'pr','ÙˆØ±ÙˆØ¯ ÙØ§ÙŠÙ„ ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡',0),(250852,6969,'tr','Alma DistribÃ¼tÃ¶r satÄ±ÅŸ',0),(250853,6969,'pl','PrzywÃ³z dystrybutora sprzedaÅ¼y',0),(250854,6969,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¾Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(250855,6969,'ur','ÚˆØ³Ù¹Ø±ÛŒØ¨ÛŒÙˆÙ¹Ø± Ø³ÛŒÙ„Ø² Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(250856,6969,'sr','Ð£Ð²Ð¾Ð· Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚ÐµÑ€ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(250857,6969,'vi','Nháº­p há»“ sÆ¡ phÃ¢n phá»‘i',0),(250858,6969,'af','GroothandelaarlÃªer Invoer',0),(250859,6969,'ro','VÃ¢nzÄƒri de distribuitor de import',0),(250860,6969,'et','Impordi turustaja mÃ¼Ã¼k',0),(250861,6969,'si','Uvoz distributer prodaje',0),(250862,6969,'ba','Impor Distributor penjualan',0),(250863,6969,'nl','Importeren van distributeur verkoop',0),(250864,6969,'fi','Tuonti jakelija myynti',0),(250865,6969,'no','Import DistributÃ¸r salg',0),(250866,6969,'da','Import forhandler salg',0),(250867,6969,'ko','ìˆ˜ìž… ëŒ€ë¦¬ì  íŒë§¤',0),(250868,6969,'he','×™×™×‘×•× ×ž×¤×™×¥ ×ž×›×™×¨×•×ª',0),(250869,6969,'el','Î”Î¹Î±Î½Î¿Î¼Î­Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(250870,6969,'zh','ç»é”€å•†æ–‡ä»¶å¯¼å…¥\r\n',0),(250871,6969,'sv','Importera distributÃ¶r fÃ¶rsÃ¤ljning',0),(250872,6969,'it','Importazione distributore vendite',0),(250873,6969,'tl','',0),(250874,6969,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3652;&#3615;&#3621;&#3660;&#3612;&#3641;&#3657;&#3592;&#3635;&#3627;&#3609;&#3656;&#3634;&#3618;',0),(250875,6969,'hi','à¤µà¤¿à¤¤à¤°à¤• à¤¬à¤¿à¤•à¥à¤°à¥€ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(250876,6969,'ms','Jualan pengedar import',0),(250877,6969,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…ÙˆØ²Ø¹ Ù…Ø¨ÙŠØ¹Ø§Øª',0),(250878,6969,'fr','Importer des ventes du distributeur',0),(250879,6969,'jp','è¼¸å…¥è²©å£²ä»£ç†åº—è²©å£²',0),(250880,6969,'pt','ImportaÃ§Ã£o de vendas do distribuidor',0),(250881,6969,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑŒÑŽÑ‚Ð¾Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(250882,6969,'es','Importar Archivo de Distribuidor',0),(250883,6969,'de','Import-Vertriebsgesellschaften',0),(250884,6969,'en','Import Distributor Sales',0),(250885,6970,'is','',0),(250886,6970,'dr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ÙØ±ÙˆØ´ ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡',0),(250887,6970,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ÙØ±ÙˆØ´ ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡',0),(250888,6970,'tr','DistribÃ¼tÃ¶r satÄ±ÅŸ dosyasÄ± sÃ¼tun biÃ§imi',0),(250889,6970,'pl','Dystrybutor sprzedaÅ¼y kolumna formacie',0),(250890,6970,'bg','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¾Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ð°',0),(250891,6970,'ur','ÚˆØ³Ù¹Ø±ÛŒØ¨ÛŒÙˆÙ¹Ø± Ø³ÛŒÙ„Ø² Ú©Ø§ ÙØ§Ø¦Ù„ Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(250892,6970,'sr','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚ÐµÑ€ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(250893,6970,'vi','PhÃ¢n chia há»“ sÆ¡ bÃ¡n hÃ ng dáº¡ng cá»™t',0),(250894,6970,'af','Verspreider verkope kolom lÃªerformaat',0),(250895,6970,'ro','Distribuitor vÃ¢nzÄƒri dosar Format coloane',0),(250896,6970,'et','Turustaja mÃ¼Ã¼gi faili veeruvormingut',0),(250897,6970,'si','Distributer prodaje stolpec zapisa',0),(250898,6970,'ba','Format kolom distributor penjualan File',0),(250899,6970,'nl','Distributeur verkoop-bestandsindeling kolom',0),(250900,6970,'fi','Jakelija myynti sarakkeessa muodossa',0),(250901,6970,'no','DistributÃ¸r salg-kolonnen filformat',0),(250902,6970,'da','DistributÃ¸r salg filformat kolonne',0),(250903,6970,'ko','ëŒ€ë¦¬ì  íŒë§¤ íŒŒì¼ ì—´ í˜•ì‹',0),(250904,6970,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×ž×¤×™×¥ ×”×§×•×‘×¥ ×ž×›×™×¨×•×ª',0),(250905,6970,'el','Î”Î¹Î±Î½Î¿Î¼Î­Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î±ÏÏ‡ÎµÎ¯Î¿ Î¼Î¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½',0),(250906,6970,'zh','ç»é”€å•†é”€å”®æ¡£æ¡ˆæ æ ¼å¼\r\n',0),(250907,6970,'sv','DistributÃ¶r fÃ¶rsÃ¤ljning kolumn filformatet',0),(250908,6970,'it','Distributore vendite formato colonna',0),(250909,6970,'tl','',0),(250910,6970,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3652;&#3615;&#3621;&#3660;&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3592;&#3635;&#3627;&#3609;&#3656;&#3634;&#3618;',0),(250911,6970,'hi','à¤µà¤¿à¤¤à¤°à¤• à¤¬à¤¿à¤•à¥à¤°à¥€ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(250912,6970,'ms','Format kolum fail jualan pengedar',0),(250913,6970,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ Ù…Ù„Ù Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù…ÙˆØ²Ø¹',0),(250914,6970,'fr','Format de colonne pour le fichier vente distributeur',0),(250915,6970,'jp','ãƒ‡ã‚£ã‚¹ãƒˆãƒªãƒ“ãƒ¥ãƒ¼ã‚¿ãƒ¼è²©å£²ãƒ•ã‚¡ã‚¤ãƒ«åˆ—å½¢å¼',0),(250916,6970,'pt','Distribuidor vendas arquivo formato de coluna',0),(250917,6970,'ru','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑŒÑŽÑ‚Ð¾Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð¾Ð²',0),(250918,6970,'es','Ventas de Distribuidor fila Columna Formato',0),(250919,6970,'de','Verteiler Spalte Sales Dateiformat',0),(250920,6970,'en','Distributor Sales File Column Format',0),(250921,6971,'is','',0),(250922,6971,'dr','Ø«Ø¨ØªÙ‡Ø§ÙŠ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(250923,6971,'pr','Ø«Ø¨ØªÙ‡Ø§ÙŠ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(250924,6971,'tr','Ä°thal girdi',0),(250925,6971,'pl','WejÅ›cia przywozu',0),(250926,6971,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸',0),(250927,6971,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(250928,6971,'sr','Ð£Ð²ÐµÐ·ÐµÑ‚Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(250929,6971,'vi','ÄÃ£ nháº­p bÃºt toÃ¡n',0),(250930,6971,'af','Inskrywings Ingevoer',0),(250931,6971,'ro','IntrÄƒrile importate',0),(250932,6971,'et','Sissekanded imporditud',0),(250933,6971,'si','Postavke, ki so uvoÅ¾ena',0),(250934,6971,'ba','Entri yang diimpor',0),(250935,6971,'nl','Posten geÃ¯mporteerd',0),(250936,6971,'fi','Tuoda tapahtumat',0),(250937,6971,'no','OppfÃ¸ringer importert',0),(250938,6971,'da','Poster importeres',0),(250939,6971,'ko','ê°€ì ¸ì˜¬ í•­ëª©',0),(250940,6971,'he','×¢×¨×›×™ ×ž×™×•×‘××™×',0),(250941,6971,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(250942,6971,'zh','è¿›å£æ¡ç›®',0),(250943,6971,'sv','Poster som importeras',0),(250944,6971,'it','Voci importate',0),(250945,6971,'tl','',0),(250946,6971,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3649;&#3621;&#3657;&#3623;&#3588;&#3619;&#3610;&#3606;&#3657;&#3623;&#3609;',0),(250947,6971,'hi','à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚',0),(250948,6971,'ms','Entri yang diimport',0),(250949,6971,'ar','Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯Ù‡Ø§',0),(250950,6971,'fr','EntrÃ©es importÃ©es',0),(250951,6971,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚ŒãŸã‚¨ãƒ³ãƒˆãƒª',0),(250952,6971,'pt','Entradas importadas',0),(250953,6971,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐµÐ¼Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(250954,6971,'es','Entradas Importadas',0),(250955,6971,'de','EintrÃ¤ge importiert',0),(250956,6971,'en','Entries Imported',0),(250957,6972,'is','',0),(250958,6972,'dr','Ø­Ù„ ÙƒØ±Ø¯Ù† Ù…Ø´ÙƒÙ„Ø§Øª Ùˆ Ø³Ø¹ÙŠ Ø¯ÙˆØ¨Ø§Ø±Ù‡ ',0),(250959,6972,'pr','Ø­Ù„ ÙƒØ±Ø¯Ù† Ù…Ø´ÙƒÙ„Ø§Øª Ùˆ Ø³Ø¹ÙŠ Ø¯ÙˆØ¨Ø§Ø±Ù‡ ',0),(250960,6972,'tr','Fix sorunlarÄ± ve yeniden deneyin',0),(250961,6972,'pl','RozwiÄ…Å¼ problemy i sprÃ³buj ponownie',0),(250962,6972,'bg','ÐšÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð¸ Ð¸ Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(250963,6972,'ur','ÙÚ©Ø³ Ù…Ø³Ø§Ø¦Ù„ Ø§ÙˆØ± Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº',0),(250964,6972,'sr','ÐžÑ‚ÐºÐ»Ð°ÑšÐ°ÑšÐµ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð° Ð¸ Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(250965,6972,'vi','Sá»­a trá»¥c tráº·c & thá»­ láº¡i',0),(250966,6972,'af','Los probleme en probeer weer',0),(250967,6972,'ro','Fix probleme ÅŸi Ã®ncercaÅ£i din nou',0),(250968,6972,'et','Lahendused probleemidele ja proovige uuesti',0),(250969,6972,'si','Odpravite teÅ¾ave in poskusite znova',0),(250970,6972,'ba','Memperbaiki masalah dan coba lagi',0),(250971,6972,'nl','Problemen oplossen en probeer het opnieuw',0),(250972,6972,'fi','Korjaa ongelmat ja yritÃ¤ uudelleen',0),(250973,6972,'no','LÃ¸s problemer og prÃ¸v igjen',0),(250974,6972,'da','LÃ¸se problemer og prÃ¸ve igen',0),(250975,6972,'ko','ë¬¸ì œë¥¼ í•´ê²° í•˜ ê³  ë‹¤ì‹œ ì‹œë„',0),(250976,6972,'he','×ª×™×§×•×Ÿ ×‘×¢×™×•×ª ×•× ×¡×” ×©× ×™×ª',0),(250977,6972,'el','Fix Ï€ÏÎ¿Î²Î»Î®Î¼Î±Ï„Î± ÎºÎ±Î¹ Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(250978,6972,'zh','è§£å†³é—®é¢˜ï¼Œç„¶åŽå†è¯•ä¸€æ¬¡\r\n',0),(250979,6972,'sv','Fix problem och fÃ¶rsÃ¶k igen',0),(250980,6972,'it','Correzione di problemi e riprovare',0),(250981,6972,'tl','',0),(250982,6972,'th','&#3605;&#3636;&#3604;&#3611;&#3633;&#3597;&#3627;&#3634;&#3649;&#3621;&#3632;&#3585;&#3619;&#3640;&#3603;&#3634;&#3621;&#3629;&#3591;&#3651;&#3627;&#3617;&#3656;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(250983,6972,'hi','à¤ à¥€à¤• à¤•à¤° à¤¸à¤®à¤¸à¥à¤¯à¤¾à¤“à¤‚ à¤”à¤° à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚',0),(250984,6972,'ms','Betulkan masalah dan cuba sekali lagi',0),(250985,6972,'ar','Ø¹Ø§Ù„Ø¬ Ø§Ù„Ù…Ø´Ø§ÙƒÙ„ Ø«Ù… Ø­ÙˆÙ„ Ù…Ø±Ù‘Ø© Ø§Ø®Ø±Ù‰',0),(250986,6972,'fr','Corrigera les problÃ¨mes et essayez Ã  nouveau',0),(250987,6972,'jp','å•é¡Œã‚’ä¿®æ­£ã—ã€ã‚‚ã†ä¸€åº¦ã‚„ã‚Šç›´ã—ã¦ãã ã•ã„ã€‚',0),(250988,6972,'pt','Corrigir problemas e tente novamente',0),(250989,6972,'ru','Ð£ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼ Ð¸ Ð¿Ð¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÐµÑ‰Ðµ Ñ€Ð°Ð·',0),(250990,6972,'es','Arreglar Problemas y Intentar Otra Vez',0),(250991,6972,'de','Fix Probleme und versuchen Sie es erneut',0),(250992,6972,'en','Fix Problems and Try Again',0),(250993,6973,'is','',0),(250994,6973,'dr','2',0),(250995,6973,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª2',0),(250996,6973,'tr','NOT2',0),(250997,6973,'pl','Uwaga 2',0),(250998,6973,'bg','NOTE2',0),(250999,6973,'ur','Note2',0),(251000,6973,'sr','ÐÐ¾Ñ‚Ðµ2',0),(251001,6973,'vi','Ghi ChÃº2',0),(251002,6973,'af','Nota2',0),(251003,6973,'ro','Note2',0),(251004,6973,'et','Lisa2',0),(251005,6973,'si','Note2',0),(251006,6973,'ba','NOTE2 pribadi',0),(251007,6973,'nl','Note2',0),(251008,6973,'fi','Note2',0),(251009,6973,'no','Note2',0),(251010,6973,'da','NOTE2',0),(251011,6973,'ko','Note2',0),(251012,6973,'he','Note2',0),(251013,6973,'el','Î£Î·Î¼.2',0),(251014,6973,'zh','æ³¨2\r\n',0),(251015,6973,'sv','NOTE2',0),(251016,6973,'it','Nota2',0),(251017,6973,'tl','',0),(251018,6973,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;2',0),(251019,6973,'hi','Note2',0),(251020,6973,'ms','Note2',0),(251021,6973,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© 2',0),(251022,6973,'fr','Note 2',0),(251023,6973,'jp','æ³¨ 2ï¼‰',0),(251024,6973,'pt','Obs2',0),(251025,6973,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ°2',0),(251026,6973,'es','Nota2',0),(251027,6973,'de','Hinweis2',0),(251028,6973,'en','Note2',0),(251029,6974,'is','',0),(251030,6974,'dr','Ù‡ÙŠÚ† ÙØ§ÙŠÙ„ÙŠ Ø¨Ù‡ Ø®Ø§Ø·Ø± Ø®Ø·Ø§ Ø¢Ù¾Ù„ÙˆØ¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(251031,6974,'pr','Ù‡ÙŠÚ† ÙØ§ÙŠÙ„ÙŠ Ø¨Ù‡ Ø®Ø§Ø·Ø± Ø®Ø·Ø§ Ø¢Ù¾Ù„ÙˆØ¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(251032,6974,'tr','Hatalar nedeniyle karÅŸÄ±ya dosya',0),(251033,6974,'pl','Å»adne pliki przesÅ‚ane z powodu bÅ‚Ä™dÃ³w',0),(251034,6974,'bg','ÐÑÐ¼Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ, ÐºÐ°Ñ‡ÐµÐ½Ð¸ Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð³Ñ€ÐµÑˆÐºÐ¸',0),(251035,6974,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø³Ù„ÛŒÚº Ù†Ù‚Ø§Ø¦Øµ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ø§Ù¾ Ù„ÙˆÚˆ',0),(251036,6974,'sr','ÐÐµÐ¼Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ð¸Ñ‚Ð¸ Ð·Ð±Ð¾Ð³ Ð³Ñ€ÐµÑˆÐ°ÐºÐ°',0),(251037,6974,'vi','KhÃ´ng táº£i há»“ sÆ¡ lÃªn vÃ¬ bá»‹ lá»—i',0),(251038,6974,'af','Geen LÃªer Opgelaai Weens Foute Wat Opgespoor is',0),(251039,6974,'ro','Nu fiÅŸierele Ã®ncÄƒrcate din cauza unor erori',0),(251040,6974,'et','TÃµrgete tÃµttu Ã¼leslaaditud faile',0),(251041,6974,'si','Ne datoteke naloÅ¾ili zaradi napak',0),(251042,6974,'ba','Tidak ada file upload karena kesalahan',0),(251043,6974,'nl','Geen bestanden geÃ¼pload als gevolg van fouten',0),(251044,6974,'fi','Ei tiedostoja ladataan virheiden vuoksi',0),(251045,6974,'no','Ingen filer lastet opp pÃ¥ grunn av feil',0),(251046,6974,'da','Ingen filer, der uploades pÃ¥ grund af fejl',0),(251047,6974,'ko','ì˜¤ë¥˜ë¡œ ì¸í•´ ì—…ë¡œë“œ íŒŒì¼ì´ ì—†ìŠµë‹ˆë‹¤',0),(251048,6974,'he','××™×Ÿ ×§×‘×¦×™× ×©×”×•×¢×œ×• ×¢×§×‘ ×©×’×™××•×ª',0),(251049,6974,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î±ÏÏ‡ÎµÎ¯Î± Ï†Î¿ÏÏ„ÏŽÎ¸Î·ÎºÎµ ÎµÎ¾Î±Î¹Ï„Î¯Î±Ï‚ ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½',0),(251050,6974,'zh','ç”±äºŽé”™è¯¯æ²¡æœ‰æ–‡ä»¶ä¸Šä¼ \r\n',0),(251051,6974,'sv','Inga filer som laddas upp pÃ¥ grund av fel',0),(251052,6974,'it','Nessun file caricato a causa di Errori',0),(251053,6974,'tl','',0),(251054,6974,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3629;&#3633;&#3614;&#3650;&#3627;&#3621;&#3604;&#3652;&#3615;&#3621;&#3660;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3592;&#3634;&#3585;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3',0),(251055,6974,'hi','à¤•à¥‹à¤ˆ à¤­à¥€ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤•à¤¾à¤°à¤£ à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(251056,6974,'ms','Tiada fail yang dimuat naik oleh kerana kesilapan',0),(251057,6974,'ar','Ù„Ù… ÙŠØªÙ… ØªØ­Ù…ÙŠÙ„ Ø£ÙŠØ© Ù…Ù„ÙØ§Øª Ù†ØªÙŠØ¬Ø© ',0),(251058,6974,'fr','Pas de fichiers tÃ©lÃ©chargÃ©s en raison d\'erreurs',0),(251059,6974,'jp','ã‚¨ãƒ©ãƒ¼ã®ãŸã‚ãƒ•ã‚¡ã‚¤ãƒ«ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(251060,6974,'pt','NÃ£o hÃ¡ arquivos enviados devido a erros',0),(251061,6974,'ru','Ð‘ÐµÐ· Ñ„Ð°Ð¹Ð»Ð¾Ð², Ð·Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ñ… Ð¸Ð·-Ð·Ð° Ð¾ÑˆÐ¸Ð±ÐºÐ¸',0),(251062,6974,'es','No se Subieron Archivos Debido a Errores',0),(251063,6974,'de','Keine Dateien hochgeladen, die aufgrund von Fehlern',0),(251064,6974,'en','No Files Uploaded Due to Errors',0),(251065,6975,'is','',0),(251066,6975,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ ÙƒÙ‡ ÙØ§ÙŠÙ„Ø´ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(251067,6975,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ ÙƒÙ‡ ÙØ§ÙŠÙ„Ø´ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(251068,6975,'tr','Kimin dosya iÃ§e aktarÄ±lacak olan mÃ¼ÅŸteriyi seÃ§in',0),(251069,6975,'pl','Wybierz klienta, ktÃ³rego plik ma byÄ‡ przywoÅ¼one',0),(251070,6975,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚, Ñ‡Ð¸Ð¹Ñ‚Ð¾ Ñ„Ð°Ð¹Ð» Ðµ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸',0),(251071,6975,'ur','Ú¯Ø§ÛÚ© Ø¬Ù† Ù…Ø³Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(251072,6975,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÑƒÐ¿Ñ†Ð° ÐºÐ¾Ð¼Ðµ Ñ‡Ð¸Ñ˜Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(251073,6975,'vi','Chá»n khÃ¡ch hÃ ng Ä‘á»ƒ nháº­p há»“ sÆ¡',0),(251074,6975,'af','Selekteer KliÃ«nt/Klant Wie Se LÃªer Ingevoer Moet Word',0),(251075,6975,'ro','SelectaÅ£i client al cÄƒror dosar trebuie sÄƒ fie importat',0),(251076,6975,'et','Vali klient, kelle faili tahad importida',0),(251077,6975,'si','Izberite kupca, katere datoteke za uvoz',0),(251078,6975,'ba','Pilih File yang akan diimpor pelanggan',0),(251079,6975,'nl','Selecteer klant waarvan het bestand moet worden ingevoerd',0),(251080,6975,'fi','Valitse asiakas, jonka tiedostoa on tuotava',0),(251081,6975,'no','Velg kunde der filen som skal importeres',0),(251082,6975,'da','VÃ¦lg debitor, hvis filen er der skal importeres',0),(251083,6975,'ko','ê·¸ íŒŒì¼ì„ ê°€ì ¸ì˜¬ ìˆ˜ëŠ” ê³ ê° ì„ íƒ',0),(251084,6975,'he','×‘×—×¨ ×œ×§×•×— ×©×œ ×ž×™ ×”×§×•×‘×¥ ×”×•× ×œ×”×™×•×ª ×ž×™×•×‘××™×',0),(251085,6975,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Ï„Ï‰Î½ Î¿Ï€Î¿Î¯Ï‰Î½ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï€Î¿Ï… Ï€ÏÏŒÎºÎµÎ¹Ï„Î±Î¹ Î½Î± ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯',0),(251086,6975,'zh','é€‰æ‹©æ–‡ä»¶è¦å¯¼å…¥çš„å®¢æˆ·\r\n',0),(251087,6975,'sv','VÃ¤lj kund vars fil Ã¤r att importeras',0),(251088,6975,'it','Selezionare il cliente a cui il File Ã¨ da importare',0),(251089,6975,'tl','',0),(251090,6975,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3612;&#3641;&#3657;&#3595;&#3638;&#3656;&#3591;&#3649;&#3615;&#3657;&#3617;&#3605;&#3657;&#3629;&#3591;&#3606;&#3641;&#3585;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(251091,6975,'hi','à¤œà¤¿à¤¸à¤•à¤¾ à¤«à¤¼à¤¾à¤‡à¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(251092,6975,'ms','Pilih pelanggan adalah fail yang diimport',0),(251093,6975,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ù…Ù„Ù Ø§Ù„Ø°ÙŠ ÙŠØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯Ù‡',0),(251094,6975,'fr','SÃ©lectionnez le client dont le dossier est Ã  importer',0),(251095,6975,'jp','ãã®ãƒ•ã‚¡ã‚¤ãƒ«ãŒã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã‚‹é¡§å®¢ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(251096,6975,'pt','Selecione o cliente cujo arquivo Ã© para ser importado',0),(251097,6975,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°, Ñ„Ð°Ð¹Ð» ÐºÐ¾Ñ‚Ð¾Ñ€Ð¾Ð³Ð¾ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(251098,6975,'es','Seleccionar Cliente Cuyo File se ImportarÃ¡',0),(251099,6975,'de','WÃ¤hlen Sie Kunden aus, die deren Datei importiert werden soll',0),(251100,6975,'en','Select Customer Whose File Is To Be Imported',0),(251101,6976,'is','',0),(251102,6976,'dr','(Ø§Ø±Ø³Ø§Ù„) ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡  ',0),(251103,6976,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ø­Ù…Ù„(Ø§Ø±Ø³Ø§Ù„) ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡  ',0),(251104,6976,'tr','DaÄŸÄ±tÄ±mcÄ± gemi dosyasÄ±nÄ± seÃ§in',0),(251105,6976,'pl','Wybierz plik statku dystrybutor',0),(251106,6976,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¾Ñ€ ÐºÐ¾Ñ€Ð°Ð± Ñ„Ð°Ð¹Ð»',0),(251107,6976,'ur','ÚˆØ³Ù¹Ø±ÛŒØ¨ÛŒÙˆÙ¹Ø± Ø¬ÛØ§Ø² Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(251108,6976,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð±Ñ€Ð¾Ð´ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚ÐµÑ€',0),(251109,6976,'vi','Chá»n há»“ sÆ¡ váº­n chuyá»ƒn phÃ¢n phá»‘i',0),(251110,6976,'af','Kies Verspreider VersendlÃªer',0),(251111,6976,'ro','SelectaÅ£i fiÅŸierul de navÄƒ distribuitor',0),(251112,6976,'et','Vali edasimÃ¼Ã¼ja laeva fail',0),(251113,6976,'si','Izberite datoteko distributer ladje',0),(251114,6976,'ba','Pilih File kapal Distributor',0),(251115,6976,'nl','Selecteer distributeur schip bestand',0),(251116,6976,'fi','Valitse toimittaja aluksen tiedosto',0),(251117,6976,'no','Velg DistributÃ¸r skipet fil',0),(251118,6976,'da','VÃ¦lg distributÃ¸r skib fil',0),(251119,6976,'ko','ë°°í¬ìž ë°° íŒŒì¼ ì„ íƒ',0),(251120,6976,'he','×‘×—×¨ ×§×•×‘×¥ ×”×¡×¤×™× ×” ×ž×¤×™×¥',0),(251121,6976,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î‘ÏÏ‡ÎµÎ¯Î¿ Ï€Î»Î¿Î¯Î¿ Î´Î¹Î±Î½Î¿Î¼Î­Î±Ï‚',0),(251122,6976,'zh','é€‰æ‹©åˆ†é”€å•†èˆ¹èˆ¶æ–‡ä»¶\r\n',0),(251123,6976,'sv','VÃ¤lj distributÃ¶r fartyget fil',0),(251124,6976,'it','Selezionare File di nave del distributore',0),(251125,6976,'tl','',0),(251126,6976,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3649;&#3615;&#3657;&#3617;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3588;&#3657;&#3634;&#3626;&#3656;&#3591;',0),(251127,6976,'hi','à¤µà¤¿à¤¤à¤°à¤• à¤œà¤¹à¤¾à¤œ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(251128,6976,'ms','Pilih fail kapal pengedar',0),(251129,6976,'ar','Ø­Ø¯Ø¯ Ù…Ù„Ù Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„Ù…ÙˆØ²Ø¹',0),(251130,6976,'fr','SÃ©lectionnez fichier de navire de distributeur',0),(251131,6976,'jp','ãƒ‡ã‚£ã‚¹ãƒˆãƒªãƒ“ãƒ¥ãƒ¼ã‚¿ãƒ¼ã®èˆ¹ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã—ã¾ã™',0),(251132,6976,'pt','Selecione o arquivo do navio de distribuidor',0),(251133,6976,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ„Ð°Ð¹Ð» ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑŒÑŽÑ‚Ð¾Ñ€',0),(251134,6976,'es','Seleccionar File de Enviar de Distribuidor',0),(251135,6976,'de','Verteiler-Schiff-Datei auswÃ¤hlen',0),(251136,6976,'en','Select Distributor Ship File',0),(251137,6977,'is','',0),(251138,6977,'dr','ØªØ§Ø±ÙŠØ® ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(251139,6977,'pr','ØªØ§Ø±ÙŠØ® ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(251140,6977,'tr','Fatura tarihi',0),(251141,6977,'pl','Data',0),(251142,6977,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(251143,6977,'ur','Ø¨Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(251144,6977,'sr','Ð‘Ð¸Ð» Ð´Ð°Ñ‚ÑƒÐ¼',0),(251145,6977,'vi','NgÃ y ra HÃ³a ÄÆ¡n',0),(251146,6977,'af','Wetsontwerp datum',0),(251147,6977,'ro','Proiectul de lege data',0),(251148,6977,'et','Arve kuupÃ¤ev',0),(251149,6977,'si','Bill datum',0),(251150,6977,'ba','Tanggal tagihan',0),(251151,6977,'nl','Bill datum',0),(251152,6977,'fi','Laskun pÃ¤ivÃ¤ys',0),(251153,6977,'no','Bill dato',0),(251154,6977,'da','Bill dato',0),(251155,6977,'ko','ë¹Œ ë‚ ì§œ',0),(251156,6977,'he','×ª××¨×™×š ×—×©×‘×•×Ÿ',0),(251157,6977,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(251158,6977,'zh','è®¡è´¹æ—¥æœŸ\r\n',0),(251159,6977,'sv','Bill datum',0),(251160,6977,'it','Data fattura',0),(251161,6977,'tl','',0),(251162,6977,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3629;&#3629;&#3585;&#3610;&#3636;&#3621;',0),(251163,6977,'hi','à¤¬à¤¿à¤² à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(251164,6977,'ms','Bil tarikh',0),(251165,6977,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(251166,6977,'fr','Date de facturation',0),(251167,6977,'jp','è«‹æ±‚æ›¸ã®æ—¥ä»˜',0),(251168,6977,'pt','Data da factura',0),(251169,6977,'ru','Ð‘Ð¸Ð»Ð» Ð”Ð°Ñ‚Ð°',0),(251170,6977,'es','Fecha de Factura',0),(251171,6977,'de','Bill Datum',0),(251172,6977,'en','Bill Date',0),(251173,6978,'is','',0),(251174,6978,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(251175,6978,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(251176,6978,'tr','GL hesap numarasÄ±',0),(251177,6978,'pl','Numer konta GL',0),(251178,6978,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ð° GL',0),(251179,6978,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø±',0),(251180,6978,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð›',0),(251181,6978,'vi','Sá»‘ TK Sá»• CÃ¡i Tá»•ng Há»£p',0),(251182,6978,'af','AG Rekeningnommer',0),(251183,6978,'ro','NumÄƒrul de cont GL',0),(251184,6978,'et','GL kontonumber',0),(251185,6978,'si','Å tevilka raÄuna GL',0),(251186,6978,'ba','Nomor rekening GL',0),(251187,6978,'nl','GL rekeningnummer',0),(251188,6978,'fi','GL tilinumero',0),(251189,6978,'no','GL kontonummeret',0),(251190,6978,'da','GL kontonummer',0),(251191,6978,'ko','GL ê³„ì • ë²ˆí˜¸',0),(251192,6978,'he','×ž×¡×¤×¨ ×—×©×‘×•×Ÿ GL',0),(251193,6978,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï GL',0),(251194,6978,'zh','æ€»å¸å¸æˆ·å·ç \r\n',0),(251195,6978,'sv','GL kontonummer',0),(251196,6978,'it','Numero di conto GL',0),(251197,6978,'tl','',0),(251198,6978,'th','&#3651;&#3626;&#3656;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(251199,6978,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(251200,6978,'ms','Nombor akaun GL',0),(251201,6978,'ar','Ø±Ù‚Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(251202,6978,'fr','NumÃ©ro de compte GL',0),(251203,6978,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå·',0),(251204,6978,'pt','NÃºmero de conta GL',0),(251205,6978,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° GL',0),(251206,6978,'es','NÃºmero de Cuenta LM',0),(251207,6978,'de','GL-Kontonummer',0),(251208,6978,'en','GL Account Number',0),(251209,6979,'is','',0),(251210,6979,'dr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(251211,6979,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(251212,6979,'tr','SatÄ±cÄ± faturalarÄ± dosya sÃ¼tun biÃ§imi',0),(251213,6979,'pl','Dostawcy rachunki formacie kolumna',0),(251214,6979,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ¼ÐµÑ‚ÐºÐ¸ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(251215,6979,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„',0),(251216,6979,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(251217,6979,'vi','HÃ³a ÄÆ¡n NgÆ°á»i bÃ¡n dáº¡ng cá»™t',0),(251218,6979,'af','Verskaffer Rekeninge LÃªer Kolom Formaat',0),(251219,6979,'ro','Furnizor facturi coloana Format de fiÅŸier',0),(251220,6979,'et','Tarnijate arvete fail ',0),(251221,6979,'si','Prodajalca raÄune zapisa stolpec',0),(251222,6979,'ba','Penjual tagihan Format File kolom',0),(251223,6979,'nl','Leverancier facturen bestandsindeling kolom',0),(251224,6979,'fi','Toimittajan laskut sarakkeessa muodossa',0),(251225,6979,'no','Kolonnen leverandÃ¸r regninger filformat',0),(251226,6979,'da','Kreditor regninger filformat kolonne',0),(251227,6979,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ íŒŒì¼ ì—´ í˜•ì‹',0),(251228,6979,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×©×œ ×§×•×‘×¥ ×”×—×©×‘×•× ×•×ª ×”×¡×¤×§',0),(251229,6979,'el','ÎœÎ¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½ Î±ÏÏ‡ÎµÎ¯Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(251230,6979,'zh','é”€å”®æ–¹å¸å•æ–‡ä»¶æ æ ¼å¼\r\n',0),(251231,6979,'sv','Kolumn-filformat med rÃ¤kningar, leverantÃ¶r',0),(251232,6979,'it','Formato di colonna File fatture fornitore',0),(251233,6979,'tl','',0),(251234,6979,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3610;&#3636;&#3621;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(251235,6979,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(251236,6979,'ms','Format kolum fail bil-bil vendor',0),(251237,6979,'ar','Ø¨Ù†ÙŠØ© (Ø®Ø§Ù†Ø§Øª) Ù…Ù„Ù Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(251238,6979,'fr','Factures fournisseur File Format de colonne',0),(251239,6979,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸ãƒ•ã‚¡ã‚¤ãƒ«åˆ—ã®å½¢å¼',0),(251240,6979,'pt','Formato de coluna de arquivo de contas de fornecedor',0),(251241,6979,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° ÑÑ‡ÐµÑ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(251242,6979,'es','Recibos de Proveedor Formato de File Columna',0),(251243,6979,'de','Kreditor Rechnungen Dateiformat Spalte',0),(251244,6979,'en','Vendor Bills File Column Format',0),(251245,6980,'is','',0),(251246,6980,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(251247,6980,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(251248,6980,'tr','URL dosya CSV biÃ§imi GL iÃ§in',0),(251249,6980,'pl','Adres URL pliku w formacie CSV GL',0),(251250,6980,'bg','URL Ñ„Ð°Ð¹Ð» Ð·Ð° CSV Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ GL',0),(251251,6980,'ur','ÛŒÙˆ Ø¢Ø± Ø§ÛŒÙ„ ÙØ§Ø¦Ù„ CSV ÙˆØ¶Ø¹ Ø¬ÛŒØ¬Û’ Ú©Û’ Ù„Ø¦Û’',0),(251252,6980,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ð¦Ð¡Ð’ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð“Ð›',0),(251253,6980,'vi','ÄÆ°á»ng dáº«n Há»“ sÆ¡ cho sá»• cÃ¡i dáº¡ng CSV',0),(251254,6980,'af','BA (\"URL\") LÃªer vir CSV Formaat AG',0),(251255,6980,'ro','URL-ul de fiÅŸier pentru formatul CSV GL',0),(251256,6980,'et','URL/Faili asukoht CSV formaadis PR-faili jaoks',0),(251257,6980,'si','URL datoteke CSV format GL',0),(251258,6980,'ba','File URL untuk CSV Format GL',0),(251259,6980,'nl','Bestand met URL voor CSV-indeling GL',0),(251260,6980,'fi','URL tiedosto CSV-muodossa GL',0),(251261,6980,'no','URL fil For CSV-Format GL',0),(251262,6980,'da','URL fil i CSV-Format GL',0),(251263,6980,'ko','URL íŒŒì¼ CSV í˜•ì‹ GL',0),(251264,6980,'he','×›×ª×•×‘×ª url ×©×œ ×§×•×‘×¥ ×‘×ª×‘× ×™×ª CSV GL',0),(251265,6980,'el','URL Î±ÏÏ‡ÎµÎ¯Î¿Ï… CSV Î¼Î¿ÏÏ†Î® GL',0),(251266,6980,'zh','é€—å·åˆ†éš”å€¼æ ¼å¼æ–‡ä»¶çš„ç½‘å€å‰å°”\r\n',0),(251267,6980,'sv','URL-filen fÃ¶r CSV-Format GL',0),(251268,6980,'it','URL File di formato CSV GL',0),(251269,6980,'tl','',0),(251270,6980,'th','URL File For CSV Format GL',0),(251271,6980,'hi','URL à¤«à¤¼à¤¾à¤‡à¤² CSV à¤¸à¥à¤µà¤°à¥‚à¤ª GL à¤²à¤¿à¤',0),(251272,6980,'ms','URL fail untuk CSV Format GL',0),(251273,6980,'ar','Ù…Ù„Ù URL Ù„ØªÙ†Ø³ÙŠÙ‚ CSV GL',0),(251274,6980,'fr','Fichier d\'URL pour le Format CSV GL',0),(251275,6980,'jp','URL ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ CSV å½¢å¼ GL',0),(251276,6980,'pt','Arquivo de URL para o formato CSV GL',0),(251277,6980,'ru','URL-Ð°Ð´Ñ€ÐµÑ Ñ„Ð°Ð¹Ð»Ð° Ð´Ð»Ñ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð° CSV GL',0),(251278,6980,'es','URL File para Formato CSV de LM',0),(251279,6980,'de','URL-Datei fÃ¼r das CSV-Format GL',0),(251280,6980,'en','URL File For CSV Format GL',0),(251281,6981,'is','',0),(251282,6981,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù‡Ø±',0),(251283,6981,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù‡Ø±',0),(251284,6981,'tr','Her ortalama maliyeti',0),(251285,6981,'pl','Åšredni koszt kaÅ¼dego',0),(251286,6981,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð²ÑÐµÐºÐ¸',0),(251287,6981,'ur','ÛØ± Ø§ÛŒÚ© Ø§ÙˆØ³Ø· Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(251288,6981,'sr','ÐŸÑ€Ð¾ÑÐµÑ‡Ð°Ð½ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ñ˜ÐµÐ´Ð½Ð¸',0),(251289,6981,'vi','Chi PhÃ­ Trung BÃ¬nh Tá»«ng Má»¥c',0),(251290,6981,'af','Gemiddelde Koste Elk',0),(251291,6981,'ro','Fiecare costul mediu',0),(251292,6981,'et','Keskmise kulu iga',0),(251293,6981,'si','PovpreÄni stroÅ¡ek vsakega',0),(251294,6981,'ba','Rata-rata biaya masing-masing',0),(251295,6981,'nl','Gemiddelde kosten van elk',0),(251296,6981,'fi','KeskimÃ¤Ã¤rÃ¤isen kustannuksen kunkin',0),(251297,6981,'no','Gjennomsnittlig kostnad hver',0),(251298,6981,'da','Gennemsnitlige kostpris hver',0),(251299,6981,'ko','í‰ê·  ê° ë¹„ìš©',0),(251300,6981,'he','×”×ž×ž×•×¦×¢ ×¢×œ×” ××—×“',0),(251301,6981,'el','ÎœÎ­ÏƒÎ¿ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÎ¬Î¸Îµ',0),(251302,6981,'zh','å¹³å‡æˆæœ¬æ¯\r\n',0),(251303,6981,'sv','Genomsnittliga kostnaden varje',0),(251304,6981,'it','Ogni costo medio',0),(251305,6981,'tl','',0),(251306,6981,'th','&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3649;&#3605;&#3656;&#3621;&#3632;&#3626;&#3636;&#3656;&#3591;',0),(251307,6981,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤”à¤¸à¤¤ à¤²à¤¾à¤—à¤¤',0),(251308,6981,'ms','Purata kos setiap satu',0),(251309,6981,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„ØªÙƒÙ„ÙØ© Ù„Ù„Ù‚Ø·Ø¹Ø©',0),(251310,6981,'fr','Chaque coÃ»t moyen',0),(251311,6981,'jp','ãã‚Œãžã‚Œã®å¹³å‡ã‚³ã‚¹ãƒˆ',0),(251312,6981,'pt','Cada um custo mÃ©dio',0),(251313,6981,'ru','Ð¡Ñ€ÐµÐ´Ð½ÑÑ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ°Ð¶Ð´Ð¾Ð¹',0),(251314,6981,'es','Costo Promendio Cada Uno',0),(251315,6981,'de','Durchschnittskosten je',0),(251316,6981,'en','Average Cost Each',0),(251317,6982,'is','',0),(251318,6982,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(251319,6982,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(251320,6982,'tr','VarsayÄ±lan satÄ±cÄ± adÄ±',0),(251321,6982,'pl','DomyÅ›lnÄ… nazwÄ… dostawcy',0),(251322,6982,'bg','Ð˜Ð¼ÐµÑ‚Ð¾ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(251323,6982,'ur','Ø·Û’ Ø´Ø¯Û ÙˆÛŒÙ†ÚˆØ± Ù†Ø§Ù…',0),(251324,6982,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾ Ð¸Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(251325,6982,'vi','TÃªn NgÆ°á»i bÃ¡n Máº·c Ä‘á»‹nh',0),(251326,6982,'af','Verstekte Verskaffer Naam',0),(251327,6982,'ro','Numele implicit de furnizor',0),(251328,6982,'et','Vaikimisi hankija nimi',0),(251329,6982,'si','Privzeto ime dobavitelja',0),(251330,6982,'ba','Nama default Vendor',0),(251331,6982,'nl','Standaard de naam van de verkoper',0),(251332,6982,'fi','Toimittajan oletusnimi',0),(251333,6982,'no','Standard LeverandÃ¸rnavn',0),(251334,6982,'da','Standard kreditornavnet',0),(251335,6982,'ko','ê¸°ë³¸ ê³µê¸‰ ì—…ì²´ ì´ë¦„',0),(251336,6982,'he','×©× ×¡×¤×§ ×‘×¨×™×¨×ª ×”×ž×—×“×œ',0),(251337,6982,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(251338,6982,'zh','é»˜è®¤çš„ä¾›åº”å•†åç§°\r\n',0),(251339,6982,'sv','Standardnamnet fÃ¶r leverantÃ¶r',0),(251340,6982,'it','Nome fornitore predefinito',0),(251341,6982,'tl','',0),(251342,6982,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(251343,6982,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤¨à¤¾à¤®',0),(251344,6982,'ms','Nama penjual lalai',0),(251345,6982,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø§ï»¹ÙØªØ±Ø§Ø¶ÙŠ',0),(251346,6982,'fr','Nom du vendeur par dÃ©faut',0),(251347,6982,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã®ãƒ™ãƒ³ãƒ€ãƒ¼å',0),(251348,6982,'pt','Nome do fornecedor padrÃ£o',0),(251349,6982,'ru','Ð˜Ð¼Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(251350,6982,'es','Nombre de Vendedor por Defecto',0),(251351,6982,'de','Anbieter-Standardname',0),(251352,6982,'en','Default Vendor Name',0),(251353,6983,'is','',0),(251354,6983,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§',0),(251355,6983,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§',0),(251356,6983,'tr','Ã–ÄŸeleri al',0),(251357,6983,'pl','Importuj elementy',0),(251358,6983,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(251359,6983,'ur','Ø§Ø´ÛŒØ§Ø¡ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(251360,6983,'sr','Ð£Ð²Ð¾Ð· ÑÑ‚Ð°Ð²ÐºÐ¸',0),(251361,6983,'vi','Nháº­p danh má»¥c hÃ ng',0),(251362,6983,'af','Ivoer van Items',0),(251363,6983,'ro','Import elemente',0),(251364,6983,'et','Impordi tooted',0),(251365,6983,'si','Uvozi elemente',0),(251366,6983,'ba','Impor item',0),(251367,6983,'nl','Items importeren',0),(251368,6983,'fi','Tuo kohteet',0),(251369,6983,'no','Importer elementer',0),(251370,6983,'da','Importer emner',0),(251371,6983,'ko','í•­ëª© ê°€ì ¸ì˜¤ê¸°',0),(251372,6983,'he','×™×™×‘×•× ×¤×¨×™×˜×™×',0),(251373,6983,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(251374,6983,'zh','å¯¼å…¥é¡¹ç›®\r\n',0),(251375,6983,'sv','Importera objekt',0),(251376,6983,'it','Importazione di elementi',0),(251377,6983,'tl','',0),(251378,6983,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(251379,6983,'hi','à¤†à¤‡à¤Ÿà¤® à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(251380,6983,'ms','Barang-barang import',0),(251381,6983,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(251382,6983,'fr','Importer des Ã©lÃ©ments',0),(251383,6983,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(251384,6983,'pt','Importar itens',0),(251385,6983,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(251386,6983,'es','Importar Items',0),(251387,6983,'de','Importieren von Elementen',0),(251388,6983,'en','Import Items',0),(251389,6984,'is','',0),(251390,6984,'dr','Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ÙƒØ§Ù„Ø§',0),(251391,6984,'pr','Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ÙƒØ§Ù„Ø§',0),(251392,6984,'tr','Ã–ÄŸeyi dosya sÃ¼tun biÃ§imi',0),(251393,6984,'pl','Element kolumna Format pliku',0),(251394,6984,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(251395,6984,'ur','Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„ Ø´Û’',0),(251396,6984,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(251397,6984,'vi','Há»“ sÆ¡ hÃ ng dáº¡ng cá»™t',0),(251398,6984,'af','Item LÃªer Kolom Formaat',0),(251399,6984,'ro','Element File Format coloane',0),(251400,6984,'et','Kirje fail veeruvormingut',0),(251401,6984,'si','Oblike zapisa elementa datoteko stolpec',0),(251402,6984,'ba','Format kolom item File',0),(251403,6984,'nl','Bestand kolom verkoopvorm',0),(251404,6984,'fi','Kohteen sarakkeen tiedostomuoto',0),(251405,6984,'no','Element-kolonnen filformat',0),(251406,6984,'da','Vare-kolonne filformat',0),(251407,6984,'ko','í•­ëª© íŒŒì¼ ì—´ í˜•ì‹',0),(251408,6984,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×§×•×‘×¥ ×”×¤×¨×™×˜',0),(251409,6984,'el','Î£Ï„Î®Î»Î· Î¼Î¿ÏÏ†Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï… Ï„Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(251410,6984,'zh','é¡¹ç›®æ–‡ä»¶æ æ ¼å¼\r\n',0),(251411,6984,'sv','Objekt-kolumn filformatet',0),(251412,6984,'it','Elemento colonna formato',0),(251413,6984,'tl','',0),(251414,6984,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3649;&#3606;&#3623;&#3649;&#3615;&#3657;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(251415,6984,'hi','à¤†à¤‡à¤Ÿà¤® à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(251416,6984,'ms','Format kolum fail perkara',0),(251417,6984,'ar','Ø¨Ù†ÙŠØ© Ø£Ø¹Ù…Ø¯Ø© Ù…Ù„Ù Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(251418,6984,'fr','Article File Format de colonne',0),(251419,6984,'jp','é …ç›®ãƒ•ã‚¡ã‚¤ãƒ«ã®åˆ—ã®å½¢å¼',0),(251420,6984,'pt','Formato de coluna do item arquivo',0),(251421,6984,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(251422,6984,'es','Item Familia',0),(251423,6984,'de','Element-Spalte Dateiformat',0),(251424,6984,'en','Item File Column Format',0),(251425,6985,'is','',0),(251426,6985,'dr','(Ù‚ÙŠÙ…Øª ) Ù‡Ø± ',0),(251427,6985,'pr','Ø¢Ø®Ø±ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ (Ù‚ÙŠÙ…Øª ) Ù‡Ø± ',0),(251428,6985,'tr','Son maliyet',0),(251429,6985,'pl','Ostatni koszt',0),(251430,6985,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(251431,6985,'ur','Ø¢Ø®Ø±ÛŒ Ù„Ø§Ú¯Øª',0),(251432,6985,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(251433,6985,'vi','Chi phÃ­ cuá»‘i cÃ¹ng má»—i',0),(251434,6985,'af','Laaste Koste Elk',0),(251435,6985,'ro','Ultimul Cost fiecare',0),(251436,6985,'et','Viimane kulu',0),(251437,6985,'si','Zadnji stroÅ¡ek',0),(251438,6985,'ba','Terakhir biaya',0),(251439,6985,'nl','Elke laatste kosten',0),(251440,6985,'fi','Viimeinen kustannus',0),(251441,6985,'no','Siste koste hver',0),(251442,6985,'da','Sidste omkostning',0),(251443,6985,'ko','ìµœê·¼ ë¹„ìš©',0),(251444,6985,'he','×œ××—×¨×•× ×” ×¢×œ×” ××—×“',0),(251445,6985,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÎ¬Î¸Îµ',0),(251446,6985,'zh','æœ€åŽæˆæœ¬æ¯\r\n',0),(251447,6985,'sv','Sista kostar varje',0),(251448,6985,'it','Ultimo costo ogni',0),(251449,6985,'tl','',0),(251450,6985,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;&#3649;&#3605;&#3656;&#3621;&#3632;',0),(251451,6985,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤²à¤¾à¤—à¤¤',0),(251452,6985,'ms','Buat kos setiap satu',0),(251453,6985,'ar','Ø¢Ø®Ø± ØªÙƒÙ„ÙØ© Ù„Ù„Ù‚Ø·Ø¹Ø©',0),(251454,6985,'fr','Dernier coÃ»t de chaque',0),(251455,6985,'jp','æœ€å¾Œã®ã‚³ã‚¹ãƒˆ',0),(251456,6985,'pt','Ãšltimo custo cada',0),(251457,6985,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÑÑ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(251458,6985,'es','Ãšltimo Costo Cada Uno',0),(251459,6985,'de','Letzte Kosten',0),(251460,6985,'en','Last Cost Each',0),(251461,6986,'is','',0),(251462,6986,'dr','ØªÙˆÙ„ÙŠØ¯ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(251463,6986,'pr','ØªÙˆÙ„ÙŠØ¯ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(251464,6986,'tr','Ãœretici',0),(251465,6986,'pl','Producent',0),(251466,6986,'bg','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»',0),(251467,6986,'ur','Ù…ØµÙ†ÙˆØ¹Û Ú©Ø§Ø±',0),(251468,6986,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡',0),(251469,6986,'vi','NhÃ  sáº£n xuáº¥t',0),(251470,6986,'af','Vervaardiger',0),(251471,6986,'ro','Producator',0),(251472,6986,'et','Tootja',0),(251473,6986,'si','Proizvajalec',0),(251474,6986,'ba','Produsen',0),(251475,6986,'nl','Fabrikant',0),(251476,6986,'fi','Valmistaja',0),(251477,6986,'no','Produsent',0),(251478,6986,'da','Fabrikanten',0),(251479,6986,'ko','ì œì¡° ì—…ì²´',0),(251480,6986,'he','×™×¦×¨×Ÿ',0),(251481,6986,'el','ÎšÎ±Ï„Î±ÏƒÎºÎµÏ…Î±ÏƒÏ„Î®Ï‚',0),(251482,6986,'zh','åˆ¶é€ å•†\r\n',0),(251483,6986,'sv','Tillverkaren',0),(251484,6986,'it','Produttore',0),(251485,6986,'tl','',0),(251486,6986,'th','&#3612;&#3641;&#3657;&#3612;&#3621;&#3636;&#3605;',0),(251487,6986,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤¤à¤¾',0),(251488,6986,'ms','Pengeluar',0),(251489,6986,'ar','Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ù…ØµÙ†Ù‘Ø¹Ø©',0),(251490,6986,'fr','RÃ©fÃ©rence du fabricant',0),(251491,6986,'jp','ãƒ¡ãƒ¼ã‚«ãƒ¼',0),(251492,6986,'pt','Fabricante',0),(251493,6986,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒ',0),(251494,6986,'es','Fabricante',0),(251495,6986,'de','Hersteller',0),(251496,6986,'en','Manufacturer',0),(251497,6987,'is','',0),(251498,6987,'dr','Ø³ØªÙˆÙ† Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠ Ù†Ø¨Ø§ÙŠØ¯ Ø­Ø§ÙˆÙŠ Ù†Ù…Ø§Ø¯ Ù¾ÙˆÙ„ÙŠ Ø¨Ø§Ø´Ù†Ø¯ ',0),(251499,6987,'pr','Ø³ØªÙˆÙ† Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠ Ù†Ø¨Ø§ÙŠØ¯ Ø­Ø§ÙˆÙŠ Ù†Ù…Ø§Ø¯ Ù¾ÙˆÙ„ÙŠ Ø¨Ø§Ø´Ù†Ø¯ ',0),(251500,6987,'tr','Parasal Simge parasal sÃ¼tunlar iÃ§ermemelidir',0),(251501,6987,'pl','PieniÄ™Å¼nej kolumny nie powinna zawieraÄ‡ Symbol waluty',0),(251502,6987,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð°Ñ‚Ð° ÐºÐ¾Ð»Ð¾Ð½Ð¸ Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ´ÑŠÑ€Ð¶Ð° Ð²Ð°Ð»ÑƒÑ‚ÐµÐ½ ÑÐ¸Ð¼Ð²Ð¾Ð»',0),(251503,6987,'ur','Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ú©Ø§Ù„Ù… Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ø¹Ù„Ø§Ù…Øª Ú©Ø§ Ø­Ø§Ù…Ù„ Ù†ÛÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(251504,6987,'sr','ÐœÐ¾Ð½ÐµÑ‚Ð°Ñ€Ð½Ð° ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð½Ðµ Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° ÑÐ°Ð´Ñ€Ð¶Ð¸ Ð¼Ð¾Ð½ÐµÑ‚Ð°Ñ€Ð½Ðµ ÑÐ¸Ð¼Ð±Ð¾Ð»',0),(251505,6987,'vi','Cá»™t tiá»n khÃ´ng chá»©a biá»ƒu tÆ°á»£ng tiá»n',0),(251506,6987,'af','MonitÃªre Kolomme Moet Nie Uit MonitÃªre Simbole Bestaan ',0),(251507,6987,'ro','Monetare coloane nu trebuie sÄƒ conÅ£inÄƒ simbol monetar',0),(251508,6987,'et','Rahaveerud ei tohiks sisaldada valuutasÃ¼mboleid',0),(251509,6987,'si','Denarne stolpcev ne sme vsebovati denarni simbol',0),(251510,6987,'ba','Kolom moneter tidak boleh mengandung simbol moneter',0),(251511,6987,'nl','Monetaire kolommen mogen geen monetaire symbool',0),(251512,6987,'fi','Raha sarakkeet eivÃ¤t saa sisÃ¤ltÃ¤Ã¤ raha symboli',0),(251513,6987,'no','MonetÃ¦re kolonner kan ikke inneholde monetÃ¦re Symbol',0),(251514,6987,'da','MonetÃ¦re kolonner bÃ¸r ikke indeholde monetÃ¦re Symbol',0),(251515,6987,'ko','í†µí™” ì—´ í†µí™” ê¸°í˜¸ë¥¼ í¬í•¨ í•´ì„œëŠ” ì•ˆ',0),(251516,6987,'he','×¢×ž×•×“×•×ª ×›×¡×¤×™ ××™× ×• ××ž×•×¨ ×œ×”×›×™×œ ×¡×ž×œ ×”×ž×˜×‘×¢',0),(251517,6987,'el','ÎÎ¿Î¼Î¹ÏƒÎ¼Î±Ï„Î¹ÎºÎ® ÏƒÏ„Î®Î»ÎµÏ‚ Î´ÎµÎ½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€ÎµÏÎ¹Î­Ï‡Î¿Ï…Î½ Ï„Î¿ Î½Î¿Î¼Î¹ÏƒÎ¼Î±Ï„Î¹ÎºÏŒ ÏƒÏÎ¼Î²Î¿Î»Î¿',0),(251518,6987,'zh','è´§å¸åˆ—ä¸åº”åŒ…å«è´§å¸ç¬¦å·\r\n',0),(251519,6987,'sv','MonetÃ¤ra kolumner bÃ¶r inte innehÃ¥lla monetÃ¤ra Symbol',0),(251520,6987,'it','Colonne monetarie non devono contenere il simbolo monetario',0),(251521,6987,'tl','',0),(251522,6987,'th','&#3594;&#3656;&#3629;&#3591;&#3648;&#3591;&#3636;&#3609;&#3605;&#3619;&#3634;&#3652;&#3617;&#3656;&#3588;&#3623;&#3619;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3604;&#3657;&#3623;&#3618;&#3626;&#3633;&#3597;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;',0),(251523,6987,'hi','à¤®à¥Œà¤¦à¥à¤°à¤¿à¤• à¤•à¥‰à¤²à¤® à¤®à¥Œà¤¦à¥à¤°à¤¿à¤• à¤ªà¥à¤°à¤¤à¥€à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(251524,6987,'ms','Kolum kewangan tidak harus mengandungi simbol kewangan',0),(251525,6987,'ar','Ø£Ø¹Ù…Ø¯Ø© Ø§Ù„Ù†Ù‚Ø¯ Ù„Ø§ ÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ØªØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ Ø±Ù…Ø² Ø§Ù„Ù†Ù‚Ø¯',0),(251526,6987,'fr','Colonnes monÃ©taires ne doivent pas contenir symbole monÃ©taire',0),(251527,6987,'jp','é‡‘é¡ã®åˆ—ã§é€šè²¨è¨˜å·ã‚’å«ã‚ãªã„ã§ãã ã•ã„ã€‚',0),(251528,6987,'pt','Colunas monetÃ¡rias nÃ£o devem conter o sÃ­mbolo monetÃ¡rio',0),(251529,6987,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ð°Ñ ÑÑ‚Ð¾Ð»Ð±Ñ†Ñ‹ Ð½Ðµ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐ¾Ð´ÐµÑ€Ð¶Ð°Ñ‚ÑŒ ÑÐ¸Ð¼Ð²Ð¾Ð» Ð²Ð°Ð»ÑŽÑ‚Ñ‹',0),(251530,6987,'es','Columnas Monetarias No Deben Contener SÃ­mbolos Monetarios',0),(251531,6987,'de','MonetÃ¤re Spalten sollten keine WÃ¤hrungssymbol enthalten.',0),(251532,6987,'en','Monetary Columns Should Not Contain Monetary Symbol',0),(251533,6988,'is','',0),(251534,6988,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø±',0),(251535,6988,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø±',0),(251536,6988,'tr','Her fiyat',0),(251537,6988,'pl','Cena kaÅ¼dego',0),(251538,6988,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð°',0),(251539,6988,'ur','ÛØ± Ù‚ÛŒÙ…Øª',0),(251540,6988,'sr','Ð¡Ð²Ð°ÐºÑƒ Ñ†ÐµÐ½Ñƒ',0),(251541,6988,'vi','Gia má»—i',0),(251542,6988,'af','Prys elke',0),(251543,6988,'ro','Pret fiecare',0),(251544,6988,'et','Ãœhiku hind',0),(251545,6988,'si','Cena vsakega',0),(251546,6988,'ba','Harga masing-masing',0),(251547,6988,'nl','Elke prijs',0),(251548,6988,'fi','Hinta/yksikkÃ¶',0),(251549,6988,'no','Pris/stk.',0),(251550,6988,'da','Pris hver',0),(251551,6988,'ko','ê° ê°€ê²©',0),(251552,6988,'he','×ž×—×™×¨ ×›×œ',0),(251553,6988,'el','Î¤Î¹Î¼Î® ÎºÎ¬Î¸Îµ',0),(251554,6988,'zh','å•ä»·\r\n',0),(251555,6988,'sv','Pris per styck',0),(251556,6988,'it','Ogni prezzo',0),(251557,6988,'tl','',0),(251558,6988,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;&#3649;&#3605;&#3656;&#3621;&#3632;',0),(251559,6988,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤®à¥‚à¤²à¥à¤¯',0),(251560,6988,'ms','Harga setiap',0),(251561,6988,'ar','Ø³Ø¹Ø± Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(251562,6988,'fr','Prix de chaque',0),(251563,6988,'jp','ä¾¡æ ¼å„',0),(251564,6988,'pt','PreÃ§o cada',0),(251565,6988,'ru','Ð¦ÐµÐ½Ð° ÐºÐ°Ð¶Ð´Ð¾Ð³Ð¾',0),(251566,6988,'es','Precio Cada Uno',0),(251567,6988,'de','Preis pro StÃ¼ck',0),(251568,6988,'en','Price Each',0),(251569,6989,'is','',0),(251570,6989,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(251571,6989,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù‚ÙŠÙ…Øª Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(251572,6989,'tr','Hisse baÅŸÄ±na birim fiyat',0),(251573,6989,'pl','Jednostki cena jednostkowa zapasÃ³w',0),(251574,6989,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ñ†ÐµÐ½Ð° Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° ÑÑŠÑÑ‚Ð°Ð²',0),(251575,6989,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ø³Ù¹Ø§Ú© Ù‚ÛŒÙ…Øª ÛŒÙˆÙ†Ù¹Ø³',0),(251576,6989,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ñ†ÐµÐ½Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð°ÐºÑ†Ð¸Ñ˜Ð°',0),(251577,6989,'vi','ÄÆ¡n vá»‹ giÃ¡ má»—i Ä‘Æ¡n vá»‹ hÃ ng tá»“n',0),(251578,6989,'af','Pryseenhede per Voorraadeenheid',0),(251579,6989,'ro','UnitÄƒÅ£i de preÅ£ul pe unitate de stoc',0),(251580,6989,'et','Hind Ã¼hikute varude Ã¼hiku kohta',0),(251581,6989,'si','Cena enote zalog enoto',0),(251582,6989,'ba','Unit harga per Unit saham',0),(251583,6989,'nl','Prijs eenheden per voorraad eenheid',0),(251584,6989,'fi','Hinta yksikkÃ¶Ã¤ kohden varastossa',0),(251585,6989,'no','Pris enheter per lager enhet',0),(251586,6989,'da','Pris enheder pr. lager enhed',0),(251587,6989,'ko','ìž¬ê³  ë‹¨ìœ„ ë‹¹ ê°€ê²© ë‹¨ìœ„',0),(251588,6989,'he','×™×—×™×“×•×ª ×ž×—×™×¨ ×œ×™×—×™×“×ª ×ž×œ××™',0),(251589,6989,'el','Î¤Î¹Î¼Î® Î¼Î¿Î½Î¬Î´Ï‰Î½ Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Î¶Ï‰Î¹ÎºÎ¿Ï ÎºÎµÏ†Î±Î»Î±Î¯Î¿Ï…',0),(251590,6989,'zh','ä»·æ ¼å•ä½æ¯è‚¡ç¥¨å•ä½\r\n',0),(251591,6989,'sv','Pris enheter per aktie',0),(251592,6989,'it','UnitÃ  di prezzo per unitÃ  di magazzino',0),(251593,6989,'tl','',0),(251594,6989,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(251595,6989,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤¶à¥‡à¤¯à¤° à¤‡à¤•à¤¾à¤ˆ à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(251596,6989,'ms','Unit harga seunit saham',0),(251597,6989,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ø³Ø¹Ø± Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø© ØªØ®Ø²ÙŠÙ†',0),(251598,6989,'fr','UnitÃ©s de prix par unitÃ© de stockage',0),(251599,6989,'jp','åœ¨åº«å˜ä½å½“ãŸã‚Šã®ä¾¡æ ¼å˜ä½',0),(251600,6989,'pt','Unidades de preÃ§o por unidade de estoque',0),(251601,6989,'ru','Ð¦ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(251602,6989,'es','Unidades de Precio por Unidad de Stock',0),(251603,6989,'de','Preis Einheiten pro Stock Einheit',0),(251604,6989,'en','Price Units per Stock Unit',0),(251605,6990,'is','',0),(251606,6990,'dr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(251607,6990,'pr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(251608,6990,'tr','Fiyat birimi adÄ±',0),(251609,6990,'pl','Nazwa jednostki cena',0),(251610,6990,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(251611,6990,'ur','Ù‚ÛŒÙ…Øª ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ù†Ø§Ù…',0),(251612,6990,'sr','Ð˜Ð¼Ðµ ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð°',0),(251613,6990,'vi','TÃªn ÄÆ¡n vá»‹ giÃ¡',0),(251614,6990,'af','Prys Eenheidnaam',0),(251615,6990,'ro','Nume de unitatea Pret',0),(251616,6990,'et','Hind Ã¼hiku nimi',0),(251617,6990,'si','Cena enote ime',0),(251618,6990,'ba','Nama Unit harga',0),(251619,6990,'nl','De naam van de eenheid van de prijs',0),(251620,6990,'fi','Hinta yksikÃ¶n nimi',0),(251621,6990,'no','Navn pÃ¥ pris',0),(251622,6990,'da','Pris enhed navn',0),(251623,6990,'ko','ê°€ê²© ë‹¨ìœ„ ì´ë¦„',0),(251624,6990,'he','×ž×—×™×¨ ×™×—×™×“×” ×©×',0),(251625,6990,'el','Î¤Î¹Î¼Î® Î¼Î¿Î½Î¬Î´Î±Ï‚ ÏŒÎ½Î¿Î¼Î±',0),(251626,6990,'zh','ä»·æ ¼å•ä½åç§°\r\n',0),(251627,6990,'sv','Pris enhet namn',0),(251628,6990,'it','Nome dell\'unitÃ  prezzo',0),(251629,6990,'tl','',0),(251630,6990,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(251631,6990,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤¨à¤¾à¤®',0),(251632,6990,'ms','Nama Unit harga',0),(251633,6990,'ar','Ø¥Ø³Ù… ÙˆØ­Ø¯Ø© Ø§Ù„Ø³Ø¹Ø±',0),(251634,6990,'fr','Nom de l\'unitÃ© prix',0),(251635,6990,'jp','ä¾¡æ ¼å˜ä½å',0),(251636,6990,'pt','Nome da unidade de preÃ§o',0),(251637,6990,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¦ÐµÐ½Ð°',0),(251638,6990,'es','Nombre de la Unidad de Precio ',0),(251639,6990,'de','Preise-Unit-Namen',0),(251640,6990,'en','Price Unit Name',0),(251641,6991,'is','',0),(251642,6991,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø±Ù',0),(251643,6991,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø±Ù',0),(251644,6991,'tr','BaÅŸvuru kodu',0),(251645,6991,'pl','Referencyjny',0),(251646,6991,'bg','Ð ÐµÑ„ÐµÑ€ÐµÐ½Ñ‚ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(251647,6991,'ur','Ø­ÙˆØ§Ù„Û Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(251648,6991,'sr','Ð˜Ð” Ñ€ÐµÑ„ÐµÑ€ÐµÐ½Ñ‚Ð½Ð¾Ð³',0),(251649,6991,'vi','ID Tham kháº£o',0),(251650,6991,'af','Verwysing ID',0),(251651,6991,'ro','ReferinÈ›Äƒ ID',0),(251652,6991,'et','Viitenumber',0),(251653,6991,'si','ReferenÄna Å¡tevilka',0),(251654,6991,'ba','ID referensi',0),(251655,6991,'nl','Referentie-ID',0),(251656,6991,'fi','Viitteen tunnus',0),(251657,6991,'no','Referanse-ID',0),(251658,6991,'da','Reference-ID',0),(251659,6991,'ko','ì°¸ê³  ID',0),(251660,6991,'he','×ž×–×”×” ×”×¤× ×™×”',0),(251661,6991,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(251662,6991,'zh','å‚è€ƒç¼–å·\r\n',0),(251663,6991,'sv','Referens-ID',0),(251664,6991,'it','ID di riferimento',0),(251665,6991,'tl','',0),(251666,6991,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3629;&#3657;&#3634;&#3591;&#3629;&#3636;&#3591;',0),(251667,6991,'hi','à¤¸à¤‚à¤¦à¤°à¥à¤­ ID',0),(251668,6991,'ms','Rujukan ID',0),(251669,6991,'ar','Ù…Ø¹Ø±Ù Ù…Ø±Ø¬Ø¹',0),(251670,6991,'fr','ID de rÃ©fÃ©rence',0),(251671,6991,'jp','å‚ç…§ ID',0),(251672,6991,'pt','ID de referÃªncia',0),(251673,6991,'ru','ÐšÐžÐ” ÑÑÑ‹Ð»ÐºÐ¸',0),(251674,6991,'es','ID de Referencia',0),(251675,6991,'de','Referenz-ID',0),(251676,6991,'en','Reference ID',0),(251677,6992,'is','',0),(251678,6992,'dr','Ø­Ø°Ù Ø¹Ù„Ø§Ù…Øª Ù‡Ø§ÙŠ Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ø² Ù…ØªÙ† ÙÙŠÙ„Ø¯Ù‡Ø§',0),(251679,6992,'pr','Ø­Ø°Ù Ø¹Ù„Ø§Ù…Øª Ù‡Ø§ÙŠ Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ø² Ù…ØªÙ† ÙÙŠÙ„Ø¯Ù‡Ø§',0),(251680,6992,'tr','TÄ±rnak iÅŸareti iÃ§inde metin alanlarÄ± Ã¼zerinden iÅŸaretlerini kaldÄ±rmak',0),(251681,6992,'pl','UsuÅ„ ofertÄ™ znaki od wewnÄ…trz pÃ³l tekstowych',0),(251682,6992,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ð¼Ð°Ñ€ÐºÐ¸ Ð¾Ñ‚ Ð² Ñ‚ÐµÐºÑÑ‚Ð¾Ð²Ð¸ Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(251683,6992,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: Ø³Û’ Ù…Ø§Ø±Ú©Ø³ Ú©Û’ Ø§Ù†Ø¯Ø± Ù…ØªÙ† Ù‚Ø·Ø¹Ø§Øª ÛÙ¹Ø§Ø¦ÛŒÚº',0),(251684,6992,'sr','Ð£ÐºÐ»Ð¾Ð½Ð¸Ñ‚Ðµ Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ñ‚Ñ€Ð°Ð³Ð¾Ð²Ð¸ Ð¾Ð´ ÑƒÐ½ÑƒÑ‚Ð°Ñ€ Ð¿Ð¾Ñ™Ð° Ð·Ð° Ñ‚ÐµÐºÑÑ‚',0),(251685,6992,'vi','Bá» Ä‘Ã¡nh dáº¥u bÃ¡o giÃ¡ tá»« trÆ°á»ng vÄƒn báº£n',0),(251686,6992,'af','Verwyder Aanhalingstekens Van Teksvelde Binne-in',0),(251687,6992,'ro','Citat eliminaÅ£i mÄƒrcile de Ã®n cÃ¢mpuri Text',0),(251688,6992,'et','Eemalda jutumÃ¤rgid tekstivÃ¤ljadelt',0),(251689,6992,'si','Premestitev citiram znamk od znotraj polja z besedilom',0),(251690,6992,'ba','Menghapus kutipan tanda dari dalam bidang teks',0),(251691,6992,'nl','Citaat merken uit binnen tekstvelden verwijderen',0),(251692,6992,'fi','Poista lainaus Marks teksti aloilla',0),(251693,6992,'no','Fjern sitat merker fra i tekstfelt',0),(251694,6992,'da','Fjern citat mÃ¦rker fra inden for tekstfelter',0),(251695,6992,'ko','ì¸ìš© í…ìŠ¤íŠ¸ í•„ë“œ ë‚´ì—ì„œ í‘œì‹œë¥¼ ì œê±°',0),(251696,6992,'he','×œ×”×¡×™×¨ ×‘×–×›×™×•×ª ×‘×”×¦×¢×ª ×ž×—×™×¨ ×¡×™×ž× ×™ ×‘×ª×•×š ×©×“×•×ª ×˜×§×¡×˜',0),(251697,6992,'el','Î‘Ï†Î±Î¹ÏÎ­ÏƒÏ„Îµ Ï€Î±ÏÎ±Î¸Î­Ï„Ï‰ ÏƒÎ®Î¼Î±Ï„Î± Î±Ï€ÏŒ Î¼Î­ÏƒÎ± ÏƒÎµ Ï€ÎµÎ´Î¯Î± ÎºÎµÎ¹Î¼Î­Î½Î¿Ï…',0),(251698,6992,'zh','ä»Žæ–‡æœ¬å­—æ®µå†…ç§»é™¤æŠ¥ä»·\r\n',0),(251699,6992,'sv','Ta bort citat mÃ¤rken frÃ¥n inom textfÃ¤lt',0),(251700,6992,'it','Citazione rimuovere marchi da ai campi di testo',0),(251701,6992,'tl','',0),(251702,6992,'th','&#3621;&#3610;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3588;&#3635;&#3614;&#3641;&#3604;&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(251703,6992,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£ à¤ªà¤¾à¤  à¤«à¤¼à¥€à¤²à¥à¤¡ à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤¸à¥‡ à¤¨à¤¿à¤¶à¤¾à¤¨ à¤¹à¤Ÿà¤¾à¤à¤',0),(251704,6992,'ms','Mengeluarkan petikan markah dari dalam bidang-bidang teks',0),(251705,6992,'ar','Ø¥Ø²Ø§Ù„Ø© Ø¹Ù„Ø§Ù…Ø© Ø§Ù‚ØªØ¨Ø§Ø³ Ø¹Ù„Ø§Ù…Ø§Øª Ù…Ù† Ø¯Ø§Ø®Ù„ Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù†Øµ',0),(251706,6992,'fr','Supprimer citation marques faites Ã  l\'intÃ©rieur des champs de texte',0),(251707,6992,'jp','å¼•ç”¨ãƒ†ã‚­ã‚¹ãƒˆ ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰å†…ã‹ã‚‰ãƒžãƒ¼ã‚¯ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(251708,6992,'pt','CitaÃ§Ã£o remover marcas de dentro de campos de texto',0),(251709,6992,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€ÑƒÑŽ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð·Ð½Ð°ÐºÐ¸ Ð¸Ð· Ð²Ð½ÑƒÑ‚Ñ€Ð¸ Ñ‚ÐµÐºÑÑ‚Ð¾Ð²Ñ‹Ñ… Ð¿Ð¾Ð»ÐµÐ¹',0),(251710,6992,'es','Eliminar Comillas Desde Dentro de Los Campos de Texto',0),(251711,6992,'de','Zitat-Zeichen in Textfeldern zu entfernen',0),(251712,6992,'en','Remove Quote Marks From Within Text Fields',0),(251713,6993,'is','',0),(251714,6993,'dr','(~)',0),(251715,6993,'pr','ÙƒØ§Ù…Ø§ Ø±Ø§ Ø¯Ø± Ù…ØªÙ† Ø¨Ø§ Ø§ÙŠÙ† Ø¹Ù„Ø§Ù…Øª Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† ÙƒÙ†ÙŠØ¯  (~)',0),(251716,6993,'tr','Tilde(~) ile virgÃ¼l metnin iÃ§inde deÄŸiÅŸtir',0),(251717,6993,'pl','ZastÄ…p przecinki w tekÅ›cie Tilde(~)',0),(251718,6993,'bg','Ð—Ð°Ð¼ÐµÐ½Ð¸ Ð·Ð°Ð¿ÐµÑ‚Ð°Ð¸ Ð² Ñ‚ÐµÐºÑÑ‚Ð° Ñ Tilde(~)',0),(251719,6993,'ur','Tilde(~) Ú©Û’ Ø³Ø§ØªÚ¾ ÙˆÙ‚Ù Ú©Û’ Ø§Ù†Ø¯Ø± Ù…ØªÙ† Ø¨Ø¯Ù„ Ø¯ÛŒÚº',0),(251720,6993,'sr','Ð—Ð°Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð·Ð°Ñ€ÐµÐ·Ðµ ÑƒÐ½ÑƒÑ‚Ð°Ñ€ Ñ‚ÐµÐºÑÑ‚Ð° ÑÐ° Ð¢Ð¸Ð»Ð´Ðµ(~)',0),(251721,6993,'vi','Thay tháº¿ dáº¥u pháº©y trong vÄƒn báº£n vá»›i dáº¥u ngÃ£',0),(251722,6993,'af','Vervang Kommas Binne-in Teks met Slangetjie of Tilde (~)',0),(251723,6993,'ro','ÃŽnlocuiÅ£i virgule Ã®n textul cu Tilde(~)',0),(251724,6993,'et','Asenda tekstis komad tildega (~)',0),(251725,6993,'si','Zamenjajte vejice v besedilo z Tilde(~)',0),(251726,6993,'ba','Mengganti koma dalam teks dengan Tilde(~)',0),(251727,6993,'nl','Komma\'s in de tekst vervangen door Tilde(~)',0),(251728,6993,'fi','Pilkkuja tekstin korvaaminen Tilde(~)',0),(251729,6993,'no','Erstatt komma i tekst med Tilde(~)',0),(251730,6993,'da','Erstatte kommaer i tekst med Tilde(~)',0),(251731,6993,'ko','Tilde(~) í…ìŠ¤íŠ¸ ë‚´ì—ì„œ ì‰¼í‘œë¥¼ ë°”ê¿‰ë‹ˆë‹¤',0),(251732,6993,'he','×”×—×œ×£ ×¤×¡×™×§×™× ×‘×ª×•×š ×˜×§×¡×˜ Tilde(~)',0),(251733,6993,'el','Î‘Î½Ï„Î¹ÎºÎ±Ï„Î±ÏƒÏ„Î®ÏƒÏ„Îµ Ï„Î± ÎºÏŒÎ¼Î¼Î±Ï„Î± ÏƒÏ„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î¼Îµ Tilde(~)',0),(251734,6993,'zh','ä»¥æ³¢å½¢ç¬¦å·æ›¿æ¢æ–‡æœ¬ä¸­çš„é€—å·\r\n',0),(251735,6993,'sv','ErsÃ¤tta kommatecken i Text med Tilde(~)',0),(251736,6993,'it','Sostituire virgole all\'interno del testo con Tilde(~)',0),(251737,6993,'tl','',0),(251738,6993,'th','&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;(,)&#3616;&#3634;&#3618;&#3651;&#3609;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3604;&#3657;&#3623;&#3618;(~)',0),(251739,6993,'hi','à¤ªà¤¾à¤  à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤…à¤²à¥à¤ªà¤µà¤¿à¤°à¤¾à¤® à¤•à¥‡ à¤¸à¤¾à¤¥ Tilde(~) à¤•à¥€ à¤œà¤—à¤¹',0),(251740,6993,'ms','Menggantikan koma dalam teks dengan Tilde(~)',0),(251741,6993,'ar','Ø§Ø³ØªØ¨Ø¯Ø§Ù„ Ø§Ù„ÙÙˆØ§ØµÙ„ Ø¯Ø§Ø®Ù„ Ø§Ù„Ù†Øµ Ù…Ø¹ Tilde(~)',0),(251742,6993,'fr','Remplacer les virgules dans le texte par Tilde(~)',0),(251743,6993,'jp','ãƒ†ã‚­ã‚¹ãƒˆå†…ã§ã‚³ãƒ³ãƒžã‚’ Tilde(~) ã«ç½®ãæ›ãˆã¾ã™',0),(251744,6993,'pt','Substituir vÃ­rgulas dentro do texto com Tilde(~)',0),(251745,6993,'ru','Ð—Ð°Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð·Ð°Ð¿ÑÑ‚Ñ‹Ðµ Ð² Ñ‚ÐµÐºÑÑ‚Ðµ Tilde(~)',0),(251746,6993,'es','Reemplazar Comas Dentro del Texto con el Tilde (~)',0),(251747,6993,'de','Kommas im Text durch Tilde(~) ersetzen',0),(251748,6993,'en','Replace Commas Within Text with Tilde(~)',0),(251749,6994,'is','',0),(251750,6994,'dr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(251751,6994,'pr','Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(251752,6994,'tr','Stok birimi adÄ±',0),(251753,6994,'pl','Nazwa jednostki pieÅ„',0),(251754,6994,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° ÑÑŠÑÑ‚Ð°Ð²',0),(251755,6994,'ur','Ø§Ø³Ù¹Ø§Ú© ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ù†Ø§Ù…',0),(251756,6994,'sr','Ð˜Ð¼Ðµ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(251757,6994,'vi','TÃªn ÄÆ¡n vá»‹ HÃ ng tá»“n',0),(251758,6994,'af','Voorraad Eenheidnaam',0),(251759,6994,'ro','Nume de unitatea de stoc',0),(251760,6994,'et','Varude Ã¼hiku nimi',0),(251761,6994,'si','Ime osnovne enote',0),(251762,6994,'ba','Nama Unit saham',0),(251763,6994,'nl','Naam van de voorraad eenheid',0),(251764,6994,'fi','Varastossa yksikÃ¶n nimi',0),(251765,6994,'no','Navn pÃ¥ lager',0),(251766,6994,'da','Stock enhed navn',0),(251767,6994,'ko','ìž¬ê³  ë‹¨ìœ„ ì´ë¦„',0),(251768,6994,'he','×‘×©× ×™×—×™×“×ª ×ž×œ××™',0),(251769,6994,'el','ÎŒÎ½Î¿Î¼Î± Î¼Î¿Î½Î¬Î´Î± Î¶Ï‰Î¹ÎºÎ¿Ï ÎºÎµÏ†Î±Î»Î±Î¯Î¿Ï…',0),(251770,6994,'zh','åº“å­˜å•ä½åç§°\r\n',0),(251771,6994,'sv','Aktie namn',0),(251772,6994,'it','Nome dell\'unitÃ  in magazzino',0),(251773,6994,'tl','',0),(251774,6994,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(251775,6994,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤¨à¤¾à¤®',0),(251776,6994,'ms','Nama Unit saham',0),(251777,6994,'ar','Ø¥Ø³Ù… ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†',0),(251778,6994,'fr','Nom de l\'unitÃ© de stock',0),(251779,6994,'jp','åœ¨åº«å˜ä½ã®åå‰',0),(251780,6994,'pt','Nome da unidade de estoque',0),(251781,6994,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ñ„Ð¾Ð½Ð´Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ',0),(251782,6994,'es','Nombre de Unidad de Stock',0),(251783,6994,'de','Hat den Namen',0),(251784,6994,'en','Stock Unit Name',0),(251785,6995,'is','',0),(251786,6995,'dr','Ù…ÙˆÙÙ‚',0),(251787,6995,'pr','Ù…ÙˆÙÙ‚',0),(251788,6995,'tr','BaÅŸarÄ±lÄ±',0),(251789,6995,'pl','Sukces',0),(251790,6995,'bg','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾',0),(251791,6995,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨',0),(251792,6995,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð°',0),(251793,6995,'vi','ThÃ nh cÃ´ng',0),(251794,6995,'af','Suksesvol',0),(251795,6995,'ro','Cu success',0),(251796,6995,'et','Ã•nnestus',0),(251797,6995,'si','UspeÅ¡no',0),(251798,6995,'ba','Sukses',0),(251799,6995,'nl','Succesvolle',0),(251800,6995,'fi','Onnistunut',0),(251801,6995,'no','Vellykket',0),(251802,6995,'da','Vellykket',0),(251803,6995,'ko','ì„±ê³µì ì¸',0),(251804,6995,'he','×”×¦×œ×™×—',0),(251805,6995,'el','Î•Ï€Î¹Ï„Ï…Ï‡Î®Ï‚',0),(251806,6995,'zh','æˆåŠŸ\r\n',0),(251807,6995,'sv','FramgÃ¥ngsrika',0),(251808,6995,'it','Successo',0),(251809,6995,'tl','',0),(251810,6995,'th','&#3617;&#3637;&#3612;&#3621;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(251811,6995,'hi','à¤¸à¤«à¤²',0),(251812,6995,'ms','Berjaya',0),(251813,6995,'ar','Ù†Ø§Ø¬Ø­',0),(251814,6995,'fr','RÃ©ussie',0),(251815,6995,'jp','æˆåŠŸã—ã¾ã—ãŸã€‚',0),(251816,6995,'pt','Bem sucedido',0),(251817,6995,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ñ‹Ð¹',0),(251818,6995,'es','Exitoso',0),(251819,6995,'de','Erfolgreiche',0),(251820,6995,'en','Successful',0),(251821,6996,'is','',0),(251822,6996,'dr','/ Ø®ÙŠØ±',0),(251823,6996,'pr','Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª  Ø¨Ù„Ù‡  / Ø®ÙŠØ±',0),(251824,6996,'tr','Taxable(Y/N)',0),(251825,6996,'pl','Taxable(Y/N)',0),(251826,6996,'bg','Taxable(Y/N)',0),(251827,6996,'ur','Taxable(Y/N)',0),(251828,6996,'sr','Ð¢Ð°xÐ°Ð±Ð»Ðµ(Y/Ð)',0),(251829,6996,'vi','Chá»‹u thuáº¿ (CÃ³/KhÃ´ng)',0),(251830,6996,'af','Belasbaar (J/N)',0),(251831,6996,'ro','Taxable(Y/N)',0),(251832,6996,'et','Maksustatav (Jah/Ei)',0),(251833,6996,'si','Taxable(Y/N)',0),(251834,6996,'ba','Taxable(Y/N)',0),(251835,6996,'nl','Taxable(Y/N)',0),(251836,6996,'fi','Taxable(Y/N)',0),(251837,6996,'no','Taxable(Y/N)',0),(251838,6996,'da','Taxable(Y/N)',0),(251839,6996,'ko','Taxable(Y/N)',0),(251840,6996,'he','Taxable(Y/N)',0),(251841,6996,'el','Taxable(Y/N)',0),(251842,6996,'zh','åº”çº³ç¨Žï¼ˆæ˜¯/å¦ï¼‰\r\n',0),(251843,6996,'sv','Taxable(Y/N)',0),(251844,6996,'it','Taxable(Y/N)',0),(251845,6996,'tl','',0),(251846,6996,'th','&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618; (Y/N)',0),(251847,6996,'hi','Taxable(Y/N)',0),(251848,6996,'ms','Taxable(Y/N)',0),(251849,6996,'ar','Taxable(Y/N)',0),(251850,6996,'fr','Taxable(Y/N)',0),(251851,6996,'jp','Taxable(Y/N)',0),(251852,6996,'pt','Taxable(Y/N)',0),(251853,6996,'ru','Taxable(Y/N)',0),(251854,6996,'es','Imponible (S/N)',0),(251855,6996,'de','Taxable(Y/N)',0),(251856,6996,'en','Taxable(Y/N)',0),(251857,6997,'is','',0),(251858,6997,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„  Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(251859,6997,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„  Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(251860,6997,'tr','URL dosya CSV biÃ§imi Ã¶ÄŸeler iÃ§in',0),(251861,6997,'pl','Adres URL pliku CSV Format elementÃ³w',0),(251862,6997,'bg','URL Ñ„Ð°Ð¹Ð» Ð·Ð° CSV Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(251863,6997,'ur','ÛŒÙˆ Ø¢Ø± Ø§ÛŒÙ„ ÙØ§Ø¦Ù„ CSV ÙˆØ¶Ø¹ Ø§Ø´ÛŒØ§ Ú©Û’ Ù„ÛŒÛ’',0),(251864,6997,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ð¦Ð¡Ð’ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð°Ð²ÐºÐµ',0),(251865,6997,'vi','Há»“ sÆ¡ Ä‘Æ°á»ng dáº«n cho hÃ ng dáº¡ng CSV',0),(251866,6997,'af','BA (\"URL\") LÃªer Vir CSV Formaatitems',0),(251867,6997,'ro','URL-ul de fiÅŸier pentru elementele de Format CSV',0),(251868,6997,'et','URL/Faili asukoht CSV formaadis toodetefaili jaoks',0),(251869,6997,'si','URL datoteke CSV oblika elementov',0),(251870,6997,'ba','URL File CSV Format item',0),(251871,6997,'nl','Bestand met URL voor CSV-formaat Items',0),(251872,6997,'fi','URL tiedosto CSV muodossa eriÃ¤',0),(251873,6997,'no','URL fil For CSV-Format elementer',0),(251874,6997,'da','URL fil i CSV-Format emner',0),(251875,6997,'ko','URL íŒŒì¼ CSV í˜•ì‹ í•­ëª©ì— ëŒ€ í•œ',0),(251876,6997,'he','×›×ª×•×‘×ª url ×©×œ ×§×•×‘×¥ ×¢×‘×•×¨ ×¤×¨×™×˜×™× ×‘×¤×•×¨×ž×˜ CSV',0),(251877,6997,'el','URL Î±ÏÏ‡ÎµÎ¯Î¿Ï… CSV Î¼Î¿ÏÏ†Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(251878,6997,'zh','ç½‘å€æ–‡ä»¶é€—å·åˆ†éš”å€¼æ ¼å¼çš„é¡¹ç›®\r\n',0),(251879,6997,'sv','URL-filen fÃ¶r CSV-Format objekt',0),(251880,6997,'it','URL File per elementi di formato CSV',0),(251881,6997,'tl','',0),(251882,6997,'th','URL File For CSV Format Items',0),(251883,6997,'hi','CSV à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ URL à¤«à¤¼à¤¾à¤‡à¤²',0),(251884,6997,'ms','URL fail CSV Format item',0),(251885,6997,'ar','Ù…Ù„Ù URL Ù„Ø¹Ù†Ø§ØµØ± ØªÙ†Ø³ÙŠÙ‚ CSV',0),(251886,6997,'fr','Fichier d\'URL pour les Ã©lÃ©ments de Format CSV',0),(251887,6997,'jp','URL é …ç›®ã®ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ CSV å½¢å¼',0),(251888,6997,'pt','Arquivo URL para itens de formato CSV',0),(251889,6997,'ru','URL-Ð°Ð´Ñ€ÐµÑ Ñ„Ð°Ð¹Ð»Ð° Ð´Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð° CSV',0),(251890,6997,'es','URL File para Formato CSV de Items',0),(251891,6997,'de','URL-Datei fÃ¼r CSV Formatelemente',0),(251892,6997,'en','URL File For CSV Format Items',0),(251893,6998,'is','',0),(251894,6998,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ\r\n V',0),(251895,6998,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ\r\n V',0),(251896,6998,'tr','URL dosya CSV biÃ§iminde V',0),(251897,6998,'pl','Adres URL pliku w formacie CSV V',0),(251898,6998,'bg','URL Ñ„Ð°Ð¹Ð» Ð·Ð° CSV Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ V',0),(251899,6998,'ur','ÛŒÙˆ Ø¢Ø± Ø§ÛŒÙ„ ÙØ§Ø¦Ù„ CSV ÙˆØ¶Ø¹ V Ú©Û’ Ù„Ø¦Û’',0),(251900,6998,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ð¦Ð¡Ð’ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð’',0),(251901,6998,'vi','ÄÆ°á»ng dáº«n Há»“ sÆ¡ cho V dáº¡ng CSV',0),(251902,6998,'af','URL lÃªer vir CSV formaat V',0),(251903,6998,'ro','URL-ul de fiÅŸier pentru formatul CSV V',0),(251904,6998,'et','URL faili CSV formaadis V',0),(251905,6998,'si','URL datoteke CSV oblika V',0),(251906,6998,'ba','File URL untuk CSV Format V',0),(251907,6998,'nl','Bestand met URL voor CSV-indeling V',0),(251908,6998,'fi','URL tiedosto CSV-muodossa V',0),(251909,6998,'no','URL fil For CSV-Format V',0),(251910,6998,'da','URL fil i CSV-Format og V',0),(251911,6998,'ko','URL íŒŒì¼ CSV í˜•ì‹ Vì— ëŒ€ í•œ',0),(251912,6998,'he','×›×ª×•×‘×ª url ×©×œ ×§×•×‘×¥ ×‘×ª×‘× ×™×ª CSV V',0),(251913,6998,'el','URL Î±ÏÏ‡ÎµÎ¯Î¿Ï… CSV Î¼Î¿ÏÏ†Î® V',0),(251914,6998,'zh','é€—å·åˆ†éš”å€¼æ ¼å¼çš„ç½‘å€æ–‡ä»¶\r\n',0),(251915,6998,'sv','URL-filen fÃ¶r CSV-Format V',0),(251916,6998,'it','URL File di formato CSV V',0),(251917,6998,'tl','',0),(251918,6998,'th','URL File For CSV Format V',0),(251919,6998,'hi','URL à¤«à¤¼à¤¾à¤‡à¤² CSV à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª V à¤•à¥‡ à¤²à¤¿à¤',0),(251920,6998,'ms','URL fail untuk CSV Format V',0),(251921,6998,'ar','Ù…Ù„Ù URL Ù„ØªÙ†Ø³ÙŠÙ‚ CSV Ø§Ù„Ø®Ø§Ù…Ø³',0),(251922,6998,'fr','Fichier d\'URL pour le Format CSV V',0),(251923,6998,'jp','URL ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ CSV å½¢å¼ V ã®',0),(251924,6998,'pt','Arquivo de URL para o formato CSV V',0),(251925,6998,'ru','URL-Ð°Ð´Ñ€ÐµÑ Ñ„Ð°Ð¹Ð»Ð° Ð´Ð»Ñ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð° CSV V',0),(251926,6998,'es','URL File para Formato CSV de V',0),(251927,6998,'de','URL-Datei fÃ¼r das CSV-Format V',0),(251928,6998,'en','URL File For CSV Format V',0),(251929,6999,'is','',0),(251930,6999,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª ',0),(251931,6999,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª ',0),(251932,6999,'tr','Faaliyet Raporu',0),(251933,6999,'pl','Sprawozdanie z dziaÅ‚alnoÅ›ci',0),(251934,6999,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð°',0),(251935,6999,'ur','Ø³Ø±Ú¯Ø±Ù…ÛŒÙˆÚº Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(251936,6999,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(251937,6999,'vi','BÃ¡o CÃ¡o Hoáº¡t Äá»™ng',0),(251938,6999,'af','Aktiwiteitsverslag',0),(251939,6999,'ro','Raport de activitate',0),(251940,6999,'et','Tegevuste aruanne',0),(251941,6999,'si','PoroÄilo o dejavnostih',0),(251942,6999,'ba','Laporan Aktifitas',0),(251943,6999,'nl','Activiteitenverslag',0),(251944,6999,'fi','Toimintakertomus',0),(251945,6999,'no','Aktivitetsrapport',0),(251946,6999,'da','Aktivitetsrapport',0),(251947,6999,'ko','í™œë™ ë³´ê³ ì„œ',0),(251948,6999,'he','×“×•×— ×¤×¢×™×œ×•×ª',0),(251949,6999,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï„Î®Ï„Ï‰Î½',0),(251950,6999,'zh','æ´»åŠ¨æŠ¥å‘Š\r\n',0),(251951,6999,'sv','Verksamhetsrapport',0),(251952,6999,'it','Rapporto di attivitÃ ',0),(251953,6999,'tl','',0),(251954,6999,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3607;&#3635;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;',0),(251955,6999,'hi','à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(251956,6999,'ms','Laporan aktiviti',0),(251957,6999,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù†Ø´Ø§Ø·',0),(251958,6999,'fr','Rapport d\'activitÃ©',0),(251959,6999,'jp','æ´»å‹•ãƒ¬ãƒãƒ¼ãƒˆ',0),(251960,6999,'pt','RelatÃ³rio de actividades',0),(251961,6999,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(251962,6999,'es','Reporte de Actividad',0),(251963,6999,'de','TÃ¤tigkeitsbericht',0),(251964,6999,'en','Activity Report',0),(251965,7000,'is','',0),(251966,7000,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ø¹Ø¯Ù… ÙØ¹Ø§Ù„ÙŠØª Ø¯Ø± Ø¯ÙˆØ±Ù‡ Ø±Ø§ Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯ ',0),(251967,7000,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ø¹Ø¯Ù… ÙØ¹Ø§Ù„ÙŠØª Ø¯Ø± Ø¯ÙˆØ±Ù‡ Ø±Ø§ Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯ ',0),(251968,7000,'tr','DÃ¶nem iÃ§inde hiÃ§bir etkinlik ile Ã¶ÄŸeleri ekle',0),(251969,7000,'pl','DoÅ‚Ä…cz elementy z na razie brak aktywnoÅ›ci w okresie',0),(251970,7000,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð°Ð¹ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð±ÐµÐ· Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð² Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(251971,7000,'ur','Ø²Ù…Ø§Ù†Û’ Ù…ÛŒÚº Ú©ÙˆØ¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ø´ÛŒØ§Ø¡ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(251972,7000,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ ÑÐ° Ð½ÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ñƒ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñƒ',0),(251973,7000,'vi','Bao gá»“m hÃ ng khÃ´ng cÃ³ hoáº¡t Ä‘á»™ng trong giai Ä‘oáº¡n',0),(251974,7000,'af','Sluit Items met Geen Aktiwiteit in Periode in',0),(251975,7000,'ro','Includ elemente cu nici o activitate Ã®n perioada',0),(251976,7000,'et','Kaasa Ã¼ksused tegevuseks on periood',0),(251977,7000,'si','VkljuÄi elemente, ki nimajo dejavnosti v obdobju',0),(251978,7000,'ba','Termasuk barang-barang tanpa aktivitas dalam periode',0),(251979,7000,'nl','Serviceartikelen met geen activiteit in periode',0),(251980,7000,'fi','MyÃ¶s kohteet, kÃ¤yttÃ¤mÃ¤ttÃ¶mÃ¤nÃ¤ aikana',0),(251981,7000,'no','Ta elementer uten aktivitet i perioden',0),(251982,7000,'da','Omfatte elementer med ingen aktivitet i perioden',0),(251983,7000,'ko','ê¸°ê°„ì— ì•„ë¬´ëŸ° ìž‘ì—… í•­ëª© í¬í•¨',0),(251984,7000,'he','×›×œ×•×œ ×¤×¨×™×˜×™× ×‘×”× ××™×Ÿ ×¤×¢×™×œ×•×ª ×‘×ª×§×•×¤×”',0),(251985,7000,'el','Î£Ï…Î¼Ï€ÎµÏÎ¯Î»Î·ÏˆÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î¼Îµ ÎºÎ±Î¼Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± ÏƒÏ„Î¿ Ï‡ÏÎ¿Î½Î¹ÎºÏŒ',0),(251986,7000,'zh','åŒ…æ‹¬æœŸå†…æ— æ´»åŠ¨çš„é¡¹ç›®',0),(251987,7000,'sv','Inkludera objekt utan aktivitet i perioden',0),(251988,7000,'it','Includere oggetti con nessuna attivitÃ  nel periodo',0),(251989,7000,'tl','',0),(251990,7000,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3651;&#3609;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3',0),(251991,7000,'hi','à¤…à¤µà¤§à¤¿ à¤®à¥‡à¤‚ à¤•à¥‹à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤‡à¤Ÿà¤® à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(251992,7000,'ms','Termasuk item dengan tiada aktiviti dalam tempoh',0),(251993,7000,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ø¨Ù†ÙˆØ¯ Ù…Ø¹ Ù„Ø§ Ù†Ø´Ø§Ø· ÙÙŠ Ø§Ù„ÙØªØ±Ø©',0),(251994,7000,'fr','Inclure des Ã©lÃ©ments sans activitÃ© en pÃ©riode',0),(251995,7000,'jp','æœŸé–“ã®ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ãŒãªã„ã¨ã‚¢ã‚¤ãƒ†ãƒ ã‚’å«ã‚ã‚‹',0),(251996,7000,'pt','Incluir itens com nenhuma atividade no perÃ­odo',0),(251997,7000,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð½Ð¸ÐºÐ°ÐºÐ¾Ð¹ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð² Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(251998,7000,'es','Incluir Items Sin Actividad en el PerÃ­odo',0),(251999,7000,'de','EintrÃ¤ge ohne AktivitÃ¤t in Periode einschlieÃŸen',0),(252000,7000,'en','Include Items with No Activity in Period',0),(252001,7001,'is','',0),(252002,7001,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¨Ø±Ø§ÙŠ ØªÙƒØ±Ø§Ø±ÙŠ Ø¨ÙˆØ¯Ù†',0),(252003,7001,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¨Ø±Ø§ÙŠ ØªÙƒØ±Ø§Ø±ÙŠ Ø¨ÙˆØ¯Ù†',0),(252004,7001,'tr','Ã‡oÄŸaltma iÃ§in onay',0),(252005,7001,'pl','Wyboru do powielania',0),(252006,7001,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð° Ð´ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ‚Ð¸',0),(252007,7001,'ur','Ø§Ø¯ØºØ§Ù… Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„',0),(252008,7001,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð° Ð´ÑƒÐ¿Ð»Ð¸Ñ€Ð°ÑšÐµ',0),(252009,7001,'vi','Kiá»ƒm tra trÃ¹ng',0),(252010,7001,'af','Merk vir Duplikasie',0),(252011,7001,'ro','VerificaÅ£i pentru duplicarea',0),(252012,7001,'et','Kontrolli dubleerimist',0),(252013,7001,'si','ÄŒek za podvajanje',0),(252014,7001,'ba','Periksa duplikasi',0),(252015,7001,'nl','Selectievakje voor duplicatie',0),(252016,7001,'fi','Tarkista pÃ¤Ã¤llekkÃ¤isten',0),(252017,7001,'no','Se etter duplisering',0),(252018,7001,'da','Check for dobbeltarbejde',0),(252019,7001,'ko','ì¤‘ë³µ í™•ì¸',0),(252020,7001,'he','×”×¡×™×ž×•×Ÿ ×¢×‘×•×¨ ×©×›×¤×•×œ',0),(252021,7001,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ Î³Î¹Î± ÎµÏ€Î¹ÎºÎ¬Î»Ï…ÏˆÎ·',0),(252022,7001,'zh','æ£€æŸ¥å‰¯æœ¬\r\n',0),(252023,7001,'sv','Check fÃ¶r duplicering',0),(252024,7001,'it','Controllo per duplicazione',0),(252025,7001,'tl','',0),(252026,7001,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3585;&#3634;&#3619;&#3595;&#3657;&#3635;&#3595;&#3657;&#3629;&#3609;',0),(252027,7001,'hi','à¤¦à¥‹à¤¹à¤°à¤¾à¤µ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(252028,7001,'ms','Semak pertindihan',0),(252029,7001,'ar','ÙØ­Øµ Ø§Ù„ØªÙƒØ±Ø§Ø±',0),(252030,7001,'fr','Cocher pour la reproduction',0),(252031,7001,'jp','é‡è¤‡ã®ãƒã‚§ãƒƒã‚¯',0),(252032,7001,'pt','SeleÃ§Ã£o para duplicaÃ§Ã£o',0),(252033,7001,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(252034,7001,'es','Cheque para DuplicaciÃ³n',0),(252035,7001,'de','ÃœberprÃ¼fung auf doppelte',0),(252036,7001,'en','Check for Duplication',0),(252037,7002,'is','',0),(252038,7002,'dr','ÙƒØ¯ ÙƒØ§Ù„Ø§ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(252039,7002,'pr','ÙƒØ¯ ÙƒØ§Ù„Ø§ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(252040,7002,'tr','Girilen olmayan madde kodu',0),(252041,7002,'pl','Kod towaru nie wszedÅ‚',0),(252042,7002,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð½Ðµ ÑÐ° Ð²Ð»ÐµÐ·Ð»Ð¸',0),(252043,7002,'ur','Ø´Û’ Ú©ÙˆÚˆ Ø¯Ø§Ø®Ù„ Ù†ÛÛŒÚº',0),(252044,7002,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÐ½ÐµÑ‚Ð°',0),(252045,7002,'vi','ChÆ°a nháº­p mÃ£ hÃ ng',0),(252046,7002,'af','Itemkode Nie Ingevoer',0),(252047,7002,'ro','Cod articol nu a intrat',0),(252048,7002,'et','Tootekoodi ei sisestatud',0),(252049,7002,'si','Å ifra artikla ne vnesete',0),(252050,7002,'ba','Kode barang yang tidak dimasukkan',0),(252051,7002,'nl','Artikelcode niet ingevoerd',0),(252052,7002,'fi','Nimikkeen koodi ole tullut',0),(252053,7002,'no','Varekode er ikke angitt',0),(252054,7002,'da','Varekode, der er ikke angivet',0),(252055,7002,'ko','í•­ëª© ì½”ë“œë¥¼ ìž…ë ¥ í•˜ì§€',0),(252056,7002,'he','×§×•×“ ×¤×¨×™×˜ ×œ× ×”×•×›× ×¡',0),(252057,7002,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î´ÎµÎ½ Ï„ÎµÎ¸ÎµÎ¯',0),(252058,7002,'zh','æœªè¾“å…¥äº§å“ç¼–å·\r\n',0),(252059,7002,'sv','Artikelkod som angetts',0),(252060,7002,'it','Codice articolo non inserito',0),(252061,7002,'tl','',0),(252062,7002,'th','&#3619;&#3627;&#3633;&#3626;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3611;&#3657;&#3629;&#3609;',0),(252063,7002,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤¨à¤¹à¥€à¤‚ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾',0),(252064,7002,'ms','Kod item yang tidak dimasukkan',0),(252065,7002,'ar','Ø±Ù…Ø² Ø§Ù„ØµÙ†Ù Ù„Ù… ÙŠØ¯Ø®Ù„',0),(252066,7002,'fr','Code d\'article n\'est ne pas entrÃ©',0),(252067,7002,'jp','ã‚¢ã‚¤ãƒ†ãƒ  ã‚³ãƒ¼ãƒ‰ãŒå…¥åŠ›ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(252068,7002,'pt','CÃ³digo do artigo nÃ£o entrado',0),(252069,7002,'ru','ÐšÐ¾Ð´ Ð¢Ð¾Ð²Ð°Ñ€Ð° ÐÐµ Ð’Ð²ÐµÐ´ÐµÐ½',0),(252070,7002,'es','Item CÃ³digo no Entrado',0),(252071,7002,'de','Feld-Code nicht eingegeben',0),(252072,7002,'en','Item Code Not Entered',0),(252073,7003,'is','',0),(252074,7003,'dr','ÙƒØ§Ù„Ø§ Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø¹Ø§Ù Ø§Ø³Øª ',0),(252075,7003,'pr','ÙƒØ§Ù„Ø§ Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª Ù…Ø¹Ø§Ù Ø§Ø³Øª ',0),(252076,7003,'tr','Madde vergi muaf olduÄŸunu',0),(252077,7003,'pl','Element jest NIP',0),(252078,7003,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ðµ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð´ÐµÐ½Ð¸ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(252079,7003,'ur','Ø´Û’ Ù¹ÛŒÚ©Ø³ Ø³Û’ Ù…Ø³ØªØ«Ù†ÛŒ ÛÛ’',0),(252080,7003,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ Ð¸Ð·ÑƒÐ·ÐµÑ‚Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(252081,7003,'vi','HÃ ng miá»…n thuáº¿',0),(252082,7003,'af','Item is Vrygestel van Belasting',0),(252083,7003,'ro','Element este scutitÄƒ de taxa',0),(252084,7003,'et','Toode on maksuvaba',0),(252085,7003,'si','Element je davka oproÅ¡Äena',0),(252086,7003,'ba','Item adalah bebas pajak',0),(252087,7003,'nl','Object is belasting vrijgesteld',0),(252088,7003,'fi','Nimike ei verovapautus',0),(252089,7003,'no','Elementet er skattefri',0),(252090,7003,'da','Varen er moms undtaget',0),(252091,7003,'ko','ì„¸ê¸ˆ ë©´ì œ í•­ëª©ì€',0),(252092,7003,'he','×¤×¨×™×˜ ×¤×˜×•×¨ ×ž×ž×¡',0),(252093,7003,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÎ¯Î½Î±Î¹ Î±Ï€Î±Î»Î»Î±Î³Î¼Î­Î½Î± Î±Ï€ÏŒ Ï„Î¿ Ï†ÏŒÏÎ¿',0),(252094,7003,'zh','é¡¹ç›®æ˜¯å…ç¨Ž\r\n',0),(252095,7003,'sv','Artikeln Ã¤r momsregistrering',0),(252096,7003,'it','Item Ã¨ esente IVA',0),(252097,7003,'tl','',0),(252098,7003,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(252099,7003,'hi','à¤®à¤¦ à¤•à¤° à¤®à¥à¤•à¥à¤¤ à¤¹à¥ˆ',0),(252100,7003,'ms','Perkara yang dikecualikan cukai',0),(252101,7003,'ar','Ø§Ù„ØµÙ†Ù Ù…Ø¹ÙÙŠ Ù…Ù† Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(252102,7003,'fr','Item est exonÃ©rÃ©e de taxes',0),(252103,7003,'jp','é …ç›®ã¯ã€ç¨Žå…é™¤',0),(252104,7003,'pt','Item Ã© isento de imposto',0),(252105,7003,'ru','ÐŸÑ€ÐµÐ´Ð¼ÐµÑ‚ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð³Ð¾ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(252106,7003,'es','Item es Exento de Impuestos',0),(252107,7003,'de','Item ist Steuer befreit',0),(252108,7003,'en','Item is Tax Exempt',0),(252109,7004,'is','',0),(252110,7004,'dr','Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ ',0),(252111,7004,'pr','Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ ',0),(252112,7004,'tr','Grup adÄ±',0),(252113,7004,'pl','Nazwa grupy',0),(252114,7004,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(252115,7004,'ur','Ú¯Ø±ÙˆÙ¾ Ú©Ø§ Ù†Ø§Ù…',0),(252116,7004,'sr','Ð˜Ð¼Ðµ Ð³Ñ€ÑƒÐ¿Ðµ',0),(252117,7004,'vi','TÃªn nhÃ³m',0),(252118,7004,'af','Groepnaam',0),(252119,7004,'ro','Nume de grup',0),(252120,7004,'et','RÃ¼hma nimi',0),(252121,7004,'si','Ime skupine',0),(252122,7004,'ba','Nama grup',0),(252123,7004,'nl','Groepsnaam',0),(252124,7004,'fi','RyhmÃ¤nimi',0),(252125,7004,'no','Gruppenavn',0),(252126,7004,'da','Gruppenavn',0),(252127,7004,'ko','ê·¸ë£¹ ì´ë¦„',0),(252128,7004,'he','×©× ×§×‘×•×¦×”',0),(252129,7004,'el','ÎŒÎ½Î¿Î¼Î± Î¿Î¼Î¬Î´Î±Ï‚',0),(252130,7004,'zh','ç»„åç§°\r\n',0),(252131,7004,'sv','Gruppens namn',0),(252132,7004,'it','Nome gruppo',0),(252133,7004,'tl','',0),(252134,7004,'th','&#3594;&#3639;&#3656;&#3629;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(252135,7004,'hi','à¤¸à¤®à¥‚à¤¹ à¤¨à¤¾à¤®',0),(252136,7004,'ms','Nama Kumpulan',0),(252137,7004,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(252138,7004,'fr','Nom du groupe',0),(252139,7004,'jp','ã‚°ãƒ«ãƒ¼ãƒ—å',0),(252140,7004,'pt','Nome do grupo',0),(252141,7004,'ru','Ð˜Ð¼Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(252142,7004,'es','Nombre de Grupo',0),(252143,7004,'de','Gruppenname',0),(252144,7004,'en','Group Name',0),(252145,7005,'is','',0),(252146,7005,'dr','Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ Ø¯Ø± Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(252147,7005,'pr','Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ Ø¯Ø± Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(252148,7005,'tr','Bu Ã¶ÄŸeyi bu gruba ekle',0),(252149,7005,'pl','ZawieraÄ‡ ten przedmiot w tej grupie',0),(252150,7005,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð¸ Ñ‚Ð¾Ð·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð² Ñ‚Ð°Ð·Ð¸ Ð³Ñ€ÑƒÐ¿Ð°',0),(252151,7005,'ur','Ø§Ø³ Ø´Û’ Ú©Ùˆ Ø§Ø³ Ú¯Ø±ÙˆÙ¾ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(252152,7005,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¾Ð²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ð¾Ð²Ð¾Ñ˜ Ð³Ñ€ÑƒÐ¿Ð¸',0),(252153,7005,'vi','Bao gá»“m hÃ ng nÃ y trong nhÃ³m nÃ y',0),(252154,7005,'af','Sluit Hierdie Item in Hierdie Groep in',0),(252155,7005,'ro','Include acest element Ã®n acest grup',0),(252156,7005,'et','Sisaldab seda kaupa selles grupis',0),(252157,7005,'si','VkljuÄite element v skupino',0),(252158,7005,'ba','Termasuk Item ini di grup ini',0),(252159,7005,'nl','Dit Item opnemen in deze groep',0),(252160,7005,'fi','SisÃ¤llytÃ¤ tÃ¤mÃ¤ ryhmÃ¤',0),(252161,7005,'no','Inkludere denne varen i denne gruppen',0),(252162,7005,'da','Indeholde denne vare i denne gruppe',0),(252163,7005,'ko','ì´ ê·¸ë£¹ì—ì´ í•­ëª©ì„ í¬í•¨',0),(252164,7005,'he','×œ×›×œ×•×œ ×¤×¨×™×˜ ×–×” ×‘×§×‘×•×¦×” ×–×•',0),(252165,7005,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÏ„Î±Î¹ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¶Î®Ï„Î·Î¼Î± ÏƒÎµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î¿Î¼Î¬Î´Î±',0),(252166,7005,'zh','åœ¨è¯¥ç»„åŒ…æ‹¬æ­¤é¡¹ç›®\r\n',0),(252167,7005,'sv','Inkludera denna post i denna grupp',0),(252168,7005,'it','Includere questo elemento in questo gruppo',0),(252169,7005,'tl','',0),(252170,7005,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;&#3651;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;&#3609;&#3637;&#3657;',0),(252171,7005,'hi','à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤‡à¤¸ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(252172,7005,'ms','Termasuk Item ini dalam Kumpulan ini',0),(252173,7005,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ù‡Ø°Ø§ Ø§Ù„Ø¨Ù†Ø¯ ÙÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(252174,7005,'fr','Inscrire cette question Ã  ce groupe',0),(252175,7005,'jp','ã“ã®ã‚°ãƒ«ãƒ¼ãƒ—ã«ã“ã®ã‚¢ã‚¤ãƒ†ãƒ ã‚’å«ã‚ã‚‹',0),(252176,7005,'pt','Incluir este Item neste grupo',0),(252177,7005,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿ÑƒÐ½ÐºÑ‚ Ð² ÑÑ‚Ð¾Ð¹ Ð³Ñ€ÑƒÐ¿Ð¿Ðµ',0),(252178,7005,'es','Incluir Este Item en Este Grupo',0),(252179,7005,'de','Diesem Titel in dieser Gruppe enthalten',0),(252180,7005,'en','Include This Item in This Group',0),(252181,7006,'is','',0),(252182,7006,'dr','ØªØ®ØµÙŠØµ Ú¯Ø±ÙˆÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø± ÙƒØ§Ù„Ø§',0),(252183,7006,'pr','ØªØ®ØµÙŠØµ Ú¯Ø±ÙˆÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø± ÙƒØ§Ù„Ø§',0),(252184,7006,'tr','Madde mÃ¼ÅŸteri grubu atama',0),(252185,7006,'pl','Pozycja grupy klientÃ³w',0),(252186,7006,'bg','Ð“Ñ€ÑƒÐ¿Ð° Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(252187,7006,'ur','Ø´Û’ Ú©Ø³Ù¹Ù…Ø± Ú¯Ø±ÙˆÙ¾ ØªÙÙˆÛŒØ¶',0),(252188,7006,'sr','Ð—Ð°Ð´Ð°Ñ‚Ð°Ðº Ð³Ñ€ÑƒÐ¿Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° ÐºÑƒÐ¿Ñ†Ñƒ',0),(252189,7006,'vi','Chá»‰ Ä‘á»‹nh nhÃ³m khÃ¡ch hÃ ng cho hÃ ng',0),(252190,7006,'af','Item Klant/KliÃ«nt Groep Toeskrywing',0),(252191,7006,'ro','Grupa de client articole misiune',0),(252192,7006,'et','Toote kliendigrupi mÃ¤Ã¤ramine',0),(252193,7006,'si','Skupina artikla kupcu odstop',0),(252194,7006,'ba','Kelompok pelanggan item tugas',0),(252195,7006,'nl','Klant itemgroep toewijzing',0),(252196,7006,'fi','Nimike-asiakasryhmÃ¤ tehtÃ¤vÃ¤n',0),(252197,7006,'no','Kunden varegruppe tildeling',0),(252198,7006,'da','Varegruppe kunde tildeling',0),(252199,7006,'ko','í•­ëª© ê³ ê° ê·¸ë£¹ í• ë‹¹',0),(252200,7006,'he','×§×‘×•×¦×ª ×œ×§×•×—×•×ª ×œ×¤×¨×™×˜ ×”×§×¦××”',0),(252201,7006,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ Î¿Î¼Î¬Î´Î± ÎµÎ¹Î´ÏŽÎ½ Î±Î½Î¬Î¸ÎµÏƒÎ·Ï‚',0),(252202,7006,'zh','é¡¹ç›®å®¢æˆ·ç»„åˆ†é…\r\n',0),(252203,7006,'sv','Artikelgrupp kund tilldelning',0),(252204,7006,'it','Assegnazione gruppo cliente elemento',0),(252205,7006,'tl','',0),(252206,7006,'th','&#3585;&#3634;&#3619;&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;&#3585;&#3621;&#3640;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(252207,7006,'hi','à¤†à¤‡à¤Ÿà¤® à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹ à¤…à¤¸à¤¾à¤‡à¤¨à¤®à¥‡à¤‚à¤Ÿ',0),(252208,7006,'ms','Tugasan Kumpulan pelanggan item',0),(252209,7006,'ar','Ø¥Ø­Ø§Ù„Ø© Ø§Ù„Ø¨Ù†Ø¯ Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(252210,7006,'fr','Affectation article groupe client',0),(252211,7006,'jp','å“ç›®ã®é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—ã®å‰²ã‚Šå½“ã¦',0),(252212,7006,'pt','AtribuiÃ§Ã£o do item cliente grupo',0),(252213,7006,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð² Ð¿ÑƒÐ½ÐºÑ‚ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(252214,7006,'es','Item Cliente AsignaciÃ³n de Grupo',0),(252215,7006,'de','Element Kunde Gruppenzuordnung',0),(252216,7006,'en','Item Customer Group Assignment',0),(252217,7007,'is','',0),(252218,7007,'dr','Ù‚ÙŠÙ…Øª ÙˆÙŠÚ˜Ù‡',0),(252219,7007,'pr','Ù‚ÙŠÙ…Øª ÙˆÙŠÚ˜Ù‡',0),(252220,7007,'tr','Ã–zel fiyat',0),(252221,7007,'pl','Specjalna cena',0),(252222,7007,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð° Ñ†ÐµÐ½Ð°',0),(252223,7007,'ur','Ø®Ø§Øµ Ù‚ÛŒÙ…Øª',0),(252224,7007,'sr','ÐŸÐ¾ÑÐµÐ±Ð½Ðµ Ñ†Ð¸Ñ˜ÐµÐ½Ðµ',0),(252225,7007,'vi','GÃ­a Ä‘áº·c biá»‡t',0),(252226,7007,'af','Spesiale Prys',0),(252227,7007,'ro','Pret special',0),(252228,7007,'et','Soodushind',0),(252229,7007,'si','Akcijska cena',0),(252230,7007,'ba','Harga khusus',0),(252231,7007,'nl','Speciale prijs',0),(252232,7007,'fi','Tarjoushinta',0),(252233,7007,'no','Spesialpris',0),(252234,7007,'da','SÃ¦rlige pris',0),(252235,7007,'ko','íŠ¹ë³„ í•œ ê°€ê²©',0),(252236,7007,'he','×ž×—×™×¨ ×ž×™×•×—×“',0),(252237,7007,'el','Î•Î¹Î´Î¹ÎºÎ® Ï„Î¹Î¼Î®',0),(252238,7007,'zh','ä¼˜æƒ ä»·\r\n',0),(252239,7007,'sv','Specialpris',0),(252240,7007,'it','Prezzo speciale',0),(252241,7007,'tl','',0),(252242,7007,'th','&#3619;&#3634;&#3588;&#3634;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(252243,7007,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤®à¥‚à¤²à¥à¤¯',0),(252244,7007,'ms','Harga istimewa',0),(252245,7007,'ar','Ø³Ø¹Ø± Ø®Ø§Øµ',0),(252246,7007,'fr','Prix spÃ©cial',0),(252247,7007,'jp','ç‰¹åˆ¥ä¾¡æ ¼',0),(252248,7007,'pt','PreÃ§o especial',0),(252249,7007,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ð°Ñ Ñ†ÐµÐ½Ð°',0),(252250,7007,'es','Precio Especial',0),(252251,7007,'de','Sonderpreis',0),(252252,7007,'en','Special Price',0),(252253,7008,'is','',0),(252254,7008,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ§Ø¯',0),(252255,7008,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ§Ø¯',0),(252256,7008,'tr','Bill malzemeleri Ã¶ÄŸesi listesi',0),(252257,7008,'pl','Zestawienie materiaÅ‚Ã³w elementu listy',0),(252258,7008,'bg','ÐšÐ¾Ð¼Ð¿Ð»ÐµÐºÑÐ½Ð¾ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº',0),(252259,7008,'ur','Ù…ÙˆØ§Ø¯ Ø´Û’ ÙÛØ±Ø³Øª Ú©Û’ Ø¨Ù„',0),(252260,7008,'sr','Ð‘Ð¸Ð» Ð¾Ð´ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð° Ð›Ð¸ÑÑ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(252261,7008,'vi','Danh SÃ¡ch HÃ³a ÄÆ¡n NguyÃªn Váº­t Liá»‡u',0),(252262,7008,'af','Materiaallys - Itemlys',0),(252263,7008,'ro','Proiect de lege de materiale element listÄƒ',0),(252264,7008,'et','Bill materjalid kaupade loend',0),(252265,7008,'si','Bill element seznama materialov',0),(252266,7008,'ba','Bill daftar bahan Item',0),(252267,7008,'nl','Bill materialen itemlijst',0),(252268,7008,'fi','Bill kohteen luettelo',0),(252269,7008,'no','Bill av materiale elementlisten',0),(252270,7008,'da','Bill af materiale elementlisten',0),(252271,7008,'ko','ìžë£Œ í•­ëª© ëª©ë¡ì˜ ë¹Œ',0),(252272,7008,'he','×‘×™×œ ×¤×¨×™×˜ ×¨×©×™×ž×”',0),(252273,7008,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï„Î¿Ï… ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ¹Î´ÏŽÎ½ Ï…Î»Î¹ÎºÎ¬',0),(252274,7008,'zh','ææ–™å¸å•é¡¹ç›®æ¸…å•\r\n',0),(252275,7008,'sv','Bill objekt lista',0),(252276,7008,'it','Bill dell\'elenco di elementi materiali',0),(252277,7008,'tl','',0),(252278,7008,'th','&#3619;&#3634;&#3618;&#3594;&#3639;&#3656;&#3629;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3636;&#3621;&#3586;&#3629;&#3591;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(252279,7008,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤•à¥€ à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤†à¤‡à¤Ÿà¤® à¤¸à¥‚à¤šà¥€',0),(252280,7008,'ms','Bil senarai barangan bahan-bahan',0),(252281,7008,'ar','Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ù„Ù„Ù…ÙˆØ§Ø¯ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¨Ù†Ø¯',0),(252282,7008,'fr','Projet de loi de la liste d\'Ã©lÃ©ments de matÃ©riaux',0),(252283,7008,'jp','éƒ¨å“è¡¨é …ç›®ã®',0),(252284,7008,'pt','Bill da lista de itens de materiais',0),(252285,7008,'ru','Ð‘Ð¸Ð»Ð» Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð² ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÑÐ¿Ð¸ÑÐºÐ°',0),(252286,7008,'es','Lista de Materiales Lista de Items',0),(252287,7008,'de','StÃ¼ckliste StÃ¼ckliste Element',0),(252288,7008,'en','Bill of Materials Item List',0),(252289,7009,'is','',0),(252290,7009,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(252291,7009,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(252292,7009,'tr','SatÄ±cÄ± Madde fiyatlarÄ±',0),(252293,7009,'pl','Ceny towaru dostawcy',0),(252294,7009,'bg','Ð¦ÐµÐ½Ð¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°',0),(252295,7009,'ur','ÙˆÛŒÙ†ÚˆØ± Ø´Û’ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº',0),(252296,7009,'sr','Ð¦ÐµÐ½Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(252297,7009,'vi','GiÃ¡ hÃ ng cá»§a ngÆ°á»i bÃ¡n',0),(252298,7009,'af','Verskaffer Itempryse',0),(252299,7009,'ro','PreÅ£urile de element vÃ¢nzÄƒtor',0),(252300,7009,'et','Hankija kauba eest',0),(252301,7009,'si','Cene artiklov dobavitelja',0),(252302,7009,'ba','Harga barang vendor',0),(252303,7009,'nl','Leverancier artikelprijzen',0),(252304,7009,'fi','Toimittajan nimikkeen hinnat',0),(252305,7009,'no','LeverandÃ¸ren varepriser',0),(252306,7009,'da','Kreditor varepriser',0),(252307,7009,'ko','ê³µê¸‰ ì—…ì²´ í•­ëª© ê°€ê²©',0),(252308,7009,'he','×ž×—×™×¨×™ ×¤×¨×™×˜ ×©×œ ×¡×¤×§',0),(252309,7009,'el','Î¤Î¹Î¼Î­Ï‚ ÎµÎ¹Î´ÏŽÎ½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(252310,7009,'zh','ä¾›åº”å•†é¡¹ç›®ä»·æ ¼\r\n',0),(252311,7009,'sv','Artikelpriser fÃ¶r leverantÃ¶r',0),(252312,7009,'it','Prezzi degli articoli Fornitore',0),(252313,7009,'tl','',0),(252314,7009,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(252315,7009,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤†à¤‡à¤Ÿà¤® à¤®à¥‚à¤²à¥à¤¯',0),(252316,7009,'ms','Penjual barang harga',0),(252317,7009,'ar','Ø£Ø³Ø¹Ø§Ø± ØµÙ†Ù Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(252318,7009,'fr','Prix dâ€™article fournisseur',0),(252319,7009,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼å•†å“ä¾¡æ ¼',0),(252320,7009,'pt','PreÃ§os de Item fornecedor',0),(252321,7009,'ru','Ð¦ÐµÐ½Ñ‹ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»Ñ',0),(252322,7009,'es','Precios de Item de Proveedor',0),(252323,7009,'de','Kreditor Artikelpreise',0),(252324,7009,'en','Vendor Item Prices',0),(252325,7010,'is','',0),(252326,7010,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(252327,7010,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(252328,7010,'tr','SatÄ±cÄ± fiyatlarÄ±',0),(252329,7010,'pl','Ceny producenta',0),(252330,7010,'bg','Vendor Ñ†ÐµÐ½Ð¸',0),(252331,7010,'ur','ÙˆÛŒÙ†ÚˆØ± Ù‚ÛŒÙ…ØªÙˆÚº',0),(252332,7010,'sr','Ð¦ÐµÐ½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(252333,7010,'vi','GiÃ¡ ngÆ°á»i bÃ¡n',0),(252334,7010,'af','Verskaffer Pryse',0),(252335,7010,'ro','PreÅ£urile de furnizor',0),(252336,7010,'et','tarnija hinnad',0),(252337,7010,'si','Cene dobavitelja',0),(252338,7010,'ba','Vendor harga',0),(252339,7010,'nl','Vendor prijzen',0),(252340,7010,'fi','MyyjÃ¤ hinnat',0),(252341,7010,'no','LeverandÃ¸rer priser',0),(252342,7010,'da','Kreditor priser',0),(252343,7010,'ko','ê³µê¸‰ ì—…ì²´ ê°€ê²©',0),(252344,7010,'he','×ž×—×™×¨×™ ×¡×¤×§',0),(252345,7010,'el','Î¤Î¹Î¼Î­Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(252346,7010,'zh','å–æ–¹ä»·æ ¼\r\n',0),(252347,7010,'sv','LeverantÃ¶rens priser',0),(252348,7010,'it','Prezzi Fornitore',0),(252349,7010,'tl','',0),(252350,7010,'th','&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(252351,7010,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€à¤®à¤¤à¥‹à¤‚',0),(252352,7010,'ms','Harga Penjual',0),(252353,7010,'ar','Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ù…ÙˆØ±Ø¯',0),(252354,7010,'fr','Prix du vendeur',0),(252355,7010,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®ä¾¡æ ¼',0),(252356,7010,'pt','PreÃ§os do fornecedor',0),(252357,7010,'ru','Ð¦ÐµÐ½Ñ‹ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»Ñ',0),(252358,7010,'es','Proveedor Precios',0),(252359,7010,'de','Lieferanten-Preise',0),(252360,7010,'en','Vendor Prices',0),(252361,7011,'is','',0),(252362,7011,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ ',0),(252363,7011,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ ',0),(252364,7011,'tr','SeÃ§enek gruplarÄ± Ekle',0),(252365,7011,'pl','DodaÄ‡ grupy opcji',0),(252366,7011,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¾Ð¿Ñ†Ð¸Ñ Ð³Ñ€ÑƒÐ¿Ð¸',0),(252367,7011,'ur','Ø§Ø®ØªÛŒØ§Ø± Ú¯Ø±ÙˆÛÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(252368,7011,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(252369,7011,'vi','Cá»™ng ThÃªm NhÃ³m Lá»±a Chá»n',0),(252370,7011,'af','Opsie Groepe Byvoeg',0),(252371,7011,'ro','Adauga opÅ£iunea grupuri',0),(252372,7011,'et','Lisada Ã¼levaade',0),(252373,7011,'si','Dodaj moÅ¾nost skupine',0),(252374,7011,'ba','Menambahkan opsi kelompok',0),(252375,7011,'nl','Groepsvakken toevoegen',0),(252376,7011,'fi','LisÃ¤Ã¤ asetus ryhmÃ¤t',0),(252377,7011,'no','Legge til alternativgrupper',0),(252378,7011,'da','TilfÃ¸je gruppebokse',0),(252379,7011,'ko','ì˜µì…˜ ê·¸ë£¹ ì¶”ê°€',0),(252380,7011,'he','×”×•×¡×£ ×§×‘×•×¦×•×ª ××¤×©×¨×•×ª',0),(252381,7011,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏ€Î¹Î»Î¿Î³Î® Î¿Î¼Î¬Î´Ï‰Î½',0),(252382,7011,'zh','å¢žåŠ é€‰é¡¹ç»„\r\n',0),(252383,7011,'sv','LÃ¤gga till grupprutor',0),(252384,7011,'it','Aggiungere l\'opzione gruppi',0),(252385,7011,'tl','',0),(252386,7011,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(252387,7011,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(252388,7011,'ms','Menambah opsyen Kumpulan',0),(252389,7011,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª',0),(252390,7011,'fr','Ajouter des groupes d\'options',0),(252391,7011,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ ã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(252392,7011,'pt','Adicionar grupos de opÃ§Ã£o',0),(252393,7011,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð¿ÐµÑ€ÐµÐºÐ»ÑŽÑ‡Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(252394,7011,'es','Agregar Grupos de Opciones',0),(252395,7011,'de','Optionsgruppen hinzufÃ¼gen',0),(252396,7011,'en','Add Option Groups',0),(252397,7012,'is','',0),(252398,7012,'dr','ØªØ¹ÙŠÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(252399,7012,'pr','ØªØ¹ÙŠÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(252400,7012,'tr','SeÃ§enekler atama',0),(252401,7012,'pl','Przypisywanie opcji',0),(252402,7012,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¾Ð¿Ñ†Ð¸Ð¸',0),(252403,7012,'ur','Ø§Ø®ØªÛŒØ§Ø±Ø§Øª ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(252404,7012,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(252405,7012,'vi','Chá»‰ Äá»‹nh Lá»±a Chá»n',0),(252406,7012,'af','Opsies Toestaan',0),(252407,7012,'ro','AtribuiÅ£i opÅ£iuni',0),(252408,7012,'et','MÃ¤Ã¤rake suvandid',0),(252409,7012,'si','DoloÄite moÅ¾nosti',0),(252410,7012,'ba','Menetapkan pilihan',0),(252411,7012,'nl','Opties toewijzen',0),(252412,7012,'fi','MÃ¤Ã¤ritÃ¤ asetukset',0),(252413,7012,'no','Tilordne alternativer',0),(252414,7012,'da','Tildel indstillinger',0),(252415,7012,'ko','ì˜µì…˜ ì§€ì •',0),(252416,7012,'he','×œ×”×§×¦×•×ª ××¤×©×¨×•×™×•×ª',0),(252417,7012,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(252418,7012,'zh','æŒ‡å®šé€‰é¡¹\r\n',0),(252419,7012,'sv','Tilldela alternativ',0),(252420,7012,'it','Assegnare opzioni',0),(252421,7012,'tl','',0),(252422,7012,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(252423,7012,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(252424,7012,'ms','Peruntukan opsyen',0),(252425,7012,'ar','ØªØ¹ÙŠÙŠÙ† Ø®ÙŠØ§Ø±Ø§Øª',0),(252426,7012,'fr','Attribuer des Options',0),(252427,7012,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’å‰²ã‚Šå½“ã¦ã‚‹',0),(252428,7012,'pt','Atribuir as opÃ§Ãµes',0),(252429,7012,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹',0),(252430,7012,'es','Asignar Opciones',0),(252431,7012,'de','Zuweisen von Optionen',0),(252432,7012,'en','Assign Options',0),(252433,7013,'is','',0),(252434,7013,'dr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® ØªÙˆÙ„ÙŠØ¯',0),(252435,7013,'pr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® ØªÙˆÙ„ÙŠØ¯',0),(252436,7013,'tr','BaÅŸlangÄ±Ã§ tarihi',0),(252437,7013,'pl','Tworzenie Data rozp.',0),(252438,7013,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(252439,7013,'ur','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(252440,7013,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(252441,7013,'vi','Táº¡o ngÃ y báº¯t Ä‘áº§u',0),(252442,7013,'af','Skep Begin Datum',0),(252443,7013,'ro','Data de Ã®nceput a crea',0),(252444,7013,'et','Loo algus kuupÃ¤ev',0),(252445,7013,'si','Ustvarite zaÄetni datum',0),(252446,7013,'ba','Mulai tanggal pembuatan',0),(252447,7013,'nl','Begindatum maken',0),(252448,7013,'fi','Luo aloituspÃ¤ivÃ¤',0),(252449,7013,'no','Opprett Start dato',0),(252450,7013,'da','Opret Start dato',0),(252451,7013,'ko','ì‹œìž‘ ë‚ ì§œë¥¼ ë§Œë“¤',0),(252452,7013,'he','×œ×™×¦×•×¨ ×‘×’×™×Ÿ ×ª××¨×™×š',0),(252453,7013,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(252454,7013,'zh','åˆ›å»ºå¼€å§‹æ—¥æœŸ\r\n',0),(252455,7013,'sv','Skapa bÃ¶rja datum',0),(252456,7013,'it','Creare data Begin',0),(252457,7013,'tl','',0),(252458,7013,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3626;&#3619;&#3657;&#3634;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(252459,7013,'hi','à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¬à¤¨à¤¾à¤à¤',0),(252460,7013,'ms','Mencipta Mulakan tarikh',0),(252461,7013,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡ ÙÙŠ Ø¥Ù†Ø´Ø§Ø¡',0),(252462,7013,'fr','Date de dÃ©but de crÃ©er',0),(252463,7013,'jp','é–‹å§‹æ—¥ä»˜ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(252464,7013,'pt','Criar Begin data',0),(252465,7013,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð”Ð°Ñ‚Ñƒ ÐÐ°Ñ‡Ð°Ð»Ð°',0),(252466,7013,'es','Crear Fecha de Comienza',0),(252467,7013,'de','Anfangsdatum zu erstellen',0),(252468,7013,'en','Create Begin Date',0),(252469,7014,'is','',0),(252470,7014,'dr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ®  ØªÙˆÙ„ÙŠØ¯',0),(252471,7014,'pr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ®  ØªÙˆÙ„ÙŠØ¯',0),(252472,7014,'tr','Tarih aralÄ±ÄŸÄ± oluÅŸturabilirsiniz',0),(252473,7014,'pl','UtwÃ³rz zakres dat.',0),(252474,7014,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ñ‚Ðµ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(252475,7014,'ur','ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(252476,7014,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¾Ð¿ÑÐµÐ³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(252477,7014,'vi','Táº¡o pháº¡m vi ngÃ y',0),(252478,7014,'af','Skep Datumreeks',0),(252479,7014,'ro','Crea intervalul de Date',0),(252480,7014,'et','Loo kuupÃ¤evavahemik',0),(252481,7014,'si','Ustvarite datumski obseg',0),(252482,7014,'ba','Membuat rentang tanggal',0),(252483,7014,'nl','Datum bereik maken',0),(252484,7014,'fi','Luo pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤alue',0),(252485,7014,'no','Opprette datointervall',0),(252486,7014,'da','Opret et datointerval',0),(252487,7014,'ko','ë‚ ì§œ ë²”ìœ„ ë§Œë“¤ê¸°',0),(252488,7014,'he','×™×¦×™×¨×ª ×˜×•×•×— ×ª××¨×™×›×™×',0),(252489,7014,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÏÏÎ¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½',0),(252490,7014,'zh','åˆ›å»ºæ—¥æœŸèŒƒå›´\r\n',0),(252491,7014,'sv','Skapa datumintervall',0),(252492,7014,'it','Creare l\'intervallo di Date',0),(252493,7014,'tl','',0),(252494,7014,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3594;&#3656;&#3623;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(252495,7014,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¬à¤¨à¤¾à¤à¤',0),(252496,7014,'ms','Mencipta pelbagai tarikh',0),(252497,7014,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù†Ø·Ø§Ù‚ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(252498,7014,'fr','CrÃ©er la plage de dates',0),(252499,7014,'jp','æ—¥ä»˜ã®ç¯„å›²ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(252500,7014,'pt','Criar o intervalo de datas',0),(252501,7014,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚',0),(252502,7014,'es','Crear Rango de Fechas',0),(252503,7014,'de','Create Date Range',0),(252504,7014,'en','Create Date Range',0),(252505,7015,'is','',0),(252506,7015,'dr','Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® ØªÙˆÙ„ÙŠØ¯',0),(252507,7015,'pr','Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® ØªÙˆÙ„ÙŠØ¯',0),(252508,7015,'tr','BitiÅŸ tarihi oluÅŸturma',0),(252509,7015,'pl','Tworzenie data zakoÅ„czenia',0),(252510,7015,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(252511,7015,'ur','Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ® ØªØ®Ù„ÛŒÙ‚',0),(252512,7015,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(252513,7015,'vi','Táº¡o ngÃ y káº¿t thÃºc',0),(252514,7015,'af','Skep End Datum',0),(252515,7015,'ro','Data de sfÃ¢rÅŸit a crea',0),(252516,7015,'et','Loo lÃµpp kuupÃ¤ev',0),(252517,7015,'si','Ustvariti konÄni datum',0),(252518,7015,'ba','Membuat tanggal akhir',0),(252519,7015,'nl','Einddatum maken',0),(252520,7015,'fi','Luo pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(252521,7015,'no','Opprette sluttdatoen',0),(252522,7015,'da','Oprette slutdato',0),(252523,7015,'ko','ë ë‚ ì§œë¥¼ ë§Œë“¤',0),(252524,7015,'he','×œ×™×¦×•×¨ ×ª××¨×™×š ×¡×™×•×',0),(252525,7015,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(252526,7015,'zh','åˆ›å»ºç»“æŸæ—¥æœŸ\r\n',0),(252527,7015,'sv','Skapa slutdatum',0),(252528,7015,'it','Creare la data di fine',0),(252529,7015,'tl','',0),(252530,7015,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(252531,7015,'hi','à¤…à¤‚à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¬à¤¨à¤¾à¤à¤',0),(252532,7015,'ms','Tarikh akhir membuat',0),(252533,7015,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙˆØ¹Ø¯ Ù†Ù‡Ø§ÙŠØ©',0),(252534,7015,'fr','Date de fin de crÃ©er',0),(252535,7015,'jp','çµ‚äº†æ—¥ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(252536,7015,'pt','Criar data final',0),(252537,7015,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ ÐšÐ¾Ð½ÐµÑ‡Ð½ÑƒÑŽ Ð”Ð°Ñ‚Ñƒ',0),(252538,7015,'es','Crear Fecha de TerminaciÃ³n',0),(252539,7015,'de','End-Datum erstellen',0),(252540,7015,'en','Create End Date',0),(252541,7016,'is','',0),(252542,7016,'dr','(Ù†Ø§Ù…Ø¹ÙŠÙ† ',0),(252543,7016,'pr','ØºÙŠØ± Ù‚Ø·Ø¹ÙŠ (Ù†Ø§Ù…Ø¹ÙŠÙ† ',0),(252544,7016,'tr','Belirsiz',0),(252545,7016,'pl','NieokreÅ›lony',0),(252546,7016,'bg','ÐÐµÐ¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½',0),(252547,7016,'ur','ØºÛŒØ± Ù…Ø¹ÛŒÙ†Û Ù…Ø¯Øª ØªÚ©',0),(252548,7016,'sr','ÐÐµÐ¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¾',0),(252549,7016,'vi','KhÃ´ng thá»i háº¡n',0),(252550,7016,'af','Onbepaalde',0),(252551,7016,'ro','NedeterminatÄƒ',0),(252552,7016,'et','MÃ¤Ã¤ramata',0),(252553,7016,'si','NedoloÄen',0),(252554,7016,'ba','Tidak terbatas',0),(252555,7016,'nl','Onbepaalde',0),(252556,7016,'fi','Toistaiseksi',0),(252557,7016,'no','Ubestemt',0),(252558,7016,'da','Ubestemt',0),(252559,7016,'ko','ë¬´ê¸°í•œ',0),(252560,7016,'he','×œ× ×ž×•×’×“×¨',0),(252561,7016,'el','Î‘Î¿ÏÎ¯ÏƒÏ„Î¿Ï… Ï‡ÏÏŒÎ½Î¿Ï…',0),(252562,7016,'zh','ä¸å®š\r\n',0),(252563,7016,'sv','ObestÃ¤md',0),(252564,7016,'it','Tempo indeterminato',0),(252565,7016,'tl','',0),(252566,7016,'th','&#3595;&#3638;&#3656;&#3591;&#3652;&#3617;&#3656;&#3617;&#3637;&#3586;&#3657;&#3629;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(252567,7016,'hi','à¤…à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤à¤•à¤¾à¤²à¥€à¤¨',0),(252568,7016,'ms','Tidak terhad',0),(252569,7016,'ar','Ø¥Ù„Ù‰ Ø£Ø¬Ù„ ØºÙŠØ± Ù…Ø³Ù…Ù‰',0),(252570,7016,'fr','IndÃ©finie',0),(252571,7016,'jp','ç„¡æœŸé™',0),(252572,7016,'pt','Por tempo indeterminado',0),(252573,7016,'ru','Ð‘ÐµÑÑÑ€Ð¾Ñ‡Ð½Ð¾Ðµ',0),(252574,7016,'es','Indefinido',0),(252575,7016,'de','Unbestimmte',0),(252576,7016,'en','Indefinite',0),(252577,7017,'is','',0),(252578,7017,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(252579,7017,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(252580,7017,'tr','Stok bildirim istekleri',0),(252581,7017,'pl','Spis zgÅ‚oszenia Å¼Ä…dania',0),(252582,7017,'bg','Ð˜ÑÐºÐ°Ð½Ð¸Ñ Ð·Ð° ÑƒÐ²ÐµÐ´Ð¾Ð¼ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(252583,7017,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(252584,7017,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ',0),(252585,7017,'vi','YÃªu Cáº§u Gá»­i ThÃ´ng BÃ¡o HÃ ng Trong Kho',0),(252586,7017,'af','Inventaris Kennisgewingsversoeke',0),(252587,7017,'ro','Cereri de notificare inventar',0),(252588,7017,'et','Varude Ekspordieelse teatamise',0),(252589,7017,'si','Zaloge obvestilu proÅ¡enj',0),(252590,7017,'ba','Persediaan pemberitahuan permintaan',0),(252591,7017,'nl','Verzoeken om voorraad-meldingen',0),(252592,7017,'fi','Varaston ilmoituspyynnÃ¶t',0),(252593,7017,'no','Lager-forespÃ¸rsler om katalogvarsling',0),(252594,7017,'da','Lageret anmeldelse anmodninger',0),(252595,7017,'ko','ìž¬ê³  ì•Œë¦¼ ìš”ì²­',0),(252596,7017,'he','×‘×§×©×•×ª ×“×™×•×•×— ×”×ž×œ××™',0),(252597,7017,'el','Î‘Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ Î³Î¹Î± ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(252598,7017,'zh','åº“å­˜é€šçŸ¥è¯·æ±‚\r\n',0),(252599,7017,'sv','Inventering anmÃ¤lan Ã¶nskemÃ¥l',0),(252600,7017,'it','Richieste di notifica di inventario',0),(252601,7017,'tl','',0),(252602,7017,'th','&#3585;&#3634;&#3619;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3651;&#3627;&#3657;&#3649;&#3592;&#3657;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(252603,7017,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥‚à¤šà¤¨à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(252604,7017,'ms','Inventori notis permintaan',0),(252605,7017,'ar','Ø·Ù„Ø¨Ø§Øª Ø¥Ø¹Ù„Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(252606,7017,'fr','Demandes de Notification de l\'inventaire',0),(252607,7017,'jp','åœ¨åº«é€šçŸ¥è¦æ±‚',0),(252608,7017,'pt','SolicitaÃ§Ãµes de notificaÃ§Ã£o de inventÃ¡rio',0),(252609,7017,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð²',0),(252610,7017,'es','Solicitaciones para Notificaciones de Inventario',0),(252611,7017,'de','Benachrichtigungsanforderungen Warenbestand',0),(252612,7017,'en','Inventory Notification Requests',0),(252613,7018,'is','',0),(252614,7018,'dr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(252615,7018,'pr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(252616,7018,'tr','GÃ¶nderilmedi',0),(252617,7018,'pl','Nie wysÅ‚ane',0),(252618,7018,'bg','ÐÐµ ÑÐµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°',0),(252619,7018,'ur','Ø¨Ú¾ÛŒØ¬Ø§ Ù†ÛÛŒÚº',0),(252620,7018,'sr','ÐÐµ ÑˆÐ°Ñ™Ñƒ',0),(252621,7018,'vi','ChÆ°a gá»­i',0),(252622,7018,'af','Nie Gestuur',0),(252623,7018,'ro','Nu a trimis',0),(252624,7018,'et','Saatmata',0),(252625,7018,'si','Ni poslano',0),(252626,7018,'ba','Tidak dikirim',0),(252627,7018,'nl','Niet verzonden',0),(252628,7018,'fi','Ei lÃ¤hetetty',0),(252629,7018,'no','Ikke sendt',0),(252630,7018,'da','Ikke sendt',0),(252631,7018,'ko','ì „ì†¡ ë˜ì§€',0),(252632,7018,'he','×œ× × ×©×œ×—',0),(252633,7018,'el','Î”ÎµÎ½ Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(252634,7018,'zh','æœªå‘é€\r\n',0),(252635,7018,'sv','Inte skickas',0),(252636,7018,'it','Non inviato',0),(252637,7018,'tl','',0),(252638,7018,'th','&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3626;&#3656;&#3591;',0),(252639,7018,'hi','à¤¨à¤¹à¥€à¤‚ à¤­à¥‡à¤œà¥‡ à¤—à¤',0),(252640,7018,'ms','Tidak dihantar',0),(252641,7018,'ar','Ø¹Ø¯Ù… Ø¥Ø±Ø³Ø§Ù„',0),(252642,7018,'fr','Non envoyÃ©',0),(252643,7018,'jp','é€ä¿¡ã•ã‚Œã¾ã›ã‚“ã€‚',0),(252644,7018,'pt','NÃ£o enviado',0),(252645,7018,'ru','ÐÐµ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(252646,7018,'es','No Enviado',0),(252647,7018,'de','Nicht gesendet',0),(252648,7018,'en','Not Sent',0),(252649,7019,'is','',0),(252650,7019,'dr','(Ø³ÙˆØ§Ø¨Ù‚) Ø¨Ø§Ø² Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù‡ Ø´Ø¯ ',0),(252651,7019,'pr','Ø§Ø³Ù†Ø§Ø¯ (Ø³ÙˆØ§Ø¨Ù‚) Ø¨Ø§Ø² Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù‡ Ø´Ø¯ ',0),(252652,7019,'tr','KayÄ±t DÃ¶ndÃ¼rdÃ¼',0),(252653,7019,'pl','Zwracanych rekordÃ³w',0),(252654,7019,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸, Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸',0),(252655,7019,'ur','Ù„ÙˆÙ¹ Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(252656,7019,'sr','Ð—Ð°Ð¿Ð¸ÑÐ° ÐºÐ¾Ñ˜Ð¸ ÑÑƒ Ð²Ñ€Ð°Ñ›ÐµÐ½Ð¸',0),(252657,7019,'vi','Há»“ sÆ¡ tráº£ láº¡i',0),(252658,7019,'af','Rekords Teruggegaan',0),(252659,7019,'ro','Inregistrari returnate',0),(252660,7019,'et','Tagastatavate kirjete',0),(252661,7019,'si','Vrnjenih zapisov',0),(252662,7019,'ba','Catatan kembali',0),(252663,7019,'nl','Geretourneerde records',0),(252664,7019,'fi','Palautettavien tietueiden',0),(252665,7019,'no','Postene som returneres',0),(252666,7019,'da','Poster, der returneres',0),(252667,7019,'ko','ë°˜í™˜ ë˜ëŠ” ë ˆì½”ë“œ',0),(252668,7019,'he','×”×¨×©×•×ž×•×ª ×”×ž×•×—×–×¨×•×ª',0),(252669,7019,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹ÏƒÏ„ÏÎ­Ï†Î¿Î½Ï„Î±Î¹',0),(252670,7019,'zh','è®°å½•è¿”å›ž\r\n',0),(252671,7019,'sv','Poster som returneras',0),(252672,7019,'it','Record restituiti',0),(252673,7019,'tl','',0),(252674,7019,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3588;&#3639;&#3609;',0),(252675,7019,'hi','à¤…à¤­à¤¿à¤²à¥‡à¤–à¥‹à¤‚ à¤®à¥‡à¤‚ à¤²à¥Œà¤Ÿà¥‡',0),(252676,7019,'ms','Rekod-rekod yang kembali',0),(252677,7019,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø³Ø¬Ù„Ø§Øª',0),(252678,7019,'fr','Enregistrements renvoyÃ©s',0),(252679,7019,'jp','è¿”ã•ã‚Œã‚‹ãƒ¬ã‚³ãƒ¼ãƒ‰',0),(252680,7019,'pt','Registros retornados',0),(252681,7019,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸, Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÐ¼Ñ‹Ðµ',0),(252682,7019,'es','Records Devueltos',0),(252683,7019,'de','ZurÃ¼ckgegebenen DatensÃ¤tze',0),(252684,7019,'en','Records Returned',0),(252685,7020,'is','',0),(252686,7020,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ',0),(252687,7020,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ',0),(252688,7020,'tr','BaÅŸlangÄ±Ã§ tarihi gÃ¶nder',0),(252689,7020,'pl','WyÅ›lij Data rozp.',0),(252690,7020,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(252691,7020,'ur','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(252692,7020,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(252693,7020,'vi','NgÃ y báº¯t Ä‘áº§u gá»­i',0),(252694,7020,'af','Gestuurde Datum Begin',0),(252695,7020,'ro','Data de Ã®nceput a trimite',0),(252696,7020,'et','Saada alguskuupÃ¤ev',0),(252697,7020,'si','PoÅ¡lji zaÄetni datum',0),(252698,7020,'ba','Mulai tanggal kirim',0),(252699,7020,'nl','Begindatum verzenden',0),(252700,7020,'fi','LÃ¤hetÃ¤ aloituspÃ¤ivÃ¤',0),(252701,7020,'no','Sende Start dato',0),(252702,7020,'da','Send Begin dato',0),(252703,7020,'ko','ì‹œìž‘ ë‚ ì§œë¥¼ ë³´ë‚´',0),(252704,7020,'he','×©×œ×— ×‘×’×™×Ÿ ×ª××¨×™×š',0),(252705,7020,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(252706,7020,'zh','å‘é€å¼€å§‹æ—¥æœŸ\r\n',0),(252707,7020,'sv','Skicka start datum',0),(252708,7020,'it','Invia data Begin',0),(252709,7020,'tl','',0),(252710,7020,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;',0),(252711,7020,'hi','à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤­à¥‡à¤œà¥‡à¤‚',0),(252712,7020,'ms','Menghantar tarikh mulakan',0),(252713,7020,'ar','Ø¥Ø±Ø³Ø§Ù„ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(252714,7020,'fr','Envoyer la Date de dÃ©but',0),(252715,7020,'jp','é–‹å§‹æ—¥ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(252716,7020,'pt','Envie a data de inÃ­cio',0),(252717,7020,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(252718,7020,'es','Enviar Fecha de Comienza',0),(252719,7020,'de','Sendedatum: Begin',0),(252720,7020,'en','Send Begin Date',0),(252721,7021,'is','',0),(252722,7021,'dr','ØªØ§Ø±ÙŠØ® Ø§Ø±Ø³Ø§Ù„ ',0),(252723,7021,'pr','ØªØ§Ø±ÙŠØ® Ø§Ø±Ø³Ø§Ù„ ',0),(252724,7021,'tr','GÃ¶nderme tarihi',0),(252725,7021,'pl','WyÅ›lij Data',0),(252726,7021,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð´Ð°Ñ‚Ð°',0),(252727,7021,'ur','ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(252728,7021,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(252729,7021,'vi','NgÃ y gá»­i',0),(252730,7021,'af','Gestuurde Datum',0),(252731,7021,'ro','Trimite data',0),(252732,7021,'et','Saada kuupÃ¤eva',0),(252733,7021,'si','PoÅ¡lji datum',0),(252734,7021,'ba','Tanggal Kirim',0),(252735,7021,'nl','Datum verzenden',0),(252736,7021,'fi','LÃ¤hetÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(252737,7021,'no','Sende dato',0),(252738,7021,'da','Send dato',0),(252739,7021,'ko','ë‚ ì§œë¥¼ ë³´ë‚´',0),(252740,7021,'he','×ª××¨×™×š ×©×œ×™×—×”',0),(252741,7021,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(252742,7021,'zh','å‘é€æ—¥æœŸ\r\n',0),(252743,7021,'sv','Skicka datum',0),(252744,7021,'it','Invia data',0),(252745,7021,'tl','',0),(252746,7021,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;',0),(252747,7021,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤­à¥‡à¤œà¥‡à¤‚',0),(252748,7021,'ms','Tarikh hantar',0),(252749,7021,'ar','ØªØ§Ø±ÙŠØ® Ø¥Ø±Ø³Ø§Ù„',0),(252750,7021,'fr','Envoyer Date',0),(252751,7021,'jp','æ—¥ä»˜ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(252752,7021,'pt','Envie a data',0),(252753,7021,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(252754,7021,'es','Fecha de EnvÃ­o',0),(252755,7021,'de','Sendedatum:',0),(252756,7021,'en','Send Date',0),(252757,7022,'is','',0),(252758,7022,'dr','Ø§Ø±Ø³Ø§Ù„ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® ',0),(252759,7022,'pr','Ø§Ø±Ø³Ø§Ù„ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® ',0),(252760,7022,'tr','GÃ¶nderme tarihi aralÄ±ÄŸÄ±',0),(252761,7022,'pl','WyÅ›lij zakres dat.',0),(252762,7022,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(252763,7022,'ur','Ø¨Ú¾ÛŒØ¬ÛŒÚº ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(252764,7022,'sr','ÐžÐ¿ÑÐµÐ³ Ð´Ð°Ñ‚ÑƒÐ¼Ð° ÑÐ»Ð°ÑšÐ°',0),(252765,7022,'vi','Pháº¡m vi ngÃ y gá»­i',0),(252766,7022,'af','Gestuurde Datum Reeks',0),(252767,7022,'ro','Intervalul de Date trimite',0),(252768,7022,'et','Saatmise kuupÃ¤evade vahemik',0),(252769,7022,'si','PoÅ¡lji datumski obseg',0),(252770,7022,'ba','Rentang tanggal kirim',0),(252771,7022,'nl','Verzenden datumbereik',0),(252772,7022,'fi','LÃ¤hetÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤alue',0),(252773,7022,'no','Send datointervall',0),(252774,7022,'da','Send datointerval',0),(252775,7022,'ko','ì†¡ì‹  ë‚ ì§œ ë²”ìœ„',0),(252776,7022,'he','×˜×•×•×— ×ª××¨×™×›×™× ×©×œ×—',0),(252777,7022,'el','Î•ÏÏÎ¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(252778,7022,'zh','å‘é€æ—¥æœŸèŒƒå›´\r\n',0),(252779,7022,'sv','Skicka datumintervall',0),(252780,7022,'it','Intervallo di Date di invio',0),(252781,7022,'tl','',0),(252782,7022,'th','&#3594;&#3656;&#3623;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3656;&#3591;',0),(252783,7022,'hi','à¤­à¥‡à¤œà¥‡à¤‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€',0),(252784,7022,'ms','Julat tarikh hantar',0),(252785,7022,'ar','Ù†Ø·Ø§Ù‚ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø±Ø³Ø§Ù„',0),(252786,7022,'fr','Plage de dates d\'envoi',0),(252787,7022,'jp','é€ä¿¡æ—¥ä»˜ç¯„å›²',0),(252788,7022,'pt','Intervalo de datas de envio',0),(252789,7022,'ru','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(252790,7022,'es','Rango de Fechas de EnvÃ­o',0),(252791,7022,'de','Send Datumsbereich',0),(252792,7022,'en','Send Date Range',0),(252793,7023,'is','',0),(252794,7023,'dr','Ø§Ø±Ø³Ø§Ù„ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(252795,7023,'pr','Ø§Ø±Ø³Ø§Ù„ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(252796,7023,'tr','BitiÅŸ tarihi gÃ¶nder',0),(252797,7023,'pl','WyÅ›lij data zakoÅ„czenia',0),(252798,7023,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(252799,7023,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(252800,7023,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(252801,7023,'vi','NgÃ y káº¿t thÃºc gá»­i',0),(252802,7023,'af','Gestuurde Datum Eindig',0),(252803,7023,'ro','Data de sfÃ¢rÅŸit a trimite',0),(252804,7023,'et','Saada lÃµppkuupÃ¤ev',0),(252805,7023,'si','PoÅ¡lji konÄni datum',0),(252806,7023,'ba','Akhir tanggal kirim',0),(252807,7023,'nl','Einddatum van sturen',0),(252808,7023,'fi','LÃ¤hetÃ¤ pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(252809,7023,'no','Sende sluttdatoen',0),(252810,7023,'da','Send slutdato',0),(252811,7023,'ko','ë ë‚ ì§œë¥¼ ë³´ë‚´ëŠ”',0),(252812,7023,'he','×œ×©×œ×•×— ×ª××¨×™×š ×¡×™×•×',0),(252813,7023,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(252814,7023,'zh','å‘é€ç»“æŸæ—¥æœŸ\r\n',0),(252815,7023,'sv','Skicka slutdatum',0),(252816,7023,'it','Inviare la data di fine',0),(252817,7023,'tl','',0),(252818,7023,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;',0),(252819,7023,'hi','à¤…à¤‚à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤­à¥‡à¤œà¥‡à¤‚',0),(252820,7023,'ms','Tarikh akhir menghantar',0),(252821,7023,'ar','Ø¥Ø±Ø³Ø§Ù„ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(252822,7023,'fr','Envoyer la Date de fin',0),(252823,7023,'jp','çµ‚äº†æ—¥ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(252824,7023,'pt','Envie a data de tÃ©rmino',0),(252825,7023,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(252826,7023,'es','Enviar Fecha de TerminaciÃ³n',0),(252827,7023,'de','Sendedatum: Ende',0),(252828,7023,'en','Send End Date',0),(252829,7024,'is','',0),(252830,7024,'dr','Ø´Ø±ÙˆØ¹ Ø³ÙŠØ³ØªÙ…',0),(252831,7024,'pr','Ø´Ø±ÙˆØ¹ Ø³ÙŠØ³ØªÙ…',0),(252832,7024,'tr','Sistem baÅŸlatmasÄ±',0),(252833,7024,'pl','Start systemu',0),(252834,7024,'bg','Ð¡Ñ‚Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(252835,7024,'ur','Ù†Ø¸Ø§Ù… Ø´Ø±ÙˆØ¹',0),(252836,7024,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚Ð°ÑšÐ° ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(252837,7024,'vi','Báº¯t Ä‘áº§u há»‡ thá»‘ng',0),(252838,7024,'af','Sisteem Begin',0),(252839,7024,'ro','Porneste sistemul',0),(252840,7024,'et','SÃ¼steemi kÃ¤ivitamisel',0),(252841,7024,'si','Sistem Start',0),(252842,7024,'ba','Sistem mulai',0),(252843,7024,'nl','Systeem Start',0),(252844,7024,'fi','ElimistÃ¶ alku',0),(252845,7024,'no','Systemoppstart',0),(252846,7024,'da','System Start',0),(252847,7024,'ko','ì‹œìŠ¤í…œ ì‹œìž‘',0),(252848,7024,'he','×ž×¢×¨×›×ª ×”×ª×—×œ×”',0),(252849,7024,'el','Î•ÎºÎºÎ¯Î½Î·ÏƒÎ· Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚',0),(252850,7024,'zh','ç³»ç»Ÿå¯åŠ¨\r\n',0),(252851,7024,'sv','Systemstart',0),(252852,7024,'it','Avvio del sistema',0),(252853,7024,'tl','',0),(252854,7024,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3619;&#3632;&#3610;&#3610;',0),(252855,7024,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­',0),(252856,7024,'ms','Memulakan sistem',0),(252857,7024,'ar','Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ù†Ø¸Ø§Ù…',0),(252858,7024,'fr','DÃ©marrage du systÃ¨me',0),(252859,7024,'jp','ã‚·ã‚¹ãƒ†ãƒ ã®èµ·å‹•',0),(252860,7024,'pt','InÃ­cio sistema',0),(252861,7024,'ru','Ð—Ð°Ð¿ÑƒÑÐº ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹',0),(252862,7024,'es','Iniciar Sistema',0),(252863,7024,'de','Start des Systems',0),(252864,7024,'en','System Start',0),(252865,7025,'is','',0),(252866,7025,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(252867,7025,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(252868,7025,'tr','PO Ekle',0),(252869,7025,'pl','DodaÄ‡ PO',0),(252870,7025,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° PO',0),(252871,7025,'ur','Ù¾Ùˆ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(252872,7025,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ ÐŸÐž',0),(252873,7025,'vi','ThÃªm ÄÆ¡n Mua HÃ ng',0),(252874,7025,'af','AB Byvoeg',0),(252875,7025,'ro','Adauga PO',0),(252876,7025,'et','Lisada PO',0),(252877,7025,'si','Dodajte PO',0),(252878,7025,'ba','Tambahkan PO',0),(252879,7025,'nl','PO toevoegen',0),(252880,7025,'fi','LisÃ¤Ã¤ PO',0),(252881,7025,'no','Legge PO',0),(252882,7025,'da','TilfÃ¸je PO',0),(252883,7025,'ko','í¬',0),(252884,7025,'he','×œ×”×•×¡×™×£ ×¤×•',0),(252885,7025,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ PO',0),(252886,7025,'zh','å¢žåŠ é‡‡è´­è®¢å•\r\n',0),(252887,7025,'sv','LÃ¤gg till PO',0),(252888,7025,'it','Aggiungi PO',0),(252889,7025,'tl','',0),(252890,7025,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(252891,7025,'hi','PO à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(252892,7025,'ms','Tambah PO',0),(252893,7025,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ùˆ',0),(252894,7025,'fr','Ajouter PO',0),(252895,7025,'jp','PO ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(252896,7025,'pt','Adicionar PO',0),(252897,7025,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ PO',0),(252898,7025,'es','Agregar OC',0),(252899,7025,'de','FÃ¼gen Sie PO',0),(252900,7025,'en','Add PO',0),(252901,7026,'is','',0),(252902,7026,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯',0),(252903,7026,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯',0),(252904,7026,'tr','GL hesap boÅŸ olmamalÄ±dÄ±r',0),(252905,7026,'pl','GL konto nie moÅ¼e byÄ‡ pusta',0),(252906,7026,'bg','GL Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ð¿Ñ€Ð°Ð·ÐµÐ½',0),(252907,7026,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø®Ø§Ù„ÛŒ Ù†ÛÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(252908,7026,'sr','Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ð½Ðµ Ð¼Ð¾Ñ€Ð° Ð´Ð° Ð±ÑƒÐ´Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð°',0),(252909,7026,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p KhÃ´ng ÄÆ°á»£c Äá»ƒ Trá»‘ng',0),(252910,7026,'af','AG Rekening Moet nie Leeg Wees Nie',0),(252911,7026,'ro','GL cont nu trebuie sÄƒ fie gol',0),(252912,7026,'et','GL konto ei tohi olla tÃ¼hi',0),(252913,7026,'si','GL raÄun ne sme biti prazen',0),(252914,7026,'ba','GL Account tidak boleh kosong',0),(252915,7026,'nl','GL Account Must Not Be Empty',0),(252916,7026,'fi','KÃ¤ytetÃ¤Ã¤nkÃ¶ KP-tiliÃ¤ ei voi olla tyhjÃ¤',0),(252917,7026,'no','GI-konto kan ikke vÃ¦re tomt',0),(252918,7026,'da','GL konto mÃ¥ ikke vÃ¦re tom',0),(252919,7026,'ko','GL ê³„ì • ë¹„ì–´ ìžˆì–´ì•¼',0),(252920,7026,'he','GL ×—×©×‘×•×Ÿ ××™× ×• ×™×›×•×œ ×œ×”×™×•×ª ×¨×™×§',0),(252921,7026,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î´ÎµÎ½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ½ÏŒ',0),(252922,7026,'zh','æ€»å¸å¸æˆ·ä¸èƒ½ä¸ºç©º\r\n',0),(252923,7026,'sv','GL konto fÃ¥r inte vara tom',0),(252924,7026,'it','GL Account non deve essere vuoto',0),(252925,7026,'tl','',0),(252926,7026,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3605;&#3657;&#3629;&#3591;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3591;&#3648;&#3611;&#3621;&#3656;&#3634;',0),(252927,7026,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤–à¤¾à¤²à¥€ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(252928,7026,'ms','GL akaun tidak boleh kosong',0),(252929,7026,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ÙŠÙƒÙˆÙ† Ø®Ø§Ù„ÙŠØ§',0),(252930,7026,'fr','GL compte ne doit pas Ãªtre vide',0),(252931,7026,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã¯ç©ºã«ã§ãã¾ã›ã‚“ã€‚',0),(252932,7026,'pt','GL conta nÃ£o deve estar vazia',0),(252933,7026,'ru','GL ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð½Ðµ Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ Ð¿ÑƒÑÑ‚Ð¾Ð¹',0),(252934,7026,'es','Cuenta LM No Debe Ser VacÃ­o',0),(252935,7026,'de','GL-Konto darf nicht leer sein.',0),(252936,7026,'en','GL Account Must Not Be Empty',0),(252937,7027,'is','',0),(252938,7027,'dr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ Ø®Ø±ÙŠØ¯ ',0),(252939,7027,'pr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ Ø®Ø±ÙŠØ¯ ',0),(252940,7027,'tr','SatÄ±nalma birimi baÅŸÄ±na fiyat',0),(252941,7027,'pl','Cena jednostkowa zakupu',0),(252942,7027,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(252943,7027,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ø®Ø±ÛŒØ¯ Ù‚ÛŒÙ…Øª',0),(252944,7027,'sr','Ð¦ÐµÐ½Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(252945,7027,'vi','GiÃ¡ má»—i Ä‘Æ¡n vá»‹ mua',0),(252946,7027,'af','Prys per Aankoopeenheid',0),(252947,7027,'ro','PreÈ›ul pe unitatea de cumpÄƒrare',0),(252948,7027,'et','Hind ostuÃ¼hiku kohta',0),(252949,7027,'si','Cena na enoto nabave',0),(252950,7027,'ba','Harga per Unit pembelian',0),(252951,7027,'nl','Prijs per eenheid van de aankoop',0),(252952,7027,'fi','Oston YksikkÃ¶hinta',0),(252953,7027,'no','Pris pr. innkjÃ¸psenhet',0),(252954,7027,'da','Pris pr. KÃ¸bsenhed',0),(252955,7027,'ko','êµ¬ë§¤ ë‹¨ê°€',0),(252956,7027,'he','×ž×—×™×¨ ×œ×™×—×™×“×” ×¨×›×™×©×”',0),(252957,7027,'el','Î¤Î¹Î¼Î® Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Î±Î³Î¿ÏÎ¬',0),(252958,7027,'zh','æ¯å•ä½è´­ä¹°ä»·æ ¼\r\n',0),(252959,7027,'sv','Pris per inkÃ¶psenhet',0),(252960,7027,'it','Prezzo unitario di acquisto',0),(252961,7027,'tl','',0),(252962,7027,'th','&#3619;&#3634;&#3588;&#3634;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3595;&#3639;&#3657;&#3629;',0),(252963,7027,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤ªà¥à¤°à¤¤à¤¿ à¤–à¤°à¥€à¤¦ à¤‡à¤•à¤¾à¤ˆ',0),(252964,7027,'ms','Harga belian seunit',0),(252965,7027,'ar','Ø§Ù„Ø³Ø¹Ø± Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø© Ø§Ù„Ø´Ø±Ø§Ø¡',0),(252966,7027,'fr','Prix unitaire d\'achat',0),(252967,7027,'jp','è³¼è²·å˜ä½ã‚ãŸã‚Šã®ä¾¡æ ¼',0),(252968,7027,'pt','PreÃ§o unitÃ¡rio de compra',0),(252969,7027,'ru','Ð¦ÐµÐ½Ð° Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(252970,7027,'es','Precio por Unidad de Compra',0),(252971,7027,'de','Preis pro Bestelleinheit',0),(252972,7027,'en','Price per Purchase Unit',0),(252973,7028,'is','',0),(252974,7028,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯ ',0),(252975,7028,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯ ',0),(252976,7028,'tr','SatÄ±nalma birimleri',0),(252977,7028,'pl','Zakup jednostek',0),(252978,7028,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(252979,7028,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(252980,7028,'sr','Ð˜Ð·Ð»Ð°Ð·Ð½Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(252981,7028,'vi','ÄÆ¡n vá»‹ mua',0),(252982,7028,'af','Aankoop Eenhede',0),(252983,7028,'ro','CumpÄƒrarea de unitÄƒÅ£i',0),(252984,7028,'et','OstuÃ¼hikutes',0),(252985,7028,'si','Nakup enot',0),(252986,7028,'ba','Pembelian unit',0),(252987,7028,'nl','Aankoop Units',0),(252988,7028,'fi','OstoyksikkÃ¶inÃ¤ ilmaistu',0),(252989,7028,'no','InnkjÃ¸psenheter',0),(252990,7028,'da','KÃ¸bsenheder',0),(252991,7028,'ko','êµ¬ë§¤ ë‹¨ìœ„',0),(252992,7028,'he','×œ×¨×›×™×©×ª ×™×—×™×“×•×ª',0),(252993,7028,'el','ÎœÎ¿Î½Î¬Î´ÎµÏ‚ Î±Î³Î¿ÏÎ¬',0),(252994,7028,'zh','è´­ä¹°å•ä½\r\n',0),(252995,7028,'sv','InkÃ¶psenheter',0),(252996,7028,'it','UnitÃ  di acquisto',0),(252997,7028,'tl','',0),(252998,7028,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(252999,7028,'hi','à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤•à¥€ à¤–à¤°à¥€à¤¦',0),(253000,7028,'ms','Unit-unit',0),(253001,7028,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ø´Ø±Ø§Ø¡',0),(253002,7028,'fr','UnitÃ©s d\'achat',0),(253003,7028,'jp','è³¼è²·å˜ä½',0),(253004,7028,'pt','Unidades de compra',0),(253005,7028,'ru','ÐŸÑ€Ð¸Ð¾Ð±Ñ€ÐµÑ‚ÐµÐ½Ð¸Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†',0),(253006,7028,'es','Unidades de Compra',0),(253007,7028,'de','Bestelleinheiten',0),(253008,7028,'en','Purchase Units',0),(253009,7029,'is','',0),(253010,7029,'dr','- Ø«Ø¨Øª ÙˆØ¶Ø¹ÙŠØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(253011,7029,'pr','ÙØ§ÙƒØªÙˆØ±- Ø«Ø¨Øª ÙˆØ¶Ø¹ÙŠØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(253012,7029,'tr','Fatura satÄ±cÄ± yapÄ±landÄ±rma girin',0),(253013,7029,'pl','WprowadÅº faktury dostawcy konfiguracji',0),(253014,7029,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°-Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ñ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(253015,7029,'ur','ÙˆÛŒÙ†ÚˆØ± ØªØ±ØªÛŒØ¨ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(253016,7029,'sr','Ð£Ð½Ð¾Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ñ˜Ðµ',0),(253017,7029,'vi','Cáº¥u hÃ¬nh ngÆ°á»i bÃ¡n nháº­p hÃ³a Ä‘Æ¡n',0),(253018,7029,'af','Faktuur-tik handelaar konfigurasie',0),(253019,7029,'ro','IntroduceÈ›i factura furnizor de configurare',0),(253020,7029,'et','Hankija arve sisestada konfiguratsiooni',0),(253021,7029,'si','Vnesite raÄun dobavitelja konfiguracijo',0),(253022,7029,'ba','Faktur-masukkan Vendor konfigurasi',0),(253023,7029,'nl','Factuur-Voer leverancier configuratie',0),(253024,7029,'fi','Laskun syÃ¶ttÃ¤Ã¤ toimittajan konfiguraatio',0),(253025,7029,'no','Faktura-angi leverandÃ¸r konfigurasjon',0),(253026,7029,'da','Faktura-Indtast kreditor konfiguration',0),(253027,7029,'ko','ì†¡ìž¥ ìž…ë ¥ ê³µê¸‰ ì—…ì²´ êµ¬ì„±',0),(253028,7029,'he','×”×–×Ÿ ×—×©×‘×•× ×™×ª ×¡×¤×§ ×ª×¦×•×¨×”',0),(253029,7029,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿-Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï€Î±ÏÎ±Î¼Î­Ï„ÏÏ‰Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(253030,7029,'zh','å‘ç¥¨è¾“å…¥ä¾›åº”å•†é…ç½®\r\n',0),(253031,7029,'sv','Faktura-ange leverantÃ¶ren konfiguration',0),(253032,7029,'it','Fattura-immettere la configurazione del fornitore',0),(253033,7029,'tl','',0),(253034,7029,'th','&#3611;&#3657;&#3629;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3619;&#3641;&#3611;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(253035,7029,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤•à¥‰à¤¨à¥à¤«à¤¼à¤¿à¤—à¤°à¥‡à¤¶à¤¨',0),(253036,7029,'ms','Invois-isikan konfigurasi Penjual',0),(253037,7029,'ar','Ø¥Ø¯Ø®Ø§Ù„ ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„ØªÙƒÙˆÙŠÙ†',0),(253038,7029,'fr','-Entrer dans la facture du vendeur Configuration',0),(253039,7029,'jp','è«‹æ±‚æ›¸å…¥åŠ›ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã«ã‚ˆã‚‹æ§‹æˆ',0),(253040,7029,'pt','ConfiguraÃ§Ã£o de fornecedor fatura-entrar',0),(253041,7029,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÑ‡ÐµÑ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ð¸',0),(253042,7029,'es','Factura-Introducir ConfiguraciÃ³n de Proveedores',0),(253043,7029,'de','Rechnung eingeben Vendor Konfiguration',0),(253044,7029,'en','Invoice-Enter Vendor Configuration',0),(253045,7030,'is','',0),(253046,7030,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø®Ø±ÙŠØ¯ ',0),(253047,7030,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø®Ø±ÙŠØ¯ ',0),(253048,7030,'tr','SatÄ±n alma boyutu',0),(253049,7030,'pl','WielkoÅ›Ä‡ zakupu',0),(253050,7030,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(253051,7030,'ur','Ø³Ø§Ø¦Ø² Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(253052,7030,'sr','Ð˜Ð·Ð»Ð°Ð·Ð½Ðµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(253053,7030,'vi','Cá»¡ Mua',0),(253054,7030,'af','Aankoop Grootte',0),(253055,7030,'ro','Dimensiunea de cumpÄƒrare',0),(253056,7030,'et','Ostu suurus',0),(253057,7030,'si','Nakup velikost',0),(253058,7030,'ba','Membeli ukuran',0),(253059,7030,'nl','Aankoop grootte',0),(253060,7030,'fi','Ostaa kokoa',0),(253061,7030,'no','KjÃ¸p stÃ¸rrelse',0),(253062,7030,'da','KÃ¸b stÃ¸rrelse',0),(253063,7030,'ko','í¬ê¸°ë¥¼ êµ¬ìž…',0),(253064,7030,'he','×’×•×“×œ ×¨×›×™×©×”',0),(253065,7030,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Î±Î³Î¿ÏÎ¬Ï‚',0),(253066,7030,'zh','é‡‡è´­è§„æ¨¡\r\n',0),(253067,7030,'sv','KÃ¶pa storlek',0),(253068,7030,'it','Acquisto dimensione',0),(253069,7030,'tl','',0),(253070,7030,'th','&#3586;&#3609;&#3634;&#3604;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(253071,7030,'hi','à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤†à¤•à¤¾à¤°',0),(253072,7030,'ms','Saiz pembelian',0),(253073,7030,'ar','Ø­Ø¬Ù… Ø§Ù„Ø´Ø±Ø§Ø¡',0),(253074,7030,'fr','Achat taille',0),(253075,7030,'jp','ã‚µã‚¤ã‚ºã‚’è³¼å…¥',0),(253076,7030,'pt','Tamanho de compra',0),(253077,7030,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(253078,7030,'es','TamaÃ±o de Compra',0),(253079,7030,'de','Kaufen Gr',0),(253080,7030,'en','Purchase Size',0),(253081,7031,'is','',0),(253082,7031,'dr','Ø¨Ø®Ø´ÙŠ Ø§Ø² Ù…ØªÙ† Ø¯Ø± ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(253083,7031,'pr','Ø¨Ø®Ø´ÙŠ Ø§Ø² Ù…ØªÙ† Ø¯Ø± ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(253084,7031,'tr','KÄ±smi metin PO ayrÄ±ntÄ±lÄ± notlar',0),(253085,7031,'pl','CzÄ™Å›ciowe tekst PO szczegÃ³Å‚owe notatki',0),(253086,7031,'bg','Ð§Ð°ÑÑ‚ Ð¾Ñ‚ Ñ‚ÐµÐºÑÑ‚Ð° Ð² PO Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(253087,7031,'ur','Ù¾Ùˆ ØªÙØµÛŒÙ„ Ù†ÙˆÙ¹ Ù…ÛŒÚº Ø¬Ø²ÙˆÛŒ Ù…ØªÙ†',0),(253088,7031,'sr','Ð”ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð° Ñ‚ÐµÐºÑÑ‚ Ñƒ Ð±ÐµÐ»ÐµÑˆÐºÐ°Ð¼Ð° Ð´ÐµÑ‚Ð°Ñ™ ÐŸÐž',0),(253089,7031,'vi','Má»™t pháº§n ná»™i dung trong ghi chÃº chi tiáº¿t cá»§a Ä‘Æ¡n mua hÃ ng',0),(253090,7031,'af','Gedeeltelike Teks in AB Detail Notas',0),(253091,7031,'ro','Text parÅ£iale Ã®n notele de detaliu PO',0),(253092,7031,'et','Osalise tekstiotsingu PO Ã¼ksikasjalikud mÃ¤rkused',0),(253093,7031,'si','Delno besedilo PO podrobno opombe',0),(253094,7031,'ba','Sebagian teks dalam PO Detail catatan',0),(253095,7031,'nl','Gedeeltelijke tekst in PO Detail notities',0),(253096,7031,'fi','Tekstin osaa PO tiedot Notesissa',0),(253097,7031,'no','DELTEKST i PO detalj notater',0),(253098,7031,'da','Delvis tekst i PO detaljerede noter',0),(253099,7031,'ko','í¬ ìƒì„¸ ë©”ëª¨ ë¶€ë¶„ í…ìŠ¤íŠ¸',0),(253100,7031,'he','×—×œ×§×™ ×˜×§×¡×˜ ×‘×¤×ª×§×™× ×¤×™×¨×•×˜ ×¤×•',0),(253101,7031,'el','ÎœÎµÏÎ¹ÎºÎ® ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÎµ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ PO',0),(253102,7031,'zh','åœ¨é‡‡è´­å•ç»†èŠ‚éƒ¨åˆ†æ–‡å­—è¯´æ˜Ž\r\n',0),(253103,7031,'sv','Partiell Text i PO detalj anteckningar',0),(253104,7031,'it','Testo parziale nelle note di dettaglio PO',0),(253105,7031,'tl','',0),(253106,7031,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;&#3651;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3',0),(253107,7031,'hi','à¤†à¤‚à¤¶à¤¿à¤• à¤ªà¤¾à¤  à¤ªà¥‹ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤¨à¥‹à¤Ÿà¥à¤¸ à¤®à¥‡à¤‚',0),(253108,7031,'ms','Sebahagian teks dalam Nota-Nota terperinci PO',0),(253109,7031,'ar','Ø§Ù„Ù†Øµ Ø§Ù„Ø¬Ø²Ø¦ÙŠ ÙÙŠ Ø§Ù„Ù…Ø°ÙƒØ±Ø§Øª Øµ. Ø¨ Ø§Ù„ØªÙØµÙŠÙ„',0),(253110,7031,'fr','Texte partiel dans PO dÃ©tail Notes',0),(253111,7031,'jp','PO è©³ç´°ãƒŽãƒ¼ãƒˆã§éƒ¨åˆ†çš„ãªãƒ†ã‚­ã‚¹ãƒˆ',0),(253112,7031,'pt','Texto parcial em notas de detalhe de PO',0),(253113,7031,'ru','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾Ðµ Ñ‚ÐµÐºÑÑ‚ Ð² Ð·Ð°Ð¼ÐµÑ‚ÐºÐ°Ñ… Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ PO',0),(253114,7031,'es','Texto Parcial en Notas de Detalle de OC',0),(253115,7031,'de','Teilweise Text in den PO-Detail-Notizen',0),(253116,7031,'en','Partial Text in PO Detail Notes',0),(253117,7032,'is','',0),(253118,7032,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ ',0),(253119,7032,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ ',0),(253120,7032,'tr','SatÄ±ÅŸ sipariÅŸi numarasÄ±',0),(253121,7032,'pl','Numer zamÃ³wienia sprzedaÅ¼y',0),(253122,7032,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(253123,7032,'ur','Ø³ÛŒÙ„Ø² Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø±',0),(253124,7032,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑƒÐ»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(253125,7032,'vi','ÄÆ¡n hÃ ng kinh doanh sá»‘',0),(253126,7032,'af','Verkoopsbestellingnommer',0),(253127,7032,'ro','NumÄƒr comandÄƒ de vÃ¢nzÄƒri',0),(253128,7032,'et','MÃ¼Ã¼gitellimuse Number',0),(253129,7032,'si','Å tevilka prodajnega naroÄila',0),(253130,7032,'ba','Jumlah Order penjualan',0),(253131,7032,'nl','Verkoopordernummer',0),(253132,7032,'fi','Myyntitilauksen numero',0),(253133,7032,'no','Salgsordrenummeret',0),(253134,7032,'da','Salgsordrenummeret',0),(253135,7032,'ko','íŒë§¤ ì£¼ë¬¸ ë²ˆí˜¸',0),(253136,7032,'he','×ž×¡×¤×¨ ×”×–×ž× ×ª ×ž×›×™×¨×•×ª',0),(253137,7032,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(253138,7032,'zh','é”€å”®è®¢å•ç¼–å·\r\n',0),(253139,7032,'sv','FÃ¶rsÃ¤ljningsordernummer',0),(253140,7032,'it','Numero di ordine di vendita',0),(253141,7032,'tl','',0),(253142,7032,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(253143,7032,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(253144,7032,'ms','Nombor pesanan jualan',0),(253145,7032,'ar','Ø¹Ø¯Ø¯ Ø£ÙˆØ§Ù…Ø± Ø§Ù„ØªÙˆØ±ÙŠØ¯',0),(253146,7032,'fr','NumÃ©ro de commande client',0),(253147,7032,'jp','è²©å£²æ³¨æ–‡ç•ªå·',0),(253148,7032,'pt','NÃºmero de ordem de venda',0),(253149,7032,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ñƒ',0),(253150,7032,'es','NÃºmero de Orden de Ventas',0),(253151,7032,'de','Auftragsnummer',0),(253152,7032,'en','Sales Order Number',0),(253153,7033,'is','',0),(253154,7033,'dr',': Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù†Ø³ Ø¢Ø³ÙŠØ¨ Ø¯ÙŠØ¯Ù‡ Ø¨Ø§ÙŠØ¯ Ø¯Ø± Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(253155,7033,'pr','ØªÙˆØ¬Ù‡ ÙƒÙ†ÙŠØ¯ ÙƒÙ‡ : Ù…Ù‚Ø¯Ø§Ø± ÙƒØ§Ù„Ø§ÙŠ Ø¢Ø³ÙŠØ¨ Ø¯ÙŠØ¯Ù‡ Ø¨Ø§ÙŠØ¯ Ø¯Ø± Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(253156,7033,'tr','Miktar hasarlÄ± Not-meli var olmak dahil iÃ§inde miktar almak',0),(253157,7033,'pl','NaleÅ¼y zauwaÅ¼yÄ‡, Å¼e uszkodzony iloÅ›ci powinny byÄ‡ uwzglÄ™dnione w otrzymujÄ… iloÅ›Ä‡',0),(253158,7033,'bg','ÐžÐ±ÑŠÑ€Ð½ÐµÑ‚Ðµ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ, Ñ‡Ðµ Ð¿Ð¾Ð²Ñ€ÐµÐ´ÐµÐ½Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ»ÐµÐ´Ð²Ð° Ð´Ð° ÑÐµ Ð²ÐºÐ»ÑŽÑ‡Ð°Ñ‚ Ð² Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(253159,7033,'ur','Ù†ÙˆÙ¹ Ú©Ø±ÛŒÚº Ú©Û Ù…Ù‚Ø¯Ø§Ø± Ú©Ùˆ Ù†Ù‚ØµØ§Ù† Ù¾ÛÙ†Ú†Ø§ ÛÙˆÙ†Ø§ Ú†Ø§ÛØ¦Û’ Ø´Ø§Ù…Ù„ Ù…Ù‚Ø¯Ø§Ø± Ù…ÛŒÚº Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(253160,7033,'sr','Ð˜Ð¼Ð°Ñ˜Ñ‚Ðµ Ð½Ð° ÑƒÐ¼Ñƒ Ð´Ð° Ñ˜Ðµ Ð¾ÑˆÑ‚ÐµÑ›ÐµÐ½ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° ÑÐµ ÑƒÐºÑ™ÑƒÑ‡Ðµ Ñƒ Ð¿Ñ€Ð¸Ð¼Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(253161,7033,'vi','ChÃº Ã½: HÃ ng hÆ° há»ng sáº½ bao gá»“m trong tá»•ng sá»‘ hÃ ng nháº­n',0),(253162,7033,'af','Let Wel dat Beskadigde Hoeveelhede moet ingesluit word in Hoeveelheid Ontvang',0),(253163,7033,'ro','ReÅ£ineÅ£i cÄƒ deteriorate cantitatea ar trebui sÄƒ fie incluse Ã®n primi cantitatea',0),(253164,7033,'et','Pange tÃ¤hele, et kahjustatud kogus tuleks kaasata ka saada kogus',0),(253165,7033,'si','UpoÅ¡tevajte, da poÅ¡kodovane koliÄino je treba vkljuÄiti v prejeli koliÄina',0),(253166,7033,'ba','Catatan yang rusak kuantitas harus dimasukkan dalam menerima kuantitas',0),(253167,7033,'nl','Merk op dat beschadigd hoeveelheid moet worden opgenomen in ontvangen hoeveelheid',0),(253168,7033,'fi','Huomaa, ettÃ¤ vahingoittunut mÃ¤Ã¤rÃ¤ olisi sisÃ¤llytettÃ¤vÃ¤ itse vastaanottomÃ¤Ã¤rÃ¤',0),(253169,7033,'no','Merk at skadet antall skal inkluderes i motta antall',0),(253170,7033,'da','BemÃ¦rk, at beskadigede mÃ¦ngde bÃ¸r medtages i modtage mÃ¦ngde',0),(253171,7033,'ko','í¬í•¨ ë˜ì–´ì•¼ í•˜ëŠ” ìˆ˜ëŸ‰ì„ ì†ìƒì— ìˆ˜ëŸ‰ì„ ë°›ì„',0),(253172,7033,'he','×©×™×ž×• ×œ×‘: ×¤×’×•× ×›×ž×•×ª ×¦×¨×™×š ×œ×”×™×•×ª ×›×œ×•×œ ×‘ ×œ×§×‘×œ ×›×ž×•×ª',0),(253173,7033,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÏ„Îµ ÏŒÏ„Î¹ Î¸Î± ÎºÎ±Ï„Î±ÏƒÏ„ÏÎ±Ï†ÎµÎ¯ Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î¸Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î·Ï†Î¸Î¿ÏÎ½ ÏƒÏ„Î·Î½ Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(253174,7033,'zh','è¯·æ³¨æ„ï¼ŒæŸåçš„æ•°é‡åº”åŒ…æ‹¬åœ¨æŽ¥æ”¶æ•°é‡\r\n',0),(253175,7033,'sv','Observera att skadade kvantitet bÃ¶r inkluderas i inleveranskvantitet',0),(253176,7033,'it','Nota che ha danneggiato la quantitÃ  dovrebbe essere incluso in ricevere quantitÃ ',0),(253177,7033,'tl','',0),(253178,7033,'th','Note That Damaged Quantity Should Be Included in Receive Quantity',0),(253179,7033,'hi','à¤§à¥à¤¯à¤¾à¤¨ à¤¦à¥‡à¤‚ à¤•à¤¿ à¤•à¥à¤·à¤¤à¤¿à¤—à¥à¤°à¤¸à¥à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(253180,7033,'ms','Ambil perhatian bahawa kerosakan bahan hendaklah dimasukkan dalam menerima kuantiti',0),(253181,7033,'ar','Ø¹Ù„Ù…Ø§ Ø¨Ø£Ù† ØªÙ„Ù Ø§Ù„ÙƒÙ…ÙŠØ© ÙŠÙ†Ø¨ØºÙŠ Ø¥Ø¯Ø±Ø§Ø¬Ù‡Ø§ ÙÙŠ Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„ÙƒÙ…ÙŠØ©',0),(253182,7033,'fr','Remarque qui a endommagÃ© la quantitÃ© doit Ãªtre inclus en recevoir quantitÃ©',0),(253183,7033,'jp','æ•°é‡ã‚’ç ´æã—ã¦ã„ã‚‹ãƒ¡ãƒ¢ã‚’å«ã‚ã‚‹ã¹ãã§æ•°é‡ã‚’å—ä¿¡',0),(253184,7033,'pt','Observe que danificou a quantidade deve ser incluÃ­do em receber a quantidade',0),(253185,7033,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ, Ñ‡Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð²Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ñ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ Ð² Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(253186,7033,'es','Ojo Que Cantidad DaÃ±ada Debe Ser Incluido en la Cantidad Recibida',0),(253187,7033,'de','Hinweis, die Menge beschÃ¤digt die Plombennummer in Menge erhalten',0),(253188,7033,'en','Note That Damaged Quantity Should Be Included in Receive Quantity',0),(253189,7034,'is','',0),(253190,7034,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø¬Ù‡Øª ØªØ§ÙŠÙŠØ¯ ',0),(253191,7034,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø¬Ù‡Øª ØªØ§ÙŠÙŠØ¯ ',0),(253192,7034,'tr','AP iÃ§in pass',0),(253193,7034,'pl','PrzejÅ›Ä‡ do AP',0),(253194,7034,'bg','ÐŸÑ€ÐµÐ´Ð°Ð´Ðµ AP',0),(253195,7034,'ur','AP Ø³Û’ Ú¯Ø²Ø±Ù†Ø§',0),(253196,7034,'sr','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´Ð¸Ñ‚Ðµ ÐÐŸ',0),(253197,7034,'vi','Káº¿t chuyá»ƒn qua TK Pháº£i Tráº£',0),(253198,7034,'af','Oorgaan na RB',0),(253199,7034,'ro','Treci la AP',0),(253200,7034,'et','Liigu AP',0),(253201,7034,'si','Prenesti AP',0),(253202,7034,'ba','Lulus AP',0),(253203,7034,'nl','Doorgeven aan AP',0),(253204,7034,'fi','SiirrÃ¤ ostoreskontraan',0),(253205,7034,'no','GÃ¥ til AP',0),(253206,7034,'da','Pass til AP',0),(253207,7034,'ko','APì— ì „ë‹¬',0),(253208,7034,'he','×œ×”×¢×‘×™×¨ ×œ- AP',0),(253209,7034,'el','Î ÎµÏÎ¬ÏƒÎµÎ¹ Î±Ï€',0),(253210,7034,'zh','ä¼ é€’åˆ°é™„åŠ ä¿é™©è´¹\r\n',0),(253211,7034,'sv','Passera till AP',0),(253212,7034,'it','Passare all\'AP',0),(253213,7034,'tl','',0),(253214,7034,'th','&#3612;&#3656;&#3634;&#3609;&#3652;&#3611;&#3618;&#3633;&#3591;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(253215,7034,'hi','à¤à¤ªà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤°à¤¿à¤¤',0),(253216,7034,'ms','Pas ke AP',0),(253217,7034,'ar','ØªÙ…Ø±ÙŠØ± Ù„ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(253218,7034,'fr','Passez Ã  l\'AP',0),(253219,7034,'jp','AP ã«æ¸¡ã™',0),(253220,7034,'pt','Passar para AP',0),(253221,7034,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‚ÑŒ AP',0),(253222,7034,'es','Pasar a CP',0),(253223,7034,'de','Ãœbergeben an AP',0),(253224,7034,'en','Pass to AP',0),(253225,7035,'is','',0),(253226,7035,'dr','ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(253227,7035,'pr','ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(253228,7035,'tr','B2B',0),(253229,7035,'pl','B2B',0),(253230,7035,'bg','B2B',0),(253231,7035,'ur','B2B',0),(253232,7035,'sr','Ð‘2Ð‘',0),(253233,7035,'vi','B2B',0),(253234,7035,'af','B2B',0),(253235,7035,'ro','B2B',0),(253236,7035,'et','B2B',0),(253237,7035,'si','B2B',0),(253238,7035,'ba','B2B',0),(253239,7035,'nl','B2B',0),(253240,7035,'fi','B2B',0),(253241,7035,'no','B2B',0),(253242,7035,'da','B2B',0),(253243,7035,'ko','B2B',0),(253244,7035,'he','B2B',0),(253245,7035,'el','B2B',0),(253246,7035,'zh','å•†ä¸šå¯¹å•†ä¸šçš„\r\n',0),(253247,7035,'sv','B2B',0),(253248,7035,'it','B2B',0),(253249,7035,'tl','',0),(253250,7035,'th','B2B',0),(253251,7035,'hi','B2B',0),(253252,7035,'ms','B2B',0),(253253,7035,'ar','* Ø´Ø±ÙƒØ§Ø¡ Ø§Ù„ØªØ¹Ø§Ù…Ù„ *',0),(253254,7035,'fr','B2B',0),(253255,7035,'jp','B2B',0),(253256,7035,'pt','B2B',0),(253257,7035,'ru','B2B',0),(253258,7035,'es','N2N',0),(253259,7035,'de','B2B',0),(253260,7035,'en','B2B',0),(253261,7036,'is','',0),(253262,7036,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø·Ø¨Ù‚ Ú†Ù‡ Ø¯ÙˆØ±Ù‡ Ø§ÙŠ',0),(253263,7036,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø·Ø¨Ù‚ Ú†Ù‡ Ø¯ÙˆØ±Ù‡ Ø§ÙŠ',0),(253264,7036,'tr','Hangi dÃ¶nemi temel vergi hesaplama',0),(253265,7036,'pl','Obliczenia podatku w oparciu o jaki okres',0),(253266,7036,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸, Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð° ÐºÐ°ÐºÑŠÐ² Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(253267,7036,'ur','Ú©Ø³ Ø¯ÙˆØ± Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø± Ù¹ÛŒÚ©Ø³ Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(253268,7036,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ ÐŸÐµÑ€Ð¸Ð¾Ð´ Ñƒ',0),(253269,7036,'vi','TÃ­nh thuáº¿ dá»±a trÃªn thá»i ká»³ nÃ o',0),(253270,7036,'af','Bereken Belastings Gebasseer op Watter Periode',0),(253271,7036,'ro','Calcularea taxelor bazate pe ce perioadÄƒ',0),(253272,7036,'et','Arvuta maksud mis perioodi',0),(253273,7036,'si','IzraÄuna davke, kakÅ¡no obdobje na osnovi',0),(253274,7036,'ba','Menghitung pajak yang berdasar pada masa',0),(253275,7036,'nl','Belastingen op basis van welke periode berekenen',0),(253276,7036,'fi','Laske verot ajanjakso',0),(253277,7036,'no','Beregne avgifter basert pÃ¥ hvilken periode',0),(253278,7036,'da','Beregne skatter baseret pÃ¥ hvilken periode',0),(253279,7036,'ko','ì–´ë–¤ ê¸°ê°„ì— ë”°ë¼ ì„¸ê¸ˆì„ ê³„ì‚°',0),(253280,7036,'he','×œ×—×©×‘ ×ž×™×¡×™× ×‘×”×ª×× ×‘××™×–×” ×©×™×¢×•×¨',0),(253281,7036,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Ï„Ï‰Î½ Ï†ÏŒÏÏ‰Î½ Ï€Î¿Ï… Î²Î±ÏƒÎ¯Î¶ÎµÏ„Î±Î¹ ÏƒÎµ Ï€Î¿Î¹Î¿ Ï‡ÏÎ¿Î½Î¹ÎºÏŒ Î´Î¹Î¬ÏƒÏ„Î·Î¼Î±',0),(253282,7036,'zh','è®¡ç®—ä¾æ®åŸºäºŽä»€ä¹ˆæœŸé™\r\n',0),(253283,7036,'sv','BerÃ¤kna skatter utifrÃ¥n vilken Period',0),(253284,7036,'it','Calcolare le tasse basate su quale periodo',0),(253285,7036,'tl','',0),(253286,7036,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3616;&#3634;&#3625;&#3637;&#3610;&#3609;&#3614;&#3639;&#3657;&#3609;&#3600;&#3634;&#3609;&#3586;&#3629;&#3591;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3629;&#3632;&#3652;&#3619;',0),(253287,7036,'hi','à¤•à¥à¤¯à¤¾ à¤…à¤µà¤§à¤¿ à¤ªà¤° à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤•à¤°à¥‹à¤‚ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(253288,7036,'ms','Mengira cukai yang berdasarkan tempoh apa',0),(253289,7036,'ar','Ø§Ø­ØªØ³Ø§Ø¨ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ø³ØªÙ†Ø§Ø¯Ø§Ù‹ Ø¥Ù„Ù‰ Ø§Ù„ÙØªØ±Ø© Ù…Ø§',0),(253290,7036,'fr','Calculer impÃ´ts basÃ©s sur quelle pÃ©riode',0),(253291,7036,'jp','ã©ã®ã‚ˆã†ãªæœŸé–“ã«åŸºã¥ãç¨Žé‡‘ã‚’è¨ˆç®—ã—ã¾ã™ã€‚',0),(253292,7036,'pt','Calcular impostos, com base em qual perÃ­odo',0),(253293,7036,'ru','Ð Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð½Ð°Ð»Ð¾Ð³Ð¸, Ð¾ÑÐ½Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð½Ð° ÐºÐ°ÐºÐ¾Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(253294,7036,'es','Calcular Impuestos Basado en Cual PeriÃ³do',0),(253295,7036,'de','Berechnen Sie Steuern auf der Grundlage von welchem Zeitraum',0),(253296,7036,'en','Calculate Taxes Based on What Period',0),(253297,7037,'is','',0),(253298,7037,'dr','Ø¯Ø± Ú†Ù‡ Ø³Ø§Ù„ÙŠ Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡  Ù¾Ø±Ø¯Ø§Ø®Øª Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ØŸ',0),(253299,7037,'pr','Ø¯Ø± Ú†Ù‡ Ø³Ø§Ù„ÙŠ Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡  Ù¾Ø±Ø¯Ø§Ø®Øª Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ØŸ',0),(253300,7037,'tr','Hangi yÄ±l bu dÃ¶nemde Ã¶denecektir',0),(253301,7037,'pl','Co roku otrzyma ten okres',0),(253302,7037,'bg','ÐŸÑ€ÐµÐ· ÐºÐ¾Ñ Ð³Ð¾Ð´Ð¸Ð½Ð° Ñ‰Ðµ Ð±ÑŠÐ´Ð°Ñ‚ Ð¸Ð·Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ñ‚Ð¾Ð·Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(253303,7037,'ur','ÛŒÛ Ø¯ÙˆØ± Ú©Ø³ Ø³Ø§Ù„ Ù…ÛŒÚº Ø§Ø¯Ø§ Ú©ÛŒ Ø¬Ø§Ø¦Û’ Ú¯ÛŒ',0),(253304,7037,'sr','ÐšÐ¾Ñ˜Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ñ›Ðµ Ð¾Ð²Ð°Ñ˜ ÐŸÐµÑ€Ð¸Ð¾Ð´ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸',0),(253305,7037,'vi','Trong nÄƒm nÃ o ká»³ nÃ y sáº½ thanh toÃ¡n',0),(253306,7037,'af','In Watter Jaar Sal Hierdie Periode Betaal word',0),(253307,7037,'ro','In ce an va fi plÄƒtit aceastÄƒ perioadÄƒ',0),(253308,7037,'et','Mis aastal sellel perioodil makstakse',0),(253309,7037,'si','Leta bo to obdobje izplaÄa',0),(253310,7037,'ba','Apa tahun periode ini dibayar',0),(253311,7037,'nl','In welk jaar wordt deze periode uitbetaald',0),(253312,7037,'fi','MinÃ¤ vuonna tÃ¤nÃ¤ aikana maksetaan',0),(253313,7037,'no','I hvilket Ã¥r betales denne perioden',0),(253314,7037,'da','I hvilket Ã¥r vil denne periode udbetales',0),(253315,7037,'ko','ì–´ë–¤ ë…„ì´ì´ ê¸°ê°„ ì§€ë¶ˆ ë  ê²ƒ ì´ë‹¤',0),(253316,7037,'he','×‘××™×–×• ×©× ×” ×ª×©×•×œ× ×œ×ª×§×•×¤×” ×–×•',0),(253317,7037,'el','Î£Îµ Ï€Î¿Î¹Î¿ Î­Ï„Î¿Ï‚ Î¸Î± ÎºÎ±Ï„Î±Î²Î¬Î»ÎµÎ¹ Î±Ï…Ï„Î® Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(253318,7037,'zh','åœ¨å“ªä¸€å¹´æ”¯ä»˜æ­¤æœŸé™\r\n',0),(253319,7037,'sv','Vilket Ã¥r kommer denna Period betalas',0),(253320,7037,'it','In quale anno sarÃ  pagato questo periodo',0),(253321,7037,'tl','',0),(253322,7037,'th','&#3651;&#3609;&#3611;&#3637;&#3652;&#3627;&#3609;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3651;&#3609;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3609;&#3637;&#3657;',0),(253323,7037,'hi','à¤‡à¤¸ à¤…à¤µà¤§à¤¿ à¤®à¥‡à¤‚ à¤•à¤¿à¤¸ à¤µà¤°à¥à¤· à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾',0),(253324,7037,'ms','Tahun apa akan tempoh ini dibayar',0),(253325,7037,'ar','ÙÙŠ Ø§Ù„Ø³Ù†Ø© Ù…Ø§ Ø³ÙˆÙ ØªØ¯ÙØ¹ Ù‡Ø°Ù‡ Ø§Ù„ÙØªØ±Ø©',0),(253326,7037,'fr','En quelle annÃ©e sera versÃ©e cette pÃ©riode',0),(253327,7037,'jp','ä½•å¹´ã«ã“ã®æœŸé–“æ”¯æ‰•ã‚ã‚Œã‚‹',0),(253328,7037,'pt','Em que ano serÃ¡ pago neste perÃ­odo',0),(253329,7037,'ru','Ð’ ÐºÐ°ÐºÐ¾Ð¼ Ð³Ð¾Ð´Ñƒ Ð±ÑƒÐ´ÐµÑ‚ Ð²Ñ‹Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°Ñ‚ÑŒÑÑ ÑÑ‚Ð¾Ñ‚ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(253330,7037,'es','En que ejercicio se PagarÃ¡ este PerÃ­odod',0),(253331,7037,'de','In welchem Jahr wird dieser Zeitraum ausgezahlt',0),(253332,7037,'en','In What Year Will This Period Be Paid',0),(253333,7038,'is','',0),(253334,7038,'dr','Ø´Ø±ÙƒØª ',0),(253335,7038,'pr','Ø´Ø±ÙƒØª ',0),(253336,7038,'tr','CO',0),(253337,7038,'pl','CO',0),(253338,7038,'bg','CO',0),(253339,7038,'ur','Ø´Ø±ÛŒÚ©',0),(253340,7038,'sr','Ð¦Ðž',0),(253341,7038,'vi','CO',0),(253342,7038,'af','CO',0),(253343,7038,'ro','CO',0),(253344,7038,'et','CO',0),(253345,7038,'si','CO',0),(253346,7038,'ba','CO',0),(253347,7038,'nl','CO',0),(253348,7038,'fi','CO',0),(253349,7038,'no','CO',0),(253350,7038,'da','CO',0),(253351,7038,'ko','CO',0),(253352,7038,'he','CO',0),(253353,7038,'el','CO',0),(253354,7038,'zh','å…¬å¸\r\n',0),(253355,7038,'sv','CO',0),(253356,7038,'it','CO',0),(253357,7038,'tl','',0),(253358,7038,'th','CO',0),(253359,7038,'hi','à¤¸à¤¹',0),(253360,7038,'ms','CO',0),(253361,7038,'ar','Ø£ÙˆÙ„ Ø£ÙƒØ³ÙŠØ¯ Ø§Ù„ÙƒØ±Ø¨ÙˆÙ†',0),(253362,7038,'fr','CO',0),(253363,7038,'jp','CO',0),(253364,7038,'pt','CO',0),(253365,7038,'ru','CO',0),(253366,7038,'es','CO',0),(253367,7038,'de','CO',0),(253368,7038,'en','CO',0),(253369,7039,'is','',0),(253370,7039,'dr','ØªØºÙŠÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ',0),(253371,7039,'pr','ØªØºÙŠÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ',0),(253372,7039,'tr','GruplandÄ±rma deÄŸiÅŸtirmek',0),(253373,7039,'pl','Zmiana grupy',0),(253374,7039,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ð½Ðµ',0),(253375,7039,'ur','Ú¯Ø±ÙˆÙ¾ Ø¨Ù†Ø¯ÛŒ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(253376,7039,'sr','ÐœÐµÑšÐ°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ð¸ÑÐ°ÑšÐ°',0),(253377,7039,'vi','Thay Ä‘á»•i nhÃ³m',0),(253378,7039,'af','Verander Groepering',0),(253379,7039,'ro','Schimba gruparea',0),(253380,7039,'et','Muuda rÃ¼hmitamine',0),(253381,7039,'si','Spreminjanje, zdruÅ¾evanje',0),(253382,7039,'ba','Mengubah pengelompokan',0),(253383,7039,'nl','Groepering wijzigen',0),(253384,7039,'fi','Muuta ryhmittelymerkin',0),(253385,7039,'no','Endre gruppering',0),(253386,7039,'da','Ã†ndre gruppering',0),(253387,7039,'ko','ê·¸ë£¹í™” ë³€ê²½',0),(253388,7039,'he','×©×™× ×•×™ ×”×§×™×‘×•×¥',0),(253389,7039,'el','Î‘Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î·Î½ Î¿Î¼Î±Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(253390,7039,'zh','æ›´æ”¹åˆ†ç»„\r\n',0),(253391,7039,'sv','Ã„ndra gruppering',0),(253392,7039,'it','Modificare il raggruppamento',0),(253393,7039,'tl','',0),(253394,7039,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(253395,7039,'hi','à¤¸à¤®à¥‚à¤¹à¥€à¤•à¥ƒà¤¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(253396,7039,'ms','Tukar Kumpulan',0),(253397,7039,'ar','ØªØºÙŠÙŠØ± Ø§Ù„ØªØ¬Ù…ÙŠØ¹',0),(253398,7039,'fr','Modifier le regroupement',0),(253399,7039,'jp','ã‚°ãƒ«ãƒ¼ãƒ—åŒ–ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(253400,7039,'pt','Alterar o agrupamento',0),(253401,7039,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð³Ñ€ÑƒÐ¿Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(253402,7039,'es','Cambiar Grupamiento',0),(253403,7039,'de','Ã„ndern gruppieren',0),(253404,7039,'en','Change Grouping',0),(253405,7040,'is','',0),(253406,7040,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§ Ù…Ø§Ù‡ ',0),(253407,7040,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§ Ù…Ø§Ù‡ ',0),(253408,7040,'tr','Aya gÃ¶re grup',0),(253409,7040,'pl','Grupa przez miesiÄ…c',0),(253410,7040,'bg','Ð“Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾ Ð¼ÐµÑÐµÑ†Ð¸',0),(253411,7040,'ur','Ú¯Ø±ÙˆÙ¾ Ø¨Ù…Ø·Ø§Ø¨Ù‚ Ù…Ø§Û',0),(253412,7040,'sr','Ð“Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾ Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(253413,7040,'vi','NhÃ³m theo thÃ¡ng',0),(253414,7040,'af','Groepeer per Maand',0),(253415,7040,'ro','Grup de luna',0),(253416,7040,'et','Grupeeri kuu kaupa',0),(253417,7040,'si','ZdruÅ¾i po mesecu',0),(253418,7040,'ba','Kelompok oleh bulan',0),(253419,7040,'nl','Groep per maand',0),(253420,7040,'fi','Ryhmittely kuukausittain',0),(253421,7040,'no','Grupper etter mÃ¥ned',0),(253422,7040,'da','GruppÃ©r efter mÃ¥ned',0),(253423,7040,'ko','ì›”ë³„ë¡œ ê·¸ë£¹',0),(253424,7040,'he','×§×‘×¥ ×œ×¤×™ ×—×•×“×©',0),(253425,7040,'el','ÎŸÎ¼Î±Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· ÎºÎ±Ï„Î¬ Î¼Î®Î½Î±',0),(253426,7040,'zh','æŒ‰æœˆåˆ†ç»„\r\n',0),(253427,7040,'sv','Gruppera efter mÃ¥nad',0),(253428,7040,'it','Gruppo di mese',0),(253429,7040,'tl','',0),(253430,7040,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3616;&#3634;&#3618;&#3651;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(253431,7040,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤®à¥‚à¤¹',0),(253432,7040,'ms','Kumpulan mengikut bulan',0),(253433,7040,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø­Ø³Ø¨ Ø§Ù„Ø´Ù‡Ø±',0),(253434,7040,'fr','Groupe par mois',0),(253435,7040,'jp','æœˆåˆ¥ã®ã‚°ãƒ«ãƒ¼ãƒ—åŒ–',0),(253436,7040,'pt','Grupo por mÃªs',0),(253437,7040,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð¿Ð¾ Ð¼ÐµÑÑÑ†Ð°Ð¼',0),(253438,7040,'es','Grupo por Mes',0),(253439,7040,'de','Gruppieren nach Monat',0),(253440,7040,'en','Group by Month',0),(253441,7041,'is','',0),(253442,7041,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§ Ø³Ù‡ Ù…Ø§Ù‡ ',0),(253443,7041,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§ Ø³Ù‡ Ù…Ø§Ù‡ ',0),(253444,7041,'tr','ÃœÃ§ aylÄ±k dÃ¶nemlere gÃ¶re grup',0),(253445,7041,'pl','Grupa kwartaÅ‚u',0),(253446,7041,'bg','Ð“Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾ Ñ‚Ñ€Ð¸Ð¼ÐµÑÐµÑ‡Ð¸Ðµ',0),(253447,7041,'ur','Ú¯Ø±ÙˆÙ¾ Ø¨Ù…Ø·Ø§Ø¨Ù‚ Ø³Û Ù…Ø§ÛÛŒ',0),(253448,7041,'sr','Ð“Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾ ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ñƒ',0),(253449,7041,'vi','NhÃ³m theo QuÃ½',0),(253450,7041,'af','Groepeer per Kwartaal',0),(253451,7041,'ro','Grup de trimestru',0),(253452,7041,'et','Grupeeri kvartali kaupa',0),(253453,7041,'si','ZdruÅ¾i po Äetrtletju',0),(253454,7041,'ba','Kelompok kuartal',0),(253455,7041,'nl','Groep per kwartaal',0),(253456,7041,'fi','Ryhmittely neljÃ¤nnesvuosittain',0),(253457,7041,'no','Grupper etter kvartal',0),(253458,7041,'da','GruppÃ©r efter kvartal',0),(253459,7041,'ko','ë¶„ê¸°ë³„ë¡œ ê·¸ë£¹',0),(253460,7041,'he','×§×‘×•×¦×” ×œ×¤×™ ×¨×‘×¢×•×Ÿ',0),(253461,7041,'el','ÎŸÎ¼Î±Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· ÎºÎ±Ï„Î¬ Ï„ÏÎ¯Î¼Î·Î½Î¿',0),(253462,7041,'zh','æŒ‰å­£åˆ†ç»„\r\n',0),(253463,7041,'sv','Grupp av kvartalet',0),(253464,7041,'it','Gruppo di quarto',0),(253465,7041,'tl','',0),(253466,7041,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3616;&#3634;&#3618;&#3651;&#3609;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;',0),(253467,7041,'hi','à¤¤à¤¿à¤®à¤¾à¤¹à¥€ à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤° à¤¸à¤®à¥‚à¤¹à¥€à¤•à¥ƒà¤¤',0),(253468,7041,'ms','Kumpulan suku',0),(253469,7041,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø­Ø³Ø¨ Ø±Ø¨Ø¹ Ø§Ù„Ø³Ù†Ø©',0),(253470,7041,'fr','Groupe par trimestre',0),(253471,7041,'jp','å››åŠæœŸã”ã¨ã®ã‚°ãƒ«ãƒ¼ãƒ—',0),(253472,7041,'pt','Grupo por trimestre',0),(253473,7041,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð¿Ð¾ ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð°Ð¼',0),(253474,7041,'es','Grupo por Trimestre',0),(253475,7041,'de','Gruppe pro Quartal',0),(253476,7041,'en','Group by Quarter',0),(253477,7042,'is','',0),(253478,7042,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§ Ø³Ø§Ù„ ',0),(253479,7042,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø¨Ø§ Ø³Ø§Ù„ ',0),(253480,7042,'tr','YÄ±llara gÃ¶re grup',0),(253481,7042,'pl','Grupa przez rok',0),(253482,7042,'bg','Ð“Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾ Ð³Ð¾Ð´Ð¸Ð½Ð¸',0),(253483,7042,'ur','Ú¯Ø±ÙˆÙ¾ Ø¨Ù…Ø·Ø§Ø¨Ù‚ Ø³Ø§Ù„',0),(253484,7042,'sr','Ð“Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾ Ð³Ð¾Ð´Ð¸Ð½Ð¸',0),(253485,7042,'vi','NhÃ³m theo nÄƒm',0),(253486,7042,'af','Groepeer per Jaar',0),(253487,7042,'ro','Grup de an',0),(253488,7042,'et','Grupeeri aasta kaupa',0),(253489,7042,'si','ZdruÅ¾i po letu',0),(253490,7042,'ba','Kelompok tahun',0),(253491,7042,'nl','Groeperen op jaar',0),(253492,7042,'fi','Ryhmittely vuosittain',0),(253493,7042,'no','Grupper etter Ã¥r',0),(253494,7042,'da','Gruppe af Ã¥r',0),(253495,7042,'ko','ë…„ ê·¸ë£¹',0),(253496,7042,'he','×§×‘×¥ ×œ×¤×™ ×©× ×”',0),(253497,7042,'el','ÎŸÎ¼Î±Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· ÎºÎ±Ï„Î¬ Î­Ï„Î¿Ï‚',0),(253498,7042,'zh','æŒ‰å¹´åˆ†ç»„\r\n',0),(253499,7042,'sv','Grupp av Ã¥r',0),(253500,7042,'it','Gruppo di anno',0),(253501,7042,'tl','',0),(253502,7042,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3616;&#3634;&#3618;&#3651;&#3609;&#3611;&#3637;',0),(253503,7042,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤®à¥‚à¤¹',0),(253504,7042,'ms','Kumpulan mengikut tahun',0),(253505,7042,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø­Ø³Ø¨ Ø§Ù„Ø³Ù†Ø©',0),(253506,7042,'fr','Groupe par annÃ©e',0),(253507,7042,'jp','å¹´ã®ã‚°ãƒ«ãƒ¼ãƒ—',0),(253508,7042,'pt','Grupo por ano',0),(253509,7042,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð¿Ð¾ Ð³Ð¾Ð´Ð°Ð¼',0),(253510,7042,'es','Grupo por AÃ±o',0),(253511,7042,'de','Gruppieren nach Jahr',0),(253512,7042,'en','Group by Year',0),(253513,7043,'is','',0),(253514,7043,'dr','Ù†Ú¯Ù‡Ø¯Ø§Ø´ØªÙ† ÙƒÙ†ØªØ±Ù„ â€“ Ø´ÙŠÙØª',0),(253515,7043,'pr','Ù†Ú¯Ù‡Ø¯Ø§Ø´ØªÙ† ÙƒÙ†ØªØ±Ù„ â€“ Ø´ÙŠÙØª',0),(253516,7043,'tr','Control-Shift tutun',0),(253517,7043,'pl','Przytrzymaj Ctrl Shift',0),(253518,7043,'bg','Ð”Ñ€ÑŠÐ¶Ñ‚Ðµ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»-ÑÐ¼ÑÐ½Ð°',0),(253519,7043,'ur','Ú©Ù†Ù¹Ø±ÙˆÙ„-Shift Ø¯Ø¨Ø§ Ø±Ú©Ú¾ÛŒÚº',0),(253520,7043,'sr','Ð”Ñ€Ð¶Ð¸Ñ‚Ðµ Ð¦Ð¾Ð½Ñ‚Ñ€Ð¾Ð» Ð¸ Ð¡Ñ…Ð¸Ñ„Ñ‚',0),(253521,7043,'vi','Nháº¥n phÃ­m Control-Shift',0),(253522,7043,'af','Hou beheer-Shift',0),(253523,7043,'ro','Å¢ineÅ£i Control-Shift',0),(253524,7043,'et','Control-Shift hoiavad',0),(253525,7043,'si','DrÅ¾ite nadzor-premika',0),(253526,7043,'ba','Memegang kendali-Shift',0),(253527,7043,'nl','Houd Ctrl-Shift',0),(253528,7043,'fi','PidÃ¤ CTRL-VAIHTO',0),(253529,7043,'no','Hold nede Ctrl-Shift',0),(253530,7043,'da','Hold Ctrl-Skift',0),(253531,7043,'ko','Shift í‚¤ë¥¼ ì»¨íŠ¸ë¡¤',0),(253532,7043,'he','×”×—×–×§ ××ª ×ž×§×© Shift-×©×œ×™×˜×”',0),(253533,7043,'el','ÎšÏÎ±Ï„Î®ÏƒÏ„Îµ Ï„Î¿ Ï€Î»Î®ÎºÏ„ÏÎ¿ ÎµÎ»Î­Î³Ï‡Î¿Ï…-Shift',0),(253534,7043,'zh','æŒ‰ä½controlé”®å’Œshifté”®\r\n',0),(253535,7043,'sv','HÃ¥ll CTRL-SKIFT',0),(253536,7043,'it','Tenere premuto CTRL-MAIUSC',0),(253537,7043,'tl','',0),(253538,7043,'th','&#3588;&#3619;&#3629;&#3610;&#3588;&#3621;&#3640;&#3617;&#3585;&#3634;&#3619;&#3588;&#3623;&#3610;&#3588;&#3640;&#3617;&#3585;&#3634;&#3619;&#3612;&#3585;&#3612;&#3633;&#3609;',0),(253539,7043,'hi','à¤¨à¤¿à¤¯à¤‚à¤¤à¥à¤°à¤£-Shift à¤¦à¤¬à¤¾à¤ à¤°à¤–à¥‡à¤‚',0),(253540,7043,'ms','Mengadakan kawalan-Shift',0),(253541,7043,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø§Ù„Ù…ÙØªØ§Ø­ Shift Ø§Ù„ØªØ­ÙƒÙ…',0),(253542,7043,'fr','Maintenez Ctrl-Maj',0),(253543,7043,'jp','ã‚³ãƒ³ãƒˆãƒ­ãƒ¼ãƒ« shift ã‚­ãƒ¼ã‚’æŠ¼ã—',0),(253544,7043,'pt','Pressione Control-Shift',0),(253545,7043,'ru','Ð£Ð´ÐµÑ€Ð¶Ð¸Ð²Ð°Ñ Control-Shift',0),(253546,7043,'es','Oprimir Control-Tecla Shift',0),(253547,7043,'de','Halten Sie Control-Shift',0),(253548,7043,'en','Hold Control-Shift',0),(253549,7044,'is','',0),(253550,7044,'dr','(Ø§Ø®ØªØµØ§ØµÙŠ',0),(253551,7044,'pr','Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ±Ø¯ÙŠ (Ø§Ø®ØªØµØ§ØµÙŠ',0),(253552,7044,'tr','Bireysel Ã¶deme dÃ¶nemi',0),(253553,7044,'pl','Okresie rozliczeniowym poszczegÃ³lnych',0),(253554,7044,'bg','Ð˜Ð½Ð´Ð¸Ð²Ð¸Ð´ÑƒÐ°Ð»Ð½Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(253555,7044,'ur','Ø§Ù†ÙØ±Ø§Ø¯ÛŒ ØªÙ†Ø®ÙˆØ§Û Ø¯ÙˆØ±',0),(253556,7044,'sr','ÐŸÐ¾Ñ˜ÐµÐ´Ð¸Ð½Ð°Ñ‡Ð½Ðµ Ð¿Ð»Ð°Ñ‚Ðµ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(253557,7044,'vi','Ká»³ tráº£ lÆ°Æ¡ng cÃ¡ nhÃ¢n',0),(253558,7044,'af','Indiwiduele Besoldiging Periode',0),(253559,7044,'ro','PerioadÄƒ de platÄƒ individuale',0),(253560,7044,'et','Ãœksikute makseperioodi',0),(253561,7044,'si','Posamezna plaÄi',0),(253562,7044,'ba','Periode individu membayar',0),(253563,7044,'nl','Individuele betalen periode',0),(253564,7044,'fi','YksittÃ¤isten maksukauden',0),(253565,7044,'no','Individuelle lÃ¸nnsperioden',0),(253566,7044,'da','Enkelte lÃ¸nperiode',0),(253567,7044,'ko','ê°œë³„ ì§€ë¶ˆ ê¸°ê°„',0),(253568,7044,'he','×ª×§×•×¤×ª ×”×ª×©×œ×•× ×‘×•×“×“×™×',0),(253569,7044,'el','Î•Ï€Î¹Î¼Î­ÏÎ¿Ï…Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿Ï„Î¹ÎºÎ®Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(253570,7044,'zh','ä¸ªäººç¼´çº³æœŸé™\r\n',0),(253571,7044,'sv','Enskilda lÃ¶neperiod',0),(253572,7044,'it','Periodo di paga individuali',0),(253573,7044,'tl','',0),(253574,7044,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3626;&#3656;&#3623;&#3609;&#3610;&#3640;&#3588;&#3588;&#3621;',0),(253575,7044,'hi','à¤…à¤²à¤—-à¤…à¤²à¤— à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿',0),(253576,7044,'ms','Tempoh gaji',0),(253577,7044,'ar','ÙØªØ±Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„ÙØ±Ø¯ÙŠØ©',0),(253578,7044,'fr','PÃ©riode de paie individuelles',0),(253579,7044,'jp','å€‹åˆ¥æ”¯æ‰•æœŸé–“',0),(253580,7044,'pt','PerÃ­odo de pagamento individual',0),(253581,7044,'ru','Ð˜Ð½Ð´Ð¸Ð²Ð¸Ð´ÑƒÐ°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(253582,7044,'es','PerÃ­odo de Pago Individual',0),(253583,7044,'de','Einzelne Zahlungsperiode',0),(253584,7044,'en','Individual Pay Period',0),(253585,7045,'is','',0),(253586,7045,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ ',0),(253587,7045,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ ',0),(253588,7045,'tr','GruplandÄ±rma seÃ§in',0),(253589,7045,'pl','Wybierz opcje grupowanie',0),(253590,7045,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð³Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ð½Ðµ',0),(253591,7045,'ur','Ú¯Ø±ÙˆÙ¾ Ø¨Ù†Ø¯ÛŒ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(253592,7045,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð³Ñ€ÑƒÐ¿Ð¸ÑÐ°ÑšÐµ',0),(253593,7045,'vi','Chá»n nhÃ³m',0),(253594,7045,'af','Selekteer Groepering',0),(253595,7045,'ro','SelectaÅ£i grupare',0),(253596,7045,'et','Valige rÃ¼hmituse',0),(253597,7045,'si','Izberite zdruÅ¾evanje',0),(253598,7045,'ba','Pilih pengelompokan',0),(253599,7045,'nl','Selecteer groeperen',0),(253600,7045,'fi','Valitse ryhmittely',0),(253601,7045,'no','Velg gruppering',0),(253602,7045,'da','VÃ¦lg gruppering',0),(253603,7045,'ko','ê·¸ë£¹í™” ì„ íƒ',0),(253604,7045,'he','×‘×—×¨ ×§×™×‘×•×¥',0),(253605,7045,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¿Î¼Î±Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(253606,7045,'zh','é€‰æ‹©åˆ†ç»„\r\n',0),(253607,7045,'sv','VÃ¤lja gruppering',0),(253608,7045,'it','Selezionare raggruppamento',0),(253609,7045,'tl','',0),(253610,7045,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(253611,7045,'hi','à¤¸à¤®à¥‚à¤¹à¥€à¤•à¤°à¤£ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(253612,7045,'ms','Pilih Kumpulan',0),(253613,7045,'ar','Ø­Ø¯Ø¯ Ø§Ù„ØªØ¬Ù…Ø¹',0),(253614,7045,'fr','SÃ©lectionnez groupement',0),(253615,7045,'jp','ã‚°ãƒ«ãƒ¼ãƒ—åŒ–ã‚’é¸æŠžã—ã¾ã™',0),(253616,7045,'pt','Selecione o agrupamento',0),(253617,7045,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð“Ñ€ÑƒÐ¿Ð¿Ð¸Ñ€Ð¾Ð²ÐºÐ°',0),(253618,7045,'es','Seleccionar Agrupamiento',0),(253619,7045,'de','WÃ¤hlen Sie Gruppierung',0),(253620,7045,'en','Select Grouping',0),(253621,7046,'is','',0),(253622,7046,'dr','(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ) ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(253623,7046,'pr','Ù…ØµØ§Ø±Ù(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ) ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(253624,7046,'tr','Ã–deme tarihi kullanÄ±r',0),(253625,7046,'pl','Data zastosowania wypÅ‚acane',0),(253626,7046,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð´Ð°Ñ‚Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(253627,7046,'ur','ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ø§Ø¯Ø§ Ú©ÛŒ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªØ§ ÛÛ’',0),(253628,7046,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ñ›ÐµÐ½Ð°',0),(253629,7046,'vi','Tráº£ ngÃ y sá»­ dá»¥ng',0),(253630,7046,'af','Gebruik Datum Betaal',0),(253631,7046,'ro','UtilizeazÄƒ data de plÄƒtit',0),(253632,7046,'et','Kasutab maksmise kuupÃ¤eva',0),(253633,7046,'si','Uporabi datum, plaÄa',0),(253634,7046,'ba','Menggunakan tanggal dibayar',0),(253635,7046,'nl','Gebruik datum betaald',0),(253636,7046,'fi','KÃ¤yttÃ¤Ã¤ maksupÃ¤ivÃ¤',0),(253637,7046,'no','Bruker datoen betalt',0),(253638,7046,'da','Bruger dato betales',0),(253639,7046,'ko','ì§€ë¶ˆ ë‚ ì§œë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(253640,7046,'he','×ž×©×ª×ž×© ×‘×ª××¨×™×š ×©×™×œ×',0),(253641,7046,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹',0),(253642,7046,'zh','ç”¨æ”¯ä»˜æ—¥æœŸ\r\n',0),(253643,7046,'sv','AnvÃ¤nder datum betalt',0),(253644,7046,'it','Utilizza Data pagato',0),(253645,7046,'tl','',0),(253646,7046,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(253647,7046,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(253648,7046,'ms','Menggunakan tarikh dibayar',0),(253649,7046,'ar','ÙŠØ³ØªØ®Ø¯Ù… ØªØ§Ø±ÙŠØ® Ø¯ÙØ¹',0),(253650,7046,'fr','Utilise la Date payÃ©e',0),(253651,7046,'jp','æ”¯æ‰•ã‚ã‚Œã‚‹æ—¥ä»˜ã‚’ä½¿ç”¨ã—ã¾ã™',0),(253652,7046,'pt','Usa a data de pagamento',0),(253653,7046,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑ Ð”Ð°Ñ‚Ñƒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(253654,7046,'es','Usos Fecha Pagado',0),(253655,7046,'de','Datum bezahlt verwendet',0),(253656,7046,'en','Uses Date Paid',0),(253657,7047,'is','',0),(253658,7047,'dr','(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ) ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ ',0),(253659,7047,'pr','Ù…ØµØ§Ø±Ù(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ) ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ ',0),(253660,7047,'tr','DÃ¶nem tarihi kullanÄ±r',0),(253661,7047,'pl','UÅ¼ywa okresu daty zakoÅ„czenia',0),(253662,7047,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° ÐºÑ€Ð°Ñ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð´Ð°Ñ‚Ð°',0),(253663,7047,'ur','Ù…Ø¯Øª ØªØ§Ø±ÛŒØ® Ú©Û’ Ø§Ø®ØªØªØ§Ù… Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªØ§ ÛÛ’',0),(253664,7047,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(253665,7047,'vi','DÃ¹ng ngÃ y cuá»‘i cá»§a ká»³',0),(253666,7047,'af','Gebruik Einde van Periode Datum',0),(253667,7047,'ro','Foloseste sfÃ¢rÅŸitul perioada data',0),(253668,7047,'et','Kasutab perioodi lÃµppkuupÃ¤ev',0),(253669,7047,'si','Uporablja konÄni datum obdobja',0),(253670,7047,'ba','Menggunakan akhir periode tanggal',0),(253671,7047,'nl','Einde van periode datum gebruikt',0),(253672,7047,'fi','KÃ¤yttÃ¤Ã¤ loppuun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(253673,7047,'no','Bruker slutten av perioden dato',0),(253674,7047,'da','Bruger slutningen af perioden dato',0),(253675,7047,'ko','ê¸°ê°„ ë‚ ì§œì˜ ëì„ ì‚¬ìš© í•˜ ì—¬',0),(253676,7047,'he','×©×™×ž×•×©×™× ×ª××¨×™×š ×¡×™×•× ×©×œ ×ª×§×•×¤×ª',0),(253677,7047,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯ Ï€ÎµÏÎ¯Î¿Î´Î¿ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(253678,7047,'zh','ç”¨æœŸæœ«æ—¥æœŸ\r\n',0),(253679,7047,'sv','AnvÃ¤nder slut datum fÃ¶r Period',0),(253680,7047,'it','Utilizza la fine del periodo data',0),(253681,7047,'tl','',0),(253682,7047,'th','&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(253683,7047,'hi','à¤…à¤‚à¤¤ à¤…à¤µà¤§à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(253684,7047,'ms','Kegunaan akhir tarikh tempoh',0),(253685,7047,'ar','ÙŠØ³ØªØ®Ø¯Ù… ÙÙŠ Ù†Ù‡Ø§ÙŠØ© ÙØªØ±Ø© Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(253686,7047,'fr','Utilisations Date de fin de pÃ©riode',0),(253687,7047,'jp','æœŸé–“ã®çµ‚ã‚ã‚Šã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(253688,7047,'pt','Usa o fim do perÃ­odo data',0),(253689,7047,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ ÐºÐ¾Ð½ÐµÑ† Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð´Ð°Ñ‚Ñ‹',0),(253690,7047,'es','Usos Fecha de Fin del PerÃ­odo',0),(253691,7047,'de','Ende Datum',0),(253692,7047,'en','Uses End of Period Date',0),(253693,7048,'is','',0),(253694,7048,'dr','Ø­Ù‚ÙˆÙ‚ Ø®Ø§Ù„Øµ Ù…Ù†ÙÙŠ Ø§Ø³Øª ',0),(253695,7048,'pr','Ø­Ù‚ÙˆÙ‚ Ø®Ø§Ù„Øµ Ù…Ù†ÙÙŠ Ø§Ø³Øª ',0),(253696,7048,'tr','Negatif net payÄ±n',0),(253697,7048,'pl','Wynagrodzenie netto jest ujemna',0),(253698,7048,'bg','ÐÐµÑ‚Ð½Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ðµ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»Ð½Ð°',0),(253699,7048,'ur','Ø®Ø§Ù„Øµ ØªÙ†Ø®ÙˆØ§Û Ù…Ù†ÙÛŒ ÛÛ’ Û”',0),(253700,7048,'sr','ÐÐµÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ð° Ñ˜Ðµ Ð½ÐµÐ³Ð°Ñ‚Ð¸Ð²Ð½Ð¾',0),(253701,7048,'vi','LÆ°Æ¡ng thuáº§n lÃ  Ã¢m',0),(253702,7048,'af','Net Besoldiging is Negatief',0),(253703,7048,'ro','Plata netÄƒ este negativ',0),(253704,7048,'et','Netopalk on negatiivne',0),(253705,7048,'si','Neto plaÄa je negativno',0),(253706,7048,'ba','Membayar bersih adalah negatif',0),(253707,7048,'nl','Nettoloon is negatief',0),(253708,7048,'fi','Nettopalkka on negatiivinen',0),(253709,7048,'no','NettolÃ¸nn er negativ',0),(253710,7048,'da','NettolÃ¸n er negativ',0),(253711,7048,'ko','ì¸í„°ë„· ì§€ë¶ˆì´ ë¶€ì •',0),(253712,7048,'he','×”×©×›×¨ × ×˜×• ×”×•× ×©×œ×™×œ×™',0),(253713,7048,'el','ÎšÎ±Î¸Î±ÏÎ­Ï‚ Î±Ï€Î¿Î´Î¿Ï‡Î­Ï‚ ÎµÎ¯Î½Î±Î¹ Î±ÏÎ½Î·Ï„Î¹ÎºÏŒ',0),(253714,7048,'zh','å‡€å·¥èµ„æ˜¯è´Ÿ\r\n',0),(253715,7048,'sv','NettolÃ¶n Ã¤r negativ',0),(253716,7048,'it','Paga netta Ã¨ negativo',0),(253717,7048,'tl','',0),(253718,7048,'th','&#3592;&#3656;&#3634;&#3618;&#3626;&#3640;&#3607;&#3608;&#3636;&#3611;&#3599;&#3636;&#3648;&#3626;&#3608;',0),(253719,7048,'hi','à¤¨à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤¨à¤¿à¤µà¤² à¤µà¥‡à¤¤à¤¨ à¤¹à¥ˆ',0),(253720,7048,'ms','Gaji bersih adalah negatif',0),(253721,7048,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„ØµØ§ÙÙŠ Ù‡Ùˆ Ø³Ù„Ø¨ÙŠ',0),(253722,7048,'fr','Le salaire net est nÃ©gatif',0),(253723,7048,'jp','ç´”æ”¯æ‰•ã„ã¯è² ',0),(253724,7048,'pt','SalÃ¡rio lÃ­quido Ã© negativo',0),(253725,7048,'ru','Ð§Ð¸ÑÑ‚Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼',0),(253726,7048,'es','Pago Neto es Negativo',0),(253727,7048,'de','Nettolohn ist negativ',0),(253728,7048,'en','Net Pay is Negative',0),(253729,7049,'is','',0),(253730,7049,'dr','ØªÙ„ÙÙ† Ø¢Ø¯Ø±Ø³ ',0),(253731,7049,'pr','ØªÙ„ÙÙ† Ø¢Ø¯Ø±Ø³ ',0),(253732,7049,'tr','Adres / telefon',0),(253733,7049,'pl','Adres / telefon',0),(253734,7049,'bg','ÐÐ´Ñ€ÐµÑ / Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(253735,7049,'ur','Ù¾ØªØ§ Ø¬Ø§Øª / ÙÙˆÙ†',0),(253736,7049,'sr','ÐÐ´Ñ€ÐµÑÐ° / Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(253737,7049,'vi','Äiá»‡n thoáº¡i',0),(253738,7049,'af','Adreslyn Telefoon',0),(253739,7049,'ro','Telefon acasa',0),(253740,7049,'et','Aadress / telefon',0),(253741,7049,'si','Naslov / telefon',0),(253742,7049,'ba','Telepon',0),(253743,7049,'nl','Adres / telefoon',0),(253744,7049,'fi','Osoite / Puhelin',0),(253745,7049,'no','Adresse / telefon',0),(253746,7049,'da','Adresse / telefon',0),(253747,7049,'ko','ì£¼ì†Œ / ì „í™”',0),(253748,7049,'he','×˜×œ×¤×•×Ÿ ×‘×›×ª×•×‘×ª',0),(253749,7049,'el','Î”Î™Î•Î¥Î˜Î¥ÎÎ£Î— / Î¤Î—Î›Î•Î¦Î©ÎÎŸ',0),(253750,7049,'zh','åœ°å€ç”µè¯\r\n',0),(253751,7049,'sv','Adress / telefon',0),(253752,7049,'it','Indirizzo / telefono',0),(253753,7049,'tl','',0),(253754,7049,'th','&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(253755,7049,'hi','à¤ªà¤¤à¤¾ / à¤«à¥‹à¤¨',0),(253756,7049,'ms','Alamat / telefon',0),(253757,7049,'ar','Ù…Ø¹Ø§Ù„Ø¬Ø©/Ø§Ù„Ù‡Ø§ØªÙ',0),(253758,7049,'fr','Adresse TÃ©lÃ©phone',0),(253759,7049,'jp','ä½æ‰€ ï¼ é›»è©±ç•ªå·',0),(253760,7049,'pt','EndereÃ§o / telefone',0),(253761,7049,'ru','ÐÐ´Ñ€ÐµÑ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(253762,7049,'es','TelÃ©fono DirecciÃ³n',0),(253763,7049,'de','Adresse / Telefon',0),(253764,7049,'en','Address / Phone',0),(253765,7050,'is','',0),(253766,7050,'dr','Ù…Ø¯Øª Ø§Ø³ØªØ®Ø¯Ø§Ù…  ',0),(253767,7050,'pr','Ù…Ø¯Øª Ø§Ø³ØªØ®Ø¯Ø§Ù…  ',0),(253768,7050,'tr','EMP uzunluÄŸu',0),(253769,7050,'pl','DÅ‚ugoÅ›Ä‡ EMP',0),(253770,7050,'bg','Ð•Ð¼Ð¸ Ð´ÑŠÐ»Ð¶Ð¸Ð½Ð°',0),(253771,7050,'ur','Ù¾ Ú©ÛŒ Ù„Ù…Ø¨Ø§Ø¦ÛŒ',0),(253772,7050,'sr','Ð”ÑƒÐ¶Ð¸Ð½Ð° Ð•ÐœÐŸ',0),(253773,7050,'vi','Chiá»u dÃ i EMP',0),(253774,7050,'af','Werkn. Duur',0),(253775,7050,'ro','EMP lungime',0),(253776,7050,'et','EMP pikkus',0),(253777,7050,'si','DolÅ¾ina EMP',0),(253778,7050,'ba','Panjang EMP',0),(253779,7050,'nl','EMP lengte',0),(253780,7050,'fi','EMP pituus',0),(253781,7050,'no','EMP lengde',0),(253782,7050,'da','EMP lÃ¦ngde',0),(253783,7050,'ko','Emp ê¸¸ì´',0),(253784,7050,'he','××•×¨×š ×”×©×“×” ×”××œ×§×˜×¨×•×ž×’× ×˜×™',0),(253785,7050,'el','EMP Î¼Î®ÎºÎ¿Ï‚',0),(253786,7050,'zh','ç”µç£è„‰å†²é•¿åº¦\r\n',0),(253787,7050,'sv','EMP lÃ¤ngd',0),(253788,7050,'it','Lunghezza EMP',0),(253789,7050,'tl','',0),(253790,7050,'th','&#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623; Emp ',0),(253791,7050,'hi','Emp à¤²à¤‚à¤¬à¤¾à¤ˆ',0),(253792,7050,'ms','Panjang EMP',0),(253793,7050,'ar','Ù…Ø¯Ù‘Ø© Ø§Ù„ØªÙˆØ¸ÙŠÙ',0),(253794,7050,'fr','Longueur de l\'EMP',0),(253795,7050,'jp','Emp ã®é•·ã•',0),(253796,7050,'pt','Comprimento de EMP',0),(253797,7050,'ru','Ð”Ð»Ð¸Ð½Ð° EMP',0),(253798,7050,'es','Emp Largo',0),(253799,7050,'de','EMP-LÃ¤nge',0),(253800,7050,'en','Emp Length',0),(253801,7051,'is','',0),(253802,7051,'dr','ØªØ§Ø±ÙŠØ® Ø§Ø¬Ø§Ø±Ù‡ ',0),(253803,7051,'pr','ØªØ§Ø±ÙŠØ® Ø§Ø¬Ø§Ø±Ù‡ ',0),(253804,7051,'tr','Ä°ÅŸe alma tarihi',0),(253805,7051,'pl','Data zatrudnienia',0),(253806,7051,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾ÑÑ‚ÑŠÐ¿Ð²Ð°Ð½Ðµ',0),(253807,7051,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø®Ø¯Ù…Ø§Øª Ø­Ø§ØµÙ„',0),(253808,7051,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð¿Ð¾ÑˆÑ™Ð°Ð²Ð°ÑšÐ°',0),(253809,7051,'vi','NgÃ y thuÃª',0),(253810,7051,'af','Aanstellingsdatum',0),(253811,7051,'ro','Data de Ã®nchiriere',0),(253812,7051,'et','Palkamise kuupÃ¤ev',0),(253813,7051,'si','Datum zaposlitve',0),(253814,7051,'ba','Penyewaan tanggal',0),(253815,7051,'nl','Datum indiensttreding',0),(253816,7051,'fi','TyÃ¶suhteen alkamispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(253817,7051,'no','Ansettelsesdato',0),(253818,7051,'da','AnsÃ¦ttelsesdato',0),(253819,7051,'ko','ìž…ì‚¬ ë‚ ì§œ',0),(253820,7051,'he','×ª××¨×™×š ×”×¢×¡×§×”',0),(253821,7051,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€ÏÏŒÏƒÎ»Î·ÏˆÎ·Ï‚',0),(253822,7051,'zh','è˜ç”¨æ—¥æœŸ\r\n',0),(253823,7051,'sv','AnstÃ¤llningsdatum',0),(253824,7051,'it','Data di assunzione',0),(253825,7051,'tl','',0),(253826,7051,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3657;&#3634;&#3591; ',0),(253827,7051,'hi','à¤²à¥‡à¤¨à¥‡ à¤•à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(253828,7051,'ms','Tarikh sewa',0),(253829,7051,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙˆØ¸ÙŠÙ',0),(253830,7051,'fr','Date d\'embauche',0),(253831,7051,'jp','å…¥ç¤¾æ—¥',0),(253832,7051,'pt','Data de contrataÃ§Ã£o',0),(253833,7051,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ñ€Ð¸ÐµÐ¼Ð° Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(253834,7051,'es','Fecha de Emplear',0),(253835,7051,'de','Einstellungsdatum',0),(253836,7051,'en','Hire Date',0),(253837,7052,'is','',0),(253838,7052,'dr','Ø­Ù‚ÙˆÙ‚ Ø·Ø¨Ù‚ Ù…Ø§Ù‡ ',0),(253839,7052,'pr','Ø­Ù‚ÙˆÙ‚ Ø·Ø¨Ù‚ Ù…Ø§Ù‡ ',0),(253840,7052,'tr','AylÄ±k Ã¶de',0),(253841,7052,'pl','ZapÅ‚aciÄ‡ za miesiÄ…c',0),(253842,7052,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ð¿Ð¾ Ð¼ÐµÑÐµÑ†Ð¸',0),(253843,7052,'ur','Ù…ÛÛŒÙ†Û’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø¯Ø§ Ú©Ø±ØªÛ’',0),(253844,7052,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð¿Ð¾ Ð¼ÐµÑÐµÑ†Ð¸Ð¼Ð°',0),(253845,7052,'vi','Tráº£ theo thÃ¡ng ',0),(253846,7052,'af','Besoldiging Per Maand',0),(253847,7052,'ro','Plata lunara',0),(253848,7052,'et','Maksta kuu kaupa',0),(253849,7052,'si','PlaÄati po mesecih',0),(253850,7052,'ba','Membayar dengan bulan',0),(253851,7052,'nl','Betalen per maand',0),(253852,7052,'fi','Maksa kuukausittain',0),(253853,7052,'no','Betale per mÃ¥ned',0),(253854,7052,'da','Betale pr. mÃ¥ned',0),(253855,7052,'ko','ì›”ë³„ ì§€ë¶ˆ',0),(253856,7052,'he','×ª×©×œ×•× ×œ×¤×™ ×—×•×“×©',0),(253857,7052,'el','Î Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Î±Î½Î¬ Î¼Î®Î½Î±',0),(253858,7052,'zh','æœˆä»˜\r\n',0),(253859,7052,'sv','Betala per mÃ¥nad',0),(253860,7052,'it','Pagare di mese',0),(253861,7052,'tl','',0),(253862,7052,'th','&#3592;&#3656;&#3634;&#3618;&#3619;&#3634;&#3618;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(253863,7052,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(253864,7052,'ms','Membayar mengikut bulan',0),(253865,7052,'ar','Ø§Ù„Ø¯ÙØ¹ Ø¨Ø§Ù„Ø´Ù‡Ø±',0),(253866,7052,'fr','Payer par mois',0),(253867,7052,'jp','1 ãƒ¶æœˆã§æ”¯æ‰•ã„',0),(253868,7052,'pt','Pagar por mÃªs',0),(253869,7052,'ru','ÐœÐµÑÑÑ‡Ð½Ð°Ñ ÐŸÐ»Ð°Ñ‚Ð°',0),(253870,7052,'es','Pagar por Mes',0),(253871,7052,'de','Per Monat bezahlen',0),(253872,7052,'en','Pay By Month',0),(253873,7053,'is','',0),(253874,7053,'dr','Ø­Ù‚ÙˆÙ‚ Ø·Ø¨Ù‚ Ø³Ù‡ Ù…Ø§Ù‡ ',0),(253875,7053,'pr','Ø­Ù‚ÙˆÙ‚ Ø·Ø¨Ù‚ Ø³Ù‡ Ù…Ø§Ù‡ ',0),(253876,7053,'tr','ÃœÃ§ aylÄ±k dÃ¶nemlere gÃ¶re Ã¶deme',0),(253877,7053,'pl','PÅ‚aÄ‡ za kwartaÅ‚',0),(253878,7053,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ð¿Ð¾ Ñ‚Ñ€Ð¸Ð¼ÐµÑÐµÑ‡Ð¸Ñ',0),(253879,7053,'ur','Ø§Ø² Ø³Û Ù…Ø§ÛÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(253880,7053,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð¿Ð¾ ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð¸Ð¼Ð°',0),(253881,7053,'vi','Tráº£ theo quÃ½',0),(253882,7053,'af','Besoldiging Per Kwartaal',0),(253883,7053,'ro','Plata trimestriala',0),(253884,7053,'et','Kvartali alusel maksta',0),(253885,7053,'si','PlaÄati Äetrtino',0),(253886,7053,'ba','Membayar dengan Quarter',0),(253887,7053,'nl','Betalen per kwartaal',0),(253888,7053,'fi','Maksu vuosineljÃ¤nneksittÃ¤in',0),(253889,7053,'no','Betale etter kvartal',0),(253890,7053,'da','Betale efter kvartal',0),(253891,7053,'ko','ë¶„ê¸°ë³„ ì§€ë¶ˆ',0),(253892,7053,'he','×ª×©×œ×•× ×œ×¤×™ ×¨×‘×¢×•×Ÿ',0),(253893,7053,'el','Î Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Î±Î½Î¬ Ï„ÏÎ¯Î¼Î·Î½Î¿',0),(253894,7053,'zh','å­£ä»˜\r\n',0),(253895,7053,'sv','Betala per kvartal',0),(253896,7053,'it','Pagare di quarto',0),(253897,7053,'tl','',0),(253898,7053,'th','&#3592;&#3656;&#3634;&#3618;&#3619;&#3634;&#3618;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;',0),(253899,7053,'hi','à¤¤à¤¿à¤®à¤¾à¤¹à¥€ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(253900,7053,'ms','Membayar dengan suku',0),(253901,7053,'ar','Ø¯ÙØ¹ Ø¨Ø§Ù„Ø±Ø¨Ø¹',0),(253902,7053,'fr','Payer par trimestre',0),(253903,7053,'jp','å››åŠæœŸã”ã¨ã®æ”¯æ‰•ã„',0),(253904,7053,'pt','Pagar por trimestre',0),(253905,7053,'ru','ÐŸÐ¾ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»ÑŒÐ½Ñ‹Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸',0),(253906,7053,'es','Pagar por Trimestre',0),(253907,7053,'de','Per Quartal bezahlen',0),(253908,7053,'en','Pay By Quarter',0),(253909,7054,'is','',0),(253910,7054,'dr','Ø­Ù‚ÙˆÙ‚ Ø·Ø¨Ù‚ Ù‡ÙØªÙ‡ ',0),(253911,7054,'pr','Ø­Ù‚ÙˆÙ‚ Ø·Ø¨Ù‚ Ù‡ÙØªÙ‡ ',0),(253912,7054,'tr','Haftaya gÃ¶re Ã¶deme',0),(253913,7054,'pl','ZapÅ‚aty przez tydzieÅ„',0),(253914,7054,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ð¿Ð¾ ÑÐµÐ´Ð¼Ð¸Ñ†Ð¸',0),(253915,7054,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ÛÙØªÛ’ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(253916,7054,'sr','ÐŸÐ»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð´Ð¾ ÐºÑ€Ð°Ñ˜Ð° Ð½ÐµÐ´ÐµÑ™Ðµ',0),(253917,7054,'vi','Tráº£ theo tuáº§n',0),(253918,7054,'af','Besoldiging Per Week',0),(253919,7054,'ro','Plata saptaminala',0),(253920,7054,'et','Tasuma nÃ¤dala jÃ¤rgi',0),(253921,7054,'si','PlaÄati po tednu',0),(253922,7054,'ba','Membayar dengan minggu',0),(253923,7054,'nl','Betalen per Week',0),(253924,7054,'fi','Maksaa viikolta',0),(253925,7054,'no','Betale etter uke',0),(253926,7054,'da','Betale ved uge',0),(253927,7054,'ko','ì£¼ ì—¬',0),(253928,7054,'he','×ª×©×œ×•× ×œ×¤×™ ×©×‘×•×¢',0),(253929,7054,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Î±Ï€ÏŒ ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(253930,7054,'zh','æŒ‰å‘¨æ”¯ä»˜\r\n',0),(253931,7054,'sv','Betala av veckan',0),(253932,7054,'it','Pagare di settimana',0),(253933,7054,'tl','',0),(253934,7054,'th','&#3592;&#3656;&#3634;&#3618;&#3619;&#3634;&#3618;&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(253935,7054,'hi','à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(253936,7054,'ms','Bayar mengikut minggu',0),(253937,7054,'ar','Ø§Ù„Ø¯ÙØ¹ Ø¨ÙˆØ§Ø³Ø·Ø© Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹',0),(253938,7054,'fr','Payer par semaine',0),(253939,7054,'jp','1 é€±é–“ã§æ”¯æ‰•ã„',0),(253940,7054,'pt','Pagar por semana',0),(253941,7054,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð—Ð° ÐÐµÐ´ÐµÐ»ÑŽ',0),(253942,7054,'es','Pagar por Semana',0),(253943,7054,'de','Bezahlen per Woche',0),(253944,7054,'en','Pay By Week',0),(253945,7055,'is','',0),(253946,7055,'dr','Ø§ÙˆÙ„ÙˆÙŠØª ',0),(253947,7055,'pr','Ø§ÙˆÙ„ÙˆÙŠØª ',0),(253948,7055,'tr','KÄ±dem',0),(253949,7055,'pl','StaÅ¼',0),(253950,7055,'bg','Ð¡Ñ‚Ð°Ñ€ÑˆÐ¸Ð½ÑÑ‚Ð²Ð¾',0),(253951,7055,'ur','Ù¾ÛÙ„ÛŒ ØªÙˆ Ø³ÛŒÙ†ÛŒØ§Ø±Ù¹ÛŒ',0),(253952,7055,'sr','Ð¡Ñ‚Ð°Ð¶Ð°',0),(253953,7055,'vi','ThÃ¢m niÃªn',0),(253954,7055,'af','Senioriteit',0),(253955,7055,'ro','Vechimea',0),(253956,7055,'et','StaaÅ¾',0),(253957,7055,'si','Delovna doba',0),(253958,7055,'ba','Senioritas',0),(253959,7055,'nl','AnciÃ«nniteit',0),(253960,7055,'fi','Virka',0),(253961,7055,'no','Ansiennitet',0),(253962,7055,'da','Anciennitet',0),(253963,7055,'ko','ì—° ê³µ',0),(253964,7055,'he','×•×ª×§',0),(253965,7055,'el','Î‘ÏÏ‡Î±Î¹ÏŒÏ„Î·Ï„Î±',0),(253966,7055,'zh','å·¥é¾„\r\n',0),(253967,7055,'sv','FÃ¶retrÃ¤de',0),(253968,7055,'it','AnzianitÃ ',0),(253969,7055,'tl','',0),(253970,7055,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3629;&#3634;&#3623;&#3640;&#3650;&#3626;',0),(253971,7055,'hi','à¤µà¤°à¤¿à¤·à¥à¤ à¤¤à¤¾',0),(253972,7055,'ms','Kekananan',0),(253973,7055,'ar','Ø§Ù„Ø£Ù‚Ø¯Ù…ÙŠØ©',0),(253974,7055,'fr','AnciennetÃ©',0),(253975,7055,'jp','å¹´åŠŸåºåˆ—',0),(253976,7055,'pt','Antiguidade',0),(253977,7055,'ru','Ð¡Ñ‚Ð°Ð¶ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(253978,7055,'es','AntigÃ¼edad',0),(253979,7055,'de','Dienstalter',0),(253980,7055,'en','Seniority',0),(253981,7056,'is','',0),(253982,7056,'dr','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø±ÙŠÙ† ØªØºÙŠÙŠØ± ',0),(253983,7056,'pr','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø±ÙŠÙ† ØªØºÙŠÙŠØ± ',0),(253984,7056,'tr','Son deÄŸiÅŸiklik tarihi',0),(253985,7056,'pl','Data ostatniej zmiany',0),(253986,7056,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(253987,7056,'ur','Ø¢Ø®Ø±ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(253988,7056,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð¸Ð·Ð¼ÐµÐ½Ðµ',0),(253989,7056,'vi','Thay Ä‘á»•i ngÃ y cuá»‘i',0),(253990,7056,'af','Datum Laas Verander',0),(253991,7056,'ro','Modificat ultima data',0),(253992,7056,'et','Viimase muutmise kuupÃ¤ev',0),(253993,7056,'si','Datum zadnje spremembe',0),(253994,7056,'ba','Tanggal terakhir diubah',0),(253995,7056,'nl','Datum laatst gewijzigd',0),(253996,7056,'fi','Haut',0),(253997,7056,'no','Dato Sist endret',0),(253998,7056,'da','Dato, sidst Ã¦ndret',0),(253999,7056,'ko','ë§ˆì§€ë§‰ìœ¼ë¡œ ë³€ê²½í•œ ë‚ ì§œ',0),(254000,7056,'he','×”×ª××¨×™×š ×”×©×ª× ×” ×œ××—×¨×•× ×”',0),(254001,7056,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î±Î»Î»Î±Î³Î®',0),(254002,7056,'zh','æœ€åŽä¿®æ”¹çš„æ—¥æœŸ\r\n',0),(254003,7056,'sv','Datum senast Ã¤ndrades',0),(254004,7056,'it','Data ultima modificata',0),(254005,7056,'tl','',0),(254006,7056,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3588;&#3619;&#3633;&#3657;&#3591;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(254007,7056,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤…à¤‚à¤¤à¤¿à¤® à¤¬à¤¾à¤° à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤',0),(254008,7056,'ms','Tarikh Terakhir diubah',0),(254009,7056,'ar','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø± ØªØºÙŠÙŠØ±',0),(254010,7056,'fr','Date de derniÃ¨re modifiÃ©',0),(254011,7056,'jp','å‰å›žå¤‰æ›´ã•ã‚ŒãŸæ—¥ä»˜',0),(254012,7056,'pt','Data de Ãºltima modifica',0),(254013,7056,'ru','Ð”Ð°Ñ‚Ð° ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(254014,7056,'es','Fecha de Ultimo Cambio',0),(254015,7056,'de','Datum letzte Ã„nderung',0),(254016,7056,'en','Date Last Changed',0),(254017,7057,'is','',0),(254018,7057,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ú†Ùƒ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(254019,7057,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ú†Ùƒ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(254020,7057,'tr','Ã‡alÄ±ÅŸan onay DÃ¼zenle',0),(254021,7057,'pl','Edycja wyboru pracownika',0),(254022,7057,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(254023,7057,'ur','Ù…Ù„Ø§Ø²Ù… Ú†ÛŒÚ© Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(254024,7057,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(254025,7057,'vi','Sá»­a SÃ©c NhÃ¢n ViÃªn',0),(254026,7057,'af','Redigeer Werknemer Loonrol',0),(254027,7057,'ro','Editare angajat Check',0),(254028,7057,'et','Redigeeri tÃ¶Ã¶taja vÃ¤ljaregistreerimine',0),(254029,7057,'si','Urejanje preverjanje zaposlenih',0),(254030,7057,'ba','Mengedit karyawan Check',0),(254031,7057,'nl','Werknemer controle bewerken',0),(254032,7057,'fi','Muokkaa tyÃ¶ntekijÃ¤n uloskirjautuminen',0),(254033,7057,'no','Redigere ansatt av',0),(254034,7057,'da','Redigere medarbejder Check',0),(254035,7057,'ko','ì§ì› í‘œ íŽ¸ì§‘',0),(254036,7057,'he','×¢×¨×™×›×ª ×‘×“×™×§×ª ×”×¢×•×‘×“',0),(254037,7057,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(254038,7057,'zh','å‘˜å·¥æ£€æŸ¥ç¼–è¾‘\r\n',0),(254039,7057,'sv','Redigera anstÃ¤lld kontrollera',0),(254040,7057,'it','Modifica controllo dipendente',0),(254041,7057,'tl','',0),(254042,7057,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3648;&#3594;&#3655;&#3588;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(254043,7057,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤šà¥‡à¤• à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(254044,7057,'ms','Edit Daftar pekerja',0),(254045,7057,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù…ÙˆØ¸Ù',0),(254046,7057,'fr','Ã‰diter le chÃ¨que employÃ©',0),(254047,7057,'jp','å¾“æ¥­å“¡ãƒã‚§ãƒƒã‚¯ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(254048,7057,'pt','Editar verificaÃ§Ã£o de empregado',0),(254049,7057,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(254050,7057,'es','Cheque de Empleado Editar',0),(254051,7057,'de','Bearbeiten Mitarbeiter Check',0),(254052,7057,'en','Edit Employee Check',0),(254053,7058,'is','',0),(254054,7058,'dr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø¨Ù‡ ',0),(254055,7058,'pr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø¨Ù‡ ',0),(254056,7058,'tr','GÃ¶nderilen',0),(254057,7058,'pl','WysÅ‚ana do',0),(254058,7058,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð´Ð¾',0),(254059,7058,'ur','Ø¨Ú¾ÛŒØ¬Ø§ Ú¯ÛŒØ§ Ø¨Ø®Ø¯Ù…Øª',0),(254060,7058,'sr','Ð”Ð° Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(254061,7058,'vi','Gá»­i tá»›i',0),(254062,7058,'af','Gestuur Na',0),(254063,7058,'ro','Trimis la',0),(254064,7058,'et','Saadetud',0),(254065,7058,'si','Poslati',0),(254066,7058,'ba','Dikirim ke',0),(254067,7058,'nl','Verzonden naar',0),(254068,7058,'fi','LÃ¤hetetÃ¤Ã¤n',0),(254069,7058,'no','Sendt til',0),(254070,7058,'da','Sendt til',0),(254071,7058,'ko','ì „ì†¡',0),(254072,7058,'he','× ×©×œ×— ××œ',0),(254073,7058,'el','ÎˆÏƒÏ„ÎµÎ¹Î»Îµ Î½Î±',0),(254074,7058,'zh','å‘é€åˆ°\r\n',0),(254075,7058,'sv','Skickas till',0),(254076,7058,'it','Inviato a',0),(254077,7058,'tl','',0),(254078,7058,'th','&#3626;&#3656;&#3591;&#3652;&#3611;&#3618;&#3633;&#3591;',0),(254079,7058,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œà¤¾',0),(254080,7058,'ms','Dihantar kepada',0),(254081,7058,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¥Ù„Ù‰',0),(254082,7058,'fr','EnvoyÃ© Ã ',0),(254083,7058,'jp','ã‚’é€ä¿¡',0),(254084,7058,'pt','Enviado para',0),(254085,7058,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾ Ð²',0),(254086,7058,'es','Enviado A',0),(254087,7058,'de','Geschickt, um',0),(254088,7058,'en','Sent To',0),(254089,7059,'is','',0),(254090,7059,'dr','W2',0),(254091,7059,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  W2\r\n ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(254092,7059,'tr','W-2 gÃ¶rmek iÃ§in tÄ±klayÄ±n',0),(254093,7059,'pl','Kliknij, aby wyÅ›wietliÄ‡ W-2',0),(254094,7059,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ W-2',0),(254095,7059,'ur','W-2 Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(254096,7059,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ W-2',0),(254097,7059,'vi','Nháº¥n Ä‘á»ƒ xem W2',0),(254098,7059,'af','Klik om te bekyk W-2',0),(254099,7059,'ro','Click pentru a vizualiza W-2',0),(254100,7059,'et','Click to View W-2',0),(254101,7059,'si','Kliknite za ogled W-2',0),(254102,7059,'ba','Klik untuk melihat W-2',0),(254103,7059,'nl','Klik om te bekijken van W-2',0),(254104,7059,'fi','Klikkaa nÃ¤hdÃ¤ksesi W-2',0),(254105,7059,'no','Klikk for Ã¥ vise W-2',0),(254106,7059,'da','Klik her for at se W-2',0),(254107,7059,'ko','W-2ë¥¼ í´ë¦­',0),(254108,7059,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’ ××ª W-2',0),(254109,7059,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î¿ W-2',0),(254110,7059,'zh','ç‚¹å‡»æŸ¥çœ‹W2\r\n',0),(254111,7059,'sv','Klicka fÃ¶r att Visa W-2',0),(254112,7059,'it','Mostra W2',0),(254113,7059,'tl','',0),(254114,7059,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641; W2',0),(254115,7059,'hi','W-2 à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(254116,7059,'ms','Klik untuk melihat W-2',0),(254117,7059,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ø¹Ø±Ø¶ Ø«-2',0),(254118,7059,'fr','Cliquez pour voir le W-2',0),(254119,7059,'jp','W 2 ã‚’è¡¨ç¤ºã™ã‚‹] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(254120,7059,'pt','Clique para ver os W-2',0),(254121,7059,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° W-2',0),(254122,7059,'es','Click para Ver W2',0),(254123,7059,'de','Klicken Sie W-2 an',0),(254124,7059,'en','Click to View W-2',0),(254125,7060,'is','',0),(254126,7060,'dr','Ú†Ø§Ù¾\r\n W2',0),(254127,7060,'pr','Ú†Ø§Ù¾\r\n W2',0),(254128,7060,'tr','YazdÄ±rma W-2',0),(254129,7060,'pl','Drukowanie W-2',0),(254130,7060,'bg','ÐŸÐµÑ‡Ð°Ñ‚ W-2',0),(254131,7060,'ur','W-2 Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº',0),(254132,7060,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ W-2',0),(254133,7060,'vi','In W2',0),(254134,7060,'af','Druk W2',0),(254135,7060,'ro','Imprimare W-2',0),(254136,7060,'et','Prindi W-2',0),(254137,7060,'si','Tiskanje W-2',0),(254138,7060,'ba','Mencetak W-2',0),(254139,7060,'nl','Afdrukken van W-2',0),(254140,7060,'fi','Tulostaa W-2',0),(254141,7060,'no','Skrive W-2',0),(254142,7060,'da','Udskrive W-2',0),(254143,7060,'ko','W-2ë¥¼ ì¸ì‡„',0),(254144,7060,'he','×”×“×¤×¡ W-2',0),(254145,7060,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ W-2',0),(254146,7060,'zh','æ‰“å°W2\r\n',0),(254147,7060,'sv','Skriva ut W-2',0),(254148,7060,'it','Stampa W-2',0),(254149,7060,'tl','',0),(254150,7060,'th','&#3614;&#3636;&#3617;&#3614;&#3660; W2',0),(254151,7060,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤¡à¤¬à¥à¤²à¥à¤¯à¥‚-2',0),(254152,7060,'ms','W-2 cetakan',0),(254153,7060,'ar','Ø«-2 Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(254154,7060,'fr','Imprimer les W-2',0),(254155,7060,'jp','W 2 ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(254156,7060,'pt','Imprimir o W-2',0),(254157,7060,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ W2',0),(254158,7060,'es','Imptimir W2',0),(254159,7060,'de','Drucken Sie W-2',0),(254160,7060,'en','Print W-2',0),(254161,7061,'is','',0),(254162,7061,'dr','Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨Ø¹Ø¯ Ø§Ø² ',0),(254163,7061,'pr','Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨Ø¹Ø¯ Ø§Ø² ',0),(254164,7061,'tr','Sonra girilen',0),(254165,7061,'pl','WeszÅ‚a po',0),(254166,7061,'bg','Ð¡Ð»ÐµÐ´',0),(254167,7061,'ur','Ø¨Ø¹Ø¯ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(254168,7061,'sr','Ð£Ð½ÐµÑ‚Ð° Ð½Ð°ÐºÐ¾Ð½',0),(254169,7061,'vi','ÄÃ£ nháº­p sau',0),(254170,7061,'af','Ingetik het na',0),(254171,7061,'ro','Introdus dupÄƒ',0),(254172,7061,'et','PÃ¤rast',0),(254173,7061,'si','Vstopil po',0),(254174,7061,'ba','Masuk setelah',0),(254175,7061,'nl','Ingevoerd na',0),(254176,7061,'fi','JÃ¤lkeen',0),(254177,7061,'no','Etter',0),(254178,7061,'da','Indtastet efter',0),(254179,7061,'ko','ìž…ë ¥ í•œ í›„',0),(254180,7061,'he','× ×›× ×¡ ×œ××—×¨',0),(254181,7061,'el','ÎœÎµÏ„Î¬',0),(254182,7061,'zh','åŽè¿›å…¥',0),(254183,7061,'sv','Efter',0),(254184,7061,'it','Entrate dopo',0),(254185,7061,'tl','',0),(254186,7061,'th','&#3627;&#3621;&#3633;&#3591;&#3606;&#3641;&#3585;&#3611;&#3657;&#3629;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(254187,7061,'hi','à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(254188,7061,'ms','Dimasukkan selepas',0),(254189,7061,'ar','Ø¯Ø®Ù„Øª Ø¨Ø¹Ø¯',0),(254190,7061,'fr','EntrÃ© aprÃ¨s',0),(254191,7061,'jp','å¾Œã«å…¥åŠ›',0),(254192,7061,'pt','Entrou depois',0),(254193,7061,'ru','Ð’Ð²ÐµÐ´ÐµÐ½Ð¾ ÐŸÐ¾ÑÐ»Ðµ',0),(254194,7061,'es','Entrado DespuÃ©s de',0),(254195,7061,'de','Nach eingegebenen',0),(254196,7061,'en','Entered After',0),(254197,7062,'is','',0),(254198,7062,'dr','Ø¢ÙŠØ§ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(254199,7062,'pr','Ø¢ÙŠØ§ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(254200,7062,'tr','MÃ¼ÅŸteri',0),(254201,7062,'pl','Klient',0),(254202,7062,'bg','Ð• ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(254203,7062,'ur','Ú¯Ø§ÛÚ© ÛÛ’',0),(254204,7062,'sr','ÐˆÐµ ÐºÑƒÐ¿Ð°Ñ†',0),(254205,7062,'vi','lÃ  khÃ¡ch hÃ ng',0),(254206,7062,'af','Is Klant/KliÃ«nt',0),(254207,7062,'ro','Este client',0),(254208,7062,'et','On kliendi',0),(254209,7062,'si','Je kupec',0),(254210,7062,'ba','Nasabah',0),(254211,7062,'nl','Klant',0),(254212,7062,'fi','On asiakas',0),(254213,7062,'no','Kunde',0),(254214,7062,'da','Er kunden',0),(254215,7062,'ko','ê³ ê°ì€',0),(254216,7062,'he','×”×•× ×œ×§×•×—',0),(254217,7062,'el','Î•Î¯Î½Î±Î¹ Ï€ÎµÎ»Î¬Ï„Î·Ï‚',0),(254218,7062,'zh','æ˜¯å®¢æˆ·\r\n',0),(254219,7062,'sv','Ã„r kund',0),(254220,7062,'it','Ãˆ il cliente',0),(254221,7062,'tl','',0),(254222,7062,'th','&#3648;&#3611;&#3655;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(254223,7062,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¹à¥ˆ',0),(254224,7062,'ms','Adalah pelanggan',0),(254225,7062,'ar','Ù‡Ùˆ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(254226,7062,'fr','Est client',0),(254227,7062,'jp','é¡§å®¢ã¯',0),(254228,7062,'pt','Ã‰ cliente',0),(254229,7062,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚',0),(254230,7062,'es','Es Cliente',0),(254231,7062,'de','Kunde ist',0),(254232,7062,'en','Is Customer',0),(254233,7063,'is','',0),(254234,7063,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¬Ø¯ÙŠØ¯',0),(254235,7063,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¬Ø¯ÙŠØ¯',0),(254236,7063,'tr','Son mÃ¼ÅŸteriler',0),(254237,7063,'pl','Ostatnich klientÃ³w',0),(254238,7063,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(254239,7063,'ur','Ø­Ø§Ù„ÛŒÛ ØµØ§Ø±ÙÛŒÙ†',0),(254240,7063,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¸ ÐºÑƒÐ¿Ñ†Ð¸',0),(254241,7063,'vi','KhÃ¡ch hÃ ng gáº§n Ä‘Ã¢y ',0),(254242,7063,'af','Onlangse Klante/KliÃ«nte ',0),(254243,7063,'ro','ClienÅ£ii recente',0),(254244,7063,'et','Tehtud kÃ¼lastajad',0),(254245,7063,'si','Zadnjih stranke',0),(254246,7063,'ba','Terbaru pelanggan',0),(254247,7063,'nl','Recente klanten',0),(254248,7063,'fi','Viime asiakkaat',0),(254249,7063,'no','Siste kundene',0),(254250,7063,'da','Seneste kunder',0),(254251,7063,'ko','ìµœê·¼ ê³ ê°',0),(254252,7063,'he','×”×œ×§×•×—×•×ª ×”××—×¨×•× ×•×ª',0),(254253,7063,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(254254,7063,'zh','æ–°é¡¾å®¢\r\n',0),(254255,7063,'sv','Senaste kunder',0),(254256,7063,'it','Clienti recenti',0),(254257,7063,'tl','',0),(254258,7063,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(254259,7063,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(254260,7063,'ms','Hari pelanggan',0),(254261,7063,'ar','Ø§Ù„Ø²Ø¨Ø§Ø¦Ù† Ø§Ù„Ø£Ø­Ø¯Ø«',0),(254262,7063,'fr','Visiteurs rÃ©cents',0),(254263,7063,'jp','æœ€è¿‘ã®é¡§å®¢',0),(254264,7063,'pt','Clientes recentes',0),(254265,7063,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¸Ðµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹',0),(254266,7063,'es','Clientes Recientes',0),(254267,7063,'de','Aktuelle Kunden',0),(254268,7063,'en','Recent Customers',0),(254269,7064,'is','',0),(254270,7064,'dr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨Ø¹Ø¯ Ø§Ø² ',0),(254271,7064,'pr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨Ø¹Ø¯ Ø§Ø² ',0),(254272,7064,'tr','Sonra girilen mÃ¼ÅŸterilere gÃ¶stermek',0),(254273,7064,'pl','PokaÅ¼ klientÃ³w wprowadzone po',0),(254274,7064,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ ÑÐ»ÐµÐ´',0),(254275,7064,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø¨Ø¹Ø¯ Ø¯Ø§Ø®Ù„ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(254276,7064,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐºÑƒÐ¿Ñ†Ðµ ÑƒÐ½ÐµÑ‚Ð° Ð½Ð°ÐºÐ¾Ð½',0),(254277,7064,'vi','Hiá»ƒn thá»‹ khÃ¡ch hÃ ng Ä‘Ã£ nháº­p sau ',0),(254278,7064,'af','Wys Klante/KliÃ«nte Ingevoer Na',0),(254279,7064,'ro','AratÄƒ clienÅ£ii a intrat dupÄƒ',0),(254280,7064,'et','Nita kliente, kes on lisatud peale',0),(254281,7064,'si','PrikaÅ¾i stranke zaÄele po',0),(254282,7064,'ba','Menunjukkan pelanggan masuk setelah',0),(254283,7064,'nl','Klanten ingevoerd na laten zien',0),(254284,7064,'fi','Osoittaa asiakkaille jÃ¤lkeen',0),(254285,7064,'no','Vise kunder etter',0),(254286,7064,'da','Vise kunderne ind efter',0),(254287,7064,'ko','ê³ ê° ìž…ë ¥ í•œ í›„ í‘œì‹œ',0),(254288,7064,'he','×œ×”×¨××•×ª ×œ×œ×§×•×—×•×ª × ×›× ×¡ ×œ××—×¨',0),(254289,7064,'el','Î”ÎµÎ¯Î¾ÎµÎ¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î¼ÎµÏ„Î¬',0),(254290,7064,'zh','å®¢æˆ·å±•ç¤ºåŽè¿›å…¥\r\n',0),(254291,7064,'sv','Visa kunder efter',0),(254292,7064,'it','Visualizza clienti entrati dopo',0),(254293,7064,'tl','',0),(254294,7064,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3627;&#3621;&#3633;&#3591;',0),(254295,7064,'hi','à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤œà¥‹ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(254296,7064,'ms','Menunjukkan pelanggan yang dimasukkan selepas',0),(254297,7064,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¯Ø®Ù„Øª Ø¨Ø¹Ø¯',0),(254298,7064,'fr','Montrer aux clients sont entrÃ©s aprÃ¨s',0),(254299,7064,'jp','ã‚·ãƒ§ãƒ¼ã®å¾Œã«å…¥åŠ›ã—ãŸãŠå®¢æ§˜',0),(254300,7064,'pt','Mostrar aos clientes que entraram depois',0),(254301,7064,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð’Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ñ… ÐŸÐ¾ÑÐ»Ðµ',0),(254302,7064,'es','Mostrar Clientes Entrados DepuÃ©s',0),(254303,7064,'de','Zeigen Sie Kunden, die nach eingegebenen an',0),(254304,7064,'en','Show Customers Entered After',0),(254305,7065,'is','',0),(254306,7065,'dr','( Ú©ÙˆØ¯ Ù¾Ø³ØªÙŠ Ø§ÙˆÙ„ÙŠÙ‡',0),(254307,7065,'pr','Ø´Ø±ÙˆØ¹ ÙƒØ¯ Ù¾Ø³ØªÙŠ( ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø§ÙˆÙ„ÙŠÙ‡',0),(254308,7065,'tr','Alan kodu baÅŸlar',0),(254309,7065,'pl','Kod pocztowy BEGIN',0),(254310,7065,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(254311,7065,'ur','Ø²Ù¾ Ú©ÙˆÚˆ Ú©Ø§ Ø¢ØºØ§Ø²',0),(254312,7065,'sr','ÐŸÐ¾Ñ‡Ð½Ðµ ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(254313,7065,'vi','Báº¯t Ä‘áº§u sá»‘ Zip',0),(254314,7065,'af','Begin poskode',0),(254315,7065,'ro','ÃŽncepe codul poÅŸtal',0),(254316,7065,'et','Alustada postiindeks',0),(254317,7065,'si','ZaÄetni Å¾viÅ¾g zbornik',0),(254318,7065,'ba','Mulai kode pos',0),(254319,7065,'nl','Begin Zip Code',0),(254320,7065,'fi','Alkaa postinumero',0),(254321,7065,'no','Fra postnummer',0),(254322,7065,'da','Begynde postnummer',0),(254323,7065,'ko','ìš°íŽ¸ ë²ˆí˜¸ ì‹œìž‘',0),(254324,7065,'he','×‘×’×™×Ÿ ×ž×™×§×•×“',0),(254325,7065,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(254326,7065,'zh','å¼€å§‹é‚®ç¼–\r\n',0),(254327,7065,'sv','BÃ¶rja postnummer',0),(254328,7065,'it','Codice di avviamento postale di Begin',0),(254329,7065,'tl','',0),(254330,7065,'th','&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(254331,7065,'hi','à¤œà¤¼à¤¿à¤ª à¤•à¥‹à¤¡ à¤¶à¥à¤°à¥‚ à¤¹à¥‹',0),(254332,7065,'ms','Bermula Kod Zip',0),(254333,7065,'ar','ÙŠØ¨Ø¯Ø£ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(254334,7065,'fr','Commencer le Code postal',0),(254335,7065,'jp','Zip ã‚³ãƒ¼ãƒ‰ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(254336,7065,'pt','Begin CEP',0),(254337,7065,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ Ð¸Ð½Ð´ÐµÐºÑ Begin',0),(254338,7065,'es','CÃ³digo Postal de Inicio',0),(254339,7065,'de','Postleitzahl beginnen',0),(254340,7065,'en','Begin Zip Code',0),(254341,7066,'is','',0),(254342,7066,'dr','Ù¾Ø§ÙŠØ§Ù† ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(254343,7066,'pr','Ù¾Ø§ÙŠØ§Ù† ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(254344,7066,'tr','Son alan kodu',0),(254345,7066,'pl','Koniec kod pocztowy',0),(254346,7066,'bg','ÐšÑ€Ð°Ð¹ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(254347,7066,'ur','Ø¢Ø®Ø± Ø²Ù¾ Ú©ÙˆÚˆ',0),(254348,7066,'sr','ÐšÑ€Ð°Ñ˜ ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(254349,7066,'vi','Káº¿t thÃºc mÃ£ Zip',0),(254350,7066,'af','Einde poskode',0),(254351,7066,'ro','SfÃ¢rÅŸitul Zip Code',0),(254352,7066,'et','LÃµpuks postiindeks',0),(254353,7066,'si','Konec poÅ¡tna Å¡tevilka',0),(254354,7066,'ba','Akhir kode pos',0),(254355,7066,'nl','Einde Zip Code',0),(254356,7066,'fi','Lopulta postinumero',0),(254357,7066,'no','Slutten postnummer',0),(254358,7066,'da','End postnummer',0),(254359,7066,'ko','ê²°êµ­ ìš°íŽ¸ ë²ˆí˜¸',0),(254360,7066,'he','×¡×•×£ ×ž×™×§×•×“',0),(254361,7066,'el','Î¤Î­Î»Î¿Ï‚ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒ ÎºÏŽÎ´Î¹ÎºÎ±',0),(254362,7066,'zh','ç»“æŸé‚®ç¼–',0),(254363,7066,'sv','Slutet postnummer',0),(254364,7066,'it','Fine Cap',0),(254365,7066,'tl','',0),(254366,7066,'th','&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(254367,7066,'hi','à¤…à¤‚à¤¤ à¤œà¤¼à¤¿à¤ª à¤•à¥‹à¤¡',0),(254368,7066,'ms','Kod Zip akhir',0),(254369,7066,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ ÙÙŠ Ù†Ù‡Ø§ÙŠØ©',0),(254370,7066,'fr','Code postal fin',0),(254371,7066,'jp','æœ€å¾Œã®éƒµä¾¿',0),(254372,7066,'pt','CEP final',0),(254373,7066,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ Ð¸Ð½Ð´ÐµÐºÑ ÐºÐ¾Ð½ÐµÑ†',0),(254374,7066,'es','CÃ³digo Postal Final',0),(254375,7066,'de','Ende-Postleitzahl',0),(254376,7066,'en','End Zip Code',0),(254377,7067,'is','',0),(254378,7067,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø°Ø®ÙŠØ±Ù‡  ÙƒØ±Ø¯Ù† ÙŠØ§ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…ØºØ§ÙŠØ±',0),(254379,7067,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø°Ø®ÙŠØ±Ù‡  ÙƒØ±Ø¯Ù† ÙŠØ§ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…ØºØ§ÙŠØ±',0),(254380,7067,'tr','SÄ±rasÄ±nda hata kaydetme veya Ã§akÄ±ÅŸan veri',0),(254381,7067,'pl','BÅ‚Ä…d podczas zapisywania lub dane konfliktowe',0),(254382,7067,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ñ‚Ð¸Ð²Ð¾Ñ€ÐµÑ‡Ð¸Ð²Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(254383,7067,'ur','Ù†Ù‚Øµ Ø¯ÙˆØ±Ø§Ù† Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº ÛŒØ§ Ù…ØªØ¶Ø§Ø¯ Ú©ÙˆØ§Ø¦Ù',0),(254384,7067,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ Ñ‡ÑƒÐ²Ð°ÑšÐ° Ð¸Ð»Ð¸ Ð½ÐµÑƒÑÐ°Ð³Ð»Ð°ÑˆÐµÐ½Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(254385,7067,'vi','Sao lÆ°u cÃ³ lá»—i hay dá»¯ liá»‡u khÃ´ng phÃ¹ há»£p',0),(254386,7067,'af','Fout tydens stoor of teenstrydige Data',0),(254387,7067,'ro','Eroare Ã®n timpul salvare sau contradictorii date',0),(254388,7067,'et','Viga salvestamisel vÃµi vastuolulised andmed',0),(254389,7067,'si','Napaka med shrani ali nasprotujoÄih si podatkov',0),(254390,7067,'ba','Error selama Simpan atau konflik Data',0),(254391,7067,'nl','Fout tijdens opslaan of conflicterende gegevens',0),(254392,7067,'fi','Virhe aikana Tallenna tai ristiriitaiset tiedot',0),(254393,7067,'no','Feil under lagre eller motstridende Data',0),(254394,7067,'da','Fejl under Gem eller modstridende Data',0),(254395,7067,'ko','ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤ ì €ìž¥ ë˜ëŠ” ì¶©ëŒ í•˜ëŠ” ë°ì´í„°',0),(254396,7067,'he','×©×’×™××” ×‘×ž×”×œ×š ×©×ž×™×¨×” ××• ×”× ×ª×•× ×™× ×”×¡×•×ª×¨×™×',0),(254397,7067,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Î® Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÎ¬ Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(254398,7067,'zh','åœ¨ä¿å­˜ä¸­é”™è¯¯æˆ–æ•°æ®å†²çª\r\n',0),(254399,7067,'sv','Fel vid spara eller motstridiga Data',0),(254400,7067,'it','Errore durante il salvataggio o dati contrastanti',0),(254401,7067,'tl','',0),(254402,7067,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585; &#3627;&#3619;&#3639;&#3629;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3586;&#3633;&#3604;&#',0),(254403,7067,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤¯à¤¾ à¤ªà¤°à¤¸à¥à¤ªà¤° à¤µà¤¿à¤°à¥‹à¤§à¥€ à¤¡à¥‡à¤Ÿà¤¾',0),(254404,7067,'ms','Ralat semasa Simpan atau Data bercanggah',0),(254405,7067,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸ Ø£Ùˆ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ØªØ¹Ø§Ø±Ø¶Ø©',0),(254406,7067,'fr','Erreur lors de la Save ou donnÃ©es contradictoires',0),(254407,7067,'jp','ä¸­ã«ã‚¨ãƒ©ãƒ¼ã‚’ä¿å­˜ã¾ãŸã¯ãƒ‡ãƒ¼ã‚¿ã®ç«¶åˆ',0),(254408,7067,'pt','Erro ao salvar ou dados conflitantes',0),(254409,7067,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ñ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ñ‚Ð¸Ð²Ð¾Ñ€ÐµÑ‡Ð¸Ð²Ñ‹Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(254410,7067,'es','Error Durante Guardar o Datos Conflictivos',0),(254411,7067,'de','Fehler beim Speichern oder widersprÃ¼chliche Daten',0),(254412,7067,'en','Error During Save or Conflicting Data',0),(254413,7068,'is','',0),(254414,7068,'dr','ÙŠØ§ Ù…Ø®ÙÙ Ø§Ø³ØªØ§Ù†',0),(254415,7068,'pr','ÙŠØ§ Ù…Ø®ÙÙ Ø§Ø³ØªØ§Ù†',0),(254416,7068,'tr','Ya da devlet Abbrev',0),(254417,7068,'pl','Lub Abbrev',0),(254418,7068,'bg','Ð˜Ð»Ð¸ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð½Ð¸ ÐµÐºÐ²Ð°Ñ‚Ð¾Ñ€Ð¸Ð°Ð»Ð½Ð°Ñ‚Ð°',0),(254419,7068,'ur','ÛŒØ§ Ø±ÛŒØ§Ø³ØªÛŒ Ø§Ø¨Ø¨Ù‚Ø±ÛŒÙˆ',0),(254420,7068,'sr','Ð˜Ð»Ð¸ Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ ÐÐ±Ð±Ñ€ÐµÐ²',0),(254421,7068,'vi','hay viáº¿t táº¯t cá»§a tiá»ƒu bang',0),(254422,7068,'af','Of Staat (Landsgebied) Afkort.',0),(254423,7068,'ro','Sau Abbrev de stat',0),(254424,7068,'et','VÃµi Abbrev',0),(254425,7068,'si','Ali drÅ¾avna Abbrev',0),(254426,7068,'ba','Atau negara Abbrev',0),(254427,7068,'nl','Of State Abbrev',0),(254428,7068,'fi','Tai Abbrev',0),(254429,7068,'no','Eller Abbrev',0),(254430,7068,'da','Eller tilstand Kongerige',0),(254431,7068,'ko','ë˜ëŠ” ì£¼ Abbrev',0),(254432,7068,'he','×ž×ž×¦×‘ Abbrev ××•',0),(254433,7068,'el','Î‰ ÎºÏÎ¬Ï„Î¿Ï…Ï‚ Î¼Î­Î»Î¿Ï…Ï‚, Abbrev',0),(254434,7068,'zh','æˆ–å·žç¼©å†™\r\n',0),(254435,7068,'sv','Eller Abbrev',0),(254436,7068,'it','O stato Abbrev',0),(254437,7068,'tl','',0),(254438,7068,'th','&#3627;&#3619;&#3639;&#3629;&#3626;&#3616;&#3634;&#3614;&#3585;&#3634;&#3619;&#3618;&#3656;&#3629;',0),(254439,7068,'hi','à¤¯à¤¾ Abbrev à¤°à¤¾à¤œà¥à¤¯',0),(254440,7068,'ms','Atau Negeri Abbrev',0),(254441,7068,'ar','Ø£Ùˆ Ø¯ÙˆÙ„Ø© Ø£Ø¨Ø±ÙŠÙ',0),(254442,7068,'fr','Ou Ã©tat Abbrev',0),(254443,7068,'jp','ã¾ãŸã¯çŠ¶æ…‹ã®ç•¥èªž',0),(254444,7068,'pt','Ou estado abrev',0),(254445,7068,'ru','Ð˜Ð»Ð¸ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð° Abbrev',0),(254446,7068,'es','O Abrev. de Estado',0),(254447,7068,'de','Oder staatliche Abbrev',0),(254448,7068,'en','Or State Abbrev',0),(254449,7069,'is','',0),(254450,7069,'dr','Ù…Ù†Ø·Ù‚Ù‡ ',0),(254451,7069,'pr','Ù…Ù†Ø·Ù‚Ù‡ ',0),(254452,7069,'tr','BÃ¶lge',0),(254453,7069,'pl','Terytorium',0),(254454,7069,'bg','Ð¢ÐµÑ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ',0),(254455,7069,'ur','Ø¹Ù„Ø§Ù‚Û',0),(254456,7069,'sr','Ð¢ÐµÑ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ˜Ð°',0),(254457,7069,'vi','LÃ£nh thá»•',0),(254458,7069,'af','Gebied',0),(254459,7069,'ro','Pe teritoriul',0),(254460,7069,'et','Territooriumil',0),(254461,7069,'si','Ozemlje',0),(254462,7069,'ba','Wilayah',0),(254463,7069,'nl','Grondgebied',0),(254464,7069,'fi','Alueella',0),(254465,7069,'no','Territorium',0),(254466,7069,'da','OmrÃ¥de',0),(254467,7069,'ko','ì˜í† ',0),(254468,7069,'he','×˜×¨×™×˜×•×¨×™×”',0),(254469,7069,'el','ÎˆÎ´Î±Ï†Î¿Ï‚',0),(254470,7069,'zh','é¢†åŸŸ\r\n',0),(254471,7069,'sv','Territorium',0),(254472,7069,'it','Territorio',0),(254473,7069,'tl','',0),(254474,7069,'th','&#3629;&#3634;&#3603;&#3634;&#3648;&#3586;&#3605;',0),(254475,7069,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(254476,7069,'ms','Wilayah',0),(254477,7069,'ar','Ø§Ù„Ø¥Ù‚Ù„ÙŠÙ…',0),(254478,7069,'fr','Territoire',0),(254479,7069,'jp','é ˜åœŸ',0),(254480,7069,'pt','TerritÃ³rio',0),(254481,7069,'ru','Ð¢ÐµÑ€Ñ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ',0),(254482,7069,'es','Territorio',0),(254483,7069,'de','Gebiet',0),(254484,7069,'en','Territory',0),(254485,7070,'is','',0),(254486,7070,'dr','ÙƒØ¯ Ù¾Ø³ØªÙŠ  ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(254487,7070,'pr','ÙƒØ¯ Ù¾Ø³ØªÙŠ  ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(254488,7070,'tr','Atanan ZIP',0),(254489,7070,'pl','Pocztowy przypisany do',0),(254490,7070,'bg','ZIP, Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½Ð¸ Ð½Ð°',0),(254491,7070,'ur','Ø²Ù¾ Ú©Ùˆ ØªÙÙˆÛŒØ¶ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(254492,7070,'sr','Ð—Ð˜ÐŸ Ð´Ð¾Ð´ÐµÑ™ÐµÐ½',0),(254493,7070,'vi','Zip chá»‰ Ä‘á»‹nh cho',0),(254494,7070,'af','Kode Toegestaan Aan',0),(254495,7070,'ro','cod postal alocat lui',0),(254496,7070,'et','Postikood on seotud',0),(254497,7070,'si','Zip, dodeljena',0),(254498,7070,'ba','Zip yang ditugaskan untuk',0),(254499,7070,'nl','Zip toegewezen aan',0),(254500,7070,'fi','Liitetty zip',0),(254501,7070,'no','Zip tilordnet',0),(254502,7070,'da','Zip tildelt',0),(254503,7070,'ko','ìš°íŽ¸ ë²ˆí˜¸ì— í• ë‹¹',0),(254504,7070,'he','Zip ×©×”×•×§×¦×•',0),(254505,7070,'el','ZIP Ï€Î¿Ï…',0),(254506,7070,'zh','é‚®ç¼–è¢«åˆ†é…åˆ°',0),(254507,7070,'sv','Zip tilldelats',0),(254508,7070,'it','Zip assegnato a ',0),(254509,7070,'tl','',0),(254510,7070,'th','&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;&#3606;&#3641;&#3585;&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(254511,7070,'hi','à¤œà¤¼à¤¿à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(254512,7070,'ms','Zip yang diperuntukkan kepada',0),(254513,7070,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ø§Ù„Ù…Ø¹ÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(254514,7070,'fr','Zip attribuÃ© Ã ',0),(254515,7070,'jp','éƒµä¾¿ç•ªå·ã«å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ã¾ã™ã€‚',0),(254516,7070,'pt','Zip atribuÃ­do a',0),(254517,7070,'ru','Ð˜Ð½Ð´ÐµÐºÑ, Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½Ð½Ñ‹Ð¹',0),(254518,7070,'es','Zip asignado a',0),(254519,7070,'de','ZIP zugewiesen',0),(254520,7070,'en','Zip Assigned To',0),(254521,7071,'is','',0),(254522,7071,'dr','ÙƒØ§Ø± Ø¯Ø§Ø®Ù„ÙŠ ',0),(254523,7071,'pr','ÙƒØ§Ø± Ø¯Ø§Ø®Ù„ÙŠ ',0),(254524,7071,'tr','Ä°Ã§ Ã§alÄ±ÅŸma',0),(254525,7071,'pl','WewnÄ™trznych',0),(254526,7071,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð¸',0),(254527,7071,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ú©Ø§Ù…',0),(254528,7071,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ¸ Ñ€Ð°Ð´Ð½Ð¸',0),(254529,7071,'vi','CÃ´ng viá»‡c ná»™i bá»™',0),(254530,7071,'af','Interne Werk',0),(254531,7071,'ro','Interne de lucru',0),(254532,7071,'et','TÃ¶Ã¶sisekorra',0),(254533,7071,'si','Notranjega dela',0),(254534,7071,'ba','Kerja internal',0),(254535,7071,'nl','Interne werkzaamheden',0),(254536,7071,'fi','SisÃ¤inen tyÃ¶',0),(254537,7071,'no','Interne arbeidet',0),(254538,7071,'da','Interne arbejde',0),(254539,7071,'ko','ë‚´ë¶€ ìž‘ì—…',0),(254540,7071,'he','×¢×‘×•×“×” ×¤× ×™×ž×™×ª',0),(254541,7071,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(254542,7071,'zh','å†…éƒ¨å·¥ä½œ\r\n',0),(254543,7071,'sv','Interna arbete',0),(254544,7071,'it','Lavoro interno',0),(254545,7071,'tl','',0),(254546,7071,'th','&#3585;&#3634;&#3619;&#3611;&#3599;&#3636;&#3610;&#3633;&#3605;&#3636;&#3591;&#3634;&#3609;&#3616;&#3634;&#3618;&#3651;&#3609;',0),(254547,7071,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤•à¤¾à¤®',0),(254548,7071,'ms','Kerja-kerja dalaman',0),(254549,7071,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(254550,7071,'fr','Travail interne',0),(254551,7071,'jp','å†…éƒ¨ã®ä½œæ¥­',0),(254552,7071,'pt','Trabalho interno',0),(254553,7071,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÑÑ Ð Ð°Ð±Ð¾Ñ‚Ð°',0),(254554,7071,'es','Trabajo Internal',0),(254555,7071,'de','Interne Arbeit',0),(254556,7071,'en','Internal Work',0),(254557,7072,'is','',0),(254558,7072,'dr','Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡ Ø²Ù…Ø§Ù† Ø¬Ø¯ÙŠØ¯',0),(254559,7072,'pr','Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡ Ø²Ù…Ø§Ù† Ø¬Ø¯ÙŠØ¯',0),(254560,7072,'tr','Oturum yeni zaman',0),(254561,7072,'pl','Rejestracja nowego czasu',0),(254562,7072,'bg','Ð’Ð»ÐµÐ·Ñ‚Ðµ \"Ð½Ð¾Ð²Ð¾Ñ‚Ð¾ Ð²Ñ€ÐµÐ¼Ðµ\"',0),(254563,7072,'ur','Ù†ÛŒØ§ ÙˆÙ‚Øª Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº',0),(254564,7072,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(254565,7072,'vi','Giá» Cháº¥m cÃ´ng má»›i',0),(254566,7072,'af','Log Nuwe Tyd',0),(254567,7072,'ro','Jurnal nou timp',0),(254568,7072,'et','Logige uue aja',0),(254569,7072,'si','Prijavite nov Äas',0),(254570,7072,'ba','Login baru waktu',0),(254571,7072,'nl','Meld u nieuwe tijd',0),(254572,7072,'fi','Kirjaudu uusi aika',0),(254573,7072,'no','Logg ny tid',0),(254574,7072,'da','Log ny tid',0),(254575,7072,'ko','ìƒˆë¡œìš´ ì‹œê°„ ë¡œê·¸',0),(254576,7072,'he','×¨×™×©×•× ×ž×•×¢×“ ×—×“×©',0),(254577,7072,'el','Î£Ï…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Î½Î­Î± ÏŽÏÎ±',0),(254578,7072,'zh','è®°å½•æ–°æ—¶é—´\r\n',0),(254579,7072,'sv','Logga in ny tid',0),(254580,7072,'it','Accedere di nuovo orario',0),(254581,7072,'tl','',0),(254582,7072,'th','&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3619;&#3632;&#3610;&#3610;&#3588;&#3619;&#3633;&#3657;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(254583,7072,'hi','à¤¨à¤ˆ à¤¸à¤®à¤¯ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¥‡à¤‚',0),(254584,7072,'ms','Log masa baru',0),(254585,7072,'ar','ØªØ³Ø¬ÙŠÙ„ ÙˆÙ‚Øª Ø¬Ø¯ÙŠØ¯',0),(254586,7072,'fr','Connecter la nouvelle heure',0),(254587,7072,'jp','æ–°ã—ã„æ™‚é–“ã®ãƒ­ã‚°ã‚ªãƒ³',0),(254588,7072,'pt','Log novo tempo',0),(254589,7072,'ru','Ð—Ð°Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ðµ Ð’Ñ€ÐµÐ¼Ñ',0),(254590,7072,'es','Log Nuevo Tiempo',0),(254591,7072,'de','Melden Sie neues Zeit',0),(254592,7072,'en','Log New Time',0),(254593,7073,'is','',0),(254594,7073,'dr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± Ø²Ù…Ø§Ù† Ø¯Ø§Ø®Ù„ÙŠ ',0),(254595,7073,'pr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± Ø²Ù…Ø§Ù† Ø¯Ø§Ø®Ù„ÙŠ ',0),(254596,7073,'tr','Ä°Ã§ saat EditÃ¶r',0),(254597,7073,'pl','WewnÄ™trzny edytor czasu',0),(254598,7073,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¾Ñ€',0),(254599,7073,'ur','Ø¯Ø§Ø®Ù„ÛŒ ÙˆÙ‚Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø§Ø±',0),(254600,7073,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ¸ Ð¿ÑƒÑ‚ Ð•Ð´Ð¸Ñ‚Ð¾Ñ€',0),(254601,7073,'vi','BiÃªn Táº­p Thá»i Gian Ná»™i Bá»™',0),(254602,7073,'af','Interne Tyd Redigeerder',0),(254603,7073,'ro','Interne timp Editor',0),(254604,7073,'et','Sisemine toimetaja',0),(254605,7073,'si','Notranji Äas urednik',0),(254606,7073,'ba','Internal waktu Editor',0),(254607,7073,'nl','Interne Editor van de tijd',0),(254608,7073,'fi','SisÃ¤inen aika toimittaja',0),(254609,7073,'no','Intern tid Editor',0),(254610,7073,'da','Indre tid Editor',0),(254611,7073,'ko','ë‚´ë¶€ ì‹œê°„ íŽ¸ì§‘ê¸°',0),(254612,7073,'he','×¢×•×¨×š ×–×ž×Ÿ ×¤× ×™×ž×™',0),(254613,7073,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® Ï‡ÏÏŒÎ½Î¿Ï‚ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î®',0),(254614,7073,'zh','å†…éƒ¨æ—¶é—´ç¼–è¾‘\r\n',0),(254615,7073,'sv','Intern tid redaktÃ¶r',0),(254616,7073,'it','Editor interno di tempo',0),(254617,7073,'tl','',0),(254618,7073,'th','&#3650;&#3611;&#3619;&#3649;&#3585;&#3619;&#3617;&#3649;&#3585;&#3657;&#3652;&#3586;&#3648;&#3623;&#3621;&#3634;&#3616;&#3634;&#3618;&#3651;&#3609;',0),(254619,7073,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¸à¤®à¤¯ à¤¸à¤‚à¤ªà¤¾à¤¦à¤•',0),(254620,7073,'ms','Dalaman masa Editor',0),(254621,7073,'ar','Ø§Ù„Ù…Ø­Ø±Ø± Ø§Ù„Ø³Ø§Ø¹Ø© Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(254622,7073,'fr','Ã‰diteur de temps intern',0),(254623,7073,'jp','å†…éƒ¨æ™‚é–“ã‚¨ãƒ‡ã‚£ã‚¿ãƒ¼',0),(254624,7073,'pt','Editor interno do tempo',0),(254625,7073,'ru','Ð’ÑÑ‚Ñ€Ð¾ÐµÐ½Ð½Ñ‹Ð¹ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¾Ñ€ Ð²Ñ€ÐµÐ¼Ñ',0),(254626,7073,'es','Editor de Tiempo Internal',0),(254627,7073,'de','Internen Zeit-Editor',0),(254628,7073,'en','Internal Time Editor',0),(254629,7074,'is','',0),(254630,7074,'dr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø±ÙŠØ® Ø¬Ø¯ÙŠØ¯ ',0),(254631,7074,'pr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø±ÙŠØ® Ø¬Ø¯ÙŠØ¯ ',0),(254632,7074,'tr','Yeni tarihleri seÃ§meden Ã¶nce deÄŸiÅŸiklikleri kaydetmek',0),(254633,7074,'pl','ZapisaÄ‡ zmiany przed wybierajÄ…c nowe terminy',0),(254634,7074,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð´Ð°Ñ‚Ð¸',0),(254635,7074,'ur','Ù†Ø¦ÛŒ ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ø³Û’ Ù¾ÛÙ„Û’ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(254636,7074,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð¿Ñ€Ðµ Ð½ÐµÐ³Ð¾ ÑˆÑ‚Ð¾ Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð²Ðµ Ð´Ð°Ñ‚ÑƒÐ¼Ðµ',0),(254637,7074,'vi','Sao lÆ°u thay Ä‘á»•i trÆ°á»›c khi chá»n ngÃ y má»›i',0),(254638,7074,'af','Veranderinge stoor voordat jy kies nuwe datums',0),(254639,7074,'ro','SalvaÅ£i modificÄƒrile Ã®nainte de a selecta noi date',0),(254640,7074,'et','Salvesta muudatused enne uute kuupÃ¤evade valimist',0),(254641,7074,'si','Shranite spremembe pred izbiro nove datume',0),(254642,7074,'ba','Simpan perubahan sebelum memilih tanggal baru',0),(254643,7074,'nl','Wijzigingen opslaan voordat u nieuwe datums',0),(254644,7074,'fi','Tallenna muutokset ennen valintaa uudet pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(254645,7074,'no','Lagre endringene fÃ¸r du velger nye datoer',0),(254646,7074,'da','Gemme Ã¦ndringer, fÃ¸r du vÃ¦lger nye datoer',0),(254647,7074,'ko','ìƒˆ ë‚ ì§œë¥¼ ì„ íƒ í•˜ê¸° ì „ì— ë³€ê²½ ì‚¬í•­ì„ ì €ìž¥í•©ë‹ˆë‹¤',0),(254648,7074,'he','×œ×©×ž×•×¨ ××ª ×”×©×™× ×•×™×™× ×œ×¤× ×™ ×‘×—×™×¨×ª ×”×ª××¨×™×›×™× ×”×—×“×©×™×',0),(254649,7074,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® Ï„Î¹Ï‚ Î½Î­ÎµÏ‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(254650,7074,'zh','ä¿å­˜åœ¨é€‰æ‹©æ–°çš„æ—¥æœŸå˜åŒ–\r\n',0),(254651,7074,'sv','Spara Ã¤ndringar innan du vÃ¤ljer nya datum',0),(254652,7074,'it','Salvare le modifiche prima di selezionare nuove date',0),(254653,7074,'tl','',0),(254654,7074,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3656;&#3629;&#3609;&#3648;&#3621;&#3639;&#3629;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(254655,7074,'hi','à¤¨à¤ˆ à¤¤à¤¾à¤°à¥€à¤–à¥‹à¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¥‹à¤‚ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(254656,7074,'ms','Menyimpan perubahan sebelum memilih tarikh baru',0),(254657,7074,'ar','Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ ØªØ­Ø¯ÙŠØ¯ Ù…ÙˆØ§Ø¹ÙŠØ¯ Ø¬Ø¯ÙŠØ¯Ø©',0),(254658,7074,'fr','Enregistrer les modifications avant de sÃ©lectionner de nouvelles Dates',0),(254659,7074,'jp','æ–°ã—ã„æ—¥ä»˜ã‚’é¸æŠžã™ã‚‹å‰ã«å¤‰æ›´ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(254660,7074,'pt','Salvar as alteraÃ§Ãµes antes de selecionar novas datas',0),(254661,7074,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð”Ð¾ Ð’Ñ‹Ð±Ð¾Ñ€Ð° ÐÐ¾Ð²Ñ‹Ñ… Ð”Ð°Ñ‚',0),(254662,7074,'es','Guardar Cambios Antes Que Seleccionar Nuevas Fechas',0),(254663,7074,'de','Speichern Sie Ã„nderungen, bevor Sie sich fÃ¼r neue Termine',0),(254664,7074,'en','Save Changes Before Selecting New Dates',0),(254665,7075,'is','',0),(254666,7075,'dr','(ÙØ¶Ø§ÙŠ Ø®Ø§Ù„ÙŠ- ÙØ³Ø®) Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† ',0),(254667,7075,'pr','Ù†Ù…Ø§ÙŠØ´(ÙØ¶Ø§ÙŠ Ø®Ø§Ù„ÙŠ- ÙØ³Ø®) Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† ',0),(254668,7075,'tr','BoÅŸluÄŸu gÃ¶ster',0),(254669,7075,'pl','PokaÅ¼ Void',0),(254670,7075,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Void',0),(254671,7075,'ur','Ø®Ù„Ø§ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(254672,7075,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ñƒ',0),(254673,7075,'vi','Hiá»ƒn thá»‹ Ä‘Ã£ há»§y',0),(254674,7075,'af','Wys leemte',0),(254675,7075,'ro','AratÄƒ gol',0),(254676,7075,'et','Kuva Void',0),(254677,7075,'si','PokaÅ¾i prazen prostor',0),(254678,7075,'ba','Menunjukkan kekosongan',0),(254679,7075,'nl','Void weergeven',0),(254680,7075,'fi','NÃ¤ytÃ¤ hotelli Void',0),(254681,7075,'no','Vis Void',0),(254682,7075,'da','Vis Void',0),(254683,7075,'ko','Void í‘œì‹œ',0),(254684,7075,'he','×”×¦×’ ××ª ×”×—×œ×œ ×”×¨×™×§',0),(254685,7075,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎºÎµÎ½ÏŒ',0),(254686,7075,'zh','æ˜¾ç¤ºæ— æ•ˆ\r\n',0),(254687,7075,'sv','Visa Void',0),(254688,7075,'it','Visualizza Void',0),(254689,7075,'tl','',0),(254690,7075,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(254691,7075,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(254692,7075,'ms','Menunjukkan tidak',0),(254693,7075,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙØ±Ø§Øº',0),(254694,7075,'fr','Voir l\'Ã©tablissement vide',0),(254695,7075,'jp','Void ã‚’ç¤ºã™',0),(254696,7075,'pt','Mostrar vazio',0),(254697,7075,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð¾Ðµ',0),(254698,7075,'es','Mostrar Anulado',0),(254699,7075,'de','Void anzeigen',0),(254700,7075,'en','Show Void',0),(254701,7076,'is','',0),(254702,7076,'dr','1-   ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø± Ø¯Ø§Ø®Ù„ÙŠ ',0),(254703,7076,'pr','Ù…Ù†Ù‡Ø§ÙŠ 1-   ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø± Ø¯Ø§Ø®Ù„ÙŠ ',0),(254704,7076,'tr','Ä°Ã§ Ã§alÄ±ÅŸma sadece iÃ§in -1',0),(254705,7076,'pl','-1 tylko w pracy wewnÄ™trznej',0),(254706,7076,'bg','-1 Ð·Ð° Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð¸ ÑÐ°Ð¼Ð¾',0),(254707,7076,'ur','-1 ØµØ±Ù Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ú©Ø§Ù… Ú©Û’ Ù„ÛŒÛ’',0),(254708,7076,'sr','-1 Ð·Ð° Ð¸Ð½Ñ‚ÐµÑ€Ð½Ð¸ Ñ€Ð°Ð´ ÑÐ°Ð¼Ð¾',0),(254709,7076,'vi','-1 chá»‰ cho cÃ´ng viá»‡c ná»™i bá»™',0),(254710,7076,'af','-l vir Interne Werk Alleenlik',0),(254711,7076,'ro','-1 pentru interne de lucru numai',0),(254712,7076,'et','Ainult tÃ¶Ã¶sisekorra -1',0),(254713,7076,'si','-1 za notranje delo samo',0),(254714,7076,'ba','-1 untuk kerja Internal hanya',0),(254715,7076,'nl','-1 voor interne werkzaamheden alleen',0),(254716,7076,'fi','SisÃ¤istÃ¤ tyÃ¶tÃ¤ vain -1',0),(254717,7076,'no','-1 for interne arbeidet bare',0),(254718,7076,'da','-1 for interne arbejde kun',0),(254719,7076,'ko','ë‚´ë¶€ ìž‘ì—… ì „ìš©-1',0),(254720,7076,'he','-1 ×œ×¢×‘×•×“×” ×¤× ×™×ž×™×ª ×‘×œ×‘×“',0),(254721,7076,'el','-1 Î³Î¹Î± ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼ÏŒÎ½Î¿',0),(254722,7076,'zh','-1ä»…ä¸ºå†…éƒ¨å·¥ä½œ\r\n',0),(254723,7076,'sv','-1 fÃ¶r interna arbete endast',0),(254724,7076,'it','-1 per lavoro interno solo',0),(254725,7076,'tl','',0),(254726,7076,'th','-1 &#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3607;&#3635;&#3591;&#3634;&#3609;&#3616;&#3634;&#3618;&#3651;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(254727,7076,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤•à¤¾à¤® à¤•à¥‡à¤µà¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ -1',0),(254728,7076,'ms','-1 untuk kerja-kerja dalaman sahaja',0),(254729,7076,'ar','-1 Ù„Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠ ÙÙ‚Ø·',0),(254730,7076,'fr','-1 pour travail interne seulement',0),(254731,7076,'jp','å†…éƒ¨ä½œæ¥­ã®ã¿ã®å ´åˆã¯-1',0),(254732,7076,'pt','-1 para o trabalho domÃ©stico sÃ³',0),(254733,7076,'ru','-1 Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÐµÐ¹ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(254734,7076,'es','-1 solo para Trabajo Internal',0),(254735,7076,'de','-1 fÃ¼r interne Arbeit nur',0),(254736,7076,'en','-1 for Internal Work Only',0),(254737,7077,'is','',0),(254738,7077,'dr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(254739,7077,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(254740,7077,'tr','TÃ¼m iÅŸÃ§ilik giderleri toplam',0),(254741,7077,'pl','OgÃ³Å‚em wszystkie koszty robocizny',0),(254742,7077,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ñ‚Ñ€ÑƒÐ´Ð° Ñ‚Ð°ÐºÑÐ¸',0),(254743,7077,'ur','Ù…Ø­Ù†Øª Ú©Û’ Ø³Ø¨Ú¾ÛŒ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Ùˆ Ú©Ù„',0),(254744,7077,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ñ€Ð°Ð´ ÑÐ²Ð¸Ñ… Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ð¸',0),(254745,7077,'vi','Tá»•ng cá»™ng táº¥t cáº£ phÃ­ nhÃ¢n cÃ´ng',0),(254746,7077,'af','Totaal van Alle Arbeidskostes',0),(254747,7077,'ro','Total toate costurile forÅ£ei de muncÄƒ',0),(254748,7077,'et','Kokku sÃ¼Ã¼distustest Labor',0),(254749,7077,'si','Skupaj vsi stroÅ¡ki dela',0),(254750,7077,'ba','Jumlah semua biaya tenaga kerja',0),(254751,7077,'nl','Total alle arbeid kosten',0),(254752,7077,'fi','YhteensÃ¤ kaikki Labour maksut',0),(254753,7077,'no','Sum alle Ap. kostnader',0),(254754,7077,'da','Alle Labor omkostninger i alt',0),(254755,7077,'ko','ëª¨ë“  ë…¸ë™ ìš”ê¸ˆ í•©ê³„',0),(254756,7077,'he','×¡×š ×›×œ ×”×—×™×•×‘×™× ×”×¢×‘×•×“×”',0),(254757,7077,'el','Î£ÏÎ½Î¿Î»Î¿ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î´Î±Ï€Î¬Î½ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(254758,7077,'zh','æ€»åŠæ‰€æœ‰äººå·¥è´¹ç”¨\r\n',0),(254759,7077,'sv','Totalt alla Labor avgifter',0),(254760,7077,'it','Totale di tutte le spese di manodopera',0),(254761,7077,'tl','',0),(254762,7077,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3588;&#3656;&#3634;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(254763,7077,'hi','à¤•à¥à¤² à¤¸à¤­à¥€ à¤¶à¥à¤°à¤® à¤†à¤°à¥‹à¤ª',0),(254764,7077,'ms','Jumlah semua caj-caj buruh',0),(254765,7077,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø¬Ù…ÙŠØ¹ Ø§Ù„ØªÙ‡Ù… Ø§Ù„Ù…ÙˆØ¬Ù‡Ø© Ø¥Ù„ÙŠÙ‡ Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ù„',0),(254766,7077,'fr','Total de tous les frais de main d\'oeuvre',0),(254767,7077,'jp','ã™ã¹ã¦ã®åŠ´åƒæ–™é‡‘ã‚’åˆè¨ˆã—ã¾ã™ã€‚',0),(254768,7077,'pt','Total de todos os encargos trabalhistas',0),(254769,7077,'ru','Ð’ÑÐµÐ³Ð¾ Ð²ÑÐµ Ñ‚Ñ€ÑƒÐ´Ð¾Ð²Ñ‹Ðµ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹',0),(254770,7077,'es','Total todos los cargos laborales',0),(254771,7077,'de','Alle Labor Kosten insgesamt',0),(254772,7077,'en','Total All Labor Charges',0),(254773,7078,'is','',0),(254774,7078,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(254775,7078,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(254776,7078,'tr','Toplam faturalanabilir iÅŸÃ§i Ã¼cretleri',0),(254777,7078,'pl','CaÅ‚kowita rozliczane koszty robocizny',0),(254778,7078,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð»Ð°Ñ‚Ð¸Ð¼Ð¸ Ñ‚Ñ€ÑƒÐ´Ð° Ñ‚Ð°ÐºÑÐ¸',0),(254779,7078,'ur','Ú©Ù„ Ø¨Ù„Ù„Ø§Ø¨Ù„ÛŒ Ù…Ø²Ø¯ÙˆØ± Ú†Ø§Ø±Ø¬Ø²',0),(254780,7078,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð·Ð° ÐºÐ¾Ñ˜Ðµ Ñ‚Ñ€ÐµÐ±Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ñ€Ð°Ð´',0),(254781,7078,'vi','Tá»•ng cÃ´ng phÃ­ nhÃ¢n cÃ´ng cÃ³ thá»ƒ thanh toÃ¡n',0),(254782,7078,'af','Totale Verrekenbare Arbeidkostes',0),(254783,7078,'ro','Total taxe facturabile muncii',0),(254784,7078,'et','Maksustatavaid tÃ¶Ã¶jÃµu kulud kokku',0),(254785,7078,'si','Skupni stroÅ¡ki plaÄljivo delo',0),(254786,7078,'ba','Total biaya tenaga kerja yang ditagih',0),(254787,7078,'nl','Totaal factureerbare arbeid kosten',0),(254788,7078,'fi','Laskutettava tyÃ¶mÃ¤Ã¤rÃ¤ kulut yhteensÃ¤',0),(254789,7078,'no','Totalt fakturerbart arbeid kostnader',0),(254790,7078,'da','Samlede fakturerbare Labor omkostninger',0),(254791,7078,'ko','ì´ ì²­êµ¬ ë…¸ë™ ë¹„ìš©',0),(254792,7078,'he','×¡×” ×› ×—×™×•×‘×™× ×”×¢×‘×•×“×” ×œ×—×™×•×‘',0),(254793,7078,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Ï‡ÏÎµÏŽÏƒÎ¹Î¼Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(254794,7078,'zh','æ€»è®¡è®¡è´¹äººå·¥è´¹ç”¨\r\n',0),(254795,7078,'sv','Totala fakturerbara Labor avgifter',0),(254796,7078,'it','Totale spese di manodopera fatturabile',0),(254797,7078,'tl','',0),(254798,7078,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3588;&#3656;&#3634;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;',0),(254799,7078,'hi','à¤•à¥à¤² à¤¬à¤¿à¤² à¤¯à¥‹à¤—à¥à¤¯ à¤¶à¥à¤°à¤® à¤†à¤°à¥‹à¤ª',0),(254800,7078,'ms','Jumlah caj buruh situasi Billable',0),(254801,7078,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹ Ø§ØªÙ‡Ø§Ù…Ø§Øª Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ø§Ù„',0),(254802,7078,'fr','Total des droits du travail facturables',0),(254803,7078,'jp','åˆè¨ˆè«‹æ±‚åŠ´åƒå……æº€',0),(254804,7078,'pt','Totais encargos trabalhistas faturÃ¡veis',0),(254805,7078,'ru','Ð’ÑÐµÐ³Ð¾ Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÐ¼Ð¾Ð³Ð¾ Ñ‚Ñ€ÑƒÐ´Ð° Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(254806,7078,'es','Total de Cargos Laborales Facturables',0),(254807,7078,'de','Billable Labor GesamtgebÃ¼hren',0),(254808,7078,'en','Total Billable Labor Charges',0),(254809,7079,'is','',0),(254810,7079,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¯Ø§Ø®Ù„ÙŠ ',0),(254811,7079,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¯Ø§Ø®Ù„ÙŠ ',0),(254812,7079,'tr','Toplam iÃ§ iÅŸÃ§i Ã¼cretleri',0),(254813,7079,'pl','CaÅ‚kowite wewnÄ™trzne koszty robocizny',0),(254814,7079,'bg','ÐžÐ±Ñ‰Ð¾ Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¾ Ñ‚Ñ€ÑƒÐ´Ð° Ñ‚Ð°ÐºÑÐ¸',0),(254815,7079,'ur','Ú©Ù„ Ø¯Ø§Ø®Ù„ÛŒ Ù…Ø²Ø¯ÙˆØ± Ú†Ø§Ø±Ø¬Ø²',0),(254816,7079,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð·Ð° Ð¸Ð½Ñ‚ÐµÑ€Ð½Ð¸ Ñ€Ð°Ð´',0),(254817,7079,'vi','Tá»•ng cá»™ng phÃ­ nhÃ¢n cÃ´ng ná»™i bá»™',0),(254818,7079,'af','Totale Interne Arbeidkostes',0),(254819,7079,'ro','Total taxe interne muncii',0),(254820,7079,'et','Sisemine tÃ¶Ã¶jÃµu kulud kokku',0),(254821,7079,'si','Skupni notranji stroÅ¡ki dela',0),(254822,7079,'ba','Total biaya tenaga kerja Internal',0),(254823,7079,'nl','Totale interne arbeid kosten',0),(254824,7079,'fi','YhteensÃ¤ sisÃ¤inen Labour maksut',0),(254825,7079,'no','Intern Ap. totalkostnadene',0),(254826,7079,'da','Samlede indre Labor omkostninger',0),(254827,7079,'ko','ì´ ë‚´ë¶€ ë…¸ë™ ë¹„ìš©',0),(254828,7079,'he','×¡×” ×› ×—×™×•×‘×™× ×¢×‘×•×“×” ×¤× ×™×ž×™×ª',0),(254829,7079,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ­Ï‚ ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ­Ï‚ ÎµÏ€Î¹Î²Î±ÏÏÎ½ÏƒÎµÎ¹Ï‚ Ï„Î·Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(254830,7079,'zh','æ€»è®¡å†…éƒ¨åŠ³åŠ¨è´¹ç”¨\r\n',0),(254831,7079,'sv','Totala interna Labor avgifter',0),(254832,7079,'it','Totale oneri di lavoro interni',0),(254833,7079,'tl','',0),(254834,7079,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3588;&#3656;&#3634;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;&#3616;&#3634;&#3618;&#3651;&#3609;',0),(254835,7079,'hi','à¤•à¥à¤² à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¶à¥à¤°à¤® à¤†à¤°à¥‹à¤ª',0),(254836,7079,'ms','Jumlah caj buruh dalaman',0),(254837,7079,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(254838,7079,'fr','Total des droits du travail internes',0),(254839,7079,'jp','ç·å†…éƒ¨åŠ´åƒå……æº€',0),(254840,7079,'pt','Totais encargos trabalhistas internos',0),(254841,7079,'ru','Ð’ÑÐµÐ³Ð¾ Ð²Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÐµÐ³Ð¾ Ñ‚Ñ€ÑƒÐ´Ð° Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(254842,7079,'es','Total Cargos de Labor Internal',0),(254843,7079,'de','Interne Labor GesamtgebÃ¼hren',0),(254844,7079,'en','Total Internal Labor Charges',0),(254845,7080,'is','',0),(254846,7080,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù‡Ø± Ù‚Ø³Ù…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(254847,7080,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù‡Ø± Ù‚Ø³Ù…Øª Ú†Ø§Ù¾ Ù†Ø´Ø¯Ù‡ ',0),(254848,7080,'tr','Miktar her bÃ¶lÃ¼m-basÄ±lmamÄ±ÅŸ',0),(254849,7080,'pl','IloÅ›Ä‡ kaÅ¼dej czÄ™Å›ci bez nadruku',0),(254850,7080,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²ÑÑÐºÐ° Ñ‡Ð°ÑÑ‚, Ð±ÐµÐ· Ð¿ÐµÑ‡Ð°Ñ‚',0),(254851,7080,'ur','ÛØ± Ù…Ù‚Ø¯Ø§Ø± Ø­ØµÛ ØºÛŒØ± Ù…Ø·Ø¨ÙˆØ¹Û',0),(254852,7080,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑÐ²Ð°ÐºÐ¸ Ð´ÐµÐ¾ ÐºÐ¾Ñ˜Ð¸ Ð½Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°',0),(254853,7080,'vi','Sá»‘ lÆ°á»£ng má»—i phá»¥ tÃ¹ng khÃ´ng in',0),(254854,7080,'af','Hoeveelheid Elke Onderdeel Nie-Gedruk',0),(254855,7080,'ro','Cantitatea fiecare partea Non-imprimate',0),(254856,7080,'et','Kogus iga osa-trÃ¼kitud',0),(254857,7080,'si','KoliÄine vsak del netiskanih',0),(254858,7080,'ba','Kuantitas setiap bagian Non-cetak',0),(254859,7080,'nl','Hoeveelheid elk deel niet afgedrukt',0),(254860,7080,'fi','MÃ¤Ã¤rÃ¤ kunkin osa painamattoman',0),(254861,7080,'no','Antall hver del uten utskrift',0),(254862,7080,'da','MÃ¦ngde hver del ikke-trykte',0),(254863,7080,'ko','ì–‘ ê° ë¶€ ì¸ì‡„ ë¹„',0),(254864,7080,'he','×›×ž×•×ª ×›×œ ×—×œ×§ ×©××™× ×• ×ž×•×“×¤×¡',0),(254865,7080,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎºÎ¬Î¸Îµ Î¼Î­ÏÎ¿Ï‚ Î¼Î·',0),(254866,7080,'zh','æ¯ä¸ªéžå°åˆ·éƒ¨åˆ†æ•°é‡\r\n',0),(254867,7080,'sv','Kvantitet varje del utan tryck',0),(254868,7080,'it','QuantitÃ  ogni parte Non stampata',0),(254869,7080,'tl','',0),(254870,7080,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3649;&#3605;&#3656;&#3621;&#3632;&#3626;&#3656;&#3623;&#3609;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(254871,7080,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤­à¤¾à¤— à¤—à¥ˆà¤° à¤®à¥à¤¦à¥à¤°à¤¿à¤¤',0),(254872,7080,'ms','Kuantiti setiap bahagian bebas dicetak',0),(254873,7080,'ar','ÙƒÙ…ÙŠØ© ÙƒÙ„ Ø¬Ø²Ø¡ ØºÙŠØ± Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø©',0),(254874,7080,'fr','QuantitÃ© chaque partie Non imprimÃ©e',0),(254875,7080,'jp','å„æ•°é‡ãã®éžå°åˆ·',0),(254876,7080,'pt','Quantidade de cada parte nÃ£o-impresso',0),(254877,7080,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÐ°Ð¶Ð´Ð¾Ð¹ Ñ‡Ð°ÑÑ‚Ð¸ Ð±ÐµÐ· Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(254878,7080,'es','Cantidad Cada Parte No-Imprimida',0),(254879,7080,'de','Menge jeder Teil nicht gedruckt',0),(254880,7080,'en','Quantity Each Part Non-printed',0),(254881,7081,'is','',0),(254882,7081,'dr','Ù„ÙŠØ³Øª Ø¨Ø§Ø±ÙƒØ¯ ÙƒØ§Ø±Ø¨Ø± ',0),(254883,7081,'pr','Ù„ÙŠØ³Øª Ø¨Ø§Ø±ÙƒØ¯ ÙƒØ§Ø±Ø¨Ø± ',0),(254884,7081,'tr','KullanÄ±cÄ± barkod listesi',0),(254885,7081,'pl','Lista kodÃ³w kreskowych',0),(254886,7081,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ñ‰Ñ€Ð¸Ñ…ÐºÐ¾Ð´Ð° Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ',0),(254887,7081,'ur','ØµØ§Ø±Ù Ø¨Ø§Ø±Ú©ÙˆÚˆ ÙÛØ±Ø³Øª',0),(254888,7081,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð°',0),(254889,7081,'vi','Danh SÃ¡ch NgÆ°á»i Sá»­ Dá»¥ng MÃ£ Váº¡ch',0),(254890,7081,'af','Gebruiker Stepieskode Lys',0),(254891,7081,'ro','Lista de coduri de bare utilizator',0),(254892,7081,'et','Kasutaja vÃ¶Ã¶tkoodi loend',0),(254893,7081,'si','Seznam uporabnikov Ärtne kode',0),(254894,7081,'ba','Daftar Barcode pengguna',0),(254895,7081,'nl','Barcode gebruikerslijst',0),(254896,7081,'fi','Viivakoodi KÃ¤yttÃ¤jÃ¤luettelo',0),(254897,7081,'no','Barcode brukerlisten',0),(254898,7081,'da','Brugeren stregkode liste',0),(254899,7081,'ko','ì‚¬ìš©ìž ë°”ì½”ë“œ ëª©ë¡',0),(254900,7081,'he','×¨×©×™×ž×ª ×‘×¨×§×•×“ ×ž×©×ª×ž×©',0),(254901,7081,'el','Barcode Î»Î¯ÏƒÏ„Î± Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½',0),(254902,7081,'zh','ç”¨æˆ·æ¡ç åå•\r\n',0),(254903,7081,'sv','Barcode AnvÃ¤ndarlista',0),(254904,7081,'it','Elenco dei codici a barre utente',0),(254905,7081,'tl','',0),(254906,7081,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3634;&#3619;&#3660;&#3650;&#3588;&#3657;&#3604;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(254907,7081,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤¸à¥‚à¤šà¥€',0),(254908,7081,'ms','Senarai kod bar pengguna',0),(254909,7081,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠ',0),(254910,7081,'fr','Liste de codes Ã  barres de l\'utilisateur',0),(254911,7081,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ [ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ ãƒªã‚¹ãƒˆ]',0),(254912,7081,'pt','Lista de cÃ³digo de barras do usuÃ¡rio',0),(254913,7081,'ru','Ð¨Ñ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ ÑÐ¿Ð¸ÑÐºÐ° Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(254914,7081,'es','Usuario Lista de CÃ³digo de Barras',0),(254915,7081,'de','Barcode-Benutzerliste',0),(254916,7081,'en','User Barcode List',0),(254917,7082,'is','',0),(254918,7082,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ·',0),(254919,7082,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ·',0),(254920,7082,'tr','Terimler ekleme',0),(254921,7082,'pl','Dodaj warunki',0),(254922,7082,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð¸',0),(254923,7082,'ur','Ø´Ø±Ø§Ø¦Ø· Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(254924,7082,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð°',0),(254925,7082,'vi','ThÃªm Äiá»u Khoáº£n',0),(254926,7082,'af','Terme Byvoeg',0),(254927,7082,'ro','AdÄƒugaÅ£i termeni',0),(254928,7082,'et','Lisa tingimusi',0),(254929,7082,'si','Dodajanje pogojev',0),(254930,7082,'ba','Menambahkan istilah',0),(254931,7082,'nl','Begrippen toevoegen',0),(254932,7082,'fi','LisÃ¤Ã¤ termejÃ¤',0),(254933,7082,'no','Legg til termer',0),(254934,7082,'da','TilfÃ¸je vilkÃ¥r',0),(254935,7082,'ko','ìš©ì–´ ì¶”ê°€',0),(254936,7082,'he','×”×•×¡×£ ×ª× ××™',0),(254937,7082,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏŒÏÎ¿Î¹',0),(254938,7082,'zh','å¢žåŠ æ¡æ¬¾\r\n',0),(254939,7082,'sv','LÃ¤gga till termer',0),(254940,7082,'it','Aggiungere termini',0),(254941,7082,'tl','',0),(254942,7082,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;(&#3626;&#3633;&#3597;&#3597;&#3634;)',0),(254943,7082,'hi','à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(254944,7082,'ms','Menambah syarat-syarat',0),(254945,7082,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±ÙˆØ· Ø³Ø¯Ø§Ø¯',0),(254946,7082,'fr','Ajouter les termes',0),(254947,7082,'jp','ç”¨èªžã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(254948,7082,'pt','Adicionar termos',0),(254949,7082,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð¾Ð²',0),(254950,7082,'es','Agregar TÃ©rminos',0),(254951,7082,'de','Begriffe hinzufÃ¼gen',0),(254952,7082,'en','Add Terms',0),(254953,7083,'is','',0),(254954,7083,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ Ø¬Ù‡Øª Ù¾ÙŠÙˆØ³Øª ÙŠØ§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ ÙˆØ¬Ù‡',0),(254955,7083,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ùƒ Ø¬Ù‡Øª Ù¾ÙŠÙˆØ³Øª ÙŠØ§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ ÙˆØ¬Ù‡',0),(254956,7083,'tr','ACH veya EFT Ã¶demelerini banka hesap numarasÄ±',0),(254957,7083,'pl','Numer konta bankowego dla ACH lub EFT pÅ‚atnoÅ›ci',0),(254958,7083,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° ÐÐšÐš Ð¸Ð»Ð¸ EFT Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(254959,7083,'ur','Ø§Ú† ÛŒØ§ EFT Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Û’ Ù„ÛŒÛ’ Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§ÙˆÙ†Ù¹ Ù†Ù…Ø¨Ø±',0),(254960,7083,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸ Ð·Ð° ÐÑ… Ð¸Ð»Ð¸ Ð•Ð¤Ð¢ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(254961,7083,'vi','Sá»‘ TK NgÃ¢n HÃ ng Cho Thanh ToÃ¡n Báº±ng ACH hay EFT',0),(254962,7083,'af','Bankrekeningnommer vir ACH of EFT Betalings',0),(254963,7083,'ro','NumÄƒrul de cont bancar pentru ACH sau EFT plÄƒÅ£i',0),(254964,7083,'et','Arveldusarve Number ACH vÃµi EFT maksed',0),(254965,7083,'si','Å tevilka banÄnega raÄuna za ACH ali EFT plaÄila',0),(254966,7083,'ba','Nomor rekening bank untuk pembayaran TDE atau ACH',0),(254967,7083,'nl','Bankrekeningnummer voor ACH of EFT betalingen',0),(254968,7083,'fi','Pankkitilinumero ACH tai EFT-maksut',0),(254969,7083,'no','Kontonummer for ACH eller EFT betaling',0),(254970,7083,'da','Bankkontonummeret for ACH eller EFT betalinger',0),(254971,7083,'ko','ACH ë˜ëŠ” ì „ìž ì†¡ê¸ˆ ì§€ë¶ˆì„ ìœ„í•œ ì€í–‰ ê³„ì¢Œ ë²ˆí˜¸',0),(254972,7083,'he','×ž×¡×¤×¨ ×—×©×‘×•×Ÿ ×‘× ×§ ×¢×‘×•×¨ ACH ××• ×ª×©×œ×•×ž×™× EFT',0),(254973,7083,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î³Î¹Î± ACH Î® Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î—ÎœÎ§',0),(254974,7083,'zh','é“¶è¡Œè‡ªåŠ¨åŒ–äº¤æ˜“æ‰€æˆ–ç”µå­è½¬å¸ä»˜æ¬¾å¸å·\r\n',0),(254975,7083,'sv','Bankkontonummer fÃ¶r ACH eller EFT betalningar',0),(254976,7083,'it','Numero di conto bancario per ACH o pagamenti EFT',0),(254977,7083,'tl','',0),(254978,7083,'th','&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3610;&#3633;&#3597;&#3594;&#3637;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3586;&#3629;&#3591; ACH &#3627;&#3619;&#3639;&#3629; EFT &#3648;&#3614;&#3639;&#3656;&#3629;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;',0),(254979,7083,'hi','ACH à¤¯à¤¾ à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(254980,7083,'ms','Nombor akaun bank untuk men atau pembayaran EFT',0),(254981,7083,'ar','Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ Ù„Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ Ø£Ùˆ ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø£Ù…ÙˆØ§Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(254982,7083,'fr','NumÃ©ro de compte bancaire pour ACH ou paiements EFT',0),(254983,7083,'jp','ACH ã®éŠ€è¡Œå£åº§æŒ¯è¾¼éŠ€è¡Œå£åº§ç•ªå·',0),(254984,7083,'pt','NÃºmero de conta bancÃ¡ria para ACH ou pagamentos de EFT',0),(254985,7083,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ ACH Ð¸Ð»Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ EFT',0),(254986,7083,'es','Numero de Cuenta Bancario para ACH o EFT Pagos',0),(254987,7083,'de','Kontonummer fÃ¼r ACH oder EFT Zahlungen',0),(254988,7083,'en','Bank Account Number for ACH or EFT Payments',0),(254989,7084,'is','',0),(254990,7084,'dr','Ù…Ø³ÙŠØ± ÙŠØ§Ø¨ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ø¨Ø±Ø§ÙŠ Ù¾ÙŠÙˆØ³Øª Ù‡Ø§ ÙŠØ§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ ÙˆØ¬Ù‡',0),(254991,7084,'pr','Ù…Ø³ÙŠØ± ÙŠØ§Ø¨ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ø¨Ø±Ø§ÙŠ Ù¾ÙŠÙˆØ³Øª Ù‡Ø§ ÙŠØ§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ ÙˆØ¬Ù‡',0),(254992,7084,'tr','Banka Ã¶demeleri ACH veya EFT iÃ§in yÃ¶nlendirme',0),(254993,7084,'pl','Banku routingu dla ACH lub EFT pÅ‚atnoÅ›ci',0),(254994,7084,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð°Ñ‚Ð° Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚ Ð·Ð° ÐÐšÐš Ð¸Ð»Ð¸ EFT Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(254995,7084,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ù„Ø¦Û’ Ø§Ú† ÛŒØ§ EFT Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Ø§ Ø±ÙˆÙ¹ Ø¨Ù†Ø¯ÛŒ',0),(254996,7084,'sr','Ð‘Ð°Ð½ÐºÐ° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¸ Ð¿Ð¾ÑÑ‚ÑƒÐ¿Ð°Ðº Ð·Ð° ÐÑ… Ð¸Ð»Ð¸ Ð•Ð¤Ð¢ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(254997,7084,'vi','TrÃ¬nh tá»± ngÃ¢n hÃ ng cho thanh toÃ¡n ACH & EFT',0),(254998,7084,'af','Bank \"Routing\" vir ACH of EFT Betalings',0),(254999,7084,'ro','Banca de rutare pentru ACH sau EFT plÄƒÅ£i',0),(255000,7084,'et','Marsruudi ACH vÃµi EFT maksed pangale',0),(255001,7084,'si','Usmerjanje za ACH ali EFT plaÄila banki',0),(255002,7084,'ba','Bank Routing untuk ACH atau TDE pembayaran',0),(255003,7084,'nl','Bank routering voor ACH of EFT betalingen',0),(255004,7084,'fi','Pankin reititys ACH tai EFT maksut',0),(255005,7084,'no','Banken ruting for ACH eller EFT betaling',0),(255006,7084,'da','Bank Routing for ACH eller EFT betalinger',0),(255007,7084,'ko','ì€í–‰ ì§€ë¶ˆ ACH ë˜ëŠ” ì „ìž ì†¡ê¸ˆì— ëŒ€ í•œ ë¼ìš°íŒ…',0),(255008,7084,'he','×”×‘× ×§ × ×™×ª×•×‘ ×©×œ ACH ××• EFT ×ª×©×œ×•×ž×™×',0),(255009,7084,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± Î´ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Î³Î¹Î± ACH Î® EFT Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(255010,7084,'zh','è‡ªåŠ¨åŒ–äº¤æ˜“æ‰€æˆ–ç”µæ±‡ä»˜æ¬¾çš„é“¶è¡Œç¼–å·',0),(255011,7084,'sv','Bank routning fÃ¶r ACH eller EFT betalningar',0),(255012,7084,'it','Banca di Routing per ACH o EFT pagamenti',0),(255013,7084,'tl','',0),(255014,7084,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3650;&#3629;&#3609;&#3612;&#3656;&#3634;&#3609;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619; ACH &#3627;&#3619;&#3639;&#3629; EFT',0),(255015,7084,'hi','à¤¬à¥ˆà¤‚à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ ACH à¤¯à¤¾ à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¥‚à¤Ÿà¤¿à¤‚à¤—',0),(255016,7084,'ms','Penghalaan bagi men atau EFT bayaran Bank',0),(255017,7084,'ar','Ø¨Ù†Ùƒ Ø§Ù„ØªÙˆØ¬ÙŠÙ‡ Ù„Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ Ø£Ùˆ ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø£Ù…ÙˆØ§Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(255018,7084,'fr','Banque routage pour ACH ou EFT de paiements',0),(255019,7084,'jp','éŠ€è¡Œã¾ãŸã¯ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ã‚’ ACH éŠ€è¡Œå£åº§æŒ¯è¾¼ã®æ”¯æ‰•ã„',0),(255020,7084,'pt','Banco de roteamento para ACH ou EFT pagamentos',0),(255021,7084,'ru','Ð‘Ð°Ð½Ðº Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð´Ð»Ñ ACH Ð¸Ð»Ð¸ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(255022,7084,'es','Ruta (Routing) Bancaria para Pagos de ACH o EFT',0),(255023,7084,'de','Bank Routing fÃ¼r ACH oder EFT Zahlungen',0),(255024,7084,'en','Bank Routing for ACH or EFT Payments',0),(255025,7085,'is','',0),(255026,7085,'dr','( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(255027,7085,'pr','Ú¯Ø±ÙˆÙ‡ Ù…ØµØ±Ù ( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(255028,7085,'tr','KDV vergi grubu',0),(255029,7085,'pl','Grupa podatku VAT',0),(255030,7085,'bg','Ð”Ð”Ð¡ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(255031,7085,'ur','ÙˆØ§Ù¹ Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÙ¾',0),(255032,7085,'sr','Ð“Ñ€ÑƒÐ¿Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ð° ÐŸÐ”Ð’-Ð°',0),(255033,7085,'vi','NhÃ³m thuáº¿ VAT',0),(255034,7085,'af','BTW belasting groep',0),(255035,7085,'ro','Grupa de taxa TVA',0),(255036,7085,'et','KÃ¤ibemaksu maksugrupp',0),(255037,7085,'si','DDV davÄna skupina',0),(255038,7085,'ba','Kelompok pajak PPN',0),(255039,7085,'nl','BTW groep',0),(255040,7085,'fi','ArvonlisÃ¤vero alv-ryhmÃ¤',0),(255041,7085,'no','MVA-gruppe',0),(255042,7085,'da','MOMS momsgruppe',0),(255043,7085,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸ ì„¸ê¸ˆ ê·¸ë£¹',0),(255044,7085,'he','×§×‘×•×¦×ª ×ž×¡ ×ž×¢ ×ž',0),(255045,7085,'el','ÎŸÎ¼Î¬Î´Î±Ï‚ Ï†ÏŒÏÎ¿Ï… Î¦Î Î‘',0),(255046,7085,'zh','å¢žå€¼ç¨Žæ¶ˆè´¹ç¨Žç»„\r\n',0),(255047,7085,'sv','MOMS momsgrupp',0),(255048,7085,'it','Gruppo fiscale IVA',0),(255049,7085,'tl','',0),(255050,7085,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3648;&#3614;&#3636;&#3656;&#3617;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3650;&#3616;&#3588;',0),(255051,7085,'hi','à¤µà¥ˆà¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¤®à¥‚à¤¹',0),(255052,7085,'ms','VAT cukai Kumpulan',0),(255053,7085,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©',0),(255054,7085,'fr','Groupe fiscal TVA',0),(255055,7085,'jp','VAT ç¨Žã‚°ãƒ«ãƒ¼ãƒ—',0),(255056,7085,'pt','Grupo de tributaÃ§Ã£o do IVA',0),(255057,7085,'ru','ÐÐ”Ð¡ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð°Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ð°',0),(255058,7085,'es','Grupo de Impuesto de Consumo IVA',0),(255059,7085,'de','MwSt-Steuergruppe',0),(255060,7085,'en','VAT Tax Group',0),(255061,7086,'is','',0),(255062,7086,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø¯Ø¯Ù‡ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(255063,7086,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø¯Ø¯Ù‡ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(255064,7086,'tr','Hata SatÄ±cÄ± Ã¶deme veri ekleme',0),(255065,7086,'pl','BÅ‚Ä…d dodawania danych pÅ‚atnoÅ›ci dostawcy',0),(255066,7086,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(255067,7086,'ur','Ù†Ù‚Øµ Ø§Ø¶Ø§ÙÛ ÙˆÛŒÙ†ÚˆØ± Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÙˆØ§Ø¦Ù',0),(255068,7086,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(255069,7086,'vi','ThÃªm dá»¯ liá»‡u thanh toÃ¡n ngÆ°á»i bÃ¡n bá»‹ lá»—i',0),(255070,7086,'af','Fout het ontstaan met die Byvoeging van Verskaffer Betalingsdata',0),(255071,7086,'ro','Eroare adÄƒugÃ¢nd furnizor platÄƒ date',0),(255072,7086,'et','Viga lisades hankija makse andmed',0),(255073,7086,'si','Napaka dodajanje prodajalec plaÄilo podatkov',0),(255074,7086,'ba','Menambahkan kesalahan Vendor Data pembayaran',0),(255075,7086,'nl','Toevoegen van leverancier betaling foutgegevens',0),(255076,7086,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ toimittajan maksutietoja',0),(255077,7086,'no','Feil Ã¥ legge leverandÃ¸r betalingsdata',0),(255078,7086,'da','Fejl tilfÃ¸jelse af kreditor betalingsdata',0),(255079,7086,'ko','ë°ì´í„° ì˜¤ë¥˜ ì¶”ê°€ ê³µê¸‰ ì—…ì²´ ì§€ë¶ˆ',0),(255080,7086,'he','×©×’×™××” ×”×•×¡×¤×ª ×¡×¤×§ ×”×ª×©×œ×•× × ×ª×•× ×™×',0),(255081,7086,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(255082,7086,'zh','é”™è¯¯ï¼šæ–°å¢žä¾›åº”å•†ä»˜æ¬¾æ•°æ®',0),(255083,7086,'sv','Fel att lÃ¤gga till betalning leverantÃ¶rsdata',0),(255084,7086,'it','Errore aggiungendo i dati di pagamento per fornitore',0),(255085,7086,'tl','',0),(255086,7086,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3',0),(255087,7086,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¡à¥‡à¤Ÿà¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(255088,7086,'ms','Ralat menambah penjual data-Data pembayaran',0),(255089,7086,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø¨ÙŠØ§Ù†Ø§Øª Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(255090,7086,'fr','Erreur ajout des donnÃ©es de paiement du vendeur',0),(255091,7086,'jp','ä»•å…¥å…ˆæ”¯æ‰•ãƒ‡ãƒ¼ã‚¿ã®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(255092,7086,'pt','Dados de pagamento erro adicionando fornecedores',0),(255093,7086,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(255094,7086,'es','Error Agregando Datos de Pagos al Proveedor',0),(255095,7086,'de','Fehler beim HinzufÃ¼gen von Anbieter Zahlungsdaten',0),(255096,7086,'en','Error Adding Vendor Payment Data',0),(255097,7087,'is','',0),(255098,7087,'dr','Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ ÙƒØ±Ø¯Ù† Ú†Ùƒ ',0),(255099,7087,'pr','Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ ÙƒØ±Ø¯Ù† Ú†Ùƒ ',0),(255100,7087,'tr','Onay yazdÄ±rmak iÃ§in',0),(255101,7087,'pl','Do wyboru druku',0),(255102,7087,'bg','Ð—Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° Ñ‡ÐµÐº',0),(255103,7087,'ur','Ú†ÛŒÚ© Ø§Ù† Ú©ÛŒ Ø·Ø¨Ø§Ø¹Øª Ú©Û’ Ù„ÛŒÛ’',0),(255104,7087,'sr','Ð—Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(255105,7087,'vi','DÃ nh cho in SÃ©c',0),(255106,7087,'af','Kontroleer gedruk',0),(255107,7087,'ro','Pentru selectare imprimare',0),(255108,7087,'et','Sisse trÃ¼kkimiseks',0),(255109,7087,'si','Za tiskanje preverite',0),(255110,7087,'ba','Untuk memeriksa pencetakan',0),(255111,7087,'nl','Voor het selectievakje afdrukken',0),(255112,7087,'fi','Uloskirjautuminen tulostusta varten',0),(255113,7087,'no','Sjekk utskrift',0),(255114,7087,'da','For Check udskrivning',0),(255115,7087,'ko','í‘œ ì¸ì‡„',0),(255116,7087,'he','×”×¡×™×ž×•×Ÿ ×”×“×¤×¡×”',0),(255117,7087,'el','Î“Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„Î¿Ï… ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(255118,7087,'zh','å¯¹äºŽæ£€æŸ¥æ‰“å°\r\n',0),(255119,7087,'sv','FÃ¶r incheckningen utskrift',0),(255120,7087,'it','Per la stampa Check',0),(255121,7087,'tl','',0),(255122,7087,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3594;&#3655;&#3588;',0),(255123,7087,'hi','à¤šà¥‡à¤• à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤',0),(255124,7087,'ms','Untuk semak percetakan',0),(255125,7087,'ar','Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(255126,7087,'fr','Pour l\'impression de chÃ¨que',0),(255127,7087,'jp','å°åˆ·ã®ç¢ºèªã®ãŸã‚',0),(255128,7087,'pt','Para impressÃ£o de cheque',0),(255129,7087,'ru','Ð”Ð»Ñ ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸ ÐŸÐµÑ‡Ð°Ñ‚Ð¸',0),(255130,7087,'es','Para ImpresiÃ³n de Cheque',0),(255131,7087,'de','FÃ¼r Scheckdruck',0),(255132,7087,'en','For Check Printing',0),(255133,7088,'is','',0),(255134,7088,'dr','Ù¾ÙŠØºØ§Ù… Ø§Ø¹Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(255135,7088,'pr','Ù¾ÙŠØºØ§Ù… Ø§Ø¹Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(255136,7088,'tr','Inv bildirim iletisi',0),(255137,7088,'pl','Komunikat z powiadomieniem inv',0),(255138,7088,'bg','INV ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð¸Ñ‚ÐµÐ»Ð½Ð¾ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(255139,7088,'ur','Ø§Ù†Ùˆ Ø§Ø·Ù„Ø§Ø¹ Ù¾ÛŒØºØ§Ù…',0),(255140,7088,'sr','Ð˜Ð½Ð² ÑÐ¸ÑÑ‚ÐµÐ¼ÑÐºÐµ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(255141,7088,'vi','Tin nháº¯n thÃ´ng bÃ¡o hÃ³a Ä‘Æ¡n',0),(255142,7088,'af','Fkt Kennisgewingsboodskap',0),(255143,7088,'ro','Mesaj de notificare inv',0),(255144,7088,'et','Inv teade',0),(255145,7088,'si','Inv oznanilo vest',0),(255146,7088,'ba','Pesan pemberitahuan INV',0),(255147,7088,'nl','INV melding',0),(255148,7088,'fi','Inv ilmoitusviesti',0),(255149,7088,'no','Inv-melding',0),(255150,7088,'da','Inv anmeldelse besked',0),(255151,7088,'ko','Inv ì•Œë¦¼ ë©”ì‹œì§€',0),(255152,7088,'he','×”×•×“×¢×” ×¢×œ Inv',0),(255153,7088,'el','ÎœÎ®Î½Ï…Î¼Î± Î±Î½Î±ÎºÎ¿Î¯Î½Ï‰ÏƒÎ·Ï‚ Inv',0),(255154,7088,'zh','å‘ç¥¨é€šçŸ¥æ¶ˆæ¯\r\n',0),(255155,7088,'sv','Inv tillkÃ¤nnagivanden meddelande',0),(255156,7088,'it','Messaggio di notifica inv',0),(255157,7088,'tl','',0),(255158,7088,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3649;&#3592;&#3657;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(255159,7088,'hi','Inv à¤¸à¥‚à¤šà¤¨à¤¾ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(255160,7088,'ms','Mesej pemberitahuan songsang',0),(255161,7088,'ar','Ø±Ø³Ø§Ù„Ø© Ø¥Ø¹Ù„Ø§Ù… Ù„Ù„Ø§Ø³ØªØ«Ù…Ø§Ø±Ø§Øª',0),(255162,7088,'fr','Message de Notification d\'inv',0),(255163,7088,'jp','Inv é€šçŸ¥ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(255164,7088,'pt','Mensagem de notificaÃ§Ã£o de inv',0),(255165,7088,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Inv',0),(255166,7088,'es','Mensaje de NotificaciÃ³n de Inv.',0),(255167,7088,'de','Inv-Benachrichtigung',0),(255168,7088,'en','Inv Notification Message',0),(255169,7089,'is','',0),(255170,7089,'dr','Ù…ÙˆØ¶ÙˆØ¹ Ø§Ø¹Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(255171,7089,'pr','Ù…ÙˆØ¶ÙˆØ¹ Ø§Ø¹Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(255172,7089,'tr','Inv bildirim konusu',0),(255173,7089,'pl','Przedmiotem powiadomienia inv',0),(255174,7089,'bg','INV ÑƒÐ²ÐµÐ´Ð¾Ð¼ÑÐ²Ð°Ð½Ðµ Ð¾Ñ‚Ð½Ð¾ÑÐ½Ð¾',0),(255175,7089,'ur','Ø§Ù†Ùˆ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹ Ù…ÙˆØ¶ÙˆØ¹',0),(255176,7089,'sr','Ð˜Ð½Ð² Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµ Ð¾ Ñ‚ÐµÐ¼Ð¸',0),(255177,7089,'vi','Chá»§ Ä‘á»: ThÃ´ng bÃ¡o hÃ ng trong kho',0),(255178,7089,'af','Fakt. Kennisgewing Onderwerp',0),(255179,7089,'ro','Subiect de notificare inv',0),(255180,7089,'et','Inv teate teema',0),(255181,7089,'si','Predmet obvestila Inv',0),(255182,7089,'ba','INV pemberitahuan subjek',0),(255183,7089,'nl','INV kennisgeving onderwerp',0),(255184,7089,'fi','Inv ilmoituksen aihe',0),(255185,7089,'no','Inv varsling emne',0),(255186,7089,'da','Inv anmeldelse emne',0),(255187,7089,'ko','Inv ì•Œë¦¼ ì£¼ì œ',0),(255188,7089,'he','Inv ×”×•×“×¢×” ×¢×œ ×”× ×•×©×',0),(255189,7089,'el','Î˜Î­Î¼Î± ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ· Inv',0),(255190,7089,'zh','å‘ç¥¨é€šçŸ¥çš„ä¸»é¢˜\r\n',0),(255191,7089,'sv','Inv anmÃ¤lan angÃ¥ende',0),(255192,7089,'it','Oggetto di notifica inv',0),(255193,7089,'tl','',0),(255194,7089,'th','&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;&#3649;&#3592;&#3657;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(255195,7089,'hi','Inv à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾ à¤µà¤¿à¤·à¤¯',0),(255196,7089,'ms','Subjek pemberitahuan songsang',0),(255197,7089,'ar','Ù…ÙˆØ¶ÙˆØ¹ Ø§Ù„Ø¥Ø®Ø·Ø§Ø± Ù„Ù„Ø§Ø³ØªØ«Ù…Ø§Ø±Ø§Øª',0),(255198,7089,'fr','Objet de Notification inv',0),(255199,7089,'jp','Inv é€šçŸ¥ã®ä»¶å',0),(255200,7089,'pt','Objecto de notificaÃ§Ã£o de inv',0),(255201,7089,'ru','ÐŸÑ€ÐµÐ´Ð¼ÐµÑ‚ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Inv',0),(255202,7089,'es','Asunto de NotificaciÃ³n de Inv.',0),(255203,7089,'de','Inv Notification Betreff',0),(255204,7089,'en','Inv Notification Subject',0),(255205,7090,'is','',0),(255206,7090,'dr','Ø§Ù†ÙˆØ§Ø¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø¬Ø§Ø² Ø§Ø³Øª ',0),(255207,7090,'pr','Ø§Ù†ÙˆØ§Ø¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø¬Ø§Ø² Ø§Ø³Øª ',0),(255208,7090,'tr','Ä°zin verilen Ã¶deme tÃ¼rleri',0),(255209,7090,'pl','Typy pÅ‚atnoÅ›ci dozwolone',0),(255210,7090,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(255211,7090,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù… Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(255212,7090,'sr','Ð”Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(255213,7090,'vi','Cho phÃ©p Loáº¡i Thanh ToÃ¡n',0),(255214,7090,'af','Betalingstipe Toegelaat',0),(255215,7090,'ro','Tipuri de platÄƒ permise',0),(255216,7090,'et','Lubatud MaksevÃµimalused',0),(255217,7090,'si','Dovoljene vrste plaÄil',0),(255218,7090,'ba','Jenis pembayaran yang diperbolehkan',0),(255219,7090,'nl','Betaalwijzen toegestaan',0),(255220,7090,'fi','Maksutavat Internet',0),(255221,7090,'no','Betalingstyper tillatt',0),(255222,7090,'da','Betalingstyper tilladt',0),(255223,7090,'ko','í—ˆìš© ì§€ë¶ˆ ìœ í˜•',0),(255224,7090,'he','×¡×•×’×™ ×ª×©×œ×•× ×ž×•×ª×¨',0),(255225,7090,'el','Î•Ï€Î¹Ï„ÏÎµÏ€ÏŒÎ¼ÎµÎ½Î¿Î¹ Ï„ÏÏ€Î¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(255226,7090,'zh','å…è®¸çš„ä»˜æ¬¾æ–¹å¼\r\n',0),(255227,7090,'sv','Betalningstyper tillÃ¥tet',0),(255228,7090,'it','Tipi di pagamento consentiti',0),(255229,7090,'tl','',0),(255230,7090,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(255231,7090,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(255232,7090,'ms','Jenis-jenis bayaran yang dibenarkan',0),(255233,7090,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(255234,7090,'fr','Types de paiement autorisÃ©s',0),(255235,7090,'jp','æ”¯æ‰•ã„ã®ç¨®é¡žã‚’è¨±å¯',0),(255236,7090,'pt','Tipos de pagamento permitidos',0),(255237,7090,'ru','Ð”Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ðµ Ñ‚Ð¸Ð¿Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(255238,7090,'es','Tipos de Pagos Permitidos',0),(255239,7090,'de','Zahlungsarten erlaubt',0),(255240,7090,'en','Payment Types Allowed',0),(255241,7091,'is','',0),(255242,7091,'dr','3',0),(255243,7091,'pr','Ú†Ø§Ù¾ Ù‡Ø§ÙŠ Ø§ÙˆÙ„ÙŠÙ‡ Ú†Ùƒ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± â€“ Ø±ÙˆØ´  3',0),(255244,7091,'tr','Ã–nceden basÄ±lmÄ±ÅŸ onay stok-Style #3',0),(255245,7091,'pl','Nadrukiem sprawdzanie zapasÃ³w stylu #3',0),(255246,7091,'bg','ÐŸÐ¾ÑÑÐ½Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð° ÑÑ‚Ð¸Ð» #3',0),(255247,7091,'ur','Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹Ø¯ Ú†ÛŒÚ© Ø§Ø³Ù¹Ø§Ú© Ø·Ø±Ø² #3',0),(255248,7091,'sr','Ð¤Ð°Ð±Ñ€Ð¸Ñ‡ÐºÐ¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ñƒ ÑÑ‚Ð¸Ð»Ñƒ #3',0),(255249,7091,'vi','Kiá»ƒu dÃ¡ng SÃ©c in trÆ°á»›c sá»‘ 3',0),(255250,7091,'af','Vooruitgedrukte Tjek Voorraad-Styl #3',0),(255251,7091,'ro','Selectare pre-imprimate stil stoc #3',0),(255252,7091,'et','ValmistrÃ¼kitud sisse Stock-stiil #3',0),(255253,7091,'si','Nespremenljivo Äek staleÅ¾-Style #3',0),(255254,7091,'ba','Cetakan Check saham-gaya #3',0),(255255,7091,'nl','Voorgedrukte selectievakje Stock-Style #3',0),(255256,7091,'fi','Esipainettua uloskirjautuminen Stock-tyylinen #3',0),(255257,7091,'no','Fortrykt av lager-stil #3',0),(255258,7091,'da','Fortrykt Check Stock-stil #3',0),(255259,7091,'ko','ì¸ì‡„ ëœ ìˆ˜ í‘œ ì£¼ì‹ ìŠ¤íƒ€ì¼ #3',0),(255260,7091,'he','×”×¡×™×ž×•×Ÿ ×ž×•×“×¤×¡ ×ž×¨××© ×ž×œ××™ ×‘×¡×’× ×•×Ÿ #3',0),(255261,7091,'el','Î ÏÎ¿Ï„Ï…Ï€Ï‰Î¼Î­Î½ÎµÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÏƒÏ„Î¹Î» #3',0),(255262,7091,'zh','é¢„å°æŸ¥çœ‹åº“å­˜æ ·å¼ï¼ƒ3\r\n',0),(255263,7091,'sv','FÃ¶rtryckta kontroll lager stil #3',0),(255264,7091,'it','Prestampati Check Stock-stile #3',0),(255265,7091,'tl','',0),(255266,7091,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3626;&#3605;&#3655;&#3629;&#3585;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3656;&#3629;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660; #3',0),(255267,7091,'hi','Preprinted à¤šà¥‡à¤• à¤¶à¥‡à¤¯à¤°-à¤¶à¥ˆà¤²à¥€ #3',0),(255268,7091,'ms','Pracetak semak stok-gaya #3',0),(255269,7091,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù…Ø·Ø¨ÙˆØ¹ Ø¹Ù„Ù‰ ØºØ±Ø§Ø± Ø§Ù„Ø£Ø³Ù‡Ù… #3',0),(255270,7091,'fr','ChÃ¨que prÃ©imprimÃ© Style Stock #3',0),(255271,7091,'jp','ã‚ã‚‰ã‹ã˜ã‚ãƒã‚§ãƒƒã‚¯åœ¨åº«ã‚¹ã‚¿ã‚¤ãƒ« #3',0),(255272,7091,'pt','SeleÃ§Ã£o prÃ©-impresso Stock-estilo #3',0),(255273,7091,'ru','ÐŸÐ»Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð°Ð¿Ð°ÑÐ¾Ð² ÑÑ‚Ð¸Ð»ÑŒ #3',0),(255274,7091,'es','Estilo-Stock #3 de Cheque Preimprimido',0),(255275,7091,'de','Vorgedruckte Check Stock-Style #3',0),(255276,7091,'en','Preprinted Check Stock-Style #3',0),(255277,7092,'is','',0),(255278,7092,'dr','Ù†Ø±Ø® ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ÙØ±ÙˆØ´ ØªÙˆØ³Ø·  Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(255279,7092,'pr','Ù†Ø±Ø® ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ÙØ±ÙˆØ´ ØªÙˆØ³Ø·  Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(255280,7092,'tr','Bu satÄ±ÅŸ temsilcisi iÃ§in komisyon oranÄ±',0),(255281,7092,'pl','Stawki prowizji dla tego sprzedawcy',0),(255282,7092,'bg','ÐšÑƒÑ€Ñ Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(255283,7092,'ur','ÛŒÛ Ù¾Ø±Ø³Ù† Ú©Û’ Ù„Ø¦Û’ Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ø´Ø±Ø­',0),(255284,7092,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° ÑÑ‚Ð¾Ð¿Ð° Ð·Ð° Ñ‚Ð¾Ð³ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(255285,7092,'vi','GiÃ¡ Hoa há»“ng bÃ¡n hÃ ng cho nhÃ¢n viÃªn kinh doanh nÃ y',0),(255286,7092,'af','Kommissie Koers Verkope deur hierdie Verkoopspersoon',0),(255287,7092,'ro','Rata comision pentru acest agent de vÃ¢nzÄƒri',0),(255288,7092,'et','Vahendustasu mÃ¤Ã¤r selle mÃ¼Ã¼giisiku puhul',0),(255289,7092,'si','Stopnja provizije za tega prodajalca',0),(255290,7092,'ba','Tingkat komisi untuk tenaga penjualan ini',0),(255291,7092,'nl','Commissie tarief voor deze verkoper',0),(255292,7092,'fi','Komissio mÃ¤Ã¤rÃ¤Ã¤ myyjÃ¤n',0),(255293,7092,'no','Kommisjon for denne selgeren',0),(255294,7092,'da','Provisionssats for denne sÃ¦lger',0),(255295,7092,'ko','ì´ íŒë§¤ì›ì— ëŒ€ í•œ ìˆ˜ìˆ˜ë£Œìœ¨',0),(255296,7092,'he','×©×™×¢×•×¨ ×”×¢×ž×œ×” ×¢×‘×•×¨ ××™×© ×ž×›×™×¨×•×ª ×–×”',0),(255297,7092,'el','Î ÎŸÎ£ÎŸÎ£Î¤ÎŸ Ï€ÏÎ¿Î¼Î·Î¸ÎµÎ¹Î±Ï‚ Î³Î¹Î± Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï€Ï‰Î»Î·Ï„Î®',0),(255298,7092,'zh','ä½£é‡‘æ¯”çŽ‡ç”±è¿™åé”€å”®äººå‘˜é”€å”®\r\n',0),(255299,7092,'sv','Provisionssats fÃ¶r denna sÃ¤ljare',0),(255300,7092,'it','Tasso di Commissione per questo venditore',0),(255301,7092,'tl','',0),(255302,7092,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3588;&#3609;&#3609;&#3',0),(255303,7092,'hi','à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¯à¥‹à¤— à¤¦à¤°',0),(255304,7092,'ms','Kadar komisen untuk jurujual ini',0),(255305,7092,'ar','Ù…Ø¹Ø¯Ù„ Ù„Ø¬Ù†Ø© Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(255306,7092,'fr','Taux de Commission pour ce vendeur',0),(255307,7092,'jp','ã“ã®å–¶æ¥­æ‹…å½“è€…ã®ãŸã‚ã®æ‰‹æ•°æ–™çŽ‡',0),(255308,7092,'pt','Taxa de ComissÃ£o para o vendedor',0),(255309,7092,'ru','Ð¡Ñ‚Ð°Ð²ÐºÐ° ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(255310,7092,'es','Tasa de ComisiÃ³n Ventas pro este Vendedor',0),(255311,7092,'de','Provision fÃ¼r diesen VerkÃ¤ufer',0),(255312,7092,'en','Commission Rate for this Salesperson',0),(255313,7093,'is','',0),(255314,7093,'dr','Ù†Ø±Ø® ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ÙØ±ÙˆØ´ Ø¨Ù‡ Ù…Ù†Ø·Ù‚Ù‡ Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(255315,7093,'pr','Ù†Ø±Ø® ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ÙØ±ÙˆØ´ Ø¨Ù‡ Ù…Ù†Ø·Ù‚Ù‡ Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(255316,7093,'tr','Bu satÄ±ÅŸ temsilcisinin bÃ¶lge komisyon oranÄ±',0),(255317,7093,'pl','Komisji stawki w tym terytorium sprzedawcy',0),(255318,7093,'bg','ÐšÑƒÑ€Ñ Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð² Ñ‚Ð°Ð·Ð¸ Ñ‚ÐµÑ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†Ð°',0),(255319,7093,'ur','Ø´Ø±Ø­ Ù…ÛŒÚº Ù¾Ø±Ø³Ù† Ú©Û’ Ø¹Ù„Ø§Ù‚Û Ú©ØªØ±Ù†ÙˆÚº',0),(255320,7093,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° ÑÑ‚Ð¾Ð¿Ð° Ñƒ Ð¾Ð²Ð¾Ñ˜ Ñ‚ÐµÑ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ˜Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(255321,7093,'vi','GiÃ¡ Hoa há»“ng bÃ¡n hÃ ng cho khu vá»±c cá»§a nhÃ¢n viÃªn kinh doanh nÃ y',0),(255322,7093,'af','Kommissie Koers Verkope aan Hierdie Verkoopspersoon se Gebied',0),(255323,7093,'ro','Rata a Comisiei Ã®n acest agent de vÃ¢nzÄƒri pe teritoriul',0),(255324,7093,'et','Komisjoni mÃ¤Ã¤r selle mÃ¼Ã¼giisiku territooriumil',0),(255325,7093,'si','Komisije stopnja v tem ozemlju prodajalca',0),(255326,7093,'ba','Tingkat komisi dalam hal ini penjual di wilayah',0),(255327,7093,'nl','Tarief van de Commissie in dit grondgebied van verkoper',0),(255328,7093,'fi','Komission myyjÃ¤n alueella korko',0),(255329,7093,'no','Kommisjonen Rate i denne selgerens territorium',0),(255330,7093,'da','Kommissionens sats i dette sÃ¦lgerens omrÃ¥de',0),(255331,7093,'ko','íŒë§¤ì›ì˜ ì˜í† ê°€ í‰ê°€ ìœ„ì›íšŒ',0),(255332,7093,'he','×¢×ž×œ×” ×‘×©×™×¢×•×¨ ×”×–×” ×©×˜×— ×©×œ ××™×© ×ž×›×™×¨×•×ª',0),(255333,7093,'el','Î¤Î·Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®Ï‚ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î­Î´Î±Ï†Î¿Ï‚ Ï„Î¿Ï… Ï€Ï‰Î»Î·Ï„Î®',0),(255334,7093,'zh','ä½£é‡‘çŽ‡ç”±è¿™åé”€å”®äººå‘˜é”€å”®é¢†åŸŸ\r\n',0),(255335,7093,'sv','Kommissionens kurs i denna sÃ¤ljares territorium',0),(255336,7093,'it','Tasso della Commissione in questo territorio del venditore',0),(255337,7093,'tl','',0),(255338,7093,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;&#3648;&#3586;&#3605;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3',0),(255339,7093,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤®à¥‡à¤‚ à¤¯à¤¹ à¤¦à¤° à¤†à¤¯à¥‹à¤—',0),(255340,7093,'ms','Suruhanjaya kadar dalam hal ini jurujual di Wilayah',0),(255341,7093,'ar','Ù„Ø¬Ù†Ø© Ù…Ø¹Ø¯Ù„ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ø¥Ù‚Ù„ÙŠÙ… Ù„Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(255342,7093,'fr','Taux du Conseil dans ce territoire de vendeur',0),(255343,7093,'jp','å§”å“¡ä¼šã®çŽ‡ã§è²©å£²å“¡ã®é ˜åœŸ',0),(255344,7093,'pt','Taxa da ComissÃ£o neste territÃ³rio do vendedor',0),(255345,7093,'ru','Ð¡Ñ‚Ð°Ð²ÐºÐ¸ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¾Ð½Ð½Ð¾Ð³Ð¾ Ð² ÑÑ‚Ð¾Ð¹ Ñ‚ÐµÑ€Ñ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(255346,7093,'es','Tasa de ComisiÃ³n Ventas al Territorio de este Vendedor',0),(255347,7093,'de','Kommission Rate in diesem Gebiet des VerkÃ¤ufers',0),(255348,7093,'en','Commission Rate in this Salesperson\'s Territory',0),(255349,7094,'is','',0),(255350,7094,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø§Ø·Ù„Ø§Ø¹  ÙˆÙ‚ØªÙŠ ',0),(255351,7094,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø§Ø·Ù„Ø§Ø¹  ÙˆÙ‚ØªÙŠ ',0),(255352,7094,'tr','E-posta ne zaman bildirin',0),(255353,7094,'pl','E-mail powiadomienia, gdy',0),(255354,7094,'bg','Email ÑÑŠÐ¾Ð±Ñ‰Ð°Ð²Ð°Ð¼ ÐºÐ¾Ð³Ð°',0),(255355,7094,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø¬Ø¨ Ù…Ø·Ù„Ø¹ Ú©Ø±ÛŒÚº',0),(255356,7094,'sr','Ð•-Ð¼Ð°Ð¸Ð» ÐžÐ±Ð°Ð²Ð¸Ñ˜ÐµÑÑ‚Ð¸ ÐºÐ°Ð´Ð°',0),(255357,7094,'vi','Email thÃ´ng bÃ¡o khi',0),(255358,7094,'af','E-pos Kennisgewing Wanneer',0),(255359,7094,'ro','Email notifica atunci cÃ¢nd',0),(255360,7094,'et','E-posti teavitada',0),(255361,7094,'si','Email objaviti Äas',0),(255362,7094,'ba','Email memberitahu ketika',0),(255363,7094,'nl','E-mail melden wanneer',0),(255364,7094,'fi','SÃ¤hkÃ¶posti ilmoittaa jahka',0),(255365,7094,'no','E-post varsle nÃ¥r',0),(255366,7094,'da','E-mail informere hvor',0),(255367,7094,'ko','ì´ë©”ì¼ í†µì§€ ì‹œê¸°',0),(255368,7094,'he','×“×•× ×œ ×œ×”×•×“×™×¢ ×ž×ª×™',0),(255369,7094,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· ÏŒÏ„Î±Î½',0),(255370,7094,'zh','ç”µå­é‚®ä»¶é€šçŸ¥å½“\r\n',0),(255371,7094,'sv','E-post underrÃ¤tta nÃ¤r',0),(255372,7094,'it','E-mail notificare quando',0),(255373,7094,'tl','',0),(255374,7094,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3649;&#3592;&#3657;&#3591;&#3648;&#3617;&#3639;&#3656;&#3629;',0),(255375,7094,'hi','à¤ˆà¤®à¥‡à¤² à¤œà¤¬ à¤¸à¥‚à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(255376,7094,'ms','E-mel memberitahu apabila',0),(255377,7094,'ar','Ø¥Ø¹Ù„Ø§Ù… Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¹Ù†Ø¯Ù…Ø§',0),(255378,7094,'fr','Email notifier quand',0),(255379,7094,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«é€šçŸ¥ã®ã‚¿ã‚¤ãƒŸãƒ³ã‚°',0),(255380,7094,'pt','E-mail notificar quando',0),(255381,7094,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ, ÐºÐ¾Ð³Ð´Ð°',0),(255382,7094,'es','Email Notificar Cuando',0),(255383,7094,'de','E-Mail benachrichtigen, wenn',0),(255384,7094,'en','Email Notify When',0),(255385,7095,'is','',0),(255386,7095,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø¬Ù…Ø¹ Ø¢ÙˆØ±ÙŠ Ø´Ø¯Ù‡ ',0),(255387,7095,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø¬Ù…Ø¹ Ø¢ÙˆØ±ÙŠ Ø´Ø¯Ù‡ ',0),(255388,7095,'tr','Toplanan vergi hesabÄ±na GL',0),(255389,7095,'pl','GL konto podatek pobierany',0),(255390,7095,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° Ñ‚Ð°ÐºÑÐ¸',0),(255391,7095,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¹ÛŒÚ©Ø³ Ø¬Ù…Ø¹ Ú©Û’ Ù„ÛŒÛ’',0),(255392,7095,'sr','Ð“Ð› ÐºÐ¾Ð½Ñ‚Ð¾ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð¿Ñ€Ð¸ÐºÑƒÐ¿Ñ™ÐµÐ½Ð¸',0),(255393,7095,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Cho Thuáº¿ ÄÃ£ Thu',0),(255394,7095,'af','AG Rekening vir Belasting Gekollekteer',0),(255395,7095,'ro','GL cont pentru taxa perceputÄƒ',0),(255396,7095,'et','Pearaamatu maksukonto',0),(255397,7095,'si','GL raÄun za pobranega davka',0),(255398,7095,'ba','GL Account untuk pajak',0),(255399,7095,'nl','GL Account voor belastingen verzameld',0),(255400,7095,'fi','Kirjanpitotilin pÃ¤Ã¤tilin veroja kerÃ¤tÃ¤Ã¤n',0),(255401,7095,'no','GL kontoen for mva som er samlet inn',0),(255402,7095,'da','GL konto for skat indsamlet',0),(255403,7095,'ko','ìˆ˜ì§‘ í•˜ëŠ” ì„¸ê¸ˆì— ëŒ€ í•œ GL ê³„ì •',0),(255404,7095,'he','GL ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×ž×¡ ×©× ××¡×¤×•',0),(255405,7095,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± Ï„Î¿Î½ ÎµÎ¹ÏƒÏ€ÏÎ±Ï‡Î¸Î­Î½Ï„Î± Ï†ÏŒÏÎ¿',0),(255406,7095,'zh','æ€»å¸å¸æˆ·çš„ç¨Žæ”¶å¾æ”¶\r\n',0),(255407,7095,'sv','GL kontot fÃ¶r skatt samlas in',0),(255408,7095,'it','GL Account per fiscali raccolti',0),(255409,7095,'tl','',0),(255410,7095,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3619;&#3623;&#3610;&#3',0),(255411,7095,'hi','GL à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤à¤•à¤¤à¥à¤° à¤•à¤° à¤•à¥‡ à¤²à¤¿à¤',0),(255412,7095,'ms','GL akaun cukai yang dipungut',0),(255413,7095,'ar','Ø­Ø³Ø§Ø¨ GL Ù„Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„ØªÙŠ ØªÙ… Ø¬Ù…Ø¹Ù‡Ø§',0),(255414,7095,'fr','Compte GL pour impÃ´ts perÃ§us',0),(255415,7095,'jp','ç¨Žã®åŽé›†ã®ãŸã‚ã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(255416,7095,'pt','GL conta de impostos recolhidos',0),(255417,7095,'ru','GL ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ ÑÐ±Ð¾Ñ€Ð° Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(255418,7095,'es','Cuenta LM para Impuesto Cobrado',0),(255419,7095,'de','GL-Konto fÃ¼r zusammengestellt',0),(255420,7095,'en','GL Account for Tax Collected',0),(255421,7096,'is','',0),(255422,7096,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(255423,7096,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(255424,7096,'tr','Ã–denen vergi hesabÄ±na GL',0),(255425,7096,'pl','GL konta dla podatku od',0),(255426,7096,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸Ñ Ð´Ð°Ð½ÑŠÐº',0),(255427,7096,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’',0),(255428,7096,'sr','Ð“Ð› ÐºÐ¾Ð½Ñ‚Ð¾ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(255429,7096,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Cho Thuáº¿ ÄÃ£ Tráº£',0),(255430,7096,'af','AG Rekening vir Belasting Betaal',0),(255431,7096,'ro','GL cont pentru impozitul plÄƒtit',0),(255432,7096,'et','GL kontole makstud maks',0),(255433,7096,'si','GL raÄun za plaÄanega davka',0),(255434,7096,'ba','GL Account untuk pajak yang dibayar',0),(255435,7096,'nl','GL Account voor belasting',0),(255436,7096,'fi','Kirjanpitotilin pÃ¤Ã¤tilin maksetun veron',0),(255437,7096,'no','GI-konto for skatt betalt',0),(255438,7096,'da','GL konto for skat betalt',0),(255439,7096,'ko','ì„¸ê¸ˆ ì§€ë¶ˆì— ëŒ€ í•œ GL ê³„ì •',0),(255440,7096,'he','GL ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×ž×¡ ×©×™×œ×',0),(255441,7096,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± Ï„Î¿ Ï†ÏŒÏÎ¿ Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹',0),(255442,7096,'zh','æ€»å¸å¸æˆ·çš„ç¼´çº³ç¨Žæ¬¾\r\n',0),(255443,7096,'sv','GL kontot fÃ¶r skatt betalas',0),(255444,7096,'it','GL conto per la tassa pagata',0),(255445,7096,'tl','',0),(255446,7096,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3',0),(255447,7096,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ GL à¤–à¤¾à¤¤à¤¾',0),(255448,7096,'ms','GL akaun cukai yang dibayar',0),(255449,7096,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© ÙÙŠ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(255450,7096,'fr','Compte GL pour la taxe payÃ©e',0),(255451,7096,'jp','ç¨Žé‡‘ã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(255452,7096,'pt','GL conta para o imposto pago',0),(255453,7096,'ru','GL ÑÑ‡ÐµÑ‚ Ð´Ð»Ñ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(255454,7096,'es','Cuenta LM para Impuesto Pagado',0),(255455,7096,'de','GL-entfallen versteuert',0),(255456,7096,'en','GL Account for Tax Paid',0),(255457,7097,'is','',0),(255458,7097,'dr','ÙÙ‚Ø· ÙƒØ§Ù„Ø§Ù‡Ø§Ø±Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ú¯Ø±ÙˆÙ‡ÙŠ Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ù†Ø´Ø§Ù† Ø¨Ø¯Ù‡ÙŠØ¯ ',0),(255459,7097,'pr','ÙÙ‚Ø· ÙƒØ§Ù„Ø§Ù‡Ø§Ø±Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ú¯Ø±ÙˆÙ‡ÙŠ Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ù†Ø´Ø§Ù† Ø¨Ø¯Ù‡ÙŠØ¯ ',0),(255460,7097,'tr','Sadece Ã¼zerinde B2B mÃ¼ÅŸteri grubu Ã¶ÄŸeleri gÃ¶rÃ¼ntÃ¼leme',0),(255461,7097,'pl','Tylko wyÅ›wietlacz klienta Grupa przedmiotÃ³w na B2B',0),(255462,7097,'bg','Ð¡Ð°Ð¼Ð¾ Ð´Ð¸ÑÐ¿Ð»ÐµÐ¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ° Ð³Ñ€ÑƒÐ¿Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð½Ð° B2B',0),(255463,7097,'ur','ÙÙ‚Ø· Ø§Ø´ÛŒØ§Ø¡ Ú¯Ø±ÙˆÙ¾ Ú©Ø³Ù¹Ù…Ø± B2B Ù¾Ø± Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(255464,7097,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð°Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ ÑÑ‚Ð°Ð²ÐºÐµ Ð³Ñ€ÑƒÐ¿Ðµ ÐºÑƒÐ¿Ð°Ñ†Ð° Ð½Ð° Ð‘2Ð‘',0),(255465,7097,'vi','Chá»‰ thá»ƒ hiá»‡n hÃ ng trong nhÃ³m cá»§a trang B2B',0),(255466,7097,'af','Wys Items Slegs in Groep Op B2B Webwerf',0),(255467,7097,'ro','AfiÅŸeazÄƒ numai elementele de grup client pe B2B',0),(255468,7097,'et','Kliendi nimel Ã¼ksusi kuvada ainult linna B2B',0),(255469,7097,'si','Le skupina kupca prikaz elementov na B2B',0),(255470,7097,'ba','Hanya menampilkan item kelompok pelanggan B2B',0),(255471,7097,'nl','Alleen die onderdelen van de groep van de klant op B2B weergegeven',0),(255472,7097,'fi','NÃ¤ytÃ¤ vain asiakkaan ryhmitellÃ¤ B2B',0),(255473,7097,'no','Bare vise kunde elementer pÃ¥ B2B',0),(255474,7097,'da','Kun vise kunden gruppeelementer pÃ¥ B2B',0),(255475,7097,'ko','B2Bì— ê³ ê° ê·¸ë£¹ í•­ëª© í‘œì‹œ',0),(255476,7097,'he','×œ×”×¦×™×’ ×¨×§ ×¤×¨×™×˜×™ ×§×‘×•×¦×ª ×œ×§×•×—×•×ª-B2B',0),(255477,7097,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î±Ï€ÏŒ Î¿Î¼Î¬Î´Î± Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î³Î¹Î± B2B',0),(255478,7097,'zh','åªæ˜¾ç¤ºåœ¨å•†ä¸šå¯¹å•†ä¸šç½‘ç«™ä¸Šçš„é¡¹ç›®ç»„\r\n',0),(255479,7097,'sv','Endast Visa kund-objekt pÃ¥ B2B',0),(255480,7097,'it','Mostra solo gli elementi del gruppo Customer sul B2B',0),(255481,7097,'tl','',0),(255482,7097,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3651;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;&#3586;&#3629;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591; B2B ',0),(255483,7097,'hi','à¤•à¥‡à¤µà¤² B2B à¤ªà¤° à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹ à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(255484,7097,'ms','Hanya memaparkan perkara-perkara Kumpulan pelanggan B2B',0),(255485,7097,'ar','Ø¹Ø±Ø¶ Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„ ÙÙ‚Ø· ÙÙŠ B2B',0),(255486,7097,'fr','Afficher uniquement les Ã©lÃ©ments du groupe client sur B2B',0),(255487,7097,'jp','B2B ã®é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—ã®ã‚¢ã‚¤ãƒ†ãƒ ã®ã¿è¡¨ç¤ºã—ã¾ã™ã€‚',0),(255488,7097,'pt','Exibir somente os itens do grupo de cliente no B2B',0),(255489,7097,'ru','ÐžÑ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð½Ð° B2B',0),(255490,7097,'es','Solo Muestra Clientes',0),(255491,7097,'de','Nur Anzeige Kundengruppe Angaben auf B2B',0),(255492,7097,'en','Only Display Customer Group Items on B2B',0),(255493,7098,'is','',0),(255494,7098,'dr','( Ù†Ù‡ Ù‡Ø± Ø¯Ùˆ',0),(255495,7098,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠØ§ Ø§ÙŠÙ† ÙƒØ§Ø±Ù…Ù†Ø¯  ÙŠØ§ ÙŠÙƒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ( Ù†Ù‡ Ù‡Ø± Ø¯Ùˆ',0),(255496,7098,'tr','Ã‡alÄ±ÅŸan ya da satÄ±cÄ± (her ikisini birden) seÃ§in',0),(255497,7098,'pl','Wybierz pracownika lub dostawcy (nie zarÃ³wno)',0),(255498,7098,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¸Ð»Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº (Ð½Ðµ ÐµÐ´Ð½Ð¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾)',0),(255499,7098,'ur','Ù…Ù„Ø§Ø²Ù… ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û (Ù†ÛÛŒÚº Ø¯ÙˆÙ†ÙˆÚº) Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(255500,7098,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° (Ð½Ðµ Ð¾Ð±Ð°)',0),(255501,7098,'vi','Hoáº·c chá»n nhÃ¢n viÃªn hoáº·c ngÆ°á»i bÃ¡n (khÃ´ng cáº£ hai)',0),(255502,7098,'af','Kies eerder \'n Werknemer of \'n Verskaffer (nie albei nie)',0),(255503,7098,'ro','SelectaÅ£i fie angajat sau furnizor (nu atÃ¢t)',0),(255504,7098,'et','Vali kas tÃ¶Ã¶taja vÃµi hankija (mitte mÃµlemad)',0),(255505,7098,'si','Izberite zaposlenega ali dobavitelja, (ne oboje)',0),(255506,7098,'ba','Memilih karyawan atau Vendor (tidak baik)',0),(255507,7098,'nl','Selecteer werknemer of leverancier (niet beide)',0),(255508,7098,'fi','Valitse tyÃ¶ntekijÃ¤n tai toimittajan (molemmat)',0),(255509,7098,'no','Velg enten ansatte eller leverandÃ¸ren (ikke begge)',0),(255510,7098,'da','VÃ¦lg enten medarbejder eller kreditor (ikke begge)',0),(255511,7098,'ko','ì§ì› ë˜ëŠ” ê³µê¸‰ ì—…ì²´ (ëª¨ë‘)ë¥¼ ì„ íƒ',0),(255512,7098,'he','×‘×—×¨ ×”×¢×•×‘×“ ××• ×”×¡×¤×§ (×œ× ×©× ×™×”×)',0),(255513,7098,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎµÎ¯Ï„Îµ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚ Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® (ÏŒÏ‡Î¹ Ï„ÏŒÏƒÎ¿)',0),(255514,7098,'zh','é€‰æ‹©é›‡å‘˜æˆ–ä¾›åº”å•†ï¼ˆä¸åŒæ—¶ï¼‰\r\n',0),(255515,7098,'sv','VÃ¤lj antingen medarbetare eller leverantÃ¶r (inte bÃ¥da)',0),(255516,7098,'it','Seleziona dipendente o Vendor (non entrambi)',0),(255517,7098,'tl','',0),(255518,7098,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3627;&#3619;&#3639;&#3629;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618; (&#3652;&#3617;&#3656;&#3607;&#3633;&#3657;&#3591;&#3626;&#3629;&#3591;)',0),(255519,7098,'hi','à¤¯à¤¾ à¤¤à¥‹ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ (à¤¦à¥‹à¤¨à¥‹à¤‚ à¤¨à¤¹à¥€à¤‚) à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(255520,7098,'ms','Pilih sama ada pekerja atau penjual (tidak kedua-duanya)',0),(255521,7098,'ar','Ø­Ø¯Ø¯ Ø£Ù…Ø§ Ù…Ù† Ø§Ù„Ù…ÙˆØ¸Ù Ø£Ùˆ Ø§Ù„Ø¨Ø§Ø¦Ø¹ (ÙˆÙ„ÙŠØ³ ÙƒÙ„Ø§Ù‡Ù…Ø§)',0),(255522,7098,'fr','SÃ©lectionnez employÃ© ou fournisseur (pas les deux)',0),(255523,7098,'jp','å¾“æ¥­å“¡ã¾ãŸã¯ãƒ™ãƒ³ãƒ€ãƒ¼ ï¼ˆä¸¡æ–¹ï¼‰ ã®ã„ãšã‚Œã‹ã‚’é¸æŠžã—ã¾ã™',0),(255524,7098,'pt','Selecione empregado ou fornecedor (nÃ£o ambos)',0),(255525,7098,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð›ÑŽÐ±Ð¾Ð³Ð¾ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð¸Ð»Ð¸ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°(Ð½Ðµ Ð¾Ð±Ð¾Ð¸Ñ…)',0),(255526,7098,'es','Seleccionar o un Empleado o un Proveedor (no los dos)',0),(255527,7098,'de','WÃ¤hlen Sie entweder Mitarbeiter oder Lieferanten (nicht beide)',0),(255528,7098,'en','Select either Employee or Vendor (not both)',0),(255529,7099,'is','',0),(255530,7099,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙØ±Ù…  Ù¾ÙŠØ´ Ø§Ø² Ú†Ø§Ù¾ Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ø¬Ø¹Ø¨Ù‡ ',0),(255531,7099,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙØ±Ù…  Ù¾ÙŠØ´ Ø§Ø² Ú†Ø§Ù¾ Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ø¬Ø¹Ø¨Ù‡ ',0),(255532,7099,'tr','Preprint formu kutusu etiketlerini kullanÄ±n',0),(255533,7099,'pl','Zadruk wstÄ™pny formularz dla pole etykiety',0),(255534,7099,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð° Ð·Ð° Ð¿Ñ€ÐµÐ´Ð¿ÐµÑ‡Ð°Ñ‚ Ð·Ð° ÐºÑƒÑ‚Ð¸Ñ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(255535,7099,'ur','Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ ÙØ§Ø±Ù… Ú©Û’ Ù„ÛŒÛ’ Ù„ÛŒØ¨Ù„ Ø®Ø§Ù†Û Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(255536,7099,'sr','ÐŸÑ€ÐµÐ¿Ñ€Ð¸Ð½Ñ‚ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ† ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð·Ð° ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ Ð¾Ð·Ð½Ð°ÐºÐµ',0),(255537,7099,'vi','DÃ¹ng máº«u in trÆ°á»›c cho nhÃ£n há»™p',0),(255538,7099,'af','Gebruik Voorafgedrukte Vorm vir Gebokste Etikette',0),(255539,7099,'ro','UtilizaÅ£i formularul de manuscrise pentru caseta de etichete',0),(255540,7099,'et','Asuvad avaldamiseelsetes vormi lahtrisse etiketid',0),(255541,7099,'si','Za polje oznake uporabite obrazec Preprint',0),(255542,7099,'ba','Gunakan formulir Preprint untuk kotak label',0),(255543,7099,'nl','Preprint formulier gebruiken voor het vak Labels',0),(255544,7099,'fi','Preprint lomakkeessa Box tarrat',0),(255545,7099,'no','Bruke konferansedokument skjema for boks',0),(255546,7099,'da','Brug Preprint Form for afkrydsningsfeltet etiketter',0),(255547,7099,'ko','ìƒìž ë¼ë²¨ ì¸ì‡„ìš© ì–‘ì‹ ì‚¬ìš©',0),(255548,7099,'he','×”×©×ª×ž×© ×‘×˜×•×¤×¡ Preprint ×¢×‘×•×¨ ×ª×™×‘×ª ×ª×•×•×™×•×ª',0),(255549,7099,'el','Î§ÏÎ®ÏƒÎ· Ï€ÏÎ¿-Î´Î¿ÎºÎ¯Î¼Î¹Î¿ Ï†ÏŒÏÎ¼Î± Î³Î¹Î± Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚ Ï€Î»Î±Î¯ÏƒÎ¹Î¿',0),(255550,7099,'zh','ä½¿ç”¨é¢„å°è¡¨æ ¼ä½œç®±æ ‡ç­¾\r\n',0),(255551,7099,'sv','AnvÃ¤nd formulÃ¤ret om Preprint fÃ¶r rutan etiketter',0),(255552,7099,'it','Utilizzare il modulo di prestampa per casella etichette',0),(255553,7099,'tl','',0),(255554,7099,'th','&#3651;&#3594;&#3657;&#3615;&#3629;&#3619;&#3660;&#3617;&#3585;&#3656;&#3629;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;&#3586;&#3629;&#3591;&#3611;&#3657;&#3634;&#3618;&#3585;&#3635;&#3585;&#3633;&#3610;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(255555,7099,'hi','Preprint à¤«à¤¾à¤°à¥à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥‰à¤•à¥à¤¸ à¤²à¥‡à¤¬à¤² à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(255556,7099,'ms','Menggunakan borang Preprint untuk label Peti',0),(255557,7099,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù†Ù…ÙˆØ°Ø¬ ÙˆØ±Ù‚Ø© ØªØ³Ù…ÙŠØ§Øª Ù…Ø±Ø¨Ø¹',0),(255558,7099,'fr','Utilisez le formulaire de prÃ©-impression pour Ã©tiquettes de zone',0),(255559,7099,'jp','ãƒ—ãƒ¬ãƒ—ãƒªãƒ³ãƒˆ ãƒ•ã‚©ãƒ¼ãƒ  ãƒœãƒƒã‚¯ã‚¹ã®ãƒ©ãƒ™ãƒ«ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(255560,7099,'pt','Use o formulÃ¡rio de prÃ©-impressÃ£o para rÃ³tulos de caixa',0),(255561,7099,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ñ„Ð¾Ñ€Ð¼Ñƒ ÐŸÑ€ÐµÐ¿Ñ€Ð¸Ð½Ñ‚ Ð´Ð»Ñ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸ Ð¿Ð¾Ð»Ñ',0),(255562,7099,'es','Usar Formulario de Preimprimirpara Etiquetas de Cajas',0),(255563,7099,'de','Preprint-Kontaktformular fÃ¼r Etiketten',0),(255564,7099,'en','Use Preprint Form for Box Labels',0),(255565,7100,'is','',0),(255566,7100,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ ØµØ­ÙŠØ­ Ù†ÙŠØ³Øª',0),(255567,7100,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ ØµØ­ÙŠØ­ Ù†ÙŠØ³Øª',0),(255568,7100,'tr','Hesap numarasÄ± geÃ§ersiz',0),(255569,7100,'pl','Numer konta jest nieprawidÅ‚owy',0),(255570,7100,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð½Ð¾Ð¼ÐµÑ€ Ðµ Ð½ÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½',0),(255571,7100,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ù†Ø§Ø¬Ø§Ø¦Ø² ÛÛ’',0),(255572,7100,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ðµ',0),(255573,7100,'vi','Sá»‘ TK KhÃ´ng Há»£p Lá»‡',0),(255574,7100,'af','Rekeningnommer is Ongeldig',0),(255575,7100,'ro','Numarul contului este invalid',0),(255576,7100,'et','Konto Number ei sobi',0),(255577,7100,'si','Å tevilka raÄuna je neveljaven',0),(255578,7100,'ba','Nomor Akun Salah',0),(255579,7100,'nl','Rekeningnummer Is ongeldig',0),(255580,7100,'fi','Numero ei kelpaa',0),(255581,7100,'no','Kontonummeret er ugyldig',0),(255582,7100,'da','Kontonummeret er ugyldig',0),(255583,7100,'ko','ê³„ì • ë²ˆí˜¸ê°€ ìœ íš¨ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(255584,7100,'he','×ž×¡×¤×¨ ×—×©×‘×•×Ÿ ×œ× ×—×•×§×™',0),(255585,7100,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ·',0),(255586,7100,'zh','å¸æˆ·å·ç ç„¡æ•ˆ',0),(255587,7100,'sv','Kontonumret Ã¤r ogiltig',0),(255588,7100,'it','Il numero del profilo non Ã¨ valido',0),(255589,7100,'tl','',0),(255590,7100,'th','&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3610;&#3633;&#3597;&#3594;&#3637;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(255591,7100,'hi','à¤–à¤¾à¤¤à¤¾ à¤•à¥à¤°à¤®à¤¾à¤‚à¤• à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤¹à¥ˆ',0),(255592,7100,'ms','Nombor akaun tidak sah',0),(255593,7100,'ar','Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ ',0),(255594,7100,'fr','Le numÃ©ro de compte n\'est pas valide',0),(255595,7100,'jp','å£åº§ç•ªå·ãŒç„¡åŠ¹ã§ã™ã€‚',0),(255596,7100,'pt','NÃºmero da conta Ã© invÃ¡lido',0),(255597,7100,'ru','ÐÐµÐ²ÐµÑ€Ð½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°',0),(255598,7100,'es','NÃºmero de Cuenta InvÃ¡lido',0),(255599,7100,'de','Kontonummer ist ungÃ¼ltig',0),(255600,7100,'en','Account Number Is Invalid',0),(255601,7101,'is','',0),(255602,7101,'dr',' Ø§Ø¬Ø§Ø²Ù‡',0),(255603,7101,'pr',' Ø§Ø¬Ø§Ø²Ù‡',0),(255604,7101,'tr','Yetkilendirme',0),(255605,7101,'pl','Autoryzacja',0),(255606,7101,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ',0),(255607,7101,'ur','Ú©Ø§ Ø§Ø¬Ø§Ø²Øª Ù†Ø§Ù…Û',0),(255608,7101,'sr','ÐÑƒÑ‚Ð¾Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ð°',0),(255609,7101,'vi','Quyá»n ',0),(255610,7101,'af','Magtiging',0),(255611,7101,'ro','Autorizare',0),(255612,7101,'et','Luba',0),(255613,7101,'si','Dovoljenje',0),(255614,7101,'ba','Otorisasi',0),(255615,7101,'nl','Vergunning',0),(255616,7101,'fi','Luvan',0),(255617,7101,'no','Autorisasjon',0),(255618,7101,'da','Tilladelse',0),(255619,7101,'ko','ê¶Œí•œ ë¶€ì—¬',0),(255620,7101,'he','××™×©×•×¨',0),(255621,7101,'el','Î†Î´ÎµÎ¹Î±',0),(255622,7101,'zh','æŽˆæƒ\r\n',0),(255623,7101,'sv','TillstÃ¥nd',0),(255624,7101,'it','Autorizzazione',0),(255625,7101,'tl','',0),(255626,7101,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(255627,7101,'hi','à¤ªà¥à¤°à¤¾à¤§à¤¿à¤•à¤°à¤£',0),(255628,7101,'ms','Kebenaran',0),(255629,7101,'ar','Ø§Ù„ØªØ®ÙˆÙŠÙ„',0),(255630,7101,'fr','Autorisation',0),(255631,7101,'jp','æ‰¿èª',0),(255632,7101,'pt','AutorizaÃ§Ã£o',0),(255633,7101,'ru','ÐÐ²Ñ‚Ð¾Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(255634,7101,'es','AutorizaciÃ³n',0),(255635,7101,'de','Autorisierung',0),(255636,7101,'en','Authorization',0),(255637,7102,'is','',0),(255638,7102,'dr','( ØªØµØ±Ù ÙƒØ±Ø¯Ù†)',0),(255639,7102,'pr','ÙÙ‚Ø· Ø¶Ø¨Ø· Ú©Ø±Ø¯Ù† ( ØªØµØ±Ù ÙƒØ±Ø¯Ù†)',0),(255640,7102,'tr','YalnÄ±zca yakalama',0),(255641,7102,'pl','Przechwytywania tylko',0),(255642,7102,'bg','Ð£Ð»Ð¾Ð²Ð¸ ÑÐ°Ð¼Ð¾',0),(255643,7102,'ur','ØµØ±Ù Ú¯Ø±ÙØª Ú©Ø±ÛŒÚº',0),(255644,7102,'sr','Ð¡Ð°Ð¼Ð¾ ÑƒÑ…Ð²Ð°Ñ‚Ð¸Ñ‚Ðµ',0),(255645,7102,'vi','Chá»‰ ghi nháº­n',0),(255646,7102,'af','Slegs Datavaslegging',0),(255647,7102,'ro','Captura numai',0),(255648,7102,'et','LÃ¼Ã¼a ainult',0),(255649,7102,'si','Zajame le',0),(255650,7102,'ba','Menangkap hanya',0),(255651,7102,'nl','Alleen vastleggen',0),(255652,7102,'fi','Capture vain',0),(255653,7102,'no','Ta bare',0),(255654,7102,'da','Indfange kun',0),(255655,7102,'ko','ë§Œ ìº¡ì²˜',0),(255656,7102,'he','×œ×›×™×“×ª ×‘×œ×‘×“',0),(255657,7102,'el','Î£Ï…Î»Î»Î¬Î²ÎµÎ¹ Î¼ÏŒÎ½Î¿',0),(255658,7102,'zh','ä»…æ•èŽ·\r\n',0),(255659,7102,'sv','FÃ¥nga endast',0),(255660,7102,'it','Catturare solo',0),(255661,7102,'tl','',0),(255662,7102,'th','&#3592;&#3633;&#3610;&#3652;&#3604;&#3657;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(255663,7102,'hi','à¤•à¥‡à¤µà¤² à¤ªà¤° à¤•à¤¬à¥à¤œà¤¾',0),(255664,7102,'ms','Tangkap sahaja',0),(255665,7102,'ar','Ø§Ù„ØªÙ‚Ø§Ø· ÙÙ‚Ø·',0),(255666,7102,'fr','Capturer seulement',0),(255667,7102,'jp','ã®ã¿ã®å–ã‚Šè¾¼ã¿',0),(255668,7102,'pt','Capturar apenas',0),(255669,7102,'ru','Ð—Ð°Ð¿Ð¸ÑÑ‹Ð²Ð°Ð¹Ñ‚Ðµ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(255670,7102,'es','Capturar Solo',0),(255671,7102,'de','Nur erfassen',0),(255672,7102,'en','Capture Only',0),(255673,7103,'is','',0),(255674,7103,'dr','.',0),(255675,7103,'pr','ØªØ§Ø±ÙŠØ® Ø§Ù†Ù‚Ø¶Ø§ÙŠ ÙƒØ§Ø±Øª ÙØ§Ù‚Ø¯ Ø§Ø¹ØªØ¨Ø§Ø± Ø§Ø³Øª.',0),(255676,7103,'tr','KartÄ± son kullanma tarihi geÃ§ersiz.',0),(255677,7103,'pl','Data waÅ¼noÅ›ci karty jest nieprawidÅ‚owy',0),(255678,7103,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°Ñ‚Ð° Ðµ Ð½ÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½',0),(255679,7103,'ur','Ú©Ø§Ø±Úˆ Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ù†Ø§Ø¬Ø§Ø¦Ø² ÛÛ’ Û”',0),(255680,7103,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÑÑ‚Ð°Ð½ÐºÐ° Ð²Ð°Ð¶ÐµÑšÐ° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð¸',0),(255681,7103,'vi','NgÃ y háº¿t háº¡n tháº» vÃ´ hiá»‡u',0),(255682,7103,'af','Kaart Vervaldatum is Ongeldig',0),(255683,7103,'ro','Data de expirare a cardului este nevalidÄƒ',0),(255684,7103,'et','Kaardi aegumiskuupÃ¤ev on vigane',0),(255685,7103,'si','Datum veljavnosti kartice je neveljaven',0),(255686,7103,'ba','Tanggal kadaluarsa kartu adalah valid',0),(255687,7103,'nl','Vervaldatum van de kaart is ongeldig',0),(255688,7103,'fi','Kortin vanhentumispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ ei kelpaa',0),(255689,7103,'no','Kortet utlÃ¸psdatoen er ugyldig',0),(255690,7103,'da','Kortet udlÃ¸bsdatoen er ugyldig',0),(255691,7103,'ko','ì¹´ë“œ ë§Œë£Œ ë‚ ì§œëŠ” ìœ íš¨ í•˜ì§€ ì•ŠìŒ',0),(255692,7103,'he','×ª××¨×™×š ×ª×¤×•×’×ª ×”×›×¨×˜×™×¡ ××™× ×• ×—×•×§×™',0),(255693,7103,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ·',0),(255694,7103,'zh','å¡çš„åˆ°æœŸæ—¥æœŸæ˜¯æ— æ•ˆçš„\r\n',0),(255695,7103,'sv','Kort utgÃ¥ngsdatum Ã¤r ogiltig',0),(255696,7103,'it','Data di scadenza carta Ã¨ invalido',0),(255697,7103,'tl','',0),(255698,7103,'th','&#3623;&#3633;&#3609;&#3627;&#3617;&#3604;&#3629;&#3634;&#3618;&#3640;&#3610;&#3633;&#3605;&#3619;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(255699,7103,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤¹à¥ˆ',0),(255700,7103,'ms','Kad tarikh luput adalah tidak sah',0),(255701,7103,'ar','Ù‡Ùˆ \"ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ ØµÙ„Ø§Ø­ÙŠØ©\" Ø¨Ø·Ø§Ù‚Ø© ØµØ§Ù„Ø­Ø©',0),(255702,7103,'fr','Date d\'Expiration de carte est invalide',0),(255703,7103,'jp','ã‚«ãƒ¼ãƒ‰ã®æœ‰åŠ¹æœŸé™ãŒç„¡åŠ¹ã§ã™ã€‚',0),(255704,7103,'pt','Data de expiraÃ§Ã£o do cartÃ£o Ã© invÃ¡lido',0),(255705,7103,'ru','Ð¡Ñ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐºÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐ¸ â€” Ð¸Ð½Ð²Ð°Ð»Ð¸Ð´',0),(255706,7103,'es','Tarjeta Fecha de Vencimiento es InvÃ¡lida',0),(255707,7103,'de','Ablaufdatum der Karte ist ungÃ¼ltig',0),(255708,7103,'en','Card Expiration Date is Invalid',0),(255709,7104,'is','',0),(255710,7104,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø±Øª Ø¨Ù‡ Ø±Ø³Ù…ÙŠØª Ø´Ù†Ø§Ø®ØªÙ‡ Ù†Ø´Ø¯',0),(255711,7104,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø±Øª Ø¨Ù‡ Ø±Ø³Ù…ÙŠØª Ø´Ù†Ø§Ø®ØªÙ‡ Ù†Ø´Ø¯',0),(255712,7104,'tr','Kart tÃ¼rÃ¼ tanÄ±nmadÄ±',0),(255713,7104,'pl','Typ karty nie rozpoznany',0),(255714,7104,'bg','Ð¢Ð¸Ð¿ÑŠÑ‚ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°Ñ‚Ð° Ð½Ðµ ÑÐµ Ñ€Ð°Ð·Ð¿Ð¾Ð·Ð½Ð°Ð²Ð°',0),(255715,7104,'ur','Ú©Ø§Ø±Úˆ Ú©ÛŒ Ù‚Ø³Ù… Ù†ÛÛŒÚº Ù¾ÛÚ†Ø§Ù†Ø§',0),(255716,7104,'sr','Ð¢Ð¸Ð¿ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€ÐµÐ¿Ð¾Ð·Ð½Ð°Ñ‚',0),(255717,7104,'vi','KhÃ´ng nháº­n ra loáº¡i tháº»',0),(255718,7104,'af','Kaart Tipe Nie Herken',0),(255719,7104,'ro','Tipul de card nu este recunoscut',0),(255720,7104,'et','Kaardi tÃ¼Ã¼pi ei tuntud Ã¤ra',0),(255721,7104,'si','Vrsta kartice ni mogoÄe prepoznati',0),(255722,7104,'ba','Jenis kartu yang tidak diakui',0),(255723,7104,'nl','Kaarttype niet herkend',0),(255724,7104,'fi','Tuntematon korttityyppi',0),(255725,7104,'no','Korttype gjenkjennes ikke',0),(255726,7104,'da','Korttype ikke genkendt',0),(255727,7104,'ko','ì¸ì‹ ë˜ì§€ ì•ŠëŠ” ì¹´ë“œ ì¢…ë¥˜',0),(255728,7104,'he','×¡×•×’ ×”×›×¨×˜×™×¡ ××™× ×• ×ž×–×•×”×”',0),(255729,7104,'el','Î¤ÏÏ€Î¿Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ Î´ÎµÎ½ Î±Î½Î±Î³Î½Ï‰ÏÎ¯Î¶ÎµÏ„Î±Î¹',0),(255730,7104,'zh','å¡ç±»åž‹æ— æ³•è¯†åˆ«\r\n',0),(255731,7104,'sv','Korttyp inte igen',0),(255732,7104,'it','Tipo di carta non riconosciuta',0),(255733,7104,'tl','',0),(255734,7104,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3610;&#3633;&#3605;&#3619;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;',0),(255735,7104,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¤¹à¤šà¤¾à¤¨à¤¾ à¤¨à¤¹à¥€à¤‚ à¤—à¤¯à¤¾',0),(255736,7104,'ms','Jenis kad yang tidak diiktiraf',0),(255737,7104,'ar','Ù†ÙˆØ¹ Ø¨Ø·Ø§Ù‚Ø© ØºÙŠØ± Ù…Ø¹ØªØ±Ù Ø¨Ù‡Ø§',0),(255738,7104,'fr','Type de carte non reconnu',0),(255739,7104,'jp','ã‚«ãƒ¼ãƒ‰ã®ç¨®é¡žã‚’èªè­˜ã§ãã¾ã›ã‚“ã€‚',0),(255740,7104,'pt','Tipo de cartÃ£o nÃ£o reconhecido',0),(255741,7104,'ru','Ð¢Ð¸Ð¿ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð½Ðµ Ð¿Ñ€Ð¸Ð·Ð½Ð°ÑŽÑ‚ÑÑ',0),(255742,7104,'es','No se Reconoce el Tipo de Tarjeta',0),(255743,7104,'de','Kartentyp nicht erkannt',0),(255744,7104,'en','Card Type Not Recognized',0),(255745,7105,'is','',0),(255746,7105,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(255747,7105,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(255748,7105,'tr','Reddedildi',0),(255749,7105,'pl','Odmowa',0),(255750,7105,'bg','ÐžÑ‚ÐºÐ°Ð·Ð°Ð½ Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(255751,7105,'ur','Ú©ÛŒ ØªØ±Ø¯ÛŒØ¯ Ú©ÛŒ',0),(255752,7105,'sr','ÐžÐ´Ð±Ð¸Ñ˜ÐµÐ½',0),(255753,7105,'vi','Bá»‹ tá»« chá»‘i',0),(255754,7105,'af','Verbied',0),(255755,7105,'ro','Negat',0),(255756,7105,'et','Keelatud',0),(255757,7105,'si','Zavrnjen',0),(255758,7105,'ba','Ditolak',0),(255759,7105,'nl','Geweigerd',0),(255760,7105,'fi','Estetty',0),(255761,7105,'no','AvslÃ¥tt',0),(255762,7105,'da','NÃ¦gtet',0),(255763,7105,'ko','ê±°ë¶€',0),(255764,7105,'he','× ×“×—×ª×”',0),(255765,7105,'el','Î”ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î·',0),(255766,7105,'zh','è¢«æ‹’ç»\r\n',0),(255767,7105,'sv','Nekad',0),(255768,7105,'it','Negato',0),(255769,7105,'tl','',0),(255770,7105,'th','&#3606;&#3641;&#3585;&#3611;&#3599;&#3636;&#3648;&#3626;&#3608;',0),(255771,7105,'hi','à¤¨à¤¿à¤·à¥‡à¤§',0),(255772,7105,'ms','Ditolak',0),(255773,7105,'ar','Ø±ÙØ¶',0),(255774,7105,'fr','RefusÃ©',0),(255775,7105,'jp','æ‹’å¦',0),(255776,7105,'pt','Negado',0),(255777,7105,'ru','ÐžÑ‚ÐºÐ°Ð·Ð°Ð½Ð¾',0),(255778,7105,'es','Negado',0),(255779,7105,'de','Verweigert',0),(255780,7105,'en','Denied',0),(255781,7106,'is','',0),(255782,7106,'dr','Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ',0),(255783,7106,'pr','Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ',0),(255784,7106,'tr','Yeni hesap iÃ§in',0),(255785,7106,'pl','Nowe konto',0),(255786,7106,'bg','ÐÐ¾Ð² Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð·Ð°',0),(255787,7106,'ur','Ù†ÛŒØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù„ÛŒÛ’',0),(255788,7106,'sr','ÐÐ¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð°',0),(255789,7106,'vi','TK Má»›i cho',0),(255790,7106,'af','Nuwe Rekening Vir',0),(255791,7106,'ro','Nou cont pentru',0),(255792,7106,'et','Uus konto:',0),(255793,7106,'si','Nov raÄun za',0),(255794,7106,'ba','Account baru untuk',0),(255795,7106,'nl','Nieuwe Account',0),(255796,7106,'fi','Uuden tilin',0),(255797,7106,'no','Ny',0),(255798,7106,'da','Ny beretning For',0),(255799,7106,'ko','ìƒˆ ê³„ì •ì— ëŒ€ í•œ',0),(255800,7106,'he','×ž×—×©×‘×•×Ÿ ×—×“×©',0),(255801,7106,'el','ÎÎ­Î¿Ï‚ Î›Î¿Î³',0),(255802,7106,'zh','æ–°å¸æˆ·\r\n',0),(255803,7106,'sv','Nytt konto fÃ¶r',0),(255804,7106,'it','Nuovo Account per',0),(255805,7106,'tl','',0),(255806,7106,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3651;&#3627;&#3617;&#3656;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(255807,7106,'hi','à¤¨à¤ à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(255808,7106,'ms','Akaun baru bagi',0),(255809,7106,'ar','Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯',0),(255810,7106,'fr','Nouveau compte pour',0),(255811,7106,'jp','æ–°ã—ã„ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(255812,7106,'pt','Nova conta para',0),(255813,7106,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐŸÑ€Ð¾Ñ„Ð¸Ð»ÑŒ Ð”Ð»Ñ',0),(255814,7106,'es','Nueva Cuenta para',0),(255815,7106,'de','Neues Konto fÃ¼r',0),(255816,7106,'en','New Account For',0),(255817,7107,'is','',0),(255818,7107,'dr','ÙƒÙ†ØªØ±Ù„ Ø§Ø®ØªÙŠØ§Ø±Øª Ù‚Ø¨Ù„ÙŠ',0),(255819,7107,'pr','ÙƒÙ†ØªØ±Ù„ Ø§Ø®ØªÙŠØ§Ø±Øª Ù‚Ø¨Ù„ÙŠ',0),(255820,7107,'tr','Ã–nceden yakalama',0),(255821,7107,'pl','Uprzednie przechwytywania',0),(255822,7107,'bg','Ð¡Ð½ÐµÐ¼Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ',0),(255823,7107,'ur','Ù¾ÛŒØ´Ú¯ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛÙ†Ø¯Ú¯ÛŒ Ú©ÛŒ Ú¯Ø±ÙØªØ§Ø±ÛŒ',0),(255824,7107,'sr','Ð¥Ð²Ð°Ñ‚Ð°ÑšÐµ Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ñƒ Ð°ÑƒÑ‚Ð¾Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(255825,7107,'vi','Ghi nháº­n quyá»n trÆ°á»›c',0),(255826,7107,'af','Vorige Magtiging vir Datavaslegging.',0),(255827,7107,'ro','AutorizaÈ›ia prealabilÄƒ de captare',0),(255828,7107,'et','Eelloa hÃµive',0),(255829,7107,'si','Predhodno dovoljenje zajem',0),(255830,7107,'ba','Menangkap otorisasi',0),(255831,7107,'nl','Voorafgaande toestemming Capture',0),(255832,7107,'fi','Ennakkolupa kaapata',0),(255833,7107,'no','Godkjenning pÃ¥ forhÃ¥nd fange',0),(255834,7107,'da','ForhÃ¥ndsbevillingen opsamling',0),(255835,7107,'ko','ì‚¬ì „ ìŠ¹ì¸ ìº¡ì²˜',0),(255836,7107,'he','×œ×›×™×“×ª ××™×©×•×¨ ×ž×¨××©',0),(255837,7107,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Î¬Î´ÎµÎ¹Î± ÏƒÏÎ»Î»Î·ÏˆÎ·',0),(255838,7107,'zh','ä¼˜å…ˆæŽˆæƒæ•æ‰\r\n',0),(255839,7107,'sv','FÃ¶rhandstillstÃ¥nd Capture',0),(255840,7107,'it','Acquisizione di autorizzazione preventiva',0),(255841,7107,'tl','',0),(255842,7107,'th','&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3648;&#3585;&#3655;&#3610;&#3616;&#3634;&#3614;&#3607;&#3637;&#3656;&#3617;&#3637;&#3617;&#3634;&#3585;&#3656;&#3629;&#3609;\n',0),(255843,7107,'hi','à¤ªà¤¹à¤²à¥‡ à¤ªà¥à¤°à¤¾à¤§à¤¿à¤•à¤°à¤£ à¤ªà¤° à¤•à¤¬à¥à¤œà¤¾',0),(255844,7107,'ms','Tangkap kebenaran terlebih dahulu',0),(255845,7107,'ar','Ø§Ù„Ù‚Ø¨Ø¶ Ø¹Ù„Ù‰ Ø¥Ø°Ù† Ù…Ø³Ø¨Ù‚',0),(255846,7107,'fr','Capture d\'une autorisation prÃ©alable',0),(255847,7107,'jp','äº‹å‰æ‰¿èªã®ã‚­ãƒ£ãƒ—ãƒãƒ£',0),(255848,7107,'pt','Captura de autorizaÃ§Ã£o prÃ©via',0),(255849,7107,'ru','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð·Ð°Ñ…Ð²Ð°Ñ‚Ð°',0),(255850,7107,'es','Captura de AutorizaciÃ³n Previa',0),(255851,7107,'de','Vorherige Genehmigung Capture',0),(255852,7107,'en','Prior Authorization Capture',0),(255853,7108,'is','',0),(255854,7108,'dr','Ø­Ø±Ø§Ø¬',0),(255855,7108,'pr','Ø­Ø±Ø§Ø¬',0),(255856,7108,'tr','SatÄ±lÄ±k',0),(255857,7108,'pl','Sprzedam',0),(255858,7108,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(255859,7108,'ur','ÙØ±ÙˆØ®Øª',0),(255860,7108,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð°',0),(255861,7108,'vi','BÃ¡n hÃ ng',0),(255862,7108,'af','Verkope',0),(255863,7108,'ro','Vanzare',0),(255864,7108,'et','MÃ¼Ã¼k',0),(255865,7108,'si','Prodajo',0),(255866,7108,'ba','Dijual',0),(255867,7108,'nl','Verkoop',0),(255868,7108,'fi','MyytÃ¤vÃ¤nÃ¤',0),(255869,7108,'no','Salg',0),(255870,7108,'da','Salg',0),(255871,7108,'ko','íŒë§¤',0),(255872,7108,'he','×ž×›×™×¨×”',0),(255873,7108,'el','Î ÏŽÎ»Î·ÏƒÎ·',0),(255874,7108,'zh','é”€å”®\r\n',0),(255875,7108,'sv','FÃ¶rsÃ¤ljning',0),(255876,7108,'it','Vendita',0),(255877,7108,'tl','',0),(255878,7108,'th','&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(255879,7108,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€',0),(255880,7108,'ms','Jualan',0),(255881,7108,'ar','Ø¨ÙŠØ¹',0),(255882,7108,'fr','Vente',0),(255883,7108,'jp','è²©å£²',0),(255884,7108,'pt','Venda',0),(255885,7108,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð°',0),(255886,7108,'es','Venta',0),(255887,7108,'de','Verkauf',0),(255888,7108,'en','Sale',0),(255889,7109,'is','',0),(255890,7109,'dr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(255891,7109,'pr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(255892,7109,'tr','Void Trans',0),(255893,7109,'pl','NiewaÅ¼ne Trans',0),(255894,7109,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ Ñ‚Ñ€Ð°Ð½Ñ',0),(255895,7109,'ur','Ø¨Ø±Ø¨Ø§Ø¯ Ù¹Ø±Ø§Ù†Ø³',0),(255896,7109,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ð¢Ñ€Ð°Ð½Ñ',0),(255897,7109,'vi','Há»§y giao dá»‹ch',0),(255898,7109,'af','Leemte Trans',0),(255899,7109,'ro','Nule Trans',0),(255900,7109,'et','Void Trans',0),(255901,7109,'si','Neveljavne Trans',0),(255902,7109,'ba','Membatalkan Trans',0),(255903,7109,'nl','VOID Trans',0),(255904,7109,'fi','MitÃ¤tÃ¶n Trans',0),(255905,7109,'no','Ugyldig Trans',0),(255906,7109,'da','Ugyldig Trans',0),(255907,7109,'ko','Void íŠ¸ëžœìŠ¤',0),(255908,7109,'he','×˜×¨× ×¡ void',0),(255909,7109,'el','Î‘ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Î¤Î¡Î‘ÎÎ£',0),(255910,7109,'zh','ä½œåºŸäº¤æ˜“\r\n',0),(255911,7109,'sv','Void Trans',0),(255912,7109,'it','Void Trans',0),(255913,7109,'tl','',0),(255914,7109,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(255915,7109,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤Ÿà¥à¤°à¤¾à¤‚à¤¸',0),(255916,7109,'ms','Trans tidak sah',0),(255917,7109,'ar','ØªØ±Ø§Ù†Ø³ Ø¨Ø§Ø·Ù„Ø©',0),(255918,7109,'fr','Sub Trans',0),(255919,7109,'jp','Void ãƒˆãƒ©ãƒ³ã‚¹',0),(255920,7109,'pt','Void Trans',0),(255921,7109,'ru','Void Ñ‚Ñ€Ð°Ð½Ñ',0),(255922,7109,'es','Anular TranacciÃ³n ',0),(255923,7109,'de','Void Trans',0),(255924,7109,'en','Void Trans',0),(255925,7110,'is','',0),(255926,7110,'dr','! Ù¾Ø§Ø±Ø§Ø²ÙŠØª Ù¾ÙŠØºØ§Ù… Ø¯ÙŠØ¬ÙŠØªØ§Ù„ 5 Ø¨Ø§ Ø§Ø¬Ø§Ø²Ù‡ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯  ',0),(255927,7110,'pr','Ø§Ø®Ø·Ø§Ø± Ø§Ù…Ù†ÙŠØª ! Ù¾Ø§Ø±Ø§Ø²ÙŠØª Ù¾ÙŠØºØ§Ù… Ø¯ÙŠØ¬ÙŠØªØ§Ù„ 5 Ø¨Ø§ Ø§Ø¬Ø§Ø²Ù‡ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯  ',0),(255928,7110,'tr','GÃ¼venlik UyarÄ±sÄ±! MD5 Karma deÄŸerden Authorize eÅŸleÅŸmiyor',0),(255929,7110,'pl','OstrzeÅ¼enie o zabezpieczeniach! MD5 Hash z Autoryzuj nie pasuje',0),(255930,7110,'bg','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð° Ð·Ð°Ñ‰Ð¸Ñ‚Ð°! MD5 Ð¥ÐµÑˆ Ð¾Ñ‚ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÑ‚Ðµ Ð½Ðµ ÑÑŠÐ²Ð¿Ð°Ð´Ð°',0),(255931,7110,'ur','Ø³Ù„Ø§Ù…ØªÛŒ ØªÙ†Ø¨ÛŒÛ! MD5 ÛÛŒØ´ Authorize Ø³Û’ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº',0),(255932,7110,'sr','Ð‘ÐµÐ·Ð±ÐµÐ´Ð½Ð¾ÑÐ½Ð¾ ÑƒÐ¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ! ÐœÐ”5 Ð¥Ð°ÑÑ… Ð¸Ð· ÐÑƒÑ‚Ñ…Ð¾Ñ€Ð¸Ð·Ðµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°',0),(255933,7110,'vi','Cáº£nh bÃ¡o! MD5 tá»« phÃ¢n quyá»n khÃ´ng Ä‘Ãºng',0),(255934,7110,'af','Sekuriteitswaarskuwing! MD5 \"Hash\" vanaf Matiging pas nie',0),(255935,7110,'ro','Avertisment de securitate! MD5 Hash de autorizare nu se potriveÅŸte',0),(255936,7110,'et','Security Warning! MD5 RÃ¤si Authorize ei sobi',0),(255937,7110,'si','Varnostno opozorilo! MD5 HaÅ¡e iz pooblasti se ne ujema',0),(255938,7110,'ba','Peringatan keamanan! MD5 Hash dari Authorize tidak cocok',0),(255939,7110,'nl','Beveiligingswaarschuwing! MD5 Hash van machtigen komt niet overeen met',0),(255940,7110,'fi','Turvallisuus varoitus! MD5 Hash alkaen Valtuuta ei vastaa',0),(255941,7110,'no','Advarsel! MD5 Hash fra Godkjenn samsvarer ikke',0),(255942,7110,'da','Sikkerhedsadvarsel! MD5 Hash fra Authorize stemmer ikke overens',0),(255943,7110,'ko','ë³´ì•ˆ ê²½ê³ ! MD5 ì¸ì¦ì—ì„œ í•´ì‹œì™€ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(255944,7110,'he','××–×”×¨×ª ××‘×˜×—×”! MD5 Hash ×©×œ ×œ×ž×•×¢×“×™× ××™× ×• ×ª×•××',0),(255945,7110,'el','Î ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚! MD5 Hash Î±Ï€ÏŒ ÎµÎ¾Î¿Ï…ÏƒÎ¹Î¿Î´ÏŒÏ„Î·ÏƒÎ· Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹',0),(255946,7110,'zh','å®‰å…¨è­¦å‘Šï¼ æŽˆæƒçš„MD5çš„æ‚é¡¹ä¿¡æ¯ä¸Žä¸åŒ¹é…\r\n',0),(255947,7110,'sv','SÃ¤kerhetsvarning! MD5 Hash frÃ¥n auktorisera matchar inte',0),(255948,7110,'it','Avviso di sicurezza! MD5 Hash da autorizzare non corrisponde',0),(255949,7110,'tl','',0),(255950,7110,'th','Security Warning! MD5 Hash From Authorize Does Not Match',0),(255951,7110,'hi','à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤šà¥‡à¤¤à¤¾à¤µà¤¨à¥€! MD5 à¤¹à¥ˆà¤¶ à¤…à¤§à¤¿à¤•à¥ƒà¤¤ à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€ à¤¹à¥ˆ',0),(255952,7110,'ms','Amaran Keselamatan! MD5 Hash daripada Authorize tidak sepadan dengan',0),(255953,7110,'ar','ØªØ­Ø°ÙŠØ± Ø£Ù…Ø§Ù†! MD5 Ù„Ø§ ØªØ·Ø§Ø¨Ù‚ ØªØ¬Ø²Ø¦Ø© Ù…Ù† ØªØ®ÙˆÙŠÙ„',0),(255954,7110,'fr','Avertissement de sÃ©curitÃ© ! MD5 Hash d\'autoriser ne correspond pas',0),(255955,7110,'jp','ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£ã®è­¦å‘Š ï¼MD5 èªè¨¼ã‹ã‚‰ãƒãƒƒã‚·ãƒ¥ã¨ä¸€è‡´ã—ã¾ã›ã‚“',0),(255956,7110,'pt','Aviso de seguranÃ§a! MD5 Hash de autorizar nÃ£o coincide',0),(255957,7110,'ru','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹ Ð±ÐµÐ·Ð¾Ð¿Ð°ÑÐ½Ð¾ÑÑ‚Ð¸! MD5 Ð¥ÑÑˆ Ð¾Ñ‚ Ð°Ð²Ñ‚Ð¾Ñ€Ð¸Ð·Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ðµ ÑÐ¾Ð²Ð¿Ð°Ð´Ð°ÐµÑ‚',0),(255958,7110,'es','Aviso de Seguridad! MD5 Hash De Autorizar No Empareja',0),(255959,7110,'de','Sicherheitswarnung! MD5 Hash aus autorisieren stimmt nicht Ã¼berein.',0),(255960,7110,'en','Security Warning! MD5 Hash From Authorize Does Not Match',0),(255961,7111,'is','',0),(255962,7111,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ ',0),(255963,7111,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ ',0),(255964,7111,'tr','HesaplarÄ±',0),(255965,7111,'pl','Konta',0),(255966,7111,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸',0),(255967,7111,'ur','Ú©Ú¾Ø§ØªÛ’',0),(255968,7111,'sr','ÐÐ°Ð»Ð¾Ð·Ð¸',0),(255969,7111,'vi','TK',0),(255970,7111,'af','Rekeninge',0),(255971,7111,'ro','Conturi',0),(255972,7111,'et','Kontod',0),(255973,7111,'si','RaÄunov',0),(255974,7111,'ba','Akun-akun',0),(255975,7111,'nl','Rekeningen',0),(255976,7111,'fi','Tilit',0),(255977,7111,'no','Kontoer',0),(255978,7111,'da','Konti',0),(255979,7111,'ko','ê³„ì •',0),(255980,7111,'he','×—×©×‘×•× ×•×ª',0),(255981,7111,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(255982,7111,'zh','å¸æˆ·',0),(255983,7111,'sv','Konton',0),(255984,7111,'it','Conti',0),(255985,7111,'tl','',0),(255986,7111,'th','à¸šà¸±à¸à¸Šà¸µ',0),(255987,7111,'hi','à¤—à¥‚à¤—à¤² à¤–à¤¾à¤¤',0),(255988,7111,'ms','Akaun-akaun',0),(255989,7111,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(255990,7111,'fr','Comptes',0),(255991,7111,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(255992,7111,'pt','Contas',0),(255993,7111,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(255994,7111,'es','Cuentas',0),(255995,7111,'de','Konten',0),(255996,7111,'en','Accounts',0),(255997,7112,'is','',0),(255998,7112,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ ',0),(255999,7112,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ ',0),(256000,7112,'tr','Yeni hesap ekle',0),(256001,7112,'pl','Dodaj nowe konto',0),(256002,7112,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(256003,7112,'ur','Ù†ÛŒØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(256004,7112,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(256005,7112,'vi','ThÃªm TK Má»›i',0),(256006,7112,'af','Nuwe Rekening Byvoeg',0),(256007,7112,'ro','Adauga Cont nou',0),(256008,7112,'et','Lisa uus konto',0),(256009,7112,'si','Dodaj nov raÄun',0),(256010,7112,'ba','Tambahkan akun baru',0),(256011,7112,'nl','Nieuwe Account toevoegen',0),(256012,7112,'fi','LisÃ¤Ã¤ uusi tili',0),(256013,7112,'no','Legge til ny konto',0),(256014,7112,'da','TilfÃ¸j ny konto',0),(256015,7112,'ko','ìƒˆ ê³„ì • ì¶”ê°€',0),(256016,7112,'he','×”×•×¡×£ ×—×©×‘×•×Ÿ ×—×“×©',0),(256017,7112,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(256018,7112,'zh','å¢žåŠ æ–°å¸æˆ·\r\n',0),(256019,7112,'sv','LÃ¤gg till nytt konto',0),(256020,7112,'it','Aggiungi nuovo Account',0),(256021,7112,'tl','',0),(256022,7112,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(256023,7112,'hi','à¤¨à¤¯à¤¾ à¤–à¤¾à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(256024,7112,'ms','Tambah akaun baru',0),(256025,7112,'ar','Ø£Ø¶Ù Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯',0),(256026,7112,'fr','Ajouter Nouvelle Compte',0),(256027,7112,'jp','æ–°ã—ã„ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(256028,7112,'pt','Adicionar nova conta',0),(256029,7112,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(256030,7112,'es','Agregar Nueva Cuenta',0),(256031,7112,'de','Neues Konto hinzufÃ¼gen',0),(256032,7112,'en','Add New Account',0),(256033,7113,'is','',0),(256034,7113,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´Ú¯Ø±Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯',0),(256035,7113,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´Ú¯Ø±Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯',0),(256036,7113,'tr','KullanÄ±labilir iÅŸlemci',0),(256037,7113,'pl','DostÄ™pne procesory',0),(256038,7113,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€Ð¸',0),(256039,7113,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ Ù¾Ø±ÙˆØ³ÛŒØ³Ø±Ø²',0),(256040,7113,'sr','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€Ðµ',0),(256041,7113,'vi','Bá»™ Xá»­ LÃ½ CÃ³ Sáºµn',0),(256042,7113,'af','Beskikbare Prosesseerders',0),(256043,7113,'ro','Procesoare disponibile',0),(256044,7113,'et','Saadaval protsessorid',0),(256045,7113,'si','Na voljo procesorji',0),(256046,7113,'ba','Tersedia prosesor',0),(256047,7113,'nl','Beschikbare Processors',0),(256048,7113,'fi','KÃ¤ytettÃ¤vissÃ¤ prosessorit',0),(256049,7113,'no','Tilgjengelige prosessorer',0),(256050,7113,'da','TilgÃ¦ngelige processorer',0),(256051,7113,'ko','ì‚¬ìš© ê°€ëŠ¥í•œ í”„ë¡œì„¸ì„œ',0),(256052,7113,'he','×ž×¢×‘×“×™× ×”×–×ž×™× ×™×',0),(256053,7113,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î­Ï‚',0),(256054,7113,'zh','å¯ç”¨çš„å¤„ç†å™¨\r\n',0),(256055,7113,'sv','TillgÃ¤ngliga processorer',0),(256056,7113,'it','Processori disponibili',0),(256057,7113,'tl','',0),(256058,7113,'th','&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;',0),(256059,7113,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤°',0),(256060,7113,'ms','Pemproses yang disediakan',0),(256061,7113,'ar','Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬Ø§Øª Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(256062,7113,'fr','Processeurs disponibles',0),(256063,7113,'jp','ä½¿ç”¨å¯èƒ½ãªãƒ—ãƒ­ã‚»ãƒƒã‚µ',0),(256064,7113,'pt','Processadores disponÃ­veis',0),(256065,7113,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€Ñ‹',0),(256066,7113,'es','Procesadores Disponibles',0),(256067,7113,'de','VerfÃ¼gbaren Prozessoren',0),(256068,7113,'en','Available Processors',0),(256069,7114,'is','',0),(256070,7114,'dr','AVS Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ú©ÙˆØ¯ ÙØ±ÙˆØ´',0),(256071,7114,'pr','AVS Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† ÙƒØ¯ ÙØ±ÙˆØ´',0),(256072,7114,'tr','AVS ÅŸifre',0),(256073,7114,'pl','AV kodu',0),(256074,7114,'bg','AVS ÐºÐ¾Ð´',0),(256075,7114,'ur','Ø§ÙˆØ³ Ú©ÙˆÚˆ',0),(256076,7114,'sr','ÐÐ’Ð¡ Ð¨Ð¸Ñ„Ñ€Ð°',0),(256077,7114,'vi','MÃ£ Sá»‘ AVS',0),(256078,7114,'af','AVS kode',0),(256079,7114,'ro','AVS cod',0),(256080,7114,'et','AVS kood',0),(256081,7114,'si','AVS kodo',0),(256082,7114,'ba','AVS kode',0),(256083,7114,'nl','AVS code',0),(256084,7114,'fi','AVS koodi',0),(256085,7114,'no','AVS kode',0),(256086,7114,'da','AVS kode',0),(256087,7114,'ko','AVS ì½”ë“œ',0),(256088,7114,'he','×§×•×“ AVS',0),(256089,7114,'el','AVS ÎºÏŽÎ´Î¹ÎºÎ±',0),(256090,7114,'zh','åº”ç”¨ç¨‹åºå¯è§†åŒ–æ ¼å¼çš„ä»£ç \r\n',0),(256091,7114,'sv','AVS-kod',0),(256092,7114,'it','Codice AVS',0),(256093,7114,'tl','',0),(256094,7114,'th','&#3619;&#3627;&#3633;&#3626; AVS',0),(256095,7114,'hi','AVS à¤•à¥‹à¤¡',0),(256096,7114,'ms','AVS kod',0),(256097,7114,'ar','Ø±Ù…Ø² Ø§Ù„Ù‡Ù„Ø§Ù„',0),(256098,7114,'fr','Code de l\'AVS',0),(256099,7114,'jp','AVS ã®ã‚³ãƒ¼ãƒ‰',0),(256100,7114,'pt','CÃ³digo AVS',0),(256101,7114,'ru','AVS ÐºÐ¾Ð´',0),(256102,7114,'es','CÃ³digo AVS',0),(256103,7114,'de','AVS-code',0),(256104,7114,'en','AVS code',0),(256105,7115,'is','',0),(256106,7115,'dr','B2B ÛŒÙˆØ²Ø± ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(256107,7115,'pr','B2B ÙƒØ§Ø±Ø¨Ø± ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(256108,7115,'tr','B2B kullanÄ±cÄ±',0),(256109,7115,'pl','UÅ¼ytkownik B2B',0),(256110,7115,'bg','B2B Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(256111,7115,'ur','B2B ØµØ§Ø±Ù',0),(256112,7115,'sr','Ð‘2Ð‘ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(256113,7115,'vi','NgÆ°á»i Sá»­ Dá»¥ng B2B',0),(256114,7115,'af','B2B Gebruiker',0),(256115,7115,'ro','Utilizator B2B',0),(256116,7115,'et','B2B kasutaja',0),(256117,7115,'si','B2B uporabnika',0),(256118,7115,'ba','B2B pengguna',0),(256119,7115,'nl','B2B gebruiker',0),(256120,7115,'fi','B2B kÃ¤yttÃ¤jÃ¤',0),(256121,7115,'no','B2B bruker',0),(256122,7115,'da','B2B bruger',0),(256123,7115,'ko','B2B ì‚¬ìš©ìž',0),(256124,7115,'he','×”×ž×©×ª×ž×© B2B',0),(256125,7115,'el','B2B Ï‡ÏÎ®ÏƒÏ„Î·',0),(256126,7115,'zh','å•†ä¸šå¯¹å•†ä¸šçš„ç”¨æˆ·\r\n',0),(256127,7115,'sv','B2B anvÃ¤ndare',0),(256128,7115,'it','Utente azienda B2B',0),(256129,7115,'tl','',0),(256130,7115,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657; B2B',0),(256131,7115,'hi','B2B à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(256132,7115,'ms','Pengguna B2B',0),(256133,7115,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… - Ø´Ø±ÙƒØ§Ø¡ Ø§Ù„ØªØ¹Ø§Ù…Ù„',0),(256134,7115,'fr','Utilisateur B2B',0),(256135,7115,'jp','B2B ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(256136,7115,'pt','UsuÃ¡rio de B2B',0),(256137,7115,'ru','B2B ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ',0),(256138,7115,'es','N2N usuario',0),(256139,7115,'de','B2B Benutzer',0),(256140,7115,'en','B2B User',0),(256141,7116,'is','',0),(256142,7116,'dr','ÙƒØ¯ ÙƒØ§Ø±Øª',0),(256143,7116,'pr','ÙƒØ¯ ÙƒØ§Ø±Øª',0),(256144,7116,'tr','Kart kodu',0),(256145,7116,'pl','Kod karty',0),(256146,7116,'bg','ÐšÐ¾Ð´ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°Ñ‚Ð°',0),(256147,7116,'ur','Ú©Ø§Ø±Úˆ Ú©ÙˆÚˆ',0),(256148,7116,'sr','Ð¨Ð¸Ñ„Ñ€Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(256149,7116,'vi','MÃ£ tháº»',0),(256150,7116,'af','Kaart Kode',0),(256151,7116,'ro','Cardul cod',0),(256152,7116,'et','Kaardi kood',0),(256153,7116,'si','Kodo kartice',0),(256154,7116,'ba','Kartu kode',0),(256155,7116,'nl','Kaart-Code',0),(256156,7116,'fi','Koodi',0),(256157,7116,'no','Kort kode',0),(256158,7116,'da','Kort kode',0),(256159,7116,'ko','ì¹´ë“œ ì½”ë“œ',0),(256160,7116,'he','×›×¨×˜×™×¡ ×§×•×“',0),(256161,7116,'el','ÎšÏ‰Î´Î¹ÎºÏŒ Ï„Î·Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(256162,7116,'zh','å¡ç \r\n',0),(256163,7116,'sv','Kort kod',0),(256164,7116,'it','Codice Card',0),(256165,7116,'tl','',0),(256166,7116,'th','&#3619;&#3627;&#3633;&#3626;&#3586;&#3629;&#3591;&#3610;&#3633;&#3605;&#3619;',0),(256167,7116,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‹à¤¡',0),(256168,7116,'ms','Kod Kad',0),(256169,7116,'ar','Ø±Ù…Ø² Ø§Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(256170,7116,'fr','Code de carte',0),(256171,7116,'jp','ã‚«ãƒ¼ãƒ‰ã®ã‚³ãƒ¼ãƒ‰',0),(256172,7116,'pt','CÃ³digo do cartÃ£o',0),(256173,7116,'ru','ÐšÐ¾Ð´ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(256174,7116,'es','Tarjeta CÃ³digo',0),(256175,7116,'de','Karte Code',0),(256176,7116,'en','Card Code',0),(256177,7117,'is','',0),(256178,7117,'dr','Ø§Ù†Ù‚Ø¶Ø§ÙŠ ÙƒØ§Ø±Øª',0),(256179,7117,'pr','Ø§Ù†Ù‚Ø¶Ø§ÙŠ ÙƒØ§Ø±Øª',0),(256180,7117,'tr','Kart Exp',0),(256181,7117,'pl','Karta Exp',0),(256182,7117,'bg','ÐšÐ°Ñ€Ñ‚Ð°Ñ‚Ð° Ð“Ð¾Ð´ÐµÐ½',0),(256183,7117,'ur','Ú©Ø§Ø±Úˆ Ù¾',0),(256184,7117,'sr','ÐšÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð•xÐ¿',0),(256185,7117,'vi','NgÃ y háº¿t háº¡n tháº»',0),(256186,7117,'af','Kaart Exp',0),(256187,7117,'ro','Carte de Exp',0),(256188,7117,'et','Kaardi aegumiskuupÃ¤ev',0),(256189,7117,'si','Kartico Exp',0),(256190,7117,'ba','Kartu Exp',0),(256191,7117,'nl','Kaart Exp',0),(256192,7117,'fi','Kortin Exp',0),(256193,7117,'no','Kort Exp',0),(256194,7117,'da','Kort Exp',0),(256195,7117,'ko','ì¹´ë“œ íŠ¹ê¸‰',0),(256196,7117,'he','×›×¨×˜×™×¡ Exp',0),(256197,7117,'el','ÎšÎ¬ÏÏ„Î± Exp',0),(256198,7117,'zh','è¿›å‡ºå£å¡\r\n',0),(256199,7117,'sv','Kort Exp',0),(256200,7117,'it','Scheda Exp',0),(256201,7117,'tl','',0),(256202,7117,'th','&#3623;&#3633;&#3609;&#3627;&#3617;&#3604;&#3629;&#3634;&#3618;&#3640;&#3610;&#3633;&#3605;&#3619;',0),(256203,7117,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤à¤•à¥à¤¸à¥à¤ª',0),(256204,7117,'ms','Lumpur Kad',0),(256205,7117,'ar','Ø£ÙƒØ³Ø¨ Ø¨Ø·Ø§Ù‚Ø©',0),(256206,7117,'fr','Carte Exp',0),(256207,7117,'jp','ã‚«ãƒ¼ãƒ‰ Exp',0),(256208,7117,'pt','CartÃ£o Exp',0),(256209,7117,'ru','ÐšÐ°Ñ€Ñ‚Ð° Exp',0),(256210,7117,'es','Tarjeta Exp.',0),(256211,7117,'de','Karte Exp',0),(256212,7117,'en','Card Exp',0),(256213,7118,'is','',0),(256214,7118,'dr','Ù†Ø§Ù… ÙƒØ§Ø±Øª',0),(256215,7118,'pr','Ù†Ø§Ù… ÙƒØ§Ø±Øª',0),(256216,7118,'tr','Kart adÄ±',0),(256217,7118,'pl','Karta imiÄ™',0),(256218,7118,'bg','ÐšÐ°Ñ€Ñ‚Ð° Ð¸Ð¼Ðµ',0),(256219,7118,'ur','Ú©Ø§Ø±Úˆ Ú©Û’ Ù¾ÛÙ„Û’ Ú©Û’ Ù†Ø§Ù…',0),(256220,7118,'sr','Ð˜Ð¼Ðµ Ð¿Ñ€Ð²Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(256221,7118,'vi','TÃªn Ä‘áº§u cá»§a tháº»',0),(256222,7118,'af','Kaart Voornaam',0),(256223,7118,'ro','Numele de prima carte',0),(256224,7118,'et','Kaardil olev eesnimi',0),(256225,7118,'si','Ime kartice',0),(256226,7118,'ba','Kartu nama',0),(256227,7118,'nl','Kaart-voornaam',0),(256228,7118,'fi','Kortin ensimmÃ¤inen nimi',0),(256229,7118,'no','Kort fornavn',0),(256230,7118,'da','Kortet fornavn',0),(256231,7118,'ko','ì¹´ë“œ ì´ë¦„',0),(256232,7118,'he','×©× ×¤×¨×˜×™ ×›×¨×˜×™×¡',0),(256233,7118,'el','ÎšÎ¬ÏÏ„Î± ÏŒÎ½Î¿Î¼Î±',0),(256234,7118,'zh','å¡å¤´å\r\n',0),(256235,7118,'sv','Kort fÃ¶rnamn',0),(256236,7118,'it','Nome carta',0),(256237,7118,'tl','',0),(256238,7118,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3606;&#3639;&#3629;&#3610;&#3633;&#3605;&#3619;',0),(256239,7118,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤®',0),(256240,7118,'ms','Kad nama',0),(256241,7118,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„',0),(256242,7118,'fr','Carte prÃ©nom',0),(256243,7118,'jp','ã‚«ãƒ¼ãƒ‰å',0),(256244,7118,'pt','Nome cartÃ£o',0),(256245,7118,'ru','Ð˜Ð¼Ñ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(256246,7118,'es','Tarjeta Su Nombre (Nombres)',0),(256247,7118,'de','Karte-Vorname',0),(256248,7118,'en','Card First Name',0),(256249,7119,'is','',0),(256250,7119,'dr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ ÙƒØ§Ø±Øª',0),(256251,7119,'pr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ ÙƒØ§Ø±Øª',0),(256252,7119,'tr','Kart soyadÄ±',0),(256253,7119,'pl','Karta nazwisko',0),(256254,7119,'bg','ÐšÐ°Ñ€Ñ‚Ð° Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(256255,7119,'ur','Ú©Ø§Ø±Úˆ Ú©Û’ Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù…',0),(256256,7119,'sr','ÐšÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(256257,7119,'vi','Há» cá»§a tháº»',0),(256258,7119,'af','Kaart Van',0),(256259,7119,'ro','Numele de familie carte',0),(256260,7119,'et','Kaardil olev perekonnanimi',0),(256261,7119,'si','Priimek kartice',0),(256262,7119,'ba','Kartu nama',0),(256263,7119,'nl','Kaart-achternaam',0),(256264,7119,'fi','Kortin sukunimi',0),(256265,7119,'no','Kort etternavn',0),(256266,7119,'da','Kortet efternavn',0),(256267,7119,'ko','ì¹´ë“œ ì„±',0),(256268,7119,'he','×›×¨×˜×™×¡ ×©× ×ž×©×¤×—×”',0),(256269,7119,'el','ÎšÎ¬ÏÏ„Î± ÎµÏ€ÏŽÎ½Ï…Î¼Î¿',0),(256270,7119,'zh','å¡å§“\r\n',0),(256271,7119,'sv','Kort efternamn',0),(256272,7119,'it','Ultimo nome carta',0),(256273,7119,'tl','',0),(256274,7119,'th','&#3594;&#3639;&#3656;&#3629;&#3626;&#3585;&#3640;&#3621;&#3612;&#3641;&#3657;&#3606;&#3639;&#3629;&#3610;&#3633;&#3605;&#3619;',0),(256275,7119,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤•à¤¾ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤®',0),(256276,7119,'ms','Kad nama',0),(256277,7119,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£Ø®ÙŠØ±',0),(256278,7119,'fr','Nom de famille de carte',0),(256279,7119,'jp','ã‚«ãƒ¼ãƒ‰ã®æœ€å¾Œã®åå‰',0),(256280,7119,'pt','Ãšltimo nome do cartÃ£o',0),(256281,7119,'ru','Ð¤Ð°Ð¼Ð¸Ð»Ð¸Ñ ÐÐ° ÐšÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐµ',0),(256282,7119,'es','Tarjeta Apellido',0),(256283,7119,'de','Karte-Nachname',0),(256284,7119,'en','Card Last Name',0),(256285,7120,'is','',0),(256286,7120,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Øª',0),(256287,7120,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Øª',0),(256288,7120,'tr','Kart numarasÄ±',0),(256289,7120,'pl','Numer karty',0),(256290,7120,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°Ñ‚Ð°',0),(256291,7120,'ur','Ú©Ø§Ø±Úˆ Ù†Ù…Ø¨Ø±',0),(256292,7120,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(256293,7120,'vi','Sá»‘ tháº»',0),(256294,7120,'af','Kaar Nommer',0),(256295,7120,'ro','NumÄƒrul cardului',0),(256296,7120,'et','Kaardi number',0),(256297,7120,'si','Å tevilka kartice',0),(256298,7120,'ba','Nomor kartu',0),(256299,7120,'nl','Kaartnummer',0),(256300,7120,'fi','Kortin numero',0),(256301,7120,'no','Kortnummer',0),(256302,7120,'da','Kortnummer',0),(256303,7120,'ko','ì¹´ë“œ ë²ˆí˜¸',0),(256304,7120,'he','×ž×¡×¤×¨ ×›×¨×˜×™×¡',0),(256305,7120,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(256306,7120,'zh','èº«ä»½è¯å·ç \r\n',0),(256307,7120,'sv','Kortnummer',0),(256308,7120,'it','Numero di carta',0),(256309,7120,'tl','',0),(256310,7120,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3610;&#3633;&#3605;&#3619;',0),(256311,7120,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(256312,7120,'ms','Nombor kad',0),(256313,7120,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(256314,7120,'fr','NumÃ©ro de carte',0),(256315,7120,'jp','ã‚«ãƒ¼ãƒ‰ç•ªå·',0),(256316,7120,'pt','NÃºmero do cartÃ£o',0),(256317,7120,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐšÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(256318,7120,'es','Tarjeta NÃºmero',0),(256319,7120,'de','Kartennummer',0),(256320,7120,'en','Card Number',0),(256321,7121,'is','',0),(256322,7121,'dr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(256323,7121,'pr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(256324,7121,'tr','Kredi kartÄ± iÅŸlemleri',0),(256325,7121,'pl','Transakcje kartami kredytowymi',0),(256326,7121,'bg','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(256327,7121,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø³Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ†',0),(256328,7121,'sr','Ð¢Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°Ð¼Ð°',0),(256329,7121,'vi','Giao Dá»‹ch Tháº» TÃ­n Dá»¥ng',0),(256330,7121,'af','Kredietkaart Transaksies',0),(256331,7121,'ro','TranzacÅ£iile cu cÄƒrÅ£i de credit',0),(256332,7121,'et','Krediitkaardi tehingute',0),(256333,7121,'si','Transakcije s kreditno kartico',0),(256334,7121,'ba','Transaksi kartu kredit',0),(256335,7121,'nl','Credit Card transacties',0),(256336,7121,'fi','Luottokorttitapahtumat',0),(256337,7121,'no','Kredittkorttransaksjoner',0),(256338,7121,'da','Kreditkorttransaktioner',0),(256339,7121,'ko','ì‹ ìš© ì¹´ë“œ ê±°ëž˜',0),(256340,7121,'he','×¢×¡×§××•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(256341,7121,'el','Î£Ï…Î½Î±Î»Î»Î±Î³Î­Ï‚ Î¼Î­ÏƒÏ‰ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(256342,7121,'zh','ä¿¡ç”¨å¡äº¤æ˜“\r\n',0),(256343,7121,'sv','Kreditkortstransaktioner',0),(256344,7121,'it','Transazioni con carta di credito',0),(256345,7121,'tl','',0),(256346,7121,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(256347,7121,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨',0),(256348,7121,'ms','Transaksi kad kredit',0),(256349,7121,'ar','Ø¹Ù…Ù„ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(256350,7121,'fr','Transactions par carte de crÃ©dit',0),(256351,7121,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰å–å¼•',0),(256352,7121,'pt','TransaÃ§Ãµes com cartÃ£o de crÃ©dito',0),(256353,7121,'ru','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ð¡ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¼Ð¸ ÐšÐ°Ñ€Ñ‚Ð°Ð¼Ð¸',0),(256354,7121,'es','Tarjeta de CrÃ©dito Transacciones',0),(256355,7121,'de','Kreditkarten-Transaktionen',0),(256356,7121,'en','Credit Card Transactions',0),(256357,7122,'is','',0),(256358,7122,'dr','Ø¢ÙŠ Ù¾ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± \r\n IP',0),(256359,7122,'pr','Ø¢ÙŠ Ù¾ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± \r\n IP',0),(256360,7122,'tr','MÃ¼ÅŸteri IP',0),(256361,7122,'pl','Klienta IP',0),(256362,7122,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ IP',0),(256363,7122,'ur','Ú©Ø³Ù¹Ù…Ø± IP',0),(256364,7122,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð˜ÐŸ',0),(256365,7122,'vi','IP cá»§a khÃ¡ch hÃ ng',0),(256366,7122,'af','Klant / KliÃ«nt ',0),(256367,7122,'ro','Client IP',0),(256368,7122,'et','Kliendi ID',0),(256369,7122,'si','Kupec IP',0),(256370,7122,'ba','Pelanggan IP',0),(256371,7122,'nl','Klant IP',0),(256372,7122,'fi','Asiakkaan IP',0),(256373,7122,'no','Kunden IP',0),(256374,7122,'da','Kunde IP',0),(256375,7122,'ko','ê³ ê° IP',0),(256376,7122,'he','×œ×§×•×—×•×ª ×”-IP',0),(256377,7122,'el','Î ÎµÎ»Î¬Ï„Î· IP',0),(256378,7122,'zh','å®¢æˆ·IP',0),(256379,7122,'sv','Kundens IP',0),(256380,7122,'it','Cliente IP',0),(256381,7122,'tl','',0),(256382,7122,'th','IP &#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(256383,7122,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤†à¤ˆà¤ªà¥€',0),(256384,7122,'ms','Baca IP',0),(256385,7122,'ar','Ø¹Ù…ÙŠÙ„ IP',0),(256386,7122,'fr','Client IP',0),(256387,7122,'jp','ã‚«ã‚¹ã‚¿ãƒžãƒ¼ IP',0),(256388,7122,'pt','Cliente IP',0),(256389,7122,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ IP',0),(256390,7122,'es','Cliente IP',0),(256391,7122,'de','Kunden IP',0),(256392,7122,'en','Customer IP',0),(256393,7123,'is','',0),(256394,7123,'dr','Ø®Ø·Ø§ Ø¨Ø§ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø­Ø³Ø§Ø¨ â€“ Ù¾Ø±Ø¯Ø§Ø²Ø´Ú¯Ø± ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(256395,7123,'pr','Ø®Ø·Ø§ Ø¨Ø§ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø­Ø³Ø§Ø¨ â€“ Ù¾Ø±Ø¯Ø§Ø²Ø´Ú¯Ø± ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(256396,7123,'tr','Hesap Kurulumu-iÅŸlemci hata yok',0),(256397,7123,'pl','BÅ‚Ä…d z procesorem konfiguracji konta nie istnieje',0),(256398,7123,'bg','Ð“Ñ€ÐµÑˆÐºÐ° ÑÑŠÑ ÑÐ¼ÐµÑ‚ÐºÐ° Setup-Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€ Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(256399,7123,'ur','Ù†Ù‚Øµ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ Ø§Ù¾ Ù¾Ø±ÙˆØ³ÛŒØ³Ø± Ú©Û’ Ø³Ø§ØªÚ¾ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(256400,7123,'sr','ÐÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð³Ñ€ÐµÑˆÐºÐ° ÑÐ° Ñ€Ð°Ñ‡ÑƒÐ½Ð° ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€Ð°',0),(256401,7123,'vi','TK Setup Bá»‹ Lá»—i-Bá»™ Xá»­ LÃ½ khÃ´ng tá»“n táº¡i',0),(256402,7123,'af','Fout met rekening opstelling-verwerker bestaan nie',0),(256403,7123,'ro','Eroare cu contul de instalare-procesor nu exista',0),(256404,7123,'et','TÃµrge konto hÃ¤Ã¤lestus-protsessoriga pole olemas',0),(256405,7123,'si','Napaka s procesorjem Setup raÄun ne obstaja',0),(256406,7123,'ba','Kesalahan dengan Account Setup-prosesor tidak ada',0),(256407,7123,'nl','Fout met Account Setup-Processor Does Not Exist',0),(256408,7123,'fi','Virhe tilin asetukset-prosessori ei ole',0),(256409,7123,'no','Feil med konto oppsett-prosessor finnes ikke',0),(256410,7123,'da','Fejl med konto opsÃ¦tning-Processor findes ikke',0),(256411,7123,'ko','ê³„ì • ì„¤ì •-í”„ë¡œì„¸ì„œ ì˜¤ë¥˜ê°€ ì¡´ìž¬ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(256412,7123,'he','×©×’×™××” ×¢× ×—×©×‘×•×Ÿ ×”×ª×§× ×”-×ž×¢×‘×“ ×œ× ×§×™×™×',0),(256413,7123,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÏƒÏ†Î¬Î»Î¼Î± Î¼Îµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚-ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î®',0),(256414,7123,'zh','é”™è¯¯ï¼šå¸æˆ·è®¾ç½®å¤„ç†å™¨ä¸å­˜åœ¨\r\n',0),(256415,7123,'sv','Fel med konto Setup-Processor finns inte',0),(256416,7123,'it','Non esiste errore con Account Setup-processore',0),(256417,7123,'tl','',0),(256418,7123,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3633;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637; &#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3612;&#3641;&#3657;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#',0),(256419,7123,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿà¤…à¤ª-à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤° à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(256420,7123,'ms','Ralat dengan akaun persediaan-pemproses tidak wujud',0),(256421,7123,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(256422,7123,'fr','Erreur avec le compte d\'installation-processeur n\'existe pas',0),(256423,7123,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—-ãƒ—ãƒ­ã‚»ãƒƒã‚µã®ã‚¨ãƒ©ãƒ¼ãŒå­˜åœ¨ã—ã¾ã›ã‚“',0),(256424,7123,'pt','Erro com processador de configuraÃ§Ã£o de conta nÃ£o existe',0),(256425,7123,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(256426,7123,'es','Error Con ConfiguraciÃ³n de Cuenta-Procesador No Existe',0),(256427,7123,'de','Fehler mit Konto-Setup-Prozessor ist nicht vorhanden',0),(256428,7123,'en','Error With Account Setup-Processor Does Not Exist',0),(256429,7124,'is','',0),(256430,7124,'dr','Ø¯Ø±ØµØ¯ Ø§Ø¶Ø§ÙÙŠ Ù…ÙˆÙ„Ù ',0),(256431,7124,'pr','Ø¯Ø±ØµØ¯ Ø§Ø¶Ø§ÙÙŠ Ù…ÙˆÙ„Ù ',0),(256432,7124,'tr','Fazladan Auth yÃ¼zde',0),(256433,7124,'pl','Dodatkowy procent Auth',0),(256434,7124,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ ÑƒÐ´Ð¾ÑÑ‚Ð¾Ð²ÐµÑ€ÑÐ²Ð°Ð½Ðµ %',0),(256435,7124,'ur','Ø§Ø¶Ø§ÙÛŒ Ø¢ ÙÛŒØµØ¯',0),(256436,7124,'sr','Ð•ÐºÑÑ‚Ñ€Ð° ÐÑƒÑ‚Ñ… Ð¿Ð¾ÑÑ‚Ð¾',0),(256437,7124,'vi','% phÃ¢n quyá»n thÃªm',0),(256438,7124,'af','Ekstra Auth persent',0),(256439,7124,'ro','Suplimentar la sutÄƒ Auth',0),(256440,7124,'et','Extra Auth protsenti',0),(256441,7124,'si','Dodatno Auth odstotkov',0),(256442,7124,'ba','Tambahan Auth persen',0),(256443,7124,'nl','Extra Auth procent',0),(256444,7124,'fi','Auth lisÃ¤prosentti',0),(256445,7124,'no','Ekstra Auth prosent',0),(256446,7124,'da','Ekstra Auth procent',0),(256447,7124,'ko','ì¶”ê°€ ì¸ì¦ %',0),(256448,7124,'he','××—×•×– ××™×ž×•×ª × ×•×¡×£',0),(256449,7124,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï„Î¿Ï… Î‘Î Î˜',0),(256450,7124,'zh','é¢å¤–çš„æŽˆæƒç™¾åˆ†æ¯”\r\n',0),(256451,7124,'sv','Extra Auth procent',0),(256452,7124,'it','Extra per cento Auth',0),(256453,7124,'tl','',0),(256454,7124,'th','&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(256455,7124,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ Auth à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(256456,7124,'ms','Tambahan pengesahan peratus',0),(256457,7124,'ar','Ø¥Ø¶Ø§ÙÙŠ ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ø§Ù„Ù…ØµØ§Ø¯Ù‚Ø©',0),(256458,7124,'fr','Extra Auth pour cent',0),(256459,7124,'jp','ä½™åˆ†ãª Auth %',0),(256460,7124,'pt','Extra por cento Auth',0),(256461,7124,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð² Auth',0),(256462,7124,'es','Extra Porcentaje de AutorizaciÃ³n',0),(256463,7124,'de','ZusÃ¤tzliche Auth-Prozent',0),(256464,7124,'en','Extra Auth Percent',0),(256465,7125,'is','',0),(256466,7125,'dr','ÙƒØ§Ø±Ø¨Ø± Ø¯Ø§Ø®Ù„ÙŠ ',0),(256467,7125,'pr','ÙƒØ§Ø±Ø¨Ø± Ø¯Ø§Ø®Ù„ÙŠ ',0),(256468,7125,'tr','Ä°Ã§ kullanÄ±cÄ±',0),(256469,7125,'pl','WewnÄ™trznego uÅ¼ytkownika',0),(256470,7125,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐµÐ½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(256471,7125,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ ØµØ§Ø±Ù',0),(256472,7125,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð½Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº',0),(256473,7125,'vi','NgÆ°á»i Sá»­ Dá»¥ng Ná»™i Bá»™',0),(256474,7125,'af','Interne Gebruiker',0),(256475,7125,'ro','Utilizator intern',0),(256476,7125,'et','Sisemine kasutaja',0),(256477,7125,'si','Notranjih uporabnikov',0),(256478,7125,'ba','Pengguna internal',0),(256479,7125,'nl','Interne gebruiker',0),(256480,7125,'fi','SisÃ¤inen kÃ¤yttÃ¤jÃ¤',0),(256481,7125,'no','Intern bruker',0),(256482,7125,'da','Intern bruger',0),(256483,7125,'ko','ë‚´ë¶€ ì‚¬ìš©ìž',0),(256484,7125,'he','×ž×©×ª×ž×© ×¤× ×™×ž×™',0),(256485,7125,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® Ï‡ÏÎ®ÏƒÏ„Î·',0),(256486,7125,'zh','å†…éƒ¨ç”¨æˆ·\r\n',0),(256487,7125,'sv','Intern anvÃ¤ndare',0),(256488,7125,'it','Utente interno',0),(256489,7125,'tl','',0),(256490,7125,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3616;&#3634;&#3618;&#3651;&#3609;',0),(256491,7125,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(256492,7125,'ms','Pengguna dalaman',0),(256493,7125,'ar','Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(256494,7125,'fr','Utilisateur interne',0),(256495,7125,'jp','å†…éƒ¨ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(256496,7125,'pt','UsuÃ¡rio interno',0),(256497,7125,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ð¹ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ',0),(256498,7125,'es','Usuario Internal',0),(256499,7125,'de','Interne Benutzer',0),(256500,7125,'en','Internal User',0),(256501,7126,'is','',0),(256502,7126,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ø´Ù†Ø§Ø³Ù‡',0),(256503,7126,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ø´Ù†Ø§Ø³Ù‡',0),(256504,7126,'tr','KimliÄŸi tercih',0),(256505,7126,'pl','WybraÄ‡ ID',0),(256506,7126,'bg','ÐžÑ‚ÐºÐ°Ð¶ÐµÑ‚Ðµ Ð˜Ð”',0),(256507,7126,'ur','ID Ø¢Ù¾Ù¹ Ø¢Ø¤Ù¹',0),(256508,7126,'sr','Ð˜Ð” ÑÐµ Ð¾Ð´Ð»ÑƒÑ‡ÑƒÑ˜Ñƒ',0),(256509,7126,'vi','ID Lá»±a chá»n',0),(256510,7126,'af','Kies ID',0),(256511,7126,'ro','Opta ID',0),(256512,7126,'et','Valida ID',0),(256513,7126,'si','Opt ID',0),(256514,7126,'ba','Memilih ID',0),(256515,7126,'nl','ID kiezen',0),(256516,7126,'fi','Valita tunnus',0),(256517,7126,'no','Velge ID',0),(256518,7126,'da','VÃ¦lge ID',0),(256519,7126,'ko','ID ì„ íƒ',0),(256520,7126,'he','×œ×‘×—×•×¨ ×ž×–×”×”',0),(256521,7126,'el','Î•Ï€Î¹Î»Î­Î¾Î¿Ï…Î½ ID',0),(256522,7126,'zh','é€‰é¡¹èº«ä»½\r\n',0),(256523,7126,'sv','VÃ¤lja ID',0),(256524,7126,'it','Optare ID',0),(256525,7126,'tl','',0),(256526,7126,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(256527,7126,'hi','ID à¤‘à¤ªà¥à¤Ÿ',0),(256528,7126,'ms','Memilih ID',0),(256529,7126,'ar','ØªØ®ØªØ§Ø± Ù…Ø¹Ø±Ù',0),(256530,7126,'fr','Opt ID',0),(256531,7126,'jp','ID ã‚’é¸ã¶',0),(256532,7126,'pt','Optar por ID',0),(256533,7126,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ID',0),(256534,7126,'es','ID Optar',0),(256535,7126,'de','Opt ID',0),(256536,7126,'en','Opt ID',0),(256537,7127,'is','',0),(256538,7127,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø§ØµÙ„ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(256539,7127,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø§ØµÙ„ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(256540,7127,'tr','Orijinal Trans kimliÄŸi',0),(256541,7127,'pl','Oryginalny Trans ID',0),(256542,7127,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸Ñ Ð˜Ð” Ð·Ð° Ñ‚Ñ€Ð°Ð½Ñ',0),(256543,7127,'ur','Ù¹Ø±Ø§Ù†Ø³ Ú©ÛŒ Ø§ØµÙ„ Ø´Ù†Ø§Ø®Øª',0),(256544,7127,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ Ð¢Ñ€Ð°Ð½Ñ Ð˜Ð”',0),(256545,7127,'vi','ID giao dá»‹ch gá»‘c',0),(256546,7127,'af','Oorspronklike Trans-ID',0),(256547,7127,'ro','Original Trans ID',0),(256548,7127,'et','Algne Trans ID',0),(256549,7127,'si','Izvirni ID Trans',0),(256550,7127,'ba','ID Trans awal',0),(256551,7127,'nl','Oorspronkelijke Trans-ID',0),(256552,7127,'fi','AlkuperÃ¤inen Trans tunnus',0),(256553,7127,'no','Opprinnelige Trans-ID',0),(256554,7127,'da','Oprindelige Trans ID',0),(256555,7127,'ko','ì›ëž˜ íŠ¸ëžœìŠ¤ ID',0),(256556,7127,'he','×ž×–×”×” ×˜×¨× ×¡ ×”×ž×§×•×¨×™',0),(256557,7127,'el','Î‘ÏÏ‡Î¹ÎºÏŒ ID Trans',0),(256558,7127,'zh','åŽŸå§‹äº¤æ˜“ç¼–å·\r\n',0),(256559,7127,'sv','Ursprungliga Trans-ID',0),(256560,7127,'it','ID originale Trans',0),(256561,7127,'tl','',0),(256562,7127,'th','&#3648;&#3621;&#3586;&#3627;&#3617;&#3634;&#3618;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3604;&#3633;&#3657;&#3591;&#3648;&#3604;&#3636;&#3617;',0),(256563,7127,'hi','à¤®à¥‚à¤² à¤Ÿà¥à¤°à¤¾à¤‚à¤¸ ID',0),(256564,7127,'ms','Asal Trans ID',0),(256565,7127,'ar','Ù…Ø¹Ø±Ù Ø¹Ø¨Ø± Ø§Ù„Ø£ØµÙ„ÙŠ',0),(256566,7127,'fr','ID Trans origine',0),(256567,7127,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ« ãƒˆãƒ©ãƒ³ã‚¹ ID',0),(256568,7127,'pt','Original Trans ID',0),(256569,7127,'ru','Ð˜ÑÑ…Ð¾Ð´Ð½Ñ‹Ð¹ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½Ñ',0),(256570,7127,'es','Original Trans. ID',0),(256571,7127,'de','Original Trans ID',0),(256572,7127,'en','Original Trans ID',0),(256573,7128,'is','',0),(256574,7128,'dr','Ù†ØªÙŠØ¬Ù‡ Ù¾ÙŠØºØ§Ù… ',0),(256575,7128,'pr','Ù†ØªÙŠØ¬Ù‡ Ù¾ÙŠØºØ§Ù… ',0),(256576,7128,'tr','SonuÃ§ iletisi',0),(256577,7128,'pl','Wynik wiadomoÅ›ci',0),(256578,7128,'bg','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(256579,7128,'ur','Ù†ØªÛŒØ¬Û Ù¾ÛŒØºØ§Ù…',0),(256580,7128,'sr','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚ Ð¿Ð¾Ñ€ÑƒÐºÐ°',0),(256581,7128,'vi','Káº¿t quáº£ tin nháº¯n',0),(256582,7128,'af','Boodskap Resultaat',0),(256583,7128,'ro','Rezultatul mesaj',0),(256584,7128,'et','Tulemusena sÃµnum',0),(256585,7128,'si','Rezultat sporoÄilo',0),(256586,7128,'ba','Pesan hasil',0),(256587,7128,'nl','Resultaat bericht',0),(256588,7128,'fi','Tulosta viesti',0),(256589,7128,'no','Resultatet meldingen',0),(256590,7128,'da','Resultatet besked',0),(256591,7128,'ko','ê²°ê³¼ ë©”ì‹œì§€',0),(256592,7128,'he','×”×ž×¡×¨ ×”×ª×•×¦××”',0),(256593,7128,'el','Î‘Ï€Î¿Ï„Î­Î»ÎµÏƒÎ¼Î± Î¼Î®Î½Ï…Î¼Î±',0),(256594,7128,'zh','ç»“æžœæ¶ˆæ¯\r\n',0),(256595,7128,'sv','Meddelandet resultatet',0),(256596,7128,'it','Messaggio di risultato',0),(256597,7128,'tl','',0),(256598,7128,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3612;&#3621;&#3621;&#3633;&#3614;&#3608;&#3660;',0),(256599,7128,'hi','à¤ªà¤°à¤¿à¤£à¤¾à¤® à¤¸à¤‚à¤¦à¥‡à¤¶',0),(256600,7128,'ms','Mesej keputusan',0),(256601,7128,'ar','Ø±Ø³Ø§Ù„Ø© Ø§Ù„Ù†ØªÙŠØ¬Ø©',0),(256602,7128,'fr','Message de rÃ©sultat',0),(256603,7128,'jp','çµæžœãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(256604,7128,'pt','Mensagem de resultado',0),(256605,7128,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¾ Ñ€ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ðµ',0),(256606,7128,'es','Mensaje de Resultado',0),(256607,7128,'de','Ergebnismeldung',0),(256608,7128,'en','Result Message',0),(256609,7129,'is','',0),(256610,7129,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„',0),(256611,7129,'pr','ØªØ§Ø±ÙŠØ® Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„',0),(256612,7129,'tr','Trans tarihi',0),(256613,7129,'pl','Data Trans',0),(256614,7129,'bg','Ð¢Ñ€Ð°Ð½Ñ Ð´Ð°Ñ‚Ð°',0),(256615,7129,'ur','Ù¹Ø±Ø§Ù†Ø³ ØªØ§Ø±ÛŒØ®',0),(256616,7129,'sr','Ð¢Ñ€Ð°Ð½Ñ Ð´Ð°Ñ‚ÑƒÐ¼',0),(256617,7129,'vi','NgÃ y Giao dá»‹ch',0),(256618,7129,'af','Oorpl. Datum',0),(256619,7129,'ro','Trans data',0),(256620,7129,'et','Trans kuupÃ¤ev',0),(256621,7129,'si','Trans datum',0),(256622,7129,'ba','Trans tanggal',0),(256623,7129,'nl','Trans datum',0),(256624,7129,'fi','Trans pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(256625,7129,'no','Trans-dato',0),(256626,7129,'da','Trans dato',0),(256627,7129,'ko','íŠ¸ëžœìŠ¤ ë‚ ì§œ',0),(256628,7129,'he','×˜×¨×× ×¡ ×ª××¨×™×š',0),(256629,7129,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± trans',0),(256630,7129,'zh','è½¬ç§»æ—¥æœŸ\r\n',0),(256631,7129,'sv','Trans datum',0),(256632,7129,'it','Data trans',0),(256633,7129,'tl','',0),(256634,7129,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(256635,7129,'hi','à¤Ÿà¥à¤°à¤¾à¤‚à¤¸ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(256636,7129,'ms','Tarikh Trans',0),(256637,7129,'ar','Ø¹Ø¨Ø± Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(256638,7129,'fr','Date de transaction',0),(256639,7129,'jp','ãƒˆãƒ©ãƒ³ã‚¹æ—¥ä»˜',0),(256640,7129,'pt','Trans data',0),(256641,7129,'ru','Ð¢Ñ€Ð°Ð½Ñ Ð”Ð°Ñ‚Ð°',0),(256642,7129,'es','Fecha de Transferencia',0),(256643,7129,'de','Trans-Datum',0),(256644,7129,'en','Trans Date',0),(256645,7130,'is','',0),(256646,7130,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„',0),(256647,7130,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„',0),(256648,7130,'tr','Trans kimliÄŸi',0),(256649,7130,'pl','Trans ID',0),(256650,7130,'bg','Ð˜Ð” Ð½Ð° Ñ‚Ñ€Ð°Ð½Ñ',0),(256651,7130,'ur','Ù¹Ø±Ø§Ù†Ø³ Ø´Ù†Ø§Ø®Øª',0),(256652,7130,'sr','Ð¢Ñ€Ð°Ð½Ñ-Ð˜Ð”',0),(256653,7130,'vi','ID Giao dá»‹ch',0),(256654,7130,'af','Trans-ID',0),(256655,7130,'ro','Trans ID',0),(256656,7130,'et','Trans ID',0),(256657,7130,'si','Trans ID',0),(256658,7130,'ba','Trans ID',0),(256659,7130,'nl','Trans-ID',0),(256660,7130,'fi','Trans tunnus',0),(256661,7130,'no','Trans-ID',0),(256662,7130,'da','Trans-ID',0),(256663,7130,'ko','íŠ¸ëžœìŠ¤ ID',0),(256664,7130,'he','×–×™×”×•×™ ×˜×¨× ×¡',0),(256665,7130,'el','Trans ID',0),(256666,7130,'zh','è½¬ç§»å¸å·\r\n',0),(256667,7130,'sv','Trans-ID',0),(256668,7130,'it','Trans ID',0),(256669,7130,'tl','',0),(256670,7130,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(256671,7130,'hi','à¤Ÿà¥à¤°à¤¾à¤‚à¤¸ ID',0),(256672,7130,'ms','Trans ID',0),(256673,7130,'ar','Ù…Ø¹Ø±Ù ØªØ±Ø§Ù†Ø³',0),(256674,7130,'fr','TRANS ID',0),(256675,7130,'jp','ãƒˆãƒ©ãƒ³ã‚¹ ID',0),(256676,7130,'pt','Trans ID',0),(256677,7130,'ru','ID Ñ‚Ñ€Ð°Ð½Ñ',0),(256678,7130,'es','ID de Transferencia',0),(256679,7130,'de','Trans ID',0),(256680,7130,'en','Trans ID',0),(256681,7131,'is','',0),(256682,7131,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„',0),(256683,7131,'pr','Ù†ÙˆØ¹ Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„',0),(256684,7131,'tr','Trans tÃ¼rÃ¼',0),(256685,7131,'pl','Typu trans',0),(256686,7131,'bg','Ð¢Ñ€Ð°Ð½Ñ Ñ‚Ð¸Ð¿',0),(256687,7131,'ur','Ù¹Ø±Ø§Ù†Ø³ Ù‚Ø³Ù…',0),(256688,7131,'sr','Ð¢Ñ€Ð°Ð½Ñ Ñ‚Ð¸Ð¿',0),(256689,7131,'vi','Loáº¡i Giao dá»‹ch',0),(256690,7131,'af','Trans tipe',0),(256691,7131,'ro','Tip trans',0),(256692,7131,'et','Trans tÃ¼Ã¼p',0),(256693,7131,'si','Vrsta trans',0),(256694,7131,'ba','Jenis Trans',0),(256695,7131,'nl','Trans Type',0),(256696,7131,'fi','Trans tyyppi',0),(256697,7131,'no','Trans Type',0),(256698,7131,'da','Trans Type',0),(256699,7131,'ko','íŠ¸ëžœìŠ¤ ì¢…ë¥˜',0),(256700,7131,'he','×¡×•×’ ×˜×¨× ×¡',0),(256701,7131,'el','Trans Ï„ÏÏ€Î¿Ï…',0),(256702,7131,'zh','è½¬ç§»ç±»åž‹\r\n',0),(256703,7131,'sv','Trans typ',0),(256704,7131,'it','Tipo trans',0),(256705,7131,'tl','',0),(256706,7131,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(256707,7131,'hi','à¤Ÿà¥à¤°à¤¾à¤‚à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(256708,7131,'ms','Jenis Trans',0),(256709,7131,'ar','Ù†ÙˆØ¹ ØªØ±Ø§Ù†Ø³',0),(256710,7131,'fr','Type de TRANS',0),(256711,7131,'jp','ãƒˆãƒ©ãƒ³ã‚¹åž‹',0),(256712,7131,'pt','Tipo trans',0),(256713,7131,'ru','Ð¢Ð¸Ð¿ Ñ‚Ñ€Ð°Ð½Ñ',0),(256714,7131,'es','Tipo de Transferencia',0),(256715,7131,'de','Trans-Typ',0),(256716,7131,'en','Trans Type',0),(256717,7132,'is','',0),(256718,7132,'dr','/ Ø§ØµÙ„Ø§Ø­  Ù…Ø±Ø§ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ù„ÛŒØ¬Ø±',0),(256719,7132,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / ÙˆÙŠØ±Ø§ÙŠØ´ Ù…Ø±Ø§ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(256720,7132,'tr','GL maliyet merkezleri',0),(256721,7132,'pl','Centra kosztÃ³w GL',0),(256722,7132,'bg','GL Cost Centers',0),(256723,7132,'ur','Ø¬ÛŒØ¬Û’ Ù„Ø§Ú¯Øª Ù…Ø±Ø§Ú©Ø²',0),(256724,7132,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð“Ð›',0),(256725,7132,'vi','ThÃªm/Sá»­a Cost Center Trong Sá»• CÃ¡i Tá»•ng Há»£p',0),(256726,7132,'af','Algemene Grootboek Koste Sentrum Byvoeg/Redigeer',0),(256727,7132,'ro','Adauga/Modifica centre de cost in contabilitate',0),(256728,7132,'et','Lisa/muuda pearaamatu kuluÃ¼ksusi',0),(256729,7132,'si','GL StroÅ¡kovni centri',0),(256730,7132,'ba','GL biaya Pusat',0),(256731,7132,'nl','GL kostenplaatsen',0),(256732,7132,'fi','GL kustannuspaikat',0),(256733,7132,'no','GL kostsentre',0),(256734,7132,'da','GL omkostningssteder',0),(256735,7132,'ko','GL ë¹„ìš© ì„¼í„°',0),(256736,7132,'he','×ž×¨×›×–×™ ×¢×œ×•×ª GL',0),(256737,7132,'el','ÎšÎ­Î½Ï„ÏÎ± ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ GL',0),(256738,7132,'zh','å¢žåŠ /ç¼–è¾‘æ€»å¸æˆæœ¬ä¸­å¿ƒ\r\n',0),(256739,7132,'sv','GL kostnadsstÃ¤llen',0),(256740,7132,'it','Centri di costo GL',0),(256741,7132,'tl','',0),(256742,7132,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(256743,7132,'hi','GL à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤¨à¥à¤¦à¥à¤°',0),(256744,7132,'ms','Pusat-Pusat kos GL',0),(256745,7132,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ù…Ø±Ø§ÙƒØ² ØªÙƒÙ„ÙØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(256746,7132,'fr','Ajouter/Modifier centre de coÃ»ts du Grand Livre',0),(256747,7132,'jp','GL ã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼',0),(256748,7132,'pt','Centros de custo GL',0),(256749,7132,'ru','GL ÐœÐ’Ð—',0),(256750,7132,'es','Agregar/Editar Centro de Costos Generales de Libro Mayor',0),(256751,7132,'de','GL-Kostenstellen',0),(256752,7132,'en','GL Cost Centers',0),(256753,7133,'is','',0),(256754,7133,'dr','/ Ø§ØµÙ„Ø§Ø­  ØªÙˆØ¶ÙŠØ­Ø§Øª Ø³Ø·Ø­ Ø®Ù„Ø§ØµÙ‡ ',0),(256755,7133,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / ÙˆÙŠØ±Ø§ÙŠØ´ ØªÙˆØ¶ÙŠØ­Ø§Øª Ø³Ø·Ø­ Ø®Ù„Ø§ØµÙ‡ ',0),(256756,7133,'tr','Yeni/DÃ¼zenle Ã–zet dÃ¼zeyi aÃ§Ä±klamalarÄ±',0),(256757,7133,'pl','Nowy/Edytuj podsumowanie poziomu opisy',0),(256758,7133,'bg','ÐÐ¾Ð²Ð¸/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð¸Ð²Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(256759,7133,'ur','Ù†Ø¦ÛŒ/ØªØ±Ù…ÛŒÙ… Ø®Ù„Ø§ØµÛ Ø³Ø·Ø­ Ø¨ÛŒØ§Ù†Ø§Øª',0),(256760,7133,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ð²Ð¾Ð° Ð¾Ð¿Ð¸ÑÐµ Ð½Ð¾Ð²Ð¸Ñ…/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(256761,7133,'vi','ThÃªm/Sá»­a Cáº¥p Äá»™ Diá»…n Giáº£i Tá»•ng Há»£p',0),(256762,7133,'af','Beskrywings van Opsommingsvlakke Byvoeg/Redigeer ',0),(256763,7133,'ro','Adauga/Modifica descriere nivel totalizare',0),(256764,7133,'et','Uus/Muuda tasandil kokkuvÃµtlikud kirjeldused',0),(256765,7133,'si','Novo/urejanje povzetka ravni opisi',0),(256766,7133,'ba','Baru/Edit ringkasan Deskripsi tingkat',0),(256767,7133,'nl','Samenvatting niveau beschrijvingen van nieuwe/bewerken',0),(256768,7133,'fi','Uusi tai muokkaa Yhteenveto tasokuvaukset',0),(256769,7133,'no','Ny/Rediger Sammendrag nivÃ¥ beskrivelser',0),(256770,7133,'da','Nyt/Rediger oversigt niveau beskrivelser',0),(256771,7133,'ko','ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘ ìš”ì•½ ìˆ˜ì¤€ ì„¤ëª…',0),(256772,7133,'he','×ª×™××•×¨×™× ×‘×¨×ž×ª ×¡×™×›×•× ×—×“×©/×¢×¨×™×›×”',0),(256773,7133,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î£ÏÎ½Î¿ÏˆÎ·Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚',0),(256774,7133,'zh','å¢žåŠ /ç¼–è¾‘æ‘˜è¦çº§åˆ«æè¿°\r\n',0),(256775,7133,'sv','Ny/redigera Sammanfattning nivÃ¥beskrivningar',0),(256776,7133,'it','Descrizioni di livello riepilogo nuovo/modifica',0),(256777,7133,'tl','',0),(256778,7133,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3619;&#3632;&#3604;&#3633;&#3610;&#3626;&#3619;&#3640;&#3611;&#3585;&#3634;&#3619;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(256779,7133,'hi','à¤¨à¤ˆ/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¸à¥à¤¤à¤° à¤µà¤°à¥à¤£à¤¨',0),(256780,7133,'ms','Baru/Edit ringkasan peringkat penerangan',0),(256781,7133,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ø¨ÙŠØ§Ù† Ù…Ø³ØªÙˆÙ‰ Ø§Ù„ØªÙ„Ø®ÙŠØµ',0),(256782,7133,'fr','Ajouter/Modifier Description de Niveau Sommaires',0),(256783,7133,'jp','æ–°è¦/ç·¨é›†æ¦‚è¦ãƒ¬ãƒ™ãƒ«ã®èª¬æ˜Ž',0),(256784,7133,'pt','Novo/editar descriÃ§Ãµes resumidas de nÃ­vel',0),(256785,7133,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ/Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÐ²Ð¾Ð´Ð½Ñ‹Ñ… Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ð¹ ÑƒÑ€Ð¾Ð²Ð½Ñ',0),(256786,7133,'es','Agregar/Editar Descripciones de Nivel de Sumario ',0),(256787,7133,'de','Zusammenfassende Beschreibung neu/bearbeiten',0),(256788,7133,'en','New/Edit Summary Level Descriptions',0),(256789,7134,'is','',0),(256790,7134,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¬Ù†Ø³',0),(256791,7134,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ù„Ø§',0),(256792,7134,'tr','Ã–ÄŸe Ekle/GÃ¼ncelle',0),(256793,7134,'pl','Pozycji Dodaj/Aktualizuj',0),(256794,7134,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(256795,7134,'ur','Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(256796,7134,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð»/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(256797,7134,'vi','ThÃªm/Cáº­p Nháº­t Danh Má»¥c',0),(256798,7134,'af','Item Byvoeg/Opdateer',0),(256799,7134,'ro','Adauga/Actualizeaza articol',0),(256800,7134,'et','Lisa/Uuenda toodet',0),(256801,7134,'si','Element Dodaj/posodobi',0),(256802,7134,'ba','Item Tambahkan/Perbarui',0),(256803,7134,'nl','Item toevoegen/bijwerken',0),(256804,7134,'fi','Nimikkeen lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(256805,7134,'no','Elementet Legg til/Oppdater',0),(256806,7134,'da','Elementet TilfÃ¸j/opdater',0),(256807,7134,'ko','í•­ëª© ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(256808,7134,'he','×”×•×¡×£/×¢×“×›×Ÿ ×¤×¨×™×˜',0),(256809,7134,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(256810,7134,'zh','å¢žåŠ /æ›´æ–°é¡¹ç›®\r\n',0),(256811,7134,'sv','Artikel LÃ¤gg till/uppdatera',0),(256812,7134,'it','Aggiungere/aggiornare un elemento',0),(256813,7134,'tl','',0),(256814,7134,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(256815,7134,'hi','à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(256816,7134,'ms','Item Tambah/Kemaskini',0),(256817,7134,'ar','Ø§Ù„Ø¹Ù†ØµØ± Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(256818,7134,'fr','Ã‰lÃ©ment Ajouter/mettre Ã  jour',0),(256819,7134,'jp','é …ç›®ã‚’è¿½åŠ /æ›´æ–°',0),(256820,7134,'pt','Item Adicionar/atualizar',0),(256821,7134,'ru','Ð¢Ð¾Ð²Ð°Ñ€ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(256822,7134,'es','Item Agregar/Actualizar',0),(256823,7134,'de','Element hinzufÃ¼gen/aktualisieren',0),(256824,7134,'en','Item Add/Update',0),(256825,7135,'is','',0),(256826,7135,'dr','Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù… Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(256827,7135,'pr','Ø´Ø±Ø§ÙŠØ· Ù„Ø§Ø²Ù… Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(256828,7135,'tr','Nakit gereksinimleri',0),(256829,7135,'pl','Potrzeb gotÃ³wkowych',0),(256830,7135,'bg','ÐšÐ°ÑÐ¾Ð²Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ÑÑ‚Ð¸',0),(256831,7135,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©Û’ ØªÙ‚Ø§Ø¶Û’',0),(256832,7135,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð¸ Ð·Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ñƒ',0),(256833,7135,'vi','YÃªu cáº§u tiá»n máº·t',0),(256834,7135,'af','Kontant Benodighede',0),(256835,7135,'ro','CerinÅ£ele de numerar',0),(256836,7135,'et','SularahanÃµudluse',0),(256837,7135,'si','Denarne zahteve',0),(256838,7135,'ba','Kebutuhan kas',0),(256839,7135,'nl','Kasmiddelen',0),(256840,7135,'fi','KÃ¤teisvarojen saamiseksi',0),(256841,7135,'no','Likviditetsbehov',0),(256842,7135,'da','Likviditetsbehov',0),(256843,7135,'ko','í˜„ê¸ˆ ìš”êµ¬ ì‚¬í•­',0),(256844,7135,'he','×“×¨×™×©×•×ª ×ž×–×•×ž× ×™×',0),(256845,7135,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ Î±Î½Î¬Î³ÎºÎµÏ‚',0),(256846,7135,'zh','çŽ°é‡‘éœ€æ±‚\r\n',0),(256847,7135,'sv','Likviditetsbehov',0),(256848,7135,'it','Requisiti di contanti',0),(256849,7135,'tl','',0),(256850,7135,'th','&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;&#3626;&#3604;',0),(256851,7135,'hi','à¤¨à¤•à¤¦ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾à¤à¤',0),(256852,7135,'ms','Keperluan Tunai',0),(256853,7135,'ar','Ø§Ù„Ù…ØªØ·Ù„Ø¨Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(256854,7135,'fr','Besoins de trÃ©sorerie',0),(256855,7135,'jp','ç¾é‡‘ã®è¦ä»¶',0),(256856,7135,'pt','Necessidades de caixa',0),(256857,7135,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(256858,7135,'es','Requerimientos de Efectivo',0),(256859,7135,'de','Kassenmittel',0),(256860,7135,'en','Cash Requirements',0),(256861,7136,'is','',0),(256862,7136,'dr','Ú†Ùƒ Ù‡Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(256863,7136,'pr','Ú†Ùƒ Ù‡Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(256864,7136,'tr','Komisyon kontrol',0),(256865,7136,'pl','Komisja kontroli',0),(256866,7136,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸Ñ‚Ðµ Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(256867,7136,'ur','Ú©Ù…ÛŒØ´Ù† Ú©Û’ Ú†ÛŒÚ©',0),(256868,7136,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(256869,7136,'vi','SÃ©c hoa há»“ng',0),(256870,7136,'af','Kommissie Tjeks',0),(256871,7136,'ro','Controalele Comisiei',0),(256872,7136,'et','Komisjoni kontrollid',0),(256873,7136,'si','Pregledi Komisije',0),(256874,7136,'ba','Cek komisi',0),(256875,7136,'nl','Commissie controles',0),(256876,7136,'fi','Komission tarkastukset',0),(256877,7136,'no','Kommisjonen regningene',0),(256878,7136,'da','Kommissionens kontrol',0),(256879,7136,'ko','ìœ„ì›íšŒ ê²€ì‚¬',0),(256880,7136,'he','×‘×“×™×§×•×ª ×•×¢×“×ª',0),(256881,7136,'el','Î•Î»Î­Î³Ï‡Î¿Ï…Ï‚ Ï„Î·Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®Ï‚',0),(256882,7136,'zh','ä½£é‡‘æ”¯ç¥¨\r\n',0),(256883,7136,'sv','Kommissionens kontroller',0),(256884,7136,'it','Commissione controlli',0),(256885,7136,'tl','',0),(256886,7136,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(256887,7136,'hi','à¤†à¤¯à¥‹à¤— à¤•à¥€ à¤œà¤¾à¤‚à¤š',0),(256888,7136,'ms','Cek komisen',0),(256889,7136,'ar','ØµÙƒÙˆÙƒ Ø§Ù„Ø¹Ù…ÙˆÙ„Ø§Øª',0),(256890,7136,'fr','ContrÃ´les de la Commission',0),(256891,7136,'jp','å§”å“¡ä¼šã®ãƒã‚§ãƒƒã‚¯',0),(256892,7136,'pt','Controlos da ComissÃ£o',0),(256893,7136,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚',0),(256894,7136,'es','Cheques de ComisiÃ³n',0),(256895,7136,'de','Provisionsschecks',0),(256896,7136,'en','Commission Checks',0),(256897,7137,'is','',0),(256898,7137,'dr','/ ÙŠÙ‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø´Ø±ÙƒØª ',0),(256899,7137,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / ÙŠÙ‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø´Ø±ÙƒØª ',0),(256900,7137,'tr','Åžirket yeni/DÃ¼zenle',0),(256901,7137,'pl','Firmy nowy/edycja',0),(256902,7137,'bg','ÐÐ¾Ð²Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(256903,7137,'ur','Ù†Ø¦ÛŒ Ú©Ù…Ù¾Ù†ÛŒ/ØªØ¯ÙˆÛŒÙ†',0),(256904,7137,'sr','ÐÐ¾Ð²Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(256905,7137,'vi','ThÃªm/Cáº­p Nháº­t Cty',0),(256906,7137,'af','Onderneming Bygevoeg/Opdateer',0),(256907,7137,'ro','Adauga/actualizeaza Firma',0),(256908,7137,'et','EttevÃµtte Lisamine/Uuendamine',0),(256909,7137,'si','Podjetje nova/Uredi',0),(256910,7137,'ba','Perusahaan baru/Edit',0),(256911,7137,'nl','Bedrijf toevoegen/updaten',0),(256912,7137,'fi','YhtiÃ¶n uusi tai Muokkaa',0),(256913,7137,'no','Selskapet ny/Rediger',0),(256914,7137,'da','Virksomheden ny/Rediger',0),(256915,7137,'ko','íšŒì‚¬ ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘',0),(256916,7137,'he','×”×•×¡×¤×ª/×¢×“×›×•×Ÿ ×—×‘×¨×”',0),(256917,7137,'el','ÎÎ­Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(256918,7137,'zh','å…¬å¸æ–°å¢ž/æ›´æ–°\r\n',0),(256919,7137,'sv','FÃ¶retaget ny/redigera',0),(256920,7137,'it','Azienda nuovo/modifica',0),(256921,7137,'tl','',0),(256922,7137,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(256923,7137,'hi','à¤¨à¤ˆ à¤•à¤‚à¤ªà¤¨à¥€/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(256924,7137,'ms','Syarikat baru/Edit',0),(256925,7137,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø´Ø±ÙƒØ©',0),(256926,7137,'fr','SociÃ©tÃ© nouvelle/modifier',0),(256927,7137,'jp','ä¼šç¤¾ã®ä½œæˆã¨ç·¨é›†',0),(256928,7137,'pt','Nova empresa/editar',0),(256929,7137,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(256930,7137,'es','Empresa Agregar/Actualizar',0),(256931,7137,'de','Firma neu/bearbeiten',0),(256932,7137,'en','Company New/Edit',0),(256933,7138,'is','',0),(256934,7138,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ø¨Ø§Ø¬Ù‡ ÙØ±ÙˆØ´',0),(256935,7138,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ø¨Ø§Ø¬Ù‡ ÙØ±ÙˆØ´',0),(256936,7138,'tr','Bir sayaÃ§ satÄ±ÅŸ oluÅŸturun',0),(256937,7138,'pl','Tworzenie licznika sprzedaÅ¼',0),(256938,7138,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð±Ñ€Ð¾ÑÑ‡ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(256939,7138,'ur','Ø§ÛŒÚ© Ú©Ø§Ø¤Ù†Ù¹Ø± Ú©Û’ Ù„ÙŠØ¦Û’ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(256940,7138,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ñ€Ð°ÑÐ¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð¿ÑƒÐ»Ñ‚Ð°',0),(256941,7138,'vi','Táº¡o 1 giao dá»‹ch bÃ¡n táº¡i quáº§y',0),(256942,7138,'af','Skep \'n Toonbank Verkoopstransaksie',0),(256943,7138,'ro','CreaÅ£i o vÃ¢nzare de Counter',0),(256944,7138,'et','Loo Counter MÃ¼Ã¼k',0),(256945,7138,'si','Ustvarite Counter prodaje',0),(256946,7138,'ba','Membuat penjualan Counter',0),(256947,7138,'nl','Een teller uitverkoop maken',0),(256948,7138,'fi','Luo Counter myynti',0),(256949,7138,'no','Opprette en Counter-salg',0),(256950,7138,'da','Oprette en Counter salg',0),(256951,7138,'ko','ì¹´ìš´í„° íŒë§¤ë¥¼ ë§Œë“¤',0),(256952,7138,'he','×¦×•×¨ ×ž×›×™×¨×ª ×“×œ×¤×§',0),(256953,7138,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î¼Î¹Î± Ï€ÏŽÎ»Î·ÏƒÎ· Î¼ÎµÏ„ÏÎ·Ï„Î®',0),(256954,7138,'zh','åˆ›å»ºä¸€ä¸ªå¼€å”®\r\n',0),(256955,7138,'sv','Skapa en Counter-fÃ¶rsÃ¤ljning',0),(256956,7138,'it','Creare un contatore in vendita',0),(256957,7138,'tl','',0),(256958,7138,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3648;&#3588;&#3634;&#3609;&#3660;&#3648;&#3605;&#3629;&#3619;&#3660;&#3586;&#3634;&#3618;',0),(256959,7138,'hi','à¤à¤• à¤•à¤¾à¤‰à¤‚à¤Ÿà¤° à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¬à¤¨à¤¾à¤à¤',0),(256960,7138,'ms','Mewujudkan kaunter jualan',0),(256961,7138,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¹Ù…Ù„ÙŠØ© Ø¨ÙŠØ¹ Ø§Ù„Ø¹Ø¯Ø§Ø¯',0),(256962,7138,'fr','CrÃ©er un vente de comptoir',0),(256963,7138,'jp','ã‚«ã‚¦ãƒ³ã‚¿ãƒ¼è²©å£²ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(256964,7138,'pt','Criar uma venda de contador',0),(256965,7138,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ñ‡Ð¸ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°',0),(256966,7138,'es','Crear una Venta en Tienda',0),(256967,7138,'de','Erstellen Sie einen Counter-Verkauf',0),(256968,7138,'en','Create A Counter Sale',0),(256969,7139,'is','',0),(256970,7139,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ØªØ±Ø§Ø² Ù†Ø§Ù…Ù‡  Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ ØªÙØµÙŠÙ„ÙŠ',0),(256971,7139,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ØªØ±Ø§Ø² Ù†Ø§Ù…Ù‡  Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ ØªÙØµÙŠÙ„ÙŠ',0),(256972,7139,'tr','AyrÄ±ntÄ±lÄ± mizan sayfasÄ± oluÅŸturma',0),(256973,7139,'pl','UtwÃ³rz arkusz szczegÃ³Å‚owy bilans prÃ³bny',0),(256974,7139,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ° Ð·Ð° Ð¾Ð±Ð¾Ñ€Ð¾Ñ‚Ð½Ð° Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚ Ð»Ð¸ÑÑ‚',0),(256975,7139,'ur','Ø§ÛŒÚ© ØªÙØµÛŒÙ„ÛŒ Ù…Ù‚Ø¯Ù…Û Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(256976,7139,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð´ÐµÑ‚Ð°Ñ™Ð½Ð¾Ð³ Ð±Ñ€ÑƒÑ‚Ð¾ Ð±Ð¸Ð»Ð°Ð½ÑÐ°',0),(256977,7139,'vi','Táº¡o má»™t báº£ng cÃ¢n Ä‘á»‘i chi tiáº¿t thá»­',0),(256978,7139,'af','Skep \'n Gedetailleerde Proefbalansstaat',0),(256979,7139,'ro','CreaÅ£i un bilanÅ£ proces detaliate',0),(256980,7139,'et','Luua Ãœksikasjalik proovibilanss leht',0),(256981,7139,'si','Ustvarite podrobno bruto bilanco stanja',0),(256982,7139,'ba','Buat lembaran rinci Trial Balance',0),(256983,7139,'nl','Een gedetailleerde proefbalans vel maken',0),(256984,7139,'fi','Luominen eritelty alustava saldo',0),(256985,7139,'no','Opprette et kontoutdrag ark',0),(256986,7139,'da','Oprette et detaljeret rÃ¥balance ark',0),(256987,7139,'ko','ìƒì„¸ ì‹œì‚°í‘œ ì‹œíŠ¸ ë§Œë“¤ê¸°',0),(256988,7139,'he','×¦×•×¨ ×’×œ×™×•×Ÿ ×ž××–×Ÿ ×‘×•×—×Ÿ × ×ª×•× ×™× ×”×™×¡×˜×•×¨×™×™×',0),(256989,7139,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î­Î½Î± Ï†ÏÎ»Î»Î¿ Î±Î½Î±Î»Ï…Ï„Î¹ÎºÏŒ Î¹ÏƒÎ¿Î¶ÏÎ³Î¹Î¿',0),(256990,7139,'zh','åˆ›å»ºä¸€ä¸ªè¯¦ç»†çš„è¯•éªŒèµ„äº§è´Ÿå€ºè¡¨\r\n',0),(256991,7139,'sv','Skapa en detaljerad rÃ¥balans ark',0),(256992,7139,'it','Creare un bilancio dettagliato Trial',0),(256993,7139,'tl','',0),(256994,7139,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3591;&#3610;&#3607;&#3604;&#3621;&#3629;&#3591;&#3591;&#3610;&#3604;&#3640;&#3621;',0),(256995,7139,'hi','à¤à¤• à¤µà¤¿à¤¸à¥à¤¤à¥ƒà¤¤ à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤¶à¥‡à¤· à¤ªà¤¤à¥à¤°à¤• à¤¬à¤¨à¤¾à¤à¤',0),(256996,7139,'ms','Mencipta lembaran imbangan duga yang terperinci',0),(256997,7139,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙŠØ²Ø§Ù† Ø§Ù„Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ù…ÙØµÙ‘Ù„',0),(256998,7139,'fr','CrÃ©er une feuille de Balance de vÃ©rification dÃ©taillÃ©e',0),(256999,7139,'jp','è©³ç´°ã®è©¦ç®—è¡¨ã®ã‚·ãƒ¼ãƒˆã‚’ä½œæˆã—ã¾ã™ã€‚',0),(257000,7139,'pt','Criar uma folha de Balancete Detalhado',0),(257001,7139,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð»Ð¸ÑÑ‚Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ñ‹Ð¹ Ð¿Ñ€Ð¾Ð±Ð½Ñ‹Ð¹ Ð±Ð°Ð»Ð°Ð½Ñ',0),(257002,7139,'es','Crear Una Balance de ComprobaciÃ³n Detallada',0),(257003,7139,'de','Erstellen Sie eine detaillierte Studie Bilanz',0),(257004,7139,'en','Create A Detailed Trial Balance Sheet',0),(257005,7140,'is','',0),(257006,7140,'dr','/ Ø§ØµÙ„Ø§Ø­   / Ø¯Ø±ÙŠØ§ÙØª Ù…ÙˆØ§Ø¯  Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(257007,7140,'pr','Ø§ÙŠØ¬Ø§Ø¯  / ÙˆÙŠØ±Ø§ÙŠØ´  / Ø¯Ø±ÙŠØ§ÙØª Ù…ÙˆØ§Ø¯  Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(257008,7140,'tr','RMAs oluÅŸturma/dÃ¼zenleme/alma',0),(257009,7140,'pl','UtwÃ³rz/Edytuj/odbierania RMAs',0),(257010,7140,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ RMAs',0),(257011,7140,'ur','Ø±Ù…ÛØ³ ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº/ØªØ¯ÙˆÛŒÙ†/ÙˆØµÙˆÙ„ÛŒÚº',0),(257012,7140,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ /Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼ Ð ÐœÐÑ',0),(257013,7140,'vi','Táº¡o Má»›i/Sá»­a/Nháº­n RMAs',0),(257014,7140,'af','Skep/Redigeer/Ontvang \"RMA\'s\"',0),(257015,7140,'ro','Creare/editare/primi RMAs',0),(257016,7140,'et','Loo/Muuda/saada RMAs',0),(257017,7140,'si','Ustvarjanje/urejanje/prejemanje RMAs',0),(257018,7140,'ba','RMAs buat/Edit/menerima',0),(257019,7140,'nl','Maken/bewerken/ontvangen RMAs',0),(257020,7140,'fi','Luo/Muokkaa/vastaanottaa RMAs',0),(257021,7140,'no','Opprette/redigere/motta RMAs',0),(257022,7140,'da','Opret/Rediger/modtage RMAs',0),(257023,7140,'ko','Rma ìƒì„±/íŽ¸ì§‘/ìˆ˜ì‹ ',0),(257024,7140,'he','RMAs ×œ×™×¦×•×¨/×œ×¢×¨×•×š/×§×‘×œ×”',0),(257025,7140,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±/Î»Î®ÏˆÎ· RMAs',0),(257026,7140,'zh','åˆ›å»º/ç¼–è¾‘/æŽ¥æ”¶è¿”å›žå•†å“æŽˆæƒ\r\n',0),(257027,7140,'sv','Skapa/redigera/ta emot RMA',0),(257028,7140,'it','Crea/modifica/ricezione RMA',0),(257029,7140,'tl','',0),(257030,7140,'th','&#3626;&#3619;&#3657;&#3634;&#3591;/&#3649;&#3585;&#3657;&#3652;&#3586;/&#3619;&#3633;&#3610; RMAs',0),(257031,7140,'hi','à¤¬à¤¨à¤¾à¤à¤/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚/à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ RMAs',0),(257032,7140,'ms','RMAs mencipta/Edit/menerima',0),(257033,7140,'ar','Ø¥Ù†Ø´Ø§Ø¡/ØªØ­Ø±ÙŠØ±/Ø¥Ø³ØªÙ„Ø§Ù… Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(257034,7140,'fr','CrÃ©er/modifier/recevoir RMA',0),(257035,7140,'jp','Rma ã®ä½œæˆ/ç·¨é›†/å—ä¿¡',0),(257036,7140,'pt','Criar/editar/receber RMAs',0),(257037,7140,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ/Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ/Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹ RMA',0),(257038,7140,'es','Crear/Editar/Recibir RMAs',0),(257039,7140,'de','Erstellen/Bearbeiten/empfangen RMAs',0),(257040,7140,'en','Create/Edit/Receive RMAs',0),(257041,7141,'is','',0),(257042,7141,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(257043,7141,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(257044,7141,'tr','MÃ¼ÅŸteri gruplarÄ±',0),(257045,7141,'pl','Grup klientÃ³w',0),(257046,7141,'bg','Ð“Ñ€ÑƒÐ¿Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(257047,7141,'ur','Ú©Ø³Ù¹Ù…Ø± Ú¯Ø±ÙˆÙ¾',0),(257048,7141,'sr','Ð“Ñ€ÑƒÐ¿Ðµ ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(257049,7141,'vi','NhÃ³m KhÃ¡ch hÃ ng',0),(257050,7141,'af','Klant / KliÃ«nt Groepe',0),(257051,7141,'ro','Grupuri de clienti',0),(257052,7141,'et','Kliendigrupid',0),(257053,7141,'si','Skupine kupcev',0),(257054,7141,'ba','Kelompok pelanggan',0),(257055,7141,'nl','Klantgroepen',0),(257056,7141,'fi','AsiakasryhmÃ¤t',0),(257057,7141,'no','Kundegrupper',0),(257058,7141,'da','Kundegrupper',0),(257059,7141,'ko','ê³ ê° ê·¸ë£¹',0),(257060,7141,'he','×§×‘×•×¦×•×ª ×œ×§×•×—×•×ª',0),(257061,7141,'el','ÎŸÎ¼Î¬Î´ÎµÏ‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(257062,7141,'zh','å®¢æˆ·ç¾¤ä½“\r\n',0),(257063,7141,'sv','Kundgrupper',0),(257064,7141,'it','Gruppi di clienti',0),(257065,7141,'tl','',0),(257066,7141,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(257067,7141,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹à¥‹à¤‚',0),(257068,7141,'ms','Kumpulan pelanggan',0),(257069,7141,'ar','ÙØ¦Ø§Øª Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(257070,7141,'fr','Groupes de clients',0),(257071,7141,'jp','é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—',0),(257072,7141,'pt','Grupos de clientes',0),(257073,7141,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(257074,7141,'es','Cliente Grupos',0),(257075,7141,'de','Kundengruppen',0),(257076,7141,'en','Customer Groups',0),(257077,7142,'is','',0),(257078,7142,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§ Ù‡Ø§ÙŠ  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(257079,7142,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§ Ù‡Ø§ÙŠ  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(257080,7142,'tr','MÃ¼ÅŸteri gruplarÄ± stok maddeleri iÃ§in',0),(257081,7142,'pl','Grup klientÃ³w dla zapasÃ³w',0),(257082,7142,'bg','Ð“Ñ€ÑƒÐ¿Ð¸ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð·Ð° ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(257083,7142,'ur','Ú©Ø³Ù¹Ù…Ø± Ú¯Ø±ÙˆÙ¾ÙˆÚº Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§ Ú©Û’ Ù„ÛŒÛ’',0),(257084,7142,'sr','Ð“Ñ€ÑƒÐ¿Ðµ ÐºÑƒÐ¿Ð°Ñ†Ð° Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(257085,7142,'vi','NhÃ³m KhÃ¡ch hÃ ng cho MÃ£ HÃ ng HÃ³a',0),(257086,7142,'af','Klant / KliÃ«nt Groepe vir Voorraaditems',0),(257087,7142,'ro','Grupuri de clienti pentru articole din gestiune',0),(257088,7142,'et','Kliendigruppide laokaupade puhul',0),(257089,7142,'si','Skupine kupcev za artikle v zalogi',0),(257090,7142,'ba','Kelompok pelanggan untuk barang-barang inventori',0),(257091,7142,'nl','Klantgroepen voor voorraadartikelen',0),(257092,7142,'fi','AsiakasryhmÃ¤t varastonimikkeille',0),(257093,7142,'no','Kundegrupper for varer pÃ¥ lager',0),(257094,7142,'da','Debitorgrupper for lagervarer',0),(257095,7142,'ko','ì¸ë²¤í† ë¦¬ í•­ëª©ì— ëŒ€ í•œ ê³ ê° ê·¸ë£¹',0),(257096,7142,'he','×§×‘×•×¦×•×ª ×œ×§×•×—×•×ª ×¢×‘×•×¨ ×¤×¨×™×˜×™ ×ž×œ××™',0),(257097,7142,'el','ÎŸÎ¼Î¬Î´ÎµÏ‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î³Î¹Î± ÎµÎ¯Î´Î· Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(257098,7142,'zh','å­˜è´§é¡¹ç›®çš„å®¢æˆ·ç¾¤ä½“\r\n',0),(257099,7142,'sv','Kundgrupper fÃ¶r lagerartiklar',0),(257100,7142,'it','Gruppi di clienti per gli articoli di magazzino',0),(257101,7142,'tl','',0),(257102,7142,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(257103,7142,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹à¥‹à¤‚',0),(257104,7142,'ms','Golongan pelanggan bagi item inventori',0),(257105,7142,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(257106,7142,'fr','Groupes de clients pour des articles en stock',0),(257107,7142,'jp','åœ¨åº«å“ç›®ã®é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—',0),(257108,7142,'pt','Grupos de clientes para itens de estoque',0),(257109,7142,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð´Ð»Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð½Ð¾-Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ñ… Ñ†ÐµÐ½Ð½Ð¾ÑÑ‚ÐµÐ¹',0),(257110,7142,'es','Grupos de Clientes para Items de Inventario',0),(257111,7142,'de','Kundengruppen fÃ¼r Lagerartikel',0),(257112,7142,'en','Customer Groups for Inventory Items',0),(257113,7143,'is','',0),(257114,7143,'dr','ØªØ±Ø§Ø² Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ Ø¬Ø²Ø¡ Ø¨Ù‡ Ø¬Ø²Ø¡',0),(257115,7143,'pr','ØªØ±Ø§Ø² Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ Ø¬Ø²Ø¡ Ø¨Ù‡ Ø¬Ø²Ø¡',0),(257116,7143,'tr','BilanÃ§o - detaylÄ± deneme',0),(257117,7143,'pl','Bilans - prÃ³ba SzczegÃ³Å‚owa',0),(257118,7143,'bg','Ð‘Ð°Ð»Ð°Ð½Ñ - Ð¿Ð¾Ð´Ñ€Ð¾Ð±ÐµÐ½ Ð¿Ñ€Ð¾Ð±ÐµÐ½',0),(257119,7143,'ur','Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ - ØªÙØµÛŒÙ„ÛŒ Ù…Ù‚Ø¯Ù…Û’ Ú©ÛŒ Ø³Ù…Ø§Ø¹Øª',0),(257120,7143,'sr','Ð‘Ð¸Ð»Ð°Ð½Ñ ÑÑ‚Ð°ÑšÐ° - Ð´ÐµÑ‚Ð°Ñ™Ð½Ðµ ÑÑƒÑ’ÐµÑšÐµ',0),(257121,7143,'vi','Chi tiáº¿t DÆ° ná»£ thá»­',0),(257122,7143,'af','Gedetailleerde Proefbalans',0),(257123,7143,'ro','BilanÅ£ul - studiu detaliat',0),(257124,7143,'et','Bilanss - Ã¼ksikasjalik uuring',0),(257125,7143,'si','Bilanca stanja - podrobne sojenja',0),(257126,7143,'ba','Neraca - rinci Trial',0),(257127,7143,'nl','Balans - gedetailleerde proces',0),(257128,7143,'fi','Tase - yksityiskohtaiset oikeudenkÃ¤ynti',0),(257129,7143,'no','Balanse - detaljert prÃ¸veversjon',0),(257130,7143,'da','Balancen - detaljerede retssag',0),(257131,7143,'ko','ëŒ€ì°¨ ëŒ€ì¡°í‘œ-ìƒì„¸í•œ ìž¬íŒ',0),(257132,7143,'he','×ž××–×Ÿ × ×¡×™×•×Ÿ ×ž×¤×•×¨×˜',0),(257133,7143,'el','Î™ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ - Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¯Ï‚ Î´Î¯ÎºÎ·',0),(257134,7143,'zh','è¯¦ç»†çš„è¯•ç®—è¡¨\r\n',0),(257135,7143,'sv','BalansrÃ¤kning - detaljerad rÃ¤ttegÃ¥ng',0),(257136,7143,'it','Stato patrimoniale - prova dettagliata',0),(257137,7143,'tl','',0),(257138,7143,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3591;&#3610;&#3607;&#3604;&#3621;&#3629;&#3591;',0),(257139,7143,'hi','à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ - à¤µà¤¿à¤¸à¥à¤¤à¥ƒà¤¤ à¤ªà¤°à¥€à¤•à¥à¤·à¤£',0),(257140,7143,'ms','Lembaran imbangan - perbicaraan yang terperinci',0),(257141,7143,'ar','Ù…ÙŠØ²Ø§Ù† Ø§Ù„Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ù…ÙØµÙ‘Ù„',0),(257142,7143,'fr','Bilan - essai dÃ©taillÃ©',0),(257143,7143,'jp','ãƒãƒ©ãƒ³ã‚¹ ã‚·ãƒ¼ãƒˆ - è©³ç´°ãªè©¦é¨“',0),(257144,7143,'pt','BalanÃ§o - julgamento detalhado',0),(257145,7143,'ru','Ð‘Ð°Ð»Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚ - Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾Ð³Ð¾ Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(257146,7143,'es','Balance de ComprobaciÃ³n Detallado',0),(257147,7143,'de','Bilanz - detaillierte Studie',0),(257148,7143,'en','Balance Sheet - Detailed Trial',0),(257149,7144,'is','',0),(257150,7144,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø²Ù…Ø§Ù† ÙƒØ§Ø± Ø¯Ø§Ø®Ù„ÙŠ ',0),(257151,7144,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø²Ù…Ø§Ù† ÙƒØ§Ø± Ø¯Ø§Ø®Ù„ÙŠ ',0),(257152,7144,'tr','Ä°Ã§ Ã§alÄ±ÅŸma zamanÄ± DeÄŸiÅŸtir',0),(257153,7144,'pl','Edycja czasu pracy wewnÄ™trznej',0),(257154,7144,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(257155,7144,'ur','ÙˆÙ‚Øª Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ú©Ø§Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(257156,7144,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ¸ Ñ€Ð°Ð´Ð½Ð¸ Ð²Ñ€Ð¸Ñ˜ÐµÐ¼Ðµ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐ°',0),(257157,7144,'vi','Sá»­a Thá»i Gian LÃ m Viá»‡c Ná»™i Bá»™',0),(257158,7144,'af','Redigeer Interne Werkstyd',0),(257159,7144,'ro','Editare interne de lucru timp',0),(257160,7144,'et','Redigeeri sisemise tÃ¶Ã¶ ajal',0),(257161,7144,'si','Uredi notranji delovni Äas',0),(257162,7144,'ba','Mengedit waktu kerja Internal',0),(257163,7144,'nl','Interne werktijd bewerken',0),(257164,7144,'fi','Muokkaa sisÃ¤inen tyÃ¶aika',0),(257165,7144,'no','Redigere interne arbeidstid',0),(257166,7144,'da','Redigere indre arbejdstid',0),(257167,7144,'ko','ë‚´ë¶€ ìž‘ì—… ì‹œê°„ íŽ¸ì§‘',0),(257168,7144,'he','×¢×¨×™×›×ª ×–×ž×Ÿ ×¢×‘×•×“×” ×¤× ×™×ž×™×ª',0),(257169,7144,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® ÎµÏÎ³Î±ÏƒÎ¯Î± Ï‡ÏÏŒÎ½Î¿',0),(257170,7144,'zh','ç¼–è¾‘å†…éƒ¨ä½œä¸šæ—¶é—´\r\n',0),(257171,7144,'sv','Redigera inre arbetstid',0),(257172,7144,'it','Modificare il tempo di lavoro interno',0),(257173,7144,'tl','',0),(257174,7144,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3616;&#3634;&#3618;&#3651;&#3609;',0),(257175,7144,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤•à¤¾à¤® à¤•à¥‡ à¤¸à¤®à¤¯ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(257176,7144,'ms','Edit masa kerja dalaman',0),(257177,7144,'ar','ØªØ­Ø±ÙŠØ± ÙˆÙ‚Øª Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(257178,7144,'fr','Modifier le temps de travail interne',0),(257179,7144,'jp','å†…éƒ¨ã®ä½œæ¥­æ™‚é–“ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(257180,7144,'pt','Editar o tempo de trabalho interno',0),(257181,7144,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÐµÐµ Ð Ð°Ð±Ð¾Ñ‡ÐµÐµ Ð’Ñ€ÐµÐ¼Ñ',0),(257182,7144,'es','Editar Tiempo de Trabajo Internal',0),(257183,7144,'de','Bearbeiten interne Arbeitszeit',0),(257184,7144,'en','Edit Internal Work Time',0),(257185,7145,'is','',0),(257186,7145,'dr','/ Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ / ÙƒÙ¾ÙŠ  / Ú†Ø§Ù¾ ÙØ±Ù…Ø§ÛŒØ´ ',0),(257187,7145,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ / Ú†Ø§Ù¾ Ù…Ø¬Ø¯Ø¯ / ÙƒÙ¾ÙŠ  / Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´ ',0),(257188,7145,'tr','DÃ¼zen/Kopyala sipariÅŸ YazdÄ±r yeni baskÄ±',0),(257189,7145,'pl','Edycja/przedruk kopii wydruku zleceÅ„',0),(257190,7145,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ð¿Ñ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ ÐºÐ¾Ð¿Ð¸Ðµ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(257191,7145,'ur','ØªØ¯ÙˆÛŒÙ†/Ù†Ù‚Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº Ø­Ú©Ù… Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹',0),(257192,7145,'sr','Ð£Ñ€ÐµÐ´Ð¸ /Ð¿Ð¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ ÐºÐ¾Ð¿Ð¸Ñ˜Ñƒ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(257193,7145,'vi','Sá»­a/In Láº¡i ÄÆ¡n Äáº·t HÃ ng In',0),(257194,7145,'af','Redigeer/Herdruk/KopiÃ«er/Druk Bestellings',0),(257195,7145,'ro','Editare/imprimaÅ£i comenzi de imprimare copie',0),(257196,7145,'et','Edit/kordustrÃ¼kk koopia trÃ¼kitÃ¶Ã¶de tellimused',0),(257197,7145,'si','Uredi/natisnite izvod tiskanje nalogov',0),(257198,7145,'ba','Edit/Cetak Ulang Pesanan',0),(257199,7145,'nl','Bewerken/herdruk kopie afdrukken bestellingen',0),(257200,7145,'fi','Muokkaa/uusintapainoksia kopio tulosta tilaukset',0),(257201,7145,'no','Rediger/trykke kopi bestilling',0),(257202,7145,'da','Rediger/genoptryk kopi aftryksbestillinger',0),(257203,7145,'ko','íŽ¸ì§‘/ë¬´ë‹¨ ì „ìž¬ ë³µì‚¬ ì¸ì‡„ ì£¼ë¬¸',0),(257204,7145,'he','×¢×¨×™×›×”/×”×“×¤×¡×” ×ž×—×“×© ×¢×•×ª×§ ×”×“×¤×¡×•×ª',0),(257205,7145,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±/Î±Î½Î±Ï„ÏÏ€Ï‰ÏƒÎ· Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½',0),(257206,7145,'zh','ç¼–è¾‘/é‡å°æ‹·è´æ‰“å°è®¢å•\r\n',0),(257207,7145,'sv','Redigera/Reprint kopia utskrift order',0),(257208,7145,'it','Modifica/ristampa copia stampa ordini',0),(257209,7145,'tl','',0),(257210,7145,'th','&#3649;&#3585;&#3657;&#3652;&#3586;/&#3614;&#3636;&#3617;&#3614;&#3660; &#3626;&#3635;&#3648;&#3609;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(257211,7145,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚/à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£',0),(257212,7145,'ms','Edit/pencetakan semula salinan cetakan arahan',0),(257213,7145,'ar','ØªØ­Ø±ÙŠØ±/Ø·Ø¨Ø¹ Ù†Ø³Ø® Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(257214,7145,'fr','Edit/rÃ©impression commandes copie',0),(257215,7145,'jp','ç·¨é›†/è»¢è¼‰ã‚³ãƒ”ãƒ¼ã®ãƒ—ãƒªãƒ³ãƒˆã®æ³¨æ–‡',0),(257216,7145,'pt','Editar/reimprimir pedidos de impressÃ£o de cÃ³pia',0),(257217,7145,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ/ÐŸÐµÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚ÐºÐ° ÐºÐ¾Ð¿Ð¸Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(257218,7145,'es','Editar/Reimprimir Copiar Ordenes de ImpresiÃ³n',0),(257219,7145,'de','Bearbeiten/Reprint Kopie DruckauftrÃ¤ge',0),(257220,7145,'en','Edit/Reprint Copy Print Orders',0),(257221,7146,'is','',0),(257222,7146,'dr','Ø§Ø±Ø´Ø¯ÙŠØªâ€Œ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(257223,7146,'pr','Ø§Ø±Ø´Ø¯ÙŠØªâ€Œ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(257224,7146,'tr','Ã‡alÄ±ÅŸanÄ±n KÄ±dem',0),(257225,7146,'pl','StaÅ¼ pracownika',0),(257226,7146,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ð¾ ÑÑ‚Ð°Ñ€ÑˆÐ¸Ð½ÑÑ‚Ð²Ð¾',0),(257227,7146,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ù¾ÛÙ„ÛŒ ØªÙˆ Ø³ÛŒÙ†ÛŒØ§Ø±Ù¹ÛŒ',0),(257228,7146,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÑÑ‚Ð°Ð¶Ð°',0),(257229,7146,'vi','ThÃ¢m niÃªn NhÃ¢n viÃªn',0),(257230,7146,'af','Senior Werknemer ',0),(257231,7146,'ro','Vechimea angajatului',0),(257232,7146,'et','TÃ¶Ã¶taja staaÅ¾',0),(257233,7146,'si','Delovna doba zaposlenega',0),(257234,7146,'ba','Karyawan senioritas',0),(257235,7146,'nl','AnciÃ«nniteit van de werknemer',0),(257236,7146,'fi','TyÃ¶ntekijÃ¤n virkaikÃ¤',0),(257237,7146,'no','Ansattes ansiennitet',0),(257238,7146,'da','Medarbejder anciennitet',0),(257239,7146,'ko','ì§ì› ì„ ìž„',0),(257240,7146,'he','×•×ª×§ ×”×¢×•×‘×“',0),(257241,7146,'el','Î‘ÏÏ‡Î±Î¹ÏŒÏ„Î·Ï„Î± Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚',0),(257242,7146,'zh','å‘˜å·¥å·¥é¾„\r\n',0),(257243,7146,'sv','AnstÃ¤lldas tjÃ¤nsteÃ¥lder',0),(257244,7146,'it','AnzianitÃ  del dipendente',0),(257245,7146,'tl','',0),(257246,7146,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3629;&#3634;&#3623;&#3640;&#3650;&#3626;',0),(257247,7146,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¤°à¤¿à¤·à¥à¤ à¤¤à¤¾',0),(257248,7146,'ms','Kekananan pekerja',0),(257249,7146,'ar','Ø£Ù‚Ø¯Ù…ÙŠØ© Ø§Ù„Ù…ÙˆØ¸Ù',0),(257250,7146,'fr','AnciennetÃ© de l\'employÃ©',0),(257251,7146,'jp','å¾“æ¥­å“¡ã®å‹¤ç¶šæ—¥æ•°',0),(257252,7146,'pt','Antiguidade do empregado',0),(257253,7146,'ru','ÐŸÐµÐ½ÑÐ¸Ñ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(257254,7146,'es','Empleado AntigÃ¼edad',0),(257255,7146,'de','Mitarbeiter Dienstalter',0),(257256,7146,'en','Employee Seniority',0),(257257,7147,'is','',0),(257258,7147,'dr','Ø«Ø¨Øª Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù¾ÙŠÙ…Ø§Ù†ÙƒØ§Ø±ÙŠ',0),(257259,7147,'pr','Ø«Ø¨Øª Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù¾ÙŠÙ…Ø§Ù†ÙƒØ§Ø±ÙŠ',0),(257260,7147,'tr','ParÃ§a baÅŸÄ± iÅŸ gruplarÄ±nÄ± girin',0),(257261,7147,'pl','Wpisz grupy pracy akordowej',0),(257262,7147,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð±Ñ€Ð¾Ð¹ÐºÐ° Ð³Ñ€ÑƒÐ¿Ð¸',0),(257263,7147,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ú¯Ø±ÙˆÛ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(257264,7147,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð³Ñ€ÑƒÐ¿Ðµ',0),(257265,7147,'vi','Nháº­p nhÃ³m lÃ m khoÃ¡n',0),(257266,7147,'af','Invoer van Stukwerk Groepe',0),(257267,7147,'ro','Intre grupurile de acord',0),(257268,7147,'et','Sisestage tÃ¼kitÃ¶Ã¶ rÃ¼hmad',0),(257269,7147,'si','Vnesite skupine akord',0),(257270,7147,'ba','Masukkan Piecework kelompok',0),(257271,7147,'nl','Voer stukloon groepen',0),(257272,7147,'fi','Kirjoita urakkatyÃ¶ryhmÃ¤t',0),(257273,7147,'no','Angi akkordgrupper',0),(257274,7147,'da','Angiv akkordgrupper',0),(257275,7147,'ko','Piecework ê·¸ë£¹ ìž…ë ¥',0),(257276,7147,'he','×”×–×Ÿ ×§×‘×•×¦×•×ª ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(257277,7147,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Ï‡Î¿Ï…ÏƒÎ±Ï‚ Î¿Î¼Î¬Î´ÎµÏ‚',0),(257278,7147,'zh','è¾“å…¥è®¡ä»¶ç»„',0),(257279,7147,'sv','Ange ackordgrupper',0),(257280,7147,'it','Entrare in gruppi di lavoro a cottimo',0),(257281,7147,'tl','',0),(257282,7147,'th','&#3611;&#3657;&#3629;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;&#3591;&#3634;&#3609;&#3592;&#3657;&#3634;&#3591;&#3648;&#3627;&#3617;&#3634;',0),(257283,7147,'hi','Piecework à¤¸à¤®à¥‚à¤¹ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(257284,7147,'ms','Masukkan Piecework Kumpulan',0),(257285,7147,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(257286,7147,'fr','Entrer dans des groupes de travail Ã  la piÃ¨ce',0),(257287,7147,'jp','å‡ºæ¥é«˜æ‰•ã„ã‚°ãƒ«ãƒ¼ãƒ—ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(257288,7147,'pt','Insira os grupos de trabalho por tarefa',0),(257289,7147,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ ÑÐ´ÐµÐ»ÑŒÐ½Ð¾Ð¹',0),(257290,7147,'es','Introducir Gupos de Trabajo por Pieza',0),(257291,7147,'de','Geben Sie Akkord Gruppen',0),(257292,7147,'en','Enter Piecework Groups',0),(257293,7148,'is','',0),(257294,7148,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§ ÙŠØ§ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(257295,7148,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§ ÙŠØ§ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(257296,7148,'tr','Ã–deme veya Ã§ek BorÃ§lar iÃ§in kullanÄ±lan hesaplarÄ± girin/gÃ¼ncelleme',0),(257297,7148,'pl','WprowadÅº/aktualizacja pÅ‚atnoÅ›ci lub kontrola kont uÅ¼ywane dla zobowiÄ…zaÅ„',0),(257298,7148,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð·Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(257299,7148,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ÛŒØ§ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(257300,7148,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð¸Ð»Ð¸ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ð¸ ÐºÐ¾Ñ€Ð¸ÑˆÑ‚ÐµÐ½Ð¸ Ð·Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(257301,7148,'vi','Nháº­p/Cáº­p Nháº­t Thanh ToÃ¡n hay TK Kiá»ƒm Tra Sá»­ Dá»¥ng Cho TK Pháº£i Tráº£',0),(257302,7148,'af','Invoer/Opdateer Betaling of Tjekrekening Gebruik Vir Uitgawes (RB)',0),(257303,7148,'ro','IntroduceÅ£i/actualizare platÄƒ sau de verificare a conturilor utilizate pentru datorii',0),(257304,7148,'et','Sisestamine/ajakohastamine makse vÃµi kontrolli kontosid kasutatakse vÃµlad',0),(257305,7148,'si','Vnesite posodobitev plaÄilne ali banÄni raÄuni uporabljajo za obveznosti',0),(257306,7148,'ba','Masukkan Update pembayaran atau rekening digunakan untuk hutang',0),(257307,7148,'nl','Invoeren/bijwerken betaling of controle van de rekeningen gebruikt voor schulden',0),(257308,7148,'fi','PÃ¤ivittÃ¤minen maksu tai tileistÃ¤ kÃ¤ytetÃ¤Ã¤n ostojen',0),(257309,7148,'no','Angi/Oppdater betaling eller sjekker regnskapet brukes For leverandÃ¸rgjeld',0),(257310,7148,'da','Indtaste/opdatere betaling eller kontrol af regnskaber bruges til gÃ¦ld',0),(257311,7148,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ ì§€ë¶ˆ ë˜ëŠ” ë¯¸ì§€ê¸‰ê¸ˆì— ëŒ€ í•œ ì‚¬ìš© í•˜ëŠ” ë‹¹ì¢Œ ê³„ì •',0),(257312,7148,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×ª×©×œ×•× ××• ×—×©×‘×•× ×•×ª ×‘× ×§ ×”×ž×©×ž×© ×¢×‘×•×¨ ×–×›××™×',0),(257313,7148,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î® Ï„Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Ï„Ï‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Î³Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(257314,7148,'zh','è¾“å…¥/æ›´æ–°ç”¨äºŽæ”¯ä»˜çš„åº”ä»˜æ¬¾é¡¹æˆ–æ”¯ç¥¨å¸æˆ·',0),(257315,7148,'sv','Ange/uppdatera betalning eller kontroll konton fÃ¶r leverantÃ¶rsskulder',0),(257316,7148,'it','Inserisci/Aggiorna pagamento o conti correnti utilizzati per debiti',0),(257317,7148,'tl','',0),(257318,7148,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3627;&#3619;&#3639;&#3629;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&',0),(257319,7148,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¤¾ à¤œà¤¾à¤à¤š à¤–à¤¾à¤¤à¥‡ Payables à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(257320,7148,'ms','Masukkan/Kemaskini pembayaran atau menyemak akaun yang digunakan untuk pembayaran',0),(257321,7148,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¯ÙØ¹ Ø£Ùˆ Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(257322,7148,'fr','Entrez/mise Ã  jour de paiement ou la vÃ©rification des comptes utilisÃ©s pour des comptes fournisseurs',0),(257323,7148,'jp','æ”¯æ‰•ã„ã‚„è²·æŽ›é‡‘ç”¨ã®å½“åº§é é‡‘å£åº§ã®å…¥åŠ›/æ›´æ–°',0),(257324,7148,'pt','Inserir/atualizar pagamento ou utilizado para pagar contas',0),(257325,7148,'ru','Ð’Ð²Ð¾Ð´/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ ÑÑ‡ÐµÑ‚Ð¾Ð², Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ñ… Ð´Ð»Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(257326,7148,'es','Introducir/Actualizar Cuentas de Cheques o Pagos Usados para Proveedores',0),(257327,7148,'de','Geben Sie/Update Zahlung oder Girokonten fÃ¼r Verbindlichkeiten verwendet',0),(257328,7148,'en','Enter/Update Payment or Checking Accounts Used For Payables',0),(257329,7149,'is','',0),(257330,7149,'dr','Ù…Ø±Ø§ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(257331,7149,'pr','Ù…Ø±Ø§ÙƒØ² Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(257332,7149,'tr','GL maliyet merkezleri',0),(257333,7149,'pl','GL MPK',0),(257334,7149,'bg','GL Cost Centers',0),(257335,7149,'ur','Ø¬ÛŒØ¬Û’ Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ø§Ú©Ø²',0),(257336,7149,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð“Ð›',0),(257337,7149,'vi','Cost Center Sá»• CÃ¡i Tá»•ng Há»£p',0),(257338,7149,'af','AG Koste Sentrums',0),(257339,7149,'ro','Centre de Cost GL',0),(257340,7149,'et','GL kulukeskuste',0),(257341,7149,'si','GL StroÅ¡kovni centri',0),(257342,7149,'ba','GL biaya Pusat',0),(257343,7149,'nl','GL kostenplaatsen',0),(257344,7149,'fi','GL kustannuspaikat',0),(257345,7149,'no','GL kostsentre',0),(257346,7149,'da','GL omkostningssteder',0),(257347,7149,'ko','GL ë¹„ìš© ì„¼í„°',0),(257348,7149,'he','×ž×¨×›×–×™ ×¢×œ×•×ª GL',0),(257349,7149,'el','GL ÎºÎ­Î½Ï„ÏÎ± ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(257350,7149,'zh','æ€»å¸æˆæœ¬ä¸­å¿ƒ\r\n',0),(257351,7149,'sv','GL kostnadsstÃ¤llen',0),(257352,7149,'it','Centri di costo GL',0),(257353,7149,'tl','',0),(257354,7149,'th','&#3624;&#3641;&#3609;&#3618;&#3660;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(257355,7149,'hi','à¤œà¥€à¤à¤² à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤¨à¥à¤¦à¥à¤°à¥‹à¤‚',0),(257356,7149,'ms','Pusat-Pusat kos GL',0),(257357,7149,'ar','Ù…Ø±Ø§ÙƒØ² ØªÙƒÙ„ÙØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(257358,7149,'fr','Centres de coÃ»ts GL',0),(257359,7149,'jp','GL åŽŸä¾¡ã‚»ãƒ³ã‚¿ãƒ¼',0),(257360,7149,'pt','Centros de custo GL',0),(257361,7149,'ru','GL ÐœÐ’Ð—',0),(257362,7149,'es','LM Centros de Costo',0),(257363,7149,'de','GL-Kostenstellen',0),(257364,7149,'en','GL Cost Centers',0),(257365,7150,'is','',0),(257366,7150,'dr','Ø³Ø·ÙˆØ­ Ø®Ù„Ø§ØµÙ‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(257367,7150,'pr','Ø³Ø·ÙˆØ­ Ø®Ù„Ø§ØµÙ‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(257368,7150,'tr','GL Ã–zet dÃ¼zeyleri',0),(257369,7150,'pl','Podsumowanie poziomu GL',0),(257370,7150,'bg','GL Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð¸Ð²Ð°',0),(257371,7150,'ur','Ø¬ÛŒØ¬Û’ Ø®Ù„Ø§ØµÛ Ø³Ø·Ø­ÛŒÚº',0),(257372,7150,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ð²Ð¾Ðµ Ð“Ð›',0),(257373,7150,'vi','Má»©c Tá»•ng quÃ¡t sá»• cÃ¡i',0),(257374,7150,'af','AG Opsommingsvlakke',0),(257375,7150,'ro','GL Rezumat niveluri',0),(257376,7150,'et','GL kokkuvÃµtlik tasemed',0),(257377,7150,'si','GL Povzetek ravni',0),(257378,7150,'ba','Tingkat ringkasan GL',0),(257379,7150,'nl','GL samenvatting niveaus',0),(257380,7150,'fi','GL Yhteenveto tasot',0),(257381,7150,'no','GL Sammendrag nivÃ¥er',0),(257382,7150,'da','GL sammenfattende niveauer',0),(257383,7150,'ko','GL ìš”ì•½ ìˆ˜ì¤€',0),(257384,7150,'he','×¨×ž×•×ª ×¡×™×›×•× GL',0),(257385,7150,'el','GL ÎµÏ€Î¯Ï€ÎµÎ´Î± ÏƒÏÎ½Î¿ÏˆÎ·Ï‚',0),(257386,7150,'zh','æ€»å¸æ°´å¹³ç»¼è¿°\r\n',0),(257387,7150,'sv','GL Sammanfattning nivÃ¥er',0),(257388,7150,'it','Riepilogo livelli GL',0),(257389,7150,'tl','',0),(257390,7150,'th','GL à¸ªà¸£à¸¸à¸›à¸£à¸°à¸”à¸±à¸š',0),(257391,7150,'hi','à¤œà¥€à¤à¤² à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¸à¥à¤¤à¤°',0),(257392,7150,'ms','GL rumusan peringkat',0),(257393,7150,'ar','Ù…Ø³ØªÙˆÙŠØ§Øª Ø®Ù„Ø§ØµØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(257394,7150,'fr','Niveaux rÃ©sumÃ©s GL',0),(257395,7150,'jp','GL ã‚µãƒžãƒªãƒ¼ ãƒ¬ãƒ™ãƒ«',0),(257396,7150,'pt','NÃ­veis de Resumo de GL',0),(257397,7150,'ru','Ð¡ÑƒÐ¼Ð¼Ð°Ñ€Ð½Ñ‹Ðµ ÑƒÑ€Ð¾Ð²Ð½Ð¸ GL',0),(257398,7150,'es','LM Niveles de Resumenes',0),(257399,7150,'de','GL-Zusammenfassung-Ebenen',0),(257400,7150,'en','GL Summary Levels',0),(257401,7151,'is','',0),(257402,7151,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ØªÙˆØ²ÙŠØ¹ Ù‡Ø§ ',0),(257403,7151,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ØªÙˆØ²ÙŠØ¹ Ù‡Ø§ ',0),(257404,7151,'tr','DaÄŸÄ±tÄ±m ithalat',0),(257405,7151,'pl','Import dystrybucja',0),(257406,7151,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(257407,7151,'ur','ØªÙ‚Ø³ÛŒÙ…ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(257408,7151,'sr','Ð£Ð²Ð¾Ð· Ð¸ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ†Ð¸Ñ˜Ð°',0),(257409,7151,'vi','Nháº­p phÃ¢n phá»‘i',0),(257410,7151,'af','Invoer van Verspreiding',0),(257411,7151,'ro','Import distributie',0),(257412,7151,'et','Impordi jaotus',0),(257413,7151,'si','UvaÅ¾anje distribucijskih',0),(257414,7151,'ba','Impor distribusi',0),(257415,7151,'nl','Importeren van distributie',0),(257416,7151,'fi','Tuo jakelu',0),(257417,7151,'no','Importere distribusjon',0),(257418,7151,'da','Importere Distribution',0),(257419,7151,'ko','ìˆ˜ìž… ìœ í†µ',0),(257420,7151,'he','×™×™×‘×•× ×”×¤×¦×”',0),(257421,7151,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î´Î¹Î±Î½Î¿Î¼Î®Ï‚',0),(257422,7151,'zh','å¯¼å…¥æåŠ©\r\n',0),(257423,7151,'sv','Importera Distribution',0),(257424,7151,'it','Importazione distribuzione',0),(257425,7151,'tl','',0),(257426,7151,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3585;&#3634;&#3619;&#3592;&#3635;&#3627;&#3609;&#3656;&#3634;&#3618;',0),(257427,7151,'hi','à¤†à¤¯à¤¾à¤¤ à¤µà¤¿à¤¤à¤°à¤£',0),(257428,7151,'ms','Pengagihan import',0),(257429,7151,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨',0),(257430,7151,'fr','Importation Distribution',0),(257431,7151,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®åˆ†å¸ƒ',0),(257432,7151,'pt','DistribuiÃ§Ã£o de importaÃ§Ã£o',0),(257433,7151,'ru','Ð Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(257434,7151,'es','DistribuciÃ³n de Importaciones',0),(257435,7151,'de','Import Vertrieb',0),(257436,7151,'en','Import Distribution',0),(257437,7152,'is','',0),(257438,7152,'dr','CSV Files ',0),(257439,7152,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ§ÙŠÙ„Ù‡Ø§ÙŠ Ø§Ø³ÙƒÙŠ Ø¨Ø±Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ù‡Ø§  CSV Files ',0),(257440,7152,'tr','KomisyonlarÄ± iÃ§in DistribÃ¼tÃ¶r CSV dosyalarÄ±nÄ± iÃ§e aktarma',0),(257441,7152,'pl','Importowanie plikÃ³w CSV dystrybutor dla prowizji',0),(257442,7152,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¾Ñ€ CSV Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ Ð·Ð° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸',0),(257443,7152,'ur','Ú©Ù…ÛŒØ´Ù† Ú©Û’ Ù„ÛŒÛ’ ÚˆØ³Ù¹Ø±ÛŒØ¨ÛŒÙˆÙ¹Ø± CSV ÙØ§Ø¦Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(257444,7152,'sr','Ð£Ð²ÐµÐ·Ð¸ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚ÐµÑ€ Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ð¿Ñ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ðµ',0),(257445,7152,'vi','Nháº­p há»“ sÆ¡ phÃ¢n phá»‘i CSV cho hoa há»“ng',0),(257446,7152,'af','Invoer van Verspreider CSV LÃªers vir Kommissies',0),(257447,7152,'ro','ImportaÅ£i fiÅŸiere CSV distribuitor pentru comisioane',0),(257448,7152,'et','Import turustaja CSV faile komisjonitasud',0),(257449,7152,'si','Uvozne datoteke CSV distributer za provizije',0),(257450,7152,'ba','Mengimpor file CSV Distributor untuk Komisi',0),(257451,7152,'nl','Distributeur CSV-bestanden importeren voor commissies',0),(257452,7152,'fi','Tuo jakelija CSV-tiedostoja palkkiot',0),(257453,7152,'no','Importere DistributÃ¸r CSV-filer for provisjoner',0),(257454,7152,'da','Importere distributÃ¸r CSV-filer for provisioner',0),(257455,7152,'ko','ìˆ˜ìˆ˜ë£Œì— ëŒ€ í•œ ë°°í¬ìž CSV íŒŒì¼ ê°€ì ¸ì˜¤ê¸°',0),(257456,7152,'he','×œ×™×™×‘× ×§×‘×¦×™ CSV ×ž×¤×™×¥ ×¢×‘×•×¨ ×¢×ž×œ×•×ª',0),(257457,7152,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±ÏÏ‡ÎµÎ¯Î± CSV Î´Î¹Î±Î½Î¿Î¼Î­Î±Ï‚ Î³Î¹Î± Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚',0),(257458,7152,'zh','å¯¼å…¥åˆ†é”€å•†çš„ä½£é‡‘é€—å·åˆ†éš”å€¼æ–‡ä»¶\r\n',0),(257459,7152,'sv','Importera distributÃ¶r CSV-filer fÃ¶r provisioner',0),(257460,7152,'it','Importare il file CSV distributore per le commissioni',0),(257461,7152,'tl','',0),(257462,7152,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3585;&#3634;&#3619;&#3592;&#3635;&#3627;&#3609;&#3656;&#3634;&#3618;&#3652;&#3615;&#3621;&#3660; CSV &#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#359',0),(257463,7152,'hi','à¤•à¤®à¥€à¤¶à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤¤à¤°à¤• CSV à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(257464,7152,'ms','Mengimport fail CSV pengedar untuk komisen',0),(257465,7152,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù„ÙØ§Øª CSV Ø§Ù„Ù…ÙˆØ²Ø¹ Ù„Ù„Ø¬Ø§Ù†',0),(257466,7152,'fr','Importer des fichiers CSV de distributeur pour les Commissions',0),(257467,7152,'jp','æ‰‹æ•°æ–™ã®ãƒ‡ã‚£ã‚¹ãƒˆãƒªãƒ“ãƒ¥ãƒ¼ã‚¿ãƒ¼ã® CSV ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(257468,7152,'pt','Importar arquivos CSV de distribuidor para as comissÃµes',0),(257469,7152,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ñ„Ð°Ð¹Ð»Ð¾Ð² CSV Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑŒ Ð´Ð»Ñ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¹',0),(257470,7152,'es','Distribuidor de Importaciones Archivos de CDV para Comisiones',0),(257471,7152,'de','Importieren Sie Verteiler-CSV-Dateien, fÃ¼r Provisionen',0),(257472,7152,'en','Import Distributor CSV Files for Commissions',0),(257473,7153,'is','',0),(257474,7153,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(257475,7153,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(257476,7153,'tr','Inv Ã¶ÄŸeleri al',0),(257477,7153,'pl','Importuj elementy Inv',0),(257478,7153,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð¹ Ð˜Ð½Ð²',0),(257479,7153,'ur','Ø§Ù†Ùˆ Ø§Ø´ÛŒØ§Ø¡ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(257480,7153,'sr','Ð£Ð²Ð¾Ð· ÑÑ‚Ð°Ð²ÐºÐ¸ Ð˜Ð½Ð²',0),(257481,7153,'vi','Nháº­p Danh Má»¥c HÃ ng HÃ³a',0),(257482,7153,'af','Invoer van Voorraaditems',0),(257483,7153,'ro','Import Inv elemente',0),(257484,7153,'et','Impordi tooted',0),(257485,7153,'si','UvaÅ¾aj Inv',0),(257486,7153,'ba','Impor Inv item',0),(257487,7153,'nl','Inv Items importeren',0),(257488,7153,'fi','Tuo Inv kohteet',0),(257489,7153,'no','Importere Inv',0),(257490,7153,'da','Importer Inv emner',0),(257491,7153,'ko','Inv í•­ëª© ê°€ì ¸ì˜¤ê¸°',0),(257492,7153,'he','×™×‘× ×¤×¨×™×˜×™ ×ž×œ××™',0),(257493,7153,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Inv',0),(257494,7153,'zh','å¯¼å…¥åº“å­˜é¡¹ç›®\r\n',0),(257495,7153,'sv','Importera Inv objekt',0),(257496,7153,'it','Importazione di elementi Inv',0),(257497,7153,'tl','',0),(257498,7153,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(257499,7153,'hi','Inv à¤†à¤‡à¤Ÿà¤® à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(257500,7153,'ms','Import barang-barang songsang',0),(257501,7153,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(257502,7153,'fr','Importer des Ã©lÃ©ments Inv',0),(257503,7153,'jp','Inv ã‚¢ã‚¤ãƒ†ãƒ ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(257504,7153,'pt','Importar itens de Inv',0),(257505,7153,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Inv',0),(257506,7153,'es','Importar Items de Inventario',0),(257507,7153,'de','Inv-Elemente importieren',0),(257508,7153,'en','Import Inv Items',0),(257509,7154,'is','',0),(257510,7154,'dr','CSV File',0),(257511,7154,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§Ø§Ø² ÙØ§ÙŠÙ„ Ø§Ø³ÙƒÙŠ CSV File',0),(257512,7154,'tr','Stok maddeleri CSV dosyasÄ±ndan iÃ§e aktarma',0),(257513,7154,'pl','Importowanie zapasÃ³w z pliku CSV',0),(257514,7154,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð¾Ñ‚ CSV Ñ„Ð°Ð¹Ð»',0),(257515,7154,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡ CSV Ù…Ø³Ù„ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(257516,7154,'sr','Ð£Ð²Ð¾Ð· Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° Ð¸Ð· Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(257517,7154,'vi','Nháº­p Danh Má»¥c HÃ ng HÃ³a Tá»« Há»“ SÆ¡ CSV',0),(257518,7154,'af','Invoer van Voorraaditems Vanaf CSV LÃªer',0),(257519,7154,'ro','Obiecte de inventar de import din fiÅŸier CSV',0),(257520,7154,'et','Impordi tooted CSV failina',0),(257521,7154,'si','Uvozite elemente zaloge iz datoteke CSV',0),(257522,7154,'ba','Barang-barang inventaris impor dari CSV File',0),(257523,7154,'nl','Voorraadartikelen importeren uit CSV-bestand',0),(257524,7154,'fi','Varastonimikkeiden tuominen CSV-tiedostosta',0),(257525,7154,'no','Importere lagervarer fra CSV-fil',0),(257526,7154,'da','Importere lagervarer fra CSV-fil',0),(257527,7154,'ko','CSV íŒŒì¼ì—ì„œ ê°€ì ¸ì˜¤ê¸° ìž¬ê³  ëª©ë¡ í’ˆëª©',0),(257528,7154,'he','CSV ×™×‘× ×¤×¨×˜×™ ×ž×œ××™ ×ž×§×•×‘×¥',0),(257529,7154,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ Î±Ï€ÏŒ Î±ÏÏ‡ÎµÎ¯Î¿ CSV',0),(257530,7154,'zh','ä»Žé€—å·åˆ†éš”å€¼æ–‡ä»¶å¯¼å…¥åº“å­˜é¡¹ç›®\r\n',0),(257531,7154,'sv','Importera lagerartiklar frÃ¥n CSV-filen',0),(257532,7154,'it','Articoli di magazzino di importazione da File CSV',0),(257533,7154,'tl','',0),(257534,7154,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3592;&#3634;&#3585;&#3652;&#3615;&#3621;&#3660; CSV',0),(257535,7154,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¸à¥‡ CSV à¤«à¤¼à¤¾à¤‡à¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(257536,7154,'ms','Mengimport item inventori dari fail CSV',0),(257537,7154,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù…Ù† Ù…Ù„Ù CSV',0),(257538,7154,'fr','Articles en stock Import de fichier CSV',0),(257539,7154,'jp','åœ¨åº«å“ç›® CSV ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(257540,7154,'pt','Importar itens do inventÃ¡rio do arquivo CSV',0),(257541,7154,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð½Ð¾Ð¼ÐµÐ½ÐºÐ»Ð°Ñ‚ÑƒÑ€Ñ‹ Ð¸Ð· CSV-Ñ„Ð°Ð¹Ð»Ð°',0),(257542,7154,'es','Importar Items de Inventario De Archivo de  CDV',0),(257543,7154,'de','Lagerartikel aus CSV-Datei importieren',0),(257544,7154,'en','Import Inventory Items From CSV File',0),(257545,7155,'is','',0),(257546,7155,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(257547,7155,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(257548,7155,'tr','Envanter Madde SatÄ±cÄ± fiyatlarÄ±',0),(257549,7155,'pl','Ceny dostawcy zapasÃ³w magazynowych',0),(257550,7155,'bg','Ð¦ÐµÐ½Ð¸ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(257551,7155,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ ÙˆÛŒÙ†ÚˆØ± Ù‚ÛŒÙ…ØªÙˆÚº',0),(257552,7155,'sr','Ð¦ÐµÐ½Ð° Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(257553,7155,'vi','GiÃ¡ Cá»§a NgÆ°á»i Cung Cáº¥p HÃ ng HÃ³a',0),(257554,7155,'af','Voorraaditem Verskafferspryse',0),(257555,7155,'ro','Inventarul articol furnizor preturi',0),(257556,7155,'et','Kaubavaru kauba mÃ¼Ã¼ja hinnad',0),(257557,7155,'si','Cene zaloge artikla dobavitelja',0),(257558,7155,'ba','Persediaan barang Vendor harga',0),(257559,7155,'nl','Inventaris Item Vendor prijzen',0),(257560,7155,'fi','Varaston toimittajan nimikehinnat',0),(257561,7155,'no','Lager varepriser leverandÃ¸r',0),(257562,7155,'da','Lageret leverandÃ¸ren varepriser',0),(257563,7155,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ê°€ê²© ê³µê¸‰ ì—…ì²´',0),(257564,7155,'he','×ž×—×™×¨×™ ×¡×¤×§ ×ž×œ××™ ×¤×¨×™×˜×™×',0),(257565,7155,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Ï„Î¹Î¼ÏŽÎ½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÎµÎ¹Î´ÏŽÎ½',0),(257566,7155,'zh','åº“å­˜ç‰©å“ä¾›åº”å•†çš„ä»·æ ¼\r\n',0),(257567,7155,'sv','Inventering artikelpriser fÃ¶r leverantÃ¶r',0),(257568,7155,'it','Prezzi di inventario articoli fornitore',0),(257569,7155,'tl','',0),(257570,7155,'th','&#3619;&#3634;&#3588;&#3634;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(257571,7155,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€à¤®à¤¤à¥‹à¤‚',0),(257572,7155,'ms','Harga penjual Item inventori',0),(257573,7155,'ar','Ø£Ø³Ø¹Ø§Ø± Ù…ÙˆØ±Ù‘Ø¯ÙŠ Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(257574,7155,'fr','Prix de l\'inventaire article fournisseur',0),(257575,7155,'jp','åœ¨åº«å“ç›®ã®ä»•å…¥å…ˆä¾¡æ ¼',0),(257576,7155,'pt','InventÃ¡rio Item fornecedor preÃ§os',0),(257577,7155,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ñ†ÐµÐ½Ñ‹',0),(257578,7155,'es','Item de Inventario Precios de Proveedor',0),(257579,7155,'de','Inventar Artikelpreise Hersteller',0),(257580,7155,'en','Inventory Item Vendor Prices',0),(257581,7156,'is','',0),(257582,7156,'dr','Ø§ØµÙ„Ø§Ø­Ø§Øª ÙƒØ§Ù„Ø§ ',0),(257583,7156,'pr','Ø§ØµÙ„Ø§Ø­Ø§Øª ÙƒØ§Ù„Ø§ ',0),(257584,7156,'tr','Ã–ÄŸeyi ayarlar',0),(257585,7156,'pl','Przedmiot regulacji',0),(257586,7156,'bg','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(257587,7156,'ur','Ø´Û’ Ú©ÛŒ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(257588,7156,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(257589,7156,'vi','Chá»‰nh hÃ ng',0),(257590,7156,'af','Item Aanpassings',0),(257591,7156,'ro','Element ajustÄƒri',0),(257592,7156,'et','Toodete kohandamine',0),(257593,7156,'si','Element prilagoditve',0),(257594,7156,'ba','Penyesuaian item',0),(257595,7156,'nl','Item aanpassingen',0),(257596,7156,'fi','Kohteen mukautukset',0),(257597,7156,'no','Elementet justeringer',0),(257598,7156,'da','Vare justeringer',0),(257599,7156,'ko','í•­ëª© ì¡°ì •',0),(257600,7156,'he','×”×ª××ž×•×ª ×¤×¨×™×˜×™×',0),(257601,7156,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Ï„Î¿Ï… ÎµÎ¯Î´Î¿Ï…Ï‚',0),(257602,7156,'zh','é¡¹ç›®è°ƒæ•´\r\n',0),(257603,7156,'sv','Objektet justeringar',0),(257604,7156,'it','Voce rettifiche',0),(257605,7156,'tl','',0),(257606,7156,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(257607,7156,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(257608,7156,'ms','Pelarasan item',0),(257609,7156,'ar','ØªØ¹Ø¯ÙŠÙ„ ÙƒÙ…Ù‘ÙŠÙ‘Ø© ØµÙ†Ù',0),(257610,7156,'fr','Ajustements de l\'Ã©lÃ©ment',0),(257611,7156,'jp','é …ç›®ã®èª¿æ•´',0),(257612,7156,'pt','Ajustes de item',0),(257613,7156,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(257614,7156,'es','Item Ajuste',0),(257615,7156,'de','Element-Anpassungen',0),(257616,7156,'en','Item Adjustments',0),(257617,7157,'is','',0),(257618,7157,'dr','Ø´Ø±Ø­ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ ',0),(257619,7157,'pr','Ø´Ø±Ø­ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ ',0),(257620,7157,'tr','Madde gruplarÄ± seÃ§eneÄŸi Desc',0),(257621,7157,'pl','Element opcji grupy Desc',0),(257622,7157,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ð¿Ñ†Ð¸Ñ Ð³Ñ€ÑƒÐ¿Ð¸ Ð½Ð¸Ð·Ñ….',0),(257623,7157,'ur','Ø´Û’ Ø§Ø®ØªÛŒØ§Ø± Ø¯ÛŒØ³Ú© Ú¯Ø±ÙˆÙ¾',0),(257624,7157,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð³Ñ€ÑƒÐ¿Ð¸ÑˆÐµ Ð”ÐµÑÑ†',0),(257625,7157,'vi','MÃ´ táº£ NhÃ³m lá»±a chá»n hÃ ng',0),(257626,7157,'af','Item Opsie Groepe Beskr',0),(257627,7157,'ro','Element opÅ£iunea grupuri Desc',0),(257628,7157,'et','Kauba valik rÃ¼hmitab Desc',0),(257629,7157,'si','Element moÅ¾nost skupine Desc',0),(257630,7157,'ba','Item pilihan kelompok Desc',0),(257631,7157,'nl','Object groepen optie Desc',0),(257632,7157,'fi','Tuotteen vaihtoehtoryhmien Desc',0),(257633,7157,'no','Element grupper alternativet synkende',0),(257634,7157,'da','Element grupper mulighed Desc',0),(257635,7157,'ko','í•­ëª© ì˜µì…˜ ê·¸ë£¹ ì„¤ëª…',0),(257636,7157,'he','×¤×¨×™×˜ ×‘××¤×©×¨×•×ª ×§×‘×•×¦×•×ª Desc',0),(257637,7157,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÏ€Î¹Î»Î¿Î³Î® Î¿Î¼Î¬Î´ÎµÏ‚ Desc',0),(257638,7157,'zh','é¡¹ç›®é€‰é¡¹ç»„æè¿°\r\n',0),(257639,7157,'sv','Objektet grupper alternativ Desc',0),(257640,7157,'it','Elemento opzione gruppi Desc',0),(257641,7157,'tl','',0),(257642,7157,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(257643,7157,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¥‡ à¤µà¤¿à¤•à¤²à¥à¤ª Desc',0),(257644,7157,'ms','Item opsyen Kumpulan Desc',0),(257645,7157,'ar','Ø¨ÙŠØ§Ù† Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„ØµÙ†Ù',0),(257646,7157,'fr','Question Option groupes Desc',0),(257647,7157,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ ã‚°ãƒ«ãƒ¼ãƒ— Desc é …ç›®',0),(257648,7157,'pt','Item opÃ§Ã£o agrupa Desc',0),(257649,7157,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Desc',0),(257650,7157,'es','Item Grupos de Opciones Desc.',0),(257651,7157,'de','Element Gruppen Option Desc',0),(257652,7157,'en','Item Option Groups Desc',0),(257653,7158,'is','',0),(257654,7158,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(257655,7158,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(257656,7158,'tr','Madde SatÄ±cÄ± fiyatlarÄ±',0),(257657,7158,'pl','Ceny towaru dostawcy',0),(257658,7158,'bg','Ð¦ÐµÐ½Ð¸ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(257659,7158,'ur','Ø´Û’ ÙˆÛŒÙ†ÚˆØ± Ù‚ÛŒÙ…ØªÙˆÚº',0),(257660,7158,'sr','Ð¦ÐµÐ½Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(257661,7158,'vi','GiÃ¡ hÃ ng cá»§a ngÆ°á»i bÃ¡n',0),(257662,7158,'af','Item Verskaffer Pryse',0),(257663,7158,'ro','PreÅ£urile de furnizor articolelor',0),(257664,7158,'et','Toote hankijate hinnad',0),(257665,7158,'si','Cene artiklov dobavitelja',0),(257666,7158,'ba','Harga barang Vendor',0),(257667,7158,'nl','Leverancier artikelprijzen',0),(257668,7158,'fi','Toimittajan nimikehinnat',0),(257669,7158,'no','LeverandÃ¸ren varepriser',0),(257670,7158,'da','Kreditor varepriser',0),(257671,7158,'ko','í•­ëª© ê³µê¸‰ ì—…ì²´ ê°€ê²©',0),(257672,7158,'he','×ž×—×™×¨×™ ×¡×¤×§ ×©×œ ×”×¤×¨×™×˜',0),(257673,7158,'el','Î•Î¯Î´Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¹Î¼Î­Ï‚',0),(257674,7158,'zh','ç‰©å“ä¾›åº”å•†çš„ä»·æ ¼\r\n',0),(257675,7158,'sv','Artikelpriser fÃ¶r leverantÃ¶r',0),(257676,7158,'it','Prezzi degli articoli Fornitore',0),(257677,7158,'tl','',0),(257678,7158,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(257679,7158,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€à¤®à¤¤à¥‹à¤‚',0),(257680,7158,'ms','Harga penjual item',0),(257681,7158,'ar','Ø£Ø³Ø¹Ø§Ø± Ù…ÙˆØ±Ù‘Ø¯ Ø§Ù„ØµÙ†Ù',0),(257682,7158,'fr','Prix fournisseur article',0),(257683,7158,'jp','å•†å“ä»•å…¥å…ˆä¾¡æ ¼',0),(257684,7158,'pt','PreÃ§os de fornecedor',0),(257685,7158,'ru','Ð¦ÐµÐ½Ñ‹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(257686,7158,'es','Item Precios de Proveedor',0),(257687,7158,'de','Kreditor Artikelpreise',0),(257688,7158,'en','Item Vendor Prices',0),(257689,7159,'is','',0),(257690,7159,'dr','Ù„ÙŠØ³Øª Ø±ØªØ¨Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(257691,7159,'pr','Ù„ÙŠØ³Øª Ø±ØªØ¨Ù‡ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(257692,7159,'tr','Ã‡alÄ±ÅŸanÄ±n kÄ±dem listesi',0),(257693,7159,'pl','Wykaz pracownikÃ³w staÅ¼',0),(257694,7159,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¿Ð¾ ÑÑ‚Ð°Ñ€ÑˆÐ¸Ð½ÑÑ‚Ð²Ð¾',0),(257695,7159,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ù¾ÛÙ„ÛŒ ØªÙˆ Ø³ÛŒÙ†ÛŒØ§Ø±Ù¹ÛŒ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(257696,7159,'sr','Ð¡Ð¿Ð¸ÑÐ°Ðº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… ÑÑ‚Ð°Ð¶Ð°',0),(257697,7159,'vi','Danh sÃ¡ch thÃ¢m niÃªn nhÃ¢n viÃªn',0),(257698,7159,'af','Lys van Senior Werknemer',0),(257699,7159,'ro','ListÄƒ de vechimea angajatului',0),(257700,7159,'et','Nimekiri tÃ¶Ã¶tajate staaÅ¾ist',0),(257701,7159,'si','Seznam delovna doba zaposlenega',0),(257702,7159,'ba','Daftar karyawan senioritas',0),(257703,7159,'nl','Lijst van de anciÃ«nniteit van de werknemer',0),(257704,7159,'fi','Luettelo tyÃ¶ntekijÃ¤n virkaikÃ¤',0),(257705,7159,'no','Liste over ansattes ansiennitet',0),(257706,7159,'da','Liste over medarbejder anciennitet',0),(257707,7159,'ko','ì§ì› ì„ ìž„ì˜ ëª©ë¡',0),(257708,7159,'he','×¨×©×™×ž×ª ×•×ª×§ ×”×¢×•×‘×“',0),(257709,7159,'el','Î›Î¯ÏƒÏ„Î± Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î±ÏÏ‡Î±Î¹ÏŒÏ„Î·Ï„Î±Ï‚',0),(257710,7159,'zh','èŒå·¥å·¥é¾„åå•\r\n',0),(257711,7159,'sv','Lista Ã¶ver medarbetare fÃ¶retrÃ¤de',0),(257712,7159,'it','Lista di anzianitÃ  dei dipendenti',0),(257713,7159,'tl','',0),(257714,7159,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3619;&#3632;&#3604;&#3633;&#3610;&#3629;&#3634;&#3623;&#3640;&#3650;&#3626;',0),(257715,7159,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¤°à¤¿à¤·à¥à¤ à¤¤à¤¾ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(257716,7159,'ms','Senarai kekananan pekerja',0),(257717,7159,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø£Ù‚Ø¯Ù…ÙŠØ© Ø§Ù„Ù…ÙˆØ¸Ù',0),(257718,7159,'fr','Liste d\'anciennetÃ© des employÃ©s',0),(257719,7159,'jp','å¾“æ¥­å“¡ã®å‹¤ç¶šæ—¥æ•°ã®ãƒªã‚¹ãƒˆ',0),(257720,7159,'pt','Lista de antiguidade do empregado',0),(257721,7159,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑÑ‚Ð°Ð¶Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(257722,7159,'es','Lista de AntigÃ¼dad de Empleados',0),(257723,7159,'de','Liste der Mitarbeiter Dienstalter',0),(257724,7159,'en','List of Employee Seniority',0),(257725,7160,'is','',0),(257726,7160,'dr','Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ÙƒØ§Ù…Ù„  Ùˆ Ù…Ø¹ÙˆÙ‚',0),(257727,7160,'pr','Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ÙƒØ§Ù…Ù„  Ùˆ Ù…Ø¹ÙˆÙ‚',0),(257728,7160,'tr','Liste bekleyen ve tamamlanan RMAs',0),(257729,7160,'pl','Listy oczekujÄ…cych i wypeÅ‚niony RMAs',0),(257730,7160,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð§Ð°ÐºÐ°Ñ‰Ð¸ Ð¸ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ RMAs',0),(257731,7160,'ur','ÙÛØ±Ø³Øª Ù†Ø§Ù…Ú©Ù…Ù„ Ø§ÙˆØ± Ù…Ú©Ù…Ù„ Ø±Ù…ÛØ³',0),(257732,7160,'sr','Ð›Ð¸ÑÑ‚Ð° Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð¸ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸Ñ… Ð ÐœÐÑ',0),(257733,7160,'vi','Danh sÃ¡ch RMA Ä‘ang treo & hoÃ n thÃ nh',0),(257734,7160,'af','Lys Afwagtende en Voltooide \"RMAs\"',0),(257735,7160,'ro','Lista pÃ¢nÄƒ ÅŸi completat RMAs',0),(257736,7160,'et','Loendi ootel ja lÃµpetatud RMAs',0),(257737,7160,'si','Seznam do in dodelana RMAs',0),(257738,7160,'ba','Daftar tertunda dan selesai RMAs',0),(257739,7160,'nl','Lijst in afwachting van en voltooide RMAs',0),(257740,7160,'fi','Luettelo odottavat ja valmiit RMAs',0),(257741,7160,'no','Listen ventende og avsluttet RMAs',0),(257742,7160,'da','Liste over ventende og udfyldte RMAs',0),(257743,7160,'ko','ë³´ë¥˜ ì¤‘ì¸ ëª©ë¡ê³¼ ì™„ë£Œ ëœ Rma',0),(257744,7160,'he','×¨×©×™×ž×ª ×”×ž×ž×ª×™× ×™×, RMAs ×©×”×•×©×œ×ž×•',0),(257745,7160,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î® ÎºÎ±Î¹ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½Î· RMAs',0),(257746,7160,'zh','åˆ—å‡ºå¾…åŠžæˆ–å·²å®Œæˆçš„é€€è´§æŽˆæƒ\r\n',0),(257747,7160,'sv','Lista pÃ¥gÃ¥ende och avslutade RMA',0),(257748,7160,'it','Elenco in sospeso e completato RMAs',0),(257749,7160,'tl','',0),(257750,7160,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; RMAs &#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3632;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;',0),(257751,7160,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¸à¥‚à¤šà¥€ à¤”à¤° à¤ªà¥‚à¤°à¤¾ RMAs',0),(257752,7160,'ms','Senarai belum selesai dan siap RMAs',0),(257753,7160,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù†ØªØ¸Ø§Ø± Ùˆ RMAs Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø©',0),(257754,7160,'fr','Liste en attente et RMA rempli',0),(257755,7160,'jp','å®Œæˆã—ãŸ Rma ã¨ä¿ç•™ä¸­ã®ãƒªã‚¹ãƒˆ',0),(257756,7160,'pt','Lista pendente e RMAs concluÃ­dos',0),(257757,7160,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¾Ð¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ñ… Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ RMA',0),(257758,7160,'es','Listar RMAs Pendientes y Completados',0),(257759,7160,'de','Liste ausstehenden und abgeschlossene RMAs',0),(257760,7160,'en','List Pending and Completed RMAs',0),(257761,7161,'is','',0),(257762,7161,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… ',0),(257763,7161,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… ',0),(257764,7161,'tr','Bildirim istekleri',0),(257765,7161,'pl','ZgÅ‚oszenia Å¼Ä…dania',0),(257766,7161,'bg','Ð˜ÑÐºÐ°Ð½Ð¸Ñ Ð·Ð° ÑƒÐ²ÐµÐ´Ð¾Ð¼ÑÐ²Ð°Ð½Ðµ',0),(257767,7161,'ur','Ø§Ø·Ù„Ø§Ø¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(257768,7161,'sr','ÐžÐ±Ð°Ð²ÐµÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ',0),(257769,7161,'vi','YÃªu cáº§u thÃ´ng bÃ¡o',0),(257770,7161,'af','KENNISGEWING versoeke',0),(257771,7161,'ro','Cereri de notificare',0),(257772,7161,'et','Ekspordieelse teatamise',0),(257773,7161,'si','Obvestilu proÅ¡enj',0),(257774,7161,'ba','Permintaan pemberitahuan',0),(257775,7161,'nl','Verzoeken om meldingen',0),(257776,7161,'fi','IlmoituspyynnÃ¶t',0),(257777,7161,'no','-ForespÃ¸rsler om katalogvarsling',0),(257778,7161,'da','Anmodninger om besked om',0),(257779,7161,'ko','ì•Œë¦¼ ìš”ì²­',0),(257780,7161,'he','×”×•×“×¢×” ×¢×œ ×‘×§×©×•×ª',0),(257781,7161,'el','Î‘Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚',0),(257782,7161,'zh','é€šçŸ¥è¯·æ±‚\r\n',0),(257783,7161,'sv','AnmÃ¤lan-begÃ¤randen',0),(257784,7161,'it','Richieste di notifica',0),(257785,7161,'tl','',0),(257786,7161,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;',0),(257787,7161,'hi','à¤¸à¥‚à¤šà¤¨à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(257788,7161,'ms','Notis permintaan',0),(257789,7161,'ar','Ø·Ù„Ø¨Ø§Øª Ø¥Ø¹Ù„Ø§Ù…',0),(257790,7161,'fr','Demandes de notification',0),(257791,7161,'jp','é€šçŸ¥è¦æ±‚',0),(257792,7161,'pt','SolicitaÃ§Ãµes de notificaÃ§Ã£o',0),(257793,7161,'ru','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Ð¾ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°Ñ…',0),(257794,7161,'es','Solicitaciones de Notificaciones',0),(257795,7161,'de','Benachrichtigungsanforderungen',0),(257796,7161,'en','Notification Requests',0),(257797,7162,'is','',0),(257798,7162,'dr','Ø¯Ø³ØªØ±Ø³ÙŠ Ø³Ø±ÙŠØ¹ Ø¨Ù‡  ÙØ§ÙƒØªÙˆØ±Ù‡Ø§  Ø³ÙØ§Ø±Ø´Ø§Øª',0),(257799,7162,'pr','Ø¯Ø³ØªØ±Ø³ÙŠ Ø³Ø±ÙŠØ¹ Ø¨Ù‡  ÙØ§ÙƒØªÙˆØ±Ù‡Ø§  Ø³ÙØ§Ø±Ø´Ø§Øª',0),(257800,7162,'tr','SipariÅŸleri faturalara hÄ±zlÄ±',0),(257801,7162,'pl','ZamÃ³wienia szybko fakturach',0),(257802,7162,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð±ÑŠÑ€Ð·Ð¾',0),(257803,7162,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª ÙˆØ¨Ø¬Ù„ÛŒ ÙÙˆØ±ÛŒ',0),(257804,7162,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð±Ñ€Ð·Ð¾',0),(257805,7162,'vi','HÃ³a Ä‘Æ¡n Ä‘áº·t hÃ ng nhanh',0),(257806,7162,'af','Bestellings fakture vinnig',0),(257807,7162,'ro','Comenzi facturate rapid',0),(257808,7162,'et','Tellimuste arved Kiire',0),(257809,7162,'si','NaroÄila raÄune hitro',0),(257810,7162,'ba','Pesanan faktur cepat',0),(257811,7162,'nl','Bestellingen facturen Quick',0),(257812,7162,'fi','Tilauksia laskujen nopeasti',0),(257813,7162,'no','Bestillinger fakturaer rask',0),(257814,7162,'da','Ordrer fakturaer hurtig',0),(257815,7162,'ko','ì£¼ë¬¸ ì†¡ìž¥ ë¹ ë¥¸',0),(257816,7162,'he','×”×–×ž× ×•×ª ×•×—×©×‘×•× ×™×•×ª ×ž×”×¨',0),(257817,7162,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î³ÏÎ®Î³Î¿ÏÎ·',0),(257818,7162,'zh','å¿«é€Ÿè®¢å•å‘ç¥¨\r\n',0),(257819,7162,'sv','Order fakturor Quick',0),(257820,7162,'it','Quick fatture ordini',0),(257821,7162,'tl','',0),(257822,7162,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3648;&#3619;&#3656;&#3591;&#3604;&#3656;&#3623;&#3609;',0),(257823,7162,'hi','à¤†à¤¦à¥‡à¤¶ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¤à¥à¤µà¤°à¤¿à¤¤',0),(257824,7162,'ms','Cepat invois pesanan',0),(257825,7162,'ar','Ø£ÙˆØ§Ù…Ø± Ø³Ø±ÙŠØ¹Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(257826,7162,'fr','Commandes factures rapide',0),(257827,7162,'jp','æ³¨æ–‡ã®è«‹æ±‚æ›¸ã®ã‚¯ã‚¤ãƒƒã‚¯',0),(257828,7162,'pt','Ordens rÃ¡pidas de facturas',0),(257829,7162,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ ÑÑ‡ÐµÑ‚Ð° Ð±Ñ‹ÑÑ‚Ñ€Ð¾',0),(257830,7162,'es','Pedidos Facturas Rapidos',0),(257831,7162,'de','Bestellungen Rechnungen schnell',0),(257832,7162,'en','Orders Invoices Quick',0),(257833,7163,'is','',0),(257834,7163,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² ',0),(257835,7163,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² ',0),(257836,7163,'tr','SipariÅŸleri aÃ§',0),(257837,7163,'pl','Zlecenia otwarte',0),(257838,7163,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¾Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ',0),(257839,7163,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ú¾ÙˆÙ„ÛŒÚº',0),(257840,7163,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ ÐžÐ¿ÐµÐ½',0),(257841,7163,'vi','ÄÆ¡n HÃ ng Äá»ƒ Má»Ÿ',0),(257842,7163,'af','Open Bestellings',0),(257843,7163,'ro','Comenzi deschise',0),(257844,7163,'et','Tellimustele avatud',0),(257845,7163,'si','Odprtih naroÄil',0),(257846,7163,'ba','Pesanan terbuka',0),(257847,7163,'nl','Bestellingen openen',0),(257848,7163,'fi','Tilaukset auki',0),(257849,7163,'no','Bestillinger Ã¥pen',0),(257850,7163,'da','Ordrer Open',0),(257851,7163,'ko','ì£¼ë¬¸ ì˜¤í”ˆ',0),(257852,7163,'he','×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª',0),(257853,7163,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î¬Î½Î¿Î¹Î³Î¼Î±',0),(257854,7163,'zh','æ‰“å¼€è®¢å•\r\n',0),(257855,7163,'sv','BestÃ¤llningar Ã¶ppna',0),(257856,7163,'it','Ordini aperti',0),(257857,7163,'tl','',0),(257858,7163,'th','&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(257859,7163,'hi','à¤†à¤¦à¥‡à¤¶ à¤–à¥‹à¤²à¥‡à¤‚',0),(257860,7163,'ms','Perintah terbuka',0),(257861,7163,'ar','ÙØªØ­ Ø£ÙˆØ§Ù…Ø±',0),(257862,7163,'fr','Commandes ouvertes',0),(257863,7163,'jp','æ³¨æ–‡ã‚ªãƒ¼ãƒ—ãƒ³',0),(257864,7163,'pt','Encomendas abertas',0),(257865,7163,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(257866,7163,'es','Pedidos Abiertos',0),(257867,7163,'de','Bestellungen Ã¶ffnen',0),(257868,7163,'en','Orders Open',0),(257869,7164,'is','',0),(257870,7164,'dr','(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†Ùƒ',0),(257871,7164,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†Ùƒ',0),(257872,7164,'tr','Ã–deme Ã§ek hesaplarÄ±',0),(257873,7164,'pl','Sprawdzanie kont pÅ‚atniczych',0),(257874,7164,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(257875,7164,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(257876,7164,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ñ‡ÐµÐºÐ¾Ð²Ð½Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(257877,7164,'vi','TK Kiá»ƒm Tra Thanh ToÃ¡n',0),(257878,7164,'af','Uitbetaling Tjekrekeninge',0),(257879,7164,'ro','Conturile de verificare platÄƒ',0),(257880,7164,'et','Maksmine kontroll raamatupidamise',0),(257881,7164,'si','PlaÄilo preverjanje raÄunov',0),(257882,7164,'ba','Rekening pembayaran',0),(257883,7164,'nl','Betaling controle van de rekeningen',0),(257884,7164,'fi','Maksun tarkastaa tilit',0),(257885,7164,'no','Betaling sjekker regnskapet',0),(257886,7164,'da','Betaling lÃ¸nkonti',0),(257887,7164,'ko','ì§€ë¶ˆ ë‹¹ì¢Œ ê³„ì •',0),(257888,7164,'he','×ª×©×œ×•× ×—×©×‘×•× ×•×ª ×‘× ×§',0),(257889,7164,'el','Î¤Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Ï„Ï‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(257890,7164,'zh','ä»˜æ¬¾æ£€æŸ¥å¸æˆ·\r\n',0),(257891,7164,'sv','Betalning kontroll konton',0),(257892,7164,'it','Pagamento conti correnti',0),(257893,7164,'tl','',0),(257894,7164,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3594;&#3655;&#3588;',0),(257895,7164,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤œà¤¾à¤à¤š à¤–à¤¾à¤¤à¥‹à¤‚',0),(257896,7164,'ms','Bayaran menyemak akaun',0),(257897,7164,'ar','Ø§Ù„Ø¯ÙØ¹ Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(257898,7164,'fr','Comptes de chÃ¨ques de paiement',0),(257899,7164,'jp','ãŠæ”¯æ‰•ã„ã®å½“åº§é é‡‘å£åº§',0),(257900,7164,'pt','Contas de pagamento',0),(257901,7164,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÑ‡ÐµÑ‚Ð°',0),(257902,7164,'es','Pago Cuenta de Cheques',0),(257903,7164,'de','Zahlung-Girokonten',0),(257904,7164,'en','Payment Checking Accounts',0),(257905,7165,'is','',0),(257906,7165,'dr','ÙƒØ§Ø± Ù…Ø¹ÙˆÙ‚ ',0),(257907,7165,'pr','ÙƒØ§Ø± Ù…Ø¹ÙˆÙ‚ ',0),(257908,7165,'tr','Bekleyen Ã§alÄ±ÅŸma',0),(257909,7165,'pl','Czasu pracy',0),(257910,7165,'bg','Ð Ð°Ð±Ð¾Ñ‚ÑÑ‚ Ñ',0),(257911,7165,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Ø§Ù…',0),(257912,7165,'sr','ÐÐ° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð¿Ð¾ÑÐ»Ð°',0),(257913,7165,'vi','CÃ´ng viá»‡c Ä‘ang treo',0),(257914,7165,'af','Afwagtende Werk',0),(257915,7165,'ro','LucrÄƒrile Ã®n curs',0),(257916,7165,'et','Ootel tÃ¶Ã¶',0),(257917,7165,'si','Delo v ÄakajoÄa',0),(257918,7165,'ba','Pekerjaan yang tertunda',0),(257919,7165,'nl','In behandeling werk',0),(257920,7165,'fi','Odottava tyÃ¶',0),(257921,7165,'no','Ventende arbeid',0),(257922,7165,'da','Ventende arbejde',0),(257923,7165,'ko','ë³´ë¥˜ ì¤‘ì¸ ìž‘ì—…',0),(257924,7165,'he','×”×¢×‘×•×“×” ×ž×ž×ª×™× ×”',0),(257925,7165,'el','Î•ÎºÎºÏÎµÎ¼Î®Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(257926,7165,'zh','å¾…åŠžå·¥ä½œ\r\n',0),(257927,7165,'sv','PÃ¥gÃ¥ende arbete',0),(257928,7165,'it','Lavoro in sospeso',0),(257929,7165,'tl','',0),(257930,7165,'th','&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(257931,7165,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤•à¤¾à¤®',0),(257932,7165,'ms','Kerja-kerja yang belum selesai',0),(257933,7165,'ar','Ø£Ø¹Ù…Ø§Ù„ Ù…Ø¹Ù„Ù‚Ø©',0),(257934,7165,'fr','Travail en attente',0),(257935,7165,'jp','ä¿ç•™ä¸­ã®ä½œæ¥­',0),(257936,7165,'pt','Trabalho pendente',0),(257937,7165,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(257938,7165,'es','Trabajo Pendiente',0),(257939,7165,'de','Ausstehende',0),(257940,7165,'en','Pending Work',0),(257941,7166,'is','',0),(257942,7166,'dr','ÙƒØ§Ø± Ù…Ø¹ÙˆÙ‚ Ø·Ø¨Ù‚ Ù†Ø§Ø­ÙŠÙ‡',0),(257943,7166,'pr','ÙƒØ§Ø± Ù…Ø¹ÙˆÙ‚ Ø·Ø¨Ù‚ Ù†Ø§Ø­ÙŠÙ‡',0),(257944,7166,'tr','Bekleyen iÅŸ alanÄ± tarafÄ±ndan',0),(257945,7166,'pl','Czasu pracy przez obszar',0),(257946,7166,'bg','Ð Ð°Ð±Ð¾Ñ‚ÑÑ‚ Ð¿Ð¾ Ð¿Ð»Ð¾Ñ‰',0),(257947,7166,'ur','Ø¹Ù„Ø§Ù‚Û’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Ø§Ù…',0),(257948,7166,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ñ€Ð°Ð´ Ð¿Ð¾ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(257949,7166,'vi','CÃ´ng viá»‡c Ä‘ang treo theo khu vá»±c',0),(257950,7166,'af','Afwagtende Werk per Area',0),(257951,7166,'ro','LucrÄƒrile Ã®n curs de zonÄƒ',0),(257952,7166,'et','Ootel tÃ¶Ã¶d piirkonna',0),(257953,7166,'si','ÄŒakajoÄe dela po podroÄjih',0),(257954,7166,'ba','Tertunda karya Area',0),(257955,7166,'nl','In behandeling werk van gebied',0),(257956,7166,'fi','Odottava tyÃ¶ alueittain',0),(257957,7166,'no','Ventende arbeid av omrÃ¥det',0),(257958,7166,'da','Ventende arbejde efter omrÃ¥de',0),(257959,7166,'ko','ë³´ë¥˜ ì¤‘ì¸ ìž‘ì—… ì˜ì—­',0),(257960,7166,'he','×¢×‘×•×“×” ×ž×ž×ª×™× ×•×ª ×œ×¤×™ ××–×•×¨',0),(257961,7166,'el','Î•ÎºÎºÏÎµÎ¼Î®Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Ï€ÏŒ Ï„Î·Î½ Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(257962,7166,'zh','å¾…åŠžå·¥ä½œåŒº\r\n',0),(257963,7166,'sv','PÃ¥gÃ¥ende arbete av omrÃ¥det',0),(257964,7166,'it','Lavoro in sospeso di zona',0),(257965,7166,'tl','',0),(257966,7166,'th','&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;&#3650;&#3604;&#3618;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;',0),(257967,7166,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤²à¤‚à¤¬à¤¿à¤¤ à¤•à¤¾à¤®',0),(257968,7166,'ms','Kerja-kerja yang belum selesai mengikut kawasan',0),(257969,7166,'ar','Ø¹Ù…Ù„ Ù…Ø¹Ù„Ù‚Ø© Ø¨Ø§Ù„Ù…Ù†Ø·Ù‚Ø©',0),(257970,7166,'fr','Travail en attente par rÃ©gion',0),(257971,7166,'jp','ä¿ç•™ä¸­ã®ä½œæ¥­é ˜åŸŸã§',0),(257972,7166,'pt','Trabalho pendente por Ã¡rea',0),(257973,7166,'ru','Ð”Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð² Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(257974,7166,'es','Trabajo Pendiente por Ãrea',0),(257975,7166,'de','Ausstehende Stellenangebote Bereich',0),(257976,7166,'en','Pending Work by Area',0),(257977,7167,'is','',0),(257978,7167,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(257979,7167,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(257980,7167,'tr','ParÃ§a baÅŸÄ± iÅŸ grubu',0),(257981,7167,'pl','Grupy pracy akordowej',0),(257982,7167,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ð³Ñ€ÑƒÐ¿Ð¸',0),(257983,7167,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ú¯Ø±ÙˆÙ¾',0),(257984,7167,'sr','Ð“Ñ€ÑƒÐ¿Ðµ Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(257985,7167,'vi','NhÃ³m lÃ m khoÃ¡n',0),(257986,7167,'af','Stukwerk Groepe',0),(257987,7167,'ro','Grupuri de acord',0),(257988,7167,'et','TÃ¼kitÃ¶Ã¶ rÃ¼hmad',0),(257989,7167,'si','Akord skupine',0),(257990,7167,'ba','Kelompok-kelompok piecework',0),(257991,7167,'nl','Stukloon groepen',0),(257992,7167,'fi','UrakkatyÃ¶ryhmÃ¤t',0),(257993,7167,'no','Akkordgrupper',0),(257994,7167,'da','Akkordgrupper',0),(257995,7167,'ko','Piecework ê·¸ë£¹',0),(257996,7167,'he','×§×‘×•×¦×•×ª ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(257997,7167,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹ Î¿Î¼Î¬Î´ÎµÏ‚',0),(257998,7167,'zh','è®¡ä»¶ç»„\r\n',0),(257999,7167,'sv','Ackordgrupper',0),(258000,7167,'it','Gruppi di lavoro a cottimo',0),(258001,7167,'tl','',0),(258002,7167,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3619;&#3633;&#3610;&#3591;&#3634;&#3609;&#3648;&#3611;&#3655;&#3609;&#3619;&#3634;&#3618;&#3594;&#3636;&#3657;&#3609;',0),(258003,7167,'hi','Piecework à¤¸à¤®à¥‚à¤¹',0),(258004,7167,'ms','Kumpulan piecework',0),(258005,7167,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(258006,7167,'fr','Groupes de travail Ã  la piÃ¨ce',0),(258007,7167,'jp','å‡ºæ¥é«˜æ‰•ã„ã‚°ãƒ«ãƒ¼ãƒ—',0),(258008,7167,'pt','Grupos de trabalho por tarefa',0),(258009,7167,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½ÑƒÑŽ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(258010,7167,'es','Grupos de Trabajo por Pieza',0),(258011,7167,'de','Akkordgruppen',0),(258012,7167,'en','Piecework Groups',0),(258013,7168,'is','',0),(258014,7168,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(258015,7168,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(258016,7168,'tr','POS sipariÅŸler',0),(258017,7168,'pl','ZamÃ³wienia POS',0),(258018,7168,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ ÐŸÐžÐ¡',0),(258019,7168,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(258020,7168,'sr','ÐŸÐžÐ¡ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(258021,7168,'vi','ÄÆ¡n hÃ ng á»Ÿ Ä‘iá»ƒm bÃ¡n hÃ ng',0),(258022,7168,'af','PVV (\"POS\")Bestellings',0),(258023,7168,'ro','Comenzi de POS',0),(258024,7168,'et','POS tellimused',0),(258025,7168,'si','Nalogi POS',0),(258026,7168,'ba','POS perintah',0),(258027,7168,'nl','POS Orders',0),(258028,7168,'fi','POS tilauksia',0),(258029,7168,'no','POS ordrer',0),(258030,7168,'da','POS ordrer',0),(258031,7168,'ko','POS ì£¼ë¬¸',0),(258032,7168,'he','×”×–×ž× ×•×ª POS',0),(258033,7168,'el','POS ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(258034,7168,'zh','é”€å”®ç‚¹è®¢å•\r\n',0),(258035,7168,'sv','POS order',0),(258036,7168,'it','Ordini POS',0),(258037,7168,'tl','',0),(258038,7168,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; &#3603; &#3592;&#3640;&#3604;&#3586;&#3634;&#3618;',0),(258039,7168,'hi','POS à¤†à¤¦à¥‡à¤¶',0),(258040,7168,'ms','Pesanan POS',0),(258041,7168,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨ÙŠØ¹',0),(258042,7168,'fr','POS arrÃªtÃ©s',0),(258043,7168,'jp','PO ã®å—æ³¨',0),(258044,7168,'pt','Ordens de POS',0),(258045,7168,'ru','POS Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(258046,7168,'es','PDV Ordenes',0),(258047,7168,'de','POS-Bestellungen',0),(258048,7168,'en','POS Orders',0),(258049,7169,'is','',0),(258050,7169,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(258051,7169,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(258052,7169,'tr','PO notlarÄ±',0),(258053,7169,'pl','Notatki PO',0),(258054,7169,'bg','PO Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(258055,7169,'ur','Ù¾Ùˆ Ù†ÙˆÙ¹',0),(258056,7169,'sr','ÐŸÐž Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(258057,7169,'vi','Ghi chÃº Ä‘Æ¡n mua hÃ ng',0),(258058,7169,'af','AB Notas',0),(258059,7169,'ro','Note de PO',0),(258060,7169,'et','PO mÃ¤rkmed',0),(258061,7169,'si','PO pojasnilih',0),(258062,7169,'ba','Catatan PO',0),(258063,7169,'nl','PO notities',0),(258064,7169,'fi','PO toteaa',0),(258065,7169,'no','PO notater',0),(258066,7169,'da','PO noter',0),(258067,7169,'ko','í¬ ì£¼',0),(258068,7169,'he','×”×¢×¨×•×ª ×¤×•',0),(258069,7169,'el','PO ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(258070,7169,'zh','é‡‡è´­è®¢å•å¤‡æ³¨\r\n',0),(258071,7169,'sv','PO anteckningar',0),(258072,7169,'it','Note di PO',0),(258073,7169,'tl','',0),(258074,7169,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(258075,7169,'hi','PO à¤¨à¥‹à¤Ÿà¥à¤¸',0),(258076,7169,'ms','Nota-Nota PO',0),(258077,7169,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ø´Ø±Ø§Ø¡',0),(258078,7169,'fr','Notes de PO',0),(258079,7169,'jp','PO ãƒŽãƒ¼ãƒˆ',0),(258080,7169,'pt','Notas de PO',0),(258081,7169,'ru','PO Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(258082,7169,'es','OC Notas',0),(258083,7169,'de','PO ErlÃ¤uterungen',0),(258084,7169,'en','PO Notes',0),(258085,7170,'is','',0),(258086,7170,'dr','Ø«Ø¨Øª Ùˆ Ø¬Ø³ØªØ¬ÙˆÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(258087,7170,'pr','Ø«Ø¨Øª Ùˆ Ø¬Ø³ØªØ¬ÙˆÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(258088,7170,'tr','GiriÅŸ ve arama teklifi',0),(258089,7170,'pl','ZacytowaÄ‡ wpis i Szukaj',0),(258090,7170,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð¸ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(258091,7170,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø§ÙˆØ± ØªÙ„Ø§Ø´ Ø³Û’ Ø§Ù‚ØªØ¨Ø§Ø³',0),(258092,7170,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° ÑƒÐ½Ð¾Ñ Ð¸ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(258093,7170,'vi','Nháº­p BÃ¡o GiÃ¡ & TÃ¬m Kiáº¿m',0),(258094,7170,'af','Aanhaling inskrywing en soek',0),(258095,7170,'ro','Citat de intrare ÅŸi CÄƒutaÅ£i',0),(258096,7170,'et','Hinnapakkumise kirjet ja otsing',0),(258097,7170,'si','Citiram vstop in iskanje',0),(258098,7170,'ba','Mengutip entri dan pencarian',0),(258099,7170,'nl','Offerte ingang en zoeken',0),(258100,7170,'fi','MerkintÃ¤ ja Etsi',0),(258101,7170,'no','Sitere oppfÃ¸ring og sÃ¸k',0),(258102,7170,'da','Citat indrejse og sÃ¸ge',0),(258103,7170,'ko','ê²¬ì  í•­ëª© ë° ê²€ìƒ‰',0),(258104,7170,'he','×”×¦×¢×ª ×ž×—×™×¨ ×›× ×™×¡×” ×•×—×™×¤×•×©',0),(258105,7170,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï„Î·Î½ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÎºÎ±Î¹ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(258106,7170,'zh','æŠ¥ä»·è¾“å…¥å’Œæœç´¢\r\n',0),(258107,7170,'sv','Citera intrade och SÃ¶k',0),(258108,7170,'it','Quota iscrizione e ricerca',0),(258109,7170,'tl','',0),(258110,7170,'th','&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3649;&#3621;&#3632;&#3588;&#3657;&#3609;&#3627;&#3634;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;',0),(258111,7170,'hi','à¤¬à¥‹à¤²à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤”à¤° à¤–à¥‹à¤œ',0),(258112,7170,'ms','Petikan entri dan Cari',0),(258113,7170,'ar','Ø¥Ø¯Ø®Ø§Ù„ ÙˆØ§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(258114,7170,'fr','Cite l\'entrÃ©e et la perquisition',0),(258115,7170,'jp','å¼•ç”¨ã‚¨ãƒ³ãƒˆãƒªã¨æ¤œç´¢',0),(258116,7170,'pt','Entrada de citaÃ§Ã£o e pesquisa',0),(258117,7170,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¸ Ð¿Ð¾Ð¸ÑÐº',0),(258118,7170,'es','CotizaciÃ³n Entrada y Busqueda',0),(258119,7170,'de','Zitat Eintrag und Suche',0),(258120,7170,'en','Quote Entry and Search',0),(258121,7171,'is','',0),(258122,7171,'dr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø§Ø®ÙŠØ±Ø§ Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(258123,7171,'pr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø§Ø®ÙŠØ±Ø§ Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(258124,7171,'tr','Son zamanlarda mÃ¼ÅŸteriler listesine girdi',0),(258125,7171,'pl','PojawiÅ‚a siÄ™ lista klientÃ³w',0),(258126,7171,'bg','ÐÐ°ÑÐºÐ¾Ñ€Ð¾ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(258127,7171,'ur','Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº ØµØ§Ø±ÙÛŒÙ† Ú©ÛŒ ÙÛØ±Ø³Øª Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(258128,7171,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¾ ÑƒÐ½ÐµÑ‚Ð° Ð»Ð¸ÑÑ‚Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(258129,7171,'vi','Danh sÃ¡ch khÃ¡ch hÃ ng nháº­p gáº§n Ä‘Ã¢y ',0),(258130,7171,'af','Onlangse Ingevoerde Klante/KliÃ«nte Lys',0),(258131,7171,'ro','Intrat recent pe lista de clienÅ£ii',0),(258132,7171,'et','Hiljuti sisestatud hotelli loend',0),(258133,7171,'si','Pred kratkim zaÄel stranke seznam',0),(258134,7171,'ba','Baru saja memasuki daftar pelanggan',0),(258135,7171,'nl','Onlangs ingevoerd klanten lijst',0),(258136,7171,'fi','Ã„skettÃ¤in tuli asiakkaitamme',0),(258137,7171,'no','Nylig kom kundene liste',0),(258138,7171,'da','For nylig trÃ¥dte kunder liste',0),(258139,7171,'ko','ìµœê·¼ ê³ ê° ëª©ë¡ ìž…ë ¥',0),(258140,7171,'he','×œ××—×¨×•× ×” × ×›× ×¡ ×œ×¨×©×™×ž×ª ×”×œ×§×•×—×•×ª',0),(258141,7171,'el','Î•Î¹ÏƒÎ®Î»Î¸Îµ Ï€ÏÏŒÏƒÏ†Î±Ï„Î± Î»Î¯ÏƒÏ„Î± Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(258142,7171,'zh','æœ€è¿‘è¾“å…¥çš„å®¢æˆ·åå•\r\n',0),(258143,7171,'sv','Nyligen in kunder listan',0),(258144,7171,'it','Recentemente entrato elenco clienti',0),(258145,7171,'tl','',0),(258146,7171,'th','&#3611;&#3657;&#3629;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(258147,7171,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‚à¤šà¥€ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾',0),(258148,7171,'ms','Telah memasuki senarai pelanggan',0),(258149,7171,'ar','Ø¯Ø®Ù„Øª Ù…Ø¤Ø®Ø±Ø§ ÙÙŠ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(258150,7171,'fr','RÃ©cemment entrÃ© dans la liste de clients',0),(258151,7171,'jp','æœ€è¿‘ã€é¡§å®¢ãƒªã‚¹ãƒˆã‚’å…¥åŠ›',0),(258152,7171,'pt','Recentemente entrou a lista de clientes',0),(258153,7171,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð’Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ð¹ Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(258154,7171,'es','Lista de Clientes ReciÃ©n Entrada',0),(258155,7171,'de','Vor kurzem trat Kunden Liste',0),(258156,7171,'en','Recently Entered Customers List',0),(258157,7172,'is','',0),(258158,7172,'dr','/ Ø¯Ù„Ø§ÙŠÙ„ /Ø§Ù‚Ø¯Ø§Ù…Ø§Øª )',0),(258159,7172,'pr','Ø´Ø±Ø§ÙŠØ· Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ / Ø¯Ù„Ø§ÙŠÙ„ /Ø§Ù‚Ø¯Ø§Ù…Ø§Øª )',0),(258160,7172,'tr','RMA koÅŸullarÄ±/nedenleri/eylemleri',0),(258161,7172,'pl','RMA warunki/przyczyny/dziaÅ‚ania',0),(258162,7172,'bg','Ð Ð¡Ðž ÑƒÑÐ»Ð¾Ð²Ð¸Ñ/Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð¸/Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(258163,7172,'ur','Ø±Ù… Ø´Ø±Ø§Ø¦Ø·/ÙˆØ¬ÙˆÛØ§Øª Ú©ÛŒ Ø¨Ù†Ø§ Ù¾Ø±/Ø§Ø¹Ù…Ø§Ù„',0),(258164,7172,'sr','ÐžÐ¿Ñ ÑƒÑÐ»Ð¾Ð²Ð¸/Ñ€Ð°Ð·Ð»Ð¾Ð·Ð¸/Ñ€Ð°Ð´ÑšÐµ',0),(258165,7172,'vi','Äiá»u kiá»‡n RMA/LÃ½ do/HÃ ng Ä‘á»™ng',0),(258166,7172,'af','RMA voorwaardes/redes/aksies',0),(258167,7172,'ro','RMA condiÅ£ii/motive/actiuni',0),(258168,7172,'et','RMA tingimused/pÃµhjused/tegevused',0),(258169,7172,'si','RMA pogoji/razlogov ukrepov',0),(258170,7172,'ba','RMA kondisi/alasan/tindakan',0),(258171,7172,'nl','RMA voorwaarden/redenen/acties',0),(258172,7172,'fi','RMA ehdoissa tai syistÃ¤/toiminnoissa',0),(258173,7172,'no','RMA forhold/grunner/handlinger',0),(258174,7172,'da','RMA betingelser/Ã¥rsager/handlinger',0),(258175,7172,'ko','RMA ì¡°ê±´/ì´ìœ /ì•¡ì…˜',0),(258176,7172,'he','RMA ×ª× ××™×/×ž×¡×™×‘×•×ª/×¤×¢×•×œ×•×ª',0),(258177,7172,'el','RMA ÏƒÏ…Î½Î¸Î®ÎºÎµÏ‚/Î»ÏŒÎ³Î¿Ï…Ï‚/Î´ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(258178,7172,'zh','è¿”å›žå•†å“æŽˆæƒæ¡ä»¶/åŽŸå› /åŠ¨ä½œ\r\n',0),(258179,7172,'sv','RMA villkor/orsaker/Ã¥tgÃ¤rder',0),(258180,7172,'it','RMA condizioni/situazioni/azioni',0),(258181,7172,'tl','',0),(258182,7172,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;/&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;/&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619; RMA',0),(258183,7172,'hi','RMA à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿/à¤•à¤¾à¤°à¤£à¥‹à¤‚/à¤•à¥à¤°à¤¿à¤¯à¤¾à¤à¤',0),(258184,7172,'ms','RMA syarat/sebab/tindakan',0),(258185,7172,'ar','Ø­Ø§Ù„Ø§Øª/Ø£Ø³Ø¨Ø§Ø¨/Ø¹Ù…Ù„ÙŠØ§Øª Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(258186,7172,'fr','RMA Conditions/motifs/Actions',0),(258187,7172,'jp','RMA çŠ¶æ³/ç†ç”±/ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(258188,7172,'pt','RMA condiÃ§Ãµes/razÃµes/aÃ§Ãµes',0),(258189,7172,'ru','RMA ÑƒÑÐ»Ð¾Ð²Ð¸Ñ/Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ñ‹/Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(258190,7172,'es','RMA Condiciones/Razones/Acciones',0),(258191,7172,'de','RMA Bedingungen/GrÃ¼nde/Aktionen',0),(258192,7172,'en','RMA Conditions/Reasons/Actions',0),(258193,7173,'is','',0),(258194,7173,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(258195,7173,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(258196,7173,'tr','RMA listesi',0),(258197,7173,'pl','Lista RMA',0),(258198,7173,'bg','Ð Ð¡Ðž ÑÐ¿Ð¸ÑÑŠÐº',0),(258199,7173,'ur','Ø±Ù… Ú©ÛŒ ÙÛØ±Ø³Øª',0),(258200,7173,'sr','ÐžÐ¿Ñ Ð»Ð¸ÑÑ‚Ð°',0),(258201,7173,'vi','Danh sÃ¡ch RMA',0),(258202,7173,'af','RMA lys',0),(258203,7173,'ro','RMA lista',0),(258204,7173,'et','RMA nimekirjad',0),(258205,7173,'si','RMA seznam',0),(258206,7173,'ba','Daftar RMA',0),(258207,7173,'nl','RMA lijst',0),(258208,7173,'fi','RMA luettelo',0),(258209,7173,'no','RMA-listen',0),(258210,7173,'da','RMA liste',0),(258211,7173,'ko','RMA ëª©ë¡',0),(258212,7173,'he','×¨×©×™×ž×ª RMA',0),(258213,7173,'el','RMA Î»Î¯ÏƒÏ„Î±',0),(258214,7173,'zh','è¿”å›žå•†å“æŽˆæƒåˆ—è¡¨\r\n',0),(258215,7173,'sv','RMA lista',0),(258216,7173,'it','Elenco RMA',0),(258217,7173,'tl','',0),(258218,7173,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; RMA ',0),(258219,7173,'hi','RMA à¤¸à¥‚à¤šà¥€',0),(258220,7173,'ms','RMA senarai',0),(258221,7173,'ar','Ù‚ÙˆØ§Ø¦Ù… Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(258222,7173,'fr','Liste RMA',0),(258223,7173,'jp','RMA ã®ãƒªã‚¹ãƒˆ',0),(258224,7173,'pt','Lista RMA',0),(258225,7173,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº RMA',0),(258226,7173,'es','RMA Listas',0),(258227,7173,'de','RMA-Liste',0),(258228,7173,'en','RMA List',0),(258229,7174,'is','',0),(258230,7174,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ  Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(258231,7174,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ  Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(258232,7174,'tr','RMA Kur',0),(258233,7174,'pl','RMA instalacji',0),(258234,7174,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð Ð¡Ðž',0),(258235,7174,'ur','Ø±Ù… Ø³ÛŒÙ¹ Ø§Ù¾',0),(258236,7174,'sr','ÐžÐ¿Ñ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(258237,7174,'vi','Setup RMA',0),(258238,7174,'af','RMA opstelling',0),(258239,7174,'ro','RMA Setup',0),(258240,7174,'et','RMA seadistamine',0),(258241,7174,'si','RMA Setup',0),(258242,7174,'ba','RMA Setup',0),(258243,7174,'nl','RMA Setup',0),(258244,7174,'fi','RMA asetukset',0),(258245,7174,'no','RMA oppsett',0),(258246,7174,'da','RMA Setup',0),(258247,7174,'ko','RMA ì„¤ì¹˜',0),(258248,7174,'he','×”×’×“×¨×ª RMA',0),(258249,7174,'el','RMA ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(258250,7174,'zh','è¿”å›žå•†å“æŽˆæƒè®¾ç½®\r\n',0),(258251,7174,'sv','RMA Setup',0),(258252,7174,'it','RMA Setup',0),(258253,7174,'tl','',0),(258254,7174,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634; RMA ',0),(258255,7174,'hi','RMA à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(258256,7174,'ms','RMA persediaan',0),(258257,7174,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(258258,7174,'fr','Installation RMA',0),(258259,7174,'jp','RMA ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(258260,7174,'pt','InstalaÃ§Ã£o RMA',0),(258261,7174,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° RMA',0),(258262,7174,'es','RMA ConfiguraciÃ³n',0),(258263,7174,'de','RMA-Setup',0),(258264,7174,'en','RMA Setup',0),(258265,7175,'is','',0),(258266,7175,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ ',0),(258267,7175,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ ',0),(258268,7175,'tr','Arama SipariÅŸ YazdÄ±r',0),(258269,7175,'pl','Druk zamÃ³wienia wyszukiwania',0),(258270,7175,'bg','Ð¢ÑŠÑ€ÑÐ¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(258271,7175,'ur','ØªÙ„Ø§Ø´ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(258272,7175,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(258273,7175,'vi','TÃ¬m Ä‘Æ¡n hÃ ng in',0),(258274,7175,'af','Soek Gedrukte Bestellings',0),(258275,7175,'ro','CÄƒutaÅ£i ordine de imprimare',0),(258276,7175,'et','Otsi trÃ¼kitÃ¶Ã¶de tellimused',0),(258277,7175,'si','Nalogi za tiskanja',0),(258278,7175,'ba','Perintah cetak pencarian',0),(258279,7175,'nl','Zoek Print Orders',0),(258280,7175,'fi','Etsi Tulosta tilaukset',0),(258281,7175,'no','SÃ¸k etter bestilling',0),(258282,7175,'da','SÃ¸g aftryksbestillinger',0),(258283,7175,'ko','ê²€ìƒ‰ ì¸ì‡„ ì£¼ë¬¸',0),(258284,7175,'he','×—×™×¤×•×© ×”×“×¤×¡×•×ª',0),(258285,7175,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½',0),(258286,7175,'zh','æœç´¢å°åˆ·è®¢å•\r\n',0),(258287,7175,'sv','SÃ¶k Print Order',0),(258288,7175,'it','Stampa ordini di ricerca',0),(258289,7175,'tl','',0),(258290,7175,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(258291,7175,'hi','à¤–à¥‹à¤œ à¤•à¥‡ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶',0),(258292,7175,'ms','Pesanan cetakan Cari',0),(258293,7175,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(258294,7175,'fr','Impression mandats de perquisition',0),(258295,7175,'jp','æ¤œç´¢ã®ãƒ—ãƒªãƒ³ãƒˆã®æ³¨æ–‡',0),(258296,7175,'pt','Ordens de impressÃ£o de pesquisa',0),(258297,7175,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(258298,7175,'es','Busacar Ordenes de ImpresiÃ³n',0),(258299,7175,'de','Suche DruckauftrÃ¤ge',0),(258300,7175,'en','Search Print Orders',0),(258301,7176,'is','',0),(258302,7176,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÛŒÙˆØ²Ø±',0),(258303,7176,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Ø¨Ø±',0),(258304,7176,'tr','KullanÄ±cÄ± Ekle/GÃ¼ncelle',0),(258305,7176,'pl','Dodaj uÅ¼ytkownika/aktualizacja',0),(258306,7176,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(258307,7176,'ur','ØµØ§Ø±Ù Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(258308,7176,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(258309,7176,'vi','ThÃªm/Cáº­p Nháº­t NgÆ°á»i Sá»­ Dá»¥ng',0),(258310,7176,'af','Gebruiker Skep/Opdateer',0),(258311,7176,'ro','Utilizator AdÄƒugaÅ£i/actualizaÅ£i',0),(258312,7176,'et','Kasutaja Lisamine/Uuendamine',0),(258313,7176,'si','Uporabnik Dodaj/posodobi',0),(258314,7176,'ba','Pengguna Tambahkan/Perbarui',0),(258315,7176,'nl','Gebruiker toevoegen/upate',0),(258316,7176,'fi','KÃ¤yttÃ¤jÃ¤ lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(258317,7176,'no','Bruker Legg til/Oppdater',0),(258318,7176,'da','Bruger TilfÃ¸j/opdater',0),(258319,7176,'ko','ì‚¬ìš©ìž ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(258320,7176,'he','×”×•×¡×£/×¢×“×›×Ÿ ×ž×©×ª×ž×©',0),(258321,7176,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï‡ÏÎ®ÏƒÏ„Î·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(258322,7176,'zh','ç”¨æˆ·æ–°å¢ž/æ›´æ–°\r\n',0),(258323,7176,'sv','LÃ¤gg till anvÃ¤ndare/uppdatera',0),(258324,7176,'it','Utente aggiungere o aggiornare',0),(258325,7176,'tl','',0),(258326,7176,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(258327,7176,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(258328,7176,'ms','Pengguna tambah/Kemaskini',0),(258329,7176,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù…Ø³ØªØ®Ø¯Ù…',0),(258330,7176,'fr','Utilisateur ajouter/mettre Ã  jour',0),(258331,7176,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’è¿½åŠ /æ›´æ–°',0),(258332,7176,'pt','UsuÃ¡rio adicionar/atualizar',0),(258333,7176,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(258334,7176,'es','Usuario Agregar/Actualizar',0),(258335,7176,'de','Benutzer hinzufÃ¼gen/aktualisieren',0),(258336,7176,'en','User Add/Update',0),(258337,7177,'is','',0),(258338,7177,'dr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ø§Ø² ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ÙŠØ§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú¯Ø²Ø§Ø±Ø´ ',0),(258339,7177,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ù‡Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ø§Ø² ØªÙˆØ²ÙŠØ¹ ÙƒÙ†Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ ÙŠØ§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú¯Ø²Ø§Ø±Ø´ ',0),(258340,7177,'tr','Yazma komisyon kontrol DistribÃ¼tÃ¶r satÄ±ÅŸ veya raporu gÃ¶rÃ¼ntÃ¼le',0),(258341,7177,'pl','Kontrole Komisji zapisu z dystrybutora sprzedaÅ¼y lub WyÅ›wietl raport',0),(258342,7177,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸Ñ‚Ðµ Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð¾Ñ‚ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¾Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¸Ð»Ð¸ Ð¸Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(258343,7177,'ur','ØªØ­Ø±ÛŒØ± Ú©Ù…ÛŒØ´Ù† Ú†ÛŒÚ© ÚˆØ³Ù¹Ø±ÛŒØ¨ÛŒÙˆÙ¹Ø± Ø³ÛŒÙ„Ø² ÛŒØ§ Ù…Ù†Ø¸Ø± Ø±Ù¾ÙˆØ±Ù¹ Ø³Û’',0),(258344,7177,'sr','ÐŸÐ¸ÑÐ°ÑšÐµ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð¾Ð´ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚ÐµÑ€Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¸Ð»Ð¸ ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð·Ð²Ñ˜ÐµÑˆÑ‚Ð°Ñ˜',0),(258345,7177,'vi','Viáº¿c sÃ©c hoa há»“ng cho Ä‘áº¡i lÃ½ phÃ¢n phá»‘i hay xem bÃ¡o cÃ¡o',0),(258346,7177,'af','Skryf Kommissie Tjeks vanaf Verspreider Verkope of Besigtig Verslag',0),(258347,7177,'ro','Scrie controalelor Comisiei de vÃ¢nzare distribuitor sau Vizualizare raport',0),(258348,7177,'et','Write Commission Checks from Distributor Sales or View Report',0),(258349,7177,'si','Pregledi Komisije pisanje iz distributer prodaje ali ogled poroÄila',0),(258350,7177,'ba','Menulis cek komisi dari penjualan Distributor atau Lihat laporan',0),(258351,7177,'nl','Schrijven Commissie controles van distributeur verkoop of rapport weergeven',0),(258352,7177,'fi','Kirjoita komissio tarkastaa jakelijan myynti tai NÃ¤ytÃ¤ raportti',0),(258353,7177,'no','Skrive kommisjon sjekker DistributÃ¸r salgs-eller Vis rapport',0),(258354,7177,'da','Skriver Kommissionens kontrol fra distributÃ¸r salg eller Vis rapport',0),(258355,7177,'ko','ëŒ€ë¦¬ì  íŒë§¤ ë˜ëŠ” ë³´ê³ ì„œ ë³´ê¸°ì—ì„œ ì“°ê¸° ìœ„ì›íšŒ ê²€ì‚¬',0),(258356,7177,'he','×‘×“×™×§×•×ª ×•×¢×“×ª ×›×ª×™×‘×” ×ž×¤×™×¥ ×ž×›×™×¨×•×ª ××• ×”×¦×’ ×“×•×—',0),(258357,7177,'el','Î•Î»Î­Î³Ï‡Î¿Ï…Ï‚ Ï„Î·Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ Î±Ï€ÏŒ Î´Î¹Î±Î½Î¿Î¼Î­Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î® Ï€ÏÎ¿Î²Î¿Î»Î® Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(258358,7177,'zh','ä»Žåˆ†é”€å•†çš„é”€å”®æˆ–æŸ¥çœ‹æŠ¥å‘Šä¸­å†™ä½£é‡‘æ”¯ç¥¨\r\n',0),(258359,7177,'sv','Skriva kommissionens kontroller frÃ¥n distributÃ¶r fÃ¶rsÃ¤ljning eller Visa rapport',0),(258360,7177,'it','Scrittura Commissione controlli dal distributore vendite o Visualizza rapporto',0),(258361,7177,'tl','',0),(258362,7177,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;&#3592;&#3634;&#3585;&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3592;&#3635;&#3',0),(258363,7177,'hi','à¤²à¤¿à¤–à¤¨à¥‡ à¤¸à¥‡ à¤µà¤¿à¤¤à¤°à¤• à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¯à¤¾ à¤¦à¥ƒà¤¶à¥à¤¯ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤†à¤¯à¥‹à¤— à¤•à¥€ à¤œà¤¾à¤‚à¤š',0),(258364,7177,'ms','Tulis cek komisen daripada jualan Pengedar atau laporan paparan',0),(258365,7177,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„Ù„Ø¬Ù†Ø© Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ù…ÙˆØ²Ø¹ Ù…Ø¨ÙŠØ¹Ø§Øª Ø£Ùˆ Ø¹Ø±Ø¶ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(258366,7177,'fr','Ã‰crire les chÃ¨ques de Commission de vente distributeur ou afficher le rapport',0),(258367,7177,'jp','ãƒ‡ã‚£ã‚¹ãƒˆãƒªãƒ“ãƒ¥ãƒ¼ã‚¿ãƒ¼è²©å£²ã¾ãŸã¯ãƒ¬ãƒãƒ¼ãƒˆã®è¡¨ç¤ºã‹ã‚‰æ›¸ãè¾¼ã¿å§”å“¡ä¼šã®ãƒã‚§ãƒƒã‚¯',0),(258368,7177,'pt','Escrever cheques de ComissÃ£o de vendas do distribuidor ou Exibir relatÃ³rio',0),(258369,7177,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑŒÑŽÑ‚Ð¾Ñ€Ð° Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(258370,7177,'es','Elaborar Cheques de ComisiÃ³n de Ventas de Distribuidores o Visionar el Informe',0),(258371,7177,'de','Schreiben Provisionsschecks von Vertriebsgesellschaften oder Bericht anzeigen',0),(258372,7177,'en','Write Commission Checks from Distributor Sales or View Report',0),(258373,7178,'is','',0),(258374,7178,'dr','Ø¨Ø±Ø§ÙŠ Ø¹Ø¯Ù… Ù†Ù…Ø§ÙŠØ´ Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(258375,7178,'pr','Ø¨Ø±Ø§ÙŠ Ø¹Ø¯Ù… Ù†Ù…Ø§ÙŠØ´ Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(258376,7178,'tr','HayÄ±r gÃ¶stermek iÃ§in boÅŸ bÄ±rakÄ±n.',0),(258377,7178,'pl','Pozostaw puste brak obrazu',0),(258378,7178,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½ÑÐ¼Ð°',0),(258379,7178,'ur','Ú©ÙˆØ¦ÛŒ ÚˆØ³Ù¾Ù„Û’ Ú©Û’ Ù„Ø¦Û’ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(258380,7178,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° Ð±ÐµÐ· ÐµÐºÑ€Ð°Ð½Ð°',0),(258381,7178,'vi','Äá»ƒ trá»‘ng Ä‘á»ƒ khÃ´ng hiá»ƒn thá»‹',0),(258382,7178,'af','Laat Oop vir Geen Vertoon',0),(258383,7178,'ro','LÄƒsaÅ£i necompletat pentru niciun afiÅŸaj',0),(258384,7178,'et','Mitte kuvamiseks jÃ¤ta tÃ¼hjaks',0),(258385,7178,'si','Pustimo prazno Å¡t zaslon',0),(258386,7178,'ba','Biarkan kosong untuk menampilkan No',0),(258387,7178,'nl','Laat leeg voor geen weergave',0),(258388,7178,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi nÃ¤yttÃ¶ on pimeÃ¤nÃ¤',0),(258389,7178,'no','Tomt for ingen visning',0),(258390,7178,'da','For ingen Display er tomt',0),(258391,7178,'ko','ë””ìŠ¤í”Œë ˆì´ ëŒ€ í•œ ë¹„ì›Œ',0),(258392,7178,'he','×ª×©××™×¨ ×¨×™×§ ×œ×ª×¦×•×’×” ××™×Ÿ',0),(258393,7178,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ Î³Î¹Î± ÎºÎ±Î¼Î¯Î± ÎµÏ€Î¯Î´ÎµÎ¹Î¾Î·',0),(258394,7178,'zh','ç»™æ— æ˜¾ç¤ºç©ºç™½\r\n',0),(258395,7178,'sv','LÃ¤mna tomt fÃ¶r ingen Display',0),(258396,7178,'it','Lasciare vuoto per nessun Display',0),(258397,7178,'tl','',0),(258398,7178,'th','&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3649;&#3626;&#3604;&#3591;',0),(258399,7178,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚',0),(258400,7178,'ms','Biarkan kosong untuk paparan tiada',0),(258401,7178,'ar','ØªØªØ±Ùƒ ÙØ§Ø±ØºØ© Ù„Ø£ÙŠ Ø¹Ø±Ø¶',0),(258402,7178,'fr','Laissez vide pour pas d\'affichage',0),(258403,7178,'jp','ä½•ã‚‚è¡¨ç¤ºã•ã‚Œãªã„ã®ã¯ç©ºç™½ã®ã¾ã¾',0),(258404,7178,'pt','Deixe em branco para nÃ£o exibir',0),(258405,7178,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼ Ð´Ð»Ñ Ð±ÐµÐ· Ð´Ð¸ÑÐ¿Ð»ÐµÑ',0),(258406,7178,'es','Dejar en Blanco para No Desplegar',0),(258407,7178,'de','Freilassen, fÃ¼r die keine Anzeige',0),(258408,7178,'en','Leave Blank for No Display',0),(258409,7179,'is','',0),(258410,7179,'dr','ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø¨Ø±Ø§ÙŠ ØµÙØ­Ù‡ Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§',0),(258411,7179,'pr','ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø¨Ø±Ø§ÙŠ ØµÙØ­Ù‡ Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§',0),(258412,7179,'tr','Alan kodu iÃ§in Ana sayfa hava',0),(258413,7179,'pl','Kod pocztowy dla Strona Pogoda',0),(258414,7179,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´ Ð·Ð° Ð²Ñ€ÐµÐ¼ÐµÑ‚Ð¾ Ð½Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(258415,7179,'ur','Ø²Ù¾ Ú©ÙˆÚˆ Ú©Û’ ÛÙˆÙ… Ù¾ÛŒØ¬ Ú©Û’ Ù…ÙˆØ³Ù… Ú©Û’ Ù„ÛŒÛ’',0),(258416,7179,'sr','ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜ Ð·Ð° Ð²Ñ€ÐµÐ¼Ðµ Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(258417,7179,'vi','Zip Code cho trang chá»§ dá»± bÃ¡o thá»i tiáº¿t',0),(258418,7179,'af','Poskode vir Tuisblad Weer',0),(258419,7179,'ro','cod postal pentru Pagina despre Vreme',0),(258420,7179,'et','Postiindeks pealehel ilma kuvamiseks',0),(258421,7179,'si','PoÅ¡tna Å¡tevilka za domaÄo stran vreme',0),(258422,7179,'ba','Kode pos untuk halaman rumah cuaca',0),(258423,7179,'nl','Postcode voor homepage weerbericht',0),(258424,7179,'fi','Postinumero kotisivun SÃ¤Ã¤',0),(258425,7179,'no','Postnummer for hjemmesiden VÃ¦r',0),(258426,7179,'da','Postnummer for startsiden vejr',0),(258427,7179,'ko','í™ˆíŽ˜ì´ì§€ ë‚ ì”¨ì— ëŒ€ í•œ ìš°íŽ¸ ë²ˆí˜¸',0),(258428,7179,'he','×ž×™×§×•×“ ×¢×‘×•×¨ ×“×£ ×”×‘×™×ª ×ž×–×’ ××•×•×™×¨',0),(258429,7179,'el','Î¤Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚ Î³Î¹Î± Ï„Î·Î½ Î±ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î± ÎºÎ±Î¹ÏÎ¿Ï',0),(258430,7179,'zh','é‚®æ”¿ç¼–ç ä¸»é¡µæ°”å€™',0),(258431,7179,'sv','Postnummer fÃ¶r startsidan vÃ¤der',0),(258432,7179,'it','Codice postale per le previsioni del tempo nella pagina principale',0),(258433,7179,'tl','',0),(258434,7179,'th','&#3619;&#3627;&#3633;&#3626;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3627;&#3609;&#3657;&#3634;&#3650;&#3630;&#3617;&#3586;&#3629;&#3591;&#3648;&#3614;&#3592;&#3629;&#3634;&#3585;&#3634;&#3624;',0),(258435,7179,'hi','à¤®à¥à¤–à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‡ à¤®à¥Œà¤¸à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¼à¤¿à¤ª à¤•à¥‹à¤¡',0),(258436,7179,'ms','Poskod untuk cuaca Laman Utama',0),(258437,7179,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ù„Ù„Ø·Ù‚Ø³ ÙÙŠ Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(258438,7179,'fr','Code postal pour la page d\'accueil MÃ©tÃ©o',0),(258439,7179,'jp','ãƒ›ãƒ¼ãƒ  ãƒšãƒ¼ã‚¸å¤©æ°—ã® Zip ã‚³ãƒ¼ãƒ‰',0),(258440,7179,'pt','CÃ³digo postal de tempo Home Page',0),(258441,7179,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ Ð¸Ð½Ð´ÐµÐºÑ Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐŸÐ¾Ð³Ð¾Ð´Ð°',0),(258442,7179,'es','CÃ³digo zip para pÃ¡gina inicio de tiempo',0),(258443,7179,'de','Postleitzahl fÃ¼r Homepage-Wetter',0),(258444,7179,'en','Zip Code for Home Page Weather',0),(258445,7180,'is','',0),(258446,7180,'dr','Ø³Ø·ÙˆØ­ Ø®Ù„Ø§ØµÙ‡ Ø§Ø¶Ø§ÙÛŒ',0),(258447,7180,'pr','Ø³Ø·ÙˆØ­ Ø®Ù„Ø§ØµÙ‡ Ø§Ø¶Ø§ÙÛŒ',0),(258448,7180,'tr','Ek Ã–zet dÃ¼zeyleri',0),(258449,7180,'pl','Dodatkowe poziomy podsumowania',0),(258450,7180,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð¸Ð²Ð°',0),(258451,7180,'ur','Ø§Ø¶Ø§ÙÛŒ Ø®Ù„Ø§ØµÛ Ø³Ø·Ø­ÛŒÚº',0),(258452,7180,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°ÑšÐµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð½Ð¸Ð²Ð¾Ðµ',0),(258453,7180,'vi','Cáº¥p Báº­c Tá»•ng Há»£p Cá»™ng ThÃªm',0),(258454,7180,'af','Adisionele Opsommingsvlakke',0),(258455,7180,'ro','Nivele de totalizare suplimentare',0),(258456,7180,'et','TÃ¤iendav kokkuvÃµtlik tasemed',0),(258457,7180,'si','Dodatne ravni Povzetek',0),(258458,7180,'ba','Level Penambahan Jumlah',0),(258459,7180,'nl','Extra samenvatting niveaus',0),(258460,7180,'fi','Yhteenveto tasot',0),(258461,7180,'no','Flere Sammendrag nivÃ¥er',0),(258462,7180,'da','Yderligere sammenfattende niveauer',0),(258463,7180,'ko','ì¶”ê°€ ìš”ì•½ ìˆ˜ì¤€',0),(258464,7180,'he','×¨×ž×•×ª ×¡×™×›×•× × ×•×¡×¤×•×ª',0),(258465,7180,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î± ÎµÏ€Î¯Ï€ÎµÎ´Î± ÏƒÏÎ½Î¿ÏˆÎ·Ï‚',0),(258466,7180,'zh','å¢žåŠ ç¸½æ•¸ç¨‹åº¦\r\n',0),(258467,7180,'sv','Ytterligare Sammanfattning nivÃ¥er',0),(258468,7180,'it','Ulteriori livelli di riepilogo',0),(258469,7180,'tl','',0),(258470,7180,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3632;&#3604;&#3633;&#3610;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;',0),(258471,7180,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¸à¥à¤¤à¤°',0),(258472,7180,'ms','Peringkat rumusan tambahan',0),(258473,7180,'ar','Ù…Ø³ØªÙˆÙŠØ§Øª ØªÙ„Ø®ÙŠØµ Ø¥Ø¶Ø§ÙÙŠØ©',0),(258474,7180,'fr','Sommaire Niveaux supplÃ©mentaires\r\n',0),(258475,7180,'jp','ã‚µãƒžãƒªãƒ¼ ãƒ¬ãƒ™ãƒ«ã‚’è¿½åŠ ',0),(258476,7180,'pt','NÃ­veis de resumo adicionais',0),(258477,7180,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑƒÑ€Ð¾Ð²Ð½Ð¸ ÑÑƒÐ¼Ð¼Ð°Ñ€Ð½Ñ‹Ñ…',0),(258478,7180,'es','Sumario de Niveles Adicionales',0),(258479,7180,'de','Weitere Zusammenfassung Ebenen',0),(258480,7180,'en','Additional Summary Levels',0),(258481,7181,'is','',0),(258482,7181,'dr','(Ø¨Ù‡ Ø­Ø³Ø§Ø¨',0),(258483,7181,'pr','Ø®Ù„Ø§ØµÙ‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¹Ù„ÙŠ Ø§Ù„Ø­Ø³Ø§Ø¨(Ø¨Ù‡ Ø­Ø³Ø§Ø¨',0),(258484,7181,'tr','Standart hesap iÃ§in Ã¶zetlemek',0),(258485,7181,'pl','Standardowe podsumowanie konta',0),(258486,7181,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ Ð¾Ð±Ð¾Ð±Ñ‰Ð°Ð²Ð°Ð½Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð°',0),(258487,7181,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³Û’ Ø®Ù„Ø§ØµÛ ØªÛŒØ§Ø±',0),(258488,7181,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¾ Ñ€ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°Ñ˜Ñƒ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(258489,7181,'vi','Tá»•ng Há»£p Chuáº©n Cho TK',0),(258490,7181,'af','Standaard Opsomming na Rekening',0),(258491,7181,'ro','Standardul rezuma la cont',0),(258492,7181,'et','Standardi summeerida kontole',0),(258493,7181,'si','Standarda, povzeti na raÄun',0),(258494,7181,'ba','Standar meringkas ke akun',0),(258495,7181,'nl','Standaard samenvatten naar Account',0),(258496,7181,'fi','Standardi on tiivistÃ¤Ã¤ tilille',0),(258497,7181,'no','Standard oppsummere konto',0),(258498,7181,'da','Standard opsummere konto',0),(258499,7181,'ko','í‘œì¤€ ê³„ì • ìš”ì•½',0),(258500,7181,'he','×ª×§×Ÿ ×œ×¡×›× ×œ×—×©×‘×•×Ÿ',0),(258501,7181,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ ÏƒÏ…Î½Î¿ÏˆÎ¯ÏƒÎµÏ„Îµ Î³Î¹Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(258502,7181,'zh','æ ‡å‡†æ±‡æ€»åˆ°å¸æˆ·\r\n',0),(258503,7181,'sv','Standard sammanfatta till konto',0),(258504,7181,'it','Norma riassumere per conto',0),(258505,7181,'tl','',0),(258506,7181,'th','&#3626;&#3619;&#3640;&#3611;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(258507,7181,'hi','à¤®à¤¾à¤¨à¤• à¤–à¤¾à¤¤à¤¾ à¤•à¥‹ à¤¸à¤‚à¤•à¥à¤·à¥‡à¤ª à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤ à¤•à¤°à¤¨à¤¾',0),(258508,7181,'ms','Standard meringkaskan ke akaun',0),(258509,7181,'ar','Ø§Ù„ØªÙ„Ø®ÙŠØµ Ø¥Ù„Ù‰ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ',0),(258510,7181,'fr','Norme rÃ©sumer au compte',0),(258511,7181,'jp','æ¨™æº–ã¯ã€ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¦ç´„ã—ã¾ã™ã€‚',0),(258512,7181,'pt','PadrÃ£o resumir a conta',0),(258513,7181,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(258514,7181,'es','ResÃºmen de Cuenta TamaÃ±o EstÃ¡ndar',0),(258515,7181,'de','Standard Konto zusammenfassen',0),(258516,7181,'en','Standard Summarize to Account',0),(258517,7182,'is','',0),(258518,7182,'dr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø±Ø§ Ø§Ø² Ù‚Ù„Ù… Ù†ÙŠÙ†Ø¯Ø§Ø²ÙŠØ¯ ',0),(258519,7182,'pr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø±Ø§ Ø§Ø² Ù‚Ù„Ù… Ù†ÙŠÙ†Ø¯Ø§Ø²ÙŠØ¯ ',0),(258520,7182,'tr','Sevk damla bile',0),(258521,7182,'pl','Nie dostarczanego',0),(258522,7182,'bg','ÐÐµ Ð¸Ð·Ð¿ÑƒÑÐºÐ°Ð¹Ñ‚Ðµ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸',0),(258523,7182,'ur','Ù‚Ø·Ø±Û Ø³Û’ Ù†ÛÛŒÚº Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(258524,7182,'sr','ÐÐµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸',0),(258525,7182,'vi','KhÃ´ng chuyá»ƒn',0),(258526,7182,'af','Versending Nie Afgelewer',0),(258527,7182,'ro','Nu picÄƒturÄƒ expediate',0),(258528,7182,'et','Tilk lÃ¤hetatud',0),(258529,7182,'si','Ne spusti ob dobavi',0),(258530,7182,'ba','Drop dikirim',0),(258531,7182,'nl','Niet doorverzonden',0),(258532,7182,'fi','Ei pudota lÃ¤hetetty',0),(258533,7182,'no','Ikke slipp leveres',0),(258534,7182,'da','Ikke leveres direkte',0),(258535,7182,'ko','ì•„ë‹ˆ ë“œë¡­ ë°°ì†¡',0),(258536,7182,'he','×œ× ×˜×™×¤×” ×©× ×©×œ×—×•',0),(258537,7182,'el','Î”ÎµÎ½ Ï„Î¹Ï‚ Ï€Ï„ÏŽÏƒÎ· Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(258538,7182,'zh','æœªç»“æŸè´§è¿\r\n',0),(258539,7182,'sv','Inte slÃ¤ppa levereras',0),(258540,7182,'it','Non goccia spedito',0),(258541,7182,'tl','',0),(258542,7182,'th','&#3652;&#3617;&#3656;&#3607;&#3636;&#3657;&#3591;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(258543,7182,'hi','à¤¡à¥à¤°à¥‰à¤ª à¤¨à¤¹à¥€à¤‚ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(258544,7182,'ms','Jatuhkan dihantar',0),(258545,7182,'ar','Ø¹Ø¯Ù… Ø¥Ø³Ù‚Ø§Ø· Ø´Ø­Ù†Ù‡Ø§',0),(258546,7182,'fr','Ne laissez pas tomber embarquÃ©e',0),(258547,7182,'jp','å‡ºè·ã‚’ãƒ‰ãƒ­ãƒƒãƒ—',0),(258548,7182,'pt','NÃ£o soltar enviado',0),(258549,7182,'ru','ÐÐµ Ñ€Ð¾Ð½ÑÐ¹Ñ‚Ðµ Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ð¾Ð¹',0),(258550,7182,'es','No es Enviado Directamente',0),(258551,7182,'de','Nicht Tropfen ausgeliefert',0),(258552,7182,'en','Not Drop Shipped',0),(258553,7183,'is','',0),(258554,7183,'dr','(Ø§Ø±Ø³Ø§Ù„)Ø§Ø² Ù‚Ù„Ù… Ø§ÙØªØ§Ø¯Ù‡ Ø§Ø³Øª(Ø­Ø°Ù Ø´Ø¯Ù‡',0),(258555,7183,'pr','Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ Ø§Ú¯Ø± Ø­Ù…Ù„ (Ø§Ø±Ø³Ø§Ù„)Ø§Ø² Ù‚Ù„Ù… Ø§ÙØªØ§Ø¯Ù‡ Ø§Ø³Øª(Ø­Ø°Ù Ø´Ø¯Ù‡',0),(258556,7183,'tr','SatÄ±ÅŸ sipariÅŸ verirseniz damla gemi',0),(258557,7183,'pl','ZamÃ³wienie sprzedaÅ¼y, jeÅ›li spadek statku',0),(258558,7183,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°, Ð°ÐºÐ¾ ÐºÐ°Ð¿ÐºÐ° ÐºÐ¾Ñ€Ð°Ð±',0),(258559,7183,'ur','Ø§Ú¯Ø± ÙØ±ÙˆØ®Øª Ú©Ø§ Ø¢Ø±ÚˆØ± Ú†Ú¾ÙˆÚ‘ÛŒÚº Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²',0),(258560,7183,'sr','Ð£Ð»Ð°Ð·Ð½Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° Ð°ÐºÐ¾ Ð±Ð°Ñ†Ð¸ Ð±Ñ€Ð¾Ð´',0),(258561,7183,'vi','ÄÆ¡n hÃ ng kinh doanh náº¿u bá» váº­n chuyá»ƒn',0),(258562,7183,'af','Verkoopsbestelling Indein Versending Afgelewer is',0),(258563,7183,'ro','VÃ¢nzÄƒri ordine dacÄƒ picÄƒturÄƒ navÄƒ',0),(258564,7183,'et','MÃ¼Ã¼gitellimuse kui Drop laev',0),(258565,7183,'si','Prodajni nalog, Äe spusti ladje',0),(258566,7183,'ba','Penjualan memesan jika Drop kapal',0),(258567,7183,'nl','Verkooporder als schip neerzetten',0),(258568,7183,'fi','Myyntitilauksen jos pudota aluksen',0),(258569,7183,'no','Salgsordrer hvis slippe skipet',0),(258570,7183,'da','Hvis Drop skib',0),(258571,7183,'ko','íŒë§¤ ì£¼ë¬¸ ê²½ìš° í•˜ë½ ë°°',0),(258572,7183,'he','×”×–×ž× ×ª ×ž×›×™×¨×” ×× ×©×—×¨×¨ ××ª ×”×¡×¤×™× ×”',0),(258573,7183,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚, Î±Î½ Î‘ÎœÎ•Î£ Î‘Î ÎŸÎ£Î¤',0),(258574,7183,'zh','å¦‚æžœç›´æŽ¥ä»˜è¿é”€å”®è®¢å•\r\n',0),(258575,7183,'sv','FÃ¶rsÃ¤ljningsorder om Drop Ship',0),(258576,7183,'it','Ordine di vendita se nave di goccia',0),(258577,7183,'tl','',0),(258578,7183,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3648;&#3617;&#3639;&#3656;&#3629;&#3627;&#3618;&#3640;&#3604;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(258579,7183,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶ à¤¯à¤¦à¤¿ à¤¡à¥à¤°à¥‰à¤ª à¤œà¤¹à¤¾à¤œ',0),(258580,7183,'ms','Jualan memerintahkan jika jatuh kapal',0),(258581,7183,'ar','Ø£Ù…Ø± Ø§Ù„ØªÙˆØ±ÙŠØ¯ ÙÙŠ Ø­Ø§Ù„Ø© Ø¥Ø³Ù‚Ø§Ø· Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(258582,7183,'fr','Ventes commander si Drop Ship',0),(258583,7183,'jp','è²©å£²æ³¨æ–‡ã®å ´åˆã¯ãƒ‰ãƒ­ãƒƒãƒ—èˆ¹',0),(258584,7183,'pt','Ordem de vendas se navio da gota',0),(258585,7183,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° Ð·Ð°ÐºÐ°Ð· ÐµÑÐ»Ð¸ Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(258586,7183,'es','Orden de Ventas Si Es EnvÃ­o Directo',0),(258587,7183,'de','Kundenauftrag wenn Drop Ship',0),(258588,7183,'en','Sales Order If Drop Ship',0),(258589,7184,'is','',0),(258590,7184,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù…ØµØ±ÙÙŠ ',0),(258591,7184,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù…ØµØ±ÙÙŠ ',0),(258592,7184,'tr','KullanÄ±m birimi baÅŸÄ±na maliyet',0),(258593,7184,'pl','Koszt uÅ¼ycia jednostki',0),(258594,7184,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ',0),(258595,7184,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ ÙÛŒ ÛŒÙˆÙ†Ù¹ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(258596,7184,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ‚ÐµÑšÐµ',0),(258597,7184,'vi','GiÃ¡ má»—i 1 Ä‘Æ¡n vá»‹ sá»­ dá»¥ng',0),(258598,7184,'af','Koste per Gebruikseenheid',0),(258599,7184,'ro','Costul pe unitate de utilizare',0),(258600,7184,'et','Kasutus Ã¼hiku kulu',0),(258601,7184,'si','StroÅ¡ek na enoto uporabe',0),(258602,7184,'ba','Biaya per Unit penggunaan',0),(258603,7184,'nl','Kosten per gebruik eenheid',0),(258604,7184,'fi','KÃ¤yttÃ¶ yksikkÃ¶kustannukset',0),(258605,7184,'no','Kostnader per bruk enhet',0),(258606,7184,'da','Omkostninger pr. enhed, forbrug',0),(258607,7184,'ko','ì‚¬ìš© ë‹¨ìœ„ ë‹¹ ë¹„ìš©',0),(258608,7184,'he','×¢×œ×•×ª ×œ×™×—×™×“×” ×”×©×™×ž×•×©',0),(258609,7184,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ Ï‡ÏÎ®ÏƒÎ· Î¼Î¿Î½Î¬Î´Î±',0),(258610,7184,'zh','æ¯æ¬¡ä½¿ç”¨å•ä½æˆæœ¬\r\n',0),(258611,7184,'sv','Kostnad per anvÃ¤ndning enhet',0),(258612,7184,'it','Costo per unitÃ  di utilizzo',0),(258613,7184,'tl','',0),(258614,7184,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;',0),(258615,7184,'hi','à¤‰à¤ªà¤¯à¥‹à¤— à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤•à¤¾à¤ˆ à¤²à¤¾à¤—à¤¤',0),(258616,7184,'ms','Kos seunit penggunaan',0),(258617,7184,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø© Ø¥Ø³ØªØ¹Ù…Ø§Ù„',0),(258618,7184,'fr','CoÃ»t par unitÃ© d\'utilisation',0),(258619,7184,'jp','ä½¿ç”¨å˜ä½å½“ãŸã‚Šã®ã‚³ã‚¹ãƒˆ',0),(258620,7184,'pt','Custo por unidade de uso',0),(258621,7184,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(258622,7184,'es','Costo Por Unidad de Uso',0),(258623,7184,'de','Kosten pro Einsatz Einheit',0),(258624,7184,'en','Cost per Usage Unit',0),(258625,7185,'is','',0),(258626,7185,'dr',' Ù„ÙŠØ³Øª ÙƒØ´ÙˆÙŠÙŠ',0),(258627,7185,'pr',' Ù„ÙŠØ³Øª ÙƒØ´ÙˆÙŠÙŠ',0),(258628,7185,'tr','AÃ§Ä±lan kutusu',0),(258629,7185,'pl','Rozwijanej',0),(258630,7185,'bg','ÐšÐ°Ð¿ÐºÐ° Ð³Ð¾Ð»Ð¾ Ð²ÑŠÐ·Ð²Ð¸ÑˆÐµÐ½Ð¸Ðµ ÐºÑƒÑ‚Ð¸Ñ',0),(258631,7185,'ur','Ù†ÛŒÚ†Û’ Ø®Ø§Ù†Û Ú†Ú¾ÙˆÚ‘ÛŒÚº',0),(258632,7185,'sr','ÐŸÐ°Ð´Ð°Ñ˜ÑƒÑ›Ð¸ Ð¾ÐºÐ²Ð¸Ñ€',0),(258633,7185,'vi','Há»™p tháº£ xuá»‘ng',0),(258634,7185,'af','\' Drop-Down Box',0),(258635,7185,'ro','Drop jos cutie',0),(258636,7185,'et','RippmenÃ¼Ã¼st',0),(258637,7185,'si','Spustnega seznama',0),(258638,7185,'ba','Drop-Down Box',0),(258639,7185,'nl','Drop-Down Box',0),(258640,7185,'fi','Avattavasta',0),(258641,7185,'no','Rullegardinliste',0),(258642,7185,'da','Drop Down boksen',0),(258643,7185,'ko','ë“œë¡­ë‹¤ìš´ ìƒìž',0),(258644,7185,'he','×‘×¨×©×™×ž×” ×”× ×¤×ª×—×ª ×©×œ ×”×ª×™×‘×”',0),(258645,7185,'el','Î‘Î½Î±Ï€Ï„Ï…ÏƒÏƒÏŒÎ¼ÎµÎ½Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿',0),(258646,7185,'zh','ä¸‹æ‹‰æ¡†\r\n',0),(258647,7185,'sv','Listrutan',0),(258648,7185,'it','Casella a discesa',0),(258649,7185,'tl','',0),(258650,7185,'th','Drop Down Box',0),(258651,7185,'hi','à¤¬à¥‰à¤•à¥à¤¸ à¤¨à¥€à¤šà¥‡ à¤›à¥‹à¤¡à¤¼',0),(258652,7185,'ms','Jatuh bawah Peti',0),(258653,7185,'ar','Ø¥Ø³Ù‚Ø§Ø· Ø¥Ù„Ù‰ Ø£Ø³ÙÙ„ Ù…Ø±Ø¨Ø¹',0),(258654,7185,'fr','Zone dÃ©roulante',0),(258655,7185,'jp','ãƒ‰ãƒ­ãƒƒãƒ—ãƒ€ã‚¦ãƒ³ ãƒœãƒƒã‚¯ã‚¹',0),(258656,7185,'pt','Deixe cair para baixo de caixa',0),(258657,7185,'ru','Ð Ð°ÑÐºÑ€Ñ‹Ð²Ð°ÑŽÑ‰ÐµÐ¼ÑÑ ÑÐ¿Ð¸ÑÐºÐµ',0),(258658,7185,'es','Casilla Desplegable',0),(258659,7185,'de','Drop-Down-Box',0),(258660,7185,'en','Drop Down Box',0),(258661,7186,'is','',0),(258662,7186,'dr','Ù…ÙˆØ§Ø¬Ù‡ Ø´Ø¯Ù† Ø¨Ø§ Ø®Ø·Ø§ â€“ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø±Ú¯Ø´Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯ ',0),(258663,7186,'pr','Ù…ÙˆØ§Ø¬Ù‡ Ø´Ø¯Ù† Ø¨Ø§ Ø®Ø·Ø§ â€“ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø±Ú¯Ø´Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯ ',0),(258664,7186,'tr','KarÅŸÄ±laÅŸÄ±lan hata-veri dÃ¶ndÃ¼rÃ¼ldÃ¼',0),(258665,7186,'pl','PrzywrÃ³cone dane napotkaÅ‚ bÅ‚Ä…d',0),(258666,7186,'bg','Ð“Ñ€ÐµÑˆÐºÐ° ÑÑ€ÐµÑ‰Ð½Ð°Ñ‚-Ð´Ð°Ð½Ð½Ð¸ ÑÐµ Ð²Ñ€ÑŠÑ‰Ð°Ñ‚',0),(258667,7186,'ur','Ù†Ù‚Øµ Ø³Û’ ÙˆØ§Ø³Ø·Û Ù¾Ú‘Ø§-ÚˆÛŒÙ¹Ø§ Ú©ÛŒ Ø·Ø±Ù Ù¾Ù„Ù¹Ø§Ø¦Û’',0),(258668,7186,'sr','ÐÐµÐ¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ñ™Ð¸Ð²Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð³Ñ€ÐµÑˆÐºÐ°Ð¼Ð° Ñ˜Ðµ Ð½Ð°Ð¸ÑˆÐ°Ð¾ Ð½Ð°-',0),(258669,7186,'vi','CÃ³ lá»—i-dá»¯ liá»‡u viáº¿t ngÆ°á»£c',0),(258670,7186,'af','Fout teÃ«gekom-Data teruggekeer',0),(258671,7186,'ro','Eroare Ã®ntÃ¢lnit-date a revenit',0),(258672,7186,'et','TÃµrge ilmnes andmete pÃ¶Ã¶rdus',0),(258673,7186,'si','Vrnil napaka je naletel podatkov',0),(258674,7186,'ba','Kesalahan dijumpai-Data dikembalikan',0),(258675,7186,'nl','Fout opgetreden-Data teruggekeerd',0),(258676,7186,'fi','Virhe havainnut-Data palanneet',0),(258677,7186,'no','Feil oppstod-Data tilbake',0),(258678,7186,'da','Fejl opstod-dataene gendannes',0),(258679,7186,'ko','ì˜¤ë¥˜ ë°œìƒ ë°ì´í„° ë˜ ëŒ',0),(258680,7186,'he','×”×ž×¢×¨×›×ª × ×ª×§×œ×”-× ×ª×•× ×™ ×”×©×’×™××” ×œ×”×—×–×™×¨×”',0),(258681,7186,'el','Î•Ï€Î±Î½Î®Î»Î¸Î± Î±Î½Ï„Î¹Î¼ÎµÏ„ÏŽÏ€Î¹ÏƒÎµ ÏƒÏ†Î¬Î»Î¼Î±-Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(258682,7186,'zh','é‡åˆ°çš„é”™è¯¯ï¼Œæ•°æ®æ¢å¤',0),(258683,7186,'sv','Fel pÃ¥trÃ¤ffades-Data Ã¥tergÃ¥tt',0),(258684,7186,'it','Errore rilevato-dati ripristinato',0),(258685,7186,'tl','',0),(258686,7186,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3614;&#3610;&#3586;&#3657;&#3629;&#3606;&#3641;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3585;&#3621;&#3633;&#3610;',0),(258687,7186,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¤¾ à¤¸à¤¾à¤®à¤¨à¤¾ à¤•à¤°à¤¨à¤¾ à¤ªà¤¡à¤¼à¤¾-à¤¡à¥‡à¤Ÿà¤¾ à¤µà¤¾à¤ªà¤¸ à¤¸à¥Œà¤‚à¤ª à¤¦à¤¿à¤¯à¤¾',0),(258688,7186,'ms','Kembali menemui ralat-Data',0),(258689,7186,'ar','Ø¹Ø§Ø¯Øª Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ù…ØµØ§Ø¯ÙØ© Ø®Ø·Ø£',0),(258690,7186,'fr','Erreur rencontrÃ©e-Data est revenue',0),(258691,7186,'jp','ã‚¨ãƒ©ãƒ¼ãŒç™ºç”Ÿã—ãŸãƒ‡ãƒ¼ã‚¿ã‚’å…ƒã«æˆ»ã™',0),(258692,7186,'pt','Erro encontrado-dados revertido',0),(258693,7186,'ru','Ð’ÐµÑ€Ð½ÑƒÐ»Ð°ÑÑŒ Ñ ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ð¼Ð¸ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¾ÑˆÐ¸Ð±Ð¾Ðº',0),(258694,7186,'es','Error Encontrado-Datos revertidos',0),(258695,7186,'de','Fehler aufgetreten-Daten zurÃ¼ckgesetzt',0),(258696,7186,'en','Error Encountered-Data Reverted',0),(258697,7187,'is','',0),(258698,7187,'dr','( Ø¹Ø¯Ø¯',0),(258699,7187,'pr','Ø®Ø·Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ ( Ø¹Ø¯Ø¯',0),(258700,7187,'tr','Hata numarasÄ±',0),(258701,7187,'pl','Numer bÅ‚Ä™du',0),(258702,7187,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð³Ñ€ÐµÑˆÐºÐ°',0),(258703,7187,'ur','Ù†Ù‚Øµ Ù†Ù…Ø¨Ø±',0),(258704,7187,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð³Ñ€ÐµÑˆÐºÐµ',0),(258705,7187,'vi','Lá»—i sá»‘',0),(258706,7187,'af','Foutnommer',0),(258707,7187,'ro','NumÄƒr eroare',0),(258708,7187,'et','TÃµrke Number',0),(258709,7187,'si','Å tevilka napake',0),(258710,7187,'ba','Nomor kesalahan',0),(258711,7187,'nl','Foutnummer',0),(258712,7187,'fi','Virhenumero',0),(258713,7187,'no','Feilnummer',0),(258714,7187,'da','Fejlnummer',0),(258715,7187,'ko','ì˜¤ë¥˜ ë²ˆí˜¸',0),(258716,7187,'he','×ž×¡×¤×¨ ×©×’×™××”',0),(258717,7187,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚',0),(258718,7187,'zh','é”™è¯¯å·',0),(258719,7187,'sv','Felnummer',0),(258720,7187,'it','Errore numero',0),(258721,7187,'tl','',0),(258722,7187,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(258723,7187,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(258724,7187,'ms','Nombor ralat',0),(258725,7187,'ar','Ø±Ù‚Ù… Ø§Ù„Ø®Ø·Ø£',0),(258726,7187,'fr','NumÃ©ro d\'erreur',0),(258727,7187,'jp','ã‚¨ãƒ©ãƒ¼ç•ªå·',0),(258728,7187,'pt','NÃºmero do erro',0),(258729,7187,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐÐ¾Ð¼ÐµÑ€Ð°',0),(258730,7187,'es','NÃºmero de Error',0),(258731,7187,'de','Fehlernummer',0),(258732,7187,'en','Error Number',0),(258733,7188,'is','',0),(258734,7188,'dr','(Ù†Ù…ÙˆÙ†Ù‡',0),(258735,7188,'pr','Ù…Ø«Ø§Ù„(Ù†Ù…ÙˆÙ†Ù‡',0),(258736,7188,'tr','Ã–rnek',0),(258737,7188,'pl','PrzykÅ‚ad',0),(258738,7188,'bg','ÐŸÑ€Ð¸Ð¼ÐµÑ€',0),(258739,7188,'ur','Ù…Ø«Ø§Ù„ Ú©Û’ Ø·ÙˆØ± Ù¾Ø±',0),(258740,7188,'sr','ÐŸÑ€Ð¸Ð¼ÐµÑ€',0),(258741,7188,'vi','VÃ­ dá»¥',0),(258742,7188,'af','Voorbeeld',0),(258743,7188,'ro','Exemplu',0),(258744,7188,'et','NÃ¤ide',0),(258745,7188,'si','Primer',0),(258746,7188,'ba','Contoh',0),(258747,7188,'nl','In het volgende voorbeeld',0),(258748,7188,'fi','Esimerkki',0),(258749,7188,'no','Eksempel',0),(258750,7188,'da','Eksempel',0),(258751,7188,'ko','ì˜ˆë¥¼ ë“¤ì–´',0),(258752,7188,'he','×“×•×’×ž×',0),(258753,7188,'el','Î Î±ÏÎ¬Î´ÎµÎ¹Î³Î¼Î±',0),(258754,7188,'zh','èŒƒä¾‹\r\n',0),(258755,7188,'sv','Exempel',0),(258756,7188,'it','Esempio',0),(258757,7188,'tl','',0),(258758,7188,'th','&#3605;&#3633;&#3623;&#3629;&#3618;&#3656;&#3634;&#3591;',0),(258759,7188,'hi','à¤‰à¤¦à¤¾à¤¹à¤°à¤£',0),(258760,7188,'ms','Contoh',0),(258761,7188,'ar','Ù…Ø«Ø§Ù„',0),(258762,7188,'fr','Exemple',0),(258763,7188,'jp','ä¾‹',0),(258764,7188,'pt','Exemplo',0),(258765,7188,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ€',0),(258766,7188,'es','Ejemplo',0),(258767,7188,'de','Beispiel',0),(258768,7188,'en','Example',0),(258769,7189,'is','',0),(258770,7189,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ Ø¯Ø± Ù…Ù†Ùˆ ØªÙ†Ø¸ÙŠÙ…Ø§Øª  ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ù†Ø¯ ',0),(258771,7189,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ Ø¯Ø± Ù…Ù†Ùˆ ØªÙ†Ø¸ÙŠÙ…Ø§Øª  ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ù†Ø¯ ',0),(258772,7189,'tr','Ek SeÃ§enekler \'Ayarlar\' menÃ¼sÃ¼nden alanlarÄ±nda kullanÄ±labilir',0),(258773,7189,'pl','Dodatkowe opcje dostÄ™pne sÄ… w obszary menu \"Ustawienia\"',0),(258774,7189,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸ ÑÐ° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸ Ð² Ð¼ÐµÐ½ÑŽÑ‚Ð¾ \"ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°\" Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(258775,7189,'ur','Ù…Ø²ÛŒØ¯ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª \'Ø³ÛŒÙ¹ Ø§Ù¾\' Ù…ÛŒÙ†ÛŒÙˆ Ú©Û’ Ø¹Ù„Ø§Ù‚ÙˆÚº Ù…ÛŒÚº Ø¯Ø³ØªÛŒØ§Ø¨ ÛÛŒÚº Û”',0),(258776,7189,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ ÑÑƒ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ðµ Ñƒ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸Ð¼Ð° Ð¼ÐµÐ½Ð¸Ñ˜Ñƒ \'ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐ°\'',0),(258777,7189,'vi','Nhiá»u lá»±a chá»n cÃ³ trong trÃ¬nh Ä‘Æ¡n Setup',0),(258778,7189,'af','Verdere opsies is beskikbaar in die \'Opstel\' kieslys gebiede',0),(258779,7189,'ro','Alte opÅ£iuni sunt disponibile Ã®n zonele de meniul \"Setup\"',0),(258780,7189,'et','TÃ¤iendav Valikud on saadaval \"Setup\" menÃ¼Ã¼ alad',0),(258781,7189,'si','Dodatne moÅ¾nosti so na voljo na podroÄjih meni \"Setup\"',0),(258782,7189,'ba','Pilihan tambahan tersedia di daerah menu \'Setup\'',0),(258783,7189,'nl','Verdere opties zijn beschikbaar in de \'Setup\' menu gebieden',0),(258784,7189,'fi','\'Asetukset\' menu aloilla on lisÃ¤Ã¤ vaihtoehtoja',0),(258785,7189,'no','Flere alternativer er tilgjengelige innen menyen \'Setup\'',0),(258786,7189,'da','Yderligere indstillinger er tilgÃ¦ngelige i menubaggrunde \'Setup\'',0),(258787,7189,'ko','ì¶”ê°€ ì˜µì…˜ \'ì„¤ì •\' ë©”ë‰´ ì˜ì—­ì—ì„œ ì‚¬ìš©í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(258788,7189,'he','××¤×©×¨×•×™×•×ª × ×•×¡×¤×•×ª ×”×–×ž×™× ×•×ª ×‘×ª×—×•×ž×™× ×ž×ª×¤×¨×™×˜ \'×”×’×“×¨×”\'',0),(258789,7189,'el','Î ÎµÏÎ±Î¹Ï„Î­ÏÏ‰ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼ÎµÏ‚ ÏƒÏ„Î¹Ï‚ Ï€ÎµÏÎ¹Î¿Ï‡Î­Ï‚ Â«Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚Â» Î¼ÎµÎ½Î¿Ï',0),(258790,7189,'zh','å…¶ä»–é€‰æ‹©å¯åœ¨\'è®¾ç½®\'èœå•åŒºåŸŸ\r\n',0),(258791,7189,'sv','Ytterligare alternativ Ã¤r tillgÃ¤ngliga i omrÃ¥dena \"Setup\"-menyn',0),(258792,7189,'it','Ulteriori opzioni sono disponibili nelle aree menu \'Setup\'',0),(258793,7189,'tl','',0),(258794,7189,'th','&#3607;&#3634;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;&#3607;&#3637;&#3656;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3',0),(258795,7189,'hi','à¤‡à¤¸à¤•à¥‡ à¤…à¤²à¤¾à¤µà¤¾ à¤µà¤¿à¤•à¤²à¥à¤ª \'à¤¸à¥‡à¤Ÿà¤…à¤ª\' à¤®à¥‡à¤¨à¥‚ à¤•à¥à¤·à¥‡à¤¤à¥à¤°à¥‹à¤‚ à¤®à¥‡à¤‚ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¹à¥ˆà¤‚',0),(258796,7189,'ms','Pilihan tambahan boleh didapati di menu \'Persediaan\'',0),(258797,7189,'ar','ØªØªÙˆÙØ± Ø®ÙŠØ§Ø±Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ© ÙÙŠ Ø§Ù„Ù…Ù†Ø§Ø·Ù‚ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© \'Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯\'',0),(258798,7189,'fr','D\'autres options sont disponibles dans les domaines du menu Â« Setup Â»',0),(258799,7189,'jp','\'ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—\' ãƒ¡ãƒ‹ãƒ¥ãƒ¼é ˜åŸŸã§ã¯ã•ã‚‰ã«ã‚ªãƒ—ã‚·ãƒ§ãƒ³ãŒåˆ©ç”¨å¯èƒ½ã§ã™',0),(258800,7189,'pt','Mais opÃ§Ãµes estÃ£o disponÃ­veis na Ã¡rea de menu \'ConfiguraÃ§Ã£o\'',0),(258801,7189,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¾Ð¿Ñ†Ð¸Ð¸ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹ Ð² Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ Ð¼ÐµÐ½ÑŽ Â«ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸Â»',0),(258802,7189,'es','MÃ¡s opciones disponibles en las Ã¡reas de menÃº \'ConfiguraciÃ³n\'',0),(258803,7189,'de','Weitere Optionen stehen im Bereich MenÃ¼ \'Setup\'',0),(258804,7189,'en','Further options are available in the \'Setup\' menu areas',0),(258805,7190,'is','',0),(258806,7190,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø±ÙŠØ¹ ',0),(258807,7190,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø±ÙŠØ¹ ',0),(258808,7190,'tr','HÄ±zlÄ± kurulum',0),(258809,7190,'pl','Szybkie ustawienie',0),(258810,7190,'bg','Ð‘ÑŠÑ€Ð·Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(258811,7190,'ur','ÙÙˆØ±ÛŒ Ø³ÛŒÙ¹ Ø§Ù¾',0),(258812,7190,'sr','Ð‘Ñ€Ð·Ð¾ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ð°Ñ€Ð°',0),(258813,7190,'vi','Setup nhanh',0),(258814,7190,'af','Blits Opstelling',0),(258815,7190,'ro','Setare rapida',0),(258816,7190,'et','Quick Setup',0),(258817,7190,'si','Quick Setup',0),(258818,7190,'ba','Quick Setup',0),(258819,7190,'nl','Snelle Setup',0),(258820,7190,'fi','Nopea asennus',0),(258821,7190,'no','Raskt oppsett',0),(258822,7190,'da','Hurtig opsÃ¦tning',0),(258823,7190,'ko','ë¹ ë¥¸ ì„¤ì¹˜',0),(258824,7190,'he','×”×ª×§× ×” ×ž×”×™×¨×”',0),(258825,7190,'el','Î“ÏÎ®Î³Î¿ÏÎ· ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(258826,7190,'zh','å¿«é€Ÿå®‰è£…\r\n',0),(258827,7190,'sv','Snabb installation',0),(258828,7190,'it','Configurazione rapida',0),(258829,7190,'tl','',0),(258830,7190,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3629;&#3618;&#3656;&#3634;&#3591;&#3619;&#3623;&#3604;&#3648;&#3619;&#3655;&#3623;',0),(258831,7190,'hi','à¤¤à¥à¤µà¤°à¤¿à¤¤ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(258832,7190,'ms','Persediaan cepat',0),(258833,7190,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø³Ø±ÙŠØ¹',0),(258834,7190,'fr','Configuration rapide',0),(258835,7190,'jp','ã‚¯ã‚¤ãƒƒã‚¯ ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(258836,7190,'pt','ConfiguraÃ§Ã£o rÃ¡pida',0),(258837,7190,'ru','Ð‘Ñ‹ÑÑ‚Ñ€Ð°Ñ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ°',0),(258838,7190,'es','ConfiguraciÃ³n Rapida',0),(258839,7190,'de','Quick-Setup',0),(258840,7190,'en','Quick Setup',0),(258841,7191,'is','',0),(258842,7191,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(258843,7191,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(258844,7191,'tr','Gerekli Ã§ek hesabÄ± bilgileri',0),(258845,7191,'pl','Wymagane konto bankowe Info',0),(258846,7191,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(258847,7191,'ur','Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ú©Û’ Ù…Ø·Ù„ÙˆØ¨Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(258848,7191,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð°Ð½ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð˜Ð½Ñ„Ð¾',0),(258849,7191,'vi','YÃªu Cáº§u ThÃ´ng Tin Kiá»ƒm Tra TK',0),(258850,7191,'af','Vereiste Tjekrekening Inligting',0),(258851,7191,'ro','Info necesare verificarea cont',0),(258852,7191,'et','Vajalik pangakonto Info',0),(258853,7191,'si','Info zahteva preverjanje raÄuna',0),(258854,7191,'ba','Diperlukan rekening giro Info',0),(258855,7191,'nl','Vereiste betaalrekening Info',0),(258856,7191,'fi','Tarpeen tarkistaa tilin tiedot',0),(258857,7191,'no','NÃ¸dvendig brukskonto informasjon',0),(258858,7191,'da','KrÃ¦ves checkkonto Info',0),(258859,7191,'ko','í•„ìš”í•œ ë‹¹ì¢Œ ê³„ì • ì •ë³´',0),(258860,7191,'he','×¤×¨×˜×™ ×—×©×‘×•×Ÿ ×‘× ×§ × ×“×¨×©',0),(258861,7191,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÏŒÏˆÎµÏ‰Ï‚',0),(258862,7191,'zh','éœ€è¦æ£€æŸ¥å¸æˆ·ä¿¡æ¯\r\n',0),(258863,7191,'sv','KrÃ¤vs kontroll-kontoinformation',0),(258864,7191,'it','Conto corrente richiesta Info',0),(258865,7191,'tl','',0),(258866,7191,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3594;&#3655;&#3588;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(258867,7191,'hi','à¤†à¤µà¤¶à¥à¤¯à¤• à¤šà¥‡à¤•à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(258868,7191,'ms','Maklumat dikehendaki memeriksa akaun',0),(258869,7191,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø­Ø³Ø§Ø¨ Ø§Ù„ØªØ­Ù‚Ù‚ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(258870,7191,'fr','Infos nÃ©cessaires sur le compte courant',0),(258871,7191,'jp','å¿…è¦ãªã‚¢ã‚«ã‚¦ãƒ³ãƒˆæƒ…å ±ã‚’ãƒã‚§ãƒƒã‚¯',0),(258872,7191,'pt','InformaÃ§Ã£o de conta necessÃ¡ria',0),(258873,7191,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚',0),(258874,7191,'es','Info de Cuenta de Cheques Requerido',0),(258875,7191,'de','Erforderliche Girokonto Info',0),(258876,7191,'en','Required Checking Account Info',0),(258877,7192,'is','',0),(258878,7192,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù„Ø§Ø²Ù… Ú¯Ù… Ø´Ø¯Ù‡ ',0),(258879,7192,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù„Ø§Ø²Ù… Ú¯Ù… Ø´Ø¯Ù‡ ',0),(258880,7192,'tr','Gerekli bilgiler eksik',0),(258881,7192,'pl','Brak wymaganych informacji',0),(258882,7192,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð°Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð»Ð¸Ð¿ÑÐ²Ð°',0),(258883,7192,'ur','Ù…Ø·Ù„ÙˆØ¨Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØºØ§Ø¦Ø¨',0),(258884,7192,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ñƒ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(258885,7192,'vi','Cáº§n ThÃ´ng Tin cÃ²n thiáº¿u',0),(258886,7192,'af','Vereiste Inligting Vermis',0),(258887,7192,'ro','Lipseste info obligatorie',0),(258888,7192,'et','Kohustuslik informatsioon on puudu',0),(258889,7192,'si','Manjka zahtevani podatki',0),(258890,7192,'ba','Informasi yang diperlukan hilang',0),(258891,7192,'nl','Vereiste informatie ontbreekt',0),(258892,7192,'fi','Tarvittavat tiedot puuttuvat',0),(258893,7192,'no','NÃ¸dvendig informasjon mangler',0),(258894,7192,'da','KrÃ¦vede oplysninger mangler',0),(258895,7192,'ko','í•„ìˆ˜ ì •ë³´ ëˆ„ë½',0),(258896,7192,'he','×”×ž×™×“×¢ ×”×“×¨×•×© ×—×¡×¨',0),(258897,7192,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î¿Ï… Î»ÎµÎ¯Ï€Î¿Ï…Î½',0),(258898,7192,'zh','æ‰€éœ€èµ„æ–™é—å¤±\r\n',0),(258899,7192,'sv','Information som krÃ¤vs saknas',0),(258900,7192,'it','Informazioni necessarie mancanti',0),(258901,7192,'tl','',0),(258902,7192,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(258903,7192,'hi','à¤†à¤µà¤¶à¥à¤¯à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¨à¤¹à¥€à¤‚',0),(258904,7192,'ms','Maklumat yang diperlukan hilang',0),(258905,7192,'ar','Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© ÙÙŠ Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙÙ‚ÙˆØ¯ÙŠÙ†.',0),(258906,7192,'fr','Renseignements requis manquant',0),(258907,7192,'jp','å¿…è¦ãªæƒ…å ±ãŒè¦‹ã¤ã‹ã‚‰ãªã„',0),(258908,7192,'pt','Falta de informaÃ§Ãµes necessÃ¡rias',0),(258909,7192,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð°Ñ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚',0),(258910,7192,'es','Falta InformaciÃ³n Requerida',0),(258911,7192,'de','Erforderlichen Informationen fehlen',0),(258912,7192,'en','Required Information Missing',0),(258913,7193,'is','',0),(258914,7193,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(258915,7193,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(258916,7193,'tr','Gerekli vergi bilgisi',0),(258917,7193,'pl','Informacji wymaganych podatkÃ³w',0),(258918,7193,'bg','Ð”Ð°Ð½ÑŠÐº Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð¸Ð·Ð¸ÑÐºÐ²Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(258919,7193,'ur','Ù…Ø·Ù„ÙˆØ¨Û Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(258920,7193,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð˜Ð½Ñ„Ð¾',0),(258921,7193,'vi','ThÃ´ng tin thuáº¿ kinh doanh yÃªu cáº§u',0),(258922,7193,'af','Vereiste Verkoopsbelasting Inligting',0),(258923,7193,'ro','Info necesare impozit pe vÃ¢nzÄƒri',0),(258924,7193,'et','NÃµutav kÃ¤ibemaks Info',0),(258925,7193,'si','Info zahteva prometnega davka',0),(258926,7193,'ba','Info diperlukan pajak penjualan',0),(258927,7193,'nl','Vereiste Sales Tax Info',0),(258928,7193,'fi','Pakollinen arvonlisÃ¤veron Info',0),(258929,7193,'no','NÃ¸dvendige mva-Info',0),(258930,7193,'da','KrÃ¦ves Sales Tax Info',0),(258931,7193,'ko','í•„ìš”í•œ íŒë§¤ ì„¸ê¸ˆ ì •ë³´',0),(258932,7193,'he','× ×“×¨×© ×ž×¢ ×ž×™×“×¢',0),(258933,7193,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(258934,7193,'zh','æ‰€éœ€é”€å”®ç¨Žä¿¡æ¯\r\n',0),(258935,7193,'sv','KrÃ¤vs moms information',0),(258936,7193,'it','Info IVA richiesto',0),(258937,7193,'tl','',0),(258938,7193,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(258939,7193,'hi','à¤†à¤µà¤¶à¥à¤¯à¤• à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(258940,7193,'ms','Maklumat cukai jualan diperlukan',0),(258941,7193,'ar','Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© Ù…Ù† Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(258942,7193,'fr','Info taxe requise',0),(258943,7193,'jp','å¿…è¦ãªå£²ä¸Šç¨Žæƒ…å ±',0),(258944,7193,'pt','InformaÃ§Ã£o necessÃ¡ria imposto sobre vendas',0),(258945,7193,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ñ‹Ñ… Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(258946,7193,'es','Info de IVA requerida',0),(258947,7193,'de','Erforderliche Umsatzsteuer-Info',0),(258948,7193,'en','Required Sales Tax Info',0),(258949,7194,'is','',0),(258950,7194,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(258951,7194,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(258952,7194,'tr','Kur tamamlandÄ±',0),(258953,7194,'pl','Konfigurowanie zakoÅ„czone',0),(258954,7194,'bg','Ð˜Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸',0),(258955,7194,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ù…Ú©Ù…Ù„',0),(258956,7194,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð°',0),(258957,7194,'vi','HoÃ n táº¥t Setup',0),(258958,7194,'af','Opstelling Voltooi',0),(258959,7194,'ro','Setare completa',0),(258960,7194,'et','Seadistus lÃµpetatud',0),(258961,7194,'si','Namestitev je dokonÄana',0),(258962,7194,'ba','Setup Complete',0),(258963,7194,'nl','Installatie voltooid',0),(258964,7194,'fi','Asennus valmis',0),(258965,7194,'no','Installasjonen er fullfÃ¸rt',0),(258966,7194,'da','Setup komplet',0),(258967,7194,'ko','ì„¤ì¹˜ ì™„ë£Œ',0),(258968,7194,'he','×”×ª×§× ×” ×ž×œ××”',0),(258969,7194,'el','Î Î»Î®ÏÎ·Ï‚ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(258970,7194,'zh','å®‰è£…å®Œæˆ\r\n',0),(258971,7194,'sv','Setup komplett',0),(258972,7194,'it','Installazione completa',0),(258973,7194,'tl','',0),(258974,7194,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(258975,7194,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤ªà¥‚à¤°à¥à¤£',0),(258976,7194,'ms','Persediaan yang lengkap',0),(258977,7194,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ ÙƒØ§Ù…Ù„Ø©',0),(258978,7194,'fr','Programme d\'installation complet',0),(258979,7194,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ãŒå®Œäº†ã—ã¾ã—ãŸ',0),(258980,7194,'pt','InstalaÃ§Ã£o completa',0),(258981,7194,'ru','ÐŸÐ¾Ð»Ð½Ð°Ñ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ°',0),(258982,7194,'es','ConfiguraciÃ³n Completa',0),(258983,7194,'de','Installation abgeschlossen',0),(258984,7194,'en','Setup Complete',0),(258985,7195,'is','',0),(258986,7195,'dr','Ù†Ø§Ù… Ø´Ø±ÙƒØª Ø´Ù…Ø§ Ú†ÙŠØ³ØªØŸ',0),(258987,7195,'pr','Ù†Ø§Ù… Ø´Ø±ÙƒØª Ø´Ù…Ø§ Ú†ÙŠØ³ØªØŸ',0),(258988,7195,'tr','Åžirketinizin ismi nedir',0),(258989,7195,'pl','Co to jest nazwa firmy',0),(258990,7195,'bg','ÐšÐ°ÐºÐ²Ð¾ Ðµ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(258991,7195,'ur','Ø§Ù¾Ù†ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… Ú©ÛŒØ§ ÛÛ’',0),(258992,7195,'sr','ÐšÐ°ÐºÐ¾ ÑÐµ Ð·Ð¾Ð²Ðµ Ñ‚Ð²Ð¾Ñ˜Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(258993,7195,'vi','TÃªn cty cá»§a báº¡n lÃ  gÃ¬',0),(258994,7195,'af','Wat is u Ondernemingnaam',0),(258995,7195,'ro','Care este numele firmei',0),(258996,7195,'et','Teie ettevÃµtte nimi',0),(258997,7195,'si','Kaj je ime vaÅ¡ega podjetja',0),(258998,7195,'ba','Apa itu nama perusahaan Anda',0),(258999,7195,'nl','Wat is de naam van uw bedrijf',0),(259000,7195,'fi','MikÃ¤ on yrityksesi nimi',0),(259001,7195,'no','Hva er firmanavn',0),(259002,7195,'da','Hvad er navnet pÃ¥ din virksomhed',0),(259003,7195,'ko','íšŒì‚¬ ì´ë¦„ì€ ë¬´ì—‡ìž…ë‹ˆê¹Œ',0),(259004,7195,'he','×ž×”×• ×©× ×”×—×‘×¨×” ×©×œ×š',0),(259005,7195,'el','Î¤Î¹ ÎµÎ¯Î½Î±Î¹ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ ÏƒÎ±Ï‚',0),(259006,7195,'zh','ä»€ä¹ˆæ˜¯æ‚¨çš„å…¬å¸åç§°\r\n',0),(259007,7195,'sv','Vad Ã¤r ditt fÃ¶retagsnamn',0),(259008,7195,'it','Qual Ã¨ il nome della tua azienda',0),(259009,7195,'tl','',0),(259010,7195,'th','&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3594;&#3639;&#3656;&#3629;&#3629;&#3632;&#3652;&#3619;',0),(259011,7195,'hi','à¤•à¥à¤¯à¤¾ à¤†à¤ªà¤•à¥€ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¹à¥ˆ',0),(259012,7195,'ms','Apakah nama syarikat anda',0),(259013,7195,'ar','Ù…Ø§ Ù‡Ùˆ \"Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ©\" Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(259014,7195,'fr','Quel est votre nom de compagnie',0),(259015,7195,'jp','ã‚ãªãŸã®ä¼šç¤¾åã¯ä½•ã§ã™ã‹',0),(259016,7195,'pt','Qual Ã© o nome da sua empresa',0),(259017,7195,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð’Ð°ÑˆÐµÐ¹ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(259018,7195,'es','Que es el Nombre de su Empresa',0),(259019,7195,'de','Wie heiÃŸt Ihr Unternehmen',0),(259020,7195,'en','What is your Company Name',0),(259021,7196,'is','',0),(259022,7196,'dr','Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§ Ø¨Ø±Ø§ÙŠ ',0),(259023,7196,'pr','Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§ Ø¨Ø±Ø§ÙŠ ',0),(259024,7196,'tr','Hava iÃ§in',0),(259025,7196,'pl','Pogoda dla',0),(259026,7196,'bg','Ð’Ñ€ÐµÐ¼ÐµÑ‚Ð¾ Ð·Ð°',0),(259027,7196,'ur','Ù…ÙˆØ³Ù… Ú©Û’ Ù„ÛŒÛ’',0),(259028,7196,'sr','Ð’Ñ€ÐµÐ¼ÐµÐ½ÑÐºÐ¾Ñ˜ Ð¿Ñ€Ð¾Ð³Ð½Ð¾Ð·Ð¸',0),(259029,7196,'vi','Thá»i tiáº¿t cho',0),(259030,7196,'af','Weer vir',0),(259031,7196,'ro','Vremea pentru',0),(259032,7196,'et','Ilm',0),(259033,7196,'si','Vreme za',0),(259034,7196,'ba','Cuaca untuk',0),(259035,7196,'nl','Weer voor',0),(259036,7196,'fi','SÃ¤Ã¤',0),(259037,7196,'no','VÃ¦r For',0),(259038,7196,'da','Vejret For',0),(259039,7196,'ko','ë‚ ì”¨ì— ëŒ€ í•œ',0),(259040,7196,'he','-×ž×–×’ ××•×•×™×¨ ×‘',0),(259041,7196,'el','ÎšÎ±Î¹ÏÏŒÏ‚ Î³Î¹Î±',0),(259042,7196,'zh','å¤©æ°”\r\n',0),(259043,7196,'sv','VÃ¤der fÃ¶r',0),(259044,7196,'it','Meteo per',0),(259045,7196,'tl','',0),(259046,7196,'th','&#3626;&#3616;&#3634;&#3614;&#3629;&#3634;&#3585;&#3634;&#3624;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(259047,7196,'hi','à¤®à¥Œà¤¸à¤® à¤•à¥‡ à¤²à¤¿à¤',0),(259048,7196,'ms','Keadaan cuaca',0),(259049,7196,'ar','Ø§Ù„Ø·Ù‚Ø³',0),(259050,7196,'fr','MÃ©tÃ©o pour',0),(259051,7196,'jp','ãŸã‚ã®å¤©æ°—',0),(259052,7196,'pt','Tempo para',0),(259053,7196,'ru','ÐŸÐ¾Ð³Ð¾Ð´Ð° ',0),(259054,7196,'es','Clima Para',0),(259055,7196,'de','Wettervorhersage',0),(259056,7196,'en','Weather For',0),(259057,7197,'is','',0),(259058,7197,'dr','(Ù…ØªØ¹Ù„Ù‚Ù‡)',0),(259059,7197,'pr','Ø¬Ù…Ø¹ Ø´Ø¯Ù‡(Ù…ØªØ¹Ù„Ù‚Ù‡)',0),(259060,7197,'tr','Tahakkuk eden',0),(259061,7197,'pl','Naliczone',0),(259062,7197,'bg','ÐÐ°Ñ‚Ñ€ÑƒÐ¿Ð°Ð½Ð¸',0),(259063,7197,'ur','ØªÙ…Ø§Ù… ÛÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§',0),(259064,7197,'sr','ÐÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ',0),(259065,7197,'vi','Cá»™ng Láº¡i',0),(259066,7197,'af','Opgeloop',0),(259067,7197,'ro','Acumulat',0),(259068,7197,'et','Kogunenud',0),(259069,7197,'si','ObraÄunane',0),(259070,7197,'ba','Bertambah',0),(259071,7197,'nl','Opgebouwde',0),(259072,7197,'fi','Kertyneet',0),(259073,7197,'no','PÃ¥lÃ¸pt',0),(259074,7197,'da','Periodiseret',0),(259075,7197,'ko','ë°œìƒ í•œ',0),(259076,7197,'he','× ×¦×‘×¨',0),(259077,7197,'el','Î”ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Î±',0),(259078,7197,'zh','åº”è®¡\r\n',0),(259079,7197,'sv','Upplupna',0),(259080,7197,'it','Maturati',0),(259081,7197,'tl','',0),(259082,7197,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3588;&#3591;&#3588;&#3657;&#3634;&#3591;',0),(259083,7197,'hi','à¤…à¤°à¥à¤œà¤¿à¤¤',0),(259084,7197,'ms','Terakru',0),(259085,7197,'ar','Ø§Ù„Ù…ØªØ±Ø§ÙƒÙ…Ø©',0),(259086,7197,'fr','AccumulÃ©e',0),(259087,7197,'jp','æœªæ‰•',0),(259088,7197,'pt','Acumulados',0),(259089,7197,'ru','ÐÐ°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð½Ñ‹Ðµ',0),(259090,7197,'es','Acumulado',0),(259091,7197,'de','RÃ¼ckstellungen',0),(259092,7197,'en','Accrued',0),(259093,7198,'is','',0),(259094,7198,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø¨Ø§ÙŠØ¯ Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø¨Ø§Ø´Ø¯ ',0),(259095,7198,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø¨Ø§ÙŠØ¯ Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø¨Ø§Ø´Ø¯ ',0),(259096,7198,'tr','Ã–deme tutarÄ± bakiyeden bÃ¼yÃ¼k olmamalÄ±dÄ±r',0),(259097,7198,'pl','Kwota wynagrodzenia nie moÅ¼e byÄ‡ wiÄ™ksze niÅ¼ rÃ³wnowagi',0),(259098,7198,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ð¾-Ð³Ð¾Ð»ÐµÐ¼Ð¸ Ð¾Ñ‚',0),(259099,7198,'ur','Ø±Ù‚Ù… Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ØªÙˆØ§Ø²Ù† Ù†ÛÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(259100,7198,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð½Ðµ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð²ÐµÑ›Ð° Ð¾Ð´ ÑÐ°Ð»Ð´Ð°',0),(259101,7198,'vi','Sá»‘ Tiá»n Thanh ToÃ¡n KhÃ´ng ÄÆ°á»£c Lá»›n HÆ¡n Sá»‘ DÆ°',0),(259102,7198,'af','Bedrag Om Te Betaal Moet Nie Groter Wees as die Balans',0),(259103,7198,'ro','Suma de platÄƒ nu trebuie sÄƒ fie mai mare decÃ¢t soldul',0),(259104,7198,'et','Makstav summa ei tohi olla suurem kui saldo',0),(259105,7198,'si','Znesek za plaÄilo, ne sme biti veÄje od bilance',0),(259106,7198,'ba','Jumlah bayar tidak harus lebih besar dari saldo',0),(259107,7198,'nl','Te betalen bedrag moet niet groter zijn dan saldo',0),(259108,7198,'fi','MÃ¤Ã¤rÃ¤ maksu ei saa olla suurempi kuin saldo',0),(259109,7198,'no','BelÃ¸p til betaling mÃ¥ ikke vÃ¦re stÃ¸rre enn',0),(259110,7198,'da','BelÃ¸b til lÃ¸n mÃ¥ ikke vÃ¦re stÃ¸rre end Balance',0),(259111,7198,'ko','ê¸ˆì•¡ì€ ì§€ë¶ˆ í•˜ì§€ ë³´ë‹¤ ì»¤ì•¼ ê· í˜•',0),(259112,7198,'he','×”×¡×›×•× ×©×™×© ×œ×©×œ× ××™× ×• ×™×›×•×œ ×œ×”×™×•×ª ×’×“×•×œ ×ž××™×–×•×Ÿ',0),(259113,7198,'el','Î Î¿ÏƒÏŒ Î½Î± Ï€Î»Î·ÏÏŽÏƒÎµÎ¹ Î´ÎµÎ½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼ÎµÎ³Î±Î»ÏÏ„ÎµÏÎ· Î±Ï€ÏŒ Ï„Î·Î½ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±',0),(259114,7198,'zh','æ”¯ä»˜é‡‘é¢ä¸å¾—å¤§äºŽç»“ä½™\r\n',0),(259115,7198,'sv','Belopp att betala fÃ¥r inte vara stÃ¶rre Ã¤n balans',0),(259116,7198,'it','Importo da pagare non deve essere maggiore di equilibrio',0),(259117,7198,'tl','',0),(259118,7198,'th','&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3605;&#3657;&#3629;&#3591;&#3652;&#3617;&#3656;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3648;&#3591;&#3636;&#3609;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(259119,7198,'hi','à¤°à¤¾à¤¶à¤¿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡ à¤­à¥€ à¤…à¤§à¤¿à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(259120,7198,'ms','Jumlah gaji hendaklah tidak melebihi baki',0),(259121,7198,'ar','ÙŠØ¬Ø¨ Ø£Ù† Ù„Ø§ ÙŠÙƒÙˆÙ† Ø§Ù„Ù…Ø¨Ù„Øº Ù„Ù„Ø¯ÙØ¹ Ø£ÙƒØ¨Ø± Ù…Ù† Ø§Ù„ØªÙˆØ§Ø²Ù†',0),(259122,7198,'fr','Montant Ã  payer ne doit pas Ãªtre supÃ©rieur Ã  l\'Ã©quilibre',0),(259123,7198,'jp','ãŠæ”¯æ‰•ã„é‡‘é¡ãŒãƒãƒ©ãƒ³ã‚¹ã‚’è¶…ãˆã‚‹ã¯ãªã‚Šã¾ã›ã‚“',0),(259124,7198,'pt','Montante a pagar nÃ£o deve ser maior que o equilÃ­brio',0),(259125,7198,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð²Ð¾Ð·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ñ Ð½Ðµ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð±Ð¾Ð»ÑŒÑˆÐµ Ñ‡ÐµÐ¼ Ð±Ð°Ð»Ð°Ð½Ñ',0),(259126,7198,'es','Monto que Pagar no Debe Ser MÃ¡s Grande que el Balance',0),(259127,7198,'de','Betrag zu zahlen dÃ¼rfen nicht grÃ¶ÃŸer als Balance',0),(259128,7198,'en','Amount To Pay Must Not Be Greater Than Balance',0),(259129,7199,'is','',0),(259130,7199,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(259131,7199,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(259132,7199,'tr','Ã–deme yap',0),(259133,7199,'pl','PÅ‚atnoÅ›ci',0),(259134,7199,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²ÐµÑ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(259135,7199,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ùˆ',0),(259136,7199,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(259137,7199,'vi','Tráº£ tiá»n',0),(259138,7199,'af','Maak Betaling',0),(259139,7199,'ro','Face plata',0),(259140,7199,'et','Teosta makse',0),(259141,7199,'si','PlaÄevanje',0),(259142,7199,'ba','Melakukan pembayaran',0),(259143,7199,'nl','Betaling',0),(259144,7199,'fi','Maksun',0),(259145,7199,'no','Foreta betaling',0),(259146,7199,'da','Foretage betaling',0),(259147,7199,'ko','ë‚©ë¶€ê¸ˆ',0),(259148,7199,'he','×ª×©×œ×•×',0),(259149,7199,'el','Î Î»Î·ÏÏŽÏƒÎ·',0),(259150,7199,'zh','è¿›è¡Œä»˜æ¬¾\r\n',0),(259151,7199,'sv','GÃ¶ra betalning',0),(259152,7199,'it','Effettuare il pagamento',0),(259153,7199,'tl','',0),(259154,7199,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(259155,7199,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¥‡à¤‚',0),(259156,7199,'ms','Membuat bayaran',0),(259157,7199,'ar','ØªØ³Ø¯ÙŠØ¯ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø©',0),(259158,7199,'fr','Effectuer le paiement',0),(259159,7199,'jp','æ”¯æ‰•ã„ã‚’è¡Œã†',0),(259160,7199,'pt','Fazer o pagamento',0),(259161,7199,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(259162,7199,'es','Hacer Pago',0),(259163,7199,'de','Zahlung vornehmen',0),(259164,7199,'en','Make Payment',0),(259165,7200,'is','',0),(259166,7200,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ù…Ù†ÙÙŠ Ø¨Ø§Ø´Ø¯ ',0),(259167,7200,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ù…Ù†ÙÙŠ Ø¨Ø§Ø´Ø¯ ',0),(259168,7200,'tr','Ã–deme miktarÄ± eksi olamaz',0),(259169,7200,'pl','Kwota pÅ‚atnoÅ›ci nie moÅ¼e byÄ‡ ujemna',0),(259170,7200,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»Ð½Ð¾',0),(259171,7200,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù‚Ù… Ù…Ù†ÙÛŒ Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©ØªØ§',0),(259172,7200,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð½ÐµÐ³Ð°Ñ‚Ð¸Ð²Ð½Ð°',0),(259173,7200,'vi','Sá»‘ tiá»n Thanh ToÃ¡n khÃ´ng thá»ƒ Ã¢m',0),(259174,7200,'af','Betalingsbedrag Kan Nie Negatief Wees',0),(259175,7200,'ro','Suma de platÄƒ nu poate fi negativ',0),(259176,7200,'et','Maksesumma ei tohi olla negatiivne',0),(259177,7200,'si','Znesek plaÄila ne sme biti negativna',0),(259178,7200,'ba','Jumlah pembayaran tidak dapat negatif',0);
INSERT INTO `langdef` VALUES (259179,7200,'nl','Verschuldigde bedrag niet negatief kan zijn',0),(259180,7200,'fi','Maksusumma ei voi olla negatiivinen',0),(259181,7200,'no','BetalingsbelÃ¸pet kan ikke vÃ¦re negativ',0),(259182,7200,'da','BetalingsbelÃ¸b mÃ¥ ikke vÃ¦re negativ',0),(259183,7200,'ko','ì§€ë¶ˆ ê¸ˆì•¡ì€ ìŒìˆ˜ê°€ ë  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(259184,7200,'he','×¡×›×•× ×”×ª×©×œ×•× ××™× ×• ×™×›×•×œ ×œ×”×™×•×ª ×©×œ×™×œ×™',0),(259185,7200,'el','Î Î¿ÏƒÏŒ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ Î±ÏÎ½Î·Ï„Î¹ÎºÎ®',0),(259186,7200,'zh','ä»˜æ¬¾é‡‘é¢ä¸èƒ½ä¸ºè´Ÿæ•°\r\n',0),(259187,7200,'sv','Beloppet fÃ¥r inte vara negativ',0),(259188,7200,'it','Importo del pagamento non puÃ² essere negativo',0),(259189,7200,'tl','',0),(259190,7200,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3652;&#3617;&#3656;&#3648;&#3611;&#3655;&#3609;&#3621;&#3610;',0),(259191,7200,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿ à¤¨à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤¹à¥‹ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(259192,7200,'ms','Jumlah bayaran tidak boleh negatif',0),(259193,7200,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¯ÙØ¹ Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªÙƒÙˆÙ† Ø³Ù„Ø¨ÙŠØ©',0),(259194,7200,'fr','Montant du paiement ne peut pas Ãªtre nÃ©gatif',0),(259195,7200,'jp','ãŠæ”¯æ‰•ã„é‡‘é¡ã‚’è² ã«ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(259196,7200,'pt','Valor do pagamento nÃ£o pode ser negativo',0),(259197,7200,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð° Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼',0),(259198,7200,'es','Monto de Pago no Puede Ser Negativo',0),(259199,7200,'de','Der Zahlung kann nicht negativ sein.',0),(259200,7200,'en','Payment Amount Cannot Be Negative',0),(259201,7201,'is','',0),(259202,7201,'dr','Ø­Ù‚ÙˆÙ‚ Ø§ÙƒÙ†ÙˆÙ†',0),(259203,7201,'pr','Ø­Ù‚ÙˆÙ‚ Ø§ÙƒÙ†ÙˆÙ†',0),(259204,7201,'tr','Åžimdi Ã¶demek',0),(259205,7201,'pl','ZapÅ‚aÄ‡ teraz',0),(259206,7201,'bg','ÐŸÐ»Ð°Ñ‚Ð¸ ÑÐµÐ³Ð°',0),(259207,7201,'ur','Ø§Ø¨ Ø§Ø¯Ø§',0),(259208,7201,'sr','ÐŸÐ»Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐ°Ð´Ð°',0),(259209,7201,'vi','Tráº£ bÃ¢y giá»',0),(259210,7201,'af','Betaal Nou',0),(259211,7201,'ro','PlÄƒtiÅ£i acum',0),(259212,7201,'et','NÃ¼Ã¼d maksma',0),(259213,7201,'si','Pay Now',0),(259214,7201,'ba','Bayar sekarang',0),(259215,7201,'nl','Nu betalen',0),(259216,7201,'fi','Maksaa nyt',0),(259217,7201,'no','Betal nÃ¥',0),(259218,7201,'da','Betale nu',0),(259219,7201,'ko','ì§€ê¸ˆ ì§€ë¶ˆ',0),(259220,7201,'he','×©×œ× ×›×¢×ª',0),(259221,7201,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Ï„ÏŽÏÎ±',0),(259222,7201,'zh','çŽ°åœ¨ä»˜æ¬¾\r\n',0),(259223,7201,'sv','Betala nu',0),(259224,7201,'it','Paga adesso',0),(259225,7201,'tl','',0),(259226,7201,'th','&#3592;&#3656;&#3634;&#3618;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(259227,7201,'hi','à¤…à¤¬ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(259228,7201,'ms','Bayar sekarang',0),(259229,7201,'ar','Ø§Ø¯ÙØ¹ Ø§Ù„Ø¢Ù†',0),(259230,7201,'fr','Payer maintenant',0),(259231,7201,'jp','ä»Šã™ãæ”¯æ‰•ã†',0),(259232,7201,'pt','Pagar agora',0),(259233,7201,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ ÑÐµÐ¹Ñ‡Ð°Ñ',0),(259234,7201,'es','Pagar Ahora',0),(259235,7201,'de','Jetzt bezahlen',0),(259236,7201,'en','Pay Now',0),(259237,7202,'is','',0),(259238,7202,'dr','B2B Ù…Ù†Ø§Ø¨Ø¹  ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(259239,7202,'pr','B2B Ù…Ù†Ø§Ø¨Ø¹  ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(259240,7202,'tr','B2B baÅŸvurusu',0),(259241,7202,'pl','B2B odniesienia',0),(259242,7202,'bg','B2B Ð¿Ñ€ÐµÐ¿Ñ€Ð°Ñ‚ÐºÐ°',0),(259243,7202,'ur','B2B Ø­ÙˆØ§Ù„Û',0),(259244,7202,'sr','Ð‘2Ð‘ Ñ€ÐµÑ„ÐµÑ€ÐµÐ½Ñ†Ð°',0),(259245,7202,'vi','B2B Tham Kháº£o',0),(259246,7202,'af','B2B Verwysings',0),(259247,7202,'ro','B2B de referinÅ£Äƒ',0),(259248,7202,'et','B2B viide',0),(259249,7202,'si','B2B referenÄne',0),(259250,7202,'ba','B2B referensi',0),(259251,7202,'nl','B2B verwijzing',0),(259252,7202,'fi','B2B viite',0),(259253,7202,'no','B2B referanse',0),(259254,7202,'da','B2B Reference',0),(259255,7202,'ko','B2B ì°¸ì¡°',0),(259256,7202,'he','×”×¤× ×™×” B2B',0),(259257,7202,'el','B2B Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(259258,7202,'zh','å•†ä¸šå¯¹å•†ä¸šçš„å‚è€ƒ\r\n',0),(259259,7202,'sv','B2B referens',0),(259260,7202,'it','Riferimento B2B',0),(259261,7202,'tl','',0),(259262,7202,'th','&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591; B2B',0),(259263,7202,'hi','B2B à¤¸à¤‚à¤¦à¤°à¥à¤­',0),(259264,7202,'ms','Rujukan B2B',0),(259265,7202,'ar','Ù…Ø±Ø¬Ø¹ B2B',0),(259266,7202,'fr','RÃ©fÃ©rence B2B',0),(259267,7202,'jp','B2B ã®å‚ç…§',0),(259268,7202,'pt','ReferÃªncia de B2B',0),(259269,7202,'ru','Ð¡Ð¿Ñ€Ð°Ð²Ð¾Ñ‡Ð½Ð¸Ðº B2B',0),(259270,7202,'es','N2N Referencia',0),(259271,7202,'de','B2B-Verweis',0),(259272,7202,'en','B2B Reference',0),(259273,7203,'is','',0),(259274,7203,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(259275,7203,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(259276,7203,'tr','Ã–deme tarihi',0),(259277,7203,'pl','Historia pÅ‚atnoÅ›ci',0),(259278,7203,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(259279,7203,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(259280,7203,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(259281,7203,'vi','Lá»‹ch sá»­ Thanh ToÃ¡n',0),(259282,7203,'af','Betalinggeskiedenis',0),(259283,7203,'ro','Istoricul plÄƒÅ£ilor',0),(259284,7203,'et','Makseajalugu',0),(259285,7203,'si','PlaÄilo zgodovino',0),(259286,7203,'ba','Riwayat pembayaran',0),(259287,7203,'nl','Geschiedenis van de betaling',0),(259288,7203,'fi','Maksuhistoria',0),(259289,7203,'no','Betaling historie',0),(259290,7203,'da','Betaling historie',0),(259291,7203,'ko','ê²°ì œ ë‚´ì—­',0),(259292,7203,'he','×”×™×¡×˜×•×¨×™×™×ª ×ª×©×œ×•×',0),(259293,7203,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(259294,7203,'zh','ä»˜æ¬¾åŽ†å²\r\n',0),(259295,7203,'sv','Betalning historia',0),(259296,7203,'it','Storia di pagamento',0),(259297,7203,'tl','',0),(259298,7203,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(259299,7203,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(259300,7203,'ms','\"Payment History\"',0),(259301,7203,'ar','Ø­Ø±ÙƒØ© Ø§Ù„Ø³Ø¯Ø§Ø¯',0),(259302,7203,'fr','Historique de paiement',0),(259303,7203,'jp','ãŠæ”¯æ‰•ã„å±¥æ­´',0),(259304,7203,'pt','HistÃ³rico de pagamentos',0),(259305,7203,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(259306,7203,'es','Historia de Pagos',0),(259307,7203,'de','Zahlungsverhalten',0),(259308,7203,'en','Payment History',0),(259309,7204,'is','',0),(259310,7204,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(259311,7204,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(259312,7204,'tr','Fatura tarihi',0),(259313,7204,'pl','Historia faktury',0),(259314,7204,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(259315,7204,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(259316,7204,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(259317,7204,'vi','Lá»‹ch sá»­ hÃ³a Ä‘Æ¡n',0),(259318,7204,'af','Faktuur Geskiedenis',0),(259319,7204,'ro','Istoric factura',0),(259320,7204,'et','Arve ajalugu',0),(259321,7204,'si','Zgodovina raÄuna',0),(259322,7204,'ba','Sejarah faktur',0),(259323,7204,'nl','Factuur geschiedenis',0),(259324,7204,'fi','Historia',0),(259325,7204,'no','Faktura historie',0),(259326,7204,'da','Faktura historie',0),(259327,7204,'ko','ì†¡ìž¥ ì—­ì‚¬',0),(259328,7204,'he','×”×™×¡×˜×•×¨×™×™×ª ×—×©×‘×•× ×™×ª',0),(259329,7204,'el','Î™ÏƒÏ„Î¿ÏÎ¯Î± Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(259330,7204,'zh','å‘ç¥¨åŽ†å²\r\n',0),(259331,7204,'sv','Faktura historia',0),(259332,7204,'it','Storia di fattura',0),(259333,7204,'tl','',0),(259334,7204,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(259335,7204,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(259336,7204,'ms','Sejarah invois',0),(259337,7204,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(259338,7204,'fr','Historique des factures',0),(259339,7204,'jp','è«‹æ±‚æ›¸ã®æ­´å²',0),(259340,7204,'pt','HistÃ³ria de factura',0),(259341,7204,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¡Ñ‡ÐµÑ‚Ð°',0),(259342,7204,'es','Historia de Factura',0),(259343,7204,'de','Rechnungs-Historie',0),(259344,7204,'en','Invoice History',0),(259345,7205,'is','',0),(259346,7205,'dr','Ø§ÙØ²ÙˆØ¯Ù‡ Ø´Ø¯ ÙˆÙ‚ØªÙŠ Ø­Ù…Ù„  ',0),(259347,7205,'pr','Ø§ÙØ²ÙˆØ¯Ù‡ Ø´Ø¯ ÙˆÙ‚ØªÙŠ Ø­Ù…Ù„  ',0),(259348,7205,'tr','Ne zaman eklendi gemi',0),(259349,7205,'pl','Dodane, gdy statek',0),(259350,7205,'bg','ÐšÐ¾Ð³Ð°Ñ‚Ð¾ Ð´Ð¾Ð±Ð°Ð²Ñ ÐºÐ¾Ñ€Ð°Ð±',0),(259351,7205,'ur','Ø¬Ø¨ Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²',0),(259352,7205,'sr','ÐšÐ°Ð´Ð° Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð¾ Ð±Ñ€Ð¾Ð´',0),(259353,7205,'vi','ThÃªm VÃ o Khi Váº­n Chuyá»ƒn',0),(259354,7205,'af','Bygevoeg met Versending',0),(259355,7205,'ro','Adaugat la livrare ',0),(259356,7205,'et','Lisatud kui laev',0),(259357,7205,'si','Doda, ko ladja',0),(259358,7205,'ba','Ditambahkan ketika dikirim',0),(259359,7205,'nl','Toegevoegd wanneer schip',0),(259360,7205,'fi','LisÃ¤tÃ¤ hintaa aluksen',0),(259361,7205,'no','Lagt nÃ¥r skipet',0),(259362,7205,'da','TilfÃ¸jet nÃ¥r skibet',0),(259363,7205,'ko','ë•Œ ì¶”ê°€ ë°°',0),(259364,7205,'he','×”×•×¡×™×£ ×›××©×¨ ×”×¡×¤×™× ×”',0),(259365,7205,'el','ÎŒÏ„Î±Î½ Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Ï€Î»Î¿Î¯Î¿',0),(259366,7205,'zh','ä¸Šèˆ¹æ—¶æ·»åŠ \r\n',0),(259367,7205,'sv','LÃ¤ggs till nÃ¤r fartyget',0),(259368,7205,'it','Aggiunto alla consegna',0),(259369,7205,'tl','',0),(259370,7205,'th','&#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3617;&#3639;&#3656;&#3629;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(259371,7205,'hi','à¤œà¤¬ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤œà¤¹à¤¾à¤œ',0),(259372,7205,'ms','Ditambah apabila kapal',0),(259373,7205,'ar','ÙˆØ£Ø¶Ø§Ù Ø¹Ù†Ø¯Ù…Ø§ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(259374,7205,'fr','AjoutÃ©e avec Transport ',0),(259375,7205,'jp','ã„ã¤è¿½åŠ ã•ã‚ŒãŸèˆ¹',0),(259376,7205,'pt','Adicionado quando navio',0),(259377,7205,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ð» ÐºÐ¾Ð³Ð´Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(259378,7205,'es','Agregado al Enviar',0),(259379,7205,'de','HinzugefÃ¼gt wenn Schiff',0),(259380,7205,'en','Added When Ship',0),(259381,7206,'is','',0),(259382,7206,'dr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(259383,7206,'pr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(259384,7206,'tr','Ã–ÄŸe yok',0),(259385,7206,'pl','Nie ma dostÄ™pnych przedmiotÃ³w',0),(259386,7206,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(259387,7206,'ur','Ú©ÙˆØ¦ÛŒ Ø´Û’ Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº',0),(259388,7206,'sr','ÐÐµÐ¼Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸ ÐºÐ¾Ñ˜Ðµ',0),(259389,7206,'vi','KhÃ´ng cÃ³ hÃ ng',0),(259390,7206,'af','Geen Items Beskikbaar',0),(259391,7206,'ro','Articole disponibile',0),(259392,7206,'et','Ãœksusi pole saadaval',0),(259393,7206,'si','Ni elementov, ki so na voljo',0),(259394,7206,'ba','Tidak ada item yang tersedia',0),(259395,7206,'nl','Geen Items beschikbaar',0),(259396,7206,'fi','Kohteita ei saatavilla',0),(259397,7206,'no','Ingen elementer tilgjengelig',0),(259398,7206,'da','Ingen poster til rÃ¥dighed',0),(259399,7206,'ko','ì‚¬ìš©í•  ìˆ˜ ì—†ëŠ” í•­ëª©',0),(259400,7206,'he','××™×Ÿ ×¤×¨×™×˜×™× ×–×ž×™× ×™×',0),(259401,7206,'el','Î”ÎµÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î±',0),(259402,7206,'zh','æ²¡æœ‰é¡¹ç›®æä¾›\r\n',0),(259403,7206,'sv','Inga artiklar finns',0),(259404,7206,'it','Nessun oggetto disponibile',0),(259405,7206,'tl','',0),(259406,7206,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3652;&#3604;&#3657;',0),(259407,7206,'hi','à¤•à¥‹à¤ˆ à¤†à¤‡à¤Ÿà¤® à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(259408,7206,'ms','Tiada item yang disediakan',0),(259409,7206,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ØµÙ†Ø§Ù Ù…ØªØ§Ø­Ø©',0),(259410,7206,'fr','Aucun Ã©lÃ©ment disponible',0),(259411,7206,'jp','åˆ©ç”¨å¯èƒ½ãªé …ç›®ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(259412,7206,'pt','NÃ£o hÃ¡ itens disponÃ­veis',0),(259413,7206,'ru','ÐÐµÑ‚ Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾Ð³Ð¾ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(259414,7206,'es','No Hay Items Disponibles',0),(259415,7206,'de','Keine Artikel verfÃ¼gbar',0),(259416,7206,'en','No Items Available',0),(259417,7207,'is','',0),(259418,7207,'dr','_ Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ _ ØµÙØ­Ù‡ Ø±Ø§ ØªØ§Ø²Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(259419,7207,'pr','Ø¨Ø¹Ø¯ Ø§Ø² Ø§ÙØ²ÙˆØ¯Ù†_ Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ _ ØµÙØ­Ù‡ Ø±Ø§ ØªØ§Ø²Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(259420,7207,'tr','Yeni ShipTo ekledikten sonra ekran yenileme',0),(259421,7207,'pl','OdÅ›wieÅ¼anie ekranu po dodaniu nowe miejsce dostawy',0),(259422,7207,'bg','ÐžÐ±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐµÐºÑ€Ð°Ð½Ð° ÑÐ»ÐµÐ´ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ ShipTo',0),(259423,7207,'ur','Ù†Ø¦Û’ Ø´Ø§Ù¾Ù¹Ùˆ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ø¹Ø¯ Ø³Ú©Ø±ÛŒÙ† ØªØ§Ø²Û Ú©Ø±ÛŒÚº',0),(259424,7207,'sr','ÐžÑÐ²ÐµÐ¶Ð°Ð²Ð°ÑšÐµ ÐµÐºÑ€Ð°Ð½Ð° ÐºÐ°Ð´Ð° Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ ÐŸÑ€Ð¸Ð¼Ð°Ð¾Ñ† Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(259425,7207,'vi','Refresh mÃ n hÃ¬nh sau khi thÃªm Ä‘á»‹a chá»‰ váº­n chuyá»ƒn',0),(259426,7207,'af','Verfris Skerm Nadat Nuwe VersendAan Bygevoeg is',0),(259427,7207,'ro','ReÃ®mprospÄƒtare ecran dupÄƒ adÄƒugarea de noi ShipTo',0),(259428,7207,'et','VÃ¤rskenda ekraan pÃ¤rast lisades uusi ShipTo',0),(259429,7207,'si','OsveÅ¾iti zaslon Äez seÅ¡tevanje nov ShipTo',0),(259430,7207,'ba','Me-refresh layar setelah menambahkan baru ShipTo',0),(259431,7207,'nl','Scherm vernieuwen na het toevoegen van nieuwe ShipTo',0),(259432,7207,'fi','PÃ¤ivitÃ¤ LisÃ¤ttyÃ¤si uuden ShipTo',0),(259433,7207,'no','Oppdater skjermen etter ny ShipTo',0),(259434,7207,'da','Opdater skÃ¦rmen efter tilfÃ¸jelse af nye ShipTo',0),(259435,7207,'ko','ìƒˆë¡œìš´ ShipTo ì¶”ê°€í•œ í›„ í™”ë©´ì„ ìƒˆë¡œ ê³ ì¹¨',0),(259436,7207,'he','×¨×¢× ×•×Ÿ ×”×ž×¡×š ×œ××—×¨ ×”×•×¡×¤×ª ×—×“×© ×©×¢×•×–×‘×ª',0),(259437,7207,'el','Î‘Î½Î±Î½ÎµÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ Î¿Î¸ÏŒÎ½Î· Î¼ÎµÏ„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Ï‰Î½ Î½Î­Ï‰Î½ ShipTo',0),(259438,7207,'zh','åˆ·æ–°å±å¹•åŽåŠ å…¥æ–°èˆ¹è¦\r\n',0),(259439,7207,'sv','Uppdatera skÃ¤rmen efter att lÃ¤gga till nya ShipTo',0),(259440,7207,'it','Aggiornare la schermata dopo l\'aggiunta di nuovo ShipTo',0),(259441,7207,'tl','',0),(259442,7207,'th','&#3619;&#3637;&#3648;&#3615;&#3619;&#3594;&#3627;&#3609;&#3657;&#3634;&#3592;&#3629;&#3627;&#3621;&#3633;&#3591;&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(259443,7207,'hi','à¤¨à¤ˆ ShipTo à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤•à¥‹ à¤¤à¤¾à¤œà¤¼à¤¾ à¤•à¤°à¥‡à¤‚',0),(259444,7207,'ms','Segar semula skrin selepas menambah ShipTo baru',0),(259445,7207,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø´Ø§Ø´Ø© Ø¨Ø¹Ø¯ Ø¥Ø¶Ø§ÙØ© Ø¬Ø¯ÙŠØ¯Ø© Ø´ÙŠØªÙˆ',0),(259446,7207,'fr','RafraÃ®chir l\'Ã©cran aprÃ¨s l\'ajout de nouveaux ShipTo',0),(259447,7207,'jp','æ–°ã—ã„ ShipTo ã‚’è¿½åŠ ã—ãŸå¾Œã®ç”»é¢ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(259448,7207,'pt','Atualizar tela apÃ³s a adiÃ§Ã£o de novo ShipTo',0),(259449,7207,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÐºÑ€Ð°Ð½ Ð¿Ð¾ÑÐ»Ðµ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð¾Ð²Ñ‹Ñ… ShipTo',0),(259450,7207,'es','Refrescar Pantalla DespuÃ©s de Agregar Nuvo Enviar A',0),(259451,7207,'de','Aktualisieren Sie Bildschirm nach dem HinzufÃ¼gen neuer ShipTo',0),(259452,7207,'en','Refresh Screen After Adding New ShipTo',0),(259453,7208,'is','',0),(259454,7208,'dr','Ø­Ù…Ù„ Ø¯Ø± Ø²Ù…Ø§Ù† Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ Ø§Ø¶Ø§ÙÙ‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(259455,7208,'pr','Ø­Ù…Ù„ Ø¯Ø± Ø²Ù…Ø§Ù† Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ Ø§Ø¶Ø§ÙÙ‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(259456,7208,'tr','Nakliye olacak olmak eklendi, zaman, sevk irsaliyesi',0),(259457,7208,'pl','WysyÅ‚ka bÄ™dzie byÄ‡ dodane w czasie zaÅ‚adunku',0),(259458,7208,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ‰Ðµ ÑÐµ Ð´Ð¾Ð±Ð°Ð²ÑÑ‚ Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(259459,7208,'ur','Ø´Ù¾Ù†Ú¯ Ú¯Ø§ ÛÙˆ Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ù…ÛŒÚº ÙˆÙ‚Øª Ú©ÛŒ Ú©Ú¾ÛŒÙ¾',0),(259460,7208,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð´Ð¾Ð´Ð°Ñ‚ Ð½Ð° Ð¿ÑƒÑ‚ Ð¾Ð´ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(259461,7208,'vi','Váº­n chuyá»ƒn sáº½ thÃªm vÃ o khi chuyá»ƒn hÃ ng',0),(259462,7208,'af','Versending sal Bygevoeg word Met die Tyd van Versending',0),(259463,7208,'ro','Transport maritim va fi adÄƒugat la timpul de livrare',0),(259464,7208,'et','Laevandus on olla lisatud kell aeg ja saadetise',0),(259465,7208,'si','Dostava bo se doda v Äasu odpreme',0),(259466,7208,'ba','Pengiriman akan akan ditambahkan di masa dari pengiriman',0),(259467,7208,'nl','Verzendkosten zullen worden toegevoegd op moment van verzending',0),(259468,7208,'fi','Toimitus ovat voidaan lisÃ¤tÃ¤ on aika ja toimituskulut',0),(259469,7208,'no','Norge vil bli lagt pÃ¥ tid av levering',0),(259470,7208,'da','Forsendelse vil blive tilfÃ¸jet pÃ¥ tid af leverance',0),(259471,7208,'ko','ë°°ì†¡ì´ ë©ë‹ˆë‹¤ ìˆ˜ ì¶”ê°€ì— ì‹œê°„ì˜ ì„ ì ',0),(259472,7208,'he','×”×ž×©×œ×•×— ×™×”×™×” × ×™×ª×Ÿ ×œ×”×•×¡×™×£-×–×ž×Ÿ ×©×œ ×”×ž×©×œ×•×—',0),(259473,7208,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î± Î¸Î± Î½Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ ÏƒÏ„Î¿ Ï‡ÏÏŒÎ½Î¿ Ï„Î·Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(259474,7208,'zh','èˆ¹èˆ¶å°†è¢«æ·»åŠ åœ¨è£…è¿æœŸé™\r\n',0),(259475,7208,'sv','Frakt kommer att lÃ¤ggas pÃ¥ tid fÃ¶r transport',0),(259476,7208,'it','Spedizione sarÃ  essere aggiunto al tempo di spedizione',0),(259477,7208,'tl','',0),(259478,7208,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3592;&#3632;&#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3609;&#3648;&#3623;&#3621;&#3634;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(259479,7208,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤œà¤¾à¤à¤—à¤¾ à¤¹à¥‹ à¤œà¥‹à¤¡à¤¼à¥‡ à¤ªà¤° à¤¸à¤®à¤¯ à¤•à¥€ à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ',0),(259480,7208,'ms','Penghantaran akan akan ditambah pada masa untuk penghantaran',0),(259481,7208,'ar','Ø§Ù„Ø´Ø­Ù† Ø³ÙˆÙ \"ÙŠÙƒÙˆÙ† Ø¥Ø¶Ø§ÙØ© ÙÙŠ ÙˆÙ‚Øª Ù„Ù„Ø´Ø­Ù†\"',0),(259482,7208,'fr','ExpÃ©dition va Ãªtre ajoutÃ© au temps d\'expÃ©dition',0),(259483,7208,'jp','é€æ–™ã¯å‡ºè·ã®æ™‚é–“ã«è¿½åŠ ã‚’ã—ã¾ã™ã€‚',0),(259484,7208,'pt','Transporte vai ser adicionado no tempo de carregamento',0),(259485,7208,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð±ÑƒÐ´ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð½Ð° Ð²Ñ€ÐµÐ¼Ñ Ð¸Ð· Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(259486,7208,'es','Flete SerÃ¡ Agregado al Tiempo de EnvÃ­o',0),(259487,7208,'de','Versand wird werden hinzugefÃ¼gt zur Zeit der Lieferung',0),(259488,7208,'en','Shipping will Be Added At Time Of Shipment',0),(259489,7209,'is','',0),(259490,7209,'dr','ÙƒØ§Ø±Øª',0),(259491,7209,'pr','ÙƒØ§Ø±Øª',0),(259492,7209,'tr','Kart',0),(259493,7209,'pl','Karty',0),(259494,7209,'bg','ÐšÐ°Ñ€Ñ‚Ð°',0),(259495,7209,'ur','Ú©Ø§Ø±Úˆ',0),(259496,7209,'sr','ÐšÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(259497,7209,'vi','Tháº»',0),(259498,7209,'af','Kaart',0),(259499,7209,'ro','Carte',0),(259500,7209,'et','Kaart',0),(259501,7209,'si','Kartice',0),(259502,7209,'ba','Kartu',0),(259503,7209,'nl','Kaart',0),(259504,7209,'fi','Kortti',0),(259505,7209,'no','Kort',0),(259506,7209,'da','Kort',0),(259507,7209,'ko','ì¹´ë“œ',0),(259508,7209,'he','×›×¨×˜×™×¡',0),(259509,7209,'el','ÎšÎ¬ÏÏ„Î±',0),(259510,7209,'zh','å¡\r\n',0),(259511,7209,'sv','Kort',0),(259512,7209,'it','Scheda',0),(259513,7209,'tl','',0),(259514,7209,'th','&#3610;&#3633;&#3605;&#3619;',0),(259515,7209,'hi','à¤•à¤¾à¤°à¥à¤¡',0),(259516,7209,'ms','Kad',0),(259517,7209,'ar','Ø¨Ø·Ø§Ù‚Ø©',0),(259518,7209,'fr','Carte',0),(259519,7209,'jp','ã‚«ãƒ¼ãƒ‰',0),(259520,7209,'pt','CartÃ£o',0),(259521,7209,'ru','ÐšÐ°Ñ€Ñ‚Ð°',0),(259522,7209,'es','Tarjeta',0),(259523,7209,'de','Karte',0),(259524,7209,'en','Card',0),(259525,7210,'is','',0),(259526,7210,'dr','ÙƒØ¯ ØªØ§ÙŠÙŠØ¯',0),(259527,7210,'pr','ÙƒØ¯ ØªØ§ÙŠÙŠØ¯',0),(259528,7210,'tr','Onay kodu',0),(259529,7210,'pl','Kod potwierdzajÄ…cy',0),(259530,7210,'bg','ÐšÐ¾Ð´ Ð·Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(259531,7210,'ur','ØªØµØ¯ÛŒÙ‚ÛŒ Ú©ÙˆÚˆ',0),(259532,7210,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° ÐºÐ¾Ð´Ð°',0),(259533,7210,'vi','MÃ£ xÃ¡c nháº­n',0),(259534,7210,'af','Bevestigingskode',0),(259535,7210,'ro','Cod de confirmare',0),(259536,7210,'et','Kinnitus kood',0),(259537,7210,'si','Krizma zbornik',0),(259538,7210,'ba','Kode konfirmasi',0),(259539,7210,'nl','Bevestigingscode',0),(259540,7210,'fi','Vahvistuskoodi',0),(259541,7210,'no','Bekreftelseskode',0),(259542,7210,'da','BekrÃ¦ftelseskoden',0),(259543,7210,'ko','í™•ì¸ ì½”ë“œ',0),(259544,7210,'he','×§×•×“ ×”××™×©×•×¨',0),(259545,7210,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·Ï‚',0),(259546,7210,'zh','ç¡®è®¤ç \r\n',0),(259547,7210,'sv','BekrÃ¤ftelsekoden',0),(259548,7210,'it','Codice di conferma',0),(259549,7210,'tl','',0),(259550,7210,'th','&#3619;&#3627;&#3633;&#3626;&#3585;&#3634;&#3619;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(259551,7210,'hi','à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ à¤•à¥‹à¤¡',0),(259552,7210,'ms','Kod pengesahan',0),(259553,7210,'ar','Ø±Ù…Ø² Ø§Ù„ØªØ£ÙƒÙŠØ¯',0),(259554,7210,'fr','Code de confirmation',0),(259555,7210,'jp','ç¢ºèªã‚³ãƒ¼ãƒ‰',0),(259556,7210,'pt','CÃ³digo de confirmaÃ§Ã£o',0),(259557,7210,'ru','ÐšÐ¾Ð´ ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(259558,7210,'es','CÃ³digo de ConfirmaciÃ³n',0),(259559,7210,'de','BestÃ¤tigungs-Code',0),(259560,7210,'en','Confirmation Code',0),(259561,7211,'is','',0),(259562,7211,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø´Ù…Ø§ Ø­ÙˆØ§Ù„Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(259563,7211,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø´Ù…Ø§ Ø­ÙˆØ§Ù„Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(259564,7211,'tr','Ã–deme hesabÄ±nÄ±za uygulanan',0),(259565,7211,'pl','PÅ‚atnoÅ›Ä‡ zostaÅ‚a zastosowana do konta',0),(259566,7211,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾ Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ ÐºÑŠÐ¼ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð°',0),(259567,7211,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¢Ù¾ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³Û’ Ù„Ú¯Ø§ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(259568,7211,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ Ð¿Ñ€Ð¸Ð¼ÐµÑšÐµÐ½Ð¾ Ð½Ð° Ð²Ð°Ñˆ Ð½Ð°Ð»Ð¾Ð³',0),(259569,7211,'vi','Thanh toÃ¡n Ä‘Ã£ Ã¡p dá»¥ng cho TK cá»§a báº¡n',0),(259570,7211,'af','Betaling is Gevoeg tot jou Rekening',0),(259571,7211,'ro','Plata a fost aplicat la contul dvs.',0),(259572,7211,'et','Makse on seotud kontoga',0),(259573,7211,'si','PlaÄilom na vaÅ¡ raÄun',0),(259574,7211,'ba','Pembayaran telah diterapkan untuk account Anda',0),(259575,7211,'nl','Betaling is toegepast op uw account',0),(259576,7211,'fi','Tilisi on kohdistettu maksu',0),(259577,7211,'no','Betaling er utlignet for kontoen',0),(259578,7211,'da','Betaling er blevet anvendt til din konto',0),(259579,7211,'ko','ì§€ë¶ˆ ê·€í•˜ì˜ ê³„ì •ì— ì ìš© ëœ',0),(259580,7211,'he','×”×ª×©×œ×•× ×”×•×—×œ ×œ×—×©×‘×•×Ÿ ×©×œ×š',0),(259581,7211,'el','ÎˆÏ‡ÎµÎ¹ ÏƒÏ…ÏƒÏ‡ÎµÏ„Î¹ÏƒÏ„ÎµÎ¯ Î· Ï€Î»Î·ÏÏ‰Î¼Î® ÏƒÏ„Î¿Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÎ±Ï‚',0),(259582,7211,'zh','ä»˜æ¬¾å·²åº”ç”¨åˆ°æ‚¨çš„å¸æˆ·\r\n',0),(259583,7211,'sv','Betalning har anvÃ¤nts pÃ¥ ditt konto',0),(259584,7211,'it','Pagamento Ã¨ stato applicato al tuo account',0),(259585,7211,'tl','',0),(259586,7211,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3606;&#3641;&#3585;&#3651;&#3594;&#3657;&#3585;&#3633;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3588;&#3640;&#3603;',0),(259587,7211,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤†à¤ªà¤•à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¥‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(259588,7211,'ms','Pembayaran yang telah digunakan untuk akaun anda',0),(259589,7211,'ar','ØªÙ… ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø¯ÙØ¹ Ø¥Ù„Ù‰ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(259590,7211,'fr','Paiement a Ã©tÃ© appliquÃ© Ã  votre compte',0),(259591,7211,'jp','ãŠæ”¯æ‰•ã„ã¯ã€ãŠå®¢æ§˜ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã«é©ç”¨ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(259592,7211,'pt','Pagamento tem sido aplicado Ã  sua conta',0),(259593,7211,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶ Ð±Ñ‹Ð» Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÐµÐ½ Ðº Ð²Ð°ÑˆÐµÐ¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(259594,7211,'es','Pago se aplicÃ³ a su cuenta',0),(259595,7211,'de','Zahlung wurde auf Ihr Konto angewendet',0),(259596,7211,'en','Payment has been applied to your account',0),(259597,7212,'is','',0),(259598,7212,'dr',') Ø®ÙˆØ¯ Ú†Ø§Ù¾ ÙƒÙ†ÙŠØ¯ ',0),(259599,7212,'pr','Ù„Ø·ÙØ§ Ø§ÙŠÙ† ØªØ§ÙŠÙŠØ¯ÙŠÙ‡ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø§Ø³Ù†Ø§Ø¯ Ø¯ÙØ§ØªØ± ) Ø®ÙˆØ¯ Ú†Ø§Ù¾ ÙƒÙ†ÙŠØ¯ ',0),(259600,7212,'tr','LÃ¼tfen kayÄ±tlarÄ±nÄ±z iÃ§in bu onayÄ± YazdÄ±r',0),(259601,7212,'pl','ProszÄ™ wydrukowaÄ‡ tego potwierdzenia Twoje rekordy',0),(259602,7212,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ Ñ‚Ð¾Ð²Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(259603,7212,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§Ø³ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Û’ Ù„Ø¦Û’ Ø¢Ù¾ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(259604,7212,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜Ñ‚Ðµ Ð¾Ð²Ñƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð° Ð·Ð°Ð¿Ð¸ÑÐµ',0),(259605,7212,'vi','Vui lÃ²ng in xÃ¡c nháº­n cho há»“ sÆ¡ cá»§a báº¡n',0),(259606,7212,'af','Druk asseblief hierdie bevestiging Uit vir u rekords. ',0),(259607,7212,'ro','VÄƒ rugÄƒm sÄƒ imprima aceasta confirmare pentru Ã®nregistrÄƒri',0),(259608,7212,'et','Palun printige see kinnitust enda jaoks',0),(259609,7212,'si','Natisnite to potrdilo za svojo evidenco',0),(259610,7212,'ba','Harap cetak ini konfirmasi untuk catatan Anda',0),(259611,7212,'nl','Deze bevestiging voor uw administratie in blokletters',0),(259612,7212,'fi','Tulosta itsellesi tÃ¤mÃ¤n tilausvahvistuksen',0),(259613,7212,'no','Skriv ut denne bekreftelse for oppfÃ¸ringene',0),(259614,7212,'da','Venligst udskrive denne bekrÃ¦ftelse til din registreringer',0),(259615,7212,'ko','ë‹¹ì‹ ì˜ ê¸°ë¡ ìœ„í•œì´ í™•ì¸ ì¸ì‡„ í•˜ì‹­ì‹œì˜¤',0),(259616,7212,'he','× × ×œ×”×“×¤×™×¡ ××ª ××™×©×•×¨ ×–×” ×¢×‘×•×¨ ×”×¨×©×•×ž×•×ª ×©×œ×š',0),(259617,7212,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï„Ï…Ï€ÏŽÏƒÏ„Îµ Î±Ï…Ï„Î® Î· ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Î³Î¹Î± Ï„Î¿ Î‘Î¡Î§Î•Î™ÎŸ Î£Î‘Î£',0),(259618,7212,'zh','è¯·ä¸ºæ‚¨çš„è®°å½•æ‰“å°æ­¤ç¡®è®¤\r\n',0),(259619,7212,'sv','VÃ¤nligen texta denna bekrÃ¤ftelse fÃ¶r din bokfÃ¶ring',0),(259620,7212,'it','Consigliamo di stampare la conferma per i record',0),(259621,7212,'tl','',0),(259622,7212,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3614;&#3636;&#3617;&#3614;&#3660;&#3585;&#3634;&#3619;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3609;&#3637;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3586;&#3',0),(259623,7212,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤ªà¤¨à¥‡ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(259624,7212,'ms','Sila cetak pengesahan ini untuk rujukan anda',0),(259625,7212,'ar','ÙŠØ±Ø¬Ù‰ Ø·Ø¨Ø§Ø¹Ø© Ù‡Ø°Ø§ Ø§Ù„ØªØ£ÙƒÙŠØ¯ Ù„Ù„Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(259626,7212,'fr','Veuillez imprimer cette confirmation pour vos dossiers',0),(259627,7212,'jp','ã“ã®ç¢ºèªã‚’è¨˜éŒ²ç”¨ã«å°åˆ·ã—ã¦ãã ã•ã„ã€‚',0),(259628,7212,'pt','Por favor, imprima esta confirmaÃ§Ã£o para seus registros',0),(259629,7212,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð½Ð°Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ ÑÑ‚Ð¾ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ðº Ð²Ð°ÑˆÐ¸Ð¼ Ð·Ð°Ð¿Ð¸ÑÑÐ¼',0),(259630,7212,'es','Por favor imprimir esta confirmaciÃ³n para sus records',0),(259631,7212,'de','Bitte drucken Sie diese BestÃ¤tigung fÃ¼r Ihre Unterlagen',0),(259632,7212,'en','Please print this confirmation for your records',0),(259633,7213,'is','',0),(259634,7213,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø®Ø¯Ù…Ø§Øª ',0),(259635,7213,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø®Ø¯Ù…Ø§Øª ',0),(259636,7213,'tr','Hizmet isteÄŸi',0),(259637,7213,'pl','Å»Ä…danie usÅ‚ugi',0),(259638,7213,'bg','Ð˜ÑÐºÐ°Ð½Ðµ ÑÐ»ÑƒÐ¶Ð±Ð°',0),(259639,7213,'ur','Ø³ÛÙˆÙ„Øª Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(259640,7213,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(259641,7213,'vi','YÃªu cáº§u dá»‹ch vá»¥',0),(259642,7213,'af','Diens Versoek',0),(259643,7213,'ro','Cerere servicii',0),(259644,7213,'et','Taotleda teenuse',0),(259645,7213,'si','Storitev na zahtevo',0),(259646,7213,'ba','Permintaan layanan',0),(259647,7213,'nl','Een serviceaanvraag indienen',0),(259648,7213,'fi','Kuvia tilaustyÃ¶nÃ¤',0),(259649,7213,'no','Be om Service',0),(259650,7213,'da','Anmode om Service',0),(259651,7213,'ko','ì„œë¹„ìŠ¤ ìš”ì²­',0),(259652,7213,'he','×œ×‘×§×© ×©×™×¨×•×ª',0),(259653,7213,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Î±Î¯Ï„Î·ÏƒÎ·',0),(259654,7213,'zh','ç”³è¯·æœåŠ¡\r\n',0),(259655,7213,'sv','BegÃ¤ra tjÃ¤nst',0),(259656,7213,'it','Richiesta servizio',0),(259657,7213,'tl','',0),(259658,7213,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(259659,7213,'hi','à¤¸à¥‡à¤µà¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(259660,7213,'ms','Permintaan Perkhidmatan',0),(259661,7213,'ar','Ø·Ù„Ø¨ Ø§Ù„Ø®Ø¯Ù…Ø©',0),(259662,7213,'fr','Demande de Service',0),(259663,7213,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã‚’è¦æ±‚ã—ã¾ã™ã€‚',0),(259664,7213,'pt','SolicitaÃ§Ã£o de serviÃ§o',0),(259665,7213,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(259666,7213,'es','Pedir Servicio',0),(259667,7213,'de','Service anfordern',0),(259668,7213,'en','Request Service',0),(259669,7214,'is','',0),(259670,7214,'dr','EIC ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯  Ù…ØªØ§Ù‡Ù„ , â€“ Ù‡Ù…Ø³Ø± Ú¯ÙˆØ§Ù‡ÙŠÙ†Ø§Ù…Ù‡ Ø±Ø§ Ù¾Ø± Ù…ÙŠ ÙƒÙ†Ø¯ ',0),(259671,7214,'pr','EIC ÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯  Ù…ØªØ§Ù‡Ù„ , â€“ Ù‡Ù…Ø³Ø± Ú¯ÙˆØ§Ù‡ÙŠÙ†Ø§Ù…Ù‡ Ø±Ø§ Ù¾Ø± Ù…ÙŠ ÙƒÙ†Ø¯ ',0),(259672,7214,'tr','EIC evli eÅŸ sertifika dosyalama mi.',0),(259673,7214,'pl','EIC Å¼onaty, maÅ‚Å¼onek jest skÅ‚adanie Å›wiadectwa',0),(259674,7214,'bg','Ð•Ð˜Ð¦ Ð¶ÐµÐ½ÐµÐ½, ÑÑŠÐ¿Ñ€ÑƒÐ³Ð° Ðµ ÑƒÐ´Ð¾ÑÑ‚Ð¾Ð²ÐµÑ€ÐµÐ½Ð¸Ðµ Ð·Ð° Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ',0),(259675,7214,'ur','Ø´Ø§Ø¯ÛŒØŒ Ø´Ø±ÛŒÚ© Ø­ÛŒØ§Øª ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û Ø¯Ø§Ø®Ù„ ÛÛ’ Û”',0),(259676,7214,'sr','Ð•Ð˜Ð¦ Ð¾Ð¶ÐµÑšÐµÐ½, ÑÑƒÐ¿Ñ€ÑƒÐ³Ð° Ñ˜Ðµ Ð¿Ð¾Ð´Ð½Ð¾ÑÐ¸Ð¾ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(259677,7214,'vi','ÄÃ£ káº¿t hÃ´n báº¡n Ä‘á»i Ä‘ang xin chá»©ng nháº­n',0),(259678,7214,'af','EIC getroud, gade is liassering sertifikaat',0),(259679,7214,'ro','EIC cÄƒsÄƒtorit, soÅ£ul/soÅ£ia este depunerea certificatului',0),(259680,7214,'et','EIC abielus, abikaasa on sertifikaadi esitamine',0),(259681,7214,'si','EIC poroÄen, zakonec je vloÅ¾itev potrdilo',0),(259682,7214,'ba','EIC menikah, pasangan adalah mengajukan sertifikat',0),(259683,7214,'nl','EIC getrouwd, echtgenoot is indienen van certificaat',0),(259684,7214,'fi','EIC naimisissa, puoliso on arkistointi todistus',0),(259685,7214,'no','EIC gift, ektefelle er innlevering sertifikat',0),(259686,7214,'da','EIC gift, Ã¦gtefÃ¦lle er arkivering certifikat',0),(259687,7214,'ko','EIC ê²°í˜¼, ë°°ìš°ìžê°€ ì œì¶œ ì¸ì¦ì„œ',0),(259688,7214,'he','× ×©×•×™ EIC, ×‘×Ÿ/×‘×ª ×”×–×•×’ ×”×•× ××™×©×•×¨ ×”×’×©×ª',0),(259689,7214,'el','Î•ÎšÎ  Ï€Î±Î½Ï„ÏÎµÎ¼Î­Î½Î·, ÏƒÏÎ¶Ï…Î³Î¿Ï‚ ÎµÎ¯Î½Î±Î¹ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÎ¿Ï',0),(259690,7214,'zh','é›‡ä¸»è¯†åˆ«å·²å©šï¼Œé…å¶å¤‡æ¡ˆè¯ä¹¦\r\n',0),(259691,7214,'sv','EIC gift, maken Ã¤r arkivering certifikat',0),(259692,7214,'it','EIC sposato, il coniuge Ã¨ certificato di deposito',0),(259693,7214,'tl','',0),(259694,7214,'th','EIC &#3626;&#3617;&#3619;&#3626;&#3649;&#3621;&#3657;&#3623;, &#3588;&#3641;&#3656;&#3626;&#3617;&#3619;&#3626;&#3618;&#3639;&#3656;&#3609;&#3651;&#3610;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;',0),(259695,7214,'hi','EIC à¤µà¤¿à¤µà¤¾à¤¹à¤¿à¤¤, à¤ªà¤¤à¤¿ à¤¯à¤¾ à¤ªà¤¤à¥à¤¨à¥€ à¤¹à¥ˆ à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤° à¤¦à¤¾à¤–à¤¿à¤²',0),(259696,7214,'ms','EIC berkahwin, pasangan adalah sijil memfailkan',0),(259697,7214,'ar','Ù…ØªØ²ÙˆØ¬ Ø¥ÙŠÙƒØŒ Ø§Ù„Ø²ÙˆØ¬ Ù‡Ùˆ \"Ø´Ù‡Ø§Ø¯Ø© Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹\"',0),(259698,7214,'fr','CPN mariÃ©, conjoint est le certificat de dÃ©pÃ´t',0),(259699,7214,'jp','EIC æ—¢å©šé…å¶è€…ã¯è¨¼æ˜Žæ›¸ã®æå‡º',0),(259700,7214,'pt','EIC casado, o cÃ´njuge Ã© certificado de depÃ³sito',0),(259701,7214,'ru','Ð•Ð˜Ð¦ Ð¶ÐµÐ½Ð°Ñ‚, ÑÑƒÐ¿Ñ€ÑƒÐ³Ð° â€” Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(259702,7214,'es','EIC Casado, Esposo esta Declarando el Certificado',0),(259703,7214,'de','EIC verheiratet, Ehegatte ist Anmeldung Zertifikat',0),(259704,7214,'en','EIC Married, Spouse is Filing Certificate',0),(259705,7215,'is','',0),(259706,7215,'dr','EICÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯  Ù…ØªØ§Ù‡Ù„',0),(259707,7215,'pr','EICÙƒØ§Ø±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯  Ù…ØªØ§Ù‡Ù„\r\n, â€“ Ù‡Ù…Ø³Ø± Ú¯ÙˆØ§Ù‡ÙŠÙ†Ø§Ù…Ù‡ Ø±Ø§ Ù¾Ø± Ù†Ù…ÙŠ ÙƒÙ†Ø¯ ',0),(259708,7215,'tr','EIC evli, eÅŸi sertifika dosyalama',0),(259709,7215,'pl','EIC Å¼onaty, Å¼ona nie skÅ‚adanie Å›wiadectwa',0),(259710,7215,'bg','Ð•Ð˜Ð¦ Ð¶ÐµÐ½ÐµÐ½, ÑÑŠÐ¿Ñ€ÑƒÐ³Ð° Ð½Ðµ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(259711,7215,'ur','Ø´Ø§Ø¯ÛŒØŒ Ø´Ø±ÛŒÚ© Ø­ÛŒØ§Øª Ù†ÛÛŒÚº Ø¯Ø§Ø®Ù„ ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û',0),(259712,7215,'sr','Ð•Ð˜Ð¦ ÑÐµ Ð¾Ð¶ÐµÐ½Ð¸Ð¾, Ð±Ñ€Ð°Ñ†Ð½Ð¸ Ð´Ñ€ÑƒÐ³ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾Ð´Ð½Ð¾ÑÐ¸Ð¾ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(259713,7215,'vi','ÄÃ£ káº¿t hÃ´n báº¡n Ä‘á»i khÃ´ng xin chá»©ng nháº­n',0),(259714,7215,'af','EIC getroud, gade nie indiening van sertifikaat',0),(259715,7215,'ro','EIC cÄƒsÄƒtorit, soÅ£ul/soÅ£ia nu depunerea certificatului',0),(259716,7215,'et','EIC abielus, abikaasa esitab tÃµendi',0),(259717,7215,'si','EIC poroÄen, Å¾ena ne vloÅ¾itve potrdilo',0),(259718,7215,'ba','EIC menikah, pasangan tidak mengajukan sertifikat',0),(259719,7215,'nl','EIC getrouwd, echtgenoot niet indienen van certificaat',0),(259720,7215,'fi','EIC naimisissa, puoliso hakemuksen todistus',0),(259721,7215,'no','EIC gift, ektefelle ikke Filing sertifikat',0),(259722,7215,'da','EIC gift, Ã¦gtefÃ¦lle ikke indgive certifikat',0),(259723,7215,'ko','EIC ê²°í˜¼ ë°°ìš°ìž ì•„ë‹Œ ì œì¶œ ì¸ì¦ì„œ',0),(259724,7215,'he','× ×©×•×™ EIC, ×‘×Ÿ ×–×•×’×• ×œ× ××™×©×•×¨ ×”×’×©×ª',0),(259725,7215,'el','Î•ÎšÎ  Ï€Î±Î½Ï„ÏÎµÎ¼Î­Î½Î·, ÏƒÏÎ¶Ï…Î³Î¿Ï‚ Î´ÎµÎ½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÎ¿Ï',0),(259726,7215,'zh','é›‡ä¸»è¯†åˆ«å·²å©šï¼Œé…å¶ä¸ç«‹æ¡ˆè¯ä¹¦\r\n',0),(259727,7215,'sv','EIC gift, make inte arkivering certifikat',0),(259728,7215,'it','EIC sposato, il coniuge non certificato di deposito',0),(259729,7215,'tl','',0),(259730,7215,'th','EIC &#3626;&#3617;&#3619;&#3626;&#3649;&#3621;&#3657;&#3623;, &#3588;&#3641;&#3656;&#3626;&#3617;&#3619;&#3626;&#3652;&#3617;&#3656;&#3618;&#3639;&#3656;&#3609;&#3651;&#3610;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;',0),(259731,7215,'hi','EIC à¤µà¤¿à¤µà¤¾à¤¹à¤¿à¤¤, à¤ªà¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤° à¤¦à¤¾à¤–à¤¿à¤²',0),(259732,7215,'ms','EIC berkahwin, suami isteri tidak memfailkan perakuan',0),(259733,7215,'ar','Ù…ØªØ²ÙˆØ¬ Ø¥ÙŠÙƒØŒ Ø§Ù„Ø²ÙˆØ¬ Ù„Ø§ \"Ø´Ù‡Ø§Ø¯Ø© Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹\"',0),(259734,7215,'fr','CPN mariÃ©, ne conjoint pas les certificats de dÃ©pÃ´t',0),(259735,7215,'jp','EIC ã®çµå©šã€é…å¶è€…ã®ãªã„è¨¼æ˜Žæ›¸ã‚’æå‡º',0),(259736,7215,'pt','EIC casado, cÃ´njuge nÃ£o apresentaÃ§Ã£o de certificado',0),(259737,7215,'ru','Ð•Ð˜Ð¦ Ð¶ÐµÐ½Ð°Ñ‚, ÑÑƒÐ¿Ñ€ÑƒÐ³Ð° Ð½Ðµ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(259738,7215,'es','EIC Casado, Esposo no esta Declarando el Certificado',0),(259739,7215,'de','EIC verheiratet, Ehegatte nicht Hinterlegung Zertifikat',0),(259740,7215,'en','EIC Married, Spouse not Filing Certificate',0),(259741,7216,'is','',0),(259742,7216,'dr','- Ù‡Ù…Ø³Ø± Ø³Ù†Ø¯ Ø±Ø³Ù…ÙŠ Ø¯Ø§Ø±Ø¯ ',0),(259743,7216,'pr','Ù…ØªØ§Ù‡Ù„- Ù‡Ù…Ø³Ø± Ø³Ù†Ø¯ Ø±Ø³Ù…ÙŠ Ø¯Ø§Ø±Ø¯ ',0),(259744,7216,'tr','Evli, eÅŸi sertifikasÄ±na sahip',0),(259745,7216,'pl','Å»onaty, maÅ‚Å¼onek posiada certyfikat',0),(259746,7216,'bg','Ð–ÐµÐ½ÐµÐ½, ÑÑŠÐ¿Ñ€ÑƒÐ³Ð° Ð¸Ð¼Ð° ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(259747,7216,'ur','Ø´Ø§Ø¯ÛŒ Ú©Ø± Ù„ÛŒ ÛÛ’ØŒ Ø´Ø±ÛŒÚ© Ø­ÛŒØ§Øª ÛÛ’ ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û',0),(259748,7216,'sr','Ð£Ð´Ð°Ñ‚Ð° , Ð¸Ð¼Ð° Ñ˜Ðµ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ ÑÑƒÐ¿Ñ€ÑƒÐ¶Ð½Ð¸ÐºÐ°',0),(259749,7216,'vi','Káº¿t hÃ´n báº¡n Ä‘á»i cÃ³ chá»©ng nháº­n',0),(259750,7216,'af','Getroud - Huweliksmaat het Sertifikaat',0),(259751,7216,'ro','CÄƒsÄƒtorit, soÅ£ul/soÅ£ia are certificat de',0),(259752,7216,'et','Abielus, abikaasa on sertifikaat',0),(259753,7216,'si','PoroÄen, Å¾ena ima certifikat',0),(259754,7216,'ba','Menikah, pasangan memiliki sertifikat',0),(259755,7216,'nl','Echtgenoot is getrouwd, en heeft certificaat',0),(259756,7216,'fi','Naimisissa, puoliso on sertifikaatti',0),(259757,7216,'no','Gift, har ektefelle sertifikat',0),(259758,7216,'da','Gift, har Ã¦gtefÃ¦lle certifikat',0),(259759,7216,'ko','ê²°í˜¼, ë°°ìš°ìžëŠ” ì¸ì¦ì„œ',0),(259760,7216,'he','× ×©×•×™, ×‘×Ÿ/×‘×ª ×”×–×•×’ ×™×© ××™×©×•×¨',0),(259761,7216,'el','Î Î±Î½Ï„ÏÎµÎ¼Î­Î½Î·, ÏƒÏÎ¶Ï…Î³Î¿Ï‚ Î­Ï‡ÎµÎ¹ Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŒ',0),(259762,7216,'zh','å·²å©šï¼Œé…å¶è¯ä¹¦\r\n',0),(259763,7216,'sv','Gift, har maken certifikat',0),(259764,7216,'it','Sposato, il coniuge ha certificato',0),(259765,7216,'tl','',0),(259766,7216,'th','&#3649;&#3605;&#3656;&#3591;&#3591;&#3634;&#3609;&#3649;&#3621;&#3657;&#3623;,&#3588;&#3641;&#3656;&#3626;&#3634;&#3617;&#3637;&#3616;&#3619;&#3619;&#3618;&#3634;&#3607;&#3637;&#3656;&#3592;&#3604;&#3607;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;',0),(259767,7216,'hi','à¤µà¤¿à¤µà¤¾à¤¹à¤¿à¤¤, à¤ªà¤¤à¤¿ à¤¯à¤¾ à¤ªà¤¤à¥à¤¨à¥€ à¤¹à¥ˆ à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤°',0),(259768,7216,'ms','Berkahwin, pasangan mempunyai Sijil',0),(259769,7216,'ar','Ù…ØªØ²ÙˆØ¬Ø© ÙˆØ§Ù„Ø²ÙˆØ¬ Ù„Ø¯ÙŠÙ‡ Ø´Ù‡Ø§Ø¯Ø©',0),(259770,7216,'fr','MariÃ©, conjoint a certificat',0),(259771,7216,'jp','é…å¶è€…ã¨çµå©šã—ã¦ã€è¨¼æ˜Žæ›¸ã‚’æŒã£ã¦ã„ã¾ã™',0),(259772,7216,'pt','Casado, o cÃ´njuge tem certificado',0),(259773,7216,'ru','Ð–ÐµÐ½Ð°Ñ‚, ÑÑƒÐ¿Ñ€ÑƒÐ³Ð° Ð¸Ð¼ÐµÐµÑ‚ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(259774,7216,'es','Casado, Esposo(a) tiene Certificado',0),(259775,7216,'de','Verheiratet, hat Ehepartner Zertifikat',0),(259776,7216,'en','Married, Spouse has Certificate',0),(259777,7217,'is','',0),(259778,7217,'dr','- Ù‡Ù…Ø³Ø± Ø³Ù†Ø¯ Ø±Ø³Ù…ÙŠ Ù†Ø¯Ø§Ø±Ø¯ ',0),(259779,7217,'pr','Ù…ØªØ§Ù‡Ù„- Ù‡Ù…Ø³Ø± Ø³Ù†Ø¯ Ø±Ø³Ù…ÙŠ Ù†Ø¯Ø§Ø±Ø¯ ',0),(259780,7217,'tr','Evli, eÅŸi sertifikasÄ± olmayan',0),(259781,7217,'pl','Å»onaty, maÅ‚Å¼onka bez certyfikatu',0),(259782,7217,'bg','Ð–ÐµÐ½ÐµÐ½, ÑÑŠÐ¿Ñ€ÑƒÐ³Ð° Ð±ÐµÐ· ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(259783,7217,'ur','Ø´Ø§Ø¯ÛŒØŒ Ø³Ù†Ø¯ Ú©Û’ Ø¨ØºÛŒØ± Ø´Ø±ÛŒÚ© Ø­ÛŒØ§Øª',0),(259784,7217,'sr','Ð£ Ð±Ñ€Ð°ÐºÑƒ, ÑÑƒÐ¿Ñ€ÑƒÐ¶Ð½Ð¸ÐºÐ° Ð±ÐµÐ· Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(259785,7217,'vi','Káº¿t hÃ´n báº¡n Ä‘á»i khÃ´ng cÃ³ chá»©ng nháº­n',0),(259786,7217,'af','Getroud - Huweliksmaat sonder Sertifikaat',0),(259787,7217,'ro','CÄƒsÄƒtorit, soÅ£ul fÄƒrÄƒ certificat de',0),(259788,7217,'et','Abielus, abikaasa ilma sertifikaadi',0),(259789,7217,'si','PoroÄen, zakonca brez certifikata',0),(259790,7217,'ba','Menikah, pasangan tanpa sertifikat',0),(259791,7217,'nl','Getrouwd, echtgenoot zonder certificaat',0),(259792,7217,'fi','Naimisissa, puoliso ilman todistus',0),(259793,7217,'no','Gift, ektefelle uten sertifikat',0),(259794,7217,'da','Gift, Ã¦gtefÃ¦lle uden certifikat',0),(259795,7217,'ko','ê²°í˜¼, ë°°ìš°ìž ì¸ì¦ì„œ ì—†ì´',0),(259796,7217,'he','× ×©×•×™, ×‘×Ÿ ×”×–×•×’ ×œ×œ× ××™×©×•×¨',0),(259797,7217,'el','Î Î±Î½Ï„ÏÎµÎ¼Î­Î½Î¿Ï‚, ÏƒÏÎ¶Ï…Î³Î¿ Ï‡Ï‰ÏÎ¯Ï‚ Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŒ',0),(259798,7217,'zh','å·²å©šï¼Œé…å¶æ— è¯\r\n',0),(259799,7217,'sv','Gift, make utan certifikat',0),(259800,7217,'it','Sposato, il coniuge senza certificato',0),(259801,7217,'tl','',0),(259802,7217,'th','&#3649;&#3605;&#3656;&#3591;&#3591;&#3634;&#3609;&#3649;&#3621;&#3657;&#3623;,&#3588;&#3641;&#3656;&#3626;&#3634;&#3617;&#3637;&#3616;&#3619;&#3619;&#3618;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3592;&#3604;&#3607;&#3632;&#3648;&#3610;&#3637;&#',0),(259803,7217,'hi','à¤µà¤¿à¤µà¤¾à¤¹à¤¿à¤¤, à¤ªà¤¤à¤¿ à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾ à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤°',0),(259804,7217,'ms','Berkahwin, pasangan tanpa Sijil',0),(259805,7217,'ar','ØªØ²ÙˆØ¬ Ø§Ù„Ø²ÙˆØ¬ Ø¯ÙˆÙ† Ø´Ù‡Ø§Ø¯Ø©',0),(259806,7217,'fr','MariÃ©, conjoint sans certificat',0),(259807,7217,'jp','è¨¼æ˜Žæ›¸ãªã—ã®é…å¶è€…ã¨çµå©šã—ã¾ã—ãŸã€‚',0),(259808,7217,'pt','Casado, cÃ´njuge sem certificado',0),(259809,7217,'ru','Ð–ÐµÐ½Ð°Ñ‚, ÑÑƒÐ¿Ñ€ÑƒÐ³Ð° Ð±ÐµÐ· ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(259810,7217,'es','Casado, Esposo(a) no tiene Certificado',0),(259811,7217,'de','Verheiratet, Ehepartner ohne Zertifikat',0),(259812,7217,'en','Married, Spouse without Certificate',0),(259813,7218,'is','',0),(259814,7218,'dr','_Ø­Ù…Ù„ Ø¨Ù‡ .._',0),(259815,7218,'pr','Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÙŠØ¯ Ù…Ø´Ø§Ø¨Ù‡  _Ø­Ù…Ù„ Ø¨Ù‡ .._',0),(259816,7218,'tr','Yeni sipariÅŸ aynÄ± ShipTo',0),(259817,7218,'pl','Nowe zamÃ³wienie samo miejsce dostawy',0),(259818,7218,'bg','ÐÐ¾Ð² Ñ€ÐµÐ´ ÑÑŠÑ‰Ð¾Ñ‚Ð¾ ShipTo',0),(259819,7218,'ur','Ú©Û Ø§Ø³ÛŒ Ù†Ø¦ÛŒ Ø¢Ø±ÚˆØ± Ø´Ø§Ù¾Ù¹Ùˆ',0),(259820,7218,'sr','ÐÐ¾Ð²Ð¾ Ð½Ð°Ñ€ÐµÐ´Ð¸ Ð¸ÑÑ‚Ð¾ ÐŸÑ€Ð¸Ð¼Ð°Ð¾Ñ† Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(259821,7218,'vi','ÄÆ¡n Ä‘áº·t hÃ ng má»›i cÃ¹ng Ä‘á»‹a chá»‰ giao hÃ ng',0),(259822,7218,'af','Nuwe Bestelling Dieselfde Versend Aan',0),(259823,7218,'ro','Noua ordine acelaÅŸi ShipTo',0),(259824,7218,'et','Uus tellimus, sama tarneaadress',0),(259825,7218,'si','Novo, da enako ShipTo',0),(259826,7218,'ba','Baru memesan sama ShipTo',0),(259827,7218,'nl','Nieuwe bestellen hetzelfde ShipTo',0),(259828,7218,'fi','Uusi jÃ¤rjestys sama ShipTo',0),(259829,7218,'no','Ny bestilling samme ShipTo',0),(259830,7218,'da','Nye bestille Same ShipTo',0),(259831,7218,'ko','ìƒˆë¡œìš´ ì£¼ë¬¸ ê°™ì€ ShipTo',0),(259832,7218,'he','×—×“×© ×œ×”×–×ž×™×Ÿ ××•×ª×• ×©×¢×•×–×‘×ª',0),(259833,7218,'el','ÎÎ­Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î¯Î´Î¹Î¿ ShipTo',0),(259834,7218,'zh','åŒä¸€èˆ¹èˆ¶ä¸ºæ–°ç§©åº\r\n',0),(259835,7218,'sv','Nytt bestÃ¤lla samma ShipTo',0),(259836,7218,'it','Nuovo ordine stesso ShipTo',0),(259837,7218,'tl','',0),(259838,7218,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3607;&#3637;&#3656;&#3648;&#3604;&#3636;&#3617;',0),(259839,7218,'hi','à¤‰à¤¸à¥€ à¤•à¥‡ à¤¨à¤ à¤†à¤¦à¥‡à¤¶ ShipTo',0),(259840,7218,'ms','Baru perintah sama ShipTo',0),(259841,7218,'ar','Ø¬Ø¯ÙŠØ¯ Ù…Ù† Ø£Ø¬Ù„ Ù†ÙØ³ Ø´ÙŠØªÙˆ',0),(259842,7218,'fr','Nouvel ordre mÃªme ShipTo',0),(259843,7218,'jp','æ–°ã—ã„é †åºåŒã˜ ShipTo',0),(259844,7218,'pt','Nova ordem mesmo ShipTo',0),(259845,7218,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¶Ðµ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº ShipTo',0),(259846,7218,'es','Nuevo Pedido Mismo Enviar a',0),(259847,7218,'de','Neu bestellen Sie gleiche ShipTo',0),(259848,7218,'en','New Order Same ShipTo',0),(259849,7219,'is','',0),(259850,7219,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(259851,7219,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(259852,7219,'tr','Teklif arama',0),(259853,7219,'pl','Wyszukiwanie ofert online',0),(259854,7219,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(259855,7219,'ur','ØªÙ„Ø§Ø´ Ø³Û’ Ø§Ù‚ØªØ¨Ø§Ø³',0),(259856,7219,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(259857,7219,'vi','TÃ¬m BÃ¡o giÃ¡ ',0),(259858,7219,'af','Kwotasie Soektog',0),(259859,7219,'ro','Citat de cÄƒutare',0),(259860,7219,'et','Hinnapakkumise otsing',0),(259861,7219,'si','Iskanje ponudbe',0),(259862,7219,'ba','Cari Penawaran',0),(259863,7219,'nl','Offerte zoeken',0),(259864,7219,'fi','Lainaus Etsi',0),(259865,7219,'no','TilbudssÃ¸k',0),(259866,7219,'da','Tilbud SÃ¸g',0),(259867,7219,'ko','ê²¬ì  ê²€ìƒ‰',0),(259868,7219,'he','×—×™×¤×•×© ×”×¦×¢×ª ×ž×—×™×¨',0),(259869,7219,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÏŽÎ½',0),(259870,7219,'zh','æŠ¥ä»·æœç´¢\r\n',0),(259871,7219,'sv','Citera SÃ¶k',0),(259872,7219,'it','Citazione ricerca',0),(259873,7219,'tl','',0),(259874,7219,'th','&#3649;&#3592;&#3657;&#3591;&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;',0),(259875,7219,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£ à¤–à¥‹à¤œ',0),(259876,7219,'ms','Cari sebut harga',0),(259877,7219,'ar','Ø¨Ø­Ø« Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(259878,7219,'fr','Recherche de citation',0),(259879,7219,'jp','å¼•ç”¨æ¤œç´¢',0),(259880,7219,'pt','Pesquisa de citaÃ§Ãµes',0),(259881,7219,'ru','ÐŸÐ¾Ð¸ÑÐº ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(259882,7219,'es','CotizaciÃ³n Buscar',0),(259883,7219,'de','Zitat-Suche',0),(259884,7219,'en','Quote Search',0),(259885,7220,'is','',0),(259886,7220,'dr','ØªØ§ÙŠÙŠØ¯ Ø­Ù…Ù„',0),(259887,7220,'pr','ØªØ§ÙŠÙŠØ¯ Ø­Ù…Ù„',0),(259888,7220,'tr','Gemiye alÄ±ndÄ± bildirimi',0),(259889,7220,'pl','Potwierdzenie statku',0),(259890,7220,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð°',0),(259891,7220,'ur','Ø¬ÛØ§Ø² Ú©Ø¦Û’',0),(259892,7220,'sr','Ð‘Ñ€Ð¾Ð´ Ð¿Ñ€Ð¸Ð·Ð½Ð°ÑšÐµ',0),(259893,7220,'vi','XÃ¡c nháº­n váº­n chuyá»ƒn ',0),(259894,7220,'af','Versend Erkening',0),(259895,7220,'ro','Confirmare livrare',0),(259896,7220,'et','Kauba saaja kinnitus',0),(259897,7220,'si','Ladja priznanje',0),(259898,7220,'ba','Kapal pengakuan',0),(259899,7220,'nl','Schip bevestiging',0),(259900,7220,'fi','Aluksen vahvistus',0),(259901,7220,'no','Sende bekreftelse',0),(259902,7220,'da','Skibet anerkendelse',0),(259903,7220,'ko','ë°° ì¸ì •',0),(259904,7220,'he','×•×™×“×•×¢ ×”×¡×¤×™× ×”',0),(259905,7220,'el','Î‘Î½Î±Î³Î½ÏŽÏÎ¹ÏƒÎ· Ï„Ï‰Î½ Ï€Î»Î¿Î¯Ï‰Î½',0),(259906,7220,'zh','èˆ¹èˆ¶è‡´è°¢\r\n',0),(259907,7220,'sv','Fartyget bekrÃ¤ftelse',0),(259908,7220,'it','Riconoscimento di nave',0),(259909,7220,'tl','',0),(259910,7220,'th','&#3651;&#3610;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(259911,7220,'hi','à¤œà¤¹à¤¾à¤œ à¤°à¤¸à¥€à¤¦',0),(259912,7220,'ms','Akuan kapal',0),(259913,7220,'ar','Ø¥Ø¹Ù„Ø§Ù… Ø§Ù„Ø³ÙÙ†',0),(259914,7220,'fr','AccusÃ© de rÃ©ception de navire',0),(259915,7220,'jp','èˆ¹ã®å—ä¿¡ç¢ºèª',0),(259916,7220,'pt','Nave de reconhecimento',0),(259917,7220,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(259918,7220,'es','Reconocimiento de EnvÃ­o',0),(259919,7220,'de','Schiff-Anerkennung',0),(259920,7220,'en','Ship Acknowledgment',0),(259921,7221,'is','',0),(259922,7221,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø´ØºÙ„ Ù‡Ø§',0),(259923,7221,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø´ØºÙ„ Ù‡Ø§',0),(259924,7221,'tr','Ä°ÅŸ arama',0),(259925,7221,'pl','Szukaj pracy',0),(259926,7221,'bg','Ð¢ÑŠÑ€ÑÐ¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(259927,7221,'ur','ØªÙ„Ø§Ø´ ÙƒØ±ÛŒÚº',0),(259928,7221,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÐ»Ð¾Ð²Ð°',0),(259929,7221,'vi','TÃ¬m Job',0),(259930,7221,'af','Soek werk',0),(259931,7221,'ro','CÄƒutare de locuri de muncÄƒ',0),(259932,7221,'et','Otsi tÃ¶Ã¶kohta',0),(259933,7221,'si','IÅ¡Äi delovna mesta',0),(259934,7221,'ba','Cari pekerjaan',0),(259935,7221,'nl','Zoek Jobs',0),(259936,7221,'fi','Etsi tyÃ¶paikkoja',0),(259937,7221,'no','SÃ¸k etter jobber',0),(259938,7221,'da','SÃ¸g job',0),(259939,7221,'ko','ê²€ìƒ‰ ìž‘ì—…',0),(259940,7221,'he','×—×¤×© ×¢×‘×•×“×•×ª',0),(259941,7221,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î¸Î­ÏƒÎµÏ‰Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(259942,7221,'zh','æœç´¢å·¥ä½œ\r\n',0),(259943,7221,'sv','SÃ¶k jobb',0),(259944,7221,'it','Lavori di ricerca',0),(259945,7221,'tl','',0),(259946,7221,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3591;&#3634;&#3609;',0),(259947,7221,'hi','à¤–à¥‹à¤œ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¤¾à¤‚',0),(259948,7221,'ms','Carian kerja',0),(259949,7221,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† ÙˆØ¸Ø§Ø¦Ù',0),(259950,7221,'fr','Recherche d\'emplois',0),(259951,7221,'jp','æ±‚äººã‚’æ¤œç´¢',0),(259952,7221,'pt','Pesquisar Empregos',0),(259953,7221,'ru','ÐŸÐ¾Ð¸ÑÐº Ð²Ð°ÐºÐ°Ð½ÑÐ¸Ð¸',0),(259954,7221,'es','Buscar Trabajos',0),(259955,7221,'de','Jobs suchen',0),(259956,7221,'en','Search Jobs',0),(259957,7222,'is','',0),(259958,7222,'dr','Ø¨Ø¯ÙˆÙ† Ú¯Ø²Ø§Ø±Ø´ ',0),(259959,7222,'pr','Ø¨Ø¯ÙˆÙ† Ú¯Ø²Ø§Ø±Ø´ ',0),(259960,7222,'tr','Rapor yok',0),(259961,7222,'pl','Raport',0),(259962,7222,'bg','ÐÑÐ¼Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(259963,7222,'ur','Ú©ÙˆØ¦ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(259964,7222,'sr','ÐÐµÐ¼Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(259965,7222,'vi','KhÃ´ng bÃ¡o cÃ¡o',0),(259966,7222,'af','Geen Verslag',0),(259967,7222,'ro','Nici un raport',0),(259968,7222,'et','Aruannet',0),(259969,7222,'si','No poroÄilo',0),(259970,7222,'ba','Tidak ada laporan',0),(259971,7222,'nl','Geen verslag',0),(259972,7222,'fi','Raporttia',0),(259973,7222,'no','Ingen rapport',0),(259974,7222,'da','Ingen rapport',0),(259975,7222,'ko','ë³´ê³ ì„œ',0),(259976,7222,'he','××™×Ÿ ×“×•×—',0),(259977,7222,'el','ÎšÎ±Î¼Î¯Î± Î­ÎºÎ¸ÎµÏƒÎ·',0),(259978,7222,'zh','æ— æŠ¥å‘Š',0),(259979,7222,'sv','Ingen rapport',0),(259980,7222,'it','Nessuna relazione',0),(259981,7222,'tl','',0),(259982,7222,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(259983,7222,'hi','à¤•à¥‹à¤ˆ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(259984,7222,'ms','Tiada laporan',0),(259985,7222,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªÙ‚Ø±ÙŠØ±',0),(259986,7222,'fr','Aucun rapport',0),(259987,7222,'jp','ã„ã„ãˆãƒ¬ãƒãƒ¼ãƒˆ',0),(259988,7222,'pt','Nenhum relatÃ³rio',0),(259989,7222,'ru','ÐžÑ‚Ñ‡ÐµÑ‚Ð° ÐÐµÑ‚',0),(259990,7222,'es','No hay Informe',0),(259991,7222,'de','Kein Bericht',0),(259992,7222,'en','No Report',0),(259993,7223,'is','',0),(259994,7223,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ†  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª  Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(259995,7223,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ†  Ù„ÙŠØ³Øª Ù‚ÙŠÙ…Øª  Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(259996,7223,'tr','B2B sitesi sipariÅŸlerinde fiyat listesi YazdÄ±r izin ver',0),(259997,7223,'pl','PozwalajÄ… Cennik druku zamÃ³wienia na stronie B2B',0),(259998,7223,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ñ†ÐµÐ½Ð¾Ñ€Ð°Ð·Ð¿Ð¸Ñ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð° B2B ÑÐ°Ð¹Ñ‚',0),(259999,7223,'ur','B2B ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ù¾Ø± Ù¾Ø±Ø§Ú©Ø§Ù„Ø§Ø³Ù¹ Ù¾Ø±Ù†Ù¹ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(260000,7223,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð¦Ñ˜ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÐŸÑ€Ð¸Ð½Ñ‚ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð‘2Ð‘',0),(260001,7223,'vi','Cho PhÃ©p Báº£ng GiÃ¡ ÄÆ¡n Äáº·t HÃ ng In TrÃªn Trang B2B',0),(260002,7223,'af','Laat toe om Pryslys Bestellings uit te druk op die B2B Perseel',0),(260003,7223,'ro','Permite comenzi de imprimare listÄƒ de preÅ£uri pe site-ul B2B',0),(260004,7223,'et','Luba hinnakiri Prindi tellimuste B2B kohapeal',0),(260005,7223,'si','OmogoÄajo cenik tiskanja naroÄil na B2B strani',0),(260006,7223,'ba','Mengijinkan Pencetakan Daftar Harga Pesanan pada situs B2B',0),(260007,7223,'nl','Prijslijst afdrukken bestellingen op B2B Site toestaan',0),(260008,7223,'fi','Salli hinnasto tulosta tilaukset B2B pÃ¤Ã¤llÃ¤',0),(260009,7223,'no','Tillate prisliste ut bestillinger pÃ¥ B2B webomrÃ¥de',0),(260010,7223,'da','Tillad prisliste Print ordrer pÃ¥ B2B Site',0),(260011,7223,'ko','B2B ì‚¬ì´íŠ¸ì— PriceList ì¸ì‡„ ì£¼ë¬¸ í—ˆìš©',0),(260012,7223,'he','×œ××¤×©×¨ ×”×“×¤×¡×” ×ž×—×™×¨×•×Ÿ ×”×–×ž× ×•×ª ×‘××ª×¨ B2B',0),(260013,7223,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€ÎµÎ¹ Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÏƒÏ„Î¿ Ï‡ÏŽÏÎ¿ Ï„Î¿Ï… B2B',0),(260014,7223,'zh','å…è®¸åœ¨ä¼ä¸šå¯¹ä¼ä¸šç«™ç‚¹ä»·æ ¼è¡¨æ‰“å°è®¢å•\r\n',0),(260015,7223,'sv','TillÃ¥ta prislista Print order pÃ¥ B2B webbplats',0),(260016,7223,'it','Consentire gli ordini di stampa Listino prezzi sul sito B2B',0),(260017,7223,'tl','',0),(260018,7223,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591; B2B',0),(260019,7223,'hi','Pricelist à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ B2B à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤° à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(260020,7223,'ms','Membenarkan pesanan cetakan senarai lokasi B2B',0),(260021,7223,'ar','ØªØ³Ù…Ø­ Ø£ÙˆØ§Ù…Ø± Ø·Ø¨Ø§Ø¹Ø© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¹Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ B2B',0),(260022,7223,'fr','Permet d\'imprimer la liste de prix des ordres sur le Site B2B',0),(260023,7223,'jp','B2B ã‚µã‚¤ãƒˆä¸Šã®ä¾¡æ ¼è¡¨ãƒ—ãƒªãƒ³ãƒˆã®æ³¨æ–‡ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(260024,7223,'pt','Permite imprimir lista de preÃ§os pedidos B2B site',0),(260025,7223,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð° ÑÐ°Ð¹Ñ‚Ðµ B2B',0),(260026,7223,'es','Permitir Ordenes de ImpresiÃ³n de  Lista de Precios en Sitio de B2B',0),(260027,7223,'de','Preisliste drucken AuftrÃ¤ge auf B2B-Website zu ermÃ¶glichen',0),(260028,7223,'en','Allow PriceList Print Orders on B2B Site',0),(260029,7224,'is','',0),(260030,7224,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(260031,7224,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(260032,7224,'tr','B2B sitesi Ã¼zerinde sipariÅŸ YazdÄ±r izin ver',0),(260033,7224,'pl','UmoÅ¼liwia druk zamÃ³wienia na stronie B2B',0),(260034,7224,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»ÑÐ²Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð° B2B ÑÐ°Ð¹Ñ‚',0),(260035,7224,'ur','B2B Ø³Ø§Ø¦Ù¹ Ù¾Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø­Ú©Ù… Ø¯ÛŒÚº',0),(260036,7224,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð‘2Ð‘',0),(260037,7224,'vi','Cho PhÃ©p ÄÆ¡n Äáº·t HÃ ng In TrÃªn Trang B2B',0),(260038,7224,'af','Laat toe om Bestellings uit te druk op B2B Perseel',0),(260039,7224,'ro','Permite comenzi imprimare pe site-ul B2B',0),(260040,7224,'et','Luba trÃ¼kitÃ¶Ã¶de tellimused B2B kohapeal',0),(260041,7224,'si','OmogoÄajo tiskanje nalogov na B2B strani',0),(260042,7224,'ba','Mengijinkan Pencetakan Pesanan pada situs B2B',0),(260043,7224,'nl','Afdrukken bestellingen op B2B Site toestaan',0),(260044,7224,'fi','Salli tulosta tilaukset B2B pÃ¤Ã¤llÃ¤',0),(260045,7224,'no','Tillat bestilling pÃ¥ B2B nettsted',0),(260046,7224,'da','Tillad aftryksbestillinger pÃ¥ B2B Site',0),(260047,7224,'ko','B2B ì‚¬ì´íŠ¸ì— ì¸ì‡„ ì£¼ë¬¸ í—ˆìš©',0),(260048,7224,'he','×œ××¤×©×¨ ×”×“×¤×¡×•×ª ×‘××ª×¨ B2B',0),(260049,7224,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î¹Ï‚ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½ ÏƒÏ„Î¿ Ï‡ÏŽÏÎ¿ Ï„Î¿Ï… B2B',0),(260050,7224,'zh','å…è®¸åœ¨ä¼ä¸šå¯¹ä¼ä¸šç«™ç‚¹æ‰“å°è®¢å•\r\n',0),(260051,7224,'sv','TillÃ¥t utskrift order pÃ¥ B2B webbplats',0),(260052,7224,'it','Consentire la stampa ordini sul sito B2B',0),(260053,7224,'tl','',0),(260054,7224,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591; B2B',0),(260055,7224,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ B2B à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤° à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(260056,7224,'ms','Membenarkan pesanan cetakan di lokasi B2B',0),(260057,7224,'ar','ØªØ³Ù…Ø­ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø¹Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ B2B',0),(260058,7224,'fr','Permettre l\'impression des commandes sur le Site B2B',0),(260059,7224,'jp','B2B ã‚µã‚¤ãƒˆã®ãƒ—ãƒªãƒ³ãƒˆã®æ³¨æ–‡ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(260060,7224,'pt','Permitem imprimir ordens no Site B2B',0),(260061,7224,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð° ÑÐ°Ð¹Ñ‚Ðµ B2B',0),(260062,7224,'es','Permitir Ordenes de ImpresiÃ³n en Sitios de N2N',0),(260063,7224,'de','KÃ¶nnen Sie DruckauftrÃ¤ge auf B2B-Website',0),(260064,7224,'en','Allow Print Orders on B2B Site',0),(260065,7225,'is','',0),(260066,7225,'dr','/ Ø¢Ù¾Ø¯ÛŒØª    Ú¯Ø±ÙˆÙ‡ Ù…ØµØ±Ù ( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260067,7225,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ   Ú¯Ø±ÙˆÙ‡ Ù…ØµØ±Ù ( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260068,7225,'tr','KDV vergisi gruplarÄ± ekleyin/gÃ¼ncelleyin',0),(260069,7225,'pl','Podatek VAT grupy dodaÄ‡ aktualizacji',0),(260070,7225,'bg','Ð”Ð”Ð¡ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(260071,7225,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ VAT Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÙ¾',0),(260072,7225,'sr','ÐŸÐ”Ð’ Ð³Ñ€ÑƒÐ¿Ð¸ÑˆÐµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(260073,7225,'vi','ThÃªm/Cáº­p Nháº­t NhÃ³m Thuáº¿ VAT',0),(260074,7225,'af','BTW belasting groepe byvoeg/opdatering',0),(260075,7225,'ro','TVA grupuri AdÄƒugaÅ£i/actualizaÅ£i',0),(260076,7225,'et','KÃ¤ibemaksu Tax Groups lisamine/uuendamine',0),(260077,7225,'si','DDV davka zdruÅ¾i Dodaj/posodobi',0),(260078,7225,'ba','PPN kelompok menambahkan Update',0),(260079,7225,'nl','BTW-heffing groepen toevoegen/bijwerken',0),(260080,7225,'fi','ALV Tax Groups lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(260081,7225,'no','Mva grupper Legg til/Oppdater',0),(260082,7225,'da','MOMS Tax Groups TilfÃ¸j/opdater',0),(260083,7225,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸ ì„¸ê¸ˆ ê·¸ë£¹ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(260084,7225,'he','×”×•×¡×£/×¢×“×›×Ÿ ×§×‘×•×¦×•×ª ×ž×¢',0),(260085,7225,'el','Î¦Î Î‘ Î¿Î¼Î¬Î´ÎµÏ‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(260086,7225,'zh','å¢žå€¼ç¨Žæ¶ˆè´¹ç¨Žç»„æ–°å¢ž/æ›´æ–°\r\n',0),(260087,7225,'sv','LÃ¤gg till/uppdatera momsgrupper fÃ¶r moms',0),(260088,7225,'it','IVA gruppi aggiungere/aggiornare',0),(260089,7225,'tl','',0),(260090,7225,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3585;&#3621;&#3640;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(260091,7225,'hi','à¤µà¥ˆà¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(260092,7225,'ms','Kumpulan-Kumpulan Komando cukai Tambah/Kemaskini',0),(260093,7225,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ© Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(260094,7225,'fr','Ajouter/mettre Ã  jour les groupes TVA taxe',0),(260095,7225,'jp','ä»˜åŠ ä¾¡å€¤ç¨Žã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ /æ›´æ–°',0),(260096,7225,'pt','IVA grupos adicionar/atualizar',0),(260097,7225,'ru','ÐÐ”Ð¡ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(260098,7225,'es','Grupos de Impuesto de Consumo IVA Agregar/Actualizar',0),(260099,7225,'de','MwSt. Gruppen hinzufÃ¼gen/aktualisieren',0),(260100,7225,'en','VAT Tax Groups Add/Update',0),(260101,7226,'is','',0),(260102,7226,'dr','( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260103,7226,'pr','Ø§ÙØ²ÙˆØ¯Ù†  Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…ØµØ±Ù ( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260104,7226,'tr','KDV vergisi gruplarÄ± Ekle',0),(260105,7226,'pl','DodaÄ‡ grupy podatku VAT',0),(260106,7226,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð”Ð”Ð¡ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸',0),(260107,7226,'ur','ÙˆØ§Ù¹ Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÛÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(260108,7226,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ð° ÐŸÐ”Ð’-Ð°',0),(260109,7226,'vi','ThÃªm NhÃ³m thuáº¿ VAT',0),(260110,7226,'af','Voeg BTW belasting groepe',0),(260111,7226,'ro','Adauga TVA grupuri',0),(260112,7226,'et','KÃ¤ibemaks rÃ¼hmade lisamine',0),(260113,7226,'si','Dodaj DDV davÄnih skupin',0),(260114,7226,'ba','Tambahkan kelompok PPN',0),(260115,7226,'nl','BTW-groepen toevoegen',0),(260116,7226,'fi','ALV-ryhmien lisÃ¤Ã¤minen',0),(260117,7226,'no','Mva-grupper legge',0),(260118,7226,'da','Moms grupper tilfÃ¸je',0),(260119,7226,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸ ì„¸ê¸ˆ ê·¸ë£¹ ì¶”ê°€',0),(260120,7226,'he','×”×•×¡×¤×ª ×§×‘×•×¦×•×ª ×ž×¢',0),(260121,7226,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¦Î Î‘ Î¿Î¼Î¬Î´ÎµÏ‚',0),(260122,7226,'zh','å¢žåŠ å¢žå€¼ç¨Žæ¶ˆè´¹ç¨Žç»„ï¼Œ\r\n',0),(260123,7226,'sv','Moms grupper lÃ¤gga till',0),(260124,7226,'it','Aggiungi gruppi IVA',0),(260125,7226,'tl','',0),(260126,7226,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3621;&#3640;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3648;&#3614;&#3636;&#3656;&#3617;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3650;&#3616;&#3',0),(260127,7226,'hi','à¤µà¥ˆà¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¤®à¥‚à¤¹ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(260128,7226,'ms','Tambah Kumpulan Komando cukai',0),(260129,7226,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©',0),(260130,7226,'fr','Ajouter des groupes de taxe TVA',0),(260131,7226,'jp','ä»˜åŠ ä¾¡å€¤ç¨Žã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(260132,7226,'pt','Adicionar grupos de IVA',0),(260133,7226,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ”Ð¡ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(260134,7226,'es','Agregar Grupos de Impuesto de Consumo IVA',0),(260135,7226,'de','MwSt-Gruppen hinzufÃ¼gen',0),(260136,7226,'en','VAT Tax Groups Add',0),(260137,7227,'is','',0),(260138,7227,'dr','( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260139,7227,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…ØµØ±Ù ( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260140,7227,'tr','KDV vergisi gruplarÄ±',0),(260141,7227,'pl','Grup podatkowych VAT',0),(260142,7227,'bg','Ð”Ð”Ð¡ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸',0),(260143,7227,'ur','ÙˆØ§Ù¹ Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÙ¾',0),(260144,7227,'sr','ÐŸÐ”Ð’ Ð¿Ð¾Ñ€ÐµÑÐºÐµ Ð³Ñ€ÑƒÐ¿Ðµ',0),(260145,7227,'vi','NhÃ³m thuáº¿ VAT',0),(260146,7227,'af','BTW belasting groepe',0),(260147,7227,'ro','Grupurile de TVA',0),(260148,7227,'et','KÃ¤ibemaksu maksugruppe',0),(260149,7227,'si','DDV davÄnih skupin',0),(260150,7227,'ba','Kelompok-kelompok PPN',0),(260151,7227,'nl','BTW-groepen',0),(260152,7227,'fi','Alv-ryhmÃ¤t',0),(260153,7227,'no','Mva-grupper',0),(260154,7227,'da','Moms grupper',0),(260155,7227,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸ ì„¸ê¸ˆ ê·¸ë£¹',0),(260156,7227,'he','×§×‘×•×¦×•×ª ×ž×¢',0),(260157,7227,'el','ÎŸÎ¼Î¬Î´ÎµÏ‚ Î¦Î Î‘',0),(260158,7227,'zh','å¢žå€¼ç¨Žæ¶ˆè´¹ç¨Žç»„\r\n',0),(260159,7227,'sv','Moms grupper',0),(260160,7227,'it','Gruppi IVA',0),(260161,7227,'tl','',0),(260162,7227,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3648;&#3614;&#3636;&#3656;&#3617;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3650;&#3616;&#3588;',0),(260163,7227,'hi','à¤µà¥ˆà¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚',0),(260164,7227,'ms','Kumpulan Komando cukai',0),(260165,7227,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©',0),(260166,7227,'fr','Groupes de taxe TVA',0),(260167,7227,'jp','ä»˜åŠ ä¾¡å€¤ç¨Žã‚°ãƒ«ãƒ¼ãƒ—',0),(260168,7227,'pt','Grupos de IVA',0),(260169,7227,'ru','ÐÐ”Ð¡ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(260170,7227,'es','Grupos de Impuesto de Consumo IVA',0),(260171,7227,'de','MwSt-Gruppen',0),(260172,7227,'en','VAT Tax Groups',0),(260173,7228,'is','',0),(260174,7228,'dr','( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260175,7228,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ   Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…ØµØ±Ù ( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260176,7228,'tr','GÃ¼ncelleÅŸtirme KDV vergisi gruplarÄ±',0),(260177,7228,'pl','Podatek VAT grupy aktualizacji',0),(260178,7228,'bg','Ð”Ð”Ð¡ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(260179,7228,'ur','Ø§Ù¾ ÚˆÛŒÙ¹ VAT Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÙ¾',0),(260180,7228,'sr','ÐŸÐ”Ð’ Ð³Ñ€ÑƒÐ¿Ð¸ÑˆÐµ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(260181,7228,'vi','Cáº­p Nháº­t NhÃ³m Thuáº¿ VAT',0),(260182,7228,'af','BTW belasting groepe bywerking',0),(260183,7228,'ro','TVA grupuri Update',0),(260184,7228,'et','KÃ¤ibemaksu Tax Groups Update',0),(260185,7228,'si','DDV davka zdruÅ¾i posodobitev',0),(260186,7228,'ba','PPN kelompok Update',0),(260187,7228,'nl','BTW-heffing groepen Update',0),(260188,7228,'fi','ALV Tax Groups pÃ¤ivitys',0),(260189,7228,'no','Mva grupper oppdatering',0),(260190,7228,'da','MOMS Tax Groups opdatering',0),(260191,7228,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸ ì„¸ê¸ˆ ê·¸ë£¹ ì—…ë°ì´íŠ¸',0),(260192,7228,'he','×ž×¢ ×§×‘×•×¦×•×ª ×¢×“×›×•×Ÿ',0),(260193,7228,'el','Î¦Î Î‘ Î¿Î¼Î¬Î´ÎµÏ‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(260194,7228,'zh','å¢žå€¼ç¨Žæ¶ˆè´¹ç¨Žç»„æ›´æ–°\r\n',0),(260195,7228,'sv','Moms grupper uppdatering',0),(260196,7228,'it','IVA gruppi aggiornamento',0),(260197,7228,'tl','',0),(260198,7228,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3648;&#3614;&#3636;&#3656;&#3617;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3610;&#3619;&#3',0),(260199,7228,'hi','à¤µà¥ˆà¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(260200,7228,'ms','Kumpulan-Kumpulan Komando cukai Kemaskini',0),(260201,7228,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ© Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(260202,7228,'fr','Mise Ã  jour des groupes TVA taxe',0),(260203,7228,'jp','ä»˜åŠ ä¾¡å€¤ç¨Žã‚°ãƒ«ãƒ¼ãƒ—ã®æ›´æ–°',0),(260204,7228,'pt','IVA grupos atualizaÃ§Ã£o',0),(260205,7228,'ru','ÐÐ”Ð¡ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(260206,7228,'es','Actualizar Grupos de Impuesto de Consumo IVA',0),(260207,7228,'de','MwSt-Gruppen-Update',0),(260208,7228,'en','VAT Tax Groups Update',0),(260209,7229,'is','',0),(260210,7229,'dr','2 = Ø«Ø¨Øª Ù†Ø§Ù…   - Ø¬Ù‡Øª  2 ÙÙ‚Ø· ÙˆÙ‚ØªÙŠ Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ø¯Ø± Ø¬Ù‡Øª  2 Ø§Ø³Øª ',0),(260211,7229,'pr','Ø¬Ù‡Øª  2 = Ø«Ø¨Øª Ù†Ø§Ù…   - Ø¬Ù‡Øª  2 ÙÙ‚Ø· ÙˆÙ‚ØªÙŠ Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ø¯Ø± Ø¬Ù‡Øª  2 Ø§Ø³Øª ',0),(260212,7229,'tr','2 Side sÄ±kÄ± kayÄ±t; = Yan yan 2\'de 2 yalnÄ±zca birden fazla mÃ¼rekkep',0),(260213,7229,'pl','Strony 2 = mocno rejestracji; Strona 2 tylko wtedy, gdy wiÄ™cej niÅ¼ jeden atramentu na stronie 2',0),(260214,7229,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð° 2 = Ð·Ð´Ñ€Ð°Ð²Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ; Ð¡Ñ‚Ñ€Ð°Ð½Ð° 2 ÑÐ°Ð¼Ð¾ ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð¸Ð½ Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð° 2',0),(260215,7229,'ur','Ø·Ø±Ù 2 = ØªÙ†Ú¯ Ø±Ø¬Ø³Ù¹Ø±ÛŒØ´Ù† Û” ØµØ±Ù Ø§ÛŒÚ© Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø§Ù†Ú© Ø¬Ø¨ Ø·Ø±Ù 2 Ù¾Ø± 2 Ú©ÛŒ Ø·Ø±Ù',0),(260216,7229,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð° 2 = ÑƒÑÐºÐ¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ðµ; Ð¡Ñ‚Ñ€Ð°Ð½Ð° 2 ÑÐ°Ð¼Ð¾ ÐºÐ°Ð´Ð° Ñ˜Ðµ Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ñ˜ÐµÐ´Ð°Ð½ Ð·Ð°Ð¿Ð¸Ñ Ð¾Ð»Ð¾Ð²ÐºÐ¾Ð¼ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ñƒ 2',0),(260217,7229,'vi','Máº·t 2=Ä‘Äƒng kÃ½ cháº·t; Máº·t 2 chá»‰ khi cÃ³ hÆ¡n 1 loáº¡i má»±c trÃªn máº·t 2',0),(260218,7229,'af','Kant 2 = stywe registrasie; Kant 2 slegs wanneer meer as een ink op kant 2',0),(260219,7229,'ro','Partea 2 = inregistrare strÃ¢mt; Partea 2 numai Ã®n cazul Ã®n care mai multe de cernealÄƒ pe partea 2',0),(260220,7229,'et','Pool 2 = tihe registreerimine; Pool 2 ainult siis, kui rohkem kui Ã¼he tindi lk 2',0),(260221,7229,'si','Stran 2 = tesen registracije; Stran 2 samo, ko veÄ kot eno Ärnilo na strani 2',0),(260222,7229,'ba','Sisi 2 = ketat pendaftaran; Sisi 2 hanya ketika lebih dari satu tinta pada sisi 2',0),(260223,7229,'nl','Bladzijde 2 = strakke registratie; Bladzijde 2 alleen wanneer meer dan Ã©Ã©n inkt op bladzijde 2',0),(260224,7229,'fi','Side 2 = tiukka rekisterÃ¶inti; 2 vain, kun useampi kuin yksi muste on puoli 2-puoli',0),(260225,7229,'no','Side 2 = stramme registrering; Side 2 bare nÃ¥r flere blekk pÃ¥ Side 2',0),(260226,7229,'da','Side 2 = stramme registrering; Side 2 kun, nÃ¥r mere end Ã©n trykfarve pÃ¥ Side 2',0),(260227,7229,'ko','ì¸¡ë©´ 2 = ê½‰ ë“±ë¡; ì¸¡ë©´ 2 2 ë©´ì— ìž‰í¬ í•˜ë‚˜ ì´ìƒì˜ ê²½ìš°ì—',0),(260228,7229,'he','×¦×“ 2 = ×¨×™×©×•× ×—×–×§; ×¦×“ 2 ×¨×§ ×›××©×¨ ×™×•×ª×¨ ×ž×¤×¢× ××—×ª ×“×™×• ×¢×œ ×¦×“ 2',0),(260229,7229,'el','Î Î»ÎµÏ…ÏÎ¬ 2 = ÏƒÏ†Î¹Ï‡Ï„ÏŒ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ¹ÏƒÎ·Ï‚Â· Î Î»ÎµÏ…ÏÎ¬ 2 Î¼ÏŒÎ½Î¿ ÏŒÏ„Î±Î½ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ± Î±Ï€ÏŒ Î­Î½Î± Î¼ÎµÎ»Î¬Î½Î¹ ÏƒÏ„Î·Î½ Ï€Î»ÎµÏ…ÏÎ¬ 2',0),(260230,7229,'zh','ä¾§2 =ç´§ç™»è®°;åªæœ‰å½“ä¾§2æœ‰å¤šäºŽä¸€ç§å¢¨æ°´\r\n',0),(260231,7229,'sv','Sidan 2 = snÃ¤va registrering. Sida 2 bara nÃ¤r mer Ã¤n en tryckfÃ¤rg pÃ¥ sida 2',0),(260232,7229,'it','Lato 2 = registrazione stretto; Lato 2 solo quando piÃ¹ di uno di inchiostro sul lato 2',0),(260233,7229,'tl','',0),(260234,7229,'th','Side 2=Tight Registration; Side 2 only when more than one ink on Side 2',0),(260235,7229,'hi','à¤•à¤¿à¤¨à¤¾à¤°à¤¾ 2 = à¤¤à¤‚à¤— à¤ªà¤‚à¤œà¥€à¤•à¤°à¤£; à¤“à¤° à¤œà¤¬ à¤•à¥‡à¤µà¤² à¤à¤• à¤…à¤§à¤¿à¤• à¤‡à¤‚à¤• à¤ªà¤° à¤¸à¤¾à¤‡à¤¡ 2 2',0),(260236,7229,'ms','Bahagian 2 = ketat pendaftaran; Bahagian 2 hanya apabila lebih daripada satu dakwat pada bahagian 2',0),(260237,7229,'ar','Ø§Ù„Ø¬Ø§Ù†Ø¨ 2 = Ø¶ÙŠÙ‚ Ø§Ù„ØªØ³Ø¬ÙŠÙ„Ø› Ø§Ù„Ø¬Ø§Ù†Ø¨ 2 ÙÙ‚Ø· Ø¹Ù†Ø¯Ù…Ø§ Ø£ÙƒØ«Ø± Ù…Ù† ÙˆØ§Ø­Ø¯Ø© Ø¨Ø§Ù„Ø­Ø¨Ø± Ø¹Ù„Ù‰ Ø§Ù„Ø¬Ø§Ù†Ø¨ 2',0),(260238,7229,'fr','CÃ´tÃ© 2 = enregistrement serrÃ© ; CÃ´tÃ© 2 uniquement lorsque plus d\'une encre sur cÃ´tÃ© 2',0),(260239,7229,'jp','ã‚µã‚¤ãƒ‰ 2 = ã‚¿ã‚¤ãƒˆã®ç™»éŒ²;å´ 2 å´ 2 ã‚¤ãƒ³ã‚¯ 1 ã¤ä»¥ä¸Šå ´åˆã«ã®ã¿',0),(260240,7229,'pt','Lado 2 = registo apertado; Lado 2 somente quando mais de uma tinta no lado 2',0),(260241,7229,'ru','Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð° 2 = Ð¶ÐµÑÑ‚ÐºÐ¾Ð¹ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸; Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð° 2 Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ‚Ð¾Ð³Ð´Ð°, ÐºÐ¾Ð³Ð´Ð° Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ð¾Ð´Ð¸Ð½ Ñ‡ÐµÑ€Ð½Ð¸Ð»Ð° Ð½Ð° ÑÑ‚Ð¾Ñ€Ð¾Ð½Ðµ 2',0),(260242,7229,'es','Lado 2=RegistraciÃ³n Apretada; Lado 2 solo cuando mÃ¡s que una tinta en Lado 2',0),(260243,7229,'de','Seite 2 = enge Registrierung; Seite 2 nur dann, wenn mehrere Tusche auf Seite 2',0),(260244,7229,'en','Side 2=Tight Registration; Side 2 only when more than one ink on Side 2',0),(260245,7230,'is','',0),(260246,7230,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ',0),(260247,7230,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ',0),(260248,7230,'tr','Ek vergi',0),(260249,7230,'pl','Dodatkowe zobowiÄ…zanie podatkowe',0),(260250,7230,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº',0),(260251,7230,'ur','Ø§Ø¶Ø§ÙÛŒ Ù¹ÛŒÚ©Ø³',0),(260252,7230,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(260253,7230,'vi','Thuáº¿ Cá»™ng ThÃªm',0),(260254,7230,'af','Addisionele Belasting',0),(260255,7230,'ro','Taxa aditionala',0),(260256,7230,'et','Lisamaks',0),(260257,7230,'si','Dodatni davek',0),(260258,7230,'ba','Pajak Tambahan',0),(260259,7230,'nl','Extra belasting',0),(260260,7230,'fi','LisÃ¤vero',0),(260261,7230,'no','Tilleggsavgift',0),(260262,7230,'da','Ekstra skat',0),(260263,7230,'ko','ì¶”ê°€ ì„¸ê¸ˆ',0),(260264,7230,'he','×ž×¡ × ×•×¡×£',0),(260265,7230,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î¿Ï‚ Ï†ÏŒÏÎ¿Ï‚',0),(260266,7230,'zh','é™„åŠ ç¨Ž\r\n',0),(260267,7230,'sv','Extra skatt',0),(260268,7230,'it','Tassa addizionale',0),(260269,7230,'tl','',0),(260270,7230,'th','&#3616;&#3634;&#3625;&#3637;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(260271,7230,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤•à¤°',0),(260272,7230,'ms','Cukai tambahan',0),(260273,7230,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø¥Ø¶Ø§ÙÙŠØ©',0),(260274,7230,'fr','Taxe SupplÃ©mentaire',0),(260275,7230,'jp','ä»˜åŠ ç¨Ž',0),(260276,7230,'pt','Imposto adicional',0),(260277,7230,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÐÐ°Ð»Ð¾Ð³',0),(260278,7230,'es','Impuesto Adicional',0),(260279,7230,'de','ZusÃ¤tzliche Steuer',0),(260280,7230,'en','Additional Tax',0),(260281,7231,'is','',0),(260282,7231,'dr','Ú¯Ø±ÙˆÙ‡ Ù…Ø§Ù„ÙŠØ§Øª ',0),(260283,7231,'pr','Ú¯Ø±ÙˆÙ‡ Ù…Ø§Ù„ÙŠØ§Øª ',0),(260284,7231,'tr','Vergi grubu',0),(260285,7231,'pl','Grupa podatkÃ³w',0),(260286,7231,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(260287,7231,'ur','Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÙ¾',0),(260288,7231,'sr','ÐŸÐ¾Ñ€ÐµÑÐºÐ° Ð³Ñ€ÑƒÐ¿Ð°',0),(260289,7231,'vi','NhÃ³m thuáº¿',0),(260290,7231,'af','Belastinggroepe',0),(260291,7231,'ro','Taxe',0),(260292,7231,'et','Maksugrupp',0),(260293,7231,'si','DavÄne skupine',0),(260294,7231,'ba','Kelompok pajak',0),(260295,7231,'nl','Tax Group',0),(260296,7231,'fi','Alv-ryhmÃ¤',0),(260297,7231,'no','Mva-gruppe',0),(260298,7231,'da','Momsgruppe',0),(260299,7231,'ko','ì„¸ê¸ˆ ê·¸ë£¹',0),(260300,7231,'he','×§×‘×•×¦×ª ×ž×¡',0),(260301,7231,'el','ÎŸÎ¼Î¬Î´Î±Ï‚ Ï†ÏŒÏÎ¿Ï…',0),(260302,7231,'zh','ç¨Žç»„\r\n',0),(260303,7231,'sv','Momsgrupp',0),(260304,7231,'it','Gruppo fiscale',0),(260305,7231,'tl','',0),(260306,7231,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;',0),(260307,7231,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¤®à¥‚à¤¹',0),(260308,7231,'ms','Cukai Kumpulan',0),(260309,7231,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©',0),(260310,7231,'fr','Groupe fiscal',0),(260311,7231,'jp','ç¨Žã‚°ãƒ«ãƒ¼ãƒ—',0),(260312,7231,'pt','Grupo de impostos sobre',0),(260313,7231,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° ÐÐ°Ð»Ð¾Ð³Ð¾Ð²',0),(260314,7231,'es','Grupo de Impuestos',0),(260315,7231,'de','Steuergruppe',0),(260316,7231,'en','Tax Group',0),(260317,7232,'is','',0),(260318,7232,'dr','( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260319,7232,'pr','Ù…ØµØ±Ù ( Ø³ÙˆØ®Øª ) Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260320,7232,'tr','KDV vergisi',0),(260321,7232,'pl','Podatek VAT',0),(260322,7232,'bg','Ð”Ð°Ð½ÑŠÐº Ð”Ð”Ð¡',0),(260323,7232,'ur','ÙˆØ§Ù¹ Ù¹ÛŒÚ©Ø³',0),(260324,7232,'sr','ÐŸÐ”Ð’ -Ð° Ð¿Ð¾Ñ€ÐµÐ·',0),(260325,7232,'vi','Thuáº¿ VAT',0),(260326,7232,'af','BTW belasting',0),(260327,7232,'ro','TVA',0),(260328,7232,'et','KÃ¤ibemaks',0),(260329,7232,'si','DDV davÄna',0),(260330,7232,'ba','PPN',0),(260331,7232,'nl','BTW',0),(260332,7232,'fi','ALV',0),(260333,7232,'no','Mva',0),(260334,7232,'da','Moms',0),(260335,7232,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸',0),(260336,7232,'he','×ž×¢',0),(260337,7232,'el','Î¦Î Î‘',0),(260338,7232,'zh','å¢žå€¼ç¨Žæ¶ˆè´¹\r\n',0),(260339,7232,'sv','Moms',0),(260340,7232,'it','IVA',0),(260341,7232,'tl','',0),(260342,7232,'th','&#3616;&#3634;&#3625;&#3637;&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3648;&#3614;&#3636;&#3656;&#3617;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3650;&#3616;&#3588;',0),(260343,7232,'hi','à¤µà¥ˆà¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(260344,7232,'ms','Cukai VAT',0),(260345,7232,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©',0),(260346,7232,'fr','Imposition de la TVA',0),(260347,7232,'jp','ä»˜åŠ ä¾¡å€¤ç¨Ž',0),(260348,7232,'pt','IVA',0),(260349,7232,'ru','ÐÐ°Ð»Ð¾Ð³ ÐÐ”Ð¡',0),(260350,7232,'es','Impuesto de Consumo IVA',0),(260351,7232,'de','MwSt.',0),(260352,7232,'en','VAT Tax',0),(260353,7233,'is','',0),(260354,7233,'dr','Ù…Ù†Ø·Ù‚Ù‡ ',0),(260355,7233,'pr','Ù…Ù†Ø·Ù‚Ù‡ ',0),(260356,7233,'tr','BÃ¶lge',0),(260357,7233,'pl','Dzielnicy',0),(260358,7233,'bg','ÐžÐºÑ€ÑŠÐ³',0),(260359,7233,'ur','Ø¶Ù„Ø¹',0),(260360,7233,'sr','ÐžÐºÑ€ÑƒÐ³',0),(260361,7233,'vi','Quáº­n/Huyá»‡n',0),(260362,7233,'af','Distrik',0),(260363,7233,'ro','Districtul',0),(260364,7233,'et','District',0),(260365,7233,'si','OkroÅ¾je',0),(260366,7233,'ba','Distrik',0),(260367,7233,'nl','District',0),(260368,7233,'fi','Alueella',0),(260369,7233,'no','Distriktet',0),(260370,7233,'da','Distrikt',0),(260371,7233,'ko','ì§€êµ¬',0),(260372,7233,'he','×ž×—×•×–',0),(260373,7233,'el','Î ÎµÏÎ¹Î¿Ï‡Î®',0),(260374,7233,'zh','åŒº\r\n',0),(260375,7233,'sv','Distriktet',0),(260376,7233,'it','Distretto',0),(260377,7233,'tl','',0),(260378,7233,'th','&#3605;&#3635;&#3610;&#3621;',0),(260379,7233,'hi','à¤œà¤¿à¤²à¤¾',0),(260380,7233,'ms','Daerah',0),(260381,7233,'ar','Ø­ÙŠ',0),(260382,7233,'fr','Quartier',0),(260383,7233,'jp','åœ°åŒº',0),(260384,7233,'pt','Distrito',0),(260385,7233,'ru','Ð Ð°Ð¹Ð¾Ð½',0),(260386,7233,'es','Distrito',0),(260387,7233,'de','Landkreis',0),(260388,7233,'en','District',0),(260389,7234,'is','',0),(260390,7234,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø®Ø§Ù„Øµ ',0),(260391,7234,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø®Ø§Ù„Øµ ',0),(260392,7234,'tr','NET vergi',0),(260393,7234,'pl','Netto podatku',0),(260394,7234,'bg','ÐÐµÑ‚Ð½Ð¸, Ð±ÐµÐ· Ð´Ð°Ð½ÑŠÐº',0),(260395,7234,'ur','Ø¬Ø§Ù„ Ù¹ÛŒÚ©Ø³',0),(260396,7234,'sr','ÐÐµÑ‚Ð¾ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(260397,7234,'vi','Thuáº¿ thuáº§n',0),(260398,7234,'af','Net Belasting',0),(260399,7234,'ro','Net fiscale',0),(260400,7234,'et','Net eelarvepoliitika',0),(260401,7234,'si','Neto davÄna',0),(260402,7234,'ba','Pajak',0),(260403,7234,'nl','Net belasting',0),(260404,7234,'fi','Nettotulojen',0),(260405,7234,'no','Netto mva',0),(260406,7234,'da','Netto skat',0),(260407,7234,'ko','ì¸í„°ë„· ì„¸ê¸ˆ',0),(260408,7234,'he','×ž×¡ × ×˜×•',0),(260409,7234,'el','ÎšÎ±Î¸Î±ÏÏŽÎ½ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½',0),(260410,7234,'zh','èµ‹ç¨Žå®žå¾å‡€é¢\r\n',0),(260411,7234,'sv','Net skatt',0),(260412,7234,'it','Fiscale netto',0),(260413,7234,'tl','',0),(260414,7234,'th','&#3616;&#3634;&#3625;&#3637;&#3626;&#3640;&#3607;&#3608;&#3636;',0),(260415,7234,'hi','à¤¨à¥‡à¤Ÿ à¤•à¤°',0),(260416,7234,'ms','Cukai bersih',0),(260417,7234,'ar','ØµØ§ÙÙŠ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(260418,7234,'fr','Taxe nette',0),(260419,7234,'jp','ç´”ç¨Ž',0),(260420,7234,'pt','Imposto lÃ­quido',0),(260421,7234,'ru','Ð§Ð¸ÑÑ‚Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(260422,7234,'es','Impuesto Neto',0),(260423,7234,'de','Netto',0),(260424,7234,'en','Net Tax',0),(260425,7235,'is','',0),(260426,7235,'dr','(Ù‡Ø²ÙŠÙ†Ù‡ Ø´Ø¯Ù‡ ',0),(260427,7235,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø®Ø±Ø¬ Ú¯Ø°Ø§Ø±Ù‰ Ø´Ø¯Ù‡ (Ù‡Ø²ÙŠÙ†Ù‡ Ø´Ø¯Ù‡ ',0),(260428,7235,'tr','Vergi tahsil',0),(260429,7235,'pl','Podatkiem naliczonym',0),(260430,7235,'bg','ÐÐ°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð´Ð°Ð½ÑŠÐº',0),(260431,7235,'ur','Ù¹ÛŒÚ©Ø³ ÙˆØµÙˆÙ„ Ú©ÛŒØ§',0),(260432,7235,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð°Ð¿Ð»Ð°Ñ›Ð¸Ð²Ð°Ð½Ð°',0),(260433,7235,'vi','TÃ­nh thuáº¿',0),(260434,7235,'af','Belasting gehef',0),(260435,7235,'ro','Impozitul perceput',0),(260436,7235,'et','Maks',0),(260437,7235,'si','Davek, ki',0),(260438,7235,'ba','Pajak yang dikenakan biaya',0),(260439,7235,'nl','Belasting betalen',0),(260440,7235,'fi','Vero',0),(260441,7235,'no','Skatten',0),(260442,7235,'da','Skat opkrÃ¦vet',0),(260443,7235,'ko','ì„¸ê¸ˆ ë¶€ê³¼',0),(260444,7235,'he','×ž×¡ ×˜×¢×•× ×”',0),(260445,7235,'el','Î¦ÏŒÏÎ¿ Ï€Î¿Ï… ÎµÏ€Î¹Î²Î¬Î»Î»ÎµÏ„Î±Î¹',0),(260446,7235,'zh','ç¨Žé¡¹\r\n',0),(260447,7235,'sv','Skatt tas ut',0),(260448,7235,'it','Imposta prelevata',0),(260449,7235,'tl','',0),(260450,7235,'th','&#3588;&#3656;&#3634;&#3616;&#3634;&#3625;&#3637;',0),(260451,7235,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¤¾ à¤†à¤°à¥‹à¤ª',0),(260452,7235,'ms','Cukai yang dikenakan',0),(260453,7235,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…ÙƒÙ„Ù',0),(260454,7235,'fr','ImpÃ´t Ã©tabli',0),(260455,7235,'jp','ç¨Žè«‹æ±‚',0),(260456,7235,'pt','Imposto cobrado',0),(260457,7235,'ru','ÐÐ°Ð»Ð¾Ð³ Ð²Ð·Ð¸Ð¼Ð°ÐµÑ‚ÑÑ',0),(260458,7235,'es','Impuesto Cargado',0),(260459,7235,'de','Steuer',0),(260460,7235,'en','Tax Charged',0),(260461,7236,'is','',0),(260462,7236,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯',0),(260463,7236,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯',0),(260464,7236,'tr','Ã–denen vergi',0),(260465,7236,'pl','Podatku od',0),(260466,7236,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸Ñ Ð´Ð°Ð½ÑŠÐº',0),(260467,7236,'ur','Ù¹ÛŒÚ©Ø³ Ø§Ø¯Ø§ Ú©ÛŒØ§',0),(260468,7236,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ð»Ð°Ñ‚Ðµ',0),(260469,7236,'vi','ÄÃ£ tráº£ thuáº¿',0),(260470,7236,'af','Belasting Betaal',0),(260471,7236,'ro','Impozitului plÄƒtit',0),(260472,7236,'et','Makstud maks',0),(260473,7236,'si','PlaÄanega davka',0),(260474,7236,'ba','Pajak dibayar',0),(260475,7236,'nl','Betaalde belastingen',0),(260476,7236,'fi','Maksetut verot',0),(260477,7236,'no','Skatt betalt',0),(260478,7236,'da','Betalt skat',0),(260479,7236,'ko','ì„¸ê¸ˆ ì§€ë¶ˆ',0),(260480,7236,'he','××™×¡×™×ž ×™×ª×ž×œ×™×©',0),(260481,7236,'el','Î¦ÏŒÏÎ¿Ï… Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î»Î®Î¸Î·ÎºÎµ',0),(260482,7236,'zh','ç¼´çº³çš„ç¨Žæ¬¾\r\n',0),(260483,7236,'sv','Skatt som betalas',0),(260484,7236,'it','Tassa pagata',0),(260485,7236,'tl','',0),(260486,7236,'th','&#3592;&#3656;&#3634;&#3618;&#3616;&#3634;&#3625;&#3637;',0),(260487,7236,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(260488,7236,'ms','Cukai dibayar',0),(260489,7236,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(260490,7236,'fr','Taxe payÃ©e',0),(260491,7236,'jp','æ”¯æ‰•ã‚ã‚ŒãŸç¨Ž',0),(260492,7236,'pt','Imposto pago',0),(260493,7236,'ru','ÐÐ°Ð»Ð¾Ð³',0),(260494,7236,'es','Impuesto Pagado',0),(260495,7236,'de','Versteuert',0),(260496,7236,'en','Tax Paid',0),(260497,7237,'is','',0),(260498,7237,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ Ø´Ø¯Ù‡',0),(260499,7237,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ Ø´Ø¯Ù‡',0),(260500,7237,'tr','Toplam Ã¼cret',0),(260501,7237,'pl','CaÅ‚kowita opÅ‚ata za',0),(260502,7237,'bg','ÐžÐ±Ñ‰Ð¾ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ñ‚',0),(260503,7237,'ur','Ú©Ù„ Ú©Ø§ Ø§Ù„Ø²Ø§Ù… Ù„Ú¯Ø§ÛŒØ§',0),(260504,7237,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¾Ð¿Ñ‚ÑƒÐ¶ÐµÐ½Ð¸Ñ…',0),(260505,7237,'vi','Tá»•ng cá»™ng phÃ­',0),(260506,7237,'af','Totaal gehef',0),(260507,7237,'ro','Total Ã®ncasat',0),(260508,7237,'et','Kokku tuleb maksta',0),(260509,7237,'si','Skupaj zaraÄunavajo',0),(260510,7237,'ba','Total biaya sebesar',0),(260511,7237,'nl','Totaal in rekening gebracht',0),(260512,7237,'fi','YhteensÃ¤ hintaan',0),(260513,7237,'no','Totalt belastet',0),(260514,7237,'da','Total opkrÃ¦vet',0),(260515,7237,'ko','ì´ ì²­êµ¬',0),(260516,7237,'he','×¡×” ×› ×˜×¢×•× ×”',0),(260517,7237,'el','Î£ÏÎ½Î¿Î»Î¿ Ï€Î¿Ï… Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹',0),(260518,7237,'zh','æ€»å…±æ”¶è´¹\r\n',0),(260519,7237,'sv','Totalt debiteras',0),(260520,7237,'it','Totale addebitato',0),(260521,7237,'tl','',0),(260522,7237,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;',0),(260523,7237,'hi','à¤•à¥à¤² à¤•à¤¾ à¤†à¤°à¥‹à¤ª',0),(260524,7237,'ms','Jumlah yang dikenakan',0),(260525,7237,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ù…ØªÙ‡Ù…ÙŠÙ†',0),(260526,7237,'fr','Total facturÃ©',0),(260527,7237,'jp','åˆè¨ˆè«‹æ±‚',0),(260528,7237,'pt','Total cobrado',0),(260529,7237,'ru','Ð’ÑÐµÐ³Ð¾ Ð²Ð·Ð¸Ð¼Ð°ÐµÑ‚ÑÑ',0),(260530,7237,'es','Total Cargado',0),(260531,7237,'de','Insgesamt berechnet',0),(260532,7237,'en','Total Charged',0),(260533,7238,'is','',0),(260534,7238,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙˆØ®Øª Ù…Ø§Ù„ÙŠØ§Øª  Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260535,7238,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙˆØ®Øª Ù…Ø§Ù„ÙŠØ§Øª  Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(260536,7238,'tr','KDV tÃ¼ketim vergisi raporu',0),(260537,7238,'pl','Raport podatku VAT zuÅ¼ycie',0),(260538,7238,'bg','Ð”Ð”Ð¡ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð»ÐµÐ½Ð¸Ðµ Ð´Ð°Ð½ÑŠÐº Ð´Ð¾ÐºÐ»Ð°Ð´',0),(260539,7238,'ur','ÙˆØ§Ù¹ Ú©ÛŒ Ú©Ú¾Ù¾Øª Ù¹ÛŒÚ©Ø³ Ø±Ù¾ÙˆØ±Ù¹',0),(260540,7238,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ð¾Ñ‚Ñ€Ð¾ÑˆÑšÑƒ ÐŸÐ”Ð’-Ð°',0),(260541,7238,'vi','BÃ¡o cÃ¡o VAT',0),(260542,7238,'af','BTW Verbruiksbelasting Verslag',0),(260543,7238,'ro','Fiscala TVA consumul',0),(260544,7238,'et','KÃ¤ibemaksu tarbimist kÃ¤ibemaksu aruanne',0),(260545,7238,'si','PoroÄilo davÄne porabe DDV',0),(260546,7238,'ba','Pelaporan pajak konsumsi PPN',0),(260547,7238,'nl','BTW-consumptie belasting verslag',0),(260548,7238,'fi','ALV kulutus arvonlisÃ¤veroa koskeva raportti',0),(260549,7238,'no','Mva-forbruk-rapporten',0),(260550,7238,'da','MOMS forbrug momsrapport',0),(260551,7238,'ko','ë¶€ê°€ê°€ì¹˜ì„¸ ì†Œë¹„ ì„¸ ë¦¬í¬íŠ¸',0),(260552,7238,'he','×“×•×— ×ž×¡ ×¦×¨×™×›×ª ×ž×¢ ×ž',0),(260553,7238,'el','Î¦Î Î‘ Î­ÎºÎ¸ÎµÏƒÎ· Ï†ÏŒÏÎ¿Ï… ÎºÎ±Ï„Î±Î½Î¬Î»Ï‰ÏƒÎ·Ï‚',0),(260554,7238,'zh','å¢žå€¼ç¨Žæ¶ˆè´¹ç¨Žçš„æŠ¥å‘Š\r\n',0),(260555,7238,'sv','Momsrapport konsumtion skatt',0),(260556,7238,'it','Report fiscali IVA consumo',0),(260557,7238,'tl','',0),(260558,7238,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; VAT &#3616;&#3634;&#3625;&#3637;&#3612;&#3641;&#3657;&#3610;&#3619;&#3636;&#3650;&#3616;&#3588;',0),(260559,7238,'hi','à¤µà¥ˆà¤Ÿ à¤•à¥€ à¤–à¤ªà¤¤ à¤•à¤° à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(260560,7238,'ms','Laporan cukai penggunaan VAT',0),(260561,7238,'ar','ØªÙ‚Ø±ÙŠØ± Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø§Ø³ØªÙ‡Ù„Ø§Ùƒ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©',0),(260562,7238,'fr','DÃ©claration de TVA consommation',0),(260563,7238,'jp','ä»˜åŠ ä¾¡å€¤ç¨Žæ¶ˆè²»ç¨Žãƒ¬ãƒãƒ¼ãƒˆ',0),(260564,7238,'pt','RelatÃ³rio de imposto de consumo de IVA',0),(260565,7238,'ru','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð»ÐµÐ½Ð¸Ðµ ÐÐ”Ð¡ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(260566,7238,'es','IVA Informe Impuestos sobre ConsunciÃ³n',0),(260567,7238,'de','MwSt. Verbrauch Steuer-Bericht',0),(260568,7238,'en','VAT Consumption Tax Report',0),(260569,7239,'is','',0),(260570,7239,'dr','(Ù†Ù…ÙˆÙ†Ù‡) Ø³Ø§Ø¯Ù‡',0),(260571,7239,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª (Ù†Ù…ÙˆÙ†Ù‡) Ø³Ø§Ø¯Ù‡',0),(260572,7239,'tr','Basit deyimi kullanÄ±n',0),(260573,7239,'pl','Prosta instrukcja uÅ¼ytkowania',0),(260574,7239,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð¿Ñ€Ð¾ÑÑ‚Ð° Ð´ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ',0),(260575,7239,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø¢Ø³Ø§Ù† Ø¨ÛŒØ§Ù†',0),(260576,7239,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚Ð°Ð²Ð½Ñƒ Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(260577,7239,'vi','Sá»­ dá»¥ng sao kÃª Ä‘Æ¡n giáº£n',0),(260578,7239,'af','Gebruik Eenvoudige Staat',0),(260579,7239,'ro','Utilizare simplÄƒ declaraÅ£ie',0),(260580,7239,'et','Kasuta lihtsat vÃ¤ljavÃµtet',0),(260581,7239,'si','Uporabite preprosto izjavo',0),(260582,7239,'ba','Menggunakan pernyataan sederhana',0),(260583,7239,'nl','Gebruik eenvoudige verklaring',0),(260584,7239,'fi','Yksinkertaisella lauseella',0),(260585,7239,'no','Bruk enkle utsagnet',0),(260586,7239,'da','Bruge Simple sÃ¦tning',0),(260587,7239,'ko','ê°„ë‹¨í•œ ë¬¸ì„ ì‚¬ìš© í•˜ ì—¬',0),(260588,7239,'he','×”×©×ª×ž×© ×‘×ž×©×¤×˜ ×¤×©×•×˜',0),(260589,7239,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Î±Ï€Î»Î® Î´Î®Î»Ï‰ÏƒÎ·',0),(260590,7239,'zh','ä½¿ç”¨ç®€å•çš„å£°æ˜Ž\r\n',0),(260591,7239,'sv','AnvÃ¤nda enkla uttryck',0),(260592,7239,'it','Uso semplice dichiarazione',0),(260593,7239,'tl','',0),(260594,7239,'th','&#3651;&#3594;&#3657;&#3585;&#3635;&#3627;&#3609;&#3604;&#3605;&#3619;&#3591;&#3654;',0),(260595,7239,'hi','à¤¸à¤¾à¤§à¤¾à¤°à¤£ à¤•à¤¥à¤¨ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(260596,7239,'ms','Gunakan penyata yang mudah',0),(260597,7239,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¹Ø¨Ø§Ø±Ø© Ø¨Ø³ÙŠØ·Ø©',0),(260598,7239,'fr','Utilisez une instruction Simple',0),(260599,7239,'jp','å˜ç´”ãªã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(260600,7239,'pt','Use a instruÃ§Ã£o simples',0),(260601,7239,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÐŸÑ€Ð¾ÑÑ‚ÑƒÑŽ Ð’Ñ‹Ð¿Ð¸ÑÐºÑƒ',0),(260602,7239,'es','Usar DeclaraciÃ³n Sencillo',0),(260603,7239,'de','Verwenden Sie einfache Anweisung',0),(260604,7239,'en','Use Simple Statement',0),(260605,7240,'is','',0),(260606,7240,'dr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ø´Ø±ÙˆØ¹ Ùˆ Ù¾Ø§ÙŠØ§Ù† Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(260607,7240,'pr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ø´Ø±ÙˆØ¹ Ùˆ Ù¾Ø§ÙŠØ§Ù† Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(260608,7240,'tr','Begin gÃ¶z ardÄ± eder ve son tarihleri',0),(260609,7240,'pl','Zignoruje rozpoczÄ™cia i daty zakoÅ„czenia',0),(260610,7240,'bg','Ð©Ðµ Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð¸ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð¸',0),(260611,7240,'ur','Ø¢ØºØ§Ø² Ù†Ø¸Ø±Ø§Ù†Ø¯Ø§Ø² Ú©Ø± Ø¯Û’ Ú¯Ø§ Ø§ÙˆØ± Ø¢Ø®Ø± Ù…ÛŒÚº ØªØ§Ø±ÛŒØ®ÛŒÚº',0),(260612,7240,'sr','Ð‹Ðµ Ð·Ð°Ð½ÐµÐ¼Ð°Ñ€Ð¸Ñ‚Ð¸ Ð‘ÐµÐ³Ð¸Ð½ Ð¸ Ð·Ð°Ð²Ñ€ÑˆÐ½Ðµ Ð´Ð°Ñ‚ÑƒÐ¼Ðµ',0),(260613,7240,'vi','Sáº½ bá» qua ngÃ y báº¯t Ä‘áº§u & káº¿t thÃºc',0),(260614,7240,'af','Sal Begin en End Datums Ignoreer',0),(260615,7240,'ro','Va ignora Ã®ncepe ÅŸi termina de dvs.',0),(260616,7240,'et','Eirab algus- ja lÃµppkuupÃ¤evi',0),(260617,7240,'si','Bo prezreti zaÄetni in konÄni datum',0),(260618,7240,'ba','Akan mengabaikan dimulai dan berakhir tanggal',0),(260619,7240,'nl','Zal negeren Begin- en einddatums',0),(260620,7240,'fi','Ohittaa aloitus- ja pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(260621,7240,'no','Ignorerer start- og sluttdatoer',0),(260622,7240,'da','Vil ignorere start- og slutdatoer',0),(260623,7240,'ko','ë¬´ì‹œ ì‹œìž‘ ë‚ ì§œì™€ ë ë‚ ì§œ',0),(260624,7240,'he','×™×ª×¢×œ× ×œ×”×ª×—×™×œ ×•×œ×¡×™×™× ×ª××¨×™×›×™×',0),(260625,7240,'el','Î˜Î± Î±Î³Î½Î¿Î®ÏƒÎµÎ¹ Î­Î½Î±ÏÎ¾Î·Ï‚ ÎºÎ±Î¹ Î»Î®Î¾Î·Ï‚',0),(260626,7240,'zh','å°†å¿½ç•¥å¼€å§‹å’Œç»“æŸæ—¥æœŸ\r\n',0),(260627,7240,'sv','Att ignorera Begin och slutdatum',0),(260628,7240,'it','IgnorerÃ  Begin e alla fine date',0),(260629,7240,'tl','',0),(260630,7240,'th','&#3592;&#3632;&#3621;&#3632;&#3607;&#3636;&#3657;&#3591;&#3623;&#3633;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3649;&#3621;&#3632;&#3623;&#3633;&#3609;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(260631,7240,'hi','à¤¶à¥à¤°à¥‚ à¤•à¥€ à¤…à¤¨à¤¦à¥‡à¤–à¥€ à¤•à¤°à¥‡à¤‚à¤—à¥‡ à¤”à¤° à¤…à¤‚à¤¤ à¤®à¥‡à¤‚ à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤',0),(260632,7240,'ms','Akan mengabaikan mulakan dan berakhir pada tarikh',0),(260633,7240,'ar','Ø³ÙŠØªÙ… ØªØ¬Ø§Ù‡Ù„ Ø§Ù„Ø¨Ø¯Ø¡ ÙˆØ§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØªÙˆØ§Ø±ÙŠØ®',0),(260634,7240,'fr','Ignorera Begin et fin de Dates',0),(260635,7240,'jp','é–‹å§‹ã¯ç„¡è¦–ã•ã‚Œã¾ã™ã¨çµ‚äº†æ—¥',0),(260636,7240,'pt','IrÃ¡ ignorar o inÃ­cio e fim datas',0),(260637,7240,'ru','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð”Ð°Ñ‚Ñ‹ ÐÐ°Ñ‡Ð°Ð»Ð° Ð¸ ÐšÐ¾Ð½Ñ†Ð°',0),(260638,7240,'es','Se IgnorarÃ¡ Fechas de Comienza y TerminaciÃ³n',0),(260639,7240,'de','Begin ignoriert und Enddatum',0),(260640,7240,'en','Will Ignore Begin and End Dates',0),(260641,7241,'is','',0),(260642,7241,'dr','ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± Ø­Ù…Ù„ ',0),(260643,7241,'pr','ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± Ø­Ù…Ù„ ',0),(260644,7241,'tr','Gemi fatura tarihi',0),(260645,7241,'pl','Data wysyÅ‚ki faktury',0),(260646,7241,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(260647,7241,'ur','Ø¬ÛØ§Ø² Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(260648,7241,'sr','Ð‘Ñ€Ð¾Ð´ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(260649,7241,'vi','NgÃ y chuyá»ƒn hÃ³a Ä‘Æ¡n',0),(260650,7241,'af','Versende Faktuurdatum',0),(260651,7241,'ro','Data de facturÄƒ navei',0),(260652,7241,'et','Laeva arve kuupÃ¤ev',0),(260653,7241,'si','Ladja datum raÄuna',0),(260654,7241,'ba','Tanggal faktur kapal',0),(260655,7241,'nl','Schip factuurdatum',0),(260656,7241,'fi','Aluksen laskutuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(260657,7241,'no','Faktura forsendelsesdato',0),(260658,7241,'da','Skibet fakturadatoen',0),(260659,7241,'ko','ë°°ì†¡ ì†¡ìž¥ ë‚ ì§œ',0),(260660,7241,'he','×ª××¨×™×š ×—×©×‘×•× ×™×ª ×”×¡×¤×™× ×”',0),(260661,7241,'el','Î—Î¼/Î½Î¯Î± Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Ï€Î»Î¿Î¯Î¿',0),(260662,7241,'zh','è¿é€å‘ç¥¨æ—¥æœŸ\r\n',0),(260663,7241,'sv','Fartyget fakturadatum',0),(260664,7241,'it','Nave data fattura',0),(260665,7241,'tl','',0),(260666,7241,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(260667,7241,'hi','à¤œà¤¹à¤¾à¤œ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(260668,7241,'ms','Tarikh invois kapal',0),(260669,7241,'ar','ØªØ§Ø±ÙŠØ® ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø´Ø­Ù†',0),(260670,7241,'fr','Date de facture d\'expÃ©dition',0),(260671,7241,'jp','è«‹æ±‚æ›¸ã®å‡ºè·æ—¥',0),(260672,7241,'pt','Data da factura de envio',0),(260673,7241,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(260674,7241,'es','Enviar Fecha de Factura',0),(260675,7241,'de','Rechnung Lieferdatum',0),(260676,7241,'en','Ship Invoice Date',0),(260677,7242,'is','',0),(260678,7242,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¬Ø²Ø§Ø¡',0),(260679,7242,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¬Ø²Ø§Ø¡',0),(260680,7242,'tr','BileÅŸen Ekle',0),(260681,7242,'pl','Dodaj skÅ‚adnik',0),(260682,7242,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚',0),(260683,7242,'ur','Ø¬Ø²Ùˆ ØªØ±Ú©ÛŒØ¨ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(260684,7242,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ñƒ',0),(260685,7242,'vi','ThÃªm ThÃ nh Pháº§n',0),(260686,7242,'af','Voeg \'n Komponent by',0),(260687,7242,'ro','Adauga o componenta',0),(260688,7242,'et','Lisa komponent',0),(260689,7242,'si','Dodajanje komponente',0),(260690,7242,'ba','Menambahkan komponen',0),(260691,7242,'nl','Een onderdeel toevoegen',0),(260692,7242,'fi','LisÃ¤Ã¤ osa',0),(260693,7242,'no','Legg til komponenten',0),(260694,7242,'da','TilfÃ¸j komponent',0),(260695,7242,'ko','êµ¬ì„± ìš”ì†Œ ì¶”ê°€',0),(260696,7242,'he','×”×•×¡×£ ×¨×›×™×‘',0),(260697,7242,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(260698,7242,'zh','å¢žåŠ ç»„ä»¶\r\n',0),(260699,7242,'sv','LÃ¤gga till komponenten',0),(260700,7242,'it','Aggiungere il componente',0),(260701,7242,'tl','',0),(260702,7242,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(260703,7242,'hi','à¤˜à¤Ÿà¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(260704,7242,'ms','Menambah komponen',0),(260705,7242,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù†ØµØ±',0),(260706,7242,'fr','Ajouter Composant',0),(260707,7242,'jp','ã‚³ãƒ³ãƒãƒ¼ãƒãƒ³ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(260708,7242,'pt','Adicionar o componente',0),(260709,7242,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÐ¾Ð½Ð¿Ð¾Ð½ÐµÐ½Ñ‚',0),(260710,7242,'es','Agregar Componente',0),(260711,7242,'de','Komponente hinzufÃ¼gen',0),(260712,7242,'en','Add Component',0),(260713,7243,'is','',0),(260714,7243,'dr','Ø¨Ø¹Ø¯ Ø§Ø² ',0),(260715,7243,'pr','Ø¨Ø¹Ø¯ Ø§Ø² ',0),(260716,7243,'tr','Sonra',0),(260717,7243,'pl','Po',0),(260718,7243,'bg','Ð¡Ð»ÐµÐ´',0),(260719,7243,'ur','Ú©Û’ Ø¨Ø¹Ø¯',0),(260720,7243,'sr','ÐÐ°ÐºÐ¾Ð½',0),(260721,7243,'vi','Sau',0),(260722,7243,'af','Na',0),(260723,7243,'ro','DupÄƒ',0),(260724,7243,'et','PÃ¤rast',0),(260725,7243,'si','Po',0),(260726,7243,'ba','Setelah',0),(260727,7243,'nl','Na',0),(260728,7243,'fi','JÃ¤lkeen',0),(260729,7243,'no','Etter',0),(260730,7243,'da','Efter',0),(260731,7243,'ko','í›„',0),(260732,7243,'he','××—×¨×™',0),(260733,7243,'el','ÎœÎµÏ„Î¬',0),(260734,7243,'zh','åŽ\r\n',0),(260735,7243,'sv','Efter',0),(260736,7243,'it','Dopo',0),(260737,7243,'tl','',0),(260738,7243,'th','&#3627;&#3621;&#3633;&#3591;',0),(260739,7243,'hi','à¤•à¥‡ à¤¬à¤¾à¤¦',0),(260740,7243,'ms','Selepas',0),(260741,7243,'ar','Ø¨Ø¹Ø¯',0),(260742,7243,'fr','AprÃ¨s',0),(260743,7243,'jp','å¾Œ',0),(260744,7243,'pt','ApÃ³s',0),(260745,7243,'ru','ÐŸÐ¾ÑÐ»Ðµ',0),(260746,7243,'es','DespuÃ©s',0),(260747,7243,'de','Nach',0),(260748,7243,'en','After',0),(260749,7244,'is','',0),(260750,7244,'dr','ÙØ¹Ù„Ø§ ØªÙˆØ¶ÙŠØ­ Ø¯Ø§Ø±Ø¯ â€“ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§ÙƒÙ†ÙˆÙ† Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(260751,7244,'pr','ÙØ¹Ù„Ø§ ØªÙˆØ¶ÙŠØ­ Ø¯Ø§Ø±Ø¯ â€“ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§ÙƒÙ†ÙˆÙ† Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(260752,7244,'tr','Zaten olan tanÄ±mÄ±, ithal ÅŸimdi gÃ¼ncellenir',0),(260753,7244,'pl','Definicja, jest juÅ¼ teraz importowanie bÄ™dzie aktualizacja',0),(260754,7244,'bg','Ð’ÐµÑ‡Ðµ Ð¸Ð¼Ð° Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ ÑÐµÐ³Ð° Ñ‰Ðµ ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°',0),(260755,7244,'ur','Ù¾ÛÙ„Û’ ÛÛŒ ØªØ¹Ø±ÛŒÙ ÛÛ’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø± Ø±ÛØ§ ÛÛ’ Ø§Ø¨ Ú¯ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(260756,7244,'sr','Ð’ÐµÑ› Ð¸Ð¼Ð° Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ðµ, ÑƒÐ²Ð¾Ð· ÑÐ°Ð´Ð° Ñ›Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ð¸',0),(260757,7244,'vi','ÄÃ£ cÃ³ Ä‘á»‹nh nghÄ©a, nháº­p dá»¯ liá»‡u báº¯t Ä‘áº§u cáº­p nháº­t',0),(260758,7244,'af','Het Alreeds \'n definisie, invoer sal nou opdateer',0),(260759,7244,'ro','Are deja definiÅ£ie, acum importul va actualiza',0),(260760,7244,'et','On juba mÃ¤Ã¤ratluse importimine nÃ¼Ã¼d update',0),(260761,7244,'si','Å½e ima opredelitev, uvoz zdaj posodobi',0),(260762,7244,'ba','Sudah memiliki definisi, mengimpor sekarang akan memperbarui',0),(260763,7244,'nl','Al definitie, nu importeren zal bijwerken',0),(260764,7244,'fi','Jo lÃ¤htÃ¶kohtaisesti tuodaan nyt pÃ¤ivittÃ¤Ã¤',0),(260765,7244,'no','Allerede har definisjon, importerer nÃ¥ oppdateres',0),(260766,7244,'da','Definition, har allerede importerer nu vil opdatere',0),(260767,7244,'ko','ì´ë¯¸ ì •ì˜ ì—…ë°ì´ íŠ¸ ë©ë‹ˆë‹¤ ì§€ê¸ˆ ê°€ì ¸ì˜¤ê¸°',0),(260768,7244,'he','×›×‘×¨ ×™×© ×”×’×“×¨×”, ×™×™×‘×•× ×¢×›×©×™×• ×™×¢×“×›×Ÿ',0),(260769,7244,'el','Î‰Î´Î· Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÎ¼ÏŒ, ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Ï„ÏŽÏÎ± Î¸Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹',0),(260770,7244,'zh','å·²ç»æœ‰å®šä¹‰ï¼ŒçŽ°åœ¨è¿›å£å°†æ›´æ–°\r\n',0),(260771,7244,'sv','Redan har definition, importerar nu uppdateras',0),(260772,7244,'it','Ha giÃ  la definizione, importando adesso aggiornerÃ ',0),(260773,7244,'tl','',0),(260774,7244,'th','&#3617;&#3637;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;, &#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3605;&#3629;&#3609;&#3609;&#3637;&',0),(260775,7244,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¹à¥ˆ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾, à¤†à¤¯à¤¾à¤¤ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ à¤…à¤¬ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤—à¤¾',0),(260776,7244,'ms','Sudah pun mempunyai definisi, mengimport sekarang akan mengemaskini',0),(260777,7244,'ar','ÙˆÙ‚Ø¯ Ø³Ø¨Ù‚ ØªØ¹Ø±ÙŠÙØŒ Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø© Ø³ÙŠØªÙ… Ø§Ù„ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¢Ù†',0),(260778,7244,'fr','A dÃ©jÃ  dÃ©finition, importation sera dÃ©sormais mise Ã  jour',0),(260779,7244,'jp','å®šç¾©ã¯æ—¢ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹ä»Šæ›´æ–°ã•ã‚Œã¾ã™',0),(260780,7244,'pt','JÃ¡ tem definiÃ§Ã£o, importando agora irÃ¡ atualizar',0),(260781,7244,'ru','Ð£Ð¶Ðµ ÐµÑÑ‚ÑŒ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ, Ñ‚ÐµÐ¿ÐµÑ€ÑŒ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð±ÑƒÐ´ÐµÑ‚ Ð¾Ð±Ð½Ð¾Ð²Ð»ÑÑ‚ÑŒ',0),(260782,7244,'es','Ya Hay DefiniciÃ³n, Ahora ImportaciÃ³n ActualizarÃ¡',0),(260783,7244,'de','Bereits Definition importieren jetzt aktualisiert',0),(260784,7244,'en','Already has definition, importing now will update',0),(260785,7245,'is','',0),(260786,7245,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨',0),(260787,7245,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨',0),(260788,7245,'tr','SeÃ§imi geri',0),(260789,7245,'pl','PowrÃ³t do wyboru',0),(260790,7245,'bg','ÐÐ°Ð·Ð°Ð´ ÐºÑŠÐ¼ Ð¸Ð·Ð±Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾',0),(260791,7245,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ùˆ ÙˆØ§Ù¾Ø³',0),(260792,7245,'sr','ÐÐ°Ð·Ð°Ð´ Ð½Ð° Ð¸Ð·Ð±Ð¾Ñ€',0),(260793,7245,'vi','Quay láº¡i lá»±a chá»n',0),(260794,7245,'af','Terug na Seleksie',0),(260795,7245,'ro','ÃŽnapoi la selecÅ£ia',0),(260796,7245,'et','Naasta valik',0),(260797,7245,'si','Nazaj na izbor',0),(260798,7245,'ba','Kembali ke seleksi',0),(260799,7245,'nl','Terug naar selectie',0),(260800,7245,'fi','Palaa valinta',0),(260801,7245,'no','Tilbake til utvalg',0),(260802,7245,'da','Tilbage til udvalg',0),(260803,7245,'ko','ì„ íƒìœ¼ë¡œ ëŒì•„ê°€ê¸°',0),(260804,7245,'he','×‘×—×–×¨×” ×œ×‘×—×™×¨×”',0),(260805,7245,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î®',0),(260806,7245,'zh','è¿”å›žé€‰æ‹©\r\n',0),(260807,7245,'sv','Tillbaka till val',0),(260808,7245,'it','Torna alla selezione',0),(260809,7245,'tl','',0),(260810,7245,'th','&#3585;&#3621;&#3633;&#3610;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(260811,7245,'hi','à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤ªà¤¸',0),(260812,7245,'ms','Kembali ke pilihan',0),(260813,7245,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ù„ØªØ­Ø¯ÙŠØ¯',0),(260814,7245,'fr','Retour Ã  la sÃ©lection',0),(260815,7245,'jp','é¸æŠžã«æˆ»ã‚‹',0),(260816,7245,'pt','Voltar Ã  seleÃ§Ã£o',0),(260817,7245,'ru','ÐÐ°Ð·Ð°Ð´ Ðº Ð’Ñ‹Ð±Ð¾Ñ€Ñƒ',0),(260818,7245,'es','Atras a la SelecciÃ³n',0),(260819,7245,'de','ZurÃ¼ck zur Auswahl',0),(260820,7245,'en','Back to Selection',0),(260821,7246,'is','',0),(260822,7246,'dr','Ù‚Ø¨Ù„ Ø§Ø² ',0),(260823,7246,'pr','Ù‚Ø¨Ù„ Ø§Ø² ',0),(260824,7246,'tr','Daha Ã¶nce',0),(260825,7246,'pl','Przed',0),(260826,7246,'bg','ÐŸÑ€ÐµÐ´Ð¸',0),(260827,7246,'ur','Ø³Û’ Ù¾ÛÙ„Û’',0),(260828,7246,'sr','ÐŸÑ€Ðµ',0),(260829,7246,'vi','TrÆ°á»›c khi',0),(260830,7246,'af','Voor',0),(260831,7246,'ro','ÃŽnainte de a',0),(260832,7246,'et','Enne',0),(260833,7246,'si','Pred',0),(260834,7246,'ba','Sebelum',0),(260835,7246,'nl','Voordat',0),(260836,7246,'fi','Ennen',0),(260837,7246,'no','FÃ¸r',0),(260838,7246,'da','FÃ¸r',0),(260839,7246,'ko','ì „ì—',0),(260840,7246,'he','×œ×¤× ×™',0),(260841,7246,'el','Î ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½',0),(260842,7246,'zh','å‰\r\n',0),(260843,7246,'sv','Innan',0),(260844,7246,'it','Prima',0),(260845,7246,'tl','',0),(260846,7246,'th','&#3585;&#3656;&#3629;&#3609;',0),(260847,7246,'hi','à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡',0),(260848,7246,'ms','Sebelum',0),(260849,7246,'ar','Ù‚Ø¨Ù„',0),(260850,7246,'fr','Avant',0),(260851,7246,'jp','å‰ã«',0),(260852,7246,'pt','Antes',0),(260853,7246,'ru','ÐŸÐµÑ€ÐµÐ´',0),(260854,7246,'es','Antes',0),(260855,7246,'de','Vor',0),(260856,7246,'en','Before',0),(260857,7247,'is','',0),(260858,7247,'dr','Ø«Ø¨Øª  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù…Ø´Ø®ØµØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ§Ø¯',0),(260859,7247,'pr','Ø«Ø¨Øª  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù…Ø´Ø®ØµØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ§Ø¯',0),(260860,7247,'tr','Bill malzeme giriÅŸ GÃ¼ncelleÅŸtirmesi',0),(260861,7247,'pl','Zestawienie materiaÅ‚Ã³w wejÅ›cia aktualizacji',0),(260862,7247,'bg','ÐšÐ¾Ð¼Ð¿Ð»ÐµÐºÑÐ½Ð¾ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ°',0),(260863,7247,'ur','Ù…ÙˆØ§Ø¯ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø§ Ø¨Ù„',0),(260864,7247,'sr','Ð‘Ð¸Ð» Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(260865,7247,'vi','Nháº­p/Cáº­p Nháº­t HÃ³a ÄÆ¡n NguyÃªn Váº­t Liá»‡u',0),(260866,7247,'af','Wetsontwerp van materiaal inskrywing bywerking',0),(260867,7247,'ro','Proiect de lege de materiale de intrare Update',0),(260868,7247,'et','Bill materjalide kanne Update',0),(260869,7247,'si','Bill materialov vnos posodobitve',0),(260870,7247,'ba','Tagihan bahan masuk pembaruan',0),(260871,7247,'nl','Bill van materialen post Update',0),(260872,7247,'fi','Bill materiaalien merkintÃ¤ pÃ¤ivityksen',0),(260873,7247,'no','Bill av materiale oppfÃ¸ring oppdateringen',0),(260874,7247,'da','Bill af materiale post opdatering',0),(260875,7247,'ko','ìžë£Œ í•­ëª© ì—…ë°ì´íŠ¸ì˜ ë¹Œ',0),(260876,7247,'he','×‘×™×œ ×©×œ ×—×•×ž×¨×™ ×”×–× ×” ×¢×“×›×•×Ÿ',0),(260877,7247,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Î³Î¹Î± Ï…Î»Î¹ÎºÏŽÎ½ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… Ï„Î·Ï‚ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î·Ï‚ Î­ÎºÎ´Î¿ÏƒÎ·Ï‚',0),(260878,7247,'zh','ææ–™æ¸…å•é¡¹æ›´æ–°\r\n',0),(260879,7247,'sv','Bill av material posten uppdatering',0),(260880,7247,'it','Disegno di legge di aggiornamento entrata materiali',0),(260881,7247,'tl','',0),(260882,7247,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3636;&#3621;&#3586;&#3629;&#3591;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(260883,7247,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾ à¤¬à¤¿à¤²',0),(260884,7247,'ms','Rang undang-undang Update kemasukan bahan-bahan',0),(260885,7247,'ar','Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ù„ØªØ­Ø¯ÙŠØ« Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ù…ÙˆØ§Ø¯',0),(260886,7247,'fr','Projet de loi de matÃ©riaux entrÃ©e mise Ã  jour',0),(260887,7247,'jp','ææ–™ã®ã‚¨ãƒ³ãƒˆãƒªã®æ›´æ–°ã®ãƒ“ãƒ«',0),(260888,7247,'pt','Bill da atualizaÃ§Ã£o de entrada de materiais',0),(260889,7247,'ru','Ð‘Ð¸Ð»Ð» Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð² Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(260890,7247,'es','Lista de Materiales Actualizar la Entrada',0),(260891,7247,'de','Bill of Material-Eintrag-Update',0),(260892,7247,'en','Bill of Materials Entry Update',0),(260893,7248,'is','',0),(260894,7248,'dr','ØªØºÙŠÙŠØ± ÙˆØ¶Ø¹ÙŠØª ',0),(260895,7248,'pr','ØªØºÙŠÙŠØ± ÙˆØ¶Ø¹ÙŠØª ',0),(260896,7248,'tr','Durumu deÄŸiÅŸtir',0),(260897,7248,'pl','Zmiana stanu',0),(260898,7248,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾',0),(260899,7248,'ur','Ø­Ø§Ù„Øª Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(260900,7248,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(260901,7248,'vi','Thay Ä‘á»•i tÃ¬nh tráº¡ng',0),(260902,7248,'af','Verander Status',0),(260903,7248,'ro','ModificaÅ£i starea',0),(260904,7248,'et','Oleku muutmine',0),(260905,7248,'si','Spremeni stanje',0),(260906,7248,'ba','Perubahan Status',0),(260907,7248,'nl','Wijzigingsstatus',0),(260908,7248,'fi','Muuta tila',0),(260909,7248,'no','Endre Status',0),(260910,7248,'da','Skift Status',0),(260911,7248,'ko','ìƒíƒœ ë³€ê²½',0),(260912,7248,'he','×©×™× ×•×™ ×¡×˜×˜×•×¡',0),(260913,7248,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î¼ÎµÏ„Î±Î²Î¿Î»Î®Ï‚',0),(260914,7248,'zh','æ›´æ”¹çŠ¶æ€\r\n',0),(260915,7248,'sv','Ã„ndra Status',0),(260916,7248,'it','Modifica stato',0),(260917,7248,'tl','',0),(260918,7248,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3626;&#3606;&#3634;&#3609;&#3632;',0),(260919,7248,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¬à¤¦à¤²à¥‡à¤‚',0),(260920,7248,'ms','Tukar Status',0),(260921,7248,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø­Ø§Ù„Ø©',0),(260922,7248,'fr','Changement de statut',0),(260923,7248,'jp','ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã®å¤‰æ›´',0),(260924,7248,'pt','Alterar Status',0),(260925,7248,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(260926,7248,'es','Cambiar Status',0),(260927,7248,'de','Ã„nderungsstatus',0),(260928,7248,'en','Change Status',0),(260929,7249,'is','',0),(260930,7249,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(260931,7249,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(260932,7249,'tr','VeritabanÄ± gÃ¼ncelleÅŸtirme hatasÄ±',0),(260933,7249,'pl','BÅ‚Ä…d aktualizacji bazy danych',0),(260934,7249,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(260935,7249,'ur','Ù†Ù‚Øµ Ú©ÙˆØ§Ø¦ÙÛŒÛ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(260936,7249,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(260937,7249,'vi','Cáº­p nháº­t dá»¯ liá»‡u bá»‹ lá»—i',0),(260938,7249,'af','Fout met Opdatering van Databasis',0),(260939,7249,'ro','Eroare de actualizare baza de date',0),(260940,7249,'et','Andmebaasi uuendamisel ilmnes viga',0),(260941,7249,'si','Napaka posodabljanje zbirke podatkov',0),(260942,7249,'ba','Kesalahan update Database',0),(260943,7249,'nl','Fout bijwerken Database',0),(260944,7249,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tietokantaa',0),(260945,7249,'no','Feil oppdatering Database',0),(260946,7249,'da','Fejl opdatering Database',0),(260947,7249,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë°ì´í„°ë² ì´ìŠ¤',0),(260948,7249,'he','×©×’×™××ª ×¢×“×›×•×Ÿ ×ž×¡×“ × ×ª×•× ×™×',0),(260949,7249,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ ÏƒÏ†Î¬Î»Î¼Î±',0),(260950,7249,'zh','æ›´æ–°æ•°æ®åº“é”™è¯¯\r\n',0),(260951,7249,'sv','Error uppdaterar databasen',0),(260952,7249,'it','Errore aggiornamento Database',0),(260953,7249,'tl','',0),(260954,7249,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(260955,7249,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸',0),(260956,7249,'ms','Ralat pengemaskinian pangkalan data',0),(260957,7249,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(260958,7249,'fr','Erreur mise Ã  jour base de donnÃ©es',0),(260959,7249,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(260960,7249,'pt','Erro atualizaÃ§Ã£o de banco de dados',0),(260961,7249,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð‘Ð°Ð·Ñ‹ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(260962,7249,'es','Error Actualizando Base de Datos',0),(260963,7249,'de','Aktualisierung Fehlerdatenbank',0),(260964,7249,'en','Error Updating Database',0),(260965,7250,'is','',0),(260966,7250,'dr','Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(260967,7250,'pr','Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(260968,7250,'tr','BaÅŸarÄ±sÄ±z oldu',0),(260969,7250,'pl','Nie powiodÅ‚o siÄ™',0),(260970,7250,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(260971,7250,'ur','Ù†Ø§Ú©Ø§Ù…',0),(260972,7250,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(260973,7250,'vi','Tháº¥t báº¡i',0),(260974,7250,'af','Het misluk',0),(260975,7250,'ro','Nu a reuÈ™it',0),(260976,7250,'et','Nurjus',0),(260977,7250,'si','Ni uspelo',0),(260978,7250,'ba','Gagal',0),(260979,7250,'nl','Is mislukt',0),(260980,7250,'fi','EpÃ¤onnistui',0),(260981,7250,'no','Mislyktes',0),(260982,7250,'da','Mislykkedes',0),(260983,7250,'ko','ì‹¤íŒ¨',0),(260984,7250,'he','× ×›×©×œ',0),(260985,7250,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ',0),(260986,7250,'zh','å¤±è´¥\r\n',0),(260987,7250,'sv','Misslyckades',0),(260988,7250,'it','Non riuscita',0),(260989,7250,'tl','',0),(260990,7250,'th','&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(260991,7250,'hi','à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(260992,7250,'ms','Gagal',0),(260993,7250,'ar','ÙØ´Ù„',0),(260994,7250,'fr','A Ã©chouÃ©',0),(260995,7250,'jp','å¤±æ•—ã—ã¾ã—ãŸ',0),(260996,7250,'pt','Falhou',0),(260997,7250,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(260998,7250,'es','Fallado',0),(260999,7250,'de','Fehlgeschlagen',0),(261000,7250,'en','Failed',0),(261001,7251,'is','',0),(261002,7251,'dr','ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(261003,7251,'pr','ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(261004,7251,'tr','Yeniden dÃ¼zenlendi',0),(261005,7251,'pl','ZostaÅ‚ zmieniony',0),(261006,7251,'bg','Ð• Ð±Ð¸Ð» Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÐ½',0),(261007,7251,'ur','Ù†Ø¸Ø± Ø«Ø§Ù†ÛŒ Ú©ÛŒ Ú¯Ø¦ÛŒ ÛÛ’',0),(261008,7251,'sr','-ÐÐ°Ñ€Ð°ÑÑ‚Ð°Ð¾',0),(261009,7251,'vi','ÄÃ£ nháº­n',0),(261010,7251,'af','Hersien is',0),(261011,7251,'ro','A fost revizuit',0),(261012,7251,'et','On Ã¼le vaadatud',0),(261013,7251,'si','Spremenjeni',0),(261014,7251,'ba','Telah direvisi',0),(261015,7251,'nl','Is herzien',0),(261016,7251,'fi','On tarkistettu',0),(261017,7251,'no','Har blitt revidert',0),(261018,7251,'da','Er blevet revideret',0),(261019,7251,'ko','ê°œì • ë˜ì–´',0),(261020,7251,'he','×ª×•×§× ×”',0),(261021,7251,'el','ÎˆÏ‡ÎµÎ¹ Î±Î½Î±Î¸ÎµÏ‰ÏÎ·Î¸ÎµÎ¯',0),(261022,7251,'zh','å·²ä¿®è®¢\r\n',0),(261023,7251,'sv','Har reviderats',0),(261024,7251,'it','Ãˆ stato rivisto',0),(261025,7251,'tl','',0),(261026,7251,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3649;&#3621;&#3657;&#3623;',0),(261027,7251,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(261028,7251,'ms','Telah disemak',0),(261029,7251,'ar','ÙˆÙ‚Ø¯ ØªÙ… ØªÙ†Ù‚ÙŠØ­',0),(261030,7251,'fr','A Ã©tÃ© rÃ©visÃ©',0),(261031,7251,'jp','æ”¹è¨‚ã•ã‚Œã¦ã„ã¾ã™',0),(261032,7251,'pt','Foi revisado',0),(261033,7251,'ru','Ð‘Ñ‹Ð» Ð¿ÐµÑ€ÐµÑÐ¼Ð¾Ñ‚Ñ€ÐµÐ½',0),(261034,7251,'es','Ha sido Revisado',0),(261035,7251,'de','Wurde Ã¼berarbeitet',0),(261036,7251,'en','Has Been Revised',0),(261037,7252,'is','',0),(261038,7252,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ',0),(261039,7252,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ',0),(261040,7252,'tr','ÃœrÃ¼n ReÃ§etesi iÃ§e aktarma',0),(261041,7252,'pl','Importowanie BOM',0),(261042,7252,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐšÐ˜',0),(261043,7252,'ur','Ø¨Ø§Ù… Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(261044,7252,'sr','Ð£Ð²Ð¾Ð· Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ',0),(261045,7252,'vi','Nháº­p BOM',0),(261046,7252,'af','Ingevoerde \"BOM\"',0),(261047,7252,'ro','Importul LM',0),(261048,7252,'et','Importimine Koosluse',0),(261049,7252,'si','UvaÅ¾anje Kosovnice',0),(261050,7252,'ba','Mengimpor BOM',0),(261051,7252,'nl','Importeren van Stuklijst',0),(261052,7252,'fi','Tuominen Tuoterakenteen',0),(261053,7252,'no','Importere Stykkliste',0),(261054,7252,'da','Importerer Styklisten',0),(261055,7252,'ko','BOMì„ ê°€ì ¸ì˜¤ê¸°',0),(261056,7252,'he','×™×™×‘×•× BOM',0),(261057,7252,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï„ÎµÏ‡Î½Î¹ÎºÏŽÎ½ Ï€ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†ÏŽÎ½',0),(261058,7252,'zh','å¯¼å…¥çš„BOM\r\n',0),(261059,7252,'sv','Importera BOM',0),(261060,7252,'it','Importazione di BOM',0),(261061,7252,'tl','',0),(261062,7252,'th','&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634; BOM',0),(261063,7252,'hi','BOM à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¤¾',0),(261064,7252,'ms','Mengimport BOM',0),(261065,7252,'ar','Ø´Ø¬Ø±Ø© Ø§Ù„Ù…ÙˆØ§Ø¯ Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(261066,7252,'fr','Importation de BOM',0),(261067,7252,'jp','éƒ¨å“è¡¨ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(261068,7252,'pt','ImportaÃ§Ã£o de BOM',0),(261069,7252,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(261070,7252,'es','Importando BOM',0),(261071,7252,'de','Import von StÃ¼cklisten',0),(261072,7252,'en','Importing BOM',0),(261073,7253,'is','',0),(261074,7253,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ',0),(261075,7253,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ',0),(261076,7253,'tr','Alma Ã¼rÃ¼n ReÃ§etesi',0),(261077,7253,'pl','PrzywÃ³z BOM',0),(261078,7253,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ ÐšÐ˜',0),(261079,7253,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø¨Ø§Ù…',0),(261080,7253,'sr','Ð£Ð²Ð¾Ð· Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ',0),(261081,7253,'vi','Nháº­p BOM',0),(261082,7253,'af','Invoer van \"BOM\"',0),(261083,7253,'ro','Import LM',0),(261084,7253,'et','Impordi Koosluse',0),(261085,7253,'si','Uvoz Kosovnice',0),(261086,7253,'ba','Impor BOM',0),(261087,7253,'nl','Import BOM',0),(261088,7253,'fi','Tuo Tuoterakenteen',0),(261089,7253,'no','Importer Stykkliste',0),(261090,7253,'da','Import Stykliste',0),(261091,7253,'ko','ê°€ì ¸ì˜¤ê¸° BOM',0),(261092,7253,'he','×™×™×‘×•× BOM',0),(261093,7253,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï„ÎµÏ‡Î½Î¹ÎºÏŽÎ½ Ï€ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†ÏŽÎ½',0),(261094,7253,'zh','è¿›å£ç‰©æ–™æ¸…å•\r\n',0),(261095,7253,'sv','Importera BOM',0),(261096,7253,'it','Importazione BOM',0),(261097,7253,'tl','',0),(261098,7253,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634; BOM',0),(261099,7253,'hi','à¤†à¤¯à¤¾à¤¤ BOM',0),(261100,7253,'ms','Import BOM',0),(261101,7253,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø´Ø¬Ø±Ø© Ø§Ù„Ù…ÙˆØ§Ø¯',0),(261102,7253,'fr','Importation BOM',0),(261103,7253,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆéƒ¨å“è¡¨',0),(261104,7253,'pt','ImportaÃ§Ã£o BOM',0),(261105,7253,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(261106,7253,'es','Importar BOM',0),(261107,7253,'de','Import BOM',0),(261108,7253,'en','Import BOM',0),(261109,7254,'is','',0),(261110,7254,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(261111,7254,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(261112,7254,'tr','Veri alma',0),(261113,7254,'pl','Importowanie danych',0),(261114,7254,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸',0),(261115,7254,'ur','Ú©ÙˆØ§Ø¦Ù Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(261116,7254,'sr','Ð£Ð²Ð¾Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(261117,7254,'vi','Nháº­p dá»¯ liá»‡u',0),(261118,7254,'af','Invoer van Data',0),(261119,7254,'ro','Import date',0),(261120,7254,'et','Impordi andmed',0),(261121,7254,'si','Uvoz podatkov',0),(261122,7254,'ba','Mengimpor Data',0),(261123,7254,'nl','Gegevens importeren',0),(261124,7254,'fi','Tietojen tuominen',0),(261125,7254,'no','Importere Data',0),(261126,7254,'da','Importdata',0),(261127,7254,'ko','ë°ì´í„° ê°€ì ¸ì˜¤ê¸°',0),(261128,7254,'he','×™×™×‘×•× × ×ª×•× ×™×',0),(261129,7254,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(261130,7254,'zh','å¯¼å…¥æ•°æ®\r\n',0),(261131,7254,'sv','Importera Data',0),(261132,7254,'it','Importazione dati',0),(261133,7254,'tl','',0),(261134,7254,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(261135,7254,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(261136,7254,'ms','Import Data',0),(261137,7254,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(261138,7254,'fr','Importer des donnÃ©es',0),(261139,7254,'jp','ãƒ‡ãƒ¼ã‚¿ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(261140,7254,'pt','Importar dados',0),(261141,7254,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(261142,7254,'es','Importar Datos',0),(261143,7254,'de','Importieren von Daten',0),(261144,7254,'en','Import Data',0),(261145,7255,'is','',0),(261146,7255,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ',0),(261147,7255,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ',0),(261148,7255,'tr','Alma dosyasÄ± sÃ¼tun biÃ§imi',0),(261149,7255,'pl','Kolumna w formacie pliku importu',0),(261150,7255,'bg','ÐšÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð° Ñ„Ð°Ð¹Ð» Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(261151,7255,'ur','Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(261152,7255,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÑƒÐ²Ð¾Ð·Ð°',0),(261153,7255,'vi','Nháº­p há»“ sÆ¡ dáº¡ng cá»™t',0),(261154,7255,'af','Invoer deur LÃªerkolom Formaat',0),(261155,7255,'ro','Import fiÅŸier Format coloane',0),(261156,7255,'et','Impordi faili veeruvormingut',0),(261157,7255,'si','Uvozna datoteka stolpec oblika',0),(261158,7255,'ba','Format kolom impor File',0),(261159,7255,'nl','Import bestand kolomindeling',0),(261160,7255,'fi','Sarakkeen tiedostomuodoksi',0),(261161,7255,'no','Kolonnen for importfilformat',0),(261162,7255,'da','Kolonne importfilformat',0),(261163,7255,'ko','ê°€ì ¸ì˜¤ê¸° íŒŒì¼ ì—´ í˜•ì‹',0),(261164,7255,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×§×•×‘×¥ ×™×™×‘×•×',0),(261165,7255,'el','ÎœÎ¿ÏÏ†Î® ÏƒÏ„Î®Î»Î·Ï‚ Ï„Î¿Ï… Î±ÏÏ‡ÎµÎ¯Î¿Ï… ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(261166,7255,'zh','å¯¼å…¥æ–‡ä»¶æ ¼å¼åˆ—\r\n',0),(261167,7255,'sv','Importfilformat fÃ¶r kolumn',0),(261168,7255,'it','Importazione File formato colonne',0),(261169,7255,'tl','',0),(261170,7255,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3649;&#3615;&#3657;&#3617;&#3605;&#3634;&#3617;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3588;&#3629;&#3621;&#3633;&#3617;&#3616;&#3660;',0),(261171,7255,'hi','à¤†à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(261172,7255,'ms','Format kolum fail import',0),(261173,7255,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù„Ù ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯',0),(261174,7255,'fr','Format de colonne de fichier importation',0),(261175,7255,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«ã®åˆ—ã®å½¢å¼',0),(261176,7255,'pt','Formato de coluna do arquivo de importaÃ§Ã£o',0),(261177,7255,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(261178,7255,'es','Importar Formato de Fila Columna',0),(261179,7255,'de','Spalte-Dateiformat importieren',0),(261180,7255,'en','Import File Column Format',0),(261181,7256,'is','',0),(261182,7256,'dr','Ø¢ÙŠØ§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ø¬Ø²Ø¦ÙŠ Ø§Ø²',0),(261183,7256,'pr','Ø¢ÙŠØ§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ø¬Ø²Ø¦ÙŠ Ø§Ø²',0),(261184,7256,'tr','Zaten bir bileÅŸenidir',0),(261185,7256,'pl','Jest juÅ¼ czÄ™Å›ciÄ…',0),(261186,7256,'bg','Ð’ÐµÑ‡Ðµ Ðµ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚ Ð½Ð°',0),(261187,7256,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ú©Ø§ Ø§ÛŒÚ© Ø¬Ø²Ùˆ ÛÛ’',0),(261188,7256,'sr','Ð’ÐµÑ› Ñ˜Ðµ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð°',0),(261189,7256,'vi','ÄÃ£ lÃ  1 thÃ nh pháº§n cá»§a',0),(261190,7256,'af','Is Alreeds \'n Komponent Van',0),(261191,7256,'ro','Este deja o componentÄƒ a',0),(261192,7256,'et','On juba osa',0),(261193,7256,'si','Je Å¾e sestavni del',0),(261194,7256,'ba','Sudah komponen',0),(261195,7256,'nl','Is al een onderdeel van',0),(261196,7256,'fi','On jo osa',0),(261197,7256,'no','Er allerede en del av',0),(261198,7256,'da','Er allerede en del af',0),(261199,7256,'ko','ì´ë¯¸ì˜ êµ¬ì„± ìš”ì†Œ',0),(261200,7256,'he','×”×•× ×›×‘×¨ ×ž×¨×›×™×‘ ×©×œ',0),(261201,7256,'el','Î•Î¯Î½Î±Î¹ Î®Î´Î· Î­Î½Î± ÏƒÏ…ÏƒÏ„Î±Ï„Î¹ÎºÏŒ Ï„Î·Ï‚',0),(261202,7256,'zh','å·²ç»æ˜¯ä¸€ä¸ªæˆåˆ†\r\n',0),(261203,7256,'sv','Ã„r redan en del av',0),(261204,7256,'it','Ãˆ giÃ  un componente della',0),(261205,7256,'tl','',0),(261206,7256,'th','&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(261207,7256,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤à¤• à¤˜à¤Ÿà¤• à¤¹à¥ˆ',0),(261208,7256,'ms','Sudah satu komponen',0),(261209,7256,'ar','Ù‡Ùˆ Ø¨Ø§Ù„ÙØ¹Ù„ Ø¹Ù†ØµØ± Ù…Ù† Ø¹Ù†Ø§ØµØ±',0),(261210,7256,'fr','Est dÃ©jÃ  un Ã©lÃ©ment de',0),(261211,7256,'jp','æ¸ˆã¿ã®ã‚³ãƒ³ãƒãƒ¼ãƒãƒ³ãƒˆãŒ',0),(261212,7256,'pt','JÃ¡ Ã© um componente de',0),(261213,7256,'ru','Ð£Ð¶Ðµ ÐšÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚',0),(261214,7256,'es','Ya Esta un Componente De',0),(261215,7256,'de','Ist bereits ein Bestandteil des',0),(261216,7256,'en','Is Already a Component Of',0),(261217,7257,'is','',0),(261218,7257,'dr','ÙƒØ§Ù„Ø§ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù†ÙŠØ³Øª',0),(261219,7257,'pr','ÙƒØ§Ù„Ø§ Ø¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ù†ÙŠØ³Øª',0),(261220,7257,'tr','Madde stokta yok',0),(261221,7257,'pl','Element nie w magazynie',0),(261222,7257,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ð½Ðµ Ðµ Ð² ÑÐºÐ»Ð°Ð´Ð°',0),(261223,7257,'ur','Ø´Û’ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…ÛŒÚº Ù†ÛÛŒÚº',0),(261224,7257,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ð½Ð¸Ñ˜Ðµ Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(261225,7257,'vi','HÃ ng KhÃ´ng Trong Danh sÃ¡ch kho',0),(261226,7257,'af','Item Nie in Voorraad',0),(261227,7257,'ro','Element Ã®n inventar',0),(261228,7257,'et','Kaup ei ole laos',0),(261229,7257,'si','Artikla ni na zalogi',0),(261230,7257,'ba','Item tidak dalam persediaan',0),(261231,7257,'nl','Artikel niet in voorraad',0),(261232,7257,'fi','Ei varastossa nimikkeen',0),(261233,7257,'no','Elementet ikke pÃ¥ lager',0),(261234,7257,'da','Varen ikke pÃ¥ lager',0),(261235,7257,'ko','ëª©ë¡ì— ì—†ëŠ” í•­ëª©',0),(261236,7257,'he','×¤×¨×™×˜ ×œ× ×‘×ž×œ××™',0),(261237,7257,'el','Î•Î¯Î´Î¿Ï‚ ÏƒÏ„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± ÎºÎ±Î¹ Î´ÎµÎ½ ÏƒÎµ',0),(261238,7257,'zh','æ²¡æœ‰ç›¸å…³é¡¹ç›®åœ¨åº“å­˜\r\n',0),(261239,7257,'sv','Artikeln inte i lagret',0),(261240,7257,'it','Elemento non in magazzino',0),(261241,7257,'tl','',0),(261242,7257,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3652;&#3617;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(261243,7257,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚',0),(261244,7257,'ms','Item dalam inventori',0),(261245,7257,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ù„Ø§ ÙÙŠ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(261246,7257,'fr','Ã‰lÃ©ment pas dans l\'inventaire',0),(261247,7257,'jp','åœ¨åº«ã®å•†å“',0),(261248,7257,'pt','Item nÃ£o no inventÃ¡rio',0),(261249,7257,'ru','Ð¢Ð¾Ð²Ð°Ñ€ ÐÐµ Ð½Ð° Ð¡ÐºÐ»Ð°Ð´Ðµ',0),(261250,7257,'es','Item no esta en inventario',0),(261251,7257,'de','Element nicht im Inventar',0),(261252,7257,'en','Item Not in Inventory',0),(261253,7258,'is','',0),(261254,7258,'dr','LN/NR ÙˆØ§Ù…/ØŸ',0),(261255,7258,'pr','LN/NR ÙˆØ§Ù…/ØŸ',0),(261256,7258,'tr','LN/NR',0),(261257,7258,'pl','LN/NR',0),(261258,7258,'bg','LN/ÐÐŸ',0),(261259,7258,'ur','Ù„Ù†/Ø§ÛŒÙ† Ø¢Ø±',0),(261260,7258,'sr','Ð£/Ð‘Ð ',0),(261261,7258,'vi','LN/NR',0),(261262,7258,'af','LN/NR',0),(261263,7258,'ro','LN/NR',0),(261264,7258,'et','Rea nr',0),(261265,7258,'si','LN/NR',0),(261266,7258,'ba','LN NR',0),(261267,7258,'nl','LN/NR',0),(261268,7258,'fi','LN/NR',0),(261269,7258,'no','LN/NR',0),(261270,7258,'da','LN/NR',0),(261271,7258,'ko','LN/NR',0),(261272,7258,'he','LN/× ',0),(261273,7258,'el','LN/NR',0),(261274,7258,'zh','æ³•å¾‹å…¬å‘Š/æ˜ŸæœŸæ—¥\r\n',0),(261275,7258,'sv','LN/NR',0),(261276,7258,'it','LN/NR',0),(261277,7258,'tl','',0),(261278,7258,'th','LN/NR',0),(261279,7258,'hi','LN/à¤à¤¨. à¤†à¤°.',0),(261280,7258,'ms','LN/NR',0),(261281,7258,'ar','LN/NR',0),(261282,7258,'fr','LN/NR',0),(261283,7258,'jp','LN/NR',0),(261284,7258,'pt','LN/NR',0),(261285,7258,'ru','LN/NR',0),(261286,7258,'es','LN/NR',0),(261287,7258,'de','LN/NR',0),(261288,7258,'en','LN/NR',0),(261289,7259,'is','',0),(261290,7259,'dr','Mfg ØªÙˆÙ„ÙŠØ¯ (Ø³Ø§Ø®Øª',0),(261291,7259,'pr','Mfg ØªÙˆÙ„ÙŠØ¯ (Ø³Ø§Ø®Øª',0),(261292,7259,'tr','Mfg',0),(261293,7259,'pl','MFG',0),(261294,7259,'bg','Mfg',0),(261295,7259,'ur','Mfg',0),(261296,7259,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²',0),(261297,7259,'vi','NhÃ  Sáº£n Xuáº¥t',0),(261298,7259,'af','Mfg',0),(261299,7259,'ro','MFG',0),(261300,7259,'et','Tootm',0),(261301,7259,'si','Mfg',0),(261302,7259,'ba','Mfg',0),(261303,7259,'nl','Mfg',0),(261304,7259,'fi','Mfg',0),(261305,7259,'no','Mfg',0),(261306,7259,'da','MFG',0),(261307,7259,'ko','ì œì¡°',0),(261308,7259,'he','Mfg',0),(261309,7259,'el','Mfg',0),(261310,7259,'zh','åˆ¶é€ \r\n',0),(261311,7259,'sv','MFG',0),(261312,7259,'it','MFG',0),(261313,7259,'tl','',0),(261314,7259,'th','Mfg',0),(261315,7259,'hi','Mfg',0),(261316,7259,'ms','MFG',0),(261317,7259,'ar','Ù…Ø¨Ø¯Ø¹ÙŠÙ†',0),(261318,7259,'fr','MFG',0),(261319,7259,'jp','è£½ä½œæ‰€',0),(261320,7259,'pt','MFG',0),(261321,7259,'ru','Mfg',0),(261322,7259,'es','Fab',0),(261323,7259,'de','MFG',0),(261324,7259,'en','Mfg',0),(261325,7260,'is','',0),(261326,7260,'dr','Ø­Ø±ÙƒØª Ø¨Ù‡ Ù¾Ø§ÙŠÙŠÙ† ',0),(261327,7260,'pr','Ø­Ø±ÙƒØª Ø¨Ù‡ Ù¾Ø§ÙŠÙŠÙ† ',0),(261328,7260,'tr','AÅŸaÄŸÄ± taÅŸÄ±',0),(261329,7260,'pl','PrzenieÅ› w dÃ³Å‚',0),(261330,7260,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸ Ð½Ð°Ð´Ð¾Ð»Ñƒ',0),(261331,7260,'ur','Ù†ÛŒÚ†Û’ Ù„Ø§Ø¦ÛŒÚº',0),(261332,7260,'sr','Ð¡Ð¿ÑƒÑÑ‚Ð¸ ÑÐµ',0),(261333,7260,'vi','Äi xuá»‘ng',0),(261334,7260,'af','Skuif af',0),(261335,7260,'ro','Mutare Ã®n jos',0),(261336,7260,'et','Nihuta alla',0),(261337,7260,'si','Premakni',0),(261338,7260,'ba','Pindahkan ke bawah',0),(261339,7260,'nl','Omlaag',0),(261340,7260,'fi','SiirrÃ¤ alas',0),(261341,7260,'no','Flytt ned',0),(261342,7260,'da','Flyt ned',0),(261343,7260,'ko','ì•„ëž˜ë¡œ ì´ë™',0),(261344,7260,'he','×”×–×– ×œ×ž×˜×”',0),(261345,7260,'el','ÎœÎµÏ„Î±ÎºÎ¯Î½Î·ÏƒÎ· Ï€ÏÎ¿Ï‚ Ï„Î± ÎºÎ¬Ï„Ï‰',0),(261346,7260,'zh','ä¸‹ç§»\r\n',0),(261347,7260,'sv','Flytta ned',0),(261348,7260,'it','Sposta giÃ¹',0),(261349,7260,'tl','',0),(261350,7260,'th','&#3618;&#3657;&#3634;&#3618;&#3652;&#3611;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3632;&#3604;&#3633;&#3610;&#3607;&#3637;&#3656;&#3605;&#3656;&#3635;&#3585;&#3623;&#3656;&#3634;',0),(261351,7260,'hi','à¤¨à¥€à¤šà¥‡ à¤²à¥‡ à¤œà¤¾à¤à¤',0),(261352,7260,'ms','Alih ke bawah',0),(261353,7260,'ar','ØªØ­Ø±ÙŠÙƒ Ù„Ø£Ø³ÙÙ„',0),(261354,7260,'fr','DÃ©placer vers le bas',0),(261355,7260,'jp','ä¸‹ã«ç§»å‹•ã—ã¾ã™ã€‚',0),(261356,7260,'pt','Mover para baixo',0),(261357,7260,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚ÑŒ Ð²Ð½Ð¸Ð·',0),(261358,7260,'es','Mover Abajo',0),(261359,7260,'de','Nach unten',0),(261360,7260,'en','Move Down',0),(261361,7261,'is','',0),(261362,7261,'dr','Ø­Ø±ÙƒØª Ø¨Ù‡ Ø¨Ø§Ù„Ø§',0),(261363,7261,'pr','Ø­Ø±ÙƒØª Ø¨Ù‡ Ø¨Ø§Ù„Ø§',0),(261364,7261,'tr','YukarÄ± TaÅŸÄ±',0),(261365,7261,'pl','PrzenieÅ› w gÃ³rÄ™',0),(261366,7261,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸ Ð½Ð°Ð³Ð¾Ñ€Ðµ',0),(261367,7261,'ur','Ø§ÙˆÙ¾Ø± Ù„Ø§Ø¦ÛŒÚº',0),(261368,7261,'sr','ÐŸÑ€ÐµÐ¼ÐµÑˆÑ‚Ð°ÑšÐµ Ð½Ð°Ð³Ð¾Ñ€Ðµ',0),(261369,7261,'vi','Chuyá»ƒn lÃªn',0),(261370,7261,'af','Skuif op',0),(261371,7261,'ro','VÄƒ deplasa Ã®n sus',0),(261372,7261,'et','Nihuta Ã¼les',0),(261373,7261,'si','Premakni gor',0),(261374,7261,'ba','Naik',0),(261375,7261,'nl','Omhoog',0),(261376,7261,'fi','SiirrÃ¤ ylÃ¶s',0),(261377,7261,'no','Flytt opp',0),(261378,7261,'da','Flyt op',0),(261379,7261,'ko','ìœ„ë¡œ ì´ë™',0),(261380,7261,'he','×”×–×– ×œ×ž×¢×œ×”',0),(261381,7261,'el','ÎœÎµÏ„Î±ÎºÎ¯Î½Î·ÏƒÎ· Ï€ÏÎ¿Ï‚ Ï„Î± ÎµÏ€Î¬Î½Ï‰',0),(261382,7261,'zh','ä¸Šç§»\r\n',0),(261383,7261,'sv','Flytta upp',0),(261384,7261,'it','Spostarsi verso l\'alto',0),(261385,7261,'tl','',0),(261386,7261,'th','&#3618;&#3657;&#3634;&#3618;&#3652;&#3611;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3632;&#3604;&#3633;&#3610;&#3607;&#3637;&#3656;&#3626;&#3641;&#3591;&#3585;&#3623;&#3656;&#3634;',0),(261387,7261,'hi','à¤Šà¤ªà¤° à¤²à¥‡ à¤œà¤¾à¤à¤',0),(261388,7261,'ms','Alih ke',0),(261389,7261,'ar','ØªØ­Ø±ÙŠÙƒ Ù„Ø£Ø¹Ù„Ù‰',0),(261390,7261,'fr','DÃ©placer vers le haut',0),(261391,7261,'jp','ä¸Šã«ç§»å‹•ã—ã¾ã™ã€‚',0),(261392,7261,'pt','Mover para cima',0),(261393,7261,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚ÑŒ Ð²Ð²ÐµÑ€Ñ…',0),(261394,7261,'es','Mover Arriba',0),(261395,7261,'de','Nach oben',0),(261396,7261,'en','Move Up',0),(261397,7262,'is','',0),(261398,7262,'dr','Ù‚Ø³Ù…Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ù†Ø¨Ø¹',0),(261399,7262,'pr','Ù‚Ø³Ù…Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…Ù†Ø¨Ø¹',0),(261400,7262,'tr','BÃ¶lÃ¼mÃ¼ baÅŸvuru veri',0),(261401,7262,'pl','CzÄ™Å›Ä‡ danych referencyjnych',0),(261402,7262,'bg','Ð§Ð°ÑÑ‚ Ñ€ÐµÑ„ÐµÑ€ÐµÐ½Ñ‚Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(261403,7262,'ur','Ø­ØµÛ Ø­ÙˆØ§Ù„Û Ú©ÙˆØ§Ø¦Ù',0),(261404,7262,'sr','Ð”ÐµÐ¾ Ñ€ÐµÑ„ÐµÑ€ÐµÐ½Ñ†Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(261405,7262,'vi','Dá»¯ liá»‡u vá» phá»¥ tÃ¹ng',0),(261406,7262,'af','Onderdeel Verwysingsdata',0),(261407,7262,'ro','Datele de referinÈ›Äƒ parte',0),(261408,7262,'et','Osa vÃµrdlusandmed',0),(261409,7262,'si','Del referenÄne podatke',0),(261410,7262,'ba','Bagian Data referensi',0),(261411,7262,'nl','Deel verwijzingsgegevens',0),(261412,7262,'fi','Osa viitetietoihin',0),(261413,7262,'no','Del referansedata',0),(261414,7262,'da','Del referencedata',0),(261415,7262,'ko','ë¶€í’ˆ ì°¸ì¡° ë°ì´í„°',0),(261416,7262,'he','×—×œ×§ ×”×¤× ×™×” × ×ª×•× ×™×',0),(261417,7262,'el','Î”ÎµÎ´Î¿Î¼Î­Î½Î± Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ Ï„Î¿Ï… Ï„Î¼Î®Î¼Î±Ï„Î¿Ï‚',0),(261418,7262,'zh','éƒ¨åˆ†å‚è€ƒæ•°æ®\r\n',0),(261419,7262,'sv','Del uppgifter',0),(261420,7262,'it','Dati di riferimento parte',0),(261421,7262,'tl','',0),(261422,7262,'th','&#3626;&#3656;&#3623;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3629;&#3657;&#3634;&#3591;&#3629;&#3636;&#3591;',0),(261423,7262,'hi','à¤­à¤¾à¤— à¤¸à¤‚à¤¦à¤°à¥à¤­ à¤¡à¥‡à¤Ÿà¤¾',0),(261424,7262,'ms','Bahagian Rujukan Data',0),(261425,7262,'ar','Ø¬Ø²Ø¡ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø±Ø¬Ø¹ÙŠØ©',0),(261426,7262,'fr','Partie donnÃ©es de rÃ©fÃ©rence',0),(261427,7262,'jp','ä¸€éƒ¨ã®å‚ç…§ãƒ‡ãƒ¼ã‚¿',0),(261428,7262,'pt','Parte de dados de referÃªncia',0),(261429,7262,'ru','Ð§Ð°ÑÑ‚ÑŒ ÑÐ¿Ñ€Ð°Ð²Ð¾Ñ‡Ð½Ñ‹Ñ… Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(261430,7262,'es','Datos de Referencia de Parte',0),(261431,7262,'de','Teil Referenzdaten',0),(261432,7262,'en','Part Reference Data',0),(261433,7263,'is','',0),(261434,7263,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù…Ø¹Ø±Ù',0),(261435,7263,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù…Ø¹Ø±Ù',0),(261436,7263,'tr','Referans notlar',0),(261437,7263,'pl','OdwoÅ‚anie notatki',0),(261438,7263,'bg','ÐŸÑ€ÐµÐ¿Ñ€Ð°Ñ‚ÐºÐ¸',0),(261439,7263,'ur','Ù†ÙˆÙ¹ Ø­ÙˆØ§Ù„Û',0),(261440,7263,'sr','Ð ÐµÑ„ÐµÑ€ÐµÐ½Ñ†Ðµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(261441,7263,'vi','Ghi chÃº Tham kháº£o',0),(261442,7263,'af','Verwysingsnotas',0),(261443,7263,'ro','Note de referinÅ£Äƒ',0),(261444,7263,'et','Viide mÃ¤rgib',0),(261445,7263,'si','Napotitev opombe',0),(261446,7263,'ba','Referensi catatan',0),(261447,7263,'nl','Verwijzingen',0),(261448,7263,'fi','Mainitsee',0),(261449,7263,'no','Referansemerknader',0),(261450,7263,'da','Reference noter',0),(261451,7263,'ko','ì°¸ì¡° ë©”ëª¨',0),(261452,7263,'he','×”×¤× ×™×” ×”×¢×¨×•×ª',0),(261453,7263,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(261454,7263,'zh','å‚ç…§ç¥¨æ®\r\n',0),(261455,7263,'sv','Referenser',0),(261456,7263,'it','Note di riferimento',0),(261457,7263,'tl','',0),(261458,7263,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3629;&#3657;&#3634;&#3591;&#3629;&#3636;&#3591;',0),(261459,7263,'hi','à¤¸à¤‚à¤¦à¤°à¥à¤­ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(261460,7263,'ms','Nota-Nota rujukan',0),(261461,7263,'ar','ÙˆØªÙ„Ø§Ø­Ø¸ Ø§Ù„Ø¥Ø´Ø§Ø±Ø©',0),(261462,7263,'fr','Notes de rÃ©fÃ©rence',0),(261463,7263,'jp','å‚ç…§ãƒŽãƒ¼ãƒˆ',0),(261464,7263,'pt','Notas de referÃªncia',0),(261465,7263,'ru','Ð¡Ð¿Ñ€Ð°Ð²Ð¾Ñ‡Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐºÐ¸',0),(261466,7263,'es','Notas de Referencia',0),(261467,7263,'de','Referenz-Notes',0),(261468,7263,'en','Reference Notes',0),(261469,7264,'is','',0),(261470,7264,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§ÙŠ Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯',0),(261471,7264,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§ÙŠ Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯',0),(261472,7264,'tr','ÃœrÃ¼n ReÃ§etesi maddesini seÃ§in',0),(261473,7264,'pl','Wybierz towar BOM',0),(261474,7264,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ ÐšÐ˜',0),(261475,7264,'ur','Ø¨Ø§Ù… Ø´Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(261476,7264,'sr','Ð‘Ð¸Ñ€Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ',0),(261477,7264,'vi','Chá»n hÃ ng BOM',0),(261478,7264,'af','Kies BOM Item',0),(261479,7264,'ro','SelectaÅ£i articolul LM',0),(261480,7264,'et','Valige Koosluse kauba',0),(261481,7264,'si','Izberite artikel Kosovnice',0),(261482,7264,'ba','Pilih BOM Item',0),(261483,7264,'nl','Selecteer stuklijstartikel',0),(261484,7264,'fi','Valitse tuoterakennenimikkeen',0),(261485,7264,'no','Velg stykklistevaren',0),(261486,7264,'da','VÃ¦lge styklistevare',0),(261487,7264,'ko','BOM í•­ëª© ì„ íƒ',0),(261488,7264,'he','×‘×—×¨ ×¤×¨×™×˜ BOM',0),(261489,7264,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ ÎµÎ¯Î´Î¿Ï‚ Ï„ÎµÏ‡Î½Î¹ÎºÎ®Ï‚ Î ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚',0),(261490,7264,'zh','é€‰æ‹©ææ–™æ¸…å•çš„é¡¹ç›®\r\n',0),(261491,7264,'sv','VÃ¤lj strukturlisteartikeln',0),(261492,7264,'it','Selezionare la voce di BOM',0),(261493,7264,'tl','',0),(261494,7264,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; BOM',0),(261495,7264,'hi','BOM à¤†à¤‡à¤Ÿà¤® à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(261496,7264,'ms','Pilih BOM Item',0),(261497,7264,'ar','Ø­Ø¯Ø¯ ØµÙ†Ù Ø´Ø¬Ø±Ø© Ø§Ù„Ù…ÙˆØ§Ø¯',0),(261498,7264,'fr','SÃ©lectionnez l\'article de nomenclature',0),(261499,7264,'jp','BOM å“ç›®ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(261500,7264,'pt','Selecione o Item BOM',0),(261501,7264,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÐ½ÐºÐ»Ð°Ñ‚ÑƒÑ€Ñ‹',0),(261502,7264,'es','Seleccionar Item BOM',0),(261503,7264,'de','WÃ¤hlen Sie die StÃ¼cklistenposition',0),(261504,7264,'en','Select BOM Item',0),(261505,7265,'is','',0),(261506,7265,'dr','= Ø¨Ù„Ù‡ ',0),(261507,7265,'pr','Ø¬Ù‡Øª Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ÙŠ Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯  Ø§Ø² Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø«Ø¨Øª ÙƒØ§Ù„Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ Ùˆ ÙƒØ§Ù„Ø§ÙŠ Ù…Ø±ÙƒØ¨ Ø±Ø§ Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ = Ø¨Ù„Ù‡ ',0),(261508,7265,'tr','Yeni Ã¼rÃ¼n ReÃ§etesi maddesi eklemek iÃ§in madde giriÅŸi Update kullanÄ±n ve bileÅŸik Ã¶ÄŸeyi kullanÄ±ma = Evet kutusu',0),(261509,7265,'pl','Aby dodaÄ‡ nowy towar BOM, element wprowadzania aktualizacji i sprawdÅº zÅ‚oÅ¼ony element = pole tak',0),(261510,7265,'bg','Ð—Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð¾Ð² ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ ÐšÐ˜, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð·Ð°Ð¿Ð¸Ñ Update Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÑÑŠÑÑ‚Ð°Ð²Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° = Ð´Ð° ÐºÑƒÑ‚Ð¸Ñ',0),(261511,7265,'ur','Ø¨Ø§Ù… Ú©ÛŒ Ù†Ø¦ÛŒ Ø´Û’ Ú©Û’ Ø§Ø¶Ø§ÙÛ’ Ú©Û’ Ù„ÛŒÛ’ Ø´Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø¬Ø§Ù…Ø¹ Ø´Û’ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº ÛØ§Úº Ø®Ø§Ù†Û =',0),(261512,7265,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð½Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ, ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð£Ð¿Ð´Ð°Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸ ÑÐ»Ð¾Ð¶ÐµÐ½Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» = Ð´Ð° ÐºÑƒÑ‚Ð¸Ñ˜Ð°',0),(261513,7265,'vi','Äá»ƒ Nháº­p Má»¥c BOM má»›i sá»­ dá»¥ng Cáº­p Nháº­t Entry HÃ ng & Ä‘Ã¡nh dáº¥u há»™p Composite Item=Yes',0),(261514,7265,'af','Om\'n nuwe BOM Item te skep, gebruik Iteminskrywing Opdatering en merk die Saamstellingitem=Ja boksie',0),(261515,7265,'ro','Pentru a adÄƒuga noi articolul LM, utilizaÅ£i actualizare la intrare ÅŸi verifica compozit element = da caseta',0),(261516,7265,'et','Uue Koosluse kauba lisamiseks kasutada kauba kanne Update ja kontrollige komposiit kirje = Jah kast',0),(261517,7265,'si','Dodati nov artikel Kosovnice, uporabite element vnos posodobitev in preverite kompozitni element = Yes polje',0),(261518,7265,'ba','Untuk menambahkan Item BOM baru, gunakan Item masuk pembaruan dan memeriksa Item komposit = ya kotak',0),(261519,7265,'nl','Om toe te voegen nieuwe stuklijstartikel, gebruik Item Entry Update en controleer samengestelde Item = ja box',0),(261520,7265,'fi','LisÃ¤Ã¤ uusi tuoterakennenimike kohteen merkintÃ¤ Update ja tarkista komposiitti kohde = kyllÃ¤ laatikko',0),(261521,7265,'no','For Ã¥ legge til nye stykklistevaren, bruke elementet oppfÃ¸ringen oppdatering og sjekk sammensatt element = Ja-boksen',0),(261522,7265,'da','For at tilfÃ¸je nye styklistevare, bruge varen post opdatering og kontrollere sammensat vare = ja boks',0),(261523,7265,'ko','ìƒˆë¡œìš´ BOM í•­ëª© ì¶”ê°€, í•­ëª© í•­ëª© ì—…ë°ì´íŠ¸ë¥¼ ì‚¬ìš© í•˜ ê³  ë³µí•© í•­ëª©ì„ ì²´í¬ = ì˜ˆ ìƒìž',0),(261524,7265,'he','×›×“×™ ×œ×”×•×¡×™×£ ×¤×¨×™×˜ BOM ×”×—×“×©, ×œ×”×©×ª×ž×© ×‘×¢×“×›×•×Ÿ ×”×¤×•×¡×˜ ×¤×¨×™×˜ ×•×œ×‘×“×•×§ ×¤×¨×™×˜ ×ž×•×¨×›×‘ = ×ª×™×‘×ª. ×›×Ÿ',0),(261525,7265,'el','Î“Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï„Î¿ Î½Î­Î¿ ÎµÎ¯Î´Î¿Ï‚ Ï„ÎµÏ‡Î½Î¹ÎºÎ®Ï‚ Î ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚, Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î­Î½Î±ÏÎ¾Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÎ±Î¹ ÎµÎ»Î­Î³Î¾Ï„Îµ Ï„Î¿ ÏƒÏÎ½Î¸ÎµÏ„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ = Î½Î±Î¹ ÎºÎ¿Ï',0),(261526,7265,'zh','è¦æ·»åŠ æ–°çš„ç‰©æ–™æ¸…å•é¡¹ç›®ï¼Œä½¿ç”¨é¡¹ç›®æ¡ç›®æ›´æ–°ï¼Œå¹¶æ£€æŸ¥ç»¼åˆé¡¹ç›®=â€œæ˜¯â€é€‰é¡¹æ¡†',0),(261527,7265,'sv','LÃ¤gg till nya strukturlisteartikeln, anvÃ¤nda objektet post uppdatera och kontrollera sammansatt objekt = ja lÃ¥da',0),(261528,7265,'it','Per aggiungere il nuovo elemento BOM, utilizzare elemento voce aggiornamento e verifica elemento composito = scatola sÃ¬',0),(261529,7265,'tl','',0),(261530,7265,'th','To add new BOM Item, use Item Entry Update and check Composite Item=Yes box',0),(261531,7265,'hi','à¤¨à¤ˆ BOM à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤¸à¤®à¤—à¥à¤° à¤†à¤‡à¤Ÿà¤® à¤šà¥‡à¤• à¤¬à¥‰à¤•à¥à¤¸ à¤¹à¤¾à¤ =',0),(261532,7265,'ms','Untuk menambah Item BOM baru, gunakan Item masuk Update dan menyemak butiran komposit = Peti Ya',0),(261533,7265,'ar','Ù„Ø¥Ø¶Ø§ÙØ© \"Ø¨Ù†Ø¯\" Ø¬Ø¯ÙŠØ¯ ÙÙŠ Ø´Ø¬Ø±Ø©ØŒ Ø§Ø³ØªØ®Ø¯Ø§Ù… \"Ø¹Ù†ØµØ± Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„ØªØ­Ø¯ÙŠØ«\" ÙˆØªØ­Ù‚Ù‚ \"Ø¹Ù†ØµØ± Ù…Ø±ÙƒØ¨\" = Ù…Ø±Ø¨Ø¹ Ù†Ø¹Ù…',0),(261534,7265,'fr','Pour ajouter un nouvel Ã©lÃ©ment BOM, utilisez point entrÃ©e mise Ã  jour et vÃ©rifier l\'Ã©lÃ©ment Composite = Yes box',0),(261535,7265,'jp','æ–°ã—ã„ BOM å“ç›®ã‚’è¿½åŠ ã™ã‚‹ã‚¢ã‚¤ãƒ†ãƒ  ã‚¨ãƒ³ãƒˆãƒªã®æ›´æ–°ã‚’ä½¿ç”¨ã—ã¦é …ç›®ã‚’ç¢ºèªã—ã¾ã™è¤‡åˆ = ã¯ã„ãƒœãƒƒã‚¯ã‚¹',0),(261536,7265,'pt','Para adicionar novo Item BOM, usar a atualizaÃ§Ã£o de entrada de Item e verifique Item composto = Sim caixa',0),(261537,7265,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð² ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿ÑƒÐ½ÐºÑ‚ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÑÐ¾ÑÑ‚Ð°Ð²Ð½Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° = Ð´Ð° ÐºÐ¾Ñ€Ð¾Ð±ÐºÐ°',0),(261538,7265,'es','Para agregar nuevo item de BOM, usa Actualizar Entrada de Item y checar la caja de Item Compuesto=Si',0),(261539,7265,'de','FÃ¼gen Sie neue StÃ¼cklistenposition, Element Eintrag aktualisieren und prÃ¼fen zusammengesetzte Element = Yes Box',0),(261540,7265,'en','To add new BOM Item, use Item Entry Update and check Composite Item=Yes box',0),(261541,7266,'is','',0),(261542,7266,'dr','Ø¨Ø§Ù„Ø§',0),(261543,7266,'pr','Ø¨Ø§Ù„Ø§',0),(261544,7266,'tr','YukarÄ±',0),(261545,7266,'pl','SiÄ™',0),(261546,7266,'bg','ÐÐ°Ð³Ð¾Ñ€Ðµ',0),(261547,7266,'ur','Ø§Ù¾',0),(261548,7266,'sr','Ð“Ð¾Ñ€Ðµ',0),(261549,7266,'vi','LÃªn',0),(261550,7266,'af','Op',0),(261551,7266,'ro','Sus',0),(261552,7266,'et','Ãœles',0),(261553,7266,'si','Up',0),(261554,7266,'ba','Up',0),(261555,7266,'nl','Omhoog',0),(261556,7266,'fi','YlÃ¶s',0),(261557,7266,'no','Opp',0),(261558,7266,'da','Op',0),(261559,7266,'ko','ìµœëŒ€',0),(261560,7266,'he','×œ×ž×¢×œ×”',0),(261561,7266,'el','Î•Ï€Î¬Î½Ï‰',0),(261562,7266,'zh','ä¸Š\r\n',0),(261563,7266,'sv','Upp',0),(261564,7266,'it','Fino',0),(261565,7266,'tl','',0),(261566,7266,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3638;&#3657;&#3609;',0),(261567,7266,'hi','à¤…à¤ª',0),(261568,7266,'ms','Sehingga',0),(261569,7266,'ar','Ø­ØªÙ‰',0),(261570,7266,'fr','Vers le haut',0),(261571,7266,'jp','ã‚¢ãƒƒãƒ—',0),(261572,7266,'pt','Up',0),(261573,7266,'ru','Ð’Ð²ÐµÑ€Ñ…',0),(261574,7266,'es','Arriba',0),(261575,7266,'de','Bis',0),(261576,7266,'en','Up',0),(261577,7267,'is','',0),(261578,7267,'dr','(Ù‚Ø§Ù„Ø¨ÙŠ ÙƒÙ‡ Ù„ÙŠØ³Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§ ØªØ¨ Ø§Ø² Ù‡Ù… Ø¬Ø¯Ø§ Ø´Ø¯Ù‡ ',0),(261579,7267,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ù‚Ø§Ù„Ø¨ Ù…ØªÙ† (Ù‚Ø§Ù„Ø¨ÙŠ ÙƒÙ‡ Ù„ÙŠØ³Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§ ØªØ¨ Ø§Ø² Ù‡Ù… Ø¬Ø¯Ø§ Ø´Ø¯Ù‡ ',0),(261580,7267,'tr','URL dosyasÄ±nÄ±n metin (sekmeyle ayrÄ±lmÄ±ÅŸ biÃ§imde)',0),(261581,7267,'pl','Adres URL pliku tekst (rozdzielany znakami tabulacji formatu)',0),(261582,7267,'bg','URL Ñ„Ð°Ð¹Ð» Ð·Ð° Ñ‚ÐµÐºÑÑ‚ (Ñ‚Ð°Ð±ÑƒÐ»Ð°Ñ‚Ð¾Ñ€Ð¸ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚)',0),(261583,7267,'ur','Ù…ØªÙ† (ÙˆØ¶Ø¹ Ø¬Ø¯ÙˆÙ„ ØªØ­Ø¯ÛŒØ¯ÛŒ) Ú©Û’ Ù„ÛŒÛ’ URL Ù…Ø³Ù„',0),(261584,7267,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ñ‚ÐµÐºÑÑ‚ (Ñ€Ð°Ð·Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½ Ñ‚Ð°Ð±ÑƒÐ»Ð°Ñ‚Ð¾Ñ€Ð¾Ð¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚)',0),(261585,7267,'vi','ÄÆ°á»ng dáº«n Há»“ sÆ¡ cho ná»™i dung (dáº¥u tÃ¡ch-)',0),(261586,7267,'af','BA (\"URL\")/LÃªer vir Teks (tabuleer gedelimineerde formaat)',0),(261587,7267,'ro','URL-ul de fiÅŸier pentru Text (cu separator tab format)',0),(261588,7267,'et','URL faili tekst (tabelduskohaga formaat)',0),(261589,7267,'si','URL datoteke za besedilo (obliki s tabulatorji)',0),(261590,7267,'ba','URL file teks (tab-delimited format)',0),(261591,7267,'nl','Bestand met URL voor tekst (door tabs gescheiden indeling)',0),(261592,7267,'fi','URL tiedosto teksti (sarkainerotin muodossa)',0),(261593,7267,'no','URL-filen for tekst (tabulatordelt format)',0),(261594,7267,'da','URL file for tekst (tabulatorsepareret format)',0),(261595,7267,'ko','í…ìŠ¤íŠ¸ (íƒ­ êµ¬ë¶„ í˜•ì‹) íŒŒì¼ URL',0),(261596,7267,'he','×›×ª×•×‘×ª url ×©×œ ×§×•×‘×¥ ×˜×§×¡×˜ (×ž×•×¤×¨×“ ×‘××ž×¦×¢×•×ª ×˜××‘×™× ×ª×‘× ×™×ª)',0),(261597,7267,'el','URL Î±ÏÏ‡ÎµÎ¯Î¿Ï… ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… (Î¼Î¿ÏÏ†Î® Î¿ÏÎ¹Î¿Î¸ÎµÏ„Î·Î¼Î­Î½Î· Î¼Îµ ÏƒÏ„Î·Î»Î¿Î¸Î­Ï„ÎµÏ‚)',0),(261598,7267,'zh','æ–‡æœ¬ç½‘å€æ–‡ä»¶ï¼ˆåˆ¶è¡¨ç¬¦åˆ†éš”çš„æ ¼å¼ï¼‰\r\n',0),(261599,7267,'sv','URL-filen fÃ¶r Text (tabbavgrÃ¤nsat format)',0),(261600,7267,'it','File URL per il testo (formato delimitato da tabulazioni)',0),(261601,7267,'tl','',0),(261602,7267,'th','URL &#3652;&#3615;&#3621;&#3660;&#3586;&#3629;&#3591;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(261603,7267,'hi','à¤ªà¤¾à¤  (à¤Ÿà¥ˆà¤¬-à¤¸à¥€à¤®à¤¾à¤‚à¤•à¤¿à¤¤ à¤¸à¥à¤µà¤°à¥‚à¤ª) à¤•à¥‡ à¤²à¤¿à¤ URL à¤«à¤¼à¤¾à¤‡à¤²',0),(261604,7267,'ms','URL fail teks (format tab-delimited)',0),(261605,7267,'ar','Ù…Ù„Ù URL Ù„Ù†Øµ (Ù…Ø­Ø¯Ø¯ Ø¨Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¨ÙˆÙŠØ¨ ØªÙ†Ø³ÙŠÙ‚)',0),(261606,7267,'fr','Fichier URL de texte (format dÃ©limitÃ© par des tabulations)',0),(261607,7267,'jp','URL ãƒ†ã‚­ã‚¹ãƒˆ ï¼ˆã‚¿ãƒ–åŒºåˆ‡ã‚Šå½¢å¼ï¼‰ ãƒ•ã‚¡ã‚¤ãƒ«',0),(261608,7267,'pt','Arquivo URL para texto (formato delimitado por tabulaÃ§Ã£o)',0),(261609,7267,'ru','URL-Ð°Ð´Ñ€ÐµÑ Ñ„Ð°Ð¹Ð»Ð° Ð´Ð»Ñ Ñ‚ÐµÐºÑÑ‚Ð° (Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ñ Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑÐ¼Ð¸ Ñ‚Ð°Ð±ÑƒÐ»ÑÑ†Ð¸Ð¸)',0),(261610,7267,'es','URL File para texto(formato de tab-delimitado)',0),(261611,7267,'de','URL-Datei fÃ¼r Text (tabulatorgetrennten Format)',0),(261612,7267,'en','URL file for Text(tab-delimited format)',0),(261613,7268,'is','',0),(261614,7268,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø³Ù…Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(261615,7268,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø³Ù…Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(261616,7268,'tr','SatÄ±cÄ± parÃ§a numarasÄ±',0),(261617,7268,'pl','Numer katalogowy producenta',0),(261618,7268,'bg','Ð§Ð°ÑÑ‚ Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ñ€Ð¸ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(261619,7268,'ur','ÙˆÛŒÙ†ÚˆØ± Ø­ØµÛ Ù†Ù…Ø¨Ø±',0),(261620,7268,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð´ÐµÐ»Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð°',0),(261621,7268,'vi','Sá»‘ phá»¥ tÃ¹ng NgÆ°á»i bÃ¡n',0),(261622,7268,'af','Verskaffer Onderdele Nommer',0),(261623,7268,'ro','NumÄƒrul de parte furnizorului',0),(261624,7268,'et','Hankija osa Number',0),(261625,7268,'si','Dobavitelj KataloÅ¡ka Å¡tevilka',0),(261626,7268,'ba','Nomor bagian Penjual',0),(261627,7268,'nl','Onderdeelnummer leverancier',0),(261628,7268,'fi','Toimittajan osanumero',0),(261629,7268,'no','Selgerens artikkelnummer',0),(261630,7268,'da','LeverandÃ¸rartikelnummer',0),(261631,7268,'ko','ê³µê¸‰ ì—…ì²´ ë¶€í’ˆ ë²ˆí˜¸',0),(261632,7268,'he','×ž×¡×¤×¨ ×—×œ×§ ×©×œ ×¡×¤×§',0),(261633,7268,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÏƒÎµÎ¹ÏÎ¬Ï‚ Ï€Ï‰Î»Î·Ï„Î®',0),(261634,7268,'zh','ä¾›åº”å•†éƒ¨ä»¶ç¼–å·\r\n',0),(261635,7268,'sv','LeverantÃ¶rens artikelnummer',0),(261636,7268,'it','Numero di parte Fornitore',0),(261637,7268,'tl','',0),(261638,7268,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(261639,7268,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤­à¤¾à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(261640,7268,'ms','Nombor bahagian penjual.',0),(261641,7268,'ar','Ø±Ù‚Ù… Ø¬Ø²Ø¡ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(261642,7268,'fr','NumÃ©ro de piÃ¨ce du vendeur',0),(261643,7268,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ãƒ‘ãƒ¼ãƒ„ç•ªå·',0),(261644,7268,'pt','NÃºmero de peÃ§a do fornecedor',0),(261645,7268,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(261646,7268,'es','Proveedor NÃºmero de Parte',0),(261647,7268,'de','Hersteller-Teilenummer',0),(261648,7268,'en','Vendor Part Number',0),(261649,7269,'is','',0),(261650,7269,'dr','ÙƒØ¯ Ù…Ø­ØµÙˆÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(261651,7269,'pr','ÙƒØ¯ Ù…Ø­ØµÙˆÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(261652,7269,'tr','SatÄ±cÄ± Ã¼rÃ¼n kodu',0),(261653,7269,'pl','Kod produktu dostawcy',0),(261654,7269,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(261655,7269,'ur','ÙˆÛŒÙ†ÚˆØ± Ù¾Ø±ÙˆÚˆÚ©Ù¹ Ú©ÙˆÚˆ',0),(261656,7269,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(261657,7269,'vi','MÃ£ sáº£n pháº©m NgÆ°á»i bÃ¡n',0),(261658,7269,'af','Verskaffer Produkkode',0),(261659,7269,'ro','Cod de produs furnizor',0),(261660,7269,'et','Tarnija tootekood',0),(261661,7269,'si','Koda artikla dobavitelja',0),(261662,7269,'ba','Kode produk vendor',0),(261663,7269,'nl','Leverancier productcode',0),(261664,7269,'fi','Toimittajan Tuotekoodi',0),(261665,7269,'no','Produktkoden for leverandÃ¸r',0),(261666,7269,'da','Kreditorkoden produkt',0),(261667,7269,'ko','ê³µê¸‰ ì—…ì²´ ì œí’ˆ ì½”ë“œ',0),(261668,7269,'he','×§×•×“ ×ž×•×¦×¨ ×©×œ ×¡×¤×§',0),(261669,7269,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚',0),(261670,7269,'zh','ä¾›åº”å•†äº§å“ä»£ç \r\n',0),(261671,7269,'sv','LeverantÃ¶rens produktkod',0),(261672,7269,'it','Codice prodotto Fornitore',0),(261673,7269,'tl','',0),(261674,7269,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3621;&#3636;&#3605;&#3616;&#3633;&#3603;&#3601;&#3660;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(261675,7269,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤•à¥‹à¤¡',0),(261676,7269,'ms','Kod produk pembekal',0),(261677,7269,'ar','Ø±Ù…Ø² Ù…Ù†ØªØ¬ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(261678,7269,'fr','Code de produit du vendeur',0),(261679,7269,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼è£½å“ã‚³ãƒ¼ãƒ‰',0),(261680,7269,'pt','CÃ³digo de produto do fornecedor',0),(261681,7269,'ru','ÐšÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(261682,7269,'es','Proveedor NÃºmero de Compra',0),(261683,7269,'de','Hersteller-Produkt-Code',0),(261684,7269,'en','Vendor Product Code',0),(261685,7270,'is','',0),(261686,7270,'dr','Ù„ÙŠØ³Øª Ù…Ø´Ø®ØµØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ§Ø¯',0),(261687,7270,'pr','Ù„ÙŠØ³Øª Ù…Ø´Ø®ØµØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ§Ø¯',0),(261688,7270,'tr','Malzeme tanÄ±mÄ± listesinde Bill',0),(261689,7270,'pl','Bill lista definicji materiaÅ‚Ã³w',0),(261690,7270,'bg','ÐšÐ¾Ð¼Ð¿Ð»ÐµÐºÑÐ½Ð¾ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ ÑÐ¿Ð¸ÑÑŠÐº Ñ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ð¸',0),(261691,7270,'ur','Ù…ÙˆØ§Ø¯ ØªØ¹Ø±ÛŒÙ ÙÛØ±Ø³Øª Ú©Û’ Ø¨Ù„',0),(261692,7270,'sr','Ð‘Ð¸Ð» Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð° Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð° Ð»Ð¸ÑÑ‚Ðµ',0),(261693,7270,'vi','Danh SÃ¡ch HÃ³a ÄÆ¡n NguyÃªn Váº­t Liá»‡u',0),(261694,7270,'af','Materiaallys - Lys van Definisies',0),(261695,7270,'ro','Proiectul de lege a listei de definiÅ£ia materialelor',0),(261696,7270,'et','Materjalide mÃ¤Ã¤ratlus List Bill',0),(261697,7270,'si','Bill definicijo seznama materialov',0),(261698,7270,'ba','Bill bahan definisi daftar',0),(261699,7270,'nl','Bill van materialen Definitielijst',0),(261700,7270,'fi','Bill mÃ¤Ã¤ritelmÃ¤ luettelo',0),(261701,7270,'no','Bill av materiale definisjonsliste',0),(261702,7270,'da','Bill af materiale definitionsliste',0),(261703,7270,'ko','ë¹Œ ìž¬ë£Œ ì •ì˜ ëª©ë¡',0),(261704,7270,'he','×‘×™×œ ×”×’×“×¨×ª ×¨×©×™×ž×”',0),(261705,7270,'el','Bill Ï…Î»Î¹ÎºÎ¬ Î¿ÏÎ¹ÏƒÎ¼ÏŒÏ‚ ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï…',0),(261706,7270,'zh','æ¡ä¾‹è‰æ¡ˆçš„å®šä¹‰ææ–™æ¸…å•\r\n',0),(261707,7270,'sv','Bill Definition lista',0),(261708,7270,'it','Distinta dei materiali definizione elenco',0),(261709,7270,'tl','',0),(261710,7270,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3610;&#3636;&#3621;&#3586;&#3629;&#3591;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(261711,7270,'hi','à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾ à¤¸à¥‚à¤šà¥€ à¤¸à¤¾à¤®à¤—à¥à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¤¾ à¤¬à¤¿à¤²',0),(261712,7270,'ms','Bil senarai takrif bahan',0),(261713,7270,'ar','Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ù„Ù„Ù…ÙˆØ§Ø¯ ØªØ¹Ø±ÙŠÙ Ù‚Ø§Ø¦Ù…Ø©',0),(261714,7270,'fr','Projet de loi de matÃ©riaux dÃ©finition liste',0),(261715,7270,'jp','ææ–™å®šç¾©ãƒªã‚¹ãƒˆã®æ³•æ¡ˆ',0),(261716,7270,'pt','Bill da definiÃ§Ã£o de lista de materiais',0),(261717,7270,'ru','Ð‘Ð¸Ð»Ð» Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð² Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ°',0),(261718,7270,'es','Lista de Materiales Lista de Definiciones',0),(261719,7270,'de','Bill der Definition StÃ¼ckliste',0),(261720,7270,'en','Bill of Materials Definition List',0),(261721,7271,'is','',0),(261722,7271,'dr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨  ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†ÙŠ Ø¯Ø± Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ ØªÙ‡ÙŠÙ‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(261723,7271,'pr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨  ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†ÙŠ Ø¯Ø± Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ ØªÙ‡ÙŠÙ‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(261724,7271,'tr','HiÃ§bir komisyon GL hesabÄ± BorÃ§lar Kurulumu iÃ§inde ayarlanÄ±r',0),(261725,7271,'pl','Nie konta k/g Komisja jest ustawiona w zobow',0),(261726,7271,'bg','ÐÑÐ¼Ð° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ðµ Ñ€Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½ Ð² Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(261727,7271,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ù…ÛŒØ´Ù† Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…ÛŒÚº Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø³ÛŒÙ¹ Ø§Ù¾ Ø³ÛŒÙ¹ ÛÛ’',0),(261728,7271,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ñƒ Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½ Ñƒ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(261729,7271,'vi','Setup TK Pháº£i Tráº£ khÃ´ng bao gá»“m TK Sá»• CÃ¡i Tá»•ng Há»£p Cho Hoa Há»“ng',0),(261730,7271,'af','Geen AG Kommissie Rekening is opgestel in Betaalbaar Opstelling ',0),(261731,7271,'ro','Nici Comisia GL contul este setat Ã®n Parametrizare cumpÄƒrÄƒri ÅŸi datorii',0),(261732,7271,'et','Arvesse komisjoni GL asub ostuvÃµlgade seadistamine',0),(261733,7271,'si','Nikakor ne GL Komisija iz obveznosti Setup',0),(261734,7271,'ba','Tidak ada komisi GL rekening terletak di hutang Setup',0),(261735,7271,'nl','Geen Commissie GL Account is ingesteld in de Inkoopinstellingen',0),(261736,7271,'fi','MissÃ¤Ã¤n komission GL on mÃ¤Ã¤ritetty ostojen ja ostovelkojen asetukset',0),(261737,7271,'no','Ingen GL konto ligger i KjÃ¸psoppsett',0),(261738,7271,'da','Ingen Kommissionen GL konto er indstillet i KÃ¸bsopsÃ¦tning',0),(261739,7271,'ko','ìœ„ì›íšŒ GL ê³„ì • ì—†ìŒ ë¯¸ì§€ê¸‰ê¸ˆ ì„¤ì •ì—ì„œ ì„¤ì • ë˜ì–´',0),(261740,7271,'he','××™×Ÿ ×—×©×‘×•×Ÿ GL ×”× ×¦×™×‘×•×ª ×ž×•×’×“×¨ ×‘×›×™×•×•× ×•×Ÿ ×–×›××™×',0),(261741,7271,'el','ÎˆÏ‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ ÎºÎ±Î¼Î¯Î± Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» ÏƒÏ„Î·Î½ Î Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(261742,7271,'zh','æ— ä½£é‡‘æ€»å¸å¸æˆ·è®¾ç½®åœ¨åº”ä»˜æ¬¾è®¾ç½®ä¸­\r\n',0),(261743,7271,'sv','Ingen kommissionen GL konto Ã¤r instÃ¤llt i InkÃ¶psinstÃ¤llningar',0),(261744,7271,'it','Nessuna Commissione GL Account Ã¨ impostato nel Setup contabilitÃ  fornitori',0),(261745,7271,'tl','',0),(261746,7271,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3',0),(261747,7271,'hi','à¤•à¥‹à¤ˆ à¤†à¤¯à¥‹à¤— GL à¤–à¤¾à¤¤à¤¾ Payables à¤¸à¥‡à¤Ÿà¤…à¤ª à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(261748,7271,'ms','Tiada akaun GL Suruhanjaya terletak dalam persediaan pemiutang',0),(261749,7271,'ar','ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù„Ø§ \"Ø­Ø³Ø§Ø¨ GL Ø§Ù„Ù„Ø¬Ù†Ø©\" ÙÙŠ \"Ø¥Ø¹Ø¯Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹\"',0),(261750,7271,'fr','Aucun compte GL de Commission nâ€™est dÃ©fini dans les paramÃ¨tres',0),(261751,7271,'jp','å‚µå‹™ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã§å§”å“¡ä¼š GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(261752,7271,'pt','Nenhuma ComissÃ£o GL conta Ã© definida na configuraÃ§Ã£o de contas a pagar',0),(261753,7271,'ru','ÐÐµÑ‚ ÑÑ‡ÐµÑ‚Ð° GL ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ ÑƒÑÑ‚Ð°Ð½Ð°Ð²Ð»Ð¸Ð²Ð°ÐµÑ‚ÑÑ Ð² Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°Ñ… ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(261754,7271,'es','Cuenta de LM Comisiones no esta Configurado en la ConfiguraciÃ³n de Proveedores',0),(261755,7271,'de','Keine Kommission Fibukonto ist im Verbindlichkeiten Setup eingestellt.',0),(261756,7271,'en','No Commission GL Account is set in Payables Setup',0),(261757,7272,'is','',0),(261758,7272,'dr','Ù†Ù…Ø¨Ø± Ù‚Ø¨Ù„ÙŠ â€“ Ø§Ú¯Ø±, ',0),(261759,7272,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù‚Ø¨Ù„ÙŠ â€“ Ø§Ú¯Ø±, \r\n Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(261760,7272,'tr','Eski kimlik, eÄŸer QB',0),(261761,7272,'pl','Stary identyfikator, jeÅ›li QB',0),(261762,7272,'bg','Ð¡Ñ‚Ð°Ñ€Ð¸Ñ ID, Ð°ÐºÐ¾ QB',0),(261763,7272,'ur','Ù¾Ø±Ø§Ù†Û’ Ø´Ù†Ø§Ø®ØªØŒ Ø§Ú¯Ø± Ù‚Ø¨',0),(261764,7272,'sr','Ð¡Ñ‚Ð°Ñ€Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°, Ð°ÐºÐ¾ Ð‘ÐµÐº',0),(261765,7272,'vi','ID cÅ© náº¿u QB',0),(261766,7272,'af','Ou ID, as QB',0),(261767,7272,'ro','Vechiul ID, dacÄƒ QB',0),(261768,7272,'et','Vana ID, kui QB',0),(261769,7272,'si','Old ID, Äe QB',0),(261770,7272,'ba','Lama ID, jika QB',0),(261771,7272,'nl','Oude ID, als QB',0),(261772,7272,'fi','Vanha tunnus, jos QB',0),(261773,7272,'no','Gammel ID, hvis QB',0),(261774,7272,'da','Gamle ID, hvis QB',0),(261775,7272,'ko','ì˜¤ëž˜ ëœ ID ì¼ ê²½ìš° ì¿¼í„° ë°±',0),(261776,7272,'he','×œ×–×”×•×ª ×”×™×©× ×”, ×× QB',0),(261777,7272,'el','Î Î±Î»Î¹Î¬ ID, ÎµÎ¬Î½ QB',0),(261778,7272,'zh','æ—§èº«ä»½è¯ï¼Œå¦‚æžœQuickBookç³»åˆ—\r\n',0),(261779,7272,'sv','Gamla ID, om QB',0),(261780,7272,'it','Vecchio ID, se QB',0),(261781,7272,'tl','',0),(261782,7272,'th','&#3619;&#3627;&#3633;&#3626;&#3648;&#3585;&#3656;&#3634;, &#3606;&#3657;&#3634; QB',0),(261783,7272,'hi','à¤ªà¥à¤°à¤¾à¤¨à¥€ à¤†à¤ˆà¤¡à¥€, à¤¯à¤¦à¤¿ QB',0),(261784,7272,'ms','ID lama, jika QB',0),(261785,7272,'ar','Ø§Ù„Ù…Ø¹Ø±Ù Ø§Ù„Ù‚Ø¯ÙŠÙ…ØŒ Ø¥Ø°Ø§ QB',0),(261786,7272,'fr','Ancien ID, si QB',0),(261787,7272,'jp','å¤ã„ ID ã‚’å ´åˆ QB',0),(261788,7272,'pt','Velho ID, se QB',0),(261789,7272,'ru','Ð¡Ñ‚Ð°Ñ€Ñ‹Ð¹ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€, ÐµÑÐ»Ð¸ QB',0),(261790,7272,'es','ID Antiguo, si QB',0),(261791,7272,'de','Alten Ausweis, wenn QB',0),(261792,7272,'en','Old ID, if QB',0),(261793,7273,'is','',0),(261794,7273,'dr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(261795,7273,'pr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(261796,7273,'tr','Fatura Ã¶deme oluÅŸtur',0),(261797,7273,'pl','Tworzenie pÅ‚atnoÅ›ci faktury',0),(261798,7273,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(261799,7273,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(261800,7273,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(261801,7273,'vi','Táº¡o hÃ³a Ä‘Æ¡n thanh toÃ¡n',0),(261802,7273,'af','Skep Faktuurbetaling',0),(261803,7273,'ro','Crea plati facturi',0),(261804,7273,'et','Loo arve tasumine',0),(261805,7273,'si','Ustvarite raÄun plaÄila',0),(261806,7273,'ba','Membuat faktur pembayaran',0),(261807,7273,'nl','Factuur maken',0),(261808,7273,'fi','Luo lasku',0),(261809,7273,'no','Opprette fakturabetalingen',0),(261810,7273,'da','Oprette fakturabetaling',0),(261811,7273,'ko','ì†¡ìž¥ ì§€ë¶ˆ ë§Œë“¤ê¸°',0),(261812,7273,'he','×œ×™×¦×•×¨ ×—×©×‘×•× ×™×ª ×ª×©×œ×•×',0),(261813,7273,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(261814,7273,'zh','åˆ›å»ºå‘ç¥¨ä»˜æ¬¾\r\n',0),(261815,7273,'sv','Skapa fakturabetalning',0),(261816,7273,'it','Creare la fattura di pagamento',0),(261817,7273,'tl','',0),(261818,7273,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(261819,7273,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¬à¤¨à¤¾à¤à¤',0),(261820,7273,'ms','Membuat pembayaran invois',0),(261821,7273,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¯ÙØ¹',0),(261822,7273,'fr','CrÃ©er le paiement de la facture',0),(261823,7273,'jp','è«‹æ±‚æ›¸ã®æ”¯æ‰•ã„ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(261824,7273,'pt','Criar o pagamento da fatura',0),(261825,7273,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð°',0),(261826,7273,'es','Crear Pago de Factura',0),(261827,7273,'de','Erstellen Rechnung Zahlung',0),(261828,7273,'en','Create Invoice Payment',0),(261829,7274,'is','',0),(261830,7274,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(261831,7274,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(261832,7274,'tr','Ã–denecek oluÅŸturun',0),(261833,7274,'pl','Tworzenie pÅ‚atne',0),(261834,7274,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸Ñ‚Ðµ',0),(261835,7274,'ur','Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(261836,7274,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(261837,7274,'vi','Táº¡o Má»›i TK Pháº£i Tráº£',0),(261838,7274,'af','Skep betaalbaar',0),(261839,7274,'ro','Crea plÄƒtit',0),(261840,7274,'et','Loo makstav',0),(261841,7274,'si','Ustvarite plaÄa',0),(261842,7274,'ba','Membuat dibayarkan',0),(261843,7274,'nl','Maken te betalen',0),(261844,7274,'fi','Luo ostoreskontran',0),(261845,7274,'no','Opprette betales',0),(261846,7274,'da','Oprette betales',0),(261847,7274,'ko','ì§€ê¸‰ ìƒì„±',0),(261848,7274,'he','×œ×™×¦×•×¨ ×–×›××™×',0),(261849,7274,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î»Î·ÏÏ‰Ï„Î­Î±',0),(261850,7274,'zh','åˆ›å»ºåº”ä»˜\r\n',0),(261851,7274,'sv','Skapa betalas',0),(261852,7274,'it','Creare pagabile',0),(261853,7274,'tl','',0),(261854,7274,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(261855,7274,'hi','à¤¦à¥‡à¤¯ à¤¬à¤¨à¤¾à¤à¤',0),(261856,7274,'ms','Mencipta dibayar',0),(261857,7274,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø¯ÙØ¹',0),(261858,7274,'fr','CrÃ©erez',0),(261859,7274,'jp','è²·æŽ›é‡‘ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(261860,7274,'pt','Criar pagÃ¡vel',0),(261861,7274,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(261862,7274,'es','Crear Pagable',0),(261863,7274,'de','Erstellen Sie zu zahlenden',0),(261864,7274,'en','Create Payable',0),(261865,7275,'is','',0),(261866,7275,'dr','Ø«Ø¨Øª Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(261867,7275,'pr','Ø«Ø¨Øª Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(261868,7275,'tr','GÃ¼nlÃ¼k girdisi',0),(261869,7275,'pl','Wpis do dziennika',0),(261870,7275,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(261871,7275,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(261872,7275,'sr','Ð£Ð½Ð¾Ñ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸Ðº',0),(261873,7275,'vi','Nháº­p BÃºt ToÃ¡n',0),(261874,7275,'af','Joernaalinskrywing',0),(261875,7275,'ro','Intrare Ã®n jurnal',0),(261876,7275,'et','TÃ¶Ã¶lehe kanne',0),(261877,7275,'si','Vnos v dnevnik',0),(261878,7275,'ba','Entri jurnal',0),(261879,7275,'nl','Logboekitem',0),(261880,7275,'fi','PÃ¤ivyrimerkinnÃ¤n',0),(261881,7275,'no','LoggoppfÃ¸ring',0),(261882,7275,'da','Journaloptegnelse',0),(261883,7275,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª©',0),(261884,7275,'he','. ×¨×™×©×•× ×™×•×ž×Ÿ ×ž×¡×¤×¨',0),(261885,7275,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ¹ÏƒÎ· Ï‡ÏÎ¿Î½Î¹ÎºÎ¿Ï',0),(261886,7275,'zh','æ—¥å¿—æ¡ç›®\r\n',0),(261887,7275,'sv','Journalpost',0),(261888,7275,'it','Giornale di registrazione',0),(261889,7275,'tl','',0),(261890,7275,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;',0),(261891,7275,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(261892,7275,'ms','Kemasukan jurnal',0),(261893,7275,'ar','Ù‚ÙŠØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(261894,7275,'fr','Ã‰criture de journal',0),(261895,7275,'jp','ä»•è¨³å¸³ã®ã‚¨ãƒ³ãƒˆãƒª',0),(261896,7275,'pt','Entrada de diÃ¡rio',0),(261897,7275,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ',0),(261898,7275,'es','Entrada al Diario',0),(261899,7275,'de','Journaleintrag',0),(261900,7275,'en','Journal Entry',0),(261901,7276,'is','',0),(261902,7276,'dr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(261903,7276,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(261904,7276,'tr','KÄ±ymet GL hesabÄ±',0),(261905,7276,'pl','Konta aktywÃ³w GL',0),(261906,7276,'bg','GL Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(261907,7276,'ur','Ø§Ø«Ø§Ø«Û Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(261908,7276,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ ÑÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð° Ð“Ð›',0),(261909,7276,'vi','TÃ i Sáº£n Cá»‘ Äá»‹nh TK Sá»• CÃ¡i Tá»•ng Há»£p',0),(261910,7276,'af','Bates AG Rekening',0),(261911,7276,'ro','Cont de GL activ',0),(261912,7276,'et','GL pÃµhivarakontot',0),(261913,7276,'si','Sredstva GL raÄun',0),(261914,7276,'ba','Aset GL Account',0),(261915,7276,'nl','Actief GL Account',0),(261916,7276,'fi','GL tulotili',0),(261917,7276,'no','GL anleggsmiddelkonto',0),(261918,7276,'da','Aktiv GL konto',0),(261919,7276,'ko','ìžì‚° GL ê³„ì •',0),(261920,7276,'he','×”× ×›×¡ GL ×—×©×‘×•×Ÿ',0),(261921,7276,'el','Î ÎµÏÎ¹Î¿Ï…ÏƒÎ¹Î±ÎºÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(261922,7276,'zh','èµ„äº§æ€»å¸å¸æˆ·\r\n',0),(261923,7276,'sv','GL tillgÃ¥ngskonto',0),(261924,7276,'it','Conto di attivitÃ  GL',0),(261925,7276,'tl','',0),(261926,7276,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3636;&#3609;&#3607;&#3619;&#3633;&#3614;&#3618;&#3660;',0),(261927,7276,'hi','à¤ªà¤°à¤¿à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ GL à¤–à¤¾à¤¤à¥‡',0),(261928,7276,'ms','Aset GL akaun',0),(261929,7276,'ar','Ø­Ø³Ø§Ø¨ Ø£ØµÙˆÙ„ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(261930,7276,'fr','Compte d\'actif GL',0),(261931,7276,'jp','è³‡ç”£ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(261932,7276,'pt','Activo GL conta',0),(261933,7276,'ru','Ð¡Ñ‡ÐµÑ‚ Ð°ÐºÑ‚Ð¸Ð²Ð¾Ð² GL',0),(261934,7276,'es','LM Cuenta de Activo',0),(261935,7276,'de','GL Anlagekonto',0),(261936,7276,'en','Asset GL Account',0),(261937,7277,'is','',0),(261938,7277,'dr',' Ø¨Ø±Ú¯Ø´Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(261939,7277,'pr',' Ø¨Ø±Ú¯Ø´Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(261940,7277,'tr','SipariÅŸ edilen geri',0),(261941,7277,'pl','PowrÃ³t zamÃ³wione',0),(261942,7277,'bg','ÐÐµÐ¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(261943,7277,'ur','Ù¾Û’ Ø¨ÛŒÚ©',0),(261944,7277,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°',0),(261945,7277,'vi','ÄÆ¡n HÃ ng ChÆ°a Thá»±c Hiá»‡n Ngay',0),(261946,7277,'af','Terugwerkende Bestelde',0),(261947,7277,'ro','ÃŽnapoi comandate',0),(261948,7277,'et','TÃ¤itmata tellimus',0),(261949,7277,'si','Zaostalo naroÄilo',0),(261950,7277,'ba','Kembali memerintahkan',0),(261951,7277,'nl','Terug besteld',0),(261952,7277,'fi','Takaisin tilatut',0),(261953,7277,'no','Tilbake bestilte',0),(261954,7277,'da','Tilbage bestilte',0),(261955,7277,'ko','ë‹¤ì‹œ ì •ë ¬',0),(261956,7277,'he','×—×–×¨×” ×ž×¡×•×“×¨×ª',0),(261957,7277,'el','Î Î¯ÏƒÏ‰ Î´Î¹Î­Ï„Î±Î¾Îµ',0),(261958,7277,'zh','å»¶æœŸäº¤è´§\r\n',0),(261959,7277,'sv','Tillbaka bestÃ¤llda',0),(261960,7277,'it','Torna ordinato',0),(261961,7277,'tl','',0),(261962,7277,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3627;&#3621;&#3633;&#3591;',0),(261963,7277,'hi','à¤µà¤¾à¤ªà¤¸ à¤‘à¤°à¥à¤¡à¤° à¤•à¤¿à¤¯à¤¾ à¤¹à¥à¤†',0),(261964,7277,'ms','Kembali disusun',0),(261965,7277,'ar','ÙŠØ¹ÙˆØ¯ Ø£Ù…Ø±',0),(261966,7277,'fr','Retour ordonnÃ©',0),(261967,7277,'jp','ãƒãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼',0),(261968,7277,'pt','Volta ordenada',0),(261969,7277,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÑƒÐ¿Ð¾Ñ€ÑÐ´Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ð¹',0),(261970,7277,'es','Pedido en Espera',0),(261971,7277,'de','Geordnete zurÃ¼ck',0),(261972,7277,'en','Back Ordered',0),(261973,7278,'is','',0),(261974,7278,'dr','Ù‚ÙŠÙ…Øª Ù¾Ø§ÙŠÙ‡ ',0),(261975,7278,'pr','Ù‚ÙŠÙ…Øª Ù¾Ø§ÙŠÙ‡ ',0),(261976,7278,'tr','Taban FiyatÄ±',0),(261977,7278,'pl','Cena bazowa',0),(261978,7278,'bg','Ð‘Ð°Ð·Ð¾Ð²Ð° Ñ†ÐµÐ½Ð°',0),(261979,7278,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯',0),(261980,7278,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð° Ñ†ÐµÐ½Ð°',0),(261981,7278,'vi','GiÃ¡ Gá»‘c',0),(261982,7278,'af','Basisprys',0),(261983,7278,'ro','PreÅ£ de bazÄƒ',0),(261984,7278,'et','Baashind',0),(261985,7278,'si','Osnovna cena',0),(261986,7278,'ba','Harga dasar',0),(261987,7278,'nl','Basisprijs',0),(261988,7278,'fi','Perushinta',0),(261989,7278,'no','Basisprisen',0),(261990,7278,'da','Basispris',0),(261991,7278,'ko','ê¸°ë³¸ ê°€ê²©',0),(261992,7278,'he','×ž×—×™×¨ ×”×‘×¡×™×¡',0),(261993,7278,'el','Î’Î±ÏƒÎ¹ÎºÎ® Ï„Î¹Î¼Î®',0),(261994,7278,'zh','åŸºä»·\r\n',0),(261995,7278,'sv','Grundpris',0),(261996,7278,'it','Prezzo base',0),(261997,7278,'tl','',0),(261998,7278,'th','&#3600;&#3634;&#3609;&#3619;&#3634;&#3588;&#3634;',0),(261999,7278,'hi','à¤†à¤§à¤¾à¤° à¤®à¥‚à¤²à¥à¤¯',0),(262000,7278,'ms','Harga asas',0),(262001,7278,'ar','Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø£Ø³Ø§Ø³ÙŠ',0),(262002,7278,'fr','Prix de base',0),(262003,7278,'jp','åŸºæœ¬ä¾¡æ ¼',0),(262004,7278,'pt','PreÃ§o base',0),(262005,7278,'ru','Ð‘Ð°Ð·Ð¾Ð²Ð°Ñ Ñ†ÐµÐ½Ð°',0),(262006,7278,'es','Base Precio de',0),(262007,7278,'de','Grundpreis',0),(262008,7278,'en','Base Price',0),(262009,7279,'is','',0),(262010,7279,'dr','Ú¯Ø±ÙˆÙ‡  Ø¨Ø¯ÙˆÙ† Ø³Ù„Ø³Ù„Ù‡ Ù…Ø±Ø§ØªØ¨',0),(262011,7279,'pr','Ú¯Ø±ÙˆÙ‡  Ø¨Ø¯ÙˆÙ† Ø³Ù„Ø³Ù„Ù‡ Ù…Ø±Ø§ØªØ¨',0),(262012,7279,'tr','HayÄ±r sÄ±nÄ±f hiyerarÅŸisi',0),(262013,7279,'pl','Klasa brak hierarchii',0),(262014,7279,'bg','ÐšÐ»Ð°Ñ â„– Ð¹ÐµÑ€Ð°Ñ€Ñ…Ð¸Ñ',0),(262015,7279,'ur','Ú©Ù„Ø§Ø³ Ú©ÛŒ Ú©ÙˆØ¦ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ',0),(262016,7279,'sr','Ð¥Ð¸Ñ˜ÐµÑ€Ð°Ñ€Ñ…Ð¸Ñ˜Ð° ÐºÐ»Ð°ÑÐ°-Ð½Ðµ',0),(262017,7279,'vi','PhÃ¢n loáº¡i-KhÃ´ng cáº¥p báº­c',0),(262018,7279,'af','Kasifikasie-Geen Rangorde',0),(262019,7279,'ro','Clasa-fÄƒrÄƒ ierarhie',0),(262020,7279,'et','Klassi nr hierarhia',0),(262021,7279,'si','Razred-brez hierarhije',0),(262022,7279,'ba','Kelas-tidak ada hirarki',0),(262023,7279,'nl','Klasse-No hiÃ«rarchie',0),(262024,7279,'fi','Luokan n hierarkia',0),(262025,7279,'no','Klasse-ingen hierarki',0),(262026,7279,'da','Klasse-ingen hierarki',0),(262027,7279,'ko','ì•„ë‹ˆ í´ëž˜ìŠ¤ ê³„ì¸µ êµ¬ì¡°',0),(262028,7279,'he','. ×œ× ×ž×—×œ×§×ª ×”×™×¨××¨×›×™×”',0),(262029,7279,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î±-Î´ÎµÎ½ Î¹ÎµÏÎ±ÏÏ‡Î¯Î±',0),(262030,7279,'zh','ç±»æ²¡æœ‰ç­‰çº§\r\n',0),(262031,7279,'sv','Klass-ingen hierarki',0),(262032,7279,'it','Gerarchia di classe-No',0),(262033,7279,'tl','',0),(262034,7279,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3621;&#3635;&#3604;&#3633;&#3610;&#3605;&#3634;&#3617;&#3586;&#3633;&#3657;&#3609;',0),(262035,7279,'hi','à¤µà¤°à¥à¤—-à¤•à¥‹à¤ˆ à¤ªà¤¦à¤¾à¤¨à¥à¤•à¥à¤°à¤®',0),(262036,7279,'ms','Hierarki kelas-tidak',0),(262037,7279,'ar','Ø§Ù„ØªØ³Ù„Ø³Ù„ Ø§Ù„Ù‡Ø±Ù…ÙŠ Ù„Ø£ÙŠ ÙØ¦Ø©',0),(262038,7279,'fr','HiÃ©rarchie de classe-pas',0),(262039,7279,'jp','ã„ã„ãˆã‚¯ãƒ©ã‚¹éšŽå±¤',0),(262040,7279,'pt','Hierarquia de classe-nÃ£o',0),(262041,7279,'ru','Ð˜ÐµÑ€Ð°Ñ€Ñ…Ð¸Ñ ÐºÐ»Ð°ÑÑÐ° Ð½ÐµÑ‚',0),(262042,7279,'es','ClÃ¡se-No JerarquÃ­a',0),(262043,7279,'de','Klasse-keine Hierarchie',0),(262044,7279,'en','Class-No Hierarchy',0),(262045,7280,'is','',0),(262046,7280,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ§ÙŠÙ„ Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² ÙˆØ±ÙˆØ¯ Ù¾Ø§Ùƒ ÙƒÙ†ÙŠØ¯',0),(262047,7280,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ§ÙŠÙ„ Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² ÙˆØ±ÙˆØ¯ Ù¾Ø§Ùƒ ÙƒÙ†ÙŠØ¯',0),(262048,7280,'tr','Ä°Ã§e aktarma iÅŸleminden Ã¶nce dosya verilerini temizle',0),(262049,7280,'pl','WyczyÅ›Ä‡ plik danych przed importem',0),(262050,7280,'bg','Ð˜Ð·Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(262051,7280,'ur','Ú©ÙˆØ§Ø¦Ù Ù…Ø³Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ø³Û’ Ù¾ÛÙ„Û’ ØµØ§Ù Ú©Ø±ÛŒÚº',0),(262052,7280,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¸Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð¿Ñ€Ðµ ÑƒÐ²Ð¾Ð·Ð°',0),(262053,7280,'vi','XÃ³a há»“ sÆ¡ dá»¯ liá»‡u trÆ°á»›c khi nháº­p',0),(262054,7280,'af','LÃªerdata Uitwis Alvorens Invoer',0),(262055,7280,'ro','CurÄƒÈ›aÈ›i fiÈ™ierul Ã®nainte de Import',0),(262056,7280,'et','Faili andmed enne importimist',0),(262057,7280,'si','PoÄistite datoteko podatkov pred uvozom',0),(262058,7280,'ba','Hapus File Data sebelum Import',0),(262059,7280,'nl','Bestand wissen vÃ³Ã³r het importeren',0),(262060,7280,'fi','Poista tiedoston tiedot ennen tuontia',0),(262061,7280,'no','Fjerne dataene fÃ¸r Import',0),(262062,7280,'da','Ryd fildata fÃ¸r Import',0),(262063,7280,'ko','ê°€ì ¸ì˜¤ê¸° ì „ì— íŒŒì¼ ë°ì´í„°ë¥¼ ì‚­ì œ',0),(262064,7280,'he','× ×§×” × ×ª×•× ×™ ×§×•×‘×¥ ×œ×¤× ×™ ×™×™×‘×•×',0),(262065,7280,'el','ÎšÎ±Ï„Î±ÏÎ³Î®ÏƒÏ„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï€ÏÎ¹Î½ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(262066,7280,'zh','æ–‡ä»¶æ•°æ®å¯¼å…¥ä¹‹å‰æ¸…é™¤\r\n',0),(262067,7280,'sv','Rensa filen Data innan Import',0),(262068,7280,'it','Cancellare File dati prima dell\'importazione',0),(262069,7280,'tl','',0),(262070,7280,'th','&#3621;&#3657;&#3634;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3609;&#3649;&#3615;&#3657;&#3617;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(262071,7280,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¡à¥‡à¤Ÿà¤¾ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤°à¤¿à¤•à¥à¤¤ à¤•à¤°à¥‡à¤‚',0),(262072,7280,'ms','Fail Data sebelum Import yang jelas',0),(262073,7280,'ar','Ù…Ø³Ø­ Ù…Ù„Ù Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ù‚Ø¨Ù„ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(262074,7280,'fr','Effacer les donnÃ©es de fichier avant l\'importation',0),(262075,7280,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹å‰ã«ãƒ•ã‚¡ã‚¤ãƒ«ã®ãƒ‡ãƒ¼ã‚¿ã‚’æ¶ˆåŽ»ã—ã¾ã™ã€‚',0),(262076,7280,'pt','Limpar arquivo de dados antes de importar',0),(262077,7280,'ru','ÐžÑ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¿ÐµÑ€ÐµÐ´ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¾Ð¼',0),(262078,7280,'es','Vaciar Datos de Archivo Antes que Importar',0),(262079,7280,'de','Dateidaten vor dem Import lÃ¶schen',0),(262080,7280,'en','Clear File Data Before Import',0),(262081,7281,'is','',0),(262082,7281,'dr','ÙƒÙ¾ÙŠ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ ',0),(262083,7281,'pr','ÙƒÙ¾ÙŠ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ ',0),(262084,7281,'tr','BÃ¶ylece Descr kopyalama',0),(262085,7281,'pl','Skopiuj Descr tak',0),(262086,7281,'bg','ÐšÐ¾Ð¿Ð¸Ðµ Ñ‚ Descr',0),(262087,7281,'ur','Ø§Ø³ÛŒ Ø·Ø±Ø­ ÙˆÛŒØ¨ ØµÙØ­Û ØªØµØ±ÛŒØ­ Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(262088,7281,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ñ‚Ð°ÐºÐ¾ Ð”ÐµÑÑ†Ñ€',0),(262089,7281,'vi','Sao chÃ©p MÃ´ táº£ SO',0),(262090,7281,'af','Kopieer SO Descr',0),(262091,7281,'ro','Copie SO Descr',0),(262092,7281,'et','Kopeeri jne Descr',0),(262093,7281,'si','Kopijo opisnega tako',0),(262094,7281,'ba','Salinan begitu indah',0),(262095,7281,'nl','SO Descr kopiÃ«ren',0),(262096,7281,'fi','Kopioi niin Descr',0),(262097,7281,'no','Kopiere sÃ¥ Descr',0),(262098,7281,'da','Kopiere sÃ¥ Descr',0),(262099,7281,'ko','ê·¸ëž˜ì„œ Descr ë³µì‚¬',0),(262100,7281,'he','×”×¢×ª×§ ×ž×ª××¨×ª ×•×›×•',0),(262101,7281,'el','Descr Î¿ÏÏ„Ï‰ Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿',0),(262102,7281,'zh','å¤åˆ¶å–ä¸»é€‰æ‹©æƒæè¿°\r\n',0),(262103,7281,'sv','Kopiera sÃ¥ Descr',0),(262104,7281,'it','Copia cosÃ¬ Descr',0),(262105,7281,'tl','',0),(262106,7281,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3',0),(262107,7281,'hi','à¤‡à¤¤à¤¨à¤¾ Descr à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(262108,7281,'ms','Salinan seterusnya Descr',0),(262109,7281,'ar','ÙˆØµÙ Ø°Ù„Ùƒ Ù†Ø³Ø®Ø©',0),(262110,7281,'fr','Copie SO Descr',0),(262111,7281,'jp','ã‚³ãƒ”ãƒ¼ãªã© Descr',0),(262112,7281,'pt','CÃ³pia assim Descr',0),(262113,7281,'ru','Descr Ñ‚Ð°Ðº ÐºÐ¾Ð¿Ð¸Ñ',0),(262114,7281,'es','Copiar SO Descr.',0),(262115,7281,'de','Kopieren SO Descr',0),(262116,7281,'en','Copy SO Descr',0),(262117,7282,'is','',0),(262118,7282,'dr','Ø±ÙˆØ´ Ù‡Ø²ÙŠÙ†Ù‡ ÙŠØ§Ø¨ÙŠ',0),(262119,7282,'pr','Ø±ÙˆØ´ Ù‡Ø²ÙŠÙ†Ù‡ ÙŠØ§Ø¨ÙŠ',0),(262120,7282,'tr','Maliyetlendirme yÃ¶ntemi',0),(262121,7282,'pl','Metoda wyceny',0),(262122,7282,'bg','ÐœÐµÑ‚Ð¾Ð´ Ð·Ð° Ð¾ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ÑÐ²Ð°Ð½Ðµ',0),(262123,7282,'ur','Ù…Ø§Ø¦Ù„ÛŒØ¬ Ø·Ø±ÛŒÙ‚Û',0),(262124,7282,'sr','ÐÐ°Ñ‡Ð¸Ð½ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(262125,7282,'vi','PhÆ°Æ¡ng thá»©c tÃ­nh giÃ¡ thÃ nh',0),(262126,7282,'af','Kosteberekening metode',0),(262127,7282,'ro','Metoda de cost',0),(262128,7282,'et','Omahinna arvutamise meetod',0),(262129,7282,'si','NaÄin vrednotenja',0),(262130,7282,'ba','Metode perhitungan biaya',0),(262131,7282,'nl','Waarderingsmethode',0),(262132,7282,'fi','Kustannuslaskenta menetelmÃ¤',0),(262133,7282,'no','Lagermetoden',0),(262134,7282,'da','Kostmetoden',0),(262135,7282,'ko','ì›ê°€ê³„ì‚° ë°©ë²•',0),(262136,7282,'he','×©×™×˜×ª ×”×ª×ž×—×™×¨',0),(262137,7282,'el','ÎœÎ­Î¸Î¿Î´Î¿Ï‚ ÎºÎ¿ÏƒÏ„Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(262138,7282,'zh','æˆæœ¬è®¡ç®—æ–¹æ³•\r\n',0),(262139,7282,'sv','VÃ¤rderingsprincipen',0),(262140,7282,'it','Metodo di costing',0),(262141,7282,'tl','',0),(262142,7282,'th','&#3623;&#3636;&#3608;&#3637;&#3588;&#3636;&#3604;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(262143,7282,'hi','à¤²à¤¾à¤—à¤¤ à¤µà¤¿à¤§à¤¿',0),(262144,7282,'ms','Kaedah kos',0),(262145,7282,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø­Ø³Ø§Ø¨ Ø§Ù„ØªÙƒÙ„ÙØ©',0),(262146,7282,'fr','Mode d\'Ã©valuation',0),(262147,7282,'jp','åŽŸä¾¡è¨ˆç®—æ–¹æ³•',0),(262148,7282,'pt','MÃ©todo de custeio',0),(262149,7282,'ru','ÐœÐµÑ‚Ð¾Ð´ ÑƒÑ‡ÐµÑ‚Ð° ÑÐµÐ±ÐµÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸',0),(262150,7282,'es','Metodo de CÃ¡lculo de Costos',0),(262151,7282,'de','Kalkulationsmethode',0),(262152,7282,'en','Costing Method',0),(262153,7283,'is','',0),(262154,7283,'dr','ØªØ¹ÙŠÙŠÙ†â€Œ ÙƒØ±Ø¯Ù†â€Œ Ø­Ø¯ÙˆØ¯',0),(262155,7283,'pr','ØªØ¹ÙŠÙŠÙ†â€Œ ÙƒØ±Ø¯Ù†â€Œ Ø­Ø¯ÙˆØ¯',0),(262156,7283,'tr','SÄ±nÄ±rlayÄ±cÄ±',0),(262157,7283,'pl','Ogranicznik',0),(262158,7283,'bg','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»',0),(262159,7283,'ur','ØªØ­Ø¯ÛŒØ¯ Ú©Ø§Ø±',0),(262160,7283,'sr','Ð—Ð½Ð°Ðº Ð·Ð° Ñ€Ð°Ð·Ð³Ñ€Ð°Ð½Ð¸Ñ‡Ð°Ð²Ð°ÑšÐµ',0),(262161,7283,'vi','Dáº¥u cÃ¡ch',0),(262162,7283,'af','Delimiter',0),(262163,7283,'ro','Delimitator',0),(262164,7283,'et','Eraldaja',0),(262165,7283,'si','LoÄilo',0),(262166,7283,'ba','Pembatas',0),(262167,7283,'nl','Scheidingsteken',0),(262168,7283,'fi','Erotin',0),(262169,7283,'no','Skilletegn',0),(262170,7283,'da','AfgrÃ¦nser',0),(262171,7283,'ko','êµ¬ë¶„ ê¸°í˜¸',0),(262172,7283,'he','×ž×¤×¨×™×“',0),(262173,7283,'el','ÎŸÏÎ¹Î¿Î¸Î­Ï„Î·Ï‚',0),(262174,7283,'zh','å®šç•Œç¬¦\r\n',0),(262175,7283,'sv','AvgrÃ¤nsare',0),(262176,7283,'it','Delimitatore',0),(262177,7283,'tl','',0),(262178,7283,'th','&#3612;&#3641;&#3657;&#3585;&#3633;&#3657;&#3609;&#3648;&#3586;&#3605;',0),(262179,7283,'hi','à¤¸à¥€à¤®à¤¾à¤‚à¤•à¤•',0),(262180,7283,'ms','Delimiter',0),(262181,7283,'ar','Ø§Ù„Ù…Ø­Ø¯Ù‘Ø¯',0),(262182,7283,'fr','DÃ©limiteur',0),(262183,7283,'jp','åŒºåˆ‡ã‚Šè¨˜å·',0),(262184,7283,'pt','Delimitador',0),(262185,7283,'ru','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑŒ',0),(262186,7283,'es','Delimitador',0),(262187,7283,'de','Trennzeichen',0),(262188,7283,'en','Delimiter',0),(262189,7284,'is','',0),(262190,7284,'dr','Ø´Ø¹Ø¨Ù‡ ',0),(262191,7284,'pr','Ø´Ø¹Ø¨Ù‡ ',0),(262192,7284,'tr','DepartmanÄ±',0),(262193,7284,'pl','W departamencie',0),(262194,7284,'bg','ÐžÑ‚Ð´ÐµÐ»',0),(262195,7284,'ur','Ø´Ø¹Ø¨Û',0),(262196,7284,'sr','ÐœÐ¸Ð½Ð¸ÑÑ‚Ð°Ñ€ÑÑ‚Ð²Ð¾',0),(262197,7284,'vi','PhÃ²ng ban',0),(262198,7284,'af','Departement',0),(262199,7284,'ro','Departamentul',0),(262200,7284,'et','Osakond',0),(262201,7284,'si','Oddelek',0),(262202,7284,'ba','Departemen',0),(262203,7284,'nl','Departement',0),(262204,7284,'fi','Osasto',0),(262205,7284,'no','Avdeling',0),(262206,7284,'da','Afdeling',0),(262207,7284,'ko','ë¶€ì„œ',0),(262208,7284,'he','×”×ž×—×œ×§×”',0),(262209,7284,'el','Î¤Î¼Î®Î¼Î±',0),(262210,7284,'zh','éƒ¨\r\n',0),(262211,7284,'sv','Institutionen',0),(262212,7284,'it','Dipartimento',0),(262213,7284,'tl','',0),(262214,7284,'th','&#3649;&#3612;&#3609;&#3585;',0),(262215,7284,'hi','à¤µà¤¿à¤­à¤¾à¤—',0),(262216,7284,'ms','Jabatan',0),(262217,7284,'ar','Ø¥Ø¯Ø§Ø±Ø©',0),(262218,7284,'fr','DÃ©partement',0),(262219,7284,'jp','éƒ¨é–€',0),(262220,7284,'pt','Departamento',0),(262221,7284,'ru','ÐšÐ°Ñ„ÐµÐ´Ñ€Ð°',0),(262222,7284,'es','Departamento',0),(262223,7284,'de','Abteilung',0),(262224,7284,'en','Department',0),(262225,7285,'is','',0),(262226,7285,'dr','Ø´Ø¹Ø¨Ù‡ â€“ Ø¨Ø¯ÙˆÙ† Ø³Ù„Ø³Ù„Ù‡ Ù…Ø±Ø§ØªØ¨ ',0),(262227,7285,'pr','Ø´Ø¹Ø¨Ù‡ â€“ Ø¨Ø¯ÙˆÙ† Ø³Ù„Ø³Ù„Ù‡ Ù…Ø±Ø§ØªØ¨ ',0),(262228,7285,'tr','BÃ¶lÃ¼m No hiyerarÅŸisi',0),(262229,7285,'pl','W departamencie brak hierarchii',0),(262230,7285,'bg','ÐžÑ‚Ð´ÐµÐ» Ð½ÑÐ¼Ð° Ð¹ÐµÑ€Ð°Ñ€Ñ…Ð¸Ñ',0),(262231,7285,'ur','Ù…Ø­Ú©Ù…Û Ú©ÛŒ Ú©ÙˆØ¦ÛŒ Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ',0),(262232,7285,'sr','ÐžÐ´ÐµÑ™ÐµÑšÐµ -Ð½Ðµ Ñ…Ð¸Ñ˜ÐµÑ€Ð°Ñ€Ñ…Ð¸Ñ˜Ð°',0),(262233,7285,'vi','PhÃ²ng ban-khÃ´ng cáº¥p báº­c',0),(262234,7285,'af','Departement-geen hiÃ«rargie',0),(262235,7285,'ro','Departamentul-fÄƒrÄƒ ierarhie',0),(262236,7285,'et','Osakond-No hierarhia',0),(262237,7285,'si','Oddelek-brez hierarhije',0),(262238,7285,'ba','Departemen-tidak ada hirarki',0),(262239,7285,'nl','Departement-No hiÃ«rarchie',0),(262240,7285,'fi','Osasto-No hierarkia',0),(262241,7285,'no','Avdeling-ingen hierarki',0),(262242,7285,'da','Afdeling-ingen hierarki',0),(262243,7285,'ko','ë¶€ì„œ ì—†ìŒ ê³„ì¸µ êµ¬ì¡°',0),(262244,7285,'he','. ×œ× ×ž×—×œ×§×ª ×”×™×¨××¨×›×™×”',0),(262245,7285,'el','Î¤Î¼Î®Î¼Î±-Î´ÎµÎ½ Î¹ÎµÏÎ±ÏÏ‡Î¯Î±',0),(262246,7285,'zh','éƒ¨-æ²¡æœ‰ç­‰çº§\r\n',0),(262247,7285,'sv','Institutionen-ingen hierarki',0),(262248,7285,'it','Gerarchia numero dipartimento',0),(262249,7285,'tl','',0),(262250,7285,'th','&#3649;&#3612;&#3609;&#3585; - &#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3621;&#3635;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;',0),(262251,7285,'hi','à¤µà¤¿à¤­à¤¾à¤—-à¤•à¥‹à¤ˆ à¤ªà¤¦à¤¾à¤¨à¥à¤•à¥à¤°à¤®',0),(262252,7285,'ms','Hierarki Jabatan-tidak',0),(262253,7285,'ar','Ù„Ø§ Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„ØªØ³Ù„Ø³Ù„ Ø§Ù„Ù‡Ø±Ù…ÙŠ',0),(262254,7285,'fr','DÃ©partement-aucune hiÃ©rarchie',0),(262255,7285,'jp','éƒ¨é–€ãªã—éšŽå±¤',0),(262256,7285,'pt','Hierarquia de departamento-nÃ£o',0),(262257,7285,'ru','Ð˜ÐµÑ€Ð°Ñ€Ñ…Ð¸Ñ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð½ÐµÑ‚',0),(262258,7285,'es','Departamento-No JerarquÃ­a',0),(262259,7285,'de','Abteilung-No-Hierarchie',0),(262260,7285,'en','Department-No Hierarchy',0),(262261,7286,'is','',0),(262262,7286,'dr','Ø´Ø±Ø­ Ø¬Ø²Ø¡ Ø¨Ù‡ Ø¬Ø²Ø¡',0),(262263,7286,'pr','Ø´Ø±Ø­ Ø¬Ø²Ø¡ Ø¨Ù‡ Ø¬Ø²Ø¡',0),(262264,7286,'tr','DetaylÄ± aÃ§Ä±klama',0),(262265,7286,'pl','SzczegÃ³Å‚owy opis',0),(262266,7286,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(262267,7286,'ur','ØªÙØµÛŒÙ„ÛŒ Ø¨ÛŒØ§Ù†',0),(262268,7286,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð°Ð½ Ð¾Ð¿Ð¸Ñ',0),(262269,7286,'vi','MÃ´ táº£ chi tiáº¿t',0),(262270,7286,'af','Gedetaileerde Beskrywing',0),(262271,7286,'ro','Descrierea detaliatÄƒ',0),(262272,7286,'et','Detailne kirjeldus',0),(262273,7286,'si','Podroben opis',0),(262274,7286,'ba','Deskripsi rinci',0),(262275,7286,'nl','Gedetailleerde beschrijving',0),(262276,7286,'fi','Yksityiskohtainen kuvaus',0),(262277,7286,'no','Detaljert beskrivelse',0),(262278,7286,'da','Detaljeret beskrivelse',0),(262279,7286,'ko','ìžì„¸í•œ ì„¤ëª…',0),(262280,7286,'he','×ª×™××•×¨ ×ž×¤×•×¨×˜',0),(262281,7286,'el','Î›ÎµÏ€Ï„Î¿Î¼ÎµÏÎ®Ï‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(262282,7286,'zh','è¯¦ç»†è¯´æ˜Ž\r\n',0),(262283,7286,'sv','Detaljerad beskrivning',0),(262284,7286,'it','Descrizione dettagliata',0),(262285,7286,'tl','',0),(262286,7286,'th','&#3585;&#3634;&#3619;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(262287,7286,'hi','à¤µà¤¿à¤¸à¥à¤¤à¥ƒà¤¤ à¤µà¤¿à¤µà¤°à¤£',0),(262288,7286,'ms','Penerangan terperinci',0),(262289,7286,'ar','Ø§Ù„Ø¨ÙŠØ§Ù† Ø§Ù„Ù…ÙØµÙ‘Ù„',0),(262290,7286,'fr','Description dÃ©taillÃ©e',0),(262291,7286,'jp','è©³ç´°ãªèª¬æ˜Ž',0),(262292,7286,'pt','DescriÃ§Ã£o detalhada',0),(262293,7286,'ru','Ð”ÐµÑ‚Ð°Ð»ÑŒÐ½Ð¾Ðµ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(262294,7286,'es','DescripciÃ³n Detallada',0),(262295,7286,'de','AusfÃ¼hrliche Beschreibung',0),(262296,7286,'en','Detailed Description',0),(262297,7287,'is','',0),(262298,7287,'dr','Ù†Ù…Ø§ÙŠØ´ Ù†Ø§Ù… ',0),(262299,7287,'pr','Ù†Ù…Ø§ÙŠØ´ Ù†Ø§Ù… ',0),(262300,7287,'tr','GÃ¶rÃ¼nen ad',0),(262301,7287,'pl','Nazwa wyÅ›wietlana',0),(262302,7287,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ð¾ Ð¸Ð¼Ðµ',0),(262303,7287,'ur','Ù†Ø§Ù… Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(262304,7287,'sr','Ð˜Ð¼Ðµ Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·',0),(262305,7287,'vi','Hiá»ƒn thá»‹ tÃªn',0),(262306,7287,'af','Wys Naam',0),(262307,7287,'ro','Nume afiÅŸat',0),(262308,7287,'et','Kuvatav nimi',0),(262309,7287,'si','Prikazno ime',0),(262310,7287,'ba','Nama tampilan',0),(262311,7287,'nl','Weergavenaam',0),(262312,7287,'fi','NÃ¤yttÃ¶nimi',0),(262313,7287,'no','Visningsnavn',0),(262314,7287,'da','Visningsnavn',0),(262315,7287,'ko','í‘œì‹œ ì´ë¦„',0),(262316,7287,'he','×©× ×ª×¦×•×’×”',0),(262317,7287,'el','Î•Î¼Ï†Î±Î½Î¹Î¶ÏŒÎ¼ÎµÎ½Î¿ ÏŒÎ½Î¿Î¼Î±',0),(262318,7287,'zh','æ˜¾ç¤ºåç§°\r\n',0),(262319,7287,'sv','Visningsnamn',0),(262320,7287,'it','Nome visualizzato',0),(262321,7287,'tl','',0),(262322,7287,'th','&#3649;&#3626;&#3604;&#3591;&#3594;&#3639;&#3656;&#3629;',0),(262323,7287,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤¨à¤¾à¤®',0),(262324,7287,'ms','Nama paparan',0),(262325,7287,'ar','Ø§Ø³Ù… Ø§Ù„Ø¹Ø±Ø¶',0),(262326,7287,'fr','Nom d\'affichage',0),(262327,7287,'jp','è¡¨ç¤ºå',0),(262328,7287,'pt','Nome para exibiÃ§Ã£o',0),(262329,7287,'ru','ÐžÑ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°ÐµÐ¼Ð¾Ðµ Ð¸Ð¼Ñ',0),(262330,7287,'es','Desplegar Nombre',0),(262331,7287,'de','Anzeigenamen',0),(262332,7287,'en','Display Name',0),(262333,7288,'is','',0),(262334,7288,'dr','Ù‚ÙŠÙ…Øª ØªÙˆØ²ÙŠØ¹ ',0),(262335,7288,'pr','Ù‚ÙŠÙ…Øª ØªÙˆØ²ÙŠØ¹ ',0),(262336,7288,'tr','DaÄŸÄ±tÄ±m fiyatÄ±',0),(262337,7288,'pl','OpÅ‚ata dystrybucyjna',0),(262338,7288,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° Ñ€Ð°Ð·Ð¿Ñ€Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ',0),(262339,7288,'ur','ØªÙ‚Ø³ÛŒÙ… Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(262340,7288,'sr','Ð¦ÐµÐ½Ð° Ð·Ð° Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ†Ð¸Ñ˜Ñƒ',0),(262341,7288,'vi','GiÃ¡ PhÃ¢n phá»‘i',0),(262342,7288,'af','Verspreiding prys',0),(262343,7288,'ro','Distributie Pret',0),(262344,7288,'et','Jaotamise hind',0),(262345,7288,'si','Cena distribucije',0),(262346,7288,'ba','Harga distribusi',0),(262347,7288,'nl','Distributiekosten',0),(262348,7288,'fi','Jakelu hinta',0),(262349,7288,'no','Distribusjon pris',0),(262350,7288,'da','Distribution pris',0),(262351,7288,'ko','ìœ í†µ ê°€ê²©',0),(262352,7288,'he','×”×ª×¤×œ×’×•×ª ×ž×—×™×¨',0),(262353,7288,'el','Î¤Î¹Î¼Î® Î´Î¹Î±Î½Î¿Î¼Î®Ï‚',0),(262354,7288,'zh','é…å”®ä»·\r\n',0),(262355,7288,'sv','Distribution pris',0),(262356,7288,'it','Prezzo di distribuzione',0),(262357,7288,'tl','',0),(262358,7288,'th','&#3619;&#3634;&#3588;&#3634;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3592;&#3635;&#3627;&#3609;&#3656;&#3634;&#3618;',0),(262359,7288,'hi','à¤µà¤¿à¤¤à¤°à¤£ à¤®à¥‚à¤²à¥à¤¯',0),(262360,7288,'ms','Pengagihan harga',0),(262361,7288,'ar','Ø§Ù„Ø³Ø¹Ø± Ø§Ù„ØªÙˆØ²ÙŠØ¹',0),(262362,7288,'fr','Prix de la distribution',0),(262363,7288,'jp','é…å¸ƒä¾¡æ ¼',0),(262364,7288,'pt','PreÃ§o de distribuiÃ§Ã£o',0),(262365,7288,'ru','Ð Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð¦ÐµÐ½Ð°',0),(262366,7288,'es','Precio de DistribuciÃ³n',0),(262367,7288,'de','Verleih-Preis',0),(262368,7288,'en','Distribution Price',0),(262369,7289,'is','',0),(262370,7289,'dr','Ø­Ø°Ù  Ø­Ù…Ù„ ÙƒØ§Ù„Ø§ ',0),(262371,7289,'pr','Ø­Ø°Ù  Ø­Ù…Ù„ ÙƒØ§Ù„Ø§ ',0),(262372,7289,'tr','Damla gemi Ã¶ÄŸe',0),(262373,7289,'pl','UpuÅ›Ä‡ przedmiot',0),(262374,7289,'bg','ÐšÐ°Ð¿ÐºÐ° ÐºÐ¾Ñ€Ð°Ð± ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(262375,7289,'ur','Ù‚Ø·Ø±Û Ø¬ÛØ§Ø² Ø´Û’',0),(262376,7289,'sr','Ð¡Ð¿ÑƒÑÑ‚Ð¸ Ð±Ñ€Ð¾Ð´ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(262377,7289,'vi','Bá» danh má»¥c váº­n chuyá»ƒn',0),(262378,7289,'af','Versende Item Aflewer',0),(262379,7289,'ro','PicÄƒturÄƒ de navÄƒ element',0),(262380,7289,'et','Drop laeva Ã¼ksuse',0),(262381,7289,'si','Padec ladja element',0),(262382,7289,'ba','Drop Item kapal',0),(262383,7289,'nl','Drop schip Item',0),(262384,7289,'fi','Pudota aluksen kohde',0),(262385,7289,'no','Slipp skipet element',0),(262386,7289,'da','Drop skib vare',0),(262387,7289,'ko','ë“œë¡­ ì„ ë°• í•­ëª©',0),(262388,7289,'he','×¤×¨×™×˜ ×”×¡×¤×™× ×” ×˜×™×¤×”',0),(262389,7289,'el','Î£ÏÏÎµÏ„Îµ Ï„Î¿ Î±Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î¿ Ï€Î»Î¿Î¯Î¿',0),(262390,7289,'zh','è¿é€é¡¹ç›®\r\n',0),(262391,7289,'sv','SlÃ¤ppa fartyget objekt',0),(262392,7289,'it','Voce nave di goccia',0),(262393,7289,'tl','',0),(262394,7289,'th','&#3621;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(262395,7289,'hi','à¤¡à¥à¤°à¥‰à¤ª à¤œà¤¹à¤¾à¤œ à¤†à¤‡à¤Ÿà¤®',0),(262396,7289,'ms','Butiran kapal drop',0),(262397,7289,'ar','Ø¥Ø³Ù‚Ø§Ø· Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(262398,7289,'fr','Drop Ship point',0),(262399,7289,'jp','ãƒ‰ãƒ­ãƒƒãƒ—èˆ¹é …ç›®',0),(262400,7289,'pt','Item de navio da gota',0),(262401,7289,'ru','Drop ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(262402,7289,'es','Enviar el Item Directamente',0),(262403,7289,'de','Drop Ship-Elementen',0),(262404,7289,'en','Drop Ship Item',0),(262405,7290,'is','',0),(262406,7290,'dr','Ù‚ÙŠÙ…Øª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(262407,7290,'pr','Ù‚ÙŠÙ…Øª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(262408,7290,'tr','Ã‡alÄ±ÅŸan fiyatÄ±',0),(262409,7290,'pl','Cena pracownika',0),(262410,7290,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ñ†ÐµÐ½Ð°',0),(262411,7290,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(262412,7290,'sr','Ð¦ÐµÐ½Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(262413,7290,'vi','GiÃ¡ NhÃ¢n viÃªn',0),(262414,7290,'af','Werknemer Prys',0),(262415,7290,'ro','Angajat Pret',0),(262416,7290,'et','TÃ¶Ã¶taja hind',0),(262417,7290,'si','Ceno zaposlenega',0),(262418,7290,'ba','Harga karyawan',0),(262419,7290,'nl','Werknemer prijs',0),(262420,7290,'fi','TyÃ¶ntekijÃ¤n hinta',0),(262421,7290,'no','Ansatt pris',0),(262422,7290,'da','Medarbejder pris',0),(262423,7290,'ko','ì§ì› ê°€ê²©',0),(262424,7290,'he','×ž×—×™×¨ ×œ×¢×•×‘×“',0),(262425,7290,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Ï„Î¹Î¼Î®',0),(262426,7290,'zh','å‘˜å·¥ä»·æ ¼',0),(262427,7290,'sv','AnstÃ¤lld pris',0),(262428,7290,'it','Dipendente prezzo',0),(262429,7290,'tl','',0),(262430,7290,'th','&#3619;&#3634;&#3588;&#3634;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(262431,7290,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤®à¥‚à¤²à¥à¤¯',0),(262432,7290,'ms','Harga pekerja',0),(262433,7290,'ar','Ø§Ù„Ø³Ø¹Ø± Ù„Ù„Ù…ÙˆØ¸Ù',0),(262434,7290,'fr','Prix employÃ©',0),(262435,7290,'jp','å¾“æ¥­å“¡ã®ä¾¡æ ¼',0),(262436,7290,'pt','PreÃ§o de empregado',0),(262437,7290,'ru','Ð¦ÐµÐ½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(262438,7290,'es','Empleado Precio',0),(262439,7290,'de','Mitarbeiter-Preis',0),(262440,7290,'en','Employee Price',0),(262441,7291,'is','',0),(262442,7291,'dr','Ø­Ø³Ø§Ø¨  Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(262443,7291,'pr','Ø­Ø³Ø§Ø¨  Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(262444,7291,'tr','GL hesabÄ±',0),(262445,7291,'pl','GL rozchodowych',0),(262446,7291,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(262447,7291,'ur','Ø®Ø±Ú†Û’ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(262448,7291,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð“Ð›',0),(262449,7291,'vi','TK Chi PhÃ­ Sá»• CÃ¡i Tá»•ng Há»£p',0),(262450,7291,'af','AG Uitgawerekening',0),(262451,7291,'ro','Cheltuieli de cont GL',0),(262452,7291,'et','GL Kulukonto',0),(262453,7291,'si','Konto stroÅ¡kov GL',0),(262454,7291,'ba','Rekening pengeluaran GL',0),(262455,7291,'nl','GL kostenrekening',0),(262456,7291,'fi','GL kulutili',0),(262457,7291,'no','GL kostnadskonto',0),(262458,7291,'da','GL udgiftskonto',0),(262459,7291,'ko','ê²½ë¹„ GL ê³„ì •',0),(262460,7291,'he','×—×©×‘×•×Ÿ ×”×”×•×¦××•×ª GL',0),(262461,7291,'el','Î”Î±Ï€Î¬Î½Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(262462,7291,'zh','æ€»å¸å¸æˆ·è´¹ç”¨\r\n',0),(262463,7291,'sv','Utgiftskonto GL',0),(262464,7291,'it','Conto di spese GL',0),(262465,7291,'tl','',0),(262466,7291,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(262467,7291,'hi','à¤µà¥à¤¯à¤¯ GL à¤–à¤¾à¤¤à¥‡',0),(262468,7291,'ms','Perbelanjaan GL akaun',0),(262469,7291,'ar','Ø­Ø³Ø§Ø¨ Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(262470,7291,'fr','Compte de dÃ©penses GL',0),(262471,7291,'jp','çµŒè²» GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(262472,7291,'pt','Conta de despesas GL',0),(262473,7291,'ru','Ð¡Ñ‡ÐµÑ‚ GL',0),(262474,7291,'es','Cuenta de Gastos LM',0),(262475,7291,'de','GL Aufwandskonto',0),(262476,7291,'en','Expense GL Account',0),(262477,7292,'is','',0),(262478,7292,'dr','ÙƒØ§Ù„Ø§ÙŠ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ ',0),(262479,7292,'pr','ÙƒØ§Ù„Ø§ÙŠ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ ',0),(262480,7292,'tr','SeÃ§me madde',0),(262481,7292,'pl','Promowany przedmiot',0),(262482,7292,'bg','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¾Ð½Ð°Ð»ÐµÐ½ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(262483,7292,'ur','Ù†Ù…Ø§ÛŒØ§Úº Ø¢Ø¦Ù¹Ù…',0),(262484,7292,'sr','Ð˜ÑÑ‚Ð°ÐºÐ½ÑƒÑ‚Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(262485,7292,'vi','HÃ ng chá»©c nÄƒng',0),(262486,7292,'af','Kenmerkende Items',0),(262487,7292,'ro','Element recomandate',0),(262488,7292,'et','EsiletÃµstetud Ã¼ksus',0),(262489,7292,'si','Izpostavljeni element',0),(262490,7292,'ba','Item Terpilih',0),(262491,7292,'nl','Topaanbieding',0),(262492,7292,'fi','Suositeltu kohde',0),(262493,7292,'no','Inneholdt elementet',0),(262494,7292,'da','FremhÃ¦vede element',0),(262495,7292,'ko','ì¶”ì²œëœ í•­ëª©',0),(262496,7292,'he','×¤×¨×™×˜×™× × ×‘×—×¨×™×',0),(262497,7292,'el','Î•Ï€Î¹Î»ÎµÎ³Î¼Î­Î½Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(262498,7292,'zh','ç‰¹è‰²é¡¹ç›®\r\n',0),(262499,7292,'sv','Presenterade objekt',0),(262500,7292,'it','Elemento in primo piano',0),(262501,7292,'tl','',0),(262502,7292,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3633;&#3585;&#3625;&#3603;&#3632;&#3648;&#3604;&#3656;&#3609;',0),(262503,7292,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤°à¥à¤ª à¤¸à¥‡ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤†à¤‡à¤Ÿà¤®',0),(262504,7292,'ms','Terutama Item',0),(262505,7292,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ù…ÙˆØµÙ‰ Ø¨Ù‡Ø§',0),(262506,7292,'fr','Point recommandÃ©',0),(262507,7292,'jp','ãŠã™ã™ã‚ã®ã‚¢ã‚¤ãƒ†ãƒ ',0),(262508,7292,'pt','Item de destaque',0),(262509,7292,'ru','Ð ÐµÐºÐ¾Ð¼ÐµÐ½Ð´ÑƒÐµÐ¼Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(262510,7292,'es','Item Destacado',0),(262511,7292,'de','Empfohlene Artikel',0),(262512,7292,'en','Featured Item',0),(262513,7293,'is','',0),(262514,7293,'dr','( Ø¬Ù†Ø³ Ø¹Ø±Ø¶Ù‡ Ø´Ø¯Ù‡',0),(262515,7293,'pr','Ø´Ø±Ø­ ØªØºØ°ÙŠÙ‡( ÙƒØ§Ù„Ø§ÙŠ Ø¹Ø±Ø¶Ù‡ Ø´Ø¯Ù‡',0),(262516,7293,'tr','Ã–zet akÄ±ÅŸÄ± aÃ§Ä±klamasÄ±',0),(262517,7293,'pl','Opis kanaÅ‚Ã³w',0),(262518,7293,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ',0),(262519,7293,'ur','ØªØµØ±ÛŒØ­ ÙÛŒÚˆ',0),(262520,7293,'sr','ÐžÐ¿Ð¸Ñ Ñ„ÐµÐµÐ´Ð°',0),(262521,7293,'vi','Náº¡p mÃ´ táº£',0),(262522,7293,'af','Voer Beskrywing',0),(262523,7293,'ro','Feed-Descriere',0),(262524,7293,'et','Kanali kirjeldus',0),(262525,7293,'si','Opis vira',0),(262526,7293,'ba','Deskripsi dari feed',0),(262527,7293,'nl','Feed omschrijving',0),(262528,7293,'fi','SyÃ¶tteen kuvaus',0),(262529,7293,'no','Mate beskrivelse',0),(262530,7293,'da','Feed beskrivelse',0),(262531,7293,'ko','í”¼ë“œ ì„¤ëª…',0),(262532,7293,'he','×ª×™××•×¨ ×”×–× ×”',0),(262533,7293,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„ÏÎ¿Ï†Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(262534,7293,'zh','æ•°æ®èµ„æ–™æè¿°\r\n',0),(262535,7293,'sv','Foder Beskrivning',0),(262536,7293,'it','Descrizione alimentazione',0),(262537,7293,'tl','',0),(262538,7293,'th','&#3651;&#3626;&#3656;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(262539,7293,'hi','à¤«à¤¼à¥€à¤¡ à¤µà¤¿à¤µà¤°à¤£',0),(262540,7293,'ms','Huraian makanan',0),(262541,7293,'ar','ÙˆØµÙ Ù…ÙˆØ¬Ø²',0),(262542,7293,'fr','Description alimentation',0),(262543,7293,'jp','ãƒ•ã‚£ãƒ¼ãƒ‰ã®èª¬æ˜Ž',0),(262544,7293,'pt','DescriÃ§Ã£o alimentaÃ§Ã£o',0),(262545,7293,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸',0),(262546,7293,'es','DescripciÃ³n de Suministro',0),(262547,7293,'de','Feed Beschreibung',0),(262548,7293,'en','Feed Description',0),(262549,7294,'is','',0),(262550,7294,'dr','Ù†Ø§Ù… ÙƒØ§Ù„Ø§ÙŠ Ø¹Ø±Ø¶Ù‡ Ø´Ø¯Ù‡',0),(262551,7294,'pr','Ù†Ø§Ù… ÙƒØ§Ù„Ø§ÙŠ Ø¹Ø±Ø¶Ù‡ Ø´Ø¯Ù‡',0),(262552,7294,'tr','Ã–zet AkÄ±ÅŸ adÄ±',0),(262553,7294,'pl','Nazwa ÅºrÃ³dÅ‚a danych',0),(262554,7294,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐºÐ°Ð½Ð°Ð»',0),(262555,7294,'ur','Ù†Ø§Ù… ÙÛŒÚˆ',0),(262556,7294,'sr','Ð˜Ð¼Ðµ Ñ„ÐµÐµÐ´Ð°',0),(262557,7294,'vi','Náº¡p tÃªn',0),(262558,7294,'af','Voer naam',0),(262559,7294,'ro','Furaje numele',0),(262560,7294,'et','Kanali nimi',0),(262561,7294,'si','Ime vira',0),(262562,7294,'ba','Nama pakan',0),(262563,7294,'nl','Voer naam',0),(262564,7294,'fi','SyÃ¶tteen nimi',0),(262565,7294,'no','Feed-navn',0),(262566,7294,'da','Feed-navn',0),(262567,7294,'ko','í”¼ë“œ ì´ë¦„',0),(262568,7294,'he','×”×–× ×ª ×©×',0),(262569,7294,'el','ÎÎ¿Î¼Î± Ï„ÏÎ¿Ï†Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(262570,7294,'zh','æ•°æ®èµ„æ–™åç§°\r\n',0),(262571,7294,'sv','Foder namn',0),(262572,7294,'it','Nome di mangimi',0),(262573,7294,'tl','',0),(262574,7294,'th','&#3651;&#3626;&#3656;&#3594;&#3639;&#3656;&#3629;',0),(262575,7294,'hi','à¤¨à¤¾à¤® à¤«à¥€à¤¡',0),(262576,7294,'ms','Nama suapan',0),(262577,7294,'ar','Ø§Ø³Ù… Ù…ÙˆØ¬Ø² ÙˆÙŠØ¨',0),(262578,7294,'fr','Nom flux',0),(262579,7294,'jp','ãƒ•ã‚£ãƒ¼ãƒ‰å',0),(262580,7294,'pt','Alimentar o nome',0),(262581,7294,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð»ÐµÐ½Ñ‚Ñ‹',0),(262582,7294,'es','Nombre de Suministro',0),(262583,7294,'de','Feed Name',0),(262584,7294,'en','Feed Name',0),(262585,7295,'is','',0),(262586,7295,'dr','ÙØ±Ù…ÙˆÙ„ Ø§Ø±Ø²',0),(262587,7295,'pr','ÙØ±Ù…ÙˆÙ„ Ø§Ø±Ø²',0),(262588,7295,'tr','FormÃ¼l DÃ¶viz',0),(262589,7295,'pl','FormuÅ‚a waluty',0),(262590,7295,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(262591,7295,'ur','ÙØ§Ø±Ù…ÙˆÙ„Ø§ Ú©Ø±Ù†Ø³ÛŒ',0),(262592,7295,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(262593,7295,'vi','CÃ´ng thá»©c tiá»n tá»‡',0),(262594,7295,'af','Formule Geldeenheid',0),(262595,7295,'ro','Formula moneda',0),(262596,7295,'et','Valemi valuuta',0),(262597,7295,'si','Formula valute',0),(262598,7295,'ba','Mata uang formula',0),(262599,7295,'nl','Formule valuta',0),(262600,7295,'fi','Kaavan valuutta',0),(262601,7295,'no','Formelen valuta',0),(262602,7295,'da','Formel valuta',0),(262603,7295,'ko','ê³µì‹ í†µí™”',0),(262604,7295,'he','×ž×˜×‘×¢ × ×•×¡×—×”',0),(262605,7295,'el','Î¤ÏÏ€Î¿Ï‚ Î½Î¿Î¼Î¯ÏƒÎ¼Î±Ï„Î¿Ï‚',0),(262606,7295,'zh','å…¬å¼è´§å¸\r\n',0),(262607,7295,'sv','Formeln valuta',0),(262608,7295,'it','Valuta formula',0),(262609,7295,'tl','',0),(262610,7295,'th','&#3626;&#3641;&#3605;&#3619;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(262611,7295,'hi','à¤¸à¥‚à¤¤à¥à¤° à¤®à¥à¤¦à¥à¤°à¤¾',0),(262612,7295,'ms','Formula Mata Wang',0),(262613,7295,'ar','Ø§Ù„Ø¹Ù…Ù„Ø© Ø§Ù„ØµÙŠØºØ©',0),(262614,7295,'fr','Formule monnaie',0),(262615,7295,'jp','æ•°å¼ã®é€šè²¨',0),(262616,7295,'pt','FÃ³rmula moeda',0),(262617,7295,'ru','ÐšÑƒÑ€Ñ Ð’Ð°Ð»ÑŽÑ‚Ñ‹',0),(262618,7295,'es','Formula Moneda',0),(262619,7295,'de','Formel WÃ¤hrung',0),(262620,7295,'en','Formula Currency',0),(262621,7296,'is','',0),(262622,7296,'dr','ÙØ±Ù…ÙˆÙ„ ØªØ§Ø±ÙŠØ® ',0),(262623,7296,'pr','ÙØ±Ù…ÙˆÙ„ ØªØ§Ø±ÙŠØ® ',0),(262624,7296,'tr','FormÃ¼l tarihi',0),(262625,7296,'pl','FormuÅ‚a daty',0),(262626,7296,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð´Ð°Ñ‚Ð°',0),(262627,7296,'ur','ÙØ§Ø±Ù…ÙˆÙ„Ø§ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(262628,7296,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(262629,7296,'vi','NgÃ y cÃ´ng thá»©c',0),(262630,7296,'af','Formule Datum',0),(262631,7296,'ro','Formula data',0),(262632,7296,'et','Valemi kuupÃ¤ev',0),(262633,7296,'si','Formula datuma',0),(262634,7296,'ba','Rumus tanggal',0),(262635,7296,'nl','Formule datum',0),(262636,7296,'fi','Reseptin pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(262637,7296,'no','Formelen dato',0),(262638,7296,'da','Formel dato',0),(262639,7296,'ko','ìˆ˜ì‹ ë‚ ì§œ',0),(262640,7296,'he','×ª××¨×™×š × ×•×¡×—×”',0),(262641,7296,'el','Î¤ÏÏ€Î¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(262642,7296,'zh','å…¬å¼æ—¥æœŸ\r\n',0),(262643,7296,'sv','Formeln datum',0),(262644,7296,'it','Formula data',0),(262645,7296,'tl','',0),(262646,7296,'th','&#3626;&#3641;&#3605;&#3619;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(262647,7296,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‡ à¤¸à¥‚à¤¤à¥à¤°',0),(262648,7296,'ms','Formula tarikh',0),(262649,7296,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØµÙŠØºØ©',0),(262650,7296,'fr','Formule Date',0),(262651,7296,'jp','æ•°å¼ã®æ—¥ä»˜',0),(262652,7296,'pt','Data fÃ³rmula',0),(262653,7296,'ru','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð´Ð°Ñ‚Ñ‹',0),(262654,7296,'es','Fecha de Formula',0),(262655,7296,'de','Formel Datum',0),(262656,7296,'en','Formula Date',0),(262657,7297,'is','',0),(262658,7297,'dr','ÙØ±Ù…ÙˆÙ„ ØªØ§Ø±ÙŠØ®  Ø²Ù…Ø§Ù† ',0),(262659,7297,'pr','ÙØ±Ù…ÙˆÙ„ ØªØ§Ø±ÙŠØ®  Ø²Ù…Ø§Ù† ',0),(262660,7297,'tr','FormÃ¼l Tarih Saat',0),(262661,7297,'pl','FormuÅ‚a daty czas',0),(262662,7297,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð´Ð°Ñ‚Ð° Ñ‡Ð°Ñ',0),(262663,7297,'ur','ÙØ§Ø±Ù…ÙˆÙ„Ø§ ØªØ§Ø±ÛŒØ® ÙˆÙ‚Øª',0),(262664,7297,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(262665,7297,'vi','Thá»i gian NgÃ y cÃ´ng thá»©c',0),(262666,7297,'af','Formule Datum Tyd',0),(262667,7297,'ro','Formula datÄƒ orÄƒ',0),(262668,7297,'et','Valemi kuupÃ¤ev kellaaeg',0),(262669,7297,'si','Datumsko formulo',0),(262670,7297,'ba','Rumus tanggal waktu',0),(262671,7297,'nl','Formule datum tijd',0),(262672,7297,'fi','Reseptin pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ aika',0),(262673,7297,'no','Formelen dato klokkeslett',0),(262674,7297,'da','Formel dato klokkeslÃ¦t',0),(262675,7297,'ko','ìˆ˜ì‹ ë‚ ì§œ ì‹œê°„',0),(262676,7297,'he','×”× ×•×¡×—×” ×ª××¨×™×š ×©×¢×”',0),(262677,7297,'el','Î¤ÏÏ€Î¿Ï‚, Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÏŽÏÎ±',0),(262678,7297,'zh','æ—¥æœŸæ—¶é—´å…¬å¼\r\n',0),(262679,7297,'sv','Formeln datum tid',0),(262680,7297,'it','Formula data ora',0),(262681,7297,'tl','',0),(262682,7297,'th','&#3626;&#3641;&#3605;&#3619;&#3623;&#3633;&#3609;&#3648;&#3623;&#3621;&#3634;',0),(262683,7297,'hi','à¤¸à¥‚à¤¤à¥à¤° à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¤®à¤¯',0),(262684,7297,'ms','Formula tarikh masa',0),(262685,7297,'ar','ØµÙŠØºØ© Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„ÙˆÙ‚Øª',0),(262686,7297,'fr','Formule Date heure',0),(262687,7297,'jp','æ•°å¼ã®æ—¥ä»˜æ™‚åˆ»',0),(262688,7297,'pt','FÃ³rmula data hora',0),(262689,7297,'ru','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð”Ð°Ñ‚Ñ‹ Ð’Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(262690,7297,'es','Fecha Tiempo de Formula',0),(262691,7297,'de','Formel DatumUhrzeit',0),(262692,7297,'en','Formula Date Time',0),(262693,7298,'is','',0),(262694,7298,'dr','ÙØ±Ù…ÙˆÙ„Ù‡Ø§ÙŠ Ø¹Ø¯Ø¯ÙŠ ',0),(262695,7298,'pr','ÙØ±Ù…ÙˆÙ„Ù‡Ø§ÙŠ Ø¹Ø¯Ø¯ÙŠ ',0),(262696,7298,'tr','FormÃ¼l sayÄ±sal',0),(262697,7298,'pl','FormuÅ‚a numeryczne',0),(262698,7298,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ñ†Ð¸Ñ„Ñ€Ð¾Ð²Ð°Ñ‚Ð°',0),(262699,7298,'ur','ÙØ§Ø±Ù…ÙˆÙ„Ø§ Ù†Ù…Ø¨Ø±ÛŒ',0),(262700,7298,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð½ÑƒÐ¼ÐµÑ€Ð¸Ñ‡ÐºÐµ',0),(262701,7298,'vi','CÃ´ng thá»©c sá»‘',0),(262702,7298,'af','Formule numeriese',0),(262703,7298,'ro','Formula numericÄƒ',0),(262704,7298,'et','Valemi numbriline',0),(262705,7298,'si','Formula Å¡tevilski',0),(262706,7298,'ba','Rumus numerik',0),(262707,7298,'nl','Formule Numeric',0),(262708,7298,'fi','Kaavan numero',0),(262709,7298,'no','Formelen numeriske',0),(262710,7298,'da','Formel numeriske',0),(262711,7298,'ko','ìˆ˜ì‹ ìˆ«ìž',0),(262712,7298,'he','×ž×¡×¤×¨×™×™× ×‘× ×•×¡×—×”',0),(262713,7298,'el','Î‘ÏÎ¹Î¸Î¼Î·Ï„Î¹ÎºÏŒ Ï„ÏÏ€Î¿',0),(262714,7298,'zh','æ•°å­—å…¬å¼\r\n',0),(262715,7298,'sv','Formeln numeriska',0),(262716,7298,'it','Formula numerica',0),(262717,7298,'tl','',0),(262718,7298,'th','&#3626;&#3641;&#3605;&#3619;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;',0),(262719,7298,'hi','à¤¸à¥‚à¤¤à¥à¤° à¤¸à¤‚à¤–à¥à¤¯à¤¾à¤¤à¥à¤®à¤•',0),(262720,7298,'ms','Formula angka',0),(262721,7298,'ar','Ø§Ù„ØµÙŠØºØ© Ø§Ù„Ø±Ù‚Ù…ÙŠØ©',0),(262722,7298,'fr','Formule numÃ©rique',0),(262723,7298,'jp','æ•°å¼ã®æ•°å€¤',0),(262724,7298,'pt','FÃ³rmula numÃ©rico',0),(262725,7298,'ru','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ñ‡Ð¸ÑÐ»Ð¾Ð²Ð¾Ð³Ð¾',0),(262726,7298,'es','Formula Numerica',0),(262727,7298,'de','Formel nummerisch',0),(262728,7298,'en','Formula Numeric',0),(262729,7299,'is','',0),(262730,7299,'dr','ÙØ±Ù…ÙˆÙ„ Ø¯Ø±ØµØ¯ ',0),(262731,7299,'pr','ÙØ±Ù…ÙˆÙ„ Ø¯Ø±ØµØ¯ ',0),(262732,7299,'tr','FormÃ¼l yÃ¼zde',0),(262733,7299,'pl','FormuÅ‚y procent',0),(262734,7299,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(262735,7299,'ur','ÙØ§Ø±Ù…ÙˆÙ„Ø§ ÙÛŒØµØ¯',0),(262736,7299,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð¿Ð¾ÑÑ‚Ð¾',0),(262737,7299,'vi','% cÃ´ng thá»©c',0),(262738,7299,'af','Formule persent',0),(262739,7299,'ro','Formula %',0),(262740,7299,'et','Valemi protsenti',0),(262741,7299,'si','Formula odstotkov',0),(262742,7299,'ba','Rumus persen',0),(262743,7299,'nl','Formule procent',0),(262744,7299,'fi','Kaavan prosenttia',0),(262745,7299,'no','Formelen prosent',0),(262746,7299,'da','Formel procent',0),(262747,7299,'ko','ìˆ˜ì‹ %',0),(262748,7299,'he','××—×•×– × ×•×¡×—×”',0),(262749,7299,'el','Î¤ÏÏ€Î¿Ï‚ Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(262750,7299,'zh','å…¬å¼ç™¾åˆ†æ¯”\r\n',0),(262751,7299,'sv','Formeln procent',0),(262752,7299,'it','Formula per cento',0),(262753,7299,'tl','',0),(262754,7299,'th','&#3626;&#3641;&#3605;&#3619;&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3609;&#3605;&#3660;',0),(262755,7299,'hi','à¤¸à¥‚à¤¤à¥à¤° à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(262756,7299,'ms','Formula peratus',0),(262757,7299,'ar','Ø§Ù„ØµÙŠØºØ© Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(262758,7299,'fr','Formule pour cent',0),(262759,7299,'jp','æ•°å¼ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ',0),(262760,7299,'pt','FÃ³rmula por cento',0),(262761,7299,'ru','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(262762,7299,'es','Formula Porcentaje',0),(262763,7299,'de','Formel Prozent',0),(262764,7299,'en','Formula Percent',0),(262765,7300,'is','',0),(262766,7300,'dr','ÙØ±Ù…ÙˆÙ„ Ù…ØªÙ† ',0),(262767,7300,'pr','ÙØ±Ù…ÙˆÙ„ Ù…ØªÙ† ',0),(262768,7300,'tr','FormÃ¼l metin',0),(262769,7300,'pl','FormuÅ‚y tekst',0),(262770,7300,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ñ‚ÐµÐºÑÑ‚',0),(262771,7300,'ur','ÙØ§Ø±Ù…ÙˆÙ„Ø§ Ù…ØªÙ†',0),(262772,7300,'sr','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»Ð° Ñ‚ÐµÐºÑÑ‚',0),(262773,7300,'vi','VÄƒn báº£n cÃ´ng thá»©c',0),(262774,7300,'af','Fomula Teks',0),(262775,7300,'ro','Formula Text',0),(262776,7300,'et','Valem teksti',0),(262777,7300,'si','Formula besedilo',0),(262778,7300,'ba','Rumus teks',0),(262779,7300,'nl','De tekst van formule',0),(262780,7300,'fi','Kaavaan',0),(262781,7300,'no','Formelen tekst',0),(262782,7300,'da','Formel tekst',0),(262783,7300,'ko','ìˆ˜ì‹ í…ìŠ¤íŠ¸',0),(262784,7300,'he','×ž××’×™×•×ª',0),(262785,7300,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Ï„ÏÏ€Î¿Ï…',0),(262786,7300,'zh','å…¬å¼æ–‡æœ¬\r\n',0),(262787,7300,'sv','Formeln Text',0),(262788,7300,'it','Formula testo',0),(262789,7300,'tl','',0),(262790,7300,'th','&#3626;&#3641;&#3605;&#3619;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(262791,7300,'hi','à¤¸à¥‚à¤¤à¥à¤° à¤ªà¤¾à¤ ',0),(262792,7300,'ms','Formula teks',0),(262793,7300,'ar','Ù†Øµ Ø§Ù„ØµÙŠØºØ©',0),(262794,7300,'fr','Texte formule',0),(262795,7300,'jp','å¼ã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(262796,7300,'pt','Texto de fÃ³rmula',0),(262797,7300,'ru','Ð¢ÐµÐºÑÑ‚ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ñ‹',0),(262798,7300,'es','Formula Texto',0),(262799,7300,'de','Formeltext',0),(262800,7300,'en','Formula Text',0),(262801,7301,'is','',0),(262802,7301,'dr','Froogle Ø¹Ø±Ø¶Ù‡ Ù…Ø­ØµÙˆÙ„',0),(262803,7301,'pr','Froogle Ø¹Ø±Ø¶Ù‡ Ù…Ø­ØµÙˆÙ„',0),(262804,7301,'tr','Froogle Ã¼rÃ¼n besleme',0),(262805,7301,'pl','Froogle produktu',0),(262806,7301,'bg','Froogle Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ Ð·Ð° Ñ…Ñ€Ð°Ð½ÐµÐ½Ðµ',0),(262807,7301,'ur','ÙØ±ÙˆÚ¯Ù„ÛŒ Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ ÙÛŒÚˆ',0),(262808,7301,'sr','Ð¤Ñ€Ð¾Ð¾Ð³Ð»Ðµ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ Ð¤ÐµÐµÐ´',0),(262809,7301,'vi','Náº¡p sáº£n pháº©m Froogle',0),(262810,7301,'af','Froogle produk voed',0),(262811,7301,'ro','Froogle produs Feed',0),(262812,7301,'et','Froogle toote etteanne',0),(262813,7301,'si','Froogle Product krme',0),(262814,7301,'ba','Feed produk Froogle',0),(262815,7301,'nl','Froogle Product Feed',0),(262816,7301,'fi','Froogle tuote-syÃ¶tteen',0),(262817,7301,'no','Froogle produktet Feed',0),(262818,7301,'da','Froogle produkt foder',0),(262819,7301,'ko','Froogle ì œí’ˆ ê³µê¸‰',0),(262820,7301,'he','×”×ž×•×¦×¨ Froogle ×œ×”××›×™×œ',0),(262821,7301,'el','Î–Ï‰Î¿Ï„ÏÎ¿Ï†Î­Ï‚ Froogle Ï€ÏÎ¿ÏŠÏŒÎ½',0),(262822,7301,'zh','Froogleäº§å“èµ„æ–™\r\n',0),(262823,7301,'sv','Froogle produkt foder',0),(262824,7301,'it','Alimentazione del prodotto Froogle',0),(262825,7301,'tl','',0),(262826,7301,'th','Froogle Product Feed',0),(262827,7301,'hi','à¤«à¤¼à¥à¤°à¥‚à¤—à¤² à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤«à¤¼à¥€à¤¡',0),(262828,7301,'ms','Suapan produk Froogle',0),(262829,7301,'ar','Ø§Ù„Ù…Ù†ØªØ¬ ÙØ±ÙˆØºÙ„ÙŠ ØªØºØ°ÙŠØ©',0),(262830,7301,'fr','Flux de produits Froogle',0),(262831,7301,'jp','Froogle è£½å“ãƒ•ã‚£ãƒ¼ãƒ‰',0),(262832,7301,'pt','Froogle produto alimentar',0),(262833,7301,'ru','ÐŸÐ¾Ð´Ð°Ñ‡Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° Froogle',0),(262834,7301,'es','Froogle AlimentaciÃ³n del Producto',0),(262835,7301,'de','Froogle Produktzufuhr',0),(262836,7301,'en','Froogle Product Feed',0),(262837,7302,'is','',0),(262838,7302,'dr','Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙØªØ± ÙƒÙ„',0),(262839,7302,'pr','Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙØªØ± ÙƒÙ„',0),(262840,7302,'tr','Gelir GL hesabÄ±',0),(262841,7302,'pl','Rachunek dochodÃ³w GL',0),(262842,7302,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸ GL',0),(262843,7302,'ur','Ø¢Ù…Ø¯Ù†ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(262844,7302,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð° Ð“Ð›',0),(262845,7302,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Káº¿t Quáº£ Hoáº¡t Äá»™ng Kinh Doanh',0),(262846,7302,'af','Inkomste AG rekening',0),(262847,7302,'ro','GL contul',0),(262848,7302,'et','GL tulukonto',0),(262849,7302,'si','GL dohodkov',0),(262850,7302,'ba','Pendapatan GL Account',0),(262851,7302,'nl','GL WenV-rekening',0),(262852,7302,'fi','GL tulotili',0),(262853,7302,'no','Inntekt gi-konto',0),(262854,7302,'da','GL resultatopgÃ¸relseskontoen',0),(262855,7302,'ko','ìˆ˜ìž… GL ê³„ì •',0),(262856,7302,'he','×—×©×‘×•×Ÿ ×”×›× ×¡×•×ª GL',0),(262857,7302,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Ï„Î¿Ï… ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(262858,7302,'zh','æ”¶å…¥æ€»å¸å¸æˆ·\r\n',0),(262859,7302,'sv','GL avkastningskonto',0),(262860,7302,'it','Conto del reddito GL',0),(262861,7302,'tl','',0),(262862,7302,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;',0),(262863,7302,'hi','à¤†à¤¯ GL à¤–à¤¾à¤¤à¥‡',0),(262864,7302,'ms','Akaun GL pendapatan',0),(262865,7302,'ar','Ø­Ø³Ø§Ø¨ Ø¥ÙŠØ±Ø§Ø¯ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(262866,7302,'fr','Compte de revenu GL',0),(262867,7302,'jp','åŽå…¥ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(262868,7302,'pt','Renda GL conta',0),(262869,7302,'ru','Ð¡Ñ‡ÐµÑ‚ Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð² GL',0),(262870,7302,'es','Cuenta LM de Ingresos',0),(262871,7302,'de','GL Ertragskonto',0),(262872,7302,'en','Income GL Account',0),(262873,7303,'is','',0),(262874,7303,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø¯Ø§Ø®Ù„ÙŠ ',0),(262875,7303,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø¯Ø§Ø®Ù„ÙŠ ',0),(262876,7303,'tr','Dahili kod',0),(262877,7303,'pl','Identyfikator wewnÄ™trzny',0),(262878,7303,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐµÐ½ Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(262879,7303,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ø´Ù†Ø§Ø®Øª',0),(262880,7303,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð½Ð¸ Ð˜Ð”',0),(262881,7303,'vi','ID ná»™i bá»™',0),(262882,7303,'af','Interne ID',0),(262883,7303,'ro','ID intern',0),(262884,7303,'et','Sisemine ID',0),(262885,7303,'si','Interna Å¡tevilka',0),(262886,7303,'ba','Internal ID',0),(262887,7303,'nl','Interne ID',0),(262888,7303,'fi','SisÃ¤inen tunnus',0),(262889,7303,'no','Interne ID',0),(262890,7303,'da','Interne ID',0),(262891,7303,'ko','ë‚´ë¶€ ID',0),(262892,7303,'he','×ž×–×”×” ×¤× ×™×ž×™',0),(262893,7303,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÏŒÏ‚ Î±ÏƒÏ„Ï…Î½Î¿Î¼Î¹ÎºÎ® Ï„Î±Ï…Ï„ÏŒÏ„Î·Ï„Î±',0),(262894,7303,'zh','å†…éƒ¨èº«ä»½è¯\r\n',0),(262895,7303,'sv','Internt ID',0),(262896,7303,'it','ID interno',0),(262897,7303,'tl','',0),(262898,7303,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3616;&#3634;&#3618;&#3651;&#3609;',0),(262899,7303,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• ID',0),(262900,7303,'ms','ID dalaman',0),(262901,7303,'ar','Ù…Ø¹Ø±Ù‘Ù Ø¯Ø§Ø®Ù„ÙŠ',0),(262902,7303,'fr','ID interne',0),(262903,7303,'jp','å†…éƒ¨ ID',0),(262904,7303,'pt','ID interno',0),(262905,7303,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ð¹ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(262906,7303,'es','Internal ID',0),(262907,7303,'de','Interne ID',0),(262908,7303,'en','Internal ID',0),(262909,7304,'is','',0),(262910,7304,'dr','Ø¢ÙŠØ§ Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª',0),(262911,7304,'pr','Ø¢ÙŠØ§ Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª',0),(262912,7304,'tr','KullanÄ±labilir',0),(262913,7304,'pl','Jest dostÄ™pny',0),(262914,7304,'bg','Ð• Ð½Ð°Ð»Ð¸Ñ‡ÐµÐ½',0),(262915,7304,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ ÛÛ’',0),(262916,7304,'sr','ÐˆÐµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½',0),(262917,7304,'vi','ÄÃ£ cÃ³ sáºµn',0),(262918,7304,'af','Is Beskikbaar',0),(262919,7304,'ro','Este disponibil',0),(262920,7304,'et','On saadaval',0),(262921,7304,'si','Je na voljo',0),(262922,7304,'ba','Tersedia',0),(262923,7304,'nl','Is beschikbaar',0),(262924,7304,'fi','On saatavilla',0),(262925,7304,'no','Er tilgjengelig',0),(262926,7304,'da','Er tilgÃ¦ngelig',0),(262927,7304,'ko','ì‚¬ìš©í•  ìˆ˜',0),(262928,7304,'he','×–×ž×™×Ÿ',0),(262929,7304,'el','Î”Î¹Î±Ï„Î¯Î¸ÎµÏ„Î±Î¹',0),(262930,7304,'zh','æ˜¯å¯ç”¨\r\n',0),(262931,7304,'sv','Ã„r tillgÃ¤nglig',0),(262932,7304,'it','Ãˆ disponibile',0),(262933,7304,'tl','',0),(262934,7304,'th','&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3652;&#3604;&#3657;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(262935,7304,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¹à¥ˆ',0),(262936,7304,'ms','Disediakan',0),(262937,7304,'ar','ÙŠØªÙˆÙØ±',0),(262938,7304,'fr','Est disponible',0),(262939,7304,'jp','åˆ©ç”¨å¯èƒ½ãªãŒ',0),(262940,7304,'pt','EstÃ¡ disponÃ­vel',0),(262941,7304,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾',0),(262942,7304,'es','Es Disponible',0),(262943,7304,'de','Ist verfÃ¼gbar',0),(262944,7304,'en','Is Available',0),(262945,7305,'is','',0),(262946,7305,'dr','URL',0),(262947,7305,'pr','ÙƒØ§Ù„Ø§ URL',0),(262948,7305,'tr','Ã–ÄŸe URL\'si',0),(262949,7305,'pl','Adres URL elementu',0),(262950,7305,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ URL',0),(262951,7305,'ur','Ø´Û’ URL',0),(262952,7305,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° ÑÑ‚Ð°Ð²ÐºÐµ',0),(262953,7305,'vi','ÄÆ°á»ng dáº«n hÃ ng',0),(262954,7305,'af','Item BA (\"URL\")',0),(262955,7305,'ro','Element URL',0),(262956,7305,'et','Toote URL',0),(262957,7305,'si','Element URL',0),(262958,7305,'ba','Item URL',0),(262959,7305,'nl','Artikel URL',0),(262960,7305,'fi','Kohteen URL-osoite',0),(262961,7305,'no','URL for element',0),(262962,7305,'da','Vare URL',0),(262963,7305,'ko','í•­ëª© URL',0),(262964,7305,'he','×›×ª×•×‘×ª url ×©×œ ×¤×¨×™×˜',0),(262965,7305,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ URL',0),(262966,7305,'zh','é¡¹ç›®ç½‘å€\r\n',0),(262967,7305,'sv','Objektet URL',0),(262968,7305,'it','Elemento URL',0),(262969,7305,'tl','',0),(262970,7305,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; URL',0),(262971,7305,'hi','à¤†à¤‡à¤Ÿà¤® à¤¯à¥‚à¤†à¤°à¤à¤²',0),(262972,7305,'ms','Item URL',0),(262973,7305,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¹Ù†ØµØ±',0),(262974,7305,'fr','URL de l\'Ã©lÃ©ment',0),(262975,7305,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã® URL',0),(262976,7305,'pt','URL do item',0),(262977,7305,'ru','URL-Ð°Ð´Ñ€ÐµÑ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(262978,7305,'es','Item URL',0),(262979,7305,'de','Objekt-URL',0),(262980,7305,'en','Item URL',0),(262981,7306,'is','',0),(262982,7306,'dr','Ø¢Ø®Ø±ÙŠÙ† ØªØºÙŠÙŠØ±Ø§Øª ',0),(262983,7306,'pr','Ø¢Ø®Ø±ÙŠÙ† ØªØºÙŠÙŠØ±Ø§Øª ',0),(262984,7306,'tr','Son deÄŸiÅŸtirilme tarihi',0),(262985,7306,'pl','Data ostatniej modyfikacji:',0),(262986,7306,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(262987,7306,'ur','Ø¢Ø®Ø±ÛŒ Ø¨Ø§Ø± ØªØ±Ù…ÛŒÙ…',0),(262988,7306,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐµ Ð¸Ð·Ð¼ÐµÐ½Ðµ',0),(262989,7306,'vi','Chá»‰nh sá»­a cuá»‘i',0),(262990,7306,'af','Laaste Verander',0),(262991,7306,'ro','Ultima modificare',0),(262992,7306,'et','Viimati Muudetud',0),(262993,7306,'si','Zadnje spremembe',0),(262994,7306,'ba','Modifikasi terakhir',0),(262995,7306,'nl','Laatst gewijzigd',0),(262996,7306,'fi','Viimeksi muokattu',0),(262997,7306,'no','Sist endret',0),(262998,7306,'da','Sidst Ã¦ndret',0),(262999,7306,'ko','ë§ˆì§€ë§‰ìœ¼ë¡œ ìˆ˜ì •',0),(263000,7306,'he','×¢×•×“×›×Ÿ ×œ××—×¨×•× ×”',0),(263001,7306,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(263002,7306,'zh','æœ€åŽæ›´æ–°\r\n',0),(263003,7306,'sv','Ã„ndrades senast',0),(263004,7306,'it','Ultima modifica per la',0),(263005,7306,'tl','',0),(263006,7306,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(263007,7306,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¬à¤¾à¤° à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤',0),(263008,7306,'ms','Buat kali',0),(263009,7306,'ar','Ø¢Ø®Ø± ØªØ¹Ø¯ÙŠÙ„',0),(263010,7306,'fr','DerniÃ¨re modification',0),(263011,7306,'jp','æœ€å¾Œã«å¤‰æ›´ã•ã‚Œã¾ã—ãŸã€‚',0),(263012,7306,'pt','Ãšltima modificaÃ§Ã£o',0),(263013,7306,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(263014,7306,'es','Ãšltima ModificaciÃ³n',0),(263015,7306,'de','Zuletzt',0),(263016,7306,'en','Last Modified',0),(263017,7307,'is','',0),(263018,7307,'dr','ØªØºÙŠÙŠØ± Ø¢Ø®Ø±ÙŠÙ† Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯ ',0),(263019,7307,'pr','ØªØºÙŠÙŠØ± Ø¢Ø®Ø±ÙŠÙ† Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯ ',0),(263020,7307,'tr','GeÃ§en miktar kullanÄ±labilir deÄŸiÅŸiklik',0),(263021,7307,'pl','Ostatnia zmiana iloÅ›ci dostÄ™pnych',0),(263022,7307,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(263023,7307,'ur','Ø¢Ø®Ø±ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø³ØªÛŒØ§Ø¨ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(263024,7307,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(263025,7307,'vi','Thay Ä‘á»•i sá»‘ lÆ°á»£ng cÃ³ sáºµn cuá»‘i cÃ¹ng',0),(263026,7307,'af','Laaste Hoeveelheid Beskikbare Veranderinge',0),(263027,7307,'ro','Ultima schimbare cantitatea disponibilÄƒ',0),(263028,7307,'et','Viimase kogus kÃ¤ttesaadavaks muutmine',0),(263029,7307,'si','Zadnja sprememba koliÄine na voljo',0),(263030,7307,'ba','Perubahan terakhir kuantitas tersedia',0),(263031,7307,'nl','Laatste wijziging van de hoeveelheid beschikbaar',0),(263032,7307,'fi','Viimeinen mÃ¤Ã¤rÃ¤ saatavilla muutos',0),(263033,7307,'no','Siste antall tilgjengelige endringen',0),(263034,7307,'da','Sidste ledige mÃ¦ngdeÃ¦ndring',0),(263035,7307,'ko','ë§ˆì§€ë§‰ ìˆ˜ëŸ‰ ì‚¬ìš©í•  ìˆ˜ ë³€ê²½',0),(263036,7307,'he','×”××—×¨×•×Ÿ ×›×ž×•×ª ×–×ž×™× ×” ×©×™× ×•×™',0),(263037,7307,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î±Î»Î»Î±Î³Î® Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(263038,7307,'zh','æœ€åŽå¯ç”¨æ•°é‡å˜åŒ–\r\n',0),(263039,7307,'sv','Senaste tillgÃ¤ngliga KvantitetsÃ¤ndring',0),(263040,7307,'it','Ultima modifica di disponibili quantitÃ ',0),(263041,7307,'tl','',0),(263042,7307,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3652;&#3604;&#3657;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(263043,7307,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(263044,7307,'ms','Tarikh kuantiti ada perubahan',0),(263045,7307,'ar','Ø¢Ø®Ø± ÙƒÙ…ÙŠØ© Ø§Ù„ØªØºÙŠÙŠØ± Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(263046,7307,'fr','DerniÃ¨re modification de disponible de quantitÃ©',0),(263047,7307,'jp','æœ€å¾Œã®é‡ã®ä½¿ç”¨å¯èƒ½ãªå¤‰æ›´',0),(263048,7307,'pt','Ãšltima alteraÃ§Ã£o de quantidade disponÃ­vel',0),(263049,7307,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ñ…',0),(263050,7307,'es','Cambia de la Ãšltima Cantidad Disponible',0),(263051,7307,'de','Letzten verfÃ¼gbaren MengenÃ¤nderung',0),(263052,7307,'en','Last Quantity Available Change',0),(263053,7308,'is','',0),(263054,7308,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡ÙŠ ',0),(263055,7308,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡ÙŠ ',0),(263056,7308,'tr','Sorumluluk hesap',0),(263057,7308,'pl','Rachunek',0),(263058,7308,'bg','ÐŸÐ°ÑÐ¸Ð²Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(263059,7308,'ur','Ø°Ù…Û Ø¯Ø§Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(263060,7308,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð¿Ð°ÑÐ¸Ð²Ðµ',0),(263061,7308,'vi','TK CÃ´ng Ná»£',0),(263062,7308,'af','Laste Rekening',0),(263063,7308,'ro','Cont de rÄƒspundere',0),(263064,7308,'et','Kohustuste konto',0),(263065,7308,'si','Konta obveznosti',0),(263066,7308,'ba','Kewajiban Account',0),(263067,7308,'nl','Aansprakelijkheid rekening',0),(263068,7308,'fi','Vastuuta',0),(263069,7308,'no','Gjeldskonto',0),(263070,7308,'da','Passivkonto',0),(263071,7308,'ko','ì±…ìž„ ê³„ì •',0),(263072,7308,'he','××—×¨×™×•×ª ×—×©×‘×•×Ÿ',0),(263073,7308,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÎµÏ€Î¹Î²Î¬ÏÏ…Î½ÏƒÎ·Ï‚',0),(263074,7308,'zh','è´Ÿå€ºè´¦æˆ·\r\n',0),(263075,7308,'sv','Skuldkonto',0),(263076,7308,'it','Conto di responsabilitÃ ',0),(263077,7308,'tl','',0),(263078,7308,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3627;&#3609;&#3637;&#3657;&#3626;&#3636;&#3609;',0),(263079,7308,'hi','à¤¦à¤¾à¤¯à¤¿à¤¤à¥à¤µ à¤–à¤¾à¤¤à¤¾',0),(263080,7308,'ms','Akaun liabiliti',0),(263081,7308,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø³Ø¤ÙˆÙ„ÙŠØ©',0),(263082,7308,'fr','Compte de passif',0),(263083,7308,'jp','è² å‚µå‹˜å®š',0),(263084,7308,'pt','Conta de responsabilidade',0),(263085,7308,'ru','Ð¡Ñ‡ÐµÑ‚ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(263086,7308,'es','Cuenta de ObligaciÃ³n',0),(263087,7308,'de','Passivkonto',0),(263088,7308,'en','Liability Account',0),(263089,7309,'is','',0),(263090,7309,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ù…Ù‚Ø¯Ø§Ø± ',0),(263091,7309,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ù…Ù‚Ø¯Ø§Ø± ',0),(263092,7309,'tr','Minimum miktar',0),(263093,7309,'pl','Minimalna iloÅ›Ä‡',0),(263094,7309,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(263095,7309,'ur','Ú©Ù… Ø³Û’ Ú©Ù… Ù…Ù‚Ø¯Ø§Ø±',0),(263096,7309,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(263097,7309,'vi','Sá»‘ lÆ°á»£ng Tá»‘i thiá»ƒu',0),(263098,7309,'af','Minimum hoeveelheid',0),(263099,7309,'ro','Cantitatea minimÄƒ',0),(263100,7309,'et','Minimaalne kogus',0),(263101,7309,'si','Minimalna koliÄina',0),(263102,7309,'ba','Jumlah minimum',0),(263103,7309,'nl','Minimumhoeveelheid',0),(263104,7309,'fi','VÃ¤himmÃ¤ismÃ¤Ã¤rÃ¤',0),(263105,7309,'no','Minimumsantall',0),(263106,7309,'da','Minimum mÃ¦ngde',0),(263107,7309,'ko','ìµœì†Œ ìˆ˜ëŸ‰',0),(263108,7309,'he','×›×ž×•×ª ×ž×™× ×™×ž×œ×™×ª',0),(263109,7309,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(263110,7309,'zh','æœ€ä½Žæ•°é‡\r\n',0),(263111,7309,'sv','Minsta kvantitet',0),(263112,7309,'it','Quantitativo minimo',0),(263113,7309,'tl','',0),(263114,7309,'th','&#3588;&#3640;&#3603;&#3616;&#3634;&#3614;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(263115,7309,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(263116,7309,'ms','Kuantiti minimum',0),(263117,7309,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† Ø§Ù„ÙƒÙ…ÙŠØ©',0),(263118,7309,'fr','QuantitÃ© minimale',0),(263119,7309,'jp','æœ€å°æ•°é‡',0),(263120,7309,'pt','Quantidade mÃ­nima',0),(263121,7309,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ðµ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(263122,7309,'es','Cantidad MÃ­nima',0),(263123,7309,'de','Mindestmenge',0),(263124,7309,'en','Minimum Quantity',0),(263125,7310,'is','',0),(263126,7310,'dr','MPN Ù…Ø­ØªÙ…Ù„ ØªØ±ÙŠÙ† ØªØ¹Ø¯Ø§Ø¯',0),(263127,7310,'pr','MPN Ù…Ø­ØªÙ…Ù„ ØªØ±ÙŠÙ† ØªØ¹Ø¯Ø§Ø¯\r\n',0),(263128,7310,'tr','MPN',0),(263129,7310,'pl','MPN',0),(263130,7310,'bg','MPN',0),(263131,7310,'ur','Ø§ØªÙ¾Ù†',0),(263132,7310,'sr','ÐœÐŸÐ',0),(263133,7310,'vi','MPN',0),(263134,7310,'af','MPN',0),(263135,7310,'ro','MPN',0),(263136,7310,'et','MPN',0),(263137,7310,'si','MPN',0),(263138,7310,'ba','MPN',0),(263139,7310,'nl','MPN',0),(263140,7310,'fi','MPN',0),(263141,7310,'no','MPN',0),(263142,7310,'da','MPN',0),(263143,7310,'ko','MPN',0),(263144,7310,'he','MPN',0),(263145,7310,'el','MPN',0),(263146,7310,'zh','æœ€å¤§æ¦‚çŽ‡æ•°\r\n',0),(263147,7310,'sv','MPN',0),(263148,7310,'it','MPN',0),(263149,7310,'tl','',0),(263150,7310,'th','MPN',0),(263151,7310,'hi','à¤¸à¥€à¤ªà¥€à¤¸à¥€à¤¬à¥€',0),(263152,7310,'ms','MPN',0),(263153,7310,'ar','MPN',0),(263154,7310,'fr','NPP',0),(263155,7310,'jp','MPN',0),(263156,7310,'pt','MPN',0),(263157,7310,'ru','MPN',0),(263158,7310,'es','MPN',0),(263159,7310,'de','MPN',0),(263160,7310,'en','MPN',0),(263161,7311,'is','',0),(263162,7311,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ø¹Ø¯ÙŠ ',0),(263163,7311,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ø¹Ø¯ÙŠ ',0),(263164,7311,'tr','NexTag Kategori',0),(263165,7311,'pl','Kategoria NexTag',0),(263166,7311,'bg','NexTag ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(263167,7311,'ur','Ù†ÛŒØ§ØªÚ¯ Ø²Ù…Ø±Û',0),(263168,7311,'sr','ÐÐµxÑ‚Ð°Ð³ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(263169,7311,'vi','Thá»ƒ loáº¡i Nextag',0),(263170,7311,'af','Nextag kategorie',0),(263171,7311,'ro','Categoria de Nextag',0),(263172,7311,'et','Nextag kategooria',0),(263173,7311,'si','Nextag Kategorija',0),(263174,7311,'ba','Kategori Nextag',0),(263175,7311,'nl','Nextag categorie',0),(263176,7311,'fi','Nextag luokka',0),(263177,7311,'no','NexTag kategori',0),(263178,7311,'da','NexTag kategori',0),(263179,7311,'ko','Nextag ì¹´í…Œê³ ë¦¬',0),(263180,7311,'he','Nextag ×§×˜×’×•×¨×™×”',0),(263181,7311,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± NexTag',0),(263182,7311,'zh','Nextagåˆ†ç±»\r\n',0),(263183,7311,'sv','Nextag kategori',0),(263184,7311,'it','Categoria di NexTag',0),(263185,7311,'tl','',0),(263186,7311,'th','Nextag Category',0),(263187,7311,'hi','Nextag à¤¶à¥à¤°à¥‡à¤£à¥€',0),(263188,7311,'ms','Kategori Nextag',0),(263189,7311,'ar','Ø§Ù„ÙØ¦Ø© Nextag',0),(263190,7311,'fr','CatÃ©gorie NexTag',0),(263191,7311,'jp','Nextag ã‚«ãƒ†ã‚´ãƒª',0),(263192,7311,'pt','Categoria NexTag',0),(263193,7311,'ru','Nextag ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(263194,7311,'es','CategorÃ­a Nextag',0),(263195,7311,'de','NexTag-Kategorie',0),(263196,7311,'en','Nextag Category',0),(263197,7312,'is','',0),(263198,7312,'dr','Ø¹Ø±Ø¶Ù‡ Ù…Ø­ØµÙˆÙ„ Ø¨Ø¹Ø¯ÙŠ ',0),(263199,7312,'pr','Ø¹Ø±Ø¶Ù‡ Ù…Ø­ØµÙˆÙ„ Ø¨Ø¹Ø¯ÙŠ ',0),(263200,7312,'tr','NexTag Ã¼rÃ¼n besleme',0),(263201,7312,'pl','RSS produkt NexTag',0),(263202,7312,'bg','NexTag Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ Ð·Ð° Ñ…Ñ€Ð°Ð½ÐµÐ½Ðµ',0),(263203,7312,'ur','Ù†ÛŒØ§ØªÚ¯ Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ ÙÛŒÚˆ',0),(263204,7312,'sr','ÐÐ°Ñ…Ñ€Ð°Ð½Ð¸ ÐÐµxÑ‚Ð°Ð³ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(263205,7312,'vi','Náº¡p sáº£n pháº©m Nextag',0),(263206,7312,'af','Nextag produk voed',0),(263207,7312,'ro','Nextag produse Feed',0),(263208,7312,'et','Nextag toote etteanne',0),(263209,7312,'si','Nextag Product krme',0),(263210,7312,'ba','Feed produk Nextag',0),(263211,7312,'nl','Nextag Product Feed',0),(263212,7312,'fi','Nextag tuote-syÃ¶tteen',0),(263213,7312,'no','NexTag produktet Feed',0),(263214,7312,'da','NexTag produkt foder',0),(263215,7312,'ko','Nextag ì œí’ˆ ê³µê¸‰',0),(263216,7312,'he','×”×ž×•×¦×¨ Nextag ×œ×”××›×™×œ',0),(263217,7312,'el','Î–Ï‰Î¿Ï„ÏÎ¿Ï†Î­Ï‚ NexTag Ï€ÏÎ¿ÏŠÏŒÎ½',0),(263218,7312,'zh','Nextagäº§å“æ•°æ®èµ„æ–™\r\n',0),(263219,7312,'sv','Nextag produkt foder',0),(263220,7312,'it','Alimentazione del prodotto NexTag',0),(263221,7312,'tl','',0),(263222,7312,'th','Nextag Product Feed',0),(263223,7312,'hi','Nextag à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤«à¤¼à¥€à¤¡',0),(263224,7312,'ms','Suapan produk Nextag',0),(263225,7312,'ar','Ø¢Ø± Ø§Ù„Ù…Ù†ØªØ¬ Nextag',0),(263226,7312,'fr','Flux de produits NexTag',0),(263227,7312,'jp','Nextag è£½å“ãƒ•ã‚£ãƒ¼ãƒ‰',0),(263228,7312,'pt','NexTag produto alimentar',0),(263229,7312,'ru','ÐŸÐ¾Ð´Ð°Ñ‡Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° nextag',0),(263230,7312,'es','AlimentaciÃ³n del Producto Nextag',0),(263231,7312,'de','NexTag Produktzufuhr',0),(263232,7312,'en','Nextag Product Feed',0),(263233,7313,'is','',0),(263234,7313,'dr','- Ù„Ø§ÙŠÙ† ',0),(263235,7313,'pr','Ø¢Ù†- Ù„Ø§ÙŠÙ† ',0),(263236,7313,'tr','Online',0),(263237,7313,'pl','Online',0),(263238,7313,'bg','ÐžÐ½Ð»Ð°Ð¹Ð½',0),(263239,7313,'ur','Ø¢Ù† Ù„Ø§Ø¦Ù†',0),(263240,7313,'sr','ÐÐ° Ð¼Ñ€ÐµÐ¶Ð¸',0),(263241,7313,'vi','Trá»±c tuyáº¿n',0),(263242,7313,'af','Aanlyn',0),(263243,7313,'ro','Online',0),(263244,7313,'et','Online',0),(263245,7313,'si','Online',0),(263246,7313,'ba','Online',0),(263247,7313,'nl','Online',0),(263248,7313,'fi','Verkossa',0),(263249,7313,'no','Online',0),(263250,7313,'da','Online',0),(263251,7313,'ko','ì˜¨ë¼ì¸',0),(263252,7313,'he','×ž×§×•×•×Ÿ',0),(263253,7313,'el','Î£Îµ Î±Ï€ÎµÏ…Î¸ÎµÎ¯Î±Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(263254,7313,'zh','åœ¨çº¿\r\n',0),(263255,7313,'sv','Online',0),(263256,7313,'it','On-line',0),(263257,7313,'tl','',0),(263258,7313,'th','&#3629;&#3629;&#3609;&#3652;&#3621;&#3609;&#3660;',0),(263259,7313,'hi','à¤‘à¤¨à¤²à¤¾à¤‡à¤¨',0),(263260,7313,'ms','Dalam talian',0),(263261,7313,'ar','Ø¹Ù„Ù‰ Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(263262,7313,'fr','En ligne',0),(263263,7313,'jp','ã‚ªãƒ³ãƒ©ã‚¤ãƒ³',0),(263264,7313,'pt','On-line',0),(263265,7313,'ru','ÐžÐ½Ð»Ð°Ð¹Ð½',0),(263266,7313,'es','Enlinea',0),(263267,7313,'de','Online',0),(263268,7313,'en','Online',0),(263269,7314,'is','',0),(263270,7314,'dr','-Ù„Ø§ÙŠÙ†',0),(263271,7314,'pr','Ù‚ÙŠÙ…Øª Ø®Ø±ÙŠØ¯Ø§Ø± Ø¢Ù†-Ù„Ø§ÙŠÙ†',0),(263272,7314,'tr','Online mÃ¼ÅŸteri fiyat',0),(263273,7314,'pl','Cena klient online',0),(263274,7314,'bg','ÐžÐ½Ð»Ð°Ð¹Ð½ ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ° Ñ†ÐµÐ½Ð°',0),(263275,7314,'ur','Ø¢Ù† Ù„Ø§Ø¦Ù† Ú¯Ø§ÛÚ© Ù‚ÛŒÙ…Øª',0),(263276,7314,'sr','Ð¦ÐµÐ½Ð° Ð·Ð° ÐºÑƒÐ¿Ñ†Ð° Ð½Ð° Ð¼Ñ€ÐµÐ¶Ð¸',0),(263277,7314,'vi','GiÃ¡ khÃ¡ch hÃ ng trá»±c tuyáº¿n',0),(263278,7314,'af','Aanlyn Klante/KliÃ«nte Prys',0),(263279,7314,'ro','Pret client online',0),(263280,7314,'et','Online kliendihind',0),(263281,7314,'si','Cena online kupcev',0),(263282,7314,'ba','Harga konsumen online',0),(263283,7314,'nl','Online klant prijs',0),(263284,7314,'fi','Online asiakashinta',0),(263285,7314,'no','Online kundepris',0),(263286,7314,'da','Online kundeservice pris',0),(263287,7314,'ko','ì˜¨ë¼ì¸ ê³ ê° ê°€ê²©',0),(263288,7314,'he','×©×™×¨×•×ª ×œ×§×•×—×•×ª ×ž×§×•×•×Ÿ ×ž×—×™×¨',0),(263289,7314,'el','Î¤Î¹Î¼Î® ÏƒÎµ Î±Ï€ÎµÏ…Î¸ÎµÎ¯Î±Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ· Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(263290,7314,'zh','ç½‘ä¸Šå®¢æˆ·ä»·æ ¼\r\n',0),(263291,7314,'sv','Online kundpris',0),(263292,7314,'it','Prezzo cliente online',0),(263293,7314,'tl','',0),(263294,7314,'th','&#3619;&#3634;&#3588;&#3634;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3629;&#3629;&#3609;&#3652;&#3621;&#3609;&#3660;',0),(263295,7314,'hi','à¤‘à¤¨à¤²à¤¾à¤‡à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¥‚à¤²à¥à¤¯',0),(263296,7314,'ms','Harga pelanggan atas-talian',0),(263297,7314,'ar','Ø³Ø¹Ø± Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø¹Ù„Ù‰ Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(263298,7314,'fr','Prix client en ligne',0),(263299,7314,'jp','ã‚ªãƒ³ãƒ©ã‚¤ãƒ³é¡§å®¢ã®ä¾¡æ ¼',0),(263300,7314,'pt','PreÃ§o on-line ao cliente',0),(263301,7314,'ru','Ð¦ÐµÐ½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¾Ð½Ð»Ð°Ð¹Ð½',0),(263302,7314,'es','Precio de Cliente Enlinea',0),(263303,7314,'de','Online-Kunden-Preis',0),(263304,7314,'en','Online Customer Price',0),(263305,7315,'is','',0),(263306,7315,'dr','-Ù„Ø§ÙŠÙ† ',0),(263307,7315,'pr','Ø´Ø±Ø­ Ø¢Ù†-Ù„Ø§ÙŠÙ† ',0),(263308,7315,'tr','Online aÃ§Ä±klamasÄ±',0),(263309,7315,'pl','Online opis',0),(263310,7315,'bg','ÐžÐ½Ð»Ð°Ð¹Ð½ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(263311,7315,'ur','Ø¢Ù† Ù„Ø§Ø¦Ù† Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(263312,7315,'sr','ÐÐ° Ð¸Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚Ñƒ Ð¾Ð¿Ð¸Ñ',0),(263313,7315,'vi','MÃ´ táº£ trá»±c tuyáº¿n',0),(263314,7315,'af','Aanlyn Beskrywing',0),(263315,7315,'ro','Descriere online',0),(263316,7315,'et','Online kirjeldus',0),(263317,7315,'si','Online opis',0),(263318,7315,'ba','Deskripsi online',0),(263319,7315,'nl','Online beschrijving',0),(263320,7315,'fi','Online kuvaus',0),(263321,7315,'no','Nettbasert beskrivelse',0),(263322,7315,'da','Online beskrivelse',0),(263323,7315,'ko','ì˜¨ë¼ì¸ ì„¤ëª…',0),(263324,7315,'he','×ª×™××•×¨ ×‘××™× ×˜×¨× ×˜',0),(263325,7315,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® ÏƒÎµ Î±Ï€ÎµÏ…Î¸ÎµÎ¯Î±Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(263326,7315,'zh','ç½‘ä¸Šæè¿°\r\n',0),(263327,7315,'sv','Online beskrivning',0),(263328,7315,'it','Descrizione online',0),(263329,7315,'tl','',0),(263330,7315,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3629;&#3629;&#3609;&#3652;&#3621;&#3609;&#3660;',0),(263331,7315,'hi','à¤‘à¤¨à¤²à¤¾à¤‡à¤¨ à¤µà¤¿à¤µà¤°à¤£',0),(263332,7315,'ms','Penerangan dalam talian',0),(263333,7315,'ar','Ø§Ù„ÙˆØµÙ Ø¹Ù„Ù‰ Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(263334,7315,'fr','Description en ligne',0),(263335,7315,'jp','ã‚ªãƒ³ãƒ©ã‚¤ãƒ³ã®èª¬æ˜Ž',0),(263336,7315,'pt','DescriÃ§Ã£o on-line',0),(263337,7315,'ru','ÐžÐ½Ð»Ð°Ð¹Ð½ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(263338,7315,'es','DescripciÃ³n Enlinea',0),(263339,7315,'de','Online Beschreibung',0),(263340,7315,'en','Online Description',0),(263341,7316,'is','',0),(263342,7316,'dr','-Ù„Ø§ÙŠÙ†',0),(263343,7316,'pr','Ù†Ø§Ù… Ø¢Ù†-Ù„Ø§ÙŠÙ†',0),(263344,7316,'tr','Online adÄ±',0),(263345,7316,'pl','Online: Nazwa',0),(263346,7316,'bg','ÐžÐ½Ð»Ð°Ð¹Ð½ Ð¸Ð¼Ðµ',0),(263347,7316,'ur','Ø¢Ù† Ù„Ø§Ø¦Ù† Ú©Ø§ Ù†Ø§Ù…',0),(263348,7316,'sr','Ð˜Ð¼Ðµ Ð½Ð° Ð¸Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚Ñƒ',0),(263349,7316,'vi','TÃªn trá»±c tuyáº¿n',0),(263350,7316,'af','Aanlyn Naam',0),(263351,7316,'ro','Numele online',0),(263352,7316,'et','Online nimi',0),(263353,7316,'si','Online ime',0),(263354,7316,'ba','Nama online',0),(263355,7316,'nl','Online naam',0),(263356,7316,'fi','Online-nimi',0),(263357,7316,'no','Navnet',0),(263358,7316,'da','Online-navn',0),(263359,7316,'ko','ì˜¨ë¼ì¸ ì´ë¦„',0),(263360,7316,'he','×©× ×‘××™× ×˜×¨× ×˜',0),(263361,7316,'el','ÎŒÎ½Î¿Î¼Î± ÏƒÎµ Î±Ï€ÎµÏ…Î¸ÎµÎ¯Î±Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(263362,7316,'zh','åœ¨çº¿åç§°\r\n',0),(263363,7316,'sv','Online namn',0),(263364,7316,'it','Nome online',0),(263365,7316,'tl','',0),(263366,7316,'th','&#3594;&#3639;&#3656;&#3629;&#3629;&#3629;&#3609;&#3652;&#3621;&#3609;&#3660;',0),(263367,7316,'hi','à¤‘à¤¨à¤²à¤¾à¤‡à¤¨ à¤¨à¤¾à¤®',0),(263368,7316,'ms','Nama dalam talian',0),(263369,7316,'ar','Ø§Ø³Ù… Ø¹Ù„Ù‰ Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(263370,7316,'fr','Nom en ligne',0),(263371,7316,'jp','ã‚ªãƒ³ãƒ©ã‚¤ãƒ³ã®åå‰',0),(263372,7316,'pt','Nome on-line',0),(263373,7316,'ru','ÐžÐ½Ð»Ð°Ð¹Ð½ Ð˜Ð¼Ñ',0),(263374,7316,'es','Nombre Enlinea',0),(263375,7316,'de','Online-Namen',0),(263376,7316,'en','Online Name',0),(263377,7317,'is','',0),(263378,7317,'dr','-Ù„Ø§ÙŠÙ† ',0),(263379,7317,'pr','Ù‚ÙŠÙ…Øª Ø¢Ù†-Ù„Ø§ÙŠÙ† ',0),(263380,7317,'tr','Online fiyat',0),(263381,7317,'pl','Online Cena',0),(263382,7317,'bg','ÐžÐ½Ð»Ð°Ð¹Ð½ Ñ†ÐµÐ½Ð°',0),(263383,7317,'ur','Ø¢Ù† Ù„Ø§Ø¦Ù† Ù‚ÛŒÙ…Øª',0),(263384,7317,'sr','ÐžÐ½Ð»Ð¸Ð½Ðµ Ñ†ÐµÐ½Ð°',0),(263385,7317,'vi','GiÃ¡ trá»±c tuyáº¿n',0),(263386,7317,'af','Aanlyn Prys',0),(263387,7317,'ro','Pret online',0),(263388,7317,'et','Online hind',0),(263389,7317,'si','Online cene',0),(263390,7317,'ba','Harga online',0),(263391,7317,'nl','Online prijs',0),(263392,7317,'fi','Online hinta',0),(263393,7317,'no','Online pris',0),(263394,7317,'da','Online pris',0),(263395,7317,'ko','ì˜¨ë¼ì¸ ê°€ê²©',0),(263396,7317,'he','×ž×—×™×¨ ××•× ×œ×™×™×Ÿ',0),(263397,7317,'el','Î¤Î™ÎœÎ— online',0),(263398,7317,'zh','ç½‘ä¸Šä»·æ ¼\r\n',0),(263399,7317,'sv','Online pris',0),(263400,7317,'it','Prezzo on-line',0),(263401,7317,'tl','',0),(263402,7317,'th','&#3619;&#3634;&#3588;&#3634;&#3629;&#3629;&#3609;&#3652;&#3621;&#3609;&#3660;',0),(263403,7317,'hi','à¤‘à¤¨à¤²à¤¾à¤‡à¤¨ à¤®à¥‚à¤²à¥à¤¯',0),(263404,7317,'ms','Harga dalam talian',0),(263405,7317,'ar','Ø§Ù„Ø³Ø¹Ø± Ø¹Ù„Ù‰ Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(263406,7317,'fr','Prix en ligne',0),(263407,7317,'jp','ã‚ªãƒ³ãƒ©ã‚¤ãƒ³ä¾¡æ ¼',0),(263408,7317,'pt','PreÃ§o on-line',0),(263409,7317,'ru','ÐžÐ½Ð»Ð°Ð¹Ð½ Ð¦ÐµÐ½Ð°',0),(263410,7317,'es','Precio Enlinea',0),(263411,7317,'de','Online-Preis',0),(263412,7317,'en','Online Price',0),(263413,7318,'is','',0),(263414,7318,'dr','Ù†ÙˆØ¹ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„ÙŠ',0),(263415,7318,'pr','Ù†ÙˆØ¹ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„ÙŠ',0),(263416,7318,'tr','Toplam miktar fiyat tÃ¼rÃ¼',0),(263417,7318,'pl','OgÃ³lna iloÅ›Ä‡ cen typu',0),(263418,7318,'bg','ÐžÐ±Ñ‰Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ñ‚Ð¸Ð¿',0),(263419,7318,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ø·ÙˆØ± Ù¾Ø± Ù‚ÛŒ Ù‚Ø³Ù… Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(263420,7318,'sr','Ð¢Ð¸Ð¿ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ð£ÐºÑƒÐ¿Ð½Ð° ÐºÐ¾Ð».',0),(263421,7318,'vi','HÆ¡n loáº¡i giÃ¡ sá»‘ lÆ°á»£ng',0),(263422,7318,'af','Algehele Qty pryse-tipe',0),(263423,7318,'ro','Total cantitate tarifarea tip',0),(263424,7318,'et','Ãœldine kogus hinnakujunduse tÃ¼Ã¼p',0),(263425,7318,'si','SploÅ¡no kol cenitev tipa',0),(263426,7318,'ba','Keseluruhan Qty harga tipe',0),(263427,7318,'nl','Totale aantal prijzen Type',0),(263428,7318,'fi','MÃ¤Ã¤rÃ¤ hinnoittelu tyyppi',0),(263429,7318,'no','Samlet antall priser Type',0),(263430,7318,'da','Samlede antal prissÃ¦tning Type',0),(263431,7318,'ko','ì „ì²´ ìˆ˜ëŸ‰ ê°€ê²© ìœ í˜•',0),(263432,7318,'he','×¡×•×’ ×ª×ž×—×•×¨ ×›×ž×•×ª ×©×œ ×”×›×œ×œ×™×ª',0),(263433,7318,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· Ï„ÏÏ€Î¿Ï‚ Î Î¿Ïƒ.',0),(263434,7318,'zh','æ€»ä½“æ•°é‡å®šä»·ç±»åž‹\r\n',0),(263435,7318,'sv','Totala antal prissÃ¤ttning typ',0),(263436,7318,'it','Tipo di valutazione globale Qty',0),(263437,7318,'tl','',0),(263438,7318,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3619;&#3634;&#3588;&#3634;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3619;&#3623;&#3617;&#3607;&#3633;&#3657;&#3591;&#3626;&#3636;&#3657;&#3609;',0),(263439,7318,'hi','à¤¸à¤®à¤—à¥à¤° à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(263440,7318,'ms','Keseluruhan Qty harga jenis',0),(263441,7318,'ar','Ù†ÙˆØ¹ Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ©',0),(263442,7318,'fr','Type de prix QtÃ© total',0),(263443,7318,'jp','å…¨ä½“çš„ãªæ•°é‡ä¾¡æ ¼ã‚¿ã‚¤ãƒ—',0),(263444,7318,'pt','Tipo geral de preÃ§os do Qty',0),(263445,7318,'ru','ÐžÐ±Ñ‰ÐµÐµ ÐšÐ¾Ð»-Ð²Ð¾ Ñ†ÐµÐ½Ñ‹ Ñ‚Ð¸Ð¿Ð°',0),(263446,7318,'es','Cantidad en General de Tipo de Precios',0),(263447,7318,'de','Insgesamt Qty-Preise-Typ',0),(263448,7318,'en','Overall Qty Pricing Type',0),(263449,7319,'is','',0),(263450,7319,'dr','Ø³Ø·Ø­ Ø³Ù‡Ø§Ù… Ù…Ù…ØªØ§Ø²',0),(263451,7319,'pr','Ø³Ø·Ø­ Ø³Ù‡Ø§Ù… Ù…Ù…ØªØ§Ø²',0),(263452,7319,'tr','Tercih edilen stok dÃ¼zeyi',0),(263453,7319,'pl','Poziom akcji uprzywilejowanych',0),(263454,7319,'bg','ÐŸÑ€Ð¸Ð²Ð¸Ð»ÐµÐ³Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸ Ð°ÐºÑ†Ð¸Ð¸ Ð½Ð¸Ð²Ð¾',0),(263455,7319,'ur','Ù¾Ø±ÛŒÙØ±Ù‚Ø±ÛŒØ¯ Ø§Ø³Ù¹Ø§Ú© Ø³Ø·Ø­',0),(263456,7319,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ð½Ð¸Ð²Ð¾',0),(263457,7319,'vi','Má»©c hÃ ng tá»“n Æ°a thÃ­ch',0),(263458,7319,'af','Verkose Voorraadvlak',0),(263459,7319,'ro','Nivel de acÅ£iuni preferenÅ£iale',0),(263460,7319,'et','Eelistatud varude tase',0),(263461,7319,'si','Prednostnimi ravni',0),(263462,7319,'ba','Saham preferen tingkat',0),(263463,7319,'nl','Preferente aandelen niveau',0),(263464,7319,'fi','Preferred Stock taso',0),(263465,7319,'no','Foretrukne aksjer nivÃ¥',0),(263466,7319,'da','Foretrukne lager niveau',0),(263467,7319,'ko','ìš°ì„ ì£¼ ìˆ˜ì¤€',0),(263468,7319,'he','×ž× ×™×™×ª ×¨×ž×”',0),(263469,7319,'el','Î•Ï€Î¯Ï€ÎµÎ´Î¿ Ï„Ï‰Î½ Ï€ÏÎ¿Î½Î¿Î¼Î¹Î¿ÏÏ‡Ï‰Î½ Î¼ÎµÏ„Î¿Ï‡ÏŽÎ½',0),(263470,7319,'zh','ä¼˜å…ˆè‚¡æ°´å¹³\r\n',0),(263471,7319,'sv','Preferensaktier nivÃ¥',0),(263472,7319,'it','Livello di azioni privilegiate',0),(263473,7319,'tl','',0),(263474,7319,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3657;&#3634;&#3609;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(263475,7319,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥à¤¤à¤°',0),(263476,7319,'ms','Saham keutamaan tahap',0),(263477,7319,'ar','Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ù…Ù…ØªØ§Ø²Ø©',0),(263478,7319,'fr','Niveau d\'actions privilÃ©giÃ©es',0),(263479,7319,'jp','å„ªå…ˆæ ªå¼ã®ãƒ¬ãƒ™ãƒ«',0),(263480,7319,'pt','NÃ­vel de aÃ§Ãµes preferenciais',0),(263481,7319,'ru','ÐŸÑ€Ð¸Ð²Ð¸Ð»ÐµÐ³Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð°ÐºÑ†Ð¸Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ',0),(263482,7319,'es','Nivel de Stock Preferido',0),(263483,7319,'de','Vorzugsaktien Ebene',0),(263484,7319,'en','Preferred Stock Level',0),(263485,7320,'is','',0),(263486,7320,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ù…ØªØ§Ø²',0),(263487,7320,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ù…ØªØ§Ø²',0),(263488,7320,'tr','Tercih edilen satÄ±cÄ±',0),(263489,7320,'pl','Preferowanego dostawcy',0),(263490,7320,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(263491,7320,'ur','ØªØ±Ø¬ÛŒØ­ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(263492,7320,'sr','ÐŸÑ€ÐµÑ„ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡',0),(263493,7320,'vi','NgÆ°á»i bÃ¡n Æ°a thÃ­ch',0),(263494,7320,'af','Verkiesde Verskaffer',0),(263495,7320,'ro','Furnizor preferat',0),(263496,7320,'et','Eelistatud tarnija',0),(263497,7320,'si','Prednostni dobavitelj',0),(263498,7320,'ba','Disukai Vendor',0),(263499,7320,'nl','Preferente leverancier',0),(263500,7320,'fi','Ensisijaisen toimittajan',0),(263501,7320,'no','Foretrukket leverandÃ¸r',0),(263502,7320,'da','Foretrukne leverandÃ¸r',0),(263503,7320,'ko','ê¸°ë³¸ ê³µê¸‰ ì—…ì²´',0),(263504,7320,'he','×¡×¤×§ ×ž×•×¢×“×£',0),(263505,7320,'el','Î ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(263506,7320,'zh','é¦–é€‰ä¾›åº”å•†\r\n',0),(263507,7320,'sv','Prioriterad leverantÃ¶r',0),(263508,7320,'it','Fornitore preferito',0),(263509,7320,'tl','',0),(263510,7320,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(263511,7320,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(263512,7320,'ms','Vendor pilihan utama',0),(263513,7320,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø§Ù„Ù…ÙØ¶Ù‘Ù„',0),(263514,7320,'fr','Fournisseur prÃ©fÃ©rÃ©',0),(263515,7320,'jp','æœ€å¯„ã‚Šã®ãƒ™ãƒ³ãƒ€ãƒ¼',0),(263516,7320,'pt','Fornecedor preferencial',0),(263517,7320,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº',0),(263518,7320,'es','Proveedor Preferido',0),(263519,7320,'de','Bevorzugter Lieferant',0),(263520,7320,'en','Preferred Vendor',0),(263521,7321,'is','',0),(263522,7321,'dr','Ú¯Ø±ÙˆÙ‡ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(263523,7321,'pr','Ú¯Ø±ÙˆÙ‡ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(263524,7321,'tr','Fiyat grubu',0),(263525,7321,'pl','Grupy cenowe',0),(263526,7321,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(263527,7321,'ur','Ú¯Ø±ÙˆÙ¾ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(263528,7321,'sr','Ð¦ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ð³Ñ€ÑƒÐ¿Ðµ',0),(263529,7321,'vi','NhÃ³m giÃ¡',0),(263530,7321,'af','Pryse van groep',0),(263531,7321,'ro','Grup de stabilire a preÅ£urilor',0),(263532,7321,'et','Hinnakujunduse grupp',0),(263533,7321,'si','Cenovne skupine',0),(263534,7321,'ba','Harga kelompok',0),(263535,7321,'nl','Groep prijzen',0),(263536,7321,'fi','Hinnoittelu ryhmÃ¤n',0),(263537,7321,'no','Priser gruppe',0),(263538,7321,'da','PrissÃ¦tning gruppe',0),(263539,7321,'ko','ê°€ê²© ê·¸ë£¹',0),(263540,7321,'he','×ª×ž×—×•×¨ ×§×‘×•×¦×”',0),(263541,7321,'el','ÎŸÎ¼Î¬Î´Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(263542,7321,'zh','ä»·æ ¼å°ç»„\r\n',0),(263543,7321,'sv','PrissÃ¤ttning grupp',0),(263544,7321,'it','Prezzi di gruppo',0),(263545,7321,'tl','',0),(263546,7321,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;',0),(263547,7321,'hi','à¤¸à¤®à¥‚à¤¹ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(263548,7321,'ms','Harga Kumpulan',0),(263549,7321,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(263550,7321,'fr','Prix de groupe',0),(263551,7321,'jp','ä¾¡æ ¼ã‚°ãƒ«ãƒ¼ãƒ—',0),(263552,7321,'pt','Grupo de preÃ§os',0),(263553,7321,'ru','Ð¦ÐµÐ½Ð¾Ð²Ð°Ñ Ð“Ñ€ÑƒÐ¿Ð¿Ð°',0),(263554,7321,'es','Grupo de FijaciÃ³n de Precios',0),(263555,7321,'de','Preise Gruppe',0),(263556,7321,'en','Pricing Group',0),(263557,7322,'is','',0),(263558,7322,'dr','Ø´Ø±Ø­ Ø®Ø±ÙŠØ¯ ',0),(263559,7322,'pr','Ø´Ø±Ø­ Ø®Ø±ÙŠØ¯ ',0),(263560,7322,'tr','SatÄ±nalma aÃ§Ä±klamasÄ±',0),(263561,7322,'pl','Opis zakupu',0),(263562,7322,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(263563,7322,'ur','ØªÙØµÛŒÙ„ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(263564,7322,'sr','ÐžÐ¿Ð¸Ñ Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(263565,7322,'vi','MÃ´ táº£ mua hÃ ng',0),(263566,7322,'af','Aankoop Beskrywing',0),(263567,7322,'ro','Descriere de cumpÄƒrare',0),(263568,7322,'et','Ostu kirjeldus',0),(263569,7322,'si','Nakup opis',0),(263570,7322,'ba','Deskripsi pembelian',0),(263571,7322,'nl','Aankoop beschrijving',0),(263572,7322,'fi','Oston kuvaus',0),(263573,7322,'no','KjÃ¸p beskrivelse',0),(263574,7322,'da','KÃ¸b beskrivelse',0),(263575,7322,'ko','êµ¬ë§¤ ì„¤ëª…',0),(263576,7322,'he','×ª×™××•×¨ ×¨×›×™×©×”',0),(263577,7322,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ Î±Î³Î¿ÏÎ¬Ï‚',0),(263578,7322,'zh','è´­ä¹°è¯´æ˜Ž\r\n',0),(263579,7322,'sv','KÃ¶p Beskrivning',0),(263580,7322,'it','Acquisto Descrizione',0),(263581,7322,'tl','',0),(263582,7322,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(263583,7322,'hi','à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤µà¤¿à¤µà¤°à¤£',0),(263584,7322,'ms','Keterangan pembelian',0),(263585,7322,'ar','ÙˆØµÙ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(263586,7322,'fr','Description de l\'achat',0),(263587,7322,'jp','è³¼è²·ã®èª¬æ˜Ž',0),(263588,7322,'pt','DescriÃ§Ã£o da compra',0),(263589,7322,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(263590,7322,'es','DescripciÃ³n de Compra',0),(263591,7322,'de','Kauf Beschreibung',0),(263592,7322,'en','Purchase Description',0),(263593,7323,'is','',0),(263594,7323,'dr','Ù‚ÙŠÙ…Øª Ø®Ø±ÙŠØ¯ ',0),(263595,7323,'pr','Ù‚ÙŠÙ…Øª Ø®Ø±ÙŠØ¯ ',0),(263596,7323,'tr','SatÄ±n alma fiyatÄ±',0),(263597,7323,'pl','Ceny zakupu',0),(263598,7323,'bg','ÐŸÐ¾ÐºÑƒÐ¿Ð½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð°',0),(263599,7323,'ur','Ù‚ÛŒÙ…Øª Ø®Ø±ÛŒØ¯',0),(263600,7323,'sr','ÐÐ°Ð±Ð°Ð²Ð½Ð° Ñ†ÐµÐ½Ð°',0),(263601,7323,'vi','GiÃ¡ mua',0),(263602,7323,'af','Aankoopprys',0),(263603,7323,'ro','PreÅ£ul de cumpÄƒrare',0),(263604,7323,'et','Ostuhind',0),(263605,7323,'si','Nakupna cena',0),(263606,7323,'ba','Harga pembelian',0),(263607,7323,'nl','Aankoopprijs',0),(263608,7323,'fi','Ostohinta',0),(263609,7323,'no','KjÃ¸pesummen',0),(263610,7323,'da','KÃ¸bsprisen',0),(263611,7323,'ko','êµ¬ìž… ê°€ê²©',0),(263612,7323,'he','×ž×—×™×¨ ×¨×›×™×©×”',0),(263613,7323,'el','Î¤Î¹Î¼Î® Î±Î³Î¿ÏÎ¬Ï‚',0),(263614,7323,'zh','è´­ä¹°ä»·æ ¼\r\n',0),(263615,7323,'sv','InkÃ¶pspriset',0),(263616,7323,'it','Prezzo d\'acquisto',0),(263617,7323,'tl','',0),(263618,7323,'th','&#3619;&#3634;&#3588;&#3634;&#3595;&#3639;&#3657;&#3629;',0),(263619,7323,'hi','à¤–à¤°à¥€à¤¦ à¤®à¥‚à¤²à¥à¤¯',0),(263620,7323,'ms','Harga belian',0),(263621,7323,'ar','Ø³Ø¹Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(263622,7323,'fr','Prix d\'achat',0),(263623,7323,'jp','è³¼å…¥ä¾¡æ ¼',0),(263624,7323,'pt','PreÃ§o de compra',0),(263625,7323,'ru','ÐŸÐ¾ÐºÑƒÐ¿Ð½Ð°Ñ Ñ†ÐµÐ½Ð°',0),(263626,7323,'es','Precio de Compra',0),(263627,7323,'de','Kaufpreis',0),(263628,7323,'en','Purchase Price',0),(263629,7324,'is','',0),(263630,7324,'dr','Ø¬Ø¯ÙˆÙ„ Ù…Ù‚Ø¯Ø§Ø±  Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(263631,7324,'pr','Ø¬Ø¯ÙˆÙ„ Ù…Ù‚Ø¯Ø§Ø±  Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(263632,7324,'tr','Zamanlama fiyatlandÄ±rma miktarÄ±',0),(263633,7324,'pl','IloÅ›Ä‡ cen harmonogram',0),(263634,7324,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð³Ñ€Ð°Ñ„Ð¸Ðº',0),(263635,7324,'ur','Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ù…Ù‚Ø¯Ø§Ø±',0),(263636,7324,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´',0),(263637,7324,'vi','Káº¿ hoáº¡ch giÃ¡ Sá»‘ lÆ°á»£ng',0),(263638,7324,'af','Hoeveelheid pryse Bylae',0),(263639,7324,'ro','Cantitatea preturi program',0),(263640,7324,'et','Koguse hindamise ajakava',0),(263641,7324,'si','KoliÄina cenitev urnik',0),(263642,7324,'ba','Jumlah harga jadwal',0),(263643,7324,'nl','Hoeveelheid prijzen schema',0),(263644,7324,'fi','MÃ¤Ã¤rÃ¤ hinnoittelu aikataulu',0),(263645,7324,'no','Antall priser tidsplan',0),(263646,7324,'da','MÃ¦ngde prissÃ¦tning tidsplan',0),(263647,7324,'ko','ì¼ì • ê°€ê²© ìˆ˜ëŸ‰',0),(263648,7324,'he','×›×ž×•×ª ×ª×ž×—×•×¨ ×œ×•×— ×”×–×ž× ×™×',0),(263649,7324,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· Ï‡ÏÎ¿Î½Î¿Î´Î¹Î¬Î³ÏÎ±Î¼Î¼Î±',0),(263650,7324,'zh','æ•°é‡ä»·ç›®è¡¨\r\n',0),(263651,7324,'sv','Kvantitet prissÃ¤ttning schema',0),(263652,7324,'it','QuantitÃ  prezzi Schedule',0),(263653,7324,'tl','',0),(263654,7324,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3648;&#3623;&#3621;&#3634;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3588;&#3634;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(263655,7324,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤…à¤¨à¥à¤¸à¥‚à¤šà¥€ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(263656,7324,'ms','Kuantiti harga Jadual',0),(263657,7324,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø²Ù…Ù†ÙŠ',0),(263658,7324,'fr','Liste de prix de quantitÃ©',0),(263659,7324,'jp','æ•°é‡ä¾¡æ ¼ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ«',0),(263660,7324,'pt','Quantidade preÃ§os programaÃ§Ã£o',0),(263661,7324,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ†ÐµÐ½Ñ‹ Ñ€Ð°ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(263662,7324,'es','Cantidad Agenda de Precios',0),(263663,7324,'de','Menge Preise Zeitplan',0),(263664,7324,'en','Quantity Pricing Schedule',0),(263665,7325,'is','',0),(263666,7325,'dr','Ù†Ù‚Ø·Ù‡ Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(263667,7325,'pr','Ù†Ù‚Ø·Ù‡ Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(263668,7325,'tr','Yeniden sipariÅŸ noktasÄ±',0),(263669,7325,'pl','Ponow.',0),(263670,7325,'bg','Ð¢Ð¾Ñ‡ÐºÐ° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(263671,7325,'ur','Ø±ÛŒÚ©Ø§Ø±ÚˆØ± Ù¾ÙˆØ§Ø¦Ù†Ù¹',0),(263672,7325,'sr','Ð¢Ð°Ñ‡ÐºÐ° Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(263673,7325,'vi','Äiá»ƒm Ä‘áº·t hÃ ng láº¡i',0),(263674,7325,'af','Herbestellingsvlak',0),(263675,7325,'ro','Punct reluare comandÄƒ',0),(263676,7325,'et','Kordustellimuse tase',0),(263677,7325,'si','Signalna',0),(263678,7325,'ba','Menyusun ulang titik',0),(263679,7325,'nl','Bestelpunt',0),(263680,7325,'fi','Uusintatilauspiste',0),(263681,7325,'no','Gjenbestillingspunkt',0),(263682,7325,'da','Genbestillingspunktet',0),(263683,7325,'ko','ìž¬ì£¼ë¬¸ ì ',0),(263684,7325,'he','× ×§×•×“×ª ×—×™×“×•×©',0),(263685,7325,'el','Î£Î·Î¼ÎµÎ¯Î¿ Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(263686,7325,'zh','å†è®¢è´§ç‚¹\r\n',0),(263687,7325,'sv','BestÃ¤llningspunkten',0),(263688,7325,'it','Punto di riordino',0),(263689,7325,'tl','',0),(263690,7325,'th','&#3605;&#3635;&#3649;&#3627;&#3609;&#3656;&#3591;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(263691,7325,'hi','à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¬à¤¾à¤¤',0),(263692,7325,'ms','Susun semula titik',0),(263693,7325,'ar','Ù†Ù‚Ø·Ø© Ø¥Ø¹Ø§Ø¯Ø© Ø§Ù„Ø·Ù„Ø¨',0),(263694,7325,'fr','Point de rÃ©approvisionnement',0),(263695,7325,'jp','ç™ºæ³¨ç‚¹',0),(263696,7325,'pt','Ponto de reposiÃ§Ã£o',0),(263697,7325,'ru','Ð¢Ð¾Ñ‡ÐºÐ° Ð´Ð¾Ð·Ð°ÐºÐ°Ð·Ð°',0),(263698,7325,'es','Punto de Reordenar',0),(263699,7325,'de','Bestellpunkt',0),(263700,7325,'en','Reorder Point',0),(263701,7326,'is','',0),(263702,7326,'dr','Ù‚ÙŠÙ…Øª Ø®Ø±Ø¯Ù‡ ÙØ±ÙˆØ´Ù‰',0),(263703,7326,'pr','Ù‚ÙŠÙ…Øª Ø®Ø±Ø¯Ù‡ ÙØ±ÙˆØ´Ù‰',0),(263704,7326,'tr','Perakende satÄ±ÅŸ fiyatÄ±',0),(263705,7326,'pl','Cena detaliczna',0),(263706,7326,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° Ð´Ñ€ÐµÐ±Ð½Ð¾',0),(263707,7326,'ur','Ø®ÙˆØ±Ø¯Û Ù‚ÛŒÙ…Øª',0),(263708,7326,'sr','ÐœÐ°Ð»Ð¾Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ðµ Ñ†ÐµÐ½Ðµ',0),(263709,7326,'vi','GiÃ¡ bÃ¡n láº»',0),(263710,7326,'af','Kleinhandel Prys',0),(263711,7326,'ro','Pret cu amÄƒnuntul',0),(263712,7326,'et','Jaehind',0),(263713,7326,'si','Maloprodajna cena',0),(263714,7326,'ba','Harga eceran',0),(263715,7326,'nl','Verkoopprijs',0),(263716,7326,'fi','VÃ¤hittÃ¤ismyyntihinta',0),(263717,7326,'no','Utsalgspris',0),(263718,7326,'da','Udsalgspris',0),(263719,7326,'ko','ì†Œë§¤ ê°€ê²©',0),(263720,7326,'he','×ž×—×™×¨ ×œ×¦×¨×›×Ÿ:',0),(263721,7326,'el','Î›Î¹Î±Î½Î¹ÎºÎ® Ï„Î¹Î¼Î®',0),(263722,7326,'zh','é›¶å”®ä»·\r\n',0),(263723,7326,'sv','Detaljhandelspriset',0),(263724,7326,'it','Prezzo di vendita al dettaglio',0),(263725,7326,'tl','',0),(263726,7326,'th','&#3619;&#3634;&#3588;&#3634;&#3586;&#3634;&#3618;&#3611;&#3621;&#3637;&#3585;',0),(263727,7326,'hi','à¤–à¥à¤¦à¤°à¤¾ à¤®à¥‚à¤²à¥à¤¯',0),(263728,7326,'ms','Harga runcit',0),(263729,7326,'ar','Ø³Ø¹Ø± Ø§Ù„ØªØ¬Ø²Ø¦Ø©',0),(263730,7326,'fr','Prix de vente au dÃ©tail',0),(263731,7326,'jp','ãƒ¡ãƒ¼ã‚«ãƒ¼å¸Œæœ›å°å£²ä¾¡æ ¼',0),(263732,7326,'pt','PreÃ§o de varejo',0),(263733,7326,'ru','Ð Ð¾Ð·Ð½Ð¸Ñ‡Ð½Ð°Ñ Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(263734,7326,'es','Precio al Consumidor',0),(263735,7326,'de','Empfohlener Verkaufspreis',0),(263736,7326,'en','Retail Price',0),(263737,7327,'is','',0),(263738,7327,'dr','ÙˆØ§Ø­Ø¯ ÙØ±ÙˆØ´ ',0),(263739,7327,'pr','ÙˆØ§Ø­Ø¯ ÙØ±ÙˆØ´ ',0),(263740,7327,'tr','SatÄ±ÅŸ birimi',0),(263741,7327,'pl','Jednostka sprzedaÅ¼y',0),(263742,7327,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(263743,7327,'ur','ÙØ±ÙˆØ®Øª ÛŒÙˆÙ†Ù¹',0),(263744,7327,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ñƒ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(263745,7327,'vi','ÄÆ¡n vá»‹ bÃ¡n hÃ ng',0),(263746,7327,'af','Verkoopseenheid',0),(263747,7327,'ro','Unitate de vanzare',0),(263748,7327,'et','MÃ¼Ã¼k Ã¼ksus',0),(263749,7327,'si','Enota za prodajo',0),(263750,7327,'ba','Unit penjualan',0),(263751,7327,'nl','Verkoop eenheid',0),(263752,7327,'fi','MyytÃ¤vÃ¤nÃ¤ yksikkÃ¶',0),(263753,7327,'no','Salg enhet',0),(263754,7327,'da','Salg enhed',0),(263755,7327,'ko','íŒë§¤ ë‹¨ìœ„',0),(263756,7327,'he','×™×—×™×“×ª ×ž×›×™×¨×”',0),(263757,7327,'el','Î ÏŽÎ»Î·ÏƒÎ· Î¼Î¿Î½Î¬Î´Î±',0),(263758,7327,'zh','é”€å”®å•ä½\r\n',0),(263759,7327,'sv','FÃ¶rsÃ¤ljning enhet',0),(263760,7327,'it','UnitÃ  di vendita',0),(263761,7327,'tl','',0),(263762,7327,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3634;&#3618;',0),(263763,7327,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤‡à¤•à¤¾à¤ˆ',0),(263764,7327,'ms','Unit jualan',0),(263765,7327,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(263766,7327,'fr','UnitÃ© de vente',0),(263767,7327,'jp','è²©å£²å˜ä½',0),(263768,7327,'pt','Unidade de venda',0),(263769,7327,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° Ð±Ð»Ð¾Ðº',0),(263770,7327,'es','Unidad de Venta',0),(263771,7327,'de','Verkauf-Einheit',0),(263772,7327,'en','Sale Unit',0),(263773,7328,'is','',0),(263774,7328,'dr','(Ø¬Ù†Ø³ Ø¹Ø±Ø¶Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§Ù‰ ÙØ±ÙˆØ´ ØŒØ¬Ù†Ø³',0),(263775,7328,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÙŠØ§Ù„ Ù‚Ø±Ø¹Ù‡ (Ø¬Ù†Ø³ Ø¹Ø±Ø¶Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§Ù‰ ÙØ±ÙˆØ´ ØŒÚ©Ø§Ù„Ø§',0),(263776,7328,'tr','Seri Lot numarasÄ±',0),(263777,7328,'pl','Numer seryjny partii',0),(263778,7328,'bg','Ð¡ÐµÑ€Ð¸ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(263779,7328,'ur','Ø³ÛŒØ±ÛŒÙ„ Ø¨ÛØª ØªØ¹Ø¯Ø§Ø¯',0),(263780,7328,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑÐµÑ€Ð¸Ñ˜ÑÐºÐ¸ ÑÐµÑ€Ð¸Ñ˜Ðµ',0),(263781,7328,'vi','Sá»‘ LÃ´ thá»© tá»±',0),(263782,7328,'af','Serie Lot nommer',0),(263783,7328,'ro','NumÄƒr de serie Lot',0),(263784,7328,'et','Seeria partiinumber',0),(263785,7328,'si','Serijski veliko Å¡tevilo',0),(263786,7328,'ba','Nomor serial Lot',0),(263787,7328,'nl','SeriÃ«le lotnummer',0),(263788,7328,'fi','Sarja numero',0),(263789,7328,'no','Seriell partinummer',0),(263790,7328,'da','Seriel lotnummer',0),(263791,7328,'ko','ì§ë ¬ ë¡œíŠ¸ ë²ˆí˜¸',0),(263792,7328,'he','×˜×•×¨×™ ×”×¨×‘×” ×ž×ž×¡×¤×¨×ª',0),(263793,7328,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€Î±ÏÏ„Î¯Î´Î±Ï‚ ÏƒÎµÎ¹ÏÎ¹Î±ÎºÎ®',0),(263794,7328,'zh','ä¸²è¡Œæ‰¹å·\r\n',0),(263795,7328,'sv','Seriell partinummer',0),(263796,7328,'it','Numero di lotto seriale',0),(263797,7328,'tl','',0),(263798,7328,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3588;&#3619;&#3633;&#3657;&#3591;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;',0),(263799,7328,'hi','à¤¸à¥€à¤°à¤¿à¤¯à¤² à¤¬à¤¹à¥à¤¤ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(263800,7328,'ms','Nombor Lot bersiri',0),(263801,7328,'ar','Ø§Ù„Ø±Ù‚Ù… Ø§Ù„ØªØ³Ù„Ø³Ù„ÙŠ Ø§Ù„ÙƒØ«ÙŠØ±',0),(263802,7328,'fr','NumÃ©ro de sÃ©rie Lot',0),(263803,7328,'jp','å¤šãã®ã‚·ãƒªã‚¢ãƒ«ç•ªå·',0),(263804,7328,'pt','NÃºmero do lote serial',0),(263805,7328,'ru','ÐœÐ½Ð¾Ð³Ð¾ ÑÐµÑ€Ð¸Ð¹Ð½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(263806,7328,'es','NÃºmero de Lote Serial',0),(263807,7328,'de','Serial Nummer',0),(263808,7328,'en','Serial Lot Number',0),(263809,7329,'is','',0),(263810,7329,'dr','Ù†Ø±Ø® Ø­Ù…Ù„',0),(263811,7329,'pr','Ù†Ø±Ø® Ø­Ù…Ù„',0),(263812,7329,'tr','Aktarma hÄ±zÄ±',0),(263813,7329,'pl','Koszty kursu',0),(263814,7329,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(263815,7329,'ur','Ø´Ø±Ø­ Ø´Ù¾Ù†Ú¯',0),(263816,7329,'sr','Ð¡Ñ‚Ð¾Ð¿Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(263817,7329,'vi','GiÃ¡ váº­n chuyá»ƒn ',0),(263818,7329,'af','Versendingstarief',0),(263819,7329,'ro','Rata de transport maritim',0),(263820,7329,'et','Laevandus mÃ¤Ã¤ra',0),(263821,7329,'si','Ladijski promet stopnje',0),(263822,7329,'ba','Biaya pengiriman',0),(263823,7329,'nl','Scheepvaart tarief',0),(263824,7329,'fi','Toimituskulut',0),(263825,7329,'no','Frakt Rate',0),(263826,7329,'da','Shipping sats',0),(263827,7329,'ko','í•´ìƒ',0),(263828,7329,'he','×ž×©×œ×•×— ×§×¦×‘',0),(263829,7329,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î± Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(263830,7329,'zh','èˆªè¿çŽ‡\r\n',0),(263831,7329,'sv','Frakt pris',0),(263832,7329,'it','Tariffa di spedizione',0),(263833,7329,'tl','',0),(263834,7329,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(263835,7329,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤¦à¤°',0),(263836,7329,'ms','Kadar penghantaran',0),(263837,7329,'ar','Ø³Ø¹Ø± Ø§Ù„Ø´Ø­Ù†',0),(263838,7329,'fr','Tarif d\'expÃ©dition',0),(263839,7329,'jp','é…é€æ–™é‡‘',0),(263840,7329,'pt','Taxa de envio',0),(263841,7329,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÐºÑƒÑ€ÑÐ°',0),(263842,7329,'es','Tarifa de Transporte',0),(263843,7329,'de','Liefer-Preis',0),(263844,7329,'en','Shipping Rate',0),(263845,7330,'is','',0),(263846,7330,'dr','COM ',0),(263847,7330,'pr','Ú¯Ø±ÙˆÙ‡ Ø­Ù…Ù„ Ø­ÙˆØ²Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø§ØºÙ„Ø¨ Ú©Ø§Ø±Ù‡Ø§ÙŠ ØªØ¬Ø§Ø±ÙŠ Ùˆ Ø¨Ø§Ø²Ø±Ú¯Ø§Ù†ÙŠ  COM ',0),(263848,7330,'tr','COM kategorisinin alÄ±ÅŸveriÅŸ',0),(263849,7330,'pl','Zakupy kategorii COM',0),(263850,7330,'bg','ÐŸÐ°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ COM ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(263851,7330,'ur','COM Ø²Ù…Ø±Û Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(263852,7330,'sr','Ð£ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ñƒ Ð¦ÐžÐœ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(263853,7330,'vi','Thá»ƒ Loáº¡i Mua Sáº¯m COM',0),(263854,7330,'af','COM kategorie inkopies',0),(263855,7330,'ro','CumpÄƒrÄƒturi COM categorie',0),(263856,7330,'et','COM-i kategoorias Uudised',0),(263857,7330,'si','Nakupovanje COM Kategorija',0),(263858,7330,'ba','Belanja COM Kategori',0),(263859,7330,'nl','Winkelen COM-categorie',0),(263860,7330,'fi','Ostokset COM-luokan',0),(263861,7330,'no','Shopping COM kategorien',0),(263862,7330,'da','Shopping COM-kategori',0),(263863,7330,'ko','COM ì¹´í…Œê³ ë¦¬ ì‡¼í•‘',0),(263864,7330,'he','×§×˜×’×•×¨×™×™×ª COM ×”×§× ×™×•×ª',0),(263865,7330,'el','Î•Î¼Ï€Î¿ÏÎ¹ÎºÎ® ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± COM',0),(263866,7330,'zh','è´­ç‰©çš„é€šä¿¡ç«¯å£ç±»åˆ«\r\n',0),(263867,7330,'sv','Shopping COM-kategori',0),(263868,7330,'it','Shopping categoria COM',0),(263869,7330,'tl','',0),(263870,7330,'th','Shopping COM Category',0),(263871,7330,'hi','COM à¤¶à¥à¤°à¥‡à¤£à¥€ à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€',0),(263872,7330,'ms','Membeli-belah kategori COM',0),(263873,7330,'ar','Ø§Ù„ØªØ³ÙˆÙ‚ ÙØ¦Ø© COM',0),(263874,7330,'fr','Shopping COM catÃ©gorie',0),(263875,7330,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°ã® COM ã‚«ãƒ†ã‚´ãƒª',0),(263876,7330,'pt','Compras COM categoria',0),(263877,7330,'ru','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½Ñ‹ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ COM',0),(263878,7330,'es','Compras COM CategorÃ­a',0),(263879,7330,'de','Shopping COM-Kategorie',0),(263880,7330,'en','Shopping COM Category',0),(263881,7331,'is','',0),(263882,7331,'dr','COM ',0),(263883,7331,'pr','Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ø­Ù…Ù„  Ù…Ø­ØµÙˆÙ„ Ø­ÙˆØ²Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø§ØºÙ„Ø¨ Ú©Ø§Ø±Ù‡Ø§ÙŠ ØªØ¬Ø§Ø±ÙŠ Ùˆ Ø¨Ø§Ø²Ø±Ú¯Ø§Ù†ÙŠ COM ',0),(263884,7331,'tr','COM Ã¼rÃ¼n alÄ±ÅŸveriÅŸ besleme',0),(263885,7331,'pl','Zakupy produktÃ³w COM paszy',0),(263886,7331,'bg','ÐŸÐ°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ COM Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ Ñ„ÑƒÑ€Ð°Ð¶Ð¸',0),(263887,7331,'ur','COM Ú©ÛŒ Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ ÙÛŒÚˆ',0),(263888,7331,'sr','Ð£ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ñƒ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð° Ð¦ÐžÐœ Ñ…Ñ€Ð°Ð½Ð¸',0),(263889,7331,'vi','Náº¡p Thá»ƒ Loáº¡i Mua Sáº¯m COM',0),(263890,7331,'af','COM produk shopping voed',0),(263891,7331,'ro','CumpÄƒrÄƒturi COM produs Feed',0),(263892,7331,'et','COM toote ostukorvi Feed',0),(263893,7331,'si','Nakupovanje izdelkov COM krme',0),(263894,7331,'ba','Belanja produk COM Feed',0),(263895,7331,'nl','Winkelen COM Product Feed',0),(263896,7331,'fi','Ostokset COM tuote-syÃ¶tteen',0),(263897,7331,'no','Shopping COM produktet Feed',0),(263898,7331,'da','Shopping COM produkt foder',0),(263899,7331,'ko','í”¼ë“œ COM ì œí’ˆ ì‡¼í•‘',0),(263900,7331,'he','×§× ×™×•×ª COM ×”×ž×•×¦×¨ ×œ×”××›×™×œ',0),(263901,7331,'el','Î¨ÏŽÎ½Î¹Î± COM Ï€ÏÎ¿ÏŠÏŒÎ½ Î¶Ï‰Î¿Ï„ÏÎ¿Ï†ÏŽÎ½',0),(263902,7331,'zh','é€šä¿¡ç«¯å£çš„äº§å“è¿›å•†åœº\r\n',0),(263903,7331,'sv','Shopping COM produkt foder',0),(263904,7331,'it','Shopping COM prodotto alimentare',0),(263905,7331,'tl','',0),(263906,7331,'th','Shopping COM Product Feed',0),(263907,7331,'hi','COM à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤«à¤¼à¥€à¤¡',0),(263908,7331,'ms','Membeli-belah produk COM Feed',0),(263909,7331,'ar','ØªØ³ÙˆÙ‚ Ø§Ù„Ù…Ù†ØªØ¬ ÙƒÙˆÙ… Ø¢Ø±',0),(263910,7331,'fr','Shopping COM produit alimentation',0),(263911,7331,'jp','ãƒ•ã‚£ãƒ¼ãƒ‰ COM è£½å“ã‚’ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°',0),(263912,7331,'pt','Compras COM produto alimentar',0),(263913,7331,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° COM ÐºÐ¾Ñ€Ð¼Ð°',0),(263914,7331,'es','Compras COM PresentaciÃ³n de Producto',0),(263915,7331,'de','Einkaufen COM Produkt Feed',0),(263916,7331,'en','Shopping COM Product Feed',0),(263917,7332,'is','',0),(263918,7332,'dr','Shopzilla Ù†Ù…Ø¨Ø± Ú¯Ø±ÙˆÙ‡',0),(263919,7332,'pr','Shopzilla Ø´Ù†Ø§Ø³Ù‡ Ú¯Ø±ÙˆÙ‡',0),(263920,7332,'tr','Shopzilla Kategori KimliÄŸi',0),(263921,7332,'pl','ID kategorii Twenga',0),(263922,7332,'bg','Shopzilla ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ID',0),(263923,7332,'ur','Ø³Ú¾ÙˆÙ¾Ø²ÛŒÙ„Ù„Û Ù‚Ø³Ù… Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(263924,7332,'sr','Ð¡Ñ…Ð¾Ð¿Ð·Ð¸Ð»Ð»Ð° Ð˜Ð” ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(263925,7332,'vi','ID thá»ƒ loáº¡i Shopzilla',0),(263926,7332,'af','Shopzilla kategorie ID',0),(263927,7332,'ro','Shopzilla categoria ID',0),(263928,7332,'et','Shopzilla kategooria ID',0),(263929,7332,'si','Shopzilla kategorije ID',0),(263930,7332,'ba','ID kategori Shopzilla',0),(263931,7332,'nl','Shopzilla categorie-ID',0),(263932,7332,'fi','Stefan SÃ¤llberg-Alltomlinser.se tunnus',0),(263933,7332,'no','Shopzilla Kategori-ID',0),(263934,7332,'da','Shopzilla kategori-ID',0),(263935,7332,'ko','Shopzilla ë²”ì£¼ ID',0),(263936,7332,'he','×ž×–×”×” ×§×˜×’×•×¨×™×™×ª Shopzilla',0),(263937,7332,'el','Î¤Î¿ Shopzilla ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ID',0),(263938,7332,'zh','Shopzillaç±»åˆ«ID\r\n',0),(263939,7332,'sv','Shopzilla kategori-ID',0),(263940,7332,'it','Shopzilla categoria ID',0),(263941,7332,'tl','',0),(263942,7332,'th','Shopzilla Category ID',0),(263943,7332,'hi','Shopzilla à¤¶à¥à¤°à¥‡à¤£à¥€ à¤†à¤ˆà¤¡à¥€',0),(263944,7332,'ms','Shopzilla kategori ID',0),(263945,7332,'ar','Ù…Ø¹Ø±Ù Ø§Ù„ÙØ¦Ø© Shopzilla',0),(263946,7332,'fr','ID de catÃ©gorie de Shopzilla',0),(263947,7332,'jp','Shopzilla ã‚«ãƒ†ã‚´ãƒª ID',0),(263948,7332,'pt','ID da categoria Shopzilla',0),(263949,7332,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Shopzilla',0),(263950,7332,'es','Shpzilla CategorÃ­a ID',0),(263951,7332,'de','Shopzilla Kategorie-ID',0),(263952,7332,'en','Shopzilla Category ID',0),(263953,7333,'is','',0),(263954,7333,'dr','Shopzilla Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ù…Ø­ØµÙˆÙ„ ',0),(263955,7333,'pr','Shopzilla Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ù…Ø­ØµÙˆÙ„ ',0),(263956,7333,'tr','Shopzilla Ã¼rÃ¼n besleme',0),(263957,7333,'pl','RSS produkt z Twenga',0),(263958,7333,'bg','Shopzilla Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ Ð·Ð° Ñ…Ñ€Ð°Ð½ÐµÐ½Ðµ',0),(263959,7333,'ur','Ø³Ú¾ÙˆÙ¾Ø²ÛŒÙ„Ù„Û Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ ÙÛŒÚˆ',0),(263960,7333,'sr','Ð¡Ñ…Ð¾Ð¿Ð·Ð¸Ð»Ð»Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ Ð¤ÐµÐµÐ´',0),(263961,7333,'vi','Náº¡p sáº£n pháº©m Shopzilla',0),(263962,7333,'af','Shopzilla produk voed',0),(263963,7333,'ro','Shopzilla produs Feed',0),(263964,7333,'et','Shopzilla toote etteanne',0),(263965,7333,'si','Shopzilla Product krme',0),(263966,7333,'ba','Feed produk Shopzilla',0),(263967,7333,'nl','Shopzilla Product Feed',0),(263968,7333,'fi','Stefan SÃ¤llberg-Alltomlinser.se tuote-syÃ¶tteen',0),(263969,7333,'no','Shopzilla produktet Feed',0),(263970,7333,'da','Shopzilla produkt foder',0),(263971,7333,'ko','Shopzilla ì œí’ˆ ê³µê¸‰',0),(263972,7333,'he','×”×ž×•×¦×¨ Shopzilla ×œ×”××›×™×œ',0),(263973,7333,'el','Î–Ï‰Î¿Ï„ÏÎ¿Ï†Î­Ï‚ Ï€ÏÎ¿ÏŠÏŒÎ½: Shopzilla',0),(263974,7333,'zh','Shopzillaäº§å“æ•°æ®èµ„æ–™\r\n',0),(263975,7333,'sv','Shopzilla produkt foder',0),(263976,7333,'it','Shopzilla prodotto alimentare',0),(263977,7333,'tl','',0),(263978,7333,'th','Shopzilla Product Feed',0),(263979,7333,'hi','Shopzilla à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤«à¤¼à¥€à¤¡',0),(263980,7333,'ms','Suapan produk Shopzilla',0),(263981,7333,'ar','ØªØºØ°ÙŠØ© Shopzilla Ø§Ù„Ù…Ù†ØªØ¬',0),(263982,7333,'fr','Flux de produits de Shopzilla',0),(263983,7333,'jp','Shopzilla è£½å“ãƒ•ã‚£ãƒ¼ãƒ‰',0),(263984,7333,'pt','Shopzilla produto alimentar',0),(263985,7333,'ru','ÐŸÐ¾Ð´Ð°Ñ‡Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° Shopzilla',0),(263986,7333,'es','Shopzilla PresentaciÃ³n de Producto',0),(263987,7333,'de','Shopzilla Produktzufuhr',0),(263988,7333,'en','Shopzilla Product Feed',0),(263989,7334,'is','',0),(263990,7334,'dr','ÙƒØ§Ù„Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙˆÙŠÚ˜Ù‡',0),(263991,7334,'pr','ÙƒØ§Ù„Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙˆÙŠÚ˜Ù‡',0),(263992,7334,'tr','Ã–zel SipariÅŸ maddesi',0),(263993,7334,'pl','Specjalne zamÃ³wienie',0),(263994,7334,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ',0),(263995,7334,'ur','Ø®ØµÙˆØµÛŒ Ø­Ú©Ù… Ø´Û’',0),(263996,7334,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ð¿Ð¾ÑÐµÐ±Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(263997,7334,'vi','ÄÆ¡n hÃ ng Ä‘áº·c biá»‡t',0),(263998,7334,'af','Spesiale Bestelitem',0),(263999,7334,'ro','Element de comandÄƒ specialÄƒ',0),(264000,7334,'et','Toode',0),(264001,7334,'si','Posebna toÄka Order',0),(264002,7334,'ba','Item pesanan khusus',0),(264003,7334,'nl','Speciale bestelling Item',0),(264004,7334,'fi','Erityinen jÃ¤rjestys Item',0),(264005,7334,'no','Spesialbestillingsvare',0),(264006,7334,'da','Specialordre',0),(264007,7334,'ko','íŠ¹ë³„ ì£¼ë¬¸ í•­ëª©',0),(264008,7334,'he','×¤×¨×™×˜ ×‘×”×–×ž× ×” ×ž×™×•×—×“×ª',0),(264009,7334,'el','Î•Î™Î”Î™ÎšÎ— Î˜Î•Î£Î— Order',0),(264010,7334,'zh','ç‰¹åˆ«è®¢è´­ç‰©å“\r\n',0),(264011,7334,'sv','Specialorderartikel',0),(264012,7334,'it','Elemento di ordine speciale',0),(264013,7334,'tl','',0),(264014,7334,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(264015,7334,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤†à¤¦à¥‡à¤¶ à¤†à¤‡à¤Ÿà¤®',0),(264016,7334,'ms','Item tempahan khas',0),(264017,7334,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø£Ù…Ø± Ø®Ø§Øµ',0),(264018,7334,'fr','Commande spÃ©ciale',0),(264019,7334,'jp','ç‰¹æ³¨å“',0),(264020,7334,'pt','Item de pedido especial',0),(264021,7334,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¿ÑƒÐ½ÐºÑ‚ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°',0),(264022,7334,'es','Item de Orden Especial',0),(264023,7334,'de','Spezielle Bestellposition',0),(264024,7334,'en','Special Order Item',0),(264025,7335,'is','',0),(264026,7335,'dr','Ù‚ÙŠÙ…Øª Ø¶Ù…Ø§Ù†Øª',0),(264027,7335,'pr','Ù‚ÙŠÙ…Øª Ø¶Ù…Ø§Ù†Øª',0),(264028,7335,'tr','Sponsorluk Bedeli',0),(264029,7335,'pl','Cena sponsorzy',0),(264030,7335,'bg','Ð¡Ð¿Ð¾Ð½ÑÐ¾Ñ€ÑÑ‚Ð²Ð¾ Ñ†ÐµÐ½Ð°',0),(264031,7335,'ur','Ú©ÙØ§Ù„Øª Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(264032,7335,'sr','Ð¡Ð¿Ð¾Ð½Ð·Ð¾Ñ€ÑÑ‚Ð²Ð¾ Ñ†ÐµÐ½Ð°',0),(264033,7335,'vi','GiÃ¡ tÃ i trá»£',0),(264034,7335,'af','Borgskap Prys',0),(264035,7335,'ro','Sponsorizare Pret',0),(264036,7335,'et','Sponsorlus hind',0),(264037,7335,'si','Sponzorstvo cena',0),(264038,7335,'ba','Sponsor harga',0),(264039,7335,'nl','Sponsoring prijs',0),(264040,7335,'fi','Sponsorointi hinta',0),(264041,7335,'no','Sponsorer pris',0),(264042,7335,'da','Sponsorering pris',0),(264043,7335,'ko','í›„ì› ê°€ê²©',0),(264044,7335,'he','×ž×—×™×¨ ×”×—×¡×•×ª',0),(264045,7335,'el','Î¤Î¹Î¼Î® Î§Î¿ÏÎ·Î³Î¯Î±',0),(264046,7335,'zh','èµžåŠ©ä»·æ ¼\r\n',0),(264047,7335,'sv','Sponsring pris',0),(264048,7335,'it','Prezzo di sponsorizzazione',0),(264049,7335,'tl','',0),(264050,7335,'th','&#3619;&#3634;&#3588;&#3634;&#3612;&#3641;&#3657;&#3626;&#3609;&#3633;&#3610;&#3626;&#3609;&#3640;&#3609;',0),(264051,7335,'hi','à¤ªà¥à¤°à¤¾à¤¯à¥‹à¤œà¤¨ à¤®à¥‚à¤²à¥à¤¯',0),(264052,7335,'ms','Harga penajaan',0),(264053,7335,'ar','Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø±Ø¹Ø§ÙŠØ©',0),(264054,7335,'fr','Prix de parrainage',0),(264055,7335,'jp','å¾Œæ´ä¾¡æ ¼',0),(264056,7335,'pt','PreÃ§o de patrocÃ­nio',0),(264057,7335,'ru','Ð¡Ð¿Ð¾Ð½ÑÐ¾Ñ€ÑÑ‚Ð²Ð¾ Ð¦ÐµÐ½Ð°',0),(264058,7335,'es','Precio de Patrocinio',0),(264059,7335,'de','Sponsoring-Preis',0),(264060,7335,'en','Sponsorship Price',0),(264061,7336,'is','',0),(264062,7336,'dr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ø³ØªØ§Ø±Ù‡ Ø¯Ø§Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(264063,7336,'pr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ø³ØªØ§Ø±Ù‡ Ø¯Ø§Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(264064,7336,'tr','YÄ±ldÄ±z eklediÄŸiniz alanlar alÄ±nÄ±r',0),(264065,7336,'pl','Pola oznaczone gwiazdkÄ… sÄ… przywoÅ¼one',0),(264066,7336,'bg','Ð—Ð²ÐµÐ·Ð´Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð° ÑÐµ Ð²Ð½Ð°ÑÑÑ‚',0),(264067,7336,'ur','Ú©Ø§Ù… Ú©ÛŒØ§ Ù‚Ø·Ø¹Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ ÛÙˆØ¦Û’ ÛÛŒÚº',0),(264068,7336,'sr','Ð¡Ð»Ð°Ð²Ð½Ð¸Ð¼ Ð¿Ð¾Ñ™Ð° ÑÐµ ÑƒÐ²Ð¾Ð·Ðµ.',0),(264069,7336,'vi','TrÆ°á»ng cÃ³ dáº¥u sao Ä‘Ã£ nháº­p',0),(264070,7336,'af','Asterisk velde is Ingevoer',0),(264071,7336,'ro','A jucat cÃ¢mpurile sÄƒ fie importate',0),(264072,7336,'et','TÃ¤rniga vÃ¤ljad on imporditud',0),(264073,7336,'si','Zvezdico polj so uvoÅ¾ene',0),(264074,7336,'ba','Bidang bintangnya diimpor',0),(264075,7336,'nl','Ster velden worden geÃ¯mporteerd',0),(264076,7336,'fi','TÃ¤hdellÃ¤ merkittyjen kenttien tuominen',0),(264077,7336,'no','Stjernemerkede feltene importeres',0),(264078,7336,'da','Stjernemarkerede felter importeres',0),(264079,7336,'ko','ë³„í‘œ í‘œì‹œ ëœ í•„ë“œëŠ” ê°€ì ¸ì˜¬',0),(264080,7336,'he','×©×“×•×ª ×”×ž×¡×•×ž× ×™× ×‘×›×•×›×‘×™×ª ×ž×™×•×‘××™×',0),(264081,7336,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Ï€ÎµÎ´Î¯Ï‰Î½ Î±ÏƒÏ„Î­ÏÎ¹',0),(264082,7336,'zh','æ˜Ÿå·æ ‡è®°çš„å­—æ®µæ˜¯å¯¼å…¥çš„\r\n',0),(264083,7336,'sv','StjÃ¤rnmÃ¤rkta fÃ¤lt importeras',0),(264084,7336,'it','Campi stellati sono importati',0),(264085,7336,'tl','',0),(264086,7336,'th','&#3605;&#3636;&#3604;&#3604;&#3634;&#3623;&#3615;&#3636;&#3621;&#3604;&#3660;&#3607;&#3637;&#3656;&#3592;&#3632;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(264087,7336,'hi','à¤¤à¤¾à¤°à¤¾à¤‚à¤•à¤¿à¤¤ à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸ à¤†à¤¯à¤¾à¤¤ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚',0),(264088,7336,'ms','Bidang-bidang berbintang diimport',0),(264089,7336,'ar','ÙŠØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ù…ÙŠØ²Ø© Ø¨Ù†Ø¬Ù…Ø©',0),(264090,7336,'fr','Les champs Ã©toilÃ©s sont importÃ©s',0),(264091,7336,'jp','ã‚¹ã‚¿ãƒ¼ ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(264092,7336,'pt','Estrelou campos sÃ£o importados',0),(264093,7336,'ru','ÐŸÐ¾Ð¼ÐµÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ð¾Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÑŽÑ‚ÑÑ',0),(264094,7336,'es','Campos Estrellados se Importan',0),(264095,7336,'de','Markierten Felder werden importiert',0),(264096,7336,'en','Starred Fields are Imported',0),(264097,7337,'is','',0),(264098,7337,'dr','Ø´Ø±Ø­ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(264099,7337,'pr','Ø´Ø±Ø­ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(264100,7337,'tr','Stok aÃ§Ä±klamasÄ±',0),(264101,7337,'pl','PieÅ„ opis',0),(264102,7337,'bg','Ð‘Ð¾Ñ€ÑÐ¾Ð²Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(264103,7337,'ur','Ø³Ù¹Ø§Ú© Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(264104,7337,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð¾Ð¿Ð¸Ñ',0),(264105,7337,'vi','MÃ´ táº£ hÃ ng tá»“n',0),(264106,7337,'af','Voorraad Beskrywing',0),(264107,7337,'ro','Stoc Descriere',0),(264108,7337,'et','Varude kirjeldus',0),(264109,7337,'si','Zalog opis',0),(264110,7337,'ba','Deskripsi saham',0),(264111,7337,'nl','Voorraad beschrijving',0),(264112,7337,'fi','Kaluston kuvaus',0),(264113,7337,'no','Lager beskrivelse',0),(264114,7337,'da','Stock beskrivelse',0),(264115,7337,'ko','ì‚¬ì§„ ì„¤ëª…',0),(264116,7337,'he','×ª×™××•×¨ ×ž× ×™×•×ª',0),(264117,7337,'el','Î‘Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(264118,7337,'zh','è‚¡ç¥¨æè¿°\r\n',0),(264119,7337,'sv','Lager Beskrivning',0),(264120,7337,'it','Descrizione stock',0),(264121,7337,'tl','',0),(264122,7337,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(264123,7337,'hi','à¤¶à¥‡à¤¯à¤° à¤µà¤¿à¤µà¤°à¤£',0),(264124,7337,'ms','Description/kawalan stok',0),(264125,7337,'ar','ÙˆØµÙ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(264126,7337,'fr','Description stock',0),(264127,7337,'jp','æ ªå¼ã®æ¦‚è¦',0),(264128,7337,'pt','DescriÃ§Ã£o das aÃ§Ãµes',0),(264129,7337,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð°ÐºÑ†Ð¸Ð¸',0),(264130,7337,'es','DescripciÃ³n de Stock',0),(264131,7337,'de','Lager Beschreibung',0),(264132,7337,'en','Stock Description',0),(264133,7338,'is','',0),(264134,7338,'dr','ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(264135,7338,'pr','ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(264136,7338,'tr','Stok birimi',0),(264137,7338,'pl','PieÅ„ jednostki',0),(264138,7338,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° ÑÑŠÑÑ‚Ð°Ð²',0),(264139,7338,'ur','Ø§Ø³Ù¹Ø§Ú© ÛŒÙˆÙ†Ù¹',0),(264140,7338,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(264141,7338,'vi','ÄÆ¡n vá»‹ HÃ ng tá»“n',0),(264142,7338,'af','Voorraadeenheid',0),(264143,7338,'ro','Unitate de stoc',0),(264144,7338,'et','Varude Ã¼ksuse',0),(264145,7338,'si','Stock enote',0),(264146,7338,'ba','Unit saham',0),(264147,7338,'nl','Voorraad eenheid',0),(264148,7338,'fi','Varastossa yksikkÃ¶',0),(264149,7338,'no','Lager enhet',0),(264150,7338,'da','Lager enhed',0),(264151,7338,'ko','ìž¬ê³  ë‹¨ìœ„',0),(264152,7338,'he','×™×—×™×“×ª ×ž×œ××™',0),(264153,7338,'el','ÎœÎ¿Î½Î¬Î´Î± Î¶Ï‰Î¹ÎºÎ¿Ï ÎºÎµÏ†Î±Î»Î±Î¯Î¿Ï…',0),(264154,7338,'zh','åº“å­˜å•ä½\r\n',0),(264155,7338,'sv','Aktie',0),(264156,7338,'it','UnitÃ  di magazzino',0),(264157,7338,'tl','',0),(264158,7338,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3626;&#3605;&#3658;&#3629;&#3588;',0),(264159,7338,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤‡à¤•à¤¾à¤ˆ',0),(264160,7338,'ms','Unit saham',0),(264161,7338,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†',0),(264162,7338,'fr','UnitÃ© de stock',0),(264163,7338,'jp','æ ªå¼ã®å˜ä½',0),(264164,7338,'pt','Unidade de estoque',0),(264165,7338,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ð¹ Ð±Ð»Ð¾Ðº',0),(264166,7338,'es','Unidad de Stock',0),(264167,7338,'de','Stock Einheit',0),(264168,7338,'en','Stock Unit',0),(264169,7339,'is','',0),(264170,7339,'dr','Ø°Ø®ÙŠØ±Ù‡ Ù†Ù…Ø§ÙŠØ´ ØªØµÙˆÙŠØ± ',0),(264171,7339,'pr','Ø°Ø®ÙŠØ±Ù‡ Ù†Ù…Ø§ÙŠØ´ ØªØµÙˆÙŠØ± ',0),(264172,7339,'tr','MaÄŸaza ekran gÃ¶rÃ¼ntÃ¼sÃ¼',0),(264173,7339,'pl','Sklep wyÅ›wietlania obrazu',0),(264174,7339,'bg','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Ð´Ð¸ÑÐ¿Ð»ÐµÑ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(264175,7339,'ur','Ø³Ù¹ÙˆØ± ÚˆØ³Ù¾Ù„Û’ Ù†Ù‚Ø´',0),(264176,7339,'sr','Ð¡Ð»Ð¸ÐºÐ° Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð° ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð°',0),(264177,7339,'vi','HÃ¬nh áº£nh phÃ²ng kho hiá»ƒn thá»‹',0),(264178,7339,'af','Winkel wys beeld',0),(264179,7339,'ro','Magazin de afiÅŸare imagine',0),(264180,7339,'et','Salvestada ekraani pilt',0),(264181,7339,'si','Trgovina prikaz slik',0),(264182,7339,'ba','Gambar Store',0),(264183,7339,'nl','Winkel displaybeeld',0),(264184,7339,'fi','Tallentaa nÃ¤yttÃ¶kuvan',0),(264185,7339,'no','Store bildet',0),(264186,7339,'da','Butikken Display billede',0),(264187,7339,'ko','ë§¤ìž¥ ë””ìŠ¤í”Œë ˆì´ ì´ë¯¸ì§€',0),(264188,7339,'he','×ª×ž×•× ×ª ×”×ª×¦×•×’×” ×‘×—× ×•×ª',0),(264189,7339,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ· ÎµÎ¹ÎºÏŒÎ½Ï‰Î½',0),(264190,7339,'zh','å­˜å‚¨æ˜¾ç¤ºå›¾ç‰‡\r\n',0),(264191,7339,'sv','Store skÃ¤rmbilden',0),(264192,7339,'it','Archivio visualizzazione immagine',0),(264193,7339,'tl','',0),(264194,7339,'th','&#3649;&#3626;&#3604;&#3591;&#3616;&#3634;&#3614;&#3626;&#3650;&#3605;&#3619;&#3660;',0),(264195,7339,'hi','à¤¸à¥à¤Ÿà¥‹à¤° à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤›à¤µà¤¿',0),(264196,7339,'ms','Kedai paparan imej',0),(264197,7339,'ar','Ù…Ø®Ø²Ù† Ø¹Ø±Ø¶ Ø§Ù„ØµÙˆØ±Ø©',0),(264198,7339,'fr','Image affichÃ©e en magasin',0),(264199,7339,'jp','ã‚¹ãƒˆã‚¢è¡¨ç¤ºã‚¤ãƒ¡ãƒ¼ã‚¸',0),(264200,7339,'pt','Imagem de exibiÃ§Ã£o de loja',0),(264201,7339,'ru','Ð¥Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ Ð´Ð¸ÑÐ¿Ð»ÐµÑ',0),(264202,7339,'es','PresentaciÃ³n de Imagen de la Tienda',0),(264203,7339,'de','Bild Shop anzeigen',0),(264204,7339,'en','Store Display Image',0),(264205,7340,'is','',0),(264206,7340,'dr','Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ØªØµØ§ÙˆÙŠØ±ÙŠ Ú©ÙˆÚ†Ú©',0),(264207,7340,'pr','Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ØªØµØ§ÙˆÙŠØ±ÙŠ Ú©ÙˆÚ†Ú©',0),(264208,7340,'tr','MaÄŸaza Dsiplay kÃ¼Ã§Ã¼k resmi',0),(264209,7340,'pl','Sklep Dsiplay miniaturki',0),(264210,7340,'bg','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Dsiplay ÐºÐ°Ñ€Ñ‚Ð¸Ð½ÐºÐ°',0),(264211,7340,'ur','Ø¯Ø³Ø§Ù¾Ù„ÛÛŒ Ù¾ÙˆØ±Ù†Û Ø°Ø®ÛŒØ±Û Ú©Ø±ÛŒÚº',0),(264212,7340,'sr','Ð Ð°Ð´ÑšÐ° Ð”ÑÐ¸Ð¿Ð»Ð°y ÑÐ»Ð¸Ñ‡Ð¸Ñ†Ð°',0),(264213,7340,'vi','Hiá»ƒn thá»‹ phÃ²ng kho theo dáº¡ng ngÃ³n tay cÃ¡i',0),(264214,7340,'af','Winkel Dsiplay posseÃ«lprentjie',0),(264215,7340,'ro','Thumbnail de Dsiplay magazin',0),(264216,7340,'et','Store Dsiplay pisipilt',0),(264217,7340,'si','Trgovina Dsiplay sliÄico',0),(264218,7340,'ba','Toko Dsiplay Thumbnail',0),(264219,7340,'nl','Winkel Dsiplay foto',0),(264220,7340,'fi','Tallentaa Dsiplay pikkukuva',0),(264221,7340,'no','Lagre Dsiplay miniatyrbilde',0),(264222,7340,'da','Butik Dsiplay miniature',0),(264223,7340,'ko','ë‹´ê²¨ ì¶•ì†ŒíŒ ê·¸ë¦¼ ì €ìž¥',0),(264224,7340,'he','×—× ×•×ª Dsiplay ×ž×ž×•×–×¢×¨×ª',0),(264225,7340,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± Dsiplay Î¼Î¹ÎºÏÎ¿Î³ÏÎ±Ï†Î¯Î±',0),(264226,7340,'zh','å­˜å‚¨æ˜¾ç¤ºç»†èŠ‚å›¾ç‰‡\r\n',0),(264227,7340,'sv','Lagra Dsiplay miniatyr',0),(264228,7340,'it','Negozio Dsiplay Thumbnail',0),(264229,7340,'tl','',0),(264230,7340,'th','&#3649;&#3626;&#3604;&#3591;&#3616;&#3634;&#3614;&#3626;&#3650;&#3605;&#3619;&#3660;&#3586;&#3609;&#3634;&#3604;&#3648;&#3621;&#3655;&#3585;',0),(264231,7340,'hi','Dsiplay à¤¥à¤‚à¤¬à¤¨à¥‡à¤² à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨',0),(264232,7340,'ms','Simpan kuku jari Dsiplay',0),(264233,7340,'ar','ØªØ®Ø²ÙŠÙ† ØµÙˆØ±Ø© Ù…ØµØºØ±Ø© Ø¯Ø³ÙŠØ¨Ù„Ø§ÙŠ',0),(264234,7340,'fr','Magasin Dsiplay miniature',0),(264235,7340,'jp','ã‚¹ãƒˆã‚¢è¡¨ç¤ºã‚µãƒ ãƒã‚¤ãƒ«',0),(264236,7340,'pt','Loja Dsiplay miniatura',0),(264237,7340,'ru','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Dsiplay ÑÑÐºÐ¸Ð·',0),(264238,7340,'es','Miniatura de Imagen de la Tienda',0),(264239,7340,'de','Dsiplay ein Bild zu speichern',0),(264240,7340,'en','Store Dsiplay Thumbnail',0),(264241,7341,'is','',0),(264242,7341,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø®Ø§Øµ',0),(264243,7341,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø®Ø§Øµ',0),(264244,7341,'tr','Ã–zel maÄŸaza',0),(264245,7341,'pl','Sklep specjalnych',0),(264246,7341,'bg','Ð¡ÑŠÑ…Ñ€Ð°Ð½ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÐ¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸',0),(264247,7341,'ur','Ø®ØµÙˆØµÛŒ Ø°Ø®ÛŒØ±Û',0),(264248,7341,'sr','Ð¡ÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚ÐµÑšÐµ Ð¿Ð¾ÑÐµÐ±Ð½Ð¾',0),(264249,7341,'vi','PhÃ²ng kho Ä‘áº·c biá»‡t',0),(264250,7341,'af','Stoor spesiale',0),(264251,7341,'ro','Magazin speciale',0),(264252,7341,'et','Hoidke eriline',0),(264253,7341,'si','Shranjevanje posebne',0),(264254,7341,'ba','Toko khusus',0),(264255,7341,'nl','Speciale opslaan',0),(264256,7341,'fi','Tallentaa erityistÃ¤',0),(264257,7341,'no','Lagre spesielle',0),(264258,7341,'da','Gemme specielle',0),(264259,7341,'ko','íŠ¹ë³„ í•œ ì €ìž¥',0),(264260,7341,'he','×—× ×•×ª ×ž×™×•×—×“×ª',0),(264261,7341,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÎ¿Ï…Î½ ÎµÎ¹Î´Î¹ÎºÎ¬',0),(264262,7341,'zh','å­˜å‚¨ç‰¹æ®Š\r\n',0),(264263,7341,'sv','Lagra speciella',0),(264264,7341,'it','Archivio speciali',0),(264265,7341,'tl','',0),(264266,7341,'th','&#3626;&#3650;&#3605;&#3619;&#3660;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(264267,7341,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤¸à¥à¤Ÿà¥‹à¤°',0),(264268,7341,'ms','Stor Khas',0),(264269,7341,'ar','ØªØ®Ø²ÙŠÙ† Ø®Ø§ØµØ©',0),(264270,7341,'fr','Magasin spÃ©cial',0),(264271,7341,'jp','ç‰¹åˆ¥ãªä¿å­˜ã—ã¾ã™ã€‚',0),(264272,7341,'pt','Loja especial',0),(264273,7341,'ru','Ð¥Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹',0),(264274,7341,'es','Oferta de Tienda',0),(264275,7341,'de','Spezielle speichern',0),(264276,7341,'en','Store Special',0),(264277,7342,'is','',0),(264278,7342,'dr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ØªØµØ§ÙˆÙŠØ±ÙŠ Ú©ÙˆÚ†Ú© Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ÙØ§ÙŠÙ„ ÙŠØ§ Ø¨Ø±Ù†Ø§Ù…Ù‡\r\n URL',0),(264279,7342,'pr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ØªØµØ§ÙˆÙŠØ±ÙŠ Ú©ÙˆÚ†Ú© Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ÙØ§ÙŠÙ„ ÙŠØ§ Ø¨Ø±Ù†Ø§Ù…Ù‡\r\n URL',0),(264280,7342,'tr','KÃ¼Ã§Ã¼k resim URL\'si',0),(264281,7342,'pl','Adres URL miniatury',0),(264282,7342,'bg','ÐšÐ°Ñ€Ñ‚Ð¸Ð½ÐºÐ° URL',0),(264283,7342,'ur','Ù¾ÙˆØ±Ù†Û URL',0),(264284,7342,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° ÑÐ»Ð¸Ñ‡Ð¸Ñ†Ðµ',0),(264285,7342,'vi','ÄÆ°á»ng dáº«m dáº¡ng ngÃ³n cÃ¡i',0),(264286,7342,'af','Duimnael BA (\"URL\")',0),(264287,7342,'ro','URL-ul miniaturÄƒ',0),(264288,7342,'et','Pisipildi URL',0),(264289,7342,'si','URL sliÄice',0),(264290,7342,'ba','Thumbnail URL',0),(264291,7342,'nl','Foto URL',0),(264292,7342,'fi','Pikkukuvan URL-osoite',0),(264293,7342,'no','Thumbnail URL',0),(264294,7342,'da','Miniature URL',0),(264295,7342,'ko','ì¶•ì†ŒíŒ ê·¸ë¦¼ URL',0),(264296,7342,'he','×›×ª×•×‘×ª URL ×©×œ ×ª×ž×•× ×•×ª ×ž×ž×•×–×¢×¨×•×ª',0),(264297,7342,'el','ÎœÎ¹ÎºÏÎ¿Î³ÏÎ±Ï†Î¯Î± URL',0),(264298,7342,'zh','é¢„è§ˆç½‘å€\r\n',0),(264299,7342,'sv','Miniatyr URL',0),(264300,7342,'it','Anteprima URL',0),(264301,7342,'tl','',0),(264302,7342,'th','URL &#3586;&#3609;&#3634;&#3604;&#3648;&#3621;&#3655;&#3585;',0),(264303,7342,'hi','à¤¥à¤‚à¤¬à¤¨à¥‡à¤² à¤¯à¥‚à¤†à¤°à¤à¤²',0),(264304,7342,'ms','URL imej kecil',0),(264305,7342,'ar','Ø±Ø§Ø¨Ø· Ø§Ù„ØµÙˆØ±Ø© Ø§Ù„Ù…ØµØºØ±Ø©',0),(264306,7342,'fr','URL miniature',0),(264307,7342,'jp','ã‚µãƒ ãƒã‚¤ãƒ«ã® URL',0),(264308,7342,'pt','URL em miniatura',0),(264309,7342,'ru','Ð­ÑÐºÐ¸Ð· URL-Ð°Ð´Ñ€ÐµÑ',0),(264310,7342,'es','URL Miniatura de Imagen',0),(264311,7342,'de','Thumbnail-URL',0),(264312,7342,'en','Thumbnail URL',0),(264313,7343,'is','',0),(264314,7343,'dr','Ø§Ø±Ø²Ø´ ÙƒÙ„',0),(264315,7343,'pr','Ø§Ø±Ø²Ø´ ÙƒÙ„',0),(264316,7343,'tr','Toplam deÄŸeri',0),(264317,7343,'pl','ÅÄ…czna wartoÅ›Ä‡',0),(264318,7343,'bg','ÐžÐ±Ñ‰Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(264319,7343,'ur','Ú©Ù„ Ù‚ÛŒÙ…Øª',0),(264320,7343,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(264321,7343,'vi','Tá»•ng giÃ¡ trá»‹',0),(264322,7343,'af','Totale Waarde',0),(264323,7343,'ro','Valoare totalÄƒ',0),(264324,7343,'et','KoguvÃ¤Ã¤rtus',0),(264325,7343,'si','Skupna vrednost',0),(264326,7343,'ba','Total nilai',0),(264327,7343,'nl','Totale waarde',0),(264328,7343,'fi','Kokonaisarvo',0),(264329,7343,'no','Samlet verdi',0),(264330,7343,'da','Samlede vÃ¦rdi',0),(264331,7343,'ko','ì´ ê°€ì¹˜',0),(264332,7343,'he','×¡×” ×› ×¢×¨×š',0),(264333,7343,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® Î±Î¾Î¯Î±',0),(264334,7343,'zh','æ€»ä»·å€¼\r\n',0),(264335,7343,'sv','Totalt vÃ¤rde',0),(264336,7343,'it','Valore totale',0),(264337,7343,'tl','',0),(264338,7343,'th','&#3588;&#3656;&#3634;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(264339,7343,'hi','à¤•à¥à¤² à¤®à¥‚à¤²à¥à¤¯',0),(264340,7343,'ms','Jumlah nilai',0),(264341,7343,'ar','Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ©',0),(264342,7343,'fr','Valeur totale',0),(264343,7343,'jp','åˆè¨ˆå€¤',0),(264344,7343,'pt','Valor total',0),(264345,7343,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(264346,7343,'es','Total Valor',0),(264347,7343,'de','Gesamtwert',0),(264348,7343,'en','Total Value',0),(264349,7344,'is','',0),(264350,7344,'dr','Ù†ÙˆØ¹ ÙˆØ§Ø­Ø¯Ù‡Ø§',0),(264351,7344,'pr','Ù†ÙˆØ¹ ÙˆØ§Ø­Ø¯Ù‡Ø§',0),(264352,7344,'tr','Ãœnite tÃ¼rÃ¼',0),(264353,7344,'pl','Typ jednostki',0),(264354,7344,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð¸ Ñ‚Ð¸Ð¿',0),(264355,7344,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(264356,7344,'sr','Ð¢Ð¸Ð¿ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(264357,7344,'vi','Loáº¡i ÄÆ¡n vá»‹ ',0),(264358,7344,'af','Eenheid Tipe',0),(264359,7344,'ro','Unitati tip',0),(264360,7344,'et','Ãœhikute tÃ¼Ã¼p',0),(264361,7344,'si','Vrste enot',0),(264362,7344,'ba','Jenis unit',0),(264363,7344,'nl','Eenheden Type',0),(264364,7344,'fi','YksikkÃ¶jen tyyppi',0),(264365,7344,'no','Enheter Type',0),(264366,7344,'da','Enheder Type',0),(264367,7344,'ko','ë‹¨ìœ„ ìœ í˜•',0),(264368,7344,'he','×¡×•×’ ×™×—×™×“×•×ª',0),(264369,7344,'el','ÎœÎ¿Î½Î¬Î´ÎµÏ‚ Ï„ÏÏ€Î¿Ï…',0),(264370,7344,'zh','å•ä½ç±»åž‹\r\n',0),(264371,7344,'sv','Enheter typ',0),(264372,7344,'it','Tipo di unitÃ ',0),(264373,7344,'tl','',0),(264374,7344,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(264375,7344,'hi','à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(264376,7344,'ms','Jenis unit',0),(264377,7344,'ar','Ù†ÙˆØ¹ Ø§Ù„ÙˆØ­Ø¯Ø§Øª',0),(264378,7344,'fr','Type d\'unitÃ©s',0),(264379,7344,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆ ã‚¿ã‚¤ãƒ—',0),(264380,7344,'pt','Tipo de unidades',0),(264381,7344,'ru','Ð¢Ð¸Ð¿ ÐµÐ´Ð¸Ð½Ð¸Ñ†',0),(264382,7344,'es','Tipo de Unidades',0),(264383,7344,'de','Einheitentyp',0),(264384,7344,'en','Units Type',0),(264385,7345,'is','',0),(264386,7345,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù†Ø±Ø® Ù‡Ø§ÙŠ Ù†Ù‡Ø§ÙŠÙŠ',0),(264387,7345,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù†Ø±Ø® Ù‡Ø§ÙŠ Ù†Ù‡Ø§ÙŠÙŠ',0),(264388,7345,'tr','Marjinal kullanÄ±m oranlarÄ±',0),(264389,7345,'pl','UÅ¼yj kraÅ„cowych',0),(264390,7345,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ Ð¿Ñ€ÐµÐ´ÐµÐ»Ð½Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(264391,7345,'ur','Ù…Ø®ØªØªÙ… Ø¯Ø±Ø¬Û’ Ú©ÛŒ Ø´Ø±Ø­ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(264392,7345,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¼Ð°Ñ€Ð³Ð¸Ð½Ð°Ð»Ð½Ðµ ÑÑ‚Ð¾Ð¿Ðµ',0),(264393,7345,'vi','DÃ¹ng giÃ¡ cÃ³ cá»™ng thÃªm',0),(264394,7345,'af','Gebruik Grenstariewe',0),(264395,7345,'ro','Utilizarea ratelor marginale',0),(264396,7345,'et','Kasutamist marginaalne mÃ¤Ã¤rad',0),(264397,7345,'si','Uporabo mejnih mer',0),(264398,7345,'ba','Menggunakan marjinal TARIF',0),(264399,7345,'nl','Gebruik van marginale tarieven',0),(264400,7345,'fi','KÃ¤yttÃ¤Ã¤ marginaalinen',0),(264401,7345,'no','Bruk marginale priser',0),(264402,7345,'da','Bruge marginale satser',0),(264403,7345,'ko','í•œê³„ ì†ë„ ì‚¬ìš© í•˜ ì—¬',0),(264404,7345,'he','×œ×”×©×ª×ž×© ×‘×©×™×¢×•×¨ ×©×•×œ×™',0),(264405,7345,'el','Î§ÏÎ®ÏƒÎ· Î¿ÏÎ¹Î±ÎºÎ­Ï‚ Ï„Î¹Î¼Î­Ï‚',0),(264406,7345,'zh','ä½¿ç”¨è¾¹é™…ç¨ŽçŽ‡\r\n',0),(264407,7345,'sv','AnvÃ¤nda marginell priser',0),(264408,7345,'it','Utilizzare tassi marginali',0),(264409,7345,'tl','',0),(264410,7345,'th','&#3651;&#3594;&#3657;&#3629;&#3633;&#3605;&#3619;&#3634;&#3648;&#3612;&#3639;&#3656;&#3629;&#3648;&#3627;&#3621;&#3639;&#3629;&#3648;&#3612;&#3639;&#3656;&#3629;&#3586;&#3634;&#3604;',0),(264411,7345,'hi','à¤¸à¥€à¤®à¤¾à¤‚à¤¤ à¤¦à¤° à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(264412,7345,'ms','Menggunakan kadar Marginal',0),(264413,7345,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù…Ø¹Ø¯Ù„Ø§Øª Ù‡Ø§Ù…Ø´ÙŠØ©',0),(264414,7345,'fr','Utiliser des taux marginaux',0),(264415,7345,'jp','ä½¿ç”¨é™ç•Œç¨ŽçŽ‡',0),(264416,7345,'pt','Usar taxas marginais',0),(264417,7345,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(264418,7345,'es','Usar Tasas Marginales',0),(264419,7345,'de','GrenzsteuersÃ¤tze verwenden',0),(264420,7345,'en','Use Marginal Rates',0),(264421,7346,'is','',0),(264422,7346,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙˆØ²Ù† ',0),(264423,7346,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙˆØ²Ù† ',0),(264424,7346,'tr','Weight(Units)',0),(264425,7346,'pl','Weight(Units)',0),(264426,7346,'bg','Weight(units)',0),(264427,7346,'ur','Weight(units)',0),(264428,7346,'sr','WÐµÐ¸Ð³Ñ…Ñ‚(Ð£Ð½Ð¸Ñ‚Ñ)',0),(264429,7346,'vi','Trá»ng lÆ°á»£ng(Ä‘Æ¡n vá»‹)',0),(264430,7346,'af','Gewig (eenhede)',0),(264431,7346,'ro','Masa unitara',0),(264432,7346,'et','Kaal (Ã¼hikud)',0),(264433,7346,'si','Weight(units)',0),(264434,7346,'ba','Weight(units)',0),(264435,7346,'nl','Weight(units)',0),(264436,7346,'fi','Weight(units)',0),(264437,7346,'no','Weight(Units)',0),(264438,7346,'da','Weight(Units)',0),(264439,7346,'ko','Weight(units)',0),(264440,7346,'he','Weight(units)',0),(264441,7346,'el','Weight(Units)',0),(264442,7346,'zh','é‡é‡ï¼ˆå•ä½ï¼‰\r\n',0),(264443,7346,'sv','Weight(units)',0),(264444,7346,'it','Weight(units)',0),(264445,7346,'tl','',0),(264446,7346,'th','&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585; (&#3627;&#3609;&#3656;&#3623;&#3618;)',0),(264447,7346,'hi','Weight(units)',0),(264448,7346,'ms','Weight(units)',0),(264449,7346,'ar','Weight(units)',0),(264450,7346,'fr','Poids (unitÃ©s)',0),(264451,7346,'jp','Weight(units)',0),(264452,7346,'pt','Weight(Units)',0),(264453,7346,'ru','Weight(Units)',0),(264454,7346,'es','Peso (unidades)',0),(264455,7346,'de','Weight(Units)',0),(264456,7346,'en','Weight(units)',0),(264457,7347,'is','',0),(264458,7347,'dr','Ø§Ø±Ø³Ø§Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ù‡',0),(264459,7347,'pr','Ø§Ø±Ø³Ø§Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ù‡',0),(264460,7347,'tr','Bill iÃ§in',0),(264461,7347,'pl','Bill',0),(264462,7347,'bg','Ð—Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(264463,7347,'ur','Ø¨Ù„ Ù…ÛŒÚº',0),(264464,7347,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐ°',0),(264465,7347,'vi','Gá»­i Äáº¿n',0),(264466,7347,'af','Wetsontwerp',0),(264467,7347,'ro','Proiect de lege',0),(264468,7347,'et','Seaduse eelnÃµu',0),(264469,7347,'si','Zakona o',0),(264470,7347,'ba','Tagihan untuk',0),(264471,7347,'nl','Bill aan',0),(264472,7347,'fi','Bill',0),(264473,7347,'no','Fakturagate',0),(264474,7347,'da','Bill til',0),(264475,7347,'ko','í•˜ ë¹Œ',0),(264476,7347,'he','×œ×—×•×‘×ª',0),(264477,7347,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Î³Î¹Î± Ï„Î·Î½',0),(264478,7347,'zh','è®¡è´¹åˆ°\r\n',0),(264479,7347,'sv','Bill till',0),(264480,7347,'it','Disegno di legge per',0),(264481,7347,'tl','',0),(264482,7347,'th','&#3626;&#3656;&#3591;&#3610;&#3636;&#3621;&#3606;&#3638;&#3591;',0),(264483,7347,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²',0),(264484,7347,'ms','Rang undang-undang untuk',0),(264485,7347,'ar','Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ø¥Ù„Ù‰',0),(264486,7347,'fr','Projet de loi',0),(264487,7347,'jp','è«‹æ±‚å…ˆ',0),(264488,7347,'pt','Projeto de lei para',0),(264489,7347,'ru','Ð—Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(264490,7347,'es','Facturar A',0),(264491,7347,'de','Gesetzentwurf zur',0),(264492,7347,'en','Bill To',0),(264493,7348,'is','',0),(264494,7348,'dr','Ø´ØºÙ„ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(264495,7348,'pr','Ø´ØºÙ„ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(264496,7348,'tr','MÃ¼ÅŸteri iÅŸi',0),(264497,7348,'pl','Klienta praca',0),(264498,7348,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(264499,7348,'ur','Ú©Ø³Ù¹Ù…Ø± Ù…Ù„Ø§Ø²Ù…Øª',0),(264500,7348,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÐºÑƒÐ¿Ñ†Ð°',0),(264501,7348,'vi','Job KhÃ¡ch hÃ ng',0),(264502,7348,'af','Klant / KliÃ«nt Projek',0),(264503,7348,'ro','Client Job',0),(264504,7348,'et','Kliendi amet',0),(264505,7348,'si','Delo strank',0),(264506,7348,'ba','Pelanggan pekerjaan',0),(264507,7348,'nl','Klant baan',0),(264508,7348,'fi','Asiakkaan tyÃ¶',0),(264509,7348,'no','Kunden jobb',0),(264510,7348,'da','Kunde Job',0),(264511,7348,'ko','ê³ ê° ìž‘ì—…',0),(264512,7348,'he','×¢×‘×•×“×ª ×œ×§×•×—',0),(264513,7348,'el','Î”Î¿Ï…Î»ÎµÎ¹Î¬ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(264514,7348,'zh','å®¢æˆ·å·¥ä½œ\r\n',0),(264515,7348,'sv','Kund jobb',0),(264516,7348,'it','Lavoro del cliente',0),(264517,7348,'tl','',0),(264518,7348,'th','&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(264519,7348,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¥Œà¤•à¤°à¥€',0),(264520,7348,'ms','Kerja Baca',0),(264521,7348,'ar','Ù…Ù‡Ù…Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(264522,7348,'fr','Emploi de client',0),(264523,7348,'jp','é¡§å®¢ã‚¸ãƒ§ãƒ–',0),(264524,7348,'pt','Trabalho de cliente',0),(264525,7348,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð´Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(264526,7348,'es','Cliente Trabajo',0),(264527,7348,'de','Kundendienst/Stelle',0),(264528,7348,'en','Customer Job',0),(264529,7349,'is','',0),(264530,7349,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´ Ù‡Ø§ ',0),(264531,7349,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´ Ù‡Ø§ ',0),(264532,7349,'tr','Alma satÄ±ÅŸ',0),(264533,7349,'pl','Importu sprzedaÅ¼y',0),(264534,7349,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(264535,7349,'ur','Ø³ÛŒÙ„Ø² Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(264536,7349,'sr','Ð£Ð²Ð¾Ð· Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð°',0),(264537,7349,'vi','Nháº­p doanh sá»‘',0),(264538,7349,'af','Invoer van Verkope',0),(264539,7349,'ro','VÃ¢nzÄƒri de import',0),(264540,7349,'et','Impordi mÃ¼Ã¼gid',0),(264541,7349,'si','Uvoz prodaje',0),(264542,7349,'ba','Impor penjualan',0),(264543,7349,'nl','Importeren van verkoop',0),(264544,7349,'fi','Tuonti myynti',0),(264545,7349,'no','Import salg',0),(264546,7349,'da','Import salg',0),(264547,7349,'ko','ìˆ˜ìž… íŒë§¤',0),(264548,7349,'he','×™×‘× ×ž×›×™×¨×•×ª',0),(264549,7349,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(264550,7349,'zh','è¿›å£é”€å”®\r\n',0),(264551,7349,'sv','Importera fÃ¶rsÃ¤ljning',0),(264552,7349,'it','Vendite di importazione',0),(264553,7349,'tl','',0),(264554,7349,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(264555,7349,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(264556,7349,'ms','Jualan import',0),(264557,7349,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(264558,7349,'fr','Importation vente',0),(264559,7349,'jp','è¼¸å…¥è²©å£²',0),(264560,7349,'pt','Vendas de importaÃ§Ã£o',0),(264561,7349,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(264562,7349,'es','Importar Ventas',0),(264563,7349,'de','Import-Vertrieb',0),(264564,7349,'en','Import Sales',0),(264565,7350,'is','',0),(264566,7350,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´ Ù‡Ø§ Ø§Ø² Ø±ÙˆÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(264567,7350,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´ Ù‡Ø§ Ø§Ø² Ø±ÙˆÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(264568,7350,'tr','MÃ¼ÅŸteriye gÃ¶re satÄ±ÅŸ almak',0),(264569,7350,'pl','Importu sprzedaÅ¼y przez klienta',0),(264570,7350,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(264571,7350,'ur','Ú¯Ø§ÛÚ© Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø³ÛŒÙ„Ø² Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(264572,7350,'sr','Ð£Ð²Ð¾Ð· Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð° Ð¿Ð¾ ÐºÑƒÐ¿Ñ†Ð¸Ð¼Ð°',0),(264573,7350,'vi','Nháº­p doanh sá»‘ theo khÃ¡ch hÃ ng',0),(264574,7350,'af','Invoer van Verkope per KliÃ«nt/Klant',0),(264575,7350,'ro','VÃ¢nzÄƒri de client de import',0),(264576,7350,'et','Impordi mÃ¼Ã¼k klientide kaupa',0),(264577,7350,'si','Uvoz prodaja po stranki',0),(264578,7350,'ba','Impor penjualan oleh nasabah',0),(264579,7350,'nl','Omzet per klant importeren',0),(264580,7350,'fi','Tuo Asiakaskohtainen myynti',0),(264581,7350,'no','Import salg av kunde',0),(264582,7350,'da','Import salg af kunden',0),(264583,7350,'ko','ê³ ê°ì— ì˜í•´ ìˆ˜ìž… íŒë§¤',0),(264584,7350,'he','×™×™×‘×•× ×ž×›×™×¨×•×ª ×œ×¤×™ ×œ×§×•×—×•×ª',0),(264585,7350,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î±Ï€ÏŒ Ï„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î· ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(264586,7350,'zh','ç”±å®¢æˆ·è¿›å£é”€å”®\r\n',0),(264587,7350,'sv','Importera fÃ¶rsÃ¤ljning av kund',0),(264588,7350,'it','Vendite di importazione da parte del cliente',0),(264589,7350,'tl','',0),(264590,7350,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3650;&#3604;&#3618;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(264591,7350,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤†à¤¯à¤¾à¤¤ à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(264592,7350,'ms','Jualan Import oleh pelanggan',0),(264593,7350,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø­Ø³Ø¨ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(264594,7350,'fr','Importation des ventes par client',0),(264595,7350,'jp','é¡§å®¢ã«ã‚ˆã£ã¦è¼¸å…¥è²©å£²',0),(264596,7350,'pt','ImportaÃ§Ã£o de vendas por cliente',0),(264597,7350,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐŸÑ€Ð¾Ð¶Ð°Ð¶ Ð¿Ð¾ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñƒ',0),(264598,7350,'es','Importar Ventas por Cliente',0),(264599,7350,'de','Import Verkauf durch den Kunden',0),(264600,7350,'en','Import Sales by Customer',0),(264601,7351,'is','',0),(264602,7351,'dr','ÙŠØ§Ø¯Ø§Ø´Øªâ€Œ',0),(264603,7351,'pr','ÙŠØ§Ø¯Ø§Ø´Øªâ€Œ',0),(264604,7351,'tr','Memo',0),(264605,7351,'pl','Nota',0),(264606,7351,'bg','Ð˜Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(264607,7351,'ur','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª',0),(264608,7351,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÑšÐ°',0),(264609,7351,'vi','Ghi chÃº',0),(264610,7351,'af','Memo',0),(264611,7351,'ro','Memo',0),(264612,7351,'et','Memo',0),(264613,7351,'si','Memo',0),(264614,7351,'ba','Memo',0),(264615,7351,'nl','Memo',0),(264616,7351,'fi','Muistio',0),(264617,7351,'no','Notat',0),(264618,7351,'da','Memo',0),(264619,7351,'ko','ë©”ëª¨',0),(264620,7351,'he','×ª×–×›×™×¨',0),(264621,7351,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(264622,7351,'zh','å¤‡å¿˜å½•\r\n',0),(264623,7351,'sv','Memo',0),(264624,7351,'it','Memo',0),(264625,7351,'tl','',0),(264626,7351,'th','&#3649;&#3617;&#3617;&#3650;&#3617;',0),(264627,7351,'hi','à¤œà¥à¤žà¤¾à¤ªà¤¨',0),(264628,7351,'ms','Memo',0),(264629,7351,'ar','\"Ù…Ø°ÙƒØ±Ø©\"',0),(264630,7351,'fr','MÃ©mo',0),(264631,7351,'jp','ãƒ¡ãƒ¢',0),(264632,7351,'pt','Memo',0),(264633,7351,'ru','ÐŸÐ°Ð¼ÑÑ‚ÐºÐ°',0),(264634,7351,'es','Memo',0),(264635,7351,'de','Memo',0),(264636,7351,'en','Memo',0),(264637,7352,'is','',0),(264638,7352,'dr','(Ø¬Ù†Ø³ Ø¹Ø±Ø¶Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§Ù‰ ÙØ±ÙˆØ´ ØŒØ¬Ù†Ø³',0),(264639,7352,'pr','Ø³Ø±ÙŠØ§Ù„ Ù‚Ø±Ø¹Ù‡ (Ø¬Ù†Ø³ Ø¹Ø±Ø¶Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§Ù‰ ÙØ±ÙˆØ´ ØŒÚ©Ø§Ù„Ø§',0),(264640,7352,'tr','Seri Ã§ok',0),(264641,7352,'pl','DuÅ¼o powieÅ›Ä‡ w odcinkach',0),(264642,7352,'bg','Ð¡ÐµÑ€Ð¸ÐµÐ½ Ð¼Ð½Ð¾Ð³Ð¾',0),(264643,7352,'ur','Ø³ÛŒØ±ÛŒÙ„ Ø¨ÛØª',0),(264644,7352,'sr','Ð¡ÐµÑ€Ð¸Ñ˜ÑÐºÐ° ÑÐµÑ€Ð¸Ñ˜Ðµ',0),(264645,7352,'vi','LÃ´ thá»© tá»±',0),(264646,7352,'af','Serie baie',0),(264647,7352,'ro','Serial mulÅ£ime',0),(264648,7352,'et','Seeria palju',0),(264649,7352,'si','Serijski veliko',0),(264650,7352,'ba','Banyak serial',0),(264651,7352,'nl','SeriÃ«le veel',0),(264652,7352,'fi','Sarja paljon',0),(264653,7352,'no','Seriell mye',0),(264654,7352,'da','Seriel masse',0),(264655,7352,'ko','ì§ë ¬ ë§Žì€',0),(264656,7352,'he','×”×¨×‘×” ×˜×•×¨×™',0),(264657,7352,'el','Î£ÎµÎ¹ÏÎ¹Î±ÎºÎ® Ï€Î¿Î»Î»Î¬',0),(264658,7352,'zh','ä¸²è¡Œåœ°æ®µ\r\n',0),(264659,7352,'sv','Seriell hel',0),(264660,7352,'it','Sacco seriale',0),(264661,7352,'tl','',0),(264662,7352,'th','&#3611;&#3619;&#3632;&#3592;&#3635;&#3588;&#3619;&#3633;&#3657;&#3591;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;',0),(264663,7352,'hi','à¤¸à¥€à¤°à¤¿à¤¯à¤² à¤¬à¤¹à¥à¤¤',0),(264664,7352,'ms','Lot bersiri',0),(264665,7352,'ar','Ø§Ù„Ù…Ø³Ù„Ø³Ù„ Ø§Ù„ÙƒØ«ÙŠØ±',0),(264666,7352,'fr','Beaucoup de sÃ©rie',0),(264667,7352,'jp','å¤šãã®ã‚·ãƒªã‚¢ãƒ«',0),(264668,7352,'pt','Muito serial',0),(264669,7352,'ru','Ð¡ÐµÑ€Ð¸Ð¹Ð½Ñ‹Ð¹ Ð¼Ð½Ð¾Ð³Ð¾',0),(264670,7352,'es','Lote Serial',0),(264671,7352,'de','Seriencharge',0),(264672,7352,'en','Serial Lot',0),(264673,7353,'is','',0),(264674,7353,'dr','Ø¯Ø±Ø§Ù…Ø¯ Ú©Ù„',0),(264675,7353,'pr','Ø¯Ø±Ø§Ù…Ø¯ Ú©Ù„',0),(264676,7353,'tr','Toplam gelir',0),(264677,7353,'pl','ÅÄ…czny przychÃ³d',0),(264678,7353,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸',0),(264679,7353,'ur','Ú©Ù„ Ø¢Ù…Ø¯Ù†ÛŒ',0),(264680,7353,'sr','Ð£ÐºÑƒÐ¿Ð°Ð½ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´',0),(264681,7353,'vi','Tá»•ng doanh thu',0),(264682,7353,'af','Totale Inkomste',0),(264683,7353,'ro','Veniturile totale',0),(264684,7353,'et','Tulud kokku',0),(264685,7353,'si','Skupni prihodki',0),(264686,7353,'ba','Total pendapatan',0),(264687,7353,'nl','Totale omzet',0),(264688,7353,'fi','Tulot yhteensÃ¤',0),(264689,7353,'no','Totalomsetning',0),(264690,7353,'da','Samlede indtÃ¦gter',0),(264691,7353,'ko','ì´ ìˆ˜ìµ',0),(264692,7353,'he','×¡×” ×› ×”×”×›× ×¡×•×ª',0),(264693,7353,'el','Î£Î¥ÎÎŸÎ›ÎŸ Î•Î£ÎŸÎ”Î©Î',0),(264694,7353,'zh','æ€»æ”¶å…¥\r\n',0),(264695,7353,'sv','Totala intÃ¤kter',0),(264696,7353,'it','Totale entrate',0),(264697,7353,'tl','',0),(264698,7353,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;',0),(264699,7353,'hi','à¤•à¥à¤² à¤°à¤¾à¤œà¤¸à¥à¤µ',0),(264700,7353,'ms','Jumlah hasil',0),(264701,7353,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª',0),(264702,7353,'fr','Total des recettes',0),(264703,7353,'jp','ç·å£²ã‚Šä¸Šã’é«˜',0),(264704,7353,'pt','Receita total',0),(264705,7353,'ru','ÐžÐ±Ñ‰Ð¸Ð¹ Ð´Ð¾Ñ…Ð¾Ð´',0),(264706,7353,'es','Renta Total',0),(264707,7353,'de','Umsatz gesamt',0),(264708,7353,'en','Total Revenue',0),(264709,7354,'is','',0),(264710,7354,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡\r\n QB ',0),(264711,7354,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡\r\n QB ',0),(264712,7354,'tr','QB fatura Ã¶demeleri alma',0),(264713,7354,'pl','PrzywÃ³z QB rachunku pÅ‚atnoÅ›ci',0),(264714,7354,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QB Ð±Ð¸Ð» Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(264715,7354,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ù‚Ø¨ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(264716,7354,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ð‘Ð¸Ð» ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(264717,7354,'vi','Nháº­p Thanh ToÃ¡n HÃ³a ÄÆ¡n QB',0),(264718,7354,'af','Invoer van QB Rekeninge Betalings',0),(264719,7354,'ro','PlÄƒÅ£i de QB factura de import',0),(264720,7354,'et','Impordi QB Bill maksete',0),(264721,7354,'si','Uvoz QB Bill plaÄila',0),(264722,7354,'ba','Pembayaran tagihan QB impor',0),(264723,7354,'nl','Importeren van QB factuur betalingen',0),(264724,7354,'fi','Tuo QB Bill maksut',0),(264725,7354,'no','Importere QB avdrag',0),(264726,7354,'da','Importere QB Bill betalinger',0),(264727,7354,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ë¹Œ ì§€ë¶ˆ',0),(264728,7354,'he','×™×‘× QB ×‘×™×œ ×ª×©×œ×•×ž×™×',0),(264729,7354,'el','Î Î›Î—Î¡Î©ÎœÎ— Î›ÎŸÎ“Î‘Î¡Î™Î‘Î£ÎœÎ©Î ÎœÎ•Î£Î© Î”Î™Î‘Î”Î¥ÎšÎ¤Î¥ÎŸÎ¥ QB ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(264730,7354,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—ç¼´è´¹å¸å•\r\n',0),(264731,7354,'sv','Importera QB faktura betalningar',0),(264732,7354,'it','Importare i pagamenti QB Bill',0),(264733,7354,'tl','',0),(264734,7354,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3605;&#3634;&#3617;&#3610;&#3636;&#3621; QB',0),(264735,7354,'hi','à¤†à¤¯à¤¾à¤¤ QB à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(264736,7354,'ms','Bayaran bil QB import',0),(264737,7354,'ar','ØªØ³Ø¯ÙŠØ¯ ÙÙˆØ§ØªÙŠØ± QB Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(264738,7354,'fr','Importer des paiements de factures de QB',0),(264739,7354,'jp','QB ã®è«‹æ±‚æ›¸ã®æ”¯æ‰•ã„ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(264740,7354,'pt','Pagamentos de contas de QB de importaÃ§Ã£o',0),(264741,7354,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ QB Ð‘Ð¸Ð»Ð»',0),(264742,7354,'es','Importar QB Pagos de Facturas',0),(264743,7354,'de','Import QB Rechnungszahlungen',0),(264744,7354,'en','Import QB Bill Payments',0),(264745,7355,'is','',0),(264746,7355,'dr','QB /',0),(264747,7355,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ QB /',0),(264748,7355,'tr','QB satÄ±cÄ± faturalarÄ±/Ã¶deme alma',0),(264749,7355,'pl','ZaimportowaÄ‡ rachunki QB dostawcy/pÅ‚atnoÅ›ci',0),(264750,7355,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QB Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ¼ÐµÑ‚ÐºÐ¸/Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(264751,7355,'ur','Ù‚Ø¨ ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„/Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(264752,7355,'sr','Ð£Ð²Ð¾Ð· Ñ€Ð°Ñ‡ÑƒÐ½Ðµ/ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸Ð¼Ð° Ð‘ÐµÐº',0),(264753,7355,'vi','Nháº­p HÃ³a ÄÆ¡n/Thanh ToÃ¡n Cá»§a NgÆ°á»i bÃ¡n QB',0),(264754,7355,'af','Invoer van QB Verskaffer Rekeninge/Betalings',0),(264755,7355,'ro','QB furnizor facturi/plÄƒÅ£ile de import',0),(264756,7355,'et','Impordi QB tarnijate arvete maksed',0),(264757,7355,'si','Uvozite raÄune/plaÄila dobaviteljem QB',0),(264758,7355,'ba','Impor QB Vendor tagihan/pembayaran',0),(264759,7355,'nl','Importeren van QB facturen/Betalingsvoorstellen',0),(264760,7355,'fi','Tuo QB toimittajan laskuja/maksuja',0),(264761,7355,'no','Importere QB regninger/leverandÃ¸rbetalinger',0),(264762,7355,'da','Importere QB v/kreditorbetalinger regninger',0),(264763,7355,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ/ê²°ì œ',0),(264764,7355,'he','×œ×™×™×‘× ×—×©×‘×•× ×•×ª/×ª×©×œ×•×ž×™ ×¡×¤×§ QB',0),(264765,7355,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® QB Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎºÎ±Î¹ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(264766,7355,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—å–æ–¹ç¥¨æ®/ä»˜æ¬¾\r\n',0),(264767,7355,'sv','Importera QB rÃ¤kningar/leverantÃ¶rsbetalningar',0),(264768,7355,'it','Importare le fatture/pagamenti fornitore di QB',0),(264769,7355,'tl','',0),(264770,7355,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634; QB &#3610;&#3636;&#3621;/&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609; &#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(264771,7355,'hi','QB à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤²/à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(264772,7355,'ms','Mengimport penjual QB bil/bayaran',0),(264773,7355,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ±/Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ† QB',0),(264774,7355,'fr','Importation de factures/paiements de QB fournisseur',0),(264775,7355,'jp','QB ã®ä»•å…¥å…ˆè«‹æ±‚æ›¸/æ”¯æ‰•ã„ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(264776,7355,'pt','Importar contas de fornecedor QB/pagamentos',0),(264777,7355,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ QB Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² ÑÑ‡ÐµÑ‚Ð°/Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(264778,7355,'es','Importar QB Recibos/Pagos de Proveedores',0),(264779,7355,'de','Importieren Sie QB Lieferanten Rechnungen/Zahlungen',0),(264780,7355,'en','Import QB Vendor Bills/Payments',0),(264781,7356,'is','',0),(264782,7356,'dr','(Ø§Ù‚Ø³Ø§Ø·) ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ ',0),(264783,7356,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ(Ø§Ù‚Ø³Ø§Ø·) ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ ',0),(264784,7356,'tr','AlÄ±nan Ã¶demeler',0),(264785,7356,'pl','PÅ‚atnoÅ›ci importowane',0),(264786,7356,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ, ÐºÐ¾Ð¸Ñ‚Ð¾ ÑÐ° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸',0),(264787,7356,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(264788,7356,'sr','Ð˜ÑÐ¿Ð»Ð°Ñ‚Ð° ÑƒÐ²ÐµÐ·ÐµÐ½Ð°',0),(264789,7356,'vi','ÄÃ£ nháº­p thanh toÃ¡n',0),(264790,7356,'af','Betalings Ingevoer',0),(264791,7356,'ro','PlÄƒÅ£i importate',0),(264792,7356,'et','Maksed imporditud',0),(264793,7356,'si','PlaÄila, uvoÅ¾enih',0),(264794,7356,'ba','Pembayaran yang diimpor',0),(264795,7356,'nl','Betalingen ingevoerd',0),(264796,7356,'fi','Maksuja tuodaan',0),(264797,7356,'no','Betalinger importert',0),(264798,7356,'da','Betalinger importeret',0),(264799,7356,'ko','ìˆ˜ìž… ì§€ê¸‰',0),(264800,7356,'he','×ª×©×œ×•×ž×™× ×ž×™×•×‘××™×',0),(264801,7356,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(264802,7356,'zh','å¯¼å…¥ä»˜æ¬¾\r\n',0),(264803,7356,'sv','Betalningar som importeras',0),(264804,7356,'it','Pagamenti importati',0),(264805,7356,'tl','',0),(264806,7356,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(264807,7356,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤¿à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(264808,7356,'ms','Pembayaran yang diimport',0),(264809,7356,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(264810,7356,'fr','Paiements importÃ©s',0),(264811,7356,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®æ”¯æ‰•ã„',0),(264812,7356,'pt','Pagamentos importados',0),(264813,7356,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐµÐ¼Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(264814,7356,'es','Pagos Importados',0),(264815,7356,'de','Zahlungen importiert',0),(264816,7356,'en','Payments Imported',0),(264817,7357,'is','',0),(264818,7357,'dr','-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(264819,7357,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ù„ÙŠÙ†Ùƒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(264820,7357,'tr','QB faturalarÄ±-baÄŸlantÄ± dosyasÄ± sÃ¼tun biÃ§imi',0),(264821,7357,'pl','Rachunki QB-Link pliku formatu kolumny',0),(264822,7357,'bg','QB ÑÐ¼ÐµÑ‚ÐºÐ¸-Ð²Ñ€ÑŠÐ·ÐºÐ° ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(264823,7357,'ur','Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„ Ù‚Ø¨ Ø¨Ù„ Ù„Ù†Ú©',0),(264824,7357,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ñ€Ð°Ñ‡ÑƒÐ½Ðµ-Ð›Ð¸Ð½Ðº',0),(264825,7357,'vi','HÃ³a ÄÆ¡n QB-Há»“ SÆ¡ ÄÆ°á»ng Dáº«n Dáº¡ng Cá»™t',0),(264826,7357,'af','QB Rekeninge-Skakel met LÃªer Kolom Formaat',0),(264827,7357,'ro','QB facturile-Link dosar Format coloane',0),(264828,7357,'et','QB arved-Link faili veeruvormingut',0),(264829,7357,'si','Menice QB-Link zapisa stolpec',0),(264830,7357,'ba','Format kolom QB tagihan-Link File',0),(264831,7357,'nl','QB rekeningen-Link kolom bestandsindeling',0),(264832,7357,'fi','QB laskut-Link sarakkeen tiedostomuoto',0),(264833,7357,'no','QB regninger-Link-kolonnen filformat',0),(264834,7357,'da','QB regninger-Link-kolonne filformat',0),(264835,7357,'ko','ì¿¼í„° ë°± ì²­êµ¬ì„œ ë§í¬ íŒŒì¼ ì—´ í˜•ì‹',0),(264836,7357,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” QB ×©×˜×¨×•×ª-×§×™×©×•×¨ ×§×•×‘×¥',0),(264837,7357,'el','ÎœÎ¿ÏÏ†Î® ÏƒÏ„Î®Î»Î·Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿Ï… QB Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚-Link',0),(264838,7357,'zh','QuickBookç³»åˆ—å¸å•ï¼Œé“¾æŽ¥æ–‡ä»¶åˆ—æ ¼å¼\r\n',0),(264839,7357,'sv','QB rÃ¤kningar-Link-kolumn filformatet',0),(264840,7357,'it','QB bollette-Link File formato colonne',0),(264841,7357,'tl','',0),(264842,7357,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3621;&#3636;&#3591;&#3588;&#3660;&#3652;&#3615;&#3621;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3610;&#3636;&#3621; QB ',0),(264843,7357,'hi','QB à¤¬à¤¿à¤²-à¤²à¤¿à¤‚à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(264844,7357,'ms','Format kolum fail QB bil-Link',0),(264845,7357,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ Ù…Ù„Ù QB ÙÙˆØ§ØªÙŠØ± Ù„ÙŠÙ†Ùƒ',0),(264846,7357,'fr','Format de colonne pour le fichier QB factures-lien',0),(264847,7357,'jp','QB æ‰‹å½¢ãƒªãƒ³ã‚¯ ãƒ•ã‚¡ã‚¤ãƒ«ã®åˆ—ã®å½¢å¼',0),(264848,7357,'pt','QB contas-Link arquivo formato de coluna',0),(264849,7357,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° Ð²ÐµÐºÑÐµÐ»ÐµÐ¹ QB-Link',0),(264850,7357,'es','QB Recibos-Enlace Formato de File Columna',0),(264851,7357,'de','QB Rechnungen-Link Spalte Dateiformat',0),(264852,7357,'en','QB Bills-Link File Column Format',0),(264853,7358,'is','',0),(264854,7358,'dr','-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(264855,7358,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(264856,7358,'tr','QB faturalarÄ±nÄ± Ã¶deme dosyasÄ± sÃ¼tun biÃ§imi',0),(264857,7358,'pl','Rachunki QB-pÅ‚atnoÅ›ci kolumna Format pliku',0),(264858,7358,'bg','QB ÑÐ¼ÐµÑ‚ÐºÐ¸-Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(264859,7358,'ur','Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„ Ù‚Ø¨ Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù†Ø² Ù…ÛŒÚº Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(264860,7358,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ñ€Ð°Ñ‡ÑƒÐ½Ðµ-Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(264861,7358,'vi','HÃ³a ÄÆ¡n QB-Há»“ SÆ¡ thanh toÃ¡n theo dáº¡ng cá»™t',0),(264862,7358,'af','QB Rekeninge-Betaling LÃªer Kolom Formaat',0),(264863,7358,'ro','QB facturile-plata dosar Format coloane',0),(264864,7358,'et','QB arved maksmata faili veeruvormingut',0),(264865,7358,'si','Menice QB-plaÄilo zapisa stolpec',0),(264866,7358,'ba','Pembayaran tagihan QB Format File kolom',0),(264867,7358,'nl','Bestandsindeling kolom QB rekeningen-betaling',0),(264868,7358,'fi','QB laskut-sarakkeen tiedostomuoto',0),(264869,7358,'no','QB regninger-kolonnen betalingsfilformatet',0),(264870,7358,'da','QB regninger-betaling-kolonne filformat',0),(264871,7358,'ko','ì¿¼í„° ë°± ì²­êµ¬ì„œ ì§€ë¶ˆ íŒŒì¼ ì—´ í˜•ì‹',0),(264872,7358,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×§×•×‘×¥ QB ×©×˜×¨×•×ª-×ª×©×œ×•×',0),(264873,7358,'el','QB-Ï€Î»Î·ÏÏ‰Î¼Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Î±ÏÏ‡ÎµÎ¯Î¿ Î¼Î¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½',0),(264874,7358,'zh','QuickBookç³»åˆ—ç¥¨æ®ä»˜æ¬¾æ æ ¼å¼æ–‡ä»¶\r\n',0),(264875,7358,'sv','QB rÃ¤kningar-betalning-kolumn filformatet',0),(264876,7358,'it','Formato colonna QB fatture-pagamento',0),(264877,7358,'tl','',0),(264878,7358,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3610;&#3636;&#3621; QB ',0),(264879,7358,'hi','QB à¤•à¥‡ à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(264880,7358,'ms','Format kolum fail QB pembayaran bil-bil',0),(264881,7358,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ Ù…Ù„Ù QB-Ø¯ÙØ¹ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(264882,7358,'fr','Format de colonne pour le fichier QB factures-paiement',0),(264883,7358,'jp','QB æ‰‹å½¢æ”¯æ‰•ãƒ•ã‚¡ã‚¤ãƒ«ã®åˆ—ã®å½¢å¼',0),(264884,7358,'pt','QB contas de pagamento arquivo formato de coluna',0),(264885,7358,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° QB-Ð¾Ð¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(264886,7358,'es','QB Recibos-Pagos Formato de File Columna',0),(264887,7358,'de','Spalte-Dateiformat QB Rechnungen-Zahlungen',0),(264888,7358,'en','QB Bills-Payment File Column Format',0),(264889,7359,'is','',0),(264890,7359,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø²ÙŠØ± Ù…Ø´ÙƒÙ„Ø§ØªÙŠ Ø±Ø§ Ø¯Ø± Ø³ÙŠØ³ØªÙ… ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª',0),(264891,7359,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø²ÙŠØ± Ù…Ø´ÙƒÙ„Ø§ØªÙŠ Ø±Ø§ Ø¯Ø± Ø³ÙŠØ³ØªÙ… ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª',0),(264892,7359,'tr','AÅŸaÄŸÄ±daki Ã¶demeler alma sorunlarÄ± sistem vardÄ±.',0),(264893,7359,'pl','NastÄ™pujÄ…ce pÅ‚atnoÅ›ci miaÅ‚ problemy z importu w systemie',0),(264894,7359,'bg','Ð¡Ð»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ ÑÐ° Ð²Ð½Ð¾Ñ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð¸ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð½Ð°',0),(264895,7359,'ur','Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø³Ø§Ø¦Ù„ Ø§Ø³ Ù†Ø¸Ø§Ù… Ù…ÛŒÚº ØªÚ¾Ø§ Û”',0),(264896,7359,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ñ˜Ðµ Ð¸Ð¼Ð°Ð¾ ÑƒÐ²Ð¾Ð· Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð¸ Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ',0),(264897,7359,'vi','Thanh toÃ¡n nÃ y táº¡o ráº¯c rá»‘i cho há»‡ thá»‘ng',0),(264898,7359,'af','Die volgende Betalings het invoerprobleme in die sisteem',0),(264899,7359,'ro','UrmÄƒtoarele plÄƒÈ›i a avut probleme de import Ã®n sistemul de',0),(264900,7359,'et','JÃ¤rgmised maksed oli impordi probleemide sÃ¼steemis',0),(264901,7359,'si','Naslednja plaÄila imel uvoz teÅ¾ave v sistemu',0),(264902,7359,'ba','Pembayaran berikut memiliki masalah impor dalam sistem',0),(264903,7359,'nl','De volgende betalingen had importeren problemen in het systeem',0),(264904,7359,'fi','Seuraavat maksut oli Tuontiongelmia jÃ¤rjestelmÃ¤n',0),(264905,7359,'no','FÃ¸lgende utbetalinger hatt Importproblemer i systemet',0),(264906,7359,'da','De fÃ¸lgende betalinger havde problemer med import i systemet',0),(264907,7359,'ko','ë‹¤ìŒ ì§€ë¶ˆ ì‹œìŠ¤í…œì—ì„œ ê°€ì ¸ì˜¤ê¸° ë¬¸ì œë¥¼ í–ˆë‹¤',0),(264908,7359,'he','×”×ª×©×œ×•×ž×™× ×”×‘××™× ×”×™×• ×‘×¢×™×•×ª ×™×™×‘×•× ×‘×ž×¢×¨×›×ª',0),(264909,7359,'el','Î¤Î¹Ï‚ Î±ÎºÏŒÎ»Î¿Ï…Î¸ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ ÎµÎ¯Ï‡Îµ Ï€ÏÎ¿Î²Î»Î®Î¼Î±Ï„Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(264910,7359,'zh','ä¸‹åˆ—æ¬¾é¡¹å·²åœ¨ç³»ç»Ÿä¸­å¯¼å…¥é—®é¢˜\r\n',0),(264911,7359,'sv','FÃ¶ljande betalningar hade import problem i systemet',0),(264912,7359,'it','I seguenti pagamenti avevano problemi di importazione nel sistema',0),(264913,7359,'tl','',0),(264914,7359,'th','&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3605;&#3656;&#3629;&#3652;&#3611;&#3609;&#3637;&#3657;&#3617;&#3637;&#3611;&#3633;&#3597;&#3627;&#3634;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3651;&#3',0),(264915,7359,'hi','à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤®à¥‡à¤‚ à¤†à¤¯à¤¾à¤¤ à¤¸à¤®à¤¸à¥à¤¯à¤¾à¤“à¤‚ à¤¥à¤¾',0),(264916,7359,'ms','Bayaran-bayaran berikut mempunyai masalah import dalam sistem',0),(264917,7359,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„ØªØ§Ù„ÙŠØ© Ù‚Ø¯ Ù…Ø´Ø§ÙƒÙ„ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(264918,7359,'fr','Les paiements suivants avaient des problÃ¨mes d\'importation dans le systÃ¨me',0),(264919,7359,'jp','ä»¥ä¸‹ã®æ”¯æ‰•ã‚·ã‚¹ãƒ†ãƒ ã§ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®å•é¡Œã‚’æŒã£ã¦ã„ãŸ',0),(264920,7359,'pt','Os seguintes pagamentos tinham problemas de importaÃ§Ã£o no sistema',0),(264921,7359,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð±Ñ‹Ð»Ð¸ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ñ‹ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ðµ',0),(264922,7359,'es','Los siguentes Pagos tenÃ­an problemas de importaciÃ³n en el sistema',0),(264923,7359,'de','Folgenden Zahlungen hatte Import Probleme im system',0),(264924,7359,'en','The following Payments had import problems in the system',0),(264925,7360,'is','',0),(264926,7360,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ  ÙˆØ§Ø±Ø¯Ø´Ø¯Ù‡',0),(264927,7360,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ  ÙˆØ§Ø±Ø¯Ø´Ø¯Ù‡',0),(264928,7360,'tr','AlÄ±nan faturalarÄ±',0),(264929,7360,'pl','Rachunki importowane',0),(264930,7360,'bg','Ð—Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¸ Ð²Ð½ÐµÑÐµÐ½Ð¸',0),(264931,7360,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û Ø¨Ù„',0),(264932,7360,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ ÑƒÐ²ÐµÐ·ÐµÐ½',0),(264933,7360,'vi','Nháº­p HÃ³a ÄÆ¡n',0),(264934,7360,'af','Rekeninge Ingevoer',0),(264935,7360,'ro','Facturile importate',0),(264936,7360,'et','Arveid importida',0),(264937,7360,'si','Menice, uvoÅ¾enih',0),(264938,7360,'ba','Tagihan yang diimpor',0),(264939,7360,'nl','Facturen ingevoerd',0),(264940,7360,'fi','Laskut tuotu',0),(264941,7360,'no','Regninger importert',0),(264942,7360,'da','Regninger importeret',0),(264943,7360,'ko','ìˆ˜ìž… ê³„ì‚° ì„œ',0),(264944,7360,'he','×”×—×©×‘×•× ×•×ª ×™×•×‘××•',0),(264945,7360,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î± Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(264946,7360,'zh','å¯¼å…¥çš„å¸å•\r\n',0),(264947,7360,'sv','RÃ¤kningar som importeras',0),(264948,7360,'it','Bollette importate',0),(264949,7360,'tl','',0),(264950,7360,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3610;&#3636;&#3621;',0),(264951,7360,'hi','à¤†à¤¯à¤¾à¤¤ à¤¬à¤¿à¤²',0),(264952,7360,'ms','Bil-bil yang diimport',0),(264953,7360,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(264954,7360,'fr','Factures importÃ©es',0),(264955,7360,'jp','è«‹æ±‚æ›¸ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(264956,7360,'pt','Contas importadas',0),(264957,7360,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(264958,7360,'es','Facturas Importadas',0),(264959,7360,'de','Rechnungen importiert',0),(264960,7360,'en','Bills Imported',0),(264961,7361,'is','',0),(264962,7361,'dr','ÙˆØ±ÙˆØ¯ ÙƒØ§Ù…Ù„ ',0),(264963,7361,'pr','ÙˆØ±ÙˆØ¯ ÙƒØ§Ù…Ù„ ',0),(264964,7361,'tr','Tam alma',0),(264965,7361,'pl','PeÅ‚nego importu',0),(264966,7361,'bg','ÐŸÑŠÐ»Ð½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(264967,7361,'ur','Ù…Ú©Ù…Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(264968,7361,'sr','ÐŸÐ¾Ñ‚Ð¿ÑƒÐ½Ð¸ ÑƒÐ²Ð¾Ð·',0),(264969,7361,'vi','Nháº­p toÃ n bá»™',0),(264970,7361,'af','Volledige Invoer',0),(264971,7361,'ro','Import complet',0),(264972,7361,'et','Importimise tÃ¼Ã¼p',0),(264973,7361,'si','Polno uvaÅ¾anje',0),(264974,7361,'ba','Impor penuh',0),(264975,7361,'nl','Volledige importbewerking',0),(264976,7361,'fi','TÃ¤ysi tuonti',0),(264977,7361,'no','Fullstendig Import',0),(264978,7361,'da','Fuld Import',0),(264979,7361,'ko','ì „ì²´ ê°€ì ¸ì˜¤ê¸°',0),(264980,7361,'he','×™×‘×•× ×ž×œ×',0),(264981,7361,'el','Î Î»Î®ÏÎ¿Ï…Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(264982,7361,'zh','å®Œå…¨å¯¼å…¥\r\n',0),(264983,7361,'sv','FullstÃ¤ndig Import',0),(264984,7361,'it','Importazione completa',0),(264985,7361,'tl','',0),(264986,7361,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3648;&#3605;&#3655;&#3617;',0),(264987,7361,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤†à¤¯à¤¾à¤¤',0),(264988,7361,'ms','Import penuh',0),(264989,7361,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¥Ø³ØªÙŠØ±Ø§Ø¯',0),(264990,7361,'fr','Importation complÃ¨te',0),(264991,7361,'jp','ãƒ•ãƒ« ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(264992,7361,'pt','ImportaÃ§Ã£o completa',0),(264993,7361,'ru','ÐŸÐ¾Ð»Ð½Ñ‹Ð¹ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(264994,7361,'es','ImportaciÃ³n Completa',0),(264995,7361,'de','VollstÃ¤ndigen Import',0),(264996,7361,'en','Full Import',0),(264997,7362,'is','',0),(264998,7362,'dr',': Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ù‡Ù…Ù‡ Ø´Ø±ÙƒØªÙ‡Ø§ Ø±Ø§ Ø­Ø°Ù Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯ ',0),(264999,7362,'pr','Ø­Ø°Ù ÙƒØ§Ù…Ù„ Ù…Ø­ØªÙˆØ§ â€“ Ø§Ø®Ø·Ø§Ø± : Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ù‡Ù…Ù‡ Ø´Ø±ÙƒØªÙ‡Ø§ Ø±Ø§ Ø­Ø°Ù Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯ ',0),(265000,7362,'tr','Tam - dikkat! TÃ¼m ÅŸirketlerin varolan verileri siler',0),(265001,7362,'pl','Full - Uwaga! Usunie istniejÄ…ce dane wszystkich firm',0),(265002,7362,'bg','ÐŸÑŠÐ»ÐµÐ½ - Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ! Ð©Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ð´Ð°Ð½Ð½Ð¸ Ð²ÑŠÐ² Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(265003,7362,'ur','Ù¾ÙˆØ±ÛŒ - Ø§Ø­ØªÛŒØ§Ø·! ØªÙ…Ø§Ù… Ø§Ø¯Ø§Ø±ÙˆÚº Ù…ÛŒÚº Ù…ÙˆØ¬ÙˆØ¯ Ú©ÙˆØ§Ø¦Ù Ø­Ø°Ù Ú©Ø± Ø¯Û’ Ú¯Ø§',0),(265004,7362,'sr','ÐŸÑƒÐ½ - Ð¾Ð¿Ñ€ÐµÐ·! Ð‹Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ñƒ ÑÐ²Ð¸Ð¼ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð¸Ð¼Ð°',0),(265005,7362,'vi','Äáº§y Ä‘á»§ (bao gá»“m xÃ³a)',0),(265006,7362,'af','Vol - Waarskuwing! Gaan Bestaande Data in Alle Ondernemings Uitwis',0),(265007,7362,'ro','Full - atenÅ£ie! Va ÅŸterge datele existente Ã®n toate companiile',0),(265008,7362,'et','TÃ¤ielik - TÃ¤helepanu! Kustutab olemasolevad andmed kÃµikides ettevÃµtetes',0),(265009,7362,'si','Polno - Pozor! Boste izbrisali obstojeÄe podatke v vsem podjetjem',0),(265010,7362,'ba','Penuh - hati-hati! Akan menghapus Data yang ada di semua perusahaan',0),(265011,7362,'nl','Full - Let op! Bestaande gegevens in alle bedrijven zal verwijderen',0),(265012,7362,'fi','Full - varoitus! Poistaa kaikkien yritysten tiedot',0),(265013,7362,'no','Full - advarsel! Sletter eksisterende Data i alle selskaper',0),(265014,7362,'da','Fuld - forsigtighed! Vil slette eksisterende Data i alle regnskaber',0),(265015,7362,'ko','ì „ì²´-ì£¼ì˜! ëª¨ë“  íšŒì‚¬ì—ì„œ ê¸°ì¡´ ë°ì´í„°ë¥¼ ì‚­ì œ í•©ë‹ˆë‹¤.',0),(265016,7362,'he','. ×ž×œ××” - ×–×”×™×¨×•×ª! ×ª×ž×—×§ ××ª ×”× ×ª×•× ×™× ×”×§×™×™×ž×™× ×‘×—×‘×¨×•×ª ×›×œ',0),(265017,7362,'el','Î Î»Î®ÏÎ·Ï‚ - Î Î¡ÎŸÎ£ÎŸÎ§Î—! Î˜Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÎ¹ Ï„Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± ÏƒÎµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚',0),(265018,7362,'zh','å…¨éƒ¨-æ³¨æ„ï¼å°†åˆ é™¤æ‰€æœ‰å…¬å¸çš„çŽ°æœ‰æ•°æ®\r\n',0),(265019,7362,'sv','Full - fÃ¶rsiktighet! Tar bort befintliga Data i alla fÃ¶retag',0),(265020,7362,'it','Pieno - attenzione! Verranno eliminati i dati esistenti in tutte le societÃ ',0),(265021,7362,'tl','',0),(265022,7362,'th','&#3648;&#3605;&#3655;&#3617; - &#3648;&#3605;&#3639;&#3629;&#3609;! &#3592;&#3632;&#3621;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3610;&#3619;&#3636;&#3625;&#3633;&#360',0),(265023,7362,'hi','à¤ªà¥‚à¤°à¥à¤£ - à¤¸à¤¾à¤µà¤§à¤¾à¤¨à¥€! à¤¸à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾ à¤¦à¥‡à¤—à¤¾',0),(265024,7362,'ms','Penuh - berhati-hati! Akan memadam Data sedia ada dalam syarikat-syarikat semua',0),(265025,7362,'ar','ÙƒØ§Ù…Ù„ - ØªØ­Ø°ÙŠØ± !! - Ø³ÙˆÙ ØªØ­Ø°Ù Ø¬Ù…ÙŠØ¹ Ø¨ÙŠØ§Ù†Ø§Øª ÙƒÙ„Ù‘ Ø§Ù„Ø´Ø±ÙƒØ§Øª !! ',0),(265026,7362,'fr','Complet - attentionÂ ! Supprime les donnÃ©es existantes dans toutes les sociÃ©tÃ©s',0),(265027,7362,'jp','ãƒ•ãƒ« - æ³¨æ„!ã™ã¹ã¦ã®ä¼æ¥­ã®æ—¢å­˜ã®ãƒ‡ãƒ¼ã‚¿ãŒå‰Šé™¤ã•ã‚Œã¾ã™ã€‚',0),(265028,7362,'pt','Completo - cuidado! Vai apagar os dados existentes em todas as empresas',0),(265029,7362,'ru','ÐŸÐ¾Ð»Ð½Ñ‹Ð¹ - Ð¾ÑÑ‚Ð¾Ñ€Ð¾Ð¶Ð½Ð¾! ÐŸÑ€Ð¸Ð²ÐµÐ´ÐµÑ‚ Ðº ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸ÑŽ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð²Ð¾ Ð²ÑÐµÑ… ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ…',0),(265030,7362,'es','Completo - CauciÃ³n! Se EliminarÃ¡n Datos Existentes en Todas las Empresas',0),(265031,7362,'de','Voll - Vorsicht! LÃ¶scht vorhandene Daten in alle Mandanten',0),(265032,7362,'en','Full - Caution! Will Delete Existing Data in All Companies',0),(265033,7363,'is','',0),(265034,7363,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡\r\n QB Bills',0),(265035,7363,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡\r\n QB Bills',0),(265036,7363,'tr','QB faturalarÄ±nÄ± almak',0),(265037,7363,'pl','Importowanie rachunki QB',0),(265038,7363,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QB ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(265039,7363,'ur','Ù‚Ø¨ Ø¨Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(265040,7363,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(265041,7363,'vi','Nháº­p HÃ³a ÄÆ¡n QB',0),(265042,7363,'af','Invoer van QB Rekeninge',0),(265043,7363,'ro','QB facturi de import',0),(265044,7363,'et','QB maksumust',0),(265045,7363,'si','Uvoz menice QB',0),(265046,7363,'ba','Impor QB tagihan',0),(265047,7363,'nl','QB facturen importeren',0),(265048,7363,'fi','Tuo QB laskut',0),(265049,7363,'no','Importere QB regninger',0),(265050,7363,'da','Importere QB regninger',0),(265051,7363,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ì²­êµ¬ì„œ',0),(265052,7363,'he','×œ×™×™×‘× ×—×©×‘×•× ×•×ª QB',0),(265053,7363,'el','Î¤Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ ÎµÎ¹ÏƒÎ±Î³ÏŒÎ¼ÎµÎ½Î·Ï‚ QB',0),(265054,7363,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—å¸å•\r\n',0),(265055,7363,'sv','Importera QB rÃ¤kningar',0),(265056,7363,'it','Bollette di importazione QB',0),(265057,7363,'tl','',0),(265058,7363,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3610;&#3636;&#3621; QB',0),(265059,7363,'hi','QB à¤†à¤¯à¤¾à¤¤ à¤¬à¤¿à¤²',0),(265060,7363,'ms','Bil-bil import QB',0),(265061,7363,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ QB',0),(265062,7363,'fr','Facture des importations QB',0),(265063,7363,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã® QB æ³•æ¡ˆ',0),(265064,7363,'pt','Importar contas de QB',0),(265065,7363,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚ QB',0),(265066,7363,'es','Importar QB Facturas',0),(265067,7363,'de','QB Rechnungen importieren',0),(265068,7363,'en','Import QB Bills',0),(265069,7364,'is','',0),(265070,7364,'dr','QB ',0),(265071,7364,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ QB ',0),(265072,7364,'tr','QB satÄ±cÄ± faturalarÄ±nÄ± almak',0),(265073,7364,'pl','ZaimportowaÄ‡ rachunki QB dostawcy',0),(265074,7364,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QB Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(265075,7364,'ur','Ù‚Ø¨ ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(265076,7364,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(265077,7364,'vi','Nháº­p HÃ³a ÄÆ¡n QB Cá»§a NgÆ°á»i bÃ¡n',0),(265078,7364,'af','Invoer van QB Verskaffer Rekeninge',0),(265079,7364,'ro','QB furnizor facturi de import',0),(265080,7364,'et','Impordi QB tarnijate arved',0),(265081,7364,'si','Uvoz menice QB dobavitelja',0),(265082,7364,'ba','Impor QB Vendor tagihan',0),(265083,7364,'nl','QB leverancier facturen importeren',0),(265084,7364,'fi','Tuo QB toimittajan laskut',0),(265085,7364,'no','Importere QB leverandÃ¸r regninger',0),(265086,7364,'da','Importere QB kreditor regninger',0),(265087,7364,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ',0),(265088,7364,'he','×œ×™×™×‘× ×—×©×‘×•× ×•×ª ×¡×¤×§ QB',0),(265089,7364,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® QB',0),(265090,7364,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—ä¾›åº”å•†å¸å•\r\n',0),(265091,7364,'sv','Importera QB leverantÃ¶r rÃ¤kningar',0),(265092,7364,'it','Importare le fatture fornitore QB',0),(265093,7364,'tl','',0),(265094,7364,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634; QB &#3610;&#3636;&#3621;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(265095,7364,'hi','QB à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(265096,7364,'ms','Bil import QB Penjual',0),(265097,7364,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙˆØ±Ø¯ QB',0),(265098,7364,'fr','Importation de factures fournisseur QB',0),(265099,7364,'jp','QB ã®ä»•å…¥å…ˆè«‹æ±‚æ›¸ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(265100,7364,'pt','Importar contas de fornecedor QB',0),(265101,7364,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚ QB Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(265102,7364,'es','Importar QB Recibos de Proveedores',0),(265103,7364,'de','Importieren Sie QB Lieferanten-Rechnungen',0),(265104,7364,'en','Import QB Vendor Bills',0),(265105,7365,'is','',0),(265106,7365,'dr','- Ù‡ÙŠÚ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø­Ø°Ù Ù†Ø´Ø¯ ',0),(265107,7365,'pr','Ø¬Ø²Ø¦ÙŠ- Ù‡ÙŠÚ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø­Ø°Ù Ù†Ø´Ø¯ ',0),(265108,7365,'tr','KÄ±smi - varolan veri silinmiÅŸ yok',0),(265109,7365,'pl','CzÄ™Å›ciowe - nie ma istniejÄ…cych danych usuniÄ™te',0),(265110,7365,'bg','Ð§Ð°ÑÑ‚Ð¸Ñ‡ÐµÐ½ - Ð½ÑÐ¼Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸',0),(265111,7365,'ur','Ø¬Ø²ÙˆÛŒ - Ú©ÙˆØ¦ÛŒ Ù…ÙˆØ¬ÙˆØ¯ Ú©ÙˆØ§Ø¦Ù Ø­Ø°Ù Ú©Ø± Ø¯ÛŒØ§',0),(265112,7365,'sr','Ð”ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð¾ - Ð½ÐµÐ¼Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½',0),(265113,7365,'vi','Má»™t pháº§n-khÃ´ng xÃ³a',0),(265114,7365,'af','Gedeetelik - Nie Bestaande Data Geskrap',0),(265115,7365,'ro','ParÅ£ialÄƒ - date existente ÅŸters',0),(265116,7365,'et','Osaline - Olemasolevaid andmeid ei kustutata',0),(265117,7365,'si','Delni - ni obstojeÄih podatkov, izbrisani',0),(265118,7365,'ba','Parsial - tidak ada Data yang dihapus',0),(265119,7365,'nl','PartiÃ«le - geen bestaande gegevens verwijderd',0),(265120,7365,'fi','Osittaisen - ole poistaa tietoja',0),(265121,7365,'no','Delvis - ingen eksisterende Data slettet',0),(265122,7365,'da','Delvis - ingen eksisterende Data slettet',0),(265123,7365,'ko','ë¶€ë¶„-ê¸°ì¡´ ë°ì´í„° ì‚­ì œ',0),(265124,7365,'he','×—×œ×§×™×ª - ××™×Ÿ × ×ª×•× ×™× ×§×™×™×ž×™× × ×ž×—×§',0),(265125,7365,'el','ÎœÎµÏÎ¹ÎºÎ® - ÎºÎ±Î¼Î¯Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹',0),(265126,7365,'zh','éƒ¨åˆ†- æ— çŽ°æœ‰æ•°æ®åˆ é™¤\r\n',0),(265127,7365,'sv','Delvis - inga befintliga Data tas bort',0),(265128,7365,'it','Parziale - non eliminati i dati esistenti',0),(265129,7365,'tl','',0),(265130,7365,'th','&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;-&#3652;&#3617;&#3656;&#3621;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(265131,7365,'hi','à¤†à¤‚à¤¶à¤¿à¤• - à¤•à¥‹à¤ˆ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(265132,7365,'ms','Separa - tiada Data yang sedia ada dihapuskan',0),(265133,7365,'ar','Ø¬Ø²Ø¦ÙŠ - Ù„Ù† ØªØ­Ø°Ù Ø£ÙŠ Ø¨ÙŠØ§Ù†Ø§Øª Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(265134,7365,'fr','Partielle - aucune donnÃ©e existante supprimÃ©e',0),(265135,7365,'jp','éƒ¨åˆ†ã®å‰Šé™¤æ—¢å­˜ãƒ‡ãƒ¼ã‚¿ãªã—',0),(265136,7365,'pt','Parcial - nÃ£o eliminados os dados existentes',0),(265137,7365,'ru','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ - Ð½ÐµÑ‚ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(265138,7365,'es','Parcial-Ningunos Datos Existentes Se EliminarÃ¡n',0),(265139,7365,'de','Teilweise - keine vorhandenen Daten gelÃ¶scht',0),(265140,7365,'en','Partial - No Existing Data Deleted',0),(265141,7366,'is','',0),(265142,7366,'dr','- Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265143,7366,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø¬Ø²Ø¦ÙŠØ§Øª Ù‡Ø²ÙŠÙ†Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§- Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265144,7366,'tr','QB faturalarÄ± harcama ayrÄ±ntÄ± F\'ile sÃ¼tun biÃ§imi',0),(265145,7366,'pl','Rachunki QB-koszt szczegÃ³Å‚owo F\'ile kolumna Format',0),(265146,7366,'bg','QB ÑÐ¼ÐµÑ‚ÐºÐ¸-ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ F\'ile ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265147,7366,'ur','Ù‚Ø¨ Ø¨Ù„ Ø®Ø±Ú†Û ØªÙØµÛŒÙ„ F\'ile Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(265148,7366,'sr','Ð‘ÐµÐº Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ð´ÐµÑ‚Ð°Ñ™ Ð¤\'Ð¸Ð»Ðµ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265149,7366,'vi','HÃ³a ÄÆ¡n QB-Chi Tiáº¿t Chi PhÃ­ theo dáº¡ng cá»™t',0),(265150,7366,'af','QB Rekeninge-Uitgawe Gedetailleerde LÃªer Kolom Formaat',0),(265151,7366,'ro','Format coloane QB facturile-cheltuieli detaliu F\'ile',0),(265152,7366,'et','QB arved-kulu Detail F\'ile veeruvormingut',0),(265153,7366,'si','Menice QB-stroÅ¡ke podrobno F\'ile stolpcu Format',0),(265154,7366,'ba','QB tagihan-biaya Detail F\'ile kolom Format',0),(265155,7366,'nl','QB rekeningen-kosten Detail F\'ile kolomindeling',0),(265156,7366,'fi','QB laskut-kulu yksityiskohtaisesti F\'ile sarakkeen muoto',0),(265157,7366,'no','QB regninger-bekostning detalj F\'ile kolonneformat',0),(265158,7366,'da','QB regninger-regning detalje F\'ile kolonneformat',0),(265159,7366,'ko','ì¿¼í„° ë°± ì²­êµ¬ì„œ ë¹„ìš© ì„¸ë¶€ F\'ile ì—´ í˜•ì‹',0),(265160,7366,'he','QB ×©×˜×¨×•×ª-×”×•×¦××•×ª ×¤×¨×˜ F\'ile ×¢×ž×•×“×” ×‘×ª×‘× ×™×ª',0),(265161,7366,'el','QB Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚-Î´Î±Ï€Î¬Î½Î· Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± F\'ile Î¼Î¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½',0),(265162,7366,'zh','QuickBookç³»åˆ—ç¥¨æ®å¼€æ”¯æ˜Žç»†æ–‡ä»¶åˆ—çš„æ ¼å¼\r\n',0),(265163,7366,'sv','QB rÃ¤kningar-kostnad ingÃ¥ende F\'ile kolumner',0),(265164,7366,'it','QB bollette-spese dettaglio F\'ile colonna formato',0),(265165,7366,'tl','',0),(265166,7366,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3610;&#3636;&#3621; QB ',0),(265167,7366,'hi','QB à¤¬à¤¿à¤²-à¤µà¥à¤¯à¤¯ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° F\'ile à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(265168,7366,'ms','QB bil-perbelanjaan terperinci F\'ile lajur Format',0),(265169,7366,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ F\'ile ØªÙØ§ØµÙŠÙ„ ÙÙˆØ§ØªÙŠØ± QB-Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª',0),(265170,7366,'fr','Format de colonne F\'ile QB factures-charges dÃ©tail',0),(265171,7366,'jp','QB æ‰‹å½¢çµŒè²»è©³ç´° F\'ile åˆ—å½¢å¼',0),(265172,7366,'pt','Formato de coluna QB contas-despesa detalhes F\'ile',0),(265173,7366,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° F\'ile Ð´ÐµÑ‚Ð°Ð»ÑŒ Ð²ÐµÐºÑÐµÐ»ÐµÐ¹ QB-ÑÑ‡ÐµÑ‚',0),(265174,7366,'es','QB Detalle de Recibos-Gastos Formato de File Columna',0),(265175,7366,'de','QB Rechnungen-Aufwand Detailformat F\'ile Spalte',0),(265176,7366,'en','QB Bills-Expense Detail F`ile Column Format',0),(265177,7367,'is','',0),(265178,7367,'dr','-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265179,7367,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265180,7367,'tr','QB faturalarÄ± dosyasÄ± sÃ¼tun biÃ§imi',0),(265181,7367,'pl','Rachunki QB-formatu kolumny',0),(265182,7367,'bg','QB ÑÐ¼ÐµÑ‚ÐºÐ¸-ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265183,7367,'ur','ÙˆØ¶Ø¹ Ú©Ø§Ù„Ù… Ù‚Ø¨ Ø¨Ù„-Ù…Ø³Ù„',0),(265184,7367,'sr','Ð‘ÐµÐº Ñ€Ð°Ñ‡ÑƒÐ½Ðµ-ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(265185,7367,'vi','HÃ³a ÄÆ¡n QB-Theo dáº¡ng cá»™t',0),(265186,7367,'af','QB Rekeninge-LÃªer Kolom Formaat',0),(265187,7367,'ro','Format de coloane QB facturile-dosar',0),(265188,7367,'et','QB arved-faili veeruvormingut',0),(265189,7367,'si','QB menice-stolpec zapisa',0),(265190,7367,'ba','Format kolom QB tagihan-File',0),(265191,7367,'nl','QB rekeningen-File kolom formaat',0),(265192,7367,'fi','QB laskut sarakkeen muoto',0),(265193,7367,'no','QB regninger-fil kolonneformat',0),(265194,7367,'da','QB regninger-fil kolonneformatet',0),(265195,7367,'ko','ì¿¼í„° ë°± ì²­êµ¬ì„œ íŒŒì¼ ì—´ í˜•ì‹',0),(265196,7367,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” QB ×©×˜×¨×•×ª-×§×•×‘×¥',0),(265197,7367,'el','ÎœÎ¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½ QB Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚-Î±ÏÏ‡ÎµÎ¯Î¿',0),(265198,7367,'zh','QuickBookç³»åˆ—ç¥¨æ®æ–‡ä»¶åˆ—æ ¼å¼\r\n',0),(265199,7367,'sv','Kolumnen QB rÃ¤kningar-filformat',0),(265200,7367,'it','QB bollette-File formato colonna',0),(265201,7367,'tl','',0),(265202,7367,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3610;&#3636;&#3621; QB ',0),(265203,7367,'hi','QB à¤¬à¤¿à¤²-à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(265204,7367,'ms','Format lajur QB bil-fail',0),(265205,7367,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ QB ÙÙˆØ§ØªÙŠØ±-Ù…Ù„Ù',0),(265206,7367,'fr','Format de colonne QB factures-fichier',0),(265207,7367,'jp','QB æ‰‹å½¢ãƒ•ã‚¡ã‚¤ãƒ«åˆ—å½¢å¼',0),(265208,7367,'pt','Formato de coluna do arquivo de contas QB',0),(265209,7367,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ð²ÐµÐºÑÐµÐ»ÐµÐ¹ QB-Ñ„Ð°Ð¹Ð»',0),(265210,7367,'es','QB Recibos-Formato de File Columna',0),(265211,7367,'de','QB Rechnungen-Dateiformat Spalte',0),(265212,7367,'en','QB Bills-File Column Format',0),(265213,7368,'is','',0),(265214,7368,'dr','- Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265215,7368,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ù„Ø§ - Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265216,7368,'tr','QB faturalarÄ±-madde ayrÄ±ntÄ± dosyasÄ± sÃ¼tun biÃ§imi',0),(265217,7368,'pl','Rachunki QB-element SzczegÃ³Å‚y formatu kolumny',0),(265218,7368,'bg','QB ÑÐ¼ÐµÑ‚ÐºÐ¸-ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265219,7368,'ur','Ù‚Ø¨ Ø¨Ù„ Ø´Û’ ØªÙØµÛŒÙ„ Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„',0),(265220,7368,'sr','ÐšÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ñ€Ð°Ñ‡ÑƒÐ½Ðµ-ÑÑ‚Ð°Ð²ÐºÐ° Ð´ÐµÑ‚Ð°Ñ™Ð°',0),(265221,7368,'vi','HÃ³a ÄÆ¡n QB-Chi Tiáº¿t Danh Má»¥c theo dáº¡ng cá»™t',0),(265222,7368,'af','QB Rekeninge-Item Detail LÃªer Kolom Formaat',0),(265223,7368,'ro','QB facturile-element detaliu fisierul coloana Format',0),(265224,7368,'et','QB arved-kauba Detail faili veeruvormingut',0),(265225,7368,'si','Menice QB-element podrobnosti zapisa stolpec',0),(265226,7368,'ba','Format kolom QB tagihan-Item Detail File',0),(265227,7368,'nl','QB rekeningen-Item Detail bestandsindeling kolom',0),(265228,7368,'fi','QB laskut-kohteen tiedot sarakkeen tiedostomuoto',0),(265229,7368,'no','QB regninger-element detaljer-kolonnen filformat',0),(265230,7368,'da','QB regninger-vare detaljer filformat kolonne',0),(265231,7368,'ko','ì¿¼í„° ë°± ì²­êµ¬ì„œ í•­ëª© ì„¸ë¶€ íŒŒì¼ ì—´ í˜•ì‹',0),(265232,7368,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×©×œ ×§×•×‘×¥ ×¤×™×¨×•×˜ QB ×©×˜×¨×•×ª-×¤×¨×™×˜',0),(265233,7368,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± QB Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚-ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î¼Î¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½',0),(265234,7368,'zh','QuickBookç³»åˆ—ç¥¨æ®é¡¹ç›®æ˜Žç»†æ æ ¼å¼æ–‡ä»¶\r\n',0),(265235,7368,'sv','QB rÃ¤kningar-objektet detalj-kolumn filformatet',0),(265236,7368,'it','QB bollette-elemento dettaglio File formato colonne',0),(265237,7368,'tl','',0),(265238,7368,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3636;&#3621; QB ',0),(265239,7368,'hi','QB à¤¬à¤¿à¤² à¤•à¥‡ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(265240,7368,'ms','Format lajur QB bil-perkara butiran fail',0),(265241,7368,'ar','ÙÙˆØ§ØªÙŠØ± QB-Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„ØªÙØµÙŠÙ„ Ù…Ù„Ù ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯',0),(265242,7368,'fr','Format de colonne fichier QB factures-Item dÃ©tail',0),(265243,7368,'jp','QB æ‰‹å½¢é …ç›®è©³ç´°ãƒ•ã‚¡ã‚¤ãƒ«åˆ—å½¢å¼',0),(265244,7368,'pt','QB contas-Item detalhe arquivo formato de coluna',0),(265245,7368,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ð²ÐµÐºÑÐµÐ»ÐµÐ¹ QB-Ð¿ÑƒÐ½ÐºÑ‚',0),(265246,7368,'es','QB Recibos-Detalle de Items Formato de File Columna',0),(265247,7368,'de','QB Rechnungen-Item Details Spalte Dateiformat',0),(265248,7368,'en','QB Bills-Item Detail File Column Format',0),(265249,7369,'is','',0),(265250,7369,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø²ÙŠØ± Ù…Ø´ÙƒÙ„Ø§ØªÙŠ Ø±Ø§ Ø¯Ø± Ø³ÙŠØ³ØªÙ… Ø§ÙŠØ¬Ø§Ø¯ ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª',0),(265251,7369,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø²ÙŠØ± Ù…Ø´ÙƒÙ„Ø§ØªÙŠ Ø±Ø§ Ø¯Ø± Ø³ÙŠØ³ØªÙ… Ø§ÙŠØ¬Ø§Ø¯ ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª',0),(265252,7369,'tr','AÅŸaÄŸÄ±daki faturalarÄ± alma sorunlarÄ± sistem vardÄ±.',0),(265253,7369,'pl','NastÄ™pujÄ…ce rachunki miaÅ‚ problemy z importu w systemie',0),(265254,7369,'bg','Ð¡Ð»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¸ ÑÐ° Ð²Ð½Ð¾Ñ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð¸ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð½Ð°',0),(265255,7369,'ur','Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ø¨Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø³Ø§Ø¦Ù„ Ø§Ø³ Ù†Ø¸Ø§Ù… Ù…ÛŒÚº ØªÚ¾Ø§ Û”',0),(265256,7369,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð¸Ð¼Ð°Ð¾ ÑƒÐ²Ð¾Ð· Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ðµ Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ',0),(265257,7369,'vi','HÃ³a ÄÆ¡n nÃ y táº¡o ráº¯c rá»‘i cho há»‡ thá»‘ng',0),(265258,7369,'af','Die volgende Rekeninge het invoerprobleme in die sisteem',0),(265259,7369,'ro','UrmÄƒtoarele facturile au avut probleme de import Ã®n sistemul',0),(265260,7369,'et','JÃ¤rgmine koosluste oli impordi probleemide sÃ¼steemis',0),(265261,7369,'si','Naslednje raÄune imel uvoz teÅ¾ave v sistemu',0),(265262,7369,'ba','Tagihan berikut memiliki masalah impor dalam sistem',0),(265263,7369,'nl','De volgende rekeningen had importeren problemen in het systeem',0),(265264,7369,'fi','Seuraavat laskut oli Tuontiongelmia jÃ¤rjestelmÃ¤n',0),(265265,7369,'no','FÃ¸lgende regninger hadde Importproblemer i systemet',0),(265266,7369,'da','De fÃ¸lgende regninger havde problemer med import i systemet',0),(265267,7369,'ko','ë‹¤ìŒê³¼ ê°™ì€ ì²­êµ¬ì„œ ì‹œìŠ¤í…œì—ì„œ ê°€ì ¸ì˜¤ê¸° ë¬¸ì œë¥¼ í–ˆë‹¤',0),(265268,7369,'he','×”×—×©×‘×•× ×•×ª ×”×‘××™× ×”×™×• ×‘×¢×™×•×ª ×™×™×‘×•× ×‘×ž×¢×¨×›×ª',0),(265269,7369,'el','ÎŸÎ¹ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ ÎµÎ¯Ï‡Î±Î½ Ï€ÏÎ¿Î²Î»Î®Î¼Î±Ï„Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(265270,7369,'zh','ä¸‹åˆ—å¸å•åœ¨ç³»ç»Ÿä¸­å¯¼å…¥é—®é¢˜\r\n',0),(265271,7369,'sv','FÃ¶ljande rÃ¤kningar hade import problem i systemet',0),(265272,7369,'it','Le seguenti bollette avevano problemi di importazione nel sistema',0),(265273,7369,'tl','',0),(265274,7369,'th','&#3610;&#3636;&#3621;&#3605;&#3656;&#3629;&#3652;&#3611;&#3609;&#3637;&#3657;&#3617;&#3637;&#3611;&#3633;&#3597;&#3627;&#3634;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3651;&#3609;&#3619;&#3632;&#3610;&#3610;',0),(265275,7369,'hi','à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤¬à¤¿à¤² à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤®à¥‡à¤‚ à¤†à¤¯à¤¾à¤¤ à¤¸à¤®à¤¸à¥à¤¯à¤¾à¤“à¤‚ à¤¥à¤¾',0),(265276,7369,'ms','Bil-bil berikut mempunyai masalah import dalam sistem',0),(265277,7369,'ar','Ù…Ø´Ø§Ø±ÙŠØ¹ Ø§Ù„Ù‚ÙˆØ§Ù†ÙŠÙ† Ø§Ù„ØªØ§Ù„ÙŠØ© Ù‚Ø¯ Ù…Ø´Ø§ÙƒÙ„ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(265278,7369,'fr','Les projets de loi suivants eu des problÃ¨mes pour importer dans le systÃ¨me',0),(265279,7369,'jp','æ¬¡ã®æ³•æ¡ˆã‚·ã‚¹ãƒ†ãƒ ã§ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®å•é¡Œã‚’æŒã£ã¦ã„ãŸ',0),(265280,7369,'pt','As seguintes contas tinham problemas de importaÃ§Ã£o no sistema',0),(265281,7369,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ñ‹ Ð±Ñ‹Ð»Ð¸ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ñ‹ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ðµ',0),(265282,7369,'es','Los recibos siguentes tenÃ­an problemas de importaciÃ³n en el sistema',0),(265283,7369,'de','Die folgenden Rechnungen hatte Import Probleme im system',0),(265284,7369,'en','The following Bills had import problems in the system',0),(265285,7370,'is','',0),(265286,7370,'dr','ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ ',0),(265287,7370,'pr','ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ ',0),(265288,7370,'tr','Ä°thal',0),(265289,7370,'pl','Importowane',0),(265290,7370,'bg','Ð’Ð½ÐµÑÐµÐ½Ð¸',0),(265291,7370,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û',0),(265292,7370,'sr','Ð£Ð²ÐµÐ·ÐµÐ½Ð¸',0),(265293,7370,'vi','ÄÃ£ Nháº­p',0),(265294,7370,'af','Ingevoer',0),(265295,7370,'ro','Importate',0),(265296,7370,'et','Imporditud',0),(265297,7370,'si','UvoÅ¾ena',0),(265298,7370,'ba','Impor',0),(265299,7370,'nl','GeÃ¯mporteerd',0),(265300,7370,'fi','Tuotu',0),(265301,7370,'no','Importert',0),(265302,7370,'da','Importeret',0),(265303,7370,'ko','ìˆ˜ìž…',0),(265304,7370,'he','×ž×™×•×‘××™×',0),(265305,7370,'el','Î•Î¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(265306,7370,'zh','å¯¼å…¥çš„\r\n',0),(265307,7370,'sv','Importerade',0),(265308,7370,'it','Importati',0),(265309,7370,'tl','',0),(265310,7370,'th','&#3606;&#3641;&#3585;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(265311,7370,'hi','à¤†à¤¯à¤¾à¤¤à¤¿à¤¤',0),(265312,7370,'ms','Diimport',0),(265313,7370,'ar','Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(265314,7370,'fr','ImportÃ©',0),(265315,7370,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(265316,7370,'pt','Importado',0),(265317,7370,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ',0),(265318,7370,'es','Importado',0),(265319,7370,'de','Importiert',0),(265320,7370,'en','Imported',0),(265321,7371,'is','',0),(265322,7371,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡\r\n QB \r\n',0),(265323,7371,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡\r\n QB \r\n',0),(265324,7371,'tr','Alma QB iade faturasÄ±',0),(265325,7371,'pl','PrzywÃ³z QB faktura korygujÄ…ca',0),(265326,7371,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ QB ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(265327,7371,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ù‚Ø¨ Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ',0),(265328,7371,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(265329,7371,'vi','Nháº­p Báº£ng Ghi Nhá»› TÃ­n Dá»¥ng QB',0),(265330,7371,'af','Invoer van QB Krediet Memo',0),(265331,7371,'ro','NotÄƒ de Credit de QB import',0),(265332,7371,'et','Impordi QB kreeditarve',0),(265333,7371,'si','Uvoz QB dobropis',0),(265334,7371,'ba','Memo kredit QB impor',0),(265335,7371,'nl','Import QB creditnota',0),(265336,7371,'fi','Tuo QB hyvityslasku',0),(265337,7371,'no','Importer QB kreditnota',0),(265338,7371,'da','Import QB kreditnota',0),(265339,7371,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ì‹ ìš© ë©”ëª¨',0),(265340,7371,'he','×™×™×‘×•× QB ×”×–×™×›×•×™',0),(265341,7371,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® QB Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(265342,7371,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—ä¿¡ç”¨å¤‡å¿˜å½•\r\n',0),(265343,7371,'sv','Importera QB kreditnota',0),(265344,7371,'it','Nota di credito QB di importazione',0),(265345,7371,'tl','',0),(265346,7371,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3649;&#3617;&#3617;&#3650;&#3617; QB',0),(265347,7371,'hi','à¤†à¤¯à¤¾à¤¤ QB à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹',0),(265348,7371,'ms','Memo QB kredit import',0),(265349,7371,'ar','Ø§Ù„Ù…Ø°ÙƒØ±Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† QB Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(265350,7371,'fr','Note de crÃ©dit de QB d\'importation',0),(265351,7371,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ QB ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆãƒ¡ãƒ¢',0),(265352,7371,'pt','Nota de crÃ©dito de QB de importaÃ§Ã£o',0),(265353,7371,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ QB ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ð°',0),(265354,7371,'es','Importar QB Memo de CrÃ©dito',0),(265355,7371,'de','Import QB-Gutschrift',0),(265356,7371,'en','Import QB Credit Memo',0),(265357,7372,'is','',0),(265358,7372,'dr','-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265359,7372,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø¬Ø²Ø¦ÙŠØ§Øª Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265360,7372,'tr','QB iade faturasÄ± ayrÄ±ntÄ± dosyasÄ± sÃ¼tun biÃ§imi',0),(265361,7372,'pl','QB Credit Memo szczegÃ³Å‚Ã³w pliku kolumna Format',0),(265362,7372,'bg','QB ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ñ„Ð°Ð¹Ð» ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265363,7372,'ur','Ù‚Ø¨ Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ ØªÙØµÛŒÙ„ Ù…Ø³Ù„ Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(265364,7372,'sr','ÐšÐ¾Ð»Ð¾Ð½Ð° ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐ° Ð´ÐµÑ‚Ð°Ñ™Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð°',0),(265365,7372,'vi','Báº£ng Ghi Nhá»› Chi Tiáº¿t TÃ­n Dá»¥ng QB theo dáº¡ng cá»™t',0),(265366,7372,'af','QB Kredietmemo Gedetailleerde LÃªer Kolom Formaat',0),(265367,7372,'ro','QB Credit Memo detaliu fisierul coloana Format',0),(265368,7372,'et','QB krediidi Detail memofaili veergu formaadis',0),(265369,7372,'si','Stolpec QB kreditne Memo podrobno datoteke Format',0),(265370,7372,'ba','Kolom QB kredit Memo Detail File Format',0),(265371,7372,'nl','QB Credit memobestand Detail kolom formaat',0),(265372,7372,'fi','QB luottoa Muistio yksityiskohtaisesti sarake muodossa',0),(265373,7372,'no','QB Memo detalj fil kolonnen Format',0),(265374,7372,'da','QB detalje-kreditnotafil kolonne Format',0),(265375,7372,'ko','ì¿¼í„° ë°± ì‹ ìš© ë©”ëª¨ ì„¸ë¶€ íŒŒì¼ ì—´ í˜•ì‹',0),(265376,7372,'he','×§×•×‘×¥ ×¤×™×¨×•×˜ ×©×œ ×”×ª×–×›×™×¨ ×”×–×™×›×•×™ QB ×¢×ž×•×“×” ×¢×™×¦×•×‘',0),(265377,7372,'el','QB Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± ÏƒÏ„Î®Î»Î· Î¼Î¿ÏÏ†Î®',0),(265378,7372,'zh','QuickBookç³»åˆ—ä¿¡ç”¨å¤‡å¿˜å½•è¯¦ç»†åˆ—çš„æ ¼å¼æ–‡ä»¶\r\n',0),(265379,7372,'sv','QB kredit Memo detalj kolumn Format',0),(265380,7372,'it','Colonna QB Credit Memo dettaglio File Format',0),(265381,7372,'tl','',0),(265382,7372,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3649;&#3617;&#3617;&#3',0),(265383,7372,'hi','QB à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(265384,7372,'ms','Lajur QB kredit Memo butiran fail Format',0),(265385,7372,'ar','Ø¹Ù…ÙˆØ¯ QB Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ù…Ø°ÙƒØ±Ø© ØªÙØ§ØµÙŠÙ„ Ù…Ù„Ù ØªÙ†Ø³ÙŠÙ‚',0),(265386,7372,'fr','Colonne QB crÃ©dit Memo dÃ©tail File Format',0),(265387,7372,'jp','QB ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ãƒ¡ãƒ¢è©³ç´°ãƒ•ã‚¡ã‚¤ãƒ«åˆ—å½¢å¼',0),(265388,7372,'pt','Coluna do arquivo de detalhe de memorando de crÃ©dito QB formato',0),(265389,7372,'ru','Ð¡Ñ‚Ð¾Ð»Ð±ÐµÑ† QB ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ñ‹ Ð´ÐµÑ‚Ð°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ñ„Ð°Ð¹Ð»Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265390,7372,'es','QB Detalle de Memo de CrÃ©dito Formato de File Columna',0),(265391,7372,'de','QB Credit Memo-Detail-Datei Spalte Format',0),(265392,7372,'en','QB Credit Memo Detail File column Format',0),(265393,7373,'is','',0),(265394,7373,'dr','-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265395,7373,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265396,7373,'tr','QB iade faturasÄ± dosyasÄ± sÃ¼tun biÃ§imi',0),(265397,7373,'pl','QB Credit Memo formatu kolumna',0),(265398,7373,'bg','QB ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265399,7373,'ur','Ù‚Ø¨ Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„',0),(265400,7373,'sr','ÐšÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐ°',0),(265401,7373,'vi','Báº£ng Ghi Nhá»› TÃ­n Dá»¥ng QB theo dáº¡ng cá»™t',0),(265402,7373,'af','QB Kredietmemo LÃªer Kolom Formaat',0),(265403,7373,'ro','QB Credit Memo coloanei formatul de fiÅŸier',0),(265404,7373,'et','QB krediidi Memo faili veeruvormingut',0),(265405,7373,'si','QB kreditne stolpec Memo zapisa',0),(265406,7373,'ba','Format kolom File Memo kredit QB',0),(265407,7373,'nl','QB Credit Memo-kolom bestandsindeling',0),(265408,7373,'fi','QB luotto Memo tiedoston sarakkeen muoto',0),(265409,7373,'no','QB kreditt Memo-kolonne filformat',0),(265410,7373,'da','QB kredit Memo-kolonne filformat',0),(265411,7373,'ko','ì¿¼í„° ë°± ì‹ ìš© ë©”ëª¨ íŒŒì¼ ì—´ í˜•ì‹',0),(265412,7373,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×©×œ ×§×•×‘×¥ ×ª×–×›×™×¨ QB ××©×¨××™',0),(265413,7373,'el','QB Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î¼Î¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½',0),(265414,7373,'zh','QuickBookç³»åˆ—ä¿¡ç”¨å¤‡æ³¨æ–‡ä»¶åˆ—çš„æ ¼å¼\r\n',0),(265415,7373,'sv','QB kredit Memo-kolumn filformatet',0),(265416,7373,'it','QB Credit Memo File formato colonne',0),(265417,7373,'tl','',0),(265418,7373,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3649;&#3617;&#3617;&#3650;&#3629;&#3626; QB',0),(265419,7373,'hi','QB à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(265420,7373,'ms','Format kolum fail Memo QB kredit',0),(265421,7373,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ Ù…Ù„Ù Ø§Ù„Ù…Ø°ÙƒØ±Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† QB',0),(265422,7373,'fr','Format de colonne fichier QB crÃ©dit Memo',0),(265423,7373,'jp','QB ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ãƒ¡ãƒ¢ ãƒ•ã‚¡ã‚¤ãƒ«åˆ—å½¢å¼',0),(265424,7373,'pt','QB crÃ©dito Memo arquivo formato de coluna',0),(265425,7373,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° QB ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ñ‹',0),(265426,7373,'es','QB Memo de CrÃ©dito Formato de File Columna',0),(265427,7373,'de','QB Credit Memo Spalte Dateiformat',0),(265428,7373,'en','QB Credit Memo File Column Format',0),(265429,7374,'is','',0),(265430,7374,'dr','Ø¨Ø¹Ø¯ÙŠ Ù…Ø´ÙƒÙ„Ø§ØªÙŠ Ø±Ø§ Ø¯Ø± Ø³ÙŠØ³ØªÙ… ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª ',0),(265431,7374,'pr','Ø¨Ø¹Ø¯ÙŠ Ù…Ø´ÙƒÙ„Ø§ØªÙŠ Ø±Ø§ Ø¯Ø± Ø³ÙŠØ³ØªÙ… ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª ',0),(265432,7374,'tr','Birini alma sorunlarÄ± vardÄ±',0),(265433,7374,'pl','NastÄ™pujÄ…ce miaÅ‚ problemy z importu w systemie',0),(265434,7374,'bg','ÐŸÐ¾-Ð´Ð¾Ð»Ñƒ Ðµ Ð²Ð½Ð¾Ñ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð¸ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð½Ð°',0),(265435,7374,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø³Ø§Ø¦Ù„ Ø§Ø³ Ù†Ø¸Ø§Ù… Ù…ÛŒÚº ØªÚ¾Û’',0),(265436,7374,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸Ñ… Ð¸Ð¼Ð°Ð¾ ÑƒÐ²Ð¾Ð· Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ðµ Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ',0),(265437,7374,'vi','Pháº§n nÃ y táº¡o ráº¯c rá»‘i cho há»‡ thá»‘ng',0),(265438,7374,'af','Die volgende het invoerprobleme in die sisteem',0),(265439,7374,'ro','UrmÄƒtoarele a avut probleme de import Ã®n sistemul de',0),(265440,7374,'et','JÃ¤rgmine oli impordi probleemide sÃ¼steemis',0),(265441,7374,'si','Naslednje je uvoz teÅ¾ave v sistemu',0),(265442,7374,'ba','Berikut memiliki masalah impor dalam sistem',0),(265443,7374,'nl','De volgende gehad invoer problemen in het systeem',0),(265444,7374,'fi','Seuraavasti oli Tuontiongelmia jÃ¤rjestelmÃ¤n',0),(265445,7374,'no','FÃ¸lgende hadde Importproblemer i systemet',0),(265446,7374,'da','FÃ¸lgende havde problemer med import i systemet',0),(265447,7374,'ko','ë‹¤ìŒ ë¬¸ì œê°€ ê°€ì ¸ì˜¤ê¸° ì‹œìŠ¤í…œ',0),(265448,7374,'he','×”×‘××™× ×”×™×• ×‘×¢×™×•×ª ×™×™×‘×•× ×‘×ž×¢×¨×›×ª',0),(265449,7374,'el','Î•Î¯Ï‡Îµ Ï„Î± Î±ÎºÏŒÎ»Î¿Ï…Î¸Î± Ï€ÏÎ¿Î²Î»Î®Î¼Î±Ï„Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(265450,7374,'zh','ä»¥ä¸‹é¡¹ç›®å·²åœ¨ç³»ç»Ÿä¸­å¯¼å…¥é—®é¢˜\r\n',0),(265451,7374,'sv','FÃ¶ljande hade import problem i systemet',0),(265452,7374,'it','Di seguito ha avuto problemi di importazione nel sistema',0),(265453,7374,'tl','',0),(265454,7374,'th','&#3605;&#3656;&#3629;&#3652;&#3611;&#3609;&#3637;&#3657;&#3617;&#3637;&#3611;&#3633;&#3597;&#3627;&#3634;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3651;&#3609;&#3619;&#3632;&#3610;&#3610;',0),(265455,7374,'hi','à¤¨à¤¿à¤®à¥à¤¨ à¤¸à¤®à¤¸à¥à¤¯à¤¾à¤“à¤‚ à¤•à¥‡ à¤†à¤¯à¤¾à¤¤ à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤®à¥‡à¤‚ à¤¥à¤¾',0),(265456,7374,'ms','Perkara-perkara berikut mempunyai masalah import dalam sistem',0),(265457,7374,'ar','Ø§Ù„ØªØ§Ù„ÙŠ Ù‚Ø¯ Ù…Ø´Ø§ÙƒÙ„ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(265458,7374,'fr','Ce qui suit eu des problÃ¨mes pour importer dans le systÃ¨me',0),(265459,7374,'jp','æ¬¡ã®ã‚·ã‚¹ãƒ†ãƒ ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®å•é¡Œã‚’æŒã£ã¦ã„ãŸ',0),(265460,7374,'pt','A seguir teve problemas de importaÃ§Ã£o no sistema',0),(265461,7374,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð±Ñ‹Ð»Ð¸ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ñ‹ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ðµ',0),(265462,7374,'es','Los siguentes tenÃ­an problemas de importaciÃ³n en el sistema',0),(265463,7374,'de','Folgendes hatte Import Probleme im system',0),(265464,7374,'en','The following had import problems in the system',0),(265465,7375,'is','',0),(265466,7375,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡\r\n QB \r\n',0),(265467,7375,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡\r\n QB \r\n',0),(265468,7375,'tr','Alma QB iade faturasÄ±',0),(265469,7375,'pl','PrzywÃ³z QB faktura korygujÄ…ca',0),(265470,7375,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ QB ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(265471,7375,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ù‚Ø¨ Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ',0),(265472,7375,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(265473,7375,'vi','Nháº­p Báº£ng TÃ­n Dá»¥ng QB',0),(265474,7375,'af','Invoer van QB Krediet Memo',0),(265475,7375,'ro','NotÄƒ de Credit de QB import',0),(265476,7375,'et','Impordi QB kreeditarve',0),(265477,7375,'si','Uvoz QB dobropis',0),(265478,7375,'ba','Memo kredit QB impor',0),(265479,7375,'nl','Import QB creditnota',0),(265480,7375,'fi','Tuo QB hyvityslasku',0),(265481,7375,'no','Importer QB kreditnota',0),(265482,7375,'da','Import QB kreditnota',0),(265483,7375,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ì‹ ìš© ë©”ëª¨',0),(265484,7375,'he','×™×™×‘×•× QB ×”×–×™×›×•×™',0),(265485,7375,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® QB Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(265486,7375,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—ä¿¡ç”¨å¤‡å¿˜å½•\r\n',0),(265487,7375,'sv','Importera QB kreditnota',0),(265488,7375,'it','Nota di credito QB di importazione',0),(265489,7375,'tl','',0),(265490,7375,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3649;&#3617;&#3617;&#3650;&#3617; QB',0),(265491,7375,'hi','à¤†à¤¯à¤¾à¤¤ QB à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹',0),(265492,7375,'ms','Memo QB kredit import',0),(265493,7375,'ar','Ø§Ù„Ù…Ø°ÙƒØ±Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† QB Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(265494,7375,'fr','Note de crÃ©dit de QB d\'importation',0),(265495,7375,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ QB ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆãƒ¡ãƒ¢',0),(265496,7375,'pt','Nota de crÃ©dito de QB de importaÃ§Ã£o',0),(265497,7375,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ QB ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ð°',0),(265498,7375,'es','Importar QB Memo de CrÃ©dito',0),(265499,7375,'de','Import QB-Gutschrift',0),(265500,7375,'en','Import QB Credit Memo',0),(265501,7376,'is','',0),(265502,7376,'dr','QB ',0),(265503,7376,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡ QB ',0),(265504,7376,'tr','QB iade faturasÄ± Ã¶demeleri alma',0),(265505,7376,'pl','PrzywÃ³z QB Credit Memo pÅ‚atnoÅ›ci',0),(265506,7376,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QB ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(265507,7376,'ur','Ù‚Ø¨ Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(265508,7376,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐ° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(265509,7376,'vi','Nháº­p Báº£ng Ghi Nhá»› Thanh ToÃ¡n TÃ­n Dá»¥ng QB',0),(265510,7376,'af','Invoer van QB Krediet Memo Betalings',0),(265511,7376,'ro','QB Credit Memo plÄƒÅ£ile de import',0),(265512,7376,'et','Importige QB kreeditkandeid Memo',0),(265513,7376,'si','Uvoz Memo QB kreditnih plaÄil',0),(265514,7376,'ba','Pembayaran Memo kredit QB impor',0),(265515,7376,'nl','Importeren van QB Credit Memo betalingen',0),(265516,7376,'fi','QB luotto Memo-maksujen tuominen',0),(265517,7376,'no','Importere QB kreditt Memo betalinger',0),(265518,7376,'da','Importere QB kredit Memo betalinger',0),(265519,7376,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ì‹ ìš© ë©”ëª¨ ì§€ë¶ˆ',0),(265520,7376,'he','×™×‘× QB ××©×¨××™ ×ª×–×›×™×¨ ×ª×©×œ×•×ž×™×',0),(265521,7376,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® QB Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(265522,7376,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—ä¿¡ç”¨å¡ä»˜æ¬¾å¤‡å¿˜å½•\r\n',0),(265523,7376,'sv','Importera QB kredit Memo betalningar',0),(265524,7376,'it','Importazione QB Credit Memo pagamenti',0),(265525,7376,'tl','',0),(265526,7376,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3649;&#3617;&#3617;&#3650;&#3617; QB',0),(265527,7376,'hi','QB à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚ à¤•à¥‹ à¤†à¤¯à¤¾à¤¤',0),(265528,7376,'ms','Import kredit QB Memo bayaran',0),(265529,7376,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø°ÙƒØ±Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† QB',0),(265530,7376,'fr','Importer des paiements de crÃ©dit QB Memo',0),(265531,7376,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ QB ãƒ¡ãƒ¢ã®ãŠæ”¯æ‰•ã„',0),(265532,7376,'pt','Pagamentos de memorando de crÃ©dito QB importaÃ§Ã£o',0),(265533,7376,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ QB ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ñ‹',0),(265534,7376,'es','Importar QB Pagos de Memo de CrÃ©dito',0),(265535,7376,'de','QB Credit Memo Zahlungen importieren',0),(265536,7376,'en','Import QB Credit Memo Payments',0),(265537,7377,'is','',0),(265538,7377,'dr','-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265539,7377,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ù„ÙŠÙ†Ùƒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265540,7377,'tr','QB iade faturasÄ± Ã¶deme baÄŸlantÄ± dosyasÄ± sÃ¼tun biÃ§imi',0),(265541,7377,'pl','QB Credit Memo pÅ‚atnoÅ›ci Link formatu kolumna',0),(265542,7377,'bg','QB ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð²Ñ€ÑŠÐ·ÐºÐ° Ñ„Ð°Ð¹Ð» ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265543,7377,'ur','Ù‚Ø¨ Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù„Ù†Ú© Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„',0),(265544,7377,'sr','ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐ° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð²ÐµÐ·Ð° ÐºÐ¾Ð»Ð¾Ð½Ð° Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(265545,7377,'vi','Nháº­t KÃ½ Thanh ToÃ¡n QB Há»“ SÆ¡ ÄÆ°á»ng Dáº«n Dáº¡ng Cá»™t',0),(265546,7377,'af','QB Kredietmemo Betalings Skakel met Kolom Formaat',0),(265547,7377,'ro','QB Credit Memo plata link-ul de fiÅŸier Format coloane',0),(265548,7377,'et','QB krediidi kreeditarve makse Link faili veeruvormingut',0),(265549,7377,'si','QB kreditne beleÅ¾ko plaÄila Link stolpec zapisa',0),(265550,7377,'ba','QB kredit Memo pembayaran Link Format File kolom',0),(265551,7377,'nl','QB Credit Memo betaling Link bestand kolomindeling',0),(265552,7377,'fi','QB luottoa Muistio linkki sarakkeen tiedostomuoto',0),(265553,7377,'no','QB kreditt Memo Link kolonnen betalingsfilformatet',0),(265554,7377,'da','QB kredit Memo betaling Link-kolonne filformat',0),(265555,7377,'ko','ì¿¼í„° ë°± ì‹ ìš© ë©”ëª¨ ì§€ë¶ˆ ë§í¬ íŒŒì¼ ì—´ í˜•ì‹',0),(265556,7377,'he','QB ××©×¨××™ ×ª×–×›×™×¨ ×”×ª×©×œ×•× ×§×™×©×•×¨ ×‘×ª×‘× ×™×ª ×§×•×‘×¥ ×¢×ž×•×“×”',0),(265557,7377,'el','QB Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ ÏƒÏ„Î®Î»Î· Î¼Î¿ÏÏ†Î® ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(265558,7377,'zh','QuickBookç³»åˆ—ä¿¡ç”¨å¤‡æ³¨ä»˜æ¬¾é“¾æŽ¥æ–‡ä»¶åˆ—çš„æ ¼å¼\r\n',0),(265559,7377,'sv','QB kredit Memo betalning lÃ¤nk-kolumn filformatet',0),(265560,7377,'it','QB Credit Memo pagamento Link File formato colonne',0),(265561,7377,'tl','',0),(265562,7377,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3621;&#3636;&#3591;&#3588;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3588;&#3619;&#3',0),(265563,7377,'hi','QB à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤²à¤¿à¤‚à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(265564,7377,'ms','Format lajur QB kredit Memo bayaran pautan fail',0),(265565,7377,'ar','Ø§Ù„Ù…Ø°ÙƒØ±Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† QB Ø§Ù„Ø¯ÙØ¹ Ø§Ø±ØªØ¨Ø§Ø· Ù…Ù„Ù ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯',0),(265566,7377,'fr','Format de colonne de fichier QB crÃ©dit mÃ©mo paiement lien',0),(265567,7377,'jp','QB ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ãƒ¡ãƒ¢æ”¯æ‰•ãƒªãƒ³ã‚¯ ãƒ•ã‚¡ã‚¤ãƒ«åˆ—å½¢å¼',0),(265568,7377,'pt','QB crÃ©dito Memo pagamento Link arquivo formato de coluna',0),(265569,7377,'ru','QB ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÑÑ‹Ð»ÐºÑƒ Ñ„Ð°Ð¹Ð»Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð¾Ð²',0),(265570,7377,'es','QB Enlace de Pago de Memo de CrÃ©dito Formato de File Columna',0),(265571,7377,'de','Spalte-Dateiformat fÃ¼r QB Credit Memo Zahlung Link',0),(265572,7377,'en','QB Credit Memo Payment Link File Column Format',0),(265573,7378,'is','',0),(265574,7378,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†\r\n QB ',0),(265575,7378,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†\r\n QB ',0),(265576,7378,'tr','QB mÃ¼ÅŸteriler alma',0),(265577,7378,'pl','Klienci importu QB',0),(265578,7378,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QB ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(265579,7378,'ur','Ù‚Ø¨ ØµØ§Ø±ÙÛŒÙ† Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(265580,7378,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº ÐºÑƒÐ¿Ñ†Ðµ',0),(265581,7378,'vi','Nháº­p khÃ¡ch hÃ ng QB',0),(265582,7378,'af','Invoer van QB KliÃ«nte/Klante',0),(265583,7378,'ro','Import QB clienÅ£ii',0),(265584,7378,'et','Impordi QB kÃ¼lastajad',0),(265585,7378,'si','Uvoz QB stranke',0),(265586,7378,'ba','Impor QB pelanggan',0),(265587,7378,'nl','Importeren van QB klanten',0),(265588,7378,'fi','Tuo QB asiakkaat',0),(265589,7378,'no','Importere QB kunder',0),(265590,7378,'da','Importere QB kunder',0),(265591,7378,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ê³ ê°',0),(265592,7378,'he','×™×™×‘×•× QB ×”×œ×§×•×—×•×ª',0),(265593,7378,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® QB Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(265594,7378,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—å®¢æˆ·\r\n',0),(265595,7378,'sv','Importera QB kunder',0),(265596,7378,'it','Clienti importazione QB',0),(265597,7378,'tl','',0),(265598,7378,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634; QB &#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(265599,7378,'hi','QB à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤†à¤¯à¤¾à¤¤',0),(265600,7378,'ms','Pelanggan import QB',0),(265601,7378,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ QB',0),(265602,7378,'fr','Importation QB clients',0),(265603,7378,'jp','QB é¡§å®¢ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(265604,7378,'pt','Clientes de importaÃ§Ã£o QB',0),(265605,7378,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ QB ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(265606,7378,'es','Importar QB Clientes',0),(265607,7378,'de','Import QB-Kunden',0),(265608,7378,'en','Import QB Customers',0),(265609,7379,'is','',0),(265610,7379,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù†\r\n QB ',0),(265611,7379,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù†\r\n QB ',0),(265612,7379,'tr','Alma QB Ã§alÄ±ÅŸanlar',0),(265613,7379,'pl','PrzywÃ³z QB pracownikÃ³w',0),(265614,7379,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QB ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(265615,7379,'ur','Ù‚Ø¨ Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(265616,7379,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(265617,7379,'vi','Nháº­p nhÃ¢n viÃªn QB',0),(265618,7379,'af','QB Werknemers Invoer',0),(265619,7379,'ro','Import QB angajaÅ£i',0),(265620,7379,'et','Impordi QB tÃ¶Ã¶tajate',0),(265621,7379,'si','Uvoz QB zaposlenih',0),(265622,7379,'ba','Impor QB karyawan',0),(265623,7379,'nl','QB werknemers importeert',0),(265624,7379,'fi','Tuo QB tyÃ¶ntekijÃ¤t',0),(265625,7379,'no','Importere QB ansatte',0),(265626,7379,'da','Importere QB medarbejdere',0),(265627,7379,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ì§ì›',0),(265628,7379,'he','×œ×™×™×‘× ×¢×•×‘×“×™× QB',0),(265629,7379,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® QB ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(265630,7379,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—é›‡å‘˜\r\n',0),(265631,7379,'sv','Importera QB anstÃ¤llda',0),(265632,7379,'it','Importazione QB dipendenti',0),(265633,7379,'tl','',0),(265634,7379,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634; QB &#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(265635,7379,'hi','QB à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤†à¤¯à¤¾à¤¤',0),(265636,7379,'ms','Pekerja-pekerja import QB',0),(265637,7379,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ† QB',0),(265638,7379,'fr','Importation QB employÃ©s',0),(265639,7379,'jp','QB å¾“æ¥­å“¡ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(265640,7379,'pt','Empregados de importaÃ§Ã£o QB',0),(265641,7379,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² QB',0),(265642,7379,'es','Importar QB Empleados',0),(265643,7379,'de','Import QB-Mitarbeiter',0),(265644,7379,'en','Import QB Employees',0),(265645,7380,'is','',0),(265646,7380,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯\r\n QB ',0),(265647,7380,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯\r\n QB ',0),(265648,7380,'tr','QB Ã§alÄ±ÅŸanÄ±n Ã¶deme alma',0),(265649,7380,'pl','Importowanie QB pracownika wynagrodzenia',0),(265650,7380,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QB ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(265651,7380,'ur','Ù‚Ø¨ Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(265652,7380,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¿Ð»Ð°Ñ‚Ð°',0),(265653,7380,'vi','Nháº­p lÆ°Æ¡ng nhÃ¢n viÃªn QB',0),(265654,7380,'af','Invoer van QB Werknemer Loon',0),(265655,7380,'ro','QB angajatului plata de import',0),(265656,7380,'et','Importige QB tÃ¶Ã¶taja tÃ¶Ã¶tasu',0),(265657,7380,'si','Uvoz QB zaposleni plaÄati',0),(265658,7380,'ba','Impor gaji karyawan QB',0),(265659,7380,'nl','Importeren van QB werknemer Pay',0),(265660,7380,'fi','Tuo QB tyÃ¶ntekijÃ¶iden palkkojen',0),(265661,7380,'no','Importere QB ansattes lÃ¸nn',0),(265662,7380,'da','Importere QB medarbejder lÃ¸n',0),(265663,7380,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ì§ì› ê¸‰ì—¬',0),(265664,7380,'he','×™×™×‘×•× QB ×”×¢×•×‘×“ ×œ×©×œ×',0),(265665,7380,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® QB Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î±Î¼Î¿Î¹Î²ÏŽÎ½',0),(265666,7380,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—å‘˜å·¥å·¥èµ„\r\n',0),(265667,7380,'sv','Importera QB medarbetare lÃ¶n',0),(265668,7380,'it','Importare QB dipendente paga',0),(265669,7380,'tl','',0),(265670,7380,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634; QB &#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(265671,7380,'hi','QB à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(265672,7380,'ms','Import gaji pekerja QB',0),(265673,7380,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø±Ø§ØªØ¨ Ø§Ù„Ù…ÙˆØ¸Ù QB',0),(265674,7380,'fr','Importer la paie de l\'employÃ© de QB',0),(265675,7380,'jp','QB å¾“æ¥­å“¡çµ¦æ–™ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(265676,7380,'pt','QB empregado pagamento de importaÃ§Ã£o',0),(265677,7380,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¾ÐºÐ»Ð°Ð´ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² QB',0),(265678,7380,'es','Importar QB Pagos a Empleados',0),(265679,7380,'de','QB-Mitarbeiter zahlen zu importieren',0),(265680,7380,'en','Import QB Employee Pay',0),(265681,7381,'is','',0),(265682,7381,'dr','- Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265683,7381,'pr','  Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ÙƒØ§Ø±Ù…Ù†Ø¯- Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265684,7381,'tr','QB Ã§alÄ±ÅŸan dosya sÃ¼tun biÃ§imi',0),(265685,7381,'pl','Pracownik QB kolumna Format pliku',0),(265686,7381,'bg','QB ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265687,7381,'ur','Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„ Ù‚Ø¨ Ù…Ù„Ø§Ø²Ù…',0),(265688,7381,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(265689,7381,'vi','Há»“ sÆ¡ nhÃ¢n viÃªn QB dáº¡ng cá»™t',0),(265690,7381,'af','QB Werknemer LÃªer Kolom Formaat',0),(265691,7381,'ro','QB angajat dosar Format coloane',0),(265692,7381,'et','QB tÃ¶Ã¶taja faili veeruvormingut',0),(265693,7381,'si','Zapisa stolpec QB zaposlenega',0),(265694,7381,'ba','Format kolom File QB karyawan',0),(265695,7381,'nl','QB werknemer kolom bestandsindeling',0),(265696,7381,'fi','QB tyÃ¶ntekijÃ¤n sarakkeen tiedostomuoto',0),(265697,7381,'no','QB ansatte-kolonnen filformat',0),(265698,7381,'da','QB medarbejder-kolonne filformat',0),(265699,7381,'ko','ì¿¼í„° ë°± ì§ì› íŒŒì¼ ì—´ í˜•ì‹',0),(265700,7381,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×”×§×•×‘×¥ ×”×¢×•×‘×“ QB',0),(265701,7381,'el','ÎœÎ¿ÏÏ†Î® ÏƒÏ„Î®Î»Î·Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿Ï… ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ QB',0),(265702,7381,'zh','QuickBookç³»åˆ—å‘˜å·¥æ–‡ä»¶åˆ—çš„æ ¼å¼\r\n',0),(265703,7381,'sv','QB anstÃ¤lld kolumn filformatet',0),(265704,7381,'it','QB dipendente formato colonna',0),(265705,7381,'tl','',0),(265706,7381,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609; QB ',0),(265707,7381,'hi','QB à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(265708,7381,'ms','Format kolum fail pekerja QB',0),(265709,7381,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ ÙÙŠ Ù…Ù„Ù Ø§Ù„Ù…ÙˆØ¸Ù QB',0),(265710,7381,'fr','Format de colonne pour le fichier employÃ© QB',0),(265711,7381,'jp','QB å¾“æ¥­å“¡ãƒ•ã‚¡ã‚¤ãƒ«åˆ—å½¢å¼',0),(265712,7381,'pt','QB empregado arquivo formato de coluna',0),(265713,7381,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° QB Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(265714,7381,'es','QB Empleado Formato de File Columna',0),(265715,7381,'de','QB-Mitarbeiter-Spalte Dateiformat',0),(265716,7381,'en','QB Employee File Column Format',0),(265717,7382,'is','',0),(265718,7382,'dr','-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265719,7382,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ù…Ù†Ø¯-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265720,7382,'tr','QB Ã§alÄ±ÅŸanÄ±n Ã¶deme dosyasÄ± sÃ¼tun biÃ§imi',0),(265721,7382,'pl','QB pracownik pÅ‚aci kolumna Format pliku',0),(265722,7382,'bg','QB ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265723,7382,'ur','Ù‚Ø¨ Ù…Ù„Ø§Ø²Ù… Ø§Ø¯Ø§ Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„',0),(265724,7382,'sr','Ð‘ÐµÐº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(265725,7382,'vi','Há»“ sÆ¡ tráº£ lÆ°Æ¡ng nhÃ¢n viÃªn QB dáº¡ng cá»™t',0),(265726,7382,'af','QB Werknemer Besoldiging LÃªer Kolom Formaat',0),(265727,7382,'ro','QB angajat plÄƒteascÄƒ dosar Format coloane',0),(265728,7382,'et','QB tÃ¶Ã¶tajale maksta veerus failivorming',0),(265729,7382,'si','QB zaposleni plaÄati stolpec zapisa',0),(265730,7382,'ba','Karyawan QB membayar Format File kolom',0),(265731,7382,'nl','QB werknemer betalen kolom bestandsindeling',0),(265732,7382,'fi','QB tyÃ¶ntekijÃ¤ maksaa sarakkeen tiedostomuoto',0),(265733,7382,'no','QB ansatte betale kolonnen filformat',0),(265734,7382,'da','QB medarbejderen betale kolonne filformat',0),(265735,7382,'ko','ì¿¼í„° ë°± ì§ì› ì§€ë¶ˆ íŒŒì¼ ì—´ í˜•ì‹',0),(265736,7382,'he','QB ×”×¢×•×‘×“ ×œ×©×œ× ×ª×‘× ×™×ª ×¢×ž×•×“×ª ×§×•×‘×¥',0),(265737,7382,'el','QB Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î½Î± Ï€Î»Î·ÏÏŽÏƒÎµÎ¹ ÏƒÏ„Î®Î»Î· Î¼Î¿ÏÏ†Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(265738,7382,'zh','QuickBookç³»åˆ—å‘˜å·¥å·¥èµ„æ–‡ä»¶åˆ—çš„æ ¼å¼\r\n',0),(265739,7382,'sv','QB anstÃ¤lld betalar kolumn filformatet',0),(265740,7382,'it','QB dipendente paga formato colonna',0),(265741,7382,'tl','',0),(265742,7382,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609; QB ',0),(265743,7382,'hi','QB à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(265744,7382,'ms','QB pekerja membayar Format kolum fail',0),(265745,7382,'ar','Ø¯ÙØ¹ Ø§Ù„Ù…ÙˆØ¸Ù QB ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ ÙÙŠ Ù…Ù„Ù',0),(265746,7382,'fr','Paie de l\'employÃ© de QB Format colonne de fichier',0),(265747,7382,'jp','QB ã®å¾“æ¥­å“¡ã‚’æ”¯æ‰•ã†ãƒ•ã‚¡ã‚¤ãƒ«åˆ—å½¢å¼',0),(265748,7382,'pt','QB empregado pagar formato de coluna do arquivo',0),(265749,7382,'ru','QB Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ° ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ðµ Ñ„Ð°Ð¹Ð»Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð¾Ð²',0),(265750,7382,'es','QB Pago de Empleado Formato de File Columna',0),(265751,7382,'de','QB-Mitarbeiter bezahlen Spalte Dateiformat',0),(265752,7382,'en','QB Employee Pay File Column Format',0),(265753,7383,'is','',0),(265754,7383,'dr','QB ',0),(265755,7383,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ QB ',0),(265756,7383,'tr','Ä°thalat QB faturalarÄ±nÄ±',0),(265757,7383,'pl','Faktury przywozowe QB',0),(265758,7383,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð²Ð½Ð¾Ñ QB',0),(265759,7383,'ur','Ù‚Ø¨ ÙˆØ¨Ø¬Ù„ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(265760,7383,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(265761,7383,'vi','Nháº­p hÃ³a Ä‘Æ¡n QB',0),(265762,7383,'af','Invoer van QB Fakture',0),(265763,7383,'ro','Facturi de import QB',0),(265764,7383,'et','Impordi QB arveid',0),(265765,7383,'si','QB uvoznih faktur',0),(265766,7383,'ba','Impor QB faktur',0),(265767,7383,'nl','QB facturen importeren',0),(265768,7383,'fi','Tuonnin QB laskuja',0),(265769,7383,'no','Importere QB fakturaer',0),(265770,7383,'da','Importere QB fakturaer',0),(265771,7383,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ì†¡ìž¥',0),(265772,7383,'he','×™×™×‘×•× QB ×—×©×‘×•× ×™×•×ª',0),(265773,7383,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³ÏŽÎ½ QB',0),(265774,7383,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—å‘ç¥¨\r\n',0),(265775,7383,'sv','Importera QB fakturor',0),(265776,7383,'it','Fatture di importazione QB',0),(265777,7383,'tl','',0),(265778,7383,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634; QB &#3651;&#3610;&#3594;&#3635;&#3619;&#3632;&#3627;&#3609;&#3637;&#3657;',0),(265779,7383,'hi','à¤†à¤¯à¤¾à¤¤ QB à¤šà¤¾à¤²à¤¾à¤¨',0),(265780,7383,'ms','Import QB invois',0),(265781,7383,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ± QB',0),(265782,7383,'fr','Factures d\'importation QB',0),(265783,7383,'jp','QB ã®è«‹æ±‚æ›¸ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(265784,7383,'pt','Faturas de importaÃ§Ã£o QB',0),(265785,7383,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ QB ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(265786,7383,'es','Importar QB Facturas',0),(265787,7383,'de','QB Rechnungen importieren',0),(265788,7383,'en','Import QB Invoices',0),(265789,7384,'is','',0),(265790,7384,'dr','QB ',0),(265791,7384,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ§ÙƒØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§QB ',0),(265792,7384,'tr','QB fatura Ã¶demeleri alma',0),(265793,7384,'pl','Importuj pÅ‚atnoÅ›ci faktury QB',0),(265794,7384,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QB Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(265795,7384,'ur','Ù‚Ø¨ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(265796,7384,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº ÐºÑšÐ¸Ð³Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð°',0),(265797,7384,'vi','Nháº­p thanh toÃ¡n cho hÃ³a Ä‘Æ¡n QB',0),(265798,7384,'af','Invoer van QB Fakture Betalings',0),(265799,7384,'ro','Plata facturilor de QB de import',0),(265800,7384,'et','Impordi QB ettemaksuarve maksed',0),(265801,7384,'si','Uvozite plaÄila raÄuna QB',0),(265802,7384,'ba','Impor QB faktur pembayaran',0),(265803,7384,'nl','Importeren van QB factuur betalingen',0),(265804,7384,'fi','Tuo QB laskun maksut',0),(265805,7384,'no','Importere QB faktura-betalinger',0),(265806,7384,'da','Importere QB fakturabetalinger',0),(265807,7384,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ì†¡ìž¥ ì§€ë¶ˆ',0),(265808,7384,'he','×™×‘× ×—×©×‘×•× ×™×ª QB ×ª×©×œ×•×ž×™×',0),(265809,7384,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® QB Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(265810,7384,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—å‘ç¥¨ä»˜æ¬¾\r\n',0),(265811,7384,'sv','Importera QB faktura betalningar',0),(265812,7384,'it','Importare i pagamenti fattura QB',0),(265813,7384,'tl','',0),(265814,7384,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634; QB &#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3651;&#3610;&#3594;&#3635;&#3619;&#3632;&#3627;&#3609;&#3637;&#3657;',0),(265815,7384,'hi','QB à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(265816,7384,'ms','Pembayaran invois QB import',0),(265817,7384,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„ÙÙˆØ§ØªÙŠØ± QB',0),(265818,7384,'fr','Importer des paiements de facture QB',0),(265819,7384,'jp','QB ã®è«‹æ±‚æ›¸ã®æ”¯æ‰•ã„ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(265820,7384,'pt','Pagamentos de fatura de QB de importaÃ§Ã£o',0),(265821,7384,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ ÑÑ‡ÐµÑ‚Ð° QB',0),(265822,7384,'es','Importar QB pagos de Facturas',0),(265823,7384,'de','QB Rechnung Zahlungen importieren',0),(265824,7384,'en','Import QB Invoice Payments',0),(265825,7385,'is','',0),(265826,7385,'dr','-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265827,7385,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ù„ÙŠÙ†Ùƒ  ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265828,7385,'tr','QB fatura Ã¶deme baÄŸlantÄ± dosyasÄ± sÃ¼tun biÃ§imi',0),(265829,7385,'pl','QB pÅ‚atnoÅ›ci faktur Link pliku formatu kolumny',0),(265830,7385,'bg','QB Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð²Ñ€ÑŠÐ·ÐºÐ° Ñ„Ð°Ð¹Ð» ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265831,7385,'ur','Ù‚Ø¨ ÙˆØ¨Ø¬Ù„ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù„Ù†Ú© Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„',0),(265832,7385,'sr','Ð‘ÐµÐº Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð²ÐµÐ·Ð° ÐºÐ¾Ð»Ð¾Ð½Ð° Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(265833,7385,'vi','HÃ³a ÄÆ¡n Thanh ToÃ¡n QB Há»“ SÆ¡ ÄÆ°á»ng Dáº«n Dáº¡ng Cá»™t',0),(265834,7385,'af','QB Fakture Betaling Skakel met LÃªer Kolom Formaat',0),(265835,7385,'ro','QB facturi platÄƒ link-ul de fiÅŸier Format coloane',0),(265836,7385,'et','QB arvete makse Link faili veeruvormingut',0),(265837,7385,'si','QB raÄunov plaÄilo povezavo stolpec zapisa',0),(265838,7385,'ba','QB faktur pembayaran Link Format File kolom',0),(265839,7385,'nl','QB facturen betaling Link bestand kolomindeling',0),(265840,7385,'fi','QB laskujen linkki sarakkeen tiedostomuoto',0),(265841,7385,'no','QB fakturaer Link kolonnen betalingsfilformatet',0),(265842,7385,'da','QB fakturaer betaling Link-kolonne filformat',0),(265843,7385,'ko','ì¿¼í„° ë°± ì†¡ìž¥ ì§€ë¶ˆ ë§í¬ íŒŒì¼ ì—´ í˜•ì‹',0),(265844,7385,'he','QB ×—×©×‘×•× ×™×•×ª ×”×ª×©×œ×•× ×§×™×©×•×¨ ×‘×ª×‘× ×™×ª ×§×•×‘×¥ ×¢×ž×•×“×”',0),(265845,7385,'el','QB Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ ÏƒÏ„Î®Î»Î· Î¼Î¿ÏÏ†Î® ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(265846,7385,'zh','QuickBookç³»åˆ—å‘ç¥¨çš„ä»˜æ¬¾é“¾æŽ¥æ–‡ä»¶åˆ—çš„æ ¼å¼\r\n',0),(265847,7385,'sv','QB fakturor betalning lÃ¤nk-kolumn filformatet',0),(265848,7385,'it','QB fatture pagamento Link File formato colonne',0),(265849,7385,'tl','',0),(265850,7385,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3621;&#3636;&#3591;&#3588;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3',0),(265851,7385,'hi','QB à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤²à¤¿à¤‚à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(265852,7385,'ms','Format lajur QB invois pembayaran pautan fail',0),(265853,7385,'ar','QB ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø¯ÙØ¹ Ø§Ø±ØªØ¨Ø§Ø· Ù…Ù„Ù ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯',0),(265854,7385,'fr','Format colonne du fichier de lien paiement QB factures',0),(265855,7385,'jp','QB è«‹æ±‚æ›¸æ”¯æ‰•ãƒªãƒ³ã‚¯ ãƒ•ã‚¡ã‚¤ãƒ«åˆ—å½¢å¼',0),(265856,7385,'pt','QB faturas pagamento Link arquivo formato de coluna',0),(265857,7385,'ru','QB ÑÑ‡ÐµÑ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÑÑ‹Ð»ÐºÑƒ Ñ„Ð°Ð¹Ð»Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð¾Ð²',0),(265858,7385,'es','QB Enlace de Pagos de Facturas Formato de File Columna',0),(265859,7385,'de','Spalte-Dateiformat fÃ¼r QB Rechnungen Zahlung Link',0),(265860,7385,'en','QB Invoices Payment Link File Column Format',0),(265861,7386,'is','',0),(265862,7386,'dr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(265863,7386,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(265864,7386,'tr','AlÄ±nan faturalar',0),(265865,7386,'pl','Faktury importowane',0),(265866,7386,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð²Ð½Ð¾Ñ',0),(265867,7386,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û ÙˆØ¨Ø¬Ù„ÛŒ',0),(265868,7386,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ ÑƒÐ²ÐµÐ·ÐµÐ½',0),(265869,7386,'vi','HÃ³a Ä‘Æ¡n Ä‘Ã£ nháº­p',0),(265870,7386,'af','Fakture Ingevoer',0),(265871,7386,'ro','Facturi importate',0),(265872,7386,'et','Imporditud arved',0),(265873,7386,'si','RaÄuni, uvoÅ¾enih',0),(265874,7386,'ba','Faktur diimpor',0),(265875,7386,'nl','Facturen ingevoerd',0),(265876,7386,'fi','Laskujen tuotu',0),(265877,7386,'no','Fakturaer som er importert',0),(265878,7386,'da','Fakturaer, der importeres',0),(265879,7386,'ko','ì¸ë³´ì´ìŠ¤ ê°€ì ¸ì˜¤ê¸°',0),(265880,7386,'he','×—×©×‘×•× ×™×•×ª ×ž×™×•×‘××™×',0),(265881,7386,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(265882,7386,'zh','å¯¼å…¥çš„å‘ç¥¨\r\n',0),(265883,7386,'sv','Fakturor som importeras',0),(265884,7386,'it','Fatture importate',0),(265885,7386,'tl','',0),(265886,7386,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(265887,7386,'hi','à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(265888,7386,'ms','Invois-invois yang diimport',0),(265889,7386,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(265890,7386,'fr','Factures importÃ©es',0),(265891,7386,'jp','è«‹æ±‚æ›¸ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(265892,7386,'pt','Facturas importadas',0),(265893,7386,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(265894,7386,'es','Facturas Importadas',0),(265895,7386,'de','Rechnungen importiert',0),(265896,7386,'en','Invoices Imported',0),(265897,7387,'is','',0),(265898,7387,'dr','-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265899,7387,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ø¬Ø²Ø¦ÙŠØ§Øª ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ -Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265900,7387,'tr','QB faturalarda ayrÄ±ntÄ± dosyasÄ± sÃ¼tun biÃ§imi',0),(265901,7387,'pl','QB faktury szczegÃ³Å‚y kolumna Format pliku',0),(265902,7387,'bg','QB Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265903,7387,'ur','Ù‚Ø¨ ÙˆØ¨Ø¬Ù„ÛŒ ØªÙØµÛŒÙ„ Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„',0),(265904,7387,'sr','Ð‘ÐµÐº Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´ÐµÑ‚Ð°Ñ™ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(265905,7387,'vi','Há»“ sÆ¡ QB hÃ³a Ä‘Æ¡n chi tiáº¿t dáº¡ng cá»™t',0),(265906,7387,'af','QB Fakture Detail LÃªer Kolom Formaat',0),(265907,7387,'ro','QB facturi detaliu fisierul coloana Format',0),(265908,7387,'et','QB arvete andmed faili veeruvormingut',0),(265909,7387,'si','QB raÄunov podrobnost stolpec obliko zapisa datoteke',0),(265910,7387,'ba','QB faktur Detail kolom Format File',0),(265911,7387,'nl','QB facturen Detail-bestandsindeling kolom',0),(265912,7387,'fi','QB laskut yksityiskohtaisesti sarake tiedostomuoto',0),(265913,7387,'no','QB fakturaer detalj kolonnen filformat',0),(265914,7387,'da','QB fakturaer detaljer filformat kolonne',0),(265915,7387,'ko','ì¿¼í„° ë°± ì†¡ìž¥ ì„¸ë¶€ íŒŒì¼ ì—´ í˜•ì‹',0),(265916,7387,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×©×œ ×§×•×‘×¥ ×¤×™×¨×•×˜ ×—×©×‘×•× ×™×•×ª QB',0),(265917,7387,'el','Î£Ï„Î®Î»Î· Î¼Î¿ÏÏ†Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï… Ï„Î¿Ï… QB Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(265918,7387,'zh','QuickBookç³»åˆ—å‘ç¥¨æ˜Žç»†æ–‡ä»¶æ æ ¼å¼\r\n',0),(265919,7387,'sv','QB fakturor detalj-kolumn filformatet',0),(265920,7387,'it','QB fatture dettaglio File formato colonne',0),(265921,7387,'tl','',0),(265922,7387,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3',0),(265923,7387,'hi','QB à¤šà¤¾à¤²à¤¾à¤¨ à¤µà¤¿à¤µà¤°à¤£ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(265924,7387,'ms','Format fail lajur QB invois terperinci',0),(265925,7387,'ar','QB Ø§Ù„ÙÙˆØ§ØªÙŠØ± ØªÙØ§ØµÙŠÙ„ Ù…Ù„Ù ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯',0),(265926,7387,'fr','QB factures dÃ©tail File Format de colonne',0),(265927,7387,'jp','QB è«‹æ±‚æ›¸è©³ç´°ãƒ•ã‚¡ã‚¤ãƒ«åˆ—å½¢å¼',0),(265928,7387,'pt','QB facturas detalhe arquivo formato de coluna',0),(265929,7387,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° QB ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(265930,7387,'es','QB Detalle de Facturas Formato de File Columna',0),(265931,7387,'de','QB Rechnungen Detail Spalte Dateiformat',0),(265932,7387,'en','QB Invoices Detail File Column Format',0),(265933,7388,'is','',0),(265934,7388,'dr','-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265935,7388,'pr',' Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ±-Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡',0),(265936,7388,'tr','QB fatura dosyasÄ± sÃ¼tun biÃ§imi',0),(265937,7388,'pl','QB faktury plik formatu kolumny',0),(265938,7388,'bg','QB Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(265939,7388,'ur','Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„ Ù‚Ø¨ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(265940,7388,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(265941,7388,'vi','Há»“ sÆ¡ QB hÃ³a Ä‘Æ¡n dáº¡ng cá»™t',0),(265942,7388,'af','QB Fakture LÃªer Kolom Formaat',0),(265943,7388,'ro','QB facturÄƒ dosar Format coloane',0),(265944,7388,'et','QB arve faili veeruvormingut',0),(265945,7388,'si','Stolpec zapisa raÄuna QB',0),(265946,7388,'ba','Format kolom QB faktur File',0),(265947,7388,'nl','QB factuur kolom bestandsindeling',0),(265948,7388,'fi','QB laskun tiedoston sarakkeen muoto',0),(265949,7388,'no','QB fakturaen filen kolonneformat',0),(265950,7388,'da','QB faktura-kolonne filformat',0),(265951,7388,'ko','ì¿¼í„° ë°± ì†¡ìž¥ íŒŒì¼ ì—´ í˜•ì‹',0),(265952,7388,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×§×•×‘×¥ ×—×©×‘×•× ×™×ª QB',0),(265953,7388,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ QB Î±ÏÏ‡ÎµÎ¯Î¿ Î¼Î¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½',0),(265954,7388,'zh','QuickBookç³»åˆ—å‘ç¥¨æ–‡ä»¶åˆ—çš„æ ¼å¼\r\n',0),(265955,7388,'sv','QB faktura-kolumn filformatet',0),(265956,7388,'it','QB fattura formato colonna',0),(265957,7388,'tl','',0),(265958,7388,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3652;&#3615;&#3621;&#3660;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657; QB ',0),(265959,7388,'hi','QB à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(265960,7388,'ms','Format kolum fail invois QB',0),(265961,7388,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ Ù…Ù„Ù QB Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(265962,7388,'fr','Format de colonne pour le fichier facture QB',0),(265963,7388,'jp','QB è«‹æ±‚ãƒ•ã‚¡ã‚¤ãƒ«ã®åˆ—ã®å½¢å¼',0),(265964,7388,'pt','QB factura arquivo formato de coluna',0),(265965,7388,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° QB ÑÑ‡ÐµÑ‚Ð°',0),(265966,7388,'es','QB Factura Formato de File Columna',0),(265967,7388,'de','QB Rechnung Spalte Dateiformat',0),(265968,7388,'en','QB Invoice File Column Format',0),(265969,7389,'is','',0),(265970,7389,'dr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø²ÙŠØ± Ù…Ø´ÙƒÙ„Ø§ØªÙŠ Ø±Ø§ Ø¯Ø± Ø³ÙŠØ³ØªÙ… ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª',0),(265971,7389,'pr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø²ÙŠØ± Ù…Ø´ÙƒÙ„Ø§ØªÙŠ Ø±Ø§ Ø¯Ø± Ø³ÙŠØ³ØªÙ… ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª',0),(265972,7389,'tr','AÅŸaÄŸÄ±daki fatura alma sorunlarÄ± sistem vardÄ±.',0),(265973,7389,'pl','NastÄ™pujÄ…ce faktury miaÅ‚ problemy z importu w systemie',0),(265974,7389,'bg','Ð¡Ð»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ ÑÐ° Ð²Ð½Ð¾Ñ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð¸ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð½Ð°',0),(265975,7389,'ur','Ø¯Ø±Ø¬ Ø°ÛŒÙ„ ÙˆØ¨Ø¬Ù„ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø³Ø§Ø¦Ù„ Ø§Ø³ Ù†Ø¸Ø§Ù… Ù…ÛŒÚº ØªÚ¾Ø§ Û”',0),(265976,7389,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸Ð¼Ð°Ð¾ ÑƒÐ²Ð¾Ð· Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ðµ Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ',0),(265977,7389,'vi','HÃ³a ÄÆ¡n nÃ y táº¡o ráº¯c rá»‘i cho há»‡ thá»‘ng',0),(265978,7389,'af','Die volgende Fakture het invoerprobleme in die sisteem',0),(265979,7389,'ro','UrmÄƒtoarele facturi a avut probleme de import Ã®n sistemul de',0),(265980,7389,'et','JÃ¤rgmistele arvetele oli impordi probleemide sÃ¼steemis',0),(265981,7389,'si','Naslednjih raÄunov imel uvoz teÅ¾ave v sistemu',0),(265982,7389,'ba','Tagihan berikut memiliki masalah impor dalam sistem',0),(265983,7389,'nl','De volgende facturen gehad importeren problemen in het systeem',0),(265984,7389,'fi','Seuraavat laskut oli Tuontiongelmia jÃ¤rjestelmÃ¤n',0),(265985,7389,'no','FÃ¸lgende fakturaene hadde Importproblemer i systemet',0),(265986,7389,'da','PÃ¥ fÃ¸lgende fakturaer havde problemer med import i systemet',0),(265987,7389,'ko','ë‹¤ìŒ ì†¡ìž¥ ì‹œìŠ¤í…œì—ì„œ ê°€ì ¸ì˜¤ê¸° ë¬¸ì œë¥¼ í–ˆë‹¤',0),(265988,7389,'he','×”×—×©×‘×•× ×™×•×ª ×”×‘××•×ª ×”×™×• ×‘×¢×™×•×ª ×™×™×‘×•× ×‘×ž×¢×¨×›×ª',0),(265989,7389,'el','Î¤Î± ÎµÎ¾Î®Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎµÎ¯Ï‡Îµ Ï€ÏÎ¿Î²Î»Î®Î¼Î±Ï„Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(265990,7389,'zh','ä¸‹åˆ—å‘ç¥¨å·²åœ¨ç³»ç»Ÿä¸­å¯¼å…¥é—®é¢˜\r\n',0),(265991,7389,'sv','FÃ¶ljande fakturorna hade import problem i systemet',0),(265992,7389,'it','Le seguenti fatture avevano problemi di importazione nel sistema',0),(265993,7389,'tl','',0),(265994,7389,'th','&#3651;&#3610;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3609;&#3637;&#3657;&#3617;&#3637;&#3611;&#3633;&#3597;&#3627;&#3634;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3651;&#3609;&#3619;&#3632;&#3610;&#3610;',0),(265995,7389,'hi','à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤®à¥‡à¤‚ à¤†à¤¯à¤¾à¤¤ à¤¸à¤®à¤¸à¥à¤¯à¤¾à¤“à¤‚ à¤¥à¤¾',0),(265996,7389,'ms','Invois-invois yang berikut mempunyai masalah import dalam sistem',0),(265997,7389,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªØ§Ù„ÙŠØ© Ù‚Ø¯ Ù…Ø´Ø§ÙƒÙ„ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(265998,7389,'fr','Les factures suivantes eu des problÃ¨mes pour importer dans le systÃ¨me',0),(265999,7389,'jp','æ¬¡ã®è«‹æ±‚æ›¸ã‚·ã‚¹ãƒ†ãƒ ã§ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®å•é¡Œã‚’æŒã£ã¦ã„ãŸ',0),(266000,7389,'pt','As facturas seguintes tinham problemas de importaÃ§Ã£o no sistema',0),(266001,7389,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð±Ñ‹Ð»Ð¸ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ñ‹ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ðµ',0),(266002,7389,'es','Los Facturas siguentes tenÃ­an problemas de importaciÃ³n en el sistema',0),(266003,7389,'de','Die folgenden Rechnungen hatte Import Probleme im system',0),(266004,7389,'en','The following Invoices had import problems in the system',0),(266005,7390,'is','',0),(266006,7390,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ Ø§Ø² ØµØ¯ÙˆØ± \r\n QB Export',0),(266007,7390,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ Ø§Ø² ØµØ¯ÙˆØ± \r\n QB Export',0),(266008,7390,'tr','Ã–ÄŸeleri QB verme etki alanÄ±ndan alma',0),(266009,7390,'pl','Importowanie elementÃ³w z QB eksportu',0),(266010,7390,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ QB Ð¸Ð·Ð½Ð¾Ñ',0),(266011,7390,'ur','Ø§Ø´ÛŒØ§ Ø³Û’ Ù‚Ø¨ Ø¨Ø±Ø¢Ù…Ø¯ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(266012,7390,'sr','Ð£Ð²Ð¾Ð· ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¸Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ð¸Ð·Ð²Ð¾Ð·Ð°',0),(266013,7390,'vi','Nháº­p hÃ ng tá»« bÃ¡o cÃ¡o xuáº¥t QB',0),(266014,7390,'af','Ivoer van Items vanaf QB Uitvoer',0),(266015,7390,'ro','Import elemente de QB Export',0),(266016,7390,'et','Ãœksuste importimine QB ekspordi',0),(266017,7390,'si','Uvozite elemente iz QB izvoz',0),(266018,7390,'ba','Impor item dari QB ekspor',0),(266019,7390,'nl','Items importeren uit QB exporteren',0),(266020,7390,'fi','Tuo kohteet QB vienti',0),(266021,7390,'no','Importer elementer fra QB eksport',0),(266022,7390,'da','Importere emnerne fra QB eksport',0),(266023,7390,'ko','ì¿¼í„° ë°± ìˆ˜ì¶œì—ì„œ ê°€ì ¸ì˜¤ê¸° í•­ëª©',0),(266024,7390,'he','×¤×¨×™×˜×™ ×™×™×‘×•× ×™×™×¦×•× QB',0),(266025,7390,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î±Ï€ÏŒ Ï„Î¿ QB ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚',0),(266026,7390,'zh','ä»ŽQuickBookå‡ºå£å¯¼å…¥é¡¹ç›®\r\n',0),(266027,7390,'sv','Importera objekt frÃ¥n QB Export',0),(266028,7390,'it','Importazione di elementi da esportazione QB',0),(266029,7390,'tl','',0),(266030,7390,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585; QB',0),(266031,7390,'hi','QB à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤†à¤‡à¤Ÿà¤®',0),(266032,7390,'ms','Mengimport barangan dari eksport QB',0),(266033,7390,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ù…Ù† ØªØµØ¯ÙŠØ± QB',0),(266034,7390,'fr','Importer des Ã©lÃ©ments d\'Export de QB',0),(266035,7390,'jp','QB ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã‹ã‚‰ã‚¢ã‚¤ãƒ†ãƒ ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(266036,7390,'pt','Importar itens de exportaÃ§Ã£o QB',0),(266037,7390,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð¸Ð· QB ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(266038,7390,'es','Importar Items de QB Exportar',0),(266039,7390,'de','Importieren von Objekten aus QB-Export',0),(266040,7390,'en','Import Items from QB Export',0),(266041,7391,'is','',0),(266042,7391,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‚Ø³Ù…Øª Ø§ÙˆÙ„ ÙØ§ÙŠÙ„\r\n A',0),(266043,7391,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‚Ø³Ù…Øª Ø§ÙˆÙ„ ÙØ§ÙŠÙ„\r\n A',0),(266044,7391,'tr','Dosya bÃ¶lÃ¼mÃ¼ A seÃ§in',0),(266045,7391,'pl','Wybierz plik czÄ™Å›ci',0),(266046,7391,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð» Ñ‡Ð°ÑÑ‚ Ð',0),(266047,7391,'ur','Ù…Ø³Ù„ Ø­ØµÛ Ø§ÛŒÚ© Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(266048,7391,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð´ÐµÐ¾ Ð',0),(266049,7391,'vi','Chá»n há»“ sÆ¡ Pháº§n A',0),(266050,7391,'af','Selekteer LÃªer Deel A',0),(266051,7391,'ro','SelectaÅ£i fiÅŸierul partea A',0),(266052,7391,'et','Valige faili osa A',0),(266053,7391,'si','Izberite datoteko del A',0),(266054,7391,'ba','Pilih File Bagian A',0),(266055,7391,'nl','Selecteer bestand deel A',0),(266056,7391,'fi','Valitse tiedosto osa A',0),(266057,7391,'no','Velg fil del A',0),(266058,7391,'da','VÃ¦lg fil del A',0),(266059,7391,'ko','íŒŒì¼ ì„ íƒ ë¶€í’ˆ A',0),(266060,7391,'he','×‘×—×¨ ×§×•×‘×¥ ×—×œ×§ ×',0),(266061,7391,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î‘ÏÏ‡ÎµÎ¯Î¿ Î¼Î­ÏÎ¿Ï‚ Î‘',0),(266062,7391,'zh','é€‰æ‹©æ–‡ä»¶çš„Aéƒ¨åˆ†\r\n',0),(266063,7391,'sv','Markera filen del A',0),(266064,7391,'it','Selezionare il File parte A',0),(266065,7391,'tl','',0),(266066,7391,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3615;&#3621;&#3660;&#3626;&#3656;&#3623;&#3609; A',0),(266067,7391,'hi','à¤­à¤¾à¤— A à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(266068,7391,'ms','Pilih fail Bahagian A',0),(266069,7391,'ar','Ø­Ø¯Ø¯ Ù…Ù„Ù Ø¬Ø²Ø¡ A',0),(266070,7391,'fr','SÃ©lectionnez le fichier partie A',0),(266071,7391,'jp','éƒ¨å“ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã—ã¾ã™ A',0),(266072,7391,'pt','Selecione o arquivo parte A',0),(266073,7391,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¤Ð°Ð¹Ð» Ð§Ð°ÑÑ‚ÑŒ Ð',0),(266074,7391,'es','Seleccionar File parte A',0),(266075,7391,'de','WÃ¤hlen Sie Datei-Teil A',0),(266076,7391,'en','Select File Part A',0),(266077,7392,'is','',0),(266078,7392,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‚Ø³Ù…Øª Ø¯ÙˆÙ… ÙØ§ÙŠÙ„\r\n B',0),(266079,7392,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‚Ø³Ù…Øª Ø¯ÙˆÙ… ÙØ§ÙŠÙ„\r\n B',0),(266080,7392,'tr','Dosya bÃ¶lÃ¼mÃ¼ B seÃ§in',0),(266081,7392,'pl','Wybierz plik czÄ™Å›Ä‡ B',0),(266082,7392,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð» Ñ‡Ð°ÑÑ‚ Ð‘',0),(266083,7392,'ur','Ù…Ù†ØªØ®Ø¨ Ù…Ø³Ù„ Ø­ØµÛ B',0),(266084,7392,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð´ÐµÐ¾ Ð‘',0),(266085,7392,'vi','Chá»n há»“ sÆ¡ Pháº§n B',0),(266086,7392,'af','Selekteer LÃªer Deel B',0),(266087,7392,'ro','SelectaÅ£i fiÅŸierul partea B',0),(266088,7392,'et','Valige faili osa B',0),(266089,7392,'si','Izberite datoteko del B',0),(266090,7392,'ba','Pilih File Bagian B',0),(266091,7392,'nl','Selecteer bestand deel B',0),(266092,7392,'fi','Valitse tiedoston osa B',0),(266093,7392,'no','Velg filen del B',0),(266094,7392,'da','VÃ¦lg fil del B',0),(266095,7392,'ko','íŒŒì¼ íŒŒíŠ¸ B ì„ íƒ',0),(266096,7392,'he','×‘×—×¨ ×§×•×‘×¥ ×—×œ×§ ×‘\'',0),(266097,7392,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î¼Î­ÏÎ¿Ï‚ Î’',0),(266098,7392,'zh','é€‰æ‹©æ–‡ä»¶Béƒ¨åˆ†\r\n',0),(266099,7392,'sv','VÃ¤lj filen del B',0),(266100,7392,'it','Selezionare il File parte B',0),(266101,7392,'tl','',0),(266102,7392,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3615;&#3621;&#3660;&#3626;&#3656;&#3623;&#3609; B',0),(266103,7392,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤­à¤¾à¤— B à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(266104,7392,'ms','Pilih fail Bahagian B',0),(266105,7392,'ar','Ø­Ø¯Ø¯ Ù…Ù„Ù Ø¬Ø²Ø¡ Ø¨',0),(266106,7392,'fr','SÃ©lectionnez le fichier partie B',0),(266107,7392,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®éƒ¨åˆ† B ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(266108,7392,'pt','Selecione o arquivo parte B',0),(266109,7392,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¤Ð°Ð¹Ð» Ð§Ð°ÑÑ‚ÑŒ Ð’',0),(266110,7392,'es','Seleccionar File parte B',0),(266111,7392,'de','WÃ¤hlen Sie Datei-Teil B',0),(266112,7392,'en','Select File Part B',0),(266113,7393,'is','',0),(266114,7393,'dr','QB ',0),(266115,7393,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† QB \r\n',0),(266116,7393,'tr','Alma QB satÄ±cÄ±lar',0),(266117,7393,'pl','ZaimportowaÄ‡ QB dostawcÃ³w',0),(266118,7393,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QB Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(266119,7393,'ur','Ù‚Ø¨ ÙˆÛŒÙ†ÚˆØ±Ø² Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(266120,7393,'sr','Ð£Ð²Ð¾Ð· ÐšÐ²Ð¾Ñ‚ÐµÑ€Ð±ÐµÐº Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(266121,7393,'vi','Nháº­p ngÆ°á»i bÃ¡n QB',0),(266122,7393,'af','Invoer van QB Verskaffers',0),(266123,7393,'ro','VÃ¢nzÄƒtorii de import QB',0),(266124,7393,'et','Impordi QB tarnijad',0),(266125,7393,'si','Uvoz QB prodajalci',0),(266126,7393,'ba','Impor QB vendor',0),(266127,7393,'nl','QB leveranciers importeren',0),(266128,7393,'fi','Tuo QB toimittajat',0),(266129,7393,'no','Importere QB leverandÃ¸rer',0),(266130,7393,'da','Importere QB leverandÃ¸rer',0),(266131,7393,'ko','ìˆ˜ìž… ì¿¼í„° ë°± ê³µê¸‰ ì—…ì²´',0),(266132,7393,'he','×™×™×‘×•× QB ×¡×¤×§×™×',0),(266133,7393,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® QB Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚',0),(266134,7393,'zh','å¯¼å…¥QuickBookè½¯ä»¶ç³»åˆ—ä¾›åº”å•†\r\n',0),(266135,7393,'sv','Importera QB leverantÃ¶rer',0),(266136,7393,'it','Fornitori di importazione QB',0),(266137,7393,'tl','',0),(266138,7393,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634; QB &#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(266139,7393,'hi','QB à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(266140,7393,'ms','Pembekal import QB',0),(266141,7393,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ† Ù…Ù† QB ',0),(266142,7393,'fr','Importer des vendeurs de QB',0),(266143,7393,'jp','QB ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(266144,7393,'pt','Fornecedores de importaÃ§Ã£o QB',0),(266145,7393,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° QB',0),(266146,7393,'es','Importar QB Proveedores',0),(266147,7393,'de','QB-Anbieter importieren',0),(266148,7393,'en','Import QB Vendors',0),(266149,7394,'is','',0),(266150,7394,'dr','(Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨) ÙØ±ÙˆØ´Ù†Ø¯Ù‡QB',0),(266151,7394,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„(Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨) ÙØ±ÙˆØ´Ù†Ø¯Ù‡QB\r\n ',0),(266152,7394,'tr','SatÄ±cÄ± QB dosya sÃ¼tun biÃ§imi',0),(266153,7394,'pl','Dostawcy plik QB kolumna Format',0),(266154,7394,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº QB Ñ„Ð°Ð¹Ð» ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(266155,7394,'ur','ÙˆÛŒÙ†ÚˆØ± Ù‚Ø¨ Ù…Ø³Ù„ Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(266156,7394,'sr','Ð‘ÐµÐº Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(266157,7394,'vi','Há»“ sÆ¡ NgÆ°á»i bÃ¡n QB dáº¡ng cá»™t',0),(266158,7394,'af','Handelaar QB kolom lÃªerformaat',0),(266159,7394,'ro','Furnizor QB fiÅŸier Format coloane',0),(266160,7394,'et','Hankija QB veeru vormingus',0),(266161,7394,'si','Prodajalec QB zapisa stolpec',0),(266162,7394,'ba','Format kolom Penjual QB File',0),(266163,7394,'nl','Leverancier QB kolom bestandsindeling',0),(266164,7394,'fi','Toimittajan QB-sarakkeen tiedostomuoto',0),(266165,7394,'no','LeverandÃ¸ren QB filen kolonneformat',0),(266166,7394,'da','Kreditor QB-kolonne filformat',0),(266167,7394,'ko','ê³µê¸‰ ì—…ì²´ ì¿¼í„° ë°± íŒŒì¼ ì—´ í˜•ì‹',0),(266168,7394,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” QB ×§×•×‘×¥ ×¡×¤×§×™×',0),(266169,7394,'el','ÎœÎ¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½ QB Î±ÏÏ‡ÎµÎ¯Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(266170,7394,'zh','ä¾›åº”å•†QBç³»åˆ—æ–‡ä»¶åˆ—æ ¼å¼\r\n',0),(266171,7394,'sv','LeverantÃ¶r QB-kolumn filformatet',0),(266172,7394,'it','Formato di colonna File QB fornitore',0),(266173,7394,'tl','',0),(266174,7394,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3652;&#3615;&#3621;&#3660; QB &#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(266175,7394,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ QB à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(266176,7394,'ms','Format kolum fail QB Penjual',0),(266177,7394,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ QB Ù…Ù„Ù Ø§Ù„Ù…ÙˆØ±Ø¯',0),(266178,7394,'fr','Format de colonne pour le fichier QB du vendeur',0),(266179,7394,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ QB ãƒ•ã‚¡ã‚¤ãƒ«åˆ—ã®å½¢å¼',0),(266180,7394,'pt','Fornecedor QB arquivo formato de coluna',0),(266181,7394,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° QB Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(266182,7394,'es','Proveedor QB Formato de File Columna',0),(266183,7394,'de','Kreditor-QB Spalte Dateiformat',0),(266184,7394,'en','Vendor QB File Column Format',0),(266185,7395,'is','',0),(266186,7395,'dr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† Ø§Ø² Ø­Ø³Ø§Ø¨',0),(266187,7395,'pr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† Ø§Ø² Ø­Ø³Ø§Ø¨',0),(266188,7395,'tr','Geri alÄ±nmÄ±ÅŸ',0),(266189,7395,'pl','Wycofane',0),(266190,7395,'bg','ÐžÑ‚Ñ‚ÐµÐ³Ð»ÐµÐ½Ð¸',0),(266191,7395,'ur','Ú©Ù†Ø§Ø±Û',0),(266192,7395,'sr','ÐŸÐ¾Ð²ÑƒÑ‡ÐµÐ½',0),(266193,7395,'vi','RÃºt ra',0),(266194,7395,'af','Het Ontrek',0),(266195,7395,'ro','Retrasa',0),(266196,7395,'et','TagasivÃµetud',0),(266197,7395,'si','Umaknjena',0),(266198,7395,'ba','Ditarik',0),(266199,7395,'nl','Ingetrokken',0),(266200,7395,'fi','Peruuttaa',0),(266201,7395,'no','Trukket tilbake',0),(266202,7395,'da','Trukket tilbage',0),(266203,7395,'ko','ì² íšŒ',0),(266204,7395,'he','×ž×¡×•×’×¨',0),(266205,7395,'el','Î‘Ï€Î¿ÏƒÏ…ÏÎ¸ÎµÎ¯',0),(266206,7395,'zh','æ’¤å›ž\r\n',0),(266207,7395,'sv','Ã…terkallas',0),(266208,7395,'it','Ritirato',0),(266209,7395,'tl','',0),(266210,7395,'th','&#3606;&#3629;&#3609;',0),(266211,7395,'hi','à¤µà¤¾à¤ªà¤¸ à¤²à¤¿à¤¯à¤¾',0),(266212,7395,'ms','Ditarik balik',0),(266213,7395,'ar','Ø³Ø­Ø¨',0),(266214,7395,'fr','RetirÃ©',0),(266215,7395,'jp','æ’¤å›ž',0),(266216,7395,'pt','Retirada',0),(266217,7395,'ru','Ð¡Ð½ÑÑ‚Ð¾',0),(266218,7395,'es','Retiro',0),(266219,7395,'de','ZurÃ¼ckgezogen',0),(266220,7395,'en','Withdrawn',0),(266221,7396,'is','',0),(266222,7396,'dr','Ø¯Ø±Ø¬  Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…ÙˆØ§Ø¯',0),(266223,7396,'pr','Ø¯Ø±Ø¬  Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…ÙˆØ§Ø¯',0),(266224,7396,'tr','ÃœrÃ¼n ReÃ§etesi sipariÅŸ iÃ§in otomatik olarak eklenen',0),(266225,7396,'pl','Auto dodaje celu BOM',0),(266226,7396,'bg','Ð’Ð¼ÑŠÐºÐ½Ð°Ñ‚Ð¾ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð·Ð° ÐšÐ˜ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(266227,7396,'ur','Ø®ÙˆØ¯Ú©Ø§Ø±-Ø¨Ø§Ù… Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø§Ø®Ù„ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(266228,7396,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ ÑƒÐ¼ÐµÑ‚Ð½ÑƒÑ‚Ð¾ Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(266229,7396,'vi','Tá»± Äá»™ng ChÃ¨n ThÃªm Cho ÄÆ¡n Äáº·t HÃ ng BOM',0),(266230,7396,'af','Outo-ingevoeg vir BOM orde',0),(266231,7396,'ro','Auto-introduce pentru LM-ului comenzii',0),(266232,7396,'et','Automaatselt lisatud komplekti tellimuse',0),(266233,7396,'si','Samodejno vstavi za Kosovnice nalog',0),(266234,7396,'ba','Auto-dimasukkan untuk pesanan BOM',0),(266235,7396,'nl','Auto-ingevoegd voor BOM Order',0),(266236,7396,'fi','Automaattisesti lisÃ¤tty Tuoterakenteen tilauksen',0),(266237,7396,'no','Automatisk satt inn for Stykkliste for',0),(266238,7396,'da','Auto indsat-for Styklisten ordre',0),(266239,7396,'ko','BOM ìˆœì„œì— ëŒ€ í•œ ìžë™ ì‚½ìž…',0),(266240,7396,'he','×”×•×¡×£ ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™ ×¢×‘×•×¨ ×”×–×ž× ×ª BOM',0),(266241,7396,'el','Î•Î¹ÏƒÎ±Ï‡Î¸ÎµÎ¯ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î± Î³Î¹Î± Ï€ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Ï„ÎµÏ‡Î½Î¹ÎºÏŽÎ½ Ï€ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†ÏŽÎ½',0),(266242,7396,'zh','è‡ªåŠ¨æ’å…¥ç‰©æ–™æ¸…å•çš„è®¢å•\r\n',0),(266243,7396,'sv','Auto infÃ¶ras-fÃ¶r Strukturlista fÃ¶r',0),(266244,7396,'it','Auto-inserito per ordine BOM',0),(266245,7396,'tl','',0),(266246,7396,'th','BOM Order &#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;',0),(266247,7396,'hi','à¤‘à¤Ÿà¥‹-BOM à¤•à¥à¤°à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¾à¤²à¥€ à¤—à¤ˆ',0),(266248,7396,'ms','Auto-dimasukkan untuk perintah BOM',0),(266249,7396,'ar','Ø¥Ø¯Ø±Ø§Ø¬ ØªÙ„Ù‚Ø§Ø¦ÙŠ Ù„Ø£Ù…Ø± Ø´Ø¬Ø±Ø© Ø§Ù„Ù…ÙˆØ§Ø¯',0),(266250,7396,'fr','Auto-insÃ©rÃ© pour ordre BOM',0),(266251,7396,'jp','BOM æ³¨æ–‡ã®è‡ªå‹•æŒ¿å…¥',0),(266252,7396,'pt','Auto-inserido para o BOM fim',0),(266253,7396,'ru','ÐÐ²Ñ‚Ð¾ Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð»Ñ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸ Ð·Ð°ÐºÐ°Ð·Ð°',0),(266254,7396,'es','Auto-Insertado por Oden de BOM',0),(266255,7396,'de','Auto fÃ¼r BOM Reihenfolge eingefÃ¼gt',0),(266256,7396,'en','Auto-Inserted for BOM Order',0),(266257,7397,'is','',0),(266258,7397,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù‡Ù…Ù‡ Ø±Ø§ Ø¨Ù‡ ØµÙˆØ±Øª Ú¯Ø±ÙˆÙ‡ÙŠ Ú†Ø§Ù¾ ÙƒÙ†ÙŠØ¯',0),(266259,7397,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù‡Ù…Ù‡ Ø±Ø§ Ø¨Ù‡ ØµÙˆØ±Øª Ú¯Ø±ÙˆÙ‡ÙŠ Ú†Ø§Ù¾ ÙƒÙ†ÙŠØ¯',0),(266260,7397,'tr','YazdÄ±r grubunda tÃ¼m iÃ§in tÄ±klayÄ±nÄ±z',0),(266261,7397,'pl','Kliknij tutaj aby wydrukowaÄ‡ wszystko z grupy',0),(266262,7397,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð²ÑÐ¸Ñ‡ÐºÐ¾ Ð² Ð³Ñ€ÑƒÐ¿Ð°',0),(266263,7397,'ur','Ù¾Ø±Ù†Ù¹ Ú¯Ø±ÙˆÙ¾ Ù…ÛŒÚº Ø³Ø¨ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(266264,7397,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÐŸÑ€Ð¸Ð½Ñ‚ ÑÐ²Ðµ Ñƒ Ð³Ñ€ÑƒÐ¿Ð¸',0),(266265,7397,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ In táº¥t cáº£ trong nhÃ³m',0),(266266,7397,'af','Kliek Hier om Alles in Groep te Druk',0),(266267,7397,'ro','Click aici pentru a imprima toate Ã®n grup',0),(266268,7397,'et','Vajuta siia, et kÃµik jaotises Prindi',0),(266269,7397,'si','Kliknite tukaj za tiskanje vse v skupini',0),(266270,7397,'ba','Klik di sini untuk mencetak semua dalam grup',0),(266271,7397,'nl','Klik hier om af te drukken alle in groep',0),(266272,7397,'fi','Klikkaa Tulosta kaikki ryhmÃ¤ssÃ¤',0),(266273,7397,'no','Klikk her for Ã¥ skrive ut alle i gruppen',0),(266274,7397,'da','Klik her for at udskrive alle i gruppen',0),(266275,7397,'ko','ê·¸ë£¹ì— ìžˆëŠ” ëª¨ë“  ì¸ì‡„ í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­í•©ë‹ˆë‹¤',0),(266276,7397,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×“×¤×™×¡ ×›×œ ×§×‘×•×¦×”',0),(266277,7397,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ, Î³Î¹Î± Î½Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î¿Î¼Î¬Î´Î±',0),(266278,7397,'zh','æŒ‰æ­¤ä»¥æ‰“å°æ‰€æœ‰ç»„\r\n',0),(266279,7397,'sv','Klicka hÃ¤r fÃ¶r att skriva ut alla i gruppen',0),(266280,7397,'it','Clicca qui per stampare tutti in gruppo',0),(266281,7397,'tl','',0),(266282,7397,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3614;&#3636;&#3617;&#3614;&#3660;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(266283,7397,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤¸à¤­à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(266284,7397,'ms','Klik di sini untuk Print semua dalam Kumpulan',0),(266285,7397,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø·Ø¨Ø§Ø¹Ø© ÙƒÙ„ Ø´ÙŠØ¡ ÙÙŠ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(266286,7397,'fr','Cliquez ici pour imprimer tout en groupe',0),(266287,7397,'jp','ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦ã‚°ãƒ«ãƒ¼ãƒ—ã«ã™ã¹ã¦å°åˆ·ã™ã‚‹ã«ã¯',0),(266288,7397,'pt','Clique aqui para imprimir tudo em grupo',0),(266289,7397,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð¡ÑŽÐ´Ð° Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð’ÑÐµ Ð² Ð“Ñ€ÑƒÐ¿Ð¿Ðµ',0),(266290,7397,'es','Click AquÃ­ para Imprimir Todo en el Grupo',0),(266291,7397,'de','Hier geht\'s zum Drucken aller in Gruppe',0),(266292,7397,'en','Click Here to Print All in Group',0),(266293,7398,'is','',0),(266294,7398,'dr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(266295,7398,'pr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(266296,7398,'tr','YapÄ± sipariÅŸi iÃ§in',0),(266297,7398,'pl','Do wykonania zamÃ³wienia',0),(266298,7398,'bg','Ð—Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(266299,7398,'ur','Ú©Û’ Ù„Ø¦Û’ ØªØ¹Ù…ÛŒØ± Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(266300,7398,'sr','Ð—Ð° Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÑƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(266301,7398,'vi','DÃ nh Cho ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(266302,7398,'af','Vir bou orde',0),(266303,7398,'ro','Pentru a construi ordine',0),(266304,7398,'et','Build tellimuse',0),(266305,7398,'si','Za izgradnje',0),(266306,7398,'ba','Untuk membangun',0),(266307,7398,'nl','Voor opbouwvolgorde',0),(266308,7398,'fi','Rakentaa jÃ¤rjestyksessÃ¤',0),(266309,7398,'no','For bygge ordre',0),(266310,7398,'da','For byg efter ordre',0),(266311,7398,'ko','ë¹Œë“œ ìˆœì„œì— ëŒ€ í•œ',0),(266312,7398,'he','×¢×‘×•×¨ ×‘× ×™×” ×”×–×ž× ×”',0),(266313,7398,'el','Î“Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(266314,7398,'zh','å¯¹äºŽæž„å»ºé¡ºåº\r\n',0),(266315,7398,'sv','FÃ¶r bygga Order',0),(266316,7398,'it','Per ordine di compilazione',0),(266317,7398,'tl','',0),(266318,7398,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(266319,7398,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤•à¥à¤°à¤® à¤•à¥‡ à¤²à¤¿à¤',0),(266320,7398,'ms','Untuk membina pesanan',0),(266321,7398,'ar','Ù„ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(266322,7398,'fr','Pour l\'ordre de compilation',0),(266323,7398,'jp','ãƒ“ãƒ«ãƒ‰é †åºã®',0),(266324,7398,'pt','Por ordem de compilaÃ§Ã£o',0),(266325,7398,'ru','Ð”Ð»Ñ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(266326,7398,'es','Para Orden de ConstrucciÃ³n',0),(266327,7398,'de','FÃ¼r Buildreihenfolge',0),(266328,7398,'en','For Build Order',0),(266329,7399,'is','',0),(266330,7399,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø§ÙŠØ¬Ø§Ø¯ Ù†Ø´Ø¯Ù‡ ',0),(266331,7399,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø§ÙŠØ¬Ø§Ø¯ Ù†Ø´Ø¯Ù‡ ',0),(266332,7399,'tr','YapÄ± sipariÅŸi iÃ§in oluÅŸturulan hiÃ§bir PO',0),(266333,7399,'pl','Nie PO stworzony dla wykonania zamÃ³wienia',0),(266334,7399,'bg','ÐÑÐ¼Ð° PO, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½ Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð°',0),(266335,7399,'ur','Ú©ÙˆØ¦ÛŒ Ù¾Ùˆ ØªØ¹Ù…ÛŒØ± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(266336,7399,'sr','ÐÐµÐ¼Ð° ÐŸÐž ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½ Ð·Ð° Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÑƒ',0),(266337,7399,'vi','ChÆ°a táº¡o Ä‘Æ¡n mua hÃ ng cho Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(266338,7399,'af','Geen AB Geskep vir Geboude Bestellings',0),(266339,7399,'ro','Nu PO creat pentru a construi ordine',0),(266340,7399,'et','Nr PO ehitada tellimuse loonud',0),(266341,7399,'si','Ne PO ustvaril za izgradnje',0),(266342,7399,'ba','PO tidak dibuat untuk membangun Order',0),(266343,7399,'nl','Geen PO gemaakt voor opbouwvolgorde',0),(266344,7399,'fi','No PO luonut tilauksen mukaan',0),(266345,7399,'no','Ingen PO opprettet for bygge ordre',0),(266346,7399,'da','Ingen PO lavet for byg efter ordre',0),(266347,7399,'ko','ë¹Œë“œ ìˆœì„œë¥¼ ìœ„í•´ ë§Œë“  ì•„ë‹ˆ í¬',0),(266348,7399,'he','××™×Ÿ ×¤×• ×©× ×•×¦×¨×• ×¢×‘×•×¨ ×‘× ×™×” ×”×–×ž× ×”',0),(266349,7399,'el','Î”ÎµÎ½ PO Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î³Î¹Î± Ï„Î·Î½ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® ÏƒÎµÎ¹ÏÎ¬',0),(266350,7399,'zh','æ²¡æœ‰ä¸ºæž„å»ºé¡ºåºè€Œåˆ›å»ºè®¢å•\r\n',0),(266351,7399,'sv','Inga PO som skapats fÃ¶r bygga Order',0),(266352,7399,'it','No PO creata per ordine di compilazione',0),(266353,7399,'tl','',0),(266354,7399,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3626;&#3619;&#3657;&#3634;&#3591;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3',0),(266355,7399,'hi','à¤•à¥‹à¤ˆ à¤ªà¥‹ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤•à¥à¤°à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¨à¤¾à¤ˆ à¤—à¤ˆ',0),(266356,7399,'ms','PO tidak dicipta untuk membina perintah',0),(266357,7399,'ar','Øµ. Ø¨ Ù„Ø§ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ù„ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(266358,7399,'fr','Aucun PO crÃ©Ã© pour Build Order',0),(266359,7399,'jp','ãƒ“ãƒ«ãƒ‰é †åºã®ä½œæˆãªã— PO',0),(266360,7399,'pt','NÃ£o PO criado por ordem de compilaÃ§Ã£o',0),(266361,7399,'ru','ÐÐµ PO, ÑÐ¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð´Ð»Ñ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(266362,7399,'es','No se CreyÃ³ OC para este Orden de No se EncontrÃ³ Ordenes de ConstrucciÃ³n ',0),(266363,7399,'de','Keine PO fÃ¼r Buildreihenfolge erstellt',0),(266364,7399,'en','No PO Created for Build Order',0),(266365,7400,'is','',0),(266366,7400,'dr','Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯  ØµØ§Ø¯Ø± Ø´Ø¯Ù‡ Ø§Ù†Ø¯ â€“ Ø³ÙØ§Ø±Ø´ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ØªØºÙŠÙŠØ± ÙƒÙ†Ø¯ ',0),(266367,7400,'pr','Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯  ØµØ§Ø¯Ø± Ø´Ø¯Ù‡ Ø§Ù†Ø¯ â€“ Ø³ÙØ§Ø±Ø´ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ØªØºÙŠÙŠØ± ÙƒÙ†Ø¯ ',0),(266368,7400,'tr','Bir kez POs verilen emri deÄŸiÅŸtirilemez',0),(266369,7400,'pl','Po POs sÄ… wydawane, zamÃ³wienie nie moÅ¼e byÄ‡ zmieniona',0),(266370,7400,'bg','Ð¡Ð»ÐµÐ´ ÐºÐ°Ñ‚Ð¾ ÐŸÐžÐ¡ ÑÐ° Ð¸Ð·Ð´Ð°Ð´ÐµÐ½Ð¸, Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð°',0),(266371,7400,'ur','Ø§ÛŒÚ© Ø¨Ø§Ø± Ù¾ÙˆØ²ÛŒØ´Ù† Ù…ØªØ­Ø¯Û Ú©ÛŒ Ø¬Ø§Ø±ÛŒ Ú©Ø±Ø¯Û ÛÛŒÚºØŒ ØªØ±ØªÛŒØ¨ ØªØ¨Ø¯ÛŒÙ„ Ú©ÛŒÛ’ Ú¯Ø¦Û’ Ø¬Ø§ Ø³Ú©ØªØ§',0),(266372,7400,'sr','ÐˆÐµÐ´Ð½Ð¾Ð¼ ÐºÐ°Ð´Ð° ÐŸÐžÑ ÑÐµ Ð¸Ð·Ð´Ð°Ñ˜Ñƒ, Ð½Ðµ Ð¼Ð¾Ð³Ñƒ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(266373,7400,'vi','Khi ÄÆ¡n Mua HÃ ng ÄÃ£ Xuáº¥t, ÄÆ¡n Ä‘áº·t hÃ ng khÃ´ng thá»ƒ chá»‰nh sá»­a',0),(266374,7400,'af','Sodra ABs uitgereik is, kan Bestellings nie gewysig word nie',0),(266375,7400,'ro','OdatÄƒ ce sunt emise POs, comanda nu poate fi modificatÄƒ',0),(266376,7400,'et','POs vÃ¤ljaandmisest jÃ¤rjekorras ei saa muuta',0),(266377,7400,'si','Ko POs izdajajo, ni mogoÄe spremeniti vrstni red',0),(266378,7400,'ba','Setelah POs yang dikeluarkan, perintah tidak dapat diubah',0),(266379,7400,'nl','Formulier Order eenmaal POs worden uitgegeven, niet worden gewijzigd',0),(266380,7400,'fi','Kun POs annetaan, jÃ¤rjestyksen ei voi muuttaa',0),(266381,7400,'no','NÃ¥r POs utstedes, kan ikke rekkefÃ¸lgen endres',0),(266382,7400,'da','NÃ¥r POs er udstedt, kan ikke bestilling Ã¦ndres',0),(266383,7400,'ko','POs ë°œê¸‰ ëœ ìˆœì„œë¥¼ ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(266384,7400,'he','×‘×¨×’×¢ POs ×ž×•× ×¤×§×™×, ××¤×©×¨×•×ª ×œ×©× ×•×ª ×¡×“×¨',0),(266385,7400,'el','ÎœÏŒÎ»Î¹Ï‚ ÎµÎºÎ´Î¯Î´Î¿Î½Ï„Î±Î¹ POs, Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î»Î»Î¬Î¾ÎµÎ¹ Î· ÏƒÎµÎ¹ÏÎ¬',0),(266386,7400,'zh','ä¸€æ—¦å‘å‡ºé‡‡è´­è®¢å•ï¼Œè®¢å•ä¸èƒ½è¢«æ”¹å˜\r\n',0),(266387,7400,'sv','NÃ¤r POs utfÃ¤rdas, kan inte ordern Ã¤ndras',0),(266388,7400,'it','Una volta che POs sono emesse, ordine non puÃ² essere alterato',0),(266389,7400,'tl','',0),(266390,7400,'th','&#3607;&#3633;&#3609;&#3607;&#3637;&#3607;&#3637;&#3656;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3617;&#3637;&#3612;&#3621; &#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3617;&#3656;&#3626;&#',0),(266391,7400,'hi','à¤•à¥à¤°à¤® à¤¬à¤¦à¤²à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤à¤• à¤¬à¤¾à¤° POs à¤œà¤¾à¤°à¥€ à¤•à¤¿à¤ à¤—à¤ à¤¹à¥ˆà¤‚,',0),(266392,7400,'ms','Setelah POs akan dikeluarkan, perintah tidak boleh dipinda',0),(266393,7400,'ar','Ø­Ø§Ù„Ù…Ø§ ÙŠØªÙ… Ø¥ØµØ¯Ø§Ø± POsØŒ Ø£Ù…Ø± Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØºÙŠÙŠØ±Ù‡Ø§',0),(266394,7400,'fr','Une fois que les POs sont Ã©mises, ordre non modifiable',0),(266395,7400,'jp','POs ãŒç™ºè¡Œã•ã‚Œã‚‹ã¨ã€é †åºã‚’å¤‰æ›´ã§ãã¾ã›ã‚“ã€‚',0),(266396,7400,'pt','Uma vez que POs sÃ£o emitidos, a ordem nÃ£o pode ser alterada',0),(266397,7400,'ru','ÐŸÐ¾ÑÐ»Ðµ Ð²Ñ‹Ð´Ð°Ñ‡Ð¸ POs, Ð·Ð°ÐºÐ°Ð· Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð°',0),(266398,7400,'es','Una vez que los OCs estan emitidos, El Orden no puede ser alterado',0),(266399,7400,'de','Nachdem POs herausgegeben wurden, kann nicht Reihenfolge geÃ¤ndert werden',0),(266400,7400,'en','Once POs are issued, Order cannot be altered',0),(266401,7401,'is','',0),(266402,7401,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(266403,7401,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(266404,7401,'tr','YapÄ± sipariÅŸi iÃ§in PO',0),(266405,7401,'pl','PO dla wykonania zamÃ³wienia',0),(266406,7401,'bg','PO Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(266407,7401,'ur','ØªØ¹Ù…ÛŒØ± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ Ù¾Ùˆ',0),(266408,7401,'sr','ÐŸÐž Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÐ¸ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(266409,7401,'vi','ÄÆ¡n mua hÃ ng cho Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(266410,7401,'af','Posbus vir bouvorm orde',0),(266411,7401,'ro','PO pentru a construi ordine',0),(266412,7401,'et','PO ehitada tellimuse',0),(266413,7401,'si','PO za izgradnje',0),(266414,7401,'ba','PO untuk membangun Order',0),(266415,7401,'nl','PO voor opbouwvolgorde',0),(266416,7401,'fi','PO tilauksen mukaan',0),(266417,7401,'no','PO For bygge ordre',0),(266418,7401,'da','PO For Byg efter ordre',0),(266419,7401,'ko','ë¹Œë“œ ìˆœì„œì— ëŒ€ í•œ í¬',0),(266420,7401,'he','×”×–×ž× ×ª ×¨×›×© ×¢×‘×•×¨ ×‘× ×™×” ×”×–×ž× ×”',0),(266421,7401,'el','PO Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(266422,7401,'zh','è®¢å•çš„æž„å»ºé¡ºåº\r\n',0),(266423,7401,'sv','PO fÃ¶r bygga Order',0),(266424,7401,'it','PO per ordine di compilazione',0),(266425,7401,'tl','',0),(266426,7401,'th','&#3651;&#3610;&#3626;&#3633;&#3657;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(266427,7401,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤•à¥à¤°à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹',0),(266428,7401,'ms','PO untuk membina pesanan',0),(266429,7401,'ar','Øµ. Ø¨. Ù„ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(266430,7401,'fr','PO pour Build Order',0),(266431,7401,'jp','ãƒ“ãƒ«ãƒ‰é †åºã® PO',0),(266432,7401,'pt','PO para ordem de compilaÃ§Ã£o',0),(266433,7401,'ru','PO Ð´Ð»Ñ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(266434,7401,'es','OC para Orden de ConstrucciÃ³n',0),(266435,7401,'de','PO fÃ¼r Buildreihenfolge',0),(266436,7401,'en','PO For Build Order',0),(266437,7402,'is','',0),(266438,7402,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(266439,7402,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(266440,7402,'tr','YapÄ± sipariÅŸi dan PO',0),(266441,7402,'pl','PO z wykonania zamÃ³wienia',0),(266442,7402,'bg','PO Ð¾Ñ‚ ÑÑ‚Ñ€Ð¾Ñ Ñ€ÐµÐ´',0),(266443,7402,'ur','ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø­Ú©Ù… Ø³Û’ Ù¾Ùˆ',0),(266444,7402,'sr','ÐŸÐž Ð¸Ð· Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(266445,7402,'vi','ÄÆ¡n mua hÃ ng tá»« Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(266446,7402,'af','Posbus uit bou orde',0),(266447,7402,'ro','PO la comandÄƒ de a construi',0),(266448,7402,'et','PO ehitada tellimusest',0),(266449,7402,'si','PO nalogu graditi',0),(266450,7402,'ba','PO membangun urutan',0),(266451,7402,'nl','PO van opbouwvolgorde',0),(266452,7402,'fi','PO tilauksen mukaan',0),(266453,7402,'no','PO fra bygge ordre',0),(266454,7402,'da','PO fra Byg efter ordre',0),(266455,7402,'ko','ë¹Œë“œ ìˆœì„œì—ì„œ í¬',0),(266456,7402,'he','×¤×• ×ž ×‘× ×™×” ×”×–×ž× ×”',0),(266457,7402,'el','PO Î±Ï€ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(266458,7402,'zh','ä»Žæž„å»ºé¡ºåºå®\r\n',0),(266459,7402,'sv','PO frÃ¥n bygga Order',0),(266460,7402,'it','PO da ordine di compilazione',0),(266461,7402,'tl','',0),(266462,7402,'th','&#3651;&#3610;&#3626;&#3633;&#3657;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(266463,7402,'hi','PO à¤¬à¤¿à¤²à¥à¤¡ à¤•à¥à¤°à¤® à¤¸à¥‡',0),(266464,7402,'ms','PO dari perintah membina',0),(266465,7402,'ar','Øµ. Ø¨ Ù…Ù† ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(266466,7402,'fr','PO de l\'ordre de compilation',0),(266467,7402,'jp','ãƒ“ãƒ«ãƒ‰é †åºã‹ã‚‰ PO',0),(266468,7402,'pt','PO de ordem de compilaÃ§Ã£o',0),(266469,7402,'ru','Ð¡ÐŸ Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(266470,7402,'es','OC para Orden de ConstrucciÃ³n',0),(266471,7402,'de','PO von Buildreihenfolge',0),(266472,7402,'en','PO From Build Order',0),(266473,7403,'is','',0),(266474,7403,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø¬Ù‡Øª Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(266475,7403,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø¬Ù‡Øª Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(266476,7403,'tr','YapÄ± sipariÅŸi PO oluÅŸturmak iÃ§in seÃ§in',0),(266477,7403,'pl','Wybierz Build aby utworzyÄ‡ PO',0),(266478,7403,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÑ‚Ñ€Ð¾Ñ, Ð·Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ PO',0),(266479,7403,'ur','Ù¾Ùˆ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ØªØ¹Ù…ÛŒØ± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(266480,7403,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð‘ÑƒÐ¸Ð»Ð´ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ ÐŸÐž',0),(266481,7403,'vi','Chá»n Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng sang táº¡o Ä‘Æ¡n mua hÃ ng',0),(266482,7403,'af','Kies bou orde skep PO',0),(266483,7403,'ro','SelectaÅ£i pentru a construi a crea PO',0),(266484,7403,'et','Valige ehitada tellimuse luua PO',0),(266485,7403,'si','Izberite izgradnje ustvariti PO',0),(266486,7403,'ba','Pilih membangun agar membuat PO',0),(266487,7403,'nl','Selecteer Build om Inkooporders maken',0),(266488,7403,'fi','Valitse tilauksen luoda PO',0),(266489,7403,'no','Velg bygge Ã¥ skape PO',0),(266490,7403,'da','VÃ¦lg bygge for at skabe PO',0),(266491,7403,'ko','í¬ë¥¼ ë§Œë“¤ ë¹Œë“œ ìˆœì„œë¥¼ ì„ íƒ í•©ë‹ˆë‹¤',0),(266492,7403,'he','×‘×—×¨ ×œ×‘× ×•×ª ×¡×“×¨ ×›×“×™ ×œ×™×¦×•×¨ ×¤×•',0),(266493,7403,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÏƒÎµÎ¹ÏÎ¬ Build Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎ¿Ï…Î½ PO',0),(266494,7403,'zh','é€‰æ‹©æž„å»ºé¡ºåºä»¥åˆ›å»ºé‡‡è´­è®¢å•\r\n',0),(266495,7403,'sv','VÃ¤lj bygga fÃ¶r att skapa PO',0),(266496,7403,'it','Selezionare l\'ordine di compilazione per creare PO',0),(266497,7403,'tl','',0),(266498,7403,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3626;&#3619;&#3657;&#3634;&#3591;&#3652;&#3611;&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3',0),(266499,7403,'hi','PO à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤•à¥à¤°à¤® à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(266500,7403,'ms','Pilih pesanan membina untuk mencipta PO',0),(266501,7403,'ar','Ø­Ø¯Ø¯ ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ Ø¨Ø±ÙŠØ¯',0),(266502,7403,'fr','SÃ©lectionnez l\'ordre de compilation pour crÃ©er PO',0),(266503,7403,'jp','PO ã‚’ä½œæˆã™ã‚‹ãƒ“ãƒ«ãƒ‰é †åºã‚’é¸æŠžã—ã¾ã™',0),(266504,7403,'pt','Selecione a ordem de compilaÃ§Ã£o para criar PO',0),(266505,7403,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ Ð´Ð»Ñ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ Ð¡ÐŸ',0),(266506,7403,'es','Seleccionar Orden de ConstrucciÃ³n para Crear OC',0),(266507,7403,'de','WÃ¤hlen Sie die Buildreihenfolge PO erstellen',0),(266508,7403,'en','Select Build Order to Create PO',0),(266509,7404,'is','',0),(266510,7404,'dr','ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(266511,7404,'pr','ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(266512,7404,'tr','YayÄ±nlanma tarihi iÃ§in',0),(266513,7404,'pl','ZakoÅ„czone do dnia',0),(266514,7404,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ ÐºÑŠÐ¼ Ð´Ð½ÐµÑˆÐ½Ð° Ð´Ð°Ñ‚Ð°',0),(266515,7404,'ur','ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§',0),(266516,7404,'sr','Ð—Ð°Ð²Ñ€ÑˆÐ¸ Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(266517,7404,'vi','ÄÃ£ hoÃ n thÃ nh tá»›i ngÃ y',0),(266518,7404,'af','Voltooi Tot op Datum',0),(266519,7404,'ro','ÃŽncheiat la data de',0),(266520,7404,'et','LÃµpetatud kuupÃ¤ev',0),(266521,7404,'si','DokonÄana do datuma',0),(266522,7404,'ba','Selesai tanggal',0),(266523,7404,'nl','Datum voltooid',0),(266524,7404,'fi','Loppuun mennessÃ¤',0),(266525,7404,'no','FullfÃ¸rt dato',0),(266526,7404,'da','Afsluttet til dato',0),(266527,7404,'ko','ë‚ ì§œì— ì™„ë£Œ',0),(266528,7404,'he','×”×•×©×œ×ž×” ×¢×“ ×”×™×•×',0),(266529,7404,'el','ÎŸÎ»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ Î¼Î­Ï‡ÏÎ¹ ÏƒÎ®Î¼ÎµÏÎ±',0),(266530,7404,'zh','å®Œæˆçš„æ—¥æœŸ\r\n',0),(266531,7404,'sv','Avslutade hittills',0),(266532,7404,'it','Completato alla data',0),(266533,7404,'tl','',0),(266534,7404,'th','&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;&#3606;&#3638;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(266535,7404,'hi','à¤¤à¤¿à¤¥à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤—à¤¯à¤¾',0),(266536,7404,'ms','Diisi dengan tarikh',0),(266537,7404,'ar','Ø£Ù†Ø¬Ø²Øª Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(266538,7404,'fr','RÃ©alisÃ©es Ã  ce jour',0),(266539,7404,'jp','æ—¥ã«å®Œäº†',0),(266540,7404,'pt','ConcluÃ­do atÃ© Ã  data',0),(266541,7404,'ru','Ðš Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐ¼Ñƒ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¾',0),(266542,7404,'es','Completado a la Fecha',0),(266543,7404,'de','Bisher abgeschlossen',0),(266544,7404,'en','Completed To Date',0),(266545,7405,'is','',0),(266546,7405,'dr','ØªÙˆØ²ÙŠØ¹ Ø´Ø¯Ù‡ ',0),(266547,7405,'pr','ØªÙˆØ²ÙŠØ¹ Ø´Ø¯Ù‡ ',0),(266548,7405,'tr','DaÄŸÄ±tÄ±lmÄ±ÅŸ',0),(266549,7405,'pl','Rozproszonych',0),(266550,7405,'bg','Ð Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸',0),(266551,7405,'ur','Ø¨Ù¹Ø§ ÛÙˆØ§',0),(266552,7405,'sr','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÐ¸Ñ€Ð°Ð½',0),(266553,7405,'vi','ÄÃ£ PhÃ¢n phá»‘i',0),(266554,7405,'af','Versprei',0),(266555,7405,'ro','Distribuite',0),(266556,7405,'et','Jaotatud',0),(266557,7405,'si','Porazdeljeno',0),(266558,7405,'ba','Didistribusikan',0),(266559,7405,'nl','Gedistribueerd',0),(266560,7405,'fi','Jaetaan',0),(266561,7405,'no','Distribuert',0),(266562,7405,'da','Distribueret',0),(266563,7405,'ko','ë¶„ì‚°',0),(266564,7405,'he','×ž×•×¤×¥',0),(266565,7405,'el','Î”Î¹Î±Î½Î­Î¼Î¿Î½Ï„Î±Î¹',0),(266566,7405,'zh','åˆ†å¸ƒå¼\r\n',0),(266567,7405,'sv','Distribueras',0),(266568,7405,'it','Distribuiti',0),(266569,7405,'tl','',0),(266570,7405,'th','&#3592;&#3633;&#3604;&#3592;&#3635;&#3627;&#3609;&#3656;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(266571,7405,'hi','à¤µà¤¿à¤¤à¤°à¤¿à¤¤',0),(266572,7405,'ms','Diedarkan',0),(266573,7405,'ar','ÙˆØ²Ø¹Øª',0),(266574,7405,'fr','DistribuÃ©',0),(266575,7405,'jp','åˆ†æ•£',0),(266576,7405,'pt','DistribuÃ­do',0),(266577,7405,'ru','Ð Ð°ÑÐ¿Ñ€Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(266578,7405,'es','Distribuido',0),(266579,7405,'de','Verteilt',0),(266580,7405,'en','Distributed',0),(266581,7406,'is','',0),(266582,7406,'dr',' Ø¢Ù…Ø§Ø¯Ù‡ Ø³Ø§Ø²ÙŠ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(266583,7406,'pr',' Ø¢Ù…Ø§Ø¯Ù‡ Ø³Ø§Ø²ÙŠ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(266584,7406,'tr','YapÄ± sipariÅŸi doldurmak',0),(266585,7406,'pl','WypeÅ‚niÄ‡ zamÃ³wienie budowaÄ‡',0),(266586,7406,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ ÑÑ‚Ñ€Ð¾Ñ Ñ€ÐµÐ´',0),(266587,7406,'ur','ØªØ¹Ù…ÛŒØ± ØªØ±ØªÛŒØ¨ Ø¨Ú¾Ø±ÛŒÚº',0),(266588,7406,'sr','ÐŸÐ¾Ð¿ÑƒÐ½Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÑƒ',0),(266589,7406,'vi','Äiá»n ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(266590,7406,'af','Vul bou orde',0),(266591,7406,'ro','Umple construi ordine',0),(266592,7406,'et','Build tellimuse tÃ¤itmine',0),(266593,7406,'si','Izpolnite izgradnje',0),(266594,7406,'ba','Mengisi Order membangun',0),(266595,7406,'nl','Vul opbouwvolgorde',0),(266596,7406,'fi','TÃ¤ytÃ¤ tilauksen mukaan',0),(266597,7406,'no','Fylle bygge rekkefÃ¸lge',0),(266598,7406,'da','Fylde Byg efter ordre',0),(266599,7406,'ko','ë¹Œë“œ ìˆœì„œë¥¼ ì±„ìš°ê¸°',0),(266600,7406,'he','×ž×™×œ×•×™ ×‘× ×™×” ×”×–×ž× ×”',0),(266601,7406,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏŽÏƒÏ„Îµ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(266602,7406,'zh','æž„å»ºé¡ºåºå¡«å†™\r\n',0),(266603,7406,'sv','Fyll bygga Order',0),(266604,7406,'it','Riempire l\'ordine di compilazione',0),(266605,7406,'tl','',0),(266606,7406,'th','&#3648;&#3605;&#3636;&#3617;&#3648;&#3605;&#3655;&#3617;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(266607,7406,'hi','à¤¬à¤¿à¤²à¥à¤¡ à¤•à¥à¤°à¤® à¤­à¤°à¥‡à¤‚',0),(266608,7406,'ms','Mengisi pesanan membina',0),(266609,7406,'ar','Ø´ØºÙ„ ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(266610,7406,'fr','Remplissez l\'ordre de compilation',0),(266611,7406,'jp','ãƒ“ãƒ«ãƒ‰é †åºã‚’åŸ‹ã‚ã‚‹',0),(266612,7406,'pt','Preencher a ordem de compilaÃ§Ã£o',0),(266613,7406,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(266614,7406,'es','Completar el Orden de ConstrucciÃ³n',0),(266615,7406,'de','Buildreihenfolge zu fÃ¼llen',0),(266616,7406,'en','Fill Build Order',0),(266617,7407,'is','',0),(266618,7407,'dr','ØªÙ…Ø§Ù…Ø§ ØªÙˆØ²ÙŠØ¹ Ù†Ø´Ø¯Ù‡ ',0),(266619,7407,'pr','ØªÙ…Ø§Ù…Ø§ ØªÙˆØ²ÙŠØ¹ Ù†Ø´Ø¯Ù‡ ',0),(266620,7407,'tr','TÃ¼m daÄŸÄ±tÄ±lmÄ±ÅŸ',0),(266621,7407,'pl','Nie wszystkie rozproszone',0),(266622,7407,'bg','ÐÐµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸',0),(266623,7407,'ur','ØªÙ…Ø§Ù… Ù†ÛÛŒÚº Ø¨Ù¹Ø§ ÛÙˆØ§',0),(266624,7407,'sr','ÐÐ¸ÑÑƒ ÑÐ²Ð¸ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÐ¸Ñ€Ð°Ð½Ð¸',0),(266625,7407,'vi','KhÃ´ng phÃ¢n phá»‘i háº¿t',0),(266626,7407,'af','Nie alle versprei',0),(266627,7407,'ro','Nu toate distribuite',0),(266628,7407,'et','Mitte kÃµik jagatud',0),(266629,7407,'si','Ne vse porazdeljeno',0),(266630,7407,'ba','Tidak semua didistribusikan',0),(266631,7407,'nl','Niet alle gedistribueerde',0),(266632,7407,'fi','Kaikki jaetaan',0),(266633,7407,'no','Ikke alle distribuert',0),(266634,7407,'da','Ikke alle distribuerede',0),(266635,7407,'ko','ëª¨ë“  ë¶„ì‚°',0),(266636,7407,'he','×œ× ×›×œ ×ž×‘×•×–×¨×•×ª',0),(266637,7407,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏŒÎ»Î± Î´Î¹Î±Î½Î­Î¼Î¿Î½Ï„Î±Î¹',0),(266638,7407,'zh','ä¸æ˜¯æ‰€æœ‰çš„åˆ†å¸ƒå¼\r\n',0),(266639,7407,'sv','Inte alla distribueras',0),(266640,7407,'it','Non tutti distribuiti',0),(266641,7407,'tl','',0),(266642,7407,'th','&#3652;&#3617;&#3656;&#3649;&#3592;&#3585;&#3592;&#3656;&#3634;&#3618;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(266643,7407,'hi','à¤¨à¤¹à¥€à¤‚ à¤¸à¤­à¥€ à¤µà¤¿à¤¤à¤°à¤¿à¤¤',0),(266644,7407,'ms','Tidak semua yang diedarkan',0),(266645,7407,'ar','Ù„ÙŠØ³ ÙƒÙ„ ØªÙˆØ²ÙŠØ¹Ù‡',0),(266646,7407,'fr','Pas tous distribuÃ©s',0),(266647,7407,'jp','ã™ã¹ã¦ã®åˆ†æ•£',0),(266648,7407,'pt','Nem todos distribuÃ­dos',0),(266649,7407,'ru','ÐÐµ Ð²ÑÐµ Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ñ‹',0),(266650,7407,'es','No todo Distribuido',0),(266651,7407,'de','Nicht alle verteilt',0),(266652,7407,'en','Not All Distributed',0),(266653,7408,'is','',0),(266654,7408,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ â€“ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙˆÙŠØ±Ø§ÙŠØ´ Ù†ÙŠØ³Øª ',0),(266655,7408,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ â€“ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙˆÙŠØ±Ø§ÙŠØ´ Ù†ÙŠØ³Øª ',0),(266656,7408,'tr','OluÅŸturulan PO-dÃ¼zenleyemezsiniz',0),(266657,7408,'pl','PO stworzony-nie moÅ¼na edytowaÄ‡',0),(266658,7408,'bg','PO ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½-Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°',0),(266659,7408,'ur','Ù¾Ùˆ Ø¨Ù†Ø§ÛŒØ§-ØªØ¯ÙˆÛŒÙ† Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(266660,7408,'sr','ÐŸÐž ÑÑ‚Ð²Ð¾Ñ€Ð¸Ð¾-Ð½Ð¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°Ñ‚Ð¸',0),(266661,7408,'vi','ÄÆ¡n Mua HÃ ng Ä‘Ã£ táº¡o-KhÃ´ng thá»ƒ sá»­a',0),(266662,7408,'af','Posbus geskep-kan nie redigeer nie',0),(266663,7408,'ro','PO creat-nu se poate edita',0),(266664,7408,'et','Loodud PO-ei saa redigeerida',0),(266665,7408,'si','PO ustvaril-ne morete urejati',0),(266666,7408,'ba','PO yang dibuat-tidak dapat mengedit',0),(266667,7408,'nl','PO gemaakt-niet bewerken',0),(266668,7408,'fi','Luotu PO-ei voi muokata',0),(266669,7408,'no','PO opprettet-kan ikke redigere',0),(266670,7408,'da','PO lavet-ikke redigere',0),(266671,7408,'ko','ë§Œë“  í¬-íŽ¸ì§‘í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(266672,7408,'he','×¤×• ×™×¦×¨-×œ× × ×™×ª×Ÿ ×œ×¢×¨×•×š',0),(266673,7408,'el','PO Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ-Î´ÎµÎ½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(266674,7408,'zh','åˆ›å»ºé‡‡è´­è®¢å•ï¼Œæ–œé¢ç¼–è¾‘\r\n',0),(266675,7408,'sv','PO skapad-gÃ¥r inte att redigera',0),(266676,7408,'it','PO creato-non Ã¨ possibile modificare',0),(266677,7408,'tl','',0),(266678,7408,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3649;&#3585;&#3657;&#3652;&#3586;&#3652;&#3604;&#3657;',0),(266679,7408,'hi','PO à¤¬à¤¨à¤¾à¤¯à¤¾-à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(266680,7408,'ms','PO dicipta-tidak boleh mengedit',0),(266681,7408,'ar','Øµ. Ø¨ Ø¥Ù†Ø´Ø§Ø¡--Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­Ø±ÙŠØ±',0),(266682,7408,'fr','PO crÃ©Ã©-ne peut pas modifier',0),(266683,7408,'jp','PO ã‚’ä½œæˆãƒ»ç·¨é›†ã§ãã¾ã›ã‚“',0),(266684,7408,'pt','PO criado-nÃ£o Ã© possÃ­vel editar',0),(266685,7408,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ð¹ PO-Ð½ÐµÐ»ÑŒÐ·Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(266686,7408,'es','OC Creado-No Se Puede Editar',0),(266687,7408,'de','PO erstellt-kann nicht bearbeitet werden',0),(266688,7408,'en','PO Created-Cannot Edit',0),(266689,7409,'is','',0),(266690,7409,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(266691,7409,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(266692,7409,'tr','TedarikÃ§i Ekle',0),(266693,7409,'pl','Dodawanie dostawcy',0),(266694,7409,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(266695,7409,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(266696,7409,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(266697,7409,'vi','ThÃªm NgÆ°á»i BÃ¡n',0),(266698,7409,'af','Verskaffer Byvoeg',0),(266699,7409,'ro','Adauga furnizor',0),(266700,7409,'et','Lisa tarnija',0),(266701,7409,'si','Dodaj dobavitelja',0),(266702,7409,'ba','Tambahkan Vendor',0),(266703,7409,'nl','Toevoegen van leverancier',0),(266704,7409,'fi','LisÃ¤Ã¤ toimittaja',0),(266705,7409,'no','Legger til leverandÃ¸r',0),(266706,7409,'da','TilfÃ¸je kreditor',0),(266707,7409,'ko','ê³µê¸‰ ì—…ì²´ë¥¼ ì¶”ê°€',0),(266708,7409,'he','×”×•×¡×£ ×¡×¤×§',0),(266709,7409,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(266710,7409,'zh','å¢žåŠ ä¾›åº”å•†\r\n',0),(266711,7409,'sv','LÃ¤gga till leverantÃ¶r',0),(266712,7409,'it','Aggiungi fornitore',0),(266713,7409,'tl','',0),(266714,7409,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(266715,7409,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(266716,7409,'ms','Tambah pembekal',0),(266717,7409,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ±Ù‘Ø¯',0),(266718,7409,'fr','Ajouter du vendeur',0),(266719,7409,'jp','ä»•å…¥å…ˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(266720,7409,'pt','Adicionar vendedor',0),(266721,7409,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(266722,7409,'es','Agregar Proveedor',0),(266723,7409,'de','Anbieter hinzufÃ¼gen',0),(266724,7409,'en','Add Vendor',0),(266725,7410,'is','',0),(266726,7410,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ¹Ù‡Ø¯',0),(266727,7410,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ¹Ù‡Ø¯',0),(266728,7410,'tr','AyrÄ±ntÄ±larÄ± iÅŸlemek',0),(266729,7410,'pl','Zatwierdzanie szczegÃ³Å‚y',0),(266730,7410,'bg','Ð˜Ð·Ð²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ Ð½Ð° Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(266731,7410,'ur','ØªÙØµÛŒÙ„Ø§Øª Ú©Ø§ Ø§Ø±ØªÚ©Ø§Ø¨',0),(266732,7410,'sr','ÐŸÐ¾Ð¸Ð¸Ð½Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ð¸',0),(266733,7410,'vi','Chi tiáº¿t Cam káº¿t',0),(266734,7410,'af','Pleeg besonderhede',0),(266735,7410,'ro','Comite detalii',0),(266736,7410,'et','Toime Ã¼ksikasjad',0),(266737,7410,'si','Zavezati podrobnosti',0),(266738,7410,'ba','Melakukan rincian',0),(266739,7410,'nl','Plegen Details',0),(266740,7410,'fi','Vahvista tiedot',0),(266741,7410,'no','Lagre detaljer',0),(266742,7410,'da','BegÃ¥ detaljer',0),(266743,7410,'ko','ì„¸ë¶€ ì‚¬í•­ì„ ì»¤ë°‹í•©ë‹ˆë‹¤',0),(266744,7410,'he','×œ×”×ª×—×™×™×‘ ×¤×¨×˜×™×',0),(266745,7410,'el','Î”ÎµÏƒÎ¼ÎµÏ…Ï„Î¿ÏÎ½ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(266746,7410,'zh','æäº¤è¯¦ç»†èµ„æ–™\r\n',0),(266747,7410,'sv','BegÃ¥ Detaljer',0),(266748,7410,'it','Commettere dettagli',0),(266749,7410,'tl','',0),(266750,7410,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;',0),(266751,7410,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤¸à¤‚à¤•à¤²à¥à¤ª à¤²à¥‡à¤‚',0),(266752,7410,'ms','Melakukan butir-butir',0),(266753,7410,'ar','Ø§Ø±ØªÙƒØ§Ø¨ Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(266754,7410,'fr','Commettre des dÃ©tails',0),(266755,7410,'jp','è©³ç´°ã‚’ã‚³ãƒŸãƒƒãƒˆã—ã¾ã™ã€‚',0),(266756,7410,'pt','Confirmar detalhes',0),(266757,7410,'ru','Ð—Ð°Ñ„Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(266758,7410,'es','Comprometir Details',0),(266759,7410,'de','Informationen zu begehen',0),(266760,7410,'en','Commit Details',0),(266761,7411,'is','',0),(266762,7411,'dr','Mfg  Ø¹Ù„Ø§Ù…Øª ØªØ¬Ø§Ø±ØªÛŒ ØªÙˆÙ„ÙŠØ¯ (Ø³Ø§Ø®Øª',0),(266763,7411,'pr','Mfg  Ø¹Ù„Ø§Ù…Øª ØªØ¬Ø§Ø±ÙŠ ØªÙˆÙ„ÙŠØ¯ (Ø³Ø§Ø®Øª',0),(266764,7411,'tr','Mfg marka',0),(266765,7411,'pl','Marka MFG',0),(266766,7411,'bg','Mfg Ð¼Ð°Ñ€ÐºÐ°',0),(266767,7411,'ur','Mfg Ø¨Ø±Ø§Ù†Úˆ',0),(266768,7411,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð² Ð±Ñ€ÐµÐ½Ð´',0),(266769,7411,'vi','ThÆ°Æ¡ng hiá»‡u nhÃ  sáº£n xuáº¥t',0),(266770,7411,'af','Mfg merk',0),(266771,7411,'ro','MFG Brand',0),(266772,7411,'et','Tootm brÃ¤ndi',0),(266773,7411,'si','Blagovne znamke Mfg',0),(266774,7411,'ba','Mfg merek',0),(266775,7411,'nl','Mfg merk',0),(266776,7411,'fi','Mfg tuotemerkin',0),(266777,7411,'no','Mfg merkevare',0),(266778,7411,'da','MFG mÃ¦rke',0),(266779,7411,'ko','ì œì¡° ë¸Œëžœë“œ',0),(266780,7411,'he','×”×ž×•×ª×’ Mfg',0),(266781,7411,'el','ÎœÎ¬ÏÎºÎ± Mfg',0),(266782,7411,'zh','åˆ¶é€ å“ç‰Œ\r\n',0),(266783,7411,'sv','MFG varumÃ¤rke',0),(266784,7411,'it','Marchio MFG',0),(266785,7411,'tl','',0),(266786,7411,'th','&#3649;&#3610;&#3619;&#3609;&#3604;&#3660; Mfg',0),(266787,7411,'hi','Mfg à¤¬à¥à¤°à¤¾à¤‚à¤¡',0),(266788,7411,'ms','Jenama MFG',0),(266789,7411,'ar','Ù…Ø¨Ø¯Ø¹ÙŠÙ† Ø§Ù„Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ©',0),(266790,7411,'fr','Marque MFG',0),(266791,7411,'jp','è£½ä½œæ‰€ãƒ–ãƒ©ãƒ³ãƒ‰',0),(266792,7411,'pt','Marca MFG',0),(266793,7411,'ru','MFG Ð±Ñ€ÐµÐ½Ð´Ð°',0),(266794,7411,'es','Marca de Fab',0),(266795,7411,'de','MFG Marke',0),(266796,7411,'en','Mfg Brand',0),(266797,7412,'is','',0),(266798,7412,'dr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ØªØ¹ÙŠÙŠÙ† Ù†Ø´Ø¯Ù‡ ',0),(266799,7412,'pr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§ ØªØ¹ÙŠÙŠÙ† Ù†Ø´Ø¯Ù‡ ',0),(266800,7412,'tr','Bu Ã¶ÄŸeye atanan satÄ±cÄ±',0),(266801,7412,'pl','Nie dostawcy przypisany do tego elementu',0),(266802,7412,'bg','ÐÑÐ¼Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(266803,7412,'ur','Ø§Ø³ Ø´Û’ Ú©Ùˆ ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(266804,7412,'sr','ÐÐµÐ¼Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð´Ð¾Ð´ÐµÑ™ÐµÐ½ Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(266805,7412,'vi','ChÆ°a cÃ³ ngÆ°á»i bÃ¡n cho hÃ ng nÃ y',0),(266806,7412,'af','Geen Verskaffers is Toegeskryf vir Hierdie Item',0),(266807,7412,'ro','Nici un furnizor atribuit acest element',0),(266808,7412,'et','Ãœhtegi tarnijat ei ole selle tootega seotud',0),(266809,7412,'si','Brez prodajalca, dodeljenega temu elementu',0),(266810,7412,'ba','Tidak ada Vendor yang ditugaskan untuk Item ini',0),(266811,7412,'nl','Geen leverancier die aan dit Item zijn toegewezen',0),(266812,7412,'fi','Ole liitetty tÃ¤mÃ¤n tuotteen toimittajaa',0),(266813,7412,'no','Ingen leverandÃ¸rer er tilordnet dette elementet',0),(266814,7412,'da','Ingen leverandÃ¸r, der er tildelt dette element',0),(266815,7412,'ko','ì´ í•­ëª©ì— í• ë‹¹ ëœ ì•„ë¬´ ê³µê¸‰ ì—…ì²´',0),(266816,7412,'he','××™×Ÿ ×¡×¤×§ ×©×”×•×§×¦×• ×œ×¤×¨×™×˜ ×–×”',0),(266817,7412,'el','ÎšÎ±Î¼Î¯Î± Ï€Ï‰Î»Î·Ï„Î® Ï€Î¿Ï… Î­Ï‡ÎµÎ¹ Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¹ÏƒÏ„ÎµÎ¯ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(266818,7412,'zh','æ²¡æœ‰ä¾›åº”å•†åˆ†é…ç»™è¯¥é¡¹ç›®\r\n',0),(266819,7412,'sv','Ingen leverantÃ¶r som tilldelats denna artikel',0),(266820,7412,'it','Nessun fornitore assegnato a questo elemento',0),(266821,7412,'tl','',0),(266822,7412,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;',0),(266823,7412,'hi','à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤•à¥‹à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(266824,7412,'ms','Tiada penjual yang ditugaskan untuk Item ini',0),(266825,7412,'ar','Ù„Ù… ÙŠØ¹ÙŠÙ‘Ù† Ù…ÙˆØ±Ù‘Ø¯ Ù„Ù‡Ø°Ø§ Ø§Ù„ØµÙ†Ù',0),(266826,7412,'fr','Aucun fournisseur affectÃ© Ã  cet article',0),(266827,7412,'jp','ã“ã®ã‚¢ã‚¤ãƒ†ãƒ ã«å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ã‚‹ãƒ™ãƒ³ãƒ€ãƒ¼',0),(266828,7412,'pt','Nenhum fornecedor atribuÃ­do a este Item',0),(266829,7412,'ru','ÐÐ¸ Ð¾Ð´Ð¸Ð½ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº, Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½Ð½Ñ‹Ð¹ ÑÑ‚Ð¾Ð¼Ñƒ Ð¿ÑƒÐ½ÐºÑ‚Ñƒ',0),(266830,7412,'es','No se Asigno un Proveedor a Este Item',0),(266831,7412,'de','Kein Anbieter, die dieses Element zugewiesen',0),(266832,7412,'en','No Vendor Assigned to This Item',0),(266833,7413,'is','',0),(266834,7413,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ØµØ§Ø¯Ø± Ø´Ø¯ ',0),(266835,7413,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ØµØ§Ø¯Ø± Ø´Ø¯ ',0),(266836,7413,'tr','Verilen PO',0),(266837,7413,'pl','PO wydane',0),(266838,7413,'bg','ÐŸÐž Ð¸Ð·Ð´Ð°Ð´ÐµÐ½Ð°',0),(266839,7413,'ur','Ø¬Ø§Ø±ÛŒ Ú©Ø±Ø¯Û Ù¾Ùˆ',0),(266840,7413,'sr','ÐŸÐž Ð¾Ð±Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð¾Ð¼',0),(266841,7413,'vi','ÄÃ£ phÃ¡t hÃ nh Ä‘Æ¡n mua hÃ ng',0),(266842,7413,'af','Posbus uitgereik',0),(266843,7413,'ro','PO emise',0),(266844,7413,'et','VÃ¤ljastatud PO',0),(266845,7413,'si','PO izdanih',0),(266846,7413,'ba','PO dikeluarkan',0),(266847,7413,'nl','PO afgegeven',0),(266848,7413,'fi','PO liikkeeseen',0),(266849,7413,'no','PO utstedt',0),(266850,7413,'da','PO udstedt',0),(266851,7413,'ko','PO ë°œí–‰',0),(266852,7413,'he','×¤×• ×©×”×•× ×¤×§×•',0),(266853,7413,'el','PO Ï€Î¿Ï… ÎµÎºÎ´Î¯Î´Î¿Î½Ï„Î±Î¹',0),(266854,7413,'zh','è®¢å•å‘å¸ƒ\r\n',0),(266855,7413,'sv','PO utfÃ¤rdat',0),(266856,7413,'it','PO rilasciato',0),(266857,7413,'tl','',0),(266858,7413,'th','&#3605;&#3637;&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(266859,7413,'hi','à¤œà¤¾à¤°à¥€ à¤•à¤¿à¤ à¤—à¤ à¤ªà¥‹',0),(266860,7413,'ms','PO yang dikeluarkan',0),(266861,7413,'ar','Ø¨Ùˆ ØµØ§Ø¯Ø±',0),(266862,7413,'fr','PO a publiÃ©',0),(266863,7413,'jp','ç™ºè¡Œã•ã‚ŒãŸ PO',0),(266864,7413,'pt','PO emitido',0),(266865,7413,'ru','PO Ð¸Ð·Ð´Ð°Ð»',0),(266866,7413,'es','OC Emitido',0),(266867,7413,'de','PO ausgestellt',0),(266868,7413,'en','PO Issued',0),(266869,7414,'is','',0),(266870,7414,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚ ',0),(266871,7414,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚ ',0),(266872,7414,'tr','Bekleyen PO',0),(266873,7414,'pl','PO oczekiwaniu',0),(266874,7414,'bg','PO Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ',0),(266875,7414,'ur','Ù¾Ùˆ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(266876,7414,'sr','ÐŸÐž Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(266877,7414,'vi','ÄÆ¡n mua hÃ ng Ä‘ang treo',0),(266878,7414,'af','AB Afwagtend',0),(266879,7414,'ro','PO Ã®n aÅŸteptarea',0),(266880,7414,'et','PO kuni',0),(266881,7414,'si','PO priÄakovanju',0),(266882,7414,'ba','PO tertunda',0),(266883,7414,'nl','PO in afwachting van',0),(266884,7414,'fi','PO vireillÃ¤',0),(266885,7414,'no','PO venter',0),(266886,7414,'da','PO indtil',0),(266887,7414,'ko','ë³´ë¥˜ ì¤‘ì¸ í¬',0),(266888,7414,'he','×¤×• ×ž×ž×ª×™× ×™×',0),(266889,7414,'el','PO ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î®',0),(266890,7414,'zh','å®å¾…å®š\r\n',0),(266891,7414,'sv','PO i avvaktan',0),(266892,7414,'it','PO in sospeso',0),(266893,7414,'tl','',0),(266894,7414,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(266895,7414,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤ªà¥‹',0),(266896,7414,'ms','PO yang belum selesai',0),(266897,7414,'ar','Øµ. Ø¨ Ø§Ù†ØªØ¸Ø§Ø±',0),(266898,7414,'fr','PO en attente',0),(266899,7414,'jp','ä¿ç•™ä¸­ã®æ³¨æ–‡',0),(266900,7414,'pt','PO pendentes',0),(266901,7414,'ru','PO Ð´Ð¾',0),(266902,7414,'es','OC Pendiente',0),(266903,7414,'de','PO bis',0),(266904,7414,'en','PO Pending',0),(266905,7415,'is','',0),(266906,7415,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(266907,7415,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(266908,7415,'tr','Miktar iÃ§in yeni PO',0),(266909,7415,'pl','IloÅ›Ä‡ na nowe PO',0),(266910,7415,'bg','ÐšÐ¾Ð»-Ð²Ð¾ Ð·Ð° Ð½Ð¾Ð²Ð¸ PO',0),(266911,7415,'ur','Ù†Ø¦ÛŒ Ù¾ÙˆØ³Ù¹ Ú©ÛŒ Ù‚ÛŒ',0),(266912,7415,'sr','ÐšÐ¾Ð» Ð·Ð° Ð½Ð¾Ð²Ð¸ ÐŸÐ¾Ð°',0),(266913,7415,'vi','Sá»‘ lÆ°á»£ng cho Ä‘Æ¡n mua hÃ ng má»›i',0),(266914,7415,'af','Hoev. vir Nuwe AB',0),(266915,7415,'ro','Cantit pentru noi PO',0),(266916,7415,'et','Uus PO kogus',0),(266917,7415,'si','KoliÄina za novo PO',0),(266918,7415,'ba','Qty untuk PO baru',0),(266919,7415,'nl','Aantal voor nieuwe PO',0),(266920,7415,'fi','MÃ¤Ã¤rÃ¤ uuden PO',0),(266921,7415,'no','Antall for nye PO',0),(266922,7415,'da','Antal for nye PO',0),(266923,7415,'ko','ìƒˆ ì‚¬ì„œí•¨ì— ëŒ€ í•œ ìˆ˜ëŸ‰',0),(266924,7415,'he','×›×ž×•×ª ×¢×‘×•×¨ ×”×–×ž× ×ª ×¨×›×© ×—×“×©',0),(266925,7415,'el','Qty Î³Î¹Î± Î½Î­Î± PO',0),(266926,7415,'zh','æ–°è®¢å•æ•°é‡\r\n',0),(266927,7415,'sv','Kvt fÃ¶r nya PO',0),(266928,7415,'it','Qty per nuovo PO',0),(266929,7415,'tl','',0),(266930,7415,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(266931,7415,'hi','à¤¨à¤ˆ à¤ªà¥‹ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(266932,7415,'ms','Qty bagi PO baru',0),(266933,7415,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ù„Ø¨Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯',0),(266934,7415,'fr','QuantitÃ© pour nouveau PO',0),(266935,7415,'jp','æ–°ã—ã„ PO ã®æ•°é‡',0),(266936,7415,'pt','Qtde de novo PO',0),(266937,7415,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð´Ð»Ñ Ð½Ð¾Ð²Ñ‹Ñ… PO',0),(266938,7415,'es','Cant. para Nuevo OC',0),(266939,7415,'de','Menge fÃ¼r neue PO',0),(266940,7415,'en','Qty for New PO',0),(266941,7416,'is','',0),(266942,7416,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØªØ¹Ù‡Ø¯ ',0),(266943,7416,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØªØ¹Ù‡Ø¯ ',0),(266944,7416,'tr','Miktar iÃ§in kaydetme',0),(266945,7416,'pl','IloÅ›Ä‡ do popeÅ‚nienia',0),(266946,7416,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¸Ð·Ð²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ',0),(266947,7416,'ur','Ù‚ÛŒ Ú©Ø±ØªÛ’ Ú©Û’ Ù„Ø¦Û’',0),(266948,7416,'sr','ÐšÐ¾Ð» Ð·Ð° Ð¿Ð¾Ñ…Ñ€Ð°ÑšÐ¸Ð²Ð°ÑšÐµ',0),(266949,7416,'vi','Sá»‘ lÆ°á»£ng Ä‘á»ƒ cam káº¿t',0),(266950,7416,'af','Hoev. om toe te vertrou',0),(266951,7416,'ro','Cantit sÄƒ comitÄƒ',0),(266952,7416,'et','Kogus kinnitamine',0),(266953,7416,'si','KoliÄina za uveljavitev',0),(266954,7416,'ba','Qty commit',0),(266955,7416,'nl','Aantal naar Commit',0),(266956,7416,'fi','MÃ¤Ã¤rÃ¤ toteutuksen',0),(266957,7416,'no','Ant Ã¥ begÃ¥',0),(266958,7416,'da','Antal til at begÃ¥',0),(266959,7416,'ko','ì»¤ë°‹ì— ìˆ˜ëŸ‰',0),(266960,7416,'he','×›×ž×•×ª ×›×“×™ ×œ×”×ª×—×™×™×‘',0),(266961,7416,'el','Qty Î½Î± Î´Î¹Î±Ï€ÏÎ¬Î¾Î¿Ï…Î½',0),(266962,7416,'zh','æ•°é‡ä»¥æäº¤\r\n',0),(266963,7416,'sv','Kvt att begÃ¥',0),(266964,7416,'it','Q. tÃ  di Commit',0),(266965,7416,'tl','',0),(266966,7416,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;&#3651;&#3627;&#3657;',0),(266967,7416,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§',0),(266968,7416,'ms','Qty untuk melakukan perbuatan keji',0),(266969,7416,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø¥Ù„Ù‰ Ø§Ø±ØªÙƒØ§Ø¨',0),(266970,7416,'fr','QtÃ© de Commit',0),(266971,7416,'jp','ã‚³ãƒŸãƒƒãƒˆã™ã‚‹æ•°é‡',0),(266972,7416,'pt','Qtde de Commit',0),(266973,7416,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð´Ð»Ñ Ñ„Ð¸ÐºÑÐ°Ñ†Ð¸Ð¸',0),(266974,7416,'es','Cant. para Comprometer',0),(266975,7416,'de','Qty Commit',0),(266976,7416,'en','Qty to Commit',0),(266977,7417,'is','',0),(266978,7417,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ù†ÙˆØ² Ù‚Ø·Ø¹ÙŠ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(266979,7417,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ù†ÙˆØ² Ù‚Ø·Ø¹ÙŠ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(266980,7417,'tr','HenÃ¼z karar toplam',0),(266981,7417,'pl','Sumie nie zdecydowaÅ‚ jeszcze',0),(266982,7417,'bg','Ð’ÑÐµ Ð¾Ñ‰Ðµ Ð½Ðµ ÑÐ° Ñ€ÐµÑˆÐ¸Ð»Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(266983,7417,'ur','Ú©Ù„ Ú©Ø§ ÙÛŒØµÙ„Û Ø§Ø¨Ú¾ÛŒ Ù†ÛÛŒÚº Ú©ÛŒØ§',0),(266984,7417,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ñ˜Ð¾Ñˆ Ð½Ð¸Ñ˜Ðµ Ð¾Ð´Ð»ÑƒÑ‡Ð¸Ð»Ð°',0),(266985,7417,'vi','Tá»•ng cá»™ng chÆ°a quyáº¿t Ä‘á»‹nh',0),(266986,7417,'af','Totaal Nog nie oor Besluit',0),(266987,7417,'ro','Total nu a fost Ã®ncÄƒ decis',0),(266988,7417,'et','Kokku ei ole veel otsustatud',0),(266989,7417,'si','Vsota, ki se Å¡e ni odloÄil',0),(266990,7417,'ba','Total belum memutuskan',0),(266991,7417,'nl','Totaal nog niet besloten',0),(266992,7417,'fi','YhteensÃ¤ ei vielÃ¤ pÃ¤Ã¤tetty',0),(266993,7417,'no','Totalt ennÃ¥ ikke besluttet',0),(266994,7417,'da','Endnu ikke besluttet i alt',0),(266995,7417,'ko','ì´ ì•„ì§ ê²°ì •',0),(266996,7417,'he','×¡×” ×› ×¢×“×™×™×Ÿ ×œ× ×”×—×œ×™×˜',0),(266997,7417,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬, Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î±ÎºÏŒÎ¼Î· Î±Ï€Î¿Ï†Î±ÏƒÎ¯ÏƒÎµÎ¹',0),(266998,7417,'zh','å…±æœ‰è¿˜æœªå†³å®š\r\n',0),(266999,7417,'sv','Totalt Ã¤nnu inte beslutat',0),(267000,7417,'it','Totale non ancora deciso',0),(267001,7417,'tl','',0),(267002,7417,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3649;&#3609;&#3656;&#3609;&#3629;&#3609;',0),(267003,7417,'hi','à¤•à¥à¤² à¤…à¤­à¥€ à¤¤à¤• à¤¤à¤¯ à¤¨à¤¹à¥€à¤‚',0),(267004,7417,'ms','Jumlah yang belum lagi membuat keputusan',0),(267005,7417,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù„Ù… ØªÙ‚Ø±Ø±',0),(267006,7417,'fr','Total n\'a pas encore dÃ©cidÃ©',0),(267007,7417,'jp','ã¾ã æ±ºã‚ã¦ã„ãªã„ã®åˆè¨ˆ',0),(267008,7417,'pt','Total ainda nÃ£o decidida',0),(267009,7417,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ð¾ÐºÐ° Ð½Ðµ Ñ€ÐµÑˆÐ¸Ð»',0),(267010,7417,'es','Total Ya No Decidido',0),(267011,7417,'de','Insgesamt noch nicht entschieden',0),(267012,7417,'en','Total Not Yet Decided',0),(267013,7418,'is','',0),(267014,7418,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² ',0),(267015,7418,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² ',0),(267016,7418,'tr','Gerekli Toplam Mkt.',0),(267017,7418,'pl','CaÅ‚kowita iloÅ›Ä‡ potrzebnych',0),(267018,7418,'bg','ÐžÐ±Ñ‰Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸',0),(267019,7418,'ur','Ú©Ù„ Ù‚ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(267020,7418,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÐºÐ¾Ð» Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ',0),(267021,7418,'vi','Tá»•ng cá»™ng sá»‘ lÆ°á»£ng cáº§n',0),(267022,7418,'af','Totale Hoev. Benodig',0),(267023,7418,'ro','Cantitate totalÄƒ necesarÄƒ',0),(267024,7418,'et','Kokku kogus vaja',0),(267025,7418,'si','Skupna koliÄina potrebne',0),(267026,7418,'ba','Total Qty diperlukan',0),(267027,7418,'nl','Totale aantal nodig',0),(267028,7418,'fi','YhteensÃ¤ mÃ¤Ã¤rÃ¤ tarvitaan',0),(267029,7418,'no','Totalt antall nÃ¸dvendig',0),(267030,7418,'da','Samlede antal nÃ¸dvendige',0),(267031,7418,'ko','í•„ìš”í•œ ì´ ìˆ˜ëŸ‰',0),(267032,7418,'he','×¡×” ×› ×›×ž×•×ª ×¦×¨×™×›×”',0),(267033,7418,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(267034,7418,'zh','æ‰€éœ€æ€»æ•°é‡\r\n',0),(267035,7418,'sv','Totalt antal behÃ¶vs',0),(267036,7418,'it','Q. tÃ  totale necessaria',0),(267037,7418,'tl','',0),(267038,7418,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(267039,7418,'hi','à¤•à¥à¤² à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(267040,7418,'ms','Qty jumlah yang diperlukan',0),(267041,7418,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(267042,7418,'fr','Totale quantitÃ© nÃ©cessaire',0),(267043,7418,'jp','å¿…è¦ãªåˆè¨ˆæ•°é‡',0),(267044,7418,'pt','Qtde total necessÃ¡ria',0),(267045,7418,'ru','ÐžÐ±Ñ‰ÐµÐµ ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾Ðµ ÐšÐ¾Ð»-Ð²Ð¾',0),(267046,7418,'es','Cant. Total Necesitado',0),(267047,7418,'de','Total Qty erforderlich',0),(267048,7418,'en','Total Qty Needed',0),(267049,7419,'is','',0),(267050,7419,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(267051,7419,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(267052,7419,'tr','SatÄ±cÄ± SipariÅŸ numarasÄ±',0),(267053,7419,'pl','Numer zamÃ³wienia dostawcy',0),(267054,7419,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(267055,7419,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø±',0),(267056,7419,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(267057,7419,'vi','Sá»‘ Ä‘Æ¡n hÃ ng ngÆ°á»i bÃ¡n',0),(267058,7419,'af','Verskaffer Bestellingsnommer',0),(267059,7419,'ro','NumÄƒrul de ordine furnizorului',0),(267060,7419,'et','Tarnija tellimuse number',0),(267061,7419,'si','Å tevilko dobaviteljevega naloga',0),(267062,7419,'ba','Nomor pesanan Penjual',0),(267063,7419,'nl','Volgorde van leveranciersnummer',0),(267064,7419,'fi','Toimittajan laskun numeron',0),(267065,7419,'no','LeverandÃ¸rordrenummer',0),(267066,7419,'da','Kreditornummeret rÃ¦kkefÃ¸lge',0),(267067,7419,'ko','ê³µê¸‰ ì—…ì²´ ì£¼ë¬¸ ë²ˆí˜¸',0),(267068,7419,'he','×ž×¡×¤×¨ ×”×–×ž× ×” ×©×œ ×¡×¤×§',0),(267069,7419,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(267070,7419,'zh','ä¾›åº”å•†è®¢è´­çš„æ•°é‡\r\n',0),(267071,7419,'sv','LeverantÃ¶rens bestÃ¤llningsnummer',0),(267072,7419,'it','Numero ordine fornitore',0),(267073,7419,'tl','',0),(267074,7419,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(267075,7419,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(267076,7419,'ms','Nombor pesanan Penjual',0),(267077,7419,'ar','Ø±Ù‚Ù… ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(267078,7419,'fr','NumÃ©ro de commande du vendeur',0),(267079,7419,'jp','ä»•å…¥å…ˆã®é †åºç•ªå·',0),(267080,7419,'pt','NÃºmero de ordem de fornecedor',0),(267081,7419,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð—Ð°ÐºÐ°Ð·Ð° ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(267082,7419,'es','Proveedor NÃºmero de Orden',0),(267083,7419,'de','Kreditor-Bestellnummer',0),(267084,7419,'en','Vendor Order Number',0),(267085,7420,'is','',0),(267086,7420,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(267087,7420,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(267088,7420,'tr','YapÄ± sipariÅŸi numarasÄ±',0),(267089,7420,'pl','BudowaÄ‡ numer zamÃ³wienia',0),(267090,7420,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(267091,7420,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ú©ÛŒ ØªØ¹Ù…ÛŒØ±',0),(267092,7420,'sr','Ð ÐµÐ´ Ð±Ñ€Ð¾Ñ˜ Ð¸Ð·Ð´Ð°ÑšÐ°',0),(267093,7420,'vi','Sá»‘ ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(267094,7420,'af','Bou orde nommer',0),(267095,7420,'ro','Construi numÄƒrul de ordine',0),(267096,7420,'et','Ehitada jÃ¤rjekorranumber',0),(267097,7420,'si','Graditi Å¡tevilka naloga',0),(267098,7420,'ba','Membangun nomor pesanan',0),(267099,7420,'nl','Ordernummer van de build',0),(267100,7420,'fi','Rakentaa numero',0),(267101,7420,'no','Bygge ordrenummer',0),(267102,7420,'da','Bygge ordrenummer',0),(267103,7420,'ko','ë¹Œë“œ ìˆœì„œ ë²ˆí˜¸',0),(267104,7420,'he','×œ×‘× ×•×ª ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(267105,7420,'el','ÎŸÎ¹ÎºÎ¿Î´Î¿Î¼Î®ÏƒÎ¿Ï…Î¼Îµ Î±ÏÎ¾Ï‰Î½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(267106,7420,'zh','æž„å»ºé¡ºåºç¼–å·\r\n',0),(267107,7420,'sv','Bygga ordernummer',0),(267108,7420,'it','Costruire il numero d\'ordine',0),(267109,7420,'tl','',0),(267110,7420,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(267111,7420,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(267112,7420,'ms','Membina nombor pesanan',0),(267113,7420,'ar','Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨',0),(267114,7420,'fr','Ordre numÃ©ro de build',0),(267115,7420,'jp','ãƒ“ãƒ«ãƒ‰é †åºç•ªå·',0),(267116,7420,'pt','NÃºmero de ordem da compilaÃ§Ã£o',0),(267117,7420,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° ÑÐ±Ð¾Ñ€ÐºÐ¸',0),(267118,7420,'es','Numero de Orden de ConstrucciÃ³n',0),(267119,7420,'de','Bestellnummer zu bauen',0),(267120,7420,'en','Build Order Number',0),(267121,7421,'is','',0),(267122,7421,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙˆØ±Ø¯ Ø§Ù†ØªØ¸Ø§Ø± ',0),(267123,7421,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙˆØ±Ø¯ Ø§Ù†ØªØ¸Ø§Ø± ',0),(267124,7421,'tr','Beklenen kullanÄ±m',0),(267125,7421,'pl','Przewidywane wykorzystanie',0),(267126,7421,'bg','ÐžÑ‡Ð°ÐºÐ²Ð°Ð½Ð¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ',0),(267127,7421,'ur','Ù…ØªÙˆÙ‚Ø¹ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(267128,7421,'sr','ÐžÑ‡ÐµÐºÐ¸Ð²Ð°Ð½Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(267129,7421,'vi','Sá»­ dá»¥ng mong Ä‘á»£i',0),(267130,7421,'af','Verwagte Gebruik',0),(267131,7421,'ro','Utilizare preconizatÄƒ',0),(267132,7421,'et','Eeldatav kasutamine',0),(267133,7421,'si','PriÄakovano uporabo',0),(267134,7421,'ba','Diharapkan penggunaan',0),(267135,7421,'nl','Verwachte gebruik',0),(267136,7421,'fi','KÃ¤yttÃ¶',0),(267137,7421,'no','Forventet bruk',0),(267138,7421,'da','Forventede brug',0),(267139,7421,'ko','ì˜ˆìƒëœ ì‚¬ìš©',0),(267140,7421,'he','×”×©×™×ž×•×© ×”×¦×¤×•×™',0),(267141,7421,'el','Î‘Î½Î±Î¼ÎµÎ½ÏŒÎ¼ÎµÎ½Î· Ï‡ÏÎ®ÏƒÎ·',0),(267142,7421,'zh','é¢„è®¡ä½¿ç”¨\r\n',0),(267143,7421,'sv','FÃ¶rvÃ¤ntad anvÃ¤ndning',0),(267144,7421,'it','Uso previsto',0),(267145,7421,'tl','',0),(267146,7421,'th','&#3588;&#3634;&#3604;&#3627;&#3623;&#3633;&#3591;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;',0),(267147,7421,'hi','à¤…à¤ªà¥‡à¤•à¥à¤·à¤¿à¤¤ à¤‰à¤ªà¤¯à¥‹à¤—',0),(267148,7421,'ms','Dijangka penggunaan',0),(267149,7421,'ar','Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…ØªÙˆÙ‚Ø¹',0),(267150,7421,'fr','Utilisation prÃ©vue',0),(267151,7421,'jp','äºˆæƒ³ã•ã‚Œã‚‹ä½¿ç”¨',0),(267152,7421,'pt','Uso esperado',0),(267153,7421,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ð»Ð°Ð³Ð°ÐµÐ¼Ð¾Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(267154,7421,'es','Uso Esperado',0),(267155,7421,'de','Erwartete Nutzung',0),(267156,7421,'en','Expected Use',0),(267157,7422,'is','',0),(267158,7422,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ÙØ¹Ù„ÙŠ ØªÙˆÙ„ÙŠØ¯ Ø´Ø¯Ù‡ ',0),(267159,7422,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ ÙØ¹Ù„ÙŠ ØªÙˆÙ„ÙŠØ¯ Ø´Ø¯Ù‡ ',0),(267160,7422,'tr','Yeni asÄ±l Ana maddeler Ã¼retilen',0),(267161,7422,'pl','Nowy mistrz przedmioty produkowane',0),(267162,7422,'bg','ÐÐ¾Ð²Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð°Ñ‚Ð° Ð¼Ð°Ð¹ÑÑ‚Ð¾Ñ€ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð¿Ñ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð¸',0),(267163,7422,'ur','Ù†Ø¦ÛŒ Ø§ØµÙ„ Ù…Ø§Ø³Ù¹Ø± Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ù¾ÛŒØ¯Ø§ÙˆØ§Ø±',0),(267164,7422,'sr','ÐÐ¾Ð²Ð¸ ÑÑ‚Ð²Ð°Ñ€Ð½Ð¸Ñ… Ð³Ð¾ÑÐ¿Ð¾Ð´Ð°Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð¸Ñ…',0),(267165,7422,'vi','Sá»‘ lÆ°á»£ng hÃ ng chá»§ thá»±c táº¿ sáº£n xuáº¥t má»›i',0),(267166,7422,'af','Nuwe Werklike Meester Items Vervaardig',0),(267167,7422,'ro','Elemente Master realÄƒ noi produse',0),(267168,7422,'et','Uus tegelik kapten kaubad toodetakse',0),(267169,7422,'si','Proizvaja nove dejanske elemente Master',0),(267170,7422,'ba','Item Master sebenarnya baru diproduksi',0),(267171,7422,'nl','Nieuwe werkelijke stramienitems geproduceerd',0),(267172,7422,'fi','Todellinen mestari uutuuksia tuotettu',0),(267173,7422,'no','Nye faktiske malobjekter produsert',0),(267174,7422,'da','Nye faktiske masterelementer produceret',0),(267175,7422,'ko','ìƒˆë¡œìš´ ì‹¤ì œ ë§ˆìŠ¤í„° ì œí’ˆ ìƒì‚°',0),(267176,7422,'he','×¤×¨×™×˜×™× ×—×“×©×™× ×ž××¡×˜×¨ ×‘×¤×•×¢×œ ×”×ž×™×•×¦×¨',0),(267177,7422,'el','ÎÎ­Î± Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® Master ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(267178,7422,'zh','äº§ç”Ÿçš„æ–°å®žé™…ç®¡ç†é¡¹ç›®\r\n',0),(267179,7422,'sv','Nya faktiska mallobjekt produceras',0),(267180,7422,'it','Prodotto nuovi elementi effettivi del Master',0),(267181,7422,'tl','',0),(267182,7422,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3621;&#3633;&#3585;&#3607;&#3637;&#3656;&#3649;&#3607;&#3657;&#3592;&#3619;&#3636;&#3591;&#3586;&#3638;&#3657;&#3609;&#3651;&#3627;&#3617;&#3656;',0),(267183,7422,'hi','à¤¨à¤ à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤µà¤¸à¥à¤¤à¥à¤“à¤‚ à¤•à¤¾ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¨ à¤•à¤¿à¤¯à¤¾',0),(267184,7422,'ms','Item induk sebenar baru dihasilkan',0),(267185,7422,'ar','Ø¥Ù†ØªØ§Ø¬ Ø§Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ø§Ù„ÙØ¹Ù„ÙŠØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(267186,7422,'fr','MaÃ®tre rÃ©elles nouveautÃ©s produit',0),(267187,7422,'jp','æ–°ã—ã„å®Ÿéš›ã®ãƒžã‚¹ã‚¿ãƒ¼ ã‚¢ã‚¤ãƒ†ãƒ ã‚’ç”Ÿç”£',0),(267188,7422,'pt','Novos itens-mestre real produzido',0),(267189,7422,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¼Ð°ÑÑ‚ÐµÑ€ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð°',0),(267190,7422,'es','Nuevos Items Maestro Actuales Producidos',0),(267191,7422,'de','Neue tatsÃ¤chliche Musterseitenobjekte produziert',0),(267192,7422,'en','New Actual Master Items Produced',0),(267193,7423,'is','',0),(267194,7423,'dr','Ø³ÙØ§Ø±Ø´ Ø§ÙƒÙ†ÙˆÙ† ÙƒØ§Ù…Ù„ Ø§Ø³Øª ',0),(267195,7423,'pr','Ø³ÙØ§Ø±Ø´ Ø§ÙƒÙ†ÙˆÙ† ÙƒØ§Ù…Ù„ Ø§Ø³Øª ',0),(267196,7423,'tr','Åžimdi tam sÄ±rasÄ±',0),(267197,7423,'pl','ZamÃ³wienie teraz kompletny',0),(267198,7423,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° ÑÐµÐ³Ð° Ð¿ÑŠÐ»Ð½Ð°',0),(267199,7423,'ur','Ø§Ø¨ Ù…Ú©Ù…Ù„ ØªØ±ØªÛŒØ¨',0),(267200,7423,'sr','Ð ÐµÐ´ Ñ˜Ðµ ÑÐ°Ð´Ð° Ð·Ð°Ð²Ñ€ÑˆÐµÐ½',0),(267201,7423,'vi','Äáº·t hÃ ng bÃ¢y giá» hoÃ n táº¥t',0),(267202,7423,'af','Bestelling Nou Voltooi',0),(267203,7423,'ro','Comanda acum complet',0),(267204,7423,'et','Et nÃ¼Ã¼d tÃ¤ielik',0),(267205,7423,'si','Naloga zdaj popolna',0),(267206,7423,'ba','Order sekarang lengkap',0),(267207,7423,'nl','Orde nu compleet',0),(267208,7423,'fi','Tilaa nyt valmis',0),(267209,7423,'no','Bestill nÃ¥ fullfÃ¸rt',0),(267210,7423,'da','Bestil nu komplet',0),(267211,7423,'ko','ì£¼ë¬¸ ì§€ê¸ˆ ì™„ë£Œ',0),(267212,7423,'he','×¡×“×¨ ×ž×œ× ×¢×›×©×™×•',0),(267213,7423,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï„ÏŽÏÎ± Ï€Î»Î®ÏÎ·',0),(267214,7423,'zh','çŽ°åœ¨å·²å®Œæˆè®¢å•\r\n',0),(267215,7423,'sv','Order nu komplett',0),(267216,7423,'it','Ordine ora completa',0),(267217,7423,'tl','',0),(267218,7423,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(267219,7423,'hi','à¤‘à¤°à¥à¤¡à¤° à¤…à¤¬ à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤—à¤¯à¤¾',0),(267220,7423,'ms','Perintah yang kini lengkap',0),(267221,7423,'ar','Ø£Ù…Ø± Ø§Ù„Ø¢Ù† ÙƒØ§Ù…Ù„Ø©',0),(267222,7423,'fr','Commander maintenant complÃ¨te',0),(267223,7423,'jp','ä»Šå®Œå…¨ãªé †åº',0),(267224,7423,'pt','Ordem agora completa',0),(267225,7423,'ru','Ð¢ÐµÐ¿ÐµÑ€ÑŒ Ð¿Ð¾Ð»Ð½Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(267226,7423,'es','Ordenar Ahora Completo',0),(267227,7423,'de','Bestellung jetzt vollstÃ¤ndig',0),(267228,7423,'en','Order Now Complete',0),(267229,7424,'is','',0),(267230,7424,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ',0),(267231,7424,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø¹ÙˆÙ‚ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ',0),(267232,7424,'tr','Bu sÄ±rada bekleyen PO',0),(267233,7424,'pl','Czasu PO tym porzÄ…dek',0),(267234,7424,'bg','Ð’Ð¸ÑÑÑ‰Ð¸ Ð¿Ð¾ Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(267235,7424,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ù…ÛŒÚº Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§ Ù¾Ùˆ',0),(267236,7424,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ ÐŸÐž Ð¾Ð²Ð¾Ð¼ Ð½Ð°Ð»Ð¾Ð³Ñƒ',0),(267237,7424,'vi','ÄÆ¡n mua hÃ ng cá»§a Ä‘Æ¡n hÃ ng nÃ y chÆ°a cÃ³',0),(267238,7424,'af','Afwagtend AB Hierdie Bestelling',0),(267239,7424,'ro','ÃŽn aÅŸteptarea PO aceastÄƒ ordine',0),(267240,7424,'et','Ootel PO selles jÃ¤rjekorras',0),(267241,7424,'si','Teku PO tem vrstnem redu',0),(267242,7424,'ba','PO Pending Order ini',0),(267243,7424,'nl','In behandeling PO deze bestelling',0),(267244,7424,'fi','Odottava PO tÃ¤ssÃ¤ jÃ¤rjestyksessÃ¤',0),(267245,7424,'no','Ventende PO denne rekkefÃ¸lgen',0),(267246,7424,'da','Ventende PO denne rÃ¦kkefÃ¸lge',0),(267247,7424,'ko','ë³´ë¥˜ ì¤‘ì¸ í¬ê°€ì´ ìˆœì„œ',0),(267248,7424,'he','×¤×• ×ª×œ×•×™ ×•×¢×•×ž×“ ×¦×• ×–×”',0),(267249,7424,'el','PO ÎµÎºÎºÏÎµÎ¼ÎµÎ¯ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬',0),(267250,7424,'zh','å¾…åŠžè®¢å•æœ¬å‘½ä»¤\r\n',0),(267251,7424,'sv','VÃ¤ntande PO denna ordning',0),(267252,7424,'it','PO in sospeso questo ordine',0),(267253,7424,'tl','',0),(267254,7424,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3',0),(267255,7424,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤ªà¥‹ à¤‡à¤¸ à¤‘à¤°à¥à¤¡à¤°',0),(267256,7424,'ms','Belum selesai PO Perintah ini',0),(267257,7424,'ar','Ù…Ø¹Ù„Ù‚Ø© Øµ. Ø¨ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(267258,7424,'fr','PO en attente cette ordonnance',0),(267259,7424,'jp','ä¿ç•™ä¸­ã® PO ã“ã®é †åº',0),(267260,7424,'pt','PO pendente nesta ordem',0),(267261,7424,'ru','Ð”Ð¾ PO ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(267262,7424,'es','OC Pendiente Este Orden',0),(267263,7424,'de','Ausstehenden PO dieser Reihenfolge',0),(267264,7424,'en','Pending PO This Order',0),(267265,7425,'is','',0),(267266,7425,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª',0),(267267,7425,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª',0),(267268,7425,'tr','Emir rapor yapÄ±',0),(267269,7425,'pl','Tworzenie zamÃ³wienia raportu',0),(267270,7425,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(267271,7425,'ur','ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(267272,7425,'sr','Ð˜Ð·Ñ€Ð°Ð´Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(267273,7425,'vi','BÃ¡o CÃ¡o ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(267274,7425,'af','Geboude Bestellingsverslag',0),(267275,7425,'ro','Construi comenzi raport',0),(267276,7425,'et','Ehitada tellimuste aruanne',0),(267277,7425,'si','Zgradite poroÄilo naloge',0),(267278,7425,'ba','Membuat Laporan Pesanan',0),(267279,7425,'nl','Orders rapport maken',0),(267280,7425,'fi','Rakentaa Tilaukset-raportti',0),(267281,7425,'no','Bygge ordrene rapporten',0),(267282,7425,'da','Bygge ordrer rapport',0),(267283,7425,'ko','ì£¼ë¬¸ ë³´ê³ ì„œ ìž‘ì„±',0),(267284,7425,'he','×œ×‘× ×•×ª ×“×•×— ×”×–×ž× ×•×ª',0),(267285,7425,'el','ÎŸÎ¹ÎºÎ¿Î´Î¿Î¼Î®ÏƒÎ¿Ï…Î¼Îµ Î±Î½Î±Ï†Î¿ÏÎ¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(267286,7425,'zh','å»ºç«‹è®¢å•æŠ¥è¡¨\r\n',0),(267287,7425,'sv','Bygga rapport',0),(267288,7425,'it','Compilare Report ordini',0),(267289,7425,'tl','',0),(267290,7425,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(267291,7425,'hi','à¤†à¤¦à¥‡à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(267292,7425,'ms','Membina laporan pesanan',0),(267293,7425,'ar','Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ ØªÙ‚Ø±ÙŠØ± Ø£ÙˆØ§Ù…Ø±',0),(267294,7425,'fr','Construire le rapport de commandes',0),(267295,7425,'jp','æ³¨æ–‡ã®ãƒ¬ãƒãƒ¼ãƒˆã‚’ä½œæˆã—ã¾ã™ã€‚',0),(267296,7425,'pt','Criar relatÃ³rio de ordens',0),(267297,7425,'ru','ÐŸÐ¾ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(267298,7425,'es','Informe de Ordenes de ConstrucciÃ³n',0),(267299,7425,'de','Bestellbericht zu bauen',0),(267300,7425,'en','Build Orders Report',0),(267301,7426,'is','',0),(267302,7426,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(267303,7426,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(267304,7426,'tr','Hata alma yapÄ± sipariÅŸ bilgileri',0),(267305,7426,'pl','BÅ‚Ä…d pobierania budowaÄ‡ kolejnoÅ›Ä‡ informacji',0),(267306,7426,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð‘Ð¸Ð»Ð´',0),(267307,7426,'ur','Ù†Ù‚Øµ Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ ØªØ¹Ù…ÛŒØ± ØªØ±ØªÛŒØ¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(267308,7426,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð‘ÑƒÐ¸Ð»Ð´ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð¸',0),(267309,7426,'vi','Lá»—i khi truy váº¥n thÃ´ng tin ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(267310,7426,'af','Fout met Herwinning van Geboude Bestellings Inligting',0),(267311,7426,'ro','Eroare recuperare construi ordine Info',0),(267312,7426,'et','TÃµrge allalaadimisel ehitada ostu Info',0),(267313,7426,'si','Napaka pri pridobivanju graditi nalog Info',0),(267314,7426,'ba','Kesalahan mengambil membangun Info pesanan',0),(267315,7426,'nl','Fout ophalen Build Order Info',0),(267316,7426,'fi','Virhe noudettaessa rakentaa Tilaustiedot',0),(267317,7426,'no','Feil hente bygge bestilling Info',0),(267318,7426,'da','Fejl under hentning af opbygge ordre Info',0),(267319,7426,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ë¹Œë“œ ìˆœì„œ ì •ë³´',0),(267320,7426,'he','×©×’×™××” ×‘××—×–×•×¨ ×œ×‘× ×•×ª ×¡×“×¨ ×¤×¨×˜×™',0),(267321,7426,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· ÏƒÏ†Î¬Î»Î¼Î±',0),(267322,7426,'zh','é”™è¯¯æ£€ç´¢æž„å»ºé¡ºåºä¿¡æ¯',0),(267323,7426,'sv','Fel hÃ¤mtar bygga bestÃ¤lla information',0),(267324,7426,'it','Errore recuperando compilazione ordine Info',0),(267325,7426,'tl','',0),(267326,7426,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3',0),(267327,7426,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¬à¤¿à¤²à¥à¤¡ à¤•à¥à¤°à¤® à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤ªà¥à¤¨à¤ƒà¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(267328,7426,'ms','Ralat mendapatkan semula membina susunan maklumat',0),(267329,7426,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù… Ø¨Ù†Ø§Ø¡',0),(267330,7426,'fr','Erreur rÃ©cupÃ©rer Build Order Info',0),(267331,7426,'jp','ã‚¨ãƒ©ãƒ¼ã‚’å–å¾—ã™ã‚‹ãƒ“ãƒ«ãƒ‰é †åºæƒ…å ±',0),(267332,7426,'pt','Erro Recuperando compilar informaÃ§Ãµes de ordem',0),(267333,7426,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ñ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð·Ð°ÐºÐ°Ð·Ðµ',0),(267334,7426,'es','Error Recogiendo Info de Orden de ConstrucciÃ³n',0),(267335,7426,'de','Fehler beim Abrufen Build Bestellinfo',0),(267336,7426,'en','Error Retrieving Build Order Info',0),(267337,7427,'is','',0),(267338,7427,'dr','ÙƒØ¯Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(267339,7427,'pr','ÙƒØ¯Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(267340,7427,'tr','Hangi gruba dahil',0),(267341,7427,'pl','To co Grupa',0),(267342,7427,'bg','ÐšÐ¾Ñ Ð³Ñ€ÑƒÐ¿Ð°',0),(267343,7427,'ur','Ø¬Ùˆ Ú¯Ø±ÙˆÙ¾ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(267344,7427,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ¾Ñ˜Ð¾Ñ˜ Ð³Ñ€ÑƒÐ¿Ð¸',0),(267345,7427,'vi','Bao gá»“m nhÃ³m nÃ o',0),(267346,7427,'af','Insluitend Watter Groep',0),(267347,7427,'ro','Includ Grupa care',0),(267348,7427,'et','Millise grupi hulka',0),(267349,7427,'si','VkljuÄujejo katero skupino',0),(267350,7427,'ba','Termasuk yang kelompok',0),(267351,7427,'nl','Omvatten welke groep',0),(267352,7427,'fi','MikÃ¤ ryhmÃ¤',0),(267353,7427,'no','Ta hvilken gruppe',0),(267354,7427,'da','Omfatte hvilken gruppe',0),(267355,7427,'ko','ê·¸ë£¹ í¬í•¨',0),(267356,7427,'he','×›×•×œ×œ×™× ×œ××™×–×• ×§×‘×•×¦×”',0),(267357,7427,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï€Î¿Î¹Î± Î¿Î¼Î¬Î´Î±',0),(267358,7427,'zh','åŒ…æ‹¬å“ªä¸ªç»„\r\n',0),(267359,7427,'sv','Vilken grupp',0),(267360,7427,'it','Quale gruppo di includere',0),(267361,7427,'tl','',0),(267362,7427,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3652;&#3627;&#3609;',0),(267363,7427,'hi','à¤œà¥‹ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(267364,7427,'ms','Termasuk Kumpulan yang',0),(267365,7427,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„ØªÙŠ',0),(267366,7427,'fr','Comprendre quel groupe',0),(267367,7427,'jp','ã©ã®ã‚°ãƒ«ãƒ¼ãƒ—ã‚’å«ã‚ã‚‹',0),(267368,7427,'pt','Incluem o grupo ao qual',0),(267369,7427,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ ÐšÐ°ÐºÐ¸Ðµ Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(267370,7427,'es','Incluir CuÃ¡l Grupo',0),(267371,7427,'de','Welcher Gruppe gehÃ¶ren',0),(267372,7427,'en','Include Which Group',0),(267373,7428,'is','',0),(267374,7428,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨ÙƒØ§Ø± Ø¨Ø±Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ Ø¨Ø±Ø§ÙŠ',0),(267375,7428,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨ÙƒØ§Ø± Ø¨Ø±Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ Ø¨Ø±Ø§ÙŠ',0),(267376,7428,'tr','Kategori iÃ§in geÃ§erlidir.',0),(267377,7428,'pl','Kategoria odnosi siÄ™ do',0),(267378,7428,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÑÐµ Ð¾Ñ‚Ð½Ð°ÑÑ Ð·Ð°',0),(267379,7428,'ur','Ø²Ù…Ø±Û Ú©Û’ Ù„ÛŒÛ’ Ù„Ø§Ú¯Ùˆ ÛÙˆØªØ§ ÛÛ’',0),(267380,7428,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° ÑÐµ Ð¾Ð´Ð½Ð¾ÑÐ¸ Ð½Ð°',0),(267381,7428,'vi','Thá»ƒ Loáº¡i Ãp dá»¥ng cho',0),(267382,7428,'af','Kategorie geld vir',0),(267383,7428,'ro','Categorie se aplicÄƒ',0),(267384,7428,'et','Kategooria rakendub',0),(267385,7428,'si','Kategorija se nanaÅ¡a na',0),(267386,7428,'ba','Kategori berlaku untuk',0),(267387,7428,'nl','Categorie is van toepassing op',0),(267388,7428,'fi','Luokka koskee',0),(267389,7428,'no','Kategorien gjelder',0),(267390,7428,'da','Kategori gÃ¦lder for',0),(267391,7428,'ko','ë²”ì£¼ì— ì ìš© ë©ë‹ˆë‹¤.',0),(267392,7428,'he','×§×˜×’×•×¨×™×” ×—×œ',0),(267393,7428,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î¹ÏƒÏ‡ÏÎµÎ¹ Î³Î¹Î±',0),(267394,7428,'zh','åˆ†ç±»é€‚ç”¨äºŽ\r\n',0),(267395,7428,'sv','Kategori gÃ¤ller',0),(267396,7428,'it','Categoria si applica alle',0),(267397,7428,'tl','',0),(267398,7428,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3651;&#3594;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(267399,7428,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(267400,7428,'ms','Kategori yang diguna pakai untuk',0),(267401,7428,'ar','ÙˆÙŠÙ†Ø·Ø¨Ù‚ Ø¹Ù„Ù‰ Ø§Ù„ÙØ¦Ø©',0),(267402,7428,'fr','CatÃ©gorie s\'applique aux',0),(267403,7428,'jp','ã‚«ãƒ†ã‚´ãƒªã«é©ç”¨ã•ã‚Œã¾ã™ã€‚',0),(267404,7428,'pt','Categoria aplica-se a',0),(267405,7428,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÐžÑ‚Ð½Ð¾ÑÐ¸Ñ‚ÑÑ Ðš',0),(267406,7428,'es','CategorÃ­a Aplica A',0),(267407,7428,'de','Kategorie bezieht sich auf',0),(267408,7428,'en','Category Applies To',0),(267409,7429,'is','',0),(267410,7429,'dr','ÙˆÙŠØ±Ø§ÙŠØ´  Ø§ØªÙ†Ø®Ø§Ø¨ Ø¬Ø¹Ø¨Ù‡  Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(267411,7429,'pr','ÙˆÙŠØ±Ø§ÙŠØ´  Ø§ØªÙ†Ø®Ø§Ø¨ Ø¬Ø¹Ø¨Ù‡  Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(267412,7429,'tr','SeÃ§in kutusu seÃ§eneklerini DÃ¼zenle',0),(267413,7429,'pl','Zaznacz pole opcji Edytuj',0),(267414,7429,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ð»ÐµÑ‚Ð¾ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(267415,7429,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Ø¨Ø§Ú©Ø³ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(267416,7429,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(267417,7429,'vi','Sá»­a Há»™p Lá»±a Chá»n',0),(267418,7429,'af','Redigeer Seleksie Boks Opsies',0),(267419,7429,'ro','Edita caseta de selectare opÅ£iuni',0),(267420,7429,'et','Redigeerimiseks valige suvandid',0),(267421,7429,'si','Uredi moÅ¾nosti izberite polje',0),(267422,7429,'ba','Edit Pilih kotak pilihan',0),(267423,7429,'nl','Select Box bewerkingsopties',0),(267424,7429,'fi','Valitse valintaruutu muokkaustilaan',0),(267425,7429,'no','Redigere Velg alternativer',0),(267426,7429,'da','Redigere VÃ¦lg indstillinger',0),(267427,7429,'ko','ì„ íƒ ìƒìž ì˜µì…˜ íŽ¸ì§‘',0),(267428,7429,'he','×¢×¨×™×›×ª ××¤×©×¨×•×™×•×ª ×ª×™×‘×ª ×‘×—×™×¨×”',0),(267429,7429,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(267430,7429,'zh','ç¼–è¾‘é€‰æ‹©æ¡†é€‰é¡¹\r\n',0),(267431,7429,'sv','Redigera VÃ¤lj alternativ',0),(267432,7429,'it','Modificare le opzioni della casella di selezione',0),(267433,7429,'tl','',0),(267434,7429,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3621;&#3656;&#3629;&#3591;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(267435,7429,'hi','à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤¬à¥‰à¤•à¥à¤¸ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(267436,7429,'ms','Kotak Pilih opsyen Edit',0),(267437,7429,'ar','ØªØ­Ø±ÙŠØ± Ø®ÙŠØ§Ø±Ø§Øª Ø­Ø¯Ø¯ Ø®Ø§Ù†Ø©',0),(267438,7429,'fr','Modifier les Options de la boÃ®te de sÃ©lection',0),(267439,7429,'jp','[é¸æŠž] ãƒœãƒƒã‚¯ã‚¹ã®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(267440,7429,'pt','Editar opÃ§Ãµes de caixa de seleÃ§Ã£o',0),(267441,7429,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð»Ðµ',0),(267442,7429,'es','Editar Opciones de Caja Seleccionada',0),(267443,7429,'de','WÃ¤hlen Sie im Feld Optionen bearbeiten',0),(267444,7429,'en','Edit Select Box Options',0),(267445,7430,'is','',0),(267446,7430,'dr','Ø«Ø¨Øª Ù†ÙˆØ¹',0),(267447,7430,'pr','Ø«Ø¨Øª Ù†ÙˆØ¹',0),(267448,7430,'tr','GiriÅŸ tÃ¼rÃ¼',0),(267449,7430,'pl','Typ wpisu',0),(267450,7430,'bg','Ð’Ð¸Ð´ Ð·Ð°Ð¿Ð¸Ñ',0),(267451,7430,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù‚Ø³Ù…',0),(267452,7430,'sr','Ð’Ñ€ÑÑ‚Ð° ÑÑ‚Ð°Ð²ÐºÐµ',0),(267453,7430,'vi','Loáº¡i Entry',0),(267454,7430,'af','Inskrywing Tipe',0),(267455,7430,'ro','Tipul de intrare',0),(267456,7430,'et','Kande liik',0),(267457,7430,'si','Vrsta postavke',0),(267458,7430,'ba','Jenis entri',0),(267459,7430,'nl','Boekingssoort',0),(267460,7430,'fi','Tapahtumatyyppi',0),(267461,7430,'no','OppfÃ¸ringstype',0),(267462,7430,'da','Posttypen',0),(267463,7430,'ko','í•­ëª© ìœ í˜•',0),(267464,7430,'he','×¡×•×’ ×¢×¨×š',0),(267465,7430,'el','Î¤ÏÏ€Î¿Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(267466,7430,'zh','æ¡ç›®ç±»åž‹',0),(267467,7430,'sv','Transaktionstypen',0),(267468,7430,'it','Tipo di voce',0),(267469,7430,'tl','',0),(267470,7430,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;',0),(267471,7430,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(267472,7430,'ms','Jenis kemasukan',0),(267473,7430,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(267474,7430,'fr','Type d\'entrÃ©e',0),(267475,7430,'jp','ã‚¨ãƒ³ãƒˆãƒªã®ç¨®é¡ž',0),(267476,7430,'pt','Tipo de entrada',0),(267477,7430,'ru','Ð¢Ð¸Ð¿ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(267478,7430,'es','Tipo de Entrada',0),(267479,7430,'de','Eintragstyp',0),(267480,7430,'en','Entry Type',0),(267481,7431,'is','',0),(267482,7431,'dr','30 Ø¹Ø¯Ø¯ Ù…Ø­Ø¯ÙˆØ¯ Ù…ÙŠ Ø´ÙˆÙ†Ø¯ ',0),(267483,7431,'pr','Ø§Ú¯Ø± Ù†ÙˆØ¹ Ø«Ø¨Øª Ù…ØªÙ† Ø¨Ø§Ø´Ø¯ â€“ ÙƒØ§Ø±Ø§ÙƒØªØ±Ù‡Ø§ÙŠ ÙˆØ±ÙˆØ¯ÙŠ ØªØ§ 30 Ø¹Ø¯Ø¯ Ù…Ø­Ø¯ÙˆØ¯ Ù…ÙŠ Ø´ÙˆÙ†Ø¯ ',0),(267484,7431,'tr','EÄŸer giriÅŸ tÃ¼rÃ¼ metin, 30 giriÅŸ karakter sayÄ±sÄ±nÄ± sÄ±nÄ±rla',0),(267485,7431,'pl','JeÅ›li typ zapisu to tekst, ograniczenie wprowadzania znakÃ³w do 30',0),(267486,7431,'bg','ÐÐºÐ¾ \"Ð²Ð¸Ð´ Ð·Ð°Ð¿Ð¸Ñ\" Ðµ Ñ‚ÐµÐºÑÑ‚, Ð»Ð¸Ð¼Ð¸Ñ‚ Ð²Ñ…Ð¾Ð´ ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¸ Ð´Ð¾ 30',0),(267487,7431,'ur','Ø§Ú¯Ø± Ù‚Ø³Ù… Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…ØªÙ†ØŒ Ø­Ø¯ Ø§Ù† Ù¾Ù¹ Ø­Ø±ÙˆÙ 30 ØªÚ© ÛÛ’ Û”',0),(267488,7431,'sr','ÐÐºÐ¾ Ñ˜Ðµ Ð²Ñ€ÑÑ‚Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ñ‚ÐµÐºÑÑ‚Ð°, Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÑšÐµ Ð·Ð° ÑƒÐ½Ð¾Ñ Ð·Ð½Ð°ÐºÐ¾Ð²Ð° Ð½Ð° 30',0),(267489,7431,'vi','Náº¿u Loáº¡i Entry lÃ  Text chá»‰ Ä‘Æ°á»£c phÃ©p nháº­p tá»‘i Ä‘a 30 kÃ½ tá»±',0),(267490,7431,'af','Indien Inskrywingstipe Teks is, Beperk invoerkarakters tot 20',0),(267491,7431,'ro','DacÄƒ tipul de intrare este Text, caractere de intrare limitÄƒ-30',0),(267492,7431,'et','Kui kande liik on tekst, piira sisend mÃ¤rkide 30',0),(267493,7431,'si','ÄŒe je vrsta postavke besedila, omejitev vnosa znakov za 30',0),(267494,7431,'ba','Apakah jenis catatan teks, batas Input karakter 30',0),(267495,7431,'nl','Als boekingssoort tekst, limiet Input tekens tot en met 30',0),(267496,7431,'fi','Jos tapahtumatyyppi on teksti, raja syÃ¶ttÃ¤Ã¤ aakkonen 30',0),(267497,7431,'no','Hvis posttypen er tekst, Begrens Input tegn til 30',0),(267498,7431,'da','Hvis posttypen er tekst, Limit Input tegn til 30',0),(267499,7431,'ko','í•­ëª© í˜•ì‹ì´ í…ìŠ¤íŠ¸, 30 ì œí•œ ìž…ë ¥ ë¬¸ìž',0),(267500,7431,'he','×× ×¡×•×’ ×”×¢×¨×š ×”×•× ×˜×§×¡×˜, ×ž×’×‘×œ×ª ×ª×•×•×™× ×§×œ×˜ ×œ- 30',0),(267501,7431,'el','Î‘Î½ Î¿ Ï„ÏÏ€Î¿Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ¯Î¼ÎµÎ½Î¿, ÏŒÏÎ¹Î¿ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÎµÏ‚ ÏƒÎµ 30',0),(267502,7431,'zh','å¦‚æžœæ¡ç›®ç±»åž‹æ˜¯æ–‡æœ¬ï¼Œé™åˆ¶è¾“å…¥30ä¸ªæ±‰å­—\r\n',0),(267503,7431,'sv','Om transaktionstypen Ã¤r Text, grÃ¤ns Input tecken till 30',0),(267504,7431,'it','Se il tipo di voce Ã¨ testo, i caratteri di Input di limite a 30',0),(267505,7431,'tl','',0),(267506,7431,'th','&#3606;&#3657;&#3634;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3648;&#3611;&#3655;&#3609;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;, &#3585;&#3635;&#3627;&#3609;&#3604;&#3651;&#3627;&#3657;&#3651;&#3626;&',0),(267507,7431,'hi','à¤¯à¤¦à¤¿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¤¾à¤ , 30 à¤•à¥‹ à¤‡à¤¨à¤ªà¥à¤Ÿ à¤µà¤°à¥à¤£ à¤¸à¥€à¤®à¤¾ à¤¹à¥ˆ',0),(267508,7431,'ms','Jika jenis kemasukan teks, aksara Input had 30',0),(267509,7431,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† \"Ù†ÙˆØ¹ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„\" Ù‡Ùˆ Ø§Ù„Ù†ØµØŒ \"Ø£Ø­Ø±Ù Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰\" Ø¥Ù„Ù‰ 30',0),(267510,7431,'fr','Si le Type d\'entrÃ©e est le texte, les caractÃ¨res d\'entrÃ©e limite Ã  30',0),(267511,7431,'jp','ã‚¨ãƒ³ãƒˆãƒªã®ç¨®é¡žãƒ†ã‚­ã‚¹ãƒˆå ´åˆã¯ã€30 ã‚’å…¥åŠ›æ–‡å­—æ•°åˆ¶é™ã§ã™ã€‚',0),(267512,7431,'pt','Se o tipo de entrada Ã© texto, caracteres de entrada limite de 30',0),(267513,7431,'ru','Ð•ÑÐ»Ð¸ Ñ‚Ð¸Ð¿ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ñ‚ÐµÐºÑÑ‚, Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸Ðµ Ð²Ð²Ð¾Ð´Ð° ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¾Ð² Ð´Ð¾ 30',0),(267514,7431,'es','Si Tipo de Entrada es Texto, Limitar nÃºmero de carÃ¡cteres a 30',0),(267515,7431,'de','Wenn Eintragstyp Limit Eingabe Zeichen bis 30',0),(267516,7431,'en','If Entry Type is Text, Limit Input Characters to 30',0),(267517,7432,'is','',0),(267518,7432,'dr','ÙÙŠÙ„Ø¯ Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ù„Ø§ ',0),(267519,7432,'pr','ÙÙŠÙ„Ø¯ Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ù„Ø§ ',0),(267520,7432,'tr','Madde hareketi ayrÄ±ntÄ± alanlarÄ±',0),(267521,7432,'pl','Pozycja pola szczegÃ³Å‚Ã³w transakcji',0),(267522,7432,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¿Ð¾Ð»ÐµÑ‚Ð°Ñ‚Ð° Ñ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸',0),(267523,7432,'ur','Ø´Û’ Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† ØªÙØµÛŒÙ„ Ù‚Ø·Ø¹Ø§Øª',0),(267524,7432,'sr','ÐŸÐ¾Ñ™Ð° ÑÐ° Ð´ÐµÑ‚Ð°Ñ™Ð¸Ð¼Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(267525,7432,'vi','TrÆ°á»ng chi tiáº¿t giao dá»‹ch hÃ ng',0),(267526,7432,'af','Item Transaksie Detailvelde',0),(267527,7432,'ro','Element tranzacÅ£ie detaliu cÃ¢mpuri',0),(267528,7432,'et','Kauba kande Ã¼ksikasjad vÃ¤ljad',0),(267529,7432,'si','Element polja s podrobnostmi transakcije',0),(267530,7432,'ba','Item transaksi Detail bidang',0),(267531,7432,'nl','Item transactie detailvelden',0),(267532,7432,'fi','Nimikkeen tapahtuman yksityiskohtakenttiÃ¤',0),(267533,7432,'no','Elementet transaksjonen detaljfelt',0),(267534,7432,'da','Vare transaktion detaljefelter',0),(267535,7432,'ko','í•­ëª© íŠ¸ëžœìž­ì…˜ ì„¸ë¶€ ì •ë³´ í•„ë“œ',0),(267536,7432,'he','×¤×¨×™×˜ ×¢×¡×§×ª ×¤×™×¨×•×˜ ×©×“×•×ª',0),(267537,7432,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Ï€ÎµÎ´Î¯Î± Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½',0),(267538,7432,'zh','ç‰©å“äº¤æ˜“æ˜Žç»†å­—æ®µ\r\n',0),(267539,7432,'sv','Objektet transaktionen detaljfÃ¤lt',0),(267540,7432,'it','Campi elemento di dettaglio delle transazioni',0),(267541,7432,'tl','',0),(267542,7432,'th','&#3615;&#3636;&#3621;&#3604;&#3660;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(267543,7432,'hi','à¤†à¤‡à¤Ÿà¤® à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤«à¤¼à¥€à¤²à¥à¤¡à¥ à¤¸',0),(267544,7432,'ms','Butiran transaksi terperinci bidang',0),(267545,7432,'ar','Ø¹Ù†ØµØ± Ø§Ù„Ø­Ø±ÙƒØ© Ø­Ù‚ÙˆÙ„ Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(267546,7432,'fr','Champs d\'Ã©lÃ©ment de dÃ©tail Transaction',0),(267547,7432,'jp','å“ç›®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è©³ç´°ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(267548,7432,'pt','Campos de detalhes de transaÃ§Ã£o de item',0),(267549,7432,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¿Ð¾Ð»Ñ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð² Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(267550,7432,'es','Item TransacciÃ³n Campos de Detalle',0),(267551,7432,'de','Element Transaktion Detailfelder',0),(267552,7432,'en','Item Transaction Detail Fields',0),(267553,7433,'is','',0),(267554,7433,'dr','ÙÙŠÙ„Ø¯ Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ù„Ø§ ',0),(267555,7433,'pr','ÙÙŠÙ„Ø¯ Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ù„Ø§ ',0),(267556,7433,'tr','Madde hareket alanÄ±',0),(267557,7433,'pl','Przedmiot transakcji pole',0),(267558,7433,'bg','ÐŸÐ¾Ð»Ðµ Ð·Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(267559,7433,'ur','Ø´Û’ Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† Ù‚Ø·Ø¹Û',0),(267560,7433,'sr','ÐŸÐ¾Ñ™Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(267561,7433,'vi','TrÆ°á»ng giao dá»‹ch hÃ ng',0),(267562,7433,'af','Item Transaksie Veld',0),(267563,7433,'ro','CÃ¢mp de tranzacÅ£ie element',0),(267564,7433,'et','Kauba kande vÃ¤li',0),(267565,7433,'si','Element transakcije polje',0),(267566,7433,'ba','Item transaksi Field',0),(267567,7433,'nl','Item transactie veld',0),(267568,7433,'fi','Nimikkeen tapahtumatekstikenttÃ¤Ã¤n',0),(267569,7433,'no','Transaksjonen elementfelt',0),(267570,7433,'da','Vare transaktion felt',0),(267571,7433,'ko','ì•„ì´í…œ ê±°ëž˜ ë¶„ì•¼',0),(267572,7433,'he','×¤×¨×™×˜ ×¢×¡×§×ª ×©×“×”',0),(267573,7433,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Ï€ÎµÎ´Î¯Î¿',0),(267574,7433,'zh','ç‰©å“äº¤æ˜“å­—æ®µ\r\n',0),(267575,7433,'sv','FÃ¤ltet artikeln transaktion',0),(267576,7433,'it','Campo elemento di transazione',0),(267577,7433,'tl','',0),(267578,7433,'th','&#3615;&#3636;&#3621;&#3604;&#3660;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(267579,7433,'hi','à¤†à¤‡à¤Ÿà¤® à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(267580,7433,'ms','Butiran transaksi Field',0),(267581,7433,'ar','Ø­Ù‚Ù„ Ø¹Ù†ØµØ± Ø§Ù„Ø­Ø±ÙƒØ©',0),(267582,7433,'fr','Champ d\'Ã©lÃ©ment de Transaction',0),(267583,7433,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³é …ç›®',0),(267584,7433,'pt','Campo de item de transaÃ§Ã£o',0),(267585,7433,'ru','ÐŸÐ¾Ð»Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(267586,7433,'es','Item TransacciÃ³n Campo ',0),(267587,7433,'de','Artikel Transaktionsfeld',0),(267588,7433,'en','Item Transaction Field',0),(267589,7434,'is','',0),(267590,7434,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø§Ù…',0),(267591,7434,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø§Ù…',0),(267592,7434,'tr','SeÃ§im adÄ±',0),(267593,7434,'pl','WybÃ³r nazwy',0),(267594,7434,'bg','Ð˜Ð¼Ðµ Ð·Ð° ÑÐµÐºÑ†Ð¸ÑÑ‚Ð°',0),(267595,7434,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø§ Ù†Ø§Ù…',0),(267596,7434,'sr','Ð˜Ð·Ð±Ð¾Ñ€ Ð¸Ð¼ÐµÐ½Ð°',0),(267597,7434,'vi','TÃªn lá»±a chá»n',0),(267598,7434,'af','Seleksie Naam',0),(267599,7434,'ro','Nume de selecÅ£ie',0),(267600,7434,'et','Valik nime',0),(267601,7434,'si','Izbira ime',0),(267602,7434,'ba','Pemilihan nama',0),(267603,7434,'nl','Selectie naam',0),(267604,7434,'fi','Valinnan nimi',0),(267605,7434,'no','Alternativet',0),(267606,7434,'da','Valg af navn',0),(267607,7434,'ko','ì„ íƒ ì´ë¦„',0),(267608,7434,'he','×©× ×‘×—×™×¨×”',0),(267609,7434,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚',0),(267610,7434,'zh','é€‰æ‹©åç§°\r\n',0),(267611,7434,'sv','Alternativets namn',0),(267612,7434,'it','Selezione nome',0),(267613,7434,'tl','',0),(267614,7434,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3594;&#3639;&#3656;&#3629;',0),(267615,7434,'hi','à¤šà¤¯à¤¨ à¤¨à¤¾à¤®',0),(267616,7434,'ms','Nama pilihan',0),(267617,7434,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø§Ø³Ù…',0),(267618,7434,'fr','Nom de la sÃ©lection',0),(267619,7434,'jp','é¸æŠžå',0),(267620,7434,'pt','Nome da seleÃ§Ã£o',0),(267621,7434,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð’Ñ‹Ð±Ð¾Ñ€Ð°',0),(267622,7434,'es','Nombre de SelecciÃ³n',0),(267623,7434,'de','Auswahlnamen',0),(267624,7434,'en','Selection Name',0),(267625,7435,'is','',0),(267626,7435,'dr','(ØªÙ„ÙˆÙŠØ²ÙŠÙˆÙ†',0),(267627,7435,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¬Ø¹Ø¨Ù‡ (ØªÙ„ÙˆÙŠØ²ÙŠÙˆÙ†',0),(267628,7435,'tr','Kutusunu seÃ§in',0),(267629,7435,'pl','Zaznacz pole',0),(267630,7435,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ð»Ðµ',0),(267631,7435,'ur','Ø®Ø§Ù†Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(267632,7435,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ð¾Ñ€ Ð·Ð°',0),(267633,7435,'vi','Lá»±a chá»n há»™p',0),(267634,7435,'af','Kies die blokkie',0),(267635,7435,'ro','SelectaÅ£i caseta',0),(267636,7435,'et','Valige lahter',0),(267637,7435,'si','Izberite polje',0),(267638,7435,'ba','Pilih kotak',0),(267639,7435,'nl','Het selectievakje',0),(267640,7435,'fi','Valitse, jos',0),(267641,7435,'no','Merk',0),(267642,7435,'da','VÃ¦lg afkrydsningsfeltet',0),(267643,7435,'ko','ìƒìž ì„ íƒ',0),(267644,7435,'he','×‘×—×¨ ×§×•×¤×¡×',0),(267645,7435,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿',0),(267646,7435,'zh','é€‰æ‹©æ¡†\r\n',0),(267647,7435,'sv','Markera kryssrutan',0),(267648,7435,'it','Selezionare la casella',0),(267649,7435,'tl','',0),(267650,7435,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3621;&#3656;&#3629;&#3591;',0),(267651,7435,'hi','à¤¬à¥‰à¤•à¥à¤¸ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(267652,7435,'ms','Pilih kotak',0),(267653,7435,'ar','Ø­Ø¯Ø¯ Ù…Ø±Ø¨Ø¹',0),(267654,7435,'fr','SÃ©lectionnez la case',0),(267655,7435,'jp','ãƒœãƒƒã‚¯ã‚¹ã‚’ã‚ªãƒ³ã«',0),(267656,7435,'pt','Selecione a caixa',0),(267657,7435,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð»Ðµ',0),(267658,7435,'es','Seleccionar Caja',0),(267659,7435,'de','Aktivieren Sie das',0),(267660,7435,'en','Select Box',0),(267661,7436,'is','',0),(267662,7436,'dr','ÙÙŠÙ„Ø¯ Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ù„Ø§ ',0),(267663,7436,'pr','ÙÙŠÙ„Ø¯ Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ù„Ø§ ',0),(267664,7436,'tr','Madde hareketi ayrÄ±ntÄ± alanÄ±',0),(267665,7436,'pl','Element pole szczegÃ³Å‚Ã³w transakcji',0),(267666,7436,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ð¿Ð¾Ð»Ðµ',0),(267667,7436,'ur','Ø´Û’ Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† ØªÙØµÛŒÙ„ Ù‚Ø·Ø¹Û',0),(267668,7436,'sr','ÐŸÐ¾Ñ™Ðµ Ð´ÐµÑ‚Ð°Ñ™Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(267669,7436,'vi','TrÆ°á»ng chi tiáº¿t giao dá»‹ch hÃ ng',0),(267670,7436,'af','Item Transaksie Detailveld',0),(267671,7436,'ro','Element tranzacÅ£ie detaliu cÃ¢mp',0),(267672,7436,'et','Ãœksuse tehingut Ã¼ksikasjavÃ¤li',0),(267673,7436,'si','Polje s podrobnostmi element transakcije',0),(267674,7436,'ba','Item transaksi Detail Field',0),(267675,7436,'nl','Item transactie detailveld',0),(267676,7436,'fi','Nimikkeen tapahtuman yksityiskohtakenttÃ¤',0),(267677,7436,'no','Elementet transaksjonen detaljfelt',0),(267678,7436,'da','Vare transaktion detaljefelt',0),(267679,7436,'ko','í•­ëª© íŠ¸ëžœìž­ì…˜ ì„¸ë¶€ ì •ë³´ í•„ë“œ',0),(267680,7436,'he','×©×“×” ×¤×™×¨×•×˜ ×ª× ×•×¢×ª ×¤×¨×™×˜',0),(267681,7436,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Ï€ÎµÎ´Î¯Î¿ Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½',0),(267682,7436,'zh','ç‰©å“äº¤æ˜“æ˜Žç»†å­—æ®µ\r\n',0),(267683,7436,'sv','Objektet transaktionen detaljfÃ¤lt',0),(267684,7436,'it','Campo elemento di dettaglio delle transazioni',0),(267685,7436,'tl','',0),(267686,7436,'th','&#3615;&#3636;&#3621;&#3604;&#3660;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(267687,7436,'hi','à¤†à¤‡à¤Ÿà¤® à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(267688,7436,'ms','Butiran transaksi terperinci bidang',0),(267689,7436,'ar','Ø­Ù‚Ù„ Ø§Ù„ØªÙØµÙŠÙ„ Ø¹Ù†ØµØ± Ø§Ù„Ø­Ø±ÙƒØ©',0),(267690,7436,'fr','Champ d\'Ã©lÃ©ment de dÃ©tail Transaction',0),(267691,7436,'jp','å“ç›®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è©³ç´°ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(267692,7436,'pt','Campo de detalhes de transaÃ§Ã£o de item',0),(267693,7436,'ru','ÐŸÐ¾Ð»Ðµ Ð´ÐµÑ‚Ð°Ð»ÐµÐ¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(267694,7436,'es','Item TransacciÃ³n Campo de Detalle',0),(267695,7436,'de','Element Transaktion Detailfeld',0),(267696,7436,'en','Item Transaction Detail Field',0),(267697,7437,'is','',0),(267698,7437,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙÙŠÙ„Ø¯ Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ù„Ø§ ',0),(267699,7437,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙÙŠÙ„Ø¯ Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø¹Ø§Ù…Ù„Ù‡ ÙƒØ§Ù„Ø§ ',0),(267700,7437,'tr','Madde hareketi ayrÄ±ntÄ± alanÄ± ekleme',0),(267701,7437,'pl','Dodaj pole szczegÃ³Å‚Ã³w przedmiotu transakcji',0),(267702,7437,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ð¿Ð¾Ð»Ðµ',0),(267703,7437,'ur','Ø´Û’ Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† ØªÙØµÛŒÙ„ Ù‚Ø·Ø¹Û Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(267704,7437,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ™Ð° Ð´ÐµÑ‚Ð°Ñ™Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(267705,7437,'vi','ThÃªm trÆ°á»ng chi tiáº¿t giao dá»‹ch hÃ ng',0),(267706,7437,'af','Item Transaksie Detailveld Skep',0),(267707,7437,'ro','Adauga postul tranzacÅ£ie detaliu cÃ¢mp',0),(267708,7437,'et','Ãœksuse tehingut Ã¼ksikasjavÃ¤li lisamine',0),(267709,7437,'si','Dodajte element polje s podrobnostmi transakcije',0),(267710,7437,'ba','Tambahkan item transaksi Detail Field',0),(267711,7437,'nl','Item transactie detailveld toevoegen',0),(267712,7437,'fi','Nimikkeen tapahtuman yksityiskohtakentÃ¤n lisÃ¤Ã¤minen',0),(267713,7437,'no','Elementet transaksjonen detaljfelt legge',0),(267714,7437,'da','Vare transaktion detaljefelt tilfÃ¸je',0),(267715,7437,'ko','í•­ëª© íŠ¸ëžœìž­ì…˜ ì„¸ë¶€ í•„ë“œ ì¶”ê°€',0),(267716,7437,'he','×”×•×¡×£ ×¤×¨×™×˜ ×ª× ×•×¢×” ×¤×¨×˜ ×©×“×”',0),(267717,7437,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÎµÎ´Î¯Î¿ Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®',0),(267718,7437,'zh','ç‰©å“äº¤æ˜“æ˜Žç»†å­—æ®µæ·»åŠ \r\n',0),(267719,7437,'sv','LÃ¤gga till objekt transaktionen detaljfÃ¤lt',0),(267720,7437,'it','Aggiungi campo elemento di dettaglio delle transazioni',0),(267721,7437,'tl','',0),(267722,7437,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3615;&#3636;&#3621;&#3604;&#3660;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3619;&#3634;&#3618;&#3585;&#3',0),(267723,7437,'hi','à¤†à¤‡à¤Ÿà¤® à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤µà¤¿à¤µà¤°à¤£ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(267724,7437,'ms','Tambah butiran transaksi terperinci bidang',0),(267725,7437,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ù‚Ù„ Ø§Ù„ØªÙØµÙŠÙ„ Ø¹Ù†ØµØ± Ø§Ù„Ø­Ø±ÙƒØ©',0),(267726,7437,'fr','Ajouter champ d\'Ã©lÃ©ment de dÃ©tail Transaction',0),(267727,7437,'jp','å“ç›®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è©³ç´°ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(267728,7437,'pt','Adicionar o campo de detalhes de transaÃ§Ã£o de item',0),(267729,7437,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð»Ðµ Ð´ÐµÑ‚Ð°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(267730,7437,'es','Item TransacciÃ³n Campo de Detalle Y',0),(267731,7437,'de','Element Transaktion Detailfeld hinzufÃ¼gen',0),(267732,7437,'en','Item Transaction Detail Field Add',0),(267733,7438,'is','',0),(267734,7438,'dr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† Ø«Ø¨Øª Ø­Ø°Ù Ø´Ø¯Ù‡',0),(267735,7438,'pr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† Ø«Ø¨Øª Ø­Ø°Ù Ø´Ø¯Ù‡',0),(267736,7438,'tr','Silinen giriÅŸini etkinleÅŸtir',0),(267737,7438,'pl','UaktywniÄ‡ usuniÄ™tej wpis',0),(267738,7438,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚ Ð·Ð°Ð¿Ð¸Ñ',0),(267739,7438,'ur','Ø­Ø°Ù Ø´Ø¯Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(267740,7438,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(267741,7438,'vi','KÃ­ch Hoáº¡t Entry ÄÃ£ XÃ³a',0),(267742,7438,'af','Aktiveer Verwyderde Inskrywing',0),(267743,7438,'ro','Activeaza intrare stearsa',0),(267744,7438,'et','Aktiveeri kustutatud kanne',0),(267745,7438,'si','Aktiviranje izbrisati vnos',0),(267746,7438,'ba','Mengaktifkan Penghapusan Entri',0),(267747,7438,'nl','Activeer verwijderde invoer',0),(267748,7438,'fi','Aktivoi poistettu merkintÃ¤',0),(267749,7438,'no','Aktivere slettet oppfÃ¸ring',0),(267750,7438,'da','Aktivere slettet post',0),(267751,7438,'ko','ì‚­ì œ ëœ í•­ëª© í™œì„±í™”',0),(267752,7438,'he','×œ×”×¤×¢×™×œ ××ª ×”×¢×¨×š ×©× ×ž×—×§',0),(267753,7438,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î· Î´Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î· ÎµÎ³Î³ÏÎ±Ï†Î®',0),(267754,7438,'zh','æ¿€æ´»å·²åˆ é™¤æ¡ç›®\r\n',0),(267755,7438,'sv','Aktivera borttagna posten',0),(267756,7438,'it','Attiva informazioni cancellate',0),(267757,7438,'tl','',0),(267758,7438,'th','&#3648;&#3611;&#3636;&#3604;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3621;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(267759,7438,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(267760,7438,'ms','Mengaktifkan penyertaan dihapuskan',0),(267761,7438,'ar','ØªÙ†Ø´ÙŠØ· Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ù…Ø­Ø°ÙˆÙØ©',0),(267762,7438,'fr','Activer EntrÃ©e SupprimÃ©',0),(267763,7438,'jp','å‰Šé™¤æ¸ˆã¿ã‚¨ãƒ³ãƒˆãƒªã‚’ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã«ã—ã¾ã™ã€‚',0),(267764,7438,'pt','Ativar entrada excluÃ­da',0),(267765,7438,'ru','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(267766,7438,'es','Activar Entrada Eliminada',0),(267767,7438,'de','GelÃ¶schten Eintrag zu aktivieren',0),(267768,7438,'en','Activate Deleted Entry',0),(267769,7439,'is','',0),(267770,7439,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙŠØ§ Ù…Ø§Ø±Ùƒ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯  ',0),(267771,7439,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙŠØ§ Ù…Ø§Ø±Ùƒ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯  ',0),(267772,7439,'tr','Yeni satÄ±nalma boyutu veya marka ekleme',0),(267773,7439,'pl','DodaÄ‡ nowy rozmiar zakupu lub marki',0),(267774,7439,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð¸Ð»Ð¸ Ð¼Ð°Ñ€ÐºÐ°',0),(267775,7439,'ur','Ù†Ø¦ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø³Ø§Ø¦Ø² ÛŒØ§ Ø¨Ø±Ø§Ù†Úˆ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(267776,7439,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð¸Ð»Ð¸ Ð±Ñ€ÐµÐ½Ð´',0),(267777,7439,'vi','ThÃªm Sá»‘ LÆ°á»£ng Hay ThÆ°Æ¡ng Hiá»‡u Äáº·t HÃ ng Má»›i',0),(267778,7439,'af','Nuwe Aankoopgrootte of Handelsmerk Byvoeg',0),(267779,7439,'ro','Adauga noua mÄƒrime de cumpÄƒrare sau de Brand',0),(267780,7439,'et','Lisa uus ostu suurus vÃµi brÃ¤ndi',0),(267781,7439,'si','Dodaj nov nakup velikosti ali blagovno znamko',0),(267782,7439,'ba','Menambahkan baru pembelian ukuran atau merek',0),(267783,7439,'nl','Nieuwe aankoop grootte of merk toevoegen',0),(267784,7439,'fi','LisÃ¤Ã¤ uuden osto koon tai tuotemerkin',0),(267785,7439,'no','Legge til nye KjÃ¸p stÃ¸rrelsen eller merke',0),(267786,7439,'da','TilfÃ¸je nye kÃ¸b stÃ¸rrelse eller mÃ¦rke',0),(267787,7439,'ko','ìƒˆë¡œìš´ êµ¬ë§¤ í¬ê¸° ë˜ëŠ” ë¸Œëžœë“œë¥¼ ì¶”ê°€',0),(267788,7439,'he','×”×•×¡×¤×ª ×’×•×“×œ ×¨×›×© ×—×“×© ××• ×ž×•×ª×’',0),(267789,7439,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Î±Î³Î¿ÏÎ¬Ï‚ Î® ÎµÎ¼Ï€Î¿ÏÎ¹ÎºÏŒ ÏƒÎ®Î¼Î±',0),(267790,7439,'zh','å¢žåŠ æ–°çš„é‡‡è´­è§„æ¨¡æˆ–å“ç‰Œ\r\n',0),(267791,7439,'sv','LÃ¤gga till nya kÃ¶p storlek eller varumÃ¤rke',0),(267792,7439,'it','Aggiungere nuove dimensioni di acquisto o di marca',0),(267793,7439,'tl','',0),(267794,7439,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3609;&#3634;&#3604;&#3627;&#3619;&#3639;&#3629;&#3618;&#3637;&#3656;&#3627;&#3657;&#3629;&#3651;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(267795,7439,'hi','à¤¨à¤ˆ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤†à¤•à¤¾à¤° à¤¯à¤¾ à¤¬à¥à¤°à¤¾à¤‚à¤¡ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(267796,7439,'ms','Menambah saiz pembelian baru atau jenama',0),(267797,7439,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø¬Ù… Ø¬Ø¯ÙŠØ¯ Ù„Ù„Ø´Ø±Ø§Ø¡ Ø£Ùˆ Ø§Ù„Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ©',0),(267798,7439,'fr','Ajouter la nouvelle taille d\'achat ou de la marque',0),(267799,7439,'jp','æ–°ã—ã„ã‚µã‚¤ã‚ºã‚’è³¼å…¥ã¾ãŸã¯ãƒ–ãƒ©ãƒ³ãƒ‰ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(267800,7439,'pt','Adicionar nova compra tamanho ou marca',0),(267801,7439,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð¸Ð»Ð¸ Ð±Ñ€ÐµÐ½Ð´',0),(267802,7439,'es','Agregar Nueva Compra de TamaÃ±o o Marca',0),(267803,7439,'de','FÃ¼gen Sie neue kaufen-GrÃ¶ÃŸe oder Marke',0),(267804,7439,'en','Add New Purchase Size or Brand',0),(267805,7440,'is','',0),(267806,7440,'dr','Ø¢ÙŠØ§ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø§Ø³Øª',0),(267807,7440,'pr','Ø¢ÙŠØ§ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø§Ø³Øª',0),(267808,7440,'tr','VarsayÄ±lan deÄŸer',0),(267809,7440,'pl','Jest domyÅ›lnie',0),(267810,7440,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ðµ',0),(267811,7440,'ur','Ø·Û’ Ø´Ø¯Û ÛÛ’',0),(267812,7440,'sr','ÐˆÐµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾',0),(267813,7440,'vi','lÃ  máº·c Ä‘á»‹nh',0),(267814,7440,'af','Is Verstek',0),(267815,7440,'ro','Este implicit',0),(267816,7440,'et','Vaikimisi on',0),(267817,7440,'si','Je privzeto',0),(267818,7440,'ba','Standar',0),(267819,7440,'nl','Is standaard',0),(267820,7440,'fi','On oletus',0),(267821,7440,'no','Standard',0),(267822,7440,'da','Er standard',0),(267823,7440,'ko','ê¸°ë³¸ì€',0),(267824,7440,'he','×‘×¨×™×¨×ª ×ž×—×“×œ',0),(267825,7440,'el','Î•Î¯Î½Î±Î¹ Î· Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î®',0),(267826,7440,'zh','æ˜¯é»˜è®¤\r\n',0),(267827,7440,'sv','Ã„r standard',0),(267828,7440,'it','Ãˆ predefinito',0),(267829,7440,'tl','',0),(267830,7440,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(267831,7440,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¹à¥ˆ',0),(267832,7440,'ms','Adalah lalai',0),(267833,7440,'ar','Ù‡Ùˆ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(267834,7440,'fr','Est par dÃ©faut',0),(267835,7440,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã¯',0),(267836,7440,'pt','Ã‰ o padrÃ£o',0),(267837,7440,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(267838,7440,'es','Es por Defecto',0),(267839,7440,'de','Ist Standard',0),(267840,7440,'en','Is Default',0),(267841,7441,'is','',0),(267842,7441,'dr','ØªÙˆÙ„ÙŠØ¯ ÙƒÙ†Ù†Ø¯Ù‡  Ùˆ Ø¹Ù„Ø§Ù…Øª ØªØ¬Ø§Ø±ÙŠ',0),(267843,7441,'pr','ØªÙˆÙ„ÙŠØ¯ ÙƒÙ†Ù†Ø¯Ù‡  Ùˆ Ø¹Ù„Ø§Ù…Øª ØªØ¬Ø§Ø±ÙŠ',0),(267844,7441,'tr','Ãœretici veya marka',0),(267845,7441,'pl','Producent lub marki',0),(267846,7441,'bg','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ» Ð¸Ð»Ð¸ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ° Ð¼Ð°Ñ€ÐºÐ°',0),(267847,7441,'ur','Ù…ØµÙ†ÙˆØ¹Û Ú©Ø§Ø± ÛŒØ§ Ø¨Ø±Ø§Ù†Úˆ',0),(267848,7441,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡ Ð¸Ð»Ð¸ Ð±Ñ€ÐµÐ½Ð´',0),(267849,7441,'vi','NhÃ  sáº£n xuáº¥t hay thÆ°Æ¡ng hiá»‡u',0),(267850,7441,'af','Vervaardiger of Handelsmerk',0),(267851,7441,'ro','ProducÄƒtorul sau Brand',0),(267852,7441,'et','Tootja vÃµi tootja',0),(267853,7441,'si','Proizvajalca ali blagovno znamko',0),(267854,7441,'ba','Produsen atau merek',0),(267855,7441,'nl','Fabrikant of merk',0),(267856,7441,'fi','Valmistaja tai tuotemerkin',0),(267857,7441,'no','Produsenten eller merke',0),(267858,7441,'da','Fabrikanten eller mÃ¦rke',0),(267859,7441,'ko','ì œì¡°ì—…ì²´ ë˜ëŠ” ë¸Œëžœë“œ',0),(267860,7441,'he','×™×¦×¨×Ÿ ××• ×ž×•×ª×’',0),(267861,7441,'el','ÎšÎ±Ï„Î±ÏƒÎºÎµÏ…Î±ÏƒÏ„Î®Ï‚ Î® ÎµÎ¼Ï€Î¿ÏÎ¹ÎºÏŒ ÏƒÎ®Î¼Î±',0),(267862,7441,'zh','åˆ¶é€ å•†æˆ–å“ç‰Œ\r\n',0),(267863,7441,'sv','Tillverkaren eller varumÃ¤rke',0),(267864,7441,'it','Produttore o marchio',0),(267865,7441,'tl','',0),(267866,7441,'th','&#3612;&#3641;&#3657;&#3612;&#3621;&#3636;&#3605;&#3627;&#3619;&#3639;&#3629;&#3618;&#3637;&#3656;&#3627;&#3657;&#3629;',0),(267867,7441,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤¤à¤¾ à¤¯à¤¾ à¤¬à¥à¤°à¤¾à¤‚à¤¡',0),(267868,7441,'ms','Pengilang atau jenama',0),(267869,7441,'ar','Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ù…ØµÙ†Ø¹Ø© Ø£Ùˆ Ø§Ù„Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ©',0),(267870,7441,'fr','RÃ©fÃ©rence du fabricant ou la marque',0),(267871,7441,'jp','ãƒ–ãƒ©ãƒ³ãƒ‰ã‚„ãƒ¡ãƒ¼ã‚«ãƒ¼',0),(267872,7441,'pt','Fabricante ou marca',0),(267873,7441,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒ Ð¸Ð»Ð¸ Ð±Ñ€ÐµÐ½Ð´',0),(267874,7441,'es','Fabricante o Marca',0),(267875,7441,'de','Hersteller oder Marke',0),(267876,7441,'en','Manufacturer or Brand',0),(267877,7442,'is','',0),(267878,7442,'dr','- Ù…Ù‚Ø§Ø¯ÙŠØ± ØªÙˆØ²ÙŠØ¹ Ù†Ø´Ø¯Ù‡ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(267879,7442,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ù†ÙŠØ³Øª- Ù…Ù‚Ø§Ø¯ÙŠØ± ØªÙˆØ²ÙŠØ¹ Ù†Ø´Ø¯Ù‡ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(267880,7442,'tr','Komple - can\'t Undistributed miktarlar vardÄ±r.',0),(267881,7442,'pl','Nie moÅ¼na zgÅ‚aszaÄ‡ reklamacjÄ™ - istniejÄ… nieprzydzielone iloÅ›ci',0),(267882,7442,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸ - Ð½ÐµÑ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(267883,7442,'ur','Ù…Ú©Ù…Ù„ - Ø³Ú©ØªØ§ Ø§Ù†Ø¯Ø§Ø³Ù¹Ø±Ø§Ø¨Ù¹ÛŒØ¯ Ù…Ù‚Ø¯Ø§Ø±ÛŒÚº Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº Û”',0),(267884,7442,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ ÐºÐ°Ð¾ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾ - Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ðµ Ð½ÐµÑ€Ð°ÑÐ¿Ð¾Ñ€ÐµÑ’ÐµÐ½Ð¸Ð¼ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(267885,7442,'vi','Má»™t sá»‘ lÆ°á»£ng chÆ°a phÃ¢n phá»‘i - khÃ´ng thá»ƒ hoÃ n táº¥t',0),(267886,7442,'af','Kan voltooi - daar is Undistributed hoeveelhede',0),(267887,7442,'ro','Nu se poate completa - sunt cantitÄƒÈ›ile nedistribuite',0),(267888,7442,'et','Ei saa valmis - ei jaotamata koguseid',0),(267889,7442,'si','Ni dokonÄano - obstajajo nerazdeljenega koliÄine',0),(267890,7442,'ba','Tidak lengkap - ada jumlah Undistributed',0),(267891,7442,'nl','Kan niet compleet - er zijn niet-uitgekeerde hoeveelheden',0),(267892,7442,'fi','Ei Complete - jakamattomat mÃ¤Ã¤riÃ¤ voidaan',0),(267893,7442,'no','Ikke FullfÃ¸r - det finnes udistribuerte mengder',0),(267894,7442,'da','Ikke komplet - der er udloddet mÃ¦ngder',0),(267895,7442,'ko','ì™„ë£Œ-ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ë°°í¬ ë˜ì§€ ì•Šì€ ìˆ˜ëŸ‰ ìžˆìŠµë‹ˆë‹¤',0),(267896,7442,'he','××™ ××¤×©×¨ ×œ×”×©×œ×™× - ×™×©× ×Ÿ ×›×ž×•×™×•×ª ×©××™× ×Ÿ ×ž×•×¤×¦×•×ª',0),(267897,7442,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Ï€Î»Î®ÏÎ·Ï‚ - Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î¼Î· ÎºÎ±Ï„Î±Î½ÎµÎ¼Î·Î¼Î­Î½ÎµÏ‚ Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚',0),(267898,7442,'zh','æ— æ³•å®Œæˆ- æœ‰æœªåˆ†é…é‡\r\n',0),(267899,7442,'sv','Inte komplett - det finns icke utdelade kvantiteterna',0),(267900,7442,'it','Non Ã¨ possibile Complete - ci sono quantitativi non distribuiti',0),(267901,7442,'tl','',0),(267902,7442,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3607;&#3635;&#3651;&#3627;&#3657;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660; &#3652;&#3617;&#3656;&#3617;&#3637;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3585;&#',0),(267903,7442,'hi','à¤ªà¥‚à¤°à¥à¤£ - à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾ à¤µà¤¹à¤¾à¤ à¤…à¤µà¤¿à¤¤à¤°à¤¿à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¹à¥ˆà¤‚',0),(267904,7442,'ms','Tidak boleh lengkapkan - terdapat kuantiti yang diagihkan',0),(267905,7442,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥ÙƒÙ…Ø§Ù„--Ù‡Ù†Ø§Ùƒ \"ÙƒÙ…ÙŠØ§Øª ØºÙŠØ± Ø§Ù„Ù…ÙˆØ²Ø¹Ø©\"',0),(267906,7442,'fr','Ne peut pas Complete - il y a des quantitÃ©s non distribuÃ©s',0),(267907,7442,'jp','å®Œäº† - ã“ã¨ã¯ã§ãã¾ã›ã‚“æœªé…å¸ƒã®é‡ãŒã‚ã‚Šã¾ã™ã€‚',0),(267908,7442,'pt','NÃ£o consigo completa - existem quantidades nÃ£o distribuÃ­dos',0),(267909,7442,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð·Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ - ÐµÑÑ‚ÑŒ ÐÐµÑ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ñ‹Ðµ Ð¾Ð±ÑŠÐµÐ¼Ñ‹',0),(267910,7442,'es','No se puede Completar - Hay Cantidades No Distribuidas',0),(267911,7442,'de','Kann nicht vollstÃ¤ndig - gibt es nicht ausgeschÃ¼ttete',0),(267912,7442,'en','Cannot Complete - There are Undistributed Quantities',0),(267913,7443,'is','',0),(267914,7443,'dr','ØªÙˆØ²ÙŠØ¹ ÙƒØ±Ø¯Ù† ',0),(267915,7443,'pr','ØªÙˆØ²ÙŠØ¹ ÙƒØ±Ø¯Ù† ',0),(267916,7443,'tr','DaÄŸÄ±t',0),(267917,7443,'pl','Dystrybucji',0),(267918,7443,'bg','Ð Ð°Ð·Ð¿Ñ€Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ',0),(267919,7443,'ur','ØªÙ‚Ø³ÛŒÙ…',0),(267920,7443,'sr','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ†Ð¸Ñ˜Ð°',0),(267921,7443,'vi','PhÃ¢n phá»‘i',0),(267922,7443,'af','Versprei',0),(267923,7443,'ro','Distribui',0),(267924,7443,'et','Levitada',0),(267925,7443,'si','Distribucijo',0),(267926,7443,'ba','Mendistribusikan',0),(267927,7443,'nl','Distribueren',0),(267928,7443,'fi','Jakaa',0),(267929,7443,'no','Distribuere',0),(267930,7443,'da','Distribuere',0),(267931,7443,'ko','ë°°í¬',0),(267932,7443,'he','×œ×”×¤×™×¥',0),(267933,7443,'el','Î”Î¹Î±Î½Î¿Î¼Î®',0),(267934,7443,'zh','æ•£å¸ƒ\r\n',0),(267935,7443,'sv','Distribuera',0),(267936,7443,'it','Distribuire',0),(267937,7443,'tl','',0),(267938,7443,'th','&#3592;&#3633;&#3604;&#3592;&#3635;&#3627;&#3609;&#3656;&#3634;&#3618;',0),(267939,7443,'hi','à¤µà¤¿à¤¤à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(267940,7443,'ms','Mengedar',0),(267941,7443,'ar','ØªÙˆØ²ÙŠØ¹',0),(267942,7443,'fr','Distribuer',0),(267943,7443,'jp','é…å¸ƒ',0),(267944,7443,'pt','Distribuir',0),(267945,7443,'ru','Ð Ð°ÑÐ¿Ñ€Ð¾ÑÑ‚Ñ€Ð°Ð½ÑÑ‚ÑŒ',0),(267946,7443,'es','Distribuir',0),(267947,7443,'de','Verteilen',0),(267948,7443,'en','Distribute',0),(267949,7444,'is','',0),(267950,7444,'dr','ØªÙ…Ø§Ù…Ø§ ØªÙˆØ²ÙŠØ¹ Ù†Ø´Ø¯Ù‡ â€“ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø®Ø§Ø±Ø¬ Ø´ÙˆØ¯ ',0),(267951,7444,'pr','ØªÙ…Ø§Ù…Ø§ ØªÙˆØ²ÙŠØ¹ Ù†Ø´Ø¯Ù‡ â€“ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø®Ø§Ø±Ø¬ Ø´ÙˆØ¯ ',0),(267952,7444,'tr','DeÄŸil tÃ¼m daÄŸÄ±tÄ±lmÄ±ÅŸ-Ã§Ä±kÄ±lamÄ±yor',0),(267953,7444,'pl','Nie wszystkie rozproszone-nie moÅ¼e wyjÅ›Ä‡ z',0),(267954,7444,'bg','ÐÐµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸-Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð»ÐµÐ·ÐµÑ‚Ðµ',0),(267955,7444,'ur','Ù†ÛÛŒÚº Ø³Ø¨ ØªÙ‚Ø³ÛŒÙ…-Ø®Ø±ÙˆØ¬ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(267956,7444,'sr','ÐÐµ Ñƒ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÐ¸Ñ€Ð°Ð½Ð¾Ð¼-Ð¼Ð¾Ð³Ñƒ Ð¸Ð·Ð°Ñ›Ð¸ Ð¸Ð·',0),(267957,7444,'vi','KhÃ´ng phÃ¢n phá»‘i háº¿t-KhÃ´ng thá»ƒ tá»“n táº¡i',0),(267958,7444,'af','Nie alle versprei-verlaat nie',0),(267959,7444,'ro','Nu toate distribuite-nu pot ieÅŸi',0),(267960,7444,'et','KÃµik laiali-ei saa vÃ¤ljuda',0),(267961,7444,'si','Ne vse distribuirane-ni mogoÄe zapreti',0),(267962,7444,'ba','Tidak semua didistribusikan-tidak dapat keluar dari',0),(267963,7444,'nl','Niet alle gedistribueerde-kan niet afsluiten',0),(267964,7444,'fi','Kaikki jaetaan-ei voi sulkea',0),(267965,7444,'no','Ikke alle distribuert-kan ikke avslutte',0),(267966,7444,'da','Ikke alle distribuerede-kan ikke afslutte',0),(267967,7444,'ko','ëª¨ë“  ë¶„ì‚°-ì¢…ë£Œ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(267968,7444,'he','×œ× ×”×›×œ ×ž×‘×•×–×¨-×™×›×•×œ ×œ×¦××ª',0),(267969,7444,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏŒÎ»Î± Î´Î¹Î±Î½Î­Î¼Î¿Î½Ï„Î±Î¹-Î´ÎµÎ½ Î²Î³ÎµÎ¯Ï„Îµ',0),(267970,7444,'zh','æœªå®Œå…¨åˆ†é…-æ— æ³•é€€å‡º\r\n',0),(267971,7444,'sv','Inte alla distribuerade-gÃ¥r inte att avsluta',0),(267972,7444,'it','Non tutti distribuiti-non puÃ² uscire',0),(267973,7444,'tl','',0),(267974,7444,'th','&#3652;&#3617;&#3656;&#3649;&#3592;&#3585;&#3592;&#3656;&#3634;&#3618;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604; &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3629;&#3629;&#3585;&#3652;&#3604;&#3657;',0),(267975,7444,'hi','à¤¨à¤¹à¥€à¤‚ à¤¸à¤­à¥€ à¤µà¤¿à¤¤à¤°à¤¿à¤¤-à¤¬à¤¾à¤¹à¤° à¤¨à¤¿à¤•à¤²à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(267976,7444,'ms','Tidak semua tersebar-tidak boleh keluar',0),(267977,7444,'ar','Ù„Ø§ ØªÙˆØ²Ø¹ ÙƒÙ„ Ø´ÙŠØ¡-Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø®Ø±ÙˆØ¬',0),(267978,7444,'fr','Pas tout distribuÃ©-ne peut pas sortir',0),(267979,7444,'jp','ã™ã¹ã¦ã®åˆ†æ•£-çµ‚äº†ã§ãã¾ã›ã‚“ã€‚',0),(267980,7444,'pt','NÃ£o, tudo distribuÃ­do-nÃ£o posso sair',0),(267981,7444,'ru','ÐÐµ Ð²ÑÐµ Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ñ‹Ðµ-Ð½Ðµ Ð²Ñ‹Ñ…Ð¾Ð´',0),(267982,7444,'es','No todo Distribuido-No Puede Salir',0),(267983,7444,'de','Nicht alle verteilten-kann nicht beendet werden',0),(267984,7444,'en','Not All Distributed-Cannot Exit',0),(267985,7445,'is','',0),(267986,7445,'dr','( Ù…ÙØ§Ø¯',0),(267987,7445,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù†Ø³( Ø³ÙˆØ¯',0),(267988,7445,'tr','Miktar iyi',0),(267989,7445,'pl','IloÅ›Ä‡ dobra',0),(267990,7445,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð¾Ð±Ñ€Ð¾',0),(267991,7445,'ur','Ù‚ÛŒ Ø§Ú†Ú¾Ø§',0),(267992,7445,'sr','Ð”Ð¾Ð±Ñ€Ð¾ Ñ˜Ðµ ÐšÐ¾Ð».',0),(267993,7445,'vi','Sá»‘ lÆ°á»£ng hÃ ng',0),(267994,7445,'af','Hoev. Geskik',0),(267995,7445,'ro','Cantit bun',0),(267996,7445,'et','Kogus hea',0),(267997,7445,'si','Kol dober',0),(267998,7445,'ba','Baik Qty',0),(267999,7445,'nl','Qty goed',0),(268000,7445,'fi','Kpl hyvÃ¤Ã¤',0),(268001,7445,'no','Antall gode',0),(268002,7445,'da','Antal gode',0),(268003,7445,'ko','Qty ì¢‹ì€',0),(268004,7445,'he','×›×ž×•×ª ×˜×•×‘×”',0),(268005,7445,'el','ÎšÎ±Î»Î® Qty',0),(268006,7445,'zh','æ•°é‡å¥½\r\n',0),(268007,7445,'sv','Antal bra',0),(268008,7445,'it','Buona Qty',0),(268009,7445,'tl','',0),(268010,7445,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(268011,7445,'hi','à¤…à¤šà¥à¤›à¤¾ à¤¹à¥ˆ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(268012,7445,'ms','Qty baik',0),(268013,7445,'ar','Ø­Ø³Ù† Qty',0),(268014,7445,'fr','Qty bonne',0),(268015,7445,'jp','Qty è‰¯ã„',0),(268016,7445,'pt','Qty bom',0),(268017,7445,'ru','Qty Ñ…Ð¾Ñ€Ð¾ÑˆÐ¾',0),(268018,7445,'es','Cant. Bueno',0),(268019,7445,'de','Qty gut',0),(268020,7445,'en','Qty Good',0),(268021,7446,'is','',0),(268022,7446,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(268023,7446,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(268024,7446,'tr','AlÄ±nan ayrÄ±ntÄ±larÄ±',0),(268025,7446,'pl','Odebrane dane',0),(268026,7446,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ Ð´Ð°Ð½Ð½Ð¸',0),(268027,7446,'ur','Ù…ÙˆØµÙˆÙ„Û ØªÙØµÛŒÙ„Ø§Øª',0),(268028,7446,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(268029,7446,'vi','Chi tiáº¿t Ä‘Ã£ nháº­n',0),(268030,7446,'af','Ontvangsdetail',0),(268031,7446,'ro','Primit detalii',0),(268032,7446,'et','VastuvÃµetud andmed',0),(268033,7446,'si','Prejete podatke',0),(268034,7446,'ba','Menerima rincian',0),(268035,7446,'nl','Ontvangen Details',0),(268036,7446,'fi','Vastaanotetut tiedot',0),(268037,7446,'no','Mottatte detaljer',0),(268038,7446,'da','Modtagne oplysninger',0),(268039,7446,'ko','ë°›ì€ ì •ë³´',0),(268040,7446,'he','×¤×¨×˜×™×š ×”×ª×§×‘×œ×•',0),(268041,7446,'el','ÎˆÎ»Î±Î²Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(268042,7446,'zh','æ”¶æ¬¾è¯¦ç»†è¯´æ˜Ž\r\n',0),(268043,7446,'sv','Mottagna Detaljer',0),(268044,7446,'it','Dettagli ricevuti',0),(268045,7446,'tl','',0),(268046,7446,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(268047,7446,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤µà¤¿à¤µà¤°à¤£',0),(268048,7446,'ms','Maklumat yang diterima',0),(268049,7446,'ar','ØªÙ„Ù‚ÙŠ Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(268050,7446,'fr','DÃ©tails reÃ§us',0),(268051,7446,'jp','å—ä¿¡ã—ãŸè©³ç´°',0),(268052,7446,'pt','Detalhes recebidos',0),(268053,7446,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(268054,7446,'es','Detalles de Recibir',0),(268055,7446,'de','Erhaltene Informationen',0),(268056,7446,'en','Received Details',0),(268057,7447,'is','',0),(268058,7447,'dr','(ØªØ®ØµÙŠØµ) Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(268059,7447,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ù†ÙˆØ² ØªÙˆØ²ÙŠØ¹(ØªØ®ØµÙŠØµ) Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(268060,7447,'tr','HenÃ¼z daÄŸÄ±tÄ±lan toplam',0),(268061,7447,'pl','Sumie nie zostaÅ‚y jeszcze dystrybuowane',0),(268062,7447,'bg','ÐžÐ±Ñ‰Ð¾ Ð²ÑÐµ Ð¾Ñ‰Ðµ Ð½Ðµ ÑÐ° Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸',0),(268063,7447,'ur','Ø§Ø¨Ú¾ÛŒ Ù†ÛÛŒÚº Ø¨Ù¹Ø§ ÛÙˆØ§ Ú©Ù„',0),(268064,7447,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ñ˜Ð¾Ñˆ Ð½Ð¸Ñ˜Ðµ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÐ¸Ñ€Ð°Ð½',0),(268065,7447,'vi','Tá»•ng cá»™ng chÆ°a phÃ¢n phá»‘i',0),(268066,7447,'af','Totaal Nog Nie Versprei',0),(268067,7447,'ro','Total Ã®ncÄƒ distribuite',0),(268068,7447,'et','Veel levitatakse kokku',0),(268069,7447,'si','Skupaj Å¡e ne razdeljeni',0),(268070,7447,'ba','Total yang belum didistribusikan',0),(268071,7447,'nl','Totaal nog niet verdeeld',0),(268072,7447,'fi','Ei vielÃ¤ jaettu yhteensÃ¤',0),(268073,7447,'no','Totalt ikke distribuert',0),(268074,7447,'da','Alt endnu ikke er fordelt',0),(268075,7447,'ko','ì´ ì•„ì§ ë°°í¬',0),(268076,7447,'he','×¡×” ×› ×¢×•×“ ×œ× ×ž×•×¤×¥',0),(268077,7447,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬, Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î±ÎºÏŒÎ¼Î· Î´Î¹Î±Î½ÎµÎ¼Î·Î¸ÎµÎ¯',0),(268078,7447,'zh','æ€»è®¡å°šæœªåˆ†é…é¡¹ç›®\r\n',0),(268079,7447,'sv','Totalt Ã¤nnu inte distribueras',0),(268080,7447,'it','Totale non ancora distribuito',0),(268081,7447,'tl','',0),(268082,7447,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3592;&#3633;&#3604;&#3592;&#3635;&#3627;&#3609;&#3656;&#3634;&#3618;',0),(268083,7447,'hi','à¤•à¥à¤² à¤…à¤¬à¤¤à¤• à¤µà¤¿à¤¤à¤°à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾',0),(268084,7447,'ms','Jumlah yang belum diagihkan',0),(268085,7447,'ar','Ù„Ù… ÙŠØªÙ… Ø¨Ø¹Ø¯ ØªÙˆØ²ÙŠØ¹ Ù…Ø§ Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(268086,7447,'fr','Total non encore distribuÃ©',0),(268087,7447,'jp','åˆè¨ˆã¯ã¾ã é…å¸ƒ',0),(268088,7447,'pt','Total ainda nÃ£o distribuÃ­do',0),(268089,7447,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ð¾ÐºÐ° Ð½Ðµ Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ñ‹',0),(268090,7447,'es','Total Ya No Distribuido',0),(268091,7447,'de','Insgesamt noch nicht verteilt',0),(268092,7447,'en','Total Not Yet Distributed',0),(268093,7448,'is','',0),(268094,7448,'dr','Ù‡ÙŠÚ† Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§ÙŠ Ù†Ø¯Ø§Ø±Ø¯ ',0),(268095,7448,'pr','Ù‡ÙŠÚ† Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø®Øª Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§ÙŠ Ù†Ø¯Ø§Ø±Ø¯ ',0),(268096,7448,'tr','HiÃ§bir Ã¶deme ÅŸartlarÄ± girmiÅŸtir',0),(268097,7448,'pl','WeszÅ‚a nie terminÃ³w pÅ‚atnoÅ›ci',0),(268098,7448,'bg','Ð• Ð²ÑŠÐ²ÐµÐ»Ð° Ð½ÑÐ¼Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(268099,7448,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø· Ù†Û’ Ø¯Ø§Ø®Ù„ Ú©ÛŒØ§ ÛÛ’',0),(268100,7448,'sr','Ð£ÑˆÐ»Ð° Ñ˜Ðµ Ð±ÐµÐ· ÑƒÑÐ»Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(268101,7448,'vi','ChÆ°a nháº­p Ä‘iá»u khoáº£n thanh toÃ¡n',0),(268102,7448,'af','Geen Betalingsterme is Ingevoer',0),(268103,7448,'ro','A intrat Ã®n nu termeni de plata',0),(268104,7448,'et','Sisestas pole maksetingimuste',0),(268105,7448,'si','Ni PlaÄilni pogoji vnesel',0),(268106,7448,'ba','Telah memasuki syarat-syarat pembayaran tidak',0),(268107,7448,'nl','Heeft geen betalingsvoorwaarden ingevoerd',0),(268108,7448,'fi','Ei ole maksuehdot tullut',0),(268109,7448,'no','Har ingen betalingsbetingelser inn',0),(268110,7448,'da','TrÃ¥dt nogen betalingsbetingelser',0),(268111,7448,'ko','ì•„ë¬´ ì§€ë¶ˆ ì¡°ê±´ì„ ìž…ë ¥ í–ˆìŠµë‹ˆë‹¤',0),(268112,7448,'he','. × ×›× ×¡×” ×œ×œ× ×ª× ××™ ×ª×©×œ×•×',0),(268113,7448,'el','Î•Î¹ÏƒÎ®Î»Î¸Îµ Î´ÎµÎ½ ÏŒÏÎ¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(268114,7448,'zh','æ²¡æœ‰ä»˜æ¬¾æ¡æ¬¾è®¢ç«‹\r\n',0),(268115,7448,'sv','Har ingen betalningsvillkor anges',0),(268116,7448,'it','Termini di pagamento non sono entrato',0),(268117,7448,'tl','',0),(268118,7448,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(268119,7448,'hi','à¤•à¥‹à¤ˆ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ',0),(268120,7448,'ms','Telah memasuki tiada tempoh bayaran',0),(268121,7448,'ar','ÙˆÙ‚Ø¯ Ø¯Ø®Ù„Øª Ù„Ø§ Ø´Ø±ÙˆØ· Ø§Ù„Ø¯ÙØ¹',0),(268122,7448,'fr','N\'a entrÃ© aucune conditions de paiement',0),(268123,7448,'jp','æ”¯æ‰•æ¡ä»¶ãŒå…¥åŠ›ã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(268124,7448,'pt','Entraram sem condiÃ§Ãµes de pagamento',0),(268125,7448,'ru','Ð’ÑÑ‚ÑƒÐ¿Ð¸Ð» Ð»Ð¸ Ð½Ðµ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(268126,7448,'es','Hay TÃ©rminos de No Pago Entrados',0),(268127,7448,'de','Hat keine Zahlungsbedingungen eingegeben',0),(268128,7448,'en','Has No Payment Terms Entered',0),(268129,7449,'is','',0),(268130,7449,'dr','Ø§ØµÙ„Ø§Ø­ Ú†Ùƒ',0),(268131,7449,'pr','Ø§ØµÙ„Ø§Ø­ Ú†Ùƒ',0),(268132,7449,'tr','Onay ayarlama',0),(268133,7449,'pl','SprawdÅº regulacji',0),(268134,7449,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ',0),(268135,7449,'ur','Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(268136,7449,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(268137,7449,'vi','Sá»­a SÃ©c',0),(268138,7449,'af','Tjek Aangepas',0),(268139,7449,'ro','Verifica ajustare',0),(268140,7449,'et','Kontrollige korrigeerimine',0),(268141,7449,'si','Preverite nastavitev',0),(268142,7449,'ba','Periksa penyesuaian',0),(268143,7449,'nl','Selectievakje aanpassing',0),(268144,7449,'fi','Tarkista sÃ¤Ã¤tÃ¶',0),(268145,7449,'no','NÃ¥r justering',0),(268146,7449,'da','Kontrollere justering',0),(268147,7449,'ko','ì¡°ì • í™•ì¸',0),(268148,7449,'he','×œ×‘×“×•×§ ××ª ×”×”×ª××ž×”',0),(268149,7449,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î· ÏÏÎ¸Î¼Î¹ÏƒÎ·',0),(268150,7449,'zh','æ£€æŸ¥è°ƒæ•´\r\n',0),(268151,7449,'sv','Kontrollera justering',0),(268152,7449,'it','Controllare la regolazione',0),(268153,7449,'tl','',0),(268154,7449,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;',0),(268155,7449,'hi','à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(268156,7449,'ms','Semak pelarasan',0),(268157,7449,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„ØªÙƒÙŠÙ',0),(268158,7449,'fr','VÃ©rifiez l\'ajustement',0),(268159,7449,'jp','èª¿æ•´ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(268160,7449,'pt','Verifique o ajuste',0),(268161,7449,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²ÐºÑƒ',0),(268162,7449,'es','Cheque Ajuste',0),(268163,7449,'de','Anpassung zu Ã¼berprÃ¼fen',0),(268164,7449,'en','Check Adjustment',0),(268165,7450,'is','',0),(268166,7450,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  ØªØ¹Ø§Ø±ÙŠÙ Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ',0),(268167,7450,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  ØªØ¹Ø§Ø±ÙŠÙ Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ',0),(268168,7450,'tr','ÃœrÃ¼n ReÃ§etesi tanÄ±mlarÄ± ekleme/gÃ¼ncelleme',0),(268169,7450,'pl','Dodaj/Aktualizuj BOM definicje',0),(268170,7450,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ð¸Ñ‚Ðµ Ð½Ð° ÐšÐ˜',0),(268171,7450,'ur','Ø¨Ø§Ù… ØªØ¹Ø±ÛŒÙÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(268172,7450,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ðµ',0),(268173,7450,'vi','ThÃªm/Cáº­p Nháº­t Äá»‹nh NghÄ©a BOM',0),(268174,7450,'af','Voeg/Update BOM definisies',0),(268175,7450,'ro','Definitii BOM Adauga/Actualizeaza',0),(268176,7450,'et','Lisada vÃµi uuendada Koosluse mÃµisted',0),(268177,7450,'si','Dodaj/posodobi definicije Kosovnice',0),(268178,7450,'ba','Tambah/Ganti BOM',0),(268179,7450,'nl','BOM definities toevoegen/bijwerken',0),(268180,7450,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ Tuoterakenteen mÃ¤Ã¤ritelmÃ¤t',0),(268181,7450,'no','Legg til/Oppdater Stykklisten definisjoner',0),(268182,7450,'da','TilfÃ¸j/opdater Stykliste definitioner',0),(268183,7450,'ko','BOM ì •ì˜ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(268184,7450,'he','×”×•×¡×£/×¢×“×›×Ÿ BOM ×”×’×“×¨×•×ª',0),(268185,7450,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹/ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Î¿ÏÎ¹ÏƒÎ¼Î¿ÏÏ‚ Ï„ÎµÏ‡Î½Î¹ÎºÎ®Ï‚ Î ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚',0),(268186,7450,'zh','å¢žåŠ /æ›´æ–°çš„ç‰©æ–™æ¸…å•è§£èªª\r\n',0),(268187,7450,'sv','LÃ¤gg till/uppdatera Strukturlista definitioner',0),(268188,7450,'it','Aggiungere o aggiornare le definizioni BOM',0),(268189,7450,'tl','',0),(268190,7450,'th','Add/Update BOM Definitions',0),(268191,7450,'hi','BOM à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾à¤“à¤‚ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(268192,7450,'ms','Tambah/Kemaskini definisi BOM',0),(268193,7450,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« ØªØ¹Ø±ÙŠÙØ§Øª BOM',0),(268194,7450,'fr','Ajouter/mettre Ã  jour des dÃ©finitions de nomenclature',0),(268195,7450,'jp','BOM ã‚’å®šç¾©ã®è¿½åŠ /æ›´æ–°',0),(268196,7450,'pt','Adicionar/atualizar definiÃ§Ãµes de BOM',0),(268197,7450,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(268198,7450,'es','Agregar/Actualizar Definiciones de BOM',0),(268199,7450,'de','BOM-Definitionen hinzufÃ¼gen/aktualisieren',0),(268200,7450,'en','Add/Update BOM Definitions',0),(268201,7451,'is','',0),(268202,7451,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(268203,7451,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(268204,7451,'tr','PO inÅŸa sipariÅŸlerini oluÅŸturmak',0),(268205,7451,'pl','Tworzenie PO do wykonania zamÃ³wienia',0),(268206,7451,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° PO Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð°',0),(268207,7451,'ur','Ù¾Ùˆ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’ ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(268208,7451,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¿Ð¾-Ð° Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÑƒ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(268209,7451,'vi','Táº¡o Ä‘Æ¡n mua hÃ ng cho ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(268210,7451,'af','Skep AB vir Geboude Bestellings',0),(268211,7451,'ro','Crea PO pentru a construi comenzi',0),(268212,7451,'et','Loo PO ehitada tellimused',0),(268213,7451,'si','Ustvarite pad za izgradnjo naroÄila',0),(268214,7451,'ba','Buat Pesanan Pembelian untuk Penjualan',0),(268215,7451,'nl','Inkooporders maken voor Build bestellingen',0),(268216,7451,'fi','Luo Ostotilaus rakentaa tilaukset',0),(268217,7451,'no','Opprette PO for bygge bestillinger',0),(268218,7451,'da','Oprette PO for bygge ordrer',0),(268219,7451,'ko','ë¹Œë“œ ëª…ë ¹ì— ëŒ€ í•œ ì‚¬ì„œí•¨ ë§Œë“¤ê¸°',0),(268220,7451,'he','×¦×•×¨ ×”×–×ž× ×ª ×¨×›×© ×¢×‘×•×¨ ×”×–×ž× ×•×ª ×œ×‘× ×•×ª',0),(268221,7451,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± PO Î³Î¹Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(268222,7451,'zh','åˆ›å»ºé‡‡è´­è®¢å•ç”Ÿæˆè®¢å•\r\n',0),(268223,7451,'sv','Skapa PO fÃ¶r bygga order',0),(268224,7451,'it','Creare PO per compilazione ordini',0),(268225,7451,'tl','',0),(268226,7451,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(268227,7451,'hi','PO à¤¬à¤¿à¤²à¥à¤¡ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¨à¤¾à¤à¤',0),(268228,7451,'ms','Buat PO untuk membina pesanan',0),(268229,7451,'ar','Ø¥Ù†Ø´Ø§Ø¡ ØµÙ†Ø¯ÙˆÙ‚ Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(268230,7451,'fr','CrÃ©er des PO pour les commandes de gÃ©nÃ©ration',0),(268231,7451,'jp','ãƒ“ãƒ«ãƒ‰æ³¨æ–‡ã® PO ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(268232,7451,'pt','Criar PO para ordens de construÃ§Ã£o',0),(268233,7451,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¡ÐŸ Ð´Ð»Ñ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(268234,7451,'es','Crear OC para Ordenes de ConstrucciÃ³n',0),(268235,7451,'de','PO fÃ¼r Build AuftrÃ¤ge erstellen',0),(268236,7451,'en','Create PO for Build Orders',0),(268237,7452,'is','',0),(268238,7452,'dr','Ù„ÙŠØ³Øª Ù…Ø´Ø®ØµØ§Øª Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(268239,7452,'pr','Ù„ÙŠØ³Øª Ù…Ø´Ø®ØµØ§Øª Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(268240,7452,'tr','Envanter Ã¶ÄŸe aÄŸacÄ± tanÄ±m listesi',0),(268241,7452,'pl','Lista definicji zapasÃ³w towaru BOM',0),(268242,7452,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» ÐšÐ˜ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÑŠÐº',0),(268243,7452,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ø¨Ø§Ù… ØªØ¹Ø±ÛŒÙ ÙÛØ±Ø³Øª',0),(268244,7452,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð° Ð»Ð¸ÑÑ‚Ð°',0),(268245,7452,'vi','Danh SÃ¡ch Äá»‹nh NghÄ©a HÃ ng hÃ³a BOM',0),(268246,7452,'af','Voorraaditem BOM Definisie Lys',0),(268247,7452,'ro','Lista inventar elemente LM definiÅ£ie',0),(268248,7452,'et','Lao kirje Koosluse mÃ¤Ã¤ratlus nimekiri',0),(268249,7452,'si','Opredelitev seznam zaloge artikla Kosovnice',0),(268250,7452,'ba','Daftar definisi persediaan Item BOM',0),(268251,7452,'nl','Inventarislijst Item BOM definitie',0),(268252,7452,'fi','Nimikkeen Tuoterakenteen mÃ¤Ã¤ritelmÃ¤ Inventaarioluettelo',0),(268253,7452,'no','Inventarliste for definisjonen av elementet Stykkliste',0),(268254,7452,'da','Lagerliste vare Stykliste Definition',0),(268255,7452,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© BOM ì •ì˜ ëª©ë¡',0),(268256,7452,'he','×ž×¦××™ ×¤×¨×™×˜ BOM ×”×’×“×¨×ª ×¨×©×™×ž×”',0),(268257,7452,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î¿ÏÎ¹ÏƒÎ¼ÏŒ Ï€ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†ÏŽÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(268258,7452,'zh','åº“å­˜é¡¹ç›®çš„ç‰©æ–™æ¸…å•å®šä¹‰åˆ—è¡¨\r\n',0),(268259,7452,'sv','Inventarielista objekt BOM Definition',0),(268260,7452,'it','Elenco di elementi BOM definizione di inventario',0),(268261,7452,'tl','',0),(268262,7452,'th','Inventory Item BOM Definition List',0),(268263,7452,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® BOM à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾ à¤¸à¥‚à¤šà¥€',0),(268264,7452,'ms','Senarai inventori Item BOM definasi',0),(268265,7452,'ar','Ù‚Ø§Ø¦Ù…Ø© ØªØ¹Ø±ÙŠÙ Ø´Ø¬Ø±Ø© Ø¹Ù†ØµØ± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(268266,7452,'fr','BOM dÃ©finition liste d\'Ã©lÃ©ments de l\'inventaire',0),(268267,7452,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªé …ç›® BOM å®šç¾©ãƒªã‚¹ãƒˆ',0),(268268,7452,'pt','Lista de definiÃ§Ã£o do inventÃ¡rio Item BOM',0),(268269,7452,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ð¹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð° ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(268270,7452,'es','Lista de Definiciones de BOM de Items de Inventario',0),(268271,7452,'de','Inventar Item BOM-Definitionsliste',0),(268272,7452,'en','Inventory Item BOM Definition List',0),(268273,7453,'is','',0),(268274,7453,'dr','Ù„ÙŠØ³Øª ØªØ¹Ø§Ø±ÙŠÙ Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ',0),(268275,7453,'pr','Ù„ÙŠØ³Øª ØªØ¹Ø§Ø±ÙŠÙ Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ',0),(268276,7453,'tr','Liste Ã¼rÃ¼n ReÃ§etesi tanÄ±mlarÄ±',0),(268277,7453,'pl','Lista BOM definicje',0),(268278,7453,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº ÐšÐ˜ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ð¸',0),(268279,7453,'ur','ÙÛØ±Ø³Øª Ø¨Ø§Ù… Ú©ÛŒ ØªØ¹Ø±ÛŒÙ',0),(268280,7453,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ð° Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ðµ',0),(268281,7453,'vi','Danh sÃ¡ch Ä‘á»‹nh nghÄ©a BOM',0),(268282,7453,'af','Lys BOM definisies',0),(268283,7453,'ro','Lista LM definiÅ£ii',0),(268284,7453,'et','Loendi Koosluserea mÃµisted',0),(268285,7453,'si','Seznam Kosovnic opredelitve',0),(268286,7453,'ba','Daftar BOM definisi',0),(268287,7453,'nl','Lijst Stuklijst definities',0),(268288,7453,'fi','Luettelo Tuoterakenteen mÃ¤Ã¤ritelmÃ¤t',0),(268289,7453,'no','Listen Stykkliste definisjoner',0),(268290,7453,'da','Liste over Stykliste definitioner',0),(268291,7453,'ko','ëª©ë¡ BOM ì •ì˜',0),(268292,7453,'he','×”×’×“×¨×•×ª ×”-BOM ×”×¨×©×™×ž×”',0),(268293,7453,'el','Î›Î¯ÏƒÏ„Î± Ï„ÎµÏ‡Î½Î¹ÎºÎ®Ï‚ Î ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ Î¿ÏÎ¹ÏƒÎ¼Î¿Î¯',0),(268294,7453,'zh','åˆ—å‡ºç‰©æ–™æ¸…å•å®šä¹‰\r\n',0),(268295,7453,'sv','Lista BOM definitioner',0),(268296,7453,'it','Elenco definizioni BOM',0),(268297,7453,'tl','',0),(268298,7453,'th','&#3586;&#3657;&#3629;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; BOM ',0),(268299,7453,'hi','à¤¸à¥‚à¤šà¥€ BOM à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾à¤à¤',0),(268300,7453,'ms','Senarai BOM definisi',0),(268301,7453,'ar','Ù‚Ø§Ø¦Ù…Ø© BOM Ø§Ù„ØªØ¹Ø§Ø±ÙŠÙ',0),(268302,7453,'fr','DÃ©finitions de liste BOM',0),(268303,7453,'jp','BOM ã‚’ãƒªã‚¹ãƒˆå®šç¾©',0),(268304,7453,'pt','Lista as definiÃ§Ãµes de BOM',0),(268305,7453,'ru','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸ ÑÐ¿Ð¸ÑÐºÐ¾Ð²',0),(268306,7453,'es','Lista Definiciones BOM',0),(268307,7453,'de','BOM Listendefinitionen',0),(268308,7453,'en','List BOM Definitions',0),(268309,7454,'is','',0),(268310,7454,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(268311,7454,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª ',0),(268312,7454,'tr','YapÄ± sipariÅŸler iÃ§in PO',0),(268313,7454,'pl','PO dla wykonania zamÃ³wienia',0),(268314,7454,'bg','PO Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð°',0),(268315,7454,'ur','ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ù¾Ùˆ',0),(268316,7454,'sr','ÐŸÐž Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÑƒ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(268317,7454,'vi','ÄÆ¡n mua hÃ ng cho Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(268318,7454,'af','AB vir Geboude Bestellings',0),(268319,7454,'ro','PO pentru a construi comenzi',0),(268320,7454,'et','PO ehitada tellimuste',0),(268321,7454,'si','PO za izgradnjo naroÄila',0),(268322,7454,'ba','PO untuk membangun perintah',0),(268323,7454,'nl','PO voor Build bestellingen',0),(268324,7454,'fi','PO rakentaa tilaukset',0),(268325,7454,'no','PO for bygge bestillinger',0),(268326,7454,'da','PO for bygge ordrer',0),(268327,7454,'ko','ë¹Œë“œ ëª…ë ¹ì— ëŒ€ í•œ í¬',0),(268328,7454,'he','×¤×• ×œ×”×–×ž× ×•×ª ×œ×‘× ×•×ª',0),(268329,7454,'el','PO Î³Î¹Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(268330,7454,'zh','è®¢å•çš„å»ºè®¾è®¢å•\r\n',0),(268331,7454,'sv','PO fÃ¶r bygga order',0),(268332,7454,'it','PO per compilazione ordini',0),(268333,7454,'tl','',0),(268334,7454,'th','&#3651;&#3610;&#3626;&#3633;&#3657;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(268335,7454,'hi','à¤¬à¤¿à¤²à¥à¤¡ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹',0),(268336,7454,'ms','PO untuk Tempahan membina',0),(268337,7454,'ar','Øµ. Ø¨ Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(268338,7454,'fr','PO pour les commandes de gÃ©nÃ©ration',0),(268339,7454,'jp','ãƒ“ãƒ«ãƒ‰ã® PO ã‚’å—æ³¨ã—ã¾ã™ã€‚',0),(268340,7454,'pt','PO para ordens de construÃ§Ã£o',0),(268341,7454,'ru','PO Ð´Ð»Ñ ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(268342,7454,'es','OC para Ordenes de ConstrucciÃ³n',0),(268343,7454,'de','PO fÃ¼r Build Orders',0),(268344,7454,'en','PO for Build Orders',0),(268345,7455,'is','',0),(268346,7455,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ú¯Ø±Ø¯Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(268347,7455,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ú¯Ø±Ø¯Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(268348,7455,'tr','Ä°zleme alanlarÄ±nÄ± stok iÃ§in akÄ±ÅŸ',0),(268349,7455,'pl','Pola Å›ledzenia zapasÃ³w przepÅ‚ywu',0),(268350,7455,'bg','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð·Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿Ð¾Ñ‚Ð¾Ðº',0),(268351,7455,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø³Ø±Ø§Øº Ø±Ø§Û Ù‚Ø·Ø¹Ø§Øª Ú©ÛŒ Ø±ÙˆØ§Ù†ÛŒ',0),(268352,7455,'sr','ÐŸÐ¾Ñ™Ð° Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ñ‚ÐµÐºÑƒ',0),(268353,7455,'vi','TÃ¬m TrÆ°á»ng HÃ ng Trong Kho LuÃ¢n Chuyá»ƒn',0),(268354,7455,'af','Sporingsvelde vir Inventaris Vloei',0),(268355,7455,'ro','Fluxul de urmÄƒrire cÃ¢mpuri pentru inventarul',0),(268356,7455,'et','JÃ¤lgimise vÃ¤ljad lao voolu',0),(268357,7455,'si','Sledenje polja za zalogo toka',0),(268358,7455,'ba','Bidang pelacakan inventaris mengalir',0),(268359,7455,'nl','Voortgangsvelden voor inventaris stromen',0),(268360,7455,'fi','Varaston seurantakentÃ¤t Flow',0),(268361,7455,'no','OppfÃ¸lgingsfeltene for lager flyt',0),(268362,7455,'da','Sporing felter for lager Flow',0),(268363,7455,'ko','ìž¬ê³ ì— ëŒ€ í•œ ì¶”ì  í•„ë“œ íë¦„',0),(268364,7455,'he','××™×ª×•×¨ ×©×“×•×ª ×œ×¡×¤×™×¨×ª ×ž×œ××™ ×–×¨×™×ž×”',0),(268365,7455,'el','Î¡Î¿Î® Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚ Ï€ÎµÎ´Î¯Î± Î³Î¹Î± \"Î±Ï€ÏŒÎ¸ÎµÎ¼Î±\"',0),(268366,7455,'zh','åº“å­˜æµåŠ¨è¿½è¸ªå­—æ®µ\r\n',0),(268367,7455,'sv','UppfÃ¶ljningsfÃ¤lt fÃ¶r inventering flÃ¶de',0),(268368,7455,'it','Campi di rilevamento per l\'inventario di flusso',0),(268369,7455,'tl','',0),(268370,7455,'th','&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3629;&#3591;&#3607;&#3636;&#3624;&#3607;&#3634;&#3591;&#3588;&#3621;&#3633;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(268371,7455,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤«à¥à¤²à¥‹',0),(268372,7455,'ms','Mengesan bidang-bidang bagi inventori mengalir',0),(268373,7455,'ar','ØªØ¯ÙÙ‚ Ø­Ù‚ÙˆÙ„ Ø§Ù„ØªØ¹Ù‚Ø¨ Ù„Ù„Ù…Ø®Ø²ÙˆÙ†',0),(268374,7455,'fr','Flux de champs de suivi de l\'inventaire',0),(268375,7455,'jp','åœ¨åº«ã‚’è¿½è·¡ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã®æµã‚Œ',0),(268376,7455,'pt','Fluem de campos de controle de inventÃ¡rio',0),(268377,7455,'ru','ÐŸÐ¾Ð»Ñ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð´Ð»Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾Ñ‚Ð¾ÐºÐ°',0),(268378,7455,'es','Rastreando Campos para el Flujo de Inventario',0),(268379,7455,'de','Ãœberwachungsfelder fÃ¼r die Inventur flieÃŸen',0),(268380,7455,'en','Tracking Fields for Inventory Flow',0),(268381,7456,'is','',0),(268382,7456,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(268383,7456,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(268384,7456,'tr','Ä°zleme ayarlarÄ±',0),(268385,7456,'pl','Konfigurowania Å›ledzenia',0),(268386,7456,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(268387,7456,'ur','Ø³Ø±Ø§Øº Ú©Ø§Ø±ÛŒ Ø³ÛŒÙ¹ Ø§Ù¾',0),(268388,7456,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð°Ñ›ÐµÑšÐ°',0),(268389,7456,'vi','Setup DÃ² tÃ¬m ',0),(268390,7456,'af','Dop opstelling',0),(268391,7456,'ro','Configurare urmÄƒrire',0),(268392,7456,'et','JÃ¤lgimise seadistamine',0),(268393,7456,'si','Sledenje Setup',0),(268394,7456,'ba','Pelacakan Setup',0),(268395,7456,'nl','Bijhouden van Setup',0),(268396,7456,'fi','Seuranta-asetukset',0),(268397,7456,'no','Sporing oppsett',0),(268398,7456,'da','OpsÃ¦tning af sporing',0),(268399,7456,'ko','ì¶”ì  ì„¤ì •',0),(268400,7456,'he','×”×’×“×¨×ª ×ž×¢×§×‘',0),(268401,7456,'el','Î¡ÏÎ¸Î¼Î¹ÏƒÎ· Ï„Î·Ï‚ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚',0),(268402,7456,'zh','è·Ÿè¸ªè®¾ç½®\r\n',0),(268403,7456,'sv','SpÃ¥ra Setup',0),(268404,7456,'it','Installazione di rilevamento',0),(268405,7456,'tl','',0),(268406,7456,'th','&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(268407,7456,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤—',0),(268408,7456,'ms','Persediaan pengesanan',0),(268409,7456,'ar','ØªØªØ¨Ø¹ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(268410,7456,'fr','Suivi d\'installation',0),(268411,7456,'jp','ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°ã®è¨­å®š',0),(268412,7456,'pt','ConfiguraÃ§Ã£o de rastreamento',0),(268413,7456,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(268414,7456,'es','ConfiguraciÃ³n Rastreo',0),(268415,7456,'de','Tracking-Setup',0),(268416,7456,'en','Tracking Setup',0),(268417,7457,'is','',0),(268418,7457,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª  Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(268419,7457,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª  Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(268420,7457,'tr','KDV vergi ayarla / GST',0),(268421,7457,'pl','Zestaw podatki do VAT / GST',0),(268422,7457,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð·Ð° Ð”Ð”Ð¡ / GST',0),(268423,7457,'ur','Ø³ÛŒÙ¹ Ù¹ÛŒÚ©Ø³ Ú©Û’ Ù„Ø¦Û’ ÙˆØ§Ù¹ / GST',0),(268424,7457,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ðµ Ð·Ð° ÐŸÐ”Ð’ / Ð“Ð¡Ð¢',0),(268425,7457,'vi','ÄÃ¡nh dáº¥u Ä‘á»ƒ thuáº¿ thÃ nh VAT',0),(268426,7457,'af','Merk om belasting as BTW Belasting te hanteer',0),(268427,7457,'ro','Stabilite taxe pentru TVA / GST',0),(268428,7457,'et','MÃ¤Ã¤ra makse kÃ¤ibemaks / GST',0),(268429,7457,'si','Nastavite davkov za DDV / GST',0),(268430,7457,'ba','Menetapkan pajak untuk PPN / GST',0),(268431,7457,'nl','Aanvinken om belastingen als BTW te beschouwen',0),(268432,7457,'fi','Asettaa veroja ALV / GST',0),(268433,7457,'no','Angi avgifter for mva / GST',0),(268434,7457,'da','SÃ¦t afgifter for moms / GST',0),(268435,7457,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸ ì„¸ê¸ˆ ì„¤ì • / GST',0),(268436,7457,'he','×”×’×“×¨×ª ×ž×™×¡×™× ×¢×‘×•×¨ ×ž×¢ ×ž / GST',0),(268437,7457,'el','ÎšÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼ÏŒ Ï„Ï‰Î½ Ï„ÎµÎ»ÏŽÎ½ Î±ÎµÏÎ¿Î´ÏÎ¿Î¼Î¯Î¿Ï… Î³Î¹Î± Î¦Î Î‘ / GST',0),(268438,7457,'zh','æ£€æŸ¥å½“ä½œå¢žå€¼ç¨Žç¨Žæ¬¾\r\n',0),(268439,7457,'sv','StÃ¤lla in skatter fÃ¶r moms / GST',0),(268440,7457,'it','Impostare le imposte IVA / GST',0),(268441,7457,'tl','',0),(268442,7457,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3616;&#3634;&#3625;&#3637;&#3617;&#3641;&#3621;&#3588;&#3656;&#3634;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(268443,7457,'hi','à¤¸à¥à¤¥à¤¾à¤ªà¤¿à¤¤ à¤•à¤°à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ VAT / GST',0),(268444,7457,'ms','Menetapkan cukai bagi VAT / GST',0),(268445,7457,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©/Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø³Ù„Ø¹ ÙˆØ§Ù„Ø®Ø¯Ù…Ø§Øª',0),(268446,7457,'fr','RÃ©gler les Taxes Ã  la TVA / TPS',0),(268447,7457,'jp','ä»˜åŠ ä¾¡å€¤ç¨Žã®ç¨Žé‡‘ã‚’è¨­å®š/GST',0),(268448,7457,'pt','Definir impostos IVA / GST',0),(268449,7457,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð½Ð°Ð»Ð¾Ð³Ð¸ Ð´Ð»Ñ ÐÐ”Ð¡ / GST',0),(268450,7457,'es','Chequear para tratar impuestos como IVA',0),(268451,7457,'de','Steuern fÃ¼r MwSt eingerichtet / GST',0),(268452,7457,'en','Set Taxes for VAT / GST',0),(268453,7458,'is','',0),(268454,7458,'dr','Ø­Ø³Ø§Ø¨Ø¯Ø§Ø± Ø±Ø³Ù…ÙŠ',0),(268455,7458,'pr','Ø­Ø³Ø§Ø¨Ø¯Ø§Ø± Ø±Ø³Ù…ÙŠ',0),(268456,7458,'tr','CPA',0),(268457,7458,'pl','CPA',0),(268458,7458,'bg','CPA',0),(268459,7458,'ur','Ø³ÛŒ',0),(268460,7458,'sr','Ð¦ÐŸÐ',0),(268461,7458,'vi','CPA',0),(268462,7458,'af','CPA',0),(268463,7458,'ro','CPA',0),(268464,7458,'et','CPA',0),(268465,7458,'si','CPA',0),(268466,7458,'ba','BPA',0),(268467,7458,'nl','CPA',0),(268468,7458,'fi','CPA',0),(268469,7458,'no','CPA',0),(268470,7458,'da','CPA',0),(268471,7458,'ko','ê³µì¸ íšŒê³„ì‚¬',0),(268472,7458,'he','×¨×• ×—',0),(268473,7458,'el','CPA',0),(268474,7458,'zh','æ³¨å†Œä¼šè®¡å¸ˆ\r\n',0),(268475,7458,'sv','CPA',0),(268476,7458,'it','CPA',0),(268477,7458,'tl','',0),(268478,7458,'th','&#3612;&#3641;&#3657;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3619;&#3633;&#3610;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(268479,7458,'hi','à¤¸à¥€à¤ªà¥€à¤',0),(268480,7458,'ms','CPA',0),(268481,7458,'ar','Ø§ØªÙØ§Ù‚ Ø§Ù„Ø³Ù„Ø§Ù… Ø§Ù„Ø´Ø§Ù…Ù„',0),(268482,7458,'fr','CPA',0),(268483,7458,'jp','å…¬èªä¼šè¨ˆå£«',0),(268484,7458,'pt','CPA',0),(268485,7458,'ru','CPA',0),(268486,7458,'es','CP',0),(268487,7458,'de','CPA',0),(268488,7458,'en','CPA',0),(268489,7459,'is','',0),(268490,7459,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡ ÙŠØ§Ø³ÙˆØ®Øª Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ÙŠÙŠ ÙƒÙ‡ Ø®Ø§Ø±Ø¬ Ø§Ø² Ø¢Ù…Ø±ÙŠÙƒØ§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆÙ†Ø¯',0),(268491,7459,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡ ÙŠØ§Ø³ÙˆØ®Øª Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ÙŠÙŠ ÙƒÙ‡ Ø®Ø§Ø±Ø¬ Ø§Ø² Ø¢Ù…Ø±ÙŠÙƒØ§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆÙ†Ø¯',0),(268492,7459,'tr','Amerika BirleÅŸik Devletleri dÄ±ÅŸÄ±nda kullanÄ±lan KDV veya tÃ¼ketim vergileri',0),(268493,7459,'pl','VAT i podatkÃ³w konsumpcyjnych, ktÃ³re sÄ… uÅ¼ywane poza Stany Zjednoczone',0),(268494,7459,'bg','Ð”Ð”Ð¡ Ð¸Ð»Ð¸ Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð»ÐµÐ½Ð¸ÐµÑ‚Ð¾ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð¸Ð·Ð²ÑŠÐ½ Ð¡ÐÐ©',0),(268495,7459,'ur','ÙˆØ§Ù¹ ÛŒØ§ Ú©Ú¾Ù¾Øª Ù¹ÛŒÚ©Ø³ Ø±ÛŒØ§Ø³Øª ÛØ§Ø¦Û’ Ù…ØªØ­Ø¯Û Ø§Ù…Ø±ÛŒÚ©Û Ø³Û’ Ø¨Ø§ÛØ± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(268496,7459,'sr','ÐŸÐ”Ð’ -Ð° Ð¸Ð»Ð¸ Ð¿Ð¾Ñ‚Ñ€Ð¾ÑˆÑšÑƒ Ð¿Ð¾Ñ€ÐµÐ·Ð¸ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð²Ð°Ð½ Ð¡Ñ˜ÐµÐ´Ð¸ÑšÐµÐ½Ð¸Ñ… Ð”Ñ€Ð¶Ð°Ð²Ð°',0),(268497,7459,'vi','VAT hay thuáº¿ tiÃªu dÃ¹ng sá»­ dá»¥ng ngoÃ i Má»¹',0),(268498,7459,'af','BTW of verbruik belastings buite die Verenigde State gebruik is',0),(268499,7459,'ro','TVA sau taxe de consum sunt utilizate Ã®n afara Statelor Unite',0),(268500,7459,'et','KÃ¤ibemaksu vÃµi tarbimismaksudest kasutatakse vÃ¤ljaspool Ameerika Ãœhendriike',0),(268501,7459,'si','DDV ali davki na potroÅ¡njo, ki se uporabljajo zunaj ZdruÅ¾enih drÅ¾av Amerike',0),(268502,7459,'ba','PPN atau pajak konsumsi yang digunakan di luar Amerika Serikat',0),(268503,7459,'nl','BTW of belastingen op de consumptie worden gebruikt buiten de Verenigde Staten',0),(268504,7459,'fi','ALV tai kulutusverot kÃ¤ytetÃ¤Ã¤n muualla Yhdysvalloissa',0),(268505,7459,'no','MVA eller forbruk skatter brukes utenfor USA',0),(268506,7459,'da','MOMS eller forbrugsafgifter bruges uden for USA',0),(268507,7459,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸ ë˜ëŠ” ì†Œë¹„ ì„¸ëŠ” ë¯¸êµ­ ë°–ì— ì„œ ì‚¬ìš©',0),(268508,7459,'he','×ž×¢ ×ž ××• ×¦×¨×™×›×ª ×ž×™×¡×™× ×ž×©×ž×©×™× ×ž×—×•×¥ ×”×‘×¨×™×ª',0),(268509,7459,'el','Î¦Î Î‘ Î® Ï†ÏŒÏÎ¿Ï…Ï‚ ÎºÎ±Ï„Î±Î½Î¬Î»Ï‰ÏƒÎ·Ï‚ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ ÎµÎºÏ„ÏŒÏ‚ Î—Î½Ï‰Î¼Î­Î½Ï‰Î½ Î Î¿Î»Î¹Ï„ÎµÎ¹ÏŽÎ½',0),(268510,7459,'zh','å¢žå€¼ç¨Žæˆ–æ¶ˆè´¹ç¨Žç”¨äºŽç¾Žå›½ä»¥å¤–\r\n',0),(268511,7459,'sv','MOMS eller konsumtionsskatter anvÃ¤nds utanfÃ¶r USA',0),(268512,7459,'it','IVA o imposte di consumo sono utilizzate di fuori degli Stati Uniti',0),(268513,7459,'tl','',0),(268514,7459,'th','VAT &#3627;&#3619;&#3639;&#3629;&#3616;&#3634;&#3625;&#3637;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3650;&#3616;&#3588;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3609;&#3629;&#3585;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(268515,7459,'hi','à¤¸à¤‚à¤¯à¥à¤•à¥à¤¤ à¤°à¤¾à¤œà¥à¤¯ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ à¤•à¥‡ à¤¬à¤¾à¤¹à¤° à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¹à¥ˆ VAT à¤¯à¤¾ à¤–à¤ªà¤¤ à¤•à¤°à¥‹à¤‚',0),(268516,7459,'ms','VAT atau cukai penggunaan yang digunakan di luar Amerika Syarikat',0),(268517,7459,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ© Ø£Ùˆ Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø§Ø³ØªÙ‡Ù„Ø§Ùƒ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ø®Ø§Ø±Ø¬ Ø§Ù„ÙˆÙ„Ø§ÙŠØ§Øª Ø§Ù„Ù…ØªØ­Ø¯Ø©',0),(268518,7459,'fr','TVA ou Taxes Ã  la consommation sont utilisÃ©s Ã  l\'extÃ©rieur des Ã‰tats-Unis',0),(268519,7459,'jp','ã‚¢ãƒ¡ãƒªã‚«åˆè¡†å›½å¤–ã§ä½¿ç”¨ã•ã‚Œã‚‹ä»˜åŠ ä¾¡å€¤ç¨Žã‚„æ¶ˆè²»ç¨Žç­‰',0),(268520,7459,'pt','IVA ou impostos sobre o consumo sÃ£o utilizados fora dos Estados Unidos',0),(268521,7459,'ru','ÐÐ”Ð¡ Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð»ÐµÐ½Ð¸Ðµ, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑŽÑ‚ÑÑ Ð·Ð° Ð¿Ñ€ÐµÐ´ÐµÐ»Ð°Ð¼Ð¸ Ð¡Ð¾ÐµÐ´Ð¸Ð½ÐµÐ½Ð½Ñ‹Ñ… Ð¨Ñ‚Ð°Ñ‚Ð¾Ð²',0),(268522,7459,'es','IVA o Impuestos de ConsunciÃ³n se usan afuera de Los Estados Unidos',0),(268523,7459,'de','MwSt. oder Verbrauchssteuern werden auÃŸerhalb der Vereinigten Staaten verwendet.',0),(268524,7459,'en','VAT or Consumption Taxes are used outside United States',0),(268525,7460,'is','',0),(268526,7460,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(268527,7460,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª ',0),(268528,7460,'tr','YapÄ± sipariÅŸ numarasÄ± iÃ§in kullanÄ±lan',0),(268529,7460,'pl','Wykorzystywane do budowania numer zamÃ³wienia',0),(268530,7460,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(268531,7460,'ur','ØªØ¹Ù…ÛŒØ± Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§',0),(268532,7460,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð·Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ Ð±Ñ€Ð¾Ñ˜ Ð¸Ð·Ð´Ð°ÑšÐ°',0),(268533,7460,'vi','DÃ¹ng cho sá»‘ Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng',0),(268534,7460,'af','Gebruik vir bouvorm orde nommer',0),(268535,7460,'ro','Folosit pentru numÄƒrul de ordine construi',0),(268536,7460,'et','Kasutatud ehitada jÃ¤rjekorranumbri',0),(268537,7460,'si','Uporablja za izgradnjo zaporedno Å¡tevilko',0),(268538,7460,'ba','Digunakan untuk membangun nomor pesanan',0),(268539,7460,'nl','Gebruikt voor Build ordernummer',0),(268540,7460,'fi','KÃ¤ytetÃ¤Ã¤n rakentaa numero',0),(268541,7460,'no','Brukes til Ã¥ bygge ordrenummer',0),(268542,7460,'da','Anvendes til opbygge ordre antal',0),(268543,7460,'ko','ë¹Œë“œ ìˆœì„œ ë²ˆí˜¸ ì‚¬ìš©',0),(268544,7460,'he','×ž×©×ž×© ×ž×¡×¤×¨ ×”×–×ž× ×” ×œ×‘× ×•×ª',0),(268545,7460,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Î±ÏÎ¾Ï‰Î½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(268546,7460,'zh','ç”¨äºŽæž„å»ºè®¢å•ç¼–å·\r\n',0),(268547,7460,'sv','AnvÃ¤nds fÃ¶r att bygga ordernummer',0),(268548,7460,'it','Utilizzato per il numero di ordine di compilazione',0),(268549,7460,'tl','',0),(268550,7460,'th','&#3651;&#3594;&#3657;&#3626;&#3619;&#3657;&#3634;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(268551,7460,'hi','à¤¬à¤¿à¤²à¥à¤¡ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(268552,7460,'ms','Digunakan untuk membina nombor pesanan',0),(268553,7460,'ar','ÙŠØ³ØªØ®Ø¯Ù… Ù„Ø¨Ù†Ø§Ø¡ Ø§Ù„Ù†Ø¸Ø§Ù… Ø±Ù‚Ù…',0),(268554,7460,'fr','UtilisÃ© pour le numÃ©ro de commande Build',0),(268555,7460,'jp','ãƒ“ãƒ«ãƒ‰ç•ªå·ã®ä½¿ç”¨',0),(268556,7460,'pt','Usado para o nÃºmero de ordem de compilaÃ§Ã£o',0),(268557,7460,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(268558,7460,'es','Usado para NÃºmero de Orden de ConstrucciÃ³n',0),(268559,7460,'de','Verwendet fÃ¼r Build-Bestellnummer',0),(268560,7460,'en','Used for Build Order Number',0),(268561,7461,'is','',0),(268562,7461,'dr','1',0),(268563,7461,'pr','Ø«Ø¨Øª  Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø± ÙÙŠÙ„Ø¯ 1',0),(268564,7461,'tr','KullanÄ±cÄ± tanÄ±mlÄ± alan 1 girin',0),(268565,7461,'pl','WprowadÅº pole uÅ¼ytkownika 1',0),(268566,7461,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ€Ð°Ð½Ð¾ Ð¾Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð¿Ð¾Ð»Ðµ 1',0),(268567,7461,'ur','ØµØ§Ø±Ù ÙˆØ¶Ø§Ø­ØªÛŒ Ù‚Ø·Ø¹Û 1 Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(268568,7461,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸ Ð´ÐµÑ„Ð¸Ð½Ð¸ÑÐ°Ð½Ð¾ Ð¿Ð¾Ñ™Ðµ 1',0),(268569,7461,'vi','Nháº­p trÆ°á»ng ngÆ°á»i sá»­ dá»¥ng tá»± Ä‘á»‹nh nghÄ©a 1',0),(268570,7461,'af','Betree Gebruikergedefinieerde Veld 1',0),(268571,7461,'ro','IntroduceÅ£i cÃ¢mp definit de utilizator 1',0),(268572,7461,'et','Sisestage kasutaja mÃ¤Ã¤ratletud vÃ¤li 1',0),(268573,7461,'si','Vnesite uporabniÅ¡ko doloÄeno polje 1',0),(268574,7461,'ba','Masukkan User-Defined Field 1',0),(268575,7461,'nl','Voer Gebruikersveld 1',0),(268576,7461,'fi','Kirjoita kÃ¤yttÃ¤jÃ¤n mÃ¤Ã¤rittÃ¤mÃ¤ kenttÃ¤ 1',0),(268577,7461,'no','Angi brukerdefinerte felt 1',0),(268578,7461,'da','Indtast bruger-defineret felt 1',0),(268579,7461,'ko','ì‚¬ìš©ìž ì •ì˜ í•„ë“œ 1ì„ ìž…ë ¥',0),(268580,7461,'he','×”×–×Ÿ ×‘×©×“×” ×¢×œ-×™×“×™ ×”×ž×©×ª×ž×© 1',0),(268581,7461,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î¿ Ï€ÎµÎ´Î¯Î¿ Ï‡ÏÎ®ÏƒÏ„Î· 1',0),(268582,7461,'zh','è¾“å…¥ç”¨æˆ·å®šä¹‰çš„å­—æ®µ1\r\n',0),(268583,7461,'sv','Ange anvÃ¤ndardefinierade fÃ¤lt 1',0),(268584,7461,'it','Inserisci campo definito dall\'utente 1',0),(268585,7461,'tl','',0),(268586,7461,'th','&#3611;&#3657;&#3629;&#3609;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3585;&#3635;&#3627;&#3609;&#3604;&#3615;&#3636;&#3621;&#3604;&#3660; 1',0),(268587,7461,'hi','à¤¯à¥‚à¤œà¤¼à¤°-à¤¡à¤¿à¤«à¤¼à¤¾à¤‡à¤‚à¤¡ à¤«à¤¼à¥€à¤²à¥à¤¡ 1 à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(268588,7461,'ms','Masukkan Field takrifan pengguna 1',0),(268589,7461,'ar','Ø£Ø¯Ø®Ù„ 1 ÙÙŠ Ø­Ù‚Ù„ Ø§Ù„Ù…Ø¹Ø±ÙØ© Ù…Ù† Ù‚Ø¨Ù„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(268590,7461,'fr','Entrer dans le champ dÃ©fini par lâ€™utilisateur 1',0),(268591,7461,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼å®šç¾©ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ 1 ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(268592,7461,'pt','Digite o campo definido pelo usuÃ¡rio 1',0),(268593,7461,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ð¿Ð¾Ð»Ñ 1',0),(268594,7461,'es','Introducir Campo Definido por Usuario 1',0),(268595,7461,'de','Geben Sie benutzerdefinierte Feld 1',0),(268596,7461,'en','Enter User-Defined Field 1',0),(268597,7462,'is','',0),(268598,7462,'dr','2  ',0),(268599,7462,'pr','Ø«Ø¨Øª  Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø± ÙÙŠÙ„Ø¯ 2  ',0),(268600,7462,'tr','KullanÄ±cÄ± tanÄ±mlÄ± alan 2 girin',0),(268601,7462,'pl','WprowadÅº uÅ¼ytkownika pole 2',0),(268602,7462,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ€Ð°Ð½Ð¾ Ð¾Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð¿Ð¾Ð»Ðµ 2',0),(268603,7462,'ur','ØµØ§Ø±Ù ÙˆØ¶Ø§Ø­ØªÛŒ Ù‚Ø·Ø¹Û 2 Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(268604,7462,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸ Ð´ÐµÑ„Ð¸Ð½Ð¸ÑÐ°Ð½Ð¾ Ð¿Ð¾Ñ™Ðµ 2',0),(268605,7462,'vi','Nháº­p trÆ°á»ng ngÆ°á»i sá»­ dá»¥ng tá»± Ä‘á»‹nh nghÄ©a 2',0),(268606,7462,'af','Betree Gebruikergedefinieerde Veld 2',0),(268607,7462,'ro','IntroduceÅ£i cÃ¢mp definit de utilizator 2',0),(268608,7462,'et','Sisestage kasutaja mÃ¤Ã¤ratletud vÃ¤li 2',0),(268609,7462,'si','Vnesite uporabniÅ¡ko doloÄeno polje 2',0),(268610,7462,'ba','Masukkan User-Defined Lapangan 2',0),(268611,7462,'nl','Geef de gebruiker gedefinieerd veld 2',0),(268612,7462,'fi','Kirjoita kÃ¤yttÃ¤jÃ¤n mÃ¤Ã¤rittÃ¤mÃ¤ kenttÃ¤ 2',0),(268613,7462,'no','Angi brukerdefinert felt 2',0),(268614,7462,'da','Indtast bruger-defineret felt 2',0),(268615,7462,'ko','ì‚¬ìš©ìž ì •ì˜ í•„ë“œ 2 ìž…ë ¥',0),(268616,7462,'he','×”×–×Ÿ ×©×“×” ×ž×•×’×“×¨ ×¢×œ-×™×“×™ ×”×ž×©×ª×ž×© 2',0),(268617,7462,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î¿ Ï€ÎµÎ´Î¯Î¿ Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î¿ Î±Ï€ÏŒ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î· 2',0),(268618,7462,'zh','è¾“å…¥ç”¨æˆ·å®šä¹‰çš„å­—æ®µ2\r\n',0),(268619,7462,'sv','Ange anvÃ¤ndardefinierade fÃ¤lt 2',0),(268620,7462,'it','Inserisci campo definito dall\'utente 2',0),(268621,7462,'tl','',0),(268622,7462,'th','&#3611;&#3657;&#3629;&#3609;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3585;&#3635;&#3627;&#3609;&#3604;&#3615;&#3636;&#3621;&#3604;&#3660; 2',0),(268623,7462,'hi','à¤¯à¥‚à¤œà¤¼à¤°-à¤¡à¤¿à¤«à¤¼à¤¾à¤‡à¤‚à¤¡ à¤«à¤¼à¥€à¤²à¥à¤¡ 2 à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(268624,7462,'ms','Masukkan takrifan pengguna bidang 2',0),(268625,7462,'ar','Ø£Ø¯Ø®Ù„ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ø¹Ø±ÙØ© Ù…Ù† Ù‚Ø¨Ù„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… 2',0),(268626,7462,'fr','Entrer dans le champ dÃ©fini par lâ€™utilisateur 2',0),(268627,7462,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼å®šç¾©ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ 2 ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(268628,7462,'pt','Digite o campo definido pelo usuÃ¡rio 2',0),(268629,7462,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ð¿Ð¾Ð»Ñ 2',0),(268630,7462,'es','Introducir Campo Definido por Usuario 2',0),(268631,7462,'de','Geben Sie benutzerdefinierte Feld 2',0),(268632,7462,'en','Enter User-Defined Field 2',0),(268633,7463,'is','',0),(268634,7463,'dr','Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(268635,7463,'pr','Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(268636,7463,'tr','Vergiden Ã¶deme kategorisi',0),(268637,7463,'pl','Kategorii opodatkowaniu pÅ‚ac',0),(268638,7463,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð½ÐµÐ·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(268639,7463,'ur','Ù…Ø³ØªØ«Ù†Ù°ÛŒ Ø§Ø¯Ø§ Ø²Ù…Ø±Û',0),(268640,7463,'sr','ÐšÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ðµ Ð¾Ð¿Ð¾Ñ€ÐµÐ·ÑƒÑ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(268641,7463,'vi','Thá»ƒ loáº¡i thanh toÃ¡n khÃ´ng thuáº¿ ',0),(268642,7463,'af','Nie-Belasbare Besoldiging Kategorie',0),(268643,7463,'ro','Neimpozabile plÄƒteascÄƒ categorie',0),(268644,7463,'et','Mittemaksukohustuslasest maksma kategooria',0),(268645,7463,'si','DavÄni zavezanec plaÄati Kategorija',0),(268646,7463,'ba','Tidak kena pajak membayar Kategori',0),(268647,7463,'nl','Niet-belastingplichtige betalen categorie',0),(268648,7463,'fi','Verovelvollisen maksuluokassa',0),(268649,7463,'no','Ikke-skattepliktige lÃ¸nnskategorien',0),(268650,7463,'da','Ikke-afgiftspligtige lÃ¸nkategori',0),(268651,7463,'ko','ë¹„ ê³¼ì„¸ ê¸‰ì—¬ ì¹´í…Œê³ ë¦¬',0),(268652,7463,'he','×§×˜×’×•×¨×™×™×ª ×”×©×›×¨ ×©××™× ×• ×—×™×™×‘ ×œ×©×œ×',0),(268653,7463,'el','Î‘Ï†Î¿ÏÎ¿Î»ÏŒÎ³Î·Ï„Î¿ Î±Î¼Î¿Î¹Î²ÏŽÎ½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(268654,7463,'zh','éžåº”ç¨Žå·¥èµ„ç±»åˆ«\r\n',0),(268655,7463,'sv','Icke beskattningsbara lÃ¶nekategorin',0),(268656,7463,'it','Categoria paga non soggetti passivi',0),(268657,7463,'tl','',0),(268658,7463,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;',0),(268659,7463,'hi','à¤—à¥ˆà¤°-à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(268660,7463,'ms','Kategori gaji tidak dikenakan cukai',0),(268661,7463,'ar','ÙØ¦Ø© Ø§Ù„Ø£Ø¬ÙˆØ± ØºÙŠØ± Ø§Ù„Ø®Ø§Ø¶Ø¹Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(268662,7463,'fr','CatÃ©gorie de salaire non imposable',0),(268663,7463,'jp','éžèª²ç¨Žçµ¦ä¸Žã‚«ãƒ†ã‚´ãƒª',0),(268664,7463,'pt','Categoria de pagamento nÃ£o-tributÃ¡veis',0),(268665,7463,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð½Ðµ Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ñ‹Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼',0),(268666,7463,'es','CategorÃ­a de Pago No Imponible',0),(268667,7463,'de','Nichtsteuerpflichtige Pay-Kategorie',0),(268668,7463,'en','Nontaxable Pay Category',0),(268669,7464,'is','',0),(268670,7464,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ ',0),(268671,7464,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ ',0),(268672,7464,'tr','Ek vergi',0),(268673,7464,'pl','Dodatkowe zobowiÄ…zanie podatkowe',0),(268674,7464,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº',0),(268675,7464,'ur','Ø§Ø¶Ø§ÙÛŒ Ù¹ÛŒÚ©Ø³',0),(268676,7464,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(268677,7464,'vi','Thuáº¿ Cá»™ng ThÃªm',0),(268678,7464,'af','Adisionele Belastings',0),(268679,7464,'ro','Taxe suplimentare',0),(268680,7464,'et','Lisamaks',0),(268681,7464,'si','Dodatni davek',0),(268682,7464,'ba','Pajak Tambahan',0),(268683,7464,'nl','Extra belasting',0),(268684,7464,'fi','LisÃ¤vero',0),(268685,7464,'no','Tilleggsavgift',0),(268686,7464,'da','Ekstra skat',0),(268687,7464,'ko','ì¶”ê°€ ì„¸ê¸ˆ',0),(268688,7464,'he','×ž×¡ × ×•×¡×£',0),(268689,7464,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î¿Ï‚ Ï†ÏŒÏÎ¿Ï‚',0),(268690,7464,'zh','é™„åŠ ç¨Ž\r\n',0),(268691,7464,'sv','Extra skatt',0),(268692,7464,'it','Imposta addizionale',0),(268693,7464,'tl','',0),(268694,7464,'th','&#3616;&#3634;&#3625;&#3637;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(268695,7464,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤•à¤°',0),(268696,7464,'ms','Cukai tambahan',0),(268697,7464,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø¥Ø¶Ø§ÙÙŠØ©',0),(268698,7464,'fr','Taxe SupplÃ©mentaire',0),(268699,7464,'jp','ä»˜åŠ ç¨Ž',0),(268700,7464,'pt','Imposto adicional',0),(268701,7464,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÐÐ°Ð»Ð¾Ð³',0),(268702,7464,'es','Impuesto Adicional',0),(268703,7464,'de','ZusÃ¤tzliche Steuer',0),(268704,7464,'en','Additional Tax',0),(268705,7465,'is','',0),(268706,7465,'dr','1',0),(268707,7465,'pr','ÙÙŠÙ„Ø¯ Ø§Ø¶Ø§ÙÙŠ   1',0),(268708,7465,'tr','Ekstra alanÄ± 1',0),(268709,7465,'pl','Dodatkowe pole 1',0),(268710,7465,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¿Ð¾Ð»Ðµ 1',0),(268711,7465,'ur','Ø§Ø¶Ø§ÙÛŒ Ù‚Ø·Ø¹Û 1',0),(268712,7465,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¾ Ð¿Ð¾Ñ™Ðµ 1',0),(268713,7465,'vi','TrÆ°á»ng thÃªm 1',0),(268714,7465,'af','Bykomende Veld 1',0),(268715,7465,'ro','CÃ¢mp suplimentar 1',0),(268716,7465,'et','Eest vÃ¤lja 1',0),(268717,7465,'si','Dodatno polje 1',0),(268718,7465,'ba','Bidang tambahan 1',0),(268719,7465,'nl','Extra veld 1',0),(268720,7465,'fi','Kun kenttÃ¤ 1',0),(268721,7465,'no','Ekstra felt 1',0),(268722,7465,'da','Ekstra felt 1',0),(268723,7465,'ko','ì—¬ë¶„ í•„ë“œ 1',0),(268724,7465,'he','×©×“×” × ×•×¡×£ 1',0),(268725,7465,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Ï€ÎµÎ´Î¯Î¿ 1',0),(268726,7465,'zh','é¢å¤–çš„å­—æ®µ1\r\n',0),(268727,7465,'sv','Extra fÃ¤lt 1',0),(268728,7465,'it','Campo aggiuntivo 1',0),(268729,7465,'tl','',0),(268730,7465,'th','&#3607;&#3637;&#3656;&#3592;&#3633;&#3604;&#3648;&#3585;&#3655;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3614;&#3636;&#3648;&#3624;&#3625; 1',0),(268731,7465,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤«à¤¼à¥€à¤²à¥à¤¡ 1',0),(268732,7465,'ms','Tambahan bidang 1',0),(268733,7465,'ar','Ø­Ù‚Ù„ Ø¥Ø¶Ø§ÙÙŠ 1',0),(268734,7465,'fr','Champ supplÃ©mentaire 1',0),(268735,7465,'jp','ä½™åˆ†ãªãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ 1',0),(268736,7465,'pt','Campo extra 1',0),(268737,7465,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ð¿Ð¾Ð»Ðµ 1',0),(268738,7465,'es','Extra Campo 1',0),(268739,7465,'de','ZusÃ¤tzliches Feld 1',0),(268740,7465,'en','Extra Field 1',0),(268741,7466,'is','',0),(268742,7466,'dr','2 ',0),(268743,7466,'pr','ÙÙŠÙ„Ø¯ Ø§Ø¶Ø§ÙÙŠ   2 ',0),(268744,7466,'tr','Ekstra alan 2',0),(268745,7466,'pl','Dodatkowe pole 2',0),(268746,7466,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¿Ð¾Ð»Ðµ 2',0),(268747,7466,'ur','Ø§Ø¶Ø§ÙÛŒ Ù‚Ø·Ø¹Û 2',0),(268748,7466,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¾ Ð¿Ð¾Ñ™Ðµ 2',0),(268749,7466,'vi','TrÆ°á»ng thÃªm 2',0),(268750,7466,'af','Bykomende Veld 2',0),(268751,7466,'ro','CÃ¢mp suplimentar 2',0),(268752,7466,'et','Eest vÃ¤lja 2',0),(268753,7466,'si','Dodatno polje 2',0),(268754,7466,'ba','Tambahan Lapangan 2',0),(268755,7466,'nl','Extra veld 2',0),(268756,7466,'fi','Kun kenttÃ¤ 2',0),(268757,7466,'no','Ekstra felt 2',0),(268758,7466,'da','Ekstra felt 2',0),(268759,7466,'ko','ì—¬ë¶„ í•„ë“œ 2',0),(268760,7466,'he','×©×“×” × ×•×¡×£ 2',0),(268761,7466,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Ï€ÎµÎ´Î¯Î¿ 2',0),(268762,7466,'zh','é¢å¤–å­—æ®µ2\r\n',0),(268763,7466,'sv','Extra fÃ¤lt 2',0),(268764,7466,'it','Campo aggiuntivo 2',0),(268765,7466,'tl','',0),(268766,7466,'th','&#3607;&#3637;&#3656;&#3592;&#3633;&#3604;&#3648;&#3585;&#3655;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3614;&#3636;&#3648;&#3624;&#3625; 2',0),(268767,7466,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤«à¤¼à¥€à¤²à¥à¤¡ 2',0),(268768,7466,'ms','Tambahan bidang 2',0),(268769,7466,'ar','Ø­Ù‚Ù„ Ø¥Ø¶Ø§ÙÙŠ 2',0),(268770,7466,'fr','Champ supplÃ©mentaire 2',0),(268771,7466,'jp','ä½™åˆ†ãªãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ 2',0),(268772,7466,'pt','Campo extra 2',0),(268773,7466,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ð¿Ð¾Ð»Ðµ 2',0),(268774,7466,'es','Extra campo 2',0),(268775,7466,'de','ZusÃ¤tzliches Feld 2',0),(268776,7466,'en','Extra Field 2',0),(268777,7467,'is','',0),(268778,7467,'dr','Ø¨Ø§ÙŠØ¯ ÙƒØ³Ø± Ø´ÙˆØ¯',0),(268779,7467,'pr','Ø¨Ø§ÙŠØ¯ ÙƒØ³Ø± Ø´ÙˆØ¯',0),(268780,7467,'tr','Mahsup edilebilir',0),(268781,7467,'pl','NaleÅ¼y odjÄ…Ä‡',0),(268782,7467,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð½Ðµ',0),(268783,7467,'ur','Ù…Ù†ÛØ§ Ù†ÛÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(268784,7467,'sr','Ð¢Ñ€ÐµÐ±Ð°Ð»Ð¾ Ð±Ð¸ Ð´Ð° Ð±ÑƒÐ´Ðµ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½.',0),(268785,7467,'vi','Pháº£i giáº£m trá»«',0),(268786,7467,'af','Moet afgetrek word',0),(268787,7467,'ro','Ar trebui dedusÄƒ',0),(268788,7467,'et','Tuleks maha',0),(268789,7467,'si','Bi bilo treba odÅ¡teti',0),(268790,7467,'ba','Harus dikurangi',0),(268791,7467,'nl','Dient te worden afgetrokken',0),(268792,7467,'fi','On vÃ¤hennettÃ¤vÃ¤',0),(268793,7467,'no','BÃ¸r trekkes',0),(268794,7467,'da','Skal fratrÃ¦kkes',0),(268795,7467,'ko','ê³µì œ í•œë‹¤',0),(268796,7467,'he','×¦×¨×™×š ×œ×”×™×•×ª ×ž×•×¤×—×ª×•×ª',0),(268797,7467,'el','Î˜Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯',0),(268798,7467,'zh','åº”æ‰£é™¤\r\n',0),(268799,7467,'sv','BÃ¶r dras',0),(268800,7467,'it','Dovrebbe essere detratto',0),(268801,7467,'tl','',0),(268802,7467,'th','&#3588;&#3623;&#3619;&#3592;&#3632;&#3607;&#3635;&#3651;&#3627;&#3657;&#3621;&#3604;&#3621;&#3591;',0),(268803,7467,'hi','à¤•à¤¾à¤Ÿ à¤°à¤¹à¤¾ à¤¹à¥‹ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(268804,7467,'ms','Perlu ditolak',0),(268805,7467,'ar','ÙˆÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ÙŠÙƒÙˆÙ† Ø®ØµÙ…',0),(268806,7467,'fr','Devraient Ãªtre dÃ©duites',0),(268807,7467,'jp','æŽ§é™¤ã•ã‚Œã‚‹ã¹ã',0),(268808,7467,'pt','Deve ser deduzido',0),(268809,7467,'ru','Ð¡Ð»ÐµÐ´ÑƒÐµÑ‚ Ð²Ñ‹Ñ‡ÐµÑÑ‚ÑŒ',0),(268810,7467,'es','Debe Ser Deducido',0),(268811,7467,'de','Sollten abgezogen',0),(268812,7467,'en','Should Be Deducted',0),(268813,7468,'is','',0),(268814,7468,'dr','Ø­Ù‚ÙˆÙ‚ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª  ÙŠØ§ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆØ¬Ù‡',0),(268815,7468,'pr','Ø­Ù‚ÙˆÙ‚ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª  ÙŠØ§ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆØ¬Ù‡',0),(268816,7468,'tr','Vergiden maaÅŸ veya Reimburesements',0),(268817,7468,'pl','Opodatkowaniu pÅ‚ac lub Reimburesements',0),(268818,7468,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð½ÐµÐ·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¸Ð»Ð¸ Reimburesements',0),(268819,7468,'ur','Ù…Ø³ØªØ«Ù†Ù°ÛŒ ØªÙ†Ø®ÙˆØ§Û ÛŒØ§ Ø±ÛŒØ§Ù…Ø¨Ø±ÛŒØ³ÛŒÙ…Ø§Ù†Ù¹',0),(268820,7468,'sr','ÐÐ¾Ð²Ð°Ñ† ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ðµ Ð¾Ð¿Ð¾Ñ€ÐµÐ·ÑƒÑ˜Ðµ Ð¸Ð»Ð¸ Ð ÐµÐ¸Ð¼Ð±ÑƒÑ€ÐµÑÐµÐ¼ÐµÐ½Ñ‚Ñ',0),(268821,7468,'vi','Thanh toÃ¡n hay hoÃ n láº¡i khÃ´ng chá»‹u thuáº¿',0),(268822,7468,'af','Nie-Belasbare Besoldiging of Terugbetalings',0),(268823,7468,'ro','Neimpozabile plata sau Reimburesements',0),(268824,7468,'et','Mittemaksukohustuslasest maksma vÃµi Reimburesements',0),(268825,7468,'si','DavÄni zavezanec plaÄati ali Reimburesements',0),(268826,7468,'ba','Membayar tidak kena pajak atau Reimburesements',0),(268827,7468,'nl','Niet-belastbare loon of Reimburesements',0),(268828,7468,'fi','Verovelvollisen maksu tai Reimburesements',0),(268829,7468,'no','Ikke-skattepliktige lÃ¸nn eller Reimburesements',0),(268830,7468,'da','Ikke-afgiftspligtige lÃ¸n eller Reimburesements',0),(268831,7468,'ko','ë¹„ ê³¼ì„¸ ê¸‰ì—¬ ë˜ëŠ” Reimburesements',0),(268832,7468,'he','×©××™× ×• ×—×™×™×‘ ×œ×©×œ× ×©×›×¨ ××• Reimburesements',0),(268833,7468,'el','Î‘Ï†Î¿ÏÎ¿Î»ÏŒÎ³Î·Ï„Î¿ Î±Î¼Î¿Î¹Î²ÏŽÎ½ Î® Reimburesements',0),(268834,7468,'zh','éžåº”ç¨Žæ”¯ä»˜æˆ–å¿è¿˜\r\n',0),(268835,7468,'sv','Icke beskattningsbara lÃ¶n eller Reimburesements',0),(268836,7468,'it','Non imponibile paga o Reimburesements',0),(268837,7468,'tl','',0),(268838,7468,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;&#3627;&#3619;&#3639;&#3629;&#3585;&#3634;&#3619;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;&#3651;&#3627;&#3657;',0),(268839,7468,'hi','à¤—à¥ˆà¤°-à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨ à¤¯à¤¾ Reimburesements',0),(268840,7468,'ms','Tidak dikenakan cukai gaji atau Reimburesements',0),(268841,7468,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± ØºÙŠØ± Ø§Ù„Ø®Ø§Ø¶Ø¹Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ø£Ùˆ Ø±ÙŠÙ…Ø¨ÙˆØ±ÙŠØ³ÙŠÙ…ÙŠÙ†ØªØ³',0),(268842,7468,'fr','RÃ©munÃ©ration non imposable ou Reimburesements',0),(268843,7468,'jp','éžèª²ç¨Žçµ¦ä¸Žåˆã¯ Reimburesements',0),(268844,7468,'pt','NÃ£o-tributÃ¡veis pagar ou Reimburesements',0),(268845,7468,'ru','ÐÐµ Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ñ‹Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼ Ð²Ð¾Ð·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¸Ð»Ð¸ Reimburesements',0),(268846,7468,'es','Pagos o Reembolsos No Imponibles',0),(268847,7468,'de','Steuerfreie Bezahlung oder Reimburesements',0),(268848,7468,'en','Nontaxable Pay or Reimburesements',0),(268849,7469,'is','',0),(268850,7469,'dr','Ú†Ø§Ù¾ ØªØ§ÙŠÙŠØ¯ ÙŠÙ‡  Ø³ÙØ§Ø±Ø´ ',0),(268851,7469,'pr','Ú†Ø§Ù¾ ØªØ§ÙŠÙŠØ¯ ÙŠÙ‡  Ø³ÙØ§Ø±Ø´ ',0),(268852,7469,'tr','SipariÅŸ onayÄ± YazdÄ±r',0),(268853,7469,'pl','WydrukowaÄ‡ potwierdzenie zamÃ³wienia',0),(268854,7469,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(268855,7469,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚',0),(268856,7469,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(268857,7469,'vi','In xÃ¡c nháº­n Ä‘Æ¡n hÃ ng',0),(268858,7469,'af','Druk Bestellingsbevestiging',0),(268859,7469,'ro','Confirmarea comenzii tipÄƒrire',0),(268860,7469,'et','Prindi kinnitus',0),(268861,7469,'si','Natisnete potrditve naroÄila',0),(268862,7469,'ba','Mencetak konfirmasi Order',0),(268863,7469,'nl','Bevestiging van bestelling afdrukken',0),(268864,7469,'fi','Tulosta vahvistus',0),(268865,7469,'no','Skrive ut ordrebekreftelsen',0),(268866,7469,'da','Udskrive ordrebekrÃ¦ftelsen',0),(268867,7469,'ko','ì¸ì‡„ ì£¼ë¬¸ í™•ì¸',0),(268868,7469,'he','×œ×”×“×¤×™×¡ ××ª ××™×©×•×¨ ×”×”×–×ž× ×”',0),(268869,7469,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(268870,7469,'zh','æ‰“å°è®¢å•ç¡®è®¤\r\n',0),(268871,7469,'sv','Skriv ut orderbekrÃ¤ftelse',0),(268872,7469,'it','Stampare la conferma d\'ordine',0),(268873,7469,'tl','',0),(268874,7469,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3585;&#3634;&#3619;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(268875,7469,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(268876,7469,'ms','Cetak pengesahan',0),(268877,7469,'ar','ØªØ£ÙƒÙŠØ¯ Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(268878,7469,'fr','Imprimer la Confirmation de commande',0),(268879,7469,'jp','å°åˆ·ã®æ³¨æ–‡ç¢ºèªæ›¸',0),(268880,7469,'pt','ConfirmaÃ§Ã£o de ordem de impressÃ£o',0),(268881,7469,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ Ð—Ð°ÐºÐ°Ð·Ð°',0),(268882,7469,'es','ConfirmaciÃ³n de Orden de ImpresiÃ³n',0),(268883,7469,'de','AuftragsbestÃ¤tigung drucken',0),(268884,7469,'en','Print Order Confirmation',0),(268885,7470,'is','',0),(268886,7470,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´',0),(268887,7470,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø³ÙØ§Ø±Ø´',0),(268888,7470,'tr','SipariÅŸ arama',0),(268889,7470,'pl','KolejnoÅ›Ä‡ wyszukiwania',0),(268890,7470,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(268891,7470,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªÙ„Ø§Ø´',0),(268892,7470,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(268893,7470,'vi','TÃ¬m Ä‘Æ¡n hÃ ng',0),(268894,7470,'af','Bestelling Soektog',0),(268895,7470,'ro','Comanda cÄƒutare',0),(268896,7470,'et','Tellimuse otsing',0),(268897,7470,'si','Vrstni red iskanja',0),(268898,7470,'ba','Urutan pencarian',0),(268899,7470,'nl','Volgorde zoeken',0),(268900,7470,'fi','Jotta haku',0),(268901,7470,'no','For sÃ¸k',0),(268902,7470,'da','Bestil SÃ¸g',0),(268903,7470,'ko','ì£¼ë¬¸ ê²€ìƒ‰',0),(268904,7470,'he','×¦×• ×—×™×¤×•×©',0),(268905,7470,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(268906,7470,'zh','è®¢å•æŸ¥è¯¢\r\n',0),(268907,7470,'sv','BestÃ¤llning sÃ¶kning',0),(268908,7470,'it','Ricerca di ordine',0),(268909,7470,'tl','',0),(268910,7470,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(268911,7470,'hi','à¤†à¤¦à¥‡à¤¶ à¤–à¥‹à¤œà¥‡à¤‚',0),(268912,7470,'ms','Carian pesanan',0),(268913,7470,'ar','Ø£Ù…Ø± Ø§Ù„Ø¨Ø­Ø«',0),(268914,7470,'fr','Recherche de commande',0),(268915,7470,'jp','ã”æ³¨æ–‡ã®æ¤œç´¢',0),(268916,7470,'pt','Busca de ordem',0),(268917,7470,'ru','ÐŸÐ¾Ð¸ÑÐº Ð—Ð°ÐºÐ°Ð·Ð°',0),(268918,7470,'es','Orden Busqueda',0),(268919,7470,'de','Bestellung Suche',0),(268920,7470,'en','Order Search',0),(268921,7471,'is','',0),(268922,7471,'dr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(268923,7471,'pr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(268924,7471,'tr','Yeri yeniden sÄ±ralama',0),(268925,7471,'pl','Miejsce ponownego',0),(268926,7471,'bg','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(268927,7471,'ur','Ø¬Ú¯Û Ø±ÛŒÚ©Ø§Ø±ÚˆØ±',0),(268928,7471,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(268929,7471,'vi','Äáº·t hÃ ng láº¡i',0),(268930,7471,'af','Plaas Herbestelling',0),(268931,7471,'ro','Locul reordona',0),(268932,7471,'et','JÃ¤rjesta Ã¼mber paigutada',0),(268933,7471,'si','Kraj naroÄanja',0),(268934,7471,'ba','Menyusun ulang tempat',0),(268935,7471,'nl','Plaats opnieuw ordenen',0),(268936,7471,'fi','Paikka JÃ¤rjestÃ¤',0),(268937,7471,'no','Plass ordne',0),(268938,7471,'da','Placer Ordn igen',0),(268939,7471,'ko','ìž¥ì†Œ ìˆœì„œ',0),(268940,7471,'he','×¡×“×¨ ×ž×—×“×© ××ª ×”×ž×§×•×',0),(268941,7471,'el','Î£Î·Î¼ÎµÎ¯Î¿ Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(268942,7471,'zh','å°±åœ°é‡æ–°æŽ’åº\r\n',0),(268943,7471,'sv','Placera orderkvantitet',0),(268944,7471,'it','Riordino del posto',0),(268945,7471,'tl','',0),(268946,7471,'th','&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(268947,7471,'hi','à¤œà¤—à¤¹ à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(268948,7471,'ms','Susun semula tempat',0),(268949,7471,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…ÙƒØ§Ù†',0),(268950,7471,'fr','Place Reorder',0),(268951,7471,'jp','å ´æ‰€ã®ä¸¦ã¹æ›¿ãˆ',0),(268952,7471,'pt','Lugar reordenar',0),(268953,7471,'ru','ÐœÐµÑÑ‚Ð¾ Ð´Ð¾Ð·Ð°ÐºÐ°Ð·Ð°',0),(268954,7471,'es','Hacer Reorden',0),(268955,7471,'de','Platz neu anordnen',0),(268956,7471,'en','Place Reorder',0),(268957,7472,'is','',0),(268958,7472,'dr','ØªØ§ÙŠÙŠØ¯ Ø­Ù…Ù„\r\n',0),(268959,7472,'pr','ØªØ§ÙŠÙŠØ¯ Ø­Ù…Ù„\r\n',0),(268960,7472,'tr','Gemi ACK',0),(268961,7472,'pl','Statek ACK',0),(268962,7472,'bg','ÐšÐ¾Ñ€Ð°Ð± ACK',0),(268963,7472,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ø§Ú©',0),(268964,7472,'sr','Ð‘Ñ€Ð¾Ð´ ÐÐ¦Ðš',0),(268965,7472,'vi','XÃ¡c nháº­n váº­n chuyá»ƒn ',0),(268966,7472,'af','Skip ACK',0),(268967,7472,'ro','Nava ACK',0),(268968,7472,'et','Laeva ACK',0),(268969,7472,'si','Ladja ACK',0),(268970,7472,'ba','Kapal ACK',0),(268971,7472,'nl','Schip ACK',0),(268972,7472,'fi','Aluksen ACK',0),(268973,7472,'no','Skipet ACK',0),(268974,7472,'da','Skibet ACK',0),(268975,7472,'ko','ë°° ACK',0),(268976,7472,'he','×”×¡×¤×™× ×” ACK',0),(268977,7472,'el','Î Î»Î¿Î¯Î¿ ACK',0),(268978,7472,'zh','èˆ¹èˆ¶è‡´è°¢\r\n',0),(268979,7472,'sv','Fartyget ACK',0),(268980,7472,'it','Nave ACK',0),(268981,7472,'tl','',0),(268982,7472,'th','&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(268983,7472,'hi','à¤œà¤¹à¤¾à¤œ ACK',0),(268984,7472,'ms','Kapal ACK',0),(268985,7472,'ar','Ø³ÙÙŠÙ†Ø© ACK',0),(268986,7472,'fr','Navire ACK',0),(268987,7472,'jp','èˆ¹ ACK',0),(268988,7472,'pt','Navio ACK',0),(268989,7472,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ ACK',0),(268990,7472,'es','Enviar ACK',0),(268991,7472,'de','Schiff ACK',0),(268992,7472,'en','Ship ACK',0),(268993,7473,'is','',0),(268994,7473,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø´Ù…Ø§',0),(268995,7473,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø´Ù…Ø§',0),(268996,7473,'tr','PO numarasÄ±',0),(268997,7473,'pl','TwÃ³j numer zamÃ³wienia',0),(268998,7473,'bg','Ð’Ð°ÑˆÐ¸ÑÑ‚ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(268999,7473,'ur','Ø¢Ù¾ Ú©ÛŒ Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø±',0),(269000,7473,'sr','Ð¢Ð²Ð¾Ñ˜ Ð±Ñ€Ð¾Ñ˜ ÐÐ°Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ðµ',0),(269001,7473,'vi','Sá»‘ ÄÆ¡n mua hÃ ng cá»§a báº¡n',0),(269002,7473,'af','U AB Nommer.',0),(269003,7473,'ro','Numarul PO-ului dumneavoastra',0),(269004,7473,'et','Teie ostutellimuse number',0),(269005,7473,'si','VaÅ¡a Å¡tevilka NaroÄilnice',0),(269006,7473,'ba','Nomor PO',0),(269007,7473,'nl','Uw inkoopordernummer',0),(269008,7473,'fi','Ostotilauksen numero',0),(269009,7473,'no','PO-nummer',0),(269010,7473,'da','Din rekvisitionsnummer',0),(269011,7473,'ko','ì£¼ë¬¸ì„œ ë²ˆí˜¸',0),(269012,7473,'he','×ž×¡×¤×¨ ×”-PO ×©×œ×š',0),(269013,7473,'el','Î£Î±Ï‚ Î±Ï Î Î±ÏÎ±Î³Î³',0),(269014,7473,'zh','æ‚¨çš„è®¢å•å·\r\n',0),(269015,7473,'sv','Ditt inkÃ¶psordernummer',0),(269016,7473,'it','Il numero di PO',0),(269017,7473,'tl','',0),(269018,7473,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(269019,7473,'hi','à¤…à¤ªà¤¨à¥‡ à¤ªà¥‹ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(269020,7473,'ms','Nombor PO',0),(269021,7473,'ar','Ø±Ù‚Ù… Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(269022,7473,'fr','Votre numÃ©ro d\'ordre d\'achat',0),(269023,7473,'jp','PO ç•ªå·',0),(269024,7473,'pt','Seu nÃºmero de PO',0),(269025,7473,'ru','Ð’Ð°Ñˆ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(269026,7473,'es','Su nÃºmero de OC',0),(269027,7473,'de','Ihre Auftragsnummer',0),(269028,7473,'en','Your PO Number',0),(269029,7474,'is','',0),(269030,7474,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø§Ø±ÙŠ ',0),(269031,7474,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø§Ø±ÙŠ ',0),(269032,7474,'tr','Åžu anki sipariÅŸleri',0),(269033,7474,'pl','Aktualne zamÃ³wienia',0),(269034,7474,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(269035,7474,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(269036,7474,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(269037,7474,'vi','Nhá»¯ng Ä‘Æ¡n Ä‘áº·t hÃ ng hiá»‡n táº¡i',0),(269038,7474,'af','Huidige Bestellings',0),(269039,7474,'ro','Comenzi de curent',0),(269040,7474,'et','Praeguste tellimuste',0),(269041,7474,'si','Trenutna naroÄila',0),(269042,7474,'ba','Pesanan Sekarang',0),(269043,7474,'nl','Huidige Orders',0),(269044,7474,'fi','NykyisiÃ¤ tilauksia',0),(269045,7474,'no','Gjeldende ordrer',0),(269046,7474,'da','NuvÃ¦rende ordrer',0),(269047,7474,'ko','í˜„ìž¬ ì£¼ë¬¸',0),(269048,7474,'he','×”×–×ž× ×•×ª',0),(269049,7474,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(269050,7474,'zh','ç›®å‰è®¢å•\r\n',0),(269051,7474,'sv','Aktuella order',0),(269052,7474,'it','Ordini in corso',0),(269053,7474,'tl','',0),(269054,7474,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(269055,7474,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤†à¤¦à¥‡à¤¶',0),(269056,7474,'ms','Pesanan semasa',0),(269057,7474,'ar','Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(269058,7474,'fr','Commandes courant',0),(269059,7474,'jp','ç¾åœ¨ã®æ³¨æ–‡',0),(269060,7474,'pt','Ordens atuais',0),(269061,7474,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(269062,7474,'es','Pedidos Actuales',0),(269063,7474,'de','Aktuelle Bestellungen',0),(269064,7474,'en','Current Orders',0),(269065,7475,'is','',0),(269066,7475,'dr','Ù†Ù…Ø§ÙŠØ´ Ú†Ø§Ù¾ ',0),(269067,7475,'pr','Ù†Ù…Ø§ÙŠØ´ Ú†Ø§Ù¾ ',0),(269068,7475,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ yazdÄ±rma',0),(269069,7475,'pl','Widok wydruku',0),(269070,7475,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¿ÐµÑ‡Ð°Ñ‚',0),(269071,7475,'ur','Ù…Ù†Ø¸Ø± Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(269072,7475,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐŸÑ€Ð¸Ð½Ñ‚',0),(269073,7475,'vi','Xem in',0),(269074,7475,'af','Besigtig Uitdruk',0),(269075,7475,'ro','Vezi Print',0),(269076,7475,'et','Vaate printimine',0),(269077,7475,'si','Pogled Print',0),(269078,7475,'ba','Tampilan cetak',0),(269079,7475,'nl','Weergeven afdrukken',0),(269080,7475,'fi','NÃ¤ytÃ¤ tulosta',0),(269081,7475,'no','Vis Skriv ut',0),(269082,7475,'da','Se Print',0),(269083,7475,'ko','ë³´ê¸° ì¸ì‡„',0),(269084,7475,'he','×ª×¦×•×’×ª ×”×“×¤×¡×”',0),(269085,7475,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(269086,7475,'zh','æµè§ˆæ‰“å°\r\n',0),(269087,7475,'sv','Visa Skriv ut',0),(269088,7475,'it','Visualizza stampa',0),(269089,7475,'tl','',0),(269090,7475,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(269091,7475,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(269092,7475,'ms','Paparan cetak',0),(269093,7475,'ar','Ø¹Ø±Ø¶ Ø·Ø¨Ø§Ø¹Ø©',0),(269094,7475,'fr','Voir imprimer',0),(269095,7475,'jp','ãƒ“ãƒ¥ãƒ¼ã®å°åˆ·',0),(269096,7475,'pt','Vista de impressÃ£o',0),(269097,7475,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ',0),(269098,7475,'es','Visionar Imprimir',0),(269099,7475,'de','Ansicht drucken',0),(269100,7475,'en','View Print',0),(269101,7476,'is','',0),(269102,7476,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡  Ø§Ø¬Ø±Ø§Ø¡ Ø¨Ø§Ø²',0),(269103,7476,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡  Ø§Ø¬Ø±Ø§Ø¡ Ø¨Ø§Ø²',0),(269104,7476,'tr','AÃ§Ä±k yerine getirilmesi Quotes',0),(269105,7476,'pl','OtwÃ³rz speÅ‚nienie Cytaty',0),(269106,7476,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(269107,7476,'ur','Ú©Ú¾Ù„ÛŒ Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø±Ø¬ Ú©Ø±Ù†Û’',0),(269108,7476,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(269109,7476,'vi','Má»Ÿ BÃ¡o giÃ¡ ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(269110,7476,'af','Oop Uitvoeringskwotasies',0),(269111,7476,'ro','Deschis Ã®mplinirea citate',0),(269112,7476,'et','Hinnapakkumisi',0),(269113,7476,'si','Izpolnitev odprtih ponudb',0),(269114,7476,'ba','Buka pemenuhan Quotes',0),(269115,7476,'nl','Open vervulling Quotes',0),(269116,7476,'fi','Avoinna tÃ¤yttymyksen lainausmerkit',0),(269117,7476,'no','Ã…pne oppfyllelse sitater',0),(269118,7476,'da','Ã…ben opfyldelse citater',0),(269119,7476,'ko','ì˜¤í”ˆ í–‰ ë”°ì˜´í‘œ',0),(269120,7476,'he','×”×’×©×ž×” ×¤×ª×•×— ×œ×”×¦×¢×•×ª ×ž×—×™×¨',0),(269121,7476,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬ Î¬Î½Î¿Î¹Î³Î¼Î± ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ·',0),(269122,7476,'zh','æ‰“å¼€å±¥è¡ŒæŠ¥ä»·\r\n',0),(269123,7476,'sv','Ã–ppna uppfyllelse citat',0),(269124,7476,'it','Citazioni di adempimento aperto',0),(269125,7476,'tl','',0),(269126,7476,'th','&#3626;&#3629;&#3610;&#3606;&#3634;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(269127,7476,'hi','à¤–à¥à¤²à¤¾ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(269128,7476,'ms','Sebut harga yang memenuhi terbuka',0),(269129,7476,'ar','ÙˆÙ†Ù‚Ù„Øª ÙˆÙØ§Ø¡ Ù…ÙØªÙˆØ­Ø©',0),(269130,7476,'fr','Citations de rÃ©alisation ouverte',0),(269131,7476,'jp','ã‚ªãƒ¼ãƒ—ãƒ³å±¥è¡Œå¼•ç”¨ç¬¦',0),(269132,7476,'pt','CitaÃ§Ãµes de cumprimento aberto',0),(269133,7476,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ñ‹ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ð¾Ð³Ð¾ Ð¸ÑÐ¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(269134,7476,'es','Cotizaciones de Cumplimiento Abiertas',0),(269135,7476,'de','Offene ErfÃ¼llung Zitate',0),(269136,7476,'en','Open Fulfillment Quotes',0),(269137,7477,'is','',0),(269138,7477,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ø¯Ø§Ø¯Ù† Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¬Ù‡Øª Ø«Ø¨Øª Ù†Ø§Ù… Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(269139,7477,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ø¯Ø§Ø¯Ù† Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¬Ù‡Øª Ø«Ø¨Øª Ù†Ø§Ù… Ø¯Ø± Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(269140,7477,'tr','MÃ¼ÅŸteriler iÃ§in B2B Site Ã¼zerinde kayÄ±t izin',0),(269141,7477,'pl','PozwalajÄ… klientom na Zarejestruj siÄ™ na stronie B2B',0),(269142,7477,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð´Ð° ÑÐµ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ñ‚Ðµ Ð½Ð° B2B ÑÐ°Ð¹Ñ‚',0),(269143,7477,'ur','B2B Ø³Ø§Ø¦Ù¹ Ù¾Ø± Ø³Ø§Ø¦Ù† Ø§Ù¾ Ú©Û’ Ù„ÛŒÛ’ ØµØ§Ø±ÙÛŒÙ† Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(269144,7477,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸Ñ‚Ðµ ÐºÑƒÐ¿Ñ†Ð¸Ð¼Ð° Ð´Ð° ÑÐµ ÑÐ²Ð¸ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð‘2Ð‘',0),(269145,7477,'vi','Cho PhÃ©p KhÃ¡ch HÃ ng ÄÄƒng KÃ½ VÃ o Trang B2B',0),(269146,7477,'af','Laat Klante/KliÃ«nte',0),(269147,7477,'ro','Permite clienÅ£ilor sÄƒ Ã®nscrie-te pe site-ul B2B',0),(269148,7477,'et','Luba klientidel registeeruda B2B lehel',0),(269149,7477,'si','OmogoÄajo strankam, da se prijavite na strani B2B',0),(269150,7477,'ba','Memungkinkan pelanggan untuk mendaftar di situs B2B',0),(269151,7477,'nl','Klanten naar aanmelden op B2B Site toestaan',0),(269152,7477,'fi','Asiakkaat voivat kirjautua B2B pÃ¤Ã¤llÃ¤',0),(269153,7477,'no','Tillate kundene Ã¥ registrere seg pÃ¥ B2B webomrÃ¥de',0),(269154,7477,'da','Kunderne mulighed for at tilmelde dig pÃ¥ B2B Site',0),(269155,7477,'ko','B2B ì‚¬ì´íŠ¸ì— ê°€ìž… í•˜ëŠ” ê³ ê° ìˆ˜ ìžˆë„ë¡',0),(269156,7477,'he','×œ××¤×©×¨ ×œ×œ×§×•×—×•×ª ×›×“×™ ×œ×”×™×¨×©× ×‘××ª×¨ B2B',0),(269157,7477,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ ÏƒÏ„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î½Î± ÎµÎ³Î³ÏÎ±Ï†ÎµÎ¯Ï„Îµ ÎµÏ€Î¹Ï„ÏŒÏ€Î¿Ï… B2B',0),(269158,7477,'zh','å…è®¸å®¢æˆ·åœ¨ä¼ä¸šå¯¹ä¼ä¸šç«™ç‚¹ä¸Šç­¾å\r\n',0),(269159,7477,'sv','TillÃ¥t kunder att registrera dig pÃ¥ B2B webbplats',0),(269160,7477,'it','Consentire ai clienti di registrarsi sul sito B2B',0),(269161,7477,'tl','',0),(269162,7477,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3626;&#3617;&#3633;&#3588;&#3619;&#3626;&#3634;&#3617;&#3594;&#3636;&#3585;&#3592;&#3629;&#3591; B2B',0),(269163,7477,'hi','B2B à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤° à¤¸à¤¾à¤‡à¤¨ à¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(269164,7477,'ms','Membolehkan pelanggan mendaftar lokasi B2B',0),(269165,7477,'ar','ØªØ³Ù…Ø­ Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù„Ù„Ø§Ø´ØªØ±Ø§Ùƒ ÙÙŠ Ù…ÙˆÙ‚Ø¹ B2B',0),(269166,7477,'fr','Permettent aux clients d\'inscrire sur le Site B2B',0),(269167,7477,'jp','B2B ã‚µã‚¤ãƒˆã«ã‚µã‚¤ãƒ³ã‚¢ãƒƒãƒ—ã™ã‚‹ã“ã¨ãŒå¯èƒ½ã—ã¾ã™ã€‚',0),(269168,7477,'pt','Permitir que clientes para se inscrever no Site B2B',0),(269169,7477,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°Ð¼ Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸ÑŽ Ð½Ð° Ð¡Ð°Ð¹Ñ‚Ðµ B2B',0),(269170,7477,'es','Permitir Clientes Inscribir en el Sitio de N2N',0),(269171,7477,'de','Damit die Kunden melden Sie sich auf B2B-Website',0),(269172,7477,'en','Allow Customers to Sign Up on B2B Site',0),(269173,7478,'is','',0),(269174,7478,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(269175,7478,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(269176,7478,'tr','VarsayÄ±lan mÃ¼ÅŸteri grubu',0),(269177,7478,'pl','DomyÅ›lne grupy klientÃ³w',0),(269178,7478,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ° Ð³Ñ€ÑƒÐ¿Ð°',0),(269179,7478,'ur','Ø·Û’ Ø´Ø¯Û Ú¯Ø§ÛÚ© Ú¯Ø±ÙˆÙ¾',0),(269180,7478,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ðµ ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(269181,7478,'vi','NhÃ³m KhÃ¡ch hÃ ng Máº·c Ä‘á»‹nh ',0),(269182,7478,'af','Verstekte KliÃ«nt / Klant Groep',0),(269183,7478,'ro','Grupul de clientul implicit',0),(269184,7478,'et','Kliendigrupi',0),(269185,7478,'si','Privzeta skupina kupca',0),(269186,7478,'ba','Default kelompok pelanggan',0),(269187,7478,'nl','Standaard klantgroep',0),(269188,7478,'fi','OletusasiakasryhmÃ¤',0),(269189,7478,'no','Standard kundegruppe',0),(269190,7478,'da','Standarddebitorgruppe',0),(269191,7478,'ko','ê¸°ë³¸ ê³ ê° ê·¸ë£¹',0),(269192,7478,'he','×§×‘×•×¦×ª ×”×œ×§×•×— ×”×ž×•×’×“×¨ ×›×‘×¨×™×¨×ª ×ž×—×“×œ',0),(269193,7478,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¿Î¼Î¬Î´Î± Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(269194,7478,'zh','é»˜è®¤çš„å®¢æˆ·ç¾¤\r\n',0),(269195,7478,'sv','Standardkundgrupp',0),(269196,7478,'it','Gruppo cliente predefinito',0),(269197,7478,'tl','',0),(269198,7478,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(269199,7478,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹',0),(269200,7478,'ms','Kumpulan pelanggan lalai',0),(269201,7478,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(269202,7478,'fr','Groupe de client par dÃ©faut',0),(269203,7478,'jp','æ—¢å®šã®é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—',0),(269204,7478,'pt','Grupo de Cliente PadrÃ£o',0),(269205,7478,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð³Ñ€ÑƒÐ¿Ð¿Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(269206,7478,'es','Grupo de Clientes por Defecto',0),(269207,7478,'de','Standard-Kundengruppe',0),(269208,7478,'en','Default Customer Group',0),(269209,7479,'is','',0),(269210,7479,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø´Ø±Ø§ÙŠØ· Ø®Ø±ÙŠØ¯Ø§Ø±  ',0),(269211,7479,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø´Ø±Ø§ÙŠØ· Ø®Ø±ÙŠØ¯Ø§Ø±  ',0),(269212,7479,'tr','VarsayÄ±lan mÃ¼ÅŸteri ÅŸartlarÄ±',0),(269213,7479,'pl','DomyÅ›lne klienta warunkÃ³w',0),(269214,7479,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð¸',0),(269215,7479,'ur','Ø·Û’ Ø´Ø¯Û Ú¯Ø§ÛÚ© Ø§ØµØ·Ù„Ø§Ø­Ø§Øª',0),(269216,7479,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ ÐºÑƒÐ¿Ñ†Ð° ÑƒÑÐ»Ð¾Ð²Ð¸',0),(269217,7479,'vi','Äiá»u khoáº£n KhÃ¡ch hÃ ng Máº·c Ä‘á»‹nh',0),(269218,7479,'af','Verstekte KliÃ«nt / Klant Terme',0),(269219,7479,'ro','Termeni de clientul implicit',0),(269220,7479,'et','Vaikimisi kliendi tingimuste',0),(269221,7479,'si','Privzeto kupec izrazi',0),(269222,7479,'ba','Persyaratan pelanggan default',0),(269223,7479,'nl','Standaard klant voorwaarden',0),(269224,7479,'fi','Oletuksena asiakkaan kannalta',0),(269225,7479,'no','Standard Kunden-AGB',0),(269226,7479,'da','Standard kunde vilkÃ¥r',0),(269227,7479,'ko','ê¸°ë³¸ ê³ ê° ì´ìš© ì•½ê´€',0),(269228,7479,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×”×œ×§×•×— ×œ×ª× ××™×',0),(269229,7479,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Ï€ÎµÎ»Î¬Ï„Î· ÏŒÏÎ¿Ï…Ï‚',0),(269230,7479,'zh','é»˜è®¤å®¢æˆ·æ¡æ¬¾\r\n',0),(269231,7479,'sv','Standard kund villkor',0),(269232,7479,'it','Termini di cliente predefinito',0),(269233,7479,'tl','',0),(269234,7479,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(269235,7479,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(269236,7479,'ms','Terma pelanggan lalai',0),(269237,7479,'ar','Ø´Ø±ÙˆØ· Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(269238,7479,'fr','Conditions de client par dÃ©faut',0),(269239,7479,'jp','é¡§å®¢ã®ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆæ¡ä»¶',0),(269240,7479,'pt','Termos PadrÃ£o de Cliente',0),(269241,7479,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ñ‹',0),(269242,7479,'es','TÃ©rminos de Clientes por Defecto',0),(269243,7479,'de','Standard-Kunden-Begriffe',0),(269244,7479,'en','Default Customer Terms',0),(269245,7480,'is','',0),(269246,7480,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ØªØ°ÙƒØ±Ø§Øª Ø³ÙØ§Ø±Ø´ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ\r\nB2B',0),(269247,7480,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ØªØ°ÙƒØ±Ø§Øª Ø³ÙØ§Ø±Ø´ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ\r\nB2B',0),(269248,7480,'tr','B2B sipariÅŸ bildirim iÃ§in e-posta',0),(269249,7480,'pl','E-mail dla powiadomieÅ„ o kolejnoÅ›ci B2B',0),(269250,7480,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð·Ð° B2B Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(269251,7480,'ur','B2B ØªØ±ØªÛŒØ¨ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒ Ù…ÛŒÙ„',0),(269252,7480,'sr','Ð•Ð¼Ð°Ð¸Ð» Ð·Ð° Ð‘2Ð‘ Ð½Ð°Ð»Ð¾Ð³ Ð¾Ð±Ð°Ð²Ð¸Ñ˜ÐµÑÑ‚Ð¸',0),(269253,7480,'vi','Gá»­i thÆ° thÃ´ng bÃ¡o cho Ä‘Æ¡n Ä‘áº·t hÃ ng B2B',0),(269254,7480,'af','E-pos vir B2B Bestellingkennisgewings',0),(269255,7480,'ro','E-mail pentru notificÄƒrile de ordine B2B',0),(269256,7480,'et','B2B tellimuse teatiste e-posti',0),(269257,7480,'si','Email za B2B reda oznanilo',0),(269258,7480,'ba','Email untuk B2B urutan pemberitahuan',0),(269259,7480,'nl','Voor B2B volgorde meldingen per e-mail',0),(269260,7480,'fi','B2B ilmoitukset sÃ¤hkÃ¶postitse',0),(269261,7480,'no','E-post for B2B for varsler',0),(269262,7480,'da','E-mail til B2B ordre anmeldelser',0),(269263,7480,'ko','B2B ì£¼ë¬¸ ì•Œë¦¼ ì´ë©”ì¼',0),(269264,7480,'he','×“×•××¨ ××œ×§×˜×¨×•× ×™ ×œ×§×‘×œ×ª ×”×•×“×¢×•×ª ×¡×“×¨ B2B',0),(269265,7480,'el','Email Î³Î¹Î± B2B ÏƒÎµÎ¹ÏÎ¬ ÎµÎ¹Î´Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚',0),(269266,7480,'zh','ç”µå­é‚®ä»¶çš„å•†ä¸šå¯¹å•†ä¸šè®¢å•é€šçŸ¥\r\n',0),(269267,7480,'sv','E-post fÃ¶r B2B Order anmÃ¤lningar',0),(269268,7480,'it','E-mail per le notifiche di ordine B2B',0),(269269,7480,'tl','',0),(269270,7480,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3586;&#3629;&#3591; B2B &#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(269271,7480,'hi','B2B à¤•à¥à¤°à¤® à¤¸à¥‚à¤šà¤¨à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤ˆà¤®à¥‡à¤²',0),(269272,7480,'ms','E-mel untuk B2B perintah pemberitahuan',0),(269273,7480,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø¥Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù… B2B',0),(269274,7480,'fr','Courrier Ã©lectronique pour les Notifications d\'ordre B2B',0),(269275,7480,'jp','B2B ã®æ³¨æ–‡ã®é€šçŸ¥ãƒ¡ãƒ¼ãƒ«',0),(269276,7480,'pt','Correio eletrÃ³nico de NotificaÃ§Ãµes de Ordem de B2B',0),(269277,7480,'ru','Email Ð´Ð»Ñ Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ B2B Ð—Ð°ÐºÐ°Ð·Ð°',0),(269278,7480,'es','Email para N2N Notificaciones de Ordenes',0),(269279,7480,'de','E-Mail fÃ¼r B2B-Auftrag-Mitteilungen',0),(269280,7480,'en','Email for B2B Order Notifications',0),(269281,7481,'is','',0),(269282,7481,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ù„ÙŠØ³Øª  Ø«Ø¨Øª Ù†Ø§Ù… Ù‡Ø§ÙŠ Ù…Ø¯Ù„ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(269283,7481,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø± Ù„ÙŠØ³Øª  Ø«Ø¨Øª Ù†Ø§Ù… Ù‡Ø§ÙŠ Ù…Ø¯Ù„ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(269284,7481,'tr','B2B kayÄ±tlar ekranda',0),(269285,7481,'pl','Wystawa w rejestracje B2B',0),(269286,7481,'bg','Ð”Ð¸ÑÐ¿Ð»ÐµÑ Ð² B2B Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸',0),(269287,7481,'ur','B2B Ø³Ø§Ú¯Ù†Ø³ Ù…ÛŒÚº ÚˆØ³Ù¾Ù„Û’',0),(269288,7481,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñƒ Ð‘2Ð‘ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ðµ',0),(269289,7481,'vi','Hiá»ƒn thá»‹ Ä‘Äƒng kÃ½ trang B2B',0),(269290,7481,'af','Vertoon in B2B Signups',0),(269291,7481,'ro','AfiÅŸare Ã®n B2B Ã®nscrieri',0),(269292,7481,'et','Kuva B2B registreerumisel',0),(269293,7481,'si','Prikaz v B2B prijav',0),(269294,7481,'ba','Tampilan dalam B2B signup',0),(269295,7481,'nl','Vertoning in B2B aanmeldingen',0),(269296,7481,'fi','NÃ¤yttÃ¶ B2B kirjautumisia',0),(269297,7481,'no','Visning i B2B registreringer',0),(269298,7481,'da','Display i B2B tilmeldinger',0),(269299,7481,'ko','ë””ìŠ¤í”Œë ˆì´ B2B ê°€ìž…ì—',0),(269300,7481,'he','×ª×¦×•×’×” ×‘ B2B ×”×¨×©×ž×•×ª',0),(269301,7481,'el','Î•ÎºÏ„Î¯Î¸ÎµÏ„Î±Î¹ ÏƒÏ„Î¿ B2B ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(269302,7481,'zh','æ˜¾ç¤ºåœ¨ä¼ä¸šå¯¹ä¼ä¸šèµ¶å¿«ç››è¡°\r\n',0),(269303,7481,'sv','Visning i B2B registreringar',0),(269304,7481,'it','Visualizzazione in iscrizioni di B2B',0),(269305,7481,'tl','',0),(269306,7481,'th','&#3649;&#3626;&#3604;&#3591;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3591;&#3594;&#3639;&#3656;&#3629; B2B',0),(269307,7481,'hi','B2B à¤ªà¤‚à¤œà¥€à¤•à¤°à¤£ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨',0),(269308,7481,'ms','Paparan dalam pendaftaran B2B',0),(269309,7481,'ar','Ø¹Ø±Ø¶ ÙÙŠ Ø§Ù„Ø¯Ù„Ø§Ø¦Ù„ B2B',0),(269310,7481,'fr','Affichage en B2B inscriptions',0),(269311,7481,'jp','B2B ã®ç”³ã—è¾¼ã¿ã§è¡¨ç¤º',0),(269312,7481,'pt','ExibiÃ§Ã£o em cadastros de B2B',0),(269313,7481,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸ Ð½Ð° B2B',0),(269314,7481,'es','Desplegar en N2N Inscripciones',0),(269315,7481,'de','Anzeige im B2B-Anmeldungen',0),(269316,7481,'en','Display in B2B Signups',0),(269317,7482,'is','',0),(269318,7482,'dr','Ø¯Ø±Ø¢Ù…Ø¯ Ø¯Ø§Ø®Ù„ÙŠ Ùˆ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ ',0),(269319,7482,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ø¯Ø§Ø®Ù„ÙŠ Ùˆ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ ',0),(269320,7482,'tr','Yerel gelir ve ek vergi',0),(269321,7482,'pl','Lokalne dochody i dodatkowe zobowiÄ…zanie podatkowe',0),(269322,7482,'bg','ÐœÐµÑÑ‚Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸ Ð¸ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº',0),(269323,7482,'ur','Ù…Ù‚Ø§Ù…ÛŒ Ø¢Ù…Ø¯Ù†ÛŒ Ø§ÙˆØ± Ø§Ø¶Ø§ÙÛŒ Ù¹ÛŒÚ©Ø³',0),(269324,7482,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¸Ñ… Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð° Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ð¸Ñ… Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(269325,7482,'vi','Thuáº¿ phá»¥ trá»™i & thu nháº­p Äá»‹a phÆ°Æ¡ng',0),(269326,7482,'af','Plaaslike Inkomste en Addisionele Belasting',0),(269327,7482,'ro','Venituri locale ÅŸi taxe suplimentare',0),(269328,7482,'et','Kohalikke tingimusi ja tÃ¤iendav maks',0),(269329,7482,'si','Lokalnih dohodka in dodatni davek',0),(269330,7482,'ba','Lokal pendapatan dan pajak tambahan',0),(269331,7482,'nl','Lokale inkomen en extra belasting',0),(269332,7482,'fi','Paikallisista tuloista ja lisÃ¤vero',0),(269333,7482,'no','Lokale inntekt og ekstra-',0),(269334,7482,'da','Lokale indkomst og ekstra skat',0),(269335,7482,'ko','ì§€ì—­ ì†Œë“ê³¼ ì¶”ê°€ ì„¸ê¸ˆ',0),(269336,7482,'he','×”×”×›× ×¡×” ×”×ž×§×•×ž×™×ª ×•×ž×¢ × ×•×¡×¤×™×',0),(269337,7482,'el','Î¤Î¿Ï€Î¹ÎºÏŒ ÎµÎ¹ÏƒÏŒÎ´Î·Î¼Î± ÎºÎ±Î¹ Ï„Î¿ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î¿ Ï†ÏŒÏÎ¿',0),(269338,7482,'zh','åœ°æ–¹æ”¶å…¥å’Œå…¶ä»–ç¨Ž\r\n',0),(269339,7482,'sv','Lokala inkomster och extra skatt',0),(269340,7482,'it','Reddito locale e imposta addizionale',0),(269341,7482,'tl','',0),(269342,7482,'th','&#3616;&#3634;&#3625;&#3637;&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;&#3649;&#3621;&#3632;&#3616;&#3634;&#3625;&#3637;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3639;&#3617;',0),(269343,7482,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤†à¤¯ à¤”à¤° à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(269344,7482,'ms','Tempatan pendapatan dan cukai tambahan',0),(269345,7482,'ar','Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø­Ù„ÙŠØ© ÙˆØ¶Ø±ÙŠØ¨Ø© Ø¥Ø¶Ø§ÙÙŠØ©',0),(269346,7482,'fr','Revenus locaux et taxe additionnelle',0),(269347,7482,'jp','åœ°åŸŸã®åˆ©ç›Šã¨ä»˜åŠ ç¨Ž',0),(269348,7482,'pt','Renda local e imposto adicional',0),(269349,7482,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ðµ Ð´Ð¾Ñ…Ð¾Ð´Ñ‹ Ð¸ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(269350,7482,'es','Ingreso Local y Impuesto Adicional',0),(269351,7482,'de','Lokale Einkommen und zusÃ¤tzliche Steuer',0),(269352,7482,'en','Local Income and Additional Tax',0),(269353,7483,'is','',0),(269354,7483,'dr','(Ù†Ù‚Ø·Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ) Ø¨Ù‡ Ø¨ÛŒØ¬Ú© ÙŠØ§ ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(269355,7483,'pr','ØªØºÙŠÙŠØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡(Ù†Ù‚Ø·Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ) Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ± ÙŠØ§ ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(269356,7483,'tr','AP fatura fatura veya Ã¶deme tarihi deftere nakil deÄŸiÅŸtirme',0),(269357,7483,'pl','Zmiana ustawy AP ksiÄ™gowania faktury lub data pÅ‚atnoÅ›ci',0),(269358,7483,'bg','AP Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¾Ð·Ð°ÐºÐ¾Ð½Ð° Ð·Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð»Ð¸ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(269359,7483,'ur','AP Ø¨Ù„ Ù¾ÙˆØ³Ù¹Ù†Ú¯ Ø§Ù†ÙˆØ§Ø¦Ø³ ÛŒØ§ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(269360,7483,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° ÐÐŸ Ð‘Ð¸Ð» ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸Ð»Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(269361,7483,'vi','Thay Äá»•i Ná»£ Pháº£i Tráº£ Sang HÃ³a ÄÆ¡n hay NgÃ y Thanh ToÃ¡n',0),(269362,7483,'af','Verander RB Rekening Postering na Faktuur of Betalingsdatum',0),(269363,7483,'ro','Schimbare AP Bill posta factura sau data platii',0),(269364,7483,'et','Muuta AP arve arve vÃµi makse kuupÃ¤eva sisestamine',0),(269365,7483,'si','Spremembe zakona AP knjiÅ¾enje raÄuna ali datum plaÄila',0),(269366,7483,'ba','Perubahan AP Bill Posting ke faktur atau tanggal pembayaran',0),(269367,7483,'nl','AP Bill posten aan factuur of betalingsdatum wijzigen',0),(269368,7483,'fi','AP lasku kirjataan laskun tai maksupÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(269369,7483,'no','AP regningen til faktura eller betalingsdato',0),(269370,7483,'da','Ã†ndre AP Bill bogfÃ¸ring af faktura eller betalingsdato',0),(269371,7483,'ko','ì†¡ìž¥ ë˜ëŠ” ì§€ë¶ˆ ë‚ ì§œ ê²Œì‹œ AP ë²•ì•ˆ ë³€ê²½',0),(269372,7483,'he','×©×™× ×•×™ AP ×‘×™×œ ×¨×™×©×•× ×”×—×©×‘×•× ×™×ª ××• ×ª××¨×™×š ×”×ª×©×œ×•×',0),(269373,7483,'el','Î‘Î»Î»Î±Î³Î® AP Bill ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î® Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(269374,7483,'zh','æ›´æ”¹åº”æ”¶è´¦æ¬¾å¸å•ç²˜è´´åˆ°å‘ç¥¨æˆ–ä»˜è´¹æ—¥æœŸ\r\n',0),(269375,7483,'sv','Ã„ndra AP affischering faktura eller betalningsdatum',0),(269376,7483,'it','Cambiamento AP affissione a fattura o la data di pagamento',0),(269377,7483,'tl','',0),(269378,7483,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3592;&#3634;&#3585;&#3648;&#3592;&#3657;&#3634;&#3',0),(269379,7483,'hi','à¤à¤ªà¥€ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤— à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(269380,7483,'ms','Perubahan AP Rang undang-undang menghantar invois atau tarikh pembayaran',0),(269381,7483,'ar','ØªØºÙŠÙŠØ± Ø¨ÙŠÙ„ AP ØªØ±Ø­ÙŠÙ„ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø£Ùˆ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹',0),(269382,7483,'fr','Changement AP Bill poster sur votre facture ou de la Date de paiement',0),(269383,7483,'jp','è«‹æ±‚æ›¸ã‚„æ”¯æ‰•æ—¥ã‚’æŠ•ç¨¿ ap é€šä¿¡æ³•æ¡ˆã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(269384,7483,'pt','MudanÃ§a AP Bill postando a factura ou a data de pagamento',0),(269385,7483,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ AP Ð‘Ð¸Ð»Ð» Ñ€Ð°Ð·Ð½Ð¾ÑÐºÐ¸ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ Ð¸Ð»Ð¸ Ð”Ð°Ñ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(269386,7483,'es','Cambiar CP Asiento de FacturaciÃ³n a la Factura o Fecha de Pago',0),(269387,7483,'de','AP Rechnung zu Rechnung oder Zahlungsdatum hinzuzufÃ¼gen',0),(269388,7483,'en','Change AP Bill Posting to Invoice or Payment Date',0),(269389,7484,'is','',0),(269390,7484,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø§Ù†ØªØ®Ø§Ø¨ÙŠ  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(269391,7484,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø§Ù†ØªØ®Ø§Ø¨ÙŠ  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(269392,7484,'tr','SeÃ§ilen mÃ¼ÅŸteriler silmek istediÄŸinizden emin misiniz?',0),(269393,7484,'pl','Czy na pewno chcesz usunÄ…Ä‡ wybrane klientÃ³w?',0),(269394,7484,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸?',0),(269395,7484,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ù…Ù†ØªØ®Ø¨ ØµØ§Ø±ÙÛŒÙ† Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(269396,7484,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð±Ñ€Ð¸ÑˆÐµÑ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ ÐºÑƒÐ¿Ñ†Ðµ?',0),(269397,7484,'vi','XÃ³a KhÃ¡ch HÃ ng Vá»«a Chá»n?',0),(269398,7484,'af','Is u seker u wil die geselekteerde Klante/KliÃ«nte skrap?',0),(269399,7484,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ ÅŸtergeÅ£i clienÅ£ii selectate?',0),(269400,7484,'et','Oled kindel, et soovid valitud kliendid kustutada?',0),(269401,7484,'si','Ali ste prepriÄani, da Å¾elite izbrisati izbrane stranke?',0),(269402,7484,'ba','Apakah Anda yakin Anda ingin menghapus pelanggan dipilih?',0),(269403,7484,'nl','Weet u zeker dat u wilt verwijderen van de geselecteerde klanten?',0),(269404,7484,'fi','Oletko varma, ettÃ¤ haluat poistaa valitut asiakkaat?',0),(269405,7484,'no','Er du sikker pÃ¥ at du vil slette de valgte kundene?',0),(269406,7484,'da','Er du sikker pÃ¥ du vil slette de valgte debitorer?',0),(269407,7484,'ko','ë‹¹ì‹ ì€ ì„ íƒ ëœ ê³ ê°ì„ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(269408,7484,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ××ª ×”×œ×§×•×—×•×ª ×©× ×‘×—×¨×•?',0),(269409,7484,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿Ï…Ï‚ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚;',0),(269410,7484,'zh','ä½ ç¡®å®šè¦åˆ é™¤é€‰å®šçš„å®¢æˆ·ï¼Ÿ\r\n',0),(269411,7484,'sv','Ã„r du sÃ¤ker du vill ta bort de valda kunderna?',0),(269412,7484,'it','Sei sicuro di che voler cancellare i clienti selezionati?',0),(269413,7484,'tl','',0),(269414,7484,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3',0),(269415,7484,'hi','à¤•à¥à¤¯à¤¾ à¤†à¤ª à¤µà¤¾à¤•à¤ˆ à¤šà¤¯à¤¨à¤¿à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤¨à¤·à¥à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(269416,7484,'ms','Adakah anda pasti anda mahu menghapuskan pelanggan terpilih?',0),(269417,7484,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø²Ø¨Ø§Ø¦Ù† Ø§Ù„Ù…Ø­Ø¯Ø¯ÙŠÙ† ØŸ',0),(269418,7484,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer les clients sÃ©lectionnÃ©s ?',0),(269419,7484,'jp','é¸æŠžã—ãŸé¡§å®¢ã‚’å‰Šé™¤ã™ã‚‹ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(269420,7484,'pt','Tem certeza que deseja excluir os clientes selecionados?',0),(269421,7484,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹ Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²?',0),(269422,7484,'es','Â¿Esta seguro que quiere eliminar los clientes seleccionados?',0),(269423,7484,'de','Bist du sicher, dass Sie die ausgewÃ¤hlten Kunden lÃ¶schen mÃ¶chten?',0),(269424,7484,'en','Are you sure you want to delete the selected customers?',0),(269425,7485,'is','',0),(269426,7485,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(269427,7485,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(269428,7485,'tr','MÃ¼ÅŸteriler baÅŸarÄ±yla silindi',0),(269429,7485,'pl','Klienci przesâ”‚anie',0),(269430,7485,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(269431,7485,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(269432,7485,'sr','ÐšÑƒÐ¿Ñ†Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(269433,7485,'vi','XÃ³a KhÃ¡ch hÃ ng thÃ nh cÃ´ng',0),(269434,7485,'af','Klante/KliÃ«nte suksesvol Geskrap',0),(269435,7485,'ro','ClienÅ£ii eliminÄƒ cu succes',0),(269436,7485,'et','Kliendid kustutati edukalt',0),(269437,7485,'si','Uporabniki, ki so uspeÅ¡no izbrisana',0),(269438,7485,'ba','Pelanggan yang berhasil dihapus',0),(269439,7485,'nl','Klanten met succes verwijderd',0),(269440,7485,'fi','Asiakkaat poistettu',0),(269441,7485,'no','Kundene slettet',0),(269442,7485,'da','Kunder slettet',0),(269443,7485,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ê³ ê°',0),(269444,7485,'he','×”×œ×§×•×—×•×ª × ×ž×—×§×• ×‘×”×¦×œ×—×”',0),(269445,7485,'el','ÎŸÎ¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(269446,7485,'zh','å®¢æˆ·æˆåŠŸåˆ é™¤\r\n',0),(269447,7485,'sv','Kunder raderades',0),(269448,7485,'it','Clienti eliminati con successo',0),(269449,7485,'tl','',0),(269450,7485,'th','&#3585;&#3634;&#3619;&#3621;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(269451,7485,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(269452,7485,'ms','Pelanggan yang berjaya dipadam',0),(269453,7485,'ar','Ø­Ø°Ù Ø§Ù„Ø²Ø¨Ø§Ø¦Ù† Ø¨Ù†Ø¬Ø§Ø­',0),(269454,7485,'fr','Clients supprimÃ©s avec succÃ¨s',0),(269455,7485,'jp','ãŠå®¢æ§˜ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(269456,7485,'pt','Clientes apagados com sucesso',0),(269457,7485,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½Ñ‹',0),(269458,7485,'es','Clientes Eliminados Exitosamente',0),(269459,7485,'de','Kunden, die erfolgreich gelÃ¶scht',0),(269460,7485,'en','Customers Deleted Successfully',0),(269461,7486,'is','',0),(269462,7486,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± Ø¨Ø¹Ø¯ Ø§Ø² ',0),(269463,7486,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± Ø¨Ø¹Ø¯ Ø§Ø² ',0),(269464,7486,'tr','Sonra yok faturalarÄ± olan mÃ¼ÅŸterileri',0),(269465,7486,'pl','Klienci z nie faktury po',0),(269466,7486,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ñ Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ ÑÐ»ÐµÐ´',0),(269467,7486,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø¨Ø¹Ø¯ Ú©ÙˆØ¦ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾',0),(269468,7486,'sr','ÐšÑƒÐ¿Ñ†Ð¸ ÑÐ° Ð½ÐµÐ¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð°ÐºÐ¾Ð½',0),(269469,7486,'vi','KhÃ¡ch hÃ ng khÃ´ng cÃ³ hÃ³a Ä‘Æ¡n sai Ä‘Ã³',0),(269470,7486,'af','Klante/KliÃ«nte met Geen Fakture na',0),(269471,7486,'ro','ClienÅ£ii cu facturi nu dupÄƒ',0),(269472,7486,'et','PÃ¤rast arvete klientidele',0),(269473,7486,'si','Kupci z ni raÄunih po',0),(269474,7486,'ba','Pelanggan dengan tagihan tidak setelah',0),(269475,7486,'nl','Klanten met geen facturen na',0),(269476,7486,'fi','Asiakkaiden kanssa ei laskuja jÃ¤lkeen',0),(269477,7486,'no','Kunder med ingen fakturaer etter',0),(269478,7486,'da','Kunder med ingen fakturaer efter',0),(269479,7486,'ko','ê³ ê°ì— ê²Œ í›„ ì•„ë¬´ ì²­êµ¬ì„œ',0),(269480,7486,'he','×”×œ×§×•×—×•×ª ×¢× ×—×©×‘×•× ×™×•×ª ×œ× ×œ××—×¨',0),(269481,7486,'el','Î¤Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î¼Îµ ÎºÎ±Î¼Î¯Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î¼ÎµÏ„Î¬',0),(269482,7486,'zh','å®¢æˆ·æ²¡æœ‰å‘ç¥¨åŽ\r\n',0),(269483,7486,'sv','Kunder med inga fakturor efter',0),(269484,7486,'it','Clienti con nessun fatture dopo',0),(269485,7486,'tl','',0),(269486,7486,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3627;&#3621;&#3633;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(269487,7486,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¥‹à¤ˆ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(269488,7486,'ms','Pelanggan dengan tiada invois selepas',0),(269489,7486,'ar','Ø²Ø¨Ø§Ø¦Ù† Ø¨Ø¯ÙˆÙ† Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ø¨Ø¹Ø¯ ',0),(269490,7486,'fr','Clients avec aucune facture aprÃ¨s',0),(269491,7486,'jp','å¾Œã‚‚è«‹æ±‚ã®ãŠå®¢æ§˜',0),(269492,7486,'pt','Clientes com nenhuma faturas apÃ³s',0),(269493,7486,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹ Ñ No Ð¡Ñ‡ÐµÑ‚Ð¾Ð² ÐŸÐ¾ÑÐ»Ðµ',0),(269494,7486,'es','Clientes sin Facturas DespuÃ©s de ',0),(269495,7486,'de','Kunden, die keine Rechnungen nach',0),(269496,7486,'en','Customers with No Invoices After',0),(269497,7487,'is','',0),(269498,7487,'dr','( Ø¯ÙØ§ØªØ± ) Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(269499,7487,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø³ÙˆØ§Ø¨Ù‚ ( Ø¯ÙØ§ØªØ± ) Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(269500,7487,'tr','MÃ¼ÅŸteri kayÄ±tlarÄ± silme hatasÄ±',0),(269501,7487,'pl','BÅ‚Ä…d podczas usuwania rekordÃ³w klientÃ³w',0),(269502,7487,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(269503,7487,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ùˆ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(269504,7487,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð·Ð°Ð¿Ð¸ÑÐµ Ð¾ ÐºÑƒÐ¿Ñ†Ð¸Ð¼Ð°',0),(269505,7487,'vi','Lá»—i khi xÃ³a há»“ sÆ¡ khÃ¡ch hÃ ng',0),(269506,7487,'af','Fout met Skrap van KliÃ«nt/Klant Rekords',0),(269507,7487,'ro','Eroare la È™tergerea client de Ã®nregistrÄƒri',0),(269508,7487,'et','Kliendi andmete kustutamisel tekkis viga',0),(269509,7487,'si','Napaka, brisanje kupca',0),(269510,7487,'ba','Error menghapus catatan pelanggan',0),(269511,7487,'nl','Fout bij het verwijderen van Records voor klanten',0),(269512,7487,'fi','Virhe poistettaessa asiakastietueita',0),(269513,7487,'no','Feil ved sletting av kundeposter',0),(269514,7487,'da','Fejl ved sletning af kundeposter',0),(269515,7487,'ko','ê³ ê° ë ˆì½”ë“œ ì‚­ì œ ì˜¤ë¥˜',0),(269516,7487,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×¨×©×•×ž×•×ª ×©×œ ×œ×§×•×—×•×ª',0),(269517,7487,'el','Î›Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(269518,7487,'zh','é”™è¯¯åˆ é™¤å®¢æˆ·è®°å½•',0),(269519,7487,'sv','Fel ta bort kundposter',0),(269520,7487,'it','Errore eliminazione dei record del cliente',0),(269521,7487,'tl','',0),(269522,7487,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(269523,7487,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(269524,7487,'ms','Ralat Menghapuskan rekod pelanggan',0),(269525,7487,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø³Ø¬Ù„Ù‘Ø§Øª Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(269526,7487,'fr','Erreur de suppression de dossiers clients',0),(269527,7487,'jp','é¡§å®¢ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’å‰Šé™¤ã™ã‚‹ã‚¨ãƒ©ãƒ¼',0),(269528,7487,'pt','Erro ao excluir registros de cliente',0),(269529,7487,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(269530,7487,'es','Error Eliminando Records de Cliente',0),(269531,7487,'de','Fehler beim LÃ¶schen der KundendatensÃ¤tze',0),(269532,7487,'en','Error Deleting Customer Records',0),(269533,7488,'is','',0),(269534,7488,'dr','Ø¯Ø± Ù†Ø¸Ø± Ù†Ú¯ÙŠØ±ÙŠØ¯Ø§Ú¯Ø± Ù…Ø§Ù†Ø¯Ù‡ Ø¨Ø¯Ù‡ÙƒØ§Ø±',0),(269535,7488,'pr','Ø¯Ø± Ù†Ø¸Ø± Ù†Ú¯ÙŠØ±ÙŠØ¯Ø§Ú¯Ø± Ù…Ø§Ù†Ø¯Ù‡ Ø¨Ø¯Ù‡ÙƒØ§Ø±',0),(269536,7488,'tr','GÃ¶z ardÄ± Ã–denecek Bakiye',0),(269537,7488,'pl','JeÅ›li saldo zadÅ‚uÅ¼enia',0),(269538,7488,'bg','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð°Ð½Ðµ Ð°ÐºÐ¾ Ð´ÑŠÐ»Ð¶Ð¸Ð¼ Ð¾ÑÑ‚Ð°Ñ‚ÑŠÐº',0),(269539,7488,'ur','ØªÙˆ Ù†Ø¸Ø±Ø§Ù†Ø¯Ø§Ø² Ú©Ø± Ù…Ù‚Ø±Ø±Û Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† ØªÙˆØ§Ø²Ù†',0),(269540,7488,'sr','Ð—Ð°Ð½ÐµÐ¼Ð°Ñ€Ð¸ Ð°ÐºÐ¾ Ð´Ð¾ÑÐ¿ÐµÐ»Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(269541,7488,'vi','Náº¿u Sá»‘ dÆ° Ä‘áº¿n háº¡n',0),(269542,7488,'af','Ignoreer Indien Balans Verskuldig',0),(269543,7488,'ro','Ignora dacÄƒ soldul cuvenit',0),(269544,7488,'et','Ignoreerida, kui saldo',0),(269545,7488,'si','Prezri Äe zapadli saldo',0),(269546,7488,'ba','Abaikan jika saldo Due',0),(269547,7488,'nl','Negeren als evenwicht Due',0),(269548,7488,'fi','Ohita, jos tasapaino asianmukaisesti',0),(269549,7488,'no','Ignorer hvis forfalt saldo',0),(269550,7488,'da','Ignorere hvis Balance behÃ¸rig',0),(269551,7488,'ko','ë¬´ì‹œë¡œ ì¸í•´ ê· í˜•',0),(269552,7488,'he','×œ×”×ª×¢×œ× ×× ××™×–×•×Ÿ ×ª×§×™×Ÿ',0),(269553,7488,'el','Î‘Î³Î½Î¿Î¿ÏÎ½ Î±Î½ Î»Î·Î¾Î¹Ï€ÏÏŒÎ¸ÎµÏƒÎ¼Î¿ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(269554,7488,'zh','å¿½ç•¥å¦‚æžœç»“ä½™åˆ°æœŸ\r\n',0),(269555,7488,'sv','Ignorera om balansera vederbÃ¶rlig',0),(269556,7488,'it','Ignorare se scaduto',0),(269557,7488,'tl','',0),(269558,7488,'th','&#3648;&#3614;&#3636;&#3585;&#3648;&#3593;&#3618;&#3606;&#3657;&#3634;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(269559,7488,'hi','à¤¯à¤¦à¤¿ à¤‰à¤ªà¥‡à¤•à¥à¤·à¤¾ à¤¬à¤•à¤¾à¤¯à¤¾ à¤°à¤¾à¤¶à¥€',0),(269560,7488,'ms','Abaikan jika baki terhutang',0),(269561,7488,'ar','ØªØ¬Ø§Ù‡Ù„ Ø¥Ø°Ø§ Ø§Ù„ØªÙˆØ§Ø²Ù† Ø§Ù„ÙˆØ§Ø¬Ø¨',0),(269562,7488,'fr','Ignorer si solde Due',0),(269563,7488,'jp','å ´åˆã‚’ç„¡è¦–ã™ã‚‹ãŸã‚ã®ãƒãƒ©ãƒ³ã‚¹ã‚’ã¨ã‚‹',0),(269564,7488,'pt','Ignorar se equilibrar devido',0),(269565,7488,'ru','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ, ÐµÑÐ»Ð¸ ÑÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ²Ð¾Ðµ',0),(269566,7488,'es','Ignorar si balance vencido',0),(269567,7488,'de','Ignorieren, wenn Due Balance',0),(269568,7488,'en','Ignore If Balance Due',0),(269569,7489,'is','',0),(269570,7489,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ØºÙŠØ± ÙØ¹Ø§Ù„',0),(269571,7489,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ØºÙŠØ± ÙØ¹Ø§Ù„',0),(269572,7489,'tr','Etkin olmayan mÃ¼ÅŸteriler',0),(269573,7489,'pl','Nieaktywnych klientÃ³w',0),(269574,7489,'bg','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(269575,7489,'ur','ØºÛŒØ± ÙØ¹Ø§Ù„ ØµØ§Ø±ÙÛŒÙ†',0),(269576,7489,'sr','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸',0),(269577,7489,'vi','KhÃ¡ch hÃ ng KhÃ´ng hoáº¡t Ä‘á»™ng',0),(269578,7489,'af','Onaktiewe KliÃ«nt/Klant',0),(269579,7489,'ro','Clienti inactivi',0),(269580,7489,'et','Mitteaktiivne klient',0),(269581,7489,'si','Neaktivne stranke',0),(269582,7489,'ba','Pelanggan tidak aktif',0),(269583,7489,'nl','Inactieve klanten',0),(269584,7489,'fi','Ei-aktiiviset asiakkaat',0),(269585,7489,'no','Inaktive kunder',0),(269586,7489,'da','Inaktive kunder',0),(269587,7489,'ko','ë¹„í™œì„± ê³ ê°',0),(269588,7489,'he','×œ×§×•×—×•×ª ×œ× ×¤×¢×™×œ×™×',0),(269589,7489,'el','Î‘Î½ÎµÎ½ÎµÏÎ³Î¿Î¯ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(269590,7489,'zh','ä¸æ´»è·ƒçš„å®¢æˆ·\r\n',0),(269591,7489,'sv','Inaktiva kunder',0),(269592,7489,'it','Clienti inattivi',0),(269593,7489,'tl','',0),(269594,7489,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3595;&#3637;&#3656;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(269595,7489,'hi','à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(269596,7489,'ms','Pelanggan tidak aktif',0),(269597,7489,'ar','Ø§Ù„Ø²Ø¨Ø§Ø¦Ù† Ø§Ù„Ø®Ø§Ù…Ù„ÙˆÙ†',0),(269598,7489,'fr','Clients inactifs',0),(269599,7489,'jp','éžã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªé¡§å®¢',0),(269600,7489,'pt','Clientes inativos',0),(269601,7489,'ru','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹',0),(269602,7489,'es','Clientes Inactivos',0),(269603,7489,'de','Inaktive Kunden',0),(269604,7489,'en','Inactive Customers',0),(269605,7490,'is','',0),(269606,7490,'dr','Ø¢Ø®Ø±ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(269607,7490,'pr','Ø¢Ø®Ø±ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(269608,7490,'tr','Son fatura',0),(269609,7490,'pl','Ostatniej faktury',0),(269610,7490,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(269611,7490,'ur','Ø¢Ø®Ø±ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(269612,7490,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(269613,7490,'vi','HÃ³a Ä‘Æ¡n cuá»‘i',0),(269614,7490,'af','Laaste Faktuur',0),(269615,7490,'ro','Ultima factura',0),(269616,7490,'et','Viimase arve',0),(269617,7490,'si','Zadnji raÄun',0),(269618,7490,'ba','Faktur terakhir',0),(269619,7490,'nl','Laatste factuur',0),(269620,7490,'fi','Viimeisen laskun',0),(269621,7490,'no','Siste fakturaen',0),(269622,7490,'da','Sidste faktura',0),(269623,7490,'ko','ë§ˆì§€ë§‰ ì¸ë³´ì´ìŠ¤',0),(269624,7490,'he','×—×©×‘×•× ×™×ª ××—×¨×•× ×”',0),(269625,7490,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(269626,7490,'zh','æœ€åŽå‘ç¥¨\r\n',0),(269627,7490,'sv','Senaste fakturan',0),(269628,7490,'it','Ultima fattura',0),(269629,7490,'tl','',0),(269630,7490,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(269631,7490,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤šà¤¾à¤²à¤¾à¤¨',0),(269632,7490,'ms','Tarikh invois',0),(269633,7490,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(269634,7490,'fr','DerniÃ¨re facture',0),(269635,7490,'jp','æœ€å¾Œã®è«‹æ±‚æ›¸',0),(269636,7490,'pt','Ãšltima fatura',0),(269637,7490,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ ÑÑ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(269638,7490,'es','Ãšltima Factura',0),(269639,7490,'de','Letzten Rechnung',0),(269640,7490,'en','Last Invoice',0),(269641,7491,'is','',0),(269642,7491,'dr','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø±ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(269643,7491,'pr','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø±ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(269644,7491,'tr','Son fatura tarihi',0),(269645,7491,'pl','Ostatnia data faktury',0),(269646,7491,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(269647,7491,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø¢Ø®Ø±ÛŒ ØªØ§Ø±ÛŒØ®',0),(269648,7491,'sr','Ð—Ð°Ð´ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(269649,7491,'vi','NgÃ y HÃ³a Ä‘Æ¡n cuá»‘i',0),(269650,7491,'af','Laaste Faktuurdatum',0),(269651,7491,'ro','Ultima data facturii',0),(269652,7491,'et','Viimase arve kuupÃ¤ev',0),(269653,7491,'si','Zadnji datum raÄuna',0),(269654,7491,'ba','Tanggal faktur terakhir',0),(269655,7491,'nl','Laatste factuurdatum',0),(269656,7491,'fi','Viimeinen laskupvm',0),(269657,7491,'no','Siste faktureringsdato',0),(269658,7491,'da','Sidste faktureringsdato',0),(269659,7491,'ko','ë§ˆì§€ë§‰ ì¸ë³´ì´ìŠ¤ ë‚ ì§œ',0),(269660,7491,'he','×ª××¨×™×š ×—×©×‘×•× ×™×ª ××—×¨×•× ×”',0),(269661,7491,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î—Î¼/Î½Î¯Î± Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(269662,7491,'zh','æœ€åŽå‘ç¥¨æ—¥æœŸ\r\n',0),(269663,7491,'sv','Senaste fakturadatum',0),(269664,7491,'it','Data dell\'ultima fattura',0),(269665,7491,'tl','',0),(269666,7491,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(269667,7491,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(269668,7491,'ms','Tarikh invois',0),(269669,7491,'ar','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø± Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨',0),(269670,7491,'fr','DerniÃ¨re Date de la facture',0),(269671,7491,'jp','æœ€å¾Œã®è«‹æ±‚æ›¸ã®æ—¥ä»˜',0),(269672,7491,'pt','Data da Ãºltima factura',0),(269673,7491,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ¹ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(269674,7491,'es','Fecha de la Ãšltima Factura',0),(269675,7491,'de','Rechnungsdatum der letzten',0),(269676,7491,'en','Last Invoice Date',0),(269677,7492,'is','',0),(269678,7492,'dr','Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ±ÙŠ ØªØ§ Ø¨Ø­Ø§Ù„ ',0),(269679,7492,'pr','Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ±ÙŠ ØªØ§ Ø¨Ø­Ø§Ù„ ',0),(269680,7492,'tr','Beri hiÃ§bir faturalar',0),(269681,7492,'pl','Nie faktury od',0),(269682,7492,'bg','ÐÑÐ¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¾Ñ‚',0),(269683,7492,'ur','Ú©ÙˆØ¦ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ø¨Ø¹Ø¯',0),(269684,7492,'sr','ÐÐµÐ¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¾Ð´',0),(269685,7492,'vi','KhÃ´ng cÃ³ hÃ³a Ä‘Æ¡n tá»«',0),(269686,7492,'af','Geen Fakture Sedert',0),(269687,7492,'ro','Nici facturile din',0),(269688,7492,'et','Ãœhtegi arvet ei leitud',0),(269689,7492,'si','Ni raÄunih od',0),(269690,7492,'ba','Tidak ada tagihan sejak',0),(269691,7492,'nl','Geen facturen sinds',0),(269692,7492,'fi','Koska laskuja',0),(269693,7492,'no','Ingen fakturaer siden',0),(269694,7492,'da','Ingen fakturaer siden',0),(269695,7492,'ko','ì´í›„ ì•„ë¬´ ì²­êµ¬ì„œ',0),(269696,7492,'he','××™×Ÿ ×—×©×‘×•× ×™×•×ª ×ž××–',0),(269697,7492,'el','Î”ÎµÎ½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î±Ï€ÏŒ',0),(269698,7492,'zh','æ²¡æœ‰å‘ç¥¨åŽŸå› \r\n',0),(269699,7492,'sv','Inga fakturor sedan',0),(269700,7492,'it','Non ci sono fatture dal',0),(269701,7492,'tl','',0),(269702,7492,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3605;&#3633;&#3657;&#3591;&#3649;&#3605;&#3656;',0),(269703,7492,'hi','à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥‡ à¤•à¥‹à¤ˆ à¤šà¤¾à¤²à¤¾à¤¨',0),(269704,7492,'ms','Invois tidak sejak',0),(269705,7492,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ù…Ù†Ø° ',0),(269706,7492,'fr','Aucune facture depuis',0),(269707,7492,'jp','ä»¥é™ã‚‚è«‹æ±‚',0),(269708,7492,'pt','NÃ£o hÃ¡ facturas desde',0),(269709,7492,'ru','ÐÐµÑ‚ Ð¡Ñ‡ÐµÑ‚Ð¾Ð² ÐÐ°Ñ‡Ð¸Ð½Ð°Ñ',0),(269710,7492,'es','No HabÃ­a facturas Desde',0),(269711,7492,'de','Keine Rechnungen seit',0),(269712,7492,'en','No Invoices Since',0),(269713,7493,'is','',0),(269714,7493,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(269715,7493,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(269716,7493,'tr','Yeni B2B karÅŸÄ±lama sipariÅŸi',0),(269717,7493,'pl','Nowego zamÃ³wienia realizacji B2B',0),(269718,7493,'bg','ÐÐ¾Ð² Ñ€ÐµÐ´ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° B2B',0),(269719,7493,'ur','B2B Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ Ù†Ø¦ÛŒ ØªØ±ØªÛŒØ¨',0),(269720,7493,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð‘2Ð‘',0),(269721,7493,'vi','ÄÆ¡n hÃ ng B2B giao táº­n nÆ¡i má»›i',0),(269722,7493,'af','Nuwe B2B Uitvoeringsbestelling',0),(269723,7493,'ro','Noua ordine de Ã®mplinire B2B',0),(269724,7493,'et','Uus B2B kaubatellimus',0),(269725,7493,'si','Nov B2B izpolnitev nalog',0),(269726,7493,'ba','B2B pemenuhan Orde Baru',0),(269727,7493,'nl','Nieuwe B2B vervulling orde',0),(269728,7493,'fi','Uuden B2B suunnitellun tilauksen',0),(269729,7493,'no','Ny B2B innfrielsesordre',0),(269730,7493,'da','Ny B2B opfyldelsesordre',0),(269731,7493,'ko','ìƒˆë¡œìš´ B2B í–‰ ìˆœì„œ',0),(269732,7493,'he','×¡×“×¨ ×—×“×© ×©×œ ×”×’×©×ž×” B2B',0),(269733,7493,'el','ÎÎ­Î± Ï„Î¬Î¾Î· ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· B2B',0),(269734,7493,'zh','æ–°çš„B2Bå±¥è¡Œè®¢å•\r\n',0),(269735,7493,'sv','Nya B2B uppfyllelseordern',0),(269736,7493,'it','Nuovo ordine di evasione B2B',0),(269737,7493,'tl','',0),(269738,7493,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3651;&#3627;&#3617;&#3656; B2B ',0),(269739,7493,'hi','à¤¨à¤ˆ B2B à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶',0),(269740,7493,'ms','Perintah perlaksanaan B2B yang baru',0),(269741,7493,'ar','Ø¬Ø¯ÙŠØ¯Ø© Ø£Ù…Ø± Ø§Ù„Ø§Ø³ØªÙŠÙØ§Ø¡ B2B',0),(269742,7493,'fr','Nouveaux ordres de traitement B2B',0),(269743,7493,'jp','æ–°ã—ã„ B2B ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼',0),(269744,7493,'pt','Nova ordem de cumprimento de B2B',0),(269745,7493,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ B2B',0),(269746,7493,'es','Nuevo N2N Orden de Cumplimiento',0),(269747,7493,'de','Neue B2B-AusfÃ¼hrungsauftrag',0),(269748,7493,'en','New B2B Fulfillment Order',0),(269749,7494,'is','',0),(269750,7494,'dr','(ØªÙƒÙ…ÙŠÙ„ÙŠ) Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯. ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(269751,7494,'pr',' ÙˆØ¬Ù‡ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ (ØªÙƒÙ…ÙŠÙ„ÙŠ) Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯. ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(269752,7494,'tr','B2B, alÄ±nan Ã¶deme emri yerine getirilmesi',0),(269753,7494,'pl','B2B realizacji zamÃ³wienia PÅ‚atnoÅ›Ä‡ otrzymana',0),(269754,7494,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ñ Ñ€ÐµÐ´Ð° Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð½Ð° B2B',0),(269755,7494,'ur','B2B Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ù¾ÛŒÙ…Ù†Ù¹ ÙˆØµÙˆÙ„ Ú©ÛŒ',0),(269756,7494,'sr','Ð‘2Ð‘ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð¼Ðµ',0),(269757,7494,'vi','ÄÃ£ Nháº­n Thanh ToÃ¡n Cho CÃ¡c ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i B2B',0),(269758,7494,'af','B2B Nuwe Uitvoeringsbestelling Betaling Ontvang',0),(269759,7494,'ro','B2B Ã®mplinirea plata Ordinul primit',0),(269760,7494,'et','B2B kaubatellimus makstud',0),(269761,7494,'si','B2B izpolnitev nalog plaÄilo prejel',0),(269762,7494,'ba','B2B pemenuhan Order pembayaran yang diterima',0),(269763,7494,'nl','B2B vervulling volgorde betaling ontvangen',0),(269764,7494,'fi','B2B tÃ¤yttÃ¤minen tilauksen maksu vastaanotettu',0),(269765,7494,'no','B2B oppfyllelse Bestill betaling mottatt',0),(269766,7494,'da','B2B opfyldelse betalingspÃ¥krav modtaget',0),(269767,7494,'ko','B2B í–‰ ìˆœì„œ ì§€ë¶ˆ ë°›ì€',0),(269768,7494,'he','B2B ×”×’×©×ž×” ×”×ª×©×œ×•× ×”×ª×§×‘×œ',0),(269769,7494,'el','B2B ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Î´Î¹Î±Ï„Î±Î³Î® Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… Î­Î»Î±Î²Îµ',0),(269770,7494,'zh','å•†ä¸šå¯¹å•†ä¸šçš„å±¥è¡Œè®¢å•å·²æ”¶åˆ°ä»˜æ¬¾\r\n',0),(269771,7494,'sv','B2B uppfyllelse ordning betalning mottagen',0),(269772,7494,'it','Ordine completo da azienda B2B ricevuto correttamente',0),(269773,7494,'tl','',0),(269774,7494,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3592;&#3634;&#3585; B2B',0),(269775,7494,'hi','B2B à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(269776,7494,'ms','B2B memenuhi perintah pembayaran yang diterima',0),(269777,7494,'ar','Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ø¯ÙØ¹ Ø£Ù…Ø± ÙˆÙØ§Ø¡ B2B',0),(269778,7494,'fr','B2B Fulfillment commande paiement reÃ§u',0),(269779,7494,'jp','B2B ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼æ”¯æ‰•å—é ˜',0),(269780,7494,'pt','B2B cumprimento ordem pagamento recebido',0),(269781,7494,'ru','B2B Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»',0),(269782,7494,'es','N2N Pago de Pedido de Cumplimiento Recibido ',0),(269783,7494,'de','B2B ErfÃ¼llung Bestellung Zahlung erhalten',0),(269784,7494,'en','B2B Fulfillment Order Payment Received',0),(269785,7495,'is','',0),(269786,7495,'dr','ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ø§ÙŠÙ† Ø§ÙŠÙ…ÙŠÙ„  ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(269787,7495,'pr','ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ø§ÙŠÙ† Ø§ÙŠÙ…ÙŠÙ„  ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(269788,7495,'tr','Bu e-posta/giriÅŸ sahip bir kullanÄ±cÄ± zaten var.',0),(269789,7495,'pl','UÅ¼ytkownik rezygnowaÄ‡ ten poczta elektroniczna/logowania juÅ¼ istnieje.',0),(269790,7495,'bg','Ð’ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ñ Ñ‚Ð¾Ð·Ð¸ Ð¸Ð¼ÐµÐ¹Ð»/Ð²Ñ…Ð¾Ð´.',0),(269791,7495,'ur','ÛŒÛ Ø§ÛŒ Ù…ÛŒÙ„/Ù„Ø§Ú¯ Ø§Ù† Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© ØµØ§Ø±Ù Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Û”',0),(269792,7495,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº ÑÐ° Ð¾Ð²Ð° ÐµÐ¼Ð°Ð¸Ð»/Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(269793,7495,'vi','NgÆ°á»i Sá»­ Dá»¥ng vá»›i email/TK Ä‘Äƒng nháº­p nÃ y Ä‘Ã£ tá»“n táº¡i',0),(269794,7495,'af','\'n Gebruiker met hierdie e-pos/aantekening bestaan alreeds.',0),(269795,7495,'ro','Un utilizator cu acest e-mail/nume existÄƒ deja.',0),(269796,7495,'et','Kasutaja e-posti/login on juba olemas.',0),(269797,7495,'si','Uporabnik s tem email/Å¾e obstaja.',0),(269798,7495,'ba','Pengguna dengan email/login ini sudah ada.',0),(269799,7495,'nl','Er bestaat al een gebruiker met deze email/login.',0),(269800,7495,'fi','Email/login kÃ¤yttÃ¤jÃ¤ on jo olemassa.',0),(269801,7495,'no','Det finnes allerede en konto med dette email /.',0),(269802,7495,'da','En bruger med denne email/login findes allerede.',0),(269803,7495,'ko','ì´ ì´ë©”ì¼/ë¡œê·¸ì¸ ì‚¬ìš©ìžê°€ ì´ë¯¸ ì¡´ìž¬ í•©ë‹ˆë‹¤.',0),(269804,7495,'he','×ž×©×ª×ž×© ×¢× ×“×•× ×œ/×›× ×™×¡×” ×–×• ×›×‘×¨ ×§×™×™×ž×ª.',0),(269805,7495,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î­Î½Î±Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿/ÏƒÏÎ½Î´ÎµÏƒÎ·.',0),(269806,7495,'zh','æ­¤ç”µå­é‚®ä»¶/ç™»å½•ç”¨æˆ·å·²ç»å­˜åœ¨..\r\n',0),(269807,7495,'sv','Det finns redan en anvÃ¤ndare med denna e-post/login.',0),(269808,7495,'it','Esiste giÃ  un utente con questa email/login.',0),(269809,7495,'tl','',0),(269810,7495,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3585;&#3633;&#3610;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3609;&#3637;&#3657;&#3652;&#3604;&#3657;&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3',0),(269811,7495,'hi','à¤‡à¤¸ à¤ˆà¤®à¥‡à¤²/à¤²à¥‰à¤—à¤¿à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆà¥¤',0),(269812,7495,'ms','Pengguna dengan e-mel/log masuk ini sudah wujud.',0),(269813,7495,'ar','Ù…Ø³ØªØ®Ø¯Ù… Ù…Ø¹ Ø§Ù„Ø¯Ø®ÙˆÙ„/Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù‡Ø°Ø§ Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„.',0),(269814,7495,'fr','Un utilisateur avec cet email/connexion existe dÃ©jÃ .',0),(269815,7495,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ãŒã“ã® e ãƒ¡ãƒ¼ãƒ« ãƒ» ãƒ­ã‚°ã‚¤ãƒ³ã¯æ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(269816,7495,'pt','Um utilizador com este e-mail/login jÃ¡ existe.',0),(269817,7495,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ñ ÑÑ‚Ð¸Ð¼ email/Ð»Ð¾Ð³Ð¸Ð½ ÑƒÐ¶Ðµ ÑÐ¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ÑÑ. ',0),(269818,7495,'es','Un usuario con est email/login ya existe',0),(269819,7495,'de','Ein Benutzer mit dieser e-Mail/Login ist bereits vorhanden.',0),(269820,7495,'en','A user with this email/login already exists.',0),(269821,7496,'is','',0),(269822,7496,'dr','B2B Ø«Ø¨Øª Ù†Ø§Ù…   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(269823,7496,'pr','B2B Ø«Ø¨Øª Ù†Ø§Ù…   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(269824,7496,'tr','B2B kayÄ±t',0),(269825,7496,'pl','Rejestracja B2B',0),(269826,7496,'bg','B2B Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(269827,7496,'ur','B2B Ø³Ø§Ø¦Ù† Ø§Ù¾',0),(269828,7496,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð° Ð½Ð° Ð‘2Ð‘',0),(269829,7496,'vi','B2B ÄÄƒng KÃ½',0),(269830,7496,'af','B2B Aantekening',0),(269831,7496,'ro','B2B Ã®nscriere',0),(269832,7496,'et','B2B registreerumine',0),(269833,7496,'si','Prijava v B2B',0),(269834,7496,'ba','B2B Signup',0),(269835,7496,'nl','B2B Signup',0),(269836,7496,'fi','B2B Kirjaudu',0),(269837,7496,'no','B2B registrering',0),(269838,7496,'da','B2B tilmelding',0),(269839,7496,'ko','B2B ë“±ë¡',0),(269840,7496,'he','×”×¨×©×ž×” B2B',0),(269841,7496,'el','Î•Î³Î³ÏÎ±Ï†Î® B2B',0),(269842,7496,'zh','å•†ä¸šå¯¹å•†ä¸šçš„æ³¨å†Œ\r\n',0),(269843,7496,'sv','B2B Signup',0),(269844,7496,'it','Iscrizione azienda B2B',0),(269845,7496,'tl','',0),(269846,7496,'th','&#3626;&#3617;&#3633;&#3588;&#3619;&#3626;&#3617;&#3634;&#3594;&#3636;&#3585; B2B',0),(269847,7496,'hi','B2B à¤¸à¤¾à¤‡à¤¨à¤…à¤ª',0),(269848,7496,'ms','Pendaftaran B2B',0),(269849,7496,'ar','Ø§Ø´ØªØ±Ùƒ B2B',0),(269850,7496,'fr','B2B Signup',0),(269851,7496,'jp','B2B ã®ã‚µã‚¤ãƒ³ã‚¢ãƒƒãƒ—',0),(269852,7496,'pt','InscriÃ§Ã£o de B2B',0),(269853,7496,'ru','B2B Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(269854,7496,'es','N2N Inscribirse',0),(269855,7496,'de','B2B-Anmeldung',0),(269856,7496,'en','B2B Signup',0),(269857,7497,'is','',0),(269858,7497,'dr','Ú¯Ø±ÙˆÙ‡ Ø«Ø¨Øª Ù†Ø§Ù…   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(269859,7497,'pr','Ú¯Ø±ÙˆÙ‡ Ø«Ø¨Øª Ù†Ø§Ù…   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(269860,7497,'tr','Kategori',0),(269861,7497,'pl','Kategoria',0),(269862,7497,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(269863,7497,'ur','Ø²Ù…Ø±Û',0),(269864,7497,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(269865,7497,'vi','Thá»ƒ Loáº¡i ',0),(269866,7497,'af','Kategorie',0),(269867,7497,'ro','Categorie',0),(269868,7497,'et','B2B registreerumise kategooria',0),(269869,7497,'si','Kategorija',0),(269870,7497,'ba','Kategori',0),(269871,7497,'nl','Categorie',0),(269872,7497,'fi','Luokka',0),(269873,7497,'no','Kategori',0),(269874,7497,'da','Kategori',0),(269875,7497,'ko','ì¹´í…Œê³ ë¦¬',0),(269876,7497,'he','×§×˜×’×•×¨×™×”',0),(269877,7497,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(269878,7497,'zh','åˆ†ç±»\r\n',0),(269879,7497,'sv','Kategori',0),(269880,7497,'it','Categoria',0),(269881,7497,'tl','',0),(269882,7497,'th','&#3627;&#3617;&#3623;&#3604;',0),(269883,7497,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€',0),(269884,7497,'ms','Kategori',0),(269885,7497,'ar','Ø§Ù„ØªØµÙ†ÙŠÙ',0),(269886,7497,'fr','CatÃ©gorie',0),(269887,7497,'jp','ã‚«ãƒ†ã‚´ãƒª',0),(269888,7497,'pt','Categoria',0),(269889,7497,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(269890,7497,'es','CategorÃ­a',0),(269891,7497,'de','Kategorie',0),(269892,7497,'en','Category',0),(269893,7498,'is','',0),(269894,7498,'dr','ØªØ§ÙŠÙŠØ¯  Ø§ÙŠÙ…ÙŠÙ„',0),(269895,7498,'pr','ØªØ§ÙŠÙŠØ¯  Ø§ÙŠÙ…ÙŠÙ„',0),(269896,7498,'tr','E-posta Onayla',0),(269897,7498,'pl','PotwierdziÄ‡ adres E-mail',0),(269898,7498,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ Ð¸Ð¼ÐµÐ¹Ð»',0),(269899,7498,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(269900,7498,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ñ’Ð¸Ð²Ð°ÑšÐµ Ðµ-',0),(269901,7498,'vi','XÃ¡c nháº­n Email',0),(269902,7498,'af','Bevestig E-pos',0),(269903,7498,'ro','ConfirmÄƒ E-mail',0),(269904,7498,'et','Kinnita e-mail',0),(269905,7498,'si','Potrdi e poÅ¡to',0),(269906,7498,'ba','Konfirmasi Email',0),(269907,7498,'nl','E-mailadres bevestigen',0),(269908,7498,'fi','Vahvista sÃ¤hkÃ¶postiosoite',0),(269909,7498,'no','Bekrefte e-post',0),(269910,7498,'da','BekrÃ¦fte E-mail',0),(269911,7498,'ko','ì´ë©”ì¼ í™•ì¸',0),(269912,7498,'he','××©×¨×¨ ×“×•×',0),(269913,7498,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎµÏ„Îµ Ï„Î¿ Email',0),(269914,7498,'zh','ç¡®è®¤ç”µå­é‚®ä»¶\r\n',0),(269915,7498,'sv','BekrÃ¤fta e-postadress',0),(269916,7498,'it','Confermare l\'Email',0),(269917,7498,'tl','',0),(269918,7498,'th','&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(269919,7498,'hi','à¤ˆà¤®à¥‡à¤² à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(269920,7498,'ms','Mengesahkan e-mel',0),(269921,7498,'ar','ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(269922,7498,'fr','Confirmer votre courriel',0),(269923,7498,'jp','ãƒ¡ãƒ¼ãƒ«ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(269924,7498,'pt','Confirmar E-mail',0),(269925,7498,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Email',0),(269926,7498,'es','Confirmar Email',0),(269927,7498,'de','Email bestÃ¤tigen',0),(269928,7498,'en','Confirm Email',0),(269929,7499,'is','',0),(269930,7499,'dr','ØªØ§ÙŠÙŠØ¯ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ',0),(269931,7499,'pr','ØªØ§ÙŠÙŠØ¯ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ',0),(269932,7499,'tr','ParolayÄ± Onayla',0),(269933,7499,'pl','PotwierdÅº hasÅ‚o',0),(269934,7499,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°Ñ‚Ð°',0),(269935,7499,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(269936,7499,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ',0),(269937,7499,'vi','XÃ¡c nháº­n máº­t mÃ£',0),(269938,7499,'af','Bevestig Wagwoord',0),(269939,7499,'ro','ConfirmÄƒ parola',0),(269940,7499,'et','Kinnita salasÃµna',0),(269941,7499,'si','Potrditev gesla',0),(269942,7499,'ba','Konfirmasi Password',0),(269943,7499,'nl','Bevestig wachtwoord',0),(269944,7499,'fi','Vahvista salasana',0),(269945,7499,'no','Bekreft passord',0),(269946,7499,'da','BekrÃ¦ft adgangskode',0),(269947,7499,'ko','ì•”í˜¸ í™•ì¸',0),(269948,7499,'he','××©×¨ ××ª ×”×¡×™×¡×ž×”',0),(269949,7499,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· ÎºÏ‰Î´Î¹ÎºÎ¿Ï',0),(269950,7499,'zh','ç¡®è®¤å¯†ç \r\n',0),(269951,7499,'sv','BekrÃ¤fta lÃ¶senord',0),(269952,7499,'it','Conferma Password',0),(269953,7499,'tl','',0),(269954,7499,'th','&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;',0),(269955,7499,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(269956,7499,'ms','Sahkan kata laluan',0),(269957,7499,'ar','ØªØ£ÙƒÙŠØ¯ ÙƒÙ„Ù…Ø© Ø§Ù„Ø³Ø±',0),(269958,7499,'fr','Confirmer mot de passe',0),(269959,7499,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®ç¢ºèªå…¥åŠ›',0),(269960,7499,'pt','Confirmar senha',0),(269961,7499,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ ÐŸÐ°Ñ€Ð¾Ð»ÑŒ',0),(269962,7499,'es','Confirmar ContraseÃ±a',0),(269963,7499,'de','Kennwort bestÃ¤tigen',0),(269964,7499,'en','Confirm Password',0),(269965,7500,'is','',0),(269966,7500,'dr','Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯ ',0),(269967,7500,'pr','Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯ ',0),(269968,7500,'tr','E-posta adresleri eÅŸleÅŸmiyor.',0),(269969,7500,'pl','Adresy e-mail nie pasujÄ… do siebie.',0),(269970,7500,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑÐ¸ Ð½Ðµ ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‚.',0),(269971,7500,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ù¾ØªÛ’ Ø³Û’ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº Û”',0),(269972,7500,'sr','ÐÐ´Ñ€ÐµÑÐµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ ÑÐµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ.',0),(269973,7500,'vi','Äá»‹a chá»‰ Email khÃ´ng phÃ¹ há»£p',0),(269974,7500,'af','E-pos Adresse het nie gelyke.',0),(269975,7500,'ro','Adresele de e-mail nu se potrivesc.',0),(269976,7500,'et','E-maili aadressid ei klapi',0),(269977,7500,'si','E-poÅ¡tni naslovi se ne ujemajo.',0),(269978,7500,'ba','Alamat email tidak cocok.',0),(269979,7500,'nl','E-mailadressen komen niet overeen.',0),(269980,7500,'fi','SÃ¤hkÃ¶postiosoitteet eivÃ¤t tÃ¤smÃ¤Ã¤.',0),(269981,7500,'no','E-postadresser samsvarer ikke.',0),(269982,7500,'da','E-mail-adresser stemmer ikke overens.',0),(269983,7500,'ko','ì´ë©”ì¼ ì£¼ì†Œê°€ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(269984,7500,'he','×›×ª×•×‘×•×ª ×”×“×•× ×œ ××™× ×Ÿ ×ª×•××ž×•×ª.',0),(269985,7500,'el','Î”Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½.',0),(269986,7500,'zh','ç”µå­é‚®ä»¶åœ°å€ä¸åŒ¹é…ã€‚\r\n',0),(269987,7500,'sv','E-postadresser matchar inte.',0),(269988,7500,'it','Gli indirizzi email non corrispondono.',0),(269989,7500,'tl','',0),(269990,7500,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(269991,7500,'hi','à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¥‡ à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥‡à¥¤',0),(269992,7500,'ms','Alamat e-mel tidak sepadan.',0),(269993,7500,'ar','Ù„Ø§ ØªØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ø¹Ù†Ø§ÙˆÙŠÙ† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ.',0),(269994,7500,'fr','Les adresses de courriel ne correspondent pas.',0),(269995,7500,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ãŒä¸€è‡´ã—ã¾ã›ã‚“ã€‚',0),(269996,7500,'pt','EndereÃ§os de e-mail nÃ£o coincidem.',0),(269997,7500,'ru','ÐÐ´Ñ€ÐµÑÐ° ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð½Ðµ ÑÐ¾Ð²Ð¿Ð°Ð´Ð°ÑŽÑ‚.',0),(269998,7500,'es','Direcciones de Email no emparejan',0),(269999,7500,'de','E-Mail-Adressen stimmen nicht Ã¼berein.',0),(270000,7500,'en','Email addresses do not match.',0),(270001,7501,'is','',0),(270002,7501,'dr','Ø§Ú¯Ø± ÙŠÙƒ ØªØ¬Ø§Ø±Øª ',0),(270003,7501,'pr','Ø§Ú¯Ø± ÙŠÙƒ ØªØ¬Ø§Ø±Øª ',0),(270004,7501,'tr','EÄŸer bir iÅŸ',0),(270005,7501,'pl','JeÅ›li biznes',0),(270006,7501,'bg','ÐÐºÐ¾ ÐµÐ´Ð¸Ð½ Ð±Ð¸Ð·Ð½ÐµÑ',0),(270007,7501,'ur','Ø§Ú¯Ø± Ú©Ø§Ø±ÙˆØ¨Ø§Ø±',0),(270008,7501,'sr','ÐÐºÐ¾ Ñ˜Ðµ Ð¿Ð¾ÑÐ°Ð¾',0),(270009,7501,'vi','Náº¿u 1 doanh nghiá»‡p',0),(270010,7501,'af','Indien \'n Besigheid',0),(270011,7501,'ro','DacÄƒ un Business',0),(270012,7501,'et','Kui Ã¤ri',0),(270013,7501,'si','ÄŒe je poslovni',0),(270014,7501,'ba','Jika bisnis',0),(270015,7501,'nl','Als een Business',0),(270016,7501,'fi','Jos Business',0),(270017,7501,'no','Hvis en virksomhet',0),(270018,7501,'da','Hvis en virksomhed',0),(270019,7501,'ko','ê²½ìš° ë¹„ì¦ˆë‹ˆìŠ¤',0),(270020,7501,'he','×× ×”×¢×¡×§',0),(270021,7501,'el','Î‘Î½ Î¼Î¹Î± ÎµÏ€Î¹Ï‡ÎµÎ¯ÏÎ·ÏƒÎ·',0),(270022,7501,'zh','å¦‚æžœä¸€ä¸ªä¼ä¸š\r\n',0),(270023,7501,'sv','Om en verksamhet',0),(270024,7501,'it','Se un Business',0),(270025,7501,'tl','',0),(270026,7501,'th','&#3606;&#3657;&#3634;&#3648;&#3611;&#3655;&#3609;&#3608;&#3640;&#3619;&#3585;&#3636;&#3592;',0),(270027,7501,'hi','à¤…à¤—à¤° à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤° à¤à¤•',0),(270028,7501,'ms','Jika perniagaan',0),(270029,7501,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø±Ø¬Ø§Ù„ Ø§Ù„Ø£Ø¹Ù…Ø§Ù„',0),(270030,7501,'fr','Dans le cas entreprise',0),(270031,7501,'jp','ãƒ“ã‚¸ãƒã‚¹ã®å ´åˆ',0),(270032,7501,'pt','Se um negÃ³cio',0),(270033,7501,'ru','Ð•ÑÐ»Ð¸ Ð±Ð¸Ð·Ð½ÐµÑ',0),(270034,7501,'es','Si un Negocio',0),(270035,7501,'de','Wenn ein Unternehmen',0),(270036,7501,'en','If a Business',0),(270037,7502,'is','',0),(270038,7502,'dr','(Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡ ',0),(270039,7502,'pr','ÙÙŠÙ„Ø¯ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ (Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡ ',0),(270040,7502,'tr','Alan eksik',0),(270041,7502,'pl','BrakujÄ…ce pole',0),(270042,7502,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° Ð¿Ð¾Ð»Ðµ',0),(270043,7502,'ur','Ù‚Ø·Ø¹Û ØºØ§Ø¦Ø¨',0),(270044,7502,'sr','ÐŸÐ¾Ñ™Ðµ ÐºÐ¾Ñ˜Ðµ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ',0),(270045,7502,'vi','Thiáº¿u trÆ°á»ng',0),(270046,7502,'af','Vermisde Veld',0),(270047,7502,'ro','LipsÄƒ de cÃ¢mp',0),(270048,7502,'et','Puuduva vÃ¤lja',0),(270049,7502,'si','Manjka polje',0),(270050,7502,'ba','Hilang Field',0),(270051,7502,'nl','Ontbrekende veld',0),(270052,7502,'fi','Puuttuvaan kenttÃ¤Ã¤n',0),(270053,7502,'no','Manglende felt',0),(270054,7502,'da','Mangler felt',0),(270055,7502,'ko','ëˆ„ë½ ëœ í•„ë“œ',0),(270056,7502,'he','×©×“×•×ª ×—×¡×¨×™×',0),(270057,7502,'el','Î›ÎµÎ¯Ï€ÎµÎ¹ Ï„Î¿ Ï€ÎµÎ´Î¯Î¿',0),(270058,7502,'zh','ç¼ºå°‘æ ä½\r\n',0),(270059,7502,'sv','FÃ¤lt som saknas',0),(270060,7502,'it','Campo mancante',0),(270061,7502,'tl','',0),(270062,7502,'th','&#3615;&#3636;&#3621;&#3604;&#3660;&#3607;&#3637;&#3656;&#3627;&#3634;&#3618;&#3652;&#3611;',0),(270063,7502,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤—à¥à¤®',0),(270064,7502,'ms','Bidang yang hilang',0),(270065,7502,'ar','Ø­Ù‚Ù„ Ù…ÙÙ‚ÙˆØ¯',0),(270066,7502,'fr','Champ manquant',0),(270067,7502,'jp','æ¬ è½ã—ã¦ã„ã‚‹ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(270068,7502,'pt','Campo ausente',0),(270069,7502,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¿Ð¾Ð»Ðµ',0),(270070,7502,'es','Falta Campo',0),(270071,7502,'de','Fehlendes Feld',0),(270072,7502,'en','Missing Field',0),(270073,7503,'is','',0),(270074,7503,'dr','NolaPro Ø«Ø¨Øª Ù†Ø§Ù… ÙƒØ±Ø¯Ù† Ø¯Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(270075,7503,'pr','NolaPro Ø«Ø¨Øª Ù†Ø§Ù… ÙƒØ±Ø¯Ù† Ø¯Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(270076,7503,'tr','B2B kayÄ±t',0),(270077,7503,'pl','Rejestracja B2B',0),(270078,7503,'bg','B2B Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(270079,7503,'ur','B2B Ø³Ø§Ø¦Ù† Ø§Ù¾',0),(270080,7503,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð° Ð½Ð° Ð‘2Ð‘',0),(270081,7503,'vi','ÄÄƒng kÃ½ NolaPro B2B',0),(270082,7503,'af','NolaPro B2B Aansluiting',0),(270083,7503,'ro','B2B Ã®nscriere',0),(270084,7503,'et','NolaPro B2B registreerumine',0),(270085,7503,'si','Prijava v B2B',0),(270086,7503,'ba','B2B Signup',0),(270087,7503,'nl','B2B Signup',0),(270088,7503,'fi','B2B Kirjaudu',0),(270089,7503,'no','B2B registrering',0),(270090,7503,'da','B2B tilmelding',0),(270091,7503,'ko','B2B ë“±ë¡',0),(270092,7503,'he','×”×¨×©×ž×” B2B',0),(270093,7503,'el','Î•Î³Î³ÏÎ±Ï†Î® B2B',0),(270094,7503,'zh','å•†ä¸šå¯¹å•†ä¸šç½‘ç«™ä¸Šç”³è¯·\r\n',0),(270095,7503,'sv','B2B Signup',0),(270096,7503,'it','Iscrizione B2B',0),(270097,7503,'tl','',0),(270098,7503,'th','&#3621;&#3591;&#3607;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609; NolaPro B2B',0),(270099,7503,'hi','B2B à¤¸à¤¾à¤‡à¤¨à¤…à¤ª',0),(270100,7503,'ms','Pendaftaran B2B',0),(270101,7503,'ar','Ø§Ø´ØªØ±Ùƒ B2B',0),(270102,7503,'fr','B2B Signup',0),(270103,7503,'jp','B2B ã®ã‚µã‚¤ãƒ³ã‚¢ãƒƒãƒ—',0),(270104,7503,'pt','InscriÃ§Ã£o de B2B',0),(270105,7503,'ru','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ NolaPro B2B',0),(270106,7503,'es','NolaPro ConfiguraciÃ³n de N2N',0),(270107,7503,'de','B2B-Anmeldung',0),(270108,7503,'en','B2B Signup',0),(270109,7504,'is','',0),(270110,7504,'dr','Ø«Ø¨Øª Ù†Ø§Ù…  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ù…Ø¬Ø§Ø² Ù†ÙŠØ³Øª ',0),(270111,7504,'pr','Ø«Ø¨Øª Ù†Ø§Ù…  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ù…Ø¬Ø§Ø² Ù†ÙŠØ³Øª ',0),(270112,7504,'tr','KayÄ±t bu ÅŸirket iÃ§in izin verilmez',0),(270113,7504,'pl','Rejestracja nie jest dozwolone dla tej firmy',0),(270114,7504,'bg','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ, Ð½Ðµ Ðµ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°',0),(270115,7504,'ur','Ø³Ø§Ø¦Ù† Ø§Ù¾ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº Ø¯ÛŒ',0),(270116,7504,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾ Ð·Ð° Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(270117,7504,'vi','Cty nÃ y khÃ´ng cho phÃ©p Ä‘Äƒng kÃ½',0),(270118,7504,'af','Aantekening Vir Hierdie Onderneming Nie Toegelaat Nie',0),(270119,7504,'ro','Nu este permis pentru aceastÄƒ companie de Ã®nscriere',0),(270120,7504,'et','Ei ole lubatud selle firma registreerimine',0),(270121,7504,'si','Znamenje, ki ni dovoljeno za to podjetje',0),(270122,7504,'ba','Pendaftaran tidak diperkenankan untuk perusahaan ini',0),(270123,7504,'nl','Signup niet toegestaan voor dit bedrijf',0),(270124,7504,'fi','Kirjaudu ei sallita tÃ¤lle yritykselle',0),(270125,7504,'no','Registrering ikke tillatt For dette selskapet',0),(270126,7504,'da','Tilmelding ikke tilladt For dette selskab',0),(270127,7504,'ko','ì´ íšŒì‚¬ì— ëŒ€ í•œ í—ˆìš© ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤ ê°€ìž…',0),(270128,7504,'he','×”×”×¦×˜×¨×¤×•×ª ××™× ×” ×ž×•×ª×¨×ª ×¢×‘×•×¨ ×”×—×‘×¨×” ×”×–××ª',0),(270129,7504,'el','Î•Î³Î³ÏÎ±Ï†Î® Î´ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ ÎµÎ½ Î»ÏŒÎ³Ï‰ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(270130,7504,'zh','ç«‹å³ç™»è®°ä¸å…è®¸æ­¤å…¬å¸\r\n',0),(270131,7504,'sv','Signup inte tillÃ¥tet fÃ¶r detta fÃ¶retag',0),(270132,7504,'it','Iscrizione non consentita per questa azienda',0),(270133,7504,'tl','',0),(270134,7504,'th','&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;&#3652;&#3617;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3609;&#3637;&#3',0),(270135,7504,'hi','à¤ªà¤‚à¤œà¥€à¤•à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(270136,7504,'ms','Pendaftaran tidak dibenarkan bagi Syarikat ini',0),(270137,7504,'ar','Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ Ù„Ø§ ÙŠØ³Ù…Ø­ Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(270138,7504,'fr','Inscription non autorisÃ©e pour cette sociÃ©tÃ©',0),(270139,7504,'jp','ã‚µã‚¤ãƒ³ã‚¢ãƒƒãƒ—ã“ã®ä¼šç¤¾ã®ãŸã‚è¨±å¯ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(270140,7504,'pt','InscriÃ§Ã£o nÃ£o permitida para esta empresa',0),(270141,7504,'ru','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ Ð½Ðµ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(270142,7504,'es','InscripciÃ³n No Permitida Para Esta Empresa',0),(270143,7504,'de','Anmeldungen fÃ¼r diese Firma nicht zulÃ¤ssig',0),(270144,7504,'en','Signup Not Allowed For This Company',0),(270145,7505,'is','',0),(270146,7505,'dr','Ø­Ø³Ø§Ø¨ Ø´Ù…Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ ',0),(270147,7505,'pr','Ø­Ø³Ø§Ø¨ Ø´Ù…Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ ',0),(270148,7505,'tr','HesabÄ±nÄ±z baÅŸarÄ±yla oluÅŸturuldu.',0),(270149,7505,'pl','PomyÅ›lnie utworzono konta.',0),(270150,7505,'bg','Ð’Ð°ÑˆÐ¸ÑÑ‚ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ðµ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(270151,7505,'ur','Ø¢Ù¾ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ù†Ø§Ø¦ÛŒ Ú¯Ø¦ÛŒ ÛÛ’ Û”',0),(270152,7505,'sr','Ð’Ð°Ñˆ Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°.',0),(270153,7505,'vi','TK Cá»§a Báº¡n Ä‘Ã£ táº¡o thÃ nh cÃ´ng',0),(270154,7505,'af','U rekening is suksesvol geskep.',0),(270155,7505,'ro','Contul tau a fost creat cu succes',0),(270156,7505,'et','Teie konto on edukalt loodud',0),(270157,7505,'si','VaÅ¡ raÄun je bil uspeÅ¡no ustvarjen.',0),(270158,7505,'ba','Account Anda telah berhasil dibuat.',0),(270159,7505,'nl','Uw account is aangemaakt.',0),(270160,7505,'fi','Tilisi on luotu onnistuneesti.',0),(270161,7505,'no','Kontoen er opprettet.',0),(270162,7505,'da','Din konto er blevet oprettet.',0),(270163,7505,'ko','ê·€í•˜ì˜ ê³„ì •ì€ ì„±ê³µì ìœ¼ë¡œ ìƒì„± ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(270164,7505,'he','×”×—×©×‘×•×Ÿ ×©×œ×š × ×•×¦×¨ ×‘×”×¦×œ×—×”.',0),(270165,7505,'el','ÎˆÏ‡ÎµÎ¹ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÎ±Ï‚.',0),(270166,7505,'zh','æ‚¨çš„å¸æˆ·å·²æˆåŠŸå»ºç«‹ã€‚\r\n',0),(270167,7505,'sv','Ditt konto har skapats.',0),(270168,7505,'it','L\'account Ã¨ stato creato correttamente.',0),(270169,7505,'tl','',0),(270170,7505,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3652;&#3604;&#3657;&#3626;&#3619;&#3657;&#3634;&#3591;&#3586;&#3638;&#3657;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(270171,7505,'hi','à¤†à¤ªà¤•à¤¾ à¤–à¤¾à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(270172,7505,'ms','Akaun anda telah berjaya dicipta.',0),(270173,7505,'ar','Ø£Ù†Ø´ÙŠØ¡ Ø­Ø³Ø§Ø¨Ùƒ Ø¨Ù†Ø¬Ø§Ø­',0),(270174,7505,'fr','Votre compte a Ã©tÃ© crÃ©Ã© avec succÃ¨s.',0),(270175,7505,'jp','ã‚ãªãŸã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒæ­£å¸¸ã«ä½œæˆã•ã‚Œã¾ã—ãŸã€‚',0),(270176,7505,'pt','Sua conta foi criada com Ãªxito.',0),(270177,7505,'ru','Ð’Ð°Ñˆ Ð¿Ñ€Ð¾Ñ„Ð¸Ð»ÑŒ Ð±Ñ‹Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½.',0),(270178,7505,'es','Su cuenta ha sido creada satisfactoriamente.',0),(270179,7505,'de','Ihr Konto wurde erfolgreich erstellt.',0),(270180,7505,'en','Your account has been successfully created.',0),(270181,7506,'is','',0),(270182,7506,'dr','. ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø´Ù…Ø§ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ù…Ø§ Ø®ÙˆØ§Ù‡Ø¯ Ø¨ÙˆØ¯',0),(270183,7506,'pr','Ø´Ù…Ø§ Ø§ÙƒÙ†ÙˆÙ† Ù…Ø¬Ø¯Ø¯Ø§ Ø¨Ù‡ ØµÙØ­Ù‡ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ù‡Ø¯Ø§ÙŠØª Ù…ÙŠ Ø´ÙˆÙŠØ¯ . ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø´Ù…Ø§ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ù…Ø§ Ø®ÙˆØ§Ù‡Ø¯ Ø¨ÙˆØ¯',0),(270184,7506,'tr','Åžimdi giriÅŸ sayfasÄ±na yÃ¶nlendirileceksiniz. GiriÅŸ bilgilerinizi e-posta adresiniz olacaktÄ±r.',0),(270185,7506,'pl','Zostaniesz teraz przekierowany na stronÄ™ logowania. Login bÄ™dzie TwÃ³j adres e-mail.',0),(270186,7506,'bg','Ð¡ÐµÐ³Ð° Ñ‰Ðµ Ð±ÑŠÐ´ÐµÑ‚Ðµ Ð¿Ñ€ÐµÐ½Ð°ÑÐ¾Ñ‡ÐµÐ½Ð¸ ÐºÑŠÐ¼ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð° Ð²Ñ…Ð¾Ð´. Ð’Ñ…Ð¾Ð´ Ñ‰Ðµ Ð±ÑŠÐ´Ðµ Ð²Ð°ÑˆÐ¸Ñ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ.',0),(270187,7506,'ur','Ø¢Ù¾ Ø§Ø¨ Ù„Ø§Ú¯ Ø§Ù† ØµÙØ­Û’ Ù¾Ø± ÛØ¯Ø§ÛŒØª Ú©Ø±Û’ Ú¯Ø§ Û” Ø¢Ù¾ Ú©Ø§ Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÛŒÚˆØ±ÛŒØ³ Ø¢Ù¾ Ù„Ø§Ú¯ Ø§Ù† Ù†ÛÛŒÚº ÛÙˆ Ú¯Ø§ Û”',0),(270188,7506,'sr','Ð¡Ð°Ð´Ð° Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÑƒÑÐ¼ÐµÑ€ÐµÐ½Ð¸ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ. Ð’Ð°ÑˆÑƒ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñƒ Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð²Ð°ÑˆÐ° Ðµ-Ð¼Ð°Ð¸Ð» Ð°Ð´Ñ€ÐµÑÐ°.',0),(270189,7506,'vi','ChÃºng tÃ´i Ä‘Ã£ chuyá»ƒn báº¡n sang trang Ä‘Äƒng nháº­p khÃ¡c. Äá»‹a chá»‰ Email cá»§a báº¡n sáº½ dÃ¹ng Ä‘á»ƒ Ä‘Äƒng nháº­p',0),(270190,7506,'af','U word nou na die aantekenbladsy geherroeteer.  U aantekening sal u e-posadres wees.',0),(270191,7506,'ro','VeÅ£i fi redirecÅ£ionat cÄƒtre pagina de conectare',0),(270192,7506,'et','Teid suunatakse nÃ¼Ã¼d sisselogimise lehele',0),(270193,7506,'si','Zdaj preusmerjeni boste na stran za prijavo. VaÅ¡o prijavo bo vaÅ¡ e-poÅ¡tni naslov.',0),(270194,7506,'ba','Sekarang Anda akan diarahkan ke halaman login. Login Anda akan menjadi alamat email Anda.',0),(270195,7506,'nl','U wordt nu doorgestuurd naar de loginpagina. Uw login zullen uw e-mailadres.',0),(270196,7506,'fi','Nyt sinut ohjataan kirjautumissivulle. KÃ¤yttÃ¤jÃ¤tunnuksesi on sÃ¤hkÃ¶postiosoitteesi.',0),(270197,7506,'no','Du vil nÃ¥ bli omdirigert til pÃ¥loggingssiden. PÃ¥loggingsinformasjonen vil vÃ¦re din e-postadresse.',0),(270198,7506,'da','Du vil nu blive omdirigeret til login-siden. Dit login vil vÃ¦re din e-mail-adresse.',0),(270199,7506,'ko','ì§€ê¸ˆ ë¡œê·¸ì¸ íŽ˜ì´ì§€ë¡œ ë¦¬ë””ë ‰ì…˜í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤. ê·€í•˜ì˜ ë¡œê·¸ì¸ ì´ë©”ì¼ ì£¼ì†Œë¥¼ ê²ƒìž…ë‹ˆë‹¤.',0),(270200,7506,'he','×›×¢×ª ×ª×•×¢×‘×¨ ×œ×¢×ž×•×“ ×”×”×ª×—×‘×¨×•×ª. ×”×›× ×™×¡×” ×©×œ×š ×ª×”×™×” ×›×ª×•×‘×ª ×”×“×•× ×œ ×©×œ×š.',0),(270201,7506,'el','Î¤ÏŽÏÎ± Î¸Î± Î¼ÎµÏ„Î±Ï†ÎµÏÎ¸ÎµÎ¯Ï„Îµ ÏƒÏ„Î· ÏƒÎµÎ»Î¯Î´Î± ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚. Î¤Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏÎ½Î´ÎµÏƒÎ®Ï‚ ÏƒÎ±Ï‚ Î¸Î± Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… ÏƒÎ±Ï‚.',0),(270202,7506,'zh','ä½ å°†é‡æ–°ç™»é™†',0),(270203,7506,'sv','Du kommer nu att omdirigeras till inloggningssidan. Din inloggning kommer att vara din e-postadress.',0),(270204,7506,'it','Sarai ora reindirizzato alla pagina di accesso. Il login sarÃ  il tuo indirizzo email.',0),(270205,7506,'tl','',0),(270206,7506,'th','You will now be redirected to the login page. Your login will be your email address.',0),(270207,7506,'hi','à¤†à¤ª à¤…à¤¬ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤ªà¥à¤¨à¤ƒ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾à¥¤ à¤…à¤ªà¤¨à¥‡ à¤²à¥‰à¤—à¤¿à¤¨ à¤…à¤ªà¤¨à¤¾ à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¤¾ à¤¹à¥‹ à¤œà¤¾à¤à¤—à¤¾à¥¤',0),(270208,7506,'ms','Anda akan kini dihalakan ke halaman log masuk. Log masuk anda adalah alamat e-mel anda.',0),(270209,7506,'ar','Ø§Ù„Ø¢Ù† Ø¥Ø¹Ø§Ø¯Ø© ØªÙˆØ¬ÙŠÙ‡Ùƒ Ø¥Ù„Ù‰ ØµÙØ­Ø© ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„. Ø³ÙˆÙ ÙŠØªÙ… ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ.',0),(270210,7506,'fr','Vous allez maintenant Ãªtre redirigÃ© vers la page d\'identification. Votre identifiant sera votre adresse e-mail.',0),(270211,7506,'jp','ã‚ãªãŸã¯ä»Šã€ãƒ­ã‚°ã‚¤ãƒ³ ãƒšãƒ¼ã‚¸ã«ãƒªãƒ€ã‚¤ãƒ¬ã‚¯ãƒˆã•ã‚Œã¾ã™ã€‚ã‚ãªãŸã®ãƒ­ã‚°ã‚¤ãƒ³ã‚’ã‚ãªãŸã®ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã¨ãªã‚Šã¾ã™ã€‚',0),(270212,7506,'pt','VocÃª serÃ¡ redirecionado para a pÃ¡gina de login. Seu login serÃ¡ o seu endereÃ§o de e-mail.',0),(270213,7506,'ru','Ð¢ÐµÐ¿ÐµÑ€ÑŒ Ð²Ñ‹ Ð±ÑƒÐ´ÐµÑ‚Ðµ Ð¿ÐµÑ€ÐµÐ½Ð°Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð²Ñ…Ð¾Ð´Ð°. Ð›Ð¾Ð³Ð¸Ð½Ð¾Ð¼ Ð±ÑƒÐ´ÐµÑ‚ Ð²Ð°Ñˆ Ð°Ð´Ñ€ÐµÑ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹.',0),(270214,7506,'es','Ahora serÃ¡ redirigido a la pÃ¡gina de entrada. Su registro serÃ¡ su direcciÃ³n de email.',0),(270215,7506,'de','Sie werden jetzt zur Anmeldeseite umgeleitet. Ihr Login wird Ihre e-Mail-Adresse sein.',0),(270216,7506,'en','You will now be redirected to the login page. Your login will be your email address.',0),(270217,7507,'is','',0),(270218,7507,'dr','Ú¯Ø±ÙˆÙ‡ Ø«Ø¨Øª Ù†Ø§Ù…   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(270219,7507,'pr','Ú¯Ø±ÙˆÙ‡ Ø«Ø¨Øª Ù†Ø§Ù…   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(270220,7507,'tr','Grup',0),(270221,7507,'pl','Grupa',0),(270222,7507,'bg','Ð“Ñ€ÑƒÐ¿Ð°',0),(270223,7507,'ur','Ú¯Ø±ÙˆÙ¾',0),(270224,7507,'sr','Ð“Ñ€ÑƒÐ¿Ð°',0),(270225,7507,'vi','NhÃ³m',0),(270226,7507,'af','Groep',0),(270227,7507,'ro','Grupa',0),(270228,7507,'et','B2B registreerumise grupp',0),(270229,7507,'si','Skupina',0),(270230,7507,'ba','Kelompok',0),(270231,7507,'nl','Groep',0),(270232,7507,'fi','RyhmÃ¤',0),(270233,7507,'no','Gruppe',0),(270234,7507,'da','Gruppe',0),(270235,7507,'ko','ê·¸ë£¹',0),(270236,7507,'he','×§×‘×•×¦×”',0),(270237,7507,'el','ÎŸÎ¼Î¬Î´Î±',0),(270238,7507,'zh','é›†å›¢\r\n',0),(270239,7507,'sv','Grupp',0),(270240,7507,'it','Gruppo',0),(270241,7507,'tl','',0),(270242,7507,'th','&#3585;&#3621;&#3640;&#3656;&#3617;',0),(270243,7507,'hi','à¤¸à¤®à¥‚à¤¹',0),(270244,7507,'ms','Kumpulan',0),(270245,7507,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(270246,7507,'fr','Groupe',0),(270247,7507,'jp','ã‚°ãƒ«ãƒ¼ãƒ—',0),(270248,7507,'pt','Grupo',0),(270249,7507,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð°',0),(270250,7507,'es','Grupo',0),(270251,7507,'de','Gruppe',0),(270252,7507,'en','Group',0),(270253,7508,'is','',0),(270254,7508,'dr',' Ø¯Ù‡ Ù…Ø´ØªØ±ÛŒ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ Ø§Ø®ÛŒØ±',0),(270255,7508,'pr',' Ø¯Ù‡ Ù…Ø´ØªØ±ÛŒ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ Ø§Ø®ÛŒØ±',0),(270256,7508,'tr','10 en son eklenen mÃ¼ÅŸteriler',0),(270257,7508,'pl','10 ostatnio dodane klienci',0),(270258,7508,'bg','10 Ð½Ð°Ð¹-Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(270259,7508,'ur','Ø¨Ø§Ù„Ú©Ù„ Ù†Ø¡Û’ Ú¯Ø§Ú¾Ú© ',0),(270260,7508,'sr','10 Ð²ÐµÑ›Ð¸Ð½Ð° Ð½ÐµÐ´Ð°Ð²Ð½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¾ ÐºÑƒÐ¿Ñ†Ðµ',0),(270261,7508,'vi','10 KhÃ¡ch HÃ ng Má»›i Cáº­p Nháº­t',0),(270262,7508,'af','10 Mees Onlangs Bygevoegde Klante/KliÃ«nte',0),(270263,7508,'ro','10 Clientii Adaugati Recent',0),(270264,7508,'et','10 hiljuti lisatud klienti',0),(270265,7508,'si','10 nazadnje dodanih strank',0),(270266,7508,'ba','10 Pelanggan terbanyak',0),(270267,7508,'nl','10 Recent toegevoegde klanten',0),(270268,7508,'fi','10 viimeksi lisÃ¤tty asiakkaat',0),(270269,7508,'no','10 mest nylig lagt til kunder',0),(270270,7508,'da','10 mest for nylig tilfÃ¸jet kunder',0),(270271,7508,'ko','10 ê°œì˜ ê°€ìž¥ ìµœê·¼ì— ì¶”ê°€ ëœ ê³ ê°',0),(270272,7508,'he','10 ×©× ×•×¡×¤×• ×œ××—×¨×•× ×” ×”×œ×§×•×—×•×ª',0),(270273,7508,'el','10 Î Î¿Î¹Î¿ Î ÏÏŒÏƒÏ†Î±Ï„Î¿Î¹ Î•Î³Î³ÎµÎ³ÏÎ±Î¼Î¼Î­Î½Î¿Î¹ Î ÎµÎ»Î¬Ï„ÎµÏ‚',0),(270274,7508,'zh','æœ€æ–°å¢žåŠ çš„10ä½å®¢æˆ·',0),(270275,7508,'sv','10 Senast tillagda kunder',0),(270276,7508,'it','Ultimi 10 clienti aggiunti',0),(270277,7508,'tl','sampung pinakahuling isinamang suki',0),(270278,7508,'th','10 à¸­à¸±à¸™à¸”à¸±à¸š à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(270279,7508,'hi','10 à¤¸à¤¬à¤¸à¥‡ à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡ à¤—à¤ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(270280,7508,'ms','10 Tempahan Recently Added pelanggan',0),(270281,7508,'ar','10 Ù…Ø¹Ø¸Ù… Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„ØªÙŠ ØªÙ…Øª Ø¥Ø¶Ø§ÙØªÙ‡Ø§ Ù…Ø¤Ø®Ø±Ø§',0),(270282,7508,'fr','10 Dernier Clients AjoutÃ©s',0),(270283,7508,'jp','10 ã»ã¨ã‚“ã©ã®æœ€è¿‘è¿½åŠ ã•ã‚ŒãŸãŠå®¢æ§˜',0),(270284,7508,'pt','10 mais recentemente adicionados clientes',0),(270285,7508,'ru','10 ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ… ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² ',0),(270286,7508,'es','10 Clientes agregados MÃ¡s Recientes',0),(270287,7508,'de','10 aktuellste Kunden',0),(270288,7508,'en','10 Most Recently Added Customers',0),(270289,7509,'is','',0),(270290,7509,'dr','Ø¯Ù‡ Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯Ø¯ ',0),(270291,7509,'pr','Ø¯Ù‡ Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯Ø¯ ',0),(270292,7509,'tr','10 en yeni mÃ¼ÅŸteriler',0),(270293,7509,'pl','10 najnowszych klientÃ³w',0),(270294,7509,'bg','10 Ð½Ð°Ð¹-Ð½Ð¾Ð²Ð¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(270295,7509,'ur','Ø¯Ø³ Ù†ÛŒÛ’ Ú¯Ø§Ú¾Ú©',0),(270296,7509,'sr','10 Ð½Ð°Ñ˜Ð½Ð¾Ð²Ð¸Ñ˜Ð° ÐºÑƒÐ¿Ñ†Ðµ',0),(270297,7509,'vi','10 KhÃ¡ch HÃ ng Má»›i Nháº¥t',0),(270298,7509,'af','10 Nuuste Klante/KliÃ«nte',0),(270299,7509,'ro','10 Clientii Noi',0),(270300,7509,'et','10 uusimat klienti',0),(270301,7509,'si','10 najnovejÅ¡ih strank',0),(270302,7509,'ba','10 Pelanggan terbaru',0),(270303,7509,'nl','10 Nieuwste klanten',0),(270304,7509,'fi','10 uusin asiakkaat',0),(270305,7509,'no','10 siste kunder',0),(270306,7509,'da','10 nyeste kunder',0),(270307,7509,'ko','10 ìµœì‹  ê³ ê°',0),(270308,7509,'he','â€10 ×œ×§×•×—×•×ª ××—×¨×•× ×™×',0),(270309,7509,'el','10 ÎÎµÏŽÏ„ÎµÏÎ¿Î¹ Î ÎµÎ»Î¬Ï„ÎµÏ‚',0),(270310,7509,'zh','æœ€æ–° 10 ä½å®¢æˆ·',0),(270311,7509,'sv','10 Senaste Kunder',0),(270312,7509,'it','I 10 clienti piÃ¹ recenti',0),(270313,7509,'tl','sampung pinakabagong suki',0),(270314,7509,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸«à¸¡à¹ˆ 10 à¸£à¸²à¸¢à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(270315,7509,'hi','10 à¤¨à¤ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(270316,7509,'ms','10 pelanggan terbaru',0),(270317,7509,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø£Ø­Ø¯Ø« 10',0),(270318,7509,'fr','10 Nouveau Clients',0),(270319,7509,'jp','10 æœ€æ–°ã®ãŠå®¢æ§˜',0),(270320,7509,'pt','10 novos clientes',0),(270321,7509,'ru','10 ÐÐ¾Ð²Ñ‹Ñ… ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(270322,7509,'es','10 Clientes mÃ¡s Nuevos',0),(270323,7509,'de','10 neueste Kunden',0),(270324,7509,'en','10 Newest Customers',0),(270325,7510,'is','',0),(270326,7510,'dr','ØªØ§Ø±ÙŠØ® Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(270327,7510,'pr','ØªØ§Ø±ÙŠØ® Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(270328,7510,'tr','Eklenme tarihi',0),(270329,7510,'pl','Data dodania',0),(270330,7510,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(270331,7510,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±Ø¯Û ØªØ§Ø±ÛŒØ®',0),(270332,7510,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ°',0),(270333,7510,'vi','ThÃªm ngÃ y',0),(270334,7510,'af','Datum Bygevoeg',0),(270335,7510,'ro','Data adaugarii',0),(270336,7510,'et','Lisamise kuupÃ¤ev',0),(270337,7510,'si','Datum dodajanja',0),(270338,7510,'ba','Tanggal ditambahkan',0),(270339,7510,'nl','Datum toegevoegd',0),(270340,7510,'fi','LisÃ¤tty',0),(270341,7510,'no','Dato lagt til',0),(270342,7510,'da','Dato tilfÃ¸jet',0),(270343,7510,'ko','ë‚ ì§œ ì¶”ê°€ ë¨',0),(270344,7510,'he','×ª××¨×™×š × ×•×¡×£',0),(270345,7510,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·Ï‚',0),(270346,7510,'zh','æ—¥æœŸæ·»åŠ \r\n',0),(270347,7510,'sv','Datum tillagd',0),(270348,7510,'it','Data di aggiunta',0),(270349,7510,'tl','',0),(270350,7510,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(270351,7510,'hi','à¤¤à¤¿à¤¥à¤¿ à¤œà¥‹à¤¡à¤¼à¥€ à¤—à¤ˆ',0),(270352,7510,'ms','Tarikh ditambah',0),(270353,7510,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø¶Ø§ÙØ©',0),(270354,7510,'fr','Date d\'ajout',0),(270355,7510,'jp','è¿½åŠ ã•ã‚ŒãŸæ—¥ä»˜',0),(270356,7510,'pt','Data adicionada',0),(270357,7510,'ru','Ð”Ð°Ñ‚Ð° Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(270358,7510,'es','Fecha Agregada',0),(270359,7510,'de','Datum hinzugefÃ¼gt',0),(270360,7510,'en','Date Added',0),(270361,7511,'is','',0),(270362,7511,'dr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¬Ø¯ÙŠØ¯ ',0),(270363,7511,'pr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¬Ø¯ÙŠØ¯ ',0),(270364,7511,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ yeni mÃ¼ÅŸteriler',0),(270365,7511,'pl','Widok nowych klientÃ³w',0),(270366,7511,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð½Ð¾Ð²Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(270367,7511,'ur','Ø¯ÛŒÚ©Ú¾ÛŒÚº Ù†Ø¦Û’ ØµØ§Ø±ÙÛŒÙ†',0),(270368,7511,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð½Ð¾Ð²Ð¸Ñ… ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(270369,7511,'vi','Xem khÃ¡ch hÃ ng má»›i',0),(270370,7511,'af','Besigtig Nuwe Klante/KliÃ«nte',0),(270371,7511,'ro','Vezi noi clienÅ£i',0),(270372,7511,'et','Vaata uusi kliente',0),(270373,7511,'si','Pogled nove stranke',0),(270374,7511,'ba','Lihat pelanggan baru',0),(270375,7511,'nl','Weergave nieuwe klanten',0),(270376,7511,'fi','NÃ¤ytÃ¤ uudet asiakkaat',0),(270377,7511,'no','Vise nye kunder',0),(270378,7511,'da','Se nye kunder',0),(270379,7511,'ko','ë³´ê¸° ì‹ ê·œ ê³ ê°',0),(270380,7511,'he','×œ×§×•×—×•×ª ×—×“×©×™× ×‘×ª×¦×•×’×”',0),(270381,7511,'el','Î ÏÎ¿Î²Î¿Î»Î® Î½Î­Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(270382,7511,'zh','æŸ¥çœ‹æ–°å®¢æˆ·\r\n',0),(270383,7511,'sv','Visa nya kunder',0),(270384,7511,'it','Vista nuovi clienti',0),(270385,7511,'tl','',0),(270386,7511,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(270387,7511,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤¨à¤ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(270388,7511,'ms','Lihat pelanggan baru',0),(270389,7511,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø²Ø¨Ø§Ø¦Ù† Ø§Ù„Ø¬Ø¯Ø¯',0),(270390,7511,'fr','Nouveaux clients vue',0),(270391,7511,'jp','ãƒ“ãƒ¥ãƒ¼ã®æ–°è¦é¡§å®¢',0),(270392,7511,'pt','Vista novos clientes',0),(270393,7511,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐÐ¾Ð²Ñ‹Ñ… ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(270394,7511,'es','Visionar Nuevos Clientes',0),(270395,7511,'de','Ansicht-Neukunden',0),(270396,7511,'en','View New Customers',0),(270397,7512,'is','',0),(270398,7512,'dr','OBS Ù…Ø¬Ù…ÙˆØ¹',0),(270399,7512,'pr','OBS Ù…Ø¬Ù…ÙˆØ¹',0),(270400,7512,'tr','OBS toplam',0),(270401,7512,'pl','Sumie OBS',0),(270402,7512,'bg','OBS Ð¾Ð±Ñ‰Ð¾',0),(270403,7512,'ur','Ø§ÙˆØ¨Ø³ Ú©Ù„',0),(270404,7512,'sr','ÐžÐ‘Ð¡ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(270405,7512,'vi','Tá»•ng cá»™ng OBS',0),(270406,7512,'af','OBS totaal',0),(270407,7512,'ro','OBS Total',0),(270408,7512,'et','OBS kokku',0),(270409,7512,'si','Skupno OBS',0),(270410,7512,'ba','OBS Total',0),(270411,7512,'nl','OBS totaal',0),(270412,7512,'fi','OBS yhteensÃ¤',0),(270413,7512,'no','OBS totalt',0),(270414,7512,'da','OBS alt',0),(270415,7512,'ko','OBS ì´',0),(270416,7512,'he','OBS ×¡×”',0),(270417,7512,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ OBS',0),(270418,7512,'zh','å¼€æ”¾å¼ä¿ç¨Žä»“\r\n',0),(270419,7512,'sv','OBS totalt',0),(270420,7512,'it','Totale OBS',0),(270421,7512,'tl','',0),(270422,7512,'th','OBS &#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(270423,7512,'hi','OBS à¤•à¥à¤²',0),(270424,7512,'ms','Jumlah OBS',0),(270425,7512,'ar','Ù…Ø¬Ù…ÙˆØ¹ OBS',0),(270426,7512,'fr','Total de l\'OBS',0),(270427,7512,'jp','æµ·åº•åœ°éœ‡è¨ˆåˆè¨ˆ',0),(270428,7512,'pt','Total OBS',0),(270429,7512,'ru','Ð’ÑÐµÐ³Ð¾ OBS',0),(270430,7512,'es','OBS Total',0),(270431,7512,'de','OBS-Total',0),(270432,7512,'en','OBS Total',0),(270433,7513,'is','',0),(270434,7513,'dr','OBS Ø­Ø¬Ù… Ú¯Ø²Ø§Ø±Ø´-30  Ø³ÙŠ Ø±ÙˆØ²   ',0),(270435,7513,'pr','OBS Ø­Ø¬Ù… Ú¯Ø²Ø§Ø±Ø´-30  Ø³ÙŠ Ø±ÙˆØ²   ',0),(270436,7513,'tr','OBS birimi raporu-30 gÃ¼n',0),(270437,7513,'pl','OBS wielkoÅ›Ä‡ raportu-30 dni',0),(270438,7513,'bg','OBS Ð¾Ð±ÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´-30 Ð´Ð½Ð¸',0),(270439,7513,'ur','Ø§ÙˆØ¨Ø³ ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹-30 Ø¯Ù†',0),(270440,7513,'sr','ÐžÐ‘Ð¡ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜-30 Ð´Ð°Ð½Ð°',0),(270441,7513,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng OBS - 30 ngÃ y',0),(270442,7513,'af','\"OBS\" Volume Verslag-30 dae',0),(270443,7513,'ro','OBS volumul raport-30 zile',0),(270444,7513,'et','OBS mahu aruande-30 pÃ¤eva',0),(270445,7513,'si','OBS obseg poroÄila-30 dni',0),(270446,7513,'ba','OBS Volume laporan-30 hari',0),(270447,7513,'nl','OBS Volume verslag-30 dagen',0),(270448,7513,'fi','OBS mÃ¤Ã¤rÃ¤ raportti-30 pÃ¤ivÃ¤Ã¤',0),(270449,7513,'no','OBS volum rapport-30 dager',0),(270450,7513,'da','OBS volumen rapport-30 dage',0),(270451,7513,'ko','OBS ë³¼ë¥¨ ë³´ê³ ì„œ-30 ì¼',0),(270452,7513,'he','OBS ×›×¨×š ×—-30 ×™×ž×™×',0),(270453,7513,'el','OBS ÏŒÎ³ÎºÎ¿ Î­ÎºÎ¸ÎµÏƒÎ·-30 Î·Î¼Î­ÏÎµÏ‚',0),(270454,7513,'zh','å¼€æ”¾å¼ä¿ç¨Žä»“é‡ç”³æŠ¥-30å¤©\r\n',0),(270455,7513,'sv','OBS volym rapport-30 dagar',0),(270456,7513,'it','OBS Volume relazione-30 giorni',0),(270457,7513,'tl','',0),(270458,7513,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; OBS 30&#3623;&#3633;&#3609;',0),(270459,7513,'hi','OBS à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ-30 à¤¦à¤¿à¤¨',0),(270460,7513,'ms','OBS jilid laporan-30 hari',0),(270461,7513,'ar','OBS Ø­Ø¬Ù… Ø§Ù„ØªÙ‚Ø±ÙŠØ±-30 ÙŠÙˆÙ…Ø§',0),(270462,7513,'fr','OBS, rapport Volume-30 jours',0),(270463,7513,'jp','OBS ãƒœãƒªãƒ¥ãƒ¼ãƒ  ãƒ¬ãƒãƒ¼ãƒˆ-30 æ—¥',0),(270464,7513,'pt','RelatÃ³rio de Volume de OBS-30 dias',0),(270465,7513,'ru','OBS Ð¾Ð±ÑŠÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð°-30 Ð´Ð½ÐµÐ¹',0),(270466,7513,'es','Informe de OBS de VolÃºmen-30 dÃ­as',0),(270467,7513,'de','OBS Band Bericht-30 Tage',0),(270468,7513,'en','OBS Volume Report-30 days',0),(270469,7514,'is','',0),(270470,7514,'dr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ù‡ Ù…Ø§Ù‡ ',0),(270471,7514,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ù‡ Ù…Ø§Ù‡ ',0),(270472,7514,'tr','Qtr iÃ§in hiÃ§ bir etkinlik',0),(270473,7514,'pl','Brak aktywnoÅ›ci dla Qtr',0),(270474,7514,'bg','ÐÑÐ¼Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° Ð¶Ðº',0),(270475,7514,'ur','Ú©ÙˆØ¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ø±Ø¨Ø¹',0),(270476,7514,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð°. ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(270477,7514,'vi','KhÃ´ng hoáº¡t Ä‘á»™ng cho quÃ½',0),(270478,7514,'af','Geen Aktiwiteit vir Kwartaal',0),(270479,7514,'ro','Nici o activitate pentru mada',0),(270480,7514,'et','Kvartali jooksul tegevusi pole',0),(270481,7514,'si','No dejavnost za Äetrtletje natisnemo',0),(270482,7514,'ba','Tidak ada kegiatan untuk Qtr',0),(270483,7514,'nl','Geen enkele activiteit plaatsvindt kW',0),(270484,7514,'fi','Ei aktiviteetteja. neljÃ¤nnes',0),(270485,7514,'no','Ingen aktivitet for kvartal',0),(270486,7514,'da','Ingen aktivitet for Qtr',0),(270487,7514,'ko','Qtr í™œë™ì´ ì—†ìŠµë‹ˆë‹¤',0),(270488,7514,'he','××™×Ÿ ×¤×¢×™×œ×•×ª ×¢×‘×•×¨ ×ž×ª×—×',0),(270489,7514,'el','ÎšÎ±Î¼Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î³Î¹Î± Qtr',0),(270490,7514,'zh','æ²¡æœ‰å­£æ´»åŠ¨\r\n',0),(270491,7514,'sv','Ingen aktivitet fÃ¶r kv',0),(270492,7514,'it','Nessuna attivitÃ  per Qtr',0),(270493,7514,'tl','',0),(270494,7514,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;',0),(270495,7514,'hi','Qtr à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(270496,7514,'ms','Tiada aktiviti untuk 1st Qtr',0),(270497,7514,'ar','Ù„Ø§ Ù†Ø´Ø§Ø· Ù„Ù„Ø±Ø¨Ø¹',0),(270498,7514,'fr','Aucune activitÃ© de Qtr',0),(270499,7514,'jp','å››åŠæœŸã®ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(270500,7514,'pt','Nenhuma atividade para Qtr',0),(270501,7514,'ru','ÐÐµÑ‚ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð»Ñ ÐºÐ²',0),(270502,7514,'es','No Hay Actividad para el Trimentre',0),(270503,7514,'de','Keine Ereignisse fÃ¼r Qtr',0),(270504,7514,'en','No Activity for Qtr',0),(270505,7515,'is','',0),(270506,7515,'dr','OBS Ø­Ø¬Ù… Ú¯Ø²Ø§Ø±Ø´',0),(270507,7515,'pr','OBS Ø­Ø¬Ù… Ú¯Ø²Ø§Ø±Ø´',0),(270508,7515,'tr','OBS birimi raporu',0),(270509,7515,'pl','OBS wielkoÅ›Ä‡ raportu',0),(270510,7515,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° OBS',0),(270511,7515,'ur','Ø§ÙˆØ¨Ø³ ØµÙˆØª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(270512,7515,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸ ÐžÐ‘Ð¡',0),(270513,7515,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng OBS',0),(270514,7515,'af','\"OBS\" Volume Verslag',0),(270515,7515,'ro','Raport de volum OBS',0),(270516,7515,'et','OBS mahu aruande',0),(270517,7515,'si','PoroÄilo obsega OBS',0),(270518,7515,'ba','OBS Volume laporan',0),(270519,7515,'nl','OBS Volume verslag',0),(270520,7515,'fi','OBS mÃ¤Ã¤rÃ¤-raportin',0),(270521,7515,'no','OBS volum rapport',0),(270522,7515,'da','OBS volumen rapport',0),(270523,7515,'ko','OBS ë³¼ë¥¨ ë³´ê³ ì„œ',0),(270524,7515,'he','OBS ×›×¨×š ×—',0),(270525,7515,'el','OBS Î¿ ÏŒÎ³ÎºÎ¿Ï‚ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ·',0),(270526,7515,'zh','å¼€æ”¾å¼ä¿ç¨Žä»“é‡ç”³æŠ¥è¡¨\r\n',0),(270527,7515,'sv','OBS volym rapport',0),(270528,7515,'it','Relazione Volume OBS',0),(270529,7515,'tl','',0),(270530,7515,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; OBS ',0),(270531,7515,'hi','OBS à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(270532,7515,'ms','Laporan jumlah OBS',0),(270533,7515,'ar','ØªÙ‚Ø±ÙŠØ± Ø­Ø¬Ù… OBS',0),(270534,7515,'fr','Rapport Volume OBS',0),(270535,7515,'jp','OBS åœŸé‡ãƒ¬ãƒãƒ¼ãƒˆ',0),(270536,7515,'pt','RelatÃ³rio de Volume OBS',0),(270537,7515,'ru','OBS Ð¾Ð±ÑŠÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð°',0),(270538,7515,'es','Informe de OBS de VolÃºmen',0),(270539,7515,'de','OBS-Volume-Bericht',0),(270540,7515,'en','OBS Volume Report',0),(270541,7516,'is','',0),(270542,7516,'dr','OBS Ø­Ø¬Ù… Ú¯Ø²Ø§Ø±Ø´- Ù†ÙˆØ¯ Ø±ÙˆØ²     ',0),(270543,7516,'pr','OBS Ø­Ø¬Ù… Ú¯Ø²Ø§Ø±Ø´- Ù†ÙˆØ¯ Ø±ÙˆØ²     ',0),(270544,7516,'tr','OBS birimi raporu-90 gÃ¼n',0),(270545,7516,'pl','OBS wielkoÅ›Ä‡ raportu-90 dni',0),(270546,7516,'bg','OBS Ð¾Ð±ÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´-90 Ð´Ð½Ð¸',0),(270547,7516,'ur','Ø§ÙˆØ¨Ø³ ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹-90 Ø¯Ù†',0),(270548,7516,'sr','ÐžÐ‘Ð¡ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜-90 Ð´Ð°Ð½Ð°',0),(270549,7516,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng OBS - 90 ngÃ y',0),(270550,7516,'af','\"OBS\" Volume Verslag-90 dae',0),(270551,7516,'ro','OBS volumul raport-90 de zile',0),(270552,7516,'et','OBS mahu aruande-90 pÃ¤eva',0),(270553,7516,'si','OBS obseg poroÄila-90 dni',0),(270554,7516,'ba','OBS Volume laporan-90 hari',0),(270555,7516,'nl','OBS Volume verslag-90 dagen',0),(270556,7516,'fi','OBS mÃ¤Ã¤rÃ¤ raportti-90 pÃ¤ivÃ¤Ã¤',0),(270557,7516,'no','OBS volum rapport-90 dager',0),(270558,7516,'da','OBS volumen rapport-90 dage',0),(270559,7516,'ko','OBS ë³¼ë¥¨ ë³´ê³ ì„œ-90 ì¼',0),(270560,7516,'he','OBS ×›×¨×š ×—-90 ×™×ž×™×',0),(270561,7516,'el','OBS ÏŒÎ³ÎºÎ¿ Î­ÎºÎ¸ÎµÏƒÎ·-90 Î·Î¼Î­ÏÎµÏ‚',0),(270562,7516,'zh','ç¬¬ä¸€å­£åº¦å¼€æ”¾å¼ä¿ç¨Žä»“é‡æŠ¥å‘Š\r\n',0),(270563,7516,'sv','OBS volym rapport-90 dagar',0),(270564,7516,'it','OBS Volume relazione-90 giorni',0),(270565,7516,'tl','',0),(270566,7516,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; OBS 90&#3623;&#3633;&#3609;',0),(270567,7516,'hi','OBS à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ-90 à¤¦à¤¿à¤¨',0),(270568,7516,'ms','OBS jilid laporan-90 hari',0),(270569,7516,'ar','OBS Ø­Ø¬Ù… Ø§Ù„ØªÙ‚Ø±ÙŠØ±-90 ÙŠÙˆÙ…Ø§',0),(270570,7516,'fr','OBS, rapport Volume-90 jours',0),(270571,7516,'jp','OBS ãƒœãƒªãƒ¥ãƒ¼ãƒ  ãƒ¬ãƒãƒ¼ãƒˆ-90 æ—¥',0),(270572,7516,'pt','RelatÃ³rio de Volume de OBS-90 dias',0),(270573,7516,'ru','OBS Ð¾Ð±ÑŠÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð°-90 Ð´Ð½ÐµÐ¹',0),(270574,7516,'es','Informe de OBS de VolÃºmen-90 dÃ­as',0),(270575,7516,'de','OBS Band Bericht-90 Tage',0),(270576,7516,'en','OBS Volume Report-90 days',0),(270577,7517,'is','',0),(270578,7517,'dr','Ø´Ø±ÙˆØ¹ Ø³Ù‡ Ù…Ø§Ù‡ ',0),(270579,7517,'pr','Ø´Ø±ÙˆØ¹ Ø³Ù‡ Ù…Ø§Ù‡ ',0),(270580,7517,'tr','Ã‡eyrek Begin',0),(270581,7517,'pl','PoczÄ…tek kwartaÅ‚u',0),(270582,7517,'bg','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð» ÐÐ°Ñ‡Ð°Ð»Ð¾',0),(270583,7517,'ur','Ø³Û Ù…Ø§ÛÛŒ Ø´Ø±ÙˆØ¹',0),(270584,7517,'sr','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð» Ð‘ÐµÐ³Ð¸Ð½',0),(270585,7517,'vi','Báº¯t Ä‘áº§u quÃ½',0),(270586,7517,'af','Kwartaal Begin',0),(270587,7517,'ro','Inceput de trimestru',0),(270588,7517,'et','Kvartali algus',0),(270589,7517,'si','ÄŒetrtletju Begin',0),(270590,7517,'ba','Mulailah Quarter',0),(270591,7517,'nl','Kwartaal Begin',0),(270592,7517,'fi','NeljÃ¤nneksellÃ¤ alkaa',0),(270593,7517,'no','Kvartal begynner',0),(270594,7517,'da','Kvartal Begin',0),(270595,7517,'ko','ë¶„ê¸° ì‹œìž‘',0),(270596,7517,'he','×‘×’×™×Ÿ ×”×¨×‘×¢×•×Ÿ',0),(270597,7517,'el','Î¤ÏÎ¯Î¼Î·Î½Î¿ Begin',0),(270598,7517,'zh','å­£å¼€å§‹\r\n',0),(270599,7517,'sv','Kvartalet bÃ¶rja',0),(270600,7517,'it','Trimestre Begin',0),(270601,7517,'tl','',0),(270602,7517,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;',0),(270603,7517,'hi','à¤¤à¤¿à¤®à¤¾à¤¹à¥€ à¤•à¥‡ à¤¶à¥à¤°à¥‚',0),(270604,7517,'ms','Mulakan suku',0),(270605,7517,'ar','Ø¨Ø¯Ø¡ Ø§Ù„Ø±Ø¨Ø¹',0),(270606,7517,'fr','Trimestre Begin',0),(270607,7517,'jp','å››åˆ†ã®ä¸€ã®é–‹å§‹',0),(270608,7517,'pt','Trimestre Begin',0),(270609,7517,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ñ‡ÐµÑ‚Ð²ÐµÑ€Ñ‚Ð¸',0),(270610,7517,'es','Comienza el Trimestre',0),(270611,7517,'de','Quartal beginnen',0),(270612,7517,'en','Quarter Begin',0),(270613,7518,'is','',0),(270614,7518,'dr','OBS Ø­Ø¬Ù… Ú¯Ø²Ø§Ø±Ø´-7Ù‡ÙØª Ø±ÙˆØ²   ',0),(270615,7518,'pr','OBS Ø­Ø¬Ù… Ú¯Ø²Ø§Ø±Ø´-7Ù‡ÙØª Ø±ÙˆØ²   ',0),(270616,7518,'tr','OBS birimi raporu-7 gÃ¼n',0),(270617,7518,'pl','OBS wielkoÅ›Ä‡ raportu-7 dni',0),(270618,7518,'bg','OBS Ð¾Ð±ÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´-7 Ð´Ð½Ð¸',0),(270619,7518,'ur','Ø§ÙˆØ¨Ø³ ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹-7 Ø¯Ù†ÙˆÚº',0),(270620,7518,'sr','ÐžÐ‘Ð¡ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜-7 Ð´Ð°Ð½Ð°',0),(270621,7518,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng OBS - 7 ngÃ y',0),(270622,7518,'af','\"OBS\" Volume Verslag-7 dae',0),(270623,7518,'ro','OBS volumul raport-7 zile',0),(270624,7518,'et','OBS mahu aruande-7 pÃ¤eva',0),(270625,7518,'si','OBS obseg poroÄila-7 dni',0),(270626,7518,'ba','OBS Volume laporan-7 hari',0),(270627,7518,'nl','OBS Volume verslag-7 dagen',0),(270628,7518,'fi','OBS mÃ¤Ã¤rÃ¤ raportti-7 pÃ¤ivÃ¤Ã¤',0),(270629,7518,'no','OBS volum rapport-7 dager',0),(270630,7518,'da','OBS bind rapport-7 dage',0),(270631,7518,'ko','OBS ë³¼ë¥¨ ë³´ê³ ì„œ-7 ì¼',0),(270632,7518,'he','OBS ×›×¨×š ×—-7 ×™×ž×™×',0),(270633,7518,'el','OBS ÏŒÎ³ÎºÎ¿ Î­ÎºÎ¸ÎµÏƒÎ·-7 Î·Î¼Î­ÏÎµÏ‚',0),(270634,7518,'zh','å¼€æ”¾å¼ä¿ç¨Žä»“é‡ç”³æŠ¥- 7å¤©\r\n',0),(270635,7518,'sv','OBS volym rapport-7 dagar',0),(270636,7518,'it','OBS Volume Report-7 giorni',0),(270637,7518,'tl','',0),(270638,7518,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; OBS 7&#3623;&#3633;&#3609;',0),(270639,7518,'hi','OBS à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ-7 à¤¦à¤¿à¤¨',0),(270640,7518,'ms','OBS jilid laporan-7 hari',0),(270641,7518,'ar','OBS Ø­Ø¬Ù… Ø§Ù„ØªÙ‚Ø±ÙŠØ±-7 Ø£ÙŠØ§Ù…',0),(270642,7518,'fr','OBS, rapport Volume-7 jours',0),(270643,7518,'jp','OBS ãƒœãƒªãƒ¥ãƒ¼ãƒ  ãƒ¬ãƒãƒ¼ãƒˆ-7 æ—¥',0),(270644,7518,'pt','RelatÃ³rio de Volume de OBS-7 dias',0),(270645,7518,'ru','OBS Ð¾Ð±ÑŠÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð°-7 Ð´Ð½ÐµÐ¹',0),(270646,7518,'es','Informe de OBS de VolÃºmen-7 dÃ­as',0),(270647,7518,'de','OBS Band Bericht-7 Tage',0),(270648,7518,'en','OBS Volume Report-7 days',0),(270649,7519,'is','',0),(270650,7519,'dr','OBS Ø­Ø¬Ù… Ú¯Ø²Ø§Ø±Ø´-1ÙŠÙƒ Ø³Ø§Ù„    ',0),(270651,7519,'pr','OBS Ø­Ø¬Ù… Ú¯Ø²Ø§Ø±Ø´-1ÙŠÙƒ Ø³Ø§Ù„    ',0),(270652,7519,'tr','OBS cilt rapor-1 yÄ±l',0),(270653,7519,'pl','OBS Tom raport-1 rok',0),(270654,7519,'bg','OBS Ð¢Ð¾Ð¼ Ð´Ð¾ÐºÐ»Ð°Ð´-1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(270655,7519,'ur','Ø§ÙˆØ¨Ø³ ØµÙˆØª Ø±Ù¾ÙˆØ±Ù¹-1 Ø³Ø§Ù„',0),(270656,7519,'sr','ÐžÐ‘Ð¡ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜-1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(270657,7519,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng OBS - 1 nÄƒm',0),(270658,7519,'af','\"OBS\" Volume Verslag-1 Year',0),(270659,7519,'ro','OBS volumul raport-1 an',0),(270660,7519,'et','OBS mahu aruande-1 aasta',0),(270661,7519,'si','OBS obseg poroÄila-1 leto',0),(270662,7519,'ba','OBS Volume laporan-1 tahun',0),(270663,7519,'nl','OBS Volume rapport-1 jaar',0),(270664,7519,'fi','OBS osa raportti-1 vuosi',0),(270665,7519,'no','OBS Volume rapport-1 Ã¥r',0),(270666,7519,'da','OBS bind rapport-1 Ã¥r',0),(270667,7519,'ko','OBS ë³¼ë¥¨ ë³´ê³ ì„œ-1 ë…„',0),(270668,7519,'he','OBS ×›×¨×š ×—-1 ×©× ×”',0),(270669,7519,'el','OBS Ï„ÏŒÎ¼Î¿Ï‚ Î­ÎºÎ¸ÎµÏƒÎ·-1 Î­Ï„Î¿Ï‚',0),(270670,7519,'zh','å¼€æ”¾å¼ä¿ç¨Žä»“é‡ç”³æŠ¥-1å¹´\r\n',0),(270671,7519,'sv','OBS volym rapport-1 Ã¥r',0),(270672,7519,'it','OBS Volume relazione-1 anno',0),(270673,7519,'tl','',0),(270674,7519,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; OBS 1&#3611;&#3637;',0),(270675,7519,'hi','OBS à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ-1 à¤¸à¤¾à¤²',0),(270676,7519,'ms','OBS jilid laporan-1 tahun',0),(270677,7519,'ar','OBS Ø§Ù„Ù…Ø¬Ù„Ø¯ 1 ØªÙ‚Ø±ÙŠØ± Ø¹Ø§Ù…',0),(270678,7519,'fr','OBS Volume rapport-1 an',0),(270679,7519,'jp','OBS ãƒœãƒªãƒ¥ãƒ¼ãƒ  ãƒ¬ãƒãƒ¼ãƒˆ 1 å¹´',0),(270680,7519,'pt','OBS Volume relatÃ³rio-1 ano',0),(270681,7519,'ru','OBS Ð¾Ð±ÑŠÐµÐ¼ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°-1 Ð³Ð¾Ð´',0),(270682,7519,'es','Informe de OBS de VolÃºmen-1 aÃ±o',0),(270683,7519,'de','OBS Volume Bericht-1 Jahr',0),(270684,7519,'en','OBS Volume Report-1 Year',0),(270685,7520,'is','',0),(270686,7520,'dr','(Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¯Ø±  Ø³Ø§Ù„',0),(270687,7520,'pr','Ú†Ø§Ù¾ Ù¾Ù†Ø¬Ø§Ù‡  ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† (Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¯Ø±  Ø³Ø§Ù„',0),(270688,7520,'tr','Top 50 yÄ±llÄ±k baskÄ± mÃ¼ÅŸteriler',0),(270689,7520,'pl','Top 50 drukowania klientÃ³w rocznie',0),(270690,7520,'bg','Ð¢Ð¾Ð¿ 50 Ð¿ÐµÑ‡Ð°Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¾',0),(270691,7520,'ur','ÛØ± Ø³Ø§Ù„ 50 Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø§ÙˆÙ¾Ø±',0),(270692,7520,'sr','50 Ð½Ð°Ñ˜Ð±Ð¾Ñ™Ð¸Ñ… ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ° ÐºÑƒÐ¿Ñ†Ðµ Ð³Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(270693,7520,'vi','MÆ°á»i khÃ¡ch hÃ ng in cao nháº¥t má»—i nÄƒm',0),(270694,7520,'af','Top 50 Druk Klante/KliÃ«nte per Jaar',0),(270695,7520,'ro','Top 50 clienÅ£ii imprimare pe an',0),(270696,7520,'et','Top 50 Print kÃ¼lastajad aastas',0),(270697,7520,'si','Top 50 Print kupci na leto',0),(270698,7520,'ba','Top 50 cetak pelanggan per tahun',0),(270699,7520,'nl','Top 50 afdrukken klanten per jaar',0),(270700,7520,'fi','Top 50 tulosta asiakkaat vuodessa',0),(270701,7520,'no','Topp 50 Print kunder per Ã¥r',0),(270702,7520,'da','Top 50 Print kunder om Ã¥ret',0),(270703,7520,'ko','ë…„ ë‹¹ ìƒìœ„ 50 ê°œ ì¸ì‡„ ê³ ê°',0),(270704,7520,'he','Top 50 ×œ×§×•×—×•×ª ×”×“×¤×¡×” ×œ×©× ×”',0),(270705,7520,'el','Top 50 ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÎµÏ„Î·ÏƒÎ¯Ï‰Ï‚',0),(270706,7520,'zh','æ¯å¹´æŽ’åå‰50ä½æ‰“å°çš„å®¢æˆ·',0),(270707,7520,'sv','Topp 50 ut kunder per Ã¥r',0),(270708,7520,'it','Clienti stampa Top 50 all\'anno',0),(270709,7520,'tl','',0),(270710,7520,'th','&#3614;&#3636;&#3617;&#3614;&#3660; 50 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;/&#3611;&#3637;',0),(270711,7520,'hi','à¤¶à¥€à¤°à¥à¤· 50 à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤·',0),(270712,7520,'ms','Top 50 cetakan pelanggan setiap tahun',0),(270713,7520,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø·Ø¨Ø§Ø¹Ø© Ø£Ø¹Ù„Ù‰ 50 ÙÙŠ Ø§Ù„Ø³Ù†Ø©',0),(270714,7520,'fr','Clients impression Top 50 par annÃ©e',0),(270715,7520,'jp','ãƒˆãƒƒãƒ— 50 å¹´é–“å°åˆ·ã€é¡§å®¢',0),(270716,7520,'pt','Top 50 clientes impressÃ£o por ano',0),(270717,7520,'ru','Ð¢Ð¾Ð¿ 50 ÐŸÐµÑ‡Ð°Ñ‚Ð¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð·Ð° Ð“Ð¾Ð´',0),(270718,7520,'es','Los 50 Clientes Principales de ImpresiÃ³n por AÃ±o',0),(270719,7520,'de','Top 50-Print-Kunden pro Jahr',0),(270720,7520,'en','Top 50 Print Customers per Year',0),(270721,7521,'is','',0),(270722,7521,'dr','OBS',0),(270723,7521,'pr','Ú¯Ø²Ø§Ø±Ø´ â€“ Ø³ÙŠ Ø±ÙˆØ²     OBS\r\n',0),(270724,7521,'tr','OBS raporu-30 gÃ¼n',0),(270725,7521,'pl','OBS raport-30 dni',0),(270726,7521,'bg','OBS Ð´Ð¾ÐºÐ»Ð°Ð´-30 Ð´Ð½Ð¸',0),(270727,7521,'ur','Ø§ÙˆØ¨Ø³ Ø±Ù¾ÙˆØ±Ù¹-30 Ø¯Ù†',0),(270728,7521,'sr','ÐžÐ‘Ð¡ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜-30 Ð´Ð°Ð½Ð°',0),(270729,7521,'vi','BÃ¡o cÃ¡o OBS - 30 ngÃ y',0),(270730,7521,'af','\"OBS\" Verslag-30 dae',0),(270731,7521,'ro','OBS raport-30 zile',0),(270732,7521,'et','OBS aruanne-30 pÃ¤eva',0),(270733,7521,'si','OBS poroÄilo-30 dni',0),(270734,7521,'ba','OBS laporan-30 hari',0),(270735,7521,'nl','OBS verslag-30 dagen',0),(270736,7521,'fi','OBS raportti-30 pÃ¤ivÃ¤Ã¤',0),(270737,7521,'no','OBS rapport-30 dager',0),(270738,7521,'da','OBS rapport-30 dage',0),(270739,7521,'ko','OBS ë³´ê³ ì„œ-30 ì¼',0),(270740,7521,'he','×“×•×— OBS-30 ×™×ž×™×',0),(270741,7521,'el','OBS Î­ÎºÎ¸ÎµÏƒÎ·-30 Î·Î¼Î­ÏÎµÏ‚',0),(270742,7521,'zh','å°±ä¸šæŠ¥å‘Šï¼Œä¸‰åå¤©\r\n',0),(270743,7521,'sv','OBS rapport-30 dagar',0),(270744,7521,'it','OBS Report-30 giorni',0),(270745,7521,'tl','',0),(270746,7521,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; OBS &#3616;&#3634;&#3618;&#3651;&#3609; 30 &#3623;&#3633;&#3609;',0),(270747,7521,'hi','OBS à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ-30 à¤¦à¤¿à¤¨',0),(270748,7521,'ms','OBS laporan-30 hari',0),(270749,7521,'ar','ØªÙ‚Ø±ÙŠØ± OBS-30 ÙŠÙˆÙ…Ø§',0),(270750,7521,'fr','OBS rapport-30 jours',0),(270751,7521,'jp','OBS ãƒ¬ãƒãƒ¼ãƒˆ-30 æ—¥',0),(270752,7521,'pt','OBS. o relatÃ³rio-30 dias',0),(270753,7521,'ru','OBS Ð´Ð¾ÐºÐ»Ð°Ð´-30 Ð´Ð½ÐµÐ¹',0),(270754,7521,'es','Informe de OBS-30 dÃ­as',0),(270755,7521,'de','OBS Bericht-30 Tage',0),(270756,7521,'en','OBS Report-30 days',0),(270757,7522,'is','',0),(270758,7522,'dr','OBS Ú¯Ø²Ø§Ø±Ø´ â€“ Ù†ÙˆØ¯ Ø±ÙˆØ²   ',0),(270759,7522,'pr','OBS Ú¯Ø²Ø§Ø±Ø´ â€“ Ù†ÙˆØ¯ Ø±ÙˆØ²   ',0),(270760,7522,'tr','OBS raporu-90 gÃ¼n',0),(270761,7522,'pl','OBS raport-90 dni',0),(270762,7522,'bg','OBS Ð´Ð¾ÐºÐ»Ð°Ð´-90 Ð´Ð½Ð¸',0),(270763,7522,'ur','Ø§ÙˆØ¨Ø³ Ø±Ù¾ÙˆØ±Ù¹-90 Ø¯Ù†',0),(270764,7522,'sr','ÐžÐ‘Ð¡ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜-90 Ð´Ð°Ð½Ð°',0),(270765,7522,'vi','BÃ¡o cÃ¡o OBS - 90 ngÃ y',0),(270766,7522,'af','\"OBS\" Verslag-90 dae',0),(270767,7522,'ro','OBS raport-90 de zile',0),(270768,7522,'et','OBS aruanne-90 pÃ¤eva',0),(270769,7522,'si','OBS poroÄilo-90 dni',0),(270770,7522,'ba','OBS laporan-90 hari',0),(270771,7522,'nl','OBS verslag-90 dagen',0),(270772,7522,'fi','OBS raportti-90 pÃ¤ivÃ¤Ã¤',0),(270773,7522,'no','OBS rapport-90 dager',0),(270774,7522,'da','OBS rapport-90 dage',0),(270775,7522,'ko','OBS ë³´ê³ ì„œ-90 ì¼',0),(270776,7522,'he','×“×•×— OBS-90 ×™×ž×™×',0),(270777,7522,'el','OBS Î­ÎºÎ¸ÎµÏƒÎ·-90 Î·Î¼Î­ÏÎµÏ‚',0),(270778,7522,'zh','å°±ä¸šæŠ¥å‘Šï¼Œ90å¤©\r\n',0),(270779,7522,'sv','OBS rapport-90 dagar',0),(270780,7522,'it','OBS Report-90 giorni',0),(270781,7522,'tl','',0),(270782,7522,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; OBS &#3616;&#3634;&#3618;&#3651;&#3609; 90 &#3623;&#3633;&#3609;',0),(270783,7522,'hi','OBS à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ-90 à¤¦à¤¿à¤¨',0),(270784,7522,'ms','OBS laporan-90 hari',0),(270785,7522,'ar','ØªÙ‚Ø±ÙŠØ± OBS-90 ÙŠÙˆÙ…Ø§',0),(270786,7522,'fr','OBS rapport-90 jours',0),(270787,7522,'jp','OBS ãƒ¬ãƒãƒ¼ãƒˆ-90 æ—¥',0),(270788,7522,'pt','OBS. o relatÃ³rio-90 dias',0),(270789,7522,'ru','OBS Ð´Ð¾ÐºÐ»Ð°Ð´-90 Ð´Ð½ÐµÐ¹',0),(270790,7522,'es','Informe de OBS-90 dÃ­as',0),(270791,7522,'de','OBS Bericht-90 Tage',0),(270792,7522,'en','OBS Report-90 days',0),(270793,7523,'is','',0),(270794,7523,'dr','OBS Ú¯Ø²Ø§Ø±Ø´ â€“ Ù‡ÙØª Ø±ÙˆØ² ',0),(270795,7523,'pr','OBS Ú¯Ø²Ø§Ø±Ø´ â€“ Ù‡ÙØª Ø±ÙˆØ² ',0),(270796,7523,'tr','OBS raporu-7 gÃ¼n',0),(270797,7523,'pl','OBS raport-7 dni',0),(270798,7523,'bg','OBS Ð´Ð¾ÐºÐ»Ð°Ð´-7 Ð´Ð½Ð¸',0),(270799,7523,'ur','Ø§ÙˆØ¨Ø³ Ø±Ù¾ÙˆØ±Ù¹-7 Ø¯Ù†ÙˆÚº',0),(270800,7523,'sr','ÐžÐ‘Ð¡ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜-7 Ð´Ð°Ð½Ð°',0),(270801,7523,'vi','BÃ¡o cÃ¡o OBS - 7 ngÃ y',0),(270802,7523,'af','\"OBS\" Verslag-7 dae',0),(270803,7523,'ro','OBS raport-7 zile',0),(270804,7523,'et','OBS aruanne-7 pÃ¤eva',0),(270805,7523,'si','OBS poroÄilo-7 dni',0),(270806,7523,'ba','OBS laporan-7 hari',0),(270807,7523,'nl','OBS verslag-7 dagen',0),(270808,7523,'fi','OBS raportti-7 pÃ¤ivÃ¤Ã¤',0),(270809,7523,'no','OBS rapport-7 dager',0),(270810,7523,'da','OBS rapport-7 dage',0),(270811,7523,'ko','OBS ë³´ê³ ì„œ-7 ì¼',0),(270812,7523,'he','×“×•×— OBS-7 ×™×ž×™×',0),(270813,7523,'el','OBS Î­ÎºÎ¸ÎµÏƒÎ·-7 Î·Î¼Î­ÏÎµÏ‚',0),(270814,7523,'zh','å°±ä¸šæŠ¥å‘Š- 7å¤©\r\n',0),(270815,7523,'sv','OBS rapport-7 dagar',0),(270816,7523,'it','OBS Report-7 giorni',0),(270817,7523,'tl','',0),(270818,7523,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; OBS &#3616;&#3634;&#3618;&#3651;&#3609; 7 &#3623;&#3633;&#3609;',0),(270819,7523,'hi','OBS à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ-7 à¤¦à¤¿à¤¨',0),(270820,7523,'ms','OBS laporan-7 hari',0),(270821,7523,'ar','OBS Ø§Ù„ØªÙ‚Ø±ÙŠØ±-7 Ø£ÙŠØ§Ù…',0),(270822,7523,'fr','Rapport de l\'OBS-7 jours',0),(270823,7523,'jp','OBS ãƒ¬ãƒãƒ¼ãƒˆ-7 æ—¥',0),(270824,7523,'pt','OBS. o relatÃ³rio-7 dias',0),(270825,7523,'ru','OBS Ð´Ð¾ÐºÐ»Ð°Ð´-7 Ð´Ð½ÐµÐ¹',0),(270826,7523,'es','Informe de OBS-7 dÃ­as',0),(270827,7523,'de','OBS Bericht-7 Tage',0),(270828,7523,'en','OBS Report-7 days',0),(270829,7524,'is','',0),(270830,7524,'dr','OBS Ú¯Ø²Ø§Ø±Ø´ â€“ ÙŠÙƒ Ø³Ø§Ù„ ',0),(270831,7524,'pr','OBS Ú¯Ø²Ø§Ø±Ø´ â€“ ÙŠÙƒ Ø³Ø§Ù„ ',0),(270832,7524,'tr','OBS rapor-1 yÄ±l',0),(270833,7524,'pl','OBS raport-1 rok',0),(270834,7524,'bg','OBS Ð´Ð¾ÐºÐ»Ð°Ð´-1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(270835,7524,'ur','Ø§ÙˆØ¨Ø³ Ø±Ù¾ÙˆØ±Ù¹-1 Ø³Ø§Ù„',0),(270836,7524,'sr','ÐžÐ‘Ð¡ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜-1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(270837,7524,'vi','BÃ¡o cÃ¡o OBS - 1 nÄƒm',0),(270838,7524,'af','\"OBS\" Verslag-1 Jaar',0),(270839,7524,'ro','OBS raport-1 an',0),(270840,7524,'et','OBS aruanne-1 aasta',0),(270841,7524,'si','OBS poroÄilo-1 leto',0),(270842,7524,'ba','OBS laporan-1 tahun',0),(270843,7524,'nl','OBS rapport-1 jaar',0),(270844,7524,'fi','OBS raportti-1 vuosi',0),(270845,7524,'no','OBS rapport-1 Ã¥r',0),(270846,7524,'da','OBS rapport-1 Ã¥r',0),(270847,7524,'ko','OBS ë³´ê³ ì„œ-1 ë…„',0),(270848,7524,'he','OBS ×—-1 ×©× ×”',0),(270849,7524,'el','OBS Î­ÎºÎ¸ÎµÏƒÎ·-1 Î­Ï„Î¿Ï‚',0),(270850,7524,'zh','å°±ä¸šæŠ¥å‘Šï¼Œ1å¹´\r\n',0),(270851,7524,'sv','OBS rapport-1 Ã¥r',0),(270852,7524,'it','OBS Report-1 anno',0),(270853,7524,'tl','',0),(270854,7524,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; OBS &#3616;&#3634;&#3618;&#3651;&#3609; 1 &#3611;&#3637;',0),(270855,7524,'hi','OBS à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ-1 à¤¸à¤¾à¤²',0),(270856,7524,'ms','OBS laporan-1 tahun',0),(270857,7524,'ar','OBS Ø§Ù„ØªÙ‚Ø±ÙŠØ±-1 Ø³Ù†Ø©',0),(270858,7524,'fr','OBS rapport-1 an',0),(270859,7524,'jp','OBS ãƒ¬ãƒãƒ¼ãƒˆ 1 å¹´',0),(270860,7524,'pt','OBS relatÃ³rio-1 ano',0),(270861,7524,'ru','OBS Ð´Ð¾ÐºÐ»Ð°Ð´-1 Ð³Ð¾Ð´',0),(270862,7524,'es','Informe de OBS-1 AÃ±o',0),(270863,7524,'de','OBS Bericht-1 Jahr',0),(270864,7524,'en','OBS Report-1 Year',0),(270865,7525,'is','',0),(270866,7525,'dr','(Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† â€“ Ø³Ø§Ù„',0),(270867,7525,'pr','Ú†Ø§Ù¾ Ù¾Ù†Ø¬Ø§Ù‡  ØªØ§ Ø§Ø² Ø¨Ù‡ØªØ±ÙŠÙ† (Ø¨Ø§Ù„Ø§ØªØ±ÙŠÙ†) Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† â€“ Ø³Ø§Ù„',0),(270868,7525,'tr','Top 50 yazdÄ±rma mÃ¼ÅŸteriler-1 yÄ±l',0),(270869,7525,'pl','Top 50 drukowania klientÃ³w-1 rok',0),(270870,7525,'bg','Ð¢Ð¾Ð¿ 50 Ð¿ÐµÑ‡Ð°Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸-1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(270871,7525,'ur','Ù¹Ø§Ù¾ 50 Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú¯Ø§ÛÚ©ÙˆÚº-1 Ø³Ø§Ù„',0),(270872,7525,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ 50 Ð½Ð°Ñ˜Ð±Ð¾Ñ™Ð¸Ñ… ÐºÑƒÐ¿Ð°Ñ†Ð°-1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(270873,7525,'vi','NÄƒm mÆ°Æ¡i khÃ¡ch hÃ ng in cao nháº¥t - 1 nÄƒm ',0),(270874,7525,'af','Top 50 Druk Klante/KliÃ«nte-1 Jaar',0),(270875,7525,'ro','Top 50 imprimare clienÅ£ii-1 an',0),(270876,7525,'et','Top 50 Print kÃ¼lastajad-1 aasta',0),(270877,7525,'si','Top 50 tiskanja stranke-1 leto',0),(270878,7525,'ba','Top 50 cetak pelanggan-1 tahun',0),(270879,7525,'nl','Top 50 afdrukken klanten-1 jaar',0),(270880,7525,'fi','Top 50 tulosta asiakkaat-1 vuosi',0),(270881,7525,'no','Topp 50 Print kunder-1 Ã¥r',0),(270882,7525,'da','Top 50 Print kunder-1 Ã¥r',0),(270883,7525,'ko','ìƒìœ„ 50 ê°œ ì¸ì‡„ ê³ ê° 1 ë…„',0),(270884,7525,'he','Top 50 ×”×“×¤×¡×” ×”×œ×§×•×—×•×ª-1 ×©× ×”',0),(270885,7525,'el','Top 50 ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚-1 Î­Ï„Î¿Ï‚',0),(270886,7525,'zh','æŽ’åå‰50ä½æ‰“å°çš„å®¢æˆ·ï¼Œ1å¹´\r\n',0),(270887,7525,'sv','Topp 50 ut kunder-1 Ã¥r',0),(270888,7525,'it','Stampa di Top 50 clienti-1 anno',0),(270889,7525,'tl','',0),(270890,7525,'th','&#3614;&#3636;&#3617;&#3614;&#3660; 50 &#3629;&#3633;&#3609;&#3604;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634; - 1&#3611;&#3637;',0),(270891,7525,'hi','à¤¶à¥€à¤°à¥à¤· 50 à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚-1 à¤¸à¤¾à¤²',0),(270892,7525,'ms','Top 50 cetakan pelanggan-1 tahun',0),(270893,7525,'ar','Ø£Ø¹Ù„Ù‰ 50 Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡--1 Ø³Ù†Ø©',0),(270894,7525,'fr','Top 50 impression clients-1 annÃ©e',0),(270895,7525,'jp','ãƒˆãƒƒãƒ— 50 å°åˆ·ãŠå®¢æ§˜ 1 å¹´',0),(270896,7525,'pt','Top 50 impressÃ£o clientes-1 ano',0),(270897,7525,'ru','Ð¢Ð¾Ð¿ 50 ÐŸÐµÑ‡Ð°Ñ‚Ð¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²-1 Ð“Ð¾Ð´',0),(270898,7525,'es','Los 50 Clientes Principales de ImpresiÃ³n-1 AÃ±o',0),(270899,7525,'de','Top 50 Druck Kunden-1 Jahr',0),(270900,7525,'en','Top 50 Print Customers-1 Year',0),(270901,7526,'is','',0),(270902,7526,'dr','Ø¬Ø¯ÙŠØ¯ØªØ±ÙŠÙ† Ø¢Ù…ÙˆØ²Ø´Ù‡Ø§ÙŠ ÙˆÙŠØ¯Ø¦ÙˆÙŠÙŠ ',0),(270903,7526,'pr','Ø¬Ø¯ÙŠØ¯ØªØ±ÙŠÙ† Ø¢Ù…ÙˆØ²Ø´Ù‡Ø§ÙŠ ÙˆÙŠØ¯Ø¦ÙˆÙŠÙŠ ',0),(270904,7526,'tr','En son eÄŸitim videolarÄ±',0),(270905,7526,'pl','Najnowsze filmy szkoleniowe',0),(270906,7526,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ð²Ð¸Ð´ÐµÐ¾ Ð¾Ð±ÑƒÑ‡ÐµÐ½Ð¸Ðµ',0),(270907,7526,'ur','ØªØ§Ø²Û ØªØ±ÛŒÙ† Ù¹Ø±ÛŒÙ†Ù†Ú¯ Ú©ÛŒ ÙˆÛŒÚˆÛŒÙˆØ²',0),(270908,7526,'sr','ÐÐ°Ñ˜Ð½Ð¾Ð²Ð¸Ñ˜Ðµ ÑÐ½Ð¸Ð¼ÐºÐµ Ð¾Ð±ÑƒÐºÐµ',0),(270909,7526,'vi','Video Ä‘Ã o táº¡o gáº§n nháº¥t',0),(270910,7526,'af','Nuutste Opleidingsvideo\'s',0),(270911,7526,'ro','Cele mai recente video de instruire',0),(270912,7526,'et','Viimane koolitus videod',0),(270913,7526,'si','NajnovejÅ¡i video posnetke usposabljanje',0),(270914,7526,'ba','Video pelatihan terbaru',0),(270915,7526,'nl','Laatste Training Video \'s',0),(270916,7526,'fi','Uusimmat Koulutus videot',0),(270917,7526,'no','Siste trening videoer',0),(270918,7526,'da','Seneste uddannelsesvideoer',0),(270919,7526,'ko','ìµœì‹  êµìœ¡ ë™ì˜ìƒ',0),(270920,7526,'he','×¡×¨×˜×•× ×™ ×”×“×¨×›×” ×”××—×¨×•× ×”',0),(270921,7526,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î²Î¯Î½Ï„ÎµÎ¿ ÎºÎ±Ï„Î¬ÏÏ„Î¹ÏƒÎ·Ï‚',0),(270922,7526,'zh','æœ€æ–°çš„è®­ç»ƒè§†é¢‘\r\n',0),(270923,7526,'sv','Senaste utbildning videor',0),(270924,7526,'it','Ultimi video di formazione',0),(270925,7526,'tl','',0),(270926,7526,'th','&#3623;&#3637;&#3604;&#3637;&#3650;&#3629;&#3585;&#3634;&#3619;&#3613;&#3638;&#3585;&#3629;&#3610;&#3619;&#3617;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(270927,7526,'hi','à¤¨à¤µà¥€à¤¨à¤¤à¤® à¤ªà¥à¤°à¤¶à¤¿à¤•à¥à¤·à¤£ à¤µà¥€à¤¡à¤¿à¤¯à¥‹',0),(270928,7526,'ms','Tempahan video latihan',0),(270929,7526,'ar','Ø£Ø­Ø¯Ø« Ø£Ø´Ø±Ø·Ø© ÙÙŠØ¯ÙŠÙˆ Ù„Ù„ØªØ¯Ø±ÙŠØ¨',0),(270930,7526,'fr','Les derniÃ¨res vidÃ©os de formation',0),(270931,7526,'jp','æœ€æ–°ã®ãƒˆãƒ¬ãƒ¼ãƒ‹ãƒ³ã‚° ãƒ“ãƒ‡ã‚ª',0),(270932,7526,'pt','Ãšltimos vÃ­deos de treinamento',0),(270933,7526,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÑƒÑ‡ÐµÐ±Ð½Ñ‹Ðµ Ð²Ð¸Ð´ÐµÐ¾',0),(270934,7526,'es','Videos de Entrenamiento MÃ¡s Recientes',0),(270935,7526,'de','Aktuelle Trainings-Videos',0),(270936,7526,'en','Latest Training Videos',0),(270937,7527,'is','',0),(270938,7527,'dr','ÙÙŠÙ„Ø¯ Ø´Ø±Ø­ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(270939,7527,'pr','ÙÙŠÙ„Ø¯ Ø´Ø±Ø­ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(270940,7527,'tr','Ä°lave AÃ§Ä±klama alanÄ± sipariÅŸ iÃ§in',0),(270941,7527,'pl','Dodatkowy opis pole dla zamÃ³wienia',0),(270942,7527,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¾Ð»Ðµ Ð·Ð° Ñ€ÐµÐ´',0),(270943,7527,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø¶Ø§ÙÛŒ ØªÙØµÛŒÙ„ Ù‚Ø·Ø¹Û',0),(270944,7527,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ð¾Ð¿Ð¸Ñ Ð¿Ð¾Ñ™Ð° Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(270945,7527,'vi','TrÆ°á»ng mÃ´ táº£ thÃªm cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(270946,7527,'af','Bykomende Beskrywingsveld vir Bestelling',0),(270947,7527,'ro','CÃ¢mp Descriere suplimentar pentru comanda',0),(270948,7527,'et','KirjeldusevÃ¤lja eest tellimuse',0),(270949,7527,'si','Dodaten opis polja za nalog',0),(270950,7527,'ba','Keterangan tambahan Lapangan untuk Order',0),(270951,7527,'nl','Extra beschrijvingsveld voor Order',0),(270952,7527,'fi','Kun Kuvaus-kenttÃ¤Ã¤n tilausta',0),(270953,7527,'no','Ekstra beskrivelsesfeltet for ordre',0),(270954,7527,'da','Ekstra beskrivelsesfeltet for ordre',0),(270955,7527,'ko','ì£¼ë¬¸ì— ëŒ€ í•œ ì¶”ê°€ ì„¤ëª… í•„ë“œ',0),(270956,7527,'he','×ª×™××•×¨ × ×•×¡×£ ×©×“×” ×¢×‘×•×¨ ×”×–×ž× ×”',0),(270957,7527,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï€ÎµÎ´Î¯Î¿ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(270958,7527,'zh','é¢å¤–çš„è®¢è´­ä»‹ç»å­—æ®µ\r\n',0),(270959,7527,'sv','Extra beskrivningsfÃ¤ltet fÃ¶r bestÃ¤llning',0),(270960,7527,'it','Campo Descrizione supplementare per ordine',0),(270961,7527,'tl','',0),(270962,7527,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3607;&#3637;&#3656;&#3592;&#3633;&#3604;&#3648;&#3585;&#3655;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3614;&#3636;&#3648;&#3624;&#3625;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3',0),(270963,7527,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤µà¤°à¥à¤£à¤¨ à¤«à¤¼à¥€à¤²à¥à¤¡',0),(270964,7527,'ms','Bidang penerangan tambahan untuk pesanan',0),(270965,7527,'ar','Ø­Ù‚Ù„ ÙˆØµÙ Ø¥Ø¶Ø§ÙÙŠ Ù„Ù„Ù†Ø¸Ø§Ù…',0),(270966,7527,'fr','Champ Description supplÃ©mentaire pour commande',0),(270967,7527,'jp','æ³¨æ–‡ã®è¿½åŠ ã®èª¬æ˜Žãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(270968,7527,'pt','Campo DescriÃ§Ã£o extra para a ordem',0),(270969,7527,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¾Ð»Ðµ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(270970,7527,'es','Extra Campo de DescripciÃ³n para el Orden',0),(270971,7527,'de','ZusÃ¤tzliche Beschreibungsfeld fÃ¼r Bestellung',0),(270972,7527,'en','Extra Description Field for Order',0),(270973,7528,'is','',0),(270974,7528,'dr','(Ù…Ø¬ÙˆØ²) Ø´ØºÙ„',0),(270975,7528,'pr','Ù…ØªÙ† ÙƒÙ†ØªØ±Ù„ ÙƒÙŠÙÙŠØª Ø¨Ø±Ø§ÙŠ Ø¨Ù„ÙŠØ·(Ù…Ø¬ÙˆØ²) Ø´ØºÙ„',0),(270976,7528,'tr','Ä°ÅŸ bileti iÃ§in kalite kontrol metin',0),(270977,7528,'pl','Kontroli jakoÅ›ci tekstu na bilet',0),(270978,7528,'bg','ÐšÐ°Ñ‡ÐµÑÑ‚Ð²ÐµÐ½ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð» Ñ‚ÐµÐºÑÑ‚ Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð±Ð¸Ð»ÐµÑ‚',0),(270979,7528,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù¹Ú©Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ§Ù„Ù¹ÛŒ Ú©Ù†Ù¹Ø±ÙˆÙ„ Ù…ØªÙ†',0),(270980,7528,'sr','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð° ÐºÐ²Ð°Ð»Ð¸Ñ‚ÐµÑ‚Ð° Ñ‚ÐµÐºÑÑ‚ Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾ ÐºÐ°Ñ€Ñ‚Ð°',0),(270981,7528,'vi','Kiá»ƒm tra cháº¥t lÆ°Æ¡ng cá»§a phiáº¿u Job',0),(270982,7528,'af','Kwaliteitskontrole Teks vir Werkstuk Kaarjtie',0),(270983,7528,'ro','Controlul de calitate Text pentru un bilet de Job',0),(270984,7528,'et','Kvaliteedikontrolli teksti tÃ¶Ã¶sedel',0),(270985,7528,'si','Nadzor kakovosti besedilo za vstopnico za zaposlitev',0),(270986,7528,'ba','Kontrol kualitas teks untuk pekerjaan Tiket',0),(270987,7528,'nl','Kwaliteitscontrole tekst voor opdrachtticket',0),(270988,7528,'fi','Laadunvalvonta teksti tyÃ¶lippu',0),(270989,7528,'no','Kvalitetskontroll tekst for jobb billett',0),(270990,7528,'da','Kvalitetskontrol tekst til jobindstilling',0),(270991,7528,'ko','ìž‘ì—… í‹°ì¼“ì— ëŒ€ í•œ í’ˆì§ˆ ê´€ë¦¬ í…ìŠ¤íŠ¸',0),(270992,7528,'he','×‘×§×¨×ª ××™×›×•×ª ×˜×§×¡×˜ ×¢×‘×•×¨ Job Ticket',0),(270993,7528,'el','Î Î¿Î¹Î¿Ï„Î¹ÎºÏŒÏ‚ Î­Î»ÎµÎ³Ï‡Î¿Ï‚ ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î³Î¹Î± Job Ticket',0),(270994,7528,'zh','è´¨é‡æŽ§åˆ¶æ–‡æœ¬ä½œä¸šå•\r\n',0),(270995,7528,'sv','Kvalitetskontroll Text fÃ¶r jobb biljett',0),(270996,7528,'it','Testo di controllo qualitÃ  per Job Ticket',0),(270997,7528,'tl','',0),(270998,7528,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3588;&#3623;&#3610;&#3588;&#3640;&#3617;&#3588;&#3640;&#3603;&#3616;&#3634;&#3614;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3605;&#3633;&#3659;&#3623;&#3591;&#3634;&#3609;',0),(270999,7528,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤Ÿà¤¿à¤•à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤£à¤µà¤¤à¥à¤¤à¤¾ à¤¨à¤¿à¤¯à¤‚à¤¤à¥à¤°à¤£ à¤ªà¤¾à¤ ',0),(271000,7528,'ms','Kawalan kualiti teks untuk Tiket kerja',0),(271001,7528,'ar','Ù…Ø±Ø§Ù‚Ø¨Ø© Ø§Ù„Ø¬ÙˆØ¯Ø© ÙÙŠ Ø§Ù„Ù†Øµ Ù„ÙˆØ¸ÙŠÙØ© Ø­Ø¬Ø² Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(271002,7528,'fr','Texte de contrÃ´le de la qualitÃ© pour bon de travail',0),(271003,7528,'jp','ã‚¸ãƒ§ãƒ– ãƒã‚±ãƒƒãƒˆã®å“è³ªã‚³ãƒ³ãƒˆãƒ­ãƒ¼ãƒ« ãƒ†ã‚­ã‚¹ãƒˆ',0),(271004,7528,'pt','Controle de qualidade de texto para tÃ­quete de trabalho',0),(271005,7528,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒ ÐºÐ°Ñ‡ÐµÑÑ‚Ð²Ð° Ñ‚ÐµÐºÑÑ‚ Ð´Ð»Ñ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(271006,7528,'es','Texto de Control de Calidad para el Boleto de Trabajo',0),(271007,7528,'de','QualitÃ¤tskontrolle Text fÃ¼r Job-Ticket',0),(271008,7528,'en','Quality Control Text for Job Ticket',0),(271009,7529,'is','',0),(271010,7529,'dr','Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ ',0),(271011,7529,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ ',0),(271012,7529,'tr','Banka mevduat',0),(271013,7529,'pl','Depozyt bankowy',0),(271014,7529,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(271015,7529,'ur','Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹',0),(271016,7529,'sr','Ð‘Ð°Ð½ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(271017,7529,'vi','TK NgÃ¢n hÃ ng Ná»£',0),(271018,7529,'af','Bank Deposito',0),(271019,7529,'ro','Depozit bancar',0),(271020,7529,'et','Pangahoiuste',0),(271021,7529,'si','BanÄni depozit',0),(271022,7529,'ba','Deposito bank',0),(271023,7529,'nl','Bankstorting',0),(271024,7529,'fi','Bank Deposit',0),(271025,7529,'no','Bankinnskudd',0),(271026,7529,'da','BankindlÃ¥nsgaranti',0),(271027,7529,'ko','ì€í–‰ ì˜ˆê¸ˆ',0),(271028,7529,'he','×¤×™×§×“×•×Ÿ ×”×‘× ×§',0),(271029,7529,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÎµ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(271030,7529,'zh','é“¶è¡Œå­˜æ¬¾\r\n',0),(271031,7529,'sv','BankinsÃ¤ttning',0),(271032,7529,'it','Deposito bancario',0),(271033,7529,'tl','',0),(271034,7529,'th','&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(271035,7529,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾',0),(271036,7529,'ms','Bank Deposit',0),(271037,7529,'ar','Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(271038,7529,'fr','DÃ©pÃ´t bancaire',0),(271039,7529,'jp','éŠ€è¡Œé é‡‘',0),(271040,7529,'pt','DepÃ³sito bancÃ¡rio',0),(271041,7529,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(271042,7529,'es','Deposto Bancario',0),(271043,7529,'de','Bank Deposit',0),(271044,7529,'en','Bank Deposit',0),(271045,7530,'is','',0),(271046,7530,'dr','Ù…Ø¹ÙƒÙˆØ³ ÙƒØ±Ø¯Ù†  Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(271047,7530,'pr','Ù…Ø¹ÙƒÙˆØ³ ÙƒØ±Ø¯Ù†  Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(271048,7530,'tr','Banka mevduat ters',0),(271049,7530,'pl','Banku depozyt odwrotnej',0),(271050,7530,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð·Ð°Ð´ÐµÐ½ Ñ…Ð¾Ð´',0),(271051,7530,'ur','Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ Ù…Ø¹Ú©ÙˆØ³',0),(271052,7530,'sr','Ð‘Ð°Ð½ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° ÑƒÐ½Ð°Ð·Ð°Ð´',0),(271053,7530,'vi','BÃºt toÃ¡n ngÃ¢n hÃ ng Ná»£ Viáº¿t ngÆ°á»£c',0),(271054,7530,'af','Bank Deposito Teruggeskryf',0),(271055,7530,'ro','InversÄƒ de depozit bancar',0),(271056,7530,'et','Panga hoiuste pÃ¶Ã¶rdel',0),(271057,7530,'si','BanÄni depozit obratno',0),(271058,7530,'ba','Bank Deposit Reverse',0),(271059,7530,'nl','Bank storting Reverse',0),(271060,7530,'fi','Pankin talletus kÃ¤Ã¤nteinen',0),(271061,7530,'no','Banken innskudd omvendt',0),(271062,7530,'da','Bank depositum tilbage',0),(271063,7530,'ko','ì€í–‰ ì˜ˆê¸ˆ ì—­',0),(271064,7530,'he','×”×‘× ×§ ×¤×™×§×“×•×Ÿ ×”×¤×•×š',0),(271065,7530,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚ Î±Î½Ï„Î¯ÏƒÏ„ÏÎ¿Ï†Î·',0),(271066,7530,'zh','é“¶è¡Œå­˜æ¬¾åå‘\r\n',0),(271067,7530,'sv','Bank insÃ¤ttning omvÃ¤nd',0),(271068,7530,'it','Banca deposito Reverse',0),(271069,7530,'tl','',0),(271070,7530,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3618;&#3657;&#3629;&#3609;&#3627;&#3621;&#3633;&#3591;',0),(271071,7530,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤°à¤¿à¤µà¤°à¥à¤¸',0),(271072,7530,'ms','Belakang Deposit Bank',0),(271073,7530,'ar','Ø¹ÙƒØ³ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(271074,7530,'fr','Inverse de dÃ©pÃ´t de banque',0),(271075,7530,'jp','éŠ€è¡Œé é‡‘ã®ãƒªãƒãƒ¼ã‚¹',0),(271076,7530,'pt','Reversa de depÃ³sito de banco',0),(271077,7530,'ru','Ð‘Ð°Ð½Ðº Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ€ÐµÐ²ÐµÑ€Ñ',0),(271078,7530,'es','Reversar Deposit Bancario',0),(271079,7530,'de','Bank Deposit Reverse',0),(271080,7530,'en','Bank Deposit Reverse',0),(271081,7531,'is','',0),(271082,7531,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(271083,7531,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(271084,7531,'tr','Teklifi dÃ¼zenle',0),(271085,7531,'pl','Edytuj cytat',0),(271086,7531,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(271087,7531,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(271088,7531,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(271089,7531,'vi','Sá»­a BÃ¡o GiÃ¡',0),(271090,7531,'af','Redigeer Kwotasie',0),(271091,7531,'ro','Editare citat',0),(271092,7531,'et','Muuda pakkumist',0),(271093,7531,'si','Uredite citat',0),(271094,7531,'ba','Mengedit kutipan',0),(271095,7531,'nl','Offerte bewerken',0),(271096,7531,'fi','Muokata tarjousta',0),(271097,7531,'no','Rediger sitat',0),(271098,7531,'da','Redigere citat',0),(271099,7531,'ko','ì¸ìš© íŽ¸ì§‘',0),(271100,7531,'he','×¢×¨×•×š ×”×¦×¢×ª ×ž×—×™×¨',0),(271101,7531,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï€Î±ÏÎ¬Î¸ÎµÏƒÎ·',0),(271102,7531,'zh','ç¼–è¾‘æŠ¥ä»·\r\n',0),(271103,7531,'sv','Redigera citat',0),(271104,7531,'it','Modifica il preventivo',0),(271105,7531,'tl','',0),(271106,7531,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(271107,7531,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(271108,7531,'ms','Edit Quote',0),(271109,7531,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(271110,7531,'fr','Modifier le devis',0),(271111,7531,'jp','è¦‹ç©ã‚‚ã‚Šã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(271112,7531,'pt','Editar a citaÃ§Ã£o',0),(271113,7531,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(271114,7531,'es','Editar CotizaciÃ³n',0),(271115,7531,'de','Zitat editieren',0),(271116,7531,'en','Edit Quote',0),(271117,7532,'is','',0),(271118,7532,'dr','Ù†Ù…Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù‚Ø§Ø¨Ù„ Ú†Ø§Ù¾ ',0),(271119,7532,'pr','Ù†Ù…Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù‚Ø§Ø¨Ù„ Ú†Ø§Ù¾ ',0),(271120,7532,'tr','GÃ¶rÃ¼nÃ¼m yazdÄ±rÄ±labilir alÄ±ntÄ±',0),(271121,7532,'pl','Zobacz ofertÄ™ do druku',0),(271122,7532,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(271123,7532,'ur','Ù…Ù†Ø¸Ø± Ù‚Ø§Ø¨Ù„ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø§Ù‚ØªØ¨Ø§Ø³',0),(271124,7532,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(271125,7532,'vi','Xem bÃ¡o giÃ¡ in',0),(271126,7532,'af','Besigtig Uitdrukbare Kwotasie',0),(271127,7532,'ro','Vezi oferta printabila',0),(271128,7532,'et','Vaata Prinditav Quote',0),(271129,7532,'si','Pogled Printable citat',0),(271130,7532,'ba','Lihat dicetak kutipan',0),(271131,7532,'nl','Weergave afdrukbare offerte',0),(271132,7532,'fi','NÃ¤ytÃ¤ tulostettava tarjous',0),(271133,7532,'no','Vis utskriftsvennlig tilbud',0),(271134,7532,'da','Se Printable citat',0),(271135,7532,'ko','ë³´ê¸° ì¸ì‡„ ê²¬ì ',0),(271136,7532,'he','×ª×¦×•×’×” ×œ×”×“×¤×¡×” ×”×¦×¢×ª ×ž×—×™×¨',0),(271137,7532,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎ¹Î¼Î· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(271138,7532,'zh','æŸ¥çœ‹å¯æ‰“å°æŠ¥ä»·\r\n',0),(271139,7532,'sv','Visa utskrivbara citat',0),(271140,7532,'it','Visualizzazione stampabile citazione',0),(271141,7532,'tl','',0),(271142,7532,'th','&#3649;&#3626;&#3604;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3614;&#3636;&#3617;&#3614;&#3660;&#3652;&#3604;&#3657;',0),(271143,7532,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤®à¥à¤¦à¥à¤°à¤£ à¤¯à¥‹à¤—à¥à¤¯ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(271144,7532,'ms','Paparan boleh dicetak Quote',0),(271145,7532,'ar','Ø¹Ø±Ø¶ Ø§Ù‚ØªØ¨Ø§Ø³ Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(271146,7532,'fr','Vue devis imprimable',0),(271147,7532,'jp','ãƒ“ãƒ¥ãƒ¼ã®å°åˆ·å¯èƒ½ãªå¼•ç”¨',0),(271148,7532,'pt','CitaÃ§Ã£o Printable View',0),(271149,7532,'ru','Ð’Ð¸Ð´ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(271150,7532,'es','Visionar CotizaciÃ³n Imprimible',0),(271151,7532,'de','Druckbare Ansicht-Zitat',0),(271152,7532,'en','View Printable Quote',0),(271153,7533,'is','',0),(271154,7533,'dr','Ù†Ù…Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…ØªØ¹Ø§Ø±Ù',0),(271155,7533,'pr','Ù†Ù…Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…ØªØ¹Ø§Ø±Ù',0),(271156,7533,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ normal fiyat teklifi',0),(271157,7533,'pl','Zobacz ofertÄ™ regularne',0),(271158,7533,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ñ€ÐµÐ´Ð¾Ð²Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(271159,7533,'ur','Ù…Ù†Ø¸Ø± Ø¨Ø§Ù‚Ø§Ø¹Ø¯Û Ø§Ù‚ØªØ¨Ø§Ø³',0),(271160,7533,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ€ÐµÐ´Ð¾Ð²Ð½Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(271161,7533,'vi','Xem bÃ¡o giÃ¡ thÃ´ng thÆ°á»ng',0),(271162,7533,'af','Besigtig Gewone Kwotasie',0),(271163,7533,'ro','Vezi Quote regulate',0),(271164,7533,'et','Vaata regulaarsete Quote',0),(271165,7533,'si','Pogled redne ponudbe',0),(271166,7533,'ba','Lihat kutipan reguler',0),(271167,7533,'nl','Weergave regelmatige offerte',0),(271168,7533,'fi','Katso sÃ¤Ã¤nnÃ¶llisesti lainaus',0),(271169,7533,'no','Vis vanlige tilbud',0),(271170,7533,'da','Se regelmÃ¦ssig citat',0),(271171,7533,'ko','ë³´ê¸° ì¼ë°˜ ê²¬ì ',0),(271172,7533,'he','×ª×¦×•×’×” ×¨×’×™×œ×™× ×¦×™×˜×•×˜',0),(271173,7533,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï„Î±ÎºÏ„Î¹ÎºÎ® Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(271174,7533,'zh','æŸ¥çœ‹å®šæœŸæŠ¥ä»·\r\n',0),(271175,7533,'sv','Visa regelbunden citat',0),(271176,7533,'it','Citazione regolare vista',0),(271177,7533,'tl','',0),(271178,7533,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(271179,7533,'hi','à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤¦à¥ƒà¤¶à¥à¤¯',0),(271180,7533,'ms','Pemandangan biasa Quote',0),(271181,7533,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³ Ø§Ù„Ø¹Ø§Ø¯ÙŠØ©',0),(271182,7533,'fr','Voir citation rÃ©guliÃ¨re',0),(271183,7533,'jp','ãƒ“ãƒ¥ãƒ¼ã®å®šæœŸçš„ãªå¼•ç”¨',0),(271184,7533,'pt','CitaÃ§Ã£o Regular de exibiÃ§Ã£o',0),(271185,7533,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¾Ñ‡ÐµÑ€ÐµÐ´Ð½Ð¾Ð¹ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(271186,7533,'es','Visionar CotizaciÃ³n Normal',0),(271187,7533,'de','RegelmÃ¤ÃŸige Angebot anzeigen',0),(271188,7533,'en','View Regular Quote',0),(271189,7534,'is','',0),(271190,7534,'dr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ',0),(271191,7534,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ',0),(271192,7534,'tr','TarafÄ±ndan tahmini',0),(271193,7534,'pl','Szacowana przez',0),(271194,7534,'bg','ÐžÑ†ÐµÐ½ÑÐ²Ð° Ñ‡Ñ€ÐµÐ·',0),(271195,7534,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù„Ú¯Ø§ÛŒØ§ Ú¯ÛŒØ§',0),(271196,7534,'sr','ÐŸÑ€ÐµÐ´Ð²Ð¸Ñ’ÐµÐ½Ðµ Ð¿Ñ€ÐµÐ¼Ð°',0),(271197,7534,'vi','Dá»± trÃ¹ bá»Ÿi',0),(271198,7534,'af','Kosteberaming Per',0),(271199,7534,'ro','Estimat de',0),(271200,7534,'et','Hinnangute kohaselt',0),(271201,7534,'si','Po oceni',0),(271202,7534,'ba','Diperkirakan oleh',0),(271203,7534,'nl','Geschat door',0),(271204,7534,'fi','Arvioiden mukaan',0),(271205,7534,'no','AnslÃ¥tt av',0),(271206,7534,'da','AnslÃ¥et af',0),(271207,7534,'ko','ì˜í•´ ì¶”ì •',0),(271208,7534,'he','×œ×¤×™ ××•×ž×“×Ÿ',0),(271209,7534,'el','Î•ÎºÏ„Î¹Î¼Î¬Ï„Î±Î¹ ÏŒÏ„Î¹ Î±Ï€ÏŒ',0),(271210,7534,'zh','ä¼°è®¡\r\n',0),(271211,7534,'sv','Uppskattas av',0),(271212,7534,'it','Stimato da',0),(271213,7534,'tl','',0),(271214,7534,'th','&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3650;&#3604;&#3618;',0),(271215,7534,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤',0),(271216,7534,'ms','Dianggarkan dengan',0),(271217,7534,'ar','ÙˆØªÙ‚Ø¯Ø±',0),(271218,7534,'fr','EstimÃ©e par',0),(271219,7534,'jp','æŽ¨å®š',0),(271220,7534,'pt','Estimado pelo',0),(271221,7534,'ru','ÐŸÐ¾ Ð¾Ñ†ÐµÐ½ÐºÐ°Ð¼',0),(271222,7534,'es','Estimado por',0),(271223,7534,'de','GeschÃ¤tzt von',0),(271224,7534,'en','Estimated By',0),(271225,7535,'is','',0),(271226,7535,'dr','30 Ø±ÙˆØ² ',0),(271227,7535,'pr','Ø¨Ø±Ø§ÙŠ Ø³ÙŠ 30 Ø±ÙˆØ² ',0),(271228,7535,'tr','30 gÃ¼n boyunca',0),(271229,7535,'pl','Do 30 dni',0),(271230,7535,'bg','Ð—Ð° 30 Ð´Ð½Ð¸',0),(271231,7535,'ur','ØªÛŒØ³ Ø¯Ù†ÙˆÚº Ú©Û’ Ù„Ø¦Û’',0),(271232,7535,'sr','Ð—Ð° 30 Ð´Ð°Ð½Ð°',0),(271233,7535,'vi','Cho 30 ngÃ y',0),(271234,7535,'af','Vir 30 Dae',0),(271235,7535,'ro','Pentru 30 de zile',0),(271236,7535,'et','30 pÃ¤eva',0),(271237,7535,'si','Za 30 dni',0),(271238,7535,'ba','Selama 30 hari',0),(271239,7535,'nl','Voor 30 dagen',0),(271240,7535,'fi','30 pÃ¤ivÃ¤Ã¤',0),(271241,7535,'no','I 30 dager',0),(271242,7535,'da','For 30 dage',0),(271243,7535,'ko','30 ì¼ ë™ì•ˆ',0),(271244,7535,'he','30 ×™×ž×™×',0),(271245,7535,'el','Î“Î¹Î± 30 Î·Î¼Î­ÏÎµÏ‚',0),(271246,7535,'zh','30å¤©\r\n',0),(271247,7535,'sv','I 30 dagar',0),(271248,7535,'it','Per 30 giorni',0),(271249,7535,'tl','',0),(271250,7535,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610; 30 &#3623;&#3633;&#3609;',0),(271251,7535,'hi','30 à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤',0),(271252,7535,'ms','Selama 30 hari',0),(271253,7535,'ar','Ù„Ù…Ø¯Ø© 30 ÙŠÙˆÙ…Ø§',0),(271254,7535,'fr','Pendant 30 jours',0),(271255,7535,'jp','30 æ—¥é–“',0),(271256,7535,'pt','Por 30 dias',0),(271257,7535,'ru','Ð—Ð° 30 Ð”Ð½ÐµÐ¹',0),(271258,7535,'es','Para 30 DÃ­as',0),(271259,7535,'de','FÃ¼r 30 Tage',0),(271260,7535,'en','For 30 Days',0),(271261,7536,'is','',0),(271262,7536,'dr','Ù‡Ù…Ù‡ Ø´ØºÙ„ Ù‡Ø§ÙŠ Ø¨Ø§Ø² ',0),(271263,7536,'pr','Ù‡Ù…Ù‡ Ø´ØºÙ„ Ù‡Ø§ÙŠ Ø¨Ø§Ø² ',0),(271264,7536,'tr','AÃ§Ä±k olan tÃ¼m iÅŸleri',0),(271265,7536,'pl','Wszystkie otwarte zadania',0),(271266,7536,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¸',0),(271267,7536,'ur','ØªÙ…Ø§Ù… Ú©Ú¾Ù„ÛŒ Ù†ÙˆÚ©Ø±ÛŒØ§Úº',0),(271268,7536,'sr','Ð¡Ð²Ð¸Ñ… Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸Ñ… Ñ€Ð°Ð´Ð½Ð¸Ñ… Ð¼ÐµÑÑ‚Ð°',0),(271269,7536,'vi','Táº¥t Cáº£ CÃ¡c Job Äang Má»Ÿ',0),(271270,7536,'af','Alle Open Werkstukke',0),(271271,7536,'ro','Deschise de locuri de muncÄƒ',0),(271272,7536,'et','KÃµik avatud TÃ¶Ã¶pakkumised',0),(271273,7536,'si','Vsa odprta delovna mesta',0),(271274,7536,'ba','Semua Lowongan',0),(271275,7536,'nl','Alle geopende banen',0),(271276,7536,'fi','Kaikki avoimet tyÃ¶paikat',0),(271277,7536,'no','Alle Ã¥pne jobber',0),(271278,7536,'da','Alle Ã¥bne Jobs',0),(271279,7536,'ko','ì—´ë ¤ ìžˆëŠ” ëª¨ë“  ìž‘ì—…',0),(271280,7536,'he','×›×œ ×”×¢×‘×•×“×•×ª ×”×¤×ª×•×—×•×ª',0),(271281,7536,'el','ÎŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î±Î½Î¿Î¹Ï‡Ï„Î­Ï‚ Î¸Î­ÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(271282,7536,'zh','æ‰€æœ‰ç©ºç¼ºèŒä½\r\n',0),(271283,7536,'sv','Alla Ã¶ppna arbetstillfÃ¤llen',0),(271284,7536,'it','Lavori tutti aperti',0),(271285,7536,'tl','',0),(271286,7536,'th','&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3648;&#3611;&#3636;&#3604;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(271287,7536,'hi','à¤¸à¤­à¥€ à¤–à¥à¤²à¥‡ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¤¾à¤‚',0),(271288,7536,'ms','Kerja-kerja yang terbuka',0),(271289,7536,'ar','ÙØªØ­ Ø¬Ù…ÙŠØ¹ Ø§Ù„ÙˆØ¸Ø§Ø¦Ù',0),(271290,7536,'fr','Ouverts tous les emplois',0),(271291,7536,'jp','é–‹ã„ã¦ã„ã‚‹ã™ã¹ã¦ã®ã‚¸ãƒ§ãƒ–',0),(271292,7536,'pt','Todos os postos de trabalho',0),(271293,7536,'ru','Ð’ÑÐµ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð²Ð°ÐºÐ°Ð½ÑÐ¸Ð¸',0),(271294,7536,'es','Todos los Trabajos Abiertos',0),(271295,7536,'de','Alle offenen Jobs',0),(271296,7536,'en','All Open Jobs',0),(271297,7537,'is','',0),(271298,7537,'dr','Ú†Ù‡ Ú¯Ø±ÙˆÙ‡ÙŠ Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ØŸ',0),(271299,7537,'pr','Ú†Ù‡ Ú¯Ø±ÙˆÙ‡ÙŠ Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ØŸ',0),(271300,7537,'tr','Ne rapor iÃ§inde gruplar dahil',0),(271301,7537,'pl','To, co grupy w raporcie',0),(271302,7537,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ñ‚Ð¾Ð²Ð°, ÐºÐ¾ÐµÑ‚Ð¾ Ð³Ñ€ÑƒÐ¿Ð¸ Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(271303,7537,'ur','Ú©ÛŒØ§ Ø±Ù¾ÙˆØ±Ù¹ Ù…ÛŒÚº Ú¯Ø±ÙˆÛ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(271304,7537,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ ÐºÐ°ÐºÐ¾ Ð³Ñ€ÑƒÐ¿Ð° Ñƒ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(271305,7537,'vi','NhÃ³m nÃ o sáº½ bao gá»“m trong bÃ¡o cÃ¡o',0),(271306,7537,'af','Sluit in Watter Groepe in Verslag',0),(271307,7537,'ro','Includ ce grupuri Ã®n raport',0),(271308,7537,'et','Hulka, mida rÃ¼hmad aruande',0),(271309,7537,'si','VkljuÄujejo kaj skupine v poroÄilu',0),(271310,7537,'ba','Termasuk apa kelompok dalam laporan',0),(271311,7537,'nl','Opnemen wat groepen in verslag',0),(271312,7537,'fi','Ovat mitÃ¤ ryhmittelee raportin',0),(271313,7537,'no','Inkluder hva grupper i rapporten',0),(271314,7537,'da','Omfatte hvad Groups betÃ¦nkning',0),(271315,7537,'ko','ë³´ê³ ì„œì— ì–´ë–¤ ê·¸ë£¹ì„ í¬í•¨',0),(271316,7537,'he','×›×•×œ×œ ×ž×” ×§×‘×•×¦×•×ª ×‘×“×• ×—',0),(271317,7537,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï„Î¹ Î¿Î¼Î¬Î´ÎµÏ‚ ÏƒÏ„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ·',0),(271318,7537,'zh','åœ¨æŠ¥è¡¨ä¸­åŒ…æ‹¬å“ªäº›ç»„\r\n',0),(271319,7537,'sv','Inkludera vad grupper i rapporten',0),(271320,7537,'it','Comprendere ciÃ² che raggruppa in relazione',0),(271321,7537,'tl','',0),(271322,7537,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3629;&#3632;&#3652;&#3619;&#3651;&#3609;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(271323,7537,'hi','à¤•à¥à¤¯à¤¾ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤®à¥‡à¤‚ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(271324,7537,'ms','Termasuk apa Kumpulan dalam Laporan',0),(271325,7537,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ù…Ø§ ÙÙŠ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(271326,7537,'fr','Comprendre ce que les groupes en rapport',0),(271327,7537,'jp','ã©ã®ã‚ˆã†ãªãƒ¬ãƒãƒ¼ãƒˆã§ã‚°ãƒ«ãƒ¼ãƒ—ã‚’å«ã‚ã‚‹',0),(271328,7537,'pt','Incluir o que agrupa no relatÃ³rio',0),(271329,7537,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ ÐšÐ°ÐºÐ¸Ðµ Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð² ÐžÑ‚Ñ‡ÐµÑ‚',0),(271330,7537,'es','Incluir Cuales Grupos en el Informe',0),(271331,7537,'de','GehÃ¶ren Sie, was im Bericht gruppiert',0),(271332,7537,'en','Include What Groups in Report',0),(271333,7538,'is','',0),(271334,7538,'dr','ØªØ§Ø±ÙŠØ® Ù…ÙˆØ¹Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´ØºÙ„ ',0),(271335,7538,'pr','ØªØ§Ø±ÙŠØ® Ù…ÙˆØ¹Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´ØºÙ„ ',0),(271336,7538,'tr','Son iÅŸ Tarih',0),(271337,7538,'pl','Pracy termin pÅ‚atnoÅ›ci',0),(271338,7538,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€Ð°Ð´Ð¸',0),(271339,7538,'ur','Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ù†ÙˆÚ©Ø±ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(271340,7538,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼ Ð´Ð¾ÑÐ¿ÐµÑ›Ð°',0),(271341,7538,'vi','Thá»i háº¡n Job',0),(271342,7538,'af','Projek Datum Verskuldig',0),(271343,7538,'ro','Job data datorate',0),(271344,7538,'et','TÃ¶Ã¶ maksetÃ¤htaeg',0),(271345,7538,'si','Delovna dneva zaradi',0),(271346,7538,'ba','Job tanggal jatuh tempo',0),(271347,7538,'nl','Jobs datum vervaldatum',0),(271348,7538,'fi','TyÃ¶ mÃ¤Ã¤rÃ¤pÃ¤ivÃ¤n',0),(271349,7538,'no','Jobb forfallsdato',0),(271350,7538,'da','Job dato grund',0),(271351,7538,'ko','ìž‘ì—… ê¸°í•œ',0),(271352,7538,'he','×”×¢×‘×•×“×” ×ª××¨×™×š ×™×¢×“',0),(271353,7538,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¿Ï†ÎµÎ¹Î»Î®Ï‚',0),(271354,7538,'zh','æ‹›è˜æ—¥åˆ°æœŸ\r\n',0),(271355,7538,'sv','Job datum pÃ¥ grund',0),(271356,7538,'it','Lavoro data dovuta',0),(271357,7538,'tl','',0),(271358,7538,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3591;&#3634;&#3609;',0),(271359,7538,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¦à¥‡à¤¯ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(271360,7538,'ms','Kerja tarikh kena dibayar',0),(271361,7538,'ar','Ù…Ù‡Ù…Ø© ÙÙŠ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(271362,7538,'fr','Emploi Date Due',0),(271363,7538,'jp','ä»•äº‹ã®æœŸé™',0),(271364,7538,'pt','Emprego data devida',0),(271365,7538,'ru','Ð Ð°Ð±Ð¾Ñ‚Ñ‹, Ð¿Ð¾Ð´Ð»ÐµÐ¶Ð°Ð²ÑˆÐ¸Ðµ',0),(271366,7538,'es','Trabajo Fecha de Vencimiento',0),(271367,7538,'de','Job FÃ¤lligkeitsdatum',0),(271368,7538,'en','Job Date Due',0),(271369,7539,'is','',0),(271370,7539,'dr','Ø´Ù…Ø§Ø±Ù‡  Ø³ÙØ§Ø±Ø´ Ø´ØºÙ„ ',0),(271371,7539,'pr','Ø´Ù…Ø§Ø±Ù‡  Ø³ÙØ§Ø±Ø´ Ø´ØºÙ„ ',0),(271372,7539,'tr','Ä°ÅŸ emri numarasÄ±',0),(271373,7539,'pl','Zadanie numer zamÃ³wienia',0),(271374,7539,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð¾Ð¼ÐµÑ€',0),(271375,7539,'ur','Ø¬Ø§Ø¨ Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø±',0),(271376,7539,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(271377,7539,'vi','Sá»‘ Job',0),(271378,7539,'af','Werkstuk Bestelnommer',0),(271379,7539,'ro','NumÄƒrul de ordine Job',0),(271380,7539,'et','TÃ¶Ã¶ jÃ¤rjekorranumbri',0),(271381,7539,'si','Å tevilka naroÄila za delo',0),(271382,7539,'ba','Nomor pesanan pekerjaan',0),(271383,7539,'nl','Baan ordernummer',0),(271384,7539,'fi','TyÃ¶n numero',0),(271385,7539,'no','Jobb ordrenummer',0),(271386,7539,'da','Jobnummer',0),(271387,7539,'ko','ìž‘ì—… ìˆœì„œ ë²ˆí˜¸',0),(271388,7539,'he','×ž×¡×¤×¨ ×”×–×ž× ×ª ×¢×‘×•×“×”',0),(271389,7539,'el','Î˜Î­ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(271390,7539,'zh','å·¥ä½œç¼–å·\r\n',0),(271391,7539,'sv','Jobb ordernummer',0),(271392,7539,'it','Numero di ordine di lavoro',0),(271393,7539,'tl','',0),(271394,7539,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3591;&#3634;&#3609;',0),(271395,7539,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(271396,7539,'ms','Nombor pesanan kerja',0),(271397,7539,'ar','Ø±Ù‚Ù… Ø£Ù…Ø± Ø§Ù„Ø¹Ù…Ù„',0),(271398,7539,'fr','NumÃ©ro d\'ordre de travail',0),(271399,7539,'jp','ã‚¸ãƒ§ãƒ– ã‚ªãƒ¼ãƒ€ãƒ¼ç•ªå·',0),(271400,7539,'pt','NÃºmero de ordem de trabalho',0),(271401,7539,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(271402,7539,'es','Trabajo NÃºmero de Orden',0),(271403,7539,'de','Job-Bestellnummer',0),(271404,7539,'en','Job Order Number',0),(271405,7540,'is','',0),(271406,7540,'dr','(Ù…Ø±ØªØ¨ Ø´Ø¯Ù†) Ø¯Ø§Ø±Ø¯ ',0),(271407,7540,'pr','ÙÙ‚Ø· Ø´ØºÙ„ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±ÙŠ ÙƒÙ‡ Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø´Ø¯Ù† (Ù…Ø±ØªØ¨ Ø´Ø¯Ù†) Ø¯Ø§Ø±Ø¯ ',0),(271408,7540,'tr','Sadece iÅŸleri ile sipariÅŸ edilebilir gerek hisse senedi',0),(271409,7540,'pl','Tylko zadania z koniecznoÅ›ci zamÃ³wiÄ‡ czas',0),(271410,7540,'bg','Ð¡Ð°Ð¼Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸ÐµÑ‚Ð¾ ÑÑŠÑ Ð·Ð°Ð¿Ð°ÑÐ¸, Ðµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð´Ð° ÑÐµ Ð¿Ð¾Ñ€ÑŠÑ‡Ð°',0),(271411,7540,'ur','ØµØ±Ù Ø±ÙˆØ²Ú¯Ø§Ø± Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ø³Ø§ØªÚ¾',0),(271412,7540,'sr','Ð¡Ð°Ð¼Ð¾ Ð¿Ð¾ÑÐ»Ð¾Ð²Ðµ ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° Ð±ÑƒÐ´Ðµ Ð¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½',0),(271413,7540,'vi','Chá»‰ cÃ³ Job cáº§n Ä‘áº·t hÃ ng ',0),(271414,7540,'af','Slegs Werstukker Met Voorraad Nodig Om Bestel te Word',0),(271415,7540,'ro','Doar de locuri de muncÄƒ cu stoc au nevoie pentru a fi comandat',0),(271416,7540,'et','Ainult tÃ¶Ã¶ oleks vaja tellida Stock',0),(271417,7540,'si','Le delovna mesta z zalogo, ki potrebujejo naloÅ¾i',0),(271418,7540,'ba','Hanya pekerjaan dengan saham yang perlu dipesan',0),(271419,7540,'nl','Alleen taken met voorraad hoeft te worden besteld',0),(271420,7540,'fi','Vain tyÃ¶t, joilla varastossa tarvitse tilata',0),(271421,7540,'no','Bare jobber med lager mÃ¥tte bestilles',0),(271422,7540,'da','Kun arbejdspladser med materiel skulle bestilles',0),(271423,7540,'ko','ì£¼ì‹ ì£¼ë¬¸ ë  í•„ìš”ê°€ ìž‘ì—…ë§Œ',0),(271424,7540,'he','×¨×§ ××ª ×”×ž×©×™×ž×•×ª ×¢× ×ž×œ××™ ×¦×•×¨×š ×œ×”×™×•×ª ×”×•×¨×”',0),(271425,7540,'el','ÎœÏŒÎ½Î¿ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Î¼Îµ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÏ„Î±Î¹',0),(271426,7540,'zh','ä»…åº“å­˜å·¥ä½œéœ€è¦è®¢è´­\r\n',0),(271427,7540,'sv','Endast jobb med lager behÃ¶va bestÃ¤llas',0),(271428,7540,'it','Solo lavori con Stock che necessitano di essere ordinato',0),(271429,7540,'tl','',0),(271430,7540,'th','Only Jobs With Stock Needing To Be Ordered',0),(271431,7540,'hi','à¤œà¤¼à¤°à¥‚à¤°à¤¤ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¹à¥€ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¥‹à¤‚',0),(271432,7540,'ms','Hanya kerja dengan stok perlu dipesan',0),(271433,7540,'ar','ÙˆØ¸Ø§Ø¦Ù ÙÙ‚Ø· Ù…Ø¹ Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„ØªÙŠ ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ Ø£Ù† ØªØ£Ù…Ø±',0),(271434,7540,'fr','Uniquement les projets de Stock qui ont besoin d\'Ãªtre commandÃ©s',0),(271435,7540,'jp','åœ¨åº«æ³¨æ–‡ã™ã‚‹å¿…è¦ãŒã‚ã‚‹ã‚¸ãƒ§ãƒ–ã®ã¿',0),(271436,7540,'pt','Somente trabalhos com aÃ§Ãµes precisam ser encomendados',0),(271437,7540,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ Ñ Ð·Ð°Ð¿Ð°ÑÐ¾Ð¼, Ð½ÑƒÐ¶Ð½Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ',0),(271438,7540,'es','Solo trabajos Con Stock Que Necesitan ser Ordenados',0),(271439,7540,'de','Nur AuftrÃ¤ge mit Lager mÃ¼ssen bestellt werden',0),(271440,7540,'en','Only Jobs With Stock Needing To Be Ordered',0),(271441,7541,'is','',0),(271442,7541,'dr','ÙÙ‚Ø· Ø´ØºÙ„ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø´Ø¯Ù‡ Ø§Ù…Ø§ Ø¯Ø±ÙŠØ§ÙØª Ù†Ø´Ø¯Ù‡ ',0),(271443,7541,'pr','ÙÙ‚Ø· Ø´ØºÙ„ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø´Ø¯Ù‡ Ø§Ù…Ø§ Ø¯Ø±ÙŠØ§ÙØª Ù†Ø´Ø¯Ù‡ ',0),(271444,7541,'tr','Sadece iÅŸleri ile stok sipariÅŸ ancak alÄ±nmadÄ±',0),(271445,7541,'pl','Tylko zadania z czas zamÃ³wiÄ‡, ale nie otrzymaÅ‚',0),(271446,7541,'bg','Ð¡Ð°Ð¼Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸ÐµÑ‚Ð¾ ÑÑŠÑ ÑÑŠÑÑ‚Ð°Ð² Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸, Ð½Ð¾ Ð½Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»Ð¸',0),(271447,7541,'ur','Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ø³Ø§ØªÚ¾ ØµØ±Ù Ú©Ø§Ù… Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§ Ù„ÛŒÚ©Ù† Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(271448,7541,'sr','Ð¡Ð°Ð¼Ð¾ Ð¿Ð¾ÑÐ»Ð¾Ð²Ðµ ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾, Ð°Ð»Ð¸ Ð½Ð¸ÑÑƒ Ð¿Ñ€Ð¸Ð¼Ð¸Ð»Ð¸',0),(271449,7541,'vi','Chá»‰ cÃ³ Job cáº§n Ä‘áº·t hÃ ng nhÆ°ng chÆ°a nháº­n Ä‘Æ°á»£c',0),(271450,7541,'af','Slegs Werstukke Met Voorraad Bestel, Maar Nie Ontvang',0),(271451,7541,'ro','Doar de locuri de muncÄƒ cu stoc comandat, dar nu a primit',0),(271452,7541,'et','Ainult tÃ¶Ã¶ Stock tellitud, kuid tarnimata',0),(271453,7541,'si','Le delovna mesta z zalogo naroÄil pa niso prejeli',0),(271454,7541,'ba','Hanya pekerjaan dengan saham memerintahkan tapi tidak menerima',0),(271455,7541,'nl','Alleen taken met voorraad besteld maar niet ontvangen',0),(271456,7541,'fi','Vain tyÃ¶t, joilla varastossa tilattu mutta ei vastaanotettu',0),(271457,7541,'no','Bare jobber med lager bestilt, men mottatt ikke',0),(271458,7541,'da','Kun job med status bestilt men modtaget ikke',0),(271459,7541,'ko','ìž¬ê³  ìž‘ì—…ë§Œ ëª…ë ¹ í•˜ì§€ë§Œ ë°›ì§€',0),(271460,7541,'he','×¨×§ ××ª ×”×ž×©×™×ž×•×ª ×¢× ×ž×œ××™ ×”×•×¨×” ××‘×œ ×œ× ×”×ª×§×‘×œ',0),(271461,7541,'el','ÎœÏŒÎ½Î¿ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Î¼Îµ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î´Î¹Î­Ï„Î±Î¾Îµ Î±Î»Î»Î¬ Î´ÎµÎ½ Î»Î¬Î²ÎµÎ¹',0),(271462,7541,'zh','ä»…è®¢è´­åº“å­˜å·¥ä½œä½†æ²¡æœ‰æ”¶åˆ°\r\n',0),(271463,7541,'sv','Endast jobb med lager bestÃ¤llt men fÃ¥tt inte',0),(271464,7541,'it','Solo lavori con Stock ordinato ma non ricevuto',0),(271465,7541,'tl','',0),(271466,7541,'th','Only Jobs With Stock Ordered But Not Received',0),(271467,7541,'hi','à¤•à¥‡à¤µà¤² à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾ à¤²à¥‡à¤•à¤¿à¤¨ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€',0),(271468,7541,'ms','Hanya kerja dengan saham diperintahkan tetapi tidak diterima',0),(271469,7541,'ar','Ø£Ù…Ø±Øª ÙÙ‚Ø· Ù…Ù† Ø§Ù„ÙˆØ¸Ø§Ø¦Ù Ù…Ø¹ Ø§Ù„Ø£Ø³Ù‡Ù…ØŒ Ù„ÙƒÙ†Ù‡Ø§ Ù„Ù… ØªØªÙ„Ù‚',0),(271470,7541,'fr','Uniquement les projets de Stock commandÃ© mais pas reÃ§u',0),(271471,7541,'jp','åœ¨åº«ã‚’æŒã¤ã‚¸ãƒ§ãƒ–ã®ã¿æ³¨æ–‡ã—ã¾ã™ãŒã€å—ä¿¡ã•ã‚Œã¾ã›ã‚“ã€‚',0),(271472,7541,'pt','Somente trabalhos com estoque ordem mas nÃ£o recebido',0),(271473,7541,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ Ñ Ð·Ð°Ð¿Ð°ÑÐ¾Ð¼, Ð·Ð°ÐºÐ°Ð·Ð°Ð», Ð½Ð¾ Ð½Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»',0),(271474,7541,'es','Solo Trabajos Con Stock Ordenado Pero No Recibido',0),(271475,7541,'de','Nur AuftrÃ¤ge mit Lager bestellt, aber nicht empfangen',0),(271476,7541,'en','Only Jobs With Stock Ordered But Not Received',0),(271477,7542,'is','',0),(271478,7542,'dr','ÙÙ‚Ø· Ø´ØºÙ„ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø§Ù…Ø§ Ù‡Ù†ÙˆØ² ÙƒØ§Ù…Ù„ Ù†Ø´Ø¯Ù‡ ',0),(271479,7542,'pr','ÙÙ‚Ø· Ø´ØºÙ„ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø§Ù…Ø§ Ù‡Ù†ÙˆØ² ÙƒØ§Ù…Ù„ Ù†Ø´Ø¯Ù‡ ',0),(271480,7542,'tr','Tek iÅŸleri hisse aldÄ±, ama hala tamamlanmadÄ±',0),(271481,7542,'pl','Tylko zadania z akcji otrzymaÅ‚, ale jeszcze nie zostaÅ‚a zakoÅ„czona',0),(271482,7542,'bg','Ð¡Ð°Ð¼Ð¾ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¸ ÑÑŠÑ Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸, Ð½Ð¾ Ð²ÑÐµ Ð¾Ñ‰Ðµ Ð½Ðµ ÑÐ° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸',0),(271483,7542,'ur','ØµØ±Ù Ù†ÙˆÚ©Ø±ÛŒØ§Úº Ù…Ù„ÛŒØŒ Ø§Ø¨Ú¾ÛŒ ØªÚ© Ù†ÛÛŒÚº Ù…Ú©Ù…Ù„ Ù„ÛŒÚ©Ù† Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ø³Ø§ØªÚ¾',0),(271484,7542,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸ Ð¿Ð¾ÑÐ»Ð¾Ð²Ð¸ ÐºÐ¾Ñ˜Ðµ Ð´ÐµÐ¾Ð½Ð¸Ñ†Ð°Ð¼Ð° Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð°, Ð°Ð»Ð¸ Ñ˜Ð¾Ñˆ ÑƒÐ²ÐµÐº Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾',0),(271485,7542,'vi','Chá»‰ cÃ³ Job cáº§n Ä‘áº·t hÃ ng nhÆ°ng chÆ°a hoÃ n táº¥t',0),(271486,7542,'af','Slegs Werstukke Met Voorraad Ontvang, Maar Steeds Onvoltooid',0),(271487,7542,'ro','Locuri de munca cu stoc primite, dar Ã®ncÄƒ nu completat',0),(271488,7542,'et','Ainult neid projekte koos varude saadud, kuid veel mitte lÃµpetatud',0),(271489,7542,'si','Edina delovna mesta z zalogo prejeli, vendar Å¡e vedno ni dokonÄano',0),(271490,7542,'ba','Pekerjaan yang hanya dengan saham yang diterima, tapi masih tidak selesai',0),(271491,7542,'nl','Enige banen met voorraad ontvangen, maar nog steeds niet is voltooid',0),(271492,7542,'fi','Vain tÃ¶itÃ¤ varastossa saanut, mutta vielÃ¤ ei lopetettu',0),(271493,7542,'no','Bare jobber med lager mottatt, men fortsatt ikke fullfÃ¸rt',0),(271494,7542,'da','Eneste job med status modtaget, men endnu ikke afsluttet',0),(271495,7542,'ko','í•˜ì§€ë§Œ ì—¬ì „ížˆ í•˜ì§€ ì™„ë£Œ ë°›ì€ ì£¼ì‹ë§Œ ìž‘ì—…',0),(271496,7542,'he','×¢×‘×•×“×•×ª ×¨×§ ×¢× ×ž×œ××™ ×”×ª×§×‘×œ, ××‘×œ ×¢×“×™×™×Ÿ ×œ× ×”×•×©×œ×ž×”',0),(271497,7542,'el','ÎœÏŒÎ½Î¿ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Î¼Îµ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Ï€Î¿Ï… Î­Î»Î±Î²Îµ, Î±Î»Î»Î¬ Î±ÎºÏŒÎ¼Î± Î´ÎµÎ½ Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ¸Î·ÎºÎµ',0),(271498,7542,'zh','ä»…æ”¶åˆ°åº“å­˜å·¥ä½œï¼Œä½†å°šæœªå®Œæˆ\r\n',0),(271499,7542,'sv','Enda jobb med lager mottagen, men fortfarande inte avslutad',0),(271500,7542,'it','Soli lavori con Stock ricevuto, ma ancora non completato',0),(271501,7542,'tl','',0),(271502,7542,'th','Only Jobs With Stock Received, But Still Not Completed',0),(271503,7542,'hi','à¤¶à¥‡à¤¯à¤° à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†, à¤…à¤­à¥€ à¤­à¥€ à¤ªà¥‚à¤°à¤¾ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤²à¥‡à¤•à¤¿à¤¨ à¤¸à¤¾à¤¥ à¤¹à¥€ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¥‹à¤‚',0),(271504,7542,'ms','Kerja-kerja hanya dengan saham yang diterima, tetapi masih belum siap dibina',0),(271505,7542,'ar','ÙˆØ¸Ø§Ø¦Ù ÙÙ‚Ø· Ù…Ø¹ Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„ØªÙŠ ÙˆØ±Ø¯ØªØŒ Ù„ÙƒÙ† Ù„Ø§ ÙŠØ²Ø§Ù„ Ù„Ù… ØªÙƒØªÙ…Ù„',0),(271506,7542,'fr','Seuls emplois avec Stock reÃ§u, mais toujours pas terminÃ©',0),(271507,7542,'jp','åœ¨åº«ã‚’å—ã‘å–ã£ãŸãŒã€ã¾ã å®Œäº†ã—ã¦ã„ãªã„ã‚¸ãƒ§ãƒ–ã®ã¿',0),(271508,7542,'pt','Ãšnicos empregos com estoque recebido, mas ainda nÃ£o estÃ¡ concluÃ­da',0),(271509,7542,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð²Ð°ÐºÐ°Ð½ÑÐ¸Ð¸ Ñ Ð·Ð°Ð¿Ð°ÑÐ¾Ð¼, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ñ‹, Ð½Ð¾ ÐµÑ‰Ðµ Ð½Ðµ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¾',0),(271510,7542,'es','Solo Trabajos Con Stock Recibido, Pero TodavÃ­a No Completado ',0),(271511,7542,'de','Nur Jobs mit Lager erhalten, aber noch nicht abgeschlossen',0),(271512,7542,'en','Only Jobs With Stock Received, But Still Not Completed',0),(271513,7543,'is','',0),(271514,7543,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§ØµÙ„ÙŠ ',0),(271515,7543,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§ØµÙ„ÙŠ ',0),(271516,7543,'tr','Ãœst boyut',0),(271517,7543,'pl','Wymiary nadrzÄ™dny',0),(271518,7543,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ñ€Ð¾Ð´Ð¸Ñ‚ÐµÐ»',0),(271519,7543,'ur','Ø¬Ø¯ Ø³Ø§Ø¦Ø²',0),(271520,7543,'sr','ÐÐ°Ð´Ñ€ÐµÑ’ÐµÐ½Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð°',0),(271521,7543,'vi','Cá»¡ cha máº¹',0),(271522,7543,'af','Hoof Grootte',0),(271523,7543,'ro','Dimensiunea de mamÄƒ',0),(271524,7543,'et','Vanem suurus',0),(271525,7543,'si','Velikost starÅ¡ev',0),(271526,7543,'ba','Ukuran induk',0),(271527,7543,'nl','Bovenliggende grootte',0),(271528,7543,'fi','Vanhempi pinta',0),(271529,7543,'no','Overordnede stÃ¸rrelse',0),(271530,7543,'da','Overordnede stÃ¸rrelse',0),(271531,7543,'ko','ë¶€ëª¨ í¬ê¸°',0),(271532,7543,'he','×’×•×“×œ ××‘',0),(271533,7543,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Ï„Î¿Ï… Î³Î¿Î½Î­Î±',0),(271534,7543,'zh','çˆ¶å¯¹è±¡å°ºå¯¸\r\n',0),(271535,7543,'sv','Ã–verordnade storlek',0),(271536,7543,'it','Dimensione del genitore',0),(271537,7543,'tl','',0),(271538,7543,'th','&#3586;&#3609;&#3634;&#3604;&#3627;&#3621;&#3633;&#3585;',0),(271539,7543,'hi','à¤®à¤¾à¤¤à¤¾ à¤ªà¤¿à¤¤à¤¾ à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(271540,7543,'ms','Saiz induk',0),(271541,7543,'ar','Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ø£ØµÙ„ÙŠ',0),(271542,7543,'fr','Taille de la mÃ¨re',0),(271543,7543,'jp','è¦ªã®ã‚µã‚¤ã‚º',0),(271544,7543,'pt','Tamanho do pai',0),(271545,7543,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ñ€Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ð³Ð¾',0),(271546,7543,'es','TamaÃ±o de Maestro',0),(271547,7543,'de','Ãœbergeordnete GrÃ¶ÃŸe',0),(271548,7543,'en','Parent Size',0),(271549,7544,'is','',0),(271550,7544,'dr','ØªØºÙŠÙŠØ± ÙˆØ¶Ø¹ÙŠØª Ø¨Ù‡ ',0),(271551,7544,'pr','ØªØºÙŠÙŠØ± ÙˆØ¶Ø¹ÙŠØª Ø¨Ù‡ ',0),(271552,7544,'tr','Durumunu deÄŸiÅŸtir',0),(271553,7544,'pl','Zmiana statusu',0),(271554,7544,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð°',0),(271555,7544,'ur','Ø­Ø§Ù„Øª Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(271556,7544,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð·Ð°',0),(271557,7544,'vi','Thay Ä‘á»•i tÃ¬nh tráº¡ng tá»›i',0),(271558,7544,'af','Verander Status Na',0),(271559,7544,'ro','Schimba statutul de',0),(271560,7544,'et','Muuda olekut',0),(271561,7544,'si','Spremeni stanje za',0),(271562,7544,'ba','Mengubah Status untuk',0),(271563,7544,'nl','Status te wijzigen',0),(271564,7544,'fi','Muuta tilaksi',0),(271565,7544,'no','Endre statusen til',0),(271566,7544,'da','Skift Status til',0),(271567,7544,'ko','ë³€ê²½ ìƒíƒœë¥¼',0),(271568,7544,'he','×©×™× ×•×™ ×¡×˜×˜×•×¡ ×›×“×™',0),(271569,7544,'el','Î‘Î»Î»Î±Î³Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î½Î±',0),(271570,7544,'zh','æ”¹å˜çŽ°åˆ°çŠ¶\r\n',0),(271571,7544,'sv','Ã„ndra Status till',0),(271572,7544,'it','Modificare lo stato di',0),(271573,7544,'tl','',0),(271574,7544,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3626;&#3606;&#3634;&#3609;&#3632;&#3652;&#3611;&#3626;&#3641;&#3656;',0),(271575,7544,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(271576,7544,'ms','Menukar Status kepada',0),(271577,7544,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø­Ø§Ù„Ø© Ø¥Ù„Ù‰',0),(271578,7544,'fr','Modifier le statut de',0),(271579,7544,'jp','ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(271580,7544,'pt','Alterar o Status para',0),(271581,7544,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(271582,7544,'es','Cambiar Status A',0),(271583,7544,'de','Status zu Ã¤ndern',0),(271584,7544,'en','Change Status To',0),(271585,7545,'is','',0),(271586,7545,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙˆØ¶Ø¹ÙŠØª Ù†ÙŠØ§Ø²Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(271587,7545,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙˆØ¶Ø¹ÙŠØª Ù†ÙŠØ§Ø²Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(271588,7545,'tr','Stok ihtiyaÃ§larÄ±nÄ±-durumu gÃ¼ncelle',0),(271589,7545,'pl','Aktualizacja potrzeb stan zapasÃ³w',0),(271590,7545,'bg','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ð° Ð½ÑƒÐ¶Ð´Ð¸-ÑÑ‚Ð°Ñ‚ÑƒÑ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(271591,7545,'ur','Ø§Ø³Ù¹Ø§Ú© Ø¶Ø±ÙˆØ±ÛŒØ§Øª Ú©ÛŒ Ø­Ø§Ù„Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(271592,7545,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°Ð¼Ð°-Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(271593,7545,'vi','Cáº­p nháº­t tÃ¬nh tráº¡ng cáº§n thiáº¿t cá»§a hÃ ng tá»“n kho',0),(271594,7545,'af','Voorraad Benodig-Status Opdateer',0),(271595,7545,'ro','Nevoile stoc-starea de actualizare',0),(271596,7545,'et','Varude vajadusi-oleku vÃ¤rskendus',0),(271597,7545,'si','Osnovne potrebe-Status Update',0),(271598,7545,'ba','Saham kebutuhan-Status Update',0),(271599,7545,'nl','Voorraad behoeften-Status Update',0),(271600,7545,'fi','Varastotilanne tarpeiden pÃ¤ivitys',0),(271601,7545,'no','Lager behov-statusoppdatering',0),(271602,7545,'da','Lager behov-Status opdatering',0),(271603,7545,'ko','ìž¬ê³  ìš”êµ¬ ìƒíƒœ ì—…ë°ì´íŠ¸',0),(271604,7545,'he','×¢×“×›×•×Ÿ ×”×¦×¨×›×™×-×ž×¦×‘ ×ž×œ××™',0),(271605,7545,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î±Î½Î¬Î³ÎºÎµÏ‚',0),(271606,7545,'zh','åº“å­˜éœ€æ±‚ï¼ŒçŠ¶æ€æ›´æ–°\r\n',0),(271607,7545,'sv','Lager behov-Status Update',0),(271608,7545,'it','Dipinga esigenze-Status Update',0),(271609,7545,'tl','',0),(271610,7545,'th','&#3626;&#3605;&#3658;&#3629;&#3588;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3606;&#3634;&#3609;&#3632;',0),(271611,7545,'hi','à¤¶à¥‡à¤¯à¤° à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥ˆ-à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(271612,7545,'ms','Keperluan-Status stok Kemaskini',0),(271613,7545,'ar','ØªØ­Ø¯ÙŠØ« Ø­Ø§Ù„Ø© Ø§Ù„Ø§Ø­ØªÙŠØ§Ø¬Ø§Øª Ø§Ù„Ø£Ø±ØµØ¯Ø©',0),(271614,7545,'fr','Mise Ã  jour des besoins-l\'Ã©tat du stock',0),(271615,7545,'jp','åœ¨åº«ã®ãƒ‹ãƒ¼ã‚º-ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã®æ›´æ–°',0),(271616,7545,'pt','Necessidades de estoque-Status Update',0),(271617,7545,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ñ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ÑÑ‚Ð¸',0),(271618,7545,'es','Necesidades de Stock-Actualizar Status',0),(271619,7545,'de','Lagerstatus BedÃ¼rfnisse-Update',0),(271620,7545,'en','Stock Needs-Status Update',0),(271621,7546,'is','',0),(271622,7546,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§Ø² ÙŠØ§Ø¨ÙŠ Ø´Ø¯Ù‡',0),(271623,7546,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¨Ø§Ø² ÙŠØ§Ø¨ÙŠ Ø´Ø¯Ù‡',0),(271624,7546,'tr','EriÅŸim tarihi alÄ±ntÄ±',0),(271625,7546,'pl','Cytat Å¹rÃ³dÅ‚o',0),(271626,7546,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ñ‚Ðµ',0),(271627,7546,'ur','Ù…ØªØ¹Ù„Ù‚Û Ø§Ù‚ØªØ¨Ø§Ø³',0),(271628,7546,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ðµ',0),(271629,7546,'vi','Truy váº¥n BÃ¡o giÃ¡ ',0),(271630,7546,'af','Kwotasie Herwin',0),(271631,7546,'ro','Citat Adus',0),(271632,7546,'et','Tsitaat vÃ¤lja otsitud',0),(271633,7546,'si','Citiram Retrieved',0),(271634,7546,'ba','Mengutip Diperoleh',0),(271635,7546,'nl','Offerte ontvangen',0),(271636,7546,'fi','Lainaus Haettu',0),(271637,7546,'no','Sitere Hentet',0),(271638,7546,'da','Citat hentet',0),(271639,7546,'ko','ê²€ìƒ‰ ì¸ìš©',0),(271640,7546,'he','×œ×¦×˜×˜ ×”×ž××•×—×–×¨×™×',0),(271641,7546,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Î±Î½Î±ÎºÏ„Î®Î¸Î·ÎºÎµ',0),(271642,7546,'zh','æŠ¥ä»·æ£€ç´¢\r\n\r\n',0),(271643,7546,'sv','Citera HÃ¤mtad',0),(271644,7546,'it','Cito Estratto',0),(271645,7546,'tl','',0),(271646,7546,'th','&#3649;&#3592;&#3657;&#3591;&#3585;&#3634;&#3619;&#3615;&#3639;&#3657;&#3609;&#3615;&#3641;',0),(271647,7546,'hi','à¤…à¤­à¤¿à¤—à¤®à¤¨ à¤¤à¤¿à¤¥à¤¿: à¤¬à¥‹à¤²à¥€',0),(271648,7546,'ms','Quote Diambil',0),(271649,7546,'ar','Ø§Ù‚ØªØ¨Ø³ Ø§Ù„Ù…Ø³ØªØ±Ø¯Ø©',0),(271650,7546,'fr','Citation RÃ©cupÃ©rÃ©e',0),(271651,7546,'jp','å–å¾—ã‚’å¼•ç”¨ã—ã¾ã™ã€‚',0),(271652,7546,'pt','CitaÃ§Ã£o Obtida',0),(271653,7546,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€ÑƒÑŽ ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¾',0),(271654,7546,'es','CotizaciÃ³n Recuperada',0),(271655,7546,'de','Zitat von',0),(271656,7546,'en','Quote Retrieved',0),(271657,7547,'is','',0),(271658,7547,'dr','Ø¯Ø±ØµØ¯ Ø³Ø±Ø¨Ø§Ø± ',0),(271659,7547,'pr','Ø¯Ø±ØµØ¯ Ø³Ø±Ø¨Ø§Ø± ',0),(271660,7547,'tr','Genel gider yÃ¼zde',0),(271661,7547,'pl','Procent ogÃ³lnych',0),(271662,7547,'bg','ÐÐ°Ð´ ÑÑ‚Ð¾',0),(271663,7547,'ur','ÛÛŒÚˆ ÙÛŒØµØ¯',0),(271664,7547,'sr','% Ð˜Ð½Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(271665,7547,'vi','& HÃ nh chÃ­nh Sá»± nghiá»‡p',0),(271666,7547,'af','Oorhoofse Persentasie',0),(271667,7547,'ro','Aeriene la sutÄƒ',0),(271668,7547,'et','Ã•huliini protsenti',0),(271669,7547,'si','ReÅ¾ijske odstotkov',0),(271670,7547,'ba','Overhead persen',0),(271671,7547,'nl','Overhead procent',0),(271672,7547,'fi','Yleiskustannusten prosenttia',0),(271673,7547,'no','Overhead prosent',0),(271674,7547,'da','Overhead procent',0),(271675,7547,'ko','ì˜¤ë²„ í—¤ë“œ %',0),(271676,7547,'he','××—×•×– ×ª×§×•×¨×”',0),(271677,7547,'el','Î“ÎµÎ½Î¹ÎºÎ¬ Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(271678,7547,'zh','é—´æŽ¥è´¹ç”¨ç™¾åˆ†æ¯”\r\n',0),(271679,7547,'sv','Overhead procent',0),(271680,7547,'it','Basculante per cento',0),(271681,7547,'tl','',0),(271682,7547,'th','&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;&#3586;&#3629;&#3591;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3651;&#3609;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;',0),(271683,7547,'hi','à¤‰à¤ªà¤°à¤¿ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(271684,7547,'ms','Overhed peratus',0),(271685,7547,'ar','Ø§Ù„Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø© Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(271686,7547,'fr','Pourcentage de frais gÃ©nÃ©raux',0),(271687,7547,'jp','ã‚ªãƒ¼ãƒãƒ¼ãƒ˜ãƒƒãƒ‰ã®ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ',0),(271688,7547,'pt','Sobrecarga por cento',0),(271689,7547,'ru','ÐÐ°ÐºÐ»Ð°Ð´Ð½Ñ‹Ðµ %',0),(271690,7547,'es','Porcentaje de Costos Operativos',0),(271691,7547,'de','Obenliegende Prozent',0),(271692,7547,'en','Overhead Percent',0),(271693,7548,'is','',0),(271694,7548,'dr','(Ø­ÙˆØ§Ù„Ù‡) ÙØ±Ù…Ø§ÛŒØ´',0),(271695,7548,'pr','ØªØ¹ÙŠÙŠÙ† (Ø­ÙˆØ§Ù„Ù‡) Ø³ÙØ§Ø±Ø´',0),(271696,7548,'tr','SipariÅŸ atama',0),(271697,7548,'pl','Przypisywanie zamÃ³wienia',0),(271698,7548,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´',0),(271699,7548,'ur','ØªØ±ØªÛŒØ¨ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(271700,7548,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(271701,7548,'vi','Chá»‰ Äá»‹nh ÄÆ¡n Äáº·t HÃ ng',0),(271702,7548,'af','Bestelling Toestaan',0),(271703,7548,'ro','Asocia comanda',0),(271704,7548,'et','MÃ¤Ã¤rake tellimuse',0),(271705,7548,'si','Dodeljevanje nalog',0),(271706,7548,'ba','Menetapkan urutan',0),(271707,7548,'nl','Aan Order toewijzen',0),(271708,7548,'fi','MÃ¤Ã¤ritÃ¤ tilauksen',0),(271709,7548,'no','Tilordne rekkefÃ¸lgen',0),(271710,7548,'da','Tildele ordre',0),(271711,7548,'ko','ìˆœì„œ ì§€ì •',0),(271712,7548,'he','×œ×”×§×¦×•×ª ×¡×“×¨',0),(271713,7548,'el','Î•ÎºÏ‡ÏŽÏÎ·ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(271714,7548,'zh','æŒ‡å®šè®¢å•\r\n',0),(271715,7548,'sv','Tilldela ordning',0),(271716,7548,'it','Assegnare l\'ordine',0),(271717,7548,'tl','',0),(271718,7548,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(271719,7548,'hi','à¤†à¤¦à¥‡à¤¶ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(271720,7548,'ms','Peruntukan perintah',0),(271721,7548,'ar','ØªØ¹ÙŠÙŠÙ† ØªØ±ØªÙŠØ¨',0),(271722,7548,'fr','Attribuer l\'ordre',0),(271723,7548,'jp','é †åºã‚’å‰²ã‚Šå½“ã¦ã‚‹',0),(271724,7548,'pt','Atribuir a ordem',0),(271725,7548,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(271726,7548,'es','Asignar Pedido',0),(271727,7548,'de','Reihenfolge zuweisen',0),(271728,7548,'en','Assign Order',0),(271729,7549,'is','',0),(271730,7549,'dr','Ù‡ÙŠÚ† Ø²Ù…Ø§Ù†ÙŠ Ø±ÙˆÙŠ Ø¨Ù„ÙŠØ·',0),(271731,7549,'pr','Ù‡ÙŠÚ† Ø²Ù…Ø§Ù†ÙŠ Ø±ÙˆÙŠ Ø¨Ù„ÙŠØ·',0),(271732,7549,'tr','HiÃ§bir zaman bilet Ã¼zerinde',0),(271733,7549,'pl','Nie ma czasu na bilet',0),(271734,7549,'bg','ÐÑÐ¼Ð° Ð²Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð±Ð¸Ð»ÐµÑ‚',0),(271735,7549,'ur','Ú©ÙˆØ¦ÛŒ ÙˆÙ‚Øª Ù¾Ø± Ù¹Ú©Ù¹',0),(271736,7549,'sr','ÐÐµÐ¼Ð°Ð¼Ð¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸',0),(271737,7549,'vi','KhÃ´ng cÃ³ thá»i gian trÃªn vÃ©',0),(271738,7549,'af','Geen Tyd Op Kaartjie',0),(271739,7549,'ro','Nici un moment pe bilet',0),(271740,7549,'et','Ei aja pilet',0),(271741,7549,'si','Brez Äasa na vozovnice',0),(271742,7549,'ba','Ada waktu pada tiket',0),(271743,7549,'nl','Geen tijd op Ticket',0),(271744,7549,'fi','Ei ole aikaa lippu',0),(271745,7549,'no','Ingen tid pÃ¥ billett',0),(271746,7549,'da','Ingen tid pÃ¥ billet',0),(271747,7549,'ko','í‹°ì¼“ ì‹œê°„',0),(271748,7549,'he','××™×Ÿ ×–×ž×Ÿ ×¢×œ ×”×›×¨×˜×™×¡',0),(271749,7549,'el','ÎšÎ±Î½Î­Î½Î±Î½ Ï‡ÏÏŒÎ½Î¿ Î³Î¹Î± ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(271750,7549,'zh','ç¥¨ä¸Šæ— æ—¶é—´\r\n',0),(271751,7549,'sv','Ingen tid pÃ¥ biljett',0),(271752,7549,'it','Nessun tempo sul biglietto',0),(271753,7549,'tl','',0),(271754,7549,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3648;&#3623;&#3621;&#3634;&#3610;&#3609;&#3605;&#3633;&#3659;&#3623;',0),(271755,7549,'hi','à¤•à¥‹à¤ˆ à¤¸à¤®à¤¯ à¤•à¥‡ à¤Ÿà¤¿à¤•à¤Ÿ à¤ªà¤°',0),(271756,7549,'ms','Masa yang singkat atas Tiket',0),(271757,7549,'ar','Ø£ÙŠ ÙˆÙ‚Øª Ù…Ù† Ø§Ù„Ø£ÙˆÙ‚Ø§Øª Ø¹Ù„Ù‰ Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(271758,7549,'fr','Pas de temps sur le billet',0),(271759,7549,'jp','èˆªç©ºåˆ¸ã«æ™‚é–“ãŒãªã„ã§ã™ã€‚',0),(271760,7549,'pt','NÃ£o hÃ¡ tempo no bilhete',0),(271761,7549,'ru','ÐÐµÑ‚ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð½Ð° Ð±Ð¸Ð»ÐµÑ‚Ðµ',0),(271762,7549,'es','No Hay Tiempo En El Boleto',0),(271763,7549,'de','Keine Zeit auf Ticket',0),(271764,7549,'en','No Time On Ticket',0),(271765,7550,'is','',0),(271766,7550,'dr','(Ø¶Ø§ÙŠØ¹Ø§Øª Ù…ÙˆØ§Ø¯) ÙƒØ§ØºØ°-  ÙÛŒØµØ¯ Ø³Ø±ÙŠ Ø¶Ø§ÙŠØ¹Ø§Øª Ù…ÙˆØ§Ø¯',0),(271767,7550,'pr','Ø¨Ø±ÙŠØ¯Ù‡(Ø¶Ø§ÙŠØ¹Ø§Øª Ù…ÙˆØ§Ø¯) ÙƒØ§ØºØ°-  Ø¯Ø±ØµØ¯ Ø³Ø±ÙŠ Ø¶Ø§ÙŠØ¹Ø§Øª Ù…ÙˆØ§Ø¯',0),(271768,7550,'tr','Hurda kaÄŸÄ±t hurda yÃ¼zdesini Ã§alÄ±ÅŸtÄ±rmak',0),(271769,7550,'pl','Papier Scrap procent uruchomiÄ‡ zÅ‚om',0),(271770,7550,'bg','Ð¥Ð°Ñ€Ñ‚Ð¸Ñ ÑÐºÑ€Ð°Ð¿-Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ð¾ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ ÑÐºÑ€Ð°Ð¿',0),(271771,7550,'ur','Ú©Ø§ØºØ° Ø³Ú©Ø±ÛŒÙ¾ ÙÛŒØµØ¯ Ø³Ú©Ø±ÛŒÙ¾ Ú†Ù„Øª Ú©Ø±ÛŒÚº',0),(271772,7550,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ ÑˆÐºÐ°Ñ€Ñ‚Ð° Ð¿Ð°Ð¿Ð¸Ñ€Ð° Ð¿Ð¾ÐºÑ€ÐµÐ½ÑƒÑ‚Ð¸ ÑˆÐºÐ°Ñ€Ñ‚Ð°',0),(271773,7550,'vi','% giáº¥y pháº¿ liá»‡u',0),(271774,7550,'af','Papier knipsel-persent loop knipsel',0),(271775,7550,'ro','Resturi de hÃ¢rtie-procente rula resturi',0),(271776,7550,'et','Raamatu kaoprotsenti kÃ¤ivitada kao',0),(271777,7550,'si','Odstotek izmeta papir teÄi ostanki',0),(271778,7550,'ba','Kertas memo-persen menjalankan Scrap',0),(271779,7550,'nl','Papier schroot-procent uitvoeren schroot',0),(271780,7550,'fi','Paperi hukkaprosentti suorittaa romu',0),(271781,7550,'no','Papir svinnprosenten kjÃ¸re skrap',0),(271782,7550,'da','Papir skrot-procent kÃ¸re skrot',0),(271783,7550,'ko','ì¢…ì´ ìŠ¤í¬ëž© í¼ì„¼íŠ¸ ìŠ¤í¬ëž© ì‹¤í–‰',0),(271784,7550,'he','× ×™×™×¨ ×’×¨×•×˜××•×ª-××—×•×– ×œ×¨×•×¥ ×’×¨×•×˜××•×ª',0),(271785,7550,'el','Î§Î±ÏÏ„Î¯ Î¸ÏÎ±ÏÏƒÎ¼Î±Ï„Î±-Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï„ÏÎ­Î¾ÎµÎ¹ Î¸ÏÎ±ÏÏƒÎ¼Î±Ï„Î±',0),(271786,7550,'zh','åºŸçº¸-ç™¾åˆ†æ¯”è¿è¡ŒåºŸæ–™\r\n',0),(271787,7550,'sv','Papper-kassationsprocent kÃ¶ra skrot',0),(271788,7550,'it','Percentuale di scarti carta eseguire rottami',0),(271789,7550,'tl','',0),(271790,7550,'th','Paper Scrap-Percent Run Scrap',0),(271791,7550,'hi','à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª à¤•à¤¾à¤—à¤œ à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª-à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤šà¤²à¤¾à¤à¤',0),(271792,7550,'ms','Kertas sekerap-peratus dijalankan sekerap',0),(271793,7550,'ar','ØªØ´ØºÙŠÙ„ Ø§Ù„ÙˆØ±Ù‚ Ø§Ù„Ø®Ø±Ø¯Ø© Ø¨Ø§Ù„Ù…Ø¦Ø© Ø§Ù„Ø®Ø±Ø¯Ø©',0),(271794,7550,'fr','Papier-pourcentage de rebut exÃ©cute Scrap',0),(271795,7550,'jp','ç´™ã®ã‚¹ã‚¯ãƒ©ãƒƒãƒ—-ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆå®Ÿè¡Œã‚¹ã‚¯ãƒ©ãƒƒãƒ—',0),(271796,7550,'pt','Papel Scrap-por cento executar sucata',0),(271797,7550,'ru','Ð‘ÑƒÐ¼Ð°Ð³Ð¸ Ð»Ð¾Ð¼Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð»Ð¾Ð¼Ð°',0),(271798,7550,'es','Papel Por Ciento de Desechos Corrida de Desechos',0),(271799,7550,'de','Papier Scrap-Prozent fÃ¼hren Schrott',0),(271800,7550,'en','Paper Scrap-Percent Run Scrap',0),(271801,7551,'is','',0),(271802,7551,'dr','ØªÙƒÙ‡ Ù‡Ø§ÙŠ Ø¨Ø±ÙŠØ¯Ù‡ ÙƒØ§ØºØ° Ø¯Ø± Ù‡Ø± ØµÙØ­Ù‡ Ø±Ø§ Ú†Ø§Ù¾ ÙƒÙ†ÙŠØ¯',0),(271803,7551,'pr','ØªÙƒÙ‡ Ù‡Ø§ÙŠ Ø¨Ø±ÙŠØ¯Ù‡ ÙƒØ§ØºØ° Ø¯Ø± Ù‡Ø± ØµÙØ­Ù‡ Ø±Ø§ Ú†Ø§Ù¾ ÙƒÙ†ÙŠØ¯',0),(271804,7551,'tr','KaÄŸÄ±t-hurda plaka / basÄ±n',0),(271805,7551,'pl','NaciÅ›nij papier zÅ‚om na pÅ‚ytkÄ™',0),(271806,7551,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ñ…Ð°Ñ€Ñ‚Ð¸Ñ-ÑÐºÑ€Ð°Ð¿ / Ð¿ÐµÑ‚Ñ€Ð¸ÐµÐ²Ð° Ð¿Ð°Ð½Ð¸Ñ‡ÐºÐ°',0),(271807,7551,'ur','Ú©Ø§ØºØ° Ø³Ú©Ø±ÛŒÙ¾ Ù¾Ù„ÛŒÙ¹ ÙÛŒ Ø¯Ø¨Ø§Ø¦ÛŒÚº',0),(271808,7551,'sr','ÐŸÑ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ Ð¿Ð°Ð¿Ð¸Ñ€-ÑˆÐºÐ°Ñ€Ñ‚Ð° Ð¿Ð¾ Ñ‚Ð°ÑšÐ¸Ñ€Ñƒ',0),(271809,7551,'vi','Giáº¥y bÃ¡o pháº¿ liá»‡u má»—i Ä‘Ä©a',0),(271810,7551,'af','Druk die papier-knipsel per bord',0),(271811,7551,'ro','Resturi de hÃ¢rtie per placÄƒ de presÄƒ',0),(271812,7551,'et','Vajutage paberi-jÃ¤Ã¤gid plaadi kohta',0),(271813,7551,'si','Pritisnite papirja ostanki na ploÅ¡Äo',0),(271814,7551,'ba','Tekan kertas-memo per piring',0),(271815,7551,'nl','Druk op papier-uitval per plaat',0),(271816,7551,'fi','Paina Paper-romu maljaa kohti',0),(271817,7551,'no','Trykk papir skrap per Plate',0),(271818,7551,'da','Tryk pÃ¥ papir-skrot pr. plade',0),(271819,7551,'ko','ì ‘ì‹œ ë‹¹ ë³´ë„ ì¢…ì´ ìŠ¤í¬ëž©',0),(271820,7551,'he','×”×§×© ×¢×œ × ×™×™×¨-×’×¨×•×˜××•×ª ×œ×›×œ ×¦×œ×—×ª',0),(271821,7551,'el','Î§Î±ÏÏ„Î¯ Ï„ÏÏ€Î¿Ï…-Î¸ÏÎ±ÏÏƒÎ¼Î±Ï„Î± Î±Î½Î¬ Ï€Î»Î¬ÎºÎ±',0),(271822,7551,'zh','æŒ‰çº¸åºŸæ–™æ¯å›¾ç‰ˆ\r\n',0),(271823,7551,'sv','Tryck pÃ¥ papper-skrot per platta',0),(271824,7551,'it','Stampa di carta-scarto per piastra',0),(271825,7551,'tl','',0),(271826,7551,'th','&#3585;&#3604;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3594;&#3636;&#3657;&#3609;&#3648;&#3621;&#3655;&#3585; &#3654; &#3605;&#3656;&#3629;&#3616;&#3634;&#3614;&#3607;&#3637;&#3656;&#3614;&#3636;&#3617;&#3614;&#3660;&#3629;&#3629;&#3585;&#3617;&#3634;',0),(271827,7551,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤ªà¥‡à¤ªà¤° à¤ªà¥à¤²à¥‡à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿ à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª',0),(271828,7551,'ms','Tekan kertas sekerap setiap plat',0),(271829,7551,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ ÙˆØ±Ù‚Ø©-Ø§Ù„Ø®Ø±Ø¯Ø© Ù„Ù„ÙˆØ­Ø© Ø§Ù„ÙˆØ§Ø­Ø¯Ø©',0),(271830,7551,'fr','Presse papier-Scrap par plaque',0),(271831,7551,'jp','ãƒ—ãƒ¬ãƒ¼ãƒˆã”ã¨ãƒ—ãƒ¬ã‚¹ç´™ã‚¹ã‚¯ãƒ©ãƒƒãƒ—',0),(271832,7551,'pt','Papel de imprensa-sucata por placa',0),(271833,7551,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° Ð¿Ð»Ð°ÑÑ‚Ð¸Ð½Ñƒ-Ð¼Ð°ÐºÑƒÐ»Ð°Ñ‚ÑƒÑ€Ð°',0),(271834,7551,'es','Prensa Papel-Desechas por Placa',0),(271835,7551,'de','Presse-Papier-StÃ¼ckchen pro Platte',0),(271836,7551,'en','Press Paper-Scrap per Plate',0),(271837,7552,'is','',0),(271838,7552,'dr','( Ù…Ø¬ÙˆØ±Ø² Ø¹Ø¨ÙˆØ±',0),(271839,7552,'pr','Ø³ÙØ§Ø±Ø´ Ù†Ù…Ø§ÙŠØ´ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø¨Ù„ÙŠØ· Ù‡Ø§ ( Ù…Ø¬ÙˆØ±Ø² Ø¹Ø¨ÙˆØ±',0),(271840,7552,'tr','Bilet iÃ§in aile gÃ¶rÃ¼ntÃ¼leme sÄ±rasÄ±',0),(271841,7552,'pl','KolejnoÅ›Ä‡ wyÅ›wietlania rodziny za bilety',0),(271842,7552,'bg','Ð¡ÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾ Ð´Ð¸ÑÐ¿Ð»ÐµÐ¹ Ñ€ÐµÐ´ Ð·Ð° Ð±Ð¸Ð»ÐµÑ‚Ð¸',0),(271843,7552,'ur','Ù¹Ú©Ù¹ Ú©Û’ Ù„Ø¦Û’ Ø®Ø§Ù†Ø¯Ø§Ù† ÚˆØ³Ù¾Ù„Û’ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(271844,7552,'sr','ÐŸÐ¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð·Ð° ÐºÐ°Ñ€Ñ‚Ðµ',0),(271845,7552,'vi','Hiá»ƒn thá»‹ ÄÆ¡n Ä‘áº·t hÃ ng gia Ä‘Ã¬nh cho vÃ©',0),(271846,7552,'af','Gesin vertoon orde vir kaartjies',0),(271847,7552,'ro','Ordinea de afiÅŸare familie pentru bilete',0),(271848,7552,'et','KuvamisjÃ¤rjestust pere piletid',0),(271849,7552,'si','Vrstni red druÅ¾inski prikaza za vstopnice',0),(271850,7552,'ba','Urutan tampilan keluarga untuk tiket',0),(271851,7552,'nl','Familie Weergavevolgorde voor Tickets',0),(271852,7552,'fi','Heimo nÃ¤yttÃ¶jÃ¤rjestyksen liput',0),(271853,7552,'no','Familie visningsrekkefÃ¸lgen for billetter',0),(271854,7552,'da','Familie visningsrÃ¦kkefÃ¸lgen for billetter',0),(271855,7552,'ko','í‹°ì¼“ì— ëŒ€ í•œ ê°€ì¡± í‘œì‹œ ìˆœì„œ',0),(271856,7552,'he','×¡×“×¨ ×”×ª×¦×•×’×” ×”×ž×©×¤×—×” ×›×¨×˜×™×¡×™×',0),(271857,7552,'el','Î£ÎµÎ¹ÏÎ¬ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î± ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î±',0),(271858,7552,'zh','å®¶åº­è´­ç¥¨æ˜¾ç¤ºé¡ºåº\r\n',0),(271859,7552,'sv','Familjen visningsordning fÃ¶r biljetter',0),(271860,7552,'it','Ordine di visualizzazione di famiglia per i biglietti',0),(271861,7552,'tl','',0),(271862,7552,'th','&#3649;&#3626;&#3604;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3633;&#3659;&#3623;&#3586;&#3629;&#3591;&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3633;&#3623;',0),(271863,7552,'hi','à¤Ÿà¤¿à¤•à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤°à¤¿à¤µà¤¾à¤°à¤¿à¤• à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¥à¤°à¤®',0),(271864,7552,'ms','Susunan paparan keluarga Tiket',0),(271865,7552,'ar','ØªØ±ØªÙŠØ¨ Ø¹Ø±Ø¶ Ø§Ù„Ø¹Ø§Ø¦Ù„Ø© Ù„ØªØ°Ø§ÙƒØ± Ø§Ù„Ø³ÙØ±',0),(271866,7552,'fr','Ordre d\'affichage familial pour les billets',0),(271867,7552,'jp','ãƒã‚±ãƒƒãƒˆã®å®¶æ—ã®è¡¨ç¤ºé †åº',0),(271868,7552,'pt','Ordem de exibiÃ§Ã£o familiar para bilhetes',0),(271869,7552,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ Ð¡ÐµÐ¼ÐµÐ¹Ð½Ñ‹Ðµ Ð±Ð¸Ð»ÐµÑ‚Ñ‹',0),(271870,7552,'es','Orden de Desplega de Familia para Boletos',0),(271871,7552,'de','Familie Anzeigereihenfolge fÃ¼r Tickets',0),(271872,7552,'en','Family Display Order for Tickets',0),(271873,7553,'is','',0),(271874,7553,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(271875,7553,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(271876,7553,'tr','Kaliper stok',0),(271877,7553,'pl','Zacisk zapasÃ³w',0),(271878,7553,'bg','Ð¨ÑƒÐ±Ð»ÐµÑ€ ÑÑŠÑÑ‚Ð°Ð²',0),(271879,7553,'ur','Ø§Ø³Ù¹Ø§Ú© Ú©Û’ ÛÙˆØªÛ’ ÛÛŒÚº',0),(271880,7553,'sr','Ð¦Ð°Ð»Ð¸Ð¿ÐµÑ€ Ð°ÐºÑ†Ð¸Ñ˜Ð°',0),(271881,7553,'vi','Com-pa cá»§a hÃ ng tá»“n',0),(271882,7553,'af','Caliper van voorraad',0),(271883,7553,'ro','Caliper de stoc',0),(271884,7553,'et','Nihikuga Stock',0),(271885,7553,'si','Kljunasto merilo zalog',0),(271886,7553,'ba','Caliper saham',0),(271887,7553,'nl','Remklauw van voorraad',0),(271888,7553,'fi','Paksuus on varastossa',0),(271889,7553,'no','Tykkelse pÃ¥ lager',0),(271890,7553,'da','Caliper af materiel',0),(271891,7553,'ko','ìž¬ê³  ìº˜ë¦¬í¼ìŠ¤',0),(271892,7553,'he','×§×œ×™×‘×¨ ×©×œ ×ž× ×™×•×ª',0),(271893,7553,'el','Î”Î±Î³ÎºÎ¬Î½Î± Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(271894,7553,'zh','å¡å°ºè‚¡ç¥¨\r\n',0),(271895,7553,'sv','Bromsok av materiel',0),(271896,7553,'it','Pinza di Stock',0),(271897,7553,'tl','',0),(271898,7553,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629;&#3623;&#3633;&#3604;&#3586;&#3609;&#3634;&#3604;&#3586;&#3629;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3651;&#3609;&#3626;&#3605;&#3655;&#3629;&#3585;',0),(271899,7553,'hi','à¤•à¥ˆà¤²à¤¿à¤ªà¤° à¤•à¥‡ à¤¶à¥‡à¤¯à¤°',0),(271900,7553,'ms','Caliper stok',0),(271901,7553,'ar','Ù‚Ø¯Ù…Ù‡ Ø°Ø§Øª Ø§Ù„ÙˆØ±Ù†ÙŠÙ‘Ø© Ù„Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(271902,7553,'fr','Ã‰trier de Stock',0),(271903,7553,'jp','åœ¨åº«ã®ã‚­ãƒ£ãƒªãƒ‘ãƒ¼',0),(271904,7553,'pt','Compasso de calibre de estoque',0),(271905,7553,'ru','Ð¡ÑƒÐ¿Ð¿Ð¾Ñ€Ñ‚ Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(271906,7553,'es','Calibrador de Stock',0),(271907,7553,'de','Bremssattel der Aktie',0),(271908,7553,'en','Caliper of Stock',0),(271909,7554,'is','',0),(271910,7554,'dr','Ù…Ø¯Øª  ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ ',0),(271911,7554,'pr','Ù…Ø¯Øª  ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ ',0),(271912,7554,'tr','BitmiÅŸ uzunluÄŸu',0),(271913,7554,'pl','DÅ‚ugoÅ›Ä‡ gotowego',0),(271914,7554,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐ¸ Ð´ÑŠÐ»Ð¶Ð¸Ð½Ð°',0),(271915,7554,'ur','ØªÚ©Ù…ÛŒÙ„ Ø´Ø¯Û Ù„Ù…Ø¨Ø§Ø¦ÛŒ',0),(271916,7554,'sr','Ð”ÑƒÐ¶Ð¸Ð½Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ñ…',0),(271917,7554,'vi','Chiá»u dÃ i Káº¿t thÃºc',0),(271918,7554,'af','Voltooide lengte',0),(271919,7554,'ro','Finite lungime',0),(271920,7554,'et','LÃµpetanud pikkus',0),(271921,7554,'si','KonÄni dolÅ¾ina',0),(271922,7554,'ba','Selesai panjang',0),(271923,7554,'nl','Afgewerkte lengte',0),(271924,7554,'fi','Valmis pituus',0),(271925,7554,'no','Ferdig lengde',0),(271926,7554,'da','FÃ¦rdig lÃ¦ngde',0),(271927,7554,'ko','ì™„ì„± ëœ ê¸¸ì´',0),(271928,7554,'he','××•×¨×š ×¡×™×™×',0),(271929,7554,'el','Î¤ÎµÎ»Î¹ÎºÏŒ Î¼Î®ÎºÎ¿Ï‚',0),(271930,7554,'zh','æˆå“é•¿åº¦\r\n',0),(271931,7554,'sv','FÃ¤rdig lÃ¤ngd',0),(271932,7554,'it','Lunghezza finita',0),(271933,7554,'tl','',0),(271934,7554,'th','&#3588;&#3623;&#3634;&#3617;&#3618;&#3634;&#3623;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(271935,7554,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤²à¤‚à¤¬à¤¾à¤ˆ',0),(271936,7554,'ms','Tempoh siap',0),(271937,7554,'ar','Ø·ÙˆÙ„ Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(271938,7554,'fr','Longueur finie',0),(271939,7554,'jp','å®Œæˆã—ãŸé•·ã•',0),(271940,7554,'pt','Comprimento acabado',0),(271941,7554,'ru','Ð“Ð¾Ñ‚Ð¾Ð²Ð°Ñ Ð´Ð»Ð¸Ð½Ð°',0),(271942,7554,'es','Largo Terminado',0),(271943,7554,'de','Fertige LÃ¤nge',0),(271944,7554,'en','Finished Length',0),(271945,7555,'is','',0),(271946,7555,'dr','Ø¹Ø±Ø¶ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ ',0),(271947,7555,'pr','Ø¹Ø±Ø¶ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ ',0),(271948,7555,'tr','BitmiÅŸ geniÅŸliÄŸi',0),(271949,7555,'pl','SzerokoÅ›Ä‡ gotowy',0),(271950,7555,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐ¸ ÑˆÐ¸Ñ€Ð¸Ð½Ð°',0),(271951,7555,'ur','ØªÚ©Ù…ÛŒÙ„ Ø´Ø¯Û Ú†ÙˆÚ‘Ø§Ø¦ÛŒ',0),(271952,7555,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸Ñ… ÑˆÐ¸Ñ€Ð¸Ð½Ð°',0),(271953,7555,'vi','Chiá»u rá»™ng Káº¿t thÃºc',0),(271954,7555,'af','Voltooide breedte',0),(271955,7555,'ro','LÄƒÅ£imea terminat',0),(271956,7555,'et','LÃµpetanud laius',0),(271957,7555,'si','KonÄal Å¡irina',0),(271958,7555,'ba','Lebar selesai',0),(271959,7555,'nl','Afgewerkte breedte',0),(271960,7555,'fi','Valmiin leveys',0),(271961,7555,'no','Ferdig bredde',0),(271962,7555,'da','FÃ¦rdige bredde',0),(271963,7555,'ko','ì™„ì„± ëœ ë„ˆë¹„',0),(271964,7555,'he','×¨×•×—×‘ ×¡×™×™×',0),(271965,7555,'el','Î¤ÎµÎ»Î¹ÎºÏŒ Ï€Î»Î¬Ï„Î¿Ï‚',0),(271966,7555,'zh','æˆå“å®½åº¦\r\n',0),(271967,7555,'sv','FÃ¤rdiga bredd',0),(271968,7555,'it','Larghezza finito',0),(271969,7555,'tl','',0),(271970,7555,'th','&#3588;&#3623;&#3634;&#3617;&#3585;&#3623;&#3657;&#3634;&#3591;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(271971,7555,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ',0),(271972,7555,'ms','Lebar siap',0),(271973,7555,'ar','Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ù…Ù† Ø§Ù„Ø¹Ø±Ø¶',0),(271974,7555,'fr','Largeur finie',0),(271975,7555,'jp','ä»•ä¸ŠãŒã‚Šå·¾',0),(271976,7555,'pt','Largura terminada',0),(271977,7555,'ru','Ð¨Ð¸Ñ€Ð¸Ð½Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¾Ð¹',0),(271978,7555,'es','Anchura Terminada',0),(271979,7555,'de','Fertige Breite',0),(271980,7555,'en','Finished Width',0),(271981,7556,'is','',0),(271982,7556,'dr',' Ø§ÙƒÙ†ÙˆÙ† Ø¨Ø³ØªÙ‡ Ø´ÙˆØ¯',0),(271983,7556,'pr',' Ø§ÙƒÙ†ÙˆÙ† Ø¨Ø³ØªÙ‡ Ø´ÙˆØ¯',0),(271984,7556,'tr','Åžimdi kapat',0),(271985,7556,'pl','Teraz zamknÄ…Ä‡',0),(271986,7556,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ ÑÐµÐ³Ð°',0),(271987,7556,'ur','Ø§Ø¨ Ø¨Ù†Ø¯',0),(271988,7556,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ Ð¾Ð´Ð¼Ð°Ñ…',0),(271989,7556,'vi','KhÃ³a sá»• bÃ¢y giá»',0),(271990,7556,'af','Sluit Nou ',0),(271991,7556,'ro','ÃŽnchide acum',0),(271992,7556,'et','Sulgege nÃ¼Ã¼d',0),(271993,7556,'si','Sedaj zaprite',0),(271994,7556,'ba','Menutup sekarang',0),(271995,7556,'nl','Nu sluiten',0),(271996,7556,'fi','Sulje nyt',0),(271997,7556,'no','Lukk nÃ¥',0),(271998,7556,'da','Luk nu',0),(271999,7556,'ko','ì§€ê¸ˆ ë‹«ê¸°',0),(272000,7556,'he','×¡×’×•×¨ ×¢×›×©×™×•',0),(272001,7556,'el','ÎšÎ»ÎµÎ¯ÏƒÏ„Îµ Ï„ÏŽÏÎ±',0),(272002,7556,'zh','çŽ°åœ¨å…³é—­\r\n',0),(272003,7556,'sv','StÃ¤ng nu',0),(272004,7556,'it','Chiudere ora',0),(272005,7556,'tl','',0),(272006,7556,'th','&#3611;&#3636;&#3604;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(272007,7556,'hi','à¤…à¤¬ à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(272008,7556,'ms','Tutup sekarang',0),(272009,7556,'ar','Ø£ØºÙ„Ù‚ Ø§Ù„Ø¢Ù†',0),(272010,7556,'fr','Fermer maintenant',0),(272011,7556,'jp','ä»Šã™ãé–‰ã˜ã‚‹',0),(272012,7556,'pt','Feche agora',0),(272013,7556,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¡ÐµÐ¹Ñ‡Ð°Ñ',0),(272014,7556,'es','Cerrar Ahora',0),(272015,7556,'de','SchlieÃŸen Sie jetzt',0),(272016,7556,'en','Close Now',0),(272017,7557,'is','',0),(272018,7557,'dr','Ø¨Ø³ØªÙ†  Ø¨Ø§Ø² ÙƒØ±Ø¯Ù†  Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(272019,7557,'pr','Ø¨Ø³ØªÙ†  Ø¨Ø§Ø² ÙƒØ±Ø¯Ù†  Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(272020,7557,'tr','SipariÅŸ YazdÄ±r aÃ§Ä±k kapatmak',0),(272021,7557,'pl','Zamknij otwarte zlecenia druku',0),(272022,7557,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÑ‚Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(272023,7557,'ur','Ú©Ú¾Ù„ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒÚº',0),(272024,7557,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(272025,7557,'vi','ÄÃ³ng ÄÆ¡n Äáº·t HÃ ng In Má»Ÿ',0),(272026,7557,'af','Afsluiting van Oop Gedrukte Bestellings',0),(272027,7557,'ro','Aproape deschis comenzi de imprimare',0),(272028,7557,'et','Sulgege avatud trÃ¼kitÃ¶Ã¶de tellimused',0),(272029,7557,'si','Zaprite odprte naloge tiskanja',0),(272030,7557,'ba','Tutup Pesanan Terbuka yang Dicetak',0),(272031,7557,'nl','Sluiten afdrukken Orders openen',0),(272032,7557,'fi','Sulje avoin tulosta tilaukset',0),(272033,7557,'no','Lukk Ã¥pne bestilling',0),(272034,7557,'da','Luk Ã¥bne aftryksbestillinger',0),(272035,7557,'ko','ë‹«ê³  ì—´ë ¤ ì¸ì‡„ ì£¼ë¬¸',0),(272036,7557,'he','×¡×’×•×¨ ×¤×ª×•×— ×”×“×¤×¡×•×ª',0),(272037,7557,'el','ÎšÎ»ÎµÎ¯ÏƒÏ„Îµ Ï„Î± Î±Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(272038,7557,'zh','å…³é—­æ‰“å¼€æ‰“å°è®¢å•\r\n',0),(272039,7557,'sv','StÃ¤ng Ã¶ppna Print Order',0),(272040,7557,'it','Chiudere gli ordini aperti di stampa',0),(272041,7557,'tl','',0),(272042,7557,'th','&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(272043,7557,'hi','à¤–à¥à¤²à¤¾ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(272044,7557,'ms','Tutup Buka pesanan cetakan',0),(272045,7557,'ar','Ø£ØºÙ„Ù‚ ÙØªØ­ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(272046,7557,'fr','Fermer les commandes ouvertes',0),(272047,7557,'jp','ã‚ªãƒ¼ãƒ—ãƒ³ã®ãƒ—ãƒªãƒ³ãƒˆã®æ³¨æ–‡ã‚’é–‰ã˜ã‚‹',0),(272048,7557,'pt','Fechar pedidos abertos de impressÃ£o',0),(272049,7557,'ru','Ð—Ð°ÐºÑ€Ð¾Ð¹Ñ‚Ðµ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(272050,7557,'es','Cerrar Ordenes de ImpresiÃ³n Abiertos',0),(272051,7557,'de','SchlieÃŸen Sie offene DruckauftrÃ¤ge',0),(272052,7557,'en','Close Open Print Orders',0),(272053,7558,'is','',0),(272054,7558,'dr','Ø¨Ø³ØªÙ†   Ù…Ø¹Ù„Ù‚  Ú†Ø§Ù¾  Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(272055,7558,'pr','Ø¨Ø³ØªÙ†   Ù…Ø¹Ù„Ù‚  Ú†Ø§Ù¾  Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(272056,7558,'tr','SipariÅŸ YazdÄ±r kapatÄ±n',0),(272057,7558,'pl','Blisko zamÃ³wieÅ„ druku',0),(272058,7558,'bg','Ð‘Ð»Ð¸Ð·Ð¾ Ð´Ð¾ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(272059,7558,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø§Ø´Ø®Ø§Øµ Ú©Û’ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒÚº',0),(272060,7558,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(272061,7558,'vi','ÄÃ³ng ÄÆ¡n Äáº·t HÃ ng In ChÆ°a HoÃ n Táº¥t',0),(272062,7558,'af','Sluite Afwagtende \"Print\" Bestellings',0),(272063,7558,'ro','ÃŽnchide pÃ¢nÄƒ la comenzi de imprimare',0),(272064,7558,'et','Sulgege enne trÃ¼kitÃ¶Ã¶de tellimused',0),(272065,7558,'si','Blizu ÄakajoÄa naroÄila tiskanja',0),(272066,7558,'ba','Tutup Cetakan Pesanan yang Tertunda',0),(272067,7558,'nl','Sluit in afwachting van Orders afdrukken',0),(272068,7558,'fi','Sulje ennen tulosta tilaukset',0),(272069,7558,'no','Lukk ventende bestilling',0),(272070,7558,'da','Luk indtil aftryksbestillinger',0),(272071,7558,'ko','ì¸ì‡„ ì£¼ë¬¸ ë³´ë¥˜ ì¤‘ì¸ ì¢…ë£Œ',0),(272072,7558,'he','×¡×’×•×¨ ××ª ×”×”×“×¤×¡×” ×”×•×¨××•×ª ×ž×ž×ª×™× ×•×ª',0),(272073,7558,'el','ÎšÎ»ÎµÎ¯ÏƒÎµÏ„Îµ ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(272074,7558,'zh','å…³é—­å¾…æ‰“å°è®¢å•\r\n',0),(272075,7558,'sv','NÃ¤ra i avvaktan pÃ¥ Print Order',0),(272076,7558,'it','Chiudere stampa ordini pendenti',0),(272077,7558,'tl','',0),(272078,7558,'th','&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3588;&#3657;&#3634;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(272079,7558,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(272080,7558,'ms','Tutup sementara menunggu pesanan cetakan',0),(272081,7558,'ar','Ø¥ØºÙ„Ø§Ù‚ Ø§Ù†ØªØ¸Ø§Ø±Ø§ Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(272082,7558,'fr','Fermer dans l\'attente de commandes',0),(272083,7558,'jp','ä¿ç•™ä¸­ã®ãƒ—ãƒªãƒ³ãƒˆã®æ³¨æ–‡ã‚’é–‰ã˜ã‚‹',0),(272084,7558,'pt','Fechar imprimir ordens pendentes',0),(272085,7558,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¾Ñ€Ð´ÐµÑ€Ð°',0),(272086,7558,'es','Cerrar Pendiente de Ordenes de ImpresiÃ³n',0),(272087,7558,'de','Close Pending DruckauftrÃ¤ge',0),(272088,7558,'en','Close Pending Print Orders',0),(272089,7559,'is','',0),(272090,7559,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ù…Ù„ Ø§Ø³Øª',0),(272091,7559,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ù…Ù„ Ø§Ø³Øª',0),(272092,7559,'tr','GÃ¼ncelleÅŸtirme tamamlandÄ±',0),(272093,7559,'pl','Aktualizacja kompletny',0),(272094,7559,'bg','ÐžÐ±Ð½Ð¾Ð²ÑÐ²Ð°Ð½ÐµÑ‚Ð¾ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¾',0),(272095,7559,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…Ú©Ù…Ù„',0),(272096,7559,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾',0),(272097,7559,'vi','HoÃ n Táº¥t Cáº­p Nháº­t',0),(272098,7559,'af','Opdatering Voltooi',0),(272099,7559,'ro','Actualizare completÄƒ',0),(272100,7559,'et','VÃ¤rskendamine valmis',0),(272101,7559,'si','Popolna posodobitev',0),(272102,7559,'ba','Update lengkap',0),(272103,7559,'nl','Update compleet',0),(272104,7559,'fi','PÃ¤ivitys valmis',0),(272105,7559,'no','Oppdatering fullfÃ¸rt',0),(272106,7559,'da','Opdatering komplet',0),(272107,7559,'ko','ì—…ë°ì´íŠ¸ ì™„ë£Œ',0),(272108,7559,'he','×”×¢×“×›×•×Ÿ ×”×•×©×œ×',0),(272109,7559,'el','Î Î»Î®ÏÎ·Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(272110,7559,'zh','æ›´æ–°å®Œæˆ\r\n',0),(272111,7559,'sv','Uppdatering komplett',0),(272112,7559,'it','Aggiornamento completo',0),(272113,7559,'tl','',0),(272114,7559,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(272115,7559,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤—à¤¯à¤¾',0),(272116,7559,'ms','Kemas kini selesai',0),(272117,7559,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙƒØ§Ù…Ù„',0),(272118,7559,'fr','Mise Ã  jour complÃ¨te',0),(272119,7559,'jp','æ›´æ–°ãŒå®Œäº†ã—ã¾ã—ãŸ',0),(272120,7559,'pt','AtualizaÃ§Ã£o completa',0),(272121,7559,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¾',0),(272122,7559,'es','ActualizaciÃ³n Completa',0),(272123,7559,'de','Update abgeschlossen',0),(272124,7559,'en','Update Complete',0),(272125,7560,'is','',0),(272126,7560,'dr','( Ø³Ù…Øª Ù‡Ø§ ',0),(272127,7560,'pr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ø´ØºÙ„ Ù‡Ø§ ( Ø³Ù…Øª Ù‡Ø§ ',0),(272128,7560,'tr','Ä°ÅŸlerini tamamlamalarÄ±',0),(272129,7560,'pl','ZakoÅ„czenie pracy',0),(272130,7560,'bg','ÐŸÑŠÐ»Ð½Ð° Ð·Ð°ÐµÑ‚Ð¾ÑÑ‚',0),(272131,7560,'ur','Ù…Ú©Ù…Ù„ Ø±ÙˆØ²Ú¯Ø§Ø±',0),(272132,7560,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐ¸Ñ‚Ðµ Ð¿Ð¾ÑÐ°Ð¾',0),(272133,7560,'vi','HoÃ n táº¥t Job',0),(272134,7560,'af','Take voltooi',0),(272135,7560,'ro','CompletÄƒ de locuri de muncÄƒ',0),(272136,7560,'et','Tehtud tÃ¶Ã¶de',0),(272137,7560,'si','DokonÄanje delovnih mest',0),(272138,7560,'ba','Menyelesaikan pekerjaan',0),(272139,7560,'nl','Volledige werkgelegenheid',0),(272140,7560,'fi','TÃ¤ydellinen tyÃ¶paikkaa',0),(272141,7560,'no','Komplett jobber',0),(272142,7560,'da','Komplette arbejdspladser',0),(272143,7560,'ko','ìž‘ì—… ì™„ë£Œ',0),(272144,7560,'he','×¢×‘×•×“×•×ª ×ž×•×©×œ×ž×•×ª',0),(272145,7560,'el','Î Î»Î®ÏÎ·Ï‚ Î±Ï€Î±ÏƒÏ‡ÏŒÎ»Î·ÏƒÎ·',0),(272146,7560,'zh','å®Œæˆä½œä¸š\r\n',0),(272147,7560,'sv','Komplett jobb',0),(272148,7560,'it','Completare i lavori',0),(272149,7560,'tl','',0),(272150,7560,'th','&#3591;&#3634;&#3609;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(272151,7560,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤°à¥‹à¤œà¤—à¤¾à¤°',0),(272152,7560,'ms','Melengkapkan kerja',0),(272153,7560,'ar','ÙˆØ¸Ø§Ø¦Ù ÙƒØ§Ù…Ù„Ø©',0),(272154,7560,'fr','Emplois complets',0),(272155,7560,'jp','ã‚¸ãƒ§ãƒ–ã‚’å®Œäº†ã—ã¾ã™ã€‚',0),(272156,7560,'pt','Trabalhos completos',0),(272157,7560,'ru','ÐŸÐ¾Ð»Ð½Ð°Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(272158,7560,'es','Completar Trabajos',0),(272159,7560,'de','Komplette ArbeitsplÃ¤tze',0),(272160,7560,'en','Complete Jobs',0),(272161,7561,'is','',0),(272162,7561,'dr','Ø´ØºÙ„ Ù‡Ø§ Ø±Ø§ ÙˆÙ‚ØªÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù†Ø¯ Ø¹Ù„Ø§Ù…Øª Ø¨Ø²Ù†ÙŠØ¯',0),(272163,7561,'pr','Ø´ØºÙ„ Ù‡Ø§ Ø±Ø§ ÙˆÙ‚ØªÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù†Ø¯ Ø¹Ù„Ø§Ù…Øª Ø¨Ø²Ù†ÙŠØ¯',0),(272164,7561,'tr','TamamlandÄ± olarak iÅŸaretle iÅŸleri',0),(272165,7561,'pl','Mark Praca jako ukoÅ„czone',0),(272166,7561,'bg','ÐœÐ°Ñ€Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð¼ÐµÑÑ‚Ð° ÐºÐ°Ñ‚Ð¾ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½',0),(272167,7561,'ur','Ù…Ú©Ù…Ù„ Ø·ÙˆØ± Ù¾Ø± Ù†Ø´Ø§Ù† Ø²Ø¯ Ú©Ø±ÛŒÚº Ú©ÛŒ Ù†ÙˆÚ©Ø±ÛŒØ§Úº',0),(272168,7561,'sr','ÐœÐ°Ñ€Ðº Ð¿Ð¾ÑÐ»Ð¾Ð²Ðµ ÐºÐ°Ð¾ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð°',0),(272169,7561,'vi','ÄÃ¡nh dáº¥u Job hoÃ n thÃ nh',0),(272170,7561,'af','Merk Kontrakwerke As Voltooi',0),(272171,7561,'ro','Marca de locuri de muncÄƒ ca finalizat',0),(272172,7561,'et','Mark tÃ¶Ã¶ lÃµpetatuks',0),(272173,7561,'si','Delovna mesta oznaÄi kot dokonÄano',0),(272174,7561,'ba','Mark pekerjaan selesai',0),(272175,7561,'nl','Mark banen als voltooid',0),(272176,7561,'fi','Merkitse tyÃ¶t valmiiksi',0),(272177,7561,'no','Mark jobber som fullfÃ¸rt',0),(272178,7561,'da','Mark job som fuldfÃ¸rt',0),(272179,7561,'ko','ë§ˆí¬ ìž‘ì—… ì™„ë£Œ',0),(272180,7561,'he','×¡×ž×Ÿ ×¢×‘×•×“×•×ª ×›×ž×•×©×œ×ž×•×ª',0),(272181,7561,'el','Mark Î¸Î­ÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï‰Ï‚ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½Î·',0),(272182,7561,'zh','æ ‡è®°å·¥ä½œä¸ºå·²å®Œæˆ\r\n',0),(272183,7561,'sv','Mark jobb som slutfÃ¶rd',0),(272184,7561,'it','Lavori di Mark come completato',0),(272185,7561,'tl','',0),(272186,7561,'th','&#3607;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;',0),(272187,7561,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤®à¤¾à¤°à¥à¤• à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¤¾à¤‚',0),(272188,7561,'ms','Kerja-kerja Mark yang siap',0),(272189,7561,'ar','ÙˆØ¸Ø§Ø¦Ù ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© Ø§ÙƒØªÙ…Ø§Ù„',0),(272190,7561,'fr','Emplois de marque comme terminÃ©',0),(272191,7561,'jp','å®Œäº†ã¨ã—ã¦ãƒžãƒ¼ã‚¯ ã‚¸ãƒ§ãƒ–',0),(272192,7561,'pt','Trabalhos de Mark como concluÃ­da',0),(272193,7561,'ru','ÐœÐ°Ñ€Ðº Ð²Ð°ÐºÐ°Ð½ÑÐ¸Ð¸ ÐºÐ°Ðº Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ',0),(272194,7561,'es','Marcar Trabajos como Completos',0),(272195,7561,'de','Mark-Jobs als abgeschlossen',0),(272196,7561,'en','Mark Jobs As Completed',0),(272197,7562,'is','',0),(272198,7562,'dr','(ØªØ³Ø¹ÙŠØ±',0),(272199,7562,'pr','ØªØ¨Ø¯ÙŠÙ„(ØªØ³Ø¹ÙŠØ±',0),(272200,7562,'tr','DÃ¶nÃ¼ÅŸtÃ¼rme',0),(272201,7562,'pl','Konwersji',0),(272202,7562,'bg','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(272203,7562,'ur','Ø¨Ø¯Ù„ÛŒ',0),(272204,7562,'sr','ÐšÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð°',0),(272205,7562,'vi','Chuyá»ƒn Ä‘á»•i',0),(272206,7562,'af','Omskakeling',0),(272207,7562,'ro','Conversie',0),(272208,7562,'et','Teisendus',0),(272209,7562,'si','Pretvorba',0),(272210,7562,'ba','Konversi',0),(272211,7562,'nl','Conversie',0),(272212,7562,'fi','Muuntaminen',0),(272213,7562,'no','Konvertering',0),(272214,7562,'da','Konvertering',0),(272215,7562,'ko','ë³€í™˜',0),(272216,7562,'he','×”×ž×¨×”',0),(272217,7562,'el','ÎœÎµÏ„Î±Ï„ÏÎ¿Ï€Î®',0),(272218,7562,'zh','è½¬æ¢\r\n',0),(272219,7562,'sv','Konvertering',0),(272220,7562,'it','Conversione',0),(272221,7562,'tl','',0),(272222,7562,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(272223,7562,'hi','à¤°à¥‚à¤ªà¤¾à¤‚à¤¤à¤°à¤£',0),(272224,7562,'ms','Penukaran',0),(272225,7562,'ar','Ø§Ù„ØªØ­ÙˆÙŠÙ„',0),(272226,7562,'fr','Conversion',0),(272227,7562,'jp','å¤‰æ›',0),(272228,7562,'pt','ConversÃ£o',0),(272229,7562,'ru','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(272230,7562,'es','ConversiÃ³n',0),(272231,7562,'de','Konvertierung',0),(272232,7562,'en','Conversion',0),(272233,7563,'is','',0),(272234,7563,'dr','(ØªØ³Ø¹ÙŠØ±',0),(272235,7563,'pr','ØªØ¨Ø¯ÙŠÙ„(ØªØ³Ø¹ÙŠØ±',0),(272236,7563,'tr','DÃ¶nÃ¼ÅŸÃ¼mleri',0),(272237,7563,'pl','Konwersje',0),(272238,7563,'bg','Ð ÐµÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(272239,7563,'ur','ØªØ­ÙˆÛŒÙ„',0),(272240,7563,'sr','ÐšÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ',0),(272241,7563,'vi','Chuyá»ƒn Ä‘á»•i',0),(272242,7563,'af','Omskakelings',0),(272243,7563,'ro','Conversii',0),(272244,7563,'et','Teisendused',0),(272245,7563,'si','Pretvorbe',0),(272246,7563,'ba','Konversi',0),(272247,7563,'nl','Conversies',0),(272248,7563,'fi','Tulokset',0),(272249,7563,'no','Konverteringer',0),(272250,7563,'da','Konverteringer',0),(272251,7563,'ko','ë³€í™˜',0),(272252,7563,'he','×”×ž×¨×•×ª',0),(272253,7563,'el','ÎœÎµÏ„Î±Ï„ÏÎ¿Ï€Î­Ï‚',0),(272254,7563,'zh','è½¬æ¢\r\n',0),(272255,7563,'sv','Omvandlingar',0),(272256,7563,'it','Conversioni',0),(272257,7563,'tl','',0),(272258,7563,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(272259,7563,'hi','à¤°à¥à¤ªà¤¾à¤¨à¥à¤¤à¤°à¤£',0),(272260,7563,'ms','Penukaran',0),(272261,7563,'ar','Ø§Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª',0),(272262,7563,'fr','Conversions',0),(272263,7563,'jp','å¤‰æ›',0),(272264,7563,'pt','ConversÃµes',0),(272265,7563,'ru','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(272266,7563,'es','ConversiÃ³ns',0),(272267,7563,'de','Konvertierungen',0),(272268,7563,'en','Conversions',0),(272269,7564,'is','',0),(272270,7564,'dr','(ØŒØªØ¨Ø¯ÙŠÙ„ ÙŠÚ© Ø¨Ø¯Ù‡Ù‰ Ø¨Ù‡ Ø¨Ø¯Ù‡Ù‰ Ø¯ÙŠÚ¯Ø± Ø¨Ø§ Ù†Ø±Ø® Ø§Ø±Ø² Ú©Ù…ØªØ± ',0),(272271,7564,'pr','ØªØ¨Ø¯ÙŠÙ„ Ø®Ø±ÙŠØ¯ (ØŒØªØ¨Ø¯ÙŠÙ„ ÙŠÚ© Ø¨Ø¯Ù‡Ù‰ Ø¨Ù‡ Ø¨Ø¯Ù‡Ù‰ Ø¯ÙŠÚ¯Ø± Ø¨Ø§ Ù†Ø±Ø® Ø§Ø±Ø² Ú©Ù…ØªØ± ',0),(272272,7564,'tr','SatÄ±n alma dÃ¶nÃ¼ÅŸÃ¼mÃ¼',0),(272273,7564,'pl','Konwersja',0),(272274,7564,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° ÐºÐ¾Ð½Ð²ÐµÑ€ÑÐ¸Ñ',0),(272275,7564,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(272276,7564,'sr','ÐšÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(272277,7564,'vi','Chuyá»ƒn Ä‘á»•i mua hÃ ng',0),(272278,7564,'af','Aankoop Conversion',0),(272279,7564,'ro','AchiziÅ£ionarea de conversie',0),(272280,7564,'et','Ostutellimuse teisendamine',0),(272281,7564,'si','Nakup pretvorbe',0),(272282,7564,'ba','Pembelian konversi',0),(272283,7564,'nl','Aankoop conversie',0),(272284,7564,'fi','Osto muunto',0),(272285,7564,'no','KjÃ¸p konvertering',0),(272286,7564,'da','KÃ¸b konvertering',0),(272287,7564,'ko','êµ¬ë§¤ ì „í™˜',0),(272288,7564,'he','×œ×¨×›×•×© ×”×ž×¨×”',0),(272289,7564,'el','Î‘Î³Î¿ÏÎ¬ Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î®Ï‚',0),(272290,7564,'zh','è´­ä¹°è½¬æ¢\r\n',0),(272291,7564,'sv','KÃ¶p konvertering',0),(272292,7564,'it','Conversione di acquisto',0),(272293,7564,'tl','',0),(272294,7564,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(272295,7564,'hi','à¤°à¥‚à¤ªà¤¾à¤‚à¤¤à¤°à¤£ à¤•à¥€ à¤–à¤°à¥€à¤¦',0),(272296,7564,'ms','Penukaran pembelian',0),(272297,7564,'ar','Ø´Ø±Ø§Ø¡ Ø§Ù„ØªØ­ÙˆÙŠÙ„',0),(272298,7564,'fr','Conversion d\'achat',0),(272299,7564,'jp','è³¼å…¥å¤‰æ›',0),(272300,7564,'pt','ConversÃ£o de compra',0),(272301,7564,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(272302,7564,'es','ConversiÃ³n de Compra',0),(272303,7564,'de','Konvertierung zu kaufen',0),(272304,7564,'en','Purchase Conversion',0),(272305,7565,'is','',0),(272306,7565,'dr','Ù‡ÙŠÚ† Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¨Ø±Ø§ÙŠ Ù…Ù‚Ø§Ø¯ÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ÙŠØ§ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡',0),(272307,7565,'pr','Ù‡ÙŠÚ† Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¨Ø±Ø§ÙŠ Ù…Ù‚Ø§Ø¯ÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ÙŠØ§ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡',0),(272308,7565,'tr','SeÃ§ilen vergiye tabi tutarlar veya vergi iÃ§in vergi tÃ¼rÃ¼ yok',0),(272309,7565,'pl','Nie podatek od typu wybranego dla kwot podlegajÄ…cych opodatkowaniu lub podatku',0),(272310,7565,'bg','ÐÑÐ¼Ð° Ð´Ð°Ð½ÑŠÐº Ñ‚Ð¸Ð¿, Ð¸Ð·Ð±Ñ€Ð°Ð½ Ð·Ð° Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð¸Ñ‚Ðµ ÑÑƒÐ¼Ð¸ Ð¸Ð»Ð¸ Ð´Ð°Ð½ÑŠÐº',0),(272311,7565,'ur','Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ Ù…Ù‚Ø¯Ø§Ø± ÛŒØ§ Ù¹ÛŒÚ©Ø³ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù…',0),(272312,7565,'sr','ÐÐµÐ¼Ð° Ð²Ñ€ÑÑ‚Ð° ÐŸÐ”Ð’-Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½ Ð·Ð° Ð¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸ Ð¸Ð·Ð½Ð¾ÑÐ¸ Ð¸Ð»Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(272313,7565,'vi','ChÆ°a chá»n loáº¡i thuáº¿ cho sá»‘ tiá»n chá»‹u thuáº¿ hay thuáº¿',0),(272314,7565,'af','Geen Belastingtipe Geselekteer vir Belasbare Bedrae of Belasting',0),(272315,7565,'ro','Nici un tip de impozit selectate pentru valorile impozabile sau fiscale',0),(272316,7565,'et','Mingit maksu liik valitud maksustatav summa ja kÃ¤ibemaksu',0),(272317,7565,'si','Ne izstavljenih izbran za obdavÄljive zneske ali davÄne',0),(272318,7565,'ba','Tidak ada jenis pajak yang dipilih untuk jumlah yang kena pajak atau pajak',0),(272319,7565,'nl','Geen belasting Type geselecteerd voor belastbare bedragen of belasting',0),(272320,7565,'fi','Vero-tyyppiÃ¤ ei valittu verotettavan tulon tai vero',0),(272321,7565,'no','Ingen mva-typen som er angitt for avgiftspliktige belÃ¸p eller skatt',0),(272322,7565,'da','Ingen skat Type valgt for afgiftspligtige belÃ¸b eller skat',0),(272323,7565,'ko','ê³¼ì„¸ ê¸ˆì•¡ ë˜ëŠ” ì„¸ê¸ˆì— ëŒ€í•´ ì„ íƒí•œ ì—†ìŒ ì„¸ê¸ˆ ì¢…ë¥˜',0),(272324,7565,'he','××™×Ÿ ×¡×•×’ ×”×ž×¡ ×©× ×‘×—×¨ ×¢×‘×•×¨ ×›×ž×•×™×•×ª ×—×™×™×‘ ×‘×ž×¡ ××• ×ž×¡',0),(272325,7565,'el','Î”ÎµÎ½ Ï„ÏÏ€Î¿Ï‚ Î¦Î Î‘ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ Î³Î¹Î± Ï†Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­Î± Ï€Î¿ÏƒÎ¬ Î® Ï†ÏŒÏÎ¿Ï…',0),(272326,7565,'zh','æ— å·²é€‰çš„åº”ç¨Žé‡‘é¢æˆ–ç¨Žæ”¶ç¨Žåž‹\r\n',0),(272327,7565,'sv','Ingen skatt typ valts fÃ¶r skattepliktiga belopp eller skatt',0),(272328,7565,'it','Nessun tipo di tassa selezionato per gli imponibili o imposte',0),(272329,7565,'tl','',0),(272330,7565,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3592;&#3635;&#3609;&#3623;&#3',0),(272331,7565,'hi','à¤•à¥‹à¤ˆ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤° à¤¯à¥‹à¤—à¥ à¤¯ à¤°à¤¾à¤¶à¤¿ à¤¯à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¯à¤¨à¤¿à¤¤',0),(272332,7565,'ms','Tiada jenis cukai yang dipilih untuk jumlah yang boleh dikenakan cukai atau cukai',0),(272333,7565,'ar','Ù„Ø§ Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø­Ø¯Ø¯ Ù„Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ø®Ø§Ø¶Ø¹Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ø£Ùˆ Ø¶Ø±ÙŠØ¨Ø©',0),(272334,7565,'fr','Aucun Type d\'impÃ´t sÃ©lectionnÃ© pour les montants imposables ou taxe',0),(272335,7565,'jp','èª²ç¨Žå¯¾è±¡é¡ã¾ãŸã¯ç¨Žé‡‘ã«å¯¾ã—ã¦é¸æŠžã•ã‚ŒãŸãªã„ç¨Žã‚¿ã‚¤ãƒ—',0),(272336,7565,'pt','Nenhum tipo de imposto selecionado para quantias tributÃ¡veis ou imposto',0),(272337,7565,'ru','Ð¢Ð¸Ð¿ Ð½Ðµ Ð½Ð°Ð»Ð¾Ð³, Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð´Ð»Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ñ‹Ñ… ÑÑƒÐ¼Ð¼ Ð¸Ð»Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð³Ð¾',0),(272338,7565,'es','No se SeleccionÃ³ un Tipo de Impuesto para Cantidades Imponibles o el Impuesto',0),(272339,7565,'de','Keine Steuerart fÃ¼r Steuerpflichtige BetrÃ¤ge oder Steuer ausgewÃ¤hlt',0),(272340,7565,'en','No Tax Type Selected for Taxable Amounts or Tax',0),(272341,7566,'is','',0),(272342,7566,'dr','Ø­Ø¯Ø§ÙƒØ«Ø± Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙØ±ÙˆØ´ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(272343,7566,'pr','Ø­Ø¯Ø§ÙƒØ«Ø± Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙØ±ÙˆØ´ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(272344,7566,'tr','Vergiye tabi satÄ±ÅŸ hareketi Max',0),(272345,7566,'pl','Max opodatkowania transakcji sprzedaÅ¼y',0),(272346,7566,'bg','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð° ÐœÐ°ÐºÑ',0),(272347,7566,'ur','Ø³ÛŒÙ„Ø² Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(272348,7566,'sr','ÐžÐ¿Ð¾Ñ€ÐµÐ·Ð¸Ð² ÐœÐ°x Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(272349,7566,'vi','Giao dá»‹ch bÃ¡n hÃ ng chá»‹u thuáº¿ tá»‘i Ä‘a',0),(272350,7566,'af','Verkoopstransaksie Maks Belasbaar',0),(272351,7566,'ro','VÃ¢nzÄƒri tranzacÅ£ia impozabilÄƒ Max',0),(272352,7566,'et','MÃ¼Ã¼gitehing maksustatava Max',0),(272353,7566,'si','Max obdavÄljive transakcije prodaje',0),(272354,7566,'ba','Max kena pajak transaksi penjualan',0),(272355,7566,'nl','Verkooptransactie belastbare Max',0),(272356,7566,'fi','Myyntitapahtuman veron Max',0),(272357,7566,'no','Salgstransaksjon skattepliktig Max',0),(272358,7566,'da','Salgstransaktion afgiftspligtige Max',0),(272359,7566,'ko','íŒë§¤ ê±°ëž˜ ê³¼ì„¸ ë§¥ìŠ¤',0),(272360,7566,'he','×ž×§×¡ ×—×™×™×‘ ×‘×ž×¡ ×¢×¡×§××•×ª ×”×ž×›×™×¨×•×ª',0),(272361,7566,'el','Î£Ï…Î½Î±Î»Î»Î±Î³Î® Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚ Ï†Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­Î¿ Max',0),(272362,7566,'zh','é”€å”®äº¤æ˜“åº”ç¨Žæœ€å¤§\r\n',0),(272363,7566,'sv','FÃ¶rsÃ¤ljningstransaktion beskattningsbara Max',0),(272364,7566,'it','Transazione di vendita imponibile Max',0),(272365,7566,'tl','',0),(272366,7566,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3595;&#3638;&#3656;&#3591;&#3605;&#3657;&#3629;&#3591;&#3648;&#3626;&#3637;&#3618;&#3616;&#3634;&#3625;&#3637;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;',0),(272367,7566,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤•à¤° à¤¯à¥‹à¤—à¥ à¤¯ à¤®à¥ˆà¤•à¥à¤¸',0),(272368,7566,'ms','Transaksi jualan Max boleh dikenakan cukai',0),(272369,7566,'ar','Ù…Ø§ÙƒØ³ ØµÙÙ‚Ø© Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(272370,7566,'fr','Transaction de vente Taxable Max',0),(272371,7566,'jp','è²©å£²å–å¼•èª²ç¨Ž Max',0),(272372,7566,'pt','Max tributÃ¡vel operaÃ§Ã£o de venda',0),(272373,7566,'ru','Ð¡Ð´ÐµÐ»ÐºÐ¸ ÐºÑƒÐ¿Ð»Ð¸-Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼ ÐœÐ°ÐºÑ',0),(272374,7566,'es','TransacciÃ³n de Ventas Max Impuesto',0),(272375,7566,'de','Verkaufstransaktion Steuerpflichtigen Max',0),(272376,7566,'en','Sales Transaction Taxable Max',0),(272377,7567,'is','',0),(272378,7567,'dr','ÙÙ‚Ø· ÙƒØ§Ø± Ù…ÙŠ ÙƒÙ†Ø¯ Ø§Ú¯Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(272379,7567,'pr','ÙÙ‚Ø· ÙƒØ§Ø± Ù…ÙŠ ÙƒÙ†Ø¯ Ø§Ú¯Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(272380,7567,'tr','Sadece iÅŸ eÄŸer kullanarak olacak',0),(272381,7567,'pl','BÄ™dzie dziaÅ‚aÄ‡ tylko jeÅ›li za pomocÄ…',0),(272382,7567,'bg','Ð©Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ',0),(272383,7567,'ur','Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ø§Ú¯Ø± ØµØ±Ù Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ú©Ø§Ù… Ú©Ø±ÛŒÚº Ú¯Û’',0),(272384,7567,'sr','Ð‹Ðµ ÑÐ°Ð¼Ð¾ Ñ€Ð°Ð´ Ð°ÐºÐ¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ',0),(272385,7567,'vi','Sáº½ chá»‰ lÃ m viá»‡c khi dÃ¹ng',0),(272386,7567,'af','Sal net werk as gebruik',0),(272387,7567,'ro','Va funcÅ£iona doar dacÄƒ folosiÅ£i',0),(272388,7567,'et','TÃ¶Ã¶tab ainult siis kui kasutatakse',0),(272389,7567,'si','Bo delovala le, Äe z uporabo',0),(272390,7567,'ba','Hanya akan bekerja jika menggunakan',0),(272391,7567,'nl','Zal alleen werken als met behulp van',0),(272392,7567,'fi','Toimii vain jos',0),(272393,7567,'no','Vil bare fungere hvis bruker',0),(272394,7567,'da','Vil kun arbejde, hvis bruger',0),(272395,7567,'ko','ì‚¬ìš© í•˜ëŠ” ê²½ìš°ë§Œ ì¼ ê²ƒ ì´ë‹¤',0),(272396,7567,'he','×™×¤×¢×œ×• ×¨×§ ×× ×ž×©×ª×ž×©',0),(272397,7567,'el','Î˜Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Î¼ÏŒÎ½Î¿ ÎµÎ¬Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ',0),(272398,7567,'zh','åªæœ‰å½“ä½¿ç”¨æ—¶å·¥ä½œ\r\n',0),(272399,7567,'sv','Kommer endast att fungera om du anvÃ¤nder',0),(272400,7567,'it','Funzioneranno solo se si utilizza',0),(272401,7567,'tl','',0),(272402,7567,'th','&#3592;&#3632;&#3607;&#3635;&#3591;&#3634;&#3609;&#3648;&#3617;&#3639;&#3656;&#3629;&#3617;&#3637;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(272403,7567,'hi','à¤•à¥‡à¤µà¤² à¤•à¤¾à¤® à¤¯à¤¦à¤¿ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(272404,7567,'ms','Hanya akan bekerja jika menggunakan',0),(272405,7567,'ar','ÙˆØ³ÙˆÙ \"ØªØ¹Ù…Ù„ ÙÙ‚Ø·\" ÙÙŠ Ø­Ø§Ù„Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(272406,7567,'fr','Fonctionnera seulement si vous utilisez',0),(272407,7567,'jp','ä½¿ç”¨ã—ã¦å ´åˆã«ã®ã¿å‹•ä½œã‚’ã—ã¾ã™',0),(272408,7567,'pt','SÃ³ funcionarÃ¡ se usando',0),(272409,7567,'ru','Ð‘ÑƒÐ´ÐµÑ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ñ€Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ð¸',0),(272410,7567,'es','Solo FuncionarÃ¡ si esta Usando',0),(272411,7567,'de','Wird nur funktionieren, wenn',0),(272412,7567,'en','Will Only Work if Using',0),(272413,7568,'is','',0),(272414,7568,'dr','ØªØ¨Ø¯ÙŠÙ„ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(272415,7568,'pr','ØªØ¨Ø¯ÙŠÙ„ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(272416,7568,'tr','Stok dÃ¶nÃ¼ÅŸÃ¼m bileÅŸen',0),(272417,7568,'pl','Przedmioty z magazynu konwersji',0),(272418,7568,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ñ€ÐµÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(272419,7568,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ ØªØ­ÙˆÛŒÙ„ Ø§Ø´ÛŒØ§Ø¡',0),(272420,7568,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° ÐºÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ',0),(272421,7568,'vi','Chuyá»ƒn Ä‘á»•i danh má»¥c hÃ ng hÃ³a',0),(272422,7568,'af','Voorraad Item Omskakelings',0),(272423,7568,'ro','Elemente de inventar conversii',0),(272424,7568,'et','Varude Ã¼ksuste teisendused',0),(272425,7568,'si','Elemente zaloge pretvorbe',0),(272426,7568,'ba','Persediaan barang konversi',0),(272427,7568,'nl','Conversies zowel eerst winkelobjecten',0),(272428,7568,'fi','Varaston erÃ¤t tuloksia',0),(272429,7568,'no','Lager elementer konverteringer',0),(272430,7568,'da','Lageret elementer konverteringer',0),(272431,7568,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ë³€í™˜',0),(272432,7568,'he','×ž×œ××™ ×¤×¨×™×˜×™× ×”×ž×¨×•×ª',0),(272433,7568,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î®-ÎšÎ±Ï„Î±ÏƒÏ„Î®Î¼Î±Ï„Î± ÎÏ…Ï†Î¹ÎºÏŽÎ½ Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î­Ï‚',0),(272434,7568,'zh','åº“å­˜ç‰©å“è½¬æ¢\r\n',0),(272435,7568,'sv','Inventering objekt omvandlingar',0),(272436,7568,'it','L\'inventario articoli conversioni',0),(272437,7568,'tl','',0),(272438,7568,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(272439,7568,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤°à¥à¤ªà¤¾à¤¨à¥à¤¤à¤°à¤£',0),(272440,7568,'ms','Inventori item penukaran',0),(272441,7568,'ar','Ø¬Ø±Ø¯ Ø§Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª',0),(272442,7568,'fr','Les Ã©lÃ©ments de l\'inventaire des Conversions',0),(272443,7568,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªé …ç›®ã®å¤‰æ›',0),(272444,7568,'pt','ConversÃµes de itens de inventÃ¡rio',0),(272445,7568,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(272446,7568,'es','Conversions de Items de Inventario',0),(272447,7568,'de','Inventar von Elementen Konvertierungen',0),(272448,7568,'en','Inventory Items Conversions',0),(272449,7569,'is','',0),(272450,7569,'dr','ØªØ¨Ø¯ÙŠÙ„ ÙƒØ§Ù„Ø§',0),(272451,7569,'pr','ØªØ¨Ø¯ÙŠÙ„ ÙƒØ§Ù„Ø§',0),(272452,7569,'tr','Madde dÃ¶nÃ¼ÅŸÃ¼mlerini',0),(272453,7569,'pl','Element konwersji',0),(272454,7569,'bg','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(272455,7569,'ur','Ø´Û’ ØªØ­ÙˆÛŒÙ„',0),(272456,7569,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» ÐºÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ',0),(272457,7569,'vi','Chuyá»ƒn Ä‘á»•i hÃ ng',0),(272458,7569,'af','Item Omskakelings',0),(272459,7569,'ro','Element de conversii',0),(272460,7569,'et','Kauba teisendused',0),(272461,7569,'si','Element pretvorbe',0),(272462,7569,'ba','Item konversi',0),(272463,7569,'nl','Item conversies',0),(272464,7569,'fi','Muunnot',0),(272465,7569,'no','Elementet konverteringer',0),(272466,7569,'da','Vare konverteringer',0),(272467,7569,'ko','í•­ëª© ë³€í™˜',0),(272468,7569,'he','×”×ž×¨×•×ª ×¤×¨×™×˜×™×',0),(272469,7569,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î­Ï‚',0),(272470,7569,'zh','é¡¹ç›®è½¬æ¢\r\n',0),(272471,7569,'sv','Objekt omvandlingar',0),(272472,7569,'it','Elemento conversioni',0),(272473,7569,'tl','',0),(272474,7569,'th','&#3585;&#3634;&#3619;&#3649;&#3611;&#3621;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(272475,7569,'hi','à¤†à¤‡à¤Ÿà¤® à¤°à¥à¤ªà¤¾à¤¨à¥à¤¤à¤°à¤£',0),(272476,7569,'ms','Penukaran item',0),(272477,7569,'ar','Ø¨Ù†Ø¯ Ø§Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª',0),(272478,7569,'fr','Conversions de point',0),(272479,7569,'jp','é …ç›®ã®å¤‰æ›',0),(272480,7569,'pt','ConversÃµes de item',0),(272481,7569,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(272482,7569,'es','Item Conversiones',0),(272483,7569,'de','Element-Konvertierungen',0),(272484,7569,'en','Item Conversions',0),(272485,7570,'is','',0),(272486,7570,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· Ø¬Ø¯ÙŠØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(272487,7570,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· Ø¬Ø¯ÙŠØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(272488,7570,'tr','SatÄ±cÄ± aÃ§Ä±sÄ±ndan - bu PO',0),(272489,7570,'pl','Dostawcy warunki - niniejsze ZamÃ³wienie',0),(272490,7570,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð¸ - Ñ‚Ð¾Ð²Ð° PO',0),(272491,7570,'ur','ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø· - Ø§Ø³ Ù¾Ùˆ',0),(272492,7570,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÑƒÑÐ»Ð¾Ð²Ð¸ - Ð¾Ð²Ð° ÐŸÐž',0),(272493,7570,'vi','Äiá»u khoáº£n NgÆ°á»i bÃ¡n-ÄÆ¡n mua hÃ ng nÃ y',0),(272494,7570,'af','Handelaar terme - hierdie PO',0),(272495,7570,'ro','Furnizor de termeni - acest PO',0),(272496,7570,'et','Hankija tingimused - selles PO',0),(272497,7570,'si','Prodajalec izrazi - to PO',0),(272498,7570,'ba','Vendor persyaratan - PO ini',0),(272499,7570,'nl','Leverancier Terms - deze PO',0),(272500,7570,'fi','Toimittajan kannalta - tÃ¤mÃ¤ PO',0),(272501,7570,'no','LeverandÃ¸ren vilkÃ¥r - denne PO',0),(272502,7570,'da','Kreditor vilkÃ¥r - denne PO',0),(272503,7570,'ko','ê³µê¸‰ ì—…ì²´ì˜ ì¡°ê±´-ì´ í¬',0),(272504,7570,'he','×¡×¤×§ ×ª× ××™ - ×¤×• ×”×–×”',0),(272505,7570,'el','ÎŒÏÎ¿Î¹ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® - Î±Ï…Ï„Î® PO',0),(272506,7570,'zh','ä¾›åº”å•†æ¡æ¬¾ï¼Œæ­¤è´­ä¹°è®¢å•\r\n',0),(272507,7570,'sv','LeverantÃ¶rens villkor - denna PO',0),(272508,7570,'it','Termini di fornitore - questo PO',0),(272509,7570,'tl','',0),(272510,7570,'th','&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618; - &#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;',0),(272511,7570,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤°à¥à¤¤à¥‡à¤‚--à¤‡à¤¸ à¤ªà¥‹',0),(272512,7570,'ms','Syarat-syarat penjual - PO ini',0),(272513,7570,'ar','Ø´Ø±ÙˆØ· Ø§Ù„Ø¨Ø§Ø¦Ø¹-Ù‡Ø°Ø§ Ø¨Ùˆ',0),(272514,7570,'fr','Conditions de paiement du fournisseur - ce PO',0),(272515,7570,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼åˆ©ç”¨è¦ç´„ - ã“ã® PO',0),(272516,7570,'pt','Termos de fornecedor - esta PO',0),(272517,7570,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð° - ÑÑ‚Ð¾ PO',0),(272518,7570,'es','Proveedor TÃ©rminos-Este OC',0),(272519,7570,'de','Anbieter AGB - dieser PO',0),(272520,7570,'en','Vendor Terms - This PO',0),(272521,7571,'is','',0),(272522,7571,'dr','Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272523,7571,'pr','Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272524,7571,'tr','HavaalanÄ± otopark tesisi',0),(272525,7571,'pl','Lotnisko Parking obiekt',0),(272526,7571,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Ð¿Ð°Ñ€ÐºÐ¸Ð½Ð³ ÑÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸Ðµ',0),(272527,7571,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ Ù¾Ø§Ø±Ú©Ù†Ú¯ Ú©ÛŒ Ø³ÛÙˆÙ„Øª',0),(272528,7571,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÐŸÐ°Ñ€ÐºÐ¸Ð½Ð³ Ð¿Ð¾ÑÑ‚Ñ€Ð¾Ñ˜ÐµÑšÐµ',0),(272529,7571,'vi','BÃ£i Xe SÃ¢n Bay',0),(272530,7571,'af','Lughawe Parkering Fasiliteit',0),(272531,7571,'ro','Facilitatea de parcare aeroport',0),(272532,7571,'et','Lennujaama parkla',0),(272533,7571,'si','LetaliÅ¡Äe parkiranje objekt',0),(272534,7571,'ba','Fasilitas parkir Bandara',0),(272535,7571,'nl','Luchthaven Parking Facility',0),(272536,7571,'fi','Airport pysÃ¤kÃ¶intilaitos',0),(272537,7571,'no','Flyplassen parkeringsanlegg',0),(272538,7571,'da','Lufthavnen parkeringsanlÃ¦g',0),(272539,7571,'ko','ê³µí•­ ì£¼ì°¨ ì‹œì„¤',0),(272540,7571,'he','×ž×ª×§×Ÿ ×—× ×™×” ×”×ª×¢×•×¤×”',0),(272541,7571,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚',0),(272542,7571,'zh','æœºåœºåœè½¦è®¾æ–½\r\n',0),(272543,7571,'sv','Flygplats parkeringsanlÃ¤ggning',0),(272544,7571,'it','Parcheggio Aeroporto',0),(272545,7571,'tl','',0),(272546,7571,'th','&#3588;&#3623;&#3634;&#3617;&#3626;&#3632;&#3604;&#3623;&#3585;&#3651;&#3609;&#3585;&#3634;&#3619;&#3592;&#3629;&#3604;&#3619;&#3606;&#3607;&#3637;&#3656;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(272547,7571,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¤¾ à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¸à¥à¤µà¤¿à¤§à¤¾',0),(272548,7571,'ms','Kemudahan tempat letak kereta Lapangan Terbang',0),(272549,7571,'ar','Ù…Ø±ÙÙ‚ Ø§Ù„Ù…Ø·Ø§Ø± Ù…ÙˆÙ‚Ù Ù„Ù„Ø³ÙŠØ§Ø±Ø§Øª',0),(272550,7571,'fr','FacilitÃ© de Parking aÃ©roport',0),(272551,7571,'jp','ç©ºæ¸¯é§è»Šå ´',0),(272552,7571,'pt','Facilidade de estacionamento do Aeroporto',0),(272553,7571,'ru','ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÐ°',0),(272554,7571,'es','Aeropuerto Facilidad para Estacionar',0),(272555,7571,'de','Flughafen-Parkplatz',0),(272556,7571,'en','Airport Parking Facility',0),(272557,7572,'is','',0),(272558,7572,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ù‡Ø§ÙŠ Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272559,7572,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ù‡Ø§ÙŠ Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272560,7572,'tr','HavaalanÄ± otopark tesis Ã¼cretleri',0),(272561,7572,'pl','Lotnisko Parking placÃ³wki opÅ‚aty',0),(272562,7572,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Ð¿Ð°Ñ€ÐºÐ¸Ð½Ð³ ÑÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸Ðµ Ñ‚Ð°ÐºÑÐ¸',0),(272563,7572,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ Ù¾Ø§Ø±Ú©Ù†Ú¯ Ú©ÛŒ Ø³ÛÙˆÙ„Øª ÙÛŒØ³',0),(272564,7572,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÐŸÐ°Ñ€ÐºÐ¸Ð½Ð³ Ð¿Ð¾ÑÑ‚Ñ€Ð¾Ñ˜ÐµÑšÐµ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ',0),(272565,7572,'vi','PhÃ­ BÃ£i Xe SÃ¢n Bay',0),(272566,7572,'af','Lughawe parkering fasiliteit fooie',0),(272567,7572,'ro','Taxe de facilitatea de aeroport parcare',0),(272568,7572,'et','Lennujaama parkla rajatise tasud',0),(272569,7572,'si','Parkirnine objekt letaliÅ¡Äa',0),(272570,7572,'ba','Biaya fasilitas parkir Bandara',0),(272571,7572,'nl','Luchthaven faciliteit parkeertarieven',0),(272572,7572,'fi','LentokenttÃ¤ pysÃ¤kÃ¶inti toimistomaksut',0),(272573,7572,'no','Flyplass parkering anlegget avgifter',0),(272574,7572,'da','Lufthavn parkering facilitet gebyrer',0),(272575,7572,'ko','ê³µí•­ ì£¼ì°¨ ì‹œì„¤ ìš”ê¸ˆ',0),(272576,7572,'he','×“×ž×™ ×ž×ª×§×Ÿ ×—× ×™×” ×”×ª×¢×•×¤×”',0),(272577,7572,'el','Î¤Î­Î»Î· ÎµÎ³ÎºÎ±Ï„Î±ÏƒÏ„Î¬ÏƒÎµÏ‰Î½ ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚ Î±ÎµÏÎ¿Î´ÏÎ¿Î¼Î¯Î¿Ï…',0),(272578,7572,'zh','æœºåœºåœè½¦åœºè®¾æ–½è´¹ç”¨\r\n',0),(272579,7572,'sv','Flygplats parkering anlÃ¤ggning avgifter',0),(272580,7572,'it','Tasse di aeroporto parcheggio Facility',0),(272581,7572,'tl','',0),(272582,7572,'th','&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3588;&#3623;&#3634;&#3617;&#3626;&#3632;&#3604;&#3623;&#3585;&#3651;&#3609;&#3585;&#3634;&#3619;&#3592;&#3629;&#3604;&#3619;&#3606;&#3607;&#3637;&#3656;&#3626;&#3609;&#3',0),(272583,7572,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤¶à¥à¤²à¥à¤•',0),(272584,7572,'ms','Bayaran kemudahan letak kereta Lapangan Terbang',0),(272585,7572,'ar','Ø±Ø³ÙˆÙ… Ù…Ø±ÙÙ‚ ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª ÙÙŠ Ù…Ø·Ø§Ø±',0),(272586,7572,'fr','Frais dâ€™Ã©tablissement Parking aÃ©roport',0),(272587,7572,'jp','ç©ºæ¸¯é§è»Šå ´æ–½è¨­ä½¿ç”¨æ–™',0),(272588,7572,'pt','Taxas de instalaÃ§Ã£o de estacionamento de aeroporto',0),(272589,7572,'ru','ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÐ° Ñ„Ð¾Ð½Ð´Ð° ÑÐ±Ð¾Ñ€Ñ‹',0),(272590,7572,'es','Cuotas de la Facilidad para Estacionar del Aeropuerto',0),(272591,7572,'de','Flughafen ParkgebÃ¼hren Anlage',0),(272592,7572,'en','Airport Parking Facility Fees',0),(272593,7573,'is','',0),(272594,7573,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø®Ø¯Ù…Ø§Øª  Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272595,7573,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø®Ø¯Ù…Ø§Øª  Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272596,7573,'tr','HavaalanÄ± otopark tesis Hizmetleri gÃ¼ncelleÅŸtirme',0),(272597,7573,'pl','Lotnisko Parking zakÅ‚adu usÅ‚ug aktualizacji',0),(272598,7573,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Ð¿Ð°Ñ€ÐºÐ¸Ð½Ð³ ÑÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(272599,7573,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ Ù¾Ø§Ø±Ú©Ù†Ú¯ Ú©ÛŒ Ø³ÛÙˆÙ„Øª Ø®Ø¯Ù…Ø§Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(272600,7573,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ÑÐºÐ¸ ÐŸÐ°Ñ€ÐºÐ¸Ð½Ð³ Ð¿Ð¾ÑÑ‚Ñ€Ð¾Ñ˜ÐµÑšÐµ ÑƒÑÐ»ÑƒÐ³Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(272601,7573,'vi','Cáº­p Nháº­t Dá»‹ch Vá»¥ Gá»­i Xe SÃ¢n Bay',0),(272602,7573,'af','Lughawe Parkeer Fasiliteit Dienste Opdateer',0),(272603,7573,'ro','Aeroport parcare facilitatea servicii actualizare',0),(272604,7573,'et','Lennujaama parkimine poole teenuste vÃ¤rskendus',0),(272605,7573,'si','LetaliÅ¡Äe parkiranje objekt storitve posodobitev',0),(272606,7573,'ba','Bandara parkir fasilitas Layanan Update',0),(272607,7573,'nl','Luchthaven Parking Facility Services Update',0),(272608,7573,'fi','LentokenttÃ¤paikoituksen laitos Services-pÃ¤ivitys',0),(272609,7573,'no','Flyplassparkering Facility Services-oppdatering',0),(272610,7573,'da','Lufthavnsparkering Facility Services opdatering',0),(272611,7573,'ko','ê³µí•­ ì£¼ì°¨ ì‹œì„¤ ì„œë¹„ìŠ¤ ì—…ë°ì´íŠ¸',0),(272612,7573,'he','×—× ×™×•×ª ×‘×ž×ª×§×Ÿ ×©×™×¨×•×ª×™ ×¢×“×›×•×Ÿ ×‘×©×“×” ×”×ª×¢×•×¤×”',0),(272613,7573,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Ï…Ï€Î·ÏÎµÏƒÎ¯ÎµÏ‚ Î´Î¹ÎµÏ…ÎºÏŒÎ»Ï…Î½ÏƒÎ·Ï‚',0),(272614,7573,'zh','æœºåœºåœè½¦è®¾æ–½æœåŠ¡æ›´æ–°\r\n',0),(272615,7573,'sv','Flygplats parkering Facility Services-uppdateringen',0),(272616,7573,'it','Aeroporto Parcheggio Facility Services aggiornamento',0),(272617,7573,'tl','',0),(272618,7573,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3592;&#3629;&#3604;&#3619;&#3606;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(272619,7573,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤¸à¥‡à¤µà¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(272620,7573,'ms','Lapangan Terbang, tempat letak kereta Kemudahan Perkhidmatan Kemaskini',0),(272621,7573,'ar','Ø§Ù„Ù…Ø·Ø§Ø± ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ù…Ø±ÙÙ‚ Ø®Ø¯Ù…Ø§Øª Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(272622,7573,'fr','Mise Ã  jour des Services de facilitÃ© de Parking Ã  lâ€™aÃ©roport',0),(272623,7573,'jp','ç©ºæ¸¯æ–½è¨­ã‚µãƒ¼ãƒ“ã‚¹æ›´æ–°ã‚’é§è»Šå ´',0),(272624,7573,'pt','AtualizaÃ§Ã£o de serviÃ§os de instalaÃ§Ã£o de estacionamento do Aeroporto',0),(272625,7573,'ru','ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÐ° Ñ„Ð¾Ð½Ð´Ð° ÑƒÑÐ»ÑƒÐ³Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(272626,7573,'es','ActualizaciÃ³n de Servicios de la Facilidad para Estacionar del Aeropuerto ',0),(272627,7573,'de','Facility Services Update Parken am Flughafen',0),(272628,7573,'en','Airport Parking Facility Services Update',0),(272629,7574,'is','',0),(272630,7574,'dr','Ø«Ø§Ø¨Øª ÙƒØ§Ø±Ù…Ø²Ø¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272631,7574,'pr','Ø«Ø§Ø¨Øª ÙƒØ§Ø±Ù…Ø²Ø¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272632,7574,'tr','HavaalanÄ± Ã¼creti daire',0),(272633,7574,'pl','Port lotniczy opÅ‚aty za mieszkanie',0),(272634,7574,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Ñ‚Ð°ÐºÑÐ° Ð¿Ð»Ð¾ÑÑŠÐº',0),(272635,7574,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ ÙÛŒØ³ ÙÙ„ÛŒÙ¹',0),(272636,7574,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ Ð¾ÑÐµÐ¶Ð°Ð¼ ÑÑ‚Ð°Ð½',0),(272637,7574,'vi','PhÃ­ SÃ¢n Bay Má»™t Láº§n',0),(272638,7574,'af','Lughawe fooi plat',0),(272639,7574,'ro','Taxa de aeroport plat',0),(272640,7574,'et','Lennujaama tasu kindla',0),(272641,7574,'si','LetaliÅ¡ke pristojbine stanovanje',0),(272642,7574,'ba','Bandara biaya datar',0),(272643,7574,'nl','Luchthaven Flat Fee',0),(272644,7574,'fi','Airport maksu taulu',0),(272645,7574,'no','Flyplass avgift Flat',0),(272646,7574,'da','Lufthavn gebyr flad',0),(272647,7574,'ko','ê³µí•­ í‰ë©´ ìˆ˜ìˆ˜ë£Œ',0),(272648,7574,'he','× ×ž×œ ×”×ª×¢×•×¤×” ×“×ž×™ ×©×˜×•×—',0),(272649,7574,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Î±Î¼Î¿Î¹Î²Î® ÎµÏ€Î¯Ï€ÎµÎ´Î·Ï‚',0),(272650,7574,'zh','å›ºå®šæœºåœºè´¹\r\n',0),(272651,7574,'sv','Flygplatsen avgift platt',0),(272652,7574,'it','Tassa di aeroporto piatto',0),(272653,7574,'tl','',0),(272654,7574,'th','&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3605;&#3633;&#3657;&#3591;&#3621;&#3635;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(272655,7574,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤«à¥à¤²à¥ˆà¤Ÿ à¤¶à¥à¤²à¥à¤•',0),(272656,7574,'ms','Lapangan Terbang yuran rata',0),(272657,7574,'ar','Ù…Ø·Ø§Ø± Ø±Ø³ÙˆÙ… Ù…Ø³Ø·Ø­Ø©',0),(272658,7574,'fr','AÃ©roport Fee plat',0),(272659,7574,'jp','ç©ºæ¸¯æ–™ãƒ•ãƒ©ãƒƒãƒˆ',0),(272660,7574,'pt','Aeroporto taxa Flat',0),(272661,7574,'ru','ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð»Ð°Ñ‚Ð° Ð·Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ñƒ',0),(272662,7574,'es','Aeropuerto Cuota Fija',0),(272663,7574,'de','Flughafen Fee Wohnung',0),(272664,7574,'en','Airport Fee Flat',0),(272665,7575,'is','',0),(272666,7575,'dr','Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ø²Ø¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272667,7575,'pr','Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ø²Ø¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272668,7575,'tr','HavaalanÄ± Ã¼creti yÃ¼zde',0),(272669,7575,'pl','Port lotniczy opÅ‚ata procent',0),(272670,7575,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Ñ‚Ð°ÐºÑÐ° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(272671,7575,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ Ú©ÛŒ ÙÛŒØ³ ÙÛŒ ØµØ¯',0),(272672,7575,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ Ð½Ð°ÐºÐ½Ð°Ð´Ð° Ð¿Ð¾ÑÑ‚Ð¾',0),(272673,7575,'vi','% PhÃ­ SÃ¢n Bay',0),(272674,7575,'af','Lughawe fooi persent',0),(272675,7575,'ro','La sutÄƒ taxa de aeroport',0),(272676,7575,'et','Lennujaama tasu protsenti',0),(272677,7575,'si','LetaliÅ¡ke pristojbine odstotkov',0),(272678,7575,'ba','Bandara biaya persen',0),(272679,7575,'nl','Luchthaven vergoeding procent',0),(272680,7575,'fi','Airport lisÃ¤maksun prosentti',0),(272681,7575,'no','Flyplass avgift prosent',0),(272682,7575,'da','Lufthavn gebyr procent',0),(272683,7575,'ko','ê³µí•­ ìˆ˜ìˆ˜ë£Œ %',0),(272684,7575,'he','××—×•×– ×“×ž×™ × ×ž×œ ×”×ª×¢×•×¤×”',0),(272685,7575,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ Î±Î¼Î¿Î¹Î²Î® Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(272686,7575,'zh','æœºåœºè´¹çš„ç™¾åˆ†ä¹‹\r\n',0),(272687,7575,'sv','Flygplatsen avgift procent',0),(272688,7575,'it','Per cento di tassa di aeroporto',0),(272689,7575,'tl','',0),(272690,7575,'th','&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;&#3619;&#3657;&#3629;&#3618;&#3621;&#3632;',0),(272691,7575,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¤¾ à¤¶à¥à¤²à¥à¤• à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(272692,7575,'ms','Peratus bayaran Lapangan Terbang',0),(272693,7575,'ar','ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ø·Ø§Ø±',0),(272694,7575,'fr','Pourcentage de taxe aÃ©roport',0),(272695,7575,'jp','ç©ºæ¸¯æ–™é‡‘ã® ï¼…',0),(272696,7575,'pt','Por cento de taxa de aeroporto',0),(272697,7575,'ru','ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(272698,7575,'es','Aeropuerto Porcentaje de Cuota ',0),(272699,7575,'de','Flughafen GebÃ¼hr Prozent',0),(272700,7575,'en','Airport Fee Percent',0),(272701,7576,'is','',0),(272702,7576,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(272703,7576,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(272704,7576,'tr','HavaalanÄ± otopark tesis gÃ¼ncelleÅŸtirme',0),(272705,7576,'pl','Aktualizacja obiektu Parking Lotnisko',0),(272706,7576,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Ð¿Ð°Ñ€ÐºÐ¸Ð½Ð³ ÑÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(272707,7576,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ Ù¾Ø§Ø±Ú©Ù†Ú¯ Ú©ÛŒ Ø³ÛÙˆÙ„Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(272708,7576,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÐŸÐ°Ñ€ÐºÐ¸Ð½Ð³ Ð¿Ð¾ÑÑ‚Ñ€Ð¾Ñ˜ÐµÑšÐµ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(272709,7576,'vi','Cáº­p Nháº­t BÃ£i Xe SÃ¢n Bay',0),(272710,7576,'af','Lughawe Parkeer Fasiliteit Opdateer',0),(272711,7576,'ro','Aeroport parcare facilitatea de actualizare',0),(272712,7576,'et','Lennujaama parkla rajatise vÃ¤rskendus',0),(272713,7576,'si','LetaliÅ¡Äe parkiranje objekt posodobitev',0),(272714,7576,'ba','Bandara parkir fasilitas Update',0),(272715,7576,'nl','Luchthaven Parking Facility Update',0),(272716,7576,'fi','Airport Internet tilan pÃ¤ivitys',0),(272717,7576,'no','Flyplass parkering anlegget oppdatering',0),(272718,7576,'da','Lufthavn parkering facilitet opdatering',0),(272719,7576,'ko','ê³µí•­ ì£¼ì°¨ ì‹œì„¤ ì—…ë°ì´íŠ¸',0),(272720,7576,'he','×”×¢×“×›×•×Ÿ ×ž×ª×§×Ÿ ×—× ×™×” ×”×ª×¢×•×¤×”',0),(272721,7576,'el','Î‘ÎµÏÎ¿Î´ÏÏŒÎ¼Î¹Î¿ ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î·Ï‚ Î­ÎºÎ´Î¿ÏƒÎ·Ï‚',0),(272722,7576,'zh','æœºåœºåœè½¦è®¾æ–½çš„æ›´æ–°\r\n',0),(272723,7576,'sv','Flygplats parkering anlÃ¤ggning uppdatering',0),(272724,7576,'it','Aeroporto Parcheggio struttura aggiornamento',0),(272725,7576,'tl','',0),(272726,7576,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3592;&#3629;&#3604;&#3619;&#3606;&#3607;&#3637;&#3656;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(272727,7576,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(272728,7576,'ms','Kemaskini Kemudahan tempat letak kereta Lapangan Terbang',0),(272729,7576,'ar','Ø§Ù„Ù…Ø·Ø§Ø± ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ù…Ø±ÙÙ‚ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(272730,7576,'fr','Mise Ã  jour des installations de Parking aÃ©roport',0),(272731,7576,'jp','ç©ºæ¸¯é§è»Šå ´æ–½è¨­æ›´æ–°',0),(272732,7576,'pt','AtualizaÃ§Ã£o de facilidade de estacionamento de aeroporto',0),(272733,7576,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð±ÑŠÐµÐºÑ‚Ð° Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÐ° Ð°ÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(272734,7576,'es','Actualizar la Facilidad para Estacionar del Aeropuerto',0),(272735,7576,'de','Flughafen parken Anlage Update',0),(272736,7576,'en','Airport Parking Facility Update',0),(272737,7577,'is','',0),(272738,7577,'dr',' Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272739,7577,'pr',' Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(272740,7577,'tr','Ãœcretsiz havaalanÄ± Ã¼creti',0),(272741,7577,'pl','OpÅ‚ata za Lotnisko',0),(272742,7577,'bg','Ð¢Ð°ÐºÑÐ¸ Ð»ÐµÑ‚Ð¸Ñ‰Ðµ Ñ‚Ð°ÐºÑÐ°',0),(272743,7577,'ur','ÙÛŒØ³ Ú†Ø§Ø±Ø¬ ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆØ§',0),(272744,7577,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼',0),(272745,7577,'vi','PhÃ­ SÃ¢n Bay',0),(272746,7577,'af','Hef Lughawe Fooi',0),(272747,7577,'ro','Taxa de taxa de aeroport',0),(272748,7577,'et','Tasuta lennujaama tasu',0),(272749,7577,'si','StroÅ¡ek letaliÅ¡kih pristojbin',0),(272750,7577,'ba','Biaya biaya Bandara',0),(272751,7577,'nl','Gratis luchthaven vergoeding',0),(272752,7577,'fi','Ilmaiseksi Airport maksu',0),(272753,7577,'no','Gratis flyplass avgift',0),(272754,7577,'da','Afgift lufthavnsgebyr',0),(272755,7577,'ko','ìš”ê¸ˆ ê³µí•­ ìˆ˜ìˆ˜ë£Œ',0),(272756,7577,'he','× ×ž×œ ×”×ª×¢×•×¤×” ×ª×©×œ×•× ×“×ž×™',0),(272757,7577,'el','Î§ÏÎ­Ï‰ÏƒÎ· Î±ÎµÏÎ¿Î´ÏÎ¿Î¼Î¯Î¿Ï… Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(272758,7577,'zh','æ”¶å–æœºåœºè´¹\r\n',0),(272759,7577,'sv','Avgift flygplats avgift',0),(272760,7577,'it','Tassa di aeroporto di carica',0),(272761,7577,'tl','',0),(272762,7577,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(272763,7577,'hi','à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¤¾ à¤¶à¥à¤²à¥à¤•',0),(272764,7577,'ms','Bayaran Lapangan Terbang bayaran',0),(272765,7577,'ar','Ø±Ø³ÙˆÙ… Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ø·Ø§Ø±',0),(272766,7577,'fr','Frais aÃ©roportuaire',0),(272767,7577,'jp','ç„¡æ–™ç©ºæ¸¯æ–™é‡‘',0),(272768,7577,'pt','Taxa de aeroporto de carga',0),(272769,7577,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° ÑÐ±Ð¾Ñ€ Ð°ÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(272770,7577,'es','Cargar Cuotas de Aeropuerto',0),(272771,7577,'de','Kostenlos Airport Fee',0),(272772,7577,'en','Charge Airport Fee',0),(272773,7578,'is','',0),(272774,7578,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯  Ø³ÙˆØ®Øª',0),(272775,7578,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯  Ø³ÙˆØ®Øª',0),(272776,7578,'tr','Åžarj yakÄ±t Ã¼creti',0),(272777,7578,'pl','OpÅ‚aty za paliwa',0),(272778,7578,'bg','Ð¢Ð°ÐºÑÐ° Ð³Ð¾Ñ€Ð¸Ð²Ð¾ Ñ‚Ð°ÐºÑÐ°',0),(272779,7578,'ur','Ú†Ø§Ø±Ø¬ Ø§ÛŒÙ†Ø¯Ú¾Ù† Ú©ÛŒ ÙÛŒØ³',0),(272780,7578,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð³Ð¾Ñ€Ð¸Ð²Ð°',0),(272781,7578,'vi','PhÃ­ nhiÃªn liá»‡u',0),(272782,7578,'af','Aanklag brandstof fooi',0),(272783,7578,'ro','Taxa de combustibil taxe',0),(272784,7578,'et','KÃ¼tuse lÃµiv',0),(272785,7578,'si','StroÅ¡ek goriva pristojbina',0),(272786,7578,'ba','Biaya bahan bakar biaya',0),(272787,7578,'nl','Lading brandstof vergoeding',0),(272788,7578,'fi','PeriÃ¤ polttoaineen maksun',0),(272789,7578,'no','Gratis drivstoff avgift',0),(272790,7578,'da','Gratis brÃ¦ndstof gebyr',0),(272791,7578,'ko','ì¶©ì „ ì—°ë£Œ ìˆ˜ìˆ˜ë£Œ',0),(272792,7578,'he','×ª×©×œ×•× ×“×ž×™ ×”×“×œ×§',0),(272793,7578,'el','Î§ÏÎ­Ï‰ÏƒÎ· ÎºÎ±Ï…ÏƒÎ¯Î¼Ï‰Î½ Î±Î¼Î¿Î¹Î²Î®',0),(272794,7578,'zh','æ”¶å–ç‡ƒæ²¹è´¹\r\n',0),(272795,7578,'sv','Avgift brÃ¤nsle avgift',0),(272796,7578,'it','Tassa carburante carica',0),(272797,7578,'tl','',0),(272798,7578,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3609;&#3657;&#3635;&#3617;&#3633;&#3609;',0),(272799,7578,'hi','à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤ˆà¤‚à¤§à¤¨ à¤¶à¥à¤²à¥à¤•',0),(272800,7578,'ms','Yuran caj bahan api',0),(272801,7578,'ar','Ø±Ø³ÙˆÙ… Ø´Ø­Ù† Ø§Ù„ÙˆÙ‚ÙˆØ¯',0),(272802,7578,'fr','Frais frais de carburant',0),(272803,7578,'jp','ç‡ƒæ–™è²»',0),(272804,7578,'pt','Taxa de combustÃ­vel de carga',0),(272805,7578,'ru','Ð—Ð°Ñ€ÑÐ´ Ñ‚Ð¾Ð¿Ð»Ð¸Ð²Ð½Ñ‹Ð¹ ÑÐ±Ð¾Ñ€',0),(272806,7578,'es','Cobrar Cuota de Combustible',0),(272807,7578,'de','Kraftstoff-GebÃ¼hr',0),(272808,7578,'en','Charge Fuel Fee',0),(272809,7579,'is','',0),(272810,7579,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯',0),(272811,7579,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯',0),(272812,7579,'tr','Otopark Ã¼creti ÅŸarj',0),(272813,7579,'pl','Za parkowanie, opÅ‚aty',0),(272814,7579,'bg','Ð¢Ð°ÐºÑÐ° Ð¿Ð°Ñ€ÐºÐ¸Ð½Ð³ Ñ‚Ð°ÐºÑÐ°',0),(272815,7579,'ur','Ù¾Ø§Ø±Ú©Ù†Ú¯ ÙÛŒØ³ Ú†Ø§Ø±Ø¬',0),(272816,7579,'sr','ÐÐ°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ð°Ñ€ÐºÐ¸Ñ€Ð°ÑšÐ°',0),(272817,7579,'vi','PhÃ­ Ä‘áº­u xe',0),(272818,7579,'af','Hef Parkeergeld',0),(272819,7579,'ro','Percepe taxa de parcare',0),(272820,7579,'et','Tasuta parkimine tasu',0),(272821,7579,'si','ZaraÄuna parkirne Fee',0),(272822,7579,'ba','Biaya parkir',0),(272823,7579,'nl','Opladen Parking tegen betaling',0),(272824,7579,'fi','PeriÃ¤ Parking Fee',0),(272825,7579,'no','Lade parkering avgift',0),(272826,7579,'da','OpkrÃ¦ve parkering gebyr',0),(272827,7579,'ko','ì£¼ì°¨ ìš”ê¸ˆ ì¶©ì „',0),(272828,7579,'he','×ª×©×œ×•× ×—× ×™×” ×‘×ª×©×œ×•×',0),(272829,7579,'el','Î§ÏÎµÏŽÎ½Î¿Ï…Î½ ÏƒÏ„Î±Î¸Î¼ÎµÏÎ¿Î½Ï„Î±Ï‚ Ï„Î·Î½ Î±Î¼Î¿Î¹Î²Î®',0),(272830,7579,'zh','æ”¶å–åœè½¦è´¹\r\n',0),(272831,7579,'sv','Ladda parkering avgift',0),(272832,7579,'it','Pagare la tassa di parcheggio',0),(272833,7579,'tl','',0),(272834,7579,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3607;&#3637;&#3656;&#3592;&#3629;&#3604;&#3619;&#3606;',0),(272835,7579,'hi','à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¶à¥à¤²à¥à¤• à¤šà¤¾à¤°à¥à¤œ',0),(272836,7579,'ms','Mengenakan bayaran tempat letak kereta',0),(272837,7579,'ar','ØªÙ‡Ù…Ø© ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ø±Ø³ÙˆÙ…',0),(272838,7579,'fr','Parking Ã  paiement frais',0),(272839,7579,'jp','é§è»Šæ–™é‡‘ã‚’è«‹æ±‚ã—ã¾ã™ã€‚',0),(272840,7579,'pt','Cobrar taxa de estacionamento',0),(272841,7579,'ru','Ð—Ð°Ñ€ÑÐ´, Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÐ°',0),(272842,7579,'es','Cobrar Cuota para Estacionar',0),(272843,7579,'de','GebÃ¼hrenpflichtiger Parkplatz GebÃ¼hr',0),(272844,7579,'en','Charge Parking Fee',0),(272845,7580,'is','',0),(272846,7580,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(272847,7580,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(272848,7580,'tr','Yetkili satÄ±ÅŸ vergisi',0),(272849,7580,'pl','OpÅ‚ata podatku',0),(272850,7580,'bg','Ð”Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(272851,7580,'ur','Ú†Ø§Ø±Ø¬ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³',0),(272852,7580,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(272853,7580,'vi','Thuáº¿ bÃ¡n hÃ ng',0),(272854,7580,'af','Hef Verkoopsbelasting',0),(272855,7580,'ro','Taxa TVA',0),(272856,7580,'et','Tasu kÃ¤ibemaksu',0),(272857,7580,'si','Prodajni davek zaraÄuna',0),(272858,7580,'ba','Biaya pajak penjualan',0),(272859,7580,'nl','Gratis Sales Tax',0),(272860,7580,'fi','Maksun arvonlisÃ¤veron',0),(272861,7580,'no','Gratis mva',0),(272862,7580,'da','Afgift Sales Tax',0),(272863,7580,'ko','ì¶©ì „ íŒë§¤ ì„¸ê¸ˆ',0),(272864,7580,'he','×ª×©×œ×•× ×ž×¢ ×ž',0),(272865,7580,'el','Î§ÏÎ­Ï‰ÏƒÎ· Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(272866,7580,'zh','å¾æ”¶è¥ä¸šç¨Ž\r\n',0),(272867,7580,'sv','Avgift moms',0),(272868,7580,'it','Addebito IVA',0),(272869,7580,'tl','',0),(272870,7580,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(272871,7580,'hi','à¤†à¤°à¥‹à¤ª à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°',0),(272872,7580,'ms','Caj cukai jualan',0),(272873,7580,'ar','Ø±Ø³ÙˆÙ… Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(272874,7580,'fr','Taxe de vente gratuitement',0),(272875,7580,'jp','æ‰‹æ•°æ–™ã®å£²ä¸Šç¨Ž',0),(272876,7580,'pt','Imposto sobre vendas de carga',0),(272877,7580,'ru','ÐÐ°Ð»Ð¾Ð³ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(272878,7580,'es','Cobrar IVA',0),(272879,7580,'de','Kostenlos-Umsatzsteuer',0),(272880,7580,'en','Charge Sales Tax',0),(272881,7581,'is','',0),(272882,7581,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø³ÙˆØ®Øª',0),(272883,7581,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø³ÙˆØ®Øª',0),(272884,7581,'tr','YakÄ±t giderleri',0),(272885,7581,'pl','Zasyp paliwa',0),(272886,7581,'bg','Ð¢Ð°ÐºÑÐ° Ð³Ð¾Ñ€Ð¸Ð²Ð¾',0),(272887,7581,'ur','Ø§ÛŒÙ†Ø¯Ú¾Ù† Ú†Ø§Ø±Ø¬',0),(272888,7581,'sr','ÐŸÑƒÑšÐµÑšÐµ Ð³Ð¾Ñ€Ð¸Ð²Ð°',0),(272889,7581,'vi','Chi phÃ­ nhiÃªn liá»‡u',0),(272890,7581,'af','Brandstof fooi',0),(272891,7581,'ro','Taxa de combustibil',0),(272892,7581,'et','KÃ¼tuse kulu',0),(272893,7581,'si','StroÅ¡ek goriva',0),(272894,7581,'ba','Biaya bahan bakar',0),(272895,7581,'nl','Brandstof kosten',0),(272896,7581,'fi','Polttoainemaksusta',0),(272897,7581,'no','Drivstoff kostnader',0),(272898,7581,'da','BrÃ¦ndstof afgift',0),(272899,7581,'ko','ì—°ë£Œ ì¶©ì „',0),(272900,7581,'he','×ª×©×œ×•× ×“×œ×§',0),(272901,7581,'el','Î§ÏÎ­Ï‰ÏƒÎ· ÎºÎ±Ï…ÏƒÎ¯Î¼Ï‰Î½',0),(272902,7581,'zh','ç‡ƒæ²¹è´¹\r\n',0),(272903,7581,'sv','BrÃ¤nsle kostnad',0),(272904,7581,'it','Carica di combustibile',0),(272905,7581,'tl','',0),(272906,7581,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3609;&#3657;&#3635;&#3617;&#3633;&#3609;',0),(272907,7581,'hi','à¤ˆà¤‚à¤§à¤¨ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(272908,7581,'ms','Caj bahan api',0),(272909,7581,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„ÙˆÙ‚ÙˆØ¯',0),(272910,7581,'fr','Frais de carburant',0),(272911,7581,'jp','ç‡ƒæ–™æ–™é‡‘',0),(272912,7581,'pt','Carga de combustÃ­vel',0),(272913,7581,'ru','Ð—Ð°Ñ€ÑÐ´ Ñ‚Ð¾Ð¿Ð»Ð¸Ð²Ð°',0),(272914,7581,'es','Cargo para Combustible',0),(272915,7581,'de','Kraftstoff kostenlos',0),(272916,7581,'en','Fuel Charge',0),(272917,7582,'is','',0),(272918,7582,'dr','Ù†Ø§Ù… Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ',0),(272919,7582,'pr','Ù†Ø§Ù… Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ',0),(272920,7582,'tr','Otopark tesisi adÄ±',0),(272921,7582,'pl','Nazwa obiektu parking',0),(272922,7582,'bg','ÐŸÐ°Ñ€ÐºÐ¸Ð½Ð³ ÑÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸Ðµ Ð¸Ð¼Ðµ',0),(272923,7582,'ur','Ù¾Ø§Ø±Ú©Ù†Ú¯ Ú©ÛŒ Ø³ÛÙˆÙ„Øª Ú©Ø§ Ù†Ø§Ù…',0),(272924,7582,'sr','Ð˜Ð¼Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ðµ Ð¿Ð°Ñ€ÐºÐ¸Ñ€Ð°ÑšÐµ',0),(272925,7582,'vi','TÃªn Ä‘áº­u xe',0),(272926,7582,'af','Parkeringfasiliteit Naam',0),(272927,7582,'ro','Numele de facilitate de parcare',0),(272928,7582,'et','Parkla rajatise nimetus',0),(272929,7582,'si','Parkiranje imenom objekta',0),(272930,7582,'ba','Nama fasilitas parkir',0),(272931,7582,'nl','Parkeren faciliteit naam',0),(272932,7582,'fi','PysÃ¤kÃ¶inti hyÃ¶dyntÃ¤mislaitoksen nimi',0),(272933,7582,'no','Parkering anlegget navn',0),(272934,7582,'da','Parkering facilitet navn',0),(272935,7582,'ko','ì£¼ì°¨ ì‹œì„¤ ì´ë¦„',0),(272936,7582,'he','×©× ×ž×ª×§×Ÿ ×—× ×™×”',0),(272937,7582,'el','ÎŒÎ½Î¿Î¼Î± Î´Î¹ÎµÏ…ÎºÏŒÎ»Ï…Î½ÏƒÎ· ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚',0),(272938,7582,'zh','åœè½¦è®¾æ–½åç§°\r\n',0),(272939,7582,'sv','Parkering Ã…tervinningsanlÃ¤ggningens namn',0),(272940,7582,'it','Nome della struttura di parcheggio',0),(272941,7582,'tl','',0),(272942,7582,'th','&#3594;&#3639;&#3656;&#3629;&#3626;&#3636;&#3656;&#3591;&#3629;&#3635;&#3609;&#3623;&#3618;&#3588;&#3623;&#3634;&#3617;&#3626;&#3632;&#3604;&#3623;&#3585;&#3607;&#3637;&#3656;&#3592;&#3629;&#3604;&#3619;&#3606;',0),(272943,7582,'hi','à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤¨à¤¾à¤®',0),(272944,7582,'ms','Nama kemudahan tempat letak kenderaan',0),(272945,7582,'ar','Ø§Ø³Ù… Ù…Ø±ÙÙ‚ ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª',0),(272946,7582,'fr','Nom de l\'installation de stationnement',0),(272947,7582,'jp','é§è»Šå ´æ–½è¨­å',0),(272948,7582,'pt','Nome de facilidade de estacionamento',0),(272949,7582,'ru','Ð˜Ð¼Ñ Ð¾Ð±ÑŠÐµÐºÑ‚Ð° Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÐ°',0),(272950,7582,'es','Nombre de la Facilidad para estacionar',0),(272951,7582,'de','Parkplatz Facility Name',0),(272952,7582,'en','Parking Facility Name',0),(272953,7583,'is','',0),(272954,7583,'dr','Ø«Ø§Ø¨Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(272955,7583,'pr','Ø«Ø§Ø¨Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(272956,7583,'tr','Komisyon, dÃ¼z',0),(272957,7583,'pl','Komisji z pÅ‚askim',0),(272958,7583,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð¿Ð»Ð¾ÑÑŠÐº',0),(272959,7583,'ur','Ú©ØªØ±Ù†ÙˆÚº ÙÙ„ÛŒÙ¹',0),(272960,7583,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° ÑÑ‚Ð°Ð½',0),(272961,7583,'vi','Hoa há»“ng 1 biá»ƒu giÃ¡',0),(272962,7583,'af','Doen plat',0),(272963,7583,'ro','Comision plat',0),(272964,7583,'et','Komisjoni Ã¼htse',0),(272965,7583,'si','Komisije stanovanje',0),(272966,7583,'ba','Komisi datar',0),(272967,7583,'nl','Flat van de Commissie',0),(272968,7583,'fi','Komission taulu',0),(272969,7583,'no','Kommisjonen Flat',0),(272970,7583,'da','Kommissionens faste',0),(272971,7583,'ko','íŽ¸í‰í•œ ìœ„ì›íšŒ',0),(272972,7583,'he','×¢×ž×œ×” ×©×˜×•×—',0),(272973,7583,'el','Î¤Î·Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î·Ï‚',0),(272974,7583,'zh','å›ºå®šä½£é‡‘\r\n',0),(272975,7583,'sv','Kommissionens platt',0),(272976,7583,'it','Piatto della Commissione',0),(272977,7583,'tl','',0),(272978,7583,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(272979,7583,'hi','à¤†à¤¯à¥‹à¤— à¤•à¥‡ à¤«à¥à¤²à¥ˆà¤Ÿ',0),(272980,7583,'ms','Suruhanjaya rata',0),(272981,7583,'ar','Ù‡ÙŠØ¦Ø© Ù…Ø³Ø·Ø­Ø©',0),(272982,7583,'fr','Plat de la Commission',0),(272983,7583,'jp','å§”å“¡ä¼šã¯ãƒ•ãƒ©ãƒƒãƒˆ',0),(272984,7583,'pt','Plano da ComissÃ£o',0),(272985,7583,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ñ Ñ Ð¿Ð»Ð¾ÑÐºÐ¸Ð¼',0),(272986,7583,'es','ComisiÃ³n Fijo',0),(272987,7583,'de','Wohnung der Kommission',0),(272988,7583,'en','Commission Flat',0),(272989,7584,'is','',0),(272990,7584,'dr','Ø¯Ø±ØµØ¯ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(272991,7584,'pr','Ø¯Ø±ØµØ¯ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(272992,7584,'tr','Komisyon yÃ¼zdesi',0),(272993,7584,'pl','Procent Komisji',0),(272994,7584,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(272995,7584,'ur','Ú©Ù…ÛŒØ´Ù† ÙÛŒØµØ¯',0),(272996,7584,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¿Ð¾ÑÑ‚Ð¾',0),(272997,7584,'vi','% Hoa há»“ng',0),(272998,7584,'af','Kommissie Persent',0),(272999,7584,'ro','Comisia la sutÄƒ',0),(273000,7584,'et','Komisjoni protsenti',0),(273001,7584,'si','Komisija odstotkov',0),(273002,7584,'ba','Komisi persen',0),(273003,7584,'nl','Commissie procent',0),(273004,7584,'fi','Komission prosenttia',0),(273005,7584,'no','Kommisjonen prosent',0),(273006,7584,'da','Kommissionen procent',0),(273007,7584,'ko','ìœ„ì›íšŒ %',0),(273008,7584,'he','××—×•×– ×¢×ž×œ×”',0),(273009,7584,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(273010,7584,'zh','ä½£é‡‘ç™¾åˆ†æ¯”\r\n',0),(273011,7584,'sv','Kommissionen procent',0),(273012,7584,'it','Commissione percentuale',0),(273013,7584,'tl','',0),(273014,7584,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3588;&#3656;&#3634;&#3609;&#3634;&#3618;&#3627;&#3609;&#3657;&#3634;',0),(273015,7584,'hi','à¤•à¤®à¥€à¤¶à¤¨ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(273016,7584,'ms','Peratus komisen',0),(273017,7584,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù„Ù„Ø¹Ù…ÙˆÙ„Ø©',0),(273018,7584,'fr','Pour cent de Commission',0),(273019,7584,'jp','æ­©åˆ (%)',0),(273020,7584,'pt','Por cento de ComissÃ£o',0),(273021,7584,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(273022,7584,'es','ComisiÃ³n Porcentaje',0),(273023,7584,'de','Kommission Prozent',0),(273024,7584,'en','Commission Percent',0),(273025,7585,'is','',0),(273026,7585,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(273027,7585,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(273028,7585,'tr','HavaalanÄ± otopark tesis ekleme',0),(273029,7585,'pl','Dodawanie obiektu Parking Lotnisko',0),(273030,7585,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»ÐµÑ‚Ð¸Ñ‰Ðµ Ð¿Ð°Ñ€ÐºÐ¸Ð½Ð³ ÑÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸Ðµ',0),(273031,7585,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ Ù¾Ø§Ø±Ú©Ù†Ú¯ Ú©ÛŒ Ø³ÛÙˆÙ„Øª Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(273032,7585,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÐŸÐ°Ñ€ÐºÐ¸Ð½Ð³ Ð¿Ð¾ÑÑ‚Ñ€Ð¾Ñ˜ÐµÑšÐµ',0),(273033,7585,'vi','ThÃªm BÃ£i Xe SÃ¢n Bay',0),(273034,7585,'af','Lughawe parkering fasiliteit voeg',0),(273035,7585,'ro','Adauga facilitatea de parcare aeroport',0),(273036,7585,'et','Lennujaama parkla lisamine',0),(273037,7585,'si','LetaliÅ¡Äe parkiranje objekt dodamo',0),(273038,7585,'ba','Fasilitas parkir Bandara menambahkan',0),(273039,7585,'nl','Luchthaven parkeergelegenheid toevoegen',0),(273040,7585,'fi','Airport pysÃ¤kÃ¶intilaitos lisÃ¤Ã¤',0),(273041,7585,'no','Flyplassen parkeringsanlegg legge',0),(273042,7585,'da','Lufthavnen parkeringsanlÃ¦g tilfÃ¸je',0),(273043,7585,'ko','ê³µí•­ ì£¼ì°¨ ì‹œì„¤ ì¶”ê°€',0),(273044,7585,'he','×ž×ª×§×Ÿ ×—× ×™×” ×”×ª×¢×•×¤×” ×œ×”×•×¡×™×£',0),(273045,7585,'el','Î§ÏŽÏÎ¿Ï‚ ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚ Î±ÎµÏÎ¿Î´ÏÎ¿Î¼Î¯Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(273046,7585,'zh','æœºåœºåœè½¦è®¾æ–½æ·»åŠ \r\n',0),(273047,7585,'sv','Flygplats parkeringsanlÃ¤ggning lÃ¤gga',0),(273048,7585,'it','Aeroporto Parcheggio aggiungere',0),(273049,7585,'tl','',0),(273050,7585,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3623;&#3634;&#3617;&#3626;&#3632;&#3604;&#3623;&#3585;&#3651;&#3609;&#3585;&#3634;&#3619;&#3592;&#3629;&#3604;&#3619;&#3606;&#3607;&#3637;&#3656;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(273051,7585,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(273052,7585,'ms','Menambah kemudahan tempat meletak kereta di Lapangan Terbang',0),(273053,7585,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø±ÙÙ‚ Ù„ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª ÙÙŠ Ù…Ø·Ø§Ø±',0),(273054,7585,'fr','Ajouter AÃ©roport Parking privatif',0),(273055,7585,'jp','ç©ºæ¸¯é§è»Šå ´ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(273056,7585,'pt','Facilidade de estacionamento do Aeroporto adicionar',0),(273057,7585,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÐ¸',0),(273058,7585,'es','Agregar Facilidad para Estacionar del Aeropuerto',0),(273059,7585,'de','Flughafen-Parkplatz hinzufÃ¼gen',0),(273060,7585,'en','Airport Parking Facility Add',0),(273061,7586,'is','',0),(273062,7586,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÙŠØ¯ ÙÙ‚Ø· Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(273063,7586,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÙŠØ¯ ÙÙ‚Ø· Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(273064,7586,'tr','SatÄ±nalma miktarÄ± sadece PO gÃ¶ster:',0),(273065,7586,'pl','PokaÅ¼ iloÅ›Ä‡ zakupu tylko na PO',0),(273066,7586,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ñ€Ð¸ÐµÐ¼Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ°Ð¼Ð¾ Ð½Ð° PO',0),(273067,7586,'ur','ØµØ±Ù Ù¾ÙˆØ³Ù¹ Ù¾Ø± Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(273068,7586,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð˜Ð·Ð»Ð°Ð·Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑÐ°Ð¼Ð¾ Ð½Ð° Ð¿Ð¾-Ð°',0),(273069,7586,'vi','Chá»‰ Hiá»ƒn thá»‹ sá»‘ lÆ°á»£ng hÃ ng Ä‘Ã£ mua trÃªn Ä‘Æ¡n mua hÃ ng',0),(273070,7586,'af','Wys Aankoop Hoeveelheid Slegs op AB',0),(273071,7586,'ro','AratÄƒ cantitatea de cumpÄƒrare numai pe PO',0),(273072,7586,'et','NÃ¤itab ostukogus ainult PO',0),(273073,7586,'si','PokaÅ¾i koliÄino nakupa le na PO',0),(273074,7586,'ba','Tampilkan jumlah pembelian hanya di PO',0),(273075,7586,'nl','Aankoop hoeveelheid Toon alleen op PO',0),(273076,7586,'fi','NÃ¤ytÃ¤ ostojen mÃ¤Ã¤rÃ¤ vain PO',0),(273077,7586,'no','Vis innkjÃ¸psantall bare pÃ¥ PO',0),(273078,7586,'da','Vis kÃ¸bsantallet kun pÃ¥ PO',0),(273079,7586,'ko','í¬ì—ë§Œ êµ¬ë§¤ ìˆ˜ëŸ‰ì„ í‘œì‹œ',0),(273080,7586,'he','×”×¦×’ ××ª ×›×ž×•×ª ×”×¨×›×™×©×” ×¨×§ ×¢×œ ×¤×•',0),(273081,7586,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î±Î³Î¿ÏÎ¬ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î¼ÏŒÎ½Î¿ ÏƒÎµ PO',0),(273082,7586,'zh','åªæ˜¾ç¤ºé‡‡è´­è®¢å•ä¸Šçš„è´­ä¹°æ•°é‡\r\n',0),(273083,7586,'sv','Visa inkÃ¶pskvantiteten bara fÃ¶r PO',0),(273084,7586,'it','Visualizza la quantitÃ  di acquisto solo su PO',0),(273085,7586,'tl','',0),(273086,7586,'th','&#3649;&#3626;&#3604;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(273087,7586,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥‹ à¤ªà¤° à¤–à¤°à¥€à¤¦ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(273088,7586,'ms','Menunjukkan kuantiti pembelian hanya pada PO',0),(273089,7586,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙƒÙ…ÙŠØ© Ø§Ù„Ø´Ø±Ø§Ø¡ ÙÙ‚Ø· Ø¹Ù„Ù‰ Ø¨Ùˆ',0),(273090,7586,'fr','Voir la quantitÃ© d\'achat que le PO',0),(273091,7586,'jp','PO ã«ã®ã¿è³¼å…¥æ•°é‡ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(273092,7586,'pt','Mostrar Quantidade Comprada Somente  na OC',0),(273093,7586,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð½Ð° PO',0),(273094,7586,'es','Mostrar Solo Cantidad de Compra en el OC',0),(273095,7586,'de','Einkaufsmenge nur auf PO anzeigen',0),(273096,7586,'en','Show Purchase Quantity Only on PO',0),(273097,7587,'is','',0),(273098,7587,'dr','ÙƒÙ¾ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(273099,7587,'pr','ÙƒÙ¾ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(273100,7587,'tr','Klon PO',0),(273101,7587,'pl','PO klon',0),(273102,7587,'bg','ÐšÐ»Ð¾Ð½Ð¸Ð½Ð³ PO',0),(273103,7587,'ur','Ú©Ù„ÙˆÙ† Ù¾Ùˆ',0),(273104,7587,'sr','ÐšÐ»Ð¾Ð½ ÐŸÐž',0),(273105,7587,'vi','ÄÆ¡n mua hÃ ng Clone',0),(273106,7587,'af','Kloon AB',0),(273107,7587,'ro','Clona PO',0),(273108,7587,'et','Kloonide PO',0),(273109,7587,'si','Klon PO',0),(273110,7587,'ba','Klon PO',0),(273111,7587,'nl','Kloon PO',0),(273112,7587,'fi','Klooni PO',0),(273113,7587,'no','Klone PO',0),(273114,7587,'da','Klon PO',0),(273115,7587,'ko','í´ë¡  í¬',0),(273116,7587,'he','×œ×©×‘×˜ ×¤×•',0),(273117,7587,'el','ÎšÎ»ÏŽÎ½Î¿Ï‚ PO',0),(273118,7587,'zh','å¤åˆ¶é‡‡è´­è®¢å•\r\n',0),(273119,7587,'sv','Klon PO',0),(273120,7587,'it','Clonare PO',0),(273121,7587,'tl','',0),(273122,7587,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(273123,7587,'hi','à¤•à¥à¤²à¥‹à¤¨ à¤ªà¥‹',0),(273124,7587,'ms','Klon PO',0),(273125,7587,'ar','Ù†Ø³Ø® Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(273126,7587,'fr','Clone PO',0),(273127,7587,'jp','PO ã®ã‚¯ãƒ­ãƒ¼ãƒ³ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(273128,7587,'pt','Clone PO',0),(273129,7587,'ru','ÐšÐ»Ð¾Ð½ PO',0),(273130,7587,'es','Clonar OC',0),(273131,7587,'de','Klon-PO',0),(273132,7587,'en','Clone PO',0),(273133,7588,'is','',0),(273134,7588,'dr','Ø¯Ø³ØªØ±Ø³ÙŠ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(273135,7588,'pr','Ø¯Ø³ØªØ±Ø³ÙŠ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡ ',0),(273136,7588,'tr','HavaalanÄ±na eriÅŸim',0),(273137,7588,'pl','DostÄ™pu do portÃ³w lotniczych',0),(273138,7588,'bg','Ð”Ð¾ÑÑ‚ÑŠÐ¿Ð° Ð´Ð¾ Ð»ÐµÑ‚Ð¸Ñ‰Ð°Ñ‚Ð°',0),(273139,7588,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ’ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ',0),(273140,7588,'sr','ÐŸÑ€Ð¸ÑÑ‚ÑƒÐ¿ Ð°ÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼Ñƒ',0),(273141,7588,'vi','Truy Cáº­p SÃ¢n bay',0),(273142,7588,'af','Lughawe Toegang',0),(273143,7588,'ro','Acces aeroport',0),(273144,7588,'et','JuurdepÃ¤Ã¤su lennuvÃ¤ljale',0),(273145,7588,'si','Dostop do letaliÅ¡Ä',0),(273146,7588,'ba','Akses Bandara',0),(273147,7588,'nl','Toegang tot luchthavens',0),(273148,7588,'fi','LentokenttÃ¤kuljetus',0),(273149,7588,'no','Flyplassen tilgang',0),(273150,7588,'da','Adgang til lufthavne',0),(273151,7588,'ko','ê³µí•­ ì ‘ê·¼',0),(273152,7588,'he','×’×™×©×” ×œ× ×ž×œ ×”×ª×¢×•×¤×”',0),(273153,7588,'el','Î ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÏ„Î¿Ï…Ï‚ Î±ÎµÏÎ¿Î»Î¹Î¼Î­Î½ÎµÏ‚',0),(273154,7588,'zh','æœºåœºå…¥å£\r\n',0),(273155,7588,'sv','Flygplatsen tillgÃ¥ng',0),(273156,7588,'it','Accesso aeroporto',0),(273157,7588,'tl','',0),(273158,7588,'th','&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(273159,7588,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤ªà¤¹à¥à¤à¤š',0),(273160,7588,'ms','Lapangan Terbang akses',0),(273161,7588,'ar','Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø·Ø§Ø±',0),(273162,7588,'fr','AccÃ¨s Ã  l\'aÃ©roport',0),(273163,7588,'jp','ç©ºæ¸¯ã¸ã®ã‚¢ã‚¯ã‚»ã‚¹',0),(273164,7588,'pt','Acesso do Aeroporto',0),(273165,7588,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿ ÐÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð°',0),(273166,7588,'es','Aeropuerto Acceso',0),(273167,7588,'de','Flughafen-Zugang',0),(273168,7588,'en','Airport Access',0),(273169,7589,'is','',0),(273170,7589,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø±Ø²Ø±Ùˆ Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(273171,7589,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø±Ø²Ø±Ùˆ Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ÙØ±ÙˆØ¯Ú¯Ø§Ù‡',0),(273172,7589,'tr','HavaalanÄ± otopark tesis rezervasyon rapor',0),(273173,7589,'pl','Lotnisko Parking zakÅ‚adu rezerwacji raport',0),(273174,7589,'bg','Ð›ÐµÑ‚Ð¸Ñ‰Ðµ Ð¿Ð°Ñ€ÐºÐ¸Ð½Ð³ ÑÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸Ðµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð° Ð´Ð¾ÐºÐ»Ð°Ð´',0),(273175,7589,'ur','ÛÙˆØ§Ø¦ÛŒ Ø§ÚˆÛ Ù¾Ø§Ø±Ú©Ù†Ú¯ Ú©ÛŒ Ø³ÛÙˆÙ„Øª Ø¨Ú©Ù†Ú¯ Ø±Ù¾ÙˆØ±Ù¹',0),(273176,7589,'sr','ÐÐµÑ€Ð¾Ð´Ñ€Ð¾Ð¼ ÐŸÐ°Ñ€ÐºÐ¸Ð½Ð³ Ð¿Ð¾ÑÑ‚Ñ€Ð¾Ñ˜ÐµÑšÐµ Ñ€ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ˜Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(273177,7589,'vi','BÃ¡o CÃ¡o Giá»¯ TrÆ°á»›c Chá»— Äáº­u Xe SÃ¢n Bay',0),(273178,7589,'af','Lughawe Parkeringfasiliteit Reserveringsverslag',0),(273179,7589,'ro','Aeroport parcare facilitatea rezervare raport',0),(273180,7589,'et','Lennujaama parkla rajatise broneeringu aruanne',0),(273181,7589,'si','LetaliÅ¡Äe parkiranje objekt rezervacije poroÄilo',0),(273182,7589,'ba','Bandara parkir fasilitas reservasi laporan',0),(273183,7589,'nl','Luchthaven parking reservering raport',0),(273184,7589,'fi','LentokenttÃ¤ pysÃ¤kÃ¶inti laitos varaus raportti',0),(273185,7589,'no','Flyplass parkering anlegget Booking rapport',0),(273186,7589,'da','Lufthavn parkering facilitet Reservation rapport',0),(273187,7589,'ko','ê³µí•­ ì£¼ì°¨ ì‹œì„¤ ì˜ˆì•½ ë³´ê³ ì„œ',0),(273188,7589,'he','× ×ž×œ ×”×ª×¢×•×¤×” ×—× ×™×™×” ×ž×ª×§×Ÿ ×”×–×ž× ×ª ×“×•×—',0),(273189,7589,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ ÎºÏÎ¬Ï„Î·ÏƒÎ·Ï‚ Î´Î¹ÎµÏ…ÎºÏŒÎ»Ï…Î½ÏƒÎ·Ï‚ ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚ Î±ÎµÏÎ¿Î´ÏÎ¿Î¼Î¯Î¿Ï…',0),(273190,7589,'zh','é¢„è®¢æœºåœºåœè½¦è®¾æ–½çš„æŠ¥å‘Š\r\n',0),(273191,7589,'sv','Flygplats parkering anlÃ¤ggning bokning rapport',0),(273192,7589,'it','Aeroporto Parcheggio struttura prenotazione Report',0),(273193,7589,'tl','',0),(273194,7589,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3592;&#3629;&#3591;&#3607;&#3637;&#3656;&#3592;&#3629;&#3604;&#3619;&#3606;&#3607;&#3637;&#3656;&#3626;&#3609;&#3634;&#3617;&#3610;&#3636;&#3609;',0),(273195,7589,'hi','à¤¹à¤µà¤¾à¤ˆ à¤…à¤¡à¥à¤¡à¥‡ à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤†à¤°à¤•à¥à¤·à¤£ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(273196,7589,'ms','Laporan Tempahan kemudahan tempat letak kereta Lapangan Terbang',0),(273197,7589,'ar','Ø§Ù„Ù…Ø·Ø§Ø± ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ù…Ø±ÙÙ‚ ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø­Ø¬Ø²',0),(273198,7589,'fr','Rapport de rÃ©servation AÃ©roport Parking facilitÃ©',0),(273199,7589,'jp','ç©ºæ¸¯é§è»Šå ´æ–½è¨­äºˆç´„ãƒ¬ãƒãƒ¼ãƒˆ',0),(273200,7589,'pt','RelatÃ³rio de reserva de facilidade de estacionamento Aeroporto',0),(273201,7589,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾ Ð±Ñ€Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ð¾Ð±ÑŠÐµÐºÑ‚Ð° Ð°ÑÑ€Ð¾Ð¿Ð¾Ñ€Ñ‚Ð° Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÐ°',0),(273202,7589,'es','Informe de Reservaciones de la Facilidad para Estacionar del Aeropuerto ',0),(273203,7589,'de','Flughafen Parkplatz MÃ¶glichkeit Reservierungsbericht',0),(273204,7589,'en','Airport Parking Facility Reservation Report',0),(273205,7590,'is','',0),(273206,7590,'dr','ÙˆØ±ÙˆØ¯ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹',0),(273207,7590,'pr','ÙˆØ±ÙˆØ¯ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹',0),(273208,7590,'tr','GiriÅŸ baÅŸlangÄ±Ã§ tarihi',0),(273209,7590,'pl','Data przyjazdu rozp.',0),(273210,7590,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¸ÑÑ‚Ð¸Ð³Ð°Ð½Ðµ',0),(273211,7590,'ur','Ø´Ø±ÙˆØ¹ Ú©ÛŒ Ø¢Ù…Ø¯ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(273212,7590,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð´Ð¾Ð»Ð°ÑÐºÐ°',0),(273213,7590,'vi','NgÃ y Báº¯t Äáº§u Äáº¿n',0),(273214,7590,'af','Aankoms Begin datum',0),(273215,7590,'ro','Data de inceput de sosire',0),(273216,7590,'et','Saabumine alguskuupÃ¤ev',0),(273217,7590,'si','ZaÄetni datum prihoda',0),(273218,7590,'ba','Tanggal mulai',0),(273219,7590,'nl','Aankomst begindatum',0),(273220,7590,'fi','Aloita saapumista',0),(273221,7590,'no','Start ankomstdato',0),(273222,7590,'da','Begynd ankomstdato',0),(273223,7590,'ko','ì‹œìž‘ ë‚ ì§œ',0),(273224,7590,'he','×ª××¨×™×›×™ ×”×”×ª×—×œ×”',0),(273225,7590,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¬Ï†Î¹Î¾Î·Ï‚',0),(273226,7590,'zh','åˆ°è¾¾å¼€å§‹æ—¥æœŸ\r\n',0),(273227,7590,'sv','BÃ¶rja ankomstdatum',0),(273228,7590,'it','Data di arrivo Begin',0),(273229,7590,'tl','',0),(273230,7590,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3617;&#3634;&#3606;&#3638;&#3591;',0),(273231,7590,'hi','à¤†à¤—à¤®à¤¨ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(273232,7590,'ms','Mulakan tarikh',0),(273233,7590,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ ÙˆØµÙˆÙ„',0),(273234,7590,'fr','Date de dÃ©but d\'arrivÃ©e',0),(273235,7590,'jp','é–‹å§‹æ—¥å’Œ',0),(273236,7590,'pt','Data de chegada Begin',0),(273237,7590,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ð·Ð°ÐµÐ·Ð´Ð°',0),(273238,7590,'es','Llegada Fecha de Comienzo',0),(273239,7590,'de','Beginnen Ankunftsdatum',0),(273240,7590,'en','Arrival Begin Date',0),(273241,7591,'is','',0),(273242,7591,'dr','ØªØ§Ø±ÙŠØ® ÙˆØ±ÙˆØ¯',0),(273243,7591,'pr','ØªØ§Ø±ÙŠØ® ÙˆØ±ÙˆØ¯',0),(273244,7591,'tr','GeliÅŸ Tarihi',0),(273245,7591,'pl','Data przyjazdu',0),(273246,7591,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¸ÑÑ‚Ð¸Ð³Ð°Ð½Ðµ',0),(273247,7591,'ur','Ø¢Ù…Ø¯ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(273248,7591,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð´Ð¾Ð»Ð°ÑÐºÐ°',0),(273249,7591,'vi','NgÃ y Äáº¿n',0),(273250,7591,'af','Aankoms datum',0),(273251,7591,'ro','Data sosirii',0),(273252,7591,'et','Saabumise kuupÃ¤ev',0),(273253,7591,'si','Datum prihoda',0),(273254,7591,'ba','Tanggal keberangkatan',0),(273255,7591,'nl','Datum van aankomst',0),(273256,7591,'fi','SaapumispÃ¤ivÃ¤',0),(273257,7591,'no','Ankomstdato',0),(273258,7591,'da','Ankomstdato',0),(273259,7591,'ko','ë„ì°© ë‚ ì§œ',0),(273260,7591,'he','×ª××¨×™×š ×”×”×’×¢×”',0),(273261,7591,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¬Ï†Î¹Î¾Î·Ï‚',0),(273262,7591,'zh','åˆ°è¾¾æ—¥æœŸ\r\n',0),(273263,7591,'sv','Ankomstdatum',0),(273264,7591,'it','Data di arrivo',0),(273265,7591,'tl','',0),(273266,7591,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3617;&#3634;&#3606;&#3638;&#3591;',0),(273267,7591,'hi','à¤†à¤—à¤®à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(273268,7591,'ms','Tarikh ketibaan',0),(273269,7591,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙˆØµÙˆÙ„',0),(273270,7591,'fr','Date d\'arrivÃ©e',0),(273271,7591,'jp','åˆ°ç€æ—¥',0),(273272,7591,'pt','Data de chegada',0),(273273,7591,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ñ€Ð¸Ð±Ñ‹Ñ‚Ð¸Ñ',0),(273274,7591,'es','Llegada Fecha',0),(273275,7591,'de','Ankunftsdatum',0),(273276,7591,'en','Arrival Date',0),(273277,7592,'is','',0),(273278,7592,'dr','ÙˆØ±ÙˆØ¯ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù†',0),(273279,7592,'pr','ÙˆØ±ÙˆØ¯ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù†',0),(273280,7592,'tr','VarÄ±ÅŸ bitiÅŸ tarihi',0),(273281,7592,'pl','Data zakoÅ„czenia przyjazdu',0),(273282,7592,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¸ÑÑ‚Ð¸Ð³Ð°Ð½Ðµ',0),(273283,7592,'ur','Ø¢Ù…Ø¯ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(273284,7592,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð´Ð¾Ð»Ð°ÑÐºÐ°',0),(273285,7592,'vi','NgÃ y Káº¿t ThÃºc Äáº¿n',0),(273286,7592,'af','Aankoms Einddatum',0),(273287,7592,'ro','Data de sfÃ¢rÅŸit sosirii',0),(273288,7592,'et','Saabumine lÃµppkuupÃ¤ev',0),(273289,7592,'si','KonÄni datum prihoda',0),(273290,7592,'ba','Tanggal akhir',0),(273291,7592,'nl','Aankomst einddatum',0),(273292,7592,'fi','Saapuminen pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(273293,7592,'no','Ankomst sluttdatoen',0),(273294,7592,'da','Ankomst slutdato',0),(273295,7592,'ko','ë ë‚ ì§œ',0),(273296,7592,'he','×ª××¨×™×›×™ ×¡×™×•×',0),(273297,7592,'el','Î¤Î­Î»Î¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¬Ï†Î¹Î¾Î·Ï‚',0),(273298,7592,'zh','åˆ°è¾¾ç»“æŸæ—¥æœŸ\r\n',0),(273299,7592,'sv','Ankomst slutdatum',0),(273300,7592,'it','Data di arrivo finale',0),(273301,7592,'tl','',0),(273302,7592,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3617;&#3634;&#3606;&#3638;&#3591;',0),(273303,7592,'hi','à¤†à¤—à¤®à¤¨ à¤…à¤‚à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(273304,7592,'ms','Tarikh akhir',0),(273305,7592,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙˆØµÙˆÙ„',0),(273306,7592,'fr','Date de fin d\'arrivÃ©e',0),(273307,7592,'jp','åˆ°ç€çµ‚äº†æ—¥',0),(273308,7592,'pt','Data final de chegada',0),(273309,7592,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ñ€Ð¸Ð±Ñ‹Ñ‚Ð¸Ñ',0),(273310,7592,'es','Llegada Fecha de TerminaciÃ³n',0),(273311,7592,'de','Anreise-Enddatum',0),(273312,7592,'en','Arrival End Date',0),(273313,7593,'is','',0),(273314,7593,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø³Ø±ÙˆÙŠØ³ Ø®ÙˆØ¯ÙƒØ§Ø±',0),(273315,7593,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø³Ø±ÙˆÙŠØ³ Ø®ÙˆØ¯ÙƒØ§Ø±',0),(273316,7593,'tr','Otomatik hizmet Ã¼creti',0),(273317,7593,'pl','Auto Service Fee',0),(273318,7593,'bg','ÐÐ²Ñ‚Ð¾ ÑÐµÑ€Ð²Ð¸Ð· Ñ‚Ð°ÐºÑÐ°',0),(273319,7593,'ur','Ø¢Ù¹Ùˆ Ø³Ø±ÙˆØ³ Ú©ÛŒ ÙÛŒØ³',0),(273320,7593,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ Ð°ÑƒÑ‚Ð¾',0),(273321,7593,'vi','PhÃ­ Dá»‹ch Vá»¥ Tá»± Äá»™ng',0),(273322,7593,'af','Outomatiese Diensfooi',0),(273323,7593,'ro','Taxa de Service auto',0),(273324,7593,'et','Auto teenustasu',0),(273325,7593,'si','Pristojbina za storitve Auto',0),(273326,7593,'ba','Biaya layanan Auto',0),(273327,7593,'nl','Auto Service Fee',0),(273328,7593,'fi','Auto Palvelumaksu',0),(273329,7593,'no','Auto serviceavgift',0),(273330,7593,'da','Auto servicegebyr',0),(273331,7593,'ko','ìžë™ ì„œë¹„ìŠ¤ ìš”ê¸ˆ',0),(273332,7593,'he','×“×ž×™ ×©×™×¨×•×ª ××•×˜×•×ž×˜×™',0),(273333,7593,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(273334,7593,'zh','æ±½è½¦æœåŠ¡è´¹\r\n',0),(273335,7593,'sv','Auto serviceavgift',0),(273336,7593,'it','Costo del servizio di auto',0),(273337,7593,'tl','',0),(273338,7593,'th','&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;',0),(273339,7593,'hi','à¤‘à¤Ÿà¥‹ à¤¸à¥‡à¤µà¤¾ à¤¶à¥à¤²à¥à¤•',0),(273340,7593,'ms','Yuran perkhidmatan auto',0),(273341,7593,'ar','Ø±Ø³ÙˆÙ… Ø®Ø¯Ù…Ø© Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª',0),(273342,7593,'fr','Frais de Service auto',0),(273343,7593,'jp','è‡ªå‹•ã‚µãƒ¼ãƒ“ã‚¹æ–™é‡‘',0),(273344,7593,'pt','Taxa de serviÃ§o de auto',0),(273345,7593,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ Ð°Ð²Ñ‚Ð¾',0),(273346,7593,'es','Auto Cuota de Servicio ',0),(273347,7593,'de','Auto-Service-GebÃ¼hr',0),(273348,7593,'en','Auto Service Fee',0),(273349,7594,'is','',0),(273350,7594,'dr','(Ø®Ø±ÙˆØ¬',0),(273351,7594,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø§Ù†Ø­Ø±Ø§Ù(Ø®Ø±ÙˆØ¬',0),(273352,7594,'tr','KalkÄ±ÅŸ baÅŸlangÄ±Ã§ tarihi',0),(273353,7594,'pl','Data rozpoczÄ™cia wyjazdu',0),(273354,7594,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ð¼Ð¸Ð½Ð°Ð²Ð°Ð½Ðµ',0),(273355,7594,'ur','Ø±ÙˆØ§Ù†Ú¯ÛŒ Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(273356,7594,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð·Ð° Ð¾Ð´Ð»Ð°Ð·Ð°Ðº',0),(273357,7594,'vi','NgÃ y báº¯t Ä‘áº§u khá»Ÿi hÃ nh',0),(273358,7594,'af','Vertrekdatum Begin',0),(273359,7594,'ro','Data de inceput de plecare',0),(273360,7594,'et','Lahkumine alguskuupÃ¤ev',0),(273361,7594,'si','ZaÄetni datum odhoda',0),(273362,7594,'ba','Tanggal mulai',0),(273363,7594,'nl','Begindatum van vertrek',0),(273364,7594,'fi','Aloita lÃ¤htÃ¶pÃ¤ivÃ¤',0),(273365,7594,'no','Start avreisedato',0),(273366,7594,'da','Begynd afrejsedato',0),(273367,7594,'ko','ì‹œìž‘ ë‚ ì§œ',0),(273368,7594,'he','×‘×’×™×Ÿ ×¢×“ ×ª××¨×™×š',0),(273369,7594,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î½Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚',0),(273370,7594,'zh','å‡ºå‘å¼€å§‹æ—¥æœŸ\r\n',0),(273371,7594,'sv','BÃ¶rja avresedatum',0),(273372,7594,'it','Data inizio trasporto',0),(273373,7594,'tl','',0),(273374,7594,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3629;&#3629;&#3585;&#3648;&#3604;&#3636;&#3609;&#3607;&#3634;&#3591;',0),(273375,7594,'hi','à¤ªà¥à¤°à¤¸à¥à¤¥à¤¾à¤¨ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(273376,7594,'ms','Mulakan tarikh',0),(273377,7594,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù†Ø·Ù„Ø§Ù‚',0),(273378,7594,'fr','Date de dÃ©but de dÃ©part',0),(273379,7594,'jp','å‡ºç™ºã®é–‹å§‹æ—¥',0),(273380,7594,'pt','Data de inÃ­cio de partida',0);
INSERT INTO `langdef` VALUES (273381,7594,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(273382,7594,'es','Partida Fecha de Comienza',0),(273383,7594,'de','Begin Abreisedatum',0),(273384,7594,'en','Departure Begin Date',0),(273385,7595,'is','',0),(273386,7595,'dr','(Ø®Ø±ÙˆØ¬',0),(273387,7595,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ù†Ø­Ø±Ø§Ù(Ø®Ø±ÙˆØ¬',0),(273388,7595,'tr','AyrÄ±lÄ±ÅŸ tarihi',0),(273389,7595,'pl','Data wyjazdu',0),(273390,7595,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ð¼Ð¸Ð½Ð°Ð²Ð°Ð½Ðµ',0),(273391,7595,'ur','Ø±ÙˆØ§Ù†Ú¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(273392,7595,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ð´Ð»Ð°ÑÐºÐ°',0),(273393,7595,'vi','NgÃ y khá»Ÿi hÃ nh',0),(273394,7595,'af','Vertrekdatum',0),(273395,7595,'ro','Data plecarii',0),(273396,7595,'et','Lahkumise kuupÃ¤ev',0),(273397,7595,'si','Datum odhoda',0),(273398,7595,'ba','Tanggal keberangkatan',0),(273399,7595,'nl','Vertrekdatum',0),(273400,7595,'fi','LÃ¤htÃ¶pÃ¤ivÃ¤',0),(273401,7595,'no','Avreisedato',0),(273402,7595,'da','Afrejsedato',0),(273403,7595,'ko','ì¶œë°œ ë‚ ì§œ',0),(273404,7595,'he','×ª××¨×™×š ×¢×–×™×‘×”',0),(273405,7595,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î½Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚',0),(273406,7595,'zh','å‡ºå‘æ—¥æœŸ\r\n',0),(273407,7595,'sv','Avresedatum',0),(273408,7595,'it','Data partenza',0),(273409,7595,'tl','',0),(273410,7595,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3629;&#3629;&#3585;&#3648;&#3604;&#3636;&#3609;&#3607;&#3634;&#3591;',0),(273411,7595,'hi','à¤ªà¥à¤°à¤¸à¥à¤¥à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿',0),(273412,7595,'ms','Tarikh berlepas',0),(273413,7595,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ØºØ§Ø¯Ø±Ø©',0),(273414,7595,'fr','Date de dÃ©part',0),(273415,7595,'jp','å‡ºç™ºæ—¥',0),(273416,7595,'pt','Data de partida',0),(273417,7595,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(273418,7595,'es','Fecha de Partida',0),(273419,7595,'de','Abreisedatum',0),(273420,7595,'en','Departure Date',0),(273421,7596,'is','',0),(273422,7596,'dr','ÙˆØ§Ø¨Ø³ØªÙ‡ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø± ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(273423,7596,'pr','ÙˆØ§Ø¨Ø³ØªÙ‡ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø± ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ ',0),(273424,7596,'tr','KalkÄ±ÅŸ bitiÅŸ tarihi',0),(273425,7596,'pl','Data zakoÅ„czenia wyjazdu',0),(273426,7596,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ð¼Ð¸Ð½Ð°Ð²Ð°Ð½Ðµ',0),(273427,7596,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø±ÙˆØ§Ù†Ú¯ÛŒ',0),(273428,7596,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¾Ð´Ð»Ð°ÑÐºÐ°',0),(273429,7596,'vi','NgÃ y cuá»‘i khá»Ÿi hÃ nh',0),(273430,7596,'af','Vertrekdatum Eindig',0),(273431,7596,'ro','Data de sfÃ¢rÅŸit plecare',0),(273432,7596,'et','Lahkumine lÃµppkuupÃ¤ev',0),(273433,7596,'si','KonÄni datum odhoda',0),(273434,7596,'ba','Tanggal akhir',0),(273435,7596,'nl','Vertrek einddatum',0),(273436,7596,'fi','LÃ¤htÃ¶ pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(273437,7596,'no','Avreisedato',0),(273438,7596,'da','Afgang slutdato',0),(273439,7596,'ko','ë ë‚ ì§œ',0),(273440,7596,'he','×ª××¨×™×š ×¡×™×•×',0),(273441,7596,'el','Î¤Î­Î»Î¿Ï‚ Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î½Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚',0),(273442,7596,'zh','å‡ºå‘ç»“æŸæ—¥æœŸ\r\n',0),(273443,7596,'sv','Slutet avresedatum',0),(273444,7596,'it','Data fine trasporto',0),(273445,7596,'tl','',0),(273446,7596,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3585;&#3634;&#3619;&#3648;&#3604;&#3636;&#3609;&#3607;&#3634;&#3591;',0),(273447,7596,'hi','à¤ªà¥à¤°à¤¸à¥à¤¥à¤¾à¤¨ à¤…à¤‚à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(273448,7596,'ms','Tarikh akhir',0),(273449,7596,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø±Ø­Ù„Ø©',0),(273450,7596,'fr','Date de fin de dÃ©part',0),(273451,7596,'jp','å‡ºç™ºçµ‚äº†æ—¥',0),(273452,7596,'pt','Data de tÃ©rmino de partida',0),(273453,7596,'ru','Ð”Ð°Ñ‚Ð° Ð²Ñ‹Ð»ÐµÑ‚Ð°',0),(273454,7596,'es','Partida Fecha de TÃ©rminaciÃ³n',0),(273455,7596,'de','End-Datum der Abreise',0),(273456,7596,'en','Departure End Date',0),(273457,7597,'is','',0),(273458,7597,'dr','(Ø§Ù…ÙƒØ§Ù†Ø§Øª',0),(273459,7597,'pr','ØªØ§Ø³ÙŠØ³Ø§Øª (Ø§Ù…ÙƒØ§Ù†Ø§Øª',0),(273460,7597,'tr','Tesis',0),(273461,7597,'pl','Obiekt',0),(273462,7597,'bg','Ð¡ÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(273463,7597,'ur','Ú©ÛŒ Ø³ÛÙˆÙ„Øª',0),(273464,7597,'sr','ÐŸÐ¾ÑÑ‚Ñ€Ð¾Ñ˜ÐµÑšÐµ',0),(273465,7597,'vi','CÆ¡ sá»Ÿ',0),(273466,7597,'af','Fasiliteit',0),(273467,7597,'ro','Facilitatea de',0),(273468,7597,'et','Rajatis',0),(273469,7597,'si','Objekt',0),(273470,7597,'ba','Fasilitas',0),(273471,7597,'nl','Faciliteit',0),(273472,7597,'fi','Laitos',0),(273473,7597,'no','Anlegget',0),(273474,7597,'da','Facilitet',0),(273475,7597,'ko','ì‹œì„¤',0),(273476,7597,'he','×ž×ª×§×Ÿ',0),(273477,7597,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(273478,7597,'zh','è®¾å¤‡\r\n',0),(273479,7597,'sv','AnlÃ¤ggning',0),(273480,7597,'it','Impianto',0),(273481,7597,'tl','',0),(273482,7597,'th','&#3626;&#3636;&#3656;&#3591;&#3629;&#3635;&#3609;&#3623;&#3618;&#3588;&#3623;&#3634;&#3617;&#3626;&#3632;&#3604;&#3623;&#3585;',0),(273483,7597,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾',0),(273484,7597,'ms','Kemudahan',0),(273485,7597,'ar','Ù…Ø±ÙÙ‚',0),(273486,7597,'fr','Installation',0),(273487,7597,'jp','æ–½è¨­',0),(273488,7597,'pt','InstalaÃ§Ã£o',0),(273489,7597,'ru','Ð¤Ð¾Ð½Ð´',0),(273490,7597,'es','Facilidad',0),(273491,7597,'de','Anlage',0),(273492,7597,'en','Facility',0),(273493,7598,'is','',0),(273494,7598,'dr','(Ø§Ø¶Ø§ÙÙ‡ ÙƒØ±Ø¯Ù†) Ù„ØºÙˆ Ø´ÙˆØ¯ ',0),(273495,7598,'pr','Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù†(Ø§Ø¶Ø§ÙÙ‡ ÙƒØ±Ø¯Ù†) Ù„ØºÙˆ Ø´ÙˆØ¯ ',0),(273496,7598,'tr','Dahil iptal edildi',0),(273497,7598,'pl','DoÅ‚Ä…czyÄ‡ anulowane',0),(273498,7598,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð¸ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð¸',0),(273499,7598,'ur','Ø´Ø§Ù…Ù„ ÛÛŒÚº Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(273500,7598,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ðµ',0),(273501,7598,'vi','Bao gá»“m há»§y',0),(273502,7598,'af','Gekanseleerdes Ingesluit',0),(273503,7598,'ro','Includ anulat',0),(273504,7598,'et','Sisaldavad tÃ¼histatud',0),(273505,7598,'si','VkljuÄujejo odpovedan',0),(273506,7598,'ba','Termasuk dibatalkan',0),(273507,7598,'nl','Omvatten geannuleerd',0),(273508,7598,'fi','Ovat peruutettu',0),(273509,7598,'no','Inkluderer avbrutt',0),(273510,7598,'da','Omfatter annulleret',0),(273511,7598,'ko','í¬í•¨ ì·¨ì†Œ',0),(273512,7598,'he','×›×•×œ×œ×™× ×‘×•×˜×œ×”',0),(273513,7598,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ',0),(273514,7598,'zh','åŒ…æ‹¬å–æ¶ˆ\r\n',0),(273515,7598,'sv','Inkluderar avbryts',0),(273516,7598,'it','Includono annullato',0),(273517,7598,'tl','',0),(273518,7598,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(273519,7598,'hi','à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚ à¤°à¤¦à¥à¤¦ à¤•à¤¿à¤¯à¤¾',0),(273520,7598,'ms','Termasuk dibatalkan',0),(273521,7598,'ar','ÙˆØªØ´Ù…Ù„ Ø¥Ù„ØºØ§Ø¡',0),(273522,7598,'fr','Inclure annulÃ©e',0),(273523,7598,'jp','å«ã‚ã‚‹ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(273524,7598,'pt','Incluem cancelado',0),(273525,7598,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½',0),(273526,7598,'es','Incluir Cancelado',0),(273527,7598,'de','Enthalten abgebrochen',0),(273528,7598,'en','Include Canceled',0),(273529,7599,'is','',0),(273530,7599,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯',0),(273531,7599,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯',0),(273532,7599,'tr','GÃ¼n Otopark',0),(273533,7599,'pl','Parking dni',0),(273534,7599,'bg','ÐŸÐ°Ñ€ÐºÐ¸Ð½Ð³ Ð´Ð½Ð¸',0),(273535,7599,'ur','Ù¾Ø§Ø±Ú©Ù†Ú¯ Ø¯Ù†',0),(273536,7599,'sr','ÐŸÐ°Ñ€ÐºÐ¸Ñ€Ð°ÑšÐµ Ð´Ð°Ð½Ð°',0),(273537,7599,'vi','NgÃ y Ä‘áº­u xe',0),(273538,7599,'af','Dae Parkeer',0),(273539,7599,'ro','Zile de parcare',0),(273540,7599,'et','Parkimine pÃ¤eva',0),(273541,7599,'si','Parkiranje dni',0),(273542,7599,'ba','Hari parkir',0),(273543,7599,'nl','Dagen parkeren',0),(273544,7599,'fi','PysÃ¤kÃ¶intiin',0),(273545,7599,'no','Parkering dager',0),(273546,7599,'da','Parkering i dage',0),(273547,7599,'ko','ì¼ ì£¼ì°¨',0),(273548,7599,'he','×—× ×™×” ×™×ž×™×',0),(273549,7599,'el','Î—Î¼Î­ÏÎµÏ‚ Ï€Î¬ÏÎºÎ¹Î½Î³Îº',0),(273550,7599,'zh','åœè½¦åœºå¤©\r\n',0),(273551,7599,'sv','Parkering dagar',0),(273552,7599,'it','Giorni di parcheggio',0),(273553,7599,'tl','',0),(273554,7599,'th','&#3623;&#3633;&#3609;&#3592;&#3629;&#3604;&#3619;&#3606;',0),(273555,7599,'hi','à¤¦à¤¿à¤¨ à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤—',0),(273556,7599,'ms','Hari tempat letak kenderaan',0),(273557,7599,'ar','Ø£ÙŠØ§Ù… ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª',0),(273558,7599,'fr','Jours de stationnement',0),(273559,7599,'jp','é§è»Šå ´ã®æ—¥',0),(273560,7599,'pt','Dias de estacionamento',0),(273561,7599,'ru','Ð”Ð½Ð¸ Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÐ°',0),(273562,7599,'es','DÃ­as para Estacionar',0),(273563,7599,'de','Parkplatz-Tage',0),(273564,7599,'en','Parking Days',0),(273565,7600,'is','',0),(273566,7600,'dr','Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ',0),(273567,7600,'pr','Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ',0),(273568,7600,'tr','Otopark tesisi',0),(273569,7600,'pl','Parkingiem',0),(273570,7600,'bg','ÐŸÐ°Ñ€ÐºÐ¸Ð½Ð³ ÑÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸Ðµ',0),(273571,7600,'ur','Ù¾Ø§Ø±Ú©Ù†Ú¯ Ú©ÛŒ Ø³ÛÙˆÙ„Øª',0),(273572,7600,'sr','ÐŸÐ¾ÑÑ‚Ñ€Ð¾Ñ˜ÐµÑšÐµ Ð·Ð° Ð¿Ð°Ñ€ÐºÐ¸Ñ€Ð°ÑšÐµ',0),(273573,7600,'vi','NÆ¡i Ä‘áº­u xe',0),(273574,7600,'af','Parkeer Fasiliteit',0),(273575,7600,'ro','Facilitatea de parcare',0),(273576,7600,'et','Parkla',0),(273577,7600,'si','Parkirne',0),(273578,7600,'ba','Fasilitas parkir',0),(273579,7600,'nl','Parkeergelegenheid',0),(273580,7600,'fi','PysÃ¤kÃ¶intilaitos',0),(273581,7600,'no','Parkeringsanlegg',0),(273582,7600,'da','P-anlÃ¦gget',0),(273583,7600,'ko','ì£¼ì°¨ ì‹œì„¤',0),(273584,7600,'he','×—× ×™×•×Ÿ',0),(273585,7600,'el','Î§ÏŽÏÎ¿Ï‚ ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚',0),(273586,7600,'zh','åœè½¦è®¾æ–½\r\n',0),(273587,7600,'sv','Parkeringshus',0),(273588,7600,'it','Autosili',0),(273589,7600,'tl','',0),(273590,7600,'th','&#3626;&#3636;&#3656;&#3591;&#3629;&#3635;&#3609;&#3623;&#3618;&#3588;&#3623;&#3634;&#3617;&#3626;&#3632;&#3604;&#3623;&#3585;&#3607;&#3637;&#3656;&#3592;&#3629;&#3604;&#3619;&#3606;',0),(273591,7600,'hi','à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¸à¥à¤µà¤¿à¤§à¤¾',0),(273592,7600,'ms','Kemudahan tempat meletak kereta',0),(273593,7600,'ar','Ù…Ø±ÙÙ‚ ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª',0),(273594,7600,'fr','Parking privatif',0),(273595,7600,'jp','é§è»Šæ–½è¨­',0),(273596,7600,'pt','Facilidade de estacionamento',0),(273597,7600,'ru','ÐœÐµÑÑ‚Ð° Ð´Ð»Ñ Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÐ¸',0),(273598,7600,'es','Facilidad de Estacionar',0),(273599,7600,'de','ParkmÃ¶glichkeiten',0),(273600,7600,'en','Parking Facility',0),(273601,7601,'is','',0),(273602,7601,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ',0),(273603,7601,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ',0),(273604,7601,'tr','Otopark Ã¼creti',0),(273605,7601,'pl','OpÅ‚ata parkingowa',0),(273606,7601,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° Ð¿Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(273607,7601,'ur','Ù¾Ø§Ø±Ú©Ù†Ú¯ ÙÛŒØ³',0),(273608,7601,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ð° Ð·Ð° Ð¿Ð°Ñ€ÐºÐ¸Ñ€Ð°ÑšÐµ',0),(273609,7601,'vi','PhÃ­ Ä‘áº­u xe',0),(273610,7601,'af','Parkeergeld',0),(273611,7601,'ro','Taxa de parcare',0),(273612,7601,'et','Parkimistasu',0),(273613,7601,'si','Parkirnine',0),(273614,7601,'ba','Biaya parkir',0),(273615,7601,'nl','Parkeergeld',0),(273616,7601,'fi','PysÃ¤kÃ¶intimaksu',0),(273617,7601,'no','Parkeringsavgift',0),(273618,7601,'da','Parkeringsafgift',0),(273619,7601,'ko','ì£¼ì°¨ ìš”ê¸ˆ',0),(273620,7601,'he','×—× ×™×” ×‘×ª×©×œ×•×',0),(273621,7601,'el','Î¤Î­Î»Î· ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚',0),(273622,7601,'zh','åœè½¦è´¹\r\n',0),(273623,7601,'sv','Parkeringsavgiften',0),(273624,7601,'it','Parcheggio a pagamento',0),(273625,7601,'tl','',0),(273626,7601,'th','&#3588;&#3656;&#3634;&#3592;&#3629;&#3604;&#3619;&#3606;',0),(273627,7601,'hi','à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤¶à¥à¤²à¥à¤•',0),(273628,7601,'ms','Bayaran tempat letak kenderaan',0),(273629,7601,'ar','Ø±Ø³ÙˆÙ… ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª',0),(273630,7601,'fr','Frais de stationnement',0),(273631,7601,'jp','é§è»Šæ–™é‡‘',0),(273632,7601,'pt','Taxa de estacionamento',0),(273633,7601,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð°Ñ€ÐºÐ¾Ð²ÐºÑƒ',0),(273634,7601,'es','Cuota para Estacionar',0),(273635,7601,'de','ParkgebÃ¼hr',0),(273636,7601,'en','Parking Fee',0),(273637,7602,'is','',0),(273638,7602,'dr','(Ø±Ø²Ø±Ùˆ Ù‡Ø§',0),(273639,7602,'pr','Ø°Ø®ÙŠØ±Ù‡ (Ø±Ø²Ø±Ùˆ Ù‡Ø§',0),(273640,7602,'tr','RezervasyonlarÄ±',0),(273641,7602,'pl','Rezerwacje',0),(273642,7602,'bg','Ð ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ð¸',0),(273643,7602,'ur','ØªØ­ÙØ¸Ø§Øª',0),(273644,7602,'sr','Ð ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ˜Ðµ',0),(273645,7602,'vi','Äáº·t trÆ°á»›c',0),(273646,7602,'af','Besprekings',0),(273647,7602,'ro','Rezervari',0),(273648,7602,'et','Broneeringud',0),(273649,7602,'si','Rezervacije',0),(273650,7602,'ba','Reservasi',0),(273651,7602,'nl','Reserveringen',0),(273652,7602,'fi','Varaukset',0),(273653,7602,'no','Reservasjoner',0),(273654,7602,'da','Forbehold',0),(273655,7602,'ko','ì˜ˆì•½',0),(273656,7602,'he','×”×–×ž× ×•×ª',0),(273657,7602,'el','ÎšÏÎ±Ï„Î®ÏƒÎµÎ¹Ï‚',0),(273658,7602,'zh','é¢„è®¢\r\n',0),(273659,7602,'sv','Reservationer',0),(273660,7602,'it','Prenotazioni',0),(273661,7602,'tl','',0),(273662,7602,'th','&#3585;&#3634;&#3619;&#3592;&#3629;&#3591;',0),(273663,7602,'hi','à¤†à¤°à¤•à¥à¤·à¤£',0),(273664,7602,'ms','Tempahan',0),(273665,7602,'ar','ØªØ­ÙØ¸Ø§Øª',0),(273666,7602,'fr','RÃ©servations',0),(273667,7602,'jp','äºˆç´„',0),(273668,7602,'pt','Reservas',0),(273669,7602,'ru','ÐžÐ³Ð¾Ð²Ð¾Ñ€ÐºÐ¸',0),(273670,7602,'es','Reservaciones',0),(273671,7602,'de','Reservierungen',0),(273672,7602,'en','Reservations',0),(273673,7603,'is','',0),(273674,7603,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø°Ø®ÙŠØ±Ù‡ ',0),(273675,7603,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø°Ø®ÙŠØ±Ù‡ ',0),(273676,7603,'tr','Res numarasÄ±',0),(273677,7603,'pl','Numer res',0),(273678,7603,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð’Ð•Ð˜',0),(273679,7603,'ur','Ú¯Ú¾Ø± Ú©Ø§ Ù†Ù…Ø¨Ø±',0),(273680,7603,'sr','Ð ÐµÑ Ð±Ñ€Ð¾Ñ˜',0),(273681,7603,'vi','Sá»‘ Äáº·t trÆ°á»›c',0),(273682,7603,'af','Besigtiging nommer',0),(273683,7603,'ro','NumÄƒrul de res',0),(273684,7603,'et','Res Number',0),(273685,7603,'si','Res Å¡tevilka',0),(273686,7603,'ba','Res nomor',0),(273687,7603,'nl','Res nummer',0),(273688,7603,'fi','Res numero',0),(273689,7603,'no','Res nummer',0),(273690,7603,'da','Res antallet',0),(273691,7603,'ko','í•´ìƒë„ ë²ˆí˜¸',0),(273692,7603,'he','Res ×ž×¡×¤×¨',0),(273693,7603,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½ Î‘Î Î•',0),(273694,7603,'zh','é¢„è®¢ç¼–å·\r\n',0),(273695,7603,'sv','Res nummer',0),(273696,7603,'it','Numero di res',0),(273697,7603,'tl','',0),(273698,7603,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3585;&#3634;&#3619;&#3592;&#3629;&#3591;',0),(273699,7603,'hi','Res à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(273700,7603,'ms','Mensyaratkan nombor',0),(273701,7603,'ar','Ø¹Ø¯Ø¯ res',0),(273702,7603,'fr','Nombre de res',0),(273703,7603,'jp','è§£åƒåº¦æ•°',0),(273704,7603,'pt','NÃºmero de res',0),(273705,7603,'ru','RES Ð½Ð¾Ð¼ÐµÑ€',0),(273706,7603,'es','NÃºmero de ReservaciÃ³n',0),(273707,7603,'de','Res Anzahl',0),(273708,7603,'en','Res Number',0),(273709,7604,'is','',0),(273710,7604,'dr','(Ø¨Ø§Ù‚ÙŠØ¨ÛŒÙ„Ø§Ù†Ø³',0),(273711,7604,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ù†ØªÙŠØ¬Ù‡(Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡',0),(273712,7604,'tr','Res Ã¼creti',0),(273713,7604,'pl','Res opÅ‚aty',0),(273714,7604,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° Ð’Ð•Ð˜',0),(273715,7604,'ur','Ú¯Ú¾Ø± Ú©ÛŒ ÙÛŒØ³',0),(273716,7604,'sr','Ð ÐµÑ Ð½Ð°ÐºÐ½Ð°Ð´Ð°',0),(273717,7604,'vi','PhÃ­ Res',0),(273718,7604,'af','Besigtiging fooi',0),(273719,7604,'ro','Taxa de res',0),(273720,7604,'et','Res tasu',0),(273721,7604,'si','Res pristojbina',0),(273722,7604,'ba','Res biaya',0),(273723,7604,'nl','Res vergoeding',0),(273724,7604,'fi','Res maksu',0),(273725,7604,'no','Res avgift',0),(273726,7604,'da','Res gebyr',0),(273727,7604,'ko','ìž…ìˆ  ìˆ˜ìˆ˜ë£Œ',0),(273728,7604,'he','Res ×“×ž×™',0),(273729,7604,'el','Î¤Î¿ Ï„Î­Î»Î¿Ï‚ Î‘Î Î•',0),(273730,7604,'zh','é¢„è®¢è´¹ç”¨\r\n',0),(273731,7604,'sv','Res avgift',0),(273732,7604,'it','Tassa di res',0),(273733,7604,'tl','',0),(273734,7604,'th','&#3612;&#3621;&#3621;&#3633;&#3614;&#3608;&#3660;&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;',0),(273735,7604,'hi','Res à¤¶à¥à¤²à¥à¤•',0),(273736,7604,'ms','Mensyaratkan yuran',0),(273737,7604,'ar','Ø±Ø³ÙˆÙ… res',0),(273738,7604,'fr','Frais de res',0),(273739,7604,'jp','è§£åƒåº¦æ–™é‡‘',0),(273740,7604,'pt','Taxa de res',0),(273741,7604,'ru','RES Ð¿Ð»Ð°Ñ‚Ð°',0),(273742,7604,'es','Tarifa de Resultado',0),(273743,7604,'de','Res Fee',0),(273744,7604,'en','Res Fee',0),(273745,7605,'is','',0),(273746,7605,'dr','Ø´Ø±Ø­ ÙÙ‡Ø±Ø³Øª',0),(273747,7605,'pr','Ø´Ø±Ø­ ÙÙ‡Ø±Ø³Øª',0),(273748,7605,'tr','Katalog aÃ§Ä±klamasÄ±',0),(273749,7605,'pl','Â«KatalogÂ» opis',0),(273750,7605,'bg','ÐšÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(273751,7605,'ur','Ú©ÛŒÙ¹Ù„Ø§Ú¯ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(273752,7605,'sr','ÐžÐ¿Ð¸Ñ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³',0),(273753,7605,'vi','MÃ´ táº£ Catalog',0),(273754,7605,'af','Katalogus Beskrywing',0),(273755,7605,'ro','Descriere catalog',0),(273756,7605,'et','Kataloogi kirjeldus',0),(273757,7605,'si','Katalog opis',0),(273758,7605,'ba','Deskripsi Katalog',0),(273759,7605,'nl','Catalogus beschrijving',0),(273760,7605,'fi','Luettelon kuvaus',0),(273761,7605,'no','Katalogen beskrivelse',0),(273762,7605,'da','Forside beskrivelse',0),(273763,7605,'ko','ì¹´íƒˆë¡œê·¸ ì„¤ëª…',0),(273764,7605,'he','×ª×™××•×¨ ×§×˜×œ×•×’',0),(273765,7605,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(273766,7605,'zh','ç›®å½•è¯´æ˜Ž\r\n',0),(273767,7605,'sv','Katalogen Beskrivning',0),(273768,7605,'it','Descrizione del catalogo',0),(273769,7605,'tl','',0),(273770,7605,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3649;&#3588;&#3655;&#3605;&#3605;&#3634;&#3621;&#3655;&#3629;&#3585;',0),(273771,7605,'hi','à¤•à¥ˆà¤Ÿà¤²à¥‰à¤— à¤µà¤¿à¤µà¤°à¤£',0),(273772,7605,'ms','Keterangan Katalog',0),(273773,7605,'ar','ÙˆØµÙ Ø§Ù„Ù†Ø´Ø±Ø© Ø§Ù„Ù…ØµÙˆØ±Ø©',0),(273774,7605,'fr','Description du catalogue',0),(273775,7605,'jp','ã‚«ã‚¿ãƒ­ã‚°ã®èª¬æ˜Ž',0),(273776,7605,'pt','DescriÃ§Ã£o de catÃ¡logo',0),(273777,7605,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐšÐ°Ñ‚Ð°Ð»Ð¾Ð³Ð°',0),(273778,7605,'es','CatÃ¡logo DescripciÃ³n',0),(273779,7605,'de','Katalogbeschreibung',0),(273780,7605,'en','Catalog Description',0),(273781,7606,'is','',0),(273782,7606,'dr','Ú¯Ø±Ø§ÙÙŠÙƒ  ÙˆØ¨ Ø³Ø§ÙŠØª\r\n',0),(273783,7606,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ  ÙˆØ¨ Ø³Ø§ÙŠØª\r\n',0),(273784,7606,'tr','Grafik URL',0),(273785,7606,'pl','Adres URL grafiki',0),(273786,7606,'bg','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° URL',0),(273787,7606,'ur','Ú¯Ø±Ø§ÙÚ© URL',0),(273788,7606,'sr','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐºÐ¸ Ð£Ð Ð›',0),(273789,7606,'vi','Káº¿t ná»‘i Ä‘á»“ há»a',0),(273790,7606,'af','Grafika BA (\"URL\")',0),(273791,7606,'ro','URL-ul grafic',0),(273792,7606,'et','Graafiline URL',0),(273793,7606,'si','GrafiÄni URL',0),(273794,7606,'ba','Grafis URL',0),(273795,7606,'nl','Grafische URL',0),(273796,7606,'fi','Graafinen URL',0),(273797,7606,'no','Grafisk URL',0),(273798,7606,'da','Grafisk URL',0),(273799,7606,'ko','ê·¸ëž˜í”½ URL',0),(273800,7606,'he','×›×ª×•×‘×ª URL ×’×¨×¤×™',0),(273801,7606,'el','Î“ÏÎ±Ï†Î¹ÎºÏŒ URL',0),(273802,7606,'zh','ç½‘å€å›¾å½¢\r\n',0),(273803,7606,'sv','Grafisk URL',0),(273804,7606,'it','Grafico URL',0),(273805,7606,'tl','',0),(273806,7606,'th','Graphic URL',0),(273807,7606,'hi','à¤—à¥à¤°à¤¾à¤«à¤¿à¤• à¤¯à¥‚à¤†à¤°à¤à¤²',0),(273808,7606,'ms','URL grafik',0),(273809,7606,'ar','URL Ø§Ù„Ø±Ø³Ù…',0),(273810,7606,'fr','URL graphique',0),(273811,7606,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã® URL',0),(273812,7606,'pt','GrÃ¡fico URL',0),(273813,7606,'ru','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ URL-Ð°Ð´Ñ€ÐµÑ',0),(273814,7606,'es','GrÃ¡fica URL',0),(273815,7606,'de','Grafik-URL',0),(273816,7606,'en','Graphic URL',0),(273817,7607,'is','',0),(273818,7607,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(273819,7607,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(273820,7607,'tr','Eldeki miktar',0),(273821,7607,'pl','IloÅ›Ä‡ zapasÃ³w',0),(273822,7607,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ñ€ÑŠÐºÐ°',0),(273823,7607,'ur','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø± ÛØ§ØªÚ¾',0),(273824,7607,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð° Ñ€ÑƒÐºÑƒ',0),(273825,7607,'vi','Sá»‘ lÆ°á»£ng cÃ³ sáºµn',0),(273826,7607,'af','Hoeveelheid op-Hand',0),(273827,7607,'ro','Cantitatea pe-o parte',0),(273828,7607,'et','Vaba laokoguse',0),(273829,7607,'si','KoliÄina na roko',0),(273830,7607,'ba','Kuantitas di tangan',0),(273831,7607,'nl','Hoeveelheid in voorraad',0),(273832,7607,'fi','VarastomÃ¤Ã¤rÃ¤',0),(273833,7607,'no','Antallet pÃ¥ lager',0),(273834,7607,'da','MÃ¦ngde pÃ¥ hÃ¥nd',0),(273835,7607,'ko','ì–‘ ì†',0),(273836,7607,'he','×›×ž×•×ª ×‘× ×ž×¦×',0),(273837,7607,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎµÏ€Î¬Î½Ï‰-Ï‡Î­ÏÎ¹',0),(273838,7607,'zh','çŽ°æœ‰æ•°é‡\r\n',0),(273839,7607,'sv','Kvantitet pÃ¥-Hand',0),(273840,7607,'it','QuantitÃ  a portata di mano',0),(273841,7607,'tl','',0),(273842,7607,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3651;&#3609;&#3617;&#3639;&#3629;',0),(273843,7607,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¤°-à¤¹à¤¾à¤¥',0),(273844,7607,'ms','Kuantiti pada tangan',0),(273845,7607,'ar','Ø§Ù„ÙƒÙ…ÙŠÙ‘Ø© Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(273846,7607,'fr','QuantitÃ© en stock',0),(273847,7607,'jp','æ‰‹å…ƒã«ã‚ã‚‹æ•°é‡',0),(273848,7607,'pt','Quantidade na mÃ£o',0),(273849,7607,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ñ€ÑƒÐºÑƒ',0),(273850,7607,'es','Cantidad En-Reserva',0),(273851,7607,'de','Menge auf die Hand',0),(273852,7607,'en','Quantity On-Hand',0),(273853,7608,'is','',0),(273854,7608,'dr','ØªØºÙŠÙŠØ± ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø´Ù…Ø§Ø±Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø±Ø§ Ù…ØªÙˆÙ‚Ù Ù…ÙŠ ÙƒÙ†Ø¯ ',0),(273855,7608,'pr','ØªØºÙŠÙŠØ± ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø´Ù…Ø§Ø±Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø±Ø§ Ù…ØªÙˆÙ‚Ù Ù…ÙŠ ÙƒÙ†Ø¯ ',0),(273856,7608,'tr','SatÄ±ÅŸ birimlerinin stok maddesinin deÄŸiÅŸtirilmesi, Stok sayÄ±mlarÄ± zarar verebilir.',0),(273857,7608,'pl','Zmiany jednostki sprzedajÄ… towar moÅ¼na zÅ‚amaÄ‡ zapasÃ³w.',0),(273858,7608,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð° ÑÐºÐ»Ð°Ð´Ð¾Ð² Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ ÑÑ‡ÑƒÐ¿ÑÑ‚ Ð¾Ð¿Ð¸ÑÐ° Ð±Ñ€Ð¾Ð¸.',0),(273859,7608,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¨ÛŒÚ† ÛŒÙˆÙ†Ù¹Ø³ Ø¨ÛŒØ´ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Ù…Ø§Ø± ØªÙˆÚ‘ Ø³Ú©ØªØ§ ÛÛ’ Û”',0),(273860,7608,'sr','ÐœÐµÑšÐ°ÑšÐµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð·Ð° Ð˜Ð·Ð»Ð¾Ð¼Ð¸ Ð·Ð°Ð»Ð¸Ñ…Ð° Ñ‚Ð°Ñ‡Ð°ÐºÐ°.',0),(273861,7608,'vi','Chá»‰nh sá»­a Ä‘Æ¡n vá»‹ hÃ ng cá»§a hÃ ng hÃ³a cÃ³ thá»ƒ áº£nh hÆ°á»Ÿng Ä‘áº¿n viá»‡c kiá»ƒm kÃª hÃ ng hÃ³a',0),(273862,7608,'af','Wysigings van verkoopte eenhede om Voorraaditems telling',0),(273863,7608,'ro','Modificarea Vindem unitÄƒÅ£i pentru inventarul element poate rupe inventar conteazÄƒ.',0),(273864,7608,'et','MÃ¼Ã¼a Ã¼hikut, varudes oleva kauba muutmata vÃµib murda Laoinventuuride.',0),(273865,7608,'si','Spreminjanje prodaja enot artikla zaloge lahko prekinil zaloge Å¡teje.',0),(273866,7608,'ba','Mengubah menjual unit untuk persediaan item dapat mematahkan menghitung persediaan.',0),(273867,7608,'nl','Veranderen verkopen eenheden voor voorraadartikel kan breken inventaris graven.',0),(273868,7608,'fi','Muuttaa osuuksien myyntiÃ¤ varastonimikkeen rikkoa Inventointien.',0),(273869,7608,'no','Endre selge enheter for lagervaren kan bryte lageropptellinger.',0),(273870,7608,'da','At Ã¦ndre sÃ¦lge enheder for lagervaren kan bryde lageroptÃ¦llinger.',0),(273871,7608,'ko','ì¸ë²¤í† ë¦¬ í•­ëª©ì— ëŒ€ í•œ íŒë§¤ ë‹¨ìœ„ ë³€ê²½ ìž¬ê³  ì¡°ì‚¬ë¥¼ ëŠì„ ìˆ˜ ìžˆë‹¤.',0),(273872,7608,'he','×©×™× ×•×™ ×œ×ž×›×•×¨ ×™×—×™×“×•×ª ×¢×‘×•×¨ ×¤×¨×™×˜ ×”×ž×œ××™ ×™×›×•×œ×” ×œ×©×‘×•×¨ ×¡×¤×™×¨×•×ª ×ž×œ××™.',0),(273873,7608,'el','Î¤ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï€Ï‰Î»Î¿ÏÎ½ Î¼Î¿Î½Î¬Î´ÎµÏ‚ Î³Î¹Î± Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÏƒÏ€Î¬ÏƒÎµÎ¹ Ï„Î·Î½ Î±Ï€Î¿Î³ÏÎ±Ï†Î® Î¼ÎµÏ„ÏÎ¬ÎµÎ¹.',0),(273874,7608,'zh','æ”¹å˜å‡ºå”®å­˜è´§é¡¹ç›®å•ä½å¯ä»¥æ‰“ç ´åº“å­˜ç›˜ç‚¹\r\n',0),(273875,7608,'sv','Ã„ndra sÃ¤lja enheter fÃ¶r lagerartikeln kan bryta lagerinventeringsjournalen.',0),(273876,7608,'it','UnitÃ  di vendita per articolo di magazzino che alterano puÃ² rompere conteggi di inventario.',0),(273877,7608,'tl','',0),(273878,7608,'th','Altering sell units for inventory item can break inventory counts.',0),(273879,7608,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥‡à¤š à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤«à¥‡à¤°à¤¬à¤¦à¤² à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤®à¤¾à¤¯à¤¨à¥‡ à¤°à¤–à¤¤à¤¾ à¤¹à¥ˆ à¤Ÿà¥‚à¤Ÿ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(273880,7608,'ms','Mengubah menjual unit-unit bagi item inventori dapat mematahkan tuduhan inventori.',0),(273881,7608,'ar','ØªØºÙŠÙŠØ± ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ø¨ÙŠØ¹ Ù„ØµÙ†Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ÙŠÙ…ÙƒÙ† ÙƒØ³Ø± Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†.',0),(273882,7608,'fr','Modifier les unitÃ©s de vente d\'article en stock peut briser dÃ©nombrement des stocks.',0),(273883,7608,'jp','åœ¨åº«å“ç›®ã®è²©å£²å˜ä½ã‚’å¤‰æ›´ã™ã‚‹åœ¨åº«æ•°ã‚’ç ´ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(273884,7608,'pt','Alterar as unidades de venda por item de inventÃ¡rio pode quebrar contagens de inventÃ¡rio.',0),(273885,7608,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ† Ð¿Ñ€Ð¾Ð´Ð°Ñ‚ÑŒ Ð´Ð»Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð¼Ð¾Ð¶ÐµÑ‚ Ð¿Ñ€Ð¸Ð²ÐµÑÑ‚Ð¸ Ðº Ð¿Ð¾Ð»Ð¾Ð¼ÐºÐµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¾Ð½Ð½ÑƒÑŽ Ð¾Ð¿Ð¸ÑÑŒ.',0),(273886,7608,'es','Alterando unidades de ventapara items de inventario puede interrumpir conteos de inventario',0),(273887,7608,'de','Ã„ndern Verkauf Einheiten fÃ¼r Inventargegenstand kann Inventar zÃ¤hlt brechen.',0),(273888,7608,'en','Altering sell units for inventory item can break inventory counts.',0),(273889,7609,'is','',0),(273890,7609,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø°Ø®ÙŠØ±Ù‡ ',0),(273891,7609,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø°Ø®ÙŠØ±Ù‡ ',0),(273892,7609,'tr','Rezervasyon raporu',0),(273893,7609,'pl','Raport rezerwacji',0),(273894,7609,'bg','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(273895,7609,'ur','Ø¨Ú©Ù†Ú¯ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(273896,7609,'sr','Ð ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ˜Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(273897,7609,'vi','BÃ¡o cÃ¡o Ä‘áº·t trÆ°á»›c',0),(273898,7609,'af','Besprekingsverslag',0),(273899,7609,'ro','Raport de rezervare',0),(273900,7609,'et','Reserveerimine aruanne',0),(273901,7609,'si','Rezervacija poroÄilo',0),(273902,7609,'ba','Reservasi laporan',0),(273903,7609,'nl','Reservering verslag',0),(273904,7609,'fi','Varaus raportti',0),(273905,7609,'no','Booking rapport',0),(273906,7609,'da','Reservation rapport',0),(273907,7609,'ko','ì˜ˆì•½ ë³´ê³ ì„œ',0),(273908,7609,'he','×”×–×ž× ×ª ×“×•×—',0),(273909,7609,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î·Ï‚ ÎºÏÎ¬Ï„Î·ÏƒÎ·Ï‚',0),(273910,7609,'zh','é¢„è®¢æŠ¥å‘Š\r\n',0),(273911,7609,'sv','Bokning rapport',0),(273912,7609,'it','Report di prenotazione',0),(273913,7609,'tl','',0),(273914,7609,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3592;&#3629;&#3591;',0),(273915,7609,'hi','à¤†à¤°à¤•à¥à¤·à¤£ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(273916,7609,'ms','Laporan Tempahan',0),(273917,7609,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø­Ø¬Ø²',0),(273918,7609,'fr','Rapport de rÃ©servation',0),(273919,7609,'jp','äºˆç´„ãƒ¬ãƒãƒ¼ãƒˆ',0),(273920,7609,'pt','RelatÃ³rio de reservas',0),(273921,7609,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾ Ð±Ñ€Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ð¸',0),(273922,7609,'es','Informe de ReservaciÃ³n',0),(273923,7609,'de','Reservierungsbericht',0),(273924,7609,'en','Reservation Report',0),(273925,7610,'is','',0),(273926,7610,'dr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ ÙƒØ§Ù‡Ø´ Ø±Ù†Ú¯ Ø¬ÙˆÙ‡Ø± Ø¯Ø± ØµÙØ­Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(273927,7610,'pr','Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯ ÙƒØ§Ù‡Ø´ Ø±Ù†Ú¯ Ø¬ÙˆÙ‡Ø± Ø¯Ø± ØµÙØ­Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(273928,7610,'tr','MÃ¼rekkep rengi Desc sormak sayfa stok',0),(273929,7610,'pl','Zapytaj Desc kolor tuszu na Fotografia Page',0),(273930,7610,'bg','ÐŸÐ¸Ñ‚Ð°Ð¼ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾ Ñ†Ð²ÑÑ‚ Desc Ð½Ð° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(273931,7610,'ur','Ø§Ù†Ú© Ø±Ù†Ú¯ Ø¯ÛŒØ³Ú© Ù¾ÙˆÚ†Ú¾ ØµÙØ­Û Ø§Ø³Ù¹Ø§Ú©',0),(273932,7610,'sr','ÐŸÐ¸Ñ‚Ð°Ñ˜ Ð”ÐµÑÑ† Ð±Ð¾Ñ˜Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(273933,7610,'vi','YÃªu Cáº§u Diá»…n Giáº£i Máº§u Má»±c TrÃªn Trang HÃ ng Tá»“n',0),(273934,7610,'af','Vra Ink kleur Desc op direkte bladsy',0),(273935,7610,'ro','Cere cernealÄƒ culoare Desc pe Bursa de valori Page',0),(273936,7610,'et','KÃ¼sige tindi vÃ¤rvi Desc lehel Stock',0),(273937,7610,'si','VpraÅ¡ajte Ärnilo barvno Desc na park stran',0),(273938,7610,'ba','Minta Desc warna tinta di Stock Page',0),(273939,7610,'nl','Inkt kleur Desc vragen op Stock Page',0),(273940,7610,'fi','Kysy musteen vÃ¤ri Desc kanta Page',0),(273941,7610,'no','Be blekk farge Desc pÃ¥ Stock side',0),(273942,7610,'da','SpÃ¸rg blÃ¦k farve Desc pÃ¥ lager side',0),(273943,7610,'ko','ì— ìž‰í¬ ìƒ‰ Descë¥¼ ë¬¼ì–´ ì¦ê¶Œ íŽ˜ì´ì§€',0),(273944,7610,'he','×œ×©××•×œ ×“×™×• ×¦×‘×¢ Desc ×¢×œ ×ž×œ××™ ×“×£',0),(273945,7610,'el','Î¡Ï‰Ï„Î®ÏƒÏ‰ Desc Ï‡ÏÏŽÎ¼Î± Î¼ÎµÎ»Î±Î½Î¹Î¿Ï ÏƒÏ„Î¿ Î§ÏÎ·Î¼Î±Ï„Î¹ÏƒÏ„Î®ÏÎ¹Î¿ ÏƒÎµÎ»Î¯Î´Î±Ï‚',0),(273946,7610,'zh','è¯¢é—®è‚¡ä»½é¡µæ²¹å¢¨é¢œè‰²å›¾ç¤º\r\n',0),(273947,7610,'sv','Be blÃ¤ck fÃ¤rg Desc pÃ¥ lager sida',0),(273948,7610,'it','Chiedo Desc colore inchiostro sulla pagina di Stock',0),(273949,7610,'tl','',0),(273950,7610,'th','&#3606;&#3634;&#3617;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3626;&#3637;&#3627;&#3617;&#3638;&#3585;&#3614;&#3636;&#3617;&#3614;&#3660;&#3610;&#3609;&#3627;&#3609;&#3657;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(273951,7610,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤°à¤‚à¤— Desc à¤ªà¥‚à¤›à¤¨à¥‡ à¤ªà¤° à¤¶à¥‡à¤¯à¤° à¤ªà¥ƒà¤·à¥à¤ ',0),(273952,7610,'ms','Tanya Desc warna dakwat terakhir saham Laman',0),(273953,7610,'ar','Ø§Ø³Ø£Ù„ Desc Ù„ÙˆÙ† Ø§Ù„Ø­Ø¨Ø± ÙÙŠ Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„ØµÙØ­Ø©',0),(273954,7610,'fr','Demandez Ã  encre couleur Desc sur Page de Stock',0),(273955,7610,'jp','ã‚¤ãƒ³ã‚¯è‰² Desc ã‚’æ±‚ã‚ã‚‹åœ¨åº«ã®ãƒšãƒ¼ã‚¸',0),(273956,7610,'pt','Pedir Desc de cor de tinta na pÃ¡gina de aÃ§Ãµes',0),(273957,7610,'ru','ÐŸÐ¾Ð¿Ñ€Ð¾ÑÐ¸Ñ‚ÑŒ Desc Ñ†Ð²ÐµÑ‚ Ñ‡ÐµÑ€Ð½Ð¸Ð» Ð½Ð° Ð¤Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ð¹ Page',0),(273958,7610,'es','Pedir descuento de Color de Tinta en la PÃ¡gina de Inventario',0),(273959,7610,'de','Fragen Sie Tinte Color Desc auf Stock Page',0),(273960,7610,'en','Ask Ink Color Desc On Stock Page',0),(273961,7611,'is','',0),(273962,7611,'dr','ÙƒØ§Ø±Ø¨Ø± Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(273963,7611,'pr','ÙƒØ§Ø±Ø¨Ø± Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(273964,7611,'tr','KullanÄ±cÄ± bu ÅŸirkette',0),(273965,7611,'pl','UÅ¼ytkownik w tej firmie',0),(273966,7611,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð² Ñ‚Ð°Ð·Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(273967,7611,'ur','Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ù…ÛŒÚº ØµØ§Ø±Ù',0),(273968,7611,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ñƒ Ð¾Ð²Ð¾Ñ˜ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð¸',0),(273969,7611,'vi','NgÆ°á»i Sá»­ Dá»¥ng trong Cty nÃ y',0),(273970,7611,'af','Gebruiker in hierdie Onderneming',0),(273971,7611,'ro','Utilizator in aceasta companie',0),(273972,7611,'et','Kasutaja selles ettevÃµttes',0),(273973,7611,'si','Uporabnik v tem podjetju',0),(273974,7611,'ba','Pengguna di perusahaan ini',0),(273975,7611,'nl','Gebruiker in dit bedrijf',0),(273976,7611,'fi','KÃ¤yttÃ¤jÃ¤ tÃ¤ssÃ¤ yrityksessÃ¤',0),(273977,7611,'no','Brukeren i dette selskapet',0),(273978,7611,'da','Brugeren i dette selskab',0),(273979,7611,'ko','ì´ íšŒì‚¬',0),(273980,7611,'he','×ž×©×ª×ž×© ×©×œ ×—×‘×¨×” ×–×•',0),(273981,7611,'el','Î§ÏÎ®ÏƒÏ„Î·Ï‚ ÏƒÎµ Î±Ï…Ï„Î® Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(273982,7611,'zh','åœ¨è¿™å®¶å…¬å¸çš„ç”¨æˆ·\r\n',0),(273983,7611,'sv','AnvÃ¤ndaren i detta fÃ¶retag',0),(273984,7611,'it','Utente in questa societÃ ',0),(273985,7611,'tl','',0),(273986,7611,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3651;&#3609;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3609;&#3637;&#3657;',0),(273987,7611,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤®à¥‡à¤‚ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(273988,7611,'ms','Pengguna dalam Syarikat ini',0),(273989,7611,'ar','Ù…Ø³ØªØ®Ø¯Ù… ÙÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(273990,7611,'fr','Utilisateur dans cette sociÃ©tÃ©',0),(273991,7611,'jp','ã“ã®ä¼šç¤¾ã§ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(273992,7611,'pt','UsuÃ¡rio nesta empresa',0),(273993,7611,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð² ÑÑ‚Ð¾Ð¹ Ð¤Ð¸Ñ€Ð¼Ðµ',0),(273994,7611,'es','Usuario en esta Empresa',0),(273995,7611,'de','Benutzer in dieser Firma',0),(273996,7611,'en','User in this Company',0),(273997,7612,'is','',0),(273998,7612,'dr','Ø±ÙˆÙŠ Ù„ÙŠÙ†Ùƒ  Ø¬Ù‡Øª Ù¾ÙŠÚ¯Ø±Ø¯Ù‰ Ú©Ø±Ø¯Ù† ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(273999,7612,'pr','Ø±ÙˆÙŠ Ù„ÙŠÙ†Ùƒ  Ø¬Ù‡Øª Ù¾ÙŠÚ¯Ø±Ø¯Ù‰ Ú©Ø±Ø¯Ù† ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(274000,7612,'tr','BaÄŸlantÄ±yÄ± izlemek iÃ§in tÄ±klayÄ±n',0),(274001,7612,'pl','Kliknij na Link do utworu',0),(274002,7612,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð²Ñ€ÑŠÐ·ÐºÐ°Ñ‚Ð° ÐºÑŠÐ¼ Ð¿ÐµÑÐµÐ½',0),(274003,7612,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ú©Û’ Ù„ÛŒÛ’ Ù„Ù†Ú© Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(274004,7612,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð›Ð¸Ð½Ðº Ð½Ð° ÑÑ‚Ð°Ð·Ñƒ',0),(274005,7612,'vi','Nháº¥n VÃ o ÄÆ°á»ng Dáº«n Äá»ƒ TÃ¬m',0),(274006,7612,'af','Kliek op Skakel om te Spoor',0),(274007,7612,'ro','FaceÅ£i clic pe link-ul pentru a urmÄƒri',0),(274008,7612,'et','KlÃµpsake linki Loo',0),(274009,7612,'si','Kliknite na povezavo za skladbo',0),(274010,7612,'ba','Klik pada Link untuk lagu',0),(274011,7612,'nl','Klik op Link naar Track',0),(274012,7612,'fi','Klikkaa linkkiÃ¤ seurata',0),(274013,7612,'no','Klikk pÃ¥ linken til spor',0),(274014,7612,'da','Klik pÃ¥ linket til spor',0),(274015,7612,'ko','ì¶”ì  ë§í¬ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(274016,7612,'he','×œ×—×¥ ×¢×œ ×§×™×©×•×¨ ×œ××ª×¨',0),(274017,7612,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÏƒÏÎ½Î´ÎµÏƒÎ¼Î¿ ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(274018,7612,'zh','åœ¨ç‚¹å‡»é“¾æŽ¥æ¥è¿½è¸ª\r\n',0),(274019,7612,'sv','Klicka pÃ¥ lÃ¤nken till spÃ¥r',0),(274020,7612,'it','Clicca sul Link per pista',0),(274021,7612,'tl','',0),(274022,7612,'th','&#3588;&#3621;&#3636;&#3585;&#3610;&#3609;&#3621;&#3636;&#3591;&#3588;&#3660;&#3648;&#3614;&#3639;&#3656;&#3629;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3652;&#3611;',0),(274023,7612,'hi','à¤Ÿà¥à¤°à¥ˆà¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¿à¤‚à¤• à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(274024,7612,'ms','Klik pada pautan ke trek',0),(274025,7612,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø· Ù„Ù„Ù…Ø³Ø§Ø±',0),(274026,7612,'fr','Cliquez sur lien vers piste',0),(274027,7612,'jp','ãƒˆãƒ©ãƒƒã‚¯ã¸ã®ãƒªãƒ³ã‚¯ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(274028,7612,'pt','Clique no Link para faixa',0),(274029,7612,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° ÑÑÑ‹Ð»ÐºÑƒ Ð½Ð° Ñ‚Ñ€ÐµÐº',0),(274030,7612,'es','Click sobre el Enlace a la Pista',0),(274031,7612,'de','Klicken Sie auf Link zum Track',0),(274032,7612,'en','Click on Link to Track',0),(274033,7613,'is','',0),(274034,7613,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…Ø¬Ø¯Ø¯ Ø³ÙØ§Ø±Ø´ ',0),(274035,7613,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ù…Ø¬Ø¯Ø¯ Ø³ÙØ§Ø±Ø´ ',0),(274036,7613,'tr','SipariÅŸ requote',0),(274037,7613,'pl','Requote zamÃ³wienie',0),(274038,7613,'bg','Requote Ñ€ÐµÐ´',0),(274039,7613,'ur','Ø¢Ø±ÚˆØ± Ø±ÛŒÙ‚ÙˆÙˆÙ¹ÛŒ',0),(274040,7613,'sr','Ð ÐµqÑƒÐ¾Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³',0),(274041,7613,'vi','ÄÆ¡n hÃ ng bÃ¡o giÃ¡ láº¡i',0),(274042,7613,'af','Herkwoteer Bestelling',0),(274043,7613,'ro','Requote comanda',0),(274044,7613,'et','Requote tellimus',0),(274045,7613,'si','Requote naloga',0),(274046,7613,'ba','Penawaran kembali urutan',0),(274047,7613,'nl','Requote volgorde',0),(274048,7613,'fi','Requote tilaus',0),(274049,7613,'no','Requote orden',0),(274050,7613,'da','Requote rÃ¦kkefÃ¸lge',0),(274051,7613,'ko','ìˆœì„œë¥¼ requote',0),(274052,7613,'he','Requote ×”×¡×“×¨',0),(274053,7613,'el','Requote ÏƒÎµÎ¹ÏÎ¬',0),(274054,7613,'zh','æ–°ä»·æ ¼è®¢è´­\r\n',0),(274055,7613,'sv','Requote ordning',0),(274056,7613,'it','Requote ordine',0),(274057,7613,'tl','',0),(274058,7613,'th','&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(274059,7613,'hi','à¤•à¥à¤°à¤® requote',0),(274060,7613,'ms','Terpamer perintah',0),(274061,7613,'ar','Ø±ÙŠÙ‚ÙˆØªÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(274062,7613,'fr','Requote ordre',0),(274063,7613,'jp','é †åºã‚’ requote ã—ã¾ã™ã€‚',0),(274064,7613,'pt','Requote ordem',0),(274065,7613,'ru','Ð ÐµÐºÐ²Ð¾Ñ‚Ð¾Ð² Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(274066,7613,'es','Orden de RecotizaciÃ³n',0),(274067,7613,'de','Requote bestellen',0),(274068,7613,'en','Requote Order',0),(274069,7614,'is','',0),(274070,7614,'dr','/ Ú†Ø§Ù¾ Ø¨ÛŒØ¬Ú© ',0),(274071,7614,'pr','Ù†Ù…Ø§ÙŠØ´ / Ú†Ø§Ù¾ ÙØ§ÙƒØªÙˆØ± ',0),(274072,7614,'tr','FaturayÄ± GÃ¶rÃ¼ntÃ¼le/YazdÄ±r',0),(274073,7614,'pl','WyÅ›wietl/drukuj fakturÄ™',0),(274074,7614,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´/Ð¿ÐµÑ‡Ð°Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(274075,7614,'ur','Ù…Ù†Ø¸Ø±/Ø§Ù†ÙˆØ§Ø¦Ø³ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(274076,7614,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ /ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(274077,7614,'vi','Xem/In hÃ³a Ä‘Æ¡n',0),(274078,7614,'af','Besigtig/Druk Faktuur',0),(274079,7614,'ro','Vezi/Imprimare facturÄƒ',0),(274080,7614,'et','Kuva/Prindi arve',0),(274081,7614,'si','Poglej/Natisni raÄun',0),(274082,7614,'ba','Tampilan cetak faktur',0),(274083,7614,'nl','Factuur weergeven/afdrukken',0),(274084,7614,'fi','NÃ¤ytÃ¤ tai Tulosta lasku',0),(274085,7614,'no','Vis/Skriv ut faktura',0),(274086,7614,'da','Se/Udskriv faktura',0),(274087,7614,'ko','êµ¬ë§¤ì„œ ë³´ê¸°/ì¸ì‡„',0),(274088,7614,'he','×”×¦×’/×”×“×¤×¡ ×—×©×‘×•× ×™×ª',0),(274089,7614,'el','Î ÏÎ¿Î²Î¿Î»Î®/Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(274090,7614,'zh','æŸ¥çœ‹/æ‰“å°å‘ç¥¨\r\n',0),(274091,7614,'sv','Visa/Skriv ut faktura',0),(274092,7614,'it','Visualizza/stampa fattura',0),(274093,7614,'tl','',0),(274094,7614,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;/&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(274095,7614,'hi','à¤¦à¥ƒà¤¶à¥à¤¯/à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(274096,7614,'ms','Pemandangan/cetak invois',0),(274097,7614,'ar','Ø¹Ø±Ø¶/Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(274098,7614,'fr','Visualiser/imprimer facture',0),(274099,7614,'jp','è«‹æ±‚æ›¸ã®è¡¨ç¤º/å°åˆ·',0),(274100,7614,'pt','Ver/imprimir factura',0),(274101,7614,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚Ð°',0),(274102,7614,'es','Visionar/Imprimir Factura',0),(274103,7614,'de','Rechnung anzeigen/drucken',0),(274104,7614,'en','View/Print Invoice',0),(274105,7615,'is','',0),(274106,7615,'dr','5 Ø³Ø§Ù„',0),(274107,7615,'pr','5 Ø³Ø§Ù„',0),(274108,7615,'tr','5 yÄ±l',0),(274109,7615,'pl','5 lat',0),(274110,7615,'bg','5 Ð³Ð¾Ð´Ð¸Ð½Ð¸',0),(274111,7615,'ur','Ù¾Ø§Ù†Ú†Ú¾ Ø³Ø§Ù„',0),(274112,7615,'sr','5 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(274113,7615,'vi','5 NÄƒm',0),(274114,7615,'af','5 Jare',0),(274115,7615,'ro','5 Ani',0),(274116,7615,'et','5 Aastat',0),(274117,7615,'si','5 let',0),(274118,7615,'ba','5 Tahun',0),(274119,7615,'nl','5 jaar',0),(274120,7615,'fi','5 vuotta',0),(274121,7615,'no','5 Ã¥r',0),(274122,7615,'da','5 Ã¥r',0),(274123,7615,'ko','5 ë…„',0),(274124,7615,'he','â€5 ×©× ×™×',0),(274125,7615,'el','5 Î§ÏÏŒÎ½Î¹Î±',0),(274126,7615,'zh','5 å¹´',0),(274127,7615,'sv','5 Ã¥r',0),(274128,7615,'it','5 Anni',0),(274129,7615,'tl','',0),(274130,7615,'th','5 à¸›à¸µ',0),(274131,7615,'hi','5 à¤¸à¤¾à¤²',0),(274132,7615,'ms','5 tahun',0),(274133,7615,'ar','Ø®Ù…Ø³ Ø³Ù†ÙˆØ§Øª',0),(274134,7615,'fr','5 Ans',0),(274135,7615,'jp','5 å¹´é–“',0),(274136,7615,'pt','5 anos',0),(274137,7615,'ru','5 Ð›ÐµÑ‚',0),(274138,7615,'es','5 AÃ±os',0),(274139,7615,'de','5 Jahre',0),(274140,7615,'en','5 Years',0),(274141,7616,'is','',0),(274142,7616,'dr','(5 ) Ø³Ø§Ù„',0),(274143,7616,'pr','Ø³ÙˆØ¯ Ù¾Ù†Ø¬(5 ) Ø³Ø§Ù„',0),(274144,7616,'tr','Kar: 5 yÄ±l',0),(274145,7616,'pl','Zysk: 5 lat',0),(274146,7616,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð°: 5 Ð³Ð¾Ð´Ð¸Ð½Ð¸',0),(274147,7616,'ur','ÙØ§Ø¦Ø¯Û: 5 Ø³Ø§Ù„',0),(274148,7616,'sr','Ð”Ð¾Ð±Ð¸Ñ‚ : 5 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(274149,7616,'vi','Lá»£i nhuáº­n - 5 nÄƒm',0),(274150,7616,'af','Wins-5JR',0),(274151,7616,'ro','Profit: 5 ani',0),(274152,7616,'et','Kasum: 5 aasta',0),(274153,7616,'si','DobiÄek: 5 leto',0),(274154,7616,'ba','Keuntungan: 5 tahun',0),(274155,7616,'nl','Winst: 5 jaar',0),(274156,7616,'fi','Voitto: 5 vuotta',0),(274157,7616,'no','Resultat: 5 Ã¥r',0),(274158,7616,'da','Overskud: 5 Ã¥r',0),(274159,7616,'ko','ì´ìµ: 5 ë…„',0),(274160,7616,'he','×¨×•×•×—: 5 ×©× ×”',0),(274161,7616,'el','ÎšÎ­ÏÎ´Î¿Ï‚: 5 Ï‡ÏÏŒÎ½Î¹Î±',0),(274162,7616,'zh','åˆ©æ¶¦-5å¹´\r\n',0),(274163,7616,'sv','Vinst: 5 Ã¥r',0),(274164,7616,'it','Profitto: 5 anni',0),(274165,7616,'tl','',0),(274166,7616,'th','&#3585;&#3635;&#3652;&#3619;-5 &#3611;&#3637;',0),(274167,7616,'hi','à¤²à¤¾à¤­: 5 à¤¸à¤¾à¤²',0),(274168,7616,'ms','Keuntungan: 5 tahun',0),(274169,7616,'ar','Ø§Ù„Ø±Ø¨Ø­: 5 Ø³Ù†ÙˆØ§Øª',0),(274170,7616,'fr','RÃ©sultat: 5 ans',0),(274171,7616,'jp','åˆ©ç›Šï¼š 5 å¹´',0),(274172,7616,'pt','Lucro: 5 anos',0),(274173,7616,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ: 5 Ð»ÐµÑ‚',0),(274174,7616,'es','Utilidad-5 AÃ±os',0),(274175,7616,'de','Gewinn: 5 Jahre',0),(274176,7616,'en','Profit: 5 Year',0),(274177,7617,'is','',0),(274178,7617,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ†  Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ Ù‚Ø¨Ù„ÙŠ  Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(274179,7617,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ†  Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ Ù‚Ø¨Ù„ÙŠ  Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(274180,7617,'tr','SatÄ±ÅŸ sipariÅŸi Ã¶nceki satÄ±ÅŸ sipariÅŸi giriÅŸleri DeÄŸiÅŸtir deÄŸiÅŸtirme',0),(274181,7617,'pl','Zmiana zamÃ³wienia sprzedaÅ¼y bÄ™dzie zastÄ…piÄ‡ wczeÅ›niejsze wpisy zamÃ³wienia sprzedaÅ¼y',0),(274182,7617,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ñ‰Ðµ Ð·Ð°Ð¼ÐµÐ½Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð·Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(274183,7617,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ Ù…Ø±Ø¶ÛŒ Ø¨Ø¯Ù„ Ù¾Ú†Ú¾Ù„Û’ ÙØ±ÙˆØ®Øª ØªØ±ØªÛŒØ¨ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Ø§',0),(274184,7617,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð²Ð¾Ñ™Ðµ ÑƒÐ»Ð°Ð·Ð½Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° Ð·Ð°Ð¼ÐµÐ½Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð³Ñ€ÐµÑˆÐºÐ°Ð¼Ð°',0),(274185,7617,'vi','ÄÆ¡n Äáº·t hÃ ng thay Ä‘á»•i sáº½ thay tháº¿ ÄÆ¡n Äáº·t hÃ ng cáº­p nháº­t láº§n trÆ°á»›c',0),(274186,7617,'af','Verandering van Verkoopsbestelling sal Vorige Verkoopsbestellingsinskrywings Vervang',0),(274187,7617,'ro','Schimbare comandÄƒ va Ã®nlocui anterior de vÃ¢nzÄƒri ordine intrÄƒri',0),(274188,7617,'et','MÃ¼Ã¼gitellimus hakkab asendama eelmise mÃ¼Ã¼k tellimus kannete muutmine',0),(274189,7617,'si','Spreminjanje prodajni nalog bo nadomestil prejÅ¡nje prodaje nalog postavke',0),(274190,7617,'ba','Mengubah urutan penjualan akan mengganti entri Order penjualan sebelumnya',0),(274191,7617,'nl','Verkooporder zal vervangen eerdere Sales Order vermeldingen wijzigen',0),(274192,7617,'fi','Myyntitilaus tulee korvata edellisen myynnin tilauksen tapahtumien muuttaminen',0),(274193,7617,'no','Endre ordre vil erstatte tidligere ordreoppfÃ¸ringer for salg',0),(274194,7617,'da','Ã†ndre salgsordre vil erstatte tidligere salg ordre poster',0),(274195,7617,'ko','íŒë§¤ ì£¼ë¬¸ ìœŒ ëŒ€ì²´ ì´ì „ íŒë§¤ ì£¼ë¬¸ í•­ëª© ë³€ê²½',0),(274196,7617,'he','×©×™× ×•×™ ×”×–×ž× ×ª ×ž×›×™×¨×” ×¨×¦×•×Ÿ ×œ×”×—×œ×™×£ ×¢×¨×›×™ ×¡×“×¨ ×ž×›×™×¨×•×ª ×§×•×“×ž×•×ª',0),(274197,7617,'el','Î‘Î»Î»Î±Î³Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚ Î¸Î± Î±Î½Ï„Î¹ÎºÎ±Ï„Î±ÏƒÏ„Î®ÏƒÎµÎ¹ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(274198,7617,'zh','æ›´æ”¹é”€å”®è®¢å•å°†å–ä»£ä»¥å¾€çš„é”€å”®è®¢å•æ¡ç›®\r\n',0),(274199,7617,'sv','Ã„ndra fÃ¶rsÃ¤ljningsorder ska ersÃ¤tta tidigare fÃ¶rsÃ¤ljning ordning poster',0),(274200,7617,'it','Cambiando la volontÃ  di ordine di vendite vendite precedenti sostituire ordine voci',0),(274201,7617,'tl','',0),(274202,7617,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3632;&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3604;&#3657;&#3623;&#3618;&#3588;&#3635;&#3626;&#3633;&#3',0),(274203,7617,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤® à¤µà¤¿à¤² à¤ªà¤¿à¤›à¤²à¥€ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤œà¤—à¤¹ à¤¬à¤¦à¤² à¤°à¤¹à¤¾',0),(274204,7617,'ms','Mengubah perintah jualan akan menggantikan jualan perintah entri terdahulu',0),(274205,7617,'ar','ØªØºÙŠÙŠØ± \"ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª\" Ø¥Ø±Ø§Ø¯Ø© \"Ø§Ø³ØªØ¨Ø¯Ø§Ù„ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©\"',0),(274206,7617,'fr','Changer ordre de ventes te remplacer les entrÃ©es prÃ©cÃ©dentes ventes ordre',0),(274207,7617,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ ãƒ» ã‚ªãƒ¼ãƒ€ãƒ¼ãŒä»¥å‰è²©å£²æ³¨æ–‡ã‚¨ãƒ³ãƒˆãƒªã®ç½®æ›ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(274208,7617,'pt','Mudar ordem de vendas testamento substituir entradas de ordem de vendas anteriores',0),(274209,7617,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ð±ÑƒÐ´ÐµÑ‚ Ð·Ð°Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð°ÐºÐ°Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(274210,7617,'es','Cambiando el Pedido de Ventas ReemplazarÃ¡ Entradas de Pedidos de Ventas Previas',0),(274211,7617,'de','Sales Order Willen ersetzen frÃ¼here Sales Order EintrÃ¤ge Ã¤ndern',0),(274212,7617,'en','Changing Sales Order will Replace Previous Sales Order Entries',0),(274213,7618,'is','',0),(274214,7618,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ÙŠØ¯ ØªØ¹ÙŠÙŠÙ† Ø´ÙˆØ¯ â€“ Ø§Ú¯Ø± ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(274215,7618,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ÙŠØ¯ ØªØ¹ÙŠÙŠÙ† Ø´ÙˆØ¯ â€“ Ø§Ú¯Ø± ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(274216,7618,'tr','PO numarasÄ± atanmÄ±ÅŸ girilen deÄŸilse,',0),(274217,7618,'pl','Numer zamÃ³wienia bÄ™dzie byÄ‡ przypisane, jeÅ›li nie wszedÅ‚',0),(274218,7618,'bg','PO Ð½Ð¾Ð¼ÐµÑ€ Ð²Ð¸ Ñ‰Ðµ Ð±ÑŠÐ´Ðµ Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½Ð°, Ð°ÐºÐ¾ Ð½Ðµ ÑÐµ Ð²Ð¿Ð¸ÑÐ²Ð°',0),(274219,7618,'ur','Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± ØªÙÙˆÛŒØ¶ Ú©ÛŒØ§ Ú¯ÛŒØ§ØŒ Ø§Ú¯Ø± Ø¯Ø§Ø®Ù„ Ù†ÛÛŒÚº Ú©Ø±Û’ Ú¯Ø§ ÛÙˆ',0),(274220,7618,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐÐ°Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ðµ Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð´Ð¾Ð´ÐµÑ™ÐµÐ½Ð°, Ð°ÐºÐ¾ Ð½Ð¸Ñ˜Ðµ ÑƒÐ½ÐµÑ‚',0),(274221,7618,'vi','Sá»‘ Ä‘Æ¡n mua hÃ ng sáº½ chá»‰ Ä‘á»‹nh náº¿u khÃ´ng nháº­p',0),(274222,7618,'af','Posbus nommer sal word toegeken, indien nie ingeskryf',0),(274223,7618,'ro','PO numÄƒrul va fi atribuit, dacÄƒ nu a intrat',0),(274224,7618,'et','PO Number on mÃ¤Ã¤ratud, kui mitte sisestatud',0),(274225,7618,'si','Å tevilka NaroÄilnice bo dodeljen, Äe ne vnesete',0),(274226,7618,'ba','Nomor PO akan ditetapkan, jika tidak masuk',0),(274227,7618,'nl','PO-nummer zal worden toegewezen, als niet ingevoerd',0),(274228,7618,'fi','Ostotilauksen numero mÃ¤Ã¤ritetty, jos ei tullut',0),(274229,7618,'no','InnkjÃ¸psordrenummer vil vÃ¦re tilordnet, om ikke angitt',0),(274230,7618,'da','PO-nummer vil blive tildelt, hvis ikke angivet',0),(274231,7618,'ko','ì£¼ë¬¸ì„œ ë²ˆí˜¸ ê²ƒìž…ë‹ˆë‹¤ ìˆ˜ í• ë‹¹ í•˜ì§€ ì•Šì„ ê²½ìš° ìž…ë ¥',0),(274232,7618,'he','×ž×¡×¤×¨ ×”-PO ×œ×”×™×•×ª ×ž×•×§×¦×”, ×× ×œ× × ×›× ×¡',0),(274233,7618,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î•Î½Ï„Î¿Î»Î®Ï‚ Î¸Î± Î½Î± Î±Î½Î±Ï„ÎµÎ¸ÎµÎ¯, Î±Î½ Î´ÎµÎ½ Ï„Î­Î¸Î·ÎºÎµ',0),(274234,7618,'zh','è‹¥æœªè¾“å…¥ï¼Œå°†åˆ†é…è®¢å•å·ç \r\n',0),(274235,7618,'sv','InkÃ¶psordernummer kommer att tilldelat, om inte anges',0),(274236,7618,'it','PO numero verrÃ  assegnato, se non inserito',0),(274237,7618,'tl','',0),(274238,7618,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3632;&#3606;&#3641;&#3585;&#3585;&#3635;&#3627;&#3609;&#3604;&#3586;&#3638;&#3657;&#3609; &#3627;&#3634;&#3585;&#3652;&#3617;&#',0),(274239,7618,'hi','à¤ªà¥‹ à¤¨à¤‚à¤¬à¤° à¤¸à¥Œà¤‚à¤ªà¤¾ à¤¨à¤¹à¥€à¤‚, à¤¤à¥‹ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾ à¤¹à¥‹',0),(274240,7618,'ms','PO nombor akan akan diberikan, jika tidak dimasukkan',0),(274241,7618,'ar','Ø±Ù‚Ù… Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø³ÙˆÙ ÙŠÙƒÙˆÙ† ØªØ¹ÙŠÙŠÙ†Ù‡ØŒ Ø£Ù† Ù„Ù… ÙŠÙƒÙ† Ø¯Ø®Ù„',0),(274242,7618,'fr','Nombre de PO sera assignÃ©, si n\'est pas entrÃ©',0),(274243,7618,'jp','PO ç•ªå·ãŒå‰²ã‚Šå½“ã¦ã‚‰ã‚Œã‚‹ã¨ã€ã—ãªã„ã™ã‚‹å…¥åŠ›',0),(274244,7618,'pt','NÃºmero de PO vai ser atribuÃ­do, se nÃ£o entrou',0),(274245,7618,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð° Ð±ÑƒÐ´ÐµÑ‚ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½, ÐµÑÐ»Ð¸ Ð½Ðµ Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»',0),(274246,7618,'es','OC NÃºmero se asignarÃ¡, si no entrada',0),(274247,7618,'de','Auftragsnummer wird zugewiesen wenn nicht werden, eingegeben',0),(274248,7618,'en','PO Number will be assigned, if not entered',0),(274249,7619,'is','',0),(274250,7619,'dr','Ú†Ø§Ù¾  ØªÙ…Ø§Ù…  Ú†Ùƒ Ù‡Ø§ÙŠ  ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø¨Ù‡ ØµÙˆØ±Øª Ú¯Ø±ÙˆÙ‡ÙŠ',0),(274251,7619,'pr','Ú†Ø§Ù¾  ØªÙ…Ø§Ù…  Ú†Ùƒ Ù‡Ø§ÙŠ  ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø¨Ù‡ ØµÙˆØ±Øª Ú¯Ø±ÙˆÙ‡ÙŠ',0),(274252,7619,'tr','Basmak tÃ¼m AP kontrol grubunda',0),(274253,7619,'pl','Drukuj wszystkie kontrole AP w grupie',0),(274254,7619,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ AP Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð² Ð³Ñ€ÑƒÐ¿Ð°',0),(274255,7619,'ur','Ú¯Ø±ÙˆÙ¾ Ù…ÛŒÚº ØªÙ…Ø§Ù… AP Ù¾Ú‘ØªØ§Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(274256,7619,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑÐ²Ð¸Ñ… ÐÐŸ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ñƒ Ð³Ñ€ÑƒÐ¿Ð¸',0),(274257,7619,'vi','In táº¥t cáº£ SÃ©c trong TK pháº£i tráº£ theo nhÃ³m',0),(274258,7619,'af','Druk Alle RB Tjeks in Groep',0),(274259,7619,'ro','ImprimaÅ£i toate controalele de AP Ã®n grup',0),(274260,7619,'et','Prindi kÃµik AP kontrolli rÃ¼hm',0),(274261,7619,'si','Natisni vse preglede AP v skupini',0),(274262,7619,'ba','Mencetak cek AP semua dalam grup',0),(274263,7619,'nl','Alle AP cheques in groep afdrukken',0),(274264,7619,'fi','Tulostaa kaikki AP tarkastukset ryhmÃ¤',0),(274265,7619,'no','Skrive ut alle AP sjekker i gruppen',0),(274266,7619,'da','Udskrive alle AP Checks i gruppen',0),(274267,7619,'ko','ì¸ì‡„ ê·¸ë£¹ì—ì„œ ëª¨ë“  AP ê²€ì‚¬',0),(274268,7619,'he','×”×“×¤×¡ ×›×œ ×”×¦\'×§×™× AP ×‘×§×‘×•×¦×”',0),(274269,7619,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î±Ï€ ÏŒÎ»Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ ÏƒÏ„Î·Î½ Î¿Î¼Î¬Î´Î±',0),(274270,7619,'zh','æ‰“å°æ‰€æœ‰é™„åŠ ä¿é™©è´¹æ”¯ç¥¨ç»„\r\n',0),(274271,7619,'sv','Skriva ut alla AP kontrollerna i gruppen',0),(274272,7619,'it','Stampare tutti i controlli AP in gruppo',0),(274273,7619,'tl','',0),(274274,7619,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3594;&#3655;&#3588;&#3592;&#3656;&#3634;&#3618;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(274275,7619,'hi','à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤¸à¤­à¥€ à¤à¤ªà¥€ à¤šà¥‡à¤• à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(274276,7619,'ms','Mencetak cek AP semua dalam Kumpulan',0),(274277,7619,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´ÙŠÙƒØ§Øª AP ÙÙŠ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(274278,7619,'fr','Imprimer tous les chÃ¨ques de AP en groupe',0),(274279,7619,'jp','ã‚°ãƒ«ãƒ¼ãƒ—å†…ã®ã™ã¹ã¦ã® AP ãƒã‚§ãƒƒã‚¯ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(274280,7619,'pt','Imprimir todas as verificaÃ§Ãµes de AP em grupo',0),(274281,7619,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð²ÑÐµ AP Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð² Ð³Ñ€ÑƒÐ¿Ð¿Ðµ',0),(274282,7619,'es','Imprimir Todos los Cheques de CP en el Grupo',0),(274283,7619,'de','Drucken Sie alle AP-PrÃ¼fungen in Gruppe',0),(274284,7619,'en','Print All AP Checks in Group',0),(274285,7620,'is','',0),(274286,7620,'dr','AR ',0),(274287,7620,'pr','Ú†Ø§Ù¾  ØªÙ…Ø§Ù…  Ú†Ùƒ Ù‡Ø§ÙŠ AR \r\n Ø¨Ù‡ ØµÙˆØ±Øª Ú¯Ø±ÙˆÙ‡ÙŠ',0),(274288,7620,'tr','Basmak tÃ¼m AR kontrol grubunda',0),(274289,7620,'pl','Drukuj wszystkie kontrole AR w grupie',0),(274290,7620,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ AR Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð² Ð³Ñ€ÑƒÐ¿Ð°',0),(274291,7620,'ur','Ú¯Ø±ÙˆÙ¾ Ù…ÛŒÚº ØªÙ…Ø§Ù… Ø§Ù„Ø±Ø­ÛŒÙ‚ Ù¾Ú‘ØªØ§Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(274292,7620,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑÐ²Ð¸Ñ… ÐÐ  Ñ‡ÐµÐºÐ¾Ð²Ðµ Ñƒ Ð³Ñ€ÑƒÐ¿Ð¸',0),(274293,7620,'vi','In táº¥t cáº£ SÃ©c trong TK pháº£i thu theo nhÃ³m',0),(274294,7620,'af','Druk alle AR ondersoeke in groep',0),(274295,7620,'ro','ImprimaÅ£i toate controalele AR Ã®n grup',0),(274296,7620,'et','Prindi kÃµik AR kontrolli rÃ¼hm',0),(274297,7620,'si','Natisni vse AR pregledov v skupini',0),(274298,7620,'ba','Mencetak cek AR semua dalam grup',0),(274299,7620,'nl','Alle AR cheques in groep afdrukken',0),(274300,7620,'fi','Tulostaa kaikki AR tarkastukset ryhmÃ¤',0),(274301,7620,'no','Skrive ut alle AR sjekker i gruppen',0),(274302,7620,'da','Udskrive alle AR Checks i gruppen',0),(274303,7620,'ko','ì¸ì‡„ ê·¸ë£¹ì—ì„œ ëª¨ë“  ì•„ì¹¸ì†Œ í™•ì¸',0),(274304,7620,'he','×”×“×¤×¡ ×›×œ ×”×¦\'×§×™× AR ×‘×§×‘×•×¦×”',0),(274305,7620,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ ÏŒÎ»Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ AR ÏƒÏ„Î·Î½ Î¿Î¼Î¬Î´Î±',0),(274306,7620,'zh','æ‰“å°æ‰€æœ‰ARç»„æ£€æŸ¥\r\n',0),(274307,7620,'sv','Skriva ut alla AR kontrollerna i gruppen',0),(274308,7620,'it','Stampare tutti i controlli di AR in gruppo',0),(274309,7620,'tl','',0),(274310,7620,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3594;&#3655;&#3588;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(274311,7620,'hi','à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤¸à¤­à¥€ à¤à¤†à¤° à¤šà¥‡à¤• à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(274312,7620,'ms','Mencetak cek AR semua dalam Kumpulan',0),(274313,7620,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´ÙŠÙƒØ§Øª AR ÙÙŠ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(274314,7620,'fr','Imprimer tous les chÃ¨ques de AR en groupe',0),(274315,7620,'jp','ã‚°ãƒ«ãƒ¼ãƒ—å†…ã®ã™ã¹ã¦ã® AR ãƒã‚§ãƒƒã‚¯ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(274316,7620,'pt','Imprimir todas as verificaÃ§Ãµes de AR em grupo',0),(274317,7620,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð²ÑÐµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ AR Ð² Ð³Ñ€ÑƒÐ¿Ð¿Ðµ',0),(274318,7620,'es','Imprimir Todos los Cheques de CC en el Grupo',0),(274319,7620,'de','Alle AR-PrÃ¼fungen in Gruppe Drucken',0),(274320,7620,'en','Print All AR Checks in Group',0),(274321,7621,'is','',0),(274322,7621,'dr','Ø´Ø±Ø­ ÙŠØ§ ÙƒØ¯ ÙƒØ§Ù„Ø§ÙŠ Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(274323,7621,'pr','Ø´Ø±Ø­ ÙŠØ§ ÙƒØ¯ ÙƒØ§Ù„Ø§ÙŠ Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(274324,7621,'tr','SilinmiÅŸ Ã¶ÄŸelerin aÃ§Ä±klamasÄ± veya kodu',0),(274325,7621,'pl','UsuniÄ™ty element opis lub kod',0),(274326,7621,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ñ‚ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¸Ð»Ð¸ ÐºÐ¾Ð´',0),(274327,7621,'ur','Ø­Ø°Ù Ø´Ø¯Û Ø¢Ø¦ÛŒÙ¹Ù… Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª ÛŒØ§ Ú©ÙˆÚˆ',0),(274328,7621,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ð¿Ð¸Ñ Ð¸Ð»Ð¸ Ð¨Ð¸Ñ„Ñ€Ð°',0),(274329,7621,'vi','XÃ³a diá»…n giáº£i hÃ ng hay mÃ£',0),(274330,7621,'af','Skrap Item Beskrywing of Kode',0),(274331,7621,'ro','Descriere element ÅŸters sau codul',0),(274332,7621,'et','Kustutatud toote kirjeldus vÃµi kood',0),(274333,7621,'si','Izbrisanega elementa opis ali Å¡ifra',0),(274334,7621,'ba','Deskripsi Item yang dihapus atau kode',0),(274335,7621,'nl','Verwijderde de objectbeschrijving of Code',0),(274336,7621,'fi','Poistetun kohteen kuvaus tai koodi',0),(274337,7621,'no','Slettet element beskrivelsen av eller koden',0),(274338,7621,'da','Slettede varebeskrivelse eller kode',0),(274339,7621,'ko','ì‚­ì œ ëœ í•­ëª© ì„¤ëª… ë˜ëŠ” ì½”ë“œ',0),(274340,7621,'he','×ª×™××•×¨ ×¤×¨×™×˜ ×©× ×ž×—×§ ××• ×§×•×“',0),(274341,7621,'el','Î”Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î® ÎºÏŽÎ´Î¹ÎºÎ±',0),(274342,7621,'zh','åˆ é™¤é¡¹ç›®è¯´æ˜Žæˆ–ä»£ç \r\n',0),(274343,7621,'sv','Borttagna objektbeskrivning eller kod',0),(274344,7621,'it','Elemento eliminato Descrizione o codice',0),(274345,7621,'tl','',0),(274346,7621,'th','&#3621;&#3610;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; &#3627;&#3619;&#3639;&#3629;&#3619;&#3627;&#3633;&#3626;&#3649;&#3621;&#3657;&#3623;',0),(274347,7621,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£ à¤¯à¤¾ à¤•à¥‹à¤¡',0),(274348,7621,'ms','Keterangan Item Dihapuskan atau kod',0),(274349,7621,'ar','Ø­Ø°Ù Ø¨ÙŠØ§Ù† Ø£Ùˆ Ø±Ù…Ø² Ø§Ù„ØµÙ†Ù',0),(274350,7621,'fr','Description de l\'Ã©lÃ©ment supprimÃ© ou Code',0),(274351,7621,'jp','å‰Šé™¤ã•ã‚ŒãŸé …ç›®ã®èª¬æ˜Žã¾ãŸã¯ã‚³ãƒ¼ãƒ‰',0),(274352,7621,'pt','DescriÃ§Ã£o do Item excluÃ­do ou cÃ³digo',0),(274353,7621,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð½Ð¾Ðµ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ð° Ð¸Ð»Ð¸ ÐšÐ¾Ð´',0),(274354,7621,'es','Nombre de Item o CÃ³digo Eliminado ',0),(274355,7621,'de','GelÃ¶schte Artikelbeschreibung oder Code',0),(274356,7621,'en','Deleted Item Description or Code',0),(274357,7622,'is','',0),(274358,7622,'dr','Ú†Ùƒ Ù‡Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ ',0),(274359,7622,'pr','Ú†Ùƒ Ù‡Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ ',0),(274360,7622,'tr','Zaten yazÄ±lÄ± denetler',0),(274361,7622,'pl','Sprawdza, czy juÅ¼ napisaÅ‚',0),(274362,7622,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð²ÐµÑ‡Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸',0),(274363,7622,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ù„Ú©Ú¾ÛŒ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’',0),(274364,7622,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð° Ð²ÐµÑ› Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(274365,7622,'vi','SÃ©c Ä‘Ã£ viáº¿t',0),(274366,7622,'af','Tjeks Alreeds Uitgeskryf',0),(274367,7622,'ro','Controalele deja scris',0),(274368,7622,'et','Juba kirjutatud kontrollid',0),(274369,7622,'si','Pregledi, ki se Å¾e napisal',0),(274370,7622,'ba','Cek yang sudah ditulis',0),(274371,7622,'nl','Controles al geschreven',0),(274372,7622,'fi','Jo kirjoittanut tarkastuksia',0),(274373,7622,'no','Kontrollerer allerede skrevet',0),(274374,7622,'da','Kontrol allerede skrevet',0),(274375,7622,'ko','ì´ë¯¸ ìž‘ì„± í™•ì¸',0),(274376,7622,'he','×‘×“×™×§×•×ª ×›×‘×¨ × ×›×ª×‘',0),(274377,7622,'el','Î•Î»Î­Î³Ï‡Î¿Ï…Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î®Î´Î· Î³ÏÎ¬ÏˆÎµÎ¹',0),(274378,7622,'zh','æ£€æŸ¥å·²ç»å†™å¥½\r\n',0),(274379,7622,'sv','Kontroller som redan skrivit',0),(274380,7622,'it','Controlli giÃ  scritti',0),(274381,7622,'tl','',0),(274382,7622,'th','&#3648;&#3594;&#3655;&#3588;&#3652;&#3604;&#3657;&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(274383,7622,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤²à¤¿à¤–à¤¾ à¤šà¥‡à¤•',0),(274384,7622,'ms','Cek yang telah ditulis',0),(274385,7622,'ar','Ø§Ù„Ø´ÙŠÙƒØ§Øª Ù…ÙƒØªÙˆØ¨Ø© Ù…Ø³Ø¨Ù‚Ø§Ù‹',0),(274386,7622,'fr','VÃ©rifie dÃ©jÃ  Ã©crit',0),(274387,7622,'jp','ã™ã§ã«æ›¸ã‹ã‚Œã¦ã„ã‚‹ã‚’ç¢ºèªã—ã¾ã™',0),(274388,7622,'pt','Verifica jÃ¡ escritos',0),(274389,7622,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚ ÑƒÐ¶Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(274390,7622,'es','Cheques ya Escritos',0),(274391,7622,'de','PrÃ¼fungen bereits geschrieben',0),(274392,7622,'en','Checks Already Written',0),(274393,7623,'is','',0),(274394,7623,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(274395,7623,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(274396,7623,'tr','PO oluÅŸturmak',0),(274397,7623,'pl','Tworzenie PO',0),(274398,7623,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° PO',0),(274399,7623,'ur','Ù¾Ùˆ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(274400,7623,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ ÐŸÐž',0),(274401,7623,'vi','Táº¡o Ä‘Æ¡n mua hÃ ng',0),(274402,7623,'af','Skep AB',0),(274403,7623,'ro','Crea PO',0),(274404,7623,'et','Loo PO',0),(274405,7623,'si','Ustvarite PO',0),(274406,7623,'ba','Membuat PO',0),(274407,7623,'nl','Inkooporders maken',0),(274408,7623,'fi','Luo Ostotilaus',0),(274409,7623,'no','Opprette PO',0),(274410,7623,'da','Oprette PO',0),(274411,7623,'ko','ì‚¬ì„œí•¨ ë§Œë“¤ê¸°',0),(274412,7623,'he','×¦×•×¨ ×”×–×ž× ×ª ×¨×›×©',0),(274413,7623,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± PO',0),(274414,7623,'zh','åˆ›å»ºé‡‡è´­è®¢å•\r\n',0),(274415,7623,'sv','Skapa PO',0),(274416,7623,'it','Creare PO',0),(274417,7623,'tl','',0),(274418,7623,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(274419,7623,'hi','PO à¤¬à¤¨à¤¾à¤à¤',0),(274420,7623,'ms','Mencipta PO',0),(274421,7623,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¨Ø±ÙŠØ¯',0),(274422,7623,'fr','CrÃ©er des PO',0),(274423,7623,'jp','PO ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(274424,7623,'pt','Criar PO',0),(274425,7623,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¡ÐŸ',0),(274426,7623,'es','Crear OC',0),(274427,7623,'de','Erstellen von PO',0),(274428,7623,'en','Create PO',0),(274429,7624,'is','',0),(274430,7624,'dr','Ø­Ø°Ù  Ø­Ù…Ù„  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(274431,7624,'pr','Ø­Ø°Ù  Ø­Ù…Ù„  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(274432,7624,'tr','Drop gemi PO',0),(274433,7624,'pl','Spadek statku PO',0),(274434,7624,'bg','ÐšÐ°Ð¿ÐºÐ° ÐºÐ¾Ñ€Ð°Ð± PO',0),(274435,7624,'ur','Ø¬ÛØ§Ø² Ù¾Ùˆ Ú†Ú¾ÙˆÚ‘ÛŒÚº',0),(274436,7624,'sr','Ð¡Ð¿ÑƒÑÑ‚Ð¸ Ð±Ñ€Ð¾Ð´ ÐŸÐž',0),(274437,7624,'vi','Bá» ',0),(274438,7624,'af','Versende AB Aflewer',0),(274439,7624,'ro','PicÄƒturÄƒ navÄƒ PO',0),(274440,7624,'et','Drop laev PO',0),(274441,7624,'si','Padec ladja PO',0),(274442,7624,'ba','Drop kapal PO',0),(274443,7624,'nl','Drop schip PO',0),(274444,7624,'fi','Pudota aluksen PO',0),(274445,7624,'no','Slipp skipet PO',0),(274446,7624,'da','Drop skib PO',0),(274447,7624,'ko','í•˜ë½ ë°° í¬',0),(274448,7624,'he','×©×—×¨×¨ ××ª ×”×¡×¤×™× ×” ×¤×•',0),(274449,7624,'el','Î‘ÎœÎ•Î£ Î‘Î ÎŸÎ£Î¤ PO',0),(274450,7624,'zh','ç»“æŸè¿é€è®¢å•\r\n',0),(274451,7624,'sv','SlÃ¤ppa fartyget PO',0),(274452,7624,'it','Goccia nave PO',0),(274453,7624,'tl','',0),(274454,7624,'th','&#3621;&#3604;&#3586;&#3609;&#3626;&#3656;&#3591;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(274455,7624,'hi','à¤¡à¥à¤°à¥‰à¤ª à¤œà¤¹à¤¾à¤œ à¤ªà¥‹',0),(274456,7624,'ms','Jatuh kapal PO',0),(274457,7624,'ar','Ø¥Ø³Ù‚Ø§Ø· Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¨Ùˆ',0),(274458,7624,'fr','Drop Ship PO',0),(274459,7624,'jp','ãƒ‰ãƒ­ãƒƒãƒ—èˆ¹ PO',0),(274460,7624,'pt','PO de navio da gota',0),(274461,7624,'ru','ÐŸÐ°Ð´ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ PO',0),(274462,7624,'es','Enviar el OC Directamente',0),(274463,7624,'de','Drop Schiff PO',0),(274464,7624,'en','Drop Ship PO',0),(274465,7625,'is','',0),(274466,7625,'dr','Ø´Ø±Ø­ Ø¯ÙŠÚ¯Ø± ÙƒØ§Ù„Ø§',0),(274467,7625,'pr','Ø´Ø±Ø­ Ø¯ÙŠÚ¯Ø± ÙƒØ§Ù„Ø§',0),(274468,7625,'tr','DiÄŸer madde aÃ§Ä±klamasÄ±',0),(274469,7625,'pl','Inny opis przedmiotu',0),(274470,7625,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(274471,7625,'ur','Ø¯ÙˆØ³Ø±ÛŒ Ø´Û’ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(274472,7625,'sr','Ð”Ñ€ÑƒÐ³Ð¸ Ð¾Ð¿Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(274473,7625,'vi','MÃ´ táº£ cÃ¡c hÃ ng khÃ¡c',0),(274474,7625,'af','Ander Item Beskrywing',0),(274475,7625,'ro','AltÄƒ descriere element',0),(274476,7625,'et','Muu kauba kirjeldus',0),(274477,7625,'si','Drugi opis artikla',0),(274478,7625,'ba','Deskripsi Item lainnya',0),(274479,7625,'nl','Andere objectbeschrijving',0),(274480,7625,'fi','Muut kohteen kuvaus',0),(274481,7625,'no','Andre varebeskrivelsen',0),(274482,7625,'da','Andre varebeskrivelse',0),(274483,7625,'ko','ë‹¤ë¥¸ í•­ëª© ì„¤ëª…',0),(274484,7625,'he','×ª×™××•×¨ ×¤×¨×™×˜ ××—×¨',0),(274485,7625,'el','Î†Î»Î»Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(274486,7625,'zh','å…¶ä»–é¡¹ç›®è¯´æ˜Ž\r\n',0),(274487,7625,'sv','Andra objektbeskrivning',0),(274488,7625,'it','Altra elemento di descrizione',0),(274489,7625,'tl','',0),(274490,7625,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3629;&#3639;&#3656;&#3609;',0),(274491,7625,'hi','à¤…à¤¨à¥à¤¯ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£',0),(274492,7625,'ms','Keterangan Item lain',0),(274493,7625,'ar','Ø£Ø®Ø±Ù‰ ÙˆØµÙ Ø§Ù„ØµÙ†Ù',0),(274494,7625,'fr','Autre Description de l\'objet',0),(274495,7625,'jp','ãã®ä»–ã®é …ç›®ã®èª¬æ˜Ž',0),(274496,7625,'pt','Outra Item DescriÃ§Ã£o',0),(274497,7625,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð”Ñ€ÑƒÐ³Ð¾Ð³Ð¾ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(274498,7625,'es','Otra DescripciÃ³n de Item',0),(274499,7625,'de','Andere Artikelbeschreibung',0),(274500,7625,'en','Other Item Description',0),(274501,7626,'is','',0),(274502,7626,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø§Ø¨Øª Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(274503,7626,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø§Ø¨Øª Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(274504,7626,'tr','TA Komisyonu-dÃ¼z tutar',0),(274505,7626,'pl','Kwota TA Komisja Flat',0),(274506,7626,'bg','Ð¢Ð ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ-Ñ„Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ð° ÑÑƒÐ¼Ð°',0),(274507,7626,'ur','TA Ú©Ù…ÛŒØ´Ù† ÙÙ„ÛŒÙ¹ Ø±Ù‚Ù…',0),(274508,7626,'sr','Ð¢Ð ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð°-Ð´ÑƒÑ€ Ð¸Ð·Ð½Ð¾Ñ',0),(274509,7626,'vi','Hoa há»“ng TA-1 giÃ¡',0),(274510,7626,'af','MNS Kommissie-plat bedrag',0),(274511,7626,'ro','Valoarea TA Comisiei-plat',0),(274512,7626,'et','Tehnilise abi komisjoni-kindla summa',0),(274513,7626,'si','TA Komisija-pavÅ¡alni znesek',0),(274514,7626,'ba','Jumlah TA Komisi-Flat',0),(274515,7626,'nl','TA Commissie-Flat bedrag',0),(274516,7626,'fi','TA komission-Flat mÃ¤Ã¤rÃ¤',0),(274517,7626,'no','TA kommisjon-Flat belÃ¸p',0),(274518,7626,'da','TA Kommissionen-faste belÃ¸b',0),(274519,7626,'ko','íƒ€ ìœ„ì›íšŒ í”Œëž« ê¸ˆì•¡',0),(274520,7626,'he','×¡×›×•× ×”×¢×ž×œ×” TA-×©×˜×•×—',0),(274521,7626,'el','Î¤Î‘ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®-ÎµÏ€Î¯Ï€ÎµÎ´Î·Ï‚ Ï€Î¿ÏƒÏŒ',0),(274522,7626,'zh','æŠ€æœ¯ç½®æ¢ä½£é‡‘ï¼Œå›ºå®šæ•°é¢\r\n',0),(274523,7626,'sv','TA kommissionen-Flat belopp',0),(274524,7626,'it','TA Commissione Flat quantitÃ ',0),(274525,7626,'tl','',0),(274526,7626,'th','TA Commission-Flat Amount',0),(274527,7626,'hi','à¤Ÿà¤¾ à¤†à¤¯à¥‹à¤—-à¤«à¥à¤²à¥ˆà¤Ÿ à¤°à¤¾à¤¶à¤¿',0),(274528,7626,'ms','TA Suruhanjaya-rata jumlah',0),(274529,7626,'ar','Ø§Ù„Ù…Ø¨Ù„Øº ØªØ§ Ø§Ù„Ù„Ø¬Ù†Ø©-Ù…Ø³Ø·Ø­Ø©',0),(274530,7626,'fr','Montant de TA Commission-plat',0),(274531,7626,'jp','TA å§”å“¡ä¼šãƒ•ãƒ©ãƒƒãƒˆé‡',0),(274532,7626,'pt','Quantidade de TA ComissÃ£o-Flat',0),(274533,7626,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ TA-Ð±ÐµÐ¼Ð¾Ð»ÑŒ',0),(274534,7626,'es','ComisiÃ³n TA-Monto Fisjo',0),(274535,7626,'de','TA Kommission-Flat-Betrag',0),(274536,7626,'en','TA Commission-Flat Amount',0),(274537,7627,'is','',0),(274538,7627,'dr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(274539,7627,'pr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(274540,7627,'tr','TA komisyon yÃ¼zdesi',0),(274541,7627,'pl','TA Komisja procent',0),(274542,7627,'bg','Ð¢Ð ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ-%',0),(274543,7627,'ur','TA Ú©Ù…ÛŒØ´Ù† ÙÛŒØµØ¯',0),(274544,7627,'sr','Ð¢Ð ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° %',0),(274545,7627,'vi','% Hoa há»“ng TA',0),(274546,7627,'af','MNS Kommissie-persent',0),(274547,7627,'ro','TA Comisiei la sutÄƒ',0),(274548,7627,'et','Tehnilise abi komisjoni-protsenti',0),(274549,7627,'si','TA Komisija-odstotno',0),(274550,7627,'ba','TA Komisi-persen',0),(274551,7627,'nl','TA Commissie-procent',0),(274552,7627,'fi','TA komission prosentin',0),(274553,7627,'no','TA kommisjonen prosent',0),(274554,7627,'da','TA Kommissionen-procent',0),(274555,7627,'ko','íƒ€ ìœ„ì›íšŒ-%',0),(274556,7627,'he','××—×•×– ×”×¢×ž×œ×” ×ª ×',0),(274557,7627,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Ï„Î±-Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(274558,7627,'zh','æŠ€æœ¯æ”¯æ´ä½£é‡‘ï¼Œç™¾åˆ†æ¯”\r\n',0),(274559,7627,'sv','TA kommissionen-procent',0),(274560,7627,'it','TA Commissione per cento',0),(274561,7627,'tl','',0),(274562,7627,'th','TA Commission-Percent',0),(274563,7627,'hi','à¤Ÿà¤¾ à¤†à¤¯à¥‹à¤—-à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(274564,7627,'ms','Peratus komisen TA',0),(274565,7627,'ar','ØªØ§ Ø§Ù„Ù„Ø¬Ù†Ø© Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(274566,7627,'fr','TA Commission pour cent',0),(274567,7627,'jp','TA å§”å“¡ä¼š ï¼…',0),(274568,7627,'pt','TA ComissÃ£o-por cento',0),(274569,7627,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ TA',0),(274570,7627,'es','ComisiÃ³n TA-Porcentaje',0),(274571,7627,'de','TA Kommission Prozent',0),(274572,7627,'en','TA Commission-Percent',0),(274573,7628,'is','',0),(274574,7628,'dr','(Ø§Ù‚Ø³Ø§Ø·) Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø¨ÛŒØ¬Ú© Ø­Ø°Ù Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ù†Ø¯ ',0),(274575,7628,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§(Ø§Ù‚Ø³Ø§Ø·) Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² ÙØ§ÙƒØªÙˆØ± Ø­Ø°Ù Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ù†Ø¯ ',0),(274576,7628,'tr','Ã–demeler Ã¶nce fatura silinmelidir.',0),(274577,7628,'pl','PÅ‚atnoÅ›ci muszÄ… byÄ‡ usuniÄ™te przed faktury',0),(274578,7628,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸ÑÑ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(274579,7628,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø³Û’ Ù‚Ø¨Ù„ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(274580,7628,'sr','Ð˜ÑÐ¿Ð»Ð°Ñ‚Ð° Ð¼Ð¾Ñ€Ð° Ð´Ð° Ð±ÑƒÐ´Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½ Ð¿Ñ€Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(274581,7628,'vi','XÃ³a Thanh ToÃ¡n trÆ°á»›c khi xuáº¥t hÃ³a Ä‘Æ¡n',0),(274582,7628,'af','Betalings Moet voor Faktuur Geskrap Word ',0),(274583,7628,'ro','PlÄƒÅ£ile trebuie sÄƒ fie ÅŸterse Ã®nainte de facturÄƒ',0),(274584,7628,'et','Maksed tuleb kustutada enne arvet',0),(274585,7628,'si','PlaÄila morate izbrisati, preden raÄuna',0),(274586,7628,'ba','Pembayaran harus dihapus sebelum faktur',0),(274587,7628,'nl','Betalingen moeten worden verwijderd voordat de factuur',0),(274588,7628,'fi','Maksut on poistettava ennen laskua',0),(274589,7628,'no','Betalinger mÃ¥ slettes fÃ¸r fakturaen',0),(274590,7628,'da','Betalinger skal slettes, fÃ¸r fakturaen',0),(274591,7628,'ko','ì§€ë¶ˆ ì†¡ìž¥ ì „ì— ì‚­ì œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(274592,7628,'he','×ª×©×œ×•×ž×™× ×™×© ×œ×ž×—×•×§ ×œ×¤× ×™ ×—×©×‘×•× ×™×ª',0),(274593,7628,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î´Î¹Î±Î³ÏÎ±Ï†Î¿ÏÎ½ Ï€ÏÎ¹Î½ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(274594,7628,'zh','ä»˜æ¬¾å¿…é¡»åœ¨å‘ç¥¨ä¹‹å‰åˆ é™¤\r\n',0),(274595,7628,'sv','Betalningar mÃ¥ste tas bort innan fakturan',0),(274596,7628,'it','I pagamenti devono essere cancellati prima fattura',0),(274597,7628,'tl','',0),(274598,7628,'th','&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3605;&#3657;&#3629;&#3591;&#3621;&#3610;&#3585;&#3656;&#3629;&#3609;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(274599,7628,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤œà¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(274600,7628,'ms','Pembayaran mesti dihapuskan sebelum invois',0),(274601,7628,'ar','ÙŠØ¬Ø¨ Ø­Ø°Ù Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ù‚Ø¨Ù„ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(274602,7628,'fr','Les paiements doivent Ãªtre supprimÃ©s avant la facture',0),(274603,7628,'jp','æ”¯æ‰•ã„ã‚’è«‹æ±‚ã™ã‚‹å‰ã«å‰Šé™¤ã—ãªã‘ã‚Œã°ãªã‚Šã¾ã›ã‚“',0),(274604,7628,'pt','Os pagamentos devem ser excluÃ­dos antes de factura',0),(274605,7628,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹ Ð´Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(274606,7628,'es','Pagos Deben Ser Eliminados Antes Que Facturar',0),(274607,7628,'de','Zahlungen mÃ¼ssen vor Rechnung gelÃ¶scht werden',0),(274608,7628,'en','Payments Must Be Deleted Before Invoice',0),(274609,7629,'is','',0),(274610,7629,'dr','Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ  Ù†Ù‡ ÙŠÙƒ  Ú†Ùƒ',0),(274611,7629,'pr','Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ  Ù†Ù‡ ÙŠÙƒ  Ú†Ùƒ',0),(274612,7629,'tr','KREDÄ° KARTI, Ã‡EK DEÄžÄ°L',0),(274613,7629,'pl','NIE CZEK, KARTA KREDYTOWA',0),(274614,7629,'bg','ÐšÐ Ð•Ð”Ð˜Ð¢ÐÐ ÐšÐÐ Ð¢Ð, ÐÐ• ÐŸÐ ÐžÐ’Ð•Ð ÐšÐ',0),(274615,7629,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±ÚˆØŒ Ù†Û Ø§ÛŒÚ© Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(274616,7629,'sr','ÐšÐ Ð•Ð”Ð˜Ð¢ÐÐ ÐšÐÐ Ð¢Ð˜Ð¦Ð, ÐÐ• Ð§Ð•Ðš',0),(274617,7629,'vi','Tháº» TÃ­n Dá»¥ng, KhÃ´ng Pháº£i SÃ©c',0),(274618,7629,'af','KREDIETKAART, NIE GEMERK',0),(274619,7629,'ro','CARD DE CREDIT, NU O VERIFICARE',0),(274620,7629,'et','KREDIITKAARDI, MITTE VAADATA',0),(274621,7629,'si','KREDITNE KARTICE, NE POTRDITE',0),(274622,7629,'ba','KARTU KREDIT, TIDAK CEK',0),(274623,7629,'nl','CREDIT CARD, NIET EEN SELECTIEVAKJE',0),(274624,7629,'fi','HYVITTÃ„Ã„ KARSTATA, EI TARKISTA',0),(274625,7629,'no','KREDITTKORT, IKKE EN SJEKK',0),(274626,7629,'da','KREDITKORT, IKKE EN CHECK',0),(274627,7629,'ko','ì‹ ìš© ì¹´ë“œ, ì²´í¬ í•˜ì§€',0),(274628,7629,'he','×›×¨×˜×™×¡ ××©×¨××™, ×œ× ×¦\'×§',0),(274629,7629,'el','Î Î™Î£Î¤Î©Î¤Î™ÎšÎ‰ ÎšÎ†Î¡Î¤Î‘, Î”Î•Î Î•ÎŠÎÎ‘Î™ ÎœÎ™Î‘ Î•Î Î™Î¤Î‘Î“Î‰',0),(274630,7629,'zh','ä¿¡ç”¨å¡ï¼Œä¸æ˜¯æ”¯ç¥¨\r\n',0),(274631,7629,'sv','KREDITKORT, INTE EN KONTROLL',0),(274632,7629,'it','CARTA DI CREDITO, NON UN ASSEGNO',0),(274633,7629,'tl','',0),(274634,7629,'th','&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3594;&#3655;&#3588;',0),(274635,7629,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡, à¤¨à¤¹à¥€à¤‚ à¤à¤• à¤šà¥‡à¤•',0),(274636,7629,'ms','KAD KREDIT, TIDAK MENDAFTAR',0),(274637,7629,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†ØŒ Ù„Ø§ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(274638,7629,'fr','CARTE DE CRÃ‰DIT, PAS UN CHÃˆQUE',0),(274639,7629,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã€ãƒã‚§ãƒƒã‚¯ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(274640,7629,'pt','CARTÃƒO DE CRÃ‰DITO, NÃƒO Ã‰ UM CHEQUE',0),(274641,7629,'ru','ÐšÐ Ð•Ð”Ð˜Ð¢ÐÐÐ¯ ÐšÐÐ Ð¢ÐžÐ§ÐšÐ, ÐÐ•',0),(274642,7629,'es','TARJETA DE CREDITO, NO CHEQUE',0),(274643,7629,'de','KREDITKARTE, KEINE ÃœBERPRÃœFUNG',0),(274644,7629,'en','CREDIT CARD, NOT A CHECK',0),(274645,7630,'is','',0),(274646,7630,'dr','ÙŠÙƒ Ú†Ùƒ Ù†ÙŠØ³Øª ',0),(274647,7630,'pr','ÙŠÙƒ Ú†Ùƒ Ù†ÙŠØ³Øª ',0),(274648,7630,'tr','BÄ°R Ã‡EK',0),(274649,7630,'pl','NIE CZEK',0),(274650,7630,'bg','ÐÐ• ÐŸÐ ÐžÐ’Ð•Ð ÐšÐ',0),(274651,7630,'ur','Ù†ÛÛŒÚº Ø§ÛŒÚ© Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(274652,7630,'sr','ÐÐ• Ð§Ð•Ðš',0),(274653,7630,'vi','KHÃ”NG PHáº¢I SÃ‰C',0),(274654,7630,'af','NIE \'n TJEK',0),(274655,7630,'ro','NU O VERIFICARE',0),(274656,7630,'et','MITTE SISSE',0),(274657,7630,'si','NE POTRDITE',0),(274658,7630,'ba','TIDAK CEK',0),(274659,7630,'nl','NIET EEN SELECTIEVAKJE',0),(274660,7630,'fi','EI SISÃ„Ã„N',0),(274661,7630,'no','IKKE EN SJEKK',0),(274662,7630,'da','IKKE EN CHECK',0),(274663,7630,'ko','ê²€ì‚¬ë¥¼ í•˜ì§€',0),(274664,7630,'he','×œ× ×¦\'×§',0),(274665,7630,'el','Î”Î•Î Î•ÎŠÎÎ‘Î™ ÎœÎ™Î‘ Î•Î Î™Î¤Î‘Î“Î‰',0),(274666,7630,'zh','ä¸æ˜¯æ”¯ç¥¨\r\n',0),(274667,7630,'sv','INTE EN CHECK',0),(274668,7630,'it','NON UN CONTROLLO',0),(274669,7630,'tl','',0),(274670,7630,'th','&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3594;&#3655;&#3588;',0),(274671,7630,'hi','à¤¨à¤¹à¥€à¤‚ à¤à¤• à¤šà¥‡à¤•',0),(274672,7630,'ms','TIDAK MENDAFTAR',0),(274673,7630,'ar','Ù„Ø§ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(274674,7630,'fr','PAS UN CHÃˆQUE',0),(274675,7630,'jp','ãƒã‚§ãƒƒã‚¯ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(274676,7630,'pt','NÃƒO Ã‰ UM CHEQUE',0),(274677,7630,'ru','ÐÐ• ÐŸÐ ÐžÐ’Ð•Ð Ð˜Ð¢Ð¬',0),(274678,7630,'es','NO ES CHEQUE',0),(274679,7630,'de','KEINE ÃœBERPRÃœFUNG',0),(274680,7630,'en','NOT A CHECK',0),(274681,7631,'is','',0),(274682,7631,'dr','(Ø®Ù„Ø§ØµÙ‡',0),(274683,7631,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ Ø¨Ø§ ÙÙŠÙˆØ² Ø®ÙˆØ¯ÙƒØ§Ø±(Ø®Ù„Ø§ØµÙ‡',0),(274684,7631,'tr','Kesik ile yardÄ±m',0),(274685,7631,'pl','Pomoc z wyciÄ™ciami',0),(274686,7631,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ Ñ Ð¸Ð·Ñ€ÐµÐ·ÐºÐ¸',0),(274687,7631,'ur','Ú©ÙˆÙ¹ÙˆØ¹Ø«Ø³ Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ø¯Ø¯',0),(274688,7631,'sr','ÐŸÐ¾Ð¼Ð¾Ð·Ð¸ ÑÐ° Ð¸Ð»Ð°Ð½Ð¾Ð²Ð°',0),(274689,7631,'vi','Trá»£ giÃºp',0),(274690,7631,'af','Help met uitsnystukke',0),(274691,7631,'ro','Ajutor cu decupaje',0),(274692,7631,'et','Cutouts aidata',0),(274693,7631,'si','PomoÄ z izrezi',0),(274694,7631,'ba','Membantu dengan guntingan',0),(274695,7631,'nl','Helpen met knipsels',0),(274696,7631,'fi','Auttaa automaattikatkaisijat',0),(274697,7631,'no','Hjelp med utklipp',0),(274698,7631,'da','HjÃ¦lpe med udskÃ¦ringer',0),(274699,7631,'ko','ë‹¨íŽ¸ì— ë„ì›€ì´',0),(274700,7631,'he','×¢×–×¨×” ×¢× ×ž×’×–×¨×•×ª',0),(274701,7631,'el','Î’Î¿Î·Î¸Î®ÏƒÎµÎ¹ Î¼Îµ Î±Ï€Î¿ÎºÏŒÎ¼Î¼Î±Ï„Î±',0),(274702,7631,'zh','å¸®åŠ©æœ‰å¼€å£\r\n',0),(274703,7631,'sv','HjÃ¤lp med utskÃ¤rningar',0),(274704,7631,'it','Aiuto con ritagli',0),(274705,7631,'tl','',0),(274706,7631,'th','&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3604;&#3657;&#3623;&#3618;&#3585;&#3634;&#3619;&#3605;&#3633;&#3604;&#3585;&#3619;&#3632;&#3649;&#3626;&#3652;&#3615;&#3615;&#3657;&#3634;',0),(274707,7631,'hi','à¤•à¤Ÿà¤†à¤‰à¤Ÿ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤®à¤¦à¤¦',0),(274708,7631,'ms','Membantu dengan Cutouts',0),(274709,7631,'ar','Ù…Ø³Ø§Ø¹Ø¯Ø© Ù…Ø¹ Ø§Ù„Ù‚ÙˆØ§Ø·Ø¹',0),(274710,7631,'fr','Aider avec dÃ©coupes',0),(274711,7631,'jp','æŽ’æ°—åˆ‡æ›¿å™¨ã‚’æ”¯æ´ã—ã¾ã™ã€‚',0),(274712,7631,'pt','Ajuda com recortes',0),(274713,7631,'ru','ÐŸÐ¾Ð¼Ð¾Ð³Ð¸Ñ‚Ðµ Ñ Ð²Ñ‹Ñ€ÐµÐ·Ð°Ð¼Ð¸',0),(274714,7631,'es','Ayuda Con Figuras Recortadas',0),(274715,7631,'de','Helfen Sie mit Ausschnitten',0),(274716,7631,'en','Help With Cutouts',0),(274717,7632,'is','',0),(274718,7632,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(274719,7632,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(274720,7632,'tr','Ana sayfa boyutu',0),(274721,7632,'pl','Rozmiar arkusza rodzicÃ³w',0),(274722,7632,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð»Ð¸ÑÑ‚ Ð½Ð° Ñ€Ð¾Ð´Ð¸Ñ‚ÐµÐ»',0),(274723,7632,'ur','Ø¬Ø¯ ÙˆØ±Ù‚ Ø³Ø§Ø¦Ø²',0),(274724,7632,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð»Ð¸ÑÑ‚Ð° Ð½Ð°Ð´Ñ€ÐµÑ’ÐµÐ½Ð¾Ð³',0),(274725,7632,'vi','Cá»¡ giáº¥y cha máº¡',0),(274726,7632,'af','Hoofvel Grootte',0),(274727,7632,'ro','Dimensiune foaie pÄƒrinte',0),(274728,7632,'et','Vanem lehe suurus',0),(274729,7632,'si','Velikost lista starÅ¡ev',0),(274730,7632,'ba','Orangtua lembar ukuran',0),(274731,7632,'nl','Bovenliggende papierformaat',0),(274732,7632,'fi','Vanhemman arkkikoko',0),(274733,7632,'no','Overordnede arkstÃ¸rrelse',0),(274734,7632,'da','Overordnede arkstÃ¸rrelse',0),(274735,7632,'ko','ë¶€ëª¨ ì‹œíŠ¸ í¬ê¸°',0),(274736,7632,'he','×’×•×“×œ ×’×™×œ×™×•×Ÿ ××‘',0),(274737,7632,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Ï†ÏÎ»Î»Î¿Ï… Î³Î¿Î½Î­Î±',0),(274738,7632,'zh','çˆ¶å¯¹è±¡çº¸å¼ å°ºå¯¸\r\n',0),(274739,7632,'sv','Ã–verordnade arkstorlek',0),(274740,7632,'it','Padre formato foglio',0),(274741,7632,'tl','',0),(274742,7632,'th','&#3586;&#3609;&#3634;&#3604;&#3649;&#3612;&#3656;&#3609;&#3591;&#3634;&#3609;&#3627;&#3621;&#3633;&#3585;',0),(274743,7632,'hi','à¤ªà¥ˆà¤°à¥‡à¤‚à¤Ÿ à¤ªà¤¤à¥à¤°à¤• à¤†à¤•à¤¾à¤°',0),(274744,7632,'ms','Ibu bapa kira-kira saiz',0),(274745,7632,'ar','Ø­Ø¬Ù… Ø§Ù„ÙˆØ±Ù‚Ø© Ø§Ù„Ø£ØµÙ„',0),(274746,7632,'fr','Taille de la feuille parent',0),(274747,7632,'jp','è¦ªã‚·ãƒ¼ãƒˆ ã‚µã‚¤ã‚º',0),(274748,7632,'pt','Pai folha tamanho',0),(274749,7632,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð»Ð¸ÑÑ‚Ð° Ñ€Ð¾Ð´Ð¸Ñ‚ÐµÐ»Ñ',0),(274750,7632,'es','TamaÃ±o de Hoja Maestra',0),(274751,7632,'de','Ãœbergeordnete BlattgrÃ¶ÃŸe',0),(274752,7632,'en','Parent Sheet Size',0),(274753,7633,'is','',0),(274754,7633,'dr','(Ù†Ù‚Ø·Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ) Ø¨Ù‡ Ø¨ÛŒØ¬Ú© Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(274755,7633,'pr','ØªØºÙŠÙŠØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡(Ù†Ù‚Ø·Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ) Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ± Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(274756,7633,'tr','AP fatura fatura iÃ§in deftere nakil deÄŸiÅŸtirme',0),(274757,7633,'pl','Zmiana ustawy AP ksiÄ™gowania faktury',0),(274758,7633,'bg','AP Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¾Ð·Ð°ÐºÐ¾Ð½Ð° Ð·Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(274759,7633,'ur','AP Ø¨Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ù¾ÙˆØ³Ù¹Ù†Ú¯ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(274760,7633,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° ÐÐŸ Ð‘Ð¸Ð» ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(274761,7633,'vi','Thay Äá»•i Ná»£ Pháº£i Tráº£ Sang HÃ³a ÄÆ¡n',0),(274762,7633,'af','Verander RB Rekening Postering na Faktuur',0),(274763,7633,'ro','Schimbare AP Bill posta factura',0),(274764,7633,'et','Muuta AP arve arve sisestamine',0),(274765,7633,'si','Spremembe zakona AP knjiÅ¾enje raÄuna',0),(274766,7633,'ba','Perubahan AP Bill Posting untuk faktur',0),(274767,7633,'nl','AP Bill posten aan factuur wijzigen',0),(274768,7633,'fi','AP lasku kirjataan lasku',0),(274769,7633,'no','AP regningen til fakturaen',0),(274770,7633,'da','Ã†ndre AP Bill bogfÃ¸ring af faktura',0),(274771,7633,'ko','ì†¡ìž¥ ê²Œì‹œ AP ë²•ì•ˆ ë³€ê²½',0),(274772,7633,'he','×©×™× ×•×™ AP ×‘×™×œ ×¨×™×©×•× ×”×—×©×‘×•× ×™×ª',0),(274773,7633,'el','Î‘Î»Î»Î±Î³Î® AP Bill Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ· Ï€ÏÎ¿Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(274774,7633,'zh','æ›´æ”¹åº”æ”¶è´¦æ¬¾å¸å•ç²˜è´´åˆ°å‘ç¥¨\r\n',0),(274775,7633,'sv','Ã„ndra AP affischering till faktura',0),(274776,7633,'it','Cambiamento AP affissione a fattura',0),(274777,7633,'tl','',0),(274778,7633,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3592;&#3634;&#3585;&#3648;&#3592;&#3657;&#3634;&#3',0),(274779,7633,'hi','à¤à¤ªà¥€ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¤°à¤¨à¥‡ à¤ªà¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤— à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(274780,7633,'ms','Perubahan AP Rang undang-undang menghantar invois',0),(274781,7633,'ar','ØªØºÙŠÙŠØ± Ø¨ÙŠÙ„ AP ØªØ±Ø­ÙŠÙ„ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(274782,7633,'fr','Changement AP Bill poster sur votre facture',0),(274783,7633,'jp','è«‹æ±‚æ›¸ã‚’è»¢è¨˜ ap é€šä¿¡æ³•æ¡ˆã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(274784,7633,'pt','MudanÃ§a AP Bill postando a factura',0),(274785,7633,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ AP Ð‘Ð¸Ð»Ð» Ñ€Ð°Ð·Ð½Ð¾ÑÐºÐ¸ Ð² ÑÑ‡ÐµÑ‚',0),(274786,7633,'es','Cambiar CP Asiento de FacturaciÃ³n a la Factura',0),(274787,7633,'de','AP Rechnung zu Rechnung hinzuzufÃ¼gen',0),(274788,7633,'en','Change AP Bill Posting to Invoice',0),(274789,7634,'is','',0),(274790,7634,'dr','Ù‡ÙŠÚ† Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø§ÙŠ ÙØ±Ø§ØªØ± Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(274791,7634,'pr','Ù‡ÙŠÚ† Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø§ÙŠ ÙØ±Ø§ØªØ± Ø§Ø² ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(274792,7634,'tr','Herhangi bir hareket Ã¶tesinde bitiÅŸ tarihi',0),(274793,7634,'pl','Brak transakcji poza datÄ™ zakoÅ„czenia',0),(274794,7634,'bg','ÐÑÐ¼Ð° ÑÐ´ÐµÐ»ÐºÐ¸ Ð¸Ð·Ð²ÑŠÐ½ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(274795,7634,'ur','Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ® Ø³Û’ Ù…Ø§ÙˆØ±Ø§ Ú©ÙˆØ¦ÛŒ Ù„ÛŒÙ† Ø¯ÛŒÙ†',0),(274796,7634,'sr','ÐÐµÐ¼Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ð¸Ð·Ð²Ð°Ð½ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(274797,7634,'vi','KhÃ´ng cÃ³ giao dá»‹ch sau ngÃ y káº¿t thÃºc',0),(274798,7634,'af','Geen Transaksies Na End Datum',0),(274799,7634,'ro','Nici tranzacÅ£iilor dincolo de data de sfÃ¢rÅŸit',0),(274800,7634,'et','Kandeid kaugemale lÃµppkuupÃ¤ev',0),(274801,7634,'si','Nobenih transakcij presega konÄni datum',0),(274802,7634,'ba','Tidak ada transaksi luar tanggal akhir',0),(274803,7634,'nl','Geen transacties na einddatum',0),(274804,7634,'fi','Ei tapahtumia pÃ¤Ã¤ttymispÃ¤ivÃ¤n jÃ¤lkeen',0),(274805,7634,'no','Ingen transaksjoner utover sluttdatoen',0),(274806,7634,'da','Ingen transaktioner uden for slutdato',0),(274807,7634,'ko','ë ë‚ ì§œë¥¼ ë„˜ì–´ ì•„ë¬´ ê±°ëž˜',0),(274808,7634,'he','××™×Ÿ ×ª× ×•×¢×•×ª ×ž×¢×‘×¨ ×ª××¨×™×š ×¡×™×•×',0),(274809,7634,'el','Î£Ï…Î½Î±Î»Î»Î±Î³Î­Ï‚ Ï€Î­ÏÎ± Î±Ï€ÏŒ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(274810,7634,'zh','ç»“æŸæ—¥æœŸåŽæ²¡æœ‰äº¤æ˜“\r\n',0),(274811,7634,'sv','Inga transaktioner utÃ¶ver slutdatum',0),(274812,7634,'it','Nessuna transazione oltre la data di fine',0),(274813,7634,'tl','',0),(274814,7634,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3608;&#3640;&#3619;&#3585;&#3636;&#3592;&#3627;&#3621;&#3633;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3',0),(274815,7634,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¸à¥‡ à¤ªà¤°à¥‡ à¤•à¥‹à¤ˆ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨',0),(274816,7634,'ms','Urusniaga tidak melepasi tarikh akhir',0),(274817,7634,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¹Ù…Ù„ÙŠØ§Øª Ø¨Ø¹Ø¯ Ù‡Ø°Ø§ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(274818,7634,'fr','Aucune transaction au-delÃ  de la Date de fin',0),(274819,7634,'jp','çµ‚äº†æ—¥ã‚’è¶…ãˆã‚‹ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(274820,7634,'pt','Nenhuma transaÃ§Ã£o alÃ©m da data de tÃ©rmino',0),(274821,7634,'ru','Ð‘ÐµÐ· ÑÐ´ÐµÐ»Ð¾Ðº Ð¿Ð¾ÑÐ»Ðµ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð´Ð°Ñ‚Ñ‹',0),(274822,7634,'es','No Hay Transacciones MÃ¡s Alla que la Fecha de TerminaciÃ³n',0),(274823,7634,'de','Keine Transaktionen Ã¼ber End-Datum',0),(274824,7634,'en','No Transactions Beyond End Date',0),(274825,7635,'is','',0),(274826,7635,'dr','(Ù†Ù‚Ø·Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ) Ø¨Ù‡ ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(274827,7635,'pr','ØªØºÙŠÙŠØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡(Ù†Ù‚Ø·Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ) Ø¨Ù‡ ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(274828,7635,'tr','AR fatura deftere nakil iÃ§in Ã¶deme tarihi deÄŸiÅŸtirme',0),(274829,7635,'pl','Zmiana AR rozlepianie plakatÃ³w do data pÅ‚atnoÅ›ci',0),(274830,7635,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ AR ÑÐ¼ÐµÑ‚ÐºÐ° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð´Ð¾ Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(274831,7635,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ù¾ÙˆØ³Ù¹Ù†Ú¯ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(274832,7635,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° ÐÐ  Ð‘Ð¸Ð» ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ð½Ð° Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(274833,7635,'vi','Thay Äá»•i Ná»£ Pháº£i Thu Sang NgÃ y Thanh ToÃ¡n',0),(274834,7635,'af','Verander AR Wetsontwerp plaas tot datum van betaling',0),(274835,7635,'ro','Schimba Bill AR posta la data platii',0),(274836,7635,'et','Muuta AR arve maksmise kuupÃ¤eva sisestamine',0),(274837,7635,'si','Spremembe zakona AR knjiÅ¾enja na datum plaÄila',0),(274838,7635,'ba','Mengubah Posting untuk tanggal pembayaran tagihan AR',0),(274839,7635,'nl','AR Bill posten aan betalingsdatum wijzigen',0),(274840,7635,'fi','AR lasku kirjataan maksupÃ¤ivÃ¤',0),(274841,7635,'no','AR regningen til betalingsdatoen',0),(274842,7635,'da','Ã†ndre AR Bill udstationering til betalingsdatoen',0),(274843,7635,'ko','AR ì²­êµ¬ì„œ ì§€ë¶ˆ ë‚ ì§œì— ê²Œì‹œë¥¼ ë³€ê²½í•©ë‹ˆë‹¤',0),(274844,7635,'he','×‘×™×œ AR ×©×™× ×•×™ ×¨×™×©×•× ×ª××¨×™×š ×”×ª×©×œ×•×',0),(274845,7635,'el','Î‘Î»Î»Î±Î³Î® AR Bill ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÏƒÎµ Î—Î¼/Î½Î¯Î± ÎµÎ¾ÏŒÏ†Î»Î·ÏƒÎ·Ï‚',0),(274846,7635,'zh','æ›´æ”¹åº”æ”¶è´¦æ¬¾å¸å•ç²˜è´´åˆ°ä»˜è´¹æ—¥æœŸ',0),(274847,7635,'sv','Ã„ndra AR affischering till betalningsdatum',0),(274848,7635,'it','Affissione pubblica AR cambio alla data di pagamento',0),(274849,7635,'tl','',0),(274850,7635,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3',0),(274851,7635,'hi','à¤. à¤†à¤°. à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤— à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(274852,7635,'ms','Tukar AR bil menghantar ke tarikh pembayaran',0),(274853,7635,'ar','ØªØºÙŠÙŠØ± Ø¨ÙŠÙ„ Ø¹ Ù†Ø´Ø± Ø¨ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹',0),(274854,7635,'fr','Changements AR affichage de la Date de paiement',0),(274855,7635,'jp','AR è«‹æ±‚æ›¸æ”¯æ‰•æ—¥ä»˜ã«è»¢è¨˜ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(274856,7635,'pt','Mudar o AR Bill postando a data de pagamento',0),(274857,7635,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ AR Ð‘Ð¸Ð»Ð» Ð¿Ñ€Ð¾Ð²Ð¾Ð´ÐºÐ¸ Ð´Ð¾ Ð´Ð°Ñ‚Ñ‹ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹',0),(274858,7635,'es','Cambiar CP Asiento de FacturaciÃ³n a la Fecha de Pago',0),(274859,7635,'de','AR Rechnung zu Zahlungsdatum hinzuzufÃ¼gen',0),(274860,7635,'en','Change AR Bill Posting to Payment Date',0),(274861,7636,'is','',0),(274862,7636,'dr','Ú†Ø§Ù¾ Ø±ÙˆØ²Ù‡Ø§',0),(274863,7636,'pr','Ú†Ø§Ù¾ Ø±ÙˆØ²Ù‡Ø§',0),(274864,7636,'tr','GÃ¼n YazdÄ±r',0),(274865,7636,'pl','WydrukowaÄ‡ dni',0),(274866,7636,'bg','Ð”Ð½Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(274867,7636,'ur','Ø¯Ù† Ú©Ùˆ Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº',0),(274868,7636,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð´Ð°Ð½Ð°',0),(274869,7636,'vi','NgÃ y In',0),(274870,7636,'af','Druk Dae',0),(274871,7636,'ro','Zile de imprimare',0),(274872,7636,'et','Prindi pÃ¤eva',0),(274873,7636,'si','Tiskanje dni',0),(274874,7636,'ba','Cetak hari',0),(274875,7636,'nl','Afdrukken van dagen',0),(274876,7636,'fi','Tulostaa pÃ¤ivÃ¤Ã¤',0),(274877,7636,'no','Skrive ut dager',0),(274878,7636,'da','Udskrive dage',0),(274879,7636,'ko','ì¼ ì¸ì‡„',0),(274880,7636,'he','×”×“×¤×¡ ×™×ž×™×',0),(274881,7636,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î·Î¼Î­ÏÎµÏ‚',0),(274882,7636,'zh','æ‰“å°å¤©æ•°\r\n',0),(274883,7636,'sv','Skriva ut dagar',0),(274884,7636,'it','Stampa giorni',0),(274885,7636,'tl','',0),(274886,7636,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3623;&#3633;&#3609;',0),(274887,7636,'hi','à¤¦à¤¿à¤¨ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(274888,7636,'ms','Cetak hari',0),(274889,7636,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø£ÙŠØ§Ù…',0),(274890,7636,'fr','Imprimer les jours',0),(274891,7636,'jp','å°åˆ·æ—¥',0),(274892,7636,'pt','Imprimir dias',0),(274893,7636,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð”Ð½Ð¸',0),(274894,7636,'es','DÃ­as de Imprenta',0),(274895,7636,'de','Tage zu drucken',0),(274896,7636,'en','Print Days',0),(274897,7637,'is','',0),(274898,7637,'dr','Ø¯Ø±Ù‡Ø± Ø¬Ø¹Ø¨Ù‡ Ù¾Ø±',0),(274899,7637,'pr','Ø¯Ø±Ù‡Ø± Ø¬Ø¹Ø¨Ù‡ Ù¾Ø±',0),(274900,7637,'tr','Tam kutusu',0),(274901,7637,'pl','Na pole peÅ‚ne',0),(274902,7637,'bg','ÐŸÑŠÐ»ÐµÐ½ ÐºÑƒÑ‚Ð¸Ñ',0),(274903,7637,'ur','Ù…Ú©Ù…Ù„ Ø¨Ø§Ú©Ø³ ÙÛŒ',0),(274904,7637,'sr','ÐŸÐ¾ Ð¿ÑƒÐ½Ñƒ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ',0),(274905,7637,'vi','Má»—i há»™p Ä‘áº§y',0),(274906,7637,'af','Per Volle Boks',0),(274907,7637,'ro','Pe cutie complet',0),(274908,7637,'et','Terve kasti',0),(274909,7637,'si','Na polno Å¡katlo',0),(274910,7637,'ba','Per kotak penuh',0),(274911,7637,'nl','Per volledige doos',0),(274912,7637,'fi','Per koko laatikko',0),(274913,7637,'no','Per Full eske',0),(274914,7637,'da','Per fuld boks',0),(274915,7637,'ko','ì „ì²´ ìƒìž ë‹¹',0),(274916,7637,'he','×œ××¨×’×– ×ž×œ×',0),(274917,7637,'el','Î‘Î½Î¬ Ï€Î»Î®ÏÎ· ÎºÎ¿Ï…Ï„Î¯',0),(274918,7637,'zh','æ¯æ•´ç›’\r\n',0),(274919,7637,'sv','Per Full lÃ¥da',0),(274920,7637,'it','Per scatola completo',0),(274921,7637,'tl','',0),(274922,7637,'th','&#3605;&#3656;&#3629;&#3585;&#3621;&#3656;&#3629;&#3591;&#3648;&#3605;&#3655;&#3617;',0),(274923,7637,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¥‚à¤°à¥à¤£ à¤¬à¥‰à¤•à¥à¤¸',0),(274924,7637,'ms','Satu Peti yang penuh',0),(274925,7637,'ar','ÙƒÙ„ Ù…Ø±Ø¨Ø¹ ÙƒØ§Ù…Ù„',0),(274926,7637,'fr','Par boÃ®te pleine',0),(274927,7637,'jp','å®Œå…¨ãªãƒœãƒƒã‚¯ã‚¹ã‚ãŸã‚Š',0),(274928,7637,'pt','Pela caixa cheia',0),(274929,7637,'ru','Ð—Ð° Ð¿Ð¾Ð»Ð½Ñ‹Ð¹ ÑÑ‰Ð¸Ðº',0),(274930,7637,'es','Por Caja Llena',0),(274931,7637,'de','Voller Karton',0),(274932,7637,'en','Per Full Box',0),(274933,7638,'is','',0),(274934,7638,'dr','( 0= Ø§Ø³ØªÙØ§Ø¯Ù‡  Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ú¯Ø¯Ø§Ù… Ø§ØµÙ„ÙŠ ',0),(274935,7638,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ù‡Ø± Ø¬Ø¹Ø¨Ù‡ ( 0= Ø§Ø³ØªÙØ§Ø¯Ù‡  Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†Ø¨Ø§Ø± Ø§ØµÙ„ÙŠ ',0),(274936,7638,'tr','Kutu baÅŸÄ±na miktar (0 = kullanÄ±m ana stok miktar)',0),(274937,7638,'pl','IloÅ›Ä‡ w kartonie (0 = uÅ¼ytkowania gÅ‚Ã³wnego iloÅ›Ä‡ zapasÃ³w)',0),(274938,7638,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° ÐºÑƒÑ‚Ð¸Ñ (0 = ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð¾ÑÐ½Ð¾Ð²Ð½Ð¸Ñ‚Ðµ Ð±Ð¾Ñ€ÑÐ¾Ð²Ð¸ ÐºÐ¾Ð»-Ð²Ð¾)',0),(274939,7638,'ur','Ø®Ø§Ù†Û ÙÛŒ Ù‚ÛŒ (0 Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø§ÛÙ… Ø³Ù¹Ø§Ú© Ù‚ÛŒ =)',0),(274940,7638,'sr','ÐšÐ¾Ð» Ð¿Ð¾ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ (0 = ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð³Ð»Ð°Ð²Ð½Ð¸ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ ÐšÐ¾Ð».)',0),(274941,7638,'vi','Sá»‘ lÆ°á»£ng má»—i há»™p(0=Sá»­ dá»¥ng Sá»‘ lÆ°á»£ng hÃ nh chÃ­nh)',0),(274942,7638,'af','Hoev. per Boks (0=Gebruik Hoof Voorraad Hoev.)',0),(274943,7638,'ro','Cantitate pe cutie (0 = utilizare principal cantitate stoc)',0),(274944,7638,'et','Tk karbis (0 = kasutamise peamised varude kogus)',0),(274945,7638,'si','KoliÄina v kartonu (0 = uporaba glavni borzni koliÄina)',0),(274946,7638,'ba','Qty per kotak (0 = gunakan Qty saham utama)',0),(274947,7638,'nl','Aantal per doos (0 = gebruik belangrijkste voorraad aantal)',0),(274948,7638,'fi','MÃ¤Ã¤rÃ¤ per laatikko (0 = kÃ¤ytÃ¶n tÃ¤rkein varastossa mÃ¤Ã¤rÃ¤)',0),(274949,7638,'no','Antall per boks (0 = bruk viktigste lager antall)',0),(274950,7638,'da','Antal pr. kasse (0 = brug vigtigste Stock Qty)',0),(274951,7638,'ko','ìƒìž ë‹¹ Qty (0 = ì‚¬ìš© ì£¼ìš” ìž¬ê³  ìˆ˜ëŸ‰)',0),(274952,7638,'he','×›×ž×•×ª ×œ××¨×’×– (0 = ×›×ž×•×ª ×”×ž× ×™×•×ª ×”×¢×™×§×¨×™ ×œ×©×™×ž×•×©)',0),(274953,7638,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Î½Î¬ ÎºÎ¿Ï…Ï„Î¯ (0 = Ï‡ÏÎ®ÏƒÎ· ÎºÏÏÎ¹Î± Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Qty)',0),(274954,7638,'zh','æ¯ç›’æ•°é‡ï¼ˆ0 =ä½¿ç”¨çš„ä¸»è¦åº“å­˜æ•°é‡ï¼‰\r\n',0),(274955,7638,'sv','Antal per lÃ¥da (0 = AnvÃ¤nd huvudsakliga lager Kvt)',0),(274956,7638,'it','QtÃ  per confezione (0 = uso principale dipinga Qty)',0),(274957,7638,'tl','',0),(274958,7638,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3605;&#3656;&#3629;&#3585;&#3621;&#3656;&#3629;&#3591; (0=&#3651;&#3594;&#3657;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3605;&#3658;&#3629;&#3585;&#3627;&#3621;&#3633;&#3585;)',0),(274959,7638,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤¬à¥‰à¤•à¥à¤¸ (0 à¤‰à¤ªà¤¯à¥‹à¤— à¤®à¥à¤–à¥à¤¯ à¤¸à¥à¤Ÿà¥‰à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ =)',0),(274960,7638,'ms','Qty satu Peti (0 = Qty saham utama penggunaan)',0),(274961,7638,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© ÙƒÙ„ Ù…Ø±Ø¨Ø¹ (0 = Ø§Ø³ØªØ®Ø¯Ø§Ù… ÙƒÙ…ÙŠØ© Ø§Ù„Ø£Ø³Ù‡Ù… Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©)',0),(274962,7638,'fr','QuantitÃ© par boÃ®te (0 = utilisation principal Stock QtÃ©)',0),(274963,7638,'jp','ç®±ã‚ãŸã‚Šå€‹æ•° (0 = ä½¿ç”¨ã™ã‚‹ä¸»ãªåœ¨åº«æ•°é‡)',0),(274964,7638,'pt','Qtd. por caixa (0 = Qtde estoque principal de uso)',0),(274965,7638,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð² ÐºÐ¾Ñ€Ð¾Ð±ÐºÐµ (0 = Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¾ÑÐ½Ð¾Ð²Ð½Ñ‹Ñ… Ñ„Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ñ… Qty)',0),(274966,7638,'es','Cant. por Caja(0=Usa Cant. de Stock Principal)',0),(274967,7638,'de','Menge pro Karton (0 = Nutzung Haupt hat Qty)',0),(274968,7638,'en','Qty per Box(0=Use Main Stock Qty)',0),(274969,7639,'is','',0),(274970,7639,'dr','Ø§Ú¯Ø± Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§  ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ù†Ø¯ â€“ Ø§ÙˆÙ„ÙŠÙ† Ù…Ø­Ù„ Ùˆ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ¯Ø§ Ø´Ø¯Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(274971,7639,'pr','Ø§Ú¯Ø± Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§  ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ù†Ø¯ â€“ Ø§ÙˆÙ„ÙŠÙ† Ù…Ø­Ù„ Ùˆ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ¯Ø§ Ø´Ø¯Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(274972,7639,'tr','VarsayÄ±lanlarÄ± ayarlanmamÄ±ÅŸsa, ilk yer ve fiyat seviyesi bulunan gÃ¼ncellenecektir',0),(274973,7639,'pl','JeÅ›li ustawienia domyÅ›lne nie sÄ… ustawione, pierwsze miejsce i cena poziom znalezione zostanÄ… zaktualizowane',0),(274974,7639,'bg','ÐÐºÐ¾ Ð½Ðµ ÑÐ° Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¸ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ, Ñ‰Ðµ ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° Ð¿ÑŠÑ€Ð²Ð¾Ñ‚Ð¾ Ð¼ÑÑÑ‚Ð¾ Ð¸ Ñ†ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾',0),(274975,7639,'ur','Ø·Û’ Ø´Ø¯Û Ø³ÛŒÙ¹ Ù†ÛÛŒÚº ÛÛŒÚº ØªÙˆ Ù¾ÛÙ„ÛŒ Ø¬Ú¯Û Ø§ÙˆØ± Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ù¾Ø§ÛŒØ§ ØªØ§Ø²Û Ú©ÛŒ Ø¬Ø§Ø¦Û’ Ú¯ÛŒ',0),(274976,7639,'sr','ÐÐºÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð¸ÑÑƒ Ð¿Ð¾Ð´ÐµÑˆÐµÐ½Ðµ, Ð¿Ñ€Ð²Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð¸ Ñ†ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(274977,7639,'vi','Náº¿u khÃ´ng Ä‘áº·t máº·c Ä‘á»‹nh, vá»‹ trÃ­ & má»©c giÃ¡ Ä‘áº§u tiÃªn sáº½ Ä‘Æ°á»£c cáº­p nháº­t',0),(274978,7639,'af','As verstek is nie gestel nie, die eerste plek en prys vlak gevind sal bygewerk word',0),(274979,7639,'ro','DacÄƒ nu sunt setate valori implicite, prima locaÅ£ie ÅŸi preÅ£ nivel gÄƒsite vor fi actualizate',0),(274980,7639,'et','Kui vaikimisi on seatud, esimene asukoht ja hind vÃµimaldavale tasemele uuendatakse',0),(274981,7639,'si','ÄŒe ni nastavljena na privzeto, prvo mesto in ceno ravni posodobi',0),(274982,7639,'ba','Jika default tidak ditetapkan, lokasi pertama dan harga tingkat Temukan akan diperbarui',0),(274983,7639,'nl','Als standaardwaarden niet zijn ingesteld, zal de eerste locatie en prijs niveau gevonden worden bijgewerkt',0),(274984,7639,'fi','Jos oletukset ei mÃ¤Ã¤ritetÃ¤, ensimmÃ¤inen paikka ja hinta taso Found pÃ¤ivitetÃ¤Ã¤n',0),(274985,7639,'no','Hvis standard ikke angis, oppdateres den fÃ¸rste plasseringen og prisen nivÃ¥ fant',0),(274986,7639,'da','Hvis standardvÃ¦rdierne ikke er angivet, vil den fÃ¸rste placering og pris niveau fundet blive opdateret',0),(274987,7639,'ko','ê¸°ë³¸ê°’ ì„¤ì • ë˜ì§€ ì•Šì€ ê²½ìš° ì²« ë²ˆì§¸ ìœ„ì¹˜ì™€ ê°€ê²© ìˆ˜ì¤€ì˜ ë°œê²¬ ì—…ë°ì´ íŠ¸ ë©ë‹ˆë‹¤.',0),(274988,7639,'he','×× ×œ× × ×§×‘×¢×• ×‘×¨×™×¨×•×ª ×ž×—×“×œ, ×”×ž×™×§×•× ×”×¨××©×•×Ÿ ×•××ª ×”×ž×—×™×¨ ×‘×¨×ž×ª × ×ž×¦××• ×™×¢×•×“×›×Ÿ',0),(274989,7639,'el','Î•Î¬Î½ Î´ÎµÎ½ Î­Ï‡Î¿Ï…Î½ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚, Ï„Î·Î½ Ï€ÏÏŽÏ„Î· Î¸Î­ÏƒÎ· ÎºÎ±Î¹ Ï„Î·Î½ Ï„Î¹Î¼Î® ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î¸Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹',0),(274990,7639,'zh','å¦‚æžœæ²¡æœ‰è®¾ç½®é»˜è®¤å€¼ï¼Œç¬¬ä¸€ä½ç½®å’Œä»·æ ¼æ°´å¹³ä¼šè¢«æ›´æ–°\r\n',0),(274991,7639,'sv','Om standardinstÃ¤llningarna inte Ã¤r, kommer det fÃ¶rsta lÃ¤get och priset nivÃ¥ hittade att uppdateras',0),(274992,7639,'it','Se le impostazioni predefinite non sono impostate, la prima posizione e prezzo livello trovato verrÃ  aggiornati',0),(274993,7639,'tl','',0),(274994,7639,'th','If Defaults Are Not Set, the First Location and Price Level Found Will Be Updated',0),(274995,7639,'hi','à¤ªà¤¹à¤²à¤¾ à¤¸à¥à¤¥à¤¾à¤¨ à¤”à¤° à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤ªà¤¾à¤¯à¤¾ à¤¯à¤¦à¤¿ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚, à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾',0),(274996,7639,'ms','Jika lalai tidak disetkan, yang pertama dan peringkat ditemui akan dikemaskini',0),(274997,7639,'ar','Ø¥Ø°Ø§ Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©ØŒ Ø³ÙŠØªÙ… ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø£ÙˆÙ„ ÙˆØ§Ù„Ø§Ø·Ù„Ø§Ø¹ Ø¹Ù„Ù‰ Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(274998,7639,'fr','Si les valeurs par dÃ©faut ne sont pas dÃ©finies, le premier emplacement et prix niveau trouvÃ© seront actualisÃ©s',0),(274999,7639,'jp','æœ€åˆã®å ´æ‰€ã¨ãƒ¬ãƒ™ãƒ«ã‚’è¦‹ã¤ã‘ãŸä¾¡æ ¼ãŒæ›´æ–°ã•ã‚Œã¾ã™ã®æ—¢å®šå€¤ãŒè¨­å®šã•ã‚Œã¦ã„ãªã„å ´åˆ',0),(275000,7639,'pt','Se os padrÃµes nÃ£o sÃ£o definidos, o primeiro local e preÃ§o nÃ­vel encontrado serÃ£o atualizados',0),(275001,7639,'ru','Ð•ÑÐ»Ð¸ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð½Ðµ Ð·Ð°Ð´Ð°Ð½Ð¾, Ð±ÑƒÐ´ÑƒÑ‚ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹ Ð¿ÐµÑ€Ð²Ð¾Ðµ Ð¼ÐµÑÑ‚Ð¾ Ð¸ Ñ†ÐµÐ½Ð° ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð½Ð°ÑˆÐ»Ð¸',0),(275002,7639,'es','Si Selecciones AutomÃ¡ticos No Estan Configurados, La Primera UbicaciÃ³n y Nivel de Precios que se Encuentran SerÃ¡n Actualizados ',0),(275003,7639,'de','Wenn die Standardwerte nicht festgelegt sind, werden die erste Lage und Preis Ebene gefunden aktualisiert',0),(275004,7639,'en','If Defaults Are Not Set, the First Location and Price Level Found Will Be Updated',0),(275005,7640,'is','',0),(275006,7640,'dr','- Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù„ÛŒØ¬Ø± Ù‚Ø¨Ù„ Ø§Ø² Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†',0),(275007,7640,'pr','ØªÙ†Ø¸ÙŠÙ… Ù…Ø­Ù„ Ù¾ÙŠØ´ ÙØ±Ø¶ Ùˆ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¯Ø± ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§- Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ù‚Ø¨Ù„ Ø§Ø² Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ',0),(275008,7640,'tr','GÃ¼ncelleÅŸtirmeden Ã¶nce standart GL hesaplarÄ±-> stok kurulumunda varsayÄ±lan konumu ve varsayÄ±lan fiyat dÃ¼zeyini ayarla',0),(275009,7640,'pl','Ustaw domyÅ›lnÄ… lokalizacjÄ™ i domyÅ›lny poziom cen zapasami-> GL standardowych kont przed aktualizacjÄ…',0),(275010,7640,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¸ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð¾ Ñ€Ð°Ð²Ð½Ð¸Ñ‰Ðµ Ð² Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÑÐºÐ»Ð°Ð´-> ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ GL ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¿Ñ€ÐµÐ´Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð',0),(275011,7640,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø³Û’ Ù‚Ø¨Ù„ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³-> Ù…ÛŒÚº Ø·Û’ Ø´Ø¯Û Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø§ÙˆØ± Ø·Û’ Ø´Ø¯Û Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(275012,7640,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð° Ñƒ Ð¿Ñ€Ð¾Ð·Ð¾Ñ€Ñƒ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð“Ð› ÐºÐ¾Ð½Ñ‚Ð° Ð¿Ñ€Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(275013,7640,'vi','Táº¡o Äá»‹a Äiá»ƒm & Má»©c GiÃ¡ Máº·c Äá»‹nh cho HÃ ng Trong Kho Setup->TrÆ°á»›c Khi Cáº­p Nháº­t TK Sá»• CÃ¡i Tá»•ng Há»£p Chuáº©n',0),(275014,7640,'af','Stel verstek ligging en prys Verstekvlak in voorraad opstelling-> standaard GL rekeninge voor werk',0),(275015,7640,'ro','SetaÅ£i nivelul de pret implicit ÅŸi de locaÅ£ie Ã®n Parametrizare stocuri-> conturi Standard GL Ã®nainte de actualizarea',0),(275016,7640,'et','Vaikeasukohta ja vaike hinnatase sÃ¤testatud varude seadistamine-> Standard GL kontod enne vÃ¤rskendamist',0),(275017,7640,'si','Nastavite privzeto lokacijo in privzeto raven cen v nastavitev zaloge-> Standard GL raÄunov pred posodabljanjem',0),(275018,7640,'ba','Atur lokasi Default dan tingkat harga Default dalam persediaan Setup-> GL standar account sebelum memperbarui',0),(275019,7640,'nl','Instellen van de standaardlocatie en standaard prijsniveau in Voorraadinstellingen-> standaard GL Accounts voordat u bijwerkt',0),(275020,7640,'fi','Asettaa oletusarvon mukaiseen kohtaan ja oletusarvon hintataso Varastonhallinnan-> Standard GL tilit ennen pÃ¤ivittÃ¤mistÃ¤',0),(275021,7640,'no','Angi standardplassering og standard prisnivÃ¥et i Lageroppsett-> Standard GL kontoer fÃ¸r oppdatering',0),(275022,7640,'da','Angive standardplaceringen og standard prisniveau i LageropsÃ¦tning-> Standard GL konti fÃ¸r opdatering',0),(275023,7640,'ko','ì—…ë°ì´íŠ¸ í•˜ê¸° ì „ì— í‘œì¤€ GL ê³„ì •-> ìž¬ê³  ì„¤ì •ì—ì„œ ê¸°ë³¸ ìœ„ì¹˜ì™€ ê¸°ë³¸ ê°€ê²© ìˆ˜ì¤€ ì„¤ì •',0),(275024,7640,'he','×”×’×“×¨ ×ž×™×§×•× ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×•××ª ×¨×ž×ª ×ž×—×™×¨ ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ ×‘×”×’×“×¨×ª ×ž×œ××™-> ×—×©×‘×•× ×•×ª ×¡×˜× ×“×¨×˜×™ GL ×œ×¤× ×™ ×¢×“×›×•×Ÿ',0),(275025,7640,'el','ÎŸÏÎ¯ÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± ÎºÎ±Î¹ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½ ÏƒÏ„Î·Î½ Ï€Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½-> Ï€ÏÏŒÏ„Ï…Ï€Î¿ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ ',0),(275026,7640,'zh','è®¾ç½®é»˜è®¤ä½ç½®å’Œåœ¨åº“å­˜è®¾ç½®ä¸­çš„ä»·æ ¼æ°´å¹³->â€œæ›´æ–°å‰çš„æ ‡å‡†æ€»å¸å¸æˆ·\r\n',0),(275027,7640,'sv','Ange lÃ¤ge och standard prisnivÃ¥n i LagerinstÃ¤llningar-> Standard GL konton fÃ¶re uppdatering',0),(275028,7640,'it','Impostare la posizione predefinita e il livello di prezzo predefinito in Setup magazzino-> conti GL Standard prima di aggiornare',0),(275029,7640,'tl','',0),(275030,7640,'th','Set Default Location and Default Price Level in Inventory Setup->Standard GL Accounts Before Updating',0),(275031,7640,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤®à¤¾à¤¨à¤• GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡-> à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤®à¥‡à¤‚ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¥‚à¤²à¥',0),(275032,7640,'ms','Menetapkan lokasi lalai dan paras harga lalai dalam inventori persediaan-> Standard GL akaun sebelum mengemas kini',0),(275033,7640,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ ÙˆÙ…Ø³ØªÙˆÙ‰ Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ ÙÙŠ Ø¥Ø¹Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø¬Ø±Ø¯-> Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª GL Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ù‚Ø¨Ù„ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(275034,7640,'fr','Emplacement de la configuration par dÃ©faut et le niveau de prix par dÃ©faut dans la configuration stock-> comptes GL Standard avant la mise Ã  jour',0),(275035,7640,'jp','-> æ¨™æº–ã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®æ›´æ–°å‰ã«åœ¨åº«ã®è¨­å®šã«æ—¢å®šã®å ´æ‰€ã¨æ—¢å®šã®ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(275036,7640,'pt','Definir local padrÃ£o e o nÃ­vel de preÃ§os padrÃ£o na configuraÃ§Ã£o do inventÃ¡rio-> contas padrÃ£o GL antes de atualizar',0),(275037,7640,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¸ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ñ†ÐµÐ½ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð² Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°Ñ… Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ-> ÑÑ‡ÐµÑ‚Ð¾Ð² ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ GL Ð¿ÐµÑ€ÐµÐ´ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸ÐµÐ¼',0),(275038,7640,'es','Configurar UbicaciÃ³n por Defecto y Nivel de Precios por Defecto en la ConfiguraciÃ³n de Inventario->Cuentas de LM EstÃ¡ndar Antes que Actualizar',0),(275039,7640,'de','Standardspeicherort und Standard-Preisniveau in Lagereinrichtung-> Standard GL Konten vor der Aktualisierung festgelegt',0),(275040,7640,'en','Set Default Location and Default Price Level in Inventory Setup->Standard GL Accounts Before Updating',0),(275041,7641,'is','',0),(275042,7641,'dr','(Ù†Ù‚Ø·Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ) Ø¨Ù‡ ØªØ§Ø±ÙŠØ® Ø¨ÛŒØ¬Ú© ',0),(275043,7641,'pr','ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ®  Ú†Ùƒ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡(Ù†Ù‚Ø·Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ) Ø¨Ù‡ ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± ',0),(275044,7641,'tr','AP onay tarihi fatura tarihini deÄŸiÅŸtirme',0),(275045,7641,'pl','ZmieniÄ‡ AP Data faktury Data',0),(275046,7641,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° AP Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° ÐºÑŠÐ¼ Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(275047,7641,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Û’ Ù„Ø¦Û’ AP Ú†ÛŒÚ© Ú©ÛŒ ØªØ§Ø±ÛŒØ® ØªØ¨Ø¯ÛŒÙ„',0),(275048,7641,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ð° ÐÐŸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµÑ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(275049,7641,'vi','Thay Ä‘á»•i ngÃ y sÃ©c pháº£i trÃ  thÃ nh ngÃ y hÃ³a Ä‘Æ¡n',0),(275050,7641,'af','Verander RB Tjekdatum na Faktuurdatum',0),(275051,7641,'ro','Schimba data de AP Check pentru a factura data',0),(275052,7641,'et','Muuda AP kontrolli kuupÃ¤ev arve kuupÃ¤ev',0),(275053,7641,'si','AP potrdite datum za fakturiranje datum spremembe',0),(275054,7641,'ba','Mengubah tanggal AP Check untuk faktur tanggal',0),(275055,7641,'nl','AP selectievakje datum te factureren datum wijzigen',0),(275056,7641,'fi','Vaihda AP pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(275057,7641,'no','Endre AP kontrolldatoen til fakturadato',0),(275058,7641,'da','Ã†ndre AP checkens dato fakturere dato',0),(275059,7641,'ko','ì†¡ìž¥ ë‚ ì§œì— AP ê²€ì‚¬ ë‚ ì§œ ë³€ê²½',0),(275060,7641,'he','×œ×©× ×•×ª AP ×”×¡×™×ž×•×Ÿ ×ª××¨×™×š ×œ×—×©×‘×•× ×™×ª ×ª××¨×™×š',0),(275061,7641,'el','Î‘Î»Î»Î±Î³Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚ AP ÎµÎ»Î­Î³Ï‡Î¿Ï… Î½Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(275062,7641,'zh','æ›´æ”¹åº”æ”¶è´¦æ¬¾å¸å•åˆ°å‘ç¥¨æ—¥æœŸ\r\n',0),(275063,7641,'sv','Ã„ndra AP kolla datum faktura datum',0),(275064,7641,'it','Modificare la data di Check AP fatturare data',0),(275065,7641,'tl','',0),(275066,7641,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3609;&#3648;&#3594;&#3655;&#3588;&#3586;&#3629;&#3591;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3652;&#3611;&#3618;&#3633;&#3591;&#3623;&#3',0),(275067,7641,'hi','à¤à¤ªà¥€ à¤šà¥‡à¤• à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(275068,7641,'ms','Tukar tarikh Daftar AP untuk invois tarikh',0),(275069,7641,'ar','ØªØºÙŠÙŠØ± ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± AP ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(275070,7641,'fr','Changer la Date de vÃ©rification de l\'AP Ã  la Date de la facture',0),(275071,7641,'jp','AP ãƒã‚§ãƒƒã‚¯æ—¥ã¨è«‹æ±‚æ›¸ã®æ—¥ä»˜ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(275072,7641,'pt','Alterar Data de verificaÃ§Ã£o AP facturar data',0),(275073,7641,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð´Ð°Ñ‚Ñƒ AP Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð° Ð”Ð°Ñ‚Ð°',0),(275074,7641,'es','Cambiar CP Fecha de Cheque a la Fecha de la Factura',0),(275075,7641,'de','AP Check Ã„nderungsdatum, Datum in Rechnung zu stellen',0),(275076,7641,'en','Change AP Check Date to Invoice Date',0),(275077,7642,'is','',0),(275078,7642,'dr','Ø¨Ø±Ø±Ø³ÙŠ ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯  Ø¨Ø¹Ø¯Ø§Ø²  Ù…Ø¹ÙƒÙˆØ³ ÙƒØ±Ø¯Ù†',0),(275079,7642,'pr','Ø¨Ø±Ø±Ø³ÙŠ ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯  Ø¨Ø¹Ø¯Ø§Ø²  Ù…Ø¹ÙƒÙˆØ³ ÙƒØ±Ø¯Ù†',0),(275080,7642,'tr','Son kontrol dÃ¶nÃ¼ÅŸtÃ¼rme sonra tarihi',0),(275081,7642,'pl','SprawdÅº Due Data po konwersji',0),(275082,7642,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð°Ð´ÐµÐ¶ Ð´Ð°Ñ‚Ð° ÑÐ»ÐµÐ´ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(275083,7642,'ur','Ú†ÛŒÚ© Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ® ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ø¹Ø¯',0),(275084,7642,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð°ÐºÐ¾Ð½ ÐºÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ',0),(275085,7642,'vi','Kiá»ƒm tra ngÃ y Ä‘Ã¡o háº¡n sau khi chuyá»ƒn Ä‘á»•i',0),(275086,7642,'af','Tjek Verskuldigde Datum Na Afloop van Oorskakeling',0),(275087,7642,'ro','Verifica respectarea data dupÄƒ convertirea',0),(275088,7642,'et','Kontrollige nÃµuetekohaselt kuupÃ¤ev pÃ¤rast konverteeriva',0),(275089,7642,'si','Preverite ustrezno datum po pretvorbi',0),(275090,7642,'ba','Periksa karena tanggal setelah konversi',0),(275091,7642,'nl','Controleer Due datum na converteren',0),(275092,7642,'fi','Tarkista asianmukaisesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ muuntamisen jÃ¤lkeen',0),(275093,7642,'no','Sjekk grunn dato etter konvertering',0),(275094,7642,'da','Kontrollere Due dato efter konvertering',0),(275095,7642,'ko','ì¸í•´ í™•ì¸ ë‚ ì§œ ë³€í™˜ í›„',0),(275096,7642,'he','×‘×“×•×§ ×™×¢×“ ×ª××¨×™×š ×œ××—×¨ ×”×”×ž×¨×”',0),(275097,7642,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î· Î´Î­Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¼ÎµÏ„Î¬ Ï„Î· Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î®',0),(275098,7642,'zh','è½¬æ¢åŽæ£€æŸ¥åˆ°æœŸæ—¥\r\n',0),(275099,7642,'sv','Kontrollera fÃ¶rfallodatum datum efter konvertering',0),(275100,7642,'it','Verifica scadenza data dopo la conversione',0),(275101,7642,'tl','',0),(275102,7642,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(275103,7642,'hi','à¤•à¤¾à¤°à¤£ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤®à¥‡à¤‚ à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦',0),(275104,7642,'ms','Periksa habis tempoh tarikh selepas menukarkan',0),(275105,7642,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ù…Ø±Ø§Ø¹Ø§Ø© ØªØ§Ø±ÙŠØ® Ø¨Ø¹Ø¯ ØªØ­ÙˆÙŠÙ„',0),(275106,7642,'fr','VÃ©rifiez Due Date aprÃ¨s la conversion',0),(275107,7642,'jp','æœŸæ—¥ã‚’ç¢ºèªã®å¤‰æ›å¾Œã®æ—¥ä»˜',0),(275108,7642,'pt','Verificar a devida data apÃ³s a conversÃ£o',0),(275109,7642,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð°Ð´Ð»ÐµÐ¶Ð°Ñ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹ Ð¿Ð¾ÑÐ»Ðµ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(275110,7642,'es','Comprobar Fecha de Vencimiento DespuÃ©s de Convertir',0),(275111,7642,'de','ÃœberprÃ¼fen Sie Due Date nach der Konvertierung',0),(275112,7642,'en','Check Due Date After Converting',0),(275113,7643,'is','',0),(275114,7643,'dr','Ú†Ø§Ù¾ ØªÙˆØ³Ø·',0),(275115,7643,'pr','Ú†Ø§Ù¾ ØªÙˆØ³Ø·',0),(275116,7643,'tr','BazÄ±nda YazdÄ±r',0),(275117,7643,'pl','Drukowanie przez',0),(275118,7643,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¾Ñ‚',0),(275119,7643,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº',0),(275120,7643,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ð¾Ð¼Ð¾Ñ›Ñƒ',0),(275121,7643,'vi','In bá»Ÿi',0),(275122,7643,'af','Gedruk deur',0),(275123,7643,'ro','Se imprimÄƒ',0),(275124,7643,'et','Prindi jÃ¤rgi',0),(275125,7643,'si','Tiskanje z',0),(275126,7643,'ba','Mencetak dengan',0),(275127,7643,'nl','Afdrukken door',0),(275128,7643,'fi','Tulosta',0),(275129,7643,'no','Skrive ut ved',0),(275130,7643,'da','Udskrive ved',0),(275131,7643,'ko','ì—¬ ì¸ì‡„',0),(275132,7643,'he','×œ×”×“×¤×™×¡ ×¢×œ-×™×“×™',0),(275133,7643,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î±Ï€ÏŒ',0),(275134,7643,'zh','æ‰“å°æ–¹å¼\r\n',0),(275135,7643,'sv','Skriva ut genom att',0),(275136,7643,'it','Stampare da',0),(275137,7643,'tl','',0),(275138,7643,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3650;&#3604;&#3618;',0),(275139,7643,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(275140,7643,'ms','Dicetak oleh',0),(275141,7643,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¨ÙˆØ§Ø³Ø·Ø©',0),(275142,7643,'fr','Imprimer en',0),(275143,7643,'jp','ã«ã‚ˆã‚‹ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(275144,7643,'pt','Imprimir por',0),(275145,7643,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ',0),(275146,7643,'es','Imprimir Por',0),(275147,7643,'de','Drucken, indem',0),(275148,7643,'en','Print By',0),(275149,7644,'is','',0),(275150,7644,'dr','/ Ø³Ø§Ù„ ',0),(275151,7644,'pr','Ù…Ù‚Ø§ÙŠØ³Ù‡  Ù…Ø§Ù‡ / Ø³Ø§Ù„ ',0),(275152,7644,'tr','KarÅŸÄ±laÅŸtÄ±rma yÄ±l/ay',0),(275153,7644,'pl','PorÃ³wnanie rok/miesiÄ…c',0),(275154,7644,'bg','Ð¡Ñ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ Ð³Ð¾Ð´Ð¸Ð½Ð°/Ð¼ÐµÑÐµÑ†',0),(275155,7644,'ur','Ù…ÙˆØ§Ø²Ù†Û Ø³Ø§Ù„/Ù…ÛÛŒÙ†Û',0),(275156,7644,'sr','ÐŸÐ¾Ñ€ÐµÑ’ÐµÑšÐµ Ð³Ð¾Ð´Ð¸Ð½Ðµ/Ð¼ÐµÑÐµÑ†',0),(275157,7644,'vi','NÄƒm/thÃ¡ng So sÃ¡nh ',0),(275158,7644,'af','Vergelyking jaar/maand',0),(275159,7644,'ro','ComparaÈ›ie anul/luna',0),(275160,7644,'et','VÃµrreldes aasta/kuu',0),(275161,7644,'si','Primerjava leto/mesec',0),(275162,7644,'ba','Perbandingan tahun/bulan',0),(275163,7644,'nl','Vergelijking jaar/maand',0),(275164,7644,'fi','Vertailu vuoden/kk',0),(275165,7644,'no','Sammenligning Ã¥r/mÃ¥ned',0),(275166,7644,'da','Sammenligning Ã¥r/mÃ¥ned',0),(275167,7644,'ko','ë¹„êµ 1 ë…„/ì›”',0),(275168,7644,'he','×”×©×•×•××” ×©× ×”/×—×•×“×©',0),(275169,7644,'el','Î£ÏÎ³ÎºÏÎ¹ÏƒÎ· Î­Ï„Î¿Ï…Ï‚/Î¼Î®Î½Î±',0),(275170,7644,'zh','æ¯”è¾ƒå¹´ä»½/æœˆ\r\n',0),(275171,7644,'sv','JÃ¤mfÃ¶relse Ã¥r/mÃ¥nad',0),(275172,7644,'it','Confronto anno/mese',0),(275173,7644,'tl','',0),(275174,7644,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3619;&#3637;&#3618;&#3610;&#3648;&#3607;&#3637;&#3618;&#3610; &#3611;&#3637;/&#3648;&#3604;&#3639;&#3629;&#3609;',0),(275175,7644,'hi','à¤¤à¥à¤²à¤¨à¤¾ à¤µà¤°à¥à¤·/à¤®à¤¾à¤¹',0),(275176,7644,'ms','Perbandingan tahun/bulan',0),(275177,7644,'ar','Ù…Ù‚Ø§Ø±Ù†Ø© Ø¨ÙŠÙ† Ø§Ù„Ø³Ù†Ø©/Ø§Ù„Ø´Ù‡Ø±',0),(275178,7644,'fr','Comparaison annÃ©e/mois',0),(275179,7644,'jp','2010 å¹´ 3 æœˆã®æ¯”è¼ƒ',0),(275180,7644,'pt','ComparaÃ§Ã£o ano/mÃªs',0),(275181,7644,'ru','Ð¡Ñ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ Ð³Ð¾Ð´/Ð¼ÐµÑÑÑ†',0),(275182,7644,'es','ComparaciÃ³n AÃ±o/Mes',0),(275183,7644,'de','Vergleich Jahr/Monat',0),(275184,7644,'en','Comparison Year/Month',0),(275185,7645,'is','',0),(275186,7645,'dr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(275187,7645,'pr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(275188,7645,'tr','BilanÃ§o - standart',0),(275189,7645,'pl','Bilans - Standard',0),(275190,7645,'bg','Ð‘Ð°Ð»Ð°Ð½Ñ - ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚',0),(275191,7645,'ur','Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ - Ù…Ø¹ÛŒØ§Ø±',0),(275192,7645,'sr','Ð‘Ð¸Ð»Ð°Ð½Ñ ÑÑ‚Ð°ÑšÐ° - Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´',0),(275193,7645,'vi','Báº£ng cÃ¢n Ä‘á»‘i chuáº©n',0),(275194,7645,'af','Standaard Balansstaat',0),(275195,7645,'ro','BilanÅ£ul - Standard',0),(275196,7645,'et','Bilanss - Standard',0),(275197,7645,'si','Bilanca stanja - Standard',0),(275198,7645,'ba','Neraca - standar',0),(275199,7645,'nl','Balans - standaard',0),(275200,7645,'fi','Tase - standardi',0),(275201,7645,'no','Balanse - Standard',0),(275202,7645,'da','Balancen - Standard',0),(275203,7645,'ko','ëŒ€ì°¨ ëŒ€ì¡°í‘œ-í‘œì¤€',0),(275204,7645,'he','×”×ž××–×Ÿ - ×ª×§×Ÿ',0),(275205,7645,'el','Î™ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ - Ï€ÏÏŒÏ„Ï…Ï€Î¿',0),(275206,7645,'zh','æ ‡å‡†èµ„äº§è´Ÿå€ºè¡¨\r\n',0),(275207,7645,'sv','BalansrÃ¤kning - Standard',0),(275208,7645,'it','Stato patrimoniale - Standard',0),(275209,7645,'tl','',0),(275210,7645,'th','&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(275211,7645,'hi','à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ - à¤®à¤¾à¤¨à¤•',0),(275212,7645,'ms','Lembaran imbangan - Standard',0),(275213,7645,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¹Ù…ÙˆÙ…ÙŠØ© Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(275214,7645,'fr','Bilan - Standard',0),(275215,7645,'jp','è²¸å€Ÿå¯¾ç…§è¡¨ - æ¨™æº–',0),(275216,7645,'pt','BalanÃ§o - padrÃ£o',0),(275217,7645,'ru','Ð‘Ð°Ð»Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚ - ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚',0),(275218,7645,'es','Balance General',0),(275219,7645,'de','Bilanz - Standard',0),(275220,7645,'en','Balance Sheet - Standard',0),(275221,7646,'is','',0),(275222,7646,'dr','Ø´Ù†Ø§Ø³Ù‡ Ú¯Ø±ÙˆÙ‡',0),(275223,7646,'pr','Ø´Ù†Ø§Ø³Ù‡ Ú¯Ø±ÙˆÙ‡',0),(275224,7646,'tr','Kategori KimliÄŸi',0),(275225,7646,'pl','ID kategorii',0),(275226,7646,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ID',0),(275227,7646,'ur','Ø²Ù…Ø±Û Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(275228,7646,'sr','Ð˜Ð” ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(275229,7646,'vi','Thá»ƒ loáº¡i ID',0),(275230,7646,'af','Kategorie ID',0),(275231,7646,'ro','ID categorie',0),(275232,7646,'et','Kategooria ID',0),(275233,7646,'si','ID zvrsti',0),(275234,7646,'ba','ID Kategori',0),(275235,7646,'nl','Categorie-ID',0),(275236,7646,'fi','Luokkatunnus',0),(275237,7646,'no','Kategori-ID',0),(275238,7646,'da','Kategori-ID',0),(275239,7646,'ko','ë²”ì£¼ ID',0),(275240,7646,'he','Category ID',0),(275241,7646,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ID',0),(275242,7646,'zh','ç±»åˆ«èº«ä»½\r\n',0),(275243,7646,'sv','Kategori-ID',0),(275244,7646,'it','Categoria ID',0),(275245,7646,'tl','',0),(275246,7646,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(275247,7646,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤†à¤ˆà¤¡à¥€',0),(275248,7646,'ms','Kategori ID',0),(275249,7646,'ar','Ù…Ø¹Ø±Ù‘Ù Ø§Ù„ØªØµÙ†ÙŠÙ',0),(275250,7646,'fr','ID de catÃ©gorie',0),(275251,7646,'jp','ã‚«ãƒ†ã‚´ãƒª ID',0),(275252,7646,'pt','ID da categoria',0),(275253,7646,'ru','ID ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(275254,7646,'es','CategorÃ­a ID',0),(275255,7646,'de','Kategorie-ID',0),(275256,7646,'en','Category ID',0),(275257,7647,'is','',0),(275258,7647,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(275259,7647,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(275260,7647,'tr','Ã–ÄŸe kategorilerini iÃ§e aktarmak',0),(275261,7647,'pl','Kategorie importu towarÃ³w',0),(275262,7647,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(275263,7647,'ur','Ø´Û’ Ø²Ù…Ø±Û Ø¬Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(275264,7647,'sr','Ð£Ð²Ð¾Ð· ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(275265,7647,'vi','Nháº­p thá»ƒ loáº¡i hÃ ng',0),(275266,7647,'af','Invoer van Item KategoriÃ«',0),(275267,7647,'ro','Categorii de element de import',0),(275268,7647,'et','Impordi tootekategooriad',0),(275269,7647,'si','Uvoz kategorije artiklov',0),(275270,7647,'ba','Impor Kategori Item',0),(275271,7647,'nl','ArtikelcategorieÃ«n importeren',0),(275272,7647,'fi','Tuo kohteen Luokat',0),(275273,7647,'no','Importere kategorier',0),(275274,7647,'da','Importere varekategorier',0),(275275,7647,'ko','ê°€ì ¸ì˜¤ê¸° í•­ëª© ë²”ì£¼',0),(275276,7647,'he','×œ×™×™×‘× ×¤×¨×™×˜ ×œ×§×˜×’×•×¨×™×•×ª',0),(275277,7647,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ ÎµÎ¹Î´ÏŽÎ½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(275278,7647,'zh','è¿›å£è´§ç‰©åˆ†ç±»\r\n',0),(275279,7647,'sv','Importera artikelkategorier',0),(275280,7647,'it','Importazione articolo categorie',0),(275281,7647,'tl','',0),(275282,7647,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(275283,7647,'hi','à¤†à¤¯à¤¾à¤¤ à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(275284,7647,'ms','Kategori barangan import',0),(275285,7647,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(275286,7647,'fr','Importer des catÃ©gories d\'articles',0),(275287,7647,'jp','é …ç›®ã®ã‚«ãƒ†ã‚´ãƒªã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(275288,7647,'pt','Categorias de Item de importaÃ§Ã£o',0),(275289,7647,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(275290,7647,'es','Importar CategorÃ­as de Item',0),(275291,7647,'de','Import Positionstypen',0),(275292,7647,'en','Import Item Categories',0),(275293,7648,'is','',0),(275294,7648,'dr','Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ ',0),(275295,7648,'pr','Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ Ø³ØªÙˆÙ† ÙØ§ÙŠÙ„ Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ù„Ø§ ',0),(275296,7648,'tr','Madde Kategori dosyasÄ± sÃ¼tun biÃ§imi',0),(275297,7648,'pl','Element Kategoria formatu kolumny',0),(275298,7648,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(275299,7648,'ur','Ø´Û’ Ø²Ù…Ø±Û Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„',0),(275300,7648,'sr','ÐšÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(275301,7648,'vi','Thá»ƒ loáº¡i hÃ ng dáº¡ng cá»™t',0),(275302,7648,'af','Item Kategorie LÃªer Kolom Formaat',0),(275303,7648,'ro','Element categoria dosar Format coloane',0),(275304,7648,'et','Ãœksuse kategooria faili veeruvormingut',0),(275305,7648,'si','Element Kategorija zapisa stolpec',0),(275306,7648,'ba','Format kolom item kategori File',0),(275307,7648,'nl','Categorie bestand kolom verkoopvorm',0),(275308,7648,'fi','Kohteen luokka tiedostomuoto sarake',0),(275309,7648,'no','Elementet kategori-kolonnen filformat',0),(275310,7648,'da','Vare kategori filformat kolonne',0),(275311,7648,'ko','í•­ëª© ë²”ì£¼ íŒŒì¼ ì—´ í˜•ì‹',0),(275312,7648,'he','×¤×¨×™×˜ ×§×˜×’×•×¨×™×” ×‘×ª×‘× ×™×ª ×¢×ž×•×“×”',0),(275313,7648,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î±ÏÏ‡ÎµÎ¯Î¿ Î¼Î¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½',0),(275314,7648,'zh','é¡¹ç›®ç±»åˆ«æ æ ¼å¼æ–‡ä»¶\r\n',0),(275315,7648,'sv','Objektet kategori-kolumn filformatet',0),(275316,7648,'it','Elemento categoria formato colonna',0),(275317,7648,'tl','',0),(275318,7648,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;&#3652;&#3615;&#3621;&#3660;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(275319,7648,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(275320,7648,'ms','Format kolum item kategori fail',0),(275321,7648,'ar','Ø¨Ù†ÙŠØ© Ø®Ø§Ù†Ø§Øª Ù…Ù„ÙÙ‘ ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„ØµÙ†Ù',0),(275322,7648,'fr','Format de colonne fichier point catÃ©gorie',0),(275323,7648,'jp','ã‚¢ã‚¤ãƒ†ãƒ  ã‚«ãƒ†ã‚´ãƒª ãƒ•ã‚¡ã‚¤ãƒ«åˆ—ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(275324,7648,'pt','Formato de coluna do item categoria arquivo',0),(275325,7648,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(275326,7648,'es','Item CategorÃ­a Formato de Fila Columna',0),(275327,7648,'de','Artikel Kategorie Spalte Dateiformat',0),(275328,7648,'en','Item Category File Column Format',0),(275329,7649,'is','',0),(275330,7649,'dr','4  Ø¹Ø¯Ø¯ Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡  ',0),(275331,7649,'pr','ÙØµÙ„  4  Ø¹Ø¯Ø¯ Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡  ',0),(275332,7649,'tr','Sezon 4 Begin ay sayÄ±sÄ±',0),(275333,7649,'pl','Numer miesiÄ…ca rozpoczÄ…Ä‡ sezon 4',0),(275334,7649,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¼ÐµÑÐµÑ† Ð·Ð° Ð½Ð°Ñ‡Ð°Ð»Ð¾ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 4',0),(275335,7649,'ur','Ù…ÙˆØ³Ù… 4 Ø´Ø±ÙˆØ¹ Ù…ÛÛŒÙ†Û Ù†Ù…Ø¨Ø±',0),(275336,7649,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 4 Ð¾Ð·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¼ÐµÑÐµÑ†Ð° Ð±Ñ€Ð¾Ñ˜',0),(275337,7649,'vi','Sá»‘ thÃ¡ng báº¯t Ä‘áº§u MÃ¹a 4 ',0),(275338,7649,'af','Seisoen 4 Begin Maand Nommer',0),(275339,7649,'ro','NumÄƒrul de luni incepe sezonul 4',0),(275340,7649,'et','Season 4 algus kuu Number',0),(275341,7649,'si','Sezona 4 Begin mesec Å¡tevilka',0),(275342,7649,'ba','Musim 4 dimulai bulan nomor',0),(275343,7649,'nl','Seizoen 4 Begin maandnummer',0),(275344,7649,'fi','Kausi 4 alkaa kuukauden numero',0),(275345,7649,'no','Sesong 4 Begin MÃ¥nedsnummer',0),(275346,7649,'da','SÃ¦son 4 begynder mÃ¥nedsnummer',0),(275347,7649,'ko','ì‹œì¦Œ 4 ì‹œìž‘ ë‹¬ ìˆ˜',0),(275348,7649,'he','×¢×•× ×” 4 ×‘×’×™×Ÿ ×ž×¡×¤×¨ ×”×—×•×“×©',0),(275349,7649,'el','Î£ÎµÎ¶ÏŒÎ½ 4 Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î¼Î·Î½ÏŽÎ½',0),(275350,7649,'zh','ç¬¬4å­£å¼€å§‹æœˆä»½æ•°\r\n',0),(275351,7649,'sv','SÃ¤song 4 bÃ¶rjar mÃ¥nadsnummer',0),(275352,7649,'it','Numero del mese di inizio stagione 4',0),(275353,7649,'tl','',0),(275354,7649,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3604;&#3639;&#3629;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 4 ',0),(275355,7649,'hi','4 à¤¸à¥€à¤œà¤¨ à¤¶à¥à¤°à¥‚ à¤®à¤¾à¤¹ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(275356,7649,'ms','Musim 4 Mulakan bulan jumlah',0),(275357,7649,'ar','Ø±Ù‚Ù… Ø§Ù„Ø´Ù‡Ø± Ø¨Ø¯Ø¡ Ø§Ù„Ù…ÙˆØ³Ù… 4',0),(275358,7649,'fr','Nombre de mois pour le dÃ©but saison 4',0),(275359,7649,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 4 é–‹å§‹æœˆæ•°',0),(275360,7649,'pt','4 Âª temporada comeÃ§ar mÃªs nÃºmero',0),(275361,7649,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼ÐµÑÑÑ†Ð° Ð½Ð°Ñ‡Ð°Ð»Ð¾ 4 ÑÐµÐ·Ð¾Ð½Ð°',0),(275362,7649,'es','Temporada 4 NÃºmero de Mes de Comienza',0),(275363,7649,'de','Staffel 4 Begin Monatszahl',0),(275364,7649,'en','Season 4 Begin Month Number',0),(275365,7650,'is','',0),(275366,7650,'dr','4   Ø¹Ø¯Ø¯ Ù¾Ø§ÙŠØ§Ù† Ù…Ø§Ù‡ ',0),(275367,7650,'pr','ÙØµÙ„ 4   Ø¹Ø¯Ø¯ Ù¾Ø§ÙŠØ§Ù† Ù…Ø§Ù‡ ',0),(275368,7650,'tr','Sezon 4 son ay sayÄ±sÄ±',0),(275369,7650,'pl','Sezon 4 koniec miesiâ•£ca',0),(275370,7650,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¼ÐµÑÐµÑ† Ð·Ð° ÐºÑ€Ð°Ñ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 4',0),(275371,7650,'ur','Ù…ÙˆØ³Ù… 4 Ø¢Ø®Ø± Ù…Ø§Û Ù†Ù…Ø¨Ø±',0),(275372,7650,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 4 ÐºÑ€Ð°Ñ˜ Ð¼ÐµÑÐµÑ†Ð° Ð±Ñ€Ð¾Ñ˜',0),(275373,7650,'vi','Sá»‘ thÃ¡ng káº¿t thÃºc MÃ¹a 4 ',0),(275374,7650,'af','Seisoen 4 End Maand Nommer',0),(275375,7650,'ro','NumÄƒrul de luni sfÃ¢rÅŸitul sezonul 4',0),(275376,7650,'et','Season 4 End kuu Number',0),(275377,7650,'si','Konec sezone 4 mesec Å¡tevilka',0),(275378,7650,'ba','Musim 4 akhir bulan nomor',0),(275379,7650,'nl','Seizoen 4 einde maandnummer',0),(275380,7650,'fi','Season 4 lopussa kuukauden numero',0),(275381,7650,'no','Sesong 4 slutten MÃ¥nedsnummer',0),(275382,7650,'da','SÃ¦son 4 ende mÃ¥nedsnummer',0),(275383,7650,'ko','ì‹œì¦Œ 4 ë§ˆì§€ë§‰ ë‹¬ ìˆ˜',0),(275384,7650,'he','×ž×¡×¤×¨ ×”×—×•×“×© ×¡×•×£ ×¢×•× ×” 4',0),(275385,7650,'el','Î¤Î­Î»Î¿Ï‚ ÏƒÎµÎ¶ÏŒÎ½ 4 Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î¼Î·Î½ÏŽÎ½',0),(275386,7650,'zh','ç¬¬4å­£ç»“æŸæœˆä»½æ•°\r\n',0),(275387,7650,'sv','SÃ¤song 4 slutet mÃ¥nadsnummer',0),(275388,7650,'it','Numero del mese di fine stagione 4',0),(275389,7650,'tl','',0),(275390,7650,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3604;&#3639;&#3629;&#3609;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 4 ',0),(275391,7650,'hi','à¤¸à¥€à¤œà¤¨ 4 à¤…à¤‚à¤¤ à¤®à¤¾à¤¹ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(275392,7650,'ms','Musim 4 akhir bulan jumlah',0),(275393,7650,'ar','Ø±Ù‚Ù… Ø§Ù„Ø´Ù‡Ø± Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ù…ÙˆØ³Ù… 4',0),(275394,7650,'fr','Nombre de mois fin saison 4',0),(275395,7650,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 4 ã®çµ‚äº†æœˆç•ªå·',0),(275396,7650,'pt','NÃºmero de mÃªs de final de temporada 4',0),(275397,7650,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼ÐµÑÑÑ†Ð° Ð² ÐºÐ¾Ð½Ñ†Ðµ 4 ÑÐµÐ·Ð¾Ð½Ð°',0),(275398,7650,'es','Temporada 4 NÃºmero de Mes de TerminaciÃ³n',0),(275399,7650,'de','Staffel 4 Ende Monatszahl',0),(275400,7650,'en','Season 4 End Month Number',0),(275401,7651,'is','',0),(275402,7651,'dr','4   Ù†Ø§Ù… ',0),(275403,7651,'pr','ÙØµÙ„  4   Ù†Ø§Ù… ',0),(275404,7651,'tr','Sezon 4 ad',0),(275405,7651,'pl','Nazwa sezon 4',0),(275406,7651,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 4',0),(275407,7651,'ur','Ù…ÙˆØ³Ù… 4 Ù†Ø§Ù…',0),(275408,7651,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 4 Ð¸Ð¼Ðµ',0),(275409,7651,'vi','TÃªn mÃ¹a 4',0),(275410,7651,'af','Seisoen 4 Naam',0),(275411,7651,'ro','Sezonul 4 nume',0),(275412,7651,'et','Season 4 nime',0),(275413,7651,'si','Sezona 4 ime',0),(275414,7651,'ba','Musim 4 nama',0),(275415,7651,'nl','Seizoen 4 naam',0),(275416,7651,'fi','Season 4 nimi',0),(275417,7651,'no','Sesong 4 navn',0),(275418,7651,'da','SÃ¦son 4 navn',0),(275419,7651,'ko','ì‹œì¦Œ 4 ì´ë¦„',0),(275420,7651,'he','4 ×©× ×¢×•× ×”',0),(275421,7651,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏ€Î¿Ï‡Î®Ï‚ 4',0),(275422,7651,'zh','ç¬¬4å­£åç§°\r\n',0),(275423,7651,'sv','SÃ¤song 4 namn',0),(275424,7651,'it','Nome stagione 4',0),(275425,7651,'tl','',0),(275426,7651,'th','&#3594;&#3639;&#3656;&#3629;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 4',0),(275427,7651,'hi','4 à¤¸à¥€à¤œà¤¨ à¤•à¤¾ à¤¨à¤¾à¤®',0),(275428,7651,'ms','Nama musim 4',0),(275429,7651,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…ÙˆØ³Ù… Ø§Ù„Ø±Ø§Ø¨Ø¹',0),(275430,7651,'fr','Nom de la saison 4',0),(275431,7651,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 4 å',0),(275432,7651,'pt','Nome da 4 Âª temporada',0),(275433,7651,'ru','Ð˜Ð¼Ñ 4 ÑÐµÐ·Ð¾Ð½Ð°',0),(275434,7651,'es','Temporada 4 Nombre',0),(275435,7651,'de','Staffel 4 Namen',0),(275436,7651,'en','Season 4 Name',0),(275437,7652,'is','',0),(275438,7652,'dr','1   Ø¹Ø¯Ø¯ Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡',0),(275439,7652,'pr','ÙØµÙ„ 1   Ø¹Ø¯Ø¯ Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡',0),(275440,7652,'tr','Sezon 1 Begin ay sayÄ±sÄ±',0),(275441,7652,'pl','Sezon 1 poczÄ…tkowy numer miesiÄ…ca',0),(275442,7652,'bg','Ð¡ÐµÐ·Ð¾Ð½ 1 Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð¼ÐµÑÐµÑ† Ð½Ð¾Ð¼ÐµÑ€',0),(275443,7652,'ur','Ù…ÙˆØ³Ù… 1 Ø§Ø¨ØªØ¯Ø§ Ù…Ø§Û Ù†Ù…Ø¨Ø±',0),(275444,7652,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¼ÐµÑÐµÑ†Ð° 1 Ð¾Ð·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° ÑÐµÐ·Ð¾Ð½Ðµ',0),(275445,7652,'vi','Sá»‘ thÃ¡ng báº¯t Ä‘áº§u MÃ¹a 1',0),(275446,7652,'af','Seisoen 1 Begin Maand Nommer',0),(275447,7652,'ro','Sezonul 1 Ã®ncepe luna numÄƒrul',0),(275448,7652,'et','Season 1 algus kuu Number',0),(275449,7652,'si','Sezona 1 Begin mesec Å¡tevilka',0),(275450,7652,'ba','Musim 1 dimulai bulan nomor',0),(275451,7652,'nl','Seizoen 1 Begin maandnummer',0),(275452,7652,'fi','Kausi 1 alkaa kuukauden numero',0),(275453,7652,'no','Sesong 1 Start MÃ¥nedsnummer',0),(275454,7652,'da','SÃ¦son 1 Begin mÃ¥nedsnummer',0),(275455,7652,'ko','ì‹œì¦Œ 1 ì‹œìž‘ ë‹¬ ìˆ˜',0),(275456,7652,'he','×¢×•× ×” 1 ×‘×’×™×Ÿ ×ž×¡×¤×¨ ×”×—×•×“×©',0),(275457,7652,'el','Î£ÎµÎ¶ÏŒÎ½ 1 Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î¼Î·Î½ÏŽÎ½',0),(275458,7652,'zh','ç¬¬1å­£å¼€å§‹æœˆä»½æ•°\r\n',0),(275459,7652,'sv','SÃ¤song 1 bÃ¶rja mÃ¥nadsnummer',0),(275460,7652,'it','Stagione 1 Begin mese numero',0),(275461,7652,'tl','',0),(275462,7652,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3604;&#3639;&#3629;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 1',0),(275463,7652,'hi','à¤¸à¥€à¤œà¤¨ 1 à¤¶à¥à¤°à¥‚ à¤®à¤¾à¤¹ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(275464,7652,'ms','Musim 1 mulakan bulan jumlah',0),(275465,7652,'ar','Ø±Ù‚Ù… Ø§Ù„Ø´Ù‡Ø± ØªØ¨Ø¯Ø£ 1 Ø§Ù„Ù…ÙˆØ³Ù…',0),(275466,7652,'fr','1 nombre de mois de dÃ©but de saison',0),(275467,7652,'jp','å­£ç¯€ 1 ã®é–‹å§‹ 1 ãƒ¶æœˆæ•°',0),(275468,7652,'pt','Temporada 1 Begin mÃªs nÃºmero',0),(275469,7652,'ru','Ð§Ð¸ÑÐ»Ð¾ Ð¼ÐµÑÑÑ†Ð° 1 ÐÐ°Ñ‡Ð°Ð»Ð¾ ÑÐµÐ·Ð¾Ð½Ð°',0),(275470,7652,'es','Temporada 1 NÃºmero de Mes de Comienza',0),(275471,7652,'de','Saison 1 Begin Monatszahl',0),(275472,7652,'en','Season 1 Begin Month Number',0),(275473,7653,'is','',0),(275474,7653,'dr','1    Ø¹Ø¯Ø¯ Ù¾Ø§ÙŠØ§Ù† Ù…Ø§Ù‡',0),(275475,7653,'pr','ÙØµÙ„ 1    Ø¹Ø¯Ø¯ Ù¾Ø§ÙŠØ§Ù† Ù…Ø§Ù‡',0),(275476,7653,'tr','Sezon 1 sonu ay sayÄ±sÄ±',0),(275477,7653,'pl','Sezon 1 koniec miesiâ•£ca',0),(275478,7653,'bg','Ð¡ÐµÐ·Ð¾Ð½ 1 ÐºÑ€Ð°Ñ Ð¼ÐµÑÐµÑ† Ð½Ð¾Ð¼ÐµÑ€',0),(275479,7653,'ur','Ù…ÙˆØ³Ù… 1 Ø§Ø®ØªØªØ§Ù… Ù…ÛÛŒÙ†Û Ù†Ù…Ø¨Ø±',0),(275480,7653,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¼ÐµÑÐµÑ†Ð° 1 ÐºÑ€Ð°Ñ˜ ÑÐµÐ·Ð¾Ð½Ðµ',0),(275481,7653,'vi','Sá»‘ thÃ¡ng káº¿t thÃºc MÃ¹a 1',0),(275482,7653,'af','Seisoen 1 End Maand Nommer',0),(275483,7653,'ro','NumÄƒrul de luni sezonul 1 final',0),(275484,7653,'et','Season 1 End kuu Number',0),(275485,7653,'si','Sezona 1 konec meseca Å¡tevilka',0),(275486,7653,'ba','Musim 1 akhir bulan nomor',0),(275487,7653,'nl','Seizoen 1 einde maandnummer',0),(275488,7653,'fi','Kausi 1 loppuun kuukauden numero',0),(275489,7653,'no','Sesong 1 mÃ¥ned Sluttnummer',0),(275490,7653,'da','SÃ¦son 1 slutningen mÃ¥nedsnummer',0),(275491,7653,'ko','ì‹œì¦Œ 1 ìµœì¢… ë‹¬ ìˆ˜',0),(275492,7653,'he','×ž×¡×¤×¨ ×”×—×•×“×© 1 ×¡×•×£ ×”×¢×•× ×”',0),(275493,7653,'el','Î£ÎµÎ¶ÏŒÎ½ 1 Ï„Î­Î»Î¿Ï‚ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î¼Î·Î½ÏŽÎ½',0),(275494,7653,'zh','ç¬¬1å­£ç»“æŸæœˆä»½æ•°\r\n',0),(275495,7653,'sv','SÃ¤song 1 slutet mÃ¥nadsnummer',0),(275496,7653,'it','Stagione 1 numero di fine mese',0),(275497,7653,'tl','',0),(275498,7653,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3604;&#3639;&#3629;&#3609;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 1',0),(275499,7653,'hi','à¤¸à¥€à¤œà¤¨ 1 à¤…à¤‚à¤¤ à¤®à¤¾à¤¹ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(275500,7653,'ms','Musim 1 akhir bulan jumlah',0),(275501,7653,'ar','1 Ø±Ù‚Ù… Ø§Ù„Ø´Ù‡Ø± ÙÙŠ Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ù…ÙˆØ³Ù…',0),(275502,7653,'fr','1 nombre de mois de fin de saison',0),(275503,7653,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 1 ã®çµ‚äº†æœˆç•ªå·',0),(275504,7653,'pt','Temporada final de 1 mÃªs nÃºmero',0),(275505,7653,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼ÐµÑÑÑ†Ð° ÐºÐ¾Ð½ÐµÑ† 1 ÑÐµÐ·Ð¾Ð½Ð°',0),(275506,7653,'es','Temporada 1 NÃºmero de Mes de TerminaciÃ³n',0),(275507,7653,'de','Saison 1 Ende Monatszahl',0),(275508,7653,'en','Season 1 End Month Number',0),(275509,7654,'is','',0),(275510,7654,'dr','1  Ù†Ø§Ù…',0),(275511,7654,'pr','ÙØµÙ„ 1  Ù†Ø§Ù…',0),(275512,7654,'tr','Sezon 1 adÄ±',0),(275513,7654,'pl','Nazwa sezon 1',0),(275514,7654,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 1',0),(275515,7654,'ur','Ù†Ø§Ù… Ù…ÙˆØ³Ù… 1',0),(275516,7654,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 1 Ð¸Ð¼Ðµ',0),(275517,7654,'vi','TÃªn mÃ¹a 1',0),(275518,7654,'af','Seisoen 1 Naam',0),(275519,7654,'ro','Sezonul 1 nume',0),(275520,7654,'et','Season 1 nimi',0),(275521,7654,'si','Sezona 1 ime',0),(275522,7654,'ba','Musim 1 nama',0),(275523,7654,'nl','Seizoen 1 naam',0),(275524,7654,'fi','Kausi 1 nimi',0),(275525,7654,'no','Sesong 1 navn',0),(275526,7654,'da','SÃ¦son 1 navn',0),(275527,7654,'ko','ì‹œì¦Œ 1 ì´ë¦„',0),(275528,7654,'he','1 ×©× ×¢×•× ×”',0),(275529,7654,'el','Î£ÎµÎ¶ÏŒÎ½ 1 ÏŒÎ½Î¿Î¼Î±',0),(275530,7654,'zh','ç¬¬1å­£åç§°\r\n',0),(275531,7654,'sv','SÃ¤song 1 namn',0),(275532,7654,'it','Nome stagione 1',0),(275533,7654,'tl','',0),(275534,7654,'th','&#3594;&#3639;&#3656;&#3629;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 1',0),(275535,7654,'hi','à¤¸à¥€à¤œà¤¨ 1 à¤¨à¤¾à¤®',0),(275536,7654,'ms','Musim 1 nama',0),(275537,7654,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…ÙˆØ³Ù… Ø§Ù„Ø£ÙˆÙ„',0),(275538,7654,'fr','Nom de la saison 1',0),(275539,7654,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 1 å',0),(275540,7654,'pt','Nome da temporada 1',0),(275541,7654,'ru','Ð¡ÐµÐ·Ð¾Ð½ 1 Ð¸Ð¼Ñ',0),(275542,7654,'es','Temporada 1 Nombre',0),(275543,7654,'de','Staffel 1-Name',0),(275544,7654,'en','Season 1 Name',0),(275545,7655,'is','',0),(275546,7655,'dr','3   Ø¹Ø¯Ø¯ Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡',0),(275547,7655,'pr','ÙØµÙ„ 3   Ø¹Ø¯Ø¯ Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡',0),(275548,7655,'tr','Sezon 3 Begin ay sayÄ±sÄ±',0),(275549,7655,'pl','Numer miesiÄ…ca rozpoczÄ…Ä‡ sezon 3',0),(275550,7655,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¼ÐµÑÐµÑ† Ð·Ð° Ð½Ð°Ñ‡Ð°Ð»Ð¾ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 3',0),(275551,7655,'ur','Ù…ÙˆØ³Ù… 3 Ø¢ØºØ§Ø² Ù…Ø§Û Ù†Ù…Ø¨Ø±',0),(275552,7655,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 3 Ð¾Ð·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¼ÐµÑÐµÑ†Ð° Ð±Ñ€Ð¾Ñ˜',0),(275553,7655,'vi','Sá»‘ thÃ¡ng báº¯t Ä‘áº§u MÃ¹a 3',0),(275554,7655,'af','Seisoen 3 Begin Maand Nommer',0),(275555,7655,'ro','ÃŽncepe sezonul 3 lunÄƒ calendaristicÄƒ NumÄƒr',0),(275556,7655,'et','Season 3 algab kuu Number',0),(275557,7655,'si','Sezona 3 zaÄetek meseca Å¡tevilka',0),(275558,7655,'ba','Musim 3 dimulai bulan nomor',0),(275559,7655,'nl','Seizoen 3 Begin maandnummer',0),(275560,7655,'fi','Kausi 3 alkaa kuukauden numero',0),(275561,7655,'no','Sesong 3 begynner MÃ¥nedsnummer',0),(275562,7655,'da','SÃ¦son 3 Begin mÃ¥nedsnummer',0),(275563,7655,'ko','ì‹œì¦Œ 3 ì‹œìž‘ ë‹¬ ìˆ˜',0),(275564,7655,'he','×ž×¡×¤×¨ ×”×—×•×“×© ×‘×’×™×Ÿ ×¢×•× ×” 3',0),(275565,7655,'el','Î£ÎµÎ¶ÏŒÎ½ 3 Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î¼Î·Î½ÏŽÎ½',0),(275566,7655,'zh','ç¬¬3å­£å¼€å§‹æœˆä»½æ•°\r\n',0),(275567,7655,'sv','SÃ¤song 3 bÃ¶rjar mÃ¥nadsnummer',0),(275568,7655,'it','Numero del mese di inizio stagione 3',0),(275569,7655,'tl','',0),(275570,7655,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3604;&#3639;&#3629;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 3',0),(275571,7655,'hi','3 à¤¸à¥€à¤œà¤¨ à¤¶à¥à¤°à¥‚ à¤®à¤¾à¤¹ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(275572,7655,'ms','Musim 3 mulakan bulan jumlah',0),(275573,7655,'ar','Ø±Ù‚Ù… Ø§Ù„Ø´Ù‡Ø± Ø¨Ø¯Ø¡ Ø§Ù„Ù…ÙˆØ³Ù… 3',0),(275574,7655,'fr','Nombre de mois pour le dÃ©but saison 3',0),(275575,7655,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 3 é–‹å§‹æœˆæ•°',0),(275576,7655,'pt','3 Âª temporada comeÃ§ar mÃªs nÃºmero',0),(275577,7655,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼ÐµÑÑÑ†Ð° Ð½Ð°Ñ‡Ð°Ð»Ð¾ 3 ÑÐµÐ·Ð¾Ð½Ð°',0),(275578,7655,'es','Temporada 3 NÃºmero de Mes de Comienza',0),(275579,7655,'de','Staffel 3 Begin Monatszahl',0),(275580,7655,'en','Season 3 Begin Month Number',0),(275581,7656,'is','',0),(275582,7656,'dr','3    Ø¹Ø¯Ø¯ Ù¾Ø§ÙŠØ§Ù† Ù…Ø§Ù‡',0),(275583,7656,'pr','ÙØµÙ„ 3    Ø¹Ø¯Ø¯ Ù¾Ø§ÙŠØ§Ù† Ù…Ø§Ù‡',0),(275584,7656,'tr','Sezon 3 son ay sayÄ±sÄ±',0),(275585,7656,'pl','Sezon 3 koniec miesiâ•£ca',0),(275586,7656,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¼ÐµÑÐµÑ† Ð·Ð° ÐºÑ€Ð°Ñ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 3',0),(275587,7656,'ur','Ù…ÙˆØ³Ù… 3 Ø¢Ø®Ø± Ù…Ø§Û Ù†Ù…Ø¨Ø±',0),(275588,7656,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 3 ÐºÑ€Ð°Ñ˜ Ð¼ÐµÑÐµÑ†Ð° Ð±Ñ€Ð¾Ñ˜',0),(275589,7656,'vi','Sá»‘ thÃ¡ng káº¿t thÃºc MÃ¹a 3',0),(275590,7656,'af','Seisoen 3 End Maand Nommer',0),(275591,7656,'ro','NumÄƒrul de luni sfÃ¢rÅŸitul sezonul 3',0),(275592,7656,'et','Season 3 End kuu Number',0),(275593,7656,'si','Sezona 3 konec meseca Å¡tevilka',0),(275594,7656,'ba','Musim 3 akhir bulan nomor',0),(275595,7656,'nl','Seizoen 3 einde maandnummer',0),(275596,7656,'fi','Kolmannen kauden lopussa kuukauden numero',0),(275597,7656,'no','Sesong 3 slutten MÃ¥nedsnummer',0),(275598,7656,'da','SÃ¦son 3 ende mÃ¥nedsnummer',0),(275599,7656,'ko','ì‹œì¦Œ 3 ë§ˆì§€ë§‰ ë‹¬ ìˆ˜',0),(275600,7656,'he','×ž×¡×¤×¨ ×”×—×•×“×© ×¡×•×£ ×¢×•× ×” 3',0),(275601,7656,'el','Î¤Î­Î»Î¿Ï‚ ÏƒÎµÎ¶ÏŒÎ½ 3 Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î¼Î·Î½ÏŽÎ½',0),(275602,7656,'zh','ç¬¬3å­£ç»“æŸæœˆä»½æ•°\r\n',0),(275603,7656,'sv','SÃ¤song 3 slutet mÃ¥nadsnummer',0),(275604,7656,'it','Numero del mese di fine stagione 3',0),(275605,7656,'tl','',0),(275606,7656,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3604;&#3639;&#3629;&#3609;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 3',0),(275607,7656,'hi','à¤®à¥Œà¤¸à¤® 3 à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤®à¤¾à¤¹ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(275608,7656,'ms','Musim 3 akhir bulan jumlah',0),(275609,7656,'ar','Ø±Ù‚Ù… Ø§Ù„Ø´Ù‡Ø± Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ù…ÙˆØ³Ù… 3',0),(275610,7656,'fr','Nombre de mois fin saison 3',0),(275611,7656,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 3 çµ‚ã‚ã‚Šæœˆæ•°',0),(275612,7656,'pt','3 Âª temporada final mÃªs nÃºmero',0),(275613,7656,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼ÐµÑÑÑ†Ð° ÐºÐ¾Ð½ÐµÑ† 3 ÑÐµÐ·Ð¾Ð½Ð°',0),(275614,7656,'es','Temporada 3 NÃºmero de Mes de TerminaciÃ³n',0),(275615,7656,'de','Staffel 3 Ende Monatszahl',0),(275616,7656,'en','Season 3 End Month Number',0),(275617,7657,'is','',0),(275618,7657,'dr','3   Ù†Ø§Ù…',0),(275619,7657,'pr','ÙØµÙ„ 3   Ù†Ø§Ù…',0),(275620,7657,'tr','Sezon 3 adÄ±',0),(275621,7657,'pl','Nazwa sezon 3',0),(275622,7657,'bg','Ð¡ÐµÐ·Ð¾Ð½ 3 Ð¸Ð¼Ðµ',0),(275623,7657,'ur','Ù…ÙˆØ³Ù… 3 Ù†Ø§Ù…',0),(275624,7657,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 3 Ð¸Ð¼Ðµ',0),(275625,7657,'vi','TÃªn mÃ¹a 3',0),(275626,7657,'af','Seisoen 3 Naam',0),(275627,7657,'ro','Sezonul 3 nume',0),(275628,7657,'et','Season 3 nimi',0),(275629,7657,'si','Sezona 3 ime',0),(275630,7657,'ba','Musim 3 nama',0),(275631,7657,'nl','Seizoen 3 naam',0),(275632,7657,'fi','Kauden nimi',0),(275633,7657,'no','Sesong 3 navn',0),(275634,7657,'da','SÃ¦son 3 navn',0),(275635,7657,'ko','ì‹œì¦Œ 3 ì´ë¦„',0),(275636,7657,'he','3 ×©× ×¢×•× ×”',0),(275637,7657,'el','ÎŒÎ½Î¿Î¼Î± Season 3',0),(275638,7657,'zh','ç¬¬3å­£åç§°\r\n',0),(275639,7657,'sv','SÃ¤song 3 namn',0),(275640,7657,'it','Nome stagione 3',0),(275641,7657,'tl','',0),(275642,7657,'th','&#3594;&#3639;&#3656;&#3629;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 3',0),(275643,7657,'hi','à¤®à¥Œà¤¸à¤® 3 à¤¨à¤¾à¤®',0),(275644,7657,'ms','Nama musim 3',0),(275645,7657,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…ÙˆØ³Ù… Ø§Ù„Ø«Ø§Ù„Ø«',0),(275646,7657,'fr','Nom de la saison 3',0),(275647,7657,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 3 å',0),(275648,7657,'pt','Nome de 3 Âª temporada',0),(275649,7657,'ru','Ð˜Ð¼Ñ 3 ÑÐµÐ·Ð¾Ð½',0),(275650,7657,'es','Temporada 3 Nombre',0),(275651,7657,'de','Staffel 3-Name',0),(275652,7657,'en','Season 3 Name',0),(275653,7658,'is','',0),(275654,7658,'dr','2   Ø¹Ø¯Ø¯ Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡',0),(275655,7658,'pr','ÙØµÙ„ 2   Ø¹Ø¯Ø¯ Ø´Ø±ÙˆØ¹ Ù…Ø§Ù‡',0),(275656,7658,'tr','Sezon 2 Begin ay sayÄ±sÄ±',0),(275657,7658,'pl','Numer miesiÄ…ca rozpoczÄ…Ä‡ sezon 2',0),(275658,7658,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¼ÐµÑÐµÑ† Ð·Ð° Ð½Ð°Ñ‡Ð°Ð»Ð¾ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 2',0),(275659,7658,'ur','Ø§ÙˆÙ¾Ø± 2 Ø´Ø±ÙˆØ¹ Ù…ÛÛŒÙ†Û Ù†Ù…Ø¨Ø±',0),(275660,7658,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 2 Ð¾Ð·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¼ÐµÑÐµÑ†Ð° Ð±Ñ€Ð¾Ñ˜',0),(275661,7658,'vi','Sá»‘ thÃ¡ng báº¯t Ä‘áº§u MÃ¹a 2',0),(275662,7658,'af','Seisoen 2 Begin Maand Nommer',0),(275663,7658,'ro','NumÄƒrul de luni incepe sezonul 2',0),(275664,7658,'et','Season 2 algab kuu Number',0),(275665,7658,'si','Sezona 2 zaÄetek meseca Å¡tevilka',0),(275666,7658,'ba','Musim 2 dimulai bulan nomor',0),(275667,7658,'nl','Seizoen 2 Begin maandnummer',0),(275668,7658,'fi','Kausi 2 alkaa kuukauden numero',0),(275669,7658,'no','Sesong 2 begynner MÃ¥nedsnummer',0),(275670,7658,'da','SÃ¦son 2 Begin mÃ¥nedsnummer',0),(275671,7658,'ko','ì‹œì¦Œ 2 ì‹œìž‘ ë‹¬ ìˆ˜',0),(275672,7658,'he','×¢×•× ×” 2 ×‘×’×™×Ÿ ×ž×¡×¤×¨ ×”×—×•×“×©',0),(275673,7658,'el','Î£ÎµÎ¶ÏŒÎ½ 2 Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î¼Î·Î½ÏŽÎ½',0),(275674,7658,'zh','ç¬¬2å­£å¼€å§‹æœˆä»½æ•°\r\n',0),(275675,7658,'sv','SÃ¤song 2 bÃ¶rjar mÃ¥nadsnummer',0),(275676,7658,'it','Numero del mese di inizio stagione 2',0),(275677,7658,'tl','',0),(275678,7658,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3604;&#3639;&#3629;&#3609;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 2',0),(275679,7658,'hi','2 à¤®à¥Œà¤¸à¤® à¤¶à¥à¤°à¥‚ à¤®à¤¾à¤¹ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(275680,7658,'ms','Musim ke-2 Begin bulan jumlah',0),(275681,7658,'ar','Ø±Ù‚Ù… Ø§Ù„Ø´Ù‡Ø± Ø¨Ø¯Ø¡ Ø§Ù„Ù…ÙˆØ³Ù… 2',0),(275682,7658,'fr','Nombre de mois pour le dÃ©but saison 2',0),(275683,7658,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 2 é–‹å§‹æœˆæ•°',0),(275684,7658,'pt','Temporada 2 Begin mÃªs nÃºmero',0),(275685,7658,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼ÐµÑÑÑ†Ð° Ð½Ð°Ñ‡Ð°Ñ‚ÑŒ ÑÐµÐ·Ð¾Ð½ 2',0),(275686,7658,'es','Temporada 2 NÃºmero de Mes de Comienza',0),(275687,7658,'de','Staffel 2 Begin Monatszahl',0),(275688,7658,'en','Season 2 Begin Month Number',0),(275689,7659,'is','',0),(275690,7659,'dr','2    Ø¹Ø¯Ø¯ Ù¾Ø§ÙŠØ§Ù† Ù…Ø§Ù‡',0),(275691,7659,'pr','ÙØµÙ„ 2    Ø¹Ø¯Ø¯ Ù¾Ø§ÙŠØ§Ù† Ù…Ø§Ù‡',0),(275692,7659,'tr','Sezon 2 uÃ§ ay sayÄ±sÄ±',0),(275693,7659,'pl','Sezon 2 koniec miesiâ•£ca',0),(275694,7659,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¼ÐµÑÐµÑ† Ð·Ð° ÐºÑ€Ð°Ñ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 2',0),(275695,7659,'ur','Ø§ÙˆÙ¾Ø± 2 Ø¢Ø®Ø± Ù…Ø§Û Ù†Ù…Ø¨Ø±',0),(275696,7659,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 2 ÐºÑ€Ð°Ñ˜ Ð¼ÐµÑÐµÑ†Ð° Ð±Ñ€Ð¾Ñ˜',0),(275697,7659,'vi','Sá»‘ thÃ¡ng káº¿t thÃºc MÃ¹a 2',0),(275698,7659,'af','Seisoen 2 End Maand Nommer',0),(275699,7659,'ro','NumÄƒrul de luni sezonul 2 sfÃ¢rÅŸitul',0),(275700,7659,'et','Season 2 End kuu Number',0),(275701,7659,'si','Sezona 2 konec meseca Å¡tevilka',0),(275702,7659,'ba','Musim 2 akhir bulan nomor',0),(275703,7659,'nl','Seizoen 2 einde maandnummer',0),(275704,7659,'fi','Kausi 2 lopussa kuukauden numero',0),(275705,7659,'no','Sesong 2 slutten MÃ¥nedsnummer',0),(275706,7659,'da','SÃ¦son 2 ende mÃ¥nedsnummer',0),(275707,7659,'ko','ì‹œì¦Œ 2 ë ë‹¬ ìˆ˜',0),(275708,7659,'he','×ž×¡×¤×¨ ×”×—×•×“×© ×¡×•×£ ×¢×•× ×” 2',0),(275709,7659,'el','Î¤Î­Î»Î¿Ï‚ ÏƒÎµÎ¶ÏŒÎ½ 2 Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î¼Î·Î½ÏŽÎ½',0),(275710,7659,'zh','ç¬¬2å­£ç»“æŸæœˆä»½æ•°\r\n',0),(275711,7659,'sv','SÃ¤song 2 slutet mÃ¥nadsnummer',0),(275712,7659,'it','Numero del mese di fine stagione 2',0),(275713,7659,'tl','',0),(275714,7659,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3604;&#3639;&#3629;&#3609;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 2',0),(275715,7659,'hi','à¤¸à¥€à¤œà¤¨ 2 à¤…à¤‚à¤¤ à¤®à¤¾à¤¹ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(275716,7659,'ms','Musim ke-2 akhir bulan jumlah',0),(275717,7659,'ar','Ø±Ù‚Ù… Ø§Ù„Ø´Ù‡Ø± Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ù…ÙˆØ³Ù… 2',0),(275718,7659,'fr','Nombre de mois fin saison 2',0),(275719,7659,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 2 ã®çµ‚ã‚ã‚Šæœˆæ•°',0),(275720,7659,'pt','NÃºmero de mÃªs de final de temporada 2',0),(275721,7659,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼ÐµÑÑÑ†Ð° ÐºÐ¾Ð½ÐµÑ† ÑÐµÐ·Ð¾Ð½ 2',0),(275722,7659,'es','Temporada 2 NÃºmero de Mes de TerminaciÃ³n',0),(275723,7659,'de','Staffel Ende Monatszahl',0),(275724,7659,'en','Season 2 End Month Number',0),(275725,7660,'is','',0),(275726,7660,'dr','2   Ù†Ø§Ù…',0),(275727,7660,'pr','ÙØµÙ„ 2   Ù†Ø§Ù…',0),(275728,7660,'tr','Sezon 2 adÄ±',0),(275729,7660,'pl','Nazwa sezon 2',0),(275730,7660,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 2',0),(275731,7660,'ur','Ø§ÙˆÙ¾Ø± 2 Ù†Ø§Ù…',0),(275732,7660,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 2 Ð¸Ð¼Ðµ',0),(275733,7660,'vi','TÃªn mÃ¹a 2',0),(275734,7660,'af','Seisoen 2 Naam',0),(275735,7660,'ro','Sezonul 2 nume',0),(275736,7660,'et','Season 2 nimi',0),(275737,7660,'si','Sezona 2 ime',0),(275738,7660,'ba','Musim 2 nama',0),(275739,7660,'nl','Seizoen 2 naam',0),(275740,7660,'fi','Kausi 2 nimi',0),(275741,7660,'no','Sesong 2 navn',0),(275742,7660,'da','SÃ¦son 2 navn',0),(275743,7660,'ko','ì‹œì¦Œ 2 ì´ë¦„',0),(275744,7660,'he','2 ×©× ×¢×•× ×”',0),(275745,7660,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏ€Î¿Ï‡Î®Ï‚ 2',0),(275746,7660,'zh','ç¬¬2å­£åç§°\r\n',0),(275747,7660,'sv','SÃ¤song 2 namn',0),(275748,7660,'it','Nome stagione 2',0),(275749,7660,'tl','',0),(275750,7660,'th','&#3594;&#3639;&#3656;&#3629;&#3620;&#3604;&#3641;&#3585;&#3634;&#3621; 2',0),(275751,7660,'hi','à¤¸à¥€à¤œà¤¨ 2 à¤•à¤¾ à¤¨à¤¾à¤®',0),(275752,7660,'ms','Nama musim ke-2',0),(275753,7660,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…ÙˆØ³Ù… Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(275754,7660,'fr','Nom de la saison 2',0),(275755,7660,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 2 å',0),(275756,7660,'pt','Temporada 2 nome',0),(275757,7660,'ru','Ð˜Ð¼Ñ 2 ÑÐµÐ·Ð¾Ð½',0),(275758,7660,'es','Temporada 2 Nombre',0),(275759,7660,'de','Staffel 2 Namen',0),(275760,7660,'en','Season 2 Name',0),(275761,7661,'is','',0),(275762,7661,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(275763,7661,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª ÙØ§ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ÙØ±Ù…Øª Ø§Ø³ÙƒÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(275764,7661,'tr','CSV biÃ§imi madde kategorileri iÃ§in URL dosya',0),(275765,7661,'pl','Adres URL pliku CSV Format elementu Kategorie',0),(275766,7661,'bg','URL Ñ„Ð°Ð¹Ð» Ð·Ð° CSV Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(275767,7661,'ur','ÛŒÙˆ Ø¢Ø± Ø§ÛŒÙ„ ÙØ§Ø¦Ù„ CSV ÙˆØ¶Ø¹ Ø´Û’ Ø²Ù…Ø±Û Ø¬Ø§Øª Ú©Û’ Ù„ÛŒÛ’',0),(275768,7661,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¦Ð¡Ð’ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(275769,7661,'vi','Há»“ sÆ¡ Ä‘Æ°á»ng dáº«n cho thá»ƒ loáº¡i hÃ ng dáº¡ng CSV',0),(275770,7661,'af','BA (\"URL\") LÃªer Vir CSV Formaatitems KategoriÃ«',0),(275771,7661,'ro','URL-ul de fiÅŸier pentru formatul CSV element categorii',0),(275772,7661,'et','URL faili CSV formaadis kaubakategooriate',0),(275773,7661,'si','URL datoteke CSV formatu element kategorije',0),(275774,7661,'ba','File URL untuk Item Kategori dalam Format CSV',0),(275775,7661,'nl','Bestand met URL voor CSV-formaat artikelcategorieÃ«n',0),(275776,7661,'fi','URL tiedosto CSV-muodossa nimikekategorioiden osalta',0),(275777,7661,'no','URL fil for CSV-Format kategorier',0),(275778,7661,'da','URL fil i CSV-Format varekategorier',0),(275779,7661,'ko','URL íŒŒì¼ CSV í˜•ì‹ í•­ëª© ë²”ì£¼ì— ëŒ€ í•œ',0),(275780,7661,'he','×›×ª×•×‘×ª url ×©×œ ×§×•×‘×¥ ×¢×‘×•×¨ ×”×§×˜×’×•×¨×™×•×ª ×”×¤×¨×™×˜ ×‘×¤×•×¨×ž×˜ CSV',0),(275781,7661,'el','URL Î±ÏÏ‡ÎµÎ¯Î¿Ï… Î³Î¹Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ ÎµÎ¹Î´ÏŽÎ½ Î¼Î¿ÏÏ†Î® CSV',0),(275782,7661,'zh','ç½‘å€æ–‡ä»¶ä¸ºé€—å·åˆ†éš”å€¼æ ¼å¼æ–‡ä»¶é¡¹ç›®ç±»åˆ«\r\n',0),(275783,7661,'sv','URL-filen fÃ¶r CSV-Format artikelkategorier',0),(275784,7661,'it','URL File per categorie di elemento formato CSV',0),(275785,7661,'tl','',0),(275786,7661,'th','URL File for CSV Format Item Categories',0),(275787,7661,'hi','URL à¤«à¤¼à¤¾à¤‡à¤² CSV à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤',0),(275788,7661,'ms','URL fail CSV Format Item kategori',0),(275789,7661,'ar','Ù…Ù„Ù URL Ù„ÙØ¦Ø§Øª Ø¹Ù†ØµØ± ØªÙ†Ø³ÙŠÙ‚ CSV',0),(275790,7661,'fr','Fichier de l\'URL pour les catÃ©gories d\'Ã©lÃ©ments de Format CSV',0),(275791,7661,'jp','CSV å½¢å¼ã®é …ç›®ã®ã‚«ãƒ†ã‚´ãƒªã® URL ãƒ•ã‚¡ã‚¤ãƒ«',0),(275792,7661,'pt','Arquivo URL para categorias de Item de formato CSV',0),(275793,7661,'ru','URL-Ð°Ð´Ñ€ÐµÑ Ñ„Ð°Ð¹Ð»Ð° Ð´Ð»Ñ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð° CSV',0),(275794,7661,'es','URL File para Formato CSV de CategorÃ­as de Items',0),(275795,7661,'de','URL-Datei fÃ¼r CSV Format Positionstypen',0),(275796,7661,'en','URL File for CSV Format Item Categories',0),(275797,7662,'is','',0),(275798,7662,'dr','1= Ø¨Ù„ÛŒ',0),(275799,7662,'pr','1= Ø¨Ù„ÛŒ',0),(275800,7662,'tr','1 = Evet',0),(275801,7662,'pl','1 = tak',0),(275802,7662,'bg','1 = Ð´Ð°',0),(275803,7662,'ur','Ù¡ Ú©Ø§ Ù…Ø·Ù„Ø¨ Ú¾Ø§Úº',0),(275804,7662,'sr','1 = Ð´Ð°',0),(275805,7662,'vi','1=Yes',0),(275806,7662,'af','1=Ja',0),(275807,7662,'ro','1=DA',0),(275808,7662,'et','1 = Jah',0),(275809,7662,'si','1=Da',0),(275810,7662,'ba','1=Ya',0),(275811,7662,'nl','1 = Ja',0),(275812,7662,'fi','1 = KyllÃ¤',0),(275813,7662,'no','1 = Ja',0),(275814,7662,'da','1 = ja',0),(275815,7662,'ko','1 = ì˜ˆ',0),(275816,7662,'he','1 = ×›×Ÿ',0),(275817,7662,'el','1=ÎÎ±Î¹',0),(275818,7662,'zh','1 = æ˜¯',0),(275819,7662,'sv','1=Ja',0),(275820,7662,'it','1=Si',0),(275821,7662,'tl','',0),(275822,7662,'th','1=Yes',0),(275823,7662,'hi','1 = à¤¹à¤¾à¤',0),(275824,7662,'ms','1 = Ya',0),(275825,7662,'ar','1 = Ù†Ø¹Ù…',0),(275826,7662,'fr','1=Oui',0),(275827,7662,'jp','1 = ã¯ã„',0),(275828,7662,'pt','1 = Sim',0),(275829,7662,'ru','1 = Ð”Ð°',0),(275830,7662,'es','1=Si',0),(275831,7662,'de','1=Ja',0),(275832,7662,'en','1=Yes',0),(275833,7663,'is','',0),(275834,7663,'dr','Ø¬Ø¯Ø§ ÙƒÙ†Ù†Ø¯Ù‡ ÙÙŠÙ„Ø¯ ',0),(275835,7663,'pr','Ø¬Ø¯Ø§ ÙƒÙ†Ù†Ø¯Ù‡ ÙÙŠÙ„Ø¯ ',0),(275836,7663,'tr','Alan ayÄ±rÄ±cÄ±',0),(275837,7663,'pl','Separator pÃ³l',0),(275838,7663,'bg','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ» Ð·Ð° Ð¿Ð¾Ð»Ðµ',0),(275839,7663,'ur','Ù‚Ø·Ø¹Û Ø¬Ø¯Ø§Ú©Ø§Ø±',0),(275840,7663,'sr','Ð—Ð° Ñ€Ð°Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ Ð¿Ð¾Ñ™Ð°',0),(275841,7663,'vi','NgÄƒn cÃ¡ch TrÆ°á»ng',0),(275842,7663,'af','Veldverdeler',0),(275843,7663,'ro','Separator de cÃ¢mp',0),(275844,7663,'et','VÃ¤ljade eraldaja',0),(275845,7663,'si','LoÄilo',0),(275846,7663,'ba','Bidang pemisah',0),(275847,7663,'nl','Veldscheidingsteken',0),(275848,7663,'fi','KenttÃ¤erotin',0),(275849,7663,'no','Skilletegn',0),(275850,7663,'da','Feltseparator',0),(275851,7663,'ko','í•„ë“œ êµ¬ë¶„ ê¸°í˜¸',0),(275852,7663,'he','×ž×¤×¨×™×“ ×©×“×”',0),(275853,7663,'el','Î”Î¹Î±Ï‡Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÎµÎ´Î¯Ï‰Î½',0),(275854,7663,'zh','å­—æ®µåˆ†éš”ç¬¦\r\n',0),(275855,7663,'sv','FÃ¤ltavgrÃ¤nsare',0),(275856,7663,'it','Separatore di campo',0),(275857,7663,'tl','',0),(275858,7663,'th','&#3605;&#3633;&#3623;&#3649;&#3618;&#3585;&#3615;&#3636;&#3621;&#3604;&#3660;',0),(275859,7663,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤µà¤¿à¤­à¤¾à¤œà¤•',0),(275860,7663,'ms','Bidang pemisah',0),(275861,7663,'ar','Ø§Ù„ÙØ§ØµÙ„ Ø¨ÙŠÙ† Ø§Ù„Ø­Ù‚ÙˆÙ„',0),(275862,7663,'fr','SÃ©parateur de champ',0),(275863,7663,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰åŒºåˆ‡ã‚Šè¨˜å·',0),(275864,7663,'pt','Separador de campo',0),(275865,7663,'ru','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑŒ Ð¿Ð¾Ð»ÐµÐ¹',0),(275866,7663,'es','Separador de Campo',0),(275867,7663,'de','Feldtrennzeichen',0),(275868,7663,'en','Field Separator',0),(275869,7664,'is','',0),(275870,7664,'dr','Ø³Ø±Ù…Ù‚Ø§Ù„Ù‡',0),(275871,7664,'pr','Ø³Ø±Ù…Ù‚Ø§Ù„Ù‡',0),(275872,7664,'tr','Ã–n sayfa',0),(275873,7664,'pl','Strona tytuÅ‚owa',0),(275874,7664,'bg','ÐŸÑŠÑ€Ð²Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(275875,7664,'ur','Ø³Ø§Ù…Ù†Û’ ÙˆØ§Ù„Ø§ Ø³Ø±ÙˆØ±Ù‚',0),(275876,7664,'sr','ÐÐ°ÑÐ»Ð¾Ð²Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð°',0),(275877,7664,'vi','Trang trÆ°á»›c',0),(275878,7664,'af','Voorblad',0),(275879,7664,'ro','Prima pagina',0),(275880,7664,'et','Esileht',0),(275881,7664,'si','Sprednji strani',0),(275882,7664,'ba','Halaman depan',0),(275883,7664,'nl','Voorpagina',0),(275884,7664,'fi','Etusivu',0),(275885,7664,'no','Forsiden',0),(275886,7664,'da','Forsiden',0),(275887,7664,'ko','í”„ë¡ íŠ¸ íŽ˜ì´ì§€',0),(275888,7664,'he','×‘×¢×ž×•×“ ×”×¨××©×™',0),(275889,7664,'el','Î ÏÏŽÏ„Î· ÏƒÎµÎ»Î¯Î´Î±',0),(275890,7664,'zh','å¤´ç‰ˆ\r\n',0),(275891,7664,'sv','FÃ¶rsta sidan',0),(275892,7664,'it','Prima pagina',0),(275893,7664,'tl','',0),(275894,7664,'th','&#3627;&#3609;&#3657;&#3634;&#3604;&#3657;&#3634;&#3609;&#3627;&#3609;&#3657;&#3634;',0),(275895,7664,'hi','à¤«à¥à¤°à¤‚à¤Ÿ à¤ªà¥‡à¤œ',0),(275896,7664,'ms','Muka depan',0),(275897,7664,'ar','Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø£Ù…Ø§Ù…ÙŠØ©',0),(275898,7664,'fr','Page d\'accueil',0),(275899,7664,'jp','ãƒ•ãƒ­ãƒ³ãƒˆ ãƒšãƒ¼ã‚¸',0),(275900,7664,'pt','Primeira pÃ¡gina',0),(275901,7664,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(275902,7664,'es','PÃ¡gina Frontal',0),(275903,7664,'de','Titelseite',0),(275904,7664,'en','Front Page',0),(275905,7665,'is','',0),(275906,7665,'dr','Ø·Ø¨Ù‚ Ø³Ø¨Ø¯ Ø®Ø±ÙŠØ¯',0),(275907,7665,'pr','Ø·Ø¨Ù‚ Ø³Ø¨Ø¯ Ø®Ø±ÙŠØ¯',0),(275908,7665,'tr','AlÄ±ÅŸveriÅŸ sepeti Ã¼zerine',0),(275909,7665,'pl','Na koszyk',0),(275910,7665,'bg','ÐÐ° ÐºÐ¾Ð»Ð¸Ñ‡ÐºÐ°Ñ‚Ð°',0),(275911,7665,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ù¾Ø±',0),(275912,7665,'sr','ÐÐ° Ð¡Ñ…Ð¾Ð¿Ð¿Ð¸Ð½Ð³ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(275913,7665,'vi','TrÃªn Giá» HÃ ng',0),(275914,7665,'af','Op Shopping Cart',0),(275915,7665,'ro','Pe coÅŸul de cumpÄƒrÄƒturi',0),(275916,7665,'et','Shopping ostukorvi',0),(275917,7665,'si','Na nakupovalni voziÄek',0),(275918,7665,'ba','Pada keranjang belanja',0),(275919,7665,'nl','Op uw winkelwagen',0),(275920,7665,'fi','Ostoskoriin',0),(275921,7665,'no','PÃ¥ handlekurven',0),(275922,7665,'da','PÃ¥ indkÃ¸bskurv',0),(275923,7665,'ko','ìž¥ë°”êµ¬ë‹ˆì—',0),(275924,7665,'he','×¢×œ ×¢×’×œ×ª ×§× ×™×•×ª',0),(275925,7665,'el','Î£Ï„Î¿ ÎºÎ±Î»Î¬Î¸Î¹ Î±Î³Î¿ÏÏŽÎ½',0),(275926,7665,'zh','åœ¨è´­ç‰©è½¦\r\n',0),(275927,7665,'sv','PÃ¥ kundvagn',0),(275928,7665,'it','Sul carrello',0),(275929,7665,'tl','',0),(275930,7665,'th','&#3610;&#3609;&#3619;&#3606;&#3648;&#3586;&#3655;&#3609;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(275931,7665,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤ªà¤°',0),(275932,7665,'ms','Di Shopping Cart',0),(275933,7665,'ar','ÙÙŠ Ø³Ù„Ø© Ø§Ù„ØªØ³ÙˆÙ‚',0),(275934,7665,'fr','Le panier d\'achat',0),(275935,7665,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚° ã‚«ãƒ¼ãƒˆã«',0),(275936,7665,'pt','No carrinho de compras',0),(275937,7665,'ru','Ð’ ÐºÐ¾Ñ€Ð·Ð¸Ð½Ñƒ',0),(275938,7665,'es','En el Carrito de Compras',0),(275939,7665,'de','Auf Warenkorb',0),(275940,7665,'en','On Shopping Cart',0),(275941,7666,'is','',0),(275942,7666,'dr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ø³Ø·Ø­ ',0),(275943,7666,'pr','Ù‚ÙŠÙ…Øª Ø¯Ø± Ø³Ø·Ø­ ',0),(275944,7666,'tr','FiyatÄ± dÃ¼zeyinde',0),(275945,7666,'pl','Cena na poziomie',0),(275946,7666,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° Ð½Ð¸Ð²Ð¾',0),(275947,7666,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­ Ù¾Ø±',0),(275948,7666,'sr','Ð¦ÐµÐ½Ð° Ð½Ð° Ð½Ð¸Ð²Ð¾Ñƒ',0),(275949,7666,'vi','GiÃ¡ theo má»©c Ä‘á»™',0),(275950,7666,'af','Prys op vlak',0),(275951,7666,'ro','Pret de la nivel',0),(275952,7666,'et','Hinnad',0),(275953,7666,'si','Cena na ravni',0),(275954,7666,'ba','Harga pada tingkat',0),(275955,7666,'nl','Prijs op niveau',0),(275956,7666,'fi','Veloittama hinta',0),(275957,7666,'no','Prisen pÃ¥ nivÃ¥',0),(275958,7666,'da','Pris pÃ¥ niveau',0),(275959,7666,'ko','ê°€ê²© ìˆ˜ì¤€',0),(275960,7666,'he','×ž×—×™×¨ ×‘×¨×ž×”',0),(275961,7666,'el','Î¤Î¹Î¼Î® ÏƒÎµ ÎµÏ€Î¯Ï€ÎµÎ´Î¿',0),(275962,7666,'zh','ä»·æ ¼åœ¨çº§åˆ«\r\n',0),(275963,7666,'sv','-Priset',0),(275964,7666,'it','Prezzo a livello',0),(275965,7666,'tl','',0),(275966,7666,'th','&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3619;&#3632;&#3604;&#3633;&#3610;',0),(275967,7666,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤ªà¤°',0),(275968,7666,'ms','Harga di peringkat',0),(275969,7666,'ar','Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ÙÙŠ Ù…Ø³ØªÙˆÙ‰',0),(275970,7666,'fr','Prix au niveau',0),(275971,7666,'jp','ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«',0),(275972,7666,'pt','PreÃ§o a nÃ­vel',0),(275973,7666,'ru','Ð¦ÐµÐ½Ð° Ð½Ð° ÑƒÑ€Ð¾Ð²Ð½Ðµ',0),(275974,7666,'es','Precio A Nivel',0),(275975,7666,'de','Preis auf Ebene',0),(275976,7666,'en','Price At Level',0),(275977,7667,'is','',0),(275978,7667,'dr','Ø¹Ù„Ø§Ù…Øª Ø¬Ø¯Ø§ÙƒÙ†Ù†Ø¯Ù‡ Ù…ØªÙ†',0),(275979,7667,'pr','Ø¹Ù„Ø§Ù…Øª Ø¬Ø¯Ø§ÙƒÙ†Ù†Ø¯Ù‡ Ù…ØªÙ†',0),(275980,7667,'tr','Metin ayÄ±rÄ±cÄ±',0),(275981,7667,'pl','Tekst ogranicznika',0),(275982,7667,'bg','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ» Ð½Ð° Ñ‚ÐµÐºÑÑ‚',0),(275983,7667,'ur','Ù…ØªÙ† ØªØ­Ø¯ÛŒØ¯ Ú©Ø§Ø±',0),(275984,7667,'sr','Ð—Ð½Ð°Ðº Ñ€Ð°Ð·Ð³Ñ€Ð°Ð½Ð¸Ñ‡Ð°Ð²Ð°ÑšÐ° Ñ‚ÐµÐºÑÑ‚Ð°',0),(275985,7667,'vi','Dáº¥u cÃ¡ch VÄƒn báº£n',0),(275986,7667,'af','Teks Delimiter',0),(275987,7667,'ro','Delimitatorul de text',0),(275988,7667,'et','Teksti eraldaja/piirimÃ¤rk',0),(275989,7667,'si','LoÄilo besedila',0),(275990,7667,'ba','Pembatas teks',0),(275991,7667,'nl','Tekstscheidingsteken',0),(275992,7667,'fi','Tekstierotin',0),(275993,7667,'no','Tekstskilletegn',0),(275994,7667,'da','TekstafgrÃ¦nseren',0),(275995,7667,'ko','í…ìŠ¤íŠ¸ êµ¬ë¶„ ê¸°í˜¸',0),(275996,7667,'he','×ž×¤×¨×™×“ ×”×˜×§×¡×˜',0),(275997,7667,'el','ÎŸÏÎ¹Î¿Î¸Î­Ï„Î·Ï‚ ÎºÎµÎ¹Î¼Î­Î½Î¿Ï…',0),(275998,7667,'zh','æ–‡æœ¬åˆ†éš”ç¬¦\r\n',0),(275999,7667,'sv','Text avgrÃ¤nsare',0),(276000,7667,'it','Delimitatore del testo',0),(276001,7667,'tl','',0),(276002,7667,'th','&#3592;&#3635;&#3585;&#3633;&#3604;&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;:',0),(276003,7667,'hi','à¤ªà¤¾à¤  à¤¸à¥€à¤®à¤¾à¤‚à¤•à¤•',0),(276004,7667,'ms','Delimiter teks',0),(276005,7667,'ar','Ù…Ø­Ø¯Ù‘Ø¯ Ø§Ù„Ù†Ù‘Øµ',0),(276006,7667,'fr','DÃ©limiteur de texte',0),(276007,7667,'jp','ãƒ†ã‚­ã‚¹ãƒˆã®åŒºåˆ‡ã‚Šè¨˜å·',0),(276008,7667,'pt','Delimitador de texto',0),(276009,7667,'ru','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑŒ Ñ‚ÐµÐºÑÑ‚Ð°',0),(276010,7667,'es','Delimitador de Textos',0),(276011,7667,'de','Texttrennzeichen',0),(276012,7667,'en','Text Delimiter',0),(276013,7668,'is','',0),(276014,7668,'dr','Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„ ÙŠØ§ Ø´Ù…Ø§Ø±Ù‡ Ø´Ø§Ø¨Ùƒ',0),(276015,7668,'pr','Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„ ÙŠØ§ Ø´Ù…Ø§Ø±Ù‡ Ø´Ø§Ø¨Ùƒ',0),(276016,7668,'tr','UPC kodu veya ISBN numarasÄ±',0),(276017,7668,'pl','Kod UPC lub numer ISBN',0),(276018,7668,'bg','ÐšÐ¾Ð´ UPC Ð¸Ð»Ð¸ ISBN Ð½Ð¾Ð¼ÐµÑ€',0),(276019,7668,'ur','UPC Ú©ÙˆÚˆ ÛŒØ§ Ù¹ÛŒÙ„ÛŒ Ù†Ù…Ø¨Ø±',0),(276020,7668,'sr','Ð£ÐŸÐ¦ ÐºÐ¾Ð´Ð° Ð¸Ð»Ð¸ Ð˜Ð¡Ð‘Ð Ð±Ñ€Ð¾Ñ˜',0),(276021,7668,'vi','MÃ£ UPC hay Sá»‘ ISBN',0),(276022,7668,'af','UPC kode of ISBN nommer',0),(276023,7668,'ro','UPC cod sau numÄƒr de ISBN',0),(276024,7668,'et','UPC koodi vÃµi ISBN-kood',0),(276025,7668,'si','UPC kodo ali kodo ISBN',0),(276026,7668,'ba','Kode UPC atau nomor ISBN',0),(276027,7668,'nl','UPC Code of ISBN-nummer',0),(276028,7668,'fi','UPC koodi tai ISBN-numero',0),(276029,7668,'no','UPC koden eller ISBN-nummer',0),(276030,7668,'da','UPC-kode eller ISBN-nummer',0),(276031,7668,'ko','UPC ì½”ë“œ ë˜ëŠ” ISBN ë²ˆí˜¸',0),(276032,7668,'he','UPC ×§×•×“ ××• ×ž×¡×¤×¨ ISBN',0),(276033,7668,'el','UPC ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Î® Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ISBN',0),(276034,7668,'zh','é€šç”¨äº§å“ä»£ç ç æˆ–ISBNå·ç \r\n',0),(276035,7668,'sv','UPC-kod eller ISBN-nummer',0),(276036,7668,'it','Codice UPC o numero ISBN',0),(276037,7668,'tl','',0),(276038,7668,'th','&#3619;&#3627;&#3633;&#3626; UPC &#3627;&#3619;&#3639;&#3629; &#3619;&#3627;&#3633;&#3626; ISBN',0),(276039,7668,'hi','UPC à¤•à¥‹à¤¡ à¤¯à¤¾ ISBN à¤¨à¤‚à¤¬à¤°',0),(276040,7668,'ms','Kod UPC atau nombor ISBN',0),(276041,7668,'ar','Ù‚Ø§Ù†ÙˆÙ† Ø§ØªØ­Ø§Ø¯ Ø§Ù„ÙˆØ·Ù†ÙŠÙŠÙ† Ø§Ù„ÙƒÙˆÙ†ØºÙˆÙ„ÙŠÙŠÙ† Ø£Ùˆ Ø±Ù‚Ù… ISBN',0),(276042,7668,'fr','Code UPC ou le numÃ©ro ISBN',0),(276043,7668,'jp','ISBN ç•ªå·ã¾ãŸã¯ UPC ã‚³ãƒ¼ãƒ‰',0),(276044,7668,'pt','CÃ³digo UPC ou nÃºmero ISBN',0),(276045,7668,'ru','Ð¡ÐšÐŸ ÐºÐ¾Ð´ Ð¸Ð»Ð¸ Ð½Ð¾Ð¼ÐµÑ€ ISBN',0),(276046,7668,'es','CÃ³digo UPC o NÃºmero ISBN',0),(276047,7668,'de','UPC-Code oder ISBN-Nummer',0),(276048,7668,'en','UPC Code or ISBN Number',0),(276049,7669,'is','',0),(276050,7669,'dr','UPC or ISBN  Ú©ÙˆØ¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„ Ø´Ø§Ø¨Ùƒ',0),(276051,7669,'pr','UPC or ISBN  Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„ Ø´Ø§Ø¨Ùƒ',0),(276052,7669,'tr','UPC veya ISBN',0),(276053,7669,'pl','UPC lub ISBN',0),(276054,7669,'bg','UPC Ð¸Ð»Ð¸ ISBN',0),(276055,7669,'ur','UPC ÛŒØ§ Ù¹ÛŒÙ„ÛŒ',0),(276056,7669,'sr','Ð£ÐŸÐ¦ Ð¸Ð»Ð¸ Ð˜Ð¡Ð‘Ð',0),(276057,7669,'vi','UPC hay ISBN',0),(276058,7669,'af','UPC of ISBN',0),(276059,7669,'ro','UPC sau ISBN',0),(276060,7669,'et','UPC vÃµi ISBN',0),(276061,7669,'si','UPC ali ISBN',0),(276062,7669,'ba','UPC atau ISBN',0),(276063,7669,'nl','UPC of ISBN',0),(276064,7669,'fi','UPC- tai ISBN',0),(276065,7669,'no','UPC eller ISBN',0),(276066,7669,'da','UPC eller ISBN',0),(276067,7669,'ko','ISBN ë˜ëŠ” UPC',0),(276068,7669,'he','UPC ××• ISBN',0),(276069,7669,'el','UPC Î® ISBN',0),(276070,7669,'zh','é€šç”¨äº§å“ä»£ç æˆ–ISBNå·\r\n',0),(276071,7669,'sv','UPC eller ISBN',0),(276072,7669,'it','UPC o ISBN',0),(276073,7669,'tl','',0),(276074,7669,'th','UPC &#3627;&#3619;&#3639;&#3629; ISBN',0),(276075,7669,'hi','UPC à¤¯à¤¾ ISBN',0),(276076,7669,'ms','UPC atau ISBN',0),(276077,7669,'ar','Ø§ØªØ­Ø§Ø¯ Ø§Ù„ÙˆØ·Ù†ÙŠÙŠÙ† Ø§Ù„ÙƒÙˆÙ†ØºÙˆÙ„ÙŠÙŠÙ† Ø£Ùˆ ISBN',0),(276078,7669,'fr','UPC ou ISBN',0),(276079,7669,'jp','UPC ã¾ãŸã¯ ISBN',0),(276080,7669,'pt','UPC ou ISBN',0),(276081,7669,'ru','Ð¡ÐšÐŸ Ð¸Ð»Ð¸ ISBN',0),(276082,7669,'es','UPC o ISBN',0),(276083,7669,'de','UPC oder ISBN',0),(276084,7669,'en','UPC or ISBN',0),(276085,7670,'is','',0),(276086,7670,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(276087,7670,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(276088,7670,'tr','Inv kategorilerini iÃ§e aktarmak',0),(276089,7670,'pl','Importowanie kategorii Inv',0),(276090,7670,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ð² ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(276091,7670,'ur','Ø§Ù†Ùˆ Ø²Ù…Ø±Û Ø¬Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(276092,7670,'sr','Ð£Ð²Ð¾Ð· Ð˜Ð½Ð² ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(276093,7670,'vi','Nháº­p CÃ¡c Thá»ƒ Loáº¡i HÃ ng HÃ³a',0),(276094,7670,'af','Invoer van Fakt. KategoriÃ«',0),(276095,7670,'ro','Categorii de Inv import',0),(276096,7670,'et','Impordi inventuuri kategooriad',0),(276097,7670,'si','Uvoz kategorije Inv',0),(276098,7670,'ba','Impor Kategori Inventori',0),(276099,7670,'nl','Inv CategorieÃ«n importeren',0),(276100,7670,'fi','Tuo Inv Luokat',0),(276101,7670,'no','Importere Inv kategorier',0),(276102,7670,'da','Importere Inv kategorier',0),(276103,7670,'ko','ê°€ì ¸ì˜¤ê¸° Inv ì¹´í…Œê³ ë¦¬',0),(276104,7670,'he','×™×™×‘×•× Inv ×§×˜×’×•×¨×™×•×ª',0),(276105,7670,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Inv ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(276106,7670,'zh','å¯¼å…¥å‘ç¥¨åˆ†ç±»\r\n',0),(276107,7670,'sv','Importera Inv kategorier',0),(276108,7670,'it','Importare categorie Inv',0),(276109,7670,'tl','',0),(276110,7670,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(276111,7670,'hi','à¤†à¤¯à¤¾à¤¤ Inv à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(276112,7670,'ms','Import kategori songsang',0),(276113,7670,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(276114,7670,'fr','Importer des catÃ©gories Inv',0),(276115,7670,'jp','Inv ã®ã‚«ãƒ†ã‚´ãƒªã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(276116,7670,'pt','Importar categorias Inv',0),(276117,7670,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ Inv',0),(276118,7670,'es','Importar CategorÃ­as de Inventario',0),(276119,7670,'de','Import-Inv-Kategorien',0),(276120,7670,'en','Import Inv Categories',0),(276121,7671,'is','',0),(276122,7671,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø§Ø² ÙØ§ÙŠÙ„',0),(276123,7671,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø§Ø² ÙØ§ÙŠÙ„',0),(276124,7671,'tr','Stok Kategoriler dosyasÄ±ndan alma',0),(276125,7671,'pl','Importowanie zapasÃ³w kategorii z pliku',0),(276126,7671,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¾Ñ‚ Ñ„Ð°Ð¹Ð»',0),(276127,7671,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ù‚Ø³Ø§Ù… Ù…Ø³Ù„ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(276128,7671,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð£Ð²ÐµÐ·Ð¸ Ð¸Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(276129,7671,'vi','Nháº­p CÃ¡c Thá»ƒ Loáº¡i HÃ ng HÃ³a Tá»« Há»“ SÆ¡ ',0),(276130,7671,'af','Invoer van Voorraad KategoriÃ« Vanaf LÃªer',0),(276131,7671,'ro','Categorii de inventar de import din fiÅŸier',0),(276132,7671,'et','Varude kategooriate importimine faili',0),(276133,7671,'si','Zaloge kategorije uvoz iz datoteke',0),(276134,7671,'ba','Impor Kategori Inventori dari file',0),(276135,7671,'nl','Inventaris CategorieÃ«n importeren uit bestand',0),(276136,7671,'fi','Tuo varaston luokat tiedostosta',0),(276137,7671,'no','Importere lager kategorier fra fil',0),(276138,7671,'da','Import lageret kategorier fra fil',0),(276139,7671,'ko','íŒŒì¼ì—ì„œ ê°€ì ¸ì˜¤ê¸° ì¸ë²¤í† ë¦¬ ì¹´í…Œê³ ë¦¬',0),(276140,7671,'he','×™×‘× ×§×˜×’×•×¨×™×•×ª ×ž×œ××™ ×ž×§×•×‘×¥',0),(276141,7671,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€ÏŒ Î±ÏÏ‡ÎµÎ¯Î¿',0),(276142,7671,'zh','ä»Žæ–‡ä»¶ä¸­å¯¼å…¥å­˜è´§åˆ†ç±»\r\n',0),(276143,7671,'sv','Importera lager kategorier frÃ¥n fil',0),(276144,7671,'it','Categorie di inventario di importazione da File',0),(276145,7671,'tl','',0),(276146,7671,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3652;&#3615;&#3621;&#3660;',0),(276147,7671,'hi','à¤¸à¥‚à¤šà¥€ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤¸à¥‡ à¤«à¤¼à¤¾à¤‡à¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(276148,7671,'ms','Kategori inventori import dari fail',0),(276149,7671,'ar','ÙØ¦Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù† Ù…Ù„Ù',0),(276150,7671,'fr','Importer des catÃ©gories de l\'inventaire de fichier',0),(276151,7671,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®ã‚«ãƒ†ã‚´ãƒªã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(276152,7671,'pt','Categorias de inventÃ¡rio de importaÃ§Ã£o de arquivo',0),(276153,7671,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¸Ð· Ñ„Ð°Ð¹Ð»Ð°',0),(276154,7671,'es','Importar Archivo de CategorÃ­as de Inventario',0),(276155,7671,'de','Inventar-Kategorien aus Datei importieren',0),(276156,7671,'en','Import Inventory Categories From File',0),(276157,7672,'is','',0),(276158,7672,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ø¹Ø¨Ù‡ Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± ÙƒØ±Ø¯Ù† Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø¬Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ø¬Ø§Ø±ÙŠ',0),(276159,7672,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ø¹Ø¨Ù‡ Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± ÙƒØ±Ø¯Ù† Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø¬Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ø¬Ø§Ø±ÙŠ',0),(276160,7672,'tr','SipariÅŸ tarihi yerine geÃ§erli tarihi kullanarak fatura iÃ§in bu kutuyu iÅŸaretleyin.',0),(276161,7672,'pl','To pole wyboru, aby faktury za pomocÄ… Data zamÃ³wienia a nie Data bieÅ¼Ä…ca',0),(276162,7672,'bg','Ð¢Ð¾Ð²Ð° ÐºÐ²Ð°Ð´Ñ€Ð°Ñ‚Ñ‡Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð´Ð°Ñ‚Ð°, Ð° Ð½Ðµ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(276163,7672,'ur','ØªØ±ØªÛŒØ¨ ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø¨Ø¬Ø§Ø¦Û’ Ù…ÙˆØ¬ÙˆØ¯Û ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ Ø®Ø§Ù†Û Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(276164,7672,'sr','ÐžÐ²Ð¾ Ð¿Ð¾Ñ™Ðµ Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ðµ Ð½ÐµÐ³Ð¾ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(276165,7672,'vi','ÄÃ¡nh dáº¥u vÃ o há»™p nÃ y Ä‘á»ƒ sá»­ dá»¥ng ngÃ y Ä‘áº·t hÃ ng trÃªn hÃ³a Ä‘Æ¡n thay ngÃ y hiá»‡n táº¡i',0),(276166,7672,'af','Merk Hierdie Boks om Besteldatum eerder As Huidige Datum te gebruik vir Fakturering',0),(276167,7672,'ro','AceastÄƒ casetÄƒ de selectare pentru facturÄƒ utilizÃ¢nd comanda data, mai degrabÄƒ decÃ¢t data curentÄƒ',0),(276168,7672,'et','See ruut abil tellimuse kuupÃ¤ev, mitte tÃ¤nane kuupÃ¤ev',0),(276169,7672,'si','To polje, Äe Å¾elite raÄun z uporabo datum namesto trenutni datum naloga',0),(276170,7672,'ba','Centang kotak ini untuk faktur menggunakan urutan tanggal daripada saat ini tanggal',0),(276171,7672,'nl','Dit selectievakje te factureren met volgorde datum eerder dan huidige datum',0),(276172,7672,'fi','TÃ¤mÃ¤ valintaruutu lasku uudelleen tilauksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ kuin nykyinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(276173,7672,'no','Merk denne fakturaen for dato enn gjeldende dato',0),(276174,7672,'da','Dette afkrydsningsfelt til faktura ved hjÃ¦lp af ordre dato snarere end dags dato',0),(276175,7672,'ko','ì£¼ë¬¸ ë‚ ì§œ ëŒ€ì‹  í˜„ìž¬ ë‚ ì§œë¥¼ ì‚¬ìš© í•˜ ì—¬ ì†¡ìž¥ í™•ì¸ì´ ìƒìž',0),(276176,7672,'he','×¡×ž×Ÿ ×ª×™×‘×” ×–×• ×›×“×™ ×—×©×‘×•× ×™×ª ×‘××ž×¦×¢×•×ª ×¡×“×¨ ×ª××¨×™×š ×•×œ× ×”×ª××¨×™×š ×”× ×•×›×—×™',0),(276177,7672,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎºÎ±Î¹ ÏŒÏ‡Î¹ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(276178,7672,'zh','é€‰ä¸­æ­¤å¤é€‰æ¡†æ¯”ç›®å‰ä½¿ç”¨çš„å‘ç¥¨æ—¥æœŸé¡ºåºç›¸åæ—¥æœŸ\r\n',0),(276179,7672,'sv','Denna kryssruta fÃ¶r att fakturan med Order datum i stÃ¤llet fÃ¶r dagens datum',0),(276180,7672,'it','Questa casella di controllo per fattura utilizzando Data ordine piuttosto che data corrente',0),(276181,7672,'tl','',0),(276182,7672,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3594;&#3656;&#3629;&#3591;&#3609;&#3637;&#3657;&#3592;&#3632;&#3651;&#3594;&#3657;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3633;&#3656;&#3',0),(276183,7672,'hi','à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤¬à¤œà¤¾à¤¯ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤•à¥‡ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥‹ à¤šà¥‡à¤• à¤•à¤°à¥‡à¤‚',0),(276184,7672,'ms','Kotak semak ini untuk invois menggunakan tarikh dan bukannya semasa tarikh perintah',0),(276185,7672,'ar','Ø®Ø§Ù†Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù‡Ø°Ù‡ Ù„Ù„ÙØ§ØªÙˆØ±Ø© Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… \"ØªØ§Ø±ÙŠØ® Ø§Ù„Ù†Ø¸Ø§Ù… Ø¨Ø¯Ù„Ø§Ù‹ Ù…Ù† Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø§Ù„ÙŠ\"',0),(276186,7672,'fr','Cette case Ã  cocher Ã  facturer Ã  l\'aide de la Date de commande plutÃ´t que Date actuelle',0),(276187,7672,'jp','é †åºã®æ—¥ä»˜ã‚ˆã‚Šã‚‚ã‚€ã—ã‚ç¾åœ¨ã®æ—¥ä»˜ã‚’ä½¿ç”¨ã—ã¦è«‹æ±‚æ›¸ã«ã“ã®ãƒœãƒƒã‚¯ã‚¹ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(276188,7672,'pt','Esta caixa de seleÃ§Ã£o para fatura usando a ordem de data em vez de data atual',0),(276189,7672,'ru','Ð­Ñ‚Ð¾Ñ‚ Ñ„Ð»Ð°Ð¶Ð¾Ðº, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÑ‡ÐµÑ‚Ð°, Ð”Ð°Ñ‚Ð° Ð·Ð°ÐºÐ°Ð·Ð°, Ð° Ð½Ðµ Ñ‚ÐµÐºÑƒÑ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹',0),(276190,7672,'es','Checar Este Caja de Factura usando la Fecha de Pedido en Lugar de la Fecha Actual',0),(276191,7672,'de','Dieses KontrollkÃ¤stchen, um Rechnung mit Datum anstatt aktuellen Bestelldatum',0),(276192,7672,'en','Check This Box to Invoice using Order Date Rather Than Current Date',0),(276193,7673,'is','',0),(276194,7673,'dr','Ø´Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(276195,7673,'pr','Ø´Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(276196,7673,'tr','Ã–deme aÃ§Ä±klamasÄ±',0),(276197,7673,'pl','Opis pÅ‚atnoÅ›ci',0),(276198,7673,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(276199,7673,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(276200,7673,'sr','ÐžÐ¿Ð¸Ñ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(276201,7673,'vi','MÃ´ táº£ thanh toÃ¡n ',0),(276202,7673,'af','Betalingsbeskrywing',0),(276203,7673,'ro','Plata Descriere',0),(276204,7673,'et','Makse kirjeldus',0),(276205,7673,'si','PlaÄilo opis',0),(276206,7673,'ba','Deskripsi pembayaran',0),(276207,7673,'nl','Beschrijving van de betaling',0),(276208,7673,'fi','Maksun kuvaus',0),(276209,7673,'no','Betaling beskrivelse',0),(276210,7673,'da','Betaling beskrivelse',0),(276211,7673,'ko','ì§€ë¶ˆ ì„¤ëª…',0),(276212,7673,'he','×ª××•×¨ ×ª×©×œ×•×',0),(276213,7673,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(276214,7673,'zh','ä»˜æ¬¾è¯´æ˜Ž\r\n',0),(276215,7673,'sv','Betalning Beskrivning',0),(276216,7673,'it','Descrizione del pagamento',0),(276217,7673,'tl','',0),(276218,7673,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(276219,7673,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤µà¤°à¤£',0),(276220,7673,'ms','Keterangan pembayaran',0),(276221,7673,'ar','ÙˆØµÙ Ø§Ù„Ø¯ÙØ¹',0),(276222,7673,'fr','Description de paiement',0),(276223,7673,'jp','æ”¯æ‰•æ¦‚è¦',0),(276224,7673,'pt','DescriÃ§Ã£o de pagamento',0),(276225,7673,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(276226,7673,'es','DescripciÃ³n de Pago',0),(276227,7673,'de','Zahlung Beschreibung',0),(276228,7673,'en','Payment Description',0),(276229,7674,'is','',0),(276230,7674,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(276231,7674,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(276232,7674,'tr','Olarak bir rapor',0),(276233,7674,'pl','Sprawozdanie na',0),(276234,7674,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´Ð²Ð° ÐºÐ°Ñ‚Ð¾ Ð¾Ñ‚',0),(276235,7674,'ur','Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø±Ù¾ÙˆØ±Ù¹',0),(276236,7674,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸ ÐºÐ°Ð¾ Ð¾Ð´',0),(276237,7674,'vi','BÃ¡o cÃ¡o cá»§a',0),(276238,7674,'af','Verslag Soos vanaf',0),(276239,7674,'ro','Un raport ca de',0),(276240,7674,'et','Aruanne seisuga',0),(276241,7674,'si','PoroÄilo kot',0),(276242,7674,'ba','Laporan seperti yang',0),(276243,7674,'nl','Verslag als van',0),(276244,7674,'fi','Raportti kuten',0),(276245,7674,'no','Rapport som',0),(276246,7674,'da','Rapport som af',0),(276247,7674,'ko','ìœ¼ë¡œ ë³´ê³ ',0),(276248,7674,'he','×”×“×• ×— ×›×ž×• ×©×œ',0),(276249,7674,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï‰Ï‚ Ï„Î·Ï‚',0),(276250,7674,'zh','æŠ¥å‘Šï¼Œä½œä¸º\r\n',0),(276251,7674,'sv','Rapport som av',0),(276252,7674,'it','Segnalare come di',0),(276253,7674,'tl','',0),(276254,7674,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; &#3603; &#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(276255,7674,'hi','à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(276256,7674,'ms','Laporan sebagai',0),(276257,7674,'ar','ØªÙ‚Ø±ÙŠØ± ÙƒÙ…Ù†',0),(276258,7674,'fr','Signaler comme des',0),(276259,7674,'jp','ã¨ã—ã¦å ±å‘Šã—ã¾ã™ã€‚',0),(276260,7674,'pt','RelatÃ³rio a partir de',0),(276261,7674,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¿Ð¾ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸ÑŽ Ð½Ð°',0),(276262,7674,'es','Reportar Desde',0),(276263,7674,'de','Als der Bericht',0),(276264,7674,'en','Report As Of',0),(276265,7675,'is','',0),(276266,7675,'dr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù†   Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ ',0),(276267,7675,'pr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù†   Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ ',0),(276268,7675,'tr','GeÃ§ersiz kÄ±lÄ±nan Ã¶deme hariÃ§',0),(276269,7675,'pl','WyÅ‚Ä…czenie pÅ‚atnoÅ›ci uniewaÅ¼nione',0),(276270,7675,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð¸ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ð¸Ñ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(276271,7675,'ur','ÙˆÙˆØ§ÚˆÛŒØ¯ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(276272,7675,'sr','Ð˜Ð·ÑƒÐ·Ð¼Ð¸ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(276273,7675,'vi','KhÃ´ng bao gá»“m thanh toÃ¡n Ä‘Ã£ há»§y',0),(276274,7675,'af','Sluit Ongeldige Betalings Uit',0),(276275,7675,'ro','Exclude anulat plÄƒÅ£ile',0),(276276,7675,'et','JÃ¤ta vÃ¤lja tÃ¼histatud maksed',0),(276277,7675,'si','IzkljuÄijo razveljavljeni plaÄila',0),(276278,7675,'ba','Mengecualikan Voided pembayaran',0),(276279,7675,'nl','Vernietigde betalingen uitsluiten',0),(276280,7675,'fi','MitÃ¤tÃ¶idyt maksujen sulkemiseksi pois',0),(276281,7675,'no','Utelate annullerte betalinger',0),(276282,7675,'da','Udelukke afviste betalinger',0),(276283,7675,'ko','ê·€í•˜ì˜ ì§€ë¶ˆì„ ì œì™¸',0),(276284,7675,'he','××™-×”×›×œ×œ×ª ×ª×©×œ×•× ×©×ª×•×§×¤×Ÿ ×‘×•×˜×œ',0),(276285,7675,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¯Î¿Ï…Î½ Î±ÎºÏ…ÏÏ‰Î¼Î­Î½Î·Ï‚',0),(276286,7675,'zh','æŽ’é™¤æ— æ•ˆä»˜æ¬¾\r\n',0),(276287,7675,'sv','Utesluta annullerade betalningar',0),(276288,7675,'it','Escludere i pagamenti escreta',0),(276289,7675,'tl','',0),(276290,7675,'th','&#3652;&#3617;&#3656;&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(276291,7675,'hi','à¤…à¤ªà¤µà¤°à¥à¤œà¤¿à¤¤ Voided à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(276292,7675,'ms','Tidak termasuk bayaran Voided',0),(276293,7675,'ar','Ø§Ø³ØªØ¨Ø¹Ø§Ø¯ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ù„ØºØ§Ø©',0),(276294,7675,'fr','Exclure les paiements invalidÃ©s',0),(276295,7675,'jp','ç„¡åŠ¹ã«ã•ã‚ŒãŸæ”¯æ‰•ã„ã‚’é™¤å¤–ã—ã¾ã™ã€‚',0),(276296,7675,'pt','Excluir pagamentos anulados',0),(276297,7675,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(276298,7675,'es','Excluir Pagos Anulados',0),(276299,7675,'de','Stornierte Zahlungen ausschlieÃŸen',0),(276300,7675,'en','Exclude Voided Payments',0),(276301,7676,'is','',0),(276302,7676,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(276303,7676,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(276304,7676,'tr','SipariÅŸ mevduat',0),(276305,7676,'pl','ZÅ‚Ã³Å¼ zamÃ³wienie',0),(276306,7676,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(276307,7676,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ø°Ø®Ø§Ø¦Ø±',0),(276308,7676,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ðµ',0),(276309,7676,'vi','Äáº·t cá»c Ä‘Æ¡n hÃ ng',0),(276310,7676,'af','Bestelling Deposito\'s',0),(276311,7676,'ro','Ordinul depozite',0),(276312,7676,'et','Korra hoiuseid',0),(276313,7676,'si','Vrstni red vlog',0),(276314,7676,'ba','Urutan deposito',0),(276315,7676,'nl','Volgorde deposito \'s',0),(276316,7676,'fi','Jotta talletukset',0),(276317,7676,'no','For innskudd',0),(276318,7676,'da','Bestil indskud',0),(276319,7676,'ko','ì£¼ë¬¸ ìž…ê¸ˆ',0),(276320,7676,'he','×¡×“×¨ ×¤×™×§×“×•× ×•×ª',0),(276321,7676,'el','Î£ÎµÎ¹ÏÎ¬ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½',0),(276322,7676,'zh','è®¢å•å­˜æ¬¾\r\n',0),(276323,7676,'sv','Ordning insÃ¤ttningar',0),(276324,7676,'it','Depositi di ordine',0),(276325,7676,'tl','',0),(276326,7676,'th','&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(276327,7676,'hi','à¤•à¥à¤°à¤® à¤œà¤®à¤¾',0),(276328,7676,'ms','Deposit perintah',0),(276329,7676,'ar','ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(276330,7676,'fr','Ordre des dÃ©pÃ´ts',0),(276331,7676,'jp','é †åºã®å †ç©ç‰©',0),(276332,7676,'pt','DepÃ³sitos ordem',0),(276333,7676,'ru','Ð—Ð°ÐºÐ°Ð· Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹',0),(276334,7676,'es','DepÃ³sitos de Pedidos',0),(276335,7676,'de','Bestellung-Einlagen',0),(276336,7676,'en','Order Deposits',0),(276337,7677,'is','',0),(276338,7677,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(276339,7677,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(276340,7677,'tr','Toplam MÃ¼ÅŸteri MevduatÄ±',0),(276341,7677,'pl','Wszystkich klientÃ³w depozytÃ³w',0),(276342,7677,'bg','ÐžÐ±Ñ‰Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(276343,7677,'ur','Ú©Ù„ Ú¯Ø§ÛÚ© Ú©Û’ Ø°Ø®Ø§Ø¦Ø±',0),(276344,7677,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÐºÑƒÐ¿Ñ†Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ðµ',0),(276345,7677,'vi','Tá»•ng cá»™ng khÃ¡ch hÃ ng kÃ½ quá»¹',0),(276346,7677,'af','Totaal vir Klante/KliÃ«nte Deposito\'s',0),(276347,7677,'ro','Comentariiile clientului Total depozite',0),(276348,7677,'et','Kokku klientide hoiused',0),(276349,7677,'si','Skupaj strank vlog',0),(276350,7677,'ba','Simpanan nasabah Total',0),(276351,7677,'nl','Totaal Klantendeposito \'s',0),(276352,7677,'fi','YhteensÃ¤ Asiakkaiden talletukset',0),(276353,7677,'no','Totalt kunde innskudd',0),(276354,7677,'da','Samlede kunde indskud',0),(276355,7677,'ko','ì´ ê³ ê° ì˜ˆê¸ˆ',0),(276356,7677,'he','×¤×§×“×•× ×•×ª ×œ×§×•×—×•×ª ×‘×¡×š ×”×›×œ',0),(276357,7677,'el','Î£ÏÎ½Î¿Î»Î¿ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚',0),(276358,7677,'zh','å®¢æˆ·å­˜æ¬¾æ€»é¢\r\n',0),(276359,7677,'sv','Totala kund inlÃ¥ning',0),(276360,7677,'it','Cliente totale depositi',0),(276361,7677,'tl','',0),(276362,7677,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(276363,7677,'hi','à¤•à¥à¤² à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤®à¤¾',0),(276364,7677,'ms','Jumlah keseluruhan Deposit pelanggan',0),(276365,7677,'ar','ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ©',0),(276366,7677,'fr','DÃ©pÃ´ts de la clientÃ¨le totale',0),(276367,7677,'jp','ç·é¡§å®¢é é‡‘',0),(276368,7677,'pt','DepÃ³sitos de clientes total',0),(276369,7677,'ru','Ð’ÑÐµÐ³Ð¾ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¾Ð²',0),(276370,7677,'es','DepÃ³sitos Totales de Clientes',0),(276371,7677,'de','Total Kundengelder',0),(276372,7677,'en','Total Customer Deposits',0),(276373,7678,'is','',0),(276374,7678,'dr','(Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±) Ø±Ø§  Ø¨Ø§Ø² ÙƒÙ†ÙŠØ¯ ',0),(276375,7678,'pr','ÙÙ‚Ø· Ø§Ø¹ØªØ¨Ø§Ø± (Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±) Ø±Ø§  Ø¨Ø§Ø² ÙƒÙ†ÙŠØ¯ ',0),(276376,7678,'tr','AÃ§Ä±k kredi sadece',0),(276377,7678,'pl','Tylko otwarte kredytÃ³w',0),(276378,7678,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸ ÑÐ°Ð¼Ð¾',0),(276379,7678,'ur','Ú©Ú¾Ù„ÛŒ Ú©Ø±ÛŒÚˆÛŒÙ¹Ø³ ØµØ±Ù',0),(276380,7678,'sr','Ð¡Ð°Ð¼Ð¾ Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸ ÑˆÐ¿Ð¸Ñ†Ð°',0),(276381,7678,'vi','Chá»‰ Má»Ÿ TÃ­n Dá»¥ng',0),(276382,7678,'af','Open Krediete Alleenlik',0),(276383,7678,'ro','Creditele deschise numai',0),(276384,7678,'et','Avatud krediitide ainult',0),(276385,7678,'si','Odprte kredite le',0),(276386,7678,'ba','Buka kredit hanya',0),(276387,7678,'nl','Open kredieten alleen',0),(276388,7678,'fi','Avoimilla mÃ¤Ã¤rÃ¤rahoilla',0),(276389,7678,'no','Ã…pne kreditt bare',0),(276390,7678,'da','Ã…ben kreditter kun',0),(276391,7678,'ko','ì˜¤í”ˆ í•™ì ë§Œ',0),(276392,7678,'he','×§×¨×“×™×˜×™× ×¤×ª×•×— ×‘×œ×‘×“',0),(276393,7678,'el','Î‘Î½Î¿Î¹Ï‡Ï„Î­Ï‚ Ï€Î¹ÏƒÏ„ÏŽÏƒÎµÎ¹Ï‚ Î¼ÏŒÎ½Î¿',0),(276394,7678,'zh','åªæ‰“å¼€ä¿¡ç”¨\r\n',0),(276395,7678,'sv','Ã–ppna krediter endast',0),(276396,7678,'it','Crediti aperti solo',0),(276397,7678,'tl','',0),(276398,7678,'th','&#3648;&#3611;&#3636;&#3604;&#3626;&#3636;&#3609;&#3648;&#3594;&#3639;&#3656;&#3629;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(276399,7678,'hi','à¤–à¥à¤²à¥‡ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¥‡à¤µà¤²',0),(276400,7678,'ms','Terbuka kredit sahaja',0),(276401,7678,'ar','Ø§Ù„Ø§Ø¹ØªÙ…Ø§Ø¯Ø§Øª Ø§Ù„Ù…ÙØªÙˆØ­Ø© ÙÙ‚Ø·',0),(276402,7678,'fr','CrÃ©dits ouverts seulement',0),(276403,7678,'jp','ã‚ªãƒ¼ãƒ—ãƒ³ ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã®ã¿',0),(276404,7678,'pt','CrÃ©ditos abertos apenas',0),(276405,7678,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ñ‹',0),(276406,7678,'es','Abrir CrÃ©ditos Solo',0),(276407,7678,'de','Offene Kredite nur',0),(276408,7678,'en','Open Credits Only',0),(276409,7679,'is','',0),(276410,7679,'dr','Ø±Ø§Ú©Ø¯',0),(276411,7679,'pr','Ø±Ø§Ú©Ø¯',0),(276412,7679,'tr','Terk edilmiÅŸ',0),(276413,7679,'pl','Opuszczony',0),(276414,7679,'bg','Ð˜Ð·Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð¸',0),(276415,7679,'ur','Ø¨Ú¯Ú‘Ø§ ÛÙˆØ§',0),(276416,7679,'sr','ÐÐ°Ð¿ÑƒÑÑ‚Ð¸Ð¾',0),(276417,7679,'vi','Bá»',0),(276418,7679,'af','Agtergeblewe ',0),(276419,7679,'ro','Abandonat',0),(276420,7679,'et','HÃ¼ljatud',0),(276421,7679,'si','Opustili',0),(276422,7679,'ba','Dibatalkan',0),(276423,7679,'nl','Verlaten',0),(276424,7679,'fi','HylÃ¤tty',0),(276425,7679,'no','Forlatt',0),(276426,7679,'da','Opgivet',0),(276427,7679,'ko','í¬ê¸°',0),(276428,7679,'he','× ×˜×•×©',0),(276429,7679,'el','Î•Î³ÎºÎ±Ï„Î±Î»ÎµÎ¹Î¼Î¼Î­Î½Î¿',0),(276430,7679,'zh','å¼ƒ\r\n',0),(276431,7679,'sv','Ã–vergivna',0),(276432,7679,'it','Abbandonato',0),(276433,7679,'tl','',0),(276434,7679,'th','à¸¢à¸à¹€à¸¥à¸´à¸',0),(276435,7679,'hi','à¤¤à¥à¤¯à¤¾à¤— à¤¦à¤¿à¤¯à¤¾',0),(276436,7679,'ms','Terbengkalai',0),(276437,7679,'ar','Ø§Ù„ØªØ®Ù„ÙŠ Ø¹Ù†',0),(276438,7679,'fr','AbandonnÃ©',0),(276439,7679,'jp','æ”¾æ£„ã•ã‚Œã¾ã—ãŸã€‚',0),(276440,7679,'pt','Abandonado',0),(276441,7679,'ru','Ð‘Ñ€Ð¾ÑˆÐµÐ½Ð½Ñ‹Ðµ',0),(276442,7679,'es','Abandonado',0),(276443,7679,'de','Aufgegeben',0),(276444,7679,'en','Abandoned',0),(276445,7680,'is','',0),(276446,7680,'dr','ÙƒØ¯Ø§Ù… ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(276447,7680,'pr','ÙƒØ¯Ø§Ù… ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(276448,7680,'tr','Hangi faturalar dahil',0),(276449,7680,'pl','To co faktury',0),(276450,7680,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÐºÐ¾Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(276451,7680,'ur','Ø¬Ùˆ ÙˆØ¨Ø¬Ù„ÛŒ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(276452,7680,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÐ¾Ñ˜Ðµ',0),(276453,7680,'vi','Bao gá»“m hÃ³a Ä‘Æ¡n nÃ o',0),(276454,7680,'af','Sluit in watter Fakture',0),(276455,7680,'ro','Includ facturile care',0),(276456,7680,'et','Milliseid arveid kaasata?',0),(276457,7680,'si','VkljuÄujejo katere raÄune',0),(276458,7680,'ba','Termasuk faktur yang',0),(276459,7680,'nl','Omvatten welke facturen',0),(276460,7680,'fi','SisÃ¤llytÃ¤ mitkÃ¤ laskut',0),(276461,7680,'no','Ta med hvilke fakturaer',0),(276462,7680,'da','Indeholde hvilke fakturaer',0),(276463,7680,'ko','ì–´ë–¤ ì²­êµ¬ì„œ í¬í•¨',0),(276464,7680,'he','×›×•×œ×œ×™× ××™×œ×• ×—×©×‘×•× ×™×•×ª',0),(276465,7680,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï€Î¿Î¹Î¬ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(276466,7680,'zh','åŒ…æ‹¬å“ªäº›å‘ç¥¨\r\n',0),(276467,7680,'sv','Inkludera vilka fakturor',0),(276468,7680,'it','Comprendere quali fatture',0),(276469,7680,'tl','',0),(276470,7680,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3629;&#3633;&#3609;&#3652;&#3627;&#3609;',0),(276471,7680,'hi','à¤œà¥‹ à¤šà¤¾à¤²à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(276472,7680,'ms','Termasuklah invois yang',0),(276473,7680,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªÙŠ',0),(276474,7680,'fr','Inclure les factures',0),(276475,7680,'jp','å¯¾è±¡ã®è«‹æ±‚æ›¸ã‚’å«ã‚ã‚‹',0),(276476,7680,'pt','Incluir quais faturas',0),(276477,7680,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ ÐšÐ°ÐºÐ¸Ðµ Ð¡Ñ‡ÐµÑ‚Ð°',0),(276478,7680,'es','Incluir Cuales Facturas',0),(276479,7680,'de','Welche Rechnungen sind',0),(276480,7680,'en','Include Which Invoices',0),(276481,7681,'is','',0),(276482,7681,'dr','(Ø±Ù‡Ø§ Ø´Ø¯Ù‡) ÙŠØ§ ÙƒØ§Ù…Ù„ Ù†Ø´Ø¯Ù‡ ',0),(276483,7681,'pr','Ù†Ù…Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø±Ø¯ Ø´Ø¯Ù‡(Ø±Ù‡Ø§ Ø´Ø¯Ù‡) ÙŠØ§ ÙƒØ§Ù…Ù„ Ù†Ø´Ø¯Ù‡ ',0),(276484,7681,'tr','Sadece terk edilmiÅŸ, eksik fatura gÃ¶ster',0),(276485,7681,'pl','PokaÅ¼ tylko porzucony, faktury niekompletny',0),(276486,7681,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¸Ð·Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð¸, Ð½ÐµÐ¿ÑŠÐ»Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(276487,7681,'ur','ØµØ±Ù Ù…ØªØ±ÙˆÚ©ØŒ Ù†Ø§Ù…Ú©Ù…Ù„ ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(276488,7681,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°, Ð½ÐµÐ¿Ð¾Ñ‚Ð¿ÑƒÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(276489,7681,'vi','Chá»‰ Hiá»ƒn thá»‹ hÃ³a Ä‘Æ¡n bá», chÆ°a hoÃ n thÃ nh',0),(276490,7681,'af','Wys Alleenlik Agtergeblewe, Onvoltooide Fakture',0),(276491,7681,'ro','AratÄƒ numai abandonat, incomplet facturi',0),(276492,7681,'et','NÃ¤ita ainult hÃ¼ljatud, lÃµpetamata arveid',0),(276493,7681,'si','PrikaÅ¾i samo prepustita nepopolne raÄune',0),(276494,7681,'ba','Tampilkan hanya ditinggalkan, faktur tidak lengkap',0),(276495,7681,'nl','Toon alleen verlaten, onvolledige facturen',0),(276496,7681,'fi','NÃ¤ytÃ¤ vain hylÃ¤tÃ¤Ã¤n epÃ¤tÃ¤ydellinen laskut',0),(276497,7681,'no','Vis bare forlatt, ufullstendig fakturaer',0),(276498,7681,'da','Vis kun opgivet, ufuldstÃ¦ndige fakturaer',0),(276499,7681,'ko','í‘œì‹œë§Œ í¬ê¸° í•˜ ê³ , ë¶ˆì™„ì „ í•œ ì†¡ìž¥',0),(276500,7681,'he','×”×¦×’ ×¨×§ × ×˜×•×©, ×—×©×‘×•× ×™×•×ª ×œ× ×©×œ×',0),(276501,7681,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î±Ï€Î»ÏŽÏ‚ ÎµÎ³ÎºÎ±Ï„Î±Î»ÎµÎ¯Ï€ÎµÏ„Î±Î¹, ÎµÎ»Î»Î¹Ï€Î®Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(276502,7681,'zh','ä»…æ˜¾ç¤ºåºŸå¼ƒé¡¹ï¼Œä¸å®Œå…¨å‘ç¥¨\r\n',0),(276503,7681,'sv','Visa endast Ã¶vergivna, ofullstÃ¤ndiga fakturor',0),(276504,7681,'it','Visualizza solo abbandonata, fatture Incomplete',0),(276505,7681,'tl','',0),(276506,7681,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3585;&#3634;&#3619;&#3621;&#3632;&#3607;&#3636;&#3657;&#3591;,&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3652;&#3617;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#',0),(276507,7681,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤ à¤•à¥‡à¤µà¤² à¤¤à¥à¤¯à¤¾à¤— à¤¦à¤¿à¤¯à¤¾, à¤…à¤§à¥‚à¤°à¥€ à¤šà¤¾à¤²à¤¾à¤¨',0),(276508,7681,'ms','Menunjukkan invois yang hanya terbiar, tidak lengkap',0),(276509,7681,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙÙˆØ§ØªÙŠØ± ÙÙ‚Ø· Ø§Ù„Ù…Ù‡Ø¬ÙˆØ±Ø©ØŒ ØºÙŠØ± Ù…ÙƒØªÙ…Ù„',0),(276510,7681,'fr','Afficher uniquement les factures abandonnÃ©s, incomplets',0),(276511,7681,'jp','æ”¾æ£„ã•ã‚ŒãŸã€ä¸å®Œå…¨ãªè«‹æ±‚æ›¸ã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(276512,7681,'pt','Mostrar apenas abandonado, facturas incompletas',0),(276513,7681,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð±Ñ€Ð¾ÑˆÐµÐ½Ð½Ñ‹Ñ…, Ð½ÐµÐ¿Ð¾Ð»Ð½Ð¾Ð¹ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(276514,7681,'es','Mostrar Solo Facturas Abandonadas, Incompletas',0),(276515,7681,'de','Karte nur aufgegeben, unvollstÃ¤ndige Rechnungen',0),(276516,7681,'en','Show Only Abandoned, Incomplete Invoices',0),(276517,7682,'is','',0),(276518,7682,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(276519,7682,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(276520,7682,'tr','GÃ¶steri sadece faturalar silindi',0),(276521,7682,'pl','PokaÅ¼ usuniÄ™te tylko faktury',0),(276522,7682,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(276523,7682,'ur','ØµØ±Ù Ø­Ø°Ù Ø´Ø¯Û ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(276524,7682,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(276525,7682,'vi','Chá»‰ Hiá»ƒn thá»‹ hÃ³a Ä‘Æ¡n há»§y',0),(276526,7682,'af','Wys Alleenlik Geskrapte Fakture',0),(276527,7682,'ro','AratÄƒ doar ÅŸterge facturi',0),(276528,7682,'et','NÃ¤ita ainult kustutatud arveid',0),(276529,7682,'si','PokaÅ¾i samo izbrisanih raÄunov',0),(276530,7682,'ba','Tampilkan hanya dihapus faktur',0),(276531,7682,'nl','Toon alleen verwijderde facturen',0),(276532,7682,'fi','NÃ¤ytÃ¤ poistaa vain laskujen',0),(276533,7682,'no','Vis bare slettet fakturaer',0),(276534,7682,'da','Vis kun slettet fakturaer',0),(276535,7682,'ko','í‘œì‹œë§Œ ì‚­ì œ ì²­êµ¬ì„œ',0),(276536,7682,'he','×”×¦×’ ×¨×§ ×œ×ž×—×•×§ ×—×©×‘×•× ×™×•×ª',0),(276537,7682,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ Î½Î± Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(276538,7682,'zh','ä»…æ˜¾ç¤ºåˆ é™¤çš„å‘ç¥¨\r\n',0),(276539,7682,'sv','Visa bara bort fakturor',0),(276540,7682,'it','Visualizza solo eliminato le fatture',0),(276541,7682,'tl','',0),(276542,7682,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(276543,7682,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤ à¤•à¥‡à¤µà¤² à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(276544,7682,'ms','Menunjukkan hanya dihapuskan invois',0),(276545,7682,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© ÙÙ‚Ø·',0),(276546,7682,'fr','Afficher uniquement les factures supprimÃ©s',0),(276547,7682,'jp','å‰Šé™¤ã•ã‚ŒãŸè«‹æ±‚æ›¸ã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(276548,7682,'pt','Mostrar apenas excluÃ­do facturas',0),(276549,7682,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð£Ð´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð¡Ñ‡ÐµÑ‚Ð°',0),(276550,7682,'es','Mostrar solo Facturas Eliminadas',0),(276551,7682,'de','Karte gelÃ¶scht nur Rechnungen',0),(276552,7682,'en','Show Only Deleted Invoices',0),(276553,7683,'is','',0),(276554,7683,'dr','(ØªØ°ÙƒØ±Ø§Øª ) Ø¯Ø§Ø®Ù„ÙŠ ',0),(276555,7683,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§(ØªØ°ÙƒØ±Ø§Øª ) Ø¯Ø§Ø®Ù„ÙŠ ',0),(276556,7683,'tr','Dahili notlar',0),(276557,7683,'pl','WewnÄ™trzne notatki',0),(276558,7683,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(276559,7683,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ù†ÙˆÙ¹',0),(276560,7683,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(276561,7683,'vi','Ghi chÃº ná»™i bá»™',0),(276562,7683,'af','Interne Notas',0),(276563,7683,'ro','Note interne',0),(276564,7683,'et','Sisemised mÃ¤rkused',0),(276565,7683,'si','Interne beleÅ¾ke',0),(276566,7683,'ba','Catatan internal',0),(276567,7683,'nl','Interne notities',0),(276568,7683,'fi','SisÃ¤iset huomautukset',0),(276569,7683,'no','Interne merknader',0),(276570,7683,'da','Interne notater',0),(276571,7683,'ko','ë‚´ë¶€ ë©”ëª¨',0),(276572,7683,'he','×”×¢×¨×•×ª ×¤× ×™×ž×™×•×ª',0),(276573,7683,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ­Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(276574,7683,'zh','å†…éƒ¨è¯´æ˜Ž\r\n',0),(276575,7683,'sv','Interna noteringar',0),(276576,7683,'it','Note interne',0),(276577,7683,'tl','',0),(276578,7683,'th','&#3616;&#3634;&#3618;&#3651;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(276579,7683,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¨à¥‹à¤Ÿà¥à¤¸',0),(276580,7683,'ms','Nota-Nota dalaman',0),(276581,7683,'ar','Ø§Ù„Ù…Ø°ÙƒØ±Ø§Øª Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(276582,7683,'fr','Notes internes',0),(276583,7683,'jp','å†…éƒ¨ãƒ¡ãƒ¢',0),(276584,7683,'pt','Notas internas',0),(276585,7683,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ðµ Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(276586,7683,'es','Notas Internales',0),(276587,7683,'de','Interne Notizen',0),(276588,7683,'en','Internal Notes',0),(276589,7684,'is','',0),(276590,7684,'dr','Ø´ØºÙ„ Ù‚Ø¨Ù„ÙŠ ',0),(276591,7684,'pr','Ø´ØºÙ„ Ù‚Ø¨Ù„ÙŠ ',0),(276592,7684,'tr','Eski iÅŸ',0),(276593,7684,'pl','Stary pracy',0),(276594,7684,'bg','Ð¡Ñ‚Ð°Ñ€Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(276595,7684,'ur','Ø¹Ù…Ø± Ø§ÛŒÙˆØ¨',0),(276596,7684,'sr','Ð¡Ñ‚Ð°Ñ€Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(276597,7684,'vi','Job cÅ©',0),(276598,7684,'af','Ou werk',0),(276599,7684,'ro','Vechea meserie',0),(276600,7684,'et','Vana tÃ¶Ã¶',0),(276601,7684,'si','Stari sluÅ¾bo',0),(276602,7684,'ba','Pekerjaan lama',0),(276603,7684,'nl','Oude baan',0),(276604,7684,'fi','Vanha tyÃ¶paikka',0),(276605,7684,'no','Gamle jobb',0),(276606,7684,'da','Gamle Job',0),(276607,7684,'ko','ì˜› ì§ìž¥',0),(276608,7684,'he','×”×¢×‘×•×“×” ×”×™×©× ×”',0),(276609,7684,'el','Î Î±Î»Î¹Î¬ Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(276610,7684,'zh','æ—§å·¥ä½œ\r\n',0),(276611,7684,'sv','Gamla jobb',0),(276612,7684,'it','Vecchio lavoro',0),(276613,7684,'tl','',0),(276614,7684,'th','&#3591;&#3634;&#3609;&#3648;&#3585;&#3656;&#3634;',0),(276615,7684,'hi','à¤ªà¥à¤°à¤¾à¤¨à¥€ à¤¨à¥Œà¤•à¤°à¥€',0),(276616,7684,'ms','Jawatan lama',0),(276617,7684,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù‚Ø¯ÙŠÙ…Ø©',0),(276618,7684,'fr','Ancien emploi',0),(276619,7684,'jp','æ˜”ã®ä»•äº‹',0),(276620,7684,'pt','Antigo emprego',0),(276621,7684,'ru','Ð¡Ñ‚Ð°Ñ€Ð°Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(276622,7684,'es','Trabajo Antiguo',0),(276623,7684,'de','Alten Job',0),(276624,7684,'en','Old Job',0),(276625,7685,'is','',0),(276626,7685,'dr','Ø§Ø³Ù†Ø§Ø¯ ',0),(276627,7685,'pr','Ø§Ø³Ù†Ø§Ø¯ ',0),(276628,7685,'tr','Belgeler',0),(276629,7685,'pl','Dokumenty',0),(276630,7685,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(276631,7685,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(276632,7685,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(276633,7685,'vi','TÃ i liá»‡u',0),(276634,7685,'af','Dokumente',0),(276635,7685,'ro','Documente',0),(276636,7685,'et','Dokumendid',0),(276637,7685,'si','Dokumenti',0),(276638,7685,'ba','Dokumen',0),(276639,7685,'nl','Documenten',0),(276640,7685,'fi','Asiakirjat',0),(276641,7685,'no','Dokumenter',0),(276642,7685,'da','Dokumenter',0),(276643,7685,'ko','ë¬¸ì„œ',0),(276644,7685,'he','×ž×¡×ž×›×™×',0),(276645,7685,'el','ÎˆÎ³Î³ÏÎ±Ï†Î±',0),(276646,7685,'zh','æ–‡ä»¶\r\n',0),(276647,7685,'sv','Dokument',0),(276648,7685,'it','Documenti',0),(276649,7685,'tl','',0),(276650,7685,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;',0),(276651,7685,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œ',0),(276652,7685,'ms','Dokumen-dokumen',0),(276653,7685,'ar','Ø§Ù„ÙˆØ«Ø§Ø¦Ù‚',0),(276654,7685,'fr','Documents',0),(276655,7685,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ',0),(276656,7685,'pt','Documentos',0),(276657,7685,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(276658,7685,'es','Documentos',0),(276659,7685,'de','Dokumente',0),(276660,7685,'en','Documents',0),(276661,7686,'is','',0),(276662,7686,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ø´ØºÙ„ ',0),(276663,7686,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ø´ØºÙ„ ',0),(276664,7686,'tr','Yeni proje numarasÄ±',0),(276665,7686,'pl','Nowy numer zadania',0),(276666,7686,'bg','ÐÐ¾Ð² Ð½Ð¾Ð¼ÐµÑ€',0),(276667,7686,'ur','Ù†Ø¦ÛŒ Ø¬Ø§Ø¨ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(276668,7686,'sr','ÐÐ¾Ð²Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(276669,7686,'vi','Sá»‘ Job má»›i',0),(276670,7686,'af','Nuwe Projeknommer',0),(276671,7686,'ro','Nou numÄƒr de Job',0),(276672,7686,'et','Uute tÃ¶Ã¶kohtade arv',0),(276673,7686,'si','Nova Å¡tevilka projekta',0),(276674,7686,'ba','Nomor pekerjaan baru',0),(276675,7686,'nl','Nieuwe projectnummer',0),(276676,7686,'fi','Uusi projektinumero',0),(276677,7686,'no','Nye jobbnummer',0),(276678,7686,'da','Nye jobnummer',0),(276679,7686,'ko','ìƒˆë¡œìš´ ìž‘ì—… ë²ˆí˜¸',0),(276680,7686,'he','×ž×¡×¤×¨ ×”×¢×‘×•×“×” ×”×—×“×©',0),(276681,7686,'el','ÎÎ­Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Î¸Î­ÏƒÎµÏ‰Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(276682,7686,'zh','æ–°å²—ä½æ•°\r\n',0),(276683,7686,'sv','Nytt jobbnummer',0),(276684,7686,'it','Nuovo numero di lavoro',0),(276685,7686,'tl','',0),(276686,7686,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3591;&#3634;&#3609;&#3651;&#3627;&#3617;&#3656;',0),(276687,7686,'hi','à¤¨à¤ˆ à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(276688,7686,'ms','Nombor kerja baru',0),(276689,7686,'ar','Ø±Ù‚Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(276690,7686,'fr','Nouveau numÃ©ro d\'emploi',0),(276691,7686,'jp','æ–°ã—ã„ã‚¸ãƒ§ãƒ–ç•ªå·',0),(276692,7686,'pt','Novo nÃºmero do emprego',0),(276693,7686,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(276694,7686,'es','Nuevo NÃºmero de Trabajo',0),(276695,7686,'de','Neue Job-Nummer',0),(276696,7686,'en','New Job Number',0),(276697,7687,'is','',0),(276698,7687,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø¨Ù„ÙŠ Ø´ØºÙ„',0),(276699,7687,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø¨Ù„ÙŠ Ø´ØºÙ„',0),(276700,7687,'tr','Eski iÅŸ numarasÄ±',0),(276701,7687,'pl','Stary numer zadania',0),(276702,7687,'bg','Ð¡Ñ‚Ð°Ñ€ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(276703,7687,'ur','Ù¾Ø±Ø§Ù†Û’ Ú©Ø§Ù… Ù†Ù…Ø¨Ø±',0),(276704,7687,'sr','Ð¡Ñ‚Ð°Ñ€Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð¿Ð¾ÑÐ»Ð°',0),(276705,7687,'vi','Sá»‘ Job cÅ©',0),(276706,7687,'af','Ou werk nommer',0),(276707,7687,'ro','NumÄƒr de Job vechi',0),(276708,7687,'et','Vana tÃ¶Ã¶ Number',0),(276709,7687,'si','Stara Å¡tevilka projekta',0),(276710,7687,'ba','Nomor pekerjaan lama',0),(276711,7687,'nl','Oude projectnummer',0),(276712,7687,'fi','Vanha tyÃ¶numero',0),(276713,7687,'no','Gamle jobbnummer',0),(276714,7687,'da','Gamle jobnummer',0),(276715,7687,'ko','ì˜¤ëž˜ ëœ ì¼ ìˆ˜',0),(276716,7687,'he','×ž×¡×¤×¨ ×”×ž×©×¨×” ×™×©×Ÿ',0),(276717,7687,'el','Î Î±Î»Î¹ÏŒ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(276718,7687,'zh','æ—§èŒä½ç¼–å·\r\n',0),(276719,7687,'sv','Gamla jobbnummer',0),(276720,7687,'it','Vecchio numero di lavoro',0),(276721,7687,'tl','',0),(276722,7687,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3591;&#3634;&#3609;&#3648;&#3585;&#3656;&#3634;',0),(276723,7687,'hi','à¤ªà¥à¤°à¤¾à¤¨à¥€ à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(276724,7687,'ms','Lama kerja jumlah',0),(276725,7687,'ar','Ø±Ù‚Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù‚Ø¯ÙŠÙ…Ø©',0),(276726,7687,'fr','Ancien numÃ©ro d\'emploi',0),(276727,7687,'jp','å¤ã„ã‚¸ãƒ§ãƒ–ç•ªå·',0),(276728,7687,'pt','NÃºmero de emprego antigo',0),(276729,7687,'ru','Ð¡Ñ‚Ð°Ñ€Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(276730,7687,'es','NÃºmero de Trabajo Antiguo',0),(276731,7687,'de','Alte Jobnummer',0),(276732,7687,'en','Old Job Number',0),(276733,7688,'is','',0),(276734,7688,'dr','(ÙˆØ¸ÙŠÙÙ‡',0),(276735,7688,'pr','Ù†Ù…ÙˆØ¯Ø§Ø±Ù‡Ø§ÙŠ Ø´ØºÙ„(ÙˆØ¸ÙŠÙÙ‡',0),(276736,7688,'tr','Ä°ÅŸ grafikleri',0),(276737,7688,'pl','Praca grafika',0),(276738,7688,'bg','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(276739,7688,'ur','Ø¬Ø§Ø¨ Ú¯Ø±Ø§ÙÚ©Ø³',0),(276740,7688,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(276741,7688,'vi','Biá»ƒu Ä‘á»“ Job',0),(276742,7688,'af','Werkstuk Grafies',0),(276743,7688,'ro','Job grafica',0),(276744,7688,'et','TÃ¶Ã¶ graafika',0),(276745,7688,'si','Delo grafike',0),(276746,7688,'ba','Grafis pekerjaan',0),(276747,7688,'nl','Baan Graphics',0),(276748,7688,'fi','TyÃ¶ grafiikka',0),(276749,7688,'no','Jobb grafikk',0),(276750,7688,'da','Job grafik',0),(276751,7688,'ko','ìž‘ì—… ê·¸ëž˜í”½',0),(276752,7688,'he','×¢×‘×•×“×” ×’×¨×¤×™×§×”',0),(276753,7688,'el','Î”Î¿Ï…Î»ÎµÎ¹Î¬ Î³ÏÎ±Ï†Î¹ÎºÏŽÎ½',0),(276754,7688,'zh','ä½œä¸šå›¾ç¤º\r\n',0),(276755,7688,'sv','Jobb grafik',0),(276756,7688,'it','Lavoro grafica',0),(276757,7688,'tl','',0),(276758,7688,'th','&#3591;&#3634;&#3609;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3585;',0),(276759,7688,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤—à¥à¤°à¤¾à¤«à¤¿à¤•à¥à¤¸',0),(276760,7688,'ms','Kerja grafik',0),(276761,7688,'ar','Ø±Ø³ÙˆÙ…Ø§Øª Ù…Ù‡Ù…Ø©',0),(276762,7688,'fr','Travail graphique',0),(276763,7688,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã®ä»•äº‹',0),(276764,7688,'pt','GrÃ¡ficos de trabalho',0),(276765,7688,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(276766,7688,'es','Trabajo GrÃ¡ficas',0),(276767,7688,'de','Job Grafik',0),(276768,7688,'en','Job Graphics',0),(276769,7689,'is','',0),(276770,7689,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´ØºÙ„ ',0),(276771,7689,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´ØºÙ„ ',0),(276772,7689,'tr','Ä°ÅŸ bilgisi',0),(276773,7689,'pl','Informacji na temat pracy',0),(276774,7689,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(276775,7689,'ur','Ø¬Ø§Ø¨ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(276776,7689,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð˜Ð½Ñ„Ð¾',0),(276777,7689,'vi','ThÃ´ng tin Job',0),(276778,7689,'af','Werkstuk Inligting',0),(276779,7689,'ro','InformaÅ£ii Job',0),(276780,7689,'et','TÃ¶Ã¶ Info',0),(276781,7689,'si','Delo Info',0),(276782,7689,'ba','Info pekerjaan',0),(276783,7689,'nl','Baan Info',0),(276784,7689,'fi','Job Info',0),(276785,7689,'no','Jobb Info',0),(276786,7689,'da','Job Info',0),(276787,7689,'ko','ìž‘ì—… ì •ë³´',0),(276788,7689,'he','×¤×¨×˜×™ ×”×¢×‘×•×“×”',0),(276789,7689,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(276790,7689,'zh','æ‹›è˜ä¿¡æ¯\r\n',0),(276791,7689,'sv','Jobb information',0),(276792,7689,'it','Lavoro Info',0),(276793,7689,'tl','',0),(276794,7689,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3591;&#3634;&#3609;',0),(276795,7689,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(276796,7689,'ms','Maklumat pekerjaan',0),(276797,7689,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(276798,7689,'fr','Emploi Info',0),(276799,7689,'jp','æ±‚äººæƒ…å ±',0),(276800,7689,'pt','InformaÃ§Ã£o de emprego',0),(276801,7689,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(276802,7689,'es','Trabajo Info',0),(276803,7689,'de','Job-Info',0),(276804,7689,'en','Job Info',0),(276805,7690,'is','',0),(276806,7690,'dr','Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(276807,7690,'pr','Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(276808,7690,'tr','Ã–zel teklif',0),(276809,7690,'pl','Personalizowane Quote',0),(276810,7690,'bg','ÐŸÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(276811,7690,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø§Ù‚ØªØ¨Ø§Ø³',0),(276812,7690,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(276813,7690,'vi','BÃ¡o giÃ¡ chá»‰nh sá»­a theo yÃªu cáº§u',0),(276814,7690,'af','Aangepasde Kwotasie',0),(276815,7690,'ro','Citat personalizate',0),(276816,7690,'et','Kohandatud hinnapakkumise',0),(276817,7690,'si','Ponudbo po meri',0),(276818,7690,'ba','Kustom kutipan',0),(276819,7690,'nl','Aangepast Quote',0),(276820,7690,'fi','Mukautettu lainaus',0),(276821,7690,'no','Tilpasset tilbud',0),(276822,7690,'da','Tilpassede tilbud',0),(276823,7690,'ko','ì‚¬ìš©ìž ì •ì˜ ê²¬ì ',0),(276824,7690,'he','×”×¦×¢×ª ×ž×—×™×¨ ×ž×•×ª××ž×ª ××™×©×™×ª',0),(276825,7690,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· Ï€Î±ÏÎ±Î¸Î­Ï„Ï‰',0),(276826,7690,'zh','å®šåˆ¶æŠ¥ä»·\r\n',0),(276827,7690,'sv','SkrÃ¤ddarsydd offert',0),(276828,7690,'it','Preventivo personalizzato',0),(276829,7690,'tl','',0),(276830,7690,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(276831,7690,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤¬à¥‹à¤²à¥€',0),(276832,7690,'ms','Quote adat',0),(276833,7690,'ar','Ø§Ù‚ØªØ¨Ø§Ø³ Ù…Ø®ØµØµØ©',0),(276834,7690,'fr','Devis personnalisÃ©',0),(276835,7690,'jp','ã‚«ã‚¹ã‚¿ãƒ å¼•ç”¨',0),(276836,7690,'pt','CotaÃ§Ã£o personalizada',0),(276837,7690,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(276838,7690,'es','CotizaciÃ³n Personalizado',0),(276839,7690,'de','Individuelles Angebot',0),(276840,7690,'en','Custom Quote',0),(276841,7691,'is','',0),(276842,7691,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø± Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(276843,7691,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø± Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(276844,7691,'tr','KullanÄ±cÄ± haklarÄ± ekleme baÅŸarÄ±sÄ±z',0),(276845,7691,'pl','Wstaw praw uÅ¼ytkownika nie powiodÅ‚o siÄ™',0),(276846,7691,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ñ€Ð°Ð²Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(276847,7691,'ur','ØµØ§Ø±Ù Ú©Û’ Ø­Ù‚ÙˆÙ‚ Ø¯Ø§Ø®Ù„ Ú©ÛŒ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§',0),(276848,7691,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ Ð¿Ñ€Ð°Ð²Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð°',0),(276849,7691,'vi','ThÃªm Quyá»n Cá»§a NgÆ°á»i Sá»­ Dá»¥ng tháº¥t báº¡i',0),(276850,7691,'af','Byvoeging van Gebruikerregte het gefaal.',0),(276851,7691,'ro','Utilizator drepturile Inserare nereuÈ™itÄƒ',0),(276852,7691,'et','Kasutaja Ãµiguste lisamine nurjus',0),(276853,7691,'si','Uporabnik pravice vstavljanje ni uspela',0),(276854,7691,'ba','Pengguna hak Insert gagal',0),(276855,7691,'nl','Gebruiker rechten invoegen mislukt',0),(276856,7691,'fi','KÃ¤yttÃ¤jÃ¤n oikeudet lisÃ¤Ã¤ epÃ¤onnistui',0),(276857,7691,'no','Brukeren rettigheter sett inn mislyktes',0),(276858,7691,'da','Bruger rettigheder IndsÃ¦t mislykkedes',0),(276859,7691,'ko','ì‚¬ìš©ìž ê¶Œí•œ ì‚½ìž… ì‹¤íŒ¨',0),(276860,7691,'he','×”×•×¡×¤×” ×©×œ ×–×›×•×™×•×ª ×ž×©×ª×ž×© × ×›×©×œ',0),(276861,7691,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î´Î¹ÎºÎ±Î¹Ï‰Î¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÏ„Î· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(276862,7691,'zh','ç”¨æˆ·æƒåˆ©â€‹â€‹æ’å…¥å¤±è´¥\r\n',0),(276863,7691,'sv','AnvÃ¤ndaren rÃ¤ttigheter infoga misslyckades',0),(276864,7691,'it','Inserimento di diritti utente non riuscito',0),(276865,7691,'tl','',0),(276866,7691,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3649;&#3607;&#3619;&#3585;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(276867,7691,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(276868,7691,'ms','Memasukkan hak-hak pengguna yang gagal',0),(276869,7691,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… ÙØ´Ù„',0),(276870,7691,'fr','Ã‰chouÃ© de l\'insertion des droits utilisateur',0),(276871,7691,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©åˆ©ã®æŒ¿å…¥ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(276872,7691,'pt','InserÃ§Ã£o de direitos do usuÃ¡rio falhada',0),(276873,7691,'ru','Ð’ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ñ€Ð°Ð² Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(276874,7691,'es','Derechos del Usuario InserciÃ³n FallÃ³',0),(276875,7691,'de','Benutzer Rechte einfÃ¼gen ist fehlgeschlagen',0),(276876,7691,'en','User Rights Insert Failed',0),(276877,7692,'is','',0),(276878,7692,'dr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ ',0),(276879,7692,'pr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ ',0),(276880,7692,'tr','SipariÅŸ',0),(276881,7692,'pl','ZÅ‚Ã³Å¼ zamÃ³wienie',0),(276882,7692,'bg','ÐœÑÑÑ‚Ð¾ Ñ€ÐµÐ´',0),(276883,7692,'ur','Ø­Ú©Ù… Ú©ÛŒ Ø¬Ú¯Û',0),(276884,7692,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´',0),(276885,7692,'vi','Äáº·t hÃ ng',0),(276886,7692,'af','Plaas Bestelling',0),(276887,7692,'ro','Comanda',0),(276888,7692,'et','Esitage tellimus',0),(276889,7692,'si','Se naroÄilo',0),(276890,7692,'ba','Menempatkan pesanan',0),(276891,7692,'nl','Bestelling plaatsen',0),(276892,7692,'fi','Tilauksen',0),(276893,7692,'no','Bestille',0),(276894,7692,'da','Afgiv ordre',0),(276895,7692,'ko','ì£¼ë¬¸',0),(276896,7692,'he','×”×–×ž× ×”',0),(276897,7692,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(276898,7692,'zh','ä¸‹è®¢å•\r\n',0),(276899,7692,'sv','Plats fÃ¶r',0),(276900,7692,'it','Ordine di luogo',0),(276901,7692,'tl','',0),(276902,7692,'th','&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(276903,7692,'hi','à¤œà¤—à¤¹ à¤†à¤¦à¥‡à¤¶',0),(276904,7692,'ms','Membuat pesanan',0),(276905,7692,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…ÙƒØ§Ù†',0),(276906,7692,'fr','Passer une commande',0),(276907,7692,'jp','å ´æ‰€é †',0),(276908,7692,'pt','Ordem do lugar',0),(276909,7692,'ru','Ð Ð°Ð·Ð¼ÐµÑÑ‚Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(276910,7692,'es','Hacer un Pedido',0),(276911,7692,'de','Bestellung aufgeben',0),(276912,7692,'en','Place Order',0),(276913,7693,'is','',0),(276914,7693,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ Ø¨Ù‡ ÙŠØ§ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(276915,7693,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ Ø¨Ù‡ ÙŠØ§ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(276916,7693,'tr','GÃ¶nderilecek ekleme veya dÃ¼zenleme',0),(276917,7693,'pl','Statek aby dodaÄ‡ lub edytowaÄ‡',0),(276918,7693,'bg','Ð”Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð¸Ð»Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ',0),(276919,7693,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ø³Û’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº ÛŒØ§ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(276920,7693,'sr','Ð‘Ñ€Ð¾Ð´ -Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð¸Ð»Ð¸ ÑƒÑ€ÐµÐ´Ð¸Ð»Ð¸',0),(276921,7693,'vi','ThÃªm hay Sá»­a Chuyá»ƒn Äáº¿n',0),(276922,7693,'af','Versend-Na Byvoeg of Redigeer',0),(276923,7693,'ro','Nava-pentru a adÄƒuga sau edita',0),(276924,7693,'et','Saaja lisamine vÃµi redigeerimine',0),(276925,7693,'si','Ladja za dodajanje ali urejanje',0),(276926,7693,'ba','Kapal-untuk menambah atau mengedit',0),(276927,7693,'nl','Verzendadres toevoegen of bewerken',0),(276928,7693,'fi','Toimitusosoitteen lisÃ¤Ã¤minen tai muokkaaminen',0),(276929,7693,'no','Lever til-legge til eller redigere',0),(276930,7693,'da','Skib-til at tilfÃ¸je eller redigere',0),(276931,7693,'ko','ë°°ì†¡ ì¶”ê°€ ë˜ëŠ” íŽ¸ì§‘',0),(276932,7693,'he','×œ×ž×©×œ×•×— ×œ×”×•×¡×™×£ ××• ×œ×¢×¨×•×š',0),(276933,7693,'el','Î Î»Î¿Î¯Î¿-Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î® Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(276934,7693,'zh','èˆ¹æ¥æ·»åŠ æˆ–ç¼–è¾‘\r\n',0),(276935,7693,'sv','Fartyg-att lÃ¤gga till eller redigera',0),(276936,7693,'it','Nave-per aggiungere o modificare',0),(276937,7693,'tl','',0),(276938,7693,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3619;&#3639;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(276939,7693,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤¯à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(276940,7693,'ms','Kapal untuk menambah atau menyunting',0),(276941,7693,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù„Ø¥Ø¶Ø§ÙØ© Ø£Ùˆ ØªØ­Ø±ÙŠØ±',0),(276942,7693,'fr','Navire-pour ajouter ou modifier',0),(276943,7693,'jp','èˆ¹ã‚’è¿½åŠ ã¾ãŸã¯ç·¨é›†',0),(276944,7693,'pt','Nave-para adicionar ou editar',0),(276945,7693,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¸Ð»Ð¸ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(276946,7693,'es','Enviar-A Agregar o Editar',0),(276947,7693,'de','Lieferadresse hinzufÃ¼gen oder bearbeiten',0),(276948,7693,'en','Ship-To Add or Edit',0),(276949,7694,'is','',0),(276950,7694,'dr','ØªÙ„ÙÙ† Ø¨Ù‡ Ø®Ø¯Ù…Ø§Øª Ù…Ø´ØªØ±ÙŠØ§Ù† Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(276951,7694,'pr','ØªÙ„ÙÙ† Ø¨Ù‡ Ø®Ø¯Ù…Ø§Øª Ù…Ø´ØªØ±ÙŠØ§Ù† Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(276952,7694,'tr','FiyatlandÄ±rma iÃ§in mÃ¼ÅŸteri hizmetlerini arayÄ±n',0),(276953,7694,'pl','ZadzwoÅ„ obsÅ‚ugi klienta na ceny',0),(276954,7694,'bg','ÐžÐ±ÑÐ»ÑƒÐ¶Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð¿Ð¾Ð²Ð¸ÐºÐ²Ð°Ð½Ðµ Ð·Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(276955,7694,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ú©Ø³Ù¹Ù…Ø± Ø³Ø±ÙˆØ³ Ú©Ùˆ Ú©Ø§Ù„ Ú©Ø±ÛŒÚº',0),(276956,7694,'sr','Ð—Ð¾Ð²Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÑƒ ÑÐ»ÑƒÐ¶Ð±Ñƒ Ð·Ð° Ð¾Ð´Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ†ÐµÐ½Ð°',0),(276957,7694,'vi','Gá»i dá»‹ch vá»¥ khÃ¡ch hÃ ng Ä‘á»ƒ bÃ¡o giÃ¡',0),(276958,7694,'af','Skakel KliÃ«ntedienssentrum vir Prysberekening',0),(276959,7694,'ro','SunaÅ£i Customer Service pentru preÅ£uri',0),(276960,7694,'et','Helista klienditeenindusele hinnakujundus',0),(276961,7694,'si','PokliÄite sluÅ¾bo za cene',0),(276962,7694,'ba','Menghubungi Customer Service untuk harga',0),(276963,7694,'nl','Bel klantenservice voor de prijsstelling',0),(276964,7694,'fi','Soita asiakaspalveluun hinnoittelu',0),(276965,7694,'no','Ringe kundeservice for priser',0),(276966,7694,'da','Ring til kundeservice for prissÃ¦tning',0),(276967,7694,'ko','ê°€ê²©ì— ëŒ€ í•œ ê³ ê° ì„œë¹„ìŠ¤ë¥¼ í˜¸ì¶œ',0),(276968,7694,'he','×œ×”×ª×§×©×¨ ×œ×©×™×¨×•×ª ×”×œ×§×•×—×•×ª ×œ×ª×ž×—×•×¨',0),(276969,7694,'el','ÎšÎ±Î»Î­ÏƒÏ„Îµ Ï„Î¿ Ï„Î¼Î®Î¼Î± ÎµÎ¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ·Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î³Î¹Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(276970,7694,'zh','å®¢æˆ·æœåŠ¡ç”µè¯æŠ¥ä»·\r\n',0),(276971,7694,'sv','Ring kundtjÃ¤nst fÃ¶r prissÃ¤ttning',0),(276972,7694,'it','Chiamare il servizio clienti per i prezzi',0),(276973,7694,'tl','',0),(276974,7694,'th','&#3648;&#3619;&#3637;&#3618;&#3585;&#3624;&#3641;&#3609;&#3618;&#3660;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3619;&#3634;&#3',0),(276975,7694,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡à¤µà¤¾ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥à¤²à¤¾à¤“',0),(276976,7694,'ms','Hubungi khidmat pelanggan untuk harga',0),(276977,7694,'ar','Ø§Ù„Ø§ØªØµØ§Ù„ Ø¨Ø®Ø¯Ù…Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù„Ù„ØªØ³Ø¹ÙŠØ±',0),(276978,7694,'fr','Appel de Service Ã  la clientÃ¨le pour une tarification',0),(276979,7694,'jp','ã‚«ã‚¹ã‚¿ãƒžãƒ¼ ã‚µãƒ¼ãƒ“ã‚¹ã®ä¾¡æ ¼ã‚’å‘¼ã³å‡ºã—ã¾ã™',0),(276980,7694,'pt','Chame a assistÃªncia tÃ©cnica para fixar o preÃ§o',0),(276981,7694,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ñƒ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð´Ð»Ñ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(276982,7694,'es','Llame a Servicio de Clientes para Precios',0),(276983,7694,'de','Rufen Sie unseren Kundendienst fÃ¼r die Preisfindung',0),(276984,7694,'en','Call Customer Service for Pricing',0),(276985,7695,'is','',0),(276986,7695,'dr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ø®Ø¯Ù…Ø§Øª Ù…Ø´ØªØ±ÙŠØ§Ù† Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(276987,7695,'pr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ø®Ø¯Ù…Ø§Øª Ù…Ø´ØªØ±ÙŠØ§Ù† Ø¨Ø±Ø§ÙŠ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(276988,7695,'tr','MÃ¼ÅŸteri Hizmetleri iÃ§in yeni alÄ±ntÄ± ile',0),(276989,7695,'pl','Skontaktuj siÄ™ z serwisem dla nowej oferty',0),(276990,7695,'bg','Ð¡Ð²ÑŠÑ€Ð¶ÐµÑ‚Ðµ ÑÐµ Ñ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð·Ð° Ð½Ð¾Ð²Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(276991,7695,'ur','Ú©Ø³Ù¹Ù…Ø± Ø³Ø±ÙˆØ³ Ú©Û’ Ù„Ø¦Û’ Ù†Ø¦Û’ Ø§Ù‚ØªØ¨Ø§Ø³ Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº Û”',0),(276992,7695,'sr','ÐžÐ±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾Ñ˜ ÑÐ»ÑƒÐ¶Ð±Ð¸ Ð·Ð° Ð½Ð¾Ð²Ñƒ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(276993,7695,'vi','LiÃªn há»‡ phÃ²ng dá»‹ch vá»¥ khÃ¡ch hÃ ng Ä‘á»ƒ láº¥y bÃ¡o giÃ¡',0),(276994,7695,'af','Kontak Klante/KliÃ«nte Diens vir Nuwe Kwotasie',0),(276995,7695,'ro','ContactaÅ£i serviciul clienÅ£i pentru noua oferta',0),(276996,7695,'et','VÃµtke Ã¼hendust klienditeenindusega uus pakkumine',0),(276997,7695,'si','Nove ponudbe, se obrnite na sluÅ¾bo',0),(276998,7695,'ba','Hubungi Customer Service untuk baru kutipan',0),(276999,7695,'nl','Neem contact op met de klantenservice voor nieuwe offerte',0),(277000,7695,'fi','Ota yhteyttÃ¤ asiakaspalveluun uuden tarjouspyynnÃ¶n',0),(277001,7695,'no','Kontakt kundeservice for nye tilbud',0),(277002,7695,'da','Kontakt kundeservice for nye tilbud',0),(277003,7695,'ko','ìƒˆë¡œìš´ ê²¬ì ì— ëŒ€ í•œ ê³ ê° ì„œë¹„ìŠ¤ì— ë¬¸ì˜',0),(277004,7695,'he','×¦×•×¨ ×§×©×¨ ×¢× ×©×™×¨×•×ª ×œ×§×•×—×•×ª ×¢×‘×•×¨ ×”×¦×¢×ª ×ž×—×™×¨ ×—×“×©×”',0),(277005,7695,'el','ÎœÎµ Ï„Î¿ Ï„Î¼Î®Î¼Î± ÎµÎ¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ·Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î³Î¹Î± Î½Î­Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(277006,7695,'zh','æ–°çš„æŠ¥ä»·è¯·è”ç³»å®¢æˆ·æœåŠ¡\r\n',0),(277007,7695,'sv','Kontakta kundtjÃ¤nst fÃ¶r ny offert',0),(277008,7695,'it','Contattare il servizio clienti di nuovo preventivo',0),(277009,7695,'tl','',0),(277010,7695,'th','&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3624;&#3641;&#3609;&#3618;&#3660;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3648;&#3614;&#3639;&#3656;&#3629;&#3586;&#3629;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3',0),(277011,7695,'hi','à¤¨à¤ˆ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡à¤µà¤¾ à¤¸à¥‡ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚',0),(277012,7695,'ms','Hubungi khidmat pelanggan untuk sebut-harga baru',0),(277013,7695,'ar','Ø¥ØªÙ‘ØµÙ„ Ø¨Ø®Ø¯Ù…Ø§Øª Ø§Ù„Ø²Ø¨Ø§Ø¦Ù† Ù„Ø¹Ø±Ø¶ Ø¬Ø¯ÙŠØ¯',0),(277014,7695,'fr','Contactez le Service clientÃ¨le pour nouveau devis',0),(277015,7695,'jp','æ–°ã—ã„è¦‹ç©ã‚‚ã‚Šã®ãŸã‚ã‚«ã‚¹ã‚¿ãƒžãƒ¼ ã‚µãƒ¼ãƒ“ã‚¹ã«é€£çµ¡ã—ã¾ã™ã€‚',0),(277016,7695,'pt','Entrar em contato com o atendimento ao cliente para Nova citaÃ§Ã£o',0),(277017,7695,'ru','Ð¡Ð²ÑÐ·Ð°Ñ‚ÑŒÑÑ ÑÐ¾ ÑÐ»ÑƒÐ¶Ð±Ð¾Ð¹ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ¸ Ð´Ð»Ñ Ð½Ð¾Ð²Ð¾Ð¹ ÐºÐ²Ð¾Ñ‚Ñ‹',0),(277018,7695,'es','Comunicarse con Servicio de AtenciÃ³n al Cliente para Nueva CotizaciÃ³n',0),(277019,7695,'de','Kundendienst fÃ¼r neue Quote',0),(277020,7695,'en','Contact Customer Service for New Quote',0),(277021,7696,'is','',0),(277022,7696,'dr',': Ø´Ù…Ø§ ÙÙ‚Ø· Ù†ÙŠØ§Ø² Ø¯Ø§Ø±ÙŠØ¯ ÙƒÙ‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙÙŠÙ„ØªØ± Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ù†Ø§Ø­ÙŠÙ‡ Ù…ÙˆØ±Ø¯ Ù†Ø¸Ø± ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(277023,7696,'pr','ØªÙˆØ¬Ù‡ Ø¬Ù‡Øª Ø¬Ø³ØªØ¬Ùˆ : Ø´Ù…Ø§ ÙÙ‚Ø· Ù†ÙŠØ§Ø² Ø¯Ø§Ø±ÙŠØ¯ ÙƒÙ‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙÙŠÙ„ØªØ± Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ù†Ø§Ø­ÙŠÙ‡ Ù…ÙˆØ±Ø¯ Ù†Ø¸Ø± ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(277024,7696,'tr','Not (istenen alanlar iÃ§in filtre veri girmek iÃ§in sadece yapmanÄ±z gereken) aramak iÃ§in',0),(277025,7696,'pl','Uwaga do wyszukiwania (wystarczy tylko wprowadziÄ‡ dane filtru dla obszarÃ³w poÅ¼Ä…dane)',0),(277026,7696,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ (ÑÐ°Ð¼Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ„Ð¸Ð»Ñ‚ÑŠÑ€ Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ Ð·Ð° Ð¿Ð»Ð¾Ñ‰Ð¸, Ð¶ÐµÐ»Ð°Ðµ)',0),(277027,7696,'ur','(ÙÙ„Ù¹Ø± Ú©ÙˆØ§Ø¦Ù Ú©Û’ Ù„ÛŒÛ’ Ù…Ø·Ù„ÙˆØ¨Û Ø¹Ù„Ø§Ù‚ÙˆÚº Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ ÛÙˆÙ†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¢Ù¾ ØµØ±Ù Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’) Ú©Ùˆ ØªÙ„Ø§Ø´ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù†ÙˆÙ¹',0),(277028,7696,'sr','Ð˜Ð¼Ð°Ñ˜Ñ‚Ðµ Ð½Ð° ÑƒÐ¼Ñƒ Ð´Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶ÑƒÑ˜ÐµÑ‚Ðµ (ÑÐ°Ð¼Ð¾ Ñ‚Ð¸ Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¤Ð¸Ð»Ñ‚ÐµÑ€ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð·Ð° Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ Ð¶ÐµÑ™ÐµÐ½Ñƒ)',0),(277029,7696,'vi','Ghi ChÃº Ä‘á»ƒ tÃ¬m(Báº¡n chá»‰ cáº§n nháº­p trÆ°á»ng lá»c dá»¯ liá»‡u cho nhá»¯ng vÃ¹ng báº¡n cáº§n)',0),(277030,7696,'af','Let wel om te soek (jy enigste behoefte om te tik Filter Data vir gebiede verlang word)',0),(277031,7696,'ro','NotÄƒ pentru a cÄƒuta (trebuie doar sÄƒ introduceÅ£i datele de filtru pentru zonele dorite)',0),(277032,7696,'et','MÃ¤rkus otsida (teil on vaja ainult sisestada andmete filtreerimine soovitud piirkondadele)',0),(277033,7696,'si','Opomba za iskanje (potrebno je le za obmoÄja, ki Å¾eli vstopiti filtriranje podatkov)',0),(277034,7696,'ba','Catatan untuk mencari (Anda hanya perlu memasukkan Filter Data untuk area yang diinginkan)',0),(277035,7696,'nl','Opmerking Als u wilt zoeken (u hoeft alleen in te voeren gegevens filteren voor gebieden gewenst)',0),(277036,7696,'fi','MerkinnÃ¤n etsiÃ¤ (sinun tarvitsee vain syÃ¶ttÃ¤Ã¤ suodattaa tietoja alueiden haluttu)',0),(277037,7696,'no','Merk sÃ¸ke (du trenger bare Ã¥ angi filtrere Data For omrÃ¥der Ã¸nsket)',0),(277038,7696,'da','BemÃ¦rk at sÃ¸ge (du behÃ¸ver kun at indtaste filtrere Data For omrÃ¥der Ã¸nskes)',0),(277039,7696,'ko','ì°¸ê³  ê²€ìƒ‰ (í•˜ê¸°ë§Œ í•˜ë©´ ì›í•˜ëŠ” ì˜ì—­ì— ëŒ€ í•œ í•„í„° ë°ì´í„°ë¥¼ ìž…ë ¥)',0),(277040,7696,'he','×”×¢×¨×” ×›×“×™ ×œ×‘×¦×¢ ×—×™×¤×•×© (×¨×§ ×¢×œ×™×š ×œ×”×–×™×Ÿ ×œ×¡× ×Ÿ × ×ª×•× ×™× ×¢×‘×•×¨ ××–×•×¨×™× ×”×¨×¦×•×™)',0),(277041,7696,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· Î³Î¹Î± Î½Î± ÎºÎ¬Î½ÎµÏ„Îµ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ· (Î¼ÏŒÎ½Î¿ Ï€Î¿Ï… Ï‡ÏÎµÎ¹Î¬Î¶ÎµÏ„Î±Î¹ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï†Î¯Î»Ï„ÏÎ¿ Î³Î¹Î± Ï„Î¹Ï‚ Ï€ÎµÏÎ¹Î¿Ï‡Î­Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Î¸Ï…Î¼ÎµÎ¯Ï„Îµ)',0),(277042,7696,'zh','æ³¨æ„ï¼šè¦æœç´¢ï¼ˆæ‚¨åªéœ€è¦è¾“å…¥æƒ³è¦çš„åœ°åŒºç­›é€‰æ•°æ®ï¼‰\r\n',0),(277043,7696,'sv','Observera att sÃ¶ka (du behÃ¶ver bara ange filtrera Data fÃ¶r omrÃ¥den som Ã¶nskas)',0),(277044,7696,'it','Nota per la ricerca (hai solo bisogno di immettere dati di filtro per aree desiderati)',0),(277045,7696,'tl','',0),(277046,7696,'th','Note to Search(You Only Need To Enter Filter Data For Areas Desired)',0),(277047,7696,'hi','à¤¨à¥‹à¤Ÿ (à¤µà¤¾à¤‚à¤›à¤¿à¤¤ à¤•à¥à¤·à¥‡à¤¤à¥à¤°à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤° à¤¡à¥‡à¤Ÿà¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤ª à¤¹à¥€ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥ˆ) à¤•à¥€ à¤–à¥‹à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à',0),(277048,7696,'ms','Ambil perhatian untuk mencari (anda hanya perlu masukkan Data penapis untuk kawasan-kawasan yang diingini)',0),(277049,7696,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ù„Ù„Ø¨Ø­Ø« (ØªØ­ØªØ§Ø¬ ÙÙ‚Ø· Ù„Ø¥Ø¯Ø®Ø§Ù„ Ø¨ÙŠØ§Ù†Ø§Øª Ø¹Ø§Ù…Ù„ Ø§Ù„ØªØµÙÙŠØ© Ù„Ù„Ù…Ù†Ø§Ø·Ù‚ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨)',0),(277050,7696,'fr','Remarque pour rechercher (vous nâ€™avez quâ€™Ã  entrer des donnÃ©es de filtre pour les zones dÃ©sirÃ©s)',0),(277051,7696,'jp','(ã ã‘ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™å¸Œæœ›ã‚¨ãƒªã‚¢ã®ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼ ãƒ‡ãƒ¼ã‚¿ã‚’å…¥åŠ›) ã‚’æ¤œç´¢ã™ã‚‹ã«æ³¨æ„ã—ã¦ãã ã•ã„ã€‚',0),(277052,7696,'pt','Nota para pesquisar (vocÃª sÃ³ precisa digitar dados de filtro para Ã¡reas desejadas)',0),(277053,7696,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ Ð´Ð»Ñ Ð¿Ð¾Ð¸ÑÐºÐ° (Ð²Ð°Ð¼ Ð½ÑƒÐ¶Ð½Ð¾ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð´Ð»Ñ Ð¾Ð±Ð»Ð°ÑÑ‚ÐµÐ¹ Ð¶ÐµÐ»Ð°ÐµÐ¼Ð¾Ð³Ð¾)',0),(277054,7696,'es','Nota para Buscar (Solo Necesita Introducir Datos de Filtro Para Los Ãreas Deseadas)',0),(277055,7696,'de','Hinweis zu suchen (Sie mÃ¼ssen nur Filterdaten fÃ¼r Bereiche gewÃ¼nscht eingeben)',0),(277056,7696,'en','Note to Search(You Only Need To Enter Filter Data For Areas Desired)',0),(277057,7697,'is','',0),(277058,7697,'dr','4',0),(277059,7697,'pr','Ú†Ø§Ù¾ Ù‡Ø§ÙŠ Ø§ÙˆÙ„ÙŠÙ‡ Ú†Ùƒ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± â€“ Ø±ÙˆØ´   4',0),(277060,7697,'tr','Ã–nceden basÄ±lmÄ±ÅŸ onay hisse senedi tarzÄ± #4',0),(277061,7697,'pl','Nadrukiem sprawdzanie zapasÃ³w stylu #4',0),(277062,7697,'bg','ÐŸÐ¾ÑÑÐ½Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð° ÑÑ‚Ð¸Ð» #4',0),(277063,7697,'ur','Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹Ø¯ Ú†ÛŒÚ© Ø§Ø³Ù¹Ø§Ú© Ø·Ø±Ø² #4',0),(277064,7697,'sr','Ð¤Ð°Ð±Ñ€Ð¸Ñ‡ÐºÐ¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ñƒ ÑÑ‚Ð¸Ð»Ñƒ #4',0),(277065,7697,'vi','Kiá»ƒu dÃ¡ng SÃ©c in trÆ°á»›c sá»‘ 4',0),(277066,7697,'af','Vooruitgedrukte Tjek Voorraad-Styl #4',0),(277067,7697,'ro','Selectare pre-imprimate stil stoc #4',0),(277068,7697,'et','ValmistrÃ¼kitud sisse Stock-stiil #4',0),(277069,7697,'si','Nespremenljivo Äek staleÅ¾-Style #4',0),(277070,7697,'ba','Cetakan Periksa saham-gaya #4',0),(277071,7697,'nl','Voorgedrukte selectievakje Stock-Style #4',0),(277072,7697,'fi','Esipainettua uloskirjautuminen Stock-tyylinen #4',0),(277073,7697,'no','Fortrykt av lager-stil #4',0),(277074,7697,'da','Fortrykt Check Stock-stil #4',0),(277075,7697,'ko','ì¸ì‡„ ëœ ìˆ˜ í‘œ ì£¼ì‹ ìŠ¤íƒ€ì¼ #4',0),(277076,7697,'he','×”×¡×™×ž×•×Ÿ ×ž×•×“×¤×¡ ×ž×¨××© ×ž×œ××™ ×‘×¡×’× ×•×Ÿ #4',0),(277077,7697,'el','Î ÏÎ¿Ï„Ï…Ï€Ï‰Î¼Î­Î½ÎµÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÏƒÏ„Î¹Î» #4',0),(277078,7697,'zh','é¢„å°æŸ¥çœ‹åº“å­˜æ ·å¼ï¼ƒ4\r\n',0),(277079,7697,'sv','FÃ¶rtryckta kontroll lager stil #4',0),(277080,7697,'it','Prestampati Check Stock-stile #4',0),(277081,7697,'tl','',0),(277082,7697,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3626;&#3605;&#3655;&#3629;&#3585;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3656;&#3629;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660; #4',0),(277083,7697,'hi','Preprinted à¤šà¥‡à¤• à¤¶à¥‡à¤¯à¤°-à¤¶à¥ˆà¤²à¥€ #4',0),(277084,7697,'ms','Pracetak semak stok-gaya #4',0),(277085,7697,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù…Ø·Ø¨ÙˆØ¹ Ø¹Ù„Ù‰ ØºØ±Ø§Ø± Ø§Ù„Ø£Ø³Ù‡Ù… #4',0),(277086,7697,'fr','ChÃ¨que prÃ©imprimÃ© Stock Style #4',0),(277087,7697,'jp','ã‚ã‚‰ã‹ã˜ã‚ãƒã‚§ãƒƒã‚¯åœ¨åº«ã‚¹ã‚¿ã‚¤ãƒ« #4',0),(277088,7697,'pt','SeleÃ§Ã£o prÃ©-impresso estilo Stock #4',0),(277089,7697,'ru','ÐŸÐ»Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð°Ð¿Ð°ÑÐ¾Ð² ÑÑ‚Ð¸Ð»ÑŒ #4',0),(277090,7697,'es','Estilo-Stock #4 de Cheque Preimprimido',0),(277091,7697,'de','Vorgedruckte Check Stock-Style #4',0),(277092,7697,'en','Preprinted Check Stock-Style #4',0),(277093,7698,'is','',0),(277094,7698,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(277095,7698,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¹Ù…Ù„ÙŠØ§Øª ÙØ±ÙˆØ´',0),(277096,7698,'tr','SatÄ±ÅŸ eylemler Ekle/GÃ¼ncelle',0),(277097,7698,'pl','SprzedaÅ¼y akcji Dodaj/Aktualizuj',0),(277098,7698,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(277099,7698,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø§Ø¹Ù…Ø§Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(277100,7698,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(277101,7698,'vi','ThÃªm/Cáº­p Nháº­t Hoáº¡t Ä‘á»™ng bÃ¡n hÃ ng',0),(277102,7698,'af','Verkoopsaksies Skep/Opdateer',0),(277103,7698,'ro','Adauga/Actualizeaza actiune vanzare',0),(277104,7698,'et','MÃ¼Ã¼gi tegevuste lisamine/uuendamine',0),(277105,7698,'si','Prodajne akcije Dodaj/posodobi',0),(277106,7698,'ba','Penjualan tindakan Tambahkan/Perbarui',0),(277107,7698,'nl','Verkoop acties toevoegen/bijwerken',0),(277108,7698,'fi','Myynnin tehtÃ¤vÃ¤t lisÃ¤Ã¤/pÃ¤ivitÃ¤',0),(277109,7698,'no','Salg handlinger/Oppdater',0),(277110,7698,'da','Salg handlinger TilfÃ¸j/opdater',0),(277111,7698,'ko','íŒë§¤ ìž‘ì—… ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(277112,7698,'he','×”×•×¡×¤×ª/×¢×“×›×•×Ÿ ×¤×¢×•×œ×•×ª ×ž×›×™×¨×”',0),(277113,7698,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î´ÏÎ¬ÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(277114,7698,'zh','é”€å”®åŠ¨ä½œæ–°å¢ž/æ›´æ–°\r\n',0),(277115,7698,'sv','FÃ¶rsÃ¤ljning Ã¥tgÃ¤rder LÃ¤gg till/uppdatera',0),(277116,7698,'it','Vendita azioni aggiungere/aggiornare',0),(277117,7698,'tl','',0),(277118,7698,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(277119,7698,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾à¤“à¤‚ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(277120,7698,'ms','Jualan tindakan Tambah/Kemaskini',0),(277121,7698,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(277122,7698,'fr','Vente Actions ajouter/mettre Ã  jour',0),(277123,7698,'jp','å–¶æ¥­ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ /æ›´æ–°',0),(277124,7698,'pt','AÃ§Ãµes de vendas adicionar/atualizar',0),(277125,7698,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐŸÑ€Ð¾Ð´Ð°Ð¶ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(277126,7698,'es','Acciones de Ventas Agregar/Actualizar',0),(277127,7698,'de','Verkaufsaktionen hinzufÃ¼gen/aktualisieren',0),(277128,7698,'en','Sales Actions Add/Update',0),(277129,7699,'is','',0),(277130,7699,'dr','(ÙÙ‚Ø· Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§',0),(277131,7699,'pr','  Ø¢Ø®Ø±ÙŠÙ†  Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯(ÙÙ‚Ø· Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§',0),(277132,7699,'tr','PO kullanÄ±lan son No (yalnÄ±zca sayÄ±lar)',0),(277133,7699,'pl','Ostatni PO numer uÅ¼ywany (tylko cyfry)',0),(277134,7699,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´ÐµÐ½ PO Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ Ð½Ð¾Ð¼ÐµÑ€ (ÑÐ°Ð¼Ð¾ Ñ†Ð¸Ñ„Ñ€Ð¸)',0),(277135,7699,'ur','Ø¢Ø®Ø±ÛŒ Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ (ÙÙ‚Ø· Ø§Ø¹Ø¯Ø§Ø¯)',0),(277136,7699,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ ÐŸÐž Ð±Ñ€Ð¾Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ (ÑÐ°Ð¼Ð¾ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ðµ)',0),(277137,7699,'vi','Sá»‘ Ä‘Æ¡n mua hÃ ng cuá»‘i cÃ¹ng dÃ¹ng (chá»‰ sá»‘)',0),(277138,7699,'af','Laaste AB Nommer Gebruik (alleenlik nommers)',0),(277139,7699,'ro','Ultima PO numÄƒrul utilizat (numai numere)',0),(277140,7699,'et','Viimase PO numbri kasutamise (ainult arve)',0),(277141,7699,'si','Zadnja PO uporabljena Å¡tevilka (samo Å¡tevilke)',0),(277142,7699,'ba','Terakhir PO nomor digunakan (angka)',0),(277143,7699,'nl','Laatste PO nummer gebruikt (alleen nummers)',0),(277144,7699,'fi','Viimeinen PO kÃ¤ytetty nro (numerot)',0),(277145,7699,'no','Siste PO tall brukt (kun tall)',0),(277146,7699,'da','Sidste PO antallet bruges (kun tal)',0),(277147,7699,'ko','ë§ˆì§€ë§‰ í¬ ë²ˆí˜¸ ì‚¬ìš© (ìˆ«ìž)',0),(277148,7699,'he','×”××—×¨×•×Ÿ ×¤×• ×ž×¡×¤×¨ ×”×ž×©×ž×© (×ž×¡×¤×¨×™× ×‘×œ×‘×“)',0),(277149,7699,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î±Î½Î¬ Î±ÏÎ¹Î¸Î¼ÏŒ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®Î¸Î·ÎºÎµ (Î¼ÏŒÎ½Î¿ Î³Î¹Î± Î±ÏÎ¹Î¸Î¼Î¿ÏÏ‚)',0),(277150,7699,'zh','æœ€åŽè®¢å•ç¼–å·ä½¿ç”¨ï¼ˆä»…é™æ•°å­—ï¼‰\r\n',0),(277151,7699,'sv','Senaste PO nummer anvÃ¤nds (endast siffror)',0),(277152,7699,'it','Ultimo PO numero utilizzato (solo numeri)',0),(277153,7699,'tl','',0),(277154,7699,'th','&#3651;&#3594;&#3657;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604; (&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3648;&#3607;&#3656;&#3634;&',0),(277155,7699,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤ªà¥‹ à¤¨à¤‚à¤¬à¤° à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² (à¤•à¥‡à¤µà¤² à¤¸à¤‚à¤–à¥à¤¯à¤¾à¤à¤)',0),(277156,7699,'ms','Lepas PO nombor digunakan (nombor sahaja)',0),(277157,7699,'ar','Ø¢Ø®Ø± \"Øµ. Ø¨ Ø¹Ø¯Ø¯ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©\" (Ø£Ø±Ù‚Ø§Ù… ÙÙ‚Ø·)',0),(277158,7699,'fr','Dernier PO numÃ©ro utilisÃ© (chiffres uniquement)',0),(277159,7699,'jp','æœ€çµ‚ã® PO ç•ªå·ã®ä½¿ç”¨ (æ•°å­—ã®ã¿)',0),(277160,7699,'pt','NÃºmero de PO Ãºltimo utilizado (apenas nÃºmeros)',0),(277161,7699,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ PO (Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ†Ð¸Ñ„Ñ€Ñ‹)',0),(277162,7699,'es','Ãšltimo NÃºmero de OC (nÃºmeros solamente)',0),(277163,7699,'de','Letzte PO Nummer verwendet (nur Zahlen)',0),(277164,7699,'en','Last PO Number Used (numbers only)',0),(277165,7700,'is','',0),(277166,7700,'dr','- ÙÙ‚Ø· Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(277167,7700,'pr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯- ÙÙ‚Ø· Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(277168,7700,'tr','PO sadece giriÅŸ satÄ±ÅŸ miktarÄ± girin',0),(277169,7700,'pl','PO tylko do wpisu wpisz iloÅ›Ä‡ SprzedajÄ…',0),(277170,7700,'bg','PO ÑÐ°Ð¼Ð¾ Ð·Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(277171,7700,'ur','Ù¾Ùˆ ÙÙ‚Ø· Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø¨ÛŒÚ†ÛŒÚº ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(277172,7700,'sr','ÐŸÐž ÑÐ°Ð¼Ð¾ Ð·Ð° ÑÑ‚Ð°Ð²ÐºÐµ ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(277173,7700,'vi','Nháº­p ÄÆ¡n Mua HÃ ng-Chá»‰ Nháº­p Sá»‘ LÆ°á»£ng BÃ¡n',0),(277174,7700,'af','AB Inskrywing-Voer Slegs Verkoopte Hoeveelheid In',0),(277175,7700,'ro','PO doar Ã®n intrare intra Vindem cantitate',0),(277176,7700,'et','PO ainult kanne sisestage mÃ¼Ã¼a kogus',0),(277177,7700,'si','PO samo za vnos vnesete koliÄino za prodajo',0),(277178,7700,'ba','PO catatan-hanya masukkan Jual kuantitas',0),(277179,7700,'nl','PO Entry-alleen verkopen aantal invoeren',0),(277180,7700,'fi','PO merkintÃ¤ vain anna Sell mÃ¤Ã¤rÃ¤',0),(277181,7700,'no','PO oppfÃ¸ring bare angi selger',0),(277182,7700,'da','PO Entry-Only Indtast sÃ¦lge mÃ¦ngde',0),(277183,7700,'ko','íŒë§¤ ìˆ˜ëŸ‰ì„ ìž…ë ¥ í•˜ëŠ” í•­ëª© ì „ìš© í¬',0),(277184,7700,'he','×¤×• ×›× ×™×¡×” ×‘×œ×‘×“ ×”×–×Ÿ ×›×ž×•×ª ×œ×ž×›×•×¨',0),(277185,7700,'el','PO Î¼ÏŒÎ½Î¿ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(277186,7700,'zh','è®¢å•æ¡ç›®-ä»…è¾“å…¥é”€å”®é‡\r\n',0),(277187,7700,'sv','PO post-bara ange sÃ¤lja kvantiteten',0),(277188,7700,'it','PO sola voce inserire vendere quantitÃ ',0),(277189,7700,'tl','',0),(277190,7700,'th','&#3585;&#3619;&#3629;&#3585;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; &#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3648;&#3593;&#3614;&#3634;&#3632;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3634;&#3618;&#3648;&#3607;&#',0),(277191,7700,'hi','à¤ªà¥€à¤“ à¤•à¥‡à¤µà¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤°à¥à¤œ à¤¬à¥‡à¤šà¤¨à¥‡ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(277192,7700,'ms','PO kemasukan hanya masukkan kuantiti jual',0),(277193,7700,'ar','Øµ. Ø¨ Ø¯Ø®ÙˆÙ„ ÙÙ‚Ø· Ø£Ø¯Ø®Ù„ Ø¨ÙŠØ¹ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(277194,7700,'fr','PO entrÃ©e uniquement entrer la quantitÃ© de vente',0),(277195,7700,'jp','PO ã‚¨ãƒ³ãƒˆãƒªã ã‘ã¯ã€è²©å£²æ•°é‡ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(277196,7700,'pt','PO somente entrada digite quantidade de venda',0),(277197,7700,'ru','PO Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ Ð²Ñ…Ð¾Ð´Ð° Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Sell',0),(277198,7700,'es','OC Entrada-Solo Ingresar Cantidad de Venta',0),(277199,7700,'de','PO nur Eintrag geben Sie verkaufen Menge',0),(277200,7700,'en','PO Entry - Only Enter Sell Quantity',0),(277201,7701,'is','',0),(277202,7701,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø´Ø±ÙƒØª ',0),(277203,7701,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø´Ø±ÙƒØª ',0),(277204,7701,'tr','Åžirket vergi seÃ§enekleri',0),(277205,7701,'pl','Firma podatku opcje',0),(277206,7701,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð°',0),(277207,7701,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(277208,7701,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð¸',0),(277209,7701,'vi','Lá»±a chá»n thuáº¿ kinh doanh Cty',0),(277210,7701,'af','Onderneming Verkoopsbelasting Opsies',0),(277211,7701,'ro','OpÅ£iuni de impozitul pe vÃ¢nzÄƒri companie',0),(277212,7701,'et','Firma kÃ¤ibemaksu Valikud',0),(277213,7701,'si','Podjetje prodajni davek moÅ¾nosti',0),(277214,7701,'ba','Perusahaan pajak penjualan pilihan',0),(277215,7701,'nl','Bedrijf Sales Tax opties',0),(277216,7701,'fi','YhtiÃ¶lle arvonlisÃ¤veron vaihtoehtoja',0),(277217,7701,'no','Selskapet mva-alternativer',0),(277218,7701,'da','Virksomheden Sales Tax indstillinger',0),(277219,7701,'ko','íšŒì‚¬ íŒë§¤ ì„¸ê¸ˆ ì˜µì…˜',0),(277220,7701,'he','××¤×©×¨×•×™×•×ª ×”×ž×¢\"×ž ×”×—×‘×¨×”',0),(277221,7701,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(277222,7701,'zh','å…¬å¸é”€å”®ç¨Žé€‰é¡¹\r\n',0),(277223,7701,'sv','FÃ¶retaget omsÃ¤ttningsskatt alternativ',0),(277224,7701,'it','Azienda IVA opzioni',0),(277225,7701,'tl','',0),(277226,7701,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(277227,7701,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤µà¤¿à¤•à¤²à¥à¤ª',0),(277228,7701,'ms','Pilihan cukai jualan syarikat',0),(277229,7701,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„Ù„Ø´Ø±ÙƒØ©',0),(277230,7701,'fr','Options de taxe de vente de la compagnie',0),(277231,7701,'jp','ä¼šç¤¾ã®å£²ä¸Šç¨Žã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(277232,7701,'pt','OpÃ§Ãµes de imposto sobre vendas de empresa',0),(277233,7701,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(277234,7701,'es','Opciones de IVA de la Impresa',0),(277235,7701,'de','Unternehmen-Umsatzsteuer-Optionen',0),(277236,7701,'en','Company Sales Tax Options',0),(277237,7702,'is','',0),(277238,7702,'dr','Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(277239,7702,'pr','Ø³Ø§ÙŠØª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(277240,7702,'tr','Ä°ÅŸletmeler iÃ§in Site',0),(277241,7702,'pl','Biznes do strony',0),(277242,7702,'bg','Ð‘Ð¸Ð·Ð½ÐµÑ ÐºÑŠÐ¼ Ð±Ð¸Ð·Ð½ÐµÑ ÑÐ°Ð¹Ñ‚',0),(277243,7702,'ur','Ú©Ø§Ø±ÙˆØ¨Ø§Ø±-Ú©Ø§Ø±ÙˆØ¨Ø§Ø±ÛŒ ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹',0),(277244,7702,'sr','ÐŸÐ¾ÑÐ°Ð¾ -Ð¿Ð¾ÑÐ»Ð¾Ð²Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(277245,7702,'vi','Trang Kinh Doanh Äáº¿n Kinh Doanh',0),(277246,7702,'af','Besigheid-tot-besigheid webwerf',0),(277247,7702,'ro','Site-ul business-to-Business',0),(277248,7702,'et','Ã„ri Ã¤ri saidi',0),(277249,7702,'si','Business-to-Business stran',0),(277250,7702,'ba','Situs bisnis-ke-bisnis',0),(277251,7702,'nl','Business-to-Business Site',0),(277252,7702,'fi','Business to Business sivusto',0),(277253,7702,'no','Business-to-Business-nettsted',0),(277254,7702,'da','Business-to-Business Site',0),(277255,7702,'ko','ë¹„ì¦ˆë‹ˆìŠ¤-ë¡œ-ë¹„ì¦ˆë‹ˆìŠ¤ ì‚¬ì´íŠ¸',0),(277256,7702,'he','××ª×¨ ×¢×¡×§×™-×œ×¢×¡×§',0),(277257,7702,'el','Business-to-Business Site',0),(277258,7702,'zh','ä¼ä¸šå¯¹ä¼ä¸šç½‘ç«™\r\n',0),(277259,7702,'sv','Business-to-Business webbplats',0),(277260,7702,'it','Sito to-Business',0),(277261,7702,'tl','',0),(277262,7702,'th','&#3604;&#3657;&#3634;&#3609;&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3608;&#3640;&#3619;&#3585;&#3636;&#3592;&#3652;&#3611;&#3606;&#3638;&#3591;&#3608;&#3640;&#3619;&#3585;&#3636;&#3592;',0),(277263,7702,'hi','à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤° à¤¸à¥‡ à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤° à¤¸à¤¾à¤‡à¤Ÿ',0),(277264,7702,'ms','Lokasi perniagaan-ke-perniagaan',0),(277265,7702,'ar','Ù…ÙˆÙ‚Ø¹ Ù„Ù„Ø£Ø¹Ù…Ø§Ù„',0),(277266,7702,'fr','Business-to-Business Site',0),(277267,7702,'jp','ãƒ“ã‚¸ãƒã‚¹-ãƒ“ã‚¸ãƒã‚¹ ã‚µã‚¤ãƒˆ',0),(277268,7702,'pt','Site de Business-to-Business',0),(277269,7702,'ru','Ð‘Ð¸Ð·Ð½ÐµÑ-ÑÐ°Ð¹Ñ‚',0),(277270,7702,'es','Sitio de NegÃ³cio-a-Negocio',0),(277271,7702,'de','Business-to-Business-Site',0),(277272,7702,'en','Business-to-Business Site',0),(277273,7703,'is','',0),(277274,7703,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù‚ÙŠÙ…Øª Ø§ÙØ²Ø§ÙŠØ´ ÙŠØ§ÙØªÙ‡ Ø¯Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª',0),(277275,7703,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù‚ÙŠÙ…Øª Ø§ÙØ²Ø§ÙŠØ´ ÙŠØ§ÙØªÙ‡ Ø¯Ø± ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª',0),(277276,7703,'tr','Fiyat birimi Ã¼zerinde toplam fiyatÄ± hesaplamak',0),(277277,7703,'pl','Oblicz cenÄ™ na cena jednostki',0),(277278,7703,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ð° Ñ†ÐµÐ½Ð° Ð½Ð° Ñ†ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(277279,7703,'ur','Ù‚ÛŒÙ…Øª ÛŒÙˆÙ†Ù¹Ø³ Ù¾Ø± ØªÙˆØ³ÛŒØ¹ Ù‚ÛŒÙ…Øª Ú©Ø§ ØªØ®Ù…ÛŒÙ†Û Ù„Ú¯Ø§ØªÛ’ ÛÛŒÚº',0),(277280,7703,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾ÑˆÐ¸Ñ€ÐµÐ½Ðµ Ñ†ÐµÐ½Ðµ Ð½Ð° Ñ†ÐµÐ½Ñƒ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(277281,7703,'vi','TÃ­nh giÃ¡ gia háº¡n trÃªn Ä‘Æ¡n vá»‹ giÃ¡',0),(277282,7703,'af','Uitgebreide prys op prys eenhede bereken',0),(277283,7703,'ro','Calcularea preÈ›ului extinse pe preÅ£ul de unitÄƒÅ£i',0),(277284,7703,'et','Hind Ã¼hikute laiendatud hinna arvutamiseks',0),(277285,7703,'si','IzraÄuna razÅ¡irjeno ceno na ceno enote',0),(277286,7703,'ba','Menghitung diperpanjang harga harga unit',0),(277287,7703,'nl','Factuurprijs op prijs eenheden berekenen',0),(277288,7703,'fi','Laskea kokonaishinnan hinnan yksikÃ¶itÃ¤',0),(277289,7703,'no','Beregne utvidet pris pÃ¥ Price enheter',0),(277290,7703,'da','Beregne udvidede pris pÃ¥ pris enheder',0),(277291,7703,'ko','ê°€ê²© ë‹¨ìœ„ì— í™•ìž¥ëœ ê°€ê²© ê³„ì‚°',0),(277292,7703,'he','×œ×—×©×‘ ×ž×—×™×¨ ×ž×•×¨×—×‘ ×¢×œ ×ž×—×™×¨ ×™×—×™×“×•×ª',0),(277293,7703,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ ÎµÎºÏ„ÎµÏ„Î±Î¼Î­Î½Î· Ï„Î¹Î¼Î® Ï„Î¹Î¼Î® Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(277294,7703,'zh','è®¡ä»·å•ä½è®¡ç®—ä»·æ ¼ä¸Šçš„æ‰©å±•\r\n',0),(277295,7703,'sv','BerÃ¤kna utÃ¶kat pris om priset enheter',0),(277296,7703,'it','Calcolare il prezzo complessivo sulle unitÃ  di prezzo',0),(277297,7703,'tl','',0),(277298,7703,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3605;&#3634;&#3617;&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(277299,7703,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤ªà¤° à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°à¤¿à¤¤ à¤®à¥‚à¤²à¥à¤¯ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(277300,7703,'ms','Mengira harga dilanjutkan atas unit-unit harga',0),(277301,7703,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ù…ÙˆØ³Ø¹ Ø¹Ù„Ù‰ Ø£Ø³Ø¹Ø§Ø± Ø§Ù„ÙˆØ­Ø¯Ø§Øª',0),(277302,7703,'fr','Calculer prix Ã©tendu sur prix unitÃ©s',0),(277303,7703,'jp','ä¾¡æ ¼å˜ä½ã§æ‹¡å¼µä¾¡æ ¼ã‚’è¨ˆç®—ã—ã¾ã™ã€‚',0),(277304,7703,'pt','Calcular o preÃ§o estendido em unidades de preÃ§o',0),(277305,7703,'ru','Ð’Ñ‹Ñ‡Ð¸ÑÐ»Ð¸Ñ‚ÑŒ Ð¾Ñ‚Ð¿ÑƒÑÐºÐ½ÑƒÑŽ Ñ†ÐµÐ½Ñƒ Ð½Ð° Ñ†ÐµÐ½Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(277306,7703,'es','Calcular Precios Extendidos sobre Unidades de Precios',0),(277307,7703,'de','Erweiterten Preis auf Preis-Einheiten berechnen',0),(277308,7703,'en','Calculate Extended Price on Price Units',0),(277309,7704,'is','',0),(277310,7704,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù‚ÙŠÙ…Øª Ø§ÙØ²Ø§ÙŠØ´ ÙŠØ§ÙØªÙ‡ Ø¯Ø± ÙØ±ÙˆØ´',0),(277311,7704,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù‚ÙŠÙ…Øª Ø§ÙØ²Ø§ÙŠØ´ ÙŠØ§ÙØªÙ‡ Ø¯Ø± ÙØ±ÙˆØ´',0),(277312,7704,'tr','SatÄ±ÅŸ birimleri Ã¼zerinde toplam fiyatÄ± hesaplamak',0),(277313,7704,'pl','Oblicz cenÄ™ na sprzedaÅ¼ jednostek',0),(277314,7704,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð° Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(277315,7704,'ur','ØªÙˆØ³ÛŒØ¹ Ú©Ø±Ø¯Û Ù‚ÛŒÙ…Øª ÙØ±ÙˆØ®Øª ÛŒÙˆÙ†Ù¹Ø³ Ù¾Ø± Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(277316,7704,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾ÑˆÐ¸Ñ€ÐµÐ½Ðµ Ñ†ÐµÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(277317,7704,'vi','TÃ­nh giÃ¡ gia háº¡n trÃªn Ä‘Æ¡n vá»‹ giÃ¡ bÃ¡n',0),(277318,7704,'af','Bereken Verlengde Prys op Verkoopte Eenhede',0),(277319,7704,'ro','Calcularea preÈ›ului extinse pe unitÄƒÅ£i de vÃ¢nzare',0),(277320,7704,'et','MÃ¼Ã¼a Ã¼ksuste laiendatud hinna arvutamiseks',0),(277321,7704,'si','IzraÄuna razÅ¡irjeno ceno na prodajo enot',0),(277322,7704,'ba','Menghitung harga diperpanjang menjual unit',0),(277323,7704,'nl','Factuurprijs op verkopen eenheden berekenen',0),(277324,7704,'fi','Osuuksien myyntiÃ¤ laajennetun hinnan laskemisessa',0),(277325,7704,'no','Beregne utvidet pris pÃ¥ selge enheter',0),(277326,7704,'da','Beregne udvidede pris pÃ¥ SÃ¦lg enheder',0),(277327,7704,'ko','íŒë§¤ ë‹¨ìœ„ì— í™•ìž¥ëœ ê°€ê²© ê³„ì‚°',0),(277328,7704,'he','×œ×—×©×‘ ×ž×—×™×¨ ×ž×•×¨×—×‘ ×¢×œ ×œ×ž×›×•×¨ ×™×—×™×“×•×ª',0),(277329,7704,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ ÎµÎºÏ„ÎµÏ„Î±Î¼Î­Î½Î· Ï„Î¹Î¼Î® Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚ Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(277330,7704,'zh','è®¡ç®—å–å‡ºå•ä½ä»·æ ¼ä¸Šçš„æ‰©å±•\r\n',0),(277331,7704,'sv','BerÃ¤kna utÃ¶kat pris pÃ¥ sÃ¤lja enheter',0),(277332,7704,'it','Calcolare prezzo vendere unitÃ ',0),(277333,7704,'tl','',0),(277334,7704,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3588;&#3634;&#3605;&#3634;&#3617;&#3627;&#3609;&#3656;&#3623;&#3618;&#3586;&#3634;&#3618;',0),(277335,7704,'hi','à¤¬à¥‡à¤š à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤ªà¤° à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°à¤¿à¤¤ à¤®à¥‚à¤²à¥à¤¯ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(277336,7704,'ms','Mengira harga dilanjutkan menjual unit',0),(277337,7704,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ù…ÙˆØ³Ø¹ ÙÙŠ Ø¨ÙŠØ¹ ÙˆØ­Ø¯Ø§Øª',0),(277338,7704,'fr','Calculer le prix total sur les unitÃ©s de vente',0),(277339,7704,'jp','è²©å£²å˜ä½ã§æ‹¡å¼µä¾¡æ ¼ã‚’è¨ˆç®—ã—ã¾ã™ã€‚',0),(277340,7704,'pt','Calcular o preÃ§o estendido na venda de unidades',0),(277341,7704,'ru','Ð’Ñ‹Ñ‡Ð¸ÑÐ»Ð¸Ñ‚ÑŒ Ð¾Ñ‚Ð¿ÑƒÑÐºÐ½ÑƒÑŽ Ñ†ÐµÐ½Ñƒ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ñƒ ÐµÐ´Ð¸Ð½Ð¸Ñ†',0),(277342,7704,'es','Calcular Precios Extendidos sobre Unidades de Ventas',0),(277343,7704,'de','Endpreis auf Verkauf Einheiten berechnen',0),(277344,7704,'en','Calculate Extended Price on Sell Units',0),(277345,7705,'is','',0),(277346,7705,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡ Ùˆ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª',0),(277347,7705,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡ Ùˆ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª',0),(277348,7705,'tr','Yerine getirilmesi ve servis sipariÅŸleri',0),(277349,7705,'pl','SpeÅ‚nienie i zleceÅ„ serwisowych',0),(277350,7705,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(277351,7705,'ur','ØªÚ©Ù…ÛŒÙ„ Ø§ÙˆØ± Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(277352,7705,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(277353,7705,'vi','ÄÆ¡n hÃ ng dá»‹ch vá»¥ & giao táº­n nÆ¡i',0),(277354,7705,'af','Uitvoerings- en Diensbestellings',0),(277355,7705,'ro','ÃŽmplinire ÅŸi comenzi de Service',0),(277356,7705,'et','Kauba- ja teenusetellimused',0),(277357,7705,'si','Izpolnitev in servisnih nalogov',0),(277358,7705,'ba','Pemenuhan dan Pelayanan Pesanan',0),(277359,7705,'nl','Vervulling en serviceorders',0),(277360,7705,'fi','TÃ¤yttÃ¤minen ja huoltotilaukset',0),(277361,7705,'no','Oppfyllelse og serviceordrer',0),(277362,7705,'da','Opfyldelse og serviceordrer',0),(277363,7705,'ko','ì´ í–‰ ë° ì„œë¹„ìŠ¤ ì£¼ë¬¸',0),(277364,7705,'he','×”×’×©×ž×” ×©×œ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(277365,7705,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· ÎºÎ±Î¹ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(277366,7705,'zh','å®žæ–½å’ŒæœåŠ¡è®¢å•\r\n',0),(277367,7705,'sv','Uppfyllandet och serviceorder',0),(277368,7705,'it','Adempimento e ordini di servizio',0),(277369,7705,'tl','',0),(277370,7705,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3649;&#3621;&#3632;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(277371,7705,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤”à¤° à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶',0),(277372,7705,'ms','Memenuhi dan arahan Perkhidmatan',0),(277373,7705,'ar','ÙˆÙØ§Ø¡ ÙˆØ£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(277374,7705,'fr','ExÃ©cution et des commandes de Service',0),(277375,7705,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆã€ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡',0),(277376,7705,'pt','Preenchimento de Ordens de ServiÃ§o',0),(277377,7705,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¸ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(277378,7705,'es','Ordenes de Cumplimiento y Servicio',0),(277379,7705,'de','Fulfillment und ServiceauftrÃ¤ge',0),(277380,7705,'en','Fulfillment and Service Orders',0),(277381,7706,'is','',0),(277382,7706,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(277383,7706,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(277384,7706,'tr','Genel satÄ±ÅŸ vergisi bilgi',0),(277385,7706,'pl','Informacji na temat podatku od sprzedaÅ¼y',0),(277386,7706,'bg','Ð”Ð°Ð½ÑŠÑ†Ð¸ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(277387,7706,'ur','Ø¬Ù†Ø±Ù„ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(277388,7706,'sr','ÐžÐ¿ÑˆÑ‚Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð˜Ð½Ñ„Ð¾',0),(277389,7706,'vi','ThÃ´ng tin thuáº¿ kinh doanh chung',0),(277390,7706,'af','Algemene Verkoopsbelasting Inligting',0),(277391,7706,'ro','InformaÅ£ii generale TVA',0),(277392,7706,'et','Ãœldist kÃ¤ibemaksu Info',0),(277393,7706,'si','SploÅ¡ni prodajni davek Info',0),(277394,7706,'ba','Info Umum pajak penjualan',0),(277395,7706,'nl','Algemene Sales Tax Info',0),(277396,7706,'fi','Yleinen Info',0),(277397,7706,'no','Generell mva Info',0),(277398,7706,'da','Almindelige moms Info',0),(277399,7706,'ko','ì¼ë°˜ íŒë§¤ ì„¸ê¸ˆ ì •ë³´',0),(277400,7706,'he','×ž×™×“×¢ ×›×œ×œ×™ ×ž×¢ ×ž',0),(277401,7706,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³ÎµÎ½Î¹ÎºÏŒ Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(277402,7706,'zh','ä¸€èˆ¬é”€å”®ç¨Žä¿¡æ¯\r\n',0),(277403,7706,'sv','AllmÃ¤n omsÃ¤ttningsskatt information',0),(277404,7706,'it','Info generali IVA',0),(277405,7706,'tl','',0),(277406,7706,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(277407,7706,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(277408,7706,'ms','Maklumat am cukai jualan',0),(277409,7706,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø©',0),(277410,7706,'fr','Info taxe de vente gÃ©nÃ©rale',0),(277411,7706,'jp','ä¸€èˆ¬çš„ãªå£²ä¸Šç¨Žæƒ…å ±',0),(277412,7706,'pt','InformaÃ§Ã£o Geral de Imposto',0),(277413,7706,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ð±Ñ‰ÐµÐ³Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(277414,7706,'es','Info de IVA General',0),(277415,7706,'de','Allgemeine Umsatzsteuer-Info',0),(277416,7706,'en','General Sales Tax Info',0),(277417,7707,'is','',0),(277418,7707,'dr','Ø±ÙˆØ´ Ù…Ø­Ø§Ø³Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(277419,7707,'pr','Ø±ÙˆØ´ Ù…Ø­Ø§Ø³Ø¨Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(277420,7707,'tr','Fatura hesaplama yÃ¶ntemi',0),(277421,7707,'pl','Metoda obliczania faktury',0),(277422,7707,'bg','ÐœÐµÑ‚Ð¾Ð´ Ð·Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(277423,7707,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø­Ø³Ø§Ø¨ÛŒ Ø·Ø±ÛŒÙ‚Û',0),(277424,7707,'sr','ÐÐ°Ñ‡Ð¸Ð½ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(277425,7707,'vi','PhÆ°Æ¡ng thá»©c tÃ­nh HÃ³a Ä‘Æ¡n',0),(277426,7707,'af','Faktuur berekening metode',0),(277427,7707,'ro','Metoda calculare factura',0),(277428,7707,'et','Arve arvutamise meetod',0),(277429,7707,'si','NaÄin izraÄunavanja raÄuna',0),(277430,7707,'ba','Metode perhitungan faktur',0),(277431,7707,'nl','Factuur berekeningsmethode',0),(277432,7707,'fi','Laskun laskentatavan',0),(277433,7707,'no','BeregningsmÃ¥ten for faktura',0),(277434,7707,'da','Faktura beregningsmetode',0),(277435,7707,'ko','ê³„ì‚° ê³„ì‚° ë°©ë²•',0),(277436,7707,'he','×©×™×˜×ª ×”×—×™×©×•×‘ ×—×©×‘×•× ×™×ª',0),(277437,7707,'el','ÎœÎ­Î¸Î¿Î´Î¿ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(277438,7707,'zh','å‘ç¥¨è®¡ç®—æ–¹æ³•\r\n',0),(277439,7707,'sv','Faktura berÃ¤kningsmetod',0),(277440,7707,'it','Metodo di calcolo fattura',0),(277441,7707,'tl','',0),(277442,7707,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(277443,7707,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤•à¥€ à¤µà¤¿à¤§à¤¿',0),(277444,7707,'ms','Kaedah Pengiraan invois',0),(277445,7707,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø­Ø³Ø§Ø¨ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(277446,7707,'fr','MÃ©thode de calcul de facture',0),(277447,7707,'jp','è«‹æ±‚æ›¸ã®è¨ˆç®—æ³•',0),(277448,7707,'pt','MÃ©todo de cÃ¡lculo da fatura',0),(277449,7707,'ru','ÐœÐµÑ‚Ð¾Ð´ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð° ÑÑ‡ÐµÑ‚Ð°',0),(277450,7707,'es','Factura MÃ©todo de CÃ¡lculo',0),(277451,7707,'de','Rechnung-Berechnungsmethode',0),(277452,7707,'en','Invoice Calculation Method',0),(277453,7708,'is','',0),(277454,7708,'dr','(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†ÙƒÙŠ',0),(277455,7708,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª(ÙƒØ§Ø±Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†ÙƒÙŠ',0),(277456,7708,'tr','Ã–deme banka hesabÄ±',0),(277457,7708,'pl','Konto bankowe pÅ‚atnoÅ›Ä‡',0),(277458,7708,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(277459,7708,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(277460,7708,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ñƒ Ð±Ð°Ð½Ñ†Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ',0),(277461,7708,'vi','TK Thanh ToÃ¡n NgÃ¢n HÃ ng',0),(277462,7708,'af','Uitbetalings Bankrekening',0),(277463,7708,'ro','Cont bancar de platÄƒ',0),(277464,7708,'et','Makse pangakontole',0),(277465,7708,'si','PlaÄilo banÄnega raÄuna',0),(277466,7708,'ba','Rekening Bank Pembayaran',0),(277467,7708,'nl','Betaling bankrekening',0),(277468,7708,'fi','Maksun pankkitilin',0),(277469,7708,'no','Bankkonto i betaling',0),(277470,7708,'da','Betaling Bank konto',0),(277471,7708,'ko','ë‚©ë¶€ ì€í–‰ ê³„ì¢Œ',0),(277472,7708,'he','×—×©×‘×•×Ÿ ×‘× ×§ ×©×œ ×ª×©×œ×•×',0),(277473,7708,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(277474,7708,'zh','ä»˜æ¬¾é“¶è¡Œå¸æˆ·\r\n',0),(277475,7708,'sv','Betalning bankkonto',0),(277476,7708,'it','Conto bancario di pagamento',0),(277477,7708,'tl','',0),(277478,7708,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(277479,7708,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾',0),(277480,7708,'ms','Akaun Bank bayaran',0),(277481,7708,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†Ùƒ Ø§Ù„Ø¯ÙØ¹',0),(277482,7708,'fr','Compte bancaire de paiement',0),(277483,7708,'jp','ãŠæ”¯æ‰•ã„éŠ€è¡Œå£åº§',0),(277484,7708,'pt','Conta bancÃ¡ria de pagamento',0),(277485,7708,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(277486,7708,'es','Cuenta Bancaria de Pago',0),(277487,7708,'de','Zahlung Bankverbindung',0),(277488,7708,'en','Payment Bank Account',0),(277489,7709,'is','',0),(277490,7709,'dr','Ø¹Ù…Ù„ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(277491,7709,'pr','Ø¹Ù…Ù„ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(277492,7709,'tr','Ã–deme eylem',0),(277493,7709,'pl','Akcja pÅ‚atnoÅ›ci',0),(277494,7709,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(277495,7709,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ú©Ø§Ø±Ø±ÙˆØ§Ø¦ÛŒ',0),(277496,7709,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ð°',0),(277497,7709,'vi','HÃ nh Ä‘á»™ng Thanh ToÃ¡n',0),(277498,7709,'af','Betalingsaksie',0),(277499,7709,'ro','AcÅ£iune de platÄƒ',0),(277500,7709,'et','Makse tegevus',0),(277501,7709,'si','PlaÄilo dejanje',0),(277502,7709,'ba','Aksi pembayaran',0),(277503,7709,'nl','Betaling actie',0),(277504,7709,'fi','Maksun toiminta',0),(277505,7709,'no','Betaling handling',0),(277506,7709,'da','Betalingen handling',0),(277507,7709,'ko','ì§€ë¶ˆ ì•¡ì…˜',0),(277508,7709,'he','×¤×¢×•×œ×ª ×ª×©×œ×•×',0),(277509,7709,'el','Î Î»Î·ÏÏ‰Î¼Î® Î´ÏÎ¬ÏƒÎ·',0),(277510,7709,'zh','ä»˜æ¬¾è¡ŒåŠ¨\r\n',0),(277511,7709,'sv','Betalning Ã¥tgÃ¤rder',0),(277512,7709,'it','Azione di pagamento',0),(277513,7709,'tl','',0),(277514,7709,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(277515,7709,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(277516,7709,'ms','Tindakan bayaran',0),(277517,7709,'ar','Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ø¯ÙØ¹',0),(277518,7709,'fr','Action de paiement',0),(277519,7709,'jp','æ”¯æ‰•ã„ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(277520,7709,'pt','AÃ§Ã£o de pagamento',0),(277521,7709,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(277522,7709,'es','Pago AcciÃ³n',0),(277523,7709,'de','Zahlung-Aktion',0),(277524,7709,'en','Payment Action',0),(277525,7710,'is','',0),(277526,7710,'dr','Ú¯Ø±ÙˆÙ‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø­Ù‚ÙˆÙ‚',0),(277527,7710,'pr','Ú¯Ø±ÙˆÙ‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø­Ù‚ÙˆÙ‚',0),(277528,7710,'tr','Misc vergiye tabi Ã¶deme kategorisi',0),(277529,7710,'pl','Misc opodatkowaniu pÅ‚ac kategorii',0),(277530,7710,'bg','Ð Ð°Ð·Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(277531,7710,'ur','Ù…ØªÙØ±Ù‚ Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ ØªÙ†Ø®ÙˆØ§Û Ø²Ù…Ø±Û',0),(277532,7710,'sr','ÐœÐ˜Ð¡Ð¦ Ð¿Ð»Ð°Ð¶Ð° Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(277533,7710,'vi','Thá»ƒ loáº¡i thanh toÃ¡n thuáº¿ láº»',0),(277534,7710,'af','Allerlei Belasbare Besoldiging Kategorie',0),(277535,7710,'ro','Categoria de salarizare misc impozabile',0),(277536,7710,'et','Varia maksukohustuslased maksavad kategooria',0),(277537,7710,'si','Misc davÄni zavezanec plaÄati Kategorija',0),(277538,7710,'ba','Misc pajak membayar Kategori',0),(277539,7710,'nl','Misc belastbare betalen categorie',0),(277540,7710,'fi','Muut verovelvollinen maksuluokassa',0),(277541,7710,'no','Diverse skattepliktig lÃ¸nnskategorien',0),(277542,7710,'da','Misc afgiftspligtige lÃ¸nkategori',0),(277543,7710,'ko','ê¸°íƒ€ ê³¼ì„¸ ê¸‰ì—¬ ì¹´í…Œê³ ë¦¬',0),(277544,7710,'he','×§×˜×’×•×¨×™×™×ª ×”×©×›×¨ ×—×™×™×‘ ×‘×ž×¡ ×©×•× ×•×ª',0),(277545,7710,'el','Misc Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(277546,7710,'zh','æ‚é¡¹åº”ç¨Žè–ªé…¬ç±»åˆ«\r\n',0),(277547,7710,'sv','Misc skattskyldig betalar kategori',0),(277548,7710,'it','Soggetti passivi misc pagare categoria',0),(277549,7710,'tl','',0),(277550,7710,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;&#3607;&#3637;&#3',0),(277551,7710,'hi','à¤µà¤¿à¤µà¤¿à¤§ à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(277552,7710,'ms','Dikenakan cukai MISC membayar kategori',0),(277553,7710,'ar','ÙØ¦Ø© Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ù…ØªÙØ±Ù‚Ø§Øª',0),(277554,7710,'fr','CatÃ©gorie salariale imposable misc',0),(277555,7710,'jp','ãã®ä»–ã®èª²ç¨Žçµ¦ä¸Žã‚«ãƒ†ã‚´ãƒª',0),(277556,7710,'pt','Misc tributÃ¡veis pagar categoria',0),(277557,7710,'ru','Ð Ð°Ð·Ð½Ð¾Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼ÑƒÑŽ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(277558,7710,'es','Misc. CategorÃ­a de Pagos Imponibles',0),(277559,7710,'de','Misc Steuerpflichtige Zahlen Kategorie',0),(277560,7710,'en','Misc Taxable Pay Category',0),(277561,7711,'is','',0),(277562,7711,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(277563,7711,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(277564,7711,'tr','Workmans Comp satÄ±cÄ±',0),(277565,7711,'pl','Workmans komp dostawcy',0),(277566,7711,'bg','Workmans Comp Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(277567,7711,'ur','ÙˆÙˆØ±Ú©Ù…Ø¢Ù†Ø³ Ú©Ù…Ù¾ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(277568,7711,'sr','WÐ¾Ñ€ÐºÐ¼Ð°Ð½Ñ Ð¦Ð¾Ð¼Ð¿ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(277569,7711,'vi','NgÆ°á»i bÃ¡n CÃ´ng nhÃ¢n Comp',0),(277570,7711,'af','Vergoedingskommisaris Verskaffer',0),(277571,7711,'ro','Furnizor de Comp Workmans',0),(277572,7711,'et','*Workmans Comp Vendor',0),(277573,7711,'si','Workmans Comp dobavitelja',0),(277574,7711,'ba','Workmans Comp Vendor',0),(277575,7711,'nl','Workmans Comp leverancier',0),(277576,7711,'fi','Workmans Comp toimittajan',0),(277577,7711,'no','Workmans Comp leverandÃ¸r',0),(277578,7711,'da','Workmans Comp leverandÃ¸r',0),(277579,7711,'ko','Workmans ê´‘ê³  ê³µê¸‰ ì—…ì²´',0),(277580,7711,'he','Workmans Comp ×”×¡×¤×§',0),(277581,7711,'el','Workmans Comp Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(277582,7711,'zh','å·¥äººèµ”å¿ä¾›åº”å•†\r\n',0),(277583,7711,'sv','Workmans Comp leverantÃ¶r',0),(277584,7711,'it','Workmans Comp fornitore',0),(277585,7711,'tl','',0),(277586,7711,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(277587,7711,'hi','Workmans Comp à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(277588,7711,'ms','Penjual Comp Workmans',0),(277589,7711,'ar','Ø¨Ø§Ø¦Ø¹ Ø´Ø±ÙƒØ§Øª ÙˆÙˆØ±ÙƒÙ…Ø§Ù†Ø³',0),(277590,7711,'fr','Fournisseur de Comp accidentÃ©s',0),(277591,7711,'jp','Workmans Comp ãƒ™ãƒ³ãƒ€ãƒ¼',0),(277592,7711,'pt','Fornecedores de direitoa Comp',0),(277593,7711,'ru','Workmans Comp Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(277594,7711,'es','Proveedor de CompensaciÃ³n al Trabajador ',0),(277595,7711,'de','Mitarbeiter-Comp-Anbieter',0),(277596,7711,'en','Workmans Comp Vendor',0),(277597,7712,'is','',0),(277598,7712,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(277599,7712,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(277600,7712,'tr','Workmans Comp satÄ±cÄ± arama',0),(277601,7712,'pl','Workmans komp dostawcy wyszukiwania',0),(277602,7712,'bg','Workmans Comp Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(277603,7712,'ur','ÙˆÙˆØ±Ú©Ù…Ø¢Ù†Ø³ Ú©Ù…Ù¾ ÙˆÛŒÙ†ÚˆØ± Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(277604,7712,'sr','WÐ¾Ñ€ÐºÐ¼Ð°Ð½Ñ Ð¦Ð¾Ð¼Ð¿ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(277605,7712,'vi','TÃ¬m NgÆ°á»i bÃ¡n CÃ´ng nhÃ¢n Comp',0),(277606,7712,'af','Vergoedingskommisaris Verskaffer Opsoek',0),(277607,7712,'ro','Workmans Comp furnizor de cÄƒutare',0),(277608,7712,'et','Workmans Comp Vendor Lookup',0),(277609,7712,'si','Workmans Comp dobavitelja za iskanje',0),(277610,7712,'ba','Workmans Comp Vendor Lookup',0),(277611,7712,'nl','Workmans Comp leverancier opzoeken',0),(277612,7712,'fi','Workmans Comp toimittajan valinta',0),(277613,7712,'no','Workmans Comp leverandÃ¸r oppslag',0),(277614,7712,'da','Workmans Comp kreditor opslag',0),(277615,7712,'ko','Workmans ê´‘ê³  ê³µê¸‰ ì—…ì²´ ì¡°íšŒ',0),(277616,7712,'he','Workmans ×”×¡×¤×§ Comp ×‘×“×™×§×ª ×ž×™×“×¢',0),(277617,7712,'el','Workmans Comp Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(277618,7712,'zh','å·¥äººèµ”å¿ä¾›åº”å•†æŸ¥æ‰¾\r\n',0),(277619,7712,'sv','Workmans Comp leverantÃ¶r Lookup',0),(277620,7712,'it','Workmans Comp fornitore Lookup',0),(277621,7712,'tl','',0),(277622,7712,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(277623,7712,'hi','Workmans Comp à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤²à¥à¤•à¤…à¤ª',0),(277624,7712,'ms','Workmans Comp penjual Lookup',0),(277625,7712,'ar','ÙˆÙˆØ±ÙƒÙ…Ø§Ù†Ø³ Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ù…ÙˆØ±Ø¯',0),(277626,7712,'fr','Recherche de fournisseur pour le Comp accidentÃ©s',0),(277627,7712,'jp','Workmans Comp ãƒ™ãƒ³ãƒ€ãƒ¼æ¤œç´¢',0),(277628,7712,'pt','Pesquisa de fornecedores direitoa Comp',0),(277629,7712,'ru','Workmans Comp Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¿Ð¾Ð¸ÑÐºÐ°',0),(277630,7712,'es','Busqueda de Proveedor de CompensaciÃ³n al Trabajador ',0),(277631,7712,'de','Mitarbeiter-Comp-Kreditor-Lookup',0),(277632,7712,'en','Workmans Comp Vendor Lookup',0),(277633,7713,'is','',0),(277634,7713,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(277635,7713,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú†Ùƒ Ùˆ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ø¨Ø±Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(277636,7713,'tr','Onay veya satÄ±cÄ± iÃ§in Ã¶deme bilgilerini dÃ¼zenleme',0),(277637,7713,'pl','Edycja wyboru lub zÅ‚oÅ¼enia informacji dla dostawcy',0),(277638,7713,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‡ÐµÐº Ð¸Ð»Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(277639,7713,'ur','Ú†ÛŒÚ© ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û Ú©Û’ Ù„ÛŒÛ’ Ø¬Ù…Ø¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(277640,7713,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¸Ð»Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(277641,7713,'vi','Sá»­a ThÃ´ng Tin Vá» SÃ©c Hay Tiá»n Cá»c Cho NgÆ°á»i BÃ¡n',0),(277642,7713,'af','Redigeer Tjek of Deposito Inligting Vir Verskaffer',0),(277643,7713,'ro','Editare cec sau depunere informaÈ›iile pentru furnizor',0),(277644,7713,'et','Muuda sisse vÃµi deposiidi teave hankija kohta',0),(277645,7713,'si','Urejanje potrdite ali depozit informacije za dobavitelja',0),(277646,7713,'ba','Mengedit cek atau informasi rekening untuk Vendor',0),(277647,7713,'nl','Check of storting informatie voor leverancier bewerken',0),(277648,7713,'fi','Muokkaa sekin tai toimittajan tiedot Internet',0),(277649,7713,'no','Redigere sjekk eller innskudd informasjon For leverandÃ¸r',0),(277650,7713,'da','Redigere Check eller indbetaling oplysninger For kreditor',0),(277651,7713,'ko','í‘œ ë˜ëŠ” ê³µê¸‰ ì—…ì²´ì— ëŒ€ í•œ ìž…ê¸ˆ ì •ë³´ íŽ¸ì§‘',0),(277652,7713,'he','×¢×¨×™×›×ª ×¡×™×ž×•×Ÿ ××• ×¤×™×§×“×•×Ÿ ×ž×™×“×¢ ×¢×‘×•×¨ ×¡×¤×§',0),(277653,7713,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÎµÏ€Î¹Ï„Î±Î³Î® Î® ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(277654,7713,'zh','ç¼–è¾‘å–æ–¹æ”¯ç¥¨æˆ–å­˜æ¬¾ä¿¡æ¯\r\n',0),(277655,7713,'sv','Redigera Check eller insÃ¤ttning Information fÃ¶r leverantÃ¶r',0),(277656,7713,'it','Modifica assegno o deposito di informazioni per il fornitore',0),(277657,7713,'tl','',0),(277658,7713,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3594;&#3655;&#3588;&#3627;&#3619;&#3639;&#3629;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3612;&#3641;&#3657;&#3586;&#3',0),(277659,7713,'hi','à¤šà¥‡à¤• à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤®à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(277660,7713,'ms','Edit cek atau Deposit maklumat untuk Vendor',0),(277661,7713,'ar','ØªØ­Ø±ÙŠØ± Ø´ÙŠÙƒ Ø£Ùˆ Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù„Ù„Ø¨Ø§Ø¦Ø¹',0),(277662,7713,'fr','Ã‰diter le chÃ¨que ou dÃ©pÃ´t de renseignements pour le fournisseur',0),(277663,7713,'jp','ãƒã‚§ãƒƒã‚¯ã¾ãŸã¯ä»•å…¥å…ˆã®å…¥é‡‘æƒ…å ±ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(277664,7713,'pt','Editar cheque ou depÃ³sito de informaÃ§Ãµes para fornecedores',0),(277665,7713,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¸Ð»Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(277666,7713,'es','Editar InformaciÃ³n de Cheque o DepÃ³sito para Proveedor',0),(277667,7713,'de','Bearbeiten von Scheck oder Einzahlung Informationen fÃ¼r Lieferanten',0),(277668,7713,'en','Edit Check Or Deposit Information For Vendor',0),(277669,7714,'is','',0),(277670,7714,'dr','FUI Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(277671,7714,'pr','FUI Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ \r\n',0),(277672,7714,'tr','FUI satÄ±cÄ±',0),(277673,7714,'pl','FUI dostawcy',0),(277674,7714,'bg','FUI Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(277675,7714,'ur','ÙØ§ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(277676,7714,'sr','Ð¡Ð¸Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(277677,7714,'vi','NgÆ°á»i bÃ¡n FUI',0),(277678,7714,'af','FUI handelaar',0),(277679,7714,'ro','Furnizor de FUI',0),(277680,7714,'et','FUI hankija',0),(277681,7714,'si','Prodajalec FUI',0),(277682,7714,'ba','FUI Vendor',0),(277683,7714,'nl','FUI leverancier',0),(277684,7714,'fi','FUI toimittajan',0),(277685,7714,'no','FUI leverandÃ¸r',0),(277686,7714,'da','FUI leverandÃ¸r',0),(277687,7714,'ko','FUI ê³µê¸‰ ì—…ì²´',0),(277688,7714,'he','×”×¡×¤×§ FUI',0),(277689,7714,'el','FUI Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(277690,7714,'zh','å¸¸ç”¨æœ€åˆçš„ä¾›åº”å•†\r\n',0),(277691,7714,'sv','FUI leverantÃ¶r',0),(277692,7714,'it','FUI fornitore',0),(277693,7714,'tl','',0),(277694,7714,'th','FUI Vendor',0),(277695,7714,'hi','FUI à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(277696,7714,'ms','Penjual FUI',0),(277697,7714,'ar','Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(277698,7714,'fr','FUI fournisseur',0),(277699,7714,'jp','FUI ãƒ™ãƒ³ãƒ€ãƒ¼',0),(277700,7714,'pt','FUI vendedor',0),(277701,7714,'ru','FUI Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(277702,7714,'es','FUI Proveedor',0),(277703,7714,'de','FUI-Anbieter',0),(277704,7714,'en','FUI Vendor',0),(277705,7715,'is','',0),(277706,7715,'dr','FUI Ø¬Ø³ØªØ¬ÙˆÙŠ  Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(277707,7715,'pr','FUI Ø¬Ø³ØªØ¬ÙˆÙŠ  Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(277708,7715,'tr','FUI satÄ±cÄ± arama',0),(277709,7715,'pl','FUI dostawcy wyszukiwania',0),(277710,7715,'bg','FUI Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(277711,7715,'ur','ÙØ§ ÙˆÛŒÙ†ÚˆØ± Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(277712,7715,'sr','Ð—Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¡Ð¸Ñ‚Ð°',0),(277713,7715,'vi','TÃ¬m NgÆ°á»i bÃ¡n FUI',0),(277714,7715,'af','FUI handelaar opsoek',0),(277715,7715,'ro','CÄƒutare de furnizor FUI',0),(277716,7715,'et','FUI hankija otsing',0),(277717,7715,'si','Iskanje dobavitelja FUI',0),(277718,7715,'ba','FUI Vendor Lookup',0),(277719,7715,'nl','FUI leverancier opzoeken',0),(277720,7715,'fi','FUI toimittajan valinta',0),(277721,7715,'no','FUI leverandÃ¸r oppslag',0),(277722,7715,'da','FUI kreditor opslag',0),(277723,7715,'ko','FUI ê³µê¸‰ ì—…ì²´ ì¡°íšŒ',0),(277724,7715,'he','×‘×“×™×§×ª ×ž×™×“×¢ ×”×¡×¤×§ FUI',0),(277725,7715,'el','FUI Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(277726,7715,'zh','å¸¸ç”¨æœ€åˆçš„ä¾›åº”å•†æŸ¥æ‰¾\r\n',0),(277727,7715,'sv','FUI leverantÃ¶r Lookup',0),(277728,7715,'it','Ricerca fornitore FUI',0),(277729,7715,'tl','',0),(277730,7715,'th','FUI Vendor Lookup',0),(277731,7715,'hi','FUI à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤²à¥à¤•à¤…à¤ª',0),(277732,7715,'ms','Lookup penjual FUI',0),(277733,7715,'ar','Ø§Ù„Ø¨Ø­Ø« ÙÙŠ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(277734,7715,'fr','Recherche fournisseur FUI',0),(277735,7715,'jp','FUI ãƒ™ãƒ³ãƒ€ãƒ¼æ¤œç´¢',0),(277736,7715,'pt','FUI vendedor de pesquisa',0),(277737,7715,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² FUI',0),(277738,7715,'es','FUI Busca Proveedor',0),(277739,7715,'de','FUI Anbieter Lookup',0),(277740,7715,'en','FUI Vendor Lookup',0),(277741,7716,'is','',0),(277742,7716,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(277743,7716,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(277744,7716,'tr','Gelir vergisi satÄ±cÄ±',0),(277745,7716,'pl','Podatek dochodowy dostawcy',0),(277746,7716,'bg','Ð”Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð´Ð¾Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(277747,7716,'ur','Ø§Ù†Ú©Ù… Ù¹ÛŒÚ©Ø³ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(277748,7716,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð´Ð¾Ñ…Ð¾Ð´Ð°Ðº Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(277749,7716,'vi','Thuáº¿ thu nháº­p ngÆ°á»i bÃ¡n',0),(277750,7716,'af','Inkomste Belasting Verskaffer',0),(277751,7716,'ro','Furnizor de impozitul pe venit',0),(277752,7716,'et','Tulumaksu hankija',0),(277753,7716,'si','Dohodnini dobavitelja',0),(277754,7716,'ba','Pajak penghasilan Vendor',0),(277755,7716,'nl','Inkomstenbelasting leverancier',0),(277756,7716,'fi','Tulovero toimittajan',0),(277757,7716,'no','Inntektsskatt leverandÃ¸r',0),(277758,7716,'da','Indkomstskat leverandÃ¸r',0),(277759,7716,'ko','ì„¸ê¸ˆ ê³µê¸‰ ì—…ì²´',0),(277760,7716,'he','×”×¡×¤×§ ×ž×¡ ×”×›× ×¡×”',0),(277761,7716,'el','Î¦ÏŒÏÎ¿Ï‚ ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(277762,7716,'zh','å–æ–¹æ‰€å¾—ç¨Ž\r\n',0),(277763,7716,'sv','Inkomstskatt leverantÃ¶r',0),(277764,7716,'it','Fornitore di imposta sul reddito',0),(277765,7716,'tl','',0),(277766,7716,'th','&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(277767,7716,'hi','à¤†à¤¯à¤•à¤° à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(277768,7716,'ms','Penjual cukai pendapatan',0),(277769,7716,'ar','Ø§Ù„Ù…ÙˆØ±Ø¯ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯Ø®Ù„',0),(277770,7716,'fr','Fournisseur de lâ€™impÃ´t sur le revenu',0),(277771,7716,'jp','æ‰€å¾—ç¨Žãƒ™ãƒ³ãƒ€ãƒ¼',0),(277772,7716,'pt','Fornecedor de imposto de renda',0),(277773,7716,'ru','ÐŸÐ¾Ð´Ð¾Ñ…Ð¾Ð´Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(277774,7716,'es','Proveedor de Impuesto Sobre la Renta',0),(277775,7716,'de','Einkommensteuer-Anbieter',0),(277776,7716,'en','Income Tax Vendor',0),(277777,7717,'is','',0),(277778,7717,'dr','Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§ÙŠØ§Ù„ØªÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(277779,7717,'pr','Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§ÙŠØ§Ù„ØªÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(277780,7717,'tr','SUI satÄ±cÄ±',0),(277781,7717,'pl','Dostawcy SUI',0),(277782,7717,'bg','SUI Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(277783,7717,'ur','Ø³ÙˆØ¦ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(277784,7717,'sr','Ð¡Ð£Ð˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(277785,7717,'vi','NgÆ°á»i bÃ¡n SUI',0),(277786,7717,'af','SUI-handelaar',0),(277787,7717,'ro','SUI furnizor',0),(277788,7717,'et','SUI hankija',0),(277789,7717,'si','SUI dobavitelja',0),(277790,7717,'ba','SUI Vendor',0),(277791,7717,'nl','SUI leverancier',0),(277792,7717,'fi','SUI toimittajan',0),(277793,7717,'no','SUI leverandÃ¸r',0),(277794,7717,'da','SUI leverandÃ¸r',0),(277795,7717,'ko','ìˆ˜ì´ ê³µê¸‰ ì—…ì²´',0),(277796,7717,'he','×”×¡×¤×§ ×¡×•×•×™',0),(277797,7717,'el','SUI Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(277798,7717,'zh','SUIä¾›åº”å•†\r\n',0),(277799,7717,'sv','SUI leverantÃ¶r',0),(277800,7717,'it','SUI fornitori',0),(277801,7717,'tl','',0),(277802,7717,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(277803,7717,'hi','à¤¸à¥à¤‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(277804,7717,'ms','Penjual SUI',0),(277805,7717,'ar','Ù…ÙˆØ±Ø¯ ÙØ±ÙŠØ¯ Ù…Ù† Ù†ÙˆØ¹Ù‡',0),(277806,7717,'fr','SUI fournisseur',0),(277807,7717,'jp','éš‹ãƒ™ãƒ³ãƒ€ãƒ¼',0),(277808,7717,'pt','Fornecedor de SUI',0),(277809,7717,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð¡ÑƒÐ¹',0),(277810,7717,'es','SUI Proveedor',0),(277811,7717,'de','SUI-Hersteller',0),(277812,7717,'en','SUI Vendor',0),(277813,7718,'is','',0),(277814,7718,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§ÙŠØ§Ù„ØªÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(277815,7718,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§ÙŠØ§Ù„ØªÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(277816,7718,'tr','SUI satÄ±cÄ± arama',0),(277817,7718,'pl','SUI dostawcy wyszukiwania',0),(277818,7718,'bg','SUI Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(277819,7718,'ur','Ø³ÙˆØ¦ÛŒ ÙˆÛŒÙ†ÚˆØ± Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(277820,7718,'sr','Ð—Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¡Ð£Ð˜',0),(277821,7718,'vi','TÃ¬m NgÆ°á»i bÃ¡n SUI',0),(277822,7718,'af','SUI handelaar opsoek',0),(277823,7718,'ro','SUI furnizor de cÄƒutare',0),(277824,7718,'et','SUI hankija otsing',0),(277825,7718,'si','Iskanje dobavitelja SUI',0),(277826,7718,'ba','SUI Vendor Lookup',0),(277827,7718,'nl','SUI leverancier opzoeken',0),(277828,7718,'fi','SUI toimittajan valinta',0),(277829,7718,'no','SUI leverandÃ¸r oppslag',0),(277830,7718,'da','SUI kreditor opslag',0),(277831,7718,'ko','ìˆ˜ì´ ê³µê¸‰ ì—…ì²´ ì¡°íšŒ',0),(277832,7718,'he','×‘×“×™×§×ª ×¡×¤×§ ×¡×•×•×™',0),(277833,7718,'el','SUI Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(277834,7718,'zh','SUIä¾›åº”å•†æŸ¥æ‰¾\r\n',0),(277835,7718,'sv','SUI leverantÃ¶r Lookup',0),(277836,7718,'it','Ricerca fornitore SUI',0),(277837,7718,'tl','',0),(277838,7718,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(277839,7718,'hi','à¤¸à¥à¤‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤²à¥à¤•à¤…à¤ª',0),(277840,7718,'ms','Lookup penjual SUI',0),(277841,7718,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ù…ÙˆØ±Ø¯ ÙØ±ÙŠØ¯ Ù…Ù† Ù†ÙˆØ¹Ù‡',0),(277842,7718,'fr','Recherche fournisseur SUI',0),(277843,7718,'jp','éš‹ã®ä»•å…¥å…ˆã®ãƒ«ãƒƒã‚¯ã‚¢ãƒƒãƒ—',0),(277844,7718,'pt','Pesquisa de fornecedores de SUI',0),(277845,7718,'ru','Ð¡ÑƒÐ¹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¿Ð¾Ð¸ÑÐºÐ°',0),(277846,7718,'es','SUI Buscar Proveedor',0),(277847,7718,'de','SUI-Anbieter-Suche',0),(277848,7718,'en','SUI Vendor Lookup',0),(277849,7719,'is','',0),(277850,7719,'dr','Ú†Ùƒ Ù‡Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ø¯ÙƒÙ…Ù‡ Ù†Ù…Ø§ÙŠØ´ Ú†Ùƒ Ù‡Ø§ Ø±Ø§ Ø¬Ù‡Øª Ú†Ø§Ù¾ Ùˆ  Ù¾Ø§ÙŠØ§Ù† Ø¹Ù…Ù„ÙŠØ§Øª ÙØ´Ø§Ø± Ø¯Ù‡ÙŠØ¯',0),(277851,7719,'pr','Ú†Ùƒ Ù‡Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ø¯ÙƒÙ…Ù‡ Ù†Ù…Ø§ÙŠØ´ Ú†Ùƒ Ù‡Ø§ Ø±Ø§ Ø¬Ù‡Øª Ú†Ø§Ù¾ Ùˆ  Ù¾Ø§ÙŠØ§Ù† Ø¹Ù…Ù„ÙŠØ§Øª ÙØ´Ø§Ø± Ø¯Ù‡ÙŠØ¯',0),(277852,7719,'tr','OluÅŸturulan, Ã§ekleri basÄ±n gÃ¶rÃ¼nÃ¼mÃ¼ yazdÄ±rmak ve iÅŸleme bitirmek iÃ§in DENETLER.',0),(277853,7719,'pl','Kontrole generowane, naciÅ›nij przycisk widoku sprawdza do druku i przetwarzania zakoÅ„czyÄ‡',0),(277854,7719,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸, Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸, Ð½Ð°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸, Ð·Ð° Ð´Ð° Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚Ðµ Ð¸ Ñ„Ð¸Ð½Ð¸Ñˆ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(277855,7719,'ur','ØªØ®Ù„ÛŒÙ‚ØŒ Ú†ÛŒÚ© Ù¾Ø±ÛŒØ³ Ù…Ù†Ø¸Ø± Ú†Ú¾Ø§Ù¾ÛŒÚº Ø§ÙˆØ± Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ù…Ú©Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’',0),(277856,7719,'sr','Ð§ÐµÐºÐ¾Ð²Ðµ Ð³ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ð¾, Ð¿Ñ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð· ÐŸÐ ÐžÐ’Ð•Ð ÐÐ’Ð Ð´Ð° Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ‚Ðµ Ð¸ Ð´Ð° ÑÐµ Ð·Ð°Ð²Ñ€ÑˆÐ¸ Ð¾Ð±Ñ€Ð°Ð´Ð°',0),(277857,7719,'vi','ÄÃ£ táº¡o SÃ©c. Nháº¥n Xem SÃ©c Ä‘á»ƒ in & hoÃ n táº¥t',0),(277858,7719,'af','Tjeks gegenereer - druk BESIGTIG TJEKS Om Uitdruk en Prosessering te Voltooi',0),(277859,7719,'ro','Controalele generate, apÄƒsaÅ£i Vezi controale pentru a imprima ÅŸi termina procesarea',0),(277860,7719,'et','Kontrolli loodud, vajutage VIEW kontroll, printida ja tÃ¶Ã¶tlemise lÃµpetame',0),(277861,7719,'si','Pregledi, ki so ustvarjeni, pritisnite, PREVERI pogled za tiskanje in konÄa predelava',0),(277862,7719,'ba','Cek yang dihasilkan, tekan Lihat cek untuk mencetak dan menyelesaikan pengolahan',0),(277863,7719,'nl','Controles gegenereerd, druk op weergave controleert om te drukken en finish verwerking',0),(277864,7719,'fi','Tarkastusten syntyy, paina NÃ¤ytÃ¤ tarkastuksia tulostaa ja lopeta kÃ¤sittely',0),(277865,7719,'no','Sjekker generert, trykk Vis SJEKKER til Ã¥ skrive ut og behandling',0),(277866,7719,'da','Kontrol genereres, skal du trykke pÃ¥ Vis kontrol til at udskrive og afslutte behandlingen',0),(277867,7719,'ko','ìƒì„±, í™•ì¸ ëˆŒëŸ¬ ë³´ê¸°ë¥¼ ì¸ì‡„ í•˜ ê³  ì²˜ë¦¬ê°€ ì™„ë£Œ í™•ì¸',0),(277868,7719,'he','×”×ž×—××•×ª ×©×”×•×¤×§×•, ×”×§×© ×¢×œ ×ª×¦×•×’×” ×‘×•×“×§ ×›×“×™ ×œ×”×“×¤×™×¡ ×•×¡×™×•× ×¢×™×‘×•×“',0),(277869,7719,'el','Î•Î»Î­Î³Ï‡Î¿Ï…Ï‚ Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½Ï„Î±Î¹, Ï€Î±Ï„Î®ÏƒÏ„Îµ Î Î¡ÎŸÎ’ÎŸÎ›Î‰ Î•Î›ÎˆÎ“Î§Î•Î™ Î½Î± ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ ÎºÎ±Î¹ Î½Î± Ï„ÎµÎ»ÎµÎ¹ÏŽÏƒÎµÎ¹ Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(277870,7719,'zh','æ£€æŸ¥ç”Ÿæˆçš„ï¼ŒæŒ‰VIEWæ£€æŸ¥ï¼Œä»¥å°åˆ·å’Œå®Œæˆå¤„ç†\r\n',0),(277871,7719,'sv','Kontroller som genereras, tryck pÃ¥ Visa kontrollerar att skriva ut och avsluta bearbetning',0),(277872,7719,'it','Controlli generati, premere vista controlla da stampare e completare l\'elaborazione',0),(277873,7719,'tl','',0),(277874,7719,'th','&#3648;&#3594;&#3655;&#3588;&#3652;&#3604;&#3657;&#3626;&#3619;&#3657;&#3634;&#3591;&#3586;&#3638;&#3657;&#3609; &#3585;&#3604;&#3604;&#3641;&#3648;&#3594;&#3655;&#3588;&#3648;&#3614;&#3639;&#3656;&#3629;&#3614;&#3636;&#3617;&#3614;&#3660;&#3649;&#3621;&#',0),(277875,7719,'hi','à¤šà¥‡à¤• à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨, à¤ªà¥à¤°à¥‡à¤¸ à¤¦à¥ƒà¤¶à¥à¤¯ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤–à¤¤à¥à¤® à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(277876,7719,'ms','Pemeriksaan yang dijana, tekan VIEW menyemak untuk mencetak dan melengkapkan proses',0),(277877,7719,'ar','Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ØŒ Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ \"Ø¹Ø±Ø¶ Ø§Ù„Ø´ÙŠÙƒØ§Øª\" Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©ØŒ ÙˆØ§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ù…Ù† ØªØ¬Ù‡ÙŠØ²',0),(277878,7719,'fr','ContrÃ´les gÃ©nÃ©rÃ©s, appuyez sur Affichage vÃ©rifie d\'imprimer et de terminer le traitement',0),(277879,7719,'jp','ç”Ÿæˆã•ã‚Œã‚‹ã¨ã€ãƒã‚§ãƒƒã‚¯ã‚’å°åˆ·ã—ã€å‡¦ç†ã‚’å®Œäº†è¡¨ç¤ºã‚’ç¢ºèªã—ã‚­ãƒ¼ã‚’æŠ¼ã—ã¾ã™',0),(277880,7719,'pt','Cheques gerados, prima vista verifica para imprimir e terminar o processamento',0),(277881,7719,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸ ÑÐ¾Ð·Ð´Ð°Ð½, Ð½Ð°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð²Ð¸Ð´ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚ Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð¸ Ð·Ð°ÐºÐ¾Ð½Ñ‡Ð¸Ñ‚ÑŒ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÑƒ',0),(277882,7719,'es','Cheques generados, Oprimir \"VER CHEQUES\" para imprimir y terminar el Procedimiento',0),(277883,7719,'de','Kontrollen generiert, drÃ¼cken Sie zum Drucken und Fertigstellen Verarbeitung-VIEW-CHECKS',0),(277884,7719,'en','Checks generated, press VIEW CHECKS to print and finish processing',0),(277885,7720,'is','',0),(277886,7720,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(277887,7720,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(277888,7720,'tr','Banka mevduat gÃ¼ncelleÅŸtirme',0),(277889,7720,'pl','Aktualizacja banku depozyt',0),(277890,7720,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(277891,7720,'ur','Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(277892,7720,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð±Ð°Ð½ÐºÐµ',0),(277893,7720,'vi','Cáº­p Nháº­t Äáº·t Cá»c NgÃ¢n hÃ ng',0),(277894,7720,'af','Bank Deposito Opdatering',0),(277895,7720,'ro','Actualizare de depozit bancar',0),(277896,7720,'et','Panga hoiuste Update',0),(277897,7720,'si','BanÄni depozit posodobitev',0),(277898,7720,'ba','Bank Deposit Update',0),(277899,7720,'nl','Bank storting Update',0),(277900,7720,'fi','Pankki Internet Update',0),(277901,7720,'no','Banken innskudd oppdatering',0),(277902,7720,'da','Bank depositum opdatering',0),(277903,7720,'ko','ì€í–‰ ì˜ˆê¸ˆ ì—…ë°ì´íŠ¸',0),(277904,7720,'he','×¢×“×›×•×Ÿ ×¤×§×“×•×Ÿ ×‘× ×§',0),(277905,7720,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(277906,7720,'zh','é“¶è¡Œå­˜æ¬¾æ›´æ–°\r\n',0),(277907,7720,'sv','Bank insÃ¤ttning uppdatering',0),(277908,7720,'it','Aggiornamento di deposito bancario',0),(277909,7720,'tl','',0),(277910,7720,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(277911,7720,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(277912,7720,'ms','Kemaskini Deposit Bank',0),(277913,7720,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(277914,7720,'fr','Mise Ã  jour de dÃ©pÃ´t de banque',0),(277915,7720,'jp','éŠ€è¡Œé é‡‘ã®æ›´æ–°',0),(277916,7720,'pt','AtualizaÃ§Ã£o de depÃ³sito de banco',0),(277917,7720,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(277918,7720,'es','Actualizar Deposito Bancario',0),(277919,7720,'de','Bank Deposit Update',0),(277920,7720,'en','Bank Deposit Update',0),(277921,7721,'is','',0),(277922,7721,'dr','Ø­Ø³Ø§Ø¨ Ø°Ø®ÙŠØ±Ù‡ Ø¨Ù‡ ',0),(277923,7721,'pr','Ø­Ø³Ø§Ø¨ Ø°Ø®ÙŠØ±Ù‡ Ø¨Ù‡ ',0),(277924,7721,'tr','Hesap iÃ§in yatÄ±rÄ±lÄ±r',0),(277925,7721,'pl','Zdeponowane na rachunku',0),(277926,7721,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ€Ð°Ð½Ð¸',0),(277927,7721,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ø¬Ù…Ø¹',0),(277928,7721,'sr','Ð Ð°Ñ‡ÑƒÐ½ ÑƒÐ¿Ð»Ð°Ñ›ÐµÐ½ Ð½Ð°',0),(277929,7721,'vi','TK Ghi Ná»£ VÃ o',0),(277930,7721,'af','Rekening Gedeponeer Na',0),(277931,7721,'ro','Cont depus la',0),(277932,7721,'et','Konto hoiule',0),(277933,7721,'si','Nakazana na raÄun',0),(277934,7721,'ba','Akun Disimpan ke',0),(277935,7721,'nl','Rekening gestort op',0),(277936,7721,'fi','Tilille talletetut',0),(277937,7721,'no','Konto avsatt til',0),(277938,7721,'da','Konto indbetalt til',0),(277939,7721,'ko','ê³„ì •ì— ì˜ˆì¹˜',0),(277940,7721,'he','×—×©×‘×•×Ÿ ×©×”×•×¤×§×“×• ×¢×“',0),(277941,7721,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÏ„Î¿Î½',0),(277942,7721,'zh','è´¦æˆ·å­˜å…¥\r\n',0),(277943,7721,'sv','Konto som deponeras till',0),(277944,7721,'it','Conto depositato a',0),(277945,7721,'tl','',0),(277946,7721,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(277947,7721,'hi','à¤–à¤¾à¤¤à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤®à¤¾ à¤•à¤¿à¤¯à¤¾',0),(277948,7721,'ms','Didepositkan ke akaun',0),(277949,7721,'ar','Ø£ÙˆØ¯Ø¹ ÙÙŠ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(277950,7721,'fr','Compte dÃ©posÃ© Ã ',0),(277951,7721,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã«å…¥é‡‘',0),(277952,7721,'pt','Conta depositada para',0),(277953,7721,'ru','Ð—Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ñ‹ Ð½Ð° ÑÑ‡ÐµÑ‚',0),(277954,7721,'es','Depositado en Cuenta',0),(277955,7721,'de','Konto hinterlegt',0),(277956,7721,'en','Account Deposited To',0),(277957,7722,'is','',0),(277958,7722,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(277959,7722,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(277960,7722,'tr','Geri Ã¶deme miktarÄ±',0),(277961,7722,'pl','Kwota refundacji',0),(277962,7722,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½ÐµÑ‚Ð¾',0),(277963,7722,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©ÛŒ Ø±Ù‚Ù…',0),(277964,7722,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°',0),(277965,7722,'vi','Sá»‘ Tiá»n HoÃ n Tráº£',0),(277966,7722,'af','Bedrag van terugbetaling',0),(277967,7722,'ro','Valoarea restituirii',0),(277968,7722,'et','Toetuse suurus',0),(277969,7722,'si','Znesek nadomestila',0),(277970,7722,'ba','Jumlah pengembalian uang',0),(277971,7722,'nl','Bedrag van de restitutie',0),(277972,7722,'fi','Tuen mÃ¤Ã¤rÃ¤',0),(277973,7722,'no','Mengden av tilbakebetaling',0),(277974,7722,'da','Restitution',0),(277975,7722,'ko','í™˜ë¶ˆ ì•¡',0),(277976,7722,'he','×¡×›×•× ×”×”×—×–×¨',0),(277977,7722,'el','Î Î¿ÏƒÏŒ Ï„Î·Ï‚ ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚',0),(277978,7722,'zh','é€€æ¬¾é‡‘é¢\r\n',0),(277979,7722,'sv','Bidragsbeloppet',0),(277980,7722,'it','Importo della restituzione',0),(277981,7722,'tl','',0),(277982,7722,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3607;&#3637;&#3656;&#3588;&#3639;&#3609;',0),(277983,7722,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¥€ à¤°à¤¾à¤¶à¤¿',0),(277984,7722,'ms','Jumlah bayaran balik',0),(277985,7722,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù„Ù„Ù…ÙˆØ¸Ù',0),(277986,7722,'fr','Montant de la restitution',0),(277987,7722,'jp','æ‰•ã„æˆ»ã—é‡‘é¡',0),(277988,7722,'pt','Montante da restituiÃ§Ã£o',0),(277989,7722,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð²Ð¾Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ñ',0),(277990,7722,'es','Monto de DevoluciÃ³n',0),(277991,7722,'de','Erstattungsbetrag',0),(277992,7722,'en','Amount of Refund',0),(277993,7723,'is','',0),(277994,7723,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª',0),(277995,7723,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª',0),(277996,7723,'tr','Geri Ã¶deme oluÅŸtur',0),(277997,7723,'pl','Tworzenie refundacji',0),(277998,7723,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(277999,7723,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(278000,7723,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°',0),(278001,7723,'vi','Táº¡o hoÃ n tráº£',0),(278002,7723,'af','Skep terugbetaling',0),(278003,7723,'ro','Crea restituire',0),(278004,7723,'et','Luua toetust',0),(278005,7723,'si','Ustvarite nadomestila',0),(278006,7723,'ba','Membuat pengembalian dana',0),(278007,7723,'nl','Maken van restitutie',0),(278008,7723,'fi','Luo hyvitys',0),(278009,7723,'no','Opprette tilbakebetaling',0),(278010,7723,'da','Oprette restitution',0),(278011,7723,'ko','í™˜ë¶ˆì„ ë§Œë“¤ê¸°',0),(278012,7723,'he','×™×¦×™×¨×ª ×”×—×–×¨',0),(278013,7723,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚',0),(278014,7723,'zh','åˆ›å»ºé€€æ¬¾\r\n',0),(278015,7723,'sv','Skapa Ã¥terbetalning',0),(278016,7723,'it','Creare il rimborso',0),(278017,7723,'tl','',0),(278018,7723,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;',0),(278019,7723,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤¬à¤¨à¤¾à¤à¤',0),(278020,7723,'ms','Membuat bayaran balik',0),(278021,7723,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø±Ø¯',0),(278022,7723,'fr','CrÃ©er le remboursement',0),(278023,7723,'jp','æ‰•ã„æˆ»ã—ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(278024,7723,'pt','Criar o reembolso',0),(278025,7723,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚',0),(278026,7723,'es','Crear DevoluciÃ³n',0),(278027,7723,'de','Erstattung zu erstellen',0),(278028,7723,'en','Create Refund',0),(278029,7724,'is','',0),(278030,7724,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(278031,7724,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(278032,7724,'tr','Hata oluÅŸturma iadesi',0),(278033,7724,'pl','BÅ‚Ä…d tworzenia refundacji',0),(278034,7724,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(278035,7724,'ur','Ù†Ù‚Øµ Ù¾ÛŒØ¯Ø§ Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(278036,7724,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ñ€ÐµÑ„ÑƒÐ½Ð´Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(278037,7724,'vi','Lá»—i táº¡o hoÃ n láº¡i',0),(278038,7724,'af','Fout skep terugbetaling',0),(278039,7724,'ro','Eroare crearea de restituire',0),(278040,7724,'et','TÃµrke loomise toetus',0),(278041,7724,'si','Napaka pri ustvarjanju nadomestila',0),(278042,7724,'ba','Kesalahan membuat pengembalian',0),(278043,7724,'nl','Fout maken van restitutie',0),(278044,7724,'fi','Virhe luodaan palautus',0),(278045,7724,'no','Feil under oppretting av refusjon',0),(278046,7724,'da','Fejl skaber restitution',0),(278047,7724,'ko','ì˜¤ë¥˜ ë§Œë“¤ê¸° í™˜ë¶ˆ',0),(278048,7724,'he','×©×’×™××ª ×™×¦×™×¨×ª ×”×—×–×¨',0),(278049,7724,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±Ï‚ ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚',0),(278050,7724,'zh','é”™è¯¯åˆ›å»ºé€€æ¬¾',0),(278051,7724,'sv','Fel att skapa Ã¥terbetalning',0),(278052,7724,'it','Errore creazione di rimborso',0),(278053,7724,'tl','',0),(278054,7724,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;',0),(278055,7724,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤µà¤¾à¤ªà¤¸à¥€ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡',0),(278056,7724,'ms','Ralat mencipta balik',0),(278057,7724,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø®Ø·Ø£',0),(278058,7724,'fr','Erreur crÃ©ation de remboursement',0),(278059,7724,'jp','ã‚¨ãƒ©ãƒ¼ã‚’ä½œæˆã™ã‚‹æ‰•ã„æˆ»ã—',0),(278060,7724,'pt','Erro criando restituiÃ§Ã£o',0),(278061,7724,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚',0),(278062,7724,'es','Error Creando DevoluciÃ³n',0),(278063,7724,'de','Fehler erstellen Erstattung',0),(278064,7724,'en','Error Creating Refund',0),(278065,7725,'is','',0),(278066,7725,'dr','Ø¯Ø± Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª  Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(278067,7725,'pr','Ø¯Ø± Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª  Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(278068,7725,'tr','Geri Ã¶deme dahil',0),(278069,7725,'pl','ZawieraÄ‡ w refundacji',0),(278070,7725,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð¸ Ð² Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(278071,7725,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(278072,7725,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ Ñƒ Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°',0),(278073,7725,'vi','Bao gá»“m trong hoÃ n vÃ©',0),(278074,7725,'af','Ingesluit in Terugbetaling',0),(278075,7725,'ro','Include Ã®n restituire',0),(278076,7725,'et','Toetuse hulka',0),(278077,7725,'si','VkljuÄujejo nadomestila',0),(278078,7725,'ba','Termasuk dalam pengembalian dana',0),(278079,7725,'nl','Opnemen in restitutie',0),(278080,7725,'fi','SisÃ¤ltÃ¤Ã¤ tuen',0),(278081,7725,'no','Inkludere i tilbakebetaling',0),(278082,7725,'da','Omfatte i refusion',0),(278083,7725,'ko','í™˜ë¶ˆì— í¬í•¨',0),(278084,7725,'he','×›×œ×•×œ ×”×—×–×¨',0),(278085,7725,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ ÏƒÏ„Î·Î½ ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(278086,7725,'zh','åŒ…æ‹¬é€€æ¬¾\r\n',0),(278087,7725,'sv','Inkludera i Ã¥terbetalning',0),(278088,7725,'it','Includere nel rimborso',0),(278089,7725,'tl','',0),(278090,7725,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;',0),(278091,7725,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(278092,7725,'ms','Termasuk dalam bayaran balik',0),(278093,7725,'ar','ÙˆØªØ´Ù…Ù„ ÙÙŠ Ø§Ø³ØªØ±Ø¯Ø§Ø¯',0),(278094,7725,'fr','Inclure dans le remboursement',0),(278095,7725,'jp','ã»ã‹ã®æ‰•ã„æˆ»ã—',0),(278096,7725,'pt','Incluem-se na restituiÃ§Ã£o',0),(278097,7725,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð² Ð²Ð¾Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ðµ',0),(278098,7725,'es','Incluir en la DevoluciÃ³n',0),(278099,7725,'de','FÃ¼gen Sie in RÃ¼ckerstattung',0),(278100,7725,'en','Include in Refund',0),(278101,7726,'is','',0),(278102,7726,'dr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯',0),(278103,7726,'pr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯',0),(278104,7726,'tr','Ä°ade baâ– arÂ²yla oluâ– turuldu',0),(278105,7726,'pl','Refundacji zostaÅ‚ utworzony pomyÅ›lnie',0),(278106,7726,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(278107,7726,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ù†Ø§ÛŒØ§ Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(278108,7726,'sr','ÐŸÐ¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°',0),(278109,7726,'vi','Táº¡o hoÃ n tráº£ thÃ nh cÃ´ng',0),(278110,7726,'af','Terugbetaling Suksesvol Geskep',0),(278111,7726,'ro','Restituirea creat cu succes',0),(278112,7726,'et','Toetus on edukalt loodud',0),(278113,7726,'si','Nadomestila, uspeÅ¡no ustvarjen',0),(278114,7726,'ba','Pengembalian yang dibuat dengan sukses',0),(278115,7726,'nl','Terugbetaling met succes gemaakt',0),(278116,7726,'fi','Tuen luonti onnistui',0),(278117,7726,'no','Tilbakebetaling opprettet',0),(278118,7726,'da','Restitutionen oprettet',0),(278119,7726,'ko','ì„±ê³µì ìœ¼ë¡œ ë§Œë“  í™˜ë¶ˆ',0),(278120,7726,'he','×”×—×–×¨ × ×•×¦×¨×• ×‘×”×¦×œ×—×”',0),(278121,7726,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(278122,7726,'zh','é€€æ¬¾æˆåŠŸåˆ›å»º\r\n',0),(278123,7726,'sv','Ã…terbetalning har skapats',0),(278124,7726,'it','Rimborso creato con successo',0),(278125,7726,'tl','',0),(278126,7726,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(278127,7726,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¥‡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(278128,7726,'ms','Bayaran balik yang berjaya dicipta',0),(278129,7726,'ar','Ø§Ø³ØªØ±Ø¯Ø§Ø¯ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(278130,7726,'fr','Remboursement crÃ©Ã© avec succÃ¨s',0),(278131,7726,'jp','æ­£å¸¸ã«ä½œæˆã•ã‚ŒãŸæ‰•ã„æˆ»ã—',0),(278132,7726,'pt','RestituiÃ§Ã£o criada com sucesso',0),(278133,7726,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½',0),(278134,7726,'es','Reembolso Creado Exitosamente',0),(278135,7726,'de','Erstattung wurde erfolgreich erstellt.',0),(278136,7726,'en','Refund Created Successfully',0),(278137,7727,'is','',0),(278138,7727,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù†ÙŠØ³Øª',0),(278139,7727,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù†ÙŠØ³Øª',0),(278140,7727,'tr','Kredi kartÄ± iÅŸlemleri geÃ§ersiz kÄ±lamazsÄ±nÄ±z',0),(278141,7727,'pl','Nie moÅ¼na uniewaÅ¼niÄ‡ transakcji kartÄ… kredytowÄ…',0),(278142,7727,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(278143,7727,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù„ÛŒÙ† Ø¯ÛŒÙ† ØµÙØ± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(278144,7727,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°Ð¼Ð°',0),(278145,7727,'vi','KhÃ´ng thá»ƒ vÃ´ hiá»‡u giao dá»‹ch báº±ng tháº» tÃ­n dá»¥ng',0),(278146,7727,'af','Kan Nie Kredietkaardtransaksies \"void\"',0),(278147,7727,'ro','Nu anulaÅ£i tranzacÅ£iile cu cÄƒrÅ£i de Credit',0),(278148,7727,'et','TÃ¼histada ei saa teostatud',0),(278149,7727,'si','Ne morem Void transakcije s kreditno kartico',0),(278150,7727,'ba','Tidak dapat membatalkan transaksi kartu kredit',0),(278151,7727,'nl','Credit Card transacties kan niet Void',0),(278152,7727,'fi','Ei voi mitÃ¤tÃ¶idÃ¤ luottokorttitapahtumat',0),(278153,7727,'no','Kan ikke annullere kredittkorttransaksjoner',0),(278154,7727,'da','Kan ikke afvise kreditkorttransaktioner',0),(278155,7727,'ko','ì‹ ìš© ì¹´ë“œ ê±°ëž˜ë¥¼ ì·¨ì†Œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(278156,7727,'he','×œ× ×œ×‘×˜×œ ××ª ×ª×•×§×¤×” ×ª× ×•×¢×•×ª ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(278157,7727,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±ÎºÏ…ÏÏŽÏƒÎµÎ¹ Ï„Î¹Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(278158,7727,'zh','ä¸å…ä¿¡ç”¨å¡äº¤æ˜“\r\n',0),(278159,7727,'sv','GÃ¥r inte att annullera kreditkortstransaktioner',0),(278160,7727,'it','Non Ã¨ possibile annullare le transazioni con carta di credito',0),(278161,7727,'tl','',0),(278162,7727,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3585;&#3633;&#3610;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3652;&#3',0),(278163,7727,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤¶à¥‚à¤¨à¥à¤¯ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(278164,7727,'ms','Tidak boleh membatalkan transaksi kad kredit',0),(278165,7727,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥ÙØ±Ø§Øº Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(278166,7727,'fr','Ne peut pas annuler les Transactions par carte de crÃ©dit',0),(278167,7727,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ãŒç„¡åŠ¹ã«ã§ãã¾ã›ã‚“ã€‚',0),(278168,7727,'pt','NÃ£o pode anular transaÃ§Ãµes de cartÃ£o de crÃ©dito',0),(278169,7727,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¼ ÐºÐ°Ñ€Ñ‚Ð°Ð¼',0),(278170,7727,'es','No se puede Anular Transacciones de Tarjeta de Credito',0),(278171,7727,'de','Kreditkarten-Transaktionen kÃ¶nnen nicht storniert werden.',0),(278172,7727,'en','Cannot Void Credit Card Transactions',0),(278173,7728,'is','',0),(278174,7728,'dr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ø·Ù„ Ø´Ø¯ ',0),(278175,7728,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ø·Ù„ Ø´Ø¯ ',0),(278176,7728,'tr','SipariÅŸ Ã¶deme boÅŸluÄŸu',0),(278177,7728,'pl','Void zÅ‚oÅ¼enia zamÃ³wienia',0),(278178,7728,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Void',0),(278179,7728,'ur','Ø¢Ø±ÚˆØ± Ø¬Ù…Ø¹ Ø®Ù„Ø§',0),(278180,7728,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ñƒ',0),(278181,7728,'vi','VÃ´ hiá»‡u Ä‘áº·t cá»c Ä‘Æ¡n hÃ ng',0),(278182,7728,'af','Bestelling Deposito\'s \"Void\"',0),(278183,7728,'ro','Ordinul depozit Void',0),(278184,7728,'et','Tellimuse tagatisraha Void',0),(278185,7728,'si','NaroÄilo depozita praznino',0),(278186,7728,'ba','Urutan penyimpanan Void',0),(278187,7728,'nl','Volgorde storting Void',0),(278188,7728,'fi','Jotta Internet Void',0),(278189,7728,'no','For innskudd Void',0),(278190,7728,'da','Bestil depositum tomrum',0),(278191,7728,'ko','ì£¼ë¬¸ ìž…ê¸ˆ ë¬´íš¨',0),(278192,7728,'he','×¦×• ×”×¤×§×“×” Void',0),(278193,7728,'el','Î£ÎµÎ¹ÏÎ¬ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½ ÎºÎµÎ½ÏŒ',0),(278194,7728,'zh','è®¢å•å­˜æ¬¾æ— æ•ˆ\r\n',0),(278195,7728,'sv','Ordning insÃ¤ttning Void',0),(278196,7728,'it','Ordine deposito vuoto',0),(278197,7728,'tl','',0),(278198,7728,'th','&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(278199,7728,'hi','à¤•à¥à¤°à¤® à¤œà¤®à¤¾ à¤¶à¥‚à¤¨à¥à¤¯',0),(278200,7728,'ms','Perintah Deposit kekosongan',0),(278201,7728,'ar','Ø£Ù…Ø± Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„ÙØ±Ø§Øº',0),(278202,7728,'fr','Ordre dÃ©pÃ´t vide',0),(278203,7728,'jp','é †åºé é‡‘ãƒœã‚¤ãƒ‰',0),(278204,7728,'pt','Ordem depÃ³sito vazio',0),(278205,7728,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Void',0),(278206,7728,'es','DepÃ³sito de Pedido Anulado',0),(278207,7728,'de','Bestellung Anzahlung Void',0),(278208,7728,'en','Order Deposit Void',0),(278209,7729,'is','',0),(278210,7729,'dr','Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´Ø¯Ù‡ â€“ Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± ØµØ§Ø¯Ø± ÙƒÙ†ÙŠØ¯ ',0),(278211,7729,'pr','Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ø·Ù„ ÙƒØ±Ø¯Ù† ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´Ø¯Ù‡ â€“ Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± ØµØ§Ø¯Ø± ÙƒÙ†ÙŠØ¯ ',0),(278212,7729,'tr','Ä°ÅŸlenmiÅŸ bir kredi kartÄ± iptal iÃ§in bir alacak dekontu kesmeniz gerekir.',0),(278213,7729,'pl','Do uniewaÅ¼nienia karty kredytowej przetworzonych, naleÅ¼y wystawiÄ‡ fakturÄ™ korygujÄ…cÄ…',0),(278214,7729,'bg','Ð—Ð° Ð´Ð° ÐÐÐ£Ð›Ð˜Ð ÐÐ¢Ð• Ð¿Ñ€ÐµÑ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°, Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð´Ð°Ð´Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(278215,7729,'ur','Ø¹Ù…Ù„Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Ùˆ ØµÙØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ØŒ Ø¢Ù¾ Ú©Ùˆ Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ Ø¬Ø§Ø±ÛŒ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(278216,7729,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¡Ð¢ÐžÐ ÐÐ˜Ð ÐÐ›Ð˜ Ð¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ, Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑÐµ Ð¸Ð·Ð´Ð°Ð²Ð°ÑšÐµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐ°',0),(278217,7729,'vi','Äá»‚ VÃ” HIá»†U má»™t tháº» tÃ­n dá»¥ng Ä‘Ã£ xá»­ lÃ½ báº¡n cáº§n xuáº¥t 1 ghj chÃº tÃ­n dá»¥ng',0),(278218,7729,'af','Om VOID \'n verwerkte kredietkaart, moet jy \'n krediet memo uitreik',0),(278219,7729,'ro','Pentru a anula un card de credit prelucrate, aveÅ£i nevoie pentru a elibera o notÄƒ de credit',0),(278220,7729,'et','TÃ¼hista tÃ¶Ã¶deldud krediitkaarti, peate kreeditarve vÃ¤ljastamise',0),(278221,7729,'si','NIÄŒNA predelanih kreditno kartico, morate izdati dobropis',0),(278222,7729,'ba','Membatalkan kartu kredit diproses, Anda perlu untuk menerbitkan memo kredit',0),(278223,7729,'nl','Als u wilt vernietigen een verwerkte credit card, moet u een creditnota geven',0),(278224,7729,'fi','MitÃ¤tÃ¶idÃ¤ jalostettujen luottokortilla, sinun tÃ¤ytyy hyvityslaskun',0),(278225,7729,'no','Hvis du vil unngÃ¥ behandlet kredittkort, mÃ¥ du utstede en kreditnota',0),(278226,7729,'da','Hvis du vil annullere en forarbejdede kreditkort, skal du udstede en kreditnota',0),(278227,7729,'ko','ë¬´íš¨ë¡œ ì²˜ë¦¬ ì‹ ìš© ì¹´ë“œ, ì‹ ìš© ë©”ëª¨ë¥¼ ë°œí–‰ í•´ì•¼',0),(278228,7729,'he','×›×“×™ ×œ×‘×˜×œ ×›×¨×˜×™×¡ ××©×¨××™ ×ž×¢×•×‘×“×™×, ××ª×” ×¦×¨×™×š ×œ×”×•×¦×™× ×ª×–×›×™×¨ ××©×¨××™',0),(278229,7729,'el','Î“Î¹Î± Î½Î± Î‘ÎšÎ¥Î¡ÎÎ£Î•Î¤Î• Î¼Î¹Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½, Î¸Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎºÎ´ÏŽÏƒÎµÎ¹ Î­Î½Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(278230,7729,'zh','ä¸ºä½œåºŸå¤„ç†è¿‡ä¿¡ç”¨å¡ï¼Œä½ éœ€è¦å‘å‡ºä¸€ä¸ªä¿¡ç”¨å¤‡å¿˜å½•\r\n',0),(278231,7729,'sv','Om du vill MAKULERA en bearbetade kreditkort, mÃ¥ste du utfÃ¤rda en kreditnota',0),(278232,7729,'it','Per annullare una carta di credito trasformata, Ã¨ necessario emettere una nota di credito',0),(278233,7729,'tl','',0),(278234,7729,'th','To VOID a processed credit card, you need to issue a credit memo',0),(278235,7729,'hi','à¤à¤• à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¥ƒà¤¤ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤†à¤ª à¤à¤• à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤®à¥à¤¦à¥à¤¦à¥‡ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(278236,7729,'ms','Untuk membatalkan kad kredit yang diproses, anda perlu mengeluarkan memo kredit',0),(278237,7729,'ar','Ù„Ø¥Ù„ØºØ§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù…Ø¬Ù‡Ø²Ø©ØŒ ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ Ø¥ØµØ¯Ø§Ø± Ù…Ø°ÙƒØ±Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(278238,7729,'fr','Pour annuler une carte de crÃ©dit transformÃ©e, vous devez Ã©mettre une note de crÃ©dit',0),(278239,7729,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ãƒ¡ãƒ¢ã‚’ç™ºè¡Œã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®å‡¦ç†ã‚’ç„¡åŠ¹ã«ã™ã‚‹ã«ã¯ã€',0),(278240,7729,'pt','Para anular um cartÃ£o de crÃ©dito processado, vocÃª precisa emitir uma nota de crÃ©dito',0),(278241,7729,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½Ð½Ñ‹Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹, Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð´Ð°Ñ‚ÑŒ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ð°',0),(278242,7729,'es','Para ANULAR una tarjeta de crÃ©dito procesado, necesita emitir un memo de crÃ©dito',0),(278243,7729,'de','Um eine verarbeitete Kreditkarte VOID, mÃ¼ssen Sie eine Gutschrift ausstellen',0),(278244,7729,'en','To VOID a processed credit card, you need to issue a credit memo',0),(278245,7730,'is','',0),(278246,7730,'dr','ÙÙ‚Ø· Ø¨Ø¯Ù‡ÙŠ Ù‚Ø¨Ù„ÙŠ',0),(278247,7730,'pr','ÙÙ‚Ø· Ø¨Ø¯Ù‡ÙŠ Ù‚Ø¨Ù„ÙŠ',0),(278248,7730,'tr','Sadece nedeniyle geÃ§miÅŸ',0),(278249,7730,'pl','Przeterminowane tylko',0),(278250,7730,'bg','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð° ÑÐ°Ð¼Ð¾',0),(278251,7730,'ur','Ù…Ø§Ø¶ÛŒ ÛÛŒ Ú©ÛŒ ÙˆØ¬Û Ø³Û’',0),(278252,7730,'sr','Ð—Ð°Ð¿Ð°Ð´Ð»Ð¸Ñ… Ñ˜ÐµÐ´Ð¸Ð½Ð¸',0),(278253,7730,'vi','Chá»‰ quÃ¡ háº¡n thÃ´i',0),(278254,7730,'af','Verlede sperdatum net',0),(278255,7730,'ro','Trecut datorate numai',0),(278256,7730,'et','Ainult tÃ¤htaja Ã¼letanud',0),(278257,7730,'si','Zapadlih dolgovanih le',0),(278258,7730,'ba','Masa lalu hanya',0),(278259,7730,'nl','Verleden wegens enige',0),(278260,7730,'fi','ErÃ¤Ã¤ntyneiden vain',0),(278261,7730,'no','Forfalte bare',0),(278262,7730,'da','Forfaldne kun',0),(278263,7730,'ko','ë§Œ ì—°ì²´',0),(278264,7730,'he','×©×ž×•×¢×“ ×”×ª×©×œ×•× ×©×œ×”× ×”×™×—×™×“×”',0),(278265,7730,'el','Î Î±ÏÎµÎ»Î¸ÏŒÎ½ Î»ÏŒÎ³Ï‰ Î¼ÏŒÎ½Î¿',0),(278266,7730,'zh','é€¾æœŸä»…\r\n',0),(278267,7730,'sv','FÃ¶rfallna endast',0),(278268,7730,'it','Passato dovuta solo',0),(278269,7730,'tl','',0),(278270,7730,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3594;&#3656;&#3623;&#3591;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3617;&#3634;',0),(278271,7730,'hi','à¤•à¤¾à¤°à¤£ à¤¹à¥€ à¤…à¤¤à¥€à¤¤',0),(278272,7730,'ms','Masa lalu kerana hanya',0),(278273,7730,'ar','Ø§Ù„Ù…Ø§Ø¶ÙŠ Ø¨Ø³Ø¨Ø¨ ÙÙ‚Ø·',0),(278274,7730,'fr','Souffrance seule',0),(278275,7730,'jp','éŽåŽ»ã®å”¯ä¸€ã®åŽŸå› ',0),(278276,7730,'pt','Passado devido Ãºnica',0),(278277,7730,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ.',0),(278278,7730,'es','Solo Atrasados',0),(278279,7730,'de','Nur Ã¼berfÃ¤llig',0),(278280,7730,'en','Past Due Only',0),(278281,7731,'is','',0),(278282,7731,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù†Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ†  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(278283,7731,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù†Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ†  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(278284,7731,'tr','Bunu geri istiyor musunuz',0),(278285,7731,'pl','Czy na pewno chcesz cofnÄ…Ä‡ to',0),(278286,7731,'bg','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ Ð»Ð¸ ÑÑ‚Ðµ, Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð’ÐªÐ—Ð¡Ð¢ÐÐÐžÐ’Ð˜Ð¢Ð• Ñ‚Ð¾Ð²Ð°',0),(278287,7731,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ÛŒÛ Ø­Ø°Ù Ø®ØªÙ… Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº',0),(278288,7731,'sr','ÐˆÐµÑÐ¸ Ð»Ð¸ ÑÐ¸Ð³ÑƒÑ€Ð°Ð½ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñˆ Ð¾Ð²Ð¾ Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð±Ñ€Ð¸ÑÐ°ÑšÐ°',0),(278289,7731,'vi','KHÃ”NG XÃ“A?',0),(278290,7731,'af','Is u seker u wil hierdie Uitwissing ONGEDAAN maak?',0),(278291,7731,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ UNDELETE acest lucru',0),(278292,7731,'et','Oled kindel, et soovid kustutamise tÃ¼histada?',0),(278293,7731,'si','Ali res Å¾elite NEODLOÅ½EN to',0),(278294,7731,'ba','Apakah Anda yakin Anda ingin membatalkan penghapusan ini',0),(278295,7731,'nl','Weet u zeker dat u wilt UNDELETE dit',0),(278296,7731,'fi','Oletko varmasti UNDELETE tÃ¤mÃ¤',0),(278297,7731,'no','Er du sikker pÃ¥ at du vil angre dette',0),(278298,7731,'da','Er du sikker pÃ¥ du Ã¸nsker at GENOPRETTER dette',0),(278299,7731,'ko','ë‹¹ì‹ ì€ ì´ê²ƒì„ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ',0),(278300,7731,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×‘×˜×œ ××ª ×”×ž×—×™×§×” ×©×œ ×–×”',0),(278301,7731,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎžÎ•Î”Î™Î‘Î“Î¡Î†Î¨Î•Î™ Î±Ï…Ï„ÏŒ',0),(278302,7731,'zh','ä½ ç¡®å®šè¦å–æ¶ˆåˆ é™¤æ­¤ï¼Ÿ',0),(278303,7731,'sv','Ã„r du sÃ¤ker pÃ¥ att du vill Ã¥terstÃ¤lla detta',0),(278304,7731,'it','Sei sicuro che si desidera annullare l\'eliminazione di questo',0),(278305,7731,'tl','',0),(278306,7731,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3652;&#3617;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;&#3626;&#3636;&#3656;&#3591;&#3609;&#3637;&#3',0),(278307,7731,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤°à¤¦à¥à¤¦ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤‡à¤šà¥à¤›à¤¾ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚',0),(278308,7731,'ms','Adakah anda pasti hendak membatalkan PENGHAPUSAN ini',0),(278309,7731,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø±ØºØ¨ØªÙƒ ÙÙŠ Ø§Ù„Ø­Ø°Ù Ù‡Ø°Ø§',0),(278310,7731,'fr','ÃŠtes-vous sÃ»r de que vouloir restaurer cela',0),(278311,7731,'jp','ã“ã‚Œã‚’å…ƒã«æˆ»ã™ã‚’ã‚ˆã‚ã—ã„ã§ã™ã€‚',0),(278312,7731,'pt','Tem certeza que deseja UNDELETE isto',0),(278313,7731,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹ Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÐÐ• Ð£Ð”ÐÐ›Ð¯Ð¢Ð¬ ÑÑ‚Ð¾',0),(278314,7731,'es','Â¿Esta seguro que quiere RESTAURAR este?',0),(278315,7731,'de','Bist du sicher, dass du dies wiederherstellen',0),(278316,7731,'en','Are you sure you wish to UNDELETE this',0),(278317,7732,'is','',0),(278318,7732,'dr','Ø­Ø°Ù Ù†Ø´Ø¯Ù†',0),(278319,7732,'pr','Ø­Ø°Ù Ù†Ø´Ø¯Ù†',0),(278320,7732,'tr','Silmeyi geri alma',0),(278321,7732,'pl','UniewaÅ¼niÄ‡ kasowanie',0),(278322,7732,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸',0),(278323,7732,'ur','Ù†Ø§Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(278324,7732,'sr','ÐŸÐ¾Ð½Ð¸ÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð±Ñ€Ð¸ÑÐ°ÑšÐ°',0),(278325,7732,'vi','ChÆ°a xÃ³a',0),(278326,7732,'af','Skraping Ongedaan maak',0),(278327,7732,'ro','Undelete',0),(278328,7732,'et','Undelete',0),(278329,7732,'si','NeodloÅ¾en',0),(278330,7732,'ba','Membatalkan penghapusan',0),(278331,7732,'nl','Undelete',0),(278332,7732,'fi','Undelete',0),(278333,7732,'no','Gjenoppretter',0),(278334,7732,'da','Genopretter',0),(278335,7732,'ko','ì‚­ì œ ì·¨ì†Œ',0),(278336,7732,'he','×ž×—×™×§×ª×•',0),(278337,7732,'el','ÎžÎµÎ´Î¹Î±Î³ÏÎ¬Ï†ÎµÎ¹',0),(278338,7732,'zh','å–æ¶ˆåˆ é™¤\r\n',0),(278339,7732,'sv','OutplÃ¥ner',0),(278340,7732,'it','Undelete',0),(278341,7732,'tl','',0),(278342,7732,'th','&#3652;&#3617;&#3656;&#3621;&#3610;',0),(278343,7732,'hi','à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚',0),(278344,7732,'ms','Membatalkan penghapusan',0),(278345,7732,'ar','Ø§Ù„Ø­Ø°Ù',0),(278346,7732,'fr','Undelete',0),(278347,7732,'jp','å…ƒã«æˆ»ã™',0),(278348,7732,'pt','Undelete',0),(278349,7732,'ru','Ð’Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(278350,7732,'es','Recuperar',0),(278351,7732,'de','Undelete',0),(278352,7732,'en','Undelete',0),(278353,7733,'is','',0),(278354,7733,'dr','Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ± Ø­Ø°Ù Ù†Ø´ÙˆØ¯ ',0),(278355,7733,'pr','Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ± Ø­Ø°Ù Ù†Ø´ÙˆØ¯ ',0),(278356,7733,'tr','Bu fatura undelete',0),(278357,7733,'pl','CofnÄ…Ä‡ tej faktury',0),(278358,7733,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸ Ñ‚Ð°Ð·Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(278359,7733,'ur','Ø§Ø³ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ø§Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(278360,7733,'sr','ÐŸÐ¾Ð½Ð¸ÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð±Ñ€Ð¸ÑÐ°ÑšÐ° Ð¾Ð²Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(278361,7733,'vi','ChÆ°a xÃ³a hÃ³a Ä‘Æ¡n nÃ y',0),(278362,7733,'af','Skraping op Hierdie Faktuur Ongedaan maak',0),(278363,7733,'ro','Undelete aceastÄƒ facturÄƒ',0),(278364,7733,'et','Kustutuse kÃ¤esolevas arves',0),(278365,7733,'si','Izbris tega raÄuna',0),(278366,7733,'ba','Membatalkan penghapusan faktur ini',0),(278367,7733,'nl','Deze factuur undelete',0),(278368,7733,'fi','Undelete tÃ¤hÃ¤n laskuun',0),(278369,7733,'no','Gjenopprette denne fakturaen',0),(278370,7733,'da','Genopretter denne faktura',0),(278371,7733,'ko','ì´ ì†¡ìž¥ ì·¨ì†Œ',0),(278372,7733,'he','×‘×™×˜×•×œ ×ž×—×™×§×” ×©×œ ×—×©×‘×•× ×™×ª ×–×•',0),(278373,7733,'el','ÎžÎµÎ´Î¹Î±Î³ÏÎ¬Ï†ÎµÎ¹ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(278374,7733,'zh','å–æ¶ˆåˆ é™¤æ­¤å‘ç¥¨\r\n',0),(278375,7733,'sv','OutplÃ¥ner denna faktura',0),(278376,7733,'it','Undelete questa fattura',0),(278377,7733,'tl','',0),(278378,7733,'th','&#3652;&#3617;&#3656;&#3621;&#3610;&#3651;&#3610;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;&#3609;&#3637;&#3657;',0),(278379,7733,'hi','à¤‡à¤¸ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚',0),(278380,7733,'ms','Membatalkan penghapusan invois ini',0),(278381,7733,'ar','Ø§Ù„Ø­Ø°Ù Ù‡Ø°Ù‡ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(278382,7733,'fr','Reprenez cette facture',0),(278383,7733,'jp','ã“ã®è«‹æ±‚æ›¸ã‚’å…ƒã«æˆ»ã™',0),(278384,7733,'pt','Undelete esta fatura',0),(278385,7733,'ru','ÐÐµ Ð£Ð´Ð°Ð»ÑÑ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ð¹ Ð¡Ñ‡ÐµÑ‚',0),(278386,7733,'es','Recuperar Esta Factura',0),(278387,7733,'de','Undelete dieser Rechnung',0),(278388,7733,'en','Undelete This Invoice',0),(278389,7734,'is','',0),(278390,7734,'dr','Ù‚ÙŠÙ…Øª Ø§Ù†Ø¯Ø§Ø²Ù‡',0),(278391,7734,'pr','Ù‚ÙŠÙ…Øª Ø§Ù†Ø¯Ø§Ø²Ù‡',0),(278392,7734,'tr','Fiyat boyutu',0),(278393,7734,'pl','Cena rozmiar',0),(278394,7734,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ñ†ÐµÐ½Ð°',0),(278395,7734,'ur','Ù‚ÛŒÙ…Øª Ø³Ø§Ø¦Ø²',0),(278396,7734,'sr','Ð¦ÐµÐ½Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(278397,7734,'vi','Cá»¡ giÃ¡',0),(278398,7734,'af','Prysgrootte',0),(278399,7734,'ro','Pret dimensiune',0),(278400,7734,'et','Hind suurus',0),(278401,7734,'si','Cena velikost',0),(278402,7734,'ba','Ukuran harga',0),(278403,7734,'nl','Prijs grootte',0),(278404,7734,'fi','Hinta koon',0),(278405,7734,'no','Pris stÃ¸rrelse',0),(278406,7734,'da','Pris stÃ¸rrelse',0),(278407,7734,'ko','ê°€ê²© í¬ê¸°',0),(278408,7734,'he','×’×•×“×œ ×ž×—×™×¨',0),(278409,7734,'el','Î¤Î¹Î¼Î® Î¼Î­Î³ÎµÎ¸Î¿Ï‚',0),(278410,7734,'zh','ä»·æ ¼å°ºå¯¸\r\n',0),(278411,7734,'sv','Pris storlek',0),(278412,7734,'it','Dimensioni prezzo',0),(278413,7734,'tl','',0),(278414,7734,'th','&#3586;&#3609;&#3634;&#3604;&#3619;&#3634;&#3588;&#3634;',0),(278415,7734,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(278416,7734,'ms','Saiz harga',0),(278417,7734,'ar','Ø­Ø¬Ù… Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(278418,7734,'fr','Taille prix',0),(278419,7734,'jp','ä¾¡æ ¼ã‚µã‚¤ã‚º',0),(278420,7734,'pt','PreÃ§o tamanho',0),(278421,7734,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¦ÐµÐ½Ð°',0),(278422,7734,'es','TamaÃ±o de Precio',0),(278423,7734,'de','Preis GrÃ¶ÃŸe',0),(278424,7734,'en','Price Size',0),(278425,7735,'is','',0),(278426,7735,'dr','Ù…Ù‚Ø¯Ø§Ø±  Ø§Ù†Ø¯Ø§Ø²Ù‡ ',0),(278427,7735,'pr','Ù…Ù‚Ø¯Ø§Ø±  Ø§Ù†Ø¯Ø§Ø²Ù‡ ',0),(278428,7735,'tr','Miktar boyutu',0),(278429,7735,'pl','IloÅ›Ä‡ rozmiar',0),(278430,7735,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° ÐºÐ¾Ð»',0),(278431,7735,'ur','Ù‚ÛŒ Ø³Ø§Ø¦Ø²',0),(278432,7735,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° ÐšÐ¾Ð».',0),(278433,7735,'vi','Cá»¡ Sá»‘ lÆ°á»£ng',0),(278434,7735,'af','Hoev. Grootte',0),(278435,7735,'ro','Cantit dimensiune',0),(278436,7735,'et','Tk suurus',0),(278437,7735,'si','KoliÄina velikost',0),(278438,7735,'ba','Ukuran Qty',0),(278439,7735,'nl','Qty grootte',0),(278440,7735,'fi','Kpl kokoa',0),(278441,7735,'no','Antall stÃ¸rrelse',0),(278442,7735,'da','Antal stÃ¸rrelse',0),(278443,7735,'ko','ìˆ˜ëŸ‰ í¬ê¸°',0),(278444,7735,'he','×›×ž×•×ª ×’×•×“×œ',0),(278445,7735,'el','Qty ÎœÎ­Î³ÎµÎ¸Î¿Ï‚',0),(278446,7735,'zh','æ•°é‡å¤§å°\r\n',0),(278447,7735,'sv','Antal storlek',0),(278448,7735,'it','Dimensione Qty',0),(278449,7735,'tl','',0),(278450,7735,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3609;&#3634;&#3604;',0),(278451,7735,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(278452,7735,'ms','Qty saiz',0),(278453,7735,'ar','Ø­Ø¬Ù… Ø§Ù„ÙƒÙ…ÙŠØ©',0),(278454,7735,'fr','QuantitÃ© taille',0),(278455,7735,'jp','æ•°é‡ã‚µã‚¤ã‚º',0),(278456,7735,'pt','Qty do tamanho',0),(278457,7735,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ ÐšÐ¾Ð»-Ð²Ð¾',0),(278458,7735,'es','Cant. TamaÃ±o',0),(278459,7735,'de','Menge: GrÃ¶ÃŸe',0),(278460,7735,'en','Qty Size',0),(278461,7736,'is','',0),(278462,7736,'dr',' ØªÙ…Ø§Ù… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ù‡Ø§Ø±Ø§ Ù„ÙŠØ³Øª ÙƒÙ†ÙŠØ¯ Ùˆ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ÙƒÙ‡ ÙƒØ¯Ø§Ù… ÙØ§ÙƒØªÙˆØ± Ø´ÙˆØ¯ ',0),(278463,7736,'pr',' ØªÙ…Ø§Ù… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ù‡Ø§Ø±Ø§ Ù„ÙŠØ³Øª ÙƒÙ†ÙŠØ¯ Ùˆ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ÙƒÙ‡ ÙƒØ¯Ø§Ù… ÙØ§ÙƒØªÙˆØ± Ø´ÙˆØ¯ ',0),(278464,7736,'tr','TÃ¼m faturalandÄ±rÄ±lmamÄ±ÅŸ, hangi faturaya seÃ§melisiniz',0),(278465,7736,'pl','Lista wszystkich nieopÅ‚aconych i wybraÄ‡ do faktury',0),(278466,7736,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Unbilled Ð¸ Ð¸Ð·Ð±Ð¾Ñ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(278467,7736,'ur','Ø³Ø¨ ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„ Ú©ÛŒ ÙÛØ±Ø³Øª Ø§ÙˆØ± Ø¬Ù† Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(278468,7736,'sr','ÐÐ°Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÐ²Ðµ Ð£Ð½Ð±Ð¸Ð»Ð»ÐµÐ´ Ð¸ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ñ˜Ð¸ Ñ›Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(278469,7736,'vi','Liá»‡t kÃª táº¥t cáº£ ChÆ°a Ra HÃ³a ÄÆ¡n vÃ  sang HÃ³a ÄÆ¡n',0),(278470,7736,'af','Lys alle Unbilled en kies wat tot faktuur',0),(278471,7736,'ro','Lista toate Unbilled ÅŸi selectaÅ£i care la factura',0),(278472,7736,'et','Reasta kÃµik ilma arveta tellimused ja vali, millistele arve koostada',0),(278473,7736,'si','Seznam vseh Unbilled in izberite katerega raÄun',0),(278474,7736,'ba','Daftar semua tertagih dan memilih untuk faktur',0),(278475,7736,'nl','Een lijst van alle ongefactureerde en selecteren welke op factuur',0),(278476,7736,'fi','Luettelo kaikki Unbilled ja valitse, mitkÃ¤ laskun',0),(278477,7736,'no','Liste alle fakturert og velge hvilke fakturaen',0),(278478,7736,'da','Liste over alle faktureret og vÃ¦lg, hvilken faktura',0),(278479,7736,'ko','ëª¨ë“  ë° ëª©ë¡ê³¼ ì†¡ìž¥ ì„ íƒ',0),(278480,7736,'he','×¨×©×™×ž×ª ×›×œ Unbilled ×•×‘×—×¨ ××©×¨ ××œ ×—×©×‘×•× ×™×ª',0),(278481,7736,'el','Î›Î¯ÏƒÏ„Î± ÏŒÎ»Î± Î±Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î· ÎºÎ±Î¹ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(278482,7736,'zh','åˆ—å‡ºå…¨éƒ¨æœªå…¥è´¦ï¼Œå¹¶é€‰æ‹©è¦å‘ç¥¨çš„å¸å•\r\n',0),(278483,7736,'sv','Lista alla relaterade och vÃ¤lja vilken till faktura',0),(278484,7736,'it','Elencare tutte le attivitÃ  non ancora fatturate e selezionare quale fattura',0),(278485,7736,'tl','',0),(278486,7736,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3',0),(278487,7736,'hi','à¤¸à¤¬ Unbilled à¤¸à¥‚à¤šà¥€ à¤¹à¥ˆ à¤”à¤° à¤œà¥‹ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(278488,7736,'ms','Senarai semua lepas dan pilih yang invois',0),(278489,7736,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø¬Ù…ÙŠØ¹ ÙÙˆØ§ØªÙŠØ± ÙˆØ­Ø¯Ø¯ ÙÙŠÙ‡Ø§ Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(278490,7736,'fr','La liste tout non facturÃ©s et sÃ©lectionnez qui Ã  facturer',0),(278491,7736,'jp','ã™ã¹ã¦æœªèª²é‡‘ãƒªã‚¹ãƒˆã—ã€è«‹æ±‚æ›¸ã‚’é¸æŠž',0),(278492,7736,'pt','Listar todos nÃ£o faturada e selecionar qual a fatura',0),(278493,7736,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð²ÑÐµÑ… Ð½ÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð¸ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ, ÐºÐ°ÐºÐ¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(278494,7736,'es','Listar Todos los Ordenes no Facturados y Seleccionar Cuales que van a Facturar',0),(278495,7736,'de','Liste aller noch nicht fakturierte und auswÃ¤hlen, welche auf Rechnung',0),(278496,7736,'en','List All Unbilled and Select Which To Invoice',0),(278497,7737,'is','',0),(278498,7737,'dr',' ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø±Ø§Ù„ÙŠØ³Øª ÙƒÙ†ÙŠØ¯ ÙˆØ§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ÙƒÙ‡ ÙƒØ¯Ø§Ù… ÙØ§ÙƒØªÙˆØ± Ø´ÙˆØ¯',0),(278499,7737,'pr',' ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø±Ø§Ù„ÙŠØ³Øª ÙƒÙ†ÙŠØ¯ ÙˆØ§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ÙƒÙ‡ ÙƒØ¯Ø§Ù… ÙØ§ÙƒØªÙˆØ± Ø´ÙˆØ¯',0),(278500,7737,'tr','Sadece faturalandÄ±rÄ±lmamÄ±ÅŸ, tamamlanan sipariÅŸler, hangi faturaya seÃ§melisiniz',0),(278501,7737,'pl','Lista tylko zleceÅ„ nieopÅ‚aconych, zakoÅ„czone i wybraÄ‡ do faktury',0),(278502,7737,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº ÑÐ°Ð¼Ð¾ Unbilled, Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¸ Ð¸Ð·Ð±Ð¾Ñ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(278503,7737,'ur','ØµØ±Ù ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„ØŒ Ù…Ú©Ù…Ù„ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø§ÙˆØ± Ø¬Ù† Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(278504,7737,'sr','Ð›Ð¸ÑÑ‚Ñƒ ÑÐ°Ð¼Ð¾ Ð£Ð½Ð±Ð¸Ð»Ð»ÐµÐ´, Ð¿Ð¾Ð¿ÑƒÑšÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð¸ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ñ˜Ð¸ Ñ›Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(278505,7737,'vi','Chá»‰ Liá»‡t kÃª nhá»¯ng ÄÆ¡n HÃ ng HoÃ n Táº¥t ChÆ°a Láº­p HÃ³a ÄÆ¡n VÃ  Chuyá»ƒn Sang BÃªn Ra HÃ³a ÄÆ¡n',0),(278506,7737,'af','Lys Slegs Ongefaktureerd, Voltooide Bestellings en Kies na Watter Faktuur te verwys',0),(278507,7737,'ro','Lista numai ordinele de Unbilled, completat ÅŸi selectaÅ£i care la factura',0),(278508,7737,'et','Reasta ainult ilma arveta, lÃµpetatud tellimused ja vali, millistele arve koostada',0),(278509,7737,'si','Seznam le Unbilled, dokonÄana naroÄila in ki izberite raÄun',0),(278510,7737,'ba','Daftar hanya tertagih, selesai perintah dan memilih untuk faktur',0),(278511,7737,'nl','Lijst alleen ongefactureerde, voltooide bestellingen en selecteren welke op factuur',0),(278512,7737,'fi','Luettelo vain Unbilled mukaan tilaukset ja valitse, mitkÃ¤ laskun',0),(278513,7737,'no','Listen bare fakturert, fullfÃ¸rt bestillinger og velge hvilke fakturaen',0),(278514,7737,'da','Liste over kun faktureret, fÃ¦rdige ordrer og vÃ¦lg, hvilken faktura',0),(278515,7737,'ko','ë°, ì™„ë£Œ ëœ ì£¼ë¬¸ë§Œ ëª©ë¡ê³¼ ì†¡ìž¥ ì„ íƒ',0),(278516,7737,'he','×œ×¤×¨×˜ ×¨×§ ×”×–×ž× ×•×ª Unbilled, ×”×©×œ×™×ž×” ×•×œ×‘×—×•×¨ ××©×¨ ×¢×œ ×”×—×©×‘×•× ×™×ª',0),(278517,7737,'el','Î›Î¯ÏƒÏ„Î± Î¼ÏŒÎ½Î¿ Î±Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î·, Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÎºÎ±Î¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÎ¹ Ï€Î¿Ï… Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(278518,7737,'zh','åªåˆ—å‡ºæœªå…¥è´¦ï¼Œå·²å®Œæˆè®¢å•å’Œé€‰æ‹©è¦çš„å‘ç¥¨\r\n',0),(278519,7737,'sv','Lista bara relaterade, avslutade bestÃ¤llningar och vÃ¤lja vilken till faktura',0),(278520,7737,'it','Elenco ordini solo attivitÃ  non ancora fatturati, completati e che seleziona per fattura',0),(278521,7737,'tl','',0),(278522,7737,'th','List Only Unbilled, Completed Orders and Select Which to Invoice',0),(278523,7737,'hi','à¤•à¥‡à¤µà¤² Unbilled, à¤ªà¥‚à¤°à¥à¤£ à¤•à¤¿à¤ à¤—à¤ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤”à¤° à¤œà¥‹ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(278524,7737,'ms','Senarai pesanan yang hanya lepas, siap dan pilih yang invois',0),(278525,7737,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø£ÙˆØ§Ù…Ø± ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø©ØŒ Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø© ÙÙ‚Ø· ÙˆØ­Ø¯Ø¯ ÙÙŠÙ‡Ø§ Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(278526,7737,'fr','Uniquement les commandes non facturÃ©es, terminÃ©es la liste et sÃ©lectionnez qui Ã  facturer',0),(278527,7737,'jp','æœªèª²é‡‘ã€å®Œäº†ã—ãŸæ³¨æ–‡ã®ã¿ã‚’è«‹æ±‚æ›¸ã«ã™ã‚‹ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(278528,7737,'pt','Listar somente ordens nÃ£o faturadas, completadas e selecionar qual a fatura',0),(278529,7737,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð½ÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ…, Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð¸ Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ, ÐºÐ°ÐºÐ¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(278530,7737,'es','Listar Solamente Ordenes No Facturados Completados y Seleccionar Cuales que van a Facturar',0),(278531,7737,'de','Liste nur noch nicht fakturierte, Abgeschlossene Bestellungen und auswÃ¤hlen, welche auf Rechnung',0),(278532,7737,'en','List Only Unbilled, Completed Orders and Select Which to Invoice',0),(278533,7738,'is','',0),(278534,7738,'dr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ø§Ú¯Ø± Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ú†Ùƒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(278535,7738,'pr','Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ Ø§Ú¯Ø± Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ú†Ùƒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(278536,7738,'tr','Ã‡ek numarasÄ±<br><small>EÄŸer (Ã§ekle Ã¶denen)</small>',0),(278537,7738,'pl','SprawdÅº numer<br><small>(jeÅ›li pÅ‚atne czekiem)</small>',0),(278538,7738,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€<br><small>(Ð°ÐºÐ¾ ÑÐµ Ð¿Ð»Ð°Ñ‚Ð¸ Ñ Ñ‡ÐµÐº)</small>',0),(278539,7738,'ur','Ù†Ù…Ø¨Ø± Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº<br><small>Ø§Ú¯Ø± (Ú†ÛŒÚ© Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø¯Ø§ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’)</small>',0),(278540,7738,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ‡ÐµÐºÐ°<br><small>(Ð°ÐºÐ¾ Ñ˜Ðµ Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ)</small>',0),(278541,7738,'vi','Sá»‘ SÃ©c (náº¿u thanh toÃ¡n báº±ng SÃ©c)',0),(278542,7738,'af','Tjeknommer (indien Betaal per Tjek)',0),(278543,7738,'ro','VerificaÅ£i numÄƒrul<br><small>(Ã®n cazul Ã®n care plata prin CEC)</small>',0),(278544,7738,'et','TÅ¡eki Number<br><small>(kui tÅ¡ekiga makstud)</small>',0),(278545,7738,'si','Preverite Å¡tevilko<br><small>(Äe plaÄa s Äekom)</small>',0),(278546,7738,'ba','Cek nomor<br><small>(jika membayar dengan cek)</small>',0),(278547,7738,'nl','Nummer van cheque<br><small>(als die betaald per cheque)</small>',0),(278548,7738,'fi','Sekin numero<br><small>(jos sekillÃ¤ maksetut)</small>',0),(278549,7738,'no','Sjekknummer<br><small>(hvis betalt med sjekk)</small>',0),(278550,7738,'da','Checknummer<br><small>(hvis betalt med Check)</small>',0),(278551,7738,'ko','ìˆ˜ í‘œ ë²ˆí˜¸<br><small>(í•´ë‹¹ ë˜ëŠ” ê²½ìš° ì²´í¬ì— ì˜í•´ ì§€ë¶ˆ)</small>',0),(278552,7738,'he','×ž×¡×¤×¨ ×”×©×™×§<br><small>(×× ×©×•×œ×ž×• ×‘×©×™×§)</small>',0),(278553,7738,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…<br><small>(Î±Î½ Ï€Î»Î·ÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Î±Î³Î®)</small>',0),(278554,7738,'zh','æ”¯ç¥¨å·ç ï¼ˆå¦‚ä»¥æ”¯ç¥¨æ”¯ä»˜ï¼‰\r\n',0),(278555,7738,'sv','Checknummer<br><small>(om betalas av Check)</small>',0),(278556,7738,'it','Controllare il numero<br><small>(se pagato con assegno)</small>',0),(278557,7738,'tl','',0),(278558,7738,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&#3588; (&#3648;&#3617;&#3639;&#3656;&#3629;&#3592;&#3656;&#3634;&#3618;&#3604;&#3657;&#3623;&#3618;&#3648;&#3594;&#3655;&#3588;)',0),(278559,7738,'hi','à¤¨à¤‚à¤¬à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚<br><small>à¤…à¤—à¤° (à¤šà¥‡à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾)</small>',0),(278560,7738,'ms','Semak nombor<br><small>(jika dibayar dengan cek)</small>',0),(278561,7738,'ar','Ø±Ù‚Ù… Ø§Ù„Ø´ÙŠÙƒ<br><small>(Ø¥Ø°Ø§ Ø¯ÙØ¹Øª Ø¨Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±)</small>',0),(278562,7738,'fr','NumÃ©ro de chÃ¨que<br><small>(si payÃ© par chÃ¨que)</small>',0),(278563,7738,'jp','å°åˆ‡æ‰‹ç•ªå·<br><small>(å ´åˆã¯å°åˆ‡æ‰‹ã§æ”¯æ‰•ã‚ã‚Œã‚‹ï¼‰</small>',0),(278564,7738,'pt','NÃºmero do cheque<br><small>(se pago em cheque)</small>',0),(278565,7738,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð§ÐµÐºÐ°(ÐµÑÐ»Ð¸ ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð¾ Ð§ÐµÐºÐ¾Ð¼)',0),(278566,7738,'es','NÃºmero de Cheque(si Paga por Cheque)',0),(278567,7738,'de','Schecknummer<br><small>(wenn per Scheck bezahlt)</small>',0),(278568,7738,'en','Check Number<br><small>(if Paid by Check)</small>',0),(278569,7739,'is','',0),(278570,7739,'dr','Ø§Ù…Ø±ÙˆØ² ',0),(278571,7739,'pr','Ø§Ù…Ø±ÙˆØ² ',0),(278572,7739,'tr','BugÃ¼n',0),(278573,7739,'pl','Dzisiaj',0),(278574,7739,'bg','Ð”Ð½ÐµÑ',0),(278575,7739,'ur','Ø¢Ø¬',0),(278576,7739,'sr','Ð”Ð°Ð½Ð°Ñ',0),(278577,7739,'vi','NgÃ y hÃ´m nay',0),(278578,7739,'af','Vandag',0),(278579,7739,'ro','Azi',0),(278580,7739,'et','TÃ¤na',0),(278581,7739,'si','Danes',0),(278582,7739,'ba','Hari ini',0),(278583,7739,'nl','Vandaag',0),(278584,7739,'fi','TÃ¤nÃ¤Ã¤n',0),(278585,7739,'no','I dag',0),(278586,7739,'da','I dag',0),(278587,7739,'ko','ì˜¤ëŠ˜',0),(278588,7739,'he','×”×™×•×',0),(278589,7739,'el','Î£Î®Î¼ÎµÏÎ±',0),(278590,7739,'zh','ä»Šå¤©\r\n',0),(278591,7739,'sv','Idag',0),(278592,7739,'it','Oggi',0),(278593,7739,'tl','',0),(278594,7739,'th','&#3623;&#3633;&#3609;&#3609;&#3637;&#3657;',0),(278595,7739,'hi','à¤†à¤œ',0),(278596,7739,'ms','Hari ini',0),(278597,7739,'ar','Ø§Ù„ÙŠÙˆÙ…',0),(278598,7739,'fr','Aujourd\'hui',0),(278599,7739,'jp','ä»Šæ—¥',0),(278600,7739,'pt','Hoje',0),(278601,7739,'ru','Ð¡ÐµÐ³Ð¾Ð´Ð½Ñ',0),(278602,7739,'es','Hoy',0),(278603,7739,'de','Heute',0),(278604,7739,'en','Today',0),(278605,7740,'is','',0),(278606,7740,'dr','Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø·Ø¨Ù‚ Ø±ÙˆØ² ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(278607,7740,'pr','Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø·Ø¨Ù‚ Ø±ÙˆØ² ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(278608,7740,'tr','GÃ¼ne gÃ¶re GruplandÄ±r',0),(278609,7740,'pl','Kliknij, aby grupa przez dzieÅ„',0),(278610,7740,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð³Ñ€ÑƒÐ¿Ð° Ð¾Ñ‚ Ð´ÐµÐ½Ñ',0),(278611,7740,'ur','Ø¯Ù† Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ú¯Ø±ÙˆÙ¾ Ú©Ùˆ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(278612,7740,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ñƒ Ð¿Ð¾ Ð´Ð°Ð½Ñƒ',0),(278613,7740,'vi','Nháº¥n tá»›i nhÃ³m theo ngÃ y',0),(278614,7740,'af','Kliek Om te Groepeer Per Dag',0),(278615,7740,'ro','FaceÅ£i clic pe grup de zi',0),(278616,7740,'et','KlÃµpsake rÃ¼hma pÃ¤ev',0),(278617,7740,'si','Kliknite skupino po dnevih',0),(278618,7740,'ba','Klik untuk kelompok hari',0),(278619,7740,'nl','Klik op groep per dag',0),(278620,7740,'fi','Klikkaa ryhmÃ¤ pÃ¤ivÃ¤llÃ¤',0),(278621,7740,'no','Klikk gruppen av dagen',0),(278622,7740,'da','Klik pÃ¥ gruppe af dagen',0),(278623,7740,'ko','í•˜ë£¨ì— ì˜í•´ ê·¸ë£¹ì„ í´ë¦­ í•©ë‹ˆë‹¤',0),(278624,7740,'he','×œ×—×¥ ×¢×œ ×§×‘×¥ ×œ×¤×™ ×™×•×',0),(278625,7740,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î·Î½ Î¿Î¼Î¬Î´Î± Î¼Îµ Ï„Î· Î¼Î­ÏÎ±',0),(278626,7740,'zh','ç‚¹å‡»æŒ‰å¤©åˆ†ç»„\r\n',0),(278627,7740,'sv','Klicka pÃ¥ gruppen av dag',0),(278628,7740,'it','Fare clic su gruppo di giorno',0),(278629,7740,'tl','',0),(278630,7740,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3592;&#3633;&#3604;&#3585;&#3621;&#3640;&#3656;&#3617;&#3648;&#3611;&#3655;&#3609;&#3623;&#3633;&#3609;',0),(278631,7740,'hi','à¤¦à¤¿à¤¨ à¤¸à¥‡ à¤¸à¤®à¥‚à¤¹ à¤•à¥‹ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(278632,7740,'ms','Klik untuk Kumpulan oleh hari',0),(278633,7740,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¨ÙˆØ§Ø³Ø·Ø© Ø§Ù„ÙŠÙˆÙ…',0),(278634,7740,'fr','Cliquez sur groupe de jour',0),(278635,7740,'jp','æ—¥ã«ã‚ˆã£ã¦ã‚°ãƒ«ãƒ¼ãƒ—ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(278636,7740,'pt','Clique em grupo por dia',0),(278637,7740,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð§Ñ‚Ð¾Ð±Ñ‹ Ð¡Ð³Ñ€ÑƒÐ¿Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐŸÐ¾ Ð”Ð½ÑÐ¼',0),(278638,7740,'es','Click para Agrupar Por DÃ­a',0),(278639,7740,'de','Klicken Sie auf Gruppe von Tag',0),(278640,7740,'en','Click To Group By Day',0),(278641,7741,'is','',0),(278642,7741,'dr','(Ù‚Ù„Ù… Ø®ÙˆØ±Ø¯Ù‡) ÙÙ‚Ø·',0),(278643,7741,'pr','Ù„ØºÙˆ Ø´Ø¯Ù‡(Ù‚Ù„Ù… Ø®ÙˆØ±Ø¯Ù‡) ÙÙ‚Ø·',0),(278644,7741,'tr','YalnÄ±zca iptal',0),(278645,7741,'pl','Anulowane tylko',0),(278646,7741,'bg','ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ð° ÑÐ°Ð¼Ð¾',0),(278647,7741,'ur','ØµØ±Ù Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(278648,7741,'sr','Ð¡Ð°Ð¼Ð¾ Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð¾',0),(278649,7741,'vi','Chá»‰ xÃ³a',0),(278650,7741,'af','Slegs gekanselleer',0),(278651,7741,'ro','Anulate numai',0),(278652,7741,'et','Ainult tÃ¼histatud',0),(278653,7741,'si','Preklicali le',0),(278654,7741,'ba','Dibatalkan hanya',0),(278655,7741,'nl','Alleen geannuleerd',0),(278656,7741,'fi','Peruuttaa vain',0),(278657,7741,'no','Avbrutt bare',0),(278658,7741,'da','Annulleret kun',0),(278659,7741,'ko','ë§Œ ì·¨ì†Œ',0),(278660,7741,'he','×‘×•×˜×œ ×¨×§',0),(278661,7741,'el','Î‘ÎºÏ…ÏÏ‰Î¸ÎµÎ¯ Î¼ÏŒÎ½Î¿',0),(278662,7741,'zh','åªæœ‰å–æ¶ˆ\r\n',0),(278663,7741,'sv','Avbryts endast',0),(278664,7741,'it','Annullato solo',0),(278665,7741,'tl','',0),(278666,7741,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(278667,7741,'hi','à¤•à¥‡à¤µà¤² à¤°à¤¦à¥à¤¦ à¤•à¤¿à¤¯à¤¾',0),(278668,7741,'ms','Dibatalkan hanya',0),(278669,7741,'ar','ØªÙ… Ø¥Ù„ØºØ§Ø¡ ÙÙ‚Ø·',0),(278670,7741,'fr','AnnulÃ© uniquement',0),(278671,7741,'jp','ã®ã¿ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(278672,7741,'pt','Cancelada somente',0),(278673,7741,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¾Ðµ',0),(278674,7741,'es','Cancelado Solamente',0),(278675,7741,'de','Nur abgebrochen',0),(278676,7741,'en','Canceled Only',0),(278677,7742,'is','',0),(278678,7742,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠ Ù„ØºÙˆ Ø´Ø¯Ù‡ ',0),(278679,7742,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠ Ù„ØºÙˆ Ø´Ø¯Ù‡ ',0),(278680,7742,'tr','YalnÄ±zca iptal edilen sevk irsaliyelerini gÃ¶ster',0),(278681,7742,'pl','PokaÅ¼ anulowane wysyÅ‚ki tylko',0),(278682,7742,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð° Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐ°Ð¼Ð¾',0),(278683,7742,'ur','ØµØ±Ù ØªØ±Ø³ÛŒÙ„ Ø´Ùˆ Ù…Ù†Ø³ÙˆØ®',0),(278684,7742,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð°Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(278685,7742,'vi','Chá»‰ hiá»‡n thá»‹ chuyáº¿n hÃ ng há»§y',0),(278686,7742,'af','Wys Gekanseleerde Versendings Alleenlik',0),(278687,7742,'ro','Spectacolul anulat transporturile numai',0),(278688,7742,'et','NÃ¤ita ainult tÃ¼histatud tarneid',0),(278689,7742,'si','PokaÅ¾i le preklicane poÅ¡iljk',0),(278690,7742,'ba','Tampilkan hanya membatalkan pengiriman',0),(278691,7742,'nl','Toon alleen geannuleerde zendingen',0),(278692,7742,'fi','NÃ¤ytÃ¤ peruutettu lÃ¤hetykset vain',0),(278693,7742,'no','Vis avbrutt forsendelser bare',0),(278694,7742,'da','Vis annulleret overfÃ¸rsler kun',0),(278695,7742,'ko','ì‡¼ë§Œ ì¶œí•˜ë¥¼ ì·¨ì†Œ',0),(278696,7742,'he','×”×¦×’ ×‘×•×˜×œ×” ×ž×©×œ×•×—×™× ×‘×œ×‘×“',0),(278697,7742,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Îµ Î±ÎºÏ…ÏÏŽÏƒÎµÎ¹Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ Î¼ÏŒÎ½Î¿',0),(278698,7742,'zh','ä»…æ˜¾ç¤ºå–æ¶ˆçš„å‡ºè´§é‡\r\n',0),(278699,7742,'sv','Visa avbrutna sÃ¤ndningar endast',0),(278700,7742,'it','Spettacolo annullato spedizioni solo',0),(278701,7742,'tl','',0),(278702,7742,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(278703,7742,'hi','à¤¶à¥‹ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤²à¤¦à¤¾à¤¨ à¤•à¥‡à¤µà¤²',0),(278704,7742,'ms','Papar dibatalkan penghantaran sahaja',0),(278705,7742,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø¥Ù„ØºØ§Ø¡ Ø´Ø­Ù†Ø§Øª ÙÙ‚Ø·',0),(278706,7742,'fr','Spectacle annulÃ© livraisons uniquement',0),(278707,7742,'jp','å–ã‚Šæ¶ˆã•ã‚ŒãŸå‡ºè·ã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(278708,7742,'pt','Show cancelado embarques somente',0),(278709,7742,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ñ‹ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(278710,7742,'es','Mostrar EnvÃ­os Cancelados Solo',0),(278711,7742,'de','Zeigen stornierte Sendungen nur',0),(278712,7742,'en','Show Canceled Shipments&nbsp;Only',0),(278713,7743,'is','',0),(278714,7743,'dr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡  Ø¨Ø±Ø§ÙŠ ',0),(278715,7743,'pr','Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡  Ø¨Ø±Ø§ÙŠ ',0),(278716,7743,'tr','TamamlanmÄ±ÅŸ sipariÅŸ listesi iÃ§in',0),(278717,7743,'pl','Lista zleceÅ„ zakoÅ„czonych na',0),(278718,7743,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð°',0),(278719,7743,'ur','Ù…Ú©Ù…Ù„ ØªØ±ØªÛŒØ¨ Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’',0),(278720,7743,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ð¾Ð¿ÑƒÑšÐµÐ½Ð¸Ñ… Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(278721,7743,'vi','HoÃ n ThÃ nh Danh SÃ¡ch ÄÆ¡n Äáº·t HÃ ng cho',0),(278722,7743,'af','Voltooide Bestellingslys Vir',0),(278723,7743,'ro','ComandÄƒ completat lista pentru',0),(278724,7743,'et','Komplekteeritud tellimus nimekiri',0),(278725,7743,'si','Seznam zakljuÄenih nalog za',0),(278726,7743,'ba','Selesai memesan daftar untuk',0),(278727,7743,'nl','Voltooide Orderlijst voor',0),(278728,7743,'fi','TÃ¤yttÃ¤mÃ¤ luettelo',0),(278729,7743,'no','FullfÃ¸rt listen For',0),(278730,7743,'da','Udfyldte Ordreoversigt For',0),(278731,7743,'ko','ì™„ë£Œ ì£¼ë¬¸ ëª©ë¡',0),(278732,7743,'he','×¨×©×™×ž×ª ×¡×“×¨ ×©×”×•×©×œ×ž×• ×¢×‘×•×¨',0),(278733,7743,'el','Î›Î¯ÏƒÏ„Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½Î· ÏƒÎµÎ¹ÏÎ¬ Î³Î¹Î±',0),(278734,7743,'zh','å¯¹äºŽå·²å®Œæˆçš„è®¢å•åˆ—è¡¨\r\n',0),(278735,7743,'sv','Ifyllda listan fÃ¶r',0),(278736,7743,'it','Elenco modulo d\'ordine per',0),(278737,7743,'tl','',0),(278738,7743,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(278739,7743,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‚à¤°à¥à¤£ à¤•à¤¿à¤ à¤—à¤ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(278740,7743,'ms','Senarai pesanan yang lengkap untuk',0),(278741,7743,'ar','Ù‚Ø§Ø¦Ù…Ø© ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø©',0),(278742,7743,'fr','Liste de commande terminÃ©e pour',0),(278743,7743,'jp','å®Œäº†ã—ãŸæ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(278744,7743,'pt','Lista de ordem concluÃ­do para',0),(278745,7743,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ð¹ Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð—Ð°ÐºÐ°Ð·Ð¾Ð² Ð”Ð»Ñ',0),(278746,7743,'es','Lista de Pedidos Completados Para',0),(278747,7743,'de','AusgefÃ¼llte Bestellliste fÃ¼r',0),(278748,7743,'en','Completed Order List For',0),(278749,7744,'is','',0),(278750,7744,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡',0),(278751,7744,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡',0),(278752,7744,'tr','TamamlanmÄ±ÅŸ sipariÅŸleri',0),(278753,7744,'pl','ZamÃ³wienia ukoÅ„czone',0),(278754,7744,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½',0),(278755,7744,'ur','Ù…Ú©Ù…Ù„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(278756,7744,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð°',0),(278757,7744,'vi','HoÃ n táº¥t Ä‘Æ¡n hÃ ng',0),(278758,7744,'af','Bestellings Voltooi',0),(278759,7744,'ro','Comenzi completate',0),(278760,7744,'et','LÃµpetatud tellimused',0),(278761,7744,'si','DokonÄana naroÄila',0),(278762,7744,'ba','Pesanan selesai',0),(278763,7744,'nl','Bestellingen voltooid',0),(278764,7744,'fi','Tilaukset pÃ¤Ã¤tÃ¶kseen',0),(278765,7744,'no','Bestillinger',0),(278766,7744,'da','Ordrer afsluttet',0),(278767,7744,'ko','ì£¼ë¬¸ ì™„ë£Œ',0),(278768,7744,'he','×”×”×–×ž× ×•×ª ×”×•×©×œ×ž×•',0),(278769,7744,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(278770,7744,'zh','å®Œæˆå®šå•',0),(278771,7744,'sv','Order slutfÃ¶rts',0),(278772,7744,'it','Ordini completati',0),(278773,7744,'tl','',0),(278774,7744,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(278775,7744,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥‚à¤°à¤¾',0),(278776,7744,'ms','Perintah-perintah yang telah siap',0),(278777,7744,'ar','Ø¥Ù†Ø¬Ø§Ø² Ø·Ù„Ø¨Ø§Øª',0),(278778,7744,'fr','Commandes complÃ©tÃ©es',0),(278779,7744,'jp','å®Œäº†ã—ãŸæ³¨æ–‡',0),(278780,7744,'pt','Encomendas concluÃ­das',0),(278781,7744,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(278782,7744,'es','Pedidos Completados',0),(278783,7744,'de','Abgeschlossene Bestellungen',0),(278784,7744,'en','Orders Completed',0),(278785,7745,'is','',0),(278786,7745,'dr','Ø¢Ø®Ø±ÙŠÙ† Ø­Ù…Ù„',0),(278787,7745,'pr','Ø¢Ø®Ø±ÙŠÙ† Ø­Ù…Ù„',0),(278788,7745,'tr','Son gemi',0),(278789,7745,'pl','KoÅ„cowe statku',0),(278790,7745,'bg','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¾ ÐºÐ¾Ñ€Ð°Ð±',0),(278791,7745,'ur','Ø¢Ø®Ø±ÛŒ Ø¬ÛØ§Ø²',0),(278792,7745,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð¸ Ð±Ñ€Ð¾Ð´',0),(278793,7745,'vi','Chuyáº¿n hÃ ng cuá»‘i',0),(278794,7745,'af','Finale Sending',0),(278795,7745,'ro','NavÄƒ de finalÄƒ',0),(278796,7745,'et','LÃµplik tarne',0),(278797,7745,'si','KonÄni ladje',0),(278798,7745,'ba','Akhir kapal',0),(278799,7745,'nl','Laatste schip',0),(278800,7745,'fi','Viimeinen alus',0),(278801,7745,'no','Siste skipet',0),(278802,7745,'da','Sidste skib',0),(278803,7745,'ko','ìµœì¢… ë°°',0),(278804,7745,'he','×”×¡×¤×™× ×” ×”××—×¨×•× ×”',0),(278805,7745,'el','Î¤ÎµÎ»Î¹ÎºÎ® Ï€Î»Î¿Î¯Î¿',0),(278806,7745,'zh','æœ€åŽä¸€æ‰¹\r\n',0),(278807,7745,'sv','Sista fartyget',0),(278808,7745,'it','Nave finale',0),(278809,7745,'tl','',0),(278810,7745,'th','&#3626;&#3656;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(278811,7745,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¶à¤¿à¤ª',0),(278812,7745,'ms','Kapal akhir',0),(278813,7745,'ar','Ø³ÙÙŠÙ†Ø© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ',0),(278814,7745,'fr','Navire final',0),(278815,7745,'jp','æœ€çµ‚çš„ãªèˆ¹',0),(278816,7745,'pt','Navio final',0),(278817,7745,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(278818,7745,'es','EnvÃ­o Final',0),(278819,7745,'de','Letzte Schiff',0),(278820,7745,'en','Final Ship',0),(278821,7746,'is','',0),(278822,7746,'dr','Ø­Ù…Ù„ Ø¬Ø²Ø¦ÙŠ',0),(278823,7746,'pr','Ø­Ù…Ù„ Ø¬Ø²Ø¦ÙŠ',0),(278824,7746,'tr','KÄ±smi gemi',0),(278825,7746,'pl','CzÄ™Å›ciowe statku',0),(278826,7746,'bg','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(278827,7746,'ur','Ø¬Ø²ÙˆÛŒ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²',0),(278828,7746,'sr','Ð”ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð° Ð±Ñ€Ð¾Ð´',0),(278829,7746,'vi','Váº­n chuyá»ƒn má»™t pháº§n',0),(278830,7746,'af','Gedeeltelik Versend',0),(278831,7746,'ro','Livrare parÅ£ialÄƒ',0),(278832,7746,'et','Osaline laeva',0),(278833,7746,'si','Delno ladje',0),(278834,7746,'ba','Kapal parsial',0),(278835,7746,'nl','Gedeeltelijke schip',0),(278836,7746,'fi','Osittainen aluksen',0),(278837,7746,'no','Delvis skipet',0),(278838,7746,'da','Delvis skib',0),(278839,7746,'ko','ë¶€ë¶„ ë°°',0),(278840,7746,'he','×ž×©×œ×•×— ×—×œ×§×™',0),(278841,7746,'el','ÎœÎµÏÎ¹ÎºÎ® Ï€Î»Î¿Î¯Î¿',0),(278842,7746,'zh','éƒ¨åˆ†è£…è¿',0),(278843,7746,'sv','Partiell fartyg',0),(278844,7746,'it','Nave parziale',0),(278845,7746,'tl','',0),(278846,7746,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;',0),(278847,7746,'hi','à¤†à¤‚à¤¶à¤¿à¤• à¤œà¤¹à¤¾à¤œ',0),(278848,7746,'ms','Sebahagian kapal',0),(278849,7746,'ar','Ø´Ø­Ù† Ø¬Ø²Ø¦ÙŠÙ‘',0),(278850,7746,'fr','Navire partielle',0),(278851,7746,'jp','éƒ¨åˆ†çš„ãªèˆ¹',0),(278852,7746,'pt','Navio parcial',0),(278853,7746,'ru','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(278854,7746,'es','Enviar Parcial',0),(278855,7746,'de','Teilweise Schiff',0),(278856,7746,'en','Partial Ship',0),(278857,7747,'is','',0),(278858,7747,'dr','(ØªÙƒÙ…ÙŠÙ„)  Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡',0),(278859,7747,'pr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ù…Ø§ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡(ØªÙƒÙ…ÙŠÙ„)  Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡',0),(278860,7747,'tr','Sevk edilen, ancak fatura deÄŸil - Fulfillment sipariÅŸler',0),(278861,7747,'pl','WysÅ‚ane ale nie rozliczone - realizacja zamÃ³wienia',0),(278862,7747,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¾, Ð½Ð¾ Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ - Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(278863,7747,'ur','Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ù…Ú¯Ø± Ù†ÛÛŒÚº Ø¨Ø§Ù„Ù„Ø§Ø¯ - ØªÚ©Ù…ÛŒÙ„ Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§ Û”',0),(278864,7747,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¾ , Ð°Ð»Ð¸ Ð½Ð¸Ñ˜Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ - Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ.',0),(278865,7747,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ váº­n chuyá»ƒn nhÆ°ng chÆ°a ra hÃ³a Ä‘Æ¡n',0),(278866,7747,'af','Versend, Maar Nie-Gefaktureerde Uitvoeringsbestelling',0),(278867,7747,'ro','Expediate dar nu taxat - Ã®mplinire comenzi',0),(278868,7747,'et','kaubatellimused, mis on tarnitud, kuid arvet ei ole koostatud',0),(278869,7747,'si','Dobavljena, vendar ne zaraÄunavajo - izpolnitev naroÄila',0),(278870,7747,'ba','Dikirim tetapi tidak ditagih - pemenuhan order',0),(278871,7747,'nl','Verzonden maar nog niet gefactureerd - bestellingen vervulling',0),(278872,7747,'fi','Toimitettu mutta ei laskutettu - tÃ¤yttÃ¤minen tilaukset',0),(278873,7747,'no','Levert, men ikke fakturert - bestillinger fullfÃ¸ringen',0),(278874,7747,'da','Leveret, men ikke faktureret - ordrer opfyldelse',0),(278875,7747,'ko','í–‰ ìˆœì„œë¥¼ ì œê³µ í•˜ì§€ë§Œ ë¹„ìš©ì´ ì²­êµ¬ ë˜ì§€-',0),(278876,7747,'he','×©× ×©×œ×—×• ××š ×œ× ×ž×—×•×™×‘ - ×ž×™×ž×•×© ×”×–×ž× ×•×ª',0),(278877,7747,'el','Î‘Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯, Î±Î»Î»Î¬ Î´ÎµÎ½ Ï„Î¹Î¼Î¿Î»Î¿Î³ÎµÎ¯Ï„Î±Î¹ - ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(278878,7747,'zh','å‘è´§ä½†å±¥è¡Œè®¢å•ä¸å…¥è´¦\r\n',0),(278879,7747,'sv','Levererats men inte faktureras - order uppfyllelse',0),(278880,7747,'it','Spedito ma non fatturati - evasione ordini',0),(278881,7747,'tl','',0),(278882,7747,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;&#3649;&#3605;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3610;&#3636;&#3621;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(278883,7747,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾, à¤²à¥‡à¤•à¤¿à¤¨ à¤¬à¤¿à¤² à¤¨à¤¹à¥€à¤‚-',0),(278884,7747,'ms','Dihantar tetapi tidak dibilkan - memenuhi perintah',0),(278885,7747,'ar','Ø´Ø­Ù† ÙˆÙ„ÙƒÙ† Ù„Ø§ ØªÙˆØµÙ-ÙˆÙØ§Ø¡ Ø£ÙˆØ§Ù…Ø±',0),(278886,7747,'fr','ExpÃ©diÃ©es mais non facturÃ©e - Fulfillment ordonne',0),(278887,7747,'jp','å‡ºè·ãŒè«‹æ±‚ã•ã‚Œãªã„ - ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼ã—ã¾ã™ã€‚',0),(278888,7747,'pt','Enviados mas nÃ£o faturado - cumprimento de ordens',0),(278889,7747,'ru','ÐžÑ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ñ‹, Ð½Ð¾ Ð½Ðµ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚ - Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(278890,7747,'es','Ordenes de Cumplimiento Enviados pero no Facturados',0),(278891,7747,'de','Geliefert aber nicht in Rechnung gestellt - Bestellungen ErfÃ¼llung',0),(278892,7747,'en','Shipped But Not Billed - Fulfillment Orders',0),(278893,7748,'is','',0),(278894,7748,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡  Ø§Ù…Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ ',0),(278895,7748,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø¯Ù‡  Ø§Ù…Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ ',0),(278896,7748,'tr','SipariÅŸleri fatura ama Ã¼cretli',0),(278897,7748,'pl','ZamÃ³wienia zafakturowane i nie zapÅ‚acone',0),(278898,7748,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ñ‚ Ð½Ð¾ Ð½Ðµ ÑÐ° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(278899,7748,'ur','Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ø§Ù„Ù„Ø§Ø¯ Ù…Ú¯Ø± Ø§Ø¯Ø§ Ù†ÛÛŒÚº Ú©ÛŒ',0),(278900,7748,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½, Ð°Ð»Ð¸ Ð½Ð¸Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(278901,7748,'vi','ÄÆ¡n HÃ ng Ä‘Ã£ ra hÃ³a Ä‘Æ¡n nhÆ°ng chÆ°a thanh toÃ¡n',0),(278902,7748,'af','Bestellings Gefaktureer, Maar Onbetaald',0),(278903,7748,'ro','Comenzi facturate dar nu plÄƒtit',0),(278904,7748,'et','Tellimuste tasulised kuid maksmata',0),(278905,7748,'si','NaroÄila zaraÄunana vendar ne plaÄa',0),(278906,7748,'ba','Pesanan ditagih tetapi belum dibayar',0),(278907,7748,'nl','Orders gefactureerd maar niet betaald',0),(278908,7748,'fi','Tilaukset laskutetaan mutta ei makseta',0),(278909,7748,'no','Bestillinger fakturert men betalt ikke',0),(278910,7748,'da','Ordrer faktureret, men betalt ikke',0),(278911,7748,'ko','ì£¼ë¬¸ ì²­êµ¬ í•˜ì§€ë§Œ ì§€ë¶ˆ í•˜ì§€',0),(278912,7748,'he','×”×”×–×ž× ×•×ª ×—×•×™×‘×• ××š ×œ× ×©×•×œ×ž×•',0),(278913,7748,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï„Î¹Î¼Î¿Î»Î¿Î³ÎµÎ¯Ï„Î±Î¹ Î±Î»Î»Î¬ Î´ÎµÎ½ Î­Ï‡Î¿Ï…Î½ ÎºÎ±Ï„Î±Î²Î»Î·Î¸ÎµÎ¯',0),(278914,7748,'zh','è®¢å•å·²å…¥è´¦ä½†å°šæœªæ”¯ä»˜\r\n',0),(278915,7748,'sv','BestÃ¤llningar faktureras men betalat inte',0),(278916,7748,'it','Ordini fatturati ma non pagato',0),(278917,7748,'tl','',0),(278918,7748,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3649;&#3621;&#3657;&#3623;&#3649;&#3605;&#3656;&#3618;&#3633;&#3591;&#3',0),(278919,7748,'hi','à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‹ à¤¬à¤¿à¤² à¤•à¤¿à¤¯à¤¾ à¤²à¥‡à¤•à¤¿à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾',0),(278920,7748,'ms','Pesanan dibilkan tetapi belum dibayar',0),(278921,7748,'ar','Ø£ÙˆØ§Ù…Ø± ÙÙˆØ§ØªÙŠØ± ÙˆÙ„ÙƒÙ† Ù„Ù… ØªØ¯ÙØ¹',0),(278922,7748,'fr','Commandes facturÃ©es mais pas payÃ©',0),(278923,7748,'jp','æ³¨æ–‡ã®è«‹æ±‚ãŒæ”¯æ‰•ã‚ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(278924,7748,'pt','Ordens de bico, mas nÃ£o pago',0),(278925,7748,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ð°, Ð½Ð¾ Ð½Ðµ Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ñ‹',0),(278926,7748,'es','Ordenes Facturados Pero No Pagados',0),(278927,7748,'de','Bestellungen in Rechnung gestellt, aber nicht gezahlt',0),(278928,7748,'en','Orders Billed But Not Paid',0),(278929,7749,'is','',0),(278930,7749,'dr','Ù„ØºÙˆ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(278931,7749,'pr','Ù„ØºÙˆ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(278932,7749,'tr','TeslimatÄ± iptal',0),(278933,7749,'pl','Anuluj przesyÅ‚kÄ™',0),(278934,7749,'bg','ÐžÑ‚Ð¼ÐµÐ½Ð¸ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ñ',0),(278935,7749,'ur','Ú©Ú¾ÛŒÙ¾ Ú©Ùˆ Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº',0),(278936,7749,'sr','ÐžÑ‚ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(278937,7749,'vi','Há»§y chuyáº¿n váº­n chuyá»ƒn',0),(278938,7749,'af','Kanseleer Versending',0),(278939,7749,'ro','Revocare expediere',0),(278940,7749,'et','TÃ¼hista tarne',0),(278941,7749,'si','PrekliÄi dobavnice',0),(278942,7749,'ba','Membatalkan pengiriman',0),(278943,7749,'nl','Annuleren van de zending',0),(278944,7749,'fi','Peruuta lÃ¤hetys',0),(278945,7749,'no','Avbryte forsendelse',0),(278946,7749,'da','Annuller leverance',0),(278947,7749,'ko','ì„ ì  ì·¨ì†Œ',0),(278948,7749,'he','×œ×‘×˜×œ ××ª ×”×ž×©×œ×•×—',0),(278949,7749,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(278950,7749,'zh','å–æ¶ˆè£…èˆ¹\r\n',0),(278951,7749,'sv','Avbryt transport',0),(278952,7749,'it','Annullare la spedizione',0),(278953,7749,'tl','',0),(278954,7749,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(278955,7749,'hi','à¤²à¤¦à¤¾à¤¨ à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚',0),(278956,7749,'ms','Membatalkan penghantaran',0),(278957,7749,'ar','Ø¥Ù„ØºØ§Ø¡ Ø´Ø­Ù†Ø©',0),(278958,7749,'fr','Annuler envoi',0),(278959,7749,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«å‡ºè·',0),(278960,7749,'pt','Cancelar carregamento',0),(278961,7749,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð° Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(278962,7749,'es','Cancelar EnvÃ­o',0),(278963,7749,'de','\"Abbrechen\" Versand',0),(278964,7749,'en','Cancel Shipment',0),(278965,7750,'is','',0),(278966,7750,'dr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(278967,7750,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(278968,7750,'tr','Bu sevkiyat Sil',0),(278969,7750,'pl','UsuÅ„ ten przesyÅ‚ki',0),(278970,7750,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð·Ð¸ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(278971,7750,'ur','ÛŒÛ Ú©Ú¾ÛŒÙ¾ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(278972,7750,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(278973,7750,'vi','XÃ³a chuyáº¿n hÃ ng',0),(278974,7750,'af','Skrap hierdie Versending',0),(278975,7750,'ro','ÅžtergeÅ£i acest transport',0),(278976,7750,'et','Kustuta see tarne',0),(278977,7750,'si','Izbrisati to dobavnico',0),(278978,7750,'ba','Menghapus kiriman ini',0),(278979,7750,'nl','Deze zending verwijderen',0),(278980,7750,'fi','Poistaa tÃ¤mÃ¤n toimituksen',0),(278981,7750,'no','Slette denne forsendelsen',0),(278982,7750,'da','Slette denne leverance',0),(278983,7750,'ko','ì´ ì„ ì ì„ ì‚­ì œ',0),(278984,7750,'he','×œ×ž×—×•×§ ××ª ×”×ž×©×œ×•×— ×”×–×”',0),(278985,7750,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(278986,7750,'zh','åˆ é™¤è¿™æ‰¹è´§ç‰©\r\n',0),(278987,7750,'sv','Ta bort denna leverans',0),(278988,7750,'it','Cancella questa spedizione',0),(278989,7750,'tl','',0),(278990,7750,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3609;&#3637;&#3657;',0),(278991,7750,'hi','à¤‡à¤¸ à¤–à¥‡à¤ª à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(278992,7750,'ms','Menghapuskan penghantaran ini',0),(278993,7750,'ar','Ø­Ø°Ù Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø­Ù†Ø©',0),(278994,7750,'fr','Supprimer cette expÃ©dition',0),(278995,7750,'jp','ã“ã®å‡ºè·ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(278996,7750,'pt','Excluir este carregamento',0),(278997,7750,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð³Ñ€ÑƒÐ·',0),(278998,7750,'es','Eliminar este EnvÃ­o',0),(278999,7750,'de','Diese Lieferung zu lÃ¶schen',0),(279000,7750,'en','Delete This Shipment',0),(279001,7751,'is','',0),(279002,7751,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ',0),(279003,7751,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÙŠ',0),(279004,7751,'tr','Ambalaj listeleri',0),(279005,7751,'pl','Pakowania listy',0),(279006,7751,'bg','ÐžÐ¿Ð°ÐºÐ¾Ð²ÑŠÑ‡Ð½Ð¸Ñ‚Ðµ Ð»Ð¸ÑÑ‚Ð¾Ð²Ðµ',0),(279007,7751,'ur','Ù¾ÛŒÚ©Ù†Ú¯ Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(279008,7751,'sr','ÐŸÐ°ÐºÐ¾Ð²Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ð°Ð¼Ð°',0),(279009,7751,'vi','Danh sÃ¡ch Ä‘Ã³ng hÃ ng',0),(279010,7751,'af','Pak lyste',0),(279011,7751,'ro','Listele de ambalare',0),(279012,7751,'et','Kirjadeta',0),(279013,7751,'si','Dobavnice',0),(279014,7751,'ba','Daftar Kemasan',0),(279015,7751,'nl','Paklijsten',0),(279016,7751,'fi','Pakkaus listat',0),(279017,7751,'no','Pakking lister',0),(279018,7751,'da','Pakkelister',0),(279019,7751,'ko','í¬ìž¥ ëª©ë¡',0),(279020,7751,'he','×¨×©×™×ž×•×ª ××¨×™×–×”',0),(279021,7751,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ ÏƒÏ…ÏƒÎºÎµÏ…Î±ÏƒÎ¹ÏŽÎ½',0),(279022,7751,'zh','è£…ç®±å•\r\n',0),(279023,7751,'sv','Packlistor',0),(279024,7751,'it','Liste di imballaggio',0),(279025,7751,'tl','',0),(279026,7751,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3614;&#3655;&#3588;&#3648;&#3585;&#3655;&#3592;',0),(279027,7751,'hi','à¤ªà¥ˆà¤•à¤¿à¤‚à¤— à¤¸à¥‚à¤šà¥€',0),(279028,7751,'ms','Senarai pembungkusan',0),(279029,7751,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„ØªØ¹Ø¨Ø¦Ø©',0),(279030,7751,'fr','Listes de colisage',0),(279031,7751,'jp','ãƒ‘ãƒƒã‚­ãƒ³ã‚° ãƒªã‚¹ãƒˆ',0),(279032,7751,'pt','Listas de embalagem',0),(279033,7751,'ru','Ð£Ð¿Ð°ÐºÐ¾Ð²Ð¾Ñ‡Ð½Ñ‹Ðµ Ð»Ð¸ÑÑ‚Ñ‹',0),(279034,7751,'es','Listas de Empaque',0),(279035,7751,'de','Packlisten',0),(279036,7751,'en','Packing Lists',0),(279037,7752,'is','',0),(279038,7752,'dr',' Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ØµØ§Ø¯Ø± Ø´Ø¯',0),(279039,7752,'pr',' Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ØµØ§Ø¯Ø± Ø´Ø¯',0),(279040,7752,'tr','Verilen RMA',0),(279041,7752,'pl','RMA wydane',0),(279042,7752,'bg','Ð Ð¡Ðž Ð¸Ð·Ð´Ð°Ð´ÐµÐ½',0),(279043,7752,'ur','Ø±Ù… Ø¬Ø§Ø±ÛŒ',0),(279044,7752,'sr','ÐžÐ¿Ñ , Ð¸Ð·Ð´Ð°Ñ‚',0),(279045,7752,'vi','PhÃ¡t hÃ nh RMA',0),(279046,7752,'af','RMA uitgereik',0),(279047,7752,'ro','RMA emise',0),(279048,7752,'et','Tagastatud kauba vÃ¤lja',0),(279049,7752,'si','RMA, izdano',0),(279050,7752,'ba','RMA yang dikeluarkan',0),(279051,7752,'nl','RMA afgegeven',0),(279052,7752,'fi','Annettu RMA',0),(279053,7752,'no','RMA utstedt',0),(279054,7752,'da','RMA udstedt',0),(279055,7752,'ko','RMA ë°œí–‰',0),(279056,7752,'he','RMA ×©×”×•× ×¤×§×•',0),(279057,7752,'el','RMA Ï€Î¿Ï… ÎµÎºÎ´Î¯Î´Î¿Î½Ï„Î±Î¹',0),(279058,7752,'zh','è¿”å›žå•†å“æŽˆæƒå‘å¸ƒ\r\n',0),(279059,7752,'sv','RMA utfÃ¤rdas',0),(279060,7752,'it','RMA rilasciato',0),(279061,7752,'tl','',0),(279062,7752,'th','&#3611;&#3619;&#3632;&#3648;&#3604;&#3655;&#3609; RMA ',0),(279063,7752,'hi','RMA à¤œà¤¾à¤°à¥€ à¤•à¤¿à¤',0),(279064,7752,'ms','RMA yang dikeluarkan',0),(279065,7752,'ar','Ø§Ù„Ø¬ÙŠØ´ Ø§Ù„Ù…Ù„ÙƒÙŠ Ø§Ù„Ù…ØºØ±Ø¨ÙŠ Ø£ØµØ¯Ø±',0),(279066,7752,'fr','RMA dÃ©livrÃ©',0),(279067,7752,'jp','RMA ç™ºè¡Œ',0),(279068,7752,'pt','RMA emitido',0),(279069,7752,'ru','RMA Ð²Ñ‹Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(279070,7752,'es','RMA Emitido',0),(279071,7752,'de','RMA ausgestellt',0),(279072,7752,'en','RMA Issued',0),(279073,7753,'is','',0),(279074,7753,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù„ØºÙˆ Ø´Ø¯ ',0),(279075,7753,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù„ØºÙˆ Ø´Ø¯ ',0),(279076,7753,'tr','GeÃ§ersiz bir sevk irsaliyesi',0),(279077,7753,'pl','WysyÅ‚ka uniewaÅ¼niony',0),(279078,7753,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½',0),(279079,7753,'ur','ÙˆÙˆØ§ÚˆÛŒØ¯ Ú©ÛŒ Ú©Ú¾ÛŒÙ¾',0),(279080,7753,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½',0),(279081,7753,'vi','XÃ³a chuyáº¿n hÃ ng',0),(279082,7753,'af','Besending \"Voided\"',0),(279083,7753,'ro','Anulate de expediere',0),(279084,7753,'et','Saadetise vÃ¤Ã¤rtus',0),(279085,7753,'si','Razveljavi dobavnico',0),(279086,7753,'ba','Pengiriman Voided',0),(279087,7753,'nl','Verzending ongeldig',0),(279088,7753,'fi','Toimituksen mitÃ¤tÃ¶ity',0),(279089,7753,'no','Forsendelsen annullert',0),(279090,7753,'da','OverfÃ¸rslen annulleret',0),(279091,7753,'ko','ì„ ì  ì·¨ì†Œ',0),(279092,7753,'he','×ž×©×œ×•×— ×©×ª×•×§×¤×Ÿ ×‘×•×˜×œ',0),(279093,7753,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î±ÎºÏ…ÏÏŽÎ½ÎµÏ„Î±Î¹',0),(279094,7753,'zh','è£…è¿åºŸé™¤\r\n',0),(279095,7753,'sv','Transporten annullerad',0),(279096,7753,'it','Spedizione annullata',0),(279097,7753,'tl','',0),(279098,7753,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3606;&#3641;&#3585;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(279099,7753,'hi','à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ Voided',0),(279100,7753,'ms','Penghantaran Voided',0),(279101,7753,'ar','Ø§Ù„Ø´Ø­Ù† Ù…Ù„ØºÙŠØ©',0),(279102,7753,'fr','ExpÃ©dition annulÃ©e',0),(279103,7753,'jp','ç„¡åŠ¹ã¨å‡ºè·',0),(279104,7753,'pt','ExpediÃ§Ã£o anulada',0),(279105,7753,'ru','ÐžÑ‚Ð³Ñ€ÑƒÐ·ÐºÐ° Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð°',0),(279106,7753,'es','EnvÃ­o Anulado',0),(279107,7753,'de','Versand fÃ¼r nichtig erklÃ¤rt',0),(279108,7753,'en','Shipment Voided',0),(279109,7754,'is','',0),(279110,7754,'dr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(279111,7754,'pr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(279112,7754,'tr','GeÃ§ersiz bir sevk irsaliyesi',0),(279113,7754,'pl','NiewaÅ¼ne przesyÅ‚ki',0),(279114,7754,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ñ',0),(279115,7754,'ur','Ú©Ú¾ÛŒÙ¾ ØµÙØ±',0),(279116,7754,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(279117,7754,'vi','XÃ³a chuyáº¿n hÃ ng',0),(279118,7754,'af','\"Void\" Besending',0),(279119,7754,'ro','Nule de expediere',0),(279120,7754,'et','Annulleeri saadetis',0),(279121,7754,'si','Razveljavi dobavnico',0),(279122,7754,'ba','Membatalkan pengiriman',0),(279123,7754,'nl','VOID verzending',0),(279124,7754,'fi','Peruuta lÃ¤hetys',0),(279125,7754,'no','Ugyldig levering',0),(279126,7754,'da','Ugyldig leverance',0),(279127,7754,'ko','Void ì„ ì ',0),(279128,7754,'he','×ž×©×œ×•×— void',0),(279129,7754,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(279130,7754,'zh','è¿è¾“ä½œåºŸ\r\n',0),(279131,7754,'sv','Annullera sÃ¤ndning',0),(279132,7754,'it','Void spedizione',0),(279133,7754,'tl','',0),(279134,7754,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(279135,7754,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤²à¤¦à¤¾à¤¨',0),(279136,7754,'ms','Penghantaran yang tidak sah',0),(279137,7754,'ar','Ø¥ÙØ±Ø§Øº Ø§Ù„Ø´Ø­Ù†Ø©',0),(279138,7754,'fr','ExpÃ©dition Sub',0),(279139,7754,'jp','å‡ºè·ã‚’ãƒœã‚¤ãƒ‰ã—ã¾ã™ã€‚',0),(279140,7754,'pt','Anular remessa',0),(279141,7754,'ru','Void Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(279142,7754,'es','Anular EnvÃ­o',0),(279143,7754,'de','Void Versand',0),(279144,7754,'en','Void Shipment',0),(279145,7755,'is','',0),(279146,7755,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(279147,7755,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(279148,7755,'tr','Fatura iÃ§in Ã¶deme ayrÄ±ntÄ±larÄ±',0),(279149,7755,'pl','SzczegÃ³Å‚y pÅ‚atnoÅ›ci za faktury',0),(279150,7755,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(279151,7755,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(279152,7755,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(279153,7755,'vi','Chi tiáº¿t thanh toÃ¡n cho hÃ³a Ä‘Æ¡n',0),(279154,7755,'af','Betalingsbesonderhede vir Faktuur',0),(279155,7755,'ro','Detaliu de platÄƒ pentru factura',0),(279156,7755,'et','Arve makse Ã¼ksikasjad',0),(279157,7755,'si','PlaÄilo podrobnosti za raÄun',0),(279158,7755,'ba','Detail pembayaran untuk faktur',0),(279159,7755,'nl','Detail van de betaling voor factuur',0),(279160,7755,'fi','Maksu yksityiskohtaisesti laskun',0),(279161,7755,'no','Betaling detaljer For faktura',0),(279162,7755,'da','Betaling detaljer For fakturaen',0),(279163,7755,'ko','ì†¡ìž¥ì— ëŒ€ í•œ ì§€ë¶ˆ ì„¸ë¶€ ì‚¬í•­',0),(279164,7755,'he','×¤×™×¨×•×˜ ×”×ª×©×œ×•× ×¢×‘×•×¨ ×—×©×‘×•× ×™×ª',0),(279165,7755,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Ï€Î»Î·ÏÏ‰Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(279166,7755,'zh','ä»˜æ¬¾æ˜Žç»†å‘ç¥¨\r\n',0),(279167,7755,'sv','Utbetalning detalj fÃ¶r faktura',0),(279168,7755,'it','Dettagli di pagamento per la fattura',0),(279169,7755,'tl','',0),(279170,7755,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(279171,7755,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤µà¤°à¤£',0),(279172,7755,'ms','Terperinci pembayaran bagi invois',0),(279173,7755,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¯ÙØ¹ Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(279174,7755,'fr','DÃ©tails de paiement pour une facture',0),(279175,7755,'jp','è«‹æ±‚æ›¸ã®æ”¯æ‰•ã„è©³ç´°',0),(279176,7755,'pt','Detalhes de pagamento por factura',0),(279177,7755,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÑ‡ÐµÑ‚Ð°',0),(279178,7755,'es','Detalle de Pago Para La Factura',0),(279179,7755,'de','Bezahlung Detail fÃ¼r Rechnung',0),(279180,7755,'en','Payment Detail For Invoice',0),(279181,7756,'is','',0),(279182,7756,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(279183,7756,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(279184,7756,'tr','AlÄ±nan toplam fatura Ã¶demeleri',0),(279185,7756,'pl','Otrzymane pÅ‚atnoÅ›ci faktury ogÃ³Å‚em',0),(279186,7756,'bg','ÐžÐ±Ñ‰Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸',0),(279187,7756,'ur','Ú©Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…ÙˆØµÙˆÙ„',0),(279188,7756,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾',0),(279189,7756,'vi','Tá»•ng cá»™ng thanh toÃ¡n hÃ³a Ä‘Æ¡n Ä‘Ã£ nháº­n',0),(279190,7756,'af','Totale Faktuur Betalings Ontvang',0),(279191,7756,'ro','Plata facturilor totale primite',0),(279192,7756,'et','Arve laekunud',0),(279193,7756,'si','Skupni raÄun plaÄila, prejeta',0),(279194,7756,'ba','Jumlah tagihan pembayaran yang diterima',0),(279195,7756,'nl','Totale factuur betalingen ontvangen',0),(279196,7756,'fi','Laskun saadut',0),(279197,7756,'no','Samlet faktura betalinger mottatt',0),(279198,7756,'da','Samlede faktura betaling',0),(279199,7756,'ko','ì´ ì²­êµ¬ì„œ ì§€ë¶ˆì„ ë°›ì€',0),(279200,7756,'he','×”×—×©×‘×•× ×™×ª ×”×›×•×œ×œ ×ª×©×œ×•×ž×™× ×©×”×ª×§×‘×œ×•',0),(279201,7756,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… Î­Î»Î±Î²Îµ',0),(279202,7756,'zh','å…±æ”¶åˆ°å‘ç¥¨ä»˜æ¬¾\r\n',0),(279203,7756,'sv','Totala faktura betalningar',0),(279204,7756,'it','Totale fattura pagamenti ricevuti',0),(279205,7756,'tl','',0),(279206,7756,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(279207,7756,'hi','à¤•à¥à¤² à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(279208,7756,'ms','Invois jumlah bayaran yang diterima',0),(279209,7756,'ar','ÙØ§ØªÙˆØ±Ø© Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…ØªÙ„Ù‚Ø§Ø©',0),(279210,7756,'fr','Total de la facture paiements reÃ§us',0),(279211,7756,'jp','åˆè¨ˆè«‹æ±‚æ›¸ã®æ”¯æ‰•ã„',0),(279212,7756,'pt','Pagamentos de fatura total recebidos',0),(279213,7756,'ru','Ð’ÑÐµÐ³Ð¾ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(279214,7756,'es','Total Pagos Recibidos de Facturas',0),(279215,7756,'de','Gesamtrechnung Zahlungen empfangen',0),(279216,7756,'en','Total Invoice Payments Received',0),(279217,7757,'is','',0),(279218,7757,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø±Ø¯Ù‡ Ø®Ø¯Ù…Ø§Øª',0),(279219,7757,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø±Ø¯Ù‡ Ø®Ø¯Ù…Ø§Øª',0),(279220,7757,'tr','Yeni hizmet sÄ±nÄ±fÄ±',0),(279221,7757,'pl','Nowa usÅ‚uga Klasa',0),(279222,7757,'bg','ÐÐ¾Ð² ÐºÐ»Ð°Ñ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð°',0),(279223,7757,'ur','Ù†Ø¦ÛŒ Ø³Ø±ÙˆØ³ Ú©Ù„Ø§Ø³',0),(279224,7757,'sr','ÐÐ¾Ð²Ð° ÑƒÑÐ»ÑƒÐ³Ð° ÐºÐ»Ð°ÑÐ°',0),(279225,7757,'vi','ThÃªm Cáº¥p báº­c Dá»‹ch vá»¥',0),(279226,7757,'af','Diens Klas Byvoeg',0),(279227,7757,'ro','Noul serviciu de clasa',0),(279228,7757,'et','Lisage teenuse liik',0),(279229,7757,'si','Nova storitev razred',0),(279230,7757,'ba','Kelas layanan baru',0),(279231,7757,'nl','Nieuwe Service-klasse',0),(279232,7757,'fi','Uuteen',0),(279233,7757,'no','Nye tjenesteklassen',0),(279234,7757,'da','Nye tjenesteklasse',0),(279235,7757,'ko','ìƒˆ ì„œë¹„ìŠ¤ í´ëž˜ìŠ¤',0),(279236,7757,'he','×”×•×¡×£ ×ž×—×œ×§×ª ×©×¨×•×ª',0),(279237,7757,'el','ÎÎ­Î± Ï…Ï€Î·ÏÎµÏƒÎ¯Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(279238,7757,'zh','æœåŠ¡ç­‰çº§æ–°å¢ž\r\n',0),(279239,7757,'sv','Nya tjÃ¤nsteklassen',0),(279240,7757,'it','Nuova classe di servizio',0),(279241,7757,'tl','',0),(279242,7757,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3632;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(279243,7757,'hi','à¤¨à¤ˆ à¤¸à¥‡à¤µà¤¾ à¤µà¤°à¥à¤—',0),(279244,7757,'ms','Kelas perkhidmatan baru',0),(279245,7757,'ar','ÙØ¦Ø© Ø§Ù„Ø®Ø¯Ù…Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(279246,7757,'fr','Nouvelle classe de Service',0),(279247,7757,'jp','æ–°ã—ã„ã‚µãƒ¼ãƒ“ã‚¹ ã‚¯ãƒ©ã‚¹',0),(279248,7757,'pt','Nova classe de serviÃ§o',0),(279249,7757,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐºÐ»Ð°ÑÑ ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(279250,7757,'es','Clase de Servicio Agregar',0),(279251,7757,'de','Neue Service-Klasse',0),(279252,7757,'en','New Service Class',0),(279253,7758,'is','',0),(279254,7758,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù„ÙŠØ·',0),(279255,7758,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù„ÙŠØ·',0),(279256,7758,'tr','Bilet al',0),(279257,7758,'pl','Wybierz bilet',0),(279258,7758,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð±Ð¸Ð»ÐµÑ‚',0),(279259,7758,'ur','Ù¹Ú©Ù¹ Ú†Ù†ÛŒÚº',0),(279260,7758,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(279261,7758,'vi','Chá»n VÃ©',0),(279262,7758,'af','Tel kaartjie',0),(279263,7758,'ro','Alege biletul',0),(279264,7758,'et','Vali Piletite',0),(279265,7758,'si','Pick vozovnice',0),(279266,7758,'ba','Pilih Tiket',0),(279267,7758,'nl','Kies Ticket',0),(279268,7758,'fi','Valitse lippu',0),(279269,7758,'no','Plukke billett',0),(279270,7758,'da','VÃ¦lg billet',0),(279271,7758,'ko','í•­ê³µê¶Œ ì„ íƒ',0),(279272,7758,'he','×œ×‘×—×•×¨ ×›×¨×˜×™×¡',0),(279273,7758,'el','Î Î¬ÏÎµÎ¹ ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(279274,7758,'zh','é€‰æ‹©æœºç¥¨\r\n',0),(279275,7758,'sv','Plocka biljett',0),(279276,7758,'it','Scegliere il biglietto',0),(279277,7758,'tl','',0),(279278,7758,'th','&#3619;&#3633;&#3610;&#3605;&#3633;&#3659;&#3623;',0),(279279,7758,'hi','à¤Ÿà¤¿à¤•à¤Ÿ à¤²à¥‡à¤¨à¥‡',0),(279280,7758,'ms','Pilih Tiket',0),(279281,7758,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(279282,7758,'fr','Choisissez le billet',0),(279283,7758,'jp','ãƒã‚±ãƒƒãƒˆã‚’æ‹¾ã†',0),(279284,7758,'pt','Pegue o bilhete',0),(279285,7758,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚',0),(279286,7758,'es','Boleto de SelecciÃ³n',0),(279287,7758,'de','Ticket wÃ¤hlen',0),(279288,7758,'en','Pick Ticket',0),(279289,7759,'is','',0),(279290,7759,'dr','ÙƒÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(279291,7759,'pr','ÙƒÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(279292,7759,'tr','Toplam Ã¶demeler',0),(279293,7759,'pl','Suma pÅ‚atnoÅ›ci',0),(279294,7759,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(279295,7759,'ur','Ú©Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(279296,7759,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¸ÑÐ¿Ð»Ð°Ñ‚Ð°',0),(279297,7759,'vi','Tá»•ng cá»™ng thanh toÃ¡n',0),(279298,7759,'af','Totale Betalings',0),(279299,7759,'ro','PlÄƒÅ£ile totale',0),(279300,7759,'et','Maksete kogusumma',0),(279301,7759,'si','Skupna plaÄila',0),(279302,7759,'ba','Pembayaran Total',0),(279303,7759,'nl','Totaal betalingen',0),(279304,7759,'fi','Maksut yhteensÃ¤',0),(279305,7759,'no','Totalt betalinger',0),(279306,7759,'da','Samlede betalinger',0),(279307,7759,'ko','ì´ ì§€ë¶ˆ',0),(279308,7759,'he','×¡×” ×› ×ª×©×œ×•×ž×™×',0),(279309,7759,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(279310,7759,'zh','æ€»ä»˜è´¹\r\n',0),(279311,7759,'sv','Totala betalningar',0),(279312,7759,'it','Totale dei pagamenti',0),(279313,7759,'tl','',0),(279314,7759,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(279315,7759,'hi','à¤•à¥à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(279316,7759,'ms','Jumlah bayaran yang',0),(279317,7759,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(279318,7759,'fr','Total des paiements',0),(279319,7759,'jp','ç·æ”¯æ‰•ã„',0),(279320,7759,'pt','Total dos pagamentos',0),(279321,7759,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑƒÐ¼Ð¼Ð° Ð²Ñ‹Ð¿Ð»Ð°Ñ‚',0),(279322,7759,'es','Total Pagos',0),(279323,7759,'de','Summe der BezÃ¼ge',0),(279324,7759,'en','Total Payments',0),(279325,7760,'is','',0),(279326,7760,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª ',0),(279327,7760,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª ',0),(279328,7760,'tr','Hizmet tÃ¼rÃ¼ Ekle',0),(279329,7760,'pl','Typ usÅ‚ugi: dodawanie',0),(279330,7760,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ ÑƒÑÐ»ÑƒÐ³Ð°',0),(279331,7760,'ur','Ø®Ø¯Ù…Øª Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(279332,7760,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð²Ñ€ÑÑ‚Ñƒ ÑÐµÑ€Ð²Ð¸ÑÐ°',0),(279333,7760,'vi','ThÃªm Loáº¡i dá»‹ch vá»¥',0),(279334,7760,'af','Diens Tipes Byvoeg',0),(279335,7760,'ro','Adauga tipul de serviciu',0),(279336,7760,'et','Teenuse tÃ¼Ã¼p lisamine',0),(279337,7760,'si','Vrsta storitve dodati',0),(279338,7760,'ba','Menambahkan jenis layanan',0),(279339,7760,'nl','Servicetype toevoegen',0),(279340,7760,'fi','Palvelutyyppi lisÃ¤Ã¤',0),(279341,7760,'no','Tjenestetype legge',0),(279342,7760,'da','Tjenestetypen tilfÃ¸je',0),(279343,7760,'ko','ì„œë¹„ìŠ¤ ìœ í˜• ì¶”ê°€',0),(279344,7760,'he','×”×•×¡×¤×ª ×¡×•×’ ×©×¨×•×ª',0),(279345,7760,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„ÏÏ€Î¿ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚',0),(279346,7760,'zh','æ–°å¢žæœåŠ¡çš„ç±»åž‹\r\n',0),(279347,7760,'sv','Typ lÃ¤gga till',0),(279348,7760,'it','Aggiungi tipo di servizio',0),(279349,7760,'tl','',0),(279350,7760,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(279351,7760,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(279352,7760,'ms','Jenis Perkhidmatan Tambah',0),(279353,7760,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„Ø®Ø¯Ù…Ø©',0),(279354,7760,'fr','Type de service ajouter',0),(279355,7760,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã®ç¨®é¡žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(279356,7760,'pt','Adicionar o tipo de serviÃ§o',0),(279357,7760,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(279358,7760,'es','Tipo de Servicio Agregar',0),(279359,7760,'de','Diensttyp hinzufÃ¼gen',0),(279360,7760,'en','Service Type Add',0),(279361,7761,'is','',0),(279362,7761,'dr','Ù‚ÙŠÙ…Øª Ù¾Ø§Ø±Ùƒ Ø´Ø®ØµÙŠ  ',0),(279363,7761,'pr','Ù‚ÙŠÙ…Øª Ù¾Ø§Ø±Ùƒ Ø´Ø®ØµÙŠ  ',0),(279364,7761,'tr','Kendi kendine Park fiyat',0),(279365,7761,'pl','Cena wÅ‚asny Park',0),(279366,7761,'bg','Ð¡Ð°Ð¼Ð¾ÑÑ‚Ð¾ÑÑ‚ÐµÐ»Ð½Ð¾ Ð¿Ð°Ñ€Ðº Ñ†ÐµÐ½Ð°',0),(279367,7761,'ur','Ù†ÙØ³ Ù¾Ø§Ø±Ú© Ù‚ÛŒÙ…Øª',0),(279368,7761,'sr','Ð¡ÐµÐ»Ñ„ ÐŸÐ°Ñ€Ðº Ñ†ÐµÐ½Ð°',0),(279369,7761,'vi','GiÃ¡ tá»± Ä‘áº­u xe',0),(279370,7761,'af','Self Park prys',0),(279371,7761,'ro','Parcul auto Pret',0),(279372,7761,'et','Ise Park hind',0),(279373,7761,'si','Cena self Park',0),(279374,7761,'ba','Harga diri Park',0),(279375,7761,'nl','Self Park prijs',0),(279376,7761,'fi','Itse Park hinta',0),(279377,7761,'no','Selv Park pris',0),(279378,7761,'da','Self Park pris',0),(279379,7761,'ko','ìžê¸° íŒŒí¬ ê°€ê²©',0),(279380,7761,'he','×ž×—×™×¨ ×”×¢×¦×ž×™ ×¤××¨×§',0),(279381,7761,'el','Î‘Ï…Ï„Î¿ Ï€Î¬ÏÎºÎ¿ Ï„Î¹Î¼Î®',0),(279382,7761,'zh','è‡ªæˆ‘æ”¾ç½®ä»·æ ¼\r\n',0),(279383,7761,'sv','Self Park pris',0),(279384,7761,'it','Parco auto prezzo',0),(279385,7761,'tl','',0),(279386,7761,'th','&#3619;&#3634;&#3588;&#3634;&#3592;&#3629;&#3604;&#3619;&#3606;&#3586;&#3629;&#3591;&#3605;&#3609;&#3648;&#3629;&#3591;',0),(279387,7761,'hi','à¤†à¤¤à¥à¤® à¤®à¥‚à¤²à¥à¤¯ à¤ªà¤¾à¤°à¥à¤•',0),(279388,7761,'ms','Harga diri Park',0),(279389,7761,'ar','Ø³Ø¹Ø± Ø¨Ø§Ø±Ùƒ Ø§Ù„Ù…ØªÙ…ØªØ¹Ø© Ø¨Ø§Ù„Ø­ÙƒÙ… Ø§Ù„Ø°Ø§ØªÙŠ',0),(279390,7761,'fr','Parc auto prix',0),(279391,7761,'jp','è‡ªå·±å…¬åœ’ã®ä¾¡æ ¼',0),(279392,7761,'pt','PreÃ§o de auto Park',0),(279393,7761,'ru','Self-Ð¿Ð°Ñ€Ðº Ñ†ÐµÐ½Ñ‹',0),(279394,7761,'es','Precio para Estacionar si Mismo',0),(279395,7761,'de','Self-Park Preise',0),(279396,7761,'en','Self Park Price',0),(279397,7762,'is','',0),(279398,7762,'dr','Ù‚ÙŠÙ…Øª Ø®Ø¯Ù…Ù‡',0),(279399,7762,'pr','Ù‚ÙŠÙ…Øª Ø®Ø¯Ù…Ù‡',0),(279400,7762,'tr','Vale fiyatÄ±',0),(279401,7762,'pl','Cena samochodu',0),(279402,7762,'bg','Valet Ñ†ÐµÐ½Ð°',0),(279403,7762,'ur','Ù‚ÛŒÙ…Øª Ø®Ø¯Ù…ØªÚ¯Ø§Ø±',0),(279404,7762,'sr','Ð¡Ð¾Ð±Ð°Ñ€ Ñ†ÐµÐ½Ð°',0),(279405,7762,'vi','GiÃ¡ Ä‘áº­u xe vá»›i ngÆ°á»i bá»“i ',0),(279406,7762,'af','Valet prys',0),(279407,7762,'ro','Valet Pret',0),(279408,7762,'et','Toapoiss hind',0),(279409,7762,'si','Cena sluga',0),(279410,7762,'ba','Harga valet',0),(279411,7762,'nl','Valet prijs',0),(279412,7762,'fi','Valuutanvaihto hinta',0),(279413,7762,'no','Betjent pris',0),(279414,7762,'da','Betjent pris',0),(279415,7762,'ko','ì£¼ì°¨ ê°€ê²©',0),(279416,7762,'he','×ž×—×™×¨ ×”×—× ×™×”',0),(279417,7762,'el','Î¤Î¹Î¼Î® Î¼Îµ Ï€Î±ÏÎºÎ±Î´ÏŒÏÎ¿',0),(279418,7762,'zh','ä»£å®¢ä»·æ ¼\r\n',0),(279419,7762,'sv','BetjÃ¤nad pris',0),(279420,7762,'it','Cameriere prezzo',0),(279421,7762,'tl','',0),(279422,7762,'th','&#3588;&#3609;&#3651;&#3594;&#3657;&#3619;&#3634;&#3588;&#3634;',0),(279423,7762,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤µà¥ˆà¤²à¥‡à¤Ÿ',0),(279424,7762,'ms','Harga Perkhidmatan valet',0),(279425,7762,'ar','Ø§Ù„Ø³Ø¹Ø± ØµÙ',0),(279426,7762,'fr','Prix avec service de voiturier',0),(279427,7762,'jp','ä¿‚å“¡ä»˜ããƒ‘ãƒ¼ã‚­ãƒ³ã‚° ã‚µãƒ¼ãƒ“ã‚¹ä¾¡æ ¼',0),(279428,7762,'pt','PreÃ§o de manobrista',0),(279429,7762,'ru','Ð¦ÐµÐ½Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð¾Ð±Ð¸Ð»ÐµÐ¹ ÑÐ»ÑƒÐ¶Ð°Ñ‰Ð¸Ð¼ Ð³Ð¾ÑÑ‚Ð¸Ð½Ð¸Ñ†Ñ‹',0),(279430,7762,'es','Precio de Valet',0),(279431,7762,'de','Valet-Preis',0),(279432,7762,'en','Valet Price',0),(279433,7763,'is','',0),(279434,7763,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ Ù…Ø³ØªÙ‚ÙŠÙ… Ù„Ø§Ø²Ù… Ø§Ø³Øª',0),(279435,7763,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ùƒ ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ Ù…Ø³ØªÙ‚ÙŠÙ… Ù„Ø§Ø²Ù… Ø§Ø³Øª',0),(279436,7763,'tr','Banka hesaplarÄ±mÄ±z (yalnÄ±zca doÄŸrudan Ã¶deme iÃ§in gerekli)',0),(279437,7763,'pl','Bank informacji (wymagane tylko dla bezpoÅ›rednich depozytÃ³w)',0),(279438,7763,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ (Ð¸Ð·Ð¸ÑÐºÐ²Ð° ÑÐ°Ð¼Ð¾ Ð·Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚)',0),(279439,7763,'ur','Ø¨ÛŒÙ†Ú© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª (ØµØ±Ù Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ú©Û’ Ù„Ø¦Û’ Ø¶Ø±ÙˆØ±Øª)',0),(279440,7763,'sr','Ð‘Ð°Ð½ÐºÐ° Ð˜Ð½Ñ„Ð¾ (ÑÐ°Ð¼Ð¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ð·Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚)',0),(279441,7763,'vi','ThÃ´ng tin ngÃ¢n hÃ ng (Chá»‰ yÃªu cáº§u khi thanh toÃ¡n trá»±c tiáº¿p)',0),(279442,7763,'af','Bank Info (Slegs Benodig vir Direkte Deposito)',0),(279443,7763,'ro','Info bancar (necesarÄƒ doar pentru Direct de depozit)',0),(279444,7763,'et','Panga Info (ainult vajalik panga Ã¼lekanne)',0),(279445,7763,'si','Info bank (zahtevana samo za neposredno depozit)',0),(279446,7763,'ba','Info Bank (hanya diperlukan untuk Deposit langsung)',0),(279447,7763,'nl','Bank Info (alleen vereist voor directe storting)',0),(279448,7763,'fi','Bank Info (tarvitaan vain suora talletus)',0),(279449,7763,'no','Bank Info (bare nÃ¸dvendig for direkte innskudd)',0),(279450,7763,'da','Bank Info (kun pÃ¥krÃ¦vet for direkte indbetaling)',0),(279451,7763,'ko','ì€í–‰ ì •ë³´ (ì§ì ‘ ìž…ê¸ˆì—ë§Œ í•„ìš”)',0),(279452,7763,'he','×¤×¨×˜×™ ×”×‘× ×§ (×“×¨×•×© ×¨×§ ×¢×‘×•×¨ ×”×¤×§×“×” ×™×©×™×¨×”)',0),(279453,7763,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¤ÏÎ¬Ï€ÎµÎ¶Î±Ï‚ (Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î¼ÏŒÎ½Î¿ Î³Î¹Î± Ï„Î·Î½ Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·)',0),(279454,7763,'zh','é“¶è¡Œä¿¡æ¯ï¼ˆåªé€‚ç”¨äºŽç›´æŽ¥å­˜æ¬¾å¿…å¡«ï¼‰\r\n',0),(279455,7763,'sv','Bank Info (endast krÃ¤vs fÃ¶r direkt insÃ¤ttning)',0),(279456,7763,'it','Info banca (richiesto solo per deposito diretto)',0),(279457,7763,'tl','',0),(279458,7763,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619; (&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;&#3613;&#3634;&#3585;&',0),(279459,7763,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ (à¤•à¥‡à¤µà¤² à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤µà¤¶à¥à¤¯à¤•)',0),(279460,7763,'ms','Maklumat Bank (hanya diperlukan untuk Deposit langsung)',0),(279461,7763,'ar','Ø¨Ù†Ùƒ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª (Ù…Ø·Ù„ÙˆØ¨ ÙÙ‚Ø· Ù„Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±)',0),(279462,7763,'fr','Info Banque (nÃ©cessaire uniquement pour le dÃ©pÃ´t Direct)',0),(279463,7763,'jp','éŠ€è¡Œæƒ…å ± (ç›´æŽ¥æ²ˆæ®¿ç‰©ã®ãŸã‚ã«ã®ã¿å¿…è¦)',0),(279464,7763,'pt','InformaÃ§Ã£o bancÃ¡ria (necessÃ¡ria apenas para depÃ³sito direto)',0),(279465,7763,'ru','Ð˜Ð½Ñ„Ð¾ Ð‘Ð°Ð½ÐºÐ°(Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ ÐŸÑ€ÑÐ¼Ð¾Ð³Ð¾ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°)',0),(279466,7763,'es','InformaciÃ³n de Banco (Solamente se requiere para Deposito Directo)',0),(279467,7763,'de','Bankverbindung (nur fÃ¼r direkte Einzahlung erforderlich)',0),(279468,7763,'en','Bank Info(Only Required for Direct Deposit)',0),(279469,7764,'is','',0),(279470,7764,'dr','ØªÙˆØ¬Ù‡ Ù†ÙƒÙ†ÙŠØ¯ ',0),(279471,7764,'pr','ØªÙˆØ¬Ù‡ Ù†ÙƒÙ†ÙŠØ¯ ',0),(279472,7764,'tr','HiÃ§bir ÅŸey',0),(279473,7764,'pl','Nic',0),(279474,7764,'bg','ÐÐµ ÑÐµ Ð¿Ñ€Ð°Ð²Ð¸ Ð½Ð¸Ñ‰Ð¾',0),(279475,7764,'ur','Ú©Ú†Ú¾ Ù†ÛÛŒÚº',0),(279476,7764,'sr','ÐÐ¸ÑˆÑ‚Ð°',0),(279477,7764,'vi','KhÃ´ng lÃ m gÃ¬',0),(279478,7764,'af','Moenie iets Doen Nie',0),(279479,7764,'ro','Nu fac nimic',0),(279480,7764,'et','Ei tee midagi',0),(279481,7764,'si','Ne stori niÄesar',0),(279482,7764,'ba','Melakukan apa-apa',0),(279483,7764,'nl','Niets doen',0),(279484,7764,'fi','EivÃ¤t tee mitÃ¤Ã¤n',0),(279485,7764,'no','Ikke gjÃ¸r noe',0),(279486,7764,'da','Intet gÃ¸re',0),(279487,7764,'ko','ì•„ë¬´ê²ƒë„ í•˜ì§€ ì•Šê³ ',0),(279488,7764,'he','×œ×¢×©×•×ª ×›×œ×•×',0),(279489,7764,'el','Î”ÎµÎ½ ÎºÎ¬Î½Î¿Ï…Î½ Ï„Î¯Ï€Î¿Ï„Î±',0),(279490,7764,'zh','æ— ä¸º\r\n',0),(279491,7764,'sv','GÃ¶r ingenting',0),(279492,7764,'it','Non fare nulla',0),(279493,7764,'tl','',0),(279494,7764,'th','&#3652;&#3617;&#3656;&#3607;&#3635;&#3629;&#3632;&#3652;&#3619;&#3648;&#3621;&#3618;',0),(279495,7764,'hi','à¤•à¥à¤› à¤­à¥€ à¤¨à¤¹à¥€à¤‚',0),(279496,7764,'ms','Melakukan apa-apa',0),(279497,7764,'ar','Ù„Ø§ ØªÙØ¹Ù„ Ø´ÙŠØ¦Ø§',0),(279498,7764,'fr','Ne rien faire',0),(279499,7764,'jp','ä½•ã‚‚ã—ã¾ã›ã‚“ã€‚',0),(279500,7764,'pt','NÃ£o fazer nada',0),(279501,7764,'ru','ÐÐµ Ð”ÐµÐ»Ð°Ñ‚ÑŒ ÐÐ¸Ñ‡ÐµÐ³Ð¾',0),(279502,7764,'es','No Hace Nada',0),(279503,7764,'de','Nichts tun',0),(279504,7764,'en','Do Nothing',0),(279505,7765,'is','',0),(279506,7765,'dr','Ù†Ø§Ù… ÙƒØ§Ø±Ù…Ù†Ø¯',0),(279507,7765,'pr','Ù†Ø§Ù… ÙƒØ§Ø±Ù…Ù†Ø¯',0),(279508,7765,'tr','Ã‡alÄ±ÅŸan adÄ±',0),(279509,7765,'pl','Nazwisko pracownika',0),(279510,7765,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(279511,7765,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ù†Ø§Ù…',0),(279512,7765,'sr','Ð˜Ð¼Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(279513,7765,'vi','TÃªn NhÃ¢n viÃªn ',0),(279514,7765,'af','Werknemer Naam',0),(279515,7765,'ro','Numele angajatului',0),(279516,7765,'et','TÃ¶Ã¶taja nimi',0),(279517,7765,'si','Ime zaposlenega',0),(279518,7765,'ba','Nama karyawan',0),(279519,7765,'nl','Werknemersnaam',0),(279520,7765,'fi','TyÃ¶ntekijÃ¤n nimi',0),(279521,7765,'no','Navn pÃ¥ ansatt',0),(279522,7765,'da','Medarbejdernavn',0),(279523,7765,'ko','ì§ì› ì´ë¦„',0),(279524,7765,'he','×©× ×¢×•×‘×“',0),(279525,7765,'el','ÎŒÎ½Î¿Î¼Î± Ï…Ï€Î±Î»Î»Î®Î»Î¿Ï…',0),(279526,7765,'zh','å‘˜å·¥å§“å',0),(279527,7765,'sv','AnstÃ¤lldes namn',0),(279528,7765,'it','Nome dipendente',0),(279529,7765,'tl','',0),(279530,7765,'th','&#3594;&#3639;&#3656;&#3629;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(279531,7765,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¤¾ à¤¨à¤¾à¤®',0),(279532,7765,'ms','Nama kakitangan',0),(279533,7765,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…ÙˆØ¸Ù',0),(279534,7765,'fr','Nom de l\'employÃ©',0),(279535,7765,'jp','å¾“æ¥­å“¡å',0),(279536,7765,'pt','Nome do funcionÃ¡rio',0),(279537,7765,'ru','Ð˜Ð¼Ñ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(279538,7765,'es','Empleado Nombre',0),(279539,7765,'de','Name des Mitarbeiters',0),(279540,7765,'en','Employee Name',0),(279541,7766,'is','',0),(279542,7766,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯\r\n SS',0),(279543,7766,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯\r\n SS',0),(279544,7766,'tr','Ã‡alÄ±ÅŸan SS',0),(279545,7766,'pl','Pracownik SS',0),(279546,7766,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¡Ð¡',0),(279547,7766,'ur','Ù…Ù„Ø§Ø²Ù… Ø§ÛŒØ³ Ø§ÛŒØ³',0),(279548,7766,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¡Ð¡',0),(279549,7766,'vi','SS NhÃ¢n viÃªn',0),(279550,7766,'af','Werknemer SS',0),(279551,7766,'ro','Angajat SS',0),(279552,7766,'et','TÃ¶Ã¶taja SS',0),(279553,7766,'si','Zaposlenega SS',0),(279554,7766,'ba','Karyawan SS',0),(279555,7766,'nl','Werknemer SS',0),(279556,7766,'fi','TyÃ¶ntekijÃ¤n SS',0),(279557,7766,'no','Ansatt SS',0),(279558,7766,'da','Medarbejder SS',0),(279559,7766,'ko','ì§ì› SS',0),(279560,7766,'he','×”×¢×•×‘×“ ×”××¡. ××¡',0),(279561,7766,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ SS',0),(279562,7766,'zh','å‘˜å·¥ç¤¾ä¼šä¿éšœ\r\n',0),(279563,7766,'sv','AnstÃ¤lld SS',0),(279564,7766,'it','Dipendente SS',0),(279565,7766,'tl','',0),(279566,7766,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609; SS',0),(279567,7766,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ SS',0),(279568,7766,'ms','Pekerja SS',0),(279569,7766,'ar','Ø§Ù„Ù…ÙˆØ¸Ù SS',0),(279570,7766,'fr','EmployÃ© SS',0),(279571,7766,'jp','å¾“æ¥­å“¡ SS',0),(279572,7766,'pt','FuncionÃ¡rio SS',0),(279573,7766,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº Ð¡Ð¡',0),(279574,7766,'es','Empleado SS',0),(279575,7766,'de','Mitarbeiter SS',0),(279576,7766,'en','Employee SS',0),(279577,7767,'is','',0),(279578,7767,'dr','Ù†Ø§Ù… ÙƒØ§Ø±ÙØ±Ù…Ø§',0),(279579,7767,'pr','Ù†Ø§Ù… ÙƒØ§Ø±ÙØ±Ù…Ø§',0),(279580,7767,'tr','Ä°ÅŸverenin adÄ±',0),(279581,7767,'pl','Nazwa pracodawcy',0),(279582,7767,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»Ñ',0),(279583,7767,'ur','Ø¢Ø¬Ø± Ú©Ø§ Ù†Ø§Ù…',0),(279584,7767,'sr','Ð˜Ð¼Ðµ Ð¿Ð¾ÑÐ»Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(279585,7767,'vi','TÃªn Chá»§ Cty',0),(279586,7767,'af','Werkgewer Naam',0),(279587,7767,'ro','Nume angajator',0),(279588,7767,'et','TÃ¶Ã¶andja nimi',0),(279589,7767,'si','Ime delodajalca',0),(279590,7767,'ba','Nama majikan',0),(279591,7767,'nl','Naam van de werkgever',0),(279592,7767,'fi','TyÃ¶nantajan nimi',0),(279593,7767,'no','Arbeidsgiver navn',0),(279594,7767,'da','Arbejdsgiverens navn',0),(279595,7767,'ko','ê³ ìš©ì£¼ ì´ë¦„',0),(279596,7767,'he','×©× ×ž×¢×¡×™×§',0),(279597,7767,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏÎ³Î¿Î´ÏŒÏ„Î·',0),(279598,7767,'zh','é›‡ä¸»åç§°\r\n',0),(279599,7767,'sv','Arbetsgivarens namn',0),(279600,7767,'it','Nome del datore di lavoro',0),(279601,7767,'tl','',0),(279602,7767,'th','&#3594;&#3639;&#3656;&#3629;&#3609;&#3634;&#3618;&#3592;&#3657;&#3634;&#3591;',0),(279603,7767,'hi','à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤•à¤¾ à¤¨à¤¾à¤®',0),(279604,7767,'ms','Nama majikan',0),(279605,7767,'ar','Ø§Ø³Ù… ØµØ§Ø­Ø¨ Ø§Ù„Ø¹Ù…Ù„',0),(279606,7767,'fr','Nom de l\'employeur',0),(279607,7767,'jp','é›‡ç”¨è€…å',0),(279608,7767,'pt','Nome do empregador',0),(279609,7767,'ru','Ð˜Ð¼Ñ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(279610,7767,'es','Empleado Nombre',0),(279611,7767,'de','Arbeitgeber Name',0),(279612,7767,'en','Employer Name',0),(279613,7768,'is','',0),(279614,7768,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ \r\nFUI ',0),(279615,7768,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ \r\nFUI ',0),(279616,7768,'tr','Federal FUI vergi',0),(279617,7768,'pl','Podatku federalnego FUI',0),(279618,7768,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð° FUI Ð´Ð°Ð½ÑŠÐº',0),(279619,7768,'ur','ÙˆÙØ§Ù‚ÛŒ ÙØ§ Ù¹ÛŒÚ©Ø³',0),(279620,7768,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ ÑÐ¸Ñ‚Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(279621,7768,'vi','Thuáº¿ FUI LiÃªn bang',0),(279622,7768,'af','Federale FUI belasting',0),(279623,7768,'ro','Impozitului federal FUI',0),(279624,7768,'et','FÃ¶deraalne FUI maksu',0),(279625,7768,'si','Zvezni FUI davka',0),(279626,7768,'ba','Pajak Federal FUI',0),(279627,7768,'nl','Federale FUI belasting',0),(279628,7768,'fi','Liittovaltion FUI vero',0),(279629,7768,'no','FÃ¸derale FUI skatt',0),(279630,7768,'da','FÃ¸derale FUI skat',0),(279631,7768,'ko','ì—°ë°© FUI ì„¸ê¸ˆ',0),(279632,7768,'he','FUI ×”×¤×“×¨×œ×™ ×ž×¡',0),(279633,7768,'el','FUI Î¿Î¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï…',0),(279634,7768,'zh','è”é‚¦å¥Žç¨Ž\r\n',0),(279635,7768,'sv','Federala FUI skatt',0),(279636,7768,'it','FUI federale fiscale',0),(279637,7768,'tl','',0),(279638,7768,'th','&#3616;&#3634;&#3625;&#3637; FUI &#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(279639,7768,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ FUI à¤Ÿà¥ˆà¤•à¥à¤¸',0),(279640,7768,'ms','Cukai Persekutuan FUI',0),(279641,7768,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(279642,7768,'fr','ImpÃ´t fÃ©dÃ©ral FUI',0),(279643,7768,'jp','é€£é‚¦ FUI ç¨Ž',0),(279644,7768,'pt','Imposto federal FUI',0),(279645,7768,'ru','FUI Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(279646,7768,'es','Impuesto Federal FUI',0),(279647,7768,'de','Bundes FUI Steuer',0),(279648,7768,'en','Federal FUI Tax',0),(279649,7769,'is','',0),(279650,7769,'dr','Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø² Ø´Ø±ÙƒØª Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(279651,7769,'pr','Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø² Ø´Ø±ÙƒØª Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(279652,7769,'tr','Åžirket katkÄ± Ã¶deme dahil',0),(279653,7769,'pl','ObejmujÄ… wkÅ‚ad firmy w pÅ‚atnoÅ›ci',0),(279654,7769,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð¿Ñ€Ð¸Ð½Ð¾Ñ Ð² Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(279655,7769,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ú©Ø±Ø¯Ø§Ø± Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”',0),(279656,7769,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾Ñ Ð¾Ð±ÑƒÑ…Ð²Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(279657,7769,'vi','ThÃªm Ä‘Ã³ng gÃ³p cá»§a cty vÃ o thanh toÃ¡n',0),(279658,7769,'af','Sluit Ondernemingbydraes in met Betaling',0),(279659,7769,'ro','Includ compania contribuÅ£ia la plata',0),(279660,7769,'et','Sisaldavad ettevÃµtte toetuse maksmine',0),(279661,7769,'si','VkljuÄujejo podjetje prispevka v plaÄilo',0),(279662,7769,'ba','Termasuk kontribusi perusahaan dalam pembayaran',0),(279663,7769,'nl','Vennootschapsbijdrage opnemen in betaling',0),(279664,7769,'fi','SisÃ¤llyttÃ¤Ã¤ yrityksen osuus maksu',0),(279665,7769,'no','Ta selskapet bidrag i betaling',0),(279666,7769,'da','Omfatte virksomhedens bidrag i betaling',0),(279667,7769,'ko','ì§€ë¶ˆì—ì„œ íšŒì‚¬ ê¸°ì—¬ë¥¼ í¬í•¨',0),(279668,7769,'he','×œ×›×œ×•×œ ×ª×¨×•×ž×ª ×”×—×‘×¨×” ×‘×ª×©×œ×•×',0),(279669,7769,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÏƒÏ…Î¼Î²Î¿Î»Î® ÏƒÏ„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î®',0),(279670,7769,'zh','åŒ…æ‹¬å…¬å¸çš„èµ„é‡‘èµ„åŠ©\r\n',0),(279671,7769,'sv','Inkludera fÃ¶retag bidrag i betalning',0),(279672,7769,'it','Includono il contributo della societÃ  nel pagamento',0),(279673,7769,'tl','',0),(279674,7769,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3651;&#3609;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3592;&#3634;&#3588;&#3586;&#3629;&#3591;&#3610;&#3',0),(279675,7769,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤…à¤‚à¤¶à¤¦à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(279676,7769,'ms','Termasuk caruman Syarikat pembayaran',0),(279677,7769,'ar','ÙˆØªØ´Ù…Ù„ Ù…Ø³Ø§Ù‡Ù…Ø© Ø§Ù„Ø´Ø±ÙƒØ© ÙÙŠ Ø§Ù„Ø¯ÙØ¹',0),(279678,7769,'fr','Comprennent la Contribution de la compagnie en paiement',0),(279679,7769,'jp','ãŠæ”¯æ‰•ã„ã«è²¢çŒ®ã‚’å«ã‚ã‚‹',0),(279680,7769,'pt','Incluir a contribuiÃ§Ã£o da empresa no pagamento',0),(279681,7769,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð²ÐºÐ»Ð°Ð´ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð² Ð¾Ð¿Ð»Ð°Ñ‚Ðµ',0),(279682,7769,'es','Incluir ContribuciÃ³n de Empresa en el Pago',0),(279683,7769,'de','Sind Sie Firma Beteiligung in Zahlung',0),(279684,7769,'en','Include Company Contribution in Payment',0),(279685,7770,'is','',0),(279686,7770,'dr','ÙƒØ¯Ø§Ù… Ø¯Ø± Ø´Ø±Ø­ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(279687,7770,'pr','ÙƒØ¯Ø§Ù… Ø¯Ø± Ø´Ø±Ø­ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(279688,7770,'tr','AÃ§Ä±klama alanÄ±na dahil',0),(279689,7770,'pl','To co w opisie',0),(279690,7770,'bg','ÐšÐ¾Ð¸Ñ‚Ð¾ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(279691,7770,'ur','Ø¬Ø³ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(279692,7770,'sr','Ð¨Ñ‚Ð¾ ÑƒÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ Ñƒ Ð¾Ð¿Ð¸Ñ',0),(279693,7770,'vi','Bao gá»“m trong mÃ´ táº£ nÃ o',0),(279694,7770,'af','Sluit wat in die beskrywing',0),(279695,7770,'ro','Care includ in Descrierea',0),(279696,7770,'et','Mis kaasata kirjeldus',0),(279697,7770,'si','Ki vkljuÄujejo opis',0),(279698,7770,'ba','Termasuk yang di Deskripsi',0),(279699,7770,'nl','Die deelnemen aan beschrijving',0),(279700,7770,'fi','Joka sisÃ¤llytetÃ¤Ã¤n kuvaus',0),(279701,7770,'no','Inkluder som beskrivelse',0),(279702,7770,'da','Omfatte der i Beskrivelse',0),(279703,7770,'ko','ì„¤ëª…ì—ëŠ” í¬í•¨',0),(279704,7770,'he','×›×œ×•×œ ×‘×• ×ª×™××•×¨',0),(279705,7770,'el','Î Î¿Ï… Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(279706,7770,'zh','åŒ…æ‹¬æè¿°ä¸­çš„\r\n',0),(279707,7770,'sv','Bland annat som i beskrivningen',0),(279708,7770,'it','Che includono nella descrizione',0),(279709,7770,'tl','',0),(279710,7770,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3629;&#3633;&#3609;&#3652;&#3627;&#3609;',0),(279711,7770,'hi','à¤œà¥‹ à¤µà¤°à¥à¤£à¤¨ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(279712,7770,'ms','Termasuk yang Perihalan',0),(279713,7770,'ar','ØªØ¯Ø±Ø¬ ÙÙŠÙ‡Ø§ ÙÙŠ Ø§Ù„ÙˆØµÙ',0),(279714,7770,'fr','Qui incluent dans la Description',0),(279715,7770,'jp','èª¬æ˜Žã‚’å«ã‚ã‚‹',0),(279716,7770,'pt','Que inclua na descriÃ§Ã£o',0),(279717,7770,'ru','Ð§Ñ‚Ð¾ Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð² Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(279718,7770,'es','Incluir CuÃ¡l en la DescripciÃ³n',0),(279719,7770,'de','Enthalten Sie, die in Beschreibung',0),(279720,7770,'en','Include Which in Description',0),(279721,7771,'is','',0),(279722,7771,'dr','Ù…ØªÙ† Ø¯ÙŠÚ¯Ø± ',0),(279723,7771,'pr','Ù…ØªÙ† Ø¯ÙŠÚ¯Ø± ',0),(279724,7771,'tr','DiÄŸer metin',0),(279725,7771,'pl','Inny tekst',0),(279726,7771,'bg','Ð”Ñ€ÑƒÐ³ Ñ‚ÐµÐºÑÑ‚',0),(279727,7771,'ur','Ø¯ÛŒÚ¯Ø± Ù…ØªÙ†',0),(279728,7771,'sr','Ð”Ñ€ÑƒÐ³Ð¸ Ñ‚ÐµÐºÑÑ‚',0),(279729,7771,'vi','VÄƒn báº£n KhÃ¡c',0),(279730,7771,'af','Ander Teks',0),(279731,7771,'ro','Alt Text',0),(279732,7771,'et','Muud teksti',0),(279733,7771,'si','Drugo besedilo',0),(279734,7771,'ba','Teks lain',0),(279735,7771,'nl','Andere tekst',0),(279736,7771,'fi','Muuta tekstiÃ¤',0),(279737,7771,'no','Annen tekst',0),(279738,7771,'da','Anden tekst',0),(279739,7771,'ko','ë‹¤ë¥¸ í…ìŠ¤íŠ¸',0),(279740,7771,'he','×˜×§×¡×˜ ××—×¨',0),(279741,7771,'el','Î†Î»Î»Î¿ ÎºÎµÎ¯Î¼ÎµÎ½Î¿',0),(279742,7771,'zh','å…¶ä»–æ–‡æœ¬\r\n',0),(279743,7771,'sv','Annan Text',0),(279744,7771,'it','Altro testo',0),(279745,7771,'tl','',0),(279746,7771,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3629;&#3639;&#3656;&#3609;',0),(279747,7771,'hi','à¤…à¤¨à¥à¤¯ à¤ªà¤¾à¤ ',0),(279748,7771,'ms','Teks lain',0),(279749,7771,'ar','Ù†Øµ Ø¢Ø®Ø±',0),(279750,7771,'fr','Autre texte',0),(279751,7771,'jp','ãã®ä»–ã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(279752,7771,'pt','Outro texto',0),(279753,7771,'ru','Ð”Ñ€ÑƒÐ³Ð¾Ð¹ Ñ‚ÐµÐºÑÑ‚',0),(279754,7771,'es','Otro Texto',0),(279755,7771,'de','Anderen Text',0),(279756,7771,'en','Other Text',0),(279757,7772,'is','',0),(279758,7772,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(279759,7772,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(279760,7772,'tr','BorÃ§lar iÃ§in geÃ§mek',0),(279761,7772,'pl','PrzekazaÄ‡ do zobowiÄ…zaÅ„',0),(279762,7772,'bg','ÐœÐ¸Ð½Ð°Ð²Ð°Ð¼ ÐºÑŠÐ¼ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(279763,7772,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Û’ Ù¾Ø§Ø³',0),(279764,7772,'sr','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´Ð¸Ñ‚Ðµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(279765,7772,'vi','Káº¿t Chuyá»ƒn Sang TK Pháº£i Tráº£',0),(279766,7772,'af','Aanstuur na Uitgawes (RB)',0),(279767,7772,'ro','Trece la datorii',0),(279768,7772,'et','Edasi kohustused',0),(279769,7772,'si','Prehod obveznosti',0),(279770,7772,'ba','Lulus ke hutang',0),(279771,7772,'nl','Doorgeven aan schulden',0),(279772,7772,'fi','SiirtÃ¤Ã¤ Ostovelat',0),(279773,7772,'no','GÃ¥ til leverandÃ¸r',0),(279774,7772,'da','Pass til gÃ¦ld',0),(279775,7772,'ko','ì™¸ìƒ ë§¤ìž…ê¸ˆì„ ì „ë‹¬',0),(279776,7772,'he','×œ×”×¢×‘×™×¨ ×–×›××™×',0),(279777,7772,'el','Î ÎµÏÎ¬ÏƒÎµÎ¹ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(279778,7772,'zh','ä¼ é€’åˆ°åº”ä»˜å¸æ¬¾\r\n',0),(279779,7772,'sv','Passera till leverantÃ¶rsskulder',0),(279780,7772,'it','Passare ai debiti',0),(279781,7772,'tl','',0),(279782,7772,'th','&#3612;&#3656;&#3634;&#3609;&#3652;&#3611;&#3618;&#3633;&#3591;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(279783,7772,'hi','à¤¸à¥‡ Payables à¤•à¥‡ à¤ªà¤¾à¤¸',0),(279784,7772,'ms','Berpindah kepada pemiutang',0),(279785,7772,'ar','ØªÙ…Ø±ÙŠØ± Ù„Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(279786,7772,'fr','Passer aux crÃ©diteurs',0),(279787,7772,'jp','å‚µå‹™ã«æ¸¡ã™',0),(279788,7772,'pt','Passar para contas a pagar',0),(279789,7772,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(279790,7772,'es','Pasar a Proveedores',0),(279791,7772,'de','Ãœbergeben an Verbindlichkeiten',0),(279792,7772,'en','Pass To Payables',0),(279793,7773,'is','',0),(279794,7773,'dr','ØªØ§Ø±ÙŠØ® Ø­Ù‚ÙˆÙ‚',0),(279795,7773,'pr','ØªØ§Ø±ÙŠØ® Ø­Ù‚ÙˆÙ‚',0),(279796,7773,'tr','Ã–deme tarihi',0),(279797,7773,'pl','PÅ‚aciÄ‡ Data',0),(279798,7773,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ð´Ð°Ñ‚Ð°',0),(279799,7773,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(279800,7773,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(279801,7773,'vi','NgÃ y tráº£',0),(279802,7773,'af','Besoldigingdatum',0),(279803,7773,'ro','PlÄƒti data',0),(279804,7773,'et','Maksmise kuupÃ¤ev',0),(279805,7773,'si','PlaÄati datum',0),(279806,7773,'ba','Membayar tanggal',0),(279807,7773,'nl','Betalen datum',0),(279808,7773,'fi','MaksupÃ¤ivÃ¤',0),(279809,7773,'no','Betale dato',0),(279810,7773,'da','Betale dato',0),(279811,7773,'ko','ì§€ë¶ˆ ë‚ ì§œ',0),(279812,7773,'he','×œ×©×œ× ×ª××¨×™×š',0),(279813,7773,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(279814,7773,'zh','ä»˜æ¬¾æ—¥æœŸ\r\n',0),(279815,7773,'sv','Betala datum',0),(279816,7773,'it','Data di pagamento',0),(279817,7773,'tl','',0),(279818,7773,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;',0),(279819,7773,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(279820,7773,'ms','Membayar tarikh',0),(279821,7773,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹',0),(279822,7773,'fr','Date de paiement',0),(279823,7773,'jp','æ”¯æ‰•æ—¥',0),(279824,7773,'pt','Data de pagar',0),(279825,7773,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(279826,7773,'es','Fecha de Pago',0),(279827,7773,'de','Zahlen, Datum',0),(279828,7773,'en','Pay Date',0),(279829,7774,'is','',0),(279830,7774,'dr','Ù…Ø§Ù„ÙŠØ§Øª ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(279831,7774,'pr','Ù…Ø§Ù„ÙŠØ§Øª ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(279832,7774,'tr','Workmans Comp vergi',0),(279833,7774,'pl','Workmans zÅ‚ podatku',0),(279834,7774,'bg','Workmans Comp Ð´Ð°Ð½ÑŠÐº',0),(279835,7774,'ur','ÙˆÙˆØ±Ú©Ù…Ø¢Ù†Ø³ Ù¹ÛŒÚ©Ø³ Ú©Ø¹Ù…Ù¾ Û”',0),(279836,7774,'sr','WÐ¾Ñ€ÐºÐ¼Ð°Ð½Ñ Ð¦Ð¾Ð¼Ð¿ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(279837,7774,'vi','Thuáº¿ CÃ´ng nhÃ¢n Comp',0),(279838,7774,'af','Vergoedingskommisaris Belasting',0),(279839,7774,'ro','Workmans Comp fiscale',0),(279840,7774,'et','TÃ¶Ã¶lise kompensatsiooni eest maks',0),(279841,7774,'si','Workmans Comp davka',0),(279842,7774,'ba','Pajak Comp Workmans',0),(279843,7774,'nl','Workmans Comp belasting',0),(279844,7774,'fi','Workmans Comp vero',0),(279845,7774,'no','Workmans Comp skatt',0),(279846,7774,'da','Workmans Comp skat',0),(279847,7774,'ko','Workmans ê´‘ê³  ì„¸ê¸ˆ',0),(279848,7774,'he','Workmans Comp ×ž×¡',0),(279849,7774,'el','Workmans Comp Ï†ÏŒÏÎ¿Ï…',0),(279850,7774,'zh','å·¥äººèµ”å¿ç¨Ž\r\n',0),(279851,7774,'sv','Workmans Comp skatt',0),(279852,7774,'it','Workmans Comp fiscale',0),(279853,7774,'tl','',0),(279854,7774,'th','&#3616;&#3634;&#3625;&#3637;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(279855,7774,'hi','Workmans à¤•à¤‚à¤ª à¤Ÿà¥ˆà¤•à¥à¤¸',0),(279856,7774,'ms','Cukai Comp Workmans',0),(279857,7774,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø´Ø±ÙƒØ§Øª ÙˆÙˆØ±ÙƒÙ…Ø§Ù†Ø³',0),(279858,7774,'fr','ImpÃ´t Comp accidentÃ©s',0),(279859,7774,'jp','æµå¤± Comp ç¨Ž',0),(279860,7774,'pt','Direitoa Comp imposto',0),(279861,7774,'ru','Workmans Comp Ð½Ð°Ð»Ð¾Ð³',0),(279862,7774,'es','Impuesto sobre CompensaciÃ³n al Trabajador ',0),(279863,7774,'de','Workmans Comp Steuer',0),(279864,7774,'en','Workmans Comp Tax',0),(279865,7775,'is','',0),(279866,7775,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø´Ø±ÙƒØª   Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(279867,7775,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø´Ø±ÙƒØª   Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(279868,7775,'tr','Bu ÅŸirketi silmek istediÄŸinizden emin misiniz',0),(279869,7775,'pl','Czy na pewno chcesz usunÄ…Ä‡ tÄ™ firmÄ™',0),(279870,7775,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ‚Ð°Ð·Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(279871,7775,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº',0),(279872,7775,'sr','ÐˆÐµÑÐ¸ Ð»Ð¸ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(279873,7775,'vi','XÃ³a CÃ´ng Ty nÃ y?',0),(279874,7775,'af','Is u seker u wil hierdie onderneming UITWIS?',0),(279875,7775,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ ÅŸtergeÅ£i aceastÄƒ companie',0),(279876,7775,'et','Oled kindel, et soovid seda ettevÃµtet kustutada?',0),(279877,7775,'si','Ali ste prepriÄani, da Å¾elite izbrisati to podjetje',0),(279878,7775,'ba','Apakah Anda yakin Anda ingin menghapus perusahaan ini',0),(279879,7775,'nl','Weet u zeker dat u wilt verwijderen van dit bedrijf',0),(279880,7775,'fi','Haluatko varmasti poistaa tÃ¤mÃ¤n yrityksen',0),(279881,7775,'no','Er du sikker pÃ¥ at du vil slette dette selskapet',0),(279882,7775,'da','Er du sikker pÃ¥ du vil slette dette selskab',0),(279883,7775,'ko','ë‹¹ì‹ ì€ì´ íšŒì‚¬ë¥¼ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ',0),(279884,7775,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ××ª ×”×—×‘×¨×” ×”×–×•',0),(279885,7775,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î”Î™Î‘Î“Î¡Î†Î¨Î•Î¤Î• Î±Ï…Ï„Î® Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(279886,7775,'zh','æ‚¨ç¡®å®šè¦åˆ é™¤è¿™å®¶å…¬å¸ï¼Ÿ\r\n',0),(279887,7775,'sv','Ã„r du sÃ¤ker du vill ta bort detta fÃ¶retag',0),(279888,7775,'it','Sei sicuro che vuoi cancellare questa azienda',0),(279889,7775,'tl','',0),(279890,7775,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3609;&#3637;&#3657;?',0),(279891,7775,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(279892,7775,'ms','Adakah anda pasti hendak menghapuskan Syarikat ini',0),(279893,7775,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¥Ù„ØºØ§Ø¡ Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ© ØŸ',0),(279894,7775,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer cette entreprise',0),(279895,7775,'jp','æœ¬å½“ã«ã“ã®ä¼šç¤¾ã‚’å‰Šé™¤ã—ãŸã„ã§ã™ã€‚',0),(279896,7775,'pt','Tem certeza que deseja excluir esta empresa',0),(279897,7775,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹ Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð£Ð”ÐÐ›Ð˜Ð¢Ð¬ ÑÑ‚Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ',0),(279898,7775,'es','Â¿Esta seguro que quiere ELIMINAR este empresa?',0),(279899,7775,'de','Sind Sie sicher, dass Sie diese Firma lÃ¶schen mÃ¶chten',0),(279900,7775,'en','Are you sure you wish to DELETE this company',0),(279901,7776,'is','',0),(279902,7776,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ØªØ±Ø§Ø² Ù†Ø´Ø¯Ù‡ ',0),(279903,7776,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ØªØ±Ø§Ø² Ù†Ø´Ø¯Ù‡ ',0),(279904,7776,'tr','Dengesiz gÃ¼nlÃ¼k giriÅŸleri',0),(279905,7776,'pl','Wpisy do dziennika niesymetryczne',0),(279906,7776,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ° Ð½Ð° Ð½ÐµÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð°Ð½Ð¸',0),(279907,7776,'ur','Unbalanced Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(279908,7776,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ Ð½ÐµÑÐ°Ð»Ð´Ð¸Ñ€Ð°Ð½Ðµ',0),(279909,7776,'vi','BÃºt toÃ¡n Ä‘á»‹nh ká»³ KhÃ´ng cÃ¢n Ä‘á»‘i',0),(279910,7776,'af','Ongebalanseerde Joernaalinskrywings',0),(279911,7776,'ro','Jurnal dezechilibrat',0),(279912,7776,'et','Tasakaalustamata pÃ¤evikukandeid',0),(279913,7776,'si','NeuravnoteÅ¾eno dnevnik',0),(279914,7776,'ba','Entri jurnal tidak seimbang',0),(279915,7776,'nl','Onevenwichtig logboekitems',0),(279916,7776,'fi','EpÃ¤tasapainoinen pÃ¤ivÃ¤kirjamerkinnÃ¤t',0),(279917,7776,'no','Ubalansert loggoppfÃ¸ringer',0),(279918,7776,'da','Ubalanceret journaloptegnelser',0),(279919,7776,'ko','ë¶ˆê· í˜•ëœ ì—…ë¬´ ì¼ì§€ í•­ëª©',0),(279920,7776,'he','×¢×¨×›×™ ×™×•×ž×Ÿ ×œ× ×ž××•×–× ×™×',0),(279921,7776,'el','ÎœÎ· Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î·Î¼Î­Î½Î· ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(279922,7776,'zh','æœªç»“ç®—çš„çš„æ—¥å¿—å¸åˆ†å½•\r\n',0),(279923,7776,'sv','Obalanserad journalposter',0),(279924,7776,'it','Voci del diario sbilanciato',0),(279925,7776,'tl','',0),(279926,7776,'th','&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3626;&#3617;&#3640;&#3604;&#3619;&#3634;&#3618;&#3623;&#3633;&#3609;&#3652;&#3617;&#3656;&#3621;&#3591;&#3605;&#3633;&#3623;',0),(279927,7776,'hi','à¤…à¤¸à¤‚à¤¤à¥à¤²à¤¿à¤¤ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(279928,7776,'ms','Catatan jurnal tidak',0),(279929,7776,'ar','Ù‚ÙŠÙˆØ¯ ÙŠÙˆÙ…ÙŠØ© ØºÙŠØ± Ù…ØªÙˆØ§Ø²Ù†Ø©',0),(279930,7776,'fr','EntrÃ©es de Journal dÃ©sÃ©quilibrÃ©',0),(279931,7776,'jp','ã‚¢ãƒ³ãƒãƒ©ãƒ³ã‚¹ ã‚¸ãƒ£ãƒ¼ãƒŠãƒ« ã‚¨ãƒ³ãƒˆãƒª',0),(279932,7776,'pt','Entradas de diÃ¡rio desequilibrado',0),(279933,7776,'ru','ÐÐµÑÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð¶ÑƒÑ€Ð½Ð°Ð» Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(279934,7776,'es','Entradas de Diario no Balanceadas',0),(279935,7776,'de','Unausgeglichene JournaleintrÃ¤ge',0),(279936,7776,'en','Unbalanced Journal Entries',0),(279937,7777,'is','',0),(279938,7777,'dr','_Ø­Ù…Ù„ Ø¨Ù‡ _ Ù†Ø§Ù… Ø§ÙˆÙ„',0),(279939,7777,'pr','_Ø­Ù…Ù„ Ø¨Ù‡ _ Ù†Ø§Ù… Ø§ÙˆÙ„',0),(279940,7777,'tr','GÃ¶nderilecek Attn ad',0),(279941,7777,'pl','Nazwa pierwszego Attn statku',0),(279942,7777,'bg','ÐÐ° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¿ÑŠÑ€Ð²Ð¾ Ð¸Ð¼Ðµ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(279943,7777,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Ùˆ Ø§Ù¹Ù¹Ù† Ù¾ÛÙ„Ø§ Ù†Ø§Ù…',0),(279944,7777,'sr','ÐÑ‚Ñ‚Ð½ Ð¿Ñ€Ð²Ð¾ Ð¸Ð¼Ðµ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(279945,7777,'vi','Gá»­i Ä‘áº¿n: tÃªn ',0),(279946,7777,'af','Versend-Na Aandag Voornaam',0),(279947,7777,'ro','Livrare-la nume Attn',0),(279948,7777,'et','Saaja teadmiseks eesnimi',0),(279949,7777,'si','Za dobavo v vednost ime',0),(279950,7777,'ba','Kapal ke nama pertama Attn',0),(279951,7777,'nl','Verzendcode T.a.v. voornaam',0),(279952,7777,'fi','Toimitusasiakkaan Huom etunimi',0),(279953,7777,'no','Lever til-Attn fornavn',0),(279954,7777,'da','Skib-til ATT fornavn',0),(279955,7777,'ko','ë°°ì†¡ ë‹´ë‹¹ìž ì´ë¦„',0),(279956,7777,'he','×œ×ž×©×œ×•×— ×©× ×¤×¨×˜×™ ×”×•×‘×œ×”',0),(279957,7777,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ Attn ÏŒÎ½Î¿Î¼Î±',0),(279958,7777,'zh','æ”¶è´§è”ç³»äººåå­—\r\n',0),(279959,7777,'sv','Attn fÃ¶rsta Leveransnamn',0),(279960,7777,'it','Spedire a nome Attn',0),(279961,7777,'tl','',0),(279962,7777,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3612;&#3641;&#3657;&#3619;&#3633;&#3610;&#3594;&#3639;&#3656;&#3629;',0),(279963,7777,'hi','Attn à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(279964,7777,'ms','Kapal untuk nama pertama U.p.',0),(279965,7777,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø¹Ù†Ø§ÙŠØ© Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„',0),(279966,7777,'fr','Nom du premier navire d\'Attn',0),(279967,7777,'jp','å‡ºè·å…ˆæ‹…å½“å',0),(279968,7777,'pt','Envio-Ã  atenÃ§Ã£o primeiro nome',0),(279969,7777,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ðº ÐºÐ¾Ð¼Ñƒ Ð¸Ð¼Ñ',0),(279970,7777,'es','Enviar A Atn. Primer Nombre',0),(279971,7777,'de','Lieferadresse Name Vorname',0),(279972,7777,'en','Ship-To Attn First Name',0),(279973,7778,'is','',0),(279974,7778,'dr','_Ø­Ù…Ù„ Ø¨Ù‡  _ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ',0),(279975,7778,'pr','_Ø­Ù…Ù„ Ø¨Ù‡  _ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ',0),(279976,7778,'tr','GÃ¶nderilecek Attn SoyadÄ±nÄ±z',0),(279977,7778,'pl','Attn nazwisko na statku',0),(279978,7778,'bg','ÐÐ° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(279979,7778,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Ùˆ Ø§Ù¹Ù¹Ù† Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù…',0),(279980,7778,'sr','ÐÑ‚Ñ‚Ð½ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(279981,7778,'vi','Gá»­i Ä‘áº¿n: há»',0),(279982,7778,'af','Versend-Na Aandag Van',0),(279983,7778,'ro','Livrare-la nume Attn ultimul',0),(279984,7778,'et','Saaja teadmiseks viimase nime',0),(279985,7778,'si','Dobave v vednost priimek',0),(279986,7778,'ba','Kapal ke Attn terakhir nama',0),(279987,7778,'nl','Verzendcode T.a.v. achternaam',0),(279988,7778,'fi','Toimitusasiakkaan Huom sukunimi',0),(279989,7778,'no','Lever til-Attn etternavn',0),(279990,7778,'da','Skib-til att sidste navn',0),(279991,7778,'ko','ë°°ì†¡ ë‹´ë‹¹ìž ë§ˆì§€ë§‰ ì´ë¦„',0),(279992,7778,'he','×©× ×ž×—×œ×§×ª ×”××—×¨×•×Ÿ ×œ×ž×©×œ×•×—',0),(279993,7778,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ Î¿Î½Î¿Î¼Î±ÏƒÎ¯Î± Attn Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î±',0),(279994,7778,'zh','æ”¶è´§è”ç³»äººå§“\r\n',0),(279995,7778,'sv','Attn sista leveransnamnet',0),(279996,7778,'it','Spedire a Attn cognome',0),(279997,7778,'tl','',0),(279998,7778,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3612;&#3641;&#3657;&#3619;&#3633;&#3610;&#3609;&#3634;&#3617;&#3626;&#3585;&#3640;&#3621;',0),(279999,7778,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‹ Attn à¤†à¤–à¤¿à¤°à¥€ à¤¨à¤¾à¤®',0),(280000,7778,'ms','Kapal untuk nama akhir U.p.',0),(280001,7778,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ø³Ù… Ø¢Ø®Ø± Ø¹Ù†Ø§ÙŠØ©',0),(280002,7778,'fr','Destinataire Attn Last Name',0),(280003,7778,'jp','èˆ¹ã«åå­—ã®æ‹…å½“',0),(280004,7778,'pt','Envio-Ã  atenÃ§Ã£o Ãºltimo nome',0),(280005,7778,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ðº ÐºÐ¾Ð¼Ñƒ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ',0),(280006,7778,'es','Enviar A Atn. Apellido',0),(280007,7778,'de','Lieferadresse Attn Nachname',0),(280008,7778,'en','Ship-To Attn Last Name',0),(280009,7779,'is','',0),(280010,7779,'dr','-Ù‡Ø± Ø¯Ùˆ Ù‡ÙØªÙ‡',0),(280011,7779,'pr',' Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´ØºÙ„ÙŠ -Ù‡Ø± Ø¯Ùˆ Ù‡ÙØªÙ‡',0),(280012,7779,'tr','Ä°ki haftalÄ±k',0),(280013,7779,'pl','Dwa razy w tygodniu',0),(280014,7779,'bg','Ð”Ð²Ð° Ð¿ÑŠÑ‚Ð¸ ÑÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð¾',0),(280015,7779,'ur','Ø¯ÙˆÛÙØªÙˆÚº',0),(280016,7779,'sr','Ð”Ð²Ð¾Ð½ÐµÐ´ÐµÑ™Ð½Ð¸',0),(280017,7779,'vi','Hai láº§n 1 tuáº§n',0),(280018,7779,'af','Tweeweekliks',0),(280019,7779,'ro','Bi-sÄƒptÄƒmÃ¢nal',0),(280020,7779,'et','KahenÃ¤dalane',0),(280021,7779,'si','Dvakrat tedensko',0),(280022,7779,'ba','Dwi-mingguan',0),(280023,7779,'nl','Bi-wekelijkse',0),(280024,7779,'fi','Toinen viikko',0),(280025,7779,'no','Bi-ukentlig',0),(280026,7779,'da','Bi-ugentlige',0),(280027,7779,'ko','ìŒë°©í–¥-ì£¼ê°„',0),(280028,7779,'he','×“×•-×©×‘×•×¢×™',0),(280029,7779,'el','Bi-ÎµÎ²Î´Î¿Î¼Î±Î´Î¹Î±Î¯Î¿',0),(280030,7779,'zh','åŒå‘¨åˆŠ\r\n',0),(280031,7779,'sv','Varannan vecka',0),(280032,7779,'it','Bi-settimanale',0),(280033,7779,'tl','',0),(280034,7779,'th','&#3619;&#3634;&#3618;&#3611;&#3633;&#3585;&#3625;&#3660;',0),(280035,7779,'hi','à¤¦à¥à¤µà¤¿-à¤¸à¤¾à¤ªà¥à¤¤à¤¾à¤¹à¤¿à¤•',0),(280036,7779,'ms','Bi-Mingguan',0),(280037,7779,'ar','ÙƒÙ„ Ø£Ø³Ø¨ÙˆØ¹ÙŠÙ†',0),(280038,7779,'fr','Toutes les deux semaines',0),(280039,7779,'jp','éš”é€±',0),(280040,7779,'pt','Bi-semanal',0),(280041,7779,'ru','Ð”Ð²Ð° Ñ€Ð°Ð·Ð° Ð² Ð½ÐµÐ´ÐµÐ»ÑŽ',0),(280042,7779,'es','Bisemanal',0),(280043,7779,'de','Alle zwei Wochen',0),(280044,7779,'en','Bi-Weekly',0),(280045,7780,'is','',0),(280046,7780,'dr','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø±ÙŠÙ† ØªØºÙŠÙŠØ± Ø­Ù‚ÙˆÙ‚',0),(280047,7780,'pr','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø±ÙŠÙ† ØªØºÙŠÙŠØ± Ø­Ù‚ÙˆÙ‚',0),(280048,7780,'tr','Son Ã¶deme deÄŸiÅŸiklik tarihi',0),(280049,7780,'pl','Data ostatniej zmiany wynagrodzenia',0),(280050,7780,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(280051,7780,'ur','Ø¢Ø®Ø±ÛŒ ØªÙ†Ø®ÙˆØ§Û ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(280052,7780,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð¸Ð·Ð¼ÐµÐ½Ðµ Ð¿Ð»Ð°Ñ‚Ðµ',0),(280053,7780,'vi','Thay Ä‘á»•i ngÃ y thanh toÃ¡n cuá»‘i',0),(280054,7780,'af','Datum van Laasste Loon Verandering',0),(280055,7780,'ro','Data trecutÄƒ Pay schimbare',0),(280056,7780,'et','Viimase makse muutmiskuupÃ¤ev',0),(280057,7780,'si','Datum zadnje spremembe plaÄati',0),(280058,7780,'ba','Tanggal perubahan gaji terakhir',0),(280059,7780,'nl','Datum van laatste wijziging van de beloning',0),(280060,7780,'fi','Viimeinen maksu muutoksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(280061,7780,'no','Datoen for siste betaling endringen',0),(280062,7780,'da','Datoen for sidste Ã¦ndring af lÃ¸n',0),(280063,7780,'ko','ë§ˆì§€ë§‰ ì§€ë¶ˆ ë³€ê²½ ë‚ ì§œ',0),(280064,7780,'he','×ª××¨×™×š ×©×™× ×•×™ ×”×©×›×¨ ×”××—×¨×•×Ÿ',0),(280065,7780,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î·Ï‚ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î±Ï‚ Î±Î»Î»Î±Î³Î®Ï‚ Î±Î¼Î¿Î¹Î²ÏŽÎ½',0),(280066,7780,'zh','æœ€åŽæ”¯è–ªæ—¥æœŸå˜æ›´\r\n',0),(280067,7780,'sv','Datum fÃ¶r senaste lÃ¶n fÃ¶rÃ¤ndring',0),(280068,7780,'it','Data dell\'ultimo cambiamento di retribuzione',0),(280069,7780,'tl','',0),(280070,7780,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;&#3621;&#3656;&#3634;&#3',0),(280071,7780,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤µà¥‡à¤¤à¤¨ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(280072,7780,'ms','Tarikh akhir perubahan gaji',0),(280073,7780,'ar','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø± ØªØºÙŠÙŠØ± ÙÙŠ Ø§Ù„Ø£Ø¬ÙˆØ±',0),(280074,7780,'fr','Date de derniÃ¨re modification du salaire',0),(280075,7780,'jp','æœ€å¾Œã®æ”¯æ‰•ã„å¤‰æ›´æ—¥',0),(280076,7780,'pt','Data da Ãºltima alteraÃ§Ã£o de salÃ¡rio',0),(280077,7780,'ru','Ð”Ð°Ñ‚Ð° ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(280078,7780,'es','Fecha de Ultimo Cambio de Pagos',0),(280079,7780,'de','Datum der letzten Ã„nderung in Zahlen',0),(280080,7780,'en','Date of Last Pay Change',0),(280081,7781,'is','',0),(280082,7781,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù†Ø¯ ',0),(280083,7781,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù†Ø¯ ',0),(280084,7781,'tr','Ã‡alÄ±ÅŸanlarÄ± aldÄ±ÄŸÄ±nÄ±z',0),(280085,7781,'pl','Pracownicy importowane',0),(280086,7781,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð²Ð½ÐµÑÐµÐ½Ð¸',0),(280087,7781,'ur','Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©ÛŒ Ø¯Ø±Ø¢Ù…Ø¯',0),(280088,7781,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÑƒÐ²ÐµÐ·ÐµÐ½',0),(280089,7781,'vi','ÄÃ£ nháº­p nhÃ¢n viÃªn',0),(280090,7781,'af','Werknemers Ingevoer',0),(280091,7781,'ro','AngajaÅ£ii importate',0),(280092,7781,'et','TÃ¶Ã¶tajad imporditud',0),(280093,7781,'si','Zaposlenih, uvoÅ¾enih',0),(280094,7781,'ba','Karyawan yang diimpor',0),(280095,7781,'nl','Werknemers geÃ¯mporteerd',0),(280096,7781,'fi','TyÃ¶ntekijÃ¶iden tuotu',0),(280097,7781,'no','Ansatte importert',0),(280098,7781,'da','Medarbejdere importeret',0),(280099,7781,'ko','ê°€ì ¸ì˜¨ ì§ì›',0),(280100,7781,'he','×¢×•×‘×“×™× ×ž×™×•×‘××™×',0),(280101,7781,'el','Î•ÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(280102,7781,'zh','é›‡å‘˜è¿›å£\r\n',0),(280103,7781,'sv','AnstÃ¤llda som importeras',0),(280104,7781,'it','Collaboratori importati',0),(280105,7781,'tl','',0),(280106,7781,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(280107,7781,'hi','à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚',0),(280108,7781,'ms','Pekerja-pekerja yang diimport',0),(280109,7781,'ar','Ù…ÙˆØ¸Ù Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(280110,7781,'fr','EmployÃ©s importÃ©s',0),(280111,7781,'jp','å¾“æ¥­å“¡ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(280112,7781,'pt','FuncionÃ¡rios importados',0),(280113,7781,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¸ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹',0),(280114,7781,'es','Empleados Importados',0),(280115,7781,'de','Mitarbeiter importiert',0),(280116,7781,'en','Employees Imported',0),(280117,7782,'is','',0),(280118,7782,'dr','ÙƒØ¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(280119,7782,'pr','ÙƒØ¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(280120,7782,'tr','Ã‡alÄ±ÅŸan kodu',0),(280121,7782,'pl','Kod pracownika',0),(280122,7782,'bg','ÐšÐ¾Ð´ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(280123,7782,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÙˆÚˆ',0),(280124,7782,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÐºÐ¾Ð´',0),(280125,7782,'vi','MÃ£ nhÃ¢n viÃªn',0),(280126,7782,'af','Werknemer Kode',0),(280127,7782,'ro','Cod angajat',0),(280128,7782,'et','TÃ¶Ã¶taja kood',0),(280129,7782,'si','Å ifra zaposlenega',0),(280130,7782,'ba','Karyawan kode',0),(280131,7782,'nl','Werknemer Code',0),(280132,7782,'fi','TyÃ¶ntekijÃ¤n',0),(280133,7782,'no','Ansattkoden',0),(280134,7782,'da','Medarbejder kode',0),(280135,7782,'ko','ì§ì› ì½”ë“œ',0),(280136,7782,'he','×§×•×“ ×¢×•×‘×“',0),(280137,7782,'el','Î¥Ï€Î±Î»Î»Î·Î»Î¹ÎºÏŒ ÎºÏŽÎ´Î¹ÎºÎ±',0),(280138,7782,'zh','å‘˜å·¥ä»£ç ',0),(280139,7782,'sv','AnstÃ¤lld kod',0),(280140,7782,'it','Codice dipendente',0),(280141,7782,'tl','',0),(280142,7782,'th','&#3619;&#3627;&#3633;&#3626;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(280143,7782,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥‹à¤¡',0),(280144,7782,'ms','Kod pekerja',0),(280145,7782,'ar','Ø±Ù…Ø² Ø§Ù„Ù…ÙˆØ¸Ù',0),(280146,7782,'fr','Code employÃ©',0),(280147,7782,'jp','å¾“æ¥­å“¡ã‚³ãƒ¼ãƒ‰',0),(280148,7782,'pt','CÃ³digo de funcionÃ¡rio',0),(280149,7782,'ru','ÐšÐ¾Ð´ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(280150,7782,'es','Empleado CÃ³digo',0),(280151,7782,'de','Mitarbeiter-Code',0),(280152,7782,'en','Employee Code',0),(280153,7783,'is','',0),(280154,7783,'dr','Ù‚Ø§Ù„Ø¨  Ø³ØªÙˆÙ†  ÙØ§ÙŠÙ„  ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(280155,7783,'pr','Ù‚Ø§Ù„Ø¨  Ø³ØªÙˆÙ†  ÙØ§ÙŠÙ„  ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(280156,7783,'tr','Ã‡alÄ±ÅŸan dosya sÃ¼tun biÃ§imi',0),(280157,7783,'pl','Pracownik kolumna Format pliku',0),(280158,7783,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(280159,7783,'ur','Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„ Ù…Ù„Ø§Ø²Ù…',0),(280160,7783,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(280161,7783,'vi','Há»“ sÆ¡ nhÃ¢n viÃªn dáº¡ng cá»™t',0),(280162,7783,'af','Werknemer LÃªer Kolomformaat',0),(280163,7783,'ro','Angajat dosar Format coloane',0),(280164,7783,'et','TÃ¶Ã¶taja faili veeru formaat',0),(280165,7783,'si','Zapisa stolpec zaposlenega',0),(280166,7783,'ba','Karyawan Format File kolom',0),(280167,7783,'nl','Werknemer kolom bestandsindeling',0),(280168,7783,'fi','TyÃ¶ntekijÃ¤n sarakkeen tiedostomuoto',0),(280169,7783,'no','Ansatte-kolonnen filformat',0),(280170,7783,'da','Medarbejder-kolonne filformat',0),(280171,7783,'ko','ì§ì› íŒŒì¼ ì—´ í˜•ì‹',0),(280172,7783,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×”×§×•×‘×¥ ×”×¢×•×‘×“',0),(280173,7783,'el','ÎœÎ¿ÏÏ†Î® ÏƒÏ„Î®Î»Î·Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿Ï… ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(280174,7783,'zh','å‘˜å·¥æ–‡ä»¶åˆ—æ ¼å¼\r\n',0),(280175,7783,'sv','Medarbetare-kolumn filformatet',0),(280176,7783,'it','Dipendente formato colonna',0),(280177,7783,'tl','',0),(280178,7783,'th','&#3592;&#3633;&#3604;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3605;&#3634;&#3617;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;',0),(280179,7783,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(280180,7783,'ms','Format kolum fail pekerja',0),(280181,7783,'ar','Ø¨Ù†ÙŠØ© Ø£Ø¹Ù…Ø¯Ø© Ù…Ù„Ù Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(280182,7783,'fr','Format de colonne pour le fichier employÃ©',0),(280183,7783,'jp','å¾“æ¥­å“¡ã®ãƒ•ã‚¡ã‚¤ãƒ«ã®åˆ—ã®å½¢å¼',0),(280184,7783,'pt','Formato de coluna do arquivo de empregado',0),(280185,7783,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÐšÐ¾Ð»Ð¾Ð½ÐºÐ¸ Ð¤Ð°Ð¹Ð»Ð° Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(280186,7783,'es','Empleado Formato Fila Columna',0),(280187,7783,'de','Mitarbeiter-Spalte Dateiformat',0),(280188,7783,'en','Employee File Column Format',0),(280189,7784,'is','',0),(280190,7784,'dr','Ù†Ø§Ù… Ùˆ Ù†Ø®Ø³ØªÙŠÙ† Ø­Ø±Ù Ù†Ø§Ù… Ù…ÙŠØ§Ù†ÙŠ ',0),(280191,7784,'pr','Ù†Ø§Ù… Ùˆ Ù†Ø®Ø³ØªÙŠÙ† Ø­Ø±Ù Ù†Ø§Ù… Ù…ÙŠØ§Ù†ÙŠ ',0),(280192,7784,'tr','Ä°lk ad ve ikinci adÄ±n baÅŸ harfi',0),(280193,7784,'pl','Nazwisko i inicjaÅ‚ drugiego imienia',0),(280194,7784,'bg','ÐŸÑŠÑ€Ð²Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ Ð¸ Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ð» Ð½Ð° Ð¿Ñ€ÐµÐ·Ð¸Ð¼ÐµÑ‚Ð¾',0),(280195,7784,'ur','Ù¾ÛÙ„Ø§ Ù†Ø§Ù… Ø§ÙˆØ± Ø¯Ø±Ù…ÛŒØ§Ù†ÛŒ Ø¯Ø³ØªØ®Ø·',0),(280196,7784,'sr','Ð˜Ð¼Ðµ Ð¸ Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð» ÑÑ€ÐµÐ´ÑšÐµÐ³ Ð¸Ð¼ÐµÐ½Ð°',0),(280197,7784,'vi','TÃªn riÃªng & tÃªn Ä‘á»‡m',0),(280198,7784,'af','Voornaam en Tweede Naam Voorletter',0),(280199,7784,'ro','Primul nume ÅŸi iniÅ£iale mijloc',0),(280200,7784,'et','Eesnimi ja teise nime esitÃ¤ht',0),(280201,7784,'si','Ime in srednje zaÄetne',0),(280202,7784,'ba','Nama depan dan inisial tengah',0),(280203,7784,'nl','Voornaam en middelste initiaal',0),(280204,7784,'fi','EnsimmÃ¤inen nimi ja nimen alkukirjain',0),(280205,7784,'no','Fornavn og Initial for mellomnavn',0),(280206,7784,'da','Fornavn og mellemnavn',0),(280207,7784,'ko','ì²« ë²ˆì§¸ ì´ë¦„ê³¼ ì¤‘ê°„ ì´ë‹ˆì…œ',0),(280208,7784,'he','×©× ×¤×¨×˜×™, ××•×ª ××ž×¦×¢×™×ª',0),(280209,7784,'el','ÎŒÎ½Î¿Î¼Î± ÎºÎ±Î¹ Î±ÏÏ‡Î¹ÎºÏŒ Ï€Î±Ï„ÏÏŽÎ½Ï…Î¼Î¿Ï…',0),(280210,7784,'zh','åå­—å’Œä¸­é—´çš„å­—æ¯\r\n',0),(280211,7784,'sv','FÃ¶rnamn och Initial fÃ¶r mellannamn',0),(280212,7784,'it','Nome e iniziale',0),(280213,7784,'tl','',0),(280214,7784,'th','&#3594;&#3639;&#3656;&#3629;&#3649;&#3619;&#3585;&#3649;&#3621;&#3632;&#3594;&#3639;&#3656;&#3629;&#3618;&#3656;&#3629;&#3585;&#3621;&#3634;&#3591;',0),(280215,7784,'hi','à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤® à¤”à¤° à¤®à¤§à¥à¤¯ à¤†à¤¦à¥à¤¯à¤¾à¤•à¥à¤·à¤°',0),(280216,7784,'ms','Nama pertama dan permulaan tengah',0),(280217,7784,'ar','Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„ ÙˆØ§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆØ³Ø·',0),(280218,7784,'fr','PrÃ©nom et initiale',0),(280219,7784,'jp','æœ€åˆã®åå‰ã¨ãƒŸãƒ‰ãƒ« ãƒãƒ¼ãƒ ã®ã‚¤ãƒ‹ã‚·ãƒ£ãƒ«',0),(280220,7784,'pt','Primeiro nome e inicial do meio',0),(280221,7784,'ru','Ð˜Ð¼Ñ Ð¸ Ð¾Ñ‚Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(280222,7784,'es','Primer Nombre y Inicial de Segundo',0),(280223,7784,'de','Vorname und Initiale des zweiten Vornamens',0),(280224,7784,'en','First Name and Middle Initial',0),(280225,7785,'is','',0),(280226,7785,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø¯Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ',0),(280227,7785,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø¯Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ',0),(280228,7785,'tr','Alma Ã§alÄ±ÅŸanlar',0),(280229,7785,'pl','PrzywÃ³z pracownikÃ³w',0),(280230,7785,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(280231,7785,'ur','Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(280232,7785,'sr','Ð£Ð²Ð¾Ð· Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(280233,7785,'vi','Nháº­p nhÃ¢n viÃªn',0),(280234,7785,'af','Invoer van Werknemers',0),(280235,7785,'ro','AngajaÅ£ii de import',0),(280236,7785,'et','Impordi tÃ¶Ã¶tajad',0),(280237,7785,'si','Uvoz zaposlenih',0),(280238,7785,'ba','Impor karyawan',0),(280239,7785,'nl','Werknemers importeert',0),(280240,7785,'fi','Tuo tyÃ¶ntekijÃ¶ille',0),(280241,7785,'no','Importere ansatte',0),(280242,7785,'da','Importere medarbejdere',0),(280243,7785,'ko','ê°€ì ¸ì˜¤ê¸° ì§ì›',0),(280244,7785,'he','×™×‘× ×¢×•×‘×“×™×',0),(280245,7785,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(280246,7785,'zh','å¯¼å…¥é›‡å‘˜\r\n',0),(280247,7785,'sv','Importera anstÃ¤llda',0),(280248,7785,'it','Collaboratori di importazione',0),(280249,7785,'tl','',0),(280250,7785,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(280251,7785,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤†à¤¯à¤¾à¤¤',0),(280252,7785,'ms','Mengimport pekerja',0),(280253,7785,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(280254,7785,'fr','Importer des employÃ©s',0),(280255,7785,'jp','å¾“æ¥­å“¡ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(280256,7785,'pt','ImportaÃ§Ã£o de empregados',0),(280257,7785,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(280258,7785,'es','Importar Empleados',0),(280259,7785,'de','Import-Mitarbeiter',0),(280260,7785,'en','Import Employees',0),(280261,7786,'is','',0),(280262,7786,'dr','ÙŠØ§ Ø¯Ø± Ù‡Ø± Ø¯ÙˆØ±Ù‡ â€“ Ø§Ú¯Ø±  Ú©Ø§Ø±Ù…Ù†Ø¯ Ø­Ù‚ÙˆÙ‚ Ø¨Ú¯ÙŠØ±',0),(280263,7786,'pr','ÙŠØ§ Ø¯Ø± Ù‡Ø± Ø¯ÙˆØ±Ù‡ â€“ Ø§Ú¯Ø±  Ú©Ø§Ø±Ù…Ù†Ø¯ Ø­Ù‚ÙˆÙ‚ Ø¨Ú¯ÙŠØ±',0),(280264,7786,'tr','Veya her dÃ¶nem, eÄŸer maaÅŸlÄ± Ã§alÄ±ÅŸan',0),(280265,7786,'pl','Lub na okres, jeÅ¼eli wynagrodzenie pracownika',0),(280266,7786,'bg','Ð˜Ð»Ð¸ Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´, Ð°ÐºÐ¾ Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(280267,7786,'ur','ÛŒØ§ Ø¯ÙˆØ±ØŒ Ø§Ú¯Ø± ØªÙ†Ø®ÙˆØ§Û ÙÛŒ Ù…Ù„Ø§Ø²Ù…',0),(280268,7786,'sr','Ð˜Ð»Ð¸ Ð¿Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñƒ, Ð°ÐºÐ¾ Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(280269,7786,'vi','hay theo thá»i ká»³ náº¿u nhÃ¢n viÃªn hÆ°á»Ÿng lÆ°Æ¡ng',0),(280270,7786,'af','Of Per Periode, Indien Werknemer is wat \'n Salaris verdien',0),(280271,7786,'ro','Sau pe o perioadÄƒ, dacÄƒ salariat angajat',0),(280272,7786,'et','VÃµi perioodi, kui palgaline tÃ¶Ã¶taja',0),(280273,7786,'si','Ali na obdobje, Äe je redna plaÄa zaposlenega',0),(280274,7786,'ba','Atau Per periode, jika gaji karyawan',0),(280275,7786,'nl','Of Per periode, als bezoldigde werknemers',0),(280276,7786,'fi','Tai kausittain, jos palkatun tyÃ¶ntekijÃ¤n',0),(280277,7786,'no','Eller Per periode, hvis lÃ¸nnede ansatte',0),(280278,7786,'da','Eller pr. periode, hvis lÃ¸nnet medarbejder',0),(280279,7786,'ko','ë˜ëŠ” ê²½ìš° ê¸‰ì—¬ ê¸°ê°„ ë‹¹ ì§ì›',0),(280280,7786,'he','××• ×œ×¤×™ ×ª×§×•×¤×”, ×× ×©×›×™×¨×™× ×”×¢×•×‘×“',0),(280281,7786,'el','Î‰ Î±Î½Î¬ Ï€ÎµÏÎ¯Î¿Î´Î¿, ÎµÎ¬Î½ ÎµÎ¯Î½Î±Î¹ Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŒÏ‚ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚',0),(280282,7786,'zh','æˆ–æ¯æœŸé—´ï¼Œå¦‚æžœå—è–ªé›‡å‘˜\r\n',0),(280283,7786,'sv','Eller Per Period, om avlÃ¶nad anstÃ¤lld',0),(280284,7786,'it','O per ogni periodo, se retribuito dipendente',0),(280285,7786,'tl','',0),(280286,7786,'th','&#3627;&#3619;&#3639;&#3629;&#3605;&#3656;&#3629;&#3591;&#3623;&#3604; &#3606;&#3657;&#3634;&#3648;&#3611;&#3655;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(280287,7786,'hi','à¤¯à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤…à¤µà¤§à¤¿, à¤¯à¤¦à¤¿ à¤µà¥‡à¤¤à¤¨à¤­à¥‹à¤—à¥€ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(280288,7786,'ms','Atau satu tempoh, jika gaji pekerja',0),(280289,7786,'ar','Ø£Ùˆ ÙƒÙ„ ÙØªØ±Ø©ØŒ Ø¥Ø°Ø§ ÙƒØ§Ù† Ù…Ø±ØªØ¨ Ø§Ù„Ù…ÙˆØ¸Ù',0),(280290,7786,'fr','Ou par pÃ©riode, si le salariÃ© employÃ©',0),(280291,7786,'jp','ã‚µãƒ©ãƒªãƒ¼ãƒžãƒ³ã®å ´åˆæœŸé–“ã”ã¨ã¾ãŸã¯å¾“æ¥­å“¡',0),(280292,7786,'pt','Ou por perÃ­odo, se assalariado empregado',0),(280293,7786,'ru','Ð˜Ð»Ð¸ Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´, ÐµÑÐ»Ð¸ Ð½Ð°ÐµÐ¼Ð½Ñ‹Ñ… Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð²',0),(280294,7786,'es','O Por PerÃ­odo, Si es Empleado Salariado',0),(280295,7786,'de','Oder pro Periode, wenn Angestellte Mitarbeiter',0),(280296,7786,'en','Or Per Period, If Salaried Employee',0),(280297,7787,'is','',0),(280298,7787,'dr','Ø­Ù‚ÙˆÙ‚ Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(280299,7787,'pr','Ø­Ù‚ÙˆÙ‚ Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª ',0),(280300,7787,'tr','Saat iÃ§in Ã¶deme',0),(280301,7787,'pl','PÅ‚acÄ… za godzinÄ™',0),(280302,7787,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ð½Ð° Ñ‡Ð°Ñ',0),(280303,7787,'ur','ÙÛŒ Ú¯Ú¾Ù†Ù¹Û Ø§Ø¯Ø§',0),(280304,7787,'sr','ÐŸÐ»Ð°Ñ‚Ð¸Ð¼ Ð¿Ð¾ ÑÐ°Ñ‚Ñƒ',0),(280305,7787,'vi','Tráº£ má»—i giá»',0),(280306,7787,'af','Besoldiging Per Uur',0),(280307,7787,'ro','Plata pe orÄƒ',0),(280308,7787,'et','Pay Per tund',0),(280309,7787,'si','PlaÄilo na uro',0),(280310,7787,'ba','Membayar Per jam',0),(280311,7787,'nl','Betalen Per uur',0),(280312,7787,'fi','Maksu / tunti',0),(280313,7787,'no','Betale Per time',0),(280314,7787,'da','Pay Per time',0),(280315,7787,'ko','ì‹œê°„ ë‹¹ ì§€ë¶ˆ',0),(280316,7787,'he','×©×œ× ×œ×¤×™ ×©×¢×”',0),(280317,7787,'el','Î Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Î±Î½Î¬ ÏŽÏÎ±',0),(280318,7787,'zh','æ¯å°æ—¶è–ªé…¬\r\n',0),(280319,7787,'sv','Betala Per timme',0),(280320,7787,'it','Paga oraria',0),(280321,7787,'tl','',0),(280322,7787,'th','&#3592;&#3656;&#3634;&#3618;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(280323,7787,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾ à¤µà¥‡à¤¤à¤¨',0),(280324,7787,'ms','Membayar setiap jam',0),(280325,7787,'ar','ØªØ¯ÙØ¹ Ø¹Ù† ÙƒÙ„ Ø³Ø§Ø¹Ø©',0),(280326,7787,'fr','Payer / heure',0),(280327,7787,'jp','1 æ™‚é–“ã‚ãŸã‚Šã®æ”¯æ‰•ã„',0),(280328,7787,'pt','Pagar por hora',0),(280329,7787,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð·Ð° Ñ‡Ð°Ñ',0),(280330,7787,'es','Pago por Hora',0),(280331,7787,'de','Zahlen pro Stunde',0),(280332,7787,'en','Pay Per Hour',0),(280333,7788,'is','',0),(280334,7788,'dr','ØªØ§Ø±ÙŠØ® ØªØ±Ø®ÙŠØµ',0),(280335,7788,'pr','ØªØ§Ø±ÙŠØ® ØªØ±Ø®ÙŠØµ',0),(280336,7788,'tr','YayÄ±n tarihi',0),(280337,7788,'pl','Data premiery',0),(280338,7788,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ð´Ð°Ð²Ð°Ð½Ðµ',0),(280339,7788,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø±ÛØ§Ø¦ÛŒ',0),(280340,7788,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸Ð·Ð´Ð°Ð²Ð°ÑšÐ°',0),(280341,7788,'vi','NgÃ y phÃ¡t hÃ nh',0),(280342,7788,'af','Vrystellingsdatum',0),(280343,7788,'ro','Data de lansare',0),(280344,7788,'et','VÃ¤ljalaske kuupÃ¤ev',0),(280345,7788,'si','Datum izdaje',0),(280346,7788,'ba','Tanggal rilis',0),(280347,7788,'nl','Releasedatum',0),(280348,7788,'fi','JulkaisupÃ¤ivÃ¤',0),(280349,7788,'no','Utgivelsesdato',0),(280350,7788,'da','Udgivelsesdato',0),(280351,7788,'ko','ë¦´ë¦¬ìŠ¤ ë‚ ì§œ',0),(280352,7788,'he','×ª××¨×™×š ×©×—×¨×•×¨',0),(280353,7788,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÏ…ÎºÎ»Î¿Ï†Î¿ÏÎ¯Î±Ï‚',0),(280354,7788,'zh','å‘å¸ƒæ—¥æœŸ\r\n',0),(280355,7788,'sv','Releasedatum',0),(280356,7788,'it','Data di rilascio',0),(280357,7788,'tl','',0),(280358,7788,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591;&#3585;&#3633;&#3609;',0),(280359,7788,'hi','à¤°à¤¿à¤²à¥€à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(280360,7788,'ms','Tarikh keluaran',0),(280361,7788,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥ØµØ¯Ø§Ø±',0),(280362,7788,'fr','Date de sortie',0),(280363,7788,'jp','ç™ºå£²æ—¥',0),(280364,7788,'pt','Data de lanÃ§amento',0),(280365,7788,'ru','Ð”Ð°Ñ‚Ð° Ð²Ñ‹Ð¿ÑƒÑÐºÐ°',0),(280366,7788,'es','Fecha de PublicaciÃ³n',0),(280367,7788,'de','Release-Datum',0),(280368,7788,'en','Release Date',0),(280369,7789,'is','',0),(280370,7789,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(280371,7789,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ ÙƒØ§Ø±Ù…Ù†Ø¯',0),(280372,7789,'tr','Personel dosyasÄ±nÄ± seÃ§in',0),(280373,7789,'pl','Wybierz plik pracownika',0),(280374,7789,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ñ„Ð°Ð¹Ð»',0),(280375,7789,'ur','Ù…Ù„Ø§Ø²Ù… Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(280376,7789,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(280377,7789,'vi','Chá»n há»“ sÆ¡ nhÃ¢n viÃªn',0),(280378,7789,'af','Selekteer Werknemer LÃªer',0),(280379,7789,'ro','SelectaÅ£i fiÅŸierul angajat',0),(280380,7789,'et','Vali tÃ¶Ã¶taja fail',0),(280381,7789,'si','Izberite datoteko zaposlenega',0),(280382,7789,'ba','Pilih File karyawan',0),(280383,7789,'nl','Selecteer werknemer bestand',0),(280384,7789,'fi','Valitse tyÃ¶ntekijÃ¤n tiedoston',0),(280385,7789,'no','Velg ansatt-fil',0),(280386,7789,'da','VÃ¦lg medarbejder fil',0),(280387,7789,'ko','ì§ì› íŒŒì¼ ì„ íƒ',0),(280388,7789,'he','×‘×—×¨ ×§×•×‘×¥ ×¢×•×‘×“',0),(280389,7789,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î‘ÏÏ‡ÎµÎ¯Î¿ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(280390,7789,'zh','é€‰æ‹©å‘˜å·¥æ–‡ä»¶\r\n',0),(280391,7789,'sv','VÃ¤lj medarbetaren fil',0),(280392,7789,'it','Selezionare File dipendente',0),(280393,7789,'tl','',0),(280394,7789,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3649;&#3615;&#3657;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(280395,7789,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(280396,7789,'ms','Pilih fail pekerja',0),(280397,7789,'ar','Ø¥Ø®ØªÙŠØ§Ø± Ù…Ù„Ù Ø§Ù„Ù…ÙˆØ¸Ù',0),(280398,7789,'fr','SÃ©lectionnez le dossier de l\'employÃ©',0),(280399,7789,'jp','å¾“æ¥­å“¡ã®ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã—ã¾ã™',0),(280400,7789,'pt','Selecione o arquivo de empregado',0),(280401,7789,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¤Ð°Ð¹Ð» Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(280402,7789,'es','Seleccionar File de Empleado',0),(280403,7789,'de','Mitarbeiterdatei auswÃ¤hlen',0),(280404,7789,'en','Select Employee File',0),(280405,7790,'is','',0),(280406,7790,'dr','Ù¾Ø§Ù†Ø²Ø¯Ù‡ Ø±ÙˆØ²ÙŠÚ©Ø¨Ø§Ø±',0),(280407,7790,'pr','Ù¾Ø§Ù†Ø²Ø¯Ù‡ Ø±ÙˆØ²ÙŠÚ©Ø¨Ø§Ø±',0),(280408,7790,'tr','YarÄ± aylÄ±k',0),(280409,7790,'pl','PÃ³Å‚-miesiÄ™czne',0),(280410,7790,'bg','ÐŸÐ¾Ð»Ñƒ-Ð¼ÐµÑÐµÑ‡ÐµÐ½',0),(280411,7790,'ur','Ø³ÛŒÙ…ÛŒ Ù…Ø§ÛØ§Ù†Û',0),(280412,7790,'sr','ÐŸÐ¾Ð»Ñƒ -Ñ˜ÐµÐ´Ð½Ð¾Ð¼ Ð¼ÐµÑÐµÑ‡Ð½Ð¾',0),(280413,7790,'vi','Giá»¯a thÃ¡ng',0),(280414,7790,'af','Semie-Maandliks',0),(280415,7790,'ro','Semi-lunar',0),(280416,7790,'et','Poolekuine',0),(280417,7790,'si','Pol-meseÄno',0),(280418,7790,'ba','Semi bulanan',0),(280419,7790,'nl','Semi-maandelijks',0),(280420,7790,'fi','Toinen kuukausi',0),(280421,7790,'no','Semi-mÃ¥nedlige',0),(280422,7790,'da','Semi-mÃ¥nedlige',0),(280423,7790,'ko','ë°˜ ì›”',0),(280424,7790,'he','×—×•×“×©×™ ×œ×ž×—×¦×”',0),(280425,7790,'el','Î—Î¼Î¹-Î¼Î·Î½Î¹Î±Î¯Î±',0),(280426,7790,'zh','åŠæœˆ\r\n',0),(280427,7790,'sv','Semi-monthly',0),(280428,7790,'it','Semi-mensile',0),(280429,7790,'tl','',0),(280430,7790,'th','&#3588;&#3619;&#3638;&#3656;&#3591;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(280431,7790,'hi','à¤…à¤°à¥à¤¦à¥à¤§-à¤®à¤¾à¤¸à¤¿à¤•',0),(280432,7790,'ms','Setengah bulanan',0),(280433,7790,'ar','Ù†ØµÙ Ø´Ù‡Ø±ÙŠ',0),(280434,7790,'fr','Deux fois par mois',0),(280435,7790,'jp','åŠæœˆåˆŠ',0),(280436,7790,'pt','Semi-mensal',0),(280437,7790,'ru','Ð Ð°Ð·Ð° Ð² Ð¼ÐµÑÑÑ†',0),(280438,7790,'es','Quincenal',0),(280439,7790,'de','Halbmonatlich',0),(280440,7790,'en','Semi-Monthly',0),(280441,7791,'is','',0),(280442,7791,'dr','Ø´Ù…Ø§Ø±Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹Ù‰',0),(280443,7791,'pr','Ø´Ù…Ø§Ø±Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹Ù‰',0),(280444,7791,'tr','Sosyal GÃ¼venlik numarasÄ±',0),(280445,7791,'pl','Numer ubezpieczenia spoÅ‚ecznego',0),(280446,7791,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¾Ñ†Ð¸Ð°Ð»Ð½Ð° Ð¾ÑÐ¸Ð³ÑƒÑ€Ð¾Ð²ÐºÐ°',0),(280447,7791,'ur','Ø³ÙˆØ´Ù„ Ø³ÛŒÚ©ÛŒÙˆØ±Ù¹ÛŒ Ù†Ù…Ø¨Ø±',0),(280448,7791,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑÐ¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾Ð³ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ°',0),(280449,7791,'vi','Sá»‘ an sinh xÃ£ há»™i',0),(280450,7791,'af','Sosiale sekerheid nommer',0),(280451,7791,'ro','NumÄƒrul de securitate socialÄƒ',0),(280452,7791,'et','Isikukood',0),(280453,7791,'si','EMÅ O',0),(280454,7791,'ba','Nomor jaminan sosial',0),(280455,7791,'nl','Sofi-nummer',0),(280456,7791,'fi','Social Security Number',0),(280457,7791,'no','Personnummer',0),(280458,7791,'da','CPR-nummer',0),(280459,7791,'ko','ì‚¬íšŒ ë³´ìž¥ ë²ˆí˜¸',0),(280460,7791,'he','×ž×¡×¤×¨ ×”×‘×™×˜×•×— ×”×œ××•×ž×™',0),(280461,7791,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÎºÎ®Ï‚ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚',0),(280462,7791,'zh','ç¤¾ä¼šä¿éšœå·ç \r\n',0),(280463,7791,'sv','Personnummer',0),(280464,7791,'it','Numero di previdenza sociale',0),(280465,7791,'tl','',0),(280466,7791,'th','&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3585;&#3629;&#3591;&#3607;&#3640;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3617;',0),(280467,7791,'hi','à¤¸à¤¾à¤®à¤¾à¤œà¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤•à¥à¤°à¤®à¤¾à¤‚à¤•',0),(280468,7791,'ms','Nombor jaminan sosial',0),(280469,7791,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø¥Ø¬ØªÙ…Ø§Ø¹ÙŠ',0),(280470,7791,'fr','NumÃ©ro de sÃ©curitÃ© sociale',0),(280471,7791,'jp','ç¤¾ä¼šä¿éšœç•ªå·',0),(280472,7791,'pt','NÃºmero de seguranÃ§a social',0),(280473,7791,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÐ¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(280474,7791,'es','Registro de Contribuyente o RFC',0),(280475,7791,'de','Sozialversicherungsnummer',0),(280476,7791,'en','Social Security Number',0),(280477,7792,'is','',0),(280478,7792,'dr','Ø­Ø±ÙˆÙ Ø§ÙˆÙ„ Ø§Ø³ØªØ§Ù† Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø³ØªØ§Ù† ',0),(280479,7792,'pr','Ø­Ø±ÙˆÙ Ø§ÙˆÙ„ Ø§Ø³ØªØ§Ù† Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø³ØªØ§Ù† ',0),(280480,7792,'tr','Devlet vergi iÃ§in devlet baÅŸ harfleri',0),(280481,7792,'pl','PaÅ„stwa inicjaÅ‚y PaÅ„stwa podatku',0),(280482,7792,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ð»Ð¸Ñ‚Ðµ Ð·Ð° Ð´ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð´Ð°Ð½ÑŠÐº',0),(280483,7792,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ù¹ÛŒÚ©Ø³ Ú©Û’ Ù„ÛŒÛ’ Ø±ÛŒØ§Ø³ØªÛŒ Ù…Ø®ØªØµØ± Ø¯Ø³ØªØ®Ø·',0),(280484,7792,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð»Ðµ Ð·Ð° Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(280485,7792,'vi','KÃ½ tá»± tiá»ƒu bang cho thuáº¿ tiá»ƒu bang',0),(280486,7792,'af','Staat voorletters vir staat belasting',0),(280487,7792,'ro','IniÅ£ialele stat pentru fiscal de stat',0),(280488,7792,'et','Riigi initsiaale osariigi maksu',0),(280489,7792,'si','DrÅ¾avna zaÄetnice za drÅ¾avne davÄne',0),(280490,7792,'ba','Inisial negara untuk negara pajak',0),(280491,7792,'nl','Staat initialen voor staat belasting',0),(280492,7792,'fi','Valtion nimikirjaimia osavaltion verotunnuksen',0),(280493,7792,'no','Statlige initialene for skattepenger',0),(280494,7792,'da','Statslige initialer for statslige skat',0),(280495,7792,'ko','ì£¼ ì„¸ì— ëŒ€ í•œ ì£¼ ì´ë‹ˆì…œ',0),(280496,7792,'he','×”×ž×“×™× ×” ×”×ª×™×‘×•×ª. ×ž×¡ ×”×›× ×¡×”',0),(280497,7792,'el','ÎšÏÎ±Ï„Î¹ÎºÎ­Ï‚ Î±ÏÏ‡Î¹ÎºÎ¬ Î³Î¹Î± ÎºÏÎ±Ï„Î¹ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï…',0),(280498,7792,'zh','å›½å®¶ç¨ŽåŠ¡ç¼©å†™ä¸ºå›½å®¶\r\n',0),(280499,7792,'sv','Statliga initialer fÃ¶r statlig skatt',0),(280500,7792,'it','Iniziali dello stato per imposte statali',0),(280501,7792,'tl','',0),(280502,7792,'th','&#3594;&#3639;&#3656;&#3629;&#3649;&#3619;&#3585;&#3586;&#3629;&#3591;&#3619;&#3633;&#3600;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3616;&#3634;&#3625;&#3637;&#3586;&#3629;&#3591;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(280503,7792,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¾à¤œà¥ à¤¯ à¤ªà¥à¤°à¤¥à¤®à¤¾à¤•à¥à¤·à¤°',0),(280504,7792,'ms','Negeri nama Negeri cukai',0),(280505,7792,'ar','Ø§Ù„Ø£Ø­Ø±Ù Ø§Ù„Ø£ÙˆÙ„Ù‰ Ù…Ù† Ø§Ø³Ù… Ø§Ù„Ø¯ÙˆÙ„Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(280506,7792,'fr','Ã‰tats initiales pour impÃ´t provincial',0),(280507,7792,'jp','å·žç¨Žã®å·žã®é ­æ–‡å­—',0),(280508,7792,'pt','Estado iniciais para impostos estaduais',0),(280509,7792,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ð»Ñ‹ Ð´Ð»Ñ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ð¾Ð¹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹',0),(280510,7792,'es','Iniciales del Estado para Impuesto del Estado',0),(280511,7792,'de','Staatliche Initialen fÃ¼r staatliche Steuer',0),(280512,7792,'en','State Initials for State Tax',0),(280513,7793,'is','',0),(280514,7793,'dr','ÙÙŠÙ„Ø¯ Ø®Ø§Ù„ÙŠ',0),(280515,7793,'pr','ÙÙŠÙ„Ø¯ Ø®Ø§Ù„ÙŠ',0),(280516,7793,'tr','BoÅŸ alan',0),(280517,7793,'pl','Puste pole',0),(280518,7793,'bg','ÐŸÑ€Ð°Ð·Ð½Ð¾ Ð¿Ð¾Ð»Ðµ',0),(280519,7793,'ur','Ø®Ø§Ù„ÛŒ Ù‚Ø·Ø¹Û',0),(280520,7793,'sr','ÐŸÑ€Ð°Ð·Ð½Ð¾ Ð¿Ð¾Ñ™Ðµ',0),(280521,7793,'vi','TrÆ°á»ng Ä‘en',0),(280522,7793,'af','Blanko Veld',0),(280523,7793,'ro','CÃ¢mp gol',0),(280524,7793,'et','TÃ¼hi vÃ¤li',0),(280525,7793,'si','Prazno polje',0),(280526,7793,'ba','Bidang kosong',0),(280527,7793,'nl','Leeg veld',0),(280528,7793,'fi','TyhjÃ¤ kenttÃ¤',0),(280529,7793,'no','Tomt felt',0),(280530,7793,'da','Tomt felt',0),(280531,7793,'ko','ë¹ˆ í•„ë“œ',0),(280532,7793,'he','×©×“×” ×¨×™×§',0),(280533,7793,'el','ÎšÎµÎ½ÏŒ Ï€ÎµÎ´Î¯Î¿',0),(280534,7793,'zh','ç©ºç™½æ \r\n',0),(280535,7793,'sv','Tomt fÃ¤lt',0),(280536,7793,'it','Campo vuoto',0),(280537,7793,'tl','',0),(280538,7793,'th','&#3586;&#3629;&#3610;&#3648;&#3586;&#3605;&#3607;&#3637;&#3656;&#3623;&#3656;&#3634;&#3591;',0),(280539,7793,'hi','à¤°à¤¿à¤•à¥à¤¤ à¤«à¤¼à¥€à¤²à¥à¤¡',0),(280540,7793,'ms','Bidang yang kosong',0),(280541,7793,'ar','Ø­Ù‚Ù„ Ø®Ø§Ù„ÙŠ',0),(280542,7793,'fr','Champ vide',0),(280543,7793,'jp','ç©ºç™½ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(280544,7793,'pt','Campo em branco',0),(280545,7793,'ru','ÐŸÑƒÑÑ‚Ð¾Ðµ Ð¿Ð¾Ð»Ðµ',0),(280546,7793,'es','Campo Blanco',0),(280547,7793,'de','Leeres Feld',0),(280548,7793,'en','Blank Field',0),(280549,7794,'is','',0),(280550,7794,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù‚ÙŠÙ…Øª',0),(280551,7794,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù‚ÙŠÙ…Øª',0),(280552,7794,'tr','AVG fiyatÄ±',0),(280553,7794,'pl','Cena AVG',0),(280554,7794,'bg','AVG Ñ†ÐµÐ½Ð°',0),(280555,7794,'ur','Ø§ÙˆØ³Ø· Ù‚ÛŒÙ…Øª',0),(280556,7794,'sr','ÐÐ²Ð³ Ñ†ÐµÐ½Ð°',0),(280557,7794,'vi','GiÃ¡ Trung BÃ¬nh',0),(280558,7794,'af','Gemiddelde Prys',0),(280559,7794,'ro','AVG Pret',0),(280560,7794,'et','Keskmie hind',0),(280561,7794,'si','AVG cena',0),(280562,7794,'ba','AVG harga',0),(280563,7794,'nl','AVG prijs',0),(280564,7794,'fi','Keskihinta',0),(280565,7794,'no','AVG pris',0),(280566,7794,'da','AVG pris',0),(280567,7794,'ko','í‰ê·  ê°€ê²©',0),(280568,7794,'he','×ž×—×™×¨ ×ž×ž×•×¦×¢',0),(280569,7794,'el','AVG Ï„Î¹Î¼Î®',0),(280570,7794,'zh','å¹³å‡ä»·æ ¼\r\n',0),(280571,7794,'sv','AVG pris',0),(280572,7794,'it','Prezzo di AVG',0),(280573,7794,'tl','',0),(280574,7794,'th','&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(280575,7794,'hi','à¤”à¤¸à¤¤ à¤®à¥‚à¤²à¥à¤¯',0),(280576,7794,'ms','Harga AVG',0),(280577,7794,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„Ø³Ø¹Ø±',0),(280578,7794,'fr','Prix moyen',0),(280579,7794,'jp','å¹³å‡å®¢å®¤æ–™é‡‘',0),(280580,7794,'pt','PreÃ§o do AVG',0),(280581,7794,'ru','Ð¡Ñ€ÐµÐ´Ð½ÑÑ Ñ†ÐµÐ½Ð°',0),(280582,7794,'es','Precio Promedio',0),(280583,7794,'de','AVG-Preis',0),(280584,7794,'en','Avg Price',0),(280585,7795,'is','',0),(280586,7795,'dr','Ø®ØµÙˆØµÙŠØ§Øª ØºÙŠØ± Ù…Ø¬Ø§Ø² Ø­Ø°Ù Ø´Ø¯Ù†Ø¯',0),(280587,7795,'pr','Ø®ØµÙˆØµÙŠØ§Øª ØºÙŠØ± Ù…Ø¬Ø§Ø² Ø­Ø°Ù Ø´Ø¯Ù†Ø¯',0),(280588,7795,'tr','Ä°zin verilmeyen karakterleri kaldÄ±rÄ±lÄ±r',0),(280589,7795,'pl','UsuniÄ™te znaki niedozwolone',0),(280590,7795,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸ Ð·Ð°Ð±Ñ€Ð°Ð½ÐµÐ½Ð¸ Ð·Ð½Ð°Ñ†Ð¸',0),(280591,7795,'ur','Ú©Ø±ÛŒÚ©Ù¹Ø± Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(280592,7795,'sr','Ð£ÐºÐ»Ð°ÑšÐ° Ð·Ð½Ð°ÐºÐ¾Ð²Ðµ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(280593,7795,'vi','Bá» kÃ½ tá»± khÃ´ng cho phÃ©p',0),(280594,7795,'af','Verwyder toegelaat karakters',0),(280595,7795,'ro','Removed caractere nepermise',0),(280596,7795,'et','Eemaldada keelatud mÃ¤rgid',0),(280597,7795,'si','Odstrani nedovoljeni znaki',0),(280598,7795,'ba','Dihapus batasan karakter',0),(280599,7795,'nl','Niet-toegestane tekens verwijderd',0),(280600,7795,'fi','Poistettu Kielletyt merkit',0),(280601,7795,'no','Fjernet ulovlig tegn',0),(280602,7795,'da','Fjernede ikke-tilladte tegn',0),(280603,7795,'ko','í—ˆìš© ë˜ì§€ ì•ŠëŠ” ë¬¸ìž ì œê±°',0),(280604,7795,'he','×œ×”×¡×™×¨ ×ª×•×•×™× ×©××™× × ×ž×•×¨×©×™×',0),(280605,7795,'el','Î‘Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯ Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÎµÏ‚ Î´ÎµÎ½ Î±Î½Î±Î³Î½Ï‰ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹',0),(280606,7795,'zh','åˆ é™¤ç¦ç”¨çš„å­—ç¬¦\r\n',0),(280607,7795,'sv','Bort otillÃ¥tna tecken',0),(280608,7795,'it','Rimossi i caratteri non consentiti',0),(280609,7795,'tl','',0),(280610,7795,'th','&#3621;&#3610;&#3605;&#3633;&#3623;&#3629;&#3633;&#3585;&#3625;&#3619;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(280611,7795,'hi','à¤…à¤¸à¥à¤µà¥€à¤•à¥ƒà¤¤ à¤…à¤•à¥à¤·à¤° à¤¨à¤¿à¤•à¤¾à¤² à¤¦à¤¿à¤¯à¤¾',0),(280612,7795,'ms','Watak-watak tidak dibenarkan dikeluarkan',0),(280613,7795,'ar','Ø¥Ø²Ø§Ù„Ø© Ø§Ù„Ø£Ø­Ø±Ù ØºÙŠØ± Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(280614,7795,'fr','SupprimÃ© les caractÃ¨res non autorisÃ©s',0),(280615,7795,'jp','è¨±å¯ã•ã‚Œã¦ã„ãªã„æ–‡å­—ã‚’å‰Šé™¤',0),(280616,7795,'pt','Removido caracteres nÃ£o permitidos',0),(280617,7795,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ñ‹ Ð½ÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ðµ ÑÐ¸Ð¼Ð²Ð¾Ð»Ñ‹',0),(280618,7795,'es','Elimiinar CarÃ¡cteres No Permitidos',0),(280619,7795,'de','Entfernten unzulÃ¤ssige Zeichen',0),(280620,7795,'en','Removed Disallowed Characters',0),(280621,7796,'is','',0),(280622,7796,'dr','ØµÙØ­Ù‡ Ø§ÙˆÙ„ ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(280623,7796,'pr','ØµÙØ­Ù‡ Ø§ÙˆÙ„ ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(280624,7796,'tr','AlÄ±ÅŸveriÅŸ sepeti Ã¶n sayfa',0),(280625,7796,'pl','Stronie przedniej koszyka',0),(280626,7796,'bg','ÐŸÑ€ÐµÐ´Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ñ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ° ÐºÐ¾ÑˆÐ½Ð¸Ñ†Ð°',0),(280627,7796,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ ÙØ±Ù†Ù¹ ØµÙØ­Û',0),(280628,7796,'sr','ÐšÑƒÐ¿Ð¾Ð²Ð¸Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ†Ð° Ð½Ð°ÑÐ»Ð¾Ð²Ð½Ñƒ ÑÑ‚Ñ€Ð°Ð½Ñƒ',0),(280629,7796,'vi','Trang Äáº§u Cá»§a Giá» HÃ ng',0),(280630,7796,'af','Winkeltrollie Voorblad',0),(280631,7796,'ro','Prima pagina coÅŸ de cumpÄƒrÄƒturi',0),(280632,7796,'et','Shopping ostukorvi esilehel',0),(280633,7796,'si','Nakupovalni voziÄek sprednji strani',0),(280634,7796,'ba','Halaman depan keranjang belanja',0),(280635,7796,'nl','Shopping Cart-voorpagina',0),(280636,7796,'fi','Shopping Cart etusivulla',0),(280637,7796,'no','Handlekurven foran siden',0),(280638,7796,'da','Shopping Cart forsiden',0),(280639,7796,'ko','ì‡¼í•‘ ì¹´íŠ¸ ì²« íŽ˜ì´ì§€',0),(280640,7796,'he','×¢×’×œ×ª ×”×§× ×™×•×ª ×‘×¢×ž×•×“ ×”×¨××©×™',0),(280641,7796,'el','Î¨ÏŽÎ½Î¹Î± ÎºÎ±Î»Î¬Î¸Î¹ Ï€ÏÏ‰Ï„Î¿ÏƒÎ­Î»Î¹Î´Î¿',0),(280642,7796,'zh','è´­ç‰©è½¦é¦–é¡µ\r\n',0),(280643,7796,'sv','Shopping Cart fÃ¶rstasida',0),(280644,7796,'it','Shopping Cart prima pagina',0),(280645,7796,'tl','',0),(280646,7796,'th','&#3627;&#3609;&#3657;&#3634;&#3649;&#3619;&#3585;&#3586;&#3629;&#3591;&#3619;&#3606;&#3648;&#3586;&#3655;&#3609;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(280647,7796,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤«à¥à¤°à¤‚à¤Ÿ à¤ªà¥‡à¤œ',0),(280648,7796,'ms','Muka depan troli membeli-belah',0),(280649,7796,'ar','ØµÙØ­Ø© Ø§Ø³ØªÙ‚Ø¨Ø§Ù„ Ø¹Ø±Ø¨Ø© Ø§Ù„ØªØ³ÙˆÙ‚',0),(280650,7796,'fr','Shopping Cart Front Page',0),(280651,7796,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚° ã‚«ãƒ¼ãƒˆã®ãƒ•ãƒ­ãƒ³ãƒˆ ãƒšãƒ¼ã‚¸',0),(280652,7796,'pt','PÃ¡gina da frente do carrinho de compras',0),(280653,7796,'ru','Ð¢Ð¾Ñ€Ð³Ð¾Ð²Ñ‹Ð¹ ÐºÐ¾Ñ€Ð·Ð¸Ð½Ñƒ Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(280654,7796,'es','Carrito de Compras Primer Plano',0),(280655,7796,'de','Shopping Cart-Titelseite',0),(280656,7796,'en','Shopping Cart Front Page',0),(280657,7797,'is','',0),(280658,7797,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®ØªÙŠ ÙƒÙ‡ Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(280659,7797,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®ØªÙŠ ÙƒÙ‡ Ù†ÙŠØ§Ø² Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(280660,7797,'tr','HiÃ§bir yapÄ± ihtiyaÃ§ duyan PO sipariÅŸler',0),(280661,7797,'pl','Stworzenie zamÃ³wieÅ„ wymagajÄ…cych PO',0),(280662,7797,'bg','ÐÐµ ÑÑ‚Ñ€Ð¾Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐµ Ð½ÑƒÐ¶Ð´Ð°ÑÑ‚ PO',0),(280663,7797,'ur','Ø¶Ø±ÙˆØ±Øª Ù¾Ùˆ Ú©ÙˆØ¦ÛŒ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Ø§ Ø­Ú©Ù… Ø¯Û’ Ø¯ÛŒØ§ Û”',0),(280664,7797,'sr','ÐÐµÐ¼Ð° Ð‘ÑƒÐ¸Ð»Ð´ Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾ Ñ‚Ñ€ÐµÐ±Ð°Ð¶Ðµ Ñ‚Ð¸ ÐŸÐž',0),(280665,7797,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n hÃ ng sáº£n xuáº¥t khi Ä‘áº·t hÃ ng cáº§n Ä‘Æ¡n mua hÃ ng',0),(280666,7797,'af','Geen Geboude Bestellings Gevind in die Gegewe Datumreeks',0),(280667,7797,'ro','Nu construi comenzi au nevoie PO',0),(280668,7797,'et','No ehitada tellib vajavad PO',0),(280669,7797,'si','Ne graditi naroÄila potrebujejo PO',0),(280670,7797,'ba','Tidak membangun perintah membutuhkan PO',0),(280671,7797,'nl','Geen Build bestellingen nodig hebben PO',0),(280672,7797,'fi','Ei rakentaa tilaukset tarvitsee PO',0),(280673,7797,'no','Ingen bygge bestillinger trenger PO',0),(280674,7797,'da','Ingen Build Orders behÃ¸ver PO',0),(280675,7797,'ko','ì•„ë¬´ ë¹Œë“œ ëª…ë ¹ì„ í•„ìš”ë¡œ í¬',0),(280676,7797,'he','××™×Ÿ ×œ×‘× ×•×ª ×”×•×¨×” ×©× ×–×§×§ ×¤×•',0),(280677,7797,'el','Î”ÎµÎ½ Ï‡Ï„Î¯Î¶ÎµÎ¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Ï‡ÏÎµÎ¹Î¬Î¶Î¿Î½Ï„Î±Î¹ Î±Î½Î¬',0),(280678,7797,'zh','æ²¡æœ‰éœ€è¦é‡‡è´­è®¢å•çš„æž„å»ºè®¢å•\r\n',0),(280679,7797,'sv','Ingen bygga order behÃ¶ver PO',0),(280680,7797,'it','Nessuna compilazione ordini che necessitano di PO',0),(280681,7797,'tl','',0),(280682,7797,'th','&#3652;&#3617;&#3617;&#3637;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3651;&#3610;&#3626;&#3633;&#3',0),(280683,7797,'hi','à¤•à¥‹à¤ˆ à¤¬à¤¿à¤²à¥à¤¡ à¤œà¤¼à¤°à¥‚à¤°à¤¤ à¤ªà¥‹ à¤†à¤¦à¥‡à¤¶',0),(280684,7797,'ms','Membina sebarang pesanan memerlukan PO',0),(280685,7797,'ar','Ù„Ø§ Ø¨Ù†Ø§Ø¡ Ø£ÙˆØ§Ù…Ø± Ø¨Ùˆ ÙŠØ­ØªØ§Ø¬ÙˆÙ† Ø¥Ù„Ù‰',0),(280686,7797,'fr','N\'ordre d\'aucune construction : XIXe siÃ¨cle / PO',0),(280687,7797,'jp','ãƒ“ãƒ«ãƒ‰ãªã—å¿…è¦ã¨ PO ã‚’å—æ³¨ã—ã¾ã™ã€‚',0),(280688,7797,'pt','NÃ£o construir ordens precisando PO',0),(280689,7797,'ru','ÐÐµ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹ PO',0),(280690,7797,'es','No Hay Ordenes de ConstrucciÃ³n que necesitan un OC',0),(280691,7797,'de','Kein Build Bestellungen benÃ¶tigen PO',0),(280692,7797,'en','No Build Orders Needing PO',0),(280693,7798,'is','',0),(280694,7798,'dr','Ø¨Ø§ÙŠØ¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² Ù¾Ø± ÙƒØ±Ø¯Ù† Ø¯Ø±ÙŠØ§ÙØª ÙƒÙ†ÙŠØ¯ ',0),(280695,7798,'pr','Ø¨Ø§ÙŠØ¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² Ù¾Ø± ÙƒØ±Ø¯Ù† Ø¯Ø±ÙŠØ§ÙØª ÙƒÙ†ÙŠØ¯ ',0),(280696,7798,'tr','PO dolgu Ã¶nce almak gerekir',0),(280697,7798,'pl','Musi otrzymaÄ‡ PO przed wypeÅ‚nienia',0),(280698,7798,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ PO Ð¿Ñ€ÐµÐ´Ð¸ Ð·Ð°Ð¿ÑŠÐ»Ð²Ð°Ð½Ðµ',0),(280699,7798,'ur','Ù¾Ùˆ Ø¨Ú¾Ø±Ù†Û’ Ø³Û’ Ù¾ÛÙ„Û’ ÙˆØµÙˆÙ„ Ú©Ø±ÛŒÚº',0),(280700,7798,'sr','ÐœÐ¾Ñ€Ð°Ñ˜Ñƒ Ð¿Ñ€Ð¸Ð¼Ð°Ñ‚Ð¸ ÐŸÐž Ð¿Ñ€Ðµ Ð¿Ð¾Ð¿ÑƒÐ½Ðµ',0),(280701,7798,'vi','Pháº£i nháº­n Ä‘Æ¡n mua hÃ ng trÆ°á»›c khi Ä‘iá»n',0),(280702,7798,'af','Posbus voor vul moet ontvang',0),(280703,7798,'ro','Trebuie sÄƒ primeascÄƒ PO Ã®nainte de umplere',0),(280704,7798,'et','Peab saama enne tÃ¤idise PO',0),(280705,7798,'si','Mora prejeti PO pred polnila',0),(280706,7798,'ba','Harus menerima PO sebelum mengisi',0),(280707,7798,'nl','Moet ontvangen PO voor opvulling',0),(280708,7798,'fi','On saatava PO ennen tÃ¤yttÃ¶Ã¤',0),(280709,7798,'no','MÃ¥ motta PO fÃ¸r fyll',0),(280710,7798,'da','Skal modtage PO fÃ¸r fyld',0),(280711,7798,'ko','ì±„ìš°ê¸° ì „ì— í¬ë¥¼ ë°›ì•„ì•¼ í•©ë‹ˆë‹¤.',0),(280712,7798,'he','×—×™×™×‘×™× ×œ×§×‘×œ ×¤×• ×œ×¤× ×™ ×ž×™×œ×•×™',0),(280713,7798,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î»Î¬Î²ÎµÏ„Îµ PO Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î¿ Î³Î­Î¼Î¹ÏƒÎ¼Î±',0),(280714,7798,'zh','å¡«å……å‰å¿…é¡»æŽ¥å—è®¢å•\r\n',0),(280715,7798,'sv','MÃ¥ste fÃ¥ PO innan fyllning',0),(280716,7798,'it','Devono ricevere un PO prima di riempimento',0),(280717,7798,'tl','',0),(280718,7798,'th','&#3605;&#3657;&#3629;&#3591;&#3619;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3656;&#3629;&#3609;&#3610;&#3619;&#3619;&#3592;&#3640;',0),(280719,7798,'hi','PO à¤­à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(280720,7798,'ms','Mesti menerima PO sebelum mengisi',0),(280721,7798,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØªÙ„Ù‚Ù‰ Ø¨Ùˆ Ù‚Ø¨Ù„ Ø§Ù„ØªØ¹Ø¨Ø¦Ø©',0),(280722,7798,'fr','Doit recevoir PO avant remplissage',0),(280723,7798,'jp','å¡—ã‚Šã¤ã¶ã—ã®å‰ã« PO ã‚’å—ä¿¡ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(280724,7798,'pt','Deve receber PO antes de preenchimento',0),(280725,7798,'ru','Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ PO Ð´Ð¾ Ð·Ð°Ð»Ð¸Ð²ÐºÐ¸',0),(280726,7798,'es','Debe Recibir el PO Antes que Llenar',0),(280727,7798,'de','PO vor der FÃ¼llung muss erhalten werden.',0),(280728,7798,'en','Must Receive PO Before Fill',0),(280729,7799,'is','',0),(280730,7799,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø³ØªØ¬ÙˆÙŠ Ú¯Ø±ÙˆÙ‡ ',0),(280731,7799,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø³ØªØ¬ÙˆÙŠ Ú¯Ø±ÙˆÙ‡ ',0),(280732,7799,'tr','Arama kategorisi gÃ¼ncelleme',0),(280733,7799,'pl','Wyszukiwanie kategorii aktualizacji',0),(280734,7799,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(280735,7799,'ur','ØªÙ„Ø§Ø´ Ø²Ù…Ø±Û ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(280736,7799,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(280737,7799,'vi','Cáº­p Nháº­t Thá»ƒ Loáº¡i TÃ¬m Kiáº¿m',0),(280738,7799,'af','Soek Katergorie Opdateer',0),(280739,7799,'ro','Actualizare de categorie cÄƒutare',0),(280740,7799,'et','Otsi kategooria uuendusi',0),(280741,7799,'si','Kategorija iskanja posodobitve',0),(280742,7799,'ba','Cari kategori Update',0),(280743,7799,'nl','Zoek categorie Update',0),(280744,7799,'fi','Etsi luokka pÃ¤ivitys',0),(280745,7799,'no','SÃ¸k etter kategori oppdatering',0),(280746,7799,'da','SÃ¸g efter kategori opdatering',0),(280747,7799,'ko','ê²€ìƒ‰ ì¹´í…Œê³ ë¦¬ ì—…ë°ì´íŠ¸',0),(280748,7799,'he','×—×™×¤×•×© ×§×˜×’×•×¨×™×” ×¢×“×›×•×Ÿ',0),(280749,7799,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(280750,7799,'zh','æœç´¢ç±»åˆ«æ›´æ–°\r\n',0),(280751,7799,'sv','SÃ¶k kategori uppdatering',0),(280752,7799,'it','Ricerca categoria aggiornamento',0),(280753,7799,'tl','',0),(280754,7799,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(280755,7799,'hi','à¤–à¥‹à¤œ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(280756,7799,'ms','Kemaskini kategori carian',0),(280757,7799,'ar','ØªØ­Ø¯ÙŠØ« ØªØµÙ†ÙŠÙ Ø§Ù„Ø¨Ø­Ø«',0),(280758,7799,'fr','Recherche catÃ©gorie mise Ã  jour',0),(280759,7799,'jp','æ¤œç´¢ã‚«ãƒ†ã‚´ãƒªã®æ›´æ–°',0),(280760,7799,'pt','Busca categoria atualizaÃ§Ã£o',0),(280761,7799,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¿Ð¾Ð¸ÑÐºÐ°',0),(280762,7799,'es','Buscar CategorÃ­a Actualizar',0),(280763,7799,'de','Suche Kategorie-Update',0),(280764,7799,'en','Search Category Update',0),(280765,7800,'is','',0),(280766,7800,'dr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(280767,7800,'pr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(280768,7800,'tr','MÃ¼ÅŸteri sipariÅŸ iÃ§in',0),(280769,7800,'pl','Na zamÃ³wienie klienta',0),(280770,7800,'bg','Ð—Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(280771,7800,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’',0),(280772,7800,'sr','Ð—Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(280773,7800,'vi','Cho ÄÆ¡n Ä‘áº·t hÃ ng cá»§a khÃ¡ch hÃ ng',0),(280774,7800,'af','Vir KliÃ«nt/Klant Bestelling',0),(280775,7800,'ro','Pentru comanda clientului',0),(280776,7800,'et','Kliendi tellimuse',0),(280777,7800,'si','Za naroÄilo kupca',0),(280778,7800,'ba','Untuk Customer Order',0),(280779,7800,'nl','Voor de bestelling van de klant',0),(280780,7800,'fi','Asiakkaan tilauksen',0),(280781,7800,'no','For kundeordre',0),(280782,7800,'da','For kundeordre',0),(280783,7800,'ko','ê³ ê° ì£¼ë¬¸ì— ëŒ€ í•œ',0),(280784,7800,'he','×¢×‘×•×¨ ×”×–×ž× ×ª ×œ×§×•×—',0),(280785,7800,'el','Î“Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(280786,7800,'zh','å¯¹äºŽå®¢æˆ·è®¢å•\r\n',0),(280787,7800,'sv','FÃ¶r kundorder',0),(280788,7800,'it','Per ordine del cliente',0),(280789,7800,'tl','',0),(280790,7800,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(280791,7800,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤†à¤¦à¥‡à¤¶',0),(280792,7800,'ms','Untuk pesanan pelanggan',0),(280793,7800,'ar','Ù„Ø·Ù„Ø¨ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(280794,7800,'fr','Pour la commande du client',0),(280795,7800,'jp','é¡§å®¢ã®æ³¨æ–‡ã®',0),(280796,7800,'pt','Por ordem do cliente',0),(280797,7800,'ru','Ð”Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(280798,7800,'es','Para Orden de Cliente',0),(280799,7800,'de','FÃ¼r die Bestellung des Kunden',0),(280800,7800,'en','For Customer Order',0),(280801,7801,'is','',0),(280802,7801,'dr','Ù‡Ù…Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª ÙØ¹Ø§Ù„ÙŠØª ',0),(280803,7801,'pr','Ù‡Ù…Ù‡ Ø¬Ø²Ø¦ÙŠØ§Øª ÙØ¹Ø§Ù„ÙŠØª ',0),(280804,7801,'tr','TÃ¼m aktivite ayrÄ±ntÄ±larÄ±',0),(280805,7801,'pl','Wszystkie szczegÃ³Å‚y dziaÅ‚ania',0),(280806,7801,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð°',0),(280807,7801,'ur','Ø³Ø±Ú¯Ø±Ù…ÛŒ Ø³Û’ Ù…ØªØ¹Ù„Ù‚ ØªÙ…Ø§Ù… ØªÙØµÛŒÙ„Ø§Øª',0),(280808,7801,'sr','Ð¡Ð²Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(280809,7801,'vi','Chi Tiáº¿t Táº¥t Cáº£ CÃ¡c Hoáº¡t Äá»™ng',0),(280810,7801,'af','Alle Aktiwiteitsbesonderhede',0),(280811,7801,'ro','Toate detaliile de activitate',0),(280812,7801,'et','KÃµik tegevuste detailid',0),(280813,7801,'si','Vse podrobnosti o stanju',0),(280814,7801,'ba','Semua rincian kegiatan',0),(280815,7801,'nl','Alle Details van de activiteit',0),(280816,7801,'fi','Kaikki aktiviteetin tiedot',0),(280817,7801,'no','Alle aktivitetsdetaljer',0),(280818,7801,'da','Alle aktivitet detaljer',0),(280819,7801,'ko','ëª¨ë“  í™œë™ ì„¸ë¶€ ì‚¬í•­',0),(280820,7801,'he','×›×œ ×¤×¢×™×œ×•×ª ×”×¤×¨×˜×™×',0),(280821,7801,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚',0),(280822,7801,'zh','æ‰€æœ‰æ´»åŠ¨è¯¦æƒ…\r\n',0),(280823,7801,'sv','Alla aktivitetsuppgifter',0),(280824,7801,'it','Tutti i dettagli dell\'attivitÃ ',0),(280825,7801,'tl','',0),(280826,7801,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(280827,7801,'hi','à¤¸à¤­à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤µà¤¿à¤µà¤°à¤£',0),(280828,7801,'ms','Semua butir-butir aktiviti',0),(280829,7801,'ar','Ø¬Ù…ÙŠØ¹ ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù†Ø´Ø§Ø·',0),(280830,7801,'fr','Tous les dÃ©tails de l\'activitÃ©',0),(280831,7801,'jp','ã™ã¹ã¦ã®ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ã®è©³ç´°',0),(280832,7801,'pt','Todos os detalhes da atividade',0),(280833,7801,'ru','Ð’ÑÐµ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾Ð± Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(280834,7801,'es','Detalles de Toda Actividad',0),(280835,7801,'de','Alle AktivitÃ¤tsdetails',0),(280836,7801,'en','All Activity Details',0),(280837,7802,'is','',0),(280838,7802,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù…ÙˆØ¬ÙˆØ¯',0),(280839,7802,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù…ÙˆØ¬ÙˆØ¯',0),(280840,7802,'tr','KullanÄ±labilir ayrÄ±ntÄ±larÄ±',0),(280841,7802,'pl','SzczegÃ³Å‚y dostÄ™pne',0),(280842,7802,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(280843,7802,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ ØªÙØµÛŒÙ„Ø§Øª',0),(280844,7802,'sr','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ð¸',0),(280845,7802,'vi','Chi Tiáº¿t CÃ³ Sáºµn',0),(280846,7802,'af','Beskikbare Details',0),(280847,7802,'ro','Detalii disponibile',0),(280848,7802,'et','Olemasolevad andmed',0),(280849,7802,'si','Na voljo podrobnosti',0),(280850,7802,'ba','Rincian tersedia',0),(280851,7802,'nl','Beschikbare gegevens',0),(280852,7802,'fi','KÃ¤ytettÃ¤vissÃ¤ olevat tiedot',0),(280853,7802,'no','Tilgjengelige detaljer',0),(280854,7802,'da','TilgÃ¦ngelige detaljer',0),(280855,7802,'ko','ì„¸ë¶€ ë‚´ìš©',0),(280856,7802,'he','×¤×¨×˜×™× ×–×ž×™× ×™×',0),(280857,7802,'el','Î¤Î± Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(280858,7802,'zh','å·²æœ‰çš„è¯¦ç»†èµ„æ–™\r\n',0),(280859,7802,'sv','TillgÃ¤ngliga uppgifter',0),(280860,7802,'it','Dettagli disponibili',0),(280861,7802,'tl','',0),(280862,7802,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;',0),(280863,7802,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤µà¤¿à¤µà¤°à¤£',0),(280864,7802,'ms','Butir-butir yang disediakan',0),(280865,7802,'ar','Ø§Ù„ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(280866,7802,'fr','DÃ©tails disponibles',0),(280867,7802,'jp','åˆ©ç”¨å¯èƒ½ãªè©³ç´°',0),(280868,7802,'pt','Detalhes disponÃ­veis',0),(280869,7802,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ Ð”ÐµÑ‚Ð°Ð»Ð¸',0),(280870,7802,'es','Detalles Disponibles',0),(280871,7802,'de','VerfÃ¼gbaren Details',0),(280872,7802,'en','Available Details',0),(280873,7803,'is','',0),(280874,7803,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(280875,7803,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ',0),(280876,7803,'tr','TaahhÃ¼t ayrÄ±ntÄ±larÄ±',0),(280877,7803,'pl','PopeÅ‚nione szczegÃ³Å‚y',0),(280878,7803,'bg','ÐÐ½Ð³Ð°Ð¶Ð¸Ñ€Ð° Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(280879,7803,'ur','Ø¹Ø²Ù… Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(280880,7803,'sr','ÐŸÑ€ÐµÐ´Ð°Ð½Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(280881,7803,'vi','Chi tiáº¿t Cam káº¿t',0),(280882,7803,'af','Toegewyde besonderhede',0),(280883,7803,'ro','AngajeazÄƒ detalii',0),(280884,7803,'et','Toime Ã¼ksikasjad',0),(280885,7803,'si','Zavezana podrobnosti',0),(280886,7803,'ba','Berkomitmen rincian',0),(280887,7803,'nl','Gepleegd Details',0),(280888,7803,'fi','Sitoutunut tiedot',0),(280889,7803,'no','Forpliktet detaljer',0),(280890,7803,'da','Engageret detaljer',0),(280891,7803,'ko','ì•½ì†ëœ ì„¸ë¶€ ì •ë³´',0),(280892,7803,'he','×¤×¨×˜×™ ×ž×—×•×™×‘',0),(280893,7803,'el','Î”ÎµÏƒÎ¼ÎµÏ…Ï„ÎµÎ¯ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(280894,7803,'zh','æ‰¿è¯ºè¯¦æƒ…\r\n',0),(280895,7803,'sv','Engagerade Detaljer',0),(280896,7803,'it','Dettagli impegnate',0),(280897,7803,'tl','',0),(280898,7803,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;',0),(280899,7803,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§ à¤µà¤¿à¤µà¤°à¤£',0),(280900,7803,'ms','Butir-butir yang komited',0),(280901,7803,'ar','ØªÙØ§ØµÙŠÙ„ Ù…Ù„ØªØ²Ù…Ø©',0),(280902,7803,'fr','DÃ©tails engagÃ©s',0),(280903,7803,'jp','ã‚³ãƒŸãƒƒãƒˆã®è©³ç´°',0),(280904,7803,'pt','Detalhes comprometidos',0),(280905,7803,'ru','Ð¡Ð¾Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(280906,7803,'es','Detalles Comprometidos',0),(280907,7803,'de','Foul Details',0),(280908,7803,'en','Committed Details',0),(280909,7804,'is','',0),(280910,7804,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª  ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø±',0),(280911,7804,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª  ÙˆØ³Ø§ÙŠÙ„ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø±',0),(280912,7804,'tr','El ile ilgili ayrÄ±ntÄ±lar',0),(280913,7804,'pl','SzczegÃ³Å‚y strony',0),(280914,7804,'bg','ÐÐ° Ñ€ÑŠÐºÐ° Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(280915,7804,'ur','ÛØ§ØªÚ¾ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ù¾Ø±',0),(280916,7804,'sr','ÐÐ° Ñ€ÑƒÑ†Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(280917,7804,'vi','Chi tiáº¿t CÃ³ sáºµn',0),(280918,7804,'af','Op Hande Details',0),(280919,7804,'ro','Pe mana detalii',0),(280920,7804,'et','KÃ¤si Ã¼ksikasjad',0),(280921,7804,'si','Na roko podrobnosti',0),(280922,7804,'ba','Pada tangan rincian',0),(280923,7804,'nl','Op Hand Details',0),(280924,7804,'fi','KÃ¤si yksityiskohdat',0),(280925,7804,'no','PÃ¥ hÃ¥nd detaljer',0),(280926,7804,'da','PÃ¥ hÃ¥nd detaljer',0),(280927,7804,'ko','ì†ìœ¼ë¡œ ì„¸ë¶€ ì‚¬í•­ì—',0),(280928,7804,'he','×¢×œ ×™×“ ×¤×¨×˜×™×',0),(280929,7804,'el','Î£Ï„Î¹Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Ï‚ Ï‡ÎµÏÎ¹ÏŽÎ½',0),(280930,7804,'zh','çŽ°æœ‰è¯¦æƒ…\r\n',0),(280931,7804,'sv','PÃ¥ Hand Detaljer',0),(280932,7804,'it','Mano dettagli',0),(280933,7804,'tl','',0),(280934,7804,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3607;&#3637;&#3656;&#3606;&#3639;&#3629;&#3629;&#3618;&#3641;&#3656;',0),(280935,7804,'hi','à¤ªà¤° à¤¹à¤¾à¤¥ à¤µà¤¿à¤µà¤°à¤£',0),(280936,7804,'ms','Pada tangan butiran',0),(280937,7804,'ar','ÙÙŠ Ù†Ø§Ø­ÙŠØ© Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(280938,7804,'fr','Sur les dÃ©tails de la main',0),(280939,7804,'jp','æ‰‹ã®è©³ç´°ã«',0),(280940,7804,'pt','Na detalhes de mÃ£o',0),(280941,7804,'ru','ÐÐ° Ñ€ÑƒÐºÑƒ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(280942,7804,'es','Disponble Detalles',0),(280943,7804,'de','Auf Hand-Details',0),(280944,7804,'en','On Hand Details',0),(280945,7805,'is','',0),(280946,7805,'dr','(Ù†Ø³Ø¨Øª Ø¨Ù‡) Ø¬Ø²Ø¦ÙŠØ§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³',0),(280947,7805,'pr','Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø¯Ø±(Ù†Ø³Ø¨Øª Ø¨Ù‡) Ø¬Ø²Ø¦ÙŠØ§Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(280948,7805,'tr','Stok detaya aldÄ±',0),(280949,7805,'pl','Do magazynu szczegÃ³Å‚y',0),(280950,7805,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð² Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(280951,7805,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ù…ÛŒÚº Ù…Ù„Ø§',0),(280952,7805,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ðµ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(280953,7805,'vi','Nháº­n VÃ o Danh Má»¥c HÃ ng Trong Kho Chi Tiáº¿t',0),(280954,7805,'af','Ontvang in voorraad besonderhede',0),(280955,7805,'ro','Primit Ã®n inventar detalii',0),(280956,7805,'et','Vastu vÃµetud inventuuri Ã¼ksikasjad',0),(280957,7805,'si','Prejel v zaloge podrobnosti',0),(280958,7805,'ba','Diterima ke rincian persediaan',0),(280959,7805,'nl','Ontvangen in voorraad Details',0),(280960,7805,'fi','Vastaan inventoinnin',0),(280961,7805,'no','Mottatt i lagerinformasjon',0),(280962,7805,'da','Der er modtaget til lager detaljer',0),(280963,7805,'ko','ì¸ë²¤í† ë¦¬ ì„¸ë¶€ ì •ë³´ë¥¼ ë°›ì•˜ìŠµë‹ˆë‹¤.',0),(280964,7805,'he','×”×ª×§×‘×œ ×œ×ª×•×š ×ž×œ××™ ×¤×¨×˜×™×',0),(280965,7805,'el','ÎˆÎ»Î±Î²Îµ ÏƒÎµ Î±Ï€Î¿Î³ÏÎ±Ï†Î® Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(280966,7805,'zh','æ”¶æ¬¾åˆ°åº“å­˜è¯¦æƒ…\r\n',0),(280967,7805,'sv','Emot i lagret Detaljer',0),(280968,7805,'it','Ricevuto in inventario dettagli',0),(280969,7805,'tl','',0),(280970,7805,'th','&#3619;&#3633;&#3610;&#3652;&#3611;&#3626;&#3641;&#3656;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(280971,7805,'hi','à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤µà¤¿à¤µà¤°à¤£ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(280972,7805,'ms','Diterima ke dalam butir-butir inventori',0),(280973,7805,'ar','ÙˆØªÙ„Ù‚Ù‰ ÙÙŠ ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(280974,7805,'fr','ReÃ§u dans les dÃ©tails de l\'inventaire',0),(280975,7805,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®è©³ç´°ã‚’å—ä¿¡',0),(280976,7805,'pt','Recebido em detalhes de inventÃ¡rio',0),(280977,7805,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ð» Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(280978,7805,'es','Detalles de Recibir en Inventario',0),(280979,7805,'de','Empfangen in Inventurdetails',0),(280980,7805,'en','Received Into Inventory Details',0),(280981,7806,'is','',0),(280982,7806,'dr','Ù†Ø§ Ø®Ø§Ù„Øµ ØªÙ…Ø§Ù… Ø­Ù‚ÙˆÙ‚',0),(280983,7806,'pr','Ù†Ø§ Ø®Ø§Ù„Øµ ØªÙ…Ø§Ù… Ø­Ù‚ÙˆÙ‚',0),(280984,7806,'tr','TÃ¼m maaÅŸ BrÃ¼t',0),(280985,7806,'pl','Wszystkie wynagrodzenia brutto',0),(280986,7806,'bg','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð»Ð°Ñ‚Ð¸',0),(280987,7806,'ur','ØªÙ…Ø§Ù… ØªÙ†Ø®ÙˆØ§Û Ø³Ø§Ù…Ù†Ø§ ÛÙˆØªØ§ Ø­Ø¯ Ø¯Ø±Ø¬Û',0),(280988,7806,'sr','Ð¡Ð²ÐµÑƒÐºÑƒÐ¿Ð½Ð¾ , ÑÐ²Ðµ',0),(280989,7806,'vi','Táº¥t cáº£ lÆ°Æ¡ng gá»™p',0),(280990,7806,'af','Bruto Alle Besoldiging',0),(280991,7806,'ro','BrutÄƒ de plata tuturor',0),(280992,7806,'et','KÃµik tÃ¶Ã¶tasu (bruto)',0),(280993,7806,'si','Bruto plaÄa vse',0),(280994,7806,'ba','Kotor membayar semua',0),(280995,7806,'nl','Bruto alle Pay',0),(280996,7806,'fi','Brutto kaikki Pay',0),(280997,7806,'no','Brutto alle betale',0),(280998,7806,'da','Brutto alle Pay',0),(280999,7806,'ko','ëª¨ë“  ì§€ë¶ˆì„ ì´',0),(281000,7806,'he','×’×¨×•×¡ ×›×•×œ× ×• × ×©×œ×',0),(281001,7806,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î¿ Ï€Î»Î·ÏÏŽÏƒÎ¿Ï…Î¼Îµ ÏŒÎ»Î¿Î¹',0),(281002,7806,'zh','æ‰€æœ‰æ”¯ä»˜æ€»é¢\r\n',0),(281003,7806,'sv','Brutto alla betala',0),(281004,7806,'it','Lordo pagano tutti',0),(281005,7806,'tl','',0),(281006,7806,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(281007,7806,'hi','à¤¸à¤­à¥€ à¤¸à¤•à¤²',0),(281008,7806,'ms','Kasar gaji semua',0),(281009,7806,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø£Ø¬Ø± Ø¬Ù…ÙŠØ¹',0),(281010,7806,'fr','Brut tous payants',0),(281011,7806,'jp','ã™ã¹ã¦ã®çµ¦ä¸Žã‚’ç·é¡ã—ã¾ã™ã€‚',0),(281012,7806,'pt','Todos pagamos de efectivaÃ§Ã£o',0),(281013,7806,'ru','Ð’Ð°Ð»Ð¾Ð²Ð¾Ð¹ Ð²ÑÐµ ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ðµ',0),(281014,7806,'es','Todo Pagos Brutos',0),(281015,7806,'de','Brutto-alle Zahlen',0),(281016,7806,'en','Gross All Pay',0),(281017,7807,'is','',0),(281018,7807,'dr','Ù†Ø§ Ø®Ø§Ù„Øµ ØªÙ…Ø§Ù… Ø­Ù‚ÙˆÙ‚ Ø¯Ø± Ø³Ø§Ù„ ',0),(281019,7807,'pr','Ù†Ø§ Ø®Ø§Ù„Øµ ØªÙ…Ø§Ù… Ø­Ù‚ÙˆÙ‚ Ø¯Ø± Ø³Ø§Ù„ ',0),(281020,7807,'tr','TÃ¼m Ã¶demek-de yÄ±l BrÃ¼t',0),(281021,7807,'pl','Wszystkie pÅ‚atnoÅ›ci rocznie brutto',0),(281022,7807,'bg','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð»Ð°Ñ‚Ð¸ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(281023,7807,'ur','ÛØ± Ø³Ø§Ù„ ØªÙ…Ø§Ù… ØªÙ†Ø®ÙˆØ§Û Ø³Ø§Ù…Ù†Ø§ ÛÙˆØªØ§ Ø­Ø¯ Ø¯Ø±Ø¬Û',0),(281024,7807,'sr','Ð¡Ð²ÐµÑƒÐºÑƒÐ¿Ð½Ð¾ , ÑÐ²Ð¸ Ð³Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(281025,7807,'vi','Táº¥t cáº£ lÆ°Æ¡ng gá»™p má»—i nÄƒm',0),(281026,7807,'af','Bruto van Alle Besoldigings per Jaar',0),(281027,7807,'ro','Brut plÄƒtiÅ£i toate pe an',0),(281028,7807,'et','Gross kÃµik maksta aastas',0),(281029,7807,'si','Bruto vse plaÄe za vsako leto',0),(281030,7807,'ba','Semua Pay per tahun bruto',0),(281031,7807,'nl','Bruto alle Pay-per jaar',0),(281032,7807,'fi','Brutto kaikki Pay per vuosi',0),(281033,7807,'no','Brutto alle betale per Ã¥r',0),(281034,7807,'da','Brutto alle Pay per Ã¥r',0),(281035,7807,'ko','ëª¨ë“  ì§€ë¶ˆ ì—°ê°„ ì´',0),(281036,7807,'he','×’×¨×•×¡ ×œ×©×œ× ×‘×›×œ ×©× ×”',0),(281037,7807,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î¿ ÏŒÎ»Î± Ï€Î»Î·ÏÏ‰Î¼Î® Î±Î½Î¬ Î­Ï„Î¿Ï‚',0),(281038,7807,'zh','æ‰€æœ‰æ€»å€¼æ¯å¹´æ”¯ä»˜\r\n',0),(281039,7807,'sv','Brutto alla betala per Ã¥r',0),(281040,7807,'it','Lorda paga tutto l\'anno',0),(281041,7807,'tl','',0),(281042,7807,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3605;&#3656;&#3629;&#3611;&#3637;',0),(281043,7807,'hi','à¤¸à¤­à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤· à¤¸à¤•à¤²',0),(281044,7807,'ms','Kasar semua gaji setiap tahun',0),(281045,7807,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø¯ÙØ¹ ÙÙŠ Ø§Ù„Ø³Ù†Ø©',0),(281046,7807,'fr','Brut de tout salaire par an',0),(281047,7807,'jp','å¹´é–“ã™ã¹ã¦ã®çµ¦ä¸Žã‚’ç·é¡ã—ã¾ã™ã€‚',0),(281048,7807,'pt','Bruta todos os Pay-per-ano',0),(281049,7807,'ru','Ð‘Ñ€ÑƒÑ‚Ñ‚Ð¾ Ð²ÑÐµÑ… Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð·Ð° Ð³Ð¾Ð´',0),(281050,7807,'es','Todo Pagos Brutos por AÃ±o',0),(281051,7807,'de','Alle Zahlen pro Jahr Brutto',0),(281052,7807,'en','Gross All Pay per Year',0),(281053,7808,'is','',0),(281054,7808,'dr','Ù†Ø§ Ø®Ø§Ù„Øµ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(281055,7808,'pr','Ù†Ø§ Ø®Ø§Ù„Øµ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(281056,7808,'tr','BrÃ¼t vergiye tabi',0),(281057,7808,'pl','Opodatkowaniu brutto',0),(281058,7808,'bg','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾',0),(281059,7808,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ø¹Ø§Ø¦Ø¯',0),(281060,7808,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ð¶Ð°',0),(281061,7808,'vi','CÃ¡c khoáº£n pháº£i Ä‘Ã³ng thuáº¿ gá»™p',0),(281062,7808,'af','Bruto Belasbaar',0),(281063,7808,'ro','Brute impozabile',0),(281064,7808,'et','Bruto maksustatav',0),(281065,7808,'si','Bruto davÄni',0),(281066,7808,'ba','Kotor kena pajak',0),(281067,7808,'nl','Bruto belastbare',0),(281068,7808,'fi','Brutto verovelvollinen',0),(281069,7808,'no','Brutto skattepliktig',0),(281070,7808,'da','Brutto afgiftspligtige',0),(281071,7808,'ko','ì´ ê³¼ì„¸',0),(281072,7808,'he','×’×¨×•×¡ ×—×™×™×‘ ×‘×ž×¡',0),(281073,7808,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î¿ Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿',0),(281074,7808,'zh','åº”çº³ç¨Žæ€»é¢\r\n',0),(281075,7808,'sv','Brutto beskattningsbara',0),(281076,7808,'it','Imponibile lordo',0),(281077,7808,'tl','',0),(281078,7808,'th','&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;&#3619;&#3623;&#3617;',0),(281079,7808,'hi','à¤¸à¤•à¤² à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯',0),(281080,7808,'ms','Dikenakan cukai kasar',0),(281081,7808,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(281082,7808,'fr','Brut imposable',0),(281083,7808,'jp','ç·èª²ç¨Ž',0),(281084,7808,'pt','Bruta tributÃ¡vel',0),(281085,7808,'ru','Ð‘Ñ€ÑƒÑ‚Ñ‚Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ',0),(281086,7808,'es','Renta en Bruto Imponible',0),(281087,7808,'de','Brutto Steuerpflichtige',0),(281088,7808,'en','Gross Taxable',0),(281089,7809,'is','',0),(281090,7809,'dr','Ø­Ù‚ÙˆÙ‚ Ù†Ø§ Ø®Ø§Ù„Øµ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(281091,7809,'pr','Ø­Ù‚ÙˆÙ‚ Ù†Ø§ Ø®Ø§Ù„Øµ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(281092,7809,'tr','BrÃ¼t vergiye tabi Ã¶deme',0),(281093,7809,'pl','Opodatkowania wynagrodzenia brutto',0),(281094,7809,'bg','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(281095,7809,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ ØªÙ†Ø®ÙˆØ§Û',0),(281096,7809,'sr','ÐžÐ¿Ð¾Ñ€ÐµÐ·Ð¸Ð² Ð±Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ',0),(281097,7809,'vi','LÆ°Æ¡ng pháº£i Ä‘Ã³ng thuáº¿ gá»™p',0),(281098,7809,'af','Bruto Belasbare Besoldiging',0),(281099,7809,'ro','Salariu brut impozabile',0),(281100,7809,'et','Brutopalga maksustatava',0),(281101,7809,'si','Bruto plaÄa davÄni',0),(281102,7809,'ba','Membayar pajak bruto',0),(281103,7809,'nl','Belastbare brutoloon',0),(281104,7809,'fi','Veron bruttopalkasta',0),(281105,7809,'no','Skattepliktig bruttolÃ¸nn',0),(281106,7809,'da','Brutto Skattepligtig lÃ¸n',0),(281107,7809,'ko','ì´ ê³¼ì„¸ ì§€ë¶ˆ',0),(281108,7809,'he','×—×™×™×‘ ×‘×ž×¡ ×©×›×¨ ×‘×¨×•×˜×•',0),(281109,7809,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î· Î±Î¼Î¿Î¹Î²Î® Ï†Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­Î¿',0),(281110,7809,'zh','è®¡ç¨Žåº”ä»˜æ€»é¢\r\n',0),(281111,7809,'sv','Beskattningsbar bruttolÃ¶n',0),(281112,7809,'it','Retribuzione lorda imponibile',0),(281113,7809,'tl','',0),(281114,7809,'th','&#3592;&#3656;&#3634;&#3618;&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;&#3619;&#3623;&#3617;',0),(281115,7809,'hi','à¤¸à¤•à¤² à¤•à¤°-à¤¯à¥‹à¤—à¥ à¤¯ à¤µà¥‡à¤¤à¤¨',0),(281116,7809,'ms','Gaji boleh cukai yang kasar',0),(281117,7809,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(281118,7809,'fr','Salaire imposable brut',0),(281119,7809,'jp','èª²ç¨Žçµ¦ä¸Žã®ç·é¡',0),(281120,7809,'pt','SalÃ¡rio bruto tributÃ¡vel',0),(281121,7809,'ru','Ð’Ð°Ð»Ð¾Ð²Ð¾Ð¹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð¾Ð³Ð¾ Ð²Ð¾Ð·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(281122,7809,'es','Sueldo Bruto Imponible',0),(281123,7809,'de','Zu versteuernde Bruttogehalt',0),(281124,7809,'en','Gross Taxable Pay',0),(281125,7810,'is','',0),(281126,7810,'dr','Ø­Ù‚ÙˆÙ‚ Ù†Ø§ Ø®Ø§Ù„Øµ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ø±Ø³Ø§Ù„',0),(281127,7810,'pr','Ø­Ù‚ÙˆÙ‚ Ù†Ø§ Ø®Ø§Ù„Øµ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ø±Ø³Ø§Ù„',0),(281128,7810,'tr','YÄ±l baÅŸÄ±na brÃ¼t vergiye tabi Ã¶deme',0),(281129,7810,'pl','Opodatkowania wynagrodzenia brutto rocznie',0),(281130,7810,'bg','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¾',0),(281131,7810,'ur','ÛØ± Ø³Ø§Ù„ Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ ØªÙ†Ø®ÙˆØ§Û',0),(281132,7810,'sr','ÐžÐ¿Ð¾Ñ€ÐµÐ·Ð¸Ð² Ð±Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ Ð³Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(281133,7810,'vi','LÆ°Æ¡ng pháº£i Ä‘Ã³ng thuáº¿ gá»™p má»—i nÄƒm',0),(281134,7810,'af','Bruto Belasbare Besoldiging per Jaar',0),(281135,7810,'ro','Plata impozabile brut pe an',0),(281136,7810,'et','Maksustatav brutopalga aastas',0),(281137,7810,'si','Bruto plaÄa davÄni na leto',0),(281138,7810,'ba','Membayar pajak Bruto per tahun',0),(281139,7810,'nl','Bruto belastbare loon per jaar',0),(281140,7810,'fi','Veron bruttopalkasta vuodessa',0),(281141,7810,'no','Skattepliktig bruttolÃ¸nn per Ã¥r',0),(281142,7810,'da','Brutto skattepligtige lÃ¸n pr. Ã¥r',0),(281143,7810,'ko','ë…„ ë‹¹ ì´ ê³¼ì„¸ ì§€ë¶ˆ',0),(281144,7810,'he','×—×™×™×‘ ×‘×ž×¡ ×©×›×¨ ×‘×¨×•×˜×• ×œ×©× ×”',0),(281145,7810,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î¿ Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿Ï‚ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Î±Î½Î¬ Î­Ï„Î¿Ï‚',0),(281146,7810,'zh','åº”çº³ç¨Žæ€»é¢æ¯å¹´æ”¯ä»˜\r\n',0),(281147,7810,'sv','Beskattningsbar bruttolÃ¶n per Ã¥r',0),(281148,7810,'it','Retribuzione lorda imponibile all\'anno',0),(281149,7810,'tl','',0),(281150,7810,'th','&#3592;&#3656;&#3634;&#3618;&#3616;&#3634;&#3625;&#3637;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;&#3619;&#3623;&#3617;&#3605;&#3656;&#3629;&#3611;&#3637;',0),(281151,7810,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤· à¤¸à¤•à¤² à¤•à¤°à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨',0),(281152,7810,'ms','Kasar gaji boleh cukai setiap tahun',0),(281153,7810,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© ÙÙŠ Ø§Ù„Ø³Ù†Ø©',0),(281154,7810,'fr','Salaire imposable brut par an',0),(281155,7810,'jp','1 å¹´é–“èª²ç¨Žçµ¦ä¸Žã®ç·é¡',0),(281156,7810,'pt','SalÃ¡rio tributÃ¡vel bruto por ano',0),(281157,7810,'ru','Ð’Ð°Ð»Ð¾Ð²Ð¾Ð¹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð¾Ð³Ð¾ Ð²Ð¾Ð·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ñ Ð² Ð³Ð¾Ð´',0),(281158,7810,'es','Sueldo Bruto Imponible por AÃ±o',0),(281159,7810,'de','Zu versteuernde Bruttogehalt pro Jahr',0),(281160,7810,'en','Gross Taxable Pay per Year',0),(281161,7811,'is','',0),(281162,7811,'dr','Ù†Ø§ Ø®Ø§Ù„Øµ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ø± Ø³Ø§Ù„',0),(281163,7811,'pr','Ù†Ø§ Ø®Ø§Ù„Øµ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ø± Ø³Ø§Ù„',0),(281164,7811,'tr','YÄ±llÄ±k brÃ¼t vergiye tabi',0),(281165,7811,'pl','Opodatkowaniu brutto rocznie',0),(281166,7811,'bg','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¾',0),(281167,7811,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ø³Ø§Ù„Ø§Ù†Û Ø¹Ø§Ø¦Ø¯',0),(281168,7811,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ð¶Ð° Ð³Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(281169,7811,'vi','CÃ¡c khoáº£n pháº£i Ä‘Ã³ng thuáº¿ gá»™p má»—i nÄƒm',0),(281170,7811,'af','Bruto Belasbaar per Jaar',0),(281171,7811,'ro','Impozabile brut pe an',0),(281172,7811,'et','Bruto maksustatav aastas',0),(281173,7811,'si','Bruto davÄni zavezanec na leto',0),(281174,7811,'ba','Pajak Bruto per tahun',0),(281175,7811,'nl','Bruto belastbare per jaar',0),(281176,7811,'fi','Brutto veron vuodessa',0),(281177,7811,'no','Brutto skattepliktig per Ã¥r',0),(281178,7811,'da','Brutto afgiftspligtige pr. Ã¥r',0),(281179,7811,'ko','ì—°ê°„ ì´ ê³¼ì„¸',0),(281180,7811,'he','×’×¨×•×¡ ×—×™×™×‘ ×‘×ž×¡ ×‘×©× ×”',0),(281181,7811,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î¿ Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ Î±Î½Î¬ Î­Ï„Î¿Ï‚',0),(281182,7811,'zh','æ¯ä¸ªå¹´åº¦åº”çº³ç¨Žæ€»é¢\r\n',0),(281183,7811,'sv','Brutto beskattningsbara per Ã¥r',0),(281184,7811,'it','Imponibile lordo all\'anno',0),(281185,7811,'tl','',0),(281186,7811,'th','&#3616;&#3634;&#3625;&#3637;&#3619;&#3623;&#3617;&#3605;&#3656;&#3629;&#3611;&#3637;',0),(281187,7811,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤· à¤¸à¤•à¤² à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯',0),(281188,7811,'ms','Kasar cukai setiap tahun',0),(281189,7811,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© ÙÙŠ Ø§Ù„Ø³Ù†Ø©',0),(281190,7811,'fr','Brut imposable par an',0),(281191,7811,'jp','å¹´é–“ç·èª²ç¨Ž',0),(281192,7811,'pt','TributÃ¡veis brutos por ano',0),(281193,7811,'ru','Ð‘Ñ€ÑƒÑ‚Ñ‚Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼ Ð² Ð³Ð¾Ð´',0),(281194,7811,'es','Renta en Bruto Imponible por AÃ±o',0),(281195,7811,'de','Brutto Steuerpflichtige pro Jahr',0),(281196,7811,'en','Gross Taxable per Year',0),(281197,7812,'is','',0),(281198,7812,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø­Ù‚ÙˆÙ‚',0),(281199,7812,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ø­Ù‚ÙˆÙ‚',0),(281200,7812,'tr','Ã–deme tarihi',0),(281201,7812,'pl','ZapÅ‚aciÄ‡ historia',0),(281202,7812,'bg','ÐŸÐ»Ð°Ñ‚Ð¸ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(281203,7812,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(281204,7812,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(281205,7812,'vi','Lá»‹ch sá»­ tráº£',0),(281206,7812,'af','Besoldiginggeskiedenis',0),(281207,7812,'ro','Istoric de plati',0),(281208,7812,'et','Maksma ajalugu',0),(281209,7812,'si','PlaÄilo zgodovino',0),(281210,7812,'ba','Membayar sejarah',0),(281211,7812,'nl','Betalen geschiedenis',0),(281212,7812,'fi','Maksu historia',0),(281213,7812,'no','Betale historie',0),(281214,7812,'da','Betale historie',0),(281215,7812,'ko','ì—­ì‚¬ë¥¼ ì§€ë¶ˆ',0),(281216,7812,'he','×œ×©×œ× ×”×™×¡×˜×•×¨×™×”',0),(281217,7812,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(281218,7812,'zh','æ”¯ä»˜åŽ†å²\r\n',0),(281219,7812,'sv','Betala historia',0),(281220,7812,'it','Storia di pagare',0),(281221,7812,'tl','',0),(281222,7812,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(281223,7812,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(281224,7812,'ms','Membayar sejarah',0),(281225,7812,'ar','Ø¯ÙØ¹ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(281226,7812,'fr','Histoire de payer',0),(281227,7812,'jp','æ­´å²ã‚’æ”¯æ‰•ã†',0),(281228,7812,'pt','HistÃ³ria de pagar',0),(281229,7812,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ ÐŸÐ»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(281230,7812,'es','Historia de Pagos',0),(281231,7812,'de','Zahlen Geschichte',0),(281232,7812,'en','Pay History',0),(281233,7813,'is','',0),(281234,7813,'dr','Ø·Ø¨Ù‚ ØªØ§Ø±ÙŠØ® Ú†Ùƒ',0),(281235,7813,'pr','Ø·Ø¨Ù‚ ØªØ§Ø±ÙŠØ® Ú†Ùƒ',0),(281236,7813,'tr','Onay tarihine gÃ¶re',0),(281237,7813,'pl','WedÅ‚ug wyboru daty',0),(281238,7813,'bg','ÐŸÐ¾ Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ‡ÐµÐº',0),(281239,7813,'ur','Ú†ÛŒÚ© Ø§Ù† ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(281240,7813,'sr','ÐŸÐ¾ Ð´Ð°Ñ‚ÑƒÐ¼Ñƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(281241,7813,'vi','Theo ngÃ y SÃ©c',0),(281242,7813,'af','Per Tjekdatum',0),(281243,7813,'ro','Data Check',0),(281244,7813,'et','Poolt kontrolli kuupÃ¤ev',0),(281245,7813,'si','Preverite datum',0),(281246,7813,'ba','Tanggal Check',0),(281247,7813,'nl','Door het selectievakje datum',0),(281248,7813,'fi','SisÃ¤Ã¤n mennessÃ¤',0),(281249,7813,'no','Etter innsjekking dato',0),(281250,7813,'da','Ved checkens dato',0),(281251,7813,'ko','ì²´í¬ì¸ ë‚ ì§œ',0),(281252,7813,'he','×œ×¤×™ ×”×¡×™×ž×•×Ÿ ×ª××¨×™×š',0),(281253,7813,'el','Î‘Ï€ÏŒ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î¿Ï… ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(281254,7813,'zh','æŒ‰æ”¯ç¥¨æ—¥æœŸ\r\n',0),(281255,7813,'sv','Kontrollera datum',0),(281256,7813,'it','Di controllo Data',0),(281257,7813,'tl','',0),(281258,7813,'th','&#3650;&#3604;&#3618;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(281259,7813,'hi','à¤šà¥‡à¤• à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¸à¥‡',0),(281260,7813,'ms','Tarikh Daftar',0),(281261,7813,'ar','Ø­Ø³Ø¨ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(281262,7813,'fr','Par chÃ¨que Date',0),(281263,7813,'jp','ãƒã‚§ãƒƒã‚¯ã®æ—¥ä»˜é †',0),(281264,7813,'pt','Por data de verificaÃ§Ã£o',0),(281265,7813,'ru','ÐŸÐ¾ Ð´Ð°Ñ‚Ðµ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸',0),(281266,7813,'es','Por Fecha de Cheque',0),(281267,7813,'de','Von Scheckdatum',0),(281268,7813,'en','By Check Date',0),(281269,7814,'is','',0),(281270,7814,'dr','Ø¨Ø§ Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ø¯ÙˆØ±Ù‡',0),(281271,7814,'pr','Ø¨Ø§ Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ø¯ÙˆØ±Ù‡',0),(281272,7814,'tr','DÃ¶nem tarihi sonuna kadar',0),(281273,7814,'pl','Koniec terminu okresu',0),(281274,7814,'bg','Ð”Ð¾ ÐºÑ€Ð°Ñ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð´Ð°Ñ‚Ð°',0),(281275,7814,'ur','Ù…Ø¯Øª ØªØ§Ø±ÛŒØ® Ú©Û’ Ø§Ø®ØªØªØ§Ù… ØªÚ©',0),(281276,7814,'sr','Ð”Ð¾ ÐºÑ€Ð°Ñ˜Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð´Ð°Ñ‚ÑƒÐ¼',0),(281277,7814,'vi','VÃ o ngÃ y cuá»‘i ká»³',0),(281278,7814,'af','Datum Teen Einde van Periode',0),(281279,7814,'ro','PÃ¢nÄƒ la sfÃ¢rÅŸitul perioadei data',0),(281280,7814,'et','LÃµppemise kuupÃ¤evad',0),(281281,7814,'si','Konca datum obdobja',0),(281282,7814,'ba','Akhir periode tanggal',0),(281283,7814,'nl','Tegen einde van periode datum',0),(281284,7814,'fi','Lopussa pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(281285,7814,'no','Ved utgangen av perioden dato',0),(281286,7814,'da','Ved udgangen af perioden dato',0),(281287,7814,'ko','ê¸°ê°„ ë‚ ì§œì˜ ëì— ì˜í•˜ì—¬',0),(281288,7814,'he','×¢×“ ×¡×•×£ ×ª×§×•×¤×ª ×ª××¨×™×š',0),(281289,7814,'el','Î‘Ï€ÏŒ Ï„Î¿ Ï„Î­Î»Î¿Ï‚ Ï„Î·Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï… Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(281290,7814,'zh','æŒ‰æ—¥æœŸé—´å†…å®Œ\r\n',0),(281291,7814,'sv','Slutet av datum fÃ¶r Period',0),(281292,7814,'it','Dalla fine del periodo data',0),(281293,7814,'tl','',0),(281294,7814,'th','&#3650;&#3604;&#3618;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3586;&#3629;&#3591;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(281295,7814,'hi','à¤…à¤‚à¤¤ à¤…à¤µà¤§à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(281296,7814,'ms','Akhir tempoh tarikh',0),(281297,7814,'ar','Ø¨Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø© Ù…Ù† ØªØ§Ø±ÙŠØ®',0),(281298,7814,'fr','Fin de la pÃ©riode Date',0),(281299,7814,'jp','æœŸé–“ã®çµ‚ã‚ã‚Šã¾ã§',0),(281300,7814,'pt','Fim do perÃ­odo data',0),(281301,7814,'ru','Ðš ÐºÐ¾Ð½Ñ†Ñƒ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð”Ð°Ñ‚Ð°',0),(281302,7814,'es','Por Fecha de Fin de PeriÃ³do',0),(281303,7814,'de','Bis Ende der Periode Datum',0),(281304,7814,'en','By End of Period Date',0),(281305,7815,'is','',0),(281306,7815,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(281307,7815,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(281308,7815,'tr','Ã–deme tarihi',0),(281309,7815,'pl','Data wypÅ‚acane',0),(281310,7815,'bg','Ð”Ð°Ñ‚Ð°, Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð°',0),(281311,7815,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(281312,7815,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(281313,7815,'vi','NgÃ y tráº£',0),(281314,7815,'af','Datum Betaal',0),(281315,7815,'ro','Data plÄƒtit',0),(281316,7815,'et','Makse kuupÃ¤ev',0),(281317,7815,'si','Datum, ki se plaÄa',0),(281318,7815,'ba','Tanggal yang dibayar',0),(281319,7815,'nl','Datum betaald',0),(281320,7815,'fi','MaksupÃ¤ivÃ¤',0),(281321,7815,'no','Dato betalt',0),(281322,7815,'da','Dato betales',0),(281323,7815,'ko','ì§€ë¶ˆ ë‚ ì§œ',0),(281324,7815,'he','×ª××¨×™×š ×ª×©×œ×•×',0),(281325,7815,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹',0),(281326,7815,'zh','æ—¥æœŸæ”¯ä»˜\r\n',0),(281327,7815,'sv','Datum betalt',0),(281328,7815,'it','Data di pagamento',0),(281329,7815,'tl','',0),(281330,7815,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;',0),(281331,7815,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿',0),(281332,7815,'ms','Tarikh dibayar',0),(281333,7815,'ar','ØªØ§Ø±ÙŠØ® Ø¯ÙØ¹',0),(281334,7815,'fr','Suivant date de paiement',0),(281335,7815,'jp','æ”¯æ‰•ã„æ—¥ä»˜',0),(281336,7815,'pt','Data de pagamento',0),(281337,7815,'ru','Ð”Ð°Ñ‚Ð° ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(281338,7815,'es','Fecha Pagada',0),(281339,7815,'de','Datum bezahlt',0),(281340,7815,'en','Date Paid',0),(281341,7816,'is','',0),(281342,7816,'dr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ø¯ÙˆØ±Ù‡ Ù‡Ø§',0),(281343,7816,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ø¯ÙˆØ±Ù‡ Ù‡Ø§',0),(281344,7816,'tr','Toplam tÃ¼m dÃ¶nemler',0),(281345,7816,'pl','Suma wszystkich okresÃ³w',0),(281346,7816,'bg','ÐžÐ±Ñ‰Ð¾ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸',0),(281347,7816,'ur','Ú©Ù„ ØªÙ…Ø§Ù… Ø§Ø¯ÙˆØ§Ø±',0),(281348,7816,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÑÐ²Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ðµ',0),(281349,7816,'vi','Tá»•ng cá»™ng táº¥t cáº£ thá»i ká»³',0),(281350,7816,'af','Totaal vir Alle Periodes',0),(281351,7816,'ro','Total toate perioadele',0),(281352,7816,'et','Kokku kÃµikide aegade',0),(281353,7816,'si','Skupaj vsa obdobja',0),(281354,7816,'ba','Jumlah semua periode',0),(281355,7816,'nl','Total alle perioden',0),(281356,7816,'fi','YhteensÃ¤ kaikki kaudet',0),(281357,7816,'no','Sum alle perioder',0),(281358,7816,'da','Samlet alle perioder',0),(281359,7816,'ko','ëª¨ë“  ê¸°ê°„ ì´',0),(281360,7816,'he','×¡×š ×›×œ ×”×ª×§×•×¤×•×ª',0),(281361,7816,'el','Î£ÏÎ½Î¿Î»Î¿ ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ Ï€ÎµÏÎ¹ÏŒÎ´Ï‰Î½',0),(281362,7816,'zh','æ€»è®¡æ‰€æœ‰å‘¨æœŸ\r\n',0),(281363,7816,'sv','Totalt alla perioder',0),(281364,7816,'it','Totale di tutti i periodi',0),(281365,7816,'tl','',0),(281366,7816,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(281367,7816,'hi','à¤•à¥à¤² à¤¸à¤­à¥€ à¤…à¤µà¤§à¤¿à¤¯à¥‹à¤‚',0),(281368,7816,'ms','Jumlah sepanjang tempoh',0),(281369,7816,'ar','Ù…Ø¬Ù…ÙˆØ¹ ÙƒØ§ÙØ© Ø§Ù„ÙØªØ±Ø§Øª Ø§Ù„Ø²Ù…Ù†ÙŠØ©',0),(281370,7816,'fr','Total de toutes les pÃ©riodes',0),(281371,7816,'jp','ã™ã¹ã¦ã®æœŸé–“ã®åˆè¨ˆ',0),(281372,7816,'pt','Total de todos os perÃ­odos',0),(281373,7816,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾ Ð’ÑÐµ ÐŸÐµÑ€Ð¸Ð¾Ð´Ñ‹',0),(281374,7816,'es','Total Todos los PerÃ­odos',0),(281375,7816,'de','Insgesamt alle Perioden',0),(281376,7816,'en','Total All Periods',0),(281377,7817,'is','',0),(281378,7817,'dr','Ú†Ù‡ ØªØ§Ø±ÙŠØ®ÙŠ ',0),(281379,7817,'pr','Ú†Ù‡ ØªØ§Ø±ÙŠØ®ÙŠ ',0),(281380,7817,'tr','Hangi tarihi',0),(281381,7817,'pl','DatÄ™',0),(281382,7817,'bg','ÐšÐ¾Ñ Ð´Ð°Ñ‚Ð°',0),(281383,7817,'ur','Ø¬Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(281384,7817,'sr','ÐšÐ¾Ð³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(281385,7817,'vi','NgÃ y nÃ o',0),(281386,7817,'af','Watter Datum',0),(281387,7817,'ro','Care data',0),(281388,7817,'et','Mis kuupÃ¤ev',0),(281389,7817,'si','Kateri datum',0),(281390,7817,'ba','Tanggal mana',0),(281391,7817,'nl','Welke datum',0),(281392,7817,'fi','Jolloin',0),(281393,7817,'no','Hvilken dato',0),(281394,7817,'da','Hvilken dato',0),(281395,7817,'ko','ì–´ëŠ ë‚ ì§œ',0),(281396,7817,'he','×‘×ª××¨×™×š ×‘×•',0),(281397,7817,'el','Î Î¿Ï… Ï‡ÏÎ¿Î½Î¿Î»Î¿Î³Î¿ÏÎ½Ï„Î±Î¹',0),(281398,7817,'zh','è¯¥æ—¥æœŸ\r\n',0),(281399,7817,'sv','Vilket datum',0),(281400,7817,'it','Data alla quale',0),(281401,7817,'tl','',0),(281402,7817,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3652;&#3627;&#3609;',0),(281403,7817,'hi','à¤•à¤¿à¤¸ à¤¤à¤¿à¤¥à¤¿',0),(281404,7817,'ms','Tarikh yang',0),(281405,7817,'ar','Ù‡Ùˆ Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø°ÙŠ',0),(281406,7817,'fr','Date Ã  laquelle',0),(281407,7817,'jp','ã©ã¡ã‚‰ã®æ—¥ä»˜',0),(281408,7817,'pt','Qual data',0),(281409,7817,'ru','ÐšÐ°ÐºÐ°Ñ Ð”Ð°Ñ‚Ð°',0),(281410,7817,'es','Cual Fecha',0),(281411,7817,'de','Welches Datum',0),(281412,7817,'en','Which Date',0),(281413,7818,'is','',0),(281414,7818,'dr','ØªØ§Ø±ÙŠØ® Ø§ØªÙ…Ø§Ù… ',0),(281415,7818,'pr','ØªØ§Ø±ÙŠØ® Ø§ØªÙ…Ø§Ù… ',0),(281416,7818,'tr','Son kullanma tarihi',0),(281417,7818,'pl','Data zakoÅ„czenia',0),(281418,7818,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÑÐ²Ð°Ð½Ðµ',0),(281419,7818,'ur','Ù…Ù†Ø³ÙˆØ®ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(281420,7818,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÐºÐ¸Ð´Ð° Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð¾Ð´Ð½Ð¾ÑÐ°',0),(281421,7818,'vi','NgÃ y Cháº¥m dá»©t',0),(281422,7818,'af','BeÃ«indigingsdatum',0),(281423,7818,'ro','Data de terminare',0),(281424,7818,'et','Lahkumise kuupÃ¤ev',0),(281425,7818,'si','Datum prenehanja',0),(281426,7818,'ba','Tanggal penghentian',0),(281427,7818,'nl','Einddatum',0),(281428,7818,'fi','TyÃ¶suhteen loppumispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(281429,7818,'no','Oppsigelse',0),(281430,7818,'da','Afslutningsdatoen',0),(281431,7818,'ko','ì¢…ë£Œ ë‚ ì§œ',0),(281432,7818,'he','×ª××¨×™×š ×¡×™×•×',0),(281433,7818,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(281434,7818,'zh','ç»ˆæ­¢æ—¥æœŸ\r\n',0),(281435,7818,'sv','UppsÃ¤gningsdatum',0),(281436,7818,'it','Data di cessazione',0),(281437,7818,'tl','',0),(281438,7818,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(281439,7818,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(281440,7818,'ms','Tarikh penamatan',0),(281441,7818,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ù†Ù‡Ø§Ø¡',0),(281442,7818,'fr','Date d\'expiration',0),(281443,7818,'jp','çµ‚äº†æ—¥',0),(281444,7818,'pt','Data de cessaÃ§Ã£o',0),(281445,7818,'ru','Ð”Ð°Ñ‚Ð° ÑƒÐ²Ð¾Ð»ÑŒÐ½ÐµÐ½Ð¸Ñ',0),(281446,7818,'es','Fecha de TerminaciÃ³n',0),(281447,7818,'de','KÃ¼ndigungstermin',0),(281448,7818,'en','Termination Date',0),(281449,7819,'is','',0),(281450,7819,'dr','ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ø³ÙØ§Ø±Ø´',0),(281451,7819,'pr','ØªØºÙŠÙŠØ± Ù‚ÙŠÙ…Øª Ø³ÙØ§Ø±Ø´',0),(281452,7819,'tr','DeÄŸiÅŸiklik sipariÅŸ fiyat',0),(281453,7819,'pl','Zmiana kolejnoÅ›ci cena',0),(281454,7819,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ñ†ÐµÐ½Ð°',0),(281455,7819,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ø¢Ø±ÚˆØ± Ù‚ÛŒÙ…Øª',0),(281456,7819,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ñ†ÐµÐ½Ð°',0),(281457,7819,'vi','Thay Ä‘á»•i giÃ¡ ÄÆ¡n Äáº·t hÃ ng',0),(281458,7819,'af','Verander Bestellingsprys',0),(281459,7819,'ro','Schimbarea comanda Pret',0),(281460,7819,'et','Muutus tellimuse hind',0),(281461,7819,'si','Sprememb da ceno',0),(281462,7819,'ba','Perubahan harga Order',0),(281463,7819,'nl','Verandering bestelling prijs',0),(281464,7819,'fi','Muutoksen aste hinta',0),(281465,7819,'no','Endre rekkefÃ¸lgen pris',0),(281466,7819,'da','Skift rÃ¦kkefÃ¸lge pris',0),(281467,7819,'ko','ë³€ê²½ ì£¼ë¬¸ ê°€ê²©',0),(281468,7819,'he','×©× ×” ×ž×—×™×¨ ×”×–×ž× ×”',0),(281469,7819,'el','Î‘Î»Î»Î±Î³Î® Ï„Î¹Î¼Î®Ï‚ Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(281470,7819,'zh','æ›´æ”¹è®¢å•ä»·æ ¼\r\n',0),(281471,7819,'sv','Ã„ndra ordning pris',0),(281472,7819,'it','Modifica ordine prezzo',0),(281473,7819,'tl','',0),(281474,7819,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3619;&#3634;&#3588;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(281475,7819,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤†à¤¦à¥‡à¤¶ à¤®à¥‚à¤²à¥à¤¯',0),(281476,7819,'ms','Perubahan perintah harga',0),(281477,7819,'ar','ØªØºÙŠÙŠØ± ØªØ±ØªÙŠØ¨ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(281478,7819,'fr','Prix de la commande changement',0),(281479,7819,'jp','å¤‰æ›´ã‚ªãƒ¼ãƒ€ãƒ¼ä¾¡æ ¼',0),(281480,7819,'pt','PreÃ§o da ordem de mudanÃ§a',0),(281481,7819,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ñ†ÐµÐ½',0),(281482,7819,'es','Cambiar Precio de Pedido',0),(281483,7819,'de','Change Order Preis',0),(281484,7819,'en','Change Order Price',0),(281485,7820,'is','',0),(281486,7820,'dr','ÙƒØ¯ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(281487,7820,'pr','ÙƒØ¯ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(281488,7820,'tr','Envanter madde kodu',0),(281489,7820,'pl','Kod towaru w magazynie',0),(281490,7820,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» ÑÐºÐ»Ð°Ð´Ð°',0),(281491,7820,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ú©ÙˆÚˆ',0),(281492,7820,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(281493,7820,'vi','MÃ£ sá»‘ hÃ ng hÃ³a',0),(281494,7820,'af','Voorraad Item Kode',0),(281495,7820,'ro','Cod articol Inventar',0),(281496,7820,'et','Tootekood',0),(281497,7820,'si','Å ifra artikla zaloge',0),(281498,7820,'ba','Kode barang persediaan',0),(281499,7820,'nl','Inventaris Artikelcode',0),(281500,7820,'fi','Varaston nimikkeen koodi',0),(281501,7820,'no','Lager Varekode',0),(281502,7820,'da','Lageret varekode',0),(281503,7820,'ko','ìž¬ê³  í’ˆëª© ì½”ë“œ',0),(281504,7820,'he','×§×•×“ ×¤×¨×™×˜ ×ž×œ××™',0),(281505,7820,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(281506,7820,'zh','åº“å­˜äº§å“ä»£ç \r\n',0),(281507,7820,'sv','Inventering Artikelkod',0),(281508,7820,'it','Codice articolo magazzino',0),(281509,7820,'tl','',0),(281510,7820,'th','&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(281511,7820,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡',0),(281512,7820,'ms','Kod Item stok',0),(281513,7820,'ar','ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù ÙÙŠ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(281514,7820,'fr','Code d\'article de l\'inventaire',0),(281515,7820,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªé …ç›®ã‚³ãƒ¼ãƒ‰',0),(281516,7820,'pt','CÃ³digo do Item de inventÃ¡rio',0),(281517,7820,'ru','ÐšÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(281518,7820,'es','CÃ³digo de Item de Inventario',0),(281519,7820,'de','Inventar-Feld-Code',0),(281520,7820,'en','Inventory Item Code',0),(281521,7821,'is','',0),(281522,7821,'dr','Ø®Ø§Ø±Ø¬ Ø¯Ø± Ù…Ø¯Ø±Ùƒ â€“ Ú†Ø§Ù¾ Ø®Ø§Ø±Ø¬ Ø§Ø² ÙØ±Ù… ',0),(281523,7821,'pr','Ø®Ø§Ø±Ø¬ Ø¯Ø± Ù…Ø¯Ø±Ùƒ â€“ Ú†Ø§Ù¾ Ø®Ø§Ø±Ø¬ Ø§Ø² ÙØ±Ù… ',0),(281524,7821,'tr','Out Proof-baskÄ± formu kapatmak iÃ§in',0),(281525,7821,'pl','Na dowÃ³d Drukuj siÄ™ formy',0),(281526,7821,'bg','ÐšÑŠÐ¼ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾-Ð¿ÐµÑ‡Ð°Ñ‚ Ñ€Ð°Ð·ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ñ„Ð¾Ñ€Ð¼Ð°',0),(281527,7821,'ur','Ø¢Ø¤Ù¹ Ø¢Ù ÙØ§Ø±Ù… Ú©Ø§ Ø«Ø¨ÙˆØª-Ù¾Ø±Ù†Ù¹ Ú©Û’ Ù„ÛŒÛ’',0),(281528,7821,'sr','Ð”Ð° Ñ˜Ðµ Ð´Ð¾ÐºÐ°Ð·-Ð¾Ñ‚Ð¸ÑÐ°Ðº Ð¿Ñ€ÑÑ‚Ð° ÑÐ° Ð¾Ð±Ñ€Ð°ÑÑ†Ð°',0),(281529,7821,'vi','NgoÃ i báº£n in thá»­ - In tá»«',0),(281530,7821,'af','Uit om te bewys-druk af vorm',0),(281531,7821,'ro','AfarÄƒ la dovada de imprimare de pe formularul de',0),(281532,7821,'et','Out Proof-Prindi vÃ¤lja vormi',0),(281533,7821,'si','Ven dokaz-Print Off obliki',0),(281534,7821,'ba','Untuk bukti cetak dari bentuk',0),(281535,7821,'nl','Out to bewijs-Print uit vorm',0),(281536,7821,'fi','Ulos Proof-Print lomake',0),(281537,7821,'no','Ut til korrekturutskrift av',0),(281538,7821,'da','Ud til Proof-Print ud Form',0),(281539,7821,'ko','ì–‘ì‹ì—ì„œ ì¦ê±° ì¸ì‡„ë¥¼',0),(281540,7821,'he','×‘×—×•×¥ ×¢×œ ×”×•×›×—×”-×”×“×¤×¡ ××ª ×”×˜×•×¤×¡',0),(281541,7821,'el','ÎˆÎ¾Ï‰ Î½Î± Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î·-Print Î¼Î±ÎºÏÎ¹Î¬ Î¼Î¿ÏÏ†Î®',0),(281542,7821,'zh','å‡ºè¯æ˜Ž-æ™’å°è¡¨æ ¼\r\n',0),(281543,7821,'sv','Ut till korrekturutskrift av Form',0),(281544,7821,'it','A prova-stampa fuori forma',0),(281545,7821,'tl','',0),(281546,7821,'th','&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3627;&#3621;&#3633;&#3585;&#3600;&#3634;&#3609; - &#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3614;&#3636;&#3617;&#3614;&#3660;&#3615;&#3629;&#3619;&#3660;&#3617;',0),(281547,7821,'hi','à¤¸à¤¬à¥‚à¤¤-à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤¬à¤‚à¤¦ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¾à¤¹à¤°',0),(281548,7821,'ms','Keluar untuk cetak bukti Off borang',0),(281549,7821,'ar','Ù„Ø·Ø¨Ø§Ø¹Ø© Ø¯Ù„ÙŠÙ„ Ø¹Ù„Ù‰ Ø¥ÙŠÙ‚Ø§Ù ØªØ´ØºÙŠÙ„ Ø§Ù„Ù†Ù…ÙˆØ°Ø¬',0),(281550,7821,'fr','Sortir Ã  impression Proof formulaire',0),(281551,7821,'jp','æ ¡æ­£å°åˆ·ãƒ•ã‚©ãƒ¼ãƒ ã‚’ã‚ªãƒ•ã«',0),(281552,7821,'pt','A prova de impressÃ£o fora de forma',0),(281553,7821,'ru','Ð’ Ð´Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð¾Ñ‚ Ñ„Ð¾Ñ€Ð¼Ñ‹',0),(281554,7821,'es','Fuera para Prueba de ImpresiÃ³n-Imprimir del Formulario',0),(281555,7821,'de','Out to Proof-Print Formular ab',0),(281556,7821,'en','Out to Proof-Print Off Form',0),(281557,7822,'is','',0),(281558,7822,'dr','Ø«Ø¨Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø®Ø±ÙŠØ¯   ÙŠØ§   Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ',0),(281559,7822,'pr','Ø«Ø¨Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø®Ø±ÙŠØ¯   ÙŠØ§   Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ',0),(281560,7822,'tr','SatÄ±nalma isteÄŸi giriÅŸi veya gÃ¼ncelleÅŸtirme',0),(281561,7822,'pl','Wpis Å¼Ä…danie zakupu lub aktualizacji',0),(281562,7822,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð¸Ð»Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(281563,7822,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù†Ø¯Ø±Ø§Ø¬ ÛŒØ§ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(281564,7822,'sr','ÐÐ°Ð±Ð°Ð²ÐºÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° ÑƒÐ½Ð¾Ñ Ð¸Ð»Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(281565,7822,'vi','Nháº­p hay Cáº­p Nháº­t YÃªu Cáº§u Mua',0),(281566,7822,'af','Aankoop Aanvraag Invoer of Opdatering',0),(281567,7822,'ro','Cumparare cerere intrare sau actualizare',0),(281568,7822,'et','Ostukande taotluse vÃµi Update',0),(281569,7822,'si','Nakup zahteva vnos ali posodobitev',0),(281570,7822,'ba','Pembelian permintaan masuk atau Update',0),(281571,7822,'nl','Verzoek inkooppost of Update',0),(281572,7822,'fi','PyynnÃ¶n ostotapahtumaan tai pÃ¤ivitys',0),(281573,7822,'no','ForespÃ¸rsel kjÃ¸psposten eller oppdatering',0),(281574,7822,'da','KÃ¸b anmodningsposten eller opdatering',0),(281575,7822,'ko','êµ¬ë§¤ ìš”ì²­ í•­ëª© ë˜ëŠ” ì—…ë°ì´íŠ¸',0),(281576,7822,'he','×¢×¨×š ×‘×§×©×ª ×¨×›×™×©×” ××• ×¢×“×›×•×Ÿ',0),(281577,7822,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î±Î¹Ï„Î®Î¼Î±Ï„Î¿Ï‚ Î±Î³Î¿ÏÎ¬Ï‚ Î® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(281578,7822,'zh','é‡‡è´­ç”³è¯·æ¡è¾“å…¥æˆ–æ›´æ–°\r\n',0),(281579,7822,'sv','InkÃ¶pstransaktionen begÃ¤ran eller uppdatering',0),(281580,7822,'it','Voce della richiesta di acquisto o aggiornamento',0),(281581,7822,'tl','',0),(281582,7822,'th','&#3611;&#3657;&#3629;&#3609;&#3627;&#3619;&#3639;&#3629;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(281583,7822,'hi','à¤–à¤°à¥€à¤¦ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¯à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(281584,7822,'ms','Kemasukan permintaan pembelian atau kemas kini',0),(281585,7822,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø£Ùˆ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(281586,7822,'fr','Saisie de demande dâ€™achat ou de mise Ã  jour',0),(281587,7822,'jp','è³¼å…¥ä¾é ¼ã®å…¥åŠ›ã¾ãŸã¯æ›´æ–°',0),(281588,7822,'pt','Entrada de pedido de compra ou atualizaÃ§Ã£o',0),(281589,7822,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ Ð¸Ð»Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(281590,7822,'es','Pedido de Compra Introducir o Actualizar',0),(281591,7822,'de','Kauf-Anfrage-Eingabe oder Aktualisierung',0),(281592,7822,'en','Purchase Request Entry or Update',0),(281593,7823,'is','',0),(281594,7823,'dr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… ',0),(281595,7823,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… ',0),(281596,7823,'tr','TÃ¼m toplam',0),(281597,7823,'pl','Suma wszystkich',0),(281598,7823,'bg','ÐžÐ±Ñ‰Ð¾ Ð²ÑÐ¸Ñ‡ÐºÐ¾',0),(281599,7823,'ur','Ú©Ù„ ØªÙ…Ø§Ù…',0),(281600,7823,'sr','Ð¡Ð²Ðµ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(281601,7823,'vi','Táº¥t cáº£ Tá»•ng cá»™ng',0),(281602,7823,'af','Totale al',0),(281603,7823,'ro','Total, toate',0),(281604,7823,'et','Kokku kÃµik',0),(281605,7823,'si','Vse skupaj',0),(281606,7823,'ba','Jumlah semua',0),(281607,7823,'nl','Totale All',0),(281608,7823,'fi','Kaikki',0),(281609,7823,'no','Sum alle',0),(281610,7823,'da','Alt i alt',0),(281611,7823,'ko','ì´ ì „ì²´',0),(281612,7823,'he','×¡×š ×”×›×œ',0),(281613,7823,'el','Î£Ï…Î³Ï‡ÏÎ¿Î½Î± Î´Î¹Î±ÎºÎ¿ÏƒÎ¼Î·Î¼Î­Î½ÎµÏ‚',0),(281614,7823,'zh','æ€»é¢æ‰€æœ‰\r\n',0),(281615,7823,'sv','Totalt alla',0),(281616,7823,'it','Totale All',0),(281617,7823,'tl','',0),(281618,7823,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(281619,7823,'hi','à¤•à¥à¤² à¤¸à¤¬',0),(281620,7823,'ms','Jumlah semua',0),(281621,7823,'ar','Ù…Ø¬Ù…ÙˆØ¹ ÙƒÙ„',0),(281622,7823,'fr','Total tous',0),(281623,7823,'jp','ã™ã¹ã¦ã‚’åˆè¨ˆã—ã¾ã™ã€‚',0),(281624,7823,'pt','Total de todos',0),(281625,7823,'ru','Ð’ÑÐµÐ³Ð¾ Ð²ÑÐµ',0),(281626,7823,'es','Total de Todo',0),(281627,7823,'de','Insgesamt alle',0),(281628,7823,'en','Total All',0),(281629,7824,'is','',0),(281630,7824,'dr','Ù…Ø¨Ù„Øº ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(281631,7824,'pr','Ù…Ø¨Ù„Øº ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(281632,7824,'tr','Workmans Comp Amt',0),(281633,7824,'pl','Amt Workmans zÅ‚',0),(281634,7824,'bg','Workmans Comp Amt',0),(281635,7824,'ur','ÙˆÙˆØ±Ú©Ù…Ø¢Ù†Ø³ Ú©Ø¹Ù…Ù¾ Ø§Ù…Ù¹',0),(281636,7824,'sr','Ð Ð•Ð¤ . Ð’Ð°Ð» WÐ¾Ñ€ÐºÐ¼Ð°Ð½Ñ Ð¦Ð¾Ð¼Ð¿.',0),(281637,7824,'vi','Sá»‘ tiá»n CÃ´ng nhÃ¢n Comp',0),(281638,7824,'af','Vergoedingskommisaris Bedrag',0),(281639,7824,'ro','Workmans Comp Amt',0),(281640,7824,'et','*Workmans Comp Amt',0),(281641,7824,'si','Workmans Comp Amt',0),(281642,7824,'ba','Workmans Comp Amt',0),(281643,7824,'nl','Workmans Comp Amt',0),(281644,7824,'fi','Workmans Comp Amt',0),(281645,7824,'no','Workmans Comp Amt',0),(281646,7824,'da','Workmans Comp Amt',0),(281647,7824,'ko','Workmans Comp Amt',0),(281648,7824,'he','Workmans Comp Amt',0),(281649,7824,'el','Workmans Comp Amt',0),(281650,7824,'zh','å·¥ä½œä¿é™©é‡‘é¢\r\n',0),(281651,7824,'sv','Workmans Comp Amt',0),(281652,7824,'it','Workmans Comp Amt',0),(281653,7824,'tl','',0),(281654,7824,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;&#3594;&#3604;&#3648;&#3594;&#3618;',0),(281655,7824,'hi','Workmans à¤•à¤‚à¤ª Amt',0),(281656,7824,'ms','Workmans Comp Amt',0),(281657,7824,'ar','Ø´Ø±ÙƒØ§Øª ÙˆÙˆØ±ÙƒÙ…Ø§Ù†Ø³ Amt',0),(281658,7824,'fr','Amt Comp accidentÃ©s',0),(281659,7824,'jp','æµå¤± Comp Amt',0),(281660,7824,'pt','Direitoa Comp Amt',0),(281661,7824,'ru','Workmans Comp Amt',0),(281662,7824,'es','Comp. trabajador Amt',0),(281663,7824,'de','Workmans Comp Amt',0),(281664,7824,'en','Workmans Comp Amt',0),(281665,7825,'is','',0),(281666,7825,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(281667,7825,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(281668,7825,'tr','Workmans Comp raporu',0),(281669,7825,'pl','Raport Workmans zÅ‚',0),(281670,7825,'bg','Workmans Comp Ð´Ð¾ÐºÐ»Ð°Ð´',0),(281671,7825,'ur','ÙˆÙˆØ±Ú©Ù…Ø¢Ù†Ø³ Ú©Ø¹Ù…Ù¾ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(281672,7825,'sr','WÐ¾Ñ€ÐºÐ¼Ð°Ð½Ñ Ð¦Ð¾Ð¼Ð¿ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(281673,7825,'vi','BÃ¡o cÃ¡o cÃ´ng viá»‡c',0),(281674,7825,'af','Vergoedingskommisaris Verslag',0),(281675,7825,'ro','Raport de Comp Workmans',0),(281676,7825,'et','TÃ¶Ã¶lise kompensatsiooni aruanne',0),(281677,7825,'si','Workmans Comp poroÄilo',0),(281678,7825,'ba','Laporan Comp Workmans',0),(281679,7825,'nl','Workmans Comp verslag',0),(281680,7825,'fi','Workmans Comp raportti',0),(281681,7825,'no','Workmans kompakt rapport',0),(281682,7825,'da','Workmans Comp rapport',0),(281683,7825,'ko','Workmans ê´‘ê³  ë³´ê³ ì„œ',0),(281684,7825,'he','Workmans ×¢×•×‘×“×™× ×”×“×•×—',0),(281685,7825,'el','Workmans Comp Î­ÎºÎ¸ÎµÏƒÎ·',0),(281686,7825,'zh','å·¥äººèµ”å¿æŠ¥å‘Š\r\n',0),(281687,7825,'sv','Workmans Comp rapport',0),(281688,7825,'it','Rapporto di Comp workmans',0),(281689,7825,'tl','',0),(281690,7825,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(281691,7825,'hi','Workmans à¤•à¤‚à¤ª à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(281692,7825,'ms','Laporan Comp Workmans',0),(281693,7825,'ar','ØªÙ‚Ø±ÙŠØ± Ø´Ø±ÙƒØ§Øª ÙˆÙˆØ±ÙƒÙ…Ø§Ù†Ø³',0),(281694,7825,'fr','Rapport maquette accidentÃ©s',0),(281695,7825,'jp','æµå¤± Comp ãƒ¬ãƒãƒ¼ãƒˆ',0),(281696,7825,'pt','Direitoa Comp relatÃ³rio',0),(281697,7825,'ru','Ð”Ð¾ÐºÐ»Ð°Ð´ Comp Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð²',0),(281698,7825,'es','Informe de CompensaciÃ³n al Trabajador ',0),(281699,7825,'de','Workmans Comp Bericht',0),(281700,7825,'en','Workmans Comp Report',0),(281701,7826,'is','',0),(281702,7826,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´',0),(281703,7826,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´',0),(281704,7826,'tr','SatÄ±ÅŸ kategorileri ekleyin/gÃ¼ncelleyin',0),(281705,7826,'pl','SprzedaÅ¼y kategorii Dodaj/Aktualizuj',0),(281706,7826,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(281707,7826,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø²Ù…Ø±ÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(281708,7826,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°Ð¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(281709,7826,'vi','ThÃªm/Cáº­p Nháº­t thá»ƒ loáº¡i bÃ¡n hÃ ng',0),(281710,7826,'af','VerkoopskategoriÃ« Skep/Opdateer',0),(281711,7826,'ro','VÃ¢nzÄƒri categorii AdÄƒugaÅ£i/actualizaÅ£i',0),(281712,7826,'et','Tootekategooria lisamine/uuendamine',0),(281713,7826,'si','Prodaja kategorije Dodaj/posodobi',0),(281714,7826,'ba','Tambah/Perbarui Kategori Penjualan',0),(281715,7826,'nl','Verkoopcategorie toevoegen/bijwerken',0),(281716,7826,'fi','Myynnin luokat lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(281717,7826,'no','Salg kategorier/Oppdater',0),(281718,7826,'da','Salg kategorier TilfÃ¸j/opdater',0),(281719,7826,'ko','íŒë§¤ ì¹´í…Œê³ ë¦¬ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(281720,7826,'he','×”×•×¡×¤×”/×¢×“×›×•×Ÿ ×§×˜×’×•×¨×™×•×ª ×ž×›×™×¨×”',0),(281721,7826,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(281722,7826,'zh','é”€å”®ç±»åˆ«æ–°å¢ž/æ›´æ–°\r\n',0),(281723,7826,'sv','FÃ¶rsÃ¤ljningskategori LÃ¤gg till/uppdatera',0),(281724,7826,'it','Categorie vendite aggiungere/aggiornare',0),(281725,7826,'tl','',0),(281726,7826,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(281727,7826,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(281728,7826,'ms','Kategori jualan Tambah/Kemaskini',0),(281729,7826,'ar','ÙØ¦Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(281730,7826,'fr','CatÃ©gories vente ajouter/mettre Ã  jour',0),(281731,7826,'jp','è²©å£²ã‚«ãƒ†ã‚´ãƒªã‚’è¿½åŠ /æ›´æ–°',0),(281732,7826,'pt','Categorias vendas adicionar/atualizar',0),(281733,7826,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ ÐŸÑ€Ð¾Ð´Ð°Ð¶ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(281734,7826,'es','CategorÃ­as de Ventas Agregar/Actualizar',0),(281735,7826,'de','Vertrieb Kategorien hinzufÃ¼gen/aktualisieren',0),(281736,7826,'en','Sales Categories Add/Update',0),(281737,7827,'is','',0),(281738,7827,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´',0),(281739,7827,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  ÙØ±Ø¢ÙŠÙ†Ø¯ ÙØ±ÙˆØ´',0),(281740,7827,'tr','Ä°ÅŸlem Ekle/GÃ¼ncelle',0),(281741,7827,'pl','Proces Dodaj/Aktualizuj',0),(281742,7827,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑÐ° Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(281743,7827,'ur','Ø¹Ù…Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(281744,7827,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(281745,7827,'vi','Xá»­ LÃ½ ThÃªm/Cáº­p Nháº­t',0),(281746,7827,'af','Proses Skep/Opdateer',0),(281747,7827,'ro','Procesul AdÄƒugaÅ£i/actualizaÅ£i',0),(281748,7827,'et','Protsessi lisamine/uuendamine',0),(281749,7827,'si','Proces Dodaj/posodobi',0),(281750,7827,'ba','Proses Tambahkan/Perbarui',0),(281751,7827,'nl','Proces toevoegen/bijwerken',0),(281752,7827,'fi','Prosessi lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(281753,7827,'no','Prosessen/Oppdater',0),(281754,7827,'da','Processen TilfÃ¸j/opdater',0),(281755,7827,'ko','í”„ë¡œì„¸ìŠ¤ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(281756,7827,'he','×”×•×¡×£/×¢×“×›×Ÿ ×ª×”×œ×™×š',0),(281757,7827,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(281758,7827,'zh','å¤„ç†æ–°å¢ž/æ›´æ–°\r\n',0),(281759,7827,'sv','Processen LÃ¤gg till/uppdatera',0),(281760,7827,'it','Aggiungere/aggiornare un processo',0),(281761,7827,'tl','',0),(281762,7827,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;',0),(281763,7827,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(281764,7827,'ms','Proses Tambah/Kemaskini',0),(281765,7827,'ar','Ø¹Ù…Ù„ÙŠØ© Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(281766,7827,'fr','Processus ajouter/mettre Ã  jour',0),(281767,7827,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã‚’è¿½åŠ /æ›´æ–°',0),(281768,7827,'pt','Adicionar/atualizar do processo',0),(281769,7827,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(281770,7827,'es','Proceso Agregar/Actualizar',0),(281771,7827,'de','Prozess hinzufÃ¼gen/aktualisieren',0),(281772,7827,'en','Process Add/Update',0),(281773,7828,'is','',0),(281774,7828,'dr','(Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ) ÙØ±ÙˆØ´ ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(281775,7828,'pr','Ø«Ø¨Øª Ø¯Ù†Ø¨Ø§Ù„ ÙƒÙ†Ù†Ø¯Ù‡ (Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ) ÙØ±ÙˆØ´ ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(281776,7828,'tr','SatÄ±ÅŸ izci GiriÅŸi Ekle',0),(281777,7828,'pl','Wstawianie wpisu sprzedaÅ¼y holownik',0),(281778,7828,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Tracker Ð·Ð°Ð¿Ð¸Ñ Ð’Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ',0),(281779,7828,'ur','Ø³ÛŒÙ„Ø² Ù¹Ø±ÛŒÚ©Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(281780,7828,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ñ‚Ñ€Ð°Ð³Ð°Ñ‡',0),(281781,7828,'vi','ChÃ¨n Entry TÃ¬m Kiáº¿m Sales',0),(281782,7828,'af','Verkope Tracker inskrywing insetsel',0),(281783,7828,'ro','Inserare intrare vÃ¢nzÄƒri Tracker',0),(281784,7828,'et','MÃ¼Ã¼gi Tracker kirje lisamine',0),(281785,7828,'si','Vstavi vnos prodaje Tracker',0),(281786,7828,'ba','Penjualan Tracker entri Insert',0),(281787,7828,'nl','Verkoop Tracker Entry invoegen',0),(281788,7828,'fi','Myynnin Tracker merkintÃ¤ lisÃ¤Ã¤',0),(281789,7828,'no','Salg Tracker oppfÃ¸ring sett inn',0),(281790,7828,'da','Salg Tracker post IndsÃ¦t',0),(281791,7828,'ko','íŒë§¤ ì¶”ì  í•­ëª© ì‚½ìž…',0),(281792,7828,'he','×”×•×¡×£ ×¢×¨×š ×ž×¢×§×‘ ×ž×›×™×¨×•×ª',0),(281793,7828,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… Tracker Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(281794,7828,'zh','é”€å”®è·Ÿè¸ªæ¡ç›®æ’å…¥\r\n',0),(281795,7828,'sv','FÃ¶rsÃ¤ljning Tracker intrÃ¤de infoga',0),(281796,7828,'it','Inserisci voce vendite Tracker',0),(281797,7828,'tl','',0),(281798,7828,'th','&#3649;&#3607;&#3619;&#3585;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(281799,7828,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤Ÿà¥à¤°à¥ˆà¤•à¤° à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(281800,7828,'ms','Masukkan entri Tracker jualan',0),(281801,7828,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø¥Ø¯Ø®Ø§Ù„ ØªØ¹Ù‚Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(281802,7828,'fr','Tracker vente entrÃ©e Insert',0),(281803,7828,'jp','è²©å£²ãƒˆãƒ©ãƒƒã‚«ãƒ¼ ã‚¨ãƒ³ãƒˆãƒªæŒ¿å…¥',0),(281804,7828,'pt','Tracker vendas entrada Insert',0),(281805,7828,'ru','Ð’ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ñ‚Ñ€ÐµÐºÐµÑ€',0),(281806,7828,'es','Rastreador de Ventas Insertar Entrada',0),(281807,7828,'de','Sales Tracker Eintrag einfÃ¼gen',0),(281808,7828,'en','Sales Tracker Entry Insert',0),(281809,7829,'is','',0),(281810,7829,'dr','Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø´Ø¯ Ø§Ù…Ø§ Ø³ÙØ§Ø±Ø´Ø§Øª Ù†ÙŠØ³Øª',0),(281811,7829,'pr','Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø´Ø¯ Ø§Ù…Ø§ Ø³ÙØ§Ø±Ø´Ø§Øª Ù†ÙŠØ³Øª',0),(281812,7829,'tr','HiÃ§bir sipariÅŸ girilen saat',0),(281813,7829,'pl','Wprowadzonego ale nie zeby',0),(281814,7829,'bg','Ð§Ð°ÑÐ°, Ð²ÑŠÐ²ÐµÐ»Ð¸, Ð½Ð¾ Ð½Ð¸ÐºÐ°ÐºÑŠÐ² Ñ€ÐµÐ´',0),(281815,7829,'ur','Ú¯Ú¾Ù†Ù¹ÙˆÚº Ø­Ú©Ù… Ù†ÛÛŒÚº ØªÚ¾Ø§ Ù„ÛŒÚ©Ù† Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(281816,7829,'sr','Ð¡Ð°Ñ‚Ð¸ ÑƒÑˆÐ°Ð¾ Ð°Ð»Ð¸ Ð½ÐµÐ¼Ð° Ñ€ÐµÐ´Ð°',0),(281817,7829,'vi','Thá»i gian Ä‘Ã£ nháº­p nhÆ°ng khÃ´ng cÃ³ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(281818,7829,'af','Ure Ingevoer Maar Geen Bestelling',0),(281819,7829,'ro','Intrat dar nici un ordin de ore',0),(281820,7829,'et','Kuid ei jÃ¤rjekorras sisestatud tundide',0),(281821,7829,'si','Uri zaÄel Å¡ele ne naloga',0),(281822,7829,'ba','Jam masuk tetapi tanpa urutan',0),(281823,7829,'nl','Uren ingevoerd maar geen orde',0),(281824,7829,'fi','Mutta missÃ¤Ã¤n jÃ¤rjestyksessÃ¤ tunnit',0),(281825,7829,'no','Timer men ingen rekkefÃ¸lge',0),(281826,7829,'da','Timer angivet men ingen ordre',0),(281827,7829,'ko','í•˜ì§€ë§Œ ìˆœì„œ ì—†ì´ ìž…ë ¥ ì‹œê°„',0),(281828,7829,'he','×”×©×¢×•×ª ×©×”×•×–× ×• ××‘×œ ××™×Ÿ ×¡×“×¨',0),(281829,7829,'el','ÎÏÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯, Î±Î»Î»Î¬ ÎºÎ±Î¼Î¯Î± Î´Î¹Î±Ï„Î±Î³Î®',0),(281830,7829,'zh','æ—¶é—´è¾“å…¥ä½†æ²¡æœ‰é¡ºåº\r\n',0),(281831,7829,'sv','Timmar som angetts men ingen ordning',0),(281832,7829,'it','Ore entrati ma nessun ordine',0),(281833,7829,'tl','',0),(281834,7829,'th','&#3648;&#3623;&#3621;&#3634;&#3648;&#3586;&#3657;&#3634;&#3649;&#3605;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(281835,7829,'hi','à¤˜à¤‚à¤Ÿà¤¾ à¤²à¥‡à¤•à¤¿à¤¨ à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾',0),(281836,7829,'ms','Jam dimasukkan tetapi tiada perintah',0),(281837,7829,'ar','Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ ÙˆÙ„ÙƒÙ† Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø£Ù…Ø±',0),(281838,7829,'fr','Heures entrÃ©s mais aucun ordre',0),(281839,7829,'jp','ãªã„æ³¨æ–‡ãŒå…¥åŠ›ã•ã‚ŒãŸæ™‚é–“',0),(281840,7829,'pt','Horas entradas mas nenhuma ordem',0),(281841,7829,'ru','Ð§Ð°ÑÐ¾Ð², Ð²Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ñ… Ð½Ð¾ Ð½Ðµ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(281842,7829,'es','Horas Entradas pero No Hay Orden',0),(281843,7829,'de','Stunden ging aber keine Bestellung',0),(281844,7829,'en','Hours Entered But No Order',0),(281845,7830,'is','',0),(281846,7830,'dr','Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø´Ø¯ Ø§Ù…Ø§ ÙƒØ§Ø± Ú¯Ø±ÙŠ  Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ù†ÙŠØ³Øª ',0),(281847,7830,'pr','Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø´Ø¯ Ø§Ù…Ø§ ÙƒØ§Ø± Ú¯Ø±ÙŠ  Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ù†ÙŠØ³Øª ',0),(281848,7830,'tr','HiÃ§bir alt sipariÅŸ iÃ§in girilen saat',0),(281849,7830,'pl','Wprowadzonego ale Å¼aden pracownik na zamÃ³wienie',0),(281850,7830,'bg','Ð§Ð°ÑÐ°, Ð²ÑŠÐ²ÐµÐ»Ð¸, Ð½Ð¾ Ð½Ð¸ÐºÐ¾Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(281851,7830,'ur','Ù„ÛŒÚ©Ù† Ú©ÙˆØ¦ÛŒ Ú©Ø§Ø±Ú©Ù† Ú©ÛŒÙ„Ø¦Û’ Ø¢Ø±ÚˆØ± Ø¯Ø§Ø®Ù„ Ú¯Ú¾Ù†Ù¹Û’',0),(281852,7830,'sr','Ð¡Ð°Ñ‚Ð¸ ÑƒÑˆÐ°Ð¾ Ð°Ð»Ð¸ Ð½ÐµÐ¼Ð° Ñ€Ð°Ð´Ð½Ð¸Ðº Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(281853,7830,'vi','Thá»i gian Ä‘Ã£ nháº­p nhÆ°ng khÃ´ng cÃ³ cÃ´ng nhÃ¢n cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(281854,7830,'af','Ure Ingevoer Maar Geen Werker Vir Bestelling',0),(281855,7830,'ro','Ore intrat dar nici un lucrÄƒtor pentru comanda',0),(281856,7830,'et','Kuid Ã¼kski tÃ¶Ã¶taja tellimuse puhul sisestatud tundide',0),(281857,7830,'si','Ure zaÄel pa noben delavec za nalog',0),(281858,7830,'ba','Jam masuk tetapi tidak ada pekerja untuk Order',0),(281859,7830,'nl','Uren ingevoerd maar geen enkele werknemer voor Order',0),(281860,7830,'fi','Mutta yksikÃ¤Ã¤n tyÃ¶ntekijÃ¤ jotta tunnit',0),(281861,7830,'no','Timer angitt men ingen arbeideren For ordre',0),(281862,7830,'da','Timer angivet men ingen arbejdstager For ordre',0),(281863,7830,'ko','ì‹œê°„ ìˆœì„œë¥¼ ìœ„í•œ ì•„ë¬´ ìž‘ì—…ìžë§Œ ìž…ë ¥',0),(281864,7830,'he','×”×©×¢×•×ª ×©×”×•×–× ×• ××‘×œ ×œ× ×¢×•×‘×“ ×¢×‘×•×¨ ×”×–×ž× ×”',0),(281865,7830,'el','ÎÏÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯ Î±Î»Î»Î¬ ÎºÎ±Î½Î­Î½Î±Ï‚ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(281866,7830,'zh','æ—¶é—´è¾“å…¥ä½†æ²¡æœ‰å·¥äººé¡ºåº\r\n',0),(281867,7830,'sv','Timmar men ingen arbetstagare har angett fÃ¶r ordern',0),(281868,7830,'it','Ore inserite ma nessun lavoratore per ordine',0),(281869,7830,'tl','',0),(281870,7830,'th','&#3648;&#3623;&#3621;&#3634;&#3648;&#3586;&#3657;&#3634;&#3649;&#3605;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3612;&#3641;&#3657;&#3607;&#3635;&#3591;&#3634;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(281871,7830,'hi','à¤²à¥‡à¤•à¤¿à¤¨ à¤•à¥‹à¤ˆ à¤•à¤¾à¤°à¥à¤¯à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤˜à¤‚à¤Ÿà¥‡',0),(281872,7830,'ms','Jam dimasukkan tetapi tiada pekerja untuk perintah',0),(281873,7830,'ar','Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ ÙˆÙ„ÙƒÙ† Ø£ÙŠ Ø¹Ø§Ù…Ù„ Ù„Ù„Ù†Ø¸Ø§Ù…',0),(281874,7830,'fr','Heures entrÃ©s mais aucun travailleur pour ordre',0),(281875,7830,'jp','æ³¨æ–‡ã®ãªã„åŠ´åƒè€…ãŒå…¥åŠ›ã•ã‚ŒãŸæ™‚é–“',0),(281876,7830,'pt','Horas entradas mas nenhum trabalhador por ordem',0),(281877,7830,'ru','Ð§Ð°ÑÐ¾Ð², Ð²Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ñ… Ð½Ð¾ Ð½Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(281878,7830,'es','Horas Entradas Pero No Hay Trabajador Para el Orden',0),(281879,7830,'de','Stunden ging aber keinem Arbeitnehmer fÃ¼r Bestellung',0),(281880,7830,'en','Hours Entered But No Worker For Order',0),(281881,7831,'is','',0),(281882,7831,'dr','Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø´Ø¯ Ø§Ù…Ø§ Ù†ÙˆØ¹ ÙƒØ§Ø±  Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ù†ÙŠØ³Øª',0),(281883,7831,'pr','Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø´Ø¯ Ø§Ù…Ø§ Ù†ÙˆØ¹ ÙƒØ§Ø±  Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ù†ÙŠØ³Øª',0),(281884,7831,'tr','HiÃ§bir WorkType sipariÅŸ iÃ§in girilen saat',0),(281885,7831,'pl','Wprowadzonego ale nie WorkType na zamÃ³wienie',0),(281886,7831,'bg','Ð§Ð°ÑÐ°, Ð²ÑŠÐ²ÐµÐ»Ð¸, Ð½Ð¾ Ð½Ðµ WorkType Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(281887,7831,'ur','Ù„ÛŒÚ©Ù† Ú©ÙˆØ¦ÛŒ ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ Ú©ÛŒÙ„Ø¦Û’ Ø¢Ø±ÚˆØ± Ø¯Ø§Ø®Ù„ Ú¯Ú¾Ù†Ù¹Û’',0),(281888,7831,'sr','Ð¡Ð°Ñ‚Ð¸ ÑƒÑˆÐ°Ð¾ Ð°Ð»Ð¸ Ð½ÐµÐ¼Ð° WÐ¾Ñ€ÐºÐ¢yÐ¿Ðµ Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(281889,7831,'vi','Thá»i gian Ä‘Ã£ nháº­p nhÆ°ng khÃ´ng cÃ³ loáº¡i cÃ´ng viá»‡c cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(281890,7831,'af','Ure Ingevoer Maar Geen Werktipe vir Bestelling',0),(281891,7831,'ro','Ore intrat dar nici WorkType pentru comanda',0),(281892,7831,'et','Aga No WorkType tellimuse puhul sisestatud tundide',0),(281893,7831,'si','Uri zaÄel ampak ne WorkType za naroÄilo',0),(281894,7831,'ba','Jam masuk tetapi tidak WorkType untuk Order',0),(281895,7831,'nl','Uren ingevoerd maar geen WorkType voor Order',0),(281896,7831,'fi','Mutta ei WorkType jÃ¤rjestyksessÃ¤ tunnit',0),(281897,7831,'no','Timer angitt men ingen WorkType for ordre',0),(281898,7831,'da','Timer angivet men ingen WorkType for rÃ¦kkefÃ¸lge',0),(281899,7831,'ko','ì‹œê°„ ìˆœì„œë¥¼ ìœ„í•œ ì•„ë¬´ WorkTypeë§Œ ìž…ë ¥',0),(281900,7831,'he','×”×©×¢×•×ª ×©×”×•×–× ×• ××‘×œ ×œ× WorkType ×¢×‘×•×¨ ×”×–×ž× ×”',0),(281901,7831,'el','ÎÏÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯ Î±Î»Î»Î¬ Î´ÎµÎ½ WorkType Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(281902,7831,'zh','æ—¶é—´è¾“å…¥ä½†æ²¡æœ‰æ²»å®‰å·¥ä½œç±»åž‹\r\n',0),(281903,7831,'sv','Timmar in men inga WorkType fÃ¶r bestÃ¤llning',0),(281904,7831,'it','Ore inserite ma non WorkType per ordine',0),(281905,7831,'tl','',0),(281906,7831,'th','&#3648;&#3623;&#3621;&#3634;&#3648;&#3586;&#3657;&#3634;&#3649;&#3605;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3',0),(281907,7831,'hi','à¤²à¥‡à¤•à¤¿à¤¨ à¤•à¥‹à¤ˆ WorkType à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤˜à¤‚à¤Ÿà¥‡',0),(281908,7831,'ms','Jam dimasukkan tetapi tidak WorkType untuk pesanan',0),(281909,7831,'ar','Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ ÙˆÙ„ÙƒÙ† Ù„Ø§ ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ Ù„Ù„Ù†Ø¸Ø§Ù…',0),(281910,7831,'fr','Heures entrÃ©s mais aucune association pour ordre',0),(281911,7831,'jp','æ³¨æ–‡ã®ãªã„ WorkType ãŒå…¥åŠ›ã•ã‚ŒãŸæ™‚é–“',0),(281912,7831,'pt','Horas entradas mas nÃ£o WorkType para a ordem',0),(281913,7831,'ru','Ð§Ð°ÑÐ¾Ð², Ð²Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ñ… Ð½Ð¾ Ð½Ðµ WorkType Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(281914,7831,'es','Horas Entradas Pero No Hay Tipo de Trabajo para el Orden',0),(281915,7831,'de','Stunden ging aber keine WorkType fÃ¼r Bestellung',0),(281916,7831,'en','Hours Entered But No WorkType for Order',0),(281917,7832,'is','',0),(281918,7832,'dr','(Ø³Ù‚ÙˆØ·',0),(281919,7832,'pr','Ø²Ù…Ø§Ù† Ø§ÙØª (Ø³Ù‚ÙˆØ·',0),(281920,7832,'tr','Zaman dÃ¼ÅŸtÃ¼',0),(281921,7832,'pl','Czas spadÅ‚a',0),(281922,7832,'bg','Ð’Ñ€ÐµÐ¼Ðµ ÑÐ¿Ð°Ð´Ð°',0),(281923,7832,'ur','ÙˆÙ‚Øª Ú©Ùˆ Ú¯Ø±Ø§ Ø¯ÛŒØ§',0),(281924,7832,'sr','ÐŸÑƒÑ‚ Ð¸ÑÐ¿ÑƒÑÑ‚Ð¸Ð¾',0),(281925,7832,'vi','Thá»i gian bá»',0),(281926,7832,'af','Tyd laat val',0),(281927,7832,'ro','Timp scÄƒzut',0),(281928,7832,'et','Mahavisatud aeg',0),(281929,7832,'si','ÄŒas kapalka',0),(281930,7832,'ba','Waktu turun',0),(281931,7832,'nl','Tijd gedaald',0),(281932,7832,'fi','Aika putosi',0),(281933,7832,'no','Tid falt',0),(281934,7832,'da','Tiden faldt',0),(281935,7832,'ko','ì‹œê°„ ì‚­ì œ',0),(281936,7832,'he','×”×–×ž×Ÿ ×™×¨×“',0),(281937,7832,'el','ÎÏÎ± Î­Ï€ÎµÏƒÎµ',0),(281938,7832,'zh','æ—¶é—´ä¸‹é™\r\n',0),(281939,7832,'sv','Tid tappade',0),(281940,7832,'it','Tempo caduto',0),(281941,7832,'tl','',0),(281942,7832,'th','&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3621;&#3604;',0),(281943,7832,'hi','à¤—à¤¿à¤°à¤¾ à¤¦à¤¿à¤¯à¤¾ à¤¸à¤®à¤¯',0),(281944,7832,'ms','Masa jatuh',0),(281945,7832,'ar','Ø§Ù„ÙˆÙ‚Øª Ø§Ù†Ø®ÙØ¶',0),(281946,7832,'fr','Temps laissÃ© tombÃ©',0),(281947,7832,'jp','æ™‚é–“ã‚’è½ã¨ã—ãŸ',0),(281948,7832,'pt','Tempo de cair',0),(281949,7832,'ru','Ð’Ñ€ÐµÐ¼Ñ ÑƒÐ¿Ð°Ð»Ð°',0),(281950,7832,'es','Tiempo Dejado',0),(281951,7832,'de','Zeit gelÃ¶scht',0),(281952,7832,'en','Time Dropped',0),(281953,7833,'is','',0),(281954,7833,'dr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ÙŠØ§ ÙƒØ§Ø±ÙƒÙ†Ø§Ù† ',0),(281955,7833,'pr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ ÙŠØ§ ÙƒØ§Ø±ÙƒÙ†Ø§Ù† ',0),(281956,7833,'tr','Yeni tarihleri veya iÅŸÃ§i seÃ§meden Ã¶nce deÄŸiÅŸiklikleri kaydetmek',0),(281957,7833,'pl','ZapisaÄ‡ zmiany przed wybraniem nowej daty lub pracownika',0),(281958,7833,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð´Ð°Ñ‚Ð¸ Ð¸Ð»Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº',0),(281959,7833,'ur','Ù†Ø¦ÛŒ ØªØ§Ø±ÛŒØ®ÙˆÚº ÛŒØ§ Ú©Ø§Ø±Ú©Ù† Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ø³Û’ Ù¾ÛÙ„Û’ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(281960,7833,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð¿Ñ€Ðµ Ð½ÐµÐ³Ð¾ ÑˆÑ‚Ð¾ Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð²Ðµ Ð´Ð°Ñ‚ÑƒÐ¼Ðµ Ð¸Ð»Ð¸ Ñ€Ð°Ð´Ð½Ð¸Ðº',0),(281961,7833,'vi','Sao lÆ°u thay Ä‘á»•i trÆ°á»›c khi chá»n ngÃ y má»›i hay cÃ´ng nhÃ¢n',0),(281962,7833,'af','Stoor Veranderinge Alvorens Nuwe Datums of Werker Gekies word',0),(281963,7833,'ro','SalvaÅ£i modificÄƒrile Ã®nainte de a selecta date de noi sau de lucrÄƒtorul',0),(281964,7833,'et','Salvestada muutused enne valida uued kuupÃ¤evad vÃµi tÃ¶Ã¶taja',0),(281965,7833,'si','Shranite spremembe pred izbiro nove datume ali delavec',0),(281966,7833,'ba','Simpan perubahan sebelum memilih tanggal baru atau pekerja',0),(281967,7833,'nl','Wijzigingen opslaan voordat u nieuwe datums of werknemer',0),(281968,7833,'fi','Tallenna muutokset ennen valintaa uudet pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t tai tyÃ¶ntekijÃ¤n',0),(281969,7833,'no','Lagre endringene fÃ¸r du velger nye datoer eller arbeideren',0),(281970,7833,'da','Gemme Ã¦ndringer, fÃ¸r du vÃ¦lger nye datoer eller arbejdstager',0),(281971,7833,'ko','ìƒˆë¡œìš´ ë‚ ì§œ ë˜ëŠ” ìž‘ì—…ìžë¥¼ ì„ íƒ í•˜ê¸° ì „ì— ë³€ê²½ ì‚¬í•­ì„ ì €ìž¥í•©ë‹ˆë‹¤',0),(281972,7833,'he','×œ×©×ž×•×¨ ××ª ×”×©×™× ×•×™×™× ×œ×¤× ×™ ×‘×—×™×¨×ª ×”×ª××¨×™×›×™× ×”×—×“×©×™× ××• ×œ×¢×‘×•×“×”',0),(281973,7833,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® Ï„Î¹Ï‚ Î½Î­ÎµÏ‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚ Î® ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚',0),(281974,7833,'zh','é€‰æ‹©æ–°çš„æ—¥æœŸæˆ–å·¥äººå‰ä¿å­˜æ›´æ”¹\r\n',0),(281975,7833,'sv','Spara Ã¤ndringar innan du vÃ¤ljer nya datum eller arbetare',0),(281976,7833,'it','Salvare le modifiche prima di selezionare nuove date o lavoratore',0),(281977,7833,'tl','',0),(281978,7833,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3',0),(281979,7833,'hi','à¤¨à¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¯à¤¾ à¤•à¤¾à¤°à¥à¤¯à¤•à¤°à¥à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¥‹à¤‚ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(281980,7833,'ms','Menyimpan perubahan sebelum memilih tarikh baru atau pekerja',0),(281981,7833,'ar','Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ ØªØ­Ø¯ÙŠØ¯ Ù…ÙˆØ§Ø¹ÙŠØ¯ Ø¬Ø¯ÙŠØ¯Ø© Ø£Ùˆ Ø¹Ø§Ù…Ù„',0),(281982,7833,'fr','Enregistrer les modifications avant de sÃ©lectionner de nouvelles Dates ou travailleur',0),(281983,7833,'jp','æ–°ã—ã„æ—¥ä»˜ã¾ãŸã¯åŠ´åƒè€…ã‚’é¸æŠžã™ã‚‹å‰ã«å¤‰æ›´ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(281984,7833,'pt','Salvar as alteraÃ§Ãµes antes de selecionar novas datas ou o trabalhador',0),(281985,7833,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð”Ð¾ Ð’Ñ‹Ð±Ð¾Ñ€Ð° ÐÐ¾Ð²Ñ‹Ñ… Ð”Ð°Ñ‚ Ð¸Ð»Ð¸ Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(281986,7833,'es','Guardar Cambios Antes Que Seleccionar Nuevas Fechas o Trabajador',0),(281987,7833,'de','Speichern Sie Ã„nderungen, bevor Sie sich fÃ¼r neue Termine oder Arbeitnehmer',0),(281988,7833,'en','Save Changes Before Selecting New Dates or Worker',0),(281989,7834,'is','',0),(281990,7834,'dr','(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(281991,7834,'pr','ÙÙ‚Ø· Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(281992,7834,'tr','Faturalanabilir sadece',0),(281993,7834,'pl','Rozliczana tylko',0),(281994,7834,'bg','ÐŸÐ»Ð°Ñ‚Ð¸Ð¼Ð¸ ÑÐ°Ð¼Ð¾',0),(281995,7834,'ur','Ø¨Ù„Ù„Ø§Ø¨Ù„ÛŒ ØµØ±Ù',0),(281996,7834,'sr','ÐšÐ¾Ñ˜Ðµ Ñ‚Ñ€ÐµÐ±Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ ÑÐ°Ð¼Ð¾',0),(281997,7834,'vi','DÃ nh Cho CÃ³ Thá»ƒ Láº­p HÃ³a ÄÆ¡n ',0),(281998,7834,'af','Billable slegs',0),(281999,7834,'ro','Facturabile numai',0),(282000,7834,'et','Maksustatavaid ainult',0),(282001,7834,'si','ObraÄunava le',0),(282002,7834,'ba','Ditagih hanya',0),(282003,7834,'nl','Factureerbare alleen',0),(282004,7834,'fi','Laskutettavat vain',0),(282005,7834,'no','Fakturerbar bare',0),(282006,7834,'da','Fakturerbar kun',0),(282007,7834,'ko','ì²­êµ¬ë§Œ',0),(282008,7834,'he','×œ×—×™×•×‘ ×‘×œ×‘×“',0),(282009,7834,'el','Î§ÏÎµÏŽÏƒÎ¹Î¼ÎµÏ‚ Î¼ÏŒÎ½Î¿',0),(282010,7834,'zh','å¯æ”¶è´¹çš„åªæœ‰\r\n',0),(282011,7834,'sv','Fakturerbar tid endast',0),(282012,7834,'it','Fatturabili solo',0),(282013,7834,'tl','',0),(282014,7834,'th','&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(282015,7834,'hi','à¤¬à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤¯à¥‹à¤—à¥à¤¯ à¤•à¥‡à¤µà¤²',0),(282016,7834,'ms','Situasi Billable sahaja',0),(282017,7834,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹ ÙÙ‚Ø·',0),(282018,7834,'fr','Facturables seulement',0),(282019,7834,'jp','è«‹æ±‚ã®ã¿',0),(282020,7834,'pt','FaturÃ¡veis somente',0),(282021,7834,'ru','ÐžÐ¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÐ¼Ð¾Ðµ Ð²Ñ€ÐµÐ¼Ñ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(282022,7834,'es','Facturable Solamente',0),(282023,7834,'de','Billable nur',0),(282024,7834,'en','Billable Only',0),(282025,7835,'is','',0),(282026,7835,'dr','Ø·Ø¨Ù‚ ØªØ§Ø±ÙŠØ®',0),(282027,7835,'pr','Ø·Ø¨Ù‚ ØªØ§Ø±ÙŠØ®',0),(282028,7835,'tr','Tarihe gÃ¶re',0),(282029,7835,'pl','WedÅ‚ug daty',0),(282030,7835,'bg','ÐŸÐ¾ Ð´Ð°Ñ‚Ð°',0),(282031,7835,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(282032,7835,'sr','ÐŸÐ¾ Ð´Ð°Ñ‚ÑƒÐ¼Ñƒ',0),(282033,7835,'vi','VÃ o ngÃ y',0),(282034,7835,'af','Per Datum',0),(282035,7835,'ro','De data',0),(282036,7835,'et','KuupÃ¤evade kaupa',0),(282037,7835,'si','Po datumu',0),(282038,7835,'ba','Menurut tanggal',0),(282039,7835,'nl','Op datum',0),(282040,7835,'fi','MennessÃ¤',0),(282041,7835,'no','Etter dato',0),(282042,7835,'da','Af dato',0),(282043,7835,'ko','ë‚ ì§œë³„ìœ¼ë¡œ',0),(282044,7835,'he','×œ×¤×™ ×ª××¨×™×š',0),(282045,7835,'el','Î‘Ï€ÏŒ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(282046,7835,'zh','æŒ‰æ—¥æœŸ\r\n',0),(282047,7835,'sv','Efter datum',0),(282048,7835,'it','Dalla data di',0),(282049,7835,'tl','',0),(282050,7835,'th','&#3650;&#3604;&#3618;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(282051,7835,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤°',0),(282052,7835,'ms','Mengikut tarikh',0),(282053,7835,'ar','Ø­Ø³Ø¨ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(282054,7835,'fr','Par Date',0),(282055,7835,'jp','æ—¥ä»˜é †',0),(282056,7835,'pt','Por data',0),(282057,7835,'ru','ÐŸÐ¾ Ð”Ð°Ñ‚Ðµ',0),(282058,7835,'es','Por Fecha',0),(282059,7835,'de','Nach Datum',0),(282060,7835,'en','By Date',0),(282061,7836,'is','',0),(282062,7836,'dr','Ø¨Ø§Ø³ÙØ§Ø±Ø´',0),(282063,7836,'pr','Ø¨Ø§Ø³ÙØ§Ø±Ø´',0),(282064,7836,'tr','Order by',0),(282065,7836,'pl','Zlecenie',0),(282066,7836,'bg','ÐŸÐ¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(282067,7836,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø­Ø§Ø¸ Ø³Û’',0),(282068,7836,'sr','ÐŸÐ¾ Ð½Ð°Ñ€ÐµÐ´Ð±Ð¸',0),(282069,7836,'vi','Theo ÄÆ¡n Äáº·t HÃ ng ',0),(282070,7836,'af','Per Bestelling',0),(282071,7836,'ro','Prin ordinul',0),(282072,7836,'et','Tellimisel',0),(282073,7836,'si','Po naroÄilu',0),(282074,7836,'ba','Berdasarkan pesanan',0),(282075,7836,'nl','Door Order',0),(282076,7836,'fi','Tilauksesta',0),(282077,7836,'no','PÃ¥ bestilling',0),(282078,7836,'da','Af ordre',0),(282079,7836,'ko','ì£¼ë¬¸ì— ì˜í•´',0),(282080,7836,'he','×œ×¤×™ ×”×–×ž× ×”',0),(282081,7836,'el','Î”Î¹',0),(282082,7836,'zh','æŒ‰è®¢å•\r\n',0),(282083,7836,'sv','Av ordning',0),(282084,7836,'it','Di ordine',0),(282085,7836,'tl','',0),(282086,7836,'th','&#3650;&#3604;&#3618;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(282087,7836,'hi','à¤†à¤¦à¥‡à¤¶ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(282088,7836,'ms','Melalui perintah yang',0),(282089,7836,'ar','Ø¨Ø£Ù…Ø±',0),(282090,7836,'fr','Par le dÃ©cret',0),(282091,7836,'jp','é †',0),(282092,7836,'pt','Por ordem',0),(282093,7836,'ru','ÐŸÐ¾ Ð—Ð°ÐºÐ°Ð·Ñƒ',0),(282094,7836,'es','Por Pedido',0),(282095,7836,'de','Durch Anordnung',0),(282096,7836,'en','By Order',0),(282097,7837,'is','',0),(282098,7837,'dr','Ø¨Ø§ ÙƒØ§Ø±ÙƒÙ†Ø§Ù†',0),(282099,7837,'pr','Ø¨Ø§ ÙƒØ§Ø±ÙƒÙ†Ø§Ù†',0),(282100,7837,'tr','Alt tarafÄ±ndan',0),(282101,7837,'pl','Przez pracownika',0),(282102,7837,'bg','ÐžÑ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº',0),(282103,7837,'ur','Ú©Ø§Ø±Ú©Ù† Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(282104,7837,'sr','ÐžÐ´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ñ€Ð°Ð´Ð½Ð¸ÐºÐ°',0),(282105,7837,'vi','Do cÃ´ng nhÃ¢n',0),(282106,7837,'af','Per Werker',0),(282107,7837,'ro','De lucrÄƒtor',0),(282108,7837,'et','TÃ¶Ã¶taja poolt',0),(282109,7837,'si','Delavec',0),(282110,7837,'ba','Oleh pekerja',0),(282111,7837,'nl','Door werknemer',0),(282112,7837,'fi','TyÃ¶ntekijÃ¤n',0),(282113,7837,'no','Av arbeideren',0),(282114,7837,'da','Arbejdstager',0),(282115,7837,'ko','ìž‘ì—…ìžì— ì˜í•´',0),(282116,7837,'he','×¢×œ ×™×“×™ ×”×¢×•×‘×“',0),(282117,7837,'el','Î‘Ï€ÏŒ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿',0),(282118,7837,'zh','ç”±å·¥äºº\r\n',0),(282119,7837,'sv','Av arbetstagare',0),(282120,7837,'it','Da lavoratore',0),(282121,7837,'tl','',0),(282122,7837,'th','&#3650;&#3604;&#3618;&#3612;&#3641;&#3657;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(282123,7837,'hi','à¤•à¤¾à¤°à¥à¤¯à¤•à¤°à¥à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(282124,7837,'ms','Oleh pekerja',0),(282125,7837,'ar','Ø¨Ø¹Ø§Ù…Ù„',0),(282126,7837,'fr','Par travailleur',0),(282127,7837,'jp','åŠ´åƒè€…ã«ã‚ˆã£ã¦',0),(282128,7837,'pt','Por trabalhador',0),(282129,7837,'ru','ÐŸÐ¾ Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÑƒ',0),(282130,7837,'es','Por Trabajador',0),(282131,7837,'de','Durch Arbeitnehmer',0),(282132,7837,'en','By Worker',0),(282133,7838,'is','',0),(282134,7838,'dr','Ø¨Ø§ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(282135,7838,'pr','Ø¨Ø§ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(282136,7838,'tr','TarafÄ±ndan WorkType',0),(282137,7838,'pl','Przez WorkType',0),(282138,7838,'bg','ÐžÑ‚ WorkType',0),(282139,7838,'ur','ÙˆÙˆØ±Ú©ØªÛŒÙ¾ÛŒ Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(282140,7838,'sr','ÐžÐ´ ÑÑ‚Ñ€Ð°Ð½Ðµ WÐ¾Ñ€ÐºÐ¢yÐ¿Ðµ',0),(282141,7838,'vi','Do loáº¡i cÃ´ng viá»‡c',0),(282142,7838,'af','Per Werkstipe',0),(282143,7838,'ro','De WorkType',0),(282144,7838,'et','Poolt WorkType',0),(282145,7838,'si','Z WorkType',0),(282146,7838,'ba','Oleh WorkType',0),(282147,7838,'nl','Door WorkType',0),(282148,7838,'fi','MennessÃ¤ WorkType',0),(282149,7838,'no','Ved WorkType',0),(282150,7838,'da','Af WorkType',0),(282151,7838,'ko','WorkTypeì— ì˜í•´',0),(282152,7838,'he','×¢×œ ×™×“×™ WorkType',0),(282153,7838,'el','Î‘Ï€ÏŒ WorkType',0),(282154,7838,'zh','æŒ‰å·¥ç¨‹ç±»åˆ«\r\n',0),(282155,7838,'sv','Av WorkType',0),(282156,7838,'it','Di WorkType',0),(282157,7838,'tl','',0),(282158,7838,'th','&#3650;&#3604;&#3618;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;',0),(282159,7838,'hi','WorkType à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(282160,7838,'ms','Oleh WorkType',0),(282161,7838,'ar','Ù‚Ø¨Ù„ ÙˆÙˆØ±ÙƒØªÙŠØ¨ÙŠ',0),(282162,7838,'fr','Par Association',0),(282163,7838,'jp','WorkType ã«ã‚ˆã£ã¦',0),(282164,7838,'pt','Por WorkType',0),(282165,7838,'ru','ÐŸÐ¾ Ð¢Ð¸Ð¿ÑƒÐ Ð°Ð±Ð¾Ñ‚Ñ‹',0),(282166,7838,'es','Por Tipo de Trabajo',0),(282167,7838,'de','Von WorkType',0),(282168,7838,'en','By WorkType',0),(282169,7839,'is','',0),(282170,7839,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(282171,7839,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(282172,7839,'tr','SÄ±ralama dÃ¼zeni seÃ§in',0),(282173,7839,'pl','Wybierz porzÄ…dek sortowania',0),(282174,7839,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ€ÐµÐ´ Ð½Ð° ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(282175,7839,'ur','Ú†Ú¾Ø§Ù†Ù¹ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(282176,7839,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°ÑšÐ°',0),(282177,7839,'vi','Chá»n Ä‘Æ¡n hÃ ng Ä‘á»ƒ sáº¯p xáº¿p',0),(282178,7839,'af','Selekteer Gesorteerde Bestelling',0),(282179,7839,'ro','SelecteazÄƒ ordine de sortare',0),(282180,7839,'et','Valige sortimisjÃ¤rjestus',0),(282181,7839,'si','Izberite vrstni red',0),(282182,7839,'ba','Pilih dasar susunan',0),(282183,7839,'nl','Kies sorteervolgorde',0),(282184,7839,'fi','Valitse lajittelujÃ¤rjestys',0),(282185,7839,'no','Velg sorteringsrekkefÃ¸lge',0),(282186,7839,'da','VÃ¦lg sorteringsrÃ¦kkefÃ¸lgen',0),(282187,7839,'ko','ì •ë ¬ ìˆœì„œ ì„ íƒ',0),(282188,7839,'he','×‘×—×¨ ×¡×“×¨ ×ž×™×•×Ÿ',0),(282189,7839,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Ï„Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ·Ï‚',0),(282190,7839,'zh','é€‰æ‹©åˆ†ç±»æŽ’åº\r\n',0),(282191,7839,'sv','VÃ¤lj sorteringsordning',0),(282192,7839,'it','Selezionare il tipo di ordinamento',0),(282193,7839,'tl','',0),(282194,7839,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3588;&#3633;&#3604;&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(282195,7839,'hi','à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¥à¤°à¤® à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(282196,7839,'ms','Pilih Susun mengikut',0),(282197,7839,'ar','Ø­Ø¯Ø¯ ØªØ±ØªÙŠØ¨ Ø§Ù„ÙØ±Ø²',0),(282198,7839,'fr','SÃ©lectionnez l\'ordre de tri',0),(282199,7839,'jp','ä¸¦ã¹æ›¿ãˆé †ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(282200,7839,'pt','Selecione a ordem de classificaÃ§Ã£o',0),(282201,7839,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð—Ð°ÐºÐ°Ð·Ð°',0),(282202,7839,'es','Seleccionar Orden de Sortear',0),(282203,7839,'de','WÃ¤hlen Sie die Sortierreihenfolge',0),(282204,7839,'en','Select Sort Order',0),(282205,7840,'is','',0),(282206,7840,'dr','Ù†Ù…Ø§ÙŠØ´ ÙÙ‚Ø· Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù‡Ø§',0),(282207,7840,'pr','Ù†Ù…Ø§ÙŠØ´ ÙÙ‚Ø· Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù‡Ø§',0),(282208,7840,'tr','YalnÄ±zca faturalandÄ±rÄ±labilir gÃ¶ster',0),(282209,7840,'pl','PokaÅ¼ tylko rozliczanych',0),(282210,7840,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ ÑÐ°Ð¼Ð¾ Ð½Ð° Ð¾Ñ‚Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¾',0),(282211,7840,'ur','ØµØ±Ù Ø¨Ù„Ù„Ø§Ø¨Ù„ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(282212,7840,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÐºÐ¾Ñ˜Ðµ Ñ‚Ñ€ÐµÐ±Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸',0),(282213,7840,'vi','Chá»‰ Hiá»‡n Thá»‹ CÃ³ Thá»ƒ Xin Thanh ToÃ¡n',0),(282214,7840,'af','Wys slegs Billable',0),(282215,7840,'ro','AratÄƒ facturabile numai',0),(282216,7840,'et','Kuva ainult maksustatavaid',0),(282217,7840,'si','PokaÅ¾i obraÄunava samo',0),(282218,7840,'ba','Tampilkan ditagih hanya',0),(282219,7840,'nl','Alleen factureerbare weergeven',0),(282220,7840,'fi','NÃ¤ytÃ¤ laskutettava vain',0),(282221,7840,'no','Vis fakturerbare bare',0),(282222,7840,'da','Vis fakturerbare kun',0),(282223,7840,'ko','ì²­êµ¬ë§Œ í‘œì‹œ',0),(282224,7840,'he','×”×¦×’ ×œ×—×™×•×‘ ×‘×œ×‘×“',0),(282225,7840,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï‡ÏÎµÏŽÏƒÎ¹Î¼ÎµÏ‚ Î¼ÏŒÎ½Î¿',0),(282226,7840,'zh','åªæ˜¾ç¤ºå¯å…¥è´¦\r\n',0),(282227,7840,'sv','Visa fakturerbara endast',0),(282228,7840,'it','Visualizza solo fatturabile',0),(282229,7840,'tl','',0),(282230,7840,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3610;&#3636;&#3621;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3652;&#3604;&#3657;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(282231,7840,'hi','à¤•à¥‡à¤µà¤² à¤¬à¤¿à¤² à¤¯à¥‹à¤—à¥à¤¯ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(282232,7840,'ms','Menunjukkan situasi Billable sahaja',0),(282233,7840,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù…Ø¯ÙÙˆØ¹ ÙÙ‚Ø·',0),(282234,7840,'fr','Afficher facturables uniquement',0),(282235,7840,'jp','è«‹æ±‚ã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(282236,7840,'pt','Mostrar faturÃ¡veis somente',0),(282237,7840,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÐ¼Ñ‹Ñ…',0),(282238,7840,'es','Mostrar Facturable Solo',0),(282239,7840,'de','Nur abrechenbar anzeigen',0),(282240,7840,'en','Show Billable Only',0),(282241,7841,'is','',0),(282242,7841,'dr','Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø± ',0),(282243,7841,'pr','Ø­Ø°Ù Ù†Ù…ÙˆØ¯Ø§Ø± ',0),(282244,7841,'tr','Grafik silme',0),(282245,7841,'pl','Usuwanie graficzne',0),(282246,7841,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(282247,7841,'ur','Ú¯Ø±Ø§ÙÛŒ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(282248,7841,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(282249,7841,'vi','XÃ³a Ä‘á»“ há»a',0),(282250,7841,'af','Skrap Grafika',0),(282251,7841,'ro','ÅžtergeÅ£i grafic',0),(282252,7841,'et','Kustuta graafika',0),(282253,7841,'si','Izbrisati grafiko',0),(282254,7841,'ba','Menghapus grafis',0),(282255,7841,'nl','Afbeelding verwijderen',0),(282256,7841,'fi','Poista kuva',0),(282257,7841,'no','Slette grafikk',0),(282258,7841,'da','Slette grafik',0),(282259,7841,'ko','ê·¸ëž˜í”½ ì‚­ì œ',0),(282260,7841,'he','×ž×—×™×§×ª ×’×¨×¤×™×§×”',0),(282261,7841,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Ï„Î¿ Î³ÏÎ±Ï†Î¹ÎºÏŒ',0),(282262,7841,'zh','åˆ é™¤å›¾å½¢\r\n',0),(282263,7841,'sv','Ta bort bild',0),(282264,7841,'it','Eliminare la grafica',0),(282265,7841,'tl','',0),(282266,7841,'th','&#3621;&#3610;&#3619;&#3641;&#3611;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3585;',0),(282267,7841,'hi','à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤• à¤¹à¤Ÿà¤¾à¤à¤',0),(282268,7841,'ms','Menghapuskan grafik',0),(282269,7841,'ar','Ø­Ø°Ù Ø§Ù„Ø±Ø³Ù…',0),(282270,7841,'fr','Supprimer graphique',0),(282271,7841,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(282272,7841,'pt','Excluir o grÃ¡fico',0),(282273,7841,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð¸ÑÑƒÐ½ÐºÐ°',0),(282274,7841,'es','Eliminar GrÃ¡fica',0),(282275,7841,'de','Grafik lÃ¶schen',0),(282276,7841,'en','Delete Graphic',0),(282277,7842,'is','',0),(282278,7842,'dr','941s',0),(282279,7842,'pr','941s',0),(282280,7842,'tr','941s',0),(282281,7842,'pl','941s',0),(282282,7842,'bg','941s',0),(282283,7842,'ur','Ù†Ùˆ Ø³Ùˆ Ø§Ú©ØªØ§Ù„ÛŒØ³ÙˆØ§Úº',0),(282284,7842,'sr','941Ñ',0),(282285,7842,'vi','941s',0),(282286,7842,'af','941s',0),(282287,7842,'ro','941s',0),(282288,7842,'et','941ne',0),(282289,7842,'si','941s',0),(282290,7842,'ba','941',0),(282291,7842,'nl','941s',0),(282292,7842,'fi','941s',0),(282293,7842,'no','941s',0),(282294,7842,'da','941s',0),(282295,7842,'ko','941s',0),(282296,7842,'he','941s',0),(282297,7842,'el','941s',0),(282298,7842,'zh','941s',0),(282299,7842,'sv','941:a',0),(282300,7842,'it','941s',0),(282301,7842,'tl','',0),(282302,7842,'th','941s',0),(282303,7842,'hi','941s',0),(282304,7842,'ms','941s',0),(282305,7842,'ar','941s',0),(282306,7842,'fr','941S',0),(282307,7842,'jp','941s',0),(282308,7842,'pt','941s',0),(282309,7842,'ru','941s',0),(282310,7842,'es','941s',0),(282311,7842,'de','941s',0),(282312,7842,'en','941s',0),(282313,7843,'is','',0),(282314,7843,'dr','ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§',0),(282315,7843,'pr','ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§',0),(282316,7843,'tr','Eylemler',0),(282317,7843,'pl','DziaÅ‚ania',0),(282318,7843,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(282319,7843,'ur','Ø§Ø¹Ù…Ø§Ù„',0),(282320,7843,'sr','Ð Ð°Ð´ÑšÐµ',0),(282321,7843,'vi','CÃ¡c HÃ nh Äá»™ng',0),(282322,7843,'af','Aksies',0),(282323,7843,'ro','Actiuni',0),(282324,7843,'et','Tegevused',0),(282325,7843,'si','Dejanja',0),(282326,7843,'ba','Tindakan',0),(282327,7843,'nl','Acties',0),(282328,7843,'fi','Toiminnot',0),(282329,7843,'no','Handlinger',0),(282330,7843,'da','Handlinger',0),(282331,7843,'ko','ìž‘ì—…',0),(282332,7843,'he','×¤×¢×•×œ×•×ª',0),(282333,7843,'el','Î”ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(282334,7843,'zh','åŠ¨ä½œ\r\n',0),(282335,7843,'sv','Ã…tgÃ¤rder',0),(282336,7843,'it','Azioni',0),(282337,7843,'tl','',0),(282338,7843,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(282339,7843,'hi','à¤•à¥à¤°à¤¿à¤¯à¤¾à¤à¤',0),(282340,7843,'ms','Tindakan-tindakan',0),(282341,7843,'ar','Ø§Ù„Ø¹Ù…Ù„ÙŠØ§Øª',0),(282342,7843,'fr','Actions',0),(282343,7843,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(282344,7843,'pt','AÃ§Ãµes',0),(282345,7843,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(282346,7843,'es','Acciones',0),(282347,7843,'de','Aktionen',0),(282348,7843,'en','Actions',0),(282349,7844,'is','',0),(282350,7844,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ¹Ø§Ù„ÙŠØª',0),(282351,7844,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ¹Ø§Ù„ÙŠØª',0),(282352,7844,'tr','Etkinlik geÃ§miÅŸi',0),(282353,7844,'pl','Historia aktywnoÅ›ci',0),(282354,7844,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð°',0),(282355,7844,'ur','Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(282356,7844,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(282357,7844,'vi','Lá»‹ch Sá»­ Hoáº¡t Äá»™ng',0),(282358,7844,'af','Aktiwiteitsgeskiedenis',0),(282359,7844,'ro','Istoric de activitate',0),(282360,7844,'et','Tegevuste ajalugu',0),(282361,7844,'si','Marljivost zgodovina',0),(282362,7844,'ba','Kronologi Aktifitas',0),(282363,7844,'nl','Activiteitsgeschiedenis',0),(282364,7844,'fi','TyÃ¶historia',0),(282365,7844,'no','Aktivitetslogg',0),(282366,7844,'da','Aktivitet historie',0),(282367,7844,'ko','í™œë™ ì—­ì‚¬',0),(282368,7844,'he','×”×™×¡×˜×•×¨×™×™×ª ×¤×¢×™×œ×•×ª',0),(282369,7844,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï„Î®Ï„Ï‰Î½',0),(282370,7844,'zh','æ´»åŠ¨å²\r\n',0),(282371,7844,'sv','Aktivitetshistorik',0),(282372,7844,'it','Storico attivitÃ ',0),(282373,7844,'tl','',0),(282374,7844,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3607;&#3635;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;',0),(282375,7844,'hi','à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(282376,7844,'ms','Sejarah aktiviti',0),(282377,7844,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù†Ø´Ø§Ø·',0),(282378,7844,'fr','Historique des activitÃ©s',0),(282379,7844,'jp','æ´»å‹•ã®æ­´å²',0),(282380,7844,'pt','HistÃ³rico de atividades',0),(282381,7844,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(282382,7844,'es','Historia de Actividad',0),(282383,7844,'de','AktivitÃ¤tsverlauf',0),(282384,7844,'en','Activity History',0),(282385,7845,'is','',0),(282386,7845,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(282387,7845,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙŠØ³Øª Ù…ÙˆØ§Ø¯ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(282388,7845,'tr','Malzeme stok maddelerinin Ekle',0),(282389,7845,'pl','Dodaj rachunek zapasÃ³w materiaÅ‚Ã³w',0),(282390,7845,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑÐ½Ð¾ Ð¸Ð·Ð´ÐµÐ»Ð¸Ðµ ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(282391,7845,'ur','Ø¨Ù„ Ù…ÙˆØ§Ø¯ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(282392,7845,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð‘Ð¸Ð» Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(282393,7845,'vi','ThÃªm HÃ³a ÄÆ¡n NguyÃªn Váº­t Liá»‡u Cá»§a HÃ ng HÃ³a',0),(282394,7845,'af','Voeg Materiaalrekening Inventaris items in',0),(282395,7845,'ro','Adauga Factura cu articole din gestiunea de materiale',0),(282396,7845,'et','Materjalide lao kaupu lisada',0),(282397,7845,'si','Dodaj raÄun materialov inventarja',0),(282398,7845,'ba','Tambahkan tagihan bahan persediaan barang',0),(282399,7845,'nl','Toevoegen van materialen voorraadartikelen materiaallijst',0),(282400,7845,'fi','LisÃ¤Ã¤ Eira materiaalit varastonimikkeiden',0),(282401,7845,'no','Legge til Bill av materiale lagervarer',0),(282402,7845,'da','TilfÃ¸je Bill af materiale lagervarer',0),(282403,7845,'ko','ì¶”ê°€ ìž¬ë£Œ ìž¬ê³  ëª©ë¡ í’ˆëª©ì˜ ë¹Œ',0),(282404,7845,'he','×œ×”×•×¡×™×£ ××ª ×”×—×©×‘×•×Ÿ ×©×œ ×¤×¨×™×˜×™ ×ž×œ××™ ×—×•×ž×¨×™×',0),(282405,7845,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Bill ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ Ï…Î»Î¹ÎºÎ¬',0),(282406,7845,'zh','å¢žåŠ ææ–™åº“å­˜é¡¹ç›®è´¦å•\r\n',0),(282407,7845,'sv','LÃ¤gg till Bill av material lagerartiklar',0),(282408,7845,'it','Aggiungere distinta materiali articoli di magazzino',0),(282409,7845,'tl','',0),(282410,7845,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;&#3588;&#3591;&#3588;&#3621;&#3',0),(282411,7845,'hi','à¤®à¤¾à¤² à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¤¾ à¤¬à¤¿à¤² à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(282412,7845,'ms','Menambah bil item inventori bahan',0),(282413,7845,'ar','Ø¥Ø¶Ø§ÙØ© ÙØ§ØªÙˆØ±Ø© Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ù…ÙˆØ§Ø¯',0),(282414,7845,'fr','Ajouter Articles d\'Inventaire pour nomenclature \r\n',0),(282415,7845,'jp','åœ¨åº«å“ç›®ã®è«‹æ±‚æ›¸ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(282416,7845,'pt','Adicionar a lista de itens de estoque de materiais',0),(282417,7845,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð² Ñ‚Ð¾Ð²Ð°Ñ€Ð½Ð¾-Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ñ… Ñ†ÐµÐ½Ð½Ð¾ÑÑ‚ÐµÐ¹',0),(282418,7845,'es','Agregar Items de Inventario de la Lista de Materiales',0),(282419,7845,'de','Materialliste Materialien Inventar hinzufÃ¼gen',0),(282420,7845,'en','Add Bill of Materials Inventory Items',0),(282421,7846,'is','',0),(282422,7846,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(282423,7846,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(282424,7846,'tr','MÃ¼ÅŸteri bilgilerini ekle',0),(282425,7846,'pl','Dodawanie informacji o klientach',0),(282426,7846,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(282427,7846,'ur','Ú¯Ø§ÛÚ© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(282428,7846,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐºÑƒÐ¿Ñ†Ñƒ',0),(282429,7846,'vi','ThÃªm ThÃ´ng Tin KhÃ¡ch HÃ ng',0),(282430,7846,'af','Voeg Klant/KliÃ«nt Informasie by',0),(282431,7846,'ro','Adauga informatii despre client',0),(282432,7846,'et','Lisa kliendiinformatsioon',0),(282433,7846,'si','Dodajte podatke o strankah',0),(282434,7846,'ba','Tambahkan informasi pelanggan',0),(282435,7846,'nl','Klantgegevens toevoegen',0),(282436,7846,'fi','LisÃ¤Ã¤ asiakkaan tiedot',0),(282437,7846,'no','Legge til kundeinformasjon',0),(282438,7846,'da','TilfÃ¸je kundeoplysninger',0),(282439,7846,'ko','ê³ ê° ì •ë³´ ì¶”ê°€',0),(282440,7846,'he','×”×•×¡×£ ×ž×™×“×¢ ×œ×§×•×—',0),(282441,7846,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(282442,7846,'zh','å¢žåŠ å®¢æˆ·ä¿¡æ¯\r\n',0),(282443,7846,'sv','LÃ¤gg till kundinformation',0),(282444,7846,'it','Aggiungere informazioni cliente',0),(282445,7846,'tl','',0),(282446,7846,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(282447,7846,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(282448,7846,'ms','Tambah maklumat pelanggan',0),(282449,7846,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(282450,7846,'fr','Ajouter Information du Client',0),(282451,7846,'jp','é¡§å®¢æƒ…å ±ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(282452,7846,'pt','Adicionar informaÃ§Ãµes sobre o cliente',0),(282453,7846,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ðž ÐšÐ»Ð¸ÐµÐ½Ñ‚Ðµ',0),(282454,7846,'es','Agregar InformaciÃ³n de Cliente',0),(282455,7846,'de','HinzufÃ¼gen von Kundeninformationen',0),(282456,7846,'en','Add Customer Information',0),(282457,7847,'is','',0),(282458,7847,'dr','/ Ø§ØµÙ„Ø§Ø­  Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯',0),(282459,7847,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯',0),(282460,7847,'tr','Ã‡alÄ±ÅŸan bilgileri ekle',0),(282461,7847,'pl','Dodawanie informacji o pracowniku',0),(282462,7847,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ',0),(282463,7847,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(282464,7847,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ð¼Ð°',0),(282465,7847,'vi','ThÃªm ThÃ´ng Tin NhÃ¢n ViÃªn',0),(282466,7847,'af','Werknemer Inligting Byvoeg',0),(282467,7847,'ro','Adauga Informatii despre angajat',0),(282468,7847,'et','Lisa tÃ¶Ã¶taja informatsioon',0),(282469,7847,'si','Dodajanje informacij zaposlenih',0),(282470,7847,'ba','Tambahkan informasi karyawan',0),(282471,7847,'nl','Toevoegen van werknemersgegevens',0),(282472,7847,'fi','LisÃ¤Ã¤ tyÃ¶ntekijÃ¤tiedot',0),(282473,7847,'no','Legge til ansattinformasjon',0),(282474,7847,'da','TilfÃ¸je medarbejderoplysninger',0),(282475,7847,'ko','ì§ì› ì •ë³´ ì¶”ê°€',0),(282476,7847,'he','×”×•×¡×£ ×ž×™×“×¢ ×¢×•×‘×“',0),(282477,7847,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ Î³Î¹Î± Ï„Î¿Î½ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿',0),(282478,7847,'zh','å¢žåŠ å‘˜å·¥ä¿¡æ¯\r\n',0),(282479,7847,'sv','LÃ¤gg till Information om anstÃ¤llda',0),(282480,7847,'it','Aggiungere informazioni sui dipendenti',0),(282481,7847,'tl','',0),(282482,7847,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(282483,7847,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(282484,7847,'ms','Tambah maklumat pekerja',0),(282485,7847,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÙˆØ¸Ù',0),(282486,7847,'fr','Ajouter Information d\'EmployÃ©',0),(282487,7847,'jp','å¾“æ¥­å“¡ã®æƒ…å ±ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(282488,7847,'pt','Adicionar informaÃ§Ãµes do funcionÃ¡rio',0),(282489,7847,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ðž Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐµ',0),(282490,7847,'es','Agregar InformaciÃ³n de Empleado',0),(282491,7847,'de','HinzufÃ¼gen von Mitarbeiterdaten',0),(282492,7847,'en','Add Employee Information',0),(282493,7848,'is','',0),(282494,7848,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ Ø¬Ø¯ÙŠØ¯ ',0),(282495,7848,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ Ø¬Ø¯ÙŠØ¯ ',0),(282496,7848,'tr','Yeni bir karÅŸÄ±lama sipariÅŸi ekle',0),(282497,7848,'pl','Dodawanie nowego zamÃ³wienia realizacji',0),(282498,7848,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ñ€ÐµÐ´ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(282499,7848,'ur','ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ù†Ø¦Û’ Ø­Ú©Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(282500,7848,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð¿Ð¾Ñ€ÐµÑ‚ÐºÐ° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ',0),(282501,7848,'vi','ThÃªm ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i Má»›i',0),(282502,7848,'af','Nuwe Uitvoeringsbestelling Byvoeg',0),(282503,7848,'ro','Adauga noi Ã®ndeplinirea comenzii',0),(282504,7848,'et','Lisa uus kaubatellimus',0),(282505,7848,'si','Dodaj nov izpolnitev nalog',0),(282506,7848,'ba','Tambahkan pemenuhan Orde Baru',0),(282507,7848,'nl','Toevoegen van nieuwe vervulling orde',0),(282508,7848,'fi','LisÃ¤Ã¤ uuden suunnitellun tilauksen',0),(282509,7848,'no','Legg til ny innfrielsesordre',0),(282510,7848,'da','TilfÃ¸j ny opfyldelsesordre',0),(282511,7848,'ko','ìƒˆë¡œìš´ í–‰ ìˆœì„œë¥¼ ì¶”ê°€',0),(282512,7848,'he','×œ×”×•×¡×™×£ ×¡×“×¨ ×”×’×©×ž×” ×—×“×©',0),(282513,7848,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Ï‰Î½ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(282514,7848,'zh','å¢žåŠ æ–°è®¢å•å±¥è¡Œ\r\n',0),(282515,7848,'sv','LÃ¤gg till ny uppfyllelseorder',0),(282516,7848,'it','Aggiungi nuovo ordine di evasione',0),(282517,7848,'tl','',0),(282518,7848,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(282519,7848,'hi','à¤¨à¤ˆ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(282520,7848,'ms','Tambah baru memenuhi perintah',0),(282521,7848,'ar','Ø¥Ø¶Ø§ÙØ© Ø·Ù„Ø¨ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(282522,7848,'fr','Ajouter de nouveaux ordres de traitement',0),(282523,7848,'jp','æ–°ã—ã„è¨ˆç”»ã‚ªãƒ¼ãƒ€ãƒ¼ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(282524,7848,'pt','Adicionar nova ordem de cumprimento',0),(282525,7848,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð·, Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ',0),(282526,7848,'es','Agregar Nuevo Cumplimiento de Pedido',0),(282527,7848,'de','FÃ¼gen neuer Bestellvorschlag hinzu',0),(282528,7848,'en','Add New Fulfillment Order',0),(282529,7849,'is','',0),(282530,7849,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª Ø¬Ø¯ÙŠØ¯ ',0),(282531,7849,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª Ø¬Ø¯ÙŠØ¯ ',0),(282532,7849,'tr','Yeni servis sipariÅŸlerini Ekle',0),(282533,7849,'pl','Dodawanie nowych zleceÅ„ serwisowych',0),(282534,7849,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(282535,7849,'ur','Ø³Ø±ÙˆØ³ Ú©Û’ Ù†Ø¦Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(282536,7849,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(282537,7849,'vi','ThÃªm ÄÆ¡n Äáº·t HÃ ng Dá»‹ch Vá»¥ Má»›i',0),(282538,7849,'af','Voeg Nuwe Diensbestellings ',0),(282539,7849,'ro','Adauga noi comenzi de Service',0),(282540,7849,'et','Lisa uus teenusetellimus',0),(282541,7849,'si','Dodajanje novih servisnih nalogov',0),(282542,7849,'ba','Buat Pesanan Jasa Baru',0),(282543,7849,'nl','Toevoegen van nieuwe serviceorders',0),(282544,7849,'fi','LisÃ¤Ã¤ uudet huoltotilaukset',0),(282545,7849,'no','Legge til nye serviceordrer',0),(282546,7849,'da','TilfÃ¸je nye serviceordrer',0),(282547,7849,'ko','ìƒˆë¡œìš´ ì„œë¹„ìŠ¤ ëª…ë ¹ ì¶”ê°€',0),(282548,7849,'he','×”×•×¡×£ ×”×–×ž× ×•×ª ×©×¨×•×ª ×—×“×©×•×ª',0),(282549,7849,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î½Î­ÎµÏ‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(282550,7849,'zh','å¢žåŠ æ–°æœåŠ¡è®¢å•\r\n',0),(282551,7849,'sv','LÃ¤gg till ny serviceorder',0),(282552,7849,'it','Aggiungere nuovi ordini di servizio',0),(282553,7849,'tl','',0),(282554,7849,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(282555,7849,'hi','à¤¨à¤ˆ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(282556,7849,'ms','Tambah baru Perkhidmatan Pesanan',0),(282557,7849,'ar','Ø¥Ø¶Ø§ÙØ© Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(282558,7849,'fr','Ajouter de nouvelles commandes de Service',0),(282559,7849,'jp','æ–°ã—ã„ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(282560,7849,'pt','Adicionar novas ordens de serviÃ§o',0),(282561,7849,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(282562,7849,'es','Agregar Nuevos Pedidos de Servicio',0),(282563,7849,'de','FÃ¼gen Sie neue Service-AuftrÃ¤ge',0),(282564,7849,'en','Add New Service Orders',0),(282565,7850,'is','',0),(282566,7850,'dr','Ø§ØµÙ„Ø§Ø­ Ù…Ù‚Ø§Ø¯ÙŠØ± ÙƒØ§Ù„Ø§',0),(282567,7850,'pr','Ø§ØµÙ„Ø§Ø­ Ù…Ù‚Ø§Ø¯ÙŠØ± ÙƒØ§Ù„Ø§',0),(282568,7850,'tr','Madde miktarlarÄ± ayarla',0),(282569,7850,'pl','Element dostosowania iloÅ›ci',0),(282570,7850,'bg','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(282571,7850,'ur','Ø´Û’ Ù…Ù‚Ø¯Ø§Ø± Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(282572,7850,'sr','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(282573,7850,'vi','Sá»­a Äá»•i Sá»‘ LÆ°á»£ng Danh Má»¥c',0),(282574,7850,'af','Item Hoeveelhede Aanpas',0),(282575,7850,'ro','Element ajusta cantitÄƒÈ›ile',0),(282576,7850,'et','Kohenda toodete koguseid',0),(282577,7850,'si','Popravi artiklov koliÄine',0),(282578,7850,'ba','Menyesuaikan Item jumlah',0),(282579,7850,'nl','Object hoeveelheden aanpassen',0),(282580,7850,'fi','Muuta mÃ¤Ã¤rÃ¤t',0),(282581,7850,'no','Juster antallet',0),(282582,7850,'da','Justere vare mÃ¦ngder',0),(282583,7850,'ko','ì¡°ì • í•­ëª© ìˆ˜ëŸ‰',0),(282584,7850,'he','×¤×¨×™×˜ ×œ×”×ª××™× ×›×ž×•×™×•×ª',0),(282585,7850,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® ÎµÎ¹Î´ÏŽÎ½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚',0),(282586,7850,'zh','è°ƒæ•´é¡¹ç›®æ•°é‡\r\n',0),(282587,7850,'sv','Justera kvantiteter',0),(282588,7850,'it','Regolare elemento quantitÃ ',0),(282589,7850,'tl','',0),(282590,7850,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(282591,7850,'hi','à¤†à¤‡à¤Ÿà¤® à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(282592,7850,'ms','Selaraskan perkara kuantiti',0),(282593,7850,'ar','Ø¶Ø¨Ø· ÙƒÙ…ÙŠØ§Øª Ø¨Ù†Ø¯',0),(282594,7850,'fr','Ajuster les quantitÃ©s point',0),(282595,7850,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®æ•°é‡ã‚’èª¿æ•´ã—ã¾ã™ã€‚',0),(282596,7850,'pt','Artigo ajustar quantidades',0),(282597,7850,'ru','ÐšÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(282598,7850,'es','Ajustar Cantidades del Item',0),(282599,7850,'de','Artikel Mengen anpassen',0),(282600,7850,'en','Adjust Item Quantities',0),(282601,7851,'is','',0),(282602,7851,'dr','Ø§Ø¨Ø²Ø§Ø± Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§Ø¬Ø±Ø§ÙŠÙŠ ',0),(282603,7851,'pr','Ø§Ø¨Ø²Ø§Ø± Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§Ø¬Ø±Ø§ÙŠÙŠ ',0),(282604,7851,'tr','Admin-kurulum araÃ§larÄ±',0),(282605,7851,'pl','NarzÄ™dzia admina konfiguracja',0),(282606,7851,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(282607,7851,'ur','Ø§ÛŒÚˆÙ…Ù†-Ø³ÛŒÙ¹ Ø§Ù¾ Ù¹ÙˆÙ„',0),(282608,7851,'sr','ÐÐ´Ð¼Ð¸Ð½ -Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ð°Ð»Ð°Ñ‚ÐºÐµ',0),(282609,7851,'vi','CÃ´ng Cá»¥ Setup-Quáº£n Trá»‹',0),(282610,7851,'af','Admin-Opstelling Nutsgoed',0),(282611,7851,'ro','Setari administrare - unelte',0),(282612,7851,'et','Admin-Setup tÃ¶Ã¶riistad',0),(282613,7851,'si','Admin-namestitev orodja',0),(282614,7851,'ba','Alat-alat admin-Setup',0),(282615,7851,'nl','Admin-Setup-Tools',0),(282616,7851,'fi','Admin-tyÃ·kalut',0),(282617,7851,'no','Admin-Setup verktÃ¸y',0),(282618,7851,'da','Admin-Setup vÃ¦rktÃ¸jer',0),(282619,7851,'ko','ê´€ë¦¬ìž ì„¤ì¹˜ ë„êµ¬',0),(282620,7851,'he','×›×œ×™ × ×™×”×•×œ-Setup',0),(282621,7851,'el','Î•ÏÎ³Î±Î»ÎµÎ¯Î± admin-Setup',0),(282622,7851,'zh','ç®¡ç†å‘˜å®‰è£…ç¨‹åºå·¥å…·\r\n',0),(282623,7851,'sv','Admin-Setup verktyg',0),(282624,7851,'it','Strumenti admin-Setup',0),(282625,7851,'tl','',0),(282626,7851,'th','&#3605;&#3636;&#3605;&#3605;&#3633;&#3657;&#3591;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3617;&#3639;&#3629; admin',0),(282627,7851,'hi','à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª à¤‰à¤ªà¤•à¤°à¤£',0),(282628,7851,'ms','Admin-persediaan alat',0),(282629,7851,'ar','Ø£Ø¯ÙˆØ§Øª Ø§Ù„Ù…Ø´Ø±Ù ÙÙŠ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(282630,7851,'fr','Outils d\'Admin-Setup',0),(282631,7851,'jp','ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ãƒ„ãƒ¼ãƒ«',0),(282632,7851,'pt','Admin-Setup ferramentas',0),(282633,7851,'ru','ÐÐ´Ð¼Ð¸Ð½-Ð˜Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ñ‹ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(282634,7851,'es','Admin-Herramientas de ConfiguraciÃ³n',0),(282635,7851,'de','Admin-Setup-Tools',0),(282636,7851,'en','Admin-Setup Tools',0),(282637,7852,'is','',0),(282638,7852,'dr','B2B ÛŒÙˆØ²Ø±Ø§Ù† ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(282639,7852,'pr','B2B ÙƒØ§Ø±Ø¨Ø±Ø§Ù† ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(282640,7852,'tr','B2B kullanÄ±cÄ±lar',0),(282641,7852,'pl','UÅ¼ytkownicy B2B',0),(282642,7852,'bg','B2B Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(282643,7852,'ur','B2B ØµØ§Ø±ÙÛŒÙ†',0),(282644,7852,'sr','Ð‘2Ð‘ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(282645,7852,'vi','NgÆ°á»i Sá»­ Dá»¥ng B2B',0),(282646,7852,'af','B2B Gebruikers',0),(282647,7852,'ro','Utilizatori B2B',0),(282648,7852,'et','B2B kasutajad',0),(282649,7852,'si','B2B uporabnike',0),(282650,7852,'ba','B2B pengguna',0),(282651,7852,'nl','B2B gebruikers',0),(282652,7852,'fi','B2B kÃ¤yttÃ¤jÃ¤t',0),(282653,7852,'no','B2B brukere',0),(282654,7852,'da','B2B-brugere',0),(282655,7852,'ko','B2B ì‚¬ìš©ìž',0),(282656,7852,'he','×ž×©×ª×ž×©×™× B2B',0),(282657,7852,'el','B2B Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(282658,7852,'zh','å•†ä¸šå¯¹å•†ä¸šçš„ç”¨æˆ·\r\n',0),(282659,7852,'sv','B2B-anvÃ¤ndare',0),(282660,7852,'it','Utenti azienda B2B',0),(282661,7852,'tl','',0),(282662,7852,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657; B2B',0),(282663,7852,'hi','B2B à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚',0),(282664,7852,'ms','Pengguna B2B',0),(282665,7852,'ar','Ù…Ø³ØªØ®Ø¯Ù…Ùˆ Ø§Ù„Ø²Ø¨ÙˆÙ† - Ø´Ø±ÙƒØ§Ø¡ Ø§Ù„ØªØ¹Ø§Ù…Ù„',0),(282666,7852,'fr','Utilisateurs B2B',0),(282667,7852,'jp','B2B ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(282668,7852,'pt','UsuÃ¡rios B2B',0),(282669,7852,'ru','B2B ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸',0),(282670,7852,'es','N2N Usuarios',0),(282671,7852,'de','B2B Benutzer',0),(282672,7852,'en','B2B Users',0),(282673,7853,'is','',0),(282674,7853,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ù…Ø§Ù†Ø¯Ù‡',0),(282675,7853,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ Ù…Ø§Ù†Ø¯Ù‡',0),(282676,7853,'tr','Bakiye geÃ§miÅŸi',0),(282677,7853,'pl','Historia rÃ³wnowagi',0),(282678,7853,'bg','Ð‘Ð°Ð»Ð°Ð½Ñ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(282679,7853,'ur','ØªÙˆØ§Ø²Ù† Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(282680,7853,'sr','Ð¡Ð°Ð»Ð´Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(282681,7853,'vi','Lá»‹ch sá»­ sá»‘ dÆ°',0),(282682,7853,'af','Balans Geskiedenis',0),(282683,7853,'ro','Echilibru istorie',0),(282684,7853,'et','Saldo ajalugu',0),(282685,7853,'si','Zgodovina ravnovesje',0),(282686,7853,'ba','Keseimbangan sejarah',0),(282687,7853,'nl','Evenwicht geschiedenis',0),(282688,7853,'fi','Balance historia',0),(282689,7853,'no','Balanse historie',0),(282690,7853,'da','Balance historie',0),(282691,7853,'ko','ëŒ€ì°¨ ì—­ì‚¬',0),(282692,7853,'he','××™×–×•×Ÿ ×”×™×¡×˜×•×¨×™×”',0),(282693,7853,'el','Î™ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(282694,7853,'zh','ä½™é¢åŽ†å²\r\n',0),(282695,7853,'sv','Balans historia',0),(282696,7853,'it','Storia di equilibrio',0),(282697,7853,'tl','',0),(282698,7853,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(282699,7853,'hi','à¤¶à¥‡à¤· à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(282700,7853,'ms','Baki sejarah',0),(282701,7853,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø±ØµÙŠØ¯',0),(282702,7853,'fr','Histoire d\'Ã©quilibre',0),(282703,7853,'jp','ãƒãƒ©ãƒ³ã‚¹ã®æ­´å²',0),(282704,7853,'pt','HistÃ³ria de equilÃ­brio',0),(282705,7853,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð‘Ð°Ð»Ð°Ð½ÑÐ°',0),(282706,7853,'es','Historia de Balance',0),(282707,7853,'de','Balance-Geschichte',0),(282708,7853,'en','Balance History',0),(282709,7854,'is','',0),(282710,7854,'dr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡',0),(282711,7854,'pr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡',0),(282712,7854,'tr','Ã–denen fatura deÄŸil',0),(282713,7854,'pl','Zapowiadane nie pÅ‚atne',0),(282714,7854,'bg','ÐÐµ Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ñ‚ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(282715,7854,'ur','ØªÙ†Ø®ÙˆØ§Û Ù†Û Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(282716,7854,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð½Ð¸Ñ˜Ðµ Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(282717,7854,'vi','HÃ³a ÄÆ¡n ChÆ°a Tráº£',0),(282718,7854,'af','WeerspieÃ«l nie betaalde',0),(282719,7854,'ro','Facturate nu plÄƒtit',0),(282720,7854,'et','Arve ei ole tasutud',0),(282721,7854,'si','ZaraÄunali ne plaÄa',0),(282722,7854,'ba','Ditagih tidak dibayar',0),(282723,7854,'nl','Gefactureerd niet betaalde',0),(282724,7854,'fi','Laskutetaan ei maksettu',0),(282725,7854,'no','Fakturert ikke betalt',0),(282726,7854,'da','Faktureres ikke betalt',0),(282727,7854,'ko','ì§€ê¸‰ ì²­êµ¬',0),(282728,7854,'he','×œ× ×ª×—×•×™×‘ ×‘×ª×©×œ×•×',0),(282729,7854,'el','Î”ÎµÎ½ Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹ Ï€Î»Î·ÏÏ‰Î¼Î­Î½Î·',0),(282730,7854,'zh','ä¸æ”¯ä»˜å¸å•\r\n',0),(282731,7854,'sv','Faktureras inte betalas',0),(282732,7854,'it','Fatturati non pagati',0),(282733,7854,'tl','',0),(282734,7854,'th','&#3610;&#3636;&#3621;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(282735,7854,'hi','à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚',0),(282736,7854,'ms','Dibilkan tidak dibayar',0),(282737,7854,'ar','ÙÙˆØ§ØªÙŠØ± ØºÙŠØ± Ù…Ø¯ÙÙˆØ¹Ø© Ø§Ù„Ø£Ø¬Ø±',0),(282738,7854,'fr','FacturÃ© pas payÃ©',0),(282739,7854,'jp','æœ‰æ–™ã«è«‹æ±‚',0),(282740,7854,'pt','NÃ£o faturado pagos',0),(282741,7854,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð½Ðµ Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ð¹',0),(282742,7854,'es','Facturado no Pagado',0),(282743,7854,'de','Rechnung nicht bezahlt',0),(282744,7854,'en','Billed Not Paid',0),(282745,7855,'is','',0),(282746,7855,'dr',' ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯Ù‡Ø§ ',0),(282747,7855,'pr',' ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯Ù‡Ø§ ',0),(282748,7855,'tr','DoÄŸum gÃ¼nÃ¼',0),(282749,7855,'pl','Urodziny',0),(282750,7855,'bg','Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸ Ð´Ð½Ð¸',0),(282751,7855,'ur','Ø³Ø§Ù„Ú¯Ø±Û',0),(282752,7855,'sr','Ð Ð¾Ñ’ÐµÐ½Ð´Ð°Ð½Ð¸',0),(282753,7855,'vi','NgÃ y sinh',0),(282754,7855,'af','Verjaarsdae',0),(282755,7855,'ro','Aniversari',0),(282756,7855,'et','SÃ¼nnipÃ¤evad',0),(282757,7855,'si','Rojstni dnevi',0),(282758,7855,'ba','Ulang tahun',0),(282759,7855,'nl','Verjaardagen',0),(282760,7855,'fi','SyntymÃ¤pÃ¤ivÃ¤t',0),(282761,7855,'no','Bursdager',0),(282762,7855,'da','FÃ¸dselsdage',0),(282763,7855,'ko','ìƒì¼',0),(282764,7855,'he','×™×ž×™ ×”×•×œ×“×ª',0),(282765,7855,'el','Î“ÎµÎ½Î­Î¸Î»Î¹Î±',0),(282766,7855,'zh','ç”Ÿæ—¥\r\n',0),(282767,7855,'sv','FÃ¶delsedagar',0),(282768,7855,'it','Compleanni',0),(282769,7855,'tl','',0),(282770,7855,'th','&#3623;&#3633;&#3609;&#3648;&#3585;&#3636;&#3604;',0),(282771,7855,'hi','à¤œà¤¨à¥à¤®à¤¦à¤¿à¤¨',0),(282772,7855,'ms','Hari lahir',0),(282773,7855,'ar','Ø£Ø¹ÙŠØ§Ø¯ Ø§Ù„Ù…ÙŠÙ„Ø§Ø¯',0),(282774,7855,'fr','Anniversaires',0),(282775,7855,'jp','èª•ç”Ÿæ—¥',0),(282776,7855,'pt','AniversÃ¡rios',0),(282777,7855,'ru','Ð”Ð½Ð¸ Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(282778,7855,'es','CumpleaÃ±os',0),(282779,7855,'de','Geburtstage',0),(282780,7855,'en','Birthdays',0),(282781,7856,'is','',0),(282782,7856,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ùˆ Ú†Ùƒ Ù‡Ø§',0),(282783,7856,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ùˆ Ú†Ùƒ Ù‡Ø§',0),(282784,7856,'tr','Hesaplamalar/Ã§ek',0),(282785,7856,'pl','Obliczenia/kontroli',0),(282786,7856,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ/Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(282787,7856,'ur','Ø­Ø³Ø§Ø¨/Ú†ÛŒÚ©',0),(282788,7856,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ°/Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(282789,7856,'vi','TÃ­nh toÃ¡n & ra SÃ©c',0),(282790,7856,'af','Berekeninge en Tjeks',0),(282791,7856,'ro','Calculele/controale',0),(282792,7856,'et','Arvutused/kontroll',0),(282793,7856,'si','IzraÄuni/pregledi',0),(282794,7856,'ba','Perhitungan cek',0),(282795,7856,'nl','Berekeningen/controles',0),(282796,7856,'fi','Laskelmat/tarkastukset',0),(282797,7856,'no','Beregninger/sjekker',0),(282798,7856,'da','Beregninger/kontrol',0),(282799,7856,'ko','ê³„ì‚°/ê²€ì‚¬',0),(282800,7856,'he','×—×™×©×•×‘×™×/×‘×“×™×§×•×ª',0),(282801,7856,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Î¯/Î­Î»ÎµÎ³Ï‡Î¿Î¹',0),(282802,7856,'zh','è®¡ç®—å’Œæ£€æŸ¥\r\n',0),(282803,7856,'sv','BerÃ¤kningar/kontroller',0),(282804,7856,'it','Calcoli/verifiche',0),(282805,7856,'tl','',0),(282806,7856,'th','&#3588;&#3635;&#3609;&#3623;&#3603;&#3649;&#3621;&#3632;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;',0),(282807,7856,'hi','à¤—à¤£à¤¨à¤¾/à¤šà¥‡à¤•',0),(282808,7856,'ms','Pengiraan/pemeriksaan',0),(282809,7856,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø¬ÙˆØ±',0),(282810,7856,'fr','Calculs/chÃ¨ques',0),(282811,7856,'jp','è¨ˆç®—/ãƒã‚§ãƒƒã‚¯',0),(282812,7856,'pt','CÃ¡lculos/cheques',0),(282813,7856,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ñ‹/Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(282814,7856,'es','CÃ¡lculo y Cheques',0),(282815,7856,'de','Berechnungen/PrÃ¼fungen',0),(282816,7856,'en','Calculations/Checks',0),(282817,7857,'is','',0),(282818,7857,'dr','Ø±ÙˆØ´Ù‡Ø§ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(282819,7857,'pr','Ø±ÙˆØ´Ù‡Ø§ÙŠ Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡',0),(282820,7857,'tr','TaÅŸÄ±yÄ±cÄ± yÃ¶ntemleri',0),(282821,7857,'pl','Metody przewoÅºnika',0),(282822,7857,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ Ð¼ÐµÑ‚Ð¾Ð´Ð¸',0),(282823,7857,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ú©Û’ Ø·Ø±ÛŒÙ‚Û’',0),(282824,7857,'sr','ÐÐ¾ÑÐ°Ñ‡ Ð¼ÐµÑ‚Ð¾Ð´Ðµ',0),(282825,7857,'vi','PhÆ°Æ¡ng thá»©c chuyá»ƒn hÃ ng',0),(282826,7857,'af','Karweier Metodes',0),(282827,7857,'ro','Metode de transport',0),(282828,7857,'et','Vedaja meetodid',0),(282829,7857,'si','Prevoznik metode',0),(282830,7857,'ba','Metode pembawa',0),(282831,7857,'nl','Vervoerder methoden',0),(282832,7857,'fi','Harjoittaja menetelmien',0),(282833,7857,'no','TransportÃ¸r metoder',0),(282834,7857,'da','Carrier metoder',0),(282835,7857,'ko','ìºë¦¬ì–´ ë°©ë²•',0),(282836,7857,'he','×©×™×˜×•×ª ×”×ž×•×‘×™×œ',0),(282837,7857,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Î±Ï‚ Î¼ÎµÎ¸ÏŒÎ´Î¿Ï…Ï‚',0),(282838,7857,'zh','è½½æ³¢æ–¹æ³•\r\n',0),(282839,7857,'sv','Carrier metoder',0),(282840,7857,'it','Metodi vettore',0),(282841,7857,'tl','',0),(282842,7857,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(282843,7857,'hi','à¤µà¤¾à¤¹à¤• à¤µà¤¿à¤§à¤¿à¤¯à¤¾à¤',0),(282844,7857,'ms','Kaedah-kaedah pengangkutan',0),(282845,7857,'ar','Ø·Ø±Ù‚ Ø§Ù„Ù†Ù‚Ù„',0),(282846,7857,'fr','MÃ©thodes transporteur',0),(282847,7857,'jp','ã‚­ãƒ£ãƒªã‚¢ ãƒ¡ã‚½ãƒƒãƒ‰',0),(282848,7857,'pt','MÃ©todos de transportadora',0),(282849,7857,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº Ð¼ÐµÑ‚Ð¾Ð´Ñ‹',0),(282850,7857,'es','Transportador MÃ©todos',0),(282851,7857,'de','Carrier-Methoden',0),(282852,7857,'en','Carrier Methods',0),(282853,7858,'is','',0),(282854,7858,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(282855,7858,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡ ',0),(282856,7858,'tr','KapalÄ± sipariÅŸler',0),(282857,7858,'pl','ZamkniÄ™te zamÃ³wienia',0),(282858,7858,'bg','ÐŸÑ€Ð¸ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(282859,7858,'ur','Ø¨Ù†Ø¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(282860,7858,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(282861,7858,'vi','ÄÃ³ng ÄÆ¡n Äáº·t HÃ ng',0),(282862,7858,'af','Afgesluite Bestelling',0),(282863,7858,'ro','ÃŽnchis comenzi',0),(282864,7858,'et','Suletud tellimused',0),(282865,7858,'si','Zaprtimi nalogi',0),(282866,7858,'ba','Pesanan Ditutup',0),(282867,7858,'nl','Gesloten Orders',0),(282868,7858,'fi','Suljettuja tilauksia',0),(282869,7858,'no','Avsluttede ordrer',0),(282870,7858,'da','Lukkede ordrer',0),(282871,7858,'ko','íì‡„ ëª…ë ¹',0),(282872,7858,'he','×œ×”×–×ž× ×•×ª ×¡×’×•×¨×•×ª',0),(282873,7858,'el','ÎšÎ»ÎµÎ¹ÏƒÏ„ÏŽÎ½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(282874,7858,'zh','å°é—­ä»¤\r\n',0),(282875,7858,'sv','StÃ¤ngda order',0),(282876,7858,'it','Ordini Chiusi',0),(282877,7858,'tl','',0),(282878,7858,'th','&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3649;&#3621;&#3657;&#3623;',0),(282879,7858,'hi','à¤¬à¤‚à¤¦ à¤†à¤¦à¥‡à¤¶',0),(282880,7858,'ms','Tutup',0),(282881,7858,'ar','Ø£ÙˆØ§Ù…Ø± Ù…ØºÙ„Ù‚Ø©',0),(282882,7858,'fr','Commandes ferme',0),(282883,7858,'jp','ã‚¯ãƒ­ãƒ¼ã‚ºæ¸ˆã®æ³¨æ–‡',0),(282884,7858,'pt','Ordens fechadas',0),(282885,7858,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(282886,7858,'es','Pedidos Cerrrados',0),(282887,7858,'de','Geschlossene Orders',0),(282888,7858,'en','Closed Orders',0),(282889,7859,'is','',0),(282890,7859,'dr','/  Ø³ØªÙˆÙ† Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(282891,7859,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ  ØªØ±Ø§Ø² Ù†Ø§Ù…Ù‡  Ø¯Ø± Ø´ÙƒÙ„  Ø³ØªÙˆÙ†  Ø¨Ø¯Ù‡Ù‰ /  Ø³ØªÙˆÙ† Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(282892,7859,'tr','BorÃ§/alacak bir bilanÃ§o oluÅŸturma',0),(282893,7859,'pl','Tworzenie bilansu w Format debetu/kredytu',0),(282894,7859,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ð»Ð°Ð½Ñ Ð² Ð´ÐµÐ±Ð¸Ñ‚Ð½Ð°/ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(282895,7859,'ur','Ú©Ø§ Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ ÚˆÛŒØ¨ÙÙ¹/Ú©Ø±ÛŒÚˆÙÙ¹ Ú©ÛŒ Ø´Ú©Ù„ Ù…ÛŒÚº Ø¨Ù†Ø§Ø¦ÛŒÚº Û”',0),(282896,7859,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð±Ð¸Ð»Ð°Ð½ÑÐ° Ñƒ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°/Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(282897,7859,'vi','Táº¡o Báº£ng CÃ¢n Äá»‘i Káº¿ ToÃ¡n Theo Dáº¡ng Ná»£/CÃ³',0),(282898,7859,'af','Skep \'n Balansstaat in Debiet-/Kredietformaat',0),(282899,7859,'ro','CreaÅ£i un bilanÅ£ Ã®n Format de Debit/Credit',0),(282900,7859,'et','Luua bilanss Deebet/kreedit formaadis',0),(282901,7859,'si','Ustvarite bilance stanja v obliki debetne/kreditne',0),(282902,7859,'ba','Membuat neraca dalam Format Debit/Kredit',0),(282903,7859,'nl','Maak een debet/credit balans',0),(282904,7859,'fi','Luoda taseen debet/kredit-muodossa',0),(282905,7859,'no','Opprette en balanse i debet/kredit-Format',0),(282906,7859,'da','Opret en balance i Debet/kreditkort Format',0),(282907,7859,'ko','ëŒ€ì°¨ ëŒ€ì¡°í‘œ ì°¨ë³€/ëŒ€ë³€ í˜•ì‹ ë§Œë“¤ê¸°',0),(282908,7859,'he','×œ×™×¦×•×¨ ×¡×™×›×•× ×ž××–×Ÿ ×‘×ª×‘× ×™×ª ×—×™×•×‘/×–×™×›×•×™',0),(282909,7859,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î­Î½Î± Ï†ÏÎ»Î»Î¿ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± ÏƒÎµ Î¼Î¿ÏÏ†Î® Ï‡ÏÎµÏ‰ÏƒÏ„Î¹ÎºÎ®/Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®',0),(282910,7859,'zh','å»ºç«‹èµ„äº§è´Ÿå€ºè¡¨ä¸­å€Ÿè®°/ä¿¡ç”¨æ ¼å¼\r\n',0),(282911,7859,'sv','Skapa en balansrÃ¤kning i debet/kredit-Format',0),(282912,7859,'it','Creare un bilancio in formato di debito/credito',0),(282913,7859,'tl','',0),(282914,7859,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3591;&#3610;&#3604;&#3640;&#3621;&#3651;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3648;&#3604;&#3610;&#3636;&#3605;/&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(282915,7859,'hi','à¤à¤• à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ à¤¡à¥‡à¤¬à¤¿à¤Ÿ/à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¬à¤¨à¤¾à¤à¤',0),(282916,7859,'ms','Mencipta kunci kira-kira dalam Format Debit/kredit',0),(282917,7859,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙˆØ±Ù‚Ø© Ø§Ù„ØªÙˆØ§Ø²Ù† ÙÙŠ ØªÙ†Ø³ÙŠÙ‚ Ù…Ø¯ÙŠÙ†/Ø¯Ø§Ø¦Ù†',0),(282918,7859,'fr','CrÃ©er un bilan sous forme de dÃ©bit/crÃ©dit',0),(282919,7859,'jp','ãƒ‡ãƒ“ãƒƒãƒˆ/ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰å½¢å¼ã§ãƒãƒ©ãƒ³ã‚¹ ã‚·ãƒ¼ãƒˆã‚’ä½œæˆã—ã¾ã™ã€‚',0),(282920,7859,'pt','Criar um balanÃ§o em formato de dÃ©bito/crÃ©dito',0),(282921,7859,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð±Ð°Ð»Ð°Ð½Ñ Ð² Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ Ð´ÐµÐ±ÐµÑ‚Ð°/ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(282922,7859,'es','Crear un Hoja de Balance en el Formato DÃ©bito/CrÃ©dito',0),(282923,7859,'de','Erstellen Sie eine Bilanz im soll-/haben-Format',0),(282924,7859,'en','Create a Balance Sheet in Debit/Credit Format',0),(282925,7860,'is','',0),(282926,7860,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯',0),(282927,7860,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯',0),(282928,7860,'tr','Yeni bir satÄ±cÄ± oluÅŸturmak',0),(282929,7860,'pl','Tworzenie nowej ustawy dostawcy',0),(282930,7860,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(282931,7860,'ur','Ø§ÛŒÚ© Ù†ÛŒØ§ ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(282932,7860,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(282933,7860,'vi','Táº¡o má»™t giao dá»‹ch ngÆ°á»i bÃ¡n má»›i',0),(282934,7860,'af','Skep \'n nuwe Wetsontwerp handelaar',0),(282935,7860,'ro','CreaÅ£i un nou proiect de lege de furnizor',0),(282936,7860,'et','Loo uus hankija arve',0),(282937,7860,'si','Ustvarite nov raÄun dobavitelja',0),(282938,7860,'ba','Membuat tagihan Vendor baru',0),(282939,7860,'nl','Maken van een nieuwe leverancier Bill',0),(282940,7860,'fi','Luo uusi toimittajan lasku',0),(282941,7860,'no','Opprette en ny leverandÃ¸r-regning',0),(282942,7860,'da','Oprette en ny kreditor Bill',0),(282943,7860,'ko','ìƒˆë¡œìš´ ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œë¥¼ ìž‘ì„±',0),(282944,7860,'he','×¦×•×¨ ×—×©×‘×•×Ÿ ×¡×¤×§ ×—×“×©',0),(282945,7860,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î­Î½Î± Î½Î­Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(282946,7860,'zh','åˆ›å»ºæ–°çš„ä¾›åº”å•†å¸å•\r\n',0),(282947,7860,'sv','Skapa ett nytt lagfÃ¶rslag fÃ¶r leverantÃ¶r',0),(282948,7860,'it','Creare una nuova fattura fornitore',0),(282949,7860,'tl','',0),(282950,7860,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3592;&#3634;&#3585;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(282951,7860,'hi','à¤à¤• à¤¨à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤¬à¤¨à¤¾à¤¨à¤¾',0),(282952,7860,'ms','Mencipta yang baru penjual Rang undang-undang',0),(282953,7860,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ù…ÙˆØ±Ù‘Ø¯',0),(282954,7860,'fr','CrÃ©ez un nouveau projet de loi du vendeur',0),(282955,7860,'jp','æ–°ã—ã„ä»•å…¥å…ˆè«‹æ±‚æ›¸ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(282956,7860,'pt','Criar uma nova conta de fornecedor',0),(282957,7860,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÑƒ Ð‘Ð¸Ð»Ð»',0),(282958,7860,'es','Crear un Recibo de Nueva Proveedor',0),(282959,7860,'de','Erstellen Sie eine neue Rechnung Kreditor',0),(282960,7860,'en','Create a New Vendor Bill',0),(282961,7861,'is','',0),(282962,7861,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ø¬Ø¯ÙŠØ¯',0),(282963,7861,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ø¬Ø¯ÙŠØ¯',0),(282964,7861,'tr','Banka MevduatÄ± oluÅŸturun',0),(282965,7861,'pl','Tworzenie depozytÃ³w bankowych',0),(282966,7861,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(282967,7861,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ø°Ø®Ø§Ø¦Ø± Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(282968,7861,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ ÑˆÑ‚ÐµÐ´Ð½Ð¸Ñ… ÑƒÐ»Ð¾Ð³Ð°',0),(282969,7861,'vi','Táº¡o 1 SÃ©c ghi má»£ ',0),(282970,7861,'af','Skep Bank Deposito\'s',0),(282971,7861,'ro','Crearea depozitelor bancare',0),(282972,7861,'et','Loo pangadeposiidid',0),(282973,7861,'si','Ustvarite banÄnih vlog',0),(282974,7861,'ba','Membuat deposito Bank',0),(282975,7861,'nl','Bank deposito\'s maken',0),(282976,7861,'fi','Luo pankkiin',0),(282977,7861,'no','Opprette bankinnskudd',0),(282978,7861,'da','Oprette bankindskud',0),(282979,7861,'ko','ì€í–‰ ì˜ˆê¸ˆ ë§Œë“¤ê¸°',0),(282980,7861,'he','×¦×•×¨ ×¤×§×“×•× ×•×ª ×‘× ×§',0),(282981,7861,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ­Ï‚ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚',0),(282982,7861,'zh','å»ºç«‹é“¶è¡Œå­˜æ¬¾\r\n',0),(282983,7861,'sv','Skapa bankinlÃ¥ning',0),(282984,7861,'it','Creare depositi bancari',0),(282985,7861,'tl','',0),(282986,7861,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(282987,7861,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(282988,7861,'ms','Membuat deposit Bank',0),(282989,7861,'ar','Ø®Ù„Ù‚ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(282990,7861,'fr','CrÃ©er des dÃ©pÃ´ts bancaires',0),(282991,7861,'jp','éŠ€è¡Œé é‡‘ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(282992,7861,'pt','Criar depÃ³sitos bancÃ¡rios',0),(282993,7861,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹',0),(282994,7861,'es','Crear Depositos Bancarios',0),(282995,7861,'de','Erstellen von Bankeinlagen',0),(282996,7861,'en','Create Bank Deposits',0),(282997,7862,'is','',0),(282998,7862,'dr','/ Ø§ØµÙ„Ø§Ø­   Ø¨ÛŒØ¬Ú© ',0),(282999,7862,'pr','Ø§ÙŠØ¬Ø§Ø¯  / ÙˆÙŠØ±Ø§ÙŠØ´  ÙØ§ÙƒØªÙˆØ± ',0),(283000,7862,'tr','Fatura OluÅŸtur/DÃ¼zenle',0),(283001,7862,'pl','UtwÃ³rz/Edytuj faktury',0),(283002,7862,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(283003,7862,'ur','ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº/ØªØ¯ÙˆÛŒÙ† Ø§Ù†ÙˆØ§Ø¦Ø³',0),(283004,7862,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(283005,7862,'vi','Táº¡o Má»›i/Sá»­a HÃ³a ÄÆ¡n',0),(283006,7862,'af','Skep/Redigeer Faktuur',0),(283007,7862,'ro','Creare/editare facturÄƒ',0),(283008,7862,'et','Loo/Muuda arveid',0),(283009,7862,'si','Ustvarjanje/urejanje raÄuna',0),(283010,7862,'ba','Membuat Edit faktur',0),(283011,7862,'nl','Factuur maken/bewerken',0),(283012,7862,'fi','Laskun luominen tai muokkaaminen',0),(283013,7862,'no','Opprette og redigere faktura',0),(283014,7862,'da','Opret/Rediger faktura',0),(283015,7862,'ko','ê³„ì‚° ë§Œë“¤ê¸°/íŽ¸ì§‘',0),(283016,7862,'he','×¦×•×¨/×¢×¨×•×š ×—×©×‘×•× ×™×ª',0),(283017,7862,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(283018,7862,'zh','åˆ›å»º/ç¼–è¾‘å‘ç¥¨\r\n',0),(283019,7862,'sv','Skapa eller redigera faktura',0),(283020,7862,'it','Crea/modifica fattura',0),(283021,7862,'tl','',0),(283022,7862,'th','&#3626;&#3619;&#3657;&#3634;&#3591;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(283023,7862,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¬à¤¨à¤¾à¤à¤/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283024,7862,'ms','Buat/Edit invois',0),(283025,7862,'ar','Ø¥Ù†Ø´Ø§Ø¡/ØªØ­Ø±ÙŠØ± Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(283026,7862,'fr','CrÃ©er/modifier la facture',0),(283027,7862,'jp','è«‹æ±‚æ›¸ã®ä½œæˆ/ç·¨é›†',0),(283028,7862,'pt','Criar/editar a factura',0),(283029,7862,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚',0),(283030,7862,'es','Crear/Editar Factura',0),(283031,7862,'de','Rechnung erstellen/bearbeiten',0),(283032,7862,'en','Create/Edit Invoice',0),(283033,7863,'is','',0),(283034,7863,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(283035,7863,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(283036,7863,'tr','Kredi kartÄ± seÃ§enekleri',0),(283037,7863,'pl','Opcje kart kredytowych',0),(283038,7863,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(283039,7863,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(283040,7863,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ',0),(283041,7863,'vi','Lá»±a Chá»n Tháº» TÃ­n Dá»¥ng',0),(283042,7863,'af','Kredietkaart Opsies',0),(283043,7863,'ro','OpÅ£iuni de Card de credit',0),(283044,7863,'et','Krediitkaardi vÃµimalused',0),(283045,7863,'si','Kreditno kartico moÅ¾nosti',0),(283046,7863,'ba','Pilihan kartu kredit',0),(283047,7863,'nl','Creditcard opties',0),(283048,7863,'fi','Luottokortin asetukset',0),(283049,7863,'no','Kredittkort alternativer',0),(283050,7863,'da','Credit Card indstillinger',0),(283051,7863,'ko','ì‹ ìš© ì¹´ë“œ ì˜µì…˜',0),(283052,7863,'he','××¤×©×¨×•×™×•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(283053,7863,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(283054,7863,'zh','ä¿¡ç”¨å¡é€‰é¡¹\r\n',0),(283055,7863,'sv','Kreditkort alternativ',0),(283056,7863,'it','Opzioni di carta di credito',0),(283057,7863,'tl','',0),(283058,7863,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(283059,7863,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(283060,7863,'ms','Pilihan kad kredit',0),(283061,7863,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(283062,7863,'fr','Cartes de crÃ©dit',0),(283063,7863,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(283064,7863,'pt','OpÃ§Ãµes de cartÃ£o de crÃ©dito',0),(283065,7863,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ñ‹',0),(283066,7863,'es','Tarjeta de CrÃ©dito Opciones',0),(283067,7863,'de','Kreditkarte-Optionen',0),(283068,7863,'en','Credit Card Options',0),(283069,7864,'is','',0),(283070,7864,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(283071,7864,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(283072,7864,'tr','MÃ¼ÅŸteri bilgileri',0),(283073,7864,'pl','Informacje o klientach',0),(283074,7864,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(283075,7864,'ur','Ú¯Ø§ÛÚ© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(283076,7864,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐºÑƒÐ¿Ñ†Ñƒ',0),(283077,7864,'vi','ThÃ´ng tin khÃ¡ch hÃ ng',0),(283078,7864,'af','Klant / KliÃ«nt Inligting',0),(283079,7864,'ro','InformaÅ£iile despre clienÅ£i',0),(283080,7864,'et','Kliendi informatsioon',0),(283081,7864,'si','Podatki o stranki',0),(283082,7864,'ba','Informasi pelanggan',0),(283083,7864,'nl','Klantgegevens',0),(283084,7864,'fi','Asiakkaan tiedot',0),(283085,7864,'no','Kundeinformasjon',0),(283086,7864,'da','Kundeoplysninger',0),(283087,7864,'ko','ê³ ê° ì •ë³´',0),(283088,7864,'he','×ž×™×“×¢ ×œ×§×•×—',0),(283089,7864,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(283090,7864,'zh','å®¢æˆ·ä¿¡æ¯',0),(283091,7864,'sv','Kundinformation',0),(283092,7864,'it','Informazioni cliente',0),(283093,7864,'tl','',0),(283094,7864,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(283095,7864,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(283096,7864,'ms','Maklumat pelanggan',0),(283097,7864,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(283098,7864,'fr','Renseignements sur les clients',0),(283099,7864,'jp','é¡§å®¢æƒ…å ±',0),(283100,7864,'pt','InformaÃ§Ãµes do cliente',0),(283101,7864,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ðž ÐšÐ»Ð¸ÐµÐ½Ñ‚Ðµ',0),(283102,7864,'es','Cliente InformaciÃ³n',0),(283103,7864,'de','Kundeninformationen',0),(283104,7864,'en','Customer Information',0),(283105,7865,'is','',0),(283106,7865,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(283107,7865,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(283108,7865,'tr','DoÄŸrudan mevduat',0),(283109,7865,'pl','BezpoÅ›rednich wpÅ‚at',0),(283110,7865,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(283111,7865,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹Ø³',0),(283112,7865,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(283113,7865,'vi','Giao dá»‹ch trá»±c tiáº¿p',0),(283114,7865,'af','Direkte Deposito\'s',0),(283115,7865,'ro','Depozite directe',0),(283116,7865,'et','Otsesed deposiitide',0),(283117,7865,'si','Neposredne vloge',0),(283118,7865,'ba','Deposit langsung',0),(283119,7865,'nl','Directe stortingen',0),(283120,7865,'fi','Suoraan talletuksia',0),(283121,7865,'no','Direkte innskudd',0),(283122,7865,'da','Direkte indskud',0),(283123,7865,'ko','ì§ì ‘ ì˜ˆê¸ˆ',0),(283124,7865,'he','×¤×§×“×•× ×•×ª ×™×©×™×¨×•×ª',0),(283125,7865,'el','Î†Î¼ÎµÏƒÎµÏ‚ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚',0),(283126,7865,'zh','ç›´æŽ¥å­˜æ¬¾\r\n',0),(283127,7865,'sv','Direkta insÃ¤ttningar',0),(283128,7865,'it','Depositi diretti',0),(283129,7865,'tl','',0),(283130,7865,'th','&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(283131,7865,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾',0),(283132,7865,'ms','Deposit terus',0),(283133,7865,'ar','Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø©',0),(283134,7865,'fr','DÃ©pÃ´ts directs',0),(283135,7865,'jp','ç›´æŽ¥é é‡‘å£åº§æŒ¯è¾¼',0),(283136,7865,'pt','DepÃ³sitos diretos',0),(283137,7865,'ru','ÐŸÑ€ÑÐ¼Ñ‹Ðµ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹',0),(283138,7865,'es','DepÃ³sitos Directos',0),(283139,7865,'de','Direkte Einzahlungen',0),(283140,7865,'en','Direct Deposits',0),(283141,7866,'is','',0),(283142,7866,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(283143,7866,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ',0),(283144,7866,'tr','DÃ¼zenle banka mevduat',0),(283145,7866,'pl','Edytuj przelew',0),(283146,7866,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð±Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(283147,7866,'ur','ØªØ¯ÙˆÛŒÙ† Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹',0),(283148,7866,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð±Ð°Ð½ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(283149,7866,'vi','Sá»­a Tiá»n Cá»c Trong NgÃ¢n HÃ ng',0),(283150,7866,'af','Redigeer Bank Deposito',0),(283151,7866,'ro','Depozit bancar de editare',0),(283152,7866,'et','Redigeeri pangahoiuste',0),(283153,7866,'si','Urejanje banÄni depozit',0),(283154,7866,'ba','Deposito Edit Bank',0),(283155,7866,'nl','Bewerken Bank storting',0),(283156,7866,'fi','Muokkaa Bank Deposit',0),(283157,7866,'no','Rediger bankinnskudd',0),(283158,7866,'da','Rediger Bank depositum',0),(283159,7866,'ko','íŽ¸ì§‘ ì€í–‰ ì˜ˆê¸ˆ',0),(283160,7866,'he','×¤×™×§×“×•×Ÿ ×”×‘× ×§ ×¢×¨×™×›×”',0),(283161,7866,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ®Ï‚ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(283162,7866,'zh','ç¼–è¾‘é“¶è¡Œå­˜æ¬¾\r\n',0),(283163,7866,'sv','Redigera Bank insÃ¤ttning',0),(283164,7866,'it','Modifica banca deposito',0),(283165,7866,'tl','',0),(283166,7866,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(283167,7866,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾',0),(283168,7866,'ms','Deposit Edit Bank',0),(283169,7866,'ar','ØªØ­Ø±ÙŠØ± Ø¥ÙŠØ¯Ø§Ø¹ Ù…ØµØ±ÙÙŠ',0),(283170,7866,'fr','DÃ©pÃ´t bancaire Edit',0),(283171,7866,'jp','ç·¨é›†éŠ€è¡Œé é‡‘',0),(283172,7866,'pt','DepÃ³sito bancÃ¡rio de editar',0),(283173,7866,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(283174,7866,'es','Editar DepÃ³sito Bancario',0),(283175,7866,'de','Bearbeiten Bank hinterlegen',0),(283176,7866,'en','Edit Bank Deposit',0),(283177,7867,'is','',0),(283178,7867,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§',0),(283179,7867,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§',0),(283180,7867,'tr','Fatura dÃ¼zenleme',0),(283181,7867,'pl','Edytuj rachunki',0),(283182,7867,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(283183,7867,'ur','Ø¨Ù„ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283184,7867,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(283185,7867,'vi','Sá»­a HÃ³a ÄÆ¡n',0),(283186,7867,'af','Redigeer Rekeninge',0),(283187,7867,'ro','Edita facturi',0),(283188,7867,'et','Muuda arveid',0),(283189,7867,'si','Urejanje raÄunov',0),(283190,7867,'ba','Mengedit tagihan',0),(283191,7867,'nl','Bewerken van rekeningen',0),(283192,7867,'fi','Muokkaa tuoterakenteita',0),(283193,7867,'no','Redigere regninger',0),(283194,7867,'da','Redigere regninger',0),(283195,7867,'ko','ì²­êµ¬ì„œë¥¼ íŽ¸ì§‘',0),(283196,7867,'he','×¢×¨×•×š ×—×©×‘×•× ×•×ª',0),(283197,7867,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(283198,7867,'zh','ä¿®æ”¹è‰æ¡ˆ\r\n',0),(283199,7867,'sv','Redigera rÃ¤kningar',0),(283200,7867,'it','Modifica di fatture',0),(283201,7867,'tl','',0),(283202,7867,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(283203,7867,'hi','à¤¬à¤¿à¤²à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283204,7867,'ms','Edit bil-bil',0),(283205,7867,'ar','ØªØ­Ø±ÙŠØ± Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(283206,7867,'fr','Ã‰diter des factures',0),(283207,7867,'jp','è«‹æ±‚æ›¸ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283208,7867,'pt','Editar notas',0),(283209,7867,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¾Ð²',0),(283210,7867,'es','Editar Facturas',0),(283211,7867,'de','Bearbeiten von Rechnungen',0),(283212,7867,'en','Edit Bills',0),(283213,7868,'is','',0),(283214,7868,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(283215,7868,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(283216,7868,'tr','MÃ¼ÅŸteri DÃ¼zenle',0),(283217,7868,'pl','Edycja klientÃ³w',0),(283218,7868,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(283219,7868,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283220,7868,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÑƒÐ¿Ñ†Ð°',0),(283221,7868,'vi','Sá»­a KhÃ¡ch HÃ ng',0),(283222,7868,'af','Redigeer KliÃ«nt/Klant',0),(283223,7868,'ro','Editare client',0),(283224,7868,'et','Muuda klienti',0),(283225,7868,'si','Urejanje kupca',0),(283226,7868,'ba','Mengedit pelanggan',0),(283227,7868,'nl','Bewerken van klant',0),(283228,7868,'fi','Muokkaa asiakasta',0),(283229,7868,'no','Redigere kunde',0),(283230,7868,'da','Rediger kunde',0),(283231,7868,'ko','ê³ ê° íŽ¸ì§‘',0),(283232,7868,'he','×¢×¨×•×š ×œ×§×•×—',0),(283233,7868,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï€ÎµÎ»Î¬Ï„Î·',0),(283234,7868,'zh','ç¼–è¾‘å®¢æˆ·\r\n',0),(283235,7868,'sv','Redigera kund',0),(283236,7868,'it','Modifica cliente',0),(283237,7868,'tl','',0),(283238,7868,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(283239,7868,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283240,7868,'ms','Edit pelanggan',0),(283241,7868,'ar','ØªØ­Ø±ÙŠØ± Ø²Ø¨ÙˆÙ†',0),(283242,7868,'fr','Ã‰diter le client',0),(283243,7868,'jp','é¡§å®¢ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283244,7868,'pt','Editar cliente',0),(283245,7868,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(283246,7868,'es','Editar Cliente',0),(283247,7868,'de','Kunde bearbeiten',0),(283248,7868,'en','Edit Customer',0),(283249,7869,'is','',0),(283250,7869,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø±',0),(283251,7869,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø±',0),(283252,7869,'tr','MÃ¼ÅŸteri bilgilerini dÃ¼zenle',0),(283253,7869,'pl','Edytowanie informacji o klientach',0),(283254,7869,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(283255,7869,'ur','Ú¯Ø§ÛÚ© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283256,7869,'sr','Ð£Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐºÑƒÐ¿Ñ†Ñƒ',0),(283257,7869,'vi','Sá»­a ThÃ´ng Tin KhÃ¡ch HÃ ng',0),(283258,7869,'af','Redigeer KliÃ«nt/Klant Inligting',0),(283259,7869,'ro','EditaÅ£i informaÅ£iile despre clienÅ£i',0),(283260,7869,'et','Muuda kliendi informatsiooni',0),(283261,7869,'si','Urejanje podatkov o strankah',0),(283262,7869,'ba','Mengedit informasi pelanggan',0),(283263,7869,'nl','Klantgegevens bewerken',0),(283264,7869,'fi','Muokkaa asiakkaan tietoja',0),(283265,7869,'no','Redigere kundeinformasjon',0),(283266,7869,'da','Redigere kundeoplysningerne',0),(283267,7869,'ko','ê³ ê° ì •ë³´ íŽ¸ì§‘',0),(283268,7869,'he','×¢×¨×•×š ×ž×™×“×¢ ×œ×§×•×—',0),(283269,7869,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï„Ï‰Î½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(283270,7869,'zh','ç¼–è¾‘å®¢æˆ·ä¿¡æ¯\r\n',0),(283271,7869,'sv','Redigera kundinformation',0),(283272,7869,'it','Modificare le informazioni del cliente',0),(283273,7869,'tl','',0),(283274,7869,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(283275,7869,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283276,7869,'ms','Edit maklumat pelanggan',0),(283277,7869,'ar','ØªØ­Ø±ÙŠØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(283278,7869,'fr','Modifier les informations du client',0),(283279,7869,'jp','é¡§å®¢æƒ…å ±ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283280,7869,'pt','Editar informaÃ§Ãµes do cliente',0),(283281,7869,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ðž ÐšÐ»Ð¸ÐµÐ½Ñ‚Ðµ',0),(283282,7869,'es','Editar InformaciÃ³n de Cliente',0),(283283,7869,'de','Kundendaten bearbeiten',0),(283284,7869,'en','Edit Customer Information',0),(283285,7870,'is','',0),(283286,7870,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªØ¹Ø§Ø±ÙŠÙ',0),(283287,7870,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªØ¹Ø§Ø±ÙŠÙ',0),(283288,7870,'tr','ÃœrÃ¼n ReÃ§etesi tanÄ±mlarÄ±nÄ± dÃ¼zenleme',0),(283289,7870,'pl','Edycja BOM definicje',0),(283290,7870,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐšÐ˜ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ð¸',0),(283291,7870,'ur','Ø¨Ø§Ù… Ú©ÛŒ ØªØ¹Ø±ÛŒÙ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283292,7870,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ðµ Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ',0),(283293,7870,'vi','Sá»­a Äá»‹nh NghÄ©a',0),(283294,7870,'af','Redigeer Definisies',0),(283295,7870,'ro','Editare definiÅ£ii LM',0),(283296,7870,'et','Muuda Koosluse mÃµisted',0),(283297,7870,'si','Urediti Kosovnico opredelitve',0),(283298,7870,'ba','Mengedit BOM definisi',0),(283299,7870,'nl','BOM definities bewerken',0),(283300,7870,'fi','Muokkaa Tuoterakenteen mÃ¤Ã¤ritelmÃ¤t',0),(283301,7870,'no','Rediger Stykklistelinje definisjoner',0),(283302,7870,'da','Rediger Styklisten definitioner',0),(283303,7870,'ko','BOM ì •ì˜ íŽ¸ì§‘',0),(283304,7870,'he','×œ×¢×¨×•×š ×”×’×“×¨×•×ª ×”-BOM',0),(283305,7870,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿Ï…Ï‚ Î¿ÏÎ¹ÏƒÎ¼Î¿ÏÏ‚ Ï„Î·Ï‚ Ï„ÎµÏ‡Î½Î¹ÎºÎ®Ï‚ Î ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚',0),(283306,7870,'zh','ç¼–è¾‘å®šä¹‰\r\n',0),(283307,7870,'sv','Redigera BOM definitioner',0),(283308,7870,'it','Modificare le definizioni BOM',0),(283309,7870,'tl','',0),(283310,7870,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3588;&#3635;&#3609;&#3636;&#3618;&#3634;&#3617;',0),(283311,7870,'hi','BOM à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾à¤“à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283312,7870,'ms','Edit definisi BOM',0),(283313,7870,'ar','ØªØ­Ø±ÙŠØ± ØªØ¹Ø±ÙŠÙØ§Øª BOM',0),(283314,7870,'fr','Modifier les dÃ©finitions de la nomenclature',0),(283315,7870,'jp','éƒ¨å“è¡¨å®šç¾©ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283316,7870,'pt','Editar definiÃ§Ãµes de BOM',0),(283317,7870,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡Ð¾Ð²Ð¿Ð°Ð´ÐµÐ½Ð¸Ñ',0),(283318,7870,'es','Editar Definiciones',0),(283319,7870,'de','Bearbeiten von StÃ¼cklisten-Definitionen',0),(283320,7870,'en','Edit BOM Definitions',0),(283321,7871,'is','',0),(283322,7871,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(283323,7871,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(283324,7871,'tr','Ã‡alÄ±ÅŸanÄ± DÃ¼zenle',0),(283325,7871,'pl','Edytuj pracownika',0),(283326,7871,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(283327,7871,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283328,7871,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(283329,7871,'vi','Sá»­a NhÃ¢n ViÃªn',0),(283330,7871,'af','Redigeer Werknemer',0),(283331,7871,'ro','Editare angajat',0),(283332,7871,'et','Muuda tÃ¶Ã¶tajat',0),(283333,7871,'si','Urejanje zaposlenega',0),(283334,7871,'ba','Mengedit karyawan',0),(283335,7871,'nl','Werknemer bewerken',0),(283336,7871,'fi','Muokkaa tyÃ¶ntekijÃ¤tietoja',0),(283337,7871,'no','Redigere ansatt',0),(283338,7871,'da','Redigere medarbejder',0),(283339,7871,'ko','ì§ì› íŽ¸ì§‘',0),(283340,7871,'he','×¢×¨×•×š ×¢×•×‘×“',0),(283341,7871,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(283342,7871,'zh','ç¼–è¾‘é›‡å‘˜\r\n',0),(283343,7871,'sv','Redigera medarbetare',0),(283344,7871,'it','Modifica dei dipendenti',0),(283345,7871,'tl','',0),(283346,7871,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(283347,7871,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283348,7871,'ms','Edit pekerja',0),(283349,7871,'ar','ØªØ­Ø±ÙŠØ± Ø¨ÙŠØ§Ù†Ø§Øª Ù…ÙˆØ¸Ù',0),(283350,7871,'fr','EmployÃ© de modifier',0),(283351,7871,'jp','å¾“æ¥­å“¡ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283352,7871,'pt','Editar empregado',0),(283353,7871,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(283354,7871,'es','Editar Empleado',0),(283355,7871,'de','Mitarbeiter bearbeiten',0),(283356,7871,'en','Edit Employee',0),(283357,7872,'is','',0),(283358,7872,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(283359,7872,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(283360,7872,'tr','KarÅŸÄ±lama sipariÅŸi DeÄŸiÅŸtir',0),(283361,7872,'pl','Edycja zamÃ³wienia realizacji',0),(283362,7872,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(283363,7872,'ur','Ø¢Ø±ÚˆØ± ØªÚ©Ù…ÛŒÙ„ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283364,7872,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(283365,7872,'vi','Sá»­a ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(283366,7872,'af','Redigeer Uitvoeringsbestelling',0),(283367,7872,'ro','Editare Ã®ndeplinirea comenzii',0),(283368,7872,'et','Muuda kaubatellimust',0),(283369,7872,'si','Uredi izpolnitev nalog',0),(283370,7872,'ba','Mengedit pemenuhan Order',0),(283371,7872,'nl','Bewerken van vervulling volgorde',0),(283372,7872,'fi','Muokkaa tÃ¤yttÃ¶tilaus',0),(283373,7872,'no','Redigere innfrielsesordren',0),(283374,7872,'da','Redigere opfyldelsesordre',0),(283375,7872,'ko','í–‰ ìˆœì„œ íŽ¸ì§‘',0),(283376,7872,'he','×œ×¢×¨×•×š ×¡×“×¨ ×”×’×©×ž×”',0),(283377,7872,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(283378,7872,'zh','ç¼–è¾‘å±¥è¡Œè®¢å•\r\n',0),(283379,7872,'sv','Redigera uppfyllelseordern',0),(283380,7872,'it','Modificare l\'ordine di evasione',0),(283381,7872,'tl','',0),(283382,7872,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(283383,7872,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283384,7872,'ms','Edit memenuhi perintah',0),(283385,7872,'ar','ØªØ­Ø±ÙŠØ± Ø·Ù„Ø¨ÙŠØ©',0),(283386,7872,'fr','Modifier l\'ordre de traitement',0),(283387,7872,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283388,7872,'pt','Editar a ordem de realizaÃ§Ã£o',0),(283389,7872,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(283390,7872,'es','Editar Orden de Cumplimiento',0),(283391,7872,'de','AusfÃ¼hrungsauftrag bearbeiten',0),(283392,7872,'en','Edit Fulfillment Order',0),(283393,7873,'is','',0),(283394,7873,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø± Ø¯Ø§Ø®Ù„ÙŠ',0),(283395,7873,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø± Ø¯Ø§Ø®Ù„ÙŠ',0),(283396,7873,'tr','Ä°Ã§ Ã§alÄ±ÅŸma dÃ¼zenleme',0),(283397,7873,'pl','Edytuj wewnÄ™trznych',0),(283398,7873,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð¸',0),(283399,7873,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ú©Ø§Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283400,7873,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÑƒÐ½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ¸ Ñ€Ð°Ð´Ð½Ð¸',0),(283401,7873,'vi','Sá»­a CÃ´ng Viá»‡c Ná»™i Bá»™',0),(283402,7873,'af','Redigeer Interne Werk',0),(283403,7873,'ro','Editare interne de lucru',0),(283404,7873,'et','Muuda sisemise tÃ¶Ã¶',0),(283405,7873,'si','Urejanje notranjega dela',0),(283406,7873,'ba','Mengedit kerja Internal',0),(283407,7873,'nl','Bewerken van interne werkzaamheden',0),(283408,7873,'fi','Muokkaa sisÃ¤istÃ¤ tyÃ¶tÃ¤',0),(283409,7873,'no','Redigere interne arbeid',0),(283410,7873,'da','Redigere indre arbejde',0),(283411,7873,'ko','ë‚´ë¶€ ìž‘ì—… íŽ¸ì§‘',0),(283412,7873,'he','×¢×¨×•×š ×¢×‘×•×“×” ×¤× ×™×ž×™×ª',0),(283413,7873,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(283414,7873,'zh','ç¼–è¾‘å†…éƒ¨å·¥ä½œ\r\n',0),(283415,7873,'sv','Redigera interna arbete',0),(283416,7873,'it','Modificare il lavoro interno',0),(283417,7873,'tl','',0),(283418,7873,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3591;&#3634;&#3609;&#3616;&#3634;&#3618;&#3651;&#3609;',0),(283419,7873,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤•à¤¾à¤°à¥à¤¯ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283420,7873,'ms','Edit kerja dalaman',0),(283421,7873,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(283422,7873,'fr','Modifier le travail interne',0),(283423,7873,'jp','å†…éƒ¨çš„ãªä½œæ¥­æ™‚é–“ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283424,7873,'pt','Editar o trabalho interno',0),(283425,7873,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÑŽÑŽ Ð Ð°Ð±Ð¾Ñ‚Ñƒ',0),(283426,7873,'es','Editar Trabajo Internal',0),(283427,7873,'de','Bearbeiten interne',0),(283428,7873,'en','Edit Internal Work',0),(283429,7874,'is','',0),(283430,7874,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ± ',0),(283431,7874,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ± ',0),(283432,7874,'tr','Fatura dÃ¼zenleme',0),(283433,7874,'pl','Edytuj faktury',0),(283434,7874,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(283435,7874,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283436,7874,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(283437,7874,'vi','Sá»­a HÃ³a ÄÆ¡n',0),(283438,7874,'af','Redigeer Faktuur',0),(283439,7874,'ro','Editare facturÄƒ',0),(283440,7874,'et','Muuda arvet',0),(283441,7874,'si','Urejanje raÄuna',0),(283442,7874,'ba','Mengedit faktur',0),(283443,7874,'nl','Factuur bewerken',0),(283444,7874,'fi','Muokkaa laskua',0),(283445,7874,'no','Redigere faktura',0),(283446,7874,'da','Redigere faktura',0),(283447,7874,'ko','ì†¡ìž¥ íŽ¸ì§‘',0),(283448,7874,'he','×¢×¨×•×š ×—×©×‘×•× ×™×ª',0),(283449,7874,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(283450,7874,'zh','ç¼–è¾‘å‘ç¥¨\r\n',0),(283451,7874,'sv','Redigera faktura',0),(283452,7874,'it','Modifica fattura',0),(283453,7874,'tl','',0),(283454,7874,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(283455,7874,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283456,7874,'ms','Edit invois',0),(283457,7874,'ar','ØªØ­Ø±ÙŠØ± Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨',0),(283458,7874,'fr','Ã‰diter la facture',0),(283459,7874,'jp','è«‹æ±‚æ›¸ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283460,7874,'pt','Editar a factura',0),(283461,7874,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚',0),(283462,7874,'es','Editar Factura',0),(283463,7874,'de','Rechnung bearbeiten',0),(283464,7874,'en','Edit Invoice',0),(283465,7875,'is','',0),(283466,7875,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(283467,7875,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(283468,7875,'tr','Ã–ÄŸeyi DÃ¼zenle',0),(283469,7875,'pl','Edytuj element',0),(283470,7875,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(283471,7875,'ur','Ø´Û’ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283472,7875,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(283473,7875,'vi','Sá»­a Má»¥c',0),(283474,7875,'af','Redigeer Items',0),(283475,7875,'ro','Editare element',0),(283476,7875,'et','Muuda tooteid',0),(283477,7875,'si','Urejanje elementa',0),(283478,7875,'ba','Mengedit Item',0),(283479,7875,'nl','Item bewerken',0),(283480,7875,'fi','Muokkaa kohdetta',0),(283481,7875,'no','Redigere elementet',0),(283482,7875,'da','Rediger element',0),(283483,7875,'ko','í•­ëª© íŽ¸ì§‘',0),(283484,7875,'he','×¢×¨×•×š ×¤×¨×™×˜×™×',0),(283485,7875,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(283486,7875,'zh','ç¼–è¾‘é¡¹ç›®\r\n',0),(283487,7875,'sv','Redigera objekt',0),(283488,7875,'it','Modifica elemento',0),(283489,7875,'tl','',0),(283490,7875,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(283491,7875,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283492,7875,'ms','Mengedit Item',0),(283493,7875,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(283494,7875,'fr','Modifier l\'article',0),(283495,7875,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283496,7875,'pt','Editar Item',0),(283497,7875,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€Ñ‹',0),(283498,7875,'es','Editar Items',0),(283499,7875,'de','Element bearbeiten',0),(283500,7875,'en','Edit Item',0),(283501,7876,'is','',0),(283502,7876,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø·Ø±Ø­ ',0),(283503,7876,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø·Ø±Ø­ ',0),(283504,7876,'tr','PlanÄ± dÃ¼zenleme',0),(283505,7876,'pl','Edycja planu',0),(283506,7876,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½',0),(283507,7876,'ur','Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283508,7876,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ð½Ð°',0),(283509,7876,'vi','Sá»­a Káº¿ Hoáº¡ch',0),(283510,7876,'af','Redigeer Plan',0),(283511,7876,'ro','Editare Plan',0),(283512,7876,'et','Muuda graafikut',0),(283513,7876,'si','Uredite naÄrta',0),(283514,7876,'ba','Mengedit rencana',0),(283515,7876,'nl','Bewerken van Plan',0),(283516,7876,'fi','Muokkaa suunnitelmaa',0),(283517,7876,'no','Rediger Plan',0),(283518,7876,'da','Redigere Plan',0),(283519,7876,'ko','íŽ¸ì§‘ ê³„íš',0),(283520,7876,'he','×¢×¨×•×š ×ª×•×›× ×™×ª',0),(283521,7876,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ ÏƒÏ‡Î­Î´Î¹Î¿',0),(283522,7876,'zh','ç¼–è¾‘è®¡åˆ’\r\n',0),(283523,7876,'sv','Redigera Plan',0),(283524,7876,'it','Modifica piano',0),(283525,7876,'tl','',0),(283526,7876,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3649;&#3612;&#3609;&#3591;&#3634;&#3609;',0),(283527,7876,'hi','à¤¯à¥‹à¤œà¤¨à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283528,7876,'ms','Edit pelan',0),(283529,7876,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø£Ù‚Ø³Ø§Ø·',0),(283530,7876,'fr','Modifier le Plan',0),(283531,7876,'jp','ãƒ—ãƒ©ãƒ³ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283532,7876,'pt','Editar plano',0),(283533,7876,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ð½',0),(283534,7876,'es','Editar Plan',0),(283535,7876,'de','Plan bearbeiten',0),(283536,7876,'en','Edit Plan',0),(283537,7877,'is','',0),(283538,7877,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(283539,7877,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(283540,7877,'tr','PO DÃ¼zenle',0),(283541,7877,'pl','Edytuj PO',0),(283542,7877,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° PO',0),(283543,7877,'ur','Ù¾Ùˆ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283544,7877,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐŸÐž',0),(283545,7877,'vi','Sá»­a ÄÆ¡n Mua HÃ ng',0),(283546,7877,'af','Redigeer AB',0),(283547,7877,'ro','Editare PO',0),(283548,7877,'et','Redigeeri PO',0),(283549,7877,'si','Urediti PO',0),(283550,7877,'ba','Mengedit PO',0),(283551,7877,'nl','PO bewerken',0),(283552,7877,'fi','Muokkaa PO',0),(283553,7877,'no','Redigere PO',0),(283554,7877,'da','Redigere PO',0),(283555,7877,'ko','í¬ë¥¼ íŽ¸ì§‘',0),(283556,7877,'he','×¢×¨×™×›×ª ×¤×•',0),(283557,7877,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ PO',0),(283558,7877,'zh','ç¼–è¾‘è®¢å•\r\n',0),(283559,7877,'sv','Redigera PO',0),(283560,7877,'it','Modifica PO',0),(283561,7877,'tl','',0),(283562,7877,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(283563,7877,'hi','PO à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283564,7877,'ms','Edit PO',0),(283565,7877,'ar','ØªØ­Ø±ÙŠØ± Øµ. Ø¨.',0),(283566,7877,'fr','Edit PO',0),(283567,7877,'jp','PO ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283568,7877,'pt','Editar PO',0),(283569,7877,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ PO',0),(283570,7877,'es','Editar OC',0),(283571,7877,'de','PO bearbeiten',0),(283572,7877,'en','Edit PO',0),(283573,7878,'is','',0),(283574,7878,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø«Ø¨ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ ',0),(283575,7878,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø«Ø¨ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ ',0),(283576,7878,'tr','Yinelenen girdileri dÃ¼zenleme',0),(283577,7878,'pl','EdytowaÄ‡ wpisy powtarzajÄ…ce',0),(283578,7878,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(283579,7878,'ur','Ø¨Ø§Ø± Ø¨Ø§Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283580,7878,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(283581,7878,'vi','Sá»­a BÃºt ToÃ¡n Äá»‹nh Ká»³',0),(283582,7878,'af','Redigeer Herhaaldende Inskrywings',0),(283583,7878,'ro','Edita intrÄƒri recurente',0),(283584,7878,'et','Redigeeri korduvaid kandeid',0),(283585,7878,'si','Urejanje ponavljajoÄih se postavkah',0),(283586,7878,'ba','Mengedit entri yang berulang',0),(283587,7878,'nl','Terugkerende items bewerken',0),(283588,7878,'fi','Muokkaa toistuvia tapahtumia',0),(283589,7878,'no','Redigere gjentakelsesposter',0),(283590,7878,'da','Redigere gentagelsesposterne',0),(283591,7878,'ko','ë˜í’€ì´ í•­ëª© íŽ¸ì§‘',0),(283592,7878,'he','×œ×¢×¨×•×š ×¢×¨×›×™× ×—×•×–×¨×™×',0),(283593,7878,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(283594,7878,'zh','ç¼–è¾‘å¾ªçŽ¯æ¡ç›®\r\n',0),(283595,7878,'sv','Redigera Ã¥terkommande poster',0),(283596,7878,'it','Modificare le voci ricorrenti',0),(283597,7878,'tl','',0),(283598,7878,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3604;&#3595;&#3657;&#3635;',0),(283599,7878,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283600,7878,'ms','Edit entri berulang',0),(283601,7878,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ù…ØªÙƒØ±Ù‘Ø±Ø©',0),(283602,7878,'fr','Modifier les entrÃ©es rÃ©currentes',0),(283603,7878,'jp','å®šæœŸçš„ãªã‚¨ãƒ³ãƒˆãƒªã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283604,7878,'pt','Editar entradas recorrentes',0),(283605,7878,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ…ÑÑ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(283606,7878,'es','Editar Entradas Recurrentes',0),(283607,7878,'de','Wiederkehrende EintrÃ¤ge bearbeiten',0),(283608,7878,'en','Edit Recurring Entries',0),(283609,7879,'is','',0),(283610,7879,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ø±ÙˆÙŠØ³ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(283611,7879,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ø±ÙˆÙŠØ³ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(283612,7879,'tr','Servis sipariÅŸlerini DÃ¼zenle',0),(283613,7879,'pl','Edytowanie zleceÅ„ serwisowych',0),(283614,7879,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(283615,7879,'ur','Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283616,7879,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(283617,7879,'vi','Sá»­a ÄÆ¡n Äáº·t HÃ ng Dá»‹ch Vá»¥',0),(283618,7879,'af','Redigeer Diensbestellings',0),(283619,7879,'ro','EditaÅ£i comenzile de Service',0),(283620,7879,'et','Redigeerida hooldustellimusi',0),(283621,7879,'si','Urejanje naroÄila storitev',0),(283622,7879,'ba','Ganti Layanan Pesanan',0),(283623,7879,'nl','Bewerken van serviceorders',0),(283624,7879,'fi','Muokkaa huoltotilauksia',0),(283625,7879,'no','Redigere serviceordrer',0),(283626,7879,'da','Redigere serviceordrer',0),(283627,7879,'ko','ì„œë¹„ìŠ¤ ëª…ë ¹ íŽ¸ì§‘',0),(283628,7879,'he','×¢×¨×•×š ×”×–×ž× ×•×ª ×©×¨×•×ª',0),(283629,7879,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(283630,7879,'zh','ç¼–è¾‘æœåŠ¡è®¢å•\r\n',0),(283631,7879,'sv','Redigera serviceorder',0),(283632,7879,'it','Modificare gli ordini di servizio',0),(283633,7879,'tl','',0),(283634,7879,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(283635,7879,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283636,7879,'ms','Edit Perkhidmatan Pesanan',0),(283637,7879,'ar','ØªØ­Ø±ÙŠØ± Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(283638,7879,'fr','Change Commandes services',0),(283639,7879,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283640,7879,'pt','Editar ordens de serviÃ§o',0),(283641,7879,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(283642,7879,'es','Editar Ordenes de Servicio',0),(283643,7879,'de','ServiceauftrÃ¤ge bearbeiten',0),(283644,7879,'en','Edit Service Orders',0),(283645,7880,'is','',0),(283646,7880,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(283647,7880,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(283648,7880,'tr','SatÄ±cÄ± DÃ¼zenle',0),(283649,7880,'pl','Edytowanie dostawcy',0),(283650,7880,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(283651,7880,'ur','ÙˆÛŒÙ†ÚˆØ± ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(283652,7880,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(283653,7880,'vi','Sá»­a NgÆ°á»i BÃ¡n',0),(283654,7880,'af','Redigeer Verskaffer',0),(283655,7880,'ro','Editare furnizor',0),(283656,7880,'et','Muuda tarnijat',0),(283657,7880,'si','Urejanje dobavitelja',0),(283658,7880,'ba','Mengedit Vendor',0),(283659,7880,'nl','Bewerken van leverancier',0),(283660,7880,'fi','Muokkaa toimittajaa',0),(283661,7880,'no','Rediger leverandÃ¸r',0),(283662,7880,'da','Rediger leverandÃ¸r',0),(283663,7880,'ko','ê³µê¸‰ ì—…ì²´ë¥¼ íŽ¸ì§‘',0),(283664,7880,'he','×¢×¨×•×š ×¡×¤×§',0),(283665,7880,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(283666,7880,'zh','ç¼–è¾‘ä¾›åº”å•†\r\n',0),(283667,7880,'sv','Redigera leverantÃ¶r',0),(283668,7880,'it','Modifica fornitore',0),(283669,7880,'tl','',0),(283670,7880,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(283671,7880,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(283672,7880,'ms','Edit Penjual',0),(283673,7880,'ar','ØªØ­Ø±ÙŠØ± Ù…ÙˆØ±Ù‘Ø¯',0),(283674,7880,'fr','Editer le fournisseur',0),(283675,7880,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(283676,7880,'pt','Editar o fornecedor',0),(283677,7880,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(283678,7880,'es','Editar Proveedor',0),(283679,7880,'de','Lieferanten zu bearbeiten',0),(283680,7880,'en','Edit Vendor',0),(283681,7881,'is','',0),(283682,7881,'dr','ÙƒØ³Ø±Ø­Ù‚ÙˆÙ‚ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯  \r\nDed',0),(283683,7881,'pr','ÙƒØ³Ø±Ø­Ù‚ÙˆÙ‚ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯  \r\nDed',0),(283684,7881,'tr','Ã‡alÄ±ÅŸanÄ±n Ã¶deme/Ded',0),(283685,7881,'pl','Pracownik pÅ‚ac/Ded',0),(283686,7881,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸/Ded',0),(283687,7881,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û/Ø¯Ø¯',0),(283688,7881,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¿Ð»Ð°Ñ‚Ð°/Ð”ÐµÐ´.',0),(283689,7881,'vi','Tráº£ lÆ°Æ¡ng/Giáº£m trá»«',0),(283690,7881,'af','Werknemer Besoldiging/Aftrekkings',0),(283691,7881,'ro','Angajat plata/Ded',0),(283692,7881,'et','TÃ¶Ã¶taja tÃ¶Ã¶tasu/Ded',0),(283693,7881,'si','Zaposleni plaÄati/zmletimi',0),(283694,7881,'ba','Karyawan gaji/Ded',0),(283695,7881,'nl','Werknemer Pay/Ded',0),(283696,7881,'fi','TyÃ¶ntekijÃ¤n maksu/Ded',0),(283697,7881,'no','Ansatte lÃ¸nn/Ded',0),(283698,7881,'da','Medarbejder lÃ¸n/Ded',0),(283699,7881,'ko','ì§ì› ê¸‰ì—¬/ê³µê²© í•œ',0),(283700,7881,'he','×©×›×¨ ×”×¢×•×‘×“/Ded',0),(283701,7881,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î±Î¼Î¿Î¹Î²ÏŽÎ½/Ded',0),(283702,7881,'zh','å‘˜å·¥å·¥èµ„/å‰¯æ‰§è¡Œå¹²äº‹\r\n',0),(283703,7881,'sv','AnstÃ¤lldas lÃ¶n/Ded',0),(283704,7881,'it','Dipendente paga/Ded',0),(283705,7881,'tl','',0),(283706,7881,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609; Pay/Ded',0),(283707,7881,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨/Ded',0),(283708,7881,'ms','Pekerja gaji/Anugerah',0),(283709,7881,'ar','Ø£Ø¬Ø± Ø§Ù„Ù…ÙˆØ¸Ù/Ø§Ù„Ø¯Ø§Ø¦Ø±Ø© Ø§Ù„Ø§Ù‚ØªØµØ§Ø¯ÙŠØ©',0),(283710,7881,'fr','EmployÃ© paye/Ded',0),(283711,7881,'jp','å¾“æ¥­å“¡çµ¦ä¸Ž/Ded',0),(283712,7881,'pt','SalÃ¡rio de empregado/Ded',0),(283713,7881,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð°/Ð£Ð´ÐµÑ€Ð¶ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(283714,7881,'es','Empleado Pagos/Ded',0),(283715,7881,'de','Mitarbeiter Lohn/Ded',0),(283716,7881,'en','Employee Pay/Ded',0),(283717,7882,'is','',0),(283718,7882,'dr','Ø«Ø¨Øª Ùˆ  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(283719,7882,'pr','Ø«Ø¨Øª Ùˆ  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(283720,7882,'tr','Girin ve servis sipariÅŸlerini gÃ¼ncelleÅŸtirme',0),(283721,7882,'pl','WprowadÅº i aktualizowanie zleceÅ„ serwisowych',0),(283722,7882,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(283723,7882,'ur','Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø®Ø¯Ù…Øª Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(283724,7882,'sr','Ð£Ð½Ð¾Ñ Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(283725,7882,'vi','Nháº­p & cáº­p nháº­t Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥',0),(283726,7882,'af','Invoer en Opdateer Diensbestellings',0),(283727,7882,'ro','IntroduceÅ£i ÅŸi actualizaÅ£i comenzile de Service',0),(283728,7882,'et','Saate sisestada ja uuendada hooldustellimusi',0),(283729,7882,'si','Vnesete in posodobite servisnih nalogov',0),(283730,7882,'ba','Buat dan Koreksi Layanan Pesanan',0),(283731,7882,'nl','Invoeren en bijwerken van serviceorders',0),(283732,7882,'fi','SyÃ¶tÃ¤ ja pÃ¤ivitÃ¤ huoltotilauksia',0),(283733,7882,'no','Angi og oppdatere serviceordrer',0),(283734,7882,'da','Indtaste og opdatere serviceordrer',0),(283735,7882,'ko','ìž…ë ¥ ë° ì„œë¹„ìŠ¤ ì£¼ë¬¸ ì—…ë°ì´íŠ¸',0),(283736,7882,'he','×œ×”×–×™×Ÿ ×•×œ×¢×“×›×Ÿ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(283737,7882,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ ÎºÎ±Î¹ Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Ï„Î¹Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„/Ï…',0),(283738,7882,'zh','è¾“å…¥å’Œæ›´æ–°æœåŠ¡è®¢å•',0),(283739,7882,'sv','Ange och uppdatera serviceorder',0),(283740,7882,'it','Inserire e aggiornare gli ordini di servizio',0),(283741,7882,'tl','',0),(283742,7882,'th','&#3611;&#3657;&#3629;&#3609;&#3649;&#3621;&#3632;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(283743,7882,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶',0),(283744,7882,'ms','Memasukkan dan mengemaskini perkhidmatan pesanan',0),(283745,7882,'ar','Ø¥Ø¯Ø®Ø§Ù„ ÙˆØªØ­Ø¯ÙŠØ« Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(283746,7882,'fr','Entrer et changer commandes',0),(283747,7882,'jp','å…¥åŠ›ãŠã‚ˆã³ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã®æ›´æ–°',0),(283748,7882,'pt','Inserir e atualizar de ordens de serviÃ§o',0),(283749,7882,'ru','Ð’Ð²Ð¾Ð´ Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(283750,7882,'es','Introducir y Actualizar Ordenes de Servicio',0),(283751,7882,'de','Eingeben und Aktualisieren von ServiceauftrÃ¤gen',0),(283752,7882,'en','Enter and Update Service Orders',0),(283753,7883,'is','',0),(283754,7883,'dr','Ø«Ø¨Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(283755,7883,'pr','Ø«Ø¨Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(283756,7883,'tr','Yeni satÄ±cÄ± veri girin',0),(283757,7883,'pl','WprowadÅº nowe dane dostawcy',0),(283758,7883,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð² Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð´Ð°Ð½Ð½Ð¸',0),(283759,7883,'ur','Ù†Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± Ú©ÙˆØ§Ø¦Ù Ø¯Ø§Ø®Ù„',0),(283760,7883,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð²Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(283761,7883,'vi','Nháº­p dá»¯ liá»‡u ngÆ°á»i bÃ¡n má»›i',0),(283762,7883,'af','Voer Data in nuwe handelaar',0),(283763,7883,'ro','IntroduceÅ£i noile date de furnizor',0),(283764,7883,'et','Lisa uued hankija andmed',0),(283765,7883,'si','Vnesite novi podatki dobavitelja',0),(283766,7883,'ba','Masukkan Data Vendor baru',0),(283767,7883,'nl','Nieuwe leverancier gegevens invoeren',0),(283768,7883,'fi','Kirjoita uuden toimittajan tiedot',0),(283769,7883,'no','Angi nye leverandÃ¸rdata',0),(283770,7883,'da','Angiv nye kreditordata',0),(283771,7883,'ko','ìƒˆ ê³µê¸‰ ì—…ì²´ ë°ì´í„° ìž…ë ¥',0),(283772,7883,'he','×”×–× ×ª × ×ª×•× ×™× ×¡×¤×§×™× ×—×“×©×™×',0),(283773,7883,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î½Î­Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(283774,7883,'zh','è¾“å…¥æ–°çš„ä¾›åº”å•†æ•°æ®',0),(283775,7883,'sv','Ange nya leverantÃ¶rsdata',0),(283776,7883,'it','Immettere i nuovi dati fornitore',0),(283777,7883,'tl','',0),(283778,7883,'th','&#3611;&#3657;&#3629;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(283779,7883,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(283780,7883,'ms','Masukkan Data penjual baru',0),(283781,7883,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø¨ÙŠØ§Ù†Ø§Øª  Ù…ÙˆØ±Ù‘Ø¯ Ø¬Ø¯ÙŠØ¯',0),(283782,7883,'fr','Entrer de nouvelles donnÃ©es du vendeur',0),(283783,7883,'jp','æ–°ã—ã„ãƒ™ãƒ³ãƒ€ãƒ¼ ãƒ‡ãƒ¼ã‚¿ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(283784,7883,'pt','Inserir novos dados de fornecedor',0),(283785,7883,'ru','Ð’Ð²ÐµÑÑ‚Ð¸ Ð”Ð°Ð½Ð½Ñ‹Ðµ ÐÐ¾Ð²Ð¾Ð³Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(283786,7883,'es','Introducir Datos del Nuevo Proveedor',0),(283787,7883,'de','Geben Sie neue Herstellerdaten',0),(283788,7883,'en','Enter New Vendor Data',0),(283789,7884,'is','',0),(283790,7884,'dr','ÙˆØ±ÙˆØ¯  Ø«Ø¨ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø±Ø´ÙˆÙ†Ø¯Ù‡ ',0),(283791,7884,'pr','ÙˆØ±ÙˆØ¯  Ø«Ø¨ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø±Ø´ÙˆÙ†Ø¯Ù‡ ',0),(283792,7884,'tr','Yinelenen giriÅŸ',0),(283793,7884,'pl','WprowadÅº ksiÄ™gowaÅ„ okresowych',0),(283794,7884,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(283795,7884,'ur','Ù…Ú©Ø±Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(283796,7884,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(283797,7884,'vi','Nháº­p bÃºt toÃ¡n Ä‘á»‹nh ká»³',0),(283798,7884,'af','Invoer van Herhaaldende Inskrywings',0),(283799,7884,'ro','IntroduceÅ£i intrÄƒri recurente',0),(283800,7884,'et','Korduva kirje',0),(283801,7884,'si','Vnesite ponavljajoÄih se postavkah',0),(283802,7884,'ba','Masukkan berulang entri',0),(283803,7884,'nl','Invoeren van periodieke posten',0),(283804,7884,'fi','Kirjoita toistuvia tapahtumia',0),(283805,7884,'no','Angi gjentakelsesposter',0),(283806,7884,'da','Angiv gentagelsesposterne',0),(283807,7884,'ko','ë˜í’€ì´ ë˜ëŠ” í•­ëª©ì„ ìž…ë ¥',0),(283808,7884,'he','×”×–×Ÿ ×¢×¨×›×™× ×—×•×–×¨×™×',0),(283809,7884,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(283810,7884,'zh','è¿›å…¥å‘¨æœŸæ€§æ¡ç›®',0),(283811,7884,'sv','Ange Ã¥terkommande poster',0),(283812,7884,'it','Immettere le voci ricorrenti',0),(283813,7884,'tl','',0),(283814,7884,'th','&#3611;&#3657;&#3629;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3604;&#3586;&#3638;&#3657;&#3609;&#3610;&#3656;&#3629;&#3618; &#3654;',0),(283815,7884,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(283816,7884,'ms','Masukkan entri berulang',0),(283817,7884,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ù…ØªÙƒØ±Ù‘Ø±Ø©',0),(283818,7884,'fr','Entrer des Ã©critures rÃ©currentes',0),(283819,7884,'jp','å®šæœŸçš„ãªã‚¨ãƒ³ãƒˆãƒªã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(283820,7884,'pt','Inserir entradas recorrentes',0),(283821,7884,'ru','Ð’Ð²Ð¾Ð´ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ…ÑÑ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(283822,7884,'es','Introducir Entrada Recurrrentes',0),(283823,7884,'de','Geben Sie Dauerbuchungen',0),(283824,7884,'en','Enter Recurring Entries',0),(283825,7885,'is','',0),(283826,7885,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(283827,7885,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(283828,7885,'tr','Vergi tablolarÄ± girin/gÃ¼ncelleme',0),(283829,7885,'pl','WprowadÅº/aktualizacja tabel podatku',0),(283830,7885,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð¸ Ð·Ð° Ð´Ð°Ð½ÑŠÐº',0),(283831,7885,'ur','Ù¹ÛŒÚ©Ø³ Ø¬Ø¯ÙˆÙ„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(283832,7885,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ð°Ð±ÐµÐ»Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð°',0),(283833,7885,'vi','Nháº­p/Cáº­p Nháº­t Báº£ng Thuáº¿',0),(283834,7885,'af','Invoer/Opdateer Belastingtabel',0),(283835,7885,'ro','IntroduceÅ£i/actualizare fiscale tabele',0),(283836,7885,'et','Sisesta/Uuenda maksutabeleid',0),(283837,7885,'si','Vnos/posodobitev tabel davka',0),(283838,7885,'ba','Masukkan/Update tabel pajak',0),(283839,7885,'nl','Fiscale tabellen invoeren/bijwerken',0),(283840,7885,'fi','PÃ¤ivittÃ¤minen verotaulut',0),(283841,7885,'no','Angi/Oppdater skattetabeller',0),(283842,7885,'da','Indtaste/opdatere Tax-tabeller',0),(283843,7885,'ko','ì„¸ê¸ˆ í…Œì´ë¸” ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(283844,7885,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×˜×‘×œ××•×ª ×ž×¡',0),(283845,7885,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î¹Î½Î¬ÎºÏ‰Î½ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½',0),(283846,7885,'zh','è¾“å…¥/æ›´æ–°ç¨Žè¡¨\r\n',0),(283847,7885,'sv','Ange/uppdatera skatt tabeller',0),(283848,7885,'it','Inserisci/Aggiorna tabelle fiscali',0),(283849,7885,'tl','',0),(283850,7885,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3605;&#3634;&#3619;&#3634;&#3591;&#3616;&#3634;&#3625;&#3637;',0),(283851,7885,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(283852,7885,'ms','Masukkan/Kemaskini Jadual cukai',0),(283853,7885,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(283854,7885,'fr','Inscrire/mettre Ã  jour des Tables dâ€™impÃ´t',0),(283855,7885,'jp','ç¨ŽçŽ‡è¡¨ã®å…¥åŠ›/æ›´æ–°',0),(283856,7885,'pt','Inserir/atualizar tabelas de impostos',0),(283857,7885,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹ ÐÐ°Ð»Ð¾Ð³Ð¾Ð²',0),(283858,7885,'es','Introducir/Actualizar Tablas de Impuestos',0),(283859,7885,'de','Geben Sie/Update-Steuertabellen',0),(283860,7885,'en','Enter/Update Tax Tables',0),(283861,7886,'is','',0),(283862,7886,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø§Ù…Ø§ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(283863,7886,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø§Ù…Ø§ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(283864,7886,'tr','Sevk edilen, ancak fatura deÄŸil - Fulfillment sipariÅŸler',0),(283865,7886,'pl','WysÅ‚ane ale nie rozliczone - realizacja zamÃ³wienia',0),(283866,7886,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¾, Ð½Ð¾ Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ - Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(283867,7886,'ur','Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ù…Ú¯Ø± Ù†ÛÛŒÚº Ø¨Ø§Ù„Ù„Ø§Ø¯ - ØªÚ©Ù…ÛŒÙ„ Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§ Û”',0),(283868,7886,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¾ , Ð°Ð»Ð¸ Ð½Ð¸Ñ˜Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ - Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ.',0),(283869,7886,'vi','ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i Ä‘Ã£ chuyá»ƒn Ä‘i nhÆ°ng chÆ°a láº­p hÃ³a Ä‘Æ¡n',0),(283870,7886,'af','Uitvoeringsbestelling Versend, maar nie Gefaktureer nie',0),(283871,7886,'ro','Expediate dar nu taxat - Ã®mplinire comenzi',0),(283872,7886,'et','Kaubatellimus tarnitud, kuid arvet pole koostatud',0),(283873,7886,'si','Dobavljena, vendar ne zaraÄunavajo - izpolnitev naroÄila',0),(283874,7886,'ba','Pesanan yang lengkap dan terkirim tetapi belun ditagih',0),(283875,7886,'nl','Verzonden maar nog niet gefactureerd - bestellingen vervulling',0),(283876,7886,'fi','Toimitettu mutta ei laskutettu - tÃ¤yttÃ¤minen tilaukset',0),(283877,7886,'no','Levert, men ikke fakturert - bestillinger fullfÃ¸ringen',0),(283878,7886,'da','Leveret, men ikke faktureret - ordrer opfyldelse',0),(283879,7886,'ko','í–‰ ìˆœì„œë¥¼ ì œê³µ í•˜ì§€ë§Œ ë¹„ìš©ì´ ì²­êµ¬ ë˜ì§€-',0),(283880,7886,'he','×©× ×©×œ×—×• ××š ×œ× ×ž×—×•×™×‘ - ×ž×™×ž×•×© ×”×–×ž× ×•×ª',0),(283881,7886,'el','Î‘Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯, Î±Î»Î»Î¬ Î´ÎµÎ½ Ï„Î¹Î¼Î¿Î»Î¿Î³ÎµÎ¯Ï„Î±Î¹ - ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(283882,7886,'zh','å±¥è¡Œè®¢å•å‘è¿ä½†æœªå‘å¸å•\r\n',0),(283883,7886,'sv','Levererats men inte faktureras - order uppfyllelse',0),(283884,7886,'it','Spedito ma non fatturati - evasione ordini',0),(283885,7886,'tl','',0),(283886,7886,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;&#3649;&#3605;&#3656;&#3652;&#3617;&#3656;&#3629;&#3629;&#3',0),(283887,7886,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾, à¤²à¥‡à¤•à¤¿à¤¨ à¤¬à¤¿à¤² à¤¨à¤¹à¥€à¤‚-',0),(283888,7886,'ms','Dihantar tetapi tidak dibilkan - memenuhi perintah',0),(283889,7886,'ar','Ø´Ø­Ù† ÙˆÙ„ÙƒÙ† Ù„Ø§ ØªÙˆØµÙ-ÙˆÙØ§Ø¡ Ø£ÙˆØ§Ù…Ø±',0),(283890,7886,'fr','ExpÃ©diÃ©es mais non facturÃ©e - Fulfillment ordonne',0),(283891,7886,'jp','å‡ºè·ãŒè«‹æ±‚ã•ã‚Œãªã„ - ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼ã—ã¾ã™ã€‚',0),(283892,7886,'pt','Enviados mas nÃ£o faturado - cumprimento de ordens',0),(283893,7886,'ru','ÐžÑ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ñ‹, Ð½Ð¾ Ð½Ðµ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚ - Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(283894,7886,'es','Ordens de Complemento Enviados Pero No Facturados',0),(283895,7886,'de','Geliefert aber nicht in Rechnung gestellt - Bestellungen ErfÃ¼llung',0),(283896,7886,'en','Shipped But Not Billed - Fulfillment Orders',0),(283897,7887,'is','',0),(283898,7887,'dr','Ù‚ÙŠÙ…ØªÙ‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§Ø¬Ø±Ø§ ',0),(283899,7887,'pr','Ù‚ÙŠÙ…ØªÙ‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§Ø¬Ø±Ø§ ',0),(283900,7887,'tr','Yerine getirilmesi Quotes',0),(283901,7887,'pl','SpeÅ‚nienie Cytaty',0),(283902,7887,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð¸ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(283903,7887,'ur','Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø±Ø¬ Ú©Ø±Ù†Û’',0),(283904,7887,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ',0),(283905,7887,'vi','BÃ¡o giÃ¡ ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(283906,7887,'af','Uitvoeringsbestelling Kwotasies',0),(283907,7887,'ro','ÃŽmplinirea citate',0),(283908,7887,'et','Eneseteostus hinnapakkumisi',0),(283909,7887,'si','Izpolnitev ponudbe',0),(283910,7887,'ba','Pemenuhan Quotes',0),(283911,7887,'nl','Vervulling Quotes',0),(283912,7887,'fi','TÃ¤yttÃ¤minen lainausmerkit',0),(283913,7887,'no','Oppfyllelsen sitater',0),(283914,7887,'da','Opfyldelse citater',0),(283915,7887,'ko','ì„±ì·¨ ì¸ìš©ë¬¸',0),(283916,7887,'he','×”×¦×¢×•×ª ×ž×—×™×¨ ×ž×™×ž×•×©',0),(283917,7887,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(283918,7887,'zh','å±¥è¡ŒæŠ¥ä»·\r\n',0),(283919,7887,'sv','Uppfyllelse citat',0),(283920,7887,'it','Citazioni di adempimento',0),(283921,7887,'tl','',0),(283922,7887,'th','&#3626;&#3629;&#3610;&#3606;&#3634;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(283923,7887,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(283924,7887,'ms','Sebut harga yang memenuhi',0),(283925,7887,'ar','Ø¹Ø±ÙˆØ¶ Ù…Ø¨Ø¯Ø¦ÙŠØ©',0),(283926,7887,'fr','RÃ©alisation de devis',0),(283927,7887,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆå¼•ç”¨ç¬¦',0),(283928,7887,'pt','CitaÃ§Ãµes de cumprimento',0),(283929,7887,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(283930,7887,'es','Cotizaciones de Cumplimiento',0),(283931,7887,'de','ErfÃ¼llung Zitate',0),(283932,7887,'en','Fulfillment Quotes',0),(283933,7888,'is','',0),(283934,7888,'dr','Ø¨Ø±ÙˆÙŠØ¯  Ø¨Ù‡ Ø³Ø§ÙŠØª Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡  Ùˆ Ú¯Ø²Ø§Ø±Ø´ Ø°Ø®ÙŠØ±Ù‡ ',0),(283935,7888,'pr','Ø¨Ø±ÙˆÙŠØ¯  Ø¨Ù‡ Ø³Ø§ÙŠØª Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡  Ùˆ Ú¯Ø²Ø§Ø±Ø´ Ø°Ø®ÙŠØ±Ù‡ ',0),(283936,7888,'tr','Ajan Site ve rezervasyon rapor gidin',0),(283937,7888,'pl','PrzejdÅº do witryny agenta i rezerwacji raport',0),(283938,7888,'bg','ÐžÑ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð° ÑÐ°Ð¹Ñ‚Ð° Ð°Ð³ÐµÐ½Ñ‚ Ð¸ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð° Ð´Ð¾ÐºÐ»Ð°Ð´',0),(283939,7888,'ur','Ø¬Ø§Ø¦ÛŒÚº Ø¨Ø·Ø±Ù Ø§ÛŒØ¬Ù†Ù¹ ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ø§ÙˆØ± Ø¨Ú©Ù†Ú¯ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(283940,7888,'sr','Ð˜Ð´Ð¸ Ð´Ð¾ ÐÐ³ÐµÐ½Ñ‚ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð¸ Ñ€ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ˜Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(283941,7888,'vi','Äáº¿n trang Ä‘áº¡i lÃ½ vÃ  bÃ¡o cÃ¡o Ä‘áº·t trÆ°á»›c',0),(283942,7888,'af','Gaan na Agent Webwerf en Besprekingsverslag',0),(283943,7888,'ro','Du-te la site-ul de Agent ÅŸi rezervare raport',0),(283944,7888,'et','Mine Agent saidi ja reserveerimine aruanne',0),(283945,7888,'si','Pojdi na stran Agent in rezervacije poroÄilo',0),(283946,7888,'ba','Pergi ke situs agen dan reservasi laporan',0),(283947,7888,'nl','Ga naar Agent Site en reservering verslag',0),(283948,7888,'fi','Siirry agentti sivuston ja varaus raportti',0),(283949,7888,'no','GÃ¥ til Agent omrÃ¥det og booking rapport',0),(283950,7888,'da','GÃ¥ til Agent Site og Reservation rapport',0),(283951,7888,'ko','ì—ì´ì „íŠ¸ ì‚¬ì´íŠ¸ ë° ì˜ˆì•½ ë³´ê³ ì„œ ì´ë™',0),(283952,7888,'he','×¢×‘×•×¨ ××œ ×”×¡×•×›×Ÿ ×‘××ª×¨, ×“×•×— ×”×–×ž× ×”',0),(283953,7888,'el','Î Î·Î³Î±Î¯Î½ÎµÏ„Îµ ÏƒÏ„Î¿ Site Ï„Î¿Ï… Ï€ÏÎ¬ÎºÏ„Î¿ÏÎ± ÎºÎ±Î¹ ÎºÏÎ¬Ï„Î·ÏƒÎ· Î­ÎºÎ¸ÎµÏƒÎ·',0),(283954,7888,'zh','è½¬åˆ°ä»£ç†ç«™ç‚¹å’Œä¿ç•™çš„æŠ¥å‘Š\r\n',0),(283955,7888,'sv','GÃ¥ till Agent webbplats och bokning rapport',0),(283956,7888,'it','Vai al sito di agente e Report di prenotazione',0),(283957,7888,'tl','',0),(283958,7888,'th','&#3652;&#3611;&#3618;&#3633;&#3591;&#3613;&#3633;&#3656;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3649;&#3621;&#3632;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3592;&#3629;&#3591;',0),(283959,7888,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ à¤¸à¤¾à¤‡à¤Ÿ à¤”à¤° à¤†à¤°à¤•à¥à¤·à¤£ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤ªà¤° à¤œà¤¾à¤à¤',0),(283960,7888,'ms','Pergi ke laman web agen dan laporan Tempahan',0),(283961,7888,'ar','Ø§Ø°Ù‡Ø¨ Ø¥Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ Ø§Ù„ÙˆÙƒÙŠÙ„ ÙˆØªØ­ÙØ¸ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(283962,7888,'fr','Aller au Site de l\'Agent et rapport de rÃ©servation',0),(283963,7888,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆ ã‚µã‚¤ãƒˆã¨äºˆç´„ãƒ¬ãƒãƒ¼ãƒˆã«è¡Œã',0),(283964,7888,'pt','Ir para o Site do agente e relatÃ³rio de reserva',0),(283965,7888,'ru','ÐŸÐµÑ€ÐµÐ¹Ð´Ð¸Ñ‚Ðµ Ð½Ð° ÑÐ°Ð¹Ñ‚ Ð°Ð³ÐµÐ½Ñ‚Ð° Ð¸ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(283966,7888,'es','Ir A Sitio de Agente y Informe de ReservaciÃ³n',0),(283967,7888,'de','Gehen Sie zu Agentstandort und Reservierungsbericht',0),(283968,7888,'en','Go To Agent Site and Reservation Report',0),(283969,7889,'is','',0),(283970,7889,'dr','Ú©Ø§Ù„Ø§Ù‡Ø§Ù‰ ÙˆØ§Ø±Ø¯Ø§ØªÙ‰',0),(283971,7889,'pr','Ú©Ø§Ù„Ø§Ù‡Ø§Ù‰ ÙˆØ§Ø±Ø¯Ø§ØªÙ‰',0),(283972,7889,'tr','Ä°thalat',0),(283973,7889,'pl','PrzywÃ³z',0),(283974,7889,'bg','Ð’Ð½Ð¾Ñ',0),(283975,7889,'ur','Ø¯Ø±Ø¢Ù…Ø¯Ø§Øª',0),(283976,7889,'sr','Ð£Ð²Ð¾Ð·',0),(283977,7889,'vi','Nháº­p',0),(283978,7889,'af','Invoere',0),(283979,7889,'ro','Importuri',0),(283980,7889,'et','Importimine',0),(283981,7889,'si','Uvoz',0),(283982,7889,'ba','Impor',0),(283983,7889,'nl','Invoer',0),(283984,7889,'fi','Tuonti',0),(283985,7889,'no','Import',0),(283986,7889,'da','Import',0),(283987,7889,'ko','ìˆ˜ìž…',0),(283988,7889,'he','×™×‘×•×',0),(283989,7889,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î­Ï‚',0),(283990,7889,'zh','å¯¼å…¥\r\n',0),(283991,7889,'sv','Import',0),(283992,7889,'it','Importazioni',0),(283993,7889,'tl','',0),(283994,7889,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(283995,7889,'hi','à¤†à¤¯à¤¾à¤¤',0),(283996,7889,'ms','Import',0),(283997,7889,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(283998,7889,'fr','Importations',0),(283999,7889,'jp','è¼¸å…¥',0),(284000,7889,'pt','ImportaÃ§Ãµes',0),(284001,7889,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(284002,7889,'es','Importaciones',0),(284003,7889,'de','Einfuhren',0),(284004,7889,'en','Imports',0),(284005,7890,'is','',0),(284006,7890,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(284007,7890,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(284008,7890,'tr','GÃ¼nlÃ¼k giriÅŸleri',0),(284009,7890,'pl','Wpisy do dziennika',0),(284010,7890,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(284011,7890,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(284012,7890,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ',0),(284013,7890,'vi','BÃºt toÃ¡n',0),(284014,7890,'af','Joernaalinskrywings',0),(284015,7890,'ro','IntrÄƒri Ã®n jurnal',0),(284016,7890,'et','TÃ¶Ã¶lehe kanded',0),(284017,7890,'si','Vnose v dnevnik',0),(284018,7890,'ba','Entri jurnal',0),(284019,7890,'nl','Logboekitems',0),(284020,7890,'fi','PÃ¤ivÃ¤kirjamerkinnÃ¤t',0),(284021,7890,'no','LoggoppfÃ¸ringer',0),(284022,7890,'da','Journaloptegnelser',0),(284023,7890,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª©',0),(284024,7890,'he','×¢×¨×›×™ ×™×•×ž×Ÿ',0),(284025,7890,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚',0),(284026,7890,'zh','æ—¥è®°å¸åˆ†å½•\r\n',0),(284027,7890,'sv','Journalposter',0),(284028,7890,'it','Voci del diario',0),(284029,7890,'tl','',0),(284030,7890,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;',0),(284031,7890,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(284032,7890,'ms','Catatan jurnal',0),(284033,7890,'ar','Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(284034,7890,'fr','Ã‰critures de journal',0),(284035,7890,'jp','ä»•è¨³å¸³ã®ã‚¨ãƒ³ãƒˆãƒª',0),(284036,7890,'pt','Entradas de diÃ¡rio',0),(284037,7890,'ru','Ð—Ð°Ð¿Ð¸ÑÐµÐ¹ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ',0),(284038,7890,'es','Entradas al Diario',0),(284039,7890,'de','JournaleintrÃ¤ge',0),(284040,7890,'en','Journal Entries',0),(284041,7891,'is','',0),(284042,7891,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú¯ÙˆØ§Ù‡ÙŠ',0),(284043,7891,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú¯ÙˆØ§Ù‡ÙŠ',0),(284044,7891,'tr','Lisans bilgisi',0),(284045,7891,'pl','Informacji na temat licencji',0),(284046,7891,'bg','Ð›Ð¸Ñ†ÐµÐ½Ð· Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(284047,7891,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù„Ø§Ø¦ÛŒØ³Ù†Ø³',0),(284048,7891,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð»Ð¸Ñ†ÐµÐ½Ñ†Ð¸',0),(284049,7891,'vi','ThÃ´ng tin giáº¥y phÃ©p',0),(284050,7891,'af','Lisensie Inligting',0),(284051,7891,'ro','Info licenta',0),(284052,7891,'et','Litsentsi Info',0),(284053,7891,'si','Dati dovoljenje zavijati',0),(284054,7891,'ba','Lisensi Info',0),(284055,7891,'nl','Licentie Info',0),(284056,7891,'fi','Lisenssin Info',0),(284057,7891,'no','Lisens informasjon',0),(284058,7891,'da','Licens Info',0),(284059,7891,'ko','ë¼ì´ì„¼ìŠ¤ ì •ë³´',0),(284060,7891,'he','×ž×™×“×¢ ×¨×©×™×•×Ÿ',0),(284061,7891,'el','Info Î¬Î´ÎµÎ¹Î±',0),(284062,7891,'zh','æŽˆæƒè®¸å¯ä¿¡æ¯\r\n',0),(284063,7891,'sv','Licens information',0),(284064,7891,'it','Licenza Info',0),(284065,7891,'tl','',0),(284066,7891,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3610;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(284067,7891,'hi','à¤²à¤¾à¤‡à¤¸à¥‡à¤‚à¤¸ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(284068,7891,'ms','Maklumat Lesen',0),(284069,7891,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ±Ø®ÙŠØµ',0),(284070,7891,'fr','Infos licence',0),(284071,7891,'jp','ãƒ©ã‚¤ã‚»ãƒ³ã‚¹æƒ…å ±',0),(284072,7891,'pt','InformaÃ§Ã£o de licenÃ§a',0),(284073,7891,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð»Ð¸Ñ†ÐµÐ½Ð·Ð¸Ð¸',0),(284074,7891,'es','Info de Licencia',0),(284075,7891,'de','Lizenzinfo',0),(284076,7891,'en','License Info',0),(284077,7892,'is','',0),(284078,7892,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(284079,7892,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(284080,7892,'tr','TamamlanmÄ±ÅŸ sipariÅŸleri listesi',0),(284081,7892,'pl','Wykaz zakoÅ„czonych zleceÅ„',0),(284082,7892,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(284083,7892,'ur','Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ Ù…Ú©Ù…Ù„ ÙÛØ±Ø³Øª',0),(284084,7892,'sr','Ð›Ð¸ÑÑ‚Ñƒ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸Ñ… Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(284085,7892,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng Ä‘Ã£ hoÃ n táº¥t',0),(284086,7892,'af','Lyste van Voltooide Bestellings',0),(284087,7892,'ro','Lista de comenzi finalizate',0),(284088,7892,'et','TÃ¤idetud tellimuste loend',0),(284089,7892,'si','Seznam dopolnil naroÄila',0),(284090,7892,'ba','Daftar Pesanan yang Terpenuhi',0),(284091,7892,'nl','Lijst van voltooide bestellingen',0),(284092,7892,'fi','Luettelo valmiiksi saaduista tilauksista',0),(284093,7892,'no','Liste over ferdige ordrer',0),(284094,7892,'da','Liste over fÃ¦rdige ordrer',0),(284095,7892,'ko','ì™„ë£Œ ëœ ì£¼ë¬¸ ëª©ë¡',0),(284096,7892,'he','×¨×©×™×ž×ª ×”×–×ž× ×•×ª ×©×”×•×©×œ×ž×•',0),(284097,7892,'el','Î•ÎºÏ„ÎµÎ»ÎµÏƒÎ¼Î­Î½ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î»Î¯ÏƒÏ„Î±',0),(284098,7892,'zh','å·²å®Œæˆè®¢å•åˆ—è¡¨\r\n',0),(284099,7892,'sv','Lista Ã¶ver avslutade bestÃ¤llningar',0),(284100,7892,'it','Elenco di ordini completati',0),(284101,7892,'tl','',0),(284102,7892,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(284103,7892,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(284104,7892,'ms','Senarai pesanan yang lengkap',0),(284105,7892,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø©',0),(284106,7892,'fr','List des commmandes complete',0),(284107,7892,'jp','å®Œäº†ã—ãŸæ³¨æ–‡ã®ä¸€è¦§',0),(284108,7892,'pt','Lista de pedidos concluÃ­dos',0),(284109,7892,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð½Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(284110,7892,'es','Lista de Pedidos Completados',0),(284111,7892,'de','Liste der abgeschlossenen Bestellungen',0),(284112,7892,'en','List of Completed Orders',0),(284113,7893,'is','',0),(284114,7893,'dr','Ù„ÙŠØ³Øª ØªÙˆØ¶ÙŠØ­Ø§Øª',0),(284115,7893,'pr','Ù„ÙŠØ³Øª ØªÙˆØ¶ÙŠØ­Ø§Øª',0),(284116,7893,'tr','Liste tanÄ±mlarÄ±',0),(284117,7893,'pl','Lista definicji',0),(284118,7893,'bg','Ð”ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ð¸ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(284119,7893,'ur','ÙÛØ±Ø³Øª Ú©ÛŒ ØªØ¹Ø±ÛŒÙ',0),(284120,7893,'sr','Ð›Ð¸ÑÑ‚Ð° Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ðµ',0),(284121,7893,'vi','Danh sÃ¡ch Ä‘á»‹nh nghÄ©a ',0),(284122,7893,'af','Lys Definisies',0),(284123,7893,'ro','Lista de definiÅ£ii',0),(284124,7893,'et','Loetelu mÃµisted',0),(284125,7893,'si','Seznam opredelitev pojmov',0),(284126,7893,'ba','Daftar definisi',0),(284127,7893,'nl','Lijst met definities',0),(284128,7893,'fi','Luettelo mÃ¤Ã¤ritelmÃ¤t',0),(284129,7893,'no','Listen definisjoner',0),(284130,7893,'da','Liste over definitioner',0),(284131,7893,'ko','ëª©ë¡ ì •ì˜',0),(284132,7893,'he','×”×’×“×¨×•×ª ×”×¨×©×™×ž×”',0),(284133,7893,'el','Î›Î¯ÏƒÏ„Î± Î¿ÏÎ¹ÏƒÎ¼ÏŽÎ½',0),(284134,7893,'zh','åˆ—è¡¨å®šä¹‰\r\n',0),(284135,7893,'sv','Lista definitioner',0),(284136,7893,'it','Elenco definizioni',0),(284137,7893,'tl','',0),(284138,7893,'th','&#3586;&#3657;&#3629;&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(284139,7893,'hi','à¤¸à¥‚à¤šà¥€ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾à¤à¤',0),(284140,7893,'ms','Senarai definisi',0),(284141,7893,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„ØªØ¹Ø§Ø±ÙŠÙ',0),(284142,7893,'fr','DÃ©finitions de liste',0),(284143,7893,'jp','ãƒªã‚¹ãƒˆå®šç¾©',0),(284144,7893,'pt','Lista de definiÃ§Ãµes',0),(284145,7893,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¡Ð¾Ð²Ð¿Ð°Ð´ÐµÐ½Ð¸Ð¹',0),(284146,7893,'es','Listar Definiciones',0),(284147,7893,'de','Listendefinitionen',0),(284148,7893,'en','List Definitions',0),(284149,7894,'is','',0),(284150,7894,'dr','Ù„ÙŠØ³Øª Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(284151,7894,'pr','Ù„ÙŠØ³Øª Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(284152,7894,'tr','Liste Ã¶deme planlarÄ±',0),(284153,7894,'pl','Lista planÃ³w pÅ‚atnoÅ›ci',0),(284154,7894,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(284155,7894,'ur','ÙÛØ±Ø³Øª Ù¾Û’ Ù…Ù†Ù¹ Ù¾Ù„Ø§Ù†',0),(284156,7894,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ð»Ð°Ð½ Ð¾Ñ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(284157,7894,'vi','Danh sÃ¡ch káº¿ hoáº¡ch thanh toÃ¡n',0),(284158,7894,'af','Lys Betalingsplanne',0),(284159,7894,'ro','Planuri de plata lista',0),(284160,7894,'et','Maksegraafikute nimekiri',0),(284161,7894,'si','Seznam plaÄilnih naÄrtov',0),(284162,7894,'ba','Daftar rencana pembayaran',0),(284163,7894,'nl','Lijst betaling plannen',0),(284164,7894,'fi','Luettelo Maksusuunnitelmat',0),(284165,7894,'no','Listen betalingsplaner',0),(284166,7894,'da','Listen betaling planer',0),(284167,7894,'ko','ëª©ë¡ ì§€ë¶ˆ ê³„íš',0),(284168,7894,'he','×¨×©×™×ž×ª ×ª×©×œ×•×ž×™×',0),(284169,7894,'el','Î›Î¯ÏƒÏ„Î± ÏƒÏ‡Î­Î´Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(284170,7894,'zh','åˆ—å‡ºä»˜æ¬¾è®¡åˆ’\r\n',0),(284171,7894,'sv','Lista betalningsplaner',0),(284172,7894,'it','Elenco piani di pagamento',0),(284173,7894,'tl','',0),(284174,7894,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(284175,7894,'hi','à¤¸à¥‚à¤šà¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(284176,7894,'ms','Senarai bayaran pelan',0),(284177,7894,'ar','Ø³Ø±Ø¯ Ø®Ø·Ø· Ø§Ù„ØªØ³ÙˆÙŠÙ‚',0),(284178,7894,'fr','Liste des Plans de paiement',0),(284179,7894,'jp','ãŠæ”¯æ‰•ã„ãƒ—ãƒ©ãƒ³ã®ä¸€è¦§',0),(284180,7894,'pt','Lista de planos de pagamento',0),(284181,7894,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ñ… ÐŸÐ»Ð°Ð½Ð¾Ð²',0),(284182,7894,'es','Lista de Planes de Pago',0),(284183,7894,'de','Liste ZahlungsplÃ¤ne',0),(284184,7894,'en','List Payment Plans',0),(284185,7895,'is','',0),(284186,7895,'dr','Ù„ÙŠØ³Øª Ø·Ø±Ø­ Ù‡Ø§ ',0),(284187,7895,'pr','Ù„ÙŠØ³Øª Ø·Ø±Ø­ Ù‡Ø§ ',0),(284188,7895,'tr','Liste planlarÄ±',0),(284189,7895,'pl','Lista planÃ³w',0),(284190,7895,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(284191,7895,'ur','ÙÛØ±Ø³Øª Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(284192,7895,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(284193,7895,'vi','Danh sÃ¡ch káº¿ hoáº¡ch',0),(284194,7895,'af','Lys Planne',0),(284195,7895,'ro','Lista planurilor',0),(284196,7895,'et','Nimekiri plaanid',0),(284197,7895,'si','Seznam naÄrti',0),(284198,7895,'ba','Daftar rencana',0),(284199,7895,'nl','Lijst plannen',0),(284200,7895,'fi','Luettelo suunnitelmat',0),(284201,7895,'no','Listen planer',0),(284202,7895,'da','Liste over planer',0),(284203,7895,'ko','ëª©ë¡ ê³„íš',0),(284204,7895,'he','×¨×©×™×ž×ª ×ª×•×›× ×™×•×ª',0),(284205,7895,'el','Î›Î¯ÏƒÏ„Î± ÏƒÏ‡Î­Î´Î¹Î±',0),(284206,7895,'zh','è®¡åˆ’åå•\r\n',0),(284207,7895,'sv','Lista planer',0),(284208,7895,'it','Elenco piani',0),(284209,7895,'tl','',0),(284210,7895,'th','&#3649;&#3612;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(284211,7895,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(284212,7895,'ms','Senarai rancangan',0),(284213,7895,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ù‚Ø³Ø§Ø·',0),(284214,7895,'fr','Liste des Plans',0),(284215,7895,'jp','ãƒªã‚¹ãƒˆã®è¨ˆç”»',0),(284216,7895,'pt','Lista de planos',0),(284217,7895,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐŸÐ»Ð°Ð½Ð¾Ð²',0),(284218,7895,'es','Listar Planes',0),(284219,7895,'de','Liste-PlÃ¤ne',0),(284220,7895,'en','List Plans',0),(284221,7896,'is','',0),(284222,7896,'dr','Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… , ØªÙ…Ø§Ù… Ù…Ø¹Ø§Ø´  Ùˆ Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(284223,7896,'pr','Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… , ØªÙ…Ø§Ù… Ø­Ù‚ÙˆÙ‚  Ùˆ Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø¯ÙˆØ±Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(284224,7896,'tr','Saat oturum, maaÅŸ ve vergi dÃ¶nemi iÃ§in hesapla',0),(284225,7896,'pl','RejestrowaÄ‡ godziny, obliczyÄ‡ wszystkie wynagrodzeÅ„ i podatkÃ³w za okres',0),(284226,7896,'bg','Ð’Ð»ÐµÐ·Ñ‚Ðµ Ñ‡Ð°ÑÐ°, Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(284227,7896,'ur','Ø§ÙˆÙ‚Ø§Øª Ù„Ø§Ú¯ Ø§Ù†ØŒ Ù…Ø¯Øª Ú©Û’ Ù„ÛŒÛ’ ØªÙ…Ø§Ù… ØªÙ†Ø®ÙˆØ§Û Ø§ÙˆØ± Ù¹ÛŒÚ©Ø³ Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(284228,7896,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸ ÑÐ°Ñ‚Ð¸, Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ˜ ÑÐ²Ðµ Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð·Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(284229,7896,'vi','Giá» cháº¥m cÃ´ng, tÃ­nh táº¥t cáº£ lÆ°Æ¡ng & thuáº¿ trong ká»³',0),(284230,7896,'af','Log Ure, Bereken Alle Lone en Belastigns vir Periode',0),(284231,7896,'ro','Jurnal de ore, se calculeazÄƒ toate platÄƒ ÅŸi impozite pentru perioada',0),(284232,7896,'et','Log tundi, palga ja maksude arvutamiseks ajavahemiku',0),(284233,7896,'si','Prijavite ur, izraÄun plaÄe in davkov za obdobje',0),(284234,7896,'ba','Log jam, menghitung semua gaji dan pajak untuk periode',0),(284235,7896,'nl','Log uren, alle salarissen en belastingen voor periode berekenen',0),(284236,7896,'fi','Kirjaudu tuntia, laskea kaikki maksu ja verot ajanjaksolta',0),(284237,7896,'no','Logge timer, beregne alle lÃ¸nn og skatt For periode',0),(284238,7896,'da','Log timer, beregne alle lÃ¸n og skatter For perioden',0),(284239,7896,'ko','ë¡œê·¸ì¸ ì‹œê°„, ê¸°ê°„ì— ëŒ€ í•œ ëª¨ë“  ê¸‰ì—¬ ë° ì„¸ê¸ˆ ê³„ì‚°',0),(284240,7896,'he','×™×•×ž×Ÿ ×©×¢×•×ª, ×—×™×©×•×‘ ×©×›×¨ ×•×ž×™×¡×™× ×›×œ ×œ×ª×§×•×¤×”',0),(284241,7896,'el','Î£Ï…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ ÏŽÏÎµÏ‚, Î½Î± Ï…Ï€Î¿Î»Î¿Î³Î¯ÏƒÎµÎ¹ ÏŒÎ»Î± Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ ÎºÎ±Î¹ Ï†ÏŒÏÎ¿Ï…Ï‚ Î³Î¹Î± Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(284242,7896,'zh','æ—¥å¿—æ—¶é—´ï¼Œè®¡ç®—å…¨éƒ¨å‘¨æœŸæ”¯ä»˜å’Œç¨Žæ”¶\r\n',0),(284243,7896,'sv','Logga in timmar, berÃ¤kna alla lÃ¶ner och skatter fÃ¶r Period',0),(284244,7896,'it','Ore di log, calcolare tutte le paga e le tasse per il periodo',0),(284245,7896,'tl','',0),(284246,7896,'th','Log Hours, Calculate All Pay and Taxes For Period',0),(284247,7896,'hi','à¤²à¥‰à¤— à¤‘à¤¨ à¤˜à¤‚à¤Ÿà¥‡, à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤µà¥‡à¤¤à¤¨ à¤”à¤° à¤•à¤°à¥‹à¤‚ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(284248,7896,'ms','Log masuk jam, kira semua gaji dan cukai untuk tempoh',0),(284249,7896,'ar','ØªØ³Ø¬ÙŠÙ„ Ø³Ø§Ø¹Ø§ØªØŒ ÙˆØ­Ø³Ø§Ø¨ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø£Ø¬ÙˆØ± ÙˆØ§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ù„Ù„ÙØªØ±Ø©',0),(284250,7896,'fr','Ouvrez une session heures, calculer tous les payants et les Taxes pour la pÃ©riode',0),(284251,7896,'jp','æ™‚é–“ã®ãƒ­ã‚°ã¯ã€ã™ã¹ã¦ã®çµ¦ä¸Žã¨ç¨Žé‡‘ã‚’è¨ˆç®—ã™ã‚‹æœŸé–“',0),(284252,7896,'pt','Horas de log, calcular todos os salÃ¡rios e impostos por perÃ­odo',0),(284253,7896,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ñ‡Ð°ÑÐ¾Ð², Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð²ÑÐµ ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ðµ Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð¸ Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(284254,7896,'es','Horas de BitÃ¡cora, Calcular Todos Pagos y Impuestos para el PerÃ­odo',0),(284255,7896,'de','Melden Sie sich Stunden, berechnen alle Zahlen und Steuern fÃ¼r Zeitraum',0),(284256,7896,'en','Log Hours, Calculate All Pay and Taxes For Period',0),(284257,7897,'is','',0),(284258,7897,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ÙØ±ÙˆØ´ Ù‡Ø§ ',0),(284259,7897,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ÙØ±ÙˆØ´ Ù‡Ø§ ',0),(284260,7897,'tr','Ã‡eÅŸitli satÄ±ÅŸ',0),(284261,7897,'pl','Misc sprzedaÅ¼y',0),(284262,7897,'bg','Ð Ð°Ð·Ð½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(284263,7897,'ur','Ù…ØªÙØ±Ù‚ Ø³ÛŒÙ„Ø²',0),(284264,7897,'sr','ÐœÐ˜Ð¡Ð¦ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(284265,7897,'vi','Doanh sá»‘ láº·t váº·t',0),(284266,7897,'af','Misc verkope',0),(284267,7897,'ro','Vanzari diverse',0),(284268,7897,'et','Varia mÃ¼Ã¼k',0),(284269,7897,'si','Misc prodaje',0),(284270,7897,'ba','Misc penjualan',0),(284271,7897,'nl','Misc verkoop',0),(284272,7897,'fi','Muut myynti',0),(284273,7897,'no','Diverse salg',0),(284274,7897,'da','Misc salg',0),(284275,7897,'ko','ê¸°íƒ€ íŒë§¤',0),(284276,7897,'he','×ž×›×™×¨×•×ª ×©×•× ×•×ª',0),(284277,7897,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ misc',0),(284278,7897,'zh','æ‚é¡¹é”€å”®\r\n',0),(284279,7897,'sv','Misc fÃ¶rsÃ¤ljning',0),(284280,7897,'it','Vendite misc',0),(284281,7897,'tl','',0),(284282,7897,'th','&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;&#3648;&#3610;&#3655;&#3604;&#3648;&#3605;&#3621;&#3655;&#3604;',0),(284283,7897,'hi','à¤µà¤¿à¤µà¤¿à¤§ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(284284,7897,'ms','Jualan MISC',0),(284285,7897,'ar','Ù…Ø¨ÙŠØ¹Ø§Øª Ù…ØªÙØ±Ù‚Ø©',0),(284286,7897,'fr','Divers ventes',0),(284287,7897,'jp','ãã®ä»–å£²ã‚Šä¸Šã’é«˜',0),(284288,7897,'pt','Misc vendas',0),(284289,7897,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° Ð Ð°Ð·Ð½Ð¾Ðµ',0),(284290,7897,'es','Ventas Misc.',0),(284291,7897,'de','Misc Verkauf',0),(284292,7897,'en','Misc Sales',0),(284293,7898,'is','',0),(284294,7898,'dr','Ù†Ø§Ù…  Ø¢Ø¯Ø±Ø³  ØªÙ„ÙÙ† ',0),(284295,7898,'pr','Ù†Ø§Ù…  Ø¢Ø¯Ø±Ø³  ØªÙ„ÙÙ† ',0),(284296,7898,'tr','Ad-adres-telefon',0),(284297,7898,'pl','Nazwa, adres, telefon',0),(284298,7898,'bg','Ð˜Ð¼Ðµ/Ð°Ð´Ñ€ÐµÑ/Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(284299,7898,'ur','Ù†Ø§Ù…/Ù¾ØªÛ/ÙÙˆÙ†',0),(284300,7898,'sr','Ð˜Ð¼Ðµ/ÐÐ´Ñ€ÐµÑÐ°/Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(284301,7898,'vi','TÃªn/Äá»‹a chá»‰/Phone',0),(284302,7898,'af','Naam/Adres/Telefoon',0),(284303,7898,'ro','Nume/adresa/telefon',0),(284304,7898,'et','Nimi/Aadress/Telefon',0),(284305,7898,'si','Naslov/ime/telefon',0),(284306,7898,'ba','Nama/alamat/telepon',0),(284307,7898,'nl','Naam/adres/telefoon',0),(284308,7898,'fi','Nimi, osoite, puhelinnumero',0),(284309,7898,'no','Navn/adresse/telefon',0),(284310,7898,'da','Navn/adresse/telefon',0),(284311,7898,'ko','ì´ë¦„/ì£¼ì†Œ/ì „í™”',0),(284312,7898,'he','×©×/×›×ª×•×‘×ª/×˜×œ×¤×•×Ÿ',0),(284313,7898,'el','ÎŒÎ½Î¿Î¼Î±/Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·/Ï„Î·Î»Î­Ï†Ï‰Î½Î¿',0),(284314,7898,'zh','å§“å/åœ°å€/ç”µè¯\r\n',0),(284315,7898,'sv','Namn/adress/telefon',0),(284316,7898,'it','Nome/indirizzo/telefono',0),(284317,7898,'tl','',0),(284318,7898,'th','&#3594;&#3639;&#3656;&#3629;/&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;/&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(284319,7898,'hi','à¤¨à¤¾à¤®/à¤ªà¤¤à¤¾/à¤«à¥‹à¤¨',0),(284320,7898,'ms','Nama/alamat/telefon',0),(284321,7898,'ar','Ø§Ù„Ø¥Ø³Ù…/Ø§Ù„Ø¹Ù†ÙˆØ§Ù†/Ø§Ù„Ù‡Ø§ØªÙ',0),(284322,7898,'fr','Nom/adresse/tÃ©lÃ©phone',0),(284323,7898,'jp','åå‰/ä½æ‰€/é›»è©±',0),(284324,7898,'pt','Nome/endereÃ§o/telefone',0),(284325,7898,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ/ÐÐ´Ñ€ÐµÑ/Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(284326,7898,'es','Nombre/DirecciÃ³n/TelÃ©fono',0),(284327,7898,'de','Name/Adresse/Telefon',0),(284328,7898,'en','Name/Address/Phone',0),(284329,7899,'is','',0),(284330,7899,'dr','Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†ÙƒÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(284331,7899,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†ÙƒÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(284332,7899,'tr','Yeni banka mevduat',0),(284333,7899,'pl','Nowy przelew',0),(284334,7899,'bg','ÐÐ¾Ð² Ð±Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(284335,7899,'ur','Ù†Ø¦Û’ Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹',0),(284336,7899,'sr','ÐÐ¾Ð²Ð¸ Ð±Ð°Ð½ÐºÐ¾Ð²Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚.',0),(284337,7899,'vi','KÃ½ quá»¹ ngÃ¢n hÃ ng má»›i',0),(284338,7899,'af','Nuwe Bank Deposito',0),(284339,7899,'ro','Noul depozit bancar',0),(284340,7899,'et','Uus pangahoiuste',0),(284341,7899,'si','Nov banÄni depozit',0),(284342,7899,'ba','Baru deposito Bank',0),(284343,7899,'nl','Nieuwe bankstorting',0),(284344,7899,'fi','Uuden pankkitalletus',0),(284345,7899,'no','Nye bankinnskudd',0),(284346,7899,'da','Ny Bank depositum',0),(284347,7899,'ko','ìƒˆë¡œìš´ ì€í–‰ ì˜ˆê¸ˆ',0),(284348,7899,'he','×¤×§×“×•×Ÿ ×‘× ×§ ×—×“×©',0),(284349,7899,'el','ÎÎ­Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÎµ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(284350,7899,'zh','æ–°çš„é“¶è¡Œå­˜æ¬¾\r\n',0),(284351,7899,'sv','Nya bankinsÃ¤ttning',0),(284352,7899,'it','Nuovo deposito bancario',0),(284353,7899,'tl','',0),(284354,7899,'th','&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(284355,7899,'hi','à¤¨à¤ à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾',0),(284356,7899,'ms','Baru Bank Deposit',0),(284357,7899,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ù…ØµØ±ÙÙŠ Ø¬Ø¯ÙŠØ¯',0),(284358,7899,'fr','Nouveau dÃ©pÃ´t de banque',0),(284359,7899,'jp','æ–°ã—ã„éŠ€è¡Œé é‡‘',0),(284360,7899,'pt','Novo depÃ³sito bancÃ¡rio',0),(284361,7899,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(284362,7899,'es','Nuevo DepÃ³sito Bancario',0),(284363,7899,'de','Neue Bank hinterlegen',0),(284364,7899,'en','New Bank Deposit',0),(284365,7900,'is','',0),(284366,7900,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯',0),(284367,7900,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯',0),(284368,7900,'tr','Yeni tasarÄ±',0),(284369,7900,'pl','Nowy projekt ustawy',0),(284370,7900,'bg','ÐÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(284371,7900,'ur','Ù†Ø¦Û’ Ø¨Ù„',0),(284372,7900,'sr','ÐÐ¾Ð²Ð¸ Ð·Ð°ÐºÐ¾Ð½',0),(284373,7900,'vi','HÃ³a ÄÆ¡n Má»›i',0),(284374,7900,'af','Nuwe Rekening',0),(284375,7900,'ro','Nou proiect de lege',0),(284376,7900,'et','Uus arve',0),(284377,7900,'si','Novega zakona',0),(284378,7900,'ba','RUU baru',0),(284379,7900,'nl','Nieuwe Bill',0),(284380,7900,'fi','Uusi Bill',0),(284381,7900,'no','Nye regningen',0),(284382,7900,'da','Nyt lovforslag',0),(284383,7900,'ko','ìƒˆë¡œìš´ ë¹Œ',0),(284384,7900,'he','×—×©×‘×•×Ÿ ×—×“×©',0),(284385,7900,'el','ÎÎ­Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(284386,7900,'zh','æ–°æ¡ä¾‹è‰æ¡ˆ\r\n',0),(284387,7900,'sv','Nytt lagfÃ¶rslag',0),(284388,7900,'it','Nuovo disegno di legge',0),(284389,7900,'tl','',0),(284390,7900,'th','&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(284391,7900,'hi','à¤¨à¤¯à¤¾ à¤¬à¤¿à¤²',0),(284392,7900,'ms','Rang undang-undang baru',0),(284393,7900,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ù…ÙˆØ±Ø¯ Ø¬Ø¯ÙŠØ¯Ø©',0),(284394,7900,'fr','Nouveau projet de loi',0),(284395,7900,'jp','æ–°æ³•æ¡ˆ',0),(284396,7900,'pt','Novo projeto de lei',0),(284397,7900,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(284398,7900,'es','Nuevo Recibo/Factura',0),(284399,7900,'de','Neue Rechnung',0),(284400,7900,'en','New Bill',0),(284401,7901,'is','',0),(284402,7901,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(284403,7901,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(284404,7901,'tr','Yeni mÃ¼ÅŸteri',0),(284405,7901,'pl','Nowy klient',0),(284406,7901,'bg','ÐÐ¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(284407,7901,'ur','Ù†Ø¦Û’ Ú¯Ø§ÛÚ©',0),(284408,7901,'sr','ÐÐ¾Ð²Ð¸ ÐºÑƒÐ¿Ð°Ñ†',0),(284409,7901,'vi','KhÃ¡ch hÃ ng má»›i',0),(284410,7901,'af','Nuwe Klant/KliÃ«nte',0),(284411,7901,'ro','Client nou',0),(284412,7901,'et','Uus klient',0),(284413,7901,'si','Novega kupca',0),(284414,7901,'ba','Pelanggan Baru',0),(284415,7901,'nl','Nieuwe klant',0),(284416,7901,'fi','Uusi asiakas',0),(284417,7901,'no','Ny kunde',0),(284418,7901,'da','Ny kunde',0),(284419,7901,'ko','ìƒˆë¡œìš´ ê³ ê°',0),(284420,7901,'he','×œ×§×•×— ×—×“×©',0),(284421,7901,'el','ÎÎ­Î¿Ï‚ Ï€ÎµÎ»Î¬Ï„Î·Ï‚',0),(284422,7901,'zh','æ–°å®¢æˆ·\r\n',0),(284423,7901,'sv','Ny kund',0),(284424,7901,'it','Nuovo cliente',0),(284425,7901,'tl','',0),(284426,7901,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(284427,7901,'hi','à¤¨à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(284428,7901,'ms','Pelanggan baru',0),(284429,7901,'ar','Ø²Ø¨ÙˆÙ† Ø¬Ø¯ÙŠØ¯',0),(284430,7901,'fr','Nouveau client',0),(284431,7901,'jp','æ–°ã—ã„é¡§å®¢',0),(284432,7901,'pt','Novo cliente',0),(284433,7901,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐšÐ»Ð¸ÐµÐ½Ñ‚',0),(284434,7901,'es','Nuevo Cliente',0),(284435,7901,'de','Neuer Kunde',0),(284436,7901,'en','New Customer',0),(284437,7902,'is','',0),(284438,7902,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(284439,7902,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(284440,7902,'tr','Yeni bir yaÅŸ',0),(284441,7902,'pl','Nowego pracownika',0),(284442,7902,'bg','ÐÐ¾Ð² ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(284443,7902,'ur','Ù†ÛŒÙˆ Ù…Ù„Ø§Ø²Ù…',0),(284444,7902,'sr','ÐÐ¾Ð²Ð¸ Ñ€Ð°Ð´Ð½Ð¸Ðº',0),(284445,7902,'vi','NhÃ¢n viÃªn má»›i',0),(284446,7902,'af','Nuwe Werknemer',0),(284447,7902,'ro','Noul angajat',0),(284448,7902,'et','Uus tÃ¶Ã¶taja',0),(284449,7902,'si','Novo zaposleni',0),(284450,7902,'ba','Karyawan baru',0),(284451,7902,'nl','Nieuwe medewerker',0),(284452,7902,'fi','Uusi tyÃ¶ntekijÃ¤',0),(284453,7902,'no','Ny ansatt',0),(284454,7902,'da','Ny medarbejder',0),(284455,7902,'ko','ìƒˆ ì§ì›',0),(284456,7902,'he','×¢×•×‘×“ ×—×“×©',0),(284457,7902,'el','ÎÎ­Î¿Ï‚ Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚',0),(284458,7902,'zh','æ–°å‘˜å·¥\r\n',0),(284459,7902,'sv','Ny medarbetare',0),(284460,7902,'it','Nuovo dipendente',0),(284461,7902,'tl','',0),(284462,7902,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(284463,7902,'hi','à¤¨à¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(284464,7902,'ms','Pekerja baru',0),(284465,7902,'ar','Ù…ÙˆØ¸Ù Ø¬Ø¯ÙŠØ¯',0),(284466,7902,'fr','Nouvel employÃ©',0),(284467,7902,'jp','æ–°ã—ã„å¾“æ¥­å“¡',0),(284468,7902,'pt','Novo funcionÃ¡rio',0),(284469,7902,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº',0),(284470,7902,'es','Nuevo Empleado',0),(284471,7902,'de','Neuer Mitarbeiter',0),(284472,7902,'en','New Employee',0),(284473,7903,'is','',0),(284474,7903,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ø¯ÙØªØ± ÙƒÙ„',0),(284475,7903,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯ Ø¯ÙØªØ± ÙƒÙ„',0),(284476,7903,'tr','Yeni GL hesabÄ±',0),(284477,7903,'pl','Nowe konto GL',0),(284478,7903,'bg','ÐÐ¾Ð² GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(284479,7903,'ur','Ø¬ÛŒØ¬Û’ Ú©Û’ Ù†Ø¦Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(284480,7903,'sr','ÐÐ¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð“Ð›',0),(284481,7903,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Má»›i',0),(284482,7903,'af','Nuwe AG Rekeninge',0),(284483,7903,'ro','Cont nou GL',0),(284484,7903,'et','Uued PR kontod',0),(284485,7903,'si','Nov raÄun GL',0),(284486,7903,'ba','Akun baru GL',0),(284487,7903,'nl','Nieuwe GL Account',0),(284488,7903,'fi','Uuden Kirjanpitotilin pÃ¤Ã¤tilin',0),(284489,7903,'no','Nye gi-konto',0),(284490,7903,'da','Nye GL konto',0),(284491,7903,'ko','ìƒˆë¡œìš´ GL ê³„ì •',0),(284492,7903,'he','×—×©×‘×•×Ÿ GL ×—×“×©',0),(284493,7903,'el','ÎÎ­Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(284494,7903,'zh','æ–°æ€»å¸å¸æˆ·\r\n',0),(284495,7903,'sv','Nytt GL konto',0),(284496,7903,'it','Nuovo Account GL',0),(284497,7903,'tl','',0),(284498,7903,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(284499,7903,'hi','à¤¨à¤ˆ GL à¤–à¤¾à¤¤à¥‡',0),(284500,7903,'ms','Akaun GL baru',0),(284501,7903,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(284502,7903,'fr','Nouveau compte GL',0),(284503,7903,'jp','æ–°ã—ã„ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(284504,7903,'pt','Nova conta GL',0),(284505,7903,'ru','ÐÐ¾Ð²Ñ‹Ð¹ GL ÑÑ‡ÐµÑ‚',0),(284506,7903,'es','Nuevas Cuentas LM',0),(284507,7903,'de','Neues GL-Konto',0),(284508,7903,'en','New GL Account',0),(284509,7904,'is','',0),(284510,7904,'dr','ÙØ§ÙƒØªÙˆØ± Ø¬Ø¯ÙŠØ¯ ',0),(284511,7904,'pr','ÙØ§ÙƒØªÙˆØ± Ø¬Ø¯ÙŠØ¯ ',0),(284512,7904,'tr','Yeni fatura',0),(284513,7904,'pl','Nowa faktura',0),(284514,7904,'bg','ÐÐ¾Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(284515,7904,'ur','Ù†Ø¦Û’ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(284516,7904,'sr','ÐÐ¾Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(284517,7904,'vi','HÃ³a Ä‘Æ¡n má»›i',0),(284518,7904,'af','Nuwe Faktuur',0),(284519,7904,'ro','NouÄƒ facturÄƒ',0),(284520,7904,'et','Uus arve',0),(284521,7904,'si','Nov raÄun',0),(284522,7904,'ba','Faktur baru',0),(284523,7904,'nl','Nieuwe factuur',0),(284524,7904,'fi','Uusi lasku',0),(284525,7904,'no','Ny faktura',0),(284526,7904,'da','Ny faktura',0),(284527,7904,'ko','ìƒˆ ì†¡ìž¥',0),(284528,7904,'he','×—×©×‘×•× ×™×ª ×—×“×©×”',0),(284529,7904,'el','ÎÎ­Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(284530,7904,'zh','æ–°å‘ç¥¨\r\n',0),(284531,7904,'sv','Ny faktura',0),(284532,7904,'it','Nuova fattura',0),(284533,7904,'tl','',0),(284534,7904,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(284535,7904,'hi','à¤¨à¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(284536,7904,'ms','Invois baru',0),(284537,7904,'ar','Ù‚ÙŒØ§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯Ø©',0),(284538,7904,'fr','Nouvelle facture',0),(284539,7904,'jp','æ–°ã—ã„è«‹æ±‚æ›¸',0),(284540,7904,'pt','Nova fatura',0),(284541,7904,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¡Ñ‡ÐµÑ‚',0),(284542,7904,'es','Nueva Factura',0),(284543,7904,'de','Neue Rechnung',0),(284544,7904,'en','New Invoice',0),(284545,7905,'is','',0),(284546,7905,'dr','Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(284547,7905,'pr','Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(284548,7905,'tr','Yeni Ã¶deme planÄ±',0),(284549,7905,'pl','Nowy Plan pÅ‚atnoÅ›ci',0),(284550,7905,'bg','ÐÐ¾Ð² Ð¿Ð»Ð°Ð½ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(284551,7905,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø§ Ù†ÛŒØ§ Ù…Ù†ØµÙˆØ¨Û',0),(284552,7905,'sr','ÐÐ¾Ð²Ð¸ ÐŸÐ»Ð°Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(284553,7905,'vi','Káº¿ hoáº¡ch thanh toÃ¡n má»›i',0),(284554,7905,'af','Nuwe Betalingsplan',0),(284555,7905,'ro','Noul Plan de platÄƒ',0),(284556,7905,'et','Uus maksegraafik',0),(284557,7905,'si','Nov naÄrt plaÄil',0),(284558,7905,'ba','Rencana pembayaran baru',0),(284559,7905,'nl','Nieuwe betalingsplan',0),(284560,7905,'fi','Uusi maksusuunnitelma',0),(284561,7905,'no','Nye betalingsplan',0),(284562,7905,'da','Ny betalingsplan',0),(284563,7905,'ko','ìƒˆë¡œìš´ ì§€ë¶ˆ ê³„íš',0),(284564,7905,'he','×ª×•×›× ×™×ª ×ª×©×œ×•× ×—×“×©×”',0),(284565,7905,'el','ÎÎ­Î¿ ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(284566,7905,'zh','æ–°çš„æ”¯ä»˜è®¡åˆ’\r\n',0),(284567,7905,'sv','Ny betalningsplan',0),(284568,7905,'it','Nuovo piano di pagamento',0),(284569,7905,'tl','',0),(284570,7905,'th','&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(284571,7905,'hi','à¤¨à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾',0),(284572,7905,'ms','Pelan pembayaran yang baru',0),(284573,7905,'ar','Ø®Ø·Ù‘Ø© ØªÙ‚Ø³ÙŠØ· Ø¬Ø¯ÙŠØ¯Ø©',0),(284574,7905,'fr','Nouveau Plan de paiement',0),(284575,7905,'jp','æ–°ã—ã„æ”¯æ‰•è¨ˆç”»',0),(284576,7905,'pt','Novo plano de pagamento',0),(284577,7905,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½',0),(284578,7905,'es','Nuevo Plan de Pagos',0),(284579,7905,'de','Neue Zahlungsplan',0),(284580,7905,'en','New Payment Plan',0),(284581,7906,'is','',0),(284582,7906,'dr','Ø·Ø±Ø­ Ø¬Ø¯ÙŠØ¯ ',0),(284583,7906,'pr','Ø·Ø±Ø­ Ø¬Ø¯ÙŠØ¯ ',0),(284584,7906,'tr','Yeni Plan',0),(284585,7906,'pl','Nowy Plan',0),(284586,7906,'bg','ÐÐ¾Ð² Ð¿Ð»Ð°Ð½',0),(284587,7906,'ur','Ù†ÛŒØ§ Ù…Ù†ØµÙˆØ¨Û',0),(284588,7906,'sr','ÐÐ¾Ð²Ð¸ ÐŸÐ»Ð°Ð½',0),(284589,7906,'vi','Káº¿ hoáº¡ch má»›i',0),(284590,7906,'af','Nuwe Plan',0),(284591,7906,'ro','Noul Plan',0),(284592,7906,'et','Uus maksegraafik',0),(284593,7906,'si','Nov naÄrt',0),(284594,7906,'ba','Rencana baru',0),(284595,7906,'nl','Nieuwe Plan',0),(284596,7906,'fi','Uusi suunnitelma',0),(284597,7906,'no','Ny Plan',0),(284598,7906,'da','Ny Plan',0),(284599,7906,'ko','ìƒˆë¡œìš´ ê³„íš',0),(284600,7906,'he','×ª×›× ×™×ª ×—×“×©×”',0),(284601,7906,'el','ÎÎ­Î¿ ÏƒÏ‡Î­Î´Î¹Î¿',0),(284602,7906,'zh','æ–°è®¡åˆ’\r\n',0),(284603,7906,'sv','Ny Plan',0),(284604,7906,'it','Nuovo piano',0),(284605,7906,'tl','',0),(284606,7906,'th','&#3649;&#3612;&#3609;&#3651;&#3627;&#3617;&#3656;',0),(284607,7906,'hi','à¤¨à¤ˆ à¤¯à¥‹à¤œà¤¨à¤¾',0),(284608,7906,'ms','Pelan baru',0),(284609,7906,'ar','Ø£Ù‚Ø³Ø§Ø· Ø¬Ø¯ÙŠØ¯Ø©',0),(284610,7906,'fr','Nouveau Plan',0),(284611,7906,'jp','æ–°ã—ã„è¨ˆç”»',0),(284612,7906,'pt','Novo plano',0),(284613,7906,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐŸÐ»Ð°Ð½',0),(284614,7906,'es','Nuevo Plan',0),(284615,7906,'de','Neuer Plan',0),(284616,7906,'en','New Plan',0),(284617,7907,'is','',0),(284618,7907,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø±Ø´ÙˆÙ†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(284619,7907,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø±Ø´ÙˆÙ†Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(284620,7907,'tr','Yeni yinelenen giriÅŸler',0),(284621,7907,'pl','Nowe wpisy powtarzajÄ…ce',0),(284622,7907,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(284623,7907,'ur','Ù†Ø¦ÛŒ Ù…Ú©Ø±Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(284624,7907,'sr','ÐÐ¾Ð²Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(284625,7907,'vi','BÃºt toÃ¡n Ä‘á»‹nh ká»³ má»›i',0),(284626,7907,'af','Nuwe Herhaaldende Inskrywings',0),(284627,7907,'ro','Noi intrÄƒri recurente',0),(284628,7907,'et','Uus korduvaid kandeid',0),(284629,7907,'si','Novo ponavljajoÄe se postavke',0),(284630,7907,'ba','Entri baru berulang',0),(284631,7907,'nl','Nieuwe periodieke posten',0),(284632,7907,'fi','Uusi toistuvia tapahtumia',0),(284633,7907,'no','Nye regelmessige oppfÃ¸ringer',0),(284634,7907,'da','Nye gentagelsesposterne',0),(284635,7907,'ko','ìƒˆ ë˜í’€ì´ ë˜ëŠ” í•­ëª©',0),(284636,7907,'he','×¢×¨×›×™× ×—×“×©×™× ×—×•×–×¨×•×ª',0),(284637,7907,'el','ÎÎ­ÎµÏ‚ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(284638,7907,'zh','æ–°çš„å¾ªçŽ¯æ¡ç›®\r\n',0),(284639,7907,'sv','Ny Ã¥terkommande poster',0),(284640,7907,'it','Nuove voci ricorrenti',0),(284641,7907,'tl','',0),(284642,7907,'th','&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3627;&#3617;&#3656;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(284643,7907,'hi','à¤¨à¤¯à¤¾ à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(284644,7907,'ms','Entri berulang yang baru',0),(284645,7907,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ù…ØªÙƒØ±Ù‘Ø±Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(284646,7907,'fr','Nouvelles entrÃ©es rÃ©currentes',0),(284647,7907,'jp','æ–°ã—ã„å®šæœŸçš„ãªã‚¨ãƒ³ãƒˆãƒª',0),(284648,7907,'pt','Novas entradas recorrentes',0),(284649,7907,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(284650,7907,'es','Nuevas Entradas Recurrentes',0),(284651,7907,'de','Neue Dauerbuchungen',0),(284652,7907,'en','New Recurring Entries',0),(284653,7908,'is','',0),(284654,7908,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(284655,7908,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(284656,7908,'tr','Emirleri beklemede',0),(284657,7908,'pl','Wstrzymane zamÃ³wienia',0),(284658,7908,'bg','Ð’ Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(284659,7908,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ø±Ú©Ú¾ÛŒÚº Û”',0),(284660,7908,'sr','ÐÐ° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(284661,7908,'vi','ÄÆ¡n Äáº·t HÃ ng táº¡m ngÆ°ng',0),(284662,7908,'af','Uitgestelde Bestellings',0),(284663,7908,'ro','Å¢ineÅ£i pe comenzi',0),(284664,7908,'et','Ootel tellimused',0),(284665,7908,'si','ZadrÅ¾ano naroÄila',0),(284666,7908,'ba','On Hold pesanan',0),(284667,7908,'nl','Uitgesteld Orders',0),(284668,7908,'fi','Estossa-tilaukset',0),(284669,7908,'no','Avvent ordrer',0),(284670,7908,'da','Afvent ordrer',0),(284671,7908,'ko','ì£¼ë¬¸ ê°œìµœ',0),(284672,7908,'he','×‘×”×ž×ª× ×” ×”×–×ž× ×•×ª',0),(284673,7908,'el','Î£Îµ Î±Î½Î±Î¼Î¿Î½Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(284674,7908,'zh','ä¿æŒè®¢å•\r\n',0),(284675,7908,'sv','Ã… hÃ¥ll order',0),(284676,7908,'it','Tenere in ordini',0),(284677,7908,'tl','',0),(284678,7908,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3606;&#3639;&#3629;&#3651;&#3609;&#3617;&#3639;&#3629;',0),(284679,7908,'hi','à¤ªà¤° à¤†à¤¦à¥‡à¤¶ à¤ªà¤•à¤¡à¤¼',0),(284680,7908,'ms','Di pegang pesanan',0),(284681,7908,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø±',0),(284682,7908,'fr','En attente des ordres',0),(284683,7908,'jp','ä¿ç•™æ³¨æ–‡',0),(284684,7908,'pt','Ã€ espera de ordens',0),(284685,7908,'ru','Ð¡ Ð¿Ñ€Ð¾Ð²Ð¾Ð´Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(284686,7908,'es','En Ordenes de Retener',0),(284687,7908,'de','ZurÃ¼ckgestellte AuftrÃ¤ge',0),(284688,7908,'en','On Hold Orders',0),(284689,7909,'is','',0),(284690,7909,'dr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ø´Ø¯ Ø§Ù…Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯ ',0),(284691,7909,'pr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ø´Ø¯ Ø§Ù…Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯ ',0),(284692,7909,'tr','Ama Ã¶denmemiÅŸ fatura dÃ¼zeni',0),(284693,7909,'pl','ZamÃ³wienie pÅ‚atna ale nie pÅ‚atne',0),(284694,7909,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°, Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ñ‚ Ð½Ð¾ Ð½Ðµ ÑÐ° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(284695,7909,'ur','Ù„ÛŒÚ©Ù† Ù†ÛÛŒÚº ØªÙ†Ø®ÙˆØ§Û Ø¨Ø§Ù„Ù„Ø§Ø¯ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(284696,7909,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð°Ð»Ð¸ Ð½Ðµ Ð±Ð¸ Ð¿Ð»Ð°Ñ‚Ð¸Ð»Ð¸',0),(284697,7909,'vi','ÄÆ¡n HÃ ng Ä‘Ã£ ra hÃ³a Ä‘Æ¡n nhÆ°ng chÆ°a thanh toÃ¡n',0),(284698,7909,'af','Bestelling Gefaktureer Maar Nie Betaal',0),(284699,7909,'ro','Comanda facturata si neachitata',0),(284700,7909,'et','Selleks aga ei makstud arve',0),(284701,7909,'si','Nalog, zaraÄunali pa ne plaÄa',0),(284702,7909,'ba','Pesanan ditagih tetapi tidak dibayar',0),(284703,7909,'nl','Volgorde gefactureerd maar niet betaalde',0),(284704,7909,'fi','Tilaus laskutetaan mutta ei maksettu',0),(284705,7909,'no','Bestillingen faktureres men ikke betalt',0),(284706,7909,'da','Ordren faktureres men ikke betalt',0),(284707,7909,'ko','ì£¼ë¬¸ í•˜ì§€ ìœ ë£Œë§Œ ì²­êµ¬',0),(284708,7909,'he','×¡×“×¨ ×”×—×™×•×‘ ××‘×œ ×©×œ× ×©×•×œ×ž×•',0),(284709,7909,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï€Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³ÎµÎ¯Ï„Î±Î¹ Î±Î»Î»Î¬ Î´ÎµÎ½ ÎºÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹',0),(284710,7909,'zh','è®¢è´­å·²å…¥è´¦ä½†å°šæœªæ”¯ä»˜\r\n',0),(284711,7909,'sv','Ordern faktureras men inte betald',0),(284712,7909,'it','Ordine fatturate ma non pagato',0),(284713,7909,'tl','',0),(284714,7909,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3604;&#3657;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3649;&#3605;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3592;&#3',0),(284715,7909,'hi','à¤²à¥‡à¤•à¤¿à¤¨ à¤¨à¤¹à¥€à¤‚ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¬à¤¿à¤² à¤•à¤¿à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶',0),(284716,7909,'ms','Perintah yang dibilkan tetapi tidak dibayar',0),(284717,7909,'ar','ØªØ±ØªÙŠØ¨ ÙÙˆØ§ØªÙŠØ± Ù„ÙƒÙ† ØºÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(284718,7909,'fr','Commande facturÃ© mais pas payÃ©',0),(284719,7909,'jp','é †åºãŒæ”¯æ‰•æ¸ˆã€è«‹æ±‚',0),(284720,7909,'pt','Ordem de bico mas nÃ£o pagos',0),(284721,7909,'ru','Ð—Ð°ÐºÐ°Ð·, Ð¾Ð¿Ð»Ð°Ñ‚Ð°, Ð½Ð¾ Ð½Ðµ Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ð¹',0),(284722,7909,'es','Pedido Facturado Pero No Pagado',0),(284723,7909,'de','Bestellung in Rechnung gestellt, aber nicht bezahlt',0),(284724,7909,'en','Order Billed But Not Paid',0),(284725,7910,'is','',0),(284726,7910,'dr','Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯ ',0),(284727,7910,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø¨Ø±Ø¢ÙˆØ±Ø¯ ',0),(284728,7910,'tr','Tahmini Ã¼zerinde',0),(284729,7910,'pl','Na szacunek',0),(284730,7910,'bg','ÐÐ°Ð´ Ð¿Ñ€Ð¸Ð±Ð»Ð¸Ð·Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(284731,7910,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ù¾Ø±',0),(284732,7910,'sr','ÐŸÑ€ÐµÐºÐ¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°',0),(284733,7910,'vi','QuÃ¡ dá»± trÃ¹',0),(284734,7910,'af','Meer as Skatting',0),(284735,7910,'ro','Peste estimarea',0),(284736,7910,'et','Jooksul hinnangu',0),(284737,7910,'si','Ocenjeni',0),(284738,7910,'ba','Atas perkiraan',0),(284739,7910,'nl','Over schatting',0),(284740,7910,'fi','Arvion',0),(284741,7910,'no','Over anslag',0),(284742,7910,'da','Over skÃ¸n',0),(284743,7910,'ko','ê²¬ì ì„ í†µí•´',0),(284744,7910,'he','×ž×¢×œ ×”××•×ž×“×Ÿ',0),(284745,7910,'el','Î Î­ÏÎ± Î±Ï€ÏŒ Ï„Î·Î½ ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ·',0),(284746,7910,'zh','é«˜ä¼°\r\n',0),(284747,7910,'sv','Ã–ver uppskattningen',0),(284748,7910,'it','Su preventivo',0),(284749,7910,'tl','',0),(284750,7910,'th','&#3648;&#3585;&#3636;&#3609;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;',0),(284751,7910,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(284752,7910,'ms','Ke atas anggaran',0),(284753,7910,'ar','Ø¹Ù„Ù‰ Ù…Ø¯Ù‰ ØªÙ‚Ø¯ÙŠØ±',0),(284754,7910,'fr','Au cours de lâ€™estimation',0),(284755,7910,'jp','è¦‹ç©ã‚‚ã‚Šã®ä¸Š',0),(284756,7910,'pt','Durante estimativa',0),(284757,7910,'ru','ÐŸÐ¾ Ð¾Ñ†ÐµÐ½ÐºÐ°Ð¼',0),(284758,7910,'es','Estimar en Exceso',0),(284759,7910,'de','Ãœber SchÃ¤tzung',0),(284760,7910,'en','Over Estimate',0),(284761,7911,'is','',0),(284762,7911,'dr','Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(284763,7911,'pr','Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(284764,7911,'tr','Ã–deme planlarÄ±',0),(284765,7911,'pl','PlanÃ³w pÅ‚atnoÅ›ci',0),(284766,7911,'bg','Ð¡Ñ…ÐµÐ¼Ð¸ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(284767,7911,'ur','Ù¾Û’ Ù…Ù†Ù¹ Ù¾Ù„Ø§Ù†',0),(284768,7911,'sr','ÐŸÐ»Ð°Ð½ Ð¾Ñ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(284769,7911,'vi','Káº¿ hoáº¡ch Thanh ToÃ¡n',0),(284770,7911,'af','Betalingsplanne',0),(284771,7911,'ro','Planurile de platÄƒ',0),(284772,7911,'et','Maksegraafikud',0),(284773,7911,'si','PlaÄila naÄrti',0),(284774,7911,'ba','Rencana pembayaran',0),(284775,7911,'nl','Betaling plannen',0),(284776,7911,'fi','Maksusuunnitelmat',0),(284777,7911,'no','Betalingsplaner',0),(284778,7911,'da','Betaling planer',0),(284779,7911,'ko','ì§€ë¶ˆ ê³„íš',0),(284780,7911,'he','×ª×•×›× ×™×•×ª ×ª×©×œ×•×',0),(284781,7911,'el','Î£Ï‡Î­Î´Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(284782,7911,'zh','ä»˜æ¬¾è®¡åˆ’\r\n',0),(284783,7911,'sv','Betalningsplaner',0),(284784,7911,'it','Piani di pagamento',0),(284785,7911,'tl','',0),(284786,7911,'th','&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(284787,7911,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(284788,7911,'ms','Pelan pembayaran',0),(284789,7911,'ar','Ø®Ø·Ø· Ø§Ù„ØªÙ‚Ø³ÙŠØ·',0),(284790,7911,'fr','Plans de paiement',0),(284791,7911,'jp','ãŠæ”¯æ‰•ã„ãƒ—ãƒ©ãƒ³',0),(284792,7911,'pt','Planos de pagamento',0),(284793,7911,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ðµ ÐŸÐ»Ð°Ð½Ñ‹',0),(284794,7911,'es','Planes de Pago',0),(284795,7911,'de','ZahlungsplÃ¤ne',0),(284796,7911,'en','Payment Plans',0),(284797,7912,'is','',0),(284798,7912,'dr','Ø®Ù„Ø§ØµÙ‡ Ø­Ù‚ÙˆÙ‚',0),(284799,7912,'pr','Ø®Ù„Ø§ØµÙ‡ Ø­Ù‚ÙˆÙ‚',0),(284800,7912,'tr','Ã–deme Ã–zeti',0),(284801,7912,'pl','ZapÅ‚aciÄ‡ KrÃ³tki opis',0),(284802,7912,'bg','ÐŸÐ»Ð°Ñ‚Ð¸ Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(284803,7912,'ur','Ø®Ù„Ø§ØµÛ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(284804,7912,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(284805,7912,'vi','Tá»•ng quÃ¡t thanh toÃ¡n',0),(284806,7912,'af','Besoldiging Opsomming',0),(284807,7912,'ro','PlÄƒteascÄƒ Rezumat',0),(284808,7912,'et','Maksma KokkuvÃµte',0),(284809,7912,'si','PlaÄati Povzetek',0),(284810,7912,'ba','Membayar ringkasan',0),(284811,7912,'nl','Betalen samenvatting',0),(284812,7912,'fi','Maksu Yhteenveto',0),(284813,7912,'no','Betale Sammendrag',0),(284814,7912,'da','Betale ResumÃ©',0),(284815,7912,'ko','ìš”ì•½ì„ ì§€ë¶ˆ',0),(284816,7912,'he','×œ×©×œ× ×¡×™×›×•×',0),(284817,7912,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(284818,7912,'zh','æ”¯ä»˜æ‘˜è¦\r\n',0),(284819,7912,'sv','Betala Sammanfattning',0),(284820,7912,'it','Riepilogo di pagare',0),(284821,7912,'tl','',0),(284822,7912,'th','&#3626;&#3619;&#3640;&#3611;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(284823,7912,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(284824,7912,'ms','Membayar ringkasan',0),(284825,7912,'ar','Ø¯ÙØ¹ Ù…ÙˆØ¬Ø²',0),(284826,7912,'fr','Paye pour',0),(284827,7912,'jp','æ”¯æ‰•ã„ã®æ¦‚è¦',0),(284828,7912,'pt','Resumo de pagar',0),(284829,7912,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(284830,7912,'es','ResÃºmen de Pagos',0),(284831,7912,'de','Zusammenfassung zu zahlen',0),(284832,7912,'en','Pay Summary',0),(284833,7913,'is','',0),(284834,7913,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø¯ÙˆØ±Ù‡ Ø§ÙŠ ',0),(284835,7913,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø¯ÙˆØ±Ù‡ Ø§ÙŠ ',0),(284836,7913,'tr','DÃ¶nemsel raporlar',0),(284837,7913,'pl','Raporty okresowe',0),(284838,7913,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(284839,7913,'ur','Ù…Ø¹ÛŒØ§Ø¯ÛŒ Ø±Ù¾ÙˆØ±Ù¹ÛŒÚº',0),(284840,7913,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ',0),(284841,7913,'vi','BÃ¡o cÃ¡o theo giai Ä‘oáº¡n',0),(284842,7913,'af','Periodieke Verslae',0),(284843,7913,'ro','Rapoarte periodice',0),(284844,7913,'et','Perioodiline aruanne',0),(284845,7913,'si','PeriodiÄna poroÄila',0),(284846,7913,'ba','Laporan berkala',0),(284847,7913,'nl','Periodieke verslagen',0),(284848,7913,'fi','SÃ¤Ã¤nnÃ¶lliset kertomukset',0),(284849,7913,'no','Periodiske rapporter',0),(284850,7913,'da','Periodiske rapporter',0),(284851,7913,'ko','ì •ê¸° ë³´ê³ ',0),(284852,7913,'he','×“×•×—×•×ª ×ª×§×•×¤×ª×™×™×',0),(284853,7913,'el','Î ÎµÏÎ¹Î¿Î´Î¹ÎºÎ­Ï‚ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(284854,7913,'zh','å®šæœŸæŠ¥å‘Š\r\n',0),(284855,7913,'sv','Periodiska rapporter',0),(284856,7913,'it','Relazioni periodiche',0),(284857,7913,'tl','',0),(284858,7913,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3648;&#3611;&#3655;&#3609;&#3619;&#3632;&#3618;&#3632;',0),(284859,7913,'hi','à¤†à¤µà¤§à¤¿à¤• à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(284860,7913,'ms','Laporan berkala',0),(284861,7913,'ar','Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„Ø¯ÙˆØ±ÙŠØ©',0),(284862,7913,'fr','Rapports pÃ©riodiques',0),(284863,7913,'jp','å®šæœŸçš„ãªãƒ¬ãƒãƒ¼ãƒˆ',0),(284864,7913,'pt','RelatÃ³rios periÃ³dicos',0),(284865,7913,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹',0),(284866,7913,'es','Informes PeriÃ³dicos/Provisionales',0),(284867,7913,'de','Periodische Berichte',0),(284868,7913,'en','Periodic Reports',0),(284869,7914,'is','',0),(284870,7914,'dr','Ù„ÙŠØ³Øª ØªÙ„ÙÙ†',0),(284871,7914,'pr','Ù„ÙŠØ³Øª ØªÙ„ÙÙ†',0),(284872,7914,'tr','Telefon listesi',0),(284873,7914,'pl','Lista telefonÃ³w',0),(284874,7914,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð¸Ñ‚Ðµ',0),(284875,7914,'ur','ÙÙˆÙ† Ú©ÛŒ ÙÛØ±Ø³Øª',0),(284876,7914,'sr','Ð›Ð¸ÑÑ‚Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(284877,7914,'vi','Danh sÃ¡ch Phone',0),(284878,7914,'af','Telefoonlys',0),(284879,7914,'ro','Lista de telefon',0),(284880,7914,'et','Telefoninumbrite nimekiri',0),(284881,7914,'si','Telefonski seznam',0),(284882,7914,'ba','Daftar telepon',0),(284883,7914,'nl','Telefoonlijst',0),(284884,7914,'fi','Puhelinluettelo',0),(284885,7914,'no','Telefonliste',0),(284886,7914,'da','Telefonliste',0),(284887,7914,'ko','ì „í™” ë²ˆí˜¸ ëª©ë¡',0),(284888,7914,'he','×¨×©×™×ž×ª ×˜×œ×¤×•× ×™×',0),(284889,7914,'el','Î›Î¯ÏƒÏ„Î± Ï„Î·Î»ÎµÏ†ÏŽÎ½Ï‰Î½',0),(284890,7914,'zh','ç”µè¯åˆ—è¡¨\r\n',0),(284891,7914,'sv','Telefonlista',0),(284892,7914,'it','Elenco telefonico',0),(284893,7914,'tl','',0),(284894,7914,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(284895,7914,'hi','à¤«à¤¼à¥‹à¤¨ à¤¸à¥‚à¤šà¥€',0),(284896,7914,'ms','Senarai telefon',0),(284897,7914,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù‡Ø§ØªÙ',0),(284898,7914,'fr','Liste de tÃ©lÃ©phone',0),(284899,7914,'jp','é›»è©±ç•ªå·ãƒªã‚¹ãƒˆ',0),(284900,7914,'pt','Lista de telefone',0),(284901,7914,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ñ… ÐÐ¾Ð¼ÐµÑ€Ð¾Ð²',0),(284902,7914,'es','Lista de TelÃ©fonos',0),(284903,7914,'de','Telefonliste',0),(284904,7914,'en','Phone List',0),(284905,7915,'is','',0),(284906,7915,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ â€“ Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(284907,7915,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙÙŠØ²ÙŠÙƒÙŠ â€“ Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(284908,7915,'tr','Fiziksel envanter oluÅŸturun PO',0),(284909,7915,'pl','Fizyczne tworzenie zapasÃ³w PO',0),(284910,7915,'bg','Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ-ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° PO',0),(284911,7915,'ur','Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ-ØªØ®Ù„ÛŒÙ‚ Ù¾Ùˆ',0),(284912,7915,'sr','ÐŸÐ¾Ð¿Ð¸ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°-ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ ÐŸÐž',0),(284913,7915,'vi','Kiá»ƒm Tra HÃ ng Kho Thá»±c táº¿- Táº¡o ÄÆ¡n Mua HÃ ng',0),(284914,7915,'af','Fisiese Inventaris-Skep AB',0),(284915,7915,'ro','Inventar fizic-crea PO',0),(284916,7915,'et','FÃ¼Ã¼silise lao luua PO',0),(284917,7915,'si','FiziÄni inventar ustvariti PO',0),(284918,7915,'ba','Fisik persediaan-membuat PO',0),(284919,7915,'nl','Fysieke inventaris-Maak PO',0),(284920,7915,'fi','Fyysisen varaston luoda PO',0),(284921,7915,'no','Fysisk lager â€“ Opprett PO',0),(284922,7915,'da','Fysisk lager â€“ Opret PO',0),(284923,7915,'ko','ì‹¤ì œ ìž¬ê³  ë§Œë“¤ê¸° í¬',0),(284924,7915,'he','×¤×• ×¤×™×–×™×ª ×©×œ ×”×ž×œ××™-×¦×•×¨',0),(284925,7915,'el','Î¦Ï…ÏƒÎ¹ÎºÎ® Î±Ï€Î¿Î³ÏÎ±Ï†Î®-Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± PO',0),(284926,7915,'zh','åº“å­˜ç›˜ç‚¹ï¼Œåˆ›å»ºé‡‡è´­è®¢å•\r\n',0),(284927,7915,'sv','Fysiska lagret-skapa PO',0),(284928,7915,'it','Inventario fisico-creare PO',0),(284929,7915,'tl','',0),(284930,7915,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656; - &#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;',0),(284931,7915,'hi','PO à¤­à¥Œà¤¤à¤¿à¤• à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€-à¤¬à¤¨à¤¾à¤à¤',0),(284932,7915,'ms','PO fizikal inventori-mencipta',0),(284933,7915,'ar','Øµ. Ø¨ Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ù…Ø§Ø¯ÙŠ',0),(284934,7915,'fr','L\'inventaire physique-crÃ©er PO',0),(284935,7915,'jp','PO ã®ç‰©ç†çš„ãªã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã‚’ä½œæˆã—ã¾ã™ã€‚',0),(284936,7915,'pt','InventÃ¡rio fÃ­sico-criar PO',0),(284937,7915,'ru','Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ°Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¡ÐŸ',0),(284938,7915,'es','Inventario FÃ­sico-Crear OC',0),(284939,7915,'de','KÃ¶rperliche Inventur-erstellen Sie PO',0),(284940,7915,'en','Physical Inventory-Create PO',0),(284941,7916,'is','',0),(284942,7916,'dr','Ø§Ø±Ø³Ø§Ù„ Ø·Ø±Ø­ Ù‡Ø§',0),(284943,7916,'pr','Ø§Ø±Ø³Ø§Ù„ Ø·Ø±Ø­ Ù‡Ø§',0),(284944,7916,'tr','SonrasÄ± planlarÄ±',0),(284945,7916,'pl','Po plany',0),(284946,7916,'bg','ÐŸÐ¾ÑÑ‚ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(284947,7916,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(284948,7916,'sr','ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(284949,7916,'vi','Káº¿t chuyá»ƒn Káº¿ hoáº¡ch',0),(284950,7916,'af','Pos Planne',0),(284951,7916,'ro','Planuri de post',0),(284952,7916,'et','Post plaanid',0),(284953,7916,'si','Objava naÄrtov',0),(284954,7916,'ba','Posting rencana',0),(284955,7916,'nl','Post plannen',0),(284956,7916,'fi','LÃ¤hetÃ¤ suunnitelmat',0),(284957,7916,'no','Legge planer',0),(284958,7916,'da','Opstille planer',0),(284959,7916,'ko','ê²Œì‹œ ê³„íš',0),(284960,7916,'he','×œ×›×ª×•×‘ ×ª×•×›× ×™×•×ª',0),(284961,7916,'el','Î˜Î­ÏƒÎ· ÏƒÏ‡Î­Î´Î¹Î±',0),(284962,7916,'zh','å‘å¸ƒè®¡åˆ’\r\n',0),(284963,7916,'sv','Post planer',0),(284964,7916,'it','Piani di post',0),(284965,7916,'tl','',0),(284966,7916,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3612;&#3609;&#3591;&#3634;&#3609;',0),(284967,7916,'hi','à¤ªà¤¦ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(284968,7916,'ms','Menghantar pelan',0),(284969,7916,'ar','ØªØ±Ø­ÙŠÙ„ Ø§Ù„Ø®Ø·Ø·',0),(284970,7916,'fr','Plans de post',0),(284971,7916,'jp','è¨ˆç”»ã‚’è¨˜äº‹ã—ã¾ã™ã€‚',0),(284972,7916,'pt','Planos de post',0),(284973,7916,'ru','ÐŸÐ¾ÑÑ‚ Ð¿Ð»Ð°Ð½Ñ‹',0),(284974,7916,'es','Planes de Asentar',0),(284975,7916,'de','Post-PlÃ¤ne',0),(284976,7916,'en','Post Plans',0),(284977,7917,'is','',0),(284978,7917,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(284979,7917,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(284980,7917,'tr','Ä°ÅŸlem',0),(284981,7917,'pl','Proces',0),(284982,7917,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑ',0),(284983,7917,'ur','Ø¹Ù…Ù„',0),(284984,7917,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ',0),(284985,7917,'vi','Xá»­ lÃ½',0),(284986,7917,'af','Proses',0),(284987,7917,'ro','Procesul',0),(284988,7917,'et','Protsess',0),(284989,7917,'si','Proces',0),(284990,7917,'ba','Proses',0),(284991,7917,'nl','Proces',0),(284992,7917,'fi','Prosessi',0),(284993,7917,'no','Prosessen',0),(284994,7917,'da','Proces',0),(284995,7917,'ko','í”„ë¡œì„¸ìŠ¤',0),(284996,7917,'he','×ª×”×œ×™×š',0),(284997,7917,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±',0),(284998,7917,'zh','å¤„ç†\r\n',0),(284999,7917,'sv','Processen',0),(285000,7917,'it','Processo',0),(285001,7917,'tl','',0),(285002,7917,'th','&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;',0),(285003,7917,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾',0),(285004,7917,'ms','Proses',0),(285005,7917,'ar','Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª',0),(285006,7917,'fr','Processus',0),(285007,7917,'jp','ãƒ—ãƒ­ã‚»ã‚¹',0),(285008,7917,'pt','Processo',0),(285009,7917,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ',0),(285010,7917,'es','Proceso',0),(285011,7917,'de','Prozess',0),(285012,7917,'en','Process',0),(285013,7918,'is','',0),(285014,7918,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(285015,7918,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(285016,7918,'tr','Ä°ÅŸlem RMAs',0),(285017,7918,'pl','Proces RMAs',0),(285018,7918,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑ RMAs',0),(285019,7918,'ur','Ø¹Ù…Ù„ Ø±Ù…ÛØ³',0),(285020,7918,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ Ð ÐœÐÑ',0),(285021,7918,'vi','Xá»­ lÃ½ RMAs',0),(285022,7918,'af','Proses RMAs',0),(285023,7918,'ro','Procesul RMAs',0),(285024,7918,'et','Protsessi RMAs',0),(285025,7918,'si','Proces RMAs',0),(285026,7918,'ba','Proses RMAs',0),(285027,7918,'nl','Proces RMAs',0),(285028,7918,'fi','Prosessin RMAs',0),(285029,7918,'no','Prosessen RMAs',0),(285030,7918,'da','Processen RMAs',0),(285031,7918,'ko','í”„ë¡œì„¸ìŠ¤ Rma',0),(285032,7918,'he','×ª×”×œ×™×š RMAs',0),(285033,7918,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± RMAs',0),(285034,7918,'zh','å¤„ç†é€€è´§æŽˆæƒ\r\n',0),(285035,7918,'sv','Processen RMA',0),(285036,7918,'it','Processo RMA',0),(285037,7918,'tl','',0),(285038,7918,'th','&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621; RMAs',0),(285039,7918,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ RMAs',0),(285040,7918,'ms','RMAs proses',0),(285041,7918,'ar','Ù…Ø¹Ø§Ù„Ø¬Ø© Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(285042,7918,'fr','Processus RMA',0),(285043,7918,'jp','Rma ãƒ—ãƒ­ã‚»ã‚¹',0),(285044,7918,'pt','RMAs de processo',0),(285045,7918,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ Ð·Ð°ÑÐ²ÐºÐ¸ RMA',0),(285046,7918,'es','Procesar RMAs',0),(285047,7918,'de','Prozess RMAs',0),(285048,7918,'en','Process RMAs',0),(285049,7919,'is','',0),(285050,7919,'dr','Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(285051,7919,'pr','Ø´Ø±Ø§ÙŠØ· Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(285052,7919,'tr','Ä°ÅŸlem durumu',0),(285053,7919,'pl','Status procesu',0),(285054,7919,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(285055,7919,'ur','Ø¹Ù…Ù„ Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(285056,7919,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(285057,7919,'vi','TÃ¬nh tráº¡ng quÃ¡ trÃ¬nh',0),(285058,7919,'af','Proses Status',0),(285059,7919,'ro','Starea de proces',0),(285060,7919,'et','TÃ¶Ã¶tlemise staatus',0),(285061,7919,'si','Stanje procesa',0),(285062,7919,'ba','Status proses',0),(285063,7919,'nl','Proces Status',0),(285064,7919,'fi','Prosessin tila',0),(285065,7919,'no','Prosessen Status',0),(285066,7919,'da','Processen Status',0),(285067,7919,'ko','í”„ë¡œì„¸ìŠ¤ ìƒíƒœ',0),(285068,7919,'he','×ž×¦×‘ ×ª×”×œ×™×š',0),(285069,7919,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï„Î·Ï‚ Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±Ï‚',0),(285070,7919,'zh','å¤„ç†çŠ¶æ€\r\n',0),(285071,7919,'sv','Process Status',0),(285072,7919,'it','Stato del processo',0),(285073,7919,'tl','',0),(285074,7919,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;',0),(285075,7919,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(285076,7919,'ms','Status proses',0),(285077,7919,'ar','Ø­Ø§Ù„Ø© Ø¹Ù…Ù„ÙŠØ©',0),(285078,7919,'fr','Ã‰tat du processus',0),(285079,7919,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã®ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(285080,7919,'pt','Status do processo',0),(285081,7919,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ°',0),(285082,7919,'es','Status de Proceso',0),(285083,7919,'de','Prozess-Status',0),(285084,7919,'en','Process Status',0),(285085,7920,'is','',0),(285086,7920,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù‡Ø± Ø³Ù‡ Ù…Ø§Ù‡ ÙŠÚ© Ø¨Ø§Ø± Ùˆ Ø³Ø§Ù„Ø§Ù†Ù‡ ',0),(285087,7920,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù‡Ø± Ø³Ù‡ Ù…Ø§Ù‡ ÙŠÚ© Ø¨Ø§Ø± Ùˆ Ø³Ø§Ù„Ø§Ù†Ù‡ ',0),(285088,7920,'tr','ÃœÃ§ aylÄ±k ve yÄ±llÄ±k raporlar',0),(285089,7920,'pl','Raporty kwartalne i roczne',0),(285090,7920,'bg','Ð¢Ñ€Ð¸Ð¼ÐµÑÐµÑ‡Ð½Ð¸Ñ‚Ðµ Ð¸ Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(285091,7920,'ur','Ø³Û Ù…Ø§ÛÛŒ Ø§ÙˆØ± Ø³Ø§Ù„Ø§Ù†Û Ø±Ù¾ÙˆØ±Ù¹',0),(285092,7920,'sr','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð½Ð° Ð¸ Ð³Ð¾Ð´Ð¸ÑˆÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(285093,7920,'vi','BÃ¡o cÃ¡o quÃ½ & nÄƒm',0),(285094,7920,'af','Kwartaalikse en Jaarlikse Verslae',0),(285095,7920,'ro','Rapoarte trimestriale ÅŸi anuale',0),(285096,7920,'et','Kvartaalsed ja iga-aastased aruanded',0),(285097,7920,'si','ÄŒetrtletna in letna poroÄila',0),(285098,7920,'ba','Laporan kwartal dan tahunan',0),(285099,7920,'nl','Driemaandelijkse en jaarlijkse verslagen',0),(285100,7920,'fi','NeljÃ¤nnesvuosittaiset ja vuotuiset kertomukset',0),(285101,7920,'no','Kvartalsvise og Ã¥rlige rapporter',0),(285102,7920,'da','Kvartalsvise og Ã¥rlige rapporter',0),(285103,7920,'ko','ë¶„ê¸°ë³„ ë° ì—°ê°„ ë³´ê³ ì„œ',0),(285104,7920,'he','×“×•×—×•×ª ×¨×‘×¢×•× ×™×™× ×•×”×©× ×ª×™×™×',0),(285105,7920,'el','Î¤ÏÎ¹Î¼Î·Î½Î¹Î±Î¯ÎµÏ‚ ÎºÎ±Î¹ ÎµÏ„Î®ÏƒÎ¹ÎµÏ‚ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(285106,7920,'zh','å­£åº¦å’Œå¹´åº¦æŠ¥å‘Š\r\n',0),(285107,7920,'sv','Kvartalsvisa och Ã¥rliga rapporter',0),(285108,7920,'it','Rapporti annuali e trimestrali',0),(285109,7920,'tl','',0),(285110,7920,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;&#3649;&#3621;&#3632;&#3619;&#3634;&#3618;&#3611;&#3637;',0),(285111,7920,'hi','à¤¤à¥à¤°à¥ˆà¤®à¤¾à¤¸à¤¿à¤• à¤”à¤° à¤µà¤¾à¤°à¥à¤·à¤¿à¤• à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥‡à¤‚',0),(285112,7920,'ms','Suku tahunan dan Laporan Tahunan',0),(285113,7920,'ar','Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„ÙØµÙ„ÙŠØ© ÙˆØ§Ù„Ø³Ù†ÙˆÙŠØ©',0),(285114,7920,'fr','Rapports trimestriels et annuels',0),(285115,7920,'jp','å››åŠæœŸåŠã³å¹´æ¬¡å ±å‘Š',0),(285116,7920,'pt','RelatÃ³rios trimestrais e anuais',0),(285117,7920,'ru','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð¸ Ð³Ð¾Ð´Ð¾Ð²Ñ‹Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹',0),(285118,7920,'es','Informes Trimestrales y Anuales',0),(285119,7920,'de','Quartals-und Jahresberichte',0),(285120,7920,'en','Quarterly and Annual Reports',0),(285121,7921,'is','',0),(285122,7921,'dr','ØªÙˆØ¶ÙŠØ­Ø§Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(285123,7921,'pr','ØªÙˆØ¶ÙŠØ­Ø§Øª Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(285124,7921,'tr','AlÄ±ntÄ± yorum',0),(285125,7921,'pl','Cytat Komentarze',0),(285126,7921,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸',0),(285127,7921,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ ØªØ¨ØµØ±Û’',0),(285128,7921,'sr','ÐšÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸ Ð¾ Ð¿Ð¾Ð½ÑƒÐ´Ð°Ð¼Ð°',0),(285129,7921,'vi','Nháº­n xÃ©t bÃ¡o giÃ¡',0),(285130,7921,'af','Kwotasie Komentare',0),(285131,7921,'ro','Citat Comentarii',0),(285132,7921,'et','Hinnapakkumise kommentaarid',0),(285133,7921,'si','Citiram Komentarje',0),(285134,7921,'ba','Kutipan komentar',0),(285135,7921,'nl','Offerte-opmerkingen',0),(285136,7921,'fi','Lainaus kommentit',0),(285137,7921,'no','Tilbud kommentarer',0),(285138,7921,'da','Citat kommentarer',0),(285139,7921,'ko','ê²¬ì  ì˜ê²¬',0),(285140,7921,'he','×”×¢×¨×•×ª ×œ×”×¦×¢×ª ×ž×—×™×¨',0),(285141,7921,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ ÏƒÏ‡ÏŒÎ»Î¹Î±',0),(285142,7921,'zh','æŠ¥ä»·è¯„è®º\r\n',0),(285143,7921,'sv','Citat kommentarer',0),(285144,7921,'it','Preventivo commenti',0),(285145,7921,'tl','',0),(285146,7921,'th','&#3649;&#3592;&#3657;&#3591;&#3588;&#3635;&#3605;&#3636;&#3594;&#3617;',0),(285147,7921,'hi','à¤•à¥‹à¤Ÿ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¤¿à¤¯à¤¾à¤',0),(285148,7921,'ms','Petikan komen',0),(285149,7921,'ar','ØªØ¹Ù‚ÙŠØ¨Ø§Øª Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦Ø¨Ø©',0),(285150,7921,'fr','Commentaires de la citation',0),(285151,7921,'jp','å¼•ç”¨ã‚³ãƒ¡ãƒ³ãƒˆ',0),(285152,7921,'pt','ComentÃ¡rios de citaÃ§Ã£o',0),(285153,7921,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¸',0),(285154,7921,'es','Comentarios de CotizaciÃ³n',0),(285155,7921,'de','Zitat-Kommentare',0),(285156,7921,'en','Quote Comments',0),(285157,7922,'is','',0),(285158,7922,'dr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(285159,7922,'pr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(285160,7922,'tr','RMAs',0),(285161,7922,'pl','RMAs',0),(285162,7922,'bg','RMAs',0),(285163,7922,'ur','Ø±Ù…ÛØ³',0),(285164,7922,'sr','Ð ÐœÐÑ',0),(285165,7922,'vi','RMAs',0),(285166,7922,'af','RMAs',0),(285167,7922,'ro','RMAs',0),(285168,7922,'et','RMAs',0),(285169,7922,'si','RMAs',0),(285170,7922,'ba','RMAs',0),(285171,7922,'nl','RMAs',0),(285172,7922,'fi','RMAs',0),(285173,7922,'no','RMAs',0),(285174,7922,'da','RMAs',0),(285175,7922,'ko','Rma',0),(285176,7922,'he','RMAs',0),(285177,7922,'el','RMAs',0),(285178,7922,'zh','è¿”å›žå•†å“æŽˆæƒ\r\n',0),(285179,7922,'sv','RMA',0),(285180,7922,'it','RMA',0),(285181,7922,'tl','',0),(285182,7922,'th','RMAs',0),(285183,7922,'hi','RMAs',0),(285184,7922,'ms','RMAs',0),(285185,7922,'ar','Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(285186,7922,'fr','RMA',0),(285187,7922,'jp','Rma',0),(285188,7922,'pt','ADMs',0),(285189,7922,'ru','Ð—Ð°ÑÐ²ÐºÐ¸ RMA',0),(285190,7922,'es','RMAz',0),(285191,7922,'de','RMAs',0),(285192,7922,'en','RMAs',0),(285193,7923,'is','',0),(285194,7923,'dr','(Ø­Ø±Ø§Ø¬',0),(285195,7923,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ„ÙŠ ÙØ±ÙˆØ´ Ù‡Ø§(Ø­Ø±Ø§Ø¬',0),(285196,7923,'tr','SatÄ±ÅŸ genel bakÄ±ÅŸ',0),(285197,7923,'pl','PrzeglÄ…d sprzedaÅ¼y',0),(285198,7923,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(285199,7923,'ur','Ø³ÛŒÙ„Ø² Ú©Ø§ Ø¬Ø§Ø¦Ø²Û',0),(285200,7923,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(285201,7923,'vi','ÄÃ¡nh giÃ¡ doanh thu',0),(285202,7923,'af','Verkope Oorsig',0),(285203,7923,'ro','VÃ¢nzÄƒri de ansamblu',0),(285204,7923,'et','MÃ¼Ã¼gi Ã¼levaade',0),(285205,7923,'si','Pregled prodaje',0),(285206,7923,'ba','Penjualan Ikhtisar',0),(285207,7923,'nl','Verkoop overzicht',0),(285208,7923,'fi','Myynnin yleiskatsaus',0),(285209,7923,'no','Salg oversikt',0),(285210,7923,'da','Salgs oversigt',0),(285211,7923,'ko','íŒë§¤ ê°œìš”',0),(285212,7923,'he','×¡×§×™×¨×ª ×ž×›×™×¨×•×ª',0),(285213,7923,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎµÏ€Î¹ÏƒÎºÏŒÏ€Î·ÏƒÎ·',0),(285214,7923,'zh','é”€å”®æ¦‚è¿°\r\n',0),(285215,7923,'sv','FÃ¶rsÃ¤ljning Ã¶versikt',0),(285216,7923,'it','Sales Overview',0),(285217,7923,'tl','',0),(285218,7923,'th','&#3616;&#3634;&#3614;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;',0),(285219,7923,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤…à¤µà¤²à¥‹à¤•à¤¨',0),(285220,7923,'ms','Gambaran keseluruhan jualan',0),(285221,7923,'ar','Ù†Ø¸Ø±Ø© Ø¹Ø§Ù…Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(285222,7923,'fr','Vue d\'ensemble de vente',0),(285223,7923,'jp','å–¶æ¥­æ¦‚è¦',0),(285224,7923,'pt','VisÃ£o geral de vendas',0),(285225,7923,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(285226,7923,'es','VisiÃ³n General de Ventas',0),(285227,7923,'de','VerkaufsÃ¼bersicht',0),(285228,7923,'en','Sales Overview',0),(285229,7924,'is','',0),(285230,7924,'dr','Ù†Ø±Ø® Ø¯Ø³ØªÙ…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª ',0),(285231,7924,'pr','Ù†Ø±Ø® Ø¯Ø³ØªÙ…Ø²Ø¯ Ø®Ø¯Ù…Ø§Øª ',0),(285232,7924,'tr','Hizmet emek oranlarÄ±',0),(285233,7924,'pl','Pracy cena usÅ‚ugi',0),(285234,7924,'bg','Ð£ÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ñ‚Ñ€ÑƒÐ´Ð¾Ð²Ð¾ Ñ†ÐµÐ½Ð¸',0),(285235,7924,'ur','Ø®Ø¯Ù…Øª Ú©Û’ Ù…Ø²Ø¯ÙˆØ± Ú©ÛŒ Ø´Ø±Ø­',0),(285236,7924,'sr','Ð£ÑÐ»ÑƒÐ³Ð° Ñ€Ð°Ð´ ÑÑ‚Ð¾Ð¿Ðµ',0),(285237,7924,'vi','GiÃ¡ nhÃ¢n cÃ´ng Dá»‹ch vá»¥',0),(285238,7924,'af','Diens Arbeid Skale',0),(285239,7924,'ro','Servicii tarife muncii',0),(285240,7924,'et','Teenuse Labor mÃ¤Ã¤rad',0),(285241,7924,'si','Labor cene storitev',0),(285242,7924,'ba','TARIF tenaga kerja Layanan',0),(285243,7924,'nl','Service arbeid tarieven',0),(285244,7924,'fi','Palvelu tyÃ¶voiman hinnat',0),(285245,7924,'no','Tjenesten Ap. priser',0),(285246,7924,'da','Service Labor priser',0),(285247,7924,'ko','ì„œë¹„ìŠ¤ ë…¸ë™ ìš”ê¸ˆ',0),(285248,7924,'he','×ª×¢×¨×™×¤×™ ×¢×‘×•×“×ª ×©×¨×•×ª',0),(285249,7924,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î¿ÏƒÎ¿ÏƒÏ„Î¬',0),(285250,7924,'zh','æœåŠ¡åŠ³åŠ¨ä»·æ ¼\r\n',0),(285251,7924,'sv','TjÃ¤nsten Labor priser',0),(285252,7924,'it','Servizio lavoro tariffe',0),(285253,7924,'tl','',0),(285254,7924,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3656;&#3634;&#3649;&#3619;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(285255,7924,'hi','à¤¸à¥‡à¤µà¤¾ à¤¶à¥à¤°à¤® à¤¦à¤°à¥‹à¤‚',0),(285256,7924,'ms','Kadar buruh Perkhidmatan',0),(285257,7924,'ar','Ø£Ø³Ø¹Ø§Ø± Ø®Ø¯Ù…Ø© Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ø§Ù„',0),(285258,7924,'fr','Tarifs du service du travail',0),(285259,7924,'jp','ã‚µãƒ¼ãƒ“ã‚¹åŠ´åƒçŽ‡',0),(285260,7924,'pt','Taxas de serviÃ§o do trabalho',0),(285261,7924,'ru','Ð¢Ð°Ñ€Ð¸Ñ„Ñ‹ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð¸ Ñ‚Ñ€ÑƒÐ´Ð°',0),(285262,7924,'es','Servicio Tasas de Labor',0),(285263,7924,'de','Service-Labor-Preise',0),(285264,7924,'en','Service Labor Rates',0),(285265,7925,'is','',0),(285266,7925,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø¯Ù…Ø§Øª ',0),(285267,7925,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø¯Ù…Ø§Øª ',0),(285268,7925,'tr','Hizmet kurulumu',0),(285269,7925,'pl','Ustawienia usÅ‚ugi',0),(285270,7925,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(285271,7925,'ur','Ø®Ø¯Ù…Ø§Øª Ø³ÛŒÙ¹ Ø§Ù¾',0),(285272,7925,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÑÐµÑ€Ð²Ð¸ÑÐ°',0),(285273,7925,'vi','Setup Dá»‹ch vá»¥',0),(285274,7925,'af','Diens Opstelling',0),(285275,7925,'ro','Setari service',0),(285276,7925,'et','Hoolduse seadistamine',0),(285277,7925,'si','Servisov',0),(285278,7925,'ba','Setup Layanan',0),(285279,7925,'nl','Service Setup',0),(285280,7925,'fi','Palvelun asennus',0),(285281,7925,'no','Installasjonsprogrammet for service',0),(285282,7925,'da','Installationsprogrammet til service',0),(285283,7925,'ko','ì„œë¹„ìŠ¤ ì„¤ì¹˜',0),(285284,7925,'he','×”×’×“×¨×ª ×©×¨×•×ª',0),(285285,7925,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(285286,7925,'zh','æœåŠ¡è®¾ç½®\r\n',0),(285287,7925,'sv','Installationsprogram fÃ¶r',0),(285288,7925,'it','Servizio installazione',0),(285289,7925,'tl','',0),(285290,7925,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(285291,7925,'hi','à¤¸à¥‡à¤µà¤¾ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(285292,7925,'ms','Perkhidmatan persediaan',0),(285293,7925,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø®Ø¯Ù…Ø©',0),(285294,7925,'fr','D\'installation du service',0),(285295,7925,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(285296,7925,'pt','ConfiguraÃ§Ã£o de serviÃ§o',0),(285297,7925,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(285298,7925,'es','Servicio ConfiguraciÃ³n',0),(285299,7925,'de','Service-Setup',0),(285300,7925,'en','Service Setup',0),(285301,7926,'is','',0),(285302,7926,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø´Ø±Ø§ÙŠØ· Ø®Ø¯Ù…Ø§Øª ',0),(285303,7926,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø´Ø±Ø§ÙŠØ· Ø®Ø¯Ù…Ø§Øª ',0),(285304,7926,'tr','Hizmet durumu seÃ§enekleri',0),(285305,7926,'pl','Opcje stanu usÅ‚ugi',0),(285306,7926,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ Ð½Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(285307,7926,'ur','Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ø®Ø¯Ù…Øª Ú©ÛŒ Ø­Ø§Ù„Øª',0),(285308,7926,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° ÑÐµÑ€Ð²Ð¸ÑÐ°',0),(285309,7926,'vi','Lá»±a chá»n tÃ¬nh tráº¡ng dá»‹ch vá»¥',0),(285310,7926,'af','Diens Status Opsies',0),(285311,7926,'ro','OpÅ£iuni pentru starea service',0),(285312,7926,'et','Teenuse oleku Valikud',0),(285313,7926,'si','MoÅ¾nosti stanja servisnega',0),(285314,7926,'ba','Pilihan Status Layanan',0),(285315,7926,'nl','Status serviceopties',0),(285316,7926,'fi','Tilan vaihtoehdosta',0),(285317,7926,'no','Alternativer for service',0),(285318,7926,'da','Service statusindstillinger',0),(285319,7926,'ko','ì„œë¹„ìŠ¤ ìƒíƒœ ì˜µì…˜',0),(285320,7926,'he','××¤×©×¨×•×™×•×ª ×ž×¦×‘ ×©×™×¨×•×ª',0),(285321,7926,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚',0),(285322,7926,'zh','æœåŠ¡çŠ¶æ€é€‰é¡¹\r\n',0),(285323,7926,'sv','Statusalternativen fÃ¶r',0),(285324,7926,'it','Opzioni di stato di servizio',0),(285325,7926,'tl','',0),(285326,7926,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3606;&#3634;&#3609;&#3632;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(285327,7926,'hi','à¤¸à¥‡à¤µà¤¾ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(285328,7926,'ms','Pilihan Status Perkhidmatan',0),(285329,7926,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ù…Ø±ÙƒØ² Ø§Ù„Ø®Ø¯Ù…Ø©',0),(285330,7926,'fr','Options d\'Ã©tat de service',0),(285331,7926,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã®çŠ¶æ…‹ã®ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(285332,7926,'pt','OpÃ§Ãµes de Status do serviÃ§o',0),(285333,7926,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ñ ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(285334,7926,'es','Opciones de Status de Sericio',0),(285335,7926,'de','Service-Status-Optionen',0),(285336,7926,'en','Service Status Options',0),(285337,7927,'is','',0),(285338,7927,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(285339,7927,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(285340,7927,'tr','Servis sipariÅŸleri kurulumu',0),(285341,7927,'pl','Ustawienia dla zleceÅ„ serwisowych',0),(285342,7927,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(285343,7927,'ur','Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ø§Ù¾',0),(285344,7927,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(285345,7927,'vi','Setup cho ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(285346,7927,'af','Opstelling Vir Dienste Bestellings',0),(285347,7927,'ro','Setup pentru comenzi de Service',0),(285348,7927,'et','Hooldustellimuste seadistamine',0),(285349,7927,'si','Namestitveni program za servisne naloge',0),(285350,7927,'ba','Setup untuk layanan pesanan',0),(285351,7927,'nl','Setup voor serviceorders',0),(285352,7927,'fi','Asennusohjelma huoltotilauksille',0),(285353,7927,'no','Oppsett For serviceordrer',0),(285354,7927,'da','OpsÃ¦tning For serviceordrer',0),(285355,7927,'ko','ì„œë¹„ìŠ¤ ì˜¤ë”ì— ëŒ€ í•œ ì„¤ì •',0),(285356,7927,'he','×›×™×•×•× ×•×Ÿ ×¢×‘×•×¨ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(285357,7927,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(285358,7927,'zh','å®‰è£…æœåŠ¡è®¢å•\r\n',0),(285359,7927,'sv','Installationsprogrammet fÃ¶r serviceorder',0),(285360,7927,'it','Installazione per gli ordini di servizio',0),(285361,7927,'tl','',0),(285362,7927,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(285363,7927,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(285364,7927,'ms','Persediaan untuk Tempahan Perkhidmatan',0),(285365,7927,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(285366,7927,'fr','Programme d\'installation pour les commandes de Service',0),(285367,7927,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(285368,7927,'pt','InstalaÃ§Ã£o para ordens de serviÃ§o',0),(285369,7927,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð´Ð»Ñ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(285370,7927,'es','ConfiguraciÃ³n para Ordenes de Servicio',0),(285371,7927,'de','Setup fÃ¼r ServiceauftrÃ¤ge',0),(285372,7927,'en','Setup For Service Orders',0),(285373,7928,'is','',0),(285374,7928,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(285375,7928,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ',0),(285376,7928,'tr','Servis sipariÅŸleri iÃ§in kurulum iÅŸlevleri',0),(285377,7928,'pl','Ustawienie funkcji dla zleceÅ„ serwisowych',0),(285378,7928,'bg','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð·Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(285379,7928,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ø§ÙØ¹Ø§Ù„ Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’',0),(285380,7928,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(285381,7928,'vi','Setup chá»©c nÄƒng cho ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(285382,7928,'af','Opstellingsfunksies Vir Dienste Bestelling',0),(285383,7928,'ro','Functii de configurare pentru comenzi de Service',0),(285384,7928,'et','Hooldustellimuste seadistustoimingute',0),(285385,7928,'si','Nastavitev funkcije za servisne naloge',0),(285386,7928,'ba','Setup fungsi untuk layanan pesanan',0),(285387,7928,'nl','Setup functies voor serviceorders',0),(285388,7928,'fi','Asetustoimintoja huoltotilauksille',0),(285389,7928,'no','Oppsettfunksjoner For serviceordrer',0),(285390,7928,'da','OpsÃ¦tningsfunktioner For serviceordrer',0),(285391,7928,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ì„¤ì • ê¸°ëŠ¥',0),(285392,7928,'he','×”×’×“×¨×ª ×¤×•× ×§×¦×™×•×ª ×¢×‘×•×¨ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(285393,7928,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(285394,7928,'zh','æœåŠ¡è®¢å•è®¾å®šåŠŸèƒ½\r\n',0),(285395,7928,'sv','Konfigurera funktioner fÃ¶r serviceorder',0),(285396,7928,'it','Funzioni di installazione per gli ordini di servizio',0),(285397,7928,'tl','',0),(285398,7928,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3627;&#3609;&#3657;&#3634;&#3607;&#3637;&#3656;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(285399,7928,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¤¾à¤°à¥à¤¯ à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤',0),(285400,7928,'ms','Fungsi persediaan bagi pesanan Perkhidmatan',0),(285401,7928,'ar','Ù…Ù‡Ø§Ù… Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(285402,7928,'fr','Fonctions de configuration pour les commandes de Service',0),(285403,7928,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—æ©Ÿèƒ½',0),(285404,7928,'pt','FunÃ§Ãµes de configuraÃ§Ã£o para ordens de serviÃ§o',0),(285405,7928,'ru','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð´Ð»Ñ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(285406,7928,'es','Configurar Funciones para Ordenes de Servicio',0),(285407,7928,'de','Setup-Funktionen fÃ¼r ServiceauftrÃ¤ge',0),(285408,7928,'en','Setup Functions For Service Orders',0),(285409,7929,'is','',0),(285410,7929,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(285411,7929,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ',0),(285412,7929,'tr','KurÅŸun izleme kurulumu',0),(285413,7929,'pl','Ustawienie Å›ledzenia oÅ‚owiu',0),(285414,7929,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¾Ð»Ð¾Ð²Ð¾ Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(285415,7929,'ur','Ù„ÛŒÚˆ Ú©ÛŒ Ø³Ø±Ø§Øº Ú©Ø§Ø±ÛŒ Ø³ÛŒÙ¹ Ø§Ù¾',0),(285416,7929,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐ° Ñ†Ð¸ÐºÐ»ÑƒÑÐ° Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ',0),(285417,7929,'vi','Setup DÃ² tÃ¬m',0),(285418,7929,'af','Opstel lei dop',0),(285419,7929,'ro','Configurare urmÄƒrire plumb',0),(285420,7929,'et','Setup Plii jÃ¤lgimine',0),(285421,7929,'si','Setup Svinec sledenje',0),(285422,7929,'ba','Setup pelacakan Lead',0),(285423,7929,'nl','Setup Lead Tracking',0),(285424,7929,'fi','Setup Lead seuranta',0),(285425,7929,'no','Sette fÃ¸re sporing',0),(285426,7929,'da','Setup bly Tracking',0),(285427,7929,'ko','ë¦¬ë“œ ì¶”ì  ì„¤ì •',0),(285428,7929,'he','×”×’×“×¨×ª ×ž×¢×§×‘ ×¢×•×¤×¨×ª',0),(285429,7929,'el','Î£Ï„Î®ÏƒÎµÏ„Îµ Î¼Î¿Î»ÏÎ²Î´Î¿Ï… Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚',0),(285430,7929,'zh','å®‰è£…é“…è·Ÿè¸ª\r\n',0),(285431,7929,'sv','Setup leda spÃ¥rning',0),(285432,7929,'it','Configurare il rilevamento di piombo',0),(285433,7929,'tl','',0),(285434,7929,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3609;&#3635;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(285435,7929,'hi','à¤²à¥€à¤¡ à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(285436,7929,'ms','Sediakan Lead Tracking',0),(285437,7929,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ ØªØªØ¨Ø¹ Ø§Ù„Ø±ØµØ§Øµ',0),(285438,7929,'fr','Installation suivi de plomb',0),(285439,7929,'jp','é‰›ã®é€²æ—ç®¡ç†ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(285440,7929,'pt','ConfiguraÃ§Ã£o de rastreamento de chumbo',0),(285441,7929,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð²ÐµÐ´ÑƒÑ‰Ð¸Ð¹ ÑÐ»ÐµÐ¶ÐµÐ½Ð¸Ñ',0),(285442,7929,'es','Configurar Rastreo de Clientes Potenciales',0),(285443,7929,'de','Lead Tracking einrichten',0),(285444,7929,'en','Setup Lead Tracking',0),(285445,7930,'is','',0),(285446,7930,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ ',0),(285447,7930,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ ',0),(285448,7930,'tr','Kurulum - fatura',0),(285449,7930,'pl','Ustawienie - rozliczeniowe',0),(285450,7930,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(285451,7930,'ur','-Ø³ÛŒÙ¹ Ø§Ù¾ Ø­Ø³Ø§Ø¨ Ú©Ø±Ù†Ø§',0),(285452,7930,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° - Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(285453,7930,'vi','Setup Pháº£i Thu',0),(285454,7930,'af','Opstel - fakturering',0),(285455,7930,'ro','Configurare - facturare',0),(285456,7930,'et','Setup - arved',0),(285457,7930,'si','Setup - zaraÄunavanje',0),(285458,7930,'ba','Setup - penagihan',0),(285459,7930,'nl','Setup - facturering',0),(285460,7930,'fi','Setup - laskutus',0),(285461,7930,'no','Oppsett - fakturering',0),(285462,7930,'da','Setup - fakturering',0),(285463,7930,'ko','ì„¤ì¹˜-ê²°ì œ',0),(285464,7930,'he','×”×ª×§× ×” - ×—×™×•×‘',0),(285465,7930,'el','ÎŸÏÎ³Î¬Î½Ï‰ÏƒÎ· - Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(285466,7930,'zh','è®¾ç½®åº”æ”¶æ¬¾\r\n',0),(285467,7930,'sv','Setup - fakturering',0),(285468,7930,'it','Installazione - fatturazione',0),(285469,7930,'tl','',0),(285470,7930,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(285471,7930,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - à¤¬à¤¿à¤²à¤¿à¤‚à¤—',0),(285472,7930,'ms','Persediaan - bil',0),(285473,7930,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(285474,7930,'fr','Installation - facturation',0),(285475,7930,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— - è«‹æ±‚',0),(285476,7930,'pt','Setup - faturamento',0),(285477,7930,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° - Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³',0),(285478,7930,'es','Configurar Cuentas por Cobrar',0),(285479,7930,'de','Setup - Abrechnung',0),(285480,7930,'en','Setup - Billing',0),(285481,7931,'is','',0),(285482,7931,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø¯Ù…Ø§Øª ',0),(285483,7931,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø¯Ù…Ø§Øª ',0),(285484,7931,'tr','Kurulum - emir',0),(285485,7931,'pl','Instalator - zamÃ³wienia',0),(285486,7931,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(285487,7931,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ - Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(285488,7931,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(285489,7931,'vi','Setup dá»‹ch vá»¥',0),(285490,7931,'af','Dienste Opstel',0),(285491,7931,'ro','Configurare - comenzi',0),(285492,7931,'et','Teenuste seaded',0),(285493,7931,'si','Priprava - naroÄil',0),(285494,7931,'ba','Pengaturan - pesanan',0),(285495,7931,'nl','Setup - Orders',0),(285496,7931,'fi','Setup - tilaukset',0),(285497,7931,'no','Oppsett - bestillinger',0),(285498,7931,'da','Setup - ordrer',0),(285499,7931,'ko','ì„¤ì •-ì£¼ë¬¸',0),(285500,7931,'he','×”×’×“×¨ ×©×¨×•×ª',0),(285501,7931,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· - Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(285502,7931,'zh','è®¾ç½®æœåŠ¡\r\n',0),(285503,7931,'sv','InstÃ¤llningar - order',0),(285504,7931,'it','Installazione - ordini',0),(285505,7931,'tl','',0),(285506,7931,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(285507,7931,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - à¤†à¤¦à¥‡à¤¶',0),(285508,7931,'ms','Persediaan - pesanan',0),(285509,7931,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø®Ø¯Ù…Ø§Øª',0),(285510,7931,'fr','Installation - commandes',0),(285511,7931,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— - æ³¨æ–‡',0),(285512,7931,'pt','InstalaÃ§Ã£o - ordens',0),(285513,7931,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° - Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(285514,7931,'es','Configurar Servicio',0),(285515,7931,'de','Setup - Bestellungen',0),(285516,7931,'en','Setup - Orders',0),(285517,7932,'is','',0),(285518,7932,'dr','(Ø¯ÛŒÙˆÙ† - Ø¹ÙˆØ§Ø±Ø¶) Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§',0),(285519,7932,'pr','Ù…ÙˆØ¹Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª(Ø¨Ø¯Ù‡ÙŠ- Ø¹ÙˆØ§Ø±Ø¶) Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§',0),(285520,7932,'tr','Nedeniyle sevk irsaliyeleri',0),(285521,7932,'pl','PrzesyÅ‚ki ze wzglÄ™du',0),(285522,7932,'bg','ÐŸÑ€Ð°Ñ‚ÐºÐ¸ Ð¿Ð¾Ñ€Ð°Ð´Ð¸',0),(285523,7932,'ur','ØªØ±Ø³ÛŒÙ„ Ú©ÛŒ ÙˆØ¬Û Ø³Û’',0),(285524,7932,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ñ‚ÐµÑ€Ð¼Ð¸Ð½',0),(285525,7932,'vi','Chuyáº¿n hÃ ng Ä‘áº¿n háº¡n',0),(285526,7932,'af','Besendings Verskuldig',0),(285527,7932,'ro','Transporturile din cauza',0),(285528,7932,'et','Saadetiste tÃµttu',0),(285529,7932,'si','PoÅ¡iljke zaradi',0),(285530,7932,'ba','Pengiriman jatuh tempo',0),(285531,7932,'nl','Zendingen verschuldigde',0),(285532,7932,'fi','Siirtojen mÃ¤Ã¤rÃ¤',0),(285533,7932,'no','Forsendelser grunn',0),(285534,7932,'da','Forsendelser grund',0),(285535,7932,'ko','ì¸í•´ ì¶œí•˜ ëŸ‰',0),(285536,7932,'he','×ž×©×œ×•×—×™× ×‘×©×œ',0),(285537,7932,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ Î»ÏŒÎ³Ï‰',0),(285538,7932,'zh','å‘è´§æˆªæ­¢\r\n',0),(285539,7932,'sv','Transporter pÃ¥ grund',0),(285540,7932,'it','Spedizioni dovute',0),(285541,7932,'tl','',0),(285542,7932,'th','&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(285543,7932,'hi','à¤•à¤¾à¤°à¤£ à¤²à¤¦à¤¾à¤¨',0),(285544,7932,'ms','Penghantaran disebabkan oleh',0),(285545,7932,'ar','Ø§Ù„Ø´Ø­Ù†Ø§Øª Ø§Ù„ÙˆØ§Ø¬Ø¨Ø©',0),(285546,7932,'fr','ExpÃ©ditions Due',0),(285547,7932,'jp','å‡ºè·äºˆå®š',0),(285548,7932,'pt','Carregamentos devido',0),(285549,7932,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¸Ð·-Ð·Ð°',0),(285550,7932,'es','EnvÃ­os Vencidos',0),(285551,7932,'de','Sendungen aufgrund',0),(285552,7932,'en','Shipments Due',0),(285553,7933,'is','',0),(285554,7933,'dr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ù…Ø§ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡',0),(285555,7933,'pr','Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ù…Ø§ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡',0),(285556,7933,'tr','DeÄŸil ama fatura sevk',0),(285557,7933,'pl','WysÅ‚ane ale nie rozliczane',0),(285558,7933,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸ Ð½Ð¾ Ð½Ðµ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸',0),(285559,7933,'ur','Ù„ÛŒÚ©Ù† Ù†Û Ø¨Ø§Ù„Ù„Ø§Ø¯ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(285560,7933,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð° Ð°Ð»Ð¸ Ð½Ðµ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ð° Ñ‚ÐµÑ€ÐµÑ‚Ð¸Ñ›Ðµ',0),(285561,7933,'vi','Ä‘Ã£ chuyá»ƒn nhÆ°ng chÆ°a ra hÃ³a Ä‘Æ¡n',0),(285562,7933,'af','Versend Maar Nie Gefaktureer',0),(285563,7933,'ro','Expediate dar nu facturate',0),(285564,7933,'et','LÃ¤hetatud aga mitte maksustatud minutite',0),(285565,7933,'si','Dobavljena, vendar ne bremenjene',0),(285566,7933,'ba','Dikirim tetapi tidak ditagih',0),(285567,7933,'nl','Verzonden maar niet gefactureerd',0),(285568,7933,'fi','LÃ¤hetetty mutta ei laskutettu',0),(285569,7933,'no','Sendt men ikke fakturerte',0),(285570,7933,'da','Afsendt men ikke faktureret',0),(285571,7933,'ko','í•˜ì§€ë§Œ í•˜ì§€ ì²­êµ¬ ë°œì†¡',0),(285572,7933,'he','× ×©×œ×— ××š ×œ× ×—×•×™×‘',0),(285573,7933,'el','Î‘Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯ Î±Î»Î»Î¬ Î´ÎµÎ½ Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î¿',0),(285574,7933,'zh','å‘è¿ä½†ä¸å…¥è´¦\r\n',0),(285575,7933,'sv','Levereras men inte fakturerade',0),(285576,7933,'it','Spedito ma non fatturate',0),(285577,7933,'tl','',0),(285578,7933,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;&#3649;&#3605;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(285579,7933,'hi','à¤²à¥‡à¤•à¤¿à¤¨ à¤¨à¤¹à¥€à¤‚ à¤–à¤¼à¤°à¥€à¤¦ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(285580,7933,'ms','Dihantar tetapi tidak dibilkan sebanyak',0),(285581,7933,'ar','Ø´Ø­Ù†Øª Ù„ÙƒÙ† Ù„Ø§ Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(285582,7933,'fr','ExpÃ©diÃ©e mais pas facturÃ©s',0),(285583,7933,'jp','ãªã„è«‹æ±‚ã€å‡ºè·',0),(285584,7933,'pt','Enviados mas nÃ£o faturado',0),(285585,7933,'ru','ÐžÑ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ñ‹, Ð½Ð¾ Ð½Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(285586,7933,'es','Enviado pero No Facturado',0),(285587,7933,'de','Geliefert aber nicht abgerechnet',0),(285588,7933,'en','Shipped But Not Billed',0),(285589,7934,'is','',0),(285590,7934,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø­Ù…Ù„',0),(285591,7934,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø­Ù…Ù„',0),(285592,7934,'tr','Nakliye Kur',0),(285593,7934,'pl','Koszty instalacji',0),(285594,7934,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(285595,7934,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ø´Ù¾Ù†Ú¯',0),(285596,7934,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(285597,7934,'vi','Setup váº­n chuyá»ƒn ',0),(285598,7934,'af','Versendingsopstelling',0),(285599,7934,'ro','Setup de transport maritim',0),(285600,7934,'et','Laevanduse seadistamine',0),(285601,7934,'si','Dostava Setup',0),(285602,7934,'ba','Pengiriman Setup',0),(285603,7934,'nl','Verzending Setup',0),(285604,7934,'fi','Toimituksen mÃ¤Ã¤ritys',0),(285605,7934,'no','Fraktoppsett',0),(285606,7934,'da','Forsendelse Setup',0),(285607,7934,'ko','ë°°ì†¡ ì„¤ì¹˜',0),(285608,7934,'he','×ž×©×œ×•×— ×”×”×ª×§× ×”',0),(285609,7934,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î± ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(285610,7934,'zh','é€è´§å®‰è£…\r\n',0),(285611,7934,'sv','Frakt Setup',0),(285612,7934,'it','Installazione di spedizione',0),(285613,7934,'tl','',0),(285614,7934,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(285615,7934,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(285616,7934,'ms','Penghantaran persediaan',0),(285617,7934,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø´Ø­Ù†',0),(285618,7934,'fr','Le programme d\'installation d\'expÃ©dition',0),(285619,7934,'jp','é…å¸ƒã®è¨­å®š',0),(285620,7934,'pt','ConfiguraÃ§Ã£o de frete',0),(285621,7934,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ°',0),(285622,7934,'es','Configurar EnvÃ­os',0),(285623,7934,'de','Versand-Setup',0),(285624,7934,'en','Shipping Setup',0),(285625,7935,'is','',0),(285626,7935,'dr','Ø§Ø±Ø³Ø§Ù„  Ø³ÙØ§Ø±Ø´ ',0),(285627,7935,'pr','Ø§Ø±Ø³Ø§Ù„  Ø³ÙØ§Ø±Ø´ ',0),(285628,7935,'tr','Gemi sipariÅŸi',0),(285629,7935,'pl','Statek zamÃ³wienia',0),(285630,7935,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(285631,7935,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(285632,7935,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(285633,7935,'vi','ÄÆ¡n hÃ ng chuyá»ƒn',0),(285634,7935,'af','Versend Bestelling',0),(285635,7935,'ro','NavÄƒ de comandÄƒ',0),(285636,7935,'et','Tarni tellimus',0),(285637,7935,'si','Dobave naloga',0),(285638,7935,'ba','Rangka kapal',0),(285639,7935,'nl','Bestelling',0),(285640,7935,'fi','Aluksen tilaus',0),(285641,7935,'no','Leverer ordre',0),(285642,7935,'da','Skibet rÃ¦kkefÃ¸lge',0),(285643,7935,'ko','ë°° ìˆœì„œ',0),(285644,7935,'he','×¡×“×¨ ××ª ×”×¡×¤×™× ×”',0),(285645,7935,'el','Î”Î¹Î±Ï„Î±Î³Î® ÏƒÎºÎ±Ï†ÏŽÎ½',0),(285646,7935,'zh','è¿é€è®¢å•\r\n',0),(285647,7935,'sv','Levererar Order',0),(285648,7935,'it','Ordine di nave',0),(285649,7935,'tl','',0),(285650,7935,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(285651,7935,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(285652,7935,'ms','Menghantar pesanan',0),(285653,7935,'ar','Ø£Ù…Ø± Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(285654,7935,'fr','Commande livraison',0),(285655,7935,'jp','å•†å“ã‚’ç™ºé€ã—ã¾ã™ã€‚',0),(285656,7935,'pt','Enviar pedido',0),(285657,7935,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·',0),(285658,7935,'es','Orden de EnvÃ­o',0),(285659,7935,'de','Bestellung',0),(285660,7935,'en','Ship Order',0),(285661,7936,'is','',0),(285662,7936,'dr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§ØªÙŠ',0),(285663,7936,'pr','Ù…Ø¹Ø§ÙÙŠØª Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§ØªÙŠ',0),(285664,7936,'tr','Vergi muafiyeti',0),(285665,7936,'pl','Zwolnienia podatkowe',0),(285666,7936,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ñ',0),(285667,7936,'ur','Ù¹ÛŒÚ©Ø³ Ø³Û’ Ø§Ø³ØªØ«Ù†Ø§Ø¡ ÙØ±Ø§ÛÙ…',0),(285668,7936,'sr','Ð£Ð²Ð¾Ð´Ð¸ Ð¸Ð·ÑƒÐ·ÐµÑ›Ðµ Ð¾Ð´ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(285669,7936,'vi','Miá»…n thuáº¿',0),(285670,7936,'af','Belasting Vrystellings',0),(285671,7936,'ro','Scutiri de taxe',0),(285672,7936,'et','Maksuvabastused',0),(285673,7936,'si','Oprostitve davka',0),(285674,7936,'ba','Pembebasan pajak',0),(285675,7936,'nl','Belastingvrijstellingen',0),(285676,7936,'fi','Verovapautukset',0),(285677,7936,'no','Skattefritak',0),(285678,7936,'da','Skattefritagelser',0),(285679,7936,'ko','ì„¸ê¸ˆ ë©´ì œ',0),(285680,7936,'he','×ž×ž×¡',0),(285681,7936,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ­Ï‚ Î±Ï€Î±Î»Î»Î±Î³Î­Ï‚',0),(285682,7936,'zh','å…ç¨Ž\r\n',0),(285683,7936,'sv','Skattebefrielser',0),(285684,7936,'it','Esenzioni fiscali',0),(285685,7936,'tl','',0),(285686,7936,'th','&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;',0),(285687,7936,'hi','à¤•à¤°à¥‹à¤‚ à¤®à¥‡à¤‚ à¤›à¥‚à¤Ÿ',0),(285688,7936,'ms','Pengecualian cukai',0),(285689,7936,'ar','Ø§Ù„Ø¥Ø¹ÙØ§Ø¡Ø§Øª Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©',0),(285690,7936,'fr','ExonÃ©rations fiscales',0),(285691,7936,'jp','ç¨Žã®å…é™¤',0),(285692,7936,'pt','IsenÃ§Ãµes fiscais',0),(285693,7936,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ ÐžÑ‚ ÐÐ°Ð»Ð¾Ð³Ð°',0),(285694,7936,'es','Exenciones de Impuestos',0),(285695,7936,'de','Steuerbefreiungen',0),(285696,7936,'en','Tax Exemptions',0),(285697,7937,'is','',0),(285698,7937,'dr','Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(285699,7937,'pr','Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(285700,7937,'tr','Vergi tablolarÄ±',0),(285701,7937,'pl','Tabele podatkowe',0),(285702,7937,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð¸ Ð·Ð° Ð´Ð°Ð½ÑŠÐº',0),(285703,7937,'ur','Ù¹ÛŒÚ©Ø³ Ø¬Ø¯Ø§ÙˆÙ„',0),(285704,7937,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð°',0),(285705,7937,'vi','Báº£ng thuáº¿',0),(285706,7937,'af','Belastingtabelle',0),(285707,7937,'ro','Mese de impozit',0),(285708,7937,'et','Tulumaksu tabelid',0),(285709,7937,'si','Tabel davka',0),(285710,7937,'ba','Tabel pajak',0),(285711,7937,'nl','Fiscale tabellen',0),(285712,7937,'fi','Verotaulut',0),(285713,7937,'no','Skattetabeller',0),(285714,7937,'da','Tax-tabeller',0),(285715,7937,'ko','ì„¸ê¸ˆ í…Œì´ë¸”',0),(285716,7937,'he','×˜×‘×œ××•×ª ×ž×¡',0),(285717,7937,'el','Î Î¯Î½Î±ÎºÎµÏ‚ Ï†ÏŒÏÎ¿Ï…',0),(285718,7937,'zh','ç¨Žè¡¨\r\n',0),(285719,7937,'sv','Skatt tabeller',0),(285720,7937,'it','Tabelle fiscali',0),(285721,7937,'tl','',0),(285722,7937,'th','&#3605;&#3634;&#3619;&#3634;&#3591;&#3616;&#3634;&#3625;&#3637;',0),(285723,7937,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤Ÿà¥‡à¤¬à¤²à¥à¤¸',0),(285724,7937,'ms','Jadual cukai',0),(285725,7937,'ar','Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(285726,7937,'fr','Tables d\'impÃ´t',0),(285727,7937,'jp','ç¨ŽçŽ‡è¡¨',0),(285728,7937,'pt','Tabelas de impostos',0),(285729,7937,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹ ÐÐ°Ð»Ð¾Ð³Ð¾Ð²',0),(285730,7937,'es','Tablas de Impuestos',0),(285731,7937,'de','Steuertabellen',0),(285732,7937,'en','Tax Tables',0),(285733,7938,'is','',0),(285734,7938,'dr','ØªØ±Ø§Ø² Ù†Ø´Ø¯Ù‡ ',0),(285735,7938,'pr','ØªØ±Ø§Ø² Ù†Ø´Ø¯Ù‡ ',0),(285736,7938,'tr','Dengesiz gÃ¼nlÃ¼kleri',0),(285737,7938,'pl','Niesymetryczne czasopism',0),(285738,7938,'bg','ÐÐµÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð°Ð½Ð¸ Ð´Ð½ÐµÐ²Ð½Ð¸Ñ†Ð¸',0),(285739,7938,'ur','Unbalanced Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û’',0),(285740,7938,'sr','ÐÐµÑÐ°Ð»Ð´Ð¸Ñ€Ð°Ð½Ðµ Ñ‡Ð°ÑÐ¾Ð¿Ð¸ÑÐ¸Ð¼Ð°',0),(285741,7938,'vi','KhÃ´ng cÃ¢n Ä‘á»‘i',0),(285742,7938,'af','Ongebalanseerd',0),(285743,7938,'ro','Jurnale dezechilibrat',0),(285744,7938,'et','Tasakaalustamata tÃ¶Ã¶lehed',0),(285745,7938,'si','NeuravnoteÅ¾eno revijah',0),(285746,7938,'ba','Jurnal tidak seimbang',0),(285747,7938,'nl','Onevenwichtig tijdschriften',0),(285748,7938,'fi','EpÃ¤tasapainoinen kirjauskansiot',0),(285749,7938,'no','Ubalansert journaler',0),(285750,7938,'da','Ubalanceret tidsskrifter',0),(285751,7938,'ko','ë¶ˆê· í˜•ëœ ì €ë„',0),(285752,7938,'he','×›×ª×‘×™ ×¢×ª ×œ× ×ž××•×–× ×™×',0),(285753,7938,'el','ÎœÎ· Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î·Î¼Î­Î½Î· Ï€ÎµÏÎ¹Î¿Î´Î¹ÎºÎ¬',0),(285754,7938,'zh','æœªç»“ç®—çš„\r\n',0),(285755,7938,'sv','Obalanserad tidskrifter',0),(285756,7938,'it','Riviste sbilanciati',0),(285757,7938,'tl','',0),(285758,7938,'th','&#3652;&#3617;&#3656;&#3621;&#3591;&#3605;&#3633;&#3623;',0),(285759,7938,'hi','à¤…à¤¸à¤‚à¤¤à¥à¤²à¤¿à¤¤ à¤ªà¤¤à¥à¤°à¤¿à¤•à¤¾à¤“à¤‚',0),(285760,7938,'ms','Jurnal-Jurnal tidak',0),(285761,7938,'ar','Ø§Ù„Ù‚ÙŠÙˆØ¯ Ø§Ù„ØºÙŠØ± Ù…ØªÙˆØ§Ø²Ù†Ø©',0),(285762,7938,'fr','Revues dÃ©sÃ©quilibrÃ©es',0),(285763,7938,'jp','ã‚¢ãƒ³ãƒãƒ©ãƒ³ã‚¹ ã‚¸ãƒ£ãƒ¼ãƒŠãƒ«',0),(285764,7938,'pt','Revistas desequilibradas',0),(285765,7938,'ru','ÐÐµÑÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð¶ÑƒÑ€Ð½Ð°Ð»Ñ‹',0),(285766,7938,'es','No Balanceado',0),(285767,7938,'de','Unausgeglichene Zeitschriften',0),(285768,7938,'en','Unbalanced Journals',0),(285769,7939,'is','',0),(285770,7939,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù…ÙˆØ¬ÙˆØ¯ ',0),(285771,7939,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù…ÙˆØ¬ÙˆØ¯ ',0),(285772,7939,'tr','GÃ¼ncelleÅŸtirme varolan bir BorÃ§lar Bill',0),(285773,7939,'pl','Aktualizacja istniejÄ…cej listy zobowiÄ…zaÅ„',0),(285774,7939,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(285775,7939,'ur','Ø§ÛŒÚ© Ù…ÙˆØ¬ÙˆØ¯Û Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø¨Ù„ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(285776,7939,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ Ð·Ð°ÐºÐ¾Ð½ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(285777,7939,'vi','Cáº­p Nháº­t 1 HÃ³a ÄÆ¡n Pháº£i Tráº£ Hiá»‡n Táº¡i',0),(285778,7939,'af','Opdatering van \'n Bestaande Betaalbare Rekening',0),(285779,7939,'ro','Update o facturÄƒ de datorii existente',0),(285780,7939,'et','Uuenda olemasolevaid vÃµlad Bill',0),(285781,7939,'si','Posodobitev obstojeÄih obveznosti zakona',0),(285782,7939,'ba','Memperbarui tagihan hutang yang ada',0),(285783,7939,'nl','Bijwerken van een bestaande schulden Bill',0),(285784,7939,'fi','PÃ¤ivitÃ¤ nykyiset velat Bill',0),(285785,7939,'no','Oppdatere en eksisterende gjeld Bill',0),(285786,7939,'da','Opdatere en eksisterende gÃ¦ld Bill',0),(285787,7939,'ko','ì—…ë°ì´íŠ¸ëŠ” ê¸°ì¡´ ì±„ë¬´ ë²•ì•ˆ',0),(285788,7939,'he','×¢×“×›×•×Ÿ ×—×©×‘×•×Ÿ ×–×›××™× ×”×§×™×™×',0),(285789,7939,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î­Î½Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(285790,7939,'zh','æ›´æ–°çŽ°æœ‰çš„åº”ä»˜å¸å•\r\n',0),(285791,7939,'sv','Uppdatera en befintlig LeverantÃ¶rsskulder Bill',0),(285792,7939,'it','Aggiornare un conto debiti esistenti',0),(285793,7939,'tl','',0),(285794,7939,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3636;&#3621;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(285795,7939,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤à¤• à¤®à¥Œà¤œà¥‚à¤¦à¤¾ Payables à¤¬à¤¿à¤²',0),(285796,7939,'ms','Kemaskini Terakhir bil pemiutang',0),(285797,7939,'ar','ØªØ­Ø¯ÙŠØ« ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(285798,7939,'fr','Mise Ã  jour un projet de loi existante des comptes fournisseurs',0),(285799,7939,'jp','æ—¢å­˜ã®å‚µå‹™æ³•æ¡ˆã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(285800,7939,'pt','Atualizar uma conta existente do contas a pagar',0),(285801,7939,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ ÑÑ‡ÐµÑ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(285802,7939,'es','Actualizar una Factura de Proveedores Existente',0),(285803,7939,'de','Update einer bestehenden Verbindlichkeiten StÃ¼ckliste',0),(285804,7939,'en','Update An Existing Payables Bill',0),(285805,7940,'is','',0),(285806,7940,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(285807,7940,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(285808,7940,'tr','GÃ¼ncelleÅŸtirme banka MevduatÄ±',0),(285809,7940,'pl','Lokaty bankowe aktualizacji',0),(285810,7940,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(285811,7940,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø¨ÛŒÙ†Ú© Ú©Û’ Ø°Ø®Ø§Ø¦Ø±',0),(285812,7940,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑˆÑ‚ÐµÐ´Ð½Ð¸Ñ… ÑƒÐ»Ð¾Ð³Ð°',0),(285813,7940,'vi','Cáº­p Nháº­t 1 TK Äáº·t Cá»c NgÃ¢n hÃ ng',0),(285814,7940,'af','Opdateer Bank Deposito\'s',0),(285815,7940,'ro','Depozite bancare de actualizare',0),(285816,7940,'et','Update pangadeposiidid',0),(285817,7940,'si','Posodobitev banÄnih vlog',0),(285818,7940,'ba','Deposito update Bank',0),(285819,7940,'nl','Update bancaire deposito \'s',0),(285820,7940,'fi','PÃ¤ivitys pankkiin',0),(285821,7940,'no','Oppdateringen bankinnskudd',0),(285822,7940,'da','Opdatering bankindskud',0),(285823,7940,'ko','ì—…ë°ì´íŠ¸ ì€í–‰ ì˜ˆê¸ˆ',0),(285824,7940,'he','×¢×“×›×Ÿ ×¤×§×“×•× ×•×ª ×‘× ×§',0),(285825,7940,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ­Ï‚ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚',0),(285826,7940,'zh','æ›´æ–°é“¶è¡Œå­˜æ¬¾\r\n',0),(285827,7940,'sv','Uppdatering bankinlÃ¥ning',0),(285828,7940,'it','Depositi bancari di aggiornamento',0),(285829,7940,'tl','',0),(285830,7940,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(285831,7940,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾',0),(285832,7940,'ms','Deposit Bank Kemaskini',0),(285833,7940,'ar','Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ© Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(285834,7940,'fr','DÃ©pÃ´ts bancaires de la mise Ã  jour',0),(285835,7940,'jp','æ›´æ–°éŠ€è¡Œé é‡‘',0),(285836,7940,'pt','DepÃ³sitos bancÃ¡rios de atualizaÃ§Ã£o',0),(285837,7940,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹',0),(285838,7940,'es','Actualizar DepÃ³sitos Bancarios',0),(285839,7940,'de','Update Bankeinlagen',0),(285840,7940,'en','Update Bank Deposits',0),(285841,7941,'is','',0),(285842,7941,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(285843,7941,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(285844,7941,'tr','Ã‡alÄ±ÅŸan bilgilerini gÃ¼ncelleÅŸtir',0),(285845,7941,'pl','Aktualizacja informacji o pracowniku',0),(285846,7941,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ',0),(285847,7941,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(285848,7941,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ð¼Ð°',0),(285849,7941,'vi','Cáº­p nháº­t thÃ´ng tin nhÃ¢n viÃªn',0),(285850,7941,'af','Opdatering van Werknemer Inligting',0),(285851,7941,'ro','ActualizaÅ£i informaÅ£iile de angajat',0),(285852,7941,'et','Uuenda tÃ¶Ã¶taja informatsiooni',0),(285853,7941,'si','Posodobite informacije o zaposlenih',0),(285854,7941,'ba','Memperbarui informasi karyawan',0),(285855,7941,'nl','Werknemer updategegevens',0),(285856,7941,'fi','PÃ¤ivitÃ¤ tyÃ¶ntekijÃ¤tiedot',0),(285857,7941,'no','Informasjon om ansatt',0),(285858,7941,'da','Opdatere medarbejderoplysninger',0),(285859,7941,'ko','ì§ì› ì •ë³´ë¥¼ ì—…ë°ì´íŠ¸',0),(285860,7941,'he','×œ×¢×“×›×Ÿ ××ª ×¤×¨×˜×™ ×”×¢×•×‘×“',0),(285861,7941,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ Î³Î¹Î± Ï„Î¿Î½ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿',0),(285862,7941,'zh','æ›´æ–°å‘˜å·¥ä¿¡æ¯\r\n',0),(285863,7941,'sv','Uppdatera Information om anstÃ¤llda',0),(285864,7941,'it','Aggiornare le informazioni sui dipendenti',0),(285865,7941,'tl','',0),(285866,7941,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(285867,7941,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(285868,7941,'ms','Mengemaskini maklumat pekerja',0),(285869,7941,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ¸Ù',0),(285870,7941,'fr','Mise Ã  jour des renseignements sur les employÃ©s',0),(285871,7941,'jp','å¾“æ¥­å“¡æƒ…å ±ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(285872,7941,'pt','Atualizar informaÃ§Ãµes do funcionÃ¡rio',0),(285873,7941,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ðž Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐµ',0),(285874,7941,'es','Actualizar InformaciÃ³n de Empleados',0),(285875,7941,'de','Update Mitarbeiterinformationen',0),(285876,7941,'en','Update Employee Information',0),(285877,7942,'is','',0),(285878,7942,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…ÙˆØ¬ÙˆØ¯ ',0),(285879,7942,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…ÙˆØ¬ÙˆØ¯ ',0),(285880,7942,'tr','Varolan Ã¶deme planÄ±nÄ± gÃ¼ncelleÅŸtir',0),(285881,7942,'pl','Aktualizacja istniejÄ…cego planu pÅ‚atnoÅ›ci',0),(285882,7942,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð° ÑÑ…ÐµÐ¼Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(285883,7942,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ù¾ÛŒÙ…Ù†Ù¹ Ù¾Ù„Ø§Ù† Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(285884,7942,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ ÐŸÐ»Ð°Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(285885,7942,'vi','Cáº­p nháº­t káº¿ hoáº¡ch thanh toÃ¡n hiá»‡n táº¡i',0),(285886,7942,'af','Opdateer Bestaande Betalingsplan',0),(285887,7942,'ro','Actualizare Plan de platÄƒ existente',0),(285888,7942,'et','Uuenda olemasolevaid maksegraafiku',0),(285889,7942,'si','Posodobite obstojeÄi naÄrt plaÄil',0),(285890,7942,'ba','Memperbarui rencana pembayaran yang ada',0),(285891,7942,'nl','Bijwerken van bestaande betalingsplan',0),(285892,7942,'fi','PÃ¤ivittÃ¤Ã¤ nykyisen maksusuunnitelman',0),(285893,7942,'no','Oppdatere eksisterende betalingsplan',0),(285894,7942,'da','Opdatere eksisterende betalingsplan',0),(285895,7942,'ko','ê¸°ì¡´ ì§€ë¶ˆ ê³„íš ì—…ë°ì´íŠ¸',0),(285896,7942,'he','×¢×“×›×•×Ÿ ×§×™×™×ž×ª ×ª×•×›× ×™×ª ×ª×©×œ×•×ž×™×',0),(285897,7942,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Ï„Î¿ Ï…Ï€Î¬ÏÏ‡Î¿Î½ ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(285898,7942,'zh','æ›´æ–°çŽ°æœ‰æ”¯ä»˜è®¡åˆ’\r\n',0),(285899,7942,'sv','Uppdatera befintliga betalningsplan',0),(285900,7942,'it','Aggiornare il piano di pagamento esistente',0),(285901,7942,'tl','',0),(285902,7942,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3612;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(285903,7942,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(285904,7942,'ms','Kemaskini Terakhir pelan pembayaran yang sedia ada',0),(285905,7942,'ar','ØªØ­Ø¯ÙŠØ« Ø®Ø·Ù‘Ø© ØªÙ‚Ø³ÙŠØ· Ù…ÙˆØ¬ÙˆØ¯Ø© Ù…Ø³Ø¨Ù‚Ø§',0),(285906,7942,'fr','Mise Ã  jour du Plan de paiement existant',0),(285907,7942,'jp','æ—¢å­˜ã®ãŠæ”¯æ‰•ã„è¨ˆç”»ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(285908,7942,'pt','Atualizar o plano de pagamento existente',0),(285909,7942,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½',0),(285910,7942,'es','Actualizar Plan de Pago Existente',0),(285911,7942,'de','Aktualisieren vorhandener Zahlungsplan',0),(285912,7942,'en','Update Existing Payment Plan',0),(285913,7943,'is','',0),(285914,7943,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(285915,7943,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(285916,7943,'tr','Fatura gÃ¼ncelleÅŸtirme',0),(285917,7943,'pl','Aktualizacji faktury',0),(285918,7943,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(285919,7943,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(285920,7943,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(285921,7943,'vi','Cáº­p Nháº­t HÃ³a ÄÆ¡n',0),(285922,7943,'af','Opdateer Fakture',0),(285923,7943,'ro','Update facturi',0),(285924,7943,'et','VÃ¤rskenda Arveid',0),(285925,7943,'si','Posodabljanje raÄunov',0),(285926,7943,'ba','Memperbarui faktur',0),(285927,7943,'nl','Bijwerken van facturen',0),(285928,7943,'fi','PÃ¤ivitÃ¤ laskut',0),(285929,7943,'no','Oppdatere fakturaer',0),(285930,7943,'da','Opdatere fakturaer',0),(285931,7943,'ko','ì—…ë°ì´íŠ¸ ì²­êµ¬ì„œ',0),(285932,7943,'he','×¢×“×›×Ÿ ×—×©×‘×•× ×™×•×ª',0),(285933,7943,'el','Î‘Î½Î±Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(285934,7943,'zh','æ›´æ–°å‘ç¥¨\r\n',0),(285935,7943,'sv','Uppdatera fakturor',0),(285936,7943,'it','Aggiornamento fatture',0),(285937,7943,'tl','',0),(285938,7943,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(285939,7943,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(285940,7943,'ms','Kemaskini invois',0),(285941,7943,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(285942,7943,'fr','Mise Ã  jour des factures',0),(285943,7943,'jp','è«‹æ±‚æ›¸ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(285944,7943,'pt','Faturas de atualizaÃ§Ã£o',0),(285945,7943,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚Ð°',0),(285946,7943,'es','Actualizar Facturas',0),(285947,7943,'de','Update Rechnungen',0),(285948,7943,'en','Update Invoices',0),(285949,7944,'is','',0),(285950,7944,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡',0),(285951,7944,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡',0),(285952,7944,'tr','Yinelenen girdileri gÃ¼ncelleÅŸtirme',0),(285953,7944,'pl','Aktualizacja wpisÃ³w powtarzajÄ…cych',0),(285954,7944,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(285955,7944,'ur','Ù…Ú©Ø±Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(285956,7944,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(285957,7944,'vi','Cáº­p Nháº­t BÃºt ToÃ¡n Äá»‹nh Ká»³',0),(285958,7944,'af','Opdateer Herhaalde Inskrywings',0),(285959,7944,'ro','Actualiza intrÄƒrile de recurente',0),(285960,7944,'et','Uuenda korduvaid kandeid',0),(285961,7944,'si','Posodobite ponavljajoÄih se postavkah',0),(285962,7944,'ba','Memperbarui entri berulang',0),(285963,7944,'nl','Terugkerende vermeldingen bijwerken',0),(285964,7944,'fi','PÃ¤ivitÃ¤ toistuvia tapahtumia',0),(285965,7944,'no','Oppdatere gjentakelsesposter',0),(285966,7944,'da','Opdatere gentagelsesposterne',0),(285967,7944,'ko','ë˜í’€ì´ í•­ëª©ì„ ì—…ë°ì´íŠ¸',0),(285968,7944,'he','×¢×“×›×•×Ÿ ×¢×¨×›×™× ×—×•×–×¨×™×',0),(285969,7944,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½Ï‰Î½ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(285970,7944,'zh','æ›´æ–°å¾ªçŽ¯æ¡ç›®\r\n',0),(285971,7944,'sv','Uppdatera Ã¥terkommande poster',0),(285972,7944,'it','Aggiornare le voci ricorrenti',0),(285973,7944,'tl','',0),(285974,7944,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3595;&#3638;&#3656;&#3591;&#3648;&#3585;&#3636;&#3604;&#3586;&#3638;&#3657;&#3609;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(285975,7944,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(285976,7944,'ms','Kemaskini Terakhir entri berulang',0),(285977,7944,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ù…ØªÙƒØ±Ù‘Ø±Ø©',0),(285978,7944,'fr','Mettre Ã  jour les entrÃ©es rÃ©currentes',0),(285979,7944,'jp','å®šæœŸçš„ãªã‚¨ãƒ³ãƒˆãƒªã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(285980,7944,'pt','Atualizar entradas recorrentes',0),(285981,7944,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ…ÑÑ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(285982,7944,'es','Actualizar Entradas Recurrentes',0),(285983,7944,'de','Wiederkehrende EintrÃ¤ge aktualisiert',0),(285984,7944,'en','Update Recurring Entries',0),(285985,7945,'is','',0),(285986,7945,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(285987,7945,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(285988,7945,'tr','SatÄ±cÄ± verileri gÃ¼ncelleÅŸtirmek',0),(285989,7945,'pl','Aktualizacja dostawcy danych',0),(285990,7945,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(285991,7945,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÙˆØ§Ø¦Ù Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(285992,7945,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(285993,7945,'vi','Cáº­p nháº­t dá»¯ liá»‡u ngÆ°á»i bÃ¡n',0),(285994,7945,'af','Opdateer Verskaffer Data',0),(285995,7945,'ro','Actualizare date de furnizor',0),(285996,7945,'et','VÃ¤rskenda tarnija andmeid',0),(285997,7945,'si','Posodabljanje podatkov dobavitelja',0),(285998,7945,'ba','Memperbarui Vendor Data',0),(285999,7945,'nl','Leverancier gegevens bijwerken',0),(286000,7945,'fi','PÃ¤ivitÃ¤ toimittajan tiedot',0),(286001,7945,'no','Oppdatere leverandÃ¸rdata',0),(286002,7945,'da','Opdatere kreditordata',0),(286003,7945,'ko','ê³µê¸‰ ì—…ì²´ ë°ì´í„° ì—…ë°ì´íŠ¸',0),(286004,7945,'he','×¢×“×›×Ÿ ×ž×™×“×¢ ×¡×¤×§',0),(286005,7945,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(286006,7945,'zh','æ›´æ–°ä¾›åº”å•†æ•°æ®\r\n',0),(286007,7945,'sv','Uppdatera Data fÃ¶r leverantÃ¶r',0),(286008,7945,'it','Aggiornare i dati del fornitore',0),(286009,7945,'tl','',0),(286010,7945,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(286011,7945,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(286012,7945,'ms','Mengemaskini data-Data Penjual',0),(286013,7945,'ar','ØªØ­Ø¯ÙŠØ« Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(286014,7945,'fr','Mettre Ã  jour les donnÃ©es du vendeur',0),(286015,7945,'jp','ä»•å…¥å…ˆã®ãƒ‡ãƒ¼ã‚¿ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(286016,7945,'pt','Atualizar dados de fornecedor',0),(286017,7945,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ðµ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(286018,7945,'es','Actualizar Datos de Proveedor',0),(286019,7945,'de','Aktualisieren von Lieferantendaten',0),(286020,7945,'en','Update Vendor Data',0),(286021,7946,'is','',0),(286022,7946,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(286023,7946,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(286024,7946,'tr','SatÄ±cÄ± faturalarÄ±',0),(286025,7946,'pl','Rachunki dostawcÃ³w',0),(286026,7946,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(286027,7946,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„',0),(286028,7946,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(286029,7946,'vi','HÃ³a ÄÆ¡n NgÆ°á»i bÃ¡n',0),(286030,7946,'af','Verskaffer Rekeninge',0),(286031,7946,'ro','Furnizor facturi',0),(286032,7946,'et','Tarnijate arved',0),(286033,7946,'si','RaÄune dobavitelja',0),(286034,7946,'ba','Penjual tagihan',0),(286035,7946,'nl','Facturen van de leverancier',0),(286036,7946,'fi','Toimittajan laskut',0),(286037,7946,'no','LeverandÃ¸ren regninger',0),(286038,7946,'da','Kreditor regninger',0),(286039,7946,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ',0),(286040,7946,'he','×—×©×‘×•× ×•×ª ×¡×¤×§×™×',0),(286041,7946,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ Ï€Ï‰Î»Î·Ï„Î®',0),(286042,7946,'zh','é”€å”®æ–¹å¸å•\r\n',0),(286043,7946,'sv','LeverantÃ¶r rÃ¤kningar',0),(286044,7946,'it','Pagamenti fornitore',0),(286045,7946,'tl','',0),(286046,7946,'th','&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(286047,7946,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤²',0),(286048,7946,'ms','Bil-bil vendor',0),(286049,7946,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(286050,7946,'fr','Factures du vendeur',0),(286051,7946,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸',0),(286052,7946,'pt','Contas de fornecedores',0),(286053,7946,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(286054,7946,'es','Facturas/Recibos de Proveedor',0),(286055,7946,'de','Lieferanten-Rechnungen',0),(286056,7946,'en','Vendor Bills',0),(286057,7947,'is','',0),(286058,7947,'dr','Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ ',0),(286059,7947,'pr','Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ ',0),(286060,7947,'tr','GÃ¶rÃ¼nÃ¼m hesabÄ±',0),(286061,7947,'pl','Widok konta',0),(286062,7947,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð¿Ñ€Ð¾Ñ„Ð¸Ð»Ð°',0),(286063,7947,'ur','Ù…Ù†Ø¸Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(286064,7947,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð½Ð°Ð»Ð¾Ð³Ð°',0),(286065,7947,'vi','Xem TK',0),(286066,7947,'af','Besigtig Rekening',0),(286067,7947,'ro','Vezi cont',0),(286068,7947,'et','Vaata kontot',0),(286069,7947,'si','Pogled raÄun',0),(286070,7947,'ba','Lihat Account',0),(286071,7947,'nl','Weergave Account',0),(286072,7947,'fi','NÃ¤ytÃ¤ tili',0),(286073,7947,'no','Vis konto',0),(286074,7947,'da','Se konto',0),(286075,7947,'ko','ë³´ê¸° ê³„ì •',0),(286076,7947,'he','×”×¦×’ ×—×©×‘×•×Ÿ',0),(286077,7947,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(286078,7947,'zh','æŸ¥çœ‹å¸æˆ·\r\n',0),(286079,7947,'sv','Visa konto',0),(286080,7947,'it','Vista Account',0),(286081,7947,'tl','',0),(286082,7947,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(286083,7947,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤–à¤¾à¤¤à¤¾',0),(286084,7947,'ms','Paparan akaun',0),(286085,7947,'ar','Ø¹Ø±Ø¶ Ø­Ø³Ø§Ø¨',0),(286086,7947,'fr','Afficher le compte',0),(286087,7947,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®è¡¨ç¤º',0),(286088,7947,'pt','Ver conta',0),(286089,7947,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐŸÑ€Ð¾Ñ„Ð¸Ð»ÑŒ',0),(286090,7947,'es','Ver Cuenta',0),(286091,7947,'de','Konto anzeigen',0),(286092,7947,'en','View Account',0),(286093,7948,'is','',0),(286094,7948,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø­Ø³Ø§Ø¨ ',0),(286095,7948,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø­Ø³Ø§Ø¨ ',0),(286096,7948,'tr','Hesap verilerini gÃ¶rÃ¼ntÃ¼leme',0),(286097,7948,'pl','Widok danych konta',0),(286098,7948,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ',0),(286099,7948,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÙˆØ§Ø¦Ù Ù…Ù†Ø¸Ø± Ú©Ø±ÛŒÚº',0),(286100,7948,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¾ Ð¿Ð¾ÑÐ»Ð¾Ð²Ð½Ð¾Ð¼ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñƒ',0),(286101,7948,'vi','Xem Dá»¯ Liá»‡u TK',0),(286102,7948,'af','Besigtig Rekening Data',0),(286103,7948,'ro','Vizualizare date cont',0),(286104,7948,'et','Kuva konto andmed',0),(286105,7948,'si','Podatkov v pogledu raÄuna',0),(286106,7948,'ba','Tampilan Data akun',0),(286107,7948,'nl','Accountgegevens weergeven',0),(286108,7948,'fi','NÃ¤ytÃ¤ tilin tiedot',0),(286109,7948,'no','Vis kontodata',0),(286110,7948,'da','Se kontodata',0),(286111,7948,'ko','ê³„ì • ë°ì´í„° ë³´ê¸°',0),(286112,7948,'he','×”×¦×’ × ×ª×•× ×™ ×—×©×‘×•×Ÿ',0),(286113,7948,'el','Î”ÎµÎ¯Ï„Îµ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(286114,7948,'zh','æŸ¥çœ‹å¸æˆ·èµ„æ–™\r\n',0),(286115,7948,'sv','Visa kontodata',0),(286116,7948,'it','Visualizzazione dati Account',0),(286117,7948,'tl','',0),(286118,7948,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(286119,7948,'hi','à¤–à¤¾à¤¤à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤¦à¥‡à¤–à¥‡à¤‚',0),(286120,7948,'ms','Paparan akaun Data',0),(286121,7948,'ar','Ø¹Ø±Ø¶ Ø¨ÙŠØ§Ù†Ø§Øª Ø­Ø³Ø§Ø¨',0),(286122,7948,'fr','Afficher les donnÃ©es de compte',0),(286123,7948,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ ãƒ‡ãƒ¼ã‚¿ã®è¡¨ç¤º',0),(286124,7948,'pt','Exibir dados de conta',0),(286125,7948,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ðµ ÐŸÑ€Ð¾Ñ„Ð¸Ð»Ñ',0),(286126,7948,'es','Ver Datos de Cuenta',0),(286127,7948,'de','Konto-Daten anzeigen',0),(286128,7948,'en','View Account Data',0),(286129,7949,'is','',0),(286130,7949,'dr','W2s',0),(286131,7949,'pr','W2s',0),(286132,7949,'tr','W-2S',0),(286133,7949,'pl','W-2S',0),(286134,7949,'bg','W-2S',0),(286135,7949,'ur','W-2S',0),(286136,7949,'sr','W-2Ð¡',0),(286137,7949,'vi','W2s',0),(286138,7949,'af','W-2S',0),(286139,7949,'ro','W-2S',0),(286140,7949,'et','*W2s',0),(286141,7949,'si','W-2S',0),(286142,7949,'ba','W-2S',0),(286143,7949,'nl','W-2S',0),(286144,7949,'fi','W-2S',0),(286145,7949,'no','W-2S',0),(286146,7949,'da','W-2S',0),(286147,7949,'ko','W-2',0),(286148,7949,'he','×“××‘×œ×™×•',0),(286149,7949,'el','W-2S',0),(286150,7949,'zh','W - 2\r\n',0),(286151,7949,'sv','W-2S',0),(286152,7949,'it','W-2S',0),(286153,7949,'tl','',0),(286154,7949,'th','W2s',0),(286155,7949,'hi','à¤¡à¤¬à¥à¤²à¥à¤¯à¥‚ 2S',0),(286156,7949,'ms','W-2S',0),(286157,7949,'ar','Ø«-2S',0),(286158,7949,'fr','W-2',0),(286159,7949,'jp','ãƒ˜ã‚¢ã‚¦ã‚£ãƒƒã‚° W-2S',0),(286160,7949,'pt','W-2S',0),(286161,7949,'ru','Ð¤ÐžÐ ÐœÐ« W-2S',0),(286162,7949,'es','W2s',0),(286163,7949,'de','W-2 S',0),(286164,7949,'en','W-2s',0),(286165,7950,'is','',0),(286166,7950,'dr','ØªØ§ÙŠÙŠØ¯ Ø§ÙŠÙ…ÙŠÙ„',0),(286167,7950,'pr','ØªØ§ÙŠÙŠØ¯ Ø§ÙŠÙ…ÙŠÙ„',0),(286168,7950,'tr','AP e-posta',0),(286169,7950,'pl','Poczta AP',0),(286170,7950,'bg','AP Ð¸Ð¼ÐµÐ¹Ð»',0),(286171,7950,'ur','AP Ø§ÛŒ Ù…ÛŒÙ„',0),(286172,7950,'sr','ÐÐŸ Ð•Ð¼Ð°Ð¸Ð»',0),(286173,7950,'vi','Email TK Pháº£i Tráº£',0),(286174,7950,'af','RB E-pos',0),(286175,7950,'ro','AP E-mail',0),(286176,7950,'et','AP Email',0),(286177,7950,'si','AP Email',0),(286178,7950,'ba','AP Email',0),(286179,7950,'nl','AP E-mail',0),(286180,7950,'fi','AP sÃ¤hkÃ¶posti',0),(286181,7950,'no','AP Email',0),(286182,7950,'da','AP E-mail',0),(286183,7950,'ko','AP ì´ë©”ì¼',0),(286184,7950,'he','×“×•× ×œ AP',0),(286185,7950,'el','AP Email',0),(286186,7950,'zh','åº”ä»˜è´¦æ¬¾ç”µå­é‚®ä»¶\r\n',0),(286187,7950,'sv','AP Email',0),(286188,7950,'it','AP Email',0),(286189,7950,'tl','',0),(286190,7950,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(286191,7950,'hi','à¤à¤ªà¥€ à¤ˆà¤®à¥‡à¤²',0),(286192,7950,'ms','E-mel AP',0),(286193,7950,'ar','Ø£ ÙØ¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(286194,7950,'fr','CP Courriel',0),(286195,7950,'jp','Ap é€šä¿¡ãƒ¡ãƒ¼ãƒ«',0),(286196,7950,'pt','E-mail AP',0),(286197,7950,'ru','AP ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(286198,7950,'es','CP Email',0),(286199,7950,'de','AP-E-Mail',0),(286200,7950,'en','AP Email',0),(286201,7951,'is','',0),(286202,7951,'dr','(Ú¯Ø±ÙˆÙ‡ ØµÙ†Ø¹ØªÙŠ',0),(286203,7951,'pr','Ø§ÙŠÙ…ÙŠÙ„ ØµÙ†Ø¹Øª(Ú¯Ø±ÙˆÙ‡ ØµÙ†Ø¹ØªÙŠ',0),(286204,7951,'tr','AR e-posta',0),(286205,7951,'pl','AR E-mail',0),(286206,7951,'bg','AR Ð¸Ð¼ÐµÐ¹Ð»',0),(286207,7951,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§ÛŒ Ù…ÛŒÙ„',0),(286208,7951,'sr','ÐÐ  Ð•Ð¼Ð°Ð¸Ð»',0),(286209,7951,'vi','Email TK Pháº£i Thu',0),(286210,7951,'af','RO E-pos',0),(286211,7951,'ro','AR E-mail',0),(286212,7951,'et','AR Email',0),(286213,7951,'si','AR Email',0),(286214,7951,'ba','AR Email',0),(286215,7951,'nl','AR E-mail',0),(286216,7951,'fi','AR sÃ¤hkÃ¶posti',0),(286217,7951,'no','AR e',0),(286218,7951,'da','AR E-mail',0),(286219,7951,'ko','ì•„ì¹¸ì†Œ ì´ë©”ì¼',0),(286220,7951,'he','×“×•× ×œ AR',0),(286221,7951,'el','AR Email',0),(286222,7951,'zh','åº”æ”¶è´¦æ¬¾ç”µé‚®\r\n',0),(286223,7951,'sv','AR e-post',0),(286224,7951,'it','AR Email',0),(286225,7951,'tl','',0),(286226,7951,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(286227,7951,'hi','à¤. à¤†à¤°. à¤ˆà¤®à¥‡à¤²',0),(286228,7951,'ms','E-mel AR',0),(286229,7951,'ar','Ø¹ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(286230,7951,'fr','CR Courriel',0),(286231,7951,'jp','AR ãƒ¡ãƒ¼ãƒ«',0),(286232,7951,'pt','E-mail do AR',0),(286233,7951,'ru','AR ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(286234,7951,'es','CC Email',0),(286235,7951,'de','AR-E-Mail',0),(286236,7951,'en','AR Email',0),(286237,7952,'is','',0),(286238,7952,'dr','Ø³Ù„Ø³ÙŠÙˆØ³',0),(286239,7952,'pr','Ø³Ù„Ø³ÙŠÙˆØ³',0),(286240,7952,'tr','Santigrat',0),(286241,7952,'pl','Celsjusza',0),(286242,7952,'bg','ÐŸÐ¾ Ð¦ÐµÐ»Ð·Ð¸Ð¹',0),(286243,7952,'ur','Ø¯Ø±Ø¬Û‚ ØµØ¯',0),(286244,7952,'sr','Ð¦ÐµÐ»Ð·Ð¸Ñ˜ÑƒÑÐ°',0),(286245,7952,'vi','Äá»™ C',0),(286246,7952,'af','Celsius',0),(286247,7952,'ro','Celsius',0),(286248,7952,'et','Celsiuse jÃ¤rgi',0),(286249,7952,'si','Celzija',0),(286250,7952,'ba','Celsius',0),(286251,7952,'nl','Celsius',0),(286252,7952,'fi','Celsius',0),(286253,7952,'no','Celsius',0),(286254,7952,'da','Celsius',0),(286255,7952,'ko','ì„­ì”¨',0),(286256,7952,'he','×¦×œ×–×™×•×¡',0),(286257,7952,'el','ÎšÎµÎ»ÏƒÎ¯Î¿Ï…',0),(286258,7952,'zh','æ‘„æ°\r\n',0),(286259,7952,'sv','Celsius',0),(286260,7952,'it','Celsius',0),(286261,7952,'tl','',0),(286262,7952,'th','&#3629;&#3640;&#3603;&#3627;&#3616;&#3641;&#3617;&#3636;&#3648;&#3595;&#3621;&#3648;&#3595;&#3637;&#3618;&#3626;',0),(286263,7952,'hi','à¤¸à¥‡à¤²à¥à¤¸à¤¿à¤¯à¤¸',0),(286264,7952,'ms','Celsius',0),(286265,7952,'ar','Ù…Ø¦ÙˆÙŠØ©',0),(286266,7952,'fr','Celsius',0),(286267,7952,'jp','æ‘‚æ°',0),(286268,7952,'pt','Celsius',0),(286269,7952,'ru','Ð¦ÐµÐ»ÑŒÑÐ¸Ñ',0),(286270,7952,'es','Celsius',0),(286271,7952,'de','Celsius',0),(286272,7952,'en','Celsius',0),(286273,7953,'is','',0),(286274,7953,'dr','Ø³Ø§Ù†ØªÙŠÚ¯Ø±Ø§Ø¯ ÙŠØ§ ÙØ§Ø±Ù†Ù‡Ø§ÙŠØª',0),(286275,7953,'pr','Ø³Ø§Ù†ØªÙŠÚ¯Ø±Ø§Ø¯ ÙŠØ§ ÙØ§Ø±Ù†Ù‡Ø§ÙŠØª',0),(286276,7953,'tr','Santigrad veya Fahrenheit',0),(286277,7953,'pl','Stopnie Celsjusza lub Fahrenheita',0),(286278,7953,'bg','ÐŸÐ¾ Ð¦ÐµÐ»Ð·Ð¸Ð¹ Ð¸Ð»Ð¸ Ð¿Ð¾ Ð¤Ð°Ñ€ÐµÐ½Ñ…Ð°Ð¹Ñ‚',0),(286279,7953,'ur','Ø³ÛŒÙ†Ù¹ÛŒ Ú¯Ø±ÛŒÚˆ ÛŒØ§ ÙØ§Ø±Ù†',0),(286280,7953,'sr','Ð¦ . Ð¸Ð»Ð¸ Ð¤Ð°Ñ€ÐµÐ½Ñ…Ð°Ñ˜Ñ‚Ð°',0),(286281,7953,'vi','TrÄƒm Ä‘á»™ hay Ä‘á»™ F',0),(286282,7953,'af','Celsius of Celsius',0),(286283,7953,'ro','Celsius sau Fahrenheit',0),(286284,7953,'et','Celsiuse vÃµi Fahrenheiti',0),(286285,7953,'si','Celzija ali Fahrenheit',0),(286286,7953,'ba','Fahrenheit atau Celcius',0),(286287,7953,'nl','Celsius of Fahrenheit',0),(286288,7953,'fi','Celsius tai Fahrenheit',0),(286289,7953,'no','Celsius eller Fahrenheit',0),(286290,7953,'da','Celsius eller Fahrenheit',0),(286291,7953,'ko','ì„­ì”¨ ë˜ëŠ” í™”ì”¨',0),(286292,7953,'he','×¦×œ×–×™×•×¡ ××• ×¤×¨× ×”×™×™×˜',0),(286293,7953,'el','ÎšÎµÎ»ÏƒÎ¯Î¿Ï… Î® Î¦Î±ÏÎµÎ½Î¬Î¹Ï„',0),(286294,7953,'zh','æ‘„æ°æˆ–åŽæ°\r\n',0),(286295,7953,'sv','Celsius eller Fahrenheit',0),(286296,7953,'it','Gradi centigradi o Fahrenheit',0),(286297,7953,'tl','',0),(286298,7953,'th','&#3585;&#3634;&#3619;&#3623;&#3633;&#3604;&#3629;&#3640;&#3603;&#3627;&#3616;&#3641;&#3617;&#3636;&#3649;&#3610;&#3610;&#3648;&#3595;&#3609;&#3605;&#3636;&#3648;&#3585;&#3619;&#3604;&#3627;&#3619;&#3639;&#3629;&#3615;&#3634;&#3648;&#3619;&#3609;&#3652;&#3',0),(286299,7953,'hi','à¤¸à¥‡à¤²à¥à¤¸à¤¿à¤¯à¤¸ à¤¯à¤¾ à¤«à¥‡à¤°à¤¨à¤¹à¤¾à¤‡à¤Ÿ',0),(286300,7953,'ms','Selsius atau Fahrenheit',0),(286301,7953,'ar','Ù…Ø¦ÙˆÙŠØ© Ø£Ùˆ ÙÙ‡Ø±Ù†Ù‡ÙŠØª',0),(286302,7953,'fr','C / f',0),(286303,7953,'jp','æ‘‚æ°ã¾ãŸã¯è¯æ°',0),(286304,7953,'pt','CentÃ­grados ou Fahrenheit',0),(286305,7953,'ru','Ð¦ÐµÐ»ÑŒÑÐ¸Ñ Ð¸Ð»Ð¸ Ð¤Ð°Ñ€ÐµÐ½Ð³ÐµÐ¹Ñ‚',0),(286306,7953,'es','CentÃ­grado o Fahrenheit',0),(286307,7953,'de','Celsius oder Fahrenheit',0),(286308,7953,'en','Centigrade or Fahrenheit',0),(286309,7954,'is','',0),(286310,7954,'dr','ÙØ§Ø±Ù†Ù‡Ø§ÙŠØª ',0),(286311,7954,'pr','ÙØ§Ø±Ù†Ù‡Ø§ÙŠØª ',0),(286312,7954,'tr','Fahrenheit',0),(286313,7954,'pl','Fahrenheit',0),(286314,7954,'bg','Ð¤Ð°Ñ€ÐµÐ½Ñ…Ð°Ð¹Ñ‚',0),(286315,7954,'ur','ÚˆÚ¯Ø±ÛŒ ÙØ§Ø±Ù† ÛØ§Ø¦ÛŒÙ¹',0),(286316,7954,'sr','Ð¤Ð°Ñ€ÐµÐ½Ñ…Ð°Ñ˜Ñ‚Ð°',0),(286317,7954,'vi','Äá»™ F',0),(286318,7954,'af','Fahrenheit',0),(286319,7954,'ro','Fahrenheit',0),(286320,7954,'et','Fahrenheiti',0),(286321,7954,'si','Fahrenheit',0),(286322,7954,'ba','Fahrenheit',0),(286323,7954,'nl','Fahrenheit',0),(286324,7954,'fi','Fahrenheit',0),(286325,7954,'no','Fahrenheit',0),(286326,7954,'da','Fahrenheit',0),(286327,7954,'ko','í™”ì”¨',0),(286328,7954,'he','×ž×¢×œ×•×ª ×¤×¨× ×”×™×™×˜',0),(286329,7954,'el','Î¦Î±ÏÎµÎ½Î¬Î¹Ï„',0),(286330,7954,'zh','åŽæ°\r\n',0),(286331,7954,'sv','Fahrenheit',0),(286332,7954,'it','Fahrenheit',0),(286333,7954,'tl','',0),(286334,7954,'th','&#3629;&#3591;&#3624;&#3634;&#3615;&#3634;&#3648;&#3619;&#3609;&#3652;&#3630;&#3607;&#3660;',0),(286335,7954,'hi','à¤«à¤¾à¤°à¥‡à¤¨à¤¹à¤¾à¤‡à¤Ÿ',0),(286336,7954,'ms','Fahrenheit',0),(286337,7954,'ar','ÙÙ‡Ø±Ù†Ù‡ÙŠØª',0),(286338,7954,'fr','Fahrenheit',0),(286339,7954,'jp','é£›è¼ªæµ·',0),(286340,7954,'pt','Fahrenheit',0),(286341,7954,'ru','Ð¤Ð°Ñ€ÐµÐ½Ð³ÐµÐ¹Ñ‚',0),(286342,7954,'es','Fahrenheit',0),(286343,7954,'de','Fahrenheit',0),(286344,7954,'en','Fahrenheit',0),(286345,7955,'is','',0),(286346,7955,'dr','Ø¨Ø§Ù‡Ø§Ù…Ø§',0),(286347,7955,'pr','Ø¨Ø§Ù‡Ø§Ù…Ø§',0),(286348,7955,'tr','Bahamalar',0),(286349,7955,'pl','Bahamy',0),(286350,7955,'bg','Ð‘Ð°Ñ…Ð°Ð¼ÑÐºÐ¸ Ð¾ÑÑ‚Ñ€Ð¾Ð²Ð¸',0),(286351,7955,'ur','Ø¨ÛØ§Ù…Ø§Ø³',0),(286352,7955,'sr','Ð‘Ð°Ñ…Ð°Ð¼Ð¸',0),(286353,7955,'vi','Bahamas',0),(286354,7955,'af','Bahamas',0),(286355,7955,'ro','Bahamas',0),(286356,7955,'et','Bahama',0),(286357,7955,'si','Bahami',0),(286358,7955,'ba','Bahama',0),(286359,7955,'nl','Bahama \'s',0),(286360,7955,'fi','Bahama',0),(286361,7955,'no','Bahamas',0),(286362,7955,'da','Bahamas',0),(286363,7955,'ko','ë°”í•˜ë§ˆ',0),(286364,7955,'he','××™×™ ×‘×”××ž×”',0),(286365,7955,'el','ÎœÏ€Î±Ï‡Î¬Î¼ÎµÏ‚',0),(286366,7955,'zh','å¨‡åªš\r\n',0),(286367,7955,'sv','Bahamas',0),(286368,7955,'it','Bahamas',0),(286369,7955,'tl','',0),(286370,7955,'th','Bahamas',0),(286371,7955,'hi','à¤¬à¤¹à¤¾à¤®à¤¾',0),(286372,7955,'ms','Bahamas',0),(286373,7955,'ar','Ø¬Ø²Ø± Ø§Ù„Ø¨Ù‡Ø§Ù…Ø§',0),(286374,7955,'fr','Bahamas',0),(286375,7955,'jp','ãƒãƒãƒž',0),(286376,7955,'pt','Bahamas',0),(286377,7955,'ru','Ð‘Ð°Ð³Ð°Ð¼ÑÐºÐ¸Ðµ Ð¾ÑÑ‚Ñ€Ð¾Ð²Ð°',0),(286378,7955,'es','Bahamas',0),(286379,7955,'de','Bahamas',0),(286380,7955,'en','Bahamas',0),(286381,7956,'is','',0),(286382,7956,'dr','Ø¨Ø±Ø§ÙŠ Ø¬Ø§Ù‡Ø§ÙŠÙŠ ØºÙŠØ± Ø§Ø² Ø¢Ù…Ø±ÙŠÙƒØ§ Ø§Ø² Ù„ÙŠÙ†Ùƒ Ø²ÙŠØ± Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(286383,7956,'pr','Ø¨Ø±Ø§ÙŠ Ø¬Ø§Ù‡Ø§ÙŠÙŠ ØºÙŠØ± Ø§Ø² Ø¢Ù…Ø±ÙŠÙƒØ§ Ø§Ø² Ù„ÙŠÙ†Ùƒ Ø²ÙŠØ± Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(286384,7956,'tr','ABD dÄ±ÅŸÄ±ndaki konumlardan kullanÄ±m Link iÃ§in',0),(286385,7956,'pl','Non US miejsca uÅ¼ytkowania Å‚Ä…cza',0),(286386,7956,'bg','Ð—Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð¸Ð·Ð²ÑŠÐ½ Ð¡ÐÐ© ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð²Ñ€ÑŠÐ·ÐºÐ°',0),(286387,7956,'ur','Ú©Û’ Ù„Ø¦Û’ ØºÛŒØ± Ø§Ù…Ø±ÛŒÚ©ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù„Ù†Ú©',0),(286388,7956,'sr','Ð—Ð° ÐÐ¼ÐµÑ€Ð¸Ñ‡ÐºÐ¾Ð³ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð²ÐµÐ·Ñƒ',0),(286389,7956,'vi','ÄÆ°á»ng Dáº«n Cho Nhá»¯ng Äá»‹a Äiá»ƒm NgoÃ i USA',0),(286390,7956,'af','Vir Nie-VSA Liggings Gebruik Skakel',0),(286391,7956,'ro','Pentru locaÅ£ii de Non-US link-ul de utilizare',0),(286392,7956,'et','USA-asukohtade Kasuta linki',0),(286393,7956,'si','Za Non-US mesta uporabe povezava',0),(286394,7956,'ba','Untuk Non-US lokasi menggunakan Link',0),(286395,7956,'nl','Voor niet-Amerikaanse locaties gebruik Link',0),(286396,7956,'fi','Sijainnit Yhdysvalloissa kÃ¤yttÃ¤Ã¤ linkin',0),(286397,7956,'no','For ikke-amerikanske steder bruk kobling',0),(286398,7956,'da','For ikke-amerikanske steder brug Link',0),(286399,7956,'ko','ë¹„ ë¯¸êµ­ ìœ„ì¹˜ ì‚¬ìš© ë§í¬ì— ëŒ€ í•œ',0),(286400,7956,'he','×‘×§×™×©×•×¨ ×©×™×ž×•×© ×ž×™×§×•×ž×™× ×ž×—×•×¥ ×œ××¨×” ×‘',0),(286401,7956,'el','Î“Î¹Î± Î¼Î·-Î—Î Î‘ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚ ÏƒÏÎ½Î´ÎµÏƒÎ¼Î¿ Ï‡ÏÎ®ÏƒÎ·',0),(286402,7956,'zh','å¯¹äºŽéžç¾Žå›½åœ°åŒºä½¿ç”¨çš„é“¾æŽ¥\r\n',0),(286403,7956,'sv','FÃ¶r icke-amerikanska platser AnvÃ¤nd lÃ¤nk',0),(286404,7956,'it','Per Non-US posizioni uso Link',0),(286405,7956,'tl','',0),(286406,7956,'th','For Non-US Locations Use Link',0),(286407,7956,'hi','à¤—à¥ˆà¤°-à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚ à¤•à¤¡à¤¼à¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(286408,7956,'ms','Untuk lokasi bukan AS menggunakan pautan',0),(286409,7956,'ar','Ù„Ù„Ù…ÙˆØ§Ù‚Ø¹ ØºÙŠØ± Ø§Ù„Ø£Ù…Ø±ÙŠÙƒÙŠØ© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø·',0),(286410,7956,'fr','Pour utiliser la liaison non-US sites',0),(286411,7956,'jp','éžç±³å›½ã®å ´æ‰€ã®ä½¿ç”¨ã¸ã®ãƒªãƒ³ã‚¯ã«ã¤ã„ã¦',0),(286412,7956,'pt','Para usar Link para locais fora dos EUA',0),(286413,7956,'ru','Ð”Ð»Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑÑÑ‹Ð»ÐºÐ¸ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¹ Non Ð¡Ð¨Ð',0),(286414,7956,'es','Para Enlaces de Uso de Ubicaciones No-Estadounidense',0),(286415,7956,'de','FÃ¼r nicht-US-Standorte verwenden Link',0),(286416,7956,'en','For Non-US Locations Use Link',0),(286417,7957,'is','',0),(286418,7957,'dr','XP ',0),(286419,7957,'pr','Ø¢ÙŠÙƒÙˆÙ† Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ù…Ù†ÙˆÙŠ ÙˆÙŠÙ†Ø¯ÙˆØ² XP ',0),(286420,7957,'tr','XP tarzÄ± menÃ¼ iÃ§in simge grubu',0),(286421,7957,'pl','Grupa ikona menu XP-styl',0),(286422,7957,'bg','Ð˜ÐºÐ¾Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð·Ð° XP-ÑÑ‚Ð¸Ð» Ð¼ÐµÐ½ÑŽ',0),(286423,7957,'ur','Ø´Ø¨ÛŒÛ Ú¯Ø±ÙˆÙ¾ XP Ø·Ø±Ø² Ù…ÛŒÙ†ÛŒÙˆ',0),(286424,7957,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð¸ÐºÐ¾Ð½Ð° Ð·Ð° XÐŸ-ÑÑ‚Ð¸Ð» Ð¼ÐµÐ½Ð¸Ñ˜Ð°',0),(286425,7957,'vi','NhÃ³m biá»ƒu tÆ°á»£ng cho dáº¡ng XP',0),(286426,7957,'af','Ikoongroep vir XP-Styl Menu',0),(286427,7957,'ro','Pictograma grupului pentru XP-stil meniul',0),(286428,7957,'et','XP stiilis menÃ¼Ã¼ ikoonid',0),(286429,7957,'si','Ikona skupine za XP-Style menija',0),(286430,7957,'ba','Kelompok ikon menu gaya XP',0),(286431,7957,'nl','Pictogram groep voor XP-stijl Menu',0),(286432,7957,'fi','Kuvake ryhmÃ¤n XP-tyylinen menu',0),(286433,7957,'no','Ikonet gruppe for XP-smak meny',0),(286434,7957,'da','Ikonet gruppe for XP-smag Menu',0),(286435,7957,'ko','XP ìŠ¤íƒ€ì¼ ë©”ë‰´ ì•„ì´ì½˜ ê·¸ë£¹',0),(286436,7957,'he','×¡×ž×œ ×”×§×‘×•×¦×” ×¢×‘×•×¨ XP ×‘×¡×’× ×•×Ÿ ×ª×¤×¨×™×˜',0),(286437,7957,'el','ÎŸÎ¼Î¬Î´Î± ÎµÎ¹ÎºÎ¿Î½Î¯Î´Î¹Î¿ Î³Î¹Î± XP-Style Î¼ÎµÎ½Î¿Ï',0),(286438,7957,'zh','å›¾æ ‡ç»„çš„XPé£Žæ ¼èœå•\r\n',0),(286439,7957,'sv','Ikonen grupp fÃ¶r XP-stil menyn',0),(286440,7957,'it','Gruppo icona per il Menu in stile XP',0),(286441,7957,'tl','',0),(286442,7957,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3652;&#3629;&#3588;&#3629;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3648;&#3617;&#3609;&#3641;&#3626;&#3652;&#3605;&#3621;&#3660; XP',0),(286443,7957,'hi','XP à¤¶à¥ˆà¤²à¥€ à¤®à¥‡à¤¨à¥‚ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¿à¤¹à¥à¤¨ à¤¸à¤®à¥‚à¤¹',0),(286444,7957,'ms','Kumpulan ikon untuk Menu XP-gaya',0),(286445,7957,'ar','Ø±Ù…Ø² Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ù„Ù„Ù‚Ø§Ø¦Ù…Ø© Ù†Ù…Ø· XP',0),(286446,7957,'fr','IcÃ´ne de groupe pour XP-Style Menu',0),(286447,7957,'jp','XP ã‚¹ã‚¿ã‚¤ãƒ«ã®ãƒ¡ãƒ‹ãƒ¥ãƒ¼ã®ã‚¢ã‚¤ã‚³ãƒ³ ã‚°ãƒ«ãƒ¼ãƒ—',0),(286448,7957,'pt','Grupo Ã­cone para XP-estilo Menu',0),(286449,7957,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð˜ÐºÐ¾Ð½ Ð´Ð»Ñ ÐœÐµÐ½ÑŽ Ð² XP-Ð¡Ñ‚Ð¸Ð»Ðµ',0),(286450,7957,'es','Grupo de Iconos para MenÃº de Estilo-XP',0),(286451,7957,'de','Symbol-Gruppe fÃ¼r \"XP-Stil\"',0),(286452,7957,'en','Icon Group for XP-Style Menu',0),(286453,7958,'is','',0),(286454,7958,'dr',' Ù…Ø¯Ù„ Ù…Ù†Ùˆ',0),(286455,7958,'pr',' Ù…Ø¯Ù„ Ù…Ù†Ùˆ',0),(286456,7958,'tr','MenÃ¼ stili',0),(286457,7958,'pl','Styl menu',0),(286458,7958,'bg','Ð¡Ñ‚Ð¸Ð» Ð½Ð° Ð¼ÐµÐ½ÑŽ',0),(286459,7958,'ur','Ù…ÛŒÙ†ÛŒÙˆ Ø·Ø±Ø²',0),(286460,7958,'sr','Ð¡Ñ‚Ð¸Ð» Ð¼ÐµÐ½Ð¸Ñ˜Ð°',0),(286461,7958,'vi','Kiá»ƒu dÃ¡ng trÃ¬nh Ä‘Æ¡n',0),(286462,7958,'af','Menu Styl',0),(286463,7958,'ro','Stil de meniu',0),(286464,7958,'et','MenÃ¼Ã¼ stiil',0),(286465,7958,'si','Slog menija',0),(286466,7958,'ba','Menu gaya',0),(286467,7958,'nl','Menustijl',0),(286468,7958,'fi','ValikkotyyliÃ¤',0),(286469,7958,'no','Menystil',0),(286470,7958,'da','Menustil',0),(286471,7958,'ko','ë©”ë‰´ ìŠ¤íƒ€ì¼',0),(286472,7958,'he','×¡×’× ×•×Ÿ ×ª×¤×¨×™×˜',0),(286473,7958,'el','Î£Ï„Ï…Î» Î¼ÎµÎ½Î¿Ï',0),(286474,7958,'zh','èœå•é£Žæ ¼\r\n',0),(286475,7958,'sv','Menyn stil',0),(286476,7958,'it','Stile del menu',0),(286477,7958,'tl','',0),(286478,7958,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3648;&#3617;&#3609;&#3641;',0),(286479,7958,'hi','à¤®à¥‡à¤¨à¥‚ à¤¶à¥ˆà¤²à¥€',0),(286480,7958,'ms','Gaya menu',0),(286481,7958,'ar','Ù†Ù…Ø· Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(286482,7958,'fr','Style de menu',0),(286483,7958,'jp','ãƒ¡ãƒ‹ãƒ¥ãƒ¼ ã‚¹ã‚¿ã‚¤ãƒ«',0),(286484,7958,'pt','Estilo do menu',0),(286485,7958,'ru','Ð¡Ñ‚Ð¸Ð»ÑŒ ÐœÐµÐ½ÑŽ',0),(286486,7958,'es','MenÃº Estilo',0),(286487,7958,'de','MenÃ¼stil',0),(286488,7958,'en','Menu Style',0),(286489,7959,'is','',0),(286490,7959,'dr','NolaPro Ù…Ø¬Ù…ÙˆØ¹Ø§Ø³ÙŠÙƒ',0),(286491,7959,'pr','NolaPro ÙƒÙ„Ø§Ø³ÙŠÙƒ',0),(286492,7959,'tr','Klasik',0),(286493,7959,'pl','Klasyczny',0),(286494,7959,'bg','ÐšÐ»Ð°ÑÐ¸Ñ‡ÐµÑÐºÐ¸',0),(286495,7959,'ur','Ú©Ù„Ø§Ø³ÛŒÚ©ÛŒ',0),(286496,7959,'sr','ÐšÐ»Ð°ÑÐ¸Ñ‡Ð½Ð¸',0),(286497,7959,'vi','NolaPro Cá»• Ä‘iá»ƒn',0),(286498,7959,'af','NolaPro Klassiek',0),(286499,7959,'ro','Clasic',0),(286500,7959,'et','NolaPro klassikaline',0),(286501,7959,'si','Classic',0),(286502,7959,'ba','Klasik',0),(286503,7959,'nl','Classic',0),(286504,7959,'fi','Classic',0),(286505,7959,'no','Klassisk',0),(286506,7959,'da','Classic',0),(286507,7959,'ko','í´ëž˜ì‹',0),(286508,7959,'he','×§×œ××¡×™',0),(286509,7959,'el','ÎšÎ»Î±ÏƒÎ¹ÎºÏŒ',0),(286510,7959,'zh','ç»å…¸\r\n',0),(286511,7959,'sv','Classic',0),(286512,7959,'it','Classico',0),(286513,7959,'tl','',0),(286514,7959,'th','NolaPro &#3588;&#3621;&#3634;&#3626;&#3626;&#3636;&#3588;',0),(286515,7959,'hi','à¤•à¥à¤²à¤¾à¤¸à¤¿à¤•',0),(286516,7959,'ms','Classic',0),(286517,7959,'ar','Ù†ÙˆÙ„Ø§ Ø¨Ø±Ùˆ Ø§Ù„ØªÙ‚Ù„ÙŠØ¯ÙŠ',0),(286518,7959,'fr','Classique',0),(286519,7959,'jp','ã‚¯ãƒ©ã‚·ãƒƒã‚¯',0),(286520,7959,'pt','ClÃ¡ssico',0),(286521,7959,'ru','ÐšÐ»Ð°ÑÑÐ¸Ñ‡ÐµÑÐºÐ¾Ðµ NolaPro',0),(286522,7959,'es','NolaPro ClÃ¡sico',0),(286523,7959,'de','Classic',0),(286524,7959,'en','Classic',0),(286525,7960,'is','',0),(286526,7960,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø³ÙØ§Ø±Ø´ â€“ Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„',0),(286527,7960,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø³ÙØ§Ø±Ø´ â€“ Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„',0),(286528,7960,'tr','SipariÅŸ e-posta',0),(286529,7960,'pl','ZamÃ³wienia E-mail',0),(286530,7960,'bg','Ð ÐµÐ´ Ð¼ÐµÐ¹Ð»',0),(286531,7960,'ur','ØªØ±ØªÛŒØ¨ Ø§ÛŒ Ù…ÛŒÙ„',0),(286532,7960,'sr','ÐÐ°Ð»Ð¾Ð³ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(286533,7960,'vi','Email Ä‘Æ¡n hÃ ng',0),(286534,7960,'af','Bestel E-pos',0),(286535,7960,'ro','Comanda E-mail',0),(286536,7960,'et','Tellimus e-posti',0),(286537,7960,'si','NaroÄilo e-poÅ¡te',0),(286538,7960,'ba','Order Email',0),(286539,7960,'nl','Bestelling E-mail',0),(286540,7960,'fi','Tilaa sÃ¤hkÃ¶postilla',0),(286541,7960,'no','Bestill epost',0),(286542,7960,'da','Bestil E-mail',0),(286543,7960,'ko','ì£¼ë¬¸ ì´ë©”ì¼',0),(286544,7960,'he','×¡×“×¨ ×“×•×',0),(286545,7960,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(286546,7960,'zh','è®¢å•é‚®ä»¶\r\n',0),(286547,7960,'sv','BestÃ¤llning e-post',0),(286548,7960,'it','Ordine E-mail',0),(286549,7960,'tl','',0),(286550,7960,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(286551,7960,'hi','à¤†à¤¦à¥‡à¤¶ à¤ˆà¤®à¥‡à¤²',0),(286552,7960,'ms','E-mel perintah',0),(286553,7960,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø·Ù„Ø¨ÙŠØ§Øª',0),(286554,7960,'fr','Courriel de commande',0),(286555,7960,'jp','ã”æ³¨æ–‡ãƒ¡ãƒ¼ãƒ«',0),(286556,7960,'pt','E-mail de ordem',0),(286557,7960,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(286558,7960,'es','Pedido Email',0),(286559,7960,'de','Bestellung-Email',0),(286560,7960,'en','Order Email',0),(286561,7961,'is','',0),(286562,7961,'dr','Ù…Ø±Ø¯Ù… ',0),(286563,7961,'pr','Ù…Ø±Ø¯Ù… ',0),(286564,7961,'tr','Ä°nsanlar',0),(286565,7961,'pl','Ludzie',0),(286566,7961,'bg','Ð¥Ð¾Ñ€Ð°',0),(286567,7961,'ur','Ù„ÙˆÚ¯',0),(286568,7961,'sr','Ð‰ÑƒÐ´Ð¸',0),(286569,7961,'vi','Má»i ngÆ°á»i',0),(286570,7961,'af','Mense',0),(286571,7961,'ro','Oameni',0),(286572,7961,'et','Inimesed',0),(286573,7961,'si','Ljudje',0),(286574,7961,'ba','Orang-orang',0),(286575,7961,'nl','Mensen',0),(286576,7961,'fi','Ihmiset',0),(286577,7961,'no','Folk',0),(286578,7961,'da','Folk',0),(286579,7961,'ko','ì‚¬ëžŒë“¤',0),(286580,7961,'he','×× ×©×™×',0),(286581,7961,'el','Î†Î½Î¸ÏÏ‰Ï€Î¿Î¹',0),(286582,7961,'zh','äºº\r\n',0),(286583,7961,'sv','MÃ¤nniskor',0),(286584,7961,'it','Persone',0),(286585,7961,'tl','',0),(286586,7961,'th','&#3588;&#3609;',0),(286587,7961,'hi','à¤²à¥‹à¤—',0),(286588,7961,'ms','Orang-orang',0),(286589,7961,'ar','Ø§Ù„Ø´Ø¹Ø¨',0),(286590,7961,'fr','Personnes',0),(286591,7961,'jp','äººã€…',0),(286592,7961,'pt','Pessoas',0),(286593,7961,'ru','Ð›ÑŽÐ´Ð¸',0),(286594,7961,'es','Gente',0),(286595,7961,'de','Menschen',0),(286596,7961,'en','People',0),(286597,7962,'is','',0),(286598,7962,'dr','Cocoa Ø³Ø§Ø­Ù„',0),(286599,7962,'pr','Cocoa Ø³Ø§Ø­Ù„',0),(286600,7962,'tr','Cocoa Beach',0),(286601,7962,'pl','Cocoa Beach',0),(286602,7962,'bg','ÐšÐ°ÐºÐ°Ð¾ Ð‘Ð¸Ð¹Ñ‡',0),(286603,7962,'ur','Ú©ÙˆÚ©Ùˆ Ø¨ÛŒÚ†',0),(286604,7962,'sr','ÐšÐ°ÐºÐ°Ð¾ Ð¿Ð»Ð°Ð¶Ð°',0),(286605,7962,'vi','BÃ£i biá»ƒn Cocoa',0),(286606,7962,'af','Kakao strand',0),(286607,7962,'ro','Cocoa Beach',0),(286608,7962,'et','Cocoa Beach',0),(286609,7962,'si','Cocoa Beach',0),(286610,7962,'ba','Cocoa Beach',0),(286611,7962,'nl','Cocoa Beach',0),(286612,7962,'fi','Cocoa Beach',0),(286613,7962,'no','Cocoa Beach',0),(286614,7962,'da','Cocoa Beach',0),(286615,7962,'ko','ì½”ì½”ì•„ ë¹„ì¹˜',0),(286616,7962,'he','Cocoa Beach',0),(286617,7962,'el','Cocoa Beach',0),(286618,7962,'zh','å¯å¯æ¯”å¥‡\r\n',0),(286619,7962,'sv','Cocoa Beach',0),(286620,7962,'it','Cocoa Beach',0),(286621,7962,'tl','',0),(286622,7962,'th','Cocoa Beach',0),(286623,7962,'hi','à¤•à¥‹à¤•à¥‹ Beach',0),(286624,7962,'ms','Cocoa Beach',0),(286625,7962,'ar','ÙƒÙˆÙƒÙˆØ§ Ø¨ÙŠØªØ´',0),(286626,7962,'fr','Cocoa Beach',0),(286627,7962,'jp','ã‚³ã‚³ã‚¢ãƒ“ãƒ¼ãƒ',0),(286628,7962,'pt','Cocoa Beach',0),(286629,7962,'ru','ÐšÐ°ÐºÐ°Ð¾-Ð‘Ð¸Ñ‡',0),(286630,7962,'es','Cocoa Beach',0),(286631,7962,'de','Cocoa Beach',0),(286632,7962,'en','Cocoa Beach',0),(286633,7963,'is','',0),(286634,7963,'dr','Ù†ÙŠÙˆ ÙŠÙˆØ±Ùƒ ',0),(286635,7963,'pr','Ù†ÙŠÙˆ ÙŠÙˆØ±Ùƒ ',0),(286636,7963,'tr','New York',0),(286637,7963,'pl','Nowy Jork',0),(286638,7963,'bg','ÐÑŽ Ð™Ð¾Ñ€Ðº',0),(286639,7963,'ur','Ù†ÛŒÙˆ ÛŒØ§Ø±Ú©',0),(286640,7963,'sr','ÐÐµw YÐ¾Ñ€Ðº-Ñƒ',0),(286641,7963,'vi','New York',0),(286642,7963,'af','New York',0),(286643,7963,'ro','New York',0),(286644,7963,'et','New York',0),(286645,7963,'si','New York',0),(286646,7963,'ba','New York',0),(286647,7963,'nl','New York',0),(286648,7963,'fi','New York',0),(286649,7963,'no','New York',0),(286650,7963,'da','New York',0),(286651,7963,'ko','ë‰´ìš•',0),(286652,7963,'he','× ×™×•-×™×•×¨×§',0),(286653,7963,'el','ÎÎ­Î± Î¥ÏŒÏÎºÎ·',0),(286654,7963,'zh','çº½çº¦\r\n',0),(286655,7963,'sv','New York',0),(286656,7963,'it','New York',0),(286657,7963,'tl','',0),(286658,7963,'th','&#3609;&#3636;&#3623;&#3618;&#3629;&#3619;&#3660;&#3588;',0),(286659,7963,'hi','à¤¨à¥à¤¯à¥‚ à¤¯à¤¾à¤°à¥à¤•',0),(286660,7963,'ms','New York',0),(286661,7963,'ar','Ù†ÙŠÙˆÙŠÙˆØ±Ùƒ',0),(286662,7963,'fr','New York',0),(286663,7963,'jp','ãƒ‹ãƒ¥ãƒ¼ãƒ¨ãƒ¼ã‚¯',0),(286664,7963,'pt','Nova Iorque',0),(286665,7963,'ru','ÐÑŒÑŽ-Ð™Ð¾Ñ€Ðº',0),(286666,7963,'es','Nueva York',0),(286667,7963,'de','New York',0),(286668,7963,'en','New York',0),(286669,7964,'is','',0),(286670,7964,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ù…Ø§',0),(286671,7964,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ù…Ø§',0),(286672,7964,'tr','SÄ±caklÄ±k gÃ¶rÃ¼ntÃ¼leme',0),(286673,7964,'pl','Wyswietlacz temperatury',0),(286674,7964,'bg','Ð¢ÐµÐ¼Ð¿ÐµÑ€Ð°Ñ‚ÑƒÑ€Ð° Ð½Ð° Ð´Ð¸ÑÐ¿Ð»ÐµÑ',0),(286675,7964,'ur','Ø¯Ø±Ø¬Û Ø­Ø±Ø§Ø±Øª Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(286676,7964,'sr','Ð¢ÐµÐ¼Ð¿ÐµÑ€Ð°Ñ‚ÑƒÑ€Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°',0),(286677,7964,'vi','Hiá»ƒn thá»‹ nhiá»‡t Ä‘á»™',0),(286678,7964,'af','Temperatuur Wys in',0),(286679,7964,'ro','Temperatura de afiÅŸare',0),(286680,7964,'et','Temperatuuriskaala',0),(286681,7964,'si','Prikaz temperature',0),(286682,7964,'ba','Tampilan suhu',0),(286683,7964,'nl','Temperatuurdisplay',0),(286684,7964,'fi','LÃ¤mpÃ¶mittari',0),(286685,7964,'no','Temperaturdisplay',0),(286686,7964,'da','Temperaturdisplay',0),(286687,7964,'ko','ì˜¨ë„ í‘œì‹œ',0),(286688,7964,'he','×ª×¦×•×’×ª ×˜×ž×¤×¨×˜×•×¨×”',0),(286689,7964,'el','Î•Ï€Î¯Î´ÎµÎ¹Î¾Î· Î¸ÎµÏÎ¼Î¿ÎºÏÎ±ÏƒÎ¯Î±Ï‚',0),(286690,7964,'zh','æ¸©åº¦æ˜¾ç¤º\r\n',0),(286691,7964,'sv','Temperatur Display',0),(286692,7964,'it','Visualizzazione della temperatura',0),(286693,7964,'tl','',0),(286694,7964,'th','&#3649;&#3626;&#3604;&#3591;&#3629;&#3640;&#3603;&#3627;&#3616;&#3641;&#3617;&#3636;',0),(286695,7964,'hi','à¤¤à¤¾à¤ªà¤®à¤¾à¤¨ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨',0),(286696,7964,'ms','Paparan suhu',0),(286697,7964,'ar','Ø¹Ø±Ø¶ Ø¯Ø±Ø¬Ø© Ø§Ù„Ø­Ø±Ø§Ø±Ø©',0),(286698,7964,'fr','Affichage de la tempÃ©rature',0),(286699,7964,'jp','æ¸©åº¦è¡¨ç¤º',0),(286700,7964,'pt','Display de temperatura',0),(286701,7964,'ru','ÐŸÐ¾ÐºÐ°Ð· Ð¢ÐµÐ¼Ð¿ÐµÑ€Ð°Ñ‚ÑƒÑ€Ñ‹',0),(286702,7964,'es','Despliegue de Temperatura',0),(286703,7964,'de','Temperaturanzeige',0),(286704,7964,'en','Temperature Display',0),(286705,7965,'is','',0),(286706,7965,'dr','ÙƒØ¯Ù¾Ø³ØªÙŠ Ø¢Ù…Ø±ÙŠÙƒØ§ ÙŠØ§ ÙƒØ¯ Ù…ÙˆÙ‚Ø¹ÙŠØª Ù…ÙƒØ§Ù†ÙŠ ÙŠØ§Ù‡Ùˆ  Ø¨Ø±Ø§ÙŠ  ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ÙˆØ¶Ø¹ÙŠØª Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§ ',0),(286707,7965,'pr','ÙƒØ¯Ù¾Ø³ØªÙŠ Ø¢Ù…Ø±ÙŠÙƒØ§ ÙŠØ§ ÙƒØ¯ Ù…ÙˆÙ‚Ø¹ÙŠØª Ù…ÙƒØ§Ù†ÙŠ ÙŠØ§Ù‡Ùˆ  Ø¨Ø±Ø§ÙŠ  ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ÙˆØ¶Ø¹ÙŠØª Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§ ',0),(286708,7965,'tr','ABD ZIP Kodu veya Yahoo konum kodu<br>Ana sayfa hava iÃ§in',0),(286709,7965,'pl','Kod pocztowy lub Yahoo kod lokalizacji<br>Strona domowa Pogoda',0),(286710,7965,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´ Ð¸Ð»Ð¸ ÐºÐ¾Ð´ Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° Yahoo<br>Ð·Ð° Ð²Ñ€ÐµÐ¼ÐµÑ‚Ð¾ Ð½Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(286711,7965,'ur','US Ø²Ù¾ Ú©ÙˆÚˆ ÛŒØ§ ÛŒØ§ÛÙˆ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©ÙˆÚˆ<br>ÛÙˆÙ… Ù¾ÛŒØ¬ Ú©Û’ Ù…ÙˆØ³Ù… Ú©Û’ Ù„ÛŒÛ’',0),(286712,7965,'sr','ÐÐœÐ•Ð Ð˜Ð§ÐšÐ˜ ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜ Ð¸Ð»Ð¸ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð° YÐ°Ñ…Ð¾Ð¾<br>Ð²Ñ€ÐµÐ¼ÐµÐ½ÑÐºÐ° Ð¿Ñ€Ð¾Ð³Ð½Ð¾Ð·Ð° Ð·Ð° Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(286713,7965,'vi','Zip Code táº¡i Má»¹ hay MÃ£ vá»‹ trÃ­ Yahoo cho trang chá»§ dá»± bÃ¡o thá»i tiáº¿t',0),(286714,7965,'af','VSA Poskode of Yahoo Lokaliteitskode<br /> vir Tuisblad Weer',0),(286715,7965,'ro','Codul U.S. Zip sau un cod de locaÅ£ie Yahoo<br>pentru pagina de start vreme',0),(286716,7965,'et','Yahoo asukoha kood<br /> Pealehel ilma kuvamiseks',0),(286717,7965,'si','PoÅ¡tna Å¡tevilka ali Å¡ifra lokacije Yahoo<br>za domaÄo stran vreme',0),(286718,7965,'ba','US kode pos atau Yahoo lokasi kode<br>Cuaca halaman rumah',0),(286719,7965,'nl','Amerikaanse postcode of Yahoo vestigingscode<br>voor introductiepagina weer',0),(286720,7965,'fi','Viivakoodin tai Yahoo Sijaintikoodi<br>Kotisivun SÃ¤Ã¤',0),(286721,7965,'no','Amerikansk postnummer eller Yahoo koden<br>for hjemmesiden VÃ¦r',0),(286722,7965,'da','Amerikanske postnummer eller Yahoo lokationskode<br>Hjemmeside vejret',0),(286723,7965,'ko','ë¯¸êµ­ ìš°íŽ¸ ë²ˆí˜¸ ë˜ëŠ” ì•¼ í›„ ìœ„ì¹˜ ì½”ë“œ<br>í™ˆíŽ˜ì´ì§€ ë‚ ì”¨',0),(286724,7965,'he','××¨×” ×‘ ×ž×™×§×•×“ ××• ×™××”×• ×ž×™×§×•× ×§×•×“<br>×“×£ ×”×‘×™×ª ×‘×ž×–×’ ×”××•×•×™×¨',0),(286725,7965,'el','Î¤Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚ Î—Î Î‘ Î® Ï„Î¿ Yahoo ÎºÏ‰Î´Î¹ÎºÏŒ Î±Ï€Î¿Î¸Î®ÎºÎ·Ï‚<br>Î‘ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î± ÎºÎ±Î¹ÏÎ¿Ï',0),(286726,7965,'zh','ç¾Žå›½é‚®æ”¿ç¼–ç æˆ–é›…è™Žåœ°ç‚¹ä»£ç ä¸ºé¦–é¡µå¤©æ°”\r\n',0),(286727,7965,'sv','Amerikanska postnummer eller Yahoo lagerstÃ¤llekod<br>fÃ¶r hemsidan vÃ¤der',0),(286728,7965,'it','Codice di avviamento postale degli Stati Uniti o codice ubicazione Yahoo<br>per la Home Page meteo',0),(286729,7965,'tl','',0),(286730,7965,'th','US Zip Code or Yahoo Location Code<br /> for Home Page Weather',0),(286731,7965,'hi','à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ à¤œà¤¼à¤¿à¤ª à¤•à¥‹à¤¡ à¤¯à¤¾ à¤¯à¤¾à¤¹à¥‚ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‹à¤¡<br>à¤®à¥à¤– à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥Œà¤¸à¤®',0),(286732,7965,'ms','Kod Zip AS atau kod lokasi Yahoo<br>untuk halaman rumah cuaca',0),(286733,7965,'ar','Ø±Ù…Ø² Ø§Ù„Ù…ÙˆÙ‚Ø¹ (ÙŠØ§Ù‡ÙˆÙˆ) Ù„Ø¥Ø³ØªØ¹Ù…Ø§Ù„ Ø­Ø§Ù„Ø© Ø§Ù„Ø·Ù‚Ø³ ÙÙŠ Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(286734,7965,'fr','US Zip Code ou Code de localisation de Yahoo<br>Page d\'accueil mÃ©tÃ©o',0),(286735,7965,'jp','ç±³å›½ã®éƒµä¾¿ç•ªå·ã¾ãŸã¯ Yahoo å ´æ‰€ã‚³ãƒ¼ãƒ‰<br>ãƒ›ãƒ¼ãƒ  ãƒšãƒ¼ã‚¸å¤©æ°—',0),(286736,7965,'pt','EUA CEP ou cÃ³digo de localizaÃ§Ã£o do Yahoo<br>por causa do tempo Home Page',0),(286737,7965,'ru','Ð¡Ð¨Ð Zip ÐºÐ¾Ð´ Ð¸Ð»Ð¸ ÐºÐ¾Ð´ ÑÐºÐ»Ð°Ð´Ð° Yahoo<br>Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐŸÐ¾Ð³Ð¾Ð´Ð°',0),(286738,7965,'es','CÃ³digo Postal US o Codogo de UbicaciÃ³n de Yahoo<br /> para Informes MeteorolÃ³gico  de PÃ¡gina de Hogar ',0),(286739,7965,'de','Postleitzahl oder Yahoo Location Code<br>fÃ¼r Homepage-Wetter',0),(286740,7965,'en','US Zip Code or Yahoo Location Code<br /> for Home Page Weather',0),(286741,7966,'is','',0),(286742,7966,'dr','. Ø§Ø² Ù‚Ø³Ù…Øª Ø§ØµÙ„ÙŠ Ø²Ø¨Ø§Ù† Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ´ØªÙ† ØµÙØ­Ø§Øª Ùˆ Ø³Ø§ÙŠØª Ù‡Ø§ Ø¯Ø± Ø§ÙŠÙ†ØªØ±Ù†Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(286743,7966,'pr','ÙˆÙ‚ØªÙŠ Ø§Ø² Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§ÙŠ Ù…Ø­Ù„ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ . Ø§Ø² Ù‚Ø³Ù…Øª Ø§ØµÙ„ÙŠ Ø²Ø¨Ø§Ù† Ø¨Ø±Ø§ÙŠ Ù†ÙˆØ´ØªÙ† ØµÙØ­Ø§Øª Ùˆ Ø³Ø§ÙŠØª Ù‡Ø§ Ø¯Ø± Ø§ÙŠÙ†ØªØ±Ù†Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(286744,7966,'tr','Ana parÃ§asÄ± HTML kullandÄ±ÄŸÄ±nÄ±zda, yerel hava durumu gÃ¶rÃ¼ntÃ¼leme',0),(286745,7966,'pl','Kiedy wyÅ›wietlanie lokalnego Pogoda korzystaÄ‡ z gÅ‚Ã³wnÄ… czÄ™Å›ciÄ… HTML',0),(286746,7966,'bg','ÐšÐ¾Ð³Ð°Ñ‚Ð¾ Ñ€Ð°Ð·Ð³Ð»ÐµÐ¶Ð´Ð°Ñ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ Ð¼ÐµÑÑ‚Ð½Ð¸Ñ‚Ðµ Ð¼ÐµÑ‚ÐµÐ¾Ñ€Ð¾Ð»Ð¾Ð³Ð¸Ñ‡Ð½Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ñ‡Ð°ÑÑ‚ Ð½Ð° HTML',0),(286747,7966,'ur','Ø¬Ø¨ HTML Ú©Û’ Ù…Ø±Ú©Ø²ÛŒ Ø­ØµÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ù¾Ù†Û’ Ù…Ù‚Ø§Ù…ÛŒ Ù…ÙˆØ³Ù… Ú©Û’ Ù†Ø¸Ø§Ø±Û’',0),(286748,7966,'sr','ÐšÐ°Ð´Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ðµ Ð»Ð¾ÐºÐ°Ð»Ð½Ñƒ Ð¿Ñ€Ð¾Ð³Ð½Ð¾Ð·Ñƒ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð³Ð»Ð°Ð²Ð½Ð¸ Ð´ÐµÐ¾ Ð¥Ð¢ÐœÐ›',0),(286749,7966,'vi','DÃ¹ng pháº§n chÃ­nh cá»§a HTML Ä‘á»ƒ xem thá»i tiáº¿t táº¡i khu vá»±c cá»§a báº¡n ',0),(286750,7966,'af','Wanneer U Plaaslike Weer Besigting word Gebruik Hoof deel van BA (\"HTML\")',0),(286751,7966,'ro','CÃ¢nd vizualizarea dumneavoastrÄƒ Local vreme folosesc partea principalÄƒ a HTML',0),(286752,7966,'et','*When Viewing Your Local Weather Use Main Part Of HTML',0),(286753,7966,'si','Ogled lokalnih vremenskih kdaj uporabite glavni del HTML',0),(286754,7966,'ba','Ketika melihat cuaca lokal Anda menggunakan bagian utama dari HTML',0),(286755,7966,'nl','Wanneer uw lokale weer bekijken gebruiken hoofdgedeelte van HTML',0),(286756,7966,'fi','Kun paikallinen sÃ¤Ã¤ jotka kÃ¤yttÃ¤vÃ¤t pÃ¤Ã¤osan HTML',0),(286757,7966,'no','NÃ¥r viser din lokale vÃ¦r bruker hoveddelen av HTML',0),(286758,7966,'da','NÃ¥r visning af din lokale vejr bruger hovedparten af HTML',0),(286759,7966,'ko','ë•Œ ë‹¹ì‹ ì˜ ì§€ì—­ ë‚ ì”¨ë¥¼ ë³´ê¸° ì‚¬ìš© í•˜ ì—¬ HTMLì˜ ì£¼ìš” ë¶€ë¶„',0),(286760,7966,'he','×ž×ª×™ ×‘×ž×œ×•× ×•×ª ×œ×ž×–×’ ×”××•×•×™×¨ ×”×ž×§×•×ž×™ ×©×œ×š ×œ×”×©×ª×ž×© ×”×—×œ×§ ×”×¢×™×§×¨×™ ×©×œ HTML',0),(286761,7966,'el','ÎŒÏ„Î±Î½ Î²Î»Î­Ï€Î¿Ï…Î½ Ï„Î¹Ï‚ Ï„Î¿Ï€Î¹ÎºÎ­Ï‚ ÎºÎ±Î¹ÏÎ¹ÎºÎ­Ï‚ ÏƒÏ…Î½Î¸Î®ÎºÎµÏ‚ Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î¿ ÎºÏÏÎ¹Î¿ Î¼Î­ÏÎ¿Ï‚ Ï„Î·Ï‚ HTML',0),(286762,7966,'zh','å½“æŸ¥çœ‹æ‚¨çš„å¤©æ°”é¢„æŠ¥ä½¿ç”¨çš„HTMLä¸»ä½“\r\n',0),(286763,7966,'sv','NÃ¤r som tittar pÃ¥ din lokala vÃ¤der anvÃ¤nda huvuddelen av HTML',0),(286764,7966,'it','Quando visualizzare il meteo locale utilizza la parte principale del HTML',0),(286765,7966,'tl','',0),(286766,7966,'th','When Viewing Your Local Weather Use Main Part Of HTML',0),(286767,7966,'hi','à¤œà¤¬ à¤®à¥à¤–à¥à¤¯ à¤­à¤¾à¤— HTML à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤†à¤ªà¤•à¥‡ à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤®à¥Œà¤¸à¤® à¤¦à¥‡à¤– à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤µà¥‹',0),(286768,7966,'ms','Apabila melihat cuaca tempatan menggunakan bahagian utama HTML',0),(286769,7966,'ar','Ø¹Ù†Ø¯ Ø¹Ø±Ø¶ Ø­Ø§Ù„Ø© Ø§Ù„Ø·Ù‚Ø³ Ø§Ù„Ù…Ø­Ù„ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¬Ø²Ø¡ Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ Ù…Ù† Ø¥ØªØ´ ØªÙŠ Ø£Ù… Ø§Ù„',0),(286770,7966,'fr','Quand Regarde un votre mÃ©tÃ©o locale utilisent la partie principale du HTML',0),(286771,7966,'jp','ã¨ãã‚ãªãŸã®åœ°å…ƒã®å¤©æ°—äºˆå ±ã‚’è¡¨ç¤ºã™ã‚‹ HTML ã®ä¸»è¦éƒ¨åˆ†ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(286772,7966,'pt','Quando que visualizaram o seu clima Local usa a parte principal do HTML',0),(286773,7966,'ru','ÐšÐ¾Ð³Ð´Ð° Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð²Ð°ÑˆÐµÐ¹ Ð¼ÐµÑÑ‚Ð½Ð¾Ð¹ Ð¿Ð¾Ð³Ð¾Ð´Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¾ÑÐ½Ð¾Ð²Ð½ÑƒÑŽ Ñ‡Ð°ÑÑ‚ÑŒ HTML',0),(286774,7966,'es','Cuando Visionar su Clima Local Usar la Parte Prinicpal de HTML',0),(286775,7966,'de','Wenn Ihr lokale Wetter anzeigen Hauptteil der HTML verwenden',0),(286776,7966,'en','When Viewing Your Local Weather Use Main Part Of HTML',0),(286777,7967,'is','',0),(286778,7967,'dr','- Ù¾ÙŠ  Ø¨Ø§ Ø³Ø±ØµÙØ­Ù‡ Ø³Ø± ØªØ§ Ø³Ø±  Ø¹Ø±Ø¶ ',0),(286779,7967,'pr',' Ù…Ø¯Ù„ Ø§ÙƒØ³- Ù¾ÙŠ  Ø¨Ø§ Ø³Ø±ØµÙØ­Ù‡ Ø³Ø± ØªØ§ Ø³Ø±  Ø¹Ø±Ø¶ ',0),(286780,7967,'tr','XP tarzÄ± tam geniÅŸliÄŸi boyunca baÅŸlÄ±ÄŸÄ± ile',0),(286781,7967,'pl','XP-styl nagÅ‚Ã³wka na peÅ‚nej szerokoÅ›ci',0),(286782,7967,'bg','XP-ÑÑ‚Ð¸Ð» Ñ Ð³Ð¾Ñ€ÐµÐ½ ÐºÐ¾Ð»Ð¾Ð½Ñ‚Ð¸Ñ‚ÑƒÐ» Ð² Ð¿ÑŠÐ»Ð½Ð° ÑˆÐ¸Ñ€Ð¸Ð½Ð°',0),(286783,7967,'ur','Ø§ÛŒÚ©Ø³ Ù¾ÛŒ Ø·Ø±Ø² Ø³Ø±ØªØ­Ø±ÛŒØ± Ø¨Ú¾Ø± Ù¾ÙˆØ±ÛŒ Ú†ÙˆÚ‘Ø§Ø¦ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾',0),(286784,7967,'sr','XÐŸ -ÑÑ‚Ð¸Ð» ÑÐ° Ð·Ð°Ð³Ð»Ð°Ð²Ñ™ÐµÐ¼ Ð¿Ñ€ÐµÐºÐ¾ Ð¿ÑƒÐ½Ðµ ÑˆÐ¸Ñ€Ð¸Ð½Ðµ',0),(286785,7967,'vi','Kiá»ƒu XP vá»›i tiÃªu Ä‘á» cháº¡y ngang chiá»u rá»™ng',0),(286786,7967,'af','XP-Styl met Kop Regoor Volle Wydte',0),(286787,7967,'ro','XP STYLE cu antet Ã®n Ã®ntreaga lÄƒÅ£ime maximÄƒ',0),(286788,7967,'et','XP-Style pÃ¤isega',0),(286789,7967,'si','XP-stil z glavo Äez celotno Å¡irino',0),(286790,7967,'ba','Gaya XP dengan Header di seluruh lebar penuh',0),(286791,7967,'nl','XP-stijl met Header over volledige breedte',0),(286792,7967,'fi','XP-tyyli otsikon koko koko leveys',0),(286793,7967,'no','XP-stil med overskriften over Full bredde',0),(286794,7967,'da','XP-stil med hovedet over fuld bredde',0),(286795,7967,'ko','ì „ì²´ ë„ˆë¹„ì— ê±¸ì³ í—¤ë”ë¡œ XP ìŠ¤íƒ€ì¼',0),(286796,7967,'he','XP ×‘×¡×’× ×•×Ÿ ×¢× ×›×•×ª×¨×ª ×¢×œ ×¤× ×™ ×¨×•×—×‘ ×ž×œ×',0),(286797,7967,'el','XP-ÏƒÏ„Ï…Î» Î¼Îµ ÎºÎµÏ†Î±Î»Î¯Î´Î± ÏƒÎµ ÏŒÎ»Î¿ Ï„Î¿ Ï€Î»Î¬Ï„Î¿Ï‚',0),(286798,7967,'zh','æœ‰è·¨è¶Šå…¨å®½é¡µçœ‰çš„XPé£Žæ ¼\r\n',0),(286799,7967,'sv','XP-stil med huvudet Ã¶ver Full bredd',0),(286800,7967,'it','XP-stile con intestazione attraverso tutto',0),(286801,7967,'tl','',0),(286802,7967,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610; XP &#3604;&#3657;&#3623;&#3618;&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;&#3607;&#3634;&#3591;&#3586;&#3623;&#3634;&#3591;&#3648;&#3605;&#3655;&#3617;&#3588;&#3623;&#3634;&#3617;&#3585;&#3623;&#3657;&#3634;&#3591',0),(286803,7967,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ à¤•à¥‡ à¤ªà¤¾à¤° à¤¶à¥€à¤°à¥à¤· à¤²à¥‡à¤– à¤•à¥‡ à¤¸à¤¾à¤¥ XP à¤¶à¥ˆà¤²à¥€',0),(286804,7967,'ms','XP-gaya dengan pengepala merentasi lebar penuh',0),(286805,7967,'ar','Ù†Ù…Ø· Ø¥ÙƒØ³ Ø¨ÙŠ Ù…Ø¹ Ù‚Ø§Ø¦Ù…Ø© Ø±Ø£Ø³ÙŠØ© - Ø¹Ø±Ø¶ ÙƒØ§Ù…Ù„',0),(286806,7967,'fr','Style XP avec en-tÃªte sur toute la largeur',0),(286807,7967,'jp','å…¨å¹…ã«ã‚ãŸã£ã¦ãƒ˜ãƒƒãƒ€ãƒ¼ã§ XP ã‚¹ã‚¿ã‚¤ãƒ«',0),(286808,7967,'pt','XP-estilo com cabeÃ§alho atravÃ©s de largura total',0),(286809,7967,'ru','XP-ÑÑ‚Ð¸Ð»ÑŒ Ñ Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²ÐºÐ¾Ð¼ Ð¿Ð¾ Ð²ÑÐµÐ¹ ÑˆÐ¸Ñ€Ð¸Ð½Ðµ',0),(286810,7967,'es','Estilo XP con encabezado a todo lo ancho',0),(286811,7967,'de','XP-Stil mit Header Ã¼ber gesamte Breite',0),(286812,7967,'en','XP-Style with Header Across Full Width',0),(286813,7968,'is','',0),(286814,7968,'dr','- Ù¾ÙŠ  Ø¨Ø§ Ù…Ù†ÙˆÙŠ ÙƒÙ†Ø§Ø±ÙŠ  Ø³Ø± ØªØ§ Ø³Ø±  Ø·ÙˆÙ„',0),(286815,7968,'pr','Ù…Ø¯Ù„ Ø§ÙƒØ³- Ù¾ÙŠ  Ø¨Ø§ Ù…Ù†ÙˆÙŠ ÙƒÙ†Ø§Ø±ÙŠ  Ø³Ø± ØªØ§ Ø³Ø±  Ø·ÙˆÙ„',0),(286816,7968,'tr','XP tarzÄ± ile yan menÃ¼ tam yÃ¼kseklikte',0),(286817,7968,'pl','XP-styl z Menu strony peÅ‚nej wysokoÅ›ci',0),(286818,7968,'bg','XP-ÑÑ‚Ð¸Ð» Ñ Ð¼ÐµÐ½ÑŽ Ð¿ÑŠÐ»Ð½Ð° Ð²Ð¸ÑÐ¾Ñ‡Ð¸Ð½Ð°',0),(286819,7968,'ur','Ø§ÛŒÚ©Ø³ Ù¾ÛŒ Ø·Ø±Ø² Ú©ÛŒ Ø·Ø±Ù Ù…ÛŒÙ†Ùˆ Ù…Ú©Ù…Ù„ Ø¨Ù„Ù†Ø¯ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾',0),(286820,7968,'sr','XÐŸ -ÑÑ‚Ð¸Ð» ÑÐ° ÑÑ‚Ñ€Ð°Ð½Ðµ Ð¼ÐµÐ½Ð¸Ñ˜Ð° Ð¿ÑƒÐ½Ðµ Ð²Ð¸ÑÐ¸Ð½Ðµ',0),(286821,7968,'vi','Kiá»ƒu XP vá»›i thanh trÃ¬nh Ä‘Æ¡n cháº¡y dá»c háº¿t chiá»u cao',0),(286822,7968,'af','XP-Styl met Kant-Indekste tot die Volle Hoogte Gestel',0),(286823,7968,'ro','XP-Style cu partea meniul de Ã®nÄƒlÅ£ime completÄƒ',0),(286824,7968,'et','XP-Style kÃ¼lgmenÃ¼Ã¼ga',0),(286825,7968,'si','XP-stil s strani meni celotna viÅ¡ina',0),(286826,7968,'ba','Gaya XP dengan sisi Menu ketinggian penuh',0),(286827,7968,'nl','XP-stijl met Side Menu volledige hoogte',0),(286828,7968,'fi','XP-tyyliin Side Menu harjakorkeuteen',0),(286829,7968,'no','XP-stil med Side meny Full hÃ¸yde',0),(286830,7968,'da','XP-stil med Side Menu fuld hÃ¸jde',0),(286831,7968,'ko','ì‚¬ì´ë“œ ë©”ë‰´ ì „ì²´ ë†’ì´ XP ìŠ¤íƒ€ì¼',0),(286832,7968,'he','XP ×‘×¡×’× ×•×Ÿ ×¢× ×ª×¤×¨×™×˜ ×¦×“ ×‘×’×•×‘×” ×ž×œ×',0),(286833,7968,'el','XP-ÏƒÏ„Ï…Î» Î¼Îµ Ï€Î»ÎµÏ…ÏÎ¬ Î¼ÎµÎ½Î¿Ï Ï€Î»Î®ÏÎµÏ‚ ÏÏˆÎ¿Ï‚',0),(286834,7968,'zh','æœ‰å…¨é«˜ä¾§è¾¹èœå•çš„XPé£Žæ ¼\r\n',0),(286835,7968,'sv','XP-stil med sidan menyn Full hÃ¶jd',0),(286836,7968,'it','XP-stile con altezza completa di Menu laterale',0),(286837,7968,'tl','',0),(286838,7968,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610; XP &#3604;&#3657;&#3623;&#3618;&#3648;&#3617;&#3609;&#3641;&#3604;&#3657;&#3634;&#3609;&#3586;&#3657;&#3634;&#3591;&#3648;&#3605;&#3655;&#3617;&#3588;&#3623;&#3634;&#3617;&#3626;&#3641;&#3591;',0),(286839,7968,'hi','XP-à¤¶à¥ˆà¤²à¥€ à¤•à¥€ à¤“à¤° à¤®à¥‡à¤¨à¥‚ à¤ªà¥‚à¤°à¥à¤£ à¤Šà¤à¤šà¤¾à¤ˆ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(286840,7968,'ms','XP-gaya dengan ketinggian penuh Menu sampingan',0),(286841,7968,'ar','Ù†Ù…Ø· Ø¥ÙƒØ³ Ø¨ÙŠ Ù…Ø¹ Ù‚Ø§Ø¦Ù…Ø© Ø¬Ø§Ù†Ø¨ÙŠØ© - Ø·ÙˆÙ„ ÙƒØ§Ù…Ù„',0),(286842,7968,'fr','Style XP avec Side Menu pleine hauteur',0),(286843,7968,'jp','XP ã‚¹ã‚¿ã‚¤ãƒ« ã‚µã‚¤ãƒ‰ ãƒ¡ãƒ‹ãƒ¥ãƒ¼å®Œå…¨ãªé«˜ã•',0),(286844,7968,'pt','XP-estilo com altura total de Menu lateral',0),(286845,7968,'ru','XP-ÑÑ‚Ð¸Ð»Ñ Ñ Ð¼ÐµÐ½ÑŽ Ð¿Ð¾Ð»Ð½Ð°Ñ Ð²Ñ‹ÑÐ¾Ñ‚Ð°',0),(286846,7968,'es','Estilo XP menu de lado altura completa',0),(286847,7968,'de','XP-Stil mit MenÃ¼ volle SeitenhÃ¶he',0),(286848,7968,'en','XP-Style with Side Menu Full Height',0),(286849,7969,'is','',0),(286850,7969,'dr','(Ù…Ø«Ø§Ù„) Ø§Ø³Øª ',0),(286851,7969,'pr','ÙƒØ¯ Ø´Ù…Ø§ Ø¯Ø± Ù†Ù…ÙˆÙ†Ù‡(Ù…Ø«Ø§Ù„) Ø§Ø³Øª ',0),(286852,7969,'tr','Ã–rnek kodudur',0),(286853,7969,'pl','Kod w przykÅ‚adzie jest',0),(286854,7969,'bg','Ð’Ð°ÑˆÐ¸ÑÑ‚ ÐºÐ¾Ð´ Ð² Ð¿Ñ€Ð¸Ð¼ÐµÑ€ Ðµ',0),(286855,7969,'ur','Ù…Ø«Ø§Ù„ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù…ÛŒÚº Ø§Ù¾Ù†Û’ Ø¶Ø§Ø¨Ø·Û ÛÛ’',0),(286856,7969,'sr','ÐšÃ´Ð´ Ñƒ Ð¿Ñ€Ð¸Ð¼ÐµÑ€Ñƒ Ñ˜Ðµ',0),(286857,7969,'vi','MÃ£ cá»§a báº¡n trong vÃ­ dá»¥ lÃ ',0),(286858,7969,'af','U Kode IN DIE VOORBEELD is',0),(286859,7969,'ro','Codul Ã®n exemplu este',0),(286860,7969,'et','Sinu kood nÃ¤iteks on',0),(286861,7969,'si','Kodo na primer je',0),(286862,7969,'ba','Kode Anda dalam contoh',0),(286863,7969,'nl','Uw Code In het volgende voorbeeld Is',0),(286864,7969,'fi','EsimerkissÃ¤ koodi on',0),(286865,7969,'no','Koden i eksemplet er',0),(286866,7969,'da','Din kode i eksempel er',0),(286867,7969,'ko','ì˜ˆì œì—ì„œ ì½”ë“œëŠ”',0),(286868,7969,'he','××ª ×”×§×•×“ ×‘×“×•×’×ž×” ×”×•×',0),(286869,7969,'el','Î¤Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ ÏƒÎ±Ï‚ ÏƒÏ„Î¿ Ï€Î±ÏÎ¬Î´ÎµÎ¹Î³Î¼Î± ÎµÎ¯Î½Î±Î¹',0),(286870,7969,'zh','æ‚¨åœ¨ç¤ºä¾‹ä»£ç \r\n',0),(286871,7969,'sv','Koden i exemplet Ã¤r',0),(286872,7969,'it','Nell\'esempio di codice Ã¨',0),(286873,7969,'tl','',0),(286874,7969,'th','&#3619;&#3627;&#3633;&#3626;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3605;&#3633;&#3623;&#3629;&#3618;&#3656;&#3634;&#3591;&#3588;&#3639;&#3629;',0),(286875,7969,'hi','à¤…à¤ªà¤¨à¥‡ à¤•à¥‹à¤¡ à¤‰à¤¦à¤¾à¤¹à¤°à¤£ à¤®à¥‡à¤‚ à¤¹à¥ˆ',0),(286876,7969,'ms','Kod anda dalam contoh',0),(286877,7969,'ar','Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© ÙÙŠ Ø§Ù„Ù…Ø«Ø§Ù„',0),(286878,7969,'fr','Votre Code dans l\'exemple est',0),(286879,7969,'jp','ã‚ãªãŸã®ã‚³ãƒ¼ãƒ‰ä¾‹ã§ã¯',0),(286880,7969,'pt','Seu cÃ³digo no exemplo Ã©',0),(286881,7969,'ru','Ð’Ð°Ñˆ ÐºÐ¾Ð´ Ð² Ð¿Ñ€Ð¸Ð¼ÐµÑ€Ðµ',0),(286882,7969,'es','Su cÃ³idigo de ejemplo es',0),(286883,7969,'de','Der Code im Beispiel ist',0),(286884,7969,'en','Your Code In Example Is',0),(286885,7970,'is','',0),(286886,7970,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ù…ØªÙˆØ§Ù„ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯',0),(286887,7970,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ù…ØªÙˆØ§Ù„ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯',0),(286888,7970,'tr','SÄ±ra numarasÄ± kullanmak iÃ§in burayÄ± tÄ±klatÄ±n',0),(286889,7970,'pl','Kliknij tutaj, aby uÅ¼yÄ‡ numeru sekwencji',0),(286890,7970,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð¿Ð¾Ñ€ÐµÐ´Ð½Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€',0),(286891,7970,'ur','ØªØ³Ù„Ø³Ù„ Ù†Ù…Ø¨Ø± Ú©Ùˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(286892,7970,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ð»Ð¸ Ð±Ñ€Ð¾Ñ˜ ÑÐµÐºÐ²ÐµÐ½Ñ†Ðµ',0),(286893,7970,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ láº¥y sá»‘ thá»© tá»±',0),(286894,7970,'af','Klik hier om te gebruik volgorde nommer',0),(286895,7970,'ro','Click aici pentru a utiliza numÄƒrul de secvenÈ›Äƒ',0),(286896,7970,'et','Vajuta siia, et kasutada seerianumber',0),(286897,7970,'si','Kliknite tukaj za uporabo zaporedno Å¡tevilko',0),(286898,7970,'ba','Klik di sini untuk menggunakan urutan nomor',0),(286899,7970,'nl','Klik hier om te volgnummer gebruik',0),(286900,7970,'fi','Klikkaa tÃ¤stÃ¤ kÃ¤yttÃ¤Ã¤ jÃ¤rjestysnumero',0),(286901,7970,'no','Klikk her for Ã¥ bruke serienummer',0),(286902,7970,'da','Klik her for at bruge sekvensnummer',0),(286903,7970,'ko','ì‹œí€€ìŠ¤ ë²ˆí˜¸ë¥¼ ì‚¬ìš© í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(286904,7970,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×©×ª×ž×© ×ž×¡×¤×¨ ×¨×¦×£',0),(286905,7970,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±ÏÎ¾Ï‰Î½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(286906,7970,'zh','ç‚¹å‡»è¿™é‡Œä½¿ç”¨åºåˆ—å·\r\n',0),(286907,7970,'sv','Klicka hÃ¤r fÃ¶r att anvÃ¤nda sekvensnummer',0),(286908,7970,'it','Clicca qui per utilizzare il numero di sequenza',0),(286909,7970,'tl','',0),(286910,7970,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3621;&#3635;&#3604;&#3633;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;',0),(286911,7970,'hi','à¤…à¤¨à¥à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(286912,7970,'ms','Klik di sini untuk menggunakan jujukan nombor',0),(286913,7970,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø±Ù‚Ù… ØªØ³Ù„Ø³Ù„',0),(286914,7970,'fr','Cliquez ici pour utiliser le numÃ©ro de sÃ©quence',0),(286915,7970,'jp','ã‚·ãƒ¼ã‚±ãƒ³ã‚¹ç•ªå·ã‚’ä½¿ç”¨ã™ã‚‹ã«ã¯ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(286916,7970,'pt','Clique aqui para utilizar o nÃºmero de seqÃ¼Ãªncia',0),(286917,7970,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ¾Ð²Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(286918,7970,'es','Click AquÃ­ para Usar NÃºmeros Secuenciales',0),(286919,7970,'de','Klicken Sie hier, um Sequenznummer verwenden',0),(286920,7970,'en','Click Here To Use Sequence Number',0),(286921,7971,'is','',0),(286922,7971,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ù† ',0),(286923,7971,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ù† ',0),(286924,7971,'tr','Benim Bilgisi DÃ¼zenle',0),(286925,7971,'pl','Edytuj moje dane',0),(286926,7971,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¼Ð¾ÑÑ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(286927,7971,'ur','Ù…ÛŒØ±ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(286928,7971,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¼Ð¾Ñ˜Ðµ Ð˜Ð½Ñ„Ð¾',0),(286929,7971,'vi','Sá»­a ThÃ´ng Tin Cá»§a TÃ´i',0),(286930,7971,'af','Redigeer My Inligting',0),(286931,7971,'ro','Editare meu Info',0),(286932,7971,'et','Redigeeri minu teavet',0),(286933,7971,'si','Uredite svoj Info',0),(286934,7971,'ba','Mengedit Info saya',0),(286935,7971,'nl','Mijn Info bewerken',0),(286936,7971,'fi','Edit My Info',0),(286937,7971,'no','Redigere min Info',0),(286938,7971,'da','Rediger min Info',0),(286939,7971,'ko','ë‚´ ì •ë³´ ìˆ˜ì •',0),(286940,7971,'he','×¢×¨×•×š ××ª ×”×ž×™×“×¢ ×©×œ×™',0),(286941,7971,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î¿Ï…',0),(286942,7971,'zh','ç¼–è¾‘æˆ‘çš„ä¿¡æ¯\r\n',0),(286943,7971,'sv','Redigera min information',0),(286944,7971,'it','Modificare le mie informazioni',0),(286945,7971,'tl','',0),(286946,7971,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3656;&#3623;&#3609;&#3605;&#3633;&#3623;',0),(286947,7971,'hi','à¤®à¥‡à¤°à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(286948,7971,'ms','Edit maklumat saya',0),(286949,7971,'ar','ØªØ­Ø±ÙŠØ± Ù…Ø¹Ù„ÙˆÙ…Ø§ØªÙŠ',0),(286950,7971,'fr','Ã‰diter mes Info',0),(286951,7971,'jp','ç§ã®æƒ…å ±ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(286952,7971,'pt','Editar a minha informaÃ§Ã£o',0),(286953,7971,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐœÐ¾ÑŽ Ð˜Ð½Ñ„Ð¾',0),(286954,7971,'es','Editar Mi Info',0),(286955,7971,'de','Meine Info bearbeiten',0),(286956,7971,'en','Edit My Info',0),(286957,7972,'is','',0),(286958,7972,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(286959,7972,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(286960,7972,'tr','Bilgi baÅŸarÄ±yla kaydedildi',0),(286961,7972,'pl','Informacji zapisane',0),(286962,7972,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(286963,7972,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(286964,7972,'sr','Ð˜Ð½Ñ„Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(286965,7972,'vi','Sao lÆ°u ThÃ´ng Tin thÃ nh cÃ´ng',0),(286966,7972,'af','Inligting Suksesvol Gestoor',0),(286967,7972,'ro','Info salvata cu succes',0),(286968,7972,'et','Info salvestati edukalt',0),(286969,7972,'si','Info uspeÅ¡no shranjen',0),(286970,7972,'ba','Info yang disimpan berhasil',0),(286971,7972,'nl','Info succesvol opgeslagen',0),(286972,7972,'fi','Info tallennettu',0),(286973,7972,'no','Informasjon lagret',0),(286974,7972,'da','Info gemt med succes',0),(286975,7972,'ko','ì •ë³´ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(286976,7972,'he','×”×ž×™×“×¢ × ×©×ž×¨ ×‘×”×¦×œ×—×”',0),(286977,7972,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(286978,7972,'zh','ä¿¡æ¯å·²æˆåŠŸä¿å­˜\r\n',0),(286979,7972,'sv','Information som sparats',0),(286980,7972,'it','Informazioni salvate correttamente',0),(286981,7972,'tl','',0),(286982,7972,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(286983,7972,'hi','à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(286984,7972,'ms','Maklumat yang berjaya disimpan',0),(286985,7972,'ar','Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(286986,7972,'fr','Infos enregistrÃ©es avec succÃ¨s',0),(286987,7972,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚ŒãŸæƒ…å ±',0),(286988,7972,'pt','InformaÃ§Ã£o com sucesso',0),(286989,7972,'ru','Ð˜Ð½Ñ„Ð¾ Ð£Ð¿ÐµÑˆÐ½Ð¾ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð°',0),(286990,7972,'es','Info Guardado Exitosamente',0),(286991,7972,'de','Info erfolgreich gespeichert',0),(286992,7972,'en','Info Saved Successfully',0),(286993,7973,'is','',0),(286994,7973,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ',0),(286995,7973,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ',0),(286996,7973,'tr','Oturum aÃ§ma',0),(286997,7973,'pl','ZgÅ‚oÅ› siÄ™ do systemu',0),(286998,7973,'bg','Ð’Ñ…Ð¾Ð´',0),(286999,7973,'ur','Ù„Ø§Ú¯ Ø§Ù†',0),(287000,7973,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð°',0),(287001,7973,'vi','ÄÄƒng nháº­p',0),(287002,7973,'af','Gebruiker',0),(287003,7973,'ro','Login',0),(287004,7973,'et','Kasutajanimi',0),(287005,7973,'si','Prijava',0),(287006,7973,'ba','Login',0),(287007,7973,'nl','Login',0),(287008,7973,'fi','Kirjaudu sisÃ¤Ã¤n',0),(287009,7973,'no','Logg inn',0),(287010,7973,'da','Login',0),(287011,7973,'ko','ë¡œê·¸ì¸',0),(287012,7973,'he','×›× ×™×¡×”',0),(287013,7973,'el','Î£ÏÎ½Î´ÎµÏƒÎ·',0),(287014,7973,'zh','ç™»å½•\r\n',0),(287015,7973,'sv','Logga in',0),(287016,7973,'it','Login',0),(287017,7973,'tl','',0),(287018,7973,'th','Login',0),(287019,7973,'hi','à¤²à¥‰à¤—à¤¿à¤¨',0),(287020,7973,'ms','Log masuk',0),(287021,7973,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(287022,7973,'fr','Login',0),(287023,7973,'jp','ãƒ­ã‚°ã‚¤ãƒ³',0),(287024,7973,'pt','Login',0),(287025,7973,'ru','Ð›Ð¾Ð³Ð¸Ð½:',0),(287026,7973,'es','Login',0),(287027,7973,'de','Login',0),(287028,7973,'en','Login',0),(287029,7974,'is','',0),(287030,7974,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡',0),(287031,7974,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡',0),(287032,7974,'tr','AracÄ±sÄ± KÄ±mlÄ±ÄŸÄ±',0),(287033,7974,'pl','Identyfikator agenta',0),(287034,7974,'bg','Ð˜Ð” Ð·Ð° Ð°Ð³ÐµÐ½Ñ‚',0),(287035,7974,'ur','Ø§ÛŒØ¬Ù†Ù¹ Ø´Ù†Ø§Ø®Øª',0),(287036,7974,'sr','Ð˜Ð” Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(287037,7974,'vi','ID Äáº¡i LÃ½',0),(287038,7974,'af','Agent ID',0),(287039,7974,'ro','Agent ID',0),(287040,7974,'et','Esindaja ID',0),(287041,7974,'si','Agent ID',0),(287042,7974,'ba','Agen ID',0),(287043,7974,'nl','Agent ID',0),(287044,7974,'fi','Matkatoimiston tunnus',0),(287045,7974,'no','Agent-ID',0),(287046,7974,'da','Agent-ID',0),(287047,7974,'ko','ì—ì´ì „íŠ¸ ID',0),(287048,7974,'he','×”×¡×•×›×Ÿ ×ž×–×”×”',0),(287049,7974,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î±',0),(287050,7974,'zh','ä»£ç†ID\r\n',0),(287051,7974,'sv','Agent-ID',0),(287052,7974,'it','ID agente',0),(287053,7974,'tl','',0),(287054,7974,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3586;&#3629;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(287055,7974,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ ID',0),(287056,7974,'ms','Ejen ID',0),(287057,7974,'ar','Ù…Ø¹Ø±Ù Ø¹Ø§Ù…Ù„',0),(287058,7974,'fr','ID d\'agent',0),(287059,7974,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆ ID',0),(287060,7974,'pt','Agente ID',0),(287061,7974,'ru','ID Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(287062,7974,'es','Agente ID',0),(287063,7974,'de','Agent-ID',0),(287064,7974,'en','Agent ID',0),(287065,7975,'is','',0),(287066,7975,'dr','(Ø³Ø§Ø²Ù…Ø§Ù† Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù‡ÙˆØ§ÙŠÙŠ Ø¨ÙŠÙ† Ø§Ù„Ù…Ù„Ù„ÙŠ ÙŠØ§ ...)TIDS)',0),(287067,7975,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡(Ø³Ø§Ø²Ù…Ø§Ù† Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù‡ÙˆØ§ÙŠÙŠ Ø¨ÙŠÙ† Ø§Ù„Ù…Ù„Ù„ÙŠ ÙŠØ§ ...)TIDS)',0),(287068,7975,'tr','AracÄ±sÄ± KÄ±mlÄ±ÄŸÄ± (IATA veya TID\'ler)',0),(287069,7975,'pl','Identyfikator agenta (IATA lub identyfikatory TID)',0),(287070,7975,'bg','Ð˜Ð” Ð·Ð° Ð°Ð³ÐµÐ½Ñ‚ (IATA Ð¸Ð»Ð¸ TIDS)',0),(287071,7975,'ur','Ø§ÛŒØ¬Ù†Ù¹ Ø´Ù†Ø§Ø®Øª (IATA ÛŒØ§ Ù¹Ø§Ø¯Ø³)',0),(287072,7975,'sr','Ð˜Ð” Ð°Ð³ÐµÐ½Ñ‚Ð° (\"Ð˜ÐÐ¢Ð\" Ð¸Ð»Ð¸ \"Ð¢Ð˜Ð”Ð¡\")',0),(287073,7975,'vi','ID Äáº¡i LÃ½(IATA hay TIDS)',0),(287074,7975,'af','Agent ID (IATA of TIDS)',0),(287075,7975,'ro','ID agent (IATA sau TIDS)',0),(287076,7975,'et','Esindaja ID (IATA vÃµi TIDS)',0),(287077,7975,'si','Agent ID (IATA ali TIDS)',0),(287078,7975,'ba','Agen ID (IATA atau TIDS)',0),(287079,7975,'nl','Agent ID (IATA of TIDS)',0),(287080,7975,'fi','Matkatoimiston tunnus (IATA tai TIDS)',0),(287081,7975,'no','Agent-ID (IATA eller TIDS)',0),(287082,7975,'da','Agent ID (IATA eller TIDS)',0),(287083,7975,'ko','ì—ì´ì „íŠ¸ ID IATA (TID)',0),(287084,7975,'he','×”×¡×•×›×Ÿ ×ž×–×”×” (IATA ××• TIDS)',0),(287085,7975,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î± (IATA Î® TIDS)',0),(287086,7975,'zh','ä»£ç†IDï¼ˆå›½é™…èˆªç©ºè¿è¾“åä¼šæˆ–ç»ˆç«¯ID)',0),(287087,7975,'sv','Agent-ID (IATA eller TIDS)',0),(287088,7975,'it','ID agente (IATA o TID)',0),(287089,7975,'tl','',0),(287090,7975,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3586;&#3629;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;(IATA or TIDS)',0),(287091,7975,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ ID (IATA à¤¯à¤¾ TIDS)',0),(287092,7975,'ms','Ejen ID (IATA atau TIDS)',0),(287093,7975,'ar','Ù…Ø¹Ø±Ù Ø¹Ø§Ù…Ù„ (Ø§ØªØ­Ø§Ø¯ Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¬ÙˆÙŠ Ø§Ù„Ø¯ÙˆÙ„ÙŠ Ø£Ùˆ TIDS)',0),(287094,7975,'fr','ID d\'agent (IATA ou TIDS)',0),(287095,7975,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆ ID (IATA ã¾ãŸã¯ TID)',0),(287096,7975,'pt','Agente ID (IATA ou TIDS)',0),(287097,7975,'ru','ID Ð°Ð³ÐµÐ½Ñ‚Ð° (IATA Ð¸Ð»Ð¸ TIDS)',0),(287098,7975,'es','Agente ID (IATA o TIDS)',0),(287099,7975,'de','Agent-ID (IATA oder TIDS)',0),(287100,7975,'en','Agent ID(IATA or TIDS)',0),(287101,7976,'is','',0),(287102,7976,'dr','Ø§ØµÙ„Ø§Ø­ Ø³Ù‡Ù… Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(287103,7976,'pr','Ø§ØµÙ„Ø§Ø­ Ø³Ù‡Ù… Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ ',0),(287104,7976,'tr','RevShare Agent aboneliÄŸi',0),(287105,7976,'pl','RevShare agenta rejestracji',0),(287106,7976,'bg','RevShare Ð°Ð³ÐµÐ½Ñ‚ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(287107,7976,'ur','Ø±ÛŒÙØ³Ø­Ø±ÛŒ Ø§ÛŒØ¬Ù†Ù¹ Ø³Ø§Ø¦Ù† Ø§Ù¾',0),(287108,7976,'sr','Ð ÐµÐ²Ð¡Ñ…Ð°Ñ€Ðµ ÐÐ³ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñƒ',0),(287109,7976,'vi','Äáº¡i lÃ½ RevShare Ä‘Äƒng kÃ½',0),(287110,7976,'af','RevShare Agent intekening',0),(287111,7976,'ro','Agent de RevShare Ã®nscriere',0),(287112,7976,'et','RevShare Agent registreerimine',0),(287113,7976,'si','RevShare Agent prijavo',0),(287114,7976,'ba','Daftar agen RevShare',0),(287115,7976,'nl','RevShare Agent Signup',0),(287116,7976,'fi','RevShare Agent kirjautuminen',0),(287117,7976,'no','RevShare Agent registrering',0),(287118,7976,'da','RevShare Agent tilmelding',0),(287119,7976,'ko','ê³µìœ  ì—ì´ì „íŠ¸ ê°€ìž…',0),(287120,7976,'he','RevShare ×¡×•×›×Ÿ ×”×¨×©×ž×”',0),(287121,7976,'el','RevShare Ï€ÏÎ¬ÎºÏ„Î¿ÏÎ± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(287122,7976,'zh','æ”¶ç›Šå…±äº«ä»£ç†ç«‹å³ç™»è®°\r\n',0),(287123,7976,'sv','RevShare Agent Signup',0),(287124,7976,'it','Agente RevShare Signup',0),(287125,7976,'tl','',0),(287126,7976,'th','&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3656;&#3623;&#3609;&#3649;&#3610;&#3656;&#3591;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(287127,7976,'hi','RevShare à¤à¤œà¥‡à¤‚à¤Ÿ à¤¸à¤¾à¤‡à¤¨à¤…à¤ª',0),(287128,7976,'ms','Pendaftaran ejen RevShare',0),(287129,7976,'ar','ØªØ³Ø¬ÙŠÙ„ ÙˆÙƒÙŠÙ„ RevShare',0),(287130,7976,'fr','RevShare Agent Signup',0),(287131,7976,'jp','æ–™é‡‘ä½“ç³»ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆ ã‚µã‚¤ãƒ³ã‚¢ãƒƒãƒ—',0),(287132,7976,'pt','Agente RevShare Signup',0),(287133,7976,'ru','RevShare Ð°Ð³ÐµÐ½Ñ‚Ð° Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸',0),(287134,7976,'es','Renta Compartir Agente InscripciÃ³n',0),(287135,7976,'de','RevShare Agent anmelden',0),(287136,7976,'en','RevShare Agent Signup',0),(287137,7977,'is','',0),(287138,7977,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ù…Ø±ÙˆØ² Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØªØ§Ø±ÙŠØ® Ù…Ø¹Ø§Ù…Ù„Ù‡ ',0),(287139,7977,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ù…Ø±ÙˆØ² Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØªØ§Ø±ÙŠØ® Ù…Ø¹Ø§Ù…Ù„Ù‡ ',0),(287140,7977,'tr','BugÃ¼n iÅŸlem tarihi olarak kullan',0),(287141,7977,'pl','UÅ¼ycie dziÅ› jako data transakcji',0),(287142,7977,'bg','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð½ÐµÑ ÐºÐ°Ñ‚Ð¾ Ð´Ð°Ñ‚Ð° Ð½Ð° ÑÐ´ÐµÐ»ÐºÐ°Ñ‚Ð°',0),(287143,7977,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø¢Ø¬',0),(287144,7977,'sr','Ð”Ð°Ð½Ð°Ñ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÐºÐ°Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(287145,7977,'vi','DÃ¹ng ngÃ y hÃ´m nay lÃ m ngÃ y giao dá»‹ch',0),(287146,7977,'af','Gebruik Vandag as Transaksiedatum',0),(287147,7977,'ro','Utilizarea azi ca data de tranzactie',0),(287148,7977,'et','Kasuta tÃ¤na kande kuupÃ¤ev',0),(287149,7977,'si','Uporaba danes kot datum transakcije',0),(287150,7977,'ba','Digunakan saat ini sebagai tanggal transaksi',0),(287151,7977,'nl','Gebruik vandaag als datum van transactie',0),(287152,7977,'fi','KÃ¤yttÃ¶ tÃ¤nÃ¤Ã¤n tapahtumapÃ¤ivÃ¤',0),(287153,7977,'no','Bruk i dag som transaksjonsdatoen',0),(287154,7977,'da','Bruges i dag som posteringsdato',0),(287155,7977,'ko','í˜„ìž¬ íŠ¸ëžœìž­ì…˜ ë‚ ì§œ ì‚¬ìš©',0),(287156,7977,'he','×”×©×™×ž×•×© ×”×™×•× ×›×ž×• ×ª××¨×™×š ×ª× ×•×¢×”',0),(287157,7977,'el','Î§ÏÎ®ÏƒÎ· ÏƒÎ®Î¼ÎµÏÎ± Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(287158,7977,'zh','ä½¿ç”¨ä»Šå¤©æ—¥æœŸä½œä¸ºäº¤æ˜“æ—¥æœŸ\r\n',0),(287159,7977,'sv','AnvÃ¤nds idag som transaktionsdatum',0),(287160,7977,'it','Uso oggi come data di transazione',0),(287161,7977,'tl','',0),(287162,7977,'th','&#3651;&#3594;&#3657;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3623;&#3633;&#3609;&#3609;&#3637;&#3657;',0),(287163,7977,'hi','à¤†à¤œ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(287164,7977,'ms','Menggunakan hari tarikh urus niaga',0),(287165,7977,'ar','Ø¥Ø³ØªØ®Ø¯Ù… ØªØ§Ø±ÙŠØ® Ø§Ù„ÙŠÙˆÙ… Ù„Ù„Ø¹Ù…Ù„ÙŠØ©',0),(287166,7977,'fr','Servir aujourd\'hui Date de Transaction',0),(287167,7977,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã®æ—¥ä»˜ã¨ã—ã¦ä»Šæ—¥ä½¿ç”¨',0),(287168,7977,'pt','Use Data de Hoje como Data de TransaÃ§Ã£o',0),(287169,7977,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ ÑÐµÐ³Ð¾Ð´Ð½Ñ ÐºÐ°Ðº Ð´Ð°Ñ‚Ð° ÑÐ´ÐµÐ»ÐºÐ¸',0),(287170,7977,'es','Usar Hoy Como Fecha De La TransacciÃ³n',0),(287171,7977,'de','Verwendung heute als Buchungsdatum',0),(287172,7977,'en','Use Today As Transaction Date',0),(287173,7978,'is','',0),(287174,7978,'dr','(Ø­Ù…Ù„ Ø¨Ù‡ Ù…Ø­Ù„ Ù‡Ø§ Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ù†Ø§Ù… Ø¨Ø§ Ù†Ø§Ù… Ø®Ø±ÙŠØ¯Ø§Ø± Ù…Ø·Ø§Ø¨Ù‚Øª Ø¯Ø§Ø±Ø¯ ',0),(287175,7978,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ù…Ø±Ø§Ø³Ù„Ø§Øª (Ø­Ù…Ù„ Ø¨Ù‡ Ù…Ø­Ù„ Ù‡Ø§ Ø¬Ø§ÙŠÙŠ ÙƒÙ‡ Ù†Ø§Ù… Ø¨Ø§ Ù†Ø§Ù… Ø®Ø±ÙŠØ¯Ø§Ø± Ù…Ø·Ø§Ø¨Ù‚Øª Ø¯Ø§Ø±Ø¯ ',0),(287176,7978,'tr','Posta etiketleri (gemi konumlara nerede adÄ±yla eÅŸleÅŸen mÃ¼ÅŸteri adÄ±)',0),(287177,7978,'pl','Etykiet adresowych (statek do miejsc, w ktÃ³rych nazwa pasuje do klienta nazwa)',0),(287178,7978,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸ (ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾ Ð¼ÐµÑÑ‚Ð°, ÐºÑŠÐ´ÐµÑ‚Ð¾ Ð¸Ð¼ÐµÑ‚Ð¾ Ð¾Ñ‚Ð³Ð¾Ð²Ð°Ñ€Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð¼Ðµ)',0),(287179,7978,'ur','ØªØ±Ø³ÛŒÙ„ÛŒ Ù„ÛŒØ¨Ù„ (Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ù…Ù‚Ø§Ù…Ø§Øª Ø¬ÛØ§Úº Ù†Ø§Ù… Ù…Ø´Ø§Ø¨Û Ú¯Ø§ÛÚ© Ú©Û’ Ù†Ø§Ù…)',0),(287180,7978,'sr','ÐÐ°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ðµ ÑÐ° Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ (Ð±Ñ€Ð¾Ð´ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°Ð¼Ð° Ð³Ð´Ðµ Ñ˜Ðµ Ð¸Ð¼Ðµ Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð° ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð¼Ðµ)',0),(287181,7978,'vi','NhÃ£n bao thÆ° (chuyá»ƒn tá»›i Ä‘á»‹a Ä‘iá»ƒm phÃ¹ há»£p tÃªn khÃ¡ch hÃ ng)',0),(287182,7978,'af','Posetikette (Versend Na Buurt Waar Name pas by KliÃ«nt/Klant Naam)',0),(287183,7978,'ro','Etichete poÅŸtale (nava la locaÅ£ii Ã®n cazul Ã®n care numele meciuri clientului numele)',0),(287184,7978,'et','Aadressisiltide (laeva kohtades kus nimi vastab kliendi nime)',0),(287185,7978,'si','Nalepke (ladja na lokacijah, kjer ime ujema kupca ime)',0),(287186,7978,'ba','Label Surat (kapal ke lokasi dimana nama cocok pelanggan nama)',0),(287187,7978,'nl','Adresetiketten (verzendlocaties waarbij naam overeenkomt met klant naam)',0),(287188,7978,'fi','Osoitetarrojen (aluksen paikkoihin jossa nimi vastaa asiakkaan nimi)',0),(287189,7978,'no','Adresseetiketter (skipet til steder der navnet samsvarer med kundens navn)',0),(287190,7978,'da','Adresseetiketter (skib til steder hvor navn matcher kundens navn)',0),(287191,7978,'ko','ìš°íŽ¸ë¬¼ ë ˆì´ë¸” (ë°° ì´ë¦„ ê³ ê°ì„ ì¼ì¹˜ í•˜ëŠ” ìœ„ì¹˜ë¥¼ ì´ë¦„)',0),(287192,7978,'he','×ª×•×•×™×•×ª ×ž×¢×Ÿ (×”×¡×¤×™× ×” ×œ×ž×™×§×•×ž×™× ××™×¤×” ×©× ×ª×•×× ×œ×§×•×— ×©×ž×•)',0),(287193,7978,'el','Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚ Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚ (Ï€Î»Î¿Î¯Î¿ ÏƒÎµ Î¸Î­ÏƒÎµÎ¹Ï‚ ÏŒÏ€Î¿Ï… Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ ÏŒÎ½Î¿Î¼Î±)',0),(287194,7978,'zh','é‚®å¯„æ ‡ç­¾ï¼ˆæ”¶è´§åœ°ç‚¹çš„åç§°ç¬¦åˆå®¢æˆ·åç§°ï¼‰\r\n',0),(287195,7978,'sv','Adressetiketter (fartyget till platser dÃ¤r namn matchar kundens namn)',0),(287196,7978,'it','Etichette postali (nave a localitÃ  il cui nome corrisponde al cliente nome)',0),(287197,7978,'tl','',0),(287198,7978,'th','&#3593;&#3621;&#3634;&#3585;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3656;&#3591;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660; (Ship To Locations Where Name Matches Customer Name)',0),(287199,7978,'hi','à¤®à¥‡à¤²à¤¿à¤‚à¤— à¤²à¥‡à¤¬à¤²à¥à¤¸ (à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤œà¤¹à¤¾à¤‚ à¤¨à¤¾à¤® à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤•à¤¾ à¤¨à¤¾à¤®)',0),(287200,7978,'ms','Surat menyurat label (kapal ke lokasi di mana nama padan Baca nama)',0),(287201,7978,'ar','Ø¨Ø·Ø§Ù‚Ø§Øª Ø¹Ù†ÙˆÙ†Ø© Ø¨Ø±ÙŠØ¯ÙŠØ© (Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù„Ù„Ù…ÙˆØ§Ù‚Ø¹ Ø­ÙŠØ« ÙŠØ·Ø§Ø¨Ù‚ Ø§Ø³Ù… Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ø³Ù…)',0),(287202,7978,'fr','Ã‰tiquettes d\'adresse (navires aux emplacements oÃ¹ le nom correspond Ã  client nom)',0),(287203,7978,'jp','å®›åãƒ©ãƒ™ãƒ« (é¡§å®¢ã¨ä¸€è‡´ã™ã‚‹åå‰ã®å ´æ‰€ã«èˆ¹ã®åå‰)',0),(287204,7978,'pt','Etiquetas de endereÃ§amento (navio para locais onde o nome corresponde ao cliente nome)',0),(287205,7978,'ru','ÐÐ°ÐºÐ»ÐµÐ¹ÐºÐ¸ (ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð² Ð¼ÐµÑÑ‚Ð°, Ð³Ð´Ðµ Ð¸Ð¼Ñ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð¼Ñ)',0),(287206,7978,'es','Etiquetas de EnvÃ­o (Enviar a Ubicaciones En Donde el Nombre se Empareja al Nombre del Cliente',0),(287207,7978,'de','Adressetiketten (Schiff an Orten wo Namen Customer Ã¼bereinstimmt Name)',0),(287208,7978,'en','Mailing Labels (Ship To Locations Where Name Matches Customer Name)',0),(287209,7979,'is','',0),(287210,7979,'dr','Ø§Ø±Ø³Ø§Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ù‡Øª Ø§Ø·Ù„Ø§Ø¹ Ø¨Ù‡ Ù†Ø§Ù… ',0),(287211,7979,'pr','Ø§Ø±Ø³Ø§Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ù‡Øª Ø§Ø·Ù„Ø§Ø¹ Ø¨Ù‡ Ù†Ø§Ù… ',0),(287212,7979,'tr','Bill Attn adÄ±na',0),(287213,7979,'pl','Bill Attn nazwÄ™',0),(287214,7979,'bg','ÐÐ° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¸Ð¼Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(287215,7979,'ur','Ø§Ù¹Ù¹Ù† Ù†Ø§Ù… Ú©Û’ Ù„ÛŒÛ’ Ø¨Ù„',0),(287216,7979,'sr','ÐÑ‚Ñ‚Ð½ Ð¸Ð¼Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐ°',0),(287217,7979,'vi','NgÆ°á»i Nháº­n',0),(287218,7979,'af','Verreken Vir Aandag Naam',0),(287219,7979,'ro','Proiect de lege Attn numele',0),(287220,7979,'et','Arve saaja vÃµi osakonna nimi',0),(287221,7979,'si','RaÄun â€“ ime v vednost',0),(287222,7979,'ba','Bill Attn nama',0),(287223,7979,'nl','T.a.v. naam voor factuur',0),(287224,7979,'fi','Bill yhteystiedot nimi',0),(287225,7979,'no','Bill Attn-navn',0),(287226,7979,'da','Bill til ATT navn',0),(287227,7979,'ko','ë‹´ë‹¹ìž ì´ë¦„ì— ë¹Œ',0),(287228,7979,'he','×‘×™×œ ×©× ×œ×™×“×™',0),(287229,7979,'el','Bill Attn ÏŒÎ½Î¿Î¼Î±',0),(287230,7979,'zh','è®¡è´¹åˆ°ç»åŠžäººå§“å\r\n',0),(287231,7979,'sv','Bill till Attn namn',0),(287232,7979,'it','Bill Attn nome',0),(287233,7979,'tl','',0),(287234,7979,'th','&#3626;&#3656;&#3591;&#3610;&#3636;&#3621;&#3606;&#3638;&#3591;&#3612;&#3641;&#3657;&#3619;&#3633;&#3610;&#3594;&#3639;&#3656;&#3629;',0),(287235,7979,'hi','Attn à¤¨à¤¾à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²',0),(287236,7979,'ms','Bil nama U.p.',0),(287237,7979,'ar','Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ø¨Ø§Ø³Ù… Ø¹Ù†Ø§ÙŠØ©',0),(287238,7979,'fr','Projet de loi au nom de Attn',0),(287239,7979,'jp','æ‹…å½“åã«æ³•æ¡ˆ',0),(287240,7979,'pt','Projeto de lei para nome Ã  atenÃ§Ã£o',0),(287241,7979,'ru','Ð‘Ð¸Ð»Ð» Attn Ð¸Ð¼Ñ',0),(287242,7979,'es','Facturar a la Attn. Nombre',0),(287243,7979,'de','Bill Attn Namen',0),(287244,7979,'en','Bill To Attn Name',0),(287245,7980,'is','',0),(287246,7980,'dr','Ù†Ø§Ù… ØªÙ…Ø§Ø³ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(287247,7980,'pr','Ù†Ø§Ù… ØªÙ…Ø§Ø³ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(287248,7980,'tr','MÃ¼ÅŸteri ilgili kiÅŸi adÄ±',0),(287249,7980,'pl','Nazwa kontaktu klienta',0),(287250,7980,'bg','Ð˜Ð¼ÐµÑ‚Ð¾ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(287251,7980,'ur','Ú©Ø³Ù¹Ù…Ø± Ø±Ø§Ø¨Ø·Û’ Ú©Û’ Ù†Ø§Ù…',0),(287252,7980,'sr','Ð˜Ð¼Ðµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð° Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(287253,7980,'vi','TÃªn khÃ¡ch hÃ ng',0),(287254,7980,'af','Klant / KliÃ«nt Kontaknaam',0),(287255,7980,'ro','Numele persoanei de Contact client',0),(287256,7980,'et','Kliendi konaktisik',0),(287257,7980,'si','Kupec ime stika',0),(287258,7980,'ba','Nama kontak pelanggan',0),(287259,7980,'nl','De naam van de contactpersoon van de klant',0),(287260,7980,'fi','Asiakkaan yhteyshenkilÃ¶n nimi',0),(287261,7980,'no','Kundenavn',0),(287262,7980,'da','Kontakt Kundenavn',0),(287263,7980,'ko','ê³ ê° ì—°ë½ì²˜ ì´ë¦„',0),(287264,7980,'he','×©× ××™×© ×§×©×¨ ×œ×§×•×—×•×ª',0),(287265,7980,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏ€Î±Ï†Î®Ï‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(287266,7980,'zh','å®¢æˆ·è”ç³»äººå§“å\r\n',0),(287267,7980,'sv','Kundens namn',0),(287268,7980,'it','Nome di contatto cliente',0),(287269,7980,'tl','',0),(287270,7980,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(287271,7980,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤‚à¤ªà¤°à¥à¤• à¤¨à¤¾à¤®',0),(287272,7980,'ms','Nama kenalan pelanggan',0),(287273,7980,'ar','Ø§Ø³Ù… Ø¬Ù‡Ø© Ø§ØªØµØ§Ù„ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(287274,7980,'fr','Nom du Contact client',0),(287275,7980,'jp','é¡§å®¢ã®é€£çµ¡å…ˆå',0),(287276,7980,'pt','Nome de contato do cliente',0),(287277,7980,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð¾Ðµ Ð›Ð¸Ñ†Ð¾ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(287278,7980,'es','Cliente Nombre de Contacto',0),(287279,7980,'de','Kontakt Kundennamen',0),(287280,7980,'en','Customer Contact Name',0),(287281,7981,'is','',0),(287282,7981,'dr','Ø¨Ø±Ú†Ø³Ø¨ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(287283,7981,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ',0),(287284,7981,'tr','Etiket YazdÄ±rma',0),(287285,7981,'pl','Drukowanie etykiet',0),(287286,7981,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(287287,7981,'ur','Ù„ÛŒØ¨Ù„ Ø·Ø¨Ø§Ø¹Øª',0),(287288,7981,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¾Ð·Ð½Ð°ÐºÐ°',0),(287289,7981,'vi','In NhÃ£n ',0),(287290,7981,'af','Druk Etiket',0),(287291,7981,'ro','TipÄƒrire de etichete',0),(287292,7981,'et','Sildi printimiseks',0),(287293,7981,'si','Tiskanje etiket',0),(287294,7981,'ba','Label Printing',0),(287295,7981,'nl','Afdrukopties voor etiketten',0),(287296,7981,'fi','Etikettien tulostaminen',0),(287297,7981,'no','Etikettutskrift',0),(287298,7981,'da','Etiketudskrivning.',0),(287299,7981,'ko','ë¼ë²¨ ì¸ì‡„',0),(287300,7981,'he','×”×“×¤×¡×ª ×ª×•×•×™×•×ª',0),(287301,7981,'el','Î•Ï„Î¹ÎºÎµÏ„Î¿Ï€Î¿Î¹Î¯Î±',0),(287302,7981,'zh','æ ‡ç­¾å°åˆ·\r\n',0),(287303,7981,'sv','Etikettutskrift',0),(287304,7981,'it','Stampa di etichette',0),(287305,7981,'tl','',0),(287306,7981,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;&#3593;&#3621;&#3634;&#3585;',0),(287307,7981,'hi','à¤²à¥‡à¤¬à¤² à¤®à¥à¤¦à¥à¤°à¤£',0),(287308,7981,'ms','Percetakan label',0),(287309,7981,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªØ³Ù…ÙŠØ©',0),(287310,7981,'fr','Impression d\'Ã©tiquettes',0),(287311,7981,'jp','ãƒ©ãƒ™ãƒ«ã®å°åˆ·',0),(287312,7981,'pt','ImpressÃ£o de etiquetas',0),(287313,7981,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÑ‚Ð¸ÐºÐµÑ‚Ð¾Ðº',0),(287314,7981,'es','ImpresiÃ³n de Etiquetas',0),(287315,7981,'de','Etikettendruck',0),(287316,7981,'en','Label Printing',0),(287317,7982,'is','',0),(287318,7982,'dr','Ú†Ø§Ù¾ Ú¯Ø±ÙˆÙ‡ ',0),(287319,7982,'pr','Ú†Ø§Ù¾ Ú¯Ø±ÙˆÙ‡ ',0),(287320,7982,'tr','BaskÄ± grubu',0),(287321,7982,'pl','Grupa wydruku',0),(287322,7982,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð³Ñ€ÑƒÐ¿Ð°',0),(287323,7982,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú¯Ø±ÙˆÙ¾',0),(287324,7982,'sr','ÐŸÑ€Ð¸Ð½Ñ‚ Ð³Ñ€ÑƒÐ¿Ð°',0),(287325,7982,'vi','NhÃ³m in',0),(287326,7982,'af','Druk Groep',0),(287327,7982,'ro','Grup de imprimare',0),(287328,7982,'et','Jaotises printimine',0),(287329,7982,'si','Print Group',0),(287330,7982,'ba','Cetak Group',0),(287331,7982,'nl','Groep afdrukken',0),(287332,7982,'fi','Tulosta ryhmÃ¤',0),(287333,7982,'no','Gruppen Skriv ut',0),(287334,7982,'da','Udskriv gruppe',0),(287335,7982,'ko','ì¸ì‡„ ê·¸ë£¹',0),(287336,7982,'he','×”×“×¤×¡ ×§×‘×•×¦×”',0),(287337,7982,'el','ÎŸÎ¼Î¬Î´Î±Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(287338,7982,'zh','æ‰“å°ç»„\r\n',0),(287339,7982,'sv','Skriv ut grupp',0),(287340,7982,'it','Gruppo di stampa',0),(287341,7982,'tl','',0),(287342,7982,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3614;&#3636;&#3617;&#3614;&#3660;',0),(287343,7982,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¸à¤®à¥‚à¤¹',0),(287344,7982,'ms','Kumpulan cetak',0),(287345,7982,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(287346,7982,'fr','Groupe d\'impression',0),(287347,7982,'jp','å°åˆ·ã‚°ãƒ«ãƒ¼ãƒ—',0),(287348,7982,'pt','Grupo impressÃ£o',0),(287349,7982,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(287350,7982,'es','Imprimir Grupo',0),(287351,7982,'de','Gruppe Drucken',0),(287352,7982,'en','Print Group',0),(287353,7983,'is','',0),(287354,7983,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ø§Ø·Ù„Ø§Ø¹ Ø¨Ù‡ Ù†Ø§Ù… ',0),(287355,7983,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ø§Ø·Ù„Ø§Ø¹ Ø¨Ù‡ Ù†Ø§Ù… ',0),(287356,7983,'tr','Attn adÄ± alÄ±ntÄ±',0),(287357,7983,'pl','Cytat Attn nazwÄ™',0),(287358,7983,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð½Ð° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¸Ð¼Ðµ',0),(287359,7983,'ur','Ø§Ù¹Ù¹Ù† Ú©Û’ Ù†Ø§Ù… Ø³Û’ Ø§Ù‚ØªØ¨Ø§Ø³',0),(287360,7983,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐÑ‚Ñ‚Ð½ Ð¸Ð¼Ðµ',0),(287361,7983,'vi','BÃ¡o giÃ¡ tá»›i tÃªn',0),(287362,7983,'af','Kwotasie Aan Vir Aandag Naam',0),(287363,7983,'ro','Citat la Attn numele',0),(287364,7983,'et','Teadmiseks nimi tsitaat',0),(287365,7983,'si','Ponudbo, ki v vednost ime',0),(287366,7983,'ba','Mengutip nama Attn',0),(287367,7983,'nl','Citaat aan T.a.v. naam',0),(287368,7983,'fi','Lainaus yhteystiedot nimi',0),(287369,7983,'no','Sitere Attn-navn',0),(287370,7983,'da','Citat til ATT navn',0),(287371,7983,'ko','ë‹´ë‹¹ìž ì´ë¦„ ì¸ìš©',0),(287372,7983,'he','×”×¦×¢×ª ×ž×—×™×¨ ×”×•×‘×œ×” ×©×',0),(287373,7983,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î½Î± Attn ÏŒÎ½Î¿Î¼Î±',0),(287374,7983,'zh','æŠ¥ä»·åˆ°ç»åŠžäººå§“å\r\n',0),(287375,7983,'sv','Citerar Attn namn',0),(287376,7983,'it','Citare per nome all\'attenzione',0),(287377,7983,'tl','',0),(287378,7983,'th','&#3649;&#3592;&#3657;&#3591;&#3606;&#3638;&#3591;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3594;&#3639;&#3656;&#3629;',0),(287379,7983,'hi','Attn à¤¨à¤¾à¤® à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(287380,7983,'ms','Sebut harga untuk U.p. nama',0),(287381,7983,'ar','Ø§Ù‚ØªØ¨Ø§Ø³ Ø¨Ø§Ø³Ù… Ø¹Ù†Ø§ÙŠØ©',0),(287382,7983,'fr','Citer le nom de Attn',0),(287383,7983,'jp','æ‹…å½“åã‚’å¼•ç”¨ã—ã¾ã™ã€‚',0),(287384,7983,'pt','Cite o nome Ã  atenÃ§Ã£o',0),(287385,7983,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ðº ÐºÐ¾Ð¼Ñƒ Ð¸Ð¼Ñ',0),(287386,7983,'es','CotizaciÃ³n a Aten. Nombre',0),(287387,7983,'de','Attn Namen zitieren',0),(287388,7983,'en','Quote To Attn Name',0),(287389,7984,'is','',0),(287390,7984,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø²ÙŠÙ†Ù‡ Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø¨Ù‡ Ù†Ø§Ù… ',0),(287391,7984,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø²ÙŠÙ†Ù‡ Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø¨Ù‡ Ù†Ø§Ù… ',0),(287392,7984,'tr','SeÃ§im ilgi-ada',0),(287393,7984,'pl','Wybierz wybÃ³r uwagi-nazwa',0),(287394,7984,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¸Ð·Ð±Ð¾Ñ€ Ð½Ð° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ-Ð¸Ð¼Ðµ',0),(287395,7984,'ur','ØªÙˆØ¬Û Ú©Ø§ Ø§Ø®ØªÛŒØ§Ø± Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº-Ù†Ø§Ù…',0),(287396,7984,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ð¾Ñ€ Ð¿Ð°Ð¶ÑšÐµ-Ð½Ð° Ð¸Ð¼Ðµ',0),(287397,7984,'vi','Lá»±a chá»n tÃªn ngÆ°á»i nháº­n',0),(287398,7984,'af','Kies keuse van aandag-naam',0),(287399,7984,'ro','OpÈ›iunea de atenÅ£ie-la nume',0),(287400,7984,'et','Valige valik tÃ¤helepanu-nimi',0),(287401,7984,'si','Izberite izbira pozornosti-ime',0),(287402,7984,'ba','Pilih pilihan perhatian-nama',0),(287403,7984,'nl','Keuze van aandacht-naam',0),(287404,7984,'fi','Valitse vaihtoehto huomiota-nimi',0),(287405,7984,'no','Velge oppmerksomhet-navn',0),(287406,7984,'da','VÃ¦lge Valg af opmÃ¦rksomhed-til navn',0),(287407,7984,'ko','ê´€ì‹¬ì˜ ì„ íƒ-ì´ë¦„',0),(287408,7984,'he','×‘×—×¨ ×‘×—×™×¨×” ×©×œ ×ª×©×•×ž×ª ×œ×‘-×©×',0),(287409,7984,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® Ï„Î·Ï‚ Ï€ÏÎ¿ÏƒÎ¿Ï‡Î®Ï‚-ÏŒÎ½Î¿Î¼Î±',0),(287410,7984,'zh','é€‰æ‹©æ³¨æ„é€‰é¡¹åç§°\r\n',0),(287411,7984,'sv','Markera Ã¶nskad uppmÃ¤rksamhet-namn',0),(287412,7984,'it','Selezionare la scelta di attenzione-per nome',0),(287413,7984,'tl','',0),(287414,7984,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3586;&#3629;&#3591;&#3594;&#3639;&#3656;&#3629;&#3607;&#3637;&#3656;&#3626;&#3609;&#3651;&#3592;',0),(287415,7984,'hi','à¤§à¥à¤¯à¤¾à¤¨ à¤¦à¥‡à¤¨à¥‡ à¤•à¥‡ à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚-à¤¨à¤¾à¤® à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(287416,7984,'ms','Pilih pilihan perhatian-kepada nama',0),(287417,7984,'ar','Ø­Ø¯Ø¯ Ø®ÙŠØ§Ø± Ù„Ù„Ø§Ù‡ØªÙ…Ø§Ù…-Ø¨Ø§Ø³Ù…',0),(287418,7984,'fr','SÃ©lectionnez le choix de l\'Attention-nom',0),(287419,7984,'jp','æ³¨æ„ã®é¸æŠž-åå‰ã‚’',0),(287420,7984,'pt','Selecione a opÃ§Ã£o de atenÃ§Ã£o-nome',0),(287421,7984,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð²Ñ‹Ð±Ð¾Ñ€ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ñ-Ð¸Ð¼Ñ',0),(287422,7984,'es','Seleccionar OpciÃ³n de AtenciÃ³n-Para Nombrar',0),(287423,7984,'de','Auswahl der Aufmerksamkeit-Namen',0),(287424,7984,'en','Select Choice of Attention-To Name',0),(287425,7985,'is','',0),(287426,7985,'dr','Ø­Ù…Ù„ Ø¨Ù‡ Ù†Ø§Ù… ',0),(287427,7985,'pr','Ø­Ù…Ù„ Ø¨Ù‡ Ù†Ø§Ù… ',0),(287428,7985,'tr','Attn adÄ±na gemi',0),(287429,7985,'pl','Attn nazwa statku',0),(287430,7985,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð·Ð° Ð¸Ð¼Ðµ Ð½Ð° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸ÐµÑ‚Ð¾',0),(287431,7985,'ur','Ø§Ù¹Ù¹Ù† Ú©Û’ Ù†Ø§Ù… Ù¾Ø± Ø¬ÛØ§Ø²',0),(287432,7985,'sr','ÐÑ‚Ñ‚Ð½ Ð¸Ð¼Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(287433,7985,'vi','Chuyá»ƒn Ä‘áº¿n TÃªn',0),(287434,7985,'af','Skip na Attn naam',0),(287435,7985,'ro','NavÄƒ la Attn numele',0),(287436,7985,'et','Kauba saaja teadmiseks nimi',0),(287437,7985,'si','Dostava â€“ ime v vednost',0),(287438,7985,'ba','Kapal ke Attn nama',0),(287439,7985,'nl','T.a.v. naam voor verzending',0),(287440,7985,'fi','Aluksen yhteystiedot nimi',0),(287441,7985,'no','Leveringsgate Attn-navn',0),(287442,7985,'da','Skib til ATT navn',0),(287443,7985,'ko','ë‹´ë‹¹ìž ì´ë¦„ ë°°',0),(287444,7985,'he','×œ×ž×©×œ×•×— ×©× ×œ×™×“×™',0),(287445,7985,'el','Î Î»Î¿Î¯Î¿ Î½Î± Attn ÏŒÎ½Î¿Î¼Î±',0),(287446,7985,'zh','æ”¶è´§è”ç³»äººå§“å\r\n',0),(287447,7985,'sv','Fartyget till Attn namn',0),(287448,7985,'it','Spedire all\'attenzione di nome',0),(287449,7985,'tl','',0),(287450,7985,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3612;&#3641;&#3657;&#3619;&#3633;&#3610;&#3594;&#3639;&#3656;&#3629;',0),(287451,7985,'hi','Attn à¤¨à¤¾à¤® à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(287452,7985,'ms','Kapal U.p. nama',0),(287453,7985,'ar','Ø³ÙÙŠÙ†Ø© Ø¨Ø§Ø³Ù… Ø¹Ù†Ø§ÙŠØ©',0),(287454,7985,'fr','ExpÃ©dier Ã  Attn nom',0),(287455,7985,'jp','æ‹…å½“åã«å‡ºè·ã—ã¾ã™ã€‚',0),(287456,7985,'pt','Navio de nome Attn',0),(287457,7985,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ðº ÐºÐ¾Ð¼Ñƒ Ð¸Ð¼Ñ',0),(287458,7985,'es','Enviar-A Atn. Nombre',0),(287459,7985,'de','Ship To Attn Name',0),(287460,7985,'en','Ship To Attn Name',0),(287461,7986,'is','',0),(287462,7986,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø²ÙŠØ§Ø¯ Ø¯Ø± ÙØ§ÙŠÙ„ Ø¨Ø§ÙŠØ¯ Ø·Ø¨Ù‚ Ú¯Ø±ÙˆÙ‡ Ú†Ø§Ù¾ Ø´ÙˆØ¯',0),(287463,7986,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø²ÙŠØ§Ø¯ Ø¯Ø± ÙØ§ÙŠÙ„ Ø¨Ø§ÙŠØ¯ Ø·Ø¨Ù‚ Ú¯Ø±ÙˆÙ‡ Ú†Ø§Ù¾ Ø´ÙˆØ¯',0),(287464,7986,'tr','Ã‡ok fazla iÃ§inde dosya grubu tarafÄ±ndan baskÄ± gerekir',0),(287465,7986,'pl','Zbyt wiele w pliku, naleÅ¼y wydrukowaÄ‡ grupy',0),(287466,7986,'bg','Ð¢Ð²ÑŠÑ€Ð´Ðµ Ð¼Ð½Ð¾Ð³Ð¾ Ð²ÑŠÐ² Ñ„Ð°Ð¹Ð», Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚Ðµ Ð¾Ñ‚ Ð³Ñ€ÑƒÐ¿Ð°',0),(287467,7986,'ur','Ø¨ÛØª Ø³Û’ Ø¯Ø± Ù…Ø³Ù„ Ú¯Ø±ÙˆÙ¾ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾Ø±Ù†Ù¹ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(287468,7986,'sr','ÐŸÑ€ÐµÐ²Ð¸ÑˆÐµ Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ, Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ‚Ð¸ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ðµ',0),(287469,7986,'vi','QuÃ¡ nhiá»u trong há»“ sÆ¡, Pháº£i in theo nhÃ³m',0),(287470,7986,'af','Te Veel in LÃªer, Moet Uitdruk Per Groep',0),(287471,7986,'ro','Prea multe Ã®n fiÅŸier, trebuie sÄƒ imprimaÅ£i de grup',0),(287472,7986,'et','Liiga palju faili peate printima Group',0),(287473,7986,'si','PreveÄ v datoteko, morate natisniti skupine',0),(287474,7986,'ba','Terlalu banyak di File, harus mencetak oleh kelompok',0),(287475,7986,'nl','Teveel In bestand, moet afdrukken door groep',0),(287476,7986,'fi','Liikaa kaupungissa tiedosto tÃ¤ytyy tulostaa ryhmittÃ¤in',0),(287477,7986,'no','For mange i filen, mÃ¥ skrive ut av gruppe',0),(287478,7986,'da','For mange i filen skal udskrives af gruppe',0),(287479,7986,'ko','ë„ˆë¬´ ë§Žì€ ì‹œë‚´ íŒŒì¼ ê·¸ë£¹ìœ¼ë¡œ ì¸ì‡„ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(287480,7986,'he','×™×•×ª×¨ ×ž×“×™ ×‘×ª×•×š ×§×•×‘×¥, ×¢×œ×™×š ×œ×”×“×¤×™×¡ ×¢×œ-×™×“×™ ×§×‘×•×¦×”',0),(287481,7986,'el','Î Î¬ÏÎ± Ï€Î¿Î»Î»Î¬ ÏƒÏ„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿, Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î±Ï€ÏŒ Î¿Î¼Î¬Î´Î±',0),(287482,7986,'zh','å¤ªæ–‡ä»¶å¤šï¼Œå¾—é›†ä½“æ‰“å°\r\n',0),(287483,7986,'sv','FÃ¶r mÃ¥nga i filen, mÃ¥ste skriva ut av grupp',0),(287484,7986,'it','Troppi File In, deve stampare dal gruppo',0),(287485,7986,'tl','',0),(287486,7986,'th','&#3652;&#3615;&#3621;&#3660;&#3617;&#3634;&#3585;&#3648;&#3585;&#3636;&#3609; &#3605;&#3657;&#3629;&#3591;&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3611;&#3655;&#3609;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(287487,7986,'hi','à¤¬à¤¹à¥à¤¤ à¤¸à¤¾à¤°à¥‡ à¤®à¥‡à¤‚ à¤«à¤¼à¤¾à¤‡à¤², à¤¸à¤®à¥‚à¤¹ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(287488,7986,'ms','Terlalu banyak fail dalam, mesti dicetak oleh Kumpulan',0),(287489,7986,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØªÙ… Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù…Ù„Ù ÙÙŠ ÙƒØ«ÙŠØ±Ø© Ø¬Ø¯Ø§Ù‹ØŒ Ø¨Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(287490,7986,'fr','Fichier en trop grand nombre, doit imprimer par groupe',0),(287491,7986,'jp','ã‚ã¾ã‚Šã«ã‚‚å¤šãã®ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚°ãƒ«ãƒ¼ãƒ—ã§å°åˆ·ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(287492,7986,'pt','Muitos em arquivo, deve imprimir por grupo',0),(287493,7986,'ru','Ð’ Ð¤Ð°Ð¹Ð»Ðµ Ð¡Ð»Ð¸ÑˆÐºÐ¾Ð¼ ÐœÐ½Ð¾Ð³Ð¾, ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ ÐŸÐ¾ Ð“Ñ€ÑƒÐ¿Ð¿Ð°Ð¼',0),(287494,7986,'es','Demasiados en el File, Debe Imprimir Por Grupo',0),(287495,7986,'de','Zu viele In Datei muss drucken, indem Sie Gruppe',0),(287496,7986,'en','Too Many In File, Must Print By Group',0),(287497,7987,'is','',0),(287498,7987,'dr','ØµÙØ­Ù‡  Ø³ÙØ§Ø±Ø´ Ø§Ø²    Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ â€“ Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(287499,7987,'pr','ØµÙØ­Ù‡  Ø³ÙØ§Ø±Ø´ Ø§Ø²    Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ â€“ Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(287500,7987,'tr','Sayfa etiketleri-bu satÄ±cÄ±dan sipariÅŸ',0),(287501,7987,'pl','Strona zakonu z etykiet to sprzedawca',0),(287502,7987,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð½Ð° Ñ€ÐµÐ´ Ð¾Ñ‚ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸ Ñ‚Ð¾Ð·Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(287503,7987,'ur','ØªØ±ØªÛŒØ¨ Ù„ÛŒØ¨Ù„ Ø§Ø³ ÙØ±ÙˆØ´Ù†Ø¯Û Ø³Û’ Ú©Ø§ ØµÙØ­Û',0),(287504,7987,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¿Ð¾Ñ€ÐµÑ‚ÐºÐ° Ð¸Ð· Ð¾Ð²Ðµ Ð¾Ð·Ð½Ð°ÐºÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(287505,7987,'vi','Trang Ä‘Æ¡n hÃ ng tá»« ngÆ°á»i bÃ¡n nÃ y',0),(287506,7987,'af','Bladsy van volgorde van etikette-hierdie handelaar',0),(287507,7987,'ro','Pagina de comanda la furnizor de etichete-aceasta',0),(287508,7987,'et','Sildid-see hankija tellimuse lehele',0),(287509,7987,'si','Stran od oznak-to dobavitelja',0),(287510,7987,'ba','Halaman Order dari label-ini Vendor',0),(287511,7987,'nl','Pagina van volgorde van Labels-deze leverancier',0),(287512,7987,'fi','Sivun tilauksen otsikot-tÃ¤mÃ¤ toimittajalta',0),(287513,7987,'no','Siden i rekkefÃ¸lgen fra etiketter-dette leverandÃ¸r',0),(287514,7987,'da','Side i rÃ¦kkefÃ¸lge fra etiketter-denne kreditor',0),(287515,7987,'ko','ë¼ë²¨-ì´ ì—…ì²´ì—ì„œ ì£¼ë¬¸ íŽ˜ì´ì§€',0),(287516,7987,'he','×¢×ž×•×“ ×©×œ ×¡×“×¨ ×ž×™×¦×¨×Ÿ ×–×” ×ª×•×•×™×•×ª',0),(287517,7987,'el','Î£ÎµÎ»Î¯Î´Î± Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î±Ï€ÏŒ Ï„Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÎµÏ„Î¹ÎºÎ­Ï„ÎµÏ‚, Î±Ï…Ï„ÏŒ',0),(287518,7987,'zh','æŒ‰æ ‡ç­¾æŽ’åºé¡µ-æ­¤ä¾›åº”å•†\r\n ',0),(287519,7987,'sv','Sidan i ordning frÃ¥n etiketter-denna leverantÃ¶r',0),(287520,7987,'it','Pagina di ordine da etichette, questo fornitore',0),(287521,7987,'tl','',0),(287522,7987,'th','&#3627;&#3609;&#3657;&#3634;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3593;&#3621;&#3634;&#3585;-&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(287523,7987,'hi','à¤²à¥‡à¤¬à¤²-à¤¯à¤¹ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥ƒà¤·à¥à¤ ',0),(287524,7987,'ms','Laman pesanan daripada penjual label ini',0),(287525,7987,'ar','ØµÙØ­Ø© Ø§Ù„Ù†Ø¸Ø§Ù… Ù…Ù† Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø¹Ù†ÙˆÙ†Ø©ØŒ ÙˆÙ‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(287526,7987,'fr','Page de commande dâ€™Ã©tiquettes-ce vendeur',0),(287527,7987,'jp','ãƒ©ãƒ™ãƒ«ã“ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã‹ã‚‰ã®æ³¨æ–‡ã®ãƒšãƒ¼ã‚¸',0),(287528,7987,'pt','PÃ¡gina da ordem de rÃ³tulos, este fornecedor',0),(287529,7987,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð·Ð°ÐºÐ°Ð·Ð° Ð¾Ñ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¼ÐµÑ‚Ð¾Ðº ÑÑ‚Ð¾',0),(287530,7987,'es','PÃ¡gina De Etiquetas Ordenar De-Este Proveedor',0),(287531,7987,'de','Seite des Ordens von Etiketten-diese Anbieter',0),(287532,7987,'en','Page Of Order From Labels-This Vendor',0),(287533,7988,'is','',0),(287534,7988,'dr','ØµÙØ­Ù‡  Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡    Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ â€“ Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(287535,7988,'pr','ØµÙØ­Ù‡  Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡    Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ â€“ Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(287536,7988,'tr','Sayfa yuvanÄ±zÄ± etiketleri-bu satÄ±cÄ±nÄ±n',0),(287537,7988,'pl','Strona banku dostawcy etykiet to',0),(287538,7988,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð½Ð° PayTo ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸ Ñ‚Ð¾Ð·Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(287539,7988,'ur','Ù¾ÛŒØ·Ùˆ Ù„ÛŒØ¨Ù„ Ø§Ø³ ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ ØµÙØ­Û',0),(287540,7988,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¾Ð´ Ð»ÐµÐ¿ÑˆÐ¸ ÐžÐ²Ð° Ð¾Ð·Ð½Ð°ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(287541,7988,'vi','Trang NhÃ£n \"Thanh ToÃ¡n Cho-NgÆ°á»i BÃ¡n NÃ y\"',0),(287542,7988,'af','Bladsy van Betaal Aan Etikette - Hierdie Verskaffer',0),(287543,7988,'ro','Filme PayTo etichete-acest furnizor',0),(287544,7988,'et','Lehel PayTo siltide-see hankija',0),(287545,7988,'si','Strani PayTo oznake-to prodajalca',0),(287546,7988,'ba','Halaman PayTo label-ini vendor',0),(287547,7988,'nl','Pagina van Labels-deze leverancier van PayTo',0),(287548,7988,'fi','Sivu talletettu otsikot-tÃ¤mÃ¤ toimittaja',0),(287549,7988,'no','Siden brukskonto etiketter-denne leverandÃ¸ren',0),(287550,7988,'da','Side af PayTo etiketter-denne kreditor',0),(287551,7988,'ko','PayTo ë ˆì´ë¸”ì´ ê³µê¸‰ ì—…ì²´ì˜ íŽ˜ì´ì§€',0),(287552,7988,'he','×“×£ ×¡×¤×§ ×ª×•×•×™×•×ª. ×–×” ×©×˜×•×™×•×ª',0),(287553,7988,'el','Î£ÎµÎ»Î¯Î´Î± Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚-Î±Ï…Ï„ÏŒ PayTo',0),(287554,7988,'zh','æ”¶æ¬¾äººæ ‡ç­¾é¡µ-æ­¤ä¾›åº”å•†\r\n',0),(287555,7988,'sv','Sida av PayTo etiketter-denna leverantÃ¶r',0),(287556,7988,'it','Pagina di pagatoper etichette-questo fornitore',0),(287557,7988,'tl','',0),(287558,7988,'th','&#3627;&#3609;&#3657;&#3634;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3593;&#3621;&#3634;&#3585;-&#3612;&#3641;&#',0),(287559,7988,'hi','PayTo à¤²à¥‡à¤¬à¤²-à¤¯à¤¹ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤ªà¥ƒà¤·à¥à¤ ',0),(287560,7988,'ms','Laman PayTo ini label pembekal',0),(287561,7988,'ar','Ø§Ù„ØµÙØ­Ø© Ù…Ù† Ø¨ÙŠØªÙˆ ØªØ³Ù…ÙŠØ§Øª Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(287562,7988,'fr','Page du modÃ©rateur Ã©tiquettes-ce vendeur',0),(287563,7988,'jp','æ”¯æ‰•ã„å…ˆãƒ©ãƒ™ãƒ«ã“ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã®ãƒšãƒ¼ã‚¸',0),(287564,7988,'pt','PÃ¡gina do fornecedor de rÃ³tulos, este imagina',0),(287565,7988,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° PayTo ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸ ÑÑ‚Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº',0),(287566,7988,'es','PÃ¡gina Etiquetas de Pagar A-Este Proveedor',0),(287567,7988,'de','Seite des PayTo Etiketten-dieses Herstellers',0),(287568,7988,'en','Page of PayTo Labels-This Vendor',0),(287569,7989,'is','',0),(287570,7989,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù† Ø¹Ù…Ù„ÙŠØ§Øª Ø­Ø°Ù   Ù†ÙŠØ³Øª',0),(287571,7989,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù† Ø¹Ù…Ù„ÙŠØ§Øª Ø­Ø°Ù   Ù†ÙŠØ³Øª',0),(287572,7989,'tr','UNDELETE deÄŸil',0),(287573,7989,'pl','Nie moÅ¼na cofnÄ…Ä‡',0),(287574,7989,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð’ÐªÐ—Ð¡Ð¢ÐÐÐžÐ’Ð˜',0),(287575,7989,'ur','Ø­Ø°Ù Ø®ØªÙ… Ú©Ø± Ø³Ú©Ø§ Ù†ÛÛŒÚº',0),(287576,7989,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³Ð°Ð¾ Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð±Ñ€Ð¸ÑÐ°ÑšÐ°',0),(287577,7989,'vi','KhÃ´ng xÃ³a Ä‘Æ°á»£c',0),(287578,7989,'af','Kon nie UITWISSING ongedaan maak nie',0),(287579,7989,'ro','Ar putea anula ÅŸtergerea',0),(287580,7989,'et','Ei saanud kustutamist tÃ¼histada',0),(287581,7989,'si','Lahko NEODLOÅ½EN',0),(287582,7989,'ba','Tidak bisa membatalkan penghapusan',0),(287583,7989,'nl','Kon niet UNDELETE',0),(287584,7989,'fi','Ei kumoa',0),(287585,7989,'no','Kan ikke angre',0),(287586,7989,'da','Kunne ikke GENOPRETTER',0),(287587,7989,'ko','ìˆ˜ ì—†ëŠ” ì‚­ì œ ì·¨ì†Œ',0),(287588,7989,'he','×™×›×•×œ ×œ× ×ž×—×™×§×ª×•',0),(287589,7989,'el','Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± ÎžÎ•Î”Î™Î‘Î“Î¡Î†Î¨Î•Î™',0),(287590,7989,'zh','æ— æ³•å–æ¶ˆåˆ é™¤\r\n',0),(287591,7989,'sv','Kunde inte Ã¥terstÃ¤lla',0),(287592,7989,'it','Non poteva UNDELETE',0),(287593,7989,'tl','',0),(287594,7989,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3607;&#3635;&#3585;&#3634;&#3619;&#3652;&#3617;&#3656;&#3621;&#3610;&#3652;&#3604;&#3657;',0),(287595,7989,'hi','à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(287596,7989,'ms','Boleh membatalkan PENGHAPUSAN',0),(287597,7989,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø­Ø°Ù',0),(287598,7989,'fr','Pouvait pas UNDELETE',0),(287599,7989,'jp','æˆ»ã›ã¾ã›ã‚“ã§ã—ãŸã€‚',0),(287600,7989,'pt','NÃ£o pode desfazer exclusÃ£o',0),(287601,7989,'ru','ÐœÐ¾Ð¶ÐµÑ‚ Ð½Ðµ Ð²Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(287602,7989,'es','No se puede ADMITIR',0),(287603,7989,'de','Konnte nicht wiederherstellen',0),(287604,7989,'en','Could Not UNDELETE',0),(287605,7990,'is','',0),(287606,7990,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(287607,7990,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(287608,7990,'tr','SipariÅŸ birimi',0),(287609,7990,'pl','ZamÃ³wienie jednostek',0),(287610,7990,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(287611,7990,'ur','Ø¢Ø±ÚˆØ± ÛŒÙˆÙ†Ù¹ÙˆÚº',0),(287612,7990,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(287613,7990,'vi','ÄÆ¡n vá»‹ Ä‘áº·t hÃ ng',0),(287614,7990,'af','Bestellings Eenhede',0),(287615,7990,'ro','UnitÄƒÅ£i de comandÄƒ',0),(287616,7990,'et','Tellimuse Ã¼hikute',0),(287617,7990,'si','Vrstni red enot',0),(287618,7990,'ba','Urutan unit',0),(287619,7990,'nl','Volgorde eenheden',0),(287620,7990,'fi','Jotta yksikÃ¶iden',0),(287621,7990,'no','RekkefÃ¸lgen enheter',0),(287622,7990,'da','Bestil enheder',0),(287623,7990,'ko','ì£¼ë¬¸ ë‹¨ìœ„',0),(287624,7990,'he','×¡×“×¨ ×™×—×™×“×•×ª',0),(287625,7990,'el','Î£ÎµÎ¹ÏÎ¬ Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(287626,7990,'zh','è®¢è´­å•ä½\r\n',0),(287627,7990,'sv','Ordning enheter',0),(287628,7990,'it','UnitÃ  di ordine',0),(287629,7990,'tl','',0),(287630,7990,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(287631,7990,'hi','à¤•à¥à¤°à¤® à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(287632,7990,'ms','Unit perintah',0);
INSERT INTO `langdef` VALUES (287633,7990,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù…',0),(287634,7990,'fr','UnitÃ©s de commande',0),(287635,7990,'jp','ç™ºæ³¨å˜ä½',0),(287636,7990,'pt','Unidades de ordem',0),(287637,7990,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(287638,7990,'es','Unidades de Orden',0),(287639,7990,'de','Bestellung-Einheiten',0),(287640,7990,'en','Order Units',0),(287641,7991,'is','',0),(287642,7991,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù‚ÙŠÙ…Øª ',0),(287643,7991,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù‚ÙŠÙ…Øª ',0),(287644,7991,'tr','Fiyat birimi',0),(287645,7991,'pl','Cena jednostki',0),(287646,7991,'bg','Ð¦ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(287647,7991,'ur','Ù‚ÛŒÙ…Øª ÛŒÙˆÙ†Ù¹Ø³',0),(287648,7991,'sr','Ð¦ÐµÐ½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(287649,7991,'vi','ÄÆ¡n vá»‹ giÃ¡',0),(287650,7991,'af','Pryseenhede',0),(287651,7991,'ro','Pret unitÄƒÅ£i',0),(287652,7991,'et','Hind Ã¼hikute',0),(287653,7991,'si','Cena enote',0),(287654,7991,'ba','Harga unit',0),(287655,7991,'nl','Prijs eenheden',0),(287656,7991,'fi','Hinta yksikkÃ¶Ã¤',0),(287657,7991,'no','Pris enheter',0),(287658,7991,'da','Pris enheder',0),(287659,7991,'ko','ê°€ê²© ë‹¨ìœ„',0),(287660,7991,'he','×ž×—×™×¨ ×™×—×™×“×•×ª',0),(287661,7991,'el','Î¤Î¹Î¼Î® Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(287662,7991,'zh','è®¡ä»·å•ä½\r\n',0),(287663,7991,'sv','Pris enheter',0),(287664,7991,'it','Prezzo unitÃ ',0),(287665,7991,'tl','',0),(287666,7991,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(287667,7991,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(287668,7991,'ms','Unit harga',0),(287669,7991,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ø³Ø¹Ø±',0),(287670,7991,'fr','UnitÃ©s de prix',0),(287671,7991,'jp','ä¾¡æ ¼å˜ä½',0),(287672,7991,'pt','Unidades de preÃ§o',0),(287673,7991,'ru','Ð¦ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(287674,7991,'es','Unidades de Precio',0),(287675,7991,'de','Preis-Einheiten',0),(287676,7991,'en','Price Units',0),(287677,7992,'is','',0),(287678,7992,'dr','ÙƒÙ„Ø§Ø³ÙŠÙƒ',0),(287679,7992,'pr','ÙƒÙ„Ø§Ø³ÙŠÙƒ',0),(287680,7992,'tr','Klasik',0),(287681,7992,'pl','Klasyczny',0),(287682,7992,'bg','ÐšÐ»Ð°ÑÐ¸Ñ‡ÐµÑÐºÐ¸',0),(287683,7992,'ur','Ú©Ù„Ø§Ø³ÛŒÚ©ÛŒ',0),(287684,7992,'sr','ÐšÐ»Ð°ÑÐ¸Ñ‡Ð½Ð¸',0),(287685,7992,'vi','Cá»• Ä‘iá»ƒn',0),(287686,7992,'af','Klassieke',0),(287687,7992,'ro','Clasic',0),(287688,7992,'et','Klassikaline',0),(287689,7992,'si','Classic',0),(287690,7992,'ba','Klasik',0),(287691,7992,'nl','Classic',0),(287692,7992,'fi','Classic',0),(287693,7992,'no','Klassisk',0),(287694,7992,'da','Classic',0),(287695,7992,'ko','í´ëž˜ì‹',0),(287696,7992,'he','×§×œ××¡×™',0),(287697,7992,'el','ÎšÎ»Î±ÏƒÎ¹ÎºÏŒ',0),(287698,7992,'zh','ç»å…¸\r\n',0),(287699,7992,'sv','Classic',0),(287700,7992,'it','Classico',0),(287701,7992,'tl','',0),(287702,7992,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3604;&#3633;&#3657;&#3591;&#3648;&#3604;&#3636;&#3617;',0),(287703,7992,'hi','à¤•à¥à¤²à¤¾à¤¸à¤¿à¤•',0),(287704,7992,'ms','Classic',0),(287705,7992,'ar','ØªÙ‚Ù„ÙŠØ¯ÙŠ',0),(287706,7992,'fr','Classique',0),(287707,7992,'jp','ã‚¯ãƒ©ã‚·ãƒƒã‚¯',0),(287708,7992,'pt','ClÃ¡ssico',0),(287709,7992,'ru','ÐšÐ»Ð°ÑÑÐ¸Ðº',0),(287710,7992,'es','ClÃ¡sico',0),(287711,7992,'de','Classic',0),(287712,7992,'en','Classic',0),(287713,7993,'is','',0),(287714,7993,'dr','ÙÙ‚Ø· Ø¨Ø§ Ù…Ø¯Ù„ Ù‡Ø§ÙŠ ÙƒÙ„Ø§Ø³ÙŠÙƒ ',0),(287715,7993,'pr','ÙÙ‚Ø· Ø¨Ø§ Ù…Ø¯Ù„ Ù‡Ø§ÙŠ ÙƒÙ„Ø§Ø³ÙŠÙƒ ',0),(287716,7993,'tr','YalnÄ±zca klasik stili ile',0),(287717,7993,'pl','Tylko w stylu klasycznym',0),(287718,7993,'bg','Ð¡Ð°Ð¼Ð¾ Ñ ÐºÐ»Ð°ÑÐ¸Ñ‡ÐµÑÐºÐ¸ ÑÑ‚Ð¸Ð»',0),(287719,7993,'ur','Ú©Ù„Ø§Ø³ÛŒÚ©ÛŒ Ø·Ø±Ø² Ú©Û’ Ø³Ø§ØªÚ¾ ØµØ±Ù',0),(287720,7993,'sr','Ð¡Ð°Ð¼Ð¾ ÑƒÐ· ÐšÐ»Ð°ÑÐ¸Ñ‡Ð½Ð¸ ÑÑ‚Ð¸Ð»',0),(287721,7993,'vi','Chá»‰ vá»›i dáº¡ng cá»• Ä‘iá»ƒn',0),(287722,7993,'af','Slegs Met Klassieke Styl',0),(287723,7993,'ro','Numai cu un stil clasic',0),(287724,7993,'et','Ainult koos klassikalises stiilis',0),(287725,7993,'si','Samo z klasiÄni slog',0),(287726,7993,'ba','Hanya dengan gaya klasik',0),(287727,7993,'nl','Alleen met klassieke stijl',0),(287728,7993,'fi','Klassinen tyylillÃ¤',0),(287729,7993,'no','Bare med klassisk stil',0),(287730,7993,'da','Kun med klassiske stil',0),(287731,7993,'ko','ê³ ì „ì ì¸ ìŠ¤íƒ€ì¼ìœ¼ë¡œë§Œ',0),(287732,7993,'he','×¨×§ ×¢× ×¡×’× ×•×Ÿ ×§×œ××¡×™',0),(287733,7993,'el','ÎœÏŒÎ½Î¿ Î¼Îµ ÎºÎ»Î±ÏƒÎ¹ÎºÏŒ ÏƒÏ„Ï…Î»',0),(287734,7993,'zh','åªæœ‰å¤å…¸é£Žæ ¼\r\n',0),(287735,7993,'sv','Endast med klassisk stil',0),(287736,7993,'it','Solo con stile classico',0),(287737,7993,'tl','',0),(287738,7993,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3588;&#3621;&#3634;&#3626;&#3626;&#3636;&#3588;',0),(287739,7993,'hi','à¤•à¥‡à¤µà¤² à¤•à¥à¤²à¤¾à¤¸à¤¿à¤• à¤¶à¥ˆà¤²à¥€ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(287740,7993,'ms','Hanya dengan gaya klasik',0),(287741,7993,'ar','ÙÙ‚Ø· Ù…Ø¹ Ø§Ù„Ù†Ù…Ø· Ø§Ù„ÙƒÙ„Ø§Ø³ÙŠÙƒÙŠ',0),(287742,7993,'fr','Seulement dans le Style classique',0),(287743,7993,'jp','ã‚¯ãƒ©ã‚·ãƒƒã‚¯ãªã‚¹ã‚¿ã‚¤ãƒ«ã§ã®ã¿',0),(287744,7993,'pt','Somente com o estilo clÃ¡ssico',0),(287745,7993,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ñ ÐºÐ»Ð°ÑÑÐ¸Ñ‡ÐµÑÐºÐ¾Ð¼ ÑÑ‚Ð¸Ð»Ðµ',0),(287746,7993,'es','Solo Con el Estilo ClÃ¡sico',0),(287747,7993,'de','Nur mit klassischen Stil',0),(287748,7993,'en','Only With Classic Style',0),(287749,7994,'is','',0),(287750,7994,'dr','ÙÙ‚Ø· Ø¨Ø§ Ù…Ø¯Ù„ Ù‡Ø§ÙŠ Ø§ÙŠÙƒØ³ Ù¾ÙŠ  ',0),(287751,7994,'pr','ÙÙ‚Ø· Ø¨Ø§ Ù…Ø¯Ù„ Ù‡Ø§ÙŠ Ø§ÙŠÙƒØ³ Ù¾ÙŠ  ',0),(287752,7994,'tr','Sadece XP stilleri ile',0),(287753,7994,'pl','Tylko z Style XP',0),(287754,7994,'bg','Ð¡Ð°Ð¼Ð¾ Ñ XP ÑÑ‚Ð¸Ð»Ð¾Ð²Ðµ',0),(287755,7994,'ur','Ø§ÛŒÚ©Ø³ Ù¾ÛŒ Ø·Ø±Ø²ÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾ ÙÙ‚Ø·',0),(287756,7994,'sr','Ð¡Ð°Ð¼Ð¾ ÑÐ° XÐŸ ÑÑ‚Ð¸Ð»Ð¾Ð²Ð¸',0),(287757,7994,'vi','Chá»‰ vá»›i dáº¡ng XP',0),(287758,7994,'af','Slegs Met XP Style',0),(287759,7994,'ro','Doar cu XP stiluri',0),(287760,7994,'et','XP laadidega',0),(287761,7994,'si','Samo s XP slogi',0),(287762,7994,'ba','Hanya dengan gaya XP',0),(287763,7994,'nl','Alleen met XP-stijlen',0),(287764,7994,'fi','Vain XP tyyleillÃ¤',0),(287765,7994,'no','Bare med XP stiler',0),(287766,7994,'da','Kun med XP stilarter',0),(287767,7994,'ko','XP ìŠ¤íƒ€ì¼ìœ¼ë¡œë§Œ',0),(287768,7994,'he','×¨×§ ×¢× ×¡×’× ×•× ×•×ª XP',0),(287769,7994,'el','ÎœÏŒÎ½Î¿ Î¼Îµ XP ÏƒÏ„Ï…Î»',0),(287770,7994,'zh','åªæœ‰XPé£Žæ ¼\r\n',0),(287771,7994,'sv','Endast med XP stilar',0),(287772,7994,'it','Solo con gli stili di XP',0),(287773,7994,'tl','',0),(287774,7994,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3648;&#3617;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610; XP',0),(287775,7994,'hi','à¤•à¥‡à¤µà¤² XP à¤¶à¥ˆà¤²à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(287776,7994,'ms','Hanya dengan gaya XP',0),(287777,7994,'ar','ÙÙ‚Ø· Ù…Ø¹ Ø£Ù†Ù…Ø§Ø· XP',0),(287778,7994,'fr','Seulement avec XP Styles',0),(287779,7994,'jp','XP ã‚¹ã‚¿ã‚¤ãƒ«ã§ã®ã¿',0),(287780,7994,'pt','SÃ³ com XP estilos',0),(287781,7994,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ ÑÑ‚Ð¸Ð»ÐµÐ¹ XP',0),(287782,7994,'es','Solo Con Estilos de XP',0),(287783,7994,'de','Nur mit XP-Stile',0),(287784,7994,'en','Only With XP Styles',0),(287785,7995,'is','',0),(287786,7995,'dr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ØªØºÙŠÙŠØ±Ø§Øª ',0),(287787,7995,'pr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ØªØºÙŠÙŠØ±Ø§Øª ',0),(287788,7995,'tr','DeÄŸiÅŸiklik yapmak iÃ§in',0),(287789,7995,'pl','Do zmiany',0),(287790,7995,'bg','Ð—Ð° Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(287791,7995,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(287792,7995,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð²Ñ€ÑˆÐ¸Ð»Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(287793,7995,'vi','Äá»ƒ thay Ä‘á»•i',0),(287794,7995,'af','Om veranderinge te maak',0),(287795,7995,'ro','Pentru a face modificÄƒri',0),(287796,7995,'et','Muudatuste tegemiseks',0),(287797,7995,'si','Do sprememb',0),(287798,7995,'ba','Untuk membuat perubahan',0),(287799,7995,'nl','Wijzigingen aan te brengen',0),(287800,7995,'fi','Muutosten tekeminen',0),(287801,7995,'no','GjÃ¸re endringer',0),(287802,7995,'da','Foretage Ã¦ndringer',0),(287803,7995,'ko','ë³€ê²½ í•˜ë ¤ë©´',0),(287804,7995,'he','×›×“×™ ×œ×‘×¦×¢ ×©×™× ×•×™×™×',0),(287805,7995,'el','ÎÎ± ÎºÎ¬Î½ÎµÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚',0),(287806,7995,'zh','è‹¥è¦å˜æ›´\r\n',0),(287807,7995,'sv','Att gÃ¶ra Ã¤ndringar',0),(287808,7995,'it','Per apportare modifiche',0),(287809,7995,'tl','',0),(287810,7995,'th','&#3606;&#3638;&#3591;&#3607;&#3635;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(287811,7995,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(287812,7995,'ms','Untuk membuat perubahan',0),(287813,7995,'ar','Ù„Ø¥Ø¬Ø±Ø§Ø¡ ØªØºÙŠÙŠØ±Ø§Øª',0),(287814,7995,'fr','Pour apporter des modifications',0),(287815,7995,'jp','å¤‰æ›´ã‚’åŠ ãˆã‚‹',0),(287816,7995,'pt','Para fazer alteraÃ§Ãµes',0),(287817,7995,'ru','Ð”Ð»Ñ Ð²Ð½ÐµÑÐµÐ½Ð¸Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(287818,7995,'es','Para Hacer Cambios',0),(287819,7995,'de','Ã„nderungen vornehmen',0),(287820,7995,'en','To Make Changes',0),(287821,7996,'is','',0),(287822,7996,'dr','Ø¨Ø³ØªÙ† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ ÙƒØ§Ù…Ù„Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡',0),(287823,7996,'pr','Ø¨Ø³ØªÙ† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ ÙƒØ§Ù…Ù„Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡',0),(287824,7996,'tr','YakÄ±n tam olarak Ã¶denen faturalar',0),(287825,7996,'pl','Zamknij faktury pÅ‚atne w caÅ‚oÅ›ci',0),(287826,7996,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð² Ð¿ÑŠÐ»ÐµÐ½',0),(287827,7996,'ur','Ù‚Ø±ÛŒØ¨ Ù…ÛŒÚº ØªÙ†Ø®ÙˆØ§Û Ù¾ÙˆØ±ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ',0),(287828,7996,'sr','Ð—Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ñƒ',0),(287829,7996,'vi','KhÃ³a sá»• hÃ³a Ä‘Æ¡n Ä‘Ã£ thanh toÃ¡n Ä‘á»§',0),(287830,7996,'af','Afsluit van Fakture ten Volle Betaal',0),(287831,7996,'ro','Aproape facturile plÄƒtite Ã®n Ã®ntregime',0),(287832,7996,'et','Sulge arved, mis on tÃ¤ielikult makstud',0),(287833,7996,'si','Zapri raÄuni plaÄani v celoti',0),(287834,7996,'ba','Dekat faktur lunas',0),(287835,7996,'nl','Sluiten facturen betaald in Full',0),(287836,7996,'fi','Sulje laskut maksetaan kokonaan',0),(287837,7996,'no','Lukk fakturaer betalt i Full',0),(287838,7996,'da','Luk fakturaer betalt i fuld',0),(287839,7996,'ko','ì£¼ë³€ì— ìœ ë£Œ ì „ì²´ ì²­êµ¬ì„œ',0),(287840,7996,'he','×¡×’×•×¨ ×—×©×‘×•× ×™×•×ª ×ž×œ× ×‘×ª×©×œ×•×',0),(287841,7996,'el','ÎšÎ»ÎµÎ¯ÏƒÎ¹Î¼Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎºÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹ ÏƒÎµ Ï€Î»Î®ÏÎ·',0),(287842,7996,'zh','å…³é—­å…¨é¢æ”¯ä»˜å‘ç¥¨\r\n',0),(287843,7996,'sv','StÃ¤ng fakturor betalas i Full',0),(287844,7996,'it','Chiudi le fatture pagate in pieno',0),(287845,7996,'tl','',0),(287846,7996,'th','&#3611;&#3636;&#3604;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3588;&#3619;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(287847,7996,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤®à¥‡à¤‚ à¤ªà¥‚à¤°à¥à¤£ à¤¬à¤‚à¤¦ à¤šà¤¾à¤²à¤¾à¤¨',0),(287848,7996,'ms','Tutup invois penuh dibayar dalam',0),(287849,7996,'ar','Ø¥Ù‚ÙØ§Ù„ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø³Ø¯Ù‘Ø¯Ø© Ø¨Ø§Ù„ÙƒØ§Ù…Ù„',0),(287850,7996,'fr','Fermer les factures payÃ©s en plein',0),(287851,7996,'jp','è«‹æ±‚æ›¸ã®ã‚¯ãƒ­ãƒ¼ã‚ºå®Œå…¨',0),(287852,7996,'pt','Fechar as faturas pagas em Full',0),(287853,7996,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð° Ð²Ñ‹Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ Ð² Ð¿Ð¾Ð»Ð½Ð¾Ð¼ Ð¾Ð±ÑŠÐµÐ¼Ðµ',0),(287854,7996,'es','Cerrar Facturas Pagados Completamente',0),(287855,7996,'de','SchlieÃŸen Rechnungen Paid in Full',0),(287856,7996,'en','Close Invoices Paid in Full',0),(287857,7997,'is','',0),(287858,7997,'dr','Ø®Ù„Ø§ØµÙ‡ Ø¬Ù…Ø¹â€Œ ÙƒÙ„ Ø·Ø¨Ù‚ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(287859,7997,'pr','Ø®Ù„Ø§ØµÙ‡ Ø¬Ù…Ø¹â€Œ ÙƒÙ„ Ø·Ø¨Ù‚ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(287860,7997,'tr','Ã–zet Toplam MÃ¼ÅŸteri tarafÄ±ndan',0),(287861,7997,'pl','Podsumowanie caÅ‚oÅ›ci przez klienta',0),(287862,7997,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½Ð¸ Ð¾Ð±Ñ‰Ð¾ Ð¾Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(287863,7997,'ur','Ø®Ù„Ø§ØµÛ Ú©Ù„ Ú¯Ø§ÛÚ© Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(287864,7997,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°ÑšÐµ ÑƒÐºÑƒÐ¿Ð½Ð¾ Ð¿Ð¾ ÐºÑƒÐ¿Ñ†Ð¸Ð¼Ð°',0),(287865,7997,'vi','Tá»•ng há»£p theo khÃ¡ch hÃ ng',0),(287866,7997,'af','Opsommingstotaal per Klant/KliÃ«nt',0),(287867,7997,'ro','Rezumat Total de client',0),(287868,7997,'et','KokkuvÃµtlik kokku kliendi jÃ¤rgi',0),(287869,7997,'si','Povzetek skupaj s stranko',0),(287870,7997,'ba','Ringkasan Total oleh nasabah',0),(287871,7997,'nl','Samenvatting totaal door klant',0),(287872,7997,'fi','Yhteenveto yhteensÃ¤ asiakkaittain',0),(287873,7997,'no','Sammendrag totalt etter kunde',0),(287874,7997,'da','Sammenfattende alt efter kunde',0),(287875,7997,'ko','ê³ ê°ì— ì˜í•´ ìš”ì•½ ì´',0),(287876,7997,'he','×›×•×œ×œ ×¡×™×›×•× ×¢×œ-×™×“×™ ×œ×§×•×—',0),(287877,7997,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬ Î±Ï€ÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(287878,7997,'zh','æŒ‰å®¢æˆ·æ‘˜è¦æ±‡æ€»\r\n',0),(287879,7997,'sv','Sammanfattning totalt av kund',0),(287880,7997,'it','Riepilogo totale dal cliente',0),(287881,7997,'tl','',0),(287882,7997,'th','&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3650;&#3604;&#3618;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(287883,7997,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤•à¥à¤² à¤—à¥à¤°à¤¾à¤¹à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(287884,7997,'ms','Ringkasan jumlah oleh pelanggan',0),(287885,7997,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ù…Ù„Ø®Øµ Ø­Ø³Ø¨ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(287886,7997,'fr','Sommaire Total par client',0),(287887,7997,'jp','é¡§å®¢ã«ã‚ˆã£ã¦ã‚µãƒžãƒªãƒ¼åˆè¨ˆ',0),(287888,7997,'pt','Resumo Total pelo cliente',0),(287889,7997,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ Ð²ÑÐµÐ³Ð¾ Ð·Ð°ÐºÐ°Ð·Ñ‡Ð¸ÐºÐ¾Ð¼',0),(287890,7997,'es','Totales de ResÃºmen Por Cliente',0),(287891,7997,'de','Zusammenfassung insgesamt durch den Kunden',0),(287892,7997,'en','Summary Total by Customer',0),(287893,7998,'is','',0),(287894,7998,'dr','1',0),(287895,7998,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø±  1',0),(287896,7998,'tr','Ä°ÅŸ tÃ¼rÃ¼ 1',0),(287897,7998,'pl','Praca typu 1',0),(287898,7998,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ 1',0),(287899,7998,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… 1',0),(287900,7998,'sr','Ð’Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð° 1',0),(287901,7998,'vi','Loáº¡i cÃ´ng viá»‡c 1',0),(287902,7998,'af','Werktipe 1',0),(287903,7998,'ro','Locul de muncÄƒ de tip 1',0),(287904,7998,'et','TÃ¶Ã¶ liik 1',0),(287905,7998,'si','Vrsta dela 1',0),(287906,7998,'ba','Jenis pekerjaan 1',0),(287907,7998,'nl','Werksoort 1',0),(287908,7998,'fi','TyÃ¶n tyyppi 1',0),(287909,7998,'no','Arbeidstype 1',0),(287910,7998,'da','Arbejdstype 1',0),(287911,7998,'ko','ìž‘ì—… í˜•ì‹ 1',0),(287912,7998,'he','×¡×•×’ ×¢×‘×•×“×” 1',0),(287913,7998,'el','Î¤ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ 1',0),(287914,7998,'zh','å·¥ä½œç±»åž‹1\r\n',0),(287915,7998,'sv','Arbetstyp 1',0),(287916,7998,'it','Tipo di lavoro 1',0),(287917,7998,'tl','',0),(287918,7998,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609; 1',0),(287919,7998,'hi','à¤Ÿà¤¾à¤‡à¤ª 1 à¤•à¤¾à¤®',0),(287920,7998,'ms','Jenis kerja 1',0),(287921,7998,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ 1',0),(287922,7998,'fr','Type de travail 1',0),(287923,7998,'jp','ä½œæ¥­ã®ç¨®é¡ž 1',0),(287924,7998,'pt','Tipo de trabalho 1',0),(287925,7998,'ru','Ð¢Ð¸Ð¿ Ð Ð°Ð±Ð¾Ñ‚Ñ‹ 1',0),(287926,7998,'es','Tipo de Trabajo 1',0),(287927,7998,'de','Arbeit-Typ 1',0),(287928,7998,'en','Work Type 1',0),(287929,7999,'is','',0),(287930,7999,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÙŠ Ø¨Ø§Ø·Ù„ Ù†Ø´Ø¯Ù‡  Ù†ÙŠØ³Øª',0),(287931,7999,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÙŠ Ø¨Ø§Ø·Ù„ Ù†Ø´Ø¯Ù‡  Ù†ÙŠØ³Øª',0),(287932,7999,'tr','Unvoided sevkiyat istenen bulamadÄ±.',0),(287933,7999,'pl','Nie moÅ¼na odnaleÅºÄ‡ unvoided przesyÅ‚ki zgÅ‚oszony.',0),(287934,7999,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð½Ð°Ð¼ÐµÑ€Ð¸ unvoided Ð¿Ñ€ÐµÐ²Ð¾Ð· Ð¸Ð·Ð¸ÑÐºÐ²Ð°.',0),(287935,7999,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù†ÙˆÙˆØ§ÚˆÛŒØ¯ Ú©Ú¾ÛŒÙ¾ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§ Û”',0),(287936,7999,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ ÑƒÐ½Ð²Ð¾Ð¸Ð´ÐµÐ´ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð·Ð°Ñ‚Ñ€Ð°Ð¶Ð¸Ð¾.',0),(287937,7999,'vi','KhÃ´ng tÃ¬m tháº¥y chuyáº¿n hÃ ng Ä‘Ã£ xÃ³a theo yÃªu cáº§u',0),(287938,7999,'af','Was Nie Staat om \"unvoided\" versendingversoek te vind nie.',0),(287939,7999,'ro','Unvoided livrare solicitat nu a putut gÄƒsi.',0),(287940,7999,'et','Ei leidnud taotletud unvoided vedudele.',0),(287941,7999,'si','Unvoided poÅ¡iljka, ki zahteva ni bilo mogoÄe najti.',0),(287942,7999,'ba','Tidak dapat menemukan unvoided pengiriman yang diminta.',0),(287943,7999,'nl','Kan niet vinden unvoided verzending opgevraagd.',0),(287944,7999,'fi','Unvoided siirtoon ei lÃ¶ytynyt.',0),(287945,7999,'no','Finner ikke unvoided forsendelse forespurt.',0),(287946,7999,'da','Kunne ikke finde unvoided Ã¸nskede overfÃ¸rsel.',0),(287947,7999,'ko','Unvoided ì„ ì  ìš”ì²­ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(287948,7999,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª unvoided ×”×ž×©×œ×•×— ×”×ž×‘×•×§×©.',0),(287949,7999,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ unvoided Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Ï€Î¿Ï… Î¶Î·Ï„Î¿ÏÎ½Ï„Î±Î¹.',0),(287950,7999,'zh','æ‰¾ä¸åˆ°ä½œæœ‰æ•ˆè£…è¿è¦æ±‚ã€‚\r\n',0),(287951,7999,'sv','Kunde inte hitta unvoided transporten efterfrÃ¥gades.',0),(287952,7999,'it','Impossibile trovare unvoided spedizione richiesta.',0),(287953,7999,'tl','',0),(287954,7999,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3588;&#3657;&#3609;&#3627;&#3634;&#3585;&#3634;&#3619;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3651;&#3627;&#3657;&#3652;&#3617;&#3656;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3',0),(287955,7999,'hi','Unvoided à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾à¥¤',0),(287956,7999,'ms','Tidak dapat mencari unvoided penghantaran yang diminta.',0),(287957,7999,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø´Ø­Ù†Ø© Ø£ÙˆÙ†ÙÙˆÙŠØ¯ÙŠØ¯ Ø·Ù„Ø¨.',0),(287958,7999,'fr','Unvoided expÃ©dition demandÃ©e introuvable.',0),(287959,7999,'jp','è¦æ±‚ã•ã‚ŒãŸ unvoided ã®å‡ºè·ã‚’è¦‹ã¤ã‘ã‚‰ã‚Œã¾ã›ã‚“ã§ã—ãŸã€‚',0),(287960,7999,'pt','NÃ£o foi possÃ­vel encontrar o carregamento unvoided solicitado.',0),(287961,7999,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ unvoided Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð¿Ñ€Ð¾ÑÐ¸Ð».',0),(287962,7999,'es','No se puede encontrar pedidos de envÃ­o no anulados',0),(287963,7999,'de','Unvoided Lieferung angefordert konnte nicht gefunden werden.',0),(287964,7999,'en','Could not find unvoided shipment requested.',0),(287965,8000,'is','',0),(287966,8000,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ù„ØºÙˆ Ø´Ø¯ ',0),(287967,8000,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ù„ØºÙˆ Ø´Ø¯ ',0),(287968,8000,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde hÃ¼kÃ¼msÃ¼z sevk irsaliyesi',0),(287969,8000,'pl','WysyÅ‚ka pomyÅ›lnie anulowane',0),(287970,8000,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°, Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(287971,8000,'ur','Ú©Ú¾ÛŒÙ¾ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ ÙˆÙˆØ§ÚˆÛŒØ¯',0),(287972,8000,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(287973,8000,'vi','XÃ³a chuyáº¿n hÃ ng thÃ nh cÃ´ng',0),(287974,8000,'af','Versendingsmetode Suksesvol Uitgewis',0),(287975,8000,'ro','Expediere anulat cu succes',0),(287976,8000,'et','Saadetise vÃ¤Ã¤rtus edukalt',0),(287977,8000,'si','PoÅ¡iljka uspeÅ¡no razveljavljena',0),(287978,8000,'ba','Pengiriman Voided berhasil',0),(287979,8000,'nl','Verzending met succes ongeldig',0),(287980,8000,'fi','Toimituksen pÃ¤tevÃ¤ onnistuneesti',0),(287981,8000,'no','Forsendelsen annullert vellykket',0),(287982,8000,'da','OverfÃ¸rslen annulleret med succes',0),(287983,8000,'ko','ì„ ì  ì„±ê³µì ìœ¼ë¡œ ë¬´íš¨í™”',0),(287984,8000,'he','×ž×©×œ×•×— ×‘×•×˜×œ ×‘×”×¦×œ×—×”',0),(287985,8000,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î±ÎºÏ…ÏÏ‰Î¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(287986,8000,'zh','è£…è¿åºŸé™¤æˆåŠŸ\r\n',0),(287987,8000,'sv','Transporten annullerad framgÃ¥ngsrikt',0),(287988,8000,'it','Spedizione annullata con successo',0),(287989,8000,'tl','',0),(287990,8000,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(287991,8000,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• Voided à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ',0),(287992,8000,'ms','Penghantaran Voided berjaya',0),(287993,8000,'ar','Ø§Ù„Ø´Ø­Ù† Ù…Ù„ØºÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(287994,8000,'fr','ExpÃ©dition annulÃ©e avec succÃ¨s',0),(287995,8000,'jp','å‡ºè·ãŒæ­£å¸¸ã«ç„¡åŠ¹åŒ–',0),(287996,8000,'pt','ExpediÃ§Ã£o anulada com Ãªxito',0),(287997,8000,'ru','ÐžÑ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð°',0),(287998,8000,'es','EnvÃ­o Anulado Exitosamente',0),(287999,8000,'de','Versand erfolgreich storniert',0),(288000,8000,'en','Shipment Voided Successfully',0),(288001,8001,'is','',0),(288002,8001,'dr','Ø¨Ø§ÙŠØ¯ Ù†Ø§Ù… Ø´Ø±ÙƒØª Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(288003,8001,'pr','Ø¨Ø§ÙŠØ¯ Ù†Ø§Ù… Ø´Ø±ÙƒØª Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(288004,8001,'tr','Have ÅŸirket adÄ±nÄ± gerekir',0),(288005,8001,'pl','Musi mieÄ‡ firmÄ™ nazwÄ™',0),(288006,8001,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¸Ð¼Ðµ',0),(288007,8001,'ur','ÛÛ’ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… Ø±Ú©Ú¾ÛŒÚº',0),(288008,8001,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð¼Ð°Ñ‚Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¸Ð¼Ðµ',0),(288009,8001,'vi','Pháº£i cÃ³ tÃªn cty',0),(288010,8001,'af','Moet \'n Ondernemingnaam hÃª',0),(288011,8001,'ro','Trebuie firma au nume',0),(288012,8001,'et','Peab olema firma nimi',0),(288013,8001,'si','Mora imeti druÅ¾ba ime',0),(288014,8001,'ba','Harus memiliki perusahaan nama',0),(288015,8001,'nl','Moet de naam van zijn bedrijf',0),(288016,8001,'fi','On saada yrityksen nimi',0),(288017,8001,'no','Ha mÃ¥ firmanavn',0),(288018,8001,'da','Have selskab skal navn',0),(288019,8001,'ko','ì´ íšŒì‚¬ ì´ë¦„ì„ ì§€ì • í•´ì•¼ í•©ë‹ˆë‹¤',0),(288020,8001,'he','×‘×˜×— ×™×© ×—×‘×¨×” ×©×',0),(288021,8001,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î­Ï‡Î¿Ï…Î½',0),(288022,8001,'zh','å¿…é¡»æœ‰å…¬å¸åç§°\r\n',0),(288023,8001,'sv','Ha fÃ¶retaget mÃ¥ste namn',0),(288024,8001,'it','Deve il nome azienda Have',0),(288025,8001,'tl','',0),(288026,8001,'th','&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3594;&#3639;&#3656;&#3629;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(288027,8001,'hi','à¤ªà¤¾à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤¨à¤¾à¤® à¤¦à¥‡à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(288028,8001,'ms','Mesti Syarikat mempunyai nama',0),(288029,8001,'ar','Ù„Ø§Ø¨Ø¯ Ù…Ù† ÙˆØ¬ÙˆØ¯ Ø¥Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ©',0),(288030,8001,'fr','Doit avoir raison sociale',0),(288031,8001,'jp','æŒã£ã¦ã„ã‚‹ä¼šç¤¾ã®åå‰ã‚’ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(288032,8001,'pt','Deve ter empresa nome',0),(288033,8001,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾ Ð‘Ñ‹Ñ‚ÑŒ ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(288034,8001,'es','Debe Tener Nombre de Empresa',0),(288035,8001,'de','Have muss Firmenname',0),(288036,8001,'en','Must Have Company Name',0),(288037,8002,'is','',0),(288038,8002,'dr','Ø¨Ø¯ÙˆÙ† Ø­Ø³Ø§Ø¨ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙØ±ÙˆØ´ ',0),(288039,8002,'pr','Ø¨Ø¯ÙˆÙ† Ø­Ø³Ø§Ø¨ Ø¯Ø³ØªÙ…Ø²Ø¯ ÙØ±ÙˆØ´ ',0),(288040,8002,'tr','HiÃ§bir iÅŸÃ§i satÄ±ÅŸ hesabÄ±',0),(288041,8002,'pl','Nie pracy sprzedaÅ¼ konta',0),(288042,8002,'bg','Ð¢Ñ€ÑƒÐ´Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(288043,8002,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø­Ù†Øª ÙØ±ÙˆØ®Øª Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(288044,8002,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ð´Ð½Ð¾ ÐºÐ¾Ð½Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(288045,8002,'vi','KhÃ´ng CÃ³ TK NhÃ¢n CÃ´ng HÃ ng BÃ¡n',0),(288046,8002,'af','Geen arbeid verkope rekening',0),(288047,8002,'ro','Nici un cont de vÃ¢nzare muncii',0),(288048,8002,'et','Ãœkski Labor MÃ¼Ã¼gikonto',0),(288049,8002,'si','Nikakor ne dela prodaje',0),(288050,8002,'ba','No akun penjualan tenaga kerja',0),(288051,8002,'nl','Geen arbeid omzetrekening',0),(288052,8002,'fi','Ei tyÃ¶ myynnin tili',0),(288053,8002,'no','Ingen Ap. salgskontoen',0),(288054,8002,'da','Ingen Labor salgskontoen',0),(288055,8002,'ko','ë…¸ë™ íŒë§¤ ê³„ì • ì—†ìŒ',0),(288056,8002,'he','××™×Ÿ ×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª ×œ×¢×‘×•×“×”',0),(288057,8002,'el','Î”ÎµÎ½ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(288058,8002,'zh','æ²¡æœ‰åŠ³åŠ¨é”€å”®å¸æˆ·\r\n',0),(288059,8002,'sv','Ingen Labor fÃ¶rsÃ¤ljningskontot',0),(288060,8002,'it','Nessun lavoro conto vendita',0),(288061,8002,'tl','',0),(288062,8002,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3619;&#3591;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(288063,8002,'hi','à¤•à¥‹à¤ˆ à¤¶à¥à¤°à¤® à¤¬à¤¿à¤•à¥à¤°à¥€ à¤–à¤¾à¤¤à¤¾',0),(288064,8002,'ms','Tiada akaun jualan buruh',0),(288065,8002,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ø§Ù„',0),(288066,8002,'fr','Aucun compte de vente Labor',0),(288067,8002,'jp','ãªã„åŠ´åƒè²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(288068,8002,'pt','Nenhuma conta de vendas do trabalho',0),(288069,8002,'ru','ÐÐµ Ñ‚Ñ€ÑƒÐ´Ð° ÑÑ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(288070,8002,'es','No Hay Cuentas de Ventas de Labor',0),(288071,8002,'de','Kein Labor Kundenkonto',0),(288072,8002,'en','No Labor Sales Account',0),(288073,8003,'is','',0),(288074,8003,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù…Ø´Ø®ØµØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ§Ø¯',0),(288075,8003,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø´Ø®ØµØ§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ§Ø¯',0),(288076,8003,'tr','Malzeme tanÄ±mlama giriÅŸ/gÃ¼ncelleme Ã¼rÃ¼n',0),(288077,8003,'pl','Bill materiaÅ‚Ã³w Definicja wejÅ›cia/aktualizacji',0),(288078,8003,'bg','ÐšÐ¾Ð¼Ð¿Ð»ÐµÐºÑÐ½Ð¾ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ Ð·Ð°Ð¿Ð¸Ñ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(288079,8003,'ur','Ø¨Ù„ Ú©Ø§ Ù…ÙˆØ§Ø¯ ØªØ¹Ø±ÛŒÙ Ø§Ù†Ø¯Ø±Ø§Ø¬/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(288080,8003,'sr','Ð‘Ð¸Ð» Ð¾Ð´ ÑƒÐ½Ð¾ÑÐ°/Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐ° Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð°',0),(288081,8003,'vi','Nháº­p/Cáº­p Nháº­t HÃ³a ÄÆ¡n Loáº¡i NguyÃªn Váº­t Liá»‡u',0),(288082,8003,'af','Wetsontwerp van materiale definisie inskrywing/opdatering',0),(288083,8003,'ro','Proiect de lege de materiale definiÅ£ie intrare/Update',0),(288084,8003,'et','Arve kande/definitsioonivÃ¤rskenduse materjalid',0),(288085,8003,'si','Bill materiala opredelitev vnos/posodobitev',0),(288086,8003,'ba','Bill bahan definisi Entry/update',0),(288087,8003,'nl','Bill van materialen definitie Entry/Update',0),(288088,8003,'fi','Bill aineiden mÃ¤Ã¤ritelmÃ¤ merkintÃ¤/pÃ¤ivitys',0),(288089,8003,'no','Bill av materiale definisjon oppfÃ¸ring/Oppdater',0),(288090,8003,'da','Bill af materialer Definition post/Update',0),(288091,8003,'ko','ìž¬ë£Œ ì •ì˜ í•­ëª©/ì—…ë°ì´íŠ¸ì˜ ë¹Œ',0),(288092,8003,'he','×”×—×©×‘×•×Ÿ ×©×œ ×—×•×ž×¨×™ ×”×–× ×”/×¢×“×›×•×Ÿ ×”×’×“×¨×•×ª',0),(288093,8003,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï„Ï‰Î½ Ï…Î»Î¹ÎºÏŽÎ½ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…/ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Î¿ÏÎ¹ÏƒÎ¼Î¿Ï',0),(288094,8003,'zh','ææ–™æ¸…å•å®šä¹‰æ¡ç›®/æ›´æ–°\r\n',0),(288095,8003,'sv','Bill av material Definition intrÃ¤de/uppdatering',0),(288096,8003,'it','Bill di inserimento/aggiornamento delle definizioni materiali',0),(288097,8003,'tl','',0),(288098,8003,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3610;&#3636;&#3621;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(288099,8003,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾ à¤¬à¤¿à¤²',0),(288100,8003,'ms','Rang undang-undang bahan definisi kemasukan/kemas kini',0),(288101,8003,'ar','Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ù„Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« ØªØ¹Ø±ÙŠÙ Ø§Ù„Ù…ÙˆØ§Ø¯',0),(288102,8003,'fr','Projet de loi de matÃ©riaux dÃ©finition saisie/mise Ã  jour',0),(288103,8003,'jp','ææ–™å®šç¾©ã‚¨ãƒ³ãƒˆãƒª/æ›´æ–°ã®ãƒ“ãƒ«',0),(288104,8003,'pt','Bill de entrada/actualizaÃ§Ã£o de definiÃ§Ã£o de materiais',0),(288105,8003,'ru','Ð‘Ð¸Ð»Ð» Ð·Ð°Ð¿Ð¸ÑÐ¸/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¾Ð²',0),(288106,8003,'es','Lista de Materiales DefiniciÃ³n Ingresar/Actualizar',0),(288107,8003,'de','Bill of Material Definition Eintrag/Update',0),(288108,8003,'en','Bill of Materials Definition Entry/Update',0),(288109,8004,'is','',0),(288110,8004,'dr','ÙØ±Ù… Ø®Ø§Ù„ÙŠ',0),(288111,8004,'pr','ÙØ±Ù… Ø®Ø§Ù„ÙŠ',0),(288112,8004,'tr','BoÅŸ Form',0),(288113,8004,'pl','Pusty formularz',0),(288114,8004,'bg','ÐŸÑ€Ð°Ð·ÐµÐ½ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€',0),(288115,8004,'ur','Ø®Ø§Ù„ÛŒ ÙØ§Ø±Ù…',0),(288116,8004,'sr','ÐŸÑ€Ð°Ð·Ð°Ð½ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ†',0),(288117,8004,'vi','Máº«u trá»‘ng',0),(288118,8004,'af','Blanko Vorm',0),(288119,8004,'ro','Formular necompletat',0),(288120,8004,'et','TÃ¼hi vorm',0),(288121,8004,'si','Prazen obrazec',0),(288122,8004,'ba','Formulir kosong',0),(288123,8004,'nl','Leeg formulier',0),(288124,8004,'fi','TyhjÃ¤ lomake',0),(288125,8004,'no','Tomt skjema',0),(288126,8004,'da','Tom formular',0),(288127,8004,'ko','ë¹ˆ ì–‘ì‹',0),(288128,8004,'he','×˜×•×¤×¡ ×¨×™×§',0),(288129,8004,'el','ÎšÎµÎ½Î® Ï†ÏŒÏÎ¼Î±',0),(288130,8004,'zh','ç©ºç™½è¡¨æ ¼\r\n',0),(288131,8004,'sv','Tomt formulÃ¤r',0),(288132,8004,'it','Modulo vuoto',0),(288133,8004,'tl','',0),(288134,8004,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3623;&#3656;&#3634;&#3591;',0),(288135,8004,'hi','à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤ªà¤¤à¥à¤°',0),(288136,8004,'ms','Borang kosong',0),(288137,8004,'ar','Ù†Ù…ÙˆØ°Ø¬ ÙØ§Ø±Øº',0),(288138,8004,'fr','Formulaire vierge',0),(288139,8004,'jp','ç©ºç™½ã®ãƒ•ã‚©ãƒ¼ãƒ ',0),(288140,8004,'pt','FormulÃ¡rio em branco',0),(288141,8004,'ru','ÐŸÑƒÑÑ‚Ð°Ñ Ñ„Ð¾Ñ€Ð¼Ð°',0),(288142,8004,'es','Formulario en Blanco',0),(288143,8004,'de','Leeres Formular',0),(288144,8004,'en','Blank Form',0),(288145,8005,'is','',0),(288146,8005,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¨Ø§Ø² Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(288147,8005,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¨Ø§Ø² Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(288148,8005,'tr','DÃ¼zenleme yeniden aÃ§Ä±n',0),(288149,8005,'pl','Edycja zostanie ponownie',0),(288150,8005,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ñ‰Ðµ Ð²ÑŠÐ·Ð¾Ð±Ð½Ð¾Ð²Ð¸',0),(288151,8005,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú¾Ø± Ú©Ú¾ÙˆÙ„ÛŒÚº Ú¯Û’',0),(288152,8005,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ›Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ð¸',0),(288153,8005,'vi','Chá»‰nh Sá»­a Sáº½ Má»Ÿ Láº¡i',0),(288154,8005,'af','Redigeering Sal Heropen',0),(288155,8005,'ro','Editare va redeschide',0),(288156,8005,'et','Muutmine avaneb uuesti',0),(288157,8005,'si','Urejanje bo obnovilo',0),(288158,8005,'ba','Mengedit akan membuka kembali',0),(288159,8005,'nl','Bewerken zal heropenen',0),(288160,8005,'fi','Muokkaaminen uudelleen',0),(288161,8005,'no','Redigering vil gjenÃ¥pne',0),(288162,8005,'da','Redigering genÃ¥bner',0),(288163,8005,'ko','íŽ¸ì§‘ì„ ë‹¤ì‹œ ì—´ ê²ƒìž…ë‹ˆë‹¤.',0),(288164,8005,'he','×¢×¨×™×›×ª ×™×™×¤×ª×— ×ž×—×“×©',0),(288165,8005,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¸Î± Î±Î½Î¿Î¯Î¾ÎµÎ¹ ÎµÎº Î½Î­Î¿Ï…',0),(288166,8005,'zh','ç¼–è¾‘å°†é‡æ–°å¼€æ”¾\r\n',0),(288167,8005,'sv','Redigering kommer att Ã¥teruppta',0),(288168,8005,'it','Modifica riaprirÃ ',0),(288169,8005,'tl','',0),(288170,8005,'th','&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3592;&#3632;&#3619;&#3639;&#3657;&#3629;&#3615;&#3639;&#3657;&#3609;',0),(288171,8005,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤•à¥‹ à¤«à¤¿à¤° à¤¸à¥‡ à¤–à¥‹à¤²à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(288172,8005,'ms','Penyuntingan akan dibuka semula',0),(288173,8005,'ar','Ø³ÙŠØªÙ… ÙØªØ­ Ø¨Ø§Ø¨ Ø§Ù„ØªØ­Ø±ÙŠØ±',0),(288174,8005,'fr','Ã‰dition rouvrira',0),(288175,8005,'jp','ç·¨é›†ã‚’å†é–‹ã—ã¾ã™ã€‚',0),(288176,8005,'pt','EdiÃ§Ã£o vai reabrir',0),(288177,8005,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð±ÑƒÐ´ÐµÑ‚ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ð°',0),(288178,8005,'es','Editando Va a Reabrir',0),(288179,8005,'de','Bearbeiten Ã¶ffnet',0),(288180,8005,'en','Editing Will Reopen',0),(288181,8006,'is','',0),(288182,8006,'dr','Ø§Ú¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙƒØ§Ù…Ù„ Ø§Ø³Øª',0),(288183,8006,'pr','Ø§Ú¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙƒØ§Ù…Ù„ Ø§Ø³Øª',0),(288184,8006,'tr','EÄŸer PO tamamlandÄ±',0),(288185,8006,'pl','JeÅ›li PO kompletne',0),(288186,8006,'bg','ÐÐºÐ¾ PO Ð¿ÑŠÐ»Ð½Ð°',0),(288187,8006,'ur','Ø§Ú¯Ø± Ù¾Ùˆ Ù…Ú©Ù…Ù„',0),(288188,8006,'sr','ÐÐºÐ¾ ÐŸÐž ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½',0),(288189,8006,'vi','Náº¿u Ä‘Æ¡n mua hÃ ng hoÃ n thÃ nh',0),(288190,8006,'af','As PO voltooi',0),(288191,8006,'ro','DacÄƒ PO complet',0),(288192,8006,'et','Kui tÃ¤ielik PO',0),(288193,8006,'si','ÄŒe PO popolni',0),(288194,8006,'ba','Jika PO lengkap',0),(288195,8006,'nl','Als volledige PO',0),(288196,8006,'fi','Jos PO tÃ¤ydellinen',0),(288197,8006,'no','Hvis PO fullfÃ¸rt',0),(288198,8006,'da','Hvis PO komplet',0),(288199,8006,'ko','ë§Œì•½ ì™„ì „ í•œ í¬',0),(288200,8006,'he','×× ×¤×• ×”×©×œ×',0),(288201,8006,'el','Î•Î¬Î½ Î±Î½Î¬ Ï€Î»Î®ÏÎ·',0),(288202,8006,'zh','å¦‚æžœè®¢å•å®Œæˆ\r\n',0),(288203,8006,'sv','Om PO komplett',0),(288204,8006,'it','Se PO completa',0),(288205,8006,'tl','',0),(288206,8006,'th','&#3606;&#3657;&#3634;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(288207,8006,'hi','à¤…à¤—à¤° à¤ªà¥‹ à¤ªà¥‚à¤°à¤¾',0),(288208,8006,'ms','Jika PO yang lengkap',0),(288209,8006,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø¨Ùˆ ÙƒØ§Ù…Ù„Ø©',0),(288210,8006,'fr','Si PO complet',0),(288211,8006,'jp','å ´åˆã¯å®Œå…¨ãª PO',0),(288212,8006,'pt','Se PO completa',0),(288213,8006,'ru','Ð•ÑÐ»Ð¸ Ð¿Ð¾ Ð¿Ð¾Ð»Ð½Ð¾Ð¹',0),(288214,8006,'es','Si OC es Completo',0),(288215,8006,'de','Wenn PO vollstÃ¤ndig',0),(288216,8006,'en','If PO Complete',0),(288217,8007,'is','',0),(288218,8007,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ù†ÙˆØ´ØªÙ‡  Ø´ÙˆØ¯ Ø²ÙŠØ±Ø§ Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ø°ÙƒØ± Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(288219,8007,'pr','Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ù†ÙˆØ´ØªÙ‡  Ø´ÙˆØ¯ Ø²ÙŠØ±Ø§ Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÙŠ Ø°ÙƒØ± Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(288220,8007,'tr','Ã‡Ã¼nkÃ¼ hiÃ§bir satÄ±cÄ± atanmÄ±ÅŸ depozito Check yazÄ±lamÄ±yor',0),(288221,8007,'pl','SprawdÅº depozyt nie mogÄ… byÄ‡ zapisywane, poniewaÅ¼ nie ma dostawcy',0),(288222,8007,'bg','Ð’Ð»Ð¾Ð³ ÑˆÐ°Ñ… Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¿Ð¸ÑˆÐµ, Ð·Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð½ÑÐ¼Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½',0),(288223,8007,'ur','Ø¬Ù…Ø¹ Ú†ÛŒÚ© Ù„Ú©Ú¾Ø§ Ù†ÛÛŒÚº Ø¬Ø§ Ø³Ú©ØªØ§ Ú©ÛŒÙˆÙ†Ú©Û Ú©ÙˆØ¦ÛŒ ÙˆÛŒÙ†ÚˆØ± ØªÙÙˆÛŒØ¶ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(288224,8007,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÑƒÐ¿Ð¸ÑÐ¸Ð²Ð°Ñ‚Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ñ˜ÐµÑ€ Ð½ÐµÐ¼Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð´Ð¾Ð´ÐµÑ™ÐµÐ½Ð¸',0),(288225,8007,'vi','SÃ©c Ä‘áº·t trÆ°á»›c khÃ´ng viáº¿t Ä‘Æ°á»£c vÃ¬ khÃ´ng cÃ³ ngÆ°á»i bÃ¡n',0),(288226,8007,'af','Deposito tjek kan geskryf word omdat geen ondernemer toegewys',0),(288227,8007,'ro','Depozit a verifica nu poate fi scris, deoarece nici un furnizor desemnat',0),(288228,8007,'et','Tagatisraha sisse ei saa kirjutada, sest pole hankija mÃ¤Ã¤ratud',0),(288229,8007,'si','Vloga Äek ni mogoÄe zapisati, ker noben dobavitelj dodelil',0),(288230,8007,'ba','Deposit Check tidak dapat ditulis karena penjual tidak ditetapkan',0),(288231,8007,'nl','Storting selectievakje kan niet worden geschreven omdat geen leverancier toegewezen',0),(288232,8007,'fi','Internet-LAN ei voi kirjoittaa, koska toimittajaa ei mÃ¤Ã¤ritetty',0),(288233,8007,'no','Innskudd sjekk kan ikke skrives fordi ingen leverandÃ¸r tilordnet',0),(288234,8007,'da','Depositum Check kan ikke skrives, fordi ingen kreditor tildelt',0),(288235,8007,'ko','ì˜ˆê¸ˆ ì—†ìŒ ê³µê¸‰ ì—…ì²´ í• ë‹¹ ëœ ë•Œë¬¸ì— ì“¸ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(288236,8007,'he','×”×¤×™×§×“×•×Ÿ × ×™×ª×Ÿ ×œ×›×ª×•×‘ ×›×™ ××™×Ÿ ×¡×¤×§ ×©×”×•×§×¦×•',0),(288237,8007,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Ï‡Ï‰ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î³ÏÎ±Ï†Ï„ÎµÎ¯ Î³Î¹Î±Ï„Î¯ Î´ÎµÎ½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¹ÏƒÎ¸ÎµÎ¯',0),(288238,8007,'zh','æŒ‰é‡‘æ”¯ç¥¨ä¸èƒ½å†™å› ä¸ºæ²¡æœ‰ä¾›åº”å•†åˆ†é…\r\n',0),(288239,8007,'sv','InsÃ¤ttning kontroll inte kan skrivas eftersom ingen leverantÃ¶r tilldelas',0),(288240,8007,'it','Deposito assegno non puÃ² essere scritto perchÃ© nessun fornitore assegnato',0),(288241,8007,'tl','',0),(288242,8007,'th','&#3648;&#3594;&#3655;&#3588;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3586;&#3637;&#3618;&#3609;&#3652;&#3604;&#3657; &#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3592;&#3634;&#',0),(288243,8007,'hi','à¤œà¤®à¤¾ à¤šà¥‡à¤• à¤²à¤¿à¤–à¤¾ à¤œà¤¾ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾ à¤•à¥à¤¯à¥‹à¤‚à¤•à¤¿ à¤•à¥‹à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹ à¤¸à¥Œà¤‚à¤ªà¤¾',0),(288244,8007,'ms','Deposit cek tidak boleh ditulis kerana penjual tiada diperuntukkan',0),(288245,8007,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ù„Ù„Ø§ Ø¨Ø§Ø¦Ø¹ Ù…Ø¹ÙŠÙ†',0),(288246,8007,'fr','ChÃ¨que de dÃ©pÃ´t ne peut Ãªtre Ã©crites car aucun fournisseur n\'affectÃ©',0),(288247,8007,'jp','ä»•å…¥å…ˆãŒå‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ãªã„ãŸã‚ã«ã‚»ãƒ¼ãƒ•ãƒ†ã‚£ ãƒã‚§ãƒƒã‚¯ã‚’æ›¸ãè¾¼ã‚€ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(288248,8007,'pt','DepÃ³sito de cheque nÃ£o pode ser gravado porque nenhum fornecedor atribuÃ­do',0),(288249,8007,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ Ñ‡ÐµÐº Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½, Ð¿Ð¾Ñ‚Ð¾Ð¼Ñƒ Ñ‡Ñ‚Ð¾ Ð½Ð¸ Ð¾Ð´Ð¸Ð½ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½',0),(288250,8007,'es','Cheque de DepÃ³sito No Puede Ser Elaborado Porque No HabÃ­a Asignado un Proveedor',0),(288251,8007,'de','Kaution-Check kann nicht geschrieben werden, da kein Anbieter zugewiesen',0),(288252,8007,'en','Deposit Check Cannot Be Written Because No Vendor Assigned',0),(288253,8008,'is','',0),(288254,8008,'dr','Ù„ÙŠØ³Øª Ú†Ùƒ Ù‡Ø§ ',0),(288255,8008,'pr','Ù„ÙŠØ³Øª Ú†Ùƒ Ù‡Ø§ ',0),(288256,8008,'tr','Kontrol listesi',0),(288257,8008,'pl','Lista kontrolna',0),(288258,8008,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð·Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(288259,8008,'ur','ÙÛØ±Ø³Øª Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(288260,8008,'sr','Ð§ÐµÐº-Ð»Ð¸ÑÑ‚Ð°',0),(288261,8008,'vi','Danh sÃ¡ch SÃ©c',0),(288262,8008,'af','Lys van Tjeks',0),(288263,8008,'ro','Lista de verificare',0),(288264,8008,'et','Kontroll-loend',0),(288265,8008,'si','Preverite seznam',0),(288266,8008,'ba','Daftar Periksa',0),(288267,8008,'nl','Checklist',0),(288268,8008,'fi','Muistilista',0),(288269,8008,'no','Sjekkliste',0),(288270,8008,'da','Tjekliste',0),(288271,8008,'ko','ì²´í¬ ë¦¬ìŠ¤íŠ¸',0),(288272,8008,'he','×‘×“×•×§ ×¨×©×™×ž×”',0),(288273,8008,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(288274,8008,'zh','æ”¯ç¥¨åˆ—è¡¨\r\n',0),(288275,8008,'sv','Checklista',0),(288276,8008,'it','Check-List',0),(288277,8008,'tl','',0),(288278,8008,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3648;&#3594;&#3655;&#3588;',0),(288279,8008,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(288280,8008,'ms','Senarai Semak',0),(288281,8008,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„ØµÙƒÙˆÙƒ',0),(288282,8008,'fr','Liste de vÃ©rification',0),(288283,8008,'jp','ãƒã‚§ãƒƒã‚¯ ãƒªã‚¹ãƒˆ',0),(288284,8008,'pt','Lista de verificaÃ§Ã£o',0),(288285,8008,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(288286,8008,'es','Lista de Cheques',0),(288287,8008,'de','Check-Liste',0),(288288,8008,'en','Check List',0),(288289,8009,'is','',0),(288290,8009,'dr','ÙƒØ§Ù„ÙŠÙØ±Ù†ÙŠØ§',0),(288291,8009,'pr','ÙƒØ§Ù„ÙŠÙØ±Ù†ÙŠØ§',0),(288292,8009,'tr','California',0),(288293,8009,'pl','California',0),(288294,8009,'bg','ÐšÐ°Ð»Ð¸Ñ„Ð¾Ñ€Ð½Ð¸Ñ',0),(288295,8009,'ur','Ú©ÛŒÙ„ÛŒ ÙÙˆØ±Ù†ÛŒØ§',0),(288296,8009,'sr','Ð¦Ð°Ð»Ð¸Ñ„Ð¾Ñ€Ð½Ð¸Ð°',0),(288297,8009,'vi','California',0),(288298,8009,'af','Kalifornia',0),(288299,8009,'ro','California',0),(288300,8009,'et','California',0),(288301,8009,'si','California',0),(288302,8009,'ba','California',0),(288303,8009,'nl','CaliforniÃ«',0),(288304,8009,'fi','California',0),(288305,8009,'no','California',0),(288306,8009,'da','Californien',0),(288307,8009,'ko','ìº˜ë¦¬í¬ë‹ˆì•„',0),(288308,8009,'he','×§×œ×™×¤×•×¨× ×™×”',0),(288309,8009,'el','ÎšÎ±Î»Î¹Ï†ÏŒÏÎ½Î¹Î±',0),(288310,8009,'zh','ç¾Žå›½åŠ å·ž\r\n',0),(288311,8009,'sv','California',0),(288312,8009,'it','California',0),(288313,8009,'tl','',0),(288314,8009,'th','&#3649;&#3588;&#3621;&#3636;&#3615;&#3629;&#3619;&#3660;&#3648;&#3609;&#3637;&#3618;',0),(288315,8009,'hi','à¤•à¥ˆà¤²à¤¿à¤«à¥‹à¤°à¥à¤¨à¤¿à¤¯à¤¾',0),(288316,8009,'ms','California',0),(288317,8009,'ar','ÙƒØ§Ù„ÙŠÙÙˆØ±Ù†ÙŠØ§',0),(288318,8009,'fr','Californie',0),(288319,8009,'jp','ã‚«ãƒªãƒ•ã‚©ãƒ«ãƒ‹ã‚¢å·ž',0),(288320,8009,'pt','CalifÃ³rnia',0),(288321,8009,'ru','ÐšÐ°Ð»Ð¸Ñ„Ð¾Ñ€Ð½Ð¸Ñ',0),(288322,8009,'es','California',0),(288323,8009,'de','California',0),(288324,8009,'en','California',0),(288325,8010,'is','',0),(288326,8010,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(288327,8010,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(288328,8010,'tr','VarsayÄ±lan',0),(288329,8010,'pl','DomyÅ›lnie',0),(288330,8010,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(288331,8010,'ur','Ø·Û’ Ø´Ø¯Û',0),(288332,8010,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸',0),(288333,8010,'vi','Máº·c Ä‘á»‹nh',0),(288334,8010,'af','Verstekte',0),(288335,8010,'ro','ÃŽn mod implicit',0),(288336,8010,'et','Vaikimisi',0),(288337,8010,'si','Privzeto',0),(288338,8010,'ba','Standar',0),(288339,8010,'nl','Standaard',0),(288340,8010,'fi','Oletus',0),(288341,8010,'no','Standard',0),(288342,8010,'da','Standard',0),(288343,8010,'ko','ê¸°ë³¸',0),(288344,8010,'he','×‘×¨×™×¨×ª ×ž×—×“×œ',0),(288345,8010,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î®',0),(288346,8010,'zh','é»˜è®¤\r\n',0),(288347,8010,'sv','Standard',0),(288348,8010,'it','Predefinito',0),(288349,8010,'tl','',0),(288350,8010,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(288351,8010,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(288352,8010,'ms','Lalai',0),(288353,8010,'ar','Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠ',0),(288354,8010,'fr','Par dÃ©faut',0),(288355,8010,'jp','æ—¢å®š',0),(288356,8010,'pt','PadrÃ£o',0),(288357,8010,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(288358,8010,'es','Por Defecto',0),(288359,8010,'de','Standard',0),(288360,8010,'en','Default',0),(288361,8011,'is','',0),(288362,8011,'dr','ÙÙ„ÙˆØ±ÙŠØ¯Ø§ ',0),(288363,8011,'pr','ÙÙ„ÙˆØ±ÙŠØ¯Ø§ ',0),(288364,8011,'tr','Florida',0),(288365,8011,'pl','Florida',0),(288366,8011,'bg','Ð¤Ð»Ð¾Ñ€Ð¸Ð´Ð°',0),(288367,8011,'ur','ÙÙ„ÙˆØ±ÛŒÚˆØ§',0),(288368,8011,'sr','ÐÐ° Ð¤Ð»Ð¾Ñ€Ð¸Ð´Ð¸',0),(288369,8011,'vi','Florida',0),(288370,8011,'af','Florida',0),(288371,8011,'ro','Florida',0),(288372,8011,'et','Florida',0),(288373,8011,'si','Florida',0),(288374,8011,'ba','Florida',0),(288375,8011,'nl','Florida',0),(288376,8011,'fi','Florida',0),(288377,8011,'no','Florida',0),(288378,8011,'da','Florida',0),(288379,8011,'ko','í”„ë¡œ ë¦¬ ë‹¤',0),(288380,8011,'he','×¤×œ×•×¨×™×“×”',0),(288381,8011,'el','Î¦Î»ÏŒÏÎ¹Î½Ï„Î±',0),(288382,8011,'zh','ä½›ç½—é‡Œè¾¾\r\n',0),(288383,8011,'sv','Florida',0),(288384,8011,'it','Florida',0),(288385,8011,'tl','',0),(288386,8011,'th','Florida',0),(288387,8011,'hi','à¤«à¥à¤²à¥‹à¤°à¤¿à¤¡à¤¾',0),(288388,8011,'ms','Florida',0),(288389,8011,'ar','ÙÙ„ÙˆØ±ÙŠØ¯Ø§',0),(288390,8011,'fr','Floride',0),(288391,8011,'jp','ãƒ•ãƒ­ãƒªãƒ€å·ž',0),(288392,8011,'pt','Florida',0),(288393,8011,'ru','Ð¤Ð»Ð¾Ñ€Ð¸Ð´Ð°',0),(288394,8011,'es','Florida',0),(288395,8011,'de','Florida',0),(288396,8011,'en','Florida',0),(288397,8012,'is','',0),(288398,8012,'dr',' Ø¢ÙŠÙƒÙˆÙ† Ú¯Ø±ÙˆÙ‡ ',0),(288399,8012,'pr',' Ø¢ÙŠÙƒÙˆÙ† Ú¯Ø±ÙˆÙ‡ ',0),(288400,8012,'tr','Simge grubu',0),(288401,8012,'pl','Grupa ikona',0),(288402,8012,'bg','Ð˜ÐºÐ¾Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(288403,8012,'ur','Ø´Ø¨ÛŒÛ Ú¯Ø±ÙˆÙ¾',0),(288404,8012,'sr','Ð˜ÐºÐ¾Ð½Ð° Ð³Ñ€ÑƒÐ¿Ðµ',0),(288405,8012,'vi','NhÃ³m biá»ƒu tÆ°á»£ng',0),(288406,8012,'af','Ikoongroep',0),(288407,8012,'ro','Pictograma grupului',0),(288408,8012,'et','Ikoonid',0),(288409,8012,'si','Ikona skupine',0),(288410,8012,'ba','Ikon Group',0),(288411,8012,'nl','Pictogram groep',0),(288412,8012,'fi','Kuvake ryhmÃ¤n',0),(288413,8012,'no','Icon-gruppen',0),(288414,8012,'da','Ikonet gruppe',0),(288415,8012,'ko','ì•„ì´ì½˜ ê·¸ë£¹',0),(288416,8012,'he','×¡×ž×œ ×”×§×‘×•×¦×”',0),(288417,8012,'el','ÎŸÎ¼Î¬Î´Î± ÎµÎ¹ÎºÎ¿Î½Î¯Î´Î¹Î¿',0),(288418,8012,'zh','å›¾æ ‡ç»„\r\n',0),(288419,8012,'sv','Ikonen grupp',0),(288420,8012,'it','Icona di gruppo',0),(288421,8012,'tl','',0),(288422,8012,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3652;&#3629;&#3588;&#3629;&#3609;',0),(288423,8012,'hi','à¤šà¤¿à¤¹à¥à¤¨ à¤¸à¤®à¥‚à¤¹',0),(288424,8012,'ms','Kumpulan ikon',0),(288425,8012,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø£ÙŠÙ‚ÙˆÙ†Ø§Øª',0),(288426,8012,'fr','IcÃ´ne de groupe',0),(288427,8012,'jp','ã‚¢ã‚¤ã‚³ãƒ³ ã‚°ãƒ«ãƒ¼ãƒ—',0),(288428,8012,'pt','Grupo Ã­cone',0),(288429,8012,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð˜ÐºÐ¾Ð½',0),(288430,8012,'es','Grupo de Iconos',0),(288431,8012,'de','Symbol-Gruppe',0),(288432,8012,'en','Icon Group',0),(288433,8013,'is','',0),(288434,8013,'dr','Ø¨Ø§ÙŠØ¯ Ø¨Ø±Ø§ÙŠ ØªØ±ØªÙŠØ¨ Ø§Ø«Ø± Ø¯Ø§Ø¯Ù† Ø¨Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ø§Ø² Ø³ÙŠØ³ØªÙ… Ø®Ø§Ø±Ø¬ Ø´ÙˆÙŠØ¯ ',0),(288435,8013,'pr','Ø¨Ø§ÙŠØ¯ Ø¨Ø±Ø§ÙŠ ØªØ±ØªÙŠØ¨ Ø§Ø«Ø± Ø¯Ø§Ø¯Ù† Ø¨Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ø§Ø² Ø³ÙŠØ³ØªÙ… Ø®Ø§Ø±Ø¬ Ø´ÙˆÙŠØ¯ ',0),(288436,8013,'tr','DeÄŸiÅŸikliklerin etkili olmasÄ± iÃ§in oturumu kapatÄ±p gerekir',0),(288437,8013,'pl','NaleÅ¼y wylogowania dla zmiany odniosÅ‚y skutek',0),(288438,8013,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð»ÐµÐ·ÐµÑ‚Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð²Ð»ÑÐ·Ð°Ñ‚ Ð² ÑÐ¸Ð»Ð°',0),(288439,8013,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©Ùˆ Ù…ÙˆØ«Ø± Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù„Ø§Ú¯ Ø¢Ø¤Ù¹ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(288440,8013,'sr','ÐœÐ¾Ñ€Ð° ÑÐµ Ð¾Ð´Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ Ð·Ð° Ð¸Ð·Ð¼Ñ˜ÐµÐ½Ðµ ÑÑ‚ÑƒÐ¿Ð¸Ð»Ðµ',0),(288441,8013,'vi','Pháº£i Ä‘Äƒng xuáº¥t Ä‘á»ƒ thay Ä‘á»•i há»¯u hiá»‡u',0),(288442,8013,'af','U Moet Uitteken Vir Veranderinge om Effektief te Raak',0),(288443,8013,'ro','Trebuie sa iesiti pentru modificÄƒrile sÄƒ aibÄƒ efect',0),(288444,8013,'et','Muutuste jÃµustumiseks pead vÃ¤lja logima',0),(288445,8013,'si','Mora Logout za spremembe zaÄnejo veljati',0),(288446,8013,'ba','Harus Logout untuk perubahan berlaku',0),(288447,8013,'nl','Moet uitloggen voor wijzigingen door te voeren',0),(288448,8013,'fi','On Logout muutokset tulevat voimaan',0),(288449,8013,'no','MÃ¥ Logg For at endringene skal tre i kraft',0),(288450,8013,'da','Skal Logout For at Ã¦ndringerne kan trÃ¦de i kraft',0),(288451,8013,'ko','ë³€ê²½ ë‚´ìš©ì„ ì ìš© í•˜ë ¤ë©´ ë¡œê·¸ ì•„ì›ƒì„ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(288452,8013,'he','×‘×˜×— ×”×ª× ×ª×§ ×©×™× ×•×™×™× ×©×”×©×™× ×•×™×™× ×™×™×›× ×¡×• ×œ×ª×•×§×£',0),(288453,8013,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î±Ï€Î¿ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Î³Î¹Î± Î½Î± Î¹ÏƒÏ‡ÏÏƒÎ¿Ï…Î½ Î¿Î¹ Î±Î»Î»Î±Î³Î­Ï‚',0),(288454,8013,'zh','å¿…é¡»æ³¨é”€ä½¿å˜æ›´ç”Ÿæ•ˆ\r\n',0),(288455,8013,'sv','MÃ¥ste logga ut fÃ¶r att verkstÃ¤lla Ã¤ndringarna',0),(288456,8013,'it','Deve Logout per rendere effettive le modifiche',0),(288457,8013,'tl','',0),(288458,8013,'th','&#3605;&#3657;&#3629;&#3591;&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3',0),(288459,8013,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¥‹à¤‚ à¤•à¥‹ à¤ªà¥à¤°à¤­à¤¾à¤µà¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥‰à¤—à¤†à¤‰à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(288460,8013,'ms','Mesti log keluar supaya perubahan dapat berkuat kuasa',0),(288461,8013,'ar','Ù„Ø§Ø¨Ø¯ Ù…Ù† Ø§Ù„Ø®Ø±ÙˆØ¬ Ù„ÙƒÙŠ ØªÙ†ÙÙ‘Ø° Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(288462,8013,'fr','Doit se dÃ©connecter pour les modifications prennent effet',0),(288463,8013,'jp','å¤‰æ›´ã‚’åæ˜ ã®ãƒ­ã‚°ã‚¢ã‚¦ãƒˆã‚’ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(288464,8013,'pt','Deve Logout para que as alteraÃ§Ãµes entrem em vigor',0),(288465,8013,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð’Ñ‹Ð¹Ñ‚Ð¸ Ð”Ð»Ñ ÐŸÑ€Ð¸Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(288466,8013,'es','Debe Logout para que los Cambios Surten Efecto',0),(288467,8013,'de','Logout fÃ¼r die Ã„nderungen wirksam werden mÃ¼ssen',0),(288468,8013,'en','Must Logout For Changes To Take Effect',0),(288469,8014,'is','',0),(288470,8014,'dr','Ø§ÙƒÙ„Ø§Ù‡Ø§Ù…Ø§',0),(288471,8014,'pr','Ø§ÙƒÙ„Ø§Ù‡Ø§Ù…Ø§',0),(288472,8014,'tr','Oklahoma',0),(288473,8014,'pl','Oklahoma',0),(288474,8014,'bg','ÐžÐºÐ»Ð°Ñ…Ð¾Ð¼Ð°',0),(288475,8014,'ur','Ø§ÙˆÚ©Ù„Ø§ÛÙˆÙ…Ø§',0),(288476,8014,'sr','ÐžÐºÐ»Ð°Ñ…Ð¾Ð¼Ð°',0),(288477,8014,'vi','Oklahoma',0),(288478,8014,'af','Oklahoma',0),(288479,8014,'ro','Oklahoma',0),(288480,8014,'et','Oklahoma',0),(288481,8014,'si','Oklahoma',0),(288482,8014,'ba','Oklahoma',0),(288483,8014,'nl','Oklahoma',0),(288484,8014,'fi','Oklahoma',0),(288485,8014,'no','Oklahoma',0),(288486,8014,'da','Oklahoma',0),(288487,8014,'ko','ì˜¤í´ë¼í˜¸ë§ˆ',0),(288488,8014,'he','××•×§×œ×”×•×ž×”',0),(288489,8014,'el','ÎŸÎºÎ»Î±Ï‡ÏŒÎ¼Î±',0),(288490,8014,'zh','ä¿„å…‹æ‹‰è·é©¬\r\n',0),(288491,8014,'sv','Oklahoma',0),(288492,8014,'it','Oklahoma',0),(288493,8014,'tl','',0),(288494,8014,'th','Oklahoma',0),(288495,8014,'hi','à¤“à¤•à¥à¤²à¤¾à¤¹à¥‹à¤®à¤¾',0),(288496,8014,'ms','Oklahoma',0),(288497,8014,'ar','Ø£ÙˆÙƒÙ„Ø§Ù‡ÙˆÙ…Ø§',0),(288498,8014,'fr','Oklahoma',0),(288499,8014,'jp','ã‚ªã‚¯ãƒ©ãƒ›ãƒž',0),(288500,8014,'pt','Oklahoma',0),(288501,8014,'ru','ÐžÐºÐ»Ð°Ñ…Ð¾Ð¼Ð°',0),(288502,8014,'es','Oklahoma',0),(288503,8014,'de','Oklahoma',0),(288504,8014,'en','Oklahoma',0),(288505,8015,'is','',0),(288506,8015,'dr','Ø§ÙŠØ§Ù„Øª ÙˆØ±Ù…ÙˆÙ†Øª ',0),(288507,8015,'pr','Ø§ÙŠØ§Ù„Øª ÙˆØ±Ù…ÙˆÙ†Øª ',0),(288508,8015,'tr','Vermont',0),(288509,8015,'pl','Vermont',0),(288510,8015,'bg','Ð’ÑŠÑ€Ð¼Ð¾Ð½Ñ‚',0),(288511,8015,'ur','ÙˆØ±Ù…ÙˆÙ†Ù¹',0),(288512,8015,'sr','Ð’ÐµÑ€Ð¼Ð¾Ð½Ñ‚',0),(288513,8015,'vi','Vermont',0),(288514,8015,'af','Vermont',0),(288515,8015,'ro','Vermont',0),(288516,8015,'et','Vermont',0),(288517,8015,'si','Vermont',0),(288518,8015,'ba','Vermont',0),(288519,8015,'nl','Vermont',0),(288520,8015,'fi','Vermont',0),(288521,8015,'no','Vermont',0),(288522,8015,'da','Vermont',0),(288523,8015,'ko','ë²„ëª¬íŠ¸',0),(288524,8015,'he','×•×¨×ž×•× ×˜',0),(288525,8015,'el','Î’ÎµÏÎ¼ÏŒÎ½Ï„',0),(288526,8015,'zh','ä½›è’™ç‰¹\r\n',0),(288527,8015,'sv','Vermont',0),(288528,8015,'it','Vermont',0),(288529,8015,'tl','',0),(288530,8015,'th','&#3619;&#3633;&#3600;&#3648;&#3623;&#3629;&#3619;&#3660;&#3617;&#3629;&#3609;&#3607;&#3660;',0),(288531,8015,'hi','à¤µà¤°à¤®à¥‹à¤‚à¤Ÿ',0),(288532,8015,'ms','Vermont',0),(288533,8015,'ar','ÙÙŠØ±Ù…ÙˆÙ†Øª',0),(288534,8015,'fr','Vermont',0),(288535,8015,'jp','ãƒãƒ¼ãƒ¢ãƒ³ãƒˆå·ž',0),(288536,8015,'pt','Vermont',0),(288537,8015,'ru','Ð’ÐµÑ€Ð¼Ð¾Ð½Ñ‚',0),(288538,8015,'es','Vermont',0),(288539,8015,'de','Vermont',0),(288540,8015,'en','Vermont',0),(288541,8016,'is','',0),(288542,8016,'dr','XP   Ù…Ø¯Ù„ Ø§ÙƒØ³- Ù¾ÙŠ',0),(288543,8016,'pr','XP   Ù…Ø¯Ù„ Ø§ÙƒØ³- Ù¾ÙŠ',0),(288544,8016,'tr','XP stili',0),(288545,8016,'pl','Styl XP',0),(288546,8016,'bg','XP ÑÑ‚Ð¸Ð»',0),(288547,8016,'ur','Ø§ÛŒÚ©Ø³ Ù¾ÛŒ Ø·Ø±Ø²',0),(288548,8016,'sr','XÐŸ ÑÑ‚Ð¸Ð»',0),(288549,8016,'vi','Kiá»ƒu XP',0),(288550,8016,'af','XP Styl',0),(288551,8016,'ro','XP Stil',0),(288552,8016,'et','XP-Style',0),(288553,8016,'si','XP stil',0),(288554,8016,'ba','Gaya XP',0),(288555,8016,'nl','XP-stijl',0),(288556,8016,'fi','XP-tyyli',0),(288557,8016,'no','XP-stil',0),(288558,8016,'da','XP Style',0),(288559,8016,'ko','XP ìŠ¤íƒ€ì¼',0),(288560,8016,'he','×¡×’× ×•×Ÿ XP',0),(288561,8016,'el','XP Style',0),(288562,8016,'zh','XPé£Žæ ¼\r\n',0),(288563,8016,'sv','XP-format',0),(288564,8016,'it','Stile XP',0),(288565,8016,'tl','',0),(288566,8016,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610; XP',0),(288567,8016,'hi','XP à¤¶à¥ˆà¤²à¥€',0),(288568,8016,'ms','Gaya XP',0),(288569,8016,'ar','Ù†Ù…Ø· Ø§Ù„Ù€ Ø¥ÙƒØ³ Ø¨ÙŠ',0),(288570,8016,'fr','Style XP',0),(288571,8016,'jp','XP ã‚¹ã‚¿ã‚¤ãƒ«',0),(288572,8016,'pt','Estilo XP',0),(288573,8016,'ru','XP ÑÑ‚Ð¸Ð»ÑŒ',0),(288574,8016,'es','Estilo XP',0),(288575,8016,'de','XP-Stil',0),(288576,8016,'en','XP Style',0),(288577,8017,'is','',0),(288578,8017,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(288579,8017,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(288580,8017,'tr','PO Not',0),(288581,8017,'pl','Uwaga PO',0),(288582,8017,'bg','PO Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(288583,8017,'ur','Ù¾Ùˆ Ù†ÙˆÙ¹',0),(288584,8017,'sr','ÐŸÐž ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(288585,8017,'vi','Ghi chÃº Ä‘Æ¡n mua hÃ ng',0),(288586,8017,'af','AB Nota',0),(288587,8017,'ro','NotÄƒ PO',0),(288588,8017,'et','PO MÃ¤rkus',0),(288589,8017,'si','Opomba PO',0),(288590,8017,'ba','Catatan PO',0),(288591,8017,'nl','PO Opmerking',0),(288592,8017,'fi','PO Huomautus',0),(288593,8017,'no','PO Merk',0),(288594,8017,'da','PO BemÃ¦rk',0),(288595,8017,'ko','í¬ ì£¼',0),(288596,8017,'he','×”×¢×¨×” ×¤×•',0),(288597,8017,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· PO',0),(288598,8017,'zh','é‡‡è´­è®¢å•å¤‡æ³¨\r\n',0),(288599,8017,'sv','PO Anm',0),(288600,8017,'it','Nota di PO',0),(288601,8017,'tl','',0),(288602,8017,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(288603,8017,'hi','PO à¤¨à¥‹à¤Ÿ',0),(288604,8017,'ms','Nota PO',0),(288605,8017,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(288606,8017,'fr','Note de PO',0),(288607,8017,'jp','PO ã®ãƒ¡ãƒ¢',0),(288608,8017,'pt','PO nota',0),(288609,8017,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ PO',0),(288610,8017,'es','OC Nota',0),(288611,8017,'de','PO-Hinweis',0),(288612,8017,'en','PO Note',0),(288613,8018,'is','',0),(288614,8018,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³Ø·Ø­',0),(288615,8018,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³Ø·Ø­',0),(288616,8018,'tr','AyrÄ±ntÄ± dÃ¼zeyi seÃ§in',0),(288617,8018,'pl','Wybierz poziom szczegÃ³Å‚owoÅ›ci',0),(288618,8018,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¸Ð²Ð¾ Ð½Ð° Ð´ÐµÑ‚Ð°Ð¹Ð»Ð½Ð¾ÑÑ‚',0),(288619,8018,'ur','ØªÙØµÛŒÙ„ Ø³Ø·Ø­ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(288620,8018,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð¸Ð²Ð¾ Ð´ÐµÑ‚Ð°Ñ™Ð°',0),(288621,8018,'vi','Lá»±a chá»n má»©c chi tiáº¿t',0),(288622,8018,'af','Kies die vlak van Detail',0),(288623,8018,'ro','SelectaÅ£i nivelul de detaliu',0),(288624,8018,'et','Valige Ã¼ksikasjade tase',0),(288625,8018,'si','Izberite raven podrobnosti',0),(288626,8018,'ba','Pilih tingkat Detail',0),(288627,8018,'nl','Selecteer detailniveau',0),(288628,8018,'fi','Valitse taso',0),(288629,8018,'no','Velg detaljnivÃ¥et',0),(288630,8018,'da','VÃ¦lg detaljeringsniveauet',0),(288631,8018,'ko','ì„¸ë¶€ ìˆ˜ì¤€ ì„ íƒ',0),(288632,8018,'he','×‘×—×¨ ×¨×ž×ª ×”×¤×™×¨×•×˜',0),(288633,8018,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±Ï‚',0),(288634,8018,'zh','é€‰æ‹©è¯¦ç»†ç¨‹åº¦\r\n',0),(288635,8018,'sv','VÃ¤lj detaljnivÃ¥',0),(288636,8018,'it','Selezionare il livello di dettaglio',0),(288637,8018,'tl','',0),(288638,8018,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(288639,8018,'hi','à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¥‡ à¤¸à¥à¤¤à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(288640,8018,'ms','Pilih aras terperinci',0),(288641,8018,'ar','Ø­Ø¯Ø¯ Ù…Ø³ØªÙˆÙ‰ Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(288642,8018,'fr','SÃ©lectionnez le niveau de dÃ©tail',0),(288643,8018,'jp','è©³ç´°ãƒ¬ãƒ™ãƒ«ã‚’é¸æŠžã—ã¾ã™',0),(288644,8018,'pt','Selecione o nÃ­vel de detalhe',0),(288645,8018,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð”ÐµÑ‚Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ',0),(288646,8018,'es','Seleccionar Nivel de Detalle',0),(288647,8018,'de','WÃ¤hlen Sie Detailstufe',0),(288648,8018,'en','Select Detail Level',0),(288649,8019,'is','',0),(288650,8019,'dr','ØªØ°ÙƒØ±Ø§Øª Ùˆ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯Ø§Øª ',0),(288651,8019,'pr','ØªØ°ÙƒØ±Ø§Øª Ùˆ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯Ø§Øª ',0),(288652,8019,'tr','Ä°puÃ§larÄ± & Ä°puÃ§larÄ±',0),(288653,8019,'pl','WskazÃ³wki & porady',0),(288654,8019,'bg','Ð¡ÑŠÐ²ÐµÑ‚Ð¸ & Ð¡ÑŠÐ²ÐµÑ‚Ð¸',0),(288655,8019,'ur','Ø¨Ù„Ø§Ù†Û’ & ØªØ¬Ø§ÙˆÛŒØ²',0),(288656,8019,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ & ÑÐ°Ð²ÐµÑ‚Ð¸',0),(288657,8019,'vi','Gá»£i Ã & MÃ¡ch Nhá»',0),(288658,8019,'af','Wenke',0),(288659,8019,'ro','Indicii & sfaturi',0),(288660,8019,'et','NÃ¤punÃ¤ited',0),(288661,8019,'si','Namigi & Nasveti',0),(288662,8019,'ba','Petunjuk & Tips',0),(288663,8019,'nl','Hints & Tips',0),(288664,8019,'fi','VinkkejÃ¤ & vinkkejÃ¤',0),(288665,8019,'no','Hint & Tips',0),(288666,8019,'da','Hints & Tips',0),(288667,8019,'ko','ížŒíŠ¸ & íŒ',0),(288668,8019,'he','×˜×™×¤×™× & ×¨×ž×–×™',0),(288669,8019,'el','& Î£Ï…Î¼Î²Î¿Ï…Î»Î­Ï‚ Î£Ï…Î¼Î²Î¿Ï…Î»Î­Ï‚',0),(288670,8019,'zh','æç¤ºä¸ŽæŠ€å·§\r\n',0),(288671,8019,'sv','Tips & Tips',0),(288672,8019,'it','Suggerimenti consigli &',0),(288673,8019,'tl','',0),(288674,8019,'th','&#3585;&#3634;&#3619;&#3610;&#3629;&#3585;&#3651;&#3610;&#3657;&#3649;&#3621;&#3632;&#3588;&#3635;&#3649;&#3609;&#3632;&#3609;&#3635;',0),(288675,8019,'hi','à¤¸à¤‚à¤•à¥‡à¤¤ & à¤Ÿà¤¿à¤ªà¥à¤¸',0),(288676,8019,'ms','Petua & Tips',0),(288677,8019,'ar','ØªÙ„Ù…ÙŠØ­Ø§Øª Ù†ØµØ§Ø¦Ø­ Ø¢Ù†Ø¯',0),(288678,8019,'fr','Astuces conseils &',0),(288679,8019,'jp','ãƒ’ãƒ³ãƒˆ &',0),(288680,8019,'pt','Dicas de & dicas',0),(288681,8019,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ¸ & ÑÐ¾Ð²ÐµÑ‚Ñ‹',0),(288682,8019,'es','Pistas & Sugerencias',0),(288683,8019,'de','Tipps- & Tipps',0),(288684,8019,'en','Hints & Tips',0),(288685,8020,'is','',0),(288686,8020,'dr','Ù…Ø³ÙŠØ± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø¨Ø§ÙŠØ¯ ØªÙˆØ³Ø· Ø¢Ù¾Ø§Ú†ÙŠ Ø¨Ù‡  Ù…Ù†Ø¸ÙˆØ± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ù‡Øª Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø§Ø¯Ù† Ù‚Ø§Ø¨Ù„ Ø¯Ø±Ø¬ Ø¨Ø§Ø´Ø¯',0),(288687,8020,'pr','Ù…Ø³ÙŠØ± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø¨Ø§ÙŠØ¯ ØªÙˆØ³Ø· Ø¢Ù¾Ø§Ú†ÙŠ Ø¨Ù‡  Ù…Ù†Ø¸ÙˆØ± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ù‡Øª Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø§Ø¯Ù† Ù‚Ø§Ø¨Ù„ Ø¯Ø±Ø¬ Ø¨Ø§Ø´Ø¯',0),(288688,8020,'tr','NolaPro dizin gÃ¼ncelleÅŸtirme devam etmek amacÄ±yla Apache tarafÄ±ndan yazÄ±labilir olmalÄ±dÄ±r.',0),(288689,8020,'pl','Katalog NolaPro musi byÄ‡ zapisywalny przez Apache w celu aktualizacji nadal.',0),(288690,8020,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸ÑÑ‚Ð° Ð½Ð° NolaPro Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ²Ð° Ð¾Ñ‚ Apache Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ, Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸Ñ‚Ðµ Ð´Ð°.',0),(288691,8020,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ ÚˆØ§Ø¦Ø±ÛŒÚ©Ù¹Ø±ÛŒ Ø§Ù¾Ø§Ú†ÛŒ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù‚Ø§Ø¨Ù„ ØªØ­Ø±ÛŒØ± Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ ØªØ±ØªÛŒØ¨ Ù…ÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ Û”',0),(288692,8020,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ñ˜Ðµ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ñ˜ÑƒÐ¼ ÑƒÐ¿Ð¸ÑÐ¸Ð² Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ ÐÐ¿Ð°Ñ†Ñ…Ðµ Ñƒ Ñ€ÐµÐ´Ñƒ Ð·Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸.',0),(288693,8020,'vi','NiÃªn GiÃ¡m NolaPro pháº£i viáº¿t trÃªn Apache Ä‘á»ƒ cÃ³ thá»ƒ tiáº¿p tá»¥c cáº­p nháº­t.',0),(288694,8020,'af','Die NolaPro Gids (\"directory\") moet Apache toelaat om daarin te skryf ter uitvoering van \'n opdatering.',0),(288695,8020,'ro','Directorul NolaPro trebuie sÄƒ fie scris de Apache pentru ca actualizarea sÄƒ continue.',0),(288696,8020,'et','NolaPro kataloogi tuleb kirjutatav Apache vÃ¤rskendus jÃ¤tkata selleks.',0),(288697,8020,'si','NolaPro imenik mora biti primeren da se napiÅ¡e z Apache v redu zakaj modernizirati Å¡e.',0),(288698,8020,'ba','NolaPro direktori ini harus bisa ditulisi oleh Apache agar update terus.',0),(288699,8020,'nl','De NolaPro map moet schrijfbaar door Apache om de update te blijven.',0),(288700,8020,'fi','NolaPro hakemistossa on kirjoitettava luona Joutuisasti, jotta jatkaa pÃ¤ivitystÃ¤.',0),(288701,8020,'no','Mappen NolaPro mÃ¥ vÃ¦re skrivbar av Apache for oppdateringen fortsette.',0),(288702,8020,'da','NolaPro mappen skal skrivbar af Apache for at opdatere hen til fortsÃ¦tte.',0),(288703,8020,'ko','NolaPro ë””ë ‰í„°ë¦¬ ì•„íŒŒì¹˜ ìˆœì„œ ëŒ€ë¡œ ê³„ì† ì—…ë°ì´ íŠ¸ì— ëŒ€ í•œ ì“°ê¸° ê¶Œí•œì´ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(288704,8020,'he','×”×¡×¤×¨×™×” NolaPro ×—×™×™×‘ ×œ×”×™×•×ª ×œ×›×ª×™×‘×” ×¢×œ-×™×“×™ ××¤××¦\'×™ ×¢×œ ×ž× ×ª ×œ×”×ž×©×™×š ×‘×ª×”×œ×™×š ×”×¢×“×›×•×Ÿ.',0),(288705,8020,'el','ÎŸ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ NolaPro Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎµÎ³Î³ÏÎ¬ÏˆÎ¹Î¼Î¿Ï‚ Î±Ï€ÏŒ Apache Î³Î¹Î± Ï„Î·Î½ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Î³Î¹Î± Î½Î± ÏƒÏ…Î½ÎµÏ‡Î¯ÏƒÎµÎ¹.',0),(288706,8020,'zh','è¯¥NolaProç›®å½•å¿…é¡»æ˜¯Apacheå¯å†™çš„ï¼Œä»¥ä¾¿æ›´æ–°åŠŸèƒ½å¾—ä»¥ç»§ç»­ã€‚\r\n',0),(288707,8020,'sv','NolaPro katalogen mÃ¥ste vara skrivbar av Apache fÃ¶r uppdateringen att fortsÃ¤tta.',0),(288708,8020,'it','La directory NolaPro deve essere scrivibile da Apache in modo che l\'aggiornamento continuare.',0),(288709,8020,'tl','',0),(288710,8020,'th','The NolaPro directory must be writable by Apache in order for the update to continue.',0),(288711,8020,'hi','NolaPro à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¤¿à¤•à¤¾ writable à¤¦à¥à¤µà¤¾à¤°à¤¾ Apache à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤œà¤¾à¤°à¥€ à¤°à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(288712,8020,'ms','Direktori NolaPro mestilah boleh tulis oleh Apache untuk Kemaskini terus.',0),(288713,8020,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Apache Ù‚Ø§Ø¯Ø±Ø§Ù‹ Ø¹Ù„Ù‰ Ø§Ù„ÙƒØªØ§Ø¨Ø© ÙÙŠ Ù…Ø¬Ù„Ø¯ NolaPro Ø­ØªÙ‰ ÙŠØ³ØªÙ…Ø± Ø§Ù„ØªØ­Ø¯ÙŠØ«.',0),(288714,8020,'fr','Le rÃ©pertoire NolaPro doit Ãªtre accessible en Ã©criture par Apache afin que la mise Ã  jour continuer.',0),(288715,8020,'jp','NolaPro ãƒ‡ã‚£ãƒ¬ã‚¯ãƒˆãƒªã¯æ›´æ–°ã‚’ç¶™ç¶šã™ã‚‹ãŸã‚ã« Apache ã«ã‚ˆã£ã¦æ›¸ãè¾¼ã¿å¯èƒ½ã§ãªã‘ã‚Œã°ãªã‚Šã¾ã›ã‚“ã€‚',0),(288716,8020,'pt','O NolaPro diretÃ³rio deve ser gravÃ¡vel pelo Apache para que a atualizaÃ§Ã£o continuar.',0),(288717,8020,'ru','NolaPro ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð»Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸ Apache Ð² Ð¿Ð¾Ñ€ÑÐ´ÐºÐµ Ð´Ð»Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÑŒ.',0),(288718,8020,'es','El directorio de NolaPro debe ser grabale por Apache con el fin de continuar la actualizaciÃ³n',0),(288719,8020,'de','Das Artikel-Verzeichnis muss Apache in Reihenfolge fÃ¼r das Update weiterhin schreibbar sein.',0),(288720,8020,'en','The NolaPro directory must be writable by Apache in order for the update to continue.',0),(288721,8021,'is','',0),(288722,8021,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø´Ø±ÙˆØ¹ Ø¨Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù† ÙƒÙ†Ø¯',0),(288723,8021,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø´Ø±ÙˆØ¹ Ø¨Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù† ÙƒÙ†Ø¯',0),(288724,8021,'tr','VeritabanÄ± gÃ¼ncelleÅŸtirme baÅŸlatmak iÃ§in burayÄ± tÄ±klatÄ±n.',0),(288725,8021,'pl','Kliknij tutaj, aby rozpoczÄ…Ä‡ aktualizacjÄ™ bazy danych.',0),(288726,8021,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸ÑÑ‚Ð° Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸.',0),(288727,8021,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø´Ø±ÙˆØ¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº.',0),(288728,8021,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð·Ð° Ð¿Ð¾Ñ‡ÐµÑ‚Ð°Ðº ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°.',0),(288729,8021,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ báº¯t Ä‘áº§u cáº­p nháº­t dá»¯ liá»‡u',0),(288730,8021,'af','Kliek hier om te begin met die databasis opdatering.',0),(288731,8021,'ro','Click aici pentru a Ã®ncepe actualizarea bazei de date.',0),(288732,8021,'et','Kliki andmebaasi uuendamiseks',0),(288733,8021,'si','Kliknite tukaj, da zaÄnete posodobitev zbirke podatkov.',0),(288734,8021,'ba','Klik di sini untuk memulai database update.',0),(288735,8021,'nl','Klik hier om te beginnen de database bijgewerkt.',0),(288736,8021,'fi','Napsauttamalla tÃ¤tÃ¤ voit aloittaa tietokannan pÃ¤ivitys.',0),(288737,8021,'no','Klikk her for Ã¥ starte databaseoppdateringen.',0),(288738,8021,'da','Klik her for at begynde database opdateringen.',0),(288739,8021,'ko','ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ ì—¬ ë°ì´í„°ë² ì´ìŠ¤ ì—…ë°ì´ íŠ¸ë¥¼ ì‹œìž‘ í•©ë‹ˆë‹¤.',0),(288740,8021,'he','.×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×ª×—×™×œ ×‘×¢×“×›×•×Ÿ ×ž×¡×“ ×”× ×ª×•× ×™×',0),(288741,8021,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î¾ÎµÎºÎ¹Î½Î®ÏƒÎµÎ¹ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½.',0),(288742,8021,'zh','ç‚¹å‡»è¿™é‡Œå¼€å§‹æ•°æ®åº“çš„æ›´æ–°ã€‚\r\n',0),(288743,8021,'sv','Klicka hÃ¤r fÃ¶r att bÃ¶rja en databasuppdatering.',0),(288744,8021,'it','Clicca qui per iniziare l\'aggiornamento del database.',0),(288745,8021,'tl','',0),(288746,8021,'th','&#3585;&#3604;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3619;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3',0),(288747,8021,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚à¥¤',0),(288748,8021,'ms','Klik di sini untuk memulakan Kemaskini pangkalan data.',0),(288749,8021,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„ØªØ¨Ø¯Ø£ ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª.',0),(288750,8021,'fr','Cliquez ici pour commencer la mise Ã  jour de la base de donnÃ©es.',0),(288751,8021,'jp','ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦ã€ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã®æ›´æ–°ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(288752,8021,'pt','Clique aqui para comeÃ§ar a atualizaÃ§Ã£o do banco de dados.',0),(288753,8021,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð´Ð»Ñ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ….',0),(288754,8021,'es','Click aquÃ­ para empezar la actualizaciÃ³n de la base de datos',0),(288755,8021,'de','Klicken Sie hier, um das Datenbank-Update.',0),(288756,8021,'en','Click here to begin the database update.',0),(288757,8022,'is','',0),(288758,8022,'dr','Ù†Ø±Ù Ø§ÙØ²Ø§Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ø§Ù…ØªÙŠØ§Ø²Ø§Øª ÙˆÙŠÚ˜Ù‡ Ù†Ø§Ø¸Ø± ÙˆØ§Ø±Ø¯ Ø³ÙŠØ³ØªÙ… Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ùˆ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¢Ù†Ø±Ø§ Ø¨Ù‡ ØµÙˆØ±Øª Ù„Ø­Ø¸Ù‡ Ø¨Ù‡ Ù„Ø­Ø¸Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ù…ÙŠ ÙƒÙ†Ø¯',0),(288759,8022,'pr','Ù†Ø±Ù Ø§ÙØ²Ø§Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø¨Ø§ Ø§Ù…ØªÙŠØ§Ø²Ø§Øª ÙˆÙŠÚ˜Ù‡ Ù†Ø§Ø¸Ø± ÙˆØ§Ø±Ø¯ Ø³ÙŠØ³ØªÙ… Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ùˆ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¢Ù†Ø±Ø§ Ø¨Ù‡ ØµÙˆØ±Øª Ù„Ø­Ø¸Ù‡ Ø¨Ù‡ Ù„Ø­Ø¸Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ù…ÙŠ ÙƒÙ†Ø¯',0),(288760,8022,'tr','Sistem gÃ¼ncelleÅŸtiriliyor. YÃ¶netici ayrÄ±calÄ±klarÄ± olan bir kullanÄ±cÄ± oturum aÃ§Ä±n ve veritabanÄ± gÃ¼ncelleÅŸtirme anlÄ±k olarak baÅŸlar.',0),(288761,8022,'pl','System jest aktualizowany. UÅ¼ytkownik z uprawnieniami inspektora bÄ™dzie zalogowaÄ‡ siÄ™ i rozpoczÄ…Ä‡ aktualizacjÄ™ bazy danych na chwilÄ™.',0),(288762,8022,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° ÑÐµ Ð¾Ð±Ð½Ð¾Ð²ÑÐ²Ð°. ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ñ Ð¿Ñ€Ð¸Ð²Ð¸Ð»ÐµÐ³Ð¸Ð¸ Ð½Ð° Ð½Ð°Ð´Ð·Ð¾Ñ€Ð° Ñ‰Ðµ Ð²Ð»ÐµÐ·ÐµÑ‚Ðµ Ð¸ Ð´Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸ÑÑ‚Ð° Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð¼Ð¸Ð³.',0),(288763,8022,'ur','Ø§Ø³ Ù†Ø¸Ø§Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ø¬Ø§ Ø±ÛÛŒ ÛÛ’ Û” Ø³Ù¾Ø±ÙˆØ§Ø¦Ø²Ø± Ú©Û’ Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ú©Û’ Ø³Ø§ØªÚ¾ ØµØ§Ø±Ù Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº Ú¯Û’ Ø§ÙˆØ± ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ø§Ù¾ ÚˆÛŒÙ¹ Ù…ÙˆÙ…Ø§Ù†ØªØ±Ø§Ù„ Ø´Ø±ÙˆØ¹.',0),(288764,8022,'sr','Ð¡Ð¸ÑÑ‚ÐµÐ¼ ÑÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°. ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº ÑÐ° Ð¿Ñ€Ð¸Ð²Ð¸Ð»ÐµÐ³Ð¸Ñ˜Ð°Ð¼Ð° Ð·Ð° ÑÑƒÐ¿ÐµÑ€Ð²Ð¸Ð·Ð¾Ñ€Ð° Ñ›Ðµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸ Ð¸ Ð¾Ð´Ð¼Ð°Ñ… Ð¿Ð¾Ñ‡ÐµÑ‚Ð¸ ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°.',0),(288765,8022,'vi','NolaPro Ä‘Ã£ Ä‘Æ°á»£c cáº­p nháº­t. Má»™t ngÆ°á»i sá»­ dá»¥ng vá»›i phÃ¢n quyá»n trÆ°á»Ÿng nhÃ³m sáº½ Ä‘Äƒng nháº­p vÃ  báº¯t Ä‘áº§u cáº­p nháº­t dá»¯ liá»‡u trong giÃ¢y lÃ¡t.',0),(288766,8022,'af','NolaPro word tans opdateer. \'n Gebruiker met toesighouermagtiging sal aanmeld en voortgaan om die databasis vir \'n oomblik op te dateer. ',0),(288767,8022,'ro','Sistemul este actualizat. Un utilizator cu privilegii de supervizor va autentifica ÅŸi Ã®ncepe actualizarea bazei de date momentan.',0),(288768,8022,'et','SÃ¼steem on vÃ¤rskendatud. Halduri Ãµigustega kasutaja sisse logida ja alustada andmebaasi uuendamine hetkeks.',0),(288769,8022,'si','Sistem se posodablja. Uporabnik s privilegiji nadzornik bo prijavite in zaÄeti Äasovno doloÄljiv modernizirati za trenutek.',0),(288770,8022,'ba','Sistem ini sedang diperbarui. Pengguna dengan hak istimewa pengawas akan log in dan mulai database update sejenak.',0),(288771,8022,'nl','Het systeem wordt bijgewerkt. Een gebruiker met de bevoegdheden van de toezichthouder zal inloggen en beginnen de database update tijdelijk.',0),(288772,8022,'fi','JÃ¤rjestelmÃ¤ on pÃ¤ivitetty. KÃ¤yttÃ¤jÃ¤ valvojan oikeuksia kirjautua sisÃ¤Ã¤n ja aloittaa tietokannan pÃ¤ivitys hetkellisesti.',0),(288773,8022,'no','Systemet blir oppdatert. En bruker med supervisor-rettigheter vil Logg inn og begynne databaseoppdateringen Ã¸yeblikk.',0),(288774,8022,'da','Systemet opdateres. En bruger med supervisor privilegier vil logge ind og begynde database opdateringen et Ã¸jeblik.',0),(288775,8022,'ko','ì‹œìŠ¤í…œ ì—…ë°ì´íŠ¸ ë˜. ê´€ë¦¬ìž ê¶Œí•œ ê°€ì§„ ì‚¬ìš©ìž ë¡œê·¸ì¸ í•˜ ê³  ì¼ì‹œì ìœ¼ë¡œ ë°ì´í„°ë² ì´ìŠ¤ ì—…ë°ì´íŠ¸ë¥¼ ì‹œìž‘ í•©ë‹ˆë‹¤.',0),(288776,8022,'he','×¢×“×›×•×Ÿ ×”×ž×¢×¨×›×ª. ×ž×©×ª×ž×© ×¢× ×”×¨×©××•×ª ×”×ž×¤×§×— ×ª×ª×—×‘×¨ ×•×ª×ª×—×™×œ ××ª ×¢×“×›×•×Ÿ ×ž×¡×“ ×”× ×ª×•× ×™× ×‘×›×œ ×¨×’×¢.',0),(288777,8022,'el','Î¤Î¿ ÏƒÏÏƒÏ„Î·Î¼Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹. ÎˆÎ½Î±Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ Î¼Îµ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± ÎµÏ€ÏŒÏ€Ï„Î·Ï‚ Î¸Î± ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ ÎºÎ±Î¹ Î½Î± Î¾ÎµÎºÎ¹Î½Î®ÏƒÎµÎ¹ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï€ÏÎ¿Ï‚ ÏƒÏ„Î¹Î³Î¼Î®Î½.',0),(288778,8022,'zh','NolaProæ­£åœ¨æ›´æ–°ã€‚ä¸€ä¸ªå…·æœ‰ç®¡ç†å‘˜æƒé™çš„ç”¨æˆ·å°†ç™»å½•å¹¶æš‚æ—¶è¿›è¡Œèµ„æ–™åº“æ›´æ–°ã€‚\r\n',0),(288779,8022,'sv','Systemet uppdateras. AnvÃ¤ndare med handledare kommer att logga in och bÃ¶rja databasuppdatering Ã¶gonblickligt.',0),(288780,8022,'it','Il sistema Ã¨ in fase di aggiornamento. Un utente con privilegi di supervisore sarÃ  il login e iniziare l\'aggiornamento del database momentaneamente.',0),(288781,8022,'tl','',0),(288782,8022,'th','NolaPro is being updated. A user with supervisor privileges will log in and begin the database update momentarily.',0),(288783,8022,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤°à¤¹à¤¾ à¤¹à¥ˆà¥¤ à¤ªà¤°à¥à¤¯à¤µà¥‡à¤•à¥à¤·à¤• à¤µà¤¿à¤¶à¥‡à¤·à¤¾à¤§à¤¿à¤•à¤¾à¤°à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¥‹à¤ˆ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤®à¥‡à¤‚ à¤²à¥‰à¤— à¤‡à¤¨ à¤•à¤°à¥‡à¤‚ à¤”à¤° à',0),(288784,8022,'ms','Sistem sedang dikemaskinikan. Pengguna dengan keistimewaan penyelia akan log in dan mula Kemaskini pangkalan data seketika nanti.',0),(288785,8022,'ar','ÙŠØ¬Ø±ÙŠ ØªØ­Ø¯ÙŠØ« NolaPro. Ø³ÙŠÙ‚ÙˆÙ… Ù…Ø³ØªØ®Ø¯Ù… Ù„Ù‡ ØµÙ„Ø§Ø­ÙŠØ§Øª Ø§Ù„Ù…Ø´Ø±Ù Ø¨ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ ÙˆØ¨Ø¯Ø§ÙŠØ© ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø®Ù„Ø§Ù„ Ù„Ø­Ø¸Ø§Øª.',0),(288786,8022,'fr','Le systÃ¨me est en cours d\'actualisation. Un utilisateur avec des privilÃ¨ges de superviseur sera connecter et commencer la mise Ã  jour de la base de donnÃ©es momentanÃ©ment.',0),(288787,8022,'jp','ã‚·ã‚¹ãƒ†ãƒ ãŒæ›´æ–°ã•ã‚Œã¾ã™ã€‚ã‚¹ãƒ¼ãƒ‘ãƒ¼ãƒã‚¤ã‚¶ãƒ¼æ¨©é™ã‚’æŒã¤ãƒ¦ãƒ¼ã‚¶ãƒ¼ãŒãƒ­ã‚°ã‚¤ãƒ³ã—ã€ä¸€æ™‚çš„ã«ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã®æ›´æ–°ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(288788,8022,'pt','O sistema estÃ¡ sendo atualizado. Um usuÃ¡rio com privilÃ©gios de supervisor irÃ¡ logar e comeÃ§ar a atualizaÃ§Ã£o do banco de dados dentro de momentos.',0),(288789,8022,'ru','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð° Ð¾Ð±Ð½Ð¾Ð²Ð»ÑÐµÑ‚ÑÑ. ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ñ Ð¿Ñ€Ð¸Ð²Ð¸Ð»ÐµÐ³Ð¸ÑÐ¼Ð¸ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð° Ð²Ð¾Ð¹Ñ‚Ð¸ Ð¸ Ð½Ð°Ñ‡Ð°Ñ‚ÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð½Ð° Ð¼Ð³Ð½Ð¾Ð²ÐµÐ½Ð¸Ðµ.',0),(288790,8022,'es','NolaPro se actualiza. Un usuario con privilegios de supervisor ingresarÃ¡ y ocmenzar la actualizaciÃ³n de la base de datos momentÃ¡niamente',0),(288791,8022,'de','Das System wird aktualisiert. Ein Benutzer mit Berechtigungen der Supervisor wird einloggen und beginnen das Datenbank-Update vorÃ¼bergehend.',0),(288792,8022,'en','The system is being updated. A user with supervisor privileges will log in and begin the database update momentarily.',0),(288793,8023,'is','',0),(288794,8023,'dr','Ø¨Ø§ Ø¨Ø±Ø®ÙŠ Ø§Ø² Ù…Ù†Ø§Ø¨Ø¹ Ø²ÙŠØ± Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ú†Ú¯ÙˆÙ†Ú¯ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±  Ù…Ø´ÙˆØ±Øª ÙƒÙ†ÙŠØ¯',0),(288795,8023,'pr','Ø¨Ø§ Ø¨Ø±Ø®ÙŠ Ø§Ø² Ù…Ù†Ø§Ø¨Ø¹ Ø²ÙŠØ± Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ú†Ú¯ÙˆÙ†Ú¯ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±  Ù…Ø´ÙˆØ±Øª ÙƒÙ†ÙŠØ¯',0),(288796,8023,'tr','NasÄ±l dÄ±ÅŸarÄ± NolaPro daha fazla bilgi edinmek iÃ§in aÅŸaÄŸÄ±daki kaynaklara baÅŸvurun',0),(288797,8023,'pl','SkonsultowaÄ‡ siÄ™ z niektÃ³rych zasobÃ³w poniÅ¼ej, aby dowiedzieÄ‡ siÄ™ wiÄ™cej z NolaPro',0),(288798,8023,'bg','ÐšÐ¾Ð½ÑÑƒÐ»Ñ‚Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ ÑÐµ Ñ Ð½ÑÐºÐ¾Ð¸ Ð¾Ñ‚ Ñ€ÐµÑÑƒÑ€ÑÐ¸Ñ‚Ðµ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ Ð·Ð° Ð´Ð° Ð½Ð°ÑƒÑ‡Ð¸Ñ‚Ðµ ÐºÐ°Ðº Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ NolaPro',0),(288799,8023,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø­Ø§ØµÙ„ Ú©Ø±Ù†Û’ Ú©Ø§ Ø·Ø±ÛŒÙ‚Û Ø³ÛŒÚ©Ú¾Ù†Û’ Ú©ÛŒÙ„Ø¦Û’ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ ÙˆØ³Ø§Ø¦Ù„ Ù…ÛŒÚº Ø³Û’ Ø¨Ø¹Ø¶ Ø³Û’ Ø±Ø¬ÙˆØ¹ Ú©Ø±ÛŒÚº',0),(288800,8023,'sr','ÐžÐ±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ð½ÐµÐºÐ¸ Ð¾Ð´ Ñ€ÐµÑÑƒÑ€ÑÐ° Ð¸ÑÐ¿Ð¾Ð´ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑÐ°Ð·Ð½Ð°Ð»Ð¸ ÐºÐ°ÐºÐ¾ Ð´Ð° ÑÐ°Ð·Ð½Ð°Ð¼ Ð²Ð¸ÑˆÐµ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾',0),(288801,8023,'vi','Äá»ƒ NolaPro phá»¥c vá»¥ báº¡n tá»‘t hÆ¡n hÃ£y dÃ¹ng nhá»¯ng hÆ°á»›ng dáº«n dÆ°á»›i Ä‘Ã¢y',0),(288802,8023,'af','Raadpleeg sommige van die hulpbronne hieronder en leer hoe om die maksimum uit NolaPro te verkry',0),(288803,8023,'ro','Consulta pe unii de resurse de mai jos pentru a afla cum sÄƒ obÅ£ineÅ£i mai mult de NolaPro',0),(288804,8023,'et','Vaata pakutavaid vÃµimalusi ja saavuta paremaid tulemusi tÃ¶Ã¶s NolaPro tarkvaraga',0),(288805,8023,'si','Posvetovati nekaj virov, ki so spodaj, Äe Å¾elite izvedeti, kako priti veÄ od NolaPro',0),(288806,8023,'ba','Berkonsultasi dengan beberapa sumber daya di bawah ini untuk belajar bagaimana untuk mendapatkan lebih banyak dari NolaPro',0),(288807,8023,'nl','Sommige van de onderstaande om te leren hoe je meer uit NolaPro bronnen raadplegen',0),(288808,8023,'fi','Kuulla joitakin resurssit alla oppia, miten saada enemmÃ¤n irti NolaPro',0),(288809,8023,'no','Se noen av ressursene nedenfor for Ã¥ lÃ¦re hvordan du fÃ¥r mer ut av NolaPro',0),(288810,8023,'da','HÃ¸re nogle af de ressourcer nedenfor for at lÃ¦re hvordan du fÃ¥r mere ud af NolaPro',0),(288811,8023,'ko','ì¼ë¶€ NolaPro ë” ì–»ì„ í•˜ëŠ” ë°©ë²•ì„ ì•Œì•„ë³´ë ¤ë©´ ì•„ëž˜ì˜ ë¦¬ì†ŒìŠ¤ë¥¼ ì°¸ì¡° í•˜ì‹­ì‹œì˜¤',0),(288812,8023,'he','×œ×”×ª×™×™×¢×¥ ×¢× ×—×œ×§ ×ž×Ÿ ×”×ž×©××‘×™× ×”×‘××™× ×›×“×™ ×œ×œ×ž×•×“ ×›×™×¦×“ ×œ×”×•×¦×™× ×™×•×ª×¨ NolaPro',0),(288813,8023,'el','Î£Ï…Î¼Î²Î¿Ï…Î»ÎµÏ…Ï„ÎµÎ¯Ï„Îµ Î¼ÎµÏÎ¹ÎºÎ¬ Î±Ï€ÏŒ Ï„Î± Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î³Î¹Î± Î½Î± Î¼Î¬Î¸ÎµÏ„Îµ Ï€ÏŽÏ‚ Î½Î± Ï€Î¬ÏÎµÏ„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Î±Ï€ÏŒ NolaPro Ï€ÏŒÏÏ‰Î½',0),(288814,8023,'zh','å’¨è¯¢ä»¥ä¸‹ä¸€äº›èµ„æºï¼Œä»¥äº†è§£å¦‚ä½•èŽ·å¾—æ›´åŠ å®Œç¾Žçš„NolaPro\r\n',0),(288815,8023,'sv','Konsultera nÃ¥gra av resurserna nedan fÃ¶r att lÃ¤ra dig att fÃ¥ ut mer av NolaPro',0),(288816,8023,'it','Consultare alcune delle risorse qui sotto per informazioni su come ottenere di piÃ¹ NolaPro',0),(288817,8023,'tl','',0),(288818,8023,'th','&#3648;&#3619;&#3637;&#3618;&#3609;&#3619;&#3641;&#3657;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;&#3592;&#3634;&#3585; NolaPro',0),(288819,8023,'hi','NolaPro à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤…à¤§à¤¿à¤• à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥ˆà¤¸à¥‡ à¤œà¤¾à¤¨à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ à¤¸à¤‚à¤¸à¤¾à¤§à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¸à¥‡ à¤•à¥à¤› à¤¸à¥‡ à¤ªà¤°à¤¾à¤®à¤°à¥à¤¶',0),(288820,8023,'ms','Rujuk kepada beberapa sumber-sumber di bawah untuk mengetahui bagaimana untuk mendapatkan lebih banyak daripada NolaPro',0),(288821,8023,'ar','Ø§Ø³ØªØ´Ø§Ø±Ø© Ø¨Ø¹Ø¶ Ø§Ù„Ù…ÙˆØ§Ø±Ø¯ Ø§Ù„Ù…Ø°ÙƒÙˆØ±Ø© Ø£Ø¯Ù†Ø§Ù‡ Ù„Ù…Ø¹Ø±ÙØ© ÙƒÙŠÙÙŠØ© Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø²ÙŠØ¯ Ù…Ù† Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ',0),(288822,8023,'fr','Consultez les ressources ci-dessous pour apprendre comment tirer le maximum de NolaPro',0),(288823,8023,'jp','ã„ãã¤ã‹ã® NolaPro ã‹ã‚‰ã‚ˆã‚Šå¤šãã‚’å–å¾—ã™ã‚‹æ–¹æ³•ã‚’å­¦ã¶ã«ã¯ã€ä»¥ä¸‹ã®ãƒªã‚½ãƒ¼ã‚¹ã‚’å‚ç…§ã—ã¦ãã ã•ã„ã€‚',0),(288824,8023,'pt','Consultar alguns dos recursos abaixo para aprender a tirar mais partido da NolaPro',0),(288825,8023,'ru','Ð˜Ð·ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð°Ð³Ð°ÐµÐ¼Ñ‹Ðµ Ñ€ÐµÑÑƒÑ€ÑÑ‹, Ð´Ð»Ñ Ð´Ð¾ÑÑ‚Ð¸Ð¶ÐµÐ½Ð¸Ñ Ð½Ð°Ð¸Ð»ÑƒÑ‡ÑˆÐµÐ³Ð¾ Ñ€ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ NolaPro.',0),(288826,8023,'es','Consulta unos de los recursos abajo para aprender como aprovechar el mÃ¡ximo de NolaPro ',0),(288827,8023,'de','Rufen Sie die Ressourcen, die lernen, wie man mehr aus Artikel unten',0),(288828,8023,'en','Consult some of the resources below to learn how to get more out of NolaPro',0),(288829,8024,'is','',0),(288830,8024,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ â€“ ÙŠÙƒ Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ Ù¾Ø±Ø³Ù†Ù„ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ  Ùˆ Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ù…Ø§ Ø¨ÙØ±Ø³ØªÙŠØ¯ ',0),(288831,8024,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ â€“ ÙŠÙƒ Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ Ù¾Ø±Ø³Ù†Ù„ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ  Ùˆ Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ù…Ø§ Ø¨ÙØ±Ø³ØªÙŠØ¯ ',0),(288832,8024,'tr','GÃ¶nderme isteÄŸi doÄŸrudan satÄ±ÅŸ ve destek personeli iÃ§in',0),(288833,8024,'pl','WyÅ›lij wniosek bezpoÅ›rednio do naszej sprzedaÅ¼y i obsÅ‚ugÄ…',0),(288834,8024,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¸ÑÐºÐ°Ð½Ðµ Ð¿Ñ€ÑÐºÐ¾ Ð´Ð¾ Ð½Ð°ÑˆÐ¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¸ Ð¿Ð¾Ð¼Ð¾Ñ‰ÐµÐ½ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(288835,8024,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÛÙ…Ø§Ø±Û’ Ø³ÛŒÙ„Ø² Ø§ÙˆØ± Ø§Ù…Ø¯Ø§Ø¯ÛŒ Ø¹Ù…Ù„Û’ Ú©Ùˆ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒÚº',0),(288836,8024,'sr','Ð¡Ð»Ð°ÑšÐµ Ð¿Ð¾Ð·Ð¸Ð²Ð° Ð·Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¾ Ð½Ð° Ð½Ð°ÑˆÐµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¸ Ð¿Ð¾Ð¼Ð¾Ñ›Ð½Ð¾Ð³ Ð¾ÑÐ¾Ð±Ñ™Ð°',0),(288837,8024,'vi','Gá»­i yÃªu cáº§u trá»±c tiáº¿p Ä‘áº¿n nhÃ¢n viÃªn há»— trá»£ vÃ  kinh doanh cá»§a chÃºng tÃ´i',0),(288838,8024,'af','Stuur \'n versoek direk aan ons verkoops- en ondersteuningspersoneel',0),(288839,8024,'ro','Trimite o cerere direct la noastre de vÃ¢nzÄƒri ÅŸi personalul de sprijin',0),(288840,8024,'et','Edasta pÃ¤ring otse meie mÃ¼Ã¼gi- ja hooldusosakonnale',0),(288841,8024,'si','PoÅ¡lji zahtevek neposredno naÅ¡e prodaje in podporno osebje',0),(288842,8024,'ba','Kirim permintaan langsung ke penjualan dan staf pendukung kami',0),(288843,8024,'nl','Verzend een verzoek direct naar onze verkoop- en ondersteunend personeel',0),(288844,8024,'fi','LÃ¤hetÃ¤ pyyntÃ¶ suoraan myynti- ja tukihenkilÃ¶stÃ¶n',0),(288845,8024,'no','Sende en forespÃ¸rsel direkte til vÃ¥rt salgs- og kundestÃ¸ttemedarbeidere',0),(288846,8024,'da','Sende en anmodning direkte til vores salgs- og supportmedarbejdere',0),(288847,8024,'ko','ì €í¬ íŒë§¤ ë° ì§€ì› ì§ì›ì— ê²Œ ì§ì ‘ ìš”ì²­ ë³´ë‚´ê¸°',0),(288848,8024,'he','×©×œ×— ×‘×§×©×” ×™×©×™×¨×•×ª ×ž×›×™×¨×•×ª ×©×œ ×¦×•×•×ª ×”×ª×ž×™×›×” ×©×œ× ×•',0),(288849,8024,'el','Î£Ï„ÎµÎ¯Î»ÎµÏ„Îµ Î±Î¯Ï„Î·ÏƒÎ· Î±Ï€ÎµÏ…Î¸ÎµÎ¯Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ ÎºÎ±Î¹ Ï„Î¿ Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÏŒ Ï…Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î·Ï‚ Î¼Î±Ï‚',0),(288850,8024,'zh','å‘é€è¯·æ±‚ç›´æŽ¥å‘æˆ‘ä»¬çš„é”€å”®å’Œæ”¯æŒäººå‘˜\r\n',0),(288851,8024,'sv','Skicka en fÃ¶rfrÃ¥gan direkt till vÃ¥r fÃ¶rsÃ¤ljning och supportpersonal',0),(288852,8024,'it','Invia una richiesta direttamente al nostro vendite e personale di supporto',0),(288853,8024,'tl','',0),(288854,8024,'th','&#3626;&#3656;&#3591;&#3588;&#3635;&#3619;&#3657;&#3629;&#3591;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;&#3652;&#3611;&#3607;&#3637;&#3656;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3649;&#3621;&#3632;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(288855,8024,'hi','à¤¹à¤®à¤¾à¤°à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤”à¤° à¤¸à¤®à¤°à¥à¤¥à¤¨ à¤¸à¥à¤Ÿà¤¾à¤« à¤¸à¥€à¤§à¥‡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤…à¤¨à¥à¤°à¥‹à¤§ à¤­à¥‡à¤œà¥‡à¤‚',0),(288856,8024,'ms','Hantar permohonan terus kepada jualan dan kakitangan sokongan',0),(288857,8024,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø·Ù„Ø¨ Ù…Ø¨Ø§Ø´Ø±Ø© Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ÙˆÙ…ÙˆØ¸ÙÙŠ Ø§Ù„Ø¯Ø¹Ù…',0),(288858,8024,'fr','Envoyer une demande directement Ã  nos ventes et personnel de soutien',0),(288859,8024,'jp','å½“ç¤¾ã®å–¶æ¥­ãŠã‚ˆã³ã‚µãƒãƒ¼ãƒˆ ã‚¹ã‚¿ãƒƒãƒ•ã«ç›´æŽ¥è¦æ±‚ã‚’é€ä¿¡',0),(288860,8024,'pt','Enviar uma solicitaÃ§Ã£o diretamente para nossas vendas e pessoal de apoio',0),(288861,8024,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð½ÐµÐ¿Ð¾ÑÑ€ÐµÐ´ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ Ð² Ð½Ð°ÑˆÐ¸Ñ… Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¸ Ð²ÑÐ¿Ð¾Ð¼Ð¾Ð³Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð°',0),(288862,8024,'es','Manda una solicitaciÃ³n directamente a nuestro equipo de ventas y apoyo',0),(288863,8024,'de','Senden einer Anfrage direkt an unsere Verkaufs- und Supportmitarbeiter',0),(288864,8024,'en','Send a request directly to our sales and support staff',0),(288865,8025,'is','',0),(288866,8025,'dr','.Ø§ÙŠÙƒÙ† Ù¾Ø§ÙŠÙŠÙ† ØµÙØ­Ù‡ Ø±Ø§ Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø±Ø§Ù‡Ù†Ù…Ø§ Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ø§Ù† ØµÙØ­Ù‡ Ø±Ø§ Ø¨Ø¨ÙŠÙ†ÙŠØ¯',0),(288867,8025,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ Ø¯Ø± Ù¾Ø§ÙŠÙŠÙ† Ù‡Ø± ØµÙØ­Ù‡ Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª .Ø§ÙŠÙƒÙ† Ù¾Ø§ÙŠÙŠÙ† ØµÙØ­Ù‡ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø±Ø§Ù‡Ù†Ù…Ø§ Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ø§Ù† ØµÙØ­Ù‡ Ø±Ø§ Ø¨Ø¨ÙŠÙ†ÙŠØ¯',0),(288868,8025,'tr','Bu sayfa hakkÄ±nda yardÄ±m gÃ¶rÃ¼ntÃ¼lemek iÃ§in altbilgi simgesine tÄ±klayÄ±n',0),(288869,8025,'pl','Kliknij na ikonÄ™ stopki, aby wyÅ›wietliÄ‡ pomoc na temat tej strony',0),(288870,8025,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð¸ÐºÐ¾Ð½Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾Ð»ÐµÐ½ ÐºÐ¾Ð»Ð¾Ð½Ñ‚Ð¸Ñ‚ÑƒÐ» Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð·Ð° Ñ‚Ð°Ð·Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(288871,8025,'ur','Ø§Ø³ ØµÙØ­Û Ú©Û’ Ù…ØªØ¹Ù„Ù‚ Ù…Ø¯Ø¯ Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø°ÛŒÙ„ ØªØ­Ø±ÛŒØ± Ú©Û’ Ø¢Ø¦Ú©Ù† Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(288872,8025,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð¸ÐºÐ¾Ð½Ñƒ Ð·Ð° Ð¿Ð¾Ð´Ð½Ð¾Ð¶Ñ˜Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð¿Ð¾Ð¼Ð¾Ñ› Ð·Ð° Ñ‚Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(288873,8025,'vi','Nháº¥n vÃ o biá»ƒu tÆ°á»£ng á»Ÿ cuá»‘i trang Ä‘á»ƒ tÃ¬m trá»£ giÃºp',0),(288874,8025,'af','Kliek op die Voetend ikoon om hulp omtrent hierdie blad te besigtig',0),(288875,8025,'ro','FaceÅ£i clic pe pictograma de subsol pentru ajutor despre acea pagina',0),(288876,8025,'et','Jaluse ikooni spikri selle lehe kohta',0),(288877,8025,'si','Kliknite na ikono nogo, Äe si Å¾elite ogledati pomoÄ o tem stran',0),(288878,8025,'ba','Klik pada ikon footer untuk melihat bantuan tentang halaman',0),(288879,8025,'nl','Klik op het pictogram van de voettekst om Help-informatie over die pagina weer te geven',0),(288880,8025,'fi','Alatunnisteen kuvaketta voit tarkastella sivun ohjeen',0),(288881,8025,'no','Klikk pÃ¥ ikonet bunntekst Ã¥ vise hjelp som',0),(288882,8025,'da','Klik pÃ¥ ikonet sidefod til at fÃ¥ vist hjÃ¦lp om side',0),(288883,8025,'ko','í•´ë‹¹ íŽ˜ì´ì§€ì— ëŒ€ í•œ ë„ì›€ë§ì„ ë³´ë ¤ë©´ ë°”ë‹¥ê¸€ ì•„ì´ì½˜ì„ í´ë¦­',0),(288884,8025,'he','×œ×—×¥ ×¢×œ ×¡×ž×œ ×”×ª×—×ª×•× ×” ×›×“×™ ×œ×”×¦×™×’ ×¢×–×¨×” ××•×“×•×ª ×”×“×£',0),(288885,8025,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÎµÎ¹ÎºÎ¿Î½Î¯Î´Î¹Î¿ Î³Î¹Î± Î½Î± Ï€ÏÎ¿Î²Î¬Î»ÎµÏ„Îµ Ï„Î· Î²Î¿Î®Î¸ÎµÎ¹Î± Î³Î¹Î± Î±Ï…Ï„Î®Î½ Ï„Î· ÏƒÎµÎ»Î¯Î´Î± Ï…Ï€Î¿ÏƒÎ­Î»Î¹Î´Î¿',0),(288886,8025,'zh','åœ¨é¡µè„šç‚¹å‡»å›¾æ ‡æŸ¥çœ‹å¸®åŠ©æœ‰å…³è¯¥ç½‘é¡µ\r\n',0),(288887,8025,'sv','Klicka pÃ¥ ikonen sidfot Visa hjÃ¤lp om sidan',0),(288888,8025,'it','Fare clic sull\'icona del piÃ¨ di pagina per visualizzare informazioni della guida su quella pagina',0),(288889,8025,'tl','',0),(288890,8025,'th','&#3588;&#3621;&#3636;&#3585;&#3652;&#3629;&#3588;&#3629;&#3609;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3',0),(288891,8025,'hi','à¤‰à¤¸ à¤ªà¥‡à¤œ à¤•à¥‡ à¤¬à¤¾à¤°à¥‡ à¤®à¥‡à¤‚ à¤®à¤¦à¤¦ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤¦ à¤²à¥‡à¤– à¤†à¤‡à¤•à¤¨ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(288892,8025,'ms','Klik pada ikon footer untuk melihat bantuan mengenai laman itu',0),(288893,8025,'ar','Ø§Ù†Ù‚Ø± Ø¹Ù„Ù‰ Ø£ÙŠÙ‚ÙˆÙ†Ø© ØªØ°ÙŠÙŠÙ„ Ø§Ù„ØµÙØ­Ø© Ù„Ø¹Ø±Ø¶ ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø­ÙˆÙ„ Ù‡Ø°Ù‡ Ø§Ù„ØµÙØ­Ø©',0),(288894,8025,'fr','Cliquez sur l\'icÃ´ne en bas de page pour afficher l\'aide sur cette page',0),(288895,8025,'jp','ãã®ãƒšãƒ¼ã‚¸ã«é–¢ã™ã‚‹ãƒ˜ãƒ«ãƒ—ã‚’è¡¨ç¤ºã™ã‚‹ãƒ•ãƒƒã‚¿ãƒ¼ ã‚¢ã‚¤ã‚³ãƒ³ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(288896,8025,'pt','Clique no Ã­cone para exibir a ajuda sobre a pÃ¡gina do rodapÃ©',0),(288897,8025,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° Ð½Ð¸Ð¶Ð½ÑŽÑŽ Ð¸ÐºÐ¾Ð½Ñƒ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð½Ð° ÑÑ‚Ð¾Ð¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(288898,8025,'es','Hace click en el icÃ³n de pie de pÃ¡gina para ver ayuda sobre este pÃ¡gina',0),(288899,8025,'de','Klicken Sie auf das Symbol \"FuÃŸzeile\" Hilfe zu dieser Seite anzeigen',0),(288900,8025,'en','Click on the footer icon to view help about that page',0),(288901,8026,'is','',0),(288902,8026,'dr','NolaPro Ø³ÙˆØ§Ù„Ø§Øª Ù…ØªÙ†ÙˆØ¹ ',0),(288903,8026,'pr','NolaPro Ø³ÙˆØ§Ù„Ø§Øª Ù…ØªÙ†ÙˆØ¹ ',0),(288904,8026,'tr','NolaPro sÄ±kÃ§a sorulan sorular',0),(288905,8026,'pl','NolaPro FAQ',0),(288906,8026,'bg','NolaPro Ñ‡ÐµÑÑ‚Ð¾ Ð·Ð°Ð´Ð°Ð²Ð°Ð½Ð¸ Ð²ÑŠÐ¿Ñ€Ð¾ÑÐ¸',0),(288907,8026,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ø³Û’ Ù…ØªØ¹Ù„Ù‚ FAQ',0),(288908,8026,'sr','ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð¤ÐQ',0),(288909,8026,'vi','NolaPro cÃ¢u há»i thÆ°á»ng gáº·p',0),(288910,8026,'af','NolaPro V&A',0),(288911,8026,'ro','NolaPro FAQ',0),(288912,8026,'et','NolaPro KKK',0),(288913,8026,'si','NolaPro FAQ',0),(288914,8026,'ba','NolaPro FAQ',0),(288915,8026,'nl','NolaPro FAQ',0),(288916,8026,'fi','NolaPro FAQ',0),(288917,8026,'no','NolaPro FAQ',0),(288918,8026,'da','NolaPro FAQ',0),(288919,8026,'ko','NolaPro FAQ',0),(288920,8026,'he','NolaPro ×©××œ×•×ª × ×¤×•×¦×•×ª',0),(288921,8026,'el','NolaPro FAQ',0),(288922,8026,'zh','NolaProå¸¸è§é—®é¢˜\r\n',0),(288923,8026,'sv','NolaPro FAQ',0),(288924,8026,'it','NolaPro FAQ',0),(288925,8026,'tl','',0),(288926,8026,'th','NolaPro &#3588;&#3635;&#3606;&#3634;&#3617;&#3607;&#3637;&#3656;&#3614;&#3610;&#3610;&#3656;&#3629;&#3618; ',0),(288927,8026,'hi','NolaPro à¤…à¤•à¤¸à¤° à¤•à¤¿à¤¯à¥‡ à¤—à¤ à¤¸à¤µà¤¾à¤²',0),(288928,8026,'ms','NolaPro soalan-soalan lazim',0),(288929,8026,'ar','Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ø£Ø³Ø¦Ù„Ø© ÙˆØ£Ø¬ÙˆØ¨Ø©',0),(288930,8026,'fr','NolaPro FAQ',0),(288931,8026,'jp','NolaPro ã‚ˆãã‚ã‚‹ã”è³ªå•',0),(288932,8026,'pt','NolaPro FAQ',0),(288933,8026,'ru','NolaPro FAQ',0),(288934,8026,'es','NolaPro FAQ',0),(288935,8026,'de','Artikel FAQ',0),(288936,8026,'en','NolaPro FAQ',0),(288937,8027,'is','',0),(288938,8027,'dr','NolaPro ÙØ±ÙˆÙ…',0),(288939,8027,'pr','NolaPro ÙØ±ÙˆÙ…',0),(288940,8027,'tr','NolaPro Forum',0),(288941,8027,'pl','NolaPro Forum',0),(288942,8027,'bg','NolaPro Ñ„Ð¾Ñ€ÑƒÐ¼',0),(288943,8027,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ ÙÙˆØ±Ù…',0),(288944,8027,'sr','ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð¤Ð¾Ñ€ÑƒÐ¼',0),(288945,8027,'vi','NÆ¡i tá»‘t nháº¥t Ä‘á»ƒ tÃ¬m lá»i khuyÃªn vá» nhá»¯ng khÃºc máº¯c trong khi dÃ¹ng NolaPro mÃ  báº¡n gáº·p pháº£i',0),(288946,8027,'af','Die beste plek vir gratis, vinnige advies omtrent enige NolaPro hindernisse waarmee u te doen mag kry',0),(288947,8027,'ro','NolaPro Forum',0),(288948,8027,'et','NolaPro Foorum',0),(288949,8027,'si','NolaPro Forum',0),(288950,8027,'ba','NolaPro Forum',0),(288951,8027,'nl','NolaPro Forum',0),(288952,8027,'fi','NolaPro foorumi',0),(288953,8027,'no','NolaPro Forum',0),(288954,8027,'da','NolaPro Forum',0),(288955,8027,'ko','NolaPro í¬ëŸ¼',0),(288956,8027,'he','×¤×•×¨×•× NolaPro',0),(288957,8027,'el','NolaPro Ï†ÏŒÏÎ¿Ï…Î¼',0),(288958,8027,'zh','NOLAPROè®ºå›\r\n',0),(288959,8027,'sv','NolaPro Forum',0),(288960,8027,'it','NolaPro Forum',0),(288961,8027,'tl','',0),(288962,8027,'th','The best place to quick free advise about any NolaPro snags you run into',0),(288963,8027,'hi','NolaPro à¤«à¥‹à¤°à¤®',0),(288964,8027,'ms','NolaPro Forum',0),(288965,8027,'ar','Ù…Ù†ØªØ¯Ù‰ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ',0),(288966,8027,'fr','NolaPro Forum',0),(288967,8027,'jp','NolaPro ãƒ•ã‚©ãƒ¼ãƒ©ãƒ ',0),(288968,8027,'pt','NolaPro FÃ³rum',0),(288969,8027,'ru','Ð¤Ð¾Ñ€ÑƒÐ¼ NolaPro',0),(288970,8027,'es','El mejor lugar para asesorÃ­a rÃ¡pido y gratis sobre cualquieres impedimentos de NolaPro que enfrente',0),(288971,8027,'de','Artikel Forum',0),(288972,8027,'en','NolaPro Forum',0),(288973,8028,'is','',0),(288974,8028,'dr','Ø·Ø¨Ù‚ Ù¾ÙŠØ´ ÙØ±Ø¶  Ø´Ø±ÙˆØ¹ Ø¨Ø§ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ Ø³ÙØ§Ø±Ø´  Ø¨Ø§Ø² Ø´Ø¯Ù† Ù¾Ù†Ø¬Ø±Ù‡',0),(288975,8028,'pr','Ø·Ø¨Ù‚ Ù¾ÙŠØ´ ÙØ±Ø¶  Ø´Ø±ÙˆØ¹ Ø¨Ø§ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ Ø³ÙØ§Ø±Ø´  Ø¨Ø§Ø² Ø´Ø¯Ù† Ù¾Ù†Ø¬Ø±Ù‡',0),(288976,8028,'tr','VarsayÄ±lan baÅŸlangÄ±Ã§ ile ek sipariÅŸ tarafÄ±ndan seÃ§enekleri aÃ§Ä±k',0),(288977,8028,'pl','Przez domyÅ›lny poczÄ…tek z zamÃ³wienia dodatkowe opcje otwarte',0),(288978,8028,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¡Ñ‚Ð°Ñ€Ñ‚ Ñ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ð¿Ñ†Ð¸Ð¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸',0),(288979,8028,'ur','Ø§Ø¶Ø§ÙÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ø³Ø§ØªÚ¾ Ø·Û’ Ø´Ø¯Û Ø´Ø±ÙˆØ¹ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ú©Ø§ Ú©Ú¾Ù„Ø§',0),(288980,8028,'sr','ÐŸÐ¾Ñ€ÐµÐ´ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾Ð³ Ð¡Ñ‚Ð°Ñ€Ñ‚ ÑÐ° Ð´Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ñ€ÐµÐ´ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ',0),(288981,8028,'vi','phÃ©p.\r\nMá»Ÿ  máº·c Ä‘á»‹nh Báº¯t Ä‘áº§u Vá»›i tÃ¹y chá»n thá»© tá»± bá»• sung ',0),(288982,8028,'af','Deur verstek begin met bykomende orde opsies oop',0),(288983,8028,'ro','De Start implicite suplimentare comanda opÅ£iuni deschise',0),(288984,8028,'et','Poolt vaikealgus tellimuste Valikud avatud',0),(288985,8028,'si','S privzeto zaÄetek, z dodatno naroÄilo moÅ¾nosti odprte',0),(288986,8028,'ba','Oleh Default mulai dengan tambahan ketertiban pilihan terbuka',0),(288987,8028,'nl','Door standaardbegin met extra volgorde opties Open',0),(288988,8028,'fi','Luona laiminlyÃ¶minen alku tilauksen vaihtoehtoja avoinna',0),(288989,8028,'no','Av standard Start med ekstra bestilling alternativer Ã¥pne',0),(288990,8028,'da','Af standardstart med yderligere ordre muligheder Ã¥bne',0),(288991,8028,'ko','ì¶”ê°€ ì£¼ë¬¸ ê¸°ë³¸ ì‹œìž‘ ì˜µì…˜ ì—´ê¸°',0),(288992,8028,'he','×¢×œ ×™×“×™ ×”×ª×—×œ ×›×‘×¨×™×¨×ª ×ž×—×“×œ ×¢× ×¡×“×¨ × ×•×¡×¤×•×ª ××¤×©×¨×•×™×•×ª ×¤×ª×•×—×•×ª',0),(288993,8028,'el','Î‘Ï€ÏŒ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î­Î½Î±ÏÎ¾Î· Î¼Îµ ÏƒÏ…Î¼Ï€Î»Î·ÏÏ‰Î¼Î±Ï„Î¹ÎºÎ® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î±Î½Î¿Î¹ÎºÏ„Î­Ï‚',0),(288994,8028,'zh','æŒ‰é»˜è®¤ä»¥æ‰“å¼€çš„é™„åŠ è®¢å•é€‰é¡¹å¯åŠ¨',0),(288995,8028,'sv','Av standardstart med ytterligare bestÃ¤llning alternativ Ã¶ppna',0),(288996,8028,'it','Di avvio predefinito con ordine aggiuntivo opzioni aperte',0),(288997,8028,'tl','',0),(288998,8028,'th','à¹‚à¸”à¸¢à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¹€à¸›à¸´à¸”',0),(288999,8028,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤•à¤°à¤•à¥‡ à¤µà¤¿à¤•à¤²à¥à¤ª à¤–à¥à¤²à¤¾',0),(289000,8028,'ms','Oleh mula lalai dengan perintah tambahan pilihan terbuka',0),(289001,8028,'ar','Ù‚Ø¨Ù„ Ø§Ù„Ø¨Ø¯Ø¡ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù…Ø¹ ØªØ±ØªÙŠØ¨ Ø¥Ø¶Ø§ÙÙŠØ© Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª Ù…ÙØªÙˆØ­Ø©',0),(289002,8028,'fr','De dÃ©but par dÃ©faut avec la commande additionnelle des Options ouvertes',0),(289003,8028,'jp','è¿½åŠ æ³¨æ–‡ã®æ—¢å®šã®é–‹å§‹ã«ã‚ˆã£ã¦ã‚ªãƒ¼ãƒ—ãƒ³ ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(289004,8028,'pt','Por padrÃ£o iniciar com ordem adicional opÃ§Ãµes abertas',0),(289005,8028,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð½Ð°Ñ‡Ð¸Ð½Ð°ÐµÑ‚ÑÑ Ñ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚Ñ‹ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ…',0),(289006,8028,'es','Comienza Predeterminada Con Opciones Adicionales Abiertas de Pedidos',0),(289007,8028,'de','Durch Standard-Start mit zusÃ¤tzlichen Auftrag Optionen offen',0),(289008,8028,'en','By Default Start With Additional Order Options Open',0),(289009,8029,'is','',0),(289010,8029,'dr','Ø¯Ø± Ø®ÙˆØ§Ø³Øª  Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ ÙŠØ§ Ø³Ø§Ø®ØªÙ† Ø¨Ø± Ø§Ø³Ø§Ø³ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(289011,8029,'pr','Ø¯Ø± Ø®ÙˆØ§Ø³Øª  Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ ÙŠØ§ Ø³Ø§Ø®ØªÙ† Ø¨Ø± Ø§Ø³Ø§Ø³ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(289012,8029,'tr','Ä°stek desteÄŸi veya Ã¶zelleÅŸtirme',0),(289013,8029,'pl','Å»Ä…danie wsparcia lub dostosowywania',0),(289014,8029,'bg','Ð˜ÑÐºÐ°Ð½Ðµ Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð¸Ð»Ð¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(289015,8029,'ur','Ù…Ø¹Ø§ÙˆÙ†Øª Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÛŒØ§ ØªØ®ØµÛŒØµ Ú©Ø§Ø±ÛŒ',0),(289016,8029,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¿Ð¾Ð´Ñ€ÑˆÐºÑƒ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’Ð°Ð²Ð°ÑšÐ°',0),(289017,8029,'vi','LiÃªn há»‡ Noguska',0),(289018,8029,'af','Kontak Noguska',0),(289019,8029,'ro','Cererea de sprijin sau de personalizare',0),(289020,8029,'et','Taotleda toetust vÃµi kohandamine',0),(289021,8029,'si','Zahtevo podpore ali prilagoditve',0),(289022,8029,'ba','Permintaan dukungan atau kustomisasi',0),(289023,8029,'nl','Verzoek Support of aanpassen',0),(289024,8029,'fi','PyytÃ¤Ã¤ tukea tai mukauttaminen',0),(289025,8029,'no','Be om stÃ¸tte eller tilpassing',0),(289026,8029,'da','Anmodning om Support eller tilpasning',0),(289027,8029,'ko','ìš”ì²­ ì§€ì› ë˜ëŠ” ì‚¬ìš©ìž ì§€ì •',0),(289028,8029,'he','×‘×§×©×ª ×ª×ž×™×›×” ××• ×”×ª××ž×” ××™×©×™×ª',0),(289029,8029,'el','Î¥Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î· Ï„Î¿Ï… Î±Î¹Ï„Î®Î¼Î±Ï„Î¿Ï‚ Î® Ï„Î·Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚',0),(289030,8029,'zh','è¯·æ±‚æ”¯æŒæˆ–å®šåˆ¶\r\n',0),(289031,8029,'sv','BegÃ¤r stÃ¶d eller anpassning',0),(289032,8029,'it','Richiesta di supporto o personalizzazione',0),(289033,8029,'tl','',0),(289034,8029,'th','Contact Noguska',0),(289035,8029,'hi','à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤®à¤°à¥à¤¥à¤¨ à¤¯à¤¾ à¤…à¤¨à¥à¤•à¥‚à¤²à¤¨',0),(289036,8029,'ms','Minta sokongan atau penyesuaian',0),(289037,8029,'ar','Ø·Ù„Ø¨ Ø§Ù„Ø¯Ø¹Ù… Ø£Ùˆ Ø§Ù„ØªØ®ØµÙŠØµ',0),(289038,8029,'fr','Demande de soutien ou de personnalisation',0),(289039,8029,'jp','ã‚µãƒãƒ¼ãƒˆã‚’è¦æ±‚ã¾ãŸã¯ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚º',0),(289040,8029,'pt','SolicitaÃ§Ã£o de suporte ou personalizaÃ§Ã£o',0),(289041,8029,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ¸ Ð¸Ð»Ð¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸',0),(289042,8029,'es','Comunicarse con Noguska',0),(289043,8029,'de','UnterstÃ¼tzung anfordern oder Anpassung',0),(289044,8029,'en','Request Support or Customization',0),(289045,8030,'is','',0),(289046,8030,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ù† ',0),(289047,8030,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ù† ',0),(289048,8030,'tr','Benim bilgilerim',0),(289049,8030,'pl','Moje Info',0),(289050,8030,'bg','ÐœÐ¾ÑÑ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(289051,8030,'ur','Ù…ÛŒØ±ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(289052,8030,'sr','ÐœÐ¾Ñ˜ Ð˜Ð½Ñ„Ð¾',0),(289053,8030,'vi','ThÃ´ng Tin Cá»§a TÃ´i',0),(289054,8030,'af','My Inligting',0),(289055,8030,'ro','Informatiile mele',0),(289056,8030,'et','Profiil',0),(289057,8030,'si','Moj Info',0),(289058,8030,'ba','Info saya',0),(289059,8030,'nl','Mijn Info',0),(289060,8030,'fi','Omat tiedot',0),(289061,8030,'no','Min Info',0),(289062,8030,'da','Min Info',0),(289063,8030,'ko','ë‚´ ì •ë³´',0),(289064,8030,'he','×”×ž×™×“×¢ ×©×œ×™',0),(289065,8030,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î¿Ï…',0),(289066,8030,'zh','æˆ‘çš„ä¿¡æ¯\r\n',0),(289067,8030,'sv','Min Info',0),(289068,8030,'it','Mia Info',0),(289069,8030,'tl','',0),(289070,8030,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3593;&#3633;&#3609;',0),(289071,8030,'hi','à¤®à¥‡à¤°à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(289072,8030,'ms','Maklumat saya',0),(289073,8030,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§ØªÙŠ',0),(289074,8030,'fr','Mes infos',0),(289075,8030,'jp','ç§ã®æƒ…å ±',0),(289076,8030,'pt','Meu Info',0),(289077,8030,'ru','ÐœÐ¾Ñ Ð˜Ð½Ñ„Ð¾',0),(289078,8030,'es','Mi Info',0),(289079,8030,'de','Meine Info',0),(289080,8030,'en','My Info',0),(289081,8031,'is','',0),(289082,8031,'dr','Ù…Ø®ÙÙŠ Ø³Ø§Ø²ÙŠ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(289083,8031,'pr','Ù…Ø®ÙÙŠ Ø³Ø§Ø²ÙŠ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(289084,8031,'tr','Ana sayfa Ã¶nbelleÄŸe alma',0),(289085,8031,'pl','Buforowanie Strona gÅ‚Ã³wna',0),(289086,8031,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐºÐµÑˆÐ¸Ñ€Ð°Ð½Ðµ',0),(289087,8031,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØµÙØ­Û Ú©ÛŒØ³Û Ú©Ø§Ø±ÛŒ',0),(289088,8031,'sr','ÐšÐµÑˆÐ¸Ñ€Ð°ÑšÐµ Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(289089,8031,'vi','Bá»™ Nhá»› Trang Chá»§',0),(289090,8031,'af','Tuisblad in tussengeheue bewaar',0),(289091,8031,'ro','Caching-ul de start, initiala',0),(289092,8031,'et','Kodulehe vahemÃ¤llu',0),(289093,8031,'si','DomaÄa stran Caching',0),(289094,8031,'ba','Caching halaman rumah',0),(289095,8031,'nl','Home Page Caching',0),(289096,8031,'fi','Kotisivun tallentaminen vÃ¤limuistiin',0),(289097,8031,'no','Hjemmesiden for skjulested',0),(289098,8031,'da','Home Page Caching',0),(289099,8031,'ko','í™ˆ íŽ˜ì´ì§€ ìºì‹±',0),(289100,8031,'he','×“×£ ×”×‘×™×ª ×‘×ž×˜×ž×•×Ÿ',0),(289101,8031,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î± Caching',0),(289102,8031,'zh','é¦–é¡µé¡µé¢ç¼“å­˜\r\n',0),(289103,8031,'sv','Home Page Caching',0),(289104,8031,'it','Memorizzazione nella cache di pagina iniziale',0),(289105,8031,'tl','',0),(289106,8031,'th','&#3585;&#3634;&#3619;&#3648;&#3585;&#3655;&#3610;&#3627;&#3609;&#3657;&#3634;&#3649;&#3619;&#3585;',0),(289107,8031,'hi','à¤®à¥à¤– à¤ªà¥ƒà¤·à¥à¤  à¤•à¥ˆà¤¶à¤¿à¤‚à¤—',0),(289108,8031,'ms','Laman cache',0),(289109,8031,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(289110,8031,'fr','Mise en cache de la Page d\'accueil',0),(289111,8031,'jp','ãƒ›ãƒ¼ãƒ  ãƒšãƒ¼ã‚¸ã®ã‚­ãƒ£ãƒƒã‚·ãƒ¥',0),(289112,8031,'pt','Cache de pÃ¡gina inicial',0),(289113,8031,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐºÑÑˆÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(289114,8031,'es','PÃ¡gina Hogar Copia CachÃ©',0),(289115,8031,'de','Home Page-Caching',0),(289116,8031,'en','Home Page Caching',0),(289117,8032,'is','',0),(289118,8032,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§Ø§Ø² ÙØ§ÙŠÙ„ Ø§Ø³ÙƒÙŠ\r\n CSV File',0),(289119,8032,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§Ø§Ø² ÙØ§ÙŠÙ„ Ø§Ø³ÙƒÙŠ\r\n CSV File',0),(289120,8032,'tr','Stok Kategoriler CSV dosyasÄ±ndan iÃ§e aktarma',0),(289121,8032,'pl','Importowanie zapasÃ³w kategorii z pliku CSV',0),(289122,8032,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¾Ñ‚ CSV Ñ„Ð°Ð¹Ð»',0),(289123,8032,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø²Ù…Ø±Û’ CSV Ù…Ø³Ù„ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(289124,8032,'sr','Ð£Ð²Ð¾Ð· Ð·Ð°Ð»Ð¸Ñ…Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð¸Ð· Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(289125,8032,'vi','Nháº­p CÃ¡c Thá»ƒ Loáº¡i HÃ ng HÃ³a Tá»« Há»“ SÆ¡ CSV',0),(289126,8032,'af','Invoer van Voorraad KategoriÃ« vanaf CSV LÃªer',0),(289127,8032,'ro','Categorii de inventar de import din fiÅŸierul CSV',0),(289128,8032,'et','Varude kategooriate importimine CSV-faili',0),(289129,8032,'si','Zaloge kategorije uvoz iz datoteke CSV',0),(289130,8032,'ba','Impor Kategori Inventori dari file CSV',0),(289131,8032,'nl','Inventaris CategorieÃ«n importeren uit CSV-bestand',0),(289132,8032,'fi','Tuo varaston luokat CSV-tiedostosta',0),(289133,8032,'no','Importere lager kategorier fra CSV-fil',0),(289134,8032,'da','Import lageret kategorier fra CSV-fil',0),(289135,8032,'ko','CSV íŒŒì¼ì—ì„œ ê°€ì ¸ì˜¤ê¸° ì¸ë²¤í† ë¦¬ ì¹´í…Œê³ ë¦¬',0),(289136,8032,'he','×§×˜×’×•×¨×™×•×ª ×ž×œ××™ ×™×™×‘×•× ×ž×§×•×‘×¥ CSV',0),(289137,8032,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€ÏŒ Î±ÏÏ‡ÎµÎ¯Î¿ CSV',0),(289138,8032,'zh','ä»Žé€—å·åˆ†éš”å€¼æ–‡ä»¶ä¸­å¯¼å…¥å­˜è´§åˆ†ç±»\r\n',0),(289139,8032,'sv','Importera lager kategorier frÃ¥n CSV-filen',0),(289140,8032,'it','Categorie di inventario di importazione da File CSV',0),(289141,8032,'tl','',0),(289142,8032,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3652;&#3615;&#3621;&#3660; CSV',0),(289143,8032,'hi','à¤¸à¥‚à¤šà¥€ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤¸à¥‡ CSV à¤«à¤¼à¤¾à¤‡à¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(289144,8032,'ms','Kategori inventori import dari fail CSV',0),(289145,8032,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙØ¦Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù…Ù† Ù…Ù„Ù CSV',0),(289146,8032,'fr','CatÃ©gories de l\'inventaire Import de fichier CSV',0),(289147,8032,'jp','åœ¨åº«ã®ç¨®é¡ž CSV ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(289148,8032,'pt','Categorias de inventÃ¡rio de importaÃ§Ã£o de arquivo CSV',0),(289149,8032,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð¸Ð· CSV-Ñ„Ð°Ð¹Ð»Ð°',0),(289150,8032,'es','Importar CategorÃ­as de Inventario de Archivo CSV',0),(289151,8032,'de','Inventar-Kategorien aus CSV-Datei importieren',0),(289152,8032,'en','Import Inventory Categories from CSV File',0),(289153,8033,'is','',0),(289154,8033,'dr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡  Ø¬Ø²Ø¦ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÙŠØ¯',0),(289155,8033,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡  Ø¬Ø²Ø¦ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÙŠØ¯',0),(289156,8033,'tr','YakÄ±n SeÃ§ili kÃ¼Ã§Ã¼k denge faturalar',0),(289157,8033,'pl','Zamknij wybranych faktur maÅ‚ej rÃ³wnowagi',0),(289158,8033,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ Ð¼Ð°Ð»ÐºÐ¸ Ð±Ð°Ð»Ð°Ð½Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(289159,8033,'ur','Ú†Ú¾ÙˆÙ¹Û’ ØªÙˆØ§Ø²Ù† ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº Ù…Ù†ØªØ®Ø¨',0),(289160,8033,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð¼Ð°Ð»Ðµ ÑÐ°Ð»Ð´Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(289161,8033,'vi','KhÃ³a sá»• nhá»¯ng hÃ³a Ä‘Æ¡n cÃ³ sá»‘ dÆ° nhá»',0),(289162,8033,'af','Afsluit van Verkose Fakture met klein Balanse',0),(289163,8033,'ro','Aproape selectat mic sold facturi',0),(289164,8033,'et','Tihe valitud vÃ¤ike saldo arved',0),(289165,8033,'si','Zapri izbrane majhen ravnoteÅ¾ja raÄunov',0),(289166,8033,'ba','Dekat dipilih kecil saldo faktur',0),(289167,8033,'nl','Nauwe geselecteerde kleine evenwicht facturen',0),(289168,8033,'fi','Sulje valittu pieni tasapaino laskut',0),(289169,8033,'no','Lukk valgt liten saldo fakturaer',0),(289170,8033,'da','NÃ¸je udvalgte smÃ¥ Balance fakturaer',0),(289171,8033,'ko','ë‹«ê¸° ì„ íƒí•œ ìž‘ì€ ìž”ì•¡ ì²­êµ¬ì„œ',0),(289172,8033,'he','×—×©×‘×•× ×™×•×ª ×§×¨×•×‘ ×©× ×‘×—×¨ ××™×–×•×Ÿ ×§×˜×Ÿ',0),(289173,8033,'el','Î£Ï„ÎµÎ½Î® ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î¼Î¹ÎºÏÏŒ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(289174,8033,'zh','å…³é—­é€‰å®šçš„å°ç»“ä½™å‘ç¥¨\r\n',0),(289175,8033,'sv','NÃ¤ra valda smÃ¥ balans fakturor',0),(289176,8033,'it','Chiudi selezionato piccolo saldo fatture',0),(289177,8033,'tl','',0),(289178,8033,'th','&#3611;&#3636;&#3604;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3604;&#3640;&#3621;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3623;&#3657;',0),(289179,8033,'hi','à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚ à¤šà¤¯à¤¨à¤¿à¤¤ à¤›à¥‹à¤Ÿà¥‡ à¤¶à¥‡à¤· à¤šà¤¾à¤²à¤¾à¤¨',0),(289180,8033,'ms','Invois-invois baki kecil terpilih yang rapat',0),(289181,8033,'ar','Ø¥ØºÙ„Ø§Ù‚ ØªØ­Ø¯ÙŠØ¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ù…ÙŠØ²Ø§Ù† ØµØºÙŠØ±',0),(289182,8033,'fr','ClÃ´ture sÃ©lectionnÃ© Ã©quilibre petites factures',0),(289183,8033,'jp','é–‰ã˜ã‚‹é¸æŠžã•ã‚Œã¦ã„ã‚‹å°ã•ãªãƒãƒ©ãƒ³ã‚¹è«‹æ±‚æ›¸',0),(289184,8033,'pt','Saldo pequeno selecionado perto de facturas',0),(289185,8033,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ð¹ Ð½ÐµÐ±Ð¾Ð»ÑŒÑˆÐ¾Ð¹ Ð¾ÑÑ‚Ð°Ñ‚Ð¾Ðº ÑÑ‡ÐµÑ‚Ð°',0),(289186,8033,'es','Cerrar Facturas Seleccionadas de Balances PequeÃ±os',0),(289187,8033,'de','Enge ausgewÃ¤hlten kleinen Balance-Rechnungen',0),(289188,8033,'en','Close Selected Small Balance Invoices',0),(289189,8034,'is','',0),(289190,8034,'dr','Ø§ØµÙ„Ø§Ø­ ÙØ§ÙƒØªÙˆØ± ',0),(289191,8034,'pr','Ø§ØµÙ„Ø§Ø­ ÙØ§ÙƒØªÙˆØ± ',0),(289192,8034,'tr','Fatura ayarlamasÄ±',0),(289193,8034,'pl','Korekta faktury',0),(289194,8034,'bg','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(289195,8034,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(289196,8034,'sr','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(289197,8034,'vi','Chá»‰nh sá»­a HÃ³a Ä‘Æ¡n',0),(289198,8034,'af','Faktuur aanpassing',0),(289199,8034,'ro','Ajustare factura',0),(289200,8034,'et','Arve parandamine',0),(289201,8034,'si','Popravek raÄuna',0),(289202,8034,'ba','Faktur penyesuaian',0),(289203,8034,'nl','Factuurcorrectie',0),(289204,8034,'fi','Laskun sÃ¤Ã¤tÃ¶',0),(289205,8034,'no','Fakturajustering',0),(289206,8034,'da','Servicejustering',0),(289207,8034,'ko','ì†¡ìž¥ ì¡°ì •',0),(289208,8034,'he','×”×ª××ž×ª ×—×©×‘×•× ×™×•×ª',0),(289209,8034,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(289210,8034,'zh','å‘ç¥¨è°ƒæ•´\r\n',0),(289211,8034,'sv','Faktura justering',0),(289212,8034,'it','Regolazione di fattura',0),(289213,8034,'tl','',0),(289214,8034,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(289215,8034,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(289216,8034,'ms','Pelarasan invois',0),(289217,8034,'ar','ØªØ³ÙˆÙŠØ© Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(289218,8034,'fr','Ajustement de la facture',0),(289219,8034,'jp','è«‹æ±‚æ›¸ã®èª¿æ•´',0),(289220,8034,'pt','Ajuste de fatura',0),(289221,8034,'ru','ÐšÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ° ÑÑ‡ÐµÑ‚Ð°',0),(289222,8034,'es','Ajuste de Factura',0),(289223,8034,'de','Rechnungskorrektur',0),(289224,8034,'en','Invoice Adjustment',0),(289225,8035,'is','',0),(289226,8035,'dr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¨Ø±Ø±Ø³ÙŠ Ø´Ø¯Ù‡ Ø¨Ø³ØªÙ‡ Ø´ÙˆØ¯',0),(289227,8035,'pr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¨Ø±Ø±Ø³ÙŠ Ø´Ø¯Ù‡ Ø¨Ø³ØªÙ‡ Ø´ÙˆØ¯',0),(289228,8035,'tr','Checked faturalarÄ± kapatmak',0),(289229,8035,'pl','Zamknij faktury sprawdzone',0),(289230,8035,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÑ‚Ðµ ÐžÑ‚Ð¼ÐµÑ‚Ð½Ð°Ñ‚Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(289231,8035,'ur','Ù¾Ú‘ØªØ§Ù„ Ø´Ø¯Û ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº',0),(289232,8035,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ Ð¾Ð´Ð°Ð±Ñ€Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(289233,8035,'vi','ÄÃ³ng hÃ³a Ä‘Æ¡n SÃ©c',0),(289234,8035,'af','Afsluit van Gemerkte Fakture',0),(289235,8035,'ro','ÃŽnchide verificate facturi',0),(289236,8035,'et','Sulge mÃ¤rgitud arved',0),(289237,8035,'si','Blizu preveriti raÄunov',0),(289238,8035,'ba','Dekat faktur Diperiksa',0),(289239,8035,'nl','Sluit gecontroleerd facturen',0),(289240,8035,'fi','Sulje valitut laskut',0),(289241,8035,'no','Lukk sjekket fakturaer',0),(289242,8035,'da','Luk kontrolleret fakturaer',0),(289243,8035,'ko','í™•ì¸ ëœ ì²­êµ¬ì„œë¥¼ ë‹«ìŠµë‹ˆë‹¤',0),(289244,8035,'he','×¡×’×™×¨×ª ×—×©×‘×•× ×™×•×ª ×©× ×‘×“×§×•',0),(289245,8035,'el','ÎšÎ»ÎµÎ¯ÏƒÏ„Îµ ÎµÎ»Î­Î³Ï‡Î¿Î½Ï„Î±Î¹ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(289246,8035,'zh','å…³é—­æ£€æŸ¥å‘ç¥¨\r\n',0),(289247,8035,'sv','NÃ¤ra kontrollerade fakturor',0),(289248,8035,'it','Chiudere le fatture controllate',0),(289249,8035,'tl','',0),(289250,8035,'th','&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(289251,8035,'hi','à¤šà¥‡à¤• à¤•à¤¿à¤ à¤—à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(289252,8035,'ms','Tutup invois disemak',0),(289253,8035,'ar','Ø¥ØºÙ„Ø§Ù‚ ÙØ­Øµ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(289254,8035,'fr','Fermer les factures vÃ©rifiÃ©es',0),(289255,8035,'jp','ãƒã‚§ãƒƒã‚¯è«‹æ±‚æ›¸ã‚’é–‰ã˜ã‚‹',0),(289256,8035,'pt','Fechar faturas verificadas',0),(289257,8035,'ru','Ð—Ð°ÐºÑ€Ð¾Ð¹Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð½Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(289258,8035,'es','Cerrar Facturas Chequeadas',0),(289259,8035,'de','GeprÃ¼fte Rechnungen zu schlieÃŸen',0),(289260,8035,'en','Close Checked Invoices',0),(289261,8036,'is','',0),(289262,8036,'dr','Ø¢ÙŠØ§ Ø¨Ø³ØªÙ‡ Ø§Ø³ØªØŸ',0),(289263,8036,'pr','Ø¢ÙŠØ§ Ø¨Ø³ØªÙ‡ Ø§Ø³ØªØŸ',0),(289264,8036,'tr','YakÄ±n mÄ±?',0),(289265,8036,'pl','Zamknij?',0),(289266,8036,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸?',0),(289267,8036,'ur','Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚºØŸ',0),(289268,8036,'sr','Ð‘Ð»Ð¸Ð·Ñƒ?',0),(289269,8036,'vi','ÄÃ³ng?',0),(289270,8036,'af','Sluit?',0),(289271,8036,'ro','Aproape?',0),(289272,8036,'et','Sulgeda?',0),(289273,8036,'si','Blizu?',0),(289274,8036,'ba','Tutup?',0),(289275,8036,'nl','Sluiten?',0),(289276,8036,'fi','LÃ¤hellÃ¤?',0),(289277,8036,'no','Lukk?',0),(289278,8036,'da','Lukke?',0),(289279,8036,'ko','ê°€ê¹Œìš´?',0),(289280,8036,'he','×§×¨×•×‘?',0),(289281,8036,'el','ÎšÎ»ÎµÎ¯ÏƒÎµÎ¹;',0),(289282,8036,'zh','å…³é—­ï¼Ÿ\r\n',0),(289283,8036,'sv','NÃ¤ra?',0),(289284,8036,'it','Chiudere?',0),(289285,8036,'tl','',0),(289286,8036,'th','&#3611;&#3636;&#3604;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(289287,8036,'hi','à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚?',0),(289288,8036,'ms','Tutup?',0),(289289,8036,'ar','Ø¥ØºÙ„Ø§Ù‚ØŸ',0),(289290,8036,'fr','Fermer ?',0),(289291,8036,'jp','é–‰ã˜ã¾ã™ã‹ã€‚',0),(289292,8036,'pt','Fechar?',0),(289293,8036,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ?',0),(289294,8036,'es','Â¿Cerrar?',0),(289295,8036,'de','In der NÃ¤he?',0),(289296,8036,'en','Close?',0),(289297,8037,'is','',0),(289298,8037,'dr','Ù…Ø§Ù†Ø¯Ù‡ Ø¬Ø²Ø¦ÙŠ',0),(289299,8037,'pr','Ù…Ø§Ù†Ø¯Ù‡ Ø¬Ø²Ø¦ÙŠ',0),(289300,8037,'tr','KÃ¼Ã§Ã¼k dengesi',0),(289301,8037,'pl','MaÅ‚e rÃ³wnowagi',0),(289302,8037,'bg','ÐœÐ°Ð»ÐºÐ¸ Ð±Ð°Ð»Ð°Ð½Ñ',0),(289303,8037,'ur','Ú†Ú¾ÙˆÙ¹Û’ ØªÙˆØ§Ø²Ù†',0),(289304,8037,'sr','ÐœÐ°Ð»Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(289305,8037,'vi','Sá»‘ dÆ° nhá»',0),(289306,8037,'af','Klein Balans',0),(289307,8037,'ro','Echilibrul de mic',0),(289308,8037,'et','VÃ¤ike saldo',0),(289309,8037,'si','Majhen ravnoteÅ¾ja',0),(289310,8037,'ba','Keseimbangan kecil',0),(289311,8037,'nl','Kleine evenwicht',0),(289312,8037,'fi','Pieni tasapaino',0),(289313,8037,'no','Liten saldo',0),(289314,8037,'da','Lille Balance',0),(289315,8037,'ko','ìž‘ì€ ê· í˜•',0),(289316,8037,'he','××™×–×•×Ÿ ×§×˜×Ÿ',0),(289317,8037,'el','ÎœÎ¹ÎºÏÏŒ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±',0),(289318,8037,'zh','å°é¢ç»“ä½™\r\n',0),(289319,8037,'sv','Liten balans',0),(289320,8037,'it','Piccola bilancia',0),(289321,8037,'tl','',0),(289322,8037,'th','&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3648;&#3621;&#3655;&#3585;',0),(289323,8037,'hi','à¤›à¥‹à¤Ÿà¥‡ à¤¶à¥‡à¤·',0),(289324,8037,'ms','Kecil baki',0),(289325,8037,'ar','Ù…ÙŠØ²Ø§Ù† ØµØºÙŠØ±',0),(289326,8037,'fr','Petite Balance',0),(289327,8037,'jp','å°ã•ãªãƒãƒ©ãƒ³ã‚¹',0),(289328,8037,'pt','Pequeno balanÃ§o',0),(289329,8037,'ru','ÐÐµÐ±Ð¾Ð»ÑŒÑˆÐ¾Ð¹ Ð¾ÑÑ‚Ð°Ñ‚Ð¾Ðº',0),(289330,8037,'es','Balance PequeÃ±o',0),(289331,8037,'de','Kleine Balance',0),(289332,8037,'en','Small Balance',0),(289333,8038,'is','',0),(289334,8038,'dr','(Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(289335,8038,'pr','Ø¢Ø¯Ø±Ø³ ØªØ³Ù‡ÙŠÙ„Ø§Øª(Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(289336,8038,'tr','Tesis adresi',0),(289337,8038,'pl','Adres obiektu',0),(289338,8038,'bg','Ð¡ÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð°Ð´Ñ€ÐµÑ',0),(289339,8038,'ur','Ù¾ØªÛ Ú©ÛŒ Ø³ÛÙˆÙ„Øª',0),(289340,8038,'sr','ÐÐ´Ñ€ÐµÑÐ° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ðµ',0),(289341,8038,'vi','Äá»‹a chá»‰ Ä‘áº­u xe',0),(289342,8038,'af','Fasiliteit adres',0),(289343,8038,'ro','Adresa instalaÅ£iei',0),(289344,8038,'et','Rajatise aadress',0),(289345,8038,'si','Naslov objekta',0),(289346,8038,'ba','Alamat Fasilitas',0),(289347,8038,'nl','Faciliteit adres',0),(289348,8038,'fi','Laitoksen osoite',0),(289349,8038,'no','Anlegget adresse',0),(289350,8038,'da','Facilitet adresse',0),(289351,8038,'ko','ì‹œì„¤ ì£¼ì†Œ',0),(289352,8038,'he','×”×ž×ª×§×Ÿ ×›×ª×•×‘×ª',0),(289353,8038,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· ÎµÎ³ÎºÎ±Ï„Î±ÏƒÏ„Î¬ÏƒÎµÏ‰Î½',0),(289354,8038,'zh','è®¾æ–½çš„åœ°å€\r\n',0),(289355,8038,'sv','AnlÃ¤ggningen adress',0),(289356,8038,'it','Indirizzo impianto',0),(289357,8038,'tl','',0),(289358,8038,'th','&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;&#3614;&#3636;&#3648;&#3624;&#3625;&#3586;&#3629;&#3591;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(289359,8038,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤ªà¤¤à¤¾',0),(289360,8038,'ms','Alamat Kemudahan',0),(289361,8038,'ar','Ø¹Ù†ÙˆØ§Ù† Ù…Ø±ÙÙ‚',0),(289362,8038,'fr','Adresse de l\'installation',0),(289363,8038,'jp','æ–½è¨­ã®ã‚¢ãƒ‰ãƒ¬ã‚¹',0),(289364,8038,'pt','EndereÃ§o de instalaÃ§Ã£o',0),(289365,8038,'ru','ÐÐ´Ñ€ÐµÑ Ð¾Ð±ÑŠÐµÐºÑ‚Ð°',0),(289366,8038,'es','DirecciÃ³n de Facilidad',0),(289367,8038,'de','Einrichtung-Adresse',0),(289368,8038,'en','Facility Address',0),(289369,8039,'is','',0),(289370,8039,'dr','Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ Ø´Ù‡Ø±',0),(289371,8039,'pr','Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ Ø´Ù‡Ø±',0),(289372,8039,'tr','Tesis ÅŸehir',0),(289373,8039,'pl','Obiekt miasto',0),(289374,8039,'bg','Ð¡ÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð¡Ð¸Ñ‚Ð¸',0),(289375,8039,'ur','Ø´ÛØ± Ú©ÛŒ Ø³ÛÙˆÙ„Øª',0),(289376,8039,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ð³Ñ€Ð°Ð´Ð°',0),(289377,8039,'vi','ThÃ nh phá»‘ Ä‘áº­u xe',0),(289378,8039,'af','Fasiliteit Stad',0),(289379,8039,'ro','Facilitatea de City',0),(289380,8039,'et','VÃµimalus City',0),(289381,8039,'si','Objekt City',0),(289382,8039,'ba','Fasilitas kota',0),(289383,8039,'nl','Faciliteit stad',0),(289384,8039,'fi','Ravintola City',0),(289385,8039,'no','Anlegget byen',0),(289386,8039,'da','Facilitet City',0),(289387,8039,'ko','ì‹œì„¤ ì‹œ',0),(289388,8039,'he','×ž×ª×§×Ÿ ×”×¢×™×¨',0),(289389,8039,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï€ÏŒÎ»Î·',0),(289390,8039,'zh','è®¾æ–½åŸŽå¸‚\r\n',0),(289391,8039,'sv','AnlÃ¤ggningen City',0),(289392,8039,'it','Impianto di cittÃ ',0),(289393,8039,'tl','',0),(289394,8039,'th','&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;&#3614;&#3636;&#3648;&#3624;&#3625;&#3586;&#3629;&#3591;&#3648;&#3617;&#3639;&#3629;&#3591;',0),(289395,8039,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤¶à¤¹à¤°',0),(289396,8039,'ms','Kemudahan bandar',0),(289397,8039,'ar','Ù…Ø¯ÙŠÙ†Ø© Ù…Ø±ÙÙ‚',0),(289398,8039,'fr','Centre ville',0),(289399,8039,'jp','æ–½è¨­éƒ½å¸‚',0),(289400,8039,'pt','Cidade de instalaÃ§Ã£o',0),(289401,8039,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð³Ð¾Ñ€Ð¾Ð´Ð°',0),(289402,8039,'es','Ciudad de la Facilidad',0),(289403,8039,'de','Facility-Stadt',0),(289404,8039,'en','Facility City',0),(289405,8040,'is','',0),(289406,8040,'dr','ØªØ³Ù‡ÙŠÙ„Ø§Øª Ø§Ø³ØªØ§Ù† ',0),(289407,8040,'pr','ØªØ³Ù‡ÙŠÙ„Ø§Øª Ø§Ø³ØªØ§Ù† ',0),(289408,8040,'tr','Tesis durumu',0),(289409,8040,'pl','Stan obiektu',0),(289410,8040,'bg','Ð¡ÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸Ðµ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(289411,8040,'ur','Ø±ÛŒØ§Ø³Øª Ú©ÛŒ Ø³ÛÙˆÙ„Øª',0),(289412,8040,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ðµ',0),(289413,8040,'vi','Tiá»ƒu bang Ä‘áº­u xe',0),(289414,8040,'af','Fasiliteit staat',0),(289415,8040,'ro','Facilitatea de stat',0),(289416,8040,'et','Poole riik',0),(289417,8040,'si','Stanje objekta',0),(289418,8040,'ba','Fasilitas State',0),(289419,8040,'nl','Faciliteit staat',0),(289420,8040,'fi','Laitoksen valtion',0),(289421,8040,'no','Anlegget State',0),(289422,8040,'da','Facilitet stat',0),(289423,8040,'ko','ì‹œì„¤ ìƒíƒœ',0),(289424,8040,'he','×ž×ª×§×Ÿ ×ž×¦×‘',0),(289425,8040,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎºÏÎ¬Ï„Î¿Ï…Ï‚',0),(289426,8040,'zh','è®¾æ–½ä¹‹çŠ¶æ€\r\n',0),(289427,8040,'sv','AnlÃ¤ggningen State',0),(289428,8040,'it','Stato impianto',0),(289429,8040,'tl','',0),(289430,8040,'th','&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;&#3614;&#3636;&#3648;&#3624;&#3625;&#3586;&#3629;&#3591;&#3619;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(289431,8040,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤°à¤¾à¤œà¥à¤¯',0),(289432,8040,'ms','Keadaan Kemudahan',0),(289433,8040,'ar','Ù…Ø±ÙÙ‚ Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(289434,8040,'fr','Ã‰tat de l\'installation',0),(289435,8040,'jp','æ–½è¨­ã®çŠ¶æ…‹',0),(289436,8040,'pt','Estado da instalaÃ§Ã£o',0),(289437,8040,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð¾Ð±ÑŠÐµÐºÑ‚Ð°',0),(289438,8040,'es','Estado de Facilidad',0),(289439,8040,'de','Zustand der Anlage',0),(289440,8040,'en','Facility State',0),(289441,8041,'is','',0),(289442,8041,'dr','ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ',0),(289443,8041,'pr','ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø§Ù…ÙƒØ§Ù†Ø§Øª Ù¾Ø§Ø±ÙƒÙŠÙ†Ú¯ ',0),(289444,8041,'tr','Tesis ZIP',0),(289445,8041,'pl','Obiekt Zip',0),(289446,8041,'bg','Ð¡ÑŠÐ¾Ñ€ÑŠÐ¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Zip',0),(289447,8041,'ur','Ø²Ù¾ Ú©ÛŒ Ø³ÛÙˆÙ„Øª',0),(289448,8041,'sr','ÐŸÐ¾ÑÑ‚Ñ€Ð¾Ñ˜ÐµÑšÐµ Ð—Ð¸Ð¿',0),(289449,8041,'vi','Zip cá»§a kho',0),(289450,8041,'af','Fasiliteit ritssluiter',0),(289451,8041,'ro','Facilitatea Zip',0),(289452,8041,'et','Rajatise Zip',0),(289453,8041,'si','Objekt Zip',0),(289454,8041,'ba','Fasilitas Zip',0),(289455,8041,'nl','Faciliteit Zip',0),(289456,8041,'fi','Laitoksen Zip',0),(289457,8041,'no','Anlegget Zip',0),(289458,8041,'da','Facilitet Zip',0),(289459,8041,'ko','ì‹œì„¤ Zip',0),(289460,8041,'he','×ž×ª×§×Ÿ Zip',0),(289461,8041,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Zip',0),(289462,8041,'zh','è®¾æ–½é‚®ç¼–\r\n',0),(289463,8041,'sv','AnlÃ¤ggningen Zip',0),(289464,8041,'it','Impianto Zip',0),(289465,8041,'tl','',0),(289466,8041,'th','&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(289467,8041,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤œà¤¼à¤¿à¤ª',0),(289468,8041,'ms','Kemudahan pos',0),(289469,8041,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ù…Ø±ÙÙ‚',0),(289470,8041,'fr','Installation Zip',0),(289471,8041,'jp','æ–½è¨­ Zip',0),(289472,8041,'pt','InstalaÃ§Ã£o Zip',0),(289473,8041,'ru','Ð˜Ð½Ð´ÐµÐºÑ Ð¾Ð±ÑŠÐµÐºÑ‚Ð°',0),(289474,8041,'es','CÃ³digo Postal de la Facilidad',0),(289475,8041,'de','Anlage Zip',0),(289476,8041,'en','Facility Zip',0),(289477,8042,'is','',0),(289478,8042,'dr','ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ù…Ù† ',0),(289479,8042,'pr','ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ù…Ù† ',0),(289480,8042,'tr','Benim ayarlarÄ±',0),(289481,8042,'pl','Moje ustawienia',0),(289482,8042,'bg','ÐœÐ¾Ð¸Ñ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸',0),(289483,8042,'ur','Ù…ÛŒØ±ÛŒ Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº',0),(289484,8042,'sr','ÐœÐ¾Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ',0),(289485,8042,'vi','Cháº¿ Ä‘á»™ cÃ i Ä‘áº·t cá»§a tÃ´i',0),(289486,8042,'af','My Verstellings',0),(289487,8042,'ro','SetÄƒrile mele',0),(289488,8042,'et','Minu seaded',0),(289489,8042,'si','Moje nastavitve',0),(289490,8042,'ba','Pengaturan saya',0),(289491,8042,'nl','Mijn instellingen',0),(289492,8042,'fi','Omat asetukset',0),(289493,8042,'no','Mine innstillinger',0),(289494,8042,'da','Mine indstillinger',0),(289495,8042,'ko','ë‚´ ì„¤ì •',0),(289496,8042,'he','×”×”×’×“×¨×•×ª ×©×œ×™',0),(289497,8042,'el','ÎŸÎ¹ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Î¼Î¿Ï…',0),(289498,8042,'zh','æˆ‘çš„è®¾ç½®\r\n',0),(289499,8042,'sv','Mina instÃ¤llningar',0),(289500,8042,'it','Mie impostazioni',0),(289501,8042,'tl','',0),(289502,8042,'th','&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3586;&#3629;&#3591;&#3593;&#3633;&#3609;',0),(289503,8042,'hi','à¤®à¥‡à¤°à¥€ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸',0),(289504,8042,'ms','Pengesetan saya',0),(289505,8042,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§ØªÙ€Ù€ÙŠ',0),(289506,8042,'fr','Mes paramÃ¨tres',0),(289507,8042,'jp','ç§ã®è¨­å®š',0),(289508,8042,'pt','Minhas configuraÃ§Ãµes',0),(289509,8042,'ru','ÐœÐ¾Ð¸ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(289510,8042,'es','Mis Configuraciones',0),(289511,8042,'de','Meine Einstellungen',0),(289512,8042,'en','My Settings',0),(289513,8043,'is','',0),(289514,8043,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØªØ§ÙŠÙŠØ¯ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(289515,8043,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØªØ§ÙŠÙŠØ¯ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(289516,8043,'tr','Onay gÃ¶rmek iÃ§in tÄ±klayÄ±n',0),(289517,8043,'pl','Kliknij, aby wyÅ›wietliÄ‡ potwierdzenie',0),(289518,8043,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(289519,8043,'ur','ØªØµØ¯ÛŒÙ‚ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(289520,8043,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð°',0),(289521,8043,'vi','Nháº¥n Ä‘á»ƒ xem xÃ¡c nháº­n',0),(289522,8043,'af','Kliek om Besigtig te Besigtig',0),(289523,8043,'ro','Click pentru a vizualiza confirmare',0),(289524,8043,'et','KlÃµpsake, et kuvada kinnituse',0),(289525,8043,'si','Kliknite za ogled potrditev',0),(289526,8043,'ba','Klik untuk melihat konfirmasi',0),(289527,8043,'nl','Klik om te bekijken bevestiging',0),(289528,8043,'fi','Klikkaa nÃ¤hdÃ¤ksesi vahvistus',0),(289529,8043,'no','Klikk for Ã¥ vise bekreftelse',0),(289530,8043,'da','Klik her for at se bekrÃ¦ftelse',0),(289531,8043,'ko','í™•ì¸ì„ í´ë¦­',0),(289532,8043,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’ ××™×©×•×¨',0),(289533,8043,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·',0),(289534,8043,'zh','ç‚¹å‡»æŸ¥çœ‹ç¡®è®¤\r\n',0),(289535,8043,'sv','Klicka fÃ¶r att Visa bekrÃ¤ftelse',0),(289536,8043,'it','Clicca per mostrare conferma',0),(289537,8043,'tl','',0),(289538,8043,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3585;&#3634;&#3619;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;',0),(289539,8043,'hi','à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(289540,8043,'ms','Klik untuk melihat pengesahan',0),(289541,8043,'ar','Ø£Ù†Ù‚Ø± Ù„Ø¹Ø±Ø¶ Ø§Ù„ØªØ£ÙƒÙŠØ¯',0),(289542,8043,'fr','Cliquez pour visualiser la Confirmation',0),(289543,8043,'jp','ç¢ºèªã‚’è¡¨ç¤ºã™ã‚‹] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(289544,8043,'pt','Clique para ver a confirmaÃ§Ã£o',0),(289545,8043,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð´Ð»Ñ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(289546,8043,'es','Click para Ver la ConfirmaciÃ³n',0),(289547,8043,'de','Klicken Sie BestÃ¤tigung an',0),(289548,8043,'en','Click to View Confirmation',0),(289549,8044,'is','',0),(289550,8044,'dr','Ø´Ù…Ø§ Ø´Ø±Ø§ÙŠØ· ØªÙˆØ§ÙÙ‚Ù†Ø§Ù…Ù‡ Ø±Ø§ Ù†Ù‚Ø¶ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(289551,8044,'pr','Ø´Ù…Ø§ Ø´Ø±Ø§ÙŠØ· ØªÙˆØ§ÙÙ‚Ù†Ø§Ù…Ù‡ Ø±Ø§ Ù†Ù‚Ø¶ ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(289552,8044,'tr','Lisans sÃ¶zleÅŸmesinin koÅŸullarÄ±nÄ± ihlal etmiÅŸ.',0),(289553,8044,'pl','ZostaÅ‚y naruszone warunki umowy licencyjnej.',0),(289554,8044,'bg','Ð’Ð¸Ðµ ÑÑ‚Ðµ Ð½Ð°Ñ€ÑƒÑˆÐ¸Ð»Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð½Ð° Ð»Ð¸Ñ†ÐµÐ½Ð·Ð¸Ð¾Ð½Ð½Ð¾Ñ‚Ð¾ ÑÐ¿Ð¾Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ½Ð¸Ðµ.',0),(289555,8044,'ur','Ø¢Ù¾ Ù†Û’ Ù…Ø¹Ø§ÛØ¯Û Ù„Ø§Ø¦Ø³Ù†Ø³ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø· Ú©ÛŒ Ø®Ù„Ø§Ù ÙˆØ±Ø²ÛŒ ÛÛ’ Û”',0),(289556,8044,'sr','Ð˜Ð·Ð´Ð°Ð¾ ÑÐ¸ ÑƒÑÐ»Ð¾Ð²Ðµ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð° Ð¾ Ð»Ð¸Ñ†ÐµÐ½Ñ†Ð¸Ñ€Ð°ÑšÑƒ.',0),(289557,8044,'vi','Báº¡n Ä‘Ã£ vi pháº¡m Ä‘iá»u khoáº£n cá»§a giáº¥y phÃ©p',0),(289558,8044,'af','U het die bepalings in die LISENSIE- OOREENKOMS geskend.',0),(289559,8044,'ro','Ati Ã®ncÄƒlcat termenii acordului de licenÅ£Äƒ',0),(289560,8044,'et','Te olete rikkunud kasutajaÃµiguste tingimusi.',0),(289561,8044,'si','Ste krÅ¡ili pogoje licenÄne pogodbe.',0),(289562,8044,'ba','Anda telah melanggar syarat-syarat perjanjian lisensi.',0),(289563,8044,'nl','U hebben geschonden de voorwaarden van de gebruiksrechtovereenkomst.',0),(289564,8044,'fi','Olet rikkonut kÃ¤yttÃ¶oikeussopimuksen ehdot.',0),(289565,8044,'no','Du har brutt vilkÃ¥rene i lisensavtalen.',0),(289566,8044,'da','Du har overtrÃ¥dt vilkÃ¥rene i licensaftalen.',0),(289567,8044,'ko','ë¼ì´ì„¼ìŠ¤ ê³„ì•½ì˜ ì¡°ê±´ì„ ìœ„ë°˜ í–ˆìŠµë‹ˆë‹¤.',0),(289568,8044,'he','×”×¤×¨×ª ××ª ×ª× ××™ ×”×¡×›× ×”×¨×©×™×•×Ÿ.',0),(289569,8044,'el','ÎˆÏ‡ÎµÏ„Îµ Ï€Î±ÏÎ±Î²Î¹Î¬ÏƒÎµÎ¹ Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î·Ï‚ Î¬Î´ÎµÎ¹Î±Ï‚ Ï‡ÏÎ®ÏƒÎ·Ï‚.',0),(289570,8044,'zh','æ‚¨è¿åè®¸å¯åè®®çš„æ¡æ¬¾ã€‚\r\n',0),(289571,8044,'sv','Du har brutit mot villkoren i licensavtalet.',0),(289572,8044,'it','Hai violato i termini del contratto di licenza.',0),(289573,8044,'tl','',0),(289574,8044,'th','&#3588;&#3640;&#3603;&#3652;&#3604;&#3657;&#3621;&#3632;&#3648;&#3617;&#3636;&#3604;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3586;&#3629;&#3591;&#3651;&#3610;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(289575,8044,'hi','à¤†à¤ª à¤²à¤¾à¤¯à¤¸à¥‡à¤‚à¤¸ à¤à¤—à¥à¤°à¥€à¤®à¥‡à¤‚à¤Ÿ à¤•à¥€ à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤•à¤¾ à¤‰à¤²à¥à¤²à¤‚à¤˜à¤¨ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(289576,8044,'ms','Anda telah melanggar syarat-syarat perjanjian perlesenan.',0),(289577,8044,'ar','Ù„Ù‚Ø¯ Ø¥Ù†ØªÙ‡ÙƒØª Ø´Ø±ÙˆØ· Ø¥ØªÙØ§Ù‚ÙŠØ© Ø§Ù„ØªØ±Ø®ÙŠØµ.',0),(289578,8044,'fr','Vous avez violÃ© les termes du contrat de licence.',0),(289579,8044,'jp','ä½¿ç”¨è¨±è«¾å¥‘ç´„æ›¸ã®æ¡é …ã«é•åã—ã¦ã„ã¾ã™ã€‚',0),(289580,8044,'pt','VocÃª violou os termos do contrato de licenÃ§a.',0),(289581,8044,'ru','Ð’Ñ‹ Ð½Ð°Ñ€ÑƒÑˆÐ¸Ð»Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð»Ð¸Ñ†ÐµÐ½Ð·Ð¸Ð¾Ð½Ð½Ð¾Ð³Ð¾ ÑÐ¾Ð³Ð»Ð°ÑˆÐµÐ½Ð¸Ñ.',0),(289582,8044,'es','Ha violado los terminos del acuerdo de licencia.',0),(289583,8044,'de','Sie haben die Bedingungen des Lizenzvertrags verletzt.',0),(289584,8044,'en','You have violated the terms of the license agreement.',0),(289585,8045,'is','',0),(289586,8045,'dr','NolaPro logos.',0),(289587,8045,'pr',' Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ù‡ÙŠÚ† ÙŠÙƒ Ø§Ø² Ù„ÙˆÚ¯ÙˆÙ‡Ø§ÙŠ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø±Ø§ ØªØºÙŠÙŠØ± Ù†Ø¯Ù‡ÙŠØ¯  NolaPro logos.',0),(289588,8045,'tr','Herhangi bir NolaPro logo deÄŸiÅŸtirmek deÄŸil.',0),(289589,8045,'pl','MoÅ¼e nie zmieniaÄ‡ Å¼adnych logo NolaPro.',0),(289590,8045,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñ Ð²ÑÐ¸Ñ‡ÐºÐ¸ NolaPro ÐµÐ¼Ð±Ð»ÐµÐ¼Ð¸.',0),(289591,8045,'ur','Ø¢Ù¾ Ú©Ø³ÛŒ Ø¨Ú¾ÛŒ Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ú©ÛŒ Ø¹Ù„Ø§Ù…Ø§Øª Ú©Ùˆ Ø¨Ø¯Ù„ Ù†ÛÛŒÚº Ø³Ú©ØªÛ’ ÛÛŒÚº Û”',0),(289592,8045,'sr','Ð¢Ð¸ ÑÐµ Ð½Ðµ Ð¼Ð¾Ð³Ñƒ Ð¼ÐµÑšÐ°Ñ‚Ð¸ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿Ðµ Ð±Ð¸Ð»Ð¾ ÐºÐ¾Ñ˜Ð¸ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾.',0),(289593,8045,'vi','Báº¡n cÃ³ thá»ƒ chÆ°a chá»‰nh sá»­a logo NolaPro',0),(289594,8045,'af','U mag nie enige VERANDERINGE aan die NolaPro logos doen nie.',0),(289595,8045,'ro','Tu nu poate modifica orice logo-uri NolaPro.',0),(289596,8045,'et','Te ei tohi muuta mitte Ã¼htegi NolPro logo!',0),(289597,8045,'si','Ne smete spreminjati NolaPro logos.',0),(289598,8045,'ba','Anda tidak dapat mengubah logo NolaPro apapun.',0),(289599,8045,'nl','NolaPro logo\'s mogen niet gewijzigd worden.',0),(289600,8045,'fi','Et voi muuttaa NolaPro logoja.',0),(289601,8045,'no','Du kan ikke endre noen NolaPro logoer.',0),(289602,8045,'da','Du kan ikke Ã¦ndre nogen NolaPro logoer.',0),(289603,8045,'ko','ì–´ë–¤ NolaPro ë¡œê³ ë¥¼ ë³€ê²½ í•˜ì§€ ìžˆìŠµë‹ˆë‹¤.',0),(289604,8045,'he','××•×œ×™ ×œ× ×ª×©× ×” ××ª ×›×œ ×”×¡×ž×œ×™× NolaPro.',0),(289605,8045,'el','ÎœÏ€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Î¼ÎµÏ„Î±Î²Î¬Î»ÎµÎ¹ Î´ÎµÎ½ ÎºÎ¬Î¸Îµ Î»Î¿Î³ÏŒÏ„Ï…Ï€Î± NolaPro.',0),(289606,8045,'zh','ä½ ä¸èƒ½æ”¹å˜ä»»ä½•NolaProæ ‡å¿—ã€‚\r\n',0),(289607,8045,'sv','Du fÃ¥r inte Ã¤ndra nÃ¥gon NolaPro logotyper.',0),(289608,8045,'it','Non si puÃ² modificare qualsiasi logo NolaPro.',0),(289609,8045,'tl','',0),(289610,8045,'th','You may not alter any NolaPro logos.',0),(289611,8045,'hi','à¤†à¤ª à¤•à¤¿à¤¸à¥€ à¤­à¥€ NolaPro à¤²à¥‹à¤—à¥‹ à¤•à¥‹ à¤¬à¤¦à¤² à¤¨à¤¹à¥€à¤‚ à¤¸à¤•à¤¤à¤¾à¥¤',0),(289612,8045,'ms','Anda tidak boleh mengubah apa-apa logo NolaPro.',0),(289613,8045,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ†Ùƒ ØªØºÙŠÙŠØ± Ø£ÙŠ Ø´Ø¹Ø§Ø±Ø§Øª Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ.',0),(289614,8045,'fr','Vous ne pouvez pas modifier tous les logos NolaPro.',0),(289615,8045,'jp','ä»»æ„ NolaPro ãƒ­ã‚´ã‚’å¤‰æ›´ã§ãã¾ã›ã‚“ã€‚',0),(289616,8045,'pt','VocÃª nÃ£o pode alterar qualquer NolaPro logotipos.',0),(289617,8045,'ru','Ð’Ñ‹ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð»ÑŽÐ±Ñ‹Ðµ NolaPro Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿Ñ‹.',0),(289618,8045,'es','Usted no puede alterar ninguno de los logos NolaPro.',0),(289619,8045,'de','Sie kÃ¶nnen keine Artikel-Logos nicht Ã¤ndern.',0),(289620,8045,'en','You may not alter any NolaPro logos.',0),(289621,8046,'is','',0),(289622,8046,'dr','ØµÙ†Ø¹Øª Ùˆ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(289623,8046,'pr','ØµÙ†Ø¹Øª Ùˆ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(289624,8046,'tr','Sanat & PO',0),(289625,8046,'pl','Sztuka & PO',0),(289626,8046,'bg','ÐÑ€Ñ‚ & PO',0),(289627,8046,'ur','Ø¢Ø±Ù¹ & Ù¾Ùˆ',0),(289628,8046,'sr','ÐÑ€Ñ‚ & Ð¿Ð¾-Ð°',0),(289629,8046,'vi','Thiáº¿t Káº¿ & ÄÆ¡n Mua HÃ ng',0),(289630,8046,'af','Kuns & AB',0),(289631,8046,'ro','Arta & PO',0),(289632,8046,'et','Art & PO',0),(289633,8046,'si','Art & PO',0),(289634,8046,'ba','Seni & PO',0),(289635,8046,'nl','Art & PO',0),(289636,8046,'fi','Art & PO',0),(289637,8046,'no','Art & PO',0),(289638,8046,'da','Kunst & PO',0),(289639,8046,'ko','ì˜ˆìˆ  & í¬',0),(289640,8046,'he','××ž× ×•×ª & ×¤×•',0),(289641,8046,'el','Î¤Î­Ï‡Î½Î· & PO',0),(289642,8046,'zh','è‰ºæœ¯åŠå®\r\n',0),(289643,8046,'sv','Konst & PO',0),(289644,8046,'it','Arte & PO',0),(289645,8046,'tl','',0),(289646,8046,'th','&#3591;&#3634;&#3609;&#3624;&#3636;&#3621;&#3611;&#3632;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(289647,8046,'hi','à¤•à¤²à¤¾ & à¤ªà¥€à¤“',0),(289648,8046,'ms','Seni & PO',0),(289649,8046,'ar','ÙÙ† Ø¨Ùˆ Ø¢Ù†Ø¯',0),(289650,8046,'fr','Art & PO',0),(289651,8046,'jp','ã‚¢ãƒ¼ãƒˆ & PO',0),(289652,8046,'pt','Arte & PO',0),(289653,8046,'ru','Ð˜ÑÐºÑƒÑÑÑ‚Ð²Ð¾ & PO',0),(289654,8046,'es','Arte & OC',0),(289655,8046,'de','Kunst- & -PO',0),(289656,8046,'en','Art & PO',0),(289657,8047,'is','',0),(289658,8047,'dr','Ù„ÙˆÚ¯Ùˆ Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(289659,8047,'pr','Ù„ÙˆÚ¯Ùˆ Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(289660,8047,'tr','Marka logosu',0),(289661,8047,'pl','Logo marki',0),(289662,8047,'bg','Ð‘Ñ€Ð°Ð½Ð´Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð»Ð¾Ð³Ð¾',0),(289663,8047,'ur','Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ) Ø°Ø§ØªÛŒ Ø¨Ø±Ø§Ù†ÚˆÙ†Ú¯',0),(289664,8047,'sr','Ð›Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿ Ð±Ñ€ÐµÐ½Ð´Ð¸Ñ€Ð°ÑšÐµ',0),(289665,8047,'vi','Biá»ƒu TÆ°á»£ng ThÆ°Æ¡ng Hiá»‡u',0),(289666,8047,'af','Handelsmerk Embleem',0),(289667,8047,'ro','Logo-ul de Branding',0),(289668,8047,'et','Logo Branding',0),(289669,8047,'si','Logotip blagovne znamke',0),(289670,8047,'ba','Merek logo',0),(289671,8047,'nl','Logo huisstijl',0),(289672,8047,'fi','Logo tuotemerkin',0),(289673,8047,'no','Logo merkevarebygging',0),(289674,8047,'da','Logo Branding',0),(289675,8047,'ko','ë¡œê³  ë¸Œëžœë“œ',0),(289676,8047,'he','×œ×•×’×• ×ž×™×ª×•×’',0),(289677,8047,'el','Î›Î¿Î³ÏŒÏ„Ï…Ï€Î¿Ï… Branding',0),(289678,8047,'zh','å“ç‰Œæ ‡å¿—\r\n',0),(289679,8047,'sv','Logotyp varumÃ¤rke',0),(289680,8047,'it','Logo marchio',0),(289681,8047,'tl','',0),(289682,8047,'th','&#3650;&#3621;&#3650;&#3585;&#3657;&#3605;&#3619;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(289683,8047,'hi','à¤¬à¥à¤°à¤¾à¤‚à¤¡à¤¿à¤‚à¤— à¤²à¥‹à¤—à¥‹',0),(289684,8047,'ms','Penjenamaan logo',0),(289685,8047,'ar','Ø´Ø¹Ø§Ø± Ø§Ù„Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ©',0),(289686,8047,'fr','Image de marque de logo',0),(289687,8047,'jp','ãƒ­ã‚´ ãƒ–ãƒ©ãƒ³ãƒ‡ã‚£ãƒ³ã‚°',0),(289688,8047,'pt','Logotipo marca',0),(289689,8047,'ru','Ð‘Ñ€ÐµÐ½Ð´Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð»Ð¾Ð³Ð¾',0),(289690,8047,'es','Logo Marcar',0),(289691,8047,'de','Logo-Branding',0),(289692,8047,'en','Logo Branding',0),(289693,8048,'is','',0),(289694,8048,'dr','Ø«Ø¨Øª ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ',0),(289695,8048,'pr','Ø«Ø¨Øª ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ',0),(289696,8048,'tr','GiriÅŸ baÅŸlangÄ±Ã§ tarihi',0),(289697,8048,'pl','Wpis Data rozp.',0),(289698,8048,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(289699,8048,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(289700,8048,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° ÑÑ‚Ð°Ð²ÐºÐµ',0),(289701,8048,'vi','NgÃ y Báº¯t Äáº§u Nháº­p',0),(289702,8048,'af','Inskrywing Begin Datum',0),(289703,8048,'ro','Data de inceput de intrare',0),(289704,8048,'et','Kande alguskuupÃ¤ev',0),(289705,8048,'si','Vnos zaÄetni datum',0),(289706,8048,'ba','Tanggal entri mulai',0),(289707,8048,'nl','Post begindatum',0),(289708,8048,'fi','Tapahtuman aloituspÃ¤ivÃ¤',0),(289709,8048,'no','Start oppfÃ¸ringsdatoen',0),(289710,8048,'da','Begynd tilmeldningsfrist',0),(289711,8048,'ko','í•­ëª© ì‹œìž‘ ë‚ ì§œ',0),(289712,8048,'he','×ª××¨×™×š ×‘×’×™×Ÿ ×›× ×™×¡×”',0),(289713,8048,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(289714,8048,'zh','æ¡ç›®å¼€å§‹æ—¥æœŸ',0),(289715,8048,'sv','BÃ¶rja datumet',0),(289716,8048,'it','Data inizio voce',0),(289717,8048,'tl','',0),(289718,8048,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(289719,8048,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(289720,8048,'ms','Tarikh mulakan kemasukan',0),(289721,8048,'ar','Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(289722,8048,'fr','Date de dÃ©but d\'entrÃ©e',0),(289723,8048,'jp','ã‚¨ãƒ³ãƒˆãƒªã®é–‹å§‹æ—¥',0),(289724,8048,'pt','Data de inÃ­cio de entrada',0),(289725,8048,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(289726,8048,'es','Entrada Fecha de Comienza',0),(289727,8048,'de','Begin Eingabedatum',0),(289728,8048,'en','Entry Begin Date',0),(289729,8049,'is','',0),(289730,8049,'dr','Ø«Ø¨Øª ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(289731,8049,'pr','Ø«Ø¨Øª ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(289732,8049,'tr','GiriÅŸ bitiÅŸ tarihi',0),(289733,8049,'pl','Wpis data zakoÅ„czenia',0),(289734,8049,'bg','Ð’ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(289735,8049,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(289736,8049,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° ÑÑ‚Ð°Ð²ÐºÐµ',0),(289737,8049,'vi','NgÃ y Káº¿t ThÃºc Entry',0),(289738,8049,'af','Inskrywing End Datum',0),(289739,8049,'ro','Data de sfÃ¢rÅŸit de intrare',0),(289740,8049,'et','Kande lÃµppkuupÃ¤ev',0),(289741,8049,'si','Vnos konÄnega datuma',0),(289742,8049,'ba','Tanggal akhir entri',0),(289743,8049,'nl','Post einddatum',0),(289744,8049,'fi','Tapahtuman pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(289745,8049,'no','OppfÃ¸ringen sluttdatoen',0),(289746,8049,'da','Posten slutdato',0),(289747,8049,'ko','í•­ëª© ì¢…ë£Œ ë‚ ì§œ',0),(289748,8049,'he','×”×–× ×ª ×ª××¨×™×š ×¡×™×•×',0),(289749,8049,'el','Î¤Î­Î»Î¿Ï‚ Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(289750,8049,'zh','æ¡ç›®ç»“æŸæ—¥æœŸ',0),(289751,8049,'sv','Posten slutdatum',0),(289752,8049,'it','Data fine iscrizione',0),(289753,8049,'tl','',0),(289754,8049,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3585;&#3634;&#3619;&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(289755,8049,'hi','à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤…à¤‚à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(289756,8049,'ms','Tarikh akhir kemasukan',0),(289757,8049,'ar','Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡',0),(289758,8049,'fr','Date de fin d\'entrÃ©e',0),(289759,8049,'jp','çµ‚äº†æ—¥ã‚’å…¥åŠ›',0),(289760,8049,'pt','Data de tÃ©rmino de entrada',0),(289761,8049,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(289762,8049,'es','Fecha Final de Entrada',0),(289763,8049,'de','Eintrag End-Datum',0),(289764,8049,'en','Entry End Date',0),(289765,8050,'is','',0),(289766,8050,'dr','Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ Ø³ÙØ§Ø±Ø´',0),(289767,8050,'pr','Ø§Ø¹Ù„Ø§Ù… ÙˆØµÙˆÙ„ Ø³ÙØ§Ø±Ø´',0),(289768,8050,'tr','SipariÅŸ bildirim notlarÄ±',0),(289769,8050,'pl','Uwagi potwierdzenie zamÃ³wienia',0),(289770,8050,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(289771,8050,'ur','Ù†Ø¸Ù… Ú©Ø¦Û’ Ù†ÙˆÙ¹',0),(289772,8050,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(289773,8050,'vi','Ghi chÃº xÃ¡c nháº­n ÄÆ¡n hÃ ng',0),(289774,8050,'af','Bestelling Erkeningsnota\'s',0),(289775,8050,'ro','Note de confirmare comandÄƒ',0),(289776,8050,'et','Tellimuse kinnitus mÃ¤rgib',0),(289777,8050,'si','Naloga potrditev opombe',0),(289778,8050,'ba','Urutan pengakuan catatan',0),(289779,8050,'nl','Volgorde Acknowledgment notities',0),(289780,8050,'fi','Tilaa tunnustus Notes',0),(289781,8050,'no','For bekreftelse notater',0),(289782,8050,'da','Ordre bekrÃ¦ftelse noter',0),(289783,8050,'ko','ì£¼ë¬¸ ìŠ¹ì¸ ë…¸íŠ¸',0),(289784,8050,'he','×•×™×“×•×¢ ×”×¢×¨×•×ª',0),(289785,8050,'el','Î£ÎµÎ¹ÏÎ¬ Î±Î½Î±Î³Î½ÏŽÏÎ¹ÏƒÎ· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(289786,8050,'zh','è®¢è´­ç¡®è®¤ä¿¡\r\n',0),(289787,8050,'sv','Ordning bekrÃ¤ftelsen anteckningar',0),(289788,8050,'it','Note di conferma ordine',0),(289789,8050,'tl','',0),(289790,8050,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3607;&#3637;&#3656;&#3649;&#3626;&#3604;&#3591;&#3623;&#3656;&#3634;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(289791,8050,'hi','à¤†à¤¦à¥‡à¤¶ à¤°à¤¸à¥€à¤¦ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(289792,8050,'ms','Nota-Nota Akuan perintah',0),(289793,8050,'ar','ÙˆØªÙ„Ø§Ø­Ø¸ Ø§Ø¹ØªØ±Ø§Ù Ø§Ù„Ù†Ø¸Ø§Ù…',0),(289794,8050,'fr','Notes d\'accusÃ© de rÃ©ception commande',0),(289795,8050,'jp','æ³¨æ–‡ã®å—ä¿¡ç¢ºèªã®ãƒŽãƒ¼ãƒˆ',0),(289796,8050,'pt','Notas de confirmaÃ§Ã£o de ordem',0),(289797,8050,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(289798,8050,'es','Reconocimiento de Orden Notas',0),(289799,8050,'de','Bestellung-BestÃ¤tigung-Notes',0),(289800,8050,'en','Order Acknowledgment Notes',0),(289801,8051,'is','',0),(289802,8051,'dr','ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø§Ø¹Ù…Ø§Ù„ Ø´ÙˆØ¯',0),(289803,8051,'pr','ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø§Ø¹Ù…Ø§Ù„ Ø´ÙˆØ¯',0),(289804,8051,'tr','Sadece bu ÅŸirket iÃ§in geÃ§erlidir',0),(289805,8051,'pl','Stosuje siÄ™ tylko do tej firmy',0),(289806,8051,'bg','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð° ÑÐ°Ð¼Ð¾ Ð·Ð° Ñ‚Ð°Ð·Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(289807,8051,'ur','ØµØ±Ù Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ùˆ Ù„Ú¯Ø§Ø¦ÛŒÚº',0),(289808,8051,'sr','ÐžÐ´Ð½Ð¾ÑÐµ ÑÐ°Ð¼Ð¾ Ð½Ð° Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(289809,8051,'vi','Chá»‰ á»¨ng Dá»¥ng cho CÃ´ng Ty nÃ y',0),(289810,8051,'af','Pas Slegs toe vir hierdie Onderneming',0),(289811,8051,'ro','Se aplicÄƒ numai la aceastÄƒ companie',0),(289812,8051,'et','Kohalda ainult selle ettevÃµtte jaoks',0),(289813,8051,'si','Uporablja samo za to podjetje',0),(289814,8051,'ba','Hanya berlaku untuk perusahaan ini',0),(289815,8051,'nl','Gelden alleen voor dit bedrijf',0),(289816,8051,'fi','Sovelletaan ainoastaan tÃ¤mÃ¤n yrityksen',0),(289817,8051,'no','Gjelde bare for dette selskapet',0),(289818,8051,'da','GÃ¦lde kun for dette selskab',0),(289819,8051,'ko','ì´ íšŒì‚¬ì—ë§Œ ì ìš©',0),(289820,8051,'he','×—×œ×™× ×¨×§ ×¢×œ ×”×—×‘×¨×” ×”×–×•',0),(289821,8051,'el','Î™ÏƒÏ‡ÏÎ¿Ï…Î½ Î¼ÏŒÎ½Î¿ Î³Î¹Î± Ï„Î·Î½ ÎµÎ½ Î»ÏŒÎ³Ï‰ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(289822,8051,'zh','ä»…é€‚ç”¨äºŽæœ¬å…¬å¸\r\n',0),(289823,8051,'sv','GÃ¤ller endast detta fÃ¶retag',0),(289824,8051,'it','Si applica solo a questa azienda',0),(289825,8051,'tl','',0),(289826,8051,'th','&#3651;&#3594;&#3657;&#3648;&#3593;&#3614;&#3634;&#3632;&#3585;&#3633;&#3610;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3609;&#3637;&#3657;',0),(289827,8051,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‡à¤µà¤² à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(289828,8051,'ms','Digunakan hanya kepada Syarikat ini',0),(289829,8051,'ar','ØªÙ†Ø·Ø¨Ù‚ ÙÙ‚Ø· Ø¹Ù„Ù‰ Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(289830,8051,'fr','S\'applique uniquement Ã  cette sociÃ©tÃ©',0),(289831,8051,'jp','ã“ã®ä¼šç¤¾ã«ã®ã¿é©ç”¨ã•ã‚Œã¾ã™ã€‚',0),(289832,8051,'pt','Se aplicam somente a esta empresa',0),(289833,8051,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½ÑÑŽÑ‚ÑÑ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ðº ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(289834,8051,'es','Aplicar Solamenta a esta Empresa',0),(289835,8051,'de','Gelten Sie nur fÃ¼r diese Firma',0),(289836,8051,'en','Apply Only to this Company',0),(289837,8052,'is','',0),(289838,8052,'dr','ØªÙ†Ø¸ÙŠÙ… Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(289839,8052,'pr','ØªÙ†Ø¸ÙŠÙ… Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(289840,8052,'tr','AlÄ±ÅŸveriÅŸ sepeti parola ayarla',0),(289841,8052,'pl','Zakupy koszyka hasÅ‚o zestaw',0),(289842,8052,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐºÐ° Ð·Ð° Ð¿Ð°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ',0),(289843,8052,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(289844,8052,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ñƒ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ñƒ ÐºÐ¾Ð»Ð¸Ñ†Ð° Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ',0),(289845,8052,'vi','Táº¡o Máº­t MÃ£ Giá» HÃ ng',0),(289846,8052,'af','Stel Shopping Cart wagwoord',0),(289847,8052,'ro','SetaÅ£i parola de coÅŸ de cumpÄƒrÄƒturi',0),(289848,8052,'et','B2B kasutaja salasÃµna',0),(289849,8052,'si','Iz Shopping voziÄek geslo',0),(289850,8052,'ba','Mengatur Password keranjang belanja',0),(289851,8052,'nl','Shopping Cart wachtwoord instellen',0),(289852,8052,'fi','Asettaa Shopping Cart salasana',0),(289853,8052,'no','Satt Shopping Cart passord',0),(289854,8052,'da','SÃ¦t Shopping Cart adgangskode',0),(289855,8052,'ko','ì‡¼í•‘ ì¹´íŠ¸ ì•”í˜¸ ì„¤ì •',0),(289856,8052,'he','×”×’×“×¨ ×¡×™×¡×ž×” ×¢×’×œ×ª ×§× ×™×•×ª',0),(289857,8052,'el','Î Î¿Ï… ÏˆÏŽÎ½Î¹Î± ÎºÎ±Î»Î¬Î¸Î¹ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(289858,8052,'zh','è®¾ç½®è´­ç‰©è½¦å¯†ç \r\n',0),(289859,8052,'sv','Ange Shopping Cart lÃ¶senord',0),(289860,8052,'it','Impostare Password carrello di Shopping',0),(289861,8052,'tl','',0),(289862,8052,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3606;&#3648;&#3586;&#3655;&#3609;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(289863,8052,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(289864,8052,'ms','Set kata laluan dalam troli membeli-belah',0),(289865,8052,'ar','ÙƒÙ„Ù…Ø© Ø³Ø±Ù‘ Ø¹Ø±Ø¨Ø© Ø§Ù„ØªØ³ÙˆÙ‘Ù‚',0),(289866,8052,'fr','Shopping Cart mot de passe de la valeur',0),(289867,8052,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚° ã‚«ãƒ¼ãƒˆã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰è¨­å®šã—ã¾ã™ã€‚',0),(289868,8052,'pt','Definir a senha do carrinho de compras',0),(289869,8052,'ru','Ð—Ð°Ð´Ð°Ñ‚ÑŒ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ ÐºÐ¾Ñ€Ð·Ð¸Ð½Ñƒ Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº',0),(289870,8052,'es','Configurar ContraseÃ±a de Carrito de Compras',0),(289871,8052,'de','Festlegen Sie Shopping Cart-Kennwort',0),(289872,8052,'en','Set Shopping Cart Password',0),(289873,8053,'is','',0),(289874,8053,'dr','1 Ø§Ø³Øª ',0),(289875,8053,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ Ø§ÙŠÙ…ÙŠÙ„ 1 Ø§Ø³Øª ',0),(289876,8053,'tr','AlÄ±ÅŸveriÅŸ sepeti giriÅŸ e-posta bir ÅŸey',0),(289877,8053,'pl','Zakupy koszyka logowania jest jeden E-mail',0),(289878,8053,'bg','ÐŸÐ°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ ÐºÐ¾ÑˆÐ½Ð¸Ñ†Ð° Ð²Ñ…Ð¾Ð´ Ðµ ÐµÐ´Ð¸Ð½ Ð¸Ð¼ÐµÐ¹Ð»',0),(289879,8053,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ù…ÛŒÚº Ù„Ø§Ú¯ Ø§Ù† Ø§ÛŒÚ© Ø§ÛŒ Ù…ÛŒÙ„ ÛÛ’',0),(289880,8053,'sr','ÐšÑƒÐ¿Ð¾Ð²Ð¸Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ†Ð° Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ñ˜Ðµ Ñ˜ÐµÐ´Ð°Ð½ Ð•Ð¼Ð°Ð¸Ð»',0),(289881,8053,'vi','MÃ£ ÄÄƒng Nháº­p Giá» HÃ ng LÃ  Email Má»™t',0),(289882,8053,'af','Winkeltrollie Aanteken is dieselfde as E-pos',0),(289883,8053,'ro','Shopping Cart Login este un E-mail',0),(289884,8053,'et','Shopping ostukorvi Login on e-posti Ã¼he',0),(289885,8053,'si','Nakupovalni voziÄek Login je en Email',0),(289886,8053,'ba','Belanja troli Login adalah satu Email',0),(289887,8053,'nl','Shopping Cart Login is een E-mail',0),(289888,8053,'fi','Shopping Cart johdonmukaisuus on sÃ¤hkÃ¶posti',0),(289889,8053,'no','Shopping Cart logikk er en e-post',0),(289890,8053,'da','Shopping Cart Login er E-mail en',0),(289891,8053,'ko','ì´ë©”ì¼ í•˜ë‚˜ëŠ” ì‡¼í•‘ ì¹´íŠ¸ ë¡œê·¸ì¸',0),(289892,8053,'he','×§× ×™×•×ª ×¢×’×œ×ª ×›× ×™×¡×” ×”×•× ××—×“ ×“×•× ×œ',0),(289893,8053,'el','Î¨ÏŽÎ½Î¹Î± ÎºÎ±Î»Î¬Î¸Î¹ ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹ Î­Î½Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(289894,8053,'zh','è´­ç‰©è½¦æ˜¯ç”¨ç”µå­é‚®ä»¶ç™»å½•\r\n',0),(289895,8053,'sv','Shopping Cart Login Ã¤r en e-post',0),(289896,8053,'it','Login carrello di shopping Ã¨ una Email',0),(289897,8053,'tl','',0),(289898,8053,'th','&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3619;&#3606;&#3648;&#3586;&#3655;&#3609;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3651;&#3594;&#3657;&#3629;&#3637;&#3648;&#3617;&#3621;',0),(289899,8053,'hi','à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤²à¥‰à¤—à¤¿à¤¨ à¤ˆà¤®à¥‡à¤² à¤à¤• à¤¹à¥ˆ',0),(289900,8053,'ms','Log-masuk troli membeli-belah adalah satu e-mel',0),(289901,8053,'ar','Ø¥Ø³Ù… Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø¥Ù„Ù‰ Ø¹Ø±Ø¨Ø© Ø§Ù„ØªØ³ÙˆÙ‘Ù‚ Ù‡Ùˆ : Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø£ÙˆÙ„',0),(289902,8053,'fr','Shopping Cart Login est un Email',0),(289903,8053,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« 1 ã¤ã¯ã€ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚°ã‚«ãƒ¼ãƒˆ ãƒ­ã‚°ã‚¤ãƒ³',0),(289904,8053,'pt','Login carrinho de compras Ã© um E-mail',0),(289905,8053,'ru','Ð¢Ð¾Ñ€Ð³Ð¾Ð²Ñ‹Ð¹ ÐºÐ¾Ñ€Ð·Ð¸Ð½Ñƒ Ð²Ð¾Ð¹Ñ‚Ð¸ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð¾Ð´Ð½Ð¾Ð¹ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(289906,8053,'es','Carrito de Compras Login es Email Uno',0),(289907,8053,'de','Shopping Cart Login ist E-Mail ein',0),(289908,8053,'en','Shopping Cart Login is Email One',0),(289909,8054,'is','',0),(289910,8054,'dr','ÙƒØ¯Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§',0),(289911,8054,'pr','ÙƒØ¯Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§',0),(289912,8054,'tr','Hangi ÅŸirketler',0),(289913,8054,'pl','Jakiej firmy',0),(289914,8054,'bg','ÐšÐ¾Ð¸ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(289915,8054,'ur','Ø¬Ùˆ Ú©Ù…Ù¾Ù†ÛŒØ§Úº',0),(289916,8054,'sr','ÐšÐ¾Ñ˜Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(289917,8054,'vi','Cty nÃ o',0),(289918,8054,'af','Watter Ondernemings',0),(289919,8054,'ro','Ce companii',0),(289920,8054,'et','Millised ettevÃµtted',0),(289921,8054,'si','Katera podjetja',0),(289922,8054,'ba','Perusahaan mana',0),(289923,8054,'nl','Welke bedrijven',0),(289924,8054,'fi','MitkÃ¤ yritykset',0),(289925,8054,'no','Hvilke selskaper',0),(289926,8054,'da','Hvilke virksomheder',0),(289927,8054,'ko','ì–´ë–¤ íšŒì‚¬',0),(289928,8054,'he','××™×œ×• ×—×‘×¨×•×ª',0),(289929,8054,'el','Î Î¿Î¹ÎµÏ‚ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚',0),(289930,8054,'zh','å“ªäº›å…¬å¸\r\n',0),(289931,8054,'sv','Vilka fÃ¶retag',0),(289932,8054,'it','Quali aziende',0),(289933,8054,'tl','',0),(289934,8054,'th','&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3652;&#3627;&#3609;',0),(289935,8054,'hi','à¤œà¥‹ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚',0),(289936,8054,'ms','Syarikat-syarikat yang',0),(289937,8054,'ar','Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„ØªÙŠ',0),(289938,8054,'fr','Quelles entreprises',0),(289939,8054,'jp','ã©ã®ä¼æ¥­',0),(289940,8054,'pt','Quais as empresas',0),(289941,8054,'ru','ÐšÐ°ÐºÐ¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(289942,8054,'es','Cuales Empresas',0),(289943,8054,'de','Welche Unternehmen',0),(289944,8054,'en','Which Companies',0),(289945,8055,'is','',0),(289946,8055,'dr','Ø§ÙˆÙ„ÙˆÙŠØª Ø­Ù…Ù„',0),(289947,8055,'pr','Ø§ÙˆÙ„ÙˆÙŠØª Ø­Ù…Ù„',0),(289948,8055,'tr','Nakliye tercihi',0),(289949,8055,'pl','WysyÅ‚ka preferencji',0),(289950,8055,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½Ð¸Ðµ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(289951,8055,'ur','ØªØ±Ø¬ÛŒØ­ Ø´Ù¾Ù†Ú¯',0),(289952,8055,'sr','Ð–ÐµÑ™ÐµÐ½Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(289953,8055,'vi','Váº­n chuyá»ƒn Æ°a thÃ­ch',0),(289954,8055,'af','Versendingsvoorkeur',0),(289955,8055,'ro','PreferinÅ£a de transport maritim',0),(289956,8055,'et','Tarnimise eelistused',0),(289957,8055,'si','Ladijskega prometa prednost',0),(289958,8055,'ba','Pengiriman preferensi',0),(289959,8055,'nl','Voorkeur voor verzending',0),(289960,8055,'fi','Toimitus Preference',0),(289961,8055,'no','Frakt preferanse',0),(289962,8055,'da','Shipping prÃ¦ference',0),(289963,8055,'ko','ìš´ì†¡ í™˜ê²½ ì„¤ì •',0),(289964,8055,'he','×ž×©×œ×•×— ×”×¢×“×¤×”',0),(289965,8055,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î±Ï‚ Ï„Î·Î½ Ï€ÏÎ¿Ï„Î¯Î¼Î·ÏƒÎ·Ï‚',0),(289966,8055,'zh','èˆªè¿é¦–é€‰\r\n',0),(289967,8055,'sv','Frakt preferens',0),(289968,8055,'it','Preferenze di spedizione',0),(289969,8055,'tl','',0),(289970,8055,'th','&#3626;&#3636;&#3607;&#3608;&#3636;&#3614;&#3636;&#3648;&#3624;&#3625;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(289971,8055,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤°à¥€à¤¯à¤¤à¤¾',0),(289972,8055,'ms','Pilihan penghantaran',0),(289973,8055,'ar','ØªÙØ¶ÙŠÙ„Ø§Øª Ø§Ù„Ø´Ø­Ù†',0),(289974,8055,'fr','Mode de transport',0),(289975,8055,'jp','å‡ºè·ã®å„ªå…ˆé †ä½',0),(289976,8055,'pt','PreferÃªncia do transporte',0),(289977,8055,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚ÐµÐ½Ð¸Ñ',0),(289978,8055,'es','preferencias de Transporte',0),(289979,8055,'de','Versand PrÃ¤ferenz',0),(289980,8055,'en','Shipping Preference',0),(289981,8056,'is','',0),(289982,8056,'dr','Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ ',0),(289983,8056,'pr','Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ ',0),(289984,8056,'tr','Fazla Ã¶deme emri',0),(289985,8056,'pl','ZamÃ³wienie nadpÅ‚aty',0),(289986,8056,'bg','ÐÐ°Ð´Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾ Ñ€ÐµÐ´',0),(289987,8056,'ur','Ø§ÙˆÙˆØ±Ù¾ÛŒÙ…Ø§Ù†Ù¹ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(289988,8056,'sr','ÐŸÑ€ÐµÐºÐ¾Ð¼ÐµÑ€Ð½Ñƒ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(289989,8056,'vi','ÄÆ¡n hÃ ng tráº£ quÃ¡ háº¡n',0),(289990,8056,'af','Oorbetaalde Bestelling',0),(289991,8056,'ro','Ordine de plata suplimentarÄƒ',0),(289992,8056,'et','Enammaksed jÃ¤rjekorras',0),(289993,8056,'si','PreplaÄilo nalog',0),(289994,8056,'ba','Kelebihan pembayaran Order',0),(289995,8056,'nl','Overbetaling volgorde',0),(289996,8056,'fi','Liikaa tilaa',0),(289997,8056,'no','Overbetalingen rekkefÃ¸lge',0),(289998,8056,'da','Overbetaling rÃ¦kkefÃ¸lge',0),(289999,8056,'ko','Overpayment ìˆœì„œ',0),(290000,8056,'he','×”×¡×“×¨ ×ª×©×œ×•× ×™×ª×¨',0),(290001,8056,'el','Î‘Ï‡ÏÎµÏ‰ÏƒÏ„Î®Ï„Ï‰Ï‚ ÎºÎ±Ï„Î±Î²Î»Î·Î¸Î­Î½Ï„Î¿Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(290002,8056,'zh','å¤šç¼´è®¢è´­\r\n',0),(290003,8056,'sv','Ã–verbetalning ordning',0),(290004,8056,'it','Ordine di pagamento in eccesso',0),(290005,8056,'tl','',0),(290006,8056,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3585;&#3636;&#3609;&#3585;&#3623;&#3656;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(290007,8056,'hi','Overpayment à¤•à¥à¤°à¤®',0),(290008,8056,'ms','Perintah berlebihan',0),(290009,8056,'ar','Ø£Ù…Ø± Ø¯ÙØ¹ Ù…Ø¨Ø§Ù„Øº Ø²Ø§Ø¦Ø¯Ø©',0),(290010,8056,'fr','Ordre de paiement en trop',0),(290011,8056,'jp','éŽæ‰•ã„é †åº',0),(290012,8056,'pt','Ordem de pagamento indevido',0),(290013,8056,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ€ÐµÐ¿Ð»Ð°Ñ‚Ñ‹',0),(290014,8056,'es','Orden de Pago Excesivo',0),(290015,8056,'de','Ãœberzahlung-Bestellung',0),(290016,8056,'en','Overpayment Order',0),(290017,8057,'is','',0),(290018,8057,'dr','Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¯Ø³ØªÙ…Ø²Ø¯Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ÙŠØ§ Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(290019,8057,'pr','Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¯Ø³ØªÙ…Ø²Ø¯Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ÙŠØ§ Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(290020,8057,'tr','STD emek veya mÃ¼ÅŸteri satÄ±ÅŸ hesabÄ± kullanmak iÃ§in boÅŸ bÄ±rakÄ±n',0),(290021,8057,'pl','Pozostaw puste, aby uÅ¼yÄ‡ konta sprzedaÅ¼y Std pracy lub klienta',0),(290022,8057,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð·Ð° Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Std Ñ‚Ñ€ÑƒÐ´ Ð¸Ð»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(290023,8057,'ur','Ø¬Ù†Ø³ÛŒ Ù…Ù†Ù‚ÙˆÙ„Û Ø§Ù…Ø±Ø§Ø¶ Ù…Ø´Ù‚Øª ÛŒØ§ Ú©Ø³Ù¹Ù…Ø± Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(290024,8057,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¡Ñ‚Ð´ Ñ€Ð°Ð´Ð° Ð¸Ð»Ð¸ ÐºÑƒÐ¿Ð°Ñ† Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð½Ð°Ð»Ð¾Ð³',0),(290025,8057,'vi','Äá»ƒ trá»‘ng Ä‘á»ƒ dÃ¹ng nhÃ¢n cÃ´ng chuáº©n hay TK bÃ¡n hÃ ng cá»§a khÃ¡ch hÃ ng',0),(290026,8057,'af','Laat Oop Om Std Arbeid of KliÃ«nt / Klant Verkoopsrekening te Gebruik',0),(290027,8057,'ro','LÄƒsaÅ£i necompletat pentru a utiliza contul Std muncii sau client vÃ¢nzÄƒri',0),(290028,8057,'et','JÃ¤tke tÃ¼hjaks kasutada Std Labor vÃµi kliendi MÃ¼Ã¼gikonto',0),(290029,8057,'si','Pustite prazno uporabite Std dela ali kupec prodaja raÄun',0),(290030,8057,'ba','Biarkan kosong untuk menggunakan tenaga kerja Std atau pelanggan penjualan Account',0),(290031,8057,'nl','Laat leeg om Std arbeid of klant Sales Account te gebruiken',0),(290032,8057,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi kÃ¤yttÃ¤Ã¤ Std tyÃ¶voiman tai asiakkaan myynnin tili',0),(290033,8057,'no','Vil bruke Std arbeidskraft eller kunden salgskontoen',0),(290034,8057,'da','Lad stÃ¥ tomt for at bruge Std arbejdskraft eller kunde salgskontoen',0),(290035,8057,'ko','í‘œì¤€ ë˜ëŠ” ê³ ê° íŒë§¤ ê³„ì •ì„ ì‚¬ìš© í•˜ë„ë¡ ë¹„ì›Œ ë‘¡ë‹ˆë‹¤',0),(290036,8057,'he','×”×©××¨ ××•×ª×• ×¨×™×§ ×›×“×™ ×œ×”×©×ª×ž×© ×‘×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª Std ×”×¢×‘×•×“×” ××• ×œ×§×•×—',0),(290037,8057,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ Î³Î¹Î± Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Std ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î® Ï€ÎµÎ»Î¬Ï„Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(290038,8057,'zh','ç•™ç©ºä½¿ç”¨æ ‡å‡†åŠ³åŠ¨æˆ–å®¢æˆ·é”€å”®å¸æˆ·\r\n',0),(290039,8057,'sv','LÃ¤mna tomt fÃ¶r att anvÃ¤nda Std arbetskraft eller kund fÃ¶rsÃ¤ljning konto',0),(290040,8057,'it','Lasciare vuoto per utilizzare manodopera Std o cliente conto vendita',0),(290041,8057,'tl','',0),(290042,8057,'th','&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657; Std Labor &#3627;&#3619;&#3639;&#3629;&#3610;&#3633;&#3597;&#3594;&#3637;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3586',0),(290043,8057,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤–à¤¾à¤¤à¥‡ Std à¤¶à¥à¤°à¤® à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚',0),(290044,8057,'ms','Tinggalkan tempat kosong untuk menggunakan akaun jualan PCB pekerja atau pelanggan',0),(290045,8057,'ar','Ø§ØªØ±Ùƒ Ø§Ù„Ù…Ø³Ø§Ø­Ø© ÙØ§Ø±ØºØ© Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Std Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ù„ Ø£Ùˆ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(290046,8057,'fr','Laissez vide pour utiliser Std Labor ou client compte de vente',0),(290047,8057,'jp','Std åŠ´åƒã¾ãŸã¯é¡§å®¢ã®è²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½¿ç”¨ã™ã‚‹ç©ºç™½ã®ã¾ã¾ã«',0),(290048,8057,'pt','Deixe em branco para usar Std trabalho ou cliente conta de vendas',0),(290049,8057,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Std Ñ‚Ñ€ÑƒÐ´Ð° Ð¸Ð»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(290050,8057,'es','Dejar en Blanco para Usar Labor EstÃ¡ndar o Cuenta de Ventas de Cliente',0),(290051,8057,'de','Freilassen Sie fÃ¼r Std Arbeit oder Customer Sales Account verwenden',0),(290052,8057,'en','Leave Blank To Use Std Labor or Customer Sales Account',0),(290053,8058,'is','',0),(290054,8058,'dr','Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ÙŠØ§ Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(290055,8058,'pr','Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ÙŠØ§ Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(290056,8058,'tr','STD emek veya mÃ¼ÅŸteri satÄ±ÅŸ hesabÄ± kullanmak iÃ§in boÅŸ bÄ±rakÄ±n',0),(290057,8058,'pl','Pozostaw puste, aby uÅ¼yÄ‡ konta sprzedaÅ¼y Std pracy lub klienta',0),(290058,8058,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð·Ð° Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Std Ñ‚Ñ€ÑƒÐ´ Ð¸Ð»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(290059,8058,'ur','Ø¬Ù†Ø³ÛŒ Ù…Ù†Ù‚ÙˆÙ„Û Ø§Ù…Ø±Ø§Ø¶ Ù…Ø´Ù‚Øª ÛŒØ§ Ú©Ø³Ù¹Ù…Ø± Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(290060,8058,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¡Ñ‚Ð´ Ñ€Ð°Ð´Ð° Ð¸Ð»Ð¸ ÐºÑƒÐ¿Ð°Ñ† Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð½Ð°Ð»Ð¾Ð³',0),(290061,8058,'vi','Äá»ƒ trá»‘ng Ä‘á»ƒ dÃ¹ng nhÃ¢n cÃ´ng chuáº©n hay TK bÃ¡n hÃ ng cá»§a khÃ¡ch hÃ ng',0),(290062,8058,'af','Laat Oop Om Std Arbeid of KliÃ«nt / Klant Verkoopsrekening te Gebruik',0),(290063,8058,'ro','LÄƒsaÅ£i necompletat pentru a utiliza contul Std muncii sau client vÃ¢nzÄƒri',0),(290064,8058,'et','JÃ¤tke tÃ¼hjaks kasutada Std Labor vÃµi kliendi MÃ¼Ã¼gikonto',0),(290065,8058,'si','Pustite prazno uporabite Std dela ali kupec prodaja raÄun',0),(290066,8058,'ba','Biarkan kosong untuk menggunakan tenaga kerja Std atau pelanggan penjualan Account',0),(290067,8058,'nl','Laat leeg om Std arbeid of klant Sales Account te gebruiken',0),(290068,8058,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi kÃ¤yttÃ¤Ã¤ Std tyÃ¶voiman tai asiakkaan myynnin tili',0),(290069,8058,'no','Vil bruke Std arbeidskraft eller kunden salgskontoen',0),(290070,8058,'da','Lad stÃ¥ tomt for at bruge Std arbejdskraft eller kunde salgskontoen',0),(290071,8058,'ko','í‘œì¤€ ë˜ëŠ” ê³ ê° íŒë§¤ ê³„ì •ì„ ì‚¬ìš© í•˜ë„ë¡ ë¹„ì›Œ ë‘¡ë‹ˆë‹¤',0),(290072,8058,'he','×”×©××¨ ××•×ª×• ×¨×™×§ ×›×“×™ ×œ×”×©×ª×ž×© ×‘×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª Std ×”×¢×‘×•×“×” ××• ×œ×§×•×—',0),(290073,8058,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ Î³Î¹Î± Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Std ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î® Ï€ÎµÎ»Î¬Ï„Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(290074,8058,'zh','ç•™ç©ºä½¿ç”¨æ ‡å‡†åŠ³åŠ¨æˆ–å®¢æˆ·é”€å”®å¸æˆ·\r\n',0),(290075,8058,'sv','LÃ¤mna tomt fÃ¶r att anvÃ¤nda Std arbetskraft eller kund fÃ¶rsÃ¤ljning konto',0),(290076,8058,'it','Lasciare vuoto per utilizzare manodopera Std o cliente conto vendita',0),(290077,8058,'tl','',0),(290078,8058,'th','&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657; Std Labor &#3627;&#3619;&#3639;&#3629;&#3610;&#3633;&#3597;&#3594;&#3637;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3586',0),(290079,8058,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤–à¤¾à¤¤à¥‡ Std à¤¶à¥à¤°à¤® à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚',0),(290080,8058,'ms','Tinggalkan tempat kosong untuk menggunakan akaun jualan PCB pekerja atau pelanggan',0),(290081,8058,'ar','Ø§ØªØ±Ùƒ Ø§Ù„Ù…Ø³Ø§Ø­Ø© ÙØ§Ø±ØºØ© Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Std Ø­Ø²Ø¨ Ø§Ù„Ø¹Ù…Ù„ Ø£Ùˆ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(290082,8058,'fr','Laissez vide pour utiliser Std Labor ou client compte de vente',0),(290083,8058,'jp','Std åŠ´åƒã¾ãŸã¯é¡§å®¢ã®è²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½¿ç”¨ã—ã¦ç©ºç™½ã®ã¾ã¾ã«',0),(290084,8058,'pt','Deixe em branco para usar Std trabalho ou cliente conta de vendas',0),(290085,8058,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Std Ñ‚Ñ€ÑƒÐ´Ð° Ð¸Ð»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(290086,8058,'es','Dejar en Blanco para Usar Labor EstÃ¡ndar o Cuenta de Ventas de Cliente ',0),(290087,8058,'de','Freilassen Sie fÃ¼r Std Arbeit oder Customer Sales Account verwenden',0),(290088,8058,'en','Leave Blank to Use Std Labor or Customer Sales Account',0),(290089,8059,'is','',0),(290090,8059,'dr','ØªØ¹ÙŠÙŠÙ† Ø®Ù„Ø§ ØµÙ‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§',0),(290091,8059,'pr','ØªØ¹ÙŠÙŠÙ† Ø®Ù„Ø§ ØµÙ‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§',0),(290092,8059,'tr','Hesap Ã–zeti atama',0),(290093,8059,'pl','Przypisywanie podsumowania konta',0),(290094,8059,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ñ€ÐµÐ·ÑŽÐ¼Ð¸Ñ€Ð°Ð½Ðµ',0),(290095,8059,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³Ù…Ù…Ø¢Ø±Ø§Ø²Ø´Ù† ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(290096,8059,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ð¡ÑƒÐ¼Ð¼Ð°Ñ€Ð¸Ð·Ð°Ñ‚Ð¸Ð¾Ð½ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(290097,8059,'vi','Chá»‰ Äá»‹nh Tá»•ng Há»£p TK',0),(290098,8059,'af','Rekening Opsomming Benoem',0),(290099,8059,'ro','AtribuiÅ£i contului sumarizare',0),(290100,8059,'et','MÃ¤Ã¤rake konto kokkuvÃµtet',0),(290101,8059,'si','Priredi raÄun povzetka',0),(290102,8059,'ba','Menetapkan Account Summarization',0),(290103,8059,'nl','Account Samenvattingsstructuur toewijzen',0),(290104,8059,'fi','MÃ¤Ã¤ritÃ¤ tilin Yhteenveto',0),(290105,8059,'no','Tilordne kontoen Summarization',0),(290106,8059,'da','Tildel kontoen sammendrag',0),(290107,8059,'ko','ê³„ì • ìš”ì•½ì„ í• ë‹¹',0),(290108,8059,'he','×œ×”×§×¦×•×ª ×œ×—×©×‘×•×Ÿ ×¡×™×›×•×',0),(290109,8059,'el','Î•ÎºÏ‡ÏŽÏÎ·ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€ÎµÏÎ¹Î»Î·Ï€Ï„Î¹ÎºÎ® Ï€Î±ÏÎ¿Ï…ÏƒÎ¯Î±ÏƒÎ· Ï„Î·Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯Î±Ï‚',0),(290110,8059,'zh','æŒ‡å®šå¸æˆ·ç»¼è¿°\r\n',0),(290111,8059,'sv','Tilldela konto Sammanfattning',0),(290112,8059,'it','Assegnare il riepilogo Account',0),(290113,8059,'tl','',0),(290114,8059,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3619;&#3640;&#3611;&#3618;&#3629;&#3604;',0),(290115,8059,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤¸à¤‚à¤•à¥à¤·à¤¿à¤ªà¥à¤¤à¥€à¤•à¤°à¤£ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(290116,8059,'ms','Peruntukkan Summarization akaun',0),(290117,8059,'ar','ØªØ¹ÙŠÙŠÙ† ØªÙ„Ø®ÙŠØµ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(290118,8059,'fr','Assignez le rÃ©sumÃ© de compte',0),(290119,8059,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®è¦ç´„ã‚’å‰²ã‚Šå½“ã¦ã‚‹',0),(290120,8059,'pt','Atribuir a sumarizaÃ§Ã£o de conta',0),(290121,8059,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÑŒÑ‚Ðµ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÐ²Ð¾Ð´Ð½Ñ‹Ñ…',0),(290122,8059,'es','Asignar Resumen de Cuenta',0),(290123,8059,'de','Zuweisen von Account-Zusammenfassung',0),(290124,8059,'en','Assign Account Summarization',0),(290125,8060,'is','',0),(290126,8060,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ù†Ø¬Ø§Ù… Ø®Ù„Ø§ØµÙ‡ Ø³Ø§Ø²ÙŠ ØªÙˆØ¯Ø± ØªÙˆ Ù†ÙŠØ³Øª',0),(290127,8060,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ù†Ø¬Ø§Ù… Ø®Ù„Ø§ØµÙ‡ Ø³Ø§Ø²ÙŠ ØªÙˆØ¯Ø± ØªÙˆ Ù†ÙŠØ³Øª',0),(290128,8060,'tr','Ä°Ã§ iÃ§e geÃ§miÅŸ Ã¶zetleme yapamam',0),(290129,8060,'pl','Nie zagnieÅ¼dÅ¼one podsumowania',0),(290130,8060,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ Ð²Ð»Ð¾Ð¶ÐµÐ½Ð¸ Ñ€ÐµÐ·ÑŽÐ¼Ð¸Ñ€Ð°Ð½Ðµ',0),(290131,8060,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ø³Ù…Ù…Ø¢Ø±Ø§Ø²Ø´Ù† Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(290132,8060,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ ÑƒÐ³Ð½ÐµÐ¶Ñ’ÐµÐ½Ð¸ Ð¡ÑƒÐ¼Ð¼Ð°Ñ€Ð¸Ð·Ð°Ñ‚Ð¸Ð¾Ð½',0),(290133,8060,'vi','KhÃ´ng thá»ƒ tá»•ng há»£p',0),(290134,8060,'af','Nested Summarization kan doen',0),(290135,8060,'ro','Nu pot face sumarizare imbricate',0),(290136,8060,'et','Pesastatud kokkuvÃµtet ei saa',0),(290137,8060,'si','Ne morem narediti gnezdo povzetka',0),(290138,8060,'ba','Tidak bisa melakukan Nested Summarization',0),(290139,8060,'nl','Niet geneste samenvatting',0),(290140,8060,'fi','Ei sisÃ¤kkÃ¤istÃ¤ yhteenvetoa',0),(290141,8060,'no','Ikke nestede Summarization',0),(290142,8060,'da','Kan ikke indlejret sammendrag',0),(290143,8060,'ko','ì¤‘ì²© ëœ ìš”ì•½ì„ í•  ìˆ˜ ì—†ì–´',0),(290144,8060,'he','×œ× ×™×›×•×œ ×œ×¢×©×•×ª ×¡×™×›×•× ×ž×§×•× × ×™×',0),(290145,8060,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ¼Îµ Î½Î± ÎºÎ¬Î½Î¿Ï…Î¼Îµ Î­Î½Î¸ÎµÏ„Î± Ï€ÎµÏÎ¹Î»Î·Ï€Ï„Î¹ÎºÎ® Ï€Î±ÏÎ¿Ï…ÏƒÎ¯Î±ÏƒÎ· Ï„Î·Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯Î±Ï‚',0),(290146,8060,'zh','æ— æ³•åµŒå¥—ç»¼è¿°\r\n',0),(290147,8060,'sv','Inte kapslade Sammanfattning',0),(290148,8060,'it','Non puÃ² fare il riepilogo nidificato',0),(290149,8060,'tl','',0),(290150,8060,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3607;&#3635;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3605;&#3656;&#3634;&#3591;&#3654;&#3627;&#3621;&#3634;&#3618;&#3619;&#3632;&#3604;&#3633;&#3610;',0),(290151,8060,'hi','à¤¨à¥‡à¤¸à¥à¤Ÿà¥‡à¤¡ à¤•à¤¾ à¤¸à¤‚à¤•à¥à¤·à¤¿à¤ªà¥à¤¤à¥€à¤•à¤°à¤£ à¤•à¤°à¤¤à¥‡ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(290152,8060,'ms','Tidak dapat Summarization bersarang',0),(290153,8060,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¬Ø±Ø§Ø¡ ØªÙ„Ø®ÙŠØµØ§Øª Ù…ØªØ¯Ø§Ø®Ù„Ø©',0),(290154,8060,'fr','Ne peut pas faire de synthÃ¨se imbriquÃ©',0),(290155,8060,'jp','å…¥ã‚Œå­ã«ãªã£ãŸé›†è¨ˆã‚’è¡Œã†ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(290156,8060,'pt','NÃ£o posso fazer sumarizaÃ§Ã£o aninhada',0),(290157,8060,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð²Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ðµ ÑƒÐ¿Ð»Ð¾Ñ‚Ð½ÐµÐ½Ð¸Ñ',0),(290158,8060,'es','No se puede hacer Resumen Anidado',0),(290159,8060,'de','Nicht geschachtelten Verdichtung',0),(290160,8060,'en','Cannot Do Nested Summarization',0),(290161,8061,'is','',0),(290162,8061,'dr','ØµÙØ­Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ØªÙˆØ¶ÙŠØ­ ÙƒØ§Ù…Ù„ Ø¨Ø¨ÙŠÙ†ÙŠØ¯',0),(290163,8061,'pr','ØµÙØ­Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ØªÙˆØ¶ÙŠØ­ ÙƒØ§Ù…Ù„ Ø¨Ø¨ÙŠÙ†ÙŠØ¯',0),(290164,8061,'tr','Buraya tÄ±klayÄ±n aÃ§Ä±klamasÄ±',0),(290165,8061,'pl','Kliknij tutaj, dla wyjaÅ›nienia',0),(290166,8061,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº Ð·Ð° Ð¾Ð±ÑÑÐ½ÐµÐ½Ð¸Ðµ',0),(290167,8061,'ur','ÙˆØ¶Ø§Ø­Øª Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(290168,8061,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð·Ð° Ð¾Ð±Ñ˜Ð°ÑˆÑšÐµÑšÐµ',0),(290169,8061,'vi','Xem trá»£ giÃºp',0),(290170,8061,'af','Sien Hulp Skerm Vir Volledige Verduideliking',0),(290171,8061,'ro','Click aici pentru explicaÅ£ia',0),(290172,8061,'et','Vajuta siia, selgitus',0),(290173,8061,'si','Kliknite tukaj za razlago',0),(290174,8061,'ba','Klik di sini untuk penjelasan',0),(290175,8061,'nl','Klik hier voor uitleg',0),(290176,8061,'fi','Klikkaa tÃ¤stÃ¤',0),(290177,8061,'no','Klikk her for forklaring',0),(290178,8061,'da','Klik her for forklaring',0),(290179,8061,'ko','ì— ëŒ€ í•œ ì„¤ëª…ì€ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(290180,8061,'he','×¨××” ××ª ×ž×¡×š ×”×¢×–×¨×” ×œ×”×¡×‘×¨ ×ž×œ×',0),(290181,8061,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± ÎµÎ¾Î®Î³Î·ÏƒÎ·',0),(290182,8061,'zh','ç‚¹å‡»è¿™é‡Œçœ‹è¯´æ˜Ž',0),(290183,8061,'sv','Klicka hÃ¤r fÃ¶r fÃ¶rklaring',0),(290184,8061,'it','Clicca qui per la spiegazione',0),(290185,8061,'tl','',0),(290186,8061,'th','&#3617;&#3629;&#3591;&#3627;&#3609;&#3657;&#3634;&#3592;&#3629;&#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3586;&#3629;&#3591;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(290187,8061,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(290188,8061,'ms','Klik di sini untuk penerangan',0),(290189,8061,'ar','Ø±Ø§Ø¬Ø¹ Ø´Ø§Ø´Ø© Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø© Ù„ØªÙˆØ¶ÙŠØ­ ÙƒØ§Ù…Ù„',0),(290190,8061,'fr','Cliquez ici pour l\'explication',0),(290191,8061,'jp','èª¬æ˜Žã¯ã€ã“ã¡ã‚‰ã‚’ã”è¦§ãã ã•ã„ã€‚',0),(290192,8061,'pt','Clique aqui para a explicaÃ§Ã£o',0),(290193,8061,'ru','Ð¡Ð¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð­ÐºÑ€Ð°Ð½ ÐŸÐ¾Ð¼Ð¾Ñ‰Ð¸ Ð”Ð»Ñ ÐŸÐ¾Ð»Ð½Ð¾Ð³Ð¾ ÐžÐ±ÑŠÑÑÐ½ÐµÐ½Ð¸Ñ',0),(290194,8061,'es','Vea Pantalla de Ayudo para ExplicaciÃ³n Pleno',0),(290195,8061,'de','Klicken Sie hier, um ErklÃ¤rung',0),(290196,8061,'en','Click Here for Explanation',0),(290197,8062,'is','',0),(290198,8062,'dr','Ø­Ø°Ù Ø³Ø·Ø± ',0),(290199,8062,'pr','Ø­Ø°Ù Ø³Ø·Ø± ',0),(290200,8062,'tr','SatÄ±rÄ± Sil',0),(290201,8062,'pl','Usuwanie linii',0),(290202,8062,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð½Ð¸Ñ',0),(290203,8062,'ur','Ø³Ø·Ø± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(290204,8062,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ñ€ÐµÐ´Ð°',0),(290205,8062,'vi','XÃ³a dÃ²ng ',0),(290206,8062,'af','Skrap Lyn',0),(290207,8062,'ro','Åžterge linia',0),(290208,8062,'et','Kustuta rida',0),(290209,8062,'si','IzbriÅ¡i vrstice',0),(290210,8062,'ba','Menghapus baris',0),(290211,8062,'nl','Regel verwijderen',0),(290212,8062,'fi','Poista rivi',0),(290213,8062,'no','Slette linje',0),(290214,8062,'da','Slet linje',0),(290215,8062,'ko','ì„  ì‚­ì œ',0),(290216,8062,'he','×œ×ž×—×•×§ ×©×•×¨×ª',0),(290217,8062,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(290218,8062,'zh','åˆ é™¤è¡Œ\r\n',0),(290219,8062,'sv','Ta bort rad',0),(290220,8062,'it','Eliminare la riga',0),(290221,8062,'tl','',0),(290222,8062,'th','&#3621;&#3610;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;',0),(290223,8062,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤¹à¤Ÿà¤¾à¤à¤',0),(290224,8062,'ms','Memadam baris',0),(290225,8062,'ar','Ø­Ø°Ù Ø§Ù„Ø³Ø·Ø±',0),(290226,8062,'fr','Supprimer ligne',0),(290227,8062,'jp','è¡Œã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(290228,8062,'pt','Apagar linha',0),(290229,8062,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¡Ñ‚Ñ€Ð¾ÐºÑƒ',0),(290230,8062,'es','Eliminar Linea',0),(290231,8062,'de','Zeile lÃ¶schen',0),(290232,8062,'en','Delete Line',0),(290233,8063,'is','',0),(290234,8063,'dr','Ú†Ù‡ ÙƒØ³ÙŠ ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(290235,8063,'pr','Ú†Ù‡ ÙƒØ³ÙŠ ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(290236,8063,'tr','Kim deÄŸiÅŸtirdi',0),(290237,8063,'pl','Kto zmieniÅ‚',0),(290238,8063,'bg','ÐšÐ¾Ð¹ Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð»',0),(290239,8063,'ur','Ø¬Ùˆ ØªØ¨Ø¯ÛŒÙ„ ÛÙˆ Ú¯ÛŒØ§',0),(290240,8063,'sr','ÐšÐ¾ Ñ˜Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð¾',0),(290241,8063,'vi','Ai thay Ä‘á»•i',0),(290242,8063,'af','Wie Het Verander',0),(290243,8063,'ro','Care a schimbat',0),(290244,8063,'et','Kes muutis',0),(290245,8063,'si','Kdo je spremenil',0),(290246,8063,'ba','Yang berubah',0),(290247,8063,'nl','Die veranderd',0),(290248,8063,'fi','Joka muutti',0),(290249,8063,'no','Som endret',0),(290250,8063,'da','Der er Ã¦ndret',0),(290251,8063,'ko','ëˆ„ê°€ ë³€ê²½',0),(290252,8063,'he','×ž×™ ×©×™× ×”',0),(290253,8063,'el','Î Î¿Î¹Î¿Ï‚ Î¬Î»Î»Î±Î¾Îµ',0),(290254,8063,'zh','è°å˜æ›´\r\n',0),(290255,8063,'sv','Som fÃ¶rÃ¤ndrats',0),(290256,8063,'it','Chi ha cambiato',0),(290257,8063,'tl','',0),(290258,8063,'th','&#3651;&#3588;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(290259,8063,'hi','à¤•à¤¿à¤¸à¤¨à¥‡ à¤¬à¤¦à¤²à¤¾',0),(290260,8063,'ms','Yang berubah',0),(290261,8063,'ar','Ù‚Ø§Ù… Ø¨ØªØºÙŠÙŠØ±Ù‡Ø§',0),(290262,8063,'fr','Qui a changÃ©',0),(290263,8063,'jp','å¤‰æ›´ã—ãŸãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(290264,8063,'pt','Quem mudou',0),(290265,8063,'ru','ÐšÑ‚Ð¾ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ð»',0),(290266,8063,'es','Quien CambiÃ³',0),(290267,8063,'de','Wer geÃ¤ndert',0),(290268,8063,'en','Who Changed',0),(290269,8064,'is','',0),(290270,8064,'dr','(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(290271,8064,'pr','Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(290272,8064,'tr','Faturalanabilir',0),(290273,8064,'pl','Rozliczaniu',0),(290274,8064,'bg','ÐŸÐ»Ð°Ñ‚Ð¸Ð¼Ð¸Ñ‚Ðµ',0),(290275,8064,'ur','Ø¨Ù„Ù„Ø§Ø¨Ù„ÛŒ',0),(290276,8064,'sr','ÐšÐ¾Ñ˜Ðµ Ñ‚Ñ€ÐµÐ±Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸',0),(290277,8064,'vi','CÃ³ Thá»ƒ Láº­p HÃ³a ÄÆ¡n',0),(290278,8064,'af','Billable',0),(290279,8064,'ro','FacturabilÄƒ',0),(290280,8064,'et','Maksustatavaid',0),(290281,8064,'si','ObraÄunava',0),(290282,8064,'ba','Ditagih',0),(290283,8064,'nl','Factureerbare uren',0),(290284,8064,'fi','Laskutettava',0),(290285,8064,'no','Fakturerbar',0),(290286,8064,'da','Fakturerbar',0),(290287,8064,'ko','ì²­êµ¬ ê°€ëŠ¥',0),(290288,8064,'he','×œ×—×™×•×‘',0),(290289,8064,'el','Î§ÏÎµÏŽÏƒÎ¹Î¼ÎµÏ‚',0),(290290,8064,'zh','å¯è®°å¸\r\n',0),(290291,8064,'sv','Fakturerbar tid',0),(290292,8064,'it','Fatturabile',0),(290293,8064,'tl','',0),(290294,8064,'th','&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;',0),(290295,8064,'hi','à¤¬à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤¯à¥‹à¤—à¥à¤¯',0),(290296,8064,'ms','Situasi Billable',0),(290297,8064,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(290298,8064,'fr','Facturables',0),(290299,8064,'jp','è«‹æ±‚',0),(290300,8064,'pt','FaturÃ¡vel',0),(290301,8064,'ru','ÐžÐ¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÐ¼Ð¾Ðµ Ð²Ñ€ÐµÐ¼Ñ',0),(290302,8064,'es','Facturable',0),(290303,8064,'de','Billable',0),(290304,8064,'en','Billable',0),(290305,8065,'is','',0),(290306,8065,'dr','ØªØ¹ÙŠÙŠÙ† Ø®Ù„Ø§ØµÙ‡ Ø³Ø§Ø²ÙŠ',0),(290307,8065,'pr','ØªØ¹ÙŠÙŠÙ† Ø®Ù„Ø§ØµÙ‡ Ø³Ø§Ø²ÙŠ',0),(290308,8065,'tr','Ã–zetleme atama',0),(290309,8065,'pl','Przypisywanie podsumowania',0),(290310,8065,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ·ÑŽÐ¼Ð¸Ñ€Ð°Ð½Ðµ',0),(290311,8065,'ur','Ø³Ù…Ù…Ø¢Ø±Ø§Ø²Ø´Ù† ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(290312,8065,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ð¡ÑƒÐ¼Ð¼Ð°Ñ€Ð¸Ð·Ð°Ñ‚Ð¸Ð¾Ð½',0),(290313,8065,'vi','Chá»‰ Äá»‹nh Tá»“ng Há»£p ',0),(290314,8065,'af','Wys Summarization',0),(290315,8065,'ro','AtribuiÅ£i sumarizare',0),(290316,8065,'et','Kontode summeerimine',0),(290317,8065,'si','Dodelite povzetka',0),(290318,8065,'ba','Menetapkan Summarization',0),(290319,8065,'nl','Samenvatting toewijzen',0),(290320,8065,'fi','MÃ¤Ã¤ritÃ¤ yhteenvedon',0),(290321,8065,'no','Tilordne Summarization',0),(290322,8065,'da','Tildele sammendrag',0),(290323,8065,'ko','í• ë‹¹ ìš”ì•½',0),(290324,8065,'he','×œ×”×§×¦×•×ª ×¡×™×›×•×',0),(290325,8065,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ Ï€ÎµÏÎ¹Î»Î·Ï€Ï„Î¹ÎºÎ® Ï€Î±ÏÎ¿Ï…ÏƒÎ¯Î±ÏƒÎ· Ï„Î·Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯Î±Ï‚',0),(290326,8065,'zh','æŒ‡å®šç»¼è¿°\r\n',0),(290327,8065,'sv','Tilldela Sammanfattning',0),(290328,8065,'it','Assegnare il riepilogo',0),(290329,8065,'tl','',0),(290330,8065,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;',0),(290331,8065,'hi','à¤¸à¤‚à¤•à¥à¤·à¤¿à¤ªà¥à¤¤à¥€à¤•à¤°à¤£ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(290332,8065,'ms','Peruntukkan Summarization',0),(290333,8065,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„ØªÙ„Ø®ÙŠØµ',0),(290334,8065,'fr','Assignez le rÃ©sumÃ©',0),(290335,8065,'jp','è¦ç´„ã‚’å‰²ã‚Šå½“ã¦ã‚‹',0),(290336,8065,'pt','Atribuir a sumarizaÃ§Ã£o',0),(290337,8065,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ ÑƒÐ¿Ð»Ð¾Ñ‚Ð½ÐµÐ½Ð¸Ñ',0),(290338,8065,'es','Asignar Resumen',0),(290339,8065,'de','Zuweisen der Verdichtung',0),(290340,8065,'en','Assign Summarization',0),(290341,8066,'is','',0),(290342,8066,'dr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ØµØ§Ø¯Ø± Ø´Ø¯Ù‡',0),(290343,8066,'pr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ØµØ§Ø¯Ø± Ø´Ø¯Ù‡',0),(290344,8066,'tr','Verilen para iadesi',0),(290345,8066,'pl','Refundacji wydane',0),(290346,8066,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°',0),(290347,8066,'ur','Ø¬Ø§Ø±ÛŒ Ú©Ø±Ø¯Û Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(290348,8066,'sr','Ð˜Ð·Ð²Ñ€ÑˆÐµÐ½',0),(290349,8066,'vi','ÄÃ£ phÃ¡t hÃ nh hoÃ n tráº£',0),(290350,8066,'af','Terugbetaling uitgereik',0),(290351,8066,'ro','Restituire emise',0),(290352,8066,'et','Antud',0),(290353,8066,'si','Izdano povraÄilo',0),(290354,8066,'ba','Pengembalian dana yang dikeluarkan',0),(290355,8066,'nl','Restitutie afgegeven',0),(290356,8066,'fi','Palauttaminen',0),(290357,8066,'no','Tilbakebetaling',0),(290358,8066,'da','Refundering udstedt',0),(290359,8066,'ko','í™˜ë¶ˆ ë°œí–‰',0),(290360,8066,'he','×”×—×–×¨ ×©×”×•× ×¤×§×•',0),(290361,8066,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚ Ï€Î¿Ï… ÎµÎºÎ´Î¯Î´Î¿Î½Ï„Î±Î¹',0),(290362,8066,'zh','é€€æ¬¾å‘å¸ƒ\r\n',0),(290363,8066,'sv','Ã…terbetalning utfÃ¤rdas',0),(290364,8066,'it','Rimborso emesso',0),(290365,8066,'tl','',0),(290366,8066,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3585;&#3634;&#3619;&#3588;&#3639;&#3609;&#3648;&#3591;&#3636;&#3609;',0),(290367,8066,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤œà¤¾à¤°à¥€ à¤•à¤¿à¤',0),(290368,8066,'ms','Bayaran balik yang dikeluarkan',0),(290369,8066,'ar','Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø¥ØµØ¯Ø§Ø±',0),(290370,8066,'fr','Remboursement Ã©mis',0),(290371,8066,'jp','æ‰•ã„æˆ»ã—',0),(290372,8066,'pt','Reembolso emitido',0),(290373,8066,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚ Ð²Ñ‹Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(290374,8066,'es','Reembolso Emitido',0),(290375,8066,'de','RÃ¼ckerstattung ausgegeben',0),(290376,8066,'en','Refund Issued',0),(290377,8067,'is','',0),(290378,8067,'dr','Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø´Ø¯Ù‡ Ù†Ù‡Ø§ÙŠÙŠ',0),(290379,8067,'pr','Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø´Ø¯Ù‡ Ù†Ù‡Ø§ÙŠÙŠ',0),(290380,8067,'tr','Son olarak iÅŸaretlenmiÅŸ',0),(290381,8067,'pl','Oznaczone ostatecznego',0),(290382,8067,'bg','ÐœÐ°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ð¸ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÐµÐ½',0),(290383,8067,'ur','Ø¢Ø®Ø±ÛŒ Ù†Ø´Ø§Ù† Ù„Ú¯Ø§ Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(290384,8067,'sr','ÐžÐ·Ð½Ð°Ñ‡ÐµÐ½Ð¸ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¸',0),(290385,8067,'vi','ÄÃ¡nh dáº¥u Ä‘Ã£ káº¿t thÃºc',0),(290386,8067,'af','Finale gemerk',0),(290387,8067,'ro','Marcat Final',0),(290388,8067,'et','MÃ¤rgitud lÃµplikuks',0),(290389,8067,'si','OznaÄene konÄne',0),(290390,8067,'ba','Menandai akhir',0),(290391,8067,'nl','Definitief gemarkeerd',0),(290392,8067,'fi','Merkitty lopullinen',0),(290393,8067,'no','Merket endelig',0),(290394,8067,'da','Markeret endelige',0),(290395,8067,'ko','ìµœì¢…ìœ¼ë¡œ í‘œì‹œ',0),(290396,8067,'he','×ž×¡×•×ž×Ÿ ×”×¡×•×¤×™',0),(290397,8067,'el','Î£Î®Î¼Î±Î½ÏƒÎ· Ï„ÎµÎ»Î¹ÎºÏŒ',0),(290398,8067,'zh','æ ‡è®°æœ€åŽ\r\n',0),(290399,8067,'sv','MÃ¤rkt sista',0),(290400,8067,'it','Contrassegnato finale',0),(290401,8067,'tl','',0),(290402,8067,'th','&#3607;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(290403,8067,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤',0),(290404,8067,'ms','Menandakan akhir',0),(290405,8067,'ar','ØªÙ… ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© Ù†Ù‡Ø§Ø¦ÙŠ',0),(290406,8067,'fr','MarquÃ©e comme finale',0),(290407,8067,'jp','Final ã¨ãƒžãƒ¼ã‚¯',0),(290408,8067,'pt','Marcado como Final',0),(290409,8067,'ru','ÐžÑ‚Ð¼ÐµÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ñ„Ð¸Ð½Ð°Ð»',0),(290410,8067,'es','Marcado Final',0),(290411,8067,'de','Als Final gekennzeichnet',0),(290412,8067,'en','Marked Final',0),(290413,8068,'is','',0),(290414,8068,'dr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù…Ù„ Ø§Ø³Øª ',0),(290415,8068,'pr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù…Ù„ Ø§Ø³Øª ',0),(290416,8068,'tr','Tam sÄ±rasÄ±dÄ±r.',0),(290417,8068,'pl','ZamÃ³wienie jest juÅ¼ gotowe',0),(290418,8068,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ðµ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð°',0),(290419,8068,'ur','ØªØ±ØªÛŒØ¨ Ù…Ú©Ù…Ù„ ÛÙˆ Ú¯ÛŒØ§ ÛÛ’',0),(290420,8068,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð°',0),(290421,8068,'vi','ÄÆ¡n hÃ ng hoÃ n thÃ nh',0),(290422,8068,'af','Bestelling Is Voltooi',0),(290423,8068,'ro','Comanda completa',0),(290424,8068,'et','Tellimus on lÃµplik',0),(290425,8068,'si','Da je popoln',0),(290426,8068,'ba','Urutan lengkap',0),(290427,8068,'nl','Bestelling Is voltooid',0),(290428,8068,'fi','Tilaus on valmis',0),(290429,8068,'no','Bestillingen er fullfÃ¸rt',0),(290430,8068,'da','Ordren er fuldfÃ¸rt',0),(290431,8068,'ko','ì£¼ë¬¸ì´ ì™„ë£Œ ë˜ ë©´',0),(290432,8068,'he','×¡×“×¨ ×”×•×©×œ×',0),(290433,8068,'el','Î£ÎµÎ¹ÏÎ¬ Î­Ï‡ÎµÎ¹ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(290434,8068,'zh','è®¢å•å·²å®Œæˆ\r\n',0),(290435,8068,'sv','BestÃ¤llningen Ã¤r klar',0),(290436,8068,'it','Ordine Ã¨ completo',0),(290437,8068,'tl','',0),(290438,8068,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(290439,8068,'hi','à¤‘à¤°à¥à¤¡à¤° à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(290440,8068,'ms','Perintah itu selesai',0),(290441,8068,'ar','Ø§ÙƒØªÙ…Ø§Ù„ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(290442,8068,'fr','Commande est terminÃ©e',0),(290443,8068,'jp','æ³¨æ–‡ãŒå®Œäº†',0),(290444,8068,'pt','A ordem Ã© completa',0),(290445,8068,'ru','Ð—Ð°ÐºÐ°Ð·',0),(290446,8068,'es','Orden es Completo',0),(290447,8068,'de','Bestellung ist abgeschlossen',0),(290448,8068,'en','Order Is Complete',0),(290449,8069,'is','',0),(290450,8069,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø­Ù…Ù„ Ù†Ù‡Ø§ÙŠÙŠ Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø´Ø¯ ',0),(290451,8069,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø­Ù…Ù„ Ù†Ù‡Ø§ÙŠÙŠ Ø¹Ù„Ø§Ù…Øª Ø²Ø¯Ù‡ Ø´Ø¯ ',0),(290452,8069,'tr','SipariÅŸ son gemisi olarak iÅŸaretlenmiÅŸ',0),(290453,8069,'pl','ZamÃ³wienie oznaczony jako koÅ„cowy statku',0),(290454,8069,'bg','Ð ÐµÐ´, Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½ ÐºÐ°Ñ‚Ð¾ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÐµÐ½ ÐºÐ¾Ñ€Ð°Ð±',0),(290455,8069,'ur','Ø­Ú©Ù… Ø­ØªÙ…ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†Ø´Ø§Ù† Ù„Ú¯Ø§ Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(290456,8069,'sr','Ð ÐµÐ´ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½ ÐºÐ°Ð¾ ÐºÐ¾Ð½Ð°Ñ‡Ð½Ð¸ Ð±Ñ€Ð¾Ð´',0),(290457,8069,'vi','ÄÆ¡n hÃ ng chuyá»ƒn láº§n cuá»‘i',0),(290458,8069,'af','Bestelling Gemerk As Finale Versend',0),(290459,8069,'ro','Ordinul marcatÄƒ ca finalÄƒ navei',0),(290460,8069,'et','MÃ¤rgitud lÃµpliku saaja tellimuse',0),(290461,8069,'si','Reda, oznaÄena kot konÄna ladje',0),(290462,8069,'ba','Urutan yang ditandai sebagai akhir kapal',0),(290463,8069,'nl','Volgorde gemarkeerd als laatste schip',0),(290464,8069,'fi','JÃ¤rjestys merkitty viimeinen laiva',0),(290465,8069,'no','Ordre som er merket som endelige skipet',0),(290466,8069,'da','Orden er markeret som Final skib',0),(290467,8069,'ko','ë‹µë³€ìœ¼ë¡œ í‘œì‹œ ë¨ ìµœì¢… ë°° ìˆœì„œ',0),(290468,8069,'he','×¡×“×¨ ×ž×¡×•×ž×Ÿ ×”×¡×¤×™× ×” ×”××—×¨×•× ×”',0),(290469,8069,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± ÎµÏ€Î¹ÏƒÎ·Î¼Î±Î½Î¸ÎµÎ¯ Ï‰Ï‚ Ï„ÎµÎ»Î¹ÎºÎ® Ï€Î»Î¿Î¯Î¿',0),(290470,8069,'zh','è®¢å•å·²æ ‡è®°ä¸ºæœ€ç»ˆè¿é€\r\n',0),(290471,8069,'sv','Ordning som markerats som sista fartyg',0),(290472,8069,'it','Ordine contrassegnato come nave finale',0),(290473,8069,'tl','',0),(290474,8069,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3607;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3592;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(290475,8069,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤…à¤‚à¤¤à¤¿à¤® à¤œà¤¹à¤¾à¤œ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤',0),(290476,8069,'ms','Perintah yang ditandakan sebagai akhir kapal',0),(290477,8069,'ar','Ø§Ù„Ø£Ù…Ø± ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© ÙƒÙ†Ù‡Ø§Ø¦ÙŠ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(290478,8069,'fr','Ordre marquÃ© comme navire Final',0),(290479,8069,'jp','æ³¨æ–‡ã®æœ€çµ‚å‡ºè·ã¨ã—ã¦ãƒžãƒ¼ã‚¯',0),(290480,8069,'pt','Ordem marcada como navio-Final',0),(290481,8069,'ru','Ð—Ð°ÐºÐ°Ð· Ð¿Ð¾Ð¼ÐµÑ‡ÐµÐ½ ÐºÐ°Ðº Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(290482,8069,'es','Orden Marcado Como EnvÃ­o Final',0),(290483,8069,'de','Bestellung als letzte Schiff gekennzeichnet',0),(290484,8069,'en','Order Marked As Final Ship',0),(290485,8070,'is','',0),(290486,8070,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø³ÙØ§Ø±Ø´',0),(290487,8070,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø³ÙØ§Ø±Ø´',0),(290488,8070,'tr','Ä°ade sipariÅŸi iÃ§in',0),(290489,8070,'pl','PowrÃ³t do zamÃ³wienia',0),(290490,8070,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(290491,8070,'ur','Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÙˆØ§Ù¾Ø³',0),(290492,8070,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ñƒ Ñ€ÐµÐ´',0),(290493,8070,'vi','Quay láº¡i Ä‘Æ¡n hÃ ng',0),(290494,8070,'af','Terug Na Bestelling',0),(290495,8070,'ro','ReveniÅ£i la comanda',0),(290496,8070,'et','Selleks naaske',0),(290497,8070,'si','Vrnitev po naroÄilu',0),(290498,8070,'ba','Kembali ke urutan',0),(290499,8070,'nl','Return To Order',0),(290500,8070,'fi','Palauta jÃ¤rjestys',0),(290501,8070,'no','GÃ¥ tilbake til ordre',0),(290502,8070,'da','Vende tilbage til ordre',0),(290503,8070,'ko','ì£¼ë¬¸ ë°˜í™˜',0),(290504,8070,'he','×œ×”×—×–×™×¨ ×œ×¡×“×¨',0),(290505,8070,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î·',0),(290506,8070,'zh','è¿”å›žåˆ°è®¢å•\r\n',0),(290507,8070,'sv','Ã…tergÃ¥ till ordningen',0),(290508,8070,'it','Ritorno all\'ordine',0),(290509,8070,'tl','',0),(290510,8070,'th','&#3585;&#3621;&#3633;&#3610;&#3626;&#3641;&#3656;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(290511,8070,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥Œà¤Ÿà¥‡à¤‚',0),(290512,8070,'ms','Kembali kepada perintah',0),(290513,8070,'ar','Ø§Ù„Ø±Ø¬ÙˆØ¹ Ø¥Ù„Ù‰ Ø§Ù„Ø·Ù„Ø¨ÙŠÙ‘Ø©',0),(290514,8070,'fr','Retour Ã  l\'ordre',0),(290515,8070,'jp','é †åºã«æˆ»ã™',0),(290516,8070,'pt','Retorno Ã  ordem',0),(290517,8070,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðš Ð—Ð°ÐºÐ°Ð·Ñƒ',0),(290518,8070,'es','Regresar Al Orden',0),(290519,8070,'de','ZurÃ¼ck zur Bestellung',0),(290520,8070,'en','Return To Order',0),(290521,8071,'is','',0),(290522,8071,'dr','- Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ ',0),(290523,8071,'pr','Ø­Ø°Ù Ø­Ù…Ù„  Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±  - Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ ',0),(290524,8071,'tr','AÃ§Ä±lan gemi iÃ§in mÃ¼ÅŸteri sevk yeri adresi',0),(290525,8071,'pl','Spadek statku do klienta adres dostawy',0),(290526,8071,'bg','ÐšÐ°Ð¿ÐºÐ° ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð°Ð´Ñ€ÐµÑ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(290527,8071,'ur','Ø¬ÛØ§Ø² Ù¾ØªÛ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Ùˆ Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù„ÛŒÛ’ Ú†Ú¾ÙˆÚ‘ÛŒÚº',0),(290528,8071,'sr','Ð¡Ð¿ÑƒÑÑ‚Ð¸ Ð±Ñ€Ð¾Ð´ Ð´Ð° ÐºÑƒÐ¿Ð°Ñ† Ð°Ð´Ñ€ÐµÑÐ° Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(290529,8071,'vi','Bá» Ä‘á»‹a chá»‰ chuyá»ƒn Ä‘áº¿n cá»§a khÃ¡ch hÃ ng',0),(290530,8071,'af','Drop skip aan kliÃ«nt skip-adres',0),(290531,8071,'ro','PicÄƒturÄƒ de navÄƒ la livrare-la adresa clientului',0),(290532,8071,'et','Drop laev kliendi saaja aadressi',0),(290533,8071,'si','Padec ladja ladje za naslov stranke',0),(290534,8071,'ba','Drop kapal untuk pelanggan kapal-untuk alamat',0),(290535,8071,'nl','Neerzetten van schip naar schip-To klantadres',0),(290536,8071,'fi','Pudota aluksen asiakkaan Toimitusasiakkaan osoite',0),(290537,8071,'no','Slipp skipet til kundens lever til-adresse',0),(290538,8071,'da','Drop skib til kundens leveringsadresse',0),(290539,8071,'ko','ë“œë¡­ ë°°ì†¡ ê³ ê° ë°°ì†¡ ì£¼ì†Œ',0),(290540,8071,'he','×”×¡×¤×™× ×” ×˜×™×¤×” ×œ×›×ª×•×‘×ª ×”×œ×§×•×— ×œ×ž×©×œ×•×—',0),(290541,8071,'el','Î‘ÎœÎ•Î£ Î‘Î ÎŸÎ£Î¤ Ï€ÎµÎ»Î¬Ï„Î· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(290542,8071,'zh','ç›´æŽ¥ä»˜è¿åˆ°å®¢æˆ·æ”¶è´§åœ°å€\r\n',0),(290543,8071,'sv','SlÃ¤ppa fartyget till kundens leveransadress',0),(290544,8071,'it','Drop Ship per indirizzo cliente',0),(290545,8071,'tl','',0),(290546,8071,'th','&#3621;&#3604;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3606;&#3638;&#3591;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(290547,8071,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¤¿à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¥à¤°à¥‰à¤ª à¤œà¤¹à¤¾à¤œ',0),(290548,8071,'ms','Kapal drop alamat kapal-untuk pelanggan',0),(290549,8071,'ar','Ù‡Ø¨ÙˆØ· Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø£Ù† Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(290550,8071,'fr','Livraison directe Ã  l\'adresse de livraison client',0),(290551,8071,'jp','ãƒ‰ãƒ­ãƒƒãƒ—èˆ¹èˆ¹ã«é¡§å®¢ã®ä½æ‰€ã‚’',0),(290552,8071,'pt','Navio da gota para envio-a endereÃ§o do cliente',0),(290553,8071,'ru','ÐŸÐ°Ð´ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ Ð°Ð´Ñ€ÐµÑÐ° Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(290554,8071,'es','Enviar Directamente al DirecciÃ³n de EnvÃ­o de Cliente',0),(290555,8071,'de','Drop Schiff lief Kundenadresse',0),(290556,8071,'en','Drop Ship to Customer Ship-To Address',0),(290557,8072,'is','',0),(290558,8072,'dr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ ',0),(290559,8072,'pr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ ',0),(290560,8072,'tr','SatÄ±ÅŸ sipariÅŸi iÃ§in',0),(290561,8072,'pl','Dla zamÃ³wienia sprzedaÅ¼y',0),(290562,8072,'bg','Ð—Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(290563,8072,'ur','Ø³ÛŒÙ„Ø² Ø¢Ø±ÚˆØ± Ú©Û’ Ù„ÛŒÛ’',0),(290564,8072,'sr','Ð—Ð° ÑƒÐ»Ð°Ð·Ð½Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(290565,8072,'vi','Cho Ä‘Æ¡n hÃ ng kinh doanh',0),(290566,8072,'af','Vir verkope bestelling',0),(290567,8072,'ro','Pentru comanda de vÃ¢nzare',0),(290568,8072,'et','MÃ¼Ã¼gitellimuse',0),(290569,8072,'si','Za prodajni nalog',0),(290570,8072,'ba','Untuk Order penjualan',0),(290571,8072,'nl','Voor verkooporder',0),(290572,8072,'fi','Myyntitilauksen',0),(290573,8072,'no','For salgsordre',0),(290574,8072,'da','For salgsordre',0),(290575,8072,'ko','íŒë§¤ ì£¼ë¬¸ì— ëŒ€ í•œ',0),(290576,8072,'he','×”×–×ž× ×•×ª ×ž×›×™×¨×”',0),(290577,8072,'el','Î“Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(290578,8072,'zh','é”€å”®è®¢å•\r\n',0),(290579,8072,'sv','FÃ¶r fÃ¶rsÃ¤ljningsorder',0),(290580,8072,'it','Per ordine di vendita',0),(290581,8072,'tl','',0),(290582,8072,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3586;&#3634;&#3618;',0),(290583,8072,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤',0),(290584,8072,'ms','Bagi pesanan jualan',0),(290585,8072,'ar','Ù„Ø£Ù…Ø± Ø§Ù„ØªÙˆØ±ÙŠØ¯',0),(290586,8072,'fr','Pour la commande client',0),(290587,8072,'jp','è²©å£²æ³¨æ–‡',0),(290588,8072,'pt','De ordem de vendas',0),(290589,8072,'ru','Ð”Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ñƒ',0),(290590,8072,'es','Para Ordenes de Venta',0),(290591,8072,'de','FÃ¼r Bestellung',0),(290592,8072,'en','For Sales Order',0),(290593,8073,'is','',0),(290594,8073,'dr','Ø§Ú¯Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ â€“ Ø¨Ø§ÙŠØ¯ Ø­Ù…Ù„ Ø­Ø°Ù Ø´ÙˆØ¯ ',0),(290595,8073,'pr','Ø§Ú¯Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ â€“ Ø¨Ø§ÙŠØ¯ Ø­Ù…Ù„ Ø­Ø°Ù Ø´ÙˆØ¯ ',0),(290596,8073,'tr','EÄŸer satÄ±ÅŸ sipariÅŸi iÃ§in sevk dÃ¼ÅŸÃ¼rmelisin',0),(290597,8073,'pl','JeÅ›li dla zamÃ³wienia sprzedaÅ¼y, naleÅ¼y spadek statku',0),(290598,8073,'bg','ÐÐºÐ¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°, Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿ÑƒÑÐºÐ°Ñ‚Ðµ ÐºÐ¾Ñ€Ð°Ð±',0),(290599,8073,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ø³ÛŒÙ„Ø² Ø¢Ø±ÚˆØ± Ø§Ú¯Ø±ØŒ ÚˆØ±Ø§Ù¾ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØ¦Û’',0),(290600,8073,'sr','ÐÐºÐ¾ Ñ˜Ðµ Ð·Ð° ÑƒÐ»Ð°Ð·Ð½Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ, Ñ‚Ñ€ÐµÐ±Ð° ÑÐ¿ÑƒÑÑ‚Ð¸Ñ‚Ð¸ Ð±Ñ€Ð¾Ð´',0),(290601,8073,'vi','Náº¿u ÄÆ¡n HÃ ng Kinh Doanh Pháº£i Bá» Váº­n Chuyá»ƒn',0),(290602,8073,'af','Indien Vir Verkoopsbestelling, Moet die Sending Afgelewer Word',0),(290603,8073,'ro','DacÄƒ pentru comandÄƒ de vÃ¢nzare, ar trebui sÄƒ picÄƒturÄƒ navÄƒ',0),(290604,8073,'et','Kui mÃ¼Ã¼gitellimuse kohta peaksid kukutage laeva',0),(290605,8073,'si','ÄŒe za prodajni nalog, naj spusti ladje',0),(290606,8073,'ba','Jika untuk Order penjualan, harus Drop kapal',0),(290607,8073,'nl','Als voor de verkooporder, moet neerzetten schip',0),(290608,8073,'fi','Jos myyntitilaukselle, pitÃ¤isi pudota aluksen',0),(290609,8073,'no','Hvis For ordre skal slippe skipet',0),(290610,8073,'da','Hvis For salgsordren, burde Drop skib',0),(290611,8073,'ko','íŒë§¤ ì£¼ë¬¸ì— ëŒ€ í•œ ê²½ìš° ì„ ë°•ì„ ë“œë¡­ í•œë‹¤',0),(290612,8073,'he','×× ×¢×‘×•×¨ ×”×–×ž× ×ª ×”×ž×›×™×¨×”, ×¦×¨×™×š ×œ×”×‘×™× ××ª ×”×¡×¤×™× ×”',0),(290613,8073,'el','Î‘Î½ Î³Î¹Î± Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚, Î¸Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¼ÎµÎ¹Ï‰Î¸ÎµÎ¯ Ï„Î¿ Ï€Î»Î¿Î¯Î¿',0),(290614,8073,'zh','å¦‚æžœé”€å”®è®¢å•ï¼Œåº”è¯¥æ”¾å¼ƒè¿é€\r\n',0),(290615,8073,'sv','Om fÃ¶r fÃ¶rsÃ¤ljningsorder ska slÃ¤ppa fartyget',0),(290616,8073,'it','Se per ordine di vendita, dovrebbe cadere la nave',0),(290617,8073,'tl','',0),(290618,8073,'th','&#3627;&#3634;&#3585;&#3617;&#3637;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3586;&#3634;&#3618;, &#3588;&#3623;&#3619;&#3627;&#3618;&#3640;&#3604;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(290619,8073,'hi','à¤¯à¤¦à¤¿ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(290620,8073,'ms','Jika bagi pesanan jualan, harus menggugurkan kapal',0),(290621,8073,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø£Ù…Ø± Ø§Ù„ØªÙˆØ±ÙŠØ¯ØŒ ÙŠØ¬Ø¨ Ø¥Ø³Ù‚Ø§Ø· Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(290622,8073,'fr','Si, pour une commande vente, bateau de baisse devrait',0),(290623,8073,'jp','è²©å£²æ³¨æ–‡ã®å ´åˆã¯èˆ¹ã‚’ãƒ‰ãƒ­ãƒƒãƒ—ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(290624,8073,'pt','Se de ordem de vendas, deve navio da gota',0),(290625,8073,'ru','Ð•ÑÐ»Ð¸ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ñƒ, ÑÐ»ÐµÐ´ÑƒÐµÑ‚ Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(290626,8073,'es','Si para Orden de Venta, Debe Enviar Directamente',0),(290627,8073,'de','Wenn fÃ¼r Auftrag, sollte das Schiff fallen gelassen',0),(290628,8073,'en','If For Sales Order, Should&nbsp;Drop Ship',0),(290629,8074,'is','',0),(290630,8074,'dr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ Ù†ÙŠØ³Øª ',0),(290631,8074,'pr','Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ Ù†ÙŠØ³Øª ',0),(290632,8074,'tr','SatÄ±ÅŸ sipariÅŸi iÃ§in deÄŸil',0),(290633,8074,'pl','Nie dla zamÃ³wienia sprzedaÅ¼y',0),(290634,8074,'bg','ÐÐµ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(290635,8074,'ur','ÙØ±ÙˆØ®Øª ØªØ±ØªÛŒØ¨ Ø³Û’ Ù†ÛÛŒÚº',0),(290636,8074,'sr','ÐÐµ Ð·Ð° ÑƒÐ»Ð°Ð·Ð½Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(290637,8074,'vi','KhÃ´ng dÃ nh cho Ä‘Æ¡n hÃ ng kinh doanh',0),(290638,8074,'af','Nie Vir Verkoopsbestelling',0),(290639,8074,'ro','Nu pentru comandÄƒ de vÃ¢nzÄƒri',0),(290640,8074,'et','MÃ¼Ã¼gitellimuse eest',0),(290641,8074,'si','Ne za prodajni nalog',0),(290642,8074,'ba','Bukan untuk Order penjualan',0),(290643,8074,'nl','Niet voor verkooporder',0),(290644,8074,'fi','Ole myyntitilaukselle',0),(290645,8074,'no','Ikke For salgsordre',0),(290646,8074,'da','Ikke For salgsordre',0),(290647,8074,'ko','íŒë§¤ ì£¼ë¬¸ì— ëŒ€ í•œ ì•ˆ',0),(290648,8074,'he','×œ× ×¢×‘×•×¨ ×”×–×ž× ×ª ×”×ž×›×™×¨×”',0),(290649,8074,'el','ÎŒÏ‡Î¹ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(290650,8074,'zh','ä¸ç”¨äºŽé”€å”®è®¢å•\r\n',0),(290651,8074,'sv','Inte fÃ¶r fÃ¶rsÃ¤ljningsorder',0),(290652,8074,'it','Non per ordine di vendita',0),(290653,8074,'tl','',0),(290654,8074,'th','&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;&#3586;&#3634;&#3618;',0),(290655,8074,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤‘à¤°à¥à¤¡à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¹à¥€à¤‚',0),(290656,8074,'ms','Bukan untuk pesanan jualan',0),(290657,8074,'ar','Ù„ÙŠØ³ Ù„Ø£Ù…Ø± Ø§Ù„ØªÙˆØ±ÙŠØ¯',0),(290658,8074,'fr','Pas de commande',0),(290659,8074,'jp','è²©å£²æ³¨æ–‡ã®ãªã„ã§ã™ã€‚',0),(290660,8074,'pt','NÃ£o por ordem de venda',0),(290661,8074,'ru','ÐÐµ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ñƒ',0),(290662,8074,'es','No es Para Ordenes de Ventas',0),(290663,8074,'de','Nicht fÃ¼r Kundenauftrag',0),(290664,8074,'en','Not For Sales Order',0),(290665,8075,'is','',0),(290666,8075,'dr','Ø¨Ù„Ù‡ â€“ Ø­Ø°Ù Ø­Ù…Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±  Ø­Ù…Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ ',0),(290667,8075,'pr','Ø¨Ù„Ù‡ â€“ Ø­Ø°Ù Ø­Ù…Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø±  Ø­Ù…Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ ',0),(290668,8075,'tr','Evet, mÃ¼ÅŸterinin sevk yeri adresinin gemiye damla',0),(290669,8075,'pl','Tak, spadek statku do klienta adres dostawy',0),(290670,8075,'bg','Ð”Ð°, ÐºÐ°Ð¿ÐºÐ° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð°Ð´Ñ€ÐµÑ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(290671,8075,'ur','Ø¬ÛŒ ÛØ§ÚºØŒ Ø¬ÛØ§Ø² Ù¾ØªÛ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Ùˆ Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù„ÛŒÛ’ Ú†Ú¾ÙˆÚ‘ÛŒÚº',0),(290672,8075,'sr','Ð”Ð° , Ð±Ð°Ñ†Ð¸ Ð±Ñ€Ð¾Ð´ Ð´Ð° ÐºÑƒÐ¿Ð°Ñ† Ð°Ð´Ñ€ÐµÑÐ° Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(290673,8075,'vi','Äá»“ng Ã½, bá» hÃ ng á»Ÿ Ä‘á»‹a chá»‰ cá»§a khÃ¡ch hÃ ng',0),(290674,8075,'af','Ja, AFLEWERING aan VERSENDSKLIÃªNT/KLANT na VERSENDINGSADRES',0),(290675,8075,'ro','Da, picÄƒturÄƒ navÄƒ client livrare-la adresa',0),(290676,8075,'et','Jah, tarnida kliendi mÃ¤Ã¤ratud aadressile',0),(290677,8075,'si','Ja, spusti ladjo ladja za naslov stranke',0),(290678,8075,'ba','Ya, Drop kapal untuk pelanggan kapal-untuk alamat',0),(290679,8075,'nl','Ja, het neerzetten van schip naar schip-To klantadres',0),(290680,8075,'fi','KyllÃ¤, pudota aluksen asiakkaan Toimitusasiakkaan osoite',0),(290681,8075,'no','Ja, slippe skipet til kundens lever til-adresse',0),(290682,8075,'da','Ja, Drop skib til kundens leveringsadresse',0),(290683,8075,'ko','ë„¤, ë“œë¡­ ë°°ì†¡ ê³ ê° ë°°ì†¡ ì£¼ì†Œ',0),(290684,8075,'he','. ×›×Ÿ, ×©×—×¨×¨ ××ª ×”×¡×¤×™× ×” ×œ×›×ª×•×‘×ª ×”×œ×§×•×— ×œ×ž×©×œ×•×—',0),(290685,8075,'el','ÎÎ±Î¹, Ï€Ï„ÏŽÏƒÎ· Ï€Î»Î¿Î¯Î¿Ï… ÏƒÎµ Ï€ÎµÎ»Î¬Ï„Î· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ Î”Î¹ÎµÏÎ¸.',0),(290686,8075,'zh','æ˜¯çš„ï¼Œç›´æŽ¥ä»˜è¿åˆ°å®¢æˆ·æ”¶è´§åœ°å€\r\n',0),(290687,8075,'sv','Ja, slÃ¤ppa fartyget att kunden leveransadress',0),(290688,8075,'it','SÃ¬, goccia nave all\'indirizzo cliente',0),(290689,8075,'tl','',0),(290690,8075,'th','&#3651;&#3594;&#3656;, &#3627;&#3618;&#3640;&#3604;&#3586;&#3609;&#3626;&#3656;&#3591;&#3606;&#3638;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(290691,8075,'hi','à¤¹à¤¾à¤, à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤›à¥‹à¤¡à¤¼',0),(290692,8075,'ms','Ya, jatuh kapal alamat kapal-untuk pelanggan',0),(290693,8075,'ar','Ù†Ø¹Ù…ØŒ Ø¥Ø³Ù‚Ø§Ø· Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø£Ù† Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(290694,8075,'fr','Oui, bateau de client-adresse d\'expÃ©dition de baisse',0),(290695,8075,'jp','ã¯ã„ã€ãƒ‰ãƒ­ãƒƒãƒ—èˆ¹èˆ¹ã«é¡§å®¢ã®ä½æ‰€ã‚’',0),(290696,8075,'pt','Sim, deixar o navio para envio-a endereÃ§o do cliente',0),(290697,8075,'ru','Ð”Ð°, Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ Ð°Ð´Ñ€ÐµÑÐ° Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(290698,8075,'es','Si, Retirar por Cliente Enviar a DirecciÃ³n',0),(290699,8075,'de','Ja, Drop Schiff lief Kundenadresse',0),(290700,8075,'en','Yes, Drop Ship To Customer Ship-To Address',0),(290701,8076,'is','',0),(290702,8076,'dr','ÙƒÙ¾ÙŠ Ø¯Ø± Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(290703,8076,'pr','ÙƒÙ¾ÙŠ Ø¯Ø± Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(290704,8076,'tr','SeÃ§ilen yÄ±l iÃ§in kopyalama',0),(290705,8076,'pl','Skopiuj wybrany rok',0),(290706,8076,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(290707,8076,'ur','Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†ØªØ®Ø¨ Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(290708,8076,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ˜ Ñƒ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(290709,8076,'vi','Sao chÃ©p vÃ o nÄƒm Ä‘Ã£ chá»n',0),(290710,8076,'af','KopieÃ«r Na Jaar Geselekteer',0),(290711,8076,'ro','Copie a an selectate',0),(290712,8076,'et','Kopeeri valitud aasta',0),(290713,8076,'si','Kopirati izbrano leto',0),(290714,8076,'ba','Salin ke tahun yang dipilih',0),(290715,8076,'nl','Kopieer naar jaar geselecteerd',0),(290716,8076,'fi','Kopioi valitun vuoden',0),(290717,8076,'no','Kopiere til Ã¥r valgt',0),(290718,8076,'da','Kopier til Ã¥r valgt',0),(290719,8076,'ko','ì„ íƒ í•´ ë³µì‚¬',0),(290720,8076,'he','×”×¢×ª×§ ××œ ×”×©× ×” × ×‘×—×¨',0),(290721,8076,'el','Î‘Î½Ï„Î¹Î³ÏÎ¬ÏˆÏ„Îµ ÏƒÏ„Î¿ Î­Ï„Î¿Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î¾Î±Ï„Îµ',0),(290722,8076,'zh','å¤åˆ¶åˆ°å¹´åº¦é€‰å®š\r\n',0),(290723,8076,'sv','Kopiera till Ã¥r valt',0),(290724,8076,'it','Copiare anno selezionato',0),(290725,8076,'tl','',0),(290726,8076,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3652;&#3611;&#3618;&#3633;&#3591;&#3611;&#3637;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3623;&#3657;',0),(290727,8076,'hi','à¤µà¤°à¥à¤· à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(290728,8076,'ms','Salin ke tahun yang dipilih',0),(290729,8076,'ar','Ù†Ø³Ø® Ù„Ø³Ù†ÙˆØ§Øª Ù…Ø®ØªØ§Ø±Ø©',0),(290730,8076,'fr','Copier vers l\'annÃ©e sÃ©lectionnÃ©e',0),(290731,8076,'jp','é¸æŠžã—ãŸå¹´ã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(290732,8076,'pt','Copiar para o ano selecionado',0),(290733,8076,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð’ Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ð¹ Ð“Ð¾Ð´',0),(290734,8076,'es','Copiar al AÃ±o Seleccionado',0),(290735,8076,'de','Kopieren Sie in Jahr ausgewÃ¤hlt',0),(290736,8076,'en','Copy To Year Selected',0),(290737,8077,'is','',0),(290738,8077,'dr','Ø§Ø² Ø³Ø§Ù„ ',0),(290739,8077,'pr','Ø§Ø² Ø³Ø§Ù„ ',0),(290740,8077,'tr','YÄ±l',0),(290741,8077,'pl','Od roku',0),(290742,8077,'bg','ÐžÑ‚ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(290743,8077,'ur','Ø³Ø§Ù„ Ø³Û’',0),(290744,8077,'sr','ÐžÐ´ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(290745,8077,'vi','Tá»« nÄƒm',0),(290746,8077,'af','Vanaf Jaar',0),(290747,8077,'ro','Din anul',0),(290748,8077,'et','Aastast',0),(290749,8077,'si','Od leta',0),(290750,8077,'ba','Dari tahun',0),(290751,8077,'nl','Van jaar',0),(290752,8077,'fi','Vuodesta',0),(290753,8077,'no','Fra Ã¥r',0),(290754,8077,'da','Fra Ã¥r',0),(290755,8077,'ko','ë…„ì—ì„œ',0),(290756,8077,'he','×ž×”×©× ×”',0),(290757,8077,'el','Î‘Ï€ÏŒ Ï„Î¿ Î­Ï„Î¿Ï‚',0),(290758,8077,'zh','ä»Žå¹´åº¦\r\n',0),(290759,8077,'sv','FrÃ¥n Ã¥r',0),(290760,8077,'it','Dall\'anno',0),(290761,8077,'tl','',0),(290762,8077,'th','&#3592;&#3634;&#3585;&#3611;&#3637;',0),(290763,8077,'hi','à¤µà¤°à¥à¤· à¤¸à¥‡',0),(290764,8077,'ms','Dari tahun',0),(290765,8077,'ar','Ù…Ù† Ø§Ù„Ø³Ù†Ø©',0),(290766,8077,'fr','De l\'annÃ©e',0),(290767,8077,'jp','å¹´ã‹ã‚‰',0),(290768,8077,'pt','Do ano',0),(290769,8077,'ru','ÐžÑ‚ Ð³Ð¾Ð´Ð°',0),(290770,8077,'es','Del AÃ±o',0),(290771,8077,'de','Ab dem Jahr',0),(290772,8077,'en','From Year',0),(290773,8078,'is','',0),(290774,8078,'dr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ â€“ ÙˆÙŠØ±Ø§ÙŠØ´ â€“ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(290775,8078,'pr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ â€“ ÙˆÙŠØ±Ø§ÙŠØ´ â€“ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª ',0),(290776,8078,'tr','Vergi tÃ¼rÃ¼ zaten var, vergi tÃ¼rÃ¼ Update kullanarak dÃ¼zenleme',0),(290777,8078,'pl','Typ podatku juÅ¼ istnieje, edytowaÄ‡ za pomocÄ… aktualizacji typu podatku',0),(290778,8078,'bg','Ð’ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ñ‚Ð¸Ð¿ Ð´Ð°Ð½ÑŠÐº, Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰Ñ‚Ð° Ð½Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ñ‚Ð¸Ð¿ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(290779,8078,'ur','Ù¹ÛŒÚ©Ø³ Ù‚Ø³Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ØŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(290780,8078,'sr','Ð’Ñ€ÑÑ‚Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸, ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾Ð¼Ð¾Ñ›Ñƒ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð²Ñ€ÑÑ‚Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(290781,8078,'vi','Loáº¡i Thuáº¿ ÄÃ£ Tá»“n Táº¡i, DÃ¹ng Cáº­p Nháº­t Loáº¡i Thuáº¿ Äá»ƒ Sá»­a',0),(290782,8078,'af','Belasting Tipe Bestaan Alreeds, Redigeer Gebruik Belasting TIpe Opdateer',0),(290783,8078,'ro','Tipul de impozit existÄƒ deja, edita folosind Update de tip fiscal',0),(290784,8078,'et','Maksu tÃ¼Ã¼p juba olemas, Redigeeri abil maksu tÃ¼Ã¼p vÃ¤rskendamine',0),(290785,8078,'si','Vrsta davka Å¾e obstaja, izdajati Using modernizirati vrsta davka',0),(290786,8078,'ba','Jenis pajak yang sudah ada, mengedit menggunakan pajak jenis Update',0),(290787,8078,'nl','Fiscale Type al bestaat, bewerken met behulp van fiscale Type Update',0),(290788,8078,'fi','ALV-tyyppi on jo olemassa, Muokkaa vero-tyypin pÃ¤ivitys',0),(290789,8078,'no','Skatt Type finnes allerede, redigere bruker skatt Type oppdatering',0),(290790,8078,'da','Skat Type findes allerede, skal du redigere ved hjÃ¦lp af skat Type opdatering',0),(290791,8078,'ko','ì´ë¯¸ ì¡´ìž¬ í•˜ëŠ” ì„¸ê¸ˆ ì¢…ë¥˜, ì„¸ê¸ˆ ì¢…ë¥˜ ì—…ë°ì´íŠ¸ë¥¼ ì‚¬ìš© í•˜ ì—¬ íŽ¸ì§‘',0),(290792,8078,'he','×¡×•×’ ×”×ž×¡ ×›×‘×¨ ×§×™×™×, ×œ×¢×¨×•×š ×‘××ž×¦×¢×•×ª ×¢×“×›×•×Ÿ ×¡×•×’ ×ž×¡',0),(290793,8078,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¿ Ï„ÏÏ€Î¿Ï‚ Î¦Î Î‘, ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Ï…',0),(290794,8078,'zh','ç¨ŽåŠ¡ç±»åž‹å·²ç»å­˜åœ¨ï¼Œç¼–è¾‘ä½¿ç”¨ç¨Žç±»åž‹æ›´æ–°\r\n',0),(290795,8078,'sv','Skatt typ finns redan, redigera med hjÃ¤lp av skatt typ Update',0),(290796,8078,'it','Tipo fiscale giÃ  esistente, modificare utilizzando gli aggiornamenti di tipo fiscale',0),(290797,8078,'tl','',0),(290798,8078,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;, &#3649;&#3585;&#3657;&#3652;&#3586;&#3650;&#3604;&#3618;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&',0),(290799,8078,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¤¹à¤²à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ, à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(290800,8078,'ms','Jenis cukai yang telah sedia wujud, Edit menggunakan Kemaskini jenis cukai',0),(290801,8078,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ù…ÙˆØ¬ÙˆØ¯Ø© Ø¨Ø§Ù„ÙØ¹Ù„ØŒ ÙˆØªØ­Ø±ÙŠØ± Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(290802,8078,'fr','Type de taxe existe dÃ©jÃ , modifier Ã  l\'aide de la mise Ã  jour du Type de taxe',0),(290803,8078,'jp','ç¨Žã®ç¨®é¡žãŒæ—¢ã«å­˜åœ¨ã™ã‚‹ã€ç¨Žã‚¿ã‚¤ãƒ—ã®ã‚¢ãƒƒãƒ—ãƒ‡ãƒ¼ãƒˆã‚’ä½¿ç”¨ã—ã¦ç·¨é›†',0),(290804,8078,'pt','Tipo de imposto jÃ¡ existe, editar usando o Update do tipo de imposto',0),(290805,8078,'ru','Ð¢Ð¸Ð¿ ÐÐ°Ð»Ð¾Ð³Ð° Ð£Ð¶Ðµ Ð˜Ð¼ÐµÐµÑ‚ÑÑ, Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¢Ð¸Ð¿Ð° ÐÐ°Ð»Ð¾Ð³Ð°',0),(290806,8078,'es','Tipo de Impuesto Ya Existe, Editar Usando ActualizaciÃ³n de Tipo de Impuesto',0),(290807,8078,'de','Steuerart bereits vorhanden ist, bearbeiten Sie mit Steuer Typ Update',0),(290808,8078,'en','Tax Type Already Exists, Edit Using Tax Type Update',0),(290809,8079,'is','',0),(290810,8079,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ù„Ø§Ù†Ù‡ ',0),(290811,8079,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ù„Ø§Ù†Ù‡ ',0),(290812,8079,'tr','Vergi yÄ±lÄ±',0),(290813,8079,'pl','Rok podatkowy',0),(290814,8079,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(290815,8079,'ur','Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø§Ø³ Ø³Ø§Ù„',0),(290816,8079,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(290817,8079,'vi','NÄƒm thuáº¿',0),(290818,8079,'af','Belastingjaar',0),(290819,8079,'ro','Anul fiscal',0),(290820,8079,'et','Maksuaasta',0),(290821,8079,'si','DavÄno leto',0),(290822,8079,'ba','Tahun pajak',0),(290823,8079,'nl','Fiscale jaar',0),(290824,8079,'fi','Verovuoden',0),(290825,8079,'no','InntektsÃ¥ret',0),(290826,8079,'da','SkatteÃ¥r',0),(290827,8079,'ko','ê³¼ì„¸ ì—°ë„',0),(290828,8079,'he','×©× ×ª ×ž×¡',0),(290829,8079,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŒ Î­Ï„Î¿Ï‚',0),(290830,8079,'zh','çº³ç¨Žå¹´åº¦\r\n',0),(290831,8079,'sv','BeskattningsÃ¥ret',0),(290832,8079,'it','Anno fiscale',0),(290833,8079,'tl','',0),(290834,8079,'th','&#3611;&#3637;&#3616;&#3634;&#3625;&#3637;',0),(290835,8079,'hi','à¤•à¤° à¤µà¤°à¥à¤·',0),(290836,8079,'ms','Cukai tahun',0),(290837,8079,'ar','Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©',0),(290838,8079,'fr','AnnÃ©e d\'imposition',0),(290839,8079,'jp','èª²ç¨Žå¹´åº¦',0),(290840,8079,'pt','Ano fiscal',0),(290841,8079,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´',0),(290842,8079,'es','Ejercicio Fiscal',0),(290843,8079,'de','Steuerjahr',0),(290844,8079,'en','Tax Year',0),(290845,8080,'is','',0),(290846,8080,'dr','Ø³Ø§Ù„ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ ØµØ­ÙŠØ­ Ù†ÙŠØ³Øª ',0),(290847,8080,'pr','Ø³Ø§Ù„ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ ØµØ­ÙŠØ­ Ù†ÙŠØ³Øª ',0),(290848,8080,'tr','YÄ±l girdi geÃ§erli deÄŸil',0),(290849,8080,'pl','Roku wprowadzone nieprawidÅ‚owe',0),(290850,8080,'bg','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð²ÑŠÐ²ÐµÐ»Ð¸ Ð½Ðµ Ðµ Ð²Ð°Ð»Ð¸Ð´ÐµÐ½',0),(290851,8080,'ur','Ø³Ø§Ù„ Ø¬Ø§Ø¦Ø² Ù†ÛÛŒÚº Ø¯Ø§Ø®Ù„',0),(290852,8080,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ ÑÑ‚Ðµ ÑƒÐ½ÐµÐ»Ð¸ Ð½Ð¸Ñ˜Ðµ Ð²Ð°Ð¶ÐµÑ›Ð°',0),(290853,8080,'vi','NÄƒm nháº­p vÃ o khÃ´ng cÃ³ hiá»‡u lá»±c',0),(290854,8080,'af','JARE INGEVOER nie geldig.',0),(290855,8080,'ro','Anul introdus nu este valid',0),(290856,8080,'et','Aasta lÃµpetamine ei ole korrektne',0),(290857,8080,'si','Leto vstopil ni veljaven',0),(290858,8080,'ba','Tahun masuk tidak Valid',0),(290859,8080,'nl','Jaar ingevoerd ongeldig',0),(290860,8080,'fi','Vuonna tuli ei kelpaa',0),(290861,8080,'no','Ã…rstall angitt ugyldig',0),(290862,8080,'da','Ã…r trÃ¥dte ikke gyldigt',0),(290863,8080,'ko','1 ë…„ ìœ íš¨ í•˜ì§€ ì•Šì€ ìž…ë ¥',0),(290864,8080,'he','×©× ×” ×©×”×•×–×Ÿ ××™× ×• ×—×•×§×™',0),(290865,8080,'el','ÎˆÏ„Î¿Ï‚ ÎµÎ³Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ·',0),(290866,8080,'zh','è¾“å…¥çš„å¹´ä»½æ— æ•ˆ\r\n',0),(290867,8080,'sv','Ã…ret in inte giltigt',0),(290868,8080,'it','Anno immesso non Ã¨ valido',0),(290869,8080,'tl','',0),(290870,8080,'th','&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3611;&#3637;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(290871,8080,'hi','à¤µà¤°à¥à¤· à¤®à¤¾à¤¨à¥à¤¯ à¤¨à¤¹à¥€à¤‚ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(290872,8080,'ms','Tahun dimasukkan tidak sah',0),(290873,8080,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø³Ù†Ø© ØºÙŠØ± ØµØ§Ù„Ø­',0),(290874,8080,'fr','AnnÃ©e saisie non valide',0),(290875,8080,'jp','å¹´å…¥åŠ›ãŒç„¡åŠ¹ã§ã™ã€‚',0),(290876,8080,'pt','Ano inserido nÃ£o Ã© vÃ¡lido',0),(290877,8080,'ru','Ð“Ð¾Ð´ Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð» Ð½Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²ÑƒÐµÑ‚',0),(290878,8080,'es','AÃ±o introducido NO VÃ¡lido',0),(290879,8080,'de','Jahreszahl nicht gÃ¼ltig',0),(290880,8080,'en','Year Entered NOT Valid',0),(290881,8081,'is','',0),(290882,8081,'dr','Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ ÙˆØ§Ù‚Ø¹ÙŠ Ø³ÙØ§Ø±Ø´ Ø´Ø¯Ù‡ ',0),(290883,8081,'pr','Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ ÙˆØ§Ù‚Ø¹ÙŠ Ø³ÙØ§Ø±Ø´ Ø´Ø¯Ù‡ ',0),(290884,8081,'tr','GerÃ§ek saat aÅŸan sipariÅŸ',0),(290885,8081,'pl','Przekracza rzeczywiste godziny sortowane',0),(290886,8081,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð°Ñ‚Ð° Ð½Ð°Ð´Ð²Ð¸ÑˆÐ°Ð²Ð° Ñ‡Ð°ÑÐ¾Ð²Ðµ Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸',0),(290887,8081,'ur','Ø§ØµÙ„ Ú¯Ú¾Ù†Ù¹Û’ Ø³Û’ ØªØ¬Ø§ÙˆØ² Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(290888,8081,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð¸ Ð¿Ñ€ÐµÐ¼Ð°ÑˆÑƒÑ˜Ðµ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ ÑÐ°Ñ‚Ð¸ Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾',0),(290889,8081,'vi','Lá»‡nh TÄƒng Giá» Thá»±c Táº¿',0),(290890,8081,'af','Werklike Oorskry Ure Bestel',0),(290891,8081,'ro','Ore depasire comanda actuala',0),(290892,8081,'et','Tegelikult Ã¼letab tundides tellitud',0),(290893,8081,'si','Ur dejansko presega naroÄil',0),(290894,8081,'ba','Aktual Jam Pemesanan Terlampaui',0),(290895,8081,'nl','Werkelijke uren overschrijdt besteld',0),(290896,8081,'fi','Tosiasialliset ylittÃ¤vÃ¤t tunnit tilattu',0),(290897,8081,'no','Faktiske overskrider timer bestilt',0),(290898,8081,'da','Faktiske overstiger timer bestilt',0),(290899,8081,'ko','ì‹¤ì œ ì‹œê°„ ì´ˆê³¼ ì£¼ë¬¸',0),(290900,8081,'he','×‘×¤×•×¢×œ ×—×•×¨×’ ×©×¢×•×ª ×”×•×¨××”',0),(290901,8081,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® Ï…Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ ÏŽÏÎµÏ‚ Î´Î¹Î­Ï„Î±Î¾Îµ',0),(290902,8081,'zh','å®žé™…è¶…å‡ºè§„å®šæ—¶é—´\r\n',0),(290903,8081,'sv','Faktiska Ã¶verstiger timmar bestÃ¤llde',0),(290904,8081,'it','Effettivo superi ore ordinato',0),(290905,8081,'tl','',0),(290906,8081,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3637;&#3656;&#3626;&#3633;&#3656;&#3591;&#3648;&#3585;&#3636;&#3609;&#3592;&#3619;&#3636;&#3591;',0),(290907,8081,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤',0),(290908,8081,'ms','Sebenar melebihi jam mengarahkan',0),(290909,8081,'ar','Ø§Ù„ÙØ¹Ù„ÙŠ ÙŠØªØ¬Ø§ÙˆØ² Ø³Ø§Ø¹Ø§Øª Ø£Ù…Ø±',0),(290910,8081,'fr','Heures RÃ©elle dÃ©passe CommandÃ©',0),(290911,8081,'jp','å®Ÿéš›ã®æ™‚é–“ã‚’è¶…ãˆã‚‹æ³¨æ–‡',0),(290912,8081,'pt','Real excede horas ordenou',0),(290913,8081,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð¿Ñ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ Ñ‡Ð°ÑÐ¾Ð² Ð·Ð°ÐºÐ°Ð·Ð°Ð»',0),(290914,8081,'es','Actual Supera Horas Pedidas',0),(290915,8081,'de','TatsÃ¤chliche Ã¼berschreitet Stunden bestellt',0),(290916,8081,'en','Actual Exceeds Hours Ordered',0),(290917,8082,'is','',0),(290918,8082,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(290919,8082,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(290920,8082,'tr','SipariÅŸ edilen miktar',0),(290921,8082,'pl','Kwota zamÃ³wionych',0),(290922,8082,'bg','Ð¡ÑƒÐ¼Ð° Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸',0),(290923,8082,'ur','Ø±Ù‚Ù… Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(290924,8082,'sr','Ð˜Ð·Ð½Ð¾Ñ Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾',0),(290925,8082,'vi','Sá»‘ LÆ°á»£ng Äáº·t HÃ ng',0),(290926,8082,'af','Bestelde Bedrag',0),(290927,8082,'ro','Suma ordonat',0),(290928,8082,'et','Tellitud kogus',0),(290929,8082,'si','KoliÄino naroÄila',0),(290930,8082,'ba','Jumlah memerintahkan',0),(290931,8082,'nl','Bedrag besteld',0),(290932,8082,'fi','TilausmÃ¤Ã¤rÃ¤',0),(290933,8082,'no','Bestilt antall',0),(290934,8082,'da','MÃ¦ngden bestilte',0),(290935,8082,'ko','ì£¼ë¬¸ ê¸ˆì•¡',0),(290936,8082,'he','×›×ž×•×ª ×”×•×¨×”',0),(290937,8082,'el','Î”Î¹Î±Ï„Î±Î³Î¼Î­Î½Î¿Ï… Ï€Î¿ÏƒÏŒ',0),(290938,8082,'zh','é‡‘é¢æŽ’åº\r\n',0),(290939,8082,'sv','Belopp som bestÃ¤llt',0),(290940,8082,'it','QuantitÃ  ordinata',0),(290941,8082,'tl','',0),(290942,8082,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(290943,8082,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤',0),(290944,8082,'ms','Jumlah yang dipesan',0),(290945,8082,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(290946,8082,'fr','Montant commandÃ©',0),(290947,8082,'jp','æ³¨æ–‡é‡‘é¡',0),(290948,8082,'pt','Quantidade ordenada',0),(290949,8082,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ð½Ñ‹Ñ…',0),(290950,8082,'es','Cantidad Pedido',0),(290951,8082,'de','Menge bestellt',0),(290952,8082,'en','Amount Ordered',0),(290953,8083,'is','',0),(290954,8083,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(290955,8083,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(290956,8083,'tr','Kalan tutar',0),(290957,8083,'pl','Kwota pozostaÅ‚a',0),(290958,8083,'bg','ÐžÑÑ‚Ð°Ð²Ð°Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(290959,8083,'ur','Ø¨Ø§Ù‚ÛŒ Ø±Ù‚Ù…',0),(290960,8083,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ðµ',0),(290961,8083,'vi','Sá»‘ Tiá»n CÃ²n Láº¡i',0),(290962,8083,'af','Oorblywende Bedrag',0),(290963,8083,'ro','Suma rÄƒmasÄƒ',0),(290964,8083,'et','ÃœlejÃ¤Ã¤nud summa',0),(290965,8083,'si','Znesek, ki ostane',0),(290966,8083,'ba','Jumlah sisa',0),(290967,8083,'nl','Resterende bedrag',0),(290968,8083,'fi','JÃ¤ljellÃ¤ oleva summa',0),(290969,8083,'no','BelÃ¸pet som gjenstÃ¥r',0),(290970,8083,'da','Resterende belÃ¸b',0),(290971,8083,'ko','ë‚¨ì€ ê¸ˆì•¡',0),(290972,8083,'he','×”×¡×›×•× ×”× ×•×ª×¨',0),(290973,8083,'el','Î Î¿ÏƒÏŒ Ï€Î¿Ï… Î±Ï€Î¿Î¼Î­Î½ÎµÎ¹',0),(290974,8083,'zh','å‰©ä½™é‡‘é¢\r\n',0),(290975,8083,'sv','Ã…terstÃ¥ende belopp',0),(290976,8083,'it','Importo rimanente',0),(290977,8083,'tl','',0),(290978,8083,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(290979,8083,'hi','à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿',0),(290980,8083,'ms','Jumlah yang masih',0),(290981,8083,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…ØªØ¨Ù‚ÙŠ',0),(290982,8083,'fr','QuantitÃ© restante',0),(290983,8083,'jp','æ®‹ã‚Šã®é‡‘é¡',0),(290984,8083,'pt','Quantidade restante',0),(290985,8083,'ru','Ð¡ÑƒÐ¼Ð¼Ð°, Ð¾ÑÑ‚Ð°ÑŽÑ‰Ð°ÑÑÑ',0),(290986,8083,'es','Cantidad Saldo',0),(290987,8083,'de','Verbleibenden Betrag',0),(290988,8083,'en','Amount Remaining',0),(290989,8084,'is','',0),(290990,8084,'dr','Ø³Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(290991,8084,'pr','Ø³Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(290992,8084,'tr','Saat sipariÅŸ',0),(290993,8084,'pl','Godziny sortowane',0),(290994,8084,'bg','Ð§Ð°ÑÐ° Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸',0),(290995,8084,'ur','Ú¯Ú¾Ù†Ù¹ÙˆÚº Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(290996,8084,'sr','Ð¡Ð°Ñ‚Ð¸ Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾.',0),(290997,8084,'vi','Thá»i gian Ä‘áº·t hÃ ng',0),(290998,8084,'af','Bestelde Ure',0),(290999,8084,'ro','Comandat de ore',0),(291000,8084,'et','Tundi tellitud',0),(291001,8084,'si','Uri odredil',0),(291002,8084,'ba','Jam memerintahkan',0),(291003,8084,'nl','Uur besteld',0),(291004,8084,'fi','Tuntia tilattu',0),(291005,8084,'no','Timer bestilt',0),(291006,8084,'da','Timer bestilt',0),(291007,8084,'ko','ì‹œê°„ ëª…ë ¹',0),(291008,8084,'he','×©×¢×•×ª ×”×•×¨××”',0),(291009,8084,'el','ÎÏÎµÏ‚ Î´Î¹Î­Ï„Î±Î¾Îµ',0),(291010,8084,'zh','æ—¶é—´åº\r\n',0),(291011,8084,'sv','Timmar bestÃ¤llde',0),(291012,8084,'it','Ore ordinato',0),(291013,8084,'tl','',0),(291014,8084,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3637;&#3617;&#3637;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(291015,8084,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶',0),(291016,8084,'ms','Jam mengarahkan',0),(291017,8084,'ar','ÙˆØ£Ù…Ø± Ø³Ø§Ø¹Ø§Øª',0),(291018,8084,'fr','ClassÃ©s en heures',0),(291019,8084,'jp','æ™‚é–“ã‚’å‘½ã˜ãŸ',0),(291020,8084,'pt','Horas ordenou',0),(291021,8084,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ð» Ñ‡Ð°ÑÑ‹',0),(291022,8084,'es','Horas Pedidas',0),(291023,8084,'de','Stunden bestellt',0),(291024,8084,'en','Hours Ordered',0),(291025,8085,'is','',0),(291026,8085,'dr','Ø³Ø§Ø¹Ø§Øª Ø¨Ø§Ù‚ÙŠ Ù…Ø§Ù†Ø¯Ù‡ ',0),(291027,8085,'pr','Ø³Ø§Ø¹Ø§Øª Ø¨Ø§Ù‚ÙŠ Ù…Ø§Ù†Ø¯Ù‡ ',0),(291028,8085,'tr','Kalan saat',0),(291029,8085,'pl','PozostaÅ‚e godziny',0),(291030,8085,'bg','Ð§Ð°ÑÐ°, Ð¾ÑÑ‚Ð°Ð½Ð°Ð»Ð¸',0),(291031,8085,'ur','Ø³Ø§Ø¹Øª Ø¨Ù‚Ø§ÛŒØ§',0),(291032,8085,'sr','Ð¡Ð°Ñ‚Ð¸ Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾',0),(291033,8085,'vi','Giá» cÃ²n láº¡i',0),(291034,8085,'af','Oorblywende Ure',0),(291035,8085,'ro','Ore rÄƒmase',0),(291036,8085,'et','Tundi jÃ¤Ã¤nud',0),(291037,8085,'si','Ur do konca:',0),(291038,8085,'ba','Jam tersisa',0),(291039,8085,'nl','Uur afloopt',0),(291040,8085,'fi','Tuntia jÃ¤ljellÃ¤',0),(291041,8085,'no','Timer igjen',0),(291042,8085,'da','Timer tilbage',0),(291043,8085,'ko','ë‚¨ì€ ì‹œê°„',0),(291044,8085,'he','× ×©××¨×• ×©×¢×•×ª',0),(291045,8085,'el','ÎÏÎµÏ‚ Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(291046,8085,'zh','å‰©ä½™æ—¶é—´\r\n',0),(291047,8085,'sv','Timmar kvar',0),(291048,8085,'it','Ore rimanenti',0),(291049,8085,'tl','',0),(291050,8085,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3629;&#3618;&#3641;&#3656;',0),(291051,8085,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤¶à¥‡à¤·',0),(291052,8085,'ms','Jam yang tinggal',0),(291053,8085,'ar','Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(291054,8085,'fr','Heures restantes',0),(291055,8085,'jp','æ®‹ã‚Šæ™‚é–“',0),(291056,8085,'pt','Horas restantes',0),(291057,8085,'ru','ÐžÑÑ‚Ð°Ð²ÑˆÐ¸Ñ…ÑÑ Ñ‡Ð°ÑÐ¾Ð²',0),(291058,8085,'es','Horas Restantes',0),(291059,8085,'de','Verbleibenden Stunden',0),(291060,8085,'en','Hours Remaining',0),(291061,8086,'is','',0),(291062,8086,'dr','Ø³Ø§Ø¹Ø§Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(291063,8086,'pr','Ø³Ø§Ø¹Ø§Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(291064,8086,'tr','Saat kullanÄ±lan',0),(291065,8086,'pl','Wykorzystanych godzin',0),(291066,8086,'bg','Ð§Ð°ÑÐ° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸',0),(291067,8086,'ur','Ú¯Ú¾Ù†Ù¹ÙˆÚº Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§',0),(291068,8086,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ð¾ Ñ˜Ðµ ÑÐ°Ñ‚Ð¸',0),(291069,8086,'vi','Giá» Ä‘Ã£ dÃ¹ng',0),(291070,8086,'af','Ure Gebruik',0),(291071,8086,'ro','Ore folosit',0),(291072,8086,'et','Tunni kasutada',0),(291073,8086,'si','Ur uporablja',0),(291074,8086,'ba','Jam digunakan',0),(291075,8086,'nl','Uren gebruikt',0),(291076,8086,'fi','Tuntia kÃ¤ytetty',0),(291077,8086,'no','Timer brukt',0),(291078,8086,'da','Timer anvendes',0),(291079,8086,'ko','ì‹œê°„ ì‚¬ìš©',0),(291080,8086,'he','×©×¢×•×ª ×‘×©×™×ž×•×©',0),(291081,8086,'el','ÎÏÎµÏ‚ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹',0),(291082,8086,'zh','ä½¿ç”¨æ—¶æ•°\r\n',0),(291083,8086,'sv','Timmar anvÃ¤nds',0),(291084,8086,'it','Usato ore',0),(291085,8086,'tl','',0),(291086,8086,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3652;&#3611;',0),(291087,8086,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(291088,8086,'ms','Jam digunakan',0),(291089,8086,'ar','ØªØ³ØªØ®Ø¯Ù… Ø³Ø§Ø¹Ø©',0),(291090,8086,'fr','Heures utilisÃ©es',0),(291091,8086,'jp','æ™‚é–“ã®ä½¿ç”¨',0),(291092,8086,'pt','Horas utilizadas',0),(291093,8086,'ru','Ð§Ð°ÑÑ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑŽÑ‚ÑÑ',0),(291094,8086,'es','Horas Usadas',0),(291095,8086,'de','Stunden benutzt',0),(291096,8086,'en','Hours Used',0),(291097,8087,'is','',0),(291098,8087,'dr','ÙƒÙ…ØªØ± Ø§Ø² Ø¯Ù‡ Ø¯Ø±ØµØ¯ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(291099,8087,'pr','ÙƒÙ…ØªØ± Ø§Ø² Ø¯Ù‡ Ø¯Ø±ØµØ¯ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(291100,8087,'tr','Kalan % 10 daha az',0),(291101,8087,'pl','Mniej niÅ¼ 10% pozostaÅ‚ych',0),(291102,8087,'bg','ÐŸÐ¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¾Ñ‚ 10 % Ð¾ÑÑ‚Ð°Ð²Ð°Ñ‚',0),(291103,8087,'ur','Ø³Û’ Ú©Ù… 10 ÙÛŒ ØµØ¯ Ø¨Ø§Ù‚ÛŒ',0),(291104,8087,'sr','ÐœÐ°ÑšÐ¸ Ð¾Ð´ Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¸Ñ… 10%',0),(291105,8087,'vi','Ãt hÆ¡n 10% cÃ²n láº¡i',0),(291106,8087,'af','Minder As 10% Oorblywend',0),(291107,8087,'ro','Mai puÅ£in de 10% rÄƒmaÅŸi',0),(291108,8087,'et','VÃ¤hem kui 10% Ã¼lejÃ¤Ã¤nud',0),(291109,8087,'si','Manj kot 10 % preostalih',0),(291110,8087,'ba','Kurang dari 10% sisa',0),(291111,8087,'nl','Minder dan 10% resterende',0),(291112,8087,'fi','Alle 10 % jÃ¤ljellÃ¤',0),(291113,8087,'no','Mindre enn 10% igjen',0),(291114,8087,'da','Mindre end 10% resterende',0),(291115,8087,'ko','ë‚¨ì•„ ìžˆëŠ” 10% ë¯¸ë§Œ',0),(291116,8087,'he','× ×•×ª×¨ ×¤×—×•×ª ×ž- 10%',0),(291117,8087,'el','Î›Î¹Î³ÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ 10% Ï€Î¿Ï… Î±Ï€Î¿Î¼Î­Î½ÎµÎ¹',0),(291118,8087,'zh','å‰©ä½™ä¸åˆ°10ï¼…\r\n',0),(291119,8087,'sv','Mindre Ã¤n 10% kvar',0),(291120,8087,'it','A meno di 10% rimanente',0),(291121,8087,'tl','',0),(291122,8087,'th','&#3627;&#3633;&#3585;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634; 10% &#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3591;&#3629;&#3618;&#3641;&#3656;',0),(291123,8087,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® 10% à¤¶à¥‡à¤·',0),(291124,8087,'ms','Kurang daripada 10% yang tinggal',0),(291125,8087,'ar','Ø£Ù‚Ù„ Ù…Ù† 10 ÙÙŠ Ø§Ù„Ù…Ø§Ø¦Ø© Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(291126,8087,'fr','InfÃ©rieure Ã  10 % restant',0),(291127,8087,'jp','æ®‹ã‚Šã® 10 ï¼… æœªæº€',0),(291128,8087,'pt','A menos de 10% restantes',0),(291129,8087,'ru','ÐœÐµÐ½ÑŒÑˆÐµ, Ñ‡ÐµÐ¼ 10% Ð¾ÑÑ‚Ð°Ð»Ð¾ÑÑŒ',0),(291130,8087,'es','Menos Que 10% que queda',0),(291131,8087,'de','Weniger als 10 % vorhanden',0),(291132,8087,'en','Less Than 10% Remaining',0),(291133,8088,'is','',0),(291134,8088,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ø²Ø¯ÙŠÙƒ ÙŠØ§  ÙØ±Ø§ØªØ± Ø§Ø² Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(291135,8088,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ø²Ø¯ÙŠÙƒ ÙŠØ§  ÙØ±Ø§ØªØ± Ø§Ø² Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(291136,8088,'tr','Emir ya da zaman iÃ§inde sipariÅŸ',0),(291137,8088,'pl','W pobliÅ¼u lub w czasie zamÃ³wiÄ‡ zamÃ³wieÅ„',0),(291138,8088,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð±Ð»Ð¸Ð·Ð¾ Ð´Ð¾ Ð¸Ð»Ð¸ Ð½Ð°Ð´ Ð²Ñ€ÐµÐ¼ÐµÑ‚Ð¾ Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸',0),(291139,8088,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù‚Ø±ÛŒØ¨ ÛŒØ§ ÙˆÙ‚Øª Ú¯Ø²Ø±Ù†Û’ Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(291140,8088,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ñƒ Ð±Ð»Ð¸Ð·Ð¸Ð½Ð¸ Ð¸Ð»Ð¸ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¾Ð¼ Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾.',0),(291141,8088,'vi','ÄÆ¡n hÃ ng gáº§n hay quÃ¡ háº¡n Ä‘áº·t hÃ ng',0),(291142,8088,'af','Bestellings Nader Of Oorskry Bestelde Tyd',0),(291143,8088,'ro','Comandate ordinele lÃ¢ngÄƒ sau Ã®n timp',0),(291144,8088,'et','LÃ¤hedal ja ajas tellimuste tellitud',0),(291145,8088,'si','NaroÄila v bliÅ¾ini ali sÄasoma naroÄil',0),(291146,8088,'ba','Pesanan di dekat atau waktu memerintahkan',0),(291147,8088,'nl','Bestellingen in de buurt van of na verloop van tijd besteld',0),(291148,8088,'fi','Tilaukset lÃ¤helle tai pÃ¤Ã¤lle mÃ¤Ã¤rÃ¤si',0),(291149,8088,'no','Ordrer i nÃ¦rheten eller Over tid bestilt',0),(291150,8088,'da','Ordrer i nÃ¦rheden af eller Over tid bestilt',0),(291151,8088,'ko','ê·¼ì²˜ ë˜ëŠ” ì£¼ë¬¸ í•˜ëŠ” ê¸°ê°„ë³„ ì£¼ë¬¸',0),(291152,8088,'he','×”×–×ž× ×•×ª ×œ×™×“ ××• ×œ××•×¨×š ×–×ž×Ÿ ×”×•×¨×”',0),(291153,8088,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÎºÎ¿Î½Ï„Î¬ Î® Î´Î¹Î±Ï‡ÏÎ¿Î½Î¹ÎºÎ¬ Î´Î¹Î­Ï„Î±Î¾Îµ',0),(291154,8088,'zh','è®¢å•æŽ¥è¿‘æˆ–è¶…è¿‡æ—¶é—´é¡ºåº\r\n',0),(291155,8088,'sv','Order nÃ¤ra eller Ã¶ver tiden bestÃ¤llde',0),(291156,8088,'it','Ordini vicino o nel tempo ordinato',0),(291157,8088,'tl','',0),(291158,8088,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3651;&#3585;&#3621;&#3657;&#3627;&#3619;&#3639;&#3629;&#3648;&#3585;&#3636;&#3609;&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3626;&#3633;&#3656;&#3591;',0),(291159,8088,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤ªà¤¾à¤¸ à¤¯à¤¾ à¤¸à¤®à¤¯ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾',0),(291160,8088,'ms','Perintah-perintah yang berhampiran atau dari semasa ke semasa mengarahkan',0),(291161,8088,'ar','ÙˆØ£Ù…Ø± Ø£ÙˆØ§Ù…Ø± Ù‚Ø±Ø¨ Ø£Ùˆ Ø¹Ù„Ù‰ Ù…Ø± Ø§Ù„Ø²Ù…Ù†',0),(291162,8088,'fr','ClassÃ©s en ordres prÃ¨s ou au fil du temps',0),(291163,8088,'jp','æ³¨æ–‡ã®è¿‘ãã¾ãŸã¯æ™‚é–“ã®çµŒéŽã‚’å‘½ã˜ãŸ',0),(291164,8088,'pt','Ordenou que ordens perto ou ao longo do tempo',0),(291165,8088,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ñ€ÑÐ´Ð¾Ð¼ Ð¸Ð»Ð¸ Ñ Ñ‚ÐµÑ‡ÐµÐ½Ð¸ÐµÐ¼ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»',0),(291166,8088,'es','Ordenes Cerca o MÃ¡s de Tiempo Ordenado',0),(291167,8088,'de','Bestellungen in der NÃ¤he oder im Laufe der Zeit bestellt',0),(291168,8088,'en','Orders Near Or Over Time Ordered',0),(291169,8089,'is','',0),(291170,8089,'dr','Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª Ø¯Ø± Ù…Ù‚Ø§Ø¨Ù„ Ø²Ù…Ø§Ù† Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(291171,8089,'pr','Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª Ø¯Ø± Ù…Ù‚Ø§Ø¨Ù„ Ø²Ù…Ø§Ù† Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(291172,8089,'tr','Saat (sipariÅŸ kalan saat servis sipariÅŸleri kez) emretti',0),(291173,8089,'pl','Godziny sortowane (czas zamÃ³wienia usÅ‚ugi zamÃ³wione vs pozostaÅ‚y czas)',0),(291174,8089,'bg','Ð§Ð°ÑÐ° Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸ (ÑÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð²Ñ€ÐµÐ¼Ðµ Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸ ÑÑ€ÐµÑ‰Ñƒ Ð¾ÑÑ‚Ð°Ð²Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð²Ñ€ÐµÐ¼Ðµ)',0),(291175,8089,'ur','Ú¯Ú¾Ù†Ù¹Û’ (Ø¨Ù…Ù‚Ø§Ø¨Ù„Û Ø¨Ø§Ù‚ÛŒ ÙˆÙ‚Øª Ø­Ú©Ù… Ø¯ÛŒØ§ Ú©Û Ø®Ø¯Ù…Øª Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª ÙˆÙ‚Øª) Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§ Û”',0),(291176,8089,'sr','Ð¡Ð°Ñ‚Ð¸ Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾ (ÑƒÑÐ»ÑƒÐ³Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾ Ð¿Ñ€Ð¾Ñ‚Ð¸Ð² Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾ Ð²Ñ€ÐµÐ¼Ðµ)',0),(291177,8089,'vi','Thá»i gian Ä‘Æ¡n hÃ ng dá»‹ch vá»¥ so vá»›i thá»i gian cÃ²n láº¡i',0),(291178,8089,'af','Diensbestellings Tyd Bestel teenoor Oorblywende Tyd',0),(291179,8089,'ro','Comandat de ore (timp de comenzi Service ordonat vs timpul rÄƒmas)',0),(291180,8089,'et','Tundi tellitud (teenuse tellimused aeg vs Ã¼lejÃ¤Ã¤nud ajal tellitud)',0),(291181,8089,'si','Uri odredil (servisni nalogi Äasa odredil vs preostali Äas)',0),(291182,8089,'ba','Jam memerintahkan (Layanan pesanan waktu memerintahkan vs sisa waktu)',0),(291183,8089,'nl','Uur besteld (Service Orders tijd besteld vs. resterende tijd)',0),(291184,8089,'fi','Tuntia tilattu (tilaukset aikaa tilata vs. jÃ¤ljellÃ¤)',0),(291185,8089,'no','Timer bestilt (Service bestillinger tid bestilt vs gjenvÃ¦rende tid)',0),(291186,8089,'da','Timer bestilt (Service ordrer gang bestilte vs resterende tid)',0),(291187,8089,'ko','ì‹œê°„ ëª…ë ¹ (ì„œë¹„ìŠ¤ ì£¼ë¬¸ ì‹œê°„ ë‚¨ì€ ì‹œê°„ ëŒ€ ì£¼ë¬¸)',0),(291188,8089,'he','×©×¢×•×ª ×”×•×¨××” (×©×™×¨×•×ª ×”×–×ž× ×•×ª ×–×ž×Ÿ ×”×•×¨×” ×œ×¢×•×ž×ª ×”×–×ž×Ÿ ×”× ×•×ª×¨)',0),(291189,8089,'el','ÎÏÎµÏ‚ Î´Î¹Î­Ï„Î±Î¾Îµ (Ï…Ï€Î·ÏÎµÏƒÎ¯Î± ÏŽÏÎ± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î´Î¹Î­Ï„Î±Î¾Îµ ÎµÎ½Î±Î½Ï„Î¯Î¿Î½ Ï…Ï€Î¿Î»ÎµÎ¹Ï€ÏŒÎ¼ÎµÎ½Î¿Ï‚ Ï‡ÏÏŒÎ½Î¿Ï‚)',0),(291190,8089,'zh','æœåŠ¡è®¢å•æ—¶é—´æŽ’åºä¸Žå‰©ä½™æ—¶é—´\r\n',0),(291191,8089,'sv','Timmar bestÃ¤llde (Service order tid bestÃ¤llt vs Ã¥terstÃ¥ende tid)',0),(291192,8089,'it','Ore ordinato (servizio ordini tempo ordinato vs tempo rimanente)',0),(291193,8089,'tl','',0),(291194,8089,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3648;&#3623;&#3621;&#3634;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3633;&#3610;&#3648;&#3623;&#3',0),(291195,8089,'hi','(à¤¶à¥‡à¤· à¤¸à¤®à¤¯ à¤¬à¤¨à¤¾à¤® à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¸à¤®à¤¯) à¤˜à¤‚à¤Ÿà¥‡ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶',0),(291196,8089,'ms','Jam diperintahkan (Perkhidmatan Pesanan masa diperintahkan vs baki masa)',0),(291197,8089,'ar','Ø³Ø§Ø¹Ø§Øª Ø£Ù…Ø± (Ø£ÙˆØ§Ù…Ø± Ø®Ø¯Ù…Ø© Ø§Ù„ÙˆÙ‚Øª Ø£Ù…Ø±Øª Ù…Ù‚Ø§Ø¨Ù„ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ù…ØªØ¨Ù‚ÙŠ)',0),(291198,8089,'fr','Heures a ordonnÃ© (Service commandes temps classÃ©s en fonction du temps restant)',0),(291199,8089,'jp','æ™‚é–“ ï¼ˆã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡æ™‚é–“å¯¾æ®‹ã‚Šæ™‚é–“æ³¨æ–‡ï¼‰ ã‚’æ³¨æ–‡ã—ã¾ã—ãŸã€‚',0),(291200,8089,'pt','Ordenou que horas (hora de ordens de serviÃ§o ordenou vs tempo restante)',0),(291201,8089,'ru','Ð§Ð°ÑÐ¾Ð² Ð·Ð°ÐºÐ°Ð·Ð°Ð» (ÑÐ»ÑƒÐ¶Ð±Ð° Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð²Ñ€ÐµÐ¼Ñ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð» Ð¿Ñ€Ð¾Ñ‚Ð¸Ð² Ð¾ÑÑ‚Ð°Ð²ÑˆÐµÐµÑÑ Ð²Ñ€ÐµÐ¼Ñ)',0),(291202,8089,'es','Ordenes de Servicio Tiempo Ordenados vs. Tiempo Restante',0),(291203,8089,'de','Stunden bestellt (Bestellungen Servicezeit vs. Restzeit bestellt)',0),(291204,8089,'en','Hours Ordered (Service Orders Time Ordered vs. Remaining Time)',0),(291205,8090,'is','',0),(291206,8090,'dr','Ø±Ø¯Ù‡  ÙƒØ§Ø±ÙŠ ',0),(291207,8090,'pr','Ø±Ø¯Ù‡  ÙƒØ§Ø±ÙŠ ',0),(291208,8090,'tr','Ä°ÅŸ sÄ±nÄ±fÄ±',0),(291209,8090,'pl','Praca klasy',0),(291210,8090,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° ÐºÐ»Ð°Ñ',0),(291211,8090,'ur','Ú©Ù„Ø§Ø³ Ù…ÛŒÚº Ú©Ø§Ù…',0),(291212,8090,'sr','ÐšÐ»Ð°ÑÐ° Ñ€Ð°Ð´',0),(291213,8090,'vi','Cáº¥p Ä‘á»™ cÃ´ng viá»‡c',0),(291214,8090,'af','Werksklas',0),(291215,8090,'ro','Clasa de lucru',0),(291216,8090,'et','TÃ¶Ã¶ klass',0),(291217,8090,'si','Delo razred',0),(291218,8090,'ba','Bekerja kelas',0),(291219,8090,'nl','Werk klasse',0),(291220,8090,'fi','Work-peruskurssi',0),(291221,8090,'no','Arbeid klasse',0),(291222,8090,'da','Arbejde klasse',0),(291223,8090,'ko','ìž‘ì—… í´ëž˜ìŠ¤',0),(291224,8090,'he','×¢×‘×•×“×” ×‘×›×™×ª×”',0),(291225,8090,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(291226,8090,'zh','å·¥ä½œçº§åˆ«\r\n',0),(291227,8090,'sv','Arbete klass',0),(291228,8090,'it','Classe di lavoro',0),(291229,8090,'tl','',0),(291230,8090,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3585;&#3634;&#3619;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(291231,8090,'hi','à¤•à¤¾à¤® à¤•à¥à¤²à¤¾à¤¸',0),(291232,8090,'ms','Kerja kelas',0),(291233,8090,'ar','ÙØ¦Ø© Ø§Ù„Ø¹Ù…Ù„',0),(291234,8090,'fr','Classe travail',0),(291235,8090,'jp','ã‚¯ãƒ©ã‚¹ã‚’å‹•ä½œã—ã¾ã™ã€‚',0),(291236,8090,'pt','Classe de trabalho',0),(291237,8090,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ð¹ ÐºÐ»Ð°ÑÑ',0),(291238,8090,'es','Clase de Trabajo',0),(291239,8090,'de','Arbeit-Klasse',0),(291240,8090,'en','Work Class',0),(291241,8091,'is','',0),(291242,8091,'dr','Ø³Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(291243,8091,'pr','Ø³Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(291244,8091,'tr','Saatler emretti',0),(291245,8091,'pl','ZamÃ³wione do godziny',0),(291246,8091,'bg','ÐžÑÑŠÐ¶Ð´Ð° Ñ‡Ð°ÑÐ¾Ð²Ðµ',0),(291247,8091,'ur','Ú¯Ú¾Ù†Ù¹Û’ Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(291248,8091,'sr','ÐÐ°Ñ€ÑƒÑ‡Ð¸Ð¾ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ ÑÐ°Ñ‚Ð¸',0),(291249,8091,'vi','Giá» Ä‘áº·t hÃ ng',0),(291250,8091,'af','Bestelde Ure',0),(291251,8091,'ro','Comandat ore',0),(291252,8091,'et','Tellisin tundides',0),(291253,8091,'si','NaloÅ¾i ure',0),(291254,8091,'ba','Memerintahkan jam',0),(291255,8091,'nl','Besteld uren',0),(291256,8091,'fi','MÃ¤Ã¤rÃ¤si tuntia',0),(291257,8091,'no','Bestilt timer',0),(291258,8091,'da','Bestilte timer',0),(291259,8091,'ko','ì‹œê°„ ëª…ë ¹',0),(291260,8091,'he','×”×•×¨×” ×©×¢×•×ª',0),(291261,8091,'el','Î”Î¹Î­Ï„Î±Î¾Îµ ÏŽÏÎµÏ‚',0),(291262,8091,'zh','æœ‰åºå°æ—¶\r\n',0),(291263,8091,'sv','BestÃ¤llde timmar',0),(291264,8091,'it','Ordinato ore',0),(291265,8091,'tl','',0),(291266,8091,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(291267,8091,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶',0),(291268,8091,'ms','Mengarahkan jam',0),(291269,8091,'ar','ÙˆØ£Ù…Ø± Ø³Ø§Ø¹Ø§Øª',0),(291270,8091,'fr','ClassÃ©s en heures',0),(291271,8091,'jp','æ™‚é–“ã‚’å‘½ã˜ãŸ',0),(291272,8091,'pt','Ordenou horas',0),(291273,8091,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ð» Ñ‡Ð°ÑÑ‹',0),(291274,8091,'es','Horas Ordenadas',0),(291275,8091,'de','Stunden bestellt',0),(291276,8091,'en','Ordered Hours',0),(291277,8092,'is','',0),(291278,8092,'dr','(Ø¯Ø³ØªÙˆØ± Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(291279,8092,'pr','Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø´Ø¯Ù‡ (Ø¯Ø³ØªÙˆØ± Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(291280,8092,'tr','Zaman sipariÅŸ',0),(291281,8092,'pl','Czas zamÃ³wiÄ‡',0),(291282,8092,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸',0),(291283,8092,'ur','ÙˆÙ‚Øª Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(291284,8092,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾',0),(291285,8092,'vi','Thá»i gian Ä‘áº·t hÃ ng',0),(291286,8092,'af','Bestelde Tyd',0),(291287,8092,'ro','Timp a ordonat',0),(291288,8092,'et','Aeg tellida',0),(291289,8092,'si','ÄŒas odredil',0),(291290,8092,'ba','Waktu memerintahkan',0),(291291,8092,'nl','Tijd besteld',0),(291292,8092,'fi','MÃ¤Ã¤rÃ¤si',0),(291293,8092,'no','Tid bestilt',0),(291294,8092,'da','Gang bestilte',0),(291295,8092,'ko','ì£¼ë¬¸ ì‹œê°„',0),(291296,8092,'he','×”×–×ž×Ÿ ×”×•×¨×”',0),(291297,8092,'el','Î¦Î¿ÏÎ¬, Î´Î¹Î­Ï„Î±Î¾Îµ',0),(291298,8092,'zh','æ—¶é—´æŽ’åº\r\n',0),(291299,8092,'sv','GÃ¥ngen bestÃ¤llde',0),(291300,8092,'it','Tempo ordinato',0),(291301,8092,'tl','',0),(291302,8092,'th','&#3648;&#3623;&#3621;&#3634;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(291303,8092,'hi','à¤¸à¤®à¤¯ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶',0),(291304,8092,'ms','Masa yang diperintahkan',0),(291305,8092,'ar','Ø§Ù„ÙˆÙ‚Øª Ø£Ù…Ø±',0),(291306,8092,'fr','Temps commandÃ©',0),(291307,8092,'jp','æ™‚é–“ã‚’å‘½ã˜ãŸ',0),(291308,8092,'pt','Como ordenou',0),(291309,8092,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð½Ð¾Ðµ Ð’Ñ€ÐµÐ¼Ñ',0),(291310,8092,'es','Tiempo Ordenado',0),(291311,8092,'de','Zeit bestellt',0),(291312,8092,'en','Time Ordered',0),(291313,8093,'is','',0),(291314,8093,'dr','Ø±Ø¯Ù‡  ÙƒØ§Ø±ÙŠ ',0),(291315,8093,'pr','Ø±Ø¯Ù‡  ÙƒØ§Ø±ÙŠ ',0),(291316,8093,'tr','Ä°ÅŸ sÄ±nÄ±fÄ±',0),(291317,8093,'pl','Praca klasy',0),(291318,8093,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° ÐºÐ»Ð°Ñ',0),(291319,8093,'ur','Ú©Ù„Ø§Ø³ Ù…ÛŒÚº Ú©Ø§Ù…',0),(291320,8093,'sr','ÐšÐ»Ð°ÑÐ° Ñ€Ð°Ð´',0),(291321,8093,'vi','Cáº¥p Ä‘á»™ cÃ´ng viá»‡c',0),(291322,8093,'af','Werksklas',0),(291323,8093,'ro','Clasa de lucru',0),(291324,8093,'et','TÃ¶Ã¶ klass',0),(291325,8093,'si','Delo razred',0),(291326,8093,'ba','Bekerja kelas',0),(291327,8093,'nl','Werk klasse',0),(291328,8093,'fi','Work-peruskurssi',0),(291329,8093,'no','Arbeid klasse',0),(291330,8093,'da','Arbejde klasse',0),(291331,8093,'ko','ìž‘ì—… í´ëž˜ìŠ¤',0),(291332,8093,'he','×¢×‘×•×“×” ×‘×›×™×ª×”',0),(291333,8093,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(291334,8093,'zh','å·¥ä½œçº§åˆ«\r\n',0),(291335,8093,'sv','Arbete klass',0),(291336,8093,'it','Classe di lavoro',0),(291337,8093,'tl','',0),(291338,8093,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3594;&#3633;&#3657;&#3609;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;',0),(291339,8093,'hi','à¤•à¤¾à¤® à¤•à¥à¤²à¤¾à¤¸',0),(291340,8093,'ms','Kerja kelas',0),(291341,8093,'ar','ÙØ¦Ø© Ø§Ù„Ø¹Ù…Ù„',0),(291342,8093,'fr','Classe travail',0),(291343,8093,'jp','ã‚¯ãƒ©ã‚¹ã‚’å‹•ä½œã—ã¾ã™ã€‚',0),(291344,8093,'pt','Classe de trabalho',0),(291345,8093,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ð¹ ÐºÐ»Ð°ÑÑ',0),(291346,8093,'es','Clase de Trabajo',0),(291347,8093,'de','Arbeit-Klasse',0),(291348,8093,'en','Work Class',0),(291349,8094,'is','',0),(291350,8094,'dr','Ø²Ù…Ø§Ù† ÙˆØ§Ù‚Ø¹ÙŠ',0),(291351,8094,'pr','Ø²Ù…Ø§Ù† ÙˆØ§Ù‚Ø¹ÙŠ',0),(291352,8094,'tr','GerÃ§ek zaman',0),(291353,8094,'pl','Rzeczywisty czas',0),(291354,8094,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¾Ñ‚Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(291355,8094,'ur','Ø§ØµÙ„ ÙˆÙ‚Øª',0),(291356,8094,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(291357,8094,'vi','Thá»i Gian Thá»±c Táº¿',0),(291358,8094,'af','Werklike Tyd',0),(291359,8094,'ro','Ora actuala',0),(291360,8094,'et','Tegelik aeg',0),(291361,8094,'si','Dejanski Äas',0),(291362,8094,'ba','Waktu Aktual',0),(291363,8094,'nl','Werkelijke tijd',0),(291364,8094,'fi','Todellinen aika',0),(291365,8094,'no','Faktisk tid',0),(291366,8094,'da','Faktiske tid',0),(291367,8094,'ko','ì‹¤ì œ ì‹œê°„',0),(291368,8094,'he','×–×ž×Ÿ ×‘×¤×•×¢×œ',0),(291369,8094,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÏŒÏ‚ Ï‡ÏÏŒÎ½Î¿Ï‚',0),(291370,8094,'zh','å®žé™…æ—¶é—´\r\n',0),(291371,8094,'sv','Faktisk tid',0),(291372,8094,'it','Tempo effettivo',0),(291373,8094,'tl','',0),(291374,8094,'th','&#3648;&#3623;&#3621;&#3634;&#3592;&#3619;&#3636;&#3591;',0),(291375,8094,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤¸à¤®à¤¯',0),(291376,8094,'ms','Masa sebenar',0),(291377,8094,'ar','Ø§Ù„ÙˆÙ‚Øª Ø§Ù„ÙØ¹Ù„ÙŠ',0),(291378,8094,'fr','Temps RÃ©elle',0),(291379,8094,'jp','å®Ÿéš›ã®æ™‚é–“',0),(291380,8094,'pt','Tempo real',0),(291381,8094,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð’Ñ€ÐµÐ¼Ñ',0),(291382,8094,'es','Tiempo Actual',0),(291383,8094,'de','Aktuelle Zeit',0),(291384,8094,'en','Actual Time',0),(291385,8095,'is','',0),(291386,8095,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(291387,8095,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø²Ù…Ø§Ù† Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(291388,8095,'tr','SipariÅŸe sipariÅŸ eklemek',0),(291389,8095,'pl','Dodaj czas zamÃ³wiÄ‡ na zamÃ³wienie',0),(291390,8095,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²Ñ€ÐµÐ¼Ðµ, Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(291391,8095,'ur','Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø­Ú©Ù… Ø¯ÛŒØ§ Ú©Û ÙˆÙ‚Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(291392,8095,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾ Ð´Ð° Ð½Ð°Ð»Ð¾Ð³',0),(291393,8095,'vi','ThÃªm Thá»i Gian Cho ÄÆ¡n Äáº·t HÃ ng ',0),(291394,8095,'af','Voeg Tyd Bestel Tot Bestelling',0),(291395,8095,'ro','Adauga timp comandat la comanda',0),(291396,8095,'et','Lisage tellitud tellimuse aeg',0),(291397,8095,'si','Dodaj Äas, ki je odredila nalog',0),(291398,8095,'ba','Menambahkan waktu yang diperintahkan untuk Order',0),(291399,8095,'nl','Tijd besteld om toevoegen',0),(291400,8095,'fi','LisÃ¤Ã¤ mÃ¤Ã¤rÃ¤si tilauksesta',0),(291401,8095,'no','Legg tiden bestilt bestille',0),(291402,8095,'da','TilfÃ¸je tid bestilt til ordren',0),(291403,8095,'ko','ì‹œê°„ ìˆœì„œì— ëª…ë ¹ ì¶”ê°€',0),(291404,8095,'he','×œ×”×•×¡×™×£ ×–×ž×Ÿ ×”×•×¨×” ×¢×œ ×¡×“×¨',0),(291405,8095,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï‡ÏÏŒÎ½Î¿ Î´Î¹Î­Ï„Î±Î¾Îµ Î½Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ',0),(291406,8095,'zh','å¢žåŠ æ—¶é—´è´£ä»¤è®¢å•\r\n',0),(291407,8095,'sv','LÃ¤gg tiden beordrade att bestÃ¤lla',0),(291408,8095,'it','Aggiungere ora ordinato per ordine',0),(291409,8095,'tl','',0),(291410,8095,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3623;&#3621;&#3634;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(291411,8095,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾ à¤¸à¤®à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(291412,8095,'ms','Tambah masa diperintahkan untuk perintah',0),(291413,8095,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù…Ø± Ø¥Ù„Ù‰ Ø£Ù…Ø± Ù…Ù† Ø§Ù„ÙˆÙ‚Øª',0),(291414,8095,'fr','Ajouter le dÃ©lai prÃ©vu Ã  l\'ordre',0),(291415,8095,'jp','è¿½åŠ æ³¨æ–‡ã«æ³¨æ–‡æ™‚é–“',0),(291416,8095,'pt','Adicionar tempo ordenado a ordem',0),(291417,8095,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ, Ð·Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½Ð° Ð·Ð°ÐºÐ°Ð·',0),(291418,8095,'es','Agregar Tiempo Ordenado al Pedido',0),(291419,8095,'de','FÃ¼gen Sie Zeit befohlen Bestellung hinzu',0),(291420,8095,'en','Add Time Ordered To Order',0),(291421,8096,'is','',0),(291422,8096,'dr','ÙƒÙ¾ÙŠ Ø¯Ø§ Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¬Ø¯ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(291423,8096,'pr','ÙƒÙ¾ÙŠ Ø¯Ø§ Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¬Ø¯ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(291424,8096,'tr','Vergi tablo veri kopyalama',0),(291425,8096,'pl','KopiowaÄ‡ dane z tabeli podatku',0),(291426,8096,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ‡Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(291427,8096,'ur','Ù¹ÛŒÚ©Ø³ Ø¬Ø¯ÙˆÙ„ Ú©ÙˆØ§Ø¦Ù Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(291428,8096,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñ‚Ð°Ð±ÐµÐ»Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(291429,8096,'vi','Báº£ng dá»¯ liá»‡u sao chÃ©p thuáº¿',0),(291430,8096,'af','KopieÃ«r Belastingtabel Data',0),(291431,8096,'ro','Copia date de tabel fiscale',0),(291432,8096,'et','Kopeeri maksutabeli andmed',0),(291433,8096,'si','Kopirajte podatke tabele davka',0),(291434,8096,'ba','Menyalin Data Tabel pajak',0),(291435,8096,'nl','Fiscale tabelgegevens kopiÃ«ren',0),(291436,8096,'fi','Kopioi taulukkotiedot',0),(291437,8096,'no','Kopiere tabellen avgiftsdata',0),(291438,8096,'da','Kopiere skat tabeldata',0),(291439,8096,'ko','ì„¸ê¸ˆ í…Œì´ë¸” ë°ì´í„° ë³µì‚¬',0),(291440,8096,'he','×œ×”×¢×ª×™×§ × ×ª×•× ×™ ×˜×‘×œ×” ×ž×¡',0),(291441,8096,'el','Î‘Î½Ï„Î¹Î³ÏÎ¬ÏˆÏ„Îµ Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï€Î¯Î½Î±ÎºÎ± Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½',0),(291442,8096,'zh','ç¨ŽçŽ‡è¡¨æ•°æ®å¤åˆ¶\r\n',0),(291443,8096,'sv','Kopiera skatt tabelldata',0),(291444,8096,'it','Copiare i dati della tabella fiscale',0),(291445,8096,'tl','',0),(291446,8096,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3605;&#3634;&#3619;&#3634;&#3591;&#3616;&#3634;&#3625;&#3637;',0),(291447,8096,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(291448,8096,'ms','Menyalin Data Jadual cukai',0),(291449,8096,'ar','Ù†Ø³Ø® Ø¨ÙŠØ§Ù†Ø§Øª Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(291450,8096,'fr','Copiez les donnÃ©es fiscales de la Table',0),(291451,8096,'jp','ç¨Žãƒ†ãƒ¼ãƒ–ãƒ« ãƒ‡ãƒ¼ã‚¿ã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(291452,8096,'pt','Copiar os dados da tabela de imposto',0),(291453,8096,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ñ…',0),(291454,8096,'es','Copiar Datos de Tabla de Impuestos',0),(291455,8096,'de','Steuer Tabellendaten kopieren',0),(291456,8096,'en','Copy Tax Table Data',0),(291457,8097,'is','',0),(291458,8097,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø§Ù„ Ø¬Ø¯ÙŠØ¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(291459,8097,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø§Ù„ Ø¬Ø¯ÙŠØ¯ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(291460,8097,'tr','Ä°nitiate yeni yÄ±l baÅŸarÄ±sÄ±z oldu',0),(291461,8097,'pl','RozpoczÄ…Ä‡ nowy rok nie powiodÅ‚o siÄ™',0),(291462,8097,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð½Ð¾Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(291463,8097,'ur','Ø§Ù†Ø§Ù¹ÛŒØ§Ù¹ÛŒ Ù†Ø¦Û’ Ø³Ø§Ù„ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(291464,8097,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸ Ð½Ð¾Ð²Ñƒ Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(291465,8097,'vi','Báº¯t Ä‘áº§u nÄƒm má»›i tháº¥t báº¡i',0),(291466,8097,'af','Aanvoor nuwe jaar het misluk',0),(291467,8097,'ro','Initiati de anul nou nu a reuÅŸit',0),(291468,8097,'et','Uue aasta alustamine ebaÃµnnestus',0),(291469,8097,'si','Spro i novo leto ni uspelo',0),(291470,8097,'ba','Memulai tahun baru yang gagal',0),(291471,8097,'nl','Starten Nieuwjaar is mislukt',0),(291472,8097,'fi','Aloittaa uusi vuosi epÃ¤onnistui',0),(291473,8097,'no','Initiere nyttÃ¥r mislyktes',0),(291474,8097,'da','IgangsÃ¦tte nye Ã¥r mislykkedes',0),(291475,8097,'ko','ì‹¤íŒ¨ í•œ ì‹œìž‘ ìƒˆ í•´',0),(291476,8097,'he','×©× ×” ×—×“×©×” ××ª×—×•×œ × ×›×©×œ×”',0),(291477,8097,'el','ÎžÎµÎºÎ¹Î½Î®ÏƒÎµÎ¹ Ï„Î¿ Î½Î­Î¿ Î­Ï„Î¿Ï‚ Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(291478,8097,'zh','åˆå§‹å¹´ä»½å¯åŠ¨å¤±è´¥\r\n',0),(291479,8097,'sv','Starta nya Ã¥ret misslyckades',0),(291480,8097,'it','Avviare nuovo anno fallito',0),(291481,8097,'tl','',0),(291482,8097,'th','&#3585;&#3634;&#3619;&#3648;&#3619;&#3636;&#3656;&#3617;&#3611;&#3637;&#3651;&#3627;&#3617;&#3656;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(291483,8097,'hi','à¤†à¤°à¤‚à¤­ à¤¨à¤ à¤¸à¤¾à¤² à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(291484,8097,'ms','Memulakan tahun baru yang gagal',0),(291485,8097,'ar','Ø¨Ø¯Ø¡ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø§Ù„ØªÙŠ ÙØ´Ù„Øª',0),(291486,8097,'fr','Initiate an a Ã©chouÃ©',0),(291487,8097,'jp','å¤±æ•—ã—ãŸé–‹å§‹æ–°å¹´',0),(291488,8097,'pt','Iniciar ano novo falhado',0),(291489,8097,'ru','Ð˜Ð½Ð¸Ñ†Ð¸Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(291490,8097,'es','Iniciar Nuevo Ejercicio FallÃ³',0),(291491,8097,'de','Initiieren neue Jahr fehlgeschlagen',0),(291492,8097,'en','Initiate New Year Failed',0),(291493,8098,'is','',0),(291494,8098,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø§Ù„ Ø¬Ø¯ÙŠØ¯ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(291495,8098,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø§Ù„ Ø¬Ø¯ÙŠØ¯ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(291496,8098,'tr','Yeni yÄ±l baÅŸarÄ±lÄ± baÅŸlatmak',0),(291497,8098,'pl','RozpoczÄ™cia nowego roku sukces',0),(291498,8098,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð½Ð¾Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(291499,8098,'ur','Ù†Ø¦Û’ Ø³Ø§Ù„ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ Ø§Ø¨ØªØ¯Ø§',0),(291500,8098,'sr','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð³Ð¾Ð´Ð¸Ð½Ñƒ ÑƒÑÐ¿ÐµÑˆÐ°Ð½',0),(291501,8098,'vi','Báº¯t Ä‘áº§u nÄƒm má»›i thÃ nh cÃ´ng',0),(291502,8098,'af','Inisieer Nuwe Jaar Suksesvol',0),(291503,8098,'ro','IniÅ£ia de succes de anul nou',0),(291504,8098,'et','Uue aasta alustamine Ãµnnestus',0),(291505,8098,'si','SproÅ¾i novo leto uspeÅ¡no',0),(291506,8098,'ba','Memulai tahun baru yang sukses',0),(291507,8098,'nl','Initialiseren nieuw jaar succesvolle',0),(291508,8098,'fi','Aloittaa uusi vuosi onnistunut',0),(291509,8098,'no','Starte nye Ã¥ret vellykket',0),(291510,8098,'da','Indlede nye Ã¥r vellykket',0),(291511,8098,'ko','ì„±ê³µì ì¸ ìƒˆ í•´ ì‹œìž‘',0),(291512,8098,'he','×œ×”×ª×—×™×œ ×©× ×” ×—×“×©×” ×ž×•×¦×œ×—×ª',0),(291513,8098,'el','ÎšÎ¹Î½Î®ÏƒÎµÎ¹ Î½Î­Î¿ Î­Ï„Î¿Ï‚ ÎµÏ€Î¹Ï„Ï…Ï‡Î·Î¼Î­Î½ÎµÏ‚',0),(291514,8098,'zh','åˆå§‹å¹´ä»½çš„æˆåŠŸå¯åŠ¨\r\n',0),(291515,8098,'sv','Initiera nya Ã¥ret framgÃ¥ngsrika',0),(291516,8098,'it','Iniziare il nuovo anno di successo',0),(291517,8098,'tl','',0),(291518,8098,'th','&#3585;&#3634;&#3619;&#3648;&#3619;&#3636;&#3656;&#3617;&#3611;&#3637;&#3651;&#3627;&#3617;&#3656;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(291519,8098,'hi','à¤¨à¤¯à¤¾ à¤¸à¤¾à¤² à¤¸à¤«à¤² à¤†à¤°à¤‚à¤­',0),(291520,8098,'ms','Memulakan tahun baru berjaya',0),(291521,8098,'ar','Ø¨Ø¯Ø¡ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø§Ù„Ù†Ø§Ø¬Ø­Ø©',0),(291522,8098,'fr','Entamer la nouvelle annÃ©e de succÃ¨s',0),(291523,8098,'jp','æ–°ã—ã„å¹´ã®æˆåŠŸã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(291524,8098,'pt','Iniciar o novo ano de sucesso',0),(291525,8098,'ru','Ð˜Ð½Ð¸Ñ†Ð¸Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´ ÑƒÑÐ¿ÐµÑˆÐ½Ñ‹Ð¼',0),(291526,8098,'es','Iniciar Nuevo Ejercicio Exitoso',0),(291527,8098,'de','Neue Jahr erfolgreich zu initiieren',0),(291528,8098,'en','Initiate New Year Successful',0),(291529,8099,'is','',0),(291530,8099,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ù„Ø§Ù†Ù‡  Ø¬Ù‡Øª Ø§ÙŠØ¬Ø§Ø¯ ',0),(291531,8099,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ù„Ø§Ù†Ù‡  Ø¬Ù‡Øª Ø§ÙŠØ¬Ø§Ø¯ ',0),(291532,8099,'tr','Vergi yÄ±lÄ± oluÅŸturmak iÃ§in',0),(291533,8099,'pl','Rok podatkowy stworzyÄ‡',0),(291534,8099,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð·Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð°',0),(291535,8099,'ur','Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ Ø³Ø§Ù„',0),(291536,8099,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ Ð¿Ð¾Ñ€ÐµÐ· Ð·Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ',0),(291537,8099,'vi','Táº¡o NÄƒm thuáº¿',0),(291538,8099,'af','Belastingjaar om te Skep',0),(291539,8099,'ro','An fiscal pentru a crea',0),(291540,8099,'et','Aastal luua',0),(291541,8099,'si','DavÄno leto ustvariti',0),(291542,8099,'ba','Tahun pajak untuk membuat',0),(291543,8099,'nl','Fiscale jaar maken',0),(291544,8099,'fi','Verovuoden luominen',0),(291545,8099,'no','InntektsÃ¥ret opprette',0),(291546,8099,'da','SkatteÃ¥r at skabe',0),(291547,8099,'ko','ë§Œë“¤ë ¤ëŠ” ê³¼ì„¸ ì—°ë„',0),(291548,8099,'he','×©× ×ª ×ž×¡ ×›×“×™ ×œ×™×¦×•×¨',0),(291549,8099,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŒ Î­Ï„Î¿Ï‚ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ',0),(291550,8099,'zh','çº³ç¨Žå¹´åº¦åˆ›å»º\r\n',0),(291551,8099,'sv','BeskattningsÃ¥ret att skapa',0),(291552,8099,'it','Anno fiscale per creare',0),(291553,8099,'tl','',0),(291554,8099,'th','&#3611;&#3637;&#3616;&#3634;&#3625;&#3637;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(291555,8099,'hi','à¤•à¤° à¤µà¤°à¥à¤· à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(291556,8099,'ms','Cukai tahun untuk mencipta',0),(291557,8099,'ar','Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ© Ø¥Ù†Ø´Ø§Ø¡',0),(291558,8099,'fr','AnnÃ©e d\'imposition pour crÃ©er',0),(291559,8099,'jp','ä½œæˆã™ã‚‹ã«ã¯ã€èª²ç¨Žå¹´åº¦',0),(291560,8099,'pt','Ano fiscal para criar',0),(291561,8099,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´ Ð´Ð»Ñ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ',0),(291562,8099,'es','Ejercicio Fiscal Para Crear',0),(291563,8099,'de','Steuerjahr erstellen',0),(291564,8099,'en','Tax Year To Create',0),(291565,8100,'is','',0),(291566,8100,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¯ÙˆÙ„ØªÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(291567,8100,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ø¯ÙˆÙ„ØªÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(291568,8100,'tr','SeÃ§ilen yÄ±l iÃ§in vergi tablolarÄ± gÃ¼ncelleÅŸtirmek',0),(291569,8100,'pl','Aktualizowanie tabel podatku federalnego dla roku wybrany',0),(291570,8100,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð¸Ñ‚Ðµ, Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½',0),(291571,8100,'ur','Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³ Ø¬Ø¯ÙˆÙ„ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(291572,8100,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° ÑÑ‚Ð¾Ð»Ð¾Ð²Ð¸Ð¼Ð° Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(291573,8100,'vi','Cáº­p Nháº­t Báº£ng Thuáº¿ LiÃªn Bang Cho nÄƒm Ä‘Ã£ chá»n',0),(291574,8100,'af','Werk federale belasting tabelle vir jaar gekies',0),(291575,8100,'ro','Actualizare impozitului Federal tabele pentru anul selectate',0),(291576,8100,'et','Uuendada fÃ¶deraalse tulumaksu tabelid aastaks valitud',0),(291577,8100,'si','Posodobitev zveznega davka tabele za leta izbran',0),(291578,8100,'ba','Memperbarui Pajak Federal tabel untuk tahun yang dipilih',0),(291579,8100,'nl','Federal Tax tabellen bijwerken voor jaar geselecteerd',0),(291580,8100,'fi','Liittovaltion vero pÃ¤ivitettÃ¤vÃ¤ valitun vuoden',0),(291581,8100,'no','Oppdatere fÃ¸deral skattetabeller For Ã¥r valgt',0),(291582,8100,'da','Opdatere Federal Tax-tabeller For Ã¥r valgt',0),(291583,8100,'ko','ì˜¬í•´ ì„ ì •ì— ëŒ€ í•œ ì—°ë°© ì„¸ê¸ˆ í…Œì´ë¸” ì—…ë°ì´íŠ¸',0),(291584,8100,'he','×¢×“×›×•×Ÿ ×˜×‘×œ××•×ª ×ž×¡ ×¤×“×¨×œ×™ ×œ×©× ×” ×©× ×‘×—×¨×•',0),(291585,8100,'el','Î•Î½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Îµ Ï„Î¿Ï…Ï‚ Ï€Î¯Î½Î±ÎºÎ­Ï‚ Ï„Î¿Ï… Î¿Î¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï… Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î¾Î±Ï„Îµ',0),(291586,8100,'zh','æ›´æ–°é€‰ä¸­å¹´ä»½çš„è”é‚¦ç¨Žè¡¨\r\n',0),(291587,8100,'sv','Uppdateringsregister fÃ¶r Federal skatt fÃ¶r Ã¥ret valt',0),(291588,8100,'it','Aggiornare le tabelle fiscali federali per l\'anno selezionato',0),(291589,8100,'tl','',0),(291590,8100,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3634;&#3619;&#3634;&#3591;&#3616;&#3634;&#3625;&#3637;&#3619;&#3633;&#3600;&#3586;&#3629;&#3591;&#3611;&#3637;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(291591,8100,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¤à¤¾à¤²à¤¿à¤•à¤¾à¤à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(291592,8100,'ms','Kemaskini Terakhir Jadual cukai Persekutuan bagi tahun yang dipilih',0),(291593,8100,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ© Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ù„Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(291594,8100,'fr','Mettre Ã  jour les Tables d\'impÃ´t fÃ©dÃ©ral pour l\'annÃ©e sÃ©lectionnÃ©e',0),(291595,8100,'jp','é¸æŠžã—ãŸå¹´ã®é€£é‚¦ç¨Žã®ãƒ†ãƒ¼ãƒ–ãƒ«ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(291596,8100,'pt','Atualizar tabelas de impostos federais para o ano selecionado',0),(291597,8100,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ† Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° Ð³Ð¾Ð´ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(291598,8100,'es','Actualizar Tablas de Impuestos Federales Para el AÃ±o Seleccionado',0),(291599,8100,'de','Aktualisieren Sie Bundessteuer-Tabellen fÃ¼r das ausgewÃ¤hlte Jahr',0),(291600,8100,'en','Update Federal Tax Tables For Year Selected',0),(291601,8101,'is','',0),(291602,8101,'dr','Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø´Ø¯ Ø§Ù…Ø§ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ ÙƒØ§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ù†ÙŠØ³Øª ',0),(291603,8101,'pr','Ø³Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø´Ø¯ Ø§Ù…Ø§ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ ÙƒØ§Ø± Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ù†ÙŠØ³Øª ',0),(291604,8101,'tr','HiÃ§bir WorkClass sipariÅŸ iÃ§in girilen saat',0),(291605,8101,'pl','Wprowadzonego ale nie WorkClass na zamÃ³wienie',0),(291606,8101,'bg','Ð§Ð°ÑÐ°, Ð²ÑŠÐ²ÐµÐ»Ð¸, Ð½Ð¾ Ð½Ðµ WorkClass Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(291607,8101,'ur','Ù„ÛŒÚ©Ù† Ú©ÙˆØ¦ÛŒ ÙˆÙˆØ±Ú©Ú©Ù„Ø§Ø³Ø³ Ú©ÛŒÙ„Ø¦Û’ Ø¢Ø±ÚˆØ± Ø¯Ø§Ø®Ù„ Ú¯Ú¾Ù†Ù¹Û’',0),(291608,8101,'sr','Ð¡Ð°Ñ‚Ð¸ ÑƒÑˆÐ°Ð¾ Ð°Ð»Ð¸ Ð½ÐµÐ¼Ð° WÐ¾Ñ€ÐºÐ¦Ð»Ð°ÑÑ Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(291609,8101,'vi','Thá»i gian Ä‘Ã£ nháº­p nhÆ°ng khÃ´ng cÃ³ cáº¥p báº­c cÃ´ng viá»‡c cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(291610,8101,'af','Ure Ingevoer Maar Geen Werkklas Vir Bestelling',0),(291611,8101,'ro','Ore intrat dar nici WorkClass pentru comanda',0),(291612,8101,'et','Aga No WorkClass tellimuse puhul sisestatud tundide',0),(291613,8101,'si','Uri zaÄel ampak ne WorkClass za naroÄilo',0),(291614,8101,'ba','Jam masuk tetapi tidak WorkClass untuk Order',0),(291615,8101,'nl','Uren ingevoerd maar geen WorkClass voor Order',0),(291616,8101,'fi','Mutta ei WorkClass jÃ¤rjestyksessÃ¤ tunnit',0),(291617,8101,'no','Timer angitt men ingen WorkClass For ordre',0),(291618,8101,'da','Timer angivet men ingen WorkClass For rÃ¦kkefÃ¸lge',0),(291619,8101,'ko','ì‹œê°„ ìˆœì„œë¥¼ ìœ„í•œ ì•„ë¬´ WorkClassë§Œ ìž…ë ¥',0),(291620,8101,'he','×”×©×¢×•×ª ×©×”×•×–× ×• ××‘×œ ×œ× WorkClass ×¢×‘×•×¨ ×”×–×ž× ×”',0),(291621,8101,'el','ÎÏÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯ Î±Î»Î»Î¬ Î´ÎµÎ½ WorkClass Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(291622,8101,'zh','æ—¶é—´è¾“å…¥ä½†æ²¡æœ‰å·¥ä½œå±‚æ¬¡é¡ºåº\r\n',0),(291623,8101,'sv','Timmar in men inga WorkClass fÃ¶r bestÃ¤llning',0),(291624,8101,'it','Ore inserite ma nessun WorkClass per ordine',0),(291625,8101,'tl','',0),(291626,8101,'th','&#3648;&#3623;&#3621;&#3634;&#3648;&#3586;&#3657;&#3634;&#3649;&#3605;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3588;&#3621;&#3634;&#3626;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3',0),(291627,8101,'hi','à¤²à¥‡à¤•à¤¿à¤¨ à¤•à¥‹à¤ˆ WorkClass à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤˜à¤‚à¤Ÿà¥‡',0),(291628,8101,'ms','Jam dimasukkan tetapi tidak WorkClass untuk pesanan',0),(291629,8101,'ar','Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ ÙˆÙ„ÙƒÙ† Ù„Ø§ ÙˆÙˆØ±ÙƒÙƒÙ„Ø§Ø³ Ù„Ù„Ù†Ø¸Ø§Ù…',0),(291630,8101,'fr','Heures entrÃ©s mais aucun WorkClass pour ordre',0),(291631,8101,'jp','æ³¨æ–‡ã®ãªã„ WorkClass ãŒå…¥åŠ›ã•ã‚ŒãŸæ™‚é–“',0),(291632,8101,'pt','Horas entradas mas nÃ£o WorkClass para a ordem',0),(291633,8101,'ru','Ð§Ð°ÑÐ¾Ð², Ð²Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ñ… Ð½Ð¾ Ð½Ðµ WorkClass Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(291634,8101,'es','Horas Entradas Pero No Hay Clase de Trabajo para el Orden',0),(291635,8101,'de','Stunden ging aber keine WorkClass fÃ¼r Bestellung',0),(291636,8101,'en','Hours Entered But No WorkClass For Order',0),(291637,8102,'is','',0),(291638,8102,'dr','Ø³Ø§Ø¹Ø§Øª Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(291639,8102,'pr','Ø³Ø§Ø¹Ø§Øª Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(291640,8102,'tr','Ã–n Ã¶demeli saat',0),(291641,8102,'pl','Pre-paid godzin',0),(291642,8102,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ñ‡Ð°ÑÐ¾Ð²Ðµ',0),(291643,8102,'ur','(Ù„Ø§Ù†Ú¯ ÚˆØ³Ù¹Ù†Ø³) Ú¯Ú¾Ù†Ù¹Û’',0),(291644,8102,'sr','ÐŸÑ€ÐµÐ¿Ð°Ð¸Ð´ ÑÐ°Ñ‚Ð¸',0),(291645,8102,'vi','Giá» Tráº£ trÆ°á»›c',0),(291646,8102,'af','Vooruitbetaalde Ure',0),(291647,8102,'ro','Preplatite de ore',0),(291648,8102,'et','Ettemakstud tundi',0),(291649,8102,'si','PredplaÄniÅ¡ke ur',0),(291650,8102,'ba','Jam prabayar',0),(291651,8102,'nl','Vooruitbetaalde uur',0),(291652,8102,'fi','Prepaid tuntia',0),(291653,8102,'no','ForhÃ¥ndsbetalte timer',0),(291654,8102,'da','Forudbetalte timer',0),(291655,8102,'ko','ì„ ë¶ˆëœ ì‹œê°„',0),(291656,8102,'he','×©×¢×•×ª ×ž×¨××©',0),(291657,8102,'el','Î ÏÎ¿Ï€Î»Î·ÏÏ‰Î¼Î­Î½Î· ÏŽÏÎµÏ‚',0),(291658,8102,'zh','é¢„ä»˜æ—¶é—´\r\n\r\n\r\nType text or a website address or translate a document.\r\nCancel\r\nListenRead phonetically\r\nEnglish to Chinese (Simplified) translation\r\né¢„ä»˜æ—¶é—´\r\n',0),(291659,8102,'sv','FÃ¶rutbetalda timmar',0),(291660,8102,'it','Ore prepagate',0),(291661,8102,'tl','',0),(291662,8102,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3585;&#3656;&#3629;&#3609;',0),(291663,8102,'hi','à¤ªà¥à¤°à¥€à¤ªà¥‡à¤¡ à¤˜à¤‚à¤Ÿà¥‡',0),(291664,8102,'ms','Jam prabayar',0),(291665,8102,'ar','Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© Ù…Ø³Ø¨Ù‚Ø§Ù‹',0),(291666,8102,'fr','Heures payÃ©es d\'avance',0),(291667,8102,'jp','ãƒ—ãƒªãƒšã‚¤ãƒ‰ã®æ™‚é–“',0),(291668,8102,'pt','Horas prÃ©-pago',0),(291669,8102,'ru','ÐŸÑ€ÐµÐ´Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ñ‡Ð°ÑÐ¾Ð²',0),(291670,8102,'es','Horas Prepagadas',0),(291671,8102,'de','Prepaid Stunden',0),(291672,8102,'en','Prepaid Hours',0),(291673,8103,'is','',0),(291674,8103,'dr','Ø«Ø¨Øª Ø²Ù…Ø§Ù† Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(291675,8103,'pr','Ø«Ø¨Øª Ø²Ù…Ø§Ù† Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(291676,8103,'tr','Servis sipariÅŸleri iÃ§in Ã¶n Ã¶demeli zaman giriÅŸi',0),(291677,8103,'pl','Prepaid czasu wejÅ›cia dla zleceÅ„ serwisowych',0),(291678,8103,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð²Ñ€ÐµÐ¼Ðµ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(291679,8103,'ur','Ù¾Ø±ÛŒ Ù¾ÛŒÚˆ ÙˆÙ‚Øª Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’',0),(291680,8103,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð°Ð²Ð°Ð½ÑÐ½Ð¾Ð³ Ð²Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(291681,8103,'vi','Nháº­p Thá»i Gian Tráº£ TrÆ°á»›c Cho ÄÆ¡n HÃ ng Dá»‹ch Vá»¥',0),(291682,8103,'af','Vooruitbetaalde Tydinskrywing Vir Diensbestellings',0),(291683,8103,'ro','Preplatite de timp de intrare pentru comenzi de Service',0),(291684,8103,'et','RÃ¼hmatreeningutes ettemakstud hooldustellimuste',0),(291685,8103,'si','PredplaÄniÅ¡ko Äasa vnos za servisne naloge',0),(291686,8103,'ba','Prabayar kali masuk untuk layanan pesanan',0),(291687,8103,'nl','Vooruitbetaalde tijd vermelding voor serviceorders',0),(291688,8103,'fi','Huoltotilaukset-aikamerkintÃ¤ prepaid',0),(291689,8103,'no','ForhÃ¥ndsbetalte tidsoppfÃ¸ring For serviceordrer',0),(291690,8103,'da','Forudbetalt tid posten For serviceordrer',0),(291691,8103,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ì„ ë¶ˆëœ ì‹œê°„ í•­ëª©',0),(291692,8103,'he','×”×–× ×ª ×–×ž× ×™× ×ž×¨××© ×¢×‘×•×¨ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(291693,8103,'el','Î ÏÎ¿Ï€Î»Î·ÏÏ‰Î¼Î­Î½Î¿Ï… Ï‡ÏÏŒÎ½Î¿Ï… Î­Î½Î±ÏÎ¾Î·Ï‚ Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(291694,8103,'zh','é¢„ä»˜æœåŠ¡è®¢å•æ—¶é—´è¾“å…¥\r\n',0),(291695,8103,'sv','FÃ¶rbetalda tid posten fÃ¶r serviceorder',0),(291696,8103,'it','Voce tempo prepagato per gli ordini di servizio',0),(291697,8103,'tl','',0),(291698,8103,'th','&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3585;&#3656;&#3629;&#3609;&#3648;&#3623;&#3621;&#3634;&#3648;&#3586;&#3657;&#3634;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3',0),(291699,8103,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¥€à¤ªà¥‡à¤¡ à¤¸à¤®à¤¯ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(291700,8103,'ms','Prabayar masa kemasukan bagi pesanan Perkhidmatan',0),(291701,8103,'ar','Ø¥Ø¯Ø®Ø§Ù„ ÙˆÙ‚Øª Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø³Ø¨Ù‚ Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(291702,8103,'fr','EntrÃ©e de temps prÃ©payÃ© pour les commandes de Service',0),(291703,8103,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã®ãƒ—ãƒªãƒšã‚¤ãƒ‰ã®æ™‚é–“ã‚¨ãƒ³ãƒˆãƒª',0),(291704,8103,'pt','Entrada de tempo prÃ©-pago para ordens de serviÃ§o',0),(291705,8103,'ru','ÐŸÑ€ÐµÐ´Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ð¾Ð³Ð¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð²Ñ…Ð¾Ð´Ð° Ð´Ð»Ñ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(291706,8103,'es','Entrada de Tiempo PrepagadoPara Ordenes de Servicio',0),(291707,8103,'de','Prepaid Zeiteintrag fÃ¼r ServiceauftrÃ¤ge',0),(291708,8103,'en','Prepaid Time Entry For Service Orders',0),(291709,8104,'is','',0),(291710,8104,'dr','Ø´Ø±ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ù„Ø§Ù†Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(291711,8104,'pr','Ø´Ø±ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ù„Ø§Ù†Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(291712,8104,'tr','Yeni vergi yÄ±lÄ± baÅŸlatmak',0),(291713,8104,'pl','RozpoczÄ™cie nowego roku podatkowego',0),(291714,8104,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð°Ñ‚Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(291715,8104,'ur','Ù†Ø¦Û’ Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø§Ø³ Ø³Ø§Ù„ Ú©Ø§ Ø¢ØºØ§Ø²',0),(291716,8104,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð½Ð¾Ð²Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¿Ð¾Ñ€ÐµÐ·',0),(291717,8104,'vi','Báº¯t Ä‘áº§u nÄƒm thuáº¿ má»›i',0),(291718,8104,'af','Begin Nuwe Belastingjaar',0),(291719,8104,'ro','ÃŽncepe noul an fiscal',0),(291720,8104,'et','Alusta uut maksuaasta',0),(291721,8104,'si','ZaÄnite novo davÄno leto',0),(291722,8104,'ba','Mulai tahun pajak baru',0),(291723,8104,'nl','Nieuwe fiscale jaar start',0),(291724,8104,'fi','Aloittaa uuden verovuoden',0),(291725,8104,'no','Starte nye inntektsÃ¥ret',0),(291726,8104,'da','Start nye skatteÃ¥r',0),(291727,8104,'ko','ìƒˆë¡œìš´ ê³¼ì„¸ ì—°ë„ ì‹œìž‘',0),(291728,8104,'he','×”×ª×—×œ ×©× ×ª ×ž×¡ ×—×“×©×”',0),(291729,8104,'el','ÎžÎµÎºÎ¹Î½Î®ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŒ Î­Ï„Î¿Ï‚',0),(291730,8104,'zh','å¼€å§‹æ–°çš„çº³ç¨Žå¹´åº¦\r\n',0),(291731,8104,'sv','Starta nya beskattningsÃ¥ret',0),(291732,8104,'it','Iniziare il nuovo anno fiscale',0),(291733,8104,'tl','',0),(291734,8104,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3611;&#3637;&#3616;&#3634;&#3625;&#3637;&#3651;&#3627;&#3617;&#3656;',0),(291735,8104,'hi','à¤¨à¤ à¤•à¤° à¤µà¤°à¥à¤· à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤•à¤°à¥‡à¤‚',0),(291736,8104,'ms','Mula tahun cukai baru',0),(291737,8104,'ar','Ø¨Ø¯Ø§ÙŠØ© Ø³Ù†Ø© Ø¶Ø±ÙŠØ¨ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(291738,8104,'fr','Commencez la nouvelle annÃ©e d\'imposition',0),(291739,8104,'jp','æ–°ã—ã„èª²ç¨Žå¹´åº¦ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(291740,8104,'pt','ComeÃ§ar o novo ano fiscal',0),(291741,8104,'ru','ÐÐ°Ñ‡Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´',0),(291742,8104,'es','Iniciar Nuevo Ejercicio',0),(291743,8104,'de','Start der neuen Steuerjahr',0),(291744,8104,'en','Start New Tax Year',0),(291745,8105,'is','',0),(291746,8105,'dr','Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§',0),(291747,8105,'pr','Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§',0),(291748,8105,'tr','Yeni yÄ±l iÃ§in vergi baÅŸlamak',0),(291749,8105,'pl','PoczÄ…tek nowego roku podatki',0),(291750,8105,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð·Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(291751,8105,'ur','Ù…Ø­ØµÙˆÙ„Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ù†Ø¦Û’ Ø³Ø§Ù„ Ú©Ø§ Ø¢ØºØ§Ø²',0),(291752,8105,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð½Ð¾Ð²Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð·Ð±Ð¾Ð³ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(291753,8105,'vi','Báº¯t Ä‘áº§u nÄƒm má»›i cho thuáº¿',0),(291754,8105,'af','Begin Nuwe Jaar vir Belastings',0),(291755,8105,'ro','ÃŽncepe noul an pentru impozite',0),(291756,8105,'et','Alusta uut aastat maksude',0),(291757,8105,'si','ZaÄetek novega leta za davke',0),(291758,8105,'ba','Memulai tahun baru untuk pajak',0),(291759,8105,'nl','Start New jaar voor belastingen',0),(291760,8105,'fi','Aloita uusi vuosi veroja',0),(291761,8105,'no','Start nyttÃ¥r For skatt',0),(291762,8105,'da','Start nytÃ¥r For afgifter',0),(291763,8105,'ko','ì„¸ê¸ˆì— ëŒ€ í•œ ìƒˆ í•´ë¥¼ ì‹œìž‘',0),(291764,8105,'he','×”×ª×—×œ ×©× ×ª ×ž×¡ ×—×“×©×”',0),(291765,8105,'el','ÎžÎµÎºÎ¹Î½Î®ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ Î­Ï„Î¿Ï‚ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï†ÏŒÏÎ¿Ï…Ï‚',0),(291766,8105,'zh','å¼€å§‹æ–°çš„ç¨Žå¹´\r\n',0),(291767,8105,'sv','Starta nya Ã¥ret fÃ¶r skatter',0),(291768,8105,'it','Iniziare il nuovo anno per le tasse',0),(291769,8105,'tl','',0),(291770,8105,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3611;&#3637;&#3651;&#3627;&#3617;&#3656;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3616;&#3634;&#3625;&#3637;',0),(291771,8105,'hi','à¤•à¤°à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¯à¤¾ à¤¸à¤¾à¤² à¤¶à¥à¤°à¥‚',0),(291772,8105,'ms','Memulakan tahun baru bagi cukai',0),(291773,8105,'ar','Ø¨Ø¯Ø¡ Ø§Ù„Ø¹Ø§Ù… Ø§Ù„Ø¬Ø¯ÙŠØ¯ Ù„Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(291774,8105,'fr','Commencer la nouvelle annÃ©e pour les impÃ´ts',0),(291775,8105,'jp','ç¨Žã®ãŸã‚ã®æ–°å¹´ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(291776,8105,'pt','ComeÃ§ar o ano novo para os impostos',0),(291777,8105,'ru','ÐÐ°Ñ‡Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(291778,8105,'es','Iniciar Nuevo Ejercicio Fiscal',0),(291779,8105,'de','Start neues Jahr fÃ¼r Steuern',0),(291780,8105,'en','Start New Year For Taxes',0),(291781,8106,'is','',0),(291782,8106,'dr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø®Ø§ØµÙŠ ',0),(291783,8106,'pr','Ù‡ÙŠÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø®Ø§ØµÙŠ ',0),(291784,8106,'tr','HiÃ§bir Ã¶zel satÄ±cÄ±',0),(291785,8106,'pl','Nie ma okreÅ›lonego dostawcy',0),(291786,8106,'bg','ÐÑÐ¼Ð° ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚ÐµÐ½ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(291787,8106,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø®ØµÙˆØµ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(291788,8106,'sr','ÐÐµÐ¼Ð° Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(291789,8106,'vi','KhÃ´ng cÃ³ ngÆ°á»i bÃ¡n cá»¥ thá»ƒ',0),(291790,8106,'af','Geen Spesifieke Verskaffer',0),(291791,8106,'ro','Nici un furnizor specifice',0),(291792,8106,'et','Ei ole kindla hankija',0),(291793,8106,'si','Ni doloÄenega dobavitelja',0),(291794,8106,'ba','Tidak ada Vendor tertentu',0),(291795,8106,'nl','Geen specifieke leverancier',0),(291796,8106,'fi','Tietyn toimittajan',0),(291797,8106,'no','Ingen bestemt leverandÃ¸r',0),(291798,8106,'da','Ingen specifik leverandÃ¸r',0),(291799,8106,'ko','ì•„ë‹ˆ íŠ¹ì • ê³µê¸‰ ì—…ì²´',0),(291800,8106,'he','××™×Ÿ ×¡×¤×§ ×¡×¤×¦×™×¤×™',0),(291801,8106,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(291802,8106,'zh','æ²¡æœ‰ç‰¹å®šçš„ä¾›åº”å•†\r\n',0),(291803,8106,'sv','Ingen specifik leverantÃ¶r',0),(291804,8106,'it','Nessun fornitore specifico',0),(291805,8106,'tl','',0),(291806,8106,'th','&#3652;&#3617;&#3656;&#3619;&#3632;&#3610;&#3640;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(291807,8106,'hi','à¤•à¥‹à¤ˆ à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(291808,8106,'ms','Tiada pembekal tertentu',0),(291809,8106,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…ÙˆØ±Ø¯ Ù…Ø­Ø¯Ø¯',0),(291810,8106,'fr','Aucun fournisseur spÃ©cifique',0),(291811,8106,'jp','ç‰¹å®šãƒ™ãƒ³ãƒ€ãƒ¼',0),(291812,8106,'pt','Nenhum fornecedor especÃ­fico',0),(291813,8106,'ru','ÐÐµÑ‚ ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ð¾Ð³Ð¾ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(291814,8106,'es','No Proveedor EspecÃ­fico',0),(291815,8106,'de','Keine bestimmten Kreditor',0),(291816,8106,'en','No Specific Vendor',0),(291817,8107,'is','',0),(291818,8107,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(291819,8107,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(291820,8107,'tr','PO Amt',0),(291821,8107,'pl','UrzÄ…d PO',0),(291822,8107,'bg','PO Amt',0),(291823,8107,'ur','Ù¾Ùˆ Ø§Ù…Ù¹',0),(291824,8107,'sr','ÐŸÐž Ð Ð•Ð¤. Ð’Ð°Ð».',0),(291825,8107,'vi','Sá»‘ tiá»n trÃªn Ä‘Æ¡n mua hÃ ng',0),(291826,8107,'af','Posbus Amt',0),(291827,8107,'ro','PO Amt',0),(291828,8107,'et','PO Amt',0),(291829,8107,'si','PO Amt',0),(291830,8107,'ba','PO Amt',0),(291831,8107,'nl','PO Amt',0),(291832,8107,'fi','PO Amt',0),(291833,8107,'no','PO Amt',0),(291834,8107,'da','PO Amt',0),(291835,8107,'ko','í¬ Amt',0),(291836,8107,'he','×¤×• Amt',0),(291837,8107,'el','Amt Î±Î½Î¬',0),(291838,8107,'zh','è®¢å•é‡‘é¢\r\n',0),(291839,8107,'sv','PO Amt',0),(291840,8107,'it','PO Amt',0),(291841,8107,'tl','',0),(291842,8107,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(291843,8107,'hi','PO Amt',0),(291844,8107,'ms','PO Amt',0),(291845,8107,'ar','Ø¨Ùˆ Amt',0),(291846,8107,'fr','Amt PO',0),(291847,8107,'jp','PO Amt',0),(291848,8107,'pt','PO Amt',0),(291849,8107,'ru','PO Amt',0),(291850,8107,'es','OC Monto',0),(291851,8107,'de','PO-Amt',0),(291852,8107,'en','PO Amt',0),(291853,8108,'is','',0),(291854,8108,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ â€“ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙˆÙŠØ±Ø§ÙŠØ´ Ù…Ù‚Ø§Ø¯ÙŠØ± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  Ù†ÙŠØ³Øª',0),(291855,8108,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ â€“ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙˆÙŠØ±Ø§ÙŠØ´ Ù…Ù‚Ø§Ø¯ÙŠØ± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  Ù†ÙŠØ³Øª',0),(291856,8108,'tr','OluÅŸturulan, PO PO tutarlarÄ± dÃ¼zenleyemezsiniz',0),(291857,8108,'pl','PO stworzony, nie moÅ¼na edytowaÄ‡ PO iloÅ›ci',0),(291858,8108,'bg','PO ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½, Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ PO ÑÑƒÐ¼Ð¸',0),(291859,8108,'ur','Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§, Ù¾Ùˆ Ù¾Ùˆ Ù…Ù‚Ø¯Ø§Ø± Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(291860,8108,'sr','ÐŸÐž ÐºÑ€ÐµÐ¸Ñ€Ð°Ð¾, Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°Ñ‚Ð¸ ÐŸÐž Ð¸Ð·Ð½Ð¾ÑÐ¸',0),(291861,8108,'vi','ÄÆ¡n Mua HÃ ng Ä‘Ã£ táº¡o, KhÃ´ng thá»ƒ sá»­a sá»‘ lÆ°á»£ng ÄÆ¡n Mua HÃ ng',0),(291862,8108,'af','Posbus geskep, Posbus bedrae kan redigeer',0),(291863,8108,'ro','PO creat, nu se poate edita PO sumele',0),(291864,8108,'et','PO loonud, ei saa redigeerida PO summad',0),(291865,8108,'si','PO ustvaril, ne morete urejati PO zneskih',0),(291866,8108,'ba','PO dibuat, tidak dapat mengedit jumlah PO',0),(291867,8108,'nl','PO gemaakt, bewerken niet PO bedragen',0),(291868,8108,'fi','PO luotu, ei voi muokata PO mÃ¤Ã¤rÃ¤t',0),(291869,8108,'no','PO opprettet, kan ikke redigere PO belÃ¸p',0),(291870,8108,'da','PO lavet, kan ikke redigere PO belÃ¸b',0),(291871,8108,'ko','ìƒì„±, PO PO ê¸ˆì•¡ì„ íŽ¸ì§‘í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(291872,8108,'he','×¤×• ×™×¦×¨, ××™×Ÿ ××¤×©×¨×•×ª ×œ×¢×¨×•×š ××ª ×›×ž×•×™×•×ª ×¤×•',0),(291873,8108,'el','PO Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ, Î´ÎµÎ½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ PO Ï€Î¿ÏƒÎ¬',0),(291874,8108,'zh','åˆ›å»ºé‡‡è´­è®¢å•ï¼Œè®¢å•é‡‘é¢ä¸èƒ½ç¼–è¾‘\r\n',0),(291875,8108,'sv','PO skapade, inte kan redigera PO',0),(291876,8108,'it','PO creato, non Ã¨ possibile modificare la quantitÃ  di PO',0),(291877,8108,'tl','',0),(291878,8108,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3626;&#3633;&#3657;&#3591;&#3595;&#3639;&#3657;&#3629; &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3649;&#3585;&#3657;&#3652;&#3586;&#3592;&#3635;&#3609;&#3623;&#',0),(291879,8108,'hi','à¤¬à¤¨à¤¾à¤¯à¤¾, à¤ªà¥‹ à¤ªà¥‹ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(291880,8108,'ms','PO yang dicipta, tidak boleh Edit PO jumlah',0),(291881,8108,'ar','Ø¨Ùˆ Ø¨Ø¥Ù†Ø´Ø§Ø¦Ù‡ØŒ Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø¨Ùˆ',0),(291882,8108,'fr','PO crÃ©Ã©, impossible de modifier les montants PO',0),(291883,8108,'jp','ä½œæˆã€PO PO é‡ã¯ç·¨é›†ã§ãã¾ã›ã‚“ã€‚',0),(291884,8108,'pt','PO criado, nÃ£o Ã© possÃ­vel editar valores de PO',0),(291885,8108,'ru','PO ÑÐ¾Ð·Ð´Ð°Ð½, Ð½ÐµÐ»ÑŒÐ·Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ PO ÑÑƒÐ¼Ð¼Ñ‹',0),(291886,8108,'es','OC Creado, No se Puede Editar Los Montos del OC',0),(291887,8108,'de','Erstellt, PO kÃ¶nnen nicht PO BetrÃ¤ge bearbeitet werden',0),(291888,8108,'en','PO Created, Cannot Edit PO Amounts',0),(291889,8109,'is','',0),(291890,8109,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(291891,8109,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(291892,8109,'tr','VarsayÄ±lan satÄ±cÄ±',0),(291893,8109,'pl','DomyÅ›lny dostawca',0),(291894,8109,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(291895,8109,'ur','Ø·Û’ Ø´Ø¯Û ÙØ±ÙˆØ´Ù†Ø¯Û',0),(291896,8109,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(291897,8109,'vi','NgÆ°á»i bÃ¡n Máº·c Ä‘á»‹nh',0),(291898,8109,'af','Verstekte Verskaffer',0),(291899,8109,'ro','Furnizor implicit',0),(291900,8109,'et','Vaikimisi hankija',0),(291901,8109,'si','Privzetega dobavitelja',0),(291902,8109,'ba','Default Vendor',0),(291903,8109,'nl','Standaard leverancier',0),(291904,8109,'fi','Oletustoimittaja',0),(291905,8109,'no','StandardleverandÃ¸r',0),(291906,8109,'da','StandardleverandÃ¸ren',0),(291907,8109,'ko','ê¸°ë³¸ ê³µê¸‰ ì—…ì²´',0),(291908,8109,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×”×¡×¤×§',0),(291909,8109,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®Ï‚',0),(291910,8109,'zh','é»˜è®¤ä¾›åº”å•†',0),(291911,8109,'sv','StandardleverantÃ¶r',0),(291912,8109,'it','Fornitore predefinito',0),(291913,8109,'tl','',0),(291914,8109,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(291915,8109,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(291916,8109,'ms','Penjual lalai',0),(291917,8109,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø§ï»¹ÙØªØ±Ø§Ø¶ÙŠ',0),(291918,8109,'fr','Fournisseur par dÃ©faut',0),(291919,8109,'jp','æ—¢å®šã®ä»•å…¥å…ˆ',0),(291920,8109,'pt','Fornecedor padrÃ£o',0),(291921,8109,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº',0),(291922,8109,'es','Proveedor por Defecto',0),(291923,8109,'de','Standardlieferant',0),(291924,8109,'en','Default Vendor',0),(291925,8110,'is','',0),(291926,8110,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(291927,8110,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(291928,8110,'tr','Miktar Ã¼zerinde PO',0),(291929,8110,'pl','IloÅ›Ä‡ na PO',0),(291930,8110,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾ ÐžÐŸ',0),(291931,8110,'ur','Ù¾ÙˆØ³Ù¹ Ù¾Ø± Ù‚ÛŒ',0),(291932,8110,'sr','ÐšÐ¾Ð» Ð½Ð° Ð¿Ð¾-Ð°',0),(291933,8110,'vi','Sá»‘ lÆ°á»£ng trÃªn Ä‘Æ¡n mua hÃ ng',0),(291934,8110,'af','Hoev. Op AB',0),(291935,8110,'ro','Cantit PO',0),(291936,8110,'et','Tk PO',0),(291937,8110,'si','KoliÄina na PO',0),(291938,8110,'ba','Qty pada PO',0),(291939,8110,'nl','Aantal op PO',0),(291940,8110,'fi','MÃ¤Ã¤rÃ¤ PO',0),(291941,8110,'no','Ant pÃ¥ PO',0),(291942,8110,'da','Antal pÃ¥ PO',0),(291943,8110,'ko','í¬ì— ìˆ˜ëŸ‰',0),(291944,8110,'he','×›×ž×•×ª-×¤×•',0),(291945,8110,'el','Î Î¿Ïƒ / Ï„Î± ÏƒÎµ PO',0),(291946,8110,'zh','è®¢å•ä¸Šçš„æ•°é‡\r\n',0),(291947,8110,'sv','Antal pÃ¥ PO',0),(291948,8110,'it','Qty sul PO',0),(291949,8110,'tl','',0),(291950,8110,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3629;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(291951,8110,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥‹ à¤ªà¤°',0),(291952,8110,'ms','Qty pada PO',0),(291953,8110,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© ÙÙŠ Ø¨Ùˆ',0),(291954,8110,'fr','Qty sur PO',0),(291955,8110,'jp','PO ã®æ•°é‡',0),(291956,8110,'pt','Qty em PO',0),(291957,8110,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð½Ð° PO',0),(291958,8110,'es','Cant. en OC',0),(291959,8110,'de','Qty am PO',0),(291960,8110,'en','Qty On PO',0),(291961,8111,'is','',0),(291962,8111,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(291963,8111,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(291964,8111,'tr','Ä°stek PO',0),(291965,8111,'pl','Wniosek PO',0),(291966,8111,'bg','Ð˜ÑÐºÐ°Ð½Ðµ PO',0),(291967,8111,'ur','Ù¾Ùˆ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø±ÛŒÚº',0),(291968,8111,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² ÐŸÐž',0),(291969,8111,'vi','YÃªu cáº§u Ä‘Æ¡n mua hÃ ng',0),(291970,8111,'af','Versoek PO',0),(291971,8111,'ro','Cerere PO',0),(291972,8111,'et','Taotluse PO',0),(291973,8111,'si','Zahtevo PO',0),(291974,8111,'ba','Permintaan PO',0),(291975,8111,'nl','Verzoek PO',0),(291976,8111,'fi','PyytÃ¤Ã¤ PO',0),(291977,8111,'no','ForespÃ¸rsel PO',0),(291978,8111,'da','Anmodning PO',0),(291979,8111,'ko','ìš”ì²­ í¬',0),(291980,8111,'he','×‘×§×©×” ×¤×•',0),(291981,8111,'el','Î‘Î¯Ï„Î·ÏƒÎ· PO',0),(291982,8111,'zh','è¯·æ±‚é‡‡è´­è®¢å•\r\n',0),(291983,8111,'sv','BegÃ¤ran PO',0),(291984,8111,'it','Richiesta PO',0),(291985,8111,'tl','',0),(291986,8111,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(291987,8111,'hi','PO à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(291988,8111,'ms','Permintaan PO',0),(291989,8111,'ar','Ø·Ù„Ø¨ Ø¨Ùˆ',0),(291990,8111,'fr','Demande PO',0),(291991,8111,'jp','PO ã‚’è¦æ±‚ã—ã¾ã™ã€‚',0),(291992,8111,'pt','SolicitaÃ§Ã£o de PO',0),(291993,8111,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð¿Ð¾',0),(291994,8111,'es','Solicitar OC',0),(291995,8111,'de','Anfrage PO',0),(291996,8111,'en','Request PO',0),(291997,8112,'is','',0),(291998,8112,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(291999,8112,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(292000,8112,'tr','Arka sipariÅŸler',0),(292001,8112,'pl','ZamÃ³wienia',0),(292002,8112,'bg','ÐÐµÐ¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(292003,8112,'ur','Ù¾ÛŒÙ¹Ú¾ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(292004,8112,'sr','ÐÐ°Ð³Ð¾Ð¼Ð¸Ð»Ð°Ð½Ð¾Ð³',0),(292005,8112,'vi','ÄÆ¡n HÃ ng ChÆ°a Thá»±c Hiá»‡n Ngay',0),(292006,8112,'af','Terugwerkende Bestelllings',0),(292007,8112,'ro','ÃŽnapoi ordinele',0),(292008,8112,'et','JÃ¤reltellimused',0),(292009,8112,'si','Nazaj nalogi',0),(292010,8112,'ba','Pemesanan Kembali',0),(292011,8112,'nl','Nabestellingen',0),(292012,8112,'fi','JÃ¤lkitoimitukset',0),(292013,8112,'no','Restordrer',0),(292014,8112,'da','Restordrer',0),(292015,8112,'ko','ë‹¤ì‹œ ì£¼ë¬¸',0),(292016,8112,'he','×’×‘ ×”×–×ž× ×•×ª',0),(292017,8112,'el','Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(292018,8112,'zh','ç¼ºè´§é€šçŸ¥å•\r\n',0),(292019,8112,'sv','Tillbaka order',0),(292020,8112,'it','Ordini arretrati',0),(292021,8112,'tl','',0),(292022,8112,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3627;&#3621;&#3633;&#3591;',0),(292023,8112,'hi','à¤ªà¥€à¤  à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(292024,8112,'ms','Perintah-perintah kembali',0),(292025,8112,'ar','Ø£ÙˆØ§Ù…Ø± Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ±Ø§Ø¡',0),(292026,8112,'fr','Commandes en souffrance',0),(292027,8112,'jp','ãƒãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼',0),(292028,8112,'pt','Pedidos',0),(292029,8112,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(292030,8112,'es','Pedidos en Espera',0),(292031,8112,'de','Nachlieferungen',0),(292032,8112,'en','Back Orders',0),(292033,8113,'is','',0),(292034,8113,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(292035,8113,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(292036,8113,'tr','EdilmemiÅŸ sipariÅŸ listeleri',0),(292037,8113,'pl','Wykaz zamÃ³wienia',0),(292038,8113,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð½ÐµÐ¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(292039,8113,'ur','ÙˆØ§Ù¾Ø³ Ø­Ú©Ù… Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(292040,8113,'sr','Ð›Ð¸ÑÑ‚Ðµ ÑÐ° Ð½Ð°Ð³Ð¾Ð¼Ð¸Ð»Ð°Ð½Ð¾Ð³',0),(292041,8113,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng chÆ°a thá»±c hiá»‡n ngay',0),(292042,8113,'af','Lyste van Terugverwysende Bestellings',0),(292043,8113,'ro','Liste cu ordinele de spate',0),(292044,8113,'et','Loendite jÃ¤reltellimused',0),(292045,8113,'si','Seznami nalogi',0),(292046,8113,'ba','Daftar Pesanan Kembali(BO)',0),(292047,8113,'nl','Lijsten van backorders',0),(292048,8113,'fi','Luettelo jÃ¤lkitoimitukset',0),(292049,8113,'no','Lister over restordrer',0),(292050,8113,'da','Lister over restordrer',0),(292051,8113,'ko','ë‹¤ì‹œ ì£¼ë¬¸ ëª©ë¡',0),(292052,8113,'he','×¨×©×™×ž×•×ª ×©×œ ×¤×§×•×“×•×ª ×”××—×•×¨×™',0),(292053,8113,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Î±Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(292054,8113,'zh','å»¶æœŸäº¤è´§åˆ—è¡¨\r\n',0),(292055,8113,'sv','Listor Ã¶ver restorder',0),(292056,8113,'it','Elenchi di ordini arretrati',0),(292057,8113,'tl','',0),(292058,8113,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3617;&#3634;&#3607;&#3637;&#3656;&#3627;&#3621;&#3633;&#3591;',0),(292059,8113,'hi','à¤ªà¥€à¤  à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(292060,8113,'ms','Senarai pesanan belakang',0),(292061,8113,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(292062,8113,'fr','Listes de commandes en souffrance',0),(292063,8113,'jp','ãƒãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼ã®ãƒªã‚¹ãƒˆ',0),(292064,8113,'pt','Listas de pedidos',0),(292065,8113,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(292066,8113,'es','Listas de Pedidos en Espera',0),(292067,8113,'de','Listen von Nachlieferungen',0),(292068,8113,'en','Lists of Back Orders',0),(292069,8114,'is','',0),(292070,8114,'dr','(Ø³Ø§Ø¨Ù‚Ù‡) ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(292071,8114,'pr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ø«Ø¨Øª (Ø³Ø§Ø¨Ù‚Ù‡) ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(292072,8114,'tr','GÃ¶nderilen hiÃ§bir kayÄ±t kodu',0),(292073,8114,'pl','Nie identyfikator rekordu wysÅ‚ane',0),(292074,8114,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾ Ð˜Ð” Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(292075,8114,'ur','Ú©ÙˆØ¦ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø´Ù†Ø§Ø®Øª Ù†ÛÛŒÚº Ø¨Ú¾ÛŒØ¬Ø§',0),(292076,8114,'sr','ÐÐµÐ¼Ð° Ð·Ð°Ð¿Ð¸ÑÐ° Ð˜Ð” Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(292077,8114,'vi','ChÆ°a gá»­i ID há»“ sÆ¡',0),(292078,8114,'af','Geen Rekord ID Gestuur',0),(292079,8114,'ro','Nici o Ã®nregistrare ID-ul trimis',0),(292080,8114,'et','Puudub kirje ID saadetud',0),(292081,8114,'si','Ni zapisa ID poÅ¡lje',0),(292082,8114,'ba','Ada catatan ID dikirim',0),(292083,8114,'nl','Geen Record-ID verzonden',0),(292084,8114,'fi','Ei lÃ¤hettÃ¤nyt Tietuetunnus',0),(292085,8114,'no','Ingen oppfÃ¸rings-ID sendt',0),(292086,8114,'da','Ingen post-id sendt',0),(292087,8114,'ko','ë ˆì½”ë“œ ID ì „ì†¡',0),(292088,8114,'he','×œ× ×ž×–×”×” ×¨×©×•×ž×” ×©×œ×—',0),(292089,8114,'el','Î§Ï‰ÏÎ¯Ï‚ Ï„Î±Ï…Ï„ÏŒÏ„Î·Ï„Î± ÏÎµÎºÏŒÏ Ï€Î¿Ï… Î­ÏƒÏ„ÎµÎ¹Î»Îµ',0),(292090,8114,'zh','æ²¡æœ‰å‘é€è®°å½•ID\r\n',0),(292091,8114,'sv','Inget post-ID som skickas',0),(292092,8114,'it','Nessun ID Record inviati',0),(292093,8114,'tl','',0),(292094,8114,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3619;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;',0),(292095,8114,'hi','à¤•à¥‹à¤ˆ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ ID à¤­à¥‡à¤œà¥€',0),(292096,8114,'ms','Tiada ID nota yang dihantar',0),(292097,8114,'ar','Ù„Ù… ÙŠØªÙ… Ø¥Ø±Ø³Ø§Ù„ Ø£ÙŠ Ù…Ø¹Ø±Ù Ø³Ø¬Ù„',0),(292098,8114,'fr','Aucun Record ID envoyÃ©',0),(292099,8114,'jp','é€ä¿¡ã•ã‚Œã‚‹ãƒ¬ã‚³ãƒ¼ãƒ‰ ID ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(292100,8114,'pt','NÃ£o hÃ¡ registro ID enviada',0),(292101,8114,'ru','ÐÐµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(292102,8114,'es','No se EnvÃ­o Record ID',0),(292103,8114,'de','Kein Datensatz-ID gesendet',0),(292104,8114,'en','No Record ID Sent',0),(292105,8115,'is','',0),(292106,8115,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†ÙˆØ¹ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ØªØ¹ÙŠÙŠÙ† ÙƒÙ†ÙŠØ¯ ',0),(292107,8115,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†ÙˆØ¹ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ØªØ¹ÙŠÙŠÙ† ÙƒÙ†ÙŠØ¯ ',0),(292108,8115,'tr','Not tÃ¼rÃ¼nÃ¼ belirtmeniz gerekir',0),(292109,8115,'pl','NaleÅ¼y okreÅ›liÄ‡ typ Uwaga',0),(292110,8115,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑƒÐºÐ°Ð¶ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(292111,8115,'ur','Ø¢Ù¾ Ù†Û’ Ù†ÙˆÙ¹ Ú©ÛŒ Ø§ÛŒÚ© Ù‚Ø³Ù… Ú©Ø§ Ø§Ø®ØªØµØ§Øµ Ú©Ø±ÛŒÚº',0),(292112,8115,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð½Ð°Ð²ÐµÑÑ‚Ð¸ Ñ‚Ð¸Ð¿ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(292113,8115,'vi','Báº¡n pháº£i chá»n 1 loáº¡i ghi chÃº',0),(292114,8115,'af','U moet \'n NOTATIPE spesifiseer.',0),(292115,8115,'ro','Trebuie sÄƒ specificaÈ›i un tip de nota',0),(292116,8115,'et','Te peate sisestama mÃ¤rke tÃ¼Ã¼bi',0),(292117,8115,'si','DoloÄite vrsto Opomba',0),(292118,8115,'ba','Anda harus menentukan jenis catatan',0),(292119,8115,'nl','U moet een Type opmerking opgeven',0),(292120,8115,'fi','MÃ¤Ã¤ritÃ¤ Huomautustyyppi',0),(292121,8115,'no','Du mÃ¥ angi en merknadstypen',0),(292122,8115,'da','Du skal angive en Note',0),(292123,8115,'ko','ì°¸ê³  í˜•ì‹ì„ ì§€ì • í•´ì•¼',0),(292124,8115,'he','×¢×œ×™×š ×œ×¦×™×™×Ÿ ×¡×•×’ ×”×¢×¨×”',0),(292125,8115,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎºÎ±Î¸Î¿ÏÎ¯ÏƒÎµÏ„Îµ Î­Î½Î±Î½ Ï„ÏÏ€Î¿ Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(292126,8115,'zh','æ‚¨å¿…é¡»æŒ‡å®šä¸€ä¸ªæ³¨æ˜Žç±»åž‹\r\n',0),(292127,8115,'sv','Du mÃ¥ste ange en Obs-typ.',0),(292128,8115,'it','Ãˆ necessario specificare un tipo di nota',0),(292129,8115,'tl','',0),(292130,8115,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3619;&#3632;&#3610;&#3640;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(292131,8115,'hi','à¤¤à¥à¤® à¤à¤• à¤¨à¥‹à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(292132,8115,'ms','Anda mesti menetapkan jenis Nota',0),(292133,8115,'ar','Ù„Ø§Ø¨Ø¯ Ù…Ù† ØªØ­Ø¯ÙŠØ¯ Ù†ÙˆØ¹ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø©',0),(292134,8115,'fr','Vous devez spÃ©cifier un type de nnote',0),(292135,8115,'jp','æ³¨è¨˜ã®ã‚¿ã‚¤ãƒ—ã‚’æŒ‡å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(292136,8115,'pt','VocÃª deve especificar um tipo de nota',0),(292137,8115,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ ÑƒÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(292138,8115,'es','Debe especificar un tipo de nota',0),(292139,8115,'de','Sie mÃ¼ssen einen Hinweis-Typ angeben.',0),(292140,8115,'en','You Must Specify a Note Type',0),(292141,8116,'is','',0),(292142,8116,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(292143,8116,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(292144,8116,'tr','Hata not ekleme',0),(292145,8116,'pl','BÅ‚Ä…d dodawania Uwaga',0),(292146,8116,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(292147,8116,'ur','Ù†Ù‚Øµ Ù†ÙˆÙ¹ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’',0),(292148,8116,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(292149,8116,'vi','ThÃªm ghi chÃº bá»‹ lá»—i',0),(292150,8116,'af','Fout voeg Nota',0),(292151,8116,'ro','Eroare de AdÄƒugare notÄƒ',0),(292152,8116,'et','MÃ¤rke lisamisel tekkis viga',0),(292153,8116,'si','Napaka pri dodajanju Opomba',0),(292154,8116,'ba','Kesalahan menambahkan catatan',0),(292155,8116,'nl','Fout toe te voegen Opmerking',0),(292156,8116,'fi','LisÃ¤Ã¤ huomautus',0),(292157,8116,'no','Feil Ã¥ legge Merk',0),(292158,8116,'da','Fejl tilfÃ¸je BemÃ¦rk',0),(292159,8116,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì°¸ê³ ',0),(292160,8116,'he','×©×’×™××” ×”×•×¡×¤×ª ×”×¢×¨×”',0),(292161,8116,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ†Î¬Î»Î¼Î±',0),(292162,8116,'zh','é”™è¯¯ï¼šæ–°å¢žæ³¨\r\n',0),(292163,8116,'sv','Fel att lÃ¤gga till anteckning',0),(292164,8116,'it','Nota aggiunta di errore',0),(292165,8116,'tl','',0),(292166,8116,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;',0),(292167,8116,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¨à¥‹à¤Ÿ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(292168,8116,'ms','Ralat menambah Nota',0),(292169,8116,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø©',0),(292170,8116,'fr','Erreur ajout de Note',0),(292171,8116,'jp','ã‚¨ãƒ©ãƒ¼ã‚’è¿½åŠ ã™ã‚‹ã“ã¨æ³¨',0),(292172,8116,'pt','Erro Adicionar nota',0),(292173,8116,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(292174,8116,'es','Error Agregando Nota',0),(292175,8116,'de','Fehler hinzufÃ¼gen Hinweis',0),(292176,8116,'en','Error Adding Note',0),(292177,8117,'is','',0),(292178,8117,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(292179,8117,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(292180,8117,'tr','Not baÅŸarÄ±yla eklendi',0),(292181,8117,'pl','Uwaga dodany pomyÅ›lnie',0),(292182,8117,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(292183,8117,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ù†ÙˆÙ¹',0),(292184,8117,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(292185,8117,'vi','ThÃªm Ghi ChÃº thÃ nh cÃ´ng',0),(292186,8117,'af','Nota\'s suksesvol bygevoeg',0),(292187,8117,'ro','NotÄƒ adÄƒugat cu succes',0),(292188,8117,'et','MÃ¤rkus on lisatud edukalt',0),(292189,8117,'si','Opomba je dodana uspeÅ¡no',0),(292190,8117,'ba','Catatan ditambahkan berhasil',0),(292191,8117,'nl','Opmerking toegevoegd',0),(292192,8117,'fi','Huomautuksen lisÃ¤Ã¤minen onnistui',0),(292193,8117,'no','Merk lagt',0),(292194,8117,'da','BemÃ¦rk tilfÃ¸jet',0),(292195,8117,'ko','ì°¸ê³  ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(292196,8117,'he','×”×¢×¨×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(292197,8117,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(292198,8117,'zh','è¯´æ˜Žæ·»åŠ æˆåŠŸ\r\n',0),(292199,8117,'sv','Obs lagts',0),(292200,8117,'it','Nota aggiunto con successo',0),(292201,8117,'tl','',0),(292202,8117,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(292203,8117,'hi','à¤¨à¥‹à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(292204,8117,'ms','Nota yang berjaya menambah',0),(292205,8117,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(292206,8117,'fr','Note ajoutÃ©e avec succÃ¨s',0),(292207,8117,'jp','ãƒ¡ãƒ¢æ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(292208,8117,'pt','Nota adicionada com sucesso',0),(292209,8117,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(292210,8117,'es','Nota actualizada exitosamente',0),(292211,8117,'de','Hinweis erfolgreich hinzugefÃ¼gt',0),(292212,8117,'en','Note Added Successfully',0),(292213,8118,'is','',0),(292214,8118,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(292215,8118,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(292216,8118,'tr','Not baÅŸarÄ±yla silindi',0),(292217,8118,'pl','Uwaga przesâ”‚anie',0),(292218,8118,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(292219,8118,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù†ÙˆÙ¹',0),(292220,8118,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(292221,8118,'vi','XÃ³a Ghi ChÃº thÃ nh cÃ´ng',0),(292222,8118,'af','Nota Suksesvol Geskrap',0),(292223,8118,'ro','NotÄƒ eliminÄƒ cu succes',0),(292224,8118,'et','MÃ¤rkus edukalt kustutatud',0),(292225,8118,'si','Opomba izbrisani uspeÅ¡no',0),(292226,8118,'ba','Catatan dihapus berhasil',0),(292227,8118,'nl','Opmerking met succes verwijderd',0),(292228,8118,'fi','Huomautus poistettu',0),(292229,8118,'no','Merk slettet',0),(292230,8118,'da','BemÃ¦rk slettet',0),(292231,8118,'ko','ì°¸ê³  ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(292232,8118,'he','×”×¢×¨×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(292233,8118,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(292234,8118,'zh','è¯´æ˜Žåˆ é™¤æˆåŠŸ\r\n',0),(292235,8118,'sv','Obs raderades',0),(292236,8118,'it','Nota eliminato con successo',0),(292237,8118,'tl','',0),(292238,8118,'th','&#3621;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(292239,8118,'hi','à¤¨à¥‹à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(292240,8118,'ms','Nota dihapuskan dengan jayanya',0),(292241,8118,'ar','Ø­Ø°ÙØª Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(292242,8118,'fr','Note supprimÃ© avec succÃ¨s',0),(292243,8118,'jp','ãƒ¡ãƒ¢æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(292244,8118,'pt','Nota apagada com sucesso',0),(292245,8118,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½Ð°',0),(292246,8118,'es','Nota eliminada exitosamente',0),(292247,8118,'de','Hinweis erfolgreich gelÃ¶scht',0),(292248,8118,'en','Note Deleted Successfully',0),(292249,8119,'is','',0),(292250,8119,'dr','Ù†ÙˆØ¹ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(292251,8119,'pr','Ù†ÙˆØ¹ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(292252,8119,'tr','Not tÃ¼rÃ¼ yok',0),(292253,8119,'pl','Uwaga typ nie istnieje',0),(292254,8119,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° Ð¢Ð¸Ð¿ÑŠÑ‚ Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(292255,8119,'ur','Ù†ÙˆÙ¹ Ú©ÛŒ Ù‚Ø³Ù… Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(292256,8119,'sr','ÐÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ñ‚Ð¸Ð¿ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(292257,8119,'vi','Loáº¡i ghi chÃº khÃ´ng cÃ³',0),(292258,8119,'af','Die Nota Tipe Bestaan Nie',0),(292259,8119,'ro','Tipul de notÃ£ nu exista',0),(292260,8119,'et','MÃ¤rkuse tÃ¼Ã¼p pole olemas',0),(292261,8119,'si','Opomba vrsta ne obstaja',0),(292262,8119,'ba','Jenis catatan tidak ada',0),(292263,8119,'nl','Het Type opmerking bestaat niet',0),(292264,8119,'fi','Huomautus tyyppiÃ¤ ei ole olemassa',0),(292265,8119,'no','Merknadstypen finnes ikke',0),(292266,8119,'da','BemÃ¦rk Type findes ikke',0),(292267,8119,'ko','ì°¸ê³  í˜•ì‹ì´ ì¡´ìž¬ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(292268,8119,'he','×¡×•×’ ×”×”×¢×¨×” ×œ× ×§×™×™×',0),(292269,8119,'el','ÎŸ Ï„ÏÏ€Î¿Ï‚ ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ· Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹',0),(292270,8119,'zh','æ³¨é‡Šç±»åž‹ä¸å­˜åœ¨\r\n',0),(292271,8119,'sv','Noteringstypens finns inte',0),(292272,8119,'it','Il tipo di nota non esiste',0),(292273,8119,'tl','',0),(292274,8119,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(292275,8119,'hi','à¤¨à¥‹à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(292276,8119,'ms','Jenis Nota tidak wujud',0),(292277,8119,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ù†ÙˆØ¹ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(292278,8119,'fr','Le Type de Note n\'existe pas',0),(292279,8119,'jp','ãƒ¡ãƒ¢åž‹ã¯å­˜åœ¨ã—ã¾ã›ã‚“',0),(292280,8119,'pt','O tipo de nota nÃ£o existe',0),(292281,8119,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ Ñ‚Ð¸Ð¿ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(292282,8119,'es','El Tipo de Nota No Existe',0),(292283,8119,'de','Der Hinweis-Typ ist nicht vorhanden.',0),(292284,8119,'en','The Note Type Does Not Exist',0),(292285,8120,'is','',0),(292286,8120,'dr','/ Ø§ÙØ²ÙˆØ¯Ù† / Ø­Ø°Ù ',0),(292287,8120,'pr','Ù†Ù…Ø§ÙŠØ´ / Ø§ÙØ²ÙˆØ¯Ù† / Ø­Ø°Ù ',0),(292288,8120,'tr','GÃ¶rÃ¼nÃ¼m/Ekle/Sil',0),(292289,8120,'pl','Zobacz/Dodaj/UsuÅ„',0),(292290,8120,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´/Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(292291,8120,'ur','Ù…Ù†Ø¸Ø±/Ø§ Ø¶Ø§ÙÛ/Ø­Ø°Ù',0),(292292,8120,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·/Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð±Ñ€Ð¸ÑÐ°ÑšÐµ',0),(292293,8120,'vi','Xem/ThÃªm/XÃ³a',0),(292294,8120,'af','Besigtig/Skep/Skrap',0),(292295,8120,'ro','Vezi/Adauga/Sterge',0),(292296,8120,'et','Vaata/Lisa/Kustuta',0),(292297,8120,'si','Pogled/dodajanje/brisanje',0),(292298,8120,'ba','Lihat/Tambahkan/Hapus',0),(292299,8120,'nl','Weergave/toevoegen/verwijderen',0),(292300,8120,'fi','NÃ¤ytÃ¤/lisÃ¤tÃ¤/poistaa',0),(292301,8120,'no','Vise/legge til/slette',0),(292302,8120,'da','Se/TilfÃ¸j/slet',0),(292303,8120,'ko','ë³´ê¸°/ì¶”ê°€/ì‚­ì œ',0),(292304,8120,'he','×ª×¦×•×’×”/×”×•×¡×¤×”/×ž×—×™×§×”',0),(292305,8120,'el','Î ÏÎ¿Î²Î¿Î»Î®/Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(292306,8120,'zh','æŸ¥çœ‹/æ·»åŠ /åˆ é™¤\r\n',0),(292307,8120,'sv','Visa/lÃ¤gga till/ta bort',0),(292308,8120,'it','Vista/aggiungere/eliminare',0),(292309,8120,'tl','',0),(292310,8120,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;/&#3648;&#3614;&#3636;&#3656;&#3617;/&#3621;&#3610;',0),(292311,8120,'hi','à¤¦à¥ƒà¤¶à¥à¤¯/à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¹à¤Ÿà¤¾à¤à¤',0),(292312,8120,'ms','Pemandangan/menambah/memadam',0),(292313,8120,'ar','Ø¹Ø±Ø¶/Ø¥Ø¶Ø§ÙØ©/Ø­Ø°Ù',0),(292314,8120,'fr','Afficher/Ajouter/supprimer',0),(292315,8120,'jp','è¡¨ç¤º/è¿½åŠ /å‰Šé™¤',0),(292316,8120,'pt','Ver/Adicionar/apagar',0),(292317,8120,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ/Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ',0),(292318,8120,'es','Visionar/Agregar/Eliminar',0),(292319,8120,'de','Anzeigen/hinzufÃ¼gen/lÃ¶schen',0),(292320,8120,'en','View/Add/Delete',0),(292321,8121,'is','',0),(292322,8121,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒÙ¾ÙŠ ÙØ§ÙŠÙ„ Ù¾Ø´ØªÙŠØ¨Ø§Ù†  Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(292323,8121,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒÙ¾ÙŠ ÙØ§ÙŠÙ„ Ù¾Ø´ØªÙŠØ¨Ø§Ù†  Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(292324,8121,'tr','VeritabanÄ±nÄ±n yedek kopyasÄ±nÄ± indirmek',0),(292325,8121,'pl','Pobierz kopiÄ™ zapasowÄ… bazy danych',0),(292326,8121,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° Ð°Ñ€Ñ…Ð¸Ð²Ð½Ð¾ ÐºÐ¾Ð¿Ð¸Ðµ Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸',0),(292327,8121,'ur','ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©ÛŒ Ù¾Ø´ØªØ§Ø±Û Ù†Ù‚Ù„ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(292328,8121,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¼Ð¸Ñ‚Ðµ Ñ€ÐµÐ·ÐµÑ€Ð²Ð½Ñƒ ÐºÐ¾Ð¿Ð¸Ñ˜Ñƒ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(292329,8121,'vi','Táº£i dá»¯ liá»‡u dá»± phÃ²ng',0),(292330,8121,'af','Laai Reserwekopie van Databasis af',0),(292331,8121,'ro','Drum liber copie de rezervÄƒ a bazei de date',0),(292332,8121,'et','Lae alla andmebaasi varukoopia',0),(292333,8121,'si','Download varnostno kopijo zbirke podatkov',0),(292334,8121,'ba','Download salinan cadangan dari Database',0),(292335,8121,'nl','Downloaden van de back-up van de Database',0),(292336,8121,'fi','Imuroi varmuuskopion tietokannasta',0),(292337,8121,'no','Last ned sikkerhetskopi av Database',0),(292338,8121,'da','DataoverfÃ¸re sikkerhedskopi af databasen',0),(292339,8121,'ko','ë°ì´í„°ë² ì´ìŠ¤ì˜ ë°±ì—… ë³µì‚¬ë³¸ì„ ë‹¤ìš´ë¡œë“œ',0),(292340,8121,'he','×”×•×¨×“ ×¢×•×ª×§ ×’×™×‘×•×™ ×©×œ ×ž×¡×“ ×”× ×ª×•× ×™×',0),(292341,8121,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚ Ï„Î·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(292342,8121,'zh','ä¸‹è½½æ•°æ®åº“çš„å¤‡ä»½å‰¯æœ¬\r\n',0),(292343,8121,'sv','HÃ¤mta sÃ¤kerhetskopia av databasen',0),(292344,8121,'it','Scarica la copia di Backup del Database',0),(292345,8121,'tl','',0),(292346,8121,'th','&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3649;&#3610;&#3621;&#3655;&#3588;&#3629;&#3633;&#3614;&#3586;&#3629;&#3591;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(292347,8121,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¥€ à¤¬à¥ˆà¤•à¤…à¤ª à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(292348,8121,'ms','Muat turun salinan sandaran pangkalan data',0),(292349,8121,'ar','ØªÙ†Ø²ÙŠÙ„ Ù†Ø³Ø®Ø© Ø§Ø­ØªÙŠØ§Ø·ÙŠØ© Ù…Ù† Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(292350,8121,'fr','TÃ©lÃ©charger la copie de sauvegarde de base de donnÃ©es',0),(292351,8121,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã®ãƒãƒƒã‚¯ã‚¢ãƒƒãƒ— ã‚³ãƒ”ãƒ¼ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(292352,8121,'pt','Baixar cÃ³pia de Backup do banco de dados',0),(292353,8121,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ Ñ€ÐµÐ·ÐµÑ€Ð²Ð½ÑƒÑŽ ÐºÐ¾Ð¿Ð¸ÑŽ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(292354,8121,'es','Descargar CÃ³pia de Respaldo de la Base de datos',0),(292355,8121,'de','Download Backup-Kopie der Datenbank',0),(292356,8121,'en','Download Backup Copy Of Database',0),(292357,8122,'is','',0),(292358,8122,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ ',0),(292359,8122,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ ',0),(292360,8122,'tr','Kargo Ã¼creti',0),(292361,8122,'pl','OpÅ‚aty za przesyÅ‚ki',0),(292362,8122,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(292363,8122,'ur','Ú†Ø§Ø±Ø¬ Ø´Ù¾Ù†Ú¯',0),(292364,8122,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(292365,8122,'vi','PhÃ­ váº­n chuyá»ƒn',0),(292366,8122,'af','Ladingskoste',0),(292367,8122,'ro','Taxa de transport maritim',0),(292368,8122,'et','Laevandus tasuta',0),(292369,8122,'si','Ladijski promet odgovoren',0),(292370,8122,'ba','Biaya pengiriman',0),(292371,8122,'nl','Verzendkosten',0),(292372,8122,'fi','Rahtikuluja',0),(292373,8122,'no','Frakt kostnader',0),(292374,8122,'da','Leveringsgebyr',0),(292375,8122,'ko','ìš´ì†¡ ìš”ê¸ˆ',0),(292376,8122,'he','×¢×œ×•×ª ×”×ž×©×œ×•×—',0),(292377,8122,'el','ÎšÎŸÎ£Î¤ÎŸÎ£ Î‘Î ÎŸÎ£Î¤ÎŸÎ›Î—Î£',0),(292378,8122,'zh','è¿è´¹\r\n',0),(292379,8122,'sv','Fraktkostnad',0),(292380,8122,'it','Le spese di spedizione',0),(292381,8122,'tl','',0),(292382,8122,'th','&#3588;&#3636;&#3604;&#3588;&#3656;&#3634;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(292383,8122,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤¶à¥à¤²à¥à¤•',0),(292384,8122,'ms','Caj penghantaran',0),(292385,8122,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø´Ø­Ù†',0),(292386,8122,'fr','Les frais de livraison',0),(292387,8122,'jp','é…é€æ–™',0),(292388,8122,'pt','Taxa de envio',0),(292389,8122,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(292390,8122,'es','Carga de EnvÃ­os',0),(292391,8122,'de','Versandkosten',0),(292392,8122,'en','Shipping Charge',0),(292393,8123,'is','',0),(292394,8123,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙŠÙ„ Ù¾Ø´ØªÙŠØ¨Ø§Ù† Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(292395,8123,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙŠÙ„ Ù¾Ø´ØªÙŠØ¨Ø§Ù† Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(292396,8123,'tr','VeritabanÄ± yedek dosyasÄ± oluÅŸturulurken hata oluÅŸtu',0),(292397,8123,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas tworzenia kopii zapasowej pliku bazy danych',0),(292398,8123,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð°Ñ€Ñ…Ð¸Ð²ÐµÐ½ Ñ„Ð°Ð¹Ð» DB',0),(292399,8123,'ur','Ù†Ù‚Øµ DB Ù¾Ø´ØªØ§Ø±Û Ù…Ø³Ù„ Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’',0),(292400,8123,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ñ€ÐµÐ·ÐµÑ€Ð²Ð½Ðµ ÐºÐ¾Ð¿Ð¸Ñ˜Ðµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð·Ð° Ð¿Ð°',0),(292401,8123,'vi','File backup bá»‹ lá»—i',0),(292402,8123,'af','Fout onstaan met skepping van DB RugsteuningslÃªer (Reserwekopie) ',0),(292403,8123,'ro','Eroare la crearea fiÅŸier copie de rezervÄƒ DB',0),(292404,8123,'et','Andmebaasi varukoopia faili loomisel ilmnes tÃµrge',0),(292405,8123,'si','Napaka pri ustvarjanju varnostne kopije DB',0),(292406,8123,'ba','Error membuat DB Backup File',0),(292407,8123,'nl','Fout bij het maken van back-upbestand DB',0),(292408,8123,'fi','Virhe luotaessa tietokannan varmuuskopiointi',0),(292409,8123,'no','Feil under oppretting av DB sikkerhetskopifilen',0),(292410,8123,'da','Fejl under oprettelse af DB Backup fil',0),(292411,8123,'ko','DB ë°±ì—… íŒŒì¼ ë§Œë“¤ê¸° ì˜¤ë¥˜',0),(292412,8123,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×§×•×‘×¥ ×’×™×‘×•×™ DB',0),(292413,8123,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î±Î½Ï„Î¹Î³ÏÎ¬Ï†Î¿Ï… Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚ Ï„Î¿Ï… Î±ÏÏ‡ÎµÎ¯Î¿Ï… DB',0),(292414,8123,'zh','åˆ›å»ºæ•°æ®åº“å¤‡ä»½æ–‡ä»¶æ—¶å‡ºé”™\r\n',0),(292415,8123,'sv','Fel vid skapande av DB Backup-fil',0),(292416,8123,'it','Errore durante la creazione di File di Backup DB',0),(292417,8123,'tl','',0),(292418,8123,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3652;&#3615;&#3621;&#3660;&#3626;&#3635;&#3619;&#3629;&#3591;&#3586;&#3629;&#3591;&#3',0),(292419,8123,'hi','DB à¤¬à¥ˆà¤•à¤…à¤ª à¤«à¤¼à¤¾à¤‡à¤² à¤¬à¤¨à¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(292420,8123,'ms','Ralat mencipta fail sandaran DB',0),(292421,8123,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ Ù…Ù„Ù Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠ DB',0),(292422,8123,'fr','Erreur de crÃ©ation du fichier de sauvegarde DB',0),(292423,8123,'jp','DB ãƒãƒƒã‚¯ã‚¢ãƒƒãƒ— ãƒ•ã‚¡ã‚¤ãƒ«ã®ä½œæˆã‚¨ãƒ©ãƒ¼',0),(292424,8123,'pt','Erro ao criar arquivo de Backup DB',0),(292425,8123,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ Ñ„Ð°Ð¹Ð»Ð° Ñ€ÐµÐ·ÐµÑ€Ð²Ð½Ð¾Ð¹ ÐºÐ¾Ð¿Ð¸Ð¸ Ð‘Ð”',0),(292426,8123,'es','Error Creando BD Archivo de Resapldo',0),(292427,8123,'de','Fehler beim Erstellen des DB-Backup-Datei',0),(292428,8123,'en','Error Creating DB Backup File',0),(292429,8124,'is','',0),(292430,8124,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø¯Ù…Ø§Øª ÙƒØ§Ù…Ù„ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(292431,8124,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®Ø¯Ù…Ø§Øª ÙƒØ§Ù…Ù„ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(292432,8124,'tr','DeÄŸil tam hizmet kurulumlarÄ±',0),(292433,8124,'pl','UsÅ‚uga konfiguracji nie kompletny',0),(292434,8124,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð° Ð½Ðµ Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸',0),(292435,8124,'ur','Ø®Ø¯Ù…Øª Ø³ÛŒÙ¹Ùˆ Ù…Ú©Ù…Ù„ Ù†ÛÛŒÚº',0),(292436,8124,'sr','Ð£ÑÐ»ÑƒÐ³Ð° Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐ° Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾',0),(292437,8124,'vi','Setup Dá»‹ch vá»¥ chÆ°a hoÃ n táº¥t',0),(292438,8124,'af','Diens Opstellings Nie Voltooi',0),(292439,8124,'ro','Serviciu setup nu Complete',0),(292440,8124,'et','Teenuse seadistuse lÃµpule',0),(292441,8124,'si','Storitev postavitve ni mogoÄe dokonÄati',0),(292442,8124,'ba','Layanan setup tidak lengkap',0),(292443,8124,'nl','Service Setups voltooien niet',0),(292444,8124,'fi','Palvelun asetuksia ei suoritettu loppuun',0),(292445,8124,'no','Tjenesten oppsett fullfÃ¸rt ikke',0),(292446,8124,'da','Service opsÃ¦tninger komplet ikke',0),(292447,8124,'ko','ì„œë¹„ìŠ¤ ì„¤ì •ì„ ì™„ë£Œ í•˜ì§€',0),(292448,8124,'he','×©×™×¨×•×ª Setups ×œ× ×”×•×©×œ×ž×”',0),(292449,8124,'el','Î¡Ï…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ Î´ÎµÎ½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(292450,8124,'zh','æœåŠ¡è®¾ç½®æœªå®Œæˆ\r\n',0),(292451,8124,'sv','TjÃ¤nsten uppstÃ¤llningar slutfÃ¶ra inte',0),(292452,8124,'it','Servizio configurazioni non completata',0),(292453,8124,'tl','',0),(292454,8124,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3652;&#3617;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(292455,8124,'hi','à¤¸à¥‡à¤µà¤¾ Setups à¤ªà¥‚à¤°à¥à¤£ à¤¨à¤¹à¥€à¤‚',0),(292456,8124,'ms','Perkhidmatan Setups tidak lengkap',0),(292457,8124,'ar','Ù„Ø§ ØªÙƒØªÙ…Ù„ Ø§Ù„Ø®Ø¯Ù…Ø© Ø¹Ù„Ù‰ Ø§Ù„Ø£Ø¬Ù‡Ø²Ø©',0),(292458,8124,'fr','Pas toutes les configurations de service',0),(292459,8124,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã‚’å®Œäº†ã§ãã¾ã›ã‚“ã€‚',0),(292460,8124,'pt','As configuraÃ§Ãµes de serviÃ§o nÃ£o concluÃ­do',0),(292461,8124,'ru','ÐžÐ±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¾Ðº Ð½Ðµ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°',0),(292462,8124,'es','Configuraciones de Servicio No Son Completas',0),(292463,8124,'de','Service-Setups vervollstÃ¤ndigen nicht',0),(292464,8124,'en','Service Setups Not Complete',0),(292465,8125,'is','',0),(292466,8125,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(292467,8125,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(292468,8125,'tr','Bunu silmek istediÄŸinizden emin misiniz',0),(292469,8125,'pl','Czy na pewno chcesz usunÄ…Ä‡',0),(292470,8125,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ‚Ð¾Ð²Ð°',0),(292471,8125,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ÛŒÛ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº',0),(292472,8125,'sr','Ð”Ð° Ð»Ð¸ ÑÑ‚Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ð¾Ð²Ð¾',0),(292473,8125,'vi','XÃ³a?',0),(292474,8125,'af','Is u seker u wil hierdie skrap?',0),(292475,8125,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ ÅŸtergeÅ£i acest lucru',0),(292476,8125,'et','Oled kindel, et soovid seda kustutada',0),(292477,8125,'si','Ali ste prepriÄani, da Å¾elite izbrisati to',0),(292478,8125,'ba','Apakah Anda yakin Anda ingin menghapus ini',0),(292479,8125,'nl','Weet u zeker dat u wilt verwijderen van dit',0),(292480,8125,'fi','Oletko varma, ettÃ¤ haluat poistaa tÃ¤mÃ¤n',0),(292481,8125,'no','Er du sikker pÃ¥ at du vil slette denne',0),(292482,8125,'da','Er du sikker pÃ¥ du vil slette denne',0),(292483,8125,'ko','ë‹¹ì‹ ì€ ì´ê²ƒì„ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ',0),(292484,8125,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ××ª ×–×”',0),(292485,8125,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒ',0),(292486,8125,'zh','æ‚¨ç¡®å®šè¦åˆ é™¤æ­¤\r\n',0),(292487,8125,'sv','Ã„r du sÃ¤ker du vill ta bort detta',0),(292488,8125,'it','Sei sicuro di che voler cancellare questo',0),(292489,8125,'tl','',0),(292490,8125,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;&#3626;&#3636;&#3656;&#3591;&#3609;&#3637;&#3657;?',0),(292491,8125,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(292492,8125,'ms','Adakah anda pasti hendak menghapuskan ini',0),(292493,8125,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¥Ù„ØºØ§Ø¡ Ù‡Ø°Ø§ ',0),(292494,8125,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer cet Ã©lÃ©ment',0),(292495,8125,'jp','ã“ã‚Œã‚’å‰Šé™¤ã™ã‚‹ã‚ˆã‚ã—ã„ã§ã™ã€‚',0),(292496,8125,'pt','Tem certeza que deseja excluir este',0),(292497,8125,'ru','Ð’Ñ‹ Ð£Ð²ÐµÑ€ÐµÐ½Ñ‹ Ð§Ñ‚Ð¾ Ð’Ñ‹ Ð¥Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð­Ñ‚Ð¾ Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ',0),(292498,8125,'es','Â¿Esta Seguro que Quiere Eliminar Ã‰ste?',0),(292499,8125,'de','Bist du sicher, dass Sie diese lÃ¶schen mÃ¶chten',0),(292500,8125,'en','Are You Sure You Want To Delete This',0),(292501,8126,'is','',0),(292502,8126,'dr','Ø§ÙƒÙ†ÙˆÙ† Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯  ',0),(292503,8126,'pr','Ø§ÙƒÙ†ÙˆÙ† Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯  ',0),(292504,8126,'tr','Åžimdi gemi',0),(292505,8126,'pl','Statek',0),(292506,8126,'bg','ÐšÐ¾Ñ€Ð°Ð±ÑŠÑ‚ ÑÐµÐ³Ð°',0),(292507,8126,'ur','Ø§Ø¨ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²',0),(292508,8126,'sr','Ð‘Ñ€Ð¾Ð´ Ñ˜Ðµ ÑÐ°Ð´Ð°',0),(292509,8126,'vi','Chuyá»ƒn bÃ¢y giá»',0),(292510,8126,'af','Versend Nou',0),(292511,8126,'ro','Nava acum',0),(292512,8126,'et','Saatke kohe',0),(292513,8126,'si','Ladje zdaj',0),(292514,8126,'ba','Kirim Sekarang',0),(292515,8126,'nl','Schip nu',0),(292516,8126,'fi','LÃ¤hetÃ¤ nyt',0),(292517,8126,'no','Lever nÃ¥',0),(292518,8126,'da','Skibet nu',0),(292519,8126,'ko','ì§€ê¸ˆ ë°œì†¡',0),(292520,8126,'he','×”×¡×¤×™× ×” ×¢×›×©×™×•',0),(292521,8126,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(292522,8126,'zh','çŽ°åœ¨è¿é€\r\n',0),(292523,8126,'sv','Fartyget nu',0),(292524,8126,'it','Nave ora',0),(292525,8126,'tl','',0),(292526,8126,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(292527,8126,'hi','à¤…à¤¬ à¤œà¤¹à¤¾à¤œ',0),(292528,8126,'ms','Kapal sekarang',0),(292529,8126,'ar','Ø¥Ø´Ø­Ù† Ø§Ù„Ø¢Ù†',0),(292530,8126,'fr','ExpÃ©diez maintenant',0),(292531,8126,'jp','ä»Šèˆ¹',0),(292532,8126,'pt','Navio agora',0),(292533,8126,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ñ‚ÐµÐ¿ÐµÑ€ÑŒ',0),(292534,8126,'es','Enviar Ahora',0),(292535,8126,'de','Schiff jetzt',0),(292536,8126,'en','Ship Now',0),(292537,8127,'is','',0),(292538,8127,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(292539,8127,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(292540,8127,'tr','Arka sipariÅŸler',0),(292541,8127,'pl','ZamÃ³wienia',0),(292542,8127,'bg','ÐÐµÐ¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(292543,8127,'ur','Ù¾ÛŒÙ¹Ú¾ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(292544,8127,'sr','ÐÐ°Ð³Ð¾Ð¼Ð¸Ð»Ð°Ð½Ð¾Ð³',0),(292545,8127,'vi','ÄÆ¡n HÃ ng ChÆ°a Thá»±c Hiá»‡n Ngay',0),(292546,8127,'af','Terugwerkende Bestelllings',0),(292547,8127,'ro','ÃŽnapoi ordinele',0),(292548,8127,'et','JÃ¤reltellimused',0),(292549,8127,'si','Nazaj nalogi',0),(292550,8127,'ba','Pemesanan Kembali',0),(292551,8127,'nl','Nabestellingen',0),(292552,8127,'fi','JÃ¤lkitoimitukset',0),(292553,8127,'no','Restordrer',0),(292554,8127,'da','Restordrer',0),(292555,8127,'ko','ë‹¤ì‹œ ì£¼ë¬¸',0),(292556,8127,'he','×’×‘ ×”×–×ž× ×•×ª',0),(292557,8127,'el','Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(292558,8127,'zh','å»¶æœŸäº¤è´§\r\n',0),(292559,8127,'sv','Tillbaka order',0),(292560,8127,'it','Ordini arretrati',0),(292561,8127,'tl','',0),(292562,8127,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3627;&#3621;&#3633;&#3591;',0),(292563,8127,'hi','à¤ªà¥€à¤  à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(292564,8127,'ms','Perintah-perintah kembali',0),(292565,8127,'ar','Ø£ÙˆØ§Ù…Ø± Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ±Ø§Ø¡',0),(292566,8127,'fr','Commandes en souffrance',0),(292567,8127,'jp','ãƒãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼',0),(292568,8127,'pt','Pedidos',0),(292569,8127,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(292570,8127,'es','Pedidos en Espera',0),(292571,8127,'de','Nachlieferungen',0),(292572,8127,'en','Back Orders',0),(292573,8128,'is','',0),(292574,8128,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ú¯Ø´ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(292575,8128,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ú¯Ø´ØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(292576,8128,'tr','Geri sipariÅŸ vermeyen bulundu',0),(292577,8128,'pl','Nie znaleziono zamÃ³wienia',0),(292578,8128,'bg','ÐÐµ Ð½ÐµÐ¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(292579,8128,'ur','Ú©ÙˆØ¦ÛŒ Ù¾ÛŒÙ¹Ú¾ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…Ù„Û’',0),(292580,8128,'sr','ÐÐµÐ¼Ð° Ð½Ð°Ð³Ð¾Ð¼Ð¸Ð»Ð°Ð½Ð¾Ð³ Ð½Ð°ÑˆÐ°Ð¾',0),(292581,8128,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n hÃ ng chÆ°a thá»¥c hiá»‡n ngay',0),(292582,8128,'af','Geen Teruggehoue/Agterstallige Bestellings Gevind',0),(292583,8128,'ro','Comenzi spate gÄƒsit',0),(292584,8128,'et','Ei leidnud jÃ¤reltellimused',0),(292585,8128,'si','Ni nalogi naÅ¡el',0),(292586,8128,'ba','Kembali perintah tidak ditemukan',0),(292587,8128,'nl','Geen backorders gevonden',0),(292588,8128,'fi','Takaisin tilauksia ei lÃ¶ytynyt',0),(292589,8128,'no','Ingen restordrer funnet',0),(292590,8128,'da','Ingen restordrer fundet',0),(292591,8128,'ko','ì•„ë‹ˆ ë‹¤ì‹œ ì£¼ë¬¸ì„ ë°œê²¬í•©ë‹ˆë‹¤',0),(292592,8128,'he','×¤×§×•×“×•×ª ×”××—×•×¨×™ × ×ž×¦×',0),(292593,8128,'el','Î”ÎµÎ½ Î±Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(292594,8128,'zh','æœªæ‰¾åˆ°å»¶æœŸäº¤è´§\r\n',0),(292595,8128,'sv','Inga restorder hittade',0),(292596,8128,'it','Nessun ordini arretrati trovati',0),(292597,8128,'tl','',0),(292598,8128,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3618;&#3657;&#3629;&#3609;&#3627;&#3621;&#3633;&#3591;',0),(292599,8128,'hi','à¤•à¥‹à¤ˆ à¤µà¤¾à¤ªà¤¸ à¤†à¤¦à¥‡à¤¶ à¤ªà¤¾à¤¯à¤¾',0),(292600,8128,'ms','Tiada arahan belakang yang ditemui',0),(292601,8128,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙˆØ§Ù…Ø± Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ ÙˆØ¬Ø¯Øª',0),(292602,8128,'fr','Aucune commande dos trouvÃ©',0),(292603,8128,'jp','ã„ã„ãˆãƒãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(292604,8128,'pt','Pedidos nÃ£o encontrados',0),(292605,8128,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(292606,8128,'es','No se EncontrÃ³ Ordenes Postergados',0),(292607,8128,'de','Keine Nachlieferungen gefunden',0),(292608,8128,'en','No Back Orders Found',0),(292609,8129,'is','',0),(292610,8129,'dr','Ù‡ÙŠÚ† Ø¨Ø§Ø±ÙƒØ¯ÙŠ Ø±ÙˆÙŠ ÙØ§ÙƒØªÙˆØ± Ù†ÙŠØ³Øª ',0),(292611,8129,'pr','Ù‡ÙŠÚ† Ø¨Ø§Ø±ÙƒØ¯ÙŠ Ø±ÙˆÙŠ ÙØ§ÙƒØªÙˆØ± Ù†ÙŠØ³Øª ',0),(292612,8129,'tr','Fatura Ã¼zerindeki Bar kod',0),(292613,8129,'pl','Nie ma kodu kreskowego na fakturze',0),(292614,8129,'bg','ÐÑÐ¼Ð° Ñ‰Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(292615,8129,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù¾Ø± Ú©ÙˆØ¦ÛŒ Ø¨Ø§Ø± Ø¶Ø§Ø¨Ø·Û',0),(292616,8129,'sr','ÐÐµÐ¼Ð° Ð‘Ð°Ñ€ ÐºÐ¾Ð´Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(292617,8129,'vi','KhÃ´ng MÃ£ váº¡ch trÃªn hÃ³a Ä‘Æ¡n',0),(292618,8129,'af','Geen Strepieskode Op Faktuur',0),(292619,8129,'ro','Nici un cod de bare pe facturÄƒ',0),(292620,8129,'et','No vÃ¶Ã¶tkoodi arvel',0),(292621,8129,'si','Brez Ärtne kode na raÄun',0),(292622,8129,'ba','Tidak ada kode Bar pada faktur',0),(292623,8129,'nl','Geen streepjescode op factuur',0),(292624,8129,'fi','Ei viivakoodia laskussa',0),(292625,8129,'no','Ingen strekkode pÃ¥ faktura',0),(292626,8129,'da','Ingen stregkode pÃ¥ fakturaen',0),(292627,8129,'ko','ì†¡ìž¥ì— ë°” ì½”ë“œ ì—†ìŒ',0),(292628,8129,'he','××™×Ÿ ×‘×¨×§×•×“ ×¢×œ ×—×©×‘×•× ×™×ª',0),(292629,8129,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Î³ÏÎ±Î¼Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(292630,8129,'zh','å‘ç¥¨ä¸Šæ²¡æœ‰æ¡å½¢ç \r\n',0),(292631,8129,'sv','Ingen streckkod pÃ¥ faktura',0),(292632,8129,'it','Nessun codice a barre sulla fattura',0),(292633,8129,'tl','',0),(292634,8129,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3610;&#3634;&#3619;&#3660;&#3650;&#3588;&#3657;&#3604;&#3610;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(292635,8129,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤ªà¤° à¤•à¥‹à¤ˆ à¤¬à¤¾à¤° à¤•à¥‹à¤¡',0),(292636,8129,'ms','Tiada Kod Bar pada invois',0),(292637,8129,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø±Ù…Ø² Ø´Ø±ÙŠØ·ÙŠ ÙÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(292638,8129,'fr','Aucun Code Ã  barres sur la facture',0),(292639,8129,'jp','è«‹æ±‚æ›¸ã«ãƒãƒ¼ ã‚³ãƒ¼ãƒ‰ãªã—',0),(292640,8129,'pt','Sem cÃ³digo de barra na fatura',0),(292641,8129,'ru','ÐÐµÑ‚ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´Ð° Ð½Ð° ÑÑ‡ÐµÑ‚',0),(292642,8129,'es','No Hay CÃ³digo de Barras En La Factura',0),(292643,8129,'de','Kein Barcode auf Rechnung',0),(292644,8129,'en','No Bar Code On Invoice',0),(292645,8130,'is','',0),(292646,8130,'dr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ',0),(292647,8130,'pr','Ù„ÙŠØ³Øª ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ',0),(292648,8130,'tr','Arka parÃ§a listesi iÃ§in sipariÅŸ',0),(292649,8130,'pl','Kopii zamÃ³wionych pozycji listy',0),(292650,8130,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ Ð¾ÑÑŠÐ´ÐµÐ½ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð°',0),(292651,8130,'ur','Ø´Û’ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’ Ø­Ú©Ù… Ø¯ÛŒØ§ Ú©Û ÙˆØ§Ù¾Ø³',0),(292652,8130,'sr','Ð—Ð°Ð´ÑšÐ° Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾ ÑÑ‚Ð°Ð²ÐºÐµ Ð»Ð¸ÑÑ‚Ðµ Ð·Ð°',0),(292653,8130,'vi','Danh Má»¥c HÃ ng Cho ÄÆ¡n HÃ ng ChÆ°a Thá»±c Hiá»‡n Ngay',0),(292654,8130,'af','Teruggehoue/Agterstallige Bestelling Itemslys Vir',0),(292655,8130,'ro','ÃŽnapoi articol comandat lista pentru',0),(292656,8130,'et','Tagasi tellitud kauba loend',0),(292657,8130,'si','Nazaj odredil element seznama za',0),(292658,8130,'ba','Kembali memerintahkan Item daftar untuk',0),(292659,8130,'nl','Terug besteld Item lijst voor',0),(292660,8130,'fi','Takaisin tilata tuotteen luettelo',0),(292661,8130,'no','Tilbake bestilte varen liste For',0),(292662,8130,'da','Back bestilt vare liste For',0),(292663,8130,'ko','ë‹¤ì‹œ ì£¼ë¬¸ í•­ëª©ì— ëŒ€ í•œ ëª©ë¡',0),(292664,8130,'he','×—×–×¨×” ×”×•×¨×” ×¤×¨×™×˜ ×¨×©×™×ž×”',0),(292665,8130,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Î±Î¾Î¹Î½Î¿Î¼Î·Î¼Î­Î½Î· Î»Î¯ÏƒÏ„Î± Î³Î¹Î±',0),(292666,8130,'zh','å¾…è¡¥é¡¹ç›®æ¸…å•å¦‚éœ€\r\n',0),(292667,8130,'sv','Tillbaka bestÃ¤llt objekt lista fÃ¶r',0),(292668,8130,'it','Torna a elenco per elemento ordinato',0),(292669,8130,'tl','',0),(292670,8130,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3626;&#3633;&#3656;&#3591;&#3605;&#3634;&#3617;&#3627;&#3621;&#3633;&#3591;&#3586;&#3629;&#3591;',0),(292671,8130,'hi','à¤µà¤¾à¤ªà¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‚à¤šà¥€ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾',0),(292672,8130,'ms','Belakang mengarahkan perkara senarai untuk',0),(292673,8130,'ar','Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ Ù‚Ø§Ø¦Ù…Ø© Ù„Ù…Ø±ØªØ¨Ø© Ø§Ù„Ø¨Ù†Ø¯',0),(292674,8130,'fr','Back Ordered article liste pour',0),(292675,8130,'jp','é †åºä»˜ã‘ã‚‰ã‚ŒãŸé …ç›®ã®ä¸€è¦§ã«æˆ»ã‚‹',0),(292676,8130,'pt','Back ordenado Item lista para',0),(292677,8130,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð» ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² ÑÐ¿Ð¸ÑÐºÐ° Ð´Ð»Ñ',0),(292678,8130,'es','Lista de Items de Pedido de Espera para',0),(292679,8130,'de','ZurÃ¼ck geordnete Artikel Liste fÃ¼r',0),(292680,8130,'en','Back Ordered Item List For',0),(292681,8131,'is','',0),(292682,8131,'dr','(Ø¨Ø±Ú¯Ø´Øª Ø§Ø² ÙØ±Ù…Ø§ÛŒØ´',0),(292683,8131,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ù…Ø¹ÙˆÙ‚(Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´',0),(292684,8131,'tr','Bekleyen sipariÅŸ Ã¶ÄŸeleri',0),(292685,8131,'pl','Elementy na zalegÅ‚ym zamÃ³wieniu',0),(292686,8131,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¿Ð¾ Ð½ÐµÐ¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(292687,8131,'ur','ÙˆØ§Ù¾Ø³ Ø­Ú©Ù… Ù¾Ø± Ø§Ø´ÛŒØ§',0),(292688,8131,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ»Ðµ Ð½Ð°Ñ€ÑƒÑ‡ÐµÐ½Ðµ',0),(292689,8131,'vi','Máº·t hÃ ng trÃªn Ä‘Æ¡n hÃ ng chÆ°a thá»±c hiá»‡n ngay',0),(292690,8131,'af','Items op Teruggehoue/Agterstallige Bestelling',0),(292691,8131,'ro','Punctele de pe ordinea spate',0),(292692,8131,'et','Hilinenud tÃ¤itmisel olevad Ã¼ksused',0),(292693,8131,'si','Elementov v nalogih',0),(292694,8131,'ba','Item pada Pemesanan',0),(292695,8131,'nl','Items op nabestelling',0),(292696,8131,'fi','Tuotteet jÃ¤lkitoimituksessa',0),(292697,8131,'no','Varer i restordre',0),(292698,8131,'da','Varer i restordre',0),(292699,8131,'ko','ë‹¤ì‹œ ì£¼ë¬¸ì— í•­ëª©',0),(292700,8131,'he','×¤×¨×™×˜×™× ×‘×ž×œ××™',0),(292701,8131,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÎµ Î±Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(292702,8131,'zh','é¡¹ç›®åœ¨ç¼ºè´§\r\n',0),(292703,8131,'sv','Objekt pÃ¥ restorder',0),(292704,8131,'it','Articoli su ordine posteriore',0),(292705,8131,'tl','',0),(292706,8131,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3619;&#3629;&#3610;&#3627;&#3621;&#3633;&#3591;',0),(292707,8131,'hi','à¤µà¤¾à¤ªà¤¸ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤Ÿà¤¿à¤•à¤Ÿ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤šà¤¾à¤°',0),(292708,8131,'ms','Item pada pesanan belakang',0),(292709,8131,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù… Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(292710,8131,'fr','Articles sur commande en diffÃ©rÃ©',0),(292711,8131,'jp','ãƒãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼ã®ã‚¢ã‚¤ãƒ†ãƒ ',0),(292712,8131,'pt','Itens em falta',0),(292713,8131,'ru','ÐŸÑƒÐ½ÐºÑ‚Ñ‹ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(292714,8131,'es','Items en Pedido Postergado',0),(292715,8131,'de','Elemente auf Nachlieferungs',0),(292716,8131,'en','Items On Back Order',0),(292717,8132,'is','',0),(292718,8132,'dr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(292719,8132,'pr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(292720,8132,'tr','Geri sipariÅŸ Ã¶ÄŸe bulunamadÄ±',0),(292721,8132,'pl','Nie z powrotem zamÃ³wione przedmioty znalezione',0),(292722,8132,'bg','ÐÐµ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾ Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(292723,8132,'ur','Ú©ÙˆØ¦ÛŒ Ù¾ÛŒÚ†Ú¾Û’ Ù¾Ø§Ø¦ÛŒ Ø¬Ø§Ù†Û’ ÙˆØ§Ù„ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§ Û”',0),(292724,8132,'sr','Ð—Ð°Ð´ÑšÐ¸ Ð½Ð°Ñ€ÐµÐ´Ð±Ð¸ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° Ð½Ð¸Ñ˜ÐµÐ´Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(292725,8132,'vi','KhÃ´ng tÃ¬m tháº¥y hÃ ng chÆ°a thá»¥c hiá»‡n ngay',0),(292726,8132,'af','Geen Teruggehoue/Agterstallige Bestellingsitems Gevind',0),(292727,8132,'ro','Nici o Ã®napoi comandate elemente gÄƒsite',0),(292728,8132,'et','Tagasi tellitud Ã¼ksusi ei leidu',0),(292729,8132,'si','Ni nazaj naloÅ¾i postavke, najti',0),(292730,8132,'ba','Kembali tidak memesan item yang ditemukan',0),(292731,8132,'nl','Geen terug bestelde Items gevonden',0),(292732,8132,'fi','Takaisin tilata kohteita ei lÃ¶ydy',0),(292733,8132,'no','Ingen ryggen bestilte varer funnet',0),(292734,8132,'da','Ingen tilbage bestilte varer fundet',0),(292735,8132,'ko','ë‹¤ì‹œ í’ˆëª© ë°œê²¬',0),(292736,8132,'he','×’×‘ ×”×•×¨×” ×¤×¨×™×˜×™× × ×ž×¦××•',0),(292737,8132,'el','Î”ÎµÎ½ Ï€Î¯ÏƒÏ‰ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¸Î­Î½Ï„Î± ÎµÎ¯Î´Î· Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(292738,8132,'zh','æœªæ‰¾åˆ°å¾…è¡¥çš„é¡¹ç›®\r\n',0),(292739,8132,'sv','Ingen tillbaka bestÃ¤llda artiklar Funna',0),(292740,8132,'it','Nessun Back ordinato oggetti trovati',0),(292741,8132,'tl','',0),(292742,8132,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3618;&#3657;&#3629;&#3609;&#3627;&#3621;&#3633;&#3591;',0),(292743,8132,'hi','à¤•à¥‹à¤ˆ à¤µà¤¾à¤ªà¤¸ à¤®à¤¿à¤²à¥‡ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾',0),(292744,8132,'ms','Tiada item disusun kembali yang ditemui',0),(292745,8132,'ar','Ù„Ø§ Ø§Ù„Ø¸Ù‡Ø± Ø£Ù…Ø±Øª Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„ØªÙŠ Ø¹Ø«Ø± Ø¹Ù„ÙŠÙ‡Ø§',0),(292746,8132,'fr','Aucun Back ne Ordered Ã©lÃ©ments trouvÃ©s',0),(292747,8132,'jp','ãƒãƒƒã‚¯é †åºä»˜ã‘ã‚‰ã‚ŒãŸé …ç›®ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(292748,8132,'pt','NÃ£o costas ordenou itens encontrados',0),(292749,8132,'ru','ÐÐµÑ‚ Ð·Ð°Ð´Ð½ÐµÐ¹ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð» Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(292750,8132,'es','No se EncontrÃ³ Items Postergados',0),(292751,8132,'de','Kein zurÃ¼ck bestellt EintrÃ¤ge gefunden',0),(292752,8132,'en','No Back Ordered Items Found',0),(292753,8133,'is','',0),(292754,8133,'dr','Ù†Ø³Ø®Ù‡ Ø¢Ù¾Ø§Ú†ÙŠ',0),(292755,8133,'pr','Ù†Ø³Ø®Ù‡ Ø¢Ù¾Ø§Ú†ÙŠ',0),(292756,8133,'tr','Apache sÃ¼rÃ¼mÃ¼',0),(292757,8133,'pl','Wersja Apache',0),(292758,8133,'bg','Apache Ð²ÐµÑ€ÑÐ¸Ñ',0),(292759,8133,'ur','Ø§Ù¾Ø§Ú†ÛŒ ÙˆØ±Ú˜Ù†',0),(292760,8133,'sr','ÐÐ¿Ð°Ñ†Ñ…Ðµ Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð°',0),(292761,8133,'vi','PhiÃªn Báº£n Apache',0),(292762,8133,'af','Apache Weergawe',0),(292763,8133,'ro','Apache versiunea',0),(292764,8133,'et','Apache versiooni',0),(292765,8133,'si','Apache prevod',0),(292766,8133,'ba','Versi Apache',0),(292767,8133,'nl','Apache versie',0),(292768,8133,'fi','Joutuisasti kÃ¤Ã¤nnÃ¶s',0),(292769,8133,'no','Apache versjon',0),(292770,8133,'da','Apache Version',0),(292771,8133,'ko','ì•„íŒŒì¹˜ ë²„ì „',0),(292772,8133,'he','××¤××¦\'×™ ×’×¨×¡×”',0),(292773,8133,'el','ÎˆÎºÎ´Î¿ÏƒÎ· Apache',0),(292774,8133,'zh','Apacheç‰ˆæœ¬\r\n',0),(292775,8133,'sv','Apache Version',0),(292776,8133,'it','Versione di Apache',0),(292777,8133,'tl','',0),(292778,8133,'th','&#3648;&#3623;&#3629;&#3619;&#3660;&#3594;&#3633;&#3656;&#3609; Apache',0),(292779,8133,'hi','Apache à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(292780,8133,'ms','Apache versi',0),(292781,8133,'ar','Ø¥ØµØ¯Ø§Ø± Ø£Ø¨Ø§ØªØ´ÙŠ',0),(292782,8133,'fr','Version d\'Apache',0),(292783,8133,'jp','Apache ã®ãƒãƒ¼ã‚¸ãƒ§ãƒ³',0),(292784,8133,'pt','Apache versÃ£o',0),(292785,8133,'ru','Ð’ÐµÑ€ÑÐ¸Ñ Apache',0),(292786,8133,'es','Apache VersiÃ³n',0),(292787,8133,'de','Apacheversion',0),(292788,8133,'en','Apache Version',0),(292789,8134,'is','',0),(292790,8134,'dr','Ø¢ÙŠØ§ Ø´Ù…Ø§ Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ø¯Ø³ØªÙŠØ§Ø¨Ù‰ Ø§Ø² Ø±Ø§Ù‡ Ø¯ÙˆØ± Ø¨Ù‡ Ø³Ø±ÙˆØ±ØªØ§Ù† Ø±Ø§ Ù…Ù‡ÙŠØ§ ÙƒÙ†ÙŠØ¯ØŸ',0),(292791,8134,'pr','Ø¢ÙŠØ§ Ø´Ù…Ø§ Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ø¯Ø³ØªÙŠØ§Ø¨Ù‰ Ø§Ø² Ø±Ø§Ù‡ Ø¯ÙˆØ± Ø¨Ù‡ Ø³Ø±ÙˆØ±ØªØ§Ù† Ø±Ø§ Ù…Ù‡ÙŠØ§ ÙƒÙ†ÙŠØ¯ØŸ',0),(292792,8134,'tr','Uzaktan eriÅŸim sunucunuza saÄŸlayabilir?',0),(292793,8134,'pl','UmoÅ¼liwiajÄ… zdalny dostÄ™p do serwera?',0),(292794,8134,'bg','ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð»Ð¸ Ð´Ð° Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¾Ñ‚Ð´Ð°Ð»ÐµÑ‡ÐµÐ½ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ð²Ð°ÑˆÐ¸Ñ ÑÑŠÑ€Ð²ÑŠÑ€?',0),(292795,8134,'ur','Ø¢Ù¾ Ø§Ù¾Ù†Û’ Ù¾ÛŒØ´ Ú©Ø§Ø± Ø³Û’ Ø¨Ø¹ÛŒØ¯ Ø±Ø³Ø§Ø¦ÛŒ Ù†ÛÛŒÚº ÙØ±Ø§ÛÙ… Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚºØŸ',0),(292796,8134,'sr','ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¿Ñ€ÑƒÐ¶Ð°Ñ‚Ðµ Ð´Ð°Ñ™Ð¸Ð½ÑÐºÐ¸ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð½Ð° Ð²Ð°Ñˆ Ð¡ÐµÑ€Ð²ÐµÑ€?',0),(292797,8134,'vi','Báº¡n cÃ³ thá»ƒ cung cáº¥p quyá»n truy cáº­p tá»« xa tá»›i mÃ¡y chá»§?',0),(292798,8134,'af','Kan u Afstandstoegang verskaf Na U Bediener?',0),(292799,8134,'ro','Poate vÄƒ asigurÄƒ accesul la Server?',0),(292800,8134,'et','Tooge kaugjuurdepÃ¤Ã¤su serverisse?',0),(292801,8134,'si','Lahko vam zakoten postranski v vaÅ¡ pomoÄnik?',0),(292802,8134,'ba','Dapatkah Anda memberikan akses Remote ke Server Anda?',0),(292803,8134,'nl','Kunt u externe toegang bieden aan uw Server?',0),(292804,8134,'fi','Kanisteri te ehkÃ¤istÃ¤ etÃ¤inen pÃ¤Ã¤sy palvelimelle?',0),(292805,8134,'no','Kan du gi ekstern tilgang til serveren?',0),(292806,8134,'da','Kan du give fjernadgang til din Server?',0),(292807,8134,'ko','ì„œë²„ì— ì›ê²© ì•¡ì„¸ìŠ¤ë¥¼ ì œê³µí•  ìˆ˜ ìžˆìŠµë‹ˆê¹Œ?',0),(292808,8134,'he','×”×× ××ª×” ×™×›×•×œ ×œ×¡×¤×§ ×’×™×©×” ×ž×¨×—×•×§ ×œ×©×¨×ª ×©×œ×š?',0),(292809,8134,'el','ÎÎ± Ï€Î±ÏÎ­Ï‡ÎµÏ„Îµ Î±Ï€Î¿Î¼Î±ÎºÏÏ…ÏƒÎ¼Î­Î½Î· Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÏ„Î¿Î½ ÎºÎµÎ½Ï„ÏÎ¹ÎºÏŒ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„Î® ÏƒÎ±Ï‚;',0),(292810,8134,'zh','ä½ èƒ½æä¾›è¿œç¨‹è®¿é—®æ‚¨çš„æœåŠ¡å™¨ï¼Ÿ\r\n',0),(292811,8134,'sv','Kan du ge fjÃ¤rrÃ¥tkomst till servern?',0),(292812,8134,'it','Potete fornire accesso remoto al Server?',0),(292813,8134,'tl','',0),(292814,8134,'th','&#3588;&#3640;&#3603;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3592;&#3633;&#3604;&#3651;&#3627;&#3657;&#3617;&#3637;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3648;&#3595;&#3636;&#3615;&#3648;&#3623;&#3629;&#3619;&#3660;&#3',0),(292815,8134,'hi','à¤†à¤ª à¤…à¤ªà¤¨à¥‡ à¤¸à¤°à¥à¤µà¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¥‚à¤°à¤¸à¥à¤¥ à¤ªà¤¹à¥à¤à¤š à¤ªà¥à¤°à¤¦à¤¾à¤¨ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(292816,8134,'ms','Bolehkah anda memberikan capaian jauh ke pelayan anda?',0),(292817,8134,'ar','ÙŠÙ…ÙƒÙ† ØªÙˆÙÙŠØ± Ø§Ù„ÙˆØµÙˆÙ„ Ø¹Ù† Ø¨Ø¹Ø¯ Ø¥Ù„Ù‰ Ø§Ù„Ø®Ø§Ø¯Ù… Ø§Ù„Ø®Ø§Øµ Ø¨ÙƒØŸ',0),(292818,8134,'fr','Pouvez-vous fournir un accÃ¨s distant Ã  votre serveur ?',0),(292819,8134,'jp','ã‚ãªãŸã®ã‚µãƒ¼ãƒãƒ¼ã«ãƒªãƒ¢ãƒ¼ãƒˆ ã‚¢ã‚¯ã‚»ã‚¹ã‚’æä¾›ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã‹ï¼Ÿ',0),(292820,8134,'pt','VocÃª pode fornecer acesso remoto ao seu servidor?',0),(292821,8134,'ru','ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð»Ð¸ Ð²Ñ‹ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½Ð½Ñ‹Ð¹ Ð´Ð¾ÑÑ‚ÑƒÐ¿ Ðº Ð²Ð°ÑˆÐµÐ¼Ñƒ ÑÐµÑ€Ð²ÐµÑ€Ñƒ?',0),(292822,8134,'es','Â¿Puede Proporcionar Acceso Remoto a su Servidor?',0),(292823,8134,'de','Bieten Ihnen Remote-Zugriff auf Ihren Server?',0),(292824,8134,'en','Can You Provide Remote Access To Your Server?',0),(292825,8135,'is','',0),(292826,8135,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø±ÙƒØª ',0),(292827,8135,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø±ÙƒØª ',0),(292828,8135,'tr','Åžirket bilgileri',0),(292829,8135,'pl','Informacje o firmie',0),(292830,8135,'bg','Ð¤Ð¸Ñ€Ð¼ÐµÐ½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(292831,8135,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(292832,8135,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð¸',0),(292833,8135,'vi','ThÃ´ng tin Cty',0),(292834,8135,'af','Onderneming Inligting',0),(292835,8135,'ro','Companie informaÅ£ii',0),(292836,8135,'et','EttevÃµtte informatsioon',0),(292837,8135,'si','Podatki o podjetju',0),(292838,8135,'ba','Informasi perusahaan',0),(292839,8135,'nl','Bedrijfsgegevens',0),(292840,8135,'fi','Yrityksen tiedot',0),(292841,8135,'no','Firmainformasjon',0),(292842,8135,'da','Firmaoplysninger',0),(292843,8135,'ko','íšŒì‚¬ ì •ë³´',0),(292844,8135,'he','×¤×¨×˜×™ ×”×—×‘×¨×”',0),(292845,8135,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(292846,8135,'zh','å…¬å¸ä¿¡æ¯\r\n',0),(292847,8135,'sv','FÃ¶retagsinformation',0),(292848,8135,'it','Informazioni sull\'azienda',0),(292849,8135,'tl','',0),(292850,8135,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(292851,8135,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(292852,8135,'ms','Maklumat syarikat',0),(292853,8135,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ©',0),(292854,8135,'fr','Informations sur la compagnie',0),(292855,8135,'jp','ä¼šç¤¾æƒ…å ±',0),(292856,8135,'pt','InformaÃ§Ãµes sobre a empresa',0),(292857,8135,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ðž ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(292858,8135,'es','Empresa InformaciÃ³n',0),(292859,8135,'de','Informationen zum Unternehmen',0),(292860,8135,'en','Company Information',0),(292861,8136,'is','',0),(292862,8136,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(292863,8136,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(292864,8136,'tr','Kredi kartÄ± bilgileri',0),(292865,8136,'pl','Informacje o karcie kredytowej',0),(292866,8136,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(292867,8136,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(292868,8136,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ñ˜ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¸',0),(292869,8136,'vi','ThÃ´ng Tin Tháº» TÃ­n Dá»¥ng',0),(292870,8136,'af','Kredietkaart Inligting',0),(292871,8136,'ro','Datele cardului de credit',0),(292872,8136,'et','Maksekaardi informatsioon',0),(292873,8136,'si','Podatke o kreditni kartici',0),(292874,8136,'ba','Informasi kartu kredit',0),(292875,8136,'nl','Credit Card informatie',0),(292876,8136,'fi','Luottokorttitiedot',0),(292877,8136,'no','Kredittkortinformasjonen',0),(292878,8136,'da','Kreditkortoplysninger',0),(292879,8136,'ko','ì‹ ìš© ì¹´ë“œ ì •ë³´',0),(292880,8136,'he','×¤×¨×˜×™ ×›×¨×˜×™×¡ ×”××©×¨××™',0),(292881,8136,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(292882,8136,'zh','ä¿¡ç”¨å¡èµ„æ–™\r\n',0),(292883,8136,'sv','Information om kreditkort',0),(292884,8136,'it','Carta di credito',0),(292885,8136,'tl','',0),(292886,8136,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(292887,8136,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(292888,8136,'ms','Maklumat kad kredit',0),(292889,8136,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(292890,8136,'fr','Informations de carte de crÃ©dit',0),(292891,8136,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æƒ…å ±',0),(292892,8136,'pt','InformaÃ§Ãµes de cartÃ£o de crÃ©dito',0),(292893,8136,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ñ‹',0),(292894,8136,'es','Tarjeta de CrÃ©dito InformaciÃ³n',0),(292895,8136,'de','Kreditkarten-Informationen',0),(292896,8136,'en','Credit Card Information',0),(292897,8137,'is','',0),(292898,8137,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ø² ',0),(292899,8137,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ø² ',0),(292900,8137,'tr','MÃ¼ÅŸteri destek talep formu',0),(292901,8137,'pl','Formularz Å¼Ä…dania obsÅ‚ugi klienta',0),(292902,8137,'bg','Ð¤Ð¾Ñ€Ð¼Ð° Ð·Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(292903,8137,'ur','Ú©Ø³Ù¹Ù…Ø± Ù…Ø¹Ø§ÙˆÙ†Øª Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙØ§Ø±Ù…',0),(292904,8137,'sr','ÐžÐ±Ñ€Ð°Ð·Ð°Ñ† Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð¿Ð¾Ð´Ñ€ÑˆÐºÑƒ ÐºÑƒÐ¿Ñ†Ð°',0),(292905,8137,'vi','YÃªu cáº§u há»— trá»£ khÃ¡ch hÃ ng tá»«',0),(292906,8137,'af','KliÃªnt/Klant Ondersteunings Navraag Vorm',0),(292907,8137,'ro','Formular de solicitare suport client',0),(292908,8137,'et','Klienditeenindus taotluse vorm',0),(292909,8137,'si','Obrazec podpore strank',0),(292910,8137,'ba','Dukungan pelanggan formulir permintaan',0),(292911,8137,'nl','Customer Support aanvraagformulier',0),(292912,8137,'fi','Asiakkaan Asiakaspalaute-lomake',0),(292913,8137,'no','Kundeskjemaet',0),(292914,8137,'da','Kunde Support anmodning Form',0),(292915,8137,'ko','ê³ ê° ì§€ì› ìš”ì²­ ì–‘ì‹',0),(292916,8137,'he','×˜×•×¤×¡ ×‘×§×©×ª ×ª×ž×™×›×” ×œ×œ×§×•×—',0),(292917,8137,'el','Î¦ÏŒÏÎ¼Î± Î±Î¯Ï„Î·ÏƒÎ·Ï‚ ÎµÎ¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ·Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(292918,8137,'zh','å®¢æˆ·æ”¯æ´ç”³è¯·è¡¨\r\n',0),(292919,8137,'sv','Kunden stÃ¶d begÃ¤ran Form',0),(292920,8137,'it','Modulo di richiesta di supporto cliente',0),(292921,8137,'tl','',0),(292922,8137,'th','&#3649;&#3610;&#3610;&#3615;&#3629;&#3619;&#3660;&#3617;&#3626;&#3609;&#3633;&#3610;&#3626;&#3609;&#3640;&#3609;&#3588;&#3635;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(292923,8137,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¤°à¥à¤¥à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤«à¥‰à¤°à¥à¤®',0),(292924,8137,'ms','Borang permohonan sokongan pelanggan',0),(292925,8137,'ar','Ù†Ù…ÙˆØ°Ø¬ Ø·Ù„Ø¨ Ø¯Ø¹Ù… Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(292926,8137,'fr','Formulaire de demande de Support client',0),(292927,8137,'jp','ã‚«ã‚¹ã‚¿ãƒžãƒ¼ ã‚µãƒãƒ¼ãƒˆ ãƒªã‚¯ã‚¨ã‚¹ãƒˆ ãƒ•ã‚©ãƒ¼ãƒ ',0),(292928,8137,'pt','FormulÃ¡rio de pedido de apoio ao cliente',0),(292929,8137,'ru','Ð¤Ð¾Ñ€Ð¼Ð° Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(292930,8137,'es','Formulario de PeticiÃ³n de Apoya a Cliente',0),(292931,8137,'de','Customer Support-Anfrage-Formular',0),(292932,8137,'en','Customer Support Request Form',0),(292933,8138,'is','',0),(292934,8138,'dr','Ø´Ø±Ø­ Ù…Ø´ÙƒÙ„ ',0),(292935,8138,'pr','Ø´Ø±Ø­ Ù…Ø´ÙƒÙ„ ',0),(292936,8138,'tr','Sorunun aÃ§Ä±klamasÄ±',0),(292937,8138,'pl','Opis problemu',0),(292938,8138,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð°',0),(292939,8138,'ur','Ø§Ø³ Ø¯Ø´ÙˆØ§Ø±ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(292940,8138,'sr','ÐžÐ¿Ð¸Ñ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð°',0),(292941,8138,'vi','MÃ´ táº£ váº¥n Ä‘á»',0),(292942,8138,'af','Beskrywing van Probleem',0),(292943,8138,'ro','Descrierea problema',0),(292944,8138,'et','Probleemi kirjeldus',0),(292945,8138,'si','Opis problema',0),(292946,8138,'ba','Deskripsi masalah',0),(292947,8138,'nl','Beschrijving van probleem',0),(292948,8138,'fi','Ongelman kuvaus',0),(292949,8138,'no','Beskrivelse av problemet',0),(292950,8138,'da','Beskrivelse af problemet',0),(292951,8138,'ko','ë¬¸ì œ ì„¤ëª…',0),(292952,8138,'he','×ª××•×¨ ×”×‘×¢×™×”',0),(292953,8138,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Ï€ÏÎ¿Î²Î»Î®Î¼Î±Ï„Î¿Ï‚',0),(292954,8138,'zh','é—®é¢˜è¯´æ˜Ž\r\n',0),(292955,8138,'sv','Beskrivning av Problem',0),(292956,8138,'it','Descrizione del problema',0),(292957,8138,'tl','',0),(292958,8138,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3586;&#3629;&#3591;&#3611;&#3633;&#3597;&#3627;&#3634;',0),(292959,8138,'hi','à¤¸à¤®à¤¸à¥à¤¯à¤¾ à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(292960,8138,'ms','Penerangan mengenai masalah',0),(292961,8138,'ar','ÙˆØµÙ Ø§Ù„Ù…Ø´ÙƒÙ„Ø©',0),(292962,8138,'fr','Description du problÃ¨me',0),(292963,8138,'jp','å•é¡Œã®èª¬æ˜Ž',0),(292964,8138,'pt','DescriÃ§Ã£o do problema',0),(292965,8138,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐŸÑ€Ð¾Ð±Ð»ÐµÐ¼Ñ‹',0),(292966,8138,'es','DescripciÃ³n del Problema',0),(292967,8138,'de','Beschreibung des Problems',0),(292968,8138,'en','Description of Problem',0),(292969,8139,'is','',0),(292970,8139,'dr','Ø¯Ø±Ø¬Ø§Ù‰ Ø¯ÙŠÚ¯Ø±',0),(292971,8139,'pr','Ø¯Ø±Ø¬Ø§Ù‰ Ø¯ÙŠÚ¯Ø±',0),(292972,8139,'tr','BaÅŸka bir yerde',0),(292973,8139,'pl','Gdzie indziej',0),(292974,8139,'bg','Ð”Ñ€ÑƒÐ³Ð¾ Ð¼ÑÑÑ‚Ð¾',0),(292975,8139,'ur','Ø§ÙˆØ± Ú©Ú†Ú¾ Ø¬Ú¯ÛÙˆÚº Ù¾Ø±',0),(292976,8139,'sr','ÐÐ° Ð´Ñ€ÑƒÐ³Ð¾Ð¼ Ð¼ÐµÑÑ‚Ñƒ',0),(292977,8139,'vi','NÆ¡i khÃ¡c',0),(292978,8139,'af','Elders',0),(292979,8139,'ro','ÃŽn altÄƒ parte',0),(292980,8139,'et','Mujal',0),(292981,8139,'si','Drugje',0),(292982,8139,'ba','Di tempat lain',0),(292983,8139,'nl','Elders',0),(292984,8139,'fi','Muualla',0),(292985,8139,'no','Andre steder',0),(292986,8139,'da','Andre steder',0),(292987,8139,'ko','ë‹¤ë¥¸ ê³³ì—ì„œ',0),(292988,8139,'he','×‘×ž×§×•× ××—×¨',0),(292989,8139,'el','Î‘Î»Î»Î¿Ï',0),(292990,8139,'zh','åˆ«å¤„\r\n',0),(292991,8139,'sv','NÃ¥gon annanstans',0),(292992,8139,'it','Altrove',0),(292993,8139,'tl','',0),(292994,8139,'th','&#3607;&#3637;&#3656;&#3629;&#3639;&#3656;&#3609;',0),(292995,8139,'hi','à¤•à¤¹à¥€à¤‚ à¤”à¤°',0),(292996,8139,'ms','Di tempat lain',0),(292997,8139,'ar','ÙÙŠ Ø£Ù…Ø§ÙƒÙ† Ø£Ø®Ø±Ù‰',0),(292998,8139,'fr','Ailleurs',0),(292999,8139,'jp','ä»–ã®å ´æ‰€',0),(293000,8139,'pt','Em outro lugar',0),(293001,8139,'ru','Ð’ Ð´Ñ€ÑƒÐ³Ð¸Ñ… ÑÑ‚Ñ€Ð°Ð½Ð°Ñ…',0),(293002,8139,'es','a otro sitio',0),(293003,8139,'de','An anderer Stelle',0),(293004,8139,'en','Elsewhere',0),(293005,8140,'is','',0),(293006,8140,'dr','Ø§Ø¶Ø·Ø±Ø§Ø±Ù‰',0),(293007,8140,'pr','Ø§Ø¶Ø·Ø±Ø§Ø±Ù‰',0),(293008,8140,'tr','Acil durum',0),(293009,8140,'pl','Awaryjne',0),(293010,8140,'bg','Ð˜Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´Ð½Ð¸ ÑÐ¸Ñ‚ÑƒÐ°Ñ†Ð¸Ð¸',0),(293011,8140,'ur','ÛÙ†Ú¯Ø§Ù…ÛŒ Ø­Ø§Ù„Ø§Øª',0),(293012,8140,'sr','Ð¥Ð¸Ñ‚Ð½Ð¾',0),(293013,8140,'vi','Kháº©n cáº¥p',0),(293014,8140,'af','Noodgeval',0),(293015,8140,'ro','De urgenÅ£Äƒ',0),(293016,8140,'et','Avarii',0),(293017,8140,'si','Sili',0),(293018,8140,'ba','Darurat',0),(293019,8140,'nl','Emergency',0),(293020,8140,'fi','Emergency',0),(293021,8140,'no','NÃ¸dsituasjon',0),(293022,8140,'da','NÃ¸dsituation',0),(293023,8140,'ko','ë¹„ìƒ',0),(293024,8140,'he','×—×¨×•×',0),(293025,8140,'el','ÎˆÎºÏ„Î±ÎºÏ„Î·Ï‚ Î±Î½Î¬Î³ÎºÎ·Ï‚',0),(293026,8140,'zh','ç´§æ€¥\r\n',0),(293027,8140,'sv','Emergency',0),(293028,8140,'it','Emergenza',0),(293029,8140,'tl','',0),(293030,8140,'th','&#3616;&#3634;&#3623;&#3632;&#3593;&#3640;&#3585;&#3648;&#3593;&#3636;&#3609;',0),(293031,8140,'hi','à¤†à¤ªà¤¾à¤¤ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(293032,8140,'ms','Kecemasan',0),(293033,8140,'ar','Ø­Ø§Ù„Ø§Øª Ø§Ù„Ø·ÙˆØ§Ø±Ø¦',0),(293034,8140,'fr','Situation d\'urgence',0),(293035,8140,'jp','ç·Šæ€¥äº‹æ…‹',0),(293036,8140,'pt','EmergÃªncia',0),(293037,8140,'ru','Ð§Ñ€ÐµÐ·Ð²Ñ‹Ñ‡Ð°Ð¹Ð½Ð¾Ðµ Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(293038,8140,'es','Emergencia',0),(293039,8140,'de','Notfall',0),(293040,8140,'en','Emergency',0),(293041,8141,'is','',0),(293042,8141,'dr','ÙØ±Ù… Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(293043,8141,'pr','ÙØ±Ù… Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(293044,8141,'tr','Form gÃ¶nderilmiÅŸ',0),(293045,8141,'pl','Formularz przedÅ‚oÅ¼ony',0),(293046,8141,'bg','Ð¤Ð¾Ñ€Ð¼Ð°, Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²ÐµÐ½Ð¸',0),(293047,8141,'ur','Ø¹Ø±Ø¶ Ú©ÛŒØ§ ÙØ§Ø±Ù…',0),(293048,8141,'sr','ÐžÐ±Ñ€Ð°Ð·Ð°Ñ†',0),(293049,8141,'vi','Ná»™p Máº«u',0),(293050,8141,'af','Vorm Ingedien',0),(293051,8141,'ro','Forma transmise',0),(293052,8141,'et','Vormi',0),(293053,8141,'si','Obrazec vpisali',0),(293054,8141,'ba','Formulir dikirimkan',0),(293055,8141,'nl','Formulier ingediend',0),(293056,8141,'fi','Lomake',0),(293057,8141,'no','Skjemaet sendt',0),(293058,8141,'da','Form indsendt',0),(293059,8141,'ko','ì–‘ì‹ ì œì¶œ',0),(293060,8141,'he','×˜×¤×¡×™× ×œ×©×œ×™×—×”',0),(293061,8141,'el','ÎœÎ¿ÏÏ†Î®Ï‚ Ï€Î¿Ï… Ï…Ï€Î¿Î²Î¬Î»Î»ÎµÏ„Î±Î¹',0),(293062,8141,'zh','è¡¨å•æäº¤\r\n',0),(293063,8141,'sv','FormulÃ¤ret skickats in',0),(293064,8141,'it','Modulo inviato',0),(293065,8141,'tl','',0),(293066,8141,'th','&#3615;&#3629;&#3619;&#3660;&#3617;&#3606;&#3641;&#3585;&#3626;&#3656;&#3591;&#3617;&#3629;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(293067,8141,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤',0),(293068,8141,'ms','Borang yang dikemukakan',0),(293069,8141,'ar','Ø§Ù„Ù†Ù…ÙˆØ°Ø¬ Ø§Ù„Ù…Ù‚Ø¯Ù…',0),(293070,8141,'fr','Formulaire soumis',0),(293071,8141,'jp','é€ä¿¡ãƒ•ã‚©ãƒ¼ãƒ ',0),(293072,8141,'pt','FormulÃ¡rio enviado',0),(293073,8141,'ru','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð½Ð°Ñ Ñ„Ð¾Ñ€Ð¼Ð°',0),(293074,8141,'es','Formulario Presentado',0),(293075,8141,'de','Eingereichten',0),(293076,8141,'en','Form Submitted',0),(293077,8142,'is','',0),(293078,8142,'dr','Ù…ÙŠØ²Ø¨Ø§Ù† Ø¨ÙˆØ³ÙŠÙ„Ù‡',0),(293079,8142,'pr','Ù…ÙŠØ²Ø¨Ø§Ù† Ø¨ÙˆØ³ÙŠÙ„Ù‡',0),(293080,8142,'tr','TarafÄ±ndan ev sahipliÄŸi yaptÄ±.',0),(293081,8142,'pl','Gospodarzem',0),(293082,8142,'bg','Ð”Ð¾Ð¼Ð°ÐºÐ¸Ð½',0),(293083,8142,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ú©ÛŒ Ù…ÛŒØ²Ø¨Ø§Ù†ÛŒ Ú©ÛŒ',0),(293084,8142,'sr','Ð”Ð¾Ð¼Ð°Ñ›Ð¸Ð½',0),(293085,8142,'vi','Host bá»Ÿi',0),(293086,8142,'af','Aangebied deur',0),(293087,8142,'ro','Gazduit de',0),(293088,8142,'et','VÃµÃµrustas',0),(293089,8142,'si','Hosted By',0),(293090,8142,'ba','Host oleh',0),(293091,8142,'nl','Gehost door',0),(293092,8142,'fi','Hosted By',0),(293093,8142,'no','Arrangert av',0),(293094,8142,'da','Hostet af',0),(293095,8142,'ko','ì£¼ìµœ',0),(293096,8142,'he','×‘×—×¡×•×ª',0),(293097,8142,'el','Î¦Î¹Î»Î¿Î¾ÎµÎ½ÎµÎ¯Ï„Î±Î¹ Î±Ï€ÏŒ',0),(293098,8142,'zh','ä¸»åŠžå•ä½\r\n',0),(293099,8142,'sv','Hosted By',0),(293100,8142,'it','Ospitato da',0),(293101,8142,'tl','',0),(293102,8142,'th','&#3650;&#3630;&#3626;&#3605;&#3660;&#3650;&#3604;&#3618;',0),(293103,8142,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¹à¥‹à¤¸à¥à¤Ÿ',0),(293104,8142,'ms','Dihoskan oleh',0),(293105,8142,'ar','Ø§Ø³ØªØ¶Ø§ÙØªÙ‡',0),(293106,8142,'fr','HÃ©bergÃ© par',0),(293107,8142,'jp','ä¸»å‚¬',0),(293108,8142,'pt','Hospedado por',0),(293109,8142,'ru','ÐžÑ€Ð³Ð°Ð½Ð¸Ð·Ð¾Ð²Ð°Ð½Ð¾',0),(293110,8142,'es','Hospedado Por',0),(293111,8142,'de','Hosted By',0),(293112,8142,'en','Hosted By',0),(293113,8143,'is','',0),(293114,8143,'dr','MySQL Ù†Ø³Ø®Ù‡',0),(293115,8143,'pr','MySQL Ù†Ø³Ø®Ù‡',0),(293116,8143,'tr','MySQL sÃ¼rÃ¼mÃ¼',0),(293117,8143,'pl','Wersja MySQL',0),(293118,8143,'bg','MySQL Ð²ÐµÑ€ÑÐ¸Ñ',0),(293119,8143,'ur','Ø§ÛŒØ³ Ú©ÛŒÙˆ Ø§ÛŒÙ„ ÙˆØ±Ú˜Ù†',0),(293120,8143,'sr','ÐœyÐ¡QÐ› Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð°',0),(293121,8143,'vi','PhiÃªn báº£n MySQL',0),(293122,8143,'af','MySQL Weergawe',0),(293123,8143,'ro','MySQL versiunea',0),(293124,8143,'et','MySQL versioon',0),(293125,8143,'si','RazliÄica MySQL',0),(293126,8143,'ba','MySQL versi',0),(293127,8143,'nl','MySQL versie',0),(293128,8143,'fi','MySQL versio',0),(293129,8143,'no','MySQL versjon',0),(293130,8143,'da','MySQL Version',0),(293131,8143,'ko','MySQL ë²„ì „',0),(293132,8143,'he','×’×¨×¡×ª MySQL',0),(293133,8143,'el','MySQL Î­ÎºÎ´Î¿ÏƒÎ·',0),(293134,8143,'zh','æˆ‘çš„SQLç‰ˆæœ¬\r\n',0),(293135,8143,'sv','MySQL Version',0),(293136,8143,'it','Versione di MySQL',0),(293137,8143,'tl','',0),(293138,8143,'th','&#3648;&#3623;&#3629;&#3619;&#3660;&#3594;&#3633;&#3656;&#3609; MySQL',0),(293139,8143,'hi','MySQL à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(293140,8143,'ms','Versi MySQL',0),(293141,8143,'ar','Ø¥ØµØ¯Ø§Ø± Ø§Ù„Ø®Ù„ÙŠØ©',0),(293142,8143,'fr','Version de MySQL',0),(293143,8143,'jp','MySQL ã®ãƒãƒ¼ã‚¸ãƒ§ãƒ³',0),(293144,8143,'pt','VersÃ£o do MySQL',0),(293145,8143,'ru','Ð’ÐµÑ€ÑÐ¸Ñ MySQL',0),(293146,8143,'es','MySQL VersiÃ³n',0),(293147,8143,'de','MySQL-Version',0),(293148,8143,'en','MySQL Version',0),(293149,8144,'is','',0),(293150,8144,'dr','Noguska',0),(293151,8144,'pr','Noguska',0),(293152,8144,'tr','Noguska',0),(293153,8144,'pl','Noguska',0),(293154,8144,'bg','Noguska',0),(293155,8144,'ur','Ù†ÙˆÚ¯ÙˆØ³Ú©',0),(293156,8144,'sr','ÐÐ¾Ð³ÑƒÑÐºÐ°',0),(293157,8144,'vi','Noguska',0),(293158,8144,'af','Noguska',0),(293159,8144,'ro','Noguska',0),(293160,8144,'et','Noguska',0),(293161,8144,'si','Noguska',0),(293162,8144,'ba','Noguska',0),(293163,8144,'nl','Noguska',0),(293164,8144,'fi','Noguska',0),(293165,8144,'no','Noguska',0),(293166,8144,'da','Noguska',0),(293167,8144,'ko','Noguska',0),(293168,8144,'he','Noguska',0),(293169,8144,'el','Noguska',0),(293170,8144,'zh','Noguska\r\n',0),(293171,8144,'sv','Noguska',0),(293172,8144,'it','Noguska',0),(293173,8144,'tl','',0),(293174,8144,'th','Noguska',0),(293175,8144,'hi','Noguska',0),(293176,8144,'ms','Noguska',0),(293177,8144,'ar','Ù†ÙˆØ¬ÙˆØ³ÙƒØ§',0),(293178,8144,'fr','Noguska',0),(293179,8144,'jp','Noguska',0),(293180,8144,'pt','Noguska',0),(293181,8144,'ru','Noguska',0),(293182,8144,'es','Noguska',0),(293183,8144,'de','NolaPro',0),(293184,8144,'en','Noguska',0),(293185,8145,'is','',0),(293186,8145,'dr',': Ø§Ú¯Ø± Ø´Ù…Ø§ ÙŠÙƒ Ø·Ø±Ø­ Ù¾Ø´ØªÙŠØ¨Ø§Ù† Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡ Ø¯Ø§Ø±ÙŠØ¯ . ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø´Ù…Ø§ Ø´Ø§Ø±Ú˜ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ù…Ú¯Ø± Ø§ÙŠÙ†ÙƒÙ‡ Ø³Ø§Ø¹Ø§Øª Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø§Ø±Ø²Ø´ Ø¯ÙØªØ±ÙŠ Ø¯Ø± Ø·Ø±Ø­ Ø´Ù…Ø§ Ø¨Ø§Ø´Ù†Ø¯ ',0),(293187,8145,'pr','ØªÙˆØ¬Ù‡ : Ø§Ú¯Ø± Ø´Ù…Ø§ ÙŠÙƒ Ø·Ø±Ø­ Ù¾Ø´ØªÙŠØ¨Ø§Ù† Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡ Ø¯Ø§Ø±ÙŠØ¯ . ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø´Ù…Ø§ Ø´Ø§Ø±Ú˜ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ù…Ú¯Ø± Ø§ÙŠÙ†ÙƒÙ‡ Ø³Ø§Ø¹Ø§Øª Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø§Ø±Ø²Ø´ Ø¯ÙØªØ±ÙŠ Ø¯Ø± Ø·Ø±Ø­ Ø´Ù…Ø§ Ø¨Ø§Ø´Ù†Ø¯ ',0),(293188,8145,'tr','Not: EÄŸer bir katma deÄŸer destek planÄ±,<br>kredi kartÄ± olmadÄ±kÃ§a Ã¼cret alÄ±nmayacaktÄ±r saat<br>planÄ±n Ã¼zerinde kalan bakiye Ã¶tesine geÃ§in.',0),(293189,8145,'pl','Uwaga: JeÅ›li masz Plan wsparcia wartoÅ›ci dodanej,<br>Karta kredytowa bÄ™dzie obciÄ…Å¼ona nie, chyba Å¼e godziny<br>wykracza poza saldo na planie.',0),(293190,8145,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ°: ÐÐºÐ¾ Ð¸Ð¼Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð¿Ð»Ð°Ð½ Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°,<br>Ð’Ð°ÑˆÐ°Ñ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð½ÑÐ¼Ð° Ð´Ð° ÑÐµ Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÐ²Ð°, Ð¾ÑÐ²ÐµÐ½ Ð°ÐºÐ¾ Ñ‡Ð°ÑÐ°<br>Ð½Ð°Ð´Ñ…Ð²ÑŠÑ€Ð»ÑÑ‚ Ð¾ÑÑ‚Ð°Ñ‚ÑŠÐºÑŠÑ‚ ',0),(293191,8145,'ur','Ù†ÙˆÙ¹: Ø§Ú¯Ø± Ø¢Ù¾ Ú©Û’ Ù¾Ø§Ø³ Ø§ÛŒÚ© Ù‚Ø¯Ø± Ø§Ø¶Ø§ÙÛŒ Ù…Ø¯Ø¯ Ú©Ø§ Ø§Ø±Ø§Ø¯Û Ø±Ú©Ú¾ØªÛ’ ÛÛŒÚº<br>Ø¢Ù¾ Ú©Û’ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ ØªÚ© Ú†Ø§Ø±Ø¬ Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§ Ù†Û Ú¯Ú¾Ù†Ù¹Û’<br>Ø§Ù¾Ù†Û’ Ù…Ù†ØµÙˆØ¨Û’ Ù¾Ø± Ø¨Ø§Ù‚ÛŒ ØªÙˆØ§Ø²Ù† Ø³Û’ Ø¢Ú¯Û’ Ø¬Ø§Ù†Ø§ Û',0),(293192,8145,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° : ÐÐºÐ¾ Ð¸Ð¼Ð°Ñ‚Ðµ Ð½Ð° Ð´Ð¾Ð´Ð°Ñ‚Ñƒ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ Ð¿Ð¾Ð´Ñ€ÑˆÐºÑƒ Ð¿Ð»Ð°Ð½Ñƒ,<br>ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼ Ð½ÐµÑ›Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð°ÐºÐ¾ Ð½Ðµ ÑÐ°Ñ‚Ðµ<br>Ð¿Ñ€ÐµÐ²Ð°Ð·Ð¸Ð»Ð°Ð·Ðµ ÑÐ°Ð»Ð´Ð¾ Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾ Ð½Ð° Ñ‚Ð²Ð¾Ñ',0),(293193,8145,'vi','Ghi ChÃº: Náº¿u báº¡n cÃ³ ChÆ°Æ¡ng trÃ¬nh há»— trá»£ giÃ¡ trá»‹ cÃ´ng thÃªm,  tháº» tÃ­n dá»¥ng cá»§a báº¡n sáº½ khÃ´ng bá»‹ tÃ­nh phÃ­ trá»« phi sá»‘ giá»  nhiá»u hÆ¡n sá»‘ cÃ²n láº¡i trong káº¿ hoáº¡ch cá»§a báº¡n',0),(293194,8145,'af','LET WEL: As u oor \'n Toegevoegde Waarde Ondersteuningplan beskik, <br /> u kredietkaart nie gehef sal word nie, tensy die ure <br /> u oorblywende saldo op u plan oorskry.',0),(293195,8145,'ro','NotÄƒ: DacÄƒ aveÅ£i un Plan valoarea adÄƒugatÄƒ suport,<br>cardul de credit nu va fi taxat cu excepÅ£ia cazului Ã®n ore<br>depÄƒÅŸesc soldul rÄƒmas pe plan.',0),(293196,8145,'et','MÃ¤rkus: Kui sul on kehtestatud toetuse kava,<br>teie krediitkaardilt tasu ei vÃµeta, kui tunnid<br>kaugemale jÃ¤Ã¤nud oma plaani saldo.',0),(293197,8145,'si','Opomba: ÄŒe vi Å¾ivljati a naÄrt dodano podporo,<br>vaÅ¡e kreditne kartice bo ne zaraÄunavajo razen v urah<br>presegajo sredstva, ki ostanejo na vaÅ¡ naÄrt.',0),(293198,8145,'ba','Catatan: Jika Anda memiliki rencana dukungan pertambahan nilai,<br>kartu kredit Anda tidak akan dikenakan kecuali jam<br>melampaui saldo yang tersisa di rencana Anda.',0),(293199,8145,'nl','Opmerking: Hebt u een Support Plan over de toegevoegde waarde,<br>wordt geen bedrag van uw creditcard afgeschreven, tenzij de uren<br>verder gaan dan het Restbedrag op uw plan.',0),(293200,8145,'fi','Huomautus: Jos arvonlisÃ¤vero Support Plan,<br>luottokortiltasi ei veloiteta, jos tunnit<br>ylittÃ¤vÃ¤t suunnitelma jÃ¤ljellÃ¤.',0),(293201,8145,'no','Merk: Hvis du har en verdiÃ¸kende Support Plan,<br>kredittkortet ditt vil ikke bli belastet med mindre timer<br>gÃ¥r utover balansen pÃ¥ planen.',0),(293202,8145,'da','BemÃ¦rk: Hvis du har en Value Added stÃ¸tte planen,<br>dit kreditkort vil ikke blive opkrÃ¦vet, medmindre timerne<br>gÃ¥ ud over balancen tilbage pÃ¥ din plan.',0),(293203,8145,'ko','ì°¸ê³ : ë§Œì•½ ë‹¹ì‹ ì´ í•œ ë¶€ê°€ê°€ì¹˜ì„¸ ì§€ì› ê³„íš,<br>í•˜ì§€ ì•ŠëŠ” í•œ ê·€í•˜ì˜ ì‹ ìš© ì¹´ë“œë¡œ ì²­êµ¬ ë˜ì§€ ê²ƒìž…ë‹ˆë‹¤ ì‹œê°„<br>ë‹¹ì‹ ì˜ ê³„íšì— ë‚¨ì•„ ìžˆëŠ” ìž”ì•¡ì„ ë„˜ì–´ ì´ë™ í•©ë‹ˆë‹¤.',0),(293204,8145,'he','×”×¢×¨×”: ×× ×™×© ×œ×š ×¢×¨×š ×ž×•×¡×£ ×ª×ž×™×›×” ×©×œ ×ª×•×›× ×™×ª,<br>×›×¨×˜×™×¡ ×”××©×¨××™ ×©×œ×›× ×œ× ×™×—×•×™×‘ ××œ× ×× ×›×Ÿ ×”×©×¢×•×ª<br>×ž×¢×‘×¨ ×”×™×ª×¨×” ×©× ×•×ª×¨×” ×¢×œ ×”×ª×•×›× ×™×ª ×©×œ×š.',0),(293205,8145,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·: Î•Î¬Î½ Î­Ï‡ÎµÏ„Îµ Î­Î½Î± ÏƒÏ‡Î­Î´Î¹Î¿ Ï…Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î·Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿ÏƒÏ„Î¹Î¸Î­Î¼ÎµÎ½Î·Ï‚ Î±Î¾Î¯Î±Ï‚,<br>Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ Î´ÎµÎ½ Î¸Î± Ï‡ÏÎµÏ‰Î¸ÎµÎ¯Ï„Îµ Î±Î½ Î´ÎµÎ½ Ï„Î¹Ï‚ ÏŽÏÎµÏ‚<br>Î Î·Î³Î±Î¯Î½ÎµÏ„Îµ Ï€Î­ÏÎ± Î±Ï',0),(293206,8145,'zh','æ³¨æ„ï¼šå¦‚æžœæ‚¨æœ‰ä¸€ä¸ªå¢žå€¼æ”¯æ´è®¡åˆ’ï¼Œæ‚¨çš„ä¿¡ç”¨å¡ä¸ä¼šæ”¶è´¹é™¤éžæ—¶æ•°è¶…è¿‡æ‚¨è®¡åˆ’å‰©ä½™ç»“ä½™\r\n',0),(293207,8145,'sv','Obs: Om du har en mervÃ¤rdesskatt stÃ¶d planerar,<br>ditt kreditkort kommer inte debiteras sÃ¥vida timmarna<br>gÃ¥r utÃ¶ver den outnyttjade pÃ¥ plan.',0),(293208,8145,'it','Nota: Se si dispone di un piano di supporto a valore aggiunto,<br>carta di credito non verrÃ  addebitato a meno che le ore<br>andare oltre il saldo rimanente sul tuo piano.',0),(293209,8145,'tl','',0),(293210,8145,'th','NOTE: If you have a Value-Added Support Plan, <br /> your credit card will not be charged unless the hours <br /> go beyond the balance remaining on your plan.',0),(293211,8145,'hi','à¤¨à¥‹à¤Ÿ: à¤¯à¤¦à¤¿ à¤†à¤ª à¤à¤• à¤®à¥‚à¤²à¥à¤¯ à¤¯à¥‹à¤œà¤¿à¤¤ à¤¸à¤®à¤°à¥à¤¥à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾,<br>à¤œà¤¬ à¤¤à¤• à¤•à¤¿ à¤†à¤ªà¤•à¥‡ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤šà¤¾à¤°à¥à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤œà¤¾à¤à¤—à¤¾ à¤˜à¤‚à¤Ÿà¥‡',0),(293212,8145,'ms','Nota: Jika anda mempunyai satu pelan sokongan nilai tambah(VAT),<br>kad kredit anda tidak akan dicaj kecuali waktu<br>melampaui baki yang tinggal pada pelan anda.',0),(293213,8145,'ar','Ù…Ù„Ø§Ø­Ø¸Ø©: Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø¯ÙŠÙƒ \"Ø®Ø·Ø© Ø§Ù„Ø¯Ø¹Ù…\" Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©ØŒ<br>Ø³ÙˆÙ Ù„Ø§ ØªØ­Ù…Ù„ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ Ø¥Ù„Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ø³Ø§Ø¹Ø§Øª<br>ØªØªØ¬Ø§ÙˆØ² Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ù…ØªØ¨Ù‚ÙŠ Ø¹Ù„Ù‰ Ø§Ù„Ø®Ø·Ø© ',0),(293214,8145,'fr','Remarque : Si vous avez un Plan de soutien Ã  valeur ajoutÃ©e,<br>votre carte de crÃ©dit prÃ©lÃ¨ve pas Ã  moins que les heures<br>dÃ©passer le solde restant sur votre plan.',0),(293215,8145,'jp','æ³¨: ä»˜åŠ ä¾¡å€¤ã‚µãƒãƒ¼ãƒˆè¨ˆç”»ãŒã‚ã‚‹å ´åˆ<br>ã‚ãªãŸã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰èª²é‡‘ã•ã‚Œã¾ã›ã‚“ãªã„é™ã‚Šæ™‚é–“<br>ã‚ãªãŸã®è¨ˆç”»ã«æ®‹ã£ã¦ã„ã‚‹ãƒãƒ©ãƒ³ã‚¹ã‚’è¶Šãˆã¦è¡Œãã¾ã™ã€‚',0),(293216,8145,'pt','Nota: Se vocÃª tem um plano de apoio de valor acrescentado,<br>seu cartÃ£o de crÃ©dito nÃ£o serÃ¡ cobrado a menos que as horas<br>ultrapassam o saldo restante em seu plano.',0),(293217,8145,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ: Ð•ÑÐ»Ð¸ Ñƒ Ð²Ð°Ñ ÐµÑÑ‚ÑŒ Ð¿Ð»Ð°Ð½ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð½ÑƒÑŽ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ,<br>Ð²Ð°ÑˆÐµÐ¹ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð½Ðµ Ð²Ð·Ð¸Ð¼Ð°ÐµÑ‚ÑÑ, ÐµÑÐ»Ð¸ Ñ‡Ð°ÑÑ‹<br>Ð²Ñ‹Ñ…Ð¾Ð´ÑÑ‚ Ð·Ð° Ñ€Ð°Ð¼ÐºÐ¸ Ð¾ÑÑ‚Ð°Ñ‚Ð¾Ð',0),(293218,8145,'es','NOTA: Si tiene un Plan de Apoyo Valor-Agregado, <br /> su tarjeta de credito no se cargarÃ¡ hasta que las horas <br /> va mÃ¡s allÃ¡ que la balance restante en su plan',0),(293219,8145,'de','Hinweis: Wenn Sie ein Value-Added Support Plan haben<br>Ihre Kreditkarte wird nicht belastet, es sei denn, die Stunden<br>das Guthaben auf Ihrem Plan hinausgehen.',0),(293220,8145,'en','NOTE: If you have a Value-Added Support Plan, <br /> your credit card will not be charged unless the hours <br /> go beyond the balance remaining on your plan.',0),(293221,8146,'is','',0),(293222,8146,'dr','PHP',0),(293223,8146,'pr','Ù†Ø³Ø®Ù‡ PHP',0),(293224,8146,'tr','PHP sÃ¼rÃ¼mÃ¼',0),(293225,8146,'pl','Wersja PHP',0),(293226,8146,'bg','PHP Ð²ÐµÑ€ÑÐ¸Ñ',0),(293227,8146,'ur','Ù¾ÛŒ Ø§ÛŒÚ† Ù¾ÛŒ ÙˆØ±Ú˜Ù†',0),(293228,8146,'sr','ÐŸÐ¥ÐŸ Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð°',0),(293229,8146,'vi','PhiÃªn báº£n PHP',0),(293230,8146,'af','PHP Weergawe',0),(293231,8146,'ro','Versiunea PHP',0),(293232,8146,'et','PHP versioon',0),(293233,8146,'si','PHP Version',0),(293234,8146,'ba','Versi PHP',0),(293235,8146,'nl','PHP versie',0),(293236,8146,'fi','PHP versio',0),(293237,8146,'no','PHP-versjon',0),(293238,8146,'da','PHP Version',0),(293239,8146,'ko','PHP ë²„ì „',0),(293240,8146,'he','×’×¨×¡×ª ×”-PHP',0),(293241,8146,'el','PHP Î­ÎºÎ´Î¿ÏƒÎ·',0),(293242,8146,'zh','PHPç‰ˆæœ¬\r\n',0),(293243,8146,'sv','PHP-Version',0),(293244,8146,'it','Versione PHP',0),(293245,8146,'tl','',0),(293246,8146,'th','&#3648;&#3623;&#3629;&#3619;&#3660;&#3594;&#3633;&#3656;&#3609; PHP',0),(293247,8146,'hi','PHP à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(293248,8146,'ms','Versi PHP',0),(293249,8146,'ar','Ø¥ØµØ¯Ø§Ø± Ø¨ÙŠ Ø¥ØªØ´ Ø¨ÙŠ',0),(293250,8146,'fr','Version PHP',0),(293251,8146,'jp','PHP ã®ãƒãƒ¼ã‚¸ãƒ§ãƒ³',0),(293252,8146,'pt','VersÃ£o do PHP',0),(293253,8146,'ru','Ð’ÐµÑ€ÑÐ¸Ñ PHP',0),(293254,8146,'es','VersiÃ³n PHP',0),(293255,8146,'de','PHP-Version',0),(293256,8146,'en','PHP Version',0),(293257,8147,'is','',0),(293258,8147,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(293259,8147,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(293260,8147,'tr','Sunucu bilgileri',0),(293261,8147,'pl','Informacje o serwerze',0),(293262,8147,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÑÑŠÑ€Ð²ÑŠÑ€Ð°',0),(293263,8147,'ur','Ù¾ÛŒØ´ Ú©Ø§Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(293264,8147,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÑÐµÑ€Ð²ÐµÑ€Ñƒ',0),(293265,8147,'vi','ThÃ´ng Tin mÃ¡y chá»§',0),(293266,8147,'af','Bediener Inligting',0),(293267,8147,'ro','InformaÅ£ii server',0),(293268,8147,'et','Serveri info',0),(293269,8147,'si','Informacije o streÅ¾niku',0),(293270,8147,'ba','Informasi server',0),(293271,8147,'nl','Serverinformatie',0),(293272,8147,'fi','Palvelimen tiedot',0),(293273,8147,'no','Serverinformasjon',0),(293274,8147,'da','Serveroplysninger',0),(293275,8147,'ko','ì„œë²„ ì •ë³´',0),(293276,8147,'he','×ž×™×“×¢ ×©×¨×ª',0),(293277,8147,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î®',0),(293278,8147,'zh','æœåŠ¡å™¨ä¿¡æ¯\r\n',0),(293279,8147,'sv','Serverinformation',0),(293280,8147,'it','Informazioni sul server',0),(293281,8147,'tl','',0),(293282,8147,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3595;&#3636;&#3615;&#3648;&#3623;&#3629;&#3619;&#3660;',0),(293283,8147,'hi','à¤¸à¤°à¥à¤µà¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(293284,8147,'ms','Maklumat pelayan',0),(293285,8147,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ù„Ù‚Ù…',0),(293286,8147,'fr','Informations sur le serveur',0),(293287,8147,'jp','ã‚µãƒ¼ãƒãƒ¼æƒ…å ±',0),(293288,8147,'pt','InformaÃ§Ãµes do servidor',0),(293289,8147,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¡ÐµÑ€Ð²ÐµÑ€Ð°',0),(293290,8147,'es','InformaciÃ³n de Servidor',0),(293291,8147,'de','Serverinformationen',0),(293292,8147,'en','Server Information',0),(293293,8148,'is','',0),(293294,8148,'dr','Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(293295,8148,'pr','Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(293296,8148,'tr','Sunucu iÅŸletim sistemi',0),(293297,8148,'pl','System operacyjny serwera',0),(293298,8148,'bg','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð° ÑÐ¸ÑÑ‚ÐµÐ¼Ð° Ð·Ð° ÑÑŠÑ€Ð²ÑŠÑ€Ð¸',0),(293299,8148,'ur','Ù†Ø¸Ø§Ù… Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ù¾ÛŒØ´ Ú©Ø§Ø±',0),(293300,8148,'sr','Ð¡ÐµÑ€Ð²ÐµÑ€ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ð¸ ÑÐ¸ÑÑ‚ÐµÐ¼',0),(293301,8148,'vi','Há»‡ thá»‘ng Ä‘iá»u hÃ nh mÃ¡y chá»§',0),(293302,8148,'af','Bediener Bedryfstelsel',0),(293303,8148,'ro','Sistem de operare server',0),(293304,8148,'et','Serveri operatsioonisÃ¼steem',0),(293305,8148,'si','StreÅ¾niÅ¡ki operacijski sistem',0),(293306,8148,'ba','Sistem operasi server',0),(293307,8148,'nl','Serverbesturingssysteem',0),(293308,8148,'fi','Palvelimen kÃ¤yttÃ¶jÃ¤rjestelmÃ¤',0),(293309,8148,'no','Server-operativsystemet',0),(293310,8148,'da','Server-operativsystemet',0),(293311,8148,'ko','ì„œë²„ ìš´ì˜ ì²´ì œ',0),(293312,8148,'he','×ž×¢×¨×›×ª ×”×¤×¢×œ×” ×©×œ ×©×¨×ª',0),(293313,8148,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¹ÎºÏŒ ÏƒÏÏƒÏ„Î·Î¼Î± Î³Î¹Î± Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î­Ï‚',0),(293314,8148,'zh','æœåŠ¡å™¨æ“ä½œç³»ç»Ÿ\r\n',0),(293315,8148,'sv','Server-operativsystem',0),(293316,8148,'it','Sistema operativo server',0),(293317,8148,'tl','',0),(293318,8148,'th','&#3619;&#3632;&#3610;&#3610;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;&#3648;&#3595;&#3636;&#3615;&#3648;&#3623;&#3629;&#3619;&#3660;',0),(293319,8148,'hi','à¤¸à¤°à¥à¤µà¤° à¤†à¤ªà¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¸à¤¿à¤¸à¥à¤Ÿà¤®',0),(293320,8148,'ms','Sistem operasi Server',0),(293321,8148,'ar','Ø®Ø§Ø¯Ù… Ù†Ø¸Ø§Ù… Ø§Ù„ØªØ´ØºÙŠÙ„',0),(293322,8148,'fr','SystÃ¨me d\'exploitation serveur',0),(293323,8148,'jp','ã‚µãƒ¼ãƒãƒ¼ã®ã‚ªãƒšãƒ¬ãƒ¼ãƒ†ã‚£ãƒ³ã‚° ã‚·ã‚¹ãƒ†ãƒ ',0),(293324,8148,'pt','Sistema operacional de servidor',0),(293325,8148,'ru','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð°Ñ ÑÐ¸ÑÑ‚ÐµÐ¼Ð° ÑÐµÑ€Ð²ÐµÑ€Ð°',0),(293326,8148,'es','Servidor Sistema de OperaciÃ³n',0),(293327,8148,'de','Server-Betriebssystem',0),(293328,8148,'en','Server Operating System',0),(293329,8149,'is','',0),(293330,8149,'dr','Ù†Ø³Ø®Ù‡ Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡',0),(293331,8149,'pr','Ù†Ø³Ø®Ù‡ Ø³Ø±ÙˆÙŠØ³ Ø¯Ù‡Ù†Ø¯Ù‡',0),(293332,8149,'tr','Sunucu sÃ¼rÃ¼mÃ¼',0),(293333,8149,'pl','Wersja serwera',0),(293334,8149,'bg','Ð’ÐµÑ€ÑÐ¸ÑÑ‚Ð° Ð½Ð° ÑÑŠÑ€Ð²ÑŠÑ€Ð°',0),(293335,8149,'ur','Ù¾ÛŒØ´ Ú©Ø§Ø± ÙˆØ±Ú˜Ù†',0),(293336,8149,'sr','Ð’ÐµÑ€Ð·Ð¸Ñ˜Ð° ÑÐµÑ€Ð²ÐµÑ€Ð°',0),(293337,8149,'vi','PhiÃªn báº£n MÃ¡y chá»§',0),(293338,8149,'af','Bediener Weergawe',0),(293339,8149,'ro','Versiune server',0),(293340,8149,'et','Serveri versioon',0),(293341,8149,'si','RazliÄica streÅ¾nika',0),(293342,8149,'ba','Server versi',0),(293343,8149,'nl','Serverversie',0),(293344,8149,'fi','Palvelimen versio',0),(293345,8149,'no','Serverversjonen',0),(293346,8149,'da','Serverversion',0),(293347,8149,'ko','ì„œë²„ ë²„ì „',0),(293348,8149,'he','×’×™×¨×¡×ª ×©×¨×ª',0),(293349,8149,'el','ÎˆÎºÎ´Î¿ÏƒÎ· Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î®',0),(293350,8149,'zh','æœåŠ¡å™¨ç‰ˆæœ¬\r\n',0),(293351,8149,'sv','Serverversionen',0),(293352,8149,'it','Versione server',0),(293353,8149,'tl','',0),(293354,8149,'th','&#3648;&#3623;&#3629;&#3619;&#3660;&#3594;&#3633;&#3656;&#3609;&#3648;&#3595;&#3636;&#3615;&#3648;&#3623;&#3629;&#3619;&#3660;',0),(293355,8149,'hi','à¤¸à¤°à¥à¤µà¤° à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(293356,8149,'ms','Versi pelayan',0),(293357,8149,'ar','Ø¥ØµØ¯Ø§Ø± Ø§Ù„Ù…Ù„Ù‚Ù…',0),(293358,8149,'fr','Version du serveur',0),(293359,8149,'jp','ã‚µãƒ¼ãƒãƒ¼ã®ãƒãƒ¼ã‚¸ãƒ§ãƒ³',0),(293360,8149,'pt','VersÃ£o do servidor',0),(293361,8149,'ru','Ð’ÐµÑ€ÑÐ¸Ñ ÑÐµÑ€Ð²ÐµÑ€Ð°',0),(293362,8149,'es','VersiÃ³n de Servidor',0),(293363,8149,'de','Server-Version',0),(293364,8149,'en','Server Version',0),(293365,8150,'is','',0),(293366,8150,'dr','Ø³Ø§Ø¹Ø§Øª Ø¹Ù…Ù„ÙŠØ§ØªÙ‰ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ù†Ø±Ù…Ø§Ù„',0),(293367,8150,'pr','Ø³Ø§Ø¹Ø§Øª Ø¹Ù…Ù„ÙŠØ§ØªÙ‰ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ù†Ø±Ù…Ø§Ù„',0),(293368,8150,'tr','Standart Normal Ã§alÄ±ÅŸma gÃ¶nderilen',0),(293369,8150,'pl','Standardowe normalnych godzin pracy',0),(293370,8150,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ð½Ð¾Ñ€Ð¼Ð°Ð»Ð½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ñ‡Ð°ÑÐ°',0),(293371,8150,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø¹Ù…ÙˆÙ„ Ø¢Ù¾Ø±ÛŒÙ¹Ù†Ú¯ Ú¯Ú¾Ù†Ù¹Û’',0),(293372,8150,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ðµ Ð½Ð¾Ñ€Ð¼Ð°Ð»Ð½Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ðµ Ñ‡',0),(293373,8150,'vi','Giá» hoáº¡t Ä‘á»™ng chuáº©n',0),(293374,8150,'af','Standaard Normale Bedryfsure',0),(293375,8150,'ro','Standard ore de funcÈ›ionare normalÄƒ',0),(293376,8150,'et','Standardse normaalse tegevuse tundi',0),(293377,8150,'si','Standardno normalno obratovalnih ur',0),(293378,8150,'ba','Jam operasi Normal standar',0),(293379,8150,'nl','Standaard normale operationele Hrs',0),(293380,8150,'fi','Standard normaali toiminta tuntia',0),(293381,8150,'no','Standard Normal drift timer',0),(293382,8150,'da','Standard Normal drift timer',0),(293383,8150,'ko','í‘œì¤€ ì •ìƒ ìš´ì˜ ì‹œê°„',0),(293384,8150,'he','×ª×§×Ÿ ×©×¢×•×ª ×”×¤×¢×œ×” ×¨×’×™×œ×”',0),(293385,8150,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ ÎºÎ±Î½Î¿Î½Î¹ÎºÎ­Ï‚ ÏŽÏÎµÏ‚ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±Ï‚',0),(293386,8150,'zh','æ ‡å‡†æ­£å¸¸å·¥ä½œå°æ—¶\r\n',0),(293387,8150,'sv','Standard normala drift timmar',0),(293388,8150,'it','Ore di funzionamento normale standard',0),(293389,8150,'tl','',0),(293390,8150,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;&#3611;&#3585;&#3605;&#3636;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;',0),(293391,8150,'hi','à¤®à¤¾à¤¨à¤• à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤‘à¤ªà¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤˜à¤‚à¤Ÿà¥‡',0),(293392,8150,'ms','Standard jam operasi biasa',0),(293393,8150,'ar','Ø³Ø§Ø¹Ø§Øª Ø§Ù„ØªØ´ØºÙŠÙ„ Ø§Ù„Ø¹Ø§Ø¯ÙŠ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ',0),(293394,8150,'fr','Heures d\'exploitation normale standard',0),(293395,8150,'jp','æ¨™æº–ã®é€šå¸¸å–¶æ¥­æ™‚é–“',0),(293396,8150,'pt','Horas de funcionamento Normal padrÃ£o',0),(293397,8150,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð½Ð¾Ñ€Ð¼Ð°Ð»ÑŒÐ½Ñ‹Ñ… Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ñ… Ñ‡Ð°ÑÐ¾Ð²',0),(293398,8150,'es','Horas EstÃ¡ndares de OperaciÃ³n Normal ',0),(293399,8150,'de','Standard normalen operativen Hrs',0),(293400,8150,'en','Standard Normal Operating Hrs',0),(293401,8151,'is','',0),(293402,8151,'dr','2000',0),(293403,8151,'pr','Ù…Ø«Ù„ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ Ù„ÙŠÙ†ÙˆÙƒØ³ â€“ ÙˆÙŠÙ†Ø¯ÙˆØ² 2000',0),(293404,8151,'tr','Linux gibi Windows 2000',0),(293405,8151,'pl','takich jak Linux, Windows 2000',0),(293406,8151,'bg','ÐºÐ°Ñ‚Ð¾ Linux, Windows 2000',0),(293407,8151,'ur','Ù„ÛŒÙ†Ú©Ø³ØŒ ÙˆÙ†ÚˆÙˆØ² 2000 Ø¬ÛŒØ³Û’',0),(293408,8151,'sr','ÐºÐ°Ð¾ ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð›Ð¸Ð½Ñƒx, WÐ¸Ð½Ð´Ð¾wÑ 2000',0),(293409,8151,'vi','nhÆ° lÃ  Linux, Window 2000',0),(293410,8151,'af','soos onder andere Linux, Windows 2000',0),(293411,8151,'ro','cum ar fi Linux, Windows 2000',0),(293412,8151,'et','nagu Linux, Windows 2000',0),(293413,8151,'si','kot so Linux, Windows 2000',0),(293414,8151,'ba','seperti Linux, Windows 2000',0),(293415,8151,'nl','zoals Linux, Windows 2000',0),(293416,8151,'fi','kuten Linux, Windows 2000',0),(293417,8151,'no','som Linux, Windows 2000',0),(293418,8151,'da','som Linux, Windows 2000',0),(293419,8151,'ko','ë¦¬ëˆ…ìŠ¤, ìœˆë„ìš° 2000 ë“±',0),(293420,8151,'he','×›×ž×• ×œ×™× ×•×§×¡, ×—×œ×•× ×•×ª 2000',0),(293421,8151,'el','ÏŒÏ€Ï‰Ï‚ Linux, Windows 2000',0),(293422,8151,'zh','å¦‚Linuxï¼ŒWindows2000\r\n',0),(293423,8151,'sv','som Linux, Windows 2000',0),(293424,8151,'it','come Linux, Windows 2000',0),(293425,8151,'tl','',0),(293426,8151,'th','&#3648;&#3594;&#3656;&#3609; Linux, Windows 2000',0),(293427,8151,'hi','à¤œà¥ˆà¤¸à¥‡ à¤•à¤¿ Linux, Windows 2000',0),(293428,8151,'ms','seperti Linux, Windows 2000',0),(293429,8151,'ar','Ù…Ø«Ù„ Ù„ÙŠÙ†ÙƒØ³ØŒ Ù†Ø¸Ø§Ù… Ø§Ù„ØªØ´ØºÙŠÙ„ Windows 2000',0),(293430,8151,'fr','comme Linux, Windows 2000',0),(293431,8151,'jp','Linux ã§ã¯ã€Windows 2000 ãªã©',0),(293432,8151,'pt','tais como Linux, Windows 2000',0),(293433,8151,'ru','Ñ‚Ð°ÐºÐ¸Ñ… ÐºÐ°Ðº Linux, Windows 2000',0),(293434,8151,'es','Como Linux, Windows 2000',0),(293435,8151,'de','wie Linux, Windows 2000',0),(293436,8151,'en','such as Linux, Windows 2000',0),(293437,8152,'is','',0),(293438,8152,'dr','Ù†ÙˆØ¹ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ø¯Ù‡ ',0),(293439,8152,'pr','Ù†ÙˆØ¹ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ø¯Ù‡ ',0),(293440,8152,'tr','YardÄ±m talep tÃ¼rÃ¼',0),(293441,8152,'pl','Rodzaj pomocy zgÅ‚oszony',0),(293442,8152,'bg','Ð’Ð¸Ð´ Ð½Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰Ñ‚Ð° Ð¸Ð·Ð¸ÑÐºÐ²Ð°',0),(293443,8152,'ur','Ù‚Ø³Ù… Ú©ÛŒ Ù…Ø¯Ø¯ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ',0),(293444,8152,'sr','Ð¢Ð¸Ð¿ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸ Ð·Ð°Ñ‚Ñ€Ð°Ð¶Ð¸Ð¾',0),(293445,8152,'vi','Loáº¡i trá»£ giÃºp yÃªu cáº§u',0),(293446,8152,'af','Tipe Hulp wat Versoek word',0),(293447,8152,'ro','Tipul de ajutor solicitat',0),(293448,8152,'et','Taotletud abi tÃ¼Ã¼pi',0),(293449,8152,'si','Vrsta pomoÄi, zahteva',0),(293450,8152,'ba','Jenis bantuan yang diminta',0),(293451,8152,'nl','Soort Help-informatie opgevraagd',0),(293452,8152,'fi','Millaisia ohjeita pyydetÃ¤Ã¤n',0),(293453,8152,'no','Type hjelp Ã¸nsket',0),(293454,8152,'da','Type af hjÃ¦lp anmodet',0),(293455,8152,'ko','ë„ì›€ ìš”ì²­ ìœ í˜•',0),(293456,8152,'he','×¡×•×’ ×”×¢×–×¨×” ×”×ž×‘×•×§×©',0),(293457,8152,'el','Î¤ÏÏ€Î¿Ï‚ Î²Î¿Î®Î¸ÎµÎ¹Î± Î¶Î·Ï„Î¿ÏÎ¼ÎµÎ½ÎµÏ‚',0),(293458,8152,'zh','å¸®åŠ©è¯·æ±‚çš„ç±»åž‹\r\n',0),(293459,8152,'sv','Typ av hjÃ¤lp efterfrÃ¥gade',0),(293460,8152,'it','Tipo di aiuto richiesto',0),(293461,8152,'tl','',0),(293462,8152,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3588;&#3623;&#3634;&#3617;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(293463,8152,'hi','à¤®à¤¦à¤¦ à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(293464,8152,'ms','Jenis bantuan yang diminta',0),(293465,8152,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(293466,8152,'fr','Type d\'aide demandÃ©e',0),(293467,8152,'jp','è¦æ±‚ã•ã‚ŒãŸãƒ˜ãƒ«ãƒ—ã®ã‚¿ã‚¤ãƒ—',0),(293468,8152,'pt','Tipo de ajuda solicitada',0),(293469,8152,'ru','Ð¢Ð¸Ð¿ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸, Ð¿Ñ€Ð¾ÑÐ¸Ð»Ð°',0),(293470,8152,'es','Tipo de Ayuda Solicitado',0),(293471,8152,'de','Art der Hilfe angefordert',0),(293472,8152,'en','Type Of Help Requested',0),(293473,8153,'is','',0),(293474,8153,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´',0),(293475,8153,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´',0),(293476,8153,'tr','SipariÅŸ bakiyesi maddeler',0),(293477,8153,'pl','PowrÃ³t kolejnoÅ›Ä‡ elementÃ³w',0),(293478,8153,'bg','ÐÐµÐ¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(293479,8153,'ur','ÙˆØ§Ù¾Ø³ Ø­Ú©Ù… Ú©ÛŒ Ø§Ø´ÛŒØ§Ø¡',0),(293480,8153,'sr','Ð—Ð°Ð´ÑšÐ¸ Ñ€ÐµÐ´ ÑÑ‚Ð°Ð²ÐºÐµ',0),(293481,8153,'vi','HÃ ng Cá»§a ÄÆ¡n HÃ ng ChÆ°a Thá»±c Hiá»‡n Ngay',0),(293482,8153,'af','Teruggehoue/Agterstallige Items',0),(293483,8153,'ro','Ordinea spate elemente',0),(293484,8153,'et','JÃ¤reltellimuse kaupade',0),(293485,8153,'si','Nalogih elementov',0),(293486,8153,'ba','Kembali urutan item',0),(293487,8153,'nl','Nabestelling Items',0),(293488,8153,'fi','JÃ¤lkitoimituksen nimikkeiden',0),(293489,8153,'no','Restordren elementer',0),(293490,8153,'da','Tilbage Bestil emner',0),(293491,8153,'ko','ë‹¤ì‹œ ì£¼ë¬¸ í•­ëª©',0),(293492,8153,'he','×’×‘ ×œ×”×–×ž×™×Ÿ ×¤×¨×™×˜×™×',0),(293493,8153,'el','Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(293494,8153,'zh','æ¬ è´§é¡¹ç›®\r\n',0),(293495,8153,'sv','Tillbaka bestÃ¤lla artiklar',0),(293496,8153,'it','Elementi di ordine posteriore',0),(293497,8153,'tl','',0),(293498,8153,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3627;&#3621;&#3633;&#3591;',0),(293499,8153,'hi','à¤µà¤¾à¤ªà¤¸ à¤†à¤¦à¥‡à¤¶ à¤†à¤‡à¤Ÿà¤®',0),(293500,8153,'ms','Barang-barang belakang perintah',0),(293501,8153,'ar','Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù†Ø¸Ø§Ù… Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(293502,8153,'fr','Ã‰lÃ©ments de commande en diffÃ©rÃ©',0),(293503,8153,'jp','ãƒãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼ã®ã‚¢ã‚¤ãƒ†ãƒ ',0),(293504,8153,'pt','Itens de fim de volta',0),(293505,8153,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð·Ð°Ð´Ð½ÐµÐ¹ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(293506,8153,'es','Items de Pedidos en Espera',0),(293507,8153,'de','Hintere Bestellartikel',0),(293508,8153,'en','Back Order Items',0),(293509,8154,'is','',0),(293510,8154,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´ ',0),(293511,8154,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´ ',0),(293512,8154,'tr','Geri sipariÅŸ edilen maddeler listesi',0),(293513,8154,'pl','List z powrotem zamÃ³wionych towarÃ³w',0),(293514,8154,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð³ÑŠÑ€Ð±Ð° Ð¿Ð¾Ñ€ÑŠÑ‡Ð°Ð½Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(293515,8154,'ur','Ú©Ù…Ø± Ù¾Û’ Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(293516,8154,'sr','Ð›Ð¸ÑÑ‚Ðµ ÑÐ° ÑÐ¿Ð¾Ñ€ÐµÐ´Ð½Ð¸Ð¼ Ð¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ',0),(293517,8154,'vi','Danh sÃ¡ch hÃ ng cá»§a Ä‘Æ¡n hÃ ng chÆ°a thá»±c hiá»‡n ngay',0),(293518,8154,'af','Lys van Teruggehoue/Agterstallige Items',0),(293519,8154,'ro','Liste de articole comandate spate',0),(293520,8154,'et','Tagasi tellitud kaupade loendid',0),(293521,8154,'si','Seznami nazaj naroÄenih artiklov',0),(293522,8154,'ba','Daftar kembali orderan',0),(293523,8154,'nl','Lijsten van terug bestelde artikelen',0),(293524,8154,'fi','Luettelo takaisin tilatut nimikkeet',0),(293525,8154,'no','Lister over ryggen bestilte varer',0),(293526,8154,'da','Lister over tilbage bestilte varer',0),(293527,8154,'ko','ë‹¤ì‹œ ì£¼ë¬¸í•œ ìƒí’ˆì˜ ëª©ë¡',0),(293528,8154,'he','×¨×©×™×ž×•×ª ×©×œ ×¤×¨×™×˜×™× ×©×”×•×–×ž× ×• ×”××—×•×¨×™',0),(293529,8154,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Ï€Î¯ÏƒÏ‰ Ï„Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¸Î­Î½Ï„Î± ÎµÎ¯Î´Î·',0),(293530,8154,'zh','æ¬ äº¤è®¢è´§é¡¹ç›®åˆ—è¡¨\r\n',0),(293531,8154,'sv','Listor Ã¶ver tillbaka bestÃ¤llda artiklar',0),(293532,8154,'it','Elenchi di elementi ordinati posteriori',0),(293533,8154,'tl','',0),(293534,8154,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3585;&#3621;&#3633;&#3610;&#3617;&#3634;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3629;&#3637;&#3585;',0),(293535,8154,'hi','à¤ªà¥€à¤  à¤•à¤¾ à¤†à¤¦à¥‡à¤¶ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(293536,8154,'ms','Senarai item-item disusun kembali',0),(293537,8154,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(293538,8154,'fr','Listes des articles commandÃ©s arriÃ¨re',0),(293539,8154,'jp','ãƒãƒƒã‚¯é †åºä»˜ã‘ã‚‰ã‚ŒãŸé …ç›®ã®ä¸€è¦§',0),(293540,8154,'pt','Listas de itens ordenados traseiras',0),(293541,8154,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ð½Ñ‹Ðµ Ñ‚Ð¾Ð²Ð°Ñ€Ñ‹',0),(293542,8154,'es','Listas de Items de Pedidos en Espera',0),(293543,8154,'de','Liste der bestellten Artikel zurÃ¼ck',0),(293544,8154,'en','Lists Of Back Ordered Items',0),(293545,8155,'is','',0),(293546,8155,'dr','(Ø¨Ø±Ú¯Ø´Øª Ø§Ø² ÙØ±Ù…Ø§ÛŒØ´',0),(293547,8155,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ù…Ø¹ÙˆÙ‚(Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´',0),(293548,8155,'tr','Maddenin arka sipariÅŸler',0),(293549,8155,'pl','Przedmiot zamÃ³wienia',0),(293550,8155,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ Ð½ÐµÐ¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(293551,8155,'ur','ÙˆØ§Ù¾Ø³ Ø´Û’ Ú©Ø§ Ø­Ú©Ù… Ø¯Û’ Ø¯ÛŒØ§',0),(293552,8155,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ð½Ð°Ð³Ð¾Ð¼Ð¸Ð»Ð°Ð½Ð¾Ð³',0),(293553,8155,'vi','Máº·t hÃ ng cá»§a Ä‘Æ¡n hÃ ng chÆ°a thá»±c hiá»‡n ngay',0),(293554,8155,'af','Teruggehoue/Agterstallige Bestellings Items',0),(293555,8155,'ro','Element Ã®napoi ordinele',0),(293556,8155,'et','Kauba jÃ¤reltellimused',0),(293557,8155,'si','Postavka nazaj naroÄila',0),(293558,8155,'ba','Item kembali perintah',0),(293559,8155,'nl','Item terug bestellingen',0),(293560,8155,'fi','Nimikkeen jÃ¤lkitoimitukset',0),(293561,8155,'no','Elementet restordrer',0),(293562,8155,'da','Vare tilbage ordrer',0),(293563,8155,'ko','í•­ëª© ë‹¤ì‹œ ì •ë ¬',0),(293564,8155,'he','×”×¤×¨×™×˜ ×—×–×¨×” ×”×–×ž× ×•×ª',0),(293565,8155,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(293566,8155,'zh','é¡¹ç›®å¾…è¡¥\r\n',0),(293567,8155,'sv','Objektet tillbaka order',0),(293568,8155,'it','Elemento ordini arretrati',0),(293569,8155,'tl','',0),(293570,8155,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3619;&#3629;&#3610;&#3627;&#3621;&#3633;&#3591;',0),(293571,8155,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¾à¤ªà¤¸ à¤†à¤¦à¥‡à¤¶',0),(293572,8155,'ms','Item kembali pesanan',0),(293573,8155,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø¯ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(293574,8155,'fr','Point de commandes en souffrance',0),(293575,8155,'jp','ãƒãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼ã®ã‚¢ã‚¤ãƒ†ãƒ ',0),(293576,8155,'pt','Item pedidos',0),(293577,8155,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(293578,8155,'es','Items de Pedido en Espera',0),(293579,8155,'de','Element Nachlieferungen',0),(293580,8155,'en','Item Back Orders',0),(293581,8156,'is','',0),(293582,8156,'dr','ØªÙ…Ø§Ù… Ù…ÙˆØ§Ø±Ø¯ Ø´Ø§Ù…Ù„ Ø¬Ø¯ÙŠØ¯ ØªØ±ÙŠÙ† Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ùˆ ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ù¾Ø´ØªÙŠØ¨Ø§ Ù† Ø´Ø¨Ø§Ù†Ù‡ ØªÙˆØ³Ø· Ø³Ø§ÙŠØª Ù…ÙŠØ²Ø¨Ø§Ù† Ù…Ø­Ø§ÙØ¸Øª Ù…ÙŠ Ø´ÙˆØ¯ ',0),(293583,8156,'pr','ØªÙ…Ø§Ù… Ù…ÙˆØ§Ø±Ø¯ Ø´Ø§Ù…Ù„ Ø¬Ø¯ÙŠØ¯ ØªØ±ÙŠÙ† Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ùˆ ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ù¾Ø´ØªÙŠØ¨Ø§ Ù† Ø´Ø¨Ø§Ù†Ù‡ ØªÙˆØ³Ø· Ø³Ø§ÙŠØª Ù…ÙŠØ²Ø¨Ø§Ù† Ù…Ø­Ø§ÙØ¸Øª Ù…ÙŠ Ø´ÙˆØ¯ ',0),(293584,8156,'tr','Her ÅŸey dahil gÃ¼venli site barÄ±ndÄ±rma sorunsuz yÃ¼kseltmeleri ve gecelik yedekleme',0),(293585,8156,'pl','All Inclusive bezpiecznej witryny hosting z bezproblemowÄ… aktualizacje i wieczorne kopii zapasowych',0),(293586,8156,'bg','ÐžÐ» Ð¸Ð½ÐºÐ»ÑƒÐ·Ð¸Ð² Ð·Ð°Ñ‰Ð¸Ñ‚ÐµÐ½ ÑÐ°Ð¹Ñ‚ Ñ…Ð¾ÑÑ‚Ð¸Ð½Ð³ Ñ Ð±ÐµÐ·ÑˆÐµÐ²Ð½Ð¸ Ð½Ð°Ð´ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¸ Ð½Ð¾Ñ‰Ð½Ð¸ Ð°Ñ€Ñ…Ð¸Ð²Ð¸',0),(293587,8156,'ur','Ø³ÛŒÙ…Ù„ÛŒØ³ Ø§Ù¾ Ú¯Ø±ÛŒÚˆ Ø§ÙˆØ± Ø±Ø§Øª Ù¾Ø´ØªØ§Ø±ÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÙØ¶Ø§ÙÛ Ù…Ø­ÙÙˆØ¸ ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ ÛÙˆØ³Ù¹Ù†Ú¯',0),(293588,8156,'sr','Ð¡Ð²ÐµÐ¾Ð±ÑƒÑ…Ð²Ð°Ñ‚Ð½Ð¾Ð³ ÑÐ¸Ð³ÑƒÑ€Ð½Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð´Ð¾Ð¼Ð°Ñ›Ð¸Ð½ ÑÐ° Ð‘ÐµÑˆÐ°Ð²Ð½Ðµ Ð½Ð°Ð´Ð¾Ð³Ñ€Ð°Ð´ÑšÐµ Ð¸ Ð½Ð¾Ñ›Ð½Ð¾ Ñ€ÐµÐ·ÐµÑ€Ð²Ð½Ðµ ÐºÐ¾Ð¿Ð¸Ñ˜Ðµ',0),(293589,8156,'vi','Trang hosting an ninh vá»›i táº¥t cáº£ má»i chá»©c nÄƒng, dá»… dÃ ng nÃ¢ng cáº¥p vÃ  sao chÃ©p dá»± phÃ²ng hÃ ng Ä‘Ãªm',0),(293590,8156,'af','\'n Alles-isluitende veilige gasheerterrein met onbeperkte opgraderings en nagtelike rugsteunings (maak van reserwekopiÃ«)',0),(293591,8156,'ro','Site-ul securizat all-inclusive gazduieste cu upgrade-uri fÄƒrÄƒ sudurÄƒ ÅŸi noapte backup',0),(293592,8156,'et','\"KÃµik hinnas\" turvalisi site hosting Ãµmbluseta uuendused ja Ã¶Ã¶sel varukoopiaid',0),(293593,8156,'si','All-inclusive varno mesto gosti z brezÅ¡ivne nadgradnje in dnevnih izdelav varnostnih kopij',0),(293594,8156,'ba','Hosting situs aman lengkap dengan mulus upgrade dan backup malam',0),(293595,8156,'nl','All-inclusive beveiligde site hosting met naadloze upgrades en nachtelijke back-ups',0),(293596,8156,'fi','All-Inclusive suojatun sivuston hosting saumattomien pÃ¤ivitykset ja Ã¶isin varmuuskopiot',0),(293597,8156,'no','All-inclusive sikkert nettsted hosting med sÃ¸mlÃ¸s oppgraderinger og nattlig backuper',0),(293598,8156,'da','All inclusive-sikkert websted hosting med problemfri opgraderinger og natlig sikkerhedskopier',0),(293599,8156,'ko','ì›í™œí•œ ì—…ê·¸ë ˆì´ë“œì™€ ì•¼ê°„ ë°±ì—… ëª¨ë“  ë³´ì•ˆ ì‚¬ì´íŠ¸ í˜¸ìŠ¤íŒ…',0),(293600,8156,'he','××—×¡×•×Ÿ ××ª×¨×™× ×ž××•×‘×˜×— ×”×›×œ ×›×œ×•×œ ×¢× ×©×“×¨×•×’×™× ×—×œ×§×” ×’×™×‘×•×™×™× ×œ×™×œ×™×™×',0),(293601,8156,'el','All-inclusive Î±ÏƒÏ†Î±Î»Î® Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Ï†Î¹Î»Î¿Î¾ÎµÎ½Î¯Î± Î¼Îµ Ï„Î·Î½ Î¬Î½ÎµÏ… ÏÎ±Ï†Î®Ï‚ Î±Î½Î±Î²Î±Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ ÎºÎ±Î¹ ÎºÎ¬Î¸Îµ Î²ÏÎ¬Î´Ï… Ï€Î»Î¬Ï„Î·',0),(293602,8156,'zh','å…¨åŒ…çš„å®‰å…¨ç½‘ç«™æ— ç—•å‡çº§å’Œå¤œé—´å¤‡ä»½ä¸»æœº\r\n',0),(293603,8156,'sv','All inclusive-sÃ¤ker webbplats hosting med sÃ¶mlÃ¶s uppgraderingar och nattliga sÃ¤kerhetskopieringar',0),(293604,8156,'it','Sito sicuro all inclusive hosting con aggiornamenti senza soluzione di continuitÃ  e backup notturno',0),(293605,8156,'tl','',0),(293606,8156,'th','All-inclusive secure site hosting with seamless upgrades and nightly backups',0),(293607,8156,'hi','à¤¸à¤­à¥€ à¤¸à¤®à¤¾à¤µà¥‡à¤¶à¥€ à¤¸à¥à¤°à¤•à¥à¤·à¤¿à¤¤ à¤¸à¤¾à¤‡à¤Ÿ à¤¨à¤¿à¤°à¥à¤¬à¤¾à¤§ à¤‰à¤¨à¥à¤¨à¤¯à¤¨ à¤”à¤° à¤¹à¤° à¤°à¤¾à¤¤ à¤¬à¥ˆà¤•à¤…à¤ª à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¹à¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤—',0),(293608,8156,'ms','Semua termasuk tapak selamat hosting dengan menaik-taraf lancar dan sandaran setiap malam',0),(293609,8156,'ar','Ø§Ø³ØªØ¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹ Ø£Ù…Ù† Ø´Ø§Ù…Ù„Ø© Ù…Ø¹ ØªØ±Ù‚ÙŠØ§Øª Ø³Ù„Ø³ ÙˆØ§Ù„Ù†Ø³Ø® Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠØ© Ù„ÙŠÙ„Ø§',0),(293610,8156,'fr','Site sÃ©curisÃ© tout compris hÃ©bergement avec mise Ã  niveau transparente et sauvegardes nocturnes',0),(293611,8156,'jp','ã‚ªãƒ¼ãƒ«ã‚¤ãƒ³ã‚¯ãƒ«ãƒ¼ã‚·ãƒ–ã®ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£ã§ä¿è­·ã•ã‚ŒãŸã‚µã‚¤ãƒˆã‚’ãƒ›ã‚¹ãƒˆã™ã‚‹ã‚·ãƒ¼ãƒ ãƒ¬ã‚¹ãªã‚¢ãƒƒãƒ—ã‚°ãƒ¬ãƒ¼ãƒ‰ã¨å¤œé–“ãƒãƒƒã‚¯ã‚¢ãƒƒãƒ—',0),(293612,8156,'pt','Hospedagem de site seguro com tudo incluÃ­do com upgrades perfeitos e backups noturnos',0),(293613,8156,'ru','Ð’ÑÐµ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¾ Ð·Ð°Ñ‰Ð¸Ñ‰ÐµÐ½Ð½Ñ‹Ð¹ ÑÐ°Ð¹Ñ‚ Ñ…Ð¾ÑÑ‚Ð¸Ð½Ð³ Ñ Ð±ÐµÑÑˆÐ¾Ð²Ð½Ð¾Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¹ Ð¸ Ð½Ð¾Ñ‡Ð½Ñ‹Ñ… Ñ€ÐµÐ·ÐµÑ€Ð²Ð½Ñ‹Ñ… ÐºÐ¾Ð¿Ð¸Ð¹',0),(293614,8156,'es','Todo-inclusivo sitio seguro de hospedaje con actualizaciones a la nueva versiÃ³n automÃ¡ticas y respaldas cada noche',0),(293615,8156,'de','All-Inclusive sichere Website hosting mit nahtlosen Upgrades und nÃ¤chtliche backups',0),(293616,8156,'en','All-inclusive secure site hosting with seamless upgrades and nightly backups',0),(293617,8157,'is','',0),(293618,8157,'dr','9 Ø¯Ø± Ø§ÙŠÙ† Ø³Ø§ÙØª ÙˆÛŒØ± ØªÙ†Ø¸ÙŠÙ… Ø´Ø¯ â€“ Ø¨Ø±Ø§ÙŠ ÙŠØ§Ø¯Ú¯ÙŠØ±ÙŠ Ø¨ÙŠØ´ØªØ± Ø±ÙˆÙŠ ØªØµÙˆÙŠØ± Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(293619,8157,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø³ØªÙŠ Ø¹Ø¯Ø¯ 9 Ø¯Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ØªÙ†Ø¸ÙŠÙ… Ø´Ø¯ â€“ Ø¨Ø±Ø§ÙŠ ÙŠØ§Ø¯Ú¯ÙŠØ±ÙŠ Ø¨ÙŠØ´ØªØ± Ø±ÙˆÙŠ ØªØµÙˆÙŠØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(293620,8157,'tr','NolaPro\'nÄ±n dokuz (9) seviyesini Manuel ayarlamak--daha fazla bilgi edinmek iÃ§in buraya tÄ±klayÄ±n',0),(293621,8157,'pl','NolaPro na dziewiÄ™Ä‡ (9) wielkoÅ›Ä‡ rÄ™czny zestaw--kliknij tutaj, aby dowiedzieÄ‡ siÄ™ wiÄ™cej',0),(293622,8157,'bg','ÐÐ° NolaPro Ð² Ð´ÐµÐ²ÐµÑ‚ (9) Ñ‚Ð¾Ð¼ Ñ€ÑŠÑ‡ÐµÐ½ Ð½Ð°Ð±Ð¾Ñ€--Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð½Ð°ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ',0),(293623,8157,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ú©ÛŒ Ù†Ùˆ (9) Ø¢ÚˆÛŒÙˆ Ø¯Ø³ØªÛŒ Ø³ÛŒÙ¹ - Ù…Ø²ÛŒØ¯ Ø¬Ø§Ù†Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(293624,8157,'sr','ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ñ˜Ðµ Ð´ÐµÐ²ÐµÑ‚ (9) Ñ€ÑƒÑ‡Ð½Ð¸ ÑÐºÑƒÐ¿ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½Ð°--ÐºÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑÐ°Ð·Ð½Ð°Ð»Ð¸ Ð²Ð¸ÑˆÐµ',0),(293625,8157,'vi','NolaPro hÆ°á»›ng dáº«n 9 - Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ há»c',0),(293626,8157,'af','NolaPro se nege (9) volume handleidingstel -- kliek hier om meer te leer',0),(293627,8157,'ro','NolaPro pe nouÄƒ (9) volumul manual setul--click aici pentru a afla mai multe',0),(293628,8157,'et','NolaPro\'s Ã¼heksa (9) KÃ¶ide kÃ¤sitsi seatud--klÃµpsake siin, et rohkem',0),(293629,8157,'si','NolaPro je devet (9) roÄni nosilcev--kliknite tukaj, Äe Å¾elite izvedeti veÄ',0),(293630,8157,'ba','NolaPro\'s sembilan (9) volume manual set--klik di sini untuk mempelajari lebih lanjut',0),(293631,8157,'nl','NolaPro van negen (9) handmatige volumeset--Klik hier om meer te leren',0),(293632,8157,'fi','NolaPro on yhdeksÃ¤n (9) manuaalinen levysarjan--klikkaa tÃ¤stÃ¤ lisÃ¤tietoja',0),(293633,8157,'no','Nolapros ni (9) manuell volumsett--Klikk her for Ã¥ lÃ¦re mer',0),(293634,8157,'da','Nolapros ni (9) volumen manuel sÃ¦t--Klik her for at lÃ¦re mere',0),(293635,8157,'ko','NolaProì˜ 9 (9) ì–‘ ìˆ˜ë™ ì„¸íŠ¸-ìžì„¸í•œ ë‚´ìš©ì€ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì„¸ìš”',0),(293636,8157,'he','×›×¨×š 9 (9) ×©×œ NolaPro ×¡×˜ ×™×“× ×™ - ×œ×—×¦×• ×›××Ÿ ×›×“×™ ×œ×œ×ž×•×“ ×¢×•×“',0),(293637,8157,'el','Î•Î³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î¿ ÏƒÏÎ½Î¿Î»Î¿ ÎµÎ½Î½Î­Î± (9) Î¿ ÏŒÎ³ÎºÎ¿Ï‚ Ï„Î¿Ï… NolaPro--ÎºÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î¼Î¬Î¸ÎµÏ„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ±',0),(293638,8157,'zh','NolaProçš„ä¹ï¼ˆ9ï¼‰å®¹é‡æ‰‹åŠ¨è®¾ç½®- ç‚¹å‡»è¿™é‡Œäº†è§£æ›´å¤š\r\n',0),(293639,8157,'sv','Nolapros nio (9) manuell volymuppsÃ¤ttning--Klicka hÃ¤r fÃ¶r att lÃ¤sa mer',0),(293640,8157,'it','Set manuale del volume di nove 9 di NolaPro..--Clicca qui per saperne di piÃ¹',0),(293641,8157,'tl','',0),(293642,8157,'th','NolaPro\'s nine (9) volume manual set -- click here to learn more',0),(293643,8157,'hi','NolaPro à¤•à¥€ à¤¨à¥Œ (9) à¤–à¤‚à¤¡ à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤¸à¥‡à¤Ÿ - à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚ à¤…à¤§à¤¿à¤• à¤œà¤¾à¤¨à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(293644,8157,'ms','NolaPro di sembilan (9) Jumlah manual set--klik di sini untuk mengetahui lebih lanjut',0),(293645,8157,'ar','Ø­Ø¬Ù… 9 ØªØ³Ø¹Ø© Ù…Ø¬Ù…ÙˆØ¹Ø© Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ø§Ù„ÙŠØ¯ÙˆÙŠ-Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ù…Ø¹Ø±ÙØ© Ø§Ù„Ù…Ø²ÙŠØ¯',0),(293646,8157,'fr','Jeu manuel de NolaPro neuf 9 volume--cliquez ici pour en savoir plus',0),(293647,8157,'jp','NolaPro ã® 9 9 å·»ãƒžãƒ‹ãƒ¥ã‚¢ãƒ« ã‚»ãƒƒãƒˆ - ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦è©³ç´°ã‚’ã”è¦§ãã ã•ã„ã€‚',0),(293648,8157,'pt','Conjunto de manual do NolaPro volume 9 nove..--Clique aqui para saber mais',0),(293649,8157,'ru','NolaPro Ð² Ð´ÐµÐ²ÑÑ‚ÑŒ (9) Ð¾Ð±ÑŠÐµÐ¼ Ñ€ÑƒÑ‡Ð½Ð¾Ð¹ Ð½Ð°Ð±Ð¾Ñ€--Ð½Ð°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑƒÐ·Ð½Ð°Ñ‚ÑŒ Ð±Ð¾Ð»ÑŒÑˆÐµ',0),(293650,8157,'es','Juego de nueve volÃºmenes de manual de NolaPro -- hace click aqui para aprender m{as',0),(293651,8157,'de','Artikel von neun 9 manuelle DatentrÃ¤gersatz--klicken Sie hier, um mehr zu erfahren',0),(293652,8157,'en','NolaPro\'s nine (9) volume manual set -- click here to learn more',0),(293653,8158,'is','',0),(293654,8158,'dr','Ø¨Ø±Ø±Ø³ÙŠ   Ø¬Ù‡Øª Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø¨Ø§Ø± ÙƒØ¯ Ø±ÙˆÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ø¬ÙˆØ§Ø² Ø¹Ø¨ÙˆØ±',0),(293655,8158,'pr','Ø¨Ø±Ø±Ø³ÙŠ   Ø¬Ù‡Øª Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø¨Ø§Ø± ÙƒØ¯ Ø±ÙˆÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ø¬ÙˆØ§Ø² Ø¹Ø¨ÙˆØ±',0),(293656,8158,'tr','Blok barkod Pick bilet kontrol edin',0),(293657,8158,'pl','SprawdÅº kod kreskowy bloku na pobranie biletu',0),(293658,8158,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð±Ð»Ð¾Ðº Ñ‰Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ Ð½Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð±Ð¸Ð»ÐµÑ‚',0),(293659,8158,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù¹Ú©Ù¹ Ù¾Ø± Ø¨Ù„Ø§Ú© Ø¨Ø§Ø± Ø¶Ø§Ø¨Ø·Û Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(293660,8158,'sr','ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð»Ð¾Ðº Ð‘Ð°Ñ€ ÐºÐ¾Ð´Ð° Ð½Ð° Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(293661,8158,'vi','ÄÃ¡nh dáº¥u Ä‘á»ƒ Ä‘áº·t mÃ£ váº¡ch trÃªn phiáº¿u',0),(293662,8158,'af','Kontroleer blok Bar kode op Pick kaartjie',0),(293663,8158,'ro','VerificaÅ£i codul de bloc Bar alege biletul',0),(293664,8158,'et','Kontrollige ploki vÃ¶Ã¶tkoodi noppimise pilet',0),(293665,8158,'si','Preverite blok Ärtne kode na Pick vozovnice',0),(293666,8158,'ba','Periksa bilah blok kode pada tiket Pick',0),(293667,8158,'nl','Controleer blok streepjescode op Pick Ticket',0),(293668,8158,'fi','Tarkista kappale-palkki Code Pick lippu',0),(293669,8158,'no','Sjekk for Ã¥ blokkere strekkode pÃ¥ plukke billett',0),(293670,8158,'da','Kontroller at blok stregkode pÃ¥ Pick billet',0),(293671,8158,'ko','ë¸”ë¡ ì„ íƒ í‹°ì¼“ì— ë°”ì½”ë“œ í™•ì¸',0),(293672,8158,'he','×‘×“×•×§ ×›×“×™ ×œ×—×¡×•× ×‘×¨×§×•×“ ×¢×œ ×”×›×¨×˜×™×¡ ×¤×™×§',0),(293673,8158,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î¼Ï€Î±Ï Î¼Ï€Î»Î¿Îº ÎºÏŽÎ´Î¹ÎºÎ± ÏƒÏ„Î¿ Pick ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(293674,8158,'zh','æ£€æŸ¥é˜»æ­¢å°±é€‰æ‹©æ¡ç ç¥¨åŠ¡\r\n',0),(293675,8158,'sv','Kontrollera att blockera streckkod pÃ¥ Pick biljett',0),(293676,8158,'it','Verifica al codice a barre di blocco sul biglietto Pick',0),(293677,8158,'tl','',0),(293678,8158,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3614;&#3639;&#3656;&#3629;&#3611;&#3657;&#3629;&#3591;&#3585;&#3633;&#3609;&#3610;&#3634;&#3619;&#3660;&#3650;&#3588;&#3657;&#3604;&#3610;&#3609;&#3610;&#3633;&#3605;&#3619;&#3650;&#3604;&#3618;&#3',0),(293679,8158,'hi','à¤‰à¤ à¤¾à¤“ à¤Ÿà¤¿à¤•à¤Ÿ à¤ªà¤° à¤¬à¥à¤²à¥‰à¤• à¤¬à¤¾à¤° à¤•à¥‹à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤šà¥‡à¤‚',0),(293680,8158,'ms','Semak Kod Bar blok atas Tiket pengangkutan',0),(293681,8158,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø´Ø±ÙŠØ· ÙƒØªÙ„Ø© Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ø¹Ù„Ù‰ Ø§Ù„ØªØ°Ø§ÙƒØ± Ø¨ÙŠÙƒ',0),(293682,8158,'fr','VÃ©rifier au bloc Bar Code sur billet choix',0),(293683,8158,'jp','ãƒ–ãƒ­ãƒƒã‚¯ ãƒãƒ¼ ã‚³ãƒ¼ãƒ‰ ãƒ”ãƒƒã‚¯ ãƒã‚±ãƒƒãƒˆã«ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(293684,8158,'pt','Verifique para cÃ³digo de barras do bloco no bilhete de Pick',0),(293685,8158,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð±Ð»Ð¾Ðº ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ Ð½Ð° Ð±Ð¸Ð»ÐµÑ‚Ðµ Pick',0),(293686,8158,'es','Checar para Bloquear CÃ³digo de Barras en Boleto de SelecciÃ³n',0),(293687,8158,'de','Block-Bar-Codes auf Pick Ticket Ã¼berprÃ¼fen',0),(293688,8158,'en','Check To Block Bar Code On Pick Ticket',0),(293689,8159,'is','',0),(293690,8159,'dr','Ø¨Ø±Ø±Ø³ÙŠ  Ø¬Ù‡Øª Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø³Ø± ØµÙØ­Ù‡  Ø±ÙˆÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ø¬ÙˆØ§Ø² Ø¹Ø¨ÙˆØ±',0),(293691,8159,'pr','Ø¨Ø±Ø±Ø³ÙŠ  Ø¬Ù‡Øª Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø³Ø± ØµÙØ­Ù‡  Ø±ÙˆÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ø¬ÙˆØ§Ø² Ø¹Ø¨ÙˆØ±',0),(293692,8159,'tr','Pick bilet baÅŸlÄ±ÄŸÄ±nda engellemek iÃ§in kontrol edin',0),(293693,8159,'pl','Zaznacz, aby zablokowaÄ‡ nagÅ‚Ã³wek na pobranie biletu',0),(293694,8159,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð·Ð° Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð³Ð»Ð°Ð²Ð½Ð¸Ñ Ð±Ð»Ð¾Ðº Ð½Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð±Ð¸Ð»ÐµÑ‚',0),(293695,8159,'ur','ÛÛŒÚˆØ± Ø§Ù†ØªØ®Ø§Ø¨ Ù¹Ú©Ù¹ Ù¾Ø± Ø¨Ù„Ø§Ú© Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(293696,8159,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð´Ð° Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð° Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ðµ Ð½Ð° Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(293697,8159,'vi','ÄÃ¡nh dáº¥u Ä‘á»ƒ Ä‘áº·t tiÃªu Ä‘á» trÃªn phiáº¿u ',0),(293698,8159,'af','Kontroleer blokkeer kop op Pick kaartjie',0),(293699,8159,'ro','VerificaÅ£i pentru a bloca antet pe bilet de Pick',0),(293700,8159,'et','Kontrollige blokeerida pÃ¤ise noppimise pilet',0),(293701,8159,'si','Preverite blokirati glavo na Pick vozovnice',0),(293702,8159,'ba','Periksa untuk blok Header pada tiket Pick',0),(293703,8159,'nl','Controleren om te blokkeren Header op Pick Ticket',0),(293704,8159,'fi','Tarkista estÃ¤Ã¤ otsikon valinta lippu',0),(293705,8159,'no','Sjekk for Ã¥ blokkere topptekst pÃ¥ plukke billett',0),(293706,8159,'da','Kontroller, at blokere Header pÃ¥ Pick billet',0),(293707,8159,'ko','ì„ íƒ í‹°ì¼“ì— í—¤ë” ì°¨ë‹¨ í™•ì¸',0),(293708,8159,'he','×‘×“×•×§ ×›×“×™ ×œ×—×¡×•× ××ª ×”×›×•×ª×¨×ª ×¤×™×§ ×“×• ×—',0),(293709,8159,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î³Î¹Î± Î½Î± ÎµÎ¼Ï€Î¿Î´Î¯ÏƒÎµÎ¹ Ï„Î·Î½ ÎºÎµÏ†Î±Î»Î¯Î´Î± ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(293710,8159,'zh','æ£€æŸ¥ä»¥å°é”ç¥¨æ®æ ‡é¢˜\r\n',0),(293711,8159,'sv','Kontrollera att blockera huvudet pÃ¥ Pick biljett',0),(293712,8159,'it','Controllare per bloccare l\'intestazione biglietto Pick',0),(293713,8159,'tl','',0),(293714,8159,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3614;&#3639;&#3656;&#3629;&#3611;&#3657;&#3629;&#3591;&#3585;&#3633;&#3609;&#3626;&#3656;&#3623;&#3609;&#3610;&#3609;&#3610;&#3633;&#3605;&#3619;&#3650;&#3604;&#3618;&#3626;&#3634;&#3619;',0),(293715,8159,'hi','à¤‰à¤ à¤¾à¤“ à¤Ÿà¤¿à¤•à¤Ÿ à¤ªà¤° à¤¶à¥€à¤°à¥à¤·à¤²à¥‡à¤– à¤•à¥‹ à¤¬à¥à¤²à¥‰à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(293716,8159,'ms','Semak untuk menyekat Header atas Tiket pengangkutan',0),(293717,8159,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† ÙƒØªÙ„Ø© Ø§Ù„Ø±Ø£Ø³ Ø¹Ù„Ù‰ Ø§Ù„ØªØ°Ø§ÙƒØ± Ø¨ÙŠÙƒ',0),(293718,8159,'fr','VÃ©rifier pour le bloc d\'en-tÃªte sur billet choix',0),(293719,8159,'jp','ãƒ”ãƒƒã‚¯ã®ãƒã‚±ãƒƒãƒˆã«é–¢ã™ã‚‹ãƒ˜ãƒƒãƒ€ãƒ¼ã‚’ãƒ–ãƒ­ãƒƒã‚¯ã™ã‚‹ã«ã¯ã€ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(293720,8159,'pt','Verifique para bloquear o cabeÃ§alho no bilhete de Pick',0),(293721,8159,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²Ð¾Ðº Ð’Ñ‹Ð±Ð¾Ñ€ Ð±Ð¸Ð»ÐµÑ‚Ð°',0),(293722,8159,'es','Checar para Bloquear Encabezado en el Boleto de SelecciÃ³n',0),(293723,8159,'de','Header auf Pick Ticket Block Ã¼berprÃ¼fen',0),(293724,8159,'en','Check To Block Header On Pick Ticket',0),(293725,8160,'is','',0),(293726,8160,'dr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ ',0),(293727,8160,'pr','Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´ ',0),(293728,8160,'tr','GiriÅŸ sÄ±rasÄ±',0),(293729,8160,'pl','Aby wpis',0),(293730,8160,'bg','Ð’Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(293731,8160,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(293732,8160,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(293733,8160,'vi','Nháº­p ÄÆ¡n Äáº·t HÃ ng',0),(293734,8160,'af','Inskrywing Bestelling',0),(293735,8160,'ro','Ordine de intrare',0),(293736,8160,'et','Kirjete jÃ¤rjestus',0),(293737,8160,'si','Vnos naloga',0),(293738,8160,'ba','Urutan entri',0),(293739,8160,'nl','Entry Order',0),(293740,8160,'fi','RivijÃ¤rjestyksessÃ¤',0),(293741,8160,'no','OppfÃ¸ring rekkefÃ¸lge',0),(293742,8160,'da','Post ordre',0),(293743,8160,'ko','í•­ëª© ìˆœì„œ',0),(293744,8160,'he','×”×¡×“×¨ ×›× ×™×¡×”',0),(293745,8160,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(293746,8160,'zh','æ¡ç›®è®¢å•',0),(293747,8160,'sv','Entry Order',0),(293748,8160,'it','Ordine di entrata',0),(293749,8160,'tl','',0),(293750,8160,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(293751,8160,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(293752,8160,'ms','Perintah kemasukan',0),(293753,8160,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø£Ù…Ø±',0),(293754,8160,'fr','Ordre d\'entrÃ©e',0),(293755,8160,'jp','ã‚¨ãƒ³ãƒˆãƒªã®é †åº',0),(293756,8160,'pt','Ordem de Entrada',0),(293757,8160,'ru','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð½Ð° Ð²Ñ…Ð¾Ð´',0),(293758,8160,'es','Orden de Entrada',0),(293759,8160,'de','Eingabereihenfolge',0),(293760,8160,'en','Entry Order',0),(293761,8161,'is','',0),(293762,8161,'dr','(Ø¯Ø³ØªÙˆØ±) Ú©ÙˆØ¯ Ø¬Ù†Ø³ ',0),(293763,8161,'pr','Ø³ÙØ§Ø±Ø´ (Ø¯Ø³ØªÙˆØ±) ÙƒØ¯ ÙƒØ§Ù„Ø§ ',0),(293764,8161,'tr','Madde kodu sipariÅŸi',0),(293765,8161,'pl','Kod przedmiotu zamÃ³wienia',0),(293766,8161,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» ÐºÐ¾Ð´ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(293767,8161,'ur','Ø´Û’ Ø¶Ø§Ø¨Ø·Û ØªØ±ØªÛŒØ¨',0),(293768,8161,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(293769,8161,'vi','MÃ£ hÃ ng Ä‘á»ƒ Ä‘áº·t hÃ ng',0),(293770,8161,'af','Itemkode Bestelling',0),(293771,8161,'ro','Element Cod comanda',0),(293772,8161,'et','Kauba kood tellimus',0),(293773,8161,'si','Nalog za kodo artikla',0),(293774,8161,'ba','Urutan kode item',0),(293775,8161,'nl','Artikelorder Code',0),(293776,8161,'fi','Nimikkeen koodi tilauksen',0),(293777,8161,'no','ElementrekkefÃ¸lgen kode',0),(293778,8161,'da','Vareordre kode',0),(293779,8161,'ko','í•­ëª© ì½”ë“œ ìˆœì„œ',0),(293780,8161,'he','×¤×¨×™×˜ ×§×•×“ ×”×–×ž× ×”',0),(293781,8161,'el','Î¥ ÎºÏŽÎ´Î¹ÎºÎ±',0),(293782,8161,'zh','é¡¹ç›®ä»£ç é¡ºåº\r\n',0),(293783,8161,'sv','Kod fÃ¶r element',0),(293784,8161,'it','Articolo codice ordine',0),(293785,8161,'tl','',0),(293786,8161,'th','&#3619;&#3627;&#3633;&#3626;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(293787,8161,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤†à¤¦à¥‡à¤¶',0),(293788,8161,'ms','Item kod pesanan',0),(293789,8161,'ar','ØªØ±ØªÙŠØ¨ Ø±Ù…Ø² Ø§Ù„Ø¹Ù†ØµØ±',0),(293790,8161,'fr','Ordre des Code',0),(293791,8161,'jp','é …ç›®ã‚³ãƒ¼ãƒ‰é †',0),(293792,8161,'pt','Ordem de cÃ³digo de item',0),(293793,8161,'ru','Ð—Ð°ÐºÐ°Ð· ÐšÐ¾Ð´Ð° Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(293794,8161,'es','Orden de Item CÃ³digo',0),(293795,8161,'de','Elementreihenfolge Code',0),(293796,8161,'en','Item Code Order',0),(293797,8162,'is','',0),(293798,8162,'dr','(Ù…Ø¬ÙˆØ²) Ø§Ù†ØªØ®Ø§Ø¨ ÙØ±Ù…Ø§ÛŒØ´ ÙƒØ§Ù…Ù„',0),(293799,8162,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ø¨Ù„ÙŠØ· (Ù…Ø¬ÙˆØ²) Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù…Ù„',0),(293800,8162,'tr','SÄ±ralama dÃ¼zeni yerine getirme emri Ã§ekme bilet Ã¶ÄŸeler iÃ§in',0),(293801,8162,'pl','KolejnoÅ›Ä‡ sortowania dla elementÃ³w realizacji zamÃ³wienia odbioru biletÃ³w',0),(293802,8162,'bg','Ð ÐµÐ´ Ð½Ð° ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ñ€ÐµÐ´ Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð±Ð¸Ð»ÐµÑ‚',0),(293803,8162,'ur','ØªÚ©Ù…ÛŒÙ„ Ø­Ú©Ù… Ø§Ù†ØªØ®Ø§Ø¨ Ù¹Ú©Ù¹ Ù¾Ø± Ø§Ø´ÛŒØ§ Ú©Û’ Ù„ÛŒÛ’ Ú†Ú¾Ø§Ù†Ù¹ ØªØ±ØªÛŒØ¨',0),(293804,8162,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°ÑšÐ° Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ð½Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(293805,8162,'vi','Sáº¯p xáº¿p Ä‘Æ¡n hÃ ng cho cÃ¡c máº·t hÃ ng cá»§a Ä‘Æ¡n hÃ ng giao táº­n nÆ¡i ',0),(293806,8162,'af','Sorteer Bestelling Vir Items Op Uitvoeringsbestelling Elite Kaartjies',0),(293807,8162,'ro','Ordinea de sortare pentru elemente pe Ã®ndeplinirea comenzii Pick bilet',0),(293808,8162,'et','Plaanitud tellimuse kÃ¤tte Piletite kaupade sortimisjÃ¤rjestus',0),(293809,8162,'si','Vrstni red elementov na izpolnitev nalog Pick vozovnice',0),(293810,8162,'ba','Urutan item pada pemenuhan Order memilih Tiket',0),(293811,8162,'nl','Sorteervolgorde voor Items op vervulling volgorde Pick Ticket',0),(293812,8162,'fi','Kohteiden tÃ¤yttÃ¤minen tilauksen poiminta lippu lajittelujÃ¤rjestys',0),(293813,8162,'no','SorteringsrekkefÃ¸lgen For elementer i oppfyllelse for plukke billett',0),(293814,8162,'da','SorteringsrÃ¦kkefÃ¸lgen For varer for Fulfillment ordre Pick billet',0),(293815,8162,'ko','í–‰ ìˆœì„œ ì„ íƒ í‹°ì¼“ í•­ëª©ì— ëŒ€ í•œ ì •ë ¬ ìˆœì„œ',0),(293816,8162,'he','×¡×“×¨ ×ž×™×•×Ÿ ×¢×‘×•×¨ ×¤×¨×™×˜×™× ×”×’×©×ž×” ×¡×“×¨ ×¤×™×§ ×“×• ×—',0),(293817,8162,'el','Î£ÎµÎ¹ÏÎ¬ Ï„Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î± ÎµÎ¯Î´Î· ÏƒÏ„Î·Î½ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Pick ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(293818,8162,'zh','å®Œæˆé¡¶åˆ°å–è´§ç¥¨æ®é¡¹ç›®åˆ†ç±»æŽ’åº\r\n',0),(293819,8162,'sv','Sorteringsordningen fÃ¶r objekten pÃ¥ uppfyllelse ordning plocka biljett',0),(293820,8162,'it','Ordinamento per gli elementi di evasione ordine Pick biglietto',0),(293821,8162,'tl','',0),(293822,8162,'th','&#3592;&#3633;&#3604;&#3648;&#3619;&#3637;&#3618;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3',0),(293823,8162,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤²à¥‡à¤¨à¥‡ à¤•à¥‡ à¤Ÿà¤¿à¤•à¤Ÿ à¤ªà¤° à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶',0),(293824,8162,'ms','Perintah Susun bagi item pada memenuhi perintah Pilih Tiket',0),(293825,8162,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„ÙØ±Ø² Ù„Ù„Ø¹Ù†Ø§ØµØ± Ø¹Ù„Ù‰ Ø§Ù„ÙˆÙØ§Ø¡ Ø¨Ø£Ù…Ø± Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(293826,8162,'fr','Ordre de tri d\'Ã©lÃ©ments sur le billet de choix Order Fulfillment',0),(293827,8162,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼ ãƒ”ãƒƒã‚¯ ãƒã‚±ãƒƒãƒˆä¸Šã®é …ç›®ã®ä¸¦ã¹æ›¿ãˆé †åº',0),(293828,8162,'pt','Ordem de classificaÃ§Ã£o para itens no cumprimento de ordem Pick bilhete',0),(293829,8162,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð½Ð° Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ð·Ð°Ð±Ñ€Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚',0),(293830,8162,'es','Orden de Sorteo para Items sobre Orden de Cumplimiento Boleto de SelecciÃ³n',0),(293831,8162,'de','Sortierreihenfolge fÃ¼r Elemente auf ErfÃ¼llung Reihenfolge Pick Ticket',0),(293832,8162,'en','Sort Order For Items On Fulfillment Order Pick Ticket',0),(293833,8163,'is','',0),(293834,8163,'dr','Ø§Ø² ÙƒØ§Ù„Ø§ ',0),(293835,8163,'pr','Ø§Ø² ÙƒØ§Ù„Ø§ ',0),(293836,8163,'tr','Maddeden',0),(293837,8163,'pl','Z pozycji',0),(293838,8163,'bg','ÐžÑ‚ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(293839,8163,'ur','Ø´Û’ Ø³Û’',0),(293840,8163,'sr','Ð˜Ð· ÑÑ‚Ð°Ð²ÐºÐµ',0),(293841,8163,'vi','Tá»« hÃ ng',0),(293842,8163,'af','Vanaf Item',0),(293843,8163,'ro','Element',0),(293844,8163,'et','Ãœksuse puhul',0),(293845,8163,'si','Iz postavke',0),(293846,8163,'ba','Dari Item',0),(293847,8163,'nl','Van Item',0),(293848,8163,'fi','Kohteen',0),(293849,8163,'no','Fra element',0),(293850,8163,'da','Fra vare',0),(293851,8163,'ko','í•­ëª©ì—ì„œ',0),(293852,8163,'he','×ž×¤×¨×™×˜',0),(293853,8163,'el','Î‘Ï€ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(293854,8163,'zh','ä»Žé¡¹ç›®\r\n',0),(293855,8163,'sv','FrÃ¥n objekt',0),(293856,8163,'it','Dalla voce',0),(293857,8163,'tl','',0),(293858,8163,'th','&#3592;&#3634;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(293859,8163,'hi','à¤®à¤¦ à¤¸à¥‡',0),(293860,8163,'ms','Dari Item',0),(293861,8163,'ar','Ù…Ù† Ø§Ù„Ø¨Ù†Ø¯',0),(293862,8163,'fr','De l\'ordre du jour',0),(293863,8163,'jp','é …ç›®ã‹ã‚‰',0),(293864,8163,'pt','De Item',0),(293865,8163,'ru','ÐžÑ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(293866,8163,'es','Desde el Item',0),(293867,8163,'de','Von Element',0),(293868,8163,'en','From Item',0),(293869,8164,'is','',0),(293870,8164,'dr','Ø§Ø² ÙƒØ¯ ÙƒØ§Ù„Ø§ ',0),(293871,8164,'pr','Ø§Ø² ÙƒØ¯ ÙƒØ§Ù„Ø§ ',0),(293872,8164,'tr','Madde kodu',0),(293873,8164,'pl','Z kod towaru',0),(293874,8164,'bg','ÐžÑ‚ ÐºÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(293875,8164,'ur','Ø´Û’ Ø¶Ø§Ø¨Ø·Û Ø³Û’',0),(293876,8164,'sr','Ð˜Ð· Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(293877,8164,'vi','Tá»« mÃ£ hÃ ng',0),(293878,8164,'af','Vanaf Itemkode',0),(293879,8164,'ro','La cod articol',0),(293880,8164,'et','Kauba kood',0),(293881,8164,'si','Iz Å ifra artikla',0),(293882,8164,'ba','Dari kode barang',0),(293883,8164,'nl','Van object Code',0),(293884,8164,'fi','Nimikkeen koodi',0),(293885,8164,'no','Fra Varekode',0),(293886,8164,'da','Fra varekode',0),(293887,8164,'ko','í•­ëª© ì½”ë“œì—ì„œ',0),(293888,8164,'he','×§×•×“ ×¤×¨×™×˜',0),(293889,8164,'el','Î‘Ï€ÏŒ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚',0),(293890,8164,'zh','ä»Žäº§å“ç¼–å·\r\n',0),(293891,8164,'sv','FrÃ¥n Artikelkod',0),(293892,8164,'it','Da codice articolo',0),(293893,8164,'tl','',0),(293894,8164,'th','&#3592;&#3634;&#3585;&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(293895,8164,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤¸à¥‡',0),(293896,8164,'ms','Dari kod Item',0),(293897,8164,'ar','Ù…Ù† ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù',0),(293898,8164,'fr','De Code article',0),(293899,8164,'jp','é …ç›®ã‚³ãƒ¼ãƒ‰ã‹ã‚‰',0),(293900,8164,'pt','CÃ³digo do Item',0),(293901,8164,'ru','Ð˜Ð· ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÐºÐ¾Ð´Ð°',0),(293902,8164,'es','Desde el CÃ³digo del Item',0),(293903,8164,'de','Von Artikelcode',0),(293904,8164,'en','From Item Code',0),(293905,8165,'is','',0),(293906,8165,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(293907,8165,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(293908,8165,'tr','Stok Transfer',0),(293909,8165,'pl','Przenoszenia zapasÃ³w',0),(293910,8165,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(293911,8165,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(293912,8165,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(293913,8165,'vi','Chuyá»ƒn NhÆ°á»£ng hÃ ng hÃ³a',0),(293914,8165,'af','Voorraad Oorplasing',0),(293915,8165,'ro','Transfer de inventar',0),(293916,8165,'et','LaoÃ¼lekande',0),(293917,8165,'si','Prenos zaloge',0),(293918,8165,'ba','Persediaan Transfer',0),(293919,8165,'nl','Voorraad overdracht',0),(293920,8165,'fi','Varastosiirto',0),(293921,8165,'no','LageroverfÃ¸ring',0),(293922,8165,'da','Lageret overfÃ¸rsel',0),(293923,8165,'ko','ìž¬ê³  ì´ì „',0),(293924,8165,'he','×”×¢×‘×¨×ª ×ž×œ××™',0),(293925,8165,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(293926,8165,'zh','åº“å­˜è½¬ç§»\r\n',0),(293927,8165,'sv','LagerÃ¶verfÃ¶ring',0),(293928,8165,'it','Trasferimento di inventario',0),(293929,8165,'tl','',0),(293930,8165,'th','&#3585;&#3634;&#3619;&#3650;&#3629;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(293931,8165,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£',0),(293932,8165,'ms','Pemindahan inventori',0),(293933,8165,'ar','Ù†Ù‚Ù„ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(293934,8165,'fr','Transfert de l\'inventaire',0),(293935,8165,'jp','åœ¨åº«è»¢é€',0),(293936,8165,'pt','TransferÃªncia de estoque',0),(293937,8165,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(293938,8165,'es','Transferencia de Inventario',0),(293939,8165,'de','Inventar-Transfer',0),(293940,8165,'en','Inventory Transfer',0),(293941,8166,'is','',0),(293942,8166,'dr','(Ø­ÙˆØ§Ù„Ù‡ Ù‡Ø§ÙŠ ) Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³',0),(293943,8166,'pr','Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª (Ø­ÙˆØ§Ù„Ù‡ Ù‡Ø§ÙŠ ) Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(293944,8166,'tr','Stok transfer',0),(293945,8166,'pl','ZapasÃ³w transferÃ³w',0),(293946,8166,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(293947,8166,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(293948,8166,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(293949,8166,'vi','Chuyá»ƒn NhÆ°á»£ng hÃ ng hÃ³a',0),(293950,8166,'af','Inventaris Oorplasings',0),(293951,8166,'ro','Transferuri de inventar',0),(293952,8166,'et','Varude Ã¼lekanded',0),(293953,8166,'si','Prenosi zaloge',0),(293954,8166,'ba','Persediaan transfer',0),(293955,8166,'nl','Voorraadtransfers',0),(293956,8166,'fi','Varastosiirrot',0),(293957,8166,'no','Lager overfÃ¸ringer',0),(293958,8166,'da','Lageroverflytninger',0),(293959,8166,'ko','ìž¬ê³  ì´ì „',0),(293960,8166,'he','×”×¢×‘×¨×•×ª ×ž×œ××™',0),(293961,8166,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Ï‚',0),(293962,8166,'zh','åº“å­˜è½¬ç§»\r\n',0),(293963,8166,'sv','LagerÃ¶verfÃ¶ringar',0),(293964,8166,'it','Trasferimenti di inventario',0),(293965,8166,'tl','',0),(293966,8166,'th','&#3585;&#3634;&#3619;&#3650;&#3629;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(293967,8166,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤¨à¥à¤¤à¤°à¤£',0),(293968,8166,'ms','Pemindahan inventori',0),(293969,8166,'ar','Ù†Ù‚Ù„ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(293970,8166,'fr','Transferts de l\'inventaire',0),(293971,8166,'jp','åœ¨åº«è»¢é€',0),(293972,8166,'pt','TransferÃªncias de estoque',0),(293973,8166,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ñ‹',0),(293974,8166,'es','Transferencias de Inventario',0),(293975,8166,'de','Inventar-Transfers',0),(293976,8166,'en','Inventory Transfers',0),(293977,8167,'is','',0),(293978,8167,'dr','(ÙˆØ§Ú¯Ø°Ø§Ø± Ø´Ø¯',0),(293979,8167,'pr','ÙƒØ§Ù„Ø§ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯ (ÙˆØ§Ú¯Ø°Ø§Ø± Ø´Ø¯',0),(293980,8167,'tr','Ã–ÄŸe transfer',0),(293981,8167,'pl','Zapasu zostanÄ… przeniesione w',0),(293982,8167,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»Ñ',0),(293983,8167,'ur','Ø´Û’ Ù…Ù†ØªÙ‚Ù„',0),(293984,8167,'sr','ÐŸÑ€ÐµÐ½Ð¾ÑÐµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(293985,8167,'vi','HÃ ng Ä‘Ã£ chuyá»ƒn',0),(293986,8167,'af','Item Oorgeplaas',0),(293987,8167,'ro','Articol sunt transferate',0),(293988,8167,'et','Kauba Ã¼le',0),(293989,8167,'si','Prenese element',0),(293990,8167,'ba','Item ditransfer',0),(293991,8167,'nl','Item overgedragen',0),(293992,8167,'fi','Viestin siirto',0),(293993,8167,'no','Varen overfÃ¸rt',0),(293994,8167,'da','Varen overfÃ¸res',0),(293995,8167,'ko','í•­ëª© ì „ì†¡',0),(293996,8167,'he','×œ×”×¢×‘×™×¨ ×¤×¨×™×˜',0),(293997,8167,'el','Î•Î¯Î´Î¿Ï…Ï‚ Î¼ÎµÏ„Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹',0),(293998,8167,'zh','é¡¹ç›®è½¬è®©\r\n',0),(293999,8167,'sv','Objekt Ã¶verfÃ¶rs',0),(294000,8167,'it','Elemento trasferito',0),(294001,8167,'tl','',0),(294002,8167,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3650;&#3629;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(294003,8167,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾',0),(294004,8167,'ms','Item yang dipindahkan',0),(294005,8167,'ar','Ù†Ù‚Ù„ Ø§Ù„Ø¹Ù†ØµØ±',0),(294006,8167,'fr','Ã‰lÃ©ment transfÃ©rÃ©',0),(294007,8167,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã‚’è»¢é€',0),(294008,8167,'pt','Item transferido',0),(294009,8167,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¿ÐµÑ€ÐµÐ´Ð°Ð½Ñ‹',0),(294010,8167,'es','Item Transferido',0),(294011,8167,'de','Element Ã¼bertragen',0),(294012,8167,'en','Item Transferred',0),(294013,8168,'is','',0),(294014,8168,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ ÙƒØ§Ù„Ø§ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(294015,8168,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ ÙƒØ§Ù„Ø§ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(294016,8168,'tr','Madde aktarÄ±mÄ± baÅŸarÄ±sÄ±z oldu',0),(294017,8168,'pl','Przeniesienie elementu nie powiodÅ‚o siÄ™',0),(294018,8168,'bg','Ð¢Ð¾Ñ‡ÐºÐ° Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(294019,8168,'ur','Ø´Û’ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ù†Ø§Ú©Ø§Ù… ÛÙˆÚ¯Ø¦ÛŒ',0),(294020,8168,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(294021,8168,'vi','HÃ ng chuyá»ƒn tháº¥t báº¡i',0),(294022,8168,'af','Item Oorplasing Gefaal.',0),(294023,8168,'ro','Transferul de element nu a reuÈ™it',0),(294024,8168,'et','Kauba Ã¼leandmine nurjus',0),(294025,8168,'si','Element prenosa ni uspel',0),(294026,8168,'ba','Transfer item yang gagal',0),(294027,8168,'nl','Object overdracht mislukt',0),(294028,8168,'fi','Kohteen siirtÃ¤minen epÃ¤onnistui',0),(294029,8168,'no','OverfÃ¸ring mislyktes',0),(294030,8168,'da','Vare overfÃ¸rsel mislykkedes',0),(294031,8168,'ko','í•­ëª© ì „ì†¡ ì‹¤íŒ¨',0),(294032,8168,'he','×”×¢×‘×¨×ª ×”×¤×¨×™×˜ × ×›×©×œ',0),(294033,8168,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ Ï„Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(294034,8168,'zh','é¡¹ç›®ä¼ è¾“å¤±è´¥\r\n',0),(294035,8168,'sv','Objektet Ã¶verfÃ¶ring misslyckades',0),(294036,8168,'it','Elemento trasferimento fallito',0),(294037,8168,'tl','',0),(294038,8168,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3650;&#3629;&#3609;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(294039,8168,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(294040,8168,'ms','Item pemindahan yang gagal',0),(294041,8168,'ar','ÙØ´Ù„ ØªØ­ÙˆÙŠÙ„ Ø§Ù„ØµÙ†Ù',0),(294042,8168,'fr','Point de transfert a Ã©chouÃ©',0),(294043,8168,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®è»¢é€ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(294044,8168,'pt','Item transferÃªncia falhada',0),(294045,8168,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(294046,8168,'es','Item Trnasferencia FallÃ³',0),(294047,8168,'de','Element-Ãœbertragung fehlgeschlagen',0),(294048,8168,'en','Item Transfer Failed',0),(294049,8169,'is','',0),(294050,8169,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± ',0),(294051,8169,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± ',0),(294052,8169,'tr','Miktar',0),(294053,8169,'pl','IloÅ›Ä‡ w',0),(294054,8169,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²',0),(294055,8169,'ur','Ù…Ù‚Ø¯Ø§Ø± Ù…ÛŒÚº',0),(294056,8169,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñƒ',0),(294057,8169,'vi','Sá»‘ lÆ°á»£ng vÃ o',0),(294058,8169,'af','Hoeveelheid In',0),(294059,8169,'ro','Cantitatea Ã®n',0),(294060,8169,'et','Kogus',0),(294061,8169,'si','KoliÄina v',0),(294062,8169,'ba','Quantity dalam',0),(294063,8169,'nl','Aantal In',0),(294064,8169,'fi','MÃ¤Ã¤rÃ¤',0),(294065,8169,'no','Antallet i',0),(294066,8169,'da','MÃ¦ngde i',0),(294067,8169,'ko','ìˆ˜ëŸ‰ì—',0),(294068,8169,'he','×›×ž×•×ª ×‘',0),(294069,8169,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± ÏƒÎµ',0),(294070,8169,'zh','æ•°é‡\r\n',0),(294071,8169,'sv','Kvantitet i',0),(294072,8169,'it','QuantitÃ  In',0),(294073,8169,'tl','',0),(294074,8169,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3648;&#3586;&#3657;&#3634;',0),(294075,8169,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚',0),(294076,8169,'ms','Kuantiti dalam',0),(294077,8169,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© ÙÙŠ',0),(294078,8169,'fr','QuantitÃ© en',0),(294079,8169,'jp','æ•°é‡',0),(294080,8169,'pt','Quantidade em',0),(294081,8169,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²',0),(294082,8169,'es','Cantidad En',0),(294083,8169,'de','Menge In',0),(294084,8169,'en','Quantity In',0),(294085,8170,'is','',0),(294086,8170,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÙˆØ¬ ',0),(294087,8170,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÙˆØ¬ ',0),(294088,8170,'tr','Miktar dÄ±ÅŸarÄ±',0),(294089,8170,'pl','IloÅ›Ä‡',0),(294090,8170,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(294091,8170,'ur','ØªØ¹Ø¯Ø§Ø¯ Ø¢Ø¤Ù¹',0),(294092,8170,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑÐµ',0),(294093,8170,'vi','Sá»‘ lÆ°á»£ng ra',0),(294094,8170,'af','Hoeveelheid uit',0),(294095,8170,'ro','Cantitatea afarÄƒ',0),(294096,8170,'et','Kogus vÃ¤lja',0),(294097,8170,'si','KoliÄina',0),(294098,8170,'ba','Kuantitas keluar',0),(294099,8170,'nl','Hoeveelheid uit',0),(294100,8170,'fi','MÃ¤Ã¤rÃ¤',0),(294101,8170,'no','Antall ut',0),(294102,8170,'da','MÃ¦ngde ud',0),(294103,8170,'ko','ê°œ ì–‘',0),(294104,8170,'he','×›×ž×•×ª ×”×—×•×¦×”',0),(294105,8170,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î­Î¾Ï‰',0),(294106,8170,'zh','æ•°é‡å¯¼å‡º\r\n',0),(294107,8170,'sv','Antalet ut',0),(294108,8170,'it','QuantitÃ  fuori',0),(294109,8170,'tl','',0),(294110,8170,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3629;&#3629;&#3585;',0),(294111,8170,'hi','à¤¬à¤¾à¤¹à¤° à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(294112,8170,'ms','Kuantiti Keluar',0),(294113,8170,'ar','ÙƒÙ…ÙŠØ© Ù…Ù†',0),(294114,8170,'fr','QuantitÃ© des',0),(294115,8170,'jp','ã†ã¡ã®æ•°é‡',0),(294116,8170,'pt','Quantidade para fora',0),(294117,8170,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(294118,8170,'es','Cantidad Fuera',0),(294119,8170,'de','Menge heraus',0),(294120,8170,'en','Quantity Out',0),(294121,8171,'is','',0),(294122,8171,'dr','Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(294123,8171,'pr','Ø¨Ø±Ø§ÙŠ ÙƒØ§Ù„Ø§',0),(294124,8171,'tr','Madde iÃ§in',0),(294125,8171,'pl','Do elementu',0),(294126,8171,'bg','ÐšÑŠÐ¼ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(294127,8171,'ur','Ø´Û’ Ú©Û’ Ù„ÛŒÛ’',0),(294128,8171,'sr','ÐÐ° ÑÑ‚Ð°Ð²ÐºÑƒ',0),(294129,8171,'vi','Tá»›i hÃ ng',0),(294130,8171,'af','Vir Item',0),(294131,8171,'ro','Element',0),(294132,8171,'et','Ãœksusega',0),(294133,8171,'si','Element',0),(294134,8171,'ba','Item',0),(294135,8171,'nl','Item',0),(294136,8171,'fi','Kohteeseen',0),(294137,8171,'no','Elementet',0),(294138,8171,'da','At varen',0),(294139,8171,'ko','í•­ëª©ì—',0),(294140,8171,'he','×”×¤×¨×™×˜',0),(294141,8171,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(294142,8171,'zh','é¡¹ç›®\r\n',0),(294143,8171,'sv','Objekt',0),(294144,8171,'it','Alla voce',0),(294145,8171,'tl','',0),(294146,8171,'th','&#3606;&#3638;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(294147,8171,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤‡à¤Ÿà¤®',0),(294148,8171,'ms','Untuk Item',0),(294149,8171,'ar','Ø¥Ù„Ù‰ Ø§Ù„ØµÙ†Ù',0),(294150,8171,'fr','Ã€ l\'article',0),(294151,8171,'jp','é …ç›®ã«',0),(294152,8171,'pt','Para o Item',0),(294153,8171,'ru','Ð”Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(294154,8171,'es','Al Item',0),(294155,8171,'de','Zum Element',0),(294156,8171,'en','To Item',0),(294157,8172,'is','',0),(294158,8172,'dr','Ø¨Ø±Ø§ÙŠ ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(294159,8172,'pr','Ø¨Ø±Ø§ÙŠ ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(294160,8172,'tr','Madde kodu',0),(294161,8172,'pl','Kod towaru',0),(294162,8172,'bg','ÐšÑŠÐ¼ ÐºÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(294163,8172,'ur','Ø³Û’ Ø´Û’ Ø¶Ø§Ø¨Ø·Û',0),(294164,8172,'sr','Ð—Ð° ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(294165,8172,'vi','Tá»›i mÃ£ hÃ ng',0),(294166,8172,'af','Vir Itemkode',0),(294167,8172,'ro','Element cod',0),(294168,8172,'et','Kauba kood',0),(294169,8172,'si','Za Å¡ifro artikla',0),(294170,8172,'ba','Kode Item',0),(294171,8172,'nl','Object code',0),(294172,8172,'fi','Nimikkeen koodi',0),(294173,8172,'no','Element-koden',0),(294174,8172,'da','Til varekode',0),(294175,8172,'ko','í•­ëª© ì½”ë“œ',0),(294176,8172,'he','×§×•×“ ×¤×¨×™×˜',0),(294177,8172,'el','ÎÎ± ÎºÏ‰Î´Î¹ÎºÏŒÏ‚',0),(294178,8172,'zh','é¡¹ç›®ä»£ç \r\n',0),(294179,8172,'sv','Till Artikelkod',0),(294180,8172,'it','Per codice articolo',0),(294181,8172,'tl','',0),(294182,8172,'th','&#3606;&#3638;&#3591;&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(294183,8172,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤•à¥‹',0),(294184,8172,'ms','Kod Item',0),(294185,8172,'ar','Ù„ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù',0),(294186,8172,'fr','Au point de Code',0),(294187,8172,'jp','é …ç›®ã‚³ãƒ¼ãƒ‰',0),(294188,8172,'pt','CÃ³digo do Item',0),(294189,8172,'ru','ÐšÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(294190,8172,'es','Al CÃ³digo de Item',0),(294191,8172,'de','Item-Code',0),(294192,8172,'en','To Item Code',0),(294193,8173,'is','',0),(294194,8173,'dr','Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(294195,8173,'pr','Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(294196,8173,'tr','Stok maddesi transferler',0),(294197,8173,'pl','PrzesuniÄ™cia zapasÃ³w magazynowych',0),(294198,8173,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(294199,8173,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(294200,8173,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(294201,8173,'vi','Danh Má»¥c HÃ ng Chuyá»ƒn Giao',0),(294202,8173,'af','Voorraaditem Oordrag',0),(294203,8173,'ro','Transferurile de articol inventar',0),(294204,8173,'et','Lao kirje Ã¼lekanded',0),(294205,8173,'si','Prenosi zaloge artikla',0),(294206,8173,'ba','Persediaan Item transfer',0),(294207,8173,'nl','Voorraadtransfers Item',0),(294208,8173,'fi','Nimikkeen varastosiirrot',0),(294209,8173,'no','Lageret varen overfÃ¸ringer',0),(294210,8173,'da','Lager vare overfÃ¸rsler',0),(294211,8173,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ì „ì†¡',0),(294212,8173,'he','×”×¢×‘×¨×•×ª ×¤×¨×™×˜ ×ž×œ××™',0),(294213,8173,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î´Î¹Î±ÎºÎ¹Î½Î®ÏƒÎµÎ¹Ï‚ ÎµÎ¹Î´ÏŽÎ½',0),(294214,8173,'zh','åº“å­˜é¡¹ç›®è½¬è®©\r\n',0),(294215,8173,'sv','Inventering artikelÃ¶verfÃ¶ringar',0),(294216,8173,'it','Trasferimenti di articoli di magazzino',0),(294217,8173,'tl','',0),(294218,8173,'th','&#3585;&#3634;&#3619;&#3650;&#3629;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(294219,8173,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤¨à¥à¤¤à¤°à¤£',0),(294220,8173,'ms','Pemindahan Item inventori',0),(294221,8173,'ar','Ù†Ù‚Ù„ Ø¹Ù†ØµØ± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(294222,8173,'fr','Les transferts d\'inventaire',0),(294223,8173,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®åœ¨åº«è»¢é€',0),(294224,8173,'pt','TransferÃªncias de Item de inventÃ¡rio',0),(294225,8173,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ñ‹',0),(294226,8173,'es','Item de Inventario Transferencias',0),(294227,8173,'de','Inventar Item Transfers',0),(294228,8173,'en','Inventory Item Transfers',0),(294229,8174,'is','',0),(294230,8174,'dr','Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª ÙƒØ§Ù„Ø§ ',0),(294231,8174,'pr','Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª ÙƒØ§Ù„Ø§ ',0),(294232,8174,'tr','Madde',0),(294233,8174,'pl','PrzesuniÄ™cia zapasÃ³w',0),(294234,8174,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(294235,8174,'ur','Ø´Û’ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(294236,8174,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(294237,8174,'vi','HÃ ng chuyá»ƒn',0),(294238,8174,'af','Item Oorplasings',0),(294239,8174,'ro','Transferurile de articol',0),(294240,8174,'et','Ãœksuse edastamine',0),(294241,8174,'si','Prenosov artiklov',0),(294242,8174,'ba','Item transfer',0),(294243,8174,'nl','Artikeltransfers',0),(294244,8174,'fi','Nimikesiirtoja',0),(294245,8174,'no','Elementet overfÃ¸ringer',0),(294246,8174,'da','Vare overfÃ¸rsler',0),(294247,8174,'ko','í•­ëª© ì´ë™',0),(294248,8174,'he','×¤×¨×™×˜ ×”×¢×‘×¨×•×ª',0),(294249,8174,'el','Î”Î¹Î±ÎºÎ¹Î½Î®ÏƒÎµÎ¹Ï‚ ÎµÎ¹Î´ÏŽÎ½',0),(294250,8174,'zh','é¡¹ç›®è½¬è®©\r\n',0),(294251,8174,'sv','ArtikelÃ¶verfÃ¶ringar',0),(294252,8174,'it','Trasferimenti di articoli',0),(294253,8174,'tl','',0),(294254,8174,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3650;&#3629;&#3609;',0),(294255,8174,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤¨à¥à¤¤à¤°à¤£',0),(294256,8174,'ms','Pemindahan barang',0),(294257,8174,'ar','ØªØ­ÙˆÙŠÙ„Ø§Øª Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(294258,8174,'fr','Les transferts d\'articles',0),(294259,8174,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®è»¢é€',0),(294260,8174,'pt','Item transferÃªncias',0),(294261,8174,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ñ‹',0),(294262,8174,'es','Item Transferencias',0),(294263,8174,'de','Element-Transfers',0),(294264,8174,'en','Item Transfers',0),(294265,8175,'is','',0),(294266,8175,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø¨Ø§Ø±ÙƒØ¯ ÙƒØ§Ù„Ø§  Ø±ÙˆÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ø¬ÙˆØ§Ø² Ø¹Ø¨ÙˆØ±',0),(294267,8175,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø¨Ø§Ø±ÙƒØ¯ ÙƒØ§Ù„Ø§  Ø±ÙˆÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ø¬ÙˆØ§Ø² Ø¹Ø¨ÙˆØ±',0),(294268,8175,'tr','Maddenin barkod Pick bilet Ã¼zerinde engellemek iÃ§in kontrol edin',0),(294269,8175,'pl','SprawdÅº, blok kodu kreskowego towaru na pobranie biletu',0),(294270,8175,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð° Ð±Ð°Ñ€ÐºÐ¾Ð´ Ð½Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð±Ð¸Ð»ÐµÑ‚',0),(294271,8175,'ur','Ø´Û’ Ø¨Ø§Ø±Ú©ÙˆÚˆ Ø§Ù†ØªØ®Ø§Ø¨ Ù¹Ú©Ù¹ Ù¾Ø± Ø¨Ù„Ø§Ú© Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(294272,8175,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð´Ð° Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð° Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð½Ð° Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(294273,8175,'vi','ÄÃ¡nh dáº¥u Ä‘á»ƒ Ä‘áº·t mÃ£ váº¡ch hÃ ng trÃªn phiáº¿u',0),(294274,8175,'af','Merk Om Item Strepieskode Op Elite Kaart te blok',0),(294275,8175,'ro','VerificaÅ£i pentru a bloca elementul de coduri de bare pe bilet de Pick',0),(294276,8175,'et','Kontrollige blokeerida kauba vÃ¶Ã¶tkoodi noppimise pilet',0),(294277,8175,'si','Preverite, da blokira Ärtno kodo artikla na Pick vozovnice',0),(294278,8175,'ba','Periksa untuk memblokir Item Barcode pada tiket Pick',0),(294279,8175,'nl','Controleren om te blokkeren Item Barcode op Pick Ticket',0),(294280,8175,'fi','Tarkista estÃ¤Ã¤ nimikkeen viivakoodi valinta lippu',0),(294281,8175,'no','Sjekk for Ã¥ blokkere varen strekkode pÃ¥ plukke billett',0),(294282,8175,'da','Kontroller, at blokere vare stregkode pÃ¥ Pick billet',0),(294283,8175,'ko','ì°¨ë‹¨ í•­ëª© ì„ íƒ í‹°ì¼“ì— ë°”ì½”ë“œ í™•ì¸',0),(294284,8175,'he','×‘×“×•×§ ×›×“×™ ×œ×—×¡×•× ×‘×¨×§×•×“ ×”×¤×¨×™×˜ ×¤×™×§ ×“×• ×—',0),(294285,8175,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î½Î± Î¼Ï€Î»Î¿ÎºÎ¬ÏÎµÎ¹ Barcode ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(294286,8175,'zh','æ£€æŸ¥ä»¥å°é”ç¥¨æ®ä¸­çš„é¡¹ç›®æ¡ç \r\n',0),(294287,8175,'sv','Kontrollera att blockera post streckkod pÃ¥ Pick biljett',0),(294288,8175,'it','Controllare per bloccare l\'elemento di codice a barre sul biglietto Pick',0),(294289,8175,'tl','',0),(294290,8175,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3614;&#3639;&#3656;&#3629;&#3611;&#3657;&#3629;&#3591;&#3585;&#3633;&#3609;&#3610;&#3634;&#3619;&#3660;&#3650;&#3588;&#3657;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3609;&#3610;&#3',0),(294291,8175,'hi','à¤‰à¤ à¤¾à¤“ à¤Ÿà¤¿à¤•à¤Ÿ à¤ªà¤° à¤†à¤‡à¤Ÿà¤® à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤•à¥‹ à¤¬à¥à¤²à¥‰à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(294292,8175,'ms','Semak untuk menyekat perkara Barcode atas Tiket pengangkutan',0),(294293,8175,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† ÙƒØªÙ„Ø© Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠ Ø¹Ù„Ù‰ Ø§Ù„ØªØ°Ø§ÙƒØ± Ø¨ÙŠÙƒ',0),(294294,8175,'fr','VÃ©rifier pour bloquer l\'Ã©lÃ©ment code Ã  barres sur billet choix',0),(294295,8175,'jp','ãƒ”ãƒƒã‚¯ ãƒã‚±ãƒƒãƒˆä¸Šã®ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã‚’é …ç›®ã‚’ãƒ–ãƒ­ãƒƒã‚¯ã™ã‚‹ã«ã¯ã€ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(294296,8175,'pt','Verifique para bloquear o Item de cÃ³digo de barras no bilhete de Pick',0),(294297,8175,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÑˆÑ‚Ñ€Ð¸Ñ… Ð½Ð° Ð·Ð°Ð±Ñ€Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚',0),(294298,8175,'es','Checar para Bloquear CÃ³digo de Barras de Item el Boleto de SeleccciÃ³n',0),(294299,8175,'de','Block Element Barcode auf Pick Ticket Ã¼berprÃ¼fen',0),(294300,8175,'en','Check To Block Item Barcode On Pick Ticket',0),(294301,8176,'is','',0),(294302,8176,'dr','Ù…Ù‚Ø§Ø¯ÙŠØ± Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… Ø±Ø§ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ØªÙƒÙ…ÙŠÙ„ Ø´Ø¯Ù‡ ØªØµØ­ÙŠØ­ ÙƒÙ†ÙŠØ¯ ',0),(294303,8176,'pr','Ù…Ù‚Ø§Ø¯ÙŠØ± Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… Ø±Ø§ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª ØªÙƒÙ…ÙŠÙ„ Ø´Ø¯Ù‡ ØªØµØ­ÙŠØ­ ÙƒÙ†ÙŠØ¯ ',0),(294304,8176,'tr','Tamamlanan servis sipariÅŸlerindeki doÄŸru eldeki miktarlarÄ±',0),(294305,8176,'pl','Poprawne OnHand iloÅ›ci zleceÅ„ zakoÅ„czonych usÅ‚ugi',0),(294306,8176,'bg','ÐšÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° OnHand ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð¾Ñ‚ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(294307,8176,'ur','Ù…Ú©Ù…Ù„ Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø³Û’ ØµØ­ÛŒØ­ Ø§ÙˆÙ†Ø­Ù†Úˆ Ù…Ù‚Ø¯Ø§Ø±',0),(294308,8176,'sr','Ð˜ÑÐ¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ Ð¸Ð· Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ðµ ÑÐµÑ€Ð²Ð¸Ñ',0),(294309,8176,'vi','BÃ¡o sá»‘ lÆ°á»£ng Ä‘Ãºng hiá»‡n cÃ³ tá»« nhá»¯ng Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥',0),(294310,8176,'af','Korrigeer Op Hande Hoeveelheid Vanaf Voltooide Diens Bestellings',0),(294311,8176,'ro','OnHand corect cantitÄƒÈ›ile din comenzile de Service completat',0),(294312,8176,'et','Ã•ige TaastÃ¤itmise kogused komplekteeritud hooldustellimustel',0),(294313,8176,'si','Pravilno OnHand koliÄine iz dokonÄanih servisnih nalogov',0),(294314,8176,'ba','Koreksi Jumlah Pesanan pada Pesanan Jasa yang sudah lengkap',0),(294315,8176,'nl','Juiste OnHand hoeveelheden van voltooide serviceorders',0),(294316,8176,'fi','Oikea OnHand mÃ¤Ã¤ristÃ¤ valmiit huoltotilaukset',0),(294317,8176,'no','Riktig OnHand mengder fra fullfÃ¸rte serviceordrer',0),(294318,8176,'da','Korrekte OnHand mÃ¦ngder fra afsluttede serviceordrer',0),(294319,8176,'ko','ì™„ë£Œ ëœ ì„œë¹„ìŠ¤ ì£¼ë¬¸ì—ì„œ ì˜¬ë°”ë¥¸ OnHand ìˆ˜ëŸ‰',0),(294320,8176,'he','×›×ž×•×™×•×ª ×‘× ×ž×¦× ×”× ×›×•×Ÿ ×©×œ ×”×–×ž× ×•×ª ×©×™×¨×•×ª ×©×”×•×©×œ×ž×•',0),(294321,8176,'el','Î£Ï‰ÏƒÏ„Î® OnHand Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚ Î±Ï€ÏŒ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½Î· Ï…Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(294322,8176,'zh','æ­£ç¡®çš„å·²å®ŒæˆæœåŠ¡è®¢å•é‡çŽ°æœ‰é‡\r\n',0),(294323,8176,'sv','Korrigera OnHand kvantiteter frÃ¥n avslutade serviceorder',0),(294324,8176,'it','QuantitÃ  corretta OnHand dagli ordini di servizio completato',0),(294325,8176,'tl','',0),(294326,8176,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3',0),(294327,8176,'hi','OnHand à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤ªà¥‚à¤°à¥à¤£ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¸à¥‡ à¤•à¥‹ à¤¸à¤¹à¥€',0),(294328,8176,'ms','OnHand betul kuantiti dari pesanan Perkhidmatan siap',0),(294329,8176,'ar','ØªØµØ­ÙŠØ­ OnHand ÙƒÙ…ÙŠØ§Øª Ù…Ù† Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© Ø§Ù„Ù…Ù†Ø¬Ø²Ø©',0),(294330,8176,'fr','Corriger OnHand quantitÃ©s de commandes de Service dÃ»ment rempli',0),(294331,8176,'jp','å®Œäº†ã‚µãƒ¼ãƒ“ã‚¹æŒ‡å›³ã‹ã‚‰æ­£ã—ã„ OnHand æ•°é‡',0),(294332,8176,'pt','Quantidades corretas OnHand de ordens de serviÃ§o concluÃ­da',0),(294333,8176,'ru','ÐŸÑ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ñ‹Ð¹ OnHand ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð¾Ñ‚ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ñ… Ñ€Ð°Ð±Ð¾Ñ‚',0),(294334,8176,'es','Corregir Cantidades en Reserva de los Pedidos de Servicio Completados',0),(294335,8176,'de','Richtige OnHand Mengen von ausgefÃ¼llte ServiceauftrÃ¤ge',0),(294336,8176,'en','Correct On Hand Quantities From Completed Service Orders',0),(294337,8177,'is','',0),(294338,8177,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¯Ù‚ÙŠÙ‚ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø´Ø±ÙˆØ¹ Ø³Ø±ÙŠØ¹',0),(294339,8177,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¯Ù‚ÙŠÙ‚ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø´Ø±ÙˆØ¹ Ø³Ø±ÙŠØ¹',0),(294340,8177,'tr','Kontrol dÄ±ÅŸarÄ± Ã§abuk baÅŸlamak kÄ±lavuz',0),(294341,8177,'pl','SprawdÅº Przewodnik Szybki Start',0),(294342,8177,'bg','Ð’Ð¸Ð¶Ñ‚Ðµ Ñ€ÑŠÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ Ð·Ð° Ð±ÑŠÑ€Ð· ÑÑ‚Ð°Ñ€Ñ‚',0),(294343,8177,'ur','ÙÙˆØ±ÛŒ Ø´Ø±ÙˆØ¹ Ú¯Ø§Ø¦ÛŒÚˆ Ø¨Ø§ÛØ± Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(294344,8177,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð’Ð¾Ð´Ð¸Ñ‡ Ð·Ð° Ð±Ñ€Ð·Ð¸ Ð¿Ð¾Ñ‡ÐµÑ‚Ð°Ðº',0),(294345,8177,'vi','Kiá»ƒm tra hÆ°á»›ng dáº«n Quick Start',0),(294346,8177,'af','\"Check out\" die Blits Beginnersgids (\"Quick Start guide\")',0),(294347,8177,'ro','A verifica afarÄƒ Ghidul de pornire rapidÄƒ',0),(294348,8177,'et','Tutvu Quick Start guide',0),(294349,8177,'si','Oglejte si vodnik za hiter zaÄetek',0),(294350,8177,'ba','Check out Panduan Ringkas',0),(294351,8177,'nl','Check out de Quick Start gids',0),(294352,8177,'fi','Tutustu Quick Start-opas',0),(294353,8177,'no','Sjekk ut Hurtigstartguiden',0),(294354,8177,'da','Check ud Quick Start guide',0),(294355,8177,'ko','í€µ ìŠ¤íƒ€íŠ¸ ê°€ì´ë“œ',0),(294356,8177,'he','×‘×“×•×§ ××ª ×ž×“×¨×™×š ×”×ª×—×œ×” ×ž×”×™×¨×”',0),(294357,8177,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î­Î¾Ï‰ Ï„Î¿Î½ Î¿Î´Î·Î³ÏŒ Î³ÏÎ®Î³Î¿ÏÎ·Ï‚ Î­Î½Î±ÏÎ¾Î·Ï‚',0),(294358,8177,'zh','æ£€æŸ¥å¿«é€Ÿå…¥é—¨æŒ‡å—\r\n',0),(294359,8177,'sv','Kolla in Quick Start guide',0),(294360,8177,'it','Controlla la guida Quick Start',0),(294361,8177,'tl','',0),(294362,8177,'th','&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3605;&#3633;&#3623;&#3594;&#3656;&#3623;&#3618;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3629;&#3618;&#3656;&#3634;&#3591;&#3619;&#3623;&#3604;&#3648;&#3619;&#3655;&#3623;',0),(294363,8177,'hi','à¤¤à¥à¤µà¤°à¤¿à¤¤ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤—à¤¾à¤‡à¤¡ à¤¬à¤¾à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(294364,8177,'ms','Menyemak panduan mula cepat',0),(294365,8177,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø¯Ù„ÙŠÙ„ \"Ø§Ù„Ø¨Ø¯Ø¡ Ø§Ù„Ø³Ø±ÙŠØ¹\"',0),(294366,8177,'fr','Consultez le guide de dÃ©marrage rapide',0),(294367,8177,'jp','ã‚¯ã‚¤ãƒƒã‚¯ ã‚¹ã‚¿ãƒ¼ãƒˆ ã‚¬ã‚¤ãƒ‰ã‚’ãƒã‚§ãƒƒã‚¯ ã‚¢ã‚¦ãƒˆ',0),(294368,8177,'pt','Confira o guia de inÃ­cio rÃ¡pido',0),(294369,8177,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÐºÑ€Ð°Ñ‚ÐºÐ¾Ðµ Ñ€ÑƒÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(294370,8177,'es','Investigar la Guia de Comienza Rapida',0),(294371,8177,'de','Schauen Sie sich das Quick Start guide',0),(294372,8177,'en','Check out the Quick Start guide',0),(294373,8178,'is','',0),(294374,8178,'dr','1 ',0),(294375,8178,'pr','Ø±ÙˆØ´ ØªØºÙŠÙŠØ±  1 ',0),(294376,8178,'tr','Alternatif stil 1',0),(294377,8178,'pl','Alternatywny styl 1',0),(294378,8178,'bg','ÐÐ»Ñ‚ÐµÑ€Ð½Ð°Ñ‚Ð¸Ð²ÐµÐ½ ÑÑ‚Ð¸Ð» 1',0),(294379,8178,'ur','Ù…ØªØ¨Ø§Ø¯Ù„ Ø·Ø±Ø² 1',0),(294380,8178,'sr','ÐÐ»Ñ‚ÐµÑ€Ð½Ð°Ñ‚Ð¸Ð²Ð½Ð¸ ÑÑ‚Ð¸Ð» 1',0),(294381,8178,'vi','Chá»‰nh sá»­a Kiá»ƒu 1',0),(294382,8178,'af','Alternatiewe Styl 1',0),(294383,8178,'ro','Stil alternativ 1',0),(294384,8178,'et','Alternatiivse stiili 1',0),(294385,8178,'si','Nadomestnega sloga 1',0),(294386,8178,'ba','Gaya alternatif',0),(294387,8178,'nl','Alternatieve stijl 1',0),(294388,8178,'fi','Vaihtoehtoinen tyyli 1',0),(294389,8178,'no','Alternative stil 1',0),(294390,8178,'da','Alternativ stil 1',0),(294391,8178,'ko','ëŒ€ì²´ ìŠ¤íƒ€ì¼ 1',0),(294392,8178,'he','×¡×’× ×•×Ÿ ×—×œ×•×¤×™ 1',0),(294393,8178,'el','Î•Î½Î±Î»Î»Î±ÎºÏ„Î¹ÎºÏŒ ÏƒÏ„Ï…Î» 1',0),(294394,8178,'zh','å¦ä¸€ç§æ ·å¼ä¸€\r\n',0),(294395,8178,'sv','Alternativa format 1',0),(294396,8178,'it','Stile alternativo 1',0),(294397,8178,'tl','',0),(294398,8178,'th','&#3607;&#3634;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;&#3649;&#3610;&#3610;&#3607;&#3637;&#3656; 1',0),(294399,8178,'hi','à¤µà¥ˆà¤•à¤²à¥à¤ªà¤¿à¤• à¤¶à¥ˆà¤²à¥€ 1',0),(294400,8178,'ms','Gaya ganti 1',0),(294401,8178,'ar','Ø§Ù„Ù†Ù…Ø· Ø§Ù„Ø¨Ø¯ÙŠÙ„ 1',0),(294402,8178,'fr','Autre Style 1',0),(294403,8178,'jp','ä»£æ›¿ã‚¹ã‚¿ã‚¤ãƒ« 1',0),(294404,8178,'pt','Estilo alternativo 1',0),(294405,8178,'ru','ÐÐ»ÑŒÑ‚ÐµÑ€Ð½Ð°Ñ‚Ð¸Ð²Ð½Ñ‹Ð¹ Ð¡Ñ‚Ð¸Ð»ÑŒ 1',0),(294406,8178,'es','Estilo Alternado 1',0),(294407,8178,'de','Alternativen Stil 1',0),(294408,8178,'en','Alternate Style 1',0),(294409,8179,'is','',0),(294410,8179,'dr','Ù…Ù‚Ø§ÙŠØ³Ù‡ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(294411,8179,'pr','Ù…Ù‚Ø§ÙŠØ³Ù‡ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(294412,8179,'tr','KarÅŸÄ±laÅŸtÄ±rma fiyat dÃ¼zeyi',0),(294413,8179,'pl','PorÃ³wnanie poziomu cen',0),(294414,8179,'bg','Ð¡Ñ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð¾ Ð½Ð¸Ð²Ð¾',0),(294415,8179,'ur','Ù…ÙˆØ§Ø²Ù†Û Ù‚ÛŒÙ…Øª Ø³Ø·Ø­',0),(294416,8179,'sr','ÐŸÐ¾Ñ€ÐµÑ’ÐµÑšÐµ Ð½Ð¸Ð²Ð¾Ñƒ Ñ†ÐµÐ½Ð°',0),(294417,8179,'vi','Má»©c giÃ¡ So sÃ¡nh ',0),(294418,8179,'af','Vergelyking prys vlak',0),(294419,8179,'ro','Nivel de preÅ£ comparaÅ£ie',0),(294420,8179,'et','VÃµrdlus hinnatase',0),(294421,8179,'si','Primerjava ravni cen',0),(294422,8179,'ba','Tingkat perbandingan harga',0),(294423,8179,'nl','Vergelijking prijsniveau',0),(294424,8179,'fi','Vertailu hintataso',0),(294425,8179,'no','Sammenligning prisnivÃ¥',0),(294426,8179,'da','Sammenligning prisniveau',0),(294427,8179,'ko','ë¹„êµ ê°€ê²© ìˆ˜ì¤€',0),(294428,8179,'he','×¨×ž×ª ×ž×—×™×¨ ×”×©×•×•××”',0),(294429,8179,'el','Î£ÏÎ³ÎºÏÎ¹ÏƒÎ· Ï„Î¹Î¼Î® ÎµÏ€Î¯Ï€ÎµÎ´Î¿',0),(294430,8179,'zh','ä»·æ ¼æ°´å¹³æ¯”è¾ƒ\r\n',0),(294431,8179,'sv','JÃ¤mfÃ¶relse prissÃ¤tter jÃ¤mnt',0),(294432,8179,'it','Livello di confronto prezzi',0),(294433,8179,'tl','',0),(294434,8179,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3585;&#3634;&#3619;&#3648;&#3611;&#3619;&#3637;&#3618;&#3610;&#3648;&#3607;&#3637;&#3618;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(294435,8179,'hi','à¤¤à¥à¤²à¤¨à¤¾ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°',0),(294436,8179,'ms','Perbandingan harga peringkat',0),(294437,8179,'ar','Ù…Ù‚Ø§Ø±Ù†Ø© Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(294438,8179,'fr','Niveau de prix de comparaison',0),(294439,8179,'jp','æ¯”è¼ƒä¾¡æ ¼ãƒ¬ãƒ™ãƒ«',0),(294440,8179,'pt','NÃ­vel de ComparaÃ§Ã£o de PreÃ§o',0),(294441,8179,'ru','Ð¡Ñ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ ÑƒÑ€Ð¾Ð²Ð½Ñ Ñ†ÐµÐ½',0),(294442,8179,'es','Nivel de Precios de ComparaciÃ³n',0),(294443,8179,'de','Vergleich-Preisniveau',0),(294444,8179,'en','Comparison Price Level',0),(294445,8180,'is','',0),(294446,8180,'dr','Ø±ÙˆØ´ Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨  Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(294447,8180,'pr','Ø±ÙˆØ´ Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨  Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(294448,8180,'tr','Yerine getirilmesi sipariÅŸ seÃ§ liste stili',0),(294449,8180,'pl','Realizacji zamÃ³wienia wybraÄ‡ styl listy',0),(294450,8180,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ñ€ÐµÐ´ Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ ÑÑ‚Ð¸Ð» Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(294451,8180,'ur','ØªÚ©Ù…ÛŒÙ„ Ø­Ú©Ù… Ø§Ù†ØªØ®Ø§Ø¨ Ø·Ø±Ø² ÙÛØ±Ø³Øª',0),(294452,8180,'sr','Ð¡Ñ‚Ð¸Ð» Ð»Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐ° Ð·Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(294453,8180,'vi','Kiá»ƒu danh sÃ¡ch ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(294454,8180,'af','Uitvoeringsbestelling Elite Lys Styl',0),(294455,8180,'ro','ÃŽndeplinirea comenzii Pick lista stil',0),(294456,8180,'et','Plaanitud tellimuse kÃ¤tte loendilaadi',0),(294457,8180,'si','Slog seznama za izpolnitev nalog Pick',0),(294458,8180,'ba','Pemenuhan Order memilih daftar gaya',0),(294459,8180,'nl','Vervulling volgorde Pick lijststijl',0),(294460,8180,'fi','TÃ¤yttÃ¤minen jÃ¤rjestyksessÃ¤ valita luettelotyyli',0),(294461,8180,'no','Oppfyllelsen ordre plukke listestil',0),(294462,8180,'da','Opfyldelse for Pick opstillingstypografi',0),(294463,8180,'ko','í–‰ ìˆœì„œ ì„ íƒ ëª©ë¡ ìŠ¤íƒ€ì¼',0),(294464,8180,'he','×¡×’× ×•×Ÿ ×¨×©×™×ž×” ×©×œ ×¤×™×§ ×¡×“×¨ ×”×’×©×ž×”',0),(294465,8180,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Pick ÏƒÏ„Ï…Î» Î»Î¯ÏƒÏ„Î±Ï‚',0),(294466,8180,'zh','å±¥è¡Œè®¢è´­é€‰æ‹©ç›®å½•æ ·å¼\r\n',0),(294467,8180,'sv','Uppfyllelse ordning plocka lista formatmall',0),(294468,8180,'it','Evasione ordine Pick elenco stile',0),(294469,8180,'tl','',0),(294470,8180,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3648;&#3585;&#3655;&#3610;&#3652;&#3',0),(294471,8180,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤‰à¤ à¤¾à¤“ à¤¸à¥‚à¤šà¥€ à¤¶à¥ˆà¤²à¥€',0),(294472,8180,'ms','Memenuhi perintah memilih senarai gaya',0),(294473,8180,'ar','ÙˆÙØ§Ø¡ Ø£Ù…Ø± Ø§Ø®ØªÙŠØ§Ø± Ù†Ù…Ø· Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(294474,8180,'fr','Order Fulfillment Pick Style de liste',0),(294475,8180,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼ ãƒ”ãƒƒã‚¯ ãƒªã‚¹ãƒˆ ã‚¹ã‚¿ã‚¤ãƒ«',0),(294476,8180,'pt','Estilo de Lista de Ordem de Cumprimento',0),(294477,8180,'ru','Ð¡Ñ‚Ð¸Ð»ÑŒ ÑÐ¿Ð¸ÑÐºÐ° Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(294478,8180,'es','Estilo de Lista de SelecciÃ³n de Orden de Cumplimiento',0),(294479,8180,'de','ErfÃ¼llung Reihenfolge Pick List Style',0),(294480,8180,'en','Fulfillment Order Pick List Style',0),(294481,8181,'is','',0),(294482,8181,'dr','( _Ø­Ù…Ù„ Ø¨Ù‡ _  ) (ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ Ø¨Ù‡ _ ) Ùˆ ØºÙŠØ±Ù‡ ',0),(294483,8181,'pr','Ù‡ÙŠÚ† Ù…ÙˆØ±Ø¯ÙŠ Ø¯Ø± ÙØ§ÙƒØªÙˆØ±( _Ø­Ù…Ù„ Ø¨Ù‡ _  ) (ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ Ø¨Ù‡ _ ) Ùˆ ØºÙŠØ±Ù‡ ',0),(294484,8181,'tr','Fatura satÄ±lan, vb gÃ¶nderilecek, Tarih kutusu yok',0),(294485,8181,'pl','Nie ma pola na fakturze statku-, sprzedawane, itp',0),(294486,8181,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð²ÑŠÐ² Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°, Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‚, Ð¸ Ñ‚.Ð½.',0),(294487,8181,'ur','Ú©ÙˆØ¦ÛŒ Ø®Ø§Ù†ÙˆÚº Ù¾Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¬ÛØ§Ø²-ÙØ±ÙˆØ®Øª Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ØŒ ÙˆØºÛŒØ±Û Ú©Û’ Ù„ÛŒÛ’',0),(294488,8181,'sr','ÐÐµÐ¼Ð° ÐºÑƒÑ‚Ð¸Ñ˜Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°, Ð¿Ñ€Ð¾Ð´Ð°Ð¾, Ð¸Ñ‚Ð´',0),(294489,8181,'vi','KhÃ´ng Ä‘á»ƒ thÃ¹ng trÃªn hÃ³a Ä‘Æ¡n chuyá»ƒn Ä‘áº¿n, bÃ¡n cho vv',0),(294490,8181,'af','Geen Bokse Op Faktuur Versend-Aan, Verkoop Aan, Ens.',0),(294491,8181,'ro','Nu cutii pe facturÄƒ livrare-la, vÃ¢ndut, Etc',0),(294492,8181,'et','Pole kaste On arve saaja-, mÃ¼Ã¼a, jne',0),(294493,8181,'si','Ni polja na raÄunu za dobavo, prodaja, itd',0),(294494,8181,'ba','Ada kotak di faktur kapal ke, dijual ke, dll',0),(294495,8181,'nl','Geen vakken op factuur verzendcode, verkocht aan, enz',0),(294496,8181,'fi','Ei laatikoita laskun Toimitusasiakas myydÃ¤Ã¤n jne',0),(294497,8181,'no','Ingen bokser pÃ¥ fakturaen lever til, solgt til, Etc',0),(294498,8181,'da','Ingen bokse pÃ¥ fakturaen leveringsadresse, solgt til mv',0),(294499,8181,'ko','ì•„ë‹ˆ ë°•ìŠ¤ì— ì†¡ìž¥ ë°°-, ë“± íŒë§¤',0),(294500,8181,'he','×œ×œ× ×ª×™×‘×•×ª ×¢×œ ×—×©×‘×•× ×™×ª ×œ×ž×©×œ×•×—, ×ž×›×¨, ×•×¢×•×“',0),(294501,8181,'el','Î”ÎµÎ½ ÎºÎ¿Ï…Ï„Î¹Î¬ ÏƒÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ, Ï€Ï‰Î»Î¿ÏÎ½Ï„Î±Î¹, ÎºÎ»Ï€',0),(294502,8181,'zh','å‘ç¥¨ä¸Šæ²¡æœ‰æ”¶è´§æ¡†ï¼Œå”®è´§æ¡†ï¼Œç­‰ç­‰\r\n',0),(294503,8181,'sv','Inga lÃ¥dor pÃ¥ fakturan leveransadress sÃ¤ljs till, Etc',0),(294504,8181,'it','Senza caselle su fattura spedire a, venduto, ecc',0),(294505,8181,'tl','',0),(294506,8181,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3594;&#3656;&#3629;&#3591;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;,&#3586;&#',0),(294507,8181,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤œà¤¹à¤¾à¤œ-à¤¬à¥‡à¤šà¥‡, à¤†à¤¦à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤ªà¤° à¤•à¥‹à¤ˆ à¤¬à¤•à¥à¤¸à¥‡',0),(294508,8181,'ms','Tiada kotak pada invois kapal-untuk dijual ke, dan lain-lain',0),(294509,8181,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ø±Ø¨Ø¹Ø§Øª Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø³ÙÙŠÙ†Ø©-Ø¥Ù„Ù‰ØŒ ØªØ¨Ø§Ø¹ØŒ Ø¥Ù„Ø®',0),(294510,8181,'fr','Pas de boÃ®tes sur facture Ship-To, vendus, etc.',0),(294511,8181,'jp','è«‹æ±‚æ›¸é€ä»˜å…ˆã€ç­‰ã«è²©å£²ã®ãƒœãƒƒã‚¯ã‚¹ã¯è¡¨ç¤ºã•ã‚Œã¾ã›ã‚“ã€‚',0),(294512,8181,'pt','Sem caixas na factura envio-a, vendido, Etc',0),(294513,8181,'ru','ÐÐµ ÐºÐ¾Ñ€Ð¾Ð±ÐºÐ¸ Ð½Ð° ÑÑ‡ÐµÑ‚ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ðº, Ð¿Ñ€Ð¾Ð´Ð°Ð½Ð¾, Ð¸ Ñ‚.Ð´.',0),(294514,8181,'es','No Hay Cajas en la Factura para Enviar-A, Vendido A, Etc.',0),(294515,8181,'de','Kein Boxen auf Rechnung Ship-To, verkauft, etc.',0),(294516,8181,'en','No Boxes On Invoice Ship-To, Sold To, Etc',0),(294517,8182,'is','',0),(294518,8182,'dr','Ù†Ù…Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙˆØ§Ø­Ø¯ Ùˆ Ù…Ù‚Ø§ÙŠØ³Ù‡ Ù‚ÙŠÙ…Øª',0),(294519,8182,'pr','Ù†Ù…Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙˆØ§Ø­Ø¯ Ùˆ Ù…Ù‚Ø§ÙŠØ³Ù‡ Ù‚ÙŠÙ…Øª',0),(294520,8182,'tr','Birim fiyat ve fiyat karÅŸÄ±laÅŸtÄ±rma',0),(294521,8182,'pl','PokaÅ¼ ceny jednostkowej i porÃ³wnanie cen',0),(294522,8182,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð° Ð¸ Ñ†ÐµÐ½Ð° ÑÑ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ',0),(294523,8182,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø§ÙˆØ± Ù‚ÛŒÙ…Øª Ú©Û’ Ù…Ù‚Ø§Ø¨Ù„Û’ Ù…ÛŒÚº Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(294524,8182,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð° Ð¸ Ð¿Ð¾Ñ€ÐµÑ’ÐµÑšÐµ Ñ†ÐµÐ½Ð°',0),(294525,8182,'vi','Hiá»ƒn thá»‹ Ä‘Æ¡n vá»‹ giÃ¡ & so sÃ¡nh giÃ¡',0),(294526,8182,'af','Wys eenheid prys en prys vergelyking',0),(294527,8182,'ro','AratÄƒ preÅ£ul unitar ÅŸi compararea preÅ£urilor',0),(294528,8182,'et','MÃ¼Ã¼gihind ja vÃµrdlus hind',0),(294529,8182,'si','PokaÅ¾i ceno enote in primerjavo cen',0),(294530,8182,'ba','Tampilkan harga satuan dan perbandingan harga',0),(294531,8182,'nl','Prijs per eenheid en vergelijkingsprijs weergeven',0),(294532,8182,'fi','NÃ¤ytÃ¤ yksikkÃ¶hinnan ja vertailuhinta',0),(294533,8182,'no','Vis enhetsprisen og sammenligning pris',0),(294534,8182,'da','Vis enhedspris og sammenligning',0),(294535,8182,'ko','í‘œì‹œ ë‹¨ìœ„ ê°€ê²©ê³¼ ë¹„êµ ê°€ê²©',0),(294536,8182,'he','×”×¦×’×ª ×ž×—×™×¨ ×™×—×™×“×” ×©×œ ×”×©×•×•××ª ×ž×—×™×¨',0),(294537,8182,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î¹Î¼Î®Ï‚ ÎºÎ±Î¹ ÏƒÏÎ³ÎºÏÎ¹ÏƒÎ· Ï„Î¹Î¼ÏŽÎ½',0),(294538,8182,'zh','æ˜¾ç¤ºå•ä»·åŠä»·æ ¼æ¯”è¾ƒ\r\n',0),(294539,8182,'sv','Visa per enhet och jÃ¤mfÃ¶relse',0),(294540,8182,'it','Visualizza il prezzo unitario e prezzo di confronto',0),(294541,8182,'tl','',0),(294542,8182,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3588;&#3634;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3648;&#3611;&#3619;&#3637;&#3618;&#3610;&#3648;&#3607;&#3637;&#3618;&#3610;&#3619;&#3634;&#3588;&#3',0),(294543,8182,'hi','à¤¶à¥‹ à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤®à¥‚à¤²à¥à¤¯ à¤”à¤° à¤®à¥‚à¤²à¥à¤¯ à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾',0),(294544,8182,'ms','Harga Unit dan perbandingan harga',0),(294545,8182,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø³Ø¹Ø± Ø§Ù„ÙˆØ­Ø¯Ø© ÙˆØ§Ù„Ø³Ø¹Ø± Ù…Ù‚Ø§Ø±Ù†Ø©',0),(294546,8182,'fr','Voir l\'Ã©tablissement de prix unitaire et le prix de comparaison',0),(294547,8182,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã®ä¾¡æ ¼ã¨æ¯”è¼ƒä¾¡æ ¼ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(294548,8182,'pt','Mostrar preÃ§o unitÃ¡rio e preÃ§o de comparaÃ§Ã£o',0),(294549,8182,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½Ð° Ð¸ Ñ†ÐµÐ½Ð° Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(294550,8182,'es','Mostrar Precio de Unidad Y Precio de ComparaciÃ³n',0),(294551,8182,'de','Einzelpreis und Vergleichspreis anzeigen',0),(294552,8182,'en','Show Unit Price And Comparison Price',0),(294553,8183,'is','',0),(294554,8183,'dr','Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(294555,8183,'pr','Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(294556,8183,'tr','Kredi kartlarÄ± iÃ§in kullanÄ±lmaz',0),(294557,8183,'pl','Nie uÅ¼ywany dla kart kredytowych',0),(294558,8183,'bg','ÐÐµ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(294559,8183,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù†ÛÛŒÚº Ú©ÛŒØ§',0),(294560,8183,'sr','ÐÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(294561,8183,'vi','KhÃ´ng Sá»­ Dá»¥ng Cho Tháº» TÃ­n Dá»¥ng',0),(294562,8183,'af','Nie Gebruik Vir Kredietkaarte',0),(294563,8183,'ro','Nu folosit pentru carduri de Credit',0),(294564,8183,'et','Mitte kasutada pangakaarte',0),(294565,8183,'si','Ne uporablja za kreditne kartice',0),(294566,8183,'ba','Tidak digunakan untuk kartu kredit',0),(294567,8183,'nl','Niet gebruikt voor Credit Cards',0),(294568,8183,'fi','Ei kÃ¤ytetÃ¤ luottokortit',0),(294569,8183,'no','Ikke brukes For kredittkort',0),(294570,8183,'da','Ikke anvendes til kreditkort',0),(294571,8183,'ko','ì‹ ìš© ì¹´ë“œ ì‚¬ìš© í•˜ì§€',0),(294572,8183,'he','×œ× ×ž×©×ž×© ×¢×‘×•×¨ ×›×¨×˜×™×¡×™ ××©×¨××™',0),(294573,8183,'el','Î”ÎµÎ½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(294574,8183,'zh','ä¸ç”¨ä»¥ä¿¡ç”¨å¡\r\n',0),(294575,8183,'sv','Inte anvÃ¤nds fÃ¶r kreditkort',0),(294576,8183,'it','Non utilizzato per le carte di credito',0),(294577,8183,'tl','',0),(294578,8183,'th','&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3651;&#3594;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(294579,8183,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¹à¥€à¤‚ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(294580,8183,'ms','Tidak digunakan untuk kad kredit',0),(294581,8183,'ar','Ù„Ø§ ØªØ³ØªØ®Ø¯Ù… Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(294582,8183,'fr','Pas utilisÃ© pour les cartes de crÃ©dit',0),(294583,8183,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã‚’ä½¿ç”¨ã—ã¾ã›ã‚“ã€‚',0),(294584,8183,'pt','NÃ£o usado para cartÃµes de crÃ©dito',0),(294585,8183,'ru','ÐÐµ Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð”Ð»Ñ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐšÐ°Ñ€Ñ‚',0),(294586,8183,'es','No Usado Para Tarjetas de CrÃ©dito',0),(294587,8183,'de','Nicht verwendet fÃ¼r Kreditkarten',0),(294588,8183,'en','Not Used For Credit Cards',0),(294589,8184,'is','',0),(294590,8184,'dr','Ù…ÙƒØ§Ù† Ø¯Ø± Ø¯Ø§Ø®Ù„ Ø§Ù†Ø¨Ø§Ø± ',0),(294591,8184,'pr','Ù…ÙƒØ§Ù† Ø¯Ø± Ø¯Ø§Ø®Ù„ Ø§Ù†Ø¨Ø§Ø± ',0),(294592,8184,'tr','Ambar iÃ§inde konum',0),(294593,8184,'pl','Lokalizacja w obrÄ™bie magazynu',0),(294594,8184,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð² ÑÐºÐ»Ð°Ð´Ð°',0),(294595,8184,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú¯ÙˆØ¯Ø§Ù… Ú©Û’ Ø§Ù†Ø¯Ø±',0),(294596,8184,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ ÑƒÐ½ÑƒÑ‚Ð°Ñ€ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ð°',0),(294597,8184,'vi','Vá»‹ trÃ­ vá»›i nhÃ  kho',0),(294598,8184,'af','Ligging binne pakhuis',0),(294599,8184,'ro','LocaÅ£ie Ã®n depozit',0),(294600,8184,'et','Lao asukoht',0),(294601,8184,'si','Lokacija znotraj skladiÅ¡Äa',0),(294602,8184,'ba','Lokasi gudang',0),(294603,8184,'nl','Locatie in magazijn',0),(294604,8184,'fi','Sijainti varastossa',0),(294605,8184,'no','Plassering pÃ¥ lageret',0),(294606,8184,'da','Placering i lageret',0),(294607,8184,'ko','ì°½ ê³  ë‚´ ìœ„ì¹˜',0),(294608,8184,'he','×ž×™×§×•× ×‘×ª×•×š ×”×ž×—×¡×Ÿ',0),(294609,8184,'el','Î˜Î­ÏƒÎ· ÏƒÎµ Î±Ï€Î¿Î¸Î®ÎºÎ·',0),(294610,8184,'zh','ä»“åº“å†…çš„ä½ç½®\r\n',0),(294611,8184,'sv','LÃ¤ge inom lager',0),(294612,8184,'it','Posizione all\'interno del magazzino',0),(294613,8184,'tl','',0),(294614,8184,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3616;&#3634;&#3618;&#3651;&#3609;&#3650;&#3585;&#3604;&#3633;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(294615,8184,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤¸à¥à¤¥à¤¾à¤¨',0),(294616,8184,'ms','Lokasi di dalam gudang',0),(294617,8184,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø¯Ø§Ø®Ù„ Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹',0),(294618,8184,'fr','Emplacement au sein de l\'entrepÃ´t',0),(294619,8184,'jp','å€‰åº«å†…ã®å ´æ‰€',0),(294620,8184,'pt','LocalizaÃ§Ã£o no armazÃ©m',0),(294621,8184,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð²Ð½ÑƒÑ‚Ñ€Ð¸ ÑÐºÐ»Ð°Ð´Ð°',0),(294622,8184,'es','UbicaciÃ³n Dentro de AlmacÃ©n',0),(294623,8184,'de','Lage im Lager',0),(294624,8184,'en','Location Within Warehouse',0),(294625,8185,'is','',0),(294626,8185,'dr','(Ø¯Ø§Ø¯Ù‡ Ù‡Ø§) ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ ',0),(294627,8185,'pr','Ù‚ÙØ³Ù‡(Ø¯Ø§Ø¯Ù‡ Ù‡Ø§) ØµØ­Ø§Ù Ø®Ø§Ù†Ù‡ ',0),(294628,8185,'tr','Bin/raf',0),(294629,8185,'pl','Bin/pÃ³Å‚ka',0),(294630,8185,'bg','Ð¡Ðš/ÑÑ‚ÐµÐ»Ð°Ð¶',0),(294631,8185,'ur','Ø¨Ù†/Ø´ÛŒÙ„Ù',0),(294632,8185,'sr','Ð‘Ð¸Ð½/Ð¿Ð¾Ð»Ð¸Ñ†Ð°',0),(294633,8185,'vi','Sá»t rÃ¡c/Ká»‡ sÃ¡ch',0),(294634,8185,'af','Asblik/rak',0),(294635,8185,'ro','Bin/raft',0),(294636,8185,'et','Bin/riiul',0),(294637,8185,'si','Bin/polica',0),(294638,8185,'ba','Bin rak',0),(294639,8185,'nl','Bin/plank',0),(294640,8185,'fi','Bin/hylly',0),(294641,8185,'no','Bin/sokkel',0),(294642,8185,'da','Bin/hylde',0),(294643,8185,'ko','ë¹ˆ/ì„ ë°˜',0),(294644,8185,'he','×¡×œ ××• ×ž×“×£',0),(294645,8185,'el','Bin/ÏÎ¬Ï†Î¹',0),(294646,8185,'zh','è£…è®¢/è´§æž¶\r\n',0),(294647,8185,'sv','Bin/hylla',0),(294648,8185,'it','Bin/mensola',0),(294649,8185,'tl','',0),(294650,8185,'th','&#3585;&#3621;&#3656;&#3629;&#3591;/&#3627;&#3636;&#3657;&#3591;',0),(294651,8185,'hi','à¤¬à¤¿à¤¨/à¤¶à¥‡à¤²à¥à¤«',0),(294652,8185,'ms','Bin/rak',0),(294653,8185,'ar','Ø¨Ù†/Ø§Ù„Ø¬Ø±Ù',0),(294654,8185,'fr','Bin/tablette',0),(294655,8185,'jp','ç®±/æ£š',0),(294656,8185,'pt','Bin/prateleira',0),(294657,8185,'ru','Bin/Ð¿Ð¾Ð»ÐºÐ°',0),(294658,8185,'es','DepÃ³sito/Repisa',0),(294659,8185,'de','Bin/Regal',0),(294660,8185,'en','Bin/Shelf',0),(294661,8186,'is','',0),(294662,8186,'dr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø§Ø¯ÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(294663,8186,'pr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ù…Ù‚Ø§Ø¯ÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(294664,8186,'tr','Varolan miktarlarÄ± engellemek',0),(294665,8186,'pl','Blok iloÅ›ci istniejÄ…cych',0),(294666,8186,'bg','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(294667,8186,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ù…Ù‚Ø¯Ø§Ø±ÛŒÚº Ø¨Ù„Ø§Ú© Ú©Ø±ÛŒÚº',0),(294668,8186,'sr','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð°Ñ˜ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(294669,8186,'vi','Sá»‘ lÆ°á»£ng Ä‘áº·t sáºµn hiá»‡n cÃ³',0),(294670,8186,'af','Bestaande hoeveelhede blokkeer',0),(294671,8186,'ro','Bloc cantitÄƒÈ›ilor existente',0),(294672,8186,'et','Blokeeri olemasolevate koguste',0),(294673,8186,'si','Blok obstojeÄe koliÄine',0),(294674,8186,'ba','Memblokir jumlah yang sudah ada',0),(294675,8186,'nl','Blokkeren van bestaande hoeveelheden',0),(294676,8186,'fi','EstÃ¤Ã¤ nykyiset mÃ¤Ã¤rÃ¤t',0),(294677,8186,'no','Blokkere eksisterende mengder',0),(294678,8186,'da','Blokere eksisterende mÃ¦ngder',0),(294679,8186,'ko','ê¸°ì¡´ ìˆ˜ëŸ‰ì„ ì°¨ë‹¨',0),(294680,8186,'he','×‘×œ×•×§ ×”×§×™×™× ×‘×›×ž×•×™×•×ª',0),(294681,8186,'el','ÎœÏ€Î»Î¿ÎºÎ¬ÏÎµÎ¹ Ï„Î¹Ï‚ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎµÏ‚ Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚',0),(294682,8186,'zh','å°é”çŽ°æœ‰æ•°é‡\r\n',0),(294683,8186,'sv','Blockera befintliga kvantiteter',0),(294684,8186,'it','Bloccare la quantitÃ  esistente',0),(294685,8186,'tl','',0),(294686,8186,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3626;&#3636;&#3656;&#3591;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3610;&#3621;&#3655;&#3629;&#3585;',0),(294687,8186,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¬à¥à¤²à¥‰à¤• à¤•à¤°à¥‡à¤‚',0),(294688,8186,'ms','Blok kuantiti yang sedia ada',0),(294689,8186,'ar','ÙƒØªÙ„Ø© Ø§Ù„ÙƒÙ…ÙŠØ§Øª Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(294690,8186,'fr','Bloquer des quantitÃ©s existantes',0),(294691,8186,'jp','æ—¢å­˜ã®æ•°é‡ã‚’ãƒ–ãƒ­ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(294692,8186,'pt','Bloquear as quantidades existentes',0),(294693,8186,'ru','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÐµÐµ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(294694,8186,'es','Cantidades Existentes del Bloque',0),(294695,8186,'de','Vorhandene Mengen zu blockieren',0),(294696,8186,'en','Block Existing Quantities',0),(294697,8187,'is','',0),(294698,8187,'dr','( Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) / Ù‚ÙØ³Ù‡ ',0),(294699,8187,'pr','Ù†Ù…Ø§ÙŠØ´  Ø³ØªÙˆÙ† Ù…Ø­Ù„  Ø§Ù†Ø¨Ø§Ø±Ú© ( Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ ) / Ù‚ÙØ³Ù‡ ',0),(294700,8187,'tr','Bin/raf konum sÃ¼tun gÃ¶rÃ¼ntÃ¼ler',0),(294701,8187,'pl','WyÅ›wietlane w kolumnie lokalizacja kosza/pÃ³Å‚ka',0),(294702,8187,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¡Ðš/ÑÑ‚ÐµÐ»Ð°Ð¶ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ ÐºÐ¾Ð»Ð¾Ð½Ð°',0),(294703,8187,'ur','ÚˆØ³Ù¾Ù„Û’ Ø¨Ù†/Ø´ÛŒÙ„Ù Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Ø§Ù„Ù…',0),(294704,8187,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð‘Ð¸Ð½/Ð¿Ð¾Ð»Ð¸Ñ†Ð°',0),(294705,8187,'vi','Hiá»ƒn thá»‹ cá»™t giá» rÃ¡c/ká»‡ vá»‹ trÃ­',0),(294706,8187,'af','Asblik/rak ligging kolom vertoon',0),(294707,8187,'ro','AfiÅŸare coloana de locaÅ£ie Bin/raft',0),(294708,8187,'et','Bin/riiuli kohta veeru kuvamine',0),(294709,8187,'si','Prikazati stolpec mesto Bin/polica',0),(294710,8187,'ba','Kolom lokasi tampilan Bin rak',0),(294711,8187,'nl','Bin/plank locatie kolom weergeven',0),(294712,8187,'fi','NÃ¤yttÃ¶sarake Bin/hylly sijainti',0),(294713,8187,'no','Bin/sokkel visningssted kolonne',0),(294714,8187,'da','Display Bin/hylde lokationskolonnen',0),(294715,8187,'ko','ë¹ˆ/ì„ ë°˜ ìœ„ì¹˜ ì—´ í‘œì‹œ',0),(294716,8187,'he','×œ×”×¦×™×’ ×”×¢×ž×•×“×” ×ž×™×§×•× ×¡×œ ××• ×ž×“×£',0),(294717,8187,'el','Î•Î¼Ï†Î±Î½Î¹Î¶ÏŒÎ¼ÎµÎ½Î· ÏƒÏ„Î®Î»Î· Î¸Î­ÏƒÎ· Bin/ÏÎ¬Ï†Î¹',0),(294718,8187,'zh','æ˜¾ç¤ºè£…è®¢/è´§æž¶ä½ç½®åˆ—\r\n',0),(294719,8187,'sv','Visa Bin/hylla plats kolumn',0),(294720,8187,'it','Visualizzare la colonna posizione Bin/mensola',0),(294721,8187,'tl','',0),(294722,8187,'th','&#3649;&#3626;&#3604;&#3591;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660; &#3606;&#3633;&#3591;&#3586;&#3618;&#3632;/&#3594;&#3633;&#3657;&#3609;&#3623;&#3634;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&',0),(294723,8187,'hi','à¤¬à¤¿à¤¨/à¤¶à¥‡à¤²à¥à¤« à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¥à¤¤à¤‚à¤­ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(294724,8187,'ms','Memaparkan ruangan lokasi Bin/rak',0),(294725,8187,'ar','Ø¹Ø±Ø¶ Ø¹Ù…ÙˆØ¯ Ù…ÙˆÙ‚Ø¹ Ø¨Ù†/Ø§Ù„Ø¬Ø±Ù',0),(294726,8187,'fr','Afficher la colonne emplacement Bin/tablette',0),(294727,8187,'jp','ç®±/æ£šã®å ´æ‰€åˆ—ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(294728,8187,'pt','Coluna de localizaÃ§Ã£o de Bin/prateleira de exposiÃ§Ã£o',0),(294729,8187,'ru','ÐžÑ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ð»Ð±ÐµÑ† Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Bin/Ð¿Ð¾Ð»ÐºÐ°',0),(294730,8187,'es','Desplegar DepÃ³sito/Estante Columna de UbicaciÃ³n',0),(294731,8187,'de','Bin/Regal Lage Anzeigespalte',0),(294732,8187,'en','Display Bin/Shelf Location Column',0),(294733,8188,'is','',0),(294734,8188,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ØªÙˆÙ† Ú¯Ø±ÙˆÙ‡ ',0),(294735,8188,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ØªÙˆÙ† Ú¯Ø±ÙˆÙ‡ ',0),(294736,8188,'tr','GÃ¶rÃ¼ntÃ¼ kategori sÃ¼tunu',0),(294737,8188,'pl','WyÅ›wietlanie kolumn',0),(294738,8188,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÐºÐ¾Ð»Ð¾Ð½Ð°',0),(294739,8188,'ur','ÚˆØ³Ù¾Ù„Û’ Ø²Ù…Ø±Û Ú©Ø§Ù„Ù…',0),(294740,8188,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° ÐºÐ¾Ð»Ð¾Ð½Ð°',0),(294741,8188,'vi','Hiá»ƒn thá»‹ cá»™t thá»ƒ loáº¡i',0),(294742,8188,'af','Wys Kategorie Kolom',0),(294743,8188,'ro','AfiÅŸare categorie coloana',0),(294744,8188,'et','Kuva kategooria veerg',0),(294745,8188,'si','Prikaz Kategorija stolpec',0),(294746,8188,'ba','Kolom tampilan Kategori',0),(294747,8188,'nl','Categoriekolom weergeven',0),(294748,8188,'fi','NÃ¤ytÃ¤ sarake',0),(294749,8188,'no','Vise kategori-kolonnen',0),(294750,8188,'da','Displayet kategori kolonne',0),(294751,8188,'ko','ë””ìŠ¤í”Œë ˆì´ ì¹´í…Œê³ ë¦¬ ì—´',0),(294752,8188,'he','×”×¦×’ ×¢×ž×•×“×ª ×§×˜×’×•×¨×™×”',0),(294753,8188,'el','Î•Î¼Ï†Î±Î½Î¹Î¶ÏŒÎ¼ÎµÎ½Î· ÏƒÏ„Î®Î»Î· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(294754,8188,'zh','æ˜¾ç¤ºåˆ†ç±»åˆ—\r\n',0),(294755,8188,'sv','Kolumnen visas kategorin',0),(294756,8188,'it','Colonna categoria di visualizzazione',0),(294757,8188,'tl','',0),(294758,8188,'th','&#3649;&#3626;&#3604;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3588;&#3629;&#3621;&#3633;&#3617;&#3609;&#3660;',0),(294759,8188,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¥à¤¤à¤‚à¤­',0),(294760,8188,'ms','Paparan Kategori kolum',0),(294761,8188,'ar','Ø¹Ø±Ø¶ Ø®Ø§Ù†Ø© Ø§Ù„ØªØµÙ†ÙŠÙ',0),(294762,8188,'fr','Dans la colonne catÃ©gorie affichage',0),(294763,8188,'jp','è¡¨ç¤ºã‚«ãƒ†ã‚´ãƒªåˆ—',0),(294764,8188,'pt','Coluna de categoria de exposiÃ§Ã£o',0),(294765,8188,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ ÐšÐ¾Ð»Ð¾Ð½ÐºÑƒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ ',0),(294766,8188,'es','Desplegar Columna de CategorÃ­a',0),(294767,8188,'de','Kategorie Anzeigespalte',0),(294768,8188,'en','Display Category Column',0),(294769,8189,'is','',0),(294770,8189,'dr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² Ø¯Ø±ÙŠØ§ÙØª ÙŠØ§ ÙƒÙ¾ÙŠ ',0),(294771,8189,'pr','Ø°Ø®ÙŠØ±Ù‡ ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² Ø¯Ø±ÙŠØ§ÙØª ÙŠØ§ ÙƒÙ¾ÙŠ ',0),(294772,8189,'tr','DeÄŸiÅŸiklikleri kaydetmek daha Ã¶nce almak veya Clone',0),(294773,8189,'pl','ZapisaÄ‡ zmiany zanim otrzyma lub klon',0),(294774,8189,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð¸Ð»Ð¸ ÐºÐ»Ð¾Ð½Ð¸Ð½Ð³',0),(294775,8189,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù†Û’ Ø³Û’ Ù¾ÛÙ„Û’ ÙˆØµÙˆÙ„ Ú©Ø±ÛŒÚº ÛŒØ§ Ù¾ÛŒÙˆÙ†Ø¯ Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(294776,8189,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð¿Ñ€Ðµ Ð½ÐµÐ³Ð¾ ÑˆÑ‚Ð¾ Ð¿Ñ€Ð¸Ð¼Ð¸Ñ‚Ðµ Ð¸Ð»Ð¸ ÐºÐ»Ð¾Ð½',0),(294777,8189,'vi','Sao lÆ°u thay Ä‘á»•i trÆ°á»›c khi nháº­n hay báº£n táº¡m',0),(294778,8189,'af','Stoor veranderinge voor ontvang of kloon',0),(294779,8189,'ro','SalvaÅ£i modificÄƒrile Ã®nainte primesc sau clona',0),(294780,8189,'et','Salvesta muudatused enne vastuvÃµttu vÃµi kloon',0),(294781,8189,'si','Shrani spremembe, preden prejmejo ali klon',0),(294782,8189,'ba','Simpan perubahan sebelum menerima atau klon',0),(294783,8189,'nl','Wijzigingen opslaan voordat ontvangen of klonen',0),(294784,8189,'fi','Tallenna muutokset ennen saada tai klooni',0),(294785,8189,'no','Lagre endringer fÃ¸r mottar eller klone',0),(294786,8189,'da','Gem Ã¦ndringer fÃ¸r modtager eller klon',0),(294787,8189,'ko','ë³€ê²½ ì‚¬í•­ì„ ì €ìž¥ í•˜ê¸° ì „ì— ìˆ˜ì‹  ë˜ëŠ” ë³µì œ',0),(294788,8189,'he','×©×ž×•×¨ ×©×™× ×•×™×™× ×œ×¤× ×™ ×©×ª×§×‘×œ ××• ×©×™×‘×•×˜',0),(294789,8189,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Î±Î»Î»Î±Î³ÏŽÎ½ Ï€ÏÎ¹Î½ Î»Î¬Î²ÎµÏ„Îµ Î® ÎºÎ»ÏŽÎ½Î¿Ï‚',0),(294790,8189,'zh','æŽ¥æ”¶æˆ–å¤åˆ¶å‰ä¿å­˜æ›´æ”¹\r\n',0),(294791,8189,'sv','Spara Ã¤ndringarna innan fÃ¥ eller klona',0),(294792,8189,'it','Salvare le modifiche prima di ricevere o clonare',0),(294793,8189,'tl','',0),(294794,8189,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3656;&#3629;&#3609;&#3619;&#3633;&#3610;&#3627;&#3619;&#3639;&#3629;&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;',0),(294795,8189,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¯à¤¾ à¤•à¥à¤²à¥‹à¤¨',0),(294796,8189,'ms','Simpan perubahan sebelum menerima atau klon',0),(294797,8189,'ar','Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ù‚Ø¨Ù„ ØªÙ„Ù‚ÙŠ Ø£Ùˆ Ø§Ø³ØªÙ†Ø³Ø§Ø®',0),(294798,8189,'fr','Enregistrer les modifications avant de recevoir ou de Clone',0),(294799,8189,'jp','å¤‰æ›´ã‚’ä¿å­˜ã™ã‚‹å‰ã«å—ä¿¡ã¾ãŸã¯ã‚¯ãƒ­ãƒ¼ãƒ³ã‚’ä½œæˆ',0),(294800,8189,'pt','Salve as alteraÃ§Ãµes antes de receber ou Clone',0),(294801,8189,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¿ÐµÑ€ÐµÐ´ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ÑŒ Ð¸Ð»Ð¸ ÐºÐ»Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(294802,8189,'es','Guardar Cambios Antes Que Recibir o Clonar',0),(294803,8189,'de','Ã„nderungen speichern bevor erhalten oder Klonen',0),(294804,8189,'en','Save Changes Before Receive Or Clone',0),(294805,8190,'is','',0),(294806,8190,'dr','Ù†ÙˆØ¹ ÙƒØ³Ø¨ Ùˆ ÙƒØ§Ø±',0),(294807,8190,'pr','Ù†ÙˆØ¹ ÙƒØ³Ø¨ Ùˆ ÙƒØ§Ø±',0),(294808,8190,'tr','Ä°ÅŸ tÃ¼rÃ¼',0),(294809,8190,'pl','Typu biznes',0),(294810,8190,'bg','Ð¢Ð¸Ð¿ Ð±Ð¸Ð·Ð½ÐµÑ',0),(294811,8190,'ur','Ú©Ø§Ø±ÙˆØ¨Ø§Ø± Ú©ÛŒ Ù‚Ø³Ù…',0),(294812,8190,'sr','Ð’Ñ€ÑÑ‚Ð° Ð¿Ð¾ÑÐ»Ð¾Ð²Ð½Ð¾Ð³',0),(294813,8190,'vi','Loáº¡i hÃ¬nh kinh doanh',0),(294814,8190,'af','Besigheid Tipe',0),(294815,8190,'ro','Tipul de afacere',0),(294816,8190,'et','EttevÃµtlusvorm',0),(294817,8190,'si','Vrsta poslovnih',0),(294818,8190,'ba','Jenis usaha',0),(294819,8190,'nl','Bedrijfstype',0),(294820,8190,'fi','Liiketoiminnan tyyppi',0),(294821,8190,'no','Type virksomhet',0),(294822,8190,'da','Business Type',0),(294823,8190,'ko','ì‚¬ì—… ì¢…ë¥˜',0),(294824,8190,'he','×¡×•×’ ×”×¢×¡×§',0),(294825,8190,'el','Î•Î¯Î´Î¿Ï‚ ÎµÏ€Î¹Ï‡ÎµÎ¯ÏÎ·ÏƒÎ·Ï‚',0),(294826,8190,'zh','ä¼ä¸šç±»åž‹\r\n',0),(294827,8190,'sv','Verksamhetstyp',0),(294828,8190,'it','Tipo di attivitÃ ',0),(294829,8190,'tl','',0),(294830,8190,'th','&#3594;&#3609;&#3636;&#3604;&#3586;&#3629;&#3591;&#3608;&#3640;&#3619;&#3585;&#3636;&#3592;',0),(294831,8190,'hi','à¤µà¥à¤¯à¤µà¤¸à¤¾à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(294832,8190,'ms','Jenis perniagaan',0),(294833,8190,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø£Ø¹Ù…Ø§Ù„',0),(294834,8190,'fr','Type d\'entreprise',0),(294835,8190,'jp','ãƒ“ã‚¸ãƒã‚¹ ã‚¿ã‚¤ãƒ—',0),(294836,8190,'pt','Tipo de negÃ³cio',0),(294837,8190,'ru','Ð¢Ð¸Ð¿ Ð±Ð¸Ð·Ð½ÐµÑÐ°',0),(294838,8190,'es','Tipo de Negocio',0),(294839,8190,'de','Business-Typ',0),(294840,8190,'en','Business Type',0),(294841,8191,'is','',0),(294842,8191,'dr','-ÙƒÙ…Ùƒ  Ø¨Ø§ Ù†ØµØ¨- Ø³ÙˆØ§Ù„Ø§Øª Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ â€“ Ù…Ø´Ù…Ø¬Ù…ÙˆØ¹Ø§Øª ØªÙƒÙ†ÙŠÙƒÙŠ Ùˆ ØºÙŠØ±Ù‡ ',0),(294843,8191,'pr','Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± -ÙƒÙ…Ùƒ  Ø¨Ø§ Ù†ØµØ¨- Ø³ÙˆØ§Ù„Ø§Øª Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ â€“ Ù…Ø´ÙƒÙ„Ø§Øª ØªÙƒÙ†ÙŠÙƒÙŠ Ùˆ ØºÙŠØ±Ù‡ ',0),(294844,8191,'tr','YÃ¼kleme, muhasebe sorularÄ± ve teknik sorunlarÄ± ile ilgili yardÄ±m',0),(294845,8191,'pl','Pomoc w instalacji, rachunkowoÅ›ci pytaÅ„, problemÃ³w technicznych i wiÄ™cej',0),(294846,8191,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ Ñ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾, ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´Ð½Ð¸ Ð²ÑŠÐ¿Ñ€Ð¾ÑÐ¸, Ñ‚ÐµÑ…Ð½Ð¸Ñ‡ÐµÑÐºÐ¸ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð¸ Ð¸ Ð´Ñ€ÑƒÐ³Ð¸',0),(294847,8191,'ur','ØªÙ†ØµÛŒØ¨ Ú©Ø§Ø±ÛŒØŒ Ø§Ú©Ø§Ø¤Ù†Ù¹Ù†Ú¯ Ø³ÙˆØ§Ù„Ø§ØªØŒ ØªÚ©Ù†ÛŒÚ©ÛŒ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§ÙˆØ± Ø²ÛŒØ§Ø¯Û Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù…Ø¯Ø§Ø¯',0),(294848,8191,'sr','ÐŸÐ¾Ð¼Ð¾Ñ› Ð¿Ñ€Ð¸ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð¸, Ñ€Ð°Ñ‡ÑƒÐ½Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²ÐµÐ½Ð¸Ñ… Ð¿Ð¸Ñ‚Ð°ÑšÐ°, Ñ‚ÐµÑ…Ð½Ð¸Ñ‡ÐºÐ° Ð¿Ð¸Ñ‚Ð°ÑšÐ° Ð¸ Ñ˜Ð¾Ñˆ Ð¼Ð½Ð¾Ð³Ð¾',0),(294849,8191,'vi','Trá»£ giÃºp láº·p Ä‘áº·t,váº¥n Ä‘á» vá» káº¿ toÃ¡n, ká»¹ thuáº­t vÃ  hÆ¡n ná»¯a',0),(294850,8191,'af','Bystand met installasie, rekenkundige kwessies, tegniese probleme en meer',0),(294851,8191,'ro','AsistenÅ£Äƒ pentru instalare, contabilitate Ã®ntrebÄƒri, probleme tehnice ÅŸi mai mult',0),(294852,8191,'et','Abi paigaldamine, raamatupidamise kÃ¼simused, tehnilisi kÃ¼simusi ja palju muud',0),(294853,8191,'si','PomoÄ pri namestitvi, raÄunovodskih vpraÅ¡anj, tehniÄna vpraÅ¡anja in Å¡e veÄ',0),(294854,8191,'ba','Bantuan dengan instalasi, akuntansi pertanyaan, masalah teknis dan lebih',0),(294855,8191,'nl','Hulp bij installatie, boekhoudkundige vragen, technische problemen en meer',0),(294856,8191,'fi','Apua asennus, kirjanpito kysymyksiÃ¤ ja teknisiÃ¤ kysymyksiÃ¤',0),(294857,8191,'no','Hjelp med installasjon, regnskapsmessige spÃ¸rsmÃ¥l, tekniske problemer og mer',0),(294858,8191,'da','Assistance med installation, regnskabsmÃ¦ssige spÃ¸rgsmÃ¥l, tekniske spÃ¸rgsmÃ¥l og meget mere',0),(294859,8191,'ko','ì„¤ì¹˜, íšŒê³„ ì§ˆë¬¸, ê¸°ìˆ  ë¬¸ì œ ë° ê¸°íƒ€ ì§€ì›',0),(294860,8191,'he','×¡×™×•×¢ ×¢× ×”×”×ª×§× ×”, ×—×©×‘×•× ××•×ª ×©××œ×•×ª, ×‘×¢×™×•×ª ×˜×›× ×™×•×ª ×•×¢×•×“',0),(294861,8191,'el','Î’Î¿Î®Î¸ÎµÎ¹Î± Î¼Îµ Ï„Î·Î½ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·, Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ¬ Î¸Î­Î¼Î±Ï„Î±, Ï„ÎµÏ‡Î½Î¹ÎºÎ¬ Î¸Î­Î¼Î±Ï„Î± ÎºÎ±Î¹ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ¿',0),(294862,8191,'zh','ååŠ©å®‰è£…ï¼Œä¼šè®¡é—®é¢˜ï¼ŒæŠ€æœ¯é—®é¢˜å’Œæ›´å¤š\r\n',0),(294863,8191,'sv','HjÃ¤lp med installation, redovisning frÃ¥gor, tekniska frÃ¥gor och mer',0),(294864,8191,'it','Assistenza con l\'installazione, questioni contabili, questioni tecniche e altro ancora',0),(294865,8191,'tl','',0),(294866,8191,'th','Assistance with installation, accounting questions, technical issues and more',0),(294867,8191,'hi','à¤¸à¥à¤¥à¤¾à¤ªà¤¨à¤¾, à¤²à¥‡à¤–à¤¾à¤‚à¤•à¤¨ à¤ªà¥à¤°à¤¶à¥à¤¨, à¤¤à¤•à¤¨à¥€à¤•à¥€ à¤®à¥à¤¦à¥à¤¦à¥‹à¤‚ à¤”à¤° à¤…à¤§à¤¿à¤• à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾',0),(294868,8191,'ms','Bantuan pemasangan, soalan-soalan perakaunan, isu-isu teknikal dan banyak lagi',0),(294869,8191,'ar','Ù…Ø³Ø§Ø¹Ø¯Ø© Ù…Ø¹ Ø§Ù„ØªØ«Ø¨ÙŠØª ÙˆØ´Ø¤ÙˆÙ† Ø§Ù„Ù…Ø­Ø§Ø³Ø¨Ø©ØŒ ÙˆØ§Ù„Ù‚Ø¶Ø§ÙŠØ§ Ø§Ù„ØªÙ‚Ù†ÙŠØ© ÙˆØ£ÙƒØ«Ø±',0),(294870,8191,'fr','Assistance pour l\'installation, questions comptables, questions techniques, etc.',0),(294871,8191,'jp','ã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«ã€ä¼šè¨ˆå‡¦ç†ã®è³ªå•ã€æŠ€è¡“çš„ãªå•é¡Œã®ãŠæ‰‹ä¼ã„',0),(294872,8191,'pt','Ajuda com instalaÃ§Ã£o, contabilidade, questÃµes tÃ©cnicas e outras questÃµes',0),(294873,8191,'ru','ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ Ð² ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐµ, Ð±ÑƒÑ…Ð³Ð°Ð»Ñ‚ÐµÑ€ÑÐºÐ¸Ðµ Ð²Ð¾Ð¿Ñ€Ð¾ÑÑ‹, Ñ‚ÐµÑ…Ð½Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ð²Ð¾Ð¿Ñ€Ð¾ÑÑ‹ Ð¸ Ð¼Ð½Ð¾Ð³Ð¾Ðµ Ð´Ñ€ÑƒÐ³Ð¾Ðµ',0),(294874,8191,'es','Asistencia con la instalaciÃ³n, preguntas sobre la contabilidad, asuntos tÃ©cnicos y mÃ¡s',0),(294875,8191,'de','UnterstÃ¼tzung bei Installation, Buchhaltung Fragen, technische Probleme und mehr',0),(294876,8191,'en','Assistance with installation, accounting questions, technical issues and more',0),(294877,8192,'is','',0),(294878,8192,'dr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† Ø³ÙˆØ®Øª Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„ ',0),(294879,8192,'pr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† Ø³ÙˆØ®Øª Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„ ',0),(294880,8192,'tr','KÃ¶tÃ¼ borÃ§ iptalleri dÄ±ÅŸla',0),(294881,8192,'pl','WykluczyÄ‡ Writeoffs zÅ‚ych dÅ‚ugÃ³w',0),(294882,8192,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¾Ñˆ Ð´ÑŠÐ»Ð³ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð°',0),(294883,8192,'ur','Ø¨Ø±ÛŒ Ù‚Ø±Ø¶ ÙˆØ±Ø§Ù¹ÛŒÙˆÙØ³ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(294884,8192,'sr','Ð˜Ð·ÑƒÐ·Ð¼Ð¸ Ð¾Ñ‚Ð¿Ð¸ÑÐ° Ð´ÑƒÐ³Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°',0),(294885,8192,'vi','KhÃ´ng bao gá»“m ná»£ xáº¥u Ä‘Ã£ xÃ³a',0),(294886,8192,'af','Uitsluitend Swak Skulde Afgeskryf',0),(294887,8192,'ro','Exclude rÄƒu datoriei amortizÄƒri',0),(294888,8192,'et','VÃ¤listada halbade laenude Writeoffs',0),(294889,8192,'si','IzkljuÄi odpisi slabih dolgov',0),(294890,8192,'ba','Mengecualikan buruk hutang Writeoffs',0),(294891,8192,'nl','Uitsluiten van slechte schulden Writeoffs',0),(294892,8192,'fi','JÃ¤ttÃ¤Ã¤ huono velkaa poistojen',0),(294893,8192,'no','Utelate dÃ¥rlig gjeld Writeoffs',0),(294894,8192,'da','Udelukke dÃ¥rlig gÃ¦ld Writeoffs',0),(294895,8192,'ko','ë‚˜ìœ ë¶€ì±„ Writeoffs ì œì™¸',0),(294896,8192,'he','××™-×”×›×œ×œ×ª ×—×•×‘ ×¨×¢ Writeoffs',0),(294897,8192,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¯ÏƒÎµÎ¹ ÎºÎ±ÎºÏŒ Ï‡ÏÎ­Î¿Ï‚ Writeoffs',0),(294898,8192,'zh','æŽ’é™¤åè´¦æ³¨é”€\r\n',0),(294899,8192,'sv','Utesluta kundfÃ¶rluster avskrivningar',0),(294900,8192,'it','Escludere i crediti inesigibili Writeoffs',0),(294901,8192,'tl','',0),(294902,8192,'th','&#3652;&#3617;&#3656;&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3605;&#3633;&#3604;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;',0),(294903,8192,'hi','à¤¬à¥à¤°à¤¾ à¤‹à¤£ Writeoffs à¤•à¥‹ à¤¬à¤¾à¤¹à¤°',0),(294904,8192,'ms','Tidak termasuk hutang lapuk Writeoffs',0),(294905,8192,'ar','Ø§Ø³ØªØ¨Ø¹Ø§Ø¯ Ø§Ù„Ø¯ÙŠÙˆÙ† Ø§Ù„Ù…Ø¹Ø¯ÙˆÙ…Ø© Ø±ÙŠØªÙŠÙˆÙØ³',0),(294906,8192,'fr','Exclure des pertes et profits de crÃ©ances irrÃ©couvrables',0),(294907,8192,'jp','ä¸è‰¯å‚µæ¨© ï¼…7600000000 ã‚’é™¤å¤–ã—ã¾ã™ã€‚',0),(294908,8192,'pt','Excluir Writeoffs de dÃ­vidas incobrÃ¡veis',0),(294909,8192,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð±ÐµÐ·Ð½Ð°Ð´ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð¾Ð»Ð³Ð¾Ð² Writeoffs',0),(294910,8192,'es','Excluir Cancelaciones de Malas Deudas',0),(294911,8192,'de','Uneinbringliche Forderungen Abzug ausschlieÃŸen',0),(294912,8192,'en','Exclude Bad Debt Write-offs',0),(294913,8193,'is','',0),(294914,8193,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„ Ø³ÙˆØ®Øª Ø´Ø¯Ù‡ ',0),(294915,8193,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„ Ø³ÙˆØ®Øª Ø´Ø¯Ù‡ ',0),(294916,8193,'tr','Sadece kÃ¶tÃ¼ borÃ§ iptalleri gÃ¶ster',0),(294917,8193,'pl','PokaÅ¼ tylko zÅ‚ych dÅ‚ugÃ³w Writeoffs',0),(294918,8193,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð»Ð¾Ñˆ Ð´ÑŠÐ»Ð³ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð°',0),(294919,8193,'ur','ØµØ±Ù Ø¨Ø±Û’ Ù‚Ø±Ø¶ ÙˆØ±Ø§Ù¹ÛŒÙˆÙØ³ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(294920,8193,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð´ÑƒÐ³Ð¾Ð²Ð° Ð¾Ñ‚Ð¿Ð¸ÑÐ° Ð´ÑƒÐ³Ð°',0),(294921,8193,'vi','Chá»‰ Hiá»ƒn thá»‹ ná»£ xáº¥u Ä‘Ã£ xÃ³a',0),(294922,8193,'af','Wys Alleenlik Swak Skulde Afgeskryf',0),(294923,8193,'ro','AratÄƒ numai rÄƒu datoriei amortizÄƒri',0),(294924,8193,'et','NÃ¤ita ainult halbade laenude Writeoffs',0),(294925,8193,'si','PokaÅ¾i samo odpisi slabih dolgov',0),(294926,8193,'ba','Tampilkan hanya buruk hutang Writeoffs',0),(294927,8193,'nl','Toon alleen slechte schulden Writeoffs',0),(294928,8193,'fi','NÃ¤ytÃ¤ vain huono velkaa poistojen',0),(294929,8193,'no','Vis bare dÃ¥rlig gjeld Writeoffs',0),(294930,8193,'da','Vis kun dÃ¥rlig gÃ¦ld Writeoffs',0),(294931,8193,'ko','ë‚˜ìœ ë¶€ì±„ Writeoffsë§Œ í‘œì‹œ',0),(294932,8193,'he','×”×¦×’ ×¨×§ ×—×•×‘×•×ª Writeoffs',0),(294933,8193,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ ÎºÎ±ÎºÏŒ Ï‡ÏÎ­Î¿Ï‚ Writeoffs',0),(294934,8193,'zh','ä»…æ˜¾ç¤ºåè´¦æ³¨é”€\r\n',0),(294935,8193,'sv','Visa endast kundfÃ¶rluster avskrivningar',0),(294936,8193,'it','Visualizza solo gli Writeoffs crediti inesigibili',0),(294937,8193,'tl','',0),(294938,8193,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3585;&#3634;&#3619;&#3605;&#3633;&#3604;&#3592;&#3635;&#3627;&#3609;&#3656;&#3634;&#3618;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3',0),(294939,8193,'hi','à¤•à¥‡à¤µà¤² à¤¬à¥à¤°à¤¾ à¤‹à¤£ Writeoffs à¤¦à¤¿à¤–à¤¾à¤à¤',0),(294940,8193,'ms','Menunjukkan hanya hutang lapuk Writeoffs',0),(294941,8193,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙÙ‚Ø· Ø§Ù„Ø¯ÙŠÙˆÙ† Ø§Ù„Ù…Ø¹Ø¯ÙˆÙ…Ø© Ø±ÙŠØªÙŠÙˆÙØ³',0),(294942,8193,'fr','Montrer seulement les mauvaises crÃ©ances pertes et profits',0),(294943,8193,'jp','ä¸è‰¯å‚µæ¨© ï¼…7600000000 ã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(294944,8193,'pt','Mostrar apenas dÃ­vidas incobrÃ¡veis Writeoffs',0),(294945,8193,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð±ÐµÐ·Ð½Ð°Ð´ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð¾Ð»Ð³Ð¾Ð² Writeoffs',0),(294946,8193,'es','Mostrar Solo Malas Deudas Descontadas',0),(294947,8193,'de','Zeigen Sie nur ForderungsausfÃ¤lle AbzÃ¼ge',0),(294948,8193,'en','Show Only Bad Debt Write-offs',0),(294949,8194,'is','',0),(294950,8194,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(294951,8194,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(294952,8194,'tr','VarsayÄ±lan Ã¶deme hesabÄ±',0),(294953,8194,'pl','DomyÅ›lne konto pÅ‚atnoÅ›ci',0),(294954,8194,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(294955,8194,'ur','Ø·Û’ Ø´Ø¯Û Ø±Ù‚Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(294956,8194,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ',0),(294957,8194,'vi','TK Thanh ToÃ¡n Máº·c Äá»‹nh',0),(294958,8194,'af','Verstekte Betalingsrekening',0),(294959,8194,'ro','Cont de plata implicite',0),(294960,8194,'et','Vaikimisi makse kontole',0),(294961,8194,'si','Privzeti raÄun za plaÄilo',0),(294962,8194,'ba','Account pembayaran default',0),(294963,8194,'nl','Standaardaccount voor betaling',0),(294964,8194,'fi','Oletusmaksutili',0),(294965,8194,'no','Standard betalingskonto',0),(294966,8194,'da','Standard betalingskonto',0),(294967,8194,'ko','ê¸°ë³¸ ê²°ì œ ê³„ì¢Œ',0),(294968,8194,'he','×—×©×‘×•×Ÿ ×ª×©×œ×•× ×”×ž×•×’×“×¨ ×›×‘×¨×™×¨×ª ×ž×—×“×œ',0),(294969,8194,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(294970,8194,'zh','é»˜è®¤ä»˜æ¬¾å¸æˆ·\r\n',0),(294971,8194,'sv','Standard betalkonto',0),(294972,8194,'it','Conto di pagamento predefinito',0),(294973,8194,'tl','',0),(294974,8194,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(294975,8194,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤–à¤¾à¤¤à¤¾',0),(294976,8194,'ms','Akaun pembayaran lalai',0),(294977,8194,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(294978,8194,'fr','Compte de paiement par dÃ©faut',0),(294979,8194,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆæ”¯æ‰•ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(294980,8194,'pt','Conta de pagamento padrÃ£o',0),(294981,8194,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(294982,8194,'es','Cuenta de Pago por Defecto',0),(294983,8194,'de','Standard-Abrechnungskonto',0),(294984,8194,'en','Default Payment Account',0),(294985,8195,'is','',0),(294986,8195,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙˆØ¬ Ø§Ø² Ø­Ø³Ø§Ø¨ Ø´Ø±ÙƒØª ',0),(294987,8195,'pr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† Ø«Ø¨Øª Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙˆØ¬ Ø§Ø² Ø­Ø³Ø§Ø¨ Ø´Ø±ÙƒØª ',0),(294988,8195,'tr','Åžirket hesabÄ±ndan para Ã§ekme iÃ§in doÄŸrudan yatÄ±rma girdisini dÄ±ÅŸlamak',0),(294989,8195,'pl','WykluczajÄ… bezpoÅ›redni depozyt do wypÅ‚aty z konta firmowego',0),(294990,8195,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¾Ñ‚Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð¾Ñ‚ Ð¤Ð¸Ñ€Ð¼ÐµÐ½ Ð¿Ñ€Ð¾Ñ„Ð¸Ð»',0),(294991,8195,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³Û’ Ø§Ù†Ø®Ù„Ø§ Ú©Û’ Ù„Ø¦Û’ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(294992,8195,'sr','Ð˜Ð·ÑƒÐ·Ð¼Ð¸ ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð½Ð° Ð¿Ð¾Ð²Ð»Ð°Ñ‡ÐµÑšÐµ Ð¸Ð· ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(294993,8195,'vi','KhÃ´ng Liá»‡t KÃª Entry Äáº·t Cá»c Trá»±c Tiáº¿p Khi RÃºt Tiá»n Tá»« TK CTy',0),(294994,8195,'af','Sluit Direkte Deposito-inskrywings uit Vir Ontrekking Vanuit Onderneming Rekening',0),(294995,8195,'ro','Exclude intrarea Direct de depozit pentru retragerea de pe contul companiei',0),(294996,8195,'et','Ei mÃ¤rgita otsene hoiuste peatamise firma kontolt',0),(294997,8195,'si','IzkljuÄuje neposredno depozit vnos za umik iz raÄuna druÅ¾be',0),(294998,8195,'ba','Mengecualikan Deposit langsung entri untuk penarikan dari rekening perusahaan',0),(294999,8195,'nl','Directe storting vermelding voor terugtrekking uit bedrijfsaccount uitsluiten',0),(295000,8195,'fi','JÃ¤ttÃ¤Ã¤ suora talletus tapahtuma vetÃ¤ytyminen yrityksen tili',0),(295001,8195,'no','Utelukke direkte innskudd oppfÃ¸ringen For tilbaketrekning fra firmakontoen',0),(295002,8195,'da','Udelukke direkte indbetaling indrejse For tilbagetrÃ¦kning fra regnskab',0),(295003,8195,'ko','íšŒì‚¬ ê³„ì •ì—ì„œ ì² ìˆ˜ì— ëŒ€ í•œ ì§ì ‘ ìž…ê¸ˆ í•­ëª© ì œì™¸',0),(295004,8195,'he','×œ× ×œ×›×œ×•×œ ×¢×¨×š ×”×¤×§×“×” ×™×©×™×¨×” ×œ× ×¡×™×’×” ×ž×—×©×‘×•×Ÿ ×”×—×‘×¨×”',0),(295005,8195,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¯ÎµÎ¹ Ï„Î·Î½ Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… Î³Î¹Î± Î±Î½Î¬Î»Î·ÏˆÎ· Î±Ï€ÏŒ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(295006,8195,'zh','æŽ’é™¤ä»Žå…¬å¸å¸æˆ·ä¸ºææ¬¾è€Œç›´æŽ¥å­˜æ¬¾æ¡ç›®\r\n',0),(295007,8195,'sv','Utesluta direkt insÃ¤ttning post fÃ¶r tillbakadragande frÃ¥n fÃ¶retagskontot',0),(295008,8195,'it','Escludere la voce deposito diretto per ritiro dal conto aziendale',0),(295009,8195,'tl','',0),(295010,8195,'th','&#3652;&#3617;&#3656;&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3650;&#3604;&#3618;&#3606;&#3629;&#3609;&#3592;&#3',0),(295011,8195,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‹ à¤•à¤‚à¤ªà¤¨à¥€ à¤–à¤¾à¤¤à¥‡ à¤¸à¥‡ à¤¨à¤¿à¤•à¤¾à¤¸à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¾à¤¹à¤°',0),(295012,8195,'ms','Tidak termasuk Deposit terus masuk bagi pengeluaran dari akaun Syarikat',0),(295013,8195,'ar','Ø§Ø³ØªØ¨Ø¹Ø§Ø¯ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± Ù„Ø³Ø­Ø¨ Ù…Ù† Ø­Ø³Ø§Ø¨ Ø§Ù„Ø´Ø±ÙƒØ©',0),(295014,8195,'fr','Exclure la saisie des dÃ©pÃ´ts directs de retrait du compte de l\'entreprise',0),(295015,8195,'jp','ä¼šç¤¾ã®å£åº§ã‹ã‚‰ã®å¼•å‡ºã—ã®ç›´æŽ¥æ²ˆæ®¿ç‰©ã‚¨ãƒ³ãƒˆãƒªã‚’é™¤å¤–ã—ã¾ã™ã€‚',0),(295016,8195,'pt','Excluir a entrada do depÃ³sito direto para retirada da conta da empresa',0),(295017,8195,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð´Ð»Ñ ÑÐ½ÑÑ‚Ð¸Ñ ÑÐ¾ ÑÑ‡ÐµÑ‚Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(295018,8195,'es','Excluir Entrada de DepÃ³sito Directo para Retirar de la Cuenta de la Empresa',0),(295019,8195,'de','Direkte Ablagerung Eintrag fÃ¼r RÃ¼cktritt vom Unternehmenskonto ausschlieÃŸen',0),(295020,8195,'en','Exclude Direct Deposit Entry For Withdrawal From Company Account',0),(295021,8196,'is','',0),(295022,8196,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(295023,8196,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(295024,8196,'tr','Silinen mÃ¼ÅŸteri',0),(295025,8196,'pl','UsuniÄ™te klienta',0),(295026,8196,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(295027,8196,'ur','Ø­Ø°Ù Ø´Ø¯Û Ú¯Ø§ÛÚ©',0),(295028,8196,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(295029,8196,'vi','XÃ³a khÃ¡ch hÃ ng ',0),(295030,8196,'af','Geskrapte KliÃ«nt / Klant',0),(295031,8196,'ro','Åžterse client',0),(295032,8196,'et','Kustutatud klient',0),(295033,8196,'si','Izbrisane kupca',0),(295034,8196,'ba','Pelanggan yang dihapus',0),(295035,8196,'nl','Verwijderde klant',0),(295036,8196,'fi','Poistetaan asiakkaan',0),(295037,8196,'no','Slettede kunde',0),(295038,8196,'da','Slettede kunde',0),(295039,8196,'ko','ì‚­ì œ ëœ ê³ ê°',0),(295040,8196,'he','×œ×§×•×—×•×ª ×©× ×ž×—×§×•',0),(295041,8196,'el','Î”Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î¿ Ï€ÎµÎ»Î¬Ï„Î·',0),(295042,8196,'zh','åˆ é™¤å®¢æˆ·',0),(295043,8196,'sv','Borttagna kunden',0),(295044,8196,'it','Cliente eliminati',0),(295045,8196,'tl','',0),(295046,8196,'th','&#3621;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3649;&#3621;&#3657;&#3623;',0),(295047,8196,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(295048,8196,'ms','Baca dihapuskan',0),(295049,8196,'ar','Ø²Ø¨ÙˆÙ† Ù…Ø­Ø°ÙˆÙ',0),(295050,8196,'fr','Client supprimÃ©',0),(295051,8196,'jp','å‰Šé™¤ã—ãŸé¡§å®¢',0),(295052,8196,'pt','Cliente excluÃ­do',0),(295053,8196,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð½Ñ‹Ð¹ ÐšÐ»Ð¸ÐµÐ½Ñ‚',0),(295054,8196,'es','Cliente Eliminado',0),(295055,8196,'de','GelÃ¶schte Kunden',0),(295056,8196,'en','Deleted Customer',0),(295057,8197,'is','',0),(295058,8197,'dr','ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯',0),(295059,8197,'pr','ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯',0),(295060,8197,'tr','Yeniden etkinleÅŸtirme',0),(295061,8197,'pl','Ponowne uaktywnianie',0),(295062,8197,'bg','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ',0),(295063,8197,'ur','Ø¯ÙˆØ¨Ø§Ø±Û Ú†Ø§Ù„Ùˆ Ú©Ø±ÛŒÚº',0),(295064,8197,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜',0),(295065,8197,'vi','KÃ­ch hoáº¡t loáº¡i',0),(295066,8197,'af','Heraktiveer',0),(295067,8197,'ro','ReactivaÅ£i',0),(295068,8197,'et','Aktiveeri uuesti',0),(295069,8197,'si','Znova aktiviraj',0),(295070,8197,'ba','Mengaktifkan kembali',0),(295071,8197,'nl','Time to reactivate',0),(295072,8197,'fi','Aktivoi uudelleen',0),(295073,8197,'no','Aktivere',0),(295074,8197,'da','Genaktivere',0),(295075,8197,'ko','ë‹¤ì‹œ í™œì„±í™”',0),(295076,8197,'he','×”×¤×¢×œ ×©×•×‘',0),(295077,8197,'el','Î•Ï€Î±Î½ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(295078,8197,'zh','é‡æ–°å¯ç”¨\r\n',0),(295079,8197,'sv','Ã…teraktivera',0),(295080,8197,'it','Riattivare',0),(295081,8197,'tl','',0),(295082,8197,'th','&#3607;&#3635;&#3651;&#3627;&#3657;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(295083,8197,'hi','à¤ªà¥à¤¨à¤ƒ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(295084,8197,'ms','Mengaktifkan semula',0),(295085,8197,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªÙ†Ø´ÙŠØ·',0),(295086,8197,'fr','RÃ©activer',0),(295087,8197,'jp','å†ã‚¢ã‚¯ãƒ†ã‚£ãƒ–åŒ–ã—ã¾ã™ã€‚',0),(295088,8197,'pt','Reativar',0),(295089,8197,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ñ',0),(295090,8197,'es','Reactivar',0),(295091,8197,'de','Reaktivieren',0),(295092,8197,'en','Reactivate',0),(295093,8198,'is','',0),(295094,8198,'dr','(Ø³ÙˆØ®Øª ÙƒØ±Ø¯Ù†)',0),(295095,8198,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ø°Ù Ú©Ø±Ø¯Ù†(Ø³ÙˆØ®Øª ÙƒØ±Ø¯Ù†)',0),(295096,8198,'tr','Tutar WriteOff',0),(295097,8198,'pl','Kwota WriteOff',0),(295098,8198,'bg','WriteOff ÑÑƒÐ¼Ð°',0),(295099,8198,'ur','Ø±Ù‚Ù… ÙˆØ±Ø§Ù¹ÛŒÙˆÙ',0),(295100,8198,'sr','Ð˜Ð·Ð½Ð¾Ñ WÑ€Ð¸Ñ‚ÐµÐžÑ„Ñ„',0),(295101,8198,'vi','Sá»‘ Tiá»n Giáº£m Bá»›t',0),(295102,8198,'af','Bedrag Afgeskryf',0),(295103,8198,'ro','Suma WriteOff',0),(295104,8198,'et','Summa WriteOff',0),(295105,8198,'si','Znesek WriteOff',0),(295106,8198,'ba','Jumlah WriteOff',0),(295107,8198,'nl','Bedrag dienen',0),(295108,8198,'fi','MÃ¤Ã¤rÃ¤ WriteOff',0),(295109,8198,'no','BelÃ¸p WriteOff',0),(295110,8198,'da','MÃ¦ngde WriteOff',0),(295111,8198,'ko','ê¸ˆì•¡ WriteOff',0),(295112,8198,'he','×›×ž×•×ª WriteOff',0),(295113,8198,'el','Î Î¿ÏƒÏŒ WriteOff',0),(295114,8198,'zh','æ ¸é”€é‡‘é¢\r\n',0),(295115,8198,'sv','Beloppet WriteOff',0),(295116,8198,'it','Importo WriteOff',0),(295117,8198,'tl','',0),(295118,8198,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;',0),(295119,8198,'hi','à¤°à¤¾à¤¶à¤¿ WriteOff',0),(295120,8198,'ms','Jumlah WriteOff',0),(295121,8198,'ar','Ø±ÙŠØªÙŠÙˆÙ Ø§Ù„Ù…Ø¨Ù„Øº',0),(295122,8198,'fr','Radiation de quantitÃ©',0),(295123,8198,'jp','é‡ã‚’å¸³æ¶ˆã—',0),(295124,8198,'pt','Cancelamento de quantidade',0),(295125,8198,'ru','Ð¡Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑÑƒÐ¼Ð¼Ñ‹',0),(295126,8198,'es','Monto AnulaciÃ³n',0),(295127,8198,'de','Betrag WriteOff',0),(295128,8198,'en','Write-off Amount',0),(295129,8199,'is','',0),(295130,8199,'dr','ÙØ§ÙƒØªÙˆØ± Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„ ØµÙ†Ø¹Øª Ø¯Ø±Ù‡Ù…Ù‡ Ø²Ø¨Ø§Ù†Ù‡Ø§ Ù…Ø´Ø§Ø¨Ù‡ Ø§Ø³Øª',0),(295131,8199,'pr','ÙØ§ÙƒØªÙˆØ± Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„ ØµÙ†Ø¹Øª Ø¯Ø±Ù‡Ù…Ù‡ Ø²Ø¨Ø§Ù†Ù‡Ø§ Ù…Ø´Ø§Ø¨Ù‡ Ø§Ø³Øª',0),(295132,8199,'tr','AR fatura kÃ¶tÃ¼ borÃ§',0),(295133,8199,'pl','AR faktury zÅ‚ych dÅ‚ugÃ³w',0),(295134,8199,'bg','AR Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð»Ð¾ÑˆÐ¸ Ð´ÑŠÐ»Ð³Ð¾Ð²Ðµ',0),(295135,8199,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¨Ø±ÛŒ Ù‚Ø±Ø¶',0),(295136,8199,'sr','ÐÐ  Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð´ÑƒÐ³Ð¾Ð²Ð°',0),(295137,8199,'vi','HÃ³a ÄÆ¡n AR Ná»£ Xáº¥u',0),(295138,8199,'af','RO Faktuur Oninbare Skulde',0),(295139,8199,'ro','AR facturÄƒ rÄƒu datoriei',0),(295140,8199,'et','AR arve halbade laenude',0),(295141,8199,'si','AR raÄun slabih dolgov',0),(295142,8199,'ba','AR faktur buruk hutang',0),(295143,8199,'nl','AR factuur slechte schulden',0),(295144,8199,'fi','AR laskun luottotappiot',0),(295145,8199,'no','AR faktura dÃ¥rlig gjeld',0),(295146,8199,'da','AR faktura dÃ¥rlig gÃ¦ld',0),(295147,8199,'ko','AR ì†¡ìž¥ ë‚˜ìœ ë¶€ì±„',0),(295148,8199,'he','AR ×—×©×‘×•× ×™×ª ×—×•×‘ ××‘×•×“',0),(295149,8199,'el','AR Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎºÎ±ÎºÏŒ Ï‡ÏÎ­Î¿Ï‚',0),(295150,8199,'zh','åº”æ”¶è´¦æ¬¾å‘ç¥¨åè´¦\r\n',0),(295151,8199,'sv','AR faktura kundfÃ¶rluster',0),(295152,8199,'it','AR fattura inesigibili',0),(295153,8199,'tl','',0),(295154,8199,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3648;&#3611;&#3655;&#3609;&#3627;&#3609;&#3637;&#3657;&#3648;&#3626;&#3637;&#3618;',0),(295155,8199,'hi','à¤. à¤†à¤°. à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¬à¥à¤°à¤¾ à¤‹à¤£',0),(295156,8199,'ms','Hutang Bad AR invois',0),(295157,8199,'ar','AR ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¯ÙŠÙˆÙ† Ø§Ù„Ù…Ø¹Ø¯ÙˆÙ…Ø©',0),(295158,8199,'fr','Facturation CR du debt perdue',0),(295159,8199,'jp','AR è«‹æ±‚æ›¸ä¸è‰¯å‚µæ¨©',0),(295160,8199,'pt','AR factura inadimplÃªncia',0),(295161,8199,'ru','AR ÑÑ‡ÐµÑ‚Ð° Ð±ÐµÐ·Ð½Ð°Ð´ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð¾Ð»Ð³Ð¾Ð²',0),(295162,8199,'es','CC Factural Deuda Perdida',0),(295163,8199,'de','AR Rechnung uneinbringliche Forderungen',0),(295164,8199,'en','AR Invoice Bad Debt',0),(295165,8200,'is','',0),(295166,8200,'dr','. Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯',0),(295167,8200,'pr','Ø­Ø³Ø§Ø¨ Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„  Ø¨Ø§ÙŠØ¯ Ø¯Ø± ØªÙ†Ø¸ÙŠÙ… ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ . Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(295168,8200,'tr','KÃ¶tÃ¼ borÃ§ hesabÄ± faturalandÄ±rma kurulumu standart hesaplarÄ±-> ayarlanmasÄ± gerekir',0),(295169,8200,'pl','NieÅ›ciÄ…galnych dÅ‚ugÃ³w konta muszÄ… byÄ‡ ustawione w konfiguracji rozliczeÅ„-> standardowych kont',0),(295170,8200,'bg','Ð›Ð¾Ñˆ Ð´ÑŠÐ»Ð³ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½ Ð² Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ-> ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸',0),(295171,8200,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³-> Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø³ÛŒÙ¹ Ø§Ù¾ Ù…ÛŒÚº Ø¨Ø±ÛŒ Ù‚Ø±Ø¶ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(295172,8200,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð° Ð½Ð°Ð»Ð¾Ð³ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½ Ñƒ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ð¾Ð½Ð¾Ð¼ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ñƒ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(295173,8200,'vi','TK Ná»£ Xáº¥u Pháº£i Liá»‡t KÃª Trong Setup Billing->TK Chuáº©n',0),(295174,8200,'af','Swak Skulde Rekening moet Opgestel word in Inkomste Opstelling->Standaard Rekeninge',0),(295175,8200,'ro','Bad credit contul trebuie sÄƒ fie setat Ã®n facturare Setup-> conturi Standard',0),(295176,8200,'et','Halva vÃµla konto peate seadma arveldamise seadistuses-> tavakasutajakontod',0),(295177,8200,'si','Slabih dolgov raÄun nastavite v obraÄunavanje Setup-> standardnih raÄunov',0),(295178,8200,'ba','Buruk hutang Account harus ditetapkan di pengaturan Penagihan-> akun standar',0),(295179,8200,'nl','Slechte schulden Account moet worden ingesteld In facturering Setup-> standaardaccounts',0),(295180,8200,'fi','Luottotappiot tunnus on mÃ¤Ã¤riteltÃ¤vÃ¤ laskutus asennus-> normaalien tilien',0),(295181,8200,'no','DÃ¥rlig gjeld konto mÃ¥ angis fakturering Setup-> standardkontoer',0),(295182,8200,'da','DÃ¥rlig gÃ¦ld konto skal indstilles i fakturering Setup-> standardkonti',0),(295183,8200,'ko','ë‚˜ìœ ë¶€ì±„ ê³„ì •ì˜ í‘œì¤€ ê³„ì •-> ê²°ì œ ì„¤ì •ì—ì„œ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(295184,8200,'he','×—×•×‘×•×ª ×”×—×©×‘×•×Ÿ ×—×™×™×‘ ×œ×”×™×•×ª ×ž×•×’×“×¨ ×‘×›×™×•×•× ×•×Ÿ ×—×™×•×‘-> ×—×©×‘×•× ×•×ª ×¨×’×™×œ×™×',0),(295185,8200,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¾ÎµÎºÎ¹Î½Î®ÏƒÎ¿Ï…Î½ ÎºÎ±ÎºÏŒ Ï‡ÏÎ­Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚-> Ï„Ï…Ï€Î¹ÎºÎ¿ÏÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(295186,8200,'zh','åè´¦è´¦æˆ·å¿…é¡»è®¾ç½®åœ¨ç»“ç®—è®¾ç½®->â€œæ ‡å‡†å¸æˆ·\r\n',0),(295187,8200,'sv','KundfÃ¶rluster kontot mÃ¥ste anges i fakturering Setup-> Standard konton',0),(295188,8200,'it','Crediti inesigibili Account deve essere impostato nel Setup di fatturazione-> conti Standard',0),(295189,8200,'tl','',0),(295190,8200,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;&#3605;&#3657;&#3629;&#3591;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;->&#3610;&',0),(295191,8200,'hi','à¤¬à¥à¤°à¤¾ à¤‹à¤£ à¤–à¤¾à¤¤à¤¾ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‡ à¤®à¤¾à¤¨à¤•-> à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤¸à¥‡à¤Ÿà¤…à¤ª à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(295192,8200,'ms','Akaun hutang lapuk harus Set dalam persediaan bil-> akaun Standard',0),(295193,8200,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¯ÙŠÙˆÙ† Ø§Ù„Ù…Ø¹Ø¯ÙˆÙ…Ø© ÙÙŠ Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(295194,8200,'fr','Compte de crÃ©ance irrÃ©couvrable doit Ãªtre dÃ©finie dans la configuration de la facturation-> comptes Standard',0),(295195,8200,'jp','ä¸è‰¯å‚µæ¨©ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã¯æ¨™æº–ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ-> è«‹æ±‚ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã§è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(295196,8200,'pt','DÃ­vidas incobrÃ¡veis conta deve ser definida na configuraÃ§Ã£o do faturamento-> contas padrÃ£o',0),(295197,8200,'ru','Ð‘ÐµÐ·Ð½Ð°Ð´ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð¾Ð»Ð³Ð¾Ð² ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹ Ð² Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸-> ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(295198,8200,'es','La Cuenta de la Deuda Incobrable debe ser configurado en ConfiguraciÃ³n de FacturaciÃ³n -> Cuentas EstÃ¡ndares',0),(295199,8200,'de','Uneinbringliche Forderungen-Konto muss im Billing-Setup-> Standardkonten festgelegt werden',0),(295200,8200,'en','Bad Debt Account Must Be Set In Billing Setup->Standard Accounts',0),(295201,8201,'is','',0),(295202,8201,'dr','Ø«Ø¨Øª Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„',0),(295203,8201,'pr','Ø«Ø¨Øª Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„',0),(295204,8201,'tr','KÃ¶tÃ¼ borÃ§ giriÅŸi',0),(295205,8201,'pl','Wpis zÅ‚ych dÅ‚ugÃ³w',0),(295206,8201,'bg','Ð›Ð¾Ñˆ Ð´ÑŠÐ»Ð³ Ð·Ð°Ð¿Ð¸Ñ',0),(295207,8201,'ur','Ø¨Ø±ÛŒ Ù‚Ø±Ø¶ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(295208,8201,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð´ÑƒÐ³Ð¾Ð²Ð°',0),(295209,8201,'vi','Nháº­p Ná»£ Xáº¥u',0),(295210,8201,'af','Oninbare Skuld Inskrywing',0),(295211,8201,'ro','Intrare rÄƒu datoriei',0),(295212,8201,'et','Halbade vÃµlgade kanne',0),(295213,8201,'si','Slabih dolgov vstop',0),(295214,8201,'ba','Catatan buruk hutang',0),(295215,8201,'nl','Slechte schulden Entry',0),(295216,8201,'fi','Luottotappiot merkintÃ¤',0),(295217,8201,'no','DÃ¥rlig gjeld oppfÃ¸ring',0),(295218,8201,'da','DÃ¥rlig gÃ¦ld lÃ¸sning',0),(295219,8201,'ko','ë‚˜ìœ ë¶€ì±„ í•­ëª©',0),(295220,8201,'he','×›× ×™×¡×” ×—×•×‘ ××‘×•×“',0),(295221,8201,'el','ÎšÎ±ÎºÏŒ Ï‡ÏÎ­Î¿Ï‚ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(295222,8201,'zh','ä¸è‰¯å€ºåŠ¡çš„å…¥è´¦\r\n',0),(295223,8201,'sv','KundfÃ¶rluster intrÃ¤de',0),(295224,8201,'it','Voce crediti inesigibili',0),(295225,8201,'tl','',0),(295226,8201,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;',0),(295227,8201,'hi','à¤¬à¥à¤°à¤¾ à¤‹à¤£ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(295228,8201,'ms','Entry hutang lapuk',0),(295229,8201,'ar','Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø¯ÙŠÙˆÙ† Ø§Ù„Ù…Ø¹Ø¯ÙˆÙ…Ø©',0),(295230,8201,'fr','EntrÃ©e de crÃ©ances irrÃ©couvrables',0),(295231,8201,'jp','ä¸è‰¯å‚µæ¨©ã®ã‚¨ãƒ³ãƒˆãƒª',0),(295232,8201,'pt','Entrada de dÃ­vidas incobrÃ¡veis',0),(295233,8201,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ Ð±ÐµÐ·Ð½Ð°Ð´ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð¾Ð»Ð³Ð¾Ð²',0),(295234,8201,'es','Entrada de Deudas Incobrables',0),(295235,8201,'de','Uneinbringliche Forderungen-Eintrag',0),(295236,8201,'en','Bad Debt Entry',0),(295237,8202,'is','',0),(295238,8202,'dr','(Ø­Ø°Ù ÙƒØ±Ø¯Ù† )  - Ø­Ø°Ù ÙƒØ±Ø¯Ù† ÙƒØ§Ù…Ù„',0),(295239,8202,'pr','ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ù…Ø³ØªÙ‡Ù„Ú© Ú©Ø±Ø¯Ù† (Ø­Ø°Ù ÙƒØ±Ø¯Ù† )  - Ø­Ø°Ù ÙƒØ±Ø¯Ù† ÙƒØ§Ù…Ù„',0),(295240,8202,'tr','Tam yazmak-off',0),(295241,8202,'pl','PeÅ‚ny odpis',0),(295242,8202,'bg','ÐŸÑŠÐ»Ð½Ð¾Ñ‚Ð¾ Ð¾Ñ‚Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(295243,8202,'ur','Ù…Ú©Ù…Ù„ Write-Off',0),(295244,8202,'sr','ÐŸÐ¾Ñ‚Ð¿ÑƒÐ½Ð¾ Ð±ÐµÑÐºÐ¾Ñ€Ð¸ÑÐ½Ð¾',0),(295245,8202,'vi','HoÃ n thÃ nh xÃ³a ná»£',0),(295246,8202,'af','Voltooi Afskrywing',0),(295247,8202,'ro','Anularea completÄƒ',0),(295248,8202,'et','TÃ¤ielik mahakandmine',0),(295249,8202,'si','Popoln odpis',0),(295250,8202,'ba','Menghapusbukukan lengkap',0),(295251,8202,'nl','Volledige afschrijving',0),(295252,8202,'fi','TÃ¤ydellinen luopuminen',0),(295253,8202,'no','Komplett avskrivning',0),(295254,8202,'da','Komplet afskrivning',0),(295255,8202,'ko','ì „ì²´ ì“°ê¸°',0),(295256,8202,'he','××—×“',0),(295257,8202,'el','Î Î»Î®ÏÎ· Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(295258,8202,'zh','å®Œæˆæ³¨é”€\r\n',0),(295259,8202,'sv','FullstÃ¤ndig avskrivning',0),(295260,8202,'it','Remissione completa',0),(295261,8202,'tl','',0),(295262,8202,'th','&#3585;&#3634;&#3619;&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3611;&#3655;&#3609;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(295263,8202,'hi','à¤ªà¥‚à¤°à¤¾ à¤²à¤¿à¤–à¤¨à¥‡ à¤¬à¤¨à¤¾à¤¨à¤¾',0),(295264,8202,'ms','Pelupusan lengkap',0),(295265,8202,'ar','Ø§Ù„Ø´Ø·Ø¨ Ø§Ù„ÙƒØ§Ù…Ù„',0),(295266,8202,'fr','Radiation Complete',0),(295267,8202,'jp','å®Œå…¨ãªå„Ÿå´',0),(295268,8202,'pt','Completamente desfeita',0),(295269,8202,'ru','ÐŸÐ¾Ð»Ð½Ð¾Ðµ ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(295270,8202,'es','Deuda Incobrable Completa',0),(295271,8202,'de','VollstÃ¤ndige Abschreibung',0),(295272,8202,'en','Complete Write-off',0),(295273,8203,'is','',0),(295274,8203,'dr','(Ø­Ø°Ù) Ø¯ÛŒÙˆÙ† ',0),(295275,8203,'pr','ØªØ§Ø±ÙŠØ® Ø³ÙˆØ®Øª(Ø­Ø°Ù) Ø¨Ø¯Ù‡ÙŠ',0),(295276,8203,'tr','KapalÄ± yazÄ±lÄ± tarihi',0),(295277,8203,'pl','Data odpisane',0),(295278,8203,'bg','Ð”Ð°Ñ‚Ð°, Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ð½Ð¸',0),(295279,8203,'ur','ØªØ§Ø±ÛŒØ® Ù„Ú©Ú¾ÛŒ',0),(295280,8203,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ð»Ð°',0),(295281,8203,'vi','NgÃ y xÃ³a ná»£',0),(295282,8203,'af','Datum Afgeskryf',0),(295283,8203,'ro','Data amortizate',0),(295284,8203,'et','KuupÃ¤eva maha',0),(295285,8203,'si','Datum odpisani',0),(295286,8203,'ba','Tanggal dihapuskan',0),(295287,8203,'nl','Datum afgeschreven',0),(295288,8203,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ kirjanpidosta',0),(295289,8203,'no','Dato skrevet ut',0),(295290,8203,'da','Dato afskrevet',0),(295291,8203,'ko','ìž‘ì„± ë‚ ì§œ',0),(295292,8203,'he','×ª××¨×™×š ×›×ª×•×‘ ×”× ×—×”',0),(295293,8203,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ',0),(295294,8203,'zh','æ³¨é”€æ—¥æœŸ\r\n',0),(295295,8203,'sv','Datum skrivs ned',0),(295296,8203,'it','Data scritto Off',0),(295297,8203,'tl','',0),(295298,8203,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3611;&#3655;&#3609;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;',0),(295299,8203,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‡ à¤¬à¤‚à¤¦ à¤²à¤¿à¤–à¤¾',0),(295300,8203,'ms','Tarikh yang dihapus kira',0),(295301,8203,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ø´Ø·ÙˆØ¨Ø©',0),(295302,8203,'fr','Date radiÃ©',0),(295303,8203,'jp','ã‚ªãƒ•ã«æ›¸ã‹ã‚Œã¦ã®æ—¥ä»˜',0),(295304,8203,'pt','Data escrita',0),(295305,8203,'ru','Ð”Ð°Ñ‚Ð° ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(295306,8203,'es','Fecha Descontada',0),(295307,8203,'de','Datum abgeschrieben',0),(295308,8203,'en','Date Written Off',0),(295309,8204,'is','',0),(295310,8204,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„ ',0),(295311,8204,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„ ',0),(295312,8204,'tr','Hata ekleme kÃ¶tÃ¼ borÃ§',0),(295313,8204,'pl','BÅ‚Ä…d dodawania zÅ‚ych dÅ‚ugÃ³w',0),(295314,8204,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»Ð¾ÑˆÐ¸ Ð´ÑŠÐ»Ð³Ð¾Ð²Ðµ',0),(295315,8204,'ur','Ù†Ù‚Øµ Ø¨Ø±ÛŒ Ù‚Ø±Ø¶ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(295316,8204,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð´ÑƒÐ³Ð¾Ð²Ð°',0),(295317,8204,'vi','ThÃªm ná»£ xáº¥u bá»‹ lá»—i',0),(295318,8204,'af','Fout toevoeging van slegte skuld',0),(295319,8204,'ro','Eroare adÄƒugarea rÄƒu datoriei',0),(295320,8204,'et','Viga lisades halbade laenude',0),(295321,8204,'si','Napaka pri dodajanju slabih dolgov',0),(295322,8204,'ba','Kesalahan menambahkan buruk hutang',0),(295323,8204,'nl','Fout toe te voegen slechte schulden',0),(295324,8204,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ luottotappiot',0),(295325,8204,'no','Feil Ã¥ legge dÃ¥rlig gjeld',0),(295326,8204,'da','Fejl tilfÃ¸je dÃ¥rlig gÃ¦ld',0),(295327,8204,'ko','ì˜¤ë¥˜ ì¶”ê°€ ëŒ€ì†',0),(295328,8204,'he','×©×’×™××” ×”×•×¡×¤×ª ×—×•×‘ ××‘×•×“',0),(295329,8204,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÎ±ÎºÏŒ Ï‡ÏÎ­Î¿Ï‚',0),(295330,8204,'zh','é”™è¯¯ï¼šæ–°å¢žåè´¦',0),(295331,8204,'sv','Fel att lÃ¤gga till kundfÃ¶rluster',0),(295332,8204,'it','Errore aggiungendo crediti inesigibili',0),(295333,8204,'tl','',0),(295334,8204,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;',0),(295335,8204,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤¬à¥à¤°à¤¾ à¤‹à¤£',0),(295336,8204,'ms','Ralat menambah hutang lapuk',0),(295337,8204,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¯ÙŠÙˆÙ† Ø§Ù„Ù…Ø¹Ø¯ÙˆÙ…Ø©',0),(295338,8204,'fr','Erreur ajout des crÃ©ances irrÃ©couvrables',0),(295339,8204,'jp','ã‚¨ãƒ©ãƒ¼ã‚’è¿½åŠ ã™ã‚‹ä¸è‰¯å‚µæ¨©',0),(295340,8204,'pt','Erro adicionando dÃ­vidas incobrÃ¡veis',0),(295341,8204,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð±ÐµÐ·Ð½Ð°Ð´ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð¾Ð»Ð³Ð¾Ð²',0),(295342,8204,'es','Error Agregando Deuda Mala',0),(295343,8204,'de','Fehler hinzufÃ¼gen uneinbringliche Forderungen',0),(295344,8204,'en','Error Adding Bad Debt',0),(295345,8205,'is','',0),(295346,8205,'dr','ÙØ§ÙƒØªÙˆØ± Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(295347,8205,'pr','ÙØ§ÙƒØªÙˆØ± Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(295348,8205,'tr','Fatura kÃ¶tÃ¼ borÃ§ baÅŸarÄ±yla eklendi',0),(295349,8205,'pl','Faktura zÅ‚ych dÅ‚ugÃ³w dodano pomyÅ›lnie',0),(295350,8205,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð»Ð¾ÑˆÐ¸ Ð´ÑŠÐ»Ð³Ð¾Ð²Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(295351,8205,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¨Ø±ÛŒ Ù‚Ø±Ø¶ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(295352,8205,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´ÑƒÐ³Ð¾Ð²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(295353,8205,'vi','ThÃªm HÃ³a Ä‘Æ¡n ná»£ xáº¥u thÃ nh cÃ´ng',0),(295354,8205,'af','Faktuur vir Slegte Skulde Suksesvol Geskep',0),(295355,8205,'ro','FacturÄƒ rÄƒu datoriei adÄƒugat cu succes',0),(295356,8205,'et','Arve halbade laenude lisatud',0),(295357,8205,'si','RaÄun slabih dolgov uspeÅ¡no dodani',0),(295358,8205,'ba','Faktur buruk hutang ditambahkan berhasil',0),(295359,8205,'nl','Factuur slechte schulden toegevoegd',0),(295360,8205,'fi','Laskun luottotappiot lisÃ¤Ã¤minen onnistui',0),(295361,8205,'no','Faktura dÃ¥rlig gjeld lagt',0),(295362,8205,'da','Faktura uerholdelige tilfÃ¸jet',0),(295363,8205,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì†¡ìž¥ ë‚˜ìœ ë¶€ì±„',0),(295364,8205,'he','×—×©×‘×•× ×™×ª ×—×•×‘ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(295365,8205,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎºÎ±ÎºÏŒ Ï‡ÏÎ­Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(295366,8205,'zh','å‘ç¥¨åè´¦å¢žåŠ æˆåŠŸ\r\n',0),(295367,8205,'sv','Faktura kundfÃ¶rluster lagts',0),(295368,8205,'it','Fattura inesigibili aggiunto con successo',0),(295369,8205,'tl','',0),(295370,8205,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(295371,8205,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¬à¥à¤°à¤¾ à¤‹à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(295372,8205,'ms','Invois hutang lapuk yang berjaya menambah',0),(295373,8205,'ar','Ø§Ù„Ø¯ÙŠÙˆÙ† Ø§Ù„Ù…Ø¹Ø¯ÙˆÙ…Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(295374,8205,'fr','Facture irrÃ©couvrable ajoutÃ© avec succÃ¨s',0),(295375,8205,'jp','è«‹æ±‚æ›¸ä¸è‰¯å‚µæ¨©ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(295376,8205,'pt','Factura inadimplÃªncia adicionado com sucesso',0),(295377,8205,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð±ÐµÐ·Ð½Ð°Ð´ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð¾Ð»Ð³Ð¾Ð² ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(295378,8205,'es','Factura Mala Deuda Agregada Exitosamente',0),(295379,8205,'de','Rechnung uneinbringliche Forderungen erfolgreich hinzugefÃ¼gt',0),(295380,8205,'en','Invoice Bad Debt Added Successfully',0),(295381,8206,'is','',0),(295382,8206,'dr','ÙŠÙƒØ³Ø§Ù† ÙƒØ±Ø¯Ù† ',0),(295383,8206,'pr','ÙŠÙƒØ³Ø§Ù† ÙƒØ±Ø¯Ù† ',0),(295384,8206,'tr','EÅŸit yap',0),(295385,8206,'pl','SprawiajÄ… rÃ³wnych',0),(295386,8206,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ñ€Ð°Ð²Ð½Ð¸',0),(295387,8206,'ur','Ù…Ø³Ø§ÙˆÛŒ Ú©Ø±ÛŒÚº',0),(295388,8206,'sr','Ð˜Ð·Ñ˜ÐµÐ´Ð½Ð°Ñ‡Ð¸',0),(295389,8206,'vi','LÃ m báº±ng',0),(295390,8206,'af','Maak gelyk',0),(295391,8206,'ro','Face egal',0),(295392,8206,'et','Tee vÃµrdsete',0),(295393,8206,'si','Naredite enako',0),(295394,8206,'ba','Membuat sama',0),(295395,8206,'nl','Gelijk maken',0),(295396,8206,'fi','Samaksi',0),(295397,8206,'no','GjÃ¸re likeverdig',0),(295398,8206,'da','GÃ¸re lig',0),(295399,8206,'ko','ë™ë“± í•˜ ê²Œ',0),(295400,8206,'he','×œ×”×¤×•×š ×©×•×•×”',0),(295401,8206,'el','ÎšÎ±Ï„Î±ÏƒÏ„Î®ÏƒÎµÎ¹ Î¹ÏƒÏŒÏ„Î¹Î¼Î·',0),(295402,8206,'zh','ä½¿ç›¸ç­‰\r\n',0),(295403,8206,'sv','GÃ¶ra lika',0),(295404,8206,'it','Rendere uguale',0),(295405,8206,'tl','',0),(295406,8206,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3627;&#3657;&#3648;&#3607;&#3656;&#3634;&#3585;&#3633;&#3609;',0),(295407,8206,'hi','à¤¬à¤°à¤¾à¤¬à¤° à¤•à¤°à¤¨à¤¾',0),(295408,8206,'ms','Membuat sama',0),(295409,8206,'ar','Ø¬Ø¹Ù„ Ø§Ù„Ù…Ø³Ø§ÙˆØ§Ø©',0),(295410,8206,'fr','Rendre Ã©gal',0),(295411,8206,'jp','ç­‰ã—ãã—ã¾ã™ã€‚',0),(295412,8206,'pt','Fazer igual',0),(295413,8206,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ñ€Ð°Ð²Ð½Ñ‹Ð¼',0),(295414,8206,'es','Hacer Igual',0),(295415,8206,'de','Machen gleich',0),(295416,8206,'en','Make Equal',0),(295417,8207,'is','',0),(295418,8207,'dr','ÙƒØ§Ù…Ù„Ø§ Ø§Ø¹Ù…Ø§Ù„ Ù†Ø´Ø¯Ù‡ ',0),(295419,8207,'pr','ÙƒØ§Ù…Ù„Ø§ Ø§Ø¹Ù…Ø§Ù„ Ù†Ø´Ø¯Ù‡ ',0),(295420,8207,'tr','Tam olarak uygulanan',0),(295421,8207,'pl','Nie w peÅ‚ni stosowane',0),(295422,8207,'bg','ÐÐµ Ðµ Ð½Ð°Ð¿ÑŠÐ»Ð½Ð¾ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½',0),(295423,8207,'ur','Ù…Ú©Ù…Ù„ Ø·ÙˆØ± Ù¾Ø± Ù„Ø§Ú¯Ùˆ Ù†ÛÛŒÚº',0),(295424,8207,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð¿ÑƒÐ½Ð¾ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð°',0),(295425,8207,'vi','KhÃ´ng Ã¡p dá»¥ng hoÃ n toÃ n',0),(295426,8207,'af','Nie Ten Volle Toegepas',0),(295427,8207,'ro','Nu este pe deplin aplicate',0),(295428,8207,'et','Ei ole tÃ¤ielikult rakendatud',0),(295429,8207,'si','Ne uporabljajo v celoti',0),(295430,8207,'ba','Tidak sepenuhnya diterapkan',0),(295431,8207,'nl','Niet volledig toegepast',0),(295432,8207,'fi','Ei kohdistusta',0),(295433,8207,'no','Ikke helt utlignet',0),(295434,8207,'da','Anvendes ikke fuldt ud',0),(295435,8207,'ko','ì™„ì „ížˆ ì ìš©',0),(295436,8207,'he','×”×—×œ×” ×œ× ×ž×œ××”',0),(295437,8207,'el','Î”ÎµÎ½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Ï„Î¹ÎºÎ¬',0),(295438,8207,'zh','æ²¡æœ‰å¾—åˆ°å……åˆ†å®žæ–½\r\n',0),(295439,8207,'sv','Inte helt tillÃ¤mpas',0),(295440,8207,'it','Non pienamente applicata',0),(295441,8207,'tl','',0),(295442,8207,'th','&#3611;&#3619;&#3632;&#3618;&#3640;&#3585;&#3605;&#3660;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;&#3652;&#3617;&#3656;&#3648;&#3605;&#3655;&#3617;&#3607;&#3637;&#3656;',0),(295443,8207,'hi','à¤¨à¤¹à¥€à¤‚ à¤ªà¥‚à¤°à¥€ à¤¤à¤°à¤¹ à¤¸à¥‡ à¤²à¤¾à¤—à¥‚ à¤•à¤¿à¤¯à¤¾',0),(295444,8207,'ms','Tidak sepenuhnya digunakan',0),(295445,8207,'ar','ÙŠØ·Ø¨Ù‚ ØªØ·Ø¨ÙŠÙ‚Ø§Ù‹ ÙƒØ§Ù…Ù„Ø§ Ù„Ø§',0),(295446,8207,'fr','Pas entiÃ¨rement appliquÃ©e',0),(295447,8207,'jp','å®Œå…¨ã«é©ç”¨ã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(295448,8207,'pt','NÃ£o Ã© plenamente aplicada',0),(295449,8207,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½ÑÐµÑ‚ÑÑ Ð½Ðµ Ð² Ð¿Ð¾Ð»Ð½Ð¾Ð¹ Ð¼ÐµÑ€Ðµ',0),(295450,8207,'es','No Plenamente Aplicado',0),(295451,8207,'de','Nicht vollstÃ¤ndig angewendet',0),(295452,8207,'en','Not Fully Applied',0),(295453,8208,'is','',0),(295454,8208,'dr','(Ø­Ø°Ù ÙƒØ±Ø¯Ù†',0),(295455,8208,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø³ÙˆØ®Øª Ø´Ø¯Ù†(Ø­Ø°Ù ÙƒØ±Ø¯Ù†',0),(295456,8208,'tr','Yazma-off iÃ§in seÃ§ilen',0),(295457,8208,'pl','Wybrane do umorzenia',0),(295458,8208,'bg','Ð˜Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð·Ð° Ð¾Ñ‚Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(295459,8208,'ur','Write-Off Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§',0),(295460,8208,'sr','Ð˜Ð·Ð°Ð±Ñ€Ð°Ð½Ð° Ð·Ð° Ð¾Ñ‚Ð¿Ð¸Ñ',0),(295461,8208,'vi','ÄÃ£ chá»n Ä‘á»ƒ xÃ³a ',0),(295462,8208,'af','Selekteer Om Af te Skryf',0),(295463,8208,'ro','Selectat pentru anularea',0),(295464,8208,'et','Valitud mahakandmine',0),(295465,8208,'si','Izbrane za odpis',0),(295466,8208,'ba','Dipilih untuk Write-Off',0),(295467,8208,'nl','Geselecteerd voor afschrijving',0),(295468,8208,'fi','Valittu anteeksi',0),(295469,8208,'no','Valgt For avskrivning',0),(295470,8208,'da','Valgt For afskrivning',0),(295471,8208,'ko','ì“°ê¸°ì— ëŒ€ í•œ ì„ ì •',0),(295472,8208,'he','× ×‘×—×¨×ª ×¢×‘×•×¨ ×ž×—×™×§×” ×‘×”×ª××',0),(295473,8208,'el','Î•Ï€Î¹Î»ÎµÎ³ÎµÎ¯ Î³Î¹Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(295474,8208,'zh','é€‰å®šæ³¨é”€\r\n',0),(295475,8208,'sv','Valt fÃ¶r avskrivning',0),(295476,8208,'it','Selezionato per la cancellazione',0),(295477,8208,'tl','',0),(295478,8208,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3605;&#3633;&#3604;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;',0),(295479,8208,'hi','à¤²à¤¿à¤–à¤¨à¥‡ à¤¬à¤¨à¤¾à¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¯à¤¨à¤¿à¤¤',0),(295480,8208,'ms','Dipilih untuk pelupusan',0),(295481,8208,'ar','Ø§Ù„Ù…Ø­Ø¯Ø¯ Ù„Ù„Ø´Ø·Ø¨',0),(295482,8208,'fr','SÃ©lectionnÃ© par profits et pertes',0),(295483,8208,'jp','å„Ÿå´ã®é¸æŠž',0),(295484,8208,'pt','Selecionado para write-off',0),(295485,8208,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ðµ Ð´Ð»Ñ ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(295486,8208,'es','Seleccionado para descontar',0),(295487,8208,'de','AusgewÃ¤hlt fÃ¼r die Abschreibung',0),(295488,8208,'en','Selected For Write-off',0),(295489,8209,'is','',0),(295490,8209,'dr','(Ø­Ø°Ù ) ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(295491,8209,'pr','Ø³ÙˆØ®Øª (Ø­Ø°Ù ) ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(295492,8209,'tr','Not yazma',0),(295493,8209,'pl','Uwaga nie odpisuje',0),(295494,8209,'bg','ÐžÑ‚Ð¿Ð¸ÑˆÐµ Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(295495,8209,'ur','Ù†ÙˆÙ¹ Ø¨Ù†Ø¯ Ù„Ú©Ú¾',0),(295496,8209,'sr','ÐžÑ‚Ð¿Ð¸ÑÐ°Ñ‚Ð¸ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(295497,8209,'vi','Ghi chÃº xÃ³a ná»£',0),(295498,8209,'af','Afskryf Nota',0),(295499,8209,'ro','Scrie cu usurinta nota',0),(295500,8209,'et','Write Off Note',0),(295501,8209,'si','OdpiÅ¡e Opomba',0),(295502,8209,'ba','Menulis dari catatan',0),(295503,8209,'nl','Opmerking afschrijven',0),(295504,8209,'fi','Anteeksi Huomautus',0),(295505,8209,'no','Skrive ut notat',0),(295506,8209,'da','Afskrive BemÃ¦rk',0),(295507,8209,'ko','ì°¸ê³  ì˜¤í”„ ì“°ê¸°',0),(295508,8209,'he','×œ×›×ª×•×‘ ××ª ×”×¤×ª×§',0),(295509,8209,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎ¿Ï…Î½ Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(295510,8209,'zh','æ³¨é”€æ³¨æ˜Ž\r\n',0),(295511,8209,'sv','Skriva av Obs',0),(295512,8209,'it','Scrivere Off nota',0),(295513,8209,'tl','',0),(295514,8209,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3585;&#3634;&#3619;&#3605;&#3633;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(295515,8209,'hi','à¤²à¤¿à¤–à¤¨à¥‡ à¤•à¥‡ à¤¨à¥‹à¤Ÿ à¤¬à¤‚à¤¦',0),(295516,8209,'ms','Menghapuskira Nota',0),(295517,8209,'ar','Ø´Ø·Ø¨ Ø¹Ù„Ù…Ø§',0),(295518,8209,'fr','Radier Note',0),(295519,8209,'jp','ãƒ¡ãƒ¢ ã‚ªãƒ•ã«æ›¸ãè¾¼ã‚€',0),(295520,8209,'pt','Amortizar nota',0),(295521,8209,'ru','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚ÑŒ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(295522,8209,'es','Cancelar Nota',0),(295523,8209,'de','Notiz schreiben',0),(295524,8209,'en','Write-off Note',0),(295525,8210,'is','',0),(295526,8210,'dr','(Ø­Ø°Ù ) Ø¬Ù…Ø¹ Ù…Ø¬Ù…ÙˆØ¹',0),(295527,8210,'pr','Ø³ÙˆØ®Øª (Ø­Ø°Ù ) Ø¬Ù…Ø¹ ÙƒÙ„',0),(295528,8210,'tr','Toplam yazmak',0),(295529,8210,'pl','Pisze siÄ™ Å‚Ä…cznie',0),(295530,8210,'bg','ÐžÑ‚Ð¿Ð¸ÑˆÐµ Ð¾Ð±Ñ‰Ð¾',0),(295531,8210,'ur','Ú©Ù„ Ø¨Ù†Ø¯ Ù„Ú©Ú¾',0),(295532,8210,'sr','ÐžÑ‚Ð¿Ð¸ÑÐ°Ñ‚Ð¸ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(295533,8210,'vi','Tá»•ng sá»‘ xÃ³a ná»£',0),(295534,8210,'af','Afgeskryfde Totaal',0),(295535,8210,'ro','Scrie cu usurinta total',0),(295536,8210,'et','Write Off Total',0),(295537,8210,'si','OdpiÅ¡e skupaj',0),(295538,8210,'ba','Menulis dari Total',0),(295539,8210,'nl','Totaal afschrijven',0),(295540,8210,'fi','Anteeksi yhteensÃ¤',0),(295541,8210,'no','Skrive ut totalt',0),(295542,8210,'da','Afskrive alt',0),(295543,8210,'ko','ì´ ì˜¤í”„ ì“°ê¸°',0),(295544,8210,'he','×œ×›×ª×•×‘ ××ª ×¡×”',0),(295545,8210,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎ¿Ï…Î½ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(295546,8210,'zh','å…±æ³¨é”€\r\n',0),(295547,8210,'sv','Skriva av totalt',0),(295548,8210,'it','Scrivere Off totale',0),(295549,8210,'tl','',0),(295550,8210,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3605;&#3633;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(295551,8210,'hi','à¤²à¤¿à¤–à¤¨à¥‡ à¤¸à¥‡ à¤•à¥à¤²',0),(295552,8210,'ms','Menghapus kira jumlah',0),(295553,8210,'ar','Ø´Ø·Ø¨ Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(295554,8210,'fr','Radier Total',0),(295555,8210,'jp','åˆè¨ˆã‚’å¸³æ¶ˆã—',0),(295556,8210,'pt','Amortizar Total',0),(295557,8210,'ru','Ð¡Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ð²ÑÐµÐ³Ð¾',0),(295558,8210,'es','Cancelar Total',0),(295559,8210,'de','Insgesamt abzuschreiben',0),(295560,8210,'en','Write-off Total',0),(295561,8211,'is','',0),(295562,8211,'dr','(ØªØ§ Ø²Ù…Ø§Ù†) Ø§Ù†ØªØ®Ø§Ø¨',0),(295563,8211,'pr','Ù‡Ù†ÙˆØ² (ØªØ§ Ø²Ù…Ø§Ù†) Ø§Ù†ØªØ®Ø§Ø¨',0),(295564,8211,'tr','HenÃ¼z SeÃ§ \'',0),(295565,8211,'pl','Jeszcze do wybierz',0),(295566,8211,'bg','Ð˜ Ð²ÑÐµ Ð¿Ð°Ðº Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ',0),(295567,8211,'ur','Ø§Ø¨Ú¾ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(295568,8211,'sr','Ð¢ÐµÐº Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° Ð¸Ð·Ð±Ð¾Ñ€',0),(295569,8211,'vi','ChÆ°a lá»±a chá»n',0),(295570,8211,'af','Moet nog KIES.',0),(295571,8211,'ro','Nu selecta inca',0),(295572,8211,'et','Pead alles valima',0),(295573,8211,'si','Å e na Izberi',0),(295574,8211,'ba','Namun untuk Pilih',0),(295575,8211,'nl','Nog te selecteren',0),(295576,8211,'fi','VielÃ¤ valittava',0),(295577,8211,'no','Men Ã¥ velge',0),(295578,8211,'da','Endnu til at vÃ¦lge',0),(295579,8211,'ko','ì•„ì§ë¥¼ ì„ íƒ',0),(295580,8211,'he','×¢×•×“ ×¢×œ ×‘×—×¨',0),(295581,8211,'el','Î‘ÎºÏŒÎ¼Î± Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ',0),(295582,8211,'zh','å°šæœªé€‰æ‹©\r\n',0),(295583,8211,'sv','Ã„nnu fÃ¶r att vÃ¤lja',0),(295584,8211,'it','Ancora su Select',0),(295585,8211,'tl','',0),(295586,8211,'th','&#3618;&#3633;&#3591;&#3588;&#3591;&#3609;&#3635;&#3652;&#3611;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(295587,8211,'hi','à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤­à¥€ à¤¤à¤•',0),(295588,8211,'ms','Namun untuk pilih',0),(295589,8211,'ar','Ø¨Ø¹Ø¯ Ø£Ù† Ø­Ø¯Ø¯',0),(295590,8211,'fr','Reste Ã  sÃ©lectionner',0),(295591,8211,'jp','ã¾ã é¸æŠžã™ã‚‹',0),(295592,8211,'pt','Ainda para selecionar',0),(295593,8211,'ru','Ð¢ÐµÐ¼ Ð½Ðµ Ð¼ÐµÐ½ÐµÐµ Ð½Ð° Ð²Ñ‹Ð±Ð¾Ñ€',0),(295594,8211,'es','Sin embargo, para seleccionar',0),(295595,8211,'de','Noch auf Select',0),(295596,8211,'en','Yet To Select',0),(295597,8212,'is','',0),(295598,8212,'dr','Ø³ÙˆØ®Øª Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„',0),(295599,8212,'pr','Ø³ÙˆØ®Øª Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„',0),(295600,8212,'tr','KÃ¶tÃ¼ borÃ§ yazmak',0),(295601,8212,'pl','Odpisuje zÅ‚ych dÅ‚ugÃ³w',0),(295602,8212,'bg','ÐžÑ‚Ð¿Ð¸ÑˆÐµ Ð»Ð¾ÑˆÐ¸ Ð´ÑŠÐ»Ð³Ð¾Ð²Ðµ',0),(295603,8212,'ur','Ø¨Ø±ÛŒ Ù‚Ø±Ø¶ Ù„Ú©Ú¾ØªÛ’ ÛÛŒÚº Û”',0),(295604,8212,'sr','ÐžÑ‚Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð´ÑƒÐ³Ð¾Ð²Ð°',0),(295605,8212,'vi','XÃ³a ná»£ xáº¥u',0),(295606,8212,'af','Skryf Swak Skuld Af',0),(295607,8212,'ro','Scrie Off rÄƒu datoriei',0),(295608,8212,'et','Write Off Bad Debt',0),(295609,8212,'si','Odpis neizterljivih terjatev',0),(295610,8212,'ba','Menulis dari hutang',0),(295611,8212,'nl','Afschrijving van slechte schulden',0),(295612,8212,'fi','Kuitata luottotappiovarauksia',0),(295613,8212,'no','Avskrive dÃ¥rlig gjeld',0),(295614,8212,'da','Afskrive dÃ¥rlige gÃ¦ld',0),(295615,8212,'ko','ë‚˜ìœ ë¶€ì±„ë¥¼ ì¨ì£¼ì„¸ìš”',0),(295616,8212,'he','×œ×ž×—×•×§ ×—×•×‘ ××‘×•×“',0),(295617,8212,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎ¿Ï…Î½ ÎºÎ±ÎºÏŒ Ï‡ÏÎ­Î¿Ï‚',0),(295618,8212,'zh','æ ¸é”€åå¸\r\n',0),(295619,8212,'sv','Skriva av kundfÃ¶rluster',0),(295620,8212,'it','Scrivi i crediti inesigibili',0),(295621,8212,'tl','',0),(295622,8212,'th','&#3605;&#3633;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;',0),(295623,8212,'hi','à¤¬à¤‚à¤¦ à¤¬à¥à¤°à¤¾ à¤‹à¤£ à¤²à¤¿à¤–à¤¨à¥‡',0),(295624,8212,'ms','Menghapus kira hutang lapuk',0),(295625,8212,'ar','Ø´Ø·Ø¨ Ø§Ù„Ø¯ÙŠÙˆÙ† Ø§Ù„Ù…Ø¹Ø¯ÙˆÙ…Ø©',0),(295626,8212,'fr','Radier de crÃ©ances irrÃ©couvrables',0),(295627,8212,'jp','ä¸è‰¯å‚µæ¨©ã‚’å„Ÿå´ã—ã¾ã™ã€‚',0),(295628,8212,'pt','Amortizar dÃ­vidas incobrÃ¡veis',0),(295629,8212,'ru','Ð¡Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð±ÐµÐ·Ð½Ð°Ð´ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð¾Ð»Ð³Ð¾Ð²',0),(295630,8212,'es','Cancelar Deudas Incobrables',0),(295631,8212,'de','Uneinbringliche Forderungen abschreiben',0),(295632,8212,'en','Write Off Bad Debt',0),(295633,8213,'is','',0),(295634,8213,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(295635,8213,'pr','Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(295636,8213,'tr','Para yatÄ±rma',0),(295637,8213,'pl','Kaucji',0),(295638,8213,'bg','Ð’Ð½ÐµÑÐµÐ½Ð¸Ñ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(295639,8213,'ur','Ø¬Ù…Ø¹ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(295640,8213,'sr','ÐšÐ°Ð¿Ð°Ñ€Ñƒ',0),(295641,8213,'vi','ÄÃ£ tráº£ Äáº·t cá»c',0),(295642,8213,'af','Deposito Betaal',0),(295643,8213,'ro','Depozit plÄƒtite',0),(295644,8213,'et','Makstud deposiiti',0),(295645,8213,'si','Depozit, plaÄa',0),(295646,8213,'ba','Deposit yang dibayar',0),(295647,8213,'nl','Vooruitbetaling',0),(295648,8213,'fi','Talletus maksetaan',0),(295649,8213,'no','Depositum betalt',0),(295650,8213,'da','Depositum betalt',0),(295651,8213,'ko','ì˜ˆê¸ˆ ì§€ê¸‰',0),(295652,8213,'he','×”×¤×§×“×ª ×›×¡×£',0),(295653,8213,'el','Î ÏÎ¿ÎºÎ±Ï„Î±Î²Î¿Î»Î®Ï‚',0),(295654,8213,'zh','å·²ä»˜æŒ‰é‡‘\r\n',0),(295655,8213,'sv','Depositionen betalas',0),(295656,8213,'it','Caparra versata',0),(295657,8213,'tl','',0),(295658,8213,'th','&#3613;&#3634;&#3585;&#3592;&#3656;&#3634;&#3618;',0),(295659,8213,'hi','à¤œà¤®à¤¾ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(295660,8213,'ms','Deposit yang telah dibayar',0),(295661,8213,'ar','Ø§Ù„Ø¹Ø±Ø¨ÙˆÙ† Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(295662,8213,'fr','Acompte versÃ©',0),(295663,8213,'jp','æ‰‹ä»˜é‡‘',0),(295664,8213,'pt','DepÃ³sito pago',0),(295665,8213,'ru','ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ð¹ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(295666,8213,'es','DepÃ³sito Pagado',0),(295667,8213,'de','Anzahlung',0),(295668,8213,'en','Deposit Paid',0),(295669,8214,'is','',0),(295670,8214,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(295671,8214,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(295672,8214,'tr','SipariÅŸler toplam',0),(295673,8214,'pl','Suma zamÃ³wienia',0),(295674,8214,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¾Ð±Ñ‰Ð¾',0),(295675,8214,'ur','Ú©Ù„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(295676,8214,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(295677,8214,'vi','Tá»•ng cá»™ng Ä‘Æ¡n hÃ ng',0),(295678,8214,'af','Bestellings Totaal',0),(295679,8214,'ro','Ordine totalÄƒ',0),(295680,8214,'et','Tellimuste kogusumma',0),(295681,8214,'si','Vsota naroÄil',0),(295682,8214,'ba','Total pesanan',0),(295683,8214,'nl','Bestellingen totaal',0),(295684,8214,'fi','Ostotilaukset yhteensÃ¤',0),(295685,8214,'no','Ordre totalt',0),(295686,8214,'da','Ordrer i alt',0),(295687,8214,'ko','ì£¼ë¬¸ í•©ê³„',0),(295688,8214,'he','×¡×” ×› ×”×–×ž× ×•×ª',0),(295689,8214,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(295690,8214,'zh','è®¢å•æ€»\r\n',0),(295691,8214,'sv','Order totalt',0),(295692,8214,'it','Totale ordini',0),(295693,8214,'tl','',0),(295694,8214,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3619;&#3623;&#3617;',0),(295695,8214,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥à¤²',0),(295696,8214,'ms','Jumlah pesanan',0),(295697,8214,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø·Ù„Ø¨ÙŠØ§Øª',0),(295698,8214,'fr','Total des commandes',0),(295699,8214,'jp','å—æ³¨åˆè¨ˆ',0),(295700,8214,'pt','Total de ordens',0),(295701,8214,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾ Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(295702,8214,'es','Ordenes Totales',0),(295703,8214,'de','Bestellungen insgesamt',0),(295704,8214,'en','Orders Total',0),(295705,8215,'is','',0),(295706,8215,'dr','Ø³ÙˆØ®Øª Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„',0),(295707,8215,'pr','Ø³ÙˆØ®Øª Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„',0),(295708,8215,'tr','KÃ¶tÃ¼ borÃ§ indirimi',0),(295709,8215,'pl','Odpisanie nieÅ›ciÄ…galnych dÅ‚ugÃ³w',0),(295710,8215,'bg','ÐžÐ¿Ñ€Ð¾Ñ‰Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¾ÑˆÐ¾',0),(295711,8215,'ur','Ø¨Ø±ÛŒ Ù‚Ø±Ø¶Û’Ù…Ø¹Ø§Ù',0),(295712,8215,'sr','ÐžÑ‚Ð¿Ð¸Ñ Ð´ÑƒÐ³Ð° Ð»Ð¾ÑˆÐµ',0),(295713,8215,'vi','XÃ³a ná»£ xáº¥u',0),(295714,8215,'af','Swak Skulde Afgeskryf',0),(295715,8215,'ro','Anularea datoriei Bad',0),(295716,8215,'et','Halbade vÃµlgade mahakandmine',0),(295717,8215,'si','Slabih dolgov odpis',0),(295718,8215,'ba','Menghapusbukukan buruk hutang',0),(295719,8215,'nl','Slechte schulden afschrijving',0),(295720,8215,'fi','Huono velkaa anteeksi',0),(295721,8215,'no','DÃ¥rlig gjeld avskrivning',0),(295722,8215,'da','DÃ¥rlige gÃ¦ldsafskrivning',0),(295723,8215,'ko','ë‚˜ìœ ë¶€ì±„ ì“°ê¸°',0),(295724,8215,'he','×ž×—×™×§×” ×‘×”×ª×× ×—×•×‘ ××‘×•×“',0),(295725,8215,'el','ÎšÎ±ÎºÏŒ Ï‡ÏÎµÏŽÎ½',0),(295726,8215,'zh','åå¸å†²é”€\r\n',0),(295727,8215,'sv','Avskrivning av osÃ¤kra fordringar',0),(295728,8215,'it','Storno di crediti inesigibili',0),(295729,8215,'tl','',0),(295730,8215,'th','&#3585;&#3634;&#3619;&#3621;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3611;&#3655;&#3609;&#3627;&#3609;&#3637;&#3657;&#3626;&#3641;&#3597;',0),(295731,8215,'hi','à¤¬à¥à¤°à¤¾ à¤‹à¤£ à¤²à¤¿à¤–à¤¨à¥‡ à¤¬à¤¨à¤¾à¤¨à¤¾',0),(295732,8215,'ms','Hapuskira hutang lapuk',0),(295733,8215,'ar','Ø´Ø·Ø¨ Ø§Ù„Ø¯ÙŠÙˆÙ† Ø§Ù„Ù…Ø¹Ø¯ÙˆÙ…Ø©',0),(295734,8215,'fr','Radiation de crÃ©ances irrÃ©couvrables',0),(295735,8215,'jp','ä¸è‰¯å‚µæ¨©å„Ÿå´',0),(295736,8215,'pt','AnulaÃ§Ã£o de dÃ­vidas incobrÃ¡veis',0),(295737,8215,'ru','Ð¡Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð±ÐµÐ·Ð½Ð°Ð´ÐµÐ¶Ð½Ñ‹Ñ… Ð´Ð¾Ð»Ð³Ð¾Ð²',0),(295738,8215,'es','Descuento de Deudas Incobrables',0),(295739,8215,'de','Uneinbringliche Forderungen abschreiben',0),(295740,8215,'en','Bad Debt Write-off',0),(295741,8216,'is','',0),(295742,8216,'dr','(Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(295743,8216,'pr','Ø³ÙˆØ®Øª Ø´Ø¯Ù‡ (Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(295744,8216,'tr','DÃ¼ÅŸÃ¼len',0),(295745,8216,'pl','Odpisane',0),(295746,8216,'bg','ÐžÑ‚Ð¿Ð¸ÑÐ°Ð½Ð¸',0),(295747,8216,'ur','ØªØ­Ø±ÛŒØ± Ø³Û’ Ø¯ÙÙˆØ±',0),(295748,8216,'sr','ÐžÑ‚Ð¿Ð¸ÑÐ°Ð»Ð°',0),(295749,8216,'vi','XÃ³a ná»£',0),(295750,8216,'af','Afgeskryf',0),(295751,8216,'ro','Amortizare',0),(295752,8216,'et','Written Off',0),(295753,8216,'si','Odpisani',0),(295754,8216,'ba','Dihapuskan',0),(295755,8216,'nl','Afgeschreven',0),(295756,8216,'fi','Anteeksi',0),(295757,8216,'no','Skrevet',0),(295758,8216,'da','Afskrevet',0),(295759,8216,'ko','ìž‘ì„±',0),(295760,8216,'he','. ×”×¢×ª×§×ª',0),(295761,8216,'el','Î‘Ï€ÏŒÏƒÎ²ÎµÏƒÎ·',0),(295762,8216,'zh','æ³¨é”€\r\n',0),(295763,8216,'sv','Avskrivna',0),(295764,8216,'it','Scritto Off',0),(295765,8216,'tl','',0),(295766,8216,'th','&#3605;&#3633;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3621;&#3657;&#3623;\n',0),(295767,8216,'hi','à¤¬à¤‚à¤¦ à¤²à¤¿à¤–à¤¾',0),(295768,8216,'ms','Dihapus kira',0),(295769,8216,'ar','Ø§Ù„Ù…Ø´Ø·ÙˆØ¨Ø©',0),(295770,8216,'fr','RadiÃ©',0),(295771,8216,'jp','ã‚ªãƒ•ã«æ›¸ã‹ã‚Œã¦',0),(295772,8216,'pt','Escrito fora',0),(295773,8216,'ru','Ð¡Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(295774,8216,'es','Anulado',0),(295775,8216,'de','Abgeschrieben',0),(295776,8216,'en','Written Off',0),(295777,8217,'is','',0),(295778,8217,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(295779,8217,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(295780,8217,'tr','RMA Ekle',0),(295781,8217,'pl','DodaÄ‡ RMA',0),(295782,8217,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð Ð¡Ðž',0),(295783,8217,'ur','Ø±Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(295784,8217,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐžÐŸÐ¡',0),(295785,8217,'vi','ThÃªm RMA',0),(295786,8217,'af','Voeg RMA',0),(295787,8217,'ro','Adauga RMA',0),(295788,8217,'et','Lisada RMA',0),(295789,8217,'si','Dodaj RMA',0),(295790,8217,'ba','Tambahkan RMA',0),(295791,8217,'nl','RMA toevoegen',0),(295792,8217,'fi','LisÃ¤Ã¤ RMA',0),(295793,8217,'no','Legge til RMA',0),(295794,8217,'da','TilfÃ¸je RMA',0),(295795,8217,'ko','RMAë¥¼ ì¶”ê°€',0),(295796,8217,'he','×œ×”×•×¡×™×£ RMA',0),(295797,8217,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ RMA',0),(295798,8217,'zh','å¢žåŠ é€€æ–™å®¡æŸ¥\r\n',0),(295799,8217,'sv','LÃ¤gg till RMA',0),(295800,8217,'it','Aggiungi RMA',0),(295801,8217,'tl','',0),(295802,8217,'th','&#3648;&#3614;&#3636;&#3656;&#3617; RMA',0),(295803,8217,'hi','RMA à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(295804,8217,'ms','Tambah RMA',0),(295805,8217,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ù…Ø¨ÙŠØ¹Ø§Øª',0),(295806,8217,'fr','Ajouter RMA',0),(295807,8217,'jp','RMA ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(295808,8217,'pt','Adicionar RMA',0),(295809,8217,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ RMA',0),(295810,8217,'es','Agregar RMA',0),(295811,8217,'de','HinzufÃ¼gen von RMA',0),(295812,8217,'en','Add RMA',0),(295813,8218,'is','',0),(295814,8218,'dr','(ØªØ¹ÙˆÛŒÙ‚',0),(295815,8218,'pr',' Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ù…Ø´Ø±ÙˆØ·(Ù…Ø¹ÙˆÙ‚',0),(295816,8218,'tr','RMA bekleyen',0),(295817,8218,'pl','RMA czasu',0),(295818,8218,'bg','Ð Ð¡Ðž Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ',0),(295819,8218,'ur','Ø±Ù… Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(295820,8218,'sr','ÐžÐ¿Ñ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(295821,8218,'vi','Äang treo RMA',0),(295822,8218,'af','\"RMA\" Afwagtend',0),(295823,8218,'ro','RMA pÃ¢nÄƒ',0),(295824,8218,'et','RMA kuni',0),(295825,8218,'si','RMA do',0),(295826,8218,'ba','RMA tertunda',0),(295827,8218,'nl','RMA in afwachting van',0),(295828,8218,'fi','RMA vireillÃ¤',0),(295829,8218,'no','RMA venter',0),(295830,8218,'da','RMA indtil',0),(295831,8218,'ko','RMA ë³´ë¥˜',0),(295832,8218,'he','RMA ×ž×ž×ª×™× ×™×',0),(295833,8218,'el','RMA ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î®',0),(295834,8218,'zh','è¿”å›žå•†å“æŽˆæƒå¾…å®š\r\n',0),(295835,8218,'sv','RMA i avvaktan',0),(295836,8218,'it','RMA in sospeso',0),(295837,8218,'tl','',0),(295838,8218,'th','RMA &#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3588;&#3657;&#3634;&#3591;&#3588;&#3634;&#3629;&#3618;&#3641;&#3656;',0),(295839,8218,'hi','RMA à¤²à¤‚à¤¬à¤¿à¤¤',0),(295840,8218,'ms','RMA yang belum selesai',0),(295841,8218,'ar','Ø§Ù„Ø¬ÙŠØ´ Ø§Ù„Ù…Ù„ÙƒÙŠ Ø§Ù„Ù…ØºØ±Ø¨ÙŠ Ø±ÙŠØ«Ù…Ø§',0),(295842,8218,'fr','RMA en attendant',0),(295843,8218,'jp','ä¿ç•™ä¸­ã® RMA',0),(295844,8218,'pt','RMA pendentes',0),(295845,8218,'ru','RMA Ð´Ð¾',0),(295846,8218,'es','RMA Pendiente',0),(295847,8218,'de','RMA bis',0),(295848,8218,'en','RMA Pending',0),(295849,8219,'is','',0),(295850,8219,'dr','Ù…Ø¬Ù…ÙˆØ¹  Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(295851,8219,'pr','Ù…Ø¬Ù…ÙˆØ¹  Ø¹ÙˆØ¯Øª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(295852,8219,'tr','RMA toplam',0),(295853,8219,'pl','Sumie RMA',0),(295854,8219,'bg','Ð Ð¡Ðž Ð¾Ð±Ñ‰Ð¾',0),(295855,8219,'ur','Ø±Ù… Ú©Ù„',0),(295856,8219,'sr','ÐžÐ¿Ñ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(295857,8219,'vi','Tá»•ng sá»‘ RMA',0),(295858,8219,'af','RMA totaal',0),(295859,8219,'ro','RMA Total',0),(295860,8219,'et','Tagastatud kauba kokku',0),(295861,8219,'si','RMA skupaj',0),(295862,8219,'ba','RMA Total',0),(295863,8219,'nl','RMA totaal',0),(295864,8219,'fi','RMA yhteensÃ¤',0),(295865,8219,'no','RMA totalt',0),(295866,8219,'da','RMA alt',0),(295867,8219,'ko','RMA ì´',0),(295868,8219,'he','×¡×” ×› RMA',0),(295869,8219,'el','RMA ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(295870,8219,'zh','è¿”å›žå•†å“æŽˆæƒæ€»\r\n',0),(295871,8219,'sv','RMA totalt',0),(295872,8219,'it','Totale RMA',0),(295873,8219,'tl','',0),(295874,8219,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617; RMA ',0),(295875,8219,'hi','RMA à¤•à¥à¤²',0),(295876,8219,'ms','RMA jumlah',0),(295877,8219,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø±Ø¯ÙˆØ¯Ø§Øª',0),(295878,8219,'fr','Total RMA',0),(295879,8219,'jp','RMA ã®åˆè¨ˆ',0),(295880,8219,'pt','Total RMA',0),(295881,8219,'ru','Ð’ÑÐµÐ³Ð¾ RMA',0),(295882,8219,'es','RMA Total',0),(295883,8219,'de','RMA gesamt',0),(295884,8219,'en','RMA Total',0),(295885,8220,'is','',0),(295886,8220,'dr','/ Ø§ØµÙ„Ø§Ø­  / Ø¯Ø±ÙŠØ§ÙØª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(295887,8220,'pr','Ù†Ù…Ø§ÙŠØ´ / ÙˆÙŠØ±Ø§ÙŠØ´ / Ø¯Ø±ÙŠØ§ÙØª Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ø¨Ø±Ú¯Ø´ØªÙŠ ',0),(295888,8220,'tr','GÃ¶rÃ¼ntÃ¼le/DÃ¼zenle/alma RMA',0),(295889,8220,'pl','Widoku, edytowanie, otrzymujÄ… RMA',0),(295890,8220,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð Ð¡Ðž',0),(295891,8220,'ur','Ù…Ù†Ø¸Ø± ØªØ¯ÙˆÛŒÙ†/ÙˆØµÙˆÙ„ÛŒÚº Ø±Ù…',0),(295892,8220,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸/Ð£Ñ€ÐµÐ´Ð¸ /Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼ ÐžÐŸÐ¡',0),(295893,8220,'vi','Xem/Sá»­a/Nháº­n RMA',0),(295894,8220,'af','Bekyk/redigeer/ontvang RMA',0),(295895,8220,'ro','Vezi/editare/primi RMA',0),(295896,8220,'et','Vaata/Muuda/saada RMA',0),(295897,8220,'si','Ogled/urejanje/prejeti RMA',0),(295898,8220,'ba','Lihat/Edit/menerima RMA',0),(295899,8220,'nl','Weergave/bewerken/ontvangen RMA',0),(295900,8220,'fi','NÃ¤ytÃ¤/Muokkaa/vastaanottaa RMA',0),(295901,8220,'no','Vis og Rediger/mottak RMA',0),(295902,8220,'da','Se/Rediger/modtage RMA',0),(295903,8220,'ko','ë³´ê¸°/íŽ¸ì§‘/ìˆ˜ì‹  RMA',0),(295904,8220,'he','RMA ×ª×¦×•×’×”/×¢×¨×™×›×”/×§×‘×œ×”',0),(295905,8220,'el','Î ÏÎ¿Î²Î¿Î»Î®/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±/Î»Î®ÏˆÎ· RMA',0),(295906,8220,'zh','æŸ¥çœ‹/ç¼–è¾‘/æŽ¥æ”¶é€€è´§æŽˆæƒ',0),(295907,8220,'sv','Visa/redigera/ta emot RMA',0),(295908,8220,'it','Visualizzazione/modifica/ricezione RMA',0),(295909,8220,'tl','',0),(295910,8220,'th','&#3604;&#3641;/&#3649;&#3585;&#3657;&#3652;&#3586;/&#3619;&#3633;&#3610; RMA',0),(295911,8220,'hi','RMA à¤¦à¥‡à¤–à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚/à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(295912,8220,'ms','RMA View/Edit/menerima',0),(295913,8220,'ar','Ø¹Ø±Ø¶/ØªØ­Ø±ÙŠØ±/Ø¥Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø±Ø¯ÙˆØ¯Ø§Øª',0),(295914,8220,'fr','Voir/modifier/recevoir RMA',0),(295915,8220,'jp','RMA ã®å—ä¿¡ã‚’è¡¨ç¤º/ç·¨é›†/',0),(295916,8220,'pt','View/Edit/receber RMA',0),(295917,8220,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ/Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ RMA',0),(295918,8220,'es','Visionar/Editar/Recibir RMA',0),(295919,8220,'de','Anzeigen/bearbeiten/empfangen von RMA',0),(295920,8220,'en','View/Edit/Receive RMA',0),(295921,8221,'is','',0),(295922,8221,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(295923,8221,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(295924,8221,'tr','AÃ§Ä±klama olarak',0),(295925,8221,'pl','Instrukcja jak z',0),(295926,8221,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ ÐºÐ°Ñ‚Ð¾ Ð½Ð°',0),(295927,8221,'ur','Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø¨ÛŒØ§Ù†',0),(295928,8221,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° ÐºÐ°Ð¾',0),(295929,8221,'vi','Sao kÃª cá»§a',0),(295930,8221,'af','State soos vanaf',0),(295931,8221,'ro','DeclaraÅ£ie de',0),(295932,8221,'et','Kui avaldus',0),(295933,8221,'si','Izjavo kot',0),(295934,8221,'ba','Pernyataan sebagai',0),(295935,8221,'nl','Verklaring als van',0),(295936,8221,'fi','Selvitys kuin',0),(295937,8221,'no','Setning som',0),(295938,8221,'da','ErklÃ¦ring som af',0),(295939,8221,'ko','ì„œ ë¬¸',0),(295940,8221,'he','×”×•×“×¢×” ×›×ž×• ×©×œ',0),(295941,8221,'el','Î”Î®Î»Ï‰ÏƒÎ· Ï‰Ï‚',0),(295942,8221,'zh','å£°æ˜Žä½œä¸º\r\n',0),(295943,8221,'sv','Uttalande som av',0),(295944,8221,'it','Istruzione come di',0),(295945,8221,'tl','',0),(295946,8221,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; &#3603; &#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(295947,8221,'hi','à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¬à¤¯à¤¾à¤¨',0),(295948,8221,'ms','Penyata sebagai',0),(295949,8221,'ar','Ø¨ÙŠØ§Ù† ÙƒÙ…Ù†',0),(295950,8221,'fr','DÃ©claration comme des',0),(295951,8221,'jp','ã¨ã—ã¦ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆ',0),(295952,8221,'pt','DeclaraÃ§Ã£o como de',0),(295953,8221,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ°Ðº',0),(295954,8221,'es','DeclaraciÃ³n A Partir De',0),(295955,8221,'de','ErklÃ¤rung als',0),(295956,8221,'en','Statement As Of',0),(295957,8222,'is','',0),(295958,8222,'dr','ØªØ§Ø±ÙŠØ® ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª',0),(295959,8222,'pr','ØªØ§Ø±ÙŠØ® ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª',0),(295960,8222,'tr','Hesap kesim tarihi',0),(295961,8222,'pl','Instrukcja Data',0),(295962,8222,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(295963,8222,'ur','Ø¨ÛŒØ§Ù† Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(295964,8222,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(295965,8222,'vi','NgÃ y Sao kÃª',0),(295966,8222,'af','Staat Datum',0),(295967,8222,'ro','Data extrasului',0),(295968,8222,'et','VÃ¤javÃµtte kuupÃ¤ev',0),(295969,8222,'si','Datum izpiska',0),(295970,8222,'ba','Tanggal tagihan kartu kredit',0),(295971,8222,'nl','Afschriftdatum',0),(295972,8222,'fi','Tiliotteen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(295973,8222,'no','Utdragsdato',0),(295974,8222,'da','Kontoudtogsdato',0),(295975,8222,'ko','ê³„ì‚° ì„œ ë‚ ì§œ',0),(295976,8222,'he','×ª××¨×™×š ×”×¦×”×¨×”',0),(295977,8222,'el','Î”Î®Î»Ï‰ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚',0),(295978,8222,'zh','å£°æ˜Žæ—¥æœŸ\r\n',0),(295979,8222,'sv','Kontoutdragets datum',0),(295980,8222,'it','Istruzione data',0),(295981,8222,'tl','',0),(295982,8222,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(295983,8222,'hi','à¤¬à¤¯à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(295984,8222,'ms','Tarikh penyata',0),(295985,8222,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨ÙŠØ§Ù†',0),(295986,8222,'fr','Date de la dÃ©claration',0),(295987,8222,'jp','æ˜Žç´°æ›¸ã®æ—¥ä»˜',0),(295988,8222,'pt','Data da declaraÃ§Ã£o',0),(295989,8222,'ru','Ð”Ð°Ñ‚Ð° Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(295990,8222,'es','Fecha de DeclaraciÃ³n',0),(295991,8222,'de','Auszugsdatum',0),(295992,8222,'en','Statement Date',0),(295993,8223,'is','',0),(295994,8223,'dr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† Ø®ØµÙˆØµÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ',0),(295995,8223,'pr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† Ø®ØµÙˆØµÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ',0),(295996,8223,'tr','Ek Ã¶zellikleri etkinleÅŸtirmek',0),(295997,8223,'pl','AktywowaÄ‡ dodatkowe funkcje',0),(295998,8223,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(295999,8223,'ur','Ø§Ø¶Ø§ÙÛŒ Ø®ØµÙˆØµÛŒØ§Øª Ú©Ùˆ Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(296000,8223,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ',0),(296001,8223,'vi','KÃ­ch Hoáº¡t TÃ­nh NÄƒng Cá»™ng ThÃªm',0),(296002,8223,'af','Aktiveer Adisionele Kenmerke',0),(296003,8223,'ro','Activeaza caracteristici aditionale',0),(296004,8223,'et','Aktiveeri lisavÃµimalusi',0),(296005,8223,'si','Aktivirati dodatne funkcije',0),(296006,8223,'ba','Mengaktifkan Fitur Tambahan',0),(296007,8223,'nl','Activeer aanvullende functies',0),(296008,8223,'fi','Aktivoi lisÃ¤ominaisuuksia',0),(296009,8223,'no','Aktivere tilleggsfunksjoner',0),(296010,8223,'da','Aktivere yderligere funktioner',0),(296011,8223,'ko','ì¶”ê°€ ê¸°ëŠ¥ í™œì„±í™”',0),(296012,8223,'he','×”×¤×¢×œ ×ª×›×•× ×•×ª × ×•×¡×¤×•×ª',0),(296013,8223,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï€ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„ÎµÏ‚',0),(296014,8223,'zh','æ¿€æ´»å…¶ä»–åŠŸèƒ½\r\n',0),(296015,8223,'sv','Aktivera ytterligare funktioner',0),(296016,8223,'it','Attiva caratteristiche addizionali',0),(296017,8223,'tl','',0),(296018,8223,'th','&#3648;&#3611;&#3636;&#3604;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3621;&#3633;&#3585;&#3625;&#3603;&#3632;&#3648;&#3604;&#3656;&#3609;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(296019,8223,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¸à¥à¤µà¤¿à¤§à¤¾à¤“à¤‚ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(296020,8223,'ms','Aktifkan ciri-ciri tambahan',0),(296021,8223,'ar','ØªÙØ¹ÙŠÙ„ Ø§Ù„Ù…ÙŠØ²Ø§Øª Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(296022,8223,'fr','Activer des fonctionnalitÃ©s supplÃ©mentaires',0),(296023,8223,'jp','ãã®ä»–ã®æ©Ÿèƒ½ã‚’ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã«ã—ã¾ã™ã€‚',0),(296024,8223,'pt','Ativar recursos adicionais',0),(296025,8223,'ru','ÐÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ñ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¹',0),(296026,8223,'es','Activar CaracterÃ­sticas Adicionales',0),(296027,8223,'de','ZusÃ¤tzliche Funktionen aktivieren',0),(296028,8223,'en','Activate Additional Features',0),(296029,8224,'is','',0),(296030,8224,'dr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† Ø®ØµÙˆØµÙŠØª ',0),(296031,8224,'pr','ÙØ¹Ø§Ù„ ÙƒØ±Ø¯Ù† Ø®ØµÙˆØµÙŠØª ',0),(296032,8224,'tr','Ã–zelliÄŸi etkinleÅŸtirin',0),(296033,8224,'pl','Uaktywnij funkcjÃª',0),(296034,8224,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸ÑÑ‚Ð°',0),(296035,8224,'ur','Ø®ØµÙˆØµÛŒØª Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(296036,8224,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ',0),(296037,8224,'vi','KÃ­ch Hoáº¡t TÃ­nh NÄƒng',0),(296038,8224,'af','Aktiveer Kenmerk',0),(296039,8224,'ro','Activeaza caracteristica',0),(296040,8224,'et','Funktsiooni aktiveerimine',0),(296041,8224,'si','Aktivirati funkcijo',0),(296042,8224,'ba','Mengaktifkan Fitur',0),(296043,8224,'nl','Activeer functie',0),(296044,8224,'fi','Ota ominaisuus kÃ¤yttÃ¶Ã¶n',0),(296045,8224,'no','Aktivere funksjonen',0),(296046,8224,'da','Aktivere funktionen',0),(296047,8224,'ko','ê¸°ëŠ¥ì„ í™œì„±í™”',0),(296048,8224,'he','×”×¤×¢×œ ×ª×›×•× ×”',0),(296049,8224,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î· Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„Î±',0),(296050,8224,'zh','å¯åŠ¨åŠŸèƒ½\r\n',0),(296051,8224,'sv','Aktivera funktionen',0),(296052,8224,'it','Attiva caratteristica',0),(296053,8224,'tl','',0),(296054,8224,'th','&#3621;&#3633;&#3585;&#3625;&#3603;&#3632;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(296055,8224,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(296056,8224,'ms','Aktifkan ciri-ciri',0),(296057,8224,'ar','ØªÙØ¹ÙŠÙ„ Ø§Ù„Ù…ÙŠØ²Ø©',0),(296058,8224,'fr','Activer Fonction',0),(296059,8224,'jp','æ©Ÿèƒ½ã‚’ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã«ã—ã¾ã™ã€‚',0),(296060,8224,'pt','Ativar o recurso',0),(296061,8224,'ru','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ„ÑƒÐ½ÐºÑ†Ð¸ÑŽ',0),(296062,8224,'es','Activar CaractarÃ­stica',0),(296063,8224,'de','Feature aktivieren',0),(296064,8224,'en','Activate Feature',0),(296065,8225,'is','',0),(296066,8225,'dr','Ø§ÙƒÙ†ÙˆÙ† Ø¨Ø®Ø±ÙŠØ¯',0),(296067,8225,'pr','Ø§ÙƒÙ†ÙˆÙ† Ø¨Ø®Ø±ÙŠØ¯',0),(296068,8225,'tr','Åžimdi satÄ±n al',0),(296069,8225,'pl','Kup teraz',0),(296070,8225,'bg','ÐšÑƒÐ¿Ð¸ ÑÐµÐ³Ð°',0),(296071,8225,'ur','Ø±Ú©Ù† Ú©ÛŒ Ù†Ù…Ø§Ø¦Ù†Ø¯Û',0),(296072,8225,'sr','ÐšÑƒÐ¿Ð¸Ñ‚Ðµ ÑÐ°Ð´Ð°',0),(296073,8225,'vi','Mua bÃ¢y giá»',0),(296074,8225,'af','Koop Nou',0),(296075,8225,'ro','Cumpara acum',0),(296076,8225,'et','Osta nÃ¼Ã¼d',0),(296077,8225,'si','Kupi zdaj',0),(296078,8225,'ba','Beli sekarang',0),(296079,8225,'nl','Koop nu',0),(296080,8225,'fi','Osta nyt',0),(296081,8225,'no','KjÃ¸p nÃ¥',0),(296082,8225,'da','KÃ¸b nu',0),(296083,8225,'ko','ì§€ê¸ˆ êµ¬ë§¤',0),(296084,8225,'he','×§× ×” ×›×¢×ª',0),(296085,8225,'el','Î‘Î³Î¿ÏÎ¬ÏƒÏ„Îµ Ï„ÏŽÏÎ±',0),(296086,8225,'zh','çŽ°åœ¨è´­ä¹°\r\n',0),(296087,8225,'sv','KÃ¶p nu',0),(296088,8225,'it','Acquista ora',0),(296089,8225,'tl','',0),(296090,8225,'th','&#3595;&#3639;&#3657;&#3629;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(296091,8225,'hi','à¤…à¤¬ à¤–à¤°à¥€à¤¦à¥‡à¤‚',0),(296092,8225,'ms','Beli sekarang',0),(296093,8225,'ar','Ø§Ù„Ø´Ø±Ø§Ø¡ Ø§Ù„Ø¢Ù†',0),(296094,8225,'fr','Acheter maintenant',0),(296095,8225,'jp','ä»Šã™ãè³¼å…¥ã—ã¾ã™ã€‚',0),(296096,8225,'pt','Compre agora',0),(296097,8225,'ru','ÐšÑƒÐ¿Ð¸Ñ‚ÑŒ Ð¡ÐµÐ¹Ñ‡Ð°Ñ',0),(296098,8225,'es','Compra Ahora',0),(296099,8225,'de','Jetzt kaufen',0),(296100,8225,'en','Buy Now',0),(296101,8226,'is','',0),(296102,8226,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ ÙˆÙŠÚ˜Ú¯ÙŠ ',0),(296103,8226,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ ÙˆÙŠÚ˜Ú¯ÙŠ ',0),(296104,8226,'tr','Ã–zellik etkinleÅŸtirilirken hata oluÅŸtu',0),(296105,8226,'pl','BÅ‚Ä…d aktywacji funkcji',0),(296106,8226,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸ÑÑ‚Ð°',0),(296107,8226,'ur','ÙÛŒÚ†Ø± Ú©Ùˆ ÙØ¹Ø§Ù„ Ú©Ø± Ù†Ù‚Øµ',0),(296108,8226,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°ÑšÑƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°',0),(296109,8226,'vi','Chá»©c nÄƒng kÃ­ch hoáº¡t lá»—i',0),(296110,8226,'af','\'n Fout het ingesluip met die Aktivering van Kenmerk',0),(296111,8226,'ro','Eroare activa caracteristica',0),(296112,8226,'et','TÃµrge funktsiooni aktiveerimist',0),(296113,8226,'si','Napaka pri aktiviranju funkcija',0),(296114,8226,'ba','Kesalahan yang mengaktifkan fitur',0),(296115,8226,'nl','Kan functie niet activeren',0),(296116,8226,'fi','Virhe aktivoitaessa ominaisuus',0),(296117,8226,'no','Feil under aktivering av funksjonen',0),(296118,8226,'da','Fejl under aktivering funktion',0),(296119,8226,'ko','ê¸°ëŠ¥ì„ í™œì„±í™” í•˜ëŠ” ì˜¤ë¥˜',0),(296120,8226,'he','×©×’×™××” ×‘×”×¤×¢×œ×ª ×ª×›×•× ×”',0),(296121,8226,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï‡Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ',0),(296122,8226,'zh','é”™è¯¯æ¿€æ´»åŠŸèƒ½',0),(296123,8226,'sv','Fel aktivera funktionen',0),(296124,8226,'it','Attivando la funzione di errore',0),(296125,8226,'tl','',0),(296126,8226,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3607;&#3635;&#3651;&#3627;&#3657;&#3621;&#3633;&#3585;&#3625;&#3603;&#3632;&#3614;&#3636;&#3648;&#3624;&#3625;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3652;&#3604;&#3',0),(296127,8226,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¤¨à¥‡ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(296128,8226,'ms','Ralat yang mengaktifkan ciri-ciri',0),(296129,8226,'ar','Ø®Ø·Ø£ ÙÙŠ ØªÙØ¹ÙŠÙ„ Ø§Ù„Ù…ÙŠØ²Ø©',0),(296130,8226,'fr','Erreur activation fonction',0),(296131,8226,'jp','æ©Ÿèƒ½ã®ã‚¢ã‚¯ãƒ†ã‚£ãƒ–åŒ–ã‚¨ãƒ©ãƒ¼',0),(296132,8226,'pt','Erro de ativaÃ§Ã£o recurso',0),(296133,8226,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(296134,8226,'es','Error Activando CaracterÃ­stica',0),(296135,8226,'de','Fehler aktivieren',0),(296136,8226,'en','Error Activating Feature',0),(296137,8227,'is','',0),(296138,8227,'dr','ÙˆÙŠÚ˜Ú¯ÙŠ',0),(296139,8227,'pr','ÙˆÙŠÚ˜Ú¯ÙŠ',0),(296140,8227,'tr','Ã–zelliÄŸi',0),(296141,8227,'pl','Funkcja',0),(296142,8227,'bg','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(296143,8227,'ur','Ø®ØµÙˆØµÛŒØª',0),(296144,8227,'sr','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°',0),(296145,8227,'vi','Äáº·c tÃ­nh',0),(296146,8227,'af','Kenmerk',0),(296147,8227,'ro','Caracteristica',0),(296148,8227,'et','Funktsioon',0),(296149,8227,'si','Funkcija',0),(296150,8227,'ba','Fitur',0),(296151,8227,'nl','Functie',0),(296152,8227,'fi','Ominaisuus',0),(296153,8227,'no','Funksjonen',0),(296154,8227,'da','Funktion',0),(296155,8227,'ko','ê¸°ëŠ¥',0),(296156,8227,'he','×ª×›×•× ×”',0),(296157,8227,'el','Î§Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Î³Î½ÏŽÏÎ¹ÏƒÎ¼Î±',0),(296158,8227,'zh','ç‰¹å¾\r\n',0),(296159,8227,'sv','Funktionen',0),(296160,8227,'it','Caratteristica',0),(296161,8227,'tl','',0),(296162,8227,'th','&#3621;&#3633;&#3585;&#3625;&#3603;&#3632;&#3648;&#3604;&#3656;&#3609;',0),(296163,8227,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾',0),(296164,8227,'ms','Ciri-ciri',0),(296165,8227,'ar','Ø§Ù„Ù…ÙŠØ²Ø©',0),(296166,8227,'fr','FonctionnalitÃ©',0),(296167,8227,'jp','æ©Ÿèƒ½',0),(296168,8227,'pt','Recurso',0),(296169,8227,'ru','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(296170,8227,'es','Presentar',0),(296171,8227,'de','Feature',0),(296172,8227,'en','Feature',0),(296173,8228,'is','',0),(296174,8228,'dr','ÙˆÙŠÚ˜Ú¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ¹Ø§Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(296175,8228,'pr','ÙˆÙŠÚ˜Ú¯ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ¹Ø§Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(296176,8228,'tr','Ã–zellik baÅŸarÄ±yla etkinleÅŸtirildi',0),(296177,8228,'pl','Funkcja pomyÅ›lnie aktywowany',0),(296178,8228,'bg','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸ÑÑ‚Ð°',0),(296179,8228,'ur','ÙÛŒÚ†Ø± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§ÛŒØ§',0),(296180,8228,'sr','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½.',0),(296181,8228,'vi','KÃ­ch hoáº¡t Äáº·c tÃ­nh thÃ nh cÃ´ng',0),(296182,8228,'af','Kenmerke Suksesvol Geaktiveer',0),(296183,8228,'ro','Caracteristica activat cu succes',0),(296184,8228,'et','Edukalt aktiveeritud funktsioon',0),(296185,8228,'si','UspeÅ¡no aktivirali funkcijo',0),(296186,8228,'ba','Fitur berhasil',0),(296187,8228,'nl','Functie met succes geactiveerd',0),(296188,8228,'fi','Toiminto aktivoitu',0),(296189,8228,'no','Funksjonen aktivert',0),(296190,8228,'da','Funktion med held aktiveret',0),(296191,8228,'ko','ì„±ê³µì ìœ¼ë¡œ í™œì„±í™” í•˜ëŠ” ê¸°ëŠ¥',0),(296192,8228,'he','×”×ª×›×•× ×” ×”×•×¤×¢×œ×” ×‘×”×¦×œ×—×”',0),(296193,8228,'el','Î§Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÎµÏ€Î¹Ï„Ï…Ï‡Î·Î¼Î­Î½Î¿Ï‚ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î¿Ï‚',0),(296194,8228,'zh','æˆåŠŸæ¿€æ´»åŠŸèƒ½\r\n',0),(296195,8228,'sv','Funktionen lyckosam aktiverat',0),(296196,8228,'it','Caratteristica attivato correttamente',0),(296197,8228,'tl','',0),(296198,8228,'th','&#3585;&#3634;&#3619;&#3585;&#3619;&#3632;&#3605;&#3640;&#3657;&#3609;&#3621;&#3633;&#3585;&#3625;&#3603;&#3632;&#3648;&#3604;&#3656;&#3609;&#3648;&#3611;&#3655;&#3609;&#3612;&#3621;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(296199,8228,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤° à¤¸à¥à¤µà¤¿à¤§à¤¾',0),(296200,8228,'ms','Ciri-ciri yang berjaya diaktifkan',0),(296201,8228,'ar','ÙØ¹Ù‘Ù„Øª Ø§Ù„Ù…Ø¨Ø²Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(296202,8228,'fr','Fonction activÃ©e avec succÃ¨s',0),(296203,8228,'jp','æ©Ÿèƒ½ã‚’æ­£å¸¸ã«ã‚¢ã‚¯ãƒ†ã‚£ãƒ–åŒ–',0),(296204,8228,'pt','Recurso ativado com sucesso',0),(296205,8228,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(296206,8228,'es','Rasgo Activado Exitosamente',0),(296207,8228,'de','Funktion erfolgreich aktiviert',0),(296208,8228,'en','Feature Successfully Activated',0),(296209,8229,'is','',0),(296210,8229,'dr','( ØªØ§Ø³ÙŠØ³Ø§Øª',0),(296211,8229,'pr','Ù†Ù‡Ø§ÙŠÙŠ ÙƒØ±Ø¯Ù† Ù†ØµØ¨ ( ØªØ§Ø³ÙŠØ³Ø§Øª',0),(296212,8229,'tr','YÃ¼kleme sonuÃ§landÄ±rmak',0),(296213,8229,'pl','Finalizowanie instalacji',0),(296214,8229,'bg','Ð¤Ð¸Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸ÑÑ‚Ð°',0),(296215,8229,'ur','ØªÙ†ØµÛŒØ¨ Ú©Ùˆ Ø¢Ø®Ø±ÛŒ Ø´Ú©Ù„ Ø¯ÛŒÚº',0),(296216,8229,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ðµ',0),(296217,8229,'vi','Káº¿t thÃºc Láº¯p Ä‘áº·t',0),(296218,8229,'af','Tydens installasie',0),(296219,8229,'ro','Finaliza instalarea',0),(296220,8229,'et','LÃµpeta paigaldamine',0),(296221,8229,'si','DokonÄanje namestitve',0),(296222,8229,'ba','Menyelesaikan instalasi',0),(296223,8229,'nl','Installatie voltooien',0),(296224,8229,'fi','Viimeistele asennus',0),(296225,8229,'no','FullfÃ¸re installasjonen',0),(296226,8229,'da','FÃ¦rdiggÃ¸re installationen',0),(296227,8229,'ko','ì„¤ì¹˜ ë§ˆë¬´ë¦¬',0),(296228,8229,'he','×¡×™×™× ×”×ª×§× ×”',0),(296229,8229,'el','ÎŸÎ»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ· ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(296230,8229,'zh','æœ€åŽå®Œæˆå®‰è£…\r\n',0),(296231,8229,'sv','SlutfÃ¶ra installationen',0),(296232,8229,'it','Finalizzare l\'installazione',0),(296233,8229,'tl','',0),(296234,8229,'th','&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;&#3586;&#3633;&#3657;&#3609;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(296235,8229,'hi','à¤¸à¥à¤¥à¤¾à¤ªà¤¨à¤¾ à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª',0),(296236,8229,'ms','Melengkapkan pemasangan',0),(296237,8229,'ar','Ø¥ÙƒÙ…Ø§Ù„ Ø§Ù„ØªÙ†ØµÙŠØ¨',0),(296238,8229,'fr','Finaliser l\'Installation',0),(296239,8229,'jp','ã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«ã®æœ€çµ‚å‡¦ç†ã—ã¾ã™ã€‚',0),(296240,8229,'pt','Finalizar a instalaÃ§Ã£o',0),(296241,8229,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ Ð˜Ð½ÑÑ‚Ð°Ð»Ð»ÑÑ†Ð¸ÑŽ',0),(296242,8229,'es','Finalizar la InstalaciÃ³n',0),(296243,8229,'de','Installation abschlieÃŸen',0),(296244,8229,'en','Finalize Installation',0),(296245,8230,'is','',0),(296246,8230,'dr','12 Ù…Ø§Ù‡Ù‡',0),(296247,8230,'pr','Ø³ÙˆØ¯ Ùˆ Ø²ÛŒØ§Ù† 12 Ù…Ø§Ù‡Ù‡',0),(296248,8230,'tr','Kar & kaybÄ± - 12 aylÄ±k ',0),(296249,8230,'pl','Zysk & straty - dwunastomiesiÄ™czne ',0),(296250,8230,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð° & Ð·Ð°Ð³ÑƒÐ±Ð° - 12 Ð¼ÐµÑÐµÑ†Ð° ',0),(296251,8230,'ur','Ø³Ø§Ù„Ø§Ù†Û Ù†ÙØ¹ Ùˆ Ù†Ù‚ØµØ§Ù†',0),(296252,8230,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð°Ðº Ð¸ Ð³ÑƒÐ±Ð¸Ñ‚Ð°Ðº - 12 Ð¼ÐµÑÐµÑ†Ð¸ ',0),(296253,8230,'vi','	\r\nQuyáº¿t ToÃ¡n Lá»i Lá»— 12 ThÃ¡ng',0),(296254,8230,'af','12 Maande Wins-en-Verlies',0),(296255,8230,'ro','12 Luni Profit & Pierdere',0),(296256,8230,'et','12 kuu kasum ja kahjum',0),(296257,8230,'si','DobiÄek & izgubo - 12 mesec ',0),(296258,8230,'ba','12 Bulan Rugi & Laba',0),(296259,8230,'nl','12-maanden winst & verlies',0),(296260,8230,'fi','Voitto & tappio - 12 kuukauden ',0),(296261,8230,'no','Fortjeneste & tap - 12 mÃ¥neder ',0),(296262,8230,'da','Profit & tab - 12 mÃ¥neders ',0),(296263,8230,'ko','ì´ìµ & ì†ì‹¤-12 ê°œì›” ',0),(296264,8230,'he','×¨×•×•×— & ××•×‘×“×Ÿ - 12 ×—×•×“×©×™× ',0),(296265,8230,'el','ÎšÎ­ÏÎ´Î¿Ï‚ & Î±Ï€ÏŽÎ»ÎµÎ¹Î± - 12 Î¼Î·Î½ÏŽÎ½ ',0),(296266,8230,'zh','12ä¸ªæœˆæŸç›Š',0),(296267,8230,'sv','12-MÃ¥naders ResultatrÃ¤kning',0),(296268,8230,'it','Profitti e Spese negli ultimi 12 mesi',0),(296269,8230,'tl','labingdalawang buwan pinagkitaan at kalugihan',0),(296270,8230,'th','à¸à¸³à¹„à¸£à¸‚à¸²à¸”à¸—à¸¸à¸™à¸£à¸­à¸š 12 à¹€à¸”à¸·à¸­à¸™',0),(296271,8230,'hi','à¤²à¤¾à¤­ & à¤¹à¤¾à¤¨à¤¿ - 12 à¤®à¤¹à¥€à¤¨à¥‡ ',0),(296272,8230,'ms','Keuntungan & kerugian - 12 bulan ',0),(296273,8230,'ar','Ø§Ù„Ø£Ø±Ø¨Ø§Ø­ ÙˆØ§Ù„Ø®Ø³Ø§Ø¦Ø± Ø¹Ù† 12 Ø´Ù‡Ø±Ø§',0),(296274,8230,'fr','Profit & Perte sur 12 Mois',0),(296275,8230,'jp','åˆ©ç›Š & æå¤± - 12 æœˆ',0),(296276,8230,'pt','Lucro & perda - 12 meses ',0),(296277,8230,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ & Ð¿Ð¾Ñ‚ÐµÑ€Ð¸ - 12 Ð¼ÐµÑÑÑ†ÐµÐ² ',0),(296278,8230,'es','12 Perdidas y Ganancias / Mes',0),(296279,8230,'de','12 Monate Gewinn & Verlust',0),(296280,8230,'en','Profit & Loss - 12 Month ',0),(296281,8231,'is','',0),(296282,8231,'dr','12 Ù…Ø§Ù‡Ù‡',0),(296283,8231,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª Ø³ÙˆØ¯ Ùˆ Ø²ÛŒØ§Ù† 12 Ù…Ø§Ù‡Ù‡',0),(296284,8231,'tr','Kar ve zarar - 12 aylÄ±k ',0),(296285,8231,'pl','Zysku & straty - 12 miesiÄ™cy ',0),(296286,8231,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð° & Ð·Ð°Ð³ÑƒÐ±Ð° - 12 Ð¼ÐµÑÐµÑ†Ð° ',0),(296287,8231,'ur','Ø³Ø§Ù„Ø§Ù†Û Ù†ÙØ¹ Ùˆ Ù†Ù‚ØµØ§Ù† Ú©Ø§ Ú©Ú¾Ø§ØªØ§',0),(296288,8231,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð°Ðº Ð¸ Ð³ÑƒÐ±Ð¸Ñ‚Ð°Ðº - 12 Ð¼ÐµÑÐµÑ†Ð¸ ',0),(296289,8231,'vi','BÃ¡o CÃ¡o Lá»i Lá»— 12 ThÃ¡ng',0),(296290,8231,'af','12 Maande Wins-en-Verlies Staat',0),(296291,8231,'ro','12 Luni Declaratie Profit & Pierdere',0),(296292,8231,'et','Kasum & kahjum - 12 kuu ',0),(296293,8231,'si','DobiÄek & izgubo - 12 mesec ',0),(296294,8231,'ba','12 Bulan Laporan Rugi & Laba',0),(296295,8231,'nl','12-maanden winst & verlies verslag',0),(296296,8231,'fi','Voitto & tappio - 12 kuukauden ',0),(296297,8231,'no','Fortjeneste & tap - 12 mÃ¥neder ',0),(296298,8231,'da','Profit & tab - 12 mÃ¥neders ',0),(296299,8231,'ko','ì´ìµ ë° ì†ì‹¤-12 ê°œì›” ',0),(296300,8231,'he','×¨×•×•×— & ××•×‘×“×Ÿ - 12 ×—×•×“×©×™× ',0),(296301,8231,'el','ÎšÎ­ÏÎ´Î¿Ï‚ & Î±Ï€ÏŽÎ»ÎµÎ¹Î± - 12 Î¼Î·Î½ÏŽÎ½ ',0),(296302,8231,'zh','12ä¸ªæœˆæŸç›Šè¡¨',0),(296303,8231,'sv','12-MÃ¥naders Resultatrapport',0),(296304,8231,'it','Profitti e Spese negli ultimi 12 mesi',0),(296305,8231,'tl','labingdalawang buwan pinagkitaan at kalugihan ulat',0),(296306,8231,'th','12 à¹€à¸”à¸·à¸­à¸™ à¸£à¸²à¸¢à¸à¸²à¸£ à¸à¸³à¹„à¸£ & à¸‚à¸²à¸”à¸—à¸¸à¸™  ',0),(296307,8231,'hi','à¤²à¤¾à¤­ & à¤¨à¥à¤•à¤¸à¤¾à¤¨ - 12 à¤®à¤¹à¥€à¤¨à¥‡ ',0),(296308,8231,'ms','Keuntungan & kerugian - 12 bulan ',0),(296309,8231,'ar','ÙƒØ´Ù Ø§Ù„Ø£Ø±Ø¨Ø§Ø­ ÙˆØ§Ù„Ø®Ø³Ø§Ø¦Ø± Ø¹Ù† 12 Ø´Ù‡Ø±Ø§',0),(296310,8231,'fr','Etat de Profit & Perte sur 12 Mois',0),(296311,8231,'jp','12 æœˆæç›Š -',0),(296312,8231,'pt','Lucro e perda - 12 meses ',0),(296313,8231,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ & Ð¿Ð¾Ñ‚ÐµÑ€Ð¸ - 12 Ð¼ÐµÑÑÑ†ÐµÐ² ',0),(296314,8231,'es','12 Informe de Perdidas y Ganancias / Mes',0),(296315,8231,'de','Gewinn & Verlust - 12 Monate ',0),(296316,8231,'en','Profit & Loss - 12 Month ',0),(296317,8232,'is','',0),(296318,8232,'dr','Ø§ÙŠÙ† ÙŠÙƒ Ø®Ø§ØµÙŠØª Ø§ÙØ²ÙˆØ¯Ù†ÙŠ  Ø§Ø³Øª ÙƒÙ‡ Ù†ÙŠØ§Ø² Ø¨Ù‡ ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ø¯Ø§Ø±Ø¯ ',0),(296319,8232,'pr','Ø§ÙŠÙ† ÙŠÙƒ Ø®Ø§ØµÙŠØª Ø§ÙØ²ÙˆØ¯Ù†ÙŠ  Ø§Ø³Øª ÙƒÙ‡ Ù†ÙŠØ§Ø² Ø¨Ù‡ ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ø¯Ø§Ø±Ø¯ ',0),(296320,8232,'tr','Bu, etkinleÅŸtirme yapÄ±lmasÄ± gerekmeden bir eklenti Ã¶zelliÄŸidir',0),(296321,8232,'pl','Jest to cecha dodatek wymaga aktywacji',0),(296322,8232,'bg','Ð¢Ð¾Ð²Ð° Ðµ ÐµÐ´Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÐºÐ° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ, ÐºÐ¾ÑÑ‚Ð¾ Ð¸Ð·Ð¸ÑÐºÐ²Ð° Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ',0),(296323,8232,'ur','ÛŒÛ Ø§ÛŒÚ© Ø¨Ø±-Ø§ Ø¶Ø§ÙÛ Ø®ØµÙˆØµÛŒØª Ø§ÛŒÚ©Ù¹ÛŒÙˆÛŒØ´Ù† Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÙˆØªÛŒ ÛÛ’',0),(296324,8232,'sr','ÐžÐ²Ð¾ Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð°Ðº Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° ÐºÐ¾Ñ˜Ðµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°Ñ˜Ñƒ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°ÑšÐµ',0),(296325,8232,'vi','ÄÃ¢y lÃ  tÃ­nh nÄƒng cá»™ng thÃªm. Cáº§n pháº£i kÃ­ch hoáº¡t',0),(296326,8232,'af','Hierdie is \'n Byvoegingskenmerk en Benodig Aktivering',0),(296327,8232,'ro','Aceasta este o caracteristicÄƒ de supliment care necesitÄƒ activare',0),(296328,8232,'et','See on lisandmooduli funktsioon nÃµuab aktiveerimine',0),(296329,8232,'si','To je poveÄati-naprej zunanja oblika, ki zahtevajo aktiviranje',0),(296330,8232,'ba','Ini adalah fitur Add-On yang memerlukan aktivasi',0),(296331,8232,'nl','Dit Is een Add-On functie waarvoor activering',0),(296332,8232,'fi','TÃ¤mÃ¤ on rekisterÃ¶itÃ¤vÃ¤ Add-On-toiminto',0),(296333,8232,'no','Dette er en Add-On-funksjon som krever aktivering',0),(296334,8232,'da','Dette er en tilfÃ¸jelse funktion krÃ¦ver aktivering',0),(296335,8232,'ko','ì´ê²ƒì€ ì •í’ˆ ì¸ì¦ì„ ìš”êµ¬ í•˜ëŠ” ì¶”ê°€ ê¸°ëŠ¥',0),(296336,8232,'he','×–×•×”×™ ×ª×›×•× ×” ×”×¨×—×‘×” ×©× ×“×¨×©×ª ×”×¤×¢×œ×”',0),(296337,8232,'el','Î‘Ï…Ï„ÏŒ ÎµÎ¯Î½Î±Î¹ Î­Î½Î± Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î¿ Ï‡Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½ Ï„Î·Î½ ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(296338,8232,'zh','è¿™æ˜¯ä¸€é¡¹éœ€è¦æ¿€æ´»çš„å¢žåŠ åŠŸèƒ½\r\n',0),(296339,8232,'sv','Detta Ã¤r ett tillÃ¤gg funktion som krÃ¤ver aktivering',0),(296340,8232,'it','Questa Ã¨ una caratteristica del componente aggiuntivo che richiede l\'attivazione',0),(296341,8232,'tl','',0),(296342,8232,'th','&#3652;&#3604;&#3657;&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3651;&#3594;&#3657;&#3591;&#3634;&#3',0),(296343,8232,'hi','à¤¯à¤¹ à¤à¤• à¤à¤¡-à¤‘à¤¨ à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤¸à¤•à¥à¤°à¤¿à¤¯à¤£ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥‹à¤¤à¥€ à¤¹à¥ˆ',0),(296344,8232,'ms','Ini adalah ciri-ciri tambahan untuk yang memerlukan pengaktifan',0),(296345,8232,'ar','Ù‡Ø°Ø§ Ù‡Ùˆ Ø¥Ø­Ø¯Ù‰ Ù…ÙŠØ²Ø§Øª Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø¥Ø¶Ø§ÙÙŠØ© Ø§Ù„ØªÙŠ ØªØªØ·Ù„Ø¨ Ø§Ù„ØªÙ†Ø´ÙŠØ·',0),(296346,8232,'fr','Il s\'agit d\'une fonction ajoutÃ©e nÃ©cessitant une Activation',0),(296347,8232,'jp','ã“ã‚Œã¯ã€ã‚¢ãƒ‰ã‚ªãƒ³æ©Ÿèƒ½ã®æ´»æ€§åŒ–ã‚’å¿…è¦ã¨ã—ã¾ã™ã€‚',0),(296348,8232,'pt','Esta Ã© uma caracterÃ­stica de complemento, que exigem a ativaÃ§Ã£o',0),(296349,8232,'ru','Ð­Ñ‚Ð¾ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ð¸',0),(296350,8232,'es','Ã‰ste es una CaracterÃ­stica Add-on que se Requiere ActivaciÃ³n',0),(296351,8232,'de','Dies ist eine Add-on-Funktion erfordert Aktivierung',0),(296352,8232,'en','This Is An Add-On Feature Requiring Activation',0),(296353,8233,'is','',0),(296354,8233,'dr','Ø¹Ø¯Ø¯ ØµÙØ± Ø±Ø§ Ø¨Ø±Ø§ÙŠ ØªØ¹ÙŠÙŠÙ† Ø®ÙˆØ¯ÙƒØ§Ø± Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯ ',0),(296355,8233,'pr','Ø¹Ø¯Ø¯ ØµÙØ± Ø±Ø§ Ø¨Ø±Ø§ÙŠ ØªØ¹ÙŠÙŠÙ† Ø®ÙˆØ¯ÙƒØ§Ø± Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯ ',0),(296356,8233,'tr','SÄ±fÄ±r otomatik atamak iÃ§in bÄ±rakÄ±n',0),(296357,8233,'pl','Pozostaw zera do automatycznego przypisywania',0),(296358,8233,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð½ÑƒÐ»Ð° Ð·Ð° Ð°Ð²Ñ‚Ð¾-Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(296359,8233,'ur','ØµÙØ± Ø®ÙˆØ¯ ØªÙÙˆÛŒØ¶ Ú©Ø±Ù†Ø§ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(296360,8233,'sr','ÐžÑÑ‚Ð°Ð²Ð¸ Ð½ÑƒÐ»Ð° Ð·Ð° Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð´Ð¾Ð´ÐµÑ™Ð¸Ð²Ð°ÑšÐµ',0),(296361,8233,'vi','Äá»ƒ Zero cho tá»± Ä‘á»™ng chá»‰ Ä‘á»‹nh',0),(296362,8233,'af','Laat nul Outo-opdra',0),(296363,8233,'ro','LÄƒsaÅ£i Zero la Auto-atribui',0),(296364,8233,'et','JÃ¤tke Auto-mÃ¤Ã¤ratav null',0),(296365,8233,'si','NiÄ do Auto-dodelijo pustite',0),(296366,8233,'ba','Meninggalkan nol menugaskan secara otomatis',0),(296367,8233,'nl','Verlaten van nul tot Auto-toewijzen',0),(296368,8233,'fi','Erota Zero automaattinen Assign',0),(296369,8233,'no','La null til Auto-tildele',0),(296370,8233,'da','Forlade nul til Auto-Tildel',0),(296371,8233,'ko','ìžë™ í• ë‹¹ì„ ë‘ê³  0',0),(296372,8233,'he','×œ×”×©××™×¨ ××¤×¡ ×›×“×™ ×œ×”×§×¦×•×ª ××•×˜×•×ž×˜×™×ª',0),(296373,8233,'el','Auto-Î½Î± ÎµÎºÏ‡Ï‰ÏÎ®ÏƒÎµÎ¹ Î¬Î´ÎµÎ¹Î± Î¼Î·Î´Î­Î½',0),(296374,8233,'zh','ç•™é›¶åˆ°è‡ªåŠ¨åˆ†é…\r\n',0),(296375,8233,'sv','LÃ¤mna noll till Auto-tilldela',0),(296376,8233,'it','Lasciare a Zero per assegnazione automatica',0),(296377,8233,'tl','',0),(296378,8233,'th','&#3648;&#3623;&#3657;&#3609;&#3652;&#3623;&#3657;&#3651;&#3627;&#3657;&#3648;&#3611;&#3655;&#3609;&#3624;&#3641;&#3609;&#3618;&#3660;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3635;&#3627;&#3609;&#3604;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3',0),(296379,8233,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤‘à¤Ÿà¥‹-à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‹',0),(296380,8233,'ms','Meninggalkan sifar untuk Auto-peruntukkan',0),(296381,8233,'ar','ØªØ±Ùƒ Ø§Ù„ØµÙØ± Ù„Ù„Ø³ÙŠØ§Ø±Ø§Øª-ØªØ¹ÙŠÙŠÙ†',0),(296382,8233,'fr','Laisser zÃ©ro d\'affecter automatiquement',0),(296383,8233,'jp','è‡ªå‹•å‰²ã‚Šå½“ã¦ã« 0 ã®ã¾ã¾ã«',0),(296384,8233,'pt','Deixar Zero para atribuir automaticamente',0),(296385,8233,'ru','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð»ÑŒ Ð´Ð»Ñ Ð°Ð²Ñ‚Ð¾ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(296386,8233,'es','Dejar en Zeros para Auto-Asignar',0),(296387,8233,'de','Zero To automatisch zuweisen lassen',0),(296388,8233,'en','Leave Zero To Auto-Assign',0),(296389,8234,'is','',0),(296390,8234,'dr','ÙƒØ¯Ø§Ù… ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(296391,8234,'pr','ÙƒØ¯Ø§Ù… ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(296392,8234,'tr','Hangi Ã¶ÄŸeleri ekle',0),(296393,8234,'pl','Zawiera elementy, ktÃ³re',0),(296394,8234,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÐºÐ¾Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(296395,8234,'ur','Ø¬Ùˆ Ø§Ø´ÛŒØ§Ø¡ Ù…ÛŒÚº Ø´Ø§Ù…Ù„',0),(296396,8234,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ ÐºÐ¾Ñ˜Ðµ',0),(296397,8234,'vi','Bao gá»“m hÃ ng nÃ o',0),(296398,8234,'af','Ingesluit Met Items',0),(296399,8234,'ro','Include elemente care',0),(296400,8234,'et','Hulka kuuluvad Ã¼ksused',0),(296401,8234,'si','VkljuÄujejo elemente, ki',0),(296402,8234,'ba','Termasuk item yang',0),(296403,8234,'nl','Welke Items worden opgenomen',0),(296404,8234,'fi','SisÃ¤llytÃ¤ nimikkeet',0),(296405,8234,'no','Inkluder elementer',0),(296406,8234,'da','Medtage elementer, som',0),(296407,8234,'ko','í•­ëª© í¬í•¨',0),(296408,8234,'he','×›×œ×•×œ ×¤×¨×™×˜×™×',0),(296409,8234,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï€Î¿Î¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(296410,8234,'zh','åŒ…æ‹¬å“ªäº›é¡¹ç›®\r\n',0),(296411,8234,'sv','Inkludera vilka objekt',0),(296412,8234,'it','Includere gli elementi che',0),(296413,8234,'tl','',0),(296414,8234,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3627;&#3609;',0),(296415,8234,'hi','à¤œà¥‹ à¤†à¤‡à¤Ÿà¤® à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(296416,8234,'ms','Meliputi perkara-perkara yang',0),(296417,8234,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„ØªÙŠ',0),(296418,8234,'fr','Inclure les Ã©lÃ©ments',0),(296419,8234,'jp','ã©ã®é …ç›®ã‚’å«ã‚ã‚‹',0),(296420,8234,'pt','Incluir os itens',0),(296421,8234,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ ÐšÐ°ÐºÐ¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ñ‹',0),(296422,8234,'es','Incluir Cuales Items',0),(296423,8234,'de','Welche Elemente gehÃ¶ren',0),(296424,8234,'en','Include Which Items',0),(296425,8235,'is','',0),(296426,8235,'dr','(Ù‡Ø²ÙŠÙ†Ù‡',0),(296427,8235,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† Ù‚ÙŠÙ…Øª(Ù‡Ø²ÙŠÙ†Ù‡',0),(296428,8235,'tr','HiÃ§bir maliyeti olan maddeler',0),(296429,8235,'pl','Elementy bez Å¼adnych kosztÃ³w',0),(296430,8235,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð±ÐµÐ· Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(296431,8235,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©Ø³ÛŒ Ù‚ÛŒÙ…Øª Ú©Û’ Ø³Ø§ØªÚ¾',0),(296432,8235,'sr','ÐÐµÐ¼Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ',0),(296433,8235,'vi','HÃ ng khÃ´ng cÃ³ giÃ¡ thÃ nh',0),(296434,8235,'af','Items Met Geen Koste',0),(296435,8235,'ro','Elementele cu nici un Cost',0),(296436,8235,'et','Ãœksused, mis ei kulu',0),(296437,8235,'si','Elementi brez stroÅ¡kov',0),(296438,8235,'ba','Item dengan tanpa biaya',0),(296439,8235,'nl','Onderdelen met geen kosten',0),(296440,8235,'fi','Nimikkeet ilman kustannuksia',0),(296441,8235,'no','Elementer uten kostnad',0),(296442,8235,'da','Varer uden omkostninger',0),(296443,8235,'ko','ë¹„ìš© í•­ëª©',0),(296444,8235,'he','×¤×¨×™×˜×™× ×œ×œ× ×ž×—×™×¨',0),(296445,8235,'el','Î‘Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î± Î¼Îµ ÎºÎ±Î½Î­Î½Î± ÎºÏŒÏƒÏ„Î¿Ï‚',0),(296446,8235,'zh','æ²¡æœ‰æˆæœ¬çš„é¡¹ç›®\r\n',0),(296447,8235,'sv','TrÃ¤ffar med utan kostnad',0),(296448,8235,'it','Oggetti con nessun costo',0),(296449,8235,'tl','',0),(296450,8235,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(296451,8235,'hi','à¤•à¥‹à¤ˆ à¤²à¤¾à¤—à¤¤ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤‡à¤Ÿà¤®',0),(296452,8235,'ms','Item dengan tanpa sebarang kos',0),(296453,8235,'ar','Ø£ØµÙ†Ø§Ù Ø¨ÙˆÙ† ØªÙƒÙ„ÙØ©',0),(296454,8235,'fr','Ã‰lÃ©ments sans frais',0),(296455,8235,'jp','ã‚³ã‚¹ãƒˆé …ç›®',0),(296456,8235,'pt','Itens sem custo',0),(296457,8235,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð±ÐµÐ· ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸',0),(296458,8235,'es','Items Sin Costo',0),(296459,8235,'de','Elemente ohne Kosten',0),(296460,8235,'en','Items With No Cost',0),(296461,8236,'is','',0),(296462,8236,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(296463,8236,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(296464,8236,'tr','SatÄ±cÄ± ile Ã¶ÄŸeleri',0),(296465,8236,'pl','Elementy z nie dostawcy',0),(296466,8236,'bg','ÐžÐ±ÐµÐºÑ‚Ð¸ Ñ Ð½ÑÐ¼Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(296467,8236,'ur','Ø§Ø´ÛŒØ§Ø¡ Ù†ÛÛŒÚº ÙˆÛŒÙ†ÚˆØ± Ú©Û’ Ø³Ø§ØªÚ¾',0),(296468,8236,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ ÑÐ° Ð½ÐµÐ¼Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(296469,8236,'vi','HÃ ng khÃ´ng cÃ³ ngÆ°á»i bÃ¡n',0),(296470,8236,'af','Item Sonder enige Verskaffers',0),(296471,8236,'ro','Elementele cu nici un furnizor',0),(296472,8236,'et','Ãœksused, mis ei ole hankija',0),(296473,8236,'si','Elemente z brez dobavitelja',0),(296474,8236,'ba','Item dengan Vendor tidak',0),(296475,8236,'nl','Onderdelen met geen leverancier',0),(296476,8236,'fi','Nimikkeet, joilla ei ole toimittajan',0),(296477,8236,'no','Elementer med ingen leverandÃ¸rer',0),(296478,8236,'da','Elementer med ingen leverandÃ¸r',0),(296479,8236,'ko','í•­ëª© ì—†ìŒ ê³µê¸‰ ì—…ì²´',0),(296480,8236,'he','×¤×¨×™×˜×™× ×œ×œ× ×¡×¤×§',0),(296481,8236,'el','Î‘Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î± Î¼Îµ ÎºÎ±Î¼Î¯Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(296482,8236,'zh','æ²¡æœ‰ä¾›åº”å•†çš„é¡¹ç›®\r\n',0),(296483,8236,'sv','TrÃ¤ffar med ingen leverantÃ¶r',0),(296484,8236,'it','Oggetti con nessun fornitore',0),(296485,8236,'tl','',0),(296486,8236,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(296487,8236,'hi','à¤•à¥‹à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤‡à¤Ÿà¤®',0),(296488,8236,'ms','Item dengan penjual tiada',0),(296489,8236,'ar','Ø£ØµÙ†Ø§Ù Ø¨Ø¯ÙˆÙ† Ù…ÙˆØ±Ù‘Ø¯',0),(296490,8236,'fr','Articles avec aucun fournisseur',0),(296491,8236,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®ã‚¢ã‚¤ãƒ†ãƒ ',0),(296492,8236,'pt','Itens com nenhum fornecedor',0),(296493,8236,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ñ Ð±ÐµÐ· Ð°Ð±Ð¾Ð½ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(296494,8236,'es','Items Sin Proveeedor',0),(296495,8236,'de','Teile mit mehr als Anbieter',0),(296496,8236,'en','Items With No Vendor',0),(296497,8237,'is','',0),(296498,8237,'dr','Ø¨Ø¯ÙˆÙ† Ù‡Ø²ÙŠÙ†Ù‡ ÙŠØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡  ',0),(296499,8237,'pr','Ø¨Ø¯ÙˆÙ† Ù‡Ø²ÙŠÙ†Ù‡ ÙŠØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡  ',0),(296500,8237,'tr','Herhangi bir maliyet veya satÄ±cÄ±',0),(296501,8237,'pl','Nie kosztÃ³w lub dostawcy',0),(296502,8237,'bg','Ð‘ÐµÐ· Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¸Ð»Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(296503,8237,'ur','Ú©ÙˆØ¦ÛŒ Ù‚ÛŒÙ…Øª ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(296504,8237,'sr','ÐÐµÐ¼Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(296505,8237,'vi','KhÃ´ng giÃ¡ thÃ nh hay ngÆ°á»i bÃ¡n',0),(296506,8237,'af','Geen koste of handelaar',0),(296507,8237,'ro','Nici un Cost sau furnizor',0),(296508,8237,'et','Tasuta vÃµi hankija',0),(296509,8237,'si','Brez stroÅ¡kov ali dobavitelja',0),(296510,8237,'ba','Tidak ada biaya atau Vendor',0),(296511,8237,'nl','Geen kosten of leverancier',0),(296512,8237,'fi','MitÃ¤Ã¤n kuluja tai toimittajan',0),(296513,8237,'no','Ingen kostnader eller leverandÃ¸r',0),(296514,8237,'da','Ingen omkostninger eller leverandÃ¸r',0),(296515,8237,'ko','ë¹„ìš© ë˜ëŠ” ê³µê¸‰ ì—…ì²´',0),(296516,8237,'he','××™×Ÿ ×ž×—×™×¨ ××• ×¡×¤×§',0),(296517,8237,'el','ÎšÎ±Î½Î­Î½Î± ÎºÏŒÏƒÏ„Î¿Ï‚ Î® Ï„Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(296518,8237,'zh','æ²¡æœ‰æˆæœ¬æˆ–ä¾›åº”å•†\r\n',0),(296519,8237,'sv','Utan kostnad eller leverantÃ¶r',0),(296520,8237,'it','Nessun costo o fornitore',0),(296521,8237,'tl','',0),(296522,8237,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3627;&#3619;&#3639;&#3629;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(296523,8237,'hi','à¤•à¥‹à¤ˆ à¤²à¤¾à¤—à¤¤ à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(296524,8237,'ms','Tiada kos atau penjual.',0),(296525,8237,'ar','Ù„Ø§ ØªÙƒÙ„ÙØ© Ø£Ùˆ Ù…ÙˆØ±Ø¯',0),(296526,8237,'fr','Sans frais ni vendeur',0),(296527,8237,'jp','ã‚³ã‚¹ãƒˆã‚„ãƒ™ãƒ³ãƒ€ãƒ¼',0),(296528,8237,'pt','Sem custo ou fornecedor',0),(296529,8237,'ru','Ð‘ÐµÐ· Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð² Ð¸Ð»Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(296530,8237,'es','Ningun Costo Ni Proveedor',0),(296531,8237,'de','Keine Kosten oder Hersteller',0),(296532,8237,'en','No Cost Or Vendor',0),(296533,8238,'is','',0),(296534,8238,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )   ÙƒÙ…ØªØ± Ø§Ø² Ú†Ùƒ ',0),(296535,8238,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )   ÙƒÙ…ØªØ± Ø§Ø² Ú†Ùƒ ',0),(296536,8238,'tr','Mevduat miktarÄ± onay daha az',0),(296537,8238,'pl','WpÅ‚aty kwoty mniejszej niÅ¼ wyboru',0),(296538,8238,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÑƒÐ¼Ð°, Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(296539,8238,'ur','Ú†ÛŒÚ© Ø§Ù† Ø³Û’ Ú©Ù… Ø±Ù‚Ù… Ø¬Ù…Ø¹',0),(296540,8238,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¸Ð·Ð½Ð¾Ñ Ð¼Ð°ÑšÐ¸ Ð¾Ð´ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(296541,8238,'vi','Sá»‘ tiá»n cá»c Ã­t hÆ¡n tiá»n khÃ¡ch hÃ ng thanh toÃ¡n',0),(296542,8238,'af','Deposito Bedrag is Minder as Tjek',0),(296543,8238,'ro','DepuneÅ£i suma la mai puÅ£in de verificare',0),(296544,8238,'et','Deposiidi summa vÃ¤iksem sisse',0),(296545,8238,'si','Depozit znesek manj kot preverite',0),(296546,8238,'ba','Deposit jumlah kurang dari Check',0),(296547,8238,'nl','Bedrag storten dat minder dan Check',0),(296548,8238,'fi','Tallettaa summan alle uloskirjautuminen',0),(296549,8238,'no','InnbetalingsbelÃ¸pet mindre enn sjekk',0),(296550,8238,'da','Indbetal belÃ¸bet mindre end kontrol',0),(296551,8238,'ko','í‘œ ë³´ë‹¤ ì ì€ ê¸ˆì•¡ì„ ìž…ê¸ˆ',0),(296552,8238,'he','×œ×”×¤×§×™×“ ×¡×›×•× ×¤×—×•×ª ×ž××©×¨ ×œ×‘×“×•×§',0),(296553,8238,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï€Î¿ÏƒÎ¿Ï Î»Î¹Î³ÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(296554,8238,'zh','å­˜æ¬¾æ¬¾é¢å°‘äºŽæ”¯ç¥¨\r\n',0),(296555,8238,'sv','Deponera belopp mindre Ã¤n Check',0),(296556,8238,'it','Deposito di importo inferiore al Check',0),(296557,8238,'tl','',0),(296558,8238,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3594;&#3655;&#3588;',0),(296559,8238,'hi','à¤šà¥‡à¤• à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾ à¤®à¥‡à¤‚ à¤•à¤® à¤°à¤¾à¤¶à¤¿ à¤œà¤®à¤¾',0),(296560,8238,'ms','Deposit amaun kurang daripada Daftar',0),(296561,8238,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ø¨Ù„Øº Ø£Ù‚Ù„ Ù…Ù† Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(296562,8238,'fr','DÃ©poser le montant moins de cocher',0),(296563,8238,'jp','ãƒã‚§ãƒƒã‚¯ã‚ˆã‚Šã‚‚å°‘ãªã„é‡‘é¡ã‚’å…¥é‡‘ã—ã¾ã™ã€‚',0),(296564,8238,'pt','Depositar a quantidade menos de seleÃ§Ã£o',0),(296565,8238,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¼ÐµÐ½ÐµÐµ Ñ‡ÐµÐ¼ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ',0),(296566,8238,'es','Monto de DepÃ³sito Menos que el Cheque',0),(296567,8238,'de','Betrag weniger als Check',0),(296568,8238,'en','Deposit Amount Less Than Check',0),(296569,8239,'is','',0),(296570,8239,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ø¨Ø±Ø§ÙŠ ',0),(296571,8239,'pr','Ù†ÙˆØ´ØªÙ† Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ (Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ø¨Ø±Ø§ÙŠ ',0),(296572,8239,'tr','Mevduat onay iÃ§in yazmak',0),(296573,8239,'pl','Napisz SprawdÅº depozyt',0),(296574,8239,'bg','ÐÐ°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð°',0),(296575,8239,'ur','Ø¬Ù…Ø¹ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Û’ Ù„ÛŒÛ’ Ù„Ú©Ú¾ØªÛ’ ÛÛŒÚº Û”',0),(296576,8239,'sr','ÐÐ°Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð·Ð°',0),(296577,8239,'vi','Viáº¿t SÃ©c Ghi Ná»£ cho',0),(296578,8239,'af','Skryf Tjek Deposito Vir',0),(296579,8239,'ro','Scrie depozit pentru CEC',0),(296580,8239,'et','Write Deposit Check For',0),(296581,8239,'si','Napisati vloga Äek za',0),(296582,8239,'ba','Menulis cek Deposit',0),(296583,8239,'nl','Storting Check voor schrijven',0),(296584,8239,'fi','Kirjoita talletus Tarkista',0),(296585,8239,'no','Skrive innskudd sjekk For',0),(296586,8239,'da','Skrive depositum Check For',0),(296587,8239,'ko','ìž…ê¸ˆ í™•ì¸ ìž‘ì„±',0),(296588,8239,'he','×œ×¨×©×•× ×¦\'×§ ×¤×™×§×“×•×Ÿ ×¢×‘×•×¨',0),(296589,8239,'el','Î“ÏÎ¬ÏˆÏ„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ»Î­Î³Ï‡Ï‰ Î³Î¹Î±',0),(296590,8239,'zh','å†™å­˜æ¬¾æ”¯ç¥¨\r\n',0),(296591,8239,'sv','Skriv insÃ¤ttning Check fÃ¶r',0),(296592,8239,'it','Deposito assegno per',0),(296593,8239,'tl','',0),(296594,8239,'th','&#3648;&#3586;&#3637;&#3618;&#3609;&#3648;&#3594;&#3655;&#3588;&#3613;&#3634;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(296595,8239,'hi','à¤²à¤¿à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤®à¤¾ à¤šà¥‡à¤•',0),(296596,8239,'ms','Menulis semak Deposit',0),(296597,8239,'ar','ÙƒØªØ§Ø¨Ø© Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø¥ÙŠØ¯Ø§Ø¹',0),(296598,8239,'fr','Faire chÃ¨que de dÃ©pÃ´t pour',0),(296599,8239,'jp','ãƒ‡ãƒã‚¸ãƒƒãƒˆã®ãƒã‚§ãƒƒã‚¯ã‚’æ›¸ã',0),(296600,8239,'pt','Cheque o depÃ³sito dos',0),(296601,8239,'ru','Ð’Ñ‹Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ñ‡ÐµÐº Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð´Ð»Ñ',0),(296602,8239,'es','Escribir depÃ³sito para',0),(296603,8239,'de','Einzahlung Scheck fÃ¼r',0),(296604,8239,'en','Write Deposit Check For',0),(296605,8240,'is','',0),(296606,8240,'dr','Ø³Ø§Ù†ØªÙŠÚ¯Ø±Ø§Ø¯',0),(296607,8240,'pr','Ø³Ø§Ù†ØªÙŠÚ¯Ø±Ø§Ø¯',0),(296608,8240,'tr','Santigrat',0),(296609,8240,'pl','Celsjusza',0),(296610,8240,'bg','Ð¦ÐµÐ»Ð·Ð¸Ð¹',0),(296611,8240,'ur','Ø³ÛŒÙ†Ù¹ÛŒ Ú¯Ø±ÛŒÚˆ',0),(296612,8240,'sr','Ð¦.',0),(296613,8240,'vi','TrÄƒm Ä‘á»™',0),(296614,8240,'af','Celsius',0),(296615,8240,'ro','Celsius',0),(296616,8240,'et','Celsiuse jÃ¤rgi',0),(296617,8240,'si','Celzija',0),(296618,8240,'ba','Celcius',0),(296619,8240,'nl','Celsius',0),(296620,8240,'fi','Celsius',0),(296621,8240,'no','Celsius',0),(296622,8240,'da','Celsius',0),(296623,8240,'ko','ì„­ì”¨',0),(296624,8240,'he','×¦×œ×–×™×•×¡',0),(296625,8240,'el','ÎšÎµÎ»ÏƒÎ¯Î¿Ï…',0),(296626,8240,'zh','æ‘„æ°\r\n',0),(296627,8240,'sv','Celsius',0),(296628,8240,'it','Centigradi',0),(296629,8240,'tl','',0),(296630,8240,'th','&#3585;&#3634;&#3619;&#3623;&#3633;&#3604;&#3629;&#3640;&#3603;&#3627;&#3616;&#3641;&#3617;&#3636;&#3649;&#3610;&#3610;&#3648;&#3595;&#3609;&#3605;&#3636;&#3648;&#3585;&#3619;&#3604;',0),(296631,8240,'hi','à¤¸à¥‡à¤‚à¤Ÿà¥€à¤—à¥à¤°à¥‡à¤¡',0),(296632,8240,'ms','Selsius',0),(296633,8240,'ar','Ù…Ø¦ÙˆÙŠØ©',0),(296634,8240,'fr','Centigrade',0),(296635,8240,'jp','ã‚»æ°æ¸©åº¦è¨ˆ',0),(296636,8240,'pt','CentÃ­grados',0),(296637,8240,'ru','Ð¦ÐµÐ»ÑŒÑÐ¸Ñ',0),(296638,8240,'es','CentÃ­grado',0),(296639,8240,'de','Celsius',0),(296640,8240,'en','Centigrade',0),(296641,8241,'is','',0),(296642,8241,'dr','Ø³Ø§Ø¹Ø§Øª Ù¾ÙŠØ´ Ø±Ùˆ ÙŠØ§  Ú¯Ø°Ø´ØªÙ‡',0),(296643,8241,'pr','Ø³Ø§Ø¹Ø§Øª Ù¾ÙŠØ´ Ø±Ùˆ ÙŠØ§  Ú¯Ø°Ø´ØªÙ‡',0),(296644,8241,'tr','Saat Ã¶nde veya arkada',0),(296645,8241,'pl','Godziny przed lub za',0),(296646,8241,'bg','Ð§Ð°ÑÐ° Ð½Ð°Ð¿Ñ€ÐµÐ´ Ð¸Ð»Ð¸ Ð½Ð°Ð·Ð°Ð´',0),(296647,8241,'ur','Ú¯Ú¾Ù†Ù¹Û’ Ø¢Ú¯Û’ ÛŒØ§ Ù¾ÛŒÚ†Ú¾Û’',0),(296648,8241,'sr','Ð¡Ð°Ñ‚Ð¸ Ð¸ÑÐ¿Ñ€ÐµÐ´ Ð¸Ð»Ð¸ Ð¸Ð·Ð° Ð½Ð°Ñ',0),(296649,8241,'vi','Máº¥y giá» sáº¯p tá»›i hay sau',0),(296650,8241,'af','Ure Vooruit of Agter',0),(296651,8241,'ro','Ore Ã®nainte sau Ã®n spatele',0),(296652,8241,'et','Tundi ees vÃµi taga',0),(296653,8241,'si','Delovni Äas spredaj ali zadaj',0),(296654,8241,'ba','Jam di depan atau di belakang',0),(296655,8241,'nl','Uur vooruit of achter',0),(296656,8241,'fi','Tuntia edellÃ¤ tai jÃ¤ljessÃ¤',0),(296657,8241,'no','Timer foran eller bak',0),(296658,8241,'da','Timer foran eller bag',0),(296659,8241,'ko','ì‹œê°„ ì•ž ë˜ëŠ” ë’¤ì—',0),(296660,8241,'he','×©×¢×•×ª ×§×“×™×ž×” ××• ×ž××—×•×¨',0),(296661,8241,'el','ÎÏÎµÏ‚ Î¼Ï€ÏÎ¿ÏƒÏ„Î¬ Î® Ï€Î¯ÏƒÏ‰',0),(296662,8241,'zh','æ—¶é—´æå‰æˆ–è½åŽ\r\n',0),(296663,8241,'sv','Timmar framÃ¥t eller bakÃ¥t',0),(296664,8241,'it','Ore avanti o dietro',0),(296665,8241,'tl','',0),(296666,8241,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3651;&#3609;&#3629;&#3609;&#3634;&#3588;&#3605;&#3627;&#3619;&#3639;&#3629;&#3629;&#3604;&#3637;&#3605;',0),(296667,8241,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤†à¤—à¥‡ à¤¯à¤¾ à¤ªà¥€à¤›à¥‡',0),(296668,8241,'ms','Jam di hadapan atau di belakang',0),(296669,8241,'ar',' ÙØ±Ù‚ Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø¹Ù† ',0),(296670,8241,'fr','Heures Ã  l\'avance ou Behind',0),(296671,8241,'jp','æ™‚é–“å‰ã¾ãŸã¯å¾Œã‚ã«',0),(296672,8241,'pt','Horas em frente ou para trÃ¡s',0),(296673,8241,'ru','Ð§Ð°ÑÐ¾Ð² Ð²Ð¿ÐµÑ€ÐµÐ´Ð¸ Ð¸Ð»Ð¸ ÑÐ·Ð°Ð´Ð¸',0),(296674,8241,'es','Horas en Adelante o AtrÃ¡s',0),(296675,8241,'de','Stunden vor oder hinter',0),(296676,8241,'en','Hours Ahead Or Behind',0),(296677,8242,'is','',0),(296678,8242,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ØªÙˆØ¶ÙŠØ­ Ø¨Ø¨ÙŠÙ†ÙŠØ¯',0),(296679,8242,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ØªÙˆØ¶ÙŠØ­ Ø¨Ø¨ÙŠÙ†ÙŠØ¯',0),(296680,8242,'tr','Bkz: yardÄ±m iÃ§in aÃ§Ä±klama',0),(296681,8242,'pl','Zobacz Pomoc dla wyjaÅ›nienia',0),(296682,8242,'bg','Ð’Ð¸Ð¶Ñ‚Ðµ Ð¿Ð¾Ð¼Ð¾Ñ‰Ñ‚Ð° Ð·Ð° Ð¾Ð±ÑÑÐ½ÐµÐ½Ð¸Ðµ',0),(296683,8242,'ur','Ø¯ÛŒÚ©Ú¾ÛŒÚº ØªÙØ³ÛŒØ± Ú©Û’ Ù„ÛŒÛ’ Ù…Ø¯Ø¯',0),(296684,8242,'sr','Ð’Ð¸Ð´Ð¸ Ð¿Ð¾Ð¼Ð¾Ñ› Ð·Ð° Ð¾Ð±Ñ˜Ð°ÑˆÑšÐµÑšÐµ',0),(296685,8242,'vi','Xem Trá»£ giÃºp ',0),(296686,8242,'af','Sien Hulp Vir Verduideliking',0),(296687,8242,'ro','ConsultaÅ£i ajutorul pentru explicaÅ£ii',0),(296688,8242,'et','Vajutage abi selgituse saamiseks',0),(296689,8242,'si','Glejte pomoÄ za razlago',0),(296690,8242,'ba','Lihat bantuan untuk penjelasan',0),(296691,8242,'nl','Zie Help voor uitleg',0),(296692,8242,'fi','Katso ohjeet selitys',0),(296693,8242,'no','Se Hjelp For forklaring',0),(296694,8242,'da','Se hjÃ¦lp til forklaring',0),(296695,8242,'ko','ì°¸ì¡°ì— ëŒ€ í•œ ì„¤ëª…ì€ ë„ì›€ë§',0),(296696,8242,'he','×¨××” ×¢×–×¨×” ×¢×‘×•×¨ ×”×¡×‘×¨',0),(296697,8242,'el','Î”ÎµÎ¯Ï„Îµ Ï„Î· Î²Î¿Î®Î¸ÎµÎ¹Î± Î³Î¹Î± Ï„Î·Î½ ÎµÎ¾Î®Î³Î·ÏƒÎ·',0),(296698,8242,'zh','è¯·å‚é˜…å¸®åŠ©è¯´æ˜Ž\r\n',0),(296699,8242,'sv','Se hjÃ¤lp fÃ¶r fÃ¶rklaring',0),(296700,8242,'it','Vedere aiuto per spiegazione',0),(296701,8242,'tl','',0),(296702,8242,'th','&#3617;&#3629;&#3591;&#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(296703,8242,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¦à¤¦',0),(296704,8242,'ms','Sila lihat bantuan untuk penjelasan',0),(296705,8242,'ar','Ø±Ø§Ø¬Ø¹ Ø´Ø§Ø´Ø© Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø© Ù„Ù„ØªÙˆØ¶ÙŠØ­',0),(296706,8242,'fr','Voir aide pour explication',0),(296707,8242,'jp','å‚ç…§ã—ã¦ãã ã•ã„ãƒ˜ãƒ«ãƒ—ã«ã¤ã„ã¦',0),(296708,8242,'pt','Consulte a ajuda para explicaÃ§Ã£o',0),(296709,8242,'ru','Ð¡Ð¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ Ð”Ð»Ñ ÐžÐ±ÑŠÑÑÐ½ÐµÐ½Ð¸Ñ',0),(296710,8242,'es','Vea Ayudo para ExplicaciÃ³n',0),(296711,8242,'de','Siehe Hilfe fÃ¼r ErklÃ¤rung',0),(296712,8242,'en','See Help For Explanation',0),(296713,8243,'is','',0),(296714,8243,'dr','ÙƒØ¯ Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§ ',0),(296715,8243,'pr','ÙƒØ¯ Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§ ',0),(296716,8243,'tr','Hava durumu kodu',0),(296717,8243,'pl','Kod pogody',0),(296718,8243,'bg','Ð’Ñ€ÐµÐ¼Ðµ ÐºÐ¾Ð´',0),(296719,8243,'ur','Ù…ÙˆØ³Ù… Ú©ÙˆÚˆ',0),(296720,8243,'sr','Ð’Ñ€ÐµÐ¼ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(296721,8243,'vi','MÃ£ thá»i tiáº¿t',0),(296722,8243,'af','Weer Kode',0),(296723,8243,'ro','Codul de vreme',0),(296724,8243,'et','Ilma kood',0),(296725,8243,'si','Vreme kodo',0),(296726,8243,'ba','Cuaca kode',0),(296727,8243,'nl','Weer Code',0),(296728,8243,'fi','SÃ¤Ã¤ koodi',0),(296729,8243,'no','VÃ¦r kode',0),(296730,8243,'da','Vejret kode',0),(296731,8243,'ko','ë‚ ì”¨ ì½”ë“œ',0),(296732,8243,'he','×§×•×“ ×ž×–×’ ××•×•×™×¨',0),(296733,8243,'el','ÎšÎ±Î¹ÏÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±',0),(296734,8243,'zh','å¤©æ°”ä»£ç \r\n',0),(296735,8243,'sv','VÃ¤der kod',0),(296736,8243,'it','Codice di tempo',0),(296737,8243,'tl','',0),(296738,8243,'th','&#3619;&#3627;&#3633;&#3626;&#3626;&#3616;&#3634;&#3614;&#3629;&#3634;&#3585;&#3634;&#3624;',0),(296739,8243,'hi','à¤®à¥Œà¤¸à¤® à¤•à¥‹à¤¡',0),(296740,8243,'ms','Kod cuaca',0),(296741,8243,'ar','Ø±Ù…Ø² Ø§Ù„Ø·Ù‚Ø³',0),(296742,8243,'fr','Code mÃ©tÃ©o',0),(296743,8243,'jp','æ°—è±¡ã‚³ãƒ¼ãƒ‰',0),(296744,8243,'pt','CÃ³digo de tempo',0),(296745,8243,'ru','ÐšÐ¾Ð´ ÐŸÐ¾Ð³Ð¾Ð´Ð°',0),(296746,8243,'es','CÃ³digo de Clima',0),(296747,8243,'de','Wetter-Code',0),(296748,8243,'en','Weather Code',0),(296749,8244,'is','',0),(296750,8244,'dr','Ù†ÙˆØ¹ Ø¯Ø±Ø¬Ù‡ Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§',0),(296751,8244,'pr','Ù†ÙˆØ¹ Ø¯Ø±Ø¬Ù‡ Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§',0),(296752,8244,'tr','Hava derecesi tipi',0),(296753,8244,'pl','Pogoda stopnia typu',0),(296754,8244,'bg','Ð¢Ð¸Ð¿ Ð½Ð° ÑÑ‚ÐµÐ¿ÐµÐ½Ñ‚Ð° Ð½Ð° Ð²Ñ€ÐµÐ¼ÐµÑ‚Ð¾',0),(296755,8244,'ur','Ù…ÙˆØ³Ù… ÚˆÚ¯Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(296756,8244,'sr','Ð’Ñ€ÐµÐ¼ÐµÐ½Ñƒ ÑÑ‚ÐµÐ¿ÐµÐ½Ð° Ñ‚Ð¸Ð¿',0),(296757,8244,'vi','Loáº¡i Ä‘á»™ thá»i tiáº¿t',0),(296758,8244,'af','Weer graad tipe',0),(296759,8244,'ro','Gradul de tip meteo',0),(296760,8244,'et','Fahrenheit vÃµi Celsius ',0),(296761,8244,'si','Vrste stopnjo vreme',0),(296762,8244,'ba','Jenis gelar cuaca',0),(296763,8244,'nl','Mate weertype',0),(296764,8244,'fi','SÃ¤Ã¤ tutkinnon tyyppi',0),(296765,8244,'no','Grad VÃ¦rtype',0),(296766,8244,'da','Vejret grad Type',0),(296767,8244,'ko','ë‚ ì”¨ë„ ìœ í˜•',0),(296768,8244,'he','×¡×•×’ ×”×ª×•××¨ ×ž×–×’ ××•×•×™×¨',0),(296769,8244,'el','Î’Î±Î¸Î¼ÏŒ Ï„ÏÏ€Î¿ ÎºÎ±Î¹ÏÎ¿Ï',0),(296770,8244,'zh','å¤©æ°”åº¦æ•°ç±»åˆ«\r\n',0),(296771,8244,'sv','VÃ¤der grad typ',0),(296772,8244,'it','Meteo grado tipo',0),(296773,8244,'tl','',0),(296774,8244,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3629;&#3640;&#3603;&#3627;&#3616;&#3641;&#3617;&#3636;',0),(296775,8244,'hi','à¤®à¥Œà¤¸à¤® à¤•à¥€ à¤¡à¤¿à¤—à¥à¤°à¥€ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(296776,8244,'ms','Jenis Ijazah cuaca',0),(296777,8244,'ar','Ù†ÙˆØ¹ Ø¯Ø±Ø¬Ø© Ø§Ù„Ø­Ø±Ø§Ø±Ø© Ù„Ù„Ø·Ù‚Ø³',0),(296778,8244,'fr','Type de mesure de temps',0),(296779,8244,'jp','å¤©æ°—åº¦ã‚¿ã‚¤ãƒ—',0),(296780,8244,'pt','Tipo de grau de tempo',0),(296781,8244,'ru','Ð¢Ð¸Ð¿ ÑÑ‚ÐµÐ¿ÐµÐ½Ð¸ ÐŸÐ¾Ð³Ð¾Ð´Ð°',0),(296782,8244,'es','Tipo de Grado de Clima',0),(296783,8244,'de','Wetter Grad Typ',0),(296784,8244,'en','Weather Degree Type',0),(296785,8245,'is','',0),(296786,8245,'dr','12 Ù…Ø§Ù‡Ù‡',0),(296787,8245,'pr','Ø³ÙˆØ¯ Ùˆ Ø²ÛŒØ§Ù† 12 Ù…Ø§Ù‡Ù‡',0),(296788,8245,'tr','12 ay P ve L',0),(296789,8245,'pl','12 miesiÄ™cy P idealna L',0),(296790,8245,'bg','12 Ð¼ÐµÑÐµÑ† P & L',0),(296791,8245,'ur','Ø³Ø§Ù„Ø§Ù†Ú¾ Ù†ÙØ¹ Ùˆ Ù†Ù‚Ø³Ø§Ù†',0),(296792,8245,'sr','12 Ð¼ÐµÑÐµÑ†Ð¸ ÐŸ & Ð›',0),(296793,8245,'vi','Lá»i Lá»• 12 ThÃ¡ng ',0),(296794,8245,'af','12 Maande W-&-V',0),(296795,8245,'ro','12 Luni P&P',0),(296796,8245,'et','12 kuu P & L',0),(296797,8245,'si','12 mesec P & L',0),(296798,8245,'ba','12 Bulan R&L',0),(296799,8245,'nl','12 maanden P&L',0),(296800,8245,'fi','12 kk P/Teachers & L',0),(296801,8245,'no','12 mÃ¥neder P & L',0),(296802,8245,'da','12 mÃ¥ned P & L',0),(296803,8245,'ko','12 ê°œì›” P & L',0),(296804,8245,'he','12 ×—×•×“×©×™× P & L',0),(296805,8245,'el','12 Î¼Î®Î½Î± P & L',0),(296806,8245,'zh','12ä¸ªæœˆæŸç›Š',0),(296807,8245,'sv','12 MÃ¥nads V&F',0),(296808,8245,'it','P&S 12 mesi',0),(296809,8245,'tl','',0),(296810,8245,'th','12 à¹€à¸”à¸·à¸­à¸™ à¸à¸³à¹„à¸£ & à¸‚à¸²à¸”à¸—à¸¸à¸™',0),(296811,8245,'hi','12 à¤®à¤¹à¥€à¤¨à¥‡ P & L',0),(296812,8245,'ms','12 bulan P & L',0),(296813,8245,'ar','Ø§Ù„Ø£Ø±Ø¨Ø§Ø­ ÙˆØ§Ù„Ø®Ø³Ø§Ø¦Ø± Ø¹Ù† 12 Ø´Ù‡Ø±Ø§',0),(296814,8245,'fr','P&P sur 12 Mois',0),(296815,8245,'jp','12 æœˆ P ãƒ» L',0),(296816,8245,'pt','12 meses P &amp; L do',0),(296817,8245,'ru','12 Ð¼ÐµÑÑÑ†ÐµÐ² P & L',0),(296818,8245,'es','12 P&G / Mes',0),(296819,8245,'de','12 Monate G&V',0),(296820,8245,'en','12 Month P&L',0),(296821,8246,'is','',0),(296822,8246,'dr','Ù…Ø¯ÙŠØ± ÙˆÙŠÚ˜Ú¯ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ ',0),(296823,8246,'pr','Ù…Ø¯ÙŠØ± ÙˆÙŠÚ˜Ú¯ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ ',0),(296824,8246,'tr','Eklenti YÃ¶neticisi',0),(296825,8246,'pl','MenedÅ¼era dodatkÃ³w',0),(296826,8246,'bg','Ð”Ð¸ÑÐ¿ÐµÑ‡ÐµÑ€ Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸Ñ‚Ðµ',0),(296827,8246,'ur','Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ù…ÛŒÙ†ÛŒØ¬Ø±',0),(296828,8246,'sr','\"Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°Ñ‡ Ð´Ð¾Ð´Ð°Ñ†Ð¸Ð¼Ð°\"',0),(296829,8246,'vi','Quáº£n LÃ½ ThÃªm VÃ o',0),(296830,8246,'af','Byvoegsel Bestuurder',0),(296831,8246,'ro','Supliment Manager',0),(296832,8246,'et','Lisandmoodulite haldur',0),(296833,8246,'si','Upravitelja dodatkov',0),(296834,8246,'ba','Pengelola add-On',0),(296835,8246,'nl','Beheer van invoegtoepassingen',0),(296836,8246,'fi','LisÃ¤osien hallinta',0),(296837,8246,'no','Behandling av tillegg',0),(296838,8246,'da','TilfÃ¸jelsesstyring',0),(296839,8246,'ko','ì¶”ê°€ ê¸°ëŠ¥ ê´€ë¦¬ìž',0),(296840,8246,'he','×ž× ×”×œ ×”×ª×•×¡×¤×•×ª',0),(296841,8246,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Ï€ÏÏŒÏƒÎ¸ÎµÏ„Ï‰Î½',0),(296842,8246,'zh','å¢žåŠ è½½é¡¹ç®¡ç†å™¨\r\n',0),(296843,8246,'sv','TillÃ¤ggshanteraren',0),(296844,8246,'it','Add-on Manager',0),(296845,8246,'tl','',0),(296846,8246,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3609;&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;',0),(296847,8246,'hi','à¤à¤¡-à¤‘à¤¨ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤•',0),(296848,8246,'ms','Pengurus tambahan',0),(296849,8246,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(296850,8246,'fr','Gestionnaire de modules complÃ©mentaires',0),(296851,8246,'jp','ã‚¢ãƒ‰ã‚ªãƒ³ ãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼',0),(296852,8246,'pt','Gerenciador de Complementos',0),(296853,8246,'ru','Ð”Ð¸ÑÐ¿ÐµÑ‚Ñ‡ÐµÑ€ Ð½Ð°Ð´ÑÑ‚Ñ€Ð¾ÐµÐº',0),(296854,8246,'es','Supervisor de Disp. de AmpliaciÃ³n',0),(296855,8246,'de','Add-on-Verwaltung',0),(296856,8246,'en','Add-On Manager',0),(296857,8247,'is','',0),(296858,8247,'dr','(Ù†Ø´Ø§Ù†Ù‡ ØªØ¬Ø§Ø±ØªÛŒ) Ø¨Ø±Ø§ÙŠ ØµÙØ­Ù‡ ÙˆØ±ÙˆØ¯ Ùˆ Ù¾Ø§ÙˆØ±Ù‚ÙŠ',0),(296859,8247,'pr','ØªØ¹ÙŠÙŠÙ† Ù„ÙˆÚ¯Ùˆ(Ù†Ø´Ø§Ù†Ù‡ ØªØ¬Ø§Ø±ÙŠ) Ø¨Ø±Ø§ÙŠ ØµÙØ­Ù‡ ÙˆØ±ÙˆØ¯ Ùˆ Ù¾Ø§ÙˆØ±Ù‚ÙŠ',0),(296860,8247,'tr','Oturum aÃ§ma sayfasÄ± ve altbilgiler iÃ§in logo ata',0),(296861,8247,'pl','PrzypisaÄ‡ Logo do strony logowania i stopki',0),(296862,8247,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¾Ð³Ð¾ Ð·Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¸ ÐºÐ¾Ð»Ð¾Ð½Ñ‚Ð¸Ñ‚ÑƒÐ»Ð¸',0),(296863,8247,'ur','Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ) Ù…ÛŒÚº Ù„Ø§Ú¯ Ø¢Ù† Ú©Û’ ØµÙØ­Û Ø§ÙˆØ± Ø°ÛŒÙ„ ØªØ­Ø±ÛŒØ± Ú©Û’ Ù„ÛŒÛ’ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº Û”',0),(296864,8247,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ð›Ð¾Ð³Ð¾ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð¸ Ð¿Ð¾Ð´Ð½Ð¾Ð¶Ñ˜Ð°',0),(296865,8247,'vi','Chá»‰ Äá»‹nh Logo trÃªn trang Ä‘Äƒng nháº­p & chÃ¢n trang',0),(296866,8247,'af','Embleem Vir Aantekenbladsy en Voeters Toeken',0),(296867,8247,'ro','AtribuiÅ£i logo-ul pentru pagina de log on ÅŸi subsoluri',0),(296868,8247,'et','MÃ¤Ã¤rata Logo sisselogimise lehele ja jalused',0),(296869,8247,'si','Dodelite Logo za prijavo stran in noge',0),(296870,8247,'ba','Menetapkan Logo untuk halaman Logon dan footer',0),(296871,8247,'nl','Logo voor aanmeldingspagina en voetteksten toewijzen',0),(296872,8247,'fi','MÃ¤Ã¤rittÃ¤Ã¤ logon Logon ja alamarginaalit',0),(296873,8247,'no','Tilordne Logo For pÃ¥loggingsside og bunntekst',0),(296874,8247,'da','Tildele logoet For logonside og sidefÃ¸dder',0),(296875,8247,'ko','ë¡œê·¸ì˜¨ íŽ˜ì´ì§€ ë° ë°”ë‹¥ê¸€ì— ëŒ€ í•œ ë¡œê³ ë¥¼ í• ë‹¹',0),(296876,8247,'he','×œ×”×§×¦×•×ª ×œ×•×’×• ×¢×‘×•×¨ ×“×£ ×›× ×™×¡×” ×¢×œ×™×•× ×•×ª ×•×ª×—×ª×•× ×•×ª',0),(296877,8247,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ Î»Î¿Î³ÏŒÏ„Ï…Ï€Î¿ Î³Î¹Î± ÏƒÏÎ½Î´ÎµÏƒÎ· ÏƒÎµÎ»Î¯Î´Î±Ï‚ ÎºÎ±Î¹ Ï„Î± Ï…Ï€Î¿ÏƒÎ­Î»Î¹Î´Î±',0),(296878,8247,'zh','æŒ‡å®šçš„æ ‡å¿—ç™»å½•é¡µå’Œé¡µè„š\r\n',0),(296879,8247,'sv','Tilldela logotyp fÃ¶r inloggningssidan och sidfÃ¶tter',0),(296880,8247,'it','Assegnare il Logo per il piÃ¨ di pagina e la pagina di accesso',0),(296881,8247,'tl','',0),(296882,8247,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3626;&#3633;&#3597;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;&#3648;&#3614;&#3639;&#3656;&#3629;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3627;&#3633;&#3623;&#3649;&#3621;&#3632;&#3607;&#3657;&#3634;&#3618;&#3',0),(296883,8247,'hi','à¤²à¥‹à¤—à¥‹ à¤²à¥‰à¤—à¤‘à¤¨ à¤ªà¥ƒà¤·à¥à¤  à¤”à¤° à¤ªà¤¾à¤¦ à¤²à¥‡à¤– à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(296884,8247,'ms','Peruntukkan Logo Laman log masuk dan pembawah',0),(296885,8247,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø´Ø¹Ø§Ø± Ø¹Ù„Ù‰ ØµÙØ­Ø© ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ ÙˆØ§Ù„ØªØ°ÙŠÙŠÙ„Ø§Øª',0),(296886,8247,'fr','Attribuer le Logo pour les pieds de page et la Page d\'ouverture de session',0),(296887,8247,'jp','ãƒ­ã‚°ã‚ªãƒ³ ãƒšãƒ¼ã‚¸ã®ãƒ•ãƒƒã‚¿ãƒ¼ã®ãƒ­ã‚´ã‚’å‰²ã‚Šå½“ã¦ã‚‹',0),(296888,8247,'pt','Atribuir o logotipo para a pÃ¡gina de Logon e rodapÃ©s',0),(296889,8247,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿ Ð´Ð»Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ð²Ñ…Ð¾Ð´Ð° Ð¸ Ð½Ð¸Ð¶Ð½Ð¸Ñ… ÐºÐ¾Ð»Ð¾Ð½Ñ‚Ð¸Ñ‚ÑƒÐ»Ð¾Ð²',0),(296890,8247,'es','Asignar Logo para PÃ¡gina de Inicio de SesiÃ³n y Pie de PÃ¡gina',0),(296891,8247,'de','Logo fÃ¼r Anmeldeseite und FuÃŸzeilen zuordnen',0),(296892,8247,'en','Assign Logo For Logon Page and Footers',0),(296893,8248,'is','',0),(296894,8248,'dr','Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(296895,8248,'pr','Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÙŠ',0),(296896,8248,'tr','Marka',0),(296897,8248,'pl','Marki',0),(296898,8248,'bg','Ð‘Ñ€Ð°Ð½Ð´Ð¸Ð½Ð³',0),(296899,8248,'ur','Ú©ÙˆØ¨Ø±Ø§Ù†ÚˆÙ†Ú¯',0),(296900,8248,'sr','Ð‘Ñ€ÐµÐ½Ð´Ð¸Ñ€Ð°ÑšÐµ',0),(296901,8248,'vi','ThÆ°Æ¡ng Hiá»‡u',0),(296902,8248,'af','Handelsmerk ',0),(296903,8248,'ro','Branding',0),(296904,8248,'et','Branding',0),(296905,8248,'si','Blagovne znamke',0),(296906,8248,'ba','Merek',0),(296907,8248,'nl','Branding',0),(296908,8248,'fi','Tuotemerkin',0),(296909,8248,'no','Merkevarebygging',0),(296910,8248,'da','Branding',0),(296911,8248,'ko','ë¸Œëžœë”©',0),(296912,8248,'he','×ž×™×ª×•×’',0),(296913,8248,'el','ÎœÎ±ÏÎºÎ¬ÏÎ¹ÏƒÎ¼Î±',0),(296914,8248,'zh','å“ç‰Œ\r\n',0),(296915,8248,'sv','Branding',0),(296916,8248,'it','Branding',0),(296917,8248,'tl','',0),(296918,8248,'th','&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3657;&#3634;',0),(296919,8248,'hi','à¤¬à¥à¤°à¤¾à¤‚à¤¡à¤¿à¤‚à¤—',0),(296920,8248,'ms','Penjenamaan',0),(296921,8248,'ar','Ø§Ù„Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ©',0),(296922,8248,'fr','Image de marque',0),(296923,8248,'jp','ãƒ–ãƒ©ãƒ³ãƒ‡ã‚£ãƒ³ã‚°',0),(296924,8248,'pt','Branding',0),(296925,8248,'ru','Ð‘Ñ€ÐµÐ½Ð´Ð¸Ð½Ð³',0),(296926,8248,'es','MarcaciÃ³n',0),(296927,8248,'de','Branding',0),(296928,8248,'en','Branding',0),(296929,8249,'is','',0),(296930,8249,'dr','NolaPro',0),(296931,8249,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø¯Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±  NolaPro',0),(296932,8249,'tr','Ã‡alÄ±ÅŸanlarÄ±n sistemi iÃ§ine alma',0),(296933,8249,'pl','Pracownicy importu do systemu',0),(296934,8249,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(296935,8249,'ur','Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ù†Ø¸Ø§Ù… Ù…ÛŒÚº Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(296936,8249,'sr','Ð£Ð²Ð¾Ð· Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼',0),(296937,8249,'vi','Nháº­p nhÃ¢n viÃªn vÃ o Nolapro',0),(296938,8249,'af','Invoer van Werknemers binne NolaPro',0),(296939,8249,'ro','Import de angajaÅ£i Ã®n sistem',0),(296940,8249,'et','Impordi tÃ¶Ã¶tajad NolaPro-sse',0),(296941,8249,'si','Uvoz zaposlenih v sistem',0),(296942,8249,'ba','Mengimpor karyawan ke sistem',0),(296943,8249,'nl','Werknemers importeert in systeem',0),(296944,8249,'fi','Tuo tyÃ¶ntekijÃ¶iden jÃ¤rjestelmÃ¤',0),(296945,8249,'no','Importere ansatte til systemet',0),(296946,8249,'da','Importere ansatte i systemet',0),(296947,8249,'ko','ì‹œìŠ¤í…œìœ¼ë¡œ ê°€ì ¸ì˜¤ê¸° ì§ì›',0),(296948,8249,'he','NolaPro ×™×‘× ×¢×•×‘×“×™× ×œ×ª×•×š',0),(296949,8249,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(296950,8249,'zh','å¯¼å…¥èŒå·¥åˆ°ç³»ç»Ÿ\r\n',0),(296951,8249,'sv','Importera anstÃ¤llda till System',0),(296952,8249,'it','Importare i dipendenti nel sistema',0),(296953,8249,'tl','',0),(296954,8249,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3652;&#3611;&#3626;&#3641;&#3656; Nolapro',0),(296955,8249,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤®à¥‡à¤‚ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(296956,8249,'ms','Mengimport pekerja ke dalam sistem',0),(296957,8249,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ† ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(296958,8249,'fr','Importer des employÃ©s dans le systÃ¨me',0),(296959,8249,'jp','å¾“æ¥­å“¡ã‚’ã‚·ã‚¹ãƒ†ãƒ ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(296960,8249,'pt','Empregados de importaÃ§Ã£o no sistema',0),(296961,8249,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² Ð’ NolaPro',0),(296962,8249,'es','Importar Empleados a NolaPro',0),(296963,8249,'de','Mitarbeiter in System importieren',0),(296964,8249,'en','Import Employees Into System',0),(296965,8250,'is','',0),(296966,8250,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù†Ø§ØªÙ…Ø§Ù…',0),(296967,8250,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù†Ø§ØªÙ…Ø§Ù…',0),(296968,8250,'tr','Eksik bileÅŸen',0),(296969,8250,'pl','ElementÃ³w nieukoÅ„czonych',0),(296970,8250,'bg','ÐÐµÐ·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(296971,8250,'ur','Ù†Ø§ Ù…Ú©Ù…Ù„ Ø¢Ø¦Ù¹Ù…Ø²',0),(296972,8250,'sr','ÐÐµÐ¿Ð¾Ñ‚Ð¿ÑƒÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(296973,8250,'vi','HÃ ng chÆ°a hoÃ n chá»‰nh',0),(296974,8250,'af','Onklaar Items',0),(296975,8250,'ro','Articole incomplete',0),(296976,8250,'et','Pooleliolevad Ã¼ksused',0),(296977,8250,'si','Nepopolni elementi',0),(296978,8250,'ba','Barang-barang yang tidak lengkap',0),(296979,8250,'nl','Onvolledige Items',0),(296980,8250,'fi','KeskenerÃ¤iset kohteet',0),(296981,8250,'no','Ufullstendige elementer',0),(296982,8250,'da','Ikke-fuldfÃ¸rte elementer',0),(296983,8250,'ko','ì™„ë£Œ ë˜ì§€ ì•Šì€ í•­ëª©',0),(296984,8250,'he','×¤×¨×™×˜×™× ×œ× ×ž×•×©×œ×ž×™×',0),(296985,8250,'el','Î•Î»Î»Î¹Ï€Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(296986,8250,'zh','ä¸å®Œæ•´çš„é¡¹ç›®\r\n',0),(296987,8250,'sv','OfullstÃ¤ndiga artiklar',0),(296988,8250,'it','Articoli incompleti',0),(296989,8250,'tl','',0),(296990,8250,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3617;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(296991,8250,'hi','à¤…à¤ªà¥‚à¤°à¥à¤£ à¤†à¤‡à¤Ÿà¤®',0),(296992,8250,'ms','Item-item yang tidak lengkap',0),(296993,8250,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± ØºÙŠØ± Ù…ÙƒØªÙ…Ù„Ø©',0),(296994,8250,'fr','Articles incomplets',0),(296995,8250,'jp','ä¸å®Œå…¨ãªé …ç›®',0),(296996,8250,'pt','Itens incompletas',0),(296997,8250,'ru','ÐÐµÐ¿Ð¾Ð»Ð½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹',0),(296998,8250,'es','Items Incompletos',0),(296999,8250,'de','UnvollstÃ¤ndige Artikel',0),(297000,8250,'en','Incomplete Items',0),(297001,8251,'is','',0),(297002,8251,'dr','(Ù‡Ø²ÙŠÙ†Ù‡)Ùˆ Ø¨Ø¯ÙˆÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(297003,8251,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† Ù‚ÙŠÙ…Øª(Ù‡Ø²ÙŠÙ†Ù‡)Ùˆ Ø¨Ø¯ÙˆÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(297004,8251,'tr','No maliyet veya satÄ±cÄ± ile Ã¶ÄŸeleri',0),(297005,8251,'pl','Elementy bez kosztÃ³w albo nie dostawcy',0),(297006,8251,'bg','ÐžÐ±ÐµÐºÑ‚Ð¸ Ñ Ð¸Ð»Ð¸ Ð±ÐµÐ· Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸, Ð¸Ð»Ð¸ Ð½ÑÐ¼Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(297007,8251,'ur','Ø§Ø´ÛŒØ§Ø¡ Ù†ÛÛŒÚº Ù„Ø§Ú¯Øª ÛŒØ§ Ú©ÙˆØ¦ÛŒ ÙˆÛŒÙ†ÚˆØ± Ú©Û’ Ø³Ø§ØªÚ¾',0),(297008,8251,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ ÐºÐ¾Ñ˜Ðµ Ð½Ðµ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ð¸Ð»Ð¸ Ð½ÐµÐ¼Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(297009,8251,'vi','HÃ ng khÃ´ng cÃ³ giÃ¡ thÃ nh hay khÃ´ng cÃ³ ngÆ°á»i bÃ¡n',0),(297010,8251,'af','Items Met Geen Koste Of Geen Verskaffer',0),(297011,8251,'ro','Elementele fÄƒrÄƒ nici un Cost sau nu furnizor',0),(297012,8251,'et','Ãœksusi ei kulusid vÃµi ei ole hankija',0),(297013,8251,'si','Elemente z brez stroÅ¡kov ali brez dobavitelja',0),(297014,8251,'ba','Item No biaya atau penjual tidak',0),(297015,8251,'nl','Onderdelen met geen kosten of geen leverancier',0),(297016,8251,'fi','NimikkeitÃ¤, joilla ei ole kustannus tai toimittajaa ei',0),(297017,8251,'no','Elementer uten kostnad eller ingen leverandÃ¸rer',0),(297018,8251,'da','Elementer med enten uden omkostninger eller ingen leverandÃ¸r',0),(297019,8251,'ko','ë¹„ìš© ì—†ìŒ ë˜ëŠ” ì—†ìŒ ê³µê¸‰ ì—…ì²´ í•­ëª©',0),(297020,8251,'he','×¤×¨×™×˜×™× ×¢× ××• ×œ×œ× ×¢×œ×•×ª ××• ××™×Ÿ ×¡×¤×§',0),(297021,8251,'el','Î‘Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î± Î¼Îµ Î´ÎµÎ½ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎµÎ¯Ï„Îµ Î´ÎµÎ½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(297022,8251,'zh','æ²¡æœ‰æˆæœ¬æˆ–æ²¡æœ‰ä¾›åº”å•†çš„ç‰©é¡¹\r\n',0),(297023,8251,'sv','Artiklar med antingen utan kostnad eller ingen leverantÃ¶r',0),(297024,8251,'it','Oggetti con o senza alcun costo o nessun fornitore',0),(297025,8251,'tl','',0),(297026,8251,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3611;&#3655;&#3609;&#3629;&#3618;&#3656;&#3634;&#3591;&#3651;&#3604;&#3629;&#3618;&#3656;&#3634;&#3591;&#3627;&#3609;&#3638;&#3656;&#3591; &#3652;&#3617;&#3656;&#3617;&#3637;&#3605;&#3657;&#3609;&#3607;&#',0),(297027,8251,'hi','à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¯à¤¾ à¤¤à¥‹ à¤¸à¥‡ à¤•à¥‹à¤ˆ à¤²à¤¾à¤—à¤¤ à¤¯à¤¾ à¤•à¥‹à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(297028,8251,'ms','Barang-barang dengan sama ada tiada kos atau penjual tiada',0),(297029,8251,'ar','Ø£ØµÙ†Ø§Ù Ø¨Ø¯ÙˆÙ† ØªÙƒÙ„ÙØ© Ø£Ùˆ Ø¨Ø¯ÙˆÙ† Ù…ÙˆØ±Ù‘Ø¯',0),(297030,8251,'fr','Ã‰lÃ©ments avec aucun fournisseur ou sans frais',0),(297031,8251,'jp','ã„ã„ãˆã‚³ã‚¹ãƒˆã¾ãŸã¯ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’æŒã¤ã‚¢ã‚¤ãƒ†ãƒ ',0),(297032,8251,'pt','Itens com nenhum custo ou nenhum fornecedor',0),(297033,8251,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ñ Ð±ÐµÐ·Ð²Ð¾Ð·Ð¼ÐµÐ·Ð´Ð½Ð¾Ð¹ Ð¸Ð»Ð¸ Ð½ÐµÑ‚ Ð°Ð±Ð¾Ð½ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(297034,8251,'es','Items con O No Costo O no Proveedor',0),(297035,8251,'de','Elemente mit No Cost oder kein Anbieter',0),(297036,8251,'en','Items With Either No Cost Or No Vendor',0),(297037,8252,'is','',0),(297038,8252,'dr','12  Ù…Ø§Ù‡Ù‡ ',0),(297039,8252,'pr','Ú†Ø§Ù¾ ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÙŠØ§Ù† 12  Ù…Ø§Ù‡Ù‡ ',0),(297040,8252,'tr','12 ay P & L ekstresi yazdÄ±r',0),(297041,8252,'pl','WydrukowaÄ‡ 12 miesiÄ…c P & L instrukcja',0),(297042,8252,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° 12-Ð¼ÐµÑÐµÑ‡ÐµÐ½ P & L Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(297043,8252,'ur','Ø§ÛŒÚ© 12 Ù…Ø§Û P & L Ø¨ÛŒØ§Ù† Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(297044,8252,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ 12 Ð¼ÐµÑÐµÑ†Ð¸ ÐŸ & Ð› Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(297045,8252,'vi','In 1 bÃ¡o cÃ¡o lá»i lá»— trong 12 thÃ¡ng',0),(297046,8252,'af','Druk \'n 12 Maande Wins-en-Verlies Staat',0),(297047,8252,'ro','Imprima o luna 12 P & L declaraÅ£ie',0),(297048,8252,'et','Prindi 12 kuu P & L avaldus',0),(297049,8252,'si','Tiskanje 12 mesec P & L izjavo',0),(297050,8252,'ba','Mencetak 12 bulan P & pernyataan L',0),(297051,8252,'nl','Afdrukken van een 12 maanden P & L verklaring',0),(297052,8252,'fi','Tulostaa 12 kuukauden P & L ilmoitus',0),(297053,8252,'no','Skrive ut en 12 mÃ¥neders P & L-setning',0),(297054,8252,'da','Udskrive en 12 mÃ¥ned P & L erklÃ¦ring',0),(297055,8252,'ko','12 ê°œì›” P & L ê³„ì‚° ì„œ ì¸ì‡„',0),(297056,8252,'he','×”×“×¤×¡ ×©×œ 12 ×—×•×“×©×™× P & L ×”×¦×”×¨×”',0),(297057,8252,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î­Î½Î± Î¼Î®Î½Î± 12 P & L Î´Î®Î»Ï‰ÏƒÎ·',0),(297058,8252,'zh','æ‰“å°12ä¸ªæœˆçš„æŸç›Šè¡¨\r\n',0),(297059,8252,'sv','Skriva ut en 12 mÃ¥naders P & L uttalande',0),(297060,8252,'it','Stampare un mese 12 P & L istruzione',0),(297061,8252,'tl','',0),(297062,8252,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3591;&#3610;&#3585;&#3635;&#3652;&#3619;&#3586;&#3634;&#3604;&#3607;&#3640;&#3609; 12 &#3648;&#3604;&#3639;&#3629;&#3609;',0),(297063,8252,'hi','à¤à¤• à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ 12 P & L à¤•à¤¥à¤¨ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(297064,8252,'ms','Mencetak 12 bulan P & L penyata',0),(297065,8252,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù…Ù† 12 Ø´Ù‡Ø± Ù Ø¢Ù†Ø¯ Ù„ Ø¨ÙŠØ§Ù†',0),(297066,8252,'fr','Imprimer un 12 mois P & L instruction',0),(297067,8252,'jp','12 æœˆ P & L ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(297068,8252,'pt','Imprimir um mÃªs 12 P & L instruÃ§Ã£o',0),(297069,8252,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ 12 Ð¼ÐµÑÑÑ†ÐµÐ² P & L Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(297070,8252,'es','Imprimir Un Estado de Resultados de 12 Meses',0),(297071,8252,'de','Drucken eines 12-Monats-P & L-Anweisung',0),(297072,8252,'en','Print a 12 Month P&L Statement',0),(297073,8253,'is','',0),(297074,8253,'dr','ÙˆÙŠÚ˜Ú¯ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ø®Ø±ÙŠØ¯ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª',0),(297075,8253,'pr','ÙˆÙŠÚ˜Ú¯ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ø®Ø±ÙŠØ¯ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª',0),(297076,8253,'tr','SatÄ±n alma ve eklentileri yÃ¶net',0),(297077,8253,'pl','Zakupu i zarzÄ…dzania dodatkami',0),(297078,8253,'bg','Ð—Ð°ÐºÑƒÐ¿ÑƒÐ²Ð°Ð½Ðµ Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸Ñ‚Ðµ',0),(297079,8253,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ø§ÙˆØ± Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº ons Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±ÛŒÚº',0),(297080,8253,'sr','ÐÐ°Ð±Ð°Ð²ÐºÐµ Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°Ñ˜Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ†Ð¸Ð¼Ð°',0),(297081,8253,'vi','Mua & Quáº£n lÃ½ cá»™ng thÃªm',0),(297082,8253,'af','Aankoop en Inrig van Byvoegings',0),(297083,8253,'ro','CumpÄƒrare ÅŸi de a gestiona Suplimente',0),(297084,8253,'et','Ostma ning Lisandmoodulite haldamine',0),(297085,8253,'si','Nakup in upravljanje dodatkov',0),(297086,8253,'ba','Membeli dan mengelola Pengaya',0),(297087,8253,'nl','Kopen en invoegtoepassingen beheren',0),(297088,8253,'fi','Osto- ja hallitse lisÃ¤osia',0),(297089,8253,'no','KjÃ¸pe og administrere tillegg',0),(297090,8253,'da','KÃ¸be og administrere tilfÃ¸jelser',0),(297091,8253,'ko','êµ¬ë§¤ í•˜ ê³  ì¶”ê°€ ê¸°ëŠ¥ì„ ê´€ë¦¬',0),(297092,8253,'he','×œ×¨×›×•×© ×•×œ× ×”×œ ×ª×•×¡×¤×•×ª',0),(297093,8253,'el','Î‘Î³Î¿ÏÎ¬ ÎºÎ±Î¹ Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Ï€ÏÏŒÏƒÎ¸ÎµÏ„Ï‰Î½',0),(297094,8253,'zh','è´­ä¹°å’Œç®¡ç†æ–°å¢žèµ·å®¶\r\n',0),(297095,8253,'sv','KÃ¶pa och hantera tillÃ¤gg',0),(297096,8253,'it','Acquisto e gestione componenti aggiuntivi',0),(297097,8253,'tl','',0),(297098,8253,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3652;&#3611;',0),(297099,8253,'hi','à¤–à¤°à¥€à¤¦ à¤”à¤° à¤à¤¡-à¤‘à¤¨à¥à¤¸ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(297100,8253,'ms','Membeli dan menguruskan tambahan',0),(297101,8253,'ar','Ø´Ø±Ø§Ø¡ ÙˆØ¥Ø¯Ø§Ø±Ø© Ø§Ù„ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(297102,8253,'fr','Acheter et gÃ©rer les modules complÃ©mentaires',0),(297103,8253,'jp','è³¼å…¥ã—ã€ã‚¢ãƒ‰ã‚ªãƒ³ã®ç®¡ç†',0),(297104,8253,'pt','Adquirir e Gerenciar Complementos',0),(297105,8253,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð°Ð´ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°Ð¼Ð¸',0),(297106,8253,'es','Comprar y Supervisar los Add-Ons',0),(297107,8253,'de','Kaufen und Verwalten von Add-ons',0),(297108,8253,'en','Purchase And Manage Add-Ons',0),(297109,8254,'is','',0),(297110,8254,'dr','ÙˆÙŠÚ˜Ú¯ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(297111,8254,'pr','ÙˆÙŠÚ˜Ú¯ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª ',0),(297112,8254,'tr','Eklenti kullanÄ±labilir',0),(297113,8254,'pl','Dodatek dostÄ™pny',0),(297114,8254,'bg','Ð”Ð¾Ð±Ð°Ð²ÐºÐ°',0),(297115,8254,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ Ø§Ø¶Ø§ÙÛ-Ø¬Ø§Øª',0),(297116,8254,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð°Ðº Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½',0),(297117,8254,'vi','CÃ´ng ThÃªm TÃ­nh NÄƒng CÃ³ Sáºµn',0),(297118,8254,'af','Byvoegingskenmerke Beskikbaar',0),(297119,8254,'ro','Add-On disponibil',0),(297120,8254,'et','Lisandmooduli kÃ¤ttesaadavaks',0),(297121,8254,'si','Dodatek na voljo',0),(297122,8254,'ba','Add-On yang tersedia',0),(297123,8254,'nl','Add-On beschikbaar',0),(297124,8254,'fi','Apuohjelma on saatavana',0),(297125,8254,'no','Add-On tilgjengelig',0),(297126,8254,'da','TilfÃ¸jelse tilgÃ¦ngelig',0),(297127,8254,'ko','ë¶€ê°€ ê¸°ëŠ¥ ì œê³µ',0),(297128,8254,'he','×–×ž×™×Ÿ ×ª×•×¡×£ ×œ×ª×›×•× ×”',0),(297129,8254,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î¿ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î¿',0),(297130,8254,'zh','é™„åŠ å¯ç”¨åŠŸèƒ½\r\nä½ æ˜¯å¦è¦ï¼šå¢žåŠ æ–°è´§è¿\r\né™„åŠ å¯ç”¨åŠŸèƒ½\r\n',0),(297131,8254,'sv','TillÃ¤gg tillgÃ¤ngliga',0),(297132,8254,'it','Componente aggiuntivo disponibile',0),(297133,8254,'tl','',0),(297134,8254,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3609;&#3621;&#3633;&#3585;&#3625;&#3603;&#3632;&#3607;&#3637;&#3656;&#3617;&#3637;&#3651;&#3627;&#3657;&#3652;&#3604;&#3657;',0),(297135,8254,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤à¤¡-à¤‘à¤¨',0),(297136,8254,'ms','Tambahan disediakan',0),(297137,8254,'ar','Ø§Ù„ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ© Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(297138,8254,'fr','Module disponible',0),(297139,8254,'jp','åˆ©ç”¨å¯èƒ½ãªã‚¢ãƒ‰ã‚ªãƒ³',0),(297140,8254,'pt','Add-on disponÃ­vel',0),(297141,8254,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾',0),(297142,8254,'es','Caracteristica de Disp. de AmpliaciÃ³n Disponible',0),(297143,8254,'de','Add-on zur VerfÃ¼gung',0),(297144,8254,'en','Add-On Available',0),(297145,8255,'is','',0),(297146,8255,'dr','Ø³Ø§Ø¹Ø§Øª Ù¾ÙŠØ´ Ø±Ùˆ ',0),(297147,8255,'pr','Ø³Ø§Ø¹Ø§Øª Ù¾ÙŠØ´ Ø±Ùˆ ',0),(297148,8255,'tr','Saat ilerideki',0),(297149,8255,'pl','Godziny przed',0),(297150,8255,'bg','Ð§Ð°ÑÐ° Ð½Ð°Ð¿Ñ€ÐµÐ´',0),(297151,8255,'ur','Ø¢Ú¯Û’ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª',0),(297152,8255,'sr','Ð¡Ð°Ñ‚Ð° Ð¸ÑÐ¿Ñ€ÐµÐ´ Ð½Ð°Ñ',0),(297153,8255,'vi','Máº¥y giá» sáº¯p tá»›i',0),(297154,8255,'af','Ure Vooruit',0),(297155,8255,'ro','Ore Ã®nainte',0),(297156,8255,'et','Tundi edasi',0),(297157,8255,'si','Ure naprej',0),(297158,8255,'ba','Jam ke depan',0),(297159,8255,'nl','Uur vooruit',0),(297160,8255,'fi','Tuntia eteenpÃ¤in',0),(297161,8255,'no','Timer foran',0),(297162,8255,'da','Timer foran',0),(297163,8255,'ko','ì•žì„œ ì‹œê°„',0),(297164,8255,'he','×©×¢×•×ª ×§×“×™×ž×”',0),(297165,8255,'el','ÎÏÎµÏ‚ Î¼Ï€ÏÎ¿ÏƒÏ„Î¬',0),(297166,8255,'zh','å°æ—¶ä¹‹å‰\r\n',0),(297167,8255,'sv','Timmar framÃ¥t',0),(297168,8255,'it','Ore avanti',0),(297169,8255,'tl','',0),(297170,8255,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3651;&#3609;&#3629;&#3609;&#3634;&#3588;&#3605;',0),(297171,8255,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤†à¤—à¥‡',0),(297172,8255,'ms','Jam masa hadapan',0),(297173,8255,'ar','Ø³Ø§Ø¹Ø§Øª Ù…ØªÙ‚Ø¯Ù…Ø©',0),(297174,8255,'fr','Heures Ã  l\'avance',0),(297175,8255,'jp','æ™‚é–“å‰',0),(297176,8255,'pt','Horas em frente',0),(297177,8255,'ru','Ð§Ð°ÑÐ¾Ð² Ð²Ð¿ÐµÑ€ÐµÐ´',0),(297178,8255,'es','Horas en Adelante',0),(297179,8255,'de','+ Std.',0),(297180,8255,'en','Hours Ahead',0),(297181,8256,'is','',0),(297182,8256,'dr','Ø³Ø§Ø¹Ø§Øª Ú¯Ø°Ø´ØªÙ‡',0),(297183,8256,'pr','Ø³Ø§Ø¹Ø§Øª Ú¯Ø°Ø´ØªÙ‡',0),(297184,8256,'tr','Saat geride',0),(297185,8256,'pl','Godziny za',0),(297186,8256,'bg','Ð§Ð°ÑÐ° Ð·Ð°Ð´',0),(297187,8256,'ur','Ú¯Ú¾Ù†Ù¹Û’ Ú©Û’ Ù¾ÛŒÚ†Ú¾Û’',0),(297188,8256,'sr','Ð¡Ð°Ñ‚Ð¸ Ð¸Ð·Ð°',0),(297189,8256,'vi','Giá» sau',0),(297190,8256,'af','Ure agter',0),(297191,8256,'ro','Ore Ã®n urmÄƒ',0),(297192,8256,'et','Tundi jÃ¤Ã¤nud',0),(297193,8256,'si','Ure zadaj',0),(297194,8256,'ba','Jam di belakang',0),(297195,8256,'nl','Uren achter',0),(297196,8256,'fi','Tuntia jÃ¤ljessÃ¤',0),(297197,8256,'no','Timer bak',0),(297198,8256,'da','Timer bag',0),(297199,8256,'ko','ë’¤ì— ì‹œê°„',0),(297200,8256,'he','×©×¢×•×ª ×ž××—×•×¨×™',0),(297201,8256,'el','ÎÏÎµÏ‚ Ï€Î¯ÏƒÏ‰ Î±Ï€ÏŒ',0),(297202,8256,'zh','æ—¶é—´åŽ\r\n',0),(297203,8256,'sv','Timmar bakom',0),(297204,8256,'it','Ore dietro',0),(297205,8256,'tl','',0),(297206,8256,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3651;&#3609;&#3629;&#3604;&#3637;&#3605;',0),(297207,8256,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤ªà¥€à¤›à¥‡',0),(297208,8256,'ms','Jam di belakang',0),(297209,8256,'ar','Ø³Ø§Ø¹Ø§Øª Ù…ØªØ£Ø®Ø±Ø©',0),(297210,8256,'fr','Heures de retard',0),(297211,8256,'jp','æ™‚é–“é…ã‚Œ',0),(297212,8256,'pt','Horas atrÃ¡s',0),(297213,8256,'ru','Ð§Ð°ÑÐ¾Ð² Ð·Ð°',0),(297214,8256,'es','Horas Atrasadas',0),(297215,8256,'de','Stunden hinter',0),(297216,8256,'en','Hours Behind',0),(297217,8257,'is','',0),(297218,8257,'dr','Ø¨Ø¯ÙˆÙ† ØªÙØ§ÙˆØª ',0),(297219,8257,'pr','Ø¨Ø¯ÙˆÙ† ØªÙØ§ÙˆØª ',0),(297220,8257,'tr','Bir fark yok',0),(297221,8257,'pl','Nie ma rÃ³Å¼nicy',0),(297222,8257,'bg','ÐÑÐ¼Ð° Ñ€Ð°Ð·Ð»Ð¸ÐºÐ°',0),(297223,8257,'ur','Ú©ÙˆØ¦ÛŒ ÙØ±Ù‚ Ù†ÛÛŒÚº',0),(297224,8257,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ð·Ð»Ð¸ÐºÐµ',0),(297225,8257,'vi','KhÃ´ng khÃ¡c nhau',0),(297226,8257,'af','Geen Verskil',0),(297227,8257,'ro','Nici o diferenÅ£Äƒ',0),(297228,8257,'et','Pole vahet',0),(297229,8257,'si','Nobene razlike',0),(297230,8257,'ba','Tidak ada perbedaan',0),(297231,8257,'nl','Geen verschil',0),(297232,8257,'fi','Eroa',0),(297233,8257,'no','Ingen forskjell',0),(297234,8257,'da','Ingen forskel',0),(297235,8257,'ko','ì°¨ì´ê°€ ì—†ìŠµë‹ˆë‹¤',0),(297236,8257,'he','××™×Ÿ ×”×‘×“×œ',0),(297237,8257,'el','ÎšÎ±Î¼Î¯Î± Î´Î¹Î±Ï†Î¿ÏÎ¬',0),(297238,8257,'zh','æ²¡æœ‰å·®åˆ«\r\n',0),(297239,8257,'sv','Ingen skillnad',0),(297240,8257,'it','Nessuna differenza',0),(297241,8257,'tl','',0),(297242,8257,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3588;&#3623;&#3634;&#3617;&#3649;&#3605;&#3585;&#3605;&#3656;&#3634;&#3591;',0),(297243,8257,'hi','à¤•à¥‹à¤ˆ à¤«à¤°à¥à¤• à¤¨à¤¹à¥€à¤‚',0),(297244,8257,'ms','Tidak ada perbezaan',0),(297245,8257,'ar','Ù„Ø§ ÙØ±Ù‚',0),(297246,8257,'fr','Aucune diffÃ©rence',0),(297247,8257,'jp','é•ã„ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(297248,8257,'pt','Nenhuma diferenÃ§a',0),(297249,8257,'ru','ÐÐµÑ‚ Ð Ð°Ð·Ð»Ð¸Ñ‡Ð¸Ð¹',0),(297250,8257,'es','No Hay Diferencia',0),(297251,8257,'de','Keinen Unterschied',0),(297252,8257,'en','No Difference',0),(297253,8258,'is','',0),(297254,8258,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´ Ù‡Ø§ÙŠ  ÙƒØ§Ø±Ù…Ù†Ø¯',0),(297255,8258,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´ Ù‡Ø§ÙŠ  ÙƒØ§Ø±Ù…Ù†Ø¯',0),(297256,8258,'tr','Ã‡alÄ±ÅŸan notlarÄ±',0),(297257,8258,'pl','Pracownik notatki',0),(297258,8258,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(297259,8258,'ur','Ù…Ù„Ø§Ø²Ù… Ù†ÙˆÙ¹',0),(297260,8258,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(297261,8258,'vi','Ghi chÃº NhÃ¢n viÃªn ',0),(297262,8258,'af','Werknemer Notas',0),(297263,8258,'ro','Note de angajat',0),(297264,8258,'et','TÃ¶Ã¶taja mÃ¤rkused',0),(297265,8258,'si','Zaposlenega opombe',0),(297266,8258,'ba','Catatan karyawan',0),(297267,8258,'nl','Werknemer notities',0),(297268,8258,'fi','TyÃ¶ntekijÃ¤ toteaa',0),(297269,8258,'no','Ansatt notater',0),(297270,8258,'da','Medarbejder noter',0),(297271,8258,'ko','ì§ì› ë©”ëª¨',0),(297272,8258,'he','×”×¢×¨×•×ª ×¢×•×‘×“',0),(297273,8258,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(297274,8258,'zh','å‘˜å·¥å¤‡æ³¨\r\n',0),(297275,8258,'sv','AnstÃ¤lld anteckningar',0),(297276,8258,'it','Dipendente note',0),(297277,8258,'tl','',0),(297278,8258,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(297279,8258,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(297280,8258,'ms','Nota-Nota pekerja',0),(297281,8258,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ù…ÙˆØ¸Ù',0),(297282,8258,'fr','Notes de l\'employÃ©',0),(297283,8258,'jp','å¾“æ¥­å“¡ã®ãƒŽãƒ¼ãƒˆ',0),(297284,8258,'pt','Notas de empregado',0),(297285,8258,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(297286,8258,'es','Empleado Notas',0),(297287,8258,'de','Mitarbeiter-Notes',0),(297288,8258,'en','Employee Notes',0),(297289,8259,'is','',0),(297290,8259,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(297291,8259,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(297292,8259,'tr','BorÃ§lar Bill notlarÄ±',0),(297293,8259,'pl','ZobowiÄ…zania Bill notatki',0),(297294,8259,'bg','Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ Ð±Ð¸Ð» Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(297295,8259,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø¨Ù„ Ù†ÙˆÙ¹',0),(297296,8259,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð‘Ð¸Ð» Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(297297,8259,'vi','Ghi ChÃº HÃ³a ÄÆ¡n Pháº£i Tráº£',0),(297298,8259,'af','Uitgawes (RB) Rekening Notas',0),(297299,8259,'ro','Note de Bill ÅŸi datorii',0),(297300,8259,'et','VÃµlad Bill mÃ¤rkmed',0),(297301,8259,'si','Obveznosti Bill opombe',0),(297302,8259,'ba','Catatan tagihan hutang',0),(297303,8259,'nl','Schulden Bill notities',0),(297304,8259,'fi','Ostovelkojen Bill toteaa',0),(297305,8259,'no','LeverandÃ¸rgjeld Bill notater',0),(297306,8259,'da','Noterer sig kreditorstyring Bill',0),(297307,8259,'ko','ë¯¸ì§€ê¸‰ê¸ˆ ë¹Œ ë…¸íŠ¸',0),(297308,8259,'he','×–×›××™× ×‘×™×œ ×”×¢×¨×•×ª',0),(297309,8259,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(297310,8259,'zh','åº”ä»˜æ¬¾å¸å•è¯´æ˜Ž\r\n',0),(297311,8259,'sv','LeverantÃ¶rsskulder Bill anteckningar',0),(297312,8259,'it','Debiti Bill note',0),(297313,8259,'tl','',0),(297314,8259,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;',0),(297315,8259,'hi','Payables à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤¨à¥‹à¤Ÿà¥à¤¸',0),(297316,8259,'ms','Nota-Nota bil pemiutang',0),(297317,8259,'ar','Ù…Ø°ÙƒØ±Ø§Øª Ø¨ÙŠÙ„ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(297318,8259,'fr','Comptes crÃ©diteurs Bill Notes',0),(297319,8259,'jp','è²·æŽ›é‡‘è«‹æ±‚æ›¸ãƒŽãƒ¼ãƒˆ',0),(297320,8259,'pt','Notas de Bill de contas a pagar',0),(297321,8259,'ru','ÐžÑ‚Ð¼ÐµÑ‡Ð°ÐµÑ‚ Ð‘Ð¸Ð»Ð» ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(297322,8259,'es','Notas de Recibos Por Pagar',0),(297323,8259,'de','Verbindlichkeiten Bill Notes',0),(297324,8259,'en','Payables Bill Notes',0),(297325,8260,'is','',0),(297326,8260,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(297327,8260,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(297328,8260,'tr','SatÄ±cÄ± notlar',0),(297329,8260,'pl','Informacje o dostawcy',0),(297330,8260,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(297331,8260,'ur','ÙˆÛŒÙ†ÚˆØ± Ù†ÙˆÙ¹Ø³',0),(297332,8260,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(297333,8260,'vi','Ghi chÃº NgÆ°á»i bÃ¡n',0),(297334,8260,'af','Verskaffer Notas',0),(297335,8260,'ro','Furnizor de note',0),(297336,8260,'et','Tarnija mÃ¤rkmed',0),(297337,8260,'si','Prodajalec ugotavlja',0),(297338,8260,'ba','Penjual catatan',0),(297339,8260,'nl','Leverancier notities',0),(297340,8260,'fi','MyyjÃ¤ toteaa',0),(297341,8260,'no','LeverandÃ¸ren notater',0),(297342,8260,'da','Kreditor noter',0),(297343,8260,'ko','ê³µê¸‰ ì—…ì²´ ì •ë³´',0),(297344,8260,'he','×”×¢×¨×•×ª ×¡×¤×§',0),(297345,8260,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(297346,8260,'zh','ä¾›åº”å•†ç¥¨æ®\r\n',0),(297347,8260,'sv','LeverantÃ¶rens anteckningar',0),(297348,8260,'it','Fornitore note',0),(297349,8260,'tl','',0),(297350,8260,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(297351,8260,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(297352,8260,'ms','Nota pembekal',0),(297353,8260,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(297354,8260,'fr','Notes du vendeur',0),(297355,8260,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®å‘ŠçŸ¥ãƒšãƒ¼ã‚¸',0),(297356,8260,'pt','Notas de fornecedor',0),(297357,8260,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(297358,8260,'es','Notas de Proveedor',0),(297359,8260,'de','Hersteller-Notizen',0),(297360,8260,'en','Vendor Notes',0),(297361,8261,'is','',0),(297362,8261,'dr','Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø§ Ø¨Ù‡ØªØ±ÙŠÙ† ÙˆÙŠÚ˜Ú¯ÙŠÙ‡Ø§ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ø¢Ù†  Ø³ÙØ§Ø±Ø´ÙŠ ÙƒÙ†ÙŠØ¯',0),(297363,8261,'pr','Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø§ Ø¨Ù‡ØªØ±ÙŠÙ† ÙˆÙŠÚ˜Ú¯ÙŠÙ‡Ø§ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ø¢Ù†  Ø³ÙØ§Ø±Ø´ÙŠ ÙƒÙ†ÙŠØ¯',0),(297364,8261,'tr','Senin NolaPro bÃ¼yÃ¼k eklenti Ã¶zellikleri ile Ã¶zelleÅŸtirme',0),(297365,8261,'pl','Dostosuj swoje NolaPro z wielki dodatek rysy twarzy',0),(297366,8261,'bg','ÐŸÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ NolaPro Ñ Ð³Ð¾Ð»ÐµÐ¼Ð¸Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²ÐºÐ° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(297367,8261,'ur','Ø§Ù¾Ù†Û’ Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ø¹Ø¸ÛŒÙ… Ø§Ø¶Ø§ÙÛŒ Ø®ØµÙˆØµÛŒØ§Øª Ú©Û’ Ø³Ø§ØªÚ¾ ØªØ®ØµÛŒØµ Ú©Ø±ÛŒÚº',0),(297368,8261,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ðµ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ ÑÐ° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°Ð¼Ð° Ð·Ð° ÑÑ˜Ð°Ñ˜Ð°Ð½ Ð´Ð¾Ð´Ð°Ñ‚Ð°Ðº',0),(297369,8261,'vi','Táº¡o NolaPro theo Ã½ muá»‘n vá»›i nhá»¯ng chá»©c nÄƒng thÃªm tuyá»‡t vá»i',0),(297370,8261,'af','Pas u NolaPro aan met fantastiese inprop kenmerke',0),(297371,8261,'ro','Personaliza dumneavoastrÄƒ NolaPro cu caracteristici mare add-on',0),(297372,8261,'et','Kohandage oma NolaPro suur lisandmooduli funktsioone',0),(297373,8261,'si','Prilagodite vaÅ¡e NolaPro z veliko add-on znaÄilnosti',0),(297374,8261,'ba','Menyesuaikan NolaPro Anda dengan fitur-fitur great add-on',0),(297375,8261,'nl','Uw NolaPro met grote add-on functies aanpassen',0),(297376,8261,'fi','Mukauta NolaPro suuri lisÃ¤ominaisuuksia',0),(297377,8261,'no','Tilpasse din NolaPro med stor tilleggsfunksjoner',0),(297378,8261,'da','Tilpas din NolaPro med great add-on funktioner',0),(297379,8261,'ko','ì¢‹ì€ ë¶€ê°€ ê¸°ëŠ¥ NolaPro ì‚¬ìš©ìž ì§€ì •',0),(297380,8261,'he','×œ×”×ª××™× ××™×©×™×ª ×©×œ×š NolaPro ×¢× ×ª×›×•× ×•×ª ×”×¨×—×‘×” ×ž×¢×•×œ×”',0),(297381,8261,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼ÏŒÏƒÎµÏ„Îµ ÏƒÎ±Ï‚ NolaPro Î¼Îµ Î¼ÎµÎ³Î¬Î»Î· add-on Ï‡Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬',0),(297382,8261,'zh','ä»¥æžå¤§çš„é™„åŠ åŠŸèƒ½è‡ªå®šä¹‰æ‚¨çš„NolaPro\r\n',0),(297383,8261,'sv','Anpassa din NolaPro med stor tillÃ¤ggsfunktioner',0),(297384,8261,'it','Personalizza la tua installazione di NolaPro con utili componenti aggiuntivi',0),(297385,8261,'tl','',0),(297386,8261,'th','&#3611;&#3619;&#3633;&#3610;&#3649;&#3605;&#3656;&#3591; Nolapro &#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3585;&#3633;&#3610;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;&#3607;&',0),(297387,8261,'hi','à¤®à¤¹à¤¾à¤¨ à¤à¤¡-à¤‘à¤¨ à¤¸à¥à¤µà¤¿à¤§à¤¾à¤“à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤ªà¤•à¥€ NolaPro à¤…à¤¨à¥à¤•à¥‚à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(297388,8261,'ms','Menyesuaikan NolaPro anda dengan ciri-ciri tambahan yang hebat',0),(297389,8261,'ar','ØªØ®ØµÙŠØµ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ù…Ø¹ Ù…ÙŠØ²Ø§Øª Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ© ÙƒØ¨ÙŠØ±Ø©',0),(297390,8261,'fr','Personnalisez votre NolaPro avec grand ajouter des fonctions supplÃ©mentaires',0),(297391,8261,'jp','ã‚ãªãŸã® NolaPro ç´ æ™´ã‚‰ã—ã„ã‚¢ãƒ‰ã‚ªãƒ³æ©Ÿèƒ½ã‚’ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚ºã—ã¾ã™ã€‚',0),(297392,8261,'pt','Personalize seu NolaPro com caracterÃ­sticas de grande Add-on',0),(297393,8261,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð²Ð°Ñˆ NolaPro Ñ Ð±Ð¾Ð»ÑŒÑˆÐ¸Ð¼ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¹',0),(297394,8261,'es','Personalizar su NolaPro con add-ons con grandiosas caracterÃ­sticas',0),(297395,8261,'de','Passen Sie Ihre Artikel mit groÃŸen Add-on-Funktionen',0),(297396,8261,'en','Customize your NolaPro with great add-on features',0),(297397,8262,'is','',0),(297398,8262,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ ÙƒØ§Ù„Ø§ ',0),(297399,8262,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ ÙƒØ§Ù„Ø§ ',0),(297400,8262,'tr','Ã–ÄŸe Ekle',0),(297401,8262,'pl','Dodaj element',0),(297402,8262,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(297403,8262,'ur','Ú©Ø³ÛŒ Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(297404,8262,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(297405,8262,'vi','ThÃªm Má»™t Danh Má»¥c',0),(297406,8262,'af','Voeg \'n Ander Item By',0),(297407,8262,'ro','Adauga un articol',0),(297408,8262,'et','Lisa toode',0),(297409,8262,'si','Dodajanje elementa',0),(297410,8262,'ba','Tambahkan Item',0),(297411,8262,'nl','Een Item toevoegen',0),(297412,8262,'fi','Kohteen lisÃ¤Ã¤minen',0),(297413,8262,'no','Legge til et element',0),(297414,8262,'da','TilfÃ¸j et element',0),(297415,8262,'ko','í•­ëª© ì¶”ê°€',0),(297416,8262,'he','×”×•×¡×£ ×¤×¨×™×˜',0),(297417,8262,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î­Î½Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(297418,8262,'zh','å¢žåŠ ä¸€ä¸ªé¡¹ç›®\r\n',0),(297419,8262,'sv','LÃ¤gga till ett objekt',0),(297420,8262,'it','Aggiungere un elemento',0),(297421,8262,'tl','',0),(297422,8262,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(297423,8262,'hi','à¤•à¥‹à¤ˆ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(297424,8262,'ms','Tambah Item',0),(297425,8262,'ar','Ø¥Ø¶Ø§ÙØ© ØµÙ†Ù',0),(297426,8262,'fr','Ajouter un Article',0),(297427,8262,'jp','é …ç›®ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(297428,8262,'pt','Adicionar um Item',0),(297429,8262,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€',0),(297430,8262,'es','Agregar un item',0),(297431,8262,'de','HinzufÃ¼gen eines Elements',0),(297432,8262,'en','Add an Item',0),(297433,8263,'is','',0),(297434,8263,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÙŠÙ† Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø¨Ø§ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…ØªÙØ§ÙˆØª Ø§Ú¯Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ø´Ø¯ ',0),(297435,8263,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÙŠÙ† Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ù„Ø§ÙŠ Ù…Ø´Ø§Ø¨Ù‡ Ø¨Ø§ Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…ØªÙØ§ÙˆØª Ø§Ú¯Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ø´Ø¯ ',0),(297436,8263,'tr','AynÄ± madde farklÄ± seÃ§eneklerle varsa sipariÅŸ iÃ§in bunu kullanÄ±n.',0),(297437,8263,'pl','UmoÅ¼liwia to zamÃ³wienia tego samego przedmiotu z rÃ³Å¼nych opcji, jeÅ›li sÄ… dostÄ™pne.',0),(297438,8263,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ‚Ð¾Ð²Ð° Ð´Ð° Ð¿Ð¾Ñ€ÑŠÑ‡Ð°Ñ‚Ðµ ÐµÐ´Ð¸Ð½ Ð¸ ÑÑŠÑ‰ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸, Ð°ÐºÐ¾ Ð¸Ð¼Ð° Ñ‚Ð°ÐºÐ¸Ð²Ð°.',0),(297439,8263,'ur','ÛŒÛ Ù…Ø®ØªÙ„Ù Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© ÛÛŒ Ø´Û’ Ù…ÙˆØ¬ÙˆØ¯ ÛÙˆ ØªÙˆ Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Û”',0),(297440,8263,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÑÐµ Ð´Ð° Ð½Ð°Ñ€ÐµÐ´Ð¸ Ð¸ÑÑ‚Ð¾Ð³ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° ÑÐ° Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð¸Ñ‚Ð¸Ð¼ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°Ð¼Ð°, Ð°ÐºÐ¾ Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½.',0),(297441,8263,'vi','Sá»­ dá»¥ng cÃ¡i nÃ y Ä‘á»ƒ Ä‘áº·t cÃ¹ng loáº¡i hÃ ng vá»›i cÃ¡c lá»±a chá»n khÃ¡c nhau náº¿u cÃ³.',0),(297442,8263,'af','Gebruik hierdie om dieselfde item te bestel met ander opsies, indien beskikbaar.',0),(297443,8263,'ro','Folosi aceasta pentru a comanda acelaÅŸi articol cu diferite opÅ£iuni, dacÄƒ este disponibil.',0),(297444,8263,'et','Selle abil saate tellida erinevaid vÃµimalusi sama kauba olemasolu korral.',0),(297445,8263,'si','Uporabite to, da isti element z razliÄnimi moÅ¾nostmi, Äe je na voljo.',0),(297446,8263,'ba','Gunakan ini untuk memesan item yang sama dengan pilihan yang berbeda jika tersedia.',0),(297447,8263,'nl','Gebruik dit om hetzelfde item met verschillende opties als beschikbaar.',0),(297448,8263,'fi','TÃ¤mÃ¤n avulla voit mÃ¤Ã¤rÃ¤tÃ¤ saman nimikkeen eri vaihtoehtoja.',0),(297449,8263,'no','Bruk denne til Ã¥ bestille den samme varen med ulike alternativer hvis tilgjengelig.',0),(297450,8263,'da','Brug dette til at bestille den samme vare med forskellige muligheder, hvis den er tilgÃ¦ngelig.',0),(297451,8263,'ko','ì´ ì‚¬ìš© í•˜ ì—¬ ì‚¬ìš© ê°€ëŠ¥í•œ ê²½ìš° ë‹¤ë¥¸ ì˜µì…˜ì´ ìžˆëŠ” ë™ì¼í•œ í•­ëª©ì„ ì£¼ë¬¸.',0),(297452,8263,'he','×”×©×ª×ž×© ×‘××¤×©×¨×•×ª ×–×• ×›×“×™ ×œ×”×–×ž×™×Ÿ ××•×ª×• ×¤×¨×™×˜ ×¢× ××¤×©×¨×•×™×•×ª ×©×•× ×•×ª ×× ×”×•× ×–×ž×™×Ÿ.',0),(297453,8263,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒ Î³Î¹Î± Î½Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Ï„Î¿ Î¯Î´Î¹Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¼Îµ Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÎ­Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚, ÎµÎ¬Î½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î±.',0),(297454,8263,'zh','ä½¿ç”¨æ­¤å‘½ä»¤å¦‚æžœæœ‰ä¸åŒçš„é€‰æ‹©ä¸Žç›¸åŒçš„é¡¹ç›®ã€‚\r\n',0),(297455,8263,'sv','AnvÃ¤nds fÃ¶r att bestÃ¤lla samma objekt med olika alternativ om tillgÃ¤ngliga.',0),(297456,8263,'it','Usatelo per ordinare lo stesso articolo con diverse opzioni, se disponibile.',0),(297457,8263,'tl','',0),(297458,8263,'th','Use this to order the same item with different options if available.',0),(297459,8263,'hi','à¤‡à¤¸ à¤¯à¤¦à¤¿ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤µà¤¿à¤­à¤¿à¤¨à¥à¤¨ à¤µà¤¿à¤•à¤²à¥à¤ªà¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤¹à¥€ à¤®à¤¦ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚à¥¤',0),(297460,8263,'ms','Menggunakan ini membuat perkara yang sama dengan pilihan yang berbeza, jika ada.',0),(297461,8263,'ar','Ø§Ø³ØªØ®Ø¯Ù… Ù‡Ø°Ø§ Ø§Ù„Ø£Ù…Ø± Ø§Ù„Ø¨Ù†Ø¯ Ù†ÙØ³Ù‡ Ù…Ø¹ Ø®ÙŠØ§Ø±Ø§Øª Ù…Ø®ØªÙ„ÙØ© Ø¥Ø°Ø§ ÙƒØ§Ù†Øª Ù…ØªÙˆÙØ±Ø©.',0),(297462,8263,'fr','Ceci permet de commander l\'article mÃªme avec diffÃ©rentes options si elles sont disponibles.',0),(297463,8263,'jp','ã“ã‚Œã‚’ä½¿ç”¨ã—ã¦åˆ©ç”¨å¯èƒ½ãªå ´åˆã«åˆ¥ã®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã§åŒã˜ã‚¢ã‚¤ãƒ†ãƒ ã‚’æ³¨æ–‡ã—ã¾ã™ã€‚',0),(297464,8263,'pt','Use isso para pedir o mesmo item com opÃ§Ãµes diferentes, se disponÃ­vel.',0),(297465,8263,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ ÑÑ‚Ð¾ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ñ‚Ð°ÐºÐ¾Ð³Ð¾ Ð¶Ðµ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ñ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ñ‹Ð¼Ð¸ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð°Ð¼Ð¸, ÐµÑÐ»Ð¸ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾.',0),(297466,8263,'es','Usar Ã©ste para ordenar el mismo item con opciones diferentes si es disponible',0),(297467,8263,'de','Hiermit kÃ¶nnen Sie den gleichen Artikel mit verschiedenen Optionen ggf. bestellen.',0),(297468,8263,'en','Use this to order the same item with different options if available.',0),(297469,8264,'is','',0),(297470,8264,'dr','Ø³ØªÙˆÙ† Ø¨Ù‡Ø±Ù‡ Ø§ÙØ²ÙˆØ¯Ù‡ Ø±Ø§ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(297471,8264,'pr','Ø³ØªÙˆÙ† Ø¨Ù‡Ø±Ù‡ Ø§ÙØ²ÙˆØ¯Ù‡ Ø±Ø§ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(297472,8264,'tr','Faiz eklenen sÃ¼tun deyimi Ã¼zerinde gÃ¶sterme<br><small>Sadece onay yokluksa kullanma faiz hesaplamalarÄ±</small>',0),(297473,8264,'pl','Nie wykazujÄ… zainteresowania dodano kolumnÄ™ na oÅ›wiadczenie<br><small>Tylko SprawdÅº czy nie obliczeÅ„ procentowych za pomocÄ…</small>',0),(297474,8264,'bg','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð° ÐºÐ¾Ð»Ð¾Ð½Ð° Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°<br><small>Ð¡Ð°Ð¼Ð¾ ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ, Ð°ÐºÐ¾ Ð½Ðµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑÐ° Ð½Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ÑÑ‚Ð°</small>',0),(297475,8264,'ur','Ø³ÙˆØ¯ Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ú©Ø§Ù„Ù… Ù¾Ø± Ø¨ÛŒØ§Ù† Ù†Ù…Ø§ÛŒØ´ Ù†Û Ú©Ø±ÛŒÚº Û”<br><small>ØµØ±Ù Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Ø§Ú¯Ø± Ù†ÛÛŒÚº Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ Ø³ÙˆØ¯ Ø­Ø³Ø§Ø¨</small>',0),(297476,8264,'sr','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·ÑƒÑ˜ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑÐ¾Ð²Ð°ÑšÐµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ñƒ ÐºÐ¾Ð»Ð¾Ð½Ñƒ Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ<br><small>Ð¡Ð°Ð¼Ð¾ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°ÐºÐ¾ Ð½Ðµ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ ÐºÐ°Ð¼Ð°Ñ‚Ðµ Ð·Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ</small>',0),(297477,8264,'vi','KhÃ´ng hiá»ƒn thá»‹ cá»™t lÃ£i suáº¥t thÃªm vÃ o trÃªn sao kÃªChá»‰ Ä‘Ã¡nh dáº¥u náº¿u khÃ´ng dÃ¹ng tÃ­nh toÃ¡n lÃ£i suáº¥t',0),(297478,8264,'af','Moenie die Kolom van Rente Bygevoeg Wys op Staat<br>Slegs Tjeks indien Nie Rente Gebruik',0),(297479,8264,'ro','Nu aratÄƒ interes adÄƒugat coloana pe declaraÅ£ie<br><small>Doar verifica dacÄƒ nu folosire interes calcule</small>',0),(297480,8264,'et','Kuva huvi lisatud veerg avaldus<br><small>Ainult sisse kui mitte kasutamine Viivisearvutuste</small>',0),(297481,8264,'si','Ne kaÅ¾ejo interesa dodani stolpec na izjavo<br><small>Samo Äek Äe ne Using obresti izraÄuni</small>',0),(297482,8264,'ba','Tidak menunjukkan minat ditambahkan kolom pada pernyataan<br><small>Hanya Check jika tidak menggunakan bunga perhitungan</small>',0),(297483,8264,'nl','Vertonen geen belang toegevoegde kolom over de verklaring van<br><small>Alleen controleren als niet gebruiken belang berekeningen</small>',0),(297484,8264,'fi','Ã„lÃ¤ NÃ¤ytÃ¤ kiinnostusta lisÃ¤ttyyn sarakkeeseen tiliotteessa<br><small>Vain sisÃ¤Ã¤n jos ei kÃ¤yttÃ¤minen edun laskelmat</small>',0),(297485,8264,'no','Ikke Vis interesse ekstra kolonnen pÃ¥ uttalelse<br><small>Bare sjekk hvis ikke bruke renteberegninger</small>',0),(297486,8264,'da','Ikke vis interesse tilfÃ¸jet kolonne pÃ¥ kontoudtog<br><small>Kun Check hvis ikke brug renteberegninger</small>',0),(297487,8264,'ko','ë¬¸ì— ê´€ì‹¬ ì¶”ê°€ ì—´ì„ í‘œì‹œ í•˜ì§€ ì•ŠìŒ<br><small>ë§Œ ì²´í¬ í•˜ì§€ ì•Šì„ ê²½ìš° ì‚¬ìš© í•˜ ì—¬ ì´ìž ê³„ì‚°</small>',0),(297488,8264,'he','××œ ×ª×¦×™×’ ×¢×ž×•×“×” × ×•×¡×¤×” ×¨×™×‘×™×ª ×¢×œ ×”×”×¦×”×¨×”<br><small>×¨×§ ×¡×™×ž×•×Ÿ ×× ×œ× ×¢× ×™×™×Ÿ ×‘××ž×¦×¢×•×ª ×—×™×©×•×‘×™×</small>',0),(297489,8264,'el','Î”ÎµÎ½ Î´ÎµÎ¯Ï‡Î½Î¿Ï…Î½ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î· ÏƒÏ„Î®Î»Î· ÏƒÎµ Î´Î®Î»Ï‰ÏƒÎ·<br><small>ÎœÏŒÎ½Î¿ ÎµÎ»Î­Î³Ï‡Î¿Ï… ÎµÎ¬Î½ ÏŒÏ‡Î¹ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Î¯</small>',0),(297490,8264,'zh','ä¸æ˜¾ç¤ºæ·»åŠ åœ¨å£°æ˜Žåˆ—ä¸Šçš„åˆ©æ¯åªæ£€æŸ¥æ˜¯å¦æ²¡æœ‰ä½¿ç”¨åˆ©æ¯è®¡ç®—\r\n',0),(297491,8264,'sv','Inte Visa intresse extra kolumn uttalande<br><small>Bara kolla om inte anvÃ¤nda rÃ¤nteberÃ¤kningar</small>',0),(297492,8264,'it','Non mostrare interesse aggiunto colonna sulla dichiarazione<br><small>Solo Check se non interesse utilizzando i calcoli</small>',0),(297493,8264,'tl','',0),(297494,8264,'th','Do Not Show Interest Added Column on Statement<br><small>Only Check if Not Using Interest Calculations</small>',0),(297495,8264,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤œà¥‹à¤¡à¤¼à¥‡ à¤—à¤ à¤¸à¥à¤¤à¤‚à¤­ à¤ªà¤° à¤¬à¤¯à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤<br><small>à¤•à¥‡à¤µà¤² à¤šà¥‡à¤• à¤…à¤—à¤° à¤¨à¤¹à¥€à¤‚ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤¬à¥à¤¯à¤¾à¤œ à¤•à¥€ à¤—à¤£à¤¨à¤¾</small>',0),(297496,8264,'ms','Jangan Tunjukkan kolum ditambah faedah pada penyata<br><small>Hanya Daftar jika tidak pengiraan faedah menggunakan</small>',0),(297497,8264,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(297498,8264,'fr','Ne prÃ©sentent pas d\'intÃ©rÃªt colonne ajoutÃ©e par dÃ©claration<br><small>Seulement vÃ©rifier si non calculs de l\'intÃ©rÃªt de l\'utilisation</small>',0),(297499,8264,'jp','æ˜Žç´°æ›¸ã«é–¢å¿ƒè¿½åŠ ã•ã‚ŒãŸåˆ—ã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚<br><small>ã®ã¿ãƒã‚§ãƒƒã‚¯ã•ã‚Œã¦ã„ãªã„å ´åˆã‚’ä½¿ç”¨ã—ã¦åˆ©æ¯è¨ˆç®—</small>',0),(297500,8264,'pt','NÃ£o mostrar interesse coluna adicionada na declaraÃ§Ã£o<br><small>SÃ³ cheque se nÃ£o interesse usando cÃ¡lculos</small>',0),(297501,8264,'ru','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð° ÐºÐ¾Ð»Ð¾Ð½ÐºÐ° Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ<br><small>ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ, ÐµÑÐ»Ð¸ Ð½Ðµ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð¾Ð²</small>',0),(297502,8264,'es','No Mostrar la Columna que agrega los interÃ©ses en la DeclaraciÃ³n<br><small>Solo Checar si No Esta Usando los InterÃ©ses',0),(297503,8264,'de','Zeigen Sie Interesse hinzugefÃ¼gte Spalte nicht auf Anweisung<br><small>Nur prÃ¼fen, wenn nicht mit Interesse Berechnungen</small>',0),(297504,8264,'en','Do Not Show Interest Added Column on Statement<br><small>Only Check if Not Using Interest Calculations</small>',0),(297505,8265,'is','',0),(297506,8265,'dr','Ø³ØªÙˆÙ† Ù…Ø§Ù†Ø¯Ù‡ Ø§Ø² Ù‚Ø¨Ù„ Ø±Ø§ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(297507,8265,'pr','Ø³ØªÙˆÙ† Ù…Ø§Ù†Ø¯Ù‡ Ø§Ø² Ù‚Ø¨Ù„ Ø±Ø§ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(297508,8265,'tr','Deyim Ã¶nceki bakiye sÃ¼tunu gÃ¶sterme',0),(297509,8265,'pl','Nie pokazuj kolumnie Saldo poprzedniego instrukcja',0),(297510,8265,'bg','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð±Ð°Ð»Ð°Ð½Ñ ÐºÐ¾Ð»Ð¾Ð½Ð° Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(297511,8265,'ur','Ù¾ÛŒØ´Ú¯ÛŒ ØªÙˆØ§Ø²Ù† Ú©Ø§Ù„Ù… Ù¾Ø± Ø¨ÛŒØ§Ù† Ù†Ù…Ø§ÛŒØ´ Ù†Û Ú©Ø±ÛŒÚº Û”',0),(297512,8265,'sr','ÐÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜ ÐºÐ¾Ð»Ð¾Ð½Ð° Ð¸Ð³ÑƒÐ¼Ð°Ð½ ÑÐ°Ð»Ð´Ð¾ Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(297513,8265,'vi','KhÃ´ng hiá»ƒn thá»‹ cá»™t dÆ° ná»£ trÆ°á»›c trÃªn sao kÃª',0),(297514,8265,'af','Moenie Vorige Balanskolom op Staat aandui nie',0),(297515,8265,'ro','Nu aratÄƒ prealabilÄƒ echilibrului coloanei pe declaraÅ£ie',0),(297516,8265,'et','Kuva eelneva saldoveeru avaldus',0),(297517,8265,'si','Ne PokaÅ¾i stolpec s predhodno stanje na izpisku',0),(297518,8265,'ba','Tidak menunjukkan kolom sebelumnya keseimbangan pada pernyataan',0),(297519,8265,'nl','Vertonen geen voorafgaande saldokolom over de verklaring van',0),(297520,8265,'fi','Ã„lÃ¤ NÃ¤ytÃ¤ ennen summasarakkeen tiliotteessa',0),(297521,8265,'no','Ikke Vis tidligere Saldo-kolonnen i setningen',0),(297522,8265,'da','Vis ikke forudgÃ¥ende saldokolonnen redegÃ¸relse',0),(297523,8265,'ko','ë¬¸ì— ì‚¬ì „ ê· í˜• ì—´ì„ í‘œì‹œ í•˜ì§€ ì•ŠìŒ',0),(297524,8265,'he','××œ ×ª×¦×™×’ ×¢×ž×•×“×” ××™×–×•×Ÿ ×ž×•×§×“×ž×ª ×¢×œ ×”×”×¦×”×¨×”',0),(297525,8265,'el','Î”ÎµÎ½ Î´ÎµÎ¯Ï‡Î½Î¿Ï…Î½ ÏƒÏ„Î®Î»Î· Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± ÏƒÏ„Î· Î´Î®Î»Ï‰ÏƒÎ·',0),(297526,8265,'zh','ä¸æ˜¾ç¤ºå£°æ˜Žä¸­å…ˆå‰çš„ç»“ä½™æ \r\n',0),(297527,8265,'sv','Visa inte tidigare saldo-kolumnen pÃ¥ kontoutdrag',0),(297528,8265,'it','Non mostrare colonna Saldo previa dichiarazione',0),(297529,8265,'tl','',0),(297530,8265,'th','&#3652;&#3617;&#3656;&#3605;&#3657;&#3629;&#3591;&#3649;&#3626;&#3604;&#3591;&#3649;&#3606;&#3623;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3618;&#3585;&#3617;&#3634;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;',0),(297531,8265,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤¶à¥‡à¤· à¤¸à¥à¤¤à¤‚à¤­ à¤ªà¤° à¤¬à¤¯à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(297532,8265,'ms','Jangan Tunjukkan kolum terlebih dahulu Baki pada penyata',0),(297533,8265,'ar','Ø¹Ø¯Ù… Ø¥Ø¸Ù‡Ø§Ø± Ø¹Ù…ÙˆØ¯ Ø§Ù„Ø±ØµÙŠØ¯ Ù…Ø³Ø¨Ù‚ Ø¹Ù„Ù‰ Ø§Ù„Ø¨ÙŠØ§Ù†',0),(297534,8265,'fr','Ne prÃ©sentent pas de colonne solde antÃ©rieur par dÃ©claration',0),(297535,8265,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã«äº‹å‰å·®å¼•æ®‹é«˜] åˆ—ã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(297536,8265,'pt','NÃ£o mostrar equilÃ­brio prÃ©vio coluna na instruÃ§Ã£o',0),(297537,8265,'ru','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ð»Ð±ÐµÑ† Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ Ð±Ð°Ð»Ð°Ð½ÑÐ° Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(297538,8265,'es','No Muestra el Columna de Balance Anterior en la DeclaraciÃ³n',0),(297539,8265,'de','Zeigen Sie vorherige Bilanzspalte nicht auf Anweisung',0),(297540,8265,'en','Do Not Show Prior Balance Column On Statement',0),(297541,8266,'is','',0),(297542,8266,'dr','- Ø¬Ø²Ø¦ÙŠØ§Øª Ø¨ÛŒØ¬Ú©',0),(297543,8266,'pr','Ø®Ù„Ø§ØµÙ‡ Ø¨Ø§ Ø®Ø±ÙŠØ¯Ø§Ø± â€“ Ø­Ù…Ù„ Ø¨Ù‡   - Ø¬Ø²Ø¦ÙŠØ§Øª ÙØ§ÙƒØªÙˆØ±',0),(297544,8266,'tr','MÃ¼ÅŸteri & gemi ayrÄ±ntÄ±lÄ± fatura kesmek - Ã–zeti',0),(297545,8266,'pl','Podsumowanie przez klienta & statku do - faktury szczegÃ³Å‚y',0),(297546,8266,'bg','Ð ÐµÐ·ÑŽÐ¼Ðµ Ð¾Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° & ÐºÐ¾Ñ€Ð°Ð± Ð·Ð° - Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»',0),(297547,8266,'ur','Ø®Ù„Ø§ØµÛ Ú©Ø³Ù¹Ù…Ø± & Ø¬ÛØ§Ø² ØªÙØµÛŒÙ„ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ - Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(297548,8266,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ ÐºÑƒÐ¿Ñ†Ð° & Ð±Ñ€Ð¾Ð´ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ - Ð´ÐµÑ‚Ð°Ñ™',0),(297549,8266,'vi','Tá»•ng há»£p theo khÃ¡ch hÃ ng & dá»‹a chá»‰ hÃ³a Ä‘Æ¡n chi tiáº¿t',0),(297550,8266,'af','Opsomming per Klant/KliÃ«nt & Versend Aan - Faktuurdetail',0),(297551,8266,'ro','Rezumat de client & nava a - factura detaliu',0),(297552,8266,'et','KokkuvÃµte klientide & laeva suhtes - arve Ã¼ksikasjad',0),(297553,8266,'si','Povzetek kupca & ladje zaraÄunati - podrobnosti',0),(297554,8266,'ba','Ringkasan oleh pelanggan & kapal untuk - faktur rinci',0),(297555,8266,'nl','Samenvatting door klant & schip naar - Factuurspecificatie',0),(297556,8266,'fi','Yhteenveto asiakkaan & aluksen ja - laskun tiedot',0),(297557,8266,'no','Sammendrag av kunden & lever til - faktura detaljer',0),(297558,8266,'da','ResumÃ© af kunden & skib til - faktura detaljer',0),(297559,8266,'ko','ê³ ê° & ë°° ê²Œ-ì¸ë³´ì´ìŠ¤ ì„¸ë¶€ ì‚¬í•­ì— ì˜í•´ ìš”ì•½',0),(297560,8266,'he','×¡×™×›×•× ×¢×œ-×™×“×™ ×”×œ×§×•×— & ×”×¡×¤×™× ×” ×›×“×™ - ×¤×™×¨×•×˜ ×—×©×‘×•× ×™×ª',0),(297561,8266,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Î±Ï€ÏŒ Ï€ÎµÎ»Î¬Ï„Î· & Ï€Î»Î¿Î¯Î¿ Î½Î± - Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(297562,8266,'zh','æŒ‰å®¢æˆ·åŠæ”¶è´§æ‘˜è¦- å‘ç¥¨æ˜Žç»†\r\n',0),(297563,8266,'sv','Sammanfattning av kunden & fartyget att - fakturera detalj',0),(297564,8266,'it','Riepilogo di Customer & nave a - fattura dettaglio',0),(297565,8266,'tl','',0),(297566,8266,'th','&#3626;&#3619;&#3640;&#3611;&#3650;&#3604;&#3618;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3649;&#3621;&#3632;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3',0),(297567,8266,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• & à¤œà¤¹à¤¾à¤œ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ - à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(297568,8266,'ms','Ringkasan oleh pelanggan & kapal ke - invois terperinci',0),(297569,8266,'ar','Ù…ÙˆØ¬Ø² Ù…Ù‚Ø¯Ù… Ù…Ù† Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø¢Ù†Ø¯ Ø§Ù„Ø³ÙÙŠÙ†Ø© ØªÙØ§ØµÙŠÙ„ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(297570,8266,'fr','RÃ©sumÃ© par client & navire Ã  - dÃ©tail de la facture',0),(297571,8266,'jp','é¡§å®¢ & èˆ¹ã‚’ - è«‹æ±‚æ›¸ã®è©³ç´°ã®è¦ç´„',0),(297572,8266,'pt','Resumo por cliente & navio para - detalhes de facturas',0),(297573,8266,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° & ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ - Ð²Ñ‹ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð´ÐµÑ‚Ð°Ð»ÑŒ',0),(297574,8266,'es','ResÃºmen Por Cliente & Enviar-A - Detalle de Factura',0),(297575,8266,'de','Zusammenfassung von Kunden & Schiff, - Detail in Rechnung zu stellen',0),(297576,8266,'en','Summary By Customer & Ship To - Invoice Detail',0),(297577,8267,'is','',0),(297578,8267,'dr','Ø®Ù„Ø§ØµÙ‡ Ø¬Ù…Ø¹â€Œ ÙƒÙ„ Ø·Ø¨Ù‚ Ø®Ø±ÙŠØ¯Ø§Ø± Ùˆ Ø­Ù…Ù„ Ø¨Ù‡ ',0),(297579,8267,'pr','Ø®Ù„Ø§ØµÙ‡ Ø¬Ù…Ø¹â€Œ ÙƒÙ„ Ø·Ø¨Ù‚ Ø®Ø±ÙŠØ¯Ø§Ø± Ùˆ Ø­Ù…Ù„ Ø¨Ù‡ ',0),(297580,8267,'tr','Ã–zet Toplam MÃ¼ÅŸteri & gemiye tarafÄ±ndan',0),(297581,8267,'pl','Podsumowanie caÅ‚oÅ›ci przez klienta & statku',0),(297582,8267,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½Ð¸ Ð¾Ð±Ñ‰Ð¾ Ð¾Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° & ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(297583,8267,'ur','Ø®Ù„Ø§ØµÛ Ú©Ù„ Ú©Ø³Ù¹Ù…Ø± & Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(297584,8267,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°ÑšÐµ ÑƒÐºÑƒÐ¿Ð½Ð¾ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ ÐºÑƒÐ¿Ñ†Ð° Ð¸ Ð´Ð° Ð±Ñ€Ð¾Ð´',0),(297585,8267,'vi','Tá»•ng há»£p tá»•ng cá»™ng theo khÃ¡ch hÃ ng & dá»‹a chá»‰ hÃ³a Ä‘Æ¡n chi tiáº¿t',0),(297586,8267,'af','Opsommingstotaal per Klant/KliÃ«nt & Versend Aan',0),(297587,8267,'ro','Rezumat Total de client & nava sÄƒ',0),(297588,8267,'et','KokkuvÃµtlik kokku kliendi & laeva poolt',0),(297589,8267,'si','Povzetek skupaj s stranko & ladje za',0),(297590,8267,'ba','Ringkasan Total oleh pelanggan & kapal untuk',0),(297591,8267,'nl','Samenvatting totaal door klant & schip',0),(297592,8267,'fi','Yhteenveto loppusumma lasketaan asiakkaan & aluksen',0),(297593,8267,'no','Sammendrag totalt av kunden & skip',0),(297594,8267,'da','Sammenfattende alt efter kunde & skib til',0),(297595,8267,'ko','ê³ ê° & ìš°ì£¼ì„ ì— ì˜í•´ ìš”ì•½ ì´',0),(297596,8267,'he','×›×•×œ×œ ×¡×™×›×•× ×¢×œ ×™×“×™ ×”×œ×§×•×— & ×”×¡×¤×™× ×”',0),(297597,8267,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬ Î±Ï€ÏŒ Ï€ÎµÎ»Î¬Ï„Î· & Ï€Î»Î¿Î¯Î¿ Î½Î±',0),(297598,8267,'zh','æŒ‰å®¢æˆ·å’Œæ”¶è´§åœ°æ‘˜è¦æ±‡æ€»\r\n',0),(297599,8267,'sv','Sammanfattning totalt av kunden & fartyget fÃ¶r att',0),(297600,8267,'it','Sintesi totale di Customer & nave a',0),(297601,8267,'tl','',0),(297602,8267,'th','&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;&#3650;&#3604;&#3618;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3606;&#3638;&#3591;',0),(297603,8267,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤•à¥à¤² à¤—à¥à¤°à¤¾à¤¹à¤• & à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(297604,8267,'ms','Ringkasan jumlah oleh pelanggan & kapal',0),(297605,8267,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ù…ÙˆØ¬Ø²Ø© Ù…Ù† Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¢Ù†Ø¯ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(297606,8267,'fr','Sommaire Total par client & navire Ã ',0),(297607,8267,'jp','é¡§å®¢ & ã«èˆ¹ã«ã‚ˆã£ã¦ã‚µãƒžãƒªãƒ¼åˆè¨ˆ',0),(297608,8267,'pt','Resumo Total pelo cliente & navio para',0),(297609,8267,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ Ð²ÑÐµÐ³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° & ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(297610,8267,'es','Totales de ResÃºmen Por Cliente & Enviar-a',0),(297611,8267,'de','Zusammenfassung insgesamt von Kunden & Schiff',0),(297612,8267,'en','Summary Total by Customer & Ship To',0),(297613,8268,'is','',0),(297614,8268,'dr','(Ø¨ÛŒÙ„Ø§Ù†Ø³ Ù‡Ø§ÙŠ) Ø§ÙØªØªØ§ Ø­ÙŠÙ‡',0),(297615,8268,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ ØªØ±Ø§Ø²Ù‡Ø§ÙŠ (Ù…Ø§Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ) Ø§ÙØªØªØ§ Ø­ÙŠÙ‡',0),(297616,8268,'tr','Bakiyeleri geri baÅŸlÄ±yor',0),(297617,8268,'pl','PowrÃ³t do poczÄ…tku salda',0),(297618,8268,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÐºÑŠÐ¼ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½ÑÐ¸',0),(297619,8268,'ur','ÙˆØ§Ù¾Ø³ Ø¨ÛŒÙ„Ù†Ø³ Ø´Ø±ÙˆØ¹ Ú©Ø±',0),(297620,8268,'sr','ÐÐ°Ð·Ð°Ð´ Ð½Ð° Ð¿Ð¾Ñ‡Ð¸ÑšÐµ ÑÐ°Ð»Ð´Ð°',0),(297621,8268,'vi','Quay láº¡i sá»‘ dÆ° Ä‘áº§u ká»³',0),(297622,8268,'af','Terug na Begin Balanse',0),(297623,8268,'ro','ÃŽnapoi la Ã®nceputul-solduri',0),(297624,8268,'et','Tagasi algsaldode juurde',0),(297625,8268,'si','Nazaj na zaÄetek bilance',0),(297626,8268,'ba','Kembali ke awal saldo',0),(297627,8268,'nl','Terug naar het begin van de saldi',0),(297628,8268,'fi','Palaa alkusaldot',0),(297629,8268,'no','Tilbake til begynnelsen saldoer',0),(297630,8268,'da','Tilbage til begyndelsen saldi',0),(297631,8268,'ko','ë‹¤ì‹œ ê· í˜•ì„ ì‹œìž‘ í•˜',0),(297632,8268,'he','×—×–×¨×” ××œ ×ª×—×™×œ×ª ×™×ª×¨×•×ª',0),(297633,8268,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î·Î½ Î±ÏÏ‡Î® Ï„Ï‰Î½ Ï…Ï€Î¿Î»Î¿Î¯Ï€Ï‰Î½',0),(297634,8268,'zh','å›žåˆ°æœŸåˆä½™é¢\r\n',0),(297635,8268,'sv','Tillbaka till bÃ¶rjan saldon',0),(297636,8268,'it','Torna a inizio saldi',0),(297637,8268,'tl','',0),(297638,8268,'th','&#3585;&#3621;&#3633;&#3610;&#3626;&#3641;&#3656;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3605;&#3657;&#3609;&#3591;&#3623;&#3604;',0),(297639,8268,'hi','à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤µà¤¾à¤ªà¤¸ à¤¶à¥à¤°à¥à¤†à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(297640,8268,'ms','Kembali ke awal baki',0),(297641,8268,'ar','Ø§Ù„Ø±Ø¬ÙˆØ¹ Ø¥Ù„Ù‰ Ø§Ù„Ø£Ø±ØµØ¯Ø© Ø§Ù„Ø¥ÙØªØªØ§Ø­ÙŠØ©',0),(297642,8268,'fr','Retour au dÃ©but des soldes',0),(297643,8268,'jp','é–‹å§‹æ®‹é«˜ã«æˆ»ã‚‹',0),(297644,8268,'pt','Volta ao inÃ­cio saldos',0),(297645,8268,'ru','ÐÐ°Ð·Ð°Ð´ Ðº ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ð¾Ð¼Ñƒ Ð‘Ð°Ð»Ð°Ð½ÑÑƒ',0),(297646,8268,'es','Regresar a Saldos de Inicio',0),(297647,8268,'de','ZurÃ¼ck zum Anfang Salden',0),(297648,8268,'en','Back to Beginning Balances',0),(297649,8269,'is','',0),(297650,8269,'dr','B2B Ú†Ø§Ù¾ ÛŒÙˆØ²Ø±Ø§Ù†  ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(297651,8269,'pr','B2B Ú†Ø§Ù¾ ÙƒØ§Ø±Ø¨Ø±Ø§Ù†  ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(297652,8269,'tr','B2B yazdÄ±rma kullanÄ±cÄ±larÄ±',0),(297653,8269,'pl','Wydruku uÅ¼ytkownicy B2B',0),(297654,8269,'bg','B2B Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(297655,8269,'ur','B2B Ú†Ú¾Ù¾Ø§Ø¦ÛŒ ØµØ§Ø±ÙÛŒÙ†',0),(297656,8269,'sr','Ð‘2Ð‘ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸',0),(297657,8269,'vi','In NgÆ°á»i Sá»­ Dá»¥ng B2B',0),(297658,8269,'af','B2B Druk Gebruikers',0),(297659,8269,'ro','Utilizatorii de imprimare B2B',0),(297660,8269,'et','B2B Prindi kasutajad',0),(297661,8269,'si','B2B tiskanja uporabnikov',0),(297662,8269,'ba','B2B cetak pengguna',0),(297663,8269,'nl','B2B afdrukken gebruikers',0),(297664,8269,'fi','B2B tulosta kÃ¤yttÃ¤jÃ¤t',0),(297665,8269,'no','B2B brukere',0),(297666,8269,'da','B2B Print brugere',0),(297667,8269,'ko','B2B ì¸ì‡„ ì‚¬ìš©ìž',0),(297668,8269,'he','×ž×©×ª×ž×©×™× ×”×“×¤×¡×” B2B',0),(297669,8269,'el','B2B ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½',0),(297670,8269,'zh','å•†ä¸šå¯¹å•†ä¸šçš„æ‰“å°ç”¨æˆ·\r\n',0),(297671,8269,'sv','B2B ut anvÃ¤ndare',0),(297672,8269,'it','Stampa utenti B2B',0),(297673,8269,'tl','',0),(297674,8269,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657; B2B',0),(297675,8269,'hi','B2B à¤®à¥à¤¦à¥à¤°à¤£ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚',0),(297676,8269,'ms','B2B cetakan pengguna',0),(297677,8269,'ar','B2B Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(297678,8269,'fr','Utilisateurs impression B2B',0),(297679,8269,'jp','B2B å°åˆ·ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(297680,8269,'pt','UsuÃ¡rios de impressÃ£o de B2B',0),(297681,8269,'ru','B2B Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(297682,8269,'es','N2N Usuarios de ImpresiÃ³n',0),(297683,8269,'de','B2B-Drucken-Benutzer',0),(297684,8269,'en','B2B Print Users',0),(297685,8270,'is','',0),(297686,8270,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(297687,8270,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(297688,8270,'tr','Veri',0),(297689,8270,'pl','Danych',0),(297690,8270,'bg','Ð”Ð°Ð½Ð½Ð¸',0),(297691,8270,'ur','Ú©ÙˆØ§Ø¦Ù',0),(297692,8270,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸',0),(297693,8270,'vi','Dá»¯ liá»‡u',0),(297694,8270,'af','Data',0),(297695,8270,'ro','Date',0),(297696,8270,'et','Andmed',0),(297697,8270,'si','Podatkov',0),(297698,8270,'ba','Data',0),(297699,8270,'nl','Gegevens',0),(297700,8270,'fi','Tiedot',0),(297701,8270,'no','Data',0),(297702,8270,'da','Data',0),(297703,8270,'ko','ë°ì´í„°',0),(297704,8270,'he','× ×ª×•× ×™×',0),(297705,8270,'el','Î”ÎµÎ´Î¿Î¼Î­Î½Î±',0),(297706,8270,'zh','æ•°æ®\r\n',0),(297707,8270,'sv','Data',0),(297708,8270,'it','Dati',0),(297709,8270,'tl','',0),(297710,8270,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(297711,8270,'hi','à¤¡à¥‡à¤Ÿà¤¾',0),(297712,8270,'ms','Data',0),(297713,8270,'ar','Ø¨ÙŠØ§Ù†Ø§Øª',0),(297714,8270,'fr','DonnÃ©es',0),(297715,8270,'jp','ãƒ‡ãƒ¼ã‚¿',0),(297716,8270,'pt','Dados',0),(297717,8270,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ',0),(297718,8270,'es','Datos',0),(297719,8270,'de','Daten',0),(297720,8270,'en','Data',0),(297721,8271,'is','',0),(297722,8271,'dr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® ',0),(297723,8271,'pr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® ',0),(297724,8271,'tr','Tarih aralÄ±ÄŸÄ±',0),(297725,8271,'pl','Zakres dat',0),(297726,8271,'bg','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(297727,8271,'ur','ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(297728,8271,'sr','ÐžÐ¿ÑÐµÐ³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(297729,8271,'vi','Pháº¡m vi ngÃ y',0),(297730,8271,'af','Datum Reeks',0),(297731,8271,'ro','Limita data',0),(297732,8271,'et','KuupÃ¤evade vahemik',0),(297733,8271,'si','Datumski obseg',0),(297734,8271,'ba','Rentang tanggal',0),(297735,8271,'nl','Datumbereik',0),(297736,8271,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤alue',0),(297737,8271,'no','Datointervall',0),(297738,8271,'da','Datointerval',0),(297739,8271,'ko','ë‚ ì§œ ë²”ìœ„',0),(297740,8271,'he','×˜×•×•×— ×ª××¨×™×›×™×',0),(297741,8271,'el','Î•ÏÏÎ¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½',0),(297742,8271,'zh','æ—¥æœŸèŒƒå›´\r\n',0),(297743,8271,'sv','Datumintervall',0),(297744,8271,'it','Intervallo di date',0),(297745,8271,'tl','',0),(297746,8271,'th','&#3594;&#3656;&#3623;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(297747,8271,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€',0),(297748,8271,'ms','Julat tarikh',0),(297749,8271,'ar','Ù†Ø·Ø§Ù‚ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(297750,8271,'fr','Plage de dates',0),(297751,8271,'jp','æ—¥ä»˜ã®ç¯„å›²',0),(297752,8271,'pt','Intervalo de datas',0),(297753,8271,'ru','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚',0),(297754,8271,'es','Rango de Fechas',0),(297755,8271,'de','Datumsbereich',0),(297756,8271,'en','Date Range',0),(297757,8272,'is','',0),(297758,8272,'dr','Ø±ÙˆÙŠØ¯Ø§Ø¯ ',0),(297759,8272,'pr','Ø±ÙˆÙŠØ¯Ø§Ø¯ ',0),(297760,8272,'tr','Olay',0),(297761,8272,'pl','Zdarzenia',0),(297762,8272,'bg','Ð¡ÑŠÐ±Ð¸Ñ‚Ð¸Ðµ',0),(297763,8272,'ur','ØªÙ‚Ø±ÛŒØ¨',0),(297764,8272,'sr','Ð”Ð¾Ð³Ð°Ñ’Ð°Ñ˜',0),(297765,8272,'vi','Sá»± kiá»‡n',0),(297766,8272,'af','Gebeurtenis',0),(297767,8272,'ro','Caz',0),(297768,8272,'et','SÃ¼ndmus',0),(297769,8272,'si','Dogodek',0),(297770,8272,'ba','Peristiwa',0),(297771,8272,'nl','Gebeurtenis',0),(297772,8272,'fi','Tapahtuma',0),(297773,8272,'no','Hendelse',0),(297774,8272,'da','Event',0),(297775,8272,'ko','ì´ë²¤íŠ¸',0),(297776,8272,'he','××¨×•×¢',0),(297777,8272,'el','Î•ÎºÎ´Î®Î»Ï‰ÏƒÎ·',0),(297778,8272,'zh','äº‹ä»¶\r\n',0),(297779,8272,'sv','HÃ¤ndelse',0),(297780,8272,'it','Evento',0),(297781,8272,'tl','',0),(297782,8272,'th','&#3648;&#3627;&#3605;&#3640;&#3585;&#3634;&#3619;&#3603;&#3660;',0),(297783,8272,'hi','à¤˜à¤Ÿà¤¨à¤¾',0),(297784,8272,'ms','Acara',0),(297785,8272,'ar','Ø§Ù„Ø­Ø¯Ø«',0),(297786,8272,'fr','Ã‰vÃ©nement',0),(297787,8272,'jp','ã‚¤ãƒ™ãƒ³ãƒˆ',0),(297788,8272,'pt','Evento',0),(297789,8272,'ru','Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ðµ',0),(297790,8272,'es','Evento',0),(297791,8272,'de','Ereignis',0),(297792,8272,'en','Event',0),(297793,8273,'is','',0),(297794,8273,'dr','IP  Ù¾Ø±ÙˆØªÙ…Ø¬Ù…ÙˆØ¹ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(297795,8273,'pr','IP  Ù¾Ø±ÙˆØªÙƒÙ„ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(297796,8273,'tr','IP',0),(297797,8273,'pl','IP',0),(297798,8273,'bg','IP',0),(297799,8273,'ur','IP',0),(297800,8273,'sr','Ð˜ÐŸ',0),(297801,8273,'vi','IP',0),(297802,8273,'af','IV (\"IP\")',0),(297803,8273,'ro','IP',0),(297804,8273,'et','IP',0),(297805,8273,'si','IP',0),(297806,8273,'ba','IP',0),(297807,8273,'nl','IP',0),(297808,8273,'fi','IP',0),(297809,8273,'no','IP',0),(297810,8273,'da','IP',0),(297811,8273,'ko','IP',0),(297812,8273,'he','×”-IP',0),(297813,8273,'el','IP',0),(297814,8273,'zh','å› ç‰¹ç½‘åå®š\r\n',0),(297815,8273,'sv','IP',0),(297816,8273,'it','IP',0),(297817,8273,'tl','',0),(297818,8273,'th','IP',0),(297819,8273,'hi','à¤†à¤ˆà¤ªà¥€',0),(297820,8273,'ms','HARTA INTELEK',0),(297821,8273,'ar','IP Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(297822,8273,'fr','IP',0),(297823,8273,'jp','IP',0),(297824,8273,'pt','IP',0),(297825,8273,'ru','IP',0),(297826,8273,'es','IP',0),(297827,8273,'de','IP',0),(297828,8273,'en','IP',0),(297829,8274,'is','',0),(297830,8274,'dr','NolaPro Ù†Ø¸Ø§Ø±Øª Ø¨Ø± ÙØ¹Ø§Ù„ÙŠØª',0),(297831,8274,'pr','NolaPro Ù†Ø¸Ø§Ø±Øª Ø¨Ø± ÙØ¹Ø§Ù„ÙŠØª',0),(297832,8274,'tr','Sistem etkinliÄŸini izleme',0),(297833,8274,'pl','Monitor aktywnoÅ›ci systemu',0),(297834,8274,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ ÐœÐ¾Ð½Ð¸Ñ‚Ð¾Ñ€',0),(297835,8274,'ur','Ù†Ø¸Ø§Ù… Ø³Ø±Ú¯Ø±Ù…ÛŒ Ù…Ø§Ù†ÛŒÙ¹Ø±',0),(297836,8274,'sr','Ð¡Ð¸ÑÑ‚ÐµÐ¼ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ ÐœÐ¾Ð½Ð¸Ñ‚Ð¾Ñ€',0),(297837,8274,'vi','Theo dÃµi Hoáº¡t Ä‘á»™ng cá»§a NolaPro',0),(297838,8274,'af','Monitor NolaPro Aktiweite',0),(297839,8274,'ro','Monitor activitate NolaPro ',0),(297840,8274,'et','NolaPro tegevuste jÃ¤lgija',0),(297841,8274,'si','Sistem Activity Monitor',0),(297842,8274,'ba','Sistem kegiatan Monitor',0),(297843,8274,'nl','Activiteit Systeemmonitor',0),(297844,8274,'fi','JÃ¤rjestelmÃ¤n Activity Monitor',0),(297845,8274,'no','Systemet Aktivitetsmonitor',0),(297846,8274,'da','System AktivitetsovervÃ¥gning',0),(297847,8274,'ko','ì‹œìŠ¤í…œ í™œë™ ëª¨ë‹ˆí„°',0),(297848,8274,'he','×¦×’ ×¤×¢×™×œ×•×ª ×”×ž×¢×¨×›×ª',0),(297849,8274,'el','ÎŒÏÎ³Î±Î½Î¿ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚ ÏƒÏ…ÏƒÏ„Î·Î¼Î¬Ï„Ï‰Î½',0),(297850,8274,'zh','ç³»ç»Ÿæ´»åŠ¨ç›‘è§†å™¨\r\n',0),(297851,8274,'sv','Systemet Aktivitetskontroll',0),(297852,8274,'it','Sistema Monitor attivitÃ ',0),(297853,8274,'tl','',0),(297854,8274,'th','&#3627;&#3609;&#3657;&#3634;&#3592;&#3629;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617; NolaPro',0),(297855,8274,'hi','à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤®à¥‰à¤¨à¤¿à¤Ÿà¤°',0),(297856,8274,'ms','Monitor aktiviti sistem',0),(297857,8274,'ar','Ù…Ø±Ø§Ù‚Ø¨ Ù†Ø´Ø§Ø· Ø§Ù„Ù…Ù†Ø¸ÙˆÙ…Ø©',0),(297858,8274,'fr','SystÃ¨me moniteur d\'activitÃ©',0),(297859,8274,'jp','ã‚·ã‚¹ãƒ†ãƒ ã®åˆ©ç”¨çŠ¶æ³ãƒ¢ãƒ‹ã‚¿ãƒ¼',0),(297860,8274,'pt','Monitor de atividade do sistema',0),(297861,8274,'ru','ÐœÐ¾Ð½Ð¸Ñ‚Ð¾Ñ€ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ NolaPro',0),(297862,8274,'es','NolaPro Monitor de Actividad',0),(297863,8274,'de','System Activity Monitor',0),(297864,8274,'en','System Activity Monitor',0),(297865,8275,'is','',0),(297866,8275,'dr','Ø¨Ø®Ø´ ',0),(297867,8275,'pr','Ø¨Ø®Ø´ ',0),(297868,8275,'tr','BÃ¶lÃ¼m',0),(297869,8275,'pl','Sekcja',0),(297870,8275,'bg','Ð Ð°Ð·Ð´ÐµÐ»',0),(297871,8275,'ur','ØµÛŒØºÛ',0),(297872,8275,'sr','Ð¡ÐµÐºÑ†Ð¸Ñ˜Ð°',0),(297873,8275,'vi','Pháº§n',0),(297874,8275,'af','Afdeling',0),(297875,8275,'ro','Sectiune',0),(297876,8275,'et','Jagu',0),(297877,8275,'si','Oddelek',0),(297878,8275,'ba','Bagian',0),(297879,8275,'nl','Sectie',0),(297880,8275,'fi','Osassa',0),(297881,8275,'no','Delen',0),(297882,8275,'da','Afsnit',0),(297883,8275,'ko','ì„¹ì…˜',0),(297884,8275,'he','×¡×¢×™×£',0),(297885,8275,'el','Î¤Î¼Î®Î¼Î±',0),(297886,8275,'zh','éƒ¨åˆ†\r\n',0),(297887,8275,'sv','Avsnitt',0),(297888,8275,'it','Sezione',0),(297889,8275,'tl','',0),(297890,8275,'th','&#3585;&#3621;&#3640;&#3656;&#3617;',0),(297891,8275,'hi','à¤…à¤¨à¥à¤­à¤¾à¤—',0),(297892,8275,'ms','Seksyen',0),(297893,8275,'ar','Ø§Ù„Ù‚Ø³Ù…',0),(297894,8275,'fr','Section',0),(297895,8275,'jp','ã‚»ã‚¯ã‚·ãƒ§ãƒ³',0),(297896,8275,'pt','SeÃ§Ã£o',0),(297897,8275,'ru','Ð Ð°Ð·Ð´ÐµÐ»',0),(297898,8275,'es','SecciÃ³n',0),(297899,8275,'de','Abschnitt',0),(297900,8275,'en','Section',0),(297901,8276,'is','',0),(297902,8276,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(297903,8276,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(297904,8276,'tr','Verileri gÃ¶ster',0),(297905,8276,'pl','PokaÅ¼ dane',0),(297906,8276,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ',0),(297907,8276,'ur','Ú©ÙˆØ§Ø¦Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(297908,8276,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(297909,8276,'vi','Hiá»ƒn thá»‹ dá»¯ liá»‡u',0),(297910,8276,'af','Wys Data',0),(297911,8276,'ro','Arata datele',0),(297912,8276,'et','Kuva andmed',0),(297913,8276,'si','Prikaz podatkov',0),(297914,8276,'ba','Menunjukkan Data',0),(297915,8276,'nl','Gegevens weergeven',0),(297916,8276,'fi','NÃ¤ytÃ¤ tiedot',0),(297917,8276,'no','Vis Data',0),(297918,8276,'da','Vis Data',0),(297919,8276,'ko','ë°ì´í„° í‘œì‹œ',0),(297920,8276,'he','×”×¦×’ × ×ª×•× ×™×',0),(297921,8276,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(297922,8276,'zh','æ˜¾ç¤ºæ•°æ®\r\n',0),(297923,8276,'sv','Visa Data',0),(297924,8276,'it','Visualizza dati',0),(297925,8276,'tl','',0),(297926,8276,'th','&#3649;&#3626;&#3604;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(297927,8276,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(297928,8276,'ms','Menunjukkan Data',0),(297929,8276,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(297930,8276,'fr','Afficher les donnÃ©es',0),(297931,8276,'jp','ãƒ‡ãƒ¼ã‚¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(297932,8276,'pt','Visualizar dados',0),(297933,8276,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ðµ',0),(297934,8276,'es','Mostrar Datos',0),(297935,8276,'de','Daten anzeigen',0),(297936,8276,'en','Show Data',0),(297937,8277,'is','',0),(297938,8277,'dr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(297939,8277,'pr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(297940,8277,'tr','Ek alanlar DÃ¼zenleyicisi',0),(297941,8277,'pl','Dodatkowe pola edytora',0),(297942,8277,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¾Ñ€',0),(297943,8277,'ur','Ø§Ø¶Ø§ÙÛŒ Ù‚Ø·Ø¹Ø§Øª Ø§ÛŒÚˆÛŒÙ¹Ø±',0),(297944,8277,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð° Ð¿Ð¾Ñ™Ð° Ð•Ð´Ð¸Ñ‚Ð¾Ñ€',0),(297945,8277,'vi','Chá»‰nh Sá»­a CÃ¡c TrÆ°á»ng Cá»™ng ThÃªm',0),(297946,8277,'af','Addisionele Veldredigeerder',0),(297947,8277,'ro','Editor campuri aditionale',0),(297948,8277,'et','LisavÃ¤ljade editor',0),(297949,8277,'si','Dodatna polja urednik',0),(297950,8277,'ba','Editor Penambahan Kolom ',0),(297951,8277,'nl','Extra velden Editor',0),(297952,8277,'fi','LisÃ¤Ã¤ kentÃ¤t Editor',0),(297953,8277,'no','Ekstra felt Editor',0),(297954,8277,'da','Yderligere felter Editor',0),(297955,8277,'ko','ì¶”ê°€ í•„ë“œ íŽ¸ì§‘ê¸°',0),(297956,8277,'he','×¢×•×¨×š ×©×“×•×ª × ×•×¡×¤×™×',0),(297957,8277,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î± Ï€ÎµÎ´Î¯Î± ÏƒÏ…Î½Ï„Î¬ÎºÏ„Î·',0),(297958,8277,'zh','å¢žåŠ ç¼–è¾‘é¢†åŸŸ\r\n',0),(297959,8277,'sv','Ytterligare fÃ¤lt redaktÃ¶r',0),(297960,8277,'it','Editori campi aggiuntivi',0),(297961,8277,'tl','',0),(297962,8277,'th','&#3612;&#3641;&#3657;&#3649;&#3585;&#3657;&#3652;&#3586;&#3615;&#3636;&#3621;&#3604;&#3660;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;',0),(297963,8277,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸ à¤¸à¤‚à¤ªà¤¾à¤¦à¤•',0),(297964,8277,'ms','Tambahan bidang Editor',0),(297965,8277,'ar','Ù…Ø­Ø±Ø± Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(297966,8277,'fr','Ã‰diteur de champs supplÃ©mentaires',0),(297967,8277,'jp','è¿½åŠ ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ ã‚¨ãƒ‡ã‚£ã‚¿ãƒ¼',0),(297968,8277,'pt','Editor de campos adicionais',0),(297969,8277,'ru','Ð’Ð²Ð¾Ð´ Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ ÐŸÐ¾Ð»Ñ',0),(297970,8277,'es','Editor de Campo Adicional',0),(297971,8277,'de','ZusÃ¤tzliche Felder Editor',0),(297972,8277,'en','Additional Fields Editor',0),(297973,8278,'is','',0),(297974,8278,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙÙŠÙ„Ø¯',0),(297975,8278,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙÙŠÙ„Ø¯',0),(297976,8278,'tr','Alan ekleme',0),(297977,8278,'pl','Dodaj pole',0),(297978,8278,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ð»Ðµ',0),(297979,8278,'ur','Ù‚Ø·Ø¹Û Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(297980,8278,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ™Ð°',0),(297981,8278,'vi','ThÃªm TrÆ°á»ng',0),(297982,8278,'af','Veld Byvoeg',0),(297983,8278,'ro','Adauga Camp',0),(297984,8278,'et','VÃ¤lja lisamine',0),(297985,8278,'si','Dodajanje polja',0),(297986,8278,'ba','Menambahkan Field',0),(297987,8278,'nl','Veld toevoegen',0),(297988,8278,'fi','LisÃ¤Ã¤ kenttÃ¤',0),(297989,8278,'no','Legg feltet',0),(297990,8278,'da','TilfÃ¸j felt',0),(297991,8278,'ko','í•„ë“œ ì¶”ê°€',0),(297992,8278,'he','×”×•×¡×£ ×©×“×”',0),(297993,8278,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï€ÎµÎ´Î¯Î¿',0),(297994,8278,'zh','å¢žåŠ é ˜åŸŸ\r\n',0),(297995,8278,'sv','LÃ¤gg till fÃ¤ltet',0),(297996,8278,'it','Aggiungi campo',0),(297997,8278,'tl','',0),(297998,8278,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(297999,8278,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(298000,8278,'ms','Tambah bidang',0),(298001,8278,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ù‚Ù„',0),(298002,8278,'fr','Ajouter Champ',0),(298003,8278,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(298004,8278,'pt','Adicionar campo',0),(298005,8278,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð»Ðµ',0),(298006,8278,'es','Agregar Campo',0),(298007,8278,'de','Feld hinzufÃ¼gen',0),(298008,8278,'en','Add Field',0),(298009,8279,'is','',0),(298010,8279,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙÙŠÙ„Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(298011,8279,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙÙŠÙ„Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(298012,8279,'tr','Alan ekleme',0),(298013,8279,'pl','Dodaj pole dla',0),(298014,8279,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¿Ð¾Ð»Ðµ Ð·Ð°',0),(298015,8279,'ur','Ù‚Ø·Ø¹Û Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(298016,8279,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ™Ð° Ð·Ð°',0),(298017,8279,'vi','ThÃªm TrÆ°á»ng cho',0),(298018,8279,'af','Veld Byvoeg Vir',0),(298019,8279,'ro','Adauga Camp pentru',0),(298020,8279,'et','Lisa vÃ¤li',0),(298021,8279,'si','Dodajanje polja za',0),(298022,8279,'ba','Menambahkan Field untuk',0),(298023,8279,'nl','Veld toevoegen voor',0),(298024,8279,'fi','LisÃ¤Ã¤ kenttÃ¤',0),(298025,8279,'no','Legg til feltet For',0),(298026,8279,'da','FÃ¸j felt til',0),(298027,8279,'ko','ì— ëŒ€ í•œ í•„ë“œ ì¶”ê°€',0),(298028,8279,'he','×”×•×¡×£ ×©×“×” ×¢×‘×•×¨',0),(298029,8279,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÎµÎ´Î¯Î¿Ï… Î³Î¹Î±',0),(298030,8279,'zh','å¢žåŠ é ˜åŸŸ\r\n\r\n',0),(298031,8279,'sv','LÃ¤gga till fÃ¤lt fÃ¶r',0),(298032,8279,'it','Aggiungere il campo per',0),(298033,8279,'tl','',0),(298034,8279,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;',0),(298035,8279,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(298036,8279,'ms','Tambah bidang',0),(298037,8279,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ù‚Ù„ Ù„Ù€',0),(298038,8279,'fr','Ajouter Champ pour',0),(298039,8279,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(298040,8279,'pt','Adicionar campo para',0),(298041,8279,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÐ¾Ð»Ðµ Ð”Ð»Ñ',0),(298042,8279,'es','Agregar Campo Para',0),(298043,8279,'de','FÃ¼gen Sie das Feld fÃ¼r',0),(298044,8279,'en','Add Field For',0),(298045,8280,'is','',0),(298046,8280,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ',0),(298047,8280,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ',0),(298048,8280,'tr','Ekle seÃ§eneÄŸi',0),(298049,8280,'pl','Dodaj opcjÄ™',0),(298050,8280,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¾Ð¿Ñ†Ð¸Ñ',0),(298051,8280,'ur','Ø§Ø®ØªÛŒØ§Ø± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(298052,8280,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(298053,8280,'vi','Cá»™ng ThÃªm Lá»±a Chá»n',0),(298054,8280,'af','Opsie Byvoeg',0),(298055,8280,'ro','Adauga opÅ£iune',0),(298056,8280,'et','Lisada valik',0),(298057,8280,'si','Dodaj moÅ¾nost',0),(298058,8280,'ba','Tambahkan pilihan',0),(298059,8280,'nl','Voeg optie',0),(298060,8280,'fi','LisÃ¤Ã¤ vaihtoehto',0),(298061,8280,'no','Legg til alternativ',0),(298062,8280,'da','TilfÃ¸j indstilling',0),(298063,8280,'ko','ì˜µì…˜ ì¶”ê°€',0),(298064,8280,'he','×”×•×¡×£ ××¤×©×¨×•×ª',0),(298065,8280,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î®',0),(298066,8280,'zh','å¢žåŠ é€‰é¡¹\r\n',0),(298067,8280,'sv','LÃ¤gga till alternativ',0),(298068,8280,'it','Aggiungere l\'opzione',0),(298069,8280,'tl','',0),(298070,8280,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(298071,8280,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(298072,8280,'ms','Menambah opsyen',0),(298073,8280,'ar','Ø¥Ø¶Ø§ÙØ© Ø®ÙŠØ§Ø±',0),(298074,8280,'fr','Ajouter l\'Option',0),(298075,8280,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(298076,8280,'pt','Adicionar opÃ§Ã£o',0),(298077,8280,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€',0),(298078,8280,'es','Agregar OpciÃ³n',0),(298079,8280,'de','Option hinzufÃ¼gen',0),(298080,8280,'en','Add Option',0),(298081,8281,'is','',0),(298082,8281,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ø±Ø§ÙŠ',0),(298083,8281,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ø±Ø§ÙŠ',0),(298084,8281,'tr','AlanlarÄ± Ekle/GÃ¼ncelle',0),(298085,8281,'pl','Dodaj/Aktualizuj pola',0),(298086,8281,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð·Ð°',0),(298087,8281,'ur','Ù‚Ø·Ø¹Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(298088,8281,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾Ñ™Ð° Ð·Ð°',0),(298089,8281,'vi','ThÃªm/Cáº­p Nháº­t TrÆ°á»ng cho',0),(298090,8281,'af','Velde Byvoeg/Opdateer Vir',0),(298091,8281,'ro','AdÄƒugaÅ£i/actualizaÅ£i cÃ¢mpuri pentru',0),(298092,8281,'et','Lisa/VÃ¤rskenda vÃ¤ljad',0),(298093,8281,'si','Dodaj/posodobi polja za',0),(298094,8281,'ba','Tambahkan/Perbarui bidang',0),(298095,8281,'nl','Velden voor het toevoegen/bijwerken',0),(298096,8281,'fi','LisÃ¤Ã¤/PÃ¤ivitÃ¤ kentÃ¤t',0),(298097,8281,'no','Legg til/Oppdater felt For',0),(298098,8281,'da','TilfÃ¸j/opdater felter For',0),(298099,8281,'ko','í•„ë“œë¥¼ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(298100,8281,'he','×”×•×¡×£/×¢×“×›×Ÿ ×©×“×•×ª ×¢×‘×•×¨',0),(298101,8281,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ/Ï€ÎµÎ´Î¯Î± Î³Î¹Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(298102,8281,'zh','å¢žåŠ /æ›´æ–°å­—æ®µ\r\n',0),(298103,8281,'sv','LÃ¤gg till/uppdatera fÃ¤lt fÃ¶r',0),(298104,8281,'it','Aggiungere o aggiornare i campi per',0),(298105,8281,'tl','',0),(298106,8281,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3615;&#3636;&#3621;&#3604;&#3660;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(298107,8281,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(298108,8281,'ms','Tambah/Kemaskini bidang bagi',0),(298109,8281,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø­Ù‚ÙˆÙ„ Ù„Ù€',0),(298110,8281,'fr','Ajouter/mettre Ã  jour les champs pour',0),(298111,8281,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’è¿½åŠ /æ›´æ–°',0),(298112,8281,'pt','Adicionar/atualizar campos para',0),(298113,8281,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐŸÐ¾Ð»Ñ Ð”Ð»Ñ',0),(298114,8281,'es','Agregar/Actualizar Campos Para',0),(298115,8281,'de','Felder hinzufÃ¼gen/aktualisieren',0),(298116,8281,'en','Add/Update Fields For',0),(298117,8282,'is','',0),(298118,8282,'dr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ ÙØ¹Ù„ÙŠ Ø¨Ø±Ø§ÙŠ',0),(298119,8282,'pr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ ÙØ¹Ù„ÙŠ Ø¨Ø±Ø§ÙŠ',0),(298120,8282,'tr','GeÃ§erli alanlarÄ± iÃ§in',0),(298121,8282,'pl','BieÅ¼Ä…cego pola',0),(298122,8282,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸Ñ‚Ðµ Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð·Ð°',0),(298123,8282,'ur','Ø­Ø§Ù„ÛŒÛ Ù‚Ø·Ø¹Ø§Øª Ú©Û’ Ù„ÛŒÛ’',0),(298124,8282,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð¿Ð¾Ñ™Ð° Ð·Ð°',0),(298125,8282,'vi','TrÆ°á»ng hiá»‡n thá»i cho',0),(298126,8282,'af','Huidige Velde Vir',0),(298127,8282,'ro','CÃ¢mpurile curent pentru',0),(298128,8282,'et','Praeguste vÃ¤ljade jaoks',0),(298129,8282,'si','Trenutnega polja za',0),(298130,8282,'ba','Bidang yang saat ini untuk',0),(298131,8282,'nl','Huidige velden voor',0),(298132,8282,'fi','Nykyinen kentÃ¤t',0),(298133,8282,'no','Gjeldende felt For',0),(298134,8282,'da','Aktuelle felter For',0),(298135,8282,'ko','í˜„ìž¬ í•„ë“œì— ëŒ€ í•œ',0),(298136,8282,'he','×©×“×•×ª ×”× ×•×›×—×™ ×¢×‘×•×¨',0),(298137,8282,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï€ÎµÎ´Î¯Î± Î³Î¹Î±',0),(298138,8282,'zh','å½“å‰å­—æ®µ\r\n',0),(298139,8282,'sv','Aktuella omrÃ¥den fÃ¶r',0),(298140,8282,'it','Campi di corrente per',0),(298141,8282,'tl','',0),(298142,8282,'th','&#3649;&#3615;&#3657;&#3617;&#3591;&#3634;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(298143,8282,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤',0),(298144,8282,'ms','Medan semasa bagi',0),(298145,8282,'ar','Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(298146,8282,'fr','Champs actuels pour',0),(298147,8282,'jp','ç¾åœ¨ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(298148,8282,'pt','Campos atuais para',0),(298149,8282,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ ÐŸÐ¾Ð»Ñ Ð”Ð»Ñ',0),(298150,8282,'es','Campos Actuales Para',0),(298151,8282,'de','Aktuelle Felder fÃ¼r',0),(298152,8282,'en','Current Fields For',0),(298153,8283,'is','',0),(298154,8283,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙÙŠÙ„Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(298155,8283,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙÙŠÙ„Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(298156,8283,'tr','AlanÄ± dÃ¼zenleme',0),(298157,8283,'pl','Edytuj pole',0),(298158,8283,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð»Ðµ Ð·Ð°',0),(298159,8283,'ur','Ù‚Ø·Ø¹Û Ú©Û’ Ù„ÛŒÛ’ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(298160,8283,'sr','Ð£Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ™Ðµ Ð·Ð°',0),(298161,8283,'vi','Sá»­a TrÆ°á»ng cho',0),(298162,8283,'af','Redigeer Veld Vir',0),(298163,8283,'ro','Edita cÃ¢mpul pentru',0),(298164,8283,'et','Redigeeri vÃ¤lja',0),(298165,8283,'si','Uredite polje za',0),(298166,8283,'ba','Mengedit bidang untuk',0),(298167,8283,'nl','Veld voor bewerken',0),(298168,8283,'fi','Muokkaa kenttÃ¤Ã¤',0),(298169,8283,'no','Redigere feltet For',0),(298170,8283,'da','Rediger feltet For',0),(298171,8283,'ko','í•„ë“œ íŽ¸ì§‘',0),(298172,8283,'he','×¢×¨×•×š ×©×“×” ×¢×‘×•×¨',0),(298173,8283,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÎµÎ´Î¯Î¿ Î³Î¹Î±',0),(298174,8283,'zh','ç¼–è¾‘å­—æ®µ\r\n',0),(298175,8283,'sv','Redigera fÃ¤ltet fÃ¶r',0),(298176,8283,'it','Modificare il campo per',0),(298177,8283,'tl','',0),(298178,8283,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(298179,8283,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(298180,8283,'ms','Edit bidang',0),(298181,8283,'ar','ØªØ­Ø±ÙŠØ± Ø­Ù‚Ù„',0),(298182,8283,'fr','Modifier le champ pour',0),(298183,8283,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(298184,8283,'pt','Editar o campo para',0),(298185,8283,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð“Ñ€Ð°Ñ„Ñƒ Ð”Ð»Ñ',0),(298186,8283,'es','Editar Campo Para',0),(298187,8283,'de','Eingabefeld fÃ¼r',0),(298188,8283,'en','Edit Field For',0),(298189,8284,'is','',0),(298190,8284,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙÙŠÙ„Ø¯ ',0),(298191,8284,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙÙŠÙ„Ø¯ ',0),(298192,8284,'tr','Hata alanÄ± ekleme',0),(298193,8284,'pl','BÅ‚Ä…d dodawania pola',0),(298194,8284,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ð»Ðµ',0),(298195,8284,'ur','Ù†Ù‚Øµ Ù‚Ø·Ø¹Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(298196,8284,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¿Ð¾Ñ™Ð°',0),(298197,8284,'vi','ThÃªm trÆ°á»ng bá»‹ lá»—i',0),(298198,8284,'af','Fout met Byvoeging van Veld',0),(298199,8284,'ro','Eroare adÄƒugarea de cÃ¢mp',0),(298200,8284,'et','Viga lisades vÃ¤lja',0),(298201,8284,'si','Napaka pri dodajanju polje',0),(298202,8284,'ba','Kesalahan menambahkan bidang',0),(298203,8284,'nl','Veld fout toe te voegen',0),(298204,8284,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ kenttÃ¤',0),(298205,8284,'no','Feil Ã¥ legge til felt',0),(298206,8284,'da','Fejl tilfÃ¸jelse af felt',0),(298207,8284,'ko','ì˜¤ë¥˜ ì¶”ê°€ í•„ë“œ',0),(298208,8284,'he','×©×’×™××” ×”×•×¡×¤×ª ×©×“×”',0),(298209,8284,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÎµÎ´Î¯Î¿ ÏƒÏ†Î¬Î»Î¼Î±',0),(298210,8284,'zh','æ·»åŠ å­—æ®µé”™è¯¯',0),(298211,8284,'sv','Fel att lÃ¤gga till fÃ¤lt',0),(298212,8284,'it','Errore aggiunta campo',0),(298213,8284,'tl','',0),(298214,8284,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3615;&#3636;&#3621;&#3604;&#3660;',0),(298215,8284,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(298216,8284,'ms','Ralat menambah bidang',0),(298217,8284,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø­Ù‚Ù„',0),(298218,8284,'fr','Erreur ajout champ',0),(298219,8284,'jp','ã‚¨ãƒ©ãƒ¼ã®è¿½åŠ ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(298220,8284,'pt','Erro adicionando campo',0),(298221,8284,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐŸÐ¾Ð»Ñ',0),(298222,8284,'es','Error Agregando Campo',0),(298223,8284,'de','HinzufÃ¼gen von Fehlerfeld',0),(298224,8284,'en','Error Adding Field',0),(298225,8285,'is','',0),(298226,8285,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ',0),(298227,8285,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ ',0),(298228,8285,'tr','Hata ekleme seÃ§eneÄŸi',0),(298229,8285,'pl','BÅ‚Ä…d dodawania opcji',0),(298230,8285,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¾Ð¿Ñ†Ð¸Ñ',0),(298231,8285,'ur','Ù†Ù‚Øµ Ø§Ø®ØªÛŒØ§Ø± Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(298232,8285,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ',0),(298233,8285,'vi','ThÃªm lá»±a chá»n bá»‹ lá»—i',0),(298234,8285,'af','Fout voeg opsie',0),(298235,8285,'ro','Eroare adÄƒugarea de opÅ£iunea',0),(298236,8285,'et','Viga lisades valik',0),(298237,8285,'si','Napaka pri dodajanju moÅ¾nost',0),(298238,8285,'ba','Kesalahan menambahkan opsi',0),(298239,8285,'nl','Fout toe te voegen optie',0),(298240,8285,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ valitsin',0),(298241,8285,'no','Feil Ã¥ legge alternativ',0),(298242,8285,'da','TilfÃ¸jer mulighed for fejl',0),(298243,8285,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì˜µì…˜',0),(298244,8285,'he','××¤×©×¨×•×ª ×”×•×¡×¤×ª ×”×©×’×™××”',0),(298245,8285,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î® Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(298246,8285,'zh','é”™è¯¯æ·»åŠ é€‰é¡¹',0),(298247,8285,'sv','Fel att lÃ¤gga till alternativ',0),(298248,8285,'it','Errore Aggiunta opzione',0),(298249,8285,'tl','',0),(298250,8285,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604; &#3607;&#3637;&#3656;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(298251,8285,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(298252,8285,'ms','Ralat menambah opsyen',0),(298253,8285,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø®ÙŠØ§Ø±',0),(298254,8285,'fr','Erreur ajout d\'Option',0),(298255,8285,'jp','ã‚¨ãƒ©ãƒ¼ã®è¿½åŠ ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(298256,8285,'pt','Erro adicionando opÃ§Ã£o',0),(298257,8285,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚',0),(298258,8285,'es','Error Agregando OpciÃ³n',0),(298259,8285,'de','Fehler beim HinzufÃ¼gen von Option',0),(298260,8285,'en','Error Adding Option',0),(298261,8286,'is','',0),(298262,8286,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ú¯Ø²ÙŠÙ†Ù‡ ',0),(298263,8286,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ú¯Ø²ÙŠÙ†Ù‡ ',0),(298264,8286,'tr','Hata silme seÃ§eneÄŸi',0),(298265,8286,'pl','Opcja usuwania bÅ‚Ä™dÃ³w',0),(298266,8286,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð¾Ð¿Ñ†Ð¸Ñ',0),(298267,8286,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ø§Ø®ØªÛŒØ§Ø±',0),(298268,8286,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(298269,8286,'vi','Lá»—i xÃ³a lá»±a chá»n',0),(298270,8286,'af','Fout met skrapping van opsie',0),(298271,8286,'ro','Eroare opÅ£iunea ÅŸtergere',0),(298272,8286,'et','TÃµrge kustutamisel suvandi',0),(298273,8286,'si','Napaka brisanja moÅ¾nost',0),(298274,8286,'ba','Error menghapus pilihan',0),(298275,8286,'nl','Fout verwijderen optie',0),(298276,8286,'fi','Virhe poistettaessa vaihtoehto',0),(298277,8286,'no','Feil slette alternativet',0),(298278,8286,'da','Fejl slette mulighed',0),(298279,8286,'ko','ì˜¤ë¥˜ ì‚­ì œ ì˜µì…˜',0),(298280,8286,'he','×©×’×™××” ×‘×ž×—×™×§×ª ××¤×©×¨×•×ª',0),(298281,8286,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î®',0),(298282,8286,'zh','é”™è¯¯åˆ é™¤é€‰é¡¹',0),(298283,8286,'sv','Misstag utplÃ¥nande alternativet',0),(298284,8286,'it','Opzione eliminazione errore',0),(298285,8286,'tl','',0),(298286,8286,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(298287,8286,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(298288,8286,'ms','Ralat Menghapuskan pilihan',0),(298289,8286,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø®ÙŠØ§Ø±',0),(298290,8286,'fr','Option suppression d\'erreurs',0),(298291,8286,'jp','ã‚¨ãƒ©ãƒ¼ã®å‰Šé™¤ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(298292,8286,'pt','OpÃ§Ã£o de erro de exclusÃ£o',0),(298293,8286,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚',0),(298294,8286,'es','Error Eliminando OpciÃ³n',0),(298295,8286,'de','Fehler beim LÃ¶schen von Option',0),(298296,8286,'en','Error Deleting Option',0),(298297,8287,'is','',0),(298298,8287,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ ÙÙŠÙ„Ø¯',0),(298299,8287,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ ÙÙŠÙ„Ø¯',0),(298300,8287,'tr','Alan varsayÄ±lan',0),(298301,8287,'pl','DomyÅ›lnie pola',0),(298302,8287,'bg','ÐŸÐ¾Ð»Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(298303,8287,'ur','Ù‚Ø·Ø¹Û Ø·Û’ Ø´Ø¯Û',0),(298304,8287,'sr','ÐŸÐ¾Ñ™Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾',0),(298305,8287,'vi','TrÆ°á»ng máº·c Ä‘á»‹nh',0),(298306,8287,'af','Vestekte Veld',0),(298307,8287,'ro','Domeniul implicit',0),(298308,8287,'et','VÃ¤li vaikimisi',0),(298309,8287,'si','Polje privzeto',0),(298310,8287,'ba','Field Default',0),(298311,8287,'nl','Veld standaard',0),(298312,8287,'fi','KentÃ¤n oletusarvo',0),(298313,8287,'no','Feltet standard',0),(298314,8287,'da','Feltet standard',0),(298315,8287,'ko','í•„ë“œ ê¸°ë³¸ê°’',0),(298316,8287,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×©×“×”',0),(298317,8287,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Ï€ÎµÎ´Î¯Î¿',0),(298318,8287,'zh','é»˜è®¤å­—æ®µ\r\n',0),(298319,8287,'sv','FÃ¤ltet standard',0),(298320,8287,'it','Campo predefinito',0),(298321,8287,'tl','',0),(298322,8287,'th','&#3615;&#3636;&#3621;&#3604;&#3660;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(298323,8287,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(298324,8287,'ms','Bidang lalai',0),(298325,8287,'ar','Ø§Ù„Ø­Ù‚Ù„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(298326,8287,'fr','Champ par dÃ©faut',0),(298327,8287,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã®æ—¢å®š',0),(298328,8287,'pt','Campo padrÃ£o',0),(298329,8287,'ru','ÐŸÐ¾Ð»Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(298330,8287,'es','Campo por Defecto',0),(298331,8287,'de','Feld Standard',0),(298332,8287,'en','Field Default',0),(298333,8288,'is','',0),(298334,8288,'dr','Ø¹Ù†ÙˆØ§Ù† ÙÙŠÙ„Ø¯ ',0),(298335,8288,'pr','Ø¹Ù†ÙˆØ§Ù† ÙÙŠÙ„Ø¯ ',0),(298336,8288,'tr','Alan baÅŸlÄ±ÄŸÄ±',0),(298337,8288,'pl','Pole tytuÅ‚',0),(298338,8288,'bg','Ð—Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð¾',0),(298339,8288,'ur','Ù‚Ø·Ø¹Û Ú©Û’ Ø¹Ù†ÙˆØ§Ù†',0),(298340,8288,'sr','ÐŸÐ¾Ñ™Ðµ Ð½Ð°ÑÐ»Ð¾Ð²',0),(298341,8288,'vi','Chá»©c danh TrÆ°á»ng',0),(298342,8288,'af','Veld Titel',0),(298343,8288,'ro','CÃ¢mpul titlu',0),(298344,8288,'et','VÃ¤lja nimetus',0),(298345,8288,'si','Polje naslov',0),(298346,8288,'ba','Bidang judul',0),(298347,8288,'nl','Veld Titel',0),(298348,8288,'fi','KentÃ¤n otsikon',0),(298349,8288,'no','Feltet tittel',0),(298350,8288,'da','Feltet Titel',0),(298351,8288,'ko','í•„ë“œ ì œëª©',0),(298352,8288,'he','×©×“×” ×”×›×•×ª×¨×ª',0),(298353,8288,'el','Î ÎµÎ´Î¯Î¿ Î¤Î¯Ï„Î»Î¿Ï‚',0),(298354,8288,'zh','å­—æ®µæ ‡é¢˜\r\n',0),(298355,8288,'sv','FÃ¤ltet titel',0),(298356,8288,'it','Campo titolo',0),(298357,8288,'tl','',0),(298358,8288,'th','&#3594;&#3639;&#3656;&#3629;&#3605;&#3657;&#3609;&#3615;&#3636;&#3621;&#3604;&#3660;',0),(298359,8288,'hi','à¤«à¥€à¤²à¥à¤¡ à¤¶à¥€à¤°à¥à¤·à¤•',0),(298360,8288,'ms','Bidang tajuk',0),(298361,8288,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø­Ù‚Ù„',0),(298362,8288,'fr','Champ titre',0),(298363,8288,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã®ã‚¿ã‚¤ãƒˆãƒ«',0),(298364,8288,'pt','Campo tÃ­tulo',0),(298365,8288,'ru','Ð—Ð°Ð³Ð¾Ð»Ð¾Ð²Ð¾Ðº Ð¿Ð¾Ð»Ñ',0),(298366,8288,'es','Titulo de Campo',0),(298367,8288,'de','Feldtitel',0),(298368,8288,'en','Field Title',0),(298369,8289,'is','',0),(298370,8289,'dr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¹Ù†ÙˆØ§Ù† ÙÙŠÙ„Ø¯ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(298371,8289,'pr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¹Ù†ÙˆØ§Ù† ÙÙŠÙ„Ø¯ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(298372,8289,'tr','Bir alan adÄ± olmasÄ± gerekir',0),(298373,8289,'pl','Musi mieÄ‡ pole tytuÅ‚',0),(298374,8289,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð¿Ð¾Ð»Ðµ Ð·Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ',0),(298375,8289,'ur','Ø§ÛŒÚ© Ù‚Ø·Ø¹Û Ú©Û’ Ø¹Ù†ÙˆØ§Ù† ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(298376,8289,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð¼Ð°Ñ‚Ð¸ Ð¿Ð¾Ñ™Ðµ Ð½Ð°ÑÐ»Ð¾Ð²',0),(298377,8289,'vi','Pháº£i cÃ³ 1 tÃªn trÆ°á»ng',0),(298378,8289,'af','Moet \'n Veld Titel HÃª',0),(298379,8289,'ro','Trebuie sÄƒ aibÄƒ un titlu de cÃ¢mp',0),(298380,8289,'et','Peab olema vÃ¤li Pealkiri',0),(298381,8289,'si','Mora imeti polje naslov',0),(298382,8289,'ba','Harus memiliki gelar Field',0),(298383,8289,'nl','Moet beschikken over een veld Titel',0),(298384,8289,'fi','On oltava kentÃ¤n nimi',0),(298385,8289,'no','MÃ¥ ha en feltet tittel',0),(298386,8289,'da','Skal Have et felt titel',0),(298387,8289,'ko','í•„ë“œ ì œëª©ì„ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(298388,8289,'he','×‘×˜×— ×™×© ×›×•×ª×¨×ª ×©×“×”',0),(298389,8289,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î­Î½Î± Ï€ÎµÎ´Î¯Î¿ Î¤Î¯Ï„Î»Î¿Ï‚',0),(298390,8289,'zh','å¿…é¡»æœ‰ä¸€ä¸ªå­—æ®µæ ‡é¢˜\r\n',0),(298391,8289,'sv','MÃ¥ste ha en fÃ¤ltet titel',0),(298392,8289,'it','Deve avere un titolo di campo',0),(298393,8289,'tl','',0),(298394,8289,'th','&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3594;&#3639;&#3656;&#3629;&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(298395,8289,'hi','à¤à¤• à¤«à¥€à¤²à¥à¤¡ à¤¶à¥€à¤°à¥à¤·à¤• à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(298396,8289,'ms','Mesti mempunyai tajuk bidang',0),(298397,8289,'ar','Ù„Ø§Ø¨Ø¯ Ù…Ù† Ø¹Ù†ÙˆØ§Ù† Ø­Ù‚Ù„',0),(298398,8289,'fr','Doit avoir un titre de champ',0),(298399,8289,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã®ã‚¿ã‚¤ãƒˆãƒ«ãŒã‚ã‚Šã¾ã™ã€‚',0),(298400,8289,'pt','Deve ter um tÃ­tulo de campo',0),(298401,8289,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð° Ð¸Ð¼ÐµÑ‚ÑŒ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð»Ñ',0),(298402,8289,'es','Debe Tener un Titulo de Campo',0),(298403,8289,'de','Muss einen Feldtitel',0),(298404,8289,'en','Must Have a Field Title',0),(298405,8290,'is','',0),(298406,8290,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(298407,8290,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(298408,8290,'tr','SeÃ§enekler',0),(298409,8290,'pl','Opcje',0),(298410,8290,'bg','ÐžÐ¿Ñ†Ð¸Ð¸',0),(298411,8290,'ur','Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(298412,8290,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ',0),(298413,8290,'vi','Lá»±a chá»n',0),(298414,8290,'af','Opsies',0),(298415,8290,'ro','OpÅ£iuni',0),(298416,8290,'et','Valikud',0),(298417,8290,'si','MoÅ¾nosti',0),(298418,8290,'ba','Pilihan',0),(298419,8290,'nl','Opties',0),(298420,8290,'fi','Asetukset',0),(298421,8290,'no','Alternativer',0),(298422,8290,'da','Indstillinger',0),(298423,8290,'ko','ì˜µì…˜',0),(298424,8290,'he','××¤×©×¨×•×™×•×ª',0),(298425,8290,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚',0),(298426,8290,'zh','é€‰é¡¹\r\n',0),(298427,8290,'sv','Alternativ',0),(298428,8290,'it','Opzioni',0),(298429,8290,'tl','',0),(298430,8290,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(298431,8290,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª',0),(298432,8290,'ms','Pilihan',0),(298433,8290,'ar','Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª',0),(298434,8290,'fr','Options',0),(298435,8290,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(298436,8290,'pt','OpÃ§Ãµes',0),(298437,8290,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹',0),(298438,8290,'es','Opciones',0),(298439,8290,'de','Optionen',0),(298440,8290,'en','Options',0),(298441,8291,'is','',0),(298442,8291,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‚ÙŠÙ…Øª Ù‡Ø§ Ùˆ Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(298443,8291,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ù‚ÙŠÙ…Øª Ù‡Ø§ Ùˆ Ú†Ø§Ù¾ Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(298444,8291,'tr','Ä°nceleme fiyatlarÄ± ve yazdÄ±rma alÄ±ntÄ±',0),(298445,8291,'pl','Ceny przeglÄ…du i wydruku oferty',0),(298446,8291,'bg','Ð¦ÐµÐ½Ð¸ Ð½Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(298447,8291,'ur','Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ø§ÙˆØ± Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø§Ù‚ØªØ¨Ø§Ø³',0),(298448,8291,'sr','Ð¦ÐµÐ½Ðµ Ð·Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð¸ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(298449,8291,'vi','Xem xÃ©t giÃ¡ & In bÃ¡o giÃ¡',0),(298450,8291,'af','Hersiening pryse en druk aanhaling',0),(298451,8291,'ro','PreÅ£urile de revizuire ÅŸi citat de imprimare',0),(298452,8291,'et','Ãœlevaade hindadest ja Prindi pakkumine',0),(298453,8291,'si','Pregled cen in tiskanje citat',0),(298454,8291,'ba','Harga Review dan mencetak kutipan',0),(298455,8291,'nl','Beoordeling prijzen en afdrukken citaat',0),(298456,8291,'fi','Tarkistaa hinnat ja Tulosta tarjous',0),(298457,8291,'no','Gjennomgang priser og Print tilbud',0),(298458,8291,'da','Anmeldelse priser og Print tilbud',0),(298459,8291,'ko','í‰ê°€ ê°€ê²© ë° ì¸ì‡„ ê²¬ì ',0),(298460,8291,'he','×¡×§×™×¨×” ×•×”×ž×—×™×¨×™× ×”×“×¤×¡ ×”×¦×¢×ª ×ž×—×™×¨',0),(298461,8291,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Ï„Î¹Î¼ÏŽÎ½ ÎºÎ±Î¹ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(298462,8291,'zh','å¤å®¡ä»·æ ¼å’Œæ‰“å°æŠ¥ä»·\r\n',0),(298463,8291,'sv','Recension priser och skriv ut citat',0),(298464,8291,'it','Revisione prezzi e preventivo stampa',0),(298465,8291,'tl','',0),(298466,8291,'th','&#3614;&#3636;&#3592;&#3634;&#3619;&#3603;&#3634;&#3619;&#3634;&#3588;&#3634;&#3649;&#3621;&#3632;&#3614;&#3636;&#3617;&#3614;&#3660;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(298467,8291,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤”à¤° à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(298468,8291,'ms','Semakan harga dan sebut harga cetakan',0),(298469,8291,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ÙˆØ·Ø¨Ø§Ø¹Ø© Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(298470,8291,'fr','RÃ©vision des prix et devis impression',0),(298471,8291,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼ä¾¡æ ¼ã¨å°åˆ·è¦‹ç©ã‚‚ã‚Š',0),(298472,8291,'pt','RevisÃ£o de preÃ§os e cotaÃ§Ã£o de impressÃ£o',0),(298473,8291,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ñ†ÐµÐ½ Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(298474,8291,'es','Revisar Precios y CotizaciÃ³n de ImpresiÃ³n',0),(298475,8291,'de','Bewertung Preise und Drucken Zitat',0),(298476,8291,'en','Review Prices and Print Quote',0),(298477,8292,'is','',0),(298478,8292,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØªØ§Ø±ÙŠØ®Ú†Ù‡ ØªØºÙŠÙŠØ± Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(298479,8292,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØªØ§Ø±ÙŠØ®Ú†Ù‡ ØªØºÙŠÙŠØ± Ø³Ø±Ø±Ø³ÙŠØ¯ ',0),(298480,8292,'tr','Nedeniyle tarihi deÄŸiÅŸiklik geÃ§miÅŸini gÃ¶rÃ¼ntÃ¼le',0),(298481,8292,'pl','Widok ze wzglÄ™du historia zmian daty',0),(298482,8292,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð´ÑŠÐ»Ð¶Ð¸Ð¼ Ð´Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(298483,8292,'ur','ØªØ§Ø±ÛŒØ® ØªØ¨Ø¯ÛŒÙ„ÛŒ ØªØ§Ø±ÛŒØ® Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ù…Ù†Ø¸Ø±',0),(298484,8292,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(298485,8292,'vi','Xem lá»‹ch sá»­ thay Ä‘á»•i ngÃ y Ä‘áº¿n háº¡n',0),(298486,8292,'af','Besigtig Verskuldigde Datum Veranderingsgeskiedenis',0),(298487,8292,'ro','Vezi datorate data istoricul modificÄƒrilor',0),(298488,8292,'et','Vaade tÃ¤htaja kuupÃ¤eva muutuste ajalugu',0),(298489,8292,'si','Pogled zaradi datuma zgodovine sprememb',0),(298490,8292,'ba','Lihat karena tanggal perubahan sejarah',0),(298491,8292,'nl','Weergave verschuldigde datum wijzigingsoverzicht',0),(298492,8292,'fi','NÃ¤kymÃ¤n pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ muutoshistoria',0),(298493,8292,'no','Vis grunn dato endringslogg',0),(298494,8292,'da','Se Due dato Ã¦ndringsoversigt',0),(298495,8292,'ko','ê¸°í•œ ë‚ ì§œ ë³€ê²½ ê¸°ë¡ ë³´ê¸°',0),(298496,8292,'he','×ª×¦×•×’×ª ×‘×©×œ ×”×™×¡×˜×•×¨×™×™×ª ×”×©×™× ×•×™×™× ×ª××¨×™×š',0),(298497,8292,'el','Î˜Î­Î± Î»ÏŒÎ³Ï‰ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î±Î»Î»Î±Î³ÏŽÎ½',0),(298498,8292,'zh','æŸ¥çœ‹æˆªæ­¢æ—¥æœŸå˜æ›´è®°å½•\r\n',0),(298499,8292,'sv','Visa vederbÃ¶rlig datum omarbetningsloggen',0),(298500,8292,'it','Vista dovuta storia di cambiamento di data',0),(298501,8292,'tl','',0),(298502,8292,'th','&#3604;&#3641;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3606;&#3638;&#3591;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(298503,8292,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤¦à¥‡à¤–à¥‡à¤‚',0),(298504,8292,'ms','Lihat kerana sejarah perubahan tarikh',0),(298505,8292,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ù‚Ø±Ø± ØªØ§Ø±ÙŠØ® ØªØºÙŠÙŠØ± Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(298506,8292,'fr','Vue Due Date historique des modifications',0),(298507,8292,'jp','æ—¥ä»˜å¤‰æ›´å±¥æ­´ã«ã‚ˆã‚‹ãƒ“ãƒ¥ãƒ¼',0),(298508,8292,'pt','Vista devido a histÃ³ria de mudanÃ§a de data',0),(298509,8292,'ru','Ð’Ð¸Ð´ Ð¸Ð·-Ð·Ð° Ð´Ð°Ñ‚Ñ‹ Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(298510,8292,'es','Ver Historia de Cambio de Fecha de Vencimiento',0),(298511,8292,'de','Ansicht Due Date Change History',0),(298512,8292,'en','View Due Date Change History',0),(298513,8293,'is','',0),(298514,8293,'dr','NolaPro ÙØ¹Ø§Ù„ÙŠØª ',0),(298515,8293,'pr','NolaPro ÙØ¹Ø§Ù„ÙŠØª ',0),(298516,8293,'tr','Sistem etkinliÄŸi',0),(298517,8293,'pl','DziaÅ‚anie systemu',0),(298518,8293,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð½Ð°Ñ‚Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(298519,8293,'ur','Ø³Ø³Ù¹Ù… Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(298520,8293,'sr','Ð¡Ð¸ÑÑ‚ÐµÐ¼ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(298521,8293,'vi','Hoáº¡t Ä‘á»™ng cá»§a NolaPro',0),(298522,8293,'af','NolaPro Aktiwiteite',0),(298523,8293,'ro','Activitatea sistemului',0),(298524,8293,'et','NolaPro tegevused',0),(298525,8293,'si','Dejavnost sistema',0),(298526,8293,'ba','Sistem kegiatan',0),(298527,8293,'nl','Systeemactiviteit',0),(298528,8293,'fi','JÃ¤rjestelmÃ¤n toiminta',0),(298529,8293,'no','Systemaktivitet',0),(298530,8293,'da','Systemaktivitet',0),(298531,8293,'ko','ì‹œìŠ¤í…œ ìž‘ì—…',0),(298532,8293,'he','NolaPro ×¤×¢×™×œ×•×ª',0),(298533,8293,'el','Î”ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚ Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚',0),(298534,8293,'zh','ç³»ç»Ÿæ´»åŠ¨\r\n',0),(298535,8293,'sv','Systemaktivitet',0),(298536,8293,'it','AttivitÃ  del sistema',0),(298537,8293,'tl','',0),(298538,8293,'th','&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617; NolaPro',0),(298539,8293,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(298540,8293,'ms','Aktiviti sistem',0),(298541,8293,'ar','Ù†Ø´Ø§Ø· Ø§Ù„Ù…Ù†Ø¸ÙˆÙ…Ø©',0),(298542,8293,'fr','ActivitÃ© du systÃ¨me',0),(298543,8293,'jp','ã‚·ã‚¹ãƒ†ãƒ  ãƒ» ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£',0),(298544,8293,'pt','Atividade do sistema',0),(298545,8293,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ NolaPro',0),(298546,8293,'es','NolaPro Actividad',0),(298547,8293,'de','SystemaktivitÃ¤t',0),(298548,8293,'en','System Activity',0),(298549,8294,'is','',0),(298550,8294,'dr','NolaProØ¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ',0),(298551,8294,'pr','NolaProØ¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ',0),(298552,8294,'tr','Sistem GÃ¼ncelleÅŸtirmesi',0),(298553,8294,'pl','Aktualizacja systemu',0),(298554,8294,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(298555,8294,'ur','Ù†Ø¸Ø§Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(298556,8294,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(298557,8294,'vi','Cáº­p Nháº­t NolaPro ',0),(298558,8294,'af','NolaPro Opdatering',0),(298559,8294,'ro','Sistem Update',0),(298560,8294,'et','NolaPro uuendamine',0),(298561,8294,'si','Posodobitev sistema',0),(298562,8294,'ba','Update sistem',0),(298563,8294,'nl','Systeemupdate',0),(298564,8294,'fi','JÃ¤rjestelmÃ¤pÃ¤ivitys',0),(298565,8294,'no','Systemoppdatering',0),(298566,8294,'da','Systemopdatering',0),(298567,8294,'ko','ì‹œìŠ¤í…œ ì—…ë°ì´íŠ¸',0),(298568,8294,'he','NolaPro ×¢×“×›×•×Ÿ',0),(298569,8294,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚',0),(298570,8294,'zh','ç³»ç»Ÿæ›´æ–°\r\n',0),(298571,8294,'sv','Uppdatering av system',0),(298572,8294,'it','Aggiornamento del sistema',0),(298573,8294,'tl','',0),(298574,8294,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; NolaPro ',0),(298575,8294,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(298576,8294,'ms','Kemaskini sistem',0),(298577,8294,'ar','ØªØ­Ø¯ÙŠØ« NolaPro',0),(298578,8294,'fr','Mise Ã  jour systÃ¨me',0),(298579,8294,'jp','ã‚·ã‚¹ãƒ†ãƒ ã®æ›´æ–°',0),(298580,8294,'pt','AtualizaÃ§Ã£o do sistema',0),(298581,8294,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ NolaPro',0),(298582,8294,'es','NolaPro ActualizaciÃ³n',0),(298583,8294,'de','Systemupdate',0),(298584,8294,'en','System Update',0),(298585,8295,'is','',0),(298586,8295,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù ÙÙŠÙ„Ø¯Ù‡Ø§ ',0),(298587,8295,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù ÙÙŠÙ„Ø¯Ù‡Ø§ ',0),(298588,8295,'tr','Hata alanlarÄ± silme',0),(298589,8295,'pl','BÅ‚Ä…d usuwania pÃ³l',0),(298590,8295,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(298591,8295,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ù‚Ø·Ø¹Ø§Øª',0),(298592,8295,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð±Ñ€Ð¸ÑÐ°ÑšÐ° Ð¿Ð¾Ñ™Ð°',0),(298593,8295,'vi','Lá»—i khi xÃ³a trÆ°á»ng',0),(298594,8295,'af','Fout met Skrapping van Velde',0),(298595,8295,'ro','Eroare ÅŸtergeÅ£i cÃ¢mpuri',0),(298596,8295,'et','TÃµrge kustutamisel vÃ¤ljad',0),(298597,8295,'si','Napaka pri brisanju polja',0),(298598,8295,'ba','Error menghapus bidang',0),(298599,8295,'nl','Fout verwijderen van velden',0),(298600,8295,'fi','Virhe poistamalla kentÃ¤t',0),(298601,8295,'no','Feil slette felt',0),(298602,8295,'da','Fejl slette felter',0),(298603,8295,'ko','ì˜¤ë¥˜ ì‚­ì œ í•„ë“œ',0),(298604,8295,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×©×“×•×ª',0),(298605,8295,'el','Î›Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï€ÎµÎ´Î¯Ï‰Î½',0),(298606,8295,'zh','é”™è¯¯åˆ é™¤å­—æ®µ\r\n',0),(298607,8295,'sv','Fel ta bort fÃ¤lt',0),(298608,8295,'it','Errore eliminando campi',0),(298609,8295,'tl','',0),(298610,8295,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(298611,8295,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤¹à¤Ÿà¤¾ à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(298612,8295,'ms','Ralat Menghapuskan bidang',0),(298613,8295,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø­Ù‚ÙˆÙ„',0),(298614,8295,'fr','Erreur suppression de champs',0),(298615,8295,'jp','ã‚¨ãƒ©ãƒ¼ã‚’å‰Šé™¤ã™ã‚‹ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(298616,8295,'pt','Erro excluindo campos',0),(298617,8295,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÐŸÐ¾Ð»ÐµÐ¹',0),(298618,8295,'es','Error eliminando campos',0),(298619,8295,'de','Fehler lÃ¶schen von Feldern',0),(298620,8295,'en','Error Deleting Fields',0),(298621,8296,'is','',0),(298622,8296,'dr','( Ø§Ø±Ø²Ø´Ù‡Ø§ÙŠ) ÙÙŠÙ„Ø¯ ',0),(298623,8296,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø´Ø§Ø®Øµ Ù‡Ø§ÙŠ ( Ø§Ø±Ø²Ø´Ù‡Ø§ÙŠ) ÙÙŠÙ„Ø¯ ',0),(298624,8296,'tr','Hata ekleyerek alan deÄŸerleri',0),(298625,8296,'pl','BÅ‚Ä…d wstawiania wartoÅ›ci pÃ³l',0),(298626,8296,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð¿Ð¾Ð»Ðµ ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸',0),(298627,8296,'ur','Ù†Ù‚Øµ Ù‚Ø·Ø¹Û Ù‚Ø¯Ø±ÛŒÚº Ø¯Ø§Ø®Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(298628,8296,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµÐ¼ Ð¿Ð¾Ñ™Ð° Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð³Ñ€ÐµÑˆÐºÐµ',0),(298629,8296,'vi','Lá»—i khi chÃ¨n giÃ¡ trá»‹ trÆ°á»ng',0),(298630,8296,'af','Fout met Invoeging van Veldwaardes',0),(298631,8296,'ro','Eroare inserarea valorile de cÃ¢mp',0),(298632,8296,'et','Viga lisamine vÃ¤ljavÃ¤Ã¤rtused',0),(298633,8296,'si','Vstavljanje polja vrednosti napak',0),(298634,8296,'ba','Kesalahan memasukkan nilai-nilai bidang',0),(298635,8296,'nl','Fout veldwaarden invoegen',0),(298636,8296,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ kenttÃ¤arvot',0),(298637,8296,'no','Feil Ã¥ sette inn verdier',0),(298638,8296,'da','Fejl indsÃ¦tte feltvÃ¦rdier',0),(298639,8296,'ko','ì˜¤ë¥˜ ì‚½ìž… í•„ë“œ ê°’',0),(298640,8296,'he','×¢×¨×›×™ ×©×“×” ×”×•×¡×¤×ª ×©×’×™××”',0),(298641,8296,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï€ÎµÎ´Î¯Î¿Ï… Ï„Î¹Î¼Î­Ï‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚',0),(298642,8296,'zh','é”™è¯¯æ’å…¥å­—æ®µå€¼',0),(298643,8296,'sv','Infoga fÃ¤ltet felvÃ¤rden',0),(298644,8296,'it','Errore inserimento valori di campo',0),(298645,8296,'tl','',0),(298646,8296,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3588;&#3656;&#3657;&#3634;&#3586;&#3629;&#3591;&#3615;&#3636;&#3621;&#3604;&#3660;',0),(298647,8296,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¡à¤¾à¤²à¤¨à¥‡ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤®à¤¾à¤¨à¥‹à¤‚',0),(298648,8296,'ms','Kesilapan memasukkan bidang nilai-nilai',0),(298649,8296,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¯Ø±Ø§Ø¬ Ø­Ù‚Ù„ Ø§Ù„Ù‚ÙŠÙ…',0),(298650,8296,'fr','Erreur insertion champ valeurs',0),(298651,8296,'jp','ã‚¨ãƒ©ãƒ¼æŒ¿å…¥ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰å€¤',0),(298652,8296,'pt','Erro inserir valores de campo',0),(298653,8296,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð¿Ð¾Ð»ÐµÐ¹',0),(298654,8296,'es','Error Insertando Valores de Campo',0),(298655,8296,'de','Fehler EinfÃ¼gen von Feldwerten',0),(298656,8296,'en','Error Inserting Field Values',0),(298657,8297,'is','',0),(298658,8297,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ø±Ø§  Ø¨Ø§Ù„Ø§ÙŠ ØµÙØ­Ù‡ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(298659,8297,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ø±Ø§  Ø¨Ø§Ù„Ø§ÙŠ ØµÙØ­Ù‡ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(298660,8297,'tr','EÄŸer sayfada bir sayÄ± girmelisiniz.',0),(298661,8297,'pl','NaleÅ¼y wprowadziÄ‡ numer na arkuszu.',0),(298662,8297,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð»Ð¸ÑÑ‚.',0),(298663,8297,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø¹Ø¯Ø¯ ÙˆØ±Ù‚ Ù¾Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(298664,8297,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð½Ð° Ñ€Ð°Ð´Ð½Ð¾Ð¼ Ð»Ð¸ÑÑ‚Ñƒ.',0),(298665,8297,'vi','Báº¡n pháº£i nháº­p 1 sá»‘ trÃªn báº£ng',0),(298666,8297,'af','U moet die totaal op hierdie blad bereken.',0),(298667,8297,'ro','Trebuie sa introduceti un nume pe foaie',0),(298668,8297,'et','Te peate sisestama lehele numbri',0),(298669,8297,'si','Morate vnesti Å¡tevilo na list.',0),(298670,8297,'ba','Anda harus memasukkan nomor pada lembar.',0),(298671,8297,'nl','U moet een aantal Voer maximaal op blad.',0),(298672,8297,'fi','Kirjoita useita arkki.',0),(298673,8297,'no','Du mÃ¥ angi et tall pÃ¥ arket.',0),(298674,8297,'da','Du skal angive et nummer pÃ¥ ark.',0),(298675,8297,'ko','ì‹œíŠ¸ ìˆ«ìžë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(298676,8297,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ž×¡×¤×¨ ×’×™×œ×™×•×Ÿ.',0),(298677,8297,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ Î±ÏÎ¹Î¸Î¼ÏŒ ÏƒÏ„Î¿ Ï†ÏÎ»Î»Î¿.',0),(298678,8297,'zh','æ‚¨åœ¨ä¸€ä¸ªè¡¨ä¸Šå¿…é¡»è¾“å…¥ä¸€ä¸ªæ•°å­—ä»¥ä¸Šã€‚\r\n',0),(298679,8297,'sv','Du mÃ¥ste ange ett nummer pÃ¥ blad.',0),(298680,8297,'it','Ãˆ necessario immettere un numero sul foglio.',0),(298681,8297,'tl','',0),(298682,8297,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3619;&#3629;&#3585;&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3610;&#3609;&#3585;&#3619;&#3632;&#3604;&#3634;&#3625;',0),(298683,8297,'hi','à¤†à¤ª à¤ªà¤¤à¥à¤°à¤• à¤ªà¤° à¤à¤• à¤¨à¤‚à¤¬à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(298684,8297,'ms','Anda mesti masukkan nombor kira-kira.',0),(298685,8297,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø¹Ù„Ù‰ ÙˆØ±Ù‚Ø©.',0),(298686,8297,'fr','Vous devez entrer un numÃ©ro sur la feuille.',0),(298687,8297,'jp','ã‚·ãƒ¼ãƒˆä¸Šæ•°å€¤ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(298688,8297,'pt','VocÃª deve digitar um nÃºmero na folha.',0),(298689,8297,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ñ‡Ð¸ÑÐ»Ð¾ Ð½Ð° Ð»Ð¸ÑÑ‚Ðµ.',0),(298690,8297,'es','Debe introducir un nÃºmero superior en la hoja',0),(298691,8297,'de','Sie mÃ¼ssen eine Zahl auf Blatt oben eingeben.',0),(298692,8297,'en','You must enter a number up on sheet.',0),(298693,8298,'is','',0),(298694,8298,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ø±ÙƒØª Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(298695,8298,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ø±ÙƒØª Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(298696,8298,'tr','Bir ÅŸirket seÃ§meniz gerekir.',0),(298697,8298,'pl','NaleÅ¼y wybraÄ‡ firmÄ™.',0),(298698,8298,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ´Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ.',0),(298699,8298,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ú©Ù…Ù¾Ù†ÛŒ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’ Û”',0),(298700,8298,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ðµ.',0),(298701,8298,'vi','Pháº£i chá»n 1 cty',0),(298702,8298,'af','U moet \'n besigheid kies.',0),(298703,8298,'ro','Trebuie sa selectati o companie',0),(298704,8298,'et','Pead valima ettevÃµtte',0),(298705,8298,'si','Izberite podjetje.',0),(298706,8298,'ba','Anda harus memilih sebuah perusahaan.',0),(298707,8298,'nl','Je moet een bedrijf selecteren',0),(298708,8298,'fi','Valitse yritys.',0),(298709,8298,'no','Du mÃ¥ velge et selskap.',0),(298710,8298,'da','Du skal vÃ¦lge en virksomhed.',0),(298711,8298,'ko','íšŒì‚¬ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(298712,8298,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×—×‘×¨×”',0),(298713,8298,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î¼Î¹Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±.',0),(298714,8298,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªå…¬å¸',0),(298715,8298,'sv','Du mÃ¥ste vÃ¤lja ett fÃ¶retag.',0),(298716,8298,'it','Ãˆ necessario selezionare una societÃ .',0),(298717,8298,'tl','',0),(298718,8298,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(298719,8298,'hi','à¤†à¤ª à¤à¤• à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(298720,8298,'ms','Anda mesti memilih sebuah syarikat.',0),(298721,8298,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ®ØªØ§Ø± Ø´Ø±ÙƒØ©',0),(298722,8298,'fr','Vous devez sÃ©lectionner une compagnie',0),(298723,8298,'jp','ä¼šç¤¾ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(298724,8298,'pt','VocÃª deve selecionar uma empresa.',0),(298725,8298,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ.',0),(298726,8298,'es','Debe seleccionar una compaÃ±Ã­a.',0),(298727,8298,'de','Sie mÃ¼ssen ein Unternehmen auswÃ¤hlen.',0),(298728,8298,'en','You must select a company.',0),(298729,8299,'is','',0),(298730,8299,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(298731,8299,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(298732,8299,'tr','Bir miktar seÃ§meniz gerekir.',0),(298733,8299,'pl','NaleÅ¼y wybraÄ‡ iloÅ›Ä‡.',0),(298734,8299,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾.',0),(298735,8299,'ur','Ø¢Ù¾ Ú©ÛŒ Ø§ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’ Û”',0),(298736,8299,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ.',0),(298737,8299,'vi','Báº¡n pháº£i chá»n sá»‘ lÆ°á»£ng',0),(298738,8299,'af','U moet \'n hoeveelheid kies.',0),(298739,8299,'ro','Trebuie sa selectati o cantitate',0),(298740,8299,'et','Pead valima koguse',0),(298741,8299,'si','Izberite koliÄino.',0),(298742,8299,'ba','Anda harus memilih sebuah kuantitas.',0),(298743,8299,'nl','je moet een hoeveelheid selecteren',0),(298744,8299,'fi','Valitse mÃ¤Ã¤rÃ¤.',0),(298745,8299,'no','Du mÃ¥ velge et antall.',0),(298746,8299,'da','Du skal vÃ¦lge en mÃ¦ngde.',0),(298747,8299,'ko','ìˆ˜ëŸ‰ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(298748,8299,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×›×ž×•×ª.',0),(298749,8299,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î¼Î¹Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±.',0),(298750,8299,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªæ•°é‡',0),(298751,8299,'sv','Du mÃ¥ste vÃ¤lja en kvantitet.',0),(298752,8299,'it','Ãˆ necessario selezionare una quantitÃ .',0),(298753,8299,'tl','',0),(298754,8299,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(298755,8299,'hi','à¤¤à¥à¤® à¤à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(298756,8299,'ms','Anda mesti memilih kuantiti.',0),(298757,8299,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ®ØªØ§Ø± ÙƒÙ…ÙŠØ©',0),(298758,8299,'fr','Vous devez sÃ©lectionner une quantitÃ©.',0),(298759,8299,'jp','æ•°é‡ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(298760,8299,'pt','VocÃª deve selecionar uma quantidade.',0),(298761,8299,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾.',0),(298762,8299,'es','Debe seleccionar una cantidad.',0),(298763,8299,'de','Sie mÃ¼ssen eine Menge auswÃ¤hlen.',0),(298764,8299,'en','You must select a quantity.',0),(298765,8300,'is','',0),(298766,8300,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø§Ù†Ø¯Ø§Ø²Ù‡  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(298767,8300,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø§Ù†Ø¯Ø§Ø²Ù‡  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(298768,8300,'tr','Bir boyut seÃ§meniz gerekir.',0),(298769,8300,'pl','NaleÅ¼y wybraÄ‡ rozmiar.',0),(298770,8300,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(298771,8300,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø³Ø§Ø¦Ø² Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Û”',0),(298772,8300,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ.',0),(298773,8300,'vi','Báº¡n pháº£i chá»n 1 cá»¡',0),(298774,8300,'af','U moet \'n grootte kies.',0),(298775,8300,'ro','Trebuie sa selectati o dimensiune',0),(298776,8300,'et','Pead valima suuruse',0),(298777,8300,'si','Izberite velikost.',0),(298778,8300,'ba','Anda harus memilih ukuran.',0),(298779,8300,'nl','Je moet een maat selecteren',0),(298780,8300,'fi','Valitse koko.',0),(298781,8300,'no','Du mÃ¥ velge en stÃ¸rrelse.',0),(298782,8300,'da','Du skal vÃ¦lge en stÃ¸rrelse.',0),(298783,8300,'ko','í¬ê¸°ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(298784,8300,'he','.×¢×œ×™×š ×œ×‘×—×•×¨ ×’×•×“×œ',0),(298785,8300,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± Î¼Î­Î³ÎµÎ¸Î¿Ï‚.',0),(298786,8300,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªå°ºå¯¸',0),(298787,8300,'sv','Du mÃ¥ste vÃ¤lja en storlek.',0),(298788,8300,'it','Ãˆ necessario selezionare una dimensione.',0),(298789,8300,'tl','',0),(298790,8300,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;&#3586;&#3609;&#3634;&#3604;',0),(298791,8300,'hi','à¤†à¤ª à¤à¤• à¤†à¤•à¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(298792,8300,'ms','Anda mesti memilih satu saiz.',0),(298793,8300,'ar','ÙŠØ¬Ø¨ ØªØ­Ø¯ÙŠØ¯ Ø­Ø¬Ù….',0),(298794,8300,'fr','Vous devez sÃ©lectionner une taille.',0),(298795,8300,'jp','ã‚µã‚¤ã‚ºã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(298796,8300,'pt','VocÃª deve selecionar um tamanho.',0),(298797,8300,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ñ€Ð°Ð·Ð¼ÐµÑ€.',0),(298798,8300,'es','Debe seleccionar un tamaÃ±o.',0),(298799,8300,'de','Sie mÃ¼ssen eine GrÃ¶ÃŸe auswÃ¤hlen.',0),(298800,8300,'en','You must select a size.',0),(298801,8301,'is','',0),(298802,8301,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(298803,8301,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(298804,8301,'tr','Bir hisse senedi tÃ¼rÃ¼ seÃ§meniz gerekir.',0),(298805,8301,'pl','NaleÅ¼y wybraÄ‡ typ.',0),(298806,8301,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿ ÑÑŠÑÑ‚Ð°Ð².',0),(298807,8301,'ur','Ø¢Ù¾ Ú©Ùˆ Ø³Ù¹Ø§Ú© Ú©ÛŒ Ø§ÛŒÚ© Ù‚Ø³Ù… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Û”',0),(298808,8301,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿ Ð°ÐºÑ†Ð¸Ñ˜Ðµ.',0),(298809,8301,'vi','Báº¡n pháº£i chá»n 1 loáº¡i hÃ ng',0),(298810,8301,'af','U moet \'n VOORRAADTIPE kies.',0),(298811,8301,'ro','Trebuie sa selectati un stoc',0),(298812,8301,'et','Te peate valima laotÃ¼Ã¼bi',0),(298813,8301,'si','Izbrati morate vrsto zalog.',0),(298814,8301,'ba','Anda harus pilih jenis saham.',0),(298815,8301,'nl','U moet een voorraad enveloptype selecteren.',0),(298816,8301,'fi','Valitse varaston laji.',0),(298817,8301,'no','Du mÃ¥ velge et lager.',0),(298818,8301,'da','Du skal vÃ¦lge en stock type.',0),(298819,8301,'ko','ìž¬ê³  ì¢…ë¥˜ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(298820,8301,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×¡×•×’ ×ž× ×™×•×ª.',0),(298821,8301,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Ï„ÏÏ€Î¿Ï….',0),(298822,8301,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªåº“å­˜ç±»åž‹',0),(298823,8301,'sv','Du mÃ¥ste vÃ¤lja en lager.',0),(298824,8301,'it','Ãˆ necessario selezionare un tipo di magazzino.',0),(298825,8301,'tl','',0),(298826,8301,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3626;&#3605;&#3658;&#3629;&#3585;',0),(298827,8301,'hi','à¤†à¤ª à¤•à¤¿à¤¸à¥€ à¤¸à¥à¤Ÿà¥‰à¤• à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(298828,8301,'ms','Anda mesti memilih satu jenis saham.',0),(298829,8301,'ar','ÙŠØ¬Ø¨ ØªØ­Ø¯ÙŠØ¯ Ù†ÙˆØ¹ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ©.',0),(298830,8301,'fr','Vous devez sÃ©lectionner un type de stock.',0),(298831,8301,'jp','æ ªå¼åž‹ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(298832,8301,'pt','VocÃª deve selecionar um tipo de estoque.',0),(298833,8301,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð°ÐºÑ†Ð¸Ð¹.',0),(298834,8301,'es','Debe seleccionar un tipo de existencia',0),(298835,8301,'de','Sie mÃ¼ssen eine Bestandsart auswÃ¤hlen.',0),(298836,8301,'en','You must select a stock type.',0),(298837,8302,'is','',0),(298838,8302,'dr','Ø³ÙˆØ¯ Ø­Ø§ØµÙ„ Ø§Ø² ÙØ±ÙˆØ´',0),(298839,8302,'pr','Ø³ÙˆØ¯ Ø­Ø§ØµÙ„ Ø§Ø² ÙØ±ÙˆØ´',0),(298840,8302,'tr','Sadece satÄ±ÅŸ KarlarÄ±',0),(298841,8302,'pl','Zyski ze sprzedaÅ¼y tylko',0),(298842,8302,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð¸Ñ‚Ðµ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°Ñ‚Ð° ÑÐ°Ð¼Ð¾',0),(298843,8302,'ur','ØµØ±Ù Ù…Ù†Ø§ÙØ¹ ÙØ±ÙˆØ®Øª Ø³Û’',0),(298844,8302,'sr','Ð¡Ð°Ð¼Ð¾ Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚ Ð¾Ð´ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(298845,8302,'vi','Chá»‰ lá»£i nhuáº­n tá»« bÃ¡n hÃ ng ',0),(298846,8302,'af','Winste vanuit Verkope Alleenlik',0),(298847,8302,'ro','Profituri din vÃ¢nzarea numai',0),(298848,8302,'et','Kasumit mÃ¼Ã¼gist ainult',0),(298849,8302,'si','DobiÄek od prodaje samo',0),(298850,8302,'ba','Keuntungan dari penjualan hanya',0),(298851,8302,'nl','Winst uit verkoop alleen',0),(298852,8302,'fi','Tuotot myytÃ¤vÃ¤nÃ¤ vain',0),(298853,8302,'no','Overskudd salg bare',0),(298854,8302,'da','Overskud fra salg kun',0),(298855,8302,'ko','íŒë§¤ ìˆ˜ìµë§Œ',0),(298856,8302,'he','×¨×•×•×—×™× ×ž×ž×›×™×¨×” ×‘×œ×‘×“',0),(298857,8302,'el','ÎšÎ­ÏÎ´Î· Î±Ï€ÏŒ Ï€ÏŽÎ»Î·ÏƒÎ· Î¼ÏŒÎ½Î¿',0),(298858,8302,'zh','ä»Žé”€å”®åˆ©æ¶¦åªæœ‰\r\n',0),(298859,8302,'sv','Vinster frÃ¥n fÃ¶rsÃ¤ljning endast',0),(298860,8302,'it','Profitti dalla vendita solo',0),(298861,8302,'tl','',0),(298862,8302,'th','&#3585;&#3635;&#3652;&#3619;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(298863,8302,'hi','à¤•à¥‡à¤µà¤² à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¥‡ à¤®à¥à¤¨à¤¾à¤«à¤¾',0),(298864,8302,'ms','Keuntungan daripada jualan sahaja',0),(298865,8302,'ar','Ø£Ø±Ø¨Ø§Ø­ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ÙÙ‚Ø·',0),(298866,8302,'fr','Profits de vente uniquement',0),(298867,8302,'jp','ã®ã¿ã®è²©å£²ã‹ã‚‰ã®åˆ©ç›Š',0),(298868,8302,'pt','Lucros da venda somente',0),(298869,8302,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(298870,8302,'es','Utilidades de la Venta Solamente',0),(298871,8302,'de','Gewinne aus dem Verkauf nur',0),(298872,8302,'en','Profits from Sale Only',0),(298873,8303,'is','',0),(298874,8303,'dr','Ø¨Ø§ Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ â€“Ù†Ù…Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(298875,8303,'pr','Ø¨Ø§ Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ â€“Ù†Ù…Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(298876,8303,'tr','Adres - faturalar gÃ¶stermek iÃ§in gemi ile',0),(298877,8303,'pl','Rejs statkiem do adres - PokaÅ¼ faktury',0),(298878,8303,'bg','Ð¡ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾ Ð°Ð´Ñ€ÐµÑ - Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(298879,8303,'ur','Ù¾ØªØ§ Ø¬Ø§Øª-ÙˆØ¨Ø¬Ù„ÛŒ Ø´Ùˆ Ú©Û’ Ù„Ø¦Û’ Ø¬ÛØ§Ø² Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(298880,8303,'sr','Ð‘Ñ€Ð¾Ð´Ð¾Ð¼ Ð´Ð° Ð¾Ð±Ñ€Ð°Ñ‚Ð¸ - ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(298881,8303,'vi','Chuyá»ƒn tá»›i - Hiá»ƒn thá»‹ hÃ³a Ä‘Æ¡n',0),(298882,8303,'af','Met Versend Aan Adresse - Wys Fakture ',0),(298883,8303,'ro','Vaporul la adresa - AratÄƒ facturi',0),(298884,8303,'et','Tarneaadressi jÃ¤rgi - nÃ¤ita arveid',0),(298885,8303,'si','Z ladjo na naslov - Show raÄuni',0),(298886,8303,'ba','Dengan kapal ke alamat - Tampilkan faktur',0),(298887,8303,'nl','Per schip naar adres - facturen weergeven',0),(298888,8303,'fi','Laivalla osoite-NÃ¤ytÃ¤ laskut',0),(298889,8303,'no','Med skip til adresse - Vis fakturaer',0),(298890,8303,'da','Med skib til adresse - viser fakturaer',0),(298891,8303,'ko','ìš´ì†¡ì§€ ì£¼ì†Œ-ì²­êµ¬ì„œë¥¼ í‘œì‹œ í•˜ ì—¬',0),(298892,8303,'he','×¢×œ ×™×“×™ ×¡×¤×™× ×” ×›×“×™ ×œ×˜×¤×œ - ×”×¦×’ ×—×©×‘×•× ×™×•×ª',0),(298893,8303,'el','ÎœÎµ Ï€Î»Î¿Î¯Î¿ Î½Î± Î±Î½Ï„Î¹Î¼ÎµÏ„Ï‰Ï€Î¯ÏƒÎµÎ¹ - ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(298894,8303,'zh','æŒ‰ç›®çš„åœ°åœ°å€ -æ˜¾ç¤ºå‘ç¥¨\r\n',0),(298895,8303,'sv','Med fartyg till adress - Visa fakturor',0),(298896,8303,'it','In nave per affrontare - Visualizza fatture',0),(298897,8303,'tl','',0),(298898,8303,'th','&#3650;&#3604;&#3618;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3607;&#3637;&#3656;&#3649;&#3626;&#3591;&#3604;&#3651;&#3609;&#3651;&#3610;&#3626;&#3656;&#3591;&#3586;&#3629;&#3',0),(298899,8303,'hi','à¤ªà¤¤à¤¾ - à¤šà¤¾à¤²à¤¾à¤¨ à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(298900,8303,'ms','Menaiki kapal untuk menangani - menunjukkan invois',0),(298901,8303,'ar','Ø¨Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù…Ø¹Ø§Ù„Ø¬Ø©-Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(298902,8303,'fr','Par navire Ã  attaquer - de montrer les factures',0),(298903,8303,'jp','ã‚¢ãƒ‰ãƒ¬ã‚¹ - è«‹æ±‚æ›¸ã‚’è¡¨ç¤ºã™ã‚‹ã«ã¯ã€èˆ¹ã§',0),(298904,8303,'pt','Pelo navio de endereÃ§o - Visualizar faturas',0),(298905,8303,'ru','ÐÐ° ÐºÐ¾Ñ€Ð°Ð±Ð»Ðµ Ð´Ð»Ñ Ð°Ð´Ñ€ÐµÑ - ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(298906,8303,'es','Por DirecciÃ³n de EnvÃ­o - Mostrar Facturas',0),(298907,8303,'de','Per Schiff nach Wende - Rechnungen anzeigen',0),(298908,8303,'en','By Ship To Address - Show Invoices',0),(298909,8304,'is','',0),(298910,8304,'dr','Ø®Ù„Ø§ØµÙ‡ Ø¨Ø§ Ø¢Ø¯Ø±Ø³ Ø­Ù…Ù„ ',0),(298911,8304,'pr','Ø®Ù„Ø§ØµÙ‡ Ø¨Ø§ Ø¢Ø¯Ø±Ø³ Ø­Ù…Ù„ ',0),(298912,8304,'tr','Gemi adresine gÃ¶re Ã–zeti',0),(298913,8304,'pl','Podsumowanie wedÅ‚ug adresu dostawy',0),(298914,8304,'bg','Ð ÐµÐ·ÑŽÐ¼Ðµ Ñ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾ Ð°Ð´Ñ€ÐµÑ',0),(298915,8304,'ur','Ù¾ØªÛ Ú©Û’ Ù„Ø¦Û’ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø®Ù„Ø§ØµÛ',0),(298916,8304,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð±Ñ€Ð¾Ð´Ð¾Ð¼ Ð½Ð° Ð°Ð´Ñ€ÐµÑÑƒ',0),(298917,8304,'vi','Tá»•ng há»£p theo dá»‹a chá»‰ chuyá»ƒn Ä‘áº¿n',0),(298918,8304,'af','Opsomming per Versend aan Adres',0),(298919,8304,'ro','Rezumat de nava la adresa',0),(298920,8304,'et','Kuhu saata KokkuvÃµte',0),(298921,8304,'si','Povzetek z ladjo na naslov',0),(298922,8304,'ba','Ringkasan oleh kapal ke alamat',0),(298923,8304,'nl','Samenvatting per schip naar adres',0),(298924,8304,'fi','Yhteenveto toim.asiakk.',0),(298925,8304,'no','Sammendrag av forsendelsesadresse',0),(298926,8304,'da','ResumÃ© af modtageradresse',0),(298927,8304,'ko','ë°°ì†¡ ì£¼ì†Œì— ì˜í•´ ìš”ì•½',0),(298928,8304,'he','×¡×™×›×•× ×¢×œ ×™×“×™ ×¡×¤×™× ×” ×œ×›×ª×•×‘×ª',0),(298929,8304,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Î±Ï€ÏŒ Ï„Î¿ Ï€Î»Î¿Î¯Î¿ ÏƒÏ„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(298930,8304,'zh','æŒ‰æ”¶è´§åœ°å€æ‘˜è¦\r\n',0),(298931,8304,'sv','Sammanfattning av fraktadress',0),(298932,8304,'it','Riepilogo di spedizione all\'indirizzo',0),(298933,8304,'tl','',0),(298934,8304,'th','&#3626;&#3619;&#3640;&#3611;&#3650;&#3604;&#3618;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;',0),(298935,8304,'hi','à¤ªà¤¤à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(298936,8304,'ms','Ringkasan oleh kapal ke alamat',0),(298937,8304,'ar','Ù…ÙˆØ¬Ø² Ø¨Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù†',0),(298938,8304,'fr','RÃ©sumÃ© par bateau Ã  l\'adresse',0),(298939,8304,'jp','é€ä»˜å…ˆä½æ‰€ã®è¦ç´„',0),(298940,8304,'pt','Resumo de navio para o endereÃ§o',0),(298941,8304,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»Ðµ Ð½Ð° Ð°Ð´Ñ€ÐµÑ',0),(298942,8304,'es','ResÃºmen por DirecciÃ³n de Enviar-a',0),(298943,8304,'de','Zusammenfassung per Schiff nach Adresse',0),(298944,8304,'en','Summary by Ship To Address',0),(298945,8305,'is','',0),(298946,8305,'dr','Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ø¨ÙŠÙ† Ø´Ø±ÙƒØªÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(298947,8305,'pr','Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ø¨ÙŠÙ† Ø´Ø±ÙƒØªÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(298948,8305,'tr','ÅžirketlerarasÄ± stok transferi',0),(298949,8305,'pl','ZapasÃ³w wewnÄ…trzfirmowych transferÃ³w',0),(298950,8305,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¾-Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(298951,8305,'ur','Ø§Ù†Ù¹Ø± Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(298952,8305,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¸Ð·Ð¼ÐµÑ’Ñƒ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð° Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(298953,8305,'vi','Chuyá»ƒn Giao HÃ ng HÃ³a Trong Ná»™i Bá»™ Cty',0),(298954,8305,'af','Tussen-Onderneming Voorraad Oorplasings',0),(298955,8305,'ro','Firma inter inventar transferuri',0),(298956,8305,'et','Kontserni laoseisu Ã¼lekanded',0),(298957,8305,'si','Med podjetji, prenosi zaloge',0),(298958,8305,'ba','Transfer antar perusahaan persediaan',0),(298959,8305,'nl','Intercompany Voorraadtransfers',0),(298960,8305,'fi','YritystenvÃ¤linen varastosiirrot',0),(298961,8305,'no','Inter selskapets lager overfÃ¸ringer',0),(298962,8305,'da','IC lageroverflytninger',0),(298963,8305,'ko','íšŒì‚¬ ê°„ ìž¬ê³  ì´ì „',0),(298964,8305,'he','×”×¢×‘×¨×•×ª ×ž×œ××™ ×”×‘×™×Ÿ-×”×—×‘×¨×”',0),(298965,8305,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÎ½Î´Î¿ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ­Ï‚ Î¼ÎµÏ„Î±Î²Î¹Î²Î¬ÏƒÎµÎ¹Ï‚',0),(298966,8305,'zh','è·¨å…¬å¸åº“å­˜è½¬å‚¨\r\n',0),(298967,8305,'sv','Mellan fÃ¶retag lagerÃ¶verfÃ¶ringar',0),(298968,8305,'it','Trasferimenti di Inter-azienda inventario',0),(298969,8305,'tl','',0),(298970,8305,'th','&#3585;&#3634;&#3619;&#3650;&#3629;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3616;&#3634;&#3618;&#3651;&#3609;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(298971,8305,'hi','à¤…à¤‚à¤¤à¤° à¤•à¤‚à¤ªà¤¨à¥€ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤¨à¥à¤¤à¤°à¤£',0),(298972,8305,'ms','Inventori antara Syarikat pemindahan',0),(298973,8305,'ar','ØªØ­ÙˆÙŠÙ„Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¨ÙŠÙ† Ø§Ù„Ø´Ø±ÙƒØ©',0),(298974,8305,'fr','Transferts de stock de la inter-sociÃ©tÃ©',0),(298975,8305,'jp','ä¼šç¤¾é–“åœ¨åº«è»¢é€',0),(298976,8305,'pt','TransferÃªncias de estoque entre empresas',0),(298977,8305,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð²Ð½ÑƒÑ‚Ñ€Ð¸Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ñ‹',0),(298978,8305,'es','Inter-Empresa Transferencias de Inventario',0),(298979,8305,'de','Ãœberbetrieblichen Inventar Transfers',0),(298980,8305,'en','Inter-Company Inventory Transfers',0),(298981,8306,'is','',0),(298982,8306,'dr','ÙÙ‚Ø· ÙŠÙƒ Ø´Ø±ÙƒØª ØªØ¹Ø±ÙŠÙ Ø´Ø¯Ù‡ ',0),(298983,8306,'pr','ÙÙ‚Ø· ÙŠÙƒ Ø´Ø±ÙƒØª ØªØ¹Ø±ÙŠÙ Ø´Ø¯Ù‡ ',0),(298984,8306,'tr','YalnÄ±zca tanÄ±mlÄ± bir ÅŸirket',0),(298985,8306,'pl','Tylko jedna firma okreÅ›lone',0),(298986,8306,'bg','Ð¡Ð°Ð¼Ð¾ ÐµÐ´Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ€Ð°Ð½Ð¸',0),(298987,8306,'ur','ØµØ±Ù Ø§ÛŒÚ© ÙˆØ¶Ø§Ø­ØªÛŒ Ú©Ù…Ù¾Ù†ÛŒ',0),(298988,8306,'sr','Ð¡Ð°Ð¼Ð¾ Ñ˜ÐµÐ´Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð´ÐµÑ„Ð¸Ð½Ð¸ÑÐ°Ð½',0),(298989,8306,'vi','Chá»‰ Ä‘á»‹nh nghÄ©a 1 cty',0),(298990,8306,'af','Slegs Een Onderneming Beskryf',0),(298991,8306,'ro','Doar o companie definite',0),(298992,8306,'et','Ainult Ã¼he ettevÃµtte mÃ¤Ã¤ratletud',0),(298993,8306,'si','Le eno podjetje, opredeljeno',0),(298994,8306,'ba','Hanya satu perusahaan didefinisikan',0),(298995,8306,'nl','Slechts Ã©Ã©n bedrijf gedefinieerd',0),(298996,8306,'fi','Ainoastaan yksi yritys mÃ¤Ã¤ritellÃ¤Ã¤n',0),(298997,8306,'no','Bare ett selskap definert',0),(298998,8306,'da','Kun Ã©t selskab defineret',0),(298999,8306,'ko','ë‹¨ í•˜ë‚˜ íšŒì‚¬ ì •ì˜',0),(299000,8306,'he','×¨×§ ×—×‘×¨×” ××—×ª ×ž×•×’×“×¨×ª',0),(299001,8306,'el','ÎœÏŒÎ½Î¿ Î¼Î¯Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Ï€Î¿Ï… Î¿ÏÎ¯Î¶ÎµÏ„Î±Î¹',0),(299002,8306,'zh','åªæœ‰ä¸€å®¶å®šä¹‰çš„å…¬å¸\r\n',0),(299003,8306,'sv','Endast ett fÃ¶retag definieras',0),(299004,8306,'it','Solo una societÃ  definita',0),(299005,8306,'tl','',0),(299006,8306,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3648;&#3593;&#3614;&#3634;&#3632;&#3627;&#3609;&#3638;&#3656;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(299007,8306,'hi','à¤•à¥‡à¤µà¤² à¤à¤• à¤•à¤‚à¤ªà¤¨à¥€ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¿à¤¤',0),(299008,8306,'ms','Hanya satu syarikat ditakrifkan',0),(299009,8306,'ar','ÙÙ‚Ø· Ø´Ø±ÙƒØ© ÙˆØ§Ø­Ø¯Ø© Ù…Ø­Ø¯Ø¯Ø©',0),(299010,8306,'fr','Seule une sociÃ©tÃ© dÃ©fini',0),(299011,8306,'jp','å®šç¾©ã•ã‚Œã¦ã„ã‚‹ 1 ã¤ã®ä¼šç¤¾ã®ã¿',0),(299012,8306,'pt','SÃ³ uma empresa definida',0),(299013,8306,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐžÐ´Ð½Ð° ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ð°Ñ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(299014,8306,'es','Solo Una Empresa Definida',0),(299015,8306,'de','Nur ein Unternehmen definiert',0),(299016,8306,'en','Only One Company Defined',0),(299017,8307,'is','',0),(299018,8307,'dr','Ø¨Ø±Ø§ÙŠ Ø´Ø±ÙƒØª',0),(299019,8307,'pr','Ø¨Ø±Ø§ÙŠ Ø´Ø±ÙƒØª',0),(299020,8307,'tr','Åžirket iÃ§in',0),(299021,8307,'pl','Do firmy',0),(299022,8307,'bg','Ð—Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð°',0),(299023,8307,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Ùˆ',0),(299024,8307,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð¸',0),(299025,8307,'vi','Tá»›i cty',0),(299026,8307,'af','Na Onderneming',0),(299027,8307,'ro','Catre compania',0),(299028,8307,'et','EttevÃµttele',0),(299029,8307,'si','Za podjetje',0),(299030,8307,'ba','Untuk perusahaan',0),(299031,8307,'nl','Bedrijf',0),(299032,8307,'fi','Yritys',0),(299033,8307,'no','Selskapet',0),(299034,8307,'da','Til virksomheden',0),(299035,8307,'ko','íšŒì‚¬ì—',0),(299036,8307,'he','×œ×—×‘×¨×”',0),(299037,8307,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î±',0),(299038,8307,'zh','ä¸ºäº†å…¬å¸\r\n',0),(299039,8307,'sv','Till fÃ¶retag',0),(299040,8307,'it','All\'azienda',0),(299041,8307,'tl','',0),(299042,8307,'th','&#3606;&#3638;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(299043,8307,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(299044,8307,'ms','Kepada Syarikat',0),(299045,8307,'ar','Ù„Ù„Ø´Ø±ÙƒØ©',0),(299046,8307,'fr','Avec une sociÃ©tÃ©',0),(299047,8307,'jp','ä¼šç¤¾ã«',0),(299048,8307,'pt','A empresa',0),(299049,8307,'ru','Ð”Ð»Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(299050,8307,'es','A la Empresa',0),(299051,8307,'de','FÃ¼r Unternehmen',0),(299052,8307,'en','To Company',0),(299053,8308,'is','',0),(299054,8308,'dr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù…Ø´ØªØ±ÙŠ',0),(299055,8308,'pr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù…Ø´ØªØ±ÙŠ',0),(299056,8308,'tr','Ã–zel alanlar DÃ¼zenleyicisi',0),(299057,8308,'pl','Edytor pÃ³l niestandardowych',0),(299058,8308,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¾Ñ€',0),(299059,8308,'ur','Ù…Ø®ØµÙˆØµ Ù‚Ø·Ø¹Ø§Øª Ø§ÛŒÚˆÛŒÙ¹Ø±',0),(299060,8308,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ñ™Ð° Ð•Ð´Ð¸Ñ‚Ð¾Ñ€',0),(299061,8308,'vi','BiÃªn Táº­p CÃ¡c TrÆ°á»ng Tá»± Táº¡o',0),(299062,8308,'af','Aangepasde Velde Redigeerder',0),(299063,8308,'ro','Editor setare campuri',0),(299064,8308,'et','Kohandatud vÃ¤lju toimetaja',0),(299065,8308,'si','Urednik polja po meri',0),(299066,8308,'ba','Custom Fields Editor',0),(299067,8308,'nl','Editor voor aangepaste velden',0),(299068,8308,'fi','Mukautetut kentÃ¤t Editor',0),(299069,8308,'no','Redigering av egendefinerte felt',0),(299070,8308,'da','Editoren til brugerdefinerede felter',0),(299071,8308,'ko','ì‚¬ìš©ìž ì§€ì • í•„ë“œ íŽ¸ì§‘ê¸°',0),(299072,8308,'he','×¢×•×¨×š ×©×“×•×ª ×ž×•×ª××ž×™× ××™×©×™×ª',0),(299073,8308,'el','Custom Ï€ÎµÎ´Î¯Î± ÏƒÏ…Î½Ï„Î¬ÎºÏ„Î·',0),(299074,8308,'zh','è‡ªå®šä¹‰å­—æ®µç¼–è¾‘å™¨\r\n',0),(299075,8308,'sv','Anpassade fÃ¤lt redaktÃ¶r',0),(299076,8308,'it','Editor di campi personalizzati',0),(299077,8308,'tl','',0),(299078,8308,'th','&#3612;&#3641;&#3657;&#3649;&#3585;&#3657;&#3652;&#3586;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(299079,8308,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤«à¥€à¤²à¥à¤¡à¥à¤¸ à¤¸à¤‚à¤ªà¤¾à¤¦à¤•',0),(299080,8308,'ms','Editor bidang Kastam',0),(299081,8308,'ar','Ù…Ø­Ø±Ø± Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ø®ØµØµØ©',0),(299082,8308,'fr','Ã‰diteur de champs personnalisÃ©s',0),(299083,8308,'jp','ã‚«ã‚¹ã‚¿ãƒ  ãƒ» ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ ãƒ» ã‚¨ãƒ‡ã‚£ã‚¿ãƒ¼',0),(299084,8308,'pt','Editor de campos personalizados',0),(299085,8308,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¾Ñ€ ÐŸÐ¾Ð»ÐµÐ¹ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(299086,8308,'es','Editor de campos Personalizados',0),(299087,8308,'de','Editor fÃ¼r benutzerdefinierte Felder',0),(299088,8308,'en','Custom Fields Editor',0),(299089,8309,'is','',0),(299090,8309,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù ÙÙŠÙ„Ø¯ ',0),(299091,8309,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù ÙÙŠÙ„Ø¯ ',0),(299092,8309,'tr','Hata alanÄ± silme',0),(299093,8309,'pl','BÅ‚Ä…d usuwania pola',0),(299094,8309,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¿Ð¾Ð»Ðµ',0),(299095,8309,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ù‚Ø·Ø¹Û',0),(299096,8309,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ð¾Ñ™Ðµ',0),(299097,8309,'vi','Lá»—i khi xÃ³a trÆ°á»ng',0),(299098,8309,'af','Fout met Skrapping van Veld',0),(299099,8309,'ro','Eroare ÅŸtergerea cÃ¢mpului',0),(299100,8309,'et','TÃµrge kustutamisel vÃ¤lja',0),(299101,8309,'si','Napaka izbrisali polje',0),(299102,8309,'ba','Kesalahan menghapus bidang',0),(299103,8309,'nl','Fout verwijderen veld',0),(299104,8309,'fi','Virhe poistettaessa kenttÃ¤',0),(299105,8309,'no','Feil slette felt',0),(299106,8309,'da','Fejl slette feltet',0),(299107,8309,'ko','ì˜¤ë¥˜ ì‚­ì œ í•„ë“œ',0),(299108,8309,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”×©×“×”',0),(299109,8309,'el','Î›Î¬Î¸Î¿Ï‚ Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Ï€ÎµÎ´Î¯Î¿Ï…',0),(299110,8309,'zh','é”™è¯¯åˆ é™¤å­—æ®µ',0),(299111,8309,'sv','Fel ta bort fÃ¤lt',0),(299112,8309,'it','Campo di eliminazione errore',0),(299113,8309,'tl','',0),(299114,8309,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(299115,8309,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤«à¤¼à¥€à¤²à¥à¤¡',0),(299116,8309,'ms','Ralat Menghapuskan bidang',0),(299117,8309,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø­Ù‚Ù„',0),(299118,8309,'fr','Erreur suppression du champ',0),(299119,8309,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’å‰Šé™¤ã™ã‚‹ã‚¨ãƒ©ãƒ¼',0),(299120,8309,'pt','Erro excluindo campo',0),(299121,8309,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÐŸÐ¾Ð»Ñ',0),(299122,8309,'es','Error eliminando campo',0),(299123,8309,'de','Fehler lÃ¶schen von Feld',0),(299124,8309,'en','Error Deleting Field',0),(299125,8310,'is','',0),(299126,8310,'dr','( Ø§Ø±Ø²Ø´',0),(299127,8310,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø§Ø¹ØªØ¨Ø§Ø± ( Ø§Ø±Ø²Ø´',0),(299128,8310,'tr','DeÄŸeri silme hatasÄ±',0),(299129,8310,'pl','BÅ‚Ä…d podczas usuwania wartoÅ›ci',0),(299130,8310,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ñ‚Ð°',0),(299131,8310,'ur','Ù†Ù‚Øµ Ù‚Ø¯Ø± Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(299132,8310,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(299133,8310,'vi','Lá»—i xÃ³a giÃ¡ trá»‹',0),(299134,8310,'af','Kon nie waarde te skrap',0),(299135,8310,'ro','Eroare la È™tergerea valoare',0),(299136,8310,'et','TÃµrge kustutamisel vÃ¤Ã¤rtus',0),(299137,8310,'si','Napaka pri brisanju vrednost',0),(299138,8310,'ba','Error menghapus nilai',0),(299139,8310,'nl','Fout bij het verwijderen van waarde',0),(299140,8310,'fi','Virhe poistettaessa arvo',0),(299141,8310,'no','Feil ved sletting av verdi',0),(299142,8310,'da','Fejl ved sletning af vÃ¦rdi',0),(299143,8310,'ko','ì˜¤ë¥˜ ê°’ ì‚­ì œ',0),(299144,8310,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×”×¢×¨×š',0),(299145,8310,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï„Î·Î½ Ï„Î¹Î¼Î®',0),(299146,8310,'zh','é”™è¯¯åˆ é™¤çš„ä»·å€¼',0),(299147,8310,'sv','Fel ta bort vÃ¤rdet',0),(299148,8310,'it','Eliminare il valore di errore',0),(299149,8310,'tl','',0),(299150,8310,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3588;&#3656;&#3634;',0),(299151,8310,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤®à¤¾à¤¨ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(299152,8310,'ms','Ralat Menghapuskan nilai',0),(299153,8310,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„Ù‚ÙŠÙ…Ø©',0),(299154,8310,'fr','Erreur de suppression de valeur',0),(299155,8310,'jp','å€¤ã®å‰Šé™¤ã‚¨ãƒ©ãƒ¼',0),(299156,8310,'pt','Erro ao excluir o valor',0),(299157,8310,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(299158,8310,'es','Error Eliminando Valor',0),(299159,8310,'de','Fehler beim LÃ¶schen der Wert',0),(299160,8310,'en','Error Deleting Value',0),(299161,8311,'is','',0),(299162,8311,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† ÙÙŠÙ„Ø¯ ',0),(299163,8311,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† ÙÙŠÙ„Ø¯ ',0),(299164,8311,'tr','Alan kaydedilirken hata oluÅŸtu',0),(299165,8311,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania pole',0),(299166,8311,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð»Ðµ',0),(299167,8311,'ur','Ù‚Ø·Ø¹Û Ù…Ø­ÙÙˆØ¸ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(299168,8311,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ¿Ñ€ÐµÐ¼Ð°ÑšÐ° Ð¿Ð¾Ñ™Ðµ',0),(299169,8311,'vi','Lá»—i sao lÆ°u trÆ°á»ng',0),(299170,8311,'af','Fout met Stoor van Veld',0),(299171,8311,'ro','Eroare la salvarea cÃ¢mp',0),(299172,8311,'et','VÃ¤li salvestamise tÃµrge',0),(299173,8311,'si','Napaka pri shranjevanju polja',0),(299174,8311,'ba','Kesalahan menyimpan Field',0),(299175,8311,'nl','Fout bij het opslaan van veld',0),(299176,8311,'fi','Virhe tallennettaessa kenttÃ¤',0),(299177,8311,'no','Feil under lagring av feltet',0),(299178,8311,'da','Fejl under lagring af felt',0),(299179,8311,'ko','í•„ë“œ ì €ìž¥ ì˜¤ë¥˜',0),(299180,8311,'he','××™×¨×¢×” ×©×’×™××” ×‘×©×ž×™×¨×ª ×©×“×”',0),(299181,8311,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï€ÎµÎ´Î¯Î¿',0),(299182,8311,'zh','é”™è¯¯ä¿å­˜å­—æ®µ',0),(299183,8311,'sv','Fel vid sparande av fÃ¤ltet',0),(299184,8311,'it','Errore durante il salvataggio di campo',0),(299185,8311,'tl','',0),(299186,8311,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(299187,8311,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(299188,8311,'ms','Ralat Menyimpan Field',0),(299189,8311,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ®Ø²ÙŠÙ† Ø§Ù„Ø­Ù‚Ù„',0),(299190,8311,'fr','Erreur d\'enregistrement de domaine',0),(299191,8311,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã®ä¿å­˜ã‚¨ãƒ©ãƒ¼',0),(299192,8311,'pt','Erro ao salvar o campo',0),(299193,8311,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ ÐŸÐ¾Ð»Ñ',0),(299194,8311,'es','Error Guardando Campo',0),(299195,8311,'de','Fehler beim Speichern des Feldes',0),(299196,8311,'en','Error Saving Field',0),(299197,8312,'is','',0),(299198,8312,'dr','ØªÙ†Ø¸ÙŠÙ… Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨ÙŠÙ† Ø´Ø±ÙƒØªÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(299199,8312,'pr','ØªÙ†Ø¸ÙŠÙ… Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨ÙŠÙ† Ø´Ø±ÙƒØªÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(299200,8312,'tr','Stok ÅŸirketlerarasÄ± transferi kurulumu',0),(299201,8312,'pl','Ustawienie przeniesienia zapasÃ³w miÄ™dzyfirmowych',0),(299202,8312,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð¼ÐµÐ¶Ð´ÑƒÑ„Ð¸Ñ€Ð¼ÐµÐ½Ð¸ Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(299203,8312,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ù†Ù¹Ø±Ú©ÙˆÙ…Ù¾Ù†ÛŒ Ù¹Ø±Ø§Ù†Ø³ÙØ± Ø³ÛŒÙ¹ Ø§Ù¾',0),(299204,8312,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¼ÐµÑ’ÑƒÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜ÑÐºÐ¸Ñ… Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€',0),(299205,8312,'vi','Setup Chuyá»ƒn Giao hÃ ng hÃ³a trong ná»™i bá»™ Cty',0),(299206,8312,'af','Voorraad Tussen-ondernemings Oorplasing Opstelling',0),(299207,8312,'ro','Setup de Transfer inventar inter-companii',0),(299208,8312,'et','Varude kontsernisisese Ã¼lekande seadistamine',0),(299209,8312,'si','Popis znotraj podjetja prenos nastavitev',0),(299210,8312,'ba','Persediaan Intercompany Transfer Setup',0),(299211,8312,'nl','Inventaris IC-Transfer Setup',0),(299212,8312,'fi','Varaston konsernin siirtÃ¤Ã¤ mÃ¤Ã¤ritykset',0),(299213,8312,'no','Lager konserninterne overfÃ¸ring oppsett',0),(299214,8312,'da','Lageret Intercompany Transfer Setup',0),(299215,8312,'ko','íšŒì‚¬ ê°„ ìž¬ê³  ì´ì „ ì„¤ì¹˜',0),(299216,8312,'he','×”×’×“×¨×ª ×”×¢×‘×¨×ª ×ž×œ××™ ×‘×™×Ÿ-×—×‘×¨×ª×™',0),(299217,8312,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î´Î¹ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ­Ï‚ Î¼ÎµÏ„Î±Ï†Î­ÏÎµÎ¹ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚',0),(299218,8312,'zh','åº“å­˜å…¬å¸é—´è½¬ç§»å®‰è£…\r\n',0),(299219,8312,'sv','Inventering koncernintern Ã¶verlÃ¥telse Setup',0),(299220,8312,'it','Inventario Intercompany Transfer Setup',0),(299221,8312,'tl','',0),(299222,8312,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3650;&#3629;&#3609;&#3618;&#3657;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3616;&#3634;&#3618;&#3651;&#3609;&#3610;&#3',0),(299223,8312,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ Intercompany à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(299224,8312,'ms','Persediaan pemindahan Intercompany inventori',0),(299225,8312,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ù†Ù‚Ù„ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¨ÙŠÙ† Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø´Ù‚ÙŠÙ‚Ø©',0),(299226,8312,'fr','L\'inventaire intersociÃ©tÃ©s transfert Setup',0),(299227,8312,'jp','ä¼šç¤¾é–“åœ¨åº«è»¢é€ã®è¨­å®š',0),(299228,8312,'pt','InstalaÃ§Ã£o de transferÃªncia de inventÃ¡rio Intercompany',0),(299229,8312,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð²Ð½ÑƒÑ‚Ñ€Ð¸Ñ…Ð¾Ð»Ð´Ð¸Ð½Ð³Ð¾Ð²Ñ‹Ñ… Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(299230,8312,'es','ConfiguraciÃ³n de Transferencia Interempresa de Inventario',0),(299231,8312,'de','Inventar Intercompany Transfer Setup',0),(299232,8312,'en','Inventory Intercompany Transfer Setup',0),(299233,8313,'is','',0),(299234,8313,'dr','Ø´Ø±ÙƒØª Ø¯ÙŠÚ¯Ø± ',0),(299235,8313,'pr','Ø´Ø±ÙƒØª Ø¯ÙŠÚ¯Ø± ',0),(299236,8313,'tr','DiÄŸer ÅŸirket',0),(299237,8313,'pl','Inne firmy',0),(299238,8313,'bg','Ð”Ñ€ÑƒÐ³Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(299239,8313,'ur','Ø¯ÙˆØ³Ø±ÛŒ Ú©Ù…Ù¾Ù†ÛŒ',0),(299240,8313,'sr','Ð”Ñ€ÑƒÐ³Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(299241,8313,'vi','Cty khÃ¡c',0),(299242,8313,'af','Ander Onderneming',0),(299243,8313,'ro','AltÄƒ companie',0),(299244,8313,'et','Teine ettevÃµte',0),(299245,8313,'si','Druga druÅ¾ba',0),(299246,8313,'ba','Perusahaan lain',0),(299247,8313,'nl','Ander bedrijf',0),(299248,8313,'fi','Toinen yritys',0),(299249,8313,'no','Annet selskap',0),(299250,8313,'da','Andet selskab',0),(299251,8313,'ko','ë‹¤ë¥¸ íšŒì‚¬',0),(299252,8313,'he','×—×‘×¨×” ××—×¨×ª',0),(299253,8313,'el','Î†Î»Î»Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(299254,8313,'zh','å…¶ä»–å…¬å¸\r\n',0),(299255,8313,'sv','Andra fÃ¶retag',0),(299256,8313,'it','Altre societÃ ',0),(299257,8313,'tl','',0),(299258,8313,'th','&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3629;&#3639;&#3656;&#3609;',0),(299259,8313,'hi','à¤…à¤¨à¥à¤¯ à¤•à¤‚à¤ªà¤¨à¥€',0),(299260,8313,'ms','Syarikat lain',0),(299261,8313,'ar','Ø´Ø±ÙƒØ© Ø£Ø®Ø±Ù‰',0),(299262,8313,'fr','Autre sociÃ©tÃ©',0),(299263,8313,'jp','ä»–ã®ä¼šç¤¾',0),(299264,8313,'pt','Outra empresa',0),(299265,8313,'ru','Ð”Ñ€ÑƒÐ³Ð°Ñ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(299266,8313,'es','Otra Empresa',0),(299267,8313,'de','Andere Unternehmen',0),(299268,8313,'en','Other Company',0),(299269,8314,'is','',0),(299270,8314,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø®Ø±ÙŠØ¯Ø§Ø± ÙˆÙ‚ØªÙŠ ÙƒÙ‡ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ Ùˆ Ø³Ù¾Ø³ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ Ù…ØªÙ†Ø§Ø³Ø¨ Ø¯Ø± Ø´Ø±ÙƒØª Ø¯ÙŠÚ¯Ø±ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(299271,8314,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø®Ø±ÙŠØ¯Ø§Ø± ÙˆÙ‚ØªÙŠ ÙƒÙ‡ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ Ùˆ Ø³Ù¾Ø³ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ Ù…ØªÙ†Ø§Ø³Ø¨ Ø¯Ø± Ø´Ø±ÙƒØª Ø¯ÙŠÚ¯Ø±ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(299272,8314,'tr','Bu ÅŸirkette bir PO oluÅŸturma ve daha sonra diÄŸer ÅŸirkette eÅŸleÅŸen bir karÅŸÄ±lama sipariÅŸi oluÅŸturmadan mÃ¼ÅŸteri kullanma',0),(299273,8314,'pl','Za pomocÄ… klienta tworzÄ…c PO w tej firmie, a nastÄ™pnie tworzÄ…c pasujÄ…ce realizacji zamÃ³wienia w innej firmy',0),(299274,8314,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° PO Ð² Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð° Ð¸ ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð¾Ð²ÐµÐ´ Ð² Ð´Ñ€ÑƒÐ³Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(299275,8314,'ur','Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ù…ÛŒÚº Ø§ÛŒÚ© Ù¾ÙˆØ³Ù¹ Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’ Ø§ÙˆØ± Ù¾Ú¾Ø± Ø¯ÙˆØ³Ø±ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ù…ÛŒÚº Ø§ÛŒÚ© Ù…Ø´Ø§Ø¨Û Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ ØªØ®Ù„ÛŒÙ‚ Ú©Ø±Ù†Û’ Ú©Û’ Ú©Ø³Ù¹Ù…Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(299276,8314,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÐšÐ£ÐŸÐ¦Ð ÑÑ‚Ð²Ð°Ñ€Ð°ÑšÐµ ÐŸÐžÐ•Ð Ñƒ Ð¾Ð²Ð¾Ñ˜ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð¸, Ð° Ð·Ð°Ñ‚Ð¸Ð¼ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ñƒ Ð´Ñ€ÑƒÐ³Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(299277,8314,'vi','Sá»­ dá»¥ng KHÃCH HÃ€NG táº¡o má»™t Ä‘Æ¡n mua hÃ ng trong cty nÃ y sau Ä‘Ã³ táº¡o ra 1 Ä‘Æ¡n hÃ ng giao táº­n nÆ¡i tÆ°Æ¡ng xá»©ng á»Ÿ cty khÃ¡c',0),(299278,8314,'af','Gebruik Klant / KliÃ«nt deur \'n AB in hierdie onderneming te skep en skep \'n passende uitvoeringsbestelling in \'n ander onderneming',0),(299279,8314,'ro','Utilizarea client crearea unui PO Ã®n aceastÄƒ companie ÅŸi apoi creÃ¢nd o potrivire ordine de Ã®mplinire Ã®n societate',0),(299280,8314,'et','Kasutada kliendi loomine on PO selle firma ja seejÃ¤rel luua sobitamine plaanitud tellimus teises Ã¤riÃ¼hingus',0),(299281,8314,'si','Uporabite kupca PO ustvarjanju v tem podjetju in nato ustvarite ujemanje izpolnitev nalog v drugo podjetje',0),(299282,8314,'ba','Menggunakan pelanggan membuat PO di perusahaan ini dan kemudian menciptakan pencocokan pemenuhan order di perusahaan lain',0),(299283,8314,'nl','Gebruik klant een PO in dit bedrijf maken en vervolgens een overeenkomende volgorde van vervulling te maken in andere bedrijf',0),(299284,8314,'fi','KÃ¤ytÃ¤ asiakkaan luominen PO tÃ¤mÃ¤n yrityksen ja luomalla vastaavia tÃ¤yttÃ¶tilaus yrityksen',0),(299285,8314,'no','Bruker skaper en PO i dette selskapet og deretter opprette en tilsvarende innfrielsesordre i andre firmaet',0),(299286,8314,'da','Brug kunde skabe en PO i dette firma og derefter oprette en matching opfyldningsordren i andet selskab',0),(299287,8314,'ko','ì´ íšŒì‚¬ëŠ” í¬ë¥¼ ìƒì„± í•˜ ê³  ë‹¤ë¥¸ íšŒì‚¬ì— ìžˆëŠ” ì¼ì¹˜ í–‰ ìˆœì„œ ë§Œë“œëŠ” ê³ ê°ì„ ì‚¬ìš© í•˜ ì—¬',0),(299288,8314,'he','×”×©×ª×ž×© ×”×œ×§×•×— ×™×¦×™×¨×” ×©×œ ×”×–×ž× ×ª ×¨×›×© ×‘×—×‘×¨×” ×–×• ×•×œ××—×¨ ×ž×›×Ÿ ×™×¦×™×¨×ª ×¦×• ×ž×™×ž×•×© ×ª×•××ž×•×ª ×‘ ×—×‘×¨×” ××—×¨×ª',0),(299289,8314,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³ÏŽÎ½Ï„Î±Ï‚ PO ÏƒÏ„Î·Î½ ÎµÎ½ Î»ÏŒÎ³Ï‰ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎºÎ±Î¹ ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î±, Î´Î·Î¼Î¹Î¿Ï…ÏÎ³ÏŽÎ½Ï„Î±Ï‚ Î¼Î¹Î± Î±Î½Ï„Î¯ÏƒÏ„Î¿Î¹Ï‡Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· ÏƒÎµ Î¬Î»Î»Î· ',0),(299290,8314,'zh','åœ¨è¿™å®¶å…¬å¸åˆ›å»ºä¸€ä¸ªé‡‡è´­è®¢å•æ—¶ä½¿ç”¨å®¢æˆ·\r\nï¼Œç„¶åŽåœ¨å…¶ä»–å…¬å¸åˆ›å»ºä¸€ä¸ªé…å¥—çš„å±¥è¡Œè®¢å•\r\n',0),(299291,8314,'sv','AnvÃ¤nder kunden att skapa ett PO i detta fÃ¶retag och sedan skapa en matchande uppfyllelseorder i andra fÃ¶retag',0),(299292,8314,'it','Utilizzare il cliente creando un PO in questa societÃ  e quindi la creazione di un ordine di evasione corrispondenza in altre societÃ ',0),(299293,8314,'tl','',0),(299294,8314,'th','Use CUSTOMER creating a PO in this company and then creating a matching fulfillment order in other company',0),(299295,8314,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤®à¥‡à¤‚ à¤à¤• PO à¤¬à¤¨à¤¾à¤¨à¥‡ à¤”à¤° à¤«à¤¿à¤° à¤à¤• à¤®à¤¿à¤²à¤¾à¤¨ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤•à¥à¤°à¤® à¤®à¥‡à¤‚ à¤…à¤¨à¥à¤¯ à¤•à¤‚à¤ªà¤¨à¥€ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(299296,8314,'ms','Menggunakan pelanggan mewujudkan PO satu dalam Syarikat ini dan kemudian membuat perintah memenuhi hampir sama di syarikat lain',0),(299297,8314,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ PO ÙÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ© ÙˆØ«Ù… Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ø§Ø³ØªÙŠÙØ§Ø¡ Ù…Ø·Ø§Ø¨Ù‚Ø© ÙÙŠ Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø£Ø®Ø±Ù‰',0),(299298,8314,'fr','Utiliser le client crÃ©ant un PO dans cette entreprise, puis en crÃ©ant un ordre de traitement correspondant dans une autre sociÃ©tÃ©',0),(299299,8314,'jp','ã“ã®ä¼šç¤¾ã§ã€PO ã‚’ä½œæˆã—ã€ã—ä»–ã®ä¼šç¤¾ã§å¯¾å¿œã™ã‚‹è¨ˆç”»ã‚ªãƒ¼ãƒ€ãƒ¼ã‚’ä½œæˆã™ã‚‹é¡§å®¢ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(299300,8314,'pt','Use o cliente criando um PO nesta empresa e em seguida, criar uma ordem de cumprimento correspondente em outra empresa',0),(299301,8314,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°, ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¡ÐŸ Ð² ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸ Ð·Ð°Ñ‚ÐµÐ¼ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð² Ð´Ñ€ÑƒÐ³Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(299302,8314,'es','Usar CLIENTE cuando crear un OC en esta empresa y entonces crear un Orden de Cumplimiento pareado en otra empresa',0),(299303,8314,'de','Verwenden Sie Kunden erstellen eine PO in diesem Unternehmen und erstellen dann eine passende AusfÃ¼hrungsauftrag in anderen Unternehmen',0),(299304,8314,'en','Use CUSTOMER creating a PO in this company and then creating a matching fulfillment order in other company',0),(299305,8315,'is','',0),(299306,8315,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙˆÙ‚ØªÙŠ ÙƒÙ‡ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠÙƒÙ†ÙŠØ¯ Ùˆ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø¯Ø± Ø´Ø±ÙƒØª Ø¯ÙŠÚ¯Ø±ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(299307,8315,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙˆÙ‚ØªÙŠ ÙƒÙ‡ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠÙƒÙ†ÙŠØ¯ Ùˆ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø¯Ø± Ø´Ø±ÙƒØª Ø¯ÙŠÚ¯Ø±ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(299308,8315,'tr','SatÄ±cÄ± firmanÄ±n ve eÅŸleÅŸen bir PO diÄŸer ÅŸirkette oluÅŸturmak bir sipariÅŸ oluÅŸtururken kullanÄ±n.',0),(299309,8315,'pl','Podczas tworzenia zamÃ³wienia w tej firmy i tworzenie pasujÄ…ce PO w innej firmy, naleÅ¼y uÅ¼yÄ‡ dostawcy.',0),(299310,8315,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð² Ñ‚Ð°Ð·Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸Ñ‚Ðµ PO Ð² Ð´Ñ€ÑƒÐ³Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ.',0),(299311,8315,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ø§ÙˆØ± Ø¯ÛŒÚ¯Ø± Ú©Ù…Ù¾Ù†ÛŒ Ù…ÛŒÚº Ø§ÛŒÚ© Ù…Ø´Ø§Ø¨Û Ù¾Ùˆ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚ Ù…ÛŒÚº Ø§ÛŒÚ© Ø­Ú©Ù… Ú©Ùˆ Ø¨Ù†Ø§ØªÛ’ ÙˆÙ‚Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Û”',0),(299312,8315,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐ° ÐÐÐ Ð•Ð‚Ð•ÐŠÐ• Ñƒ Ð¾Ð²Ð¾Ñ˜ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð¸ Ð¸ ÑÑ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð½Ð¸ ÐŸÐžÐ•Ð Ñƒ Ð´Ñ€ÑƒÐ³Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ.',0),(299313,8315,'vi','Sá»­ dá»¥ng NgÆ°á»i BÃ¡n khi táº¡o ra má»™t ÄÆ¡n HÃ ng trong cty nÃ y & táº¡o ra 1 Ä‘Æ¡n mua hÃ ng tÆ°Æ¡ng á»©ng á»Ÿ cty khÃ¡c',0),(299314,8315,'af','Gebruik VERSKAFFER wanneer \'n BESTELLING in hierdie onderneming geskep word en skep \'n gepasde AB in ander onderneming.',0),(299315,8315,'ro','UtilizaÅ£i furnizor atunci cÃ¢nd se creeazÄƒ o comandÄƒ Ã®n aceastÄƒ companie ÅŸi crearea PO o potrivire Ã®n cealaltÄƒ societate.',0),(299316,8315,'et','Kasuta hankija tellimuse loomisel selle firma ja luua sobitamine PO teises Ã¤riÃ¼hingus.',0),(299317,8315,'si','Ustvarjate dobavitelja nalog v tem podjetju in ustvarjanje ujemanje PO v drugo podjetje.',0),(299318,8315,'ba','Menggunakan VENDOR ketika membuat perintah dalam perusahaan ini dan menciptakan pencocokan PO di perusahaan lain.',0),(299319,8315,'nl','LEVERANCIER gebruiken bij het maken van een ORDER in dit bedrijf en het creÃ«ren van een overeenkomende PO in andere bedrijf.',0),(299320,8315,'fi','KÃ¤ytÃ¤ TOIMITTAJAA, kun luot tilauksen yritys ja luoda vastaava PO toisen yrityksen.',0),(299321,8315,'no','Bruk leverandÃ¸r nÃ¥r du oppretter en ordre i dette selskapet og skape en samsvarende PO i andre firmaet.',0),(299322,8315,'da','Bruge KREDITOR, nÃ¥r du opretter en ordre i dette selskab og opretter en tilsvarende PO i andet selskab.',0),(299323,8315,'ko','ê³µê¸‰ ì—…ì²´ë¥¼ ì‚¬ìš© í•˜ ì—¬ì´ íšŒì‚¬ì™€ ë‹¤ë¥¸ íšŒì‚¬ì— ì¼ì¹˜ í•˜ëŠ” í¬ë¥¼ ë§Œë“œëŠ” ìˆœì„œë¥¼ ë§Œë“¤ ë•Œ.',0),(299324,8315,'he','×”×©×ª×ž×© ×”×¡×¤×§ ×‘×¢×ª ×™×¦×™×¨×ª ×¤×§×•×“×” ×‘×ª×•×š ×”×—×‘×¨×” ×•×™×¦×™×¨×ª ×¤×• ×ª×•××ž×•×ª ×©×œ ×—×‘×¨×” ××—×¨×ª.',0),(299325,8315,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Î Î¡ÎŸÎœÎ—Î˜Î•Î¥Î¤Î‰ ÎºÎ±Ï„Î¬ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î¼Î¹Î±Ï‚ Î Î‘Î¡Î‘Î“Î“Î•Î›ÎŠÎ‘Î£ ÏƒÏ„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î® ÎºÎ±Î¹ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± PO Ï€Î¿Ï… Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ ÏƒÎµ Î¬Î»Î»Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±.',0),(299326,8315,'zh','åœ¨è¿™å®¶å…¬å¸åˆ›å»ºä¸€ä¸ªè®¢å•æ—¶ä½¿ç”¨ä¾›åº”å•†ï¼Œå¹¶åœ¨å…¶ä»–å…¬å¸åˆ›é€ ä¸€ä¸ªåŒ¹é…çš„è®¢å•ã€‚\r\n',0),(299327,8315,'sv','AnvÃ¤nd leverantÃ¶r nÃ¤r du skapar en ORDER i detta fÃ¶retag och skapa en matchande PO i andra fÃ¶retag.',0),(299328,8315,'it','Utilizzare il fornitore quando si crea un ordine in questa societÃ  e la creazione di un ordine di acquisto corrispondente in altre societÃ .',0),(299329,8315,'tl','',0),(299330,8315,'th','Use VENDOR when creating an ORDER in this company and creating a matching PO in other company.',0),(299331,8315,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤…à¤¨à¥à¤¯ à¤•à¤‚à¤ªà¤¨à¥€ à¤®à¥‡à¤‚ à¤à¤• à¤®à¥‡à¤² à¤–à¤¾à¤¤à¤¾ à¤ªà¥‹ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤”à¤° à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤®à¥‡à¤‚ à¤à¤• à¤•à¥à¤°à¤® à¤¬à¤¨à¤¾à¤¤à¥‡ à¤¸à¤®à¤¯ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚à¥¤',0),(299332,8315,'ms','Gunakan penjual apabila membuat suatu perintah di Syarikat ini dan mewujudkan PO yang hampir sama di syarikat lain.',0),(299333,8315,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…ÙˆØ±Ø¯ Ø¹Ù†Ø¯ Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± ÙÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ© ÙˆØ®Ù„Ù‚ PO Ù…Ø·Ø§Ø¨Ù‚Ø© ÙÙŠ Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø£Ø®Ø±Ù‰.',0),(299334,8315,'fr','Utilisez du vendeur lors de la crÃ©ation dâ€™un ordre dans cette entreprise et la crÃ©ation dâ€™un bon de commande correspondant dans lâ€™autre sociÃ©tÃ©.',0),(299335,8315,'jp','ã“ã®ä¼šç¤¾ã€ä»–ã®ä¼šç¤¾ã«ä¸€è‡´ã™ã‚‹ PO ã‚’ä½œæˆã™ã‚‹æ³¨æ–‡ã‚’ä½œæˆã™ã‚‹ã¨ãã¯ã€ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(299336,8315,'pt','Use o fornecedor ao criar uma ordem na empresa e criando um PO correspondente em outra empresa.',0),(299337,8315,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ Ð·Ð°ÐºÐ°Ð·Ð° Ð² ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… PO Ð² Ð´Ñ€ÑƒÐ³Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸.',0),(299338,8315,'es','Usar PROVEEDOR cuando crear un ORDEN en esta empresa y crear un OC emparejado en otra empresa',0),(299339,8315,'de','Verwenden Sie Hersteller, beim Erstellen eines Auftrags in dieses Unternehmen und erstellen eine passenden PO in anderen Unternehmen.',0),(299340,8315,'en','Use VENDOR when creating an ORDER in this company and creating a matching PO in other company.',0),(299341,8316,'is','',0),(299342,8316,'dr','ØªØ§Ø±ÙŠØ® Ù„ØºÙˆ',0),(299343,8316,'pr','ØªØ§Ø±ÙŠØ® Ù„ØºÙˆ',0),(299344,8316,'tr','Ä°ptal tarihi',0),(299345,8316,'pl','Data anulowania',0),(299346,8316,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÑÐ²Ð°Ð½Ðµ',0),(299347,8316,'ur','ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº',0),(299348,8316,'sr','ÐžÑ‚ÐºÐ°Ð¶Ð¸ ÑÐ°ÑÑ‚Ð°Ð½Ð°Ðº',0),(299349,8316,'vi','NgÃ y xÃ³a',0),(299350,8316,'af','Kanselleer Datum',0),(299351,8316,'ro','Anula data',0),(299352,8316,'et','TÃ¼hista kuupÃ¤ev',0),(299353,8316,'si','Datum preklica',0),(299354,8316,'ba','Membatalkan tanggal',0),(299355,8316,'nl','Datum annuleren',0),(299356,8316,'fi','Peruuta pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(299357,8316,'no','Avbryte dato',0),(299358,8316,'da','Annuller dato',0),(299359,8316,'ko','ì·¨ì†Œ ë‚ ì§œ',0),(299360,8316,'he','×ª××¨×™×š ×‘×™×˜×•×œ',0),(299361,8316,'el','Î‘ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(299362,8316,'zh','å–æ¶ˆæ—¥æœŸ\r\n',0),(299363,8316,'sv','Avbryt datum',0),(299364,8316,'it','Annullare la data',0),(299365,8316,'tl','',0),(299366,8316,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(299367,8316,'hi','\' à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚ \' à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(299368,8316,'ms','Tarikh Batal',0),(299369,8316,'ar','ØªØ§Ø±ÙŠØ® Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø£Ù…Ø±',0),(299370,8316,'fr','Annuler la Date',0),(299371,8316,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«æ—¥',0),(299372,8316,'pt','Cancelar a data',0),(299373,8316,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð”Ð°Ñ‚Ñƒ',0),(299374,8316,'es','Cancelar Fecha',0),(299375,8316,'de','\"Abbrechen\" Datum',0),(299376,8316,'en','Cancel Date',0),(299377,8317,'is','',0),(299378,8317,'dr','ÙÙ‚Ø· ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ ',0),(299379,8317,'pr','ÙÙ‚Ø· ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ ',0),(299380,8317,'tr','YalnÄ±zca engellenen faturalar',0),(299381,8317,'pl','UniewaÅ¼nione faktur tylko',0),(299382,8317,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ð¸Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ ÑÐ°Ð¼Ð¾',0),(299383,8317,'ur','ÙˆÙˆØ§ÚˆÛŒØ¯ ÙˆØ¨Ø¬Ù„ÛŒ ØµØ±Ù',0),(299384,8317,'sr','Ð¡Ð°Ð¼Ð¾ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(299385,8317,'vi','Chá»‰ hÃ³a Ä‘Æ¡n Ä‘Ã£ há»§y',0),(299386,8317,'af','Fakture ontlaste slegs',0),(299387,8317,'ro','Anulat facturile doar',0),(299388,8317,'et','Annulleeritud arved ainult',0),(299389,8317,'si','Razveljavljeni raÄunov le',0),(299390,8317,'ba','Voided faktur hanya',0),(299391,8317,'nl','Vernietigde facturen alleen',0),(299392,8317,'fi','MitÃ¤tÃ¶ity laskujen summat',0),(299393,8317,'no','Annullerte fakturaer',0),(299394,8317,'da','Nedlagte fakturaer kun',0),(299395,8317,'ko','ë¬´íš¨í™” ì²­êµ¬ì„œë§Œ',0),(299396,8317,'he','×¨×§ ×—×©×‘×•× ×™×•×ª ×©×ª×•×§×¤×Ÿ ×‘×•×˜×œ',0),(299397,8317,'el','Î‘ÎºÏ…ÏÏ‰Î¼Î­Î½Î·Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î¼ÏŒÎ½Î¿',0),(299398,8317,'zh','ä½œåºŸå‘ç¥¨åªæœ‰\r\n',0),(299399,8317,'sv','Annullerade fakturor endast',0),(299400,8317,'it','Fatture annullate solo',0),(299401,8317,'tl','',0),(299402,8317,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(299403,8317,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤¿à¤°à¥à¤« voided',0),(299404,8317,'ms','Invois voided sahaja',0),(299405,8317,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ù„ØºØ§Ø© ÙÙ‚Ø·',0),(299406,8317,'fr','Factures annulÃ©s uniquement',0),(299407,8317,'jp','ç„¡åŠ¹ã«ã•ã‚ŒãŸè«‹æ±‚æ›¸ã®ã¿',0),(299408,8317,'pt','Facturas anuladas apenas',0),(299409,8317,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð¡Ñ‡ÐµÑ‚Ð°',0),(299410,8317,'es','Solo Facturas Anuladas',0),(299411,8317,'de','Stornierte Rechnungen nur',0),(299412,8317,'en','Voided Invoices Only',0),(299413,8318,'is','',0),(299414,8318,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡  ',0),(299415,8318,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡  ',0),(299416,8318,'tr','Engellenen sipariÅŸler',0),(299417,8318,'pl','UniewaÅ¼nione zamÃ³wienia',0),(299418,8318,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ð¸Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(299419,8318,'ur','ÙˆÙˆØ§ÚˆÛŒØ¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(299420,8318,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½Ð¸ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(299421,8318,'vi','Há»§y Ä‘Æ¡n hÃ ng ',0),(299422,8318,'af','Geskrapte Bestellings',0),(299423,8318,'ro','Comenzi de anulat',0),(299424,8318,'et','TÃ¼histatud tellimused',0),(299425,8318,'si','Razveljavljeni naroÄila',0),(299426,8318,'ba','Pesanan voided',0),(299427,8318,'nl','Vernietigde Orders',0),(299428,8318,'fi','MitÃ¤tÃ¶ityjÃ¤ tilauksia',0),(299429,8318,'no','Annullerte ordrer',0),(299430,8318,'da','Nedlagte ordrer',0),(299431,8318,'ko','ë¬´íš¨í™” ì£¼ë¬¸',0),(299432,8318,'he','×”×–×ž× ×•×ª ×©×ª×•×§×¤×Ÿ ×‘×•×˜×œ',0),(299433,8318,'el','Î‘ÎºÏ…ÏÏ‰Î¼Î­Î½Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(299434,8318,'zh','ä½œåºŸè®¢å•\r\n',0),(299435,8318,'sv','Annullerade order',0),(299436,8318,'it','Ordini escreta',0),(299437,8318,'tl','',0),(299438,8318,'th','&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(299439,8318,'hi','Voided à¤†à¤¦à¥‡à¤¶',0),(299440,8318,'ms','Pesanan voided',0),(299441,8318,'ar','Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ù„ØºØ§Ø©',0),(299442,8318,'fr','Commandes canceles',0),(299443,8318,'jp','ç„¡åŠ¹ã«ã•ã‚ŒãŸæ³¨æ–‡',0),(299444,8318,'pt','Ordens anuladas',0),(299445,8318,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(299446,8318,'es','Ordenes Anulados',0),(299447,8318,'de','Stornierte Bestellungen',0),(299448,8318,'en','Voided Orders',0),(299449,8319,'is','',0),(299450,8319,'dr','ÙÙ‚Ø· Ú†Ø§Ù¾ Ù‡Ø§ ÙƒÙ…ØªØ± Ø§Ø² ',0),(299451,8319,'pr','ÙÙ‚Ø· Ú†Ø§Ù¾ Ù‡Ø§ ÙƒÙ…ØªØ± Ø§Ø² ',0),(299452,8319,'tr','GÃ¶sterimler yalnÄ±zca daha az',0),(299453,8319,'pl','Tylko wraÅ¼enia mniej niÅ¼',0),(299454,8319,'bg','Ð¡Ð°Ð¼Ð¾ Ð²Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸Ñ Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¾Ñ‚',0),(299455,8319,'ur','ØµØ±Ù Ù†Ù‚ÙˆØ´ Ø³Û’ Ú©Ù…',0),(299456,8319,'sr','Ð¡Ð°Ð¼Ð¾ ÑƒÑ‚Ð¸ÑÐºÐµ Ð¼Ð°ÑšÐµ Ð¾Ð´',0),(299457,8319,'vi','Chá»‰ áº¥n tÆ°á»£ng Ã­t hÆ¡n',0),(299458,8319,'af','Slegs indrukke minder',0),(299459,8319,'ro','Numai impresii mai putin',0),(299460,8319,'et','Vaid muljeid alla',0),(299461,8319,'si','Samo vtise manj kot',0),(299462,8319,'ba','Tayangan hanya kurang dari',0),(299463,8319,'nl','Alleen indrukken minder dan',0),(299464,8319,'fi','Vain vaikutelmia alle',0),(299465,8319,'no','Bare visninger under',0),(299466,8319,'da','Kun visninger mindre end',0),(299467,8319,'ko','ë…¸ì¶œë§Œ ë¯¸ë§Œ',0),(299468,8319,'he','×¨×§ ×¨×©×ž×™× ×¤×—×•×ª',0),(299469,8319,'el','ÎœÏŒÎ½Î¿ ÎµÎ½Ï„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚ Î»Î¹Î³ÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ',0),(299470,8319,'zh','åªæœ‰å°è±¡å°äºŽ\r\n',0),(299471,8319,'sv','Endast intryck mindre Ã¤n',0),(299472,8319,'it','Solo impressioni meno di',0),(299473,8319,'tl','',0),(299474,8319,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3591;&#3634;&#3609;&#3614;&#3636;&#3617;&#3614;&#3660;&#3607;&#3637;&#3656;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(299475,8319,'hi','à¤•à¥‡à¤µà¤² à¤›à¤¾à¤ªà¥‹à¤‚ à¤¸à¥‡ à¤•à¤®',0),(299476,8319,'ms','Hanya tanggapan kurang daripada',0),(299477,8319,'ar','Ø§Ù†Ø·Ø¨Ø§Ø¹Ø§Øª ÙÙ‚Ø· Ø£Ù‚Ù„ Ù…Ù†',0),(299478,8319,'fr','Seulement des Impressions moins de',0),(299479,8319,'jp','ã®ã¿è¡¨ç¤ºå›žæ•°æœªæº€',0),(299480,8319,'pt','Apenas as impressÃµes menos de',0),(299481,8319,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð²Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸Ñ Ð¼ÐµÐ½ÐµÐµ',0),(299482,8319,'es','Solo Impresiones Menos Que',0),(299483,8319,'de','Nur EindrÃ¼cke weniger als',0),(299484,8319,'en','Only Impressions Less Than',0),(299485,8320,'is','',0),(299486,8320,'dr','ÙƒØ§Ù„Ø§ Ø¯Ø± Ø´Ø±ÙƒØª',0),(299487,8320,'pr','ÙƒØ§Ù„Ø§ Ø¯Ø± Ø´Ø±ÙƒØª',0),(299488,8320,'tr','Maddesinde ÅŸirket',0),(299489,8320,'pl','Pozycja w firmie',0),(299490,8320,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð² ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(299491,8320,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ù…ÛŒÚº Ø´Û’',0),(299492,8320,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ñƒ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ñƒ',0),(299493,8320,'vi','HÃ ng trong cty',0),(299494,8320,'af','Item in Onderneming',0),(299495,8320,'ro','Articol din societate',0),(299496,8320,'et','Ãœksuse firma',0),(299497,8320,'si','Element v podjetju',0),(299498,8320,'ba','Item dalam perusahaan',0),(299499,8320,'nl','Item in bedrijf',0),(299500,8320,'fi','Nimikkeen yritys',0),(299501,8320,'no','Element i selskapet',0),(299502,8320,'da','Element i virksomheden',0),(299503,8320,'ko','íšŒì‚¬ì—ì„œ í•­ëª©',0),(299504,8320,'he','×¤×¨×™×˜ ×‘×—×‘×¨×”',0),(299505,8320,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÏ„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(299506,8320,'zh','åœ¨å…¬å¸é¡¹ç›®\r\n',0),(299507,8320,'sv','Objekt i fÃ¶retaget',0),(299508,8320,'it','Elemento in azienda',0),(299509,8320,'tl','',0),(299510,8320,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3588;&#3657;&#3634;&#3651;&#3609;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(299511,8320,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤®à¥‡à¤‚ à¤†à¤‡à¤Ÿà¤®',0),(299512,8320,'ms','Item dalam Syarikat',0),(299513,8320,'ar','Ø§Ù„Ø¨Ù†Ø¯ ÙÙŠ Ø§Ù„Ø´Ø±ÙƒØ©',0),(299514,8320,'fr','Article dans entreprise',0),(299515,8320,'jp','ä¼šç¤¾å†…ã®ã‚¢ã‚¤ãƒ†ãƒ ',0),(299516,8320,'pt','Item na empresa',0),(299517,8320,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð² ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(299518,8320,'es','Item en Empresa',0),(299519,8320,'de','Element im Unternehmen',0),(299520,8320,'en','Item in Company',0),(299521,8321,'is','',0),(299522,8321,'dr','ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ ',0),(299523,8321,'pr','ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ ',0),(299524,8321,'tr','Madde transferi',0),(299525,8321,'pl','Element na przeniesienie',0),(299526,8321,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ',0),(299527,8321,'ur','Ø´Û’ Ù…Ù†ØªÙ‚Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(299528,8321,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(299529,8321,'vi','HÃ ng Ä‘á»ƒ chuyá»ƒn',0),(299530,8321,'af','Item wat Oorgeplaas moet word',0),(299531,8321,'ro','Element de Transfer',0),(299532,8321,'et','Kauba Ã¼leandmine',0),(299533,8321,'si','Element za prenos',0),(299534,8321,'ba','Item untuk Transfer',0),(299535,8321,'nl','Object over te dragen',0),(299536,8321,'fi','Kohteen siirtÃ¤minen',0),(299537,8321,'no','Elementet til overfÃ¸ring',0),(299538,8321,'da','Varen til overfÃ¸rsel',0),(299539,8321,'ko','ì´ì „ í•­ëª©',0),(299540,8321,'he','×¤×¨×™×˜ ×œ×”×¢×‘×™×¨',0),(299541,8321,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÏ„Î·Î½ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬',0),(299542,8321,'zh','é¡¹ç›®è½¬è®©\r\n',0),(299543,8321,'sv','Objektet till Ã¶verfÃ¶ra',0),(299544,8321,'it','Elemento di trasferimento',0),(299545,8321,'tl','',0),(299546,8321,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3650;&#3629;&#3609;',0),(299547,8321,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤‡à¤Ÿà¤®',0),(299548,8321,'ms','Item untuk pemindahan',0),(299549,8321,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ù„Ù†Ù‚Ù„',0),(299550,8321,'fr','Point de transfert',0),(299551,8321,'jp','è»¢é€ã™ã‚‹é …ç›®',0),(299552,8321,'pt','Item para transferÃªncia',0),(299553,8321,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð´Ð»Ñ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(299554,8321,'es','Item para Transferir',0),(299555,8321,'de','Element zur Ãœbertragung',0),(299556,8321,'en','Item to Transfer',0),(299557,8322,'is','',0),(299558,8322,'dr','(Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ) Ø§Ø² ',0),(299559,8322,'pr','Ø­Ø±ÙƒØª(Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ) Ø§Ø² ',0),(299560,8322,'tr','Hareketli',0),(299561,8322,'pl','PrzejÅ›cie od',0),(299562,8322,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð²Ð°Ð½Ðµ Ð¾Ñ‚',0),(299563,8322,'ur','Ø³Û’ Ù…Ù†ØªÙ‚Ù„',0),(299564,8322,'sr','Ð¡ÐµÐ»Ðµ Ð¸Ð·',0),(299565,8322,'vi','Chuyá»ƒn tá»«',0),(299566,8322,'af','Beweeg vanaf',0),(299567,8322,'ro','Trecerea de la',0),(299568,8322,'et','Liikudes',0),(299569,8322,'si','Gibljejo od',0),(299570,8322,'ba','Bergerak dari',0),(299571,8322,'nl','Verplaatsen van',0),(299572,8322,'fi','Siirtyminen',0),(299573,8322,'no','Flytte fra',0),(299574,8322,'da','BevÃ¦ger sig fra',0),(299575,8322,'ko','ì´ë™',0),(299576,8322,'he','×”×¢×‘×¨×ª ×ž',0),(299577,8322,'el','Î— Î¼ÎµÏ„Î¬Î²Î±ÏƒÎ· Î±Ï€ÏŒ',0),(299578,8322,'zh','ä»Žç§»åŠ¨\r\n',0),(299579,8322,'sv','Flytta frÃ¥n',0),(299580,8322,'it','Muovendo da',0),(299581,8322,'tl','',0),(299582,8322,'th','&#3618;&#3657;&#3634;&#3618;&#3617;&#3634;&#3592;&#3634;&#3585;',0),(299583,8322,'hi','à¤¸à¥‡ à¤šà¤²à¤¤à¥€',0),(299584,8322,'ms','Bergerak dari',0),(299585,8322,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ù…Ù†',0),(299586,8322,'fr','Passant de',0),(299587,8322,'jp','ç§»å‹•',0),(299588,8322,'pt','Mover-se de',0),(299589,8322,'ru','ÐŸÐµÑ€ÐµÑ…Ð¾Ð´ Ð¾Ñ‚',0),(299590,8322,'es','Mover DE',0),(299591,8322,'de','Verschieben von',0),(299592,8322,'en','Moving FROM',0),(299593,8323,'is','',0),(299594,8323,'dr',': Ø§ÙŠÙ† ÙØ±Ø¢ÙŠÙ†Ø¯ ÙŠÙƒ Ø¨ÛŒØ¬Ú© Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†Ø¯ Ø¯Ø±  Ø§Ø² Ø´Ø±ÙƒØª Ùˆ ÙŠÙƒ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯Ø±  Ø¨Ù‡ Ø´Ø±ÙƒØª ',0),(299595,8323,'pr','ØªÙˆØ¬Ù‡ : Ø§ÙŠÙ† ÙØ±Ø¢ÙŠÙ†Ø¯ ÙŠÙƒ ÙØ§ÙƒØªÙˆØ± Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†Ø¯ Ø¯Ø±  Ø§Ø² Ø´Ø±ÙƒØª Ùˆ ÙŠÙƒ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯Ø±  Ø¨Ù‡ Ø´Ø±ÙƒØª ',0),(299596,8323,'tr','Not: Bu iÅŸlem bir fatura ÅŸirket ve borÃ§ iÃ§inde ÅŸirkete oluÅŸturur',0),(299597,8323,'pl','Uwaga: Ten proces tworzy fakturÄ™ w z firmy i pÅ‚atne w firmie',0),(299598,8323,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ°: Ð¢Ð¾Ð·Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑ ÑÑŠÐ·Ð´Ð°Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð² Ð¾Ñ‚ Ñ„Ð¸Ñ€Ð¼Ð° Ð¸ Ð¿Ð»Ð°Ñ‚Ð¸Ð¼Ð¸ Ð² ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(299599,8323,'ur','Ù†ÙˆÙ¹: Ø§Ø³ Ø¹Ù…Ù„ Ù…ÛŒÚº Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ø§ÙˆØ± Ø§ÛŒÚ© Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…ÛŒÚº Ø³Û’ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ùˆ Ø¨Ù†Ø§ØªØ§ ÛÛ’',0),(299600,8323,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° : ÐžÐ²Ð°Ñ˜ Ð¿Ñ€Ð¾Ñ†ÐµÑ ÐºÑ€ÐµÐ¸Ñ€Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ñƒ Ð¸Ð· ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸ Ð·Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð¸',0),(299601,8323,'vi','CHÃš Ã: QuÃ¡ trÃ¬nh nÃ y táº¡o ra 1 hÃ³a Ä‘Æ¡n trong Tá»ª Cty & má»™t khoáº£n pháº£i tráº£ trong Äáº¾N Cty',0),(299602,8323,'af','LET WEL:  Hierdie proses skep \'n faktuur in VANAF onderneming en \'n betaalbare in NA onderneming',0),(299603,8323,'ro','NotÄƒ: Acest proces creeazÄƒ o facturÄƒ Ã®n companie ÅŸi un de plÄƒtit Ã®n companie',0),(299604,8323,'et','MÃ¤rkus: See protsess loob arve on firma ja makstava lÃµikes ettevÃµttele',0),(299605,8323,'si','Opomba: Ta proces Ustvari raÄun v od podjetja in obveznosti v podjetju',0),(299606,8323,'ba','Catatan: Proses ini menciptakan faktur di dari perusahaan dan dibayarkan di perusahaan',0),(299607,8323,'nl','Opmerking: Dit proces zorgt voor een factuur in van het bedrijf en een betaalbaar in bedrijf',0),(299608,8323,'fi','Huomautus: TÃ¤mÃ¤ prosessi luo laskun yritys ja maksettava yhtiÃ¶lle',0),(299609,8323,'no','Merk: Denne prosessen oppretter en faktura i selskapet og en betales i selskapet',0),(299610,8323,'da','BemÃ¦rk: Denne proces opretter en faktura i fra virksomheden og en, der udbetales i selskab',0),(299611,8323,'ko','ì°¸ê³ :ì´ í”„ë¡œì„¸ìŠ¤ íšŒì‚¬ë¥¼ íšŒì‚¬ì— ì§€ê¸‰ì—ì„œì—ì„œ ì†¡ìž¥ì„ ìƒì„±í•©ë‹ˆë‹¤',0),(299612,8323,'he','×”×¢×¨×”: ×ª×”×œ×™×š ×–×” ×™×•×¦×¨ ×—×©×‘×•× ×™×ª ×‘×ž×Ÿ ×”×—×‘×¨×” ×–×›××™× ×‘ ×œ×—×‘×¨×”',0),(299613,8323,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·: Î‘Ï…Ï„Î® Î· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯ Î­Î½Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÎµ Î±Ï€ÏŒ Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎºÎ±Î¹ Î­Î½Î± Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ Ï€Î»Î·ÏÏ‰Ï„Î­Î¿Ï‚ ÏƒÏ„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(299614,8323,'zh','æ³¨æ„ï¼šæ­¤è¿‡ç¨‹ä¸­åˆ›å»ºä¸€ä¸ªæ”¶ä»¶å…¬å¸å‘ç¥¨å’ŒæŽ¥æ”¶å…¬å¸å‘ç¥¨\r\n',0),(299615,8323,'sv','Obs: Denna process skapar en faktura i frÃ¥n fÃ¶retaget och en betalas till fÃ¶retag',0),(299616,8323,'it','Nota: Questo processo crea una fattura dall\'azienda e un pagabile in azienda',0),(299617,8323,'tl','',0),(299618,8323,'th','NOTE: This process creates an invoice in FROM company and a payable in TO company',0),(299619,8323,'hi','à¤¨à¥‹à¤Ÿ: à¤‡à¤¸ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤®à¥‡à¤‚ à¤à¤• à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¥‡ à¤•à¤‚à¤ªà¤¨à¥€ à¤”à¤° à¤à¤• à¤¦à¥‡à¤¯ à¤®à¥‡à¤‚ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¨à¤¾à¤¤à¤¾ à¤¹à¥ˆ',0),(299620,8323,'ms','Nota: Proses ini mencipta invois dalam dari Syarikat dan perlu dibayar dalam Syarikat',0),(299621,8323,'ar','Ù…Ù„Ø§Ø­Ø¸Ø©: Ù‡Ø°Ù‡ Ø§Ù„Ø¹Ù…Ù„ÙŠØ© ÙŠØ®Ù„Ù‚ ÙØ§ØªÙˆØ±Ø© ÙÙŠ Ø§Ù„Ø´Ø±ÙƒØ©ØŒ ÙˆÙˆØ§Ø¬Ø¨Ø© Ø¯ÙØ¹ ÙÙŠ Ø§Ù„Ø´Ø±ÙƒØ©',0),(299622,8323,'fr','Remarque : Ce processus crÃ©e une facture dans de compagnie et un compte crÃ©diteur en sociÃ©tÃ©',0),(299623,8323,'jp','æ³¨: ã“ã®ãƒ—ãƒ­ã‚»ã‚¹ã§è«‹æ±‚æ›¸ã‹ã‚‰ä½œæˆä¼šç¤¾ã¨ã§æ”¯æ‰•ã†ã¹ãä¼šç¤¾ã«',0),(299624,8323,'pt','Nota: Este processo cria uma fatura da empresa e um pagÃ¡veis na empresa',0),(299625,8323,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ: Ð­Ñ‚Ð¾Ñ‚ Ð¿Ñ€Ð¾Ñ†ÐµÑÑ ÑÐ¾Ð·Ð´Ð°ÐµÑ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð² ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸ Ð¿Ð¾Ð´Ð»ÐµÐ¶Ð°Ñ‰Ð¸Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ðµ Ð² ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(299626,8323,'es','NOTA: Este proceso crea una factura en la empresa DE y un pagable en la empresa A',0),(299627,8323,'de','Hinweis: Dieser Prozess erstellt eine Rechnung in aus Unternehmen und eine Verbindlichkeit in Unternehmen',0),(299628,8323,'en','NOTE: This process creates an invoice in FROM company and a payable in TO company',0),(299629,8324,'is','',0),(299630,8324,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„) Ø¨Ù‡ Ø´Ø±ÙƒØª',0),(299631,8324,'pr','Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„) Ø¨Ù‡ Ø´Ø±ÙƒØª',0),(299632,8324,'tr','Åžirkete transfer',0),(299633,8324,'pl','PrzenieÅ›Ä‡ do firmy',0),(299634,8324,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(299635,8324,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ù…ÛŒÚº Ù…Ù†ØªÙ‚Ù„',0),(299636,8324,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(299637,8324,'vi','Chuyá»ƒn sang TO Cty',0),(299638,8324,'af','Oorgedra NA Onderneming',0),(299639,8324,'ro','Transfer la compania',0),(299640,8324,'et','EttevÃµtte Ã¼leandmine',0),(299641,8324,'si','Prenos podjetja',0),(299642,8324,'ba','Transfer ke perusahaan',0),(299643,8324,'nl','Overbrengen in bedrijf',0),(299644,8324,'fi','YhtiÃ¶lle',0),(299645,8324,'no','OverfÃ¸re til selskapet',0),(299646,8324,'da','OverfÃ¸rsel til virksomheden',0),(299647,8324,'ko','íšŒì‚¬ì— ì „ì†¡',0),(299648,8324,'he','×œ×”×¢×‘×™×¨ ××ª ×”×—×‘×¨×”',0),(299649,8324,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ ÏƒÎµ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(299650,8324,'zh','è½¬ç§»åˆ°å…¬å¸\r\n',0),(299651,8324,'sv','Ã–verfÃ¶ra till fÃ¶retaget',0),(299652,8324,'it','Trasferimento di azienda',0),(299653,8324,'tl','',0),(299654,8324,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3606;&#3638;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(299655,8324,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£',0),(299656,8324,'ms','Memindahkan kepada Syarikat',0),(299657,8324,'ar','Ù†Ù‚Ù„ Ø¥Ù„Ù‰ Ø§Ù„Ø´Ø±ÙƒØ©',0),(299658,8324,'fr','Transfert d\'entreprise',0),(299659,8324,'jp','ä¼šç¤¾ã¸ã®è»¢é€ã—ã¾ã™ã€‚',0),(299660,8324,'pt','Transferir para a empresa',0),(299661,8324,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‚ÑŒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(299662,8324,'es','Transferir A LA Empresa',0),(299663,8324,'de','Ãœbertragung auf Unternehmen',0),(299664,8324,'en','Transfer TO Company',0),(299665,8325,'is','',0),(299666,8325,'dr','ØªØ§Ø±ÙŠØ® Ø§ØµÙ„Ø§Ø­ ',0),(299667,8325,'pr','ØªØ§Ø±ÙŠØ® Ø§ØµÙ„Ø§Ø­ ',0),(299668,8325,'tr','Ayarlama tarihi',0),(299669,8325,'pl','Data dostosowania',0),(299670,8325,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ',0),(299671,8325,'ur','Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(299672,8325,'sr','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(299673,8325,'vi','NgÃ y Sá»­a Äá»•i',0),(299674,8325,'af','Aangepasde Datum',0),(299675,8325,'ro','Data de ajustare',0),(299676,8325,'et','Korrigeerimise kuupÃ¤ev',0),(299677,8325,'si','Nastavitev datuma',0),(299678,8325,'ba','Penyesuaian tanggal',0),(299679,8325,'nl','Aanpassing datum',0),(299680,8325,'fi','Oikaisun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(299681,8325,'no','Justeringsdato',0),(299682,8325,'da','Reguleringsdatoen',0),(299683,8325,'ko','ì¡°ì • ë‚ ì§œ',0),(299684,8325,'he','×”×ª××ž×ª ×ª××¨×™×š',0),(299685,8325,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(299686,8325,'zh','è°ƒæ•´æ—¥æœŸ\r\n',0),(299687,8325,'sv','Justeringsdatum',0),(299688,8325,'it','Data di registrazione',0),(299689,8325,'tl','',0),(299690,8325,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(299691,8325,'hi','à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(299692,8325,'ms','Tarikh pelarasan',0),(299693,8325,'ar','ØªØ§Ø±ÙŠØ® ',0),(299694,8325,'fr','Date de l\'ajustement',0),(299695,8325,'jp','èª¿æ•´æ—¥',0),(299696,8325,'pt','Data de ajuste',0),(299697,8325,'ru','Ð ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²ÐºÐ° Ð”Ð°Ñ‚Ð°',0),(299698,8325,'es','Fecha de Ajuste',0),(299699,8325,'de','Einstellung Datum',0),(299700,8325,'en','Adjustment Date',0),(299701,8326,'is','',0),(299702,8326,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ ',0),(299703,8326,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ ',0),(299704,8326,'tr','Engellenen sipariÅŸler listesi',0),(299705,8326,'pl','List uniewaÅ¼nionych zamÃ³wieÅ„',0),(299706,8326,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ð¸Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(299707,8326,'ur','ÙˆÙˆØ§ÚˆÛŒØ¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(299708,8326,'sr','Ð›Ð¸ÑÑ‚Ðµ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°',0),(299709,8326,'vi','Danh sÃ¡ch Ä‘Æ¡n hÃ ng vÃ´ hiá»‡u lá»±c',0),(299710,8326,'af','Lys van Uitgewisde Bestellings',0),(299711,8326,'ro','Liste cu ordinele de anulat',0),(299712,8326,'et','Nimekirjad tÃ¼histatud tellimustest',0),(299713,8326,'si','Seznami razveljavljeni naroÄil',0),(299714,8326,'ba','Daftar perintah Voided',0),(299715,8326,'nl','Lijsten met nietigverklaarde bestellingen',0),(299716,8326,'fi','Luettelo mitÃ¤tÃ¶ityjÃ¤ tilauksia',0),(299717,8326,'no','Lister over Annullerte ordrer',0),(299718,8326,'da','Lister over annullerede ordrer',0),(299719,8326,'ko','ë¬´íš¨í™” ì£¼ë¬¸ ëª©ë¡',0),(299720,8326,'he','×¨×©×™×ž×•×ª ×©×œ ×¤×§×•×“×•×ª ×©×ª×•×§×¤×Ÿ ×‘×•×˜×œ',0),(299721,8326,'el','Î›Î¯ÏƒÏ„ÎµÏ‚ Ï„Î·Ï‚ Î±ÎºÏ…ÏÏ‰Î¼Î­Î½Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(299722,8326,'zh','æ— æ•ˆè®¢å•åˆ—è¡¨\r\n',0),(299723,8326,'sv','Listor Ã¶ver annullerade order',0),(299724,8326,'it','Elenchi degli ordini escreta',0),(299725,8326,'tl','',0),(299726,8326,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(299727,8326,'hi','Voided à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤',0),(299728,8326,'ms','Senarai pesanan Voided',0),(299729,8326,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ù„ØºØ§Ø©',0),(299730,8326,'fr','Listes de commandes annulÃ©es',0),(299731,8326,'jp','ç„¡åŠ¹ã«ã•ã‚ŒãŸå‘½ä»¤ã®ãƒªã‚¹ãƒˆ',0),(299732,8326,'pt','Listas das ordens anuladas',0),(299733,8326,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(299734,8326,'es','Listas de Pedidos Anulados',0),(299735,8326,'de','Listen der stornierte Bestellungen',0),(299736,8326,'en','Lists of Voided Orders',0),(299737,8327,'is','',0),(299738,8327,'dr','(ØªÙƒÙ…ÙŠÙ„) ÙŠØ§ ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø¯Ù…Ø§Øª ',0),(299739,8327,'pr','Ù‡ÙŠÚ† Ø§Ø¬Ø±Ø§(ØªÙƒÙ…ÙŠÙ„) ÙŠØ§ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(299740,8327,'tr','Herhangi bir yerine getirilmesi veya servis sipariÅŸleri',0),(299741,8327,'pl','Nie speÅ‚nienie lub zleceÅ„ serwisowych',0),(299742,8327,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¸Ð»Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(299743,8327,'ur','Ú©ÙˆØ¦ÛŒ ØªÚ©Ù…ÛŒÙ„ ÛŒØ§ Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(299744,8327,'sr','ÐÐµÐ¼Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð¸Ð»Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(299745,8327,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n hÃ ng giao táº­n nÆ¡i hay Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(299746,8327,'af','Geen Uitvoerings- of Diensbestellings',0),(299747,8327,'ro','Nici o Ã®mplinire sau comenzi de Service',0),(299748,8327,'et','Pole kauba- ega teenusetellimusi',0),(299749,8327,'si','Brez izpolnitve ali servisnih nalogov',0),(299750,8327,'ba','Tidak ada pemenuhan atau layanan pesanan',0),(299751,8327,'nl','Geen vervulling of serviceorders',0),(299752,8327,'fi','Ole tÃ¤yttÃ¤minen tai huoltotilaukset',0),(299753,8327,'no','Ingen oppfyllelse eller serviceordrer',0),(299754,8327,'da','Ingen tilfredsstillelse eller serviceordrer',0),(299755,8327,'ko','ì•„ë‹ˆ í–‰ ë˜ëŠ” ì„œë¹„ìŠ¤ ì£¼ë¬¸',0),(299756,8327,'he','××™×Ÿ ×ž×™×ž×•×© ××• ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(299757,8327,'el','Î”ÎµÎ½ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Î® ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(299758,8327,'zh','æ²¡æœ‰å±¥è¡Œæˆ–æœåŠ¡è®¢å•\r\n',0),(299759,8327,'sv','Ingen uppfyllelse eller serviceorder',0),(299760,8327,'it','Nessun adempimento o ordini di servizio',0),(299761,8327,'tl','',0),(299762,8327,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3627;&#3619;&#3639;&#3629;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(299763,8327,'hi','à¤•à¥‹à¤ˆ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤¯à¤¾ à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(299764,8327,'ms','Tidak memenuhi atau pesanan Perkhidmatan',0),(299765,8327,'ar','Ù„Ø§ ÙˆÙØ§Ø¡ Ø£Ùˆ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(299766,8327,'fr','Aucune rÃ©alisation ou les commandes de Service',0),(299767,8327,'jp','ãªã„ã®å±¥è¡Œã‚„ã‚µãƒ¼ãƒ“ã‚¹ã®æ³¨æ–‡',0),(299768,8327,'pt','NÃ£o cumprimento ou ordens de serviÃ§o',0),(299769,8327,'ru','ÐÐµ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¸Ð»Ð¸ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(299770,8327,'es','No Ordenes de Cumplimiento ni de Servicio',0),(299771,8327,'de','Keine ErfÃ¼llung oder ServiceauftrÃ¤ge',0),(299772,8327,'en','No Fulfillment or Service Orders',0),(299773,8328,'is','',0),(299774,8328,'dr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø±Ø§ Ù†Ø´Ø§Ù† Ø¨Ø¯Ù‡ÙŠØ¯ ',0),(299775,8328,'pr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø±Ø§ Ù†Ø´Ø§Ù† Ø¨Ø¯Ù‡ÙŠØ¯ ',0),(299776,8328,'tr','Sadece HaritayÄ± sipariÅŸ YazdÄ±r',0),(299777,8328,'pl','Tylko PokaÅ¼ wydruku zleceÅ„',0),(299778,8328,'bg','Ð¡Ð°Ð¼Ð¾ ÑˆÐ¾Ñƒ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(299779,8328,'ur','ØµØ±Ù Ø´Ùˆ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(299780,8328,'sr','Ð¡Ð°Ð¼Ð¾ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð° ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(299781,8328,'vi','Chi hiá»ƒn thá»‹ Ä‘Æ¡n hÃ ng in',0),(299782,8328,'af','Wys Net Gedrukte Bestellings',0),(299783,8328,'ro','Numai AratÄƒ comenzi de imprimare',0),(299784,8328,'et','Ainult NÃ¤ita trÃ¼kitÃ¶Ã¶de tellimused',0),(299785,8328,'si','Le PokaÅ¾i tiskanje nalogov',0),(299786,8328,'ba','Hanya Tampilkan pesanan cetak',0),(299787,8328,'nl','Toon alleen afdrukken Orders',0),(299788,8328,'fi','Vain NÃ¤ytÃ¤ tulosta tilaukset',0),(299789,8328,'no','Bare Vis bestilling',0),(299790,8328,'da','Kun Vis aftryksbestillinger',0),(299791,8328,'ko','ë§Œ ë³´ê¸° ì¸ì‡„ ì£¼ë¬¸',0),(299792,8328,'he','×¨×§ ×”×¦×’ ×”×–×ž× ×•×ª ×œ×”×“×¤×¡×”',0),(299793,8328,'el','ÎœÏŒÎ½Î¿ ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ· Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Ï„Ï…Ï€Ï‰Î¼Î­Î½Ï‰Î½ Ï…Î»ÏŽÎ½',0),(299794,8328,'zh','åªæ˜¾ç¤ºæ‰“å°è®¢å•\r\n',0),(299795,8328,'sv','Endast Visa Print Order',0),(299796,8328,'it','Solo gli ordini di spettacolo stampa',0),(299797,8328,'tl','',0),(299798,8328,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3614;&#3636;&#3617;&#3614;&#3660;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(299799,8328,'hi','à¤•à¥‡à¤µà¤² à¤¦à¤¿à¤–à¤¾à¤à¤ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶',0),(299800,8328,'ms','Hanya Papar cetak pesanan',0),(299801,8328,'ar','ÙÙ‚Ø· Ø¹Ø±Ø¶ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(299802,8328,'fr','Seules les commandes d\'impression Voir la',0),(299803,8328,'jp','åœ°å›³ã‚’å°åˆ·å—æ³¨ã®ã¿',0),(299804,8328,'pt','Apenas Visualizar impressÃ£o ordens',0),(299805,8328,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(299806,8328,'es','Solo Muestra Ordenes de ImpresiÃ³n',0),(299807,8328,'de','Nur Karte-DruckauftrÃ¤ge',0),(299808,8328,'en','Only Show Print Orders',0),(299809,8329,'is','',0),(299810,8329,'dr','ØµÙØ­Ù‡ Ø®Ù„Ø§ØµÙ‡  Ø­Ù…Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(299811,8329,'pr','ØµÙØ­Ù‡ Ø®Ù„Ø§ØµÙ‡  Ø­Ù…Ù„ Ø¨Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(299812,8329,'tr','Ekrana kÄ±sa gemi',0),(299813,8329,'pl','KrÃ³tki statku do ekranu',0),(299814,8329,'bg','ÐšÑ€Ð°Ñ‚ÐºÐ¾ ÐºÐ¾Ñ€Ð°Ð± ÐºÑŠÐ¼ ÐµÐºÑ€Ð°Ð½',0),(299815,8329,'ur','Ù…Ø®ØªØµØ± Ø¬ÛØ§Ø² Ú©Ø±ÛŒÚº Ú©ÛŒ Ø§Ø³Ú©Ø±ÛŒÙ† Ù¾Ø±',0),(299816,8329,'sr','ÐšÑ€Ð°Ñ‚ÐºÐ¸ Ð±Ñ€Ð¾Ð´ Ð½Ð° ÐµÐºÑ€Ð°Ð½',0),(299817,8329,'vi','MÃ n hÃ¬nh khÃ¡ch hÃ ng chuyá»ƒn Ä‘áº¿n ngáº¯n',0),(299818,8329,'af','Kort skip na skerm',0),(299819,8329,'ro','Nava scurt la ecran',0),(299820,8329,'et','LÃ¼hike laeva kuvale',0),(299821,8329,'si','Kratek ladje zaslon',0),(299822,8329,'ba','Pendek kapal layar',0),(299823,8329,'nl','Korte schip naar scherm',0),(299824,8329,'fi','Lyhyt aluksen nÃ¤yttÃ¶',0),(299825,8329,'no','Kort skipet til skjermen',0),(299826,8329,'da','Kort skib til skÃ¦rm',0),(299827,8329,'ko','í™”ë©´ì— ì§§ì€ ë°°',0),(299828,8329,'he','×”×¡×¤×™× ×” ×§×¦×¨ ×œ×ž×¡×š',0),(299829,8329,'el','Î£ÏÎ½Ï„Î¿Î¼Î· Ï€Î»Î¿Î¯Î¿ ÏƒÏ„Î·Î½ Î¿Î¸ÏŒÎ½Î·',0),(299830,8329,'zh','çŸ­çº¿å®¢æˆ·æ”¶è´§é¡µé¢\r\n',0),(299831,8329,'sv','Kort fartyg till skÃ¤rm',0),(299832,8329,'it','Breve nave a schermo',0),(299833,8329,'tl','',0),(299834,8329,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3594;&#3633;&#3656;&#3623;&#3588;&#3619;&#3634;&#3623;&#3626;&#3656;&#3591;&#3652;&#3611;&#3626;&#3641;&#3656;&#3627;&#3609;&#3657;&#3634;&#3592;&#3629;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(299835,8329,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤›à¥‹à¤Ÿà¤¾ à¤œà¤¹à¤¾à¤œ',0),(299836,8329,'ms','Pendek kapal ke skrin',0),(299837,8329,'ar','Ø³ÙÙŠÙ†Ø© Ù‚ØµÙŠØ±Ø© Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø§Ø´Ø©',0),(299838,8329,'fr','Navire court Ã  l\'Ã©cran',0),(299839,8329,'jp','ç”»é¢ã«çŸ­ã„èˆ¹',0),(299840,8329,'pt','Pequeno navio para tela',0),(299841,8329,'ru','ÐšÐ¾Ñ€Ð¾Ñ‚ÐºÐ¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»Ñ Ð½Ð° ÑÐºÑ€Ð°Ð½',0),(299842,8329,'es','Cliente Abreviado Pantalla de Enviar-A',0),(299843,8329,'de','Kurze Schiff auf Bildschirm',0),(299844,8329,'en','Short Ship To Screen',0),(299845,8330,'is','',0),(299846,8330,'dr','Ø®Ø·Ø§ â€“ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ù†ÙŠØ³Øª ',0),(299847,8330,'pr','Ø®Ø·Ø§ â€“ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ù†ÙŠØ³Øª ',0),(299848,8330,'tr','Hata - veri kaydetmek deÄŸil',0),(299849,8330,'pl','BÅ‚Ä…d - nie moÅ¼na zapisaÄ‡ danych',0),(299850,8330,'bg','Ð“Ñ€ÐµÑˆÐºÐ° - Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð·Ð°Ð¿Ð¸ÑˆÐµ Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ',0),(299851,8330,'ur','Ù†Ù‚Øµ - ÚˆÛŒÙ¹Ø§ Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(299852,8330,'sr','Ð“Ñ€ÐµÑˆÐºÐ° - Ð½Ð¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÑÐ°Ñ‡ÑƒÐ²Ð°Ñ‚Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(299853,8330,'vi','Lá»—i: khÃ´ng sao lÆ°u Ä‘Æ°á»£c dá»¯ liá»‡u',0),(299854,8330,'af','Fout - Data nie Gestoor',0),(299855,8330,'ro','Eroare - ar putea salva datele',0),(299856,8330,'et','Viga - ei saanud andmeid salvetada',0),(299857,8330,'si','Napaka - ni bilo mogoÄe shraniti podatkov',0),(299858,8330,'ba','Kesalahan - tidak dapat menyelamatkan data',0),(299859,8330,'nl','Fout - kan niet opslaan gegevens',0),(299860,8330,'fi','Virhe - tietoja ei voitu tallentaa',0),(299861,8330,'no','Feil - kan ikke lagre data',0),(299862,8330,'da','Fejl - kunne ikke gemme data',0),(299863,8330,'ko','ì˜¤ë¥˜-ë°ì´í„°ë¥¼ ì €ìž¥ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(299864,8330,'he','×©×’×™××” - ×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×©×ž×•×¨ × ×ª×•× ×™×',0),(299865,8330,'el','Î£Ï†Î¬Î»Î¼Î± - Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÎ¹ Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(299866,8330,'zh','é”™è¯¯ -æ— æ³•ä¿å­˜æ•°æ®ã€‚',0),(299867,8330,'sv','Fel - kunde inte spara data',0),(299868,8330,'it','Errore - non puÃ² salvare dati',0),(299869,8330,'tl','',0),(299870,8330,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604; - &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(299871,8330,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ - à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤¸à¤¹à¥‡à¤œ à¤¸à¤•à¤¤à¤¾',0),(299872,8330,'ms','Ralat - tidak dapat menyimpan data',0),(299873,8330,'ar','Ø®Ø·Ø£-Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø­ÙØ¸ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(299874,8330,'fr','Erreur - pas pu enregistrer les donnÃ©es',0),(299875,8330,'jp','ã‚¨ãƒ©ãƒ¼ - ãƒ‡ãƒ¼ã‚¿ã‚’ä¿å­˜ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(299876,8330,'pt','Erro - nÃ£o pÃ´de salvar dados',0),(299877,8330,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° - ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(299878,8330,'es','Error - No se PodÃ­a Guardar los Datos',0),(299879,8330,'de','Fehler: konnte nicht gespeichert werden Daten',0),(299880,8330,'en','Error - Could not save data',0),(299881,8331,'is','',0),(299882,8331,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ú†Ø§Ù¾ Ù‡Ø§',0),(299883,8331,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ú†Ø§Ù¾ Ù‡Ø§',0),(299884,8331,'tr','Toplam GÃ¶sterim',0),(299885,8331,'pl','ÅÄ…czna liczba wyÅ›wietleÅ„',0),(299886,8331,'bg','ÐžÐ±Ñ‰Ð¾ Ð¸Ð¼Ð¿Ñ€ÐµÑÐ¸Ð¸',0),(299887,8331,'ur','Ú©Ù„ Ù†Ù‚ÙˆØ´',0),(299888,8331,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÑƒÑ‚Ð¸ÑÐºÐµ',0),(299889,8331,'vi','Tá»•ng cá»™ng áº¥n tÆ°á»£ng',0),(299890,8331,'af','Totale indrukke',0),(299891,8331,'ro','Total afiÅŸÄƒri',0),(299892,8331,'et','Kokku kuvamisi',0),(299893,8331,'si','Skupno Å¡tevilo prikazov',0),(299894,8331,'ba','Total tayangan',0),(299895,8331,'nl','Totale indrukken',0),(299896,8331,'fi','NÃ¤yttÃ¶kertojen kokonaismÃ¤Ã¤rÃ¤',0),(299897,8331,'no','Totalt antall visninger',0),(299898,8331,'da','Total visninger',0),(299899,8331,'ko','ì´ ë…¸ì¶œ ìˆ˜',0),(299900,8331,'he','×¨×©×ž×™× ×¡×”',0),(299901,8331,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ­Ï‚ ÎµÎ½Ï„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚',0),(299902,8331,'zh','æ€»å°è±¡\r\n',0),(299903,8331,'sv','Totalt intryck',0),(299904,8331,'it','Impressioni totali',0),(299905,8331,'tl','',0),(299906,8331,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3588;&#3656;&#3634;&#3648;&#3626;&#3639;&#3656;&#3629;&#3617;&#3619;&#3634;&#3588;&#3634;',0),(299907,8331,'hi','à¤•à¥à¤² à¤›à¤¾à¤ªà¥‡à¤‚',0),(299908,8331,'ms','Jumlah tayangan',0),(299909,8331,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø¹Ø¯Ø¯ Ù…Ø±Ø§Øª Ø§Ù„Ø¸Ù‡ÙˆØ±',0),(299910,8331,'fr','Impressions totales',0),(299911,8331,'jp','åˆè¨ˆè¡¨ç¤ºå›žæ•°',0),(299912,8331,'pt','ImpressÃµes totais',0),(299913,8331,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ð¾ÐºÐ°Ð·Ð¾Ð²',0),(299914,8331,'es','Impresiones Totales',0),(299915,8331,'de','Gesamt-Impressionen',0),(299916,8331,'en','Total Impressions',0),(299917,8332,'is','',0),(299918,8332,'dr','31 ØªØ§ 45',0),(299919,8332,'pr','31 ØªØ§ 45',0),(299920,8332,'tr','31-45',0),(299921,8332,'pl','31-45',0),(299922,8332,'bg','31-45',0),(299923,8332,'ur','Ø§Ú©ØªÛŒØ³ Ø³Û’ Ù¾ÛŒÙ†ØªØ§Ù„Ø³ Ø¯Ù†',0),(299924,8332,'sr','31-45',0),(299925,8332,'vi','31-45',0),(299926,8332,'af','31-45',0),(299927,8332,'ro','31-45',0),(299928,8332,'et','31-45',0),(299929,8332,'si','31-45',0),(299930,8332,'ba','31-45',0),(299931,8332,'nl','31-45',0),(299932,8332,'fi','31-45',0),(299933,8332,'no','31-45',0),(299934,8332,'da','31-45',0),(299935,8332,'ko','31-45',0),(299936,8332,'he','31-45',0),(299937,8332,'el','31-45',0),(299938,8332,'zh','31è‡³45',0),(299939,8332,'sv','31-45',0),(299940,8332,'it','31-45',0),(299941,8332,'tl','',0),(299942,8332,'th','31 à¸–à¸¶à¸‡ 45',0),(299943,8332,'hi','31-45',0),(299944,8332,'ms','31-45',0),(299945,8332,'ar','31-45',0),(299946,8332,'fr','31-45',0),(299947,8332,'jp','31-45',0),(299948,8332,'pt','31-45',0),(299949,8332,'ru','31-45',0),(299950,8332,'es','31-45',0),(299951,8332,'de','31-45',0),(299952,8332,'en','31-45',0),(299953,8333,'is','',0),(299954,8333,'dr','31 ØªØ§ 60',0),(299955,8333,'pr','31 ØªØ§ 60',0),(299956,8333,'tr','31-60',0),(299957,8333,'pl','31-60',0),(299958,8333,'bg','31-60',0),(299959,8333,'ur','Ø§Ú©ØªÛŒØ³ Ø³Û’ ÛŒÚ©Ø³Ù¹Ú¾ Ø¯Ù†',0),(299960,8333,'sr','31-60',0),(299961,8333,'vi','31-60',0),(299962,8333,'af','31-60',0),(299963,8333,'ro','31-60',0),(299964,8333,'et','31-60',0),(299965,8333,'si','31-60',0),(299966,8333,'ba','31-60',0),(299967,8333,'nl','31-60',0),(299968,8333,'fi','31-60',0),(299969,8333,'no','31-60',0),(299970,8333,'da','31-60',0),(299971,8333,'ko','31-60',0),(299972,8333,'he','31-60',0),(299973,8333,'el','31-60',0),(299974,8333,'zh','31è‡³60',0),(299975,8333,'sv','31-60',0),(299976,8333,'it','31-60',0),(299977,8333,'tl','',0),(299978,8333,'th','31 à¸–à¸¶à¸‡ 60',0),(299979,8333,'hi','31-60',0),(299980,8333,'ms','31-60',0),(299981,8333,'ar','31-60',0),(299982,8333,'fr','31-60',0),(299983,8333,'jp','31-60',0),(299984,8333,'pt','31-60',0),(299985,8333,'ru','31-60',0),(299986,8333,'es','31-60',0),(299987,8333,'de','31-60',0),(299988,8333,'en','31-60',0),(299989,8334,'is','',0),(299990,8334,'dr','46-60',0),(299991,8334,'pr','46-60',0),(299992,8334,'tr','46-60',0),(299993,8334,'pl','46-60',0),(299994,8334,'bg','46-60',0),(299995,8334,'ur','Ú†Ú¾ÛŒØ§Ù„ÛŒØ³ Ø³Û’ Ø³Ø§Ù¹Ú¾ Ø¯Ù†',0),(299996,8334,'sr','46-60',0),(299997,8334,'vi','46-60',0),(299998,8334,'af','46-60',0),(299999,8334,'ro','46-60',0),(300000,8334,'et','46-60',0),(300001,8334,'si','46-60',0),(300002,8334,'ba','45-60',0),(300003,8334,'nl','46-60',0),(300004,8334,'fi','46-60',0),(300005,8334,'no','46-60',0),(300006,8334,'da','46-60',0),(300007,8334,'ko','46-60',0),(300008,8334,'he','46-60',0),(300009,8334,'el','46-60',0),(300010,8334,'zh','46è‡³60',0),(300011,8334,'sv','46-60',0),(300012,8334,'it','46-60',0),(300013,8334,'tl','',0),(300014,8334,'th','46 à¸–à¸¶à¸‡ 60',0),(300015,8334,'hi','46-60',0),(300016,8334,'ms','46-60',0),(300017,8334,'ar','46-60',0),(300018,8334,'fr','46-60',0),(300019,8334,'jp','46-60',0),(300020,8334,'pt','46-60',0),(300021,8334,'ru','46-60',0),(300022,8334,'es','46-60',0),(300023,8334,'de','46-60',0),(300024,8334,'en','46-60',0),(300025,8335,'is','',0),(300026,8335,'dr','61-90',0),(300027,8335,'pr','61-90',0),(300028,8335,'tr','61-90',0),(300029,8335,'pl','61-90',0),(300030,8335,'bg','61-90',0),(300031,8335,'ur','Ø§Ú©Ø³Ù¹Ú¾ Ù² Ù†ÙˆÛ’',0),(300032,8335,'sr','61-90',0),(300033,8335,'vi','61-90',0),(300034,8335,'af','61-90',0),(300035,8335,'ro','61-90',0),(300036,8335,'et','61-90',0),(300037,8335,'si','61-90',0),(300038,8335,'ba','61-90',0),(300039,8335,'nl','61-90',0),(300040,8335,'fi','61-90',0),(300041,8335,'no','61-90',0),(300042,8335,'da','61-90',0),(300043,8335,'ko','61-90',0),(300044,8335,'he','61-90',0),(300045,8335,'el','61-90',0),(300046,8335,'zh','61è‡³90',0),(300047,8335,'sv','61-90',0),(300048,8335,'it','61-90',0),(300049,8335,'tl','',0),(300050,8335,'th','61 à¸–à¸¶à¸‡ 90',0),(300051,8335,'hi','61-90',0),(300052,8335,'ms','61-90',0),(300053,8335,'ar','61-90',0),(300054,8335,'fr','61-90',0),(300055,8335,'jp','61-90',0),(300056,8335,'pt','61-90',0),(300057,8335,'ru','61-90',0),(300058,8335,'es','61-90',0),(300059,8335,'de','61-90',0),(300060,8335,'en','61-90',0),(300061,8336,'is','',0),(300062,8336,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø±ÙˆØ²Ø§Ù†Ù‡',0),(300063,8336,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø±ÙˆØ²Ø§Ù†Ù‡',0),(300064,8336,'tr','GÃ¼nlÃ¼k raporu',0),(300065,8336,'pl','Dzienny raport',0),(300066,8336,'bg','Ð”Ð½ÐµÐ²ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(300067,8336,'ur','Ø±ÙˆØ² Ù…Ø±Û Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(300068,8336,'sr','Ð”Ð½ÐµÐ²Ð½Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(300069,8336,'vi','BÃ¡o cÃ¡o ngÃ y',0),(300070,8336,'af','Daaglikse Verslag',0),(300071,8336,'ro','Raport zilnic',0),(300072,8336,'et','PÃ¤evane aruanne',0),(300073,8336,'si','Dnevno poroÄilo',0),(300074,8336,'ba','Laporan harian',0),(300075,8336,'nl','Dagelijks rapport',0),(300076,8336,'fi','PÃ¤ivittÃ¤inen raportti',0),(300077,8336,'no','Daglig rapport',0),(300078,8336,'da','Daglig rapport',0),(300079,8336,'ko','ì¼ì¼ ë³´ê³ ì„œ',0),(300080,8336,'he','×“×•×— ×™×•×ž×™',0),(300081,8336,'el','Î—Î¼ÎµÏÎ®ÏƒÎ¹Î± Î±Î½Î±Ï†Î¿ÏÎ¬',0),(300082,8336,'zh','æ¯æ—¥æŠ¥å‘Š\r\n',0),(300083,8336,'sv','Daglig rapport',0),(300084,8336,'it','Report giornaliero',0),(300085,8336,'tl','',0),(300086,8336,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;',0),(300087,8336,'hi','à¤¦à¥ˆà¤¨à¤¿à¤• à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(300088,8336,'ms','Laporan harian',0),(300089,8336,'ar','Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„ÙŠÙˆÙ…ÙŠ',0),(300090,8336,'fr','Rapport journalier',0),(300091,8336,'jp','æ—¥æ¬¡ãƒ¬ãƒãƒ¼ãƒˆ',0),(300092,8336,'pt','RelatÃ³rio diÃ¡rio',0),(300093,8336,'ru','Ð•Ð¶ÐµÐ´Ð½ÐµÐ²Ð½Ñ‹Ð¹ ÐžÑ‚Ñ‡ÐµÑ‚',0),(300094,8336,'es','Informe Diario',0),(300095,8336,'de','Tagesbericht',0),(300096,8336,'en','Daily Report',0),(300097,8337,'is','',0),(300098,8337,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ú†Ù‡ Ø±ÙˆØ²ÙŠ ',0),(300099,8337,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ú†Ù‡ Ø±ÙˆØ²ÙŠ ',0),(300100,8337,'tr','Rapor iÃ§in hangi gÃ¼n',0),(300101,8337,'pl','Raport na co dzieÅ„',0),(300102,8337,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð·Ð° ÐºÐ°ÐºÑŠÐ² Ð´ÐµÐ½',0),(300103,8337,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú©Ø³ Ø¯Ù† Ú©Û’ Ù„ÛŒÛ’',0),(300104,8337,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð·Ð° ÐºÐ¾Ñ˜Ð¸ Ð´Ð°Ð½',0),(300105,8337,'vi','BÃ¡o cÃ¡o cho ngÃ y nÃ o',0),(300106,8337,'af','Verslag vir Watter Dag',0),(300107,8337,'ro','Raport pentru ce zi',0),(300108,8337,'et','Mis pÃ¤ev aruanne',0),(300109,8337,'si','PoroÄilo za kakÅ¡en dan',0),(300110,8337,'ba','Laporan apa hari',0),(300111,8337,'nl','Verslag voor welke dag',0),(300112,8337,'fi','MikÃ¤ pÃ¤ivÃ¤ raportti',0),(300113,8337,'no','Rapport for hvilken dag',0),(300114,8337,'da','Rapport for hvad dag',0),(300115,8337,'ko','ì–´ë–¤ ì¼ì— ëŒ€ í•œ ë³´ê³ ì„œ',0),(300116,8337,'he','×“×•×— ×¢×‘×•×¨ ××™×–×” ×™×•× ×”×™×•×',0),(300117,8337,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î³Î¹Î± Ï„Î¿ Ï„Î¹ Î¼Î­ÏÎ±',0),(300118,8337,'zh','å“ªä¸€å¤©çš„æŠ¥å‘Š\r\n',0),(300119,8337,'sv','Rapport fÃ¶r vilken dag',0),(300120,8337,'it','Relazione per quale giorno',0),(300121,8337,'tl','',0),(300122,8337,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3623;&#3633;&#3609;&#3652;&#3627;&#3609;',0),(300123,8337,'hi','à¤•à¥à¤¯à¤¾ à¤¦à¤¿à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(300124,8337,'ms','Laporan untuk hari apa',0),(300125,8337,'ar','ØªÙ‚Ø±ÙŠØ± Ù„ÙŠÙˆÙ… Ù…Ø§',0),(300126,8337,'fr','Rapport pour quel jour',0),(300127,8337,'jp','ã©ã®ã‚ˆã†ãªæ—¥ã®ãƒ¬ãƒãƒ¼ãƒˆ',0),(300128,8337,'pt','RelatÃ³rio para o dia',0),(300129,8337,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° ÐšÐ°ÐºÐ¾Ð¹ Ð”ÐµÐ½ÑŒ',0),(300130,8337,'es','Informe para QuÃ© DÃ­a',0),(300131,8337,'de','Bericht fÃ¼r was fÃ¼r ein Tag',0),(300132,8337,'en','Report for What Day',0),(300133,8338,'is','',0),(300134,8338,'dr','Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ… ',0),(300135,8338,'pr','Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ… ',0),(300136,8338,'tr','Daha az vergi',0),(300137,8338,'pl','Mniej podatkowej',0),(300138,8338,'bg','ÐŸÐ¾-Ð¼Ð°Ð»ÐºÐ¾ Ð´Ð°Ð½ÑŠÐº',0),(300139,8338,'ur','Ú©Ù… Ù¹ÛŒÚ©Ø³',0),(300140,8338,'sr','ÐœÐ°ÑšÐµ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(300141,8338,'vi','Trá»« thuáº¿',0),(300142,8338,'af','Minus Belasting',0),(300143,8338,'ro','Impozit mai puÅ£in',0),(300144,8338,'et','Millest on maha arvatud',0),(300145,8338,'si','Manj davka',0),(300146,8338,'ba','Pajak kurang',0),(300147,8338,'nl','Minder belasting',0),(300148,8338,'fi','VÃ¤hemmÃ¤n veroja',0),(300149,8338,'no','Mindre skatt',0),(300150,8338,'da','Mindre i skat',0),(300151,8338,'ko','ë” ì ì€ ì„¸ê¸ˆ',0),(300152,8338,'he','×¤×—×•×ª ×ž×¡',0),(300153,8338,'el','Î›Î¹Î³ÏŒÏ„ÎµÏÎ¿Ï…Ï‚ Ï†ÏŒÏÎ¿Ï…Ï‚',0),(300154,8338,'zh','å°‘äºŽç¨Žæ¬¾\r\n',0),(300155,8338,'sv','Mindre skatt',0),(300156,8338,'it','Meno tasse',0),(300157,8338,'tl','',0),(300158,8338,'th','&#3627;&#3633;&#3585;&#3616;&#3634;&#3625;&#3637;',0),(300159,8338,'hi','à¤•à¤® à¤Ÿà¥ˆà¤•à¥à¤¸',0),(300160,8338,'ms','Ditolak cukai',0),(300161,8338,'ar','Ø¶Ø±Ø§Ø¦Ø¨ Ø£Ù‚Ù„',0),(300162,8338,'fr','RÃ©duction d\'impÃ´t',0),(300163,8338,'jp','ä»¥ä¸‹ã®ç¨Žé‡‘',0),(300164,8338,'pt','Menos impostos',0),(300165,8338,'ru','ÐœÐµÐ½ÑŒÑˆÐµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(300166,8338,'es','Menos Impuestos',0),(300167,8338,'de','Weniger Steuern',0),(300168,8338,'en','Less Tax',0),(300169,8339,'is','',0),(300170,8339,'dr','90',0),(300171,8339,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² 90',0),(300172,8339,'tr','90',0),(300173,8339,'pl','Ponad 90',0),(300174,8339,'bg','ÐÐ°Ð´ 90',0),(300175,8339,'ur','90 Ø³Û’ Ø²Ø§Ø¦Ø¯',0),(300176,8339,'sr','ÐŸÑ€ÐµÐºÐ¾ 90',0),(300177,8339,'vi','QuÃ¡ 90',0),(300178,8339,'af','Meer As 90',0),(300179,8339,'ro','Peste 90',0),(300180,8339,'et','Ãœle 90',0),(300181,8339,'si','VeÄ kot 90',0),(300182,8339,'ba','Lebih dari 90',0),(300183,8339,'nl','Meer dan 90',0),(300184,8339,'fi','Yli 90',0),(300185,8339,'no','Over 90',0),(300186,8339,'da','Over 90',0),(300187,8339,'ko','90',0),(300188,8339,'he','×ž×¢×œ 90',0),(300189,8339,'el','Î Î¬Î½Ï‰ Î±Ï€ÏŒ 90',0),(300190,8339,'zh','è¶…è¿‡90\r\n',0),(300191,8339,'sv','Ã–ver 90',0),(300192,8339,'it','Oltre 90',0),(300193,8339,'tl','',0),(300194,8339,'th','&#3648;&#3585;&#3636;&#3609; 90',0),(300195,8339,'hi','90 à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(300196,8339,'ms','Lebih 90',0),(300197,8339,'ar','Ù…Ø§ ÙŠØ²ÙŠØ¯ Ø¹Ù„Ù‰ 90',0),(300198,8339,'fr','Plus de 90',0),(300199,8339,'jp','ä»¥ä¸Š 90',0),(300200,8339,'pt','Mais de 90',0),(300201,8339,'ru','Ð‘Ð¾Ð»ÐµÐµ 90',0),(300202,8339,'es','MÃ¡s Que 90',0),(300203,8339,'de','Mehr als 90',0),(300204,8339,'en','Over 90',0),(300205,8340,'is','',0),(300206,8340,'dr','(Ø§Ù‚Ø³Ø§Ø·) Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ ',0),(300207,8340,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§(Ø§Ù‚Ø³Ø§Ø·) Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯ ',0),(300208,8340,'tr','AlÄ±nan Ã¶demeler',0),(300209,8340,'pl','Otrzymane pÅ‚atnoÅ›ci',0),(300210,8340,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(300211,8340,'ur','Ù…Ù„Ø§ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(300212,8340,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ',0),(300213,8340,'vi','ÄÃ£ nháº­n Thanh ToÃ¡n',0),(300214,8340,'af','Betalings Ontvang',0),(300215,8340,'ro','PlÄƒÅ£ile primite',0),(300216,8340,'et','Saadud maksed',0),(300217,8340,'si','PlaÄila, prejeta',0),(300218,8340,'ba','Pembayaran yang diterima',0),(300219,8340,'nl','Betalingen ontvangen',0),(300220,8340,'fi','Saadut maksut',0),(300221,8340,'no','Mottatte betalinger',0),(300222,8340,'da','Betalinger modtaget',0),(300223,8340,'ko','ì§€ê¸‰ ë°›ì€',0),(300224,8340,'he','×ª×©×œ×•×ž×™× ×”×ª×§×‘×œ×•',0),(300225,8340,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… Î­Î»Î±Î²Îµ',0),(300226,8340,'zh','æ”¶åˆ°çš„æ¬¾é¡¹\r\n',0),(300227,8340,'sv','Betalningar',0),(300228,8340,'it','Pagamenti ricevuti',0),(300229,8340,'tl','',0),(300230,8340,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;',0),(300231,8340,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(300232,8340,'ms','Bayaran yang diterima',0),(300233,8340,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…ØªÙ„Ù‚Ø§Ø©',0),(300234,8340,'fr','Paiements reÃ§us',0),(300235,8340,'jp','å—ã‘å–ã£ãŸæ”¯æ‰•ã„',0),(300236,8340,'pt','Pagamentos recebidos',0),(300237,8340,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(300238,8340,'es','Pagos Recibidos',0),(300239,8340,'de','Erhaltene Anzahlungen',0),(300240,8340,'en','Payments Received',0),(300241,8341,'is','',0),(300242,8341,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(300243,8341,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(300244,8341,'tr','PO sipariÅŸ oluÅŸtur',0),(300245,8341,'pl','Tworzenie zamÃ³wienia z PO',0),(300246,8341,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ PO',0),(300247,8341,'ur','ØªØ±ØªÛŒØ¨ Ø³Û’ Ù¾Ùˆ Ø¨Ù†Ø§Ø¦ÛŒÚº Û”',0),(300248,8341,'sr','Ð”Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð¸Ð· ÐŸÐž',0),(300249,8341,'vi','Táº¡o Ä‘Æ¡n Ä‘áº·t hÃ ng cho Ä‘Æ¡n mua hÃ ng ',0),(300250,8341,'af','Skep Bestelling vanaf AB',0),(300251,8341,'ro','CreaÅ£i comanda de la PO',0),(300252,8341,'et','Luua tellida PO',0),(300253,8341,'si','Ustvari nalog od pad',0),(300254,8341,'ba','Menciptakan keteraturan dari PO',0),(300255,8341,'nl','Create Order from PO',0),(300256,8341,'fi','Luo tilaus PO',0),(300257,8341,'no','Opprette ordre fra PO',0),(300258,8341,'da','Opret ordre fra PO',0),(300259,8341,'ko','í¬ì—ì„œ ìˆœì„œë¥¼ ë§Œë“¤',0),(300260,8341,'he','×œ×™×¦×•×¨ ×¡×“×¨ ×©×œ ×¤×•',0),(300261,8341,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î±Ï€ÏŒ PO',0),(300262,8341,'zh','åˆ›å»ºè´­ä¹°è®¢å•\r\n',0),(300263,8341,'sv','Skapa Order frÃ¥n PO',0),(300264,8341,'it','Creare ordine dal PO',0),(300265,8341,'tl','',0),(300266,8341,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(300267,8341,'hi','à¤•à¥à¤°à¤® à¤¸à¥‡ PO à¤¬à¤¨à¤¾à¤à¤',0),(300268,8341,'ms','Mencipta pesanan dari PO',0),(300269,8341,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ù…Ù† Ø¨Ùˆ',0),(300270,8341,'fr','CrÃ©er l\'ordre de PO',0),(300271,8341,'jp','PO ã‹ã‚‰ã®æ³¨æ–‡ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(300272,8341,'pt','Criar ordem de PO',0),(300273,8341,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ð¸Ð· Ð Ð¾',0),(300274,8341,'es','Crear Pedido de OC',0),(300275,8341,'de','Bestellung von PO erstellen',0),(300276,8341,'en','Create Order from PO',0),(300277,8342,'is','',0),(300278,8342,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ ',0),(300279,8342,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ ',0),(300280,8342,'tr','SipariÅŸ oluÅŸturma',0),(300281,8342,'pl','Tworzenie zamÃ³wienia na',0),(300282,8342,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð°',0),(300283,8342,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’',0),(300284,8342,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(300285,8342,'vi','Táº¡o Ä‘Æ¡n Ä‘áº·t hÃ ng cho',0),(300286,8342,'af','Skep orde vir',0),(300287,8342,'ro','Crearea comenzii pentru',0),(300288,8342,'et','Millega maksekÃ¤su',0),(300289,8342,'si','Ustvarjanje naloga za',0),(300290,8342,'ba','Membuat pesanan untuk',0),(300291,8342,'nl','Order voor te maken',0),(300292,8342,'fi','MaksusuoritusmÃ¤Ã¤rÃ¤ysmenettelyn',0),(300293,8342,'no','Ordre for',0),(300294,8342,'da','IndfÃ¸relse af',0),(300295,8342,'ko','ë§Œë“¤ê¸° ìœ„í•´ì„œ',0),(300296,8342,'he','×™×¦×™×¨×ª ×¡×“×¨ ×¢×‘×•×¨',0),(300297,8342,'el','Î”Î¹Î±Ï„Î±Î³Î®Ï‚ Î³Î¹Î±',0),(300298,8342,'zh','åˆ›å»ºè®¢è´­\r\n',0),(300299,8342,'sv','Att skapa ordning fÃ¶r',0),(300300,8342,'it','Creazione ordine per',0),(300301,8342,'tl','',0),(300302,8342,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(300303,8342,'hi','à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶',0),(300304,8342,'ms','Membuat perintah bagi',0),(300305,8342,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ø¹Ù„Ù‰',0),(300306,8342,'fr','CrÃ©ation d\'ordre pour',0),(300307,8342,'jp','æ³¨æ–‡ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(300308,8342,'pt','CriaÃ§Ã£o de ordem de',0),(300309,8342,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð—Ð°ÐºÐ°Ð·Ð° Ð´Ð»Ñ',0),(300310,8342,'es','Crear Pedido para',0),(300311,8342,'de','EinfÃ¼hrung',0),(300312,8342,'en','Creating Order for',0),(300313,8343,'is','',0),(300314,8343,'dr','ÙƒØ¯ ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(300315,8343,'pr','ÙƒØ¯ ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´',0),(300316,8343,'tr','SipariÅŸ iÃ§in madde kodu',0),(300317,8343,'pl','Kod towaru dla zamÃ³wienia',0),(300318,8343,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(300319,8343,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ø´Û’ Ø¶Ø§Ø¨Ø·Û',0),(300320,8343,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð·Ð° Ð½Ð°Ð»Ð¾Ð³',0),(300321,8343,'vi','MÃ£ hÃ ng Ä‘á»ƒ Ä‘áº·t hÃ ng',0),(300322,8343,'af','Itemkode vir Bestelling',0),(300323,8343,'ro','Cod articol pentru comanda',0),(300324,8343,'et','Kaubakood tellimuse',0),(300325,8343,'si','Å ifra artikla za nalog',0),(300326,8343,'ba','Kode barang untuk Order',0),(300327,8343,'nl','Artikelcode voor Order',0),(300328,8343,'fi','Nimikkeen koodi jotta',0),(300329,8343,'no','Varekode for ordre',0),(300330,8343,'da','Varekoden for ordre',0),(300331,8343,'ko','ì£¼ë¬¸ í•­ëª© ì½”ë“œ',0),(300332,8343,'he','×§×•×“ ×¤×¨×™×˜ ×œ×”×–×ž× ×”',0),(300333,8343,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(300334,8343,'zh','äº§å“ç¼–å·ä¸ºè®¢å•\r\n',0),(300335,8343,'sv','Artikelkod fÃ¶r bestÃ¤llning',0),(300336,8343,'it','Codice articolo per ordine',0),(300337,8343,'tl','',0),(300338,8343,'th','&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(300339,8343,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡',0),(300340,8343,'ms','Kod item untuk Tempahan',0),(300341,8343,'ar','ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù Ù„Ø£Ù…Ø±',0),(300342,8343,'fr','Code article pour commander',0),(300343,8343,'jp','æ³¨æ–‡ã®å•†å“ã‚³ãƒ¼ãƒ‰',0),(300344,8343,'pt','CÃ³digo do item para a ordem',0),(300345,8343,'ru','ÐšÐ¾Ð´ Ð¢Ð¾Ð²Ð°Ñ€Ð° Ð”Ð»Ñ Ð—Ð°ÐºÐ°Ð·Ð°',0),(300346,8343,'es','Item CÃ³digo para Orden',0),(300347,8343,'de','Artikelcode fÃ¼r Bestellung',0),(300348,8343,'en','Item Code for Order',0),(300349,8344,'is','',0),(300350,8344,'dr','Ù…ÙƒØ§Ù† Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„  Ø§Ø² ',0),(300351,8344,'pr','Ù…ÙƒØ§Ù† Ø¨Ø±Ø§ÙŠ Ø­Ù…Ù„  Ø§Ø² ',0),(300352,8344,'tr','Kimden sevk yeri',0),(300353,8344,'pl','Lokalizacja do statku od',0),(300354,8344,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð° Ð¾Ñ‚',0),(300355,8344,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø³Û’ Ø¬ÛØ§Ø² ØªÚ©',0),(300356,8344,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ Ð¤Ð ÐžÐœ',0),(300357,8344,'vi','Äá»‹a chá»‰ váº­n chuyá»ƒn tá»«',0),(300358,8344,'af','Plek WAARVANDAAN moet versend',0),(300359,8344,'ro','LocaÅ£ie pentru a navei la',0),(300360,8344,'et','Asukohta laeva saatja',0),(300361,8344,'si','Mesto na ladji od',0),(300362,8344,'ba','Lokasi untuk kapal dari',0),(300363,8344,'nl','Locatie voor het verzenden van',0),(300364,8344,'fi','Sijainti alusta alkaen',0),(300365,8344,'no','Sted sende fra',0),(300366,8344,'da','Placering til skibet fra',0),(300367,8344,'ko','ìš°ì£¼ì„ ì—ì„œ ìœ„ì¹˜',0),(300368,8344,'he','×ž×™×§×•× ×”×¡×¤×™× ×” ×ž',0),(300369,8344,'el','Î˜Î­ÏƒÎ· Î½Î± Ï€Î»Î¿Î¯Î¿ Î±Ï€ÏŒ',0),(300370,8344,'zh','å‘è´§ä½ç½®\r\n',0),(300371,8344,'sv','LÃ¤ge att fartyget frÃ¥n',0),(300372,8344,'it','Posizione di spedire da',0),(300373,8344,'tl','',0),(300374,8344,'th','&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3586;&#3609;&#3626;&#3656;&#3591; ',0),(300375,8344,'hi','à¤ªà¥à¤°à¥‡à¤·à¤• à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¥à¤¾à¤¨',0),(300376,8344,'ms','Lokasi kapal daripada',0),(300377,8344,'ar','Ù…ÙˆÙ‚Ø¹ Ù„Ø´Ø­Ù†',0),(300378,8344,'fr','Emplacement d\'expÃ©dier de',0),(300379,8344,'jp','FROM ã‚’å‡ºè·ã™ã‚‹å ´æ‰€',0),(300380,8344,'pt','LocalizaÃ§Ã£o de navio de',0),(300381,8344,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ ÑÑƒÐ´Ð½Ð° Ð¾Ñ‚',0),(300382,8344,'es','UbicaciÃ³n DE DONDE Enviar',0),(300383,8344,'de','Lage vom Schiff',0),(300384,8344,'en','Location to ship FROM',0),(300385,8345,'is','',0),(300386,8345,'dr','Ø´Ø±Ø­ ÙƒØ§Ù„Ø§ÙŠ Ù…Ø§',0),(300387,8345,'pr','Ø´Ø±Ø­ ÙƒØ§Ù„Ø§ÙŠ Ù…Ø§',0),(300388,8345,'tr','Bizim madde aÃ§Ä±klamasÄ±',0),(300389,8345,'pl','Nasz opis przedmiotu',0),(300390,8345,'bg','ÐÐ°ÑˆÐµÑ‚Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(300391,8345,'ur','ÛÙ…Ø§Ø±Û’ Ø´Û’ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(300392,8345,'sr','ÐÐ°Ð¼ Ð¾Ð¿Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(300393,8345,'vi','MÃ´ táº£ hÃ ng cá»§a chÃºng tÃ´i',0),(300394,8345,'af','Ons Item Beskrywing',0),(300395,8345,'ro','Descriere noastre',0),(300396,8345,'et','Meie kauba kirjeldus',0),(300397,8345,'si','NaÅ¡ opis elementa',0),(300398,8345,'ba','Deskripsi Item kami',0),(300399,8345,'nl','Onze objectbeschrijving',0),(300400,8345,'fi','Nimikkeen kuvaus',0),(300401,8345,'no','VÃ¥re varebeskrivelsen',0),(300402,8345,'da','Vores varebeskrivelse',0),(300403,8345,'ko','ìš°ë¦¬ì˜ í•­ëª© ì„¤ëª…',0),(300404,8345,'he','×ª×™××•×¨ ×¤×¨×™×˜ ×©×œ× ×•',0),(300405,8345,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î¼Î±Ï‚',0),(300406,8345,'zh','æˆ‘ä»¬çš„é¡¹ç›®è¯´æ˜Ž\r\n',0),(300407,8345,'sv','VÃ¥ra objektbeskrivning',0),(300408,8345,'it','Il nostro articolo Descrizione',0),(300409,8345,'tl','',0),(300410,8345,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3614;&#3623;&#3585;&#3648;&#3619;&#3634;',0),(300411,8345,'hi','à¤¹à¤®à¤¾à¤°à¥‡ à¤®à¤¦ à¤µà¤¿à¤µà¤°à¤£',0),(300412,8345,'ms','Keterangan Item kami',0),(300413,8345,'ar','Ù„Ø¯ÙŠÙ†Ø§ ÙˆØµÙ Ø§Ù„ØµÙ†Ù',0),(300414,8345,'fr','Notre Description de l\'objet',0),(300415,8345,'jp','ç§é”ã®é …ç›®ã®èª¬æ˜Ž',0),(300416,8345,'pt','Nossa descriÃ§Ã£o do Item',0),(300417,8345,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐÐ°ÑˆÐµÐ³Ð¾ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(300418,8345,'es','Nuestra DescripciÃ³n de Item',0),(300419,8345,'de','Unsere Artikelbeschreibung',0),(300420,8345,'en','Our Item Description',0),(300421,8346,'is','',0),(300422,8346,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ ',0),(300423,8346,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ ',0),(300424,8346,'tr','SipariÅŸ oluÅŸtur',0),(300425,8346,'pl','Tworzenie zamÃ³wienia',0),(300426,8346,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(300427,8346,'ur','Ù†Ø¸Ù… ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(300428,8346,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(300429,8346,'vi','Táº¡o Ä‘Æ¡n Ä‘áº·t hÃ ng  má»›i',0),(300430,8346,'af','Skep Bestelling',0),(300431,8346,'ro','CreaÅ£i comanda',0),(300432,8346,'et','Tellimuse loomine',0),(300433,8346,'si','Ustvari nalog',0),(300434,8346,'ba','Membuat Order',0),(300435,8346,'nl','Order maken',0),(300436,8346,'fi','Luo tilaus',0),(300437,8346,'no','Opprette ordre',0),(300438,8346,'da','Opret ordre',0),(300439,8346,'ko','ì£¼ë¬¸',0),(300440,8346,'he','×¦×•×¨ ×”×–×ž× ×ª',0),(300441,8346,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(300442,8346,'zh','åˆ›å»ºè®¢å•\r\n',0),(300443,8346,'sv','Skapa Order',0),(300444,8346,'it','Creare ordine',0),(300445,8346,'tl','',0),(300446,8346,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(300447,8346,'hi','à¤‘à¤°à¥à¤¡à¤° à¤¬à¤¨à¤¾à¤à¤',0),(300448,8346,'ms','Mencipta pesanan',0),(300449,8346,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø±',0),(300450,8346,'fr','CrÃ©er l\'ordre',0),(300451,8346,'jp','æ³¨æ–‡ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(300452,8346,'pt','Criar ordem',0),(300453,8346,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·',0),(300454,8346,'es','Crear Pedido',0),(300455,8346,'de','Ordnung schaffen',0),(300456,8346,'en','Create Order',0),(300457,8347,'is','',0),(300458,8347,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ú†Ù‡ Ø´Ø±ÙƒØªÙŠ ',0),(300459,8347,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ú†Ù‡ Ø´Ø±ÙƒØªÙŠ ',0),(300460,8347,'tr','Hangi ÅŸirket iÃ§in sipariÅŸ oluÅŸtur',0),(300461,8347,'pl','Tworzenie zamÃ³wienia na co firma',0),(300462,8347,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÐºÐ¾Ñ Ñ„Ð¸Ñ€Ð¼Ð°',0),(300463,8347,'ur','Ø¬Ùˆ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø¢Ø±ÚˆØ± Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(300464,8347,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÐºÐ¾Ñ˜Ñƒ Ñ„Ð¸Ñ€Ð¼Ñƒ',0),(300465,8347,'vi','Táº¡o Ä‘Æ¡n Ä‘áº·t hÃ ng cho cty nÃ o',0),(300466,8347,'af','Skep Bestelling vir Watter Onderneming',0),(300467,8347,'ro','Pentru ca ceea ce compania a crea',0),(300468,8347,'et','Selleks, et mis firma loomine',0),(300469,8347,'si','Ustvari nalog, za katere podjetje',0),(300470,8347,'ba','Buat agar apa yang perusahaan',0),(300471,8347,'nl','Order voor welk bedrijf maken',0),(300472,8347,'fi','Luo tilaus mitÃ¤ yritys',0),(300473,8347,'no','Opprette ordre for hva selskapet',0),(300474,8347,'da','Opret ordre for hvad virksomheden',0),(300475,8347,'ko','ì–´ë–¤ íšŒì‚¬ì— ëŒ€ í•œ ì£¼ë¬¸',0),(300476,8347,'he','×¦×•×¨ ×”×–×ž× ×ª ×¢×‘×•×¨ ××™×–×• ×—×‘×¨×”',0),(300477,8347,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÎ½Ï„Î¿Î»Î®Ï‚ Î³Î¹Î± Ï„Î¿ Ï€Î¿Î¹Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(300478,8347,'zh','åˆ›å»ºä»€ä¹ˆå…¬å¸çš„è®¢å•\r\n',0),(300479,8347,'sv','Skapa Order fÃ¶r vad fÃ¶retaget',0),(300480,8347,'it','Creare ordine per quale compagnia',0),(300481,8347,'tl','',0),(300482,8347,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3657;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3629;&#3618;&#3656;&#3634;&#3591;&#3652;&#3619;',0),(300483,8347,'hi','à¤•à¥à¤¯à¤¾ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤‘à¤°à¥à¤¡à¤° à¤¬à¤¨à¤¾à¤à¤',0),(300484,8347,'ms','Membuat perintah bagi syarikat apa',0),(300485,8347,'ar','Ø¥Ù†Ø´Ø§Ø¡ ØªØ±ØªÙŠØ¨ Ù„Ù…Ø§ Ø§Ù„Ø´Ø±ÙƒØ©',0),(300486,8347,'fr','CrÃ©er pour quelle entreprise',0),(300487,8347,'jp','ã©ã®ã‚ˆã†ãªä¼šç¤¾ã®ãŸã‚ã®æ³¨æ–‡ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(300488,8347,'pt','Criar ordem para que empresa',0),(300489,8347,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð· Ð´Ð»Ñ ÐšÐ°ÐºÐ¾Ð¹ Ð¤Ð¸Ñ€Ð¼Ñ‹',0),(300490,8347,'es','Crear Pedido para Cual Empresa',0),(300491,8347,'de','Auftrag fÃ¼r welche Unternehmen erstellen',0),(300492,8347,'en','Create Order for What Company',0),(300493,8348,'is','',0),(300494,8348,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯Ø§Ø®Ù„ÙŠ  Ø´Ø±ÙƒØª',0),(300495,8348,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯Ø§Ø®Ù„ÙŠ  Ø´Ø±ÙƒØª',0),(300496,8348,'tr','ÅžirketlerarasÄ± transferler iÃ§in',0),(300497,8348,'pl','W przypadku przeniesieÅ„ miÄ™dzyfirmowych',0),(300498,8348,'bg','Ð—Ð° Ð¼ÐµÐ¶Ð´ÑƒÑ„Ð¸Ñ€Ð¼ÐµÐ½Ð¸ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(300499,8348,'ur','Ø§Ù†Ù¹Ø±Ú©ÙˆÙ…Ù¾Ù†ÛŒ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©Û’ Ù„Ø¦Û’',0),(300500,8348,'sr','Ð—Ð° Ð¼ÐµÑ’ÑƒÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜ÑÐºÐµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ.',0),(300501,8348,'vi','DÃ nh cho giao dá»‹ch ná»™i bá»™',0),(300502,8348,'af','Vir Intercompany oordrag',0),(300503,8348,'ro','Pentru transferuri inter-companii',0),(300504,8348,'et','Kontsernisisese Ã¼lekande',0),(300505,8348,'si','Za medpodjetniÅ¡ki transferji',0),(300506,8348,'ba','Untuk transfer antar',0),(300507,8348,'nl','Voor IC-overdrachten',0),(300508,8348,'fi','Siirtoja',0),(300509,8348,'no','For konserninterne overfÃ¸ringer',0),(300510,8348,'da','Ved interne overfÃ¸rsler',0),(300511,8348,'ko','íšŒì‚¬ ê°„ ì „ì†¡ì— ëŒ€ í•œ',0),(300512,8348,'he','×”×¢×‘×¨×•×ª ×‘×™×Ÿ-×—×‘×¨×ª×™×•×ª',0),(300513,8348,'el','Î“Î¹Î± Ï„Î¹Ï‚ Î´Î¹ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ­Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Ï‚',0),(300514,8348,'zh','å¯¹äºŽå…¬å¸é—´è½¬ç§»\r\n',0),(300515,8348,'sv','FÃ¶r koncerninterna Ã¶verfÃ¶ringar',0),(300516,8348,'it','Per i trasferimenti infragruppo',0),(300517,8348,'tl','',0),(300518,8348,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3619;&#3632;&#3627;&#3623;&#3656;&#3634;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(300519,8348,'hi','Intercompany à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤',0),(300520,8348,'ms','Untuk pemindahan antara Syarikat',0),(300521,8348,'ar','Ù„Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª Ø¨ÙŠÙ† Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø´Ù‚ÙŠÙ‚Ø©',0),(300522,8348,'fr','Pour les transferts intersociÃ©tÃ©s',0),(300523,8348,'jp','ä¼šç¤¾é–“è»¢é€',0),(300524,8348,'pt','Para transferÃªncias entre empresas coligadas',0),(300525,8348,'ru','Ð”Ð»Ñ Ð²Ð½ÑƒÑ‚Ñ€Ð¸Ñ…Ð¾Ð»Ð´Ð¸Ð½Ð³Ð¾Ð²Ñ‹Ñ… Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¾Ðº',0),(300526,8348,'es','Para Transferencias Interempresas',0),(300527,8348,'de','Bei konzerninternen Ãœberweisungen',0),(300528,8348,'en','For Intercompany Transfers',0),(300529,8349,'is','',0),(300530,8349,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(300531,8349,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(300532,8349,'tr','Amt.Invoices',0),(300533,8349,'pl','Amt.Invoices',0),(300534,8349,'bg','Amt.Invoices',0),(300535,8349,'ur','Amt.Invoices',0),(300536,8349,'sr','ÐÐ¼Ñ‚.Ð˜Ð½Ð²Ð¾Ð¸Ñ†ÐµÑ',0),(300537,8349,'vi','Sá»‘ Tiá»n TrÃªn HÃ³a ÄÆ¡n',0),(300538,8349,'af','Fakture Bedrag',0),(300539,8349,'ro','Amt.Invoices',0),(300540,8349,'et','Arvete kogus',0),(300541,8349,'si','Amt.Invoices',0),(300542,8349,'ba','Amt.Invoices',0),(300543,8349,'nl','Amt.Invoices',0),(300544,8349,'fi','Amt.Invoices',0),(300545,8349,'no','Amt.Invoices',0),(300546,8349,'da','Amt.Invoices',0),(300547,8349,'ko','Amt.Invoices',0),(300548,8349,'he','Amt.Invoices',0),(300549,8349,'el','Amt.Invoices',0),(300550,8349,'zh','å‘ç¥¨é‡‘é¢\r\n',0),(300551,8349,'sv','Amt.Invoices',0),(300552,8349,'it','Amt.Invoices',0),(300553,8349,'tl','',0),(300554,8349,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3651;&#3610;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;',0),(300555,8349,'hi','Amt.Invoices',0),(300556,8349,'ms','Amt.Invoices',0),(300557,8349,'ar','Amt.Invoices',0),(300558,8349,'fr','Amt.Invoices',0),(300559,8349,'jp','Amt.Invoices',0),(300560,8349,'pt','Amt.Invoices',0),(300561,8349,'ru','Amt.Invoices',0),(300562,8349,'es','Monto de Facturas',0),(300563,8349,'de','Amt.Invoices',0),(300564,8349,'en','Amt.Invoices',0),(300565,8350,'is','',0),(300566,8350,'dr','ØªØ¹Ø¯Ø§Ø¯ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(300567,8350,'pr','ØªØ¹Ø¯Ø§Ø¯ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(300568,8350,'tr','# Faturalar',0),(300569,8350,'pl','# Faktur',0),(300570,8350,'bg','# Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(300571,8350,'ur','# ÙˆØ¨Ø¬Ù„ÛŒ',0),(300572,8350,'sr','# Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(300573,8350,'vi','Sá»‘ hÃ³a Ä‘Æ¡n',0),(300574,8350,'af','# Fakture',0),(300575,8350,'ro','# Facturi',0),(300576,8350,'et','# Arved',0),(300577,8350,'si','# RaÄunov',0),(300578,8350,'ba','# Faktur',0),(300579,8350,'nl','# Facturen',0),(300580,8350,'fi','# Laskut',0),(300581,8350,'no','# Fakturaer',0),(300582,8350,'da','# Fakturaer',0),(300583,8350,'ko','# ì†¡ìž¥',0),(300584,8350,'he','# ×—×©×‘×•× ×™×•×ª',0),(300585,8350,'el','# Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(300586,8350,'zh','ï¼ƒå‘ç¥¨\r\n',0),(300587,8350,'sv','# Fakturor',0),(300588,8350,'it','# Fatture',0),(300589,8350,'tl','',0),(300590,8350,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(300591,8350,'hi','# à¤šà¤¾à¤²à¤¾à¤¨',0),(300592,8350,'ms','# Invois',0),(300593,8350,'ar','Ø¹Ø¯Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(300594,8350,'fr','# Factures',0),(300595,8350,'jp','# è«‹æ±‚æ›¸',0),(300596,8350,'pt','# Facturas',0),(300597,8350,'ru','# Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(300598,8350,'es','# Facturas',0),(300599,8350,'de','-Rechnungen',0),(300600,8350,'en','# Invoices',0),(300601,8351,'is','',0),(300602,8351,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø±ÙˆØ²Ø§Ù†Ù‡ ØªØªÙ…Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ ',0),(300603,8351,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø±ÙˆØ²Ø§Ù†Ù‡ ØªØªÙ…Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ ',0),(300604,8351,'tr','Bakiye gÃ¼nlÃ¼k rapor',0),(300605,8351,'pl','Dzienny raport sald',0),(300606,8351,'bg','Ð”Ð½ÐµÐ²ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð½Ð° ÑÐ°Ð»Ð´Ð°Ñ‚Ð°',0),(300607,8351,'ur','Ø¨ÛŒÙ„Ù†Ø³ Ú©ÛŒ Ø±ÙˆØ² Ù…Ø±Û Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(300608,8351,'sr','Ð”Ð½ÐµÐ²Ð½Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÑÐ°Ð»Ð´Ð°',0),(300609,8351,'vi','Báº£ng cÃ¢ Ä‘á»‘i ngÃ y',0),(300610,8351,'af','Daaglikse Verslag van Balanse',0),(300611,8351,'ro','Raport zilnic de solduri',0),(300612,8351,'et','PÃ¤evane saldode aruanne',0),(300613,8351,'si','Dnevno poroÄilo bilanc',0),(300614,8351,'ba','Laporan harian saldo',0),(300615,8351,'nl','Dagelijks rapport van de saldi',0),(300616,8351,'fi','PÃ¤ivittÃ¤inen raportti saldoista',0),(300617,8351,'no','Daglig rapport for saldoer',0),(300618,8351,'da','Daglig rapport af saldi',0),(300619,8351,'ko','ê· í˜•ì˜ ì¼ì¼ ë³´ê³ ì„œ',0),(300620,8351,'he','×“×•×— ×™×•×ž×™ ×©×œ ×ž××–× ×™×',0),(300621,8351,'el','Î—Î¼ÎµÏÎ®ÏƒÎ¹Î± Î±Î½Î±Ï†Î¿ÏÎ¬ Ï„Ï‰Î½ Ï…Ï€Î¿Î»Î¿Î¯Ï€Ï‰Î½',0),(300622,8351,'zh','æ¯æ—¥æŠ¥å‘Šç»“ä½™\r\n',0),(300623,8351,'sv','Daglig rapport av saldon',0),(300624,8351,'it','Report giornaliero dei saldi',0),(300625,8351,'tl','',0),(300626,8351,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3618;&#3629;&#3604;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3611;&#3619;&#3632;&#3592;&#3635;&#3623;&#3633;&#3609;',0),(300627,8351,'hi','à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤¦à¥ˆà¤¨à¤¿à¤• à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(300628,8351,'ms','Laporan harian baki-baki',0),(300629,8351,'ar','Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„ÙŠÙˆÙ…ÙŠ Ù„Ø£Ø±ØµØ¯Ø©',0),(300630,8351,'fr','Rapport quotidien des soldes',0),(300631,8351,'jp','æ®‹é«˜ã®ãƒ‡ã‚¤ãƒªãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆ',0),(300632,8351,'pt','RelatÃ³rio diÃ¡rio dos saldos',0),(300633,8351,'ru','Ð•Ð¶ÐµÐ´Ð½ÐµÐ²Ð½Ñ‹Ð¹ Ð‘Ð°Ð»Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ ÐžÑ‚Ñ‡ÐµÑ‚',0),(300634,8351,'es','Informe Diario de Balances',0),(300635,8351,'de','Tagesbericht der Salden',0),(300636,8351,'en','Daily Report of Balances',0),(300637,8352,'is','',0),(300638,8352,'dr','Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯ÙŠ ÙˆØ±ÙˆØ¯ Ù†Ø§Ø¸Ø±',0),(300639,8352,'pr','Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯ÙŠ ÙˆØ±ÙˆØ¯ Ù†Ø§Ø¸Ø±',0),(300640,8352,'tr','API gÃ¼nlÃ¼k gÃ¶rÃ¼ntÃ¼leyici',0),(300641,8352,'pl','PodglÄ…d dziennika interfejsu API',0),(300642,8352,'bg','API Ð²Ñ…Ð¾Ð´ Viewer',0),(300643,8352,'ur','API Ù„Ø§Ú¯ Ù…Ù†Ø¸Ø± Ú©Ø§Ø±',0),(300644,8352,'sr','ÐÐŸÐ˜ Ð›Ð¾Ð³ Ð’Ð¸ÐµwÐµÑ€',0),(300645,8352,'vi','Xem Nháº­t KÃ½ API',0),(300646,8352,'af','API Log Besigtiger',0),(300647,8352,'ro','API Log Viewer',0),(300648,8352,'et','API vaataja',0),(300649,8352,'si','API poleno gledalec',0),(300650,8352,'ba','Penampil API Log',0),(300651,8352,'nl','API inhoud van logboeken weergeven',0),(300652,8352,'fi','API-loki',0),(300653,8352,'no','API stokk seer',0),(300654,8352,'da','API Log Viewer',0),(300655,8352,'ko','API ë¡œê·¸ ë·°ì–´',0),(300656,8352,'he','×ž×¦×™×’ API ×™×•×ž×Ÿ',0),(300657,8352,'el','Î˜ÎµÎ±Ï„Î® ÎºÎ¿ÏÏ„ÏƒÎ¿Ï…ÏÏ‰Î½ API',0),(300658,8352,'zh','åº”ç”¨ç¨‹åºæŽ¥å£æ—¥å¿—æŸ¥çœ‹å™¨\r\n',0),(300659,8352,'sv','API Log Viewer',0),(300660,8352,'it','API Log Viewer',0),(300661,8352,'tl','',0),(300662,8352,'th','&#3612;&#3641;&#3657;&#3604;&#3641;&#3585;&#3634;&#3619;&#3648;&#3585;&#3655;&#3610;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609; API ',0),(300663,8352,'hi','API à¤²à¥‰à¤— Viewer',0),(300664,8352,'ms','Pemapar API Log',0),(300665,8352,'ar','Ø¹Ø§Ø±Ø¶ Ø³Ø¬Ù„ API',0),(300666,8352,'fr','Visionneuse du journal de l\'API',0),(300667,8352,'jp','API ãƒ­ã‚° ãƒ“ãƒ¥ãƒ¼ã‚¢ãƒ¼',0),(300668,8352,'pt','Visualizador de Log de API',0),(300669,8352,'ru','Ð¡Ñ€ÐµÐ´ÑÑ‚Ð²Ð¾ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð¶ÑƒÑ€Ð½Ð°Ð»Ð° API',0),(300670,8352,'es','Vizualizador de BitÃ¡cora API',0),(300671,8352,'de','API-Protokoll-Viewer',0),(300672,8352,'en','API Log Viewer',0),(300673,8353,'is','',0),(300674,8353,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø´Ø±ÙƒØª ',0),(300675,8353,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø´Ø±ÙƒØª ',0),(300676,8353,'tr','Åžirket kimliÄŸi',0),(300677,8353,'pl','Regon',0),(300678,8353,'bg','Ð¤Ð¸Ñ€Ð¼ÐµÐ½ Ð˜Ð”',0),(300679,8353,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(300680,8353,'sr','ÐœÐ°Ñ‚Ð¸Ñ‡Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(300681,8353,'vi','ID Cty',0),(300682,8353,'af','Onderneming ID',0),(300683,8353,'ro','ID companie',0),(300684,8353,'et','EttevÃµtte ID',0),(300685,8353,'si','DruÅ¾ba ID',0),(300686,8353,'ba','Perusahaan ID',0),(300687,8353,'nl','Bedrijfs-ID',0),(300688,8353,'fi','Yrityksen tunnus',0),(300689,8353,'no','Firma-ID',0),(300690,8353,'da','Firma-ID',0),(300691,8353,'ko','íšŒì‚¬ ID',0),(300692,8353,'he','×ž×–×”×” ×—×‘×¨×”',0),(300693,8353,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± ID',0),(300694,8353,'zh','å…¬å¸ID\r\n',0),(300695,8353,'sv','FÃ¶retags-ID',0),(300696,8353,'it','ID azienda',0),(300697,8353,'tl','',0),(300698,8353,'th','&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3592;&#3635;&#3605;&#3633;&#3623;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(300699,8353,'hi','à¤•à¤‚à¤ªà¤¨à¥€ ID',0),(300700,8353,'ms','ID Syarikat',0),(300701,8353,'ar','Ù…Ø¹Ø±Ù‘Ù Ø§Ù„Ø´Ø±ÙƒØ©',0),(300702,8353,'fr','ID de l\'entreprise',0),(300703,8353,'jp','ä¼šç¤¾ ID',0),(300704,8353,'pt','Empresa ID',0),(300705,8353,'ru','ID ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(300706,8353,'es','Empresa ID',0),(300707,8353,'de','Firmenkennung',0),(300708,8353,'en','Company ID',0),(300709,8354,'is','',0),(300710,8354,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø± ',0),(300711,8354,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø± ',0),(300712,8354,'tr','KullanÄ±cÄ± kimliÄŸi',0),(300713,8354,'pl','Identyfikator uÅ¼ytkownika',0),(300714,8354,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(300715,8354,'ur','ØµØ§Ø±Ù Ú©ÛŒ Ø¢Ø¦ÛŒ ÚˆÛŒ',0),(300716,8354,'sr','Ð˜Ð” ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(300717,8354,'vi','ID NgÆ°á»i Sá»­ Dá»¥ng',0),(300718,8354,'af','Gebruiker ID',0),(300719,8354,'ro','ID utilizator',0),(300720,8354,'et','Kasutaja ID',0),(300721,8354,'si','ID uporabnika',0),(300722,8354,'ba','ID pengguna',0),(300723,8354,'nl','Gebruikers ID\r\n',0),(300724,8354,'fi','KÃ¤yttÃ¤jÃ¤tunnus',0),(300725,8354,'no','Bruker-ID',0),(300726,8354,'da','Bruger-ID',0),(300727,8354,'ko','ì‚¬ìš©ìž ID',0),(300728,8354,'he','×ž×–×”×” ×”×ž×©×ª×ž×©',0),(300729,8354,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï‡ÏÎ®ÏƒÏ„Î·',0),(300730,8354,'zh','ç”¨æˆ·èº«ä»½è¯\r\n',0),(300731,8354,'sv','AnvÃ¤ndar-ID',0),(300732,8354,'it','ID utente',0),(300733,8354,'tl','',0),(300734,8354,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(300735,8354,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ ID',0),(300736,8354,'ms','ID pengguna',0),(300737,8354,'ar','Ù…Ø¹Ø±Ù‘Ù Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(300738,8354,'fr','ID de l\'utilisateur',0),(300739,8354,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ ID',0),(300740,8354,'pt','ID de usuÃ¡rio',0),(300741,8354,'ru','ID ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(300742,8354,'es','Usuario ID',0),(300743,8354,'de','Benutzer-ID',0),(300744,8354,'en','User ID',0),(300745,8355,'is','',0),(300746,8355,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¯Ø± ',0),(300747,8355,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¯Ø± ',0),(300748,8355,'tr','Verileri',0),(300749,8355,'pl','Danych w',0),(300750,8355,'bg','Ð”Ð°Ð½Ð½Ð¸Ñ‚Ðµ Ð²',0),(300751,8355,'ur','Ù…ÛŒÚº Ú©ÙˆØ§Ø¦Ù',0),(300752,8355,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸ Ñƒ',0),(300753,8355,'vi','Dá»¯ liá»‡u vÃ o',0),(300754,8355,'af','Data In',0),(300755,8355,'ro','Date Ã®n',0),(300756,8355,'et','Andmete',0),(300757,8355,'si','Podatkov v',0),(300758,8355,'ba','Data dalam',0),(300759,8355,'nl','Gegevens In',0),(300760,8355,'fi','Tiedot',0),(300761,8355,'no','Data i',0),(300762,8355,'da','Data i',0),(300763,8355,'ko','ë°ì´í„°ì—',0),(300764,8355,'he','× ×ª×•× ×™×',0),(300765,8355,'el','Î”ÎµÎ´Î¿Î¼Î­Î½Î± ÏƒÎµ',0),(300766,8355,'zh','æ•°æ®è¾“å…¥\r\n',0),(300767,8355,'sv','Data i',0),(300768,8355,'it','Dati In',0),(300769,8355,'tl','',0),(300770,8355,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3586;&#3657;&#3634;',0),(300771,8355,'hi','à¤®à¥‡à¤‚ à¤¡à¥‡à¤Ÿà¤¾',0),(300772,8355,'ms','Data dalam',0),(300773,8355,'ar','Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ÙÙŠ',0),(300774,8355,'fr','DonnÃ©es dans',0),(300775,8355,'jp','å†…ã®ãƒ‡ãƒ¼ã‚¿',0),(300776,8355,'pt','Dados em',0),(300777,8355,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ Ð²',0),(300778,8355,'es','Datos Ingresar',0),(300779,8355,'de','Daten In',0),(300780,8355,'en','Data In',0),(300781,8356,'is','',0),(300782,8356,'dr','Ø®Ø±ÙˆØ¬ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(300783,8356,'pr','Ø®Ø±ÙˆØ¬ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(300784,8356,'tr','Veri Ã§Ä±kÄ±ÅŸÄ±',0),(300785,8356,'pl','Dane',0),(300786,8356,'bg','Ð”Ð°Ð½Ð½Ð¸',0),(300787,8356,'ur','Ú©ÙˆØ§Ø¦Ù Ø¢Ø¤Ù¹',0),(300788,8356,'sr','ÐŸÐ¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñƒ',0),(300789,8356,'vi','Dá»¯ liá»‡u ra',0),(300790,8356,'af','Data Uit',0),(300791,8356,'ro','Data de iesire',0),(300792,8356,'et','Andmeid lÃ¤bi',0),(300793,8356,'si','Podatkov',0),(300794,8356,'ba','Data keluar',0),(300795,8356,'nl','Gegevens uit',0),(300796,8356,'fi','Tietojen',0),(300797,8356,'no','Data',0),(300798,8356,'da','Data ud',0),(300799,8356,'ko','ë°ì´í„° ì¶œë ¥',0),(300800,8356,'he','× ×ª×•× ×™×.',0),(300801,8356,'el','Î¤Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î­Î¾Ï‰',0),(300802,8356,'zh','æ•°æ®è¾“å‡º\r\n',0),(300803,8356,'sv','Data ut',0),(300804,8356,'it','Dati fuori',0),(300805,8356,'tl','',0),(300806,8356,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3629;&#3629;&#3585;',0),(300807,8356,'hi','à¤¬à¤¾à¤¹à¤° à¤¡à¤¾à¤Ÿà¤¾',0),(300808,8356,'ms','Data Keluar',0),(300809,8356,'ar','Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø¨Ù‡Ø§',0),(300810,8356,'fr','Data Out',0),(300811,8356,'jp','ãƒ‡ãƒ¼ã‚¿å‡ºåŠ›',0),(300812,8356,'pt','Dados',0),(300813,8356,'ru','Ð˜Ð· Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(300814,8356,'es','Datos Salir',0),(300815,8356,'de','Datenausgang',0),(300816,8356,'en','Data Out',0),(300817,8357,'is','',0),(300818,8357,'dr','Ø§Ø®ÙŠØ± ',0),(300819,8357,'pr','Ø§Ø®ÙŠØ± ',0),(300820,8357,'tr','En son',0),(300821,8357,'pl','Najnowsze',0),(300822,8357,'bg','ÐÐ°Ð¹-Ð½Ð¾Ð²Ð¸Ñ‚Ðµ',0),(300823,8357,'ur','ØªØ§Ø²Û ØªØ±ÛŒÙ†',0),(300824,8357,'sr','ÐÐ°Ñ˜Ð½Ð¾Ð²Ð¸Ñ˜Ðµ',0),(300825,8357,'vi','Gáº§n nháº¥t',0),(300826,8357,'af','Mees Onlangs',0),(300827,8357,'ro','Cele mai recente',0),(300828,8357,'et','Viimati tehtud',0),(300829,8357,'si','NajnovejÅ¡i',0),(300830,8357,'ba','Pemesanan',0),(300831,8357,'nl','Meest recente',0),(300832,8357,'fi','Viimeisin',0),(300833,8357,'no','Siste',0),(300834,8357,'da','Seneste',0),(300835,8357,'ko','ê°€ìž¥ ìµœê·¼',0),(300836,8357,'he','×”×›×™ ××—×¨×•× ×™×',0),(300837,8357,'el','Î— Ï€Î¹Î¿ Ï€ÏÏŒÏƒÏ†Î±Ï„Î·',0),(300838,8357,'zh','æœ€æ–°\r\n',0),(300839,8357,'sv','Senaste',0),(300840,8357,'it','PiÃ¹ recenti',0),(300841,8357,'tl','',0),(300842,8357,'th','&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(300843,8357,'hi','à¤¸à¤¬à¤¸à¥‡ à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚',0),(300844,8357,'ms','Yang terkini',0),(300845,8357,'ar','Ø£Ø­Ø¯Ø«',0),(300846,8357,'fr','Plus rÃ©cent',0),(300847,8357,'jp','æœ€ã‚‚æœ€è¿‘',0),(300848,8357,'pt','Mais recentes',0),(300849,8357,'ru','Ð¡Ð°Ð¼Ñ‹Ðµ ÐÐµÐ´Ð°Ð²Ð½Ð¸Ðµ',0),(300850,8357,'es','MÃ¡s Reciente',0),(300851,8357,'de','Die letzten',0),(300852,8357,'en','Most Recent',0),(300853,8358,'is','',0),(300854,8358,'dr','Ø¨Ø¯ÙˆÙ† Ù…Ø§Ù„ÙŠØ§Øª',0),(300855,8358,'pr','Ø¨Ø¯ÙˆÙ† Ù…Ø§Ù„ÙŠØ§Øª',0),(300856,8358,'tr','Vergi',0),(300857,8358,'pl','Bez podatku',0),(300858,8358,'bg','Ð‘ÐµÐ· Ð´Ð°Ð½ÑŠÐº',0),(300859,8358,'ur','Ú©ÙˆØ¦ÛŒ Ù¹ÛŒÚ©Ø³',0),(300860,8358,'sr','Ð‘ÐµÐ· Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(300861,8358,'vi','KhÃ´ng thuáº¿',0),(300862,8358,'af','Geen Belasting',0),(300863,8358,'ro','Nici un impozit',0),(300864,8358,'et','Mingit maksu',0),(300865,8358,'si','Brez davka',0),(300866,8358,'ba','Tidak ada pajak',0),(300867,8358,'nl','Geen belasting',0),(300868,8358,'fi','Ei veroa',0),(300869,8358,'no','Ingen skatt',0),(300870,8358,'da','Ingen skat',0),(300871,8358,'ko','ì„¸ê¸ˆë„ ì—†ê³ ',0),(300872,8358,'he','×œ×œ× ×ž×¡',0),(300873,8358,'el','ÎšÎ±Î½Î­Î½Î±Ï‚ Ï†ÏŒÏÎ¿Ï‚',0),(300874,8358,'zh','æ— ç¨Ž\r\n',0),(300875,8358,'sv','Ingen skatt',0),(300876,8358,'it','Nessuna imposta',0),(300877,8358,'tl','',0),(300878,8358,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3616;&#3634;&#3625;&#3637;',0),(300879,8358,'hi','à¤•à¥‹à¤ˆ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(300880,8358,'ms','Tiada cukai',0),(300881,8358,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¶Ø±Ø§Ø¦Ø¨',0),(300882,8358,'fr','Pas de taxe',0),(300883,8358,'jp','ãªã„ç¨Ž',0),(300884,8358,'pt','Nenhum imposto',0),(300885,8358,'ru','ÐÐµÑ‚ ÐÐ°Ð»Ð¾Ð³Ð°',0),(300886,8358,'es','No Impuestos',0),(300887,8358,'de','Keine Steuer',0),(300888,8358,'en','No Tax',0),(300889,8359,'is','',0),(300890,8359,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(300891,8359,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(300892,8359,'tr','SatÄ±cÄ±',0),(300893,8359,'pl','Dostawcy',0),(300894,8359,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(300895,8359,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û',0),(300896,8359,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(300897,8359,'vi','NgÆ°á»i bÃ¡n',0),(300898,8359,'af','Verskaffer',0),(300899,8359,'ro','Furnizor',0),(300900,8359,'et','Hankija',0),(300901,8359,'si','Dobavitelja',0),(300902,8359,'ba','Penjual',0),(300903,8359,'nl','Leverancier',0),(300904,8359,'fi','Toimittajan',0),(300905,8359,'no','LeverandÃ¸r',0),(300906,8359,'da','Kreditor',0),(300907,8359,'ko','ê³µê¸‰ ì—…ì²´',0),(300908,8359,'he','×”×¡×¤×§',0),(300909,8359,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(300910,8359,'zh','ä¾›åº”å•†\r\n',0),(300911,8359,'sv','LeverantÃ¶r',0),(300912,8359,'it','Fornitore',0),(300913,8359,'tl','',0),(300914,8359,'th','&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3627;&#3634;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(300915,8359,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(300916,8359,'ms','Penjual.',0),(300917,8359,'ar','Ø¨Ø§Ø¦Ø¹',0),(300918,8359,'fr','Fournisseur',0),(300919,8359,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼',0),(300920,8359,'pt','Fornecedor',0),(300921,8359,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº',0),(300922,8359,'es','Proveedor',0),(300923,8359,'de','Hersteller',0),(300924,8359,'en','Vendor',0),(300925,8360,'is','',0),(300926,8360,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø³Ù‡ Ù…Ø§Ù‡ ',0),(300927,8360,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø³Ù‡ Ù…Ø§Ù‡ ',0),(300928,8360,'tr','ÃœÃ§ aylÄ±k ortalama',0),(300929,8360,'pl','Kwartale Å›rednia',0),(300930,8360,'bg','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð» ÑÑ€ÐµÐ´Ð½Ð°',0),(300931,8360,'ur','Ø³Û Ù…Ø§ÛÛŒ Ø§ÙˆØ³Ø·',0),(300932,8360,'sr','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð» Ð¿Ñ€Ð¾ÑÐµÐºÐ°',0),(300933,8360,'vi','Trung bÃ¬nh quÃ½',0),(300934,8360,'af','Kwartaal Gemiddeld',0),(300935,8360,'ro','Cartierul medie',0),(300936,8360,'et','Kvartali keskmine',0),(300937,8360,'si','ÄŒetrt povpreÄjem',0),(300938,8360,'ba','Rata-rata Quarter',0),(300939,8360,'nl','Kwartaal-gemiddelde',0),(300940,8360,'fi','NeljÃ¤nneksellÃ¤ keskimÃ¤Ã¤rin',0),(300941,8360,'no','Kvartal gjennomsnitt',0),(300942,8360,'da','Kvartal gennemsnit',0),(300943,8360,'ko','ë¶„ê¸° í‰ê· ',0),(300944,8360,'he','×”×ž×ž×•×¦×¢ ×‘×¨×‘×¢×•×Ÿ',0),(300945,8360,'el','ÎœÎ­ÏƒÎ¿Ï‚ ÏŒÏÎ¿Ï‚ Ï„ÏÎ¹Î¼Î®Î½Î¿Ï…',0),(300946,8360,'zh','å­£å¹³å‡\r\n',0),(300947,8360,'sv','Kvartalet genomsnittet',0),(300948,8360,'it','Quarto media',0),(300949,8360,'tl','',0),(300950,8360,'th','&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3652;&#3605;&#3619;&#3617;&#3634;&#3626;',0),(300951,8360,'hi','à¤¤à¤¿à¤®à¤¾à¤¹à¥€ à¤”à¤¸à¤¤',0),(300952,8360,'ms','Purata suku tahun',0),(300953,8360,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„Ø±Ø¨Ø¹',0),(300954,8360,'fr','Trimestre moyenne',0),(300955,8360,'jp','å››åŠæœŸã®å¹³å‡',0),(300956,8360,'pt','MÃ©dia do trimestre',0),(300957,8360,'ru','Ð’ ÑÑ€ÐµÐ´Ð½ÐµÐ¼ Ñ‡ÐµÑ‚Ð²ÐµÑ€Ñ‚ÑŒ',0),(300958,8360,'es','Promedio Trimestral',0),(300959,8360,'de','Quartal durchschnittlich',0),(300960,8360,'en','Quarter Average',0),(300961,8361,'is','',0),(300962,8361,'dr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ ',0),(300963,8361,'pr','Ù‡ÙŠÚ† ÙØ¹Ø§Ù„ÙŠØªÙŠ ',0),(300964,8361,'tr','HiÃ§bir etkinlik',0),(300965,8361,'pl','Brak aktywnoÅ›ci',0),(300966,8361,'bg','ÐÑÐ¼Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(300967,8361,'ur','Ú©ÙˆØ¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(300968,8361,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(300969,8361,'vi','KhÃ´ng hoáº¡t Ä‘á»™ng',0),(300970,8361,'af','Geen Aktiwiteit',0),(300971,8361,'ro','Nici o activitate',0),(300972,8361,'et','Tegevusi pole',0),(300973,8361,'si','Ni dejavnost',0),(300974,8361,'ba','Tidak ada kegiatan',0),(300975,8361,'nl','Geen activiteit',0),(300976,8361,'fi','Ei toimintaa',0),(300977,8361,'no','Ingen aktivitet',0),(300978,8361,'da','Ingen aktivitet',0),(300979,8361,'ko','ìž‘ì—… ì—†ìŒ',0),(300980,8361,'he','××™×Ÿ ×¤×¢×™×œ×•×ª',0),(300981,8361,'el','ÎšÎ±Î¼Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(300982,8361,'zh','æ²¡æœ‰æ´»åŠ¨\r\n',0),(300983,8361,'sv','Ingen aktivitet',0),(300984,8361,'it','Nessuna attivitÃ ',0),(300985,8361,'tl','',0),(300986,8361,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;',0),(300987,8361,'hi','à¤•à¥‹à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(300988,8361,'ms','Tiada aktiviti',0),(300989,8361,'ar','Ù„Ø§ Ù†Ø´Ø§Ø·',0),(300990,8361,'fr','Aucune activitÃ©',0),(300991,8361,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(300992,8361,'pt','Nenhuma atividade',0),(300993,8361,'ru','ÐÐµÑ‚ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(300994,8361,'es','No Hay Actividad',0),(300995,8361,'de','Keine AktivitÃ¤t',0),(300996,8361,'en','No Activity',0),(300997,8362,'is','',0),(300998,8362,'dr','OBS Ú¯Ø²Ø§Ø±Ø´ ',0),(300999,8362,'pr','OBS Ú¯Ø²Ø§Ø±Ø´ ',0),(301000,8362,'tr','OBS raporu',0),(301001,8362,'pl','Raport OBS',0),(301002,8362,'bg','OBS Ð´Ð¾ÐºÐ»Ð°Ð´',0),(301003,8362,'ur','Ø§ÙˆØ¨Ø³ Ø±Ù¾ÙˆØ±Ù¹',0),(301004,8362,'sr','ÐžÐ‘Ð¡ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(301005,8362,'vi','BÃ¡o cÃ¡o OBS',0),(301006,8362,'af','\"OBS\" Verslag',0),(301007,8362,'ro','Raport de OBS',0),(301008,8362,'et','OBS aruanne',0),(301009,8362,'si','PoroÄilo OBS',0),(301010,8362,'ba','OBS laporan',0),(301011,8362,'nl','OBS verslag',0),(301012,8362,'fi','OBS raportti',0),(301013,8362,'no','OBS rapport',0),(301014,8362,'da','OBS rapport',0),(301015,8362,'ko','OBS ë³´ê³ ì„œ',0),(301016,8362,'he','OBS ×—',0),(301017,8362,'el','ÎˆÎºÎ¸ÎµÏƒÎ· OBS',0),(301018,8362,'zh','å°±ä¸šæŠ¥å‘Š\r\n',0),(301019,8362,'sv','OBS rapport',0),(301020,8362,'it','Relazione OBS',0),(301021,8362,'tl','',0),(301022,8362,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609; OBS ',0),(301023,8362,'hi','OBS à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(301024,8362,'ms','Laporan OBS',0),(301025,8362,'ar','ØªÙ‚Ø±ÙŠØ± OBS',0),(301026,8362,'fr','Rapport de l\'OBS',0),(301027,8362,'jp','OBS ãƒ¬ãƒãƒ¼ãƒˆ',0),(301028,8362,'pt','RelatÃ³rio OBS',0),(301029,8362,'ru','Ð”Ð¾ÐºÐ»Ð°Ð´ OBS',0),(301030,8362,'es','Informe de OBS',0),(301031,8362,'de','OBS-Bericht',0),(301032,8362,'en','OBS Report',0),(301033,8363,'is','',0),(301034,8363,'dr','Ùˆ Ø§Ú¯Ø± Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ø¯Ø± ÙŠÙƒ Ø·Ø±Ù  Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†ÙŠØ¯',0),(301035,8363,'pr','Ùˆ Ø§Ú¯Ø± Ø§Ø² Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø¬ÙˆÙ‡Ø± Ø¯Ø± ÙŠÙƒ Ø·Ø±Ù  Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†ÙŠØ¯',0),(301036,8363,'tr','Ve eÄŸer bir tarafta birden fazla mÃ¼rekkep kullanarak',0),(301037,8363,'pl','A jeÅ›li przy uÅ¼yciu wiÄ™cej niÅ¼ jednej farby na stronie',0),(301038,8363,'bg','Ð˜ Ð°ÐºÐ¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð¸Ð½ Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ Ð¾Ñ‚ ÑÑ‚Ñ€Ð°Ð½Ð°',0),(301039,8363,'ur','Ø§ÙˆØ± Ø§Ú¯Ø± Ø§ÛŒÚ© Ø³Û’ Ø²Ø§Ø¦Ø¯ Ø§Ù†Ú© Ø§ÛŒÚ© Ø¬Ø§Ù†Ø¨ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÛŒÚº ØªÙˆ',0),(301040,8363,'sr','Ð˜ Ð°ÐºÐ¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ñ˜ÐµÐ´Ð½Ð¾Ð³ Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿ÐµÑ€Ð¾Ð¼ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ñƒ',0),(301041,8363,'vi','VÃ  náº¿u sá»­ dá»¥ng hÆ¡n má»™t loáº¡i má»±c trÃªn má»™t máº·t',0),(301042,8363,'af','En indien meer as een ink op \'n kant gebruik word',0),(301043,8363,'ro','Åži dacÄƒ folosiÅ£i mai mult de o cernealÄƒ pe o parte',0),(301044,8363,'et','Ja kui pool Ã¼le Ã¼he tindi kasutamine',0),(301045,8363,'si','In Äe z veÄ Ärnila na stran',0),(301046,8363,'ba','Dan jika menggunakan tinta lebih dari satu sisi',0),(301047,8363,'nl','En als meer dan Ã©Ã©n inkt gebruiken op een kant',0),(301048,8363,'fi','Ja jos useampi kuin yksi musteella puolella',0),(301049,8363,'no','Med mer enn Ã©n trykkfarge en side',0),(301050,8363,'da','Og hvis bruger mere end Ã©n trykfarve pÃ¥ en side',0),(301051,8363,'ko','ê·¸ë¦¬ê³  ì¸¡ë©´ì— í•˜ë‚˜ ì´ìƒì˜ ìž‰í¬ë¥¼ ì‚¬ìš© í•˜ëŠ” ê²½ìš°',0),(301052,8363,'he','×•×× ×‘××ž×¦×¢×•×ª ×“×™×• ×™×•×ª×¨ ×ž×¤×¢× ××—×ª ×‘×›×œ ×¦×“',0),(301053,8363,'el','ÎšÎ±Î¹ Î±Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ± Î±Ï€ÏŒ Î­Î½Î± Î¼ÎµÎ»Î¬Î½Î¹Î± ÏƒÏ„Î·Î½ Î¼Î¹Î± Ï€Î»ÎµÏ…ÏÎ¬',0),(301054,8363,'zh','å¦‚æžœä½¿ç”¨ä¸€ä¸ªä¾§é¢å¤šä¸ªå¢¨æ°´\r\n',0),(301055,8363,'sv','Och om du anvÃ¤nder mer Ã¤n en tryckfÃ¤rg pÃ¥ en sida',0),(301056,8363,'it','E se si utilizza piÃ¹ di un inchiostro su un lato',0),(301057,8363,'tl','',0),(301058,8363,'th','&#3649;&#3621;&#3632;&#3606;&#3657;&#3634;&#3651;&#3594;&#3657;&#3627;&#3617;&#3638;&#3585;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3627;&#3609;&#3638;&#3656;&#3591;&#3626;&#3637;&#3610;&#3609;&#3627;&#3609;&#3638;&#3656;&#3591;&#3604;&#3657;&#3',0),(301059,8363,'hi','à¤”à¤° à¤…à¤—à¤° à¤à¤• à¤ªà¤•à¥à¤· à¤ªà¤° à¤à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°',0),(301060,8363,'ms','Dan jika menggunakan lebih daripada satu dakwat pada sisi yang',0),(301061,8363,'ar','ÙˆØ¥Ø°Ø§ ÙƒØ§Ù† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ø¨Ø± ÙˆØ§Ø­Ø¯ Ø£Ùˆ Ø£ÙƒØ«Ø± Ø¹Ù„Ù‰ Ø§Ù„Ø¬Ø§Ù†Ø¨',0),(301062,8363,'fr','Et si vous utilisez plus d\'une entrÃ©e manuscrite sur un cÃ´tÃ©',0),(301063,8363,'jp','å´ã® 1 ã¤ä»¥ä¸Šã®ã‚¤ãƒ³ã‚¯ã‚’ä½¿ç”¨ã™ã‚‹å ´åˆ',0),(301064,8363,'pt','E se utilizar mais de uma tinta de um lado',0),(301065,8363,'ru','Ð˜ ÐµÑÐ»Ð¸ Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸ÐµÐ¼ Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ð¾Ð´Ð½Ð¾Ð³Ð¾ Ñ‡ÐµÑ€Ð½Ð¸Ð» Ð½Ð° ÑÑ‚Ð¾Ñ€Ð¾Ð½Ðµ',0),(301066,8363,'es','y si esta usando mÃ¡s que una tinta a un lado',0),(301067,8363,'de','Und wenn mehr als eine Tinte auf einer Seite zu verwenden',0),(301068,8363,'en','And if using more than one ink on a side',0),(301069,8364,'is','',0),(301070,8364,'dr','(Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ) Ø§Ø¹Ù„Ø§Ù… Ù†Ø´Ø¯',0),(301071,8364,'pr','Ù‡ÙŠÚ† ØªØ±ÙƒÙŠØ¨ÙŠ(Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ) Ø§Ø¹Ù„Ø§Ù… Ù†Ø´Ø¯',0),(301072,8364,'tr','AlÄ±ntÄ± yok kompozisyon',0),(301073,8364,'pl','Nie skÅ‚ad podane',0),(301074,8364,'bg','ÐÐµ ÑÑŠÑÑ‚Ð°Ð²Ð° Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°',0),(301075,8364,'ur','Ú©ÙˆØ¦ÛŒ Ø³Ø§Ø®Øª Ú©Û’ Ø­ÙˆØ§Ù„Û’ Ø³Û’',0),(301076,8364,'sr','ÐšÐ¾Ð¼Ð¿Ð¾Ð½Ð¾Ð²Ð°ÑšÐµ Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð¾',0),(301077,8364,'vi','ChÆ°a bÃ¡o giÃ¡ thÃ nh pháº§n',0),(301078,8364,'af','Geen samestelling aangehaal',0),(301079,8364,'ro','Nici compozitia citat',0),(301080,8364,'et','Kompromissi kommenteeritud',0),(301081,8364,'si','Poravnava kotirajo',0),(301082,8364,'ba','Komposisi tidak dikutip',0),(301083,8364,'nl','Geen samenstelling geciteerd',0),(301084,8364,'fi','Ei kokoonpano lainasi',0),(301085,8364,'no','Ingen komposisjon sitert',0),(301086,8364,'da','Ingen sammensÃ¦tning citeret',0),(301087,8364,'ko','ì¸ìš© ì—†ëŠ” êµ¬ì„±',0),(301088,8364,'he','×”×¨×›×‘ ×œ× ×¦×™×˜×˜',0),(301089,8364,'el','Î”ÎµÎ½ ÏƒÏÎ½Î¸ÎµÏƒÎ· ÎµÎ¹ÏƒÎ·Î³Î¼Î­Î½ÎµÏ‚',0),(301090,8364,'zh','æ— æˆåˆ†æŠ¥ä»·\r\n',0),(301091,8364,'sv','Ingen sammansÃ¤ttning citerade',0),(301092,8364,'it','Nessuna composizione citato',0),(301093,8364,'tl','',0),(301094,8364,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;',0),(301095,8364,'hi','à¤•à¥‹à¤ˆ à¤°à¤šà¤¨à¤¾ à¤®à¥‡à¤‚ à¤‰à¤¦à¥à¤§à¥ƒà¤¤',0),(301096,8364,'ms','Tiada komposisi yang disebut',0),(301097,8364,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªÙƒÙˆÙŠÙ† Ù†Ù‚Ù„Ø§ Ø¹Ù†',0),(301098,8364,'fr','Aucune Composition citÃ©e',0),(301099,8364,'jp','å¼•ç”¨ç¬¦ã§å›²ã¾ã‚ŒãŸåˆæˆã‚’è¡Œã‚ãªã„',0),(301100,8364,'pt','Nenhuma composiÃ§Ã£o citada',0),(301101,8364,'ru','ÐÐµ ÑƒÐºÐ°Ð·Ð°Ð½Ñ‹ ÑÐ¾ÑÑ‚Ð°Ð²',0),(301102,8364,'es','Ninguna ComposiciÃ³n Cotizada',0),(301103,8364,'de','Keine Komposition zitiert',0),(301104,8364,'en','No Composition Quoted',0),(301105,8365,'is','',0),(301106,8365,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ Ù‚Ø³Ù…Øª Ø´Ø¯Ù‡ ',0),(301107,8365,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù…Ù„ Ù‚Ø³Ù…Øª Ø´Ø¯Ù‡ ',0),(301108,8365,'tr','Split gemi Ekle',0),(301109,8365,'pl','Dodawanie podziaÅ‚u statku',0),(301110,8365,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸ ÐºÐ¾Ñ€Ð°Ð±',0),(301111,8365,'ur','Ø§Ù„Ú¯ Ú©Ø±ÛŒÚº ÙˆØ§Ù„Ø§ Ø¬ÛØ§Ø² Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(301112,8365,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð±Ñ€Ð¾Ð´ Ð¡Ð¿Ð»Ð¸Ñ‚',0),(301113,8365,'vi','ThÃªm Chuyáº¿n HÃ ng Chia Ra',0),(301114,8365,'af','Verdeling van Versendingskoste Byvoeg',0),(301115,8365,'ro','Adauga Split navei',0),(301116,8365,'et','Lisada tÃ¼keldatud laeva',0),(301117,8365,'si','Dodajte na Split ladje',0),(301118,8365,'ba','Tambahkan Split kapal',0),(301119,8365,'nl','Split schip toevoegen',0),(301120,8365,'fi','LisÃ¤Ã¤ Split aluksen',0),(301121,8365,'no','Legge til Split skipet',0),(301122,8365,'da','TilfÃ¸je Split skib',0),(301123,8365,'ko','ë¶„í•  ë°° ì¶”ê°€',0),(301124,8365,'he','×œ×”×•×¡×™×£ ×¤×™×¦×•×œ ×”×¡×¤×™× ×”',0),(301125,8365,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î´Î¹Î¬ÏƒÏ€Î±ÏƒÎ· Ï„Î¿Ï… Ï€Î»Î¿Î¯Î¿Ï…',0),(301126,8365,'zh','å¢žåŠ åˆ†åˆ«è¿é€\r\n',0),(301127,8365,'sv','LÃ¤gg till Split fartyget',0),(301128,8365,'it','Aggiungere Split nave',0),(301129,8365,'tl','',0),(301130,8365,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3649;&#3618;&#3585;&#3626;&#3656;&#3591;&#3586;&#3629;&#3591;',0),(301131,8365,'hi','à¤­à¤¾à¤œà¤¿à¤¤ à¤œà¤¹à¤¾à¤œ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(301132,8365,'ms','Tambah kapal Split',0),(301133,8365,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù†Ù‚Ø³Ø§Ù… Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(301134,8365,'fr','Ajouter Split navire',0),(301135,8365,'jp','åˆ†å‰²èˆ¹ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(301136,8365,'pt','Adicionar o navio Split',0),(301137,8365,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑƒÐ´Ð½Ð¾ Ð¡Ð¿Ð»Ð¸Ñ‚',0),(301138,8365,'es','Agregar EnvÃ­o Partido',0),(301139,8365,'de','FÃ¼gen Sie Split Schiff',0),(301140,8365,'en','Add Split Ship',0),(301141,8366,'is','',0),(301142,8366,'dr','Ø´Ù…Ø§Ø±Ù‡  Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(301143,8366,'pr','Ø´Ù…Ø§Ø±Ù‡  Ø­Ù…Ù„ ÙƒÙ†Ù†Ø¯Ù‡ ',0),(301144,8366,'tr','GÃ¶nderici sayÄ±sÄ±',0),(301145,8366,'pl','Numer nadawcy',0),(301146,8366,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¿ÐµÐ´Ð¸Ñ‚Ð¾Ñ€Ð°',0),(301147,8366,'ur','Ø²ÛŒØ±ÙÙ‚ÛŒØ§Ø¯Øª Ù†Ù…Ø¨Ø±',0),(301148,8366,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑˆÐ¿ÐµÐ´Ð¸Ñ‚ÐµÑ€Ð°',0),(301149,8366,'vi','Sá»‘ ngÆ°á»i chuyá»ƒn',0),(301150,8366,'af','Verskeepsagent Nommer',0),(301151,8366,'ro','NumÄƒrul expeditorului',0),(301152,8366,'et','Saatja Number',0),(301153,8366,'si','Å tevilka poÅ¡iljatelja',0),(301154,8366,'ba','Nomor pengirim',0),(301155,8366,'nl','Afzender nummer',0),(301156,8366,'fi','LÃ¤hettÃ¤jÃ¤n numeron',0),(301157,8366,'no','SpeditÃ¸ren nummer',0),(301158,8366,'da','Afsender nummer',0),(301159,8366,'ko','ë°œì†¡ìž ë²ˆí˜¸',0),(301160,8366,'he','×ž×¡×¤×¨ ×”×©×•×œ×—',0),(301161,8366,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Î±',0),(301162,8366,'zh','æ‰˜è¿äººç¼–å·\r\n',0),(301163,8366,'sv','AvsÃ¤ndaren nummer',0),(301164,8366,'it','Numero mittente',0),(301165,8366,'tl','',0),(301166,8366,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3612;&#3641;&#3657;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(301167,8366,'hi','Shipper à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(301168,8366,'ms','Nombor pengirim',0),(301169,8366,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø´Ø§Ø­Ù†',0),(301170,8366,'fr','NumÃ©ro de l\'expÃ©diteur',0),(301171,8366,'jp','è·é€äººç•ªå·',0),(301172,8366,'pt','NÃºmero do remetente',0),(301173,8366,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÐµÐ»Ñ',0),(301174,8366,'es','NÃºmero de Transportador',0),(301175,8366,'de','Absender-Nummer',0),(301176,8366,'en','Shipper Number',0),(301177,8367,'is','',0),(301178,8367,'dr','Ø´ØºÙ„ Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(301179,8367,'pr','Ø´ØºÙ„ Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(301180,8367,'tr','Ä°ÅŸ silindi',0),(301181,8367,'pl','Zadanie zostaÅ‚o usuniÄ™te',0),(301182,8367,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ðµ Ð±Ð¸Ð»Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð°',0),(301183,8367,'ur','Ú©Ø§Ù… Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(301184,8367,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°.',0),(301185,8367,'vi','Job Ä‘Ã£ xÃ³a',0),(301186,8367,'af','Werkstuk is Geskrap',0),(301187,8367,'ro','Job a fost ÅŸters',0),(301188,8367,'et','TÃ¶Ã¶ on kustutatud',0),(301189,8367,'si','Delo je bil izbrisan',0),(301190,8367,'ba','Pekerjaan telah dihapus',0),(301191,8367,'nl','Job Has Been Deleted',0),(301192,8367,'fi','TyÃ¶ on poistettu',0),(301193,8367,'no','Jobben har blitt slettet',0),(301194,8367,'da','Job er slettet',0),(301195,8367,'ko','ìž‘ì—…ì„ ì‚­ì œ',0),(301196,8367,'he','×”×¢×‘×•×“×” × ×ž×—×§×”',0),(301197,8367,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î­Ï‡ÎµÎ¹ Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯',0),(301198,8367,'zh','å·¥ä½œå·²è¢«åˆ é™¤\r\n',0),(301199,8367,'sv','Jobbet har tagits bort',0),(301200,8367,'it','Processo Ã¨ stato eliminato',0),(301201,8367,'tl','',0),(301202,8367,'th','&#3591;&#3634;&#3609;&#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(301203,8367,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‹ à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(301204,8367,'ms','Kerja telah dihapuskan',0),(301205,8367,'ar','ØªÙ… Ø­Ø°Ù Ø§Ù„Ù…Ù‡Ù…Ø©',0),(301206,8367,'fr','Travail a Ã©tÃ© supprimÃ©',0),(301207,8367,'jp','ã‚¸ãƒ§ãƒ–ã¯å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(301208,8367,'pt','Trabalho foi excluÃ­do',0),(301209,8367,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð±Ñ‹Ð»Ð° ÑƒÐ´Ð°Ð»ÐµÐ½Ð°',0),(301210,8367,'es','Trabajo Ha Sido Eliminado',0),(301211,8367,'de','Job wurde gelÃ¶scht',0),(301212,8367,'en','Job Has Been Deleted',0),(301213,8368,'is','',0),(301214,8368,'dr','(Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ) Ø¯Ø± ÙØ±Ù…Ø§ÛŒØ´ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(301215,8368,'pr','Ù‡ÙŠÚ† ØªØ±ÙƒÙŠØ¨ÙŠ(Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ) Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(301216,8368,'tr','No kompozisyon sipariÅŸ',0),(301217,8368,'pl','Nie ma skÅ‚adu na zamÃ³wienie',0),(301218,8368,'bg','ÐÐµ ÑÑŠÑÑ‚Ð°Ð²Ð° Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(301219,8368,'ur','Ú©ÙˆØ¦ÛŒ ØªØ±Ú©ÛŒØ¨ Ú©Û’ Ø­Ú©Ù… Ù¾Ø±',0),(301220,8368,'sr','ÐšÐ¾Ð¼Ð¿Ð¾Ð½Ð¾Ð²Ð°ÑšÐµ Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ñƒ',0),(301221,8368,'vi','KhÃ´ng cÃ³ thÃ nh pháº§n cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(301222,8368,'af','Geen samestelling op bestelling',0),(301223,8368,'ro','Nici o compozitie pe comanda',0),(301224,8368,'et','Kompromissi tellimusel',0),(301225,8368,'si','Poravnava po naroÄilu',0),(301226,8368,'ba','Tidak ada komposisi pesanan',0),(301227,8368,'nl','Geen samenstelling op bestelling',0),(301228,8368,'fi','Ei kokoonpano tilauksesta',0),(301229,8368,'no','Ingen komposisjon pÃ¥ bestilling',0),(301230,8368,'da','Ingen sammensÃ¦tning pÃ¥ ordre',0),(301231,8368,'ko','ìˆœì„œì— ì—†ëŠ” êµ¬ì„±',0),(301232,8368,'he','×œ× ×”×¨×›×‘ ×‘×”×–×ž× ×”',0),(301233,8368,'el','Î”ÎµÎ½ ÏƒÏÎ½Î¸ÎµÏƒÎ· ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(301234,8368,'zh','æˆåˆ†æ— åº\r\n',0),(301235,8368,'sv','Ingen sammansÃ¤ttning pÃ¥ bestÃ¤llning',0),(301236,8368,'it','Nessuna composizione su ordine',0),(301237,8368,'tl','',0),(301238,8368,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3611;&#3619;&#3632;&#3585;&#3629;&#3610;&#3586;&#3638;&#3657;&#3609;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3',0),(301239,8368,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤•à¥‹à¤ˆ à¤°à¤šà¤¨à¤¾',0),(301240,8368,'ms','Komposisi tidak dengan arahan',0),(301241,8368,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªÙƒÙˆÙŠÙ† ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(301242,8368,'fr','Aucune Composition sur commande',0),(301243,8368,'jp','æ³¨æ–‡ã®åˆæˆã‚’è¡Œã‚ãªã„',0),(301244,8368,'pt','Nenhuma composiÃ§Ã£o na ordem',0),(301245,8368,'ru','ÐÐµÑ‚ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ð½Ð° Ð·Ð°ÐºÐ°Ð·',0),(301246,8368,'es','Ninguna ComposiciÃ³n en Orden',0),(301247,8368,'de','Keine Komposition auf Bestellung',0),(301248,8368,'en','No Composition on Order',0),(301249,8369,'is','',0),(301250,8369,'dr','ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(301251,8369,'pr','ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(301252,8369,'tr','DoÄŸruladÄ±',0),(301253,8369,'pl','Potwierdzone',0),(301254,8369,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¾',0),(301255,8369,'ur','Ø§Ø³ Ø¨Ø§Øª Ú©ÛŒ ØªØµØ¯ÛŒÙ‚',0),(301256,8369,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸Ð¾',0),(301257,8369,'vi','XÃ¡c nháº­n',0),(301258,8369,'af','Bevestig',0),(301259,8369,'ro','Confirmat',0),(301260,8369,'et','Kinnitatud',0),(301261,8369,'si','Potrjena',0),(301262,8369,'ba','Dikonfirmasi',0),(301263,8369,'nl','Bevestigd',0),(301264,8369,'fi','Vahvisti',0),(301265,8369,'no','Bekreftet',0),(301266,8369,'da','BekrÃ¦ftet',0),(301267,8369,'ko','í™•ì¸',0),(301268,8369,'he','××™×©×¨',0),(301269,8369,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎµ',0),(301270,8369,'zh','å·²ç¡®è®¤\r\n',0),(301271,8369,'sv','BekrÃ¤ftade',0),(301272,8369,'it','Confermato',0),(301273,8369,'tl','',0),(301274,8369,'th','&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(301275,8369,'hi','à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¥€',0),(301276,8369,'ms','Disahkan',0),(301277,8369,'ar','Ù…Ø¤ÙƒÙ‘Ù€Ø¯',0),(301278,8369,'fr','ConfirmÃ©',0),(301279,8369,'jp','ç¢ºèª',0),(301280,8369,'pt','Confirmado',0),(301281,8369,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¾',0),(301282,8369,'es','Confirmado',0),(301283,8369,'de','BestÃ¤tigt',0),(301284,8369,'en','Confirmed',0);
INSERT INTO `langdef` VALUES (301285,8370,'is','',0),(301286,8370,'dr','( _Ø­Ù…Ù„ Ø¨Ù‡ _  ) (ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ) Ùˆ ØºÙŠØ±Ù‡',0),(301287,8370,'pr','Ù‡ÙŠÚ† Ù…ÙˆØ±Ø¯ÙŠ  Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ( _Ø­Ù…Ù„ Ø¨Ù‡ _  ) (ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ) Ùˆ ØºÙŠØ±Ù‡',0),(301288,8370,'tr','PO Shipto, satÄ±cÄ± vb kutusu yok.',0),(301289,8370,'pl','Nie ma pola na PO Shipto, dostawcÃ³w itp.',0),(301290,8370,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð² PO Shipto, Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸ Ð´Ñ€.',0),(301291,8370,'ur','Ú©ÙˆØ¦ÛŒ Ø®Ø§Ù†ÙˆÚº Ù¾Ø± Ù¾Ùˆ Ø´Ø§Ù¾Ù¹ÙˆØŒ ÙˆÛŒÙ†ÚˆØ± ÙˆØºÛŒØ±Û Û”',0),(301292,8370,'sr','ÐÐµÐ¼Ð° ÐºÑƒÑ‚Ð¸Ñ˜Ðµ Ð½Ð° ÐŸÐž ÐŸÑ€Ð¸Ð¼Ð°Ð¾Ñ†, Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸Ñ‚Ð´.',0),(301293,8370,'vi','KhÃ´ng Ä‘á»ƒ thÃ¹ng trÃªn Ä‘Æ¡n mua hÃ ng chuyá»ƒn Ä‘áº¿n, ngÆ°á»i bÃ¡n cho vv',0),(301294,8370,'af','Geen Bokse Op AB Versend-Aan, Verskaffer Ens.',0),(301295,8370,'ro','Nu cutii pe PO Shipto, furnizori Etc.',0),(301296,8370,'et','Pole kaste, PO Shipto, mÃ¼Ã¼k jne.',0),(301297,8370,'si','Ni polja na PO Shipto, prodajalec itd.',0),(301298,8370,'ba','Ada kotak di Shipto PO, Vendor dll.',0),(301299,8370,'nl','Geen vakken op PO Shipto, leverancier enz.',0),(301300,8370,'fi','Ei laatikoita PO Shipto, toimittaja jne.',0),(301301,8370,'no','Ingen boksene PO Shipto, leverandÃ¸r Etc.',0),(301302,8370,'da','Ingen bokse pÃ¥ PO Shipto, kreditor osv.',0),(301303,8370,'ko','ì—†ìŒ ìƒìžì— í¬ Shipto, ê³µê¸‰ ì—…ì²´ ë“±ìž…ë‹ˆë‹¤.',0),(301304,8370,'he','×œ×œ× ×ª×™×‘×•×ª ×¢×œ ×¤×• ×©×¢×•×–×‘×ª, ×”×¡×¤×§ ×•×¢×•×“.',0),(301305,8370,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Ï€Î»Î±Î¯ÏƒÎ¹Î± ÏƒÎµ PO Shipto, Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÎºÏ„Î».',0),(301306,8370,'zh','æ²¡æœ‰è®¢å•æ”¶è´§åœ°æ¡†ï¼Œä¾›åº”å•†æ¡†ç­‰\r\n',0),(301307,8370,'sv','Inga rutor pÃ¥ PO Shipto, leverantÃ¶r Etc.',0),(301308,8370,'it','Nessun scatole su PO Shipto, fornitore ecc.',0),(301309,8370,'tl','',0),(301310,8370,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3594;&#3656;&#3629;&#3591;&#3586;&#3629;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3606;&#3638;&#3591;, &#3612;&#3641;&#3657;&#3586;&',0),(301311,8370,'hi','PO Shipto, à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤†à¤¦à¤¿ à¤ªà¤° à¤•à¥‹à¤ˆ à¤¬à¤•à¥à¤¸à¥‡à¥¤',0),(301312,8370,'ms','Tiada kotak PO Shipto, Penjual dan lain-lain.',0),(301313,8370,'ar','Ø£ÙŠØ© Ù…Ø±Ø¨Ø¹Ø§Øª Ø¹Ù„Ù‰ Ø´ÙŠØ¨ØªÙˆ Ø¨ÙˆØŒ Ø¨Ø§Ø¦Ø¹ Ø¥Ù„Ø®.',0),(301314,8370,'fr','Pas de boÃ®tes sur PO Shipto, etc. du vendeur.',0),(301315,8370,'jp','PO Shiptoã€ãƒ™ãƒ³ãƒ€ãƒ¼ç­‰ã®ãƒœãƒƒã‚¯ã‚¹ã¯è¡¨ç¤ºã•ã‚Œã¾ã›ã‚“ã€‚',0),(301316,8370,'pt','Nenhuma caixa de PO Porto, fornecedor Etc.',0),(301317,8370,'ru','ÐÐµÑ‚ ÐºÐ¾Ñ€Ð¾Ð±ÐºÐ¸ Ð½Ð° PO Shipto, Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¸ Ð´Ñ€.',0),(301318,8370,'es','No Hay Cajas en el OC Para Enviar A, Proveedor, Etc.',0),(301319,8370,'de','Keine Boxen auf PO Shipto, Lieferanten etc..',0),(301320,8370,'en','No Boxes on PO Shipto, Vendor Etc.',0),(301321,8371,'is','',0),(301322,8371,'dr','Ù‚Ø§Ù„Ø¨  ØªØ§Ø±ÙŠØ®  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(301323,8371,'pr','Ù‚Ø§Ù„Ø¨  ØªØ§Ø±ÙŠØ®  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(301324,8371,'tr','SatÄ±nalma sipariÅŸ Tarih biÃ§imi',0),(301325,8371,'pl','Format Data zamÃ³wienia zakupu',0),(301326,8371,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð° Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(301327,8371,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ§Ø±ÛŒØ® ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(301328,8371,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð½Ð°Ð»Ð¾Ð³ Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(301329,8371,'vi','Kiá»ƒu ngÃ y ÄÆ¡n Mua HÃ ng',0),(301330,8371,'af','Aankoopbestelling Datum Formaat',0),(301331,8371,'ro','CumpÄƒrare ordine data Format',0),(301332,8371,'et','Ostu tellimuse kuupÃ¤eva formaat',0),(301333,8371,'si','Oblika datuma nabavni nalog',0),(301334,8371,'ba','Format tanggal Order Pembelian',0),(301335,8371,'nl','Aankoop Order datum Format',0),(301336,8371,'fi','Tilauksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤muodossa',0),(301337,8371,'no','Format for bestillinger dato',0),(301338,8371,'da','KÃ¸b Bestil datoformat',0),(301339,8371,'ko','êµ¬ë§¤ ì£¼ë¬¸ ë‚ ì§œ í˜•ì‹',0),(301340,8371,'he','×ª×‘× ×™×ª ×ª××¨×™×š ×”×–×ž× ×ª ×¨×›×™×©×”',0),(301341,8371,'el','ÎœÎ¿ÏÏ†Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î±Î³Î¿ÏÎ¬Ï‚',0),(301342,8371,'zh','é‡‡è´­è®¢å•çš„æ—¥æœŸæ ¼å¼\r\n',0),(301343,8371,'sv','KÃ¶p Order datumformat',0),(301344,8371,'it','Formato Data ordine di acquisto',0),(301345,8371,'tl','',0),(301346,8371,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(301347,8371,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(301348,8371,'ms','Format tarikh pesanan pembelian',0),(301349,8371,'ar','ØªÙ†Ø³ÙŠÙ‚ ØªØ§Ø±ÙŠØ® Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(301350,8371,'fr','Format de Date pour le bon achat',0),(301351,8371,'jp','è³¼å…¥ã‚ªãƒ¼ãƒ€ãƒ¼ã®æ—¥ä»˜ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(301352,8371,'pt','Formato de data de ordem de compra',0),(301353,8371,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð°Ñ‚Ñ‹',0),(301354,8371,'es','Orden de Compra Formato de Fechas',0),(301355,8371,'de','Kauf-Order-Datumsformat',0),(301356,8371,'en','Purchase Order Date Format',0),(301357,8372,'is','',0),(301358,8372,'dr','Ù‚Ø§Ù„Ø¨ ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± Ùˆ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª',0),(301359,8372,'pr','Ù‚Ø§Ù„Ø¨ ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± Ùˆ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª',0),(301360,8372,'tr','Fatura ve deyim Tarih biÃ§imi',0),(301361,8372,'pl','Faktury i instrukcja Format daty',0),(301362,8372,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð·Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(301363,8372,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§ÙˆØ± Ø¨ÛŒØ§Ù† ØªØ§Ø±ÛŒØ® ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(301364,8372,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(301365,8372,'vi','Dáº¡ng ngÃ y cá»§a sao kÃª & hÃ³a Ä‘Æ¡n',0),(301366,8372,'af','Faktuur en Staat Datumformaat',0),(301367,8372,'ro','Format data pentru factura',0),(301368,8372,'et','Arve ja vÃ¤ljavÃµtte kuuva formaat',0),(301369,8372,'si','RaÄun in izjava oblika datuma',0),(301370,8372,'ba','Faktur dan Format tanggal pernyataan',0),(301371,8372,'nl','Factuur en verklaring datumnotatie',0),(301372,8372,'fi','Laskun ja ilmoitus pvm',0),(301373,8372,'no','Faktura og uttalelse datoformat',0),(301374,8372,'da','Faktura og erklÃ¦ring datoformat',0),(301375,8372,'ko','ì²­êµ¬ì„œ ë° ê³„ì‚° ì„œ ë‚ ì§œ í˜•ì‹',0),(301376,8372,'he','\' ×—×©×‘×•× ×™×ª \' ×ª×‘× ×™×ª ×ª××¨×™×š ×”×¦×”×¨×”',0),(301377,8372,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎºÎ±Î¹ Î· Î´Î®Î»Ï‰ÏƒÎ· Î¼Î¿ÏÏ†Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚',0),(301378,8372,'zh','å‘ç¥¨å’Œè¯­å¥æ—¥æœŸæ ¼å¼\r\n',0),(301379,8372,'sv','Faktura och uttalande datumformat',0),(301380,8372,'it','Fattura e formato di dichiarazione di data',0),(301381,8372,'tl','',0),(301382,8372,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3649;&#3621;&#3632;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(301383,8372,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤”à¤° à¤•à¤¥à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(301384,8372,'ms','Invois dan Format tarikh penyata',0),(301385,8372,'ar','ØªÙ†Ø³ÙŠÙ‚ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨ÙŠØ§Ù† ÙˆØ§Ù„ÙØ§ØªÙˆØ±Ø©',0),(301386,8372,'fr','Facture et dÃ©claration Format de Date',0),(301387,8372,'jp','è«‹æ±‚æ›¸ã¨ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã®æ—¥ä»˜ã®å½¢å¼',0),(301388,8372,'pt','Nota fiscal e formato de declaraÃ§Ã£o de data',0),(301389,8372,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð¸ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ñ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð°Ñ‚Ñ‹',0),(301390,8372,'es','Formato de Factura y Fecha de DeclaraciÃ³n',0),(301391,8372,'de','Rechnung und Anweisung Datumsformat',0),(301392,8372,'en','Invoice and Statement Date Format',0),(301393,8373,'is','',0),(301394,8373,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡',0),(301395,8373,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡',0),(301396,8373,'tr','KapalÄ± tut',0),(301397,8373,'pl','Kwota ujÄ™ta',0),(301398,8373,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸',0),(301399,8373,'ur','Amt. Ø¨Ù†Ø¯',0),(301400,8373,'sr','Ð˜Ð·Ð½Ð¾Ñ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ð°Ð»Ð°Ð·Ð¸ Ð¸Ð·Ð¼ÐµÑ’Ñƒ',0),(301401,8373,'vi','Sá»‘ Tiá»n KÃ¨m Theo',0),(301402,8373,'af','AMT. ingesluit',0),(301403,8373,'ro','SumÄƒ Ã®nchise',0),(301404,8373,'et','Suletud summa',0),(301405,8373,'si','Znesek zaprtih',0),(301406,8373,'ba','Amt. tertutup',0),(301407,8373,'nl','Ingesloten Amt.',0),(301408,8373,'fi','Summa suljettu',0),(301409,8373,'no','BelÃ¸p vedlagt',0),(301410,8373,'da','Feltet lukket',0),(301411,8373,'ko','í¬í•¨ ë¦¬ì†ŒìŠ¤',0),(301412,8373,'he','Amt. ×¡×’×•×¨',0),(301413,8373,'el','Î Î¿ÏƒÏŒ Ï€Î¿Ï… Ï€ÎµÏÎ¹ÎºÎ»ÎµÎ¯ÎµÏ„Î±Î¹',0),(301414,8373,'zh','é‡‘é¢ å°é—­å¼\r\n',0),(301415,8373,'sv','Belopp som omges',0),(301416,8373,'it','AMT. racchiuso',0),(301417,8373,'tl','',0),(301418,8373,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3607;&#3637;&#3656;&#3611;&#3636;&#3604;',0),(301419,8373,'hi','Amt. à¤¸à¤‚à¤²à¤—à¥à¤¨',0),(301420,8373,'ms','AMT. yang disertakan',0),(301421,8373,'ar','Amt. Ø§Ù„Ù…ØºÙ„Ù‚Ø©',0),(301422,8373,'fr','AMT. clos',0),(301423,8373,'jp','å›²ã¾ã‚ŒãŸ amt.',0),(301424,8373,'pt','AMT. fechado',0),(301425,8373,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ',0),(301426,8373,'es','Cant. Adjunto',0),(301427,8373,'de','Amt eingeschlossen.',0),(301428,8373,'en','Amt. Enclosed',0),(301429,8374,'is','',0),(301430,8374,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(301431,8374,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(301432,8374,'tr','Hata veri ekleme',0),(301433,8374,'pl','BÅ‚Ä…d podczas dodawania danych',0),(301434,8374,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸',0),(301435,8374,'ur','Ù†Ù‚Øµ Ú©ÙˆØ§Ø¦Ù Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(301436,8374,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(301437,8374,'vi','ThÃªm dá»¯ liá»‡u bá»‹ lá»—i',0),(301438,8374,'af','Fout voeg Data',0),(301439,8374,'ro','Eroare adÄƒugarea de date',0),(301440,8374,'et','Viga lisades andmed',0),(301441,8374,'si','Napaka pri dodajanju podatkov',0),(301442,8374,'ba','Kesalahan menambahkan Data',0),(301443,8374,'nl','Fout toe te voegen gegevens',0),(301444,8374,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ tietoja',0),(301445,8374,'no','Feil Ã¥ legge Data',0),(301446,8374,'da','Fejl tilfÃ¸jelse af Data',0),(301447,8374,'ko','ì¶”ê°€ ë°ì´í„° ì˜¤ë¥˜',0),(301448,8374,'he','×©×’×™××” ×‘×”×•×¡×¤×ª × ×ª×•× ×™×',0),(301449,8374,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ ÏƒÏ†Î¬Î»Î¼Î±',0),(301450,8374,'zh','æ·»åŠ æ•°æ®å‡ºé”™',0),(301451,8374,'sv','Fel att lÃ¤gga till Data',0),(301452,8374,'it','Errore aggiungendo dati',0),(301453,8374,'tl','',0),(301454,8374,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(301455,8374,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¡à¥‡à¤Ÿà¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(301456,8374,'ms','Ralat menambah Data',0),(301457,8374,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(301458,8374,'fr','Erreur ajout de donnÃ©es',0),(301459,8374,'jp','ã‚¨ãƒ©ãƒ¼ã®ãƒ‡ãƒ¼ã‚¿ã®è¿½åŠ ',0),(301460,8374,'pt','Erro adicionando dados',0),(301461,8374,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(301462,8374,'es','Error Agregando Datos',0),(301463,8374,'de','Fehler beim HinzufÃ¼gen von Daten',0),(301464,8374,'en','Error Adding Data',0),(301465,8375,'is','',0),(301466,8375,'dr','(ÙƒØ§Ø±Ø¢ÙŠÙŠ) Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ',0),(301467,8375,'pr','ÙØ¹Ø§Ù„ÙŠØª (ÙƒØ§Ø±Ø¢ÙŠÙŠ) Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ',0),(301468,8375,'tr','ParÃ§a baÅŸÄ± iÅŸ iÅŸlevi',0),(301469,8375,'pl','Funkcja pracy akordowej',0),(301470,8375,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(301471,8375,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© ÙØ¹Ù„',0),(301472,8375,'sr','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(301473,8375,'vi','Chá»©c nÄƒng lÃ m khoÃ¡n',0),(301474,8375,'af','Stukwerk Funksie',0),(301475,8375,'ro','FuncÅ£ia de acord',0),(301476,8375,'et','TÃ¼kitÃ¶Ã¶ funktsioon',0),(301477,8375,'si','Akord funkcijo',0),(301478,8375,'ba','Piecework fungsi',0),(301479,8375,'nl','Stukloon functie',0),(301480,8375,'fi','Urakka toiminto',0),(301481,8375,'no','StykkavlÃ¸nning funksjon',0),(301482,8375,'da','Akkordarbejde funktion',0),(301483,8375,'ko','Piecework í•¨ìˆ˜',0),(301484,8375,'he','×¤×•× ×§×¦×™×™×ª ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(301485,8375,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(301486,8375,'zh','è®¡ä»¶åŠŸèƒ½\r\n',0),(301487,8375,'sv','Ackord funktion',0),(301488,8375,'it','Funzione di lavoro a cottimo',0),(301489,8375,'tl','',0),(301490,8375,'th','&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3656;&#3609;&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;',0),(301491,8375,'hi','Piecework à¤¸à¤®à¤¾à¤°à¥‹à¤¹',0),(301492,8375,'ms','Fungsi piecework',0),(301493,8375,'ar','ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(301494,8375,'fr','Fonction de travail Ã  la piÃ¨ce',0),(301495,8375,'jp','å‡ºæ¥é«˜æ‰•ã„æ©Ÿèƒ½',0),(301496,8375,'pt','FunÃ§Ã£o de trabalho por tarefa',0),(301497,8375,'ru','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(301498,8375,'es','FuneciÃ³n de Trabajo por Pieza',0),(301499,8375,'de','Akkord-Funktion',0),(301500,8375,'en','Piecework Function',0),(301501,8376,'is','',0),(301502,8376,'dr','(ØªÙˆØ§Ø¨Ø¹) Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(301503,8376,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ (ØªÙˆØ§Ø¨Ø¹) Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(301504,8376,'tr','TimeClock parÃ§a baÅŸÄ± iÅŸ iÅŸlevleri ekleyin',0),(301505,8376,'pl','Dodaj funkcje TimeClock pracy akordowej',0),(301506,8376,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° TimeClock Ð¿Ð°Ñ€Ñ‡Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(301507,8376,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ú©Û’ Ø§ÙØ¹Ø§Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(301508,8376,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ',0),(301509,8376,'vi','ThÃªm chá»©c nÄƒng MÃ¡y cháº¥m cÃ´ng viá»‡c khoÃ¡n',0),(301510,8376,'af','Tydklok Stukwerk Funksies Skep',0),(301511,8376,'ro','Adauga ceas acord funcÅ£ii',0),(301512,8376,'et','TimeClock tÃ¼kitÃ¶Ã¶ funktsioonide lisamine',0),(301513,8376,'si','Akord TimeClock funkcije dodati',0),(301514,8376,'ba','Tambahkan fungsi timeclock Piecework',0),(301515,8376,'nl','Klok stukloon functies toevoegen',0),(301516,8376,'fi','Timeclock urakkatyÃ¶n toiminnot lisÃ¤Ã¤',0),(301517,8376,'no','TimeClock stykkavlÃ¸nning funksjoner legge',0),(301518,8376,'da','Timeclock akkordarbejde funktioner tilfÃ¸je',0),(301519,8376,'ko','Timeclock Piecework ê¸°ëŠ¥ ì¶”ê°€',0),(301520,8376,'he','×œ×”×•×¡×™×£ ×¤×•× ×§×¦×™×•×ª Timeclock ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(301521,8376,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Timeclock ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚',0),(301522,8376,'zh','æ—¶é’Ÿè®¡ä»¶æ–°å¢žåŠŸèƒ½\r\n',0),(301523,8376,'sv','Timeclock ackord funktionerna Add',0),(301524,8376,'it','Aggiungi funzioni a cottimo Timeclock',0),(301525,8376,'tl','',0),(301526,8376,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3656;&#3609;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3',0),(301527,8376,'hi','Timeclock Piecework à¤•à¤¾à¤°à¥à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(301528,8376,'ms','Menambah fungsi-fungsi Timeclock Piecework',0),(301529,8376,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(301530,8376,'fr','Ajouter des fonctions de travail Ã  la piÃ¨ce Timeclock',0),(301531,8376,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯å‡ºæ¥é«˜æ‰•ã„æ©Ÿèƒ½è¿½åŠ ã—ã¾ã™ã€‚',0),(301532,8376,'pt','Adicionar funÃ§Ãµes de trabalho por tarefa timeclock',0),(301533,8376,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ TimeClock ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(301534,8376,'es','Reloj Checador Funciones de Trabajo por Pieza Agregar',0),(301535,8376,'de','Timeclock Akkordarbeit Funktionen hinzufÃ¼gen',0),(301536,8376,'en','Timeclock Piecework Functions Add',0),(301537,8377,'is','',0),(301538,8377,'dr','Ù‚Ø±Ø§Ø¯Ø§Ø¯ Ø¹Ù…Ù„ÙŠØ§Øª',0),(301539,8377,'pr','Ù‚Ø±Ø§Ø¯Ø§Ø¯ Ø¹Ù…Ù„ÙŠØ§Øª',0),(301540,8377,'tr','ParÃ§a baÅŸÄ± iÅŸ eylemi',0),(301541,8377,'pl','Akcja pracy akordowej',0),(301542,8377,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(301543,8377,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ú©Ø§Ø±Ø±ÙˆØ§Ø¦ÛŒ',0),(301544,8377,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(301545,8377,'vi','HÃ nh Ä‘á»™ng Viá»‡c khoÃ¡n',0),(301546,8377,'af','Stukwerk Aksies',0),(301547,8377,'ro','Acord de acÅ£iune',0),(301548,8377,'et','TÃ¼kitÃ¶Ã¶ tegevus',0),(301549,8377,'si','Akord dejanje',0),(301550,8377,'ba','Aksi piecework',0),(301551,8377,'nl','Stukloon actie',0),(301552,8377,'fi','Urakka toiminta',0),(301553,8377,'no','StykkavlÃ¸nning handling',0),(301554,8377,'da','Akkordarbejde handling',0),(301555,8377,'ko','Piecework ìž‘ì—…',0),(301556,8377,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª ×¤×¢×•×œ×”',0),(301557,8377,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹ Î´ÏÎ¬ÏƒÎ·Ï‚',0),(301558,8377,'zh','è®¡ä»¶è¡ŒåŠ¨\r\n',0),(301559,8377,'sv','Ackord Ã¥tgÃ¤rder',0),(301560,8377,'it','Azione di lavoro a cottimo',0),(301561,8377,'tl','',0),(301562,8377,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3585;&#3633;&#3610;&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;',0),(301563,8377,'hi','Piecework à¤•à¥à¤°à¤¿à¤¯à¤¾',0),(301564,8377,'ms','Tindakan piecework',0),(301565,8377,'ar','Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(301566,8377,'fr','Action de travail Ã  la piÃ¨ce',0),(301567,8377,'jp','å‡ºæ¥é«˜æ‰•ã„ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(301568,8377,'pt','AÃ§Ã£o do trabalho por tarefa',0),(301569,8377,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½Ð°Ñ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹',0),(301570,8377,'es','AcciÃ³n de Trabajo por Pieza',0),(301571,8377,'de','Akkord-Aktion',0),(301572,8377,'en','Piecework Action',0),(301573,8378,'is','',0),(301574,8378,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(301575,8378,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(301576,8378,'tr','TimeClock parÃ§a baÅŸÄ± iÅŸ iÅŸlemleri gÃ¼ncelleyin',0),(301577,8378,'pl','TimeClock akord dziaÅ‚aÅ„ aktualizacji',0),(301578,8378,'bg','TimeClock Ð¿Ð°Ñ€Ñ‡Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(301579,8378,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ø§Ø¹Ù…Ø§Ù„ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(301580,8378,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ñ€Ð°Ð´ÑšÐµ',0),(301581,8378,'vi','Cáº­p nháº­t hÃ nh Ä‘á»™ng giá» khoÃ¡n cá»§a mÃ¡y cháº¥m cÃ´ng',0),(301582,8378,'af','Tydklok Stukwerk Aksies Opdateer',0),(301583,8378,'ro','Acord ceas acÅ£iunile Update',0),(301584,8378,'et','TimeClock tÃ¼kitÃ¶Ã¶ tegevuste Update',0),(301585,8378,'si','Akord TimeClock dejanja Update',0),(301586,8378,'ba','Timeclock Piecework tindakan Update',0),(301587,8378,'nl','Klok stukloon acties Update',0),(301588,8378,'fi','Timeclock urakkatyÃ¶n toiminnot pÃ¤ivitys',0),(301589,8378,'no','TimeClock stykkavlÃ¸nning handlingene oppdateringen',0),(301590,8378,'da','Timeclock akkordarbejde handlinger opdatering',0),(301591,8378,'ko','Timeclock Piecework ìž‘ì—… ì—…ë°ì´íŠ¸',0),(301592,8378,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª Timeclock ×¤×¢×•×œ×•×ª ×¢×“×›×•×Ÿ',0),(301593,8378,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Î´ÏÎ¬ÏƒÎµÎ¹Ï‚ Timeclock ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(301594,8378,'zh','æ—¶é’Ÿè®¡ä»¶è¡ŒåŠ¨æ›´æ–°\r\n',0),(301595,8378,'sv','Timeclock ackord Ã¥tgÃ¤rder uppdatera',0),(301596,8378,'it','Aggiornamento azioni a cottimo Timeclock',0),(301597,8378,'tl','',0),(301598,8378,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3',0),(301599,8378,'hi','Timeclock Piecework à¤•à¤¾à¤°à¥à¤¯à¥‹à¤‚ à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(301600,8378,'ms','Timeclock Piecework tindakan Kemaskini',0),(301601,8378,'ar','ØªØ­Ø¯ÙŠØ« Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(301602,8378,'fr','Mise Ã  jour de travail Ã  la piÃ¨ce Timeclock Actions',0),(301603,8378,'jp','å‡ºæ¥é«˜æ‰•ã„ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ã‚¢ã‚¯ã‚·ãƒ§ãƒ³æ›´æ–°ã—ã¾ã™ã€‚',0),(301604,8378,'pt','Trabalho por tarefa timeclock aÃ§Ãµes Update',0),(301605,8378,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹ TimeClock ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(301606,8378,'es','Reloj Checador Acciones de Trabajo por Pieza Actualizar',0),(301607,8378,'de','Timeclock Akkordarbeit Aktionen Update',0),(301608,8378,'en','Timeclock Piecework Actions Update',0),(301609,8379,'is','',0),(301610,8379,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(301611,8379,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(301612,8379,'tr','ParÃ§a baÅŸÄ± iÅŸ alanÄ±',0),(301613,8379,'pl','Obszar pracy akordowej',0),(301614,8379,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ð¾Ð±Ð»Ð°ÑÑ‚',0),(301615,8379,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ø¹Ù„Ø§Ù‚Û’',0),(301616,8379,'sr','ÐžÐ±Ð»Ð°ÑÑ‚ Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(301617,8379,'vi','Khu vá»±c Viá»‡c khoÃ¡n',0),(301618,8379,'af','Stukwerk Area',0),(301619,8379,'ro','Zona de acord',0),(301620,8379,'et','TÃ¼kitÃ¶Ã¶ ala',0),(301621,8379,'si','Akord obmoÄje',0),(301622,8379,'ba','Piecework daerah',0),(301623,8379,'nl','Stukloon gebied',0),(301624,8379,'fi','Urakka-alue',0),(301625,8379,'no','StykkavlÃ¸nning omrÃ¥det',0),(301626,8379,'da','Akkordarbejde omrÃ¥de',0),(301627,8379,'ko','Piecework ì˜ì—­',0),(301628,8379,'he','××–×•×¨ ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(301629,8379,'el','Î ÎµÏÎ¹Î¿Ï‡Î® ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(301630,8379,'zh','è®¡ä»¶åŒº\r\n',0),(301631,8379,'sv','Ackord omrÃ¥de',0),(301632,8379,'it','Area di lavoro a cottimo',0),(301633,8379,'tl','',0),(301634,8379,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;',0),(301635,8379,'hi','Piecework à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(301636,8379,'ms','Kawasan piecework',0),(301637,8379,'ar','Ù…Ø¬Ø§Ù„ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(301638,8379,'fr','Zone de travail Ã  la piÃ¨ce',0),(301639,8379,'jp','å‡ºæ¥é«˜æ‰•ã„ã‚¨ãƒªã‚¢',0),(301640,8379,'pt','Ãrea de trabalho por tarefa',0),(301641,8379,'ru','ÐŸÐ»Ð¾Ñ‰Ð°Ð´ÑŒ ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(301642,8379,'es','Ãrea de Trabajo por Pieza',0),(301643,8379,'de','Akkord-Bereich',0),(301644,8379,'en','Piecework Area',0),(301645,8380,'is','',0),(301646,8380,'dr','(ØªÙˆØ§Ø¨Ø¹) Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(301647,8380,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ (ØªÙˆØ§Ø¨Ø¹) Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(301648,8380,'tr','TimeClock parÃ§a baÅŸÄ± iÅŸ alanÄ± ekle',0),(301649,8380,'pl','DodaÄ‡ TimeClock obszar pracy akordowej',0),(301650,8380,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° TimeClock Ð¿Ð°Ñ€Ñ‡Ðµ Ð¾Ð±Ð»Ð°ÑÑ‚',0),(301651,8380,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ø¹Ù„Ø§Ù‚Û Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(301652,8380,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð¾Ð±Ð»Ð°ÑÑ‚',0),(301653,8380,'vi','ThÃªm khu vá»±c MÃ¡y cháº¥m cÃ´ng viá»‡c khoÃ¡n',0),(301654,8380,'af','Tydklok Stukwerk Areas Skep',0),(301655,8380,'ro','Zona de acord ceas Adauga',0),(301656,8380,'et','TimeClock tÃ¼kitÃ¶Ã¶ ala lisamine',0),(301657,8380,'si','Dodaj TimeClock akord obmoÄje',0),(301658,8380,'ba','Tambahkan timeclock Piecework Area',0),(301659,8380,'nl','Klok stukloon gebied toevoegen',0),(301660,8380,'fi','Timeclock urakka alueella lisÃ¤Ã¤',0),(301661,8380,'no','TimeClock stykkavlÃ¸nning omrÃ¥det legge',0),(301662,8380,'da','Timeclock akkordarbejde omrÃ¥de tilfÃ¸je',0),(301663,8380,'ko','Timeclock Piecework ì§€ì—­ ì¶”ê°€',0),(301664,8380,'he','×”×•×¡×£ ××–×•×¨ ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª Timeclock',0),(301665,8380,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Timeclock ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(301666,8380,'zh','æ—¶é’Ÿè®¡ä»¶åŒºæ–°å¢ž\r\n',0),(301667,8380,'sv','Timeclock ackord omrÃ¥de lÃ¤gga till',0),(301668,8380,'it','Aggiungi Area a cottimo Timeclock',0),(301669,8380,'tl','',0),(301670,8380,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3651;&#3609;&#3614;&#3639;&#3657;&#3609;&#3',0),(301671,8380,'hi','Timeclock Piecework à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(301672,8380,'ms','Menambah kawasan Piecework Timeclock',0),(301673,8380,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ø§Ù„ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(301674,8380,'fr','Zone de travail Ã  la piÃ¨ce Timeclock ajouter',0),(301675,8380,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯å‡ºæ¥é«˜æ‰•ã„é ˜åŸŸã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(301676,8380,'pt','Ãrea de trabalho por tarefa timeclock adicionar',0),(301677,8380,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ TimeClock ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(301678,8380,'es','Reloj Checador Ãrea de Trabajo por Pieza Agregar',0),(301679,8380,'de','Timeclock Akkordarbeit Bereich hinzuzufÃ¼gen',0),(301680,8380,'en','Timeclock Piecework Area Add',0),(301681,8381,'is','',0),(301682,8381,'dr','( ØªÙˆØ§Ø¨Ø¹ ',0),(301683,8381,'pr','ÙˆØ¸Ø§ÙŠÙ ( ØªÙˆØ§Ø¨Ø¹ ',0),(301684,8381,'tr','Ä°ÅŸlevleri',0),(301685,8381,'pl','Funkcje',0),(301686,8381,'bg','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(301687,8381,'ur','Ø§ÙØ¹Ø§Ù„',0),(301688,8381,'sr','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ',0),(301689,8381,'vi','Chá»©c nÄƒng',0),(301690,8381,'af','Funksies',0),(301691,8381,'ro','FuncÅ£ii',0),(301692,8381,'et','Funktsioonid',0),(301693,8381,'si','Funkcije',0),(301694,8381,'ba','Fungsi',0),(301695,8381,'nl','Functies',0),(301696,8381,'fi','Toiminnot',0),(301697,8381,'no','Funksjoner',0),(301698,8381,'da','Funktioner',0),(301699,8381,'ko','í•¨ìˆ˜',0),(301700,8381,'he','×¤×•× ×§×¦×™×•×ª',0),(301701,8381,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚',0),(301702,8381,'zh','åŠŸèƒ½\r\n',0),(301703,8381,'sv','Funktioner',0),(301704,8381,'it','Funzioni',0),(301705,8381,'tl','',0),(301706,8381,'th','&#3627;&#3609;&#3657;&#3634;&#3607;&#3637;&#3656;',0),(301707,8381,'hi','à¤«à¤¼à¤‚à¤•à¥à¤¶à¤‚à¤¸',0),(301708,8381,'ms','Fungsi-fungsi',0),(301709,8381,'ar','ÙˆØ¸Ø§Ø¦Ù',0),(301710,8381,'fr','Fonctions',0),(301711,8381,'jp','é–¢æ•°',0),(301712,8381,'pt','FunÃ§Ãµes',0),(301713,8381,'ru','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(301714,8381,'es','Funciones',0),(301715,8381,'de','Funktionen',0),(301716,8381,'en','Functions',0),(301717,8382,'is','',0),(301718,8382,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(301719,8382,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(301720,8382,'tr','TimeClock parÃ§a baÅŸÄ± iÅŸ alanlarÄ±nÄ± gÃ¼ncelleÅŸtir',0),(301721,8382,'pl','Akord TimeClock obszarÃ³w aktualizacji',0),(301722,8382,'bg','TimeClock Ð¿Ð°Ñ€Ñ‡Ðµ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(301723,8382,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ø¹Ù„Ø§Ù‚ÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(301724,8382,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð¿Ð¾Ð´Ñ€ÑƒÑ‡Ñ˜Ð°',0),(301725,8382,'vi','Cáº­p nháº­t khu vá»±c khoÃ¡n cá»§a mÃ¡y cháº¥m cÃ´ng',0),(301726,8382,'af','Tydklok Stukwerk Areas Opdateer',0),(301727,8382,'ro','Ceas acord zonele Update',0),(301728,8382,'et','TimeClock tÃ¼kitÃ¶Ã¶ valdkondades Update',0),(301729,8382,'si','Akord TimeClock podroÄja posodobitev',0),(301730,8382,'ba','Timeclock Piecework daerah Update',0),(301731,8382,'nl','Klok stukloon gebieden Update',0),(301732,8382,'fi','Timeclock urakka alueilla pÃ¤ivitys',0),(301733,8382,'no','TimeClock stykkavlÃ¸nning omrÃ¥der oppdatering',0),(301734,8382,'da','Timeclock akkordarbejde omrÃ¥der opdatering',0),(301735,8382,'ko','Timeclock Piecework ì§€ì—­ ì—…ë°ì´íŠ¸',0),(301736,8382,'he','×¢×“×›×•×Ÿ ××–×•×¨×™ ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª Timeclock',0),(301737,8382,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÎµÏÎ¹Î¿Ï‡Î­Ï‚ Timeclock ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(301738,8382,'zh','æ—¶é’Ÿè®¡ä»¶åŒºæ›´æ–°\r\n',0),(301739,8382,'sv','Timeclock ackord omrÃ¥den uppdatering',0),(301740,8382,'it','Aggiornamento aree a cottimo Timeclock',0),(301741,8382,'tl','',0),(301742,8382,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3651;&#3609;&#3614;&#3',0),(301743,8382,'hi','Timeclock Piecework à¤•à¥à¤·à¥‡à¤¤à¥à¤°à¥‹à¤‚ à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(301744,8382,'ms','Kemaskini Terakhir Timeclock Piecework kawasan',0),(301745,8382,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¬Ø§Ù„Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(301746,8382,'fr','Mise Ã  jour de zones Timeclock Ã  la piÃ¨ce',0),(301747,8382,'jp','å‡ºæ¥é«˜æ‰•ã„ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ã‚¨ãƒªã‚¢ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(301748,8382,'pt','AtualizaÃ§Ã£o de Ã¡reas de trabalho por tarefa timeclock',0),(301749,8382,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð±Ð»Ð°ÑÑ‚ÐµÐ¹ TimeClock ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(301750,8382,'es','Reloj Checador Ãreas de Trabajo por Pieza Actualizar',0),(301751,8382,'de','Timeclock Akkordarbeit Bereiche Update',0),(301752,8382,'en','Timeclock Piecework Areas Update',0),(301753,8383,'is','',0),(301754,8383,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(301755,8383,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(301756,8383,'tr','GÃ¼ncelleÅŸtirme TimeClock parÃ§a baÅŸÄ± iÅŸ fonksiyonlarÄ±',0),(301757,8383,'pl','Akord TimeClock funkcje aktualizacji',0),(301758,8383,'bg','TimeClock Ð¿Ð°Ñ€Ñ‡Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(301759,8383,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø§Ù… Ú©Ø±ØªØ§ ÛÛ’ Û”',0),(301760,8383,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(301761,8383,'vi','Cáº­p nháº­t chá»©c nÄƒng khoÃ¡n cá»§a mÃ¡y cháº¥m cÃ´ng',0),(301762,8383,'af','Tydklok Stukwerk Funksies Opdateer',0),(301763,8383,'ro','Ceas acord funcÅ£ii de actualizare',0),(301764,8383,'et','TimeClock tÃ¼kitÃ¶Ã¶ funktsioneerib Update',0),(301765,8383,'si','Akord TimeClock funkcije Update',0),(301766,8383,'ba','Timeclock Piecework fungsi Update',0),(301767,8383,'nl','Klok stukloon functies Update',0),(301768,8383,'fi','Timeclock urakkatyÃ¶n toiminnot pÃ¤ivitys',0),(301769,8383,'no','TimeClock stykkavlÃ¸nning fungerer oppdateringen',0),(301770,8383,'da','Timeclock akkordarbejde fungerer opdateringen',0),(301771,8383,'ko','Timeclock Piecework ê¸°ëŠ¥ ì—…ë°ì´íŠ¸',0),(301772,8383,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª Timeclock ×¤×•× ×§×¦×™×•×ª ×¢×“×›×•×Ÿ',0),(301773,8383,'el','Timeclock ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³ÎµÎ¯ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(301774,8383,'zh','æ—¶é’Ÿè®¡ä»¶åŠŸèƒ½æ›´æ–°\r\n',0),(301775,8383,'sv','Timeclock ackord fungerar uppdateringen',0),(301776,8383,'it','A cottimo Timeclock funzioni di aggiornamento',0),(301777,8383,'tl','',0),(301778,8383,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3656;&#3609;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3',0),(301779,8383,'hi','Timeclock Piecework à¤•à¤¾à¤® à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(301780,8383,'ms','Timeclock Piecework fungsi Kemaskini',0),(301781,8383,'ar','ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(301782,8383,'fr','Travail Ã  la piÃ¨ce Timeclock fonctions mise Ã  jour',0),(301783,8383,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯å‡ºæ¥é«˜æ‰•ã„æ©Ÿèƒ½ã®æ›´æ–°',0),(301784,8383,'pt','Trabalho por tarefa timeclock funÃ§Ãµes de atualizaÃ§Ã£o',0),(301785,8383,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½Ð°Ñ TimeClock Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(301786,8383,'es','Reloj Checador Funciones de Trabajo por Pieza Actualizar',0),(301787,8383,'de','Timeclock Akkordarbeit Funktionen Update',0),(301788,8383,'en','Timeclock Piecework Functions Update',0),(301789,8384,'is','',0),(301790,8384,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¯Ø± Ø³Ø§Ø¹Øª ÙƒØ§Ø±ÙŠ ',0),(301791,8384,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¯Ø± Ø³Ø§Ø¹Øª ÙƒØ§Ø±ÙŠ ',0),(301792,8384,'tr','ParÃ§a baÅŸÄ± iÅŸ yolda Timeclock',0),(301793,8384,'pl','UtwÃ³r Timeclock pracy akordowej',0),(301794,8384,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ð¿ÐµÑÐµÐ½ Timeclock',0),(301795,8384,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾Ø± Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ù¹Ø±ÛŒÚ©',0),(301796,8384,'sr','Ð¡Ñ‚Ð°Ð·Ñƒ Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð½Ð° Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº',0),(301797,8384,'vi','Theo dÃµi Viá»‡c khoÃ¡n trÃªn Ä‘á»“ng há»“ cháº¥m cÃ´ng',0),(301798,8384,'af','Stukwerk Gespoor op Tydklok',0),(301799,8384,'ro','Piesa de acord pe ceas',0),(301800,8384,'et','TÃ¼kitÃ¶Ã¶ tsentreerimise Timeclock',0),(301801,8384,'si','Akord skladbo na Timeclock',0),(301802,8384,'ba','Lagu piecework pada Timeclock',0),(301803,8384,'nl','Stukloon Track op klok',0),(301804,8384,'fi','Urakka kappale Timeclock',0),(301805,8384,'no','StykkavlÃ¸nning spor pÃ¥ Timeclock',0),(301806,8384,'da','Akkordarbejde spor pÃ¥ Timeclock',0),(301807,8384,'ko','Piecework íŠ¸ëž™ Timeclock',0),(301808,8384,'he','×¢×§×•×‘ ××—×¨ ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª-Timeclock',0),(301809,8384,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹ ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ ÏƒÏ„Î¿ Timeclock',0),(301810,8384,'zh','åŒæ­¥æ—¶é—´è®¡ä»¶è·Ÿè¸ª\r\n',0),(301811,8384,'sv','Ackord spÃ¥r pÃ¥ Timeclock',0),(301812,8384,'it','Traccia di lavoro a cottimo Timeclock',0),(301813,8384,'tl','',0),(301814,8384,'th','&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;',0),(301815,8384,'hi','Timeclock à¤ªà¤° piecework à¤Ÿà¥à¤°à¥ˆà¤•',0),(301816,8384,'ms','Lagu piecework Timeclock',0),(301817,8384,'ar','Ù…Ø³Ø§Ø± Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© Ø¹Ù„Ù‰ ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(301818,8384,'fr','Piste de travail Ã  la piÃ¨ce sur Timeclock',0),(301819,8384,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ã«å‡ºæ¥é«˜æ‰•ã„ãƒˆãƒ©ãƒƒã‚¯',0),(301820,8384,'pt','Faixa de trabalho por tarefa no Timeclock',0),(301821,8384,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½Ð°Ñ Ñ‚Ñ€ÐµÐº Ð½Ð° Timeclock',0),(301822,8384,'es','Rastreo de Trabajo por Pieza en el Registrador de Tiempo',0),(301823,8384,'de','Akkord-Track auf Timeclock',0),(301824,8384,'en','Piecework Track on Timeclock',0),(301825,8385,'is','',0),(301826,8385,'dr','ØªØºÙŠÙŠØ± Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ ',0),(301827,8385,'pr','ØªØºÙŠÙŠØ± Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ ',0),(301828,8385,'tr','TimeClock Shift',0),(301829,8385,'pl','TimeClock Shift',0),(301830,8385,'bg','TimeClock Shift',0),(301831,8385,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ø´ÙÙ¹',0),(301832,8385,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð¡Ñ…Ð¸Ñ„Ñ‚',0),(301833,8385,'vi','MÃ¡y cháº¥m cÃ´ng ca',0),(301834,8385,'af','Tydklok Skof',0),(301835,8385,'ro','Ceas Shift',0),(301836,8385,'et','TimeClock Shift',0),(301837,8385,'si','TimeClock Shift',0),(301838,8385,'ba','Timeclock Shift',0),(301839,8385,'nl','Klok Shift',0),(301840,8385,'fi','Timeclock vaihto',0),(301841,8385,'no','TimeClock SKIFT',0),(301842,8385,'da','Timeclock Skift',0),(301843,8385,'ko','Timeclock ì‹œí”„íŠ¸',0),(301844,8385,'he','Timeclock ×ž×©×ž×¨×ª',0),(301845,8385,'el','Timeclock Shift',0),(301846,8385,'zh','æ—¶é’Ÿæ›¿æ¢\r\n',0),(301847,8385,'sv','Timeclock SKIFT',0),(301848,8385,'it','Timeclock Shift',0),(301849,8385,'tl','',0),(301850,8385,'th','&#3648;&#3621;&#3639;&#3656;&#3629;&#3609;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(301851,8385,'hi','Timeclock à¤¶à¤¿à¤«à¥à¤Ÿ',0),(301852,8385,'ms','Anjakan Timeclock',0),(301853,8385,'ar','ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ Shift',0),(301854,8385,'fr','Timeclock Maj',0),(301855,8385,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ã‚·ãƒ•ãƒˆ',0),(301856,8385,'pt','Timeclock Shift',0),(301857,8385,'ru','TimeClock ÑÐ´Ð²Ð¸Ð³',0),(301858,8385,'es','Turno de Reloj Checador',0),(301859,8385,'de','Timeclock Shift',0),(301860,8385,'en','Timeclock Shift',0),(301861,8386,'is','',0),(301862,8386,'dr','Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±',0),(301863,8386,'pr','Ù¾Ø³Øª ÙƒØ±Ø¯Ù† Ø«Ø¨Øª Ù‡Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±',0),(301864,8386,'tr','Onaylanan Timeclock giriÅŸleri',0),(301865,8386,'pl','Zatwierdzone Timeclock wpisÃ³w',0),(301866,8386,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ‚Ðµ Timeclock Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(301867,8386,'ur','Ù¾ÙˆØ³Ù¹ Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(301868,8386,'sr','ÐšÑšÐ¸Ð¶ÐµÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ… Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº',0),(301869,8386,'vi','Káº¿t chuyá»ƒn thá»i gian cháº¥m cÃ´ng',0),(301870,8386,'af','Pos Goedgekeurde Tydklok Inskrywings',0),(301871,8386,'ro','Post aprobat ceas intrÄƒri',0),(301872,8386,'et','Heakskiidetud Timeclock kannete konteerimine',0),(301873,8386,'si','Objava vnosov odobrenih Timeclock',0),(301874,8386,'ba','Posting disetujui Timeclock entri',0),(301875,8386,'nl','Goedgekeurde klok posten',0),(301876,8386,'fi','HyvÃ¤ksytyn Timeclock tapahtumat',0),(301877,8386,'no','Poster godkjente Timeclock oppfÃ¸ringer',0),(301878,8386,'da','BogfÃ¸ring af godkendte Timeclock',0),(301879,8386,'ko','ê²Œì‹œë¬¼ ìŠ¹ì¸ Timeclock í•­ëª©',0),(301880,8386,'he','×¤×•×¡×˜ ×ž××•×©×¨ Timeclock ×¢×¨×›×™×',0),(301881,8386,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ ÎµÎ³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Timeclock',0),(301882,8386,'zh','å‘å¸ƒæ‰¹å‡†çš„æ—¶é’Ÿæ¡ç›®\r\n',0),(301883,8386,'sv','BokfÃ¶r godkÃ¤nda Timeclock',0),(301884,8386,'it','Post approvato Timeclock voci',0),(301885,8386,'tl','',0),(301886,8386,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;',0),(301887,8386,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ Timeclock à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥€',0),(301888,8386,'ms','Post diluluskan entri Timeclock',0),(301889,8386,'ar','Ù†Ø´Ø± Ø¥Ø¯Ø®Ø§Ù„Ø§Øª ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ Ø§Ù„Ù…Ø¹ØªÙ…Ø¯Ø©',0),(301890,8386,'fr','Poste approuvÃ©e Timeclock entrÃ©es',0),(301891,8386,'jp','ãƒã‚¹ãƒˆæ‰¿èªã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ã‚¨ãƒ³ãƒˆãƒª',0),(301892,8386,'pt','Post aprovado Timeclock entradas',0),(301893,8386,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð° Ð´Ð¾Ð»Ð¶Ð½Ð¾ÑÑ‚ÑŒ Timeclock Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(301894,8386,'es','Asentar Entradas Aprobadas de Reloj Checador',0),(301895,8386,'de','Post genehmigt Timeclock EintrÃ¤ge',0),(301896,8386,'en','Post Approved Timeclock Entries',0),(301897,8387,'is','',0),(301898,8387,'dr','Ù¾Ø³Øª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(301899,8387,'pr','Ù¾Ø³Øª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(301900,8387,'tr','Post baÅŸarÄ±sÄ±z oldu',0),(301901,8387,'pl','Post nie powiodÅ‚o siÄ™',0),(301902,8387,'bg','ÐŸÐ¾ÑÑ‚ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(301903,8387,'ur','Ù¾ÙˆØ³Ù¹ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§',0),(301904,8387,'sr','ÐŸÐ¾ÑÑ‚ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(301905,8387,'vi','Káº¿t chuyá»ƒn tháº¥t báº¡i',0),(301906,8387,'af','Post het misluk',0),(301907,8387,'ro','Post nu a reuÈ™it',0),(301908,8387,'et','Post ei saanud',0),(301909,8387,'si','Objava ni uspela',0),(301910,8387,'ba','Posting gagal',0),(301911,8387,'nl','Bericht is mislukt',0),(301912,8387,'fi','Post epÃ¤onnistui',0),(301913,8387,'no','Innlegget mislyktes',0),(301914,8387,'da','Post mislykkedes',0),(301915,8387,'ko','í¬ìŠ¤íŠ¸ ì‹¤íŒ¨',0),(301916,8387,'he','×“×•××¨ × ×›×©×œ',0),(301917,8387,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· Î¸Î­ÏƒÎ·',0),(301918,8387,'zh','å‘å¸ƒå¤±è´¥\r\n',0),(301919,8387,'sv','InlÃ¤gget misslyckades',0),(301920,8387,'it','Post non riuscita',0),(301921,8387,'tl','',0),(301922,8387,'th','&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(301923,8387,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(301924,8387,'ms','Selepas gagal',0),(301925,8387,'ar','ÙØ´Ù„ ÙÙŠ ÙˆØ¸ÙŠÙØ©',0),(301926,8387,'fr','Post a Ã©chouÃ©',0),(301927,8387,'jp','æŠ•ç¨¿ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(301928,8387,'pt','Post falhou',0),(301929,8387,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ð¾ÑÑ‚',0),(301930,8387,'es','Asentar FallÃ³',0),(301931,8387,'de','Post ist fehlgeschlagen',0),(301932,8387,'en','Post Failed',0),(301933,8388,'is','',0),(301934,8388,'dr','(*) = ØªØ§ÙŠÙŠØ¯ Ø§Ø³Øª',0),(301935,8388,'pr','Ù†Ø´Ø§Ù† Ø³ØªØ§Ø±Ù‡(*) = ØªØ§ÙŠÙŠØ¯ Ø§Ø³Øª',0),(301936,8388,'tr','* = OnayladÄ±',0),(301937,8388,'pl','* = Zatwierdzony',0),(301938,8388,'bg','* = ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¸',0),(301939,8388,'ur','* = Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(301940,8388,'sr','* = ÐžÐ´Ð¾Ð±Ñ€Ð¸Ð¾',0),(301941,8388,'vi','*=Cháº¥p Thuáº­n',0),(301942,8388,'af','*=Goedgekeur',0),(301943,8388,'ro','* = Aprobat',0),(301944,8388,'et','* = Heaks',0),(301945,8388,'si','* = Odobren',0),(301946,8388,'ba','* = Disetujui',0),(301947,8388,'nl','* = Goedgekeurd',0),(301948,8388,'fi','* = HyvÃ¤ksytty',0),(301949,8388,'no','* = Godkjent',0),(301950,8388,'da','* = Godkendt',0),(301951,8388,'ko','* = ìŠ¹ì¸',0),(301952,8388,'he','* = ××•×©×¨',0),(301953,8388,'el','* = Î•Î³ÎºÏÎ¹Î¸ÎµÎ¯',0),(301954,8388,'zh','* = æ ¸å‡†\r\n',0),(301955,8388,'sv','* = GodkÃ¤nd',0),(301956,8388,'it','* = Approvato',0),(301957,8388,'tl','',0),(301958,8388,'th','*=&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;',0),(301959,8388,'hi','* = à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥€',0),(301960,8388,'ms','* = Diluluskan',0),(301961,8388,'ar','* = ÙˆØ§ÙÙ‚Øª',0),(301962,8388,'fr','* = ApprouvÃ©',0),(301963,8388,'jp','* = æ‰¿èª',0),(301964,8388,'pt','* = Aprovado',0),(301965,8388,'ru','* = ÐžÐ´Ð¾Ð±Ñ€Ð¸Ð»',0),(301966,8388,'es','*=Aprobado',0),(301967,8388,'de','* = Genehmigt',0),(301968,8388,'en','*=Approved',0),(301969,8389,'is','',0),(301970,8389,'dr','Ù†Ø±Ø® Ù¾Ø§ÙŠÙ‡',0),(301971,8389,'pr','Ù†Ø±Ø® Ù¾Ø§ÙŠÙ‡',0),(301972,8389,'tr','Taban oranÄ±',0),(301973,8389,'pl','Podstawowa stopa procentowa',0),(301974,8389,'bg','ÐžÑÐ½Ð¾Ð²ÐµÐ½ Ð»Ð¸Ñ…Ð²ÐµÐ½ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(301975,8389,'ur','Ø¨ÛŒØ³ Ú©ÛŒ Ø´Ø±Ø­',0),(301976,8389,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð¸ ÐºÑƒÑ€Ñ',0),(301977,8389,'vi','GiÃ¡ gá»‘c',0),(301978,8389,'af','Basisloon',0),(301979,8389,'ro','Rata de bazÄƒ',0),(301980,8389,'et','Baasintressi',0),(301981,8389,'si','Osnovni teÄaj',0),(301982,8389,'ba','Tingkat dasar',0),(301983,8389,'nl','Basistarief',0),(301984,8389,'fi','Peruskorko',0),(301985,8389,'no','Base Rate',0),(301986,8389,'da','Base Rate',0),(301987,8389,'ko','ê¸°ë³¸ ìš”ê¸ˆ',0),(301988,8389,'he','×”×¡×ª×‘×¨×•×ª',0),(301989,8389,'el','Î’Î±ÏƒÎ¹ÎºÏŒ ÎµÏ€Î¹Ï„ÏŒÎºÎ¹Î¿',0),(301990,8389,'zh','åŸºæœ¬åˆ©çŽ‡\r\n',0),(301991,8389,'sv','BasrÃ¤ntan',0),(301992,8389,'it','Tasso base',0),(301993,8389,'tl','',0),(301994,8389,'th','&#3600;&#3634;&#3609;&#3629;&#3633;&#3605;&#3619;&#3634;',0),(301995,8389,'hi','à¤†à¤§à¤¾à¤° à¤¦à¤°',0),(301996,8389,'ms','Kadar asas',0),(301997,8389,'ar','Ø§Ù„Ù…Ø¹Ø¯Ù„ Ø§Ù„Ø£Ø³Ø§Ø³ÙŠ',0),(301998,8389,'fr','Tarif de base',0),(301999,8389,'jp','åŸºæœ¬æ–™é‡‘',0),(302000,8389,'pt','Taxa base',0),(302001,8389,'ru','Ð‘Ð°Ð·Ð¾Ð²Ð°Ñ ÑÑ‚Ð°Ð²ÐºÐ°',0),(302002,8389,'es','Base Tasa de',0),(302003,8389,'de','Basiszinssatz',0),(302004,8389,'en','Base Rate',0),(302005,8390,'is','',0),(302006,8390,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø«Ø¨ØªÙ‡Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ ',0),(302007,8390,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø«Ø¨ØªÙ‡Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ ',0),(302008,8390,'tr','TimeClock girdilerini dÃ¼zenlemek',0),(302009,8390,'pl','EdytowaÄ‡ wpisy Timeclock',0),(302010,8390,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð° Timeclock',0),(302011,8390,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ø§Ù†Ø¯Ø±Ø§Ø¬ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(302012,8390,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº',0),(302013,8390,'vi','Sá»­a Entry MÃ¡y Cháº¥m CÃ´ng  ',0),(302014,8390,'af','Redigeer Tydklok Inskrywings',0),(302015,8390,'ro','Edita intrÄƒri de ceas',0),(302016,8390,'et','Redigeeri Timeclock kanded',0),(302017,8390,'si','Urejanje Timeclock postavke',0),(302018,8390,'ba','Mengedit entri Timeclock',0),(302019,8390,'nl','De klok items bewerken',0),(302020,8390,'fi','Timeclock muokata',0),(302021,8390,'no','Redigere Timeclock oppfÃ¸ringer',0),(302022,8390,'da','Rediger Timeclock poster',0),(302023,8390,'ko','Timeclock í•­ëª© íŽ¸ì§‘',0),(302024,8390,'he','×¢×¨×•×š ×¤×¨×™×˜×™× Timeclock',0),(302025,8390,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Timeclock',0),(302026,8390,'zh','ç¼–è¾‘æ—¶é’Ÿæ¡ç›®\r\n',0),(302027,8390,'sv','Redigera Timeclock poster',0),(302028,8390,'it','Modificare le voci Timeclock',0),(302029,8390,'tl','',0),(302030,8390,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619; Timeclock ',0),(302031,8390,'hi','Timeclock à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(302032,8390,'ms','Edit entri Timeclock',0),(302033,8390,'ar','ØªØ­Ø±ÙŠØ± Ø¥Ø¯Ø®Ø§Ù„Ø§Øª ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(302034,8390,'fr','Modifier les entrÃ©es d\'horloge',0),(302035,8390,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ã‚¨ãƒ³ãƒˆãƒªã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(302036,8390,'pt','Editar entradas de Timeclock',0),(302037,8390,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð§Ð°ÑÐ¾Ð²',0),(302038,8390,'es','Editar Entradas de RelÃ³j Checador',0),(302039,8390,'de','Timeclock EintrÃ¤ge bearbeiten',0),(302040,8390,'en','Edit Timeclock Entries',0),(302041,8391,'is','',0),(302042,8391,'dr','Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±Ù‰',0),(302043,8391,'pr','Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±Ù‰',0),(302044,8391,'tr','Saat fazla mesai',0),(302045,8391,'pl','Godziny nadliczbowe',0),(302046,8391,'bg','Ð§Ð°ÑÐ¾Ð²Ðµ Ð¸Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´ÐµÐ½ Ñ‚Ñ€ÑƒÐ´',0),(302047,8391,'ur','Ú¯Ú¾Ù†Ù¹ÙˆÚº Ø§ÙˆÙˆØ±Ù¹Ø§Ø¦Ù…',0),(302048,8391,'sr','Ð¡Ð°Ñ‚Ð¸ Ð¿Ñ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¾.',0),(302049,8391,'vi','Giá» lÃ m thÃªm',0),(302050,8391,'af','Ure Oortyd',0),(302051,8391,'ro','Ore Overtime',0),(302052,8391,'et','Ãœletundi',0),(302053,8391,'si','Ur nadurno delo',0),(302054,8391,'ba','Jam lembur',0),(302055,8391,'nl','Uur overwerk',0),(302056,8391,'fi','Tuntia ylityÃ¶tÃ¤',0),(302057,8391,'no','Timer overtid',0),(302058,8391,'da','Timer overtid',0),(302059,8391,'ko','ì‹œê°„ ì´ˆê³¼ ê·¼ë¬´',0),(302060,8391,'he','×©×¢×•×ª ×©×¢×•×ª × ×•×¡×¤×•×ª',0),(302061,8391,'el','ÎÏÎµÏ‚ Ï…Ï€ÎµÏÏ‰ÏÎ¯Î±',0),(302062,8391,'zh','åŠ ç­\r\n',0),(302063,8391,'sv','Timmar Ã¶vertid',0),(302064,8391,'it','Ore straordinario',0),(302065,8391,'tl','',0),(302066,8391,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3609;&#3629;&#3585;&#3648;&#3623;&#3621;&#3634;&#3591;&#3634;&#3609;',0),(302067,8391,'hi','à¤¸à¤®à¤¯à¥‹à¤ªà¤°à¤¿ à¤˜à¤‚à¤Ÿà¥‡',0),(302068,8391,'ms','Waktu bayaran lebih masa',0),(302069,8391,'ar','Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ',0),(302070,8391,'fr','Heures supplÃ©mentaires',0),(302071,8391,'jp','æ™‚é–“æ®‹æ¥­',0),(302072,8391,'pt','Horas de horas extras',0),(302073,8391,'ru','Ð¡Ð²ÐµÑ€Ñ…ÑƒÑ€Ð¾Ñ‡Ð½Ñ‹Ðµ Ñ‡Ð°ÑÑ‹',0),(302074,8391,'es','Horas Extras',0),(302075,8391,'de','Stunden Ãœberstunden',0),(302076,8391,'en','Hours Overtime',0),(302077,8392,'is','',0),(302078,8392,'dr','Ø³Ø§Ø¹Ø§Øª Ù…Ø¹ÙŠÙ†',0),(302079,8392,'pr','Ø³Ø§Ø¹Ø§Øª Ù…Ø¹ÙŠÙ†',0),(302080,8392,'tr','Saat dÃ¼zenli',0),(302081,8392,'pl','Godziny regularne',0),(302082,8392,'bg','Ð ÐµÐ´Ð¾Ð²ÐµÐ½ Ñ‡Ð°ÑÐ°',0),(302083,8392,'ur','Ø¨Ø§Ù‚Ø§Ø¹Ø¯Ú¯ÛŒ Ø³Û’ Ú¯Ú¾Ù†Ù¹Û’',0),(302084,8392,'sr','Ð¡Ð°Ñ‚Ð¸ Ñ€ÐµÐ´Ð¾Ð²Ð½Ð¾',0),(302085,8392,'vi','Giá» thÆ°á»ng',0),(302086,8392,'af','Uur gereeld',0),(302087,8392,'ro','Ore regulate',0),(302088,8392,'et','Tavaline tund',0),(302089,8392,'si','Ur redno',0),(302090,8392,'ba','Jam reguler',0),(302091,8392,'nl','Reguliere uren',0),(302092,8392,'fi','SÃ¤Ã¤nnÃ¶llinen tuntia',0),(302093,8392,'no','Timer vanlig',0),(302094,8392,'da','Timer regelmÃ¦ssig',0),(302095,8392,'ko','ì‹œê°„ ì¼ì •',0),(302096,8392,'he','×©×¢×•×ª ×¨×’×™×œ',0),(302097,8392,'el','Î¤Î±ÎºÏ„Î¹ÎºÎ­Ï‚ ÏŽÏÎµÏ‚',0),(302098,8392,'zh','å®šæœŸæ—¶é—´\r\n',0),(302099,8392,'sv','Timmar regelbundet',0),(302100,8392,'it','Ore regolari',0),(302101,8392,'tl','',0),(302102,8392,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;&#3611;&#3585;&#3605;&#3636;',0),(302103,8392,'hi','à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ à¤˜à¤‚à¤Ÿà¥‡',0),(302104,8392,'ms','Jam tetap',0),(302105,8392,'ar','Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¹Ø§Ø¯ÙŠØ©',0),(302106,8392,'fr','Heures rÃ©guliÃ¨res',0),(302107,8392,'jp','é€šå¸¸ã®æ™‚é–“',0),(302108,8392,'pt','Horas regulares',0),(302109,8392,'ru','Ð ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ñ‹Ðµ Ñ‡Ð°ÑÑ‹',0),(302110,8392,'es','Horas Regulares',0),(302111,8392,'de','RegelmÃ¤ÃŸige Stunden',0),(302112,8392,'en','Hours Regular',0),(302113,8393,'is','',0),(302114,8393,'dr','Ù†Ø§Ù‡Ø§Ø±',0),(302115,8393,'pr','Ù†Ø§Ù‡Ø§Ø±',0),(302116,8393,'tr','Ã–ÄŸle YemeÄŸi',0),(302117,8393,'pl','Obiad',0),(302118,8393,'bg','ÐžÐ±ÑÐ´',0),(302119,8393,'ur','Ø¯ÙˆÙ¾ÛØ± Ú©Ø§ Ú©Ú¾Ø§Ù†Ø§',0),(302120,8393,'sr','Ð ÑƒÑ‡Ð°Ðº',0),(302121,8393,'vi','Bá»¯a trÆ°a',0),(302122,8393,'af','Etenstyd',0),(302123,8393,'ro','Masa de prÃ¢nz',0),(302124,8393,'et','LÃµunasÃ¶Ã¶k',0),(302125,8393,'si','Kosilo',0),(302126,8393,'ba','Makan Siang',0),(302127,8393,'nl','Lunch',0),(302128,8393,'fi','Lounas',0),(302129,8393,'no','Lunsj',0),(302130,8393,'da','Frokost',0),(302131,8393,'ko','ì ì‹¬ ì‹ì‚¬',0),(302132,8393,'he','××¨×•×—×ª ×¦×”×¨×™×™×',0),(302133,8393,'el','ÎœÎµÏƒÎ·Î¼ÎµÏÎ¹Î±Î½ÏŒ Î³ÎµÏÎ¼Î±',0),(302134,8393,'zh','åˆé¤\r\n',0),(302135,8393,'sv','Lunch',0),(302136,8393,'it','Pranzo',0),(302137,8393,'tl','',0),(302138,8393,'th','&#3629;&#3634;&#3627;&#3634;&#3619;&#3648;&#3607;&#3637;&#3656;&#3618;&#3591;',0),(302139,8393,'hi','à¤¦à¥‹à¤ªà¤¹à¤° à¤•à¤¾ à¤­à¥‹à¤œà¤¨',0),(302140,8393,'ms','Makan Tengahari',0),(302141,8393,'ar','Ø§Ù„ØºØ¯Ø§Ø¡',0),(302142,8393,'fr','DÃ©jeuner',0),(302143,8393,'jp','ãƒ©ãƒ³ãƒ',0),(302144,8393,'pt','AlmoÃ§o',0),(302145,8393,'ru','ÐžÐ±ÐµÐ´',0),(302146,8393,'es','Comida',0),(302147,8393,'de','Mittagessen',0),(302148,8393,'en','Lunch',0),(302149,8394,'is','',0),(302150,8394,'dr','ÙÙ‚Ø· ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ØºÙŠØ± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(302151,8394,'pr','ÙÙ‚Ø· ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ØºÙŠØ± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(302152,8394,'tr','Sadece parÃ§a baÅŸÄ± olmayan Ã§alÄ±ÅŸanlar',0),(302153,8394,'pl','Tylko pracownicy spoza pracy akordowej',0),(302154,8394,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð½Ð° Ð¿Ð°Ñ€Ñ‡Ðµ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸ ÑÐ°Ð¼Ð¾',0),(302155,8394,'ur','ØµØ±Ù ØºÛŒØ± Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ú©Û’ Ù…Ù„Ø§Ø²Ù…ÛŒÙ†',0),(302156,8394,'sr','Ð¡Ð°Ð¼Ð¾ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÐºÐ¾Ñ˜Ð¸ Ð½Ð¸ÑÑƒ ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(302157,8394,'vi','Chá»‰ nhÃ¢n viÃªn khÃ´ng lÃ m khoÃ¡n ',0),(302158,8394,'af','Nie-Stukswerk Werknemers Alleenlik',0),(302159,8394,'ro','AngajaÅ£ilor non-acord numai',0),(302160,8394,'et','TÃ¼kitÃ¶Ã¶ tÃ¶Ã¶tajad',0),(302161,8394,'si','Akord zaposlenih le',0),(302162,8394,'ba','Non-Piecework karyawan hanya',0),(302163,8394,'nl','Alleen niet-stukloon voor medewerkers',0),(302164,8394,'fi','Vain tyÃ¶ntekijÃ¶ille urakka',0),(302165,8394,'no','Bare ikke-akkorden ansatte',0),(302166,8394,'da','Ikke-akkord medarbejdere kun',0),(302167,8394,'ko','ë¹„ Piecework ì§ì› ë“¤ë§Œ',0),(302168,8394,'he','×œ×œ× ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª ×¢×•×‘×“×™× ×‘×œ×‘×“',0),(302169,8394,'el','ÎœÎ·-ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Î¹ Î¼ÏŒÎ½Î¿',0),(302170,8394,'zh','ä»…éžè®¡ä»¶å‘˜å·¥\r\n',0),(302171,8394,'sv','Icke-ackord anstÃ¤llda endast',0),(302172,8394,'it','Solo dipendenti di non-lavoro a cottimo',0),(302173,8394,'tl','',0),(302174,8394,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3591;&#3634;&#3609;&#3648;&#3627;&#3617;&#3634;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(302175,8394,'hi','à¤—à¥ˆà¤°-Piecework à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¥€',0),(302176,8394,'ms','Piecework pekerja sahaja',0),(302177,8394,'ar','Ø¹Ø¯Ù… Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© Ù„Ù„Ù…ÙˆØ¸ÙÙŠÙ† ÙÙ‚Ø·',0),(302178,8394,'fr','EmployÃ©s non-travail Ã  la piÃ¨ce uniquement',0),(302179,8394,'jp','éžå‡ºæ¥é«˜æ‰•ã„å¾“æ¥­å“¡ã®ã¿',0),(302180,8394,'pt','NÃ£o trabalho por tarefa somente funcionÃ¡rios',0),(302181,8394,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² Ð½Ðµ ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(302182,8394,'es','Empleados que no Trabajan por Pieza Solamente',0),(302183,8394,'de','Nur fÃ¼r nicht-Akkord-Mitarbeiter',0),(302184,8394,'en','Non-Piecework Employees Only',0),(302185,8395,'is','',0),(302186,8395,'dr','Ø³Ø§Ø¹Ø§Øª Ø§ØµÙ„ÙŠ',0),(302187,8395,'pr','Ø³Ø§Ø¹Ø§Øª Ø§ØµÙ„ÙŠ',0),(302188,8395,'tr','Orig. saat',0),(302189,8395,'pl','Godziny orig.',0),(302190,8395,'bg','Ð§Ð°ÑÐ° Ñ‚Ñ€ÑŠÐ±.',0),(302191,8395,'ur','Orig. Ú©Û’ Ø§ÙˆÙ‚Ø§Øª',0),(302192,8395,'sr','ÐžÑ€Ð¸Ð³ . ÑÐ°Ñ‚Ð¸',0),(302193,8395,'vi','Giá» gá»‘c',0),(302194,8395,'af','Oorspronklike Ure',0),(302195,8395,'ro','Orig. ore',0),(302196,8395,'et','Orig. tundi',0),(302197,8395,'si','Orig. ur',0),(302198,8395,'ba','Chines jam',0),(302199,8395,'nl','Orig. uur',0),(302200,8395,'fi','Orig. tuntia',0),(302201,8395,'no','Orig. timer',0),(302202,8395,'da','Orig. timer',0),(302203,8395,'ko','Orig. ì‹œê°„',0),(302204,8395,'he','Orig. ×©×¢×•×ª',0),(302205,8395,'el','Orig. ÏŽÏÎµÏ‚',0),(302206,8395,'zh','åŽŸå§‹ã€‚æ—¶é—´\r\n',0),(302207,8395,'sv','Orig. timmar',0),(302208,8395,'it','Ore orig.',0),(302209,8395,'tl','',0),(302210,8395,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3604;&#3633;&#3657;&#3591;&#3648;&#3604;&#3636;&#3617;',0),(302211,8395,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤•à¥‡à¥¤',0),(302212,8395,'ms','Jam orig.',0),(302213,8395,'ar','Ø³Ø§Ø¹Ø§Øª [Ø£Ø±ÙŠØº].',0),(302214,8395,'fr','Heures d\'orig.',0),(302215,8395,'jp','ã‚«ãƒ©ãƒ¼æ™‚é–“',0),(302216,8395,'pt','Horas orig.',0),(302217,8395,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ñ‡Ð°ÑÑ‹',0),(302218,8395,'es','Orig, Horas',0),(302219,8395,'de','Orig.-Stunden',0),(302220,8395,'en','Orig. Hours',0),(302221,8396,'is','',0),(302222,8396,'dr','Ø­Ù‚ÙˆÙ‚ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±Ù‰',0),(302223,8396,'pr','Ø­Ù‚ÙˆÙ‚ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±Ù‰',0),(302224,8396,'tr','Mesai',0),(302225,8396,'pl','PÅ‚atnoÅ›Ä‡ za nadgodziny',0),(302226,8396,'bg','Ð˜Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´ÐµÐ½',0),(302227,8396,'ur','Ø§ÙˆÙˆØ±Ù¹Ø§Ø¦Ù… ØªÙ†Ø®ÙˆØ§Û',0),(302228,8396,'sr','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð¿Ñ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ñ€Ð°Ð´',0),(302229,8396,'vi','Tráº£ lÃ m thÃªm giá»',0),(302230,8396,'af','Oortyd Besoldiging',0),(302231,8396,'ro','Plata orelor suplimentare',0),(302232,8396,'et','Ãœletunnitasu',0),(302233,8396,'si','PlaÄilo za nadure',0),(302234,8396,'ba','Lembur',0),(302235,8396,'nl','Overuren betalen',0),(302236,8396,'fi','YlityÃ¶korvaus',0),(302237,8396,'no','Overtid',0),(302238,8396,'da','Overtidsbetaling',0),(302239,8396,'ko','ì´ˆê³¼ ìž‘ì—… ì‹œê°„ ê¸‰ì—¬',0),(302240,8396,'he','×ª×©×œ×•× ×¢×œ ×©×¢×•×ª × ×•×¡×¤×•×ª',0),(302241,8396,'el','Î¥Ï€ÎµÏÏ‰ÏÎ¹Î±ÎºÎ®Ï‚ Î±Î¼Î¿Î¹Î²Î®Ï‚',0),(302242,8396,'zh','åŠ ç­è´¹\r\n',0),(302243,8396,'sv','Ã–vertidsersÃ¤ttning',0),(302244,8396,'it','Pagare gli straordinari',0),(302245,8396,'tl','',0),(302246,8396,'th','&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3588;&#3656;&#3634;&#3621;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(302247,8396,'hi','à¤“à¤µà¤°à¤Ÿà¤¾à¤‡à¤® à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(302248,8396,'ms','Gaji kerja lebih masa',0),(302249,8396,'ar','Ø£Ø¬Ø± Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ',0),(302250,8396,'fr','RÃ©munÃ©ration des heures supplÃ©mentaires',0),(302251,8396,'jp','æ®‹æ¥­æ‰‹å½“ã‚’æ”¯æ‰•ã†',0),(302252,8396,'pt','Pagamento de horas extras',0),(302253,8396,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑÐ²ÐµÑ€Ñ…ÑƒÑ€Ð¾Ñ‡Ð½Ñ‹Ñ…',0),(302254,8396,'es','Pago de Horas Extras',0),(302255,8396,'de','ÃœberstundenvergÃ¼tung',0),(302256,8396,'en','Overtime Pay',0),(302257,8397,'is','',0),(302258,8397,'dr','ÙÙ‚Ø· ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(302259,8397,'pr','ÙÙ‚Ø· ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(302260,8397,'tr','ParÃ§a baÅŸÄ± Ã§alÄ±ÅŸan sadece',0),(302261,8397,'pl','Tylko pracownikÃ³w akordowych',0),(302262,8397,'bg','Ð¡Ð°Ð¼Ð¾ ÐºÑŠÐ¼ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð½Ð° Ð±Ñ€Ð¾Ð¹ÐºÐ°',0),(302263,8397,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ù…Ù„Ø§Ø²Ù…ÛŒÙ† ØµØ±Ù',0),(302264,8397,'sr','Ð¡Ð°Ð¼Ð¾ Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð·Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ðµ',0),(302265,8397,'vi','Chá»‰ nhÃ¢n viÃªn lÃ m khoÃ¡n',0),(302266,8397,'af','Stukswerk Werknemers Alleenlik',0),(302267,8397,'ro','Acord de angajati numai',0),(302268,8397,'et','TÃ¼kitÃ¶Ã¶sse tÃ¶Ã¶tajatele Ã¼ksnes',0),(302269,8397,'si','Akord zaposlenih le',0),(302270,8397,'ba','Piecework karyawan hanya',0),(302271,8397,'nl','Alleen stukloon voor medewerkers',0),(302272,8397,'fi','UrakkatyÃ¶ntekijÃ¤t vain',0),(302273,8397,'no','StykkavlÃ¸nning, ansatte bare',0),(302274,8397,'da','Akkordarbejde medarbejdere kun',0),(302275,8397,'ko','Piecework ì§ì› ë“¤ë§Œ',0),(302276,8397,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª ×¢×•×‘×“×™× ×‘×œ×‘×“',0),(302277,8397,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Î¹ Î¼ÏŒÎ½Î¿',0),(302278,8397,'zh','ä»…è®¡ä»¶å‘˜å·¥\r\n',0),(302279,8397,'sv','Ackord anstÃ¤llda endast',0),(302280,8397,'it','Lavoro a cottimo dipendenti solo',0),(302281,8397,'tl','',0),(302282,8397,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3619;&#3633;&#3610;&#3591;&#3634;&#3609;&#3648;&#3611;&#3655;&#3609;&#3619;&#3634;&#3618;&#3594;&#3636;&#3657;&#3609;&#3648;&#3607;&#3656;&#3634;&#3',0),(302283,8397,'hi','Piecework à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¥€',0),(302284,8397,'ms','Piecework pekerja sahaja',0),(302285,8397,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© Ù„Ù„Ù…ÙˆØ¸ÙÙŠÙ† ÙÙ‚Ø·',0),(302286,8397,'fr','EmployÃ©s Ã  la piÃ¨ce seulement',0),(302287,8397,'jp','å‡ºæ¥é«˜æ‰•ã„å¾“æ¥­å“¡ã®ã¿',0),(302288,8397,'pt','Trabalho por tarefa somente funcionÃ¡rios',0),(302289,8397,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(302290,8397,'es','Empleados de Trabajo por Pieza Solamente',0),(302291,8397,'de','Nur fÃ¼r Mitarbeiter der Akkordarbeit',0),(302292,8397,'en','Piecework Employees Only',0),(302293,8398,'is','',0),(302294,8398,'dr','Ø­Ù‚ÙˆÙ‚ Ø«Ø§Ø¨Øª',0),(302295,8398,'pr','Ø­Ù‚ÙˆÙ‚ Ø«Ø§Ø¨Øª',0),(302296,8398,'tr','DÃ¼zenli Ã¶deme',0),(302297,8398,'pl','Regularne wynagrodzenie',0),(302298,8398,'bg','Ð ÐµÐ´Ð¾Ð²Ð½Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(302299,8398,'ur','Ø¨Ø§Ù‚Ø§Ø¹Ø¯Û ØªÙ†Ø®ÙˆØ§Û',0),(302300,8398,'sr','Ð ÐµÐ´Ð¾Ð²Ð½Ðµ Ð¿Ð»Ð°Ñ‚Ðµ',0),(302301,8398,'vi','Thanh toÃ¡n thÆ°á»ng ká»³',0),(302302,8398,'af','Gereelde Besoldiging',0),(302303,8398,'ro','Regulat plÄƒti',0),(302304,8398,'et','Regulaarne makse',0),(302305,8398,'si','Redno plaÄilo',0),(302306,8398,'ba','Teratur membayar',0),(302307,8398,'nl','Regelmatige betalen',0),(302308,8398,'fi','SÃ¤Ã¤nnÃ¶llinen maksu',0),(302309,8398,'no','Vanlige lÃ¸nn',0),(302310,8398,'da','RegelmÃ¦ssig lÃ¸n',0),(302311,8398,'ko','ì •ê¸° ì§€ë¶ˆ',0),(302312,8398,'he','×”×ž×©×›×•×¨×ª ×”×¨×’×™×œ×”',0),(302313,8398,'el','Î¤Î±ÎºÏ„Î¹ÎºÏŽÎ½ Î±Ï€Î¿Î´Î¿Ï‡ÏŽÎ½',0),(302314,8398,'zh','æ­£è–ª\r\n',0),(302315,8398,'sv','Regelbunden lÃ¶n',0),(302316,8398,'it','Normale retribuzione',0),(302317,8398,'tl','',0),(302318,8398,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3648;&#3611;&#3655;&#3609;&#3611;&#3619;&#3632;&#3592;&#3635;',0),(302319,8398,'hi','à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ à¤µà¥‡à¤¤à¤¨',0),(302320,8398,'ms','Gaji tetap',0),(302321,8398,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± Ø§Ù„Ø¹Ø§Ø¯ÙŠØ©',0),(302322,8398,'fr','Salaire normal',0),(302323,8398,'jp','é€šå¸¸ã®çµ¦æ–™',0),(302324,8398,'pt','Pagamento regular',0),(302325,8398,'ru','Ð ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ð¾Ð¹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(302326,8398,'es','Pago Regular',0),(302327,8398,'de','RegelmÃ¤ÃŸige Lohn',0),(302328,8398,'en','Regular Pay',0),(302329,8399,'is','',0),(302330,8399,'dr','Ú¯Ø±ÙˆÙ‡ Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(302331,8399,'pr','Ú¯Ø±ÙˆÙ‡ Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(302332,8399,'tr','TimeClock grubu',0),(302333,8399,'pl','Grupa TimeClock',0),(302334,8399,'bg','TimeClock Ð³Ñ€ÑƒÐ¿Ð°',0),(302335,8399,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ú¯Ø±ÙˆÙ¾',0),(302336,8399,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð³Ñ€ÑƒÐ¿Ðµ',0),(302337,8399,'vi','NhÃ³m mÃ¡y cháº¥m cÃ´ng ',0),(302338,8399,'af','Tydklok Groep',0),(302339,8399,'ro','Ceas grup',0),(302340,8399,'et','TimeClock grupp',0),(302341,8399,'si','TimeClock skupine',0),(302342,8399,'ba','Kelompok timeclock',0),(302343,8399,'nl','Klok groep',0),(302344,8399,'fi','Timeclock ryhmÃ¤',0),(302345,8399,'no','TimeClock gruppe',0),(302346,8399,'da','Timeclock gruppe',0),(302347,8399,'ko','Timeclock ê·¸ë£¹',0),(302348,8399,'he','×§×‘×•×¦×” Timeclock',0),(302349,8399,'el','ÎŸÎ¼Î¬Î´Î± Timeclock',0),(302350,8399,'zh','æ—¶é’Ÿç»„\r\n',0),(302351,8399,'sv','Timeclock grupp',0),(302352,8399,'it','Gruppo Timeclock',0),(302353,8399,'tl','',0),(302354,8399,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(302355,8399,'hi','Timeclock à¤¸à¤®à¥‚à¤¹',0),(302356,8399,'ms','Kumpulan Timeclock',0),(302357,8399,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(302358,8399,'fr','Groupe Timeclock',0),(302359,8399,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ã‚°ãƒ«ãƒ¼ãƒ—',0),(302360,8399,'pt','Grupo timeclock',0),(302361,8399,'ru','TimeClock Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(302362,8399,'es','Reloj Checador Grupo',0),(302363,8399,'de','Timeclock Gruppe',0),(302364,8399,'en','Timeclock Group',0),(302365,8400,'is','',0),(302366,8400,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø³Ø§Ø¹Ø§Øª ',0),(302367,8400,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³Ø§Ø¹Ø§Øª ',0),(302368,8400,'tr','Toplam Saat',0),(302369,8400,'pl','CaÅ‚kowitÄ… iloÅ›Ä‡ godzin',0),(302370,8400,'bg','ÐžÐ±Ñ‰Ð¾ Ñ‡Ð°ÑÐ¾Ð²Ðµ',0),(302371,8400,'ur','Ú©Ù„ Ú¯Ú¾Ù†Ù¹Û’',0),(302372,8400,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÑÐ°Ñ‚Ð¸',0),(302373,8400,'vi','Tá»•ng cá»™ng giá»',0),(302374,8400,'af','Totale Ure',0),(302375,8400,'ro','Total ore',0),(302376,8400,'et','Tundide koguarv',0),(302377,8400,'si','Skupaj ur',0),(302378,8400,'ba','Total jam',0),(302379,8400,'nl','Totaal aantal uren',0),(302380,8400,'fi','Tunnit yhteensÃ¤',0),(302381,8400,'no','Totalt antall timer',0),(302382,8400,'da','Samlet antal timer',0),(302383,8400,'ko','ì´ ì‹œê°„',0),(302384,8400,'he','×¡×š ×›×œ ×”×©×¢×•×ª',0),(302385,8400,'el','Î£ÏÎ½Î¿Î»Î¿ Ï‰ÏÏŽÎ½',0),(302386,8400,'zh','æ€»æ—¶æ•°\r\n',0),(302387,8400,'sv','Sammanlagt antal timmar',0),(302388,8400,'it','Totale ore',0),(302389,8400,'tl','',0),(302390,8400,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(302391,8400,'hi','à¤•à¥à¤² à¤˜à¤‚à¤Ÿà¥‡',0),(302392,8400,'ms','Jumlah jam',0),(302393,8400,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø³Ø§Ø¹Ø§Øª',0),(302394,8400,'fr','Nombre total d\'heures',0),(302395,8400,'jp','åˆè¨ˆæ™‚é–“',0),(302396,8400,'pt','Total de horas',0),(302397,8400,'ru','ÐžÐ±Ñ‰ÐµÐµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ‡Ð°ÑÐ¾Ð²',0),(302398,8400,'es','Horas Totales',0),(302399,8400,'de','Gesamtstunden',0),(302400,8400,'en','Total Hours',0),(302401,8401,'is','',0),(302402,8401,'dr','ÙƒÙ„ Ø­Ù‚ÙˆÙ‚',0),(302403,8401,'pr','ÙƒÙ„ Ø­Ù‚ÙˆÙ‚',0),(302404,8401,'tr','Toplam Ã¶deme',0),(302405,8401,'pl','CaÅ‚kowitej zapÅ‚aty',0),(302406,8401,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(302407,8401,'ur','Ú©Ù„ ØªÙ†Ø®ÙˆØ§Û',0),(302408,8401,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð°',0),(302409,8401,'vi','Tá»•ng cá»™ng tráº£',0),(302410,8401,'af','Totale Besoldiging',0),(302411,8401,'ro','Plata totalÄƒ',0),(302412,8401,'et','Kokku maksma',0),(302413,8401,'si','Skupaj plaÄilo',0),(302414,8401,'ba','Total membayar',0),(302415,8401,'nl','Totale beloning',0),(302416,8401,'fi','Palkka yhteensÃ¤',0),(302417,8401,'no','Betaling totalt',0),(302418,8401,'da','Samlede lÃ¸n',0),(302419,8401,'ko','ì´ ì§€ë¶ˆ',0),(302420,8401,'he','×¡×” ×› ×ž×©×›×•×¨×ª',0),(302421,8401,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ®Ï‚ Î±Î¼Î¿Î¹Î²Î®Ï‚',0),(302422,8401,'zh','æ€»å·¥èµ„\r\n',0),(302423,8401,'sv','Totala lÃ¶n',0),(302424,8401,'it','Retribuzione totale',0),(302425,8401,'tl','',0),(302426,8401,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(302427,8401,'hi','à¤•à¥à¤² à¤µà¥‡à¤¤à¤¨',0),(302428,8401,'ms','Jumlah gaji',0),(302429,8401,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(302430,8401,'fr','Salaire total',0),(302431,8401,'jp','æ”¯æ‰•é¡åˆè¨ˆ',0),(302432,8401,'pt','Pagamento total',0),(302433,8401,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ',0),(302434,8401,'es','Total Pago',0),(302435,8401,'de','Summe der BezÃ¼ge',0),(302436,8401,'en','Total Pay',0),(302437,8402,'is','',0),(302438,8402,'dr','(ÙƒØ§Ø±Ú¯Ø±',0),(302439,8402,'pr','Ù…Ø´ØºÙˆÙ„ ÙƒØ§Ø±(ÙƒØ§Ø±Ú¯Ø±',0),(302440,8402,'tr','Ã‡alÄ±ÅŸma',0),(302441,8402,'pl','Pracy',0),(302442,8402,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð°',0),(302443,8402,'ur','Ú©Ø§Ù… Ú©Ø±Ù†Ø§',0),(302444,8402,'sr','Ð Ð°Ð´Ð¸',0),(302445,8402,'vi','LÃ m viá»‡c',0),(302446,8402,'af','Werk',0),(302447,8402,'ro','De lucru',0),(302448,8402,'et','tÃ¶Ã¶tab',0),(302449,8402,'si','Dela',0),(302450,8402,'ba','Bekerja',0),(302451,8402,'nl','Werken',0),(302452,8402,'fi','TyÃ¶skentely',0),(302453,8402,'no','Arbeider',0),(302454,8402,'da','Arbejder',0),(302455,8402,'ko','ìž‘ì—…',0),(302456,8402,'he','×¢×•×‘×“',0),(302457,8402,'el','Î•ÏÎ³Î¬Î¶Î¿Î½Ï„Î±Î¹',0),(302458,8402,'zh','å·¥ä½œ\r\n',0),(302459,8402,'sv','Arbetar',0),(302460,8402,'it','Lavorando',0),(302461,8402,'tl','',0),(302462,8402,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(302463,8402,'hi','à¤•à¤¾à¤® à¤•à¤°à¤¨à¤¾',0),(302464,8402,'ms','Bekerja',0),(302465,8402,'ar','ÙˆØªØ¹Ù…Ù„',0),(302466,8402,'fr','Travail',0),(302467,8402,'jp','ä½œæ¥­',0),(302468,8402,'pt','Trabalhando',0),(302469,8402,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð°',0),(302470,8402,'es','Trabajando',0),(302471,8402,'de','Arbeiten',0),(302472,8402,'en','Working',0),(302473,8403,'is','',0),(302474,8403,'dr','( Ø²Ù…Ø§Ù† Ø¹Ø±Ø¶Ù‡ Ù…Ø¬Ø§Ù†ÙŠ)',0),(302475,8403,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ø²Ù…Ø§Ù† ÙƒØ§Ù…Ù¾ÙŠÙˆØªØ±( Ø²Ù…Ø§Ù† Ø¹Ø±Ø¶Ù‡ Ù…Ø¬Ø§Ù†ÙŠ)',0),(302476,8403,'tr','Comp zaman tanÄ±yÄ±n',0),(302477,8403,'pl','Czas komp',0),(302478,8403,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Comp Ð²Ñ€ÐµÐ¼Ðµ',0),(302479,8403,'ur','Ú©Ø¹Ù…Ù¾ ÙˆÙ‚Øª Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(302480,8403,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð¿Ñ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸Ñ… ÑÐ°Ñ‚Ð¸',0),(302481,8403,'vi','Cho PhÃ©p Thá»i Gian Comp ',0),(302482,8403,'af','Comp laat',0),(302483,8403,'ro','Permite Comp',0),(302484,8403,'et','Comp aega',0),(302485,8403,'si','OmogoÄi dovolj Äasa za Comp',0),(302486,8403,'ba','Memungkinkan Comp waktu',0),(302487,8403,'nl','Comp tijd toestaan',0),(302488,8403,'fi','Comp aikaa',0),(302489,8403,'no','Gi komp tid',0),(302490,8403,'da','Comp tid',0),(302491,8403,'ko','ê´‘ê³  ì‹œê°„ í—ˆìš©',0),(302492,8403,'he','Comp ×ž×¡×¤×™×§ ×–×ž×Ÿ',0),(302493,8403,'el','ÎˆÎ³ÎºÎ±Î¹ÏÎ· Comp',0),(302494,8403,'zh','å…è®¸ç«žå«æ—¶é—´\r\n',0),(302495,8403,'sv','Ge Comp tid',0),(302496,8403,'it','Concedere tempo Comp',0),(302497,8403,'tl','',0),(302498,8403,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3648;&#3623;&#3621;&#3634;&#3588;&#3629;&#3617;&#3614;&#3636;&#3623;&#3648;&#3605;&#3629;&#3619;&#3660;',0),(302499,8403,'hi','à¤•à¤‚à¤ª à¤¸à¤®à¤¯ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(302500,8403,'ms','Membenarkan masa Comp',0),(302501,8403,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„ÙˆÙ‚Øª',0),(302502,8403,'fr','Laisser le temps de la maquette',0),(302503,8403,'jp','ãŠè©¦ã—ç‰ˆã®æ™‚é–“ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(302504,8403,'pt','Permitir tempo Comp',0),(302505,8403,'ru','Ð”Ð°Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ ÐºÐ¾Ð¼Ð¿',0),(302506,8403,'es','Permitir Tiempo Compensatorio',0),(302507,8403,'de','Ãœberstunden zu ermÃ¶glichen',0),(302508,8403,'en','Allow Comp Time',0),(302509,8404,'is','',0),(302510,8404,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙŠØ§ÙØªÙ‡ Ø§Ø³Øª',0),(302511,8404,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙŠØ§ÙØªÙ‡ Ø§Ø³Øª',0),(302512,8404,'tr','BaÅŸarÄ±yla deÄŸiÅŸtirildi',0),(302513,8404,'pl','PomyÅ›lnie zmieniono',0),(302514,8404,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(302515,8404,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(302516,8404,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½',0),(302517,8404,'vi','Thay Ä‘á»•i thÃ nh cÃ´ng',0),(302518,8404,'af','Suksesvol Verander',0),(302519,8404,'ro','Schimbat cu succes',0),(302520,8404,'et','Muutmine nurjus',0),(302521,8404,'si','UspeÅ¡no',0),(302522,8404,'ba','Berhasil diubah',0),(302523,8404,'nl','Met succes gewijzigd',0),(302524,8404,'fi','Muutettu',0),(302525,8404,'no','Endret',0),(302526,8404,'da','Ã†ndret med succes',0),(302527,8404,'ko','ì„±ê³µì ìœ¼ë¡œ ë³€ê²½',0),(302528,8404,'he','×”×©×ª× ×” ×‘×”×¦×œ×—×”',0),(302529,8404,'el','Î†Î»Î»Î±Î¾Îµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(302530,8404,'zh','å˜æ›´æˆåŠŸ\r\n',0),(302531,8404,'sv','Ã„ndrade framgÃ¥ngsrikt',0),(302532,8404,'it','Cambiato con successo',0),(302533,8404,'tl','',0),(302534,8404,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(302535,8404,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¦à¤² à¤—à¤¯à¤¾',0),(302536,8404,'ms','Berjaya ditukar',0),(302537,8404,'ar','ØºÙŠÙ‘Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(302538,8404,'fr','ChangÃ© avec succÃ¨s',0),(302539,8404,'jp','æ­£å¸¸ã«å¤‰æ›´ã•ã‚Œã¾ã—ãŸã€‚',0),(302540,8404,'pt','Mudou-se com sucesso',0),(302541,8404,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½',0),(302542,8404,'es','Cambiado Exitosamente',0),(302543,8404,'de','Erfolgreich geÃ¤ndert',0),(302544,8404,'en','Changed Successfully',0),(302545,8405,'is','',0),(302546,8405,'dr','Ø³Ø§Ø¹Ø§Øª Ø¯Ø± Ø±ÙˆØ² Ù‚Ø¨Ù„ Ø§Ø² Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±Ù‰',0),(302547,8405,'pr','Ø³Ø§Ø¹Ø§Øª Ø¯Ø± Ø±ÙˆØ² Ù‚Ø¨Ù„ Ø§Ø² Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±Ù‰',0),(302548,8405,'tr','Fazla mesai Ã¶nceki gÃ¼n baÅŸÄ±na saat',0),(302549,8405,'pl','Godzin dziennie przed nadgodziny',0),(302550,8405,'bg','Ð§Ð°ÑÐ° Ð½Ð° Ð´ÐµÐ½ Ð¿Ñ€ÐµÐ´ Ð¸Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´ÐµÐ½ Ñ‚Ñ€ÑƒÐ´',0),(302551,8405,'ur','Ú¯Ú¾Ù†Ù¹Û’ ÙÛŒ ÛŒÙˆÙ… Ø§ÙˆÙˆØ±Ù¹Ø§Ø¦Ù… Ø³Û’ Ù¾ÛÙ„Û’',0),(302552,8405,'sr','Ð¡Ð°Ñ‚Ð¸ Ð´Ð½ÐµÐ²Ð½Ð¾ Ð¿Ñ€ÐµÐ´ Ð¿Ñ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ñ€Ð°Ð´',0),(302553,8405,'vi','Giá» má»—i ngÃ y trÆ°á»›c khi lÃ m thÃªm',0),(302554,8405,'af','Ure Per Dag Voor Oortyg',0),(302555,8405,'ro','Ore pe zi Ã®nainte de orele suplimentare',0),(302556,8405,'et','PÃ¤eva enne Ã¼letunnitÃ¶Ã¶ tundide',0),(302557,8405,'si','Ur na dan pred nadure',0),(302558,8405,'ba','Jam sehari sebelum lembur',0),(302559,8405,'nl','Uur Per dag voor overuren',0),(302560,8405,'fi','Vuorokauden ennen kuin ylityÃ¶',0),(302561,8405,'no','Timer Per dag fÃ¸r overtid',0),(302562,8405,'da','Timer om dagen fÃ¸r overtid',0),(302563,8405,'ko','ì‹œê°„ ì´ˆê³¼ í•˜ê¸° ì „ì— í•˜ë£¨',0),(302564,8405,'he','×©×¢×•×ª ×¢×‘×•×“×” ×‘×™×•× ×œ×¤× ×™ ×©×¢×•×ª × ×•×¡×¤×•×ª',0),(302565,8405,'el','ÎÏÎµÏ‚ Î±Î½Î¬ Î·Î¼Î­ÏÎ± Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î¹Ï‚ Ï…Ï€ÎµÏÏ‰ÏÎ¯ÎµÏ‚',0),(302566,8405,'zh','æ¯æ—¥åŠ ç­å‰æ—¶æ•°\r\n',0),(302567,8405,'sv','Timmar Per dag innan Ã¶vertid',0),(302568,8405,'it','Ore al giorno prima lavoro straordinario',0),(302569,8405,'tl','',0),(302570,8405,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;&#3605;&#3656;&#3629;&#3623;&#3633;&#3609;&#3585;&#3656;&#3629;&#3609;&#3609;&#3629;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(302571,8405,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¸à¤®à¤¯ à¤•à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¦à¤¿à¤¨ à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¥‡',0),(302572,8405,'ms','Jam sehari sebelum kerja lebih masa',0),(302573,8405,'ar','Ø³Ø§Ø¹Ø§Øª ÙŠÙˆÙ…ÙŠØ§ Ù‚Ø¨Ù„ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ',0),(302574,8405,'fr','Heures par jour avant les heures supplÃ©mentaires',0),(302575,8405,'jp','è¶…éŽã™ã‚‹å‰ã« 1 æ—¥ã‚ãŸã‚Šã®æ™‚é–“',0),(302576,8405,'pt','Horas por dia antes de horas extras',0),(302577,8405,'ru','Ð§Ð°ÑÐ¾Ð² Ð² Ð´ÐµÐ½ÑŒ Ð´Ð¾ ÑÐ²ÐµÑ€Ñ…ÑƒÑ€Ð¾Ñ‡Ð½Ñ‹Ñ…',0),(302578,8405,'es','Horas Por DÃ­a Antes que Horas Extras',0),(302579,8405,'de','Stunden pro Tag vor Ãœberstunden',0),(302580,8405,'en','Hours Per Day Before Overtime',0),(302581,8406,'is','',0),(302582,8406,'dr','Ø³Ø§Ø¹Ø§Øª Ø¯Ø± Ù‡ÙØªÙ‡ Ù‚Ø¨Ù„ Ø§Ø² Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±Ù‰',0),(302583,8406,'pr','Ø³Ø§Ø¹Ø§Øª Ø¯Ø± Ù‡ÙØªÙ‡ Ù‚Ø¨Ù„ Ø§Ø² Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±Ù‰',0),(302584,8406,'tr','Fazla mesai hafta baÅŸÄ±na saat',0),(302585,8406,'pl','Godzin tygodniowo przed nadgodziny',0),(302586,8406,'bg','Ð§Ð°ÑÐ¾Ð²Ðµ Ð½Ð° ÑÐµÐ´Ð¼Ð¸Ñ†Ð° Ð¿Ñ€ÐµÐ´Ð¸ Ð¸Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´ÐµÐ½ Ñ‚Ñ€ÑƒÐ´',0),(302587,8406,'ur','Ú¯Ú¾Ù†Ù¹Û’ ÙÛŒ ÛÙØªÛ Ø§ÙˆÙˆØ±Ù¹Ø§Ø¦Ù… Ø³Û’ Ù¾ÛÙ„Û’',0),(302588,8406,'sr','Ð§Ð°ÑÐ¾Ð²Ð° ÑÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð¾ Ð¿Ñ€Ðµ Ð¿Ñ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ñ€Ð°Ð´',0),(302589,8406,'vi','Giá» má»—i ngÃ y trÆ°á»›c khi lÃ m thÃªm',0),(302590,8406,'af','Ure Per Week Voor Oortyd',0),(302591,8406,'ro','Ore pe sÄƒptÄƒmÃ¢nÄƒ Ã®nainte de orele suplimentare',0),(302592,8406,'et','Tundi nÃ¤dalas enne Ã¼letunnitÃ¶Ã¶',0),(302593,8406,'si','Ur na teden pred nadure',0),(302594,8406,'ba','Jam Per minggu sebelum lembur',0),(302595,8406,'nl','Uur Per Week voor overuren',0),(302596,8406,'fi','Tuntia viikossa ennen kuin ylityÃ¶',0),(302597,8406,'no','Timer Per uke fÃ¸r overtid',0),(302598,8406,'da','Timer pr. uge fÃ¸r overtid',0),(302599,8406,'ko','ì—°ìž¥ ì „ì— ì£¼ë‹¹ ì‹œê°„',0),(302600,8406,'he','×ž×¡×¤×¨ ×©×¢×•×ª ×¢×‘×•×“×” ×‘×©×‘×•×¢ ×œ×¤× ×™ ×©×¢×•×ª × ×•×¡×¤×•×ª',0),(302601,8406,'el','ÎÏÎµÏ‚ Î±Î½Î¬ ÎµÎ²Î´Î¿Î¼Î¬Î´Î± Ï€ÏÎ¹Î½ Ï…Ï€ÎµÏÏ‰ÏÎ¯ÎµÏ‚',0),(302602,8406,'zh','æ¯æ—¥åŠ ç­å°æ—¶å‰\r\n',0),(302603,8406,'sv','Timmar Per vecka innan Ã¶vertid',0),(302604,8406,'it','Ore alla settimana prima di lavoro straordinario',0),(302605,8406,'tl','',0),(302606,8406,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3635;&#3591;&#3634;&#3609;&#3605;&#3656;&#3629;&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;&#3585;&#3656;&#3629;&#3609;&#3609;&#3629;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3',0),(302607,8406,'hi','à¤“à¤µà¤°à¤Ÿà¤¾à¤‡à¤® à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¥‡',0),(302608,8406,'ms','Jam seminggu sebelum kerja lebih masa',0),(302609,8406,'ar','Ø³Ø§Ø¹Ø§Øª Ø£Ø³Ø¨ÙˆØ¹ÙŠØ§ Ù‚Ø¨Ù„ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ',0),(302610,8406,'fr','Heures par semaine devant les heures supplÃ©mentaires',0),(302611,8406,'jp','è¶…éŽä½œæ¥­æ™‚é–“ã®å‰ã«é€±ã‚ãŸã‚Šã®æ™‚é–“',0),(302612,8406,'pt','Horas semanais antes de horas extras',0),(302613,8406,'ru','Ð§Ð°ÑÐ¾Ð² Ð² Ð½ÐµÐ´ÐµÐ»ÑŽ Ð´Ð¾ ÑÐ²ÐµÑ€Ñ…ÑƒÑ€Ð¾Ñ‡Ð½Ñ‹Ñ…',0),(302614,8406,'es','Horas Por Semana Antes que Horas Extras',0),(302615,8406,'de','Stunden pro Woche vor Ãœberstunden',0),(302616,8406,'en','Hours Per Week Before Overtime',0),(302617,8407,'is','',0),(302618,8407,'dr','Ø§Ú¯Ø± Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒÙŠ Ø§Ø³Øª â€“ Ø¨Ø§ ÙƒØ§Ù…Ø§ Ø¬Ø¯Ø§ Ø´ÙˆØ¯',0),(302619,8407,'pr','Ø§Ú¯Ø± Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒÙŠ Ø§Ø³Øª â€“ Ø¨Ø§ ÙƒØ§Ù…Ø§ Ø¬Ø¯Ø§ Ø´ÙˆØ¯',0),(302620,8407,'tr','Birden fazla varsa, virgÃ¼lle ayÄ±rÄ±n.',0),(302621,8407,'pl','JeÅ›li wiÄ™cej niÅ¼ jeden, naleÅ¼y oddzieliÄ‡ przecinkami',0),(302622,8407,'bg','ÐÐºÐ¾ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð¸Ð½, Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÑ‚Ðµ ÑÑŠÑ Ð·Ð°Ð¿ÐµÑ‚Ð°Ð¸',0),(302623,8407,'ur','Ø§Ú¯Ø± Ø§ÛŒÚ© Ø³Û’ Ø²ÛŒØ§Ø¯Û ÙˆÙ‚Ù Ø³Û’ Ø¹Ù„ÛŒØ­Ø¯Û Ú©Ø± Ø¯ÛŒÚº',0),(302624,8407,'sr','ÐÐºÐ¾ Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ñ˜ÐµÐ´Ð½Ð¾Ð³, Ð¾Ð´Ð²Ð¾Ñ˜ÐµÐ½Ðµ Ð·Ð°Ñ€ÐµÐ·Ð¸Ð¼Ð°',0),(302625,8407,'vi','Náº¿u cÃ³ hÆ¡n 1, dÃ¹ng dáº¥u pháº©y Ä‘á»ƒ ngÄƒn cÃ¡ch',0),(302626,8407,'af','Indien Meer As Een, Skei deur Komma\'s',0),(302627,8407,'ro','DacÄƒ mai multe, Separate prin virgule',0),(302628,8407,'et','Kui rohkem kui Ã¼ks, eraldada komadega',0),(302629,8407,'si','ÄŒe veÄ kot eno, loÄene z vejicami',0),(302630,8407,'ba','Jika lebih dari satu, pisahkan dengan koma',0),(302631,8407,'nl','Als meer dan Ã©Ã©n, gescheiden door komma \'s',0),(302632,8407,'fi','Jos useampi kuin yksi erotetaan pilkuilla',0),(302633,8407,'no','Hvis mer enn Ã©n, Skill med komma',0),(302634,8407,'da','Hvis mere end Ã©n, adskilles af kommaer',0),(302635,8407,'ko','ë§Œì•½ í•˜ë‚˜ ì´ìƒì˜ ì‰¼í‘œë¡œ êµ¬ë¶„',0),(302636,8407,'he','×× ××—×“ ××• ×™×•×ª×¨, ×œ×”×¤×¨×™×“ ×‘××ž×¦×¢×•×ª ×¤×¡×™×§×™×',0),(302637,8407,'el','Î•Î¬Î½ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Î±Ï€ÏŒ Î¼Î¯Î±, Î´Î¹Î±Ï‡Ï‰ÏÎ¯ÏƒÏ„Îµ Î¼Îµ ÎºÏŒÎ¼Î¼Î±',0),(302638,8407,'zh','å¦‚æžœä¸æ­¢ä¸€ä¸ªï¼Œä»¥é€—å·åˆ†éš”\r\n',0),(302639,8407,'sv','Om mer Ã¤n en, separera med kommatecken',0),(302640,8407,'it','Se piÃ¹ di uno, separati da virgole',0),(302641,8407,'tl','',0),(302642,8407,'th','&#3627;&#3634;&#3585;&#3617;&#3634;&#3585;&#3623;&#3656;&#3634;&#3627;&#3609;&#3638;&#3656;&#3591;, &#3586;&#3633;&#3657;&#3609;&#3604;&#3657;&#3623;&#3618;&#3588;&#3629;&#3617;&#3617;&#3656;&#3634;',0),(302643,8407,'hi','à¤¯à¤¦à¤¿ à¤à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤•, à¤…à¤²à¥à¤ªà¤µà¤¿à¤°à¤¾à¤® à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤…à¤²à¤—',0),(302644,8407,'ms','Jika lebih daripada satu, yang dipisahkan dengan koma',0),(302645,8407,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø£ÙƒØ«Ø± Ù…Ù† ÙˆØ§Ø­Ø¯ØŒ Ù…Ù†ÙØµÙ„Ø© Ø¨ÙÙˆØ§ØµÙ„',0),(302646,8407,'fr','Si plus d\'un, sÃ©parÃ©es par des virgules',0),(302647,8407,'jp','1 ã¤ä»¥ä¸Šã‚’ã‚³ãƒ³ãƒžã§åŒºåˆ‡ã‚Šã¾ã™',0),(302648,8407,'pt','Se mais de um, separados por vÃ­rgulas',0),(302649,8407,'ru','Ð•ÑÐ»Ð¸ Ð‘Ð¾Ð»ÐµÐµ ÐžÐ´Ð½Ð¾Ð³Ð¾, Ð Ð°Ð·Ð´ÐµÐ»ÑÑ‚ÑŒ Ð—Ð°Ð¿ÑÑ‚Ñ‹Ð¼Ð¸',0),(302650,8407,'es','Si mÃ¡s que uno, Separar por Comas',0),(302651,8407,'de','Wenn mehrere, durch Kommata getrennt',0),(302652,8407,'en','If More Than One, Separate by Commas',0),(302653,8408,'is','',0),(302654,8408,'dr','Ø¢ÙŠØ§ Ø¨Ø±Ø§ÙŠ ÙˆÙ‚Øª Ø§Ø³ØªØ±Ø§Ø­Øª Ø­Ù‚ÙˆÙ‚ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…ÙŠ Ø´ÙˆØ¯ØŸ',0),(302655,8408,'pr','Ø¢ÙŠØ§ Ø¨Ø±Ø§ÙŠ ÙˆÙ‚Øª Ø§Ø³ØªØ±Ø§Ø­Øª Ø­Ù‚ÙˆÙ‚ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…ÙŠ Ø´ÙˆØ¯ØŸ',0),(302656,8408,'tr','Aradan zaman Ã¶denir?',0),(302657,8408,'pl','PoÅ›wiÄ™ca czas przerwy?',0),(302658,8408,'bg','Ð• Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð° Ð¿Ð¾Ñ‡Ð¸Ð²ÐºÐ° Ð²Ñ€ÐµÐ¼Ðµ?',0),(302659,8408,'ur','ØªÙˆÚ‘ Ú©Û’ ÙˆÙ‚Øª Ø§Ø¯Ø§ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ØŸ',0),(302660,8408,'sr','ÐˆÐµ Ð»Ð¸ Ð¿Ð°ÑƒÐ·Ð° Ð¿Ð»Ð°Ñ‚Ð¸Ð¾?',0),(302661,8408,'vi','Thá»i gian nghá»‰ cÃ³ tráº£ lÆ°Æ¡ng?',0),(302662,8408,'af','Is Teetyd Betaal?',0),(302663,8408,'ro','Este pauza timp plÄƒtit?',0),(302664,8408,'et','Makstakse vaheaeg?',0),(302665,8408,'si','ÄŒasu odmora izplaÄuje?',0),(302666,8408,'ba','Waktu istirahat dibayar?',0),(302667,8408,'nl','Wordt betaald pauzetijd?',0),(302668,8408,'fi','Maksetaan taukoaika?',0),(302669,8408,'no','Betales pausetid?',0),(302670,8408,'da','Pausetid betales?',0),(302671,8408,'ko','íœ´ì‹ ì‹œê°„ ì§€ê¸‰ ë©ë‹ˆë‹¤?',0),(302672,8408,'he','×”×•× ×©×™×œ× ×–×ž×Ÿ ×”×”×¤×¡×§×”?',0),(302673,8408,'el','ÎšÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹ Î· ÏŽÏÎ± Î´Î¹Î¬Î»ÎµÎ¹Î¼Î¼Î±;',0),(302674,8408,'zh','æ˜¯ä¼‘æ¯æ—¶æ”¯ä»˜ï¼Ÿ\r\n',0),(302675,8408,'sv','Rasttid betalas?',0),(302676,8408,'it','Tempo di pausa Ã¨ pagato?',0),(302677,8408,'tl','',0),(302678,8408,'th','&#3648;&#3611;&#3655;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3648;&#3623;&#3621;&#3634;&#3627;&#3618;&#3640;&#3604;&#3591;&#3634;&#3609;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(302679,8408,'hi','à¤¤à¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¸à¤®à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ?',0),(302680,8408,'ms','Masa rehat dibayar?',0),(302681,8408,'ar','ÙˆØªØ¯ÙØ¹ ÙˆÙ‚Øª Ø§Ø³ØªØ±Ø§Ø­Ø©ØŸ',0),(302682,8408,'fr','Temps de pause est payÃ© ?',0),(302683,8408,'jp','ä¼‘æ†©æ™‚é–“ã¯æ”¯æ‰•ã‚ã‚Œã¾ã™ã‹ï¼Ÿ',0),(302684,8408,'pt','Tempo de pausa Ã© pago?',0),(302685,8408,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ Ð»Ð¸ Ð¿ÐµÑ€ÐµÑ€Ñ‹Ð²?',0),(302686,8408,'es','Â¿Es Pagable el Tiempo de Descansar',0),(302687,8408,'de','Werden Pausenzeit ist bezahlt?',0),(302688,8408,'en','Is Break Time Paid?',0),(302689,8409,'is','',0),(302690,8409,'dr','Ø¢ÙŠØ§ Ø¨Ø±Ø§ ÙŠ ÙˆÙ‚Øª Ù†Ø§Ù‡Ø§Ø± Ø­Ù‚ÙˆÙ‚ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…ÙŠ Ø´ÙˆØ¯ØŸ',0),(302691,8409,'pr','Ø¢ÙŠØ§ Ø¨Ø±Ø§ ÙŠ ÙˆÙ‚Øª Ù†Ø§Ù‡Ø§Ø± Ø­Ù‚ÙˆÙ‚ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…ÙŠ Ø´ÙˆØ¯ØŸ',0),(302692,8409,'tr','Ã–ÄŸle yemeÄŸi zaman Ã¶denir?',0),(302693,8409,'pl','PoÅ›wiÄ™ca czas na obiad?',0),(302694,8409,'bg','Ð¡Ðµ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð° Ð¾Ð±ÑÐ´ Ð²Ñ€ÐµÐ¼Ðµ?',0),(302695,8409,'ur','Ø¯ÙˆÙ¾ÛØ± Ú©Û’ Ú©Ú¾Ø§Ù†Û’ Ú©Û’ ÙˆÙ‚Øª Ø§Ø¯Ø§ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ØŸ',0),(302696,8409,'sr','ÐˆÐµ Ð»Ð¸ Ð²Ñ€ÐµÐ¼Ðµ Ñ€ÑƒÑ‡ÐºÐ° Ð¿Ð»Ð°Ñ‚Ð¸Ð¾?',0),(302697,8409,'vi','Nghá»‰ trÆ°a cÃ³ tráº£ lÆ°Æ¡ng?',0),(302698,8409,'af','Is Etenstyd Betaal?',0),(302699,8409,'ro','Este masa de prÃ¢nz timp plÄƒtit?',0),(302700,8409,'et','LÃµunasÃ¶Ã¶gi ajal maksab?',0),(302701,8409,'si','Kosilo Äas izplaÄuje?',0),(302702,8409,'ba','Waktu makan siang dibayar?',0),(302703,8409,'nl','Wordt betaald lunchtijd?',0),(302704,8409,'fi','Maksetaan lounasaikaan?',0),(302705,8409,'no','Betales lunsj?',0),(302706,8409,'da','Frokosttid betales?',0),(302707,8409,'ko','ì ì‹¬ ì‹œê°„ ì§€ê¸‰ ë©ë‹ˆë‹¤?',0),(302708,8409,'he','. ×–×” ×–×ž×Ÿ ××¨×•×—×ª ×”×¦×”×¨×™×™× ×©×™×œ×?',0),(302709,8409,'el','ÎšÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹ Î· ÏŽÏÎ± Ï„Î¿Ï… Î³ÎµÏÎ¼Î±Ï„Î¿Ï‚;',0),(302710,8409,'zh','åˆé¤æ—¶æ”¯ä»˜ï¼Ÿ\r\n',0),(302711,8409,'sv','Lunchtid betalas?',0),(302712,8409,'it','Ãˆ ora di pranzo pagato?',0),(302713,8409,'tl','',0),(302714,8409,'th','&#3648;&#3611;&#3655;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3648;&#3623;&#3621;&#3634;&#3614;&#3633;&#3585;&#3619;&#3633;&#3610;&#3611;&#3619;&#3632;&#3607;&#3634;&#3609;&#3629;&#3634;&#3627;&#3',0),(302715,8409,'hi','à¤¦à¥‹à¤ªà¤¹à¤° à¤•à¥‡ à¤­à¥‹à¤œà¤¨ à¤•à¥‡ à¤¸à¤®à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ?',0),(302716,8409,'ms','Waktu makan tengah hari dibayar?',0),(302717,8409,'ar','ÙˆØªØ¯ÙØ¹ ÙˆÙ‚Øª Ø§Ù„ØºØ¯Ø§Ø¡ØŸ',0),(302718,8409,'fr','L\'heure du dÃ©jeuner est payÃ© ?',0),(302719,8409,'jp','æ˜¼é£Ÿã®æ™‚é–“ã«æ”¯æ‰•ã‚ã‚Œã¦ã„ã‚‹ï¼Ÿ',0),(302720,8409,'pt','Hora do almoÃ§o Ã© pago?',0),(302721,8409,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð¾Ð±ÐµÐ´Ð° Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ?',0),(302722,8409,'es','Â¿Se Paga para la Hora de Comida?',0),(302723,8409,'de','Werden Mittagspause ist bezahlt?',0),(302724,8409,'en','Is Lunch Time Paid?',0),(302725,8410,'is','',0),(302726,8410,'dr','Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯  Ø§Ú¯Ø±Ù…Ø­Ø¯ÙˆØ¯ÙŠØª Ù†Ø¯Ø§Ø±Ø¯',0),(302727,8410,'pr','Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯  Ø§Ú¯Ø±Ù…Ø­Ø¯ÙˆØ¯ÙŠØª Ù†Ø¯Ø§Ø±Ø¯',0),(302728,8410,'tr','EÄŸer herhangi bir kÄ±sÄ±tlama boÅŸ bÄ±rakÄ±n',0),(302729,8410,'pl','Pozostaw je puste, jeÅ›li nie ma ograniczeÅ„',0),(302730,8410,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð°ÐºÐ¾ Ð½ÑÐ¼Ð° Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸Ñ',0),(302731,8410,'ur','Ú©ÙˆØ¦ÛŒ Ù¾Ø§Ø¨Ù†Ø¯ÛŒ Ù†ÛÛŒÚº Ù„Ú¯Ø§Ø¦ÛŒ ØªÙˆ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº Û”',0),(302732,8410,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð°ÐºÐ¾ Ð½ÐµÐ¼Ð° Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÑšÐ°',0),(302733,8410,'vi','Äá»ƒ trá»‘ng náº¿u khÃ´ng rÃ ng buá»™c',0),(302734,8410,'af','Laat Oop indien Geen Beperkings',0),(302735,8410,'ro','LÄƒsaÅ£i necompletat dacÄƒ fÄƒrÄƒ restricÅ£ii',0),(302736,8410,'et','JÃ¤ta tÃ¼hjaks, kui mingeid piiranguid',0),(302737,8410,'si','Pustite prazno, Äe ni omejitev',0),(302738,8410,'ba','Tinggalkan kosong jika tidak ada pembatasan',0),(302739,8410,'nl','Laat leeg indien geen beperkingen',0),(302740,8410,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi jos ei rajoituksia',0),(302741,8410,'no','La stÃ¥ tomt hvis ingen restriksjoner',0),(302742,8410,'da','Efterlad Blank hvis ingen begrÃ¦nsninger',0),(302743,8410,'ko','ë§Œì•½ ì œí•œì´ ë¹ˆì„ ë– ë‚˜',0),(302744,8410,'he','×œ×”×©××™×¨ ×¨×™×§ ×× ××™×Ÿ ×”×’×‘×œ×•×ª',0),(302745,8410,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ ÎµÎ¬Î½ Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Ï€ÎµÏÎ¹Î¿ÏÎ¹ÏƒÎ¼Î¿Î¯',0),(302746,8410,'zh','å¦‚æžœæ²¡æœ‰ä»»ä½•é™åˆ¶ç•™ç©º\r\n',0),(302747,8410,'sv','LÃ¤mna tomt om inga begrÃ¤nsningar',0),(302748,8410,'it','Lasciare vuoto se senza restrizioni',0),(302749,8410,'tl','',0),(302750,8410,'th','&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3606;&#3657;&#3634;&#3652;&#3617;&#3656;&#3617;&#3637;&#3586;&#3657;&#3629;&#3592;&#3635;&#3585;&#3633;&#3604;',0),(302751,8410,'hi','à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼ à¤…à¤—à¤° à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤‚à¤§ à¤¨à¤¹à¥€à¤‚',0),(302752,8410,'ms','Biarkan kosong jika tiada sekatan',0),(302753,8410,'ar','ØªØªØ±Ùƒ ÙØ§Ø±ØºØ© Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø§ Ù…Ù† Ø§Ù„Ù‚ÙŠÙˆØ¯',0),(302754,8410,'fr','Laisser en blanc si aucune restriction',0),(302755,8410,'jp','åˆ¶é™ãŒãªã„å ´åˆã¯ç©ºç™½ã‚’ã¾ã¾',0),(302756,8410,'pt','Deixe em branco se nÃ£o hÃ¡ restriÃ§Ãµes',0),(302757,8410,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, ÐµÑÐ»Ð¸ Ð½ÐµÑ‚ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸Ð¹',0),(302758,8410,'es','Dejar en Blanco si No Hay Retricciones',0),(302759,8410,'de','Lassen Sie leer, wenn keine EinschrÃ¤nkungen',0),(302760,8410,'en','Leave Blank if No Restrictions',0),(302761,8411,'is','',0),(302762,8411,'dr','IP',0),(302763,8411,'pr','Ù…Ø­Ø¯ÙˆØ¯ÙŠØª Ø¯Ø³ØªØ±Ø³ÙŠ Ø§Ø² Ø·Ø±ÙŠÙ‚ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ÙƒØ§Ø±Ø¨Ø± IP',0),(302764,8411,'tr','SÄ±nÄ±rlamak kullanÄ±cÄ± tarafÄ±ndan eriÅŸim IP',0),(302765,8411,'pl','Ograniczenia dostÄ™pu przez uÅ¼ytkownika IP',0),(302766,8411,'bg','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡Ð¸ Ð´Ð¾ÑÑ‚ÑŠÐ¿Ð° Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ IP',0),(302767,8411,'ur','Ù…Ø­Ø¯ÙˆØ¯ Ø±Ø³Ø§Ø¦ÛŒ ØµØ§Ø±Ù Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¢Ø¦ÛŒ Ù¾ÛŒ',0),(302768,8411,'sr','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð° Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð˜ÐŸ',0),(302769,8411,'vi','Giá»›i Háº¡n Truy Cáº­p Báº±ng ID NgÆ°á»i Sá»­ Dá»¥ng',0),(302770,8411,'af','Beperk Toegang deur Gebruiker IP',0),(302771,8411,'ro','Limiteaza accesul conform ID',0),(302772,8411,'et','Piirata juurdepÃ¤Ã¤su kasutaja IP',0),(302773,8411,'si','Omejitev dostopa uporabnika IP',0),(302774,8411,'ba','Membatasi akses oleh User IP',0),(302775,8411,'nl','Beperken van toegang door gebruiker IP',0),(302776,8411,'fi','Rajoittaa kÃ¤yttÃ¤jÃ¤n IP',0),(302777,8411,'no','Begrense tilgang av bruker IP',0),(302778,8411,'da','BegrÃ¦nse adgangen af bruger IP',0),(302779,8411,'ko','ëŒ€ í•œ ì‚¬ìš©ìž ì•¡ì„¸ìŠ¤ ì œí•œ IP',0),(302780,8411,'he','×œ×”×’×‘×™×œ ××ª ×”×’×™×©×” ×¢×œ-×™×“×™ ×ž×©×ª×ž×© IP',0),(302781,8411,'el','Î ÎµÏÎ¹Î¿ÏÎ¯ÏƒÎµÎ¹ Ï„Î·Î½ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· Î±Ï€ÏŒ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î· IP',0),(302782,8411,'zh','é€šè¿‡ç”¨æˆ·çš„IPé™åˆ¶è®¿é—®\r\n',0),(302783,8411,'sv','BegrÃ¤nsa Ã¥tkomst fÃ¶r anvÃ¤ndaren IP',0),(302784,8411,'it','Limitare l\'accesso di utente IP',0),(302785,8411,'tl','',0),(302786,8411,'th','&#3592;&#3635;&#3585;&#3633;&#3604;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3650;&#3604;&#3618;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657; IP',0),(302787,8411,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¤¹à¥à¤à¤š à¤•à¥‹ à¤¸à¥€à¤®à¤¿à¤¤ IP',0),(302788,8411,'ms','Menghadkan capaian oleh pengguna IP',0),(302789,8411,'ar','Ø§Ù„Ø­Ø¯ Ù…Ù† ÙˆØµÙˆÙ„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… IP',0),(302790,8411,'fr','Limiter l\'accÃ¨s par utilisateur IP',0),(302791,8411,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«ã‚ˆã‚‹ã‚¢ã‚¯ã‚»ã‚¹ã‚’åˆ¶é™ã™ã‚‹ IP',0),(302792,8411,'pt','Limitar o acesso pelo usuÃ¡rio IP',0),(302793,8411,'ru','Ð›Ð¸Ð¼Ð¸Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹ Ð”Ð¾Ð¿ÑƒÑÐº Ñ IP ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(302794,8411,'es','Limitar Acceso por Usuario IP',0),(302795,8411,'de','BeschrÃ¤nken Sie den Zugriff durch Benutzer IP',0),(302796,8411,'en','Limit Access by User IP',0),(302797,8412,'is','',0),(302798,8412,'dr','IP ',0),(302799,8412,'pr','Ù…Ø­Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø¨Ø±Ø§ÙŠ ÙÙ‚Ø· Ø§ÙŠÙ† ÙŠÙƒÙŠ IP ',0),(302800,8412,'tr','IP sadece bu bir sÄ±nÄ±rlama',0),(302801,8412,'pl','OgraniczyÄ‡ IP tylko tego jednego',0),(302802,8412,'bg','Ð›Ð¸Ð¼Ð¸Ñ‚ IP ÑÐ°Ð¼Ð¾ Ñ‚Ð¾Ð²Ð°',0),(302803,8412,'ur','IP Ø§Ø³ Ú©ÛŒ ØµØ±Ù Ø§ÛŒÚ© Ù…Ø­Ø¯ÙˆØ¯',0),(302804,8412,'sr','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡Ð¸Ñ‚Ðµ Ð˜ÐŸ Ð´Ð° ÑÐ°Ð¼Ð¾ Ð¾Ð²Ð°Ñ˜ Ñ˜ÐµÐ´Ð°Ð½',0),(302805,8412,'vi','Giá»›i háº¡n IP tá»›i Ä‘Ã¢y',0),(302806,8412,'af','Beperk IP aan net hierdie een',0),(302807,8412,'ro','Limita IP doar acest lucru unul',0),(302808,8412,'et','Piirata IP Just see Ã¼ks',0),(302809,8412,'si','Mejna IP za samo to eno',0),(302810,8412,'ba','Membatasi IP untuk hanya ini satu',0),(302811,8412,'nl','IP beperken tot alleen deze een',0),(302812,8412,'fi','Rajoittaa IP vain tÃ¤tÃ¤ yhtÃ¤',0),(302813,8412,'no','Begrense IP til nettopp dette en',0),(302814,8412,'da','BegrÃ¦nse IP til netop dette ene',0),(302815,8412,'ko','í•˜ë‚˜ ë‹¨ì§€ì´ IPë¥¼ ì œí•œ',0),(302816,8412,'he','×œ×”×’×‘×™×œ IP ×¨×§ ×–×” ××—×“',0),(302817,8412,'el','Î ÎµÏÎ¹Î¿ÏÎ¹ÏƒÎ¼ÏŒ IP ÏƒÎµ Î±Ï…Ï„ÏŒ Î­Î½Î±',0),(302818,8412,'zh','é™åˆ¶IPåˆ°æ­¤',0),(302819,8412,'sv','BegrÃ¤nsa IP till Just detta en',0),(302820,8412,'it','Limitare IP a solo questo uno',0),(302821,8412,'tl','',0),(302822,8412,'th','&#3592;&#3635;&#3585;&#3633;&#3604; IP &#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3649;&#3588;&#3656;&#3629;&#3633;&#3609;&#3609;&#3637;&#3657;',0),(302823,8412,'hi','à¤†à¤ˆà¤ªà¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¿à¤°à¥à¤« à¤¯à¤¹ à¤à¤• à¤¸à¥€à¤®à¤¾',0),(302824,8412,'ms','Menghadkan IP hanya ini satu',0),(302825,8412,'ar','ØªÙ‚ÙŠÙŠØ¯ Ø§Ù„Ù…Ù„ÙƒÙŠØ© Ø§Ù„ÙÙƒØ±ÙŠØ© Ù„Ù…Ø¬Ø±Ø¯ Ù‡Ø°Ø§ ÙˆØ§Ø­Ø¯',0),(302826,8412,'fr','Limite d\'IP Ã  tout cela un',0),(302827,8412,'jp','ã¡ã‚‡ã†ã©ã“ã‚Œã‚’ 1 ã¤ã® IP ã‚’åˆ¶é™ã—ã¾ã™ã€‚',0),(302828,8412,'pt','Limitar o IP para isto um',0),(302829,8412,'ru','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡Ð¸Ñ‚ÑŒ IP Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¾Ð´Ð½Ð¾Ð³Ð¾',0),(302830,8412,'es','Limitar IP a solamente esta persona',0),(302831,8412,'de','Begrenzen von IP nur dazu, eine',0),(302832,8412,'en','Limit IP to Just This One',0),(302833,8413,'is','',0),(302834,8413,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆÙ‚Øª Ø§Ø³ØªØ±Ø§Ø­Øª Ø¯Ø± Ø±ÙˆØ² ',0),(302835,8413,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆÙ‚Øª Ø§Ø³ØªØ±Ø§Ø­Øª Ø¯Ø± Ø±ÙˆØ² ',0),(302836,8413,'tr','Max. GÃ¼nlÃ¼k Ã¼cretli tatili',0),(302837,8413,'pl','Max. PÅ‚atnych przerw dziennie',0),(302838,8413,'bg','ÐœÐ°ÐºÑ. ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ Ð¿Ð°ÑƒÐ·Ð¸ Ð½Ð° Ð´ÐµÐ½',0),(302839,8413,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ÛÛ’ Û” ÙÛŒ Ø¯Ù† Ø§Ø¯Ø§ ØªÙˆÚ‘',0),(302840,8413,'sr','ÐœÐ°ÐºÑ. ÐŸÐ»Ð°Ñ›ÐµÐ½Ð¸ Ð¿Ð°ÑƒÐ·Ðµ Ð´Ð½ÐµÐ²Ð½Ð¾',0),(302841,8413,'vi','Tá»‘i Ä‘a giá» nghá»‰ Ä‘Æ°á»£c tráº£ lÆ°Æ¡ng má»—i ngÃ y',0),(302842,8413,'af','Max. Betaalde breek Per dag',0),(302843,8413,'ro','Max. PlÄƒtit pauze pe zi',0),(302844,8413,'et','Max. Tasustatud vaheajad pÃ¤evas',0),(302845,8413,'si','Max. PlaÄane odmori na dan',0),(302846,8413,'ba','Max. Dibayar istirahat setiap hari',0),(302847,8413,'nl','Max. Betaalde einden Per dag',0),(302848,8413,'fi','Max. Palkalliset tauot pÃ¤ivÃ¤ssÃ¤',0),(302849,8413,'no','Max. Betalte pauser Per dag',0),(302850,8413,'da','Max. Betalte pauser om dagen',0),(302851,8413,'ko','ë§¥ìŠ¤ìž…ë‹ˆë‹¤. í•˜ë£¨ ìœ ë£Œ íœ´ì‹',0),(302852,8413,'he','. ×ž×§×¡. ×ž×¢×‘×¨×™ ×‘×ª×©×œ×•× ×œ×™×•×',0),(302853,8413,'el','Max. Î Î»Î·ÏÏ‰Î¼Î­Î½Î· Î´Î¹Î±Î»ÎµÎ¯Î¼Î¼Î±Ï„Î± Î±Î½Î¬ Î·Î¼Î­ÏÎ±',0),(302854,8413,'zh','æ¯å¤©æœ€å¤šã€‚å¸¦è–ªä¼‘æ¯\r\n',0),(302855,8413,'sv','Max. Betald raster Per dag',0),(302856,8413,'it','Max. Pause pagati al giorno',0),(302857,8413,'tl','',0),(302858,8413,'th','&#3648;&#3623;&#3621;&#3634;&#3627;&#3618;&#3640;&#3604;&#3614;&#3633;&#3585;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3605;&#3656;&#3629;&#3623;&#3633;&#3609;',0),(302859,8413,'hi','à¤®à¥ˆà¤•à¥à¤¸à¥¤ à¤ªà¥à¤°à¤¤à¤¿ à¤¦à¤¿à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤¤à¥‹à¤¡à¤¼à¤¤à¤¾',0),(302860,8413,'ms','Max. Rehat yang dibayar setiap hari',0),(302861,8413,'ar','Ù…Ø§ÙƒØ³. ÙÙˆØ§ØµÙ„ Ù…Ø¯ÙÙˆØ¹Ø© Ø§Ù„Ø£Ø¬Ø± Ù„Ù„ÙŠÙˆÙ… Ø§Ù„ÙˆØ§Ø­Ø¯',0),(302862,8413,'fr','Max. Pauses payÃ©es par jour',0),(302863,8413,'jp','æœ€å¤§ã€‚1 æ—¥ã®æœ‰çµ¦ä¼‘æš‡',0),(302864,8413,'pt','Max. Quebras de pagas por dia',0),(302865,8413,'ru','ÐœÐ°ÐºÑ. ÐŸÐ»Ð°Ñ‚Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÑ€Ñ‹Ð²Ñ‹ Ð² Ð´ÐµÐ½ÑŒ',0),(302866,8413,'es','Max Descansos Pagados por DÃ­a',0),(302867,8413,'de','Max. Bezahlten Pausen pro Tag',0),(302868,8413,'en','Max. Paid Breaks Per Day',0),(302869,8414,'is','',0),(302870,8414,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø²Ù…Ø§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ù†Ø¨Ø§Ø´ØªÙ‡ Ø´Ø¯Ù‡  Ù‡Ø± Ø§Ø³ØªØ±Ø§Ø­Øª ',0),(302871,8414,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø²Ù…Ø§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ù†Ø¨Ø§Ø´ØªÙ‡ Ø´Ø¯Ù‡  Ù‡Ø± Ø§Ø³ØªØ±Ø§Ø­Øª ',0),(302872,8414,'tr','Max Ã¶deme sonu Tahakkuk ZamanÄ±',0),(302873,8414,'pl','Max wypÅ‚acane czasie naliczone na przerwie',0),(302874,8414,'bg','ÐœÐ°ÐºÑ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð°Ñ‚Ñ€ÑƒÐ¿Ð°Ð½Ð¸ Ð½Ð° Ð¿Ð¾Ñ‡Ð¸Ð²ÐºÐ°',0),(302875,8414,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ÙˆÙ‚Øª ÙÛŒ ØªÙˆÚ‘ ØªÙ…Ø§Ù… ÛÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ø§Ø¯Ø§ Ú©ÛŒØ§',0),(302876,8414,'sr','ÐœÐ°x Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾ Ð¿ÑƒÑ‚ Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°Ð½Ð¸Ñ… Ð¿Ð¾ Ð¿Ð°ÑƒÐ·Ðµ',0),(302877,8414,'vi','Thá»i gian tá»‘i Ä‘a Ä‘Æ°á»£c tráº£ cá»™ng dá»“n má»—i láº§n nghá»‰',0),(302878,8414,'af','Maks Betaalde Ure Opgeloop per Ontbyt',0),(302879,8414,'ro','Max plÄƒtit timp acumulate pe pauzÄƒ',0),(302880,8414,'et','Max tasustatava aja eest vaheaega kogunenud',0),(302881,8414,'si','Max plaÄa Äas obraÄunane na odmor',0),(302882,8414,'ba','Max dibayar waktu diperoleh setiap istirahat',0),(302883,8414,'nl','Max betaald tijd opgebouwde per Break',0),(302884,8414,'fi','Max palkkatyÃ¶ajan kertynyt / tauko',0),(302885,8414,'no','Max lÃ¸nnstid pÃ¥lÃ¸pt per pause',0),(302886,8414,'da','Max lÃ¸ntid periodiseret pr. pause',0),(302887,8414,'ko','ìµœëŒ€ ì§€ë¶ˆ íœ´ì‹ ë‹¹ ë°œìƒ í•œ ì‹œê°„',0),(302888,8414,'he','×ž×§×¡ ×©×™×œ× ×–×ž×Ÿ ×œ×¦×‘×•×¨ ×œ×›×œ ×”×¤×¡×§×”',0),(302889,8414,'el','Max Î¼ÎµÏ„ Î´ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Î± Î±Î½Î¬ Î´Î¹Î¬Î»ÎµÎ¹Î¼Î¼Î±',0),(302890,8414,'zh','æ¯é—´éš”ç´¯è®¡æ—¶é—´æœ€é«˜æ”¯ä»˜\r\n',0),(302891,8414,'sv','Max betald tid upplupna per paus',0),(302892,8414,'it','Max pagato tempo maturato per ogni pausa',0),(302893,8414,'tl','',0),(302894,8414,'th','&#3648;&#3623;&#3621;&#3634;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3607;&#3637;&#3656;&#3648;&#3614;&#3636;&#3656;&#3617;&#3651;&#3627;&#3657;&#3605;&#3656;&#3629;&#3585;&#3634;&#3619;&#3627;&#3618;&#3640;&#3604;&#3614;&#3633;&#3585;',0),(302895,8414,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¤®à¤¯ à¤…à¤°à¥à¤œà¤¿à¤¤ à¤¤à¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(302896,8414,'ms','Max dibayar masa terakru satu percutian',0),(302897,8414,'ar','Ù…Ø§ÙƒØ³ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© ÙƒÙ„ ÙØ§ØµÙ„ Ø§Ù„ÙˆÙ‚Øª',0),(302898,8414,'fr','Max payÃ© date Ã©chu par pause',0),(302899,8414,'jp','æœ€å¤§æ”¯æ‰•æ™‚é–“ä¼‘æ†©ã”ã¨ã«è¨ˆä¸Š',0),(302900,8414,'pt','Max pagos acumulado por intervalo de tempo',0),(302901,8414,'ru','ÐœÐ°ÐºÑ Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÐ¼Ð¾Ðµ Ð²Ñ€ÐµÐ¼Ñ Ð½Ð°ÐºÐ¾Ð¿Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð·Ð° Ð¿ÐµÑ€ÐµÑ€Ñ‹Ð²',0),(302902,8414,'es','Max Tiempo Pagado Acumulado por Descanso',0),(302903,8414,'de','Max bezahlt Zeit aufgelaufenen pro Pause',0),(302904,8414,'en','Max Paid Time Accrued per Break',0),(302905,8415,'is','',0),(302906,8415,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø²Ù…Ø§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ Ù†Ø§Ù‡Ø§Ø± Ø¯Ø± Ø±ÙˆØ² ',0),(302907,8415,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø²Ù…Ø§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÙŠ Ù†Ø§Ù‡Ø§Ø± Ø¯Ø± Ø±ÙˆØ² ',0),(302908,8415,'tr','GÃ¼nlÃ¼k Ã¶ÄŸle yemeÄŸi iÃ§in zaman sÄ±nÄ±rÄ± Ã¶denen',0),(302909,8415,'pl','Maksymalny czas zapÅ‚aciÅ‚ za obiad dziennie',0),(302910,8415,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð° Ð·Ð° Ð¾Ð±ÑÐ´ Ð½Ð° Ð´ÐµÐ½',0),(302911,8415,'ur','ÛØ± Ø±ÙˆØ² Ø¯ÙˆÙ¾ÛØ± Ú©Û’ Ú©Ú¾Ø§Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ÙˆÙ‚Øª Ø§Ø¯Ø§ Ú©ÛŒØ§',0),(302912,8415,'sr','ÐœÐ°x Ð¿ÑƒÑ‚ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾ Ð·Ð° Ñ€ÑƒÑ‡Ð°Ðº ÑÐ²Ð°ÐºÐ¸ Ð´Ð°Ð½',0),(302913,8415,'vi','Thá»i gian tá»‘i Ä‘a tráº£ cho Äƒn trÆ°a má»—i ngÃ y',0),(302914,8415,'af','Maks Tyd Betaal vir Etenstyd Per Dag',0),(302915,8415,'ro','Max timp plÄƒtit pentru masa de prÃ¢nz pe zi',0),(302916,8415,'et','Max aeg tasuda iga pÃ¤ev lÃµunasÃ¶Ã¶giks',0),(302917,8415,'si','NajveÄji dovoljeni Äas plaÄan za kosilo na dan',0),(302918,8415,'ba','Max waktu dibayar untuk makan siang setiap hari',0),(302919,8415,'nl','Max tijd betaald voor de Lunch Per dag',0),(302920,8415,'fi','EnimmÃ¤isaika maksetaan lounaalle pÃ¤ivÃ¤ssÃ¤',0),(302921,8415,'no','Max Time betalt lunsj Per dag',0),(302922,8415,'da','Max tid betalt frokost pr. dag',0),(302923,8415,'ko','ìµœëŒ€ ì‹œê°„ í•˜ë£¨ ì ì‹¬ì— ëŒ€ í•œ ì§€ë¶ˆ',0),(302924,8415,'he','×–×ž×Ÿ ×ž×§×¡ ×©×™×œ× ×¢×‘×•×¨ ××¨×•×—×ª ×¦×”×¨×™×™× ×œ×™×•×',0),(302925,8415,'el','Max ÏŽÏÎ± Ï€Î»Î·ÏÏŽÎ½Î¿Î½Ï„Î±Î¹ Î³ÎµÏÎ¼Î± Î·Î¼ÎµÏÎ·ÏƒÎ¯Ï‰Ï‚',0),(302926,8415,'zh','æ¯æ—¥æ”¯ä»˜åˆé¤æœ€é•¿æ—¶é—´\r\n',0),(302927,8415,'sv','Max tid betalat fÃ¶r Lunch Per dag',0),(302928,8415,'it','Max tempo pagato per il pranzo al giorno',0),(302929,8415,'tl','',0),(302930,8415,'th','&#3648;&#3623;&#3621;&#3634;&#3614;&#3633;&#3585;&#3648;&#3607;&#3637;&#3656;&#3618;&#3591;&#3626;&#3641;&#3591;&#3626;&#3640;&#3604;&#3605;&#3656;&#3629;&#3623;&#3633;&#3609;',0),(302931,8415,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¤®à¤¯ à¤ªà¥à¤°à¤¤à¤¿ à¤¦à¤¿à¤¨ à¤¦à¥‹à¤ªà¤¹à¤° à¤•à¥‡ à¤­à¥‹à¤œà¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(302932,8415,'ms','Masa maksimum yang dibayar untuk Makan tengah hari setiap hari',0),(302933,8415,'ar','ÙˆÙ‚Øª Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ ØªØ¯ÙØ¹ Ù„ØªÙ†Ø§ÙˆÙ„ Ø·Ø¹Ø§Ù… Ø§Ù„ØºØ¯Ø§Ø¡ ÙÙŠ Ø§Ù„ÙŠÙˆÙ… Ø§Ù„ÙˆØ§Ø­Ø¯',0),(302934,8415,'fr','Max temps payÃ© pour dÃ©jeuner par jour',0),(302935,8415,'jp','æœ€å¤§æ™‚é–“ã¯ 1 æ—¥ã‚ãŸã‚Šã®æ˜¼é£Ÿã‚’æ”¯æ‰•ã£ãŸ',0),(302936,8415,'pt','Max tempo pagou almoÃ§o por dia',0),(302937,8415,'ru','ÐœÐ°ÐºÑ Ð²Ñ€ÐµÐ¼Ñ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ð» Ð·Ð° Ð¾Ð±ÐµÐ´ Ð² Ð´ÐµÐ½ÑŒ',0),(302938,8415,'es','Max Tiempo Pagado para Comida Por DÃ­a',0),(302939,8415,'de','Max. Zeit fÃ¼r Mittagessen pro Tag bezahlt',0),(302940,8415,'en','Max Time Paid for Lunch Per Day',0),(302941,8416,'is','',0),(302942,8416,'dr','Ø¯ÙˆØ´Ù†Ø¨Ù‡ ',0),(302943,8416,'pr','Ø¯ÙˆØ´Ù†Ø¨Ù‡ ',0),(302944,8416,'tr','Pazartesi',0),(302945,8416,'pl','PoniedziaÅ‚ek',0),(302946,8416,'bg','ÐŸÐ¾Ð½ÐµÐ´ÐµÐ»Ð½Ð¸Ðº',0),(302947,8416,'ur','Ù¾ÛŒØ± Ú©Û’ Ø±ÙˆØ²',0),(302948,8416,'sr','Ð£ Ð¿Ð¾Ð½ÐµÐ´ÐµÑ™Ð°Ðº',0),(302949,8416,'vi','Thá»© Hai',0),(302950,8416,'af','Maandag',0),(302951,8416,'ro','Luni',0),(302952,8416,'et','EsmaspÃ¤ev',0),(302953,8416,'si','Ponedeljek',0),(302954,8416,'ba','Senin',0),(302955,8416,'nl','Maandag',0),(302956,8416,'fi','Maanantai',0),(302957,8416,'no','Mandag',0),(302958,8416,'da','Mandag',0),(302959,8416,'ko','ì›”ìš”ì¼',0),(302960,8416,'he','×™×•× ×©× ×™',0),(302961,8416,'el','Î”ÎµÏ…Ï„Î­ÏÎ±',0),(302962,8416,'zh','æ˜ŸæœŸä¸€\r\n',0),(302963,8416,'sv','MÃ¥ndag',0),(302964,8416,'it','LunedÃ¬',0),(302965,8416,'tl','',0),(302966,8416,'th','&#3623;&#3633;&#3609;&#3592;&#3633;&#3609;&#3607;&#3619;&#3660;',0),(302967,8416,'hi','à¤¸à¥‹à¤®à¤µà¤¾à¤°',0),(302968,8416,'ms','Hari Isnin',0),(302969,8416,'ar','Ø§Ù„Ø¥Ø«Ù†ÙŠÙ†',0),(302970,8416,'fr','Lundi',0),(302971,8416,'jp','æœˆæ›œæ—¥',0),(302972,8416,'pt','Segunda-feira',0),(302973,8416,'ru','ÐŸÐ¾Ð½ÐµÐ´ÐµÐ»ÑŒÐ½Ð¸Ðº',0),(302974,8416,'es','Lunes',0),(302975,8416,'de','Montag',0),(302976,8416,'en','Monday',0),(302977,8417,'is','',0),(302978,8417,'dr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ ÙƒØ§Ø± Ø¨Ù‡ ÙŠÙƒ Ø±ÙˆØ² Ø¯ÙŠÚ¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø­Ù‚ÙˆÙ‚ ',0),(302979,8417,'pr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ ÙƒØ§Ø± Ø¨Ù‡ ÙŠÙƒ Ø±ÙˆØ² Ø¯ÙŠÚ¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø­Ù‚ÙˆÙ‚ ',0),(302980,8417,'tr','Ä°ÅŸ iÃ§in baÅŸka bir Ã¶deme gÃ¼n hareketli',0),(302981,8417,'pl','PrzesÅ‚anie prac na inny dzieÅ„ wypÅ‚aty',0),(302982,8417,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð² Ð´Ñ€ÑƒÐ³ Ð´ÐµÐ½ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾',0),(302983,8417,'ur','Ú©Ø§Ù… Ú©Û’ Ù„Ø¦Û’ ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ø¯ÙˆØ³Ø±Û’ Ø¯Ù† Ø¨Ú‘Ú¾Ø§ Ø±ÛØ§ ÛÛ’ Û”',0),(302984,8417,'sr','Ð¡ÐµÐ»Ð¸ Ñ€Ð°Ð´ Ñƒ Ð´Ñ€ÑƒÐ³Ð¾Ð¼ Ð¿Ð»Ð°Ñ‚Ð°',0),(302985,8417,'vi','Chuyá»ƒn cÃ´ng viá»‡c sang ngÃ y tráº£ lÆ°Æ¡ng khÃ¡c',0),(302986,8417,'af','Skuif Werk na \'n Ander Betaaldag',0),(302987,8417,'ro','Mutarea de lucru pentru o altÄƒ zi de salariu',0),(302988,8417,'et','TÃ¶Ã¶ kolimist teise palgapÃ¤eval',0),(302989,8417,'si','Premikanje dela za drugo plaÄilo dan',0),(302990,8417,'ba','Pindah kerja ke lain hari membayar',0),(302991,8417,'nl','Verplaatsen van werk naar een andere beloning dag',0),(302992,8417,'fi','Liikkuva tyÃ¶ toinen maksaa pÃ¤ivÃ¤',0),(302993,8417,'no','Flytte arbeid til en annen Pay-dag',0),(302994,8417,'da','Flytte arbejde til en anden lÃ¸nningsdag',0),(302995,8417,'ko','ë‹¤ë¥¸ ì§€ë¶ˆ ì¼ì— ìž‘ì—…ì„ ì´ë™',0),(302996,8417,'he','×”×¢×‘×¨×ª ×”×¢×‘×•×“×” ×¢×•×“ ×™×•× ×©×œ×',0),(302997,8417,'el','ÎœÎµÏ„Î±ÎºÎ¯Î½Î·ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÏƒÎµ Î¼Î¹Î± Î¬Î»Î»Î· Î·Î¼Î­ÏÎ± Î±Î¼Î¿Î¹Î²Î®Ï‚',0),(302998,8417,'zh','ç§»åŠ¨å·¥ä½œåˆ°å¦ä¸€ä¸ªå‘è–ªæ—¥\r\n',0),(302999,8417,'sv','Flytta arbete till en annan lÃ¶n dag',0),(303000,8417,'it','Lavoro in movimento per un altro giorno di paga',0),(303001,8417,'tl','',0),(303002,8417,'th','&#3618;&#3657;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3635;&#3591;&#3634;&#3609;&#3652;&#3611;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3623;&#3633;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(303003,8417,'hi','à¤•à¤¾à¤® à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤…à¤¨à¥à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨ à¤šà¤²à¤¤à¥€',0),(303004,8417,'ms','Berpindah kerja ke satu lagi gaji hari',0),(303005,8417,'ar','Ù†Ù‚Ù„ Ø§Ù„Ø¹Ù…Ù„ Ø¥Ù„Ù‰ Ø¢Ø®Ø± ÙŠÙˆÙ… Ø§Ù„Ø¯ÙØ¹',0),(303006,8417,'fr','DÃ©placement de travail Ã  un autre jour de paie',0),(303007,8417,'jp','ä½œæ¥­åˆ¥ã®çµ¦æ–™æ—¥ã«ç§»å‹•ã—ã¾ã™ã€‚',0),(303008,8417,'pt','Movendo-se trabalho para mais um dia de pagamento',0),(303009,8417,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ð´ÐµÐ½ÑŒ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹',0),(303010,8417,'es','Moviendo el Trabajo al Otro DÃ­a de Pago',0),(303011,8417,'de','Arbeit an einem anderen Tag zu zahlen verschieben',0),(303012,8417,'en','Moving Work to Another Pay Day',0),(303013,8418,'is','',0),(303014,8418,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø­Ù‚ÙˆÙ‚ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±Ù‰',0),(303015,8418,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø­Ù‚ÙˆÙ‚ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±Ù‰',0),(303016,8418,'tr','KullanÄ±m fazla mesai Ã¶deme',0),(303017,8418,'pl','Nadgodziny zapÅ‚aciÄ‡ wykorzystania',0),(303018,8418,'bg','Ð˜Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´ÐµÐ½ Ñ‚Ñ€ÑƒÐ´ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(303019,8418,'ur','Ø§ÙˆÙˆØ±Ù¹Ø§Ù…ÛŒ Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(303020,8418,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÑƒ Ð¿Ñ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¾Ð³ Ñ€Ð°Ð´Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ',0),(303021,8418,'vi','DÃ¹ng Tráº£ lÃ m thÃªm giá»',0),(303022,8418,'af','Oortyd Besoldiging Gebruik',0),(303023,8418,'ro','Utilizarea plata orelor suplimentare',0),(303024,8418,'et','Ãœletunnitasu kasutamine',0),(303025,8418,'si','Nadure plaÄilo uporabe',0),(303026,8418,'ba','Lembur penggunaan',0),(303027,8418,'nl','Overuren betalen gebruik',0),(303028,8418,'fi','YlityÃ¶palkka kÃ¤yttÃ¶',0),(303029,8418,'no','Overtid, bruk',0),(303030,8418,'da','Overtidsbetaling brug',0),(303031,8418,'ko','ì‹œê°„ ì™¸ ì‚¬ìš©ì„ ì§€ë¶ˆ',0),(303032,8418,'he','×©×™×ž×•×© ×œ×©×œ× ×©×¢×•×ª × ×•×¡×¤×•×ª',0),(303033,8418,'el','Î§ÏÎ®ÏƒÎ· Ï…Ï€ÎµÏÏ‰ÏÎ¹Î±ÎºÎ®Ï‚ Î±Î¼Î¿Î¹Î²Î®Ï‚',0),(303034,8418,'zh','åŠ ç­è´¹ä½¿ç”¨\r\n',0),(303035,8418,'sv','Ã–vertid betala anvÃ¤ndning',0),(303036,8418,'it','Pagare gli straordinari uso',0),(303037,8418,'tl','',0),(303038,8418,'th','&#3651;&#3594;&#3657;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3588;&#3656;&#3634;&#3621;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(303039,8418,'hi','à¤¸à¤®à¤¯à¥‹à¤ªà¤°à¤¿ à¤µà¥‡à¤¤à¤¨ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(303040,8418,'ms','Lebih masa membayar penggunaan',0),(303041,8418,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø¬Ø± Ø¹Ù† Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ',0),(303042,8418,'fr','Utilisation de rÃ©munÃ©ration des heures supplÃ©mentaires',0),(303043,8418,'jp','ä½¿ç”¨æ™‚é–“å¤–æ‰‹å½“',0),(303044,8418,'pt','Pagar hora extra a utilizaÃ§Ã£o',0),(303045,8418,'ru','Ð¡Ð²ÐµÑ€Ñ…ÑƒÑ€Ð¾Ñ‡Ð½ÑƒÑŽ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(303046,8418,'es','Uso de Pago de Horas Extras',0),(303047,8418,'de','Ãœberstunden bezahlen verwenden',0),(303048,8418,'en','Overtime Pay Use',0),(303049,8419,'is','',0),(303050,8419,'dr','Ø­Ù‚ÙˆÙ‚ Ù‡ÙØªÚ¯ÙŠ Ø´Ø±ÙˆØ¹ Ù…ÙŠ Ø´ÙˆØ¯ Ø·Ø¨Ù‚',0),(303051,8419,'pr','Ø­Ù‚ÙˆÙ‚ Ù‡ÙØªÚ¯ÙŠ Ø´Ø±ÙˆØ¹ Ù…ÙŠ Ø´ÙˆØ¯ Ø·Ø¨Ù‚',0),(303052,8419,'tr','Ã–deme hafta baÅŸlangÄ±cÄ±',0),(303053,8419,'pl','ZapÅ‚aciÄ‡ tydzieÅ„ zaczyna siÄ™ od',0),(303054,8419,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÑÐµÐ´Ð¼Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð²',0),(303055,8419,'ur','ØªÙ†Ø®ÙˆØ§Û ÛÙØªÛ Ù¾Ø± Ø´Ø±ÙˆØ¹ ÛÙˆØªØ§ ÛÛ’',0),(303056,8419,'sr','ÐŸÐ»Ð°Ñ‚Ðµ ÑÐµÐ´Ð¼Ð¸Ñ†Ð° Ð¿Ð¾Ñ‡Ð¸ÑšÐµ Ð½Ð°',0),(303057,8419,'vi','Tráº£ tuáº§n báº¯t Ä‘áº§u tá»«',0),(303058,8419,'af','Betaalnweek Begin Op',0),(303059,8419,'ro','Plata sÄƒptÄƒmÃ¢na Ã®ncepe',0),(303060,8419,'et','Tasu nÃ¤dal algab',0),(303061,8419,'si','PlaÄilo teden se zaÄne v',0),(303062,8419,'ba','Bayar minggu dimulai pada',0),(303063,8419,'nl','Betalen Week begint op',0),(303064,8419,'fi','Maksu viikko alkaa',0),(303065,8419,'no','Betal uken begynner pÃ¥',0),(303066,8419,'da','LÃ¸n uge begynder pÃ¥',0),(303067,8419,'ko','ìœ ë£Œ ì£¼ì— ì‹œìž‘',0),(303068,8419,'he','×©×‘×•×¢ ×©×œ× ×ž×ª×—×™×œ×” ×‘',0),(303069,8419,'el','Î Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Ï„Î·Î½ ÎµÎ²Î´Î¿Î¼Î¬Î´Î± Ï€Î¿Ï… Î±ÏÏ‡Î¯Î¶ÎµÎ¹ ÏƒÏ„Î¹Ï‚',0),(303070,8419,'zh','æ”¯ä»˜å‘¨å¼€å§‹æ—¶é—´\r\n',0),(303071,8419,'sv','LÃ¶n veckan bÃ¶rjar pÃ¥',0),(303072,8419,'it','Paga settimana inizia',0),(303073,8419,'tl','',0),(303074,8419,'th','&#3592;&#3656;&#3634;&#3618;&#3619;&#3634;&#3618;&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3648;&#3617;&#3639;&#3656;&#3629;',0),(303075,8419,'hi','à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤•à¥‡ à¤µà¥‡à¤¤à¤¨ à¤ªà¤° à¤¶à¥à¤°à¥‚ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ',0),(303076,8419,'ms','Minggu gaji bermula',0),(303077,8419,'ar','ÙŠØ¨Ø¯Ø£ Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ ÙÙŠ Ø§Ù„Ø£Ø¬Ø± ÙÙŠ',0),(303078,8419,'fr','Semaine de paie commence le',0),(303079,8419,'jp','æœ‰æ–™ã®é€±ã®é–‹å§‹æ—¥',0),(303080,8419,'pt','Semana de pagamento comeÃ§a na',0),(303081,8419,'ru','ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ðµ Ð½ÐµÐ´ÐµÐ»Ñ Ð½Ð°Ñ‡Ð¸Ð½Ð°ÐµÑ‚ÑÑ Ñ',0),(303082,8419,'es','Semana de Pago Comienza En',0),(303083,8419,'de','Pay-Woche beginnt am',0),(303084,8419,'en','Pay Week Begins On',0),(303085,8420,'is','',0),(303086,8420,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø­Ù‚ÙˆÙ‚ Ø«Ø§Ø¨Øª ',0),(303087,8420,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø­Ù‚ÙˆÙ‚ Ø«Ø§Ø¨Øª ',0),(303088,8420,'tr','DÃ¼zenli Ã¶deme kullanÄ±mÄ±',0),(303089,8420,'pl','Stosowanie regularnych pÅ‚atnoÅ›ci',0),(303090,8420,'bg','Ð ÐµÐ´Ð¾Ð²Ð½Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(303091,8420,'ur','Ø¨Ø§Ù‚Ø§Ø¹Ø¯Û ØªÙ†Ø®ÙˆØ§Û Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(303092,8420,'sr','Ð ÐµÐ´Ð¾Ð²Ð½Ðµ Ð¿Ð»Ð°Ñ‚Ðµ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ',0),(303093,8420,'vi','Sá»­ dá»¥ng Thanh toÃ¡n thÆ°á»ng ká»³',0),(303094,8420,'af','Gereelde Besoldiging Gebruik',0),(303095,8420,'ro','Regulat plÄƒti utilizarea',0),(303096,8420,'et','Regulaarne makse kasutamine',0),(303097,8420,'si','Redno plaÄilo uporabe',0),(303098,8420,'ba','Bayar rutin menggunakan',0),(303099,8420,'nl','Regelmatige betalen gebruik',0),(303100,8420,'fi','SÃ¤Ã¤nnÃ¶llinen maksu kÃ¤yttÃ¶',0),(303101,8420,'no','Vanlig Betal bruk',0),(303102,8420,'da','RegelmÃ¦ssig lÃ¸n brug',0),(303103,8420,'ko','ì¼ë°˜ ìœ ë£Œ ì‚¬ìš©',0),(303104,8420,'he','×©×™×ž×•×© ×”×ž×©×›×•×¨×ª ×”×¨×’×™×œ×”',0),(303105,8420,'el','Î§ÏÎ®ÏƒÎ· Ï„Ï‰Î½ Ï„Î±ÎºÏ„Î¹ÎºÏŽÎ½ Î±Ï€Î¿Î´Î¿Ï‡ÏŽÎ½',0),(303106,8420,'zh','å¸¸è§„å·¥èµ„ä½¿ç”¨\r\n\r\n',0),(303107,8420,'sv','Regelbunden betala anvÃ¤nda',0),(303108,8420,'it','Uso regolare retribuzione',0),(303109,8420,'tl','',0),(303110,8420,'th','&#3651;&#3594;&#3657;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3648;&#3611;&#3655;&#3609;&#3611;&#3619;&#3632;&#3592;&#3635;',0),(303111,8420,'hi','à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ à¤µà¥‡à¤¤à¤¨ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(303112,8420,'ms','Gaji biasa digunakan',0),(303113,8420,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¹Ø§Ø¯ÙŠØ©',0),(303114,8420,'fr','Utilisation de la paye rÃ©guliÃ¨re',0),(303115,8420,'jp','æ­£è¦ã®æœ‰æ–™ä½¿ç”¨',0),(303116,8420,'pt','Uso regular de pagamento',0),(303117,8420,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ€ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ð¾Ð¹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(303118,8420,'es','Uso de Pago Regular',0),(303119,8420,'de','RegelmÃ¤ÃŸige Pay Use',0),(303120,8420,'en','Regular Pay Use',0),(303121,8421,'is','',0),(303122,8421,'dr','ÙŠÙƒØ´Ù†Ø¨Ù‡',0),(303123,8421,'pr','ÙŠÙƒØ´Ù†Ø¨Ù‡',0),(303124,8421,'tr','Pazar',0),(303125,8421,'pl','Niedziela',0),(303126,8421,'bg','ÐÐµÐ´ÐµÐ»Ñ',0),(303127,8421,'ur','Ø§ØªÙˆØ§Ø± Ú©Û’ Ø±ÙˆØ²',0),(303128,8421,'sr','Ð£ Ð½ÐµÐ´ÐµÑ™Ñƒ',0),(303129,8421,'vi','Chá»§ nháº­t',0),(303130,8421,'af','Sondag',0),(303131,8421,'ro','DuminicÄƒ',0),(303132,8421,'et','PÃ¼hapÃ¤ev',0),(303133,8421,'si','Nedelja',0),(303134,8421,'ba','Minggu',0),(303135,8421,'nl','Zondag',0),(303136,8421,'fi','Sunnuntai',0),(303137,8421,'no','SÃ¸ndag',0),(303138,8421,'da','SÃ¸ndag',0),(303139,8421,'ko','ì¼ìš”ì¼',0),(303140,8421,'he','×™×•× ×¨××©×•×Ÿ',0),(303141,8421,'el','ÎšÏ…ÏÎ¹Î±ÎºÎ®',0),(303142,8421,'zh','æ˜ŸæœŸæ—¥\r\n',0),(303143,8421,'sv','SÃ¶ndag',0),(303144,8421,'it','Domenica',0),(303145,8421,'tl','',0),(303146,8421,'th','&#3623;&#3633;&#3609;&#3629;&#3634;&#3607;&#3636;&#3605;&#3618;&#3660;',0),(303147,8421,'hi','à¤°à¤µà¤¿à¤µà¤¾à¤°',0),(303148,8421,'ms','Hari Ahad',0),(303149,8421,'ar','Ø§Ù„Ø£Ø­Ø¯',0),(303150,8421,'fr','Dimanche',0),(303151,8421,'jp','æ—¥æ›œæ—¥',0),(303152,8421,'pt','Domingo',0),(303153,8421,'ru','Ð’Ð¾ÑÐºÑ€ÐµÑÐµÐ½ÑŒÐµ',0),(303154,8421,'es','Domingo',0),(303155,8421,'de','Sonntag',0),(303156,8421,'en','Sunday',0),(303157,8422,'is','',0),(303158,8422,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙƒÙ„ÙŠ Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(303159,8422,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙƒÙ„ÙŠ Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(303160,8422,'tr','TimeClock Genel Kurulum',0),(303161,8422,'pl','Ustawienia ogÃ³lne TimeClock',0),(303162,8422,'bg','TimeClock ÐžÐ±Ñ‰Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(303163,8422,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ø¬Ù†Ø±Ù„ Ø³ÛŒÙ¹ Ø§Ù¾',0),(303164,8422,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð³Ð»Ð°Ð²Ð½Ðµ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº',0),(303165,8422,'vi','Setup mÃ¡y cháº¥m cÃ´ng chung',0),(303166,8422,'af','Tydklok Algemene Opstelling',0),(303167,8422,'ro','Ceas Parametrizare',0),(303168,8422,'et','TimeClock Ã¼ldine seadistus',0),(303169,8422,'si','Nastavitev sploÅ¡nega TimeClock',0),(303170,8422,'ba','Tetapan umum timeclock',0),(303171,8422,'nl','Klok algemene Setup',0),(303172,8422,'fi','Timeclock asennuksen',0),(303173,8422,'no','TimeClock generelt oppsett',0),(303174,8422,'da','Timeclock generel opsÃ¦tning',0),(303175,8422,'ko','Timeclock ì¼ë°˜ ì„¤ì •',0),(303176,8422,'he','×”×’×“×¨×ª ×›×œ×œ×™ Timeclock',0),(303177,8422,'el','Timeclock Î Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(303178,8422,'zh','ä¸€èˆ¬è®¾ç½®æ—¶é’Ÿ\r\n',0),(303179,8422,'sv','Timeclock allmÃ¤n instÃ¤llning',0),(303180,8422,'it','Setup generale Timeclock',0),(303181,8422,'tl','',0),(303182,8422,'th','&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3',0),(303183,8422,'hi','Timeclock à¤œà¤¨à¤°à¤² à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(303184,8422,'ms','Persediaan umum Timeclock',0),(303185,8422,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø¹Ø§Ù…Ø© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(303186,8422,'fr','Installation gÃ©nÃ©rale Timeclock',0),(303187,8422,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ä¸€èˆ¬çš„ãªã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(303188,8422,'pt','Timeclock General Setup',0),(303189,8422,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ñ… Ð§Ð°ÑÐ¾Ð²',0),(303190,8422,'es','ConfiguraciÃ³n General de Reloj Checador',0),(303191,8422,'de','Timeclock General Setup',0),(303192,8422,'en','Timeclock General Setup',0),(303193,8423,'is','',0),(303194,8423,'dr','Ø¢ÙŠØ§ Ø§ÙŠÙ† Ø²Ù…Ø§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø³Øª ØŸ',0),(303195,8423,'pr','Ø¢ÙŠØ§ Ø§ÙŠÙ† Ø²Ù…Ø§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø³Øª ØŸ',0),(303196,8423,'tr','Bu Ã¶deme zamanÄ±?',0),(303197,8423,'pl','Jest to pÅ‚atne razem?',0),(303198,8423,'bg','Ð¢Ð¾Ð²Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð° Ð²Ñ€ÐµÐ¼Ðµ Ð»Ð¸ Ðµ?',0),(303199,8423,'ur','ÛŒÛ ÙˆÙ‚Øª Ø§Ø¯Ø§ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ØŸ',0),(303200,8423,'sr','ÐˆÐµ Ð»Ð¸ Ð¾Ð²Ð¾ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾ Ð¿ÑƒÑ‚?',0),(303201,8423,'vi','CÃ³ pháº£i thá»i gian Ä‘Ã£ tráº£?',0),(303202,8423,'af','Is dit Betaalde Tyd?',0),(303203,8423,'ro','Este acest timp plÄƒtit?',0),(303204,8423,'et','Kas see makseaeg?',0),(303205,8423,'si','Je to plaÄa Äas?',0),(303206,8423,'ba','Ini dibayar waktu?',0),(303207,8423,'nl','Is dit keer betaald?',0),(303208,8423,'fi','TÃ¤mÃ¤ maksettavaa aikaa?',0),(303209,8423,'no','Er dette lÃ¸nnstid?',0),(303210,8423,'da','Er det betalt tid?',0),(303211,8423,'ko','ì´ ì‹œê°„ì„ ì§€ë¶ˆ?',0),(303212,8423,'he','×–×” ×©×™×œ× ×¤×¢×?',0),(303213,8423,'el','Î•Î¯Î½Î±Î¹ Î±Ï…Ï„ÏŒ Ï€Î»Î®ÏÏ‰ÏƒÎ± Ï‡ÏÏŒÎ½Î¿;',0),(303214,8423,'zh','æ­¤å¸¦è–ªï¼Ÿ\r\n',0),(303215,8423,'sv','Ã„r detta betald tid?',0),(303216,8423,'it','Ãˆ questo tempo Paid?',0),(303217,8423,'tl','',0),(303218,8423,'th','&#3609;&#3637;&#3656;&#3648;&#3611;&#3655;&#3609;&#3648;&#3623;&#3621;&#3634;&#3592;&#3656;&#3634;&#3618;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(303219,8423,'hi','à¤‡à¤¸ à¤¸à¤®à¤¯ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ?',0),(303220,8423,'ms','Adakah ini dibayar masa?',0),(303221,8423,'ar','Ù‡Ø°Ø§ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ù…Ø¯ÙÙˆØ¹ØŸ',0),(303222,8423,'fr','Est-ce temps payÃ© ?',0),(303223,8423,'jp','ã“ã®æ™‚é–“ã®æ”¯æ‰•ã„ã¯ï¼Ÿ',0),(303224,8423,'pt','Ã‰ pago a tempo?',0),(303225,8423,'ru','Ð­Ñ‚Ð¾ Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÐ¼Ð¾Ðµ Ð²Ñ€ÐµÐ¼Ñ?',0),(303226,8423,'es','Â¿Es Este Tiempo Pagable?',0),(303227,8423,'de','Ist diese bezahlte Zeit?',0),(303228,8423,'en','Is This Paid Time?',0),(303229,8424,'is','',0),(303230,8424,'dr','Ù†Ø§Ù… Ø¯ÙŠÚ¯Ø± Ø²Ù…Ø§Ù†',0),(303231,8424,'pr','Ù†Ø§Ù… Ø¯ÙŠÚ¯Ø± Ø²Ù…Ø§Ù†',0),(303232,8424,'tr','BaÅŸka zaman adÄ±',0),(303233,8424,'pl','Inna nazwa czas',0),(303234,8424,'bg','Ð”Ñ€ÑƒÐ³Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð¸Ð¼Ðµ',0),(303235,8424,'ur','Ø¯ÙˆØ³Ø±Û’ ÙˆÙ‚Øª Ú©Û’ Ù†Ø§Ù…',0),(303236,8424,'sr','Ð”Ñ€ÑƒÐ³Ð¸ Ð¿ÑƒÑ‚ Ð¸Ð¼Ðµ',0),(303237,8424,'vi','TÃªn Thá»i gian khÃ¡c',0),(303238,8424,'af','Ander Tyd Naam',0),(303239,8424,'ro','Alte nume de timp',0),(303240,8424,'et','Muu aeg nimi',0),(303241,8424,'si','Drugo ime za Äas',0),(303242,8424,'ba','Nama waktu lain',0),(303243,8424,'nl','De naam van andere tijd',0),(303244,8424,'fi','Muu aika nimi',0),(303245,8424,'no','Andre gang navnet',0),(303246,8424,'da','Anden gang navn',0),(303247,8424,'ko','ë‹¤ë¥¸ ì‹œê°„ ì´ë¦„',0),(303248,8424,'he','×©× ×–×ž×Ÿ ××—×¨',0),(303249,8424,'el','Î†Î»Î»Î¿ ÏŒÎ½Î¿Î¼Î± Ï‡ÏÏŒÎ½Î¿',0),(303250,8424,'zh','å…¶ä»–æ—¶é—´åç§°\r\n',0),(303251,8424,'sv','Andra gÃ¥ngen namn',0),(303252,8424,'it','Altro nome di tempo',0),(303253,8424,'tl','',0),(303254,8424,'th','&#3594;&#3639;&#3656;&#3629;&#3648;&#3623;&#3621;&#3634;&#3629;&#3639;&#3656;&#3609;',0),(303255,8424,'hi','à¤…à¤¨à¥à¤¯ à¤¸à¤®à¤¯ à¤•à¥‡ à¤¨à¤¾à¤®',0),(303256,8424,'ms','Nama masa lain',0),(303257,8424,'ar','Ø§Ù„Ø§Ø³Ù… Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(303258,8424,'fr','Autre nom de temps',0),(303259,8424,'jp','ãã®ä»–æ™‚é–“å',0),(303260,8424,'pt','Outro nome de tempo',0),(303261,8424,'ru','Ð”Ñ€ÑƒÐ³Ð¾Ðµ Ð²Ñ€ÐµÐ¼Ñ Ð¸Ð¼Ñ',0),(303262,8424,'es','Nombre de Otro Tiempo',0),(303263,8424,'de','Andere Namen',0),(303264,8424,'en','Other Time Name',0),(303265,8425,'is','',0),(303266,8425,'dr','Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ø¯ÙŠÚ¯Ø± Ø²Ù…Ø§Ù†',0),(303267,8425,'pr','Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ø¯ÙŠÚ¯Ø± Ø²Ù…Ø§Ù†',0),(303268,8425,'tr','TimeClock baÅŸka zaman',0),(303269,8425,'pl','TimeClock innym razem',0),(303270,8425,'bg','TimeClock Ð´Ñ€ÑƒÐ³Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(303271,8425,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ø¯ÙˆØ³Ø±Û’ ÙˆÙ‚Øª',0),(303272,8425,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð´Ñ€ÑƒÐ³Ð¸ Ð¿ÑƒÑ‚',0),(303273,8425,'vi','Thá»i gian mÃ¡y cháº¥m cÃ´ng khÃ¡c',0),(303274,8425,'af','Tydklok Ander Tyd',0),(303275,8425,'ro','Ceas timp alte',0),(303276,8425,'et','TimeClock muul ajal',0),(303277,8425,'si','TimeClock drugi Äas',0),(303278,8425,'ba','Timeclock waktu lain',0),(303279,8425,'nl','Klok andere tijd',0),(303280,8425,'fi','Timeclock toiste',0),(303281,8425,'no','TimeClock andre gang',0),(303282,8425,'da','Timeclock anden gang',0),(303283,8425,'ko','ë‹¤ë¥¸ ì‹œê°„ì— Timeclock',0),(303284,8425,'he','Timeclock. ×‘×¤×¢× ××—×¨×ª',0),(303285,8425,'el','Timeclock Î¬Î»Î»Î· Ï†Î¿ÏÎ¬',0),(303286,8425,'zh','å…¶ä»–æ—¶é—´æ—¶é’Ÿ\r\n',0),(303287,8425,'sv','Timeclock andra tid',0),(303288,8425,'it','Timeclock altra volta',0),(303289,8425,'tl','',0),(303290,8425,'th','&#3648;&#3623;&#3621;&#3634;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3629;&#3639;&#3656;&#3609;',0),(303291,8425,'hi','Timeclock à¤…à¤¨à¥à¤¯ à¤¸à¤®à¤¯',0),(303292,8425,'ms','Timeclock masa',0),(303293,8425,'ar','ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(303294,8425,'fr','Timeclock autres temps',0),(303295,8425,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ã®ä»–ã®æ™‚é–“',0),(303296,8425,'pt','Timeclock outra vez',0),(303297,8425,'ru','Ð§Ð°ÑÑ‹ Ð”Ñ€ÑƒÐ³Ð¾Ðµ Ð’Ñ€ÐµÐ¼Ñ',0),(303298,8425,'es','Reloj Checador Otro Tiempo',0),(303299,8425,'de','Timeclock andermal',0),(303300,8425,'en','Timeclock Other Time',0),(303301,8426,'is','',0),(303302,8426,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø²Ù…Ø§Ù† Ø¯ÙŠÚ¯Ø± Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(303303,8426,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø²Ù…Ø§Ù† Ø¯ÙŠÚ¯Ø± Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(303304,8426,'tr','BaÅŸka zaman TimeClock DÃ¼zenle',0),(303305,8426,'pl','Edytuj Timeclock innym razem',0),(303306,8426,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Timeclock Ð´Ñ€ÑƒÐ³Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(303307,8426,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ø¯ÙˆØ³Ø±Û’ ÙˆÙ‚Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(303308,8426,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð´Ñ€ÑƒÐ³Ð¸ Ð¿ÑƒÑ‚',0),(303309,8426,'vi','Cáº­p nháº­t thá»i gian khÃ¡c cá»§a mÃ¡y cháº¥m cÃ´ng',0),(303310,8426,'af','Tydklok Ander Tyd Opdateer',0),(303311,8426,'ro','Editare ceas timp alte',0),(303312,8426,'et','Redigeeri Timeclock muul ajal',0),(303313,8426,'si','Urejanje Timeclock drugi Äas',0),(303314,8426,'ba','Edit Timeclock lainnya waktu',0),(303315,8426,'nl','Klok andere tijd bewerken',0),(303316,8426,'fi','Muokkaa Timeclock toiste',0),(303317,8426,'no','Redigere Timeclock andre tid',0),(303318,8426,'da','Rediger Timeclock andre tid',0),(303319,8426,'ko','ë‹¤ë¥¸ ì‹œê°„ì— Timeclock íŽ¸ì§‘',0),(303320,8426,'he','×¢×¨×™×›×ª Timeclock. ×‘×¤×¢× ××—×¨×ª',0),(303321,8426,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Timeclock Î¬Î»Î»Î· Ï†Î¿ÏÎ¬',0),(303322,8426,'zh','æ—¶é’Ÿå…¶ä»–æ—¶é—´æ›´æ–°\r\n',0),(303323,8426,'sv','Redigera Timeclock andra tid',0),(303324,8426,'it','Modifica Timeclock altro tempo',0),(303325,8426,'tl','',0),(303326,8426,'th','&#3648;&#3623;&#3621;&#3634;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3',0),(303327,8426,'hi','Timeclock à¤…à¤¨à¥à¤¯ à¤¸à¤®à¤¯ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(303328,8426,'ms','Edit Timeclock masa',0),(303329,8426,'ar','ØªØ­Ø±ÙŠØ± ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(303330,8426,'fr','Ã‰diter Timeclock autres fois',0),(303331,8426,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ã®ä»–ã®æ™‚é–“ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(303332,8426,'pt','Editar Timeclock outra vez',0),(303333,8426,'ru','Ð§Ð°ÑÑ‹ Ð”Ñ€ÑƒÐ³Ð¾Ðµ Ð’Ñ€ÐµÐ¼Ñ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(303334,8426,'es','Reloj Checador Otro Tiempo Actualizar',0),(303335,8426,'de','Timeclock andermal bearbeiten',0),(303336,8426,'en','Edit Timeclock Other Time',0),(303337,8427,'is','',0),(303338,8427,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø²Ù…Ø§Ù† Ø¯ÙŠÚ¯Ø± Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(303339,8427,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø²Ù…Ø§Ù† Ø¯ÙŠÚ¯Ø± Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(303340,8427,'tr','Yeni Timeclock baÅŸka zaman',0),(303341,8427,'pl','Nowe Timeclock innym razem',0),(303342,8427,'bg','ÐÐ¾Ð²Ð¸ Timeclock Ð´Ñ€ÑƒÐ³Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(303343,8427,'ur','Ù†ÛŒØ§ Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ø¯ÙˆØ³Ø±Û’ ÙˆÙ‚Øª',0),(303344,8427,'sr','ÐÐ¾Ð²Ð¾ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð´Ñ€ÑƒÐ³Ð¸ Ð¿ÑƒÑ‚',0),(303345,8427,'vi','ThÃªm Thá»i gian mÃ¡y cháº¥m cÃ´ng khÃ¡c',0),(303346,8427,'af','Tydklok Ander Tyd Skep',0),(303347,8427,'ro','Noi ceas altÄƒ datÄƒ',0),(303348,8427,'et','Uus Timeclock muul ajal',0),(303349,8427,'si','Novo Timeclock drugi Äas',0),(303350,8427,'ba','Baru Timeclock waktu lain',0),(303351,8427,'nl','Nieuwe klok andere tijd',0),(303352,8427,'fi','Uusi Timeclock toiste',0),(303353,8427,'no','Nye Timeclock andre gang',0),(303354,8427,'da','Nye Timeclock andre tid',0),(303355,8427,'ko','ìƒˆë¡œìš´ Timeclock ë‹¤ë¥¸ ì‹œê°„',0),(303356,8427,'he','×—×“×© Timeclock ×‘×¤×¢× ××—×¨×ª',0),(303357,8427,'el','ÎÎ­Î± Timeclock Î¬Î»Î»Î· Ï†Î¿ÏÎ¬',0),(303358,8427,'zh','æ—¶é’Ÿå…¶ä»–æ—¶é—´æ–°å¢ž\r\n',0),(303359,8427,'sv','Nya Timeclock andra tid',0),(303360,8427,'it','Nuovo Timeclock altra volta',0),(303361,8427,'tl','',0),(303362,8427,'th','&#3648;&#3623;&#3621;&#3634;&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3629;&#3639;&#3',0),(303363,8427,'hi','à¤¨à¤ˆ Timeclock à¤…à¤¨à¥à¤¯ à¤¸à¤®à¤¯',0),(303364,8427,'ms','Baru Timeclock masa',0),(303365,8427,'ar','Ø¬Ø¯ÙŠØ¯ ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(303366,8427,'fr','Nouveau Timeclock autres temps',0),(303367,8427,'jp','æ–°ã—ã„ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ã®ä»–ã®æ™‚é–“',0),(303368,8427,'pt','Novo Timeclock outra vez',0),(303369,8427,'ru','Ð§Ð°ÑÑ‹ Ð”Ñ€ÑƒÐ³Ð¾Ðµ Ð’Ñ€ÐµÐ¼Ñ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(303370,8427,'es','Reloj Checador Otro Tiempo Agregar',0),(303371,8427,'de','Neu Timeclock andermal',0),(303372,8427,'en','New Timeclock Other Time',0),(303373,8428,'is','',0),(303374,8428,'dr','Ø³Ø± ÙƒØ§Ø± Ù†ÙŠØ³Øª ',0),(303375,8428,'pr','Ø³Ø± ÙƒØ§Ø± Ù†ÙŠØ³Øª ',0),(303376,8428,'tr','Ä°ÅŸ yerinde deÄŸil',0),(303377,8428,'pl','Nie w pracy',0),(303378,8428,'bg','ÐÐµ ÑÐ° Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(303379,8428,'ur','Ú©Ø§Ù… Ù¾Ø± Ù†ÛÛŒÚº',0),(303380,8428,'sr','ÐÐ¸ÑÐ¸ Ð½Ð° Ð¿Ð¾ÑÐ»Ñƒ',0),(303381,8428,'vi','KhÃ´ng lÃ m viá»‡c',0),(303382,8428,'af','Nie by die Werk',0),(303383,8428,'ro','Nu la locul de muncÄƒ',0),(303384,8428,'et','Ei ole tÃ¶Ã¶l',0),(303385,8428,'si','Ne pri delu',0),(303386,8428,'ba','Tidak di tempat kerja',0),(303387,8428,'nl','Niet op het werk',0),(303388,8428,'fi','Ei tyÃ¶ssÃ¤',0),(303389,8428,'no','PÃ¥ fritiden',0),(303390,8428,'da','Ikke er pÃ¥ arbejde',0),(303391,8428,'ko','ì§ìž¥ì—ì„œ ì•ˆ',0),(303392,8428,'he','×œ× ×‘×¢×‘×•×“×”',0),(303393,8428,'el','ÎŒÏ‡Î¹ ÏƒÏ„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(303394,8428,'zh','ä¼‘æ¯\r\n',0),(303395,8428,'sv','Inte pÃ¥ jobbet',0),(303396,8428,'it','Non al lavoro',0),(303397,8428,'tl','',0),(303398,8428,'th','&#3652;&#3617;&#3656;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(303399,8428,'hi','à¤•à¤¾à¤® à¤ªà¤° à¤¨à¤¹à¥€à¤‚',0),(303400,8428,'ms','Tidak di tempat kerja',0),(303401,8428,'ar','Ù„Ø§ ÙÙŠ Ø§Ù„Ø¹Ù…Ù„',0),(303402,8428,'fr','Pas au travail',0),(303403,8428,'jp','ä»•äº‹ã§ã¯ãªã„ã§ã™ã€‚',0),(303404,8428,'pt','NÃ£o no trabalho',0),(303405,8428,'ru','ÐÐµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ðµ',0),(303406,8428,'es','No a Trabajo',0),(303407,8428,'de','Nicht bei der Arbeit',0),(303408,8428,'en','Not at Work',0),(303409,8429,'is','',0),(303410,8429,'dr','Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙˆØ¶Ø¹ÙŠØª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(303411,8429,'pr','Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙˆØ¶Ø¹ÙŠØª ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(303412,8429,'tr','Ã‡alÄ±ÅŸanÄ±n durumu TimeClock gÃ¶rÃ¼ntÃ¼le',0),(303413,8429,'pl','Status pracownika TimeClock widok',0),(303414,8429,'bg','TimeClock Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(303415,8429,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù…Ù†Ø¸Ø± Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(303416,8429,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð¿Ñ€Ð¸ÐºÐ°Ð·',0),(303417,8429,'vi','Xem tÃ¬nh tráº¡ng mÃ¡y cháº¥m cÃ´ng nhÃ¢n viÃªn',0),(303418,8429,'af','Oorsig van Werknemer Status volgens Tydklok ',0),(303419,8429,'ro','Statutul de angajat ceas Vezi',0),(303420,8429,'et','TÃ¶Ã¶taja oleku TimeClock kuvamine',0),(303421,8429,'si','Status zaposlenega TimeClock pogled',0),(303422,8429,'ba','Status karyawan timeclock View',0),(303423,8429,'nl','De Status van de werknemer van de klok weergeven',0),(303424,8429,'fi','Timeclock NÃ¤ytÃ¤ tyÃ¶ntekijÃ¤n tila',0),(303425,8429,'no','TimeClock Vis ansattstatus',0),(303426,8429,'da','Timeclock Se medarbejderstatus',0),(303427,8429,'ko','ì§ì› ìƒíƒœ Timeclock ë³´ê¸°',0),(303428,8429,'he','Timeclock ×”×¦×’ ×ž×¦×‘ ×”×¢×•×‘×“',0),(303429,8429,'el','Î ÏÎ¿Î²Î¿Î»Î® Timeclock ÎºÎ±Î¸ÎµÏƒÏ„ÏŽÏ‚',0),(303430,8429,'zh','æ—¶é’ŸæŸ¥çœ‹é›‡å‘˜çŠ¶æ€\r\n',0),(303431,8429,'sv','Timeclock uppfattning anstÃ¤llningsstatus',0),(303432,8429,'it','Stato dipendente Timeclock vista',0),(303433,8429,'tl','',0),(303434,8429,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3604;&#3641;&#3626;&#3606;&#3634;&#3609;&#3632;&#3614;&#3609;&#3633;&#3585;&#3',0),(303435,8429,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ Timeclock à¤¦à¥‡à¤–à¥‡à¤‚',0),(303436,8429,'ms','Status pekerja Timeclock View',0),(303437,8429,'ar','Ø¹Ø±Ø¶ ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ Ø­Ø§Ù„Ø© Ø§Ù„Ù…ÙˆØ¸Ù',0),(303438,8429,'fr','Statut d\'employÃ© Timeclock vue',0),(303439,8429,'jp','å¾“æ¥­å“¡ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã®ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯è¡¨ç¤º',0),(303440,8429,'pt','Timeclock Exibir Status do funcionÃ¡rio',0),(303441,8429,'ru','TimeClock Ð¿Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÑÑ‚Ð°Ñ‚ÑƒÑ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(303442,8429,'es','Reloj Checador Visionar Status de Empleados',0),(303443,8429,'de','Mitarbeiter-Status Timeclock anzeigen',0),(303444,8429,'en','Timeclock View Employee Status',0),(303445,8430,'is','',0),(303446,8430,'dr',' Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø®Ù„Ø§ØµÙ‡ ',0),(303447,8430,'pr',' Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø®Ù„Ø§ØµÙ‡ ',0),(303448,8430,'tr','Back Ã–zeti',0),(303449,8430,'pl','WrÃ³Ä‡ do KrÃ³tki opis',0),(303450,8430,'bg','ÐÐ°Ð·Ð°Ð´ ÐºÑŠÐ¼ Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(303451,8430,'ur','Ø®Ù„Ø§ØµÛ Ú©Ø±Ù†Ø§',0),(303452,8430,'sr','ÐÐ°Ð·Ð°Ð´ Ð½Ð° Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(303453,8430,'vi','Quay láº¡i tá»•ng há»£p',0),(303454,8430,'af','Terug na Opsomming',0),(303455,8430,'ro','Inapoi la Sumar',0),(303456,8430,'et','Aastasse KokkuvÃµte',0),(303457,8430,'si','Nazaj na Povzetek',0),(303458,8430,'ba','Kembali ke ringkasan',0),(303459,8430,'nl','Terug naar samenvatting',0),(303460,8430,'fi','Palaa Yhteenveto',0),(303461,8430,'no','Tilbake til Sammendrag',0),(303462,8430,'da','Tilbage til oversigt',0),(303463,8430,'ko','ë‹¤ì‹œ ìš”ì•½ í•˜',0),(303464,8430,'he','×—×–×¨×” ××œ ×¡×™×›×•×',0),(303465,8430,'el','Î Î¯ÏƒÏ‰ ÏƒÎµ Î£ÏÎ½Î¿ÏˆÎ·',0),(303466,8430,'zh','å›žåˆ°æ‘˜è¦\r\n',0),(303467,8430,'sv','Tillbaka till Sammanfattning',0),(303468,8430,'it','Torna al sommario',0),(303469,8430,'tl','',0),(303470,8430,'th','&#3585;&#3621;&#3633;&#3610;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3626;&#3619;&#3640;&#3611;',0),(303471,8430,'hi','à¤µà¤¾à¤ªà¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(303472,8430,'ms','Kembali ke ringkasan',0),(303473,8430,'ar','Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ù„Ù…Ù„Ø®Ù‘Øµ',0),(303474,8430,'fr','Retour au Sommaire',0),(303475,8430,'jp','æ¦‚è¦ã«æˆ»ã‚‹',0),(303476,8430,'pt','Voltar ao SumÃ¡rio',0),(303477,8430,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(303478,8430,'es','AtrÃ¡s al Resumen',0),(303479,8430,'de','ZurÃ¼ck zur Ãœbersicht',0),(303480,8430,'en','Back to Summary',0),(303481,8431,'is','',0),(303482,8431,'dr','Ù†Ø±Ø® Ù¾Ø§ÙŠÙ‡',0),(303483,8431,'pr','Ù†Ø±Ø® Ù¾Ø§ÙŠÙ‡',0),(303484,8431,'tr','Taban oranÄ±',0),(303485,8431,'pl','Podstawowa stopa procentowa',0),(303486,8431,'bg','ÐžÑÐ½Ð¾Ð²ÐµÐ½ Ð»Ð¸Ñ…Ð²ÐµÐ½ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(303487,8431,'ur','Ø¨ÛŒØ³ Ú©ÛŒ Ø´Ø±Ø­',0),(303488,8431,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð¸ ÐºÑƒÑ€Ñ',0),(303489,8431,'vi','GiÃ¡ Gá»‘c',0),(303490,8431,'af','Basis Tarief',0),(303491,8431,'ro','Rata de bazÄƒ',0),(303492,8431,'et','Baasintressi',0),(303493,8431,'si','Osnovni teÄaj',0),(303494,8431,'ba','Tingkat dasar',0),(303495,8431,'nl','Basistarief',0),(303496,8431,'fi','Peruskorko',0),(303497,8431,'no','Base Rate',0),(303498,8431,'da','Base Rate',0),(303499,8431,'ko','ê¸°ë³¸ ìš”ê¸ˆ',0),(303500,8431,'he','×©×¢×¨ ×‘×¡×™×¡',0),(303501,8431,'el','Î’Î±ÏƒÎ¹ÎºÏŒ ÎµÏ€Î¹Ï„ÏŒÎºÎ¹Î¿',0),(303502,8431,'zh','åŸºæœ¬åˆ©çŽ‡\r\n',0),(303503,8431,'sv','BasrÃ¤ntan',0),(303504,8431,'it','Tasso base',0),(303505,8431,'tl','',0),(303506,8431,'th','&#3600;&#3634;&#3609;&#3629;&#3633;&#3605;&#3619;&#3634;',0),(303507,8431,'hi','à¤†à¤§à¤¾à¤° à¤¦à¤°',0),(303508,8431,'ms','Kadar asas',0),(303509,8431,'ar','Ø§Ù„Ù…Ø¹Ø¯Ù„ Ø§Ù„Ø£Ø³Ø§Ø³ÙŠ',0),(303510,8431,'fr','Tarif de base',0),(303511,8431,'jp','åŸºæœ¬æ–™é‡‘',0),(303512,8431,'pt','Taxa base',0),(303513,8431,'ru','Ð‘Ð°Ð·Ð¾Ð²Ð°Ñ ÑÑ‚Ð°Ð²ÐºÐ°',0),(303514,8431,'es','Base tasa de',0),(303515,8431,'de','Basiszinssatz',0),(303516,8431,'en','Base Rate',0),(303517,8432,'is','',0),(303518,8432,'dr','O.T.   Ø±ÙˆÙŠ ÙƒØ§Ù…ÙŠÙˆÙ†(Ù…Ø¹Ø§Ù…Ù„Ù‡  Ø®Ø±Ø¯Ù‡ Ø±ÙŠØ²  -Ø§Ø¶Ø§ÙÙ‡ ÙƒØ§Ø±ÙŠ',0),(303519,8432,'pr','O.T.   Ø±ÙˆÙŠ ÙƒØ§Ù…ÙŠÙˆÙ†(Ù…Ø¹Ø§Ù…Ù„Ù‡  Ø®Ø±Ø¯Ù‡ Ø±ÙŠØ²  -Ø§Ø¶Ø§ÙÙ‡ ÙƒØ§Ø±ÙŠ',0),(303520,8432,'tr','TUVALETE GÄ°RMEM',0),(303521,8432,'pl','O.T.',0),(303522,8432,'bg','Ð•Ð’Ð Ð•Ð™Ð¡ÐšÐ˜ OT',0),(303523,8432,'ur','O.T.',0),(303524,8432,'sr','Ð¡ÐÐ›Ð˜.',0),(303525,8432,'vi','Giá» ngoÃ i giá»',0),(303526,8432,'af','O.T.',0),(303527,8432,'ro','O.T.',0),(303528,8432,'et','O.T.',0),(303529,8432,'si','OT',0),(303530,8432,'ba','O.T.',0),(303531,8432,'nl','O.T.',0),(303532,8432,'fi','T.T.',0),(303533,8432,'no','OT',0),(303534,8432,'da','O.T.',0),(303535,8432,'ko','êµ¬ì•½',0),(303536,8432,'he','×©×¢×•×ª × ×•×¡×¤×•×ª',0),(303537,8432,'el','ÎŸ.Î¤.',0),(303538,8432,'zh','åŠ ç­\r\n',0),(303539,8432,'sv','OT',0),(303540,8432,'it','O.T.',0),(303541,8432,'tl','',0),(303542,8432,'th','&#3621;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;',0),(303543,8432,'hi','O.T.',0),(303544,8432,'ms','O.T.',0),(303545,8432,'ar','Ùˆ. Øª.',0),(303546,8432,'fr','O.T.',0),(303547,8432,'jp','ã‚¸ãƒ ãƒãƒ«ã‚½ãƒ³',0),(303548,8432,'pt','O.T.',0),(303549,8432,'ru','Ðž.Ð¢.',0),(303550,8432,'es','O.T.',0),(303551,8432,'de','O.T.',0),(303552,8432,'en','O.T.',0),(303553,8433,'is','',0),(303554,8433,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø§Ø¬Ø±Ø§',0),(303555,8433,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø§Ø¬Ø±Ø§',0),(303556,8433,'tr','Raporu Ã§alÄ±ÅŸtÄ±rma',0),(303557,8433,'pl','Uruchom raport',0),(303558,8433,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(303559,8433,'ur','Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ú†Ù„Ø§Ø¦ÙŠÚº',0),(303560,8433,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(303561,8433,'vi','Cháº¡y BÃ¡o cÃ¡o ',0),(303562,8433,'af','Loop Verslag',0),(303563,8433,'ro','ExecutaÅ£i raport',0),(303564,8433,'et','Aruande kÃ¤itamine',0),(303565,8433,'si','Zagon poroÄila',0),(303566,8433,'ba','Jalankan laporan',0),(303567,8433,'nl','Rapport uitvoeren',0),(303568,8433,'fi','Raportin suorittaminen',0),(303569,8433,'no','KjÃ¸re rapporten',0),(303570,8433,'da','KÃ¸re rapport',0),(303571,8433,'ko','ë³´ê³ ì„œ ì‹¤í–‰',0),(303572,8433,'he','×”×¤×¢×œ×ª ×“×•×—',0),(303573,8433,'el','Î•ÎºÏ„Î­Î»ÎµÏƒÎ· Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(303574,8433,'zh','è¿è¡ŒæŠ¥å‘Š\r\n',0),(303575,8433,'sv','KÃ¶r rapporten',0),(303576,8433,'it','Eseguire Report',0),(303577,8433,'tl','',0),(303578,8433,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3605;&#3656;&#3629;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;',0),(303579,8433,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤šà¤²à¤¾à¤à¤',0),(303580,8433,'ms','Jalankan Laporan',0),(303581,8433,'ar','ØªØ´ØºÙŠÙ„ ØªÙ‚Ø±ÙŠØ±',0),(303582,8433,'fr','ExÃ©cutez le rapport',0),(303583,8433,'jp','ãƒ¬ãƒãƒ¼ãƒˆã‚’å®Ÿè¡Œã—ã¾ã™ã€‚',0),(303584,8433,'pt','Executar relatÃ³rio',0),(303585,8433,'ru','Ð—Ð°Ð¿ÑƒÑÐº Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(303586,8433,'es','Informe de Corrida',0),(303587,8433,'de','Starten Sie den Report',0),(303588,8433,'en','Run Report',0),(303589,8434,'is','',0),(303590,8434,'dr','S.T. Ø¯Ø± Ø±Ø§Ø¨Ø·Ù‡ Ø¨Ø§.(Ø²Ù…Ø§Ù† Ù…Ø³ØªÙ‚ÙŠÙ… Ù¾Ø±Ø³Ù†Ù„',0),(303591,8434,'pr','S.T. Ø¯Ø± Ø±Ø§Ø¨Ø·Ù‡ Ø¨Ø§.(Ø²Ù…Ø§Ù† Ù…Ø³ØªÙ‚ÙŠÙ… Ù¾Ø±Ø³Ù†Ù„',0),(303592,8434,'tr','ALTYAZILI',0),(303593,8434,'pl','S.T.',0),(303594,8434,'bg','S.T.',0),(303595,8434,'ur','S.T.',0),(303596,8434,'sr','Ð ÐÐ”Ð˜Ðž',0),(303597,8434,'vi','S.T.',0),(303598,8434,'af','S.T.',0),(303599,8434,'ro','SERGHEI',0),(303600,8434,'et','S.T.',0),(303601,8434,'si','S.T.',0),(303602,8434,'ba','S.T.',0),(303603,8434,'nl','Z.T.',0),(303604,8434,'fi','ST',0),(303605,8434,'no','ST',0),(303606,8434,'da','ST',0),(303607,8434,'ko','ìŠ¤',0),(303608,8434,'he','×¢×œ×™×”',0),(303609,8434,'el','S.T.',0),(303610,8434,'zh','æ ‡å‡†\r\n',0),(303611,8434,'sv','ST',0),(303612,8434,'it','S.T.',0),(303613,8434,'tl','',0),(303614,8434,'th','S.T.',0),(303615,8434,'hi','à¤ªà¤‚à¤šà¤®à¤¹à¤¾à¤²',0),(303616,8434,'ms','S.T.',0),(303617,8434,'ar','Ø´Ø§Ø±Ø¹',0),(303618,8434,'fr','S.T.',0),(303619,8434,'jp','ãƒ†ãƒ¼',0),(303620,8434,'pt','S.T.',0),(303621,8434,'ru','Ð¡.Ð¢.',0),(303622,8434,'es','S.T.',0),(303623,8434,'de','S.T.',0),(303624,8434,'en','S.T.',0),(303625,8435,'is','',0),(303626,8435,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(303627,8435,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(303628,8435,'tr','TimeClock raporu',0),(303629,8435,'pl','Raport TimeClock',0),(303630,8435,'bg','TimeClock Ð´Ð¾ÐºÐ»Ð°Ð´',0),(303631,8435,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(303632,8435,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(303633,8435,'vi','BÃ¡o cÃ¡o thá»i gian lÃ m viá»‡c',0),(303634,8435,'af','Tydklok Verslae',0),(303635,8435,'ro','Ceas raport',0),(303636,8435,'et','TimeClock aruanne',0),(303637,8435,'si','TimeClock poroÄilo',0),(303638,8435,'ba','Timeclock laporan',0),(303639,8435,'nl','Klok verslag',0),(303640,8435,'fi','Timeclock raportti',0),(303641,8435,'no','TimeClock rapport',0),(303642,8435,'da','Timeclock betÃ¦nkning',0),(303643,8435,'ko','Timeclock ë³´ê³ ì„œ',0),(303644,8435,'he','Timeclock ×—',0),(303645,8435,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Timeclock',0),(303646,8435,'zh','æ—¶é’ŸæŠ¥å‘Š\r\n',0),(303647,8435,'sv','Timeclock rapport',0),(303648,8435,'it','Relazione Timeclock',0),(303649,8435,'tl','',0),(303650,8435,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(303651,8435,'hi','Timeclock à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(303652,8435,'ms','Laporan Timeclock',0),(303653,8435,'ar','ØªÙ‚Ø±ÙŠØ± ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(303654,8435,'fr','Timeclock rapport',0),(303655,8435,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ãƒ¬ãƒãƒ¼ãƒˆ',0),(303656,8435,'pt','RelatÃ³rio de timeclock',0),(303657,8435,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ ÐŸÐ¾ Ð§Ð°ÑÐ°Ð¼',0),(303658,8435,'es','Informe de Reloj Checador',0),(303659,8435,'de','Timeclock Bericht',0),(303660,8435,'en','Timeclock Report',0),(303661,8436,'is','',0),(303662,8436,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ Ø²Ù…Ø§Ù† ',0),(303663,8436,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ Ø²Ù…Ø§Ù† ',0),(303664,8436,'tr','Zaman Ã¶zet raporu',0),(303665,8436,'pl','Czas skrÃ³cone sprawozdanie',0),(303666,8436,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(303667,8436,'ur','ÙˆÙ‚Øª Ú©ÛŒ Ø®Ù„Ø§ØµÛ Ø±Ù¾ÙˆØ±Ù¹',0),(303668,8436,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÑÐ° Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ¾Ð¼ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(303669,8436,'vi','BÃ¡o cÃ¡o tá»•ng há»£p thá»i gian ',0),(303670,8436,'af','Tyd Opsommingsverslag',0),(303671,8436,'ro','Raport de sintezÄƒ timp',0),(303672,8436,'et','KokkuvÃµttev aruanne',0),(303673,8436,'si','ÄŒas zbirno poroÄilo',0),(303674,8436,'ba','Waktu laporan ringkasan',0),(303675,8436,'nl','Samenvatting rapport over de responstijden',0),(303676,8436,'fi','Aika yhteenvetoraportti',0),(303677,8436,'no','Tid sammendragsrapport',0),(303678,8436,'da','Tid sammenfattende rapport',0),(303679,8436,'ko','ìš”ì•½ ë³´ê³ ì„œ',0),(303680,8436,'he','×“×•×— ×¡×™×›×•× ×–×ž×Ÿ',0),(303681,8436,'el','Î£Ï…Î½Î¿Ï€Ï„Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ· Ï‡ÏÏŒÎ½Î¿Ï…',0),(303682,8436,'zh','æ—¶é—´æ‘˜è¦æŠ¥å‘Š\r\n',0),(303683,8436,'sv','Tid sammanfattande rapport',0),(303684,8436,'it','Relazione di sintesi di tempo',0),(303685,8436,'tl','',0),(303686,8436,'th','&#3648;&#3623;&#3621;&#3634;&#3626;&#3619;&#3640;&#3611;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(303687,8436,'hi','à¤¸à¤®à¤¯ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(303688,8436,'ms','Masa ringkasan laporan',0),(303689,8436,'ar','ØªÙ‚Ø±ÙŠØ± Ù…Ù„Ø®Øµ Ø§Ù„ÙˆÙ‚Øª',0),(303690,8436,'fr','Rapport sommaire de temps',0),(303691,8436,'jp','æ™‚é–“ã‚µãƒžãƒªãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆ',0),(303692,8436,'pt','RelatÃ³rio de Resumo de tempo',0),(303693,8436,'ru','Ð’Ñ€ÐµÐ¼Ñ ÑÐ²Ð¾Ð´Ð½Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(303694,8436,'es','Informe de ResÃºmen de Tiempo',0),(303695,8436,'de','Zeit-Kurzbericht',0),(303696,8436,'en','Time Summary Report',0),(303697,8437,'is','',0),(303698,8437,'dr','Ø³Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ ',0),(303699,8437,'pr','Ø³Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ ',0),(303700,8437,'tr','Ãœcretsiz saat',0),(303701,8437,'pl','NiezapÅ‚acone godziny',0),(303702,8437,'bg','ÐÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ñ‡Ð°ÑÐ¾Ð²Ðµ',0),(303703,8437,'ur','Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û Ú¯Ú¾Ù†Ù¹Û’',0),(303704,8437,'sr','ÐÐµÐ¿Ð»Ð°Ñ›ÐµÐ½Ð¸Ñ… ÑÐ°Ñ‚Ð¸',0),(303705,8437,'vi','Giá» chÆ°a tráº£',0),(303706,8437,'af','Onbetaalde Ure',0),(303707,8437,'ro','Ore de neremuneratÄƒ',0),(303708,8437,'et','Tasumata tundi',0),(303709,8437,'si','NeplaÄanih ur',0),(303710,8437,'ba','Jam belum dibayar',0),(303711,8437,'nl','Niet-betaalde uren',0),(303712,8437,'fi','Maksamattomat tuntia',0),(303713,8437,'no','Ubetalte timer',0),(303714,8437,'da','Ubetalte timer',0),(303715,8437,'ko','ë¬´ ë³´ìˆ˜ ì‹œê°„',0),(303716,8437,'he','×©×¢×•×ª ×©×œ× ×©×•×œ×ž×•',0),(303717,8437,'el','Î§ÏÏŒÎ½Î¿Ï… ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î¬Î½ÎµÏ… Î±Ï€Î¿Î´Î¿Ï‡ÏŽÎ½',0),(303718,8437,'zh','æœªä»˜æ—¶æ•°\r\n',0),(303719,8437,'sv','Obetalda timmar',0),(303720,8437,'it','Ore non retribuiti',0),(303721,8437,'tl','',0),(303722,8437,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(303723,8437,'hi','à¤…à¤µà¥ˆà¤¤à¤¨à¤¿à¤• à¤˜à¤‚à¤Ÿà¥‡',0),(303724,8437,'ms','Jam belum dibayar',0),(303725,8437,'ar','Ø³Ø§Ø¹Ø§Øª ØºÙŠØ± Ø§Ù„Ù…Ø³Ø¯Ø¯Ø©',0),(303726,8437,'fr','Heures non rÃ©munÃ©rÃ©es',0),(303727,8437,'jp','æœªæ‰•ã„æ™‚é–“',0),(303728,8437,'pt','Horas nÃ£o remuneradas',0),(303729,8437,'ru','ÐÐµÐ¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ñ‡Ð°ÑÑ‹',0),(303730,8437,'es','Horas No Pagadas',0),(303731,8437,'de','Unbezahlte Stunden',0),(303732,8437,'en','Unpaid Hours',0),(303733,8438,'is','',0),(303734,8438,'dr','Ø²Ù…Ø§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡',0),(303735,8438,'pr','Ø²Ù…Ø§Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡',0),(303736,8438,'tr','Ãœcretsiz saat',0),(303737,8438,'pl','OpÅ‚aconego czasu',0),(303738,8438,'bg','ÐÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð²Ñ€ÐµÐ¼Ðµ',0),(303739,8438,'ur','Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û ÙˆÙ‚Øª',0),(303740,8438,'sr','ÐÐµÐ¿Ð»Ð°Ñ›ÐµÐ½Ð¸Ñ… Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(303741,8438,'vi','Thá»i gian chÆ°a tráº£',0),(303742,8438,'af','Onbetaalde Tyd',0),(303743,8438,'ro','Timp neplÄƒtite',0),(303744,8438,'et','Tasumata aeg',0),(303745,8438,'si','NeplaÄane Äas',0),(303746,8438,'ba','Waktu tidak dibayar',0),(303747,8438,'nl','Onbetaalde tijd',0),(303748,8438,'fi','Palkaton aika',0),(303749,8438,'no','Ubetalt tid',0),(303750,8438,'da','UlÃ¸nnet tid',0),(303751,8438,'ko','ë¬´ ë³´ìˆ˜ ì‹œê°„',0),(303752,8438,'he','×–×ž×Ÿ ×©×œ× ×©×•×œ×ž×•',0),(303753,8438,'el','Î§ÏÏŒÎ½Î¿ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎºÎ±Ï„Î±Î²Î¿Î»Î®',0),(303754,8438,'zh','æ— è–ªå‡æœŸ\r\n',0),(303755,8438,'sv','Obetald tid',0),(303756,8438,'it','Tempo non retribuito',0),(303757,8438,'tl','',0),(303758,8438,'th','&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(303759,8438,'hi','à¤…à¤µà¥ˆà¤¤à¤¨à¤¿à¤• à¤¸à¤®à¤¯',0),(303760,8438,'ms','Waktu yang tidak dibayar',0),(303761,8438,'ar','Ø§Ù„ÙˆÙ‚Øª ØºÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(303762,8438,'fr','Temps non rÃ©munÃ©rÃ©',0),(303763,8438,'jp','æœªæ‰•ã„æ™‚é–“',0),(303764,8438,'pt','Tempo nÃ£o remunerado',0),(303765,8438,'ru','ÐÐµÐ¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÐ¼Ð¾Ð³Ð¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(303766,8438,'es','Tiempo No Pagado',0),(303767,8438,'de','Unbezahlte Zeit',0),(303768,8438,'en','Unpaid Time',0),(303769,8439,'is','',0),(303770,8439,'dr','ØªØ§ÙŠÙŠØ¯ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù†    Ø²Ù…Ø§Ù†  ÙˆØ­Ù‚ÙˆÙ‚',0),(303771,8439,'pr','ØªØ§ÙŠÙŠØ¯ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù†    Ø²Ù…Ø§Ù†  ÙˆØ­Ù‚ÙˆÙ‚',0),(303772,8439,'tr','TimeClock kez & Ã¶deme onayÄ±',0),(303773,8439,'pl','Zatwierdzenie Timeclock razy & pÅ‚aciÄ‡',0),(303774,8439,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÐ²Ð° Timeclock Ð¿ÑŠÑ‚Ð¸ & Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾',0),(303775,8439,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ø§ÙˆÙ‚Ø§Øª & Ø§Ø¯Ø§ Ù…Ù†Ø¸ÙˆØ±',0),(303776,8439,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð¸ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð¿ÑƒÑ‚Ð° & Ð¾Ð±Ñ€Ð°Ñ‚Ð¸',0),(303777,8439,'vi','Cháº¥p Thuáº­n Sá»‘ Giá» LÃ m Viá»‡c & Thanh ToÃ¡n',0),(303778,8439,'af','Goedkeuring van Tydklok Tye & Loon',0),(303779,8439,'ro','Aproba ceas ori & plata',0),(303780,8439,'et','Kinnitada Timeclock korda & pÃ¶Ã¶rama',0),(303781,8439,'si','Odobri Timeclock krat & plaÄati',0),(303782,8439,'ba','Menyetujui Timeclock kali & membayar',0),(303783,8439,'nl','Goedkeuren van klok tijden & betalen',0),(303784,8439,'fi','HyvÃ¤ksy Timeclock Times & maksaa',0),(303785,8439,'no','Godkjenne Timeclock ganger & betale',0),(303786,8439,'da','Godkende Timeclock gange & betale',0),(303787,8439,'ko','ì‹œê°„ & ì§€ë¶ˆ Timeclock ìŠ¹ì¸',0),(303788,8439,'he','×œ××©×¨ Timeclock ×¤×¢×ž×™× & ×œ×©×œ×',0),(303789,8439,'el','Î•Î³ÎºÏÎ¯Î½ÎµÎ¹ Timeclock Ï†Î¿ÏÎ­Ï‚ & Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½',0),(303790,8439,'zh','å®¡æ‰¹æ‰“å¡æœºæ—¶é—´ä¸Žæ”¶è´¹\r\n',0),(303791,8439,'sv','GodkÃ¤nna Timeclock gÃ¥nger & betala',0),(303792,8439,'it','Approvare Timeclock volte & pagare',0),(303793,8439,'tl','',0),(303794,8439,'th','&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3648;&#3623;&#3621;&#3634;&#3605;&#3619;&#3629;&#3585;&#3610;&#3633;&#3605;&#3619;&#3648;&#3586;&#3657;&#3634;&#3591;&#3634;&#3609;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(303795,8439,'hi','Timeclock à¤Ÿà¤¾à¤‡à¤®à¥à¤¸ & à¤µà¥‡à¤¤à¤¨ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨',0),(303796,8439,'ms','Meluluskan Timeclock masa & bayar',0),(303797,8439,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ Ù…Ø±Ø§Øª Ø¢Ù†Ø¯ Ø§Ù„Ø¯ÙØ¹',0),(303798,8439,'fr','Approuver Timeclock fois & payer',0),(303799,8439,'jp','å›ž & æ”¯æ‰•ã†ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ã‚’æ‰¿èªã—ã¾ã™ã€‚',0),(303800,8439,'pt','Aprovar Timeclock vezes & pagar',0),(303801,8439,'ru','ÐžÐ´Ð¾Ð±Ñ€Ð¸Ñ‚ÑŒ Ð§Ð°ÑÑ‹ Ð’Ñ€ÐµÐ¼Ñ & ÐžÐ¿Ð»Ð°Ñ‚Ñƒ',0),(303802,8439,'es','Aprobar Reloj de Registro Tiempos y Pagos',0),(303803,8439,'de','Genehmigen Sie Timeclock, mal & zahlen',0),(303804,8439,'en','Approve Timeclock Times & Pay',0),(303805,8440,'is','',0),(303806,8440,'dr','ØªØ§ÙŠÙŠØ¯ Ø²Ù…Ø§Ù† Ù‡Ø§',0),(303807,8440,'pr','ØªØ§ÙŠÙŠØ¯ Ø²Ù…Ø§Ù† Ù‡Ø§',0),(303808,8440,'tr','Kez Onayla/DÃ¼zenle',0),(303809,8440,'pl','Zatwierdzenie/edycja razy',0),(303810,8440,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÐ²Ð°/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¿ÑŠÑ‚Ð¸',0),(303811,8440,'ur','Ù…Ù†Ø¸ÙˆØ±/Ø¨Ø§Ø± ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(303812,8440,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð¸ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿ÑƒÑ‚Ð°',0),(303813,8440,'vi','Cháº¥p Thuáº­n Thá»i Gian',0),(303814,8440,'af','Goedgekeurde Tye',0),(303815,8440,'ro','Aproba/editare ori',0),(303816,8440,'et','Kinnitamine/Muuda korda',0),(303817,8440,'si','Odobri/Uredi krat',0),(303818,8440,'ba','Menyetujui/Edit kali',0),(303819,8440,'nl','Goedkeuren/bewerken tijden',0),(303820,8440,'fi','HyvÃ¤ksyÃ¤ tai Muokkaa kertaa',0),(303821,8440,'no','Godkjenne/redigere ganger',0),(303822,8440,'da','Godkende/Rediger gange',0),(303823,8440,'ko','ìŠ¹ì¸ íŽ¸ì§‘ ì‹œê°„',0),(303824,8440,'he','×œ××©×¨/×¢×¨×™×›×” ×¤×¢×ž×™×',0),(303825,8440,'el','Î•Î³ÎºÏÎ¯Î½ÎµÎ¹/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï†Î¿ÏÎ­Ï‚',0),(303826,8440,'zh','æ‰¹å‡†æ—¶é—´\r\n',0),(303827,8440,'sv','GodkÃ¤nna/redigera gÃ¥nger',0),(303828,8440,'it','Approva o modifica volte',0),(303829,8440,'tl','',0),(303830,8440,'th','&#3588;&#3619;&#3633;&#3657;&#3591;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;',0),(303831,8440,'hi','à¤¬à¤¾à¤° à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(303832,8440,'ms','Meluluskan/Edit Times',0),(303833,8440,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ ØªØ­Ø±ÙŠØ± Ù…Ø±Ø§Øª',0),(303834,8440,'fr','Approuver/Edit fois',0),(303835,8440,'jp','å›žã®æ‰¿èª/ç·¨é›†',0),(303836,8440,'pt','Aprovar/editar vezes',0),(303837,8440,'ru','ÐžÐ´Ð¾Ð±Ñ€Ð¸Ñ‚ÑŒ Ð’Ñ€ÐµÐ¼Ñ',0),(303838,8440,'es','Aprobar Tiempos',0),(303839,8440,'de','Mal genehmigen/bearbeiten',0),(303840,8440,'en','Approve/Edit Times',0),(303841,8441,'is','',0),(303842,8441,'dr','ÙˆØ¶Ø¹ÙŠØª ÙØ¹Ù„ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(303843,8441,'pr','ÙˆØ¶Ø¹ÙŠØª ÙØ¹Ù„ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(303844,8441,'tr','Ã‡alÄ±ÅŸanlarÄ±n geÃ§erli durumu',0),(303845,8441,'pl','Obecny Status pracownikÃ³w',0),(303846,8441,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¾Ñ‚Ð¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ†Ð¸Ñ‚Ðµ Ð¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ',0),(303847,8441,'ur','Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©ÛŒ Ù…ÙˆØ¬ÙˆØ¯Û Ø­Ø§Ù„Øª',0),(303848,8441,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(303849,8441,'vi','TÃ¬nh tráº¡ng hiá»‡n thá»i cá»§a nhÃ¢n viÃªn',0),(303850,8441,'af','Huidige Status van Werknemers',0),(303851,8441,'ro','Stare curenta a angajatilor',0),(303852,8441,'et','TÃ¶Ã¶taja hetkeseis',0),(303853,8441,'si','Trenutno stanje zaposlenih',0),(303854,8441,'ba','Status saat ini karyawan',0),(303855,8441,'nl','Huidige Status van de werknemers',0),(303856,8441,'fi','Nykytila tyÃ¶ntekijÃ¤t',0),(303857,8441,'no','Gjeldende Status for ansatte',0),(303858,8441,'da','Aktuelle Status for medarbejdere',0),(303859,8441,'ko','ì§ì›ì˜ í˜„ìž¬ ìƒíƒœ',0),(303860,8441,'he','×ž×¦×‘ ×”×¢×•×‘×“×™× ×”× ×•×›×—×™',0),(303861,8441,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(303862,8441,'zh','é›‡å‘˜çŽ°çŠ¶\r\n',0),(303863,8441,'sv','Aktuell Status fÃ¶r anstÃ¤llda',0),(303864,8441,'it','Stato attuale dei dipendenti',0),(303865,8441,'tl','',0),(303866,8441,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(303867,8441,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(303868,8441,'ms','Status semasa pekerja',0),(303869,8441,'ar','Ø§Ù„ÙˆØ¶Ø¹ Ø§Ù„Ø­Ø§Ù„ÙŠ Ù„Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(303870,8441,'fr','Ã‰tat d\'avancement des employÃ©s',0),(303871,8441,'jp','å¾“æ¥­å“¡ã®ç¾åœ¨ã®ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(303872,8441,'pt','Status atual de funcionÃ¡rios',0),(303873,8441,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(303874,8441,'es','Status Actual de Empleados',0),(303875,8441,'de','Aktuellen Status der Mitarbeiter',0),(303876,8441,'en','Current Status of Employees',0),(303877,8442,'is','',0),(303878,8442,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø¹ÙˆØ§Ù…Ù„ ØªÙ†Ø¸ÙŠÙ… Ù…Ø¬Ù…ÙˆØ¹ÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ ',0),(303879,8442,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¹ÙˆØ§Ù…Ù„ ØªÙ†Ø¸ÙŠÙ… ÙƒÙ„ÙŠ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ ',0),(303880,8442,'tr','Girin/gÃ¼ncelleÅŸtirme Timeclock iÃ§in genel kurulum Etkenler',0),(303881,8442,'pl','WprowadÅº/aktualizacji General Setup czynniki za darmo',0),(303882,8442,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð» Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ñ„Ð°ÐºÑ‚Ð¾Ñ€Ð¸ Ð·Ð° Timeclock',0),(303883,8442,'ur','Ø¬Ù†Ø±Ù„ Ø³ÛŒÙ¹ Ø§Ù¾ Ø¹ÙˆØ§Ù…Ù„ Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ú©Û’ Ù„Ø¦Û’ Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(303884,8442,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐžÐ¿ÑˆÑ‚Ðµ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚Ð¾Ñ€Ð° Ð·Ð° Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº',0),(303885,8442,'vi','Nháº­p/Cáº­p Nháº­t Yáº¿u Tá»‘ Setup Chung Cho MÃ¡y Cháº¥m CÃ´ng',0),(303886,8442,'af','Invoer/opdateer Algemene Opstellingsfaktore vir Tydklok',0),(303887,8442,'ro','IntroduceÅ£i/Update General Setup factori pentru ceas',0),(303888,8442,'et','Ãœldine seadistus tegurid Timeclock sisestamine/ajakohastamine',0),(303889,8442,'si','Vnos/posodobitev sploÅ¡no namestitveni dejavniki za Timeclock',0),(303890,8442,'ba','Masukkan/Update umum Setup faktor untuk Timeclock',0),(303891,8442,'nl','Invoeren/bijwerken General Setup factoren voor klok',0),(303892,8442,'fi','PÃ¤ivittÃ¤minen General Setup riskitekijÃ¶itÃ¤ Timeclock',0),(303893,8442,'no','Angi/Oppdater generelt oppsett faktorer for Timeclock',0),(303894,8442,'da','Indtaste/opdatere General Setup faktorer for Timeclock',0),(303895,8442,'ko','ì¼ë°˜ ì„¤ì¹˜ ìš”ì¸ Timeclock ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(303896,8442,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×›×œ×œ×™ ×”×ª×§× ×” ×’×•×¨×ž×™× Timeclock',0),(303897,8442,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³ÎµÎ½Î¹ÎºÎ® ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï€Î±ÏÎ¬Î³Î¿Î½Ï„ÎµÏ‚ Î³Î¹Î± Timeclock',0),(303898,8442,'zh','è¾“å…¥/æ›´æ–°æ—¶é’Ÿå¸¸è§„è®¾ç½®çš„å› ç´ ',0),(303899,8442,'sv','Ange/uppdatera General Setup faktorer fÃ¶r Timeclock',0),(303900,8442,'it','Inserisci/Aggiorna General Setup fattori per Timeclock',0),(303901,8442,'tl','',0),(303902,8442,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3611;&#3633;&#3592;&#3592;&#3633;&#3618;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3586;&#3629;&',0),(303903,8442,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¤¾à¤°à¤• Timeclock à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(303904,8442,'ms','Masukkan/Kemaskini faktor persediaan umum untuk Timeclock',0),(303905,8442,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø¹ÙˆØ§Ù…Ù„ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø¹Ø§Ù… ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(303906,8442,'fr','Entrez/mise Ã  jour des facteurs dâ€™installation gÃ©nÃ©rale pour Timeclock',0),(303907,8442,'jp','å‡ºç¤¾ã®ãŸã‚ã®ä¸€èˆ¬çš„ãªã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è¦å› ã®å…¥åŠ›/æ›´æ–°',0),(303908,8442,'pt','Inserir/atualizar fatores de configuraÃ§Ã£o geral para Timeclock',0),(303909,8442,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð±Ñ‰ÐµÐ³Ð¾ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ñ„Ð°ÐºÑ‚Ð¾Ñ€Ñ‹ Timeclock',0),(303910,8442,'es','Introducir/Actualizar Factores de ConfiguraciÃ³n General para Reloj de Trabajo',0),(303911,8442,'de','Geben Sie/Update General Setup Faktoren fÃ¼r Timeclock',0),(303912,8442,'en','Enter/Update General Setup Factors for Timeclock',0),(303913,8443,'is','',0),(303914,8443,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù†Ø±Ø®Ù‡Ø§ Ùˆ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(303915,8443,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø±Ø®Ù‡Ø§ Ùˆ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(303916,8443,'tr','Timeclock parÃ§a baÅŸÄ± iÅŸ oranlarÄ± ve bilgi girin/gÃ¼ncelleme',0),(303917,8443,'pl','WprowadÅº/Aktualizuj stawki akordowej Timeclock i informacje',0),(303918,8443,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Timeclock Ð¿Ð°Ñ€Ñ‡Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¸ Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(303919,8443,'ur','Ø¯Ø§Ø®Ù„/Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ú©ÛŒ Ø´Ø±Ø­ Ø§ÙˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(303920,8443,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº ÑÑ‚Ð¾Ð¿Ðµ Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(303921,8443,'vi','Nháº­p/Cáº­p Nháº­t Tiá»n LÆ°Æ¡ng KhoÃ¡n & ThÃ´ng Tin Cháº¥m CÃ´ng',0),(303922,8443,'af','Invoer/Opdateer van Tydklok Stukwerktariewe en -Inligting',0),(303923,8443,'ro','IntroduceÅ£i/actualizare ratele de acord ceas ÅŸi informaÅ£ii',0),(303924,8443,'et','Sisestamine/ajakohastamine Timeclock TÃ¼kitÃ¶Ã¶palgad ja teave',0),(303925,8443,'si','Vnos/posodobitev Timeclock akord stopnje in informacije',0),(303926,8443,'ba','Masukkan/Update Timeclock Piecework harga dan informasi',0),(303927,8443,'nl','Invoeren/bijwerken klok stukloon tarieven en informatie',0),(303928,8443,'fi','PÃ¤ivittÃ¤minen Timeclock urakka hinnat ja tiedot',0),(303929,8443,'no','Angi/Oppdater Timeclock stykkavlÃ¸nning priser og informasjon',0),(303930,8443,'da','Indtaste/opdatere Timeclock akkordarbejde priser og oplysninger',0),(303931,8443,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ Timeclock Piecework ì†ë„ ì •ë³´',0),(303932,8443,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×”×ž×—×™×¨×™× ×‘×§×‘×œ× ×•×ª Timeclock ×•×ž×™×“×¢',0),(303933,8443,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Timeclock Î­Ï‡Î¿Ï…ÏƒÎ±Ï‚ Ï„Î¹Î¼Î­Ï‚ ÎºÎ±Î¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(303934,8443,'zh','è¾“å…¥/æ›´æ–°æ—¶é’Ÿè®¡ä»¶çŽ‡å’Œä¿¡æ¯',0),(303935,8443,'sv','Ange/uppdatera Timeclock ackord priser och Information',0),(303936,8443,'it','Inserisci/Aggiorna a cottimo Timeclock tariffe e informazioni',0),(303937,8443,'tl','',0),(303938,8443,'th','Enter/Update Timeclock Piecework Rates and Information',0),(303939,8443,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/Timeclock Piecework à¤¦à¤°à¥‹à¤‚ à¤”à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(303940,8443,'ms','Masukkan/Kemaskini Timeclock Piecework kadar dan maklumat',0),(303941,8443,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ù‚Ø·Ø¹Ø© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ ÙˆØ§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(303942,8443,'fr','Entrez/mise Ã  jour Ã  la piÃ¨ce Timeclock tarifs et informations',0),(303943,8443,'jp','å‡ºç¤¾å‡ºæ¥é«˜æ‰•ã„çŽ‡ãŠã‚ˆã³æƒ…å ±ã®å…¥åŠ›/æ›´æ–°',0),(303944,8443,'pt','Inserir/atualizar trabalho por tarefa Timeclock preÃ§os e informaÃ§Ãµes',0),(303945,8443,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Timeclock ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(303946,8443,'es','Introducir/Actualizar RelÃ³j Checador de Tasas de Trabajo por Pieza y InformaciÃ³n',0),(303947,8443,'de','Geben Sie/Update Timeclock Akkord-Preise und Informationen',0),(303948,8443,'en','Enter/Update Timeclock Piecework Rates and Information',0),(303949,8444,'is','',0),(303950,8444,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø²Ù…Ø§Ù†ÙŠ Ø¯ÙŠÚ¯Ø± Ø¬Ù‡Øª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ',0),(303951,8444,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø²Ù…Ø§Ù†ÙŠ Ø¯ÙŠÚ¯Ø± Ø¬Ù‡Øª Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ',0),(303952,8444,'tr','BaÅŸka zaman kategorileri izlemek iÃ§in',0),(303953,8444,'pl','Inne kategorie czasu do utworu',0),(303954,8444,'bg','Ð”Ñ€ÑƒÐ³Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸, Ð²Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð¿ÐµÑÐµÐ½',0),(303955,8444,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ú©Û’ Ù„ÛŒÛ’ Ø¯ÙˆØ³Ø±Û’ ÙˆÙ‚Øª Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(303956,8444,'sr','ÐžÑÑ‚Ð°Ð»Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð½Ð° ÑÑ‚Ð°Ð·Ð¸',0),(303957,8444,'vi','Thá»ƒ loáº¡i Thá»i gian khÃ¡c Ä‘á»ƒ tÃ¬m',0),(303958,8444,'af','Ander TydkategoriÃ« om te Spoor',0),(303959,8444,'ro','Alte categorii de timp pentru a urmÄƒri',0),(303960,8444,'et','Muu aeg kategooriad rajale',0),(303961,8444,'si','Druge kategorije Äas tir',0),(303962,8444,'ba','Kategori waktu lain untuk melacak',0),(303963,8444,'nl','Andere categorieÃ«n tijd naar Track',0),(303964,8444,'fi','Muut luokat seurata',0),(303965,8444,'no','Andre kategorier til spor',0),(303966,8444,'da','Andre kategorier til spor',0),(303967,8444,'ko','íŠ¸ëž™ì„ ë‹¤ë¥¸ ì‹œê°„ ë²”ì£¼',0),(303968,8444,'he','×œ×§×˜×’×•×¨×™×•×ª ××—×¨×•×ª ×–×ž×Ÿ ×œ××ª×¨',0),(303969,8444,'el','Î†Î»Î»ÎµÏ‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Ï‡ÏÏŒÎ½Î¿Ï… Î³Î¹Î± ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(303970,8444,'zh','å…¶ä»–è·Ÿè¸ªæ—¶é—´ç±»åˆ«\r\n',0),(303971,8444,'sv','Andra gÃ¥ngen kategorier till spÃ¥r',0),(303972,8444,'it','Altre categorie di tempo alla traccia',0),(303973,8444,'tl','',0),(303974,8444,'th','&#3621;&#3635;&#3604;&#3633;&#3610;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3629;&#3639;&#3656;&#3609;&#3648;&#3614;&#3639;&#3656;&#3629;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;',0),(303975,8444,'hi','à¤Ÿà¥à¤°à¥ˆà¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤¯ à¤¸à¤®à¤¯ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(303976,8444,'ms','Lain-lain kategori masa ke trek',0),(303977,8444,'ar','ÙØ¦Ø§Øª Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø³Ø§Ø±',0),(303978,8444,'fr','Autres catÃ©gories de temps de piste',0),(303979,8444,'jp','ä»–ã®ãƒˆãƒ©ãƒƒã‚¯ã«æ™‚é–“ã®ã‚«ãƒ†ã‚´ãƒª',0),(303980,8444,'pt','Outras categorias de tempo para a faixa',0),(303981,8444,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ð²Ñ€ÐµÐ¼Ñ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ñ‚Ñ€ÐµÐº',0),(303982,8444,'es','Otras CategorÃ­as de Tiempo para Rastrear',0),(303983,8444,'de','Andere Kategorien Zeit Songtext',0),(303984,8444,'en','Other Time Categories to Track',0),(303985,8445,'is','',0),(303986,8445,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø§Ø¹Øª ÙƒØ§Ø±ÙŠ ',0),(303987,8445,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø§Ø¹Øª ÙƒØ§Ø±ÙŠ ',0),(303988,8445,'tr','Kurulum Timeclock',0),(303989,8445,'pl','Ustawienie Timeclock',0),(303990,8445,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Timeclock',0),(303991,8445,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú©',0),(303992,8445,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº',0),(303993,8445,'vi','Setup giá» cháº¥m cÃ´ng',0),(303994,8445,'af','Opstelling van Tydklok',0),(303995,8445,'ro','Setare ceas',0),(303996,8445,'et','Setup Timeclock',0),(303997,8445,'si','Setup Timeclock',0),(303998,8445,'ba','Pengaturan Timeclock',0),(303999,8445,'nl','Klok instellen',0),(304000,8445,'fi','Setup Timeclock',0),(304001,8445,'no','Installasjonsprogrammet Timeclock',0),(304002,8445,'da','OpsÃ¦tning af Timeclock',0),(304003,8445,'ko','ì„¤ì¹˜ Timeclock',0),(304004,8445,'he','×”×’×“×¨×ª Timeclock',0),(304005,8445,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Timeclock',0),(304006,8445,'zh','è®¾ç½®æ—¶é’Ÿ\r\n',0),(304007,8445,'sv','Setup Timeclock',0),(304008,8445,'it','Installazione Timeclock',0),(304009,8445,'tl','',0),(304010,8445,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3648;&#3623;&#3621;&#3634;&#3609;&#3634;&#3628;&#3636;&#3585;&#3634;&#3648;&#3586;&#3657;&#3634;&#3591;&#3634;&#3609;',0),(304011,8445,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª Timeclock',0),(304012,8445,'ms','Timeclock persediaan',0),(304013,8445,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(304014,8445,'fr','Le programme d\'installation Timeclock',0),(304015,8445,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯',0),(304016,8445,'pt','InstalaÃ§Ã£o Timeclock',0),(304017,8445,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð§Ð°ÑÑ‹',0),(304018,8445,'es','Configurar el RelÃ³j Checador',0),(304019,8445,'de','Setup Timeclock',0),(304020,8445,'en','Setup Timeclock',0),(304021,8446,'is','',0),(304022,8446,'dr','Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ ',0),(304023,8446,'pr','Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ ',0),(304024,8446,'tr','TimeClock parÃ§a baÅŸÄ± iÅŸ',0),(304025,8446,'pl','TimeClock pracy akordowej',0),(304026,8446,'bg','TimeClock Ð¿Ð°Ñ€Ñ‡Ðµ',0),(304027,8446,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú©',0),(304028,8446,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(304029,8446,'vi','MÃ¡y cháº¥m cÃ´ng viá»‡c khoÃ¡n',0),(304030,8446,'af','Tydklok Stukwerk',0),(304031,8446,'ro','Ceas acord',0),(304032,8446,'et','TimeClock tÃ¼kitÃ¶Ã¶',0),(304033,8446,'si','TimeClock akord',0),(304034,8446,'ba','Timeclock Piecework',0),(304035,8446,'nl','Klok stukloon',0),(304036,8446,'fi','Timeclock urakka',0),(304037,8446,'no','TimeClock stykkavlÃ¸nning',0),(304038,8446,'da','Timeclock akkordarbejde',0),(304039,8446,'ko','Timeclock Piecework',0),(304040,8446,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª Timeclock',0),(304041,8446,'el','Timeclock ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(304042,8446,'zh','æ—¶é’Ÿè®¡ä»¶\r\n',0),(304043,8446,'sv','Timeclock ackord',0),(304044,8446,'it','A cottimo Timeclock',0),(304045,8446,'tl','',0),(304046,8446,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3591;&#3634;&#3609;&#3648;&#3627;&#3617;&#3634;',0),(304047,8446,'hi','Timeclock Piecework',0),(304048,8446,'ms','Timeclock Piecework',0),(304049,8446,'ar','ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(304050,8446,'fr','Timeclock Ã  la piÃ¨ce',0),(304051,8446,'jp','å‡ºæ¥é«˜æ‰•ã„ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯',0),(304052,8446,'pt','Trabalho por tarefa timeclock',0),(304053,8446,'ru','TimeClock ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(304054,8446,'es','RelÃ³j Checador Trabajo por Pieza ',0),(304055,8446,'de','Timeclock Akkordarbeit',0),(304056,8446,'en','Timeclock Piecework',0),(304057,8447,'is','',0),(304058,8447,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(304059,8447,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(304060,8447,'tr','TimeClock iÅŸleme',0),(304061,8447,'pl','TimeClock przetwarzania',0),(304062,8447,'bg','TimeClock Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(304063,8447,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯',0),(304064,8447,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð¾Ð±Ñ€Ð°Ð´Ð°',0),(304065,8447,'vi','Xá»­ lÃ½ mÃ¡y cháº¥m cÃ´ng',0),(304066,8447,'af','Tydklok Prosesering',0),(304067,8447,'ro','Ceas de prelucrare',0),(304068,8447,'et','TimeClock tÃ¶Ã¶tlemine',0),(304069,8447,'si','TimeClock obdelave',0),(304070,8447,'ba','Pengolahan timeclock',0),(304071,8447,'nl','Klok Processing',0),(304072,8447,'fi','Reaaliaikainen kÃ¤sittely',0),(304073,8447,'no','TimeClock behandling',0),(304074,8447,'da','Timeclock behandling',0),(304075,8447,'ko','Timeclock ì²˜ë¦¬',0),(304076,8447,'he','×¢×™×‘×•×“ Timeclock',0),(304077,8447,'el','Timeclock ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(304078,8447,'zh','æ—¶é’Ÿå¤„ç†\r\n',0),(304079,8447,'sv','Timeclock bearbetning',0),(304080,8447,'it','Elaborazione Timeclock',0),(304081,8447,'tl','',0),(304082,8447,'th','&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(304083,8447,'hi','Timeclock à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤¿à¤‚à¤—',0),(304084,8447,'ms','Pemprosesan Timeclock',0),(304085,8447,'ar','ØªØ¬Ù‡ÙŠØ² ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(304086,8447,'fr','Timeclock traitement',0),(304087,8447,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯å‡¦ç†',0),(304088,8447,'pt','Processamento de timeclock',0),(304089,8447,'ru','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° TimeClock',0),(304090,8447,'es','RelÃ³j Checador Procesando',0),(304091,8447,'de','Timeclock Verarbeitung',0),(304092,8447,'en','Timeclock Processing',0),(304093,8448,'is','',0),(304094,8448,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(304095,8448,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(304096,8448,'tr','TimeClock raporlarÄ±',0),(304097,8448,'pl','Raporty TimeClock',0),(304098,8448,'bg','TimeClock Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(304099,8448,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(304100,8448,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(304101,8448,'vi','BÃ¡o cÃ¡o thá»i gian lÃ m viá»‡c',0),(304102,8448,'af','Tydklok Verslae',0),(304103,8448,'ro','Rapoarte de ceas',0),(304104,8448,'et','TimeClock aruanded',0),(304105,8448,'si','TimeClock poroÄila',0),(304106,8448,'ba','Timeclock laporan',0),(304107,8448,'nl','Klok rapporten',0),(304108,8448,'fi','Reaaliaikainen raportit',0),(304109,8448,'no','TimeClock rapporter',0),(304110,8448,'da','Timeclock rapporter',0),(304111,8448,'ko','Timeclock ë³´ê³ ì„œ',0),(304112,8448,'he','×“×•×—×•×ª Timeclock',0),(304113,8448,'el','Timeclock ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(304114,8448,'zh','æ—¶é’ŸæŠ¥å‘Š\r\n',0),(304115,8448,'sv','Timeclock rapporter',0),(304116,8448,'it','Rapporti Timeclock',0),(304117,8448,'tl','',0),(304118,8448,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(304119,8448,'hi','Timeclock à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(304120,8448,'ms','Laporan Timeclock',0),(304121,8448,'ar','ØªÙ‚Ø§Ø±ÙŠØ± ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(304122,8448,'fr','Timeclock rapports',0),(304123,8448,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ãƒ¬ãƒãƒ¼ãƒˆ',0),(304124,8448,'pt','RelatÃ³rios de timeclock',0),(304125,8448,'ru','ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹ ÐŸÐ¾ Ð§Ð°ÑÐ°Ð¼',0),(304126,8448,'es','RelÃ³j Checador Informes',0),(304127,8448,'de','Timeclock Berichte',0),(304128,8448,'en','Timeclock Reports',0),(304129,8449,'is','',0),(304130,8449,'dr','Ø®Ù„Ø§ØµÙ‡ Ø²Ù…Ø§Ù† ',0),(304131,8449,'pr','Ø®Ù„Ø§ØµÙ‡ Ø²Ù…Ø§Ù† ',0),(304132,8449,'tr','Ã–zeti',0),(304133,8449,'pl','Czas KrÃ³tki opis',0),(304134,8449,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(304135,8449,'ur','ÙˆÙ‚Øª Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(304136,8449,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(304137,8449,'vi','Tá»•ng quÃ¡t Thá»i gian ',0),(304138,8449,'af','Tyd Opsomming',0),(304139,8449,'ro','Sumar timp',0),(304140,8449,'et','Aeg KokkuvÃµte',0),(304141,8449,'si','Time Povzetek',0),(304142,8449,'ba','Waktu ringkasan',0),(304143,8449,'nl','Tijd samenvatting',0),(304144,8449,'fi','Time Yhteenveto',0),(304145,8449,'no','Time Sammendrag',0),(304146,8449,'da','Time ResumÃ©',0),(304147,8449,'ko','ì‹œê°„ ìš”ì•½',0),(304148,8449,'he','×¡×™×›×•× ×–×ž×Ÿ',0),(304149,8449,'el','Time Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(304150,8449,'zh','æ—¶é—´æ‘˜è¦\r\n',0),(304151,8449,'sv','Time Sammanfattning',0),(304152,8449,'it','Riassunto del tempo',0),(304153,8449,'tl','',0),(304154,8449,'th','&#3648;&#3623;&#3621;&#3634;&#3626;&#3619;&#3640;&#3611;',0),(304155,8449,'hi','à¤¸à¤®à¤¯ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(304156,8449,'ms','Ringkasan masa',0),(304157,8449,'ar','Ù…Ù„Ø®Øµ Ø§Ù„ÙˆÙ‚Øª',0),(304158,8449,'fr','RÃ©capitulation du temps',0),(304159,8449,'jp','æ™‚é–“ã®æ¦‚è¦',0),(304160,8449,'pt','Resumo de tempo',0),(304161,8449,'ru','Ð’Ñ€ÐµÐ¼Ñ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(304162,8449,'es','Resumen de Tiempo',0),(304163,8449,'de','Zeit-Zusammenfassung',0),(304164,8449,'en','Time Summary',0),(304165,8450,'is','',0),(304166,8450,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø²Ù…Ø§Ù†ÙŠ Ø¯ÙŠÚ¯Ø± ',0),(304167,8450,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø²Ù…Ø§Ù†ÙŠ Ø¯ÙŠÚ¯Ø± ',0),(304168,8450,'tr','DiÄŸer zaman kategorilerini girin/gÃ¼ncelleme',0),(304169,8450,'pl','WprowadÅº/aktualizacja inne kategorie czasu',0),(304170,8450,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸, Ð²Ñ€ÐµÐ¼Ðµ',0),(304171,8450,'ur','Ø¯ÙˆØ³Ø±Û’ ÙˆÙ‚Øª Ø²Ù…Ø±Û Ø¬Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(304172,8450,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ñ€ÑƒÐ³Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(304173,8450,'vi','Nháº­p/Cáº­p Nháº­t Thá»ƒ Loáº¡i Thá»i Gian KhÃ¡c',0),(304174,8450,'af','Invoer/Opdateer Ander Tyd KategoriÃ« ',0),(304175,8450,'ro','IntroduceÅ£i/actualizare alte categorii de timp',0),(304176,8450,'et','Muu aeg kategooriad sisestamine/ajakohastamine',0),(304177,8450,'si','Vnos/posodobitev druge kategorije Äas',0),(304178,8450,'ba','Isi/Perbarui Kategori Waktu yang Lain',0),(304179,8450,'nl','Andere categorieÃ«n tijd invoeren/bijwerken',0),(304180,8450,'fi','PÃ¤ivittÃ¤minen muut luokat',0),(304181,8450,'no','Angi/oppdatere andre kategorier',0),(304182,8450,'da','Indtaste/opdatere andre kategorier',0),(304183,8450,'ko','ë‹¤ë¥¸ ì‹œê°„ ë²”ì£¼ë¥¼ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(304184,8450,'he','×”×–×Ÿ/×¢×“×›×Ÿ ×§×˜×’×•×¨×™×•×ª ×–×ž×Ÿ ××—×¨×•×ª',0),(304185,8450,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¬Î»Î»ÎµÏ‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Ï‡ÏÏŒÎ½Î¿Ï…',0),(304186,8450,'zh','è¾“å…¥/æ›´æ–°å…¶ä»–æ—¶é—´åˆ†ç±»',0),(304187,8450,'sv','Ange/uppdatera andra tid-kategorier',0),(304188,8450,'it','Inserisci/Aggiorna altre categorie di tempo',0),(304189,8450,'tl','',0),(304190,8450,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3648;&#3623;&#3621;&#3634;&#3629;&#3639;&#3656;&#3609;&#3586;&#3629;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(304191,8450,'hi','à¤…à¤¨à¥à¤¯ à¤¸à¤®à¤¯ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(304192,8450,'ms','Masukkan/Kemaskini kategori masa yang lain',0),(304193,8450,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« ÙØ¦Ø§Øª Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(304194,8450,'fr','Entrez/mise Ã  jour des autres catÃ©gories de temps',0),(304195,8450,'jp','ä»–ã®ã‚«ãƒ†ã‚´ãƒªã®å…¥åŠ›/æ›´æ–°',0),(304196,8450,'pt','Inserir/atualizar outras categorias de tempo',0),(304197,8450,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¸Ðµ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð’Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(304198,8450,'es','Introducir/Actualizar Otras CategorÃ­as de Tiempo',0),(304199,8450,'de','Geben Sie/Update andere Zeitkategorien',0),(304200,8450,'en','Enter/Update Other Time Categories',0),(304201,8451,'is','',0),(304202,8451,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù†Ø±Ø®Ù‡Ø§ÙŠ Ù¾ÙŠÙ…Ø§Ù†ÙƒØ§Ø±ÙŠ Ùˆ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(304203,8451,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø±Ø®Ù‡Ø§ÙŠ Ù¾ÙŠÙ…Ø§Ù†ÙƒØ§Ø±ÙŠ Ùˆ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(304204,8451,'tr','ParÃ§a baÅŸÄ± iÅŸ oranlarÄ± ve bilgi girin/gÃ¼ncelleme',0),(304205,8451,'pl','Cena akordowa wprowadÅº/aktualizacji i informacji',0),(304206,8451,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð°Ñ€Ñ‡Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¸ Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(304207,8451,'ur','Ø¯Ø§Ø®Ù„/Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ú©ÛŒ Ø´Ø±Ø­ Ø§ÙˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(304208,8451,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ ÑÑ‚Ð¾Ð¿Ðµ Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(304209,8451,'vi','Nháº­p/Cáº­p Nháº­t GiÃ¡ & ThÃ´ng Tin LÃ m KhoÃ¡n ',0),(304210,8451,'af','Invoer/Opdateer van Stukwerktariewe en -Inligting',0),(304211,8451,'ro','IntroduceÅ£i/actualizare ratele de acord ÅŸi informaÅ£ii',0),(304212,8451,'et','Sisestamine/ajakohastamine TÃ¼kitÃ¶Ã¶palgad ja teave',0),(304213,8451,'si','Stopnje akord vnesite Update in informacije',0),(304214,8451,'ba','Masukkan Update Piecework harga dan informasi',0),(304215,8451,'nl','Invoeren/bijwerken stukloon tarieven en informatie',0),(304216,8451,'fi','PÃ¤ivittÃ¤minen urakka hinnat ja tiedot',0),(304217,8451,'no','Angi/Oppdater stykkavlÃ¸nning priser og informasjon',0),(304218,8451,'da','Indtaste/opdatere akkordarbejde priser og oplysninger',0),(304219,8451,'ko','ìž…ë ¥/ì—…ë°ì´íŠ¸ Piecework ì†ë„ ì •ë³´',0),(304220,8451,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª ×”×–×Ÿ/×¢×“×›×•×Ÿ ×”×ž×—×™×¨×™× ×•×›×œ ×ž×™×“×¢',0),(304221,8451,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î­Ï‡Î¿Ï…ÏƒÎ±Ï‚ Ï„Î¹Î¼Î­Ï‚ ÎºÎ±Î¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(304222,8451,'zh','è¾“å…¥/æ›´æ–°è®¡ä»¶çŽ‡å’Œä¿¡æ¯',0),(304223,8451,'sv','Ange/uppdatera ackord priser och Information',0),(304224,8451,'it','Inserisci/Aggiorna a cottimo tariffe e informazioni',0),(304225,8451,'tl','',0),(304226,8451,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3629;&#3633;&#3605;&#3619;&#3634;&#3591;&#3634;&#3609;&#3648;&#3627;&#3617;&#3634;&#3649;&#3621;&#3632;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(304227,8451,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚/Piecework à¤¦à¤°à¥‹à¤‚ à¤”à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(304228,8451,'ms','Masukkan/Kemaskini Piecework kadar dan maklumat',0),(304229,8451,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ø¯Ù„Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© ÙˆØ§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(304230,8451,'fr','Tarifs Ã  la piÃ¨ce entrez/mise Ã  jour et informations',0),(304231,8451,'jp','å‡ºæ¥é«˜æ‰•ã„ã®æ–™é‡‘ã¨æƒ…å ±ã®å…¥åŠ›/æ›´æ–°',0),(304232,8451,'pt','Inserir/atualizar informaÃ§Ãµes e taxas de trabalho por tarefa',0),(304233,8451,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(304234,8451,'es','Introducir/Actualizar Tasas de Trabajo por Pieza y InformaciÃ³n',0),(304235,8451,'de','Geben Sie/Update Akkordarbeit Preise und Informationen',0),(304236,8451,'en','Enter/Update Piecework Rates and Information',0),(304237,8452,'is','',0),(304238,8452,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(304239,8452,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(304240,8452,'tr','TimeClock Kur',0),(304241,8452,'pl','TimeClock instalacji',0),(304242,8452,'bg','TimeClock Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(304243,8452,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ø³ÛŒÙ¹ Ø§Ù¾',0),(304244,8452,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº',0),(304245,8452,'vi','Setup mÃ¡y cháº¥m cÃ´ng',0),(304246,8452,'af','Tydklok Opstelling',0),(304247,8452,'ro','Ceas Setup',0),(304248,8452,'et','TimeClock seadistamine',0),(304249,8452,'si','TimeClock Setup',0),(304250,8452,'ba','Timeclock Setup',0),(304251,8452,'nl','Klok instellen',0),(304252,8452,'fi','Timeclock asetukset',0),(304253,8452,'no','TimeClock oppsett',0),(304254,8452,'da','Timeclock opsÃ¦tning',0),(304255,8452,'ko','Timeclock ì„¤ì¹˜',0),(304256,8452,'he','×”×’×“×¨×ª Timeclock',0),(304257,8452,'el','Timeclock ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(304258,8452,'zh','æ—¶é’Ÿè®¾ç½®\r\n',0),(304259,8452,'sv','Timeclock Setup',0),(304260,8452,'it','Timeclock Setup',0),(304261,8452,'tl','',0),(304262,8452,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(304263,8452,'hi','Timeclock à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(304264,8452,'ms','Timeclock persediaan',0),(304265,8452,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(304266,8452,'fr','Timeclock Setup',0),(304267,8452,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(304268,8452,'pt','InstalaÃ§Ã£o de timeclock',0),(304269,8452,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð§Ð°ÑÐ¾Ð²',0),(304270,8452,'es','Configurar RelÃ³j Checador',0),(304271,8452,'de','Timeclock Setup',0),(304272,8452,'en','Timeclock Setup',0),(304273,8453,'is','',0),(304274,8453,'dr','ÙÙ‚Ø· Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ',0),(304275,8453,'pr','ÙÙ‚Ø· Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… ',0),(304276,8453,'tr','Sadece TimeClock oturum aÃ§ma',0),(304277,8453,'pl','TimeClock logowania tylko',0),(304278,8453,'bg','TimeClock Ð²Ñ…Ð¾Ð´ ÑÐ°Ð¼Ð¾',0),(304279,8453,'ur','ØµØ±Ù Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù„Ø§Ú¯ Ø§Ù†',0),(304280,8453,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð° ÑÐ°Ð¼Ð¾',0),(304281,8453,'vi','Chá»‰ Ä‘Äƒng nháº­p mÃ¡y cháº¥m cÃ´ng',0),(304282,8453,'af','Tydklok Aantekening Alleenlik',0),(304283,8453,'ro','Ceas Login numai',0),(304284,8453,'et','TimeClock Login',0),(304285,8453,'si','TimeClock prijavo samo',0),(304286,8453,'ba','Timeclock Login hanya',0),(304287,8453,'nl','Klok Login alleen',0),(304288,8453,'fi','Timeclock kirjautuminen',0),(304289,8453,'no','TimeClock pÃ¥logging bare',0),(304290,8453,'da','Timeclock Login kun',0),(304291,8453,'ko','Timeclock ë¡œê·¸ì¸ë§Œ',0),(304292,8453,'he','×”×›× ×™×¡×” Timeclock ×‘×œ×‘×“',0),(304293,8453,'el','Timeclock ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ Î¼ÏŒÎ½Î¿',0),(304294,8453,'zh','ä»…æ—¶é’Ÿç™»å½•\r\n',0),(304295,8453,'sv','Timeclock inloggning endast',0),(304296,8453,'it','Timeclock Login solo',0),(304297,8453,'tl','',0),(304298,8453,'th','&#3621;&#3655;&#3629;&#3585;&#3629;&#3636;&#3609;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3619;&#3632;&#3610;&#3610;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3',0),(304299,8453,'hi','Timeclock à¤•à¥‡à¤µà¤² à¤²à¥‰à¤—à¤¿à¤¨',0),(304300,8453,'ms','Login Timeclock sahaja',0),(304301,8453,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ ÙÙ‚Ø·',0),(304302,8453,'fr','Timeclock Login uniquement',0),(304303,8453,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ãƒ­ã‚°ã‚¤ãƒ³ã®ã¿',0),(304304,8453,'pt','Timeclock Login apenas',0),(304305,8453,'ru','TimeClock Ð²Ñ…Ð¾Ð´ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(304306,8453,'es','Reloj Checador Solamente Login',0),(304307,8453,'de','Timeclock Login nur',0),(304308,8453,'en','Timeclock Login Only',0),(304309,8454,'is','',0),(304310,8454,'dr','Ø§Ø³ØªØ§Ù† ',0),(304311,8454,'pr','Ø§Ø³ØªØ§Ù† ',0),(304312,8454,'tr','Ä°l',0),(304313,8454,'pl','Prowincja',0),(304314,8454,'bg','ÐŸÑ€Ð¾Ð²Ð¸Ð½Ñ†Ð¸Ñ',0),(304315,8454,'ur','ØµÙˆØ¨Û',0),(304316,8454,'sr','ÐŸÐ¾ÐºÑ€Ð°Ñ˜Ð¸Ð½Ð°',0),(304317,8454,'vi','Tá»‰nh',0),(304318,8454,'af','Provinsie',0),(304319,8454,'ro','Provincia',0),(304320,8454,'et','Provints',0),(304321,8454,'si','Provinca',0),(304322,8454,'ba','Provinsi',0),(304323,8454,'nl','Provincie',0),(304324,8454,'fi','Maakunta',0),(304325,8454,'no','Provinsen',0),(304326,8454,'da','Provinsen',0),(304327,8454,'ko','ì£¼',0),(304328,8454,'he','×¤×¨×•×‘×™× ×¦×™×”',0),(304329,8454,'el','Î•Ï€Î±ÏÏ‡Î¯Î±',0),(304330,8454,'zh','çœ\r\n',0),(304331,8454,'sv','Provinsen',0),(304332,8454,'it','Provincia',0),(304333,8454,'tl','',0),(304334,8454,'th','&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(304335,8454,'hi','à¤ªà¥à¤°à¤¾à¤‚à¤¤',0),(304336,8454,'ms','Wilayah',0),(304337,8454,'ar','Ù…Ù‚Ø§Ø·Ø¹Ø©',0),(304338,8454,'fr','Province',0),(304339,8454,'jp','å·ž',0),(304340,8454,'pt','ProvÃ­ncia',0),(304341,8454,'ru','ÐŸÑ€Ð¾Ð²Ð¸Ð½Ñ†Ð¸Ñ',0),(304342,8454,'es','Provincia',0),(304343,8454,'de','Provinz',0),(304344,8454,'en','Province',0),(304345,8455,'is','',0),(304346,8455,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø´Ø±ÙƒØª',0),(304347,8455,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø´Ø±ÙƒØª',0),(304348,8455,'tr','Gerekli firma bilgileri',0),(304349,8455,'pl','Informacje o firmie wymagane',0),(304350,8455,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(304351,8455,'ur','Ù…Ø·Ù„ÙˆØ¨Û Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(304352,8455,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸ Ð¾ Ñ„Ð¸Ñ€Ð¼Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¸',0),(304353,8455,'vi','Cáº§n ThÃ´ng Tin Cty',0),(304354,8455,'af','Vereiste Onderneming Inligting',0),(304355,8455,'ro','Info companie - obligatorie',0),(304356,8455,'et','NÃµutud ettevÃµtte Info',0),(304357,8455,'si','Zahteva druÅ¾ba Info',0),(304358,8455,'ba','Info diperlukan perusahaan',0),(304359,8455,'nl','Vereiste Bedrijfsinfo',0),(304360,8455,'fi','Pakolliset yrityksen tiedot',0),(304361,8455,'no','NÃ¸dvendig firmainformasjon',0),(304362,8455,'da','NÃ¸dvendige firmaoplysninger',0),(304363,8455,'ko','í•„ìš”í•œ íšŒì‚¬ ì •ë³´',0),(304364,8455,'he','×¤×¨×˜×™ ×”×—×‘×¨×” × ×“×¨×©×ª',0),(304365,8455,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎ¯Î± Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(304366,8455,'zh','æ‰€éœ€çš„å…¬å¸ä¿¡æ¯\r\n',0),(304367,8455,'sv','KrÃ¤vs fÃ¶retag information',0),(304368,8455,'it','Azienda richiesta Info',0),(304369,8455,'tl','',0),(304370,8455,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(304371,8455,'hi','à¤†à¤µà¤¶à¥à¤¯à¤• à¤•à¤‚à¤ªà¤¨à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(304372,8455,'ms','Maklumat syarikat yang diperlukan',0),(304373,8455,'ar','Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© Ù…Ù† Ø§Ù„Ø´Ø±ÙƒØ©',0),(304374,8455,'fr','Infos sociÃ©tÃ© requis',0),(304375,8455,'jp','å¿…è¦ãªä¼šç¤¾æƒ…å ±ã¯ã“ã¡ã‚‰',0),(304376,8455,'pt','Empresa necessÃ¡ria informaÃ§Ã£o',0),(304377,8455,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð°Ñ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ðž ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(304378,8455,'es','Info de la Empresa Requerido',0),(304379,8455,'de','Erforderlich Impressum',0),(304380,8455,'en','Required Company Info',0),(304381,8456,'is','',0),(304382,8456,'dr','ØªØºÙŠÙŠØ± ÙƒØ§Ø±Ù…Ù†Ø¯',0),(304383,8456,'pr','ØªØºÙŠÙŠØ± ÙƒØ§Ø±Ù…Ù†Ø¯',0),(304384,8456,'tr','DeÄŸiÅŸim Ã§alÄ±ÅŸan',0),(304385,8456,'pl','Zmiana pracownika',0),(304386,8456,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(304387,8456,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ù…Ù„Ø§Ø²Ù…',0),(304388,8456,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(304389,8456,'vi','Thay Ä‘á»•i nháº­n viÃªn',0),(304390,8456,'af','Verander Werknemers',0),(304391,8456,'ro','Schimbarea angajatului',0),(304392,8456,'et','Muuda tÃ¶Ã¶tajat',0),(304393,8456,'si','Sprememba zaposlenega',0),(304394,8456,'ba','Perubahan karyawan',0),(304395,8456,'nl','Verandering werknemer',0),(304396,8456,'fi','Muutos tyÃ¶ntekijÃ¤n',0),(304397,8456,'no','Endre ansatte',0),(304398,8456,'da','Ã†ndring af medarbejder',0),(304399,8456,'ko','ë³€í™” ì§ì›',0),(304400,8456,'he','×”×¢×•×‘×“ ×©×™× ×•×™',0),(304401,8456,'el','Î‘Î»Î»Î±Î³Î® ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(304402,8456,'zh','æ”¹å˜é›‡å‘˜\r\n',0),(304403,8456,'sv','Ã„ndra anstÃ¤lld',0),(304404,8456,'it','Cambiamento dipendente',0),(304405,8456,'tl','',0),(304406,8456,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(304407,8456,'hi','à¤¬à¤¦à¤²à¥‡à¤‚ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(304408,8456,'ms','Pertukaran kakitangan',0),(304409,8456,'ar','ØªØºÙŠØ± Ø§Ù„Ù…ÙˆØ¸Ù',0),(304410,8456,'fr','EmployÃ© de changement',0),(304411,8456,'jp','å¤‰æ›´ã®å¾“æ¥­å“¡',0),(304412,8456,'pt','Empregado de mudanÃ§a',0),(304413,8456,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(304414,8456,'es','Cambiar Empleado',0),(304415,8456,'de','Ã„nderung Mitarbeiter',0),(304416,8456,'en','Change Employee',0),(304417,8457,'is','',0),(304418,8457,'dr','Ø¨Ø±ÙˆÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ù†Ø§Ù‡Ø§Ø±',0),(304419,8457,'pr','Ø¨Ø±ÙˆÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ù†Ø§Ù‡Ø§Ø±',0),(304420,8457,'tr','YemeÄŸe git',0),(304421,8457,'pl','PÃ³jÅ›Ä‡ na obiad',0),(304422,8457,'bg','ÐžÑ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð° Ð¾Ð±ÑÐ´',0),(304423,8457,'ur','Ø¯ÙˆÙ¾ÛØ± Ú©Û’ Ú©Ú¾Ø§Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø¬Ø§Ù†Ø§',0),(304424,8457,'sr','Ð˜Ð´ÐµÐ¼Ð¾ Ð½Ð° Ñ€ÑƒÑ‡Ð°Ðº',0),(304425,8457,'vi','Äi Äƒn trÆ°a',0),(304426,8457,'af','Gaan na middagete',0),(304427,8457,'ro','Du-te la masa de prÃ¢nz',0),(304428,8457,'et','LÃ¤hen lÃµunat',0),(304429,8457,'si','Pojdi na kosilo',0),(304430,8457,'ba','Pergi ke Makan Siang',0),(304431,8457,'nl','Ga naar de Lunch',0),(304432,8457,'fi','MennÃ¤ lounaalle',0),(304433,8457,'no','GÃ¥ til lunsj',0),(304434,8457,'da','GÃ¥ til frokost',0),(304435,8457,'ko','ì ì‹¬ì—ê°€ ì„œ',0),(304436,8457,'he','×œ××¨×•×—×ª ×¦×”×¨×™×™×',0),(304437,8457,'el','Î Î¬Î½Îµ ÏƒÏ„Î¿ Î¼ÎµÏƒÎ·Î¼ÎµÏÎ¹Î±Î½ÏŒ Î³ÎµÏÎ¼Î±',0),(304438,8457,'zh','åŽ»åƒåˆé¥­\r\n',0),(304439,8457,'sv','GÃ¥ pÃ¥ Lunch',0),(304440,8457,'it','Andare a pranzo',0),(304441,8457,'tl','',0),(304442,8457,'th','&#3652;&#3611;&#3607;&#3637;&#3656;&#3629;&#3634;&#3627;&#3634;&#3619;&#3585;&#3621;&#3634;&#3591;&#3623;&#3633;&#3609;',0),(304443,8457,'hi','à¤¦à¥‹à¤ªà¤¹à¤° à¤•à¥‡ à¤­à¥‹à¤œà¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤“',0),(304444,8457,'ms','Pergi ke makan tengahari',0),(304445,8457,'ar','Ø§Ø°Ù‡Ø¨ Ù„Ù„ØºØ¯Ø§Ø¡',0),(304446,8457,'fr','Aller dÃ©jeuner',0),(304447,8457,'jp','ãƒ©ãƒ³ãƒã«è¡Œã',0),(304448,8457,'pt','Ir almoÃ§ar',0),(304449,8457,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ð½Ð° Ð¾Ð±ÐµÐ´',0),(304450,8457,'es','Va a Comer',0),(304451,8457,'de','Gehen Sie zum Mittagessen',0),(304452,8457,'en','Go to Lunch',0),(304453,8458,'is','',0),(304454,8458,'dr','ØªØ±Ùƒ ÙƒØ±Ø¯Ù† ÙƒØ§Ø± ',0),(304455,8458,'pr','ØªØ±Ùƒ ÙƒØ±Ø¯Ù† ÙƒØ§Ø± ',0),(304456,8458,'tr','Ä°ÅŸini bÄ±rak',0),(304457,8458,'pl','OpuÅ›ciÄ‡ pracy',0),(304458,8458,'bg','ÐÐ°Ð¿ÑƒÑÐ½Ð°Ñ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(304459,8458,'ur','Ú©Ø§Ù… Ú©Ùˆ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(304460,8458,'sr','ÐžÑÑ‚Ð°Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(304461,8458,'vi','Äá»ƒ cÃ´ng viá»‡c',0),(304462,8458,'af','Verlaat Werk',0),(304463,8458,'ro','Lasa munca',0),(304464,8458,'et','TÃ¶Ã¶lt lahkumise',0),(304465,8458,'si','Pustite delo',0),(304466,8458,'ba','Meninggalkan pekerjaan',0),(304467,8458,'nl','Laat werk',0),(304468,8458,'fi','JÃ¤ttÃ¤Ã¤ tyÃ¶',0),(304469,8458,'no','La arbeid',0),(304470,8458,'da','Forlade arbejdet',0),(304471,8458,'ko','ì¼ì„ ë‘ê³ ',0),(304472,8458,'he','×œ×¢×–×•×‘ ××ª ×”×¢×‘×•×“×”',0),(304473,8458,'el','Î•Î³ÎºÎ±Ï„Î±Î»ÎµÎ¯ÏˆÎµÎ¹ Ï„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(304474,8458,'zh','ç¦»å¼€å·¥ä½œå²—ä½\r\n',0),(304475,8458,'sv','LÃ¤mna arbetet',0),(304476,8458,'it','Lasciare il lavoro',0),(304477,8458,'tl','',0),(304478,8458,'th','&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3591;&#3634;&#3609;',0),(304479,8458,'hi','à¤•à¤¾à¤® à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚',0),(304480,8458,'ms','Meninggalkan kerja-kerja',0),(304481,8458,'ar','ØªØ±Ùƒ Ø§Ù„Ø¹Ù…Ù„',0),(304482,8458,'fr','Quitter le travail',0),(304483,8458,'jp','ä»•äº‹ã‚’æ®‹ã—ã¦ãã ã•ã„ã€‚',0),(304484,8458,'pt','Sair do trabalho',0),(304485,8458,'ru','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(304486,8458,'es','Salir del Trabajo',0),(304487,8458,'de','Aufgeben',0),(304488,8458,'en','Leave Work',0),(304489,8459,'is','',0),(304490,8459,'dr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ',0),(304491,8459,'pr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ',0),(304492,8459,'tr','ParÃ§a baÅŸÄ± iÅŸ',0),(304493,8459,'pl','Pracy akordowej',0),(304494,8459,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ',0),(304495,8459,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú©',0),(304496,8459,'sr','Ð—Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(304497,8459,'vi','Viá»‡c khoÃ¡n',0),(304498,8459,'af','Stukwerk',0),(304499,8459,'ro','Acord',0),(304500,8459,'et','TÃ¼kitÃ¶Ã¶',0),(304501,8459,'si','Akord',0),(304502,8459,'ba','Piecework',0),(304503,8459,'nl','Stukloon',0),(304504,8459,'fi','Urakka',0),(304505,8459,'no','StykkavlÃ¸nning',0),(304506,8459,'da','Akkordarbejde',0),(304507,8459,'ko','Piecework',0),(304508,8459,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(304509,8459,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹',0),(304510,8459,'zh','è®¡ä»¶å·¥ä½œ\r\n',0),(304511,8459,'sv','Ackord',0),(304512,8459,'it','Lavoro a cottimo',0),(304513,8459,'tl','',0),(304514,8459,'th','&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;',0),(304515,8459,'hi','Piecework',0),(304516,8459,'ms','Piecework',0),(304517,8459,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(304518,8459,'fr','Travail Ã  la piÃ¨ce',0),(304519,8459,'jp','å‡ºæ¥é«˜æ‰•ã„',0),(304520,8459,'pt','Trabalho por tarefa',0),(304521,8459,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(304522,8459,'es','Trabajo por Pieza',0),(304523,8459,'de','Akkordarbeit',0),(304524,8459,'en','Piecework',0),(304525,8460,'is','',0),(304526,8460,'dr','Ø¨Ø±Ú¯Ø´Øª Ø§Ø²',0),(304527,8460,'pr','Ø¨Ø±Ú¯Ø´Øª Ø§Ø²',0),(304528,8460,'tr','DÃ¶nmek',0),(304529,8460,'pl','PowrÃ³t z',0),(304530,8460,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ Ð¾Ñ‚',0),(304531,8460,'ur','Ø³Û’ ÙˆØ§Ù¾Ø³ÛŒ',0),(304532,8460,'sr','Ð”Ð¾Ð±Ð¸Ñ‚ Ñƒ',0),(304533,8460,'vi','Trá»Ÿ láº¡i tá»«',0),(304534,8460,'af','Terug Vanaf',0),(304535,8460,'ro','Reveni la',0),(304536,8460,'et','Tulu',0),(304537,8460,'si','Donos v',0),(304538,8460,'ba','Kembali dari',0),(304539,8460,'nl','Terug van',0),(304540,8460,'fi','Palauttaa',0),(304541,8460,'no','Tilbake fra',0),(304542,8460,'da','Vende tilbage fra',0),(304543,8460,'ko','ë°˜í™˜',0),(304544,8460,'he','×—×–×•×¨ ×ž-.',0),(304545,8460,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î±Ï€ÏŒ',0),(304546,8460,'zh','è¿”å›žæ¥è‡ª\r\n',0),(304547,8460,'sv','Tillbaka frÃ¥n',0),(304548,8460,'it','Ritorno da',0),(304549,8460,'tl','',0),(304550,8460,'th','&#3649;&#3610;&#3610;&#3615;&#3629;&#3619;&#3660;&#3617;&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;',0),(304551,8460,'hi','à¤¸à¥‡ à¤µà¤¾à¤ªà¤¸à¥€',0),(304552,8460,'ms','Balik dari',0),(304553,8460,'ar','Ø§Ù„Ø±Ø¬ÙˆØ¹ Ù…Ù†',0),(304554,8460,'fr','Retourner Ã  partir de',0),(304555,8460,'jp','ã‚’æˆ»ã‚‹',0),(304556,8460,'pt','Retorno de',0),(304557,8460,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ð¸Ð·',0),(304558,8460,'es','Regresar De',0),(304559,8460,'de','ZurÃ¼ck aus',0),(304560,8460,'en','Return From',0),(304561,8461,'is','',0),(304562,8461,'dr','(ØªØ¬Ø²ÙŠÙ‡',0),(304563,8461,'pr','Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø´ÙƒØ³Øª(ØªØ¬Ø²ÙŠÙ‡',0),(304564,8461,'tr','Geri ara',0),(304565,8461,'pl','PowrÃ³t z Break',0),(304566,8461,'bg','Ð’ÑŠÑ€Ð½ÐµÑ‚Ðµ Ð¾Ñ‚ Ð¿Ð¾Ñ‡Ð¸Ð²ÐºÐ°',0),(304567,8461,'ur','ÙˆÙ‚ÙÛ’ Ø³Û’ ÙˆØ§Ù¾Ø³ÛŒ',0),(304568,8461,'sr','Ð”Ð¾Ð±Ð¸Ñ‚ Ñƒ Ð¼Ð¸Ñ€Ñƒ',0),(304569,8461,'vi','Trá»Ÿ láº¡i tá»« giá» nghá»‰',0),(304570,8461,'af','Terug na Teebreek',0),(304571,8461,'ro','Reveni la despartire',0),(304572,8461,'et','Tulu Break',0),(304573,8461,'si','Vrnil iz Break',0),(304574,8461,'ba','Kembali dari istirahat',0),(304575,8461,'nl','Terug van vakantie',0),(304576,8461,'fi','Palauttaa Break',0),(304577,8461,'no','Tilbake fra ferie',0),(304578,8461,'da','Vender tilbage fra pausen',0),(304579,8461,'ko','ì¤‘ë‹¨ì—ì„œ ë°˜í™˜',0),(304580,8461,'he','×—×–×¨×” ×ž×”×¤×¡×§×”',0),(304581,8461,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î±Ï€ÏŒ Î´Î¹Î¬Î»ÎµÎ¹Î¼Î¼Î±',0),(304582,8461,'zh','ä»Žä¼‘æ¯è¿”å›ž\r\n',0),(304583,8461,'sv','Tillbaka frÃ¥n paus',0),(304584,8461,'it','Ritorno dalla pausa',0),(304585,8461,'tl','',0),(304586,8461,'th','&#3627;&#3618;&#3640;&#3604;&#3649;&#3610;&#3610;&#3615;&#3629;&#3619;&#3660;&#3617;&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;',0),(304587,8461,'hi','à¤µà¤¿à¤°à¤¾à¤® à¤¸à¥‡ à¤µà¤¾à¤ªà¤¸à¥€',0),(304588,8461,'ms','Balik dari cuti',0),(304589,8461,'ar','Ø§Ù„Ø±Ø¬ÙˆØ¹ Ù…Ù† ÙØªØ±Ø© Ø§Ù„Ø¥Ø³ØªØ±Ø§Ø­Ø©',0),(304590,8461,'fr','Retour de la pause',0),(304591,8461,'jp','ä¼‘æ†©ã‹ã‚‰æˆ»ã‚‹',0),(304592,8461,'pt','Retorno das fÃ©rias',0),(304593,8461,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ð¸Ð· Ð¿ÐµÑ€ÐµÑ€Ñ‹Ð²',0),(304594,8461,'es','Regresar De Descanso',0),(304595,8461,'de','ZurÃ¼ck aus der Pause',0),(304596,8461,'en','Return From Break',0),(304597,8462,'is','',0),(304598,8462,'dr','Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ù†Ø§Ù‡Ø§Ø±',0),(304599,8462,'pr','Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ù†Ø§Ù‡Ø§Ø±',0),(304600,8462,'tr','Ã–ÄŸle yemeÄŸinden sonra geri',0),(304601,8462,'pl','PowrÃ³t z obiadu',0),(304602,8462,'bg','Ð’ÑŠÑ€Ð½Ðµ Ð¾Ñ‚ Ð¾Ð±ÑÐ´',0),(304603,8462,'ur','Ø¯ÙˆÙ¾ÛØ± Ú©Û’ Ú©Ú¾Ø§Ù†Û’ Ø³Û’ ÙˆØ§Ù¾Ø³ÛŒ',0),(304604,8462,'sr','Ð’Ñ€Ð°Ñ‚Ð¸ Ñ Ñ€ÑƒÑ‡ÐºÐ°',0),(304605,8462,'vi','Trá»Ÿ láº¡i tá»« bá»¯a trÆ°a',0),(304606,8462,'af','Terug na Etenstyd',0),(304607,8462,'ro','A reveni la masa de prÃ¢nz',0),(304608,8462,'et','LÃµunalt',0),(304609,8462,'si','Vrnitev iz kosilo',0),(304610,8462,'ba','Kembali dari Makan Siang',0),(304611,8462,'nl','Retourneren van Lunch',0),(304612,8462,'fi','Palauttaa lounas',0),(304613,8462,'no','Tilbake fra lunsj',0),(304614,8462,'da','Vender tilbage fra frokost',0),(304615,8462,'ko','ì ì‹¬ ì‹ì‚¬ì—ì„œ ë°˜í™˜',0),(304616,8462,'he','×—×•×–×¨ ×ž××¨×•×—×ª ×”×¦×”×¨×™×™×',0),(304617,8462,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î±Ï€ÏŒ Ï„Î¿ Î¼ÎµÏƒÎ·Î¼ÎµÏÎ¹Î±Î½ÏŒ Î³ÎµÏÎ¼Î±',0),(304618,8462,'zh','ä»Žåˆé¤è¿”å›ž\r\n',0),(304619,8462,'sv','Tillbaka frÃ¥n Lunch',0),(304620,8462,'it','Ritorno da pranzo',0),(304621,8462,'tl','',0),(304622,8462,'th','&#3585;&#3621;&#3633;&#3610;&#3592;&#3634;&#3585;&#3629;&#3634;&#3627;&#3634;&#3619;&#3585;&#3621;&#3634;&#3591;&#3623;&#3633;&#3609;',0),(304623,8462,'hi','à¤¦à¥‹à¤ªà¤¹à¤° à¤•à¥‡ à¤­à¥‹à¤œà¤¨ à¤¸à¥‡ à¤µà¤¾à¤ªà¤¸à¥€',0),(304624,8462,'ms','Kembali dari makan tengahari',0),(304625,8462,'ar','Ø§Ù„Ø±Ø¬ÙˆØ¹ Ù…Ù† ÙØªØ±Ø© Ø§Ù„ØºØ°Ø§Ø¡',0),(304626,8462,'fr','Retour de dÃ©jeuner',0),(304627,8462,'jp','æ˜¼é£Ÿã‹ã‚‰æˆ»ã£ã¦ãã‚‹',0),(304628,8462,'pt','Retorno do almoÃ§o',0),(304629,8462,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ñ Ð¾Ð±ÐµÐ´Ð°',0),(304630,8462,'es','Regresar De Comida',0),(304631,8462,'de','Vom Mittagessen zurÃ¼ck',0),(304632,8462,'en','Return From Lunch',0),(304633,8463,'is','',0),(304634,8463,'dr','(Ø§Ø³ØªØ±Ø§Ø­Øª)Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡ ',0),(304635,8463,'pr','Ù…Ù‡Ù„Øª(Ø§Ø³ØªØ±Ø§Ø­Øª)Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡ ',0),(304636,8463,'tr','BaÅŸlatan Break',0),(304637,8463,'pl','ZaczÄ…Å‚ przerwa',0),(304638,8463,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð° Ð¿Ð¾Ñ‡Ð¸Ð²ÐºÐ°',0),(304639,8463,'ur','Ø¢ØºØ§Ø² ØªÙˆÚ‘',0),(304640,8463,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½ÑƒÑ‚Ð° Ð¿Ð°ÑƒÐ·Ðµ',0),(304641,8463,'vi','Báº¯t Äáº§u Chia',0),(304642,8463,'af','Begin breek',0),(304643,8463,'ro','A Ã®nceput sÄƒ pauzÄƒ',0),(304644,8463,'et','Algas vaheaeg',0),(304645,8463,'si','ZaÄel odmor',0),(304646,8463,'ba','Mulai istirahat',0),(304647,8463,'nl','Gestarte Break',0),(304648,8463,'fi','Alkoi Break',0),(304649,8463,'no','Startet pause',0),(304650,8463,'da','Startede pause',0),(304651,8463,'ko','ì‹œìž‘ëœ íœ´ì‹',0),(304652,8463,'he','×”×¤×¡×§×” ×”×ª×—×™×œ',0),(304653,8463,'el','ÎžÎµÎºÎ¯Î½Î·ÏƒÎµ Î´Î¹Î¬Î»ÎµÎ¹Î¼Î¼Î±',0),(304654,8463,'zh','å¼€å§‹æ‰“ç ´\r\n',0),(304655,8463,'sv','BÃ¶rjade bryta',0),(304656,8463,'it','Pausa ha iniziato',0),(304657,8463,'tl','',0),(304658,8463,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3627;&#3618;&#3640;&#3604;',0),(304659,8463,'hi','à¤¶à¥à¤°à¥‚ à¤•à¤° à¤¤à¥‹à¤¡à¤¼',0),(304660,8463,'ms','Cuti bermula',0),(304661,8463,'ar','Ø§Ø³ØªØ±Ø§Ø­Ø© Ø¨Ø¯Ø£Øª',0),(304662,8463,'fr','Break a commencÃ©',0),(304663,8463,'jp','é–‹å§‹å£Šã‚Œç›®',0),(304664,8463,'pt','Pausa comeÃ§ou',0),(304665,8463,'ru','ÐÐ°Ñ‡Ð°Ð» Ð¿ÐµÑ€ÐµÑ€Ñ‹Ð²',0),(304666,8463,'es','Descanso Comenzado',0),(304667,8463,'de','Running Pause',0),(304668,8463,'en','Started Break',0),(304669,8464,'is','',0),(304670,8464,'dr','Ù†Ø§Ù‡Ø§Ø± Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡',0),(304671,8464,'pr','Ù†Ø§Ù‡Ø§Ø± Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡',0),(304672,8464,'tr','BaÅŸlatan Ã¶ÄŸle',0),(304673,8464,'pl','ZaczÄ…Å‚ obiad',0),(304674,8464,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð° Ð¾Ð±ÑÐ´',0),(304675,8464,'ur','Ø¯ÙˆÙ¾ÛØ± Ú©Ø§ Ú©Ú¾Ø§Ù†Ø§ Ø´Ø±ÙˆØ¹ Ú©ÛŒÛ’ Û”',0),(304676,8464,'sr','ÐŸÐ¾Ñ‡ÐµÐ¾ Ñ€ÑƒÑ‡Ð°Ðº',0),(304677,8464,'vi','Báº¯t Äáº§u Äƒn trÆ°a',0),(304678,8464,'af','Begin middagete',0),(304679,8464,'ro','Masa de prÃ¢nz a Ã®nceput',0),(304680,8464,'et','Alustatud lÃµunasÃ¶Ã¶k',0),(304681,8464,'si','ZaÄel kosilo',0),(304682,8464,'ba','Makan Siang mulai',0),(304683,8464,'nl','Gestarte Lunch',0),(304684,8464,'fi','Alkoi lounas',0),(304685,8464,'no','Startet lunsj',0),(304686,8464,'da','Startede frokost',0),(304687,8464,'ko','ì‹œìž‘ëœ ì ì‹¬',0),(304688,8464,'he','××¨×•×—×ª ×”×¦×”×¨×™×™× ×”×ª×—×™×œ',0),(304689,8464,'el','ÎžÎµÎºÎ¯Î½Î·ÏƒÎµ Î³ÎµÏÎ¼Î±',0),(304690,8464,'zh','åˆé¤å¼€å§‹\r\n',0),(304691,8464,'sv','BÃ¶rjade Lunch',0),(304692,8464,'it','Pranzo iniziato',0),(304693,8464,'tl','',0),(304694,8464,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3629;&#3634;&#3627;&#3634;&#3619;&#3648;&#3607;&#3637;&#3656;&#3618;&#3591;',0),(304695,8464,'hi','à¤¦à¥‹à¤ªà¤¹à¤° à¤•à¥‡ à¤­à¥‹à¤œà¤¨ à¤•à¥‡ à¤¶à¥à¤°à¥‚',0),(304696,8464,'ms','Makan tengah hari bermula',0),(304697,8464,'ar','Ø¨Ø¯Ø£ Ø§Ù„ØºØ¯Ø§Ø¡',0),(304698,8464,'fr','DÃ©jeuner a commencÃ©',0),(304699,8464,'jp','é–‹å§‹ãƒ©ãƒ³ãƒ',0),(304700,8464,'pt','AlmoÃ§o comeÃ§ou',0),(304701,8464,'ru','ÐÐ°Ñ‡Ð°Ð» Ð¾Ð±ÐµÐ´',0),(304702,8464,'es','Comida Comenzada',0),(304703,8464,'de','Running Mittagessen',0),(304704,8464,'en','Started Lunch',0),(304705,8465,'is','',0),(304706,8465,'dr','Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡ Ø¯ÙŠÚ¯Ø±',0),(304707,8465,'pr','Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡ Ø¯ÙŠÚ¯Ø±',0),(304708,8465,'tr','DiÄŸer baÅŸladÄ±',0),(304709,8465,'pl','Uruchomiona inne',0),(304710,8465,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð° Ð´Ñ€ÑƒÐ³',0),(304711,8465,'ur','Ø¯ÙˆØ³Ø±Û’ Ø´Ø±ÙˆØ¹ Ú©Ø± Ø¯ÛŒØ§',0),(304712,8465,'sr','ÐŸÐ¾Ñ‡ÐµÐ¾ Ð´Ñ€ÑƒÐ³Ð¸',0),(304713,8465,'vi','Báº¯t Äáº§u khÃ¡c',0),(304714,8465,'af','Ander begin',0),(304715,8465,'ro','A inceput alta',0),(304716,8465,'et','Hakkas teine',0),(304717,8465,'si','ZaÄel drugi',0),(304718,8465,'ba','Mulai lain',0),(304719,8465,'nl','Begonnen met andere',0),(304720,8465,'fi','KÃ¤ynnistetty muu',0),(304721,8465,'no','Startet annet',0),(304722,8465,'da','Startede anden',0),(304723,8465,'ko','ë‹¤ë¥¸ ì‹œìž‘',0),(304724,8465,'he','×”×ª×—×™×œ ××ª ×”×©× ×™',0),(304725,8465,'el','ÎžÎµÎºÎ¯Î½Î·ÏƒÎµ Î±Ï€ÏŒ Î¬Î»Î»Î¿',0),(304726,8465,'zh','å¯åŠ¨å…¶ä»–\r\n',0),(304727,8465,'sv','BÃ¶rjade andra',0),(304728,8465,'it','Iniziato altro',0),(304729,8465,'tl','',0),(304730,8465,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3629;&#3636;&#3656;&#3609; &#3654;',0),(304731,8465,'hi','à¤¦à¥‚à¤¸à¤°à¥‡ à¤•à¥‡ à¤¶à¥à¤°à¥‚ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(304732,8465,'ms','Mula lain',0),(304733,8465,'ar','ÙˆØ¨Ø¯Ø£ Ø§Ù„Ø¨Ø¹Ø¶',0),(304734,8465,'fr','CommencÃ© l\'autre',0),(304735,8465,'jp','ä»–ã®é–‹å§‹',0),(304736,8465,'pt','ComeÃ§ou outro',0),(304737,8465,'ru','ÐÐ°Ñ‡Ð°Ð» Ñ Ð´Ñ€ÑƒÐ³Ð¾Ð¼',0),(304738,8465,'es','Otro Comenzado',0),(304739,8465,'de','Andere gestartet',0),(304740,8465,'en','Started Other',0),(304741,8466,'is','',0),(304742,8466,'dr','ÙƒØ§Ø± Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡',0),(304743,8466,'pr','ÙƒØ§Ø± Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡',0),(304744,8466,'tr','BaÅŸlatÄ±lan iÅŸ',0),(304745,8466,'pl','RozpoczÄ…Å‚ pracÄ™',0),(304746,8466,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð° Ð´Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð¸',0),(304747,8466,'ur','Ú©Ø§Ù… Ø´Ø±ÙˆØ¹ Ú©ÛŒÛ’ Û”',0),(304748,8466,'sr','ÐŸÐ¾Ñ‡ÐµÐ¾ Ñ€Ð°Ð´Ð¸Ñ‚Ð¸',0),(304749,8466,'vi','Báº¯t Äáº§u lÃ m viá»‡c',0),(304750,8466,'af','Begin werk',0),(304751,8466,'ro','A Ã®nceput activitatea',0),(304752,8466,'et','Alustatud tÃ¶Ã¶d',0),(304753,8466,'si','ZaÄel delo',0),(304754,8466,'ba','Mulai bekerja',0),(304755,8466,'nl','Begonnen werk',0),(304756,8466,'fi','Aloitti tyÃ¶nsÃ¤',0),(304757,8466,'no','Startet arbeid',0),(304758,8466,'da','Startet arbejde',0),(304759,8466,'ko','ì‹œìž‘ëœ ìž‘ì—…',0),(304760,8466,'he','×”×¢×‘×•×“×” ×”×ª×—×™×œ×”',0),(304761,8466,'el','ÎˆÏÎ³Î¿ Ï€Î¿Ï… Î¾ÎµÎºÎ¯Î½Î·ÏƒÎµ',0),(304762,8466,'zh','å¼€å§‹å·¥ä½œ\r\n',0),(304763,8466,'sv','BÃ¶rjade arbeta',0),(304764,8466,'it','Lavoro iniziato',0),(304765,8466,'tl','',0),(304766,8466,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3591;&#3634;&#3609;',0),(304767,8466,'hi','à¤•à¤¾à¤® à¤¶à¥à¤°à¥‚ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(304768,8466,'ms','Memulakan kerja',0),(304769,8466,'ar','Ø¨Ø¯Ø£Øª Ø§Ù„Ø¹Ù…Ù„',0),(304770,8466,'fr','Travaux ont commencÃ©',0),(304771,8466,'jp','ä»•äº‹ã‚’å§‹ã‚ãŸ',0),(304772,8466,'pt','Trabalho comeÃ§ou',0),(304773,8466,'ru','ÐÐ°Ñ‡Ð°Ð» Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(304774,8466,'es','Trabajo Comenzado',0),(304775,8466,'de','Running Arbeit',0),(304776,8466,'en','Started Work',0),(304777,8467,'is','',0),(304778,8467,'dr','( Ø§Ø³ØªØ±Ø§Ø­Øª',0),(304779,8467,'pr','Ø´Ø±ÙˆØ¹ Ù…Ù‡Ù„Øª ( Ø§Ø³ØªØ±Ø§Ø­Øª',0),(304780,8467,'tr','BaÅŸlat ara',0),(304781,8467,'pl','PoczÄ…tek przerwy',0),(304782,8467,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð¿Ð¾Ñ‡Ð¸Ð²ÐºÐ°Ñ‚Ð°',0),(304783,8467,'ur','ØªÙˆÚ‘ Ø´Ø±ÙˆØ¹',0),(304784,8467,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð¿Ð°ÑƒÐ·Ðµ',0),(304785,8467,'vi','Báº¯t Ä‘áº§u chia',0),(304786,8467,'af','Begin breek',0),(304787,8467,'ro','ÃŽncepe sÄƒ pauzÄƒ',0),(304788,8467,'et','Alusta vaheaega',0),(304789,8467,'si','ZaÄetek odmor',0),(304790,8467,'ba','Mulai istirahat',0),(304791,8467,'nl','Start Break',0),(304792,8467,'fi','Aloita tauko',0),(304793,8467,'no','Start pause',0),(304794,8467,'da','Start pause',0),(304795,8467,'ko','ë°©í•™ ì‹œìž‘',0),(304796,8467,'he','×”×ª×—×œ×” ×˜×•×‘×”',0),(304797,8467,'el','ÎˆÎ½Î±ÏÎ¾Î· Î´Î¹Î¬Î»ÎµÎ¹Î¼Î¼Î±',0),(304798,8467,'zh','å¼€å§‹æ‰“ç ´\r\n',0),(304799,8467,'sv','BÃ¶rja bryta',0),(304800,8467,'it','Iniziare la pausa',0),(304801,8467,'tl','',0),(304802,8467,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3627;&#3618;&#3640;&#3604;',0),(304803,8467,'hi','à¤¤à¥‹à¤¡à¤¼ à¤¶à¥à¤°à¥‚',0),(304804,8467,'ms','Mula cuti',0),(304805,8467,'ar','ÙØ§ØµÙ„ Ø§Ø¨Ø¯Ø£',0),(304806,8467,'fr','Lancer Break',0),(304807,8467,'jp','ãƒ–ãƒ¬ãƒ¼ã‚¯ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(304808,8467,'pt','ComeÃ§ar a pausa',0),(304809,8467,'ru','ÐÐ°Ñ‡Ð°Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÑ€Ñ‹Ð²',0),(304810,8467,'es','Comenzar Descanso',0),(304811,8467,'de','Start-Pause',0),(304812,8467,'en','Start Break',0),(304813,8468,'is','',0),(304814,8468,'dr','Ø´Ø±ÙˆØ¹ ÙƒØ§Ø±',0),(304815,8468,'pr','Ø´Ø±ÙˆØ¹ ÙƒØ§Ø±',0),(304816,8468,'tr','Ä°ÅŸe baÅŸlamak',0),(304817,8468,'pl','RozpoczÄ™cie prac',0),(304818,8468,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(304819,8468,'ur','Ú©Ø§Ù… Ø´Ø±ÙˆØ¹ Ú©Ø±ÛŒÚº',0),(304820,8468,'sr','ÐŸÐ¾Ñ‡Ð½ÐµÐ¼ Ð´Ð° Ñ€Ð°Ð´Ð¸Ð¼',0),(304821,8468,'vi','Báº¯t Ä‘áº§u lÃ n viá»‡c',0),(304822,8468,'af','Begin Werk',0),(304823,8468,'ro','ÃŽncepe munca',0),(304824,8468,'et','Alusta tÃ¶Ã¶d',0),(304825,8468,'si','ZaÄetek dela',0),(304826,8468,'ba','Mulai bekerja',0),(304827,8468,'nl','Aan de slag',0),(304828,8468,'fi','Aloittaa tyÃ¶nsÃ¤',0),(304829,8468,'no','Starte arbeidet',0),(304830,8468,'da','Begynde at arbejde',0),(304831,8468,'ko','ì‹œìž‘ ìž‘ì—…',0),(304832,8468,'he','×œ×”×ª×—×™×œ ×œ×¢×‘×•×“',0),(304833,8468,'el','ÎˆÎ½Î±ÏÎ¾Î· ÎµÏÎ³Î±ÏƒÎ¹ÏŽÎ½',0),(304834,8468,'zh','å¼€å§‹å·¥ä½œ\r\n',0),(304835,8468,'sv','BÃ¶rja arbeta',0),(304836,8468,'it','Iniziare il lavoro',0),(304837,8468,'tl','',0),(304838,8468,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3591;&#3634;&#3609;',0),(304839,8468,'hi','à¤•à¤¾ à¤•à¤¾à¤® à¤¶à¥à¤°à¥‚',0),(304840,8468,'ms','Memulakan kerja',0),(304841,8468,'ar','Ø¨Ø¯Ø¡ Ø§Ù„Ø¹Ù…Ù„',0),(304842,8468,'fr','DÃ©but de travail',0),(304843,8468,'jp','ä½œæ¥­ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(304844,8468,'pt','ComeÃ§ar a trabalhar',0),(304845,8468,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(304846,8468,'es','Comenzar el Trabajo',0),(304847,8468,'de','Arbeit beginnen',0),(304848,8468,'en','Start Work',0),(304849,8469,'is','',0),(304850,8469,'dr','Ù†Ù…Ø§ÙŠØ´ Ø²Ù…Ø§Ù† Ù‡Ø§ÙŠ Ù…Ù† ',0),(304851,8469,'pr','Ù†Ù…Ø§ÙŠØ´ Ø²Ù…Ø§Ù† Ù‡Ø§ÙŠ Ù…Ù† ',0),(304852,8469,'tr','Benim sÃ¼releri gÃ¶rÃ¼ntÃ¼lemek',0),(304853,8469,'pl','Zobacz mÃ³j razy',0),(304854,8469,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¼Ð¸ Ð¿ÑŠÑ‚Ð¸',0),(304855,8469,'ur','Ø§Ù¾Ù†ÛŒ Ø§ÙˆÙ‚Ø§Øª Ø¯ÛŒÚ©Ú¾',0),(304856,8469,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¼Ð¾Ð³ Ð¿ÑƒÑ‚Ð°',0),(304857,8469,'vi','Xem thá»i gian cá»§a tÃ´i',0),(304858,8469,'af','Besigtig My Tye',0),(304859,8469,'ro','Vezi mea ori',0),(304860,8469,'et','Vaata minu korda',0),(304861,8469,'si','Poglej si svoj Äas',0),(304862,8469,'ba','Lihat saya kali',0),(304863,8469,'nl','Mijn tijden weergeven',0),(304864,8469,'fi','Katso minun kertaa',0),(304865,8469,'no','Vis mine tider',0),(304866,8469,'da','Se min gange',0),(304867,8469,'ko','ë‚´ ì‹œê°„ì„ ë³¼',0),(304868,8469,'he','×”×¦×’ ×©×œ×™ ×¤×¢×ž×™×',0),(304869,8469,'el','Î”ÎµÏ‚ ÏƒÏ„Î¹Î³Î¼Î­Ï‚ Î¼Î¿Ï…',0),(304870,8469,'zh','æŸ¥çœ‹æˆ‘çš„æ—¶é—´\r\n',0),(304871,8469,'sv','Visa min gÃ¥nger',0),(304872,8469,'it','Mostra il mio volte',0),(304873,8469,'tl','',0),(304874,8469,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(304875,8469,'hi','à¤®à¥‡à¤°à¥€ à¤¬à¤¾à¤° à¤¦à¥‡à¤–à¥‡à¤‚',0),(304876,8469,'ms','Melihat saya Times',0),(304877,8469,'ar','Ø¹Ø±Ø¶ Ø¨Ù„Ø¯ÙŠ Ù…Ø±Ø§Øª',0),(304878,8469,'fr','DÃ©couvre ma fois',0),(304879,8469,'jp','ç§ã®æ™‚é–“ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(304880,8469,'pt','Ver os meus tempos',0),(304881,8469,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐœÐ¾Ñ‘ Ð’Ñ€ÐµÐ¼Ñ',0),(304882,8469,'es','Visionar Mis Tiempos',0),(304883,8469,'de','Meine Zeiten anzeigen',0),(304884,8469,'en','View My Times',0),(304885,8470,'is','',0),(304886,8470,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú†Ù‡ ØªØ§Ø±ÙŠØ®ÙŠ Ø¨Ø±Ø§ÙŠ ØªØ¹ÙŠÙŠÙ† Ø§ÙŠÙ†ÙƒÙ‡ Ø§Ú¯Ø± Ø§Ø² ØªØ§Ø±ÙŠØ® Ú¯Ø°Ø´ØªÙ‡ Ùˆ ØªØ¹Ø¯Ø§Ø¯ Ø±ÙˆØ²Ù‡Ø§ÙŠ Ú¯Ø°Ø´ØªÙ‡ ',0),(304887,8470,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú†Ù‡ ØªØ§Ø±ÙŠØ®ÙŠ Ø¨Ø±Ø§ÙŠ ØªØ¹ÙŠÙŠÙ† Ø§ÙŠÙ†ÙƒÙ‡ Ø§Ú¯Ø± Ø§Ø² ØªØ§Ø±ÙŠØ® Ú¯Ø°Ø´ØªÙ‡ Ùˆ ØªØ¹Ø¯Ø§Ø¯ Ø±ÙˆØ²Ù‡Ø§ÙŠ Ú¯Ø°Ø´ØªÙ‡ ',0),(304888,8470,'tr','Tarihini belirleme, vadesi geÃ§miÅŸ ve sayÄ±, gÃ¼n boyunca kullanÄ±n',0),(304889,8470,'pl','KtÃ³ra data wykorzystania OkreÅ›lanie jeÅ›li zalegÅ‚ych i numer z dni na',0),(304890,8470,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÐºÐ¾ÑÑ‚Ð¾ Ð´Ð°Ñ‚Ð° Ð·Ð° Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»Ñ Ð°ÐºÐ¾ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸ Ð¸ Ð±Ñ€Ð¾ÑÑ‚ Ð½Ð° Ð´Ð½Ð¸ Ð½Ð°Ð´',0),(304891,8470,'ur','Ø¬Ùˆ ØªØ§Ø±ÛŒØ® Ø§Ú¯Ø± Ù…ÙˆØ®Ø± Ø¯ÛŒÙ¹Ø±Ù…Ø§Ù†Ø§Ù†Ú¯ Ø§ÙˆØ± Ù†Ù…Ø¨Ø± Ú©Û’ Ø§ÛŒØ§Ù… Ù¾Ø± Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(304892,8470,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÐºÐ¾Ñ˜Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð° Ð”ÐµÑ‚ÐµÑ€Ð¼Ð¸Ð½Ð¸Ð½Ð³ Ð°ÐºÐ¾ ÐºÐ°ÑÐ½Ðµ Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð¾Ð´ Ð´Ð°Ð½Ð° Ð¿Ñ€ÐµÐºÐ¾',0),(304893,8470,'vi','DÃ¹ng ngÃ y nÃ o Ä‘á»ƒ xÃ¡c Ä‘á»‹nh quÃ¡ háº¡n & sá»‘ ngÃ y quÃ¡',0),(304894,8470,'af','Gebruik Watter Datum om te Bepaal indien Agterstallig is en Aantal Dae \"Over\"',0),(304895,8470,'ro','UtilizaÅ£i care data pentru determinarea dacÄƒ restante ÅŸi numÄƒrul de zile peste',0),(304896,8470,'et','Mis kuupÃ¤eva kasutamiseks Determining kui mÃ¶Ã¶das ja arvu kohta pÃ¤eva jooksul',0),(304897,8470,'si','Uporabite katerega datuma za doloÄanje, Äe je zapadla in Å¡tevilko od dni nad',0),(304898,8470,'ba','Menggunakan tanggal yang untuk menentukan jika terlambat dan nomor dari hari atas',0),(304899,8470,'nl','Die datum gebruiken voor vaststellen als te laat en nummer van dagen Over',0),(304900,8470,'fi','KÃ¤yttÃ¤Ã¤ joka pÃ¤ivÃ¤ mÃ¤Ã¤rittÃ¤vÃ¤llÃ¤ jos myÃ¶hÃ¤ssÃ¤ ja monta pÃ¤ivÃ¤Ã¤ yli',0),(304901,8470,'no','Bruk som dato for Determining hvis forfalt og antallet av dager Over',0),(304902,8470,'da','Bruge som dato for besluttende hvis forfaldne og antallet af dage Over',0),(304903,8470,'ko','ì–´ë–¤ ë‚ ì§œë¥¼ ì‚¬ìš© í•˜ ì—¬ ì—°ì²´ í•˜ëŠ” ê²½ìš° ê²°ì • í•˜ ê³  ìˆ˜ì˜ ì¼ì— ëŒ€ í•œ',0),(304904,8470,'he','×œ×©×™×ž×•×© ××©×¨ ×”×ª××¨×™×š ×”×§×•×‘×¢ ×× ×—×œ×£ ×•×©×•×‘ ×ž×¡×¤×¨ ×©×œ ×™×ž×™×',0),(304905,8470,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€ Ï€ÏÎ¿ÏƒÎ´Î¹Î¿ÏÎ¹ÏƒÎ¼ÏŒÏ‚ ÎµÎ¬Î½ ÎºÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ®ÏƒÎµÎ¹ ÎºÎ±Î¹ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Ï‰Î½ Î·Î¼ÎµÏÏŽÎ½ ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î¬ÏÎºÎµÎ¹Î±',0),(304906,8470,'zh','ä½¿ç”¨ä¸€ä¸ªæ—¥æœŸä»¥ä¾¿ç¡®å®šé¡¹ç›®æ˜¯å¦é€¾æœŸåŠé€¾æœŸå¤©æ•°\r\n',0),(304907,8470,'sv','AnvÃ¤nda som datum fÃ¶r beslutande om fÃ¶rfallna och numrera av dagar Ã¶ver',0),(304908,8470,'it','Utilizzare Data che per stabilire se Ã¨ in ritardo e numero di giorni sopra',0),(304909,8470,'tl','',0),(304910,8470,'th','Use Which Date for Determining if Overdue and Number of Days Over',0),(304911,8470,'hi','à¤¯à¤¦à¤¿ à¤µà¤¿à¤²à¤‚à¤¬à¤¿à¤¤ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤”à¤° à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤¦à¤¿à¤¨à¥‹à¤‚ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(304912,8470,'ms','Gunakan tarikh yang Determining jika tunggakan dan bilangan hari ke atas',0),(304913,8470,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… \"Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø°ÙŠ\" Ù„ØªØ­Ø¯ÙŠØ¯ Ø¥Ø°Ø§ ØªØ£Ø®Ø±ØªØŒ ÙˆØ¹Ø¯Ø¯ Ø£ÙŠØ§Ù… Ø£ÙƒØ«Ø±',0),(304914,8470,'fr','Utiliser qui Date pour dÃ©terminer si en retard et nombre de jours au cours',0),(304915,8470,'jp','å»¶æ»žã®å ´åˆã®æ±ºå®šãŠã‚ˆã³æ•°ã®æ—¥ä»¥ä¸Šã®æ—¥ä»˜ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(304916,8470,'pt','Usar data que por determinaÃ§Ã£o se em atraso e o nÃºmero de dias sobre',0),(304917,8470,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ñ… Ð´Ð°Ñ‚Ñ‹ Ð´Ð»Ñ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ ÐµÑÐ»Ð¸ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ð¸ Ñ‡Ð¸ÑÐ»Ð¾ Ð´Ð½ÐµÐ¹ Ð½Ð°Ð´',0),(304918,8470,'es','Usar Cual Fecha para Determinar si es Postergado y NÃºmero de DÃ­as Demorosos',0),(304919,8470,'de','Verwenden Sie das Datum fÃ¼r bestimmen Wenn Ã¼berfÃ¤llig und Anzahl der Tage Ã¼ber',0),(304920,8470,'en','Use Which Date for Determining if Overdue and Number of Days Over',0),(304921,8471,'is','',0),(304922,8471,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø³Øª Ø´Ø¯Ù‡ ',0),(304923,8471,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø³Øª Ø´Ø¯Ù‡ ',0),(304924,8471,'tr','Deftere nakledilen giriÅŸleri',0),(304925,8471,'pl','ZaksiÄ™gowane zapisy',0),(304926,8471,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(304927,8471,'ur','Ø§Ø´ØªÛØ§Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(304928,8471,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(304929,8471,'vi','BÃºt toÃ¡n ÄÃ£ káº¿t chuyá»ƒn',0),(304930,8471,'af','Geposde Inskrywings',0),(304931,8471,'ro','IntrÄƒrile Ã®nregistrate',0),(304932,8471,'et','Konteeritud kanded',0),(304933,8471,'si','KnjiÅ¾ene postavke',0),(304934,8471,'ba','Posted entri',0),(304935,8471,'nl','Geboekte posten',0),(304936,8471,'fi','Kirjatut tapahtumat',0),(304937,8471,'no','BokfÃ¸rte poster',0),(304938,8471,'da','BogfÃ¸rte poster',0),(304939,8471,'ko','ê²Œì‹œ ëœ í•­ëª©',0),(304940,8471,'he','×¢×¨×›×™ ×¤×•×¨×¡×',0),(304941,8471,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(304942,8471,'zh','å‘å¸ƒæ¡ç›®\r\n',0),(304943,8471,'sv','BokfÃ¶rda transaktioner',0),(304944,8471,'it','Movimenti registrati',0),(304945,8471,'tl','',0),(304946,8471,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3592;&#3634;&#3585;&#3626;&#3617;&#3640;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(304947,8471,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(304948,8471,'ms','Penyertaan yang dihantar',0),(304949,8471,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª ØªÙ… Ù†Ø´Ø±Ø©',0),(304950,8471,'fr','Ã‰critures validÃ©es',0),(304951,8471,'jp','æŽ²ç¤ºã•ã‚Œã‚‹ã‚¨ãƒ³ãƒˆãƒª',0),(304952,8471,'pt','Movimentos registados',0),(304953,8471,'ru','Ð£Ñ‡Ñ‚ÐµÐ½Ð½Ñ‹Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(304954,8471,'es','Entradas Asentadas',0),(304955,8471,'de','Gebuchten Posten',0),(304956,8471,'en','Posted Entries',0),(304957,8472,'is','',0),(304958,8472,'dr','ØªØ¹ÙŠÙŠÙ† Ù†Ø´Ø¯Ù‡ ',0),(304959,8472,'pr','ØªØ¹ÙŠÙŠÙ† Ù†Ø´Ø¯Ù‡ ',0),(304960,8472,'tr','TanÄ±msÄ±z',0),(304961,8472,'pl','Niezdefiniowany',0),(304962,8472,'bg','ÐÐµÐ´ÐµÑ„Ð¸Ð½Ð¸Ñ€Ð°Ð½Ð°',0),(304963,8472,'ur','ØºÛŒØ± ÙˆØ¶Ø§Ø­ØªÛŒ',0),(304964,8472,'sr','ÐÐµÐ´ÐµÑ„Ð¸Ð½Ð¸ÑÐ°Ð½Ð°',0),(304965,8472,'vi','ChÆ°a Ä‘á»‹nh nghÄ©a',0),(304966,8472,'af','Ongedefinieerd',0),(304967,8472,'ro','Nedefinit',0),(304968,8472,'et','MÃ¤Ã¤ratlemata',0),(304969,8472,'si','Undefined',0),(304970,8472,'ba','Terdefinisi',0),(304971,8472,'nl','Undefined',0),(304972,8472,'fi','MÃ¤Ã¤rittelemÃ¤tÃ¶n',0),(304973,8472,'no','Udefinert',0),(304974,8472,'da','Udefineret',0),(304975,8472,'ko','ì •ì˜ ë˜ì§€ ì•Šì€',0),(304976,8472,'he','×œ× ×ž×•×’×“×¨',0),(304977,8472,'el','Î‘Ï€ÏÎ¿ÏƒÎ´Î¹ÏŒÏÎ¹ÏƒÏ„Î¿',0),(304978,8472,'zh','æœªå®šä¹‰\r\n',0),(304979,8472,'sv','Odefinierad',0),(304980,8472,'it','Non definito',0),(304981,8472,'tl','',0),(304982,8472,'th','&#3652;&#3617;&#3656;&#3585;&#3635;&#3627;&#3609;&#3604;',0),(304983,8472,'hi','à¤…à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¿à¤¤',0),(304984,8472,'ms','Undefined',0),(304985,8472,'ar','ØºÙŠØ± Ù…Ø¹Ø±Ù',0),(304986,8472,'fr','Non dÃ©fini',0),(304987,8472,'jp','æœªå®šç¾©',0),(304988,8472,'pt','Indefinido',0),(304989,8472,'ru','ÐÐµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¾',0),(304990,8472,'es','Indefinido',0),(304991,8472,'de','Nicht definiert',0),(304992,8472,'en','Undefined',0),(304993,8473,'is','',0),(304994,8473,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ ',0),(304995,8473,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø³Øª Ù†Ø´Ø¯Ù‡ ',0),(304996,8473,'tr','Deftere nakledilmemiÅŸ giriÅŸleri',0),(304997,8473,'pl','NiezaksiÄ™gowanych zapisÃ³w',0),(304998,8473,'bg','ÐÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(304999,8473,'ur','Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(305000,8473,'sr','ÐÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(305001,8473,'vi','BÃºt toÃ¡n chÆ°a káº¿t chuyá»ƒn',0),(305002,8473,'af','Ongeposde Inskrywings',0),(305003,8473,'ro','IntrÄƒrile de neÃ®nregistrate',0),(305004,8473,'et','Sisestamata kanded',0),(305005,8473,'si','Neobjavljene postavke',0),(305006,8473,'ba','Unposted entri',0),(305007,8473,'nl','Niet-geboekte posten',0),(305008,8473,'fi','Kirjaamattomat tapahtumat',0),(305009,8473,'no','Ikke-bokfÃ¸rte poster',0),(305010,8473,'da','Ikke-bogfÃ¸rte poster',0),(305011,8473,'ko','ê²Œì‹œ ë˜ì§€ ì•Šì€ í•­ëª©',0),(305012,8473,'he','×¢×¨×›×™× ×©×œ× × ×¨×©×ž×•',0),(305013,8473,'el','ÎŸÎ¹ Î¼Î· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(305014,8473,'zh','æœªå‘å¸ƒçš„æ¡ç›®\r\n',0),(305015,8473,'sv','BokfÃ¶rda transaktioner',0),(305016,8473,'it','Voci registrate',0),(305017,8473,'tl','',0),(305018,8473,'th','&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657;',0),(305019,8473,'hi','Unposted à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(305020,8473,'ms','Entri unposted',0),(305021,8473,'ar','Ø§Ù„Ù‚ÙŠÙˆØ¯ Ø§Ù„ØºÙŠØ± Ù…Ø±Ø­Ù‘Ù„Ø©',0),(305022,8473,'fr','Ã‰critures non validÃ©es',0),(305023,8473,'jp','æœªé€ä¿¡ã®ã‚¨ãƒ³ãƒˆãƒª',0),(305024,8473,'pt','Entradas nÃ£o lanÃ§adas',0),(305025,8473,'ru','ÐÐµÐ¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð—Ð°Ð¿Ð¸ÑÐ¸',0),(305026,8473,'es','Entradas No Asentadas',0),(305027,8473,'de','Ungebuchte EintrÃ¤ge',0),(305028,8473,'en','Unposted Entries',0),(305029,8474,'is','',0),(305030,8474,'dr','- Ø¬Ù†Ø³Ù‡Ø§ÙŠ Ù…Ù†ØªØ®Ø¨',0),(305031,8474,'pr','ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ- ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…Ù†ØªØ®Ø¨',0),(305032,8474,'tr','TimeClock parÃ§a baÅŸÄ± iÅŸ eylemler - seÃ§im Ã¶ÄŸeleri',0),(305033,8474,'pl','TimeClock akord dziaÅ‚aÅ„ - wybÃ³r elementÃ³w',0),(305034,8474,'bg','TimeClock Ð¿Ð°Ñ€Ñ‡Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ - Ð¸Ð·Ð±Ð¾Ñ€ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(305035,8474,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ø¹Ù…Ù„ - Ø§Ù†ØªØ®Ø§Ø¨ Ø§Ø´ÛŒØ§Ø¡',0),(305036,8474,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ñ€Ð°Ð´ÑšÐµ - Ð¾Ð´Ð°Ð±Ð¸Ñ€ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(305037,8474,'vi','HÃ nh Ä‘á»™ng giá» khoÃ¡n - HÃ ng chá»n',0),(305038,8474,'af','Tydklok Stukwerk Aksies - Geselekteerde Items',0),(305039,8474,'ro','Ceas acord acÅ£iuni - elemente de selecÅ£ie',0),(305040,8474,'et','TimeClock tÃ¼kitÃ¶Ã¶ tegevused - valitud Ã¼ksused',0),(305041,8474,'si','Akord TimeClock akcije - izbor elementov',0),(305042,8474,'ba','Timeclock Piecework tindakan - item pilihan',0),(305043,8474,'nl','Klok stukloon acties - selectie Items',0),(305044,8474,'fi','Timeclock urakkatyÃ¶n toiminnot - valinta kohteita',0),(305045,8474,'no','TimeClock stykkavlÃ¸nning handlinger - utvalg elementer',0),(305046,8474,'da','Timeclock akkordarbejde handlinger - udvalg elementer',0),(305047,8474,'ko','Timeclock Piecework ìž‘ì—…-ì„ íƒ í•­ëª©',0),(305048,8474,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª Timeclock ×¤×¢×•×œ×•×ª - ×ž×‘×—×¨ ×¤×¨×™×˜×™×',0),(305049,8474,'el','Î”ÏÎ¬ÏƒÎµÎ¹Ï‚ Timeclock ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ - ÎµÏ€Î¹Î»Î¿Î³Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(305050,8474,'zh','æ—¶é’Ÿè®¡ä»¶è¡ŒåŠ¨ -é€‰æµ‹é¡¹ç›®\r\n',0),(305051,8474,'sv','Timeclock ackord Ã¥tgÃ¤rder - poster',0),(305052,8474,'it','A cottimo Timeclock azioni - selezione oggetti',0),(305053,8474,'tl','',0),(305054,8474,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3591;&#3634;&#3',0),(305055,8474,'hi','Timeclock Piecework à¤•à¥à¤°à¤¿à¤¯à¤¾ - à¤šà¤¯à¤¨ à¤†à¤‡à¤Ÿà¤®',0),(305056,8474,'ms','Tindakan Timeclock Piecework - item-item pilihan',0),(305057,8474,'ar','Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ-Ø§Ù†ØªÙ‚Ø§Ø¡ Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(305058,8474,'fr','Travail Ã  la piÃ¨ce Timeclock Actions - Ã©lÃ©ments de choix',0),(305059,8474,'jp','å‡ºæ¥é«˜æ‰•ã„ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ - é¸æŠžã•ã‚ŒãŸé …ç›®',0),(305060,8474,'pt','Trabalho por tarefa timeclock aÃ§Ãµes - seleÃ§Ã£o de itens',0),(305061,8474,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½Ð°Ñ TimeClock Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ - Ð²Ñ‹Ð±Ð¾Ñ€ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð¾Ð²',0),(305062,8474,'es','Reloj Checador Acciones de Trabajo por Pieza - Items de SelecciÃ³n',0),(305063,8474,'de','Timeclock Akkordarbeit Aktionen - Auswahlelemente',0),(305064,8474,'en','Timeclock Piecework Actions - Selection Items',0),(305065,8475,'is','',0),(305066,8475,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ† ÙƒØ§Ø±Ø¨Ø± â€“ Ù†Ø±Ø® Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(305067,8475,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ† ÙƒØ§Ø±Ø¨Ø± â€“ Ù†Ø±Ø® Ø«Ø¨Øª Ø´Ø¯Ù‡ ',0),(305068,8475,'tr','KullanÄ±cÄ± tarafÄ±ndan girilen oranÄ± saÄŸlar',0),(305069,8475,'pl','UmoÅ¼liwiÄ‡ szybkoÅ›Ä‡ wprowadzonych przez uÅ¼ytkownika',0),(305070,8475,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚, Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸ Ð¾Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ',0),(305071,8475,'ur','ØµØ§Ø±Ù Ø¯Ø§Ø®Ù„ Ú©ÛŒ Ø´Ø±Ø­ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(305072,8475,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº ÑƒÐ½ÐµÐ¾ ÑÑ‚Ð¾Ð¿Ð°',0),(305073,8475,'vi','Cho PhÃ©p GiÃ¡ Cá»§a NgÆ°á»i Sá»­ Dá»¥ng',0),(305074,8475,'af','Toegelate Gebruiker - Ingevoerde Tarief',0),(305075,8475,'ro','Permite rata de introdus de utilizator',0),(305076,8475,'et','Luba kasutaja sisestatud mÃ¤Ã¤r',0),(305077,8475,'si','Dovoli uporabniÅ¡ko vnesenimi stopnja',0),(305078,8475,'ba','Memungkinkan pengguna masuk suku',0),(305079,8475,'nl','Toestaan dat gebruiker ingevoerde tarief',0),(305080,8475,'fi','Sallittava kÃ¤yttÃ¤jÃ¤n',0),(305081,8475,'no','Tillat brukerdefinerte Rate',0),(305082,8475,'da','Tillad brugerindtastet sats',0),(305083,8475,'ko','ì‚¬ìš©ìžê°€ ìž…ë ¥ í•œ ë¹„ìœ¨ì„ í—ˆìš©',0),(305084,8475,'he','×œ××¤×©×¨ ×§×¦×‘ ×©×”×–×™×Ÿ ×”×ž×©×ª×ž×©',0),(305085,8475,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³ÎµÎ¹ Î¿ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚',0),(305086,8475,'zh','å…è®¸ç”¨æˆ·è¾“å…¥çš„æ¯”ä¾‹\r\n',0),(305087,8475,'sv','Medge anvÃ¤ndarsparad',0),(305088,8475,'it','Consentire il tasso immesso dall\'utente',0),(305089,8475,'tl','',0),(305090,8475,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3648;&#3586;&#3657;&#3634;&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3652;&#3604;&#3657;',0),(305091,8475,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¦à¤°à¥à¤œ à¤•à¥€ à¤¦à¤° à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(305092,8475,'ms','Membolehkan kadar pengguna-dimasukkan.',0),(305093,8475,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø¹Ø¯Ù„',0),(305094,8475,'fr','Permettre Ã  taux d\'entrÃ©es par l\'utilisateur',0),(305095,8475,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ãŒå…¥åŠ›ã—ãŸãƒ¬ãƒ¼ãƒˆã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(305096,8475,'pt','Permitir que a taxa de inserido pelo usuÃ¡rio',0),(305097,8475,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð²Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ð¹ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¼ ÑÐºÐ¾Ñ€Ð¾ÑÑ‚ÑŒ',0),(305098,8475,'es','Permitir Tasa de Entrada-Usuario',0),(305099,8475,'de','Gestatten Sie, dass einem Benutzer eingegebenen',0),(305100,8475,'en','Allow User-Entered Rate',0),(305101,8476,'is','',0),(305102,8476,'dr','* Ù†Ø±Ø® ( Ø§Ú¯Ø± Ø¨Ù„Ù‡',0),(305103,8476,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø§ÙŠÙ‡ * Ù†Ø±Ø® ( Ø§Ú¯Ø± Ø¨Ù„Ù‡',0),(305104,8476,'tr','Baz miktarÄ± x oran eÄŸer (Evet)',0),(305105,8476,'pl','Podstawy iloÅ›Ä‡ x cena (jeÅ›li tak)',0),(305106,8476,'bg','Ð‘Ð°Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ… ÑÑ‚Ð°Ð²ÐºÐ° (Ð°ÐºÐ¾ Ð´Ð°)',0),(305107,8476,'ur','Ù…Ù‚Ø¯Ø§Ø± Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ (ÛØ§Úº Ø§Ú¯Ø±) Ú©ÛŒ Ø´Ø±Ø­ x',0),(305108,8476,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° x ÑÑ‚Ð¾Ð¿Ð° (Ð°ÐºÐ¾ Ð´Ð°)',0),(305109,8476,'vi','Sá»‘ lÆ°á»£ng gá»‘c x GiÃ¡ (náº¿u yes)',0),(305110,8476,'af','Basis Hoeveelheid x Tarief (indien ja)',0),(305111,8476,'ro','Cantitatea de bazÄƒ x rata (daca da)',0),(305112,8476,'et','Baasi kogus x (kui jah)',0),(305113,8476,'si','Osnove koliÄina x hitrost (Äe je)',0),(305114,8476,'ba','Dasar kuantitas x Rate (jika ya)',0),(305115,8476,'nl','Hoeveelheid baseren x tarief (zo ja)',0),(305116,8476,'fi','Base mÃ¤Ã¤rÃ¤ x mÃ¤Ã¤rÃ¤ (Jos kyllÃ¤)',0),(305117,8476,'no','Basere antall x kurs (Hvis ja)',0),(305118,8476,'da','Basere antal x sats (hvis ja)',0),(305119,8476,'ko','ê¸°ë³¸ ìˆ˜ëŸ‰ ë¹„ìœ¨ (ê·¸ë ‡ë‹¤ë©´) x',0),(305120,8476,'he','×‘×¡×¡ ×›×ž×•×ª x ×©×™×¢×•×¨ (×× ×›×Ÿ)',0),(305121,8476,'el','Î’Î¬ÏƒÎ· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± x Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ (Î±Î½ Î½Î±Î¹)',0),(305122,8476,'zh','åŸºåœ°æ•°é‡xçŽ‡ï¼ˆè‹¥æœ‰ï¼‰\r\n',0),(305123,8476,'sv','Basera kvantitet x hastighet (om ja)',0),(305124,8476,'it','QuantitÃ  di base x tasso (se sÃ¬)',0),(305125,8476,'tl','',0),(305126,8476,'th','&#3600;&#3634;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;*&#3629;&#3633;&#3605;&#3619;&#3634; (&#3606;&#3657;&#3634;&#3651;&#3594;&#3656;)',0),(305127,8476,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤¾ à¤†à¤§à¤¾à¤° à¤¦à¤° à¤¯à¤¦à¤¿ (à¤¹à¤¾à¤) x',0),(305128,8476,'ms','Asas kuantiti x kadar (Jika ya)',0),(305129,8476,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„ÙƒÙ…ÙŠØ© Ã— Ø³Ø¹Ø± (Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ø¬ÙˆØ§Ø¨ Ù†Ø¹Ù…)',0),(305130,8476,'fr','QuantitÃ© de base x taux (si oui)',0),(305131,8476,'jp','åŸºæœ¬æ•°é‡ Ã— çŽ‡ ï¼ˆã¯ã„ã®å ´åˆ)',0),(305132,8476,'pt','Quantidade de base x taxa (se sim)',0),(305133,8476,'ru','Ð‘Ð°Ð·Ð¾Ð²Ñ‹Ð¹ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ x ÑÑ‚Ð°Ð²ÐºÐ° (ÐµÑÐ»Ð¸ Ð´Ð°)',0),(305134,8476,'es','Base Cantidad de x Tasa (si es si)',0),(305135,8476,'de','Basis-Menge x Preis (wenn ja)',0),(305136,8476,'en','Base Quantity x Rate (if yes)',0),(305137,8477,'is','',0),(305138,8477,'dr','Ù†Ø±Ø® Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(305139,8477,'pr','Ù†Ø±Ø® Ù¾ÙŠØ´ ÙØ±Ø¶ ',0),(305140,8477,'tr','VarsayÄ±lan fiyat',0),(305141,8477,'pl','Domyslnie',0),(305142,8477,'bg','ÐÐ°ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»Ð½Ð° Ð»Ð¸Ñ…Ð²Ð°',0),(305143,8477,'ur','Ø·Û’ Ø´Ø¯Û Ø´Ø±Ø­',0),(305144,8477,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ ÑÑ‚Ð¾Ð¿Ð°',0),(305145,8477,'vi','GiÃ¡ Máº·c Ä‘á»‹nh',0),(305146,8477,'af','Verstekte Koers',0),(305147,8477,'ro','Rata implicitÄƒ',0),(305148,8477,'et','VaikemÃ¤Ã¤r',0),(305149,8477,'si','Zamudne obresti',0),(305150,8477,'ba','Tingkat default',0),(305151,8477,'nl','Standaardtarief',0),(305152,8477,'fi','Oletusarvo',0),(305153,8477,'no','Standard hastighet',0),(305154,8477,'da','Standard sats',0),(305155,8477,'ko','ê¸°ë³¸ ìš”ê¸ˆ',0),(305156,8477,'he','×©×¢×¨ ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(305157,8477,'el','Î•Ï€Î¹Ï„ÏŒÎºÎ¹Î¿ Ï…Ï€ÎµÏÎ·Î¼ÎµÏÎ¯Î±Ï‚',0),(305158,8477,'zh','è¿çº¦çŽ‡\r\n',0),(305159,8477,'sv','Standard kurs',0),(305160,8477,'it','Tasso di default',0),(305161,8477,'tl','',0),(305162,8477,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(305163,8477,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¦à¤°',0),(305164,8477,'ms','Kadar ingkar',0),(305165,8477,'ar','Ø³Ø¹Ø± Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(305166,8477,'fr','Taux de dÃ©faut',0),(305167,8477,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆçŽ‡',0),(305168,8477,'pt','Taxa padrÃ£o',0),(305169,8477,'ru','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(305170,8477,'es','Tasa por Defecto',0),(305171,8477,'de','Ausfallquote',0),(305172,8477,'en','Default Rate',0),(305173,8478,'is','',0),(305174,8478,'dr','ØªÙ‚Ø³ÙŠÙ… Ù…Ù‚Ø¯Ø§Ø± Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ú†Ù‡ Ù†Ø±Ø®ÙŠ Ù‚Ø¨Ù„Ø§ Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯Ù‡ ',0),(305175,8478,'pr','ØªÙ‚Ø³ÙŠÙ… Ù…Ù‚Ø¯Ø§Ø± Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ú†Ù‡ Ù†Ø±Ø®ÙŠ Ù‚Ø¨Ù„Ø§ Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯Ù‡ ',0),(305176,8478,'tr','MiktarÄ± ne tarafÄ±ndan oranÄ± uygulamadan Ã¶nce bÃ¶lÃ¼n.',0),(305177,8478,'pl','PodzieliÄ‡ iloÅ›Ä‡ przez co przed zastosowaniem stawki',0),(305178,8478,'bg','Ð Ð°Ð·Ð´ÐµÐ»ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð¾Ñ‚ Ñ‚Ð¾Ð²Ð°, ÐºÐ¾ÐµÑ‚Ð¾ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° ÑÐµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸ ÑÑ‚Ð°Ð²ÐºÐ°',0),(305179,8478,'ur','Ù…Ù‚Ø¯Ø§Ø± Ú©ÛŒØ§ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªÙ‚Ø³ÛŒÙ… Ú©ÛŒ Ø´Ø±Ø­ Ù„Ú¯Ø§Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„',0),(305180,8478,'sr','Ð¨Ñ‚Ð° Ð¿Ð¾Ð´ÐµÐ»Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ñ€Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ðµ ÑÑ‚Ð¾Ð¿Ð°',0),(305181,8478,'vi','Chia sá»‘ lÆ°á»£ng nÃ y theo cÃ¡i gÃ¬ trÆ°á»›c khi Ã¡p dá»¥ng giÃ¡',0),(305182,8478,'af','Verdeel Hoeveelheid deur Wat van tevore alvorens Koers Aangepas word.',0),(305183,8478,'ro','ÃŽmpÄƒrÅ£iÅ£i cantitatea de ce Ã®nainte de aplicarea ratei',0),(305184,8478,'et','Jagage kogus mida enne mÃ¤Ã¤ra',0),(305185,8478,'si','Razdelimo koliÄino kaj pred teÄaju',0),(305186,8478,'ba','Membagi kuantitas oleh apa sebelum menerapkan tingkat',0),(305187,8478,'nl','Verdelen hoeveelheid door wat voor tarief toe te passen',0),(305188,8478,'fi','Jakaa mÃ¤Ã¤rÃ¤ mitÃ¤ ennen soveltamisen',0),(305189,8478,'no','Dele antall hva fÃ¸r bruke',0),(305190,8478,'da','Opdele mÃ¦ngden af hvad fÃ¸r anvendelse af sats',0),(305191,8478,'ko','ë‚˜ëˆ„ì–´ ìˆ˜ëŸ‰ ì–´ë–¤ ìš”ê¸ˆì„ ì ìš© í•˜ê¸° ì „ì—',0),(305192,8478,'he','×ž×ª×—×œ×§ ×ž×” ×”×›×ž×•×ª ×œ×¤× ×™ ×”×—×œ×ª ×ª×¢×¨×™×£',0),(305193,8478,'el','Î”Î¹Î±Î¹ÏÎ­ÏƒÏ„Îµ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Ï€ÏŒ ÏŒ, Ï„Î¹ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎµÏ†Î±ÏÎ¼Î¿Î³Î® Ï„Î¿Ï… ÏƒÏ…Î½Ï„ÎµÎ»ÎµÏƒÏ„Î®',0),(305194,8478,'zh','ç”³è¯·åˆ©çŽ‡å‰ç”¨ä»€ä¹ˆæ•°é‡é™¤\r\n',0),(305195,8478,'sv','Dela kvantitet av vad innan kurs',0),(305196,8478,'it','Dividere la quantitÃ  di quello che prima di applicare il tasso',0),(305197,8478,'tl','',0),(305198,8478,'th','&#3649;&#3610;&#3656;&#3591;&#3626;&#3656;&#3623;&#3609;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3650;&#3604;&#3618;&#3629;&#3632;&#3652;&#3619;&#3585;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3629;&#3633;&#3605;&#3619;&#3634;',0),(305199,8478,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥à¤¯à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤µà¤¿à¤­à¤¾à¤œà¤¿à¤¤ à¤¦à¤° à¤²à¤¾à¤—à¥‚ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡',0),(305200,8478,'ms','Bahagi bahan apa sebelum menggunakan kadar',0),(305201,8478,'ar','ØªÙ‚Ø³ÙŠÙ… Ø§Ù„ÙƒÙ…ÙŠØ© Ø­Ø³Ø¨ Ù…Ø§ Ù‚Ø¨Ù„ ØªØ·Ø¨ÙŠÙ‚ Ù…Ø¹Ø¯Ù„',0),(305202,8478,'fr','Diviser la quantitÃ© par ce qu\'avant application du taux',0),(305203,8478,'jp','ä½•ã§ãƒ¬ãƒ¼ãƒˆã‚’é©ç”¨ã™ã‚‹å‰ã«æ•°é‡ã‚’å‰²ã‚‹',0),(305204,8478,'pt','Dividir a quantidade por que antes de aplicar a taxa',0),(305205,8478,'ru','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, Ñ‡Ñ‚Ð¾ Ð¿ÐµÑ€ÐµÐ´ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÐµÐ½Ð¸ÐµÐ¼ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(305206,8478,'es','Dividir la Cantidad por CuÃ¡l ante que Aplicar la Tasa',0),(305207,8478,'de','Teilen Sie Menge durch was vor der Anwendung Rate',0),(305208,8478,'en','Divide Quantity by What before Applying Rate',0),(305209,8479,'is','',0),(305210,8479,'dr','/ Ø®ÙŠØ± Ø§Ø³Øª ',0),(305211,8479,'pr','Ø§Ú¯Ø± Ù†ÙˆØ¹ ÙˆØ±ÙˆØ¯ÙŠ Ø¨Ù„Ù‡ / Ø®ÙŠØ± Ø§Ø³Øª ',0),(305212,8479,'tr','GiriÅŸ tÃ¼rÃ¼ Evet/HayÄ±r ise',0),(305213,8479,'pl','JeÅ›li dane wejÅ›ciowe typu tak/nie',0),(305214,8479,'bg','ÐÐºÐ¾ Ð²Ñ…Ð¾Ð´ Ñ‚Ð¸Ð¿ Ðµ Ð´Ð°/Ð½Ðµ',0),(305215,8479,'ur','Ø§Ú¯Ø± Ø§Ù† Ù¾Ù¹ Ú©ÛŒ Ù‚Ø³Ù… ÛØ§Úº/Ù†ÛÛŒÚº ÛÛ’ Û”',0),(305216,8479,'sr','ÐÐºÐ¾ Ñ˜Ðµ ÑƒÐ½Ð¾Ñ Ð²Ñ€ÑÑ‚Ð° Ð´Ð°/Ð½Ðµ',0),(305217,8479,'vi','Náº¿u loáº¡i nháº­p lÃ  CÃ³/KhÃ´ng',0),(305218,8479,'af','Indien insette tipe Ja/Nee',0),(305219,8479,'ro','DacÄƒ tipul de intrare este da/nu',0),(305220,8479,'et','Kui sisend on jah/ei',0),(305221,8479,'si','ÄŒe je vloÅ¾ek tipa da/ne',0),(305222,8479,'ba','Jika jenis Input ya tidak',0),(305223,8479,'nl','Als Input Type Ja/Nee',0),(305224,8479,'fi','Jos Input Type on kyllÃ¤/ei',0),(305225,8479,'no','Hvis Input Type er ja/nei',0),(305226,8479,'da','Hvis Input Type er ja/nej',0),(305227,8479,'ko','ìž…ë ¥ í˜•ì‹ì´ ì˜ˆ/ì•„ë‹ˆìš”',0),(305228,8479,'he','×× ×¡×•×’ ×”×§×œ×˜ ×”×•× ×›×Ÿ/×œ×',0),(305229,8479,'el','Î‘Î½ Î¿ Ï„ÏÏ€Î¿Ï‚ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… ÎµÎ¯Î½Î±Î¹ Î½Î±Î¹/ÏŒÏ‡Î¹',0),(305230,8479,'zh','å¦‚æžœè¾“å…¥ç±»åž‹ä¸ºæ˜¯/å¦\r\n',0),(305231,8479,'sv','Om Input av typen Ja/Nej',0),(305232,8479,'it','Se il tipo di Input Ã¨ SÃ¬/No',0),(305233,8479,'tl','',0),(305234,8479,'th','&#3606;&#3657;&#3634;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3648;&#3586;&#3657;&#3634;&#3588;&#3639;&#3629;&#3651;&#3594;&#3656;/&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;',0),(305235,8479,'hi','à¤¯à¤¦à¤¿ à¤‡à¤¨à¤ªà¥à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¹à¤¾à¤‚/à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(305236,8479,'ms','Jika jenis Input ya/tidak',0),(305237,8479,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† \"Ù†ÙˆØ¹ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„\" Ù†Ø¹Ù…/Ù„Ø§',0),(305238,8479,'fr','Si le Type d\'entrÃ©e est oui/non',0),(305239,8479,'jp','å…¥åŠ›åž‹ãŒã¯ã„/ã„ã„ãˆã®å ´åˆ',0),(305240,8479,'pt','Se o tipo de entrada Ã© sim/nÃ£o',0),(305241,8479,'ru','Ð•ÑÐ»Ð¸ Ñ‚Ð¸Ð¿ Ð²Ñ…Ð¾Ð´Ð½Ñ‹Ñ… Ð´Ð°Ð½Ð½Ñ‹Ñ… ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð´Ð°/Ð½ÐµÑ‚',0),(305242,8479,'es','Si Tipo de Input es Si/No',0),(305243,8479,'de','Input Type-ist-Ja/Nein',0),(305244,8479,'en','If Input Type is Yes/No',0),(305245,8480,'is','',0),(305246,8480,'dr','Ø§Ú¯Ø± ÙƒØ§Ø±Ø¨Ø± Ø§Ø±Ø²ÙŠØ§Ø¨ÙŠ Ø´ÙˆØ¯ â€“ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªÙˆØ¶ÙŠØ­ Ø¯Ø§Ø±Ø¯',0),(305247,8480,'pr','Ø§Ú¯Ø± ÙƒØ§Ø±Ø¨Ø± Ø§Ø±Ø²ÙŠØ§Ø¨ÙŠ Ø´ÙˆØ¯ â€“ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªÙˆØ¶ÙŠØ­ Ø¯Ø§Ø±Ø¯',0),(305248,8480,'tr','KullanÄ±cÄ± oranÄ±, aÃ§Ä±klama gerektirir',0),(305249,8480,'pl','JeÅ›li uÅ¼ytkownik stawki, wymagajÄ… wyjaÅ›nienia',0),(305250,8480,'bg','ÐÐºÐ¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» ÐºÑƒÑ€Ñ, Ð¸Ð·Ð¸ÑÐºÐ²Ð° Ð¾Ð±ÑÑÐ½ÐµÐ½Ð¸Ðµ',0),(305251,8480,'ur','Ø§Ú¯Ø± ØµØ§Ø±Ù Ú©ÛŒ Ø´Ø±Ø­ ÛÛ’ØŒ ÙˆØ¶Ø§Ø­Øª Ø·Ù„Ø¨',0),(305252,8480,'sr','ÐÐºÐ¾ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð¾Ñ†ÐµÐ½Ð¸Ð»Ð¸, Ð¾Ð±Ñ˜Ð°ÑˆÑšÐµÑšÐµ',0),(305253,8480,'vi','Náº¿u GiÃ¡ cá»§a NgÆ°á»i Sá»­ Dá»¥ng Cáº§n CÃ³ ChÃº Giáº£i',0),(305254,8480,'af','Indien Gebruiker Tarief, Verduideliking Benodig',0),(305255,8480,'ro','ÃŽn cazul Ã®n care rata de utilizator, necesita explicatii',0),(305256,8480,'et','Kui kasutaja Rate, vaja selgitust',0),(305257,8480,'si','ÄŒe uporabnik stopnje, zahtevajo pojasnila',0),(305258,8480,'ba','Jika pengguna menilai, memerlukan penjelasan',0),(305259,8480,'nl','Als gebruiker stem, vereisen uitleg',0),(305260,8480,'fi','Jos kÃ¤yttÃ¤jÃ¤n Luokitus edellyttÃ¤Ã¤ selitys',0),(305261,8480,'no','Hvis brukeren Rate, kreve forklaring',0),(305262,8480,'da','Hvis brugeren Vurder, krÃ¦ve forklaring',0),(305263,8480,'ko','ì‚¬ìš©ìž í‰ê°€, ì„¤ëª… í•„ìš”',0),(305264,8480,'he','×× ×”×ž×©×ª×ž×© ×œ×“×¨×’, ×œ×“×¨×•×© ×”×¡×‘×¨',0),(305265,8480,'el','Î‘Î½ Ï‡ÏÎ®ÏƒÏ„Î· Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ, Î±Ï€Î±Î¹Ï„Î¿ÏÎ½ ÎµÎ¾Î®Î³Î·ÏƒÎ·',0),(305266,8480,'zh','å¦‚æžœç”¨æˆ·çŽ‡ï¼Œéœ€è¦è§£é‡Š\r\n',0),(305267,8480,'sv','Om anvÃ¤ndaren BetygsÃ¤tt, krÃ¤ver fÃ¶rklaring',0),(305268,8480,'it','Se l\'utente vota, richiedono spiegazione',0),(305269,8480,'tl','',0),(305270,8480,'th','&#3606;&#3657;&#3634;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3629;&#3633;&#3605;&#3619;&#3634; ,&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(305271,8480,'hi','à¤¸à¥à¤ªà¤·à¥à¤Ÿà¥€à¤•à¤°à¤£ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥‹à¤¤à¥€ à¤¹à¥ˆ à¤¯à¤¦à¤¿ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¦à¥‡à¤‚,',0),(305272,8480,'ms','Jika pengguna Nilaikan, memerlukan penjelasan',0),(305273,8480,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ù…Ø¹Ø¯Ù„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ØŒ ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ Ø´Ø±Ø­',0),(305274,8480,'fr','Si l\'utilisateur note, besoin d\'explication',0),(305275,8480,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®çŽ‡ã¯å ´åˆã€ã¯ã€èª¬æ˜ŽãŒå¿…è¦',0),(305276,8480,'pt','Se a taxa de usuÃ¡rio, requerem explicaÃ§Ã£o',0),(305277,8480,'ru','Ð•ÑÐ»Ð¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ, Ñ‚Ñ€ÐµÐ±ÑƒÑŽÑ‚ Ð¾Ð±ÑŠÑÑÐ½ÐµÐ½Ð¸Ð¹',0),(305278,8480,'es','Si Tasa de Usuario, Se Requiere ExplicaciÃ³n',0),(305279,8480,'de','Wenn Benutzer bewerten, sind ErlÃ¤uterungen erforderlich.',0),(305280,8480,'en','If User Rate, Require Explanation',0),(305281,8481,'is','',0),(305282,8481,'dr','( ÙˆØ±ÙˆØ¯ÙŠ',0),(305283,8481,'pr','Ù†ÙˆØ¹ Ø¯Ø§Ø¯Ù‡ ( ÙˆØ±ÙˆØ¯ÙŠ',0),(305284,8481,'tr','GiriÅŸ tÃ¼rÃ¼',0),(305285,8481,'pl','Typ danych wejÅ›ciowych',0),(305286,8481,'bg','Ð’Ñ…Ð¾Ð´ Ñ‚Ð¸Ð¿',0),(305287,8481,'ur','Ø§Ù† Ù¾Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(305288,8481,'sr','Ð’Ñ€ÑÑ‚Ð° ÑƒÐ½Ð¾ÑÐ°',0),(305289,8481,'vi','Loáº¡i nháº­p',0),(305290,8481,'af','Insette tipe',0),(305291,8481,'ro','Tip de intrare',0),(305292,8481,'et','Sisendi tÃ¼Ã¼p',0),(305293,8481,'si','VloÅ¾ek vrsta',0),(305294,8481,'ba','Jenis input',0),(305295,8481,'nl','Type ingang',0),(305296,8481,'fi','SyÃ¶tteen tyyppi',0),(305297,8481,'no','Inndatatypen',0),(305298,8481,'da','INPUTTYPE',0),(305299,8481,'ko','ìž…ë ¥ëœ í˜•ì‹',0),(305300,8481,'he','×¡×•×’ ×”×§×œ×˜',0),(305301,8481,'el','Î¤ÏÏ€Î¿Ï‚ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(305302,8481,'zh','è¾“å…¥ç±»åž‹\r\n',0),(305303,8481,'sv','Indatatyp',0),(305304,8481,'it','Tipo di input',0),(305305,8481,'tl','',0),(305306,8481,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3651;&#3626;&#3656;',0),(305307,8481,'hi','à¤‡à¤¨à¤ªà¥à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(305308,8481,'ms','Jenis input',0),(305309,8481,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(305310,8481,'fr','Type d\'entrÃ©e.',0),(305311,8481,'jp','å…¥åŠ›ã®åž‹',0),(305312,8481,'pt','Tipo de entrada',0),(305313,8481,'ru','Ð¢Ð¸Ð¿ Ð²Ð²Ð¾Ð´Ð°',0),(305314,8481,'es','Tipo de Input',0),(305315,8481,'de','Eingabetyp',0),(305316,8481,'en','Input Type',0),(305317,8482,'is','',0),(305318,8482,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ø­Ù‚ÙˆÙ‚',0),(305319,8482,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ø­Ù‚ÙˆÙ‚',0),(305320,8482,'tr','Minimum Ã¶deme',0),(305321,8482,'pl','PÅ‚acy minimalnej',0),(305322,8482,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(305323,8482,'ur','Ú©Ù… Ø§Ø² Ú©Ù… ØªÙ†Ø®ÙˆØ§Û',0),(305324,8482,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð°',0),(305325,8482,'vi','Thanh toÃ¡n Tá»‘i thiá»ƒu',0),(305326,8482,'af','Minimum Besoldiging',0),(305327,8482,'ro','Plata minimÄƒ',0),(305328,8482,'et','Miinimumtasu',0),(305329,8482,'si','Minimalne plaÄe',0),(305330,8482,'ba','Upah minimum',0),(305331,8482,'nl','Minimumloon',0),(305332,8482,'fi','Minimipalkka',0),(305333,8482,'no','Minimumsbetaling',0),(305334,8482,'da','MindstelÃ¸n',0),(305335,8482,'ko','ìµœì†Œ ì§€ë¶ˆ',0),(305336,8482,'he','×©×›×¨ ×ž×™× ×™×ž×•×',0),(305337,8482,'el','ÎšÎ±Ï„ÏŽÏ„Î±Ï„Î¿Ï‚ Î¼Î¹ÏƒÎ¸ÏŒÏ‚',0),(305338,8482,'zh','æœ€ä½Žå·¥èµ„\r\n',0),(305339,8482,'sv','MinimilÃ¶n',0),(305340,8482,'it','Retribuzione minima',0),(305341,8482,'tl','',0),(305342,8482,'th','&#3592;&#3656;&#3634;&#3618;&#3605;&#3656;&#3635;&#3626;&#3640;&#3604;',0),(305343,8482,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤µà¥‡à¤¤à¤¨',0),(305344,8482,'ms','Gaji minimum',0),(305345,8482,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù„Ù„Ø£Ø¬ÙˆØ±',0),(305346,8482,'fr','Salaire minimum',0),(305347,8482,'jp','æœ€ä½Žè³ƒé‡‘',0),(305348,8482,'pt','SalÃ¡rio mÃ­nimo',0),(305349,8482,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ð°',0),(305350,8482,'es','Pago MÃ­nimo',0),(305351,8482,'de','MindestlÃ¶hne',0),(305352,8482,'en','Minimum Pay',0),(305353,8483,'is','',0),(305354,8483,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¬Ø¹Ø¨Ù‡ Ù¾ÙŠØ§Ù… Ø±Ø§Ø¯ÙŠÙˆÙŠÙŠ',0),(305355,8483,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¬Ø¹Ø¨Ù‡ Ù¾ÙŠØ§Ù… Ø±Ø§Ø¯ÙŠÙˆÙŠÙŠ',0),(305356,8483,'tr','Radyo kutusu seÃ§enekleri',0),(305357,8483,'pl','Radiowych pola wyboru',0),(305358,8483,'bg','Ð Ð°Ð´Ð¸Ð¾ ÐºÑƒÑ‚Ð¸Ñ Ð¸Ð·Ð±Ð¾Ñ€',0),(305359,8483,'ur','Ø±ÛŒÚˆÛŒÙˆ Ø®Ø§Ù†Û Ø§Ù†ØªØ®Ø§Ø¨',0),(305360,8483,'sr','Ð Ð°Ð´Ð¸Ð¾ Ð¾ÐºÐ²Ð¸Ñ€ Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€Ðµ',0),(305361,8483,'vi','Lá»±a chá»n há»™p Radio',0),(305362,8483,'af','Radio boks keuses',0),(305363,8483,'ro','OpÅ£iuni de caseta radio',0),(305364,8483,'et','Raadio loendiboksi Valikud',0),(305365,8483,'si','Radio polje izbire',0),(305366,8483,'ba','Radio kotak pilihan',0),(305367,8483,'nl','Radio vak keuzes',0),(305368,8483,'fi','Radio Box valintoja',0),(305369,8483,'no','Radio boksen valg',0),(305370,8483,'da','Radio afkrydsningsfeltet valg',0),(305371,8483,'ko','ë¼ë””ì˜¤ ìƒìž ì„ íƒ',0),(305372,8483,'he','××¤×©×¨×•×™×•×ª ×ª×™×‘×ª ×¨×“×™×•',0),(305373,8483,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ ÎºÎ¿Ï…Ï„Î¯ ÏÎ±Î´Î¹ÏŒÏ†Ï‰Î½Î¿',0),(305374,8483,'zh','é€‰æ¡†é€‰æ‹©\r\n',0),(305375,8483,'sv','Radio rutan Val',0),(305376,8483,'it','Radio Box scelte',0),(305377,8483,'tl','',0),(305378,8483,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585; Radio Box',0),(305379,8483,'hi','à¤°à¥‡à¤¡à¤¿à¤¯à¥‹ à¤¬à¥‰à¤•à¥à¤¸ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(305380,8483,'ms','Pilihan Peti radio',0),(305381,8483,'ar','Ø±Ø§Ø¯ÙŠÙˆ Ù…Ø±Ø¨Ø¹ Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª',0),(305382,8483,'fr','Choix de boÃ®te de radio',0),(305383,8483,'jp','ãƒ©ã‚¸ã‚ª ãƒœãƒƒã‚¯ã‚¹ã®é¸æŠžè‚¢',0),(305384,8483,'pt','OpÃ§Ãµes de caixa de rÃ¡dio',0),(305385,8483,'ru','Ð Ð°Ð´Ð¸Ð¾ Ð¿Ð¾Ð»Ðµ Ð²Ñ‹Ð±Ð¾Ñ€Ð°',0),(305386,8483,'es','Selecciones de Caja de Radio',0),(305387,8483,'de','Radio Box Auswahl',0),(305388,8483,'en','Radio Box Choices',0),(305389,8484,'is','',0),(305390,8484,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¬Ø¹Ø¨Ù‡ Ù¾ÙŠØ§Ù… Ø±Ø§Ø¯ÙŠÙˆÙŠÙŠ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…Ù‚Ø¯Ø§Ø± ',0),(305391,8484,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¬Ø¹Ø¨Ù‡ Ù¾ÙŠØ§Ù… Ø±Ø§Ø¯ÙŠÙˆÙŠÙŠ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…Ù‚Ø¯Ø§Ø± ',0),(305392,8484,'tr','Radyo kutusu seÃ§enekleri artÄ± miktarÄ±',0),(305393,8484,'pl','Radiowych pola wyboru oraz iloÅ›ci',0),(305394,8484,'bg','Ð Ð°Ð´Ð¸Ð¾ ÐºÑƒÑ‚Ð¸Ñ Ð¸Ð·Ð±Ð¾Ñ€ Ð¿Ð»ÑŽÑ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(305395,8484,'ur','Ø±ÛŒÚˆÛŒÙˆ Ú©Û’ Ø¨Ø§Ú©Ø³ Ú©Û’ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ø¹Ù„Ø§ÙˆÛ Ù…Ù‚Ø¯Ø§Ø±',0),(305396,8484,'sr','Ð Ð°Ð´Ð¸Ð¾ Ð¾ÐºÐ²Ð¸Ñ€ Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€ ÐŸÐ›Ð£Ð¡ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(305397,8484,'vi','Lá»±a chá»n há»™p Radio thÃªm sá»‘ lÆ°á»£ng',0),(305398,8484,'af','Radio boks keuses PLUS hoeveelheid',0),(305399,8484,'ro','OpÅ£iuni de caseta Radio PLUS cantitatea',0),(305400,8484,'et','Raadio ruut valikuid pluss kogus',0),(305401,8484,'si','Izbire s radio PLUS koliÄina',0),(305402,8484,'ba','Radio kotak pilihan ditambah kuantitas',0),(305403,8484,'nl','Radio vak keuzes PLUS hoeveelheid',0),(305404,8484,'fi','Radio vaihtoehdot PLUS mÃ¤Ã¤rÃ¤',0),(305405,8484,'no','Radio boksen valg pluss antall',0),(305406,8484,'da','Radio boks valg PLUS antal',0),(305407,8484,'ko','ë¼ë””ì˜¤ ìƒìž ì„ íƒ í”ŒëŸ¬ìŠ¤ ìˆ˜ëŸ‰',0),(305408,8484,'he','××¤×©×¨×•×™×•×ª ×ª×™×‘×ª ×¨×“×™×• ×•×¢×•×“ ×›×ž×•×ª',0),(305409,8484,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ ÎºÎ¿Ï…Ï„Î¯ ÏÎ±Î´Î¹ÏŒÏ†Ï‰Î½Î¿ ÏƒÏ…Î½ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(305410,8484,'zh','é€‰æ¡†é€‰æ‹©åŠ é‡\r\n',0),(305411,8484,'sv','Radio rutan Val PLUS kvantiteten',0),(305412,8484,'it','Radio Box scelte piÃ¹ quantitÃ ',0),(305413,8484,'tl','',0),(305414,8484,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585; Radio Box &#3610;&#3623;&#3585;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(305415,8484,'hi','à¤°à¥‡à¤¡à¤¿à¤¯à¥‹ à¤¬à¥‰à¤•à¥à¤¸ à¤µà¤¿à¤•à¤²à¥à¤ªà¥‹à¤‚ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(305416,8484,'ms','Radio kotak pilihan serta kuantiti',0),(305417,8484,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ù…Ø±Ø¨Ø¹ Ø§Ù„Ø¥Ø°Ø§Ø¹Ø© Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ ÙƒÙ…ÙŠØ©',0),(305418,8484,'fr','Choix de boÃ®te de radio PLUS de quantitÃ©',0),(305419,8484,'jp','ãƒ©ã‚¸ã‚ª ãƒœãƒƒã‚¯ã‚¹é¸æŠžè‚¢ãƒ—ãƒ©ã‚¹æ•°é‡',0),(305420,8484,'pt','RÃ¡dio escolhas de caixa mais quantidade',0),(305421,8484,'ru','Ð Ð°Ð´Ð¸Ð¾ Box Ð²Ñ‹Ð±Ð¾Ñ€ Ð¿Ð»ÑŽÑ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(305422,8484,'es','Selecciones de Caja de Radio MÃ„S Cantidad',0),(305423,8484,'de','Radio Box Auswahl und Menge',0),(305424,8484,'en','Radio Box Choices PLUS Quantity',0),(305425,8485,'is','',0),(305426,8485,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…Ù‚Ø¯Ø§Ø± ',0),(305427,8485,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…Ù‚Ø¯Ø§Ø± ',0),(305428,8485,'tr','SeÃ§im artÄ± miktarÄ±',0),(305429,8485,'pl','WybÃ³r oraz iloÅ›ci',0),(305430,8485,'bg','ÐŸÐ¾Ð´Ð±Ð¾Ñ€ Ð¿Ð»ÑŽÑ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(305431,8485,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ø¹Ù„Ø§ÙˆÛ Ù…Ù‚Ø¯Ø§Ø±',0),(305432,8485,'sr','Ð˜Ð·Ð±Ð¾Ñ€ ÐŸÐ›Ð£Ð¡ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(305433,8485,'vi','Lá»±a chá»n ThÃªm sá»‘ lÆ°á»£ng',0),(305434,8485,'af','Seleksie PLUS hoeveelheid',0),(305435,8485,'ro','SelecÅ£ie PLUS cantitatea',0),(305436,8485,'et','Valik pluss kogus',0),(305437,8485,'si','Izbor PLUS koliÄina',0),(305438,8485,'ba','Seleksi ditambah kuantitas',0),(305439,8485,'nl','Selectie PLUS hoeveelheid',0),(305440,8485,'fi','Valinta sekÃ¤ mÃ¤Ã¤rÃ¤',0),(305441,8485,'no','Utvalg pluss antall',0),(305442,8485,'da','Udvalg PLUS antal',0),(305443,8485,'ko','ì„ íƒ í”ŒëŸ¬ìŠ¤ ìˆ˜ëŸ‰',0),(305444,8485,'he','×‘×—×™×¨×” ×‘×ª×•×¡×¤×ª ×”×›×ž×•×ª',0),(305445,8485,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÏƒÏ…Î½ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(305446,8485,'zh','é€‰æ‹©åŠ é‡\r\n',0),(305447,8485,'sv','Urval PLUS kvantiteten',0),(305448,8485,'it','Selezione, piÃ¹ quantitÃ ',0),(305449,8485,'tl','',0),(305450,8485,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3610;&#3623;&#3585;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(305451,8485,'hi','à¤šà¤¯à¤¨ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(305452,8485,'ms','Pilihan serta kuantiti',0),(305453,8485,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ¯ Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ ÙƒÙ…ÙŠØ©',0),(305454,8485,'fr','SÃ©lection PLUS de quantitÃ©',0),(305455,8485,'jp','é¸æŠžãƒ—ãƒ©ã‚¹æ•°é‡',0),(305456,8485,'pt','SeleÃ§Ã£o e quantidade',0),(305457,8485,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ ÐŸÐ›Ð®Ð¡ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(305458,8485,'es','SelecciÃ³n MAS Cantidad',0),(305459,8485,'de','Auswahl und Menge',0),(305460,8485,'en','Selection PLUS Quantity',0),(305461,8486,'is','',0),(305462,8486,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(305463,8486,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(305464,8486,'tr','TimeClock parÃ§a baÅŸÄ± iÅŸ eylemleri ekleme',0),(305465,8486,'pl','Dodaj akcje TimeClock pracy akordowej',0),(305466,8486,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° TimeClock Ð¿Ð°Ñ€Ñ‡Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(305467,8486,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ø§Ø¹Ù…Ø§Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(305468,8486,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ñ€Ð°Ð´ÑšÐµ',0),(305469,8486,'vi','ThÃªm hÃ nh Ä‘á»™ng MÃ¡y cháº¥m cÃ´ng viá»‡c khoÃ¡n',0),(305470,8486,'af','Tydklok Stukwerk Aksies Skep',0),(305471,8486,'ro','Adauga acord ceas acÅ£iunile',0),(305472,8486,'et','TimeClock tÃ¼kitÃ¶Ã¶ toimingute lisamine',0),(305473,8486,'si','Dodajte dejanja TimeClock akord',0),(305474,8486,'ba','Tambahkan timeclock Piecework tindakan',0),(305475,8486,'nl','Klok stukloon acties toevoegen',0),(305476,8486,'fi','Timeclock urakkatyÃ¶n toiminnot lisÃ¤Ã¤vÃ¤t',0),(305477,8486,'no','TimeClock stykkavlÃ¸nning handlinger legge',0),(305478,8486,'da','Timeclock akkordarbejde handlinger tilfÃ¸je',0),(305479,8486,'ko','Timeclock Piecework ìž‘ì—… ì¶”ê°€',0),(305480,8486,'he','×”×•×¡×£ ×¤×¢×•×œ×•×ª Timeclock ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(305481,8486,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Timeclock ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ Î´ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(305482,8486,'zh','æ—¶é’Ÿè®¡ä»¶åŠ¨ä½œæ·»åŠ \r\n',0),(305483,8486,'sv','Timeclock ackord Ã¥tgÃ¤rder lÃ¤gga till',0),(305484,8486,'it','Aggiungere azioni a cottimo Timeclock',0),(305485,8486,'tl','',0),(305486,8486,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3',0),(305487,8486,'hi','Timeclock Piecework à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(305488,8486,'ms','Tambah Timeclock Piecework tindakan',0),(305489,8486,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(305490,8486,'fr','Ajouter Ã  la piÃ¨ce Timeclock Actions',0),(305491,8486,'jp','å‡ºæ¥é«˜æ‰•ã„ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(305492,8486,'pt','Adicionar aÃ§Ãµes timeclock trabalho por tarefa',0),(305493,8486,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ TimeClock ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(305494,8486,'es','Reloj Checador Acciones de Trabajo por Pieza Agregar',0),(305495,8486,'de','Timeclock Akkordarbeit Aktionen hinzufÃ¼gen',0),(305496,8486,'en','Timeclock Piecework Actions Add',0),(305497,8487,'is','',0),(305498,8487,'dr','1 * Ù†Ø±Ø® (Ø§Ú¯Ø± Ø¨Ù„Ù‡ Ø§Ø³Øª',0),(305499,8487,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙŠÙƒ 1 * Ù†Ø±Ø® (Ø§Ú¯Ø± Ø¨Ù„Ù‡ Ø§Ø³Øª',0),(305500,8487,'tr','1 x kullanmak eÄŸer (Evet) oranÄ±',0),(305501,8487,'pl','UÅ¼yj 1 x OceÅ„ (jeÅ›li tak)',0),(305502,8487,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ 1 x ÑÑ‚Ð°Ð²ÐºÐ° (Ð°ÐºÐ¾ Ð´Ð°)',0),(305503,8487,'ur','1 Ø§ÛŒÚ©Ø³ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº (ÛØ§Úº Ø§Ú¯Ø±) Ú©ÛŒ Ø´Ø±Ø­',0),(305504,8487,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ 1 x ÑÑ‚Ð¾Ð¿Ð° (Ð°ÐºÐ¾ Ð´Ð°)',0),(305505,8487,'vi','DÃ¹ng 1 x GiÃ¡ (náº¿u cÃ³)',0),(305506,8487,'af','Gebruik 1x Tarief (indien ja)',0),(305507,8487,'ro','UtilizaÅ£i 1 x rata (daca da)',0),(305508,8487,'et','Kasutamine 1 x hinda (kui jah)',0),(305509,8487,'si','Uporabite 1 x stopnja (Äe je)',0),(305510,8487,'ba','Gunakan 1 x menilai (jika ya)',0),(305511,8487,'nl','1 x gebruik stem (als Ja)',0),(305512,8487,'fi','KÃ¤yttÃ¤Ã¤ 1 x luokitus (Jos kyllÃ¤)',0),(305513,8487,'no','Bruke 1 x Rate (Hvis ja)',0),(305514,8487,'da','Bruger 1 x Vurder (hvis ja)',0),(305515,8487,'ko','1 x ì‚¬ìš© í•˜ ì—¬ (ê·¸ë ‡ë‹¤ë©´) í‰ê°€',0),(305516,8487,'he','×œ×”×©×ª×ž×© 1 x ×œ×“×¨×’ (×× ×›×Ÿ)',0),(305517,8487,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ 1 x Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ (Î±Î½ Î½Î±Î¹)',0),(305518,8487,'zh','ä½¿ç”¨1Ã—åˆ©çŽ‡ï¼ˆè‹¥æœ‰ï¼‰\r\n',0),(305519,8487,'sv','AnvÃ¤nd 1 x BetygsÃ¤tt (om ja)',0),(305520,8487,'it','Utilizzare 1 x tasso (se sÃ¬)',0),(305521,8487,'tl','',0),(305522,8487,'th','&#3651;&#3594;&#3657; 1 &#3588;&#3619;&#3633;&#3657;&#3591;&#3629;&#3633;&#3605;&#3619;&#3634;(&#3606;&#3657;&#3634;&#3651;&#3594;&#3656;)',0),(305523,8487,'hi','1 à¤à¤•à¥à¤¸ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚ à¤¯à¤¦à¤¿ (à¤¹à¤¾à¤) à¤¦à¤°',0),(305524,8487,'ms','Gunakan 1 x kadar (Jika ya)',0),(305525,8487,'ar','Ø³ 1 Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù…Ø¹Ø¯Ù„ (Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ø¬ÙˆØ§Ø¨ Ù†Ø¹Ù…)',0),(305526,8487,'fr','Utiliser 1 x taux (si oui)',0),(305527,8487,'jp','1 x ä½¿ç”¨çŽ‡ ï¼ˆã¯ã„ã®å ´åˆ)',0),(305528,8487,'pt','Use 1 x taxa (se sim)',0),(305529,8487,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ 1 x Ð¾Ñ†ÐµÐ½Ð¸Ñ‚ÑŒ (ÐµÑÐ»Ð¸ Ð´Ð°)',0),(305530,8487,'es','Usar 1 x Tasa (si es yes)',0),(305531,8487,'de','Verwenden Sie 1 X bewerten (wenn ja)',0),(305532,8487,'en','Use 1 x Rate (if yes)',0),(305533,8488,'is','',0),(305534,8488,'dr','Ù†Ø±Ø® Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(305535,8488,'pr','Ù†Ø±Ø® Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(305536,8488,'tr','Ek oranlarÄ±',0),(305537,8488,'pl','Dodatkowa cena',0),(305538,8488,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ ÐºÑƒÑ€ÑÐ¾Ð²Ðµ',0),(305539,8488,'ur','Ø§Ø¶Ø§ÙÛŒ Ø´Ø±Ø­',0),(305540,8488,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÑÑ‚Ð¾Ð¿Ðµ',0),(305541,8488,'vi','GiÃ¡ Cá»™ng ThÃªm',0),(305542,8488,'af','Adisionele Tariewe',0),(305543,8488,'ro','Tarife suplimentare',0),(305544,8488,'et','Lisatasu mÃ¤Ã¤rad',0),(305545,8488,'si','Dodatne stopnje',0),(305546,8488,'ba','Penambahan Tarif',0),(305547,8488,'nl','Extra tarieven',0),(305548,8488,'fi','LisÃ¤Ã¤ hinnat',0),(305549,8488,'no','Flere priser',0),(305550,8488,'da','Yderligere priser',0),(305551,8488,'ko','ì¶”ê°€ ìš”ê¸ˆ',0),(305552,8488,'he','×ª×¢×¨×™×¤×™× × ×•×¡×¤×™×',0),(305553,8488,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Ï„Î¹Î¼Î­Ï‚',0),(305554,8488,'zh','å¢žåŠ è²»çŽ‡\r\n',0),(305555,8488,'sv','Ytterligare priser',0),(305556,8488,'it','Tassi addizionali',0),(305557,8488,'tl','',0),(305558,8488,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(305559,8488,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¦à¤°',0),(305560,8488,'ms','Kadar tambahan',0),(305561,8488,'ar','Ù…Ø¹Ø¯Ù„Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ©',0),(305562,8488,'fr','Tariffs SupplÃ©mentaires',0),(305563,8488,'jp','è¿½åŠ æ–™é‡‘',0),(305564,8488,'pt','Taxas adicionais',0),(305565,8488,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(305566,8488,'es','Tarifas Adicionales',0),(305567,8488,'de','ZusÃ¤tzliche Preise',0),(305568,8488,'en','Additional Rates',0),(305569,8489,'is','',0),(305570,8489,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(305571,8489,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(305572,8489,'tr','SeÃ§im Ã¶ÄŸeleri',0),(305573,8489,'pl','WybÃ³r elementÃ³w',0),(305574,8489,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(305575,8489,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ø§Ø´ÛŒØ§Ø¡',0),(305576,8489,'sr','ÐžÐ´Ð°Ð±Ð¸Ñ€ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(305577,8489,'vi','HÃ ng Ä‘Ã£ chá»n',0),(305578,8489,'af','Geselekteerde Items',0),(305579,8489,'ro','Elemente de selecÅ£ie',0),(305580,8489,'et','Valitud Ã¼ksused',0),(305581,8489,'si','Izbor elementov',0),(305582,8489,'ba','Pilihan item',0),(305583,8489,'nl','Selectie Items',0),(305584,8489,'fi','Valinta kohteita',0),(305585,8489,'no','Utvalg elementer',0),(305586,8489,'da','Valg af elementer',0),(305587,8489,'ko','ì„ íƒ í•­ëª©',0),(305588,8489,'he','×¤×¨×™×˜×™ ×‘×—×™×¨×”',0),(305589,8489,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(305590,8489,'zh','é€‰æµ‹é¡¹ç›®\r\n',0),(305591,8489,'sv','Val av objekt',0),(305592,8489,'it','Selezione articoli',0),(305593,8489,'tl','',0),(305594,8489,'th','&#3585;&#3634;&#3619;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(305595,8489,'hi','à¤šà¤¯à¤¨ à¤†à¤‡à¤Ÿà¤®',0),(305596,8489,'ms','Item-item pilihan',0),(305597,8489,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(305598,8489,'fr','Ã‰lÃ©ments de choix',0),(305599,8489,'jp','é¸æŠžã•ã‚ŒãŸé …ç›®',0),(305600,8489,'pt','Itens de seleÃ§Ã£o',0),(305601,8489,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(305602,8489,'es','SelecciÃ³n Items',0),(305603,8489,'de','Auswahlelemente',0),(305604,8489,'en','Selection Items',0),(305605,8490,'is','',0),(305606,8490,'dr','(ØªÙˆØ§Ø¨Ø¹) Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ- Ù†Ø±Ø® Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(305607,8490,'pr','ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ (ØªÙˆØ§Ø¨Ø¹) Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ- Ù†Ø±Ø® Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(305608,8490,'tr','TimeClock Piecwork fonksiyonlarÄ± - ek oranlarÄ±',0),(305609,8490,'pl','TimeClock Piecwork funkcje - dodatkowe stawki',0),(305610,8490,'bg','TimeClock Piecwork Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ - Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ‚Ð°Ñ€Ð¸Ñ„Ð¸',0),(305611,8490,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¾ÛŒÚ©ÙˆÙˆØ±Ú© Ú©Û’ Ø§ÙØ¹Ø§Ù„ - Ø§Ø¶Ø§ÙÛŒ Ø´Ø±Ø­',0),(305612,8490,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº ÐŸÐ¸ÐµÑ†wÐ¾Ñ€Ðº Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ - Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÑÑ‚Ð¾Ð¿Ðµ',0),(305613,8490,'vi','Chá»©c nÄƒng MÃ¡y cháº¥m cÃ´ng viá»‡c khoÃ¡n - GiÃ¡ thÃªm',0),(305614,8490,'af','Tydklok Stukwerk Funksies - Addisionele Skale',0),(305615,8490,'ro','Ceas Piecwork funcÅ£ii - tarife suplimentare',0),(305616,8490,'et','TimeClock Piecwork funktsioonid - lisatasu mÃ¤Ã¤rad',0),(305617,8490,'si','TimeClock Piecwork funkcije - dodatne stopnje',0),(305618,8490,'ba','Fungsi timeclock Piecwork - tingkat tambahan',0),(305619,8490,'nl','Klok Piecwork functies - extra tarieven',0),(305620,8490,'fi','Timeclock Piecwork toiminnot - lisÃ¤Ã¤ hinnat',0),(305621,8490,'no','TimeClock Piecwork funksjoner - flere priser',0),(305622,8490,'da','Timeclock Piecwork funktioner - yderligere priser',0),(305623,8490,'ko','Timeclock Piecwork ê¸°ëŠ¥-ì¶”ê°€ ìš”ê¸ˆ',0),(305624,8490,'he','Timeclock Piecwork ×¤×•× ×§×¦×™×•×ª - ×”×ž×—×™×¨×™× × ×•×¡×¤×™×',0),(305625,8490,'el','Timeclock Piecwork Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯ÎµÏ‚ - Ï€ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Ï„Î¹Î¼Î­Ï‚',0),(305626,8490,'zh','æ—¶é’Ÿè®¡ä»¶åŠŸèƒ½- é™„åŠ è´¹çŽ‡\r\n',0),(305627,8490,'sv','Timeclock Piecwork funktioner - ytterligare priser',0),(305628,8490,'it','Funzioni Timeclock Piecwork - tariffe aggiuntive',0),(305629,8490,'tl','',0),(305630,8490,'th','&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3656;&#3609;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3629;&#3',0),(305631,8490,'hi','Timeclock Piecwork à¤•à¤¾à¤°à¥à¤¯ - à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¦à¤°',0),(305632,8490,'ms','Fungsi-fungsi Timeclock Piecwork - kadar tambahan',0),(305633,8490,'ar','ÙˆØ¸Ø§Ø¦Ù Ø¨ÙŠÙƒÙˆÙˆØ±Ùƒ ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ-Ù…Ø¹Ø¯Ù„Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ©',0),(305634,8490,'fr','Timeclock Piecwork fonctions - autres tarifs',0),(305635,8490,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ Piecwork æ©Ÿèƒ½ - è¿½åŠ æ–™é‡‘',0),(305636,8490,'pt','Timeclock Piecwork funÃ§Ãµes - taxas adicionais',0),(305637,8490,'ru','TimeClock Piecwork Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸ - Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(305638,8490,'es','Reloj Checador Funciones - Tarifas Adicionales',0),(305639,8490,'de','Timeclock Piecwork Funktionen - zusÃ¤tzliche Preise',0),(305640,8490,'en','Timeclock Piecwork Functions - Additional Rates',0),(305641,8491,'is','',0),(305642,8491,'dr','Ù†Ù¾Ø°ÙŠØ±ÙØªÙ† Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„',0),(305643,8491,'pr','Ù†Ù¾Ø°ÙŠØ±ÙØªÙ† Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„',0),(305644,8491,'tr','Ä°ÅŸ numarasÄ± yok izin ver',0),(305645,8491,'pl','UmoÅ¼liwiÄ‡ nie numer zadania',0),(305646,8491,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð½ÑÐ¼Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(305647,8491,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ú©Ùˆ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(305648,8491,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð±ÐµÐ· Ð¿Ð¾ÑÐ»Ð°',0),(305649,8491,'vi','Cho PhÃ©p KhÃ´ng CÃ³ Sá»‘ Job',0),(305650,8491,'af','Laat GEEN Werkstuknommer toe nie',0),(305651,8491,'ro','Permite nici un numÄƒr de Job',0),(305652,8491,'et','Luba ei ole tÃ¶Ã¶kohtade arv',0),(305653,8491,'si','OmogoÄajo Å¡tevilka ni delo',0),(305654,8491,'ba','Memungkinkan nomor pekerjaan',0),(305655,8491,'nl','GEEN projectnummer toestaan',0),(305656,8491,'fi','Salli ei tyÃ¶numero',0),(305657,8491,'no','La ingen jobbnummer',0),(305658,8491,'da','Tillad ikke jobnummer',0),(305659,8491,'ko','ìž‘ì—… ë²ˆí˜¸ í—ˆìš©',0),(305660,8491,'he','×œ××¤×©×¨ ××™×Ÿ ×ž×¡×¤×¨ ×”×¢×‘×•×“×”',0),(305661,8491,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Î§Î©Î¡ÎŠÎ£ Î±ÏÎ¹Î¸Î¼ÏŒ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(305662,8491,'zh','ä¸å…è®¸ä»»ä½•èŒä½ç¼–å·\r\n',0),(305663,8491,'sv','LÃ¥t inget jobbnummer',0),(305664,8491,'it','Non consentire alcun numero di lavoro',0),(305665,8491,'tl','',0),(305666,8491,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3652;&#3617;&#3656;&#3617;&#3637;&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3591;&#3634;&#3609;',0),(305667,8491,'hi','à¤•à¥‹à¤ˆ à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿',0),(305668,8491,'ms','Membenarkan jumlah kerja tidak',0),(305669,8491,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ø£ÙŠ Ø±Ù‚Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(305670,8491,'fr','Ne permettre Ã  aucun numÃ©ro d\'emploi',0),(305671,8491,'jp','ã‚¸ãƒ§ãƒ–ç•ªå·ã‚‚è¨±å¯ã—ã¾ã›ã‚“ã€‚',0),(305672,8491,'pt','Permitir que nenhum nÃºmero de emprego',0),(305673,8491,'ru','ÐŸÐ¾Ð·Ð²Ð¾Ð»ÑŒÑ‚Ðµ Ð½Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(305674,8491,'es','Permitir NO NÃºmero de Trabajo',0),(305675,8491,'de','Erlauben Sie keine Job-Nummer',0),(305676,8491,'en','Allow NO Job Number',0),(305677,8492,'is','',0),(305678,8492,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„ ',0),(305679,8492,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„ ',0),(305680,8492,'tr','Ä°ÅŸ numarasÄ± isteyin',0),(305681,8492,'pl','ProszÄ™ o numer zadania',0),(305682,8492,'bg','ÐŸÐ¸Ñ‚Ð°Ð¼ Ð·Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(305683,8492,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù„ÛŒÛ’ Ù†Ù…Ø¨Ø± Ù¾ÙˆÚ†Ú¾ÛŒÚº',0),(305684,8492,'sr','ÐŸÐ¸Ñ‚Ð°Ñ˜ Ð·Ð° Ð±Ñ€Ð¾Ñ˜ Ð¿Ð¾ÑÐ»Ð°',0),(305685,8492,'vi','YÃªu Cáº§u Sá»‘ Job',0),(305686,8492,'af','Vrae vir Werkstuk Nommer',0),(305687,8492,'ro','Cere numÄƒrul de Job',0),(305688,8492,'et','KÃ¼si tÃ¶Ã¶ Number',0),(305689,8492,'si','Prosite za Å¡tevilko delovnih',0),(305690,8492,'ba','Meminta pekerjaan nomor',0),(305691,8492,'nl','Vragen voor projectnummer',0),(305692,8492,'fi','PyydÃ¤ tyÃ¶numero',0),(305693,8492,'no','Be om jobbnummer',0),(305694,8492,'da','Bede om jobnummer',0),(305695,8492,'ko','ìž‘ì—… ë²ˆí˜¸ì— ëŒ€ í•œ ì§ˆë¬¸',0),(305696,8492,'he','×ž×‘×§×© ×ž×¡×¤×¨ ×”×¢×‘×•×“×”',0),(305697,8492,'el','Î¡Ï‰Ï„Î®ÏƒÏ„Îµ Î³Î¹Î± Ï„Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(305698,8492,'zh','å’¨è¯¢å·¥ä½œå·ç \r\n',0),(305699,8492,'sv','Be om projektnummer',0),(305700,8492,'it','Chiedere il numero di lavoro',0),(305701,8492,'tl','',0),(305702,8492,'th','&#3606;&#3634;&#3617;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3591;&#3634;&#3609;',0),(305703,8492,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‚à¤›à¤¨à¤¾',0),(305704,8492,'ms','Minta kerja nombor',0),(305705,8492,'ar','Ø£Ø·Ù„Ø¨ Ø±Ù‚Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(305706,8492,'fr','Demander le numÃ©ro de Job',0),(305707,8492,'jp','ã‚¸ãƒ§ãƒ–ç•ªå·ã‚’æ±‚ã‚ã‚‹',0),(305708,8492,'pt','Pedir o nÃºmero do emprego',0),(305709,8492,'ru','ÐŸÑ€Ð¾ÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(305710,8492,'es','Pedir el Numero de Proyecto',0),(305711,8492,'de','Job-Nummer beantragen',0),(305712,8492,'en','Ask for Job Number',0),(305713,8493,'is','',0),(305714,8493,'dr','(Ø¯Ø³ØªÙˆØ± Ø§Ù„Ø¹Ù…Ù„) Ø±Ø§ Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯',0),(305715,8493,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ÙŠÙ† ØªØ§Ø¨Ø¹ (Ø¯Ø³ØªÙˆØ± Ø§Ù„Ø¹Ù…Ù„) Ø±Ø§ Ø³ÙˆØ§Ù„ ÙƒÙ†ÙŠØ¯',0),(305716,8493,'tr','Bu iÅŸlev miktarÄ± sormak',0),(305717,8493,'pl','Zapytaj iloÅ›Ä‡ ta funkcja',0),(305718,8493,'bg','ÐŸÐ¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ‚Ð°Ð·Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(305719,8493,'ur','Ø§Ø³ ÙØ¹Ù„ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø³Û’ Ù¾ÙˆÚ†Ú¾ÛŒÚº',0),(305720,8493,'sr','ÐŸÐ¸Ñ‚Ð°Ñ˜ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¾Ð²Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ',0),(305721,8493,'vi','Há»i Sá»‘ LÆ°á»£ng Cho Chá»©c NÄƒng nÃ y',0),(305722,8493,'af','Hoeveelheid vra hierdie funksie',0),(305723,8493,'ro','Cere cantitatea de aceastÄƒ funcÅ£ie',0),(305724,8493,'et','KÃ¼si kogus selle funktsiooni',0),(305725,8493,'si','VpraÅ¡ajte koliÄina to funkcijo',0),(305726,8493,'ba','Meminta jumlah fungsi ini',0),(305727,8493,'nl','Vragen hoeveelheid deze functie',0),(305728,8493,'fi','Kysy mÃ¤Ã¤rÃ¤ toiminto',0),(305729,8493,'no','SpÃ¸r antall denne funksjonen',0),(305730,8493,'da','SpÃ¸rg mÃ¦ngde denne funktion',0),(305731,8493,'ko','ìš”ì²­ ìˆ˜ëŸ‰ì´ì´ í•¨ìˆ˜',0),(305732,8493,'he','×œ×©××•×œ ×›×ž×•×ª ×¤×•× ×§×¦×™×” ×–×•',0),(305733,8493,'el','Î¡Ï‰Ï„Î®ÏƒÏ„Îµ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Ï…Ï„Î® Ï„Î· Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(305734,8493,'zh','æ­¤åŠŸèƒ½è¦æ±‚æ•°é‡\r\n',0),(305735,8493,'sv','Be kvantitet denna funktion',0),(305736,8493,'it','Chiedere quantitÃ  questa funzione',0),(305737,8493,'tl','',0),(305738,8493,'th','&#3606;&#3634;&#3617;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(305739,8493,'hi','à¤‡à¤¸ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¥‡ à¤ªà¥‚à¤›à¥‹',0),(305740,8493,'ms','Tanya kuantiti fungsi ini',0),(305741,8493,'ar','Ø£Ø·Ù„Ø¨ Ø§Ù„ÙƒÙ…ÙŠØ© Ù‡Ø°Ù‡ Ø§Ù„Ø¯Ø§Ù„Ø©',0),(305742,8493,'fr','Demandez quantitÃ© cette fonction',0),(305743,8493,'jp','ã“ã®é–¢æ•°ã®é‡ã‚’æ±‚ã‚ã‚‹',0),(305744,8493,'pt','Pergunte a quantidade esta funÃ§Ã£o',0),(305745,8493,'ru','Ð—Ð°Ð´Ð°Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÑ‚Ð¾Ð¹ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(305746,8493,'es','Pedir la Cantidad de esta FunciÃ³n',0),(305747,8493,'de','Fragen Sie Menge, die diese Funktion',0),(305748,8493,'en','Ask Quantity this Function',0),(305749,8494,'is','',0),(305750,8494,'dr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù†ÙŠØ³Øª',0),(305751,8494,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù†ÙŠØ³Øª',0),(305752,8494,'tr','EÄŸer kontrol yapmak deÄŸil',0),(305753,8494,'pl','SprawdÅº, czy nie',0),(305754,8494,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ð»Ð¸ Ð½Ðµ',0),(305755,8494,'ur','Ø§Ú¯Ø± ØªÙˆ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ù†ÛÛŒÚº Ú©Ø±ØªÛ’ ÛÛŒÚº',0),(305756,8494,'sr','Ð’Ð¸Ð´Ð¸ , Ð°ÐºÐ¾ Ð½Ðµ Ñ€Ð°Ð´Ð¸',0),(305757,8494,'vi','ÄÃ¡nh dáº¥u náº¿u KHÃ”NG',0),(305758,8494,'af','Merk as nie',0),(305759,8494,'ro','VerificaÅ£i dacÄƒ nu se',0),(305760,8494,'et','Vaata kui ei ole',0),(305761,8494,'si','Preverite, Äe ne',0),(305762,8494,'ba','Periksa jika tidak',0),(305763,8494,'nl','Controleren of niet',0),(305764,8494,'fi','Tarkistaa, jos sitÃ¤ ei ole',0),(305765,8494,'no','Sjekk Hvis ikke',0),(305766,8494,'da','Kontrollere, om ikke',0),(305767,8494,'ko','ë§Œì•½ í™•ì¸ í•˜ì§€ ë§ˆì‹­ì‹œì˜¤',0),(305768,8494,'he','×‘×“×•×§ ×× ×œ×',0),(305769,8494,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÎµÎ¬Î½ Î´ÎµÎ½',0),(305770,8494,'zh','æ£€æŸ¥å¦\r\n',0),(305771,8494,'sv','Kolla om inte',0),(305772,8494,'it','Controllare se non si',0),(305773,8494,'tl','',0),(305774,8494,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3617;&#3639;&#3656;&#3629;&#3652;&#3617;&#3656;&#3607;&#3635;',0),(305775,8494,'hi','à¤…à¤—à¤° à¤œà¤¾à¤à¤š à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¤¤à¥‡',0),(305776,8494,'ms','Periksa jika tidak',0),(305777,8494,'ar','Ù…Ø¹Ø±ÙØ© Ù…Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø§',0),(305778,8494,'fr','VÃ©rifier si ne pas',0),(305779,8494,'jp','å ´åˆã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã›ã‚“ã€‚',0),(305780,8494,'pt','Verifique se nÃ£o',0),(305781,8494,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ, ÐµÑÐ»Ð¸ Ð½Ðµ',0),(305782,8494,'es','Chequear si NO lo Hace',0),(305783,8494,'de','ÃœberprÃ¼fen Sie, ob nicht',0),(305784,8494,'en','Check if Do NOT',0),(305785,8495,'is','',0),(305786,8495,'dr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù†Ù…ÙŠ ØªÙˆØ§Ù†',0),(305787,8495,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù†Ù…ÙŠ ØªÙˆØ§Ù†',0),(305788,8495,'tr','EÄŸer kontrol yapmak deÄŸil',0),(305789,8495,'pl','SprawdÅº, czy nie',0),(305790,8495,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ð»Ð¸ Ð½Ðµ',0),(305791,8495,'ur','Ø§Ú¯Ø± Ú†ÛŒÚ© Ù†ÛÛŒÚº Ú©Ø±ØªÛ’',0),(305792,8495,'sr','Ð’Ð¸Ð´Ð¸ , Ð°ÐºÐ¾ Ð½Ðµ Ñ€Ð°Ð´Ð¸',0),(305793,8495,'vi','ÄÃ¡nh dáº¥u náº¿u KHÃ”NG',0),(305794,8495,'af','Kontroleer as doen nie',0),(305795,8495,'ro','VerificaÅ£i dacÄƒ nu se',0),(305796,8495,'et','Kui ei ole',0),(305797,8495,'si','Preverite, Äe ne',0),(305798,8495,'ba','Periksa jika tidak',0),(305799,8495,'nl','Controleerinderegel Do NOT',0),(305800,8495,'fi','Tarkistaa, jos sitÃ¤ ei ole',0),(305801,8495,'no','Sjekk Hvis ikke',0),(305802,8495,'da','Kontrollere, om ikke',0),(305803,8495,'ko','í™•ì¸ í•˜ì§€ ë§ˆì‹­ì‹œì˜¤',0),(305804,8495,'he','×‘×“×•×§ ×× ×œ×',0),(305805,8495,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î±Î½ Î´ÎµÎ½',0),(305806,8495,'zh','æ£€æŸ¥å¦\r\n',0),(305807,8495,'sv','Kontrollera om inte',0),(305808,8495,'it','Verifica se non si',0),(305809,8495,'tl','',0),(305810,8495,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3617;&#3639;&#3656;&#3629;&#3652;&#3617;&#3656;&#3607;&#3635;',0),(305811,8495,'hi','à¤¯à¤¦à¤¿ à¤œà¤¾à¤‚à¤š à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(305812,8495,'ms','Periksa jika tidak',0),(305813,8495,'ar','Ù…Ø¹Ø±ÙØ© Ù…Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø§',0),(305814,8495,'fr','VÃ©rifier si ne pas',0),(305815,8495,'jp','å ´åˆã¯ãƒã‚§ãƒƒã‚¯ã—ãªã„ã§',0),(305816,8495,'pt','Verifique se nÃ£o',0),(305817,8495,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ, ÐµÑÐ»Ð¸ Ð½Ðµ',0),(305818,8495,'es','Checar si NO hace',0),(305819,8495,'de','ÃœberprÃ¼fen Sie, ob nicht',0),(305820,8495,'en','Check if Do NOT',0),(305821,8496,'is','',0),(305822,8496,'dr','/ Ù¾Ø§ÙŠØ§Ù† ÙƒØ§Ø± Ø®Ø§Ø±Ø¬ Ù†Ø´ÙˆÙŠØ¯ ',0),(305823,8496,'pr','Ø¨Ø¹Ø¯ Ø§Ø² Ø´Ø±ÙˆØ¹ / Ù¾Ø§ÙŠØ§Ù† ÙƒØ§Ø± Ø®Ø§Ø±Ø¬ Ù†Ø´ÙˆÙŠØ¯ ',0),(305824,8496,'tr','Yapmak deÄŸil baÅŸlangÄ±Ã§/bitiÅŸ iÅŸten Ã§Ä±kÄ±ÅŸ',0),(305825,8496,'pl','Czy nie wyjÅ›Ä‡ po rozpoczÄ™cia/zakoÅ„czenia pracy',0),(305826,8496,'bg','ÐŸÑ€Ð°Ð²Ñ Ð½Ðµ Ð¸Ð·Ð»Ð¸Ð·Ð°Ð½Ðµ ÑÐ»ÐµÐ´ ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð¸ ÐºÑ€Ð°Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(305827,8496,'ur','Ú©ÛŒØ§ Ù†ÛÛŒÚº Ø´Ø±ÙˆØ¹/Ø¢Ø®Ø± Ú©Ø§Ù… Ú©Û’ Ø¨Ø¹Ø¯ Ø®Ø±ÙˆØ¬ Ú©Ø±ÛŒÚº',0),(305828,8496,'sr','Ð¢Ð¾ Ð½Ð¸Ñ˜Ðµ Ð¸Ð·Ð»Ð°Ð· Ð½Ð°ÐºÐ¾Ð½ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°/ÐºÑ€Ð°Ñ˜Ð° Ð¿Ð¾ÑÐ»Ð°',0),(305829,8496,'vi','Äá»«ng thoÃ¡t ra sau khi CÃ´ng Viá»‡c Báº¯t Äáº§u/Káº¿t ThÃºc',0),(305830,8496,'af','Moet NIE na Begin/End Werk uit program gaan nie',0),(305831,8496,'ro','A face nu ieÅŸire dupÄƒ munca de Start/End',0),(305832,8496,'et','Ei vÃ¤lju pÎ´rast algus/lÃµpp',0),(305833,8496,'si','Delati ne izstopa po zaÄetek/konec dela',0),(305834,8496,'ba','Apakah tidak keluar setelah bekerja mulai akhir',0),(305835,8496,'nl','Doen niet afsluiten na begin/einde werk',0),(305836,8496,'fi','Ã„lÃ¤ lopeta Aloita/Lopeta tÃ¶iden jÃ¤lkeen',0),(305837,8496,'no','GjÃ¸r ikke Avslutt etter Start/slutt arbeid',0),(305838,8496,'da','MÃ¥ ikke Afslut efter Start/slut arbejde',0),(305839,8496,'ko','í•  í•˜ì§€ ì‹œìž‘/ì¢…ë£Œ ìž‘ì—… í›„ ì¢…ë£Œ',0),(305840,8496,'he','×”×× ×œ× ×™×¦×™××” ××—×¨×™ ×”×ª×—×œ×”/×¡×™×•× ×”×¢×‘×•×“×”',0),(305841,8496,'el','ÎšÎ¬Î½Î¿Ï…Î¼Îµ Î´ÎµÎ½ ÎµÎ¾ÏŒÎ´Î¿Ï… Î¼ÎµÏ„Î¬ Î±ÏÏ‡Î®/Ï„Î­Î»Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(305842,8496,'zh','å¼€å§‹/ç»“æŸå·¥ä½œåŽä¸å­˜åœ¨\r\n',0),(305843,8496,'sv','GÃ¶r inte avsluta efter Start/slut arbete',0),(305844,8496,'it','Fare non uscire dopo il lavoro di inizio/fine',0),(305845,8496,'tl','',0),(305846,8496,'th','&#3629;&#3618;&#3656;&#3634;&#3629;&#3629;&#3585;&#3627;&#3621;&#3633;&#3591;&#3648;&#3619;&#3636;&#3656;&#3617;/&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3591;&#3634;&#3609;',0),(305847,8496,'hi','à¤•à¥à¤¯à¤¾ à¤¨à¤¹à¥€à¤‚ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­/à¤…à¤‚à¤¤ à¤•à¤¾à¤® à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤¨à¤¿à¤•à¤²à¥‡à¤‚',0),(305848,8496,'ms','Adakah tidak keluar selepas kerja-kerja bermula/tamat',0),(305849,8496,'ar','Ù‡Ù„ Ø¹Ø¯Ù… Ø§Ù„Ø®Ø±ÙˆØ¬ Ø¨Ø¹Ø¯ Ø¨Ø¯Ø¡/Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„Ø¹Ù…Ù„',0),(305850,8496,'fr','Faire pas sortie aprÃ¨s le travail de dÃ©but/fin',0),(305851,8496,'jp','è¡Œã†ä»•äº‹ã®é–‹å§‹/çµ‚äº†å¾Œçµ‚äº†ã—ã¾ã›ã‚“ã€‚',0),(305852,8496,'pt','Fazer nÃ£o sair depois do trabalho de inÃ­cio/fim',0),(305853,8496,'ru','Ð”ÐµÐ»Ð°Ñ‚ÑŒ Ð½Ðµ Ð²Ñ‹Ñ…Ð¾Ð´ Ð¿Ð¾ÑÐ»Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¸ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(305854,8496,'es','NO Sale despuÃ©s de Comenzar/Terminar Trabajo',0),(305855,8496,'de','Tun nicht die Ausfahrt nach Start/End-Arbeit',0),(305856,8496,'en','Do NOT Exit after Start/End Work',0),(305857,8497,'is','',0),(305858,8497,'dr',' Ø­Ù‚ÙˆÙ‚ Ø±Ø§ Ø¯Ø± ØªØ¨ Ù†Ù…Ø§ÙŠØ´ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(305859,8497,'pr',' Ø­Ù‚ÙˆÙ‚ Ø±Ø§ Ø¯Ø± ØªØ¨ Ù†Ù…Ø§ÙŠØ´ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(305860,8497,'tr','GÃ¶rÃ¼ntÃ¼leme Ã§alÄ±ÅŸan gÃ¶rÃ¼nÃ¼mÃ¼ Ã¼zerinde Ã¶deme yapar mÄ±yÄ±m',0),(305861,8497,'pl','WyÅ›wietlacz nie pÅ‚acÄ… na widok pracownika',0),(305862,8497,'bg','Ð”Ð° Ð½Ðµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð° Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¸Ð·Ð³Ð»ÐµÐ´',0),(305863,8497,'ur','Ù†ÛÛŒÚº Ø¯Ú©Ú¾Ø§ Ù…Ù„Ø§Ø²Ù… Ù…Ù†Ø¸Ø± Ù¾Ø± Ø§Ø¯Ø§ Ú©Ø±ØªÛ’ ÛÛŒÚº',0),(305864,8497,'sr','Ð”Ð° Ð½Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð° Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð½Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(305865,8497,'vi','Äá»«ng hiá»ƒn thá»‹ tráº£ lÆ°Æ¡ng cho nhÃ¢n viÃªn xem',0),(305866,8497,'af','MOENIE Loon Aandui op Werknemer Oorsig nie',0),(305867,8497,'ro','A face nu Display Pay pe angajat Vezi',0),(305868,8497,'et','Ã„ra kuva palka tÃ¶Ã¶taja vaatel',0),(305869,8497,'si','Ali ne prikaÅ¾e plaÄa na zaposlenega pogled',0),(305870,8497,'ba','Apakah tidak menampilkan membayar karyawan View',0),(305871,8497,'nl','Betaal niet weergeven op werknemer weergave',0),(305872,8497,'fi','Ei nÃ¤y maksaa tyÃ¶ntekijÃ¤n ikkunassa',0),(305873,8497,'no','Betaler ikke vise ansatte visningen',0),(305874,8497,'da','Betaler ikke Display pÃ¥ medarbejdervisningen',0),(305875,8497,'ko','ì§ì› ë³´ê¸°ì— í‘œì‹œ ë˜ì§€ ì§€ë¶ˆ í•©ë‹ˆê¹Œ',0),(305876,8497,'he','×”×× ×ª×¦×™×’ ×ž×©×œ× ×”×¢×•×‘×“ ×‘×ª×¦×•×’×”',0),(305877,8497,'el','ÎÎ± Î¼Î·Î½ ÎµÎ¼Ï†Î±Î½Î¯Î¶ÎµÏ„Î±Î¹ Ï€Î»Î·ÏÏŽÏƒÎ¿Ï…Î½ Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î¬Ï€Î¿ÏˆÎ·',0),(305878,8497,'zh','å‘˜å·¥æµè§ˆä¸­ä¸æ˜¾ç¤ºåœ¨å·¥èµ„\r\n',0),(305879,8497,'sv','Betalar inte displayen pÃ¥ medarbetarvyn',0),(305880,8497,'it','NON Display pagare vista dipendente',0),(305881,8497,'tl','',0),(305882,8497,'th','&#3629;&#3618;&#3656;&#3634;&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3651;&#3627;&#3657;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3604;&#3641;',0),(305883,8497,'hi','à¤¨à¤¹à¥€à¤‚ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¦à¥ƒà¤¶à¥à¤¯ à¤ªà¤° à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(305884,8497,'ms','Bayar tidak dipaparkan pada paparan pekerja',0),(305885,8497,'ar','Ø§Ù„Ù‚ÙŠØ§Ù… Ø¨Ø¯ÙØ¹ Ø¹Ø¯Ù… Ø§Ù„Ø¹Ø±Ø¶ ÙÙŠ Ø·Ø±ÙŠÙ‚Ø© Ø¹Ø±Ø¶ Ø§Ù„Ù…ÙˆØ¸Ù',0),(305886,8497,'fr','Ne pas afficher les paie sur avis de l\'employÃ©',0),(305887,8497,'jp','è¡¨ç¤ºã—ãªã„å¾“æ¥­å“¡ãƒ“ãƒ¥ãƒ¼ã«æ”¯æ‰•ã†ã®ã§ã™ã‹',0),(305888,8497,'pt','NÃ£o exibir Ã© pago Ã  vista do empregado',0),(305889,8497,'ru','ÐÐ• Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(305890,8497,'es','NO Desplegar Sueldo en la Vista de Empleado',0),(305891,8497,'de','Bezahle nicht anzeigen auf Mitarbeiteransicht',0),(305892,8497,'en','Do NOT Display Pay on Employee View',0),(305893,8498,'is','',0),(305894,8498,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø­Ù‚ÙˆÙ‚ Ø¨Ú¯ÙŠØ± Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙ‡ ÙƒØ§Ø±ÙŠ Ø§Ø² Ø­Ù‚ÙˆÙ‚ Ø«Ø§Ø¨Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠÙƒÙ†Ù†Ø¯ ',0),(305895,8498,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† Ø­Ù‚ÙˆÙ‚ Ø¨Ú¯ÙŠØ± Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙ‡ ÙƒØ§Ø±ÙŠ Ø§Ø² Ø­Ù‚ÙˆÙ‚ Ø«Ø§Ø¨Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠÙƒÙ†Ù†Ø¯ ',0),(305896,8498,'tr','MaaÅŸlÄ± Ã§alÄ±ÅŸanlar dÃ¼zenli Ã¶deme iÃ§in fazla mesai saat kullanÄ±n',0),(305897,8498,'pl','PracownikÃ³w etatowych uÅ¼ywaÄ‡ regularnie zapÅ‚aciÄ‡ za godziny nadliczbowe',0),(305898,8498,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ Ñ€ÐµÐ´Ð¾Ð²Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð·Ð° Ð¸Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´Ð½Ð¸ Ñ‡Ð°ÑÐ¾Ð²Ðµ',0),(305899,8498,'ur','ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ø¨Ø§Ù‚Ø§Ø¹Ø¯Û Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§ÙˆÙˆØ±Ù¹Ø§Ø¦Ù… Ú¯Ú¾Ù†Ù¹ÙˆÚº ØªÚ© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(305900,8498,'sr','Ð¡Ð° Ð¿Ð»Ð°Ñ‚Ð¾Ð¼ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¼Ð¾Ð³Ñƒ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ñ€ÐµÐ´Ð¾Ð²Ð½Ðµ Ð¿Ð»Ð°Ñ‚Ðµ Ð·Ð° Ð¿Ñ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ ÑÐ°Ñ‚Ð¸',0),(305901,8498,'vi','LÆ°Æ¡ng nhÃ¢n viÃªn sá»­ dá»¥ng thanh toÃ¡n thÃ´ng thÆ°á»ng cho giá» lÃ m quÃ¡ háº¡n',0),(305902,8498,'af','Salaris Werknemers gebruik Gereelde Besoldiging vir Oortyd Ure',0),(305903,8498,'ro','AngajaÅ£ii salariaÅ£i utilizeazÄƒ regulat plÄƒteascÄƒ pentru ore suplimentare',0),(305904,8498,'et','Palgaline tÃ¶Ã¶taja kasutada regulaarselt maksma Ã¼letundide',0),(305905,8498,'si','UsluÅ¾bencev uporabljajo redno plaÄilo za nadure',0),(305906,8498,'ba','Gaji karyawan menggunakan teratur membayar untuk jam lembur',0),(305907,8498,'nl','Bezoldigde werknemers gebruiken regelmatige betalen voor overuren',0),(305908,8498,'fi','TyÃ¶ntekijÃ¶iden kÃ¤yttÃ¤Ã¤ sÃ¤Ã¤nnÃ¶llisesti maksaa ylityÃ¶tunnit',0),(305909,8498,'no','FunksjonÃ¦rer bruke vanlige betale for overtidstimer',0),(305910,8498,'da','LÃ¸nnede medarbejdere bruge regelmÃ¦ssige betale for overtid',0),(305911,8498,'ko','ì§ì› ì´ˆê³¼ ê·¼ë¬´ ì‹œê°„ì— ëŒ€ í•œ ì •ê¸°ì ìœ¼ë¡œ ì§€ë¶ˆì„ ì‚¬ìš©í•©ë‹ˆë‹¤',0),(305912,8498,'he','×©×›×™×¨×™× ×œ×”×©×ª×ž×© ×¨×’×™×œ ×œ×©×œ× ×¢×‘×•×¨ ×©×¢×•×ª × ×•×¡×¤×•×ª',0),(305913,8498,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î¿ÏÏ‚ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½ ÎºÎ±Î½Î¿Î½Î¹ÎºÎ¬ Ï€Î»Î·ÏÏŽÏƒÎµÏ„Îµ Î³Î¹Î± Ï…Ï€ÎµÏÏ‰ÏÎ¯ÎµÏ‚',0),(305914,8498,'zh','å—è–ªé›‡å‘˜ä½¿ç”¨å¸¸è§„å·¥èµ„ä½œä¸ºåŠ ç­å·¥èµ„\r\n',0),(305915,8498,'sv','TjÃ¤nstemÃ¤n anvÃ¤nder regelbunden betala fÃ¶r Ã¶vertid',0),(305916,8498,'it','Dipendenti stipendiati uso pagare regolari per ore di lavoro straordinario',0),(305917,8498,'tl','',0),(305918,8498,'th','&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3611;&#3619;&#3632;&#3592;&#3635;&#3586;&#3629;&#3591;&#3594;&#3633;&#3656;&#3623;&#3650;&#3',0),(305919,8498,'hi','à¤µà¥‡à¤¤à¤¨à¤­à¥‹à¤—à¥€ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤®à¤¯à¥‹à¤ªà¤°à¤¿ à¤˜à¤‚à¤Ÿà¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(305920,8498,'ms','Pekerja-pekerja bergaji menggunakan tetap membayar jam kerja lebih masa',0),(305921,8498,'ar','Ø§Ø³ØªØ®Ø¯Ù… Ø§Ø¬ÙŠØ±Ø§ \"Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ù†ØªØ¸Ù…\" \"Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ\"',0),(305922,8498,'fr','SalariÃ©s utilisent la paye rÃ©guliÃ¨re pour les heures supplÃ©mentaires',0),(305923,8498,'jp','ã‚µãƒ©ãƒªãƒ¼å¾“æ¥­å“¡æ®‹æ¥­æ™‚é–“ã®å®šæœŸçš„ãªæ”¯æ‰•ã„ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(305924,8498,'pt','Assalariados usam pagar Regular para as horas extraordinÃ¡rias',0),(305925,8498,'ru','Ð¡Ð»ÑƒÐ¶Ð°Ñ‰Ð¸Ñ… Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ñ€ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ð¾ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð·Ð° ÑÐ²ÐµÑ€Ñ…ÑƒÑ€Ð¾Ñ‡Ð½Ñ‹Ðµ Ñ‡Ð°ÑÑ‹',0),(305926,8498,'es','Empleados Salariados usan Pago Regular para Horas de Sobretiempo',0),(305927,8498,'de','Angestellte Mitarbeiter verwenden regelmÃ¤ÃŸig zu zahlen, fÃ¼r Ãœberstunden',0),(305928,8498,'en','Salaried Employees use Regular Pay for Overtime Hours',0),(305929,8499,'is','',0),(305930,8499,'dr','- ØªÙ…Ø§Ù… Ø³Ø§Ø¹Ø§Øª Ø±Ø§ Ø¨Ù‡ Ø³Ø§Ø¹Ø§Øª ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯ Ù…Ø­Ø¯ÙˆØ¯ ÙƒÙ†ÙŠØ¯ ',0),(305931,8499,'pr','Ø¯Ø§Ø±Ø§Ù‰ Ø­Ù‚ÙˆÙ‚- ØªÙ…Ø§Ù… Ø³Ø§Ø¹Ø§Øª Ø±Ø§ Ø¨Ù‡ Ø³Ø§Ø¹Ø§Øª Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ù…Ø­Ø¯ÙˆØ¯ ÙƒÙ†ÙŠØ¯ ',0),(305932,8499,'tr','MaaÅŸlÄ± - sÄ±nÄ±rÄ± her zaman standart saat',0),(305933,8499,'pl','Wynagrodzenie - Limit caÅ‚y czas do godziny otwarcia',0),(305934,8499,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð° - Ð»Ð¸Ð¼Ð¸Ñ‚ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ñ‡Ð°ÑÐ°',0),(305935,8499,'ur','ØªÙ†Ø®ÙˆØ§Û - Ø­Ø¯ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ú¯Ú¾Ù†Ù¹ÙˆÚº Ú©Û’ Ù„Ø¦Û’ ÛØ± ÙˆÙ‚Øª',0),(305936,8499,'sr','Ð¡Ð° Ð¿Ð»Ð°Ñ‚Ð¾Ð¼ - Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÑšÐµ ÑÐ²Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð´Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ ÑÐ°Ñ‚Ð¸',0),(305937,8499,'vi','LÆ°Æ¡ng - giá»›i háº¡n táº¥t cáº£ thá»i gian tá»›i giá» chuáº©n',0),(305938,8499,'af','Drie - limiet heeltyd standaard uur',0),(305939,8499,'ro','SalariaÅ£i - limitÄƒ tot timpul la Standard de ore',0),(305940,8499,'et','Palgaline - Limit Standardtunnid kogu aeg',0),(305941,8499,'si','Redno zaposleni - omejitev vse Äas, standardni delovni Äas',0),(305942,8499,'ba','Gaji - batas semua waktu standar jam',0),(305943,8499,'nl','Loondienst - limiet aller tijden tot standaard uur',0),(305944,8499,'fi','Palkattuja - raja kaikkien aikojen standardin tuntia',0),(305945,8499,'no','LÃ¸nnsbasert - Limit all tid vanlige timer',0),(305946,8499,'da','LÃ¸nmodtager - grÃ¦nsen hele tiden til standardtimer',0),(305947,8499,'ko','ê¸‰ì—¬-ëª¨ë“  ì‹œê°„ì„ í‘œì¤€ ì‹œê°„ í•œë„',0),(305948,8499,'he','×©×›×™×¨×™× - ×ž×’×‘×œ×ª ×–×ž×Ÿ ×›×œ ×©×¢×•×ª ×ª×§×Ÿ',0),(305949,8499,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î¿Î¯ - ÏŒÏÎ¹Î¿ ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ ÎµÏ€Î¿Ï‡ÏŽÎ½ ÏƒÎµ Ï„Ï…Ï€Î¹ÎºÎ­Ï‚ ÏŽÏÎµÏ‚',0),(305950,8499,'zh','å·¥è–ª- é™åˆ¶æ‰€æœ‰æ—¶é—´åœ¨æ ‡å‡†æ—¶é—´å†…\r\n',0),(305951,8499,'sv','TjÃ¤nstemÃ¤n - Limit all tid till Standard timmar',0),(305952,8499,'it','Stipendiato - limite di tutti i tempi alle ore Standard',0),(305953,8499,'tl','',0),(305954,8499,'th','&#3648;&#3591;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609; - &#3592;&#3635;&#3585;&#3633;&#3604;&#3648;&#3623;&#3621;&#3634;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3648;&#3623;&#3621;&#3634;&#3617;&#3634;&#3605;&#3619;&#3600;',0),(305955,8499,'hi','à¤µà¥‡à¤¤à¤¨à¤­à¥‹à¤—à¥€ - à¤®à¤¾à¤¨à¤• à¤˜à¤‚à¤Ÿà¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾',0),(305956,8499,'ms','Bergaji - had sepanjang masa hingga jam Standard',0),(305957,8499,'ar','Ø£Ø¬ÙŠØ±-Ø­Ø¯ ÙƒÙ„ Ø§Ù„ÙˆÙ‚Øª \"Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©\"',0),(305958,8499,'fr','SalariÃ© - limite tout le temps pour la durÃ©e normale du travail',0),(305959,8499,'jp','ä¿¸çµ¦ç”Ÿæ´»è€… - æ¨™æº–æ™‚é–“ã«ã™ã¹ã¦ã®æ™‚é–“ã®åˆ¶é™',0),(305960,8499,'pt','Assalariado - limite todo tempo para horas padrÃ£o',0),(305961,8499,'ru','ÐÐ°ÐµÐ¼Ð½Ñ‹Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¸ - Ð¿Ñ€ÐµÐ´ÐµÐ» Ð²ÑÐµ Ð²Ñ€ÐµÐ¼Ñ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… Ñ‡Ð°ÑÐ¾Ð²',0),(305962,8499,'es','Salariados - Limitar todo el tiempo a las horas estÃ¡ndares',0),(305963,8499,'de','Angestellte - Limit aller Zeiten zu Stunden',0),(305964,8499,'en','Salaried - Limit all time to Standard Hours',0),(305965,8500,'is','',0),(305966,8500,'dr','( Ø¯ÙˆØ±Ù‡ ØªØ­ØµÙŠÙ„ÙŠ) Ø§Ú¯Ø± Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ',0),(305967,8500,'pr','Ù†Ù¾Ø°ÙŠØ±ÙØªÙ†  Ø²Ù…Ø§Ù†  ÙŠÙƒ Ø¯ÙˆØ±Ù‡ Ø§Ù†Ø¹Ù‚Ø§Ø¯( Ø¯ÙˆØ±Ù‡ ØªØ­ØµÙŠÙ„ÙŠ) Ø§Ú¯Ø± Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ',0),(305968,8500,'tr','AtÄ±n dÄ±ÅŸarÄ± zaman bir seans daha bÃ¼yÃ¼k olursa',0),(305969,8500,'pl','Wrzucam na czas jednej sesji jeÅ›li wiÄ™ksza niÅ¼',0),(305970,8500,'bg','Ð¥Ð²ÑŠÑ€Ð»Ð¸ Ð²ÑŠÐ½ Ð²Ñ€ÐµÐ¼Ðµ ÐµÐ´Ð½Ð° ÑÐµÑÐ¸Ñ Ð°ÐºÐ¾ Ðµ Ð¿Ð¾-Ð³Ð¾Ð»ÑÐ¼Ð° Ð¾Ñ‚',0),(305971,8500,'ur','Ù¾Ú¾ÛŒÙ†Ú© Ú©Ø± ÙˆÙ‚Øª Ø§ÛŒÚ© Ø§Ø¬Ù„Ø§Ø³ ØªÙˆ Ø¨Ú‘Ø§',0),(305972,8500,'sr','Ð‘Ð°Ñ†Ð¸ Ð½Ð°Ð¿Ð¾Ñ™Ðµ Ð¿ÑƒÑ‚ Ñ˜ÐµÐ´Ð½Ð¾Ñ˜ ÑÐµÐ°Ð½ÑÐ¸ Ð°ÐºÐ¾ Ñ˜Ðµ Ð²ÐµÑ›Ð¸ Ð¾Ð´',0),(305973,8500,'vi','NÃ©m thá»i gian 1 pháº§n náº¿u',0),(305974,8500,'af','Gooi uit tyd een sessie as groter',0),(305975,8500,'ro','Arunca Ã®n timp o sesiune dacÄƒ mai mare',0),(305976,8500,'et','Viska lÃ¤bi aja Ã¼he seansi kui suurem',0),(305977,8500,'si','Vrgel ven Äas eni seji Äe je veÄja od',0),(305978,8500,'ba','Melemparkan keluar waktu satu sesi jika lebih besar dari',0),(305979,8500,'nl','Gooien uit een tijdsessie als groter dan',0),(305980,8500,'fi','HeittÃ¤Ã¤ pois yksi istunnosta jos suurempi kuin',0),(305981,8500,'no','Kaste ut tid Ã©n Ã¸kt hvis stÃ¸rre enn',0),(305982,8500,'da','Smide ud tid Ã©n Session hvis stÃ¸rre end',0),(305983,8500,'ko','ë˜ì ¸ ë°–ìœ¼ë¡œ ì‹œê°„ í•˜ë‚˜ì˜ ì„¸ì…˜ ë³´ë‹¤ í° ê²½ìš°',0),(305984,8500,'he','×œ×–×¨×•×§ ××ª ×–×ž×Ÿ ×”×¤×¢×œ×” ××—×ª ×× ×’×“×•×œ ×™×•×ª×¨',0),(305985,8500,'el','Î¡Î¯Î¾ÎµÎ¹ Î­Î¾Ï‰ Ï‡ÏÏŒÎ½Î¿ Î¼Î¯Î± ÏƒÏ…Î½ÎµÎ´ÏÎ¯Î± Î±Î½ ÎµÎ¯Î½Î±Î¹ Î¼ÎµÎ³Î±Î»ÏÏ„ÎµÏÎ· Î±Ï€ÏŒ',0),(305986,8500,'zh','æŠ›å‡ºä¸€ä¸ªä¼šè®®æ—¶ï¼Œå¦‚æžœå¤§äºŽ\r\n',0),(305987,8500,'sv','Kasta ut tid en Session om stÃ¶rre Ã¤n',0),(305988,8500,'it','Buttare fuori tempo una sessione se maggiore di',0),(305989,8500,'tl','',0),(305990,8500,'th','&#3650;&#3618;&#3609;&#3607;&#3636;&#3657;&#3591;&#3588;&#3619;&#3633;&#3657;&#3591;&#3621;&#3632; 1 &#3594;&#3640;&#3604;&#3606;&#3657;&#3634;&#3651;&#3627;&#3597;&#3656;&#3585;&#3623;&#3656;&#3634;',0),(305991,8500,'hi','à¤«à¥‡à¤‚à¤• à¤¬à¤¾à¤¹à¤° à¤¸à¤®à¤¯ à¤à¤• à¤¸à¤¤à¥à¤° à¤¯à¤¦à¤¿ à¤…à¤§à¤¿à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(305992,8500,'ms','Membuang keluar masa satu sesi jika lebih besar daripada',0),(305993,8500,'ar','Ø±Ù…ÙŠ Ø¨Ù‡Ø§ ÙˆÙ‚Øª Ø¯ÙˆØ±Ø© ÙˆØ§Ø­Ø¯Ø© Ø¥Ø°Ø§ ÙƒØ§Ù†Øª Ø£ÙƒØ¨Ø± Ù…Ù†',0),(305994,8500,'fr','Throw Out moment une Session si supÃ©rieure Ã ',0),(305995,8500,'jp','ã‚¹ãƒ­ãƒ¼ ã‚¢ã‚¦ãƒˆæ™‚é–“ 1 ã¤ã®ã‚»ãƒƒã‚·ãƒ§ãƒ³å€¤ã‚’è¶…ãˆã‚‹å ´åˆ',0),(305996,8500,'pt','Jogue fora tempo uma sessÃ£o se maior do que',0),(305997,8500,'ru','Ð‘Ñ€Ð¾ÑÐ°Ñ‚ÑŒ, Ð²Ñ€ÐµÐ¼Ñ Ð¾Ð´Ð½Ð¾Ð¹ ÑÐµÑÑÐ¸Ð¸, ÐµÑÐ»Ð¸ Ð±Ð¾Ð»ÑŒÑˆÐµ, Ñ‡ÐµÐ¼',0),(305998,8500,'es','Desechar SesiÃ³n de Tiempo Uno si es MÃ¡s Grande Que',0),(305999,8500,'de','Werfen, mal eine Sitzung wenn grÃ¶ÃŸer',0),(306000,8500,'en','Throw Out Time One Session if Greater Than',0),(306001,8501,'is','',0),(306002,8501,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø¨Ø± Ø³Ø§Ø¹Øª        ',0),(306003,8501,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø¨Ø± Ø³Ø§Ø¹Øª        ',0),(306004,8501,'tr','Ort/saat',0),(306005,8501,'pl','Åšrednia na godzinÄ™.',0),(306006,8501,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð°/Ñ‡Ð°Ñ',0),(306007,8501,'ur','Avg. ÙÛŒ Ú¯Ú¾Ù†Ù¹Û',0),(306008,8501,'sr','ÐŸÑ€Ð¾Ñ./ÑÐ°Ñ‚',0),(306009,8501,'vi','Trung BÃ¬nh/Giá»',0),(306010,8501,'af','Gemidd./Uur',0),(306011,8501,'ro','Medie pe orÄƒ',0),(306012,8501,'et','Keskm/tund',0),(306013,8501,'si','AVG./uro',0),(306014,8501,'ba','Rata-rata/jam',0),(306015,8501,'nl','Gem. / uur',0),(306016,8501,'fi','KeskimÃ¤Ã¤rÃ¤inen/tunti',0),(306017,8501,'no','Gj.snittlig/time',0),(306018,8501,'da','AVG./time',0),(306019,8501,'ko','í‰ê· /ì‹œê°„',0),(306020,8501,'he','×ž×ž×•×¦×¢ ×œ×©×¢×”',0),(306021,8501,'el','Îœ.Î¿. / ÏŽÏÎ±',0),(306022,8501,'zh','å¹³å‡/å°æ—¶\r\n',0),(306023,8501,'sv','AVG./timme',0),(306024,8501,'it','AVG/ora',0),(306025,8501,'tl','',0),(306026,8501,'th','&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(306027,8501,'hi','à¤”à¤¸à¤¤/à¤˜à¤‚à¤Ÿà¤¾',0),(306028,8501,'ms','Purata/jam',0),(306029,8501,'ar','Ù…ØªÙˆØ³Ø· ÙƒÙ„ Ø³Ø§Ø¹Ø©',0),(306030,8501,'fr','Prix moyen/heure',0),(306031,8501,'jp','å¹³å‡/æ™‚é–“',0),(306032,8501,'pt','MÃ©dia/hora',0),(306033,8501,'ru','Ð¡Ñ€ÐµÐ´Ð½ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ/Ñ‡Ð°Ñ',0),(306034,8501,'es','Prom. /Hora',0),(306035,8501,'de','AVG/Stunde',0),(306036,8501,'en','Avg./Hour',0),(306037,8502,'is','',0),(306038,8502,'dr','Ø¯Ù„ÙŠÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯ÙŠÚ¯Ø±',0),(306039,8502,'pr','Ø¯Ù„ÙŠÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯ÙŠÚ¯Ø±',0),(306040,8502,'tr','BaÅŸka bir Ã¶deme nedeni',0),(306041,8502,'pl','Innym powodem zapÅ‚aciÄ‡',0),(306042,8502,'bg','Ð”Ñ€ÑƒÐ³Ð° Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(306043,8502,'ur','Ø¯ÛŒÚ¯Ø± ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ ÙˆØ¬Û',0),(306044,8502,'sr','Ð”Ñ€ÑƒÐ³Ð¸ Ñ€Ð°Ð·Ð»Ð¾Ð³ Ð·Ð° Ð¿Ð»Ð°Ñ‚Ðµ',0),(306045,8502,'vi','NguyÃªn nhÃ¢n tráº£ KhÃ¡c',0),(306046,8502,'af','Ander Besoldiging Rede',0),(306047,8502,'ro','Alt motiv de plata',0),(306048,8502,'et','Muud tasu pÃµhjus',0),(306049,8502,'si','Drugi razlog za plaÄilo',0),(306050,8502,'ba','Alasan lain membayar',0),(306051,8502,'nl','Andere reden Pay',0),(306052,8502,'fi','Toinen maksu syy',0),(306053,8502,'no','Annet lÃ¸nn',0),(306054,8502,'da','Andre Pay grund',0),(306055,8502,'ko','ë‹¤ë¥¸ ì§€ë¶ˆ ì´ìœ ',0),(306056,8502,'he','×¢×•×“ ×¡×™×‘×” ×œ×©×œ×',0),(306057,8502,'el','Î†Î»Î»Î¿ Î»ÏŒÎ³Î¿ Î±Î¼Î¿Î¹Î²Î®Ï‚',0),(306058,8502,'zh','å…¶ä»–æ”¶è´¹çš„åŽŸå› \r\n',0),(306059,8502,'sv','Andra betala anledning',0),(306060,8502,'it','Altro motivo di pagare',0),(306061,8502,'tl','',0),(306062,8502,'th','&#3648;&#3627;&#3605;&#3640;&#3612;&#3621;&#3651;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3629;&#3639;&#3656;&#3609;',0),(306063,8502,'hi','à¤…à¤¨à¥à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤•à¤¾à¤°à¤£',0),(306064,8502,'ms','Sebab gaji lain',0),(306065,8502,'ar','ÙˆØ§Ù„Ø³Ø¨Ø¨ Ø§Ù„Ø¢Ø®Ø± ÙÙŠ Ø§Ù„Ø£Ø¬Ø±',0),(306066,8502,'fr','Autre raison de la rÃ©munÃ©ration',0),(306067,8502,'jp','ä»–ã®æœ‰æ–™ã®ç†ç”±',0),(306068,8502,'pt','Outro motivo de pagamento',0),(306069,8502,'ru','Ð”Ñ€ÑƒÐ³Ð°Ñ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð° ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ðµ',0),(306070,8502,'es','Otra RazÃ³n de Pago',0),(306071,8502,'de','Andere Pay-Grund',0),(306072,8502,'en','Other Pay Reason',0),(306073,8503,'is','',0),(306074,8503,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(306075,8503,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(306076,8503,'tr','ParÃ§a baÅŸÄ± iÅŸ toplamlarÄ±',0),(306077,8503,'pl','Sumy pracy akordowej',0),(306078,8503,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ ÑÑƒÐ¼Ð¸',0),(306079,8503,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ù…ÛŒØ²Ø§Ù†',0),(306080,8503,'sr','Ð—Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(306081,8503,'vi','Tá»•ng cá»™ng Viá»‡c khoÃ¡n',0),(306082,8503,'af','Stukwerk Totale',0),(306083,8503,'ro','Total de acord',0),(306084,8503,'et','TÃ¼kitÃ¶Ã¶ kogusummad',0),(306085,8503,'si','Akord vsote',0),(306086,8503,'ba','Total piecework',0),(306087,8503,'nl','Stukloon totalen',0),(306088,8503,'fi','Urakka summat',0),(306089,8503,'no','StykkavlÃ¸nning totaler',0),(306090,8503,'da','Akkordarbejde totaler',0),(306091,8503,'ko','Piecework í•©ê³„',0),(306092,8503,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª ×¡×›×•×ž×™×',0),(306093,8503,'el','Î£ÏÎ½Î¿Î»Î± ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(306094,8503,'zh','è®¡ä»¶æ±‡æ€»\r\n',0),(306095,8503,'sv','Ackord summor',0),(306096,8503,'it','Lavoro a cottimo totali',0),(306097,8503,'tl','',0),(306098,8503,'th','&#3619;&#3623;&#3617;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3594;&#3636;&#3657;&#3609;',0),(306099,8503,'hi','Piecework à¤¯à¥‹à¤—',0),(306100,8503,'ms','Jumlah piecework',0),(306101,8503,'ar','Ù…Ø¬Ø§Ù…ÙŠØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(306102,8503,'fr','Totaux Ã  la piÃ¨ce',0),(306103,8503,'jp','å‡ºæ¥é«˜åˆè¨ˆ',0),(306104,8503,'pt','Totais de trabalho por tarefa',0),(306105,8503,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ',0),(306106,8503,'es','Totales de Trabajo por Pieza',0),(306107,8503,'de','Akkord-Summen',0),(306108,8503,'en','Piecework Totals',0),(306109,8504,'is','',0),(306110,8504,'dr','Ù†Ù…Ø§ÙŠØ´ ÙˆØ¶Ø¹ÙŠØª ØªÙ…Ø§Ù… ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(306111,8504,'pr','Ù†Ù…Ø§ÙŠØ´ ÙˆØ¶Ø¹ÙŠØª ØªÙ…Ø§Ù… ÙƒØ§Ø±Ù…Ù†Ø¯Ø§Ù† ',0),(306112,8504,'tr','TÃ¼m Ã§alÄ±ÅŸanlarÄ±n durumunu gÃ¶rÃ¼ntÃ¼leme',0),(306113,8504,'pl','WyÅ›wietlanie stanu wszystkich pracownikÃ³w',0),(306114,8504,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(306115,8504,'ur','ØªÙ…Ø§Ù… Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©ÛŒ Ø­Ø§Ù„Øª Ù…Ù†Ø¸Ø± Ú©Ø±ÛŒÚº',0),(306116,8504,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÑÑ‚Ð°Ñ‚ÑƒÑÐ° ÑÐ²Ð¸Ñ… Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(306117,8504,'vi','Xem tÃ¬nh tráº¡ng táº¥t cáº£ nhÃ¢n viÃªn',0),(306118,8504,'af','Besigting Status van alle Werknemers',0),(306119,8504,'ro','Vezi starea tuturor angajaÅ£ilor',0),(306120,8504,'et','Vaata kÃµikite tÃ¶Ã¶tajate staatust',0),(306121,8504,'si','PrikaÅ¾i stanje vseh zaposlenih',0),(306122,8504,'ba','Melihat Status semua karyawan',0),(306123,8504,'nl','Bekijk de Status van alle medewerkers',0),(306124,8504,'fi','Tarkastella kaikkien tyÃ¶ntekijÃ¶iden',0),(306125,8504,'no','Vis alle ansatte',0),(306126,8504,'da','Se Status alle medarbejdere',0),(306127,8504,'ko','ëª¨ë“  ì§ì› ìƒíƒœ ë³´ê¸°',0),(306128,8504,'he','×œ×”×¦×™×’ ××ª ×ž×¦×‘ ×›×œ ×”×¢×•×‘×“×™×',0),(306129,8504,'el','Î ÏÎ¿Î²Î¬Î»ÎµÏ„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(306130,8504,'zh','æŸ¥çœ‹çŠ¶æ€æ‰€æœ‰é›‡å‘˜\r\n',0),(306131,8504,'sv','Visa Status fÃ¶r alla anstÃ¤llda',0),(306132,8504,'it','Visualizzare lo stato di tutti i dipendenti',0),(306133,8504,'tl','',0),(306134,8504,'th','&#3649;&#3626;&#3604;&#3591;&#3626;&#3606;&#3634;&#3609;&#3632;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(306135,8504,'hi','à¤¸à¤­à¥€ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(306136,8504,'ms','Lihat Status semua kakitangan',0),(306137,8504,'ar','Ø¹Ø±Ø¶ Ø­Ø§Ù„Ø© ÙƒØ§ÙØ© Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(306138,8504,'fr','Afficher le statut de tous les employÃ©s',0),(306139,8504,'jp','ã™ã¹ã¦ã®å¾“æ¥­å“¡ã®ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(306140,8504,'pt','Ver os Status de todos os funcionÃ¡rios',0),(306141,8504,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¡Ñ‚Ð°Ñ‚ÑƒÑÐ° Ð’ÑÐµÑ… Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(306142,8504,'es','Ver Status Todos los Empleados',0),(306143,8504,'de','Anzeigen des Status aller Mitarbeiter',0),(306144,8504,'en','View Status All Employees',0),(306145,8505,'is','',0),(306146,8505,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(306147,8505,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(306148,8505,'tr','Ä°ÅŸ numarasÄ± gerekli',0),(306149,8505,'pl','Numer zadania wymagane',0),(306150,8505,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð¸Ð·Ð¸ÑÐºÐ²Ð°',0),(306151,8505,'ur','Ø¶Ø±ÙˆØ±Øª Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(306152,8505,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð°Ð½ Ð±Ñ€Ð¾Ñ˜ Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(306153,8505,'vi','YÃªu cáº§u sá»‘ Job',0),(306154,8505,'af','Werkstuknommer Benodig',0),(306155,8505,'ro','NumÄƒr de Job necesare',0),(306156,8505,'et','Vajaliku tÃ¶Ã¶kohtade arvu',0),(306157,8505,'si','Å tevilka projekta, ki zahteva',0),(306158,8505,'ba','Jumlah pekerjaan yang sesuai',0),(306159,8505,'nl','Projectnummer vereist',0),(306160,8505,'fi','TyÃ¶n numero vaaditaan',0),(306161,8505,'no','Jobbnummer kreves',0),(306162,8505,'da','Jobnummer krÃ¦ves',0),(306163,8505,'ko','ìž‘ì—… ë²ˆí˜¸',0),(306164,8505,'he','× ×“×¨×© ×ž×¡×¤×¨ ×”×¢×‘×•×“×”',0),(306165,8505,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(306166,8505,'zh','éœ€è¦çš„å·¥ä½œç¼–å·\r\n',0),(306167,8505,'sv','Projektnumret krÃ¤vs',0),(306168,8505,'it','Numero di lavoro richiesto',0),(306169,8505,'tl','',0),(306170,8505,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3591;&#3634;&#3609;',0),(306171,8505,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(306172,8505,'ms','Jumlah kerja yang diperlukan',0),(306173,8505,'ar','Ø±Ù‚Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(306174,8505,'fr','NumÃ©ro d\'emploi requis',0),(306175,8505,'jp','ã‚¸ãƒ§ãƒ–ç•ªå·ãŒå¿…è¦ã§ã™ã€‚',0),(306176,8505,'pt','NÃºmero de trabalho necessÃ¡rios',0),(306177,8505,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ',0),(306178,8505,'es','NÃºmero de Trabajp Requerido',0),(306179,8505,'de','Job-Nummer erforderlich',0),(306180,8505,'en','Job Number Required',0),(306181,8506,'is','',0),(306182,8506,'dr','Ù†Ø±Ø® Ø¯ÙŠÚ¯Ø±',0),(306183,8506,'pr','Ù†Ø±Ø® Ø¯ÙŠÚ¯Ø±',0),(306184,8506,'tr','DiÄŸer oranÄ±',0),(306185,8506,'pl','Inne stawki',0),(306186,8506,'bg','Ð”Ñ€ÑƒÐ³Ð¸ ÐºÑƒÑ€Ñ',0),(306187,8506,'ur','Ø¯ÛŒÚ¯Ø± Ø´Ø±Ø­',0),(306188,8506,'sr','Ð”Ñ€ÑƒÐ³Ðµ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(306189,8506,'vi','GiÃ¡ KhÃ¡c',0),(306190,8506,'af','Ander Tarief',0),(306191,8506,'ro','Rata de alte',0),(306192,8506,'et','Teist mÃ¤Ã¤ra',0),(306193,8506,'si','Druga stopnja',0),(306194,8506,'ba','Tingkat lain',0),(306195,8506,'nl','Andere tarief',0),(306196,8506,'fi','Toista tasoa',0),(306197,8506,'no','Andre rente',0),(306198,8506,'da','Anden Rate',0),(306199,8506,'ko','ë‹¤ë¥¸ ì†ë„',0),(306200,8506,'he','×©×™×¢×•×¨ ××—×¨',0),(306201,8506,'el','Î†Î»Î»Î± Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(306202,8506,'zh','å…¶ä»–åˆ©çŽ‡\r\n',0),(306203,8506,'sv','Andra pris',0),(306204,8506,'it','Altro tasso',0),(306205,8506,'tl','',0),(306206,8506,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3629;&#3639;&#3656;&#3609;',0),(306207,8506,'hi','à¤…à¤¨à¥à¤¯ à¤¦à¤°',0),(306208,8506,'ms','Kadar lain',0),(306209,8506,'ar','Ù…Ø¹Ø¯Ù„',0),(306210,8506,'fr','Autre taux',0),(306211,8506,'jp','ä»–ã®ãƒ¬ãƒ¼ãƒˆ',0),(306212,8506,'pt','Outra taxa',0),(306213,8506,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(306214,8506,'es','Otra Tasa',0),(306215,8506,'de','Andere Rate',0),(306216,8506,'en','Other Rate',0),(306217,8507,'is','',0),(306218,8507,'dr','Ù†Ø±Ø® Ø¯ÙŠÚ¯Ø± Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªÙˆØ¶ÙŠØ­ Ø¯Ø§Ø±Ø¯',0),(306219,8507,'pr','Ù†Ø±Ø® Ø¯ÙŠÚ¯Ø± Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªÙˆØ¶ÙŠØ­ Ø¯Ø§Ø±Ø¯',0),(306220,8507,'tr','DiÄŸer oran aÃ§Ä±klama gerektirir',0),(306221,8507,'pl','Inne wymagajÄ… wyjaÅ›nienia',0),(306222,8507,'bg','Ð”Ñ€ÑƒÐ³Ð°Ñ‚Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð¸Ð·Ð¸ÑÐºÐ²Ð° Ð¾Ð±ÑÑÐ½ÐµÐ½Ð¸Ðµ',0),(306223,8507,'ur','Ø¯ÛŒÚ¯Ø± Ø´Ø±Ø­ ÙˆØ¶Ø§Ø­Øª Ø¯Ø±Ú©Ø§Ø± ÛÛ’',0),(306224,8507,'sr','Ð”Ñ€ÑƒÐ³Ðµ Ð²Ð°Ð»ÑƒÑ‚Ðµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð¾Ð±Ñ˜Ð°ÑˆÑšÐµÑšÐµ',0),(306225,8507,'vi','GiÃ¡ KhÃ¡c cáº§n giáº£i thÃ­ch',0),(306226,8507,'af','Ander Tarief Benodig Verduideliking',0),(306227,8507,'ro','Alte rata necesitÄƒ explicaÅ£ii',0),(306228,8507,'et','Teist mÃ¤Ã¤ra nÃµuab selgitust',0),(306229,8507,'si','Druga stopnja zahteva pojasnilo',0),(306230,8507,'ba','Harga lain memerlukan penjelasan',0),(306231,8507,'nl','Andere tarief vereist uitleg',0),(306232,8507,'fi','Toista tasoa vaatii selitystÃ¤',0),(306233,8507,'no','Andre krever forklaring',0),(306234,8507,'da','Andre sats krÃ¦ver forklaring',0),(306235,8507,'ko','ë‹¤ë¥¸ ì†ë„ í•„ìš” ì„¤ëª…',0),(306236,8507,'he','×§×¦×‘ ××—×¨×™× ×“×•×¨×© ×”×¡×‘×¨',0),(306237,8507,'el','Î†Î»Î»Î± Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î±Ï€Î±Î¹Ï„ÎµÎ¯ ÎµÎ¾Î®Î³Î·ÏƒÎ·',0),(306238,8507,'zh','éœ€è¦è¯´æ˜Žçš„å…¶ä»–åˆ©çŽ‡\r\n',0),(306239,8507,'sv','Andra frekvens krÃ¤ver fÃ¶rklaring',0),(306240,8507,'it','Altro tasso richiede spiegazione',0),(306241,8507,'tl','',0),(306242,8507,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3629;&#3633;&#3605;&#3619;&#3634;&#3629;&#3639;&#3656;&#3609;',0),(306243,8507,'hi','à¤…à¤¨à¥à¤¯ à¤¦à¤° à¤¸à¥à¤ªà¤·à¥à¤Ÿà¥€à¤•à¤°à¤£ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(306244,8507,'ms','Kadar lain memerlukan penjelasan',0),(306245,8507,'ar','Ù…Ø¹Ø¯Ù„ Ø§Ù„Ø£Ø®Ø±Ù‰ ÙŠØªØ·Ù„Ø¨ ØªÙØ³ÙŠØ±Ø§Ù‹',0),(306246,8507,'fr','Autre frÃ©quence nÃ©cessite une explication',0),(306247,8507,'jp','ä»–ã®ãƒ¬ãƒ¼ãƒˆã«ã¯èª¬æ˜ŽãŒå¿…è¦ã§ã™ã€‚',0),(306248,8507,'pt','Outra taxa requer explicaÃ§Ã£o',0),(306249,8507,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ Ð¾Ð±ÑŠÑÑÐ½ÐµÐ½Ð¸Ð¹',0),(306250,8507,'es','Otra Tasa se Requiere ExplicaciÃ³n',0),(306251,8507,'de','Andere Rate muss erklÃ¤ren',0),(306252,8507,'en','Other Rate Requires Explanation',0),(306253,8508,'is','',0),(306254,8508,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(306255,8508,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(306256,8508,'tr','Kaydedilen',0),(306257,8508,'pl','Zapisane',0),(306258,8508,'bg','Ð—Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸',0),(306259,8508,'ur','Ù†Ø¬Ø§Øª',0),(306260,8508,'sr','Ð¡Ð¿Ð°ÑÐ¸Ð¾',0),(306261,8508,'vi','Sao lÆ°u',0),(306262,8508,'af','Gestoor',0),(306263,8508,'ro','Salvate',0),(306264,8508,'et','Salvestatud',0),(306265,8508,'si','Shranjene',0),(306266,8508,'ba','Disimpan',0),(306267,8508,'nl','Opgeslagen',0),(306268,8508,'fi','Tallennettu',0),(306269,8508,'no','Lagret',0),(306270,8508,'da','Gemt',0),(306271,8508,'ko','ì €ìž¥',0),(306272,8508,'he','× ×©×ž×¨',0),(306273,8508,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯',0),(306274,8508,'zh','ä¿å­˜\r\n',0),(306275,8508,'sv','Sparade',0),(306276,8508,'it','Salvati',0),(306277,8508,'tl','',0),(306278,8508,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3649;&#3621;&#3657;&#3623;',0),(306279,8508,'hi','à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(306280,8508,'ms','Disimpan',0),(306281,8508,'ar','Ø­ÙØ¸',0),(306282,8508,'fr','SauvÃ©',0),(306283,8508,'jp','ä¿å­˜',0),(306284,8508,'pt','Salvo',0),(306285,8508,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¾',0),(306286,8508,'es','Guardado',0),(306287,8508,'de','Gespeichert',0),(306288,8508,'en','Saved',0),(306289,8509,'is','',0),(306290,8509,'dr','Ø¢Ø¯Ø±Ø³ Ù‡Ø§ÙŠ Ù…Ø¬Ø§Ø² ÙƒÙ†ØªØ±Ù„ Ø§Ø±ØªØ¨Ø§Ø· Ú©Ø§Ù…Ù¾ÙŠÙˆØªØ±Ù‡Ø§ Ø¯Ø± Ø´Ø¨Ú©Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(306291,8509,'pr','Ø¢Ø¯Ø±Ø³ Ù‡Ø§ÙŠ Ù…Ø¬Ø§Ø² ÙƒÙ†ØªØ±Ù„ Ø§Ø±ØªØ¨Ø§Ø· Ú©Ø§Ù…Ù¾ÙŠÙˆØªØ±Ù‡Ø§ Ø¯Ø± Ø´Ø¨Ú©Ù‡ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(306292,8509,'tr','IP adresleri',0),(306293,8509,'pl','Dozwolone adresy IP',0),(306294,8509,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾ IP Ð°Ð´Ñ€ÐµÑÐ¸',0),(306295,8509,'ur','IP Ù¾ØªÙˆÚº Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(306296,8509,'sr','Ð”Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾ Ð˜ÐŸ Ð°Ð´Ñ€ÐµÑÐµ',0),(306297,8509,'vi','Cho PhÃ©p Äá»‹a Chá»‰ IP',0),(306298,8509,'af','Toegelate IP Adresse',0),(306299,8509,'ro','Permis adresele IP',0),(306300,8509,'et','Lubatud IP-aadressid',0),(306301,8509,'si','Dovoljeno IP naslove',0),(306302,8509,'ba','Diperbolehkan alamat IP',0),(306303,8509,'nl','Toegestane IP adressen',0),(306304,8509,'fi','Internet IP-osoitteet',0),(306305,8509,'no','BÃ¥ndbredde avgrensninger',0),(306306,8509,'da','Tilladt IP adresser',0),(306307,8509,'ko','IP ì£¼ì†Œ í—ˆìš©',0),(306308,8509,'he','×ž××•×¤×©×¨×•×ª IP ×›×ª×•×‘×•×ª',0),(306309,8509,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ IP-Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚',0),(306310,8509,'zh','å…è®¸çš„IPåœ°å€\r\n',0),(306311,8509,'sv','TillÃ¥tna IP-adresser',0),(306312,8509,'it','Ammessi gli indirizzi IP',0),(306313,8509,'tl','',0),(306314,8509,'th','&#3648;&#3621;&#3586;&#3619;&#3627;&#3633;&#3626;&#3611;&#3619;&#3632;&#3592;&#3635;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(306315,8509,'hi','IP à¤ªà¤¤à¥‹à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(306316,8509,'ms','Alamat IP yang dibenarkan',0),(306317,8509,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¹Ù†Ø§ÙˆÙŠÙ† IP',0),(306318,8509,'fr','Permis d\'adresses IP',0),(306319,8509,'jp','IP ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’è¨±å¯',0),(306320,8509,'pt','Permitido endereÃ§os IP',0),(306321,8509,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð½Ñ‹Ð¹ IP ÐÐ´Ñ€ÐµÑ',0),(306322,8509,'es','Permitidos Direcciones de IP',0),(306323,8509,'de','IP-Adressen zulÃ¤ssig',0),(306324,8509,'en','Allowed IP Addresses',0),(306325,8510,'is','',0),(306326,8510,'dr','( ÙƒÙ†ØªØ±Ù„ Ø§Ø±ØªØ¨Ø§Ø· ÙƒØ§Ù…ÙŠÙˆØªØ±Ù‡Ø§ Ø¯Ø± Ø´Ø¨ÙƒÙ‡) Ù…ÙŠ ØªÙˆØ§Ù†Ù†Ø¯ Ø¨Ù‡ Ø§ÙŠÙ† Ø³Ø§ÙØª ÙˆÛŒØ± Ø¯Ø³ØªØ±Ø³ÙŠ Ù¾ÙŠØ¯Ø§ ÙƒÙ†Ù†Ø¯ ',0),(306327,8510,'pr','Ù‡Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø¨Ø§ Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ Ù‡Ø§ÙŠ Ø¢ÙŠ Ù¾ÙŠ( ÙƒÙ†ØªØ±Ù„ Ø§Ø±ØªØ¨Ø§Ø· ÙƒØ§Ù…ÙŠÙˆØªØ±Ù‡Ø§ Ø¯Ø± Ø´Ø¨ÙƒÙ‡) Ù…ÙŠ ØªÙˆØ§Ù†Ù†Ø¯ Ø¨Ù‡ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø¯Ø³ØªØ±Ø³ÙŠ Ù¾ÙŠØ¯Ø§ ÙƒÙ†Ù†Ø¯ ',0),(306328,8510,'tr','TÃ¼m kullanÄ±cÄ±larÄ±n sistem bu IP adreslerinden eriÅŸebilirsiniz',0),(306329,8510,'pl','Wszystkie uÅ¼ytkownicy majÄ… dostÄ™p do systemu z tych adresÃ³w IP',0),(306330,8510,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸ Ð¸Ð¼Ð°Ñ‚ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð¾Ñ‚ Ñ‚ÐµÐ·Ð¸ IP Ð°Ð´Ñ€ÐµÑÐ¸',0),(306331,8510,'ur','ØªÙ…Ø§Ù… ØµØ§Ø±ÙÛŒÙ† Ø³Û’ ÛŒÛ IP Ù¾ØªÛ’ Ù†Ø¸Ø§Ù… ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ø­Ø§ØµÙ„ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(306332,8510,'sr','Ð¡Ð²Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ ÑÐ° Ñ‚Ð¸Ñ… Ð˜ÐŸ Ð°Ð´Ñ€ÐµÑÐ°',0),(306333,8510,'vi','Táº¥t Cáº£ NgÆ°á»i Sá»­ Dá»¥ng CÃ³ Thá»ƒ Truy Cáº­p NolaPro Tá»« Nhá»¯ng Äá»‹a Chá»‰ IP nÃ y',0),(306334,8510,'af','Alle Gebruikers met Hierdie IP Adresse kan toegang verkry tot NolaPro',0),(306335,8510,'ro','ToÅ£i utilizatorii pot accesa sistemul la aceste adrese IP',0),(306336,8510,'et','KÃµik kasutaja pÃ¤Ã¤seb sÃ¼steem need IP-aadressid',0),(306337,8510,'si','Vsi uporabniki lahko dostopajo do sistema iz teh IP naslovov',0),(306338,8510,'ba','Semua pengguna dapat mengakses sistem dari alamat IP ini',0),(306339,8510,'nl','Alle gebruikers kunnen toegang krijgen tot het systeem van deze IP-adressen',0),(306340,8510,'fi','Kaikki kÃ¤yttÃ¤jÃ¤t voivat kÃ¤yttÃ¤Ã¤ jÃ¤rjestelmÃ¤n nÃ¤mÃ¤ IP-osoitteet',0),(306341,8510,'no','Alle brukere har tilgang til systemet fra disse IP-adresser',0),(306342,8510,'da','Alle brugere kan fÃ¥ adgang til systemet fra disse IP-adresser',0),(306343,8510,'ko','ì´ëŸ¬í•œ IP ì£¼ì†Œì—ì„œ ëª¨ë“  ì‚¬ìš©ìžê°€ ì‹œìŠ¤í…œì— ì•¡ì„¸ìŠ¤í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(306344,8510,'he','×›×œ ×”×ž×©×ª×ž×©×™× ×™×›×•×œ×™× ×œ×’×©×ª ×œ×ž×¢×¨×›×ª ×ž×›×ª×•×‘×•×ª IP ××œ×”',0),(306345,8510,'el','ÎŒÎ»Î¿Î¹ Î¿Î¹ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Î­Ï‡Î¿Ï…Î½ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î± Î±Ï€ÏŒ Î±Ï…Ï„Î­Ï‚ Ï„Î¹Ï‚ Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚ IP',0),(306346,8510,'zh','æ‰€æœ‰ç”¨æˆ·éƒ½å¯ä»¥ä»Žè¿™äº›IPåœ°å€è®¿é—®ç³»ç»Ÿ',0),(306347,8510,'sv','Alla anvÃ¤ndare kan komma Ã¥t systemet frÃ¥n dessa IP-adresser',0),(306348,8510,'it','Tutti gli utenti possono accedere al sistema da questi indirizzi IP',0),(306349,8510,'tl','',0),(306350,8510,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3640;&#3585;&#3588;&#3609;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656; NolaPro &#3652;&#3604;&#3657;&#3592;&#3634;&#3585;&#3619;&#3627;&#3633;&#3626; IP Addr',0),(306351,8510,'hi','à¤¸à¤­à¥€ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤‡à¤¨ IP à¤ªà¤¤à¥‡ à¤¸à¥‡ à¤ªà¤¹à¥à¤à¤š à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(306352,8510,'ms','Semua pengguna boleh mengakses sistem ini dari alamat IP',0),(306353,8510,'ar','ÙŠÙ…ÙƒÙ† Ù„ÙƒØ§ÙØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„ÙˆØµÙˆÙ„ Ø§Ù„Ù†Ø¸Ø§Ù… Ù…Ù† Ø¹Ù†Ø§ÙˆÙŠÙ† IP Ù‡Ø°Ù‡',0),(306354,8510,'fr','Tous les utilisateurs peuvent accÃ©der au systÃ¨me de ces adresses IP',0),(306355,8510,'jp','ã“ã‚Œã‚‰ã® IP ã‚¢ãƒ‰ãƒ¬ã‚¹ã‹ã‚‰ã®ã™ã¹ã¦ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ãŒã‚·ã‚¹ãƒ†ãƒ ã«ã‚¢ã‚¯ã‚»ã‚¹ã§ãã¾ã™ã€‚',0),(306356,8510,'pt','Todos os usuÃ¡rios podem acessar o sistema desses endereÃ§os IP',0),(306357,8510,'ru','Ð’ÑÐµ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸ ÐœÐ¾Ð³ÑƒÑ‚ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒÑÑ NolaPro Ð¡ Ð”Ð°Ð½Ð½Ð¾Ð³Ð¾ IP ÐÐ´Ñ€ÐµÑÐ°',0),(306358,8510,'es','Todos los Usuarios Pueden Accesar NolaPro de Estas Direcciones de IP',0),(306359,8510,'de','Alle Benutzer kÃ¶nnen das System von diesen IP-Adressen zugreifen.',0),(306360,8510,'en','All Users Can Access The System From These IP Addresses',0),(306361,8511,'is','',0),(306362,8511,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ±Ø¯Ù† Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ ',0),(306363,8511,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ±Ø¯Ù† Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ ',0),(306364,8511,'tr','Hata iÅŸleme sorgu',0),(306365,8511,'pl','BÅ‚Ä…d przetwarzania kwerendy',0),(306366,8511,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ°Ñ‚Ð°',0),(306367,8511,'ur','Ù†Ù‚Øµ Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ø·Ù„Ø¨',0),(306368,8511,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¾Ð±Ñ€Ð°Ð´Ðµ ÑƒÐ¿Ð¸Ñ‚Ð°',0),(306369,8511,'vi','Xá»­ lÃ½ truy váº¥n bá»‹ lá»—i',0),(306370,8511,'af','Fout verwerking navraag',0),(306371,8511,'ro','Interogare de prelucrare eroare',0),(306372,8511,'et','PÃ¤ringu tÃ¶Ã¶tlemisel ilmnes tÃµrge',0),(306373,8511,'si','Napaka pri obdelavi poizvedbe',0),(306374,8511,'ba','Kesalahan pengolahan permintaan',0),(306375,8511,'nl','Fout Processing Query',0),(306376,8511,'fi','Virhe kÃ¤sittely kyselyÃ¤',0),(306377,8511,'no','Feil behandling spÃ¸rring',0),(306378,8511,'da','Fejl forarbejdning forespÃ¸rgsel',0),(306379,8511,'ko','ì˜¤ë¥˜ ì²˜ë¦¬ ì¿¼ë¦¬',0),(306380,8511,'he','×©×’×™××” ×‘×¢×™×‘×•×“ ×©××™×œ×ª×”',0),(306381,8511,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎµÏÏ‰Ï„Î®Î¼Î±Ï„Î¿Ï‚',0),(306382,8511,'zh','é”™è¯¯å¤„ç†æŸ¥è¯¢',0),(306383,8511,'sv','Fel behandling frÃ¥gan',0),(306384,8511,'it','Errore elaborazione Query',0),(306385,8511,'tl','',0),(306386,8511,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3588;&#3636;&#3623;&#3619;&#3637;',0),(306387,8511,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥à¤µà¥‡à¤°à¥€',0),(306388,8511,'ms','Ralat pemprosesan pertanyaan',0),(306389,8511,'ar','Ø®Ø·Ø£ ÙÙŠ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ø§Ø³ØªØ¹Ù„Ø§Ù…',0),(306390,8511,'fr','Erreur requÃªte de traitement',0),(306391,8511,'jp','ã‚¨ãƒ©ãƒ¼å‡¦ç†ã‚¯ã‚¨ãƒª',0),(306392,8511,'pt','Consulta de processamento de erro',0),(306393,8511,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(306394,8511,'es','Error Procesando Query',0),(306395,8511,'de','Fehler Verarbeitungsabfrage',0),(306396,8511,'en','Error Processing Query',0),(306397,8512,'is','',0),(306398,8512,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙÙŠÙ„ØªØ±ÙŠÙ†Ú¯ ØªÙ…Ø§Ù… ÙƒØ§Ø±Ø¨Ø±Ø§Ù† ',0),(306399,8512,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙÙŠÙ„ØªØ±ÙŠÙ†Ú¯ ØªÙ…Ø§Ù… ÙƒØ§Ø±Ø¨Ø±Ø§Ù† ',0),(306400,8512,'tr','TÃ¼m kullanÄ±cÄ±lar iÃ§in filtreleme seÃ§enekleri',0),(306401,8512,'pl','Opcje filtrowania dla wszystkich uÅ¼ytkownikÃ³w',0),(306402,8512,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° Ñ„Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(306403,8512,'ur','ØªÙ…Ø§Ù… ØµØ§Ø±ÙÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ ÙÙ„Ù¹Ø± Ú©Ø§Ø±ÛŒ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(306404,8512,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ñ„Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°ÑšÐ° Ð·Ð° ÑÐ²Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐµ',0),(306405,8512,'vi','Chá»n Lá»±a Khi Lá»c NgÆ°á»i Sá»­ Dá»¥ng',0),(306406,8512,'af','Filtreer Opsies vir Alle Gebruikers',0),(306407,8512,'ro','FiltrÄƒrii opÅ£iuni pentru toÅ£i utilizatorii',0),(306408,8512,'et','Filtreerimise valikud kÃµigile kasutajatele',0),(306409,8512,'si','MoÅ¾nosti filtriranja za vse uporabnike',0),(306410,8512,'ba','Opsi penyaringan untuk semua pengguna',0),(306411,8512,'nl','Filteropties die zijn ingesteld voor alle gebruikers',0),(306412,8512,'fi','Suodatus vaihtoehtoja kaikille kÃ¤yttÃ¤jille',0),(306413,8512,'no','Filtreringsalternativer for alle brukere',0),(306414,8512,'da','Filtreringsindstillingerne for alle brugere',0),(306415,8512,'ko','ëª¨ë“  ì‚¬ìš©ìžì— ëŒ€ í•œ í•„í„°ë§ ì˜µì…˜',0),(306416,8512,'he','××¤×©×¨×•×™×•×ª ×¡×™× ×•×Ÿ ×¢×‘×•×¨ ×›×œ ×”×ž×©×ª×ž×©×™×',0),(306417,8512,'el','Î¡Ï…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Ï„Ï‰Î½ ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½ Ï†Î¹Î»Ï„ÏÎ±ÏÎ¯ÏƒÎ¼Î±Ï„Î¿Ï‚ Î³Î¹Î± ÏŒÎ»Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(306418,8512,'zh','å¯¹æ‰€æœ‰ç”¨æˆ·è¿‡æ»¤é€‰é¡¹\r\n',0),(306419,8512,'sv','Filtreringsalternativ fÃ¶r alla anvÃ¤ndare',0),(306420,8512,'it','Opzioni di filtro per tutti gli utenti',0),(306421,8512,'tl','',0),(306422,8512,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3585;&#3619;&#3629;&#3591;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(306423,8512,'hi','à¤¸à¤­à¥€ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¤²à¥à¤ª à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤°à¤¿à¤‚à¤—',0),(306424,8512,'ms','Penapisan pilihan untuk semua pengguna',0),(306425,8512,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„ØªØµÙÙŠØ© Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(306426,8512,'fr','Options de filtrage pour tous les utilisateurs',0),(306427,8512,'jp','ã™ã¹ã¦ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«å¯¾ã—ã¦ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã®ãƒ•ã‚£ãƒ«ã‚¿ ãƒªãƒ³ã‚°',0),(306428,8512,'pt','OpÃ§Ãµes de filtragem para todos os usuÃ¡rios',0),(306429,8512,'ru','Ð¤Ð¸Ð»ÑŒÑ‚Ñ€ ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð² Ð´Ð»Ñ Ð’ÑÐµÑ… ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(306430,8512,'es','Opciones de FiltraciÃ³n para Todos Los Usuarios',0),(306431,8512,'de','Filteroptionen fÃ¼r alle Benutzer',0),(306432,8512,'en','Filtering Options for All Users',0),(306433,8513,'is','',0),(306434,8513,'dr','IP Ù…Ø¯ÙŠØ± Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ù¾Ø±ØªÙ…Ø¬Ù…ÙˆØ¹ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(306435,8513,'pr','IP Ù…Ø¯ÙŠØ± Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ù¾Ø±ØªÙƒÙ„ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(306436,8513,'tr','IP eriÅŸim YÃ¶neticisi',0),(306437,8513,'pl','IP Access Manager',0),(306438,8513,'bg','IP Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð¼ÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€',0),(306439,8513,'ur','IP Ø±Ø³Ø§Ø¦ÛŒ Ù…ÛŒÙ†ÛŒØ¬Ø±',0),(306440,8513,'sr','Ð˜ÐŸ ÐÑ†Ñ†ÐµÑÑ ÐœÐ°Ð½Ð°Ð³ÐµÑ€',0),(306441,8513,'vi','Quáº£n LÃ½ IP Truy Cáº­p',0),(306442,8513,'af','IV (\"IP\") Toegangsbestuurder',0),(306443,8513,'ro','Manager de acces IP',0),(306444,8513,'et','IP pÃµhise ligipÃ¤Ã¤su haldus',0),(306445,8513,'si','Upravitelj IP dostop',0),(306446,8513,'ba','Manajer akses IP',0),(306447,8513,'nl','IP toegang Manager',0),(306448,8513,'fi','IP Access Manager',0),(306449,8513,'no','IP Access Manager',0),(306450,8513,'da','IP Access Manager',0),(306451,8513,'ko','IP ì•¡ì„¸ìŠ¤ ê´€ë¦¬ìž',0),(306452,8513,'he','IP ×ž× ×”×œ ×”×¨×©××•×ª',0),(306453,8513,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ IP',0),(306454,8513,'zh','äº’è”ç½‘åè®®æŽ¥å…¥ç®¡ç†å™¨\r\n',0),(306455,8513,'sv','IP Access Manager',0),(306456,8513,'it','IP Access Manager',0),(306457,8513,'tl','',0),(306458,8513,'th','&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656; IP',0),(306459,8513,'hi','IP à¤ªà¤¹à¥à¤à¤š à¤ªà¥à¤°à¤¬à¤‚à¤§à¤•',0),(306460,8513,'ms','Pengurus Capaian IP',0),(306461,8513,'ar','ØªØ­Ø¯ÙŠØ¯ Ø¹Ù†Ø§ÙˆÙŠÙ† Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(306462,8513,'fr','IP Access Manager',0),(306463,8513,'jp','IP ã‚¢ã‚¯ã‚»ã‚¹ ãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼',0),(306464,8513,'pt','Gerenciador de acesso IP',0),(306465,8513,'ru','ÐœÐµÐ½ÐµÐ´Ð¶ÐµÑ€ Ð”Ð¾Ð¿ÑƒÑÐºÐ° IP',0),(306466,8513,'es','IP Supervisor de Acceso',0),(306467,8513,'de','IP Access Manager',0),(306468,8513,'en','IP Access Manager',0),(306469,8514,'is','',0),(306470,8514,'dr',': Ø¯Ø± Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§ÙŠ Ø²ÙŠØ± Ù„ÙŠØ³ØªÙ‡Ø§ÙŠÙŠ Ø§Ø² Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø§ÙØ±Ø§Ø¯ÙŠ Ø§Ø³Øª ÙƒÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ù†Ø¯ Ø¨Ù‡ Ø§ÙŠÙ† Ø³ÙŠØ³ØªÙ… ÙˆØ§Ø±Ø¯ Ø´ÙˆÙ†Ø¯ Ø¨Ø§ ÙƒØ§Ù…Ø§ Ø¬Ø¯Ø§ Ø´Ø¯Ù‡ Ø§Ù†Ø¯ . Ø´Ù…Ø§ Ù‡Ù… ',0),(306471,8514,'pr','Ø´Ø±Ø­ ÙˆØ±ÙˆØ¯ Ù¾Ø±ØªÙƒÙ„ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ : Ø¯Ø± Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§ÙŠ Ø²ÙŠØ± Ù„ÙŠØ³ØªÙ‡Ø§ÙŠÙŠ Ø§Ø² Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø§ÙØ±Ø§Ø¯ÙŠ Ø§Ø³Øª ÙƒÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ù†Ø¯ Ø¨Ù‡ Ø§ÙŠÙ† Ø³ÙŠØ³ØªÙ… ÙˆØ§Ø±Ø¯ Ø´ÙˆÙ†Ø¯ Ø¨Ø§ ÙƒØ§Ù…Ø§ Ø¬Ø¯Ø§ Ø´Ø¯Ù‡ Ø§Ù†Ø¯ . Ø´Ù…Ø§ Ù‡Ù… ',0),(306472,8514,'tr','Are OK Ã¼zerinden oturum aÃ§mak insanlar iÃ§in IP adreslerinin virgÃ¼lle ayrÄ±lmÄ±ÅŸ liste aÅŸaÄŸÄ±da kutularÄ± yerleÅŸtirin. Form 192.168.1.0/24 IP aralÄ±klarÄ± da girebilirsiniz. Her zaman sunucudan oturum aÃ§mak iÃ§in izin verilir.',0),(306473,8514,'pl','UmieÅ›Ä‡ w polach poniÅ¼ej rozdzielana przecinkami lista adresÃ³w IP, ktÃ³re sÄ… OK dla ludzi do logowania z. MoÅ¼na rÃ³wnieÅ¼ wprowadziÄ‡ zakresÃ³w adresÃ³w IP w postaci 192.168.1.0/24. Zawsze moÅ¼esz siÄ™ zalogowaÄ‡ z samego serwera.',0),(306474,8514,'bg','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð² Ð¿Ð¾Ð»ÐµÑ‚Ð°Ñ‚Ð° Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ ÑÐ¿Ð¸ÑÑŠÑ†Ð¸ ÑÑŠÑ ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸, Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸ ÑÑŠÑ Ð·Ð°Ð¿ÐµÑ‚Ð°Ð¸ Ð½Ð° IP Ð°Ð´Ñ€ÐµÑÐ¸, ÐºÐ¾Ð¸Ñ‚Ð¾ ÑÐ° ÐžÐš Ð·Ð° Ñ…Ð¾Ñ€Ð°Ñ‚Ð° Ð´Ð° Ð²Ð»ÐµÐ·ÐµÑ‚Ðµ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð¾Ñ‚. ÐœÐ¾Ð¶ÐµÑ‚',0),(306475,8514,'ur','IP Ù¾ØªØ§ ÛÛ’ Ú©Û Ù„ÙˆÚ¯ÙˆÚº Ø³Û’ Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù¹Ú¾ÛŒÚ© ÛÛŒÚº Ú©ÛŒ Ú©ÙˆÙ…Ø§ Ø³Û’ Ø¹Ù„ÛŒØ­Ø¯Û Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù†ÛŒÚ†Û’ Ú©Û’ Ø®Ø§Ù†ÙˆÚº Ù…ÛŒÚº Ø±Ú©Ú¾ÛŒÚº Û” Ø¢Ù¾ ÙØ§Ø±Ù… 192.168.1.0/24 Ù…ÛŒÚº Ø¨Ú¾ÛŒ Ø¢Ø¦ÛŒ Ù¾ÛŒ Ø­Ø¯ÙˆØ¯ Ø§Ø·Ù„Ø',0),(306476,8514,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ñƒ ÐºÑƒÑ‚Ð¸Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ñ€Ð°Ð·Ð´Ð²Ð¾Ñ˜ÐµÐ½Ð¸Ñ… Ð»Ð¸ÑÑ‚Ð°Ð¼Ð° ÑÐ° Ð˜ÐŸ Ð°Ð´Ñ€ÐµÑÐ°Ð¼Ð° ÐºÐ¾Ñ˜Ðµ ÑÐµ Ð½Ð°Ð»Ð°Ð·Ðµ Ñƒ Ñ€ÐµÐ´Ñƒ Ð·Ð° Ñ™ÑƒÐ´Ðµ Ð´Ð° ÑÐµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ ÑÐ°. Ð¢Ð°ÐºÐ¾Ñ’Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ ÑƒÐ½ÐµÑ‚Ð¸ Ð˜ÐŸ Ð¾Ð¿ÑÐµÐ³Ð° Ñ',0),(306477,8514,'vi','Trong há»™p dÆ°á»›i Ä‘Ã¢y, dÃ¹ng dáº¥u pháº©y Ä‘á»ƒ tÃ¡ch cÃ¡c Ä‘á»‹a chá»‰ IP cho phÃ©p users Ä‘Äƒng nháº­p. Báº¡n cÅ©ng cÃ³ thá»ƒ quy Ä‘á»‹nh pháº¡m vi IP theo Ä‘á»‹nh dáº¡ng 192.168.1.0/24. Báº¡n luÃ´n cÃ³ thá»ƒ Ä‘Äƒng nháº­p tá»« mÃ¡y chá»§. ',0),(306478,8514,'af','Plaas in die boksies hieronder komma-verdeelde lyste van IP adresse wat OK is vir mense om in te teken.  U kan ook IP reekse invoer in die vorm 192.168.1.0/24. U word altyd toegelaat om in te teken vanuit die bediener homself.',0),(306479,8514,'ro','Loc Ã®n casetele de mai jos separate prin virgulÄƒ lista de adrese IP care sunt OK pentru oameni la spre log Ã®nÄƒuntru la. AveÅ£i posibilitatea sÄƒ introduceÅ£i IP variazÄƒ Ã®n formÄƒ 192.168.1.0/24. Vi se permite Ã®ntotdeauna sÄƒ vÄƒ conectaÅ£i la serve',0),(306480,8514,'et','Asetatakse kastid allpool nimekirja komadega eraldatud IP-aadresse, mis on OK inimesed samamoodi. IP-aadresside vahemikud saate sisestada ka vormi 192.168.1.0/24. Teile on alati lubatud server ise samamoodi.',0),(306481,8514,'si','Mesto v poljih pod vejico seznamov IP naslovov, ki so v redu za ljudi, da se prijavite iz. Vnesete lahko tudi IP zbirka v obliki 192.168.1.0/24. Vedno dovoljeno prijaviti iz streÅ¾nika sama.',0),(306482,8514,'ba','Tempat di kotak di bawah ini dipisahkan dengan koma daftar alamat IP yang OK untuk orang-orang untuk login dari. Anda juga dapat memasukkan kisaran IP dalam bentuk 192.168.1.0/24. Anda selalu diperbolehkan untuk login dari server itu sendiri.',0),(306483,8514,'nl','Plaatsen in de vakken hieronder door komma\'s gescheiden lijsten van IP-adressen die zijn OK voor mensen om in te loggen uit. U kunt ook IP-adresbereiken invoeren in het formulier 192.168.1.0/24. U mag altijd inloggen vanaf de server zelf.',0),(306484,8514,'fi','Aseta alapuolella olevista ruuduista pilkuilla erotettuja listoja IP-osoitteet, jotka ovat OK ihmiset voivat kirjautua sisÃ¤Ã¤n. Kirjoitat IP-alueita muodossa 192.168.1.0/24. Sinulla on aina oikeus kirjautua sisÃ¤Ã¤n palvelimelle.',0),(306485,8514,'no','Plasser i boksene nedenfor komma lister av IP adresser det er OK for Ã¥ logge inn fra. Du kan ogsÃ¥ angi IP-serier i skjemaet 192.168.1.0/24. Du kan alltid logge inn fra selve serveren.',0),(306486,8514,'da','Sted i boksene nedenfor komma-separerede lister over IP-adresser, der er OK for folk til at logge ind fra. Du kan ogsÃ¥ indtaste IP-omrÃ¥der i formen 192.168.1.0/24. Du er altid tilladt at logge fra selve serveren.',0),(306487,8514,'ko','IP ì£¼ì†Œ í™•ì¸ì—ì„œ ë¡œê·¸ì¸ í•˜ëŠ” ì‚¬ëžŒë“¤ì— ëŒ€ í•œ ì‰¼í‘œë¡œ êµ¬ë¶„ ëœ ëª©ë¡ ì•„ëž˜ì˜ ìƒìžì— ë†“ìŠµë‹ˆë‹¤. ë˜í•œ ì–‘ì‹ 192.168.1.0/24ì— IP ë²”ìœ„ë¥¼ ìž…ë ¥í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤. í•­ìƒ ì„œë²„ì—ì„œ ë¡œê·¸ì¸ í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(306488,8514,'he','×”×¦×‘ ×‘×ª×™×‘×•×ª ×©×ž×ª×—×ª ×¤×¡×™×§ ×¨×©×™×ž×•×ª ×©×œ ×›×ª×•×‘×•×ª IP ×”× ×ž×¦××•×ª ×‘×¡×“×¨ ×œ×× ×©×™× ×œ×”×ª×—×‘×¨ ×ž. ×‘××¤×©×¨×•×ª×š ×’× ×œ×”×–×™×Ÿ ×˜×•×•×—×™ IP 192.168.1.0/24 ×”×˜×•×¤×¡. ×ž×•×ª×¨ ×œ×š ×ª×ž×™×“ ×œ×”×ª×—×‘×¨ ×ž×”×©×¨×ª ×¢×¦×ž',0),(306489,8514,'el','Î˜Î­ÏƒÎ· ÏƒÏ„Î± Ï€Î»Î±Î¯ÏƒÎ¹Î± Ï„Î¿Ï… Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î´Î¹Î±Ï‡Ï‰ÏÎ¹ÏƒÎ¼Î­Î½Ï‰Î½ Î»Î¯ÏƒÏ„ÎµÏ‚ Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÏ‰Î½ IP Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ ÎµÎ½Ï„Î¬Î¾ÎµÎ¹ Î³Î¹Î± Î½Î± ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Î±Ï€ÏŒ Ï„Î¿Ï…Ï‚ Î±Î½Î¸ÏÏŽÏ€Î¿Ï…Ï‚. Î•Ï€Î¯ÏƒÎ·Ï‚, Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î',0),(306490,8514,'zh','åœ¨é€—å·åˆ†éš”åˆ—è¡¨ä¸‹é¢çš„IPåœ°å€æ¡†ä¸­äººä»¬å¯ä»Žæ­¤ç™»å½•ã€‚æ‚¨ä¹Ÿå¯ä»¥åœ¨è¡¨å•ä¸­è¾“å…¥192.168.1.0/24 IPèŒƒå›´ã€‚ä½ æ€»æ˜¯å¯ä»¥ä»ŽæœåŠ¡å™¨æœ¬èº«ç™»å½•ã€‚\r\n',0),(306491,8514,'sv','Placera i rutorna nedan kommaseparerade listor med IP-adresser som Ã¤r OK fÃ¶r folk att logga in frÃ¥n. Du kan ocksÃ¥ ange IP-intervall i den form 192.168.1.0/24. Du fÃ¥r alltid logga in pÃ¥ sjÃ¤lva servern.',0),(306492,8514,'it','Inserire nelle caselle sotto elenchi separati da virgole di indirizzi IP che sono OK per le persone a fare il login da. Ãˆ inoltre possibile immettere intervalli di IP in 192.168.1.0/24 la forma. Sempre poter accedere dal server stesso.',0),(306493,8514,'tl','',0),(306494,8514,'th','Place in the boxes below comma-separated lists of IP addresses that are OK for people to log in from. You can also enter IP ranges in the form 192.168.1.0/24. You are always allowed to log in from the server itself.',0),(306495,8514,'hi','à¤²à¥‹à¤—à¥‹à¤‚ à¤¸à¥‡ à¤²à¥‰à¤— à¤‡à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ à¥€à¤• à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤œà¥‹ IP à¤ªà¤¤à¥‹à¤‚ à¤•à¥€ à¤•à¥‰à¤®à¤¾ à¤¸à¥‡à¤ªà¤°à¥‡à¤Ÿà¥‡à¤¡ à¤¸à¥‚à¤šà¥€ à¤¨à¥€à¤šà¥‡ à¤¬à¤•à¥à¤¸à¥‡ à¤®à¥‡à¤‚ à¤œà¤—à¤¹ à¤¹à¥ˆà¥¤ à¤†à¤ª à',0),(306496,8514,'ms','Letakkan dalam kotak di bawah dipisahkan oleh koma senarai alamat IP yang OK untuk orang ramai untuk log masuk dari. Anda juga boleh memasukkan julat IP di 192.168.1.0/24 borang. Anda sentiasa dibenarkan untuk log masuk daripada pelayan itu sendiri.',0),(306497,8514,'ar','Ù…ÙƒØ§Ù† ÙÙŠ Ø§Ù„Ù…Ø±Ø¨Ø¹Ø§Øª Ø£Ø¯Ù†Ø§Ù‡ Ù‚Ø§Ø¦Ù…Ø© Ù…ÙØµÙˆÙ„Ø© Ø¨ÙÙˆØ§ØµÙ„ Ù„Ø¹Ù†Ø§ÙˆÙŠÙ† IP Ø§Ù„ØªÙŠ ÙŠØªÙ… Ù…ÙˆØ§ÙÙ‚ Ù„Ù„Ù†Ø§Ø³ Ù„ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ù…Ù†. ÙŠÙ…ÙƒÙ†Ùƒ Ø£ÙŠØ¶Ø§ Ø¥Ø¯Ø®Ø§Ù„ Ù†Ø·Ø§Ù‚Ø§Øª IP ÙÙŠ 192.168.1.0/24 Ø§Ù„Ù†Ù…ÙˆØ°Ø¬. Ø¯Ø§Ø',0),(306498,8514,'fr','Placer dans les cases ci-dessous les listes sÃ©parÃ©es par des virgules des adresses IP qui sont OK pour les gens de vous connecter Ã  partir. Vous pouvez Ã©galement entrer des plages dâ€™adresses IP dans la forme 192.168.1.0/24. Vous Ãªtes toujours autor',0),(306499,8514,'jp','äººã€… ã‹ã‚‰ãƒ­ã‚°ã‚¤ãƒ³ã™ã‚‹ãŸã‚ã«ã¯ã€[ok] ã‚’ IP ã‚¢ãƒ‰ãƒ¬ã‚¹ã®ã‚³ãƒ³ãƒžåŒºåˆ‡ã‚Šã®ãƒªã‚¹ãƒˆã®ä¸‹ã®ãƒœãƒƒã‚¯ã‚¹ã«é…ç½®ã—ã¾ã™ã€‚ãƒ•ã‚©ãƒ¼ãƒ  192.168.1.0/24 ã® IP ã®ç¯„å›²ã‚’å…¥åŠ›ã§ãã¾ã™ã€‚å¸¸ã«ã‚µãƒ¼ãƒãƒ¼è‡ªä½“ã‹ã‚‰ã®ãƒ­ã‚°ã‚¤',0),(306500,8514,'pt','Coloque nas caixas abaixo lista separada por vÃ­rgulas de endereÃ§os IP que sÃ£o Okey para pessoas efetuar login a partir. VocÃª tambÃ©m pode inserir intervalos de IP no 192.168.1.0/24 formulÃ¡rio. Sempre podes efetuar login a partir do prÃ³prio servidor.',0),(306501,8514,'ru','ÐœÐµÑÑ‚Ð¾ Ð² Ð¿Ð¾Ð»ÑÑ… Ð½Ð¸Ð¶Ðµ ÑÐ¿Ð¸ÑÐºÐ¸ Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð½Ñ‹Ñ… Ð·Ð°Ð¿ÑÑ‚Ñ‹Ð¼Ð¸ IP-Ð°Ð´Ñ€ÐµÑÐ¾Ð², ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ ÑÐ²Ð»ÑÑŽÑ‚ÑÑ ÐžÐš Ð´Ð»Ñ Ð»ÑŽÐ´ÐµÐ¹, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð²Ð¾Ð¹Ñ‚Ð¸ Ð². ÐœÐ¾Ð¶Ð½Ð¾ Ñ‚Ð°ÐºÐ¶Ðµ Ð²Ð²ÐµÑÑ‚Ð¸ IP-Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ñ‹ Ð² Ñ„Ð¾Ñ€Ð',0),(306502,8514,'es','Pone en las cajas abajo listas separadas por comas de  direcciones de IP que son OK para la gente hacer el login. TambiÃ©n puede ingresar rangos de IP en la forma 192.168.1.0/24. Siempre puede hacer el login del servidor mismo.',0),(306503,8514,'de','Legen Sie in den Feldern unten durch Kommas getrennte Liste von IP-Adressen, die sind OK fÃ¼r Leute aus anmelden. Sie kÃ¶nnen auch IP-Bereiche in der Form 192.168.1.0/24 eingeben. Sie dÃ¼rfen immer vom Server selbst anmelden.',0),(306504,8514,'en','Place in the boxes below comma-separated lists of IP addresses that are OK for people to log in from. You can also enter IP ranges in the form 192.168.1.0/24. You are always allowed to log in from the server itself.',0),(306505,8515,'is','',0),(306506,8515,'dr','IP ÙˆØ¶Ø¹ÙŠØª ÙÙŠÙ„ØªØ±ÙŠÙ†Ú¯ ÙˆØ±ÙˆØ¯',0),(306507,8515,'pr','IP ÙˆØ¶Ø¹ÙŠØª ÙÙŠÙ„ØªØ±ÙŠÙ†Ú¯ ÙˆØ±ÙˆØ¯',0),(306508,8515,'tr','IP oturumu durumu Filtreleme',0),(306509,8515,'pl','Stan filtrowania IP',0),(306510,8515,'bg','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ‚ Ð·Ð° Ñ„Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° IP Ð²Ñ…Ð¾Ð´',0),(306511,8515,'ur','IP Ù„Ø§Ú¯ Ø§Ù† Ø­Ø§Ù„Øª Ú©ÛŒ ÙÙ„Ù¹Ø±Ù†Ú¯',0),(306512,8515,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð° Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ñ„Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°ÑšÐ° Ð˜ÐŸ',0),(306513,8515,'vi','Lá»c tÃ¬nh tráº¡ng Ä‘Äƒng nháº­p IP',0),(306514,8515,'af','IP Aantekening Status Filtreer',0),(306515,8515,'ro','IP Login statutul de filtrare',0),(306516,8515,'et','IP kasutajanime filtreerimist olek',0),(306517,8515,'si','Stanje filtriranje IP prijave',0),(306518,8515,'ba','Status penyaringan IP Login',0),(306519,8515,'nl','Aanmeldingsstatus filteren IP-',0),(306520,8515,'fi','IP johdonmukaisuus suodatus tilan',0),(306521,8515,'no','IP logikk filtrering Status',0),(306522,8515,'da','IP logonstatus filtrering.',0),(306523,8515,'ko','IP ë¡œê·¸ì¸ í•„í„°ë§ ìƒíƒœ',0),(306524,8515,'he','×ž×¦×‘ ×¡×™× ×•×Ÿ IP ×”×”×ª×—×‘×¨×•×ª',0),(306525,8515,'el','Î£ÏÎ½Î´ÎµÏƒÎ· IP Ï†Î¹Î»Ï„ÏÎ¬ÏÎ¹ÏƒÎ¼Î± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(306526,8515,'zh','äº’è”ç½‘åè®®ç™»å½•çŠ¶æ€è¿‡æ»¤\r\n',0),(306527,8515,'sv','IP-inloggning filtrering Status',0),(306528,8515,'it','Stato di filtraggio IP accesso',0),(306529,8515,'tl','',0),(306530,8515,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3588;&#3633;&#3604;&#3585;&#3619;&#3629;&#3591;&#3626;&#3606;&#3634;&#3609;&#3632;&#3585;&#3634;&#3619;&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3651;&#3594;&#3657; IP',0),(306531,8515,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ IP à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤°à¤¿à¤‚à¤—',0),(306532,8515,'ms','IP Login penapisan Status',0),(306533,8515,'ar','Ø­Ø§Ù„Ø© ØªØµÙÙŠØ© IP ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(306534,8515,'fr','Ã‰tat de filtrage de connexion IP',0),(306535,8515,'jp','IP ãƒ­ã‚°ã‚¤ãƒ³ ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼ ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(306536,8515,'pt','Status de filtragem IP Login',0),(306537,8515,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ñ„Ð¸Ð»ÑŒÑ‚Ñ€Ð°Ñ†Ð¸Ð¸ IP Ð²Ñ…Ð¾Ð´Ð°',0),(306538,8515,'es','Staus de FiltraciÃ³n de IP Login',0),(306539,8515,'de','IP-Filterung Anmeldestatus',0),(306540,8515,'en','IP Login Filtering Status',0),(306541,8516,'is','',0),(306542,8516,'dr','(Ø§Ø²',0),(306543,8516,'pr','Ø®Ø§Ø±Ø¬ Ø§Ø² Ù…Ø­Ø¯ÙˆØ¯Ù‡(Ø§Ø²',0),(306544,8516,'tr','KapalÄ±',0),(306545,8516,'pl','Poza',0),(306546,8516,'bg','Ð Ð°Ð·ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(306547,8516,'ur','Ø¨Ù†Ø¯',0),(306548,8516,'sr','Ð˜ÑÐºÑ™ÑƒÑ‡Ð¸Ð²Ð°ÑšÐµ',0),(306549,8516,'vi','táº¯t',0),(306550,8516,'af','Afskakel',0),(306551,8516,'ro','Off',0),(306552,8516,'et','VÃ¤lja',0),(306553,8516,'si','Off',0),(306554,8516,'ba','Off',0),(306555,8516,'nl','Uit',0),(306556,8516,'fi','Pois',0),(306557,8516,'no','Av',0),(306558,8516,'da','Off',0),(306559,8516,'ko','ì˜¤í”„',0),(306560,8516,'he','.',0),(306561,8516,'el','ÎœÎ±ÎºÏÎ¹Î¬',0),(306562,8516,'zh','å…³\r\n',0),(306563,8516,'sv','Off',0),(306564,8516,'it','Fuori',0),(306565,8516,'tl','',0),(306566,8516,'th','&#3611;&#3636;&#3604;',0),(306567,8516,'hi','à¤¬à¤‚à¤¦',0),(306568,8516,'ms','Off',0),(306569,8516,'ar','Ù‚Ø¨Ø§Ù„Ø©',0),(306570,8516,'fr','Hors',0),(306571,8516,'jp','ã‚ªãƒ•',0),(306572,8516,'pt','Fora',0),(306573,8516,'ru','Ð’Ñ‹ÐºÐ»',0),(306574,8516,'es','Offset - Hoja',0),(306575,8516,'de','Ab',0),(306576,8516,'en','Off',0),(306577,8517,'is','',0),(306578,8517,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙÙŠÙ„ØªØ±ÙŠÙ†Ú¯ Ù‡Ø± ÙƒØ§Ø±Ø¨Ø±',0),(306579,8517,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙÙŠÙ„ØªØ±ÙŠÙ†Ú¯ Ù‡Ø± ÙƒØ§Ø±Ø¨Ø±',0),(306580,8517,'tr','KullanÄ±cÄ± baÅŸÄ±na filtre seÃ§enekleri',0),(306581,8517,'pl','Opcje filtrowania na uÅ¼ytkownika',0),(306582,8517,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° Ñ„Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²ÑÐµÐºÐ¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(306583,8517,'ur','ÙÛŒ ØµØ§Ø±Ù ÙÙ„Ù¹Ø± Ú©Ø§Ø±ÛŒ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(306584,8517,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ñ„Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð¾ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÑƒ',0),(306585,8517,'vi','Lá»c theo lá»±a chá»n tá»«ng ngÆ°á»i sá»­ dá»¥ng',0),(306586,8517,'af','Per-Gebruiker Filteringsopsies',0),(306587,8517,'ro','Per-utilizator opÅ£iuni de filtrare',0),(306588,8517,'et','Kasutaja filtreerimise valikud',0),(306589,8517,'si','Uporabnikova filtriranja moÅ¾nosti',0),(306590,8517,'ba','Pilihan penyaringan per pengguna',0),(306591,8517,'nl','Per-User Filtering opties',0),(306592,8517,'fi','KÃ¤yttÃ¤jÃ¤kohtainen suodatus vaihtoehtoja',0),(306593,8517,'no','Per bruker filtrering alternativer',0),(306594,8517,'da','Per bruger filtrering muligheder',0),(306595,8517,'ko','ì‚¬ìš©ìž í•„í„°ë§ ì˜µì…˜',0),(306596,8517,'he','××¤×©×¨×•×™×•×ª ×¡×™× ×•×Ÿ ×œ×¤×™ ×ž×©×ª×ž×©',0),(306597,8517,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ Ï†Î¹Î»Ï„ÏÎ±ÏÎ¯ÏƒÎ¼Î±Ï„Î¿Ï‚ Î±Î½Î¬ Ï‡ÏÎ®ÏƒÏ„Î·',0),(306598,8517,'zh','æ¯ä¸ªç”¨æˆ·è¿‡æ»¤é€‰é¡¹\r\n',0),(306599,8517,'sv','Per anvÃ¤ndare filtrering alternativ',0),(306600,8517,'it','Opzioni di filtraggio per utente',0),(306601,8517,'tl','',0),(306602,8517,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3585;&#3635;&#3621;&#3633;&#3591;&#3585;&#3619;&#3629;&#3591;&#3607;&#3634;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(306603,8517,'hi','à¤ªà¥à¤°à¤¤à¤¿-à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤µà¤¿à¤•à¤²à¥à¤ª à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤°à¤¿à¤‚à¤—',0),(306604,8517,'ms','Opsyen penapisan setiap pengguna',0),(306605,8517,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„ØªØµÙÙŠØ© Ù„ÙƒÙ„ Ù…Ø³ØªØ®Ø¯Ù…',0),(306606,8517,'fr','Options de filtrage par utilisateur',0),(306607,8517,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã”ã¨ã®ãƒ•ã‚£ãƒ«ã‚¿ ãƒªãƒ³ã‚° ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(306608,8517,'pt','OpÃ§Ãµes de filtragem por usuÃ¡rio',0),(306609,8517,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ñ„Ð¸Ð»ÑŒÑ‚Ñ€Ð°Ñ†Ð¸Ð¸ Ð½Ð° Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(306610,8517,'es','Opciones de FiltraciÃ³n por-usuario',0),(306611,8517,'de','Filteroptionen fÃ¼r pro-Benutzer',0),(306612,8517,'en','Per-User Filtering Options',0),(306613,8518,'is','',0),(306614,8518,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø¨Ù†Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ Ø³Ø§Ø¹ØªÙŠ ',0),(306615,8518,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø¨Ù†Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ Ø³Ø§Ø¹ØªÙŠ ',0),(306616,8518,'tr','Temel saatlik Ã¶deme GÃ¼ncelleÅŸtir',0),(306617,8518,'pl','Aktualizacja podstawowej pÅ‚acy godzinowej',0),(306618,8518,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ð·Ð° Ñ‡Ð°ÑÐ¾Ð²Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(306619,8518,'ur','Ø¨ÛŒØ³ ÙÛŒ Ú¯Ú¾Ù†Ù¹Û ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(306620,8518,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð±Ð°Ð·Ðµ Ð¿Ð¾ ÑÐ°Ñ‚Ñƒ Ð¿Ð»Ð°Ñ‚Ðµ',0),(306621,8518,'vi','Cáº­p Nháº­t LÆ°Æ¡ng Giá»',0),(306622,8518,'af','Opdateer Basis Uurlikse Besoldiging',0),(306623,8518,'ro','Actualizare baza plata pe orÄƒ',0),(306624,8518,'et','Uuenda baasi tunnitÃ¶Ã¶',0),(306625,8518,'si','Posodobi osnovni urne',0),(306626,8518,'ba','Memperbarui dasar bayar per jam',0),(306627,8518,'nl','Base uurloon bijwerken',0),(306628,8518,'fi','PÃ¤ivittÃ¤Ã¤ Base tuntipalkan',0),(306629,8518,'no','Oppdatere Base timelÃ¸nnen',0),(306630,8518,'da','Opdatere Base timelÃ¸n',0),(306631,8518,'ko','ê¸°ë³¸ ì‹œê°„ë‹¹ ê¸‰ì—¬ ì—…ë°ì´íŠ¸',0),(306632,8518,'he','×¢×“×›×•×Ÿ ×‘×¡×™×¡ ×©×›×¨ ×©×¢×ª×™',0),(306633,8518,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î²Î¬ÏƒÎ·Ï‚ Ï‰ÏÎ¹Î±Î¯Î± Î±Î¼Î¿Î¹Î²Î®',0),(306634,8518,'zh','æ›´æ–°åŸºæœ¬æ—¶è–ª\r\n',0),(306635,8518,'sv','Uppdatera bas timlÃ¶n',0),(306636,8518,'it','Aggiornamento Base paga oraria',0),(306637,8518,'tl','',0),(306638,8518,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3600;&#3634;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3619;&#3634;&#3618;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(306639,8518,'hi','à¤¬à¥‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(306640,8518,'ms','Kemaskini Terakhir membayar setiap jam yang asas',0),(306641,8518,'ar','ØªØ­Ø¯ÙŠØ« Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø£Ø¬Ø±',0),(306642,8518,'fr','Mise Ã  jour de Base de salaire horaire',0),(306643,8518,'jp','åŸºæœ¬æ™‚çµ¦ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(306644,8518,'pt','Atualizar a Base de remuneraÃ§Ã£o horÃ¡ria',0),(306645,8518,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð±Ð°Ð·Ð¾Ð²Ð¾Ð¹ Ð¿Ð¾Ñ‡Ð°ÑÐ¾Ð²Ð¾Ð¹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(306646,8518,'es','Actualizar Pago por Hora Base',0),(306647,8518,'de','Aktualisierung der Basis Stundenlohn',0),(306648,8518,'en','Update Base Hourly Pay',0),(306649,8519,'is','',0),(306650,8519,'dr','Ø¨Ø±Ú¯Ø´Øª  Ø¨Ø¯ÙˆÙ† Ø°Ø®ÙŠØ±Ù‡',0),(306651,8519,'pr','Ø¨Ø±Ú¯Ø´Øª  Ø¨Ø¯ÙˆÙ† Ø°Ø®ÙŠØ±Ù‡',0),(306652,8519,'tr','Arka (Kaydet)',0),(306653,8519,'pl','Powrotem (nie zapisywania)',0),(306654,8519,'bg','ÐÐ°Ð·Ð°Ð´ (Ð±ÐµÐ· Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ)',0),(306655,8519,'ur','ÙˆØ§Ù¾Ø³ (Ú©ÙˆØ¦ÛŒ Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº)',0),(306656,8519,'sr','ÐÐ°Ð·Ð°Ð´ (Ð±ÐµÐ· Ñ‡ÑƒÐ²Ð°ÑšÐ°)',0),(306657,8519,'vi','Quay Láº¡i (khÃ´ng sao lÆ°u)',0),(306658,8519,'af','Terug (Ongestoor)',0),(306659,8519,'ro','Spate (fÄƒrÄƒ salvare)',0),(306660,8519,'et','Tagasi (Ei salvesta)',0),(306661,8519,'si','Nazaj (ne shrani)',0),(306662,8519,'ba','Kembali (tidak Simpan)',0),(306663,8519,'nl','Achterzijde (geen redden)',0),(306664,8519,'fi','Takaisin (Save)',0),(306665,8519,'no','Tilbake (uten lagring)',0),(306666,8519,'da','Tilbage (ingen Gem)',0),(306667,8519,'ko','ë°±ì—… (ì €ìž¥)',0),(306668,8519,'he','×‘×—×–×¨×” (×œ× ×©×ž×•×¨)',0),(306669,8519,'el','Î Î¯ÏƒÏ‰ (Î´ÎµÎ½ Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ)',0),(306670,8519,'zh','è¿”å›žï¼ˆä¸ä¿å­˜',0),(306671,8519,'sv','Tillbaka (ingen spara)',0),(306672,8519,'it','Indietro (senza salvare)',0),(306673,8519,'tl','',0),(306674,8519,'th','&#3585;&#3621;&#3633;&#3610;',0),(306675,8519,'hi','à¤µà¤¾à¤ªà¤¸ (à¤•à¥‹à¤ˆ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚)',0),(306676,8519,'ms','Belakang (tiada Save)',0),(306677,8519,'ar','Ø§Ù„Ø®Ù„Ù (Ù„Ø§ Ø­ÙØ¸)',0),(306678,8519,'fr','Dos (sans enregistrer)',0),(306679,8519,'jp','ãƒãƒƒã‚¯ ï¼ˆä¿å­˜ï¼‰',0),(306680,8519,'pt','Costas (sem salvar)',0),(306681,8519,'ru','ÐÐ°Ð·Ð°Ð´ (ÐÐµ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÑÑ‚ÑŒ)',0),(306682,8519,'es','AtrÃ¡s (No Guardar)',0),(306683,8519,'de','RÃ¼ckseite (ohne Speichern)',0),(306684,8519,'en','Back (No Save)',0),(306685,8520,'is','',0),(306686,8520,'dr','Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„  Ùˆ Ø²Ù…Ø§Ù† Ø«Ø¨Øª Ø´Ø¯Ù‡',0),(306687,8520,'pr','Ø·Ù„Ø¨ ØºÙŠØ± Ù‚Ø§Ø¨Ù„ ÙˆØµÙˆÙ„  Ùˆ Ø²Ù…Ø§Ù† Ø«Ø¨Øª Ø´Ø¯Ù‡',0),(306688,8520,'tr','KÃ¶tÃ¼ randevu & girilen zaman',0),(306689,8520,'pl','ZÅ‚Ä… datÄ… & czas wszedÅ‚',0),(306690,8520,'bg','Ð›Ð¾Ñˆ Ð´Ð°Ñ‚Ð° & Ð²Ñ€ÐµÐ¼Ðµ Ð²Ð¿Ð¸ÑÐ²Ð°Ñ‚',0),(306691,8520,'ur','Ø¨Ø±Ø§ ØªØ§Ø±ÛŒØ® & ÙˆÙ‚Øª Ø¯Ø§Ø®Ù„ ÛÙˆØ§',0),(306692,8520,'sr','Ð›Ð¾Ñˆ Ð´Ð°Ñ‚ÑƒÐ¼ & ÑƒÐ½ÐµÑÐµ',0),(306693,8520,'vi','Ná»£ xáº¥u & ngÃ y nháº­p',0),(306694,8520,'af','Slegte Datum & Tyd Ingevoer',0),(306695,8520,'ro','Bad data & timp a intrat',0),(306696,8520,'et','Vigane kuupÎ£ev & sisestatud aeg',0),(306697,8520,'si','Slab dan & Äas zaÄel',0),(306698,8520,'ba','Tanggal buruk & saat masuk',0),(306699,8520,'nl','Slechte dag & tijd ingevoerd',0),(306700,8520,'fi','Huono pÃ¤ivÃ¤ & antamasi aika',0),(306701,8520,'no','Dato & tid angitt',0),(306702,8520,'da','DÃ¥rlig dato & tid trÃ¥dte',0),(306703,8520,'ko','ë‚˜ìœ ë‚ ì§œ & ì‹œê°„ ìž…ë ¥',0),(306704,8520,'he','×¤×’×™×©×” ×¨×¢×” & ×”×–×ž×Ÿ ×”×ž×•×–×Ÿ',0),(306705,8520,'el','ÎšÎ±ÎºÎ® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± & Ï‡ÏÏŒÎ½Î¿',0),(306706,8520,'zh','è¾“å…¥é”™è¯¯çš„æ—¥æœŸåŠæ—¶é—´\r\n',0),(306707,8520,'sv','DÃ¥ligt datum & anges',0),(306708,8520,'it','Data male & volta entrati',0),(306709,8520,'tl','',0),(306710,8520,'th','&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3649;&#3621;&#3632;&#3648;&#3623;&#3621;&#3634;&#3612;&#3636;&#3604;',0),(306711,8520,'hi','à¤¬à¥à¤°à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• & à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¸à¤®à¤¯',0),(306712,8520,'ms','Tarikh & masa yang dimasukkan',0),(306713,8520,'ar','ØªØ§Ø±ÙŠØ® Ø³ÙŠØ¦Ø© Ø¢Ù†Ø¯ Ø§Ù„ÙˆÙ‚Øª Ø¯Ø®Ù„Øª',0),(306714,8520,'fr','Mauvaise Date & fois entrÃ©',0),(306715,8520,'jp','æ‚ªã„æ—¥ & å…¥åŠ›æ™‚é–“',0),(306716,8520,'pt','Encontro ruim & tempo entrado',0),(306717,8520,'ru','Bad Ð”Ð°Ñ‚Ð° & Ð·Ð°Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(306718,8520,'es','EstÃ¡ en Error la Entrada de la Fecha y el Tiempo',0),(306719,8520,'de','Schlechten Tag & eingegebene Uhrzeit',0),(306720,8520,'en','Bad Date & Time Entered',0),(306721,8521,'is','',0),(306722,8521,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¬Ø¯ÙŠØ¯ â€“ Ø²Ù…Ø§Ù† Ø¨Ø¹Ø¯Ø§Ø² ØªØ§Ø±ÙŠØ® Ùˆ Ø²Ù…Ø§Ù†  ÙØ¹Ù„ÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ø§Ø´Ø¯',0),(306723,8521,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¬Ø¯ÙŠØ¯ â€“ Ø²Ù…Ø§Ù† Ø¨Ø¹Ø¯Ø§Ø² ØªØ§Ø±ÙŠØ® Ùˆ Ø²Ù…Ø§Ù†  ÙØ¹Ù„ÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ø§Ø´Ø¯',0),(306724,8521,'tr','Yeni bitiÅŸ tarihi & saati geÃ§erli tarih & saat sonra olamaz',0),(306725,8521,'pl','Nowy koniec daty & czas moÅ¼na po bieÅ¼Ä…ca data & czas',0),(306726,8521,'bg','ÐÐ¾Ð²Ð¸ ÐºÑ€Ð°Ð¹ Ð´Ð°Ñ‚Ð° & Ð²Ñ€ÐµÐ¼Ðµ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ ÑÐ»ÐµÐ´ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð° & Ñ‡Ð°Ñ',0),(306727,8521,'ur','Ù†Ø¦Û’ Ø§Ø®ØªØªØ§Ù… ØªØ§Ø±ÛŒØ® & ÙˆÙ‚Øª Ù†ÛÛŒÚº Ø­Ø§Ù„ÛŒÛ ØªØ§Ø±ÛŒØ® & ÙˆÙ‚Øª Ú©Û’ Ø¨Ø¹Ø¯ Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§',0),(306728,8521,'sr','ÐÐ¾Ð²Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ & Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð¼Ð¾Ð³Ñƒ Ð±Ð¸Ñ‚Ð¸ Ð½Ð°ÐºÐ¾Ð½ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾Ð³ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð¸ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(306729,8521,'vi','NgÃ y & thá»i gian káº¿t thÃºc má»›i khÃ´ng thá»ƒ sau ngÃ y & thá»i gian hiá»‡n táº¡i',0),(306730,8521,'af','Nuwe Enddatum & Tyd Kan Nie NA die huidige Datum & Tyd verstel word nie',0),(306731,8521,'ro','Noi sfÃ¢rÅŸitul data & timp nu poate fi dupÄƒ data & ora curentÄƒ',0),(306732,8521,'et','Uus lÃµppkuupÃ¤ev ja aeg ei tohi olla PEALE kÃ¤esolevat aega',0),(306733,8521,'si','Novi konÄni datum & Äas ne more se po trenutni datum & Äas',0),(306734,8521,'ba','Baru akhir tanggal & waktu tidak dapat setelah tanggal & saat',0),(306735,8521,'nl','NA de huidige datum & tijd nieuwe eind datum & tijd niet worden',0),(306736,8521,'fi','Uusi loppu pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ & aika ei voi olla jÃ¤lkeen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ & aika',0),(306737,8521,'no','Nye slutten dato & tid kan ikke vÃ¦re etter gjeldende dato & klokkeslett',0),(306738,8521,'da','Nye ende dato & tid kan ikke vÃ¦re efter dags dato & klokkeslÃ¦t',0),(306739,8521,'ko','ìƒˆë¡œìš´ ë ë‚ ì§œ & ì‹œê°„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ í˜„ìž¬ ë‚ ì§œ & ì‹œê°„ í›„',0),(306740,8521,'he','×—×“×©×•×ª ×¡×•×£ ×ª××¨×™×š & ×–×ž×Ÿ × ×™×ª×Ÿ ×œ××—×¨ ×–×ž×Ÿ & ×”×ª××¨×™×š ×”× ×•×›×—×™',0),(306741,8521,'el','ÎÎ­Î¿ Ï„Î­Î»Î¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± & Ï‡ÏÏŒÎ½Î¿ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼ÎµÏ„Î¬ Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± & ÏŽÏÎ±',0),(306742,8521,'zh','æ–°çš„ç»“æŸæ—¥æœŸåŠæ—¶é—´ä¸èƒ½æ™šäºŽå½“å‰æ—¥æœŸåŠæ—¶é—´\r\n',0),(306743,8521,'sv','Nya slut datum & tid kan inte vara efter aktuellt datum & tid',0),(306744,8521,'it','Nuovo fine data & tempo non puÃ² essere dopo la data corrente & ora',0),(306745,8521,'tl','',0),(306746,8521,'th','New End Date & Time Cannot be AFTER current Date & Time',0),(306747,8521,'hi','à¤¨à¤ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• & à¤¸à¤®à¤¯ à¤¨à¤¹à¥€à¤‚ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• & à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¤®à¤¯ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(306748,8521,'ms','Baru tamat tarikh & masa tidak boleh selepas tarikh & masa semasa',0),(306749,8521,'ar','Ø§Ù„Ø¬Ø¯ÙŠØ¯ \"Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ØªØ§Ø±ÙŠØ® Ø¢Ù†Ø¯ Ø§Ù„ÙˆÙ‚Øª Ù„Ø§ ÙŠÙ…ÙƒÙ†\" Ø£Ù† ÙŠÙƒÙˆÙ† Ø¨Ø¹Ø¯ Ø§Ù„ØªØ§Ø±ÙŠØ® Ø¢Ù†Ø¯ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(306750,8521,'fr','Nouvelle fin Date & temps ne peut pas Ãªtre aprÃ¨s la Date & l\'heure actuelle',0),(306751,8521,'jp','æ–°ã—ã„çµ‚äº†æ—¥ä»˜ & æ™‚é–“ã§ãã¾ã›ã‚“ç¾åœ¨æ—¥ä»˜ & æ™‚é–“å¾Œ',0),(306752,8521,'pt','Novo fim data & tempo nÃ£o pode ser depois da data & hora atual',0),(306753,8521,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐºÐ¾Ð½ÐµÑ† Ð”Ð°Ñ‚Ð° & Ð²Ñ€ÐµÐ¼Ñ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¿Ð¾ÑÐ»Ðµ Ñ‚ÐµÐºÑƒÑ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹ & Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(306754,8521,'es','Nueva Fecha y Tiempo de TÃ©rminaciÃ³n no puede estar DESPUÃ‰S de la Fecha y Tiempo actual',0),(306755,8521,'de','Neue darf Ende Datum & Zeit nicht nach dem aktuellen Datum & Zeit',0),(306756,8521,'en','New End Date & Time Cannot be AFTER current Date & Time',0),(306757,8522,'is','',0),(306758,8522,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ÙˆØ§Ù‚Ø¹ÙŠ',0),(306759,8522,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ÙˆØ§Ù‚Ø¹ÙŠ',0),(306760,8522,'tr','Fiili bitiÅŸ tarihi',0),(306761,8522,'pl','Faktyczna data zakoÅ„czenia',0),(306762,8522,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð° ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(306763,8522,'ur','Ø§ØµÙ„ Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ®',0),(306764,8522,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(306765,8522,'vi','NgÃ y Káº¿t ThÃºc Thá»±c Táº¿',0),(306766,8522,'af','Werklike Einddatum',0),(306767,8522,'ro','Data terminare actuala',0),(306768,8522,'et','Tegelik lÃµppkuupÃ¤ev',0),(306769,8522,'si','Dejanski konÄni datum',0),(306770,8522,'ba','Akhir periode Aktual',0),(306771,8522,'nl','Werkelijke einddatum',0),(306772,8522,'fi','Todellinen pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(306773,8522,'no','Faktisk sluttdato',0),(306774,8522,'da','Faktiske slutdato',0),(306775,8522,'ko','ì‹¤ì œ ì¢…ë£Œ ë‚ ì§œ',0),(306776,8522,'he','×ª××¨×™×š ×¡×™×•× ×‘×¤×•×¢×œ',0),(306777,8522,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ®',0),(306778,8522,'zh','å®žé™…ç»“æŸæ—¥æœŸ\r\n',0),(306779,8522,'sv','Faktiskt slutdatum',0),(306780,8522,'it','Data fine effettiva',0),(306781,8522,'tl','',0),(306782,8522,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3592;&#3619;&#3636;&#3591;',0),(306783,8522,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤…à¤‚à¤¤à¤¿à¤® à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(306784,8522,'ms','Tarikh sebenar tamat',0),(306785,8522,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ÙØ¹Ù„ÙŠ',0),(306786,8522,'fr','Date de fin rÃ©elle',0),(306787,8522,'jp','å®Ÿéš›ã®çµ‚äº†æ—¥',0),(306788,8522,'pt','Data de tÃ©rmino real',0),(306789,8522,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ°Ñ Ð´Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(306790,8522,'es','Fecha Final Actual',0),(306791,8522,'de','TatsÃ¤chliche Enddatum',0),(306792,8522,'en','Actual End Date',0),(306793,8523,'is','',0),(306794,8523,'dr','Ø³Ø§Ø¹Øª Ù¾Ø§ÙŠØ§Ù† ÙˆØ§Ù‚Ø¹ÙŠ',0),(306795,8523,'pr','Ø³Ø§Ø¹Øª Ù¾Ø§ÙŠØ§Ù† ÙˆØ§Ù‚Ø¹ÙŠ',0),(306796,8523,'tr','GerÃ§ek bitiÅŸ saat',0),(306797,8523,'pl','Rzeczywiste zakoÅ„czenie godziny',0),(306798,8523,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÐµÐ½ ÐºÑ€Ð°ÐµÐ½ Ñ‡Ð°Ñ',0),(306799,8523,'ur','Ø§ØµÙ„ Ø§Ø®ØªØªØ§Ù… Ú¯Ú¾Ù†Ù¹Û’',0),(306800,8523,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð¸ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚Ð°Ðº ÑÐ°Ñ‚',0),(306801,8523,'vi','Giá» Káº¿t ThÃºc Thá»±c Táº¿',0),(306802,8523,'af','Werklike Einduur',0),(306803,8523,'ro','Ora terminare actuala',0),(306804,8523,'et','Tegelik lÃµpp tund',0),(306805,8523,'si','Dejanski konÄni uro',0),(306806,8523,'ba','Aktual Akhir - Jam',0),(306807,8523,'nl','Werkelijke einde uur',0),(306808,8523,'fi','Todellinen pÃ¤Ã¤ty',0),(306809,8523,'no','Faktisk slutt time',0),(306810,8523,'da','Faktiske ende time',0),(306811,8523,'ko','ì‹¤ì œ ë§ˆì§€ë§‰ ì‹œê°„',0),(306812,8523,'he','×©×¢×ª ×¡×™×•× ×‘×¤×•×¢×œ',0),(306813,8523,'el','Î¤ÎµÎ»Î¹ÎºÏŒ ÏŽÏÎ±',0),(306814,8523,'zh','å®žé™…ç»“æŸå°æ—¶\r\n',0),(306815,8523,'sv','Faktiska slutet timme',0),(306816,8523,'it','Ora fine effettiva',0),(306817,8523,'tl','',0),(306818,8523,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3592;&#3619;&#3636;&#3591;',0),(306819,8523,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤…à¤‚à¤¤à¤¿à¤® à¤˜à¤‚à¤Ÿà¥‡',0),(306820,8523,'ms','Jam akhir sebenar',0),(306821,8523,'ar','Ø³Ø§Ø¹Ø© Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ÙØ¹Ù„ÙŠ',0),(306822,8523,'fr','Heure rÃ©elle de fin',0),(306823,8523,'jp','å®Ÿéš›ã®çµ‚äº†æ™‚é–“',0),(306824,8523,'pt','Hora de fim real',0),(306825,8523,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ ÐºÐ¾Ð½ÐµÑ† Ñ‡Ð°Ñ',0),(306826,8523,'es','Hora Final Actual',0),(306827,8523,'de','TatsÃ¤chlichen Beendigung Stunde',0),(306828,8523,'en','Actual End Hour',0),(306829,8524,'is','',0),(306830,8524,'dr','Ø¯Ù‚ÙŠÙ‚Ù‡ Ù¾Ø§ÙŠØ§Ù† ÙˆØ§Ù‚Ø¹ÙŠ',0),(306831,8524,'pr','Ø¯Ù‚ÙŠÙ‚Ù‡ Ù¾Ø§ÙŠØ§Ù† ÙˆØ§Ù‚Ø¹ÙŠ',0),(306832,8524,'tr','GerÃ§ek bitiÅŸ dakika',0),(306833,8524,'pl','Rzeczywiste zakoÅ„czenie jazdy',0),(306834,8524,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð° ÐºÑ€Ð°Ð¹Ð½Ð° Ð¼Ð¸Ð½ÑƒÑ‚Ð°',0),(306835,8524,'ur','Ø§ØµÙ„ Ø§Ø®ØªØªØ§Ù… Ù…Ù†Ù¹',0),(306836,8524,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð¸ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚Ð°Ðº Ð¼Ð¸Ð½ÑƒÑ‚',0),(306837,8524,'vi','PhÃºt Káº¿t ThÃºc Thá»±c Táº¿',0),(306838,8524,'af','Werklike Eindminuut',0),(306839,8524,'ro','Minut terminare actual',0),(306840,8524,'et','Tegelik lÃµpp minut',0),(306841,8524,'si','Dejanski konÄni minuto',0),(306842,8524,'ba','Aktual Akhir - menit',0),(306843,8524,'nl','Werkelijke einde minuut',0),(306844,8524,'fi','Todellinen lopussa minuutti',0),(306845,8524,'no','Faktisk slutter (minutt)',0),(306846,8524,'da','Faktiske sidst minut',0),(306847,8524,'ko','ì‹¤ì œ ìµœì¢… ë¶„',0),(306848,8524,'he','×¡×™×•× ×‘×¤×•×¢×œ ×“×§×•×ª',0),(306849,8524,'el','Î¤ÎµÎ»Î¹ÎºÏŒ Î»ÎµÏ€Ï„ÏŒ',0),(306850,8524,'zh','å®žé™…æœ€ç»ˆåˆ†é’Ÿ\r\n',0),(306851,8524,'sv','Faktiska slutet minut',0),(306852,8524,'it','Minuti fine effettiva',0),(306853,8524,'tl','',0),(306854,8524,'th','&#3609;&#3634;&#3607;&#3637;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3592;&#3619;&#3636;&#3591;',0),(306855,8524,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤…à¤‚à¤¤à¤¿à¤® à¤®à¤¿à¤¨à¤Ÿ',0),(306856,8524,'ms','Minit akhir sebenar',0),(306857,8524,'ar','Ù„Ø­Ø¸Ø© Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ÙØ¹Ù„ÙŠ',0),(306858,8524,'fr','Fin rÃ©elle Minute',0),(306859,8524,'jp','å®Ÿéš›ã®çµ‚äº†åˆ†',0),(306860,8524,'pt','Minuto real final',0),(306861,8524,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ ÐºÐ¾Ð½ÐµÑ† Ð¼Ð¸Ð½ÑƒÑ‚Ñ‹',0),(306862,8524,'es','Minuto Final Actual',0),(306863,8524,'de','TatsÃ¤chlichen Beendigung Minute',0),(306864,8524,'en','Actual End Minute',0),(306865,8525,'is','',0),(306866,8525,'dr','Ø³Ø§Ø¹Ø§Øª Ø³Ù¾Ø±ÙŠ Ø´Ø¯Ù‡ ÙØ±Ø§ØªØ± Ø±ÙØª ',0),(306867,8525,'pr','Ø³Ø§Ø¹Ø§Øª Ø³Ù¾Ø±ÙŠ Ø´Ø¯Ù‡ ÙØ±Ø§ØªØ± Ø±ÙØª ',0),(306868,8525,'tr','GeÃ§en saat aÅŸan',0),(306869,8525,'pl','Godziny upÅ‚ynÄ™Å‚y przekracza',0),(306870,8525,'bg','Ð˜Ð·Ñ‚ÐµÐºÐ»Ð¸ Ñ‡Ð°ÑÐ° Ð½Ð°Ð´Ð²Ð¸ÑˆÐ°Ð²Ð°',0),(306871,8525,'ur','Ú¯Ø²Ø±Ø§ Ú¯Ú¾Ù†Ù¹Û’ Ø³Û’ ØªØ¬Ø§ÙˆØ²',0),(306872,8525,'sr','Ð¡Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾Ñ‚ÐµÐºÐ»Ð¾ Ð¿Ñ€ÐµÐ¼Ð°ÑˆÐ¸',0),(306873,8525,'vi','QuÃ¡ má»©c giá» trÃ´i qua',0),(306874,8525,'af','Uur verstryk oorskry',0),(306875,8525,'ro','Ore scurs depÄƒÅŸeÅŸte',0),(306876,8525,'et','Tundi mÃ¶Ã¶das Ã¼le',0),(306877,8525,'si','Ure preteklo presega',0),(306878,8525,'ba','Jam berlalu melebihi',0),(306879,8525,'nl','Uur verstreken overschrijden',0),(306880,8525,'fi','Tuntia kulunut enintÃ¤Ã¤n',0),(306881,8525,'no','Timer utlÃ¸p overstige',0),(306882,8525,'da','Timer udlÃ¸bet overstiger',0),(306883,8525,'ko','ì‹œê°„ ê²½ê³¼ ì´ˆê³¼',0),(306884,8525,'he','×¢×‘×¨×• ×©×¢×•×ª ×™×¢×œ×” ×¢×œ',0),(306885,8525,'el','ÎÏÎµÏ‚ Ï€Î±ÏÎ­Î»Î¸ÎµÎ¹ Ï…Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹',0),(306886,8525,'zh','è¿‡åŽ»æ—¶é—´å·²è¶…è¿‡\r\n',0),(306887,8525,'sv','Timmar fÃ¶rflutit Ã¶verstiger',0),(306888,8525,'it','Trascorso ore superare',0),(306889,8525,'tl','',0),(306890,8525,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3651;&#3604;&#3648;&#3623;&#3621;&#3634;&#3627;&#3609;&#3638;&#3656;&#3591;&#3612;&#3656;&#3634;&#3609;&#3652;&#3611;&#3648;&#3585;&#3636;&#3609;&#3585;&#3623;&#3656;&#3634;',0),(306891,8525,'hi','Elapsed à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¹à¥‹',0),(306892,8525,'ms','Jam berlalu melebihi',0),(306893,8525,'ar','Ø§Ù†Ù‚Ø¶Øª Ø³Ø§Ø¹Ø§Øª ØªØªØ¬Ø§ÙˆØ²',0),(306894,8525,'fr','Heures Ã©coulÃ©es dÃ©passe',0),(306895,8525,'jp','å˜ä½ã®çµŒéŽæ™‚é–“ã‚’è¶…ãˆã‚‹',0),(306896,8525,'pt','Horas decorrido exceder',0),(306897,8525,'ru','ÐŸÑ€Ð¾ÑˆÐ»Ð¾ Ñ‡Ð°ÑÐ¾Ð² Ð¿Ñ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚',0),(306898,8525,'es','Horas Transcurridas Excede',0),(306899,8525,'de','Stunden vergangen Ã¼berschreiten',0),(306900,8525,'en','Hours Elapsed Exceed',0),(306901,8526,'is','',0),(306902,8526,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(306903,8526,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(306904,8526,'tr','OnaylanmamÄ±ÅŸ DÃ¼zenle',0),(306905,8526,'pl','Edycja niezatwierdzone',0),(306906,8526,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½ÐµÐ¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸',0),(306907,8526,'ur','ØªØ¯ÙˆÛŒÙ† Ø§Ù†ØªØ¸Ø§Ù…ÛŒÛ',0),(306908,8526,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½ÐµÐ¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸',0),(306909,8526,'vi','Sá»­a KhÃ´ng Duyá»‡t',0),(306910,8526,'af','Redigeer Nie-Goedgekeurde',0),(306911,8526,'ro','Editare neaprobate',0),(306912,8526,'et','Redigeeri kinnitamata',0),(306913,8526,'si','Urejanje neodobrenih',0),(306914,8526,'ba','Edit tidak disetujui',0),(306915,8526,'nl','Niet-goedgekeurde bewerken',0),(306916,8526,'fi','Muokkaa hyvÃ¤ksymÃ¤ttÃ¶miÃ¤',0),(306917,8526,'no','Rediger godkjent',0),(306918,8526,'da','Rediger ikke-godkendte',0),(306919,8526,'ko','íŽ¸ì§‘ ìŠ¹ì¸ëœ',0),(306920,8526,'he','×¢×¨×™×›×” ×©×œ× ××•×©×¨×•',0),(306921,8526,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Î½Î­Î³ÎºÏÎ¹Ï„Î¿Ï‚',0),(306922,8526,'zh','ç¼–è¾‘æœªæ‰¹å‡†\r\n',0),(306923,8526,'sv','Redigera icke godkÃ¤nda',0),(306924,8526,'it','Modifica non approvato',0),(306925,8526,'tl','',0),(306926,8526,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;',0),(306927,8526,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤…à¤¨à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤',0),(306928,8526,'ms','Edit tidak',0),(306929,8526,'ar','ØªØ­Ø±ÙŠØ± ØºÙŠØ± Ù…Ø¹ØªÙ…Ø¯Ø©',0),(306930,8526,'fr','Edit non approuvÃ©e',0),(306931,8526,'jp','æœªæ‰¿èªã®ç·¨é›†',0),(306932,8526,'pt','Editar nÃ£o aprovado',0),(306933,8526,'ru','ÐŸÑ€Ð°Ð²ÐºÐ° Ð½ÐµÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ñ…',0),(306934,8526,'es','Editar No Aprobado',0),(306935,8526,'de','Bearbeiten nicht genehmigte',0),(306936,8526,'en','Edit Unapproved',0),(306937,8527,'is','',0),(306938,8527,'dr','Ø³ÙŠØ³ØªÙ… Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø´ØºÙ„ Ùˆ Ø²Ù…Ø§Ù† ',0),(306939,8527,'pr','Ø³ÙŠØ³ØªÙ… Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø´ØºÙ„ Ùˆ Ø²Ù…Ø§Ù† ',0),(306940,8527,'tr','Zaman ve iÅŸ takip sistemi',0),(306941,8527,'pl','Czasu i pracy, System Å›ledzenia',0),(306942,8527,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð°, ÑÐ¸ÑÑ‚ÐµÐ¼Ð° Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(306943,8527,'ur','ÙˆÙ‚Øª Ø§ÙˆØ± Ù†Ø¸Ø§Ù… Ø³Ø±Ø§Øº Ú©Ø§Ø±ÛŒ Ú©Ø§Ù…',0),(306944,8527,'sr','ÐŸÑƒÑ‚ Ð¸ Ð¿Ð¾ÑÐ°Ð¾, ÑÐ¸ÑÑ‚ÐµÐ¼ Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ',0),(306945,8527,'vi','Há»‡ thá»‘ng kiá»ƒm tra thá»i gian & Job',0),(306946,8527,'af','Tyd en Werkstuk Sporing Sisteem',0),(306947,8527,'ro','Timp ÅŸi loc de muncÄƒ sistem de urmÄƒrire',0),(306948,8527,'et','Aeg ja tÃ¶Ã¶ jÃ¤lgimise sÃ¼steem',0),(306949,8527,'si','ÄŒas in delo, sistem sledenja',0),(306950,8527,'ba','Waktu dan pekerjaan sistem pelacakan',0),(306951,8527,'nl','Tijd en Job Tracking Systeem',0),(306952,8527,'fi','Ja tyÃ¶ntekijÃ¶iden seurantajÃ¤rjestelmÃ¤',0),(306953,8527,'no','Tid og jobb sporingssystem',0),(306954,8527,'da','Tid og opgave Tracking System',0),(306955,8527,'ko','ì‹œê°„ ë° ìž‘ì—… ì¶”ì  ì‹œìŠ¤í…œ',0),(306956,8527,'he','×”×–×ž×Ÿ ×•×”×¢×‘×•×“×” ×ž×¢×¨×›×ª ×ž×¢×§×‘',0),(306957,8527,'el','Î§ÏÏŒÎ½Î¿ ÎºÎ±Î¹ Î´Î¿Ï…Î»ÎµÎ¹Î¬ ÏƒÏÏƒÏ„Î·Î¼Î± Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚',0),(306958,8527,'zh','æ—¶é—´å’Œä½œä¸šè·Ÿè¸ªç³»ç»Ÿ\r\n',0),(306959,8527,'sv','Tid och jobb Tracking System',0),(306960,8527,'it','Tempo e lavoro, sistema di monitoraggio',0),(306961,8527,'tl','',0),(306962,8527,'th','&#3619;&#3632;&#3610;&#3610;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617; &#3648;&#3623;&#3621;&#3634;&#3649;&#3621;&#3632;&#3591;&#3634;&#3609;',0),(306963,8527,'hi','à¤¸à¤®à¤¯ à¤”à¤° à¤¨à¥Œà¤•à¤°à¥€ à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤ªà¥à¤°à¤£à¤¾à¤²à¥€',0),(306964,8527,'ms','Masa dan kerja sistem mengesan',0),(306965,8527,'ar','Ø§Ù„ÙˆÙ‚Øª ÙˆÙ…Ù‡Ù…Ø© Ù†Ø¸Ø§Ù… Ø§Ù„ØªØªØ¨Ø¹',0),(306966,8527,'fr','Temps et travail, systÃ¨me de suivi',0),(306967,8527,'jp','æ™‚é–“ã¨ã‚¸ãƒ§ãƒ–è¿½è·¡ã‚·ã‚¹ãƒ†ãƒ ',0),(306968,8527,'pt','Tempo de trabalho e sistema de rastreamento',0),(306969,8527,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(306970,8527,'es','Sistema de Rastreo de Tiempo y Trabajo',0),(306971,8527,'de','Zeit und Job-Tracking System',0),(306972,8527,'en','Time and Job Tracking System',0),(306973,8528,'is','',0),(306974,8528,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ÙŠÙƒ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ Ø§Ø¶Ø§ÙÙ‡   ÙƒÙ†ÙŠØ¯ØŸ',0),(306975,8528,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ÙŠÙƒ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ Ø§Ø¶Ø§ÙÙ‡   ÙƒÙ†ÙŠØ¯ØŸ',0),(306976,8528,'tr','Yeni bir veritabanÄ± eklemek istediÄŸinizden emin misiniz?',0),(306977,8528,'pl','Czy jesteÅ› pewien, Å¼e chcesz dodaÄ‡ nowÄ… bazÄ™ danych?',0),(306978,8528,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸?',0),(306979,8528,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§ÛŒÚ© Ù†ÛŒØ§ ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(306980,8528,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð±Ð°Ð·Ñƒ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°?',0),(306981,8528,'vi','ThÃªm má»™t bá»™ dá»¯ liá»‡u má»›i?',0),(306982,8528,'af','Is U seker u wil \'n nuwe databasis byvoeg?',0),(306983,8528,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ adÄƒugaÅ£i o nouÄƒ bazÄƒ de date?',0),(306984,8528,'et','Oled kindel, et soovid lisada uut andmebaasi?',0),(306985,8528,'si','Ali ste prepriÄani, da Å¾elite dodati novo zbirko podatkov?',0),(306986,8528,'ba','Apakah Anda yakin Anda ingin menambahkan database baru?',0),(306987,8528,'nl','Weet u zeker dat u wilt toevoegen van een nieuwe database?',0),(306988,8528,'fi','Oletko varma, ettÃ¤ haluat lisÃ¤tÃ¤ uuden tietokannan?',0),(306989,8528,'no','Er du sikker pÃ¥ at du vil legge til en ny database?',0),(306990,8528,'da','Er du sikker pÃ¥ du vil tilfÃ¸je en ny database?',0),(306991,8528,'ko','ë‹¹ì‹ ì€ ìƒˆ ë°ì´í„°ë² ì´ìŠ¤ë¥¼ ì¶”ê°€ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(306992,8528,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×”×•×¡×™×£ ×ž×¡×“ × ×ª×•× ×™× ×—×“×©?',0),(306993,8528,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î¼Î¹Î± Î½Î­Î± Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½;',0),(306994,8528,'zh','ä½ ç¡®å®šä½ è¦æ·»åŠ ä¸€ä¸ªæ–°çš„æ•°æ®åº“å—ï¼Ÿ\r\n',0),(306995,8528,'sv','Ã„r du sÃ¤ker du vill lÃ¤gga till en ny databas?',0),(306996,8528,'it','Sei sicuro che si desidera aggiungere un nuovo database?',0),(306997,8528,'tl','',0),(306998,8528,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(306999,8528,'hi','à¤¤à¥à¤®à¥à¤¹à¥‡à¤‚ à¤¯à¤•à¥€à¤¨ à¤¹à¥ˆ à¤•à¤¿ à¤¤à¥à¤® à¤à¤• à¤¨à¤ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(307000,8528,'ms','Adakah anda pasti yang anda ingin tambah pangkalan data baru?',0),(307001,8528,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©ØŸ',0),(307002,8528,'fr','ÃŠtes-vous sÃ»r de vouloir ajouter une nouvelle base de donnÃ©es?',0),(307003,8528,'jp','æ–°ã—ã„ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚’è¿½åŠ ã™ã‚‹ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(307004,8528,'pt','Tens a certeza de que vocÃª deseja adicionar um novo banco de dados?',0),(307005,8528,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹ Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð±Ð°Ð·Ñƒ Ð´Ð°Ð½Ð½Ñ‹Ñ…?',0),(307006,8528,'es','Â¿Esta seguro que quiere agregar una nueva base de datos?',0),(307007,8528,'de','Sind Sie sicher, dass Sie eine neue Datenbank hinzufÃ¼gen mÃ¶chten?',0),(307008,8528,'en','Are you sure you want to add a new database?',0),(307009,8529,'is','',0),(307010,8529,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙŠØ¬Ø§Ø¯  Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ ÙŠ Ø¬Ø¯ÙŠØ¯  Ù†ÙŠØ³Øª',0),(307011,8529,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙŠØ¬Ø§Ø¯  Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ ÙŠ Ø¬Ø¯ÙŠØ¯  Ù†ÙŠØ³Øª',0),(307012,8529,'tr','Yeni veritabanÄ± oluÅŸturulamadÄ±',0),(307013,8529,'pl','Nie moÅ¼na utworzyÄ‡ nowÄ… bazÄ™ danych',0),(307014,8529,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ð½Ð¾Ð²Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(307015,8529,'ur','Ù†ÛŒØ§ Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù†ÛÛŒÚº Ø¨Ù†Ø§ Ø³Ú©Ø§',0),(307016,8529,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ Ð½Ð¾Ð²Ñƒ Ð±Ð°Ð·Ñƒ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(307017,8529,'vi','KhÃ´ng táº¡o Ä‘Æ°á»£c dá»¯ liá»‡u má»›i',0),(307018,8529,'af','Kan nie Nuwe Databasis Skep',0),(307019,8529,'ro','Nu ar putea crea noi baze de date',0),(307020,8529,'et','Ei saanud luuauut andmebaasi',0),(307021,8529,'si','Ni bilo mogoÄe ustvariti novo zbirko podatkov',0),(307022,8529,'ba','Tidak dapat membuat Database baru',0),(307023,8529,'nl','Could Not Create nieuwe Database',0),(307024,8529,'fi','Uuden tietokannan luominen ei onnistunut',0),(307025,8529,'no','Kan ikke opprette ny Database',0),(307026,8529,'da','Kunne ikke oprette nye Database',0),(307027,8529,'ko','ìƒˆ ë°ì´í„°ë² ì´ìŠ¤ë¥¼ ë§Œë“¤ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(307028,8529,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×™×¦×•×¨ ×ž×¡×“ × ×ª×•× ×™× ×—×“×©',0),(307029,8529,'el','Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Î½Î­Î± Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(307030,8529,'zh','æ— æ³•åˆ›å»ºæ–°çš„æ•°æ®åº“\r\n',0),(307031,8529,'sv','Kunde inte skapa ny databas',0),(307032,8529,'it','Non puÃ² creare nuovi Database',0),(307033,8529,'tl','',0),(307034,8529,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3626;&#3619;&#3657;&#3634;&#3591;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3652;&#3604;&#3657;',0),(307035,8529,'hi','à¤¨à¤ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¨à¤¹à¥€à¤‚ à¤¬à¤¨à¤¾ à¤¸à¤•à¤¾',0),(307036,8529,'ms','Tidak dapat mencipta pangkalan data baru',0),(307037,8529,'ar','Ù„Ù… ÙŠÙ…ÙƒÙ†  Ø¥Ù†Ø´Ø§Ø¡ Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(307038,8529,'fr','Pas pu crÃ©er de nouvelle base de donnÃ©es',0),(307039,8529,'jp','æ–°ã—ã„ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚’ä½œæˆã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(307040,8529,'pt','NÃ£o foi possÃ­vel criar o novo banco de dados',0),(307041,8529,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ ÐÐ¾Ð²ÑƒÑŽ Ð‘Ð°Ð·Ñƒ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(307042,8529,'es','No se PodÃ­a Crear Nueva Base de Datos',0),(307043,8529,'de','Neue Datenbank konnte nicht erstellt werden.',0),(307044,8529,'en','Could Not Create New Database',0),(307045,8530,'is','',0),(307046,8530,'dr','Ø³Ø§ÙŠØª Ù‡Ø§ÙŠ Ù…ÙŠØ²Ø¨Ø§Ù† ÙØ¹Ù„ÙŠ ',0),(307047,8530,'pr','Ø³Ø§ÙŠØª Ù‡Ø§ÙŠ Ù…ÙŠØ²Ø¨Ø§Ù† ÙØ¹Ù„ÙŠ ',0),(307048,8530,'tr','GeÃ§erli barÄ±ndÄ±rÄ±lan siteler',0),(307049,8530,'pl','BieÅ¼Ä…cej witryny obsÅ‚ugiwane',0),(307050,8530,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ñ…Ð¾ÑÑ‚Ð²Ð° ÑÐ°Ð¹Ñ‚Ð¾Ð²Ðµ',0),(307051,8530,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ù…ÛŒØ²Ø¨Ø§Ù† ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹Ø³',0),(307052,8530,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ñ˜Ð°Ð²Ð½Ð¸Ñ…',0),(307053,8530,'vi','Trang Hosting hiá»‡n thá»i',0),(307054,8530,'af','Huidige gehuisves werwe',0),(307055,8530,'ro','Curent gÄƒzduit site-uri',0),(307056,8530,'et','Praegune kodulehed',0),(307057,8530,'si','Trenutni gostiÅ¡Äe mesta',0),(307058,8530,'ba','Saat ini host situs',0),(307059,8530,'nl','Huidige gehoste Sites',0),(307060,8530,'fi','Nykyinen isÃ¤nnÃ¶i sivustoja',0),(307061,8530,'no','Gjeldende vert nettsteder',0),(307062,8530,'da','NuvÃ¦rende hostede Sites',0),(307063,8530,'ko','í˜„ìž¬ í˜¸ìŠ¤íŒ…ëœ ì‚¬ì´íŠ¸',0),(307064,8530,'he','×”××ª×¨×™× ×ž×ª××¨×— ×”× ×•×›×—×™×™×',0),(307065,8530,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Sites Ï€Î¿Ï… Ï†Î¹Î»Î¿Î¾ÎµÎ½Î¿ÏÎ½Ï„Î±Î¹',0),(307066,8530,'zh','å½“å‰ä¸»ç®¡çš„ç½‘ç«™\r\n',0),(307067,8530,'sv','Nuvarande vÃ¤rd platser',0),(307068,8530,'it','Attuali siti ospitati',0),(307069,8530,'tl','',0),(307070,8530,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3650;&#3630;&#3626;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(307071,8530,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¹à¥‹à¤¸à¥à¤Ÿà¥‡à¤¡ à¤¸à¤¾à¤‡à¤Ÿà¥à¤¸',0),(307072,8530,'ms','Semasa tapak yang dihoskan',0),(307073,8530,'ar','Ø§Ù„Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ù…Ø³ØªØ¶Ø§ÙØ© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(307074,8530,'fr','Actuelle des Sites hÃ©bergÃ©s',0),(307075,8530,'jp','ç¾åœ¨ãƒ›ã‚¹ãƒˆã•ã‚Œã¦ã„ã‚‹ã‚µã‚¤ãƒˆ',0),(307076,8530,'pt','Atuais Sites hospedados',0),(307077,8530,'ru','Ð¢ÐµÐºÑƒÑ‰ÐµÐµ Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ðµ ÑÐ°Ð¹Ñ‚Ð¾Ð²',0),(307078,8530,'es','Sitios Hospedados Actuales',0),(307079,8530,'de','Aktuelle gehostete Sites',0),(307080,8530,'en','Current Hosted Sites',0),(307081,8531,'is','',0),(307082,8531,'dr','Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(307083,8531,'pr','Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(307084,8531,'tr','VeritabanÄ± adÄ±',0),(307085,8531,'pl','Nazwa bazy danych',0),(307086,8531,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(307087,8531,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù†Ø§Ù…',0),(307088,8531,'sr','Ð˜Ð¼Ðµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(307089,8531,'vi','TÃªn Dá»¯ Liá»‡u',0),(307090,8531,'af','Databasis Naam',0),(307091,8531,'ro','Numele bazei de date',0),(307092,8531,'et','Andmebaasi nimi',0),(307093,8531,'si','Ime zbirke podatkov',0),(307094,8531,'ba','Nama database',0),(307095,8531,'nl','Databasenaam',0),(307096,8531,'fi','Tietokannan nimi',0),(307097,8531,'no','Databasenavn',0),(307098,8531,'da','Databasenavn',0),(307099,8531,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì´ë¦„',0),(307100,8531,'he','×©× ×ž×¡×“ × ×ª×•× ×™×',0),(307101,8531,'el','ÎŒÎ½Î¿Î¼Î± Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(307102,8531,'zh','æ•°æ®åº“çš„åç§°\r\n',0),(307103,8531,'sv','Databasens namn',0),(307104,8531,'it','Nome del database',0),(307105,8531,'tl','',0),(307106,8531,'th','&#3594;&#3639;&#3656;&#3629;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(307107,8531,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¤¾ à¤¨à¤¾à¤®',0),(307108,8531,'ms','Nama pangkalan data',0),(307109,8531,'ar','Ø¥Ø³Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(307110,8531,'fr','Nom de la base de donnÃ©es',0),(307111,8531,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹å',0),(307112,8531,'pt','Nome do banco de dados',0),(307113,8531,'ru','Ð˜Ð¼Ñ Ð‘Ð°Ð·Ñ‹ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(307114,8531,'es','Nombre de Base de Datos',0),(307115,8531,'de','Datenbankname',0),(307116,8531,'en','Database Name',0),(307117,8532,'is','',0),(307118,8532,'dr','Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(307119,8532,'pr','Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(307120,8532,'tr','VeritabanÄ± adÄ±',0),(307121,8532,'pl','Nazwa DB',0),(307122,8532,'bg','DB Ð¸Ð¼Ðµ',0),(307123,8532,'ur','DB Ù†Ø§Ù…',0),(307124,8532,'sr','Ð˜Ð¼Ðµ Ð”Ð‘',0),(307125,8532,'vi','TÃªn dá»¯ liá»‡u',0),(307126,8532,'af','DB Naam',0),(307127,8532,'ro','Numele DB',0),(307128,8532,'et','Andmebaasi nimi',0),(307129,8532,'si','DB ime',0),(307130,8532,'ba','Nama DB',0),(307131,8532,'nl','DB naam',0),(307132,8532,'fi','DB nimi',0),(307133,8532,'no','DB navn',0),(307134,8532,'da','DB navn',0),(307135,8532,'ko','DB ì´ë¦„',0),(307136,8532,'he','×©× DB',0),(307137,8532,'el','ÎŒÎ½Î¿Î¼Î± DB',0),(307138,8532,'zh','æ•°æ®åº“åç§°\r\n',0),(307139,8532,'sv','DB-namnet',0),(307140,8532,'it','Nome del DB',0),(307141,8532,'tl','',0),(307142,8532,'th','&#3594;&#3639;&#3656;&#3629;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(307143,8532,'hi','DB à¤¨à¤¾à¤®',0),(307144,8532,'ms','Nama DB',0),(307145,8532,'ar','Ø§Ø³Ù… DB',0),(307146,8532,'fr','Nom de la BD',0),(307147,8532,'jp','DB å',0),(307148,8532,'pt','Nome de DB',0),(307149,8532,'ru','Ð˜Ð¼Ñ Ð‘Ð”',0),(307150,8532,'es','BD Nombre',0),(307151,8532,'de','DB-Name',0),(307152,8532,'en','DB Name',0),(307153,8533,'is','',0),(307154,8533,'dr','Ù†Ø§Ù… Ø¯Ø§Ù…Ù†Ù‡ ',0),(307155,8533,'pr','Ù†Ø§Ù… Ø¯Ø§Ù…Ù†Ù‡ ',0),(307156,8533,'tr','Etki alanÄ± adÄ±',0),(307157,8533,'pl','Nazwa domeny',0),(307158,8533,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð´Ð¾Ð¼ÐµÐ¹Ð½',0),(307159,8533,'ur','Ø¹Ù…Ù„ Ø¯Ø§Ø±ÛŒ Ù†Ø§Ù…',0),(307160,8533,'sr','Ð˜Ð¼Ðµ Ð´Ð¾Ð¼ÐµÐ½Ð°',0),(307161,8533,'vi','TÃªn miá»n',0),(307162,8533,'af','Domeinnaam',0),(307163,8533,'ro','Nume de domeniu',0),(307164,8533,'et','Domeeninime',0),(307165,8533,'si','Ime domene',0),(307166,8533,'ba','Nama domain',0),(307167,8533,'nl','Domeinnaam',0),(307168,8533,'fi','Verkkotunnus',0),(307169,8533,'no','Domenenavn',0),(307170,8533,'da','DomÃ¦nenavn',0),(307171,8533,'ko','ë„ë©”ì¸ ì´ë¦„',0),(307172,8533,'he','×©× ×ª×—×•×',0),(307173,8533,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î¿Î¼Î­Î±',0),(307174,8533,'zh','åŸŸå\r\n',0),(307175,8533,'sv','DomÃ¤nnamn',0),(307176,8533,'it','Nome di dominio',0),(307177,8533,'tl','',0),(307178,8533,'th','&#3594;&#3639;&#3656;&#3629;&#3650;&#3604;&#3648;&#3617;&#3609;',0),(307179,8533,'hi','à¤¡à¥‹à¤®à¥‡à¤¨ à¤¨à¤¾à¤®',0),(307180,8533,'ms','Nama domain',0),(307181,8533,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø¬Ø§Ù„',0),(307182,8533,'fr','Nom de domaine',0),(307183,8533,'jp','ãƒ‰ãƒ¡ã‚¤ãƒ³å',0),(307184,8533,'pt','Nome de domÃ­nio',0),(307185,8533,'ru','Ð”Ð¾Ð¼ÐµÐ½Ð½Ð¾Ðµ Ð¸Ð¼Ñ',0),(307186,8533,'es','Nombre de DomÃ­nio',0),(307187,8533,'de','Domain-Namen',0),(307188,8533,'en','Domain Name',0),(307189,8534,'is','',0),(307190,8534,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ ',0),(307191,8534,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ ',0),(307192,8534,'tr','VeritabanÄ± etkinleÅŸtirilirken hata oluÅŸtu',0),(307193,8534,'pl','BÅ‚Ä…d aktywacji bazy danych',0),(307194,8534,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(307195,8534,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ ÙØ¹Ø§Ù„ Ú©Ø± Ù†Ù‚Øµ',0),(307196,8534,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°ÑšÑƒ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(307197,8534,'vi','KÃ­ch hoáº¡t dá»¯ liá»‡u bá»‹ lá»—i',0),(307198,8534,'af','Fout met Aktivering van Databasis',0),(307199,8534,'ro','Eroare activarea bazei de date',0),(307200,8534,'et','TÃµrge andmebaasi aktiveerimisel',0),(307201,8534,'si','Napaka pri aktiviranju zbirke podatkov',0),(307202,8534,'ba','Kesalahan yang mengaktifkan Database',0),(307203,8534,'nl','Kan database niet activeren',0),(307204,8534,'fi','Virhe aktivoitaessa tietokanta',0),(307205,8534,'no','Feil under aktivering av Database',0),(307206,8534,'da','Fejl under aktivering Database',0),(307207,8534,'ko','ë°ì´í„°ë² ì´ìŠ¤ë¥¼ í™œì„±í™” í•˜ëŠ” ì˜¤ë¥˜',0),(307208,8534,'he','×©×’×™××” ×”×¤×¢×œ×ª ×ž×¡×“ × ×ª×•× ×™×',0),(307209,8534,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï„Î·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(307210,8534,'zh','é”™è¯¯æ¿€æ´»æ•°æ®åº“',0),(307211,8534,'sv','Fel aktivera databas',0),(307212,8534,'it','Errore di attivazione di Database',0),(307213,8534,'tl','',0),(307214,8534,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3607;&#3635;&#3651;&#3627;&#3657;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3652;&#3604;&#3657;',0),(307215,8534,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¤¨à¥‡ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(307216,8534,'ms','Ralat Pengaktifan pangkalan data',0),(307217,8534,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªÙ†Ø´ÙŠØ· Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„ÙŠØ§Ù†Ø§Øª',0),(307218,8534,'fr','Erreur d\'activation de base de donnÃ©es',0),(307219,8534,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã®ã‚¢ã‚¯ãƒ†ã‚£ãƒ–åŒ–ã‚¨ãƒ©ãƒ¼',0),(307220,8534,'pt','Erro de ativaÃ§Ã£o do banco de dados',0),(307221,8534,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ð¸ Ð‘Ð°Ð·Ñ‹ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(307222,8534,'es','Error Activando el Base de Datos',0),(307223,8534,'de','Fehler Datenbank aktivieren',0),(307224,8534,'en','Error Activating Database',0),(307225,8535,'is','',0),(307226,8535,'dr','Ø®Ø·Ø§ ÙŠ  Ù„ØºÙˆ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(307227,8535,'pr','Ø®Ø·Ø§ ÙŠ  Ù„ØºÙˆ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(307228,8535,'tr','Hata mÃ¼ÅŸteri iptal etme',0),(307229,8535,'pl','BÅ‚Ä…d klienta anulowanie',0),(307230,8535,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ñ‚Ð¼ÐµÐ½ÑÐ½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(307231,8535,'ur','Ù†Ù‚Øµ Ú©Ø³Ù¹Ù…Ø± Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(307232,8535,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÐºÑƒÐ¿Ñ†Ð°',0),(307233,8535,'vi','Há»§y khÃ¡ch hÃ ng bá»‹ lá»—i',0),(307234,8535,'af','Fout met Kansellasie van KliÃ«nt/Klant',0),(307235,8535,'ro','Eroare de anulare a clientului',0),(307236,8535,'et','Kliendi tÃ¼histamisel tekkis vga',0),(307237,8535,'si','Napaka preklic kupca',0),(307238,8535,'ba','Kesalahan membatalkan pelanggan',0),(307239,8535,'nl','Fout annuleren klant',0),(307240,8535,'fi','Peruuttaminen asiakkaan',0),(307241,8535,'no','Feil avbryte kunde',0),(307242,8535,'da','Fejl annullering af kunden',0),(307243,8535,'ko','ì˜¤ë¥˜ ì·¨ì†Œ ê³ ê°',0),(307244,8535,'he','×©×’×™××ª ×‘×™×˜×•×œ ×”×œ×§×•×—',0),(307245,8535,'el','Î£Ï†Î¬Î»Î¼Î± Î±ÎºÏÏÏ‰ÏƒÎ· Ï€ÎµÎ»Î¬Ï„Î·',0),(307246,8535,'zh','é”™è¯¯å–æ¶ˆå®¢æˆ·',0),(307247,8535,'sv','Fel avbryter kund',0),(307248,8535,'it','Errore annullando cliente',0),(307249,8535,'tl','',0),(307250,8535,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(307251,8535,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¦à¥à¤¦ à¤•à¤°à¤¨à¤¾',0),(307252,8535,'ms','Pelanggan membatalkan ralat',0),(307253,8535,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(307254,8535,'fr','Erreur annulation client',0),(307255,8535,'jp','ã‚¨ãƒ©ãƒ¼ã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã™ã‚‹é¡§å®¢',0),(307256,8535,'pt','Erro cancelando cliente',0),(307257,8535,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ñ‚Ð¼ÐµÐ½Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð¼',0),(307258,8535,'es','Error Cancelando Cliente',0),(307259,8535,'de','Fehler Abbrechen des Kunden',0),(307260,8535,'en','Error Canceling Customer',0),(307261,8536,'is','',0),(307262,8536,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ù…Ø³ÙŠØ±  Ø¢Ù¾Ù„ÙˆØ¯ Ù‡Ø§ÙŠ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(307263,8536,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ù…Ø³ÙŠØ±  Ø¢Ù¾Ù„ÙˆØ¯ Ù‡Ø§ÙŠ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ ',0),(307264,8536,'tr','Dizin eklerse B2B oluÅŸturulurken hata oluÅŸtu',0),(307265,8536,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas tworzenia B2B zaÅ‚aduje katalogu',0),(307266,8536,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° B2B ÐºÐ°Ñ‡ÐµÐ½Ð¸ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ñ',0),(307267,8536,'ur','ÚˆØ§Ø¦Ø±ÛŒÚ©Ù¹Ø±ÛŒ Ù†Ù‚Øµ B2B Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’ Ø§Ù¾Ù„ÙˆØ§Ø¯Ø³',0),(307268,8536,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ð‘2Ð‘ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ñ˜ÑƒÐ¼Ð°',0),(307269,8536,'vi','Lá»—i táº¡o niÃªn giÃ¡m B2B',0),(307270,8536,'af','Fout het ontstaan met Skepping van B2B Oorplasingsgids',0),(307271,8536,'ro','Eroare la crearea B2B Ã®ncarcÄƒ Director',0),(307272,8536,'et','Ei Ãµnnestu luua B2B lisatud kataloogi',0),(307273,8536,'si','Napaka pri ustvarjanju B2B Uploads imenik',0),(307274,8536,'ba','Error membuat B2B upload direktori',0),(307275,8536,'nl','Fout bij het maken van B2B Upload Directory',0),(307276,8536,'fi','Virhe luotaessa B2B Kuvat Directory',0),(307277,8536,'no','Feil under oppretting av B2B laster opp mappen',0),(307278,8536,'da','Fejl under oprettelse af B2B Uploads mappe',0),(307279,8536,'ko','B2Bë¥¼ ë§Œë“œëŠ” ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤ ì—…ë¡œë“œ ë””ë ‰í† ë¦¬',0),(307280,8536,'he','×©×’×™××” ×‘×™×¦×™×¨×ª B2B ×ž×¢×œ×” ×ž×“×¨×™×š',0),(307281,8536,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± B2B Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎµÏ‚ ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎžÎµÎ½Î¿Î´Î¿Ï‡ÎµÎ¯Î±',0),(307282,8536,'zh','é”™è¯¯å»ºç«‹çš„å•†ä¸šå¯¹å•†ä¸šä¸Šä¼ ç›®å½•',0),(307283,8536,'sv','Fel vid skapande av B2B uppladdningar katalog',0),(307284,8536,'it','Errore durante la creazione di B2B che carica Directory',0),(307285,8536,'tl','',0),(307286,8536,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3629;&#3633;&#3614;&#3650;&#3627;&#3621;&#3604;&#3652;&#3604;&#3648;&#3619;&#3655;&#3585;&#3607;&#3629;&#3619;&#3',0),(307287,8536,'hi','B2B à¤¬à¤¨à¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤ªà¤²à¥‹à¤¡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¤¿à¤•à¤¾',0),(307288,8536,'ms','Ralat ketika mencipta B2B gambar direktori',0),(307289,8536,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ B2B ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ø¯Ù„ÙŠÙ„',0),(307290,8536,'fr','Erreur de crÃ©ation du B2B postera de rÃ©pertoire',0),(307291,8536,'jp','B2B ã®ä½œæˆã‚¨ãƒ©ãƒ¼ ãƒ‡ã‚£ãƒ¬ã‚¯ãƒˆãƒªã‚’ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(307292,8536,'pt','Erro ao criar B2B que carregue o diretÃ³rio',0),(307293,8536,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ B2B Ð·Ð°Ð³Ñ€ÑƒÐ¶Ð°ÐµÑ‚ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³',0),(307294,8536,'es','Error Creando N2N Directorio de Subir Archivos',0),(307295,8536,'de','Fehler beim Erstellen des B2B-Verzeichnis Uploads',0),(307296,8536,'en','Error Creating B2B Uploads Directory',0),(307297,8537,'is','',0),(307298,8537,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯  Ù…Ø³ÙŠØ± Ø¢Ù¾Ù„ÙˆØ¯ Ù‡Ø§ ',0),(307299,8537,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯  Ù…Ø³ÙŠØ± Ø¢Ù¾Ù„ÙˆØ¯ Ù‡Ø§ ',0),(307300,8537,'tr','FotoÄŸraf dizin oluÅŸturma hatasÄ±',0),(307301,8537,'pl','BÅ‚Ä…d tworzenia katalogu Uploads',0),(307302,8537,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ ÐºÐ°Ñ‡ÐµÐ½Ð¸ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ñ',0),(307303,8537,'ur','Ù†Ù‚Øµ Ø¨Ù†Ø§Ù†Û’ Ø¨Ú‘Û’ ÚˆØ§Ø¦Ø±ÛŒÚ©Ù¹Ø±ÛŒ',0),(307304,8537,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ñ˜ÑƒÐ¼Ð°',0),(307305,8537,'vi','Lá»—i táº¡o táº£i niÃªn giÃ¡m',0),(307306,8537,'af','Fout het ontstaan met Skepping van Oorplasingsgids',0),(307307,8537,'ro','Crearea de eroare Ã®ncarcÄƒ Director',0),(307308,8537,'et','TÃµrge loomisel lisatud kataloogis',0),(307309,8537,'si','Napaka pri ustvarjanju Uploads imenik',0),(307310,8537,'ba','Kesalahan membuat upload direktori',0),(307311,8537,'nl','Fout maken Uploads Directory',0),(307312,8537,'fi','Virhe luotaessa Kuvat Directory',0),(307313,8537,'no','Feil Ã¥ lage sendinger adresseliste',0),(307314,8537,'da','Fejl ved oprettelse Uploads mappe',0),(307315,8537,'ko','ë””ë ‰í† ë¦¬ë¥¼ ì—…ë¡œë“œ ì˜¤ë¥˜ ë§Œë“¤ê¸°',0),(307316,8537,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×ž×¢×œ×” ×ž×“×¨×™×š',0),(307317,8537,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î± ÏƒÏ„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎµÏ‚ ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎžÎµÎ½Î¿Î´Î¿Ï‡ÎµÎ¯Î±',0),(307318,8537,'zh','é”™è¯¯åˆ›å»ºä¸Šä¼ ç›®å½•\r\n',0),(307319,8537,'sv','Fel att skapa Uploads katalog',0),(307320,8537,'it','Errore creazione cartella Uploads',0),(307321,8537,'tl','',0),(307322,8537,'th','Error Creating Uploads Directory',0),(307323,8537,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤…à¤ªà¤²à¥‹à¤¡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¤¿à¤•à¤¾',0),(307324,8537,'ms','Ralat mencipta gambar direktori',0),(307325,8537,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ù†Ø´Ø§Ø¡ ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ø¯Ù„ÙŠÙ„',0),(307326,8537,'fr','Erreur crÃ©ation rÃ©pertoire Uploads',0),(307327,8537,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ ãƒ‡ã‚£ãƒ¬ã‚¯ãƒˆãƒªã®ä½œæˆã‚¨ãƒ©ãƒ¼',0),(307328,8537,'pt','Erro criando diretÃ³rio Uploads',0),(307329,8537,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ Ð·Ð°Ð³Ñ€ÑƒÐ¶Ð°ÐµÑ‚ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³',0),(307330,8537,'es','Error Creando Directorio de subir archivos',0),(307331,8537,'de','Fehler beim Erstellen Uploads Verzeichnis',0),(307332,8537,'en','Error Creating Uploads Directory',0),(307333,8538,'is','',0),(307334,8538,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ù…ÙŠØ²Ø¨Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(307335,8538,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ù…ÙŠØ²Ø¨Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(307336,8538,'tr','BarÄ±ndÄ±rÄ±lan mÃ¼ÅŸteri baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(307337,8538,'pl','Gospodarzem klient pomyÅ›lnie zaktualizowana',0),(307338,8538,'bg','Ð”Ð¾Ð¼Ð°ÐºÐ¸Ð½ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(307339,8538,'ur','Ù…ÛŒØ²Ø¨Ø§Ù† Ú¯Ø§ÛÚ© Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(307340,8538,'sr','ÐˆÐ°Ð²Ð½Ð¸Ñ… ÐºÑƒÐ¿Ð°Ñ†Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(307341,8538,'vi','Cáº­p Nháº­t KhÃ¡ch hÃ ng chá»§ thÃ nh cÃ´ng',0),(307342,8538,'af','Gasheer Klant/KliÃ«nt suksesvol opdateer',0),(307343,8538,'ro','GÄƒzduit client actualizat cu succes',0),(307344,8538,'et','VÃ¤rskendatud majutatud kliendile',0),(307345,8538,'si','Gosti stranka uspeÅ¡no posodobljena',0),(307346,8538,'ba','Host Pelanggan yang berhasil',0),(307347,8538,'nl','Gehoste klant met succes bijgewerkt',0),(307348,8538,'fi','IsÃ¤nnÃ¶i asiakkaan pÃ¤ivitetty',0),(307349,8538,'no','Vertsbaserte kunden oppdatert',0),(307350,8538,'da','Hostede kunde opdateret',0),(307351,8538,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´ íŠ¸ í•˜ëŠ” í˜¸ìŠ¤íŒ…ëœ ê³ ê°',0),(307352,8538,'he','×œ×§×•×—×•×ª ×ž×ª××¨×— ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(307353,8538,'el','Î¦Î¹Î»Î¿Î¾ÎµÎ½ÎµÎ¯Ï„Î±Î¹ Ï€ÎµÎ»Î¬Ï„Î· ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(307354,8538,'zh','æ‰˜ç®¡å®¢æˆ·æˆåŠŸæ›´æ–°\r\n',0),(307355,8538,'sv','VÃ¤rd kunden uppdaterats',0),(307356,8538,'it','Cliente ospitato aggiornato con successo',0),(307357,8538,'tl','',0),(307358,8538,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3650;&#3630;&#3626;&#3605;&#3660;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(307359,8538,'hi','à¤¹à¥‹à¤¸à¥à¤Ÿà¥‡à¤¡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(307360,8538,'ms','Pelanggan dihoskan berjaya dikemas kini',0),(307361,8538,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ÙˆØ§Ø³ØªØ¶Ø§ÙØª Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(307362,8538,'fr','Client hÃ©bergÃ© correctement mis Ã  jour',0),(307363,8538,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸãƒ›ã‚¹ãƒˆã®é¡§å®¢',0),(307364,8538,'pt','Cliente hospedado atualizado com sucesso',0),(307365,8538,'ru','Ð Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð², ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(307366,8538,'es','Cliente Hospedado Actualizado Exitosamente',0),(307367,8538,'de','Gehostete Kunden erfolgreich aktualisiert',0),(307368,8538,'en','Hosted Customer Updated Successfully',0),(307369,8539,'is','',0),(307370,8539,'dr','Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(307371,8539,'pr','Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø¬Ø¯ÙŠØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(307372,8539,'tr','Yeni veritabanÄ± baÅŸarÄ±yla eklendi',0),(307373,8539,'pl','Nowa baza danych dodane pomyÅ›lnie',0),(307374,8539,'bg','ÐÐ¾Ð²Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(307375,8539,'ur','Ù†ÛŒØ§ Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(307376,8539,'sr','ÐÐ¾Ð²Ð° Ð±Ð°Ð·Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(307377,8539,'vi','Dá»¯ liá»‡u má»›i thÃªm vÃ o thÃ nh cÃ´ng',0),(307378,8539,'af','Nuwe Databasis Suksesvol Bygevoeg',0),(307379,8539,'ro','BazÄƒ de date nouÄƒ adÄƒugat cu succes',0),(307380,8539,'et','Uus andmebaas lisati edukalt',0),(307381,8539,'si','Novo zbirko podatkov dodani',0),(307382,8539,'ba','Database baru ditambahkan berhasil',0),(307383,8539,'nl','nieuwe database successvol toegevoegd',0),(307384,8539,'fi','Uuden tietokannan lisÃ¤Ã¤minen onnistui',0),(307385,8539,'no','Ny Database lagt',0),(307386,8539,'da','Ny Database tilfÃ¸jet',0),(307387,8539,'ko','ìƒˆ ë°ì´í„°ë² ì´ìŠ¤ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(307388,8539,'he','×ž×¡×“ × ×ª×•× ×™× ×—×“×© × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(307389,8539,'el','ÎÎ­Î± Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(307390,8539,'zh','æ–°çš„æ•°æ®åº“æ·»åŠ æˆåŠŸ\r\n',0),(307391,8539,'sv','Ny databas lagts',0),(307392,8539,'it','Nuovo Database aggiunto con successo',0),(307393,8539,'tl','',0),(307394,8539,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3627;&#3617;&#3656;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(307395,8539,'hi','à¤¨à¤ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(307396,8539,'ms','Pangkalan data baru yang berjaya menambah',0),(307397,8539,'ar','ØªÙ…Øª Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(307398,8539,'fr','Nouvelle base de donnÃ©es ajoutÃ© avec succÃ¨s',0),(307399,8539,'jp','æ–°ã—ã„ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚’æ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(307400,8539,'pt','Novo banco de dados adicionado com sucesso',0),(307401,8539,'ru','ÐÐ¾Ð²Ð°Ñ Ð‘Ð°Ð·Ð° Ð”Ð°Ð½Ð½Ñ‹Ñ… Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(307402,8539,'es','Nueva Base de Datos Agregado Exitosamente',0),(307403,8539,'de','Neue Datenbank erfolgreich hinzugefÃ¼gt',0),(307404,8539,'en','New Database Added Successfully',0),(307405,8540,'is','',0),(307406,8540,'dr','NolaPro Ù…Ø¯ÙŠØ± Ù…ÙŠØ²Ø¨Ø§Ù† ',0),(307407,8540,'pr','NolaPro Ù…Ø¯ÙŠØ± Ù…ÙŠØ²Ø¨Ø§Ù† ',0),(307408,8540,'tr','BarÄ±ndÄ±rma yÃ¶neticisi',0),(307409,8540,'pl','Hosting Manager',0),(307410,8540,'bg','Ð¥Ð¾ÑÑ‚Ð¸Ð½Ð³ Ð¼ÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€',0),(307411,8540,'ur','Ù…ÛŒØ²Ø¨Ø§Ù† Ù…ÛŒÙ†ÛŒØ¬Ø±',0),(307412,8540,'sr','Ð¥Ð¾ÑÑ‚Ð¸Ð½Ð³ ÐœÐµÐ½Ð°ÑŸÐµÑ€',0),(307413,8540,'vi','Quáº£n LÃ½ Hosting NolaPro ',0),(307414,8540,'af','NolaPro Gasheer Bestuurder',0),(307415,8540,'ro','Manager gÄƒzduire',0),(307416,8540,'et','Hosting Manager',0),(307417,8540,'si','Gostovanje Manager',0),(307418,8540,'ba','Manajer hosting',0),(307419,8540,'nl','Hosting Manager',0),(307420,8540,'fi','Hosting johtaja',0),(307421,8540,'no','Hosting Manager',0),(307422,8540,'da','Hosting Manager',0),(307423,8540,'ko','í˜¸ìŠ¤íŒ… ê´€ë¦¬ìž',0),(307424,8540,'he','××™×¨×•×— ×ž× ×”×œ',0),(307425,8540,'el','Î¦Î¹Î»Î¿Î¾ÎµÎ½Î¯Î± Î´Î¹ÎµÏ…Î¸Ï…Î½Ï„Î®Ï‚',0),(307426,8540,'zh','ä¸»æœºç®¡ç†\r\n',0),(307427,8540,'sv','Hosting Manager',0),(307428,8540,'it','Hosting Manager',0),(307429,8540,'tl','',0),(307430,8540,'th','&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619; NolaPro Hosting',0),(307431,8540,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤• à¤•à¥€ à¤®à¥‡à¤œà¤¬à¤¾à¤¨à¥€',0),(307432,8540,'ms','Hosting Pengurus',0),(307433,8540,'ar','Ù…Ø¯ÙŠØ± Ø§Ù„Ø§Ø³ØªØ¶Ø§ÙØ©',0),(307434,8540,'fr','Gestionnaire d\'hÃ©bergement',0),(307435,8540,'jp','ãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼ã®ãƒ›ã‚¹ãƒˆ',0),(307436,8540,'pt','Gerente de hospedagem',0),(307437,8540,'ru','Ð¥Ð¾ÑÑ‚Ð¸Ð½Ð³ ÐœÐµÐ½ÐµÐ´Ð¶ÐµÑ€ NolaPro',0),(307438,8540,'es','NolaPro Supervisor de Hospedaje',0),(307439,8540,'de','Hosting Manager',0),(307440,8540,'en','Hosting Manager',0),(307441,8541,'is','',0),(307442,8541,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÙŠØ§Ù„ â€“ Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ùˆ Ù†Ø§Ù… Ø¯Ø§Ù…Ù†Ù‡ Ø¨Ø§ÙŠØ¯ Ø¬ÙˆØ§Ø¨ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(307443,8541,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÙŠØ§Ù„ â€“ Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ùˆ Ù†Ø§Ù… Ø¯Ø§Ù…Ù†Ù‡ Ø¨Ø§ÙŠØ¯ Ø¬ÙˆØ§Ø¨ Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(307444,8541,'tr','Seri numarasÄ±, veritabanÄ± adÄ± & etki alanÄ± adÄ± doldurulmalÄ±dÄ±r',0),(307445,8541,'pl','Numer seryjny, nazwa bazy danych & nazwa domeny muszÄ… byÄ‡ wypeÅ‚nione',0),(307446,8541,'bg','Ð¡ÐµÑ€Ð¸ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€, Ð¸Ð¼Ðµ Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ & Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ð´Ð¾Ð¼ÐµÐ¹Ð½Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ð¾Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸',0),(307447,8541,'ur','Ø³ÛŒØ±ÛŒÙ„ Ù†Ù…Ø¨Ø±ØŒ Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù†Ø§Ù… & ÚˆÙˆÙ…ÛŒÙ† Ù†Ø§Ù… Ø¨Ú¾Ø±Ø§ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(307448,8541,'sr','Ð ÐµÐ´Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜, Ð¸Ð¼Ðµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¸ Ð¸Ð¼Ðµ Ð´Ð¾Ð¼ÐµÐ½Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾Ð¿ÑƒÑšÐµÐ½Ð°',0),(307449,8541,'vi','Pháº£i Ä‘iá»n sá»‘ thá»© tá»±, tÃªn dá»¯ liá»‡u & tÃªn miá»n',0),(307450,8541,'af','Serienommer, Databasisnaam & Domeinnaam Moet Ingevul word',0),(307451,8541,'ro','NumÄƒrul de serie, numele bazei de date & nume de domeniu trebuie sÄƒ fie completat',0),(307452,8541,'et','Seerianumber, andmebaasinimi & domeeninime peavad olema tÃ¤idetud',0),(307453,8541,'si','Serijska Å¡tevilka, ime zbirke podatkov & ime domene obvezno izpolnite',0),(307454,8541,'ba','Nomor seri, nama Database & nama Domain harus diisi',0),(307455,8541,'nl','Serienummer, databasenaam & domeinnaam moeten worden ingevuld',0),(307456,8541,'fi','Sarjanumero, tietokannan nimi & verkkotunnuksen nimi on tÃ¤ytettÃ¤vÃ¤',0),(307457,8541,'no','Serienummer, databasenavn & domenenavn mÃ¥ fylles ut',0),(307458,8541,'da','Serienummer, databasenavn & domÃ¦nenavn skal vÃ¦re udfyldt',0),(307459,8541,'ko','ì¼ë ¨ ë²ˆí˜¸, ë°ì´í„°ë² ì´ìŠ¤ ì´ë¦„ & ë„ë©”ì¸ ì´ë¦„ì„ ê¸°ìž…í•´ ì•¼',0),(307460,8541,'he','×”×ž×¡×¤×¨ ×”×¡×™×“×•×¨×™, ×©× ×ž×¡×“ × ×ª×•× ×™× & ×©× ×ª×—×•× ×‘×ž×™×œ×•×™',0),(307461,8541,'el','Î‘ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ, Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ & ÏŒÎ½Î¿Î¼Î± Ï„Î¿Î¼Î­Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÏƒÏ…Î¼Ï€Î»Î·ÏÏ‰Î¸Î¿ÏÎ½',0),(307462,8541,'zh','åºåˆ—å·ï¼Œæ•°æ®åº“åç§°å’ŒåŸŸåå¿…é¡»å¡«å†™\r\n',0),(307463,8541,'sv','Serienummer, databasnamn & domÃ¤nnamn mÃ¥ste fyllas i',0),(307464,8541,'it','Numero di serie, nome Database & nome di dominio deve essere compilati',0),(307465,8541,'tl','',0),(307466,8541,'th','Serial Number, Database Name & Domain Name Must Be Filled Out',0),(307467,8541,'hi','à¤¸à¥€à¤°à¤¿à¤¯à¤² à¤¨à¤‚à¤¬à¤°, à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¨à¤¾à¤® & à¤¡à¥‹à¤®à¥‡à¤¨ à¤¨à¤¾à¤® à¤­à¤°à¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(307468,8541,'ms','Nombor siri, nama pangkalan data & Nama Domain mesti diisi',0),(307469,8541,'ar','ÙŠØ¬Ø¨ Ù…Ù„Ø¡ Ø§Ù„Ø±Ù‚Ù… Ø§Ù„ØªØ³Ù„Ø³Ù„ÙŠØŒ ÙˆØ§Ø³Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ÙˆØ§Ø³Ù… Ø§Ù„Ù†Ø¸Ø§Ù‚',0),(307470,8541,'fr','NumÃ©ro de sÃ©rie, nom de base de donnÃ©es & nom de domaine doivent Ãªtre remplis',0),(307471,8541,'jp','ã‚·ãƒªã‚¢ãƒ«ç•ªå·ã€ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹å & ãƒ‰ãƒ¡ã‚¤ãƒ³åãŒè¨˜å…¥ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(307472,8541,'pt','NÃºmero de sÃ©rie, nome do banco de dados & nome de domÃ­nio devem ser preenchidos',0),(307473,8541,'ru','Ð¡ÐµÑ€Ð¸Ð¹Ð½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€, Ð¸Ð¼Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… & Ð¸Ð¼Ñ Ð´Ð¾Ð¼ÐµÐ½Ð° Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ Ð·Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ñ‹',0),(307474,8541,'es','NÃºmero de Serie, Nombre de Base de Datos y Nombre de Dominio deben ser Llenados',0),(307475,8541,'de','Seriennummer, Datenbankname & Domain-Namen mÃ¼ssen ausgefÃ¼llt werden',0),(307476,8541,'en','Serial Number, Database Name & Domain Name Must Be Filled Out',0),(307477,8542,'is','',0),(307478,8542,'dr','Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ÙƒØ§Ø±Ø§ÙƒØªØ±Ù‡Ø§ÙŠ Ø®Ø§ØµÙŠ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯',0),(307479,8542,'pr','Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ÙƒØ§Ø±Ø§ÙƒØªØ±Ù‡Ø§ÙŠ Ø®Ø§ØµÙŠ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯',0),(307480,8542,'tr','VeritabanÄ± adÄ± Ã¶zel karakterler iÃ§eremez.',0),(307481,8542,'pl','Nazwa bazy danych nie moÅ¼e zawieraÄ‡ znakÃ³w specjalnych.',0),(307482,8542,'bg','Ð˜Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÑŠÐ´ÑŠÑ€Ð¶Ð° ÑÐ¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ð·Ð½Ð°Ñ†Ð¸.',0),(307483,8542,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ú©Û’ Ù†Ø§Ù… Ø®ØµÙˆØµÛŒ Ú©Ø±ÛŒÚ©Ù¹Ø± Ú©Ø§ Ø­Ø§Ù…Ù„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§ Û”',0),(307484,8542,'sr','Ð˜Ð¼Ðµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐ°Ð´Ñ€Ð¶Ð¸ ÑÐ¿ÐµÑ†Ð¸Ñ˜Ð°Ð»Ð½Ðµ Ð·Ð½Ð°ÐºÐ¾Ð²Ðµ.',0),(307485,8542,'vi','TÃªn dá»¯ liá»‡u khÃ´ng thá»ƒ cÃ³ kÃ½ tá»± Ä‘áº·c biá»‡t',0),(307486,8542,'af','Die databasisnaam kan nie bestaan uit spesiale karakters',0),(307487,8542,'ro','Numele bazei de date nu poate conÈ›ine caractere speciale.',0),(307488,8542,'et','Andmebaasi nimi ei tohi sisaldada erilisi mÃ¤rke',0),(307489,8542,'si','Ime zbirke podatkov ne sme vsebovati posebnih znakov.',0),(307490,8542,'ba','Nama database tidak boleh berisi karakter khusus.',0),(307491,8542,'nl','De naam van de database mag geen speciale tekens bevatten.',0),(307492,8542,'fi','Tietokannan nimi ei voi sisÃ¤ltÃ¤Ã¤ erikoismerkkejÃ¤.',0),(307493,8542,'no','Databasenavnet kan ikke inneholde spesialtegn.',0),(307494,8542,'da','Databasenavnet mÃ¥ ikke indeholde specialtegn.',0),(307495,8542,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì´ë¦„ íŠ¹ìˆ˜ ë¬¸ìžë¥¼ í¬í•¨í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(307496,8542,'he','×©× ×ž×¡×“ ×”× ×ª×•× ×™× ××™×Ÿ ××¤×©×¨×•×ª ×œ×”×›×™×œ ×ª×•×•×™× ×ž×™×•×—×“×™×.',0),(307497,8542,'el','Î¤Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï€ÎµÏÎ¹Î­Ï‡ÎµÎ¹ ÎµÎ¹Î´Î¹ÎºÎ¿ÏÏ‚ Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÎµÏ‚.',0),(307498,8542,'zh','æ•°æ®åº“åç§°ä¸èƒ½åŒ…å«ç‰¹æ®Šå­—ç¬¦ã€‚\r\n',0),(307499,8542,'sv','Databasnamnet fÃ¥r inte innehÃ¥lla specialtecken.',0),(307500,8542,'it','Il nome del database non puÃ² contenere caratteri speciali.',0),(307501,8542,'tl','',0),(307502,8542,'th','&#3594;&#3639;&#3656;&#3629;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3627;&#3657;&#3634;&#3617;&#3617;&#3637;&#3605;&#3633;&#3623;&#3629;&#3633;&#3585;&#3586;&#3619;&#3632;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(307503,8542,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¤¾ à¤¨à¤¾à¤® à¤µà¤¿à¤¶à¥‡à¤· à¤µà¤°à¥à¤£ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¥‡à¥¤',0),(307504,8542,'ms','Nama pangkalan data tidak boleh mengandungi aksara khas.',0),(307505,8542,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ù„Ø§Ø³Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø£Ù† ÙŠØ­ÙˆÙŠ Ø­Ø±ÙˆÙØ§Ù‹ Ø®Ø§ØµØ©.',0),(307506,8542,'fr','Le nom de la base de donnÃ©es ne peut pas contenir de caractÃ¨res spÃ©ciaux.',0),(307507,8542,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹åã¯ã€ç‰¹æ®Šæ–‡å­—ã‚’å«ã‚ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(307508,8542,'pt','O nome do banco de dados nÃ£o pode conter caracteres especiais.',0),(307509,8542,'ru','Ð˜Ð¼Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ ÑÐ¾Ð´ÐµÑ€Ð¶Ð°Ñ‚ÑŒ ÑÐ¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ ÑÐ¸Ð¼Ð²Ð¾Ð»Ñ‹.',0),(307510,8542,'es','El nombre de base de datos no se puede contener carÃ¡cteres especiales',0),(307511,8542,'de','Der Datenbankname darf keine Sonderzeichen enthalten.',0),(307512,8542,'en','The database name cannot contain special characters.',0),(307513,8543,'is','',0),(307514,8543,'dr','Ø§ÙŠÙ† Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(307515,8543,'pr','Ø§ÙŠÙ† Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(307516,8543,'tr','Bu veritabanÄ± adÄ± zaten var.',0),(307517,8543,'pl','Nazwa bazy danych juÅ¼ istnieje.',0),(307518,8543,'bg','Ð¢Ð¾Ð²Ð° Ð¸Ð¼Ðµ Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°.',0),(307519,8543,'ur','Ø§Ø³ Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù†Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Û”',0),(307520,8543,'sr','ÐžÐ²Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼ Ñƒ Ð±Ð°Ð·Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(307521,8543,'vi','TÃªn dá»¯ liá»‡u nÃ y Ä‘Ã£ tá»“n táº¡i',0),(307522,8543,'af','Hierdie databasisnaam bestaan alreeds.',0),(307523,8543,'ro','AceastÄƒ bazÄƒ de date nume existÄƒ deja.',0),(307524,8543,'et','Selline andmebaasi nimi on juba olemas',0),(307525,8543,'si','To ime zbirke podatkov Å¾e obstaja.',0),(307526,8543,'ba','Nama database ini sudah ada.',0),(307527,8543,'nl','Deze databasenaam bestaat al.',0),(307528,8543,'fi','Tietokannan nimi on jo kÃ¤ytÃ¶ssÃ¤.',0),(307529,8543,'no','Dette navnet finnes allerede.',0),(307530,8543,'da','Denne databasenavn findes allerede.',0),(307531,8543,'ko','ì´ ë°ì´í„°ë² ì´ìŠ¤ ì´ë¦„ì€ ì´ë¯¸ ì¡´ìž¬í•©ë‹ˆë‹¤.',0),(307532,8543,'he','×©× ×ž×¡×“ ×”× ×ª×•× ×™× ×–×” ×›×‘×¨ ×§×™×™×.',0),(307533,8543,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½, Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·.',0),(307534,8543,'zh','è¿™ä¸ªæ•°æ®åº“åç§°å·²ç»å­˜åœ¨ã€‚\r\n',0),(307535,8543,'sv','Denna databasnamnet finns redan.',0),(307536,8543,'it','Questo nome database esiste giÃ .',0),(307537,8543,'tl','',0),(307538,8543,'th','&#3594;&#3639;&#3656;&#3629;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3609;&#3637;&#3657;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;',0),(307539,8543,'hi','à¤‡à¤¸ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¤¾ à¤¨à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆà¥¤',0),(307540,8543,'ms','Nama pangkalan data ini telah wujud.',0),(307541,8543,'ar','Ø¥Ø³Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ù‡Ø°Ø§ Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹.',0),(307542,8543,'fr','Ce nom de base de donnÃ©es existe dÃ©jÃ .',0),(307543,8543,'jp','ã“ã®ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹åã¯æ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(307544,8543,'pt','Este nome de banco de dados jÃ¡ existe.',0),(307545,8543,'ru','Ð¢Ð°ÐºÐ¾Ðµ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… ÑƒÐ¶Ðµ ÐµÑÑ‚ÑŒ.',0),(307546,8543,'es','Este base de datos ya existe',0),(307547,8543,'de','Dieser Name der Datenbank ist bereits vorhanden.',0),(307548,8543,'en','This database name already exists.',0),(307549,8544,'is','',0),(307550,8544,'dr','Ù†Ø§Ù… Ù…ÙŠØ§Ù†ÙŠ',0),(307551,8544,'pr','Ù†Ø§Ù… Ù…ÙŠØ§Ù†ÙŠ',0),(307552,8544,'tr','Ä°kinci ad',0),(307553,8544,'pl','Drugie imiÄ™',0),(307554,8544,'bg','Ð‘Ð°Ñ‰Ð¸Ð½Ð¾ Ð¸Ð¼Ðµ',0),(307555,8544,'ur','Ø¯Ø±Ù…ÛŒØ§Ù†ÛŒ Ù†Ø§Ù…',0),(307556,8544,'sr','Ð¡Ñ€ÐµÐ´ÑšÐµ Ð¸Ð¼Ðµ',0),(307557,8544,'vi','TÃªn Ä‘á»‡m',0),(307558,8544,'af','Tweede Naam',0),(307559,8544,'ro','Prenume',0),(307560,8544,'et','Teine eesnimi',0),(307561,8544,'si','Srednje ime',0),(307562,8544,'ba','Nama tengah',0),(307563,8544,'nl','Middelste naam',0),(307564,8544,'fi','Toinen nimi',0),(307565,8544,'no','Mellomnavn',0),(307566,8544,'da','Mellemnavn',0),(307567,8544,'ko','ì¤‘ê°„ ì´ë¦„',0),(307568,8544,'he','×©× ××ž×¦×¢×™',0),(307569,8544,'el','Î Î±Ï„ÏÏŽÎ½Ï…Î¼Î¿',0),(307570,8544,'zh','ä¸­é—´åå­—\r\n',0),(307571,8544,'sv','Mellannamn',0),(307572,8544,'it','Secondo nome',0),(307573,8544,'tl','',0),(307574,8544,'th','&#3594;&#3639;&#3656;&#3629;&#3585;&#3621;&#3634;&#3591;',0),(307575,8544,'hi','à¤®à¤§à¥à¤¯ à¤¨à¤¾à¤®',0),(307576,8544,'ms','Nama tengah',0),(307577,8544,'ar','Ø¥Ø³Ù… Ø§Ù„Ø£Ø¨',0),(307578,8544,'fr','DeuxiÃ¨me prÃ©nom',0),(307579,8544,'jp','ãƒŸãƒ‰ãƒ« ãƒãƒ¼ãƒ ',0),(307580,8544,'pt','Nome do meio',0),(307581,8544,'ru','ÐžÑ‚Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(307582,8544,'es','Segundo Nombre',0),(307583,8544,'de','Zweiter Vorname',0),(307584,8544,'en','Middle Name',0),(307585,8545,'is','',0),(307586,8545,'dr','Ø³Ù„Ø§Ù… Ø§ÙˆÙ„ Ù†Ø§Ù…Ù‡',0),(307587,8545,'pr','Ø³Ù„Ø§Ù… Ø§ÙˆÙ„ Ù†Ø§Ù…Ù‡',0),(307588,8545,'tr','Selamlama',0),(307589,8545,'pl','Zwrot grzecznoÅ›ciowy',0),(307590,8545,'bg','ÐŸÐ¾Ð·Ð´Ñ€Ð°Ð²',0),(307591,8545,'ur','Ø¢Ø¯Ø§Ø¨',0),(307592,8545,'sr','ÐžÑÐ»Ð¾Ð²Ñ™Ð°Ð²Ð°ÑšÐµ',0),(307593,8545,'vi','Xin chÃ o',0),(307594,8545,'af','Aanspreekvorm',0),(307595,8545,'ro','Formula de adresare',0),(307596,8545,'et','Hr/pr/prl jne',0),(307597,8545,'si','Uvodni pozdrav',0),(307598,8545,'ba','Salam',0),(307599,8545,'nl','Aanhef',0),(307600,8545,'fi','Tervehdys',0),(307601,8545,'no','Hilsen',0),(307602,8545,'da','Hilsen',0),(307603,8545,'ko','ì¸ì‚¬ë§',0),(307604,8545,'he','×›×™× ×•×™',0),(307605,8545,'el','Î§Î±Î¹ÏÎµÏ„Î¹ÏƒÎ¼ÏŒÏ‚',0),(307606,8545,'zh','ç§°å‘¼è¯­\r\n',0),(307607,8545,'sv','HÃ¤lsningsfras',0),(307608,8545,'it','Saluto al',0),(307609,8545,'tl','',0),(307610,8545,'th','&#3607;&#3633;&#3585;&#3607;&#3634;&#3618;',0),(307611,8545,'hi','à¤…à¤­à¤¿à¤µà¤¾à¤¦à¤¨',0),(307612,8545,'ms','Berkat',0),(307613,8545,'ar','Ø§Ù„Ø¥Ø³ØªÙ‡Ù„Ø§Ù„ / Ø§Ù„ØªØ­ÙŠØ©',0),(307614,8545,'fr','Formule de politesse',0),(307615,8545,'jp','ã‚ã„ã•ã¤æ–‡',0),(307616,8545,'pt','SaudaÃ§Ã£o',0),(307617,8545,'ru','ÐŸÑ€Ð¸Ð²ÐµÑ‚ÑÑ‚Ð²Ð¸Ðµ',0),(307618,8545,'es','SalutaciÃ³n',0),(307619,8545,'de','Anrede',0),(307620,8545,'en','Salutation',0),(307621,8546,'is','',0),(307622,8546,'dr','Ù¾Ø³ÙˆÙ†Ø¯',0),(307623,8546,'pr','Ù¾Ø³ÙˆÙ†Ø¯',0),(307624,8546,'tr','Sonek',0),(307625,8546,'pl','Przyrostek',0),(307626,8546,'bg','Ð¡ÑƒÑ„Ð¸ÐºÑ',0),(307627,8546,'ur','Ù„Ø§Ø­Ù‚Û',0),(307628,8546,'sr','Ð¡ÑƒÑ„Ð¸ÐºÑ',0),(307629,8546,'vi','Tiáº¿p Ä‘áº§u ngá»¯',0),(307630,8546,'af','Agtervoegsel',0),(307631,8546,'ro','Sufix',0),(307632,8546,'et','Sufiks',0),(307633,8546,'si','Pripona',0),(307634,8546,'ba','Akhiran',0),(307635,8546,'nl','Achtervoegsel',0),(307636,8546,'fi','PÃ¤Ã¤te',0),(307637,8546,'no','Suffiks',0),(307638,8546,'da','Suffiks',0),(307639,8546,'ko','ì ‘ë¯¸ì‚¬',0),(307640,8546,'he','×¡×™×•×ž×ª',0),(307641,8546,'el','Î•Ï€Î¯Î¸Î·Î¼Î±',0),(307642,8546,'zh','åŽç¼€\r\n',0),(307643,8546,'sv','Suffix',0),(307644,8546,'it','Suffisso',0),(307645,8546,'tl','',0),(307646,8546,'th','&#3588;&#3635;&#3648;&#3626;&#3619;&#3636;&#3617;&#3607;&#3657;&#3634;&#3618;',0),(307647,8546,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤¯',0),(307648,8546,'ms','Akhiran',0),(307649,8546,'ar','\"Ø§Ù„Ù„ÙˆØ§Ø­Ù‚\"',0),(307650,8546,'fr','Suffixe',0),(307651,8546,'jp','ã‚µãƒ•ã‚£ãƒƒã‚¯ã‚¹',0),(307652,8546,'pt','Sufixo',0),(307653,8546,'ru','Ð¡ÑƒÑ„Ñ„Ð¸ÐºÑ',0),(307654,8546,'es','Sufijo',0),(307655,8546,'de','Suffix',0),(307656,8546,'en','Suffix',0),(307657,8547,'is','',0),(307658,8547,'dr','Ø­Ø³Ø§Ø¨ Ø§ØµÙ„Ø§Ø­ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(307659,8547,'pr','Ø­Ø³Ø§Ø¨ Ø§ØµÙ„Ø§Ø­ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(307660,8547,'tr','Stok ayarlama hesabÄ± GL',0),(307661,8547,'pl','Konto GL korekty zapasÃ³w',0),(307662,8547,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð½Ð° GL Ð·Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°',0),(307663,8547,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(307664,8547,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð“Ð› ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(307665,8547,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Thay Äá»•i HÃ ng HÃ³a',0),(307666,8547,'af','Voorraad Aansuiwerings AG Rekening',0),(307667,8547,'ro','Inventarul de ajustare GL cont',0),(307668,8547,'et','Lao GL konto korrigeerimine',0),(307669,8547,'si','Konto zaloge prilagoditev GL',0),(307670,8547,'ba','Persediaan penyesuaian GL Account',0),(307671,8547,'nl','Aanpassing GL voorraadrekening',0),(307672,8547,'fi','Varaston GL muutostili',0),(307673,8547,'no','Lagerkontoen justering GL',0),(307674,8547,'da','GL Lagerreguleringskonto',0),(307675,8547,'ko','ìž¬ê³  ì¡°ì • GL ê³„ì •',0),(307676,8547,'he','×ž×œ××™ ×”×ª××ž×ª GL ×—×©×‘×•×Ÿ',0),(307677,8547,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(307678,8547,'zh','åº“å­˜è°ƒæ•´æ€»å¸å¸æˆ·\r\n',0),(307679,8547,'sv','GL fÃ¶r lagerjustering',0),(307680,8547,'it','Inventario regolazione GL Account',0),(307681,8547,'tl','',0),(307682,8547,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3',0),(307683,8547,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ GL à¤–à¤¾à¤¤à¥‡',0),(307684,8547,'ms','Akaun GL Pelarasan Inventori',0),(307685,8547,'ar','Ø­Ø³Ø§Ø¨ GL ØªØ³ÙˆÙŠØ© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(307686,8547,'fr','L\'inventaire compte GL d\'ajustement',0),(307687,8547,'jp','åœ¨åº«èª¿æ•´ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(307688,8547,'pt','Conta de GL de ajuste de estoque',0),(307689,8547,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ GL ÑÑ‡ÐµÑ‚Ð°',0),(307690,8547,'es','Ajuste de Cuenta LM de Inventario',0),(307691,8547,'de','GL Lagerkorrekturkonto',0),(307692,8547,'en','Inventory Adjustment GL&nbsp;Account',0),(307693,8548,'is','',0),(307694,8548,'dr','Ù¾Ø³ÙˆÙ†Ø¯ Ù†Ø§Ù… ',0),(307695,8548,'pr','Ù¾Ø³ÙˆÙ†Ø¯ Ù†Ø§Ù… ',0),(307696,8548,'tr','Ad soneki',0),(307697,8548,'pl','Sufiks nazwy',0),(307698,8548,'bg','Ð¡ÑƒÑ„Ð¸ÐºÑ Ð½Ð° Ð¸Ð¼Ðµ',0),(307699,8548,'ur','Ù†Ø§Ù… Ú©Ø§ Ù„Ø§Ø­Ù‚Û',0),(307700,8548,'sr','Ð¡ÑƒÑ„Ð¸ÐºÑ Ð·Ð° Ð¸Ð¼Ðµ',0),(307701,8548,'vi','Tiáº¿p Ä‘áº§u ngá»¯ tÃªn',0),(307702,8548,'af','Naam suffiks',0),(307703,8548,'ro','Sufix nume',0),(307704,8548,'et','Nime liide',0),(307705,8548,'si','Ime pripona',0),(307706,8548,'ba','Akhiran nama',0),(307707,8548,'nl','Naamachtervoegsel',0),(307708,8548,'fi','Nimen liite',0),(307709,8548,'no','Suffikset',0),(307710,8548,'da','Navnesuffiks',0),(307711,8548,'ko','ì´ë¦„ ì ‘ë¯¸ì‚¬',0),(307712,8548,'he','×¡×™×•×ž×ª ×œ×©×',0),(307713,8548,'el','Î¤Î¿ ÎµÏ€Î¯Î¸Î·Î¼Î± Î¿Î½ÏŒÎ¼Î±Ï„Î¿Ï‚',0),(307714,8548,'zh','åŽç¼€å\r\n',0),(307715,8548,'sv','Namnsuffix',0),(307716,8548,'it','Suffisso del nome',0),(307717,8548,'tl','',0),(307718,8548,'th','&#3626;&#3656;&#3623;&#3609;&#3605;&#3656;&#3629;&#3607;&#3657;&#3634;&#3618;&#3594;&#3639;&#3656;&#3629;',0),(307719,8548,'hi','à¤¨à¤¾à¤® à¤ªà¥à¤°à¤¤à¥à¤¯à¤¯',0),(307720,8548,'ms','Akhiran nama',0),(307721,8548,'ar','Ù„ÙˆØ§Ø­Ù‚\" Ø§Ù„Ø¥Ø³Ù…\"',0),(307722,8548,'fr','Suffixe de nom',0),(307723,8548,'jp','åå‰ã‚µãƒ•ã‚£ãƒƒã‚¯ã‚¹',0),(307724,8548,'pt','Sufixo de nome',0),(307725,8548,'ru','Ð¡ÑƒÑ„Ñ„Ð¸ÐºÑ Ð¸Ð¼ÐµÐ½Ð¸',0),(307726,8548,'es','Nombre Sufijo',0),(307727,8548,'de','Namensuffix',0),(307728,8548,'en','Name Suffix',0),(307729,8549,'is','',0),(307730,8549,'dr','Ø§ÙØ²ÙˆØ¯Ù†  ÙŠØ§ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(307731,8549,'pr','Ø§ÙØ²ÙˆØ¯Ù†  ÙŠØ§ ÙˆÙŠØ±Ø§ÙŠØ´ ',0),(307732,8549,'tr','Ekleme veya dÃ¼zenleme',0),(307733,8549,'pl','Dodaj lub Edytuj',0),(307734,8549,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¸Ð»Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð°',0),(307735,8549,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº ÛŒØ§ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(307736,8549,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¸Ð»Ð¸ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(307737,8549,'vi','ThÃªm Hay Sá»­a',0),(307738,8549,'af','Byvoeg of Redigeer ',0),(307739,8549,'ro','AdÄƒugaÅ£i sau editaÅ£i',0),(307740,8549,'et','Lisa vÃµi muuda',0),(307741,8549,'si','Dodajanje ali urejanje',0),(307742,8549,'ba','Menambah atau mengedit',0),(307743,8549,'nl','Toevoegen of bewerken',0),(307744,8549,'fi','LisÃ¤Ã¤minen tai muokkaaminen',0),(307745,8549,'no','Legge til eller redigere',0),(307746,8549,'da','TilfÃ¸je eller redigere',0),(307747,8549,'ko','ì¶”ê°€ ë˜ëŠ” íŽ¸ì§‘',0),(307748,8549,'he','×”×•×¡×¤×” ××• ×¢×¨×™×›×”',0),(307749,8549,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î® ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(307750,8549,'zh','å¢žåŠ æˆ–ç¼–è¾‘\r\n',0),(307751,8549,'sv','LÃ¤gga till eller redigera',0),(307752,8549,'it','Aggiungere o modificare',0),(307753,8549,'tl','',0),(307754,8549,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3619;&#3639;&#3629;&#3649;&#3585;&#3657;&#3652;&#3586;',0),(307755,8549,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤¯à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(307756,8549,'ms','Menambah atau mengubah',0),(307757,8549,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ùˆ ØªØ­Ø±ÙŠØ±',0),(307758,8549,'fr','Ajouter ou modifier',0),(307759,8549,'jp','è¿½åŠ ã¾ãŸã¯ç·¨é›†',0),(307760,8549,'pt','Adicionar ou editar',0),(307761,8549,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¸Ð»Ð¸ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(307762,8549,'es','Agregar o Editar',0),(307763,8549,'de','HinzufÃ¼gen oder bearbeiten',0),(307764,8549,'en','Add or Edit',0),(307765,8550,'is','',0),(307766,8550,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ù…ÙˆØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(307767,8550,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ù…ÙˆØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(307768,8550,'tr','Yeni grafik ekleme',0),(307769,8550,'pl','Dodaj nowÄ… szatÄ™ graficznÄ…',0),(307770,8550,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(307771,8550,'ur','Ù†Ø¦Û’ Ú¯Ø±Ø§ÙÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(307772,8550,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð³Ñ€Ð°Ñ„Ð¸ÐºÑƒ',0),(307773,8550,'vi','ThÃªm Äá»“ Há»a Má»›i',0),(307774,8550,'af','Nuwe Grafika Byvoeg',0),(307775,8550,'ro','Adauga grafic nou',0),(307776,8550,'et','Lisa uus graafika',0),(307777,8550,'si','Dodajte nove grafike',0),(307778,8550,'ba','Tambahkan grafis baru',0),(307779,8550,'nl','Nieuwe afbeelding toevoegen',0),(307780,8550,'fi','LisÃ¤Ã¤ uusi kuva',0),(307781,8550,'no','Legg til ny grafikk',0),(307782,8550,'da','TilfÃ¸je ny grafik',0),(307783,8550,'ko','ìƒˆë¡œìš´ ê·¸ëž˜í”½ ì¶”ê°€',0),(307784,8550,'he','×”×•×¡×£ ×’×¨×¤×™×§×” ×—×“×©×”',0),(307785,8550,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ Î³ÏÎ±Ï†Î¹ÎºÏŒ',0),(307786,8550,'zh','å¢žåŠ æ–°çš„å›¾è¡¨\r\n',0),(307787,8550,'sv','LÃ¤gg till ny grafisk',0),(307788,8550,'it','Aggiungere la nuova veste grafica',0),(307789,8550,'tl','',0),(307790,8550,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;',0),(307791,8550,'hi','à¤¨à¤ à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(307792,8550,'ms','Tambah grafik baru',0),(307793,8550,'ar','Ø¥Ø¶Ø§ÙØ© Ø±Ø³Ù… Ø¬Ø¯ÙŠØ¯',0),(307794,8550,'fr','Ajouter nouveau graphique',0),(307795,8550,'jp','æ–°ã—ã„ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(307796,8550,'pt','Adicionar novo grÃ¡fico',0),(307797,8550,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ€Ð¸ÑÑƒÐ½Ð¾Ðº',0),(307798,8550,'es','Agregar Nuevo GrÃ¡fico',0),(307799,8550,'de','Neue Grafik hinzufÃ¼gen',0),(307800,8550,'en','Add New Graphic',0),(307801,8551,'is','',0),(307802,8551,'dr','Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù… ',0),(307803,8551,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù… ',0),(307804,8551,'tr','Ä°leti grafiÄŸi',0),(307805,8551,'pl','WiadomoÅ›ci graficzne',0),(307806,8551,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(307807,8551,'ur','Ù¾ÛŒØºØ§Ù… Ú¯Ø±Ø§ÙÛŒ',0),(307808,8551,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐ° Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(307809,8551,'vi','Äá»“ Há»a Tin Nháº¯n',0),(307810,8551,'af','Boodskap Grafika',0),(307811,8551,'ro','Mesaj grafic',0),(307812,8551,'et','SÃµnumile pildi',0),(307813,8551,'si','SporoÄilo grafiko',0),(307814,8551,'ba','Pesan grafis',0),(307815,8551,'nl','Bericht afbeelding',0),(307816,8551,'fi','Viesti graafinen',0),(307817,8551,'no','Melding grafiske',0),(307818,8551,'da','Besked grafik',0),(307819,8551,'ko','ë©”ì‹œì§€ ê·¸ëž˜í”½',0),(307820,8551,'he','×’×¨×¤×™×§×ª ×”×•×“×¢×”',0),(307821,8551,'el','ÎœÎ®Î½Ï…Î¼Î± Î³ÏÎ±Ï†Î¹ÎºÏŒ',0),(307822,8551,'zh','æ¶ˆæ¯å›¾\r\n',0),(307823,8551,'sv','Meddelandet grafik',0),(307824,8551,'it','Messaggio grafico',0),(307825,8551,'tl','',0),(307826,8551,'th','&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(307827,8551,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤•',0),(307828,8551,'ms','Mesej grafik',0),(307829,8551,'ar','Ø§Ù„Ø±Ø³Ù… Ø±Ø³Ø§Ù„Ø©',0),(307830,8551,'fr','Message graphique',0),(307831,8551,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯',0),(307832,8551,'pt','GrÃ¡fico de mensagem',0),(307833,8551,'ru','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(307834,8551,'es','GrÃ¡fica de Mensaje ',0),(307835,8551,'de','Nachricht-Grafik',0),(307836,8551,'en','Message Graphic',0),(307837,8552,'is','',0),(307838,8552,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù…',0),(307839,8552,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù…',0),(307840,8552,'tr','Ä°leti grafik gÃ¼ncelleme',0),(307841,8552,'pl','WiadomoÅ›ci graficzne aktualizacja',0),(307842,8552,'bg','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡Ð½Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(307843,8552,'ur','Ù¾ÛŒØºØ§Ù… Ú¯Ø±Ø§ÙÚ© ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(307844,8552,'sr','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐºÐ¸ Ð£Ð¿Ð´Ð°Ñ‚Ðµ Ð¿Ð¾Ñ€ÑƒÐºÑƒ',0),(307845,8552,'vi','Cáº­p Nháº­t Äá»“ Há»a Tin Nháº¯n',0),(307846,8552,'af','Boodskap Grafika Opdateer',0),(307847,8552,'ro','Mesaj grafic Update',0),(307848,8552,'et','SÃµnumi graafiline Update',0),(307849,8552,'si','SporoÄilo grafiÄni posodobitev',0),(307850,8552,'ba','Pesan grafis Update',0),(307851,8552,'nl','Bericht grafische Update',0),(307852,8552,'fi','Graafinen pÃ¤ivitys',0),(307853,8552,'no','Grafisk oppdatering av meldinger',0),(307854,8552,'da','Besked grafisk opdatering',0),(307855,8552,'ko','ë©”ì‹œì§€ ê·¸ëž˜í”½ ì—…ë°ì´íŠ¸',0),(307856,8552,'he','×”×•×“×¢×ª ×¢×“×›×•×Ÿ ×’×¨×¤×™',0),(307857,8552,'el','ÎœÎ®Î½Ï…Î¼Î± Î³ÏÎ±Ï†Î¹ÎºÏŽÎ½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(307858,8552,'zh','æ¶ˆæ¯å›¾å½¢æ›´æ–°\r\n',0),(307859,8552,'sv','Meddelande grafisk uppdatering',0),(307860,8552,'it','Aggiornamento di messaggio grafico',0),(307861,8552,'tl','',0),(307862,8552,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(307863,8552,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤—à¥à¤°à¤¾à¤«à¤¿à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(307864,8552,'ms','Kemaskini grafik mesej',0),(307865,8552,'ar','Ø±Ø³Ø§Ù„Ø© ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ø¨ÙŠØ§Ù†ÙŠØ©',0),(307866,8552,'fr','Mise Ã  jour graphique du message',0),(307867,8552,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã®æ›´æ–°',0),(307868,8552,'pt','AtualizaÃ§Ã£o de mensagem grÃ¡fica',0),(307869,8552,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(307870,8552,'es','GrÃ¡fica de Mensaje Actualizar ',0),(307871,8552,'de','Nachricht Grafik Update',0),(307872,8552,'en','Message Graphic Update',0),(307873,8553,'is','',0),(307874,8553,'dr','Ú¯Ø±ÙˆÙ‡ Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù… ',0),(307875,8553,'pr','Ú¯Ø±ÙˆÙ‡ Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù… ',0),(307876,8553,'tr','Grafik kategori mesaj',0),(307877,8553,'pl','WiadomoÅ›ci graficzne kategorii',0),(307878,8553,'bg','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(307879,8553,'ur','Ù¾ÛŒØºØ§Ù… Ú¯Ø±Ø§ÙÚ© Ø²Ù…Ø±Û',0),(307880,8553,'sr','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐºÐ¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(307881,8553,'vi','Thá»ƒ Loáº¡i Äá»“ Há»a Tin Nháº¯n',0),(307882,8553,'af','Boodskap Grafika Kategorie',0),(307883,8553,'ro','Mesaj grafic categorie',0),(307884,8553,'et','SÃµnumi graafiline kategooria',0),(307885,8553,'si','SporoÄilo grafiÄne kategorije',0),(307886,8553,'ba','Pesan grafis Kategori',0),(307887,8553,'nl','De grafische categorie bericht',0),(307888,8553,'fi','Graafinen Viestiluokalla',0),(307889,8553,'no','Grafisk meldingskategorien',0),(307890,8553,'da','Besked grafisk kategori',0),(307891,8553,'ko','ë©”ì‹œì§€ ê·¸ëž˜í”½ ì¹´í…Œê³ ë¦¬',0),(307892,8553,'he','×”×§×˜×’×•×¨×™×” ×’×¨×¤×™ ×”×•×“×¢×”',0),(307893,8553,'el','Î“ÏÎ±Ï†Î¹ÎºÏŒ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î¼Î®Î½Ï…Î¼Î±',0),(307894,8553,'zh','æ¶ˆæ¯å›¾å½¢åˆ†ç±»\r\n',0),(307895,8553,'sv','Grafisk meddelandekategori',0),(307896,8553,'it','Categoria grafica messaggio',0),(307897,8553,'tl','',0),(307898,8553,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(307899,8553,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤—à¥à¤°à¤¾à¤«à¤¿à¤• à¤¶à¥à¤°à¥‡à¤£à¥€',0),(307900,8553,'ms','Kategori grafik mesej',0),(307901,8553,'ar','ÙØ¦Ø© Ø§Ù„Ø±Ø³Ø§Ù„Ø© Ø§Ù„Ø±Ø³Ù…',0),(307902,8553,'fr','Message catÃ©gorie graphique',0),(307903,8553,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã®ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ ã‚«ãƒ†ã‚´ãƒª',0),(307904,8553,'pt','Categoria de mensagem grÃ¡fica',0),(307905,8553,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ñ… Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹',0),(307906,8553,'es','GrÃ¡fica de Mensaje CategorÃ­a',0),(307907,8553,'de','Grafik Nachrichtenkategorie',0),(307908,8553,'en','Message Graphic Category',0),(307909,8554,'is','',0),(307910,8554,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù…',0),(307911,8554,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø±ÙˆÙ‡ Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù…',0),(307912,8554,'tr','Ä°leti grafik kategori gÃ¼ncelleÅŸtirme',0),(307913,8554,'pl','WiadomoÅ›ci graficzne kategorii aktualizacji',0),(307914,8554,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð² Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(307915,8554,'ur','Ù¾ÛŒØºØ§Ù… Ú¯Ø±Ø§ÙÚ© Ø²Ù…Ø±Û ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(307916,8554,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾Ñ€ÑƒÐºÐ° Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐºÐ¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(307917,8554,'vi','Cáº­p Nháº­t Thá»ƒ Loáº¡i Äá»“ Há»a Tin Nháº¯n',0),(307918,8554,'af','Boodskap Grafika Kategorie Opdateer',0),(307919,8554,'ro','Actualizare de grafic categorie mesaj',0),(307920,8554,'et','SÃµnumi graafiline kategooria Update',0),(307921,8554,'si','Posodobitev grafiÄnih Category sporoÄilo',0),(307922,8554,'ba','Pesan grafis kategori Update',0),(307923,8554,'nl','Bericht grafische categorie Update',0),(307924,8554,'fi','Graafinen luokka pÃ¤ivitys',0),(307925,8554,'no','Oppdatering av meldinger er grafisk kategori',0),(307926,8554,'da','Besked grafisk kategori opdatering',0),(307927,8554,'ko','ë©”ì‹œì§€ ê·¸ëž˜í”½ ì¹´í…Œê³ ë¦¬ ì—…ë°ì´íŠ¸',0),(307928,8554,'he','×”×•×“×¢×ª ×¢×“×›×•×Ÿ ×§×˜×’×•×¨×™×” ×’×¨×¤×™',0),(307929,8554,'el','ÎœÎ®Î½Ï…Î¼Î± Î³ÏÎ±Ï†Î¹ÎºÏŽÎ½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(307930,8554,'zh','æ¶ˆæ¯å›¾å½¢åˆ†ç±»æ›´æ–°\r\n',0),(307931,8554,'sv','Meddelande grafisk kategori uppdatering',0),(307932,8554,'it','Messaggio aggiornamento categoria grafica',0),(307933,8554,'tl','',0),(307934,8554,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(307935,8554,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤—à¥à¤°à¤¾à¤«à¤¿à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(307936,8554,'ms','Kemaskini kategori grafik mesej',0),(307937,8554,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø±Ø³Ù… ÙØ¦Ø© Ø§Ù„Ø±Ø³Ø§Ù„Ø©',0),(307938,8554,'fr','Mise Ã  jour graphique catÃ©gorie de message',0),(307939,8554,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã®ã‚«ãƒ†ã‚´ãƒªã®æ›´æ–°',0),(307940,8554,'pt','AtualizaÃ§Ã£o do grÃ¡fico categoria de mensagem',0),(307941,8554,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ñ… Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹',0),(307942,8554,'es','GrÃ¡fica de Mensaje Actualizar CategorÃ­a',0),(307943,8554,'de','Nachricht Grafik Kategorie Update',0),(307944,8554,'en','Message Graphic Category Update',0),(307945,8555,'is','',0),(307946,8555,'dr','Ø´Ø±Ø­ Ú¯Ø±ÙˆÙ‡ Ú¯Ø±Ø§ÙÙŠÙƒ ',0),(307947,8555,'pr','Ø´Ø±Ø­ Ú¯Ø±ÙˆÙ‡ Ú¯Ø±Ø§ÙÙŠÙƒ ',0),(307948,8555,'tr','Grafik kategorisi aÃ§Ä±klamasÄ±',0),(307949,8555,'pl','Opis kategorii graficzny',0),(307950,8555,'bg','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÐ½ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(307951,8555,'ur','Ú¯Ø±Ø§ÙÚ© Ø²Ù…Ø±Û ØªØµØ±ÛŒØ­',0),(307952,8555,'sr','ÐžÐ¿Ð¸Ñ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐºÐ¾Ð³ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(307953,8555,'vi','Diá»…n giáº£i thá»ƒ loáº¡i Ä‘á»“ há»a',0),(307954,8555,'af','Grafika Kategorie Beskrywing',0),(307955,8555,'ro','Grafic categoria descriere',0),(307956,8555,'et','Graafiline kategooria kirjeldus',0),(307957,8555,'si','GrafiÄni kategorija opis',0),(307958,8555,'ba','Deskripsi kategori grafis',0),(307959,8555,'nl','Grafische categorie omschrijving',0),(307960,8555,'fi','Graafinen kuvaus',0),(307961,8555,'no','Grafisk Kategoribeskrivelse',0),(307962,8555,'da','Grafisk Kategoribeskrivelse',0),(307963,8555,'ko','ê·¸ëž˜í”½ ì¹´í…Œê³ ë¦¬ ì„¤ëª…',0),(307964,8555,'he','×ª×™××•×¨ ×§×˜×’×•×¨×™×™×ª ×’×¨×¤×™',0),(307965,8555,'el','Î“ÏÎ±Ï†Î¹ÎºÏŒ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(307966,8555,'zh','å›¾å½¢åˆ†ç±»æè¿°\r\n',0),(307967,8555,'sv','Grafisk kategoribeskrivning',0),(307968,8555,'it','Descrizione della categoria grafica',0),(307969,8555,'tl','',0),(307970,8555,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;',0),(307971,8555,'hi','à¤—à¥à¤°à¤¾à¤«à¤¿à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤µà¤¿à¤µà¤°à¤£',0),(307972,8555,'ms','Perihalan kategori grafik',0),(307973,8555,'ar','ÙˆØµÙ ÙØ¦Ø© Ø§Ù„Ø±Ø³Ù…',0),(307974,8555,'fr','Description de la catÃ©gorie graphique',0),(307975,8555,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã®ã‚«ãƒ†ã‚´ãƒªã®èª¬æ˜Ž',0),(307976,8555,'pt','DescriÃ§Ã£o da categoria grÃ¡fica',0),(307977,8555,'ru','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(307978,8555,'es','GrÃ¡fica DescripciÃ³n de CategorÃ­a',0),(307979,8555,'de','Grafisches Kategoriebeschreibung',0),(307980,8555,'en','Graphic Category Description',0),(307981,8556,'is','',0),(307982,8556,'dr','Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ú¯Ø±Ø§ÙÙŠÙƒ ',0),(307983,8556,'pr','Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ú¯Ø±Ø§ÙÙŠÙƒ ',0),(307984,8556,'tr','Grafik kategori adÄ±',0),(307985,8556,'pl','Nazwa kategorii graficzny',0),(307986,8556,'bg','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÐ½ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¸Ð¼Ðµ',0),(307987,8556,'ur','Ú¯Ø±Ø§ÙÚ© Ù‚Ø³Ù… Ú©Ø§ Ù†Ø§Ù…',0),(307988,8556,'sr','Ð˜Ð¼Ðµ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐºÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(307989,8556,'vi','TÃªn thá»ƒ loáº¡i Ä‘á»“ há»a',0),(307990,8556,'af','Grafika Kategorie Naam',0),(307991,8556,'ro','Numele categoriei de grafic',0),(307992,8556,'et','Graafiline kategooria nimi',0),(307993,8556,'si','Ime grafiÄne kategorije',0),(307994,8556,'ba','Nama kategori grafis',0),(307995,8556,'nl','Grafische categorienaam',0),(307996,8556,'fi','Graafinen luokkanimi',0),(307997,8556,'no','Grafisk kategorinavn',0),(307998,8556,'da','Grafisk kategorinavn',0),(307999,8556,'ko','ê·¸ëž˜í”½ ì¹´í…Œê³ ë¦¬ ì´ë¦„',0),(308000,8556,'he','×©× ×”×§×˜×’×•×¨×™×” ×’×¨×¤×™',0),(308001,8556,'el','ÎŒÎ½Î¿Î¼Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚ Î³ÏÎ±Ï†Î¹ÎºÏŽÎ½',0),(308002,8556,'zh','å›¾å½¢åˆ†ç±»åç§°\r\n',0),(308003,8556,'sv','Grafisk kategorinamn',0),(308004,8556,'it','Nome categoria grafica',0),(308005,8556,'tl','',0),(308006,8556,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3617;&#3623;&#3604;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;',0),(308007,8556,'hi','à¤—à¥à¤°à¤¾à¤«à¤¿à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤¨à¤¾à¤®',0),(308008,8556,'ms','Nama kategori grafik',0),(308009,8556,'ar','Ø§Ø³Ù… ÙØ¦Ø© Ø§Ù„Ø±Ø³Ù…',0),(308010,8556,'fr','Nom de la catÃ©gorie graphique',0),(308011,8556,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã®ã‚«ãƒ†ã‚´ãƒªã®åå‰',0),(308012,8556,'pt','Nome da categoria grÃ¡fica',0),(308013,8556,'ru','Ð˜Ð¼Ñ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¾Ð³Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(308014,8556,'es','GrÃ¡fica Nombre de CategorÃ­a',0),(308015,8556,'de','Grafik Kategorienamen',0),(308016,8556,'en','Graphic Category Name',0),(308017,8557,'is','',0),(308018,8557,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù…',0),(308019,8557,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù…',0),(308020,8557,'tr','Ä°leti grafik kategori ekleme',0),(308021,8557,'pl','WiadomoÅ›ci graficzne kategorii Dodaj',0),(308022,8557,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð³Ñ€Ð°Ñ„Ð¸Ñ‡Ð½Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(308023,8557,'ur','Ù¾ÛŒØºØ§Ù… Ú¯Ø±Ø§ÙÚ© Ø²Ù…Ø±Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(308024,8557,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(308025,8557,'vi','ThÃªm Thá»ƒ Loáº¡i Äá»“ Há»a Tin Nháº¯n',0),(308026,8557,'af','Boodskap Grafika Kategorie Byvoeg',0),(308027,8557,'ro','Adauga mesaj grafic categorie',0),(308028,8557,'et','SÃµnumi graafiline kategooria lisamine',0),(308029,8557,'si','GrafiÄne kategorije sporoÄilo dodate',0),(308030,8557,'ba','Menambahkan pesan grafis Kategori',0),(308031,8557,'nl','De grafische categorie bericht toevoegen',0),(308032,8557,'fi','Graafinen Viestiluokalla lisÃ¤Ã¤',0),(308033,8557,'no','Grafisk meldingskategorien legge',0),(308034,8557,'da','Besked grafisk kategori tilfÃ¸je',0),(308035,8557,'ko','ë©”ì‹œì§€ ê·¸ëž˜í”½ ì¹´í…Œê³ ë¦¬ ì¶”ê°€',0),(308036,8557,'he','×”×•×¡×£ ×§×˜×’×•×¨×™×” ×’×¨×¤×™ ×”×•×“×¢×”',0),(308037,8557,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î³ÏÎ±Ï†Î¹ÎºÏŽÎ½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î¼Î®Î½Ï…Î¼Î±',0),(308038,8557,'zh','å›¾å½¢ç±»åŠ å…¥æ¶ˆæ¯\r\n',0),(308039,8557,'sv','Grafisk meddelandekategori lÃ¤gga till',0),(308040,8557,'it','Aggiungi messaggio categoria grafica',0),(308041,8557,'tl','',0),(308042,8557,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(308043,8557,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤—à¥à¤°à¤¾à¤«à¤¿à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(308044,8557,'ms','Tambah Kategori grafik mesej',0),(308045,8557,'ar','Ø¥Ø¶Ø§ÙØ© ÙØ¦Ø© Ø§Ù„Ø±Ø³Ù… Ø±Ø³Ø§Ù„Ø©',0),(308046,8557,'fr','Ajouter message catÃ©gorie graphique',0),(308047,8557,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã®ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ ã‚«ãƒ†ã‚´ãƒªã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(308048,8557,'pt','Adicionar mensagem grÃ¡fica categoria',0),(308049,8557,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ñ… Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹',0),(308050,8557,'es','GrÃ¡fica de Mensaje Agregar CategorÃ­a',0),(308051,8557,'de','Nachrichtenkategorie Grafik hinzufÃ¼gen',0),(308052,8557,'en','Message Graphic Category Add',0),(308053,8558,'is','',0),(308054,8558,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù… ',0),(308055,8558,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±Ø§ÙÙŠÙƒ Ù¾ÙŠØºØ§Ù… ',0),(308056,8558,'tr','Ä°leti grafik ekleme',0),(308057,8558,'pl','WiadomoÅ›ci graficzne dodaÄ‡',0),(308058,8558,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(308059,8558,'ur','Ù¾ÛŒØºØ§Ù… Ú¯Ø±Ø§ÙÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(308060,8558,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(308061,8558,'vi','ThÃªm Äá»“ Há»a Tin Nháº¯n',0),(308062,8558,'af','Boodskap Grafika Byvoeg',0),(308063,8558,'ro','Adauga mesaj grafic',0),(308064,8558,'et','SÃµnumile pildi lisamine',0),(308065,8558,'si','GrafiÄni sporoÄilo dodate',0),(308066,8558,'ba','Menambahkan pesan grafis',0),(308067,8558,'nl','Bericht afbeelding toevoegen',0),(308068,8558,'fi','Viesti graafinen lisÃ¤Ã¤',0),(308069,8558,'no','Melding grafiske legge',0),(308070,8558,'da','Besked grafik tilfÃ¸je',0),(308071,8558,'ko','ë©”ì‹œì§€ ê·¸ëž˜í”½ ì¶”ê°€',0),(308072,8558,'he','×”×•×¡×£ ×”×•×“×¢×” ×’×¨×¤×™×§×”',0),(308073,8558,'el','Î“ÏÎ±Ï†Î¹ÎºÏŒ Î¼Î®Î½Ï…Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(308074,8558,'zh','æ¶ˆæ¯å›¾å½¢æ·»åŠ \r\n',0),(308075,8558,'sv','Meddelandet grafik lÃ¤gga till',0),(308076,8558,'it','Aggiungi messaggio grafico',0),(308077,8558,'tl','',0),(308078,8558,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(308079,8558,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(308080,8558,'ms','Tambah grafik mesej',0),(308081,8558,'ar','Ø¥Ø¶Ø§ÙØ© Ø±Ø³Ø§Ù„Ø© Ø§Ù„Ø±Ø³Ù…',0),(308082,8558,'fr','Ajouter message graphique',0),(308083,8558,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(308084,8558,'pt','Adicionar mensagem grÃ¡fica',0),(308085,8558,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(308086,8558,'es','GrÃ¡fica de Mensaje Agregar',0),(308087,8558,'de','Nachricht Grafik hinzufÃ¼gen',0),(308088,8558,'en','Message Graphic Add',0),(308089,8559,'is','',0),(308090,8559,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø² ÙŠØ§Ø¨ÙŠ  Ù†ÙŠØ³Øª',0),(308091,8559,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø² ÙŠØ§Ø¨ÙŠ  Ù†ÙŠØ³Øª',0),(308092,8559,'tr','AlÄ±namÄ±yor',0),(308093,8559,'pl','Nie moÅ¼na pobraÄ‡',0),(308094,8559,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ',0),(308095,8559,'ur','Ø¨Ø§Ø²Ú¯ÛŒØ± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(308096,8559,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸',0),(308097,8559,'vi','KhÃ´ng thá»ƒ truy váº¥n',0),(308098,8559,'af','Herwin kan',0),(308099,8559,'ro','Imposibil de regÄƒsit',0),(308100,8559,'et','Ei saa laadida',0),(308101,8559,'si','Ni mogoÄe pridobiti',0),(308102,8559,'ba','Tidak dapat mengambil',0),(308103,8559,'nl','Kan niet ophalen',0),(308104,8559,'fi','Ei voi noutaa',0),(308105,8559,'no','Kan ikke hente',0),(308106,8559,'da','Der kan ikke hentes',0),(308107,8559,'ko','ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(308108,8559,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ××—×–×¨',0),(308109,8559,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î½Î±ÎºÏ„Î®ÏƒÎµÎ¹',0),(308110,8559,'zh','æ— æ³•æ£€ç´¢\r\n',0),(308111,8559,'sv','GÃ¥r inte att hÃ¤mta',0),(308112,8559,'it','Non Ã¨ possibile recuperare',0),(308113,8559,'tl','',0),(308114,8559,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3629;&#3634;&#3585;&#3621;&#3633;&#3610;&#3588;&#3639;&#3609;&#3617;&#3634;&#3652;&#3604;&#3657;',0),(308115,8559,'hi','à¤ªà¥à¤¨à¤ƒ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(308116,8559,'ms','Tidak dapat membuka',0),(308117,8559,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¬Ù„Ø¨',0),(308118,8559,'fr','Impossible de rÃ©cupÃ©rer',0),(308119,8559,'jp','å–å¾—ã§ãã¾ã›ã‚“ã€‚',0),(308120,8559,'pt','NÃ£o Ã© possÃ­vel recuperar',0),(308121,8559,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð’Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(308122,8559,'es','No se puede Recoger',0),(308123,8559,'de','Kann nicht abgerufen werden',0),(308124,8559,'en','Cannot Retrieve',0),(308125,8560,'is','',0),(308126,8560,'dr','/ Ø§ØµÙ„Ø§Ø­   / Ø®Ø°Ù Ù¾ÙŠØºØ§Ù… Ù‡Ø§ ',0),(308127,8560,'pr','Ø§ÙŠØ¬Ø§Ø¯  / ÙˆÙŠØ±Ø§ÙŠØ´  / Ø®Ø°Ù Ù¾ÙŠØºØ§Ù… Ù‡Ø§ ',0),(308128,8560,'tr','OluÅŸtur, DÃ¼zenle & iletileri silme',0),(308129,8560,'pl','Tworzenie, edytowanie & usunÄ…Ä‡ wiadomoÅ›ci',0),(308130,8560,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ, Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ & Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(308131,8560,'ur','Ø¨Ù†Ø§Ø¦ÛŒÚºØŒ ØªØ±Ù…ÛŒÙ… & Ù¾ÛŒØºØ§Ù…Ø§Øª Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(308132,8560,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ , ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ & Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¿Ð¾Ñ€ÑƒÐºÐ°',0),(308133,8560,'vi','Táº¡o Má»›i, Sá»­a & XÃ³a Tin Nháº¯n',0),(308134,8560,'af','Skep, Redigeer & Skrap Boodskappe',0),(308135,8560,'ro','CreaÅ£i, editaÅ£i & ÅŸterge mesaje',0),(308136,8560,'et','Loo, muuda ja kustuta sÃµnumeid',0),(308137,8560,'si','Ustvarite, uredite & brisanje sporoÄil',0),(308138,8560,'ba','Membuat, mengedit & menghapus pesan',0),(308139,8560,'nl','Maken, bewerken & berichten verwijderen',0),(308140,8560,'fi','Luo, muokkaa & viestien poistaminen',0),(308141,8560,'no','Opprette, redigere & slette meldinger',0),(308142,8560,'da','Oprette, redigere & slette meddelelser',0),(308143,8560,'ko','ë§Œë“¤ê¸°, íŽ¸ì§‘ & ë©”ì‹œì§€ ì‚­ì œ',0),(308144,8560,'he','×œ×™×¦×•×¨, ×œ×¢×¨×•×š & ×œ×ž×—×•×§ ×”×•×“×¢×•×ª',0),(308145,8560,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ, ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ & Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î¼Î·Î½ÏÎ¼Î±Ï„Î±',0),(308146,8560,'zh','åˆ›å»ºï¼Œç¼–è¾‘å’Œåˆ é™¤æ¶ˆæ¯\r\n',0),(308147,8560,'sv','Skapa, redigera & ta bort meddelanden',0),(308148,8560,'it','Creare, modificare & eliminare messaggi',0),(308149,8560,'tl','',0),(308150,8560,'th','&#3626;&#3619;&#3657;&#3634;&#3591; &#3649;&#3585;&#3657;&#3652;&#3586;&#3649;&#3621;&#3632;&#3621;&#3610;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(308151,8560,'hi','à¤¬à¤¨à¤¾à¤à¤, à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ & à¤¸à¤‚à¤¦à¥‡à¤¶ à¤¹à¤Ÿà¤¾à¤à¤',0),(308152,8560,'ms','Cipta, Edit & menghapuskan mesej-mesej',0),(308153,8560,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ùˆ ØªØ­Ø±ÙŠØ± Ùˆ Ø­Ø°Ù Ø§Ù„Ø±Ø³Ø§Ø¦Ù„',0),(308154,8560,'fr','CrÃ©er, modifier, & supprimer Messages',0),(308155,8560,'jp','ä½œæˆã€ç·¨é›† & ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(308156,8560,'pt','Criar, editar, & excluir mensagens',0),(308157,8560,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ, Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ & Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(308158,8560,'es','Crear, Editar & Eliminar Mensajes',0),(308159,8560,'de','Erstellen, bearbeiten, & Nachrichten lÃ¶schen',0),(308160,8560,'en','Create, Edit & Delete Messages',0),(308161,8561,'is','',0),(308162,8561,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ù¾ÙŠØºØ§Ù… Ø¬Ø¯ÙŠØ¯ ',0),(308163,8561,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ù¾ÙŠØºØ§Ù… Ø¬Ø¯ÙŠØ¯ ',0),(308164,8561,'tr','Yeni ileti oluÅŸturma',0),(308165,8561,'pl','UtwÃ³rz nowÄ… wiadomoÅ›Ä‡',0),(308166,8561,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(308167,8561,'ur','Ù†ÛŒØ§ Ù…Ø³ÛŒØ¬ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(308168,8561,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(308169,8561,'vi','Táº¡o tin nháº¯n',0),(308170,8561,'af','Skep Nuwe Boodskappe',0),(308171,8561,'ro','Creare mesaj nou',0),(308172,8561,'et','Loo uus sÃµnum',0),(308173,8561,'si','Ustvari novo sporoÄilo',0),(308174,8561,'ba','Buat pesan baru',0),(308175,8561,'nl','Nieuw bericht maken',0),(308176,8561,'fi','Luo uusi viesti',0),(308177,8561,'no','Opprette ny melding',0),(308178,8561,'da','Opret ny meddelelse',0),(308179,8561,'ko','ìƒˆ ë©”ì‹œì§€ ìž‘ì„±',0),(308180,8561,'he','×™×¦×™×¨×ª ×”×•×“×¢×” ×—×“×©×”',0),(308181,8561,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î½Î­Î¿Ï… Î¼Î·Î½ÏÎ¼Î±Ï„Î¿Ï‚',0),(308182,8561,'zh','åˆ›å»ºæ–°é‚®ä»¶\r\n',0),(308183,8561,'sv','Skapa nytt meddelande',0),(308184,8561,'it','Crea nuovo messaggio',0),(308185,8561,'tl','',0),(308186,8561,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(308187,8561,'hi','à¤¨à¤¯à¤¾ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤¬à¤¨à¤¾à¤à¤',0),(308188,8561,'ms','Cipta mesej baru',0),(308189,8561,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø±Ø³Ø§Ù„Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(308190,8561,'fr','CrÃ©er Nouveau Message',0),(308191,8561,'jp','æ–°ã—ã„ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(308192,8561,'pt','Criar nova mensagem',0),(308193,8561,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ðµ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(308194,8561,'es','Crear Mensaje Nuevo',0),(308195,8561,'de','Neue Nachricht erstellen',0),(308196,8561,'en','Create New Message',0),(308197,8562,'is','',0),(308198,8562,'dr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ Ø¬Ø§Ø±ÙŠ ',0),(308199,8562,'pr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ Ø¬Ø§Ø±ÙŠ ',0),(308200,8562,'tr','GeÃ§erli etkin ileti',0),(308201,8562,'pl','BieÅ¼Ä…ce wiadomoÅ›ci aktywne',0),(308202,8562,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(308203,8562,'ur','Ø­Ø§Ù„ÛŒÛ ÙØ¹Ø§Ù„ Ù¾ÛŒØºØ§Ù…Ø§Øª',0),(308204,8562,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(308205,8562,'vi','Tin nháº¯n hiá»‡n táº¡i',0),(308206,8562,'af','Huidige Aktiewe Boodskappe',0),(308207,8562,'ro','Mesaje activ curent',0),(308208,8562,'et','Praegune aktiivne sÃµnumid',0),(308209,8562,'si','Trenutno aktivno sporoÄila',0),(308210,8562,'ba','Saat ini aktif pesan',0),(308211,8562,'nl','Huidige actieve berichten',0),(308212,8562,'fi','Nykyiset aktiiviset viestit',0),(308213,8562,'no','Gjeldende aktive meldinger',0),(308214,8562,'da','NuvÃ¦rende aktive meddelelser',0),(308215,8562,'ko','í˜„ìž¬ í™œì„± ë©”ì‹œì§€',0),(308216,8562,'he','×”×•×“×¢×•×ª ×”×¤×¢×™×œ ×”× ×•×›×—×™',0),(308217,8562,'el','Î¤ÏÎ­Ï‡Î¿Î½Ï„Î± ÎµÎ½ÎµÏÎ³ÏŒ Î¼Î·Î½ÏÎ¼Î±Ï„Î±',0),(308218,8562,'zh','å½“å‰æ´»åŠ¨æ¶ˆæ¯\r\n',0),(308219,8562,'sv','Aktuella aktiva meddelanden',0),(308220,8562,'it','Messaggi attivi correnti',0),(308221,8562,'tl','',0),(308222,8562,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3629;&#3618;&#3641;&#3656;',0),(308223,8562,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(308224,8562,'ms','Mesej aktif semasa',0),(308225,8562,'ar','Ø§Ù„Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ù†Ø´Ø¸Ø© Ø­Ø§Ù„ÙŠØ§',0),(308226,8562,'fr','Messages Active actuelles',0),(308227,8562,'jp','ç¾åœ¨ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(308228,8562,'pt','Mensagens ativas atuais',0),(308229,8562,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(308230,8562,'es','Mensajes Activos Actuales',0),(308231,8562,'de','Aktuelle aktive Nachrichten',0),(308232,8562,'en','Current Active Messages',0),(308233,8563,'is','',0),(308234,8563,'dr','Ø®Ø·Ø§ ÙŠ ÙƒÙ¾ÙŠ ÙƒØ±Ø¯Ù† Ù¾ÙŠØºØ§Ù… ',0),(308235,8563,'pr','Ø®Ø·Ø§ ÙŠ ÙƒÙ¾ÙŠ ÙƒØ±Ø¯Ù† Ù¾ÙŠØºØ§Ù… ',0),(308236,8563,'tr','Hata iletisi kopyalama',0),(308237,8563,'pl','Komunikat o bÅ‚Ä™dzie kopiowania',0),(308238,8563,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð·Ð° Ð³Ñ€ÐµÑˆÐºÐ°',0),(308239,8563,'ur','Ù†Ù‚Øµ Ù¾ÛŒØºØ§Ù… Ú©ÛŒ Ù†Ù‚Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(308240,8563,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾Ñ€ÑƒÐºÐ° Ð¾ Ð³Ñ€ÐµÑˆÑ†Ð¸',0),(308241,8563,'vi','Lá»—i sao chÃ©p tin nháº¯n',0),(308242,8563,'af','Fout met KopiÃ«ring van Boodskap',0),(308243,8563,'ro','Mesaj de eroare de copiere',0),(308244,8563,'et','TÃµrketeade kopeerimine',0),(308245,8563,'si','Napaka pri kopiranju sporoÄilo',0),(308246,8563,'ba','Menyalin pesan kesalahan',0),(308247,8563,'nl','Foutbericht kopiÃ«ren',0),(308248,8563,'fi','Virhesanoma kopiointi',0),(308249,8563,'no','Kopiere feilmelding',0),(308250,8563,'da','Fejlmeddelelse kopiering',0),(308251,8563,'ko','ì˜¤ë¥˜ ë³µì‚¬ ë©”ì‹œì§€',0),(308252,8563,'he','×”×•×“×¢×ª ×©×’×™××” ×‘×”×¢×ª×§×”',0),(308253,8563,'el','Î‘Î½Ï„Î¹Î³ÏÎ±Ï†Î® Î¼Î®Î½Ï…Î¼Î± Î»Î¬Î¸Î¿Ï…Ï‚',0),(308254,8563,'zh','é”™è¯¯å¤åˆ¶æ¶ˆæ¯',0),(308255,8563,'sv','Kopiering av meddelande',0),(308256,8563,'it','Messaggio di errore copiando',0),(308257,8563,'tl','',0),(308258,8563,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(308259,8563,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤¨à¤¾',0),(308260,8563,'ms','Ralat menyalin mesej',0),(308261,8563,'ar','Ø®Ø·Ø£ ÙÙŠ Ù†Ø³Ø® Ø§Ù„Ø±Ø³Ø§Ù„Ø©',0),(308262,8563,'fr','Message d\'erreur copie',0),(308263,8563,'jp','ã‚³ãƒ”ãƒ¼ã®ã‚¨ãƒ©ãƒ¼ ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(308264,8563,'pt','Mensagem de erro copiando',0),(308265,8563,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(308266,8563,'es','Error Copiando Mensaje',0),(308267,8563,'de','Fehlermeldung kopieren',0),(308268,8563,'en','Error Copying Message',0),(308269,8564,'is','',0),(308270,8564,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù¾ÙŠØºØ§Ù… ',0),(308271,8564,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ù¾ÙŠØºØ§Ù… ',0),(308272,8564,'tr','Ä°leti silme',0),(308273,8564,'pl','Usuwanie Komunikat o bÅ‚Ä™dzie',0),(308274,8564,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð·Ð° Ð³Ñ€ÐµÑˆÐºÐ°',0),(308275,8564,'ur','ØºÙ„Ø·ÛŒ Ú©Ø§ Ù¾ÛŒØºØ§Ù… Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(308276,8564,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¿Ð¾Ñ€ÑƒÐºÐ° Ð¾ Ð³Ñ€ÐµÑˆÑ†Ð¸',0),(308277,8564,'vi','Lá»—i xÃ³a tin nháº¯n',0),(308278,8564,'af','Fout met Skrap van Boodskap',0),(308279,8564,'ro','Mesaj de eroare ÅŸtergerea',0),(308280,8564,'et','Veateate kustutamine',0),(308281,8564,'si','Brisanje napake',0),(308282,8564,'ba','Menghapus pesan kesalahan',0),(308283,8564,'nl','Foutbericht verwijderen',0),(308284,8564,'fi','Virhesanoma poistettaessa',0),(308285,8564,'no','Slette feilmelding',0),(308286,8564,'da','Slette fejlmeddelelse',0),(308287,8564,'ko','ì˜¤ë¥˜ ì‚­ì œ ë©”ì‹œì§€',0),(308288,8564,'he','×ž×—×™×§×ª ×”×•×“×¢×ª ×©×’×™××”',0),(308289,8564,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î¼Î®Î½Ï…Î¼Î± Î»Î¬Î¸Î¿Ï…Ï‚',0),(308290,8564,'zh','é”™è¯¯åˆ é™¤ä¿¡æ¯',0),(308291,8564,'sv','Ta bort felmeddelandet',0),(308292,8564,'it','Messaggio di errore eliminazione',0),(308293,8564,'tl','',0),(308294,8564,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(308295,8564,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡',0),(308296,8564,'ms','Ralat menghapuskan mesej',0),(308297,8564,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø±Ø³Ø§Ù„Ø©',0),(308298,8564,'fr','Supprimer Message d\'erreur',0),(308299,8564,'jp','ã‚¨ãƒ©ãƒ¼ ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®å‰Šé™¤',0),(308300,8564,'pt','Apagar mensagem de erro',0),(308301,8564,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(308302,8564,'es','Error Eliminando Mensaje',0),(308303,8564,'de','Fehlermeldung LÃ¶schen',0),(308304,8564,'en','Error Deleting Message',0),(308305,8565,'is','',0),(308306,8565,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(308307,8565,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(308308,8565,'tr','Hata ekleme',0),(308309,8565,'pl','BÅ‚Ä…d wstawiania',0),(308310,8565,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ',0),(308311,8565,'ur','Ù†Ù‚Øµ Ø¯Ø§Ø®Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(308312,8565,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ¼ÐµÑ‚Ð°ÑšÑƒ',0),(308313,8565,'vi','Lá»—i khi chÃ¨n',0),(308314,8565,'af','Fout invoeging',0),(308315,8565,'ro','Inserarea de eroare',0),(308316,8565,'et','Viga paigaldamisel',0),(308317,8565,'si','Napaka pri vstavljanju',0),(308318,8565,'ba','Kesalahan memasukkan',0),(308319,8565,'nl','Fout invoegen',0),(308320,8565,'fi','Virhe lisÃ¤Ã¤minen',0),(308321,8565,'no','Feil innsetting',0),(308322,8565,'da','IndsÃ¦ttelse af fejl',0),(308323,8565,'ko','ì˜¤ë¥˜ ì‚½ìž…',0),(308324,8565,'he','×”×•×¡×¤×ª ×”×©×’×™××”',0),(308325,8565,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(308326,8565,'zh','é”™è¯¯æ’å…¥',0),(308327,8565,'sv','Fel att infoga',0),(308328,8565,'it','Errore di inserimento',0),(308329,8565,'tl','',0),(308330,8565,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;',0),(308331,8565,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(308332,8565,'ms','Kesilapan memasukkan',0),(308333,8565,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø®Ø·Ø£',0),(308334,8565,'fr','Erreur insertion',0),(308335,8565,'jp','ã‚¨ãƒ©ãƒ¼ã‚’æŒ¿å…¥ã—ã¾ã™ã€‚',0),(308336,8565,'pt','InserÃ§Ã£o de erro',0),(308337,8565,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð’Ð²Ð¾Ð´Ðµ',0),(308338,8565,'es','Error Insertando',0),(308339,8565,'de','Fehler einfÃ¼gen',0),(308340,8565,'en','Error Inserting',0),(308341,8566,'is','',0),(308342,8566,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¨Ø±Ø§ÙŠ ',0),(308343,8566,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¨Ø±Ø§ÙŠ ',0),(308344,8566,'tr','Ä°Ã§in ekleme hatasÄ±',0),(308345,8566,'pl','BÅ‚Ä…d wstawiania dla',0),(308346,8566,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð·Ð°',0),(308347,8566,'ur','Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø§Ø®Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(308348,8566,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ¼ÐµÑ‚Ð°ÑšÑƒ Ð·Ð°',0),(308349,8566,'vi','Lá»—i khi chÃ¨n cho',0),(308350,8566,'af','Fout inbring vir',0),(308351,8566,'ro','Eroare de inserare pentru',0),(308352,8566,'et','Viga lisamine',0),(308353,8566,'si','Pri vstavljanju za',0),(308354,8566,'ba','Kesalahan memasukkan untuk',0),(308355,8566,'nl','Error invoegen voor',0),(308356,8566,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ varten',0),(308357,8566,'no','Feil under innsetting For',0),(308358,8566,'da','Fejl indsÃ¦ttelse For',0),(308359,8566,'ko','ì˜¤ë¥˜ ì‚½ìž…',0),(308360,8566,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×¢×‘×•×¨',0),(308361,8566,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î³Î¹Î±',0),(308362,8566,'zh','é”™è¯¯æ’å…¥',0),(308363,8566,'sv','Fel infoga fÃ¶r',0),(308364,8566,'it','Errore di inserimento per',0),(308365,8566,'tl','',0),(308366,8566,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3649;&#3607;&#3619;&#3585;&#3586;&#3629;&#3591;',0),(308367,8566,'hi','à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(308368,8566,'ms','Kesilapan memasukkan bagi',0),(308369,8566,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ù„Ù„Ø®Ø·Ø£',0),(308370,8566,'fr','Erreur insertion pour',0),(308371,8566,'jp','ã‚¨ãƒ©ãƒ¼ã®æŒ¿å…¥',0),(308372,8566,'pt','Erro de inserÃ§Ã£o para',0),(308373,8566,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð’Ð²Ð¾Ð´Ðµ Ð”Ð»Ñ',0),(308374,8566,'es','Error Insertando Para',0),(308375,8566,'de','Fehler fÃ¼r einfÃ¼gen',0),(308376,8566,'en','Error Inserting For',0),(308377,8567,'is','',0),(308378,8567,'dr','Ø±Ù†Ú¯ Ù‚Ù„Ù…',0),(308379,8567,'pr','Ø±Ù†Ú¯ Ù‚Ù„Ù…',0),(308380,8567,'tr','YazÄ± tipi rengi',0),(308381,8567,'pl','Kolor czcionki',0),(308382,8567,'bg','Ð¦Ð²ÑÑ‚ Ð½Ð° ÑˆÑ€Ð¸Ñ„Ñ‚Ð°',0),(308383,8567,'ur','ÙØ§Ù†Ù¹ Ø±Ù†Ú¯',0),(308384,8567,'sr','Ð‘Ð¾Ñ˜Ð° Ñ„Ð¾Ð½Ñ‚Ð°',0),(308385,8567,'vi','Máº§u chá»¯',0),(308386,8567,'af','Fontkleur',0),(308387,8567,'ro','Culoare font',0),(308388,8567,'et','Fondi vÃ¤rv',0),(308389,8567,'si','Barva pisave',0),(308390,8567,'ba','Warna font',0),(308391,8567,'nl','Tekstkleur',0),(308392,8567,'fi','FonttivÃ¤ri',0),(308393,8567,'no','Skriftfarge',0),(308394,8567,'da','Skriftfarve',0),(308395,8567,'ko','ê¸€ê¼´ ìƒ‰',0),(308396,8567,'he','×¦×‘×¢ ×’×•×¤×Ÿ',0),(308397,8567,'el','Î§ÏÏŽÎ¼Î± Î³ÏÎ±Î¼Î¼Î±Ï„Î¿ÏƒÎµÎ¹ÏÎ¬Ï‚',0),(308398,8567,'zh','å­—ä½“é¢œè‰²\r\n',0),(308399,8567,'sv','TeckenfÃ¤rg',0),(308400,8567,'it','Colore del carattere',0),(308401,8567,'tl','',0),(308402,8567,'th','&#3626;&#3637;&#3605;&#3633;&#3623;&#3629;&#3633;&#3585;&#3625;&#3619;',0),(308403,8567,'hi','à¤«à¤¼à¥‰à¤¨à¥à¤Ÿ à¤°à¤‚à¤—',0),(308404,8567,'ms','Warna fon',0),(308405,8567,'ar','Ù„ÙˆÙ† Ø§Ù„Ø®Ø·',0),(308406,8567,'fr','Couleur de police',0),(308407,8567,'jp','ãƒ•ã‚©ãƒ³ãƒˆã®è‰²',0),(308408,8567,'pt','Cor da fonte',0),(308409,8567,'ru','Ð¦Ð²ÐµÑ‚ ÑˆÑ€Ð¸Ñ„Ñ‚Ð°',0),(308410,8567,'es','Color de Fuente',0),(308411,8567,'de','Schriftfarbe',0),(308412,8567,'en','Font Color',0),(308413,8568,'is','',0),(308414,8568,'dr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ÙŠ ÙƒÙ„ÙŠ Ø¯Ø± ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ Ø¨Ø±Ø§ÙŠ Ù‡Ø± ÙƒØ³ÙŠ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ ',0),(308415,8568,'pr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ÙŠ ÙƒÙ„ÙŠ Ø¯Ø± ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ Ø¨Ø±Ø§ÙŠ Ù‡Ø± ÙƒØ³ÙŠ Ù†Ù…Ø§ÙŠØ´ Ø¯Ø§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ ',0),(308416,8568,'tr','Genel Mesaj herkesin giriÅŸ sayfasÄ±nda gÃ¶rÃ¼ntÃ¼lenir.',0),(308417,8568,'pl','OgÃ³lne wiadomoÅ›ci sÄ… wyÅ›wietlane na wszystkich na stronie gÅ‚Ã³wnej.',0),(308418,8568,'bg','ÐžÐ±Ñ‰Ð¸ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ ÑÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚ Ð½Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸.',0),(308419,8568,'ur','Ø¹Ù…ÙˆÙ…ÛŒ Ù¾ÛŒØºØ§Ù…Ø§Øª Ù¾Ø± ÛÙˆÙ… Ù¾ÛŒØ¬ ÛØ± Ú©Ø³ÛŒ Ú©Ø§ Ø¯Ú©Ú¾Ø§Ø¦Û’ Ø¬Ø§ØªÛ’ ÛÛŒÚº Û”',0),(308420,8568,'sr','Ð“Ð»Ð°Ð²Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÐºÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜Ñƒ ÑÐµ ÑÐ²Ð¸ ÑÑƒ Ð¼ÐµÐ½Ñƒ.',0),(308421,8568,'vi','Tin nháº¯n chung hiá»ƒn thá»‹ trÃªn trang chá»§ cá»§a táº¥t cáº£ má»i ngÆ°á»i.',0),(308422,8568,'af','Algemene boodskap word gewys op elkeen se tuisblad.',0),(308423,8568,'ro','Mesaje generale sunt afiÅŸate pe pagina de pornire fiecÄƒruia.',0),(308424,8568,'et','Ãœldine SÃµnumid kuvatakse igaÃ¼he kodulehele.',0),(308425,8568,'si','SploÅ¡na sporoÄila so prikazani vsi \'s homepage.',0),(308426,8568,'ba','Pesan umum ditampilkan pada homepage semua orang.',0),(308427,8568,'nl','Algemene berichten worden weergegeven op ieders homepage.',0),(308428,8568,'fi','Yleiset viestit nÃ¤kyvÃ¤t kaikkien kotisivulla.',0),(308429,8568,'no','De generelle meldinger vises pÃ¥ alles hjemmeside.',0),(308430,8568,'da','Generelle meddelelser vises pÃ¥ alles hjemmeside.',0),(308431,8568,'ko','ì¼ë°˜ ë©”ì‹œì§€ ëª¨ë‘ì˜ í™ˆíŽ˜ì´ì§€ì— í‘œì‹œ ë©ë‹ˆë‹¤.',0),(308432,8568,'he','×”×•×“×¢×•×ª ×›×œ×œ×™×•×ª ×ž×•×¦×’×™× ×‘×“×£ ×”×‘×™×ª ×©×œ ×›×•×œ×.',0),(308433,8568,'el','Î“ÎµÎ½Î¹ÎºÎ® Î¼Î·Î½ÏÎ¼Î±Ï„Î± ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î·Î½ Î±ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î± Ï„Î¿Ï… ÎºÎ±Î¸ÎµÎ½ÏŒÏ‚.',0),(308434,8568,'zh','ä¸€èˆ¬ä¿¡æ¯æ˜¾ç¤ºåœ¨æ¯ä¸ªäººçš„ä¸»é¡µ',0),(308435,8568,'sv','AllmÃ¤nna meddelanden visas pÃ¥ allas hemsida.',0),(308436,8568,'it','Messaggi generali vengono visualizzati sulla Home page di tutti.',0),(308437,8568,'tl','',0),(308438,8568,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3607;&#3637;&#3656;&#3649;&#3626;&#3604;&#3591;&#3610;&#3609;&#3650;&#3630;&#3617;&#3648;&#3614;&#3592;&#3586;&#3629;&#3591;&#3607;&#3640;&#3585;&#3588;&#3609;',0),(308439,8568,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤¹à¤° à¤•à¤¿à¤¸à¥€ à¤•à¤¾ à¤®à¥à¤–à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤¿à¤ à¤œà¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(308440,8568,'ms','Mesej umum akan dipaparkan di Laman Utama semua orang.',0),(308441,8568,'ar','Ø§Ù„Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ø¹Ø§Ù…Ø© ØªØ¹Ø±Ø¶ ÙÙŠ Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(308442,8568,'fr','Messages gÃ©nÃ©raux sont affichÃ©s sur la page d\'accueil de tout le monde.',0),(308443,8568,'jp','ä¸€èˆ¬çš„ãªãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã¯ã™ã¹ã¦ã®äººã®ãƒ›ãƒ¼ãƒ ãƒšãƒ¼ã‚¸ã«è¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(308444,8568,'pt','Mensagens em geral sÃ£o exibidas na homepage de todos.',0),(308445,8568,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°ÑŽÑ‚ÑÑ Ð½Ð° Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸Ñ… ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ‡ÐºÐ°Ñ… Ð²ÑÐµÑ….',0),(308446,8568,'es','Mensajes generales se deplegan en la pÃ¡gina de casa de Todos',0),(308447,8568,'de','Allgemeine Nachrichten werden auf der Homepage angezeigt.',0),(308448,8568,'en','General messages are displayed on everyone\'s homepage.',0),(308449,8569,'is','',0),(308450,8569,'dr','ÙƒÙ„ÙŠØ¯ ÙƒÙ†ØªØ±Ù„ ÙŠØ§ ÙƒÙ„ÙŠØ¯ Ø´ÙŠÙØª Ø±Ø§ Ù¾Ø§ÙŠÙŠÙ† Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÙŠØ¯  ØªØ§ Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø´Ø®Øµ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(308451,8569,'pr','ÙƒÙ„ÙŠØ¯ ÙƒÙ†ØªØ±Ù„ ÙŠØ§ ÙƒÙ„ÙŠØ¯ Ø´ÙŠÙØª Ø±Ø§ Ù¾Ø§ÙŠÙŠÙ† Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÙŠØ¯  ØªØ§ Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø´Ø®Øµ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(308452,8569,'tr','Ctrl tuÅŸunu veya birden fazla kiÅŸi seÃ§mek iÃ§in Shift tuÅŸunu basÄ±lÄ± tutun.',0),(308453,8569,'pl','Przytrzymaj klawisz Ctrl i klawisz Shift, aby wybraÄ‡ wiÄ™cej niÅ¼ jednÄ… osobÄ™.',0),(308454,8569,'bg','Ð—Ð°Ð´Ñ€ÑŠÐ¶Ñ‚Ðµ Ð½Ð°Ñ‚Ð¸ÑÐ½Ð°Ñ‚ ÐºÐ»Ð°Ð²Ð¸ÑˆÐ° Ctrl Ð¸Ð»Ð¸ Shift ÐºÐ»Ð°Ð²Ð¸ÑˆÐ°, Ð·Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð½Ð¾ Ð»Ð¸Ñ†Ðµ.',0),(308455,8569,'ur','Ctrl Ú©Ø§ Ø¨Ù¹Ù† ÛŒØ§ Ø§ÛŒÚ© Ø³Û’ Ø²Ø§Ø¦Ø¯ Ø´Ø®Øµ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Shift Ú©Ù„ÛŒØ¯ Ø¯Ø¨Ø§ Ø±Ú©Ú¾ÛŒÚº Û”',0),(308456,8569,'sr','Ð”Ñ€Ð¶Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸Ñ‚Ð¸ÑÐ½ÑƒÑ‚ Ñ‚Ð°ÑÑ‚ÐµÑ€ Ð¦Ñ‚Ñ€Ð» Ð¸Ð»Ð¸ Ñ‚Ð°ÑÑ‚ÐµÑ€ Ð¡Ñ…Ð¸Ñ„Ñ‚ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸ Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ñ˜ÐµÐ´Ð½Ðµ Ð¾ÑÐ¾Ð±Ðµ.',0),(308457,8569,'vi','Nháº¥n Ctrl hay Shift Ä‘á»ƒ chá»n hÆ¡n 1 ngÆ°á»i',0),(308458,8569,'af','Hou die Ctrl sleutel of Shift sleutel in om meer as een persoon te selekteer',0),(308459,8569,'ro','Å¢ineÅ£i apÄƒsatÄƒ tasta Ctrl sau Shift cheie pentru a selecta mai multe persoane.',0),(308460,8569,'et','Hoidke all klahvi Ctrl vÃµi Shift klahvi, et valida rohkem kui Ã¼ks inimene.',0),(308461,8569,'si','DrÅ¾ite tipko Ctrl ali tipko Shift, Äe Å¾elite izbrati veÄ kot eno osebo.',0),(308462,8569,'ba','Tahan tombol Ctrl atau Shift kunci untuk memilih lebih dari satu orang.',0),(308463,8569,'nl','Houd de Ctrl-toets of de Shift-toets ingedrukt om meer dan Ã©Ã©n persoon.',0),(308464,8569,'fi','PidÃ¤ Ctrl-nÃ¤ppÃ¤intÃ¤ tai VAIHTO-nÃ¤ppÃ¤intÃ¤ ja valitse useampi kuin yksi henkilÃ¶.',0),(308465,8569,'no','Hold nede Ctrl-tasten eller SKIFT-tasten for Ã¥ velge mer enn Ã©n person.',0),(308466,8569,'da','Hold Ctrl-tasten eller Shift-tasten til at vÃ¦lge mere end Ã©n person.',0),(308467,8569,'ko','Ctrl í‚¤ ë˜ëŠ” ë‘˜ ì´ìƒì˜ ì‚¬ëžŒì„ ì„ íƒ í•˜ë ¤ë©´ Shift í‚¤ë¥¼ ëˆ„ë¥´ì‹­ì‹œì˜¤.',0),(308468,8569,'he','×”×—×–×§ ××ª ×ž×§×© Ctrl ××• shift ×›×“×™ ×œ×‘×—×•×¨ ××“× ××—×“ ××• ×™×•×ª×¨.',0),(308469,8569,'el','ÎšÏÎ±Ï„Î®ÏƒÏ„Îµ Ï€Î±Ï„Î·Î¼Î­Î½Î¿ Ï„Î¿ Ï€Î»Î®ÎºÏ„ÏÎ¿ Ctrl Î® Ï„Î¿ Ï€Î»Î®ÎºÏ„ÏÎ¿ Shift Î³Î¹Î± Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ± Î±Ï€ÏŒ Î­Î½Î± Î¬Ï„Î¿Î¼Î±.',0),(308470,8569,'zh','æŒ‰ä½Ctrlé”®å’ŒShifté”®é€‰æ‹©çš„ä¸æ­¢ä¸€ä¸ªäººæŽ§åˆ¶çš„å…³é”®ã€‚\r\n',0),(308471,8569,'sv','HÃ¥ll ner Ctrl-tangenten eller skifttangenten fÃ¶r att markera fler Ã¤n en person.',0),(308472,8569,'it','Tenere premuto il tasto Ctrl o il tasto MAIUSC per selezionare piÃ¹ di una persona.',0),(308473,8569,'tl','',0),(308474,8569,'th','Hold down the Ctrl key or Shift key to select more than one person.',0),(308475,8569,'hi','à¤¨à¥€à¤šà¥‡ Ctrl à¤•à¥à¤‚à¤œà¥€ à¤¯à¤¾ à¤à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤µà¥à¤¯à¤•à¥à¤¤à¤¿ à¤•à¥‹ à¤šà¥à¤¨à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ Shift à¤•à¥à¤‚à¤œà¥€ à¤¦à¤¬à¤¾à¤ à¤°à¤–à¥‡à¤‚à¥¤',0),(308476,8569,'ms','Tahan ke bawah kekunci Ctrl dan kekunci Shift untuk memilih lebih daripada satu orang.',0),(308477,8569,'ar','Ø§Ø¶ØºØ· Ø¨Ø§Ø³ØªÙ…Ø±Ø§Ø± Ø¹Ù„Ù‰ Ø§Ù„Ù…ÙØªØ§Ø­ Ctrl Ø£Ùˆ Ù…ÙØªØ§Ø­ Shift Ù„ØªØ­Ø¯ÙŠØ¯ Ø£ÙƒØ«Ø± Ù…Ù† Ø´Ø®Øµ ÙˆØ§Ø­Ø¯.',0),(308478,8569,'fr','Maintenez enfoncÃ©e la touche Ctrl ou la touche Maj pour sÃ©lectionner plusieurs personnes.',0),(308479,8569,'jp','Ctrl ã‚­ãƒ¼ã¾ãŸã¯ Shift ã‚­ãƒ¼ã‚’ 1 äººä»¥ä¸Šé¸æŠžã‚’æŠ¼ã—ãŸã¾ã¾ã«ã—ã¾ã™ã€‚',0),(308480,8569,'pt','Mantenha pressionada a tecla Ctrl ou a tecla Shift para selecionar mais de uma pessoa.',0),(308481,8569,'ru','Ð£Ð´ÐµÑ€Ð¶Ð¸Ð²Ð°Ð¹Ñ‚Ðµ Ð½Ð°Ð¶Ð°Ñ‚Ð¾Ð¹ ÐºÐ»Ð°Ð²Ð¸ÑˆÑƒ Ctrl Ð¸Ð»Ð¸ Shift, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð±Ð¾Ð»ÐµÐµ Ð¾Ð´Ð½Ð¾Ð³Ð¾ Ñ‡ÐµÐ»Ð¾Ð²ÐµÐºÐ°.',0),(308482,8569,'es','Oprimir la tecla Ctrl o Shift para seleccionar mÃ¡s que una persona',0),(308483,8569,'de','Halten Sie die STRG-Taste oder UMSCHALTTASTE gedrÃ¼ckt, um mehr als eine Person zu wÃ¤hlen.',0),(308484,8569,'en','Hold down the Ctrl key or Shift key to select more than one person.',0),(308485,8570,'is','',0),(308486,8570,'dr','Ù…ØªÙ† Ù¾ÙŠØºØ§Ù… ',0),(308487,8570,'pr','Ù…ØªÙ† Ù¾ÙŠØºØ§Ù… ',0),(308488,8570,'tr','Ä°leti gÃ¶vdesi',0),(308489,8570,'pl','TreÅ›Ä‡ wiadomoÅ›ci',0),(308490,8570,'bg','Ð¢ÑÐ»Ð¾Ñ‚Ð¾ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(308491,8570,'ur','Ù¾ÛŒØºØ§Ù… Ú©ÛŒ Ø¨Ø§ÚˆÛŒ',0),(308492,8570,'sr','Ð¢ÐµÐ»Ð¾ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(308493,8570,'vi','Ná»™i dung Tin Nháº¯n',0),(308494,8570,'af','Boodskap \"Body\"',0),(308495,8570,'ro','Corpul mesajului',0),(308496,8570,'et','SÃµnumi tekst',0),(308497,8570,'si','Telo sporoÄila',0),(308498,8570,'ba','Badan pesan',0),(308499,8570,'nl','Hoofdtekst van het bericht',0),(308500,8570,'fi','Viestin teksti',0),(308501,8570,'no','Meldingsteksten',0),(308502,8570,'da','Meddelelsesteksten',0),(308503,8570,'ko','ë©”ì‹œì§€ ë³¸ë¬¸',0),(308504,8570,'he','×’×•×£ ×”×”×•×“×¢×”',0),(308505,8570,'el','Î£ÏŽÎ¼Î± Î¼Î·Î½ÏÎ¼Î±Ï„Î¿Ï‚',0),(308506,8570,'zh','é‚®ä»¶æ­£æ–‡\r\n',0),(308507,8570,'sv','Meddelandetexten',0),(308508,8570,'it','Corpo del messaggio',0),(308509,8570,'tl','',0),(308510,8570,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3627;&#3621;&#3633;&#3585;',0),(308511,8570,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤•à¤¾ à¤®à¥à¤–à¥à¤¯ à¤­à¤¾à¤—',0),(308512,8570,'ms','Badan mesej',0),(308513,8570,'ar','Ù…ØªÙ† Ø§Ù„Ø±Ø³Ø§Ù„Ø©',0),(308514,8570,'fr','Corps du message',0),(308515,8570,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸æœ¬æ–‡',0),(308516,8570,'pt','Corpo da mensagem',0),(308517,8570,'ru','Ð¢ÐµÐ»Ð¾ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(308518,8570,'es','Cuerpo de Mensaje',0),(308519,8570,'de','Nachrichtentext',0),(308520,8570,'en','Message Body',0),(308521,8571,'is','',0),(308522,8571,'dr','Ù†ÙˆØ¹ Ù¾ÙŠØºØ§Ù… ',0),(308523,8571,'pr','Ù†ÙˆØ¹ Ù¾ÙŠØºØ§Ù… ',0),(308524,8571,'tr','Ä°leti tÃ¼rÃ¼',0),(308525,8571,'pl','Typ komunikatu',0),(308526,8571,'bg','Ð¢Ð¸Ð¿ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(308527,8571,'ur','Ù¾ÛŒØºØ§Ù… Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª',0),(308528,8571,'sr','Ð¢Ð¸Ð¿ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(308529,8571,'vi','Loáº¡i tin nháº¯n',0),(308530,8571,'af','Boodskaptipe',0),(308531,8571,'ro','Tipul de mesaj',0),(308532,8571,'et','SÃµnumi tÃ¼Ã¼p',0),(308533,8571,'si','Vrsta sporoÄila',0),(308534,8571,'ba','Jenis pesan',0),(308535,8571,'nl','Berichttype',0),(308536,8571,'fi','Viestityyppi',0),(308537,8571,'no','Meldingstypen',0),(308538,8571,'da','Beskedtypen',0),(308539,8571,'ko','ë©”ì‹œì§€ ìœ í˜•',0),(308540,8571,'he','×¡×•×’ ×”×•×“×¢×”',0),(308541,8571,'el','Î¤ÏÏ€Î¿Ï‚ Î¼Î·Î½ÏÎ¼Î±Ï„Î¿Ï‚',0),(308542,8571,'zh','æ¶ˆæ¯ç±»åž‹\r\n',0),(308543,8571,'sv','Meddelandetypen',0),(308544,8571,'it','Tipo di messaggio',0),(308545,8571,'tl','',0),(308546,8571,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(308547,8571,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(308548,8571,'ms','Jenis mesej',0),(308549,8571,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø±Ø³Ø§Ù„Ø©',0),(308550,8571,'fr','Type de message',0),(308551,8571,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®ç¨®é¡ž',0),(308552,8571,'pt','Tipo de mensagem',0),(308553,8571,'ru','Ð¢Ð¸Ð¿ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(308554,8571,'es','Mensaje Tipo',0),(308555,8571,'de','Nachrichtentyp',0),(308556,8571,'en','Message Type',0),(308557,8572,'is','',0),(308558,8572,'dr','Ù¾ÙŠØºØ§Ù…ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯',0),(308559,8572,'pr','Ù¾ÙŠØºØ§Ù…ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯',0),(308560,8572,'tr','SeÃ§ili ileti yok',0),(308561,8572,'pl','Nie wybrana wiadomoÅ›Ä‡',0),(308562,8572,'bg','Ð˜Ð·Ð±Ñ€Ð°Ð½Ð¾ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(308563,8572,'ur','Ú©ÙˆØ¦ÛŒ Ù¾ÛŒØºØ§Ù… Ù…Ù†ØªØ®Ø¨',0),(308564,8572,'sr','Ð˜Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(308565,8572,'vi','ChÆ°a chá»n tin nháº¯n',0),(308566,8572,'af','Geen Boodskap Gekies',0),(308567,8572,'ro','Nici un mesaj selectat',0),(308568,8572,'et','Valitud',0),(308569,8572,'si','Brez sporoÄila izbrali',0),(308570,8572,'ba','Tidak ada pesan yang dipilih',0),(308571,8572,'nl','Geen bericht geselecteerd',0),(308572,8572,'fi','Valittuun viestiin',0),(308573,8572,'no','Ingen melding valgt',0),(308574,8572,'da','Ingen valgte meddelelse',0),(308575,8572,'ko','ì„ íƒí•œ ì—†ìŒ ë©”ì‹œì§€ ì•ŠìŠµë‹ˆë‹¤',0),(308576,8572,'he','×œ× × ×‘×—×¨×” ×”×•×“×¢×”',0),(308577,8572,'el','ÎšÎ±Î½Î­Î½Î± Î¼Î®Î½Ï…Î¼Î± Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(308578,8572,'zh','æ²¡æœ‰å·²é€‰çš„æ¶ˆæ¯\r\n',0),(308579,8572,'sv','Inga brev markerade',0),(308580,8572,'it','Nessun messaggio selezionato',0),(308581,8572,'tl','',0),(308582,8572,'th','&#3652;&#3617;&#3656;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(308583,8572,'hi','à¤•à¥‹à¤ˆ à¤šà¤¯à¤¨à¤¿à¤¤ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(308584,8572,'ms','Tiada mesej dipilih',0),(308585,8572,'ar','Ù„Ù… ØªØ®ØªØ± Ø£ÙŠ Ø±Ø³Ø§Ø¦Ù„',0),(308586,8572,'fr','Aucun Message sÃ©lectionnÃ©',0),(308587,8572,'jp','é¸æŠžã•ã‚ŒãŸãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(308588,8572,'pt','Nenhuma mensagem seleccionada',0),(308589,8572,'ru','ÐÐµÑ‚ Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹',0),(308590,8572,'es','No SeleccionÃ³ Mensaje',0),(308591,8572,'de','Keine Nachricht ausgewÃ¤hlt',0),(308592,8572,'en','No Message Selected',0),(308593,8573,'is','',0),(308594,8573,'dr','Ù†Ø§Ø±Ù†Ø¬ÙŠ ',0),(308595,8573,'pr','Ù†Ø§Ø±Ù†Ø¬ÙŠ ',0),(308596,8573,'tr','Turuncu',0),(308597,8573,'pl','Orange',0),(308598,8573,'bg','ÐžÑ€Ð¸Ð½Ð´Ð¶',0),(308599,8573,'ur','Ù†Ø§Ø±Ù†Ú¯ÛŒ',0),(308600,8573,'sr','ÐžÑ€Ð°Ð½Ð³Ðµ',0),(308601,8573,'vi','MÃ u cam',0),(308602,8573,'af','Oranje',0),(308603,8573,'ro','Orange',0),(308604,8573,'et','Orange',0),(308605,8573,'si','Orange',0),(308606,8573,'ba','Orange',0),(308607,8573,'nl','Orange',0),(308608,8573,'fi','Oranssi',0),(308609,8573,'no','Oransje',0),(308610,8573,'da','Orange',0),(308611,8573,'ko','ì˜¤ë Œì§€',0),(308612,8573,'he','×›×ª×•×',0),(308613,8573,'el','Î Î¿ÏÏ„Î¿ÎºÎ±Î»Î¯',0),(308614,8573,'zh','æ©™\r\n',0),(308615,8573,'sv','Orange',0),(308616,8573,'it','Orange',0),(308617,8573,'tl','',0),(308618,8573,'th','&#3626;&#3637;&#3626;&#3637;&#3617;',0),(308619,8573,'hi','à¤‘à¤°à¥‡à¤‚à¤œ',0),(308620,8573,'ms','Orange',0),(308621,8573,'ar','Ø¨Ø±ØªÙ‚Ø§Ù„ÙŠ',0),(308622,8573,'fr','Orange',0),(308623,8573,'jp','ã‚ªãƒ¬ãƒ³ã‚¸',0),(308624,8573,'pt','Laranja',0),(308625,8573,'ru','ÐžÑ€Ð°Ð½Ð¶ÐµÐ²Ñ‹Ð¹',0),(308626,8573,'es','Naranja',0),(308627,8573,'de','Orange',0),(308628,8573,'en','Orange',0),(308629,8574,'is','',0),(308630,8574,'dr','Ø´Ø®ØµÙŠ',0),(308631,8574,'pr','Ø´Ø®ØµÙŠ',0),(308632,8574,'tr','KiÅŸisel',0),(308633,8574,'pl','Osobiste',0),(308634,8574,'bg','Ð›Ð¸Ñ‡Ð½Ð¸',0),(308635,8574,'ur','Ø°Ø§ØªÛŒ',0),(308636,8574,'sr','Ð›Ð¸Ñ‡Ð½Ðµ',0),(308637,8574,'vi','CÃ¡ nhÃ¢n',0),(308638,8574,'af','Personeel',0),(308639,8574,'ro','Personale',0),(308640,8574,'et','Isiklikku',0),(308641,8574,'si','Osebni',0),(308642,8574,'ba','Pribadi',0),(308643,8574,'nl','Persoonlijke',0),(308644,8574,'fi','HenkilÃ¶kohtainen',0),(308645,8574,'no','Personlig',0),(308646,8574,'da','Personlige',0),(308647,8574,'ko','ê°œì¸',0),(308648,8574,'he','××™×©×™',0),(308649,8574,'el','Î ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ®',0),(308650,8574,'zh','ä¸ªäºº\r\n',0),(308651,8574,'sv','Personliga',0),(308652,8574,'it','Personale',0),(308653,8574,'tl','',0),(308654,8574,'th','&#3626;&#3656;&#3623;&#3609;&#3610;&#3640;&#3588;&#3588;&#3621;',0),(308655,8574,'hi','à¤µà¥à¤¯à¤•à¥à¤¤à¤¿à¤—à¤¤',0),(308656,8574,'ms','Peribadi',0),(308657,8574,'ar','Ø´Ø®ØµÙŠ',0),(308658,8574,'fr','Personnels',0),(308659,8574,'jp','å€‹äººçš„ã§ã™',0),(308660,8574,'pt','Pessoal',0),(308661,8574,'ru','Ð›Ð¸Ñ‡Ð½Ñ‹Ðµ',0),(308662,8574,'es','Personal',0),(308663,8574,'de','PersÃ¶nliche',0),(308664,8574,'en','Personal',0),(308665,8575,'is','',0),(308666,8575,'dr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ÙŠ Ø®ØµÙˆØµÙŠ ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª ÙƒÙ†Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®Ø§Øµ Ù‡Ø³ØªÙ†Ø¯ ',0),(308667,8575,'pr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ÙŠ Ø®ØµÙˆØµÙŠ ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØª ÙƒÙ†Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ Ø®Ø§Øµ Ù‡Ø³ØªÙ†Ø¯ ',0),(308668,8575,'tr','KiÅŸisel iletiler yalnÄ±zca belirli alÄ±cÄ±lar iÃ§in vardÄ±r.',0),(308669,8575,'pl','Osobisty wiadomoÅ›ci sÄ… tylko dla konkretnych odbiorcÃ³w.',0),(308670,8575,'bg','Ð›Ð¸Ñ‡Ð½Ð¸ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ ÑÐ° ÑÐ°Ð¼Ð¾ Ð·Ð° ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»Ð¸.',0),(308671,8575,'ur','Ø°Ø§ØªÛŒ Ù¾ÛŒØºØ§Ù…Ø§Øª ØµØ±Ù Ù…Ø®ØµÙˆØµ ÙˆØµÙˆÙ„ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† Ú©Û’ Ù„Ø¦Û’ ÛÛŒÚº Û”',0),(308672,8575,'sr','Ð›Ð¸Ñ‡Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÐºÐµ ÑÑƒ ÑÐ°Ð¼Ð¾ Ð·Ð° Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐµ.',0),(308673,8575,'vi','Tin nháº¯n cÃ¡ nháº­n chá»‰ dÃ nh cho ngÆ°á»i nháº­n cá»¥ thá»ƒ',0),(308674,8575,'af','Persoonlike boodskappe is alleenlik vir spesifieke ontvangers.',0),(308675,8575,'ro','Mesajele personale sunt numai pentru anumiÅ£i destinatari.',0),(308676,8575,'et','Isiklikud sÃµnumid on ainult nende adressaatidega.',0),(308677,8575,'si','Osebna sporoÄila so samo za posebne prejemnike.',0),(308678,8575,'ba','Pesan pribadi adalah hanya untuk penerima tertentu.',0),(308679,8575,'nl','Persoonlijke berichten zijn alleen voor specifieke geadresseerden.',0),(308680,8575,'fi','HenkilÃ¶kohtaiset viestit ovat vain tietyille vastaanottajille.',0),(308681,8575,'no','Personlige meldinger er bare for bestemte mottakere.',0),(308682,8575,'da','Personlige meddelelser er kun for bestemte modtagere.',0),(308683,8575,'ko','ê°œì¸ ë©”ì‹œì§€ëŠ” íŠ¹ì • ë°›ëŠ” ì‚¬ëžŒì— ëŒ€í•´ì„œë§Œ ë©ë‹ˆë‹¤.',0),(308684,8575,'he','×”×•×“×¢×•×ª ××™×©×™×•×ª ×”× ×¨×§ ×¢×‘×•×¨ × ×ž×¢× ×™× ×¡×¤×¦×™×¤×™×™×.',0),(308685,8575,'el','Î ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ¬ Î¼Î·Î½ÏÎ¼Î±Ï„Î± ÎµÎ¯Î½Î±Î¹ Î¼ÏŒÎ½Î¿ Î³Î¹Î± ÎµÎ¹Î´Î¹ÎºÎ¿ÏÏ‚ Î´Î¹ÎºÎ±Î¹Î¿ÏÏ‡Î¿Ï…Ï‚.',0),(308686,8575,'zh','ä¸ªäººä¿¡æ¯åªå¯¹ç‰¹å®šçš„æ”¶ä»¶äººã€‚\r\n',0),(308687,8575,'sv','Personliga meddelanden Ã¤r endast fÃ¶r sÃ¤rskilda mottagare.',0),(308688,8575,'it','I messaggi personali sono solo per destinatari specifici.',0),(308689,8575,'tl','',0),(308690,8575,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3626;&#3656;&#3623;&#3609;&#3610;&#3640;&#3588;&#3588;&#3621;&#3607;&#3637;&#3656;&#3619;&#3632;&#3610;&#3640;&#3612;&#3641;&#3657;&#3619;&#3633;&#3610;',0),(308691,8575,'hi','à¤µà¥à¤¯à¤•à¥à¤¤à¤¿à¤—à¤¤ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤•à¥‡à¤µà¤² à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(308692,8575,'ms','Mesej peribadi adalah hanya untuk penerima tertentu.',0),(308693,8575,'ar','Ø§Ù„Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ø´Ø®ØµÙŠØ© Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ù…Ø­Ø¯Ø¯ÙŠÙ† ÙÙ‚Ø·',0),(308694,8575,'fr','Messages personnels sont uniquement pour des destinataires spÃ©cifiques.',0),(308695,8575,'jp','å€‹äººçš„ãªãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã¯ã€ç‰¹å®šã®å—ä¿¡è€…ã®ã¿ã§ã™ã€‚',0),(308696,8575,'pt','Mensagens pessoais sÃ£o apenas para destinatÃ¡rios especÃ­ficos.',0),(308697,8575,'ru','Ð›Ð¸Ñ‡Ð½Ñ‹Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ñ‹Ñ… Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»ÐµÐ¹.',0),(308698,8575,'es','Mensajes personales estan solamente para recipientes especificos',0),(308699,8575,'de','PersÃ¶nliche Nachrichten sind nur fÃ¼r bestimmte EmpfÃ¤nger.',0),(308700,8575,'en','Personal messages are only for specific recipients.',0),(308701,8576,'is','',0),(308702,8576,'dr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ù¾Ø³Øª ',0),(308703,8576,'pr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ÙŠ Ù¾Ø³Øª ',0),(308704,8576,'tr','Mesaj tarihleri',0),(308705,8576,'pl','Po datach',0),(308706,8576,'bg','ÐŸÐ¾ÑÑ‚ Ð´Ð°Ñ‚Ð¸',0),(308707,8576,'ur','Ù¾ÙˆØ³Ù¹ ØªØ§Ø±ÛŒØ®ÛŒÚº',0),(308708,8576,'sr','ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼Ðµ',0),(308709,8576,'vi','NgÃ y Káº¿t chuyá»ƒn ',0),(308710,8576,'af','Pos Datums',0),(308711,8576,'ro','Posta dvs.',0),(308712,8576,'et','Post kuupÃ¤evad',0),(308713,8576,'si','Post datumi',0),(308714,8576,'ba','Tanggal posting',0),(308715,8576,'nl','Postdata',0),(308716,8576,'fi','JÃ¤lkeen pÃ¤ivinÃ¤',0),(308717,8576,'no','Post datoer',0),(308718,8576,'da','Post datoer',0),(308719,8576,'ko','ê²Œì‹œ ë‚ ì§œ',0),(308720,8576,'he','×¤×•×¡×˜ ×ª××¨×™×›×™×',0),(308721,8576,'el','Î”Î·Î¼Î¿ÏƒÎ¯ÎµÏ…ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(308722,8576,'zh','å‘å¸ƒæ—¥æœŸ\r\n',0),(308723,8576,'sv','BokfÃ¶r datum',0),(308724,8576,'it','Post date',0),(308725,8576,'tl','',0),(308726,8576,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(308727,8576,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(308728,8576,'ms','Tarikh Post',0),(308729,8576,'ar','ÙØªØ±Ø© Ø§Ù„Ø¥Ø±Ø³Ø§Ù„/Ø§Ù„Ø¥Ø¹Ù„Ø§Ù†',0),(308730,8576,'fr','Dates de la poste',0),(308731,8576,'jp','è¨˜äº‹ã®æ—¥ä»˜',0),(308732,8576,'pt','Datas de postagem',0),(308733,8576,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾ÑÑ‚ÑŒ Ð´Ð°Ñ‚Ñ‹',0),(308734,8576,'es','Fechas de Asentar',0),(308735,8576,'de','Post-Daten',0),(308736,8576,'en','Post Dates',0),(308737,8577,'is','',0),(308738,8577,'dr','Ø¨Ù†ÙØ´ ',0),(308739,8577,'pr','Ø¨Ù†ÙØ´ ',0),(308740,8577,'tr','Mor',0),(308741,8577,'pl','Fioletowy',0),(308742,8577,'bg','Ð›Ð¸Ð»Ð°Ð²Ð¾',0),(308743,8577,'ur','Ø¬Ø§Ù…Ù†ÛŒ',0),(308744,8577,'sr','ÐŸÑƒÑ€Ð¿ÑƒÑ€Ð½Ð¸',0),(308745,8577,'vi','TÃ­m',0),(308746,8577,'af','Pers',0),(308747,8577,'ro','Violet',0),(308748,8577,'et','Lilla',0),(308749,8577,'si','VijoliÄna',0),(308750,8577,'ba','Ungu',0),(308751,8577,'nl','Paars',0),(308752,8577,'fi','Violetti',0),(308753,8577,'no','Lilla',0),(308754,8577,'da','Lilla',0),(308755,8577,'ko','ë³´ë¼ìƒ‰',0),(308756,8577,'he','×¡×’×•×œ',0),(308757,8577,'el','ÎœÏ‰Î²',0),(308758,8577,'zh','ç´«\r\n',0),(308759,8577,'sv','Lila',0),(308760,8577,'it','Viola',0),(308761,8577,'tl','',0),(308762,8577,'th','&#3626;&#3637;&#3617;&#3656;&#3623;&#3591;',0),(308763,8577,'hi','à¤¬à¥ˆà¤‚à¤—à¤¨à¥€',0),(308764,8577,'ms','Ungu',0),(308765,8577,'ar','Ø¨Ù†ÙØ³Ø¬ÙŠ',0),(308766,8577,'fr','Purple',0),(308767,8577,'jp','ç´«è‰²',0),(308768,8577,'pt','Roxo',0),(308769,8577,'ru','Ð¤Ð¸Ð¾Ð»ÐµÑ‚Ð¾Ð²Ñ‹Ð¹',0),(308770,8577,'es','PÃºrpura',0),(308771,8577,'de','Lila',0),(308772,8577,'en','Purple',0),(308773,8578,'is','',0),(308774,8578,'dr',' ÙˆØµÙˆÙ„ Ú©Ù†Ù†Ø¯Ù‡',0),(308775,8578,'pr',' ÙˆØµÙˆÙ„ Ú©Ù†Ù†Ø¯Ù‡',0),(308776,8578,'tr','AlÄ±cÄ±lar',0),(308777,8578,'pl','OdbiorcÃ³w',0),(308778,8578,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ',0),(308779,8578,'ur','ÙˆØµÙˆÙ„ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù†',0),(308780,8578,'sr','ÐŸÑ€Ð¸Ð¼Ð°Ð¾Ñ†Ð¸',0),(308781,8578,'vi','NgÆ°á»i nháº­n',0),(308782,8578,'af','Ontvangers',0),(308783,8578,'ro','Destinatarii',0),(308784,8578,'et','Saajad',0),(308785,8578,'si','Prejemniki',0),(308786,8578,'ba','Penerima',0),(308787,8578,'nl','Geadresseerden',0),(308788,8578,'fi','Vastaanottajat',0),(308789,8578,'no','Mottakere',0),(308790,8578,'da','Modtagere',0),(308791,8578,'ko','ë°›ëŠ” ì‚¬ëžŒ',0),(308792,8578,'he','× ×ž×¢× ×™×',0),(308793,8578,'el','Î Î±ÏÎ±Î»Î®Ï€Ï„ÎµÏ‚',0),(308794,8578,'zh','æ”¶ä»¶äºº\r\n',0),(308795,8578,'sv','Mottagare',0),(308796,8578,'it','Destinatari',0),(308797,8578,'tl','',0),(308798,8578,'th','&#3612;&#3641;&#3657;&#3619;&#3633;&#3610;',0),(308799,8578,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤•à¤°à¥à¤¤à¤¾',0),(308800,8578,'ms','Penerima',0),(308801,8578,'ar','Ø§Ù„Ù…Ø³ØªÙ„Ù…ÙˆÙ†',0),(308802,8578,'fr','Destinataires',0),(308803,8578,'jp','å—ä¿¡è€…',0),(308804,8578,'pt','DestinatÃ¡rios',0),(308805,8578,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»Ð¸',0),(308806,8578,'es','Recipientes',0),(308807,8578,'de','EmpfÃ¤nger',0),(308808,8578,'en','Recipients',0),(308809,8579,'is','',0),(308810,8579,'dr','Ù‚Ø±Ù…Ø² ',0),(308811,8579,'pr','Ù‚Ø±Ù…Ø² ',0),(308812,8579,'tr','KÄ±rmÄ±zÄ±',0),(308813,8579,'pl','Czerwony',0),(308814,8579,'bg','Ð§ÐµÑ€Ð²ÐµÐ½',0),(308815,8579,'ur','Ø³Ø±Ø®',0),(308816,8579,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸',0),(308817,8579,'vi','Äá»',0),(308818,8579,'af','Rooi',0),(308819,8579,'ro','Red',0),(308820,8579,'et','Punane',0),(308821,8579,'si','RdeÄa',0),(308822,8579,'ba','Merah',0),(308823,8579,'nl','Red',0),(308824,8579,'fi','Punainen',0),(308825,8579,'no','RÃ¸d',0),(308826,8579,'da','RÃ¸d',0),(308827,8579,'ko','ë ˆë“œ',0),(308828,8579,'he','××“×•×',0),(308829,8579,'el','ÎšÏŒÎºÎºÎ¹Î½Î¿',0),(308830,8579,'zh','çº¢\r\n',0),(308831,8579,'sv','RÃ¶d',0),(308832,8579,'it','Rosso',0),(308833,8579,'tl','',0),(308834,8579,'th','&#3626;&#3637;&#3649;&#3604;&#3591;',0),(308835,8579,'hi','à¤²à¤¾à¤²',0),(308836,8579,'ms','Merah',0),(308837,8579,'ar','Ø£Ø­Ù…Ø±',0),(308838,8579,'fr','Rouge',0),(308839,8579,'jp','èµ¤',0),(308840,8579,'pt','Vermelho',0),(308841,8579,'ru','ÐšÑ€Ð°ÑÐ½Ñ‹Ð¹',0),(308842,8579,'es','Rojo',0),(308843,8579,'de','Rot',0),(308844,8579,'en','Red',0),(308845,8580,'is','',0),(308846,8580,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(308847,8580,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(308848,8580,'tr','BaÅŸarÄ±yla kaydedildi',0),(308849,8580,'pl','Zapisane',0),(308850,8580,'bg','Ð—Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(308851,8580,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§',0),(308852,8580,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(308853,8580,'vi','Sao lÆ°u thÃ nh cÃ´ng',0),(308854,8580,'af','Suksesvol Gestoor',0),(308855,8580,'ro','Salvat cu succes',0),(308856,8580,'et','Salvestati edukalt',0),(308857,8580,'si','UspeÅ¡no shranjen',0),(308858,8580,'ba','Menyelamatkan berhasil',0),(308859,8580,'nl','Succesvol opgeslagen',0),(308860,8580,'fi','Tallennettu',0),(308861,8580,'no','Lagret',0),(308862,8580,'da','Gemt med succes',0),(308863,8580,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(308864,8580,'he','× ×©×ž×¨ ×‘×”×¦×œ×—×”',0),(308865,8580,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(308866,8580,'zh','ä¿å­˜æˆåŠŸ\r\n',0),(308867,8580,'sv','Sparats',0),(308868,8580,'it','Salvato correttamente',0),(308869,8580,'tl','',0),(308870,8580,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;&#3649;&#3621;&#3657;&#3623;',0),(308871,8580,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(308872,8580,'ms','Berjaya disimpan',0),(308873,8580,'ar','Ø­ÙØ¸Øª Ø¨Ù†Ø¬Ø§Ø­',0),(308874,8580,'fr','EnregistrÃ© avec succÃ¨s',0),(308875,8580,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(308876,8580,'pt','Salvo com sucesso',0),(308877,8580,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¾',0),(308878,8580,'es','Guardado Exitosamente',0),(308879,8580,'de','Erfolgreich gespeichert',0),(308880,8580,'en','Saved Successfully',0),(308881,8581,'is','',0),(308882,8581,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ù…ÙˆØ¯Ø§Ø±',0),(308883,8581,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ù…ÙˆØ¯Ø§Ø±',0),(308884,8581,'tr','GrafiÄŸi seÃ§in',0),(308885,8581,'pl','Zaznacz grafikÄ™',0),(308886,8581,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(308887,8581,'ur','Ú¯Ø±Ø§ÙÛŒ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(308888,8581,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÑƒ',0),(308889,8581,'vi','Chá»n Äá»“ há»a ',0),(308890,8581,'af','Kies Grafika',0),(308891,8581,'ro','SelectaÅ£i grafice',0),(308892,8581,'et','Valige pilt',0),(308893,8581,'si','Izberite grafiko',0),(308894,8581,'ba','Pilih grafis',0),(308895,8581,'nl','Selecteer afbeelding',0),(308896,8581,'fi','Valitse grafiikka',0),(308897,8581,'no','Velg grafikken',0),(308898,8581,'da','VÃ¦lg grafik',0),(308899,8581,'ko','ê·¸ëž˜í”½ ì„ íƒ',0),(308900,8581,'he','×‘×—×¨ ××™×•×¨',0),(308901,8581,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ Î³ÏÎ±Ï†Î¹ÎºÏŒ',0),(308902,8581,'zh','é€‰æ‹©å›¾æ¡ˆ\r\n',0),(308903,8581,'sv','Markera bild',0),(308904,8581,'it','Selezionare il grafico',0),(308905,8581,'tl','',0),(308906,8581,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;',0),(308907,8581,'hi','à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(308908,8581,'ms','Pilih grafik',0),(308909,8581,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø±Ø³Ù…',0),(308910,8581,'fr','SÃ©lectionnez graphique',0),(308911,8581,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã‚’é¸æŠžã—ã¾ã™',0),(308912,8581,'pt','Selecione o grÃ¡fico',0),(308913,8581,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð“Ñ€Ð°Ñ„Ð¸ÐºÑƒ',0),(308914,8581,'es','Seleccionar GrÃ¡fica',0),(308915,8581,'de','WÃ¤hlen Sie Grafik',0),(308916,8581,'en','Select Graphic',0),(308917,8582,'is','',0),(308918,8582,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ù†ÙŠØ³Øª ',0),(308919,8582,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ù†ÙŠØ³Øª ',0),(308920,8582,'tr','Veri alÄ±namÄ±yor',0),(308921,8582,'pl','Nie moÅ¼na pobraÄ‡ danych',0),(308922,8582,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ Ð´Ð°Ð½Ð½Ð¸',0),(308923,8582,'ur','Ú©ÙˆØ§Ø¦Ù Ø¨Ø§Ø² Ú¯ÛŒØ± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(308924,8582,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(308925,8582,'vi','KhÃ´ng truy váº¥n Ä‘Æ°á»£c dá»¯ liá»‡u',0),(308926,8582,'af','Kan nie Data herwin nie',0),(308927,8582,'ro','Imposibil de regÄƒsit date',0),(308928,8582,'et','Andmeid ei saa tuua',0),(308929,8582,'si','Ni mogoÄe pridobiti podatkov',0),(308930,8582,'ba','Mampu mengambil Data',0),(308931,8582,'nl','Unable to Retrieve Data',0),(308932,8582,'fi','Tietoja ei voi noutaa',0),(308933,8582,'no','Kan ikke hente Data',0),(308934,8582,'da','Stand til at hente Data',0),(308935,8582,'ko','ë°ì´í„°ë¥¼ ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(308936,8582,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ××—×–×¨ × ×ª×•× ×™×',0),(308937,8582,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(308938,8582,'zh','æ— æ³•æ£€ç´¢æ•°æ®\r\n',0),(308939,8582,'sv','Det gick inte att hÃ¤mta Data',0),(308940,8582,'it','Impossibile recuperare i dati',0),(308941,8582,'tl','',0),(308942,8582,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3585;&#3641;&#3657;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3652;&#3604;&#3657;',0),(308943,8582,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(308944,8582,'ms','Tidak dapat mendapatkan semula Data',0),(308945,8582,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¬Ù„Ø¨ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(308946,8582,'fr','Impossible de rÃ©cupÃ©rer les donnÃ©es',0),(308947,8582,'jp','ãƒ‡ãƒ¼ã‚¿ã‚’å–å¾—ã§ãã¾ã›ã‚“ã€‚',0),(308948,8582,'pt','NÃ£o Ã© possÃ­vel recuperar dados',0),(308949,8582,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(308950,8582,'es','No se Puede Recuperar Datos',0),(308951,8582,'de','Nicht in der Lage zum Abrufen von Daten',0),(308952,8582,'en','Unable to Retrieve Data',0),(308953,8583,'is','',0),(308954,8583,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ù¾ÙŠØºØ§Ù… Ù†ÙŠØ³Øª ',0),(308955,8583,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ù¾ÙŠØºØ§Ù… Ù†ÙŠØ³Øª ',0),(308956,8583,'tr','Ä°leti alÄ±namÄ±yor',0),(308957,8583,'pl','Nie moÅ¼na pobraÄ‡ wiadomoÅ›ci',0),(308958,8583,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(308959,8583,'ur','Ù¾ÛŒØºØ§Ù… Ø¨Ø§Ø²Ú¯ÛŒØ± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(308960,8583,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ð¾Ñ€ÑƒÐºÑƒ',0),(308961,8583,'vi','KhÃ´ng truy váº¥n Ä‘Æ°á»£c tin nháº¯n',0),(308962,8583,'af','Onbevoeg om Boodskappe te Herwin',0),(308963,8583,'ro','Imposibil de regÄƒsit mesaj',0),(308964,8583,'et','Ei saa tuua sÃµnumi',0),(308965,8583,'si','NezmoÅ¾en v reÅ¡itev sporoÄilo',0),(308966,8583,'ba','Mampu mengambil pesan',0),(308967,8583,'nl','Unable to Retrieve bericht',0),(308968,8583,'fi','Ei voi noutaa viestin',0),(308969,8583,'no','Kan ikke hente melding',0),(308970,8583,'da','AfskÃ¥ret fra Apportere besked',0),(308971,8583,'ko','ë©”ì‹œì§€ë¥¼ ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(308972,8583,'he','×œ× × ×™×ª×Ÿ ×œ××—×–×¨ ××ª ×”×”×•×“×¢×”',0),(308973,8583,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Î¼Î·Î½ÏÎ¼Î±Ï„Î¿Ï‚',0),(308974,8583,'zh','æ— æ³•æ£€ç´¢ä¿¡æ¯\r\n',0),(308975,8583,'sv','Det gick inte att hÃ¤mta meddelande',0),(308976,8583,'it','Impossibile recuperare il messaggio',0),(308977,8583,'tl','',0),(308978,8583,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3585;&#3641;&#3657;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3652;&#3604;&#3657;',0),(308979,8583,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(308980,8583,'ms','Tidak dapat mendapatkan semula mesej',0),(308981,8583,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¬Ù„Ø¨ Ø§Ù„Ø±Ø³Ø§Ù„Ø©',0),(308982,8583,'fr','Impossible de rÃ©cupÃ©rer le Message',0),(308983,8583,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’å–å¾—ã§ãã¾ã›ã‚“ã€‚',0),(308984,8583,'pt','NÃ£o Ã© possÃ­vel recuperar a mensagem',0),(308985,8583,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð’Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(308986,8583,'es','No se Puede Recuperar Mensaje',0),(308987,8583,'de','Keine Nachricht abrufen',0),(308988,8583,'en','Unable to Retrieve Message',0),(308989,8584,'is','',0),(308990,8584,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ù¾ÙŠØºØ§Ù… Ù‡Ø§ Ù†ÙŠØ³Øª',0),(308991,8584,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ù¾ÙŠØºØ§Ù… Ù‡Ø§ Ù†ÙŠØ³Øª',0),(308992,8584,'tr','Ä°leti alÄ±namÄ±yor',0),(308993,8584,'pl','Nie moÅ¼na pobraÄ‡ wiadomoÅ›ci',0),(308994,8584,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(308995,8584,'ur','Ù¾ÛŒØºØ§Ù… Ø¨Ø§Ø²Ú¯ÛŒØ± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(308996,8584,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(308997,8584,'vi','KhÃ´ng truy váº¥n Ä‘Æ°á»£c tin nháº¯n',0),(308998,8584,'af','Onbevoeg om Boodskappe te Herwin',0),(308999,8584,'ro','Imposibilitatea de a prelua mesajele',0),(309000,8584,'et','Ei saa alla laadida sÃµnumid',0),(309001,8584,'si','Ni mogoÄe pridobiti sporoÄila',0),(309002,8584,'ba','Mampu mengambil pesan',0),(309003,8584,'nl','Unable to Retrieve berichten',0),(309004,8584,'fi','Ei voi noutaa viestit',0),(309005,8584,'no','Kan ikke hente meldinger',0),(309006,8584,'da','Kunne ikke hente meddelelser',0),(309007,8584,'ko','ë©”ì‹œì§€ë¥¼ ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(309008,8584,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ××—×–×¨ ×”×•×“×¢×•×ª',0),(309009,8584,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î»Î®ÏˆÎ· Î¼Î·Î½Ï…Î¼Î¬Ï„Ï‰Î½',0),(309010,8584,'zh','æ— æ³•æ£€ç´¢é‚®ä»¶\r\n',0),(309011,8584,'sv','Det gick inte att hÃ¤mta meddelanden',0),(309012,8584,'it','Impossibile recuperare i messaggi',0),(309013,8584,'tl','',0),(309014,8584,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3585;&#3641;&#3657;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3652;&#3604;&#3657;',0),(309015,8584,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‹ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(309016,8584,'ms','Tidak dapat mendapatkan semula mesej',0),(309017,8584,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¬Ù„Ø¨ Ø§Ù„Ø±Ø³Ø§Ø¦Ù„',0),(309018,8584,'fr','Impossible de rÃ©cupÃ©rer les Messages',0),(309019,8584,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’å–å¾—ã™ã‚‹ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(309020,8584,'pt','NÃ£o Ã© possÃ­vel recuperar mensagens',0),(309021,8584,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð’Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(309022,8584,'es','No se Puede Recuperar Mensajes',0),(309023,8584,'de','Nicht in der Lage, Nachrichten abrufen',0),(309024,8584,'en','Unable to Retrieve Messages',0),(309025,8585,'is','',0),(309026,8585,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ú¯ÙŠØ±Ù†Ø¯Ù‡ Ù‡Ø§ Ù†ÙŠØ³Øª',0),(309027,8585,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ú¯ÙŠØ±Ù†Ø¯Ù‡ Ù‡Ø§ Ù†ÙŠØ³Øª',0),(309028,8585,'tr','AlÄ±cÄ±lar alÄ±namadÄ±',0),(309029,8585,'pl','Nie moÅ¼na pobraÄ‡ adresatÃ³w',0),(309030,8585,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»Ð¸',0),(309031,8585,'ur','ÙˆØµÙˆÙ„ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† Ú©ÛŒ Ø¨Ø§Ø²ÛŒØ§ÙØª Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(309032,8585,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ðµ',0),(309033,8585,'vi','KhÃ´ng truy váº¥n Ä‘Æ°á»£c ngÆ°á»i nháº­n',0),(309034,8585,'af','Hierwinning van Ontvangers is Onmoontlik',0),(309035,8585,'ro','Imposibil de regÄƒsit destinatari',0),(309036,8585,'et','Ei saa tuua adressaadid',0),(309037,8585,'si','Ni mogoÄe pridobiti prejemniki',0),(309038,8585,'ba','Mampu mengambil Penerima',0),(309039,8585,'nl','Unable to Retrieve ontvangers',0),(309040,8585,'fi','Ei voi noutaa vastaanottajat',0),(309041,8585,'no','Kan ikke hente mottakere',0),(309042,8585,'da','Kunne ikke hente modtagere',0),(309043,8585,'ko','ë°›ëŠ” ì‚¬ëžŒì„ ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(309044,8585,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ××—×–×¨ × ×ž×¢× ×™×',0),(309045,8585,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï€Î±ÏÎ±Î»Î®Ï€Ï„ÎµÏ‚',0),(309046,8585,'zh','æ— æ³•æ£€ç´¢æ”¶ä»¶äºº\r\n',0),(309047,8585,'sv','Det gick inte att hÃ¤mta mottagare',0),(309048,8585,'it','Impossibile recuperare i destinatari',0),(309049,8585,'tl','',0),(309050,8585,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3585;&#3641;&#3657;&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3652;&#3604;&#3657;',0),(309051,8585,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤ªà¥à¤¨à¤ƒ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(309052,8585,'ms','Tidak dapat mendapat semula penerima',0),(309053,8585,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¬Ù„Ø¨ Ø§Ù„Ù…Ø³ØªÙ„Ù…ÙŠÙ†',0),(309054,8585,'fr','Impossible de rÃ©cupÃ©rer les destinataires',0),(309055,8585,'jp','å—ä¿¡è€…ã‚’å–å¾—ã™ã‚‹ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(309056,8585,'pt','NÃ£o Ã© possÃ­vel recuperar os destinatÃ¡rios',0),(309057,8585,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(309058,8585,'es','No se Puede Recuperar Recipientes',0),(309059,8585,'de','Keine EmpfÃ¤nger abrufen',0),(309060,8585,'en','Unable to Retrieve Recipients',0),(309061,8586,'is','',0),(309062,8586,'dr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø± ',0),(309063,8586,'pr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø± ',0),(309064,8586,'tr','KullanÄ±cÄ± mesajlarÄ±',0),(309065,8586,'pl','WiadomoÅ›ci uÅ¼ytkownika',0),(309066,8586,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÑ‚ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(309067,8586,'ur','ØµØ§Ø±Ù Ú©Û’ Ù¾ÛŒØºØ§Ù…Ø§Øª',0),(309068,8586,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(309069,8586,'vi','Tin Nháº¯n NgÆ°á»i Sá»­ Dá»¥ng',0),(309070,8586,'af','Gebruikerboodskappe',0),(309071,8586,'ro','Mesaje utilizator',0),(309072,8586,'et','Kasutaja sÃµnumite',0),(309073,8586,'si','Uporabnik sporoÄila',0),(309074,8586,'ba','Pengguna pesan',0),(309075,8586,'nl','Gebruiker berichten',0),(309076,8586,'fi','Muistiinpanot',0),(309077,8586,'no','Brukermeldinger',0),(309078,8586,'da','Brugeren meddelelser',0),(309079,8586,'ko','ì‚¬ìš©ìž ë©”ì‹œì§€',0),(309080,8586,'he','×”×•×“×¢×•×ª ×ž×©×ª×ž×©',0),(309081,8586,'el','ÎœÎ·Î½ÏÎ¼Î±Ï„Î± Ï„Î¿Ï… Ï‡ÏÎ®ÏƒÏ„Î·',0),(309082,8586,'zh','ç”¨æˆ·æ¶ˆæ¯\r\n',0),(309083,8586,'sv','AnvÃ¤ndare meddelanden',0),(309084,8586,'it','Messaggi utente',0),(309085,8586,'tl','',0),(309086,8586,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(309087,8586,'hi','à¤ªà¥à¤°à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(309088,8586,'ms','Mesej pengguna',0),(309089,8586,'ar','Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(309090,8586,'fr','Messages de l\'utilisateur',0),(309091,8586,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(309092,8586,'pt','UsuÃ¡rio mensagens',0),(309093,8586,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(309094,8586,'es','Mensajes de Usuarios',0),(309095,8586,'de','Nachrichten von Benutzern',0),(309096,8586,'en','User Messages',0),(309097,8587,'is','',0),(309098,8587,'dr','Ø±ÙˆÙŠ Ú¯Ø±Ø§ÙÙŠÙƒ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¢Ù†Ø±Ø§ Ø¨Ù‡ Ù¾ÙŠØºØ§Ù… Ø®ÙˆØ¯  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯\r\n\r\n',0),(309099,8587,'pr','Ø±ÙˆÙŠ Ú¯Ø±Ø§ÙÙŠÙƒ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¢Ù†Ø±Ø§ Ø¨Ù‡ Ù¾ÙŠØºØ§Ù… Ø®ÙˆØ¯  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯\r\n\r\n',0),(309100,8587,'tr','Ä°letinize eklemek iÃ§in grafiÄŸi tÄ±klatÄ±n.',0),(309101,8587,'pl','Kliknij grafikÄ™, aby dodaÄ‡ go do wiadomoÅ›ci.',0),(309102,8587,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°Ñ‚Ð°, Ð·Ð° Ð´Ð° Ð³Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ ÐºÑŠÐ¼ Ð²Ð°ÑˆÐµÑ‚Ð¾ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ.',0),(309103,8587,'ur','ÛŒÛ Ø§Ù¾Ù†Û’ Ù¾ÛŒØºØ§Ù… Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú¯Ø±Ø§ÙÛŒ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(309104,8587,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð³Ñ€Ð°Ñ„Ð¸ÐºÑƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ñƒ Ð¿Ð¾Ñ€ÑƒÐºÑƒ.',0),(309105,8587,'vi','Nháº¥n vÃ o 1 Ä‘á»“ há»a Ä‘á»ƒ thÃªm vÃ o tin nháº¯n cá»§a báº¡n',0),(309106,8587,'af','Kliek op grafika om dit by te voeg by u boodskap.',0),(309107,8587,'ro','FaceÅ£i clic pe un grafic sÄƒ-l adÄƒugaÅ£i la mesaj.',0),(309108,8587,'et','Kliki pildi oma sÃµnumile lisada.',0),(309109,8587,'si','Kliknite na sliko dodati v vaÅ¡e sporoÄilo.',0),(309110,8587,'ba','Klik pada grafik untuk menambahkannya ke pesan Anda.',0),(309111,8587,'nl','Klik op een afbeelding toe te voegen aan uw bericht.',0),(309112,8587,'fi','Klikkaa kuvan lisÃ¤Ã¤minen viestiin.',0),(309113,8587,'no','Klikk pÃ¥ grafikk til meldingen.',0),(309114,8587,'da','Klik pÃ¥ et grafikobjekt for at fÃ¸je det til din besked.',0),(309115,8587,'ko','ë‹¹ì‹ ì˜ ë©”ì‹œì§€ë¥¼ ì¶”ê°€ í•˜ë ¤ë©´ ê·¸ëž˜í”½ì„ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(309116,8587,'he','×œ×—×¥ ×¢×œ ×¤×¨×™×˜ ×’×¨×¤×™×§×” ×›×“×™ ×œ×”×•×¡×™×¤×” ×œ×”×•×“×¢×” ×©×œ×š.',0),(309117,8587,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÎµ Î­Î½Î± Î³ÏÎ±Ï†Î¹ÎºÏŒ Î³Î¹Î± Î½Î± Ï„Î¿ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÏƒÏ„Î¿ Î¼Î®Î½Ï…Î¼Î¬ ÏƒÎ±Ï‚.',0),(309118,8587,'zh','æŒ‰ä¸€ä¸‹å›¾å½¢ï¼Œå°†å…¶æ·»åŠ åˆ°é‚®ä»¶ä¸­ã€‚\r\n',0),(309119,8587,'sv','Klicka pÃ¥ en bild att lÃ¤gga till ditt meddelande.',0),(309120,8587,'it','Fare clic su un elemento grafico per aggiungerlo al tuo messaggio.',0),(309121,8587,'tl','',0),(309122,8587,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3616;&#3634;&#3614;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3614;&#3636;&#3656;&#3617;&#3616;&#3634;&#3614;&#3652;&#3611;&#3607;&#3637;&#3656;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3586;&#3',0),(309123,8587,'hi','à¤¯à¤¹ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤ªà¤•à¥‡ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤• à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚à¥¤',0),(309124,8587,'ms','Klik grafik untuk menambahkannya pada mesej anda.',0),(309125,8587,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø±Ø³Ù… Ù„Ø¥Ø¶Ø§ÙØªÙ‡ Ø¥Ù„Ù‰ Ø§Ù„Ø±Ø³Ø§Ù„Ø© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(309126,8587,'fr','Cliquez sur un graphique ajouter Ã  votre message.',0),(309127,8587,'jp','ã‚ãªãŸã®ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã«è¿½åŠ ã™ã‚‹ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™ã€‚',0),(309128,8587,'pt','Clique em um grÃ¡fico para adicionÃ¡-lo Ã  sua mensagem.',0),(309129,8587,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° Ñ€Ð¸ÑÑƒÐ½Ð¾Ðº, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐµÐ³Ð¾ Ðº Ð²Ð°ÑˆÐµÐ¼Ñƒ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸ÑŽ.',0),(309130,8587,'es','Click sobre la GrÃ¡fica para agregarla a su mensaje',0),(309131,8587,'de','Klicken Sie auf eine Grafik es Ihrer Nachricht hinzu.',0),(309132,8587,'en','Click on a graphic to add it to your message.',0),(309133,8588,'is','',0),(309134,8588,'dr','Ú¯Ø±Ø§ÙÙŠÙƒ Ù‡Ø§ÙŠ Ù¾ÙŠØºØ§Ù… ',0),(309135,8588,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ Ù‡Ø§ÙŠ Ù¾ÙŠØºØ§Ù… ',0),(309136,8588,'tr','Ä°leti grafik',0),(309137,8588,'pl','WiadomoÅ›ci graficzne',0),(309138,8588,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(309139,8588,'ur','Ù¾ÛŒØºØ§Ù… Ú¯Ø±Ø§ÙÚ©Ø³',0),(309140,8588,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐ° Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(309141,8588,'vi','Äá»“ Há»a Tin Nháº¯n',0),(309142,8588,'af','Boodskap Grafies',0),(309143,8588,'ro','Mesaj grafica',0),(309144,8588,'et','SÃµnumi graafika',0),(309145,8588,'si','SporoÄilo grafike',0),(309146,8588,'ba','Pesan grafis',0),(309147,8588,'nl','Bericht afbeeldingen',0),(309148,8588,'fi','Viestin grafiikka',0),(309149,8588,'no','Meldingen grafikk',0),(309150,8588,'da','Besked grafik',0),(309151,8588,'ko','ë©”ì‹œì§€ ê·¸ëž˜í”½',0),(309152,8588,'he','×’×¨×¤×™×§×•×ª ×”×•×“×¢×”',0),(309153,8588,'el','ÎœÎ®Î½Ï…Î¼Î± Î³ÏÎ±Ï†Î¹ÎºÏŽÎ½',0),(309154,8588,'zh','æ¶ˆæ¯å›¾å½¢\r\n',0),(309155,8588,'sv','Meddelandet grafik',0),(309156,8588,'it','Grafica messaggio',0),(309157,8588,'tl','',0),(309158,8588,'th','&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(309159,8588,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤—à¥à¤°à¤¾à¤«à¤¿à¤•à¥à¤¸',0),(309160,8588,'ms','Mesej grafik',0),(309161,8588,'ar','Ø±Ø³ÙˆÙ…Ø§Øª Ø§Ù„Ø±Ø³Ø§Ø¦Ù„',0),(309162,8588,'fr','Message graphique',0),(309163,8588,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã‚¹',0),(309164,8588,'pt','Mensagem grÃ¡fica',0),(309165,8588,'ru','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(309166,8588,'es','GrÃ¡ficas de Mensajes',0),(309167,8588,'de','Message-Grafiken',0),(309168,8588,'en','Message Graphics',0),(309169,8589,'is','',0),(309170,8589,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ú¯Ø±Ø§ÙÙŠÙƒ',0),(309171,8589,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ú¯Ø±Ø§ÙÙŠÙƒ',0),(309172,8589,'tr','Bir grafik seÃ§in',0),(309173,8589,'pl','Wybierz grafikÄ™',0),(309174,8589,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(309175,8589,'ur','Ú¯Ø±Ø§ÙÛŒ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(309176,8589,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÑƒ',0),(309177,8589,'vi','Chá»n 1 Äá»“ há»a ',0),(309178,8589,'af','Kies Grafika ',0),(309179,8589,'ro','SelectaÅ£i un grafic',0),(309180,8589,'et','Valige pilt',0),(309181,8589,'si','Izberite grafiko',0),(309182,8589,'ba','Pilih grafis',0),(309183,8589,'nl','Selecteer een afbeelding',0),(309184,8589,'fi','Valitsee kuvan',0),(309185,8589,'no','Velg grafikk',0),(309186,8589,'da','Marker et grafikobjekt',0),(309187,8589,'ko','ê·¸ëž˜í”½ ì„ íƒ',0),(309188,8589,'he','×‘×—×¨ ××™×•×¨',0),(309189,8589,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Î³ÏÎ±Ï†Î¹ÎºÏŒ',0),(309190,8589,'zh','é€‰æ‹©ä¸€ä¸ªå›¾å½¢\r\n',0),(309191,8589,'sv','VÃ¤lj en bild',0),(309192,8589,'it','Selezionare un elemento grafico',0),(309193,8589,'tl','',0),(309194,8589,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;',0),(309195,8589,'hi','à¤•à¥‹à¤ˆ à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(309196,8589,'ms','Pilih grafik yang',0),(309197,8589,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø±Ø³Ù…',0),(309198,8589,'fr','SÃ©lectionnez un graphique',0),(309199,8589,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã‚’é¸æŠžã—ã¾ã™',0),(309200,8589,'pt','Selecione um grÃ¡fico',0),(309201,8589,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð¾Ð±ÑŠÐµÐºÑ‚',0),(309202,8589,'es','Seleccionar una GrÃ¡fica',0),(309203,8589,'de','WÃ¤hlen Sie eine Grafik',0),(309204,8589,'en','Select a Graphic',0),(309205,8590,'is','',0),(309206,8590,'dr','( Ú¯Ø±Ø§ÙÙ‡Ø§) Ù†ÙŠØ³Øª ',0),(309207,8590,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ Ú¯Ø±Ø§ÙÙŠÙƒ Ù‡Ø§( Ù†Ù…ÙˆØ¯Ø§Ø±Ù‡Ø§) Ù†ÙŠØ³Øª ',0),(309208,8590,'tr','Grafik alÄ±namÄ±yor',0),(309209,8590,'pl','Nie moÅ¼na pobraÄ‡ grafiki',0),(309210,8590,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(309211,8590,'ur','Ú¯Ø±Ø§ÙÚ©Ø³ Ø¨Ø§Ø²Ú¯ÛŒØ± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(309212,8590,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(309213,8590,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘á»“ há»a',0),(309214,8590,'af','Onbevoeg om Grafika te Herwin ',0),(309215,8590,'ro','Imposibil de regÄƒsit grafica',0),(309216,8590,'et','Ei saa tuua graafika',0),(309217,8590,'si','Ni mogoÄe pridobiti grafike',0),(309218,8590,'ba','Mampu mengambil grafis',0),(309219,8590,'nl','Unable to Retrieve Graphics',0),(309220,8590,'fi','Ei voi noutaa grafiikka',0),(309221,8590,'no','Kan ikke hente grafikk',0),(309222,8590,'da','AfskÃ¥ret fra Apportere Graphics',0),(309223,8590,'ko','ê·¸ëž˜í”½ì„ ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(309224,8590,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ××—×–×¨ ×’×¨×¤×™×§×”',0),(309225,8590,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Î³ÏÎ±Ï†Î¹ÎºÏŽÎ½',0),(309226,8590,'zh','æ— æ³•æ£€ç´¢å›¾å½¢\r\n',0),(309227,8590,'sv','Det gick inte att hÃ¤mta grafik',0),(309228,8590,'it','Impossibile recuperare la grafica',0),(309229,8590,'tl','',0),(309230,8590,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3585;&#3641;&#3657;&#3619;&#3641;&#3611;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3585;&#3652;&#3604;&#3657;',0),(309231,8590,'hi','à¤—à¥à¤°à¤¾à¤«à¤¿à¤•à¥à¤¸ à¤•à¥‹ à¤ªà¥à¤¨à¤ƒ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(309232,8590,'ms','Tidak dapat mendapat semula grafik',0),(309233,8590,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¬Ù„Ø¨ Ø§Ù„Ø±Ø³ÙˆÙ…Ø§Øª',0),(309234,8590,'fr','Impossible d\'extraire Graphics',0),(309235,8590,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã‚’å–å¾—ã™ã‚‹ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(309236,8590,'pt','NÃ£o Ã© possÃ­vel recuperar grÃ¡ficos',0),(309237,8590,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ¸',0),(309238,8590,'es','No se Puede Recuperar GrÃ¡ficas',0),(309239,8590,'de','Keine Grafiken abrufen',0),(309240,8590,'en','Unable to Retrieve Graphics',0),(309241,8591,'is','',0),(309242,8591,'dr','ØªØ§Ø±ÙŠØ® Ø¯ÙŠØ¯Ù‡ Ø´Ø¯Ù‡ ',0),(309243,8591,'pr','ØªØ§Ø±ÙŠØ® Ø¯ÙŠØ¯Ù‡ Ø´Ø¯Ù‡ ',0),(309244,8591,'tr','GÃ¶rÃ¼lme tarihi',0),(309245,8591,'pl','Data widziaÅ‚',0),(309246,8591,'bg','Ð”Ð°Ñ‚Ð° Ð·Ð° Ð¿ÑŠÑ‚',0),(309247,8591,'ur','ØªØ§Ø±ÛŒØ® Ù†Û’ Ø¯ÛŒÚ©Ú¾Ø§',0),(309248,8591,'sr','Ð’Ð¸Ð´ÐµÐ¾ Ñ˜Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(309249,8591,'vi','NgÃ y Ä‘Ã£ tháº¥y',0),(309250,8591,'af','Datum Gesien',0),(309251,8591,'ro','Data vazut',0),(309252,8591,'et','KuupÃ¤eva nÃ¤inud',0),(309253,8591,'si','Datum, ki je videl',0),(309254,8591,'ba','Tanggal dilihat',0),(309255,8591,'nl','Datum gezien',0),(309256,8591,'fi','MennessÃ¤ nÃ¤hnyt',0),(309257,8591,'no','Dato sett',0),(309258,8591,'da','Dato set',0),(309259,8591,'ko','ë³¸ ë‚ ì§œ',0),(309260,8591,'he','×ª××¨×™×š ×¨××™×ª×™',0),(309261,8591,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î´ÎµÎ¹',0),(309262,8591,'zh','çœ‹æ—¥æœŸ\r\n',0),(309263,8591,'sv','Date sett',0),(309264,8591,'it','Data visto',0),(309265,8591,'tl','',0),(309266,8591,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3611;&#3619;&#3634;&#3585;&#3599;',0),(309267,8591,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤¦à¥‡à¤–à¤¾',0),(309268,8591,'ms','Tarikh yang dilihat',0),(309269,8591,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø·Ù‘Ù„Ø§Ø¹',0),(309270,8591,'fr','Date vu',0),(309271,8591,'jp','æ—¥è¦‹',0),(309272,8591,'pt','Data de visto',0),(309273,8591,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÐµÑ‰ÐµÐ½Ð¸Ñ',0),(309274,8591,'es','Fecha Vistada',0),(309275,8591,'de','Datum gesehen',0),(309276,8591,'en','Date Seen',0),(309277,8592,'is','',0),(309278,8592,'dr','Ø¹Ù†ÙˆØ§Ù† Ù¾ÙŠØºØ§Ù… ',0),(309279,8592,'pr','Ø¹Ù†ÙˆØ§Ù† Ù¾ÙŠØºØ§Ù… ',0),(309280,8592,'tr','Mesaj baÅŸlÄ±ÄŸÄ±',0),(309281,8592,'pl','TytuÅ‚ wiadomoÅ›ci',0),(309282,8592,'bg','Ð—Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(309283,8592,'ur','Ù¾ÛŒØºØ§Ù… Ø¹Ù†ÙˆØ§Ù†',0),(309284,8592,'sr','ÐÐ°ÑÐ»Ð¾Ð² Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(309285,8592,'vi','TiÃªu Ä‘á» tin nháº¯n',0),(309286,8592,'af','Boodskaptitel',0),(309287,8592,'ro','Titlu mesaj',0),(309288,8592,'et','SÃµnumi pealkiri',0),(309289,8592,'si','Naslov sporoÄila',0),(309290,8592,'ba','Judul pesan',0),(309291,8592,'nl','Titel van het bericht',0),(309292,8592,'fi','Viestin otsikko',0),(309293,8592,'no','Meldingstittelen',0),(309294,8592,'da','Meddelelsestitel',0),(309295,8592,'ko','ë©”ì‹œì§€ ì œëª©',0),(309296,8592,'he','×›×•×ª×¨×ª ×”×•×“×¢×”',0),(309297,8592,'el','ÎŸ Ï„Î¯Ï„Î»Î¿Ï‚ Ï„Î¿Ï… Î¼Î·Î½ÏÎ¼Î±Ï„Î¿Ï‚',0),(309298,8592,'zh','ä¿¡æ¯æ ‡é¢˜\r\n',0),(309299,8592,'sv','Meddelanderubriken',0),(309300,8592,'it','Titolo del messaggio',0),(309301,8592,'tl','',0),(309302,8592,'th','&#3594;&#3639;&#3656;&#3629;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(309303,8592,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤¶à¥€à¤°à¥à¤·à¤•',0),(309304,8592,'ms','Tajuk mesej',0),(309305,8592,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø±Ø³Ø§Ù„Ø©',0),(309306,8592,'fr','Titre du message',0),(309307,8592,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®ã‚¿ã‚¤ãƒˆãƒ«',0),(309308,8592,'pt','TÃ­tulo da mensagem',0),(309309,8592,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(309310,8592,'es','Mensaje TÃ­tulo',0),(309311,8592,'de','Nachrichtentitel',0),(309312,8592,'en','Message Title',0),(309313,8593,'is','',0),(309314,8593,'dr','Ù¾Ø³Øª ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ',0),(309315,8593,'pr','Ù¾Ø³Øª ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ',0),(309316,8593,'tr','SonrasÄ± baÅŸlangÄ±Ã§ tarihi',0),(309317,8593,'pl','Post Data rozp.',0),(309318,8593,'bg','ÐŸÐ¾ÑÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(309319,8593,'ur','Ù¾ÙˆØ³Ù¹ Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(309320,8593,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¿Ð¾ÑÑ‚Ð°',0),(309321,8593,'vi','NgÃ y báº¯t Ä‘áº§u Káº¿t chuyá»ƒn ',0),(309322,8593,'af','Pos Begin Datum',0),(309323,8593,'ro','Data de inceput de post',0),(309324,8593,'et','Post alguskuupÃ¤ev',0),(309325,8593,'si','Post zaÄetni datum',0),(309326,8593,'ba','Tanggal mulai posting',0),(309327,8593,'nl','Post begindatum',0),(309328,8593,'fi','Post aloituspÃ¤ivÃ¤',0),(309329,8593,'no','Post Start Date',0),(309330,8593,'da','Post Start dato',0),(309331,8593,'ko','ê²Œì‹œë¬¼ ì‹œìž‘ ë‚ ì§œ',0),(309332,8593,'he','×¤×•×¡×˜ ×‘×’×™×Ÿ ×ª××¨×™×š',0),(309333,8593,'el','Î—Î¼ÎµÏ/Î½Î¯Î± Î­ÎºÎ´Î¿ÏƒÎ·Ï‚ Î±ÏÏ‡Î¯ÏƒÏ„Îµ',0),(309334,8593,'zh','å‘å¸ƒå¼€å§‹æ—¥æœŸ\r\n',0),(309335,8593,'sv','BÃ¶rja datum',0),(309336,8593,'it','Data di inserimento: Begin',0),(309337,8593,'tl','',0),(309338,8593,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(309339,8593,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(309340,8593,'ms','Tarikh mulakan pos',0),(309341,8593,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(309342,8593,'fr','Date de dÃ©but de post',0),(309343,8593,'jp','ãƒã‚¹ãƒˆé–‹å§‹æ—¥',0),(309344,8593,'pt','Data de inÃ­cio do post',0),(309345,8593,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(309346,8593,'es','Asentar Fecha de Comienza',0),(309347,8593,'de','Post Anfangsdatum',0),(309348,8593,'en','Post Begin Date',0),(309349,8594,'is','',0),(309350,8594,'dr','Ù¾Ø³Øª ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(309351,8594,'pr','Ù¾Ø³Øª ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ',0),(309352,8594,'tr','Post bitiÅŸ tarihi',0),(309353,8594,'pl','Data zakoÅ„czenia postu',0),(309354,8594,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ',0),(309355,8594,'ur','Ù¾ÙˆØ³Ù¹ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(309356,8594,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð¿Ð¾ÑÑ‚Ð°',0),(309357,8594,'vi','NgÃ y káº¿t thÃºc Káº¿t chuyá»ƒn ',0),(309358,8594,'af','Post Einddatum',0),(309359,8594,'ro','Data de sfÃ¢rÅŸit post',0),(309360,8594,'et','Post lÃµppkuupÃ¤ev',0),(309361,8594,'si','Objava konÄnega datuma',0),(309362,8594,'ba','Tanggal akhir posting',0),(309363,8594,'nl','Post einddatum',0),(309364,8594,'fi','Post loppuun mennessÃ¤',0),(309365,8594,'no','Innlegg dato',0),(309366,8594,'da','Post slutdato',0),(309367,8594,'ko','ê²Œì‹œë¬¼ ì¢…ë£Œì¼',0),(309368,8594,'he','×ª××¨×™×š ×¡×™×•× post',0),(309369,8594,'el','Î”Î·Î¼Î¿ÏƒÎ¯ÎµÏ…ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(309370,8594,'zh','å‘å¸ƒç»“æŸæ—¥æœŸ\r\n',0),(309371,8594,'sv','Post slutdatum',0),(309372,8594,'it','Data di fine del post',0),(309373,8594,'tl','',0),(309374,8594,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3585;&#3634;&#3619;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(309375,8594,'hi','à¤ªà¤¦ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(309376,8594,'ms','Tarikh akhir Post',0),(309377,8594,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(309378,8594,'fr','Date de fin de poste',0),(309379,8594,'jp','æœ€å¾Œã®æŠ•ç¨¿æ—¥æ™‚',0),(309380,8594,'pt','Data de tÃ©rmino do post',0),(309381,8594,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð¿Ð¾ÑÑ‚Ð°',0),(309382,8594,'es','Asentar Fecha de TÃ©rminaciÃ³n',0),(309383,8594,'de','Post-Enddatum',0),(309384,8594,'en','Post End Date',0),(309385,8595,'is','',0),(309386,8595,'dr','Ú†Ù‡ ÙƒØ³ÙŠ Ø¯ÙŠØ¯Ù‡ Ø§Ø³Øª ',0),(309387,8595,'pr','Ú†Ù‡ ÙƒØ³ÙŠ Ø¯ÙŠØ¯Ù‡ Ø§Ø³Øª ',0),(309388,8595,'tr','Kim gÃ¶rdÃ¼',0),(309389,8595,'pl','Kto widziaÅ‚',0),(309390,8595,'bg','ÐšÐ¾Ð¹ Ðµ Ð²Ð¸Ð¶Ð´Ð°Ð»',0),(309391,8595,'ur','Ø¬Ùˆ Ø¯ÛŒÚ©Ú¾Ø§ ÛÛ’',0),(309392,8595,'sr','ÐšÐ¾ Ñ˜Ðµ Ð²Ð¸Ð´ÐµÐ¾',0),(309393,8595,'vi','Ai Ä‘Ã£ gá»­i',0),(309394,8595,'af','Wat gesien het',0),(309395,8595,'ro','Care a vazut',0),(309396,8595,'et','Kes on vaadanud',0),(309397,8595,'si','Kdo je videl',0),(309398,8595,'ba','Yang melihat',0),(309399,8595,'nl','Wie heeft gezien',0),(309400,8595,'fi','Kuka on nÃ¤hnyt',0),(309401,8595,'no','Hvem har sett',0),(309402,8595,'da','Hvem har set',0),(309403,8595,'ko','ëˆ„ê°€ ë³¸',0),(309404,8595,'he','×ž×™ ×¨××”',0),(309405,8595,'el','Î Î¿Î¹Î¿Ï‚ Î­Ï‡ÎµÎ¹ Î´ÎµÎ¹',0),(309406,8595,'zh','è°è§è¿‡\r\n',0),(309407,8595,'sv','Vem har sett',0),(309408,8595,'it','Chi ha visto',0),(309409,8595,'tl','',0),(309410,8595,'th','&#3651;&#3588;&#3619;&#3652;&#3604;&#3657;&#3617;&#3629;&#3591;&#3648;&#3627;&#3655;&#3609;',0),(309411,8595,'hi','à¤œà¥‹ à¤¦à¥‡à¤–à¤¾ à¤¹à¥ˆ',0),(309412,8595,'ms','Yang telah dilihat',0),(309413,8595,'ar','Ø§Ù„Ø°ÙŠ Ø´Ù‡Ø¯',0),(309414,8595,'fr','Qui l\'a vu',0),(309415,8595,'jp','èª°ãŒè¦‹ãŸ',0),(309416,8595,'pt','Quem viu',0),(309417,8595,'ru','ÐšÑ‚Ð¾ Ð’Ð¸Ð´ÐµÐ»',0),(309418,8595,'es','Quien Ha Visto',0),(309419,8595,'de','Wer hat gesehen',0),(309420,8595,'en','Who Has Seen',0),(309421,8596,'is','',0),(309422,8596,'dr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ ',0),(309423,8596,'pr','Ù¾ÙŠØºØ§Ù… Ù‡Ø§ ',0),(309424,8596,'tr','Ä°letileri',0),(309425,8596,'pl','WiadomoÅ›ci',0),(309426,8596,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(309427,8596,'ur','Ù¾ÛŒØºØ§Ù…Ø§Øª',0),(309428,8596,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐµ',0),(309429,8596,'vi','Tin Nháº¯n',0),(309430,8596,'af','Boodskappe',0),(309431,8596,'ro','Mesaje',0),(309432,8596,'et','SÃµnumid',0),(309433,8596,'si','SporoÄila',0),(309434,8596,'ba','Pesan',0),(309435,8596,'nl','Berichten',0),(309436,8596,'fi','Viestit',0),(309437,8596,'no','Meldinger',0),(309438,8596,'da','Meddelelser',0),(309439,8596,'ko','ë©”ì‹œì§€',0),(309440,8596,'he','×”×•×“×¢×•×ª',0),(309441,8596,'el','ÎœÎ·Î½ÏÎ¼Î±Ï„Î±',0),(309442,8596,'zh','æ¶ˆæ¯\r\n',0),(309443,8596,'sv','Meddelanden',0),(309444,8596,'it','Messaggi',0),(309445,8596,'tl','',0),(309446,8596,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(309447,8596,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶',0),(309448,8596,'ms','Mesej-mesej',0),(309449,8596,'ar','Ø§Ù„Ø±Ø³Ø§Ø¦Ù„',0),(309450,8596,'fr','Messages',0),(309451,8596,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(309452,8596,'pt','Mensagens',0),(309453,8596,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(309454,8596,'es','Mensajes',0),(309455,8596,'de','Nachrichten',0),(309456,8596,'en','Messages',0),(309457,8597,'is','',0),(309458,8597,'dr','Ù¾ÙŠØºØ§Ù… Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§ ',0),(309459,8597,'pr','Ù¾ÙŠØºØ§Ù… Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§ ',0),(309460,8597,'tr','Sana mesaj',0),(309461,8597,'pl','WiadomoÅ›Ä‡ dla Ciebie',0),(309462,8597,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð·Ð° Ð²Ð°Ñ',0),(309463,8597,'ur','Ø¢Ù¾ Ú©Û’ Ù„Ø¦Û’ Ù¾ÛŒØºØ§Ù…',0),(309464,8597,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐ° Ð·Ð° Ñ‚ÐµÐ±Ðµ',0),(309465,8597,'vi','Tin nháº¯n cho báº¡n',0),(309466,8597,'af','Boodskap Vir U',0),(309467,8597,'ro','Mesaj pentru tine',0),(309468,8597,'et','SÃµnum teile',0),(309469,8597,'si','SporoÄilo za vas',0),(309470,8597,'ba','Pesan untuk Anda',0),(309471,8597,'nl','Bericht voor u',0),(309472,8597,'fi','Viesti sinulle',0),(309473,8597,'no','Melding For deg',0),(309474,8597,'da','Besked til dig',0),(309475,8597,'ko','ë‹¹ì‹ ì„ ìœ„í•œ ë©”ì‹œì§€',0),(309476,8597,'he','×”×•×“×¢×” ×¢×‘×•×¨×š',0),(309477,8597,'el','ÎœÎ®Î½Ï…Î¼Î± Î³Î¹Î± ÏƒÎ±Ï‚',0),(309478,8597,'zh','æ‚¨çš„ä¿¡æ¯\r\n',0),(309479,8597,'sv','Meddelande till dig',0),(309480,8597,'it','Messaggio per te',0),(309481,8597,'tl','',0),(309482,8597,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(309483,8597,'hi','à¤†à¤ª à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(309484,8597,'ms','Mesej untuk anda',0),(309485,8597,'ar','Ø±Ø³Ø§Ù„Ø© Ù„Ùƒ',0),(309486,8597,'fr','Message pour vous',0),(309487,8597,'jp','ã‚ãªãŸã®ãŸã‚ã®ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(309488,8597,'pt','Mensagem para vocÃª',0),(309489,8597,'ru','Ð”Ð»Ñ Ð’Ð°Ñ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(309490,8597,'es','Mensaje Para Usted',0),(309491,8597,'de','Nachricht fÃ¼r Sie',0),(309492,8597,'en','Message For You',0),(309493,8598,'is','',0),(309494,8598,'dr','Ù…Ø¬Ø§Ø² Ø¬Ù‡Øª Ø§ÙŠØ¬Ø§Ø¯ Ù¾ÙŠØºØ§Ù…',0),(309495,8598,'pr','Ù…Ø¬Ø§Ø² Ø¬Ù‡Øª Ø§ÙŠØ¬Ø§Ø¯ Ù¾ÙŠØºØ§Ù…',0),(309496,8598,'tr','Ä°letileri oluÅŸturmak iÃ§in izin',0),(309497,8598,'pl','MoÅ¼liwoÅ›Ä‡ tworzenia wiadomoÅ›ci',0),(309498,8598,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ñ‚Ðµ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(309499,8598,'ur','Ù¾ÛŒØºØ§Ù…Ø§Øª Ø¨Ù†Ø§Ù†Û’ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(309500,8598,'sr','ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(309501,8598,'vi','Cho PhÃ©p Táº¡o Tin Nháº¯n',0),(309502,8598,'af','Toelating om Boodskap te Skep',0),(309503,8598,'ro','Permise pentru a crea mesaje',0),(309504,8598,'et','Lubatud luua sÃµnumeid',0),(309505,8598,'si','Dovoljeno ustvariti sporoÄila',0),(309506,8598,'ba','Diperbolehkan untuk membuat pesan',0),(309507,8598,'nl','Toegestaan om berichten te maken',0),(309508,8598,'fi','Voi luoda viestejÃ¤',0),(309509,8598,'no','Kan opprette meldinger',0),(309510,8598,'da','Lov til at oprette meddelelser',0),(309511,8598,'ko','ë©”ì‹œì§€ë¥¼ ë§Œë“¤ ìˆ˜',0),(309512,8598,'he','×ž×•×ª×¨ ×œ×™×¦×•×¨ ×”×•×“×¢×•×ª',0),(309513,8598,'el','Î¤Î· Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„Î± Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î¼Î·Î½ÏÎ¼Î±Ï„Î±',0),(309514,8598,'zh','å…è®¸åˆ›å»ºæ¶ˆæ¯\r\n',0),(309515,8598,'sv','TillÃ¥tet att skapa meddelanden',0),(309516,8598,'it','Permesso di creare messaggi',0),(309517,8598,'tl','',0),(309518,8598,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3626;&#3619;&#3657;&#3634;&#3591;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3652;&#3604;&#3657;',0),(309519,8598,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(309520,8598,'ms','Dibenarkan untuk mencipta mesej-mesej',0),(309521,8598,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨Ø¥Ù†Ø´Ø§Ø¡ Ø±Ø³Ø§Ø¦Ù„',0),(309522,8598,'fr','AutorisÃ© Ã  crÃ©er des Messages',0),(309523,8598,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®ä½œæˆã‚’è¨±å¯ã™ã‚‹ã«ã¯',0),(309524,8598,'pt','PermissÃ£o para criar mensagens',0),(309525,8598,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾ Ð¡Ð¾Ð·Ð´Ð°Ð²Ð°Ñ‚ÑŒ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(309526,8598,'es','Permitido Crear Mensajes',0),(309527,8598,'de','Berechtigt, Nachrichten zu erstellen',0),(309528,8598,'en','Allowed to Create Messages',0),(309529,8599,'is','',0),(309530,8599,'dr','Ù…Ø¯ÙŠØ± Ù…ÙŠØ²Ø¨Ø§Ù†',0),(309531,8599,'pr','Ù…Ø¯ÙŠØ± Ù…ÙŠØ²Ø¨Ø§Ù†',0),(309532,8599,'tr','BarÄ±ndÄ±rma yÃ¶neticisi',0),(309533,8599,'pl','Hosting Manager',0),(309534,8599,'bg','Ð¥Ð¾ÑÑ‚Ð¸Ð½Ð³ Ð¼ÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€',0),(309535,8599,'ur','Ù…ÛŒØ²Ø¨Ø§Ù† Ù…ÛŒÙ†ÛŒØ¬Ø±',0),(309536,8599,'sr','Ð¥Ð¾ÑÑ‚Ð¸Ð½Ð³ ÐœÐµÐ½Ð°ÑŸÐµÑ€',0),(309537,8599,'vi','Quáº£n LÃ½ Hosting',0),(309538,8599,'af','Gasheer Bestuurder',0),(309539,8599,'ro','Manager gÄƒzduire',0),(309540,8599,'et','Hosting Manager',0),(309541,8599,'si','Gostovanje Manager',0),(309542,8599,'ba','Manajer hosting',0),(309543,8599,'nl','Hosting Manager',0),(309544,8599,'fi','Hosting johtaja',0),(309545,8599,'no','Hosting Manager',0),(309546,8599,'da','Hosting Manager',0),(309547,8599,'ko','í˜¸ìŠ¤íŒ… ê´€ë¦¬ìž',0),(309548,8599,'he','×ž× ×”×œ ×”××—×¡×•×Ÿ',0),(309549,8599,'el','Î¦Î¹Î»Î¿Î¾ÎµÎ½Î¯Î± Î´Î¹ÎµÏ…Î¸Ï…Î½Ï„Î®Ï‚',0),(309550,8599,'zh','ä¸»æœºç®¡ç†\r\n',0),(309551,8599,'sv','Hosting Manager',0),(309552,8599,'it','Hosting Manager',0),(309553,8599,'tl','',0),(309554,8599,'th','&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3650;&#3630;&#3626;&#3605;&#3660;',0),(309555,8599,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤• à¤•à¥€ à¤®à¥‡à¤œà¤¬à¤¾à¤¨à¥€',0),(309556,8599,'ms','Hosting Pengurus',0),(309557,8599,'ar','Ù…Ø¯ÙŠØ± Ø§Ù„Ø§Ø³ØªØ¶Ø§ÙØ©',0),(309558,8599,'fr','Gestionnaire d\'hÃ©bergement',0),(309559,8599,'jp','ãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼ã®ãƒ›ã‚¹ãƒˆ',0),(309560,8599,'pt','Gerente de hospedagem',0),(309561,8599,'ru','Ð¥Ð¾ÑÑ‚Ð¸Ð½Ð³ ÐœÐµÐ½ÐµÐ´Ð¶ÐµÑ€',0),(309562,8599,'es','Supervisor de Hosting',0),(309563,8599,'de','Hosting Manager',0),(309564,8599,'en','Hosting Manager',0),(309565,8600,'is','',0),(309566,8600,'dr','10:Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù…ØªÙ†ÙŠ Ù…Ø±ØªØ¨Ø· Ùˆ Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ ÙˆÙŠØ¯ÙŠÙˆØ¦ÙŠ Ø¯Ø± Ø¨ÙŠØ´ØªØ± ØµÙØ­Ø§Øª Ø§ÙŠÙ† Ø³Ø§ÙØª ÙˆÛŒØ± Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª . Ø¨Ø§ Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ Ø§ÙŠÙƒÙ† Ø±Ø§Ù‡Ù†Ù…Ø§ Ù¾Ø§ÙŠÙŠÙ† ØµÙØ­Ù‡ ',0),(309567,8600,'pr','Ø´Ø±Ø­ Ø±Ø§Ù‡Ù†Ù…Ø§ 10:Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù…ØªÙ†ÙŠ Ù…Ø±ØªØ¨Ø· Ùˆ Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ ÙˆÙŠØ¯ÙŠÙˆØ¦ÙŠ Ø¯Ø± Ø¨ÙŠØ´ØªØ± ØµÙØ­Ø§Øª Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª . Ø¨Ø§ ÙƒÙ„ÙŠÙƒ Ø§ÙŠÙƒÙ† Ø±Ø§Ù‡Ù†Ù…Ø§ Ù¾Ø§ÙŠÙŠÙ† ØµÙØ­Ù‡ ',0),(309568,8600,'tr','Ä°lgili metin tabanlÄ± YardÄ±m ve video baÄŸlantÄ±larÄ± da altbilgi YardÄ±m simgesini tÄ±klatarak en NolaPro sayfalarÄ±nda kullanÄ±labilir.',0),(309569,8600,'pl','Odpowiednich pomocy opartej na tekst i wideo linki sÄ… rÃ³wnieÅ¼ dostÄ™pne na wiÄ™kszoÅ›ci stron NolaPro klikajÄ…c na ikonÄ™ Pomoc stopki.',0),(309570,8600,'bg','Ð¡ÑŠÐ¾Ñ‚Ð²ÐµÑ‚Ð½Ð¸Ñ‚Ðµ Ñ‚ÐµÐºÑÑ‚Ð¾Ð²Ð¾ Ð±Ð°Ð·Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð¸ Ð²Ð¸Ð´ÐµÐ¾ Ð²Ñ€ÑŠÐ·ÐºÐ¸ ÑÑŠÑ‰Ð¾ ÑÐ° Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ð²ÐµÑ‡ÐµÑ‚Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸, NolaPro ÐºÐ°Ñ‚Ð¾ Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð¸ÐºÐ¾Ð½Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰ ',0),(309571,8600,'ur','Ù…ØªØ¹Ù„Ù‚Û Ù…ØªÙ† Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø± Ù…Ø¯Ø¯ Ø§ÙˆØ± ÙˆÛŒÚˆÛŒÙˆ Ù„Ù†Ú©Ø³ Ø¨Ú¾ÛŒ Ø°ÛŒÙ„ ØªØ­Ø±ÛŒØ± Ù…Ø¯Ø¯ Ø´Ø¨ÛŒÛ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±Ú©Û’ Ø³Ø¨ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ ØµÙØ­Ø§Øª Ù¾Ø± Ø¯Ø³ØªÛŒØ§Ø¨ ÛÛŒÚº Û”',0),(309572,8600,'sr','ÐžÐ´Ð³Ð¾Ð²Ð°Ñ€Ð°Ñ˜ÑƒÑ›Ñƒ Ð¿Ð¾Ð¼Ð¾Ñ› Ð·Ð°ÑÐ½Ð¾Ð²Ð°Ð½ Ð½Ð° Ñ‚ÐµÐºÑÑ‚Ñƒ Ð¸ Ð²Ð¸Ð´ÐµÐ¾ Ð»Ð¸Ð½ÐºÐ° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ðµ ÑÑƒ Ð¸ Ð½Ð° Ð²ÐµÑ›Ð¸Ð½Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ñ‚Ð°ÐºÐ¾ ÑˆÑ‚Ð¾ Ñ›ÐµÑ‚Ðµ ÐºÐ»Ð¸ÐºÐ½ÑƒÑ‚Ð¸ Ð½Ð° Ð¸ÐºÐ¾Ð½Ñƒ Ð·Ð° Ð¿Ð¾Ð¼Ð¾Ñ› Ð¿Ð¾Ð´Ð½Ð¾',0),(309573,8600,'vi','Káº¿t ná»‘i tá»›i trang trá»£ giÃºp dáº¡ng vÄƒn báº£n & video Ä‘áº·t trÃªn cÃ¡c trang NolaPro. Nháº¥n vÃ o biá»ƒu tÆ°á»£ng Trá»£ GiÃºp Ä‘á»ƒ káº¿t ná»‘i.',0),(309574,8600,'af','Relevante teks-gebaseerde hulp en video webskakels is ook beskikbaar op die meeste NolaPro bladsye deur te kliek op die voetenend hulp ikoon.',0),(309575,8600,'ro','Ajutor relevante bazate pe text ÅŸi link-uri pagina, de asemenea, sunt disponibile cele mai multe NolaPro pagini fÄƒcÃ¢nd clic pe pictograma de ajutor subsol.',0),(309576,8600,'et','Asjakohaste tekstipÃµhine abi ja video lingid on ka enamik NolaPro lehtedel saadaval jalus aidata ikoonil klikkides.',0),(309577,8600,'si','Ustrezno pomoÄ tekstovne in video povezave na voljo tudi na najbolj NolaPro strani s klikom na ikono pomoÄ nogo.',0),(309578,8600,'ba','Bantuan berbasis teks yang relevan dan link video juga tersedia pada kebanyakan NolaPro halaman dengan mengklik ikon bantuan footer.',0),(309579,8600,'nl','Relevante tekst gebaseerde help en video links zijn ook beschikbaar op de meeste NolaPro\'s door te klikken op het pictogram van de help voettekst.',0),(309580,8600,'fi','Teksti-pohjainen auttavat ja video linkit ovat saatavilla useimmilla NolaPro sivuilla klikkaamalla alatunnisteen ohje-kuvaketta.',0),(309581,8600,'no','Relevant tekst-basert hjelp og video golfbane er ogsÃ¥ tilgjengelig pÃ¥ de fleste NolaPro sider ved Ã¥ klikke pÃ¥ bunntekst hjelp-ikonet.',0),(309582,8600,'da','Relevante tekst-baseret hjÃ¦lp og video links er ogsÃ¥ tilgÃ¦ngelige pÃ¥ de fleste NolaPro sider ved at klikke pÃ¥ hjÃ¦lpikonet sidefod.',0),(309583,8600,'ko','ê´€ë ¨ í…ìŠ¤íŠ¸ ê¸°ë°˜ ë„ì›€ë§ ë° ë¹„ë””ì˜¤ ë§í¬ ë˜í•œ ì‚¬ìš©í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤ ëŒ€ë¶€ë¶„ì˜ NolaPro íŽ˜ì´ì§€ ë°”ë‹¥ê¸€ ë„ì›€ë§ ì•„ì´ì½˜ì„ í´ë¦­ í•˜ ì—¬.',0),(309584,8600,'he','×¢×–×¨×” ×ž×‘×•×¡×¡×™ ×˜×§×¡×˜ ×¨×œ×•×•× ×˜×™ ×•×§×™×©×•×¨×™× ×•×™×“××• ×–×ž×™× ×™× ×’× ×‘×“×¤×™ ×©×¨×•×‘ NolaPro ×¢×œ ×™×“×™ ×œ×—×™×¦×” ×¢×œ ××™×™×§×•×Ÿ ×”×¢×–×¨×” ×”×ª×—×ª×•× ×”.',0),(309585,8600,'el','Î£Ï‡ÎµÏ„Î¹ÎºÎ® Î²Î¿Î®Î¸ÎµÎ¹Î± Ï€Î¿Ï… Î²Î±ÏƒÎ¯Î¶Î¿Î½Ï„Î±Î¹ ÏƒÎµ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÎºÎ±Î¹ Ï„Î·Î»ÎµÎ¿Ï€Ï„Î¹ÎºÎ­Ï‚ ÏƒÏ…Î½Î´Î­ÏƒÎµÎ¹Ï‚ ÎµÎ¯Î½Î±Î¹ ÎµÏ€Î¯ÏƒÎ·Ï‚ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± ÏƒÏ„Î¹Ï‚ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚ NolaPro ÎºÎ¬Î½Î¿Î½Ï„Î±Ï‚ ÎºÎ»Î¹Îº Ïƒ',0),(309586,8600,'zh','ç›¸å…³çš„æ–‡å­—ä¸ºåŸºç¡€çš„å¸®åŠ©å’Œè§†é¢‘çš„é“¾æŽ¥ï¼Œä¹Ÿå¯ç”¨äºŽå¤§å¤šæ•°\r\n',0),(309587,8600,'sv','Text-baserade hjÃ¤lp och video lÃ¤nkar finns ocksÃ¥ pÃ¥ de flesta NolaPro sidor genom att klicka pÃ¥ hjÃ¤lpikonen sidfot.',0),(309588,8600,'it','Aiuto basati su testo e dei collegamenti sono disponibili sulla maggior parte delle pagine di NolaPro anche facendo clic sull\'icona di aiuto del piÃ¨ di pagina.',0),(309589,8600,'tl','',0),(309590,8600,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3588;&#3621;&#3636;&#3658;&#3585;&#3607;&#3637;&#3656;&#3652;&#3629;&#3588;&#3629;&#3609; Nolapro',0),(309591,8600,'hi','à¤ªà¥à¤°à¤¾à¤¸à¤‚à¤—à¤¿à¤• à¤®à¤¦à¤¦ à¤ªà¤¾à¤ -à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤”à¤° à¤µà¥€à¤¡à¤¿à¤¯à¥‹ à¤²à¤¿à¤‚à¤• à¤­à¥€ à¤ªà¤¾à¤¦ à¤²à¥‡à¤– à¤®à¤¦à¤¦ à¤†à¤‡à¤•à¤¨ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¤•à¥‡ à¤…à¤§à¤¿à¤•à¤¾à¤‚à¤¶ NolaPro à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤ªà¤° à¤‰à',0),(309592,8600,'ms','Berkaitan bantuan berasaskan teks dan pautan video juga disediakan di kebanyakan muka surat NolaPro dengan klik pada ikon bantuan footer.',0),(309593,8600,'ar','Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø© Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø© Ø¥Ù„Ù‰ Ø§Ù„Ù†ØµÙˆØµ Ø°Ø§Øª Ø§Ù„ØµÙ„Ø© ÙˆÙˆØµÙ„Ø§Øª Ø§Ù„ÙÙŠØ¯ÙŠÙˆ Ù…ØªØ§Ø­Ø© Ø£ÙŠØ¶Ø§ Ø¹Ù„Ù‰ Ù…Ø¹Ø¸Ù… Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ø§Ù„ØµÙØ­Ø§Øª Ø¨Ø§Ù„Ù†Ù‚Ø± Ø¹Ù„Ù‰ Ø£ÙŠÙ‚ÙˆÙ†Ø© ØªØ¹Ù„ÙŠÙ…Ø§Øª ØªØ°ÙŠÙŠÙ„ Ø§Ù„ØµÙØ­Ø©.',0),(309594,8600,'fr','Aide basÃ© sur du texte et des liens vidÃ©o sont Ã©galement disponibles sur la plupart des pages de NolaPro en cliquant sur l\'icÃ´ne d\'aide de pied de page.',0),(309595,8600,'jp','ãƒ†ã‚­ã‚¹ãƒˆ ãƒ™ãƒ¼ã‚¹ã®é–¢é€£æ€§ã®é«˜ã„ãƒ˜ãƒ«ãƒ—ã¨ãƒ“ãƒ‡ã‚ªã®ãƒªãƒ³ã‚¯ã‚‚å¯èƒ½ã§ã™ã»ã¨ã‚“ã©ã® NolaPro ãƒšãƒ¼ã‚¸ ãƒ•ãƒƒã‚¿ãƒ¼ ãƒ˜ãƒ«ãƒ— ã‚¢ã‚¤ã‚³ãƒ³ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦',0),(309596,8600,'pt','Relevante ajuda baseada em texto e links de vÃ­deo tambÃ©m estÃ£o disponÃ­vel na maioria das pÃ¡ginas NolaPro clicando no Ã­cone de ajuda do rodapÃ©.',0),(309597,8600,'ru','Ð¢ÐµÐºÑÑ‚Ð¾Ð²Ð°Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒ Ð¸ ÑÑÑ‹Ð»ÐºÐ¸ Ð½Ð° Ð²Ð¸Ð´ÐµÐ¾ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ… NolaPro Ð¿Ñ€Ð¸ Ð½Ð°Ð¶Ð°Ñ‚Ð¸Ð¸ Ð½Ð° Ð¸ÐºÐ¾Ð½Ñƒ Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð²Ð½Ð¸Ð·Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹.',0),(309598,8600,'es','Ayuda relevante basada en texto y enlaces de video tambiÃ©n estan disponibles en la mayorÃ­a de pÃ¡ginas de NolaPro por hacer click en el icÃ³n de ayuda de pie de pÃ¡gina',0),(309599,8600,'de','Entsprechende Text-basierte Hilfe und video Links stehen auch auf den meisten Seiten der Artikel durch Klicken auf das Hilfesymbol FuÃŸzeile.',0),(309600,8600,'en','Relevant text-based help and video links are also available on most NolaPro pages by clicking on the footer help icon.',0),(309601,8601,'is','',0),(309602,8601,'dr','10: Ø±Ø§Ù‡Ù†Ù…Ø§ ÙˆÙŠÚ˜Ù‡ ØµÙØ­Ù‡',0),(309603,8601,'pr','Ø¹Ù†ÙˆØ§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ 10: Ø±Ø§Ù‡Ù†Ù…Ø§ ÙˆÙŠÚ˜Ù‡ ØµÙØ­Ù‡',0),(309604,8601,'tr','Sayfa Ã¶zel yardÄ±m',0),(309605,8601,'pl','Strona pomocy',0),(309606,8601,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰, ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(309607,8601,'ur','ØµÙØ­Û Ù…Ø®ØµÙˆØµ Ù…Ø¯Ø¯',0),(309608,8601,'sr','ÐžÐ´Ñ€ÐµÑ’ÐµÐ½Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸',0),(309609,8601,'vi','Trang Trá»£ GiÃºp Cá»¥ Thá»ƒ',0),(309610,8601,'af','Bladsy-Spesifieke Hulp',0),(309611,8601,'ro','Ajutor specific pagina',0),(309612,8601,'et','Lehe konkreetset abi',0),(309613,8601,'si','Strani pomoÄi',0),(309614,8601,'ba','Khusus halaman bantuan',0),(309615,8601,'nl','Pagina-specifieke Help',0),(309616,8601,'fi','Sivun ohjeen',0),(309617,8601,'no','Siden spesifikk hjelp',0),(309618,8601,'da','Side specifik hjÃ¦lp',0),(309619,8601,'ko','íŽ˜ì´ì§€ ê´€ë ¨ ë„ì›€ë§',0),(309620,8601,'he','×œ×¢×–×¨×” ×¡×¤×¦×™×¤×™×ª ×“×£',0),(309621,8601,'el','Î’Î¿Î®Î¸ÎµÎ¹Î± ÎµÎ¾ÎµÎ¹Î´Î¹ÎºÎµÏ…Î¼Î­Î½Î· Î³Î¹Î± ÎºÎ¬Î¸Îµ ÏƒÎµÎ»Î¯Î´Î±',0),(309622,8601,'zh','é€šè¿‡ç‚¹å‡»NolaProåœ¨é¡µé¢é¡µè„šå¸®åŠ©å›¾æ ‡èŽ·å¾—ç½‘é¡µçš„ç‰¹å®šå¸®åŠ©',0),(309623,8601,'sv','Sidan specifik hjÃ¤lp',0),(309624,8601,'it','Guida specifica pagina',0),(309625,8601,'tl','',0),(309626,8601,'th','&#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(309627,8601,'hi','à¤ªà¥ƒà¤·à¥à¤  à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤®à¤¦à¤¦',0),(309628,8601,'ms','Bantuan Laman khusus',0),(309629,8601,'ar','Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨Ø§Ù„ØµÙØ­Ø©',0),(309630,8601,'fr','Aide spÃ©cifique de la page',0),(309631,8601,'jp','ãƒšãƒ¼ã‚¸å›ºæœ‰ã®ãƒ˜ãƒ«ãƒ—',0),(309632,8601,'pt','Ajuda pÃ¡gina especÃ­fica',0),(309633,8601,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡ÐµÑÐºÐ°Ñ ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ',0),(309634,8601,'es','Ayuda de PÃ¡gina EspecÃ­fica',0),(309635,8601,'de','Seite spezifische Hilfe',0),(309636,8601,'en','Page Specific Help',0),(309637,8602,'is','',0),(309638,8602,'dr','1:ØªÙˆØ³Ø¹Ù‡ Ø³Ø§ÙØª ÙˆÛŒØ±ÙŠ Ø±Ø§ Ú†Ùƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø§ÙŠÙ† Ø³Ø§ÙØª ÙˆÛŒØ± Ø±Ø§ Ø¨Ø§ Ù†ÙŠØ§Ø²Ù‡Ø§ÙŠ Ø®ÙˆØ¯ Ù‡Ù…Ø§Ù‡Ù†Ú¯ ÙƒÙ†ÙŠØ¯ ÙŠØ§ Ø¨Ø§ Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ ÙˆØ§Ø­Ø¯ Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ù…Ø§  ØªØºÙŠÙŠØ±Ø§Øª Ù…ÙˆØ±Ø¯ Ù†Ø¸Ø± Ø®ÙˆØ¯ Ø±',0),(309639,8602,'pr','Ø´Ø±Ø­ Ø±Ø§Ù‡Ù†Ù…Ø§ 1:ØªÙˆØ³Ø¹Ù‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±ÙŠ Ø±Ø§ Ú†Ùƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø±Ø§ Ø¨Ø§ Ù†ÙŠØ§Ø²Ù‡Ø§ÙŠ Ø®ÙˆØ¯ Ù‡Ù…Ø§Ù‡Ù†Ú¯ ÙƒÙ†ÙŠØ¯ ÙŠØ§ Ø¨Ø§ Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ ÙˆØ§Ø­Ø¯ Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ù…Ø§  ØªØºÙŠÙŠØ±Ø§Øª Ù…ÙˆØ±Ø¯ Ù†Ø¸Ø± Ø®ÙˆØ¯ Ø±ï',0),(309640,8602,'tr','Kontrol belgili tanÄ±mlÄ±k enhancements iÃ§in senin lÃ¼zum NolaPro Ã¶zelleÅŸtirmek veya sadece bize e-posta ve kendi deÄŸiÅŸikliklerini istemek kullanÄ±labilir.',0),(309641,8602,'pl','SprawdÅº ulepszenia dostÄ™pne dostosowaÄ‡ NolaPro dla potrzeb, lub po prostu napisz do nas i Å¼Ä…dania wÅ‚asnych zmian.',0),(309642,8602,'bg','Ð’Ð¸Ð¶Ñ‚Ðµ Ð¿Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð´Ð° Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚Ðµ NolaPro Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð½ÑƒÐ¶Ð´Ð¸, Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾ÑÑ‚Ð¾ Ð½Ð¸ Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¸ Ð´Ð° Ð¿Ð¾Ð¸ÑÐºÐ° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸.',0),(309643,8602,'ur','NolaPro Ø¢Ù¾ Ú©ÛŒ Ø¶Ø±ÙˆØ±ÛŒØ§Øª Ú©Û’ Ù„ÛŒÛ’ ØªØ®ØµÛŒØµ Ú©Ø±ÛŒÚº ÛŒØ§ Ø¨Ø³ ÛÙ…ÛŒÚº Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø¢Ù¾ Ú©ÛŒ Ø§Ù¾Ù†ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø¯Ø³ØªÛŒØ§Ø¨ Ø§ÙØ²ÙˆÙ†ÛŒØ§Úº Ø¨Ø§ÛØ± Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº Û”',0),(309644,8602,'sr','Ð’Ð¸Ð´Ð¸ Ð¿Ð¾Ð±Ð¾Ñ™ÑˆÐ°ÑšÐ° ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½ Ð·Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’Ð°Ð²Ð°ÑšÐµ NolaPro Ð·Ð° Ð²Ð°ÑˆÐµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ðµ, Ð¸Ð»Ð¸ Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚Ð°Ð²Ð½Ð¾ ÐŸÐ¸ÑˆÐ¸Ñ‚Ðµ Ð½Ð°Ð¼ Ð¸ Ð·Ð°Ñ‚Ñ€Ð°Ð¶Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ.',0),(309645,8602,'vi','TÃ¬m hiá»ƒu thÃªm giÃ¡ trá»‹ tÄƒng cÆ°á»ng cho pháº§n má»m NolaPro theo yÃªu cáº§u hay or Ä‘Æ¡n giáº£n gá»­i email email us Ä‘á»ƒ yÃªu cáº§u.',0),(309646,8602,'af','Sien die versterkings beskikbaar om NolaPro vir u unieke behoeftes aan te pas, of stuur eenvoudig net n e-pos aan ons en versoek u eie veranderinge.',0),(309647,8602,'ro','A verifica afarÄƒ accesorii disponibile pentru a personaliza NolaPro pentru nevoile dumneavoastra, sau pur ÅŸi simplu e-mail-ne si solicita modificÄƒrile proprii.',0),(309648,8602,'et','Vaata saadaval kohandada oma vajadustele, NolaPro vÃµi lihtsalt kirjuta meile ja nÃµuda oma muudatuste tÃ¤iustused.',0),(309649,8602,'si','Oglejte si izboljÅ¡ave, ki so na voljo za prilagajanje NolaPro za vaÅ¡e potrebe, ali preprosto piÅ¡ite in zahtevajo svoje spremembe.',0),(309650,8602,'ba','Periksa perangkat tambahan tersedia untuk menyesuaikan NolaPro untuk kebutuhan Anda, atau hanya email kami dan meminta perubahan Anda sendiri.',0),(309651,8602,'nl','Bekijk de uitbreidingen beschikbaar voor het aanpassen van de NolaPro voor uw behoeften, of gewoon e-mail ons en vraag uw eigen wijzigingen.',0),(309652,8602,'fi','Tutustu parannuksia voi mukauttaa NolaPro tarpeisiin, tai LÃ¤hetÃ¤ meille sÃ¤hkÃ¶postia ja pyytÃ¤Ã¤ omia muutoksia.',0),(309653,8602,'no','Sjekk ut forbedringene tilpasse NolaPro for dine behov, eller bare send oss og be om dine egne endringer.',0),(309654,8602,'da','Tjek de forbedringer, der er tilgÃ¦ngelige til at tilpasse NolaPro til dine behov, eller blot kontakte os og bede om dine egne Ã¦ndringer.',0),(309655,8602,'ko','ê·€í•˜ì˜ ìš”êµ¬ì— ëŒ€ í•œ NolaPro ì‚¬ìš©ìž ì§€ì • ë˜ëŠ” ë‹¨ìˆœížˆ ì´ë©”ì¼ì„ í•˜ ê³  ìžì‹ ì˜ ë³€ê²½ ë‚´ìš©ì„ ìš”ì²­ì— ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” í–¥ìƒ ëœ ê¸°ëŠ¥ì„ í™•ì¸ í•©ë‹ˆë‹¤.',0),(309656,8602,'he','×‘×“×•×§ ××ª ×”×©×™×¤×•×¨×™× ×–×ž×™×Ÿ ×œ×”×ª××™× ××™×©×™×ª ××ª NolaPro ×œ×¦×¨×›×™× ×©×œ×š, ××• ×¤×©×•×˜ ×©×œ×— ×œ× ×• ×“×•× ×œ ×•×œ×‘×§×© ××ª ×”×©×™× ×•×™×™× ×©×œ×š.',0),(309657,8602,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î­Î¾Ï‰ Ï„Î¹Ï‚ Î²ÎµÎ»Ï„Î¹ÏŽÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼ÎµÏ‚ Î³Î¹Î± Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® NolaPro Î³Î¹Î± Ï„Î¹Ï‚ Î±Î½Î¬Î³ÎºÎµÏ‚ ÏƒÎ±Ï‚, Î® Î±Ï€Î»Î¬ ÏƒÏ„ÎµÎ¯Î»Ï„Îµ Î¼Î±Ï‚ Î­Î½Î± email ÎºÎ±Î¹ Î½Î± Î¶Î·Ï„Î®ÏƒÎµÏ„Îµ Ï„Î¿ Î´Î¹ÎºÏŒ ÏƒÎ',0),(309658,8602,'zh','ç™»å‡ºå¯ç”¨çš„ä¼˜åŒ–å¤„ç†ä»¥æ ¹æ®è‡ªèº«éœ€è¦è‡ªå®šä¹‰NolaPro,æˆ–ä»…ç”µé‚®æˆ‘ä»¬å¹¶æå‡ºä½ æ”¹å˜çš„è¦æ±‚ã€‚\r\n',0),(309659,8602,'sv','Kolla in fÃ¶rbÃ¤ttringarna som Ã¤r tillgÃ¤ngliga att anpassa NolaPro fÃ¶r dina behov, eller helt enkelt maila oss och begÃ¤ra egna Ã¤ndringar.',0),(309660,8602,'it','Scopri i miglioramenti disponibili per personalizzare NolaPro per le vostre esigenze, o semplicemente contattarci via email e richiedere le proprie modifiche.',0),(309661,8602,'tl','',0),(309662,8602,'th','Check out the enhancements available to customize NolaPro for your needs, or simply <a href=\"mailto:support@noguska.com\">email us</a> and request your own changes.',0),(309663,8602,'hi','à¤¸à¤‚à¤µà¤°à¥à¤¦à¥à¤§à¤¨ NolaPro à¤…à¤ªà¤¨à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤•à¥‚à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤¬à¤¸ à¤¹à¤®à¥‡à¤‚ à¤ˆà¤®à¥‡à¤² à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤…à¤ªà¤¨à¥‡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹',0),(309664,8602,'ms','Menyemak penambahan ini disediakan untuk menyesuaikan NolaPro untuk keperluan anda, atau hanya email dan meminta perubahan sendiri.',0),(309665,8602,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„ØªØ­Ø³ÙŠÙ†Ø§Øª Ø§Ù„Ù…ØªØ§Ø­Ø© Ù„ØªØ®ØµÙŠØµ NolaPro Ù„ØªÙ„Ø¨ÙŠØ© Ø§Ù„Ø§Ø­ØªÙŠØ§Ø¬Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨ÙƒØŒ Ø£Ùˆ Ø¨Ø¨Ø³Ø§Ø·Ø© Ù…Ø±Ø§Ø³Ù„ØªÙ†Ø§ ÙˆØ·Ù„Ø¨ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(309666,8602,'fr','DÃ©couvrez les amÃ©liorations disponibles pour personnaliser NolaPro pour vos besoins, ou tout simplement nous envoyer un courriel et demander vos propres modifications.',0),(309667,8602,'jp','ã‚ãªãŸã®å¿…è¦æ€§ã®ãŸã‚ã® NolaPro ã‚’ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚ºã¾ãŸã¯å˜ã«é›»å­ãƒ¡ãƒ¼ãƒ«ã‚’é€ã‚Šã€ã‚ãªãŸè‡ªèº«ã®å¤‰æ›´ã‚’è¦æ±‚ã™ã‚‹åˆ©ç”¨å¯èƒ½ãªæ‹¡å¼µæ©Ÿèƒ½ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¦ãã ã•ã„ã€‚',0),(309668,8602,'pt','Confira as melhorias disponÃ­veis para personalizar NolaPro para suas necessidades, ou simplesmente enviar-em um e-mail e solicitar suas prÃ³prias alteraÃ§Ãµes.',0),(309669,8602,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ ÑƒÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½ÑÑ‚Ð²Ð¾Ð²Ð°Ð½Ð¸Ñ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ NolaPro Ð² ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¸Ð¸ Ñ Ð’Ð°ÑˆÐ¸Ð¼Ð¸ Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸ÑÐ¼Ð¸ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾ÑÑ‚Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÑŒÑ‚Ðµ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð¿Ð¾ Email.',0),(309670,8602,'es','Checar las adiciones que estan disponibles para personalizar NolaPro a sus necesidades',0),(309671,8602,'de','Schauen Sie sich die Erweiterungen zur VerfÃ¼gung, um NolaPro fÃ¼r Ihre BedÃ¼rfnisse anpassen oder einfach eine email und fordern Sie Ihre eigenen Ã„nderungen.',0),(309672,8602,'en','Check out the enhancements available to customize NolaPro for your needs, or simply email us and request your own changes.',0),(309673,8603,'is','',0),(309674,8603,'dr','1: Ø®ØµÙˆØµÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ  Ùˆ Ø®Ø§ØµÙŠØª Ø§ÙØ²ÙˆØ¯Ù†ÙŠ',0),(309675,8603,'pr','Ø¹Ù†ÙˆØ§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ 1: Ø®ØµÙˆØµÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ  Ùˆ Ø®Ø§ØµÙŠØª Ø§ÙØ²ÙˆØ¯Ù†ÙŠ',0),(309676,8603,'tr','Ekstra & eklentileri',0),(309677,8603,'pl','Dodatki & Dodatki',0),(309678,8603,'bg','Ð•ÐºÑÑ‚Ñ€Ð¸ & Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(309679,8603,'ur','Ù…Ø¹ Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª & Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº ons',0),(309680,8603,'sr','Ð”Ð¾Ð´Ð°Ñ†Ð¸ Ð¸ Ð´Ð¾Ð´Ð°Ñ†Ð¸',0),(309681,8603,'vi','ThÃªm VÃ o ',0),(309682,8603,'af','Bykomstighede & Byvoegings',0),(309683,8603,'ro','Extrase & add-on-uri',0),(309684,8603,'et','Lisamoodulid & Pluginad',0),(309685,8603,'si','Dodatki & dodatkov',0),(309686,8603,'ba','Ekstra & Pengaya',0),(309687,8603,'nl','Extras & Add-Ons',0),(309688,8603,'fi','Ekstrat & lisÃ¤osat',0),(309689,8603,'no','Ekstra & tilleggsprogrammer',0),(309690,8603,'da','Extras & tilfÃ¸jelser',0),(309691,8603,'ko','ì—‘ìŠ¤íŠ¸ë¼ & ê¸°ëŠ¥',0),(309692,8603,'he','×ª×•×¡×¤×•×ª & ×ª×•×¡×¤×•×ª',0),(309693,8603,'el','ÎˆÎ¾Ï„ÏÎ± & Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î±',0),(309694,8603,'zh','é™„åŠ åŠŸèƒ½å’Œæ·»åŠ åŠŸèƒ½\r\n',0),(309695,8603,'sv','Extras & tillÃ¤gg',0),(309696,8603,'it','Componenti aggiuntivi & extra',0),(309697,8603,'tl','',0),(309698,8603,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3609;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(309699,8603,'hi','à¤à¤•à¥à¤¸à¥à¤Ÿà¥à¤°à¤¾ à¤•à¤²à¤¾à¤•à¤¾à¤° & add-ons',0),(309700,8603,'ms','Tambahan & tambahan',0),(309701,8603,'ar','Ø§Ù„Ø¥Ø¶Ø§ÙØ§Øª',0),(309702,8603,'fr','Options des modules &',0),(309703,8603,'jp','ã‚¨ã‚¯ã‚¹ãƒˆãƒ© & ã‚¢ãƒ‰ã‚ªãƒ³',0),(309704,8603,'pt','Extras & Add-ons',0),(309705,8603,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ & ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(309706,8603,'es','Extras & Adiciones',0),(309707,8603,'de','Extras & Add-ons',0),(309708,8603,'en','Extras & Add-Ons',0),(309709,8604,'is','',0),(309710,8604,'dr','2: Ø¨Ø±Ø§ÙŠ ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ ØªØ¬Ø§Ø±ØªÛŒ ÙƒÙ‡ ØªÙ‚Ø§Ø¶Ø§ÙŠ Ø§Ù…Ù†ÙŠØª Ùˆ Ø§Ø³ØªØ­ÙƒØ§Ù…  Ø¨Ø¯ÙˆÙ†  ØªØ¹Ù…ÙŠØ± Ùˆ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ø±Ø§  Ø¯Ø§Ø±Ù†Ø¯  . Ø§ÙŠÙ† Ø¨Ù‡ØªØ±ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø§Ø³Øª. Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù…ØªØ¹Ø¯Ø¯ Ø¨Ø§ Ø­Ø¯Ø§Ù‚Ù„ Ù‚ÙŠÙ…',0),(309711,8604,'pr','Ø´Ø±Ø­ Ø±Ø§Ù‡Ù†Ù…Ø§ 2: Ø¨Ø±Ø§ÙŠ ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ ØªØ¬Ø§Ø±ÙŠ ÙƒÙ‡ ØªÙ‚Ø§Ø¶Ø§ÙŠ Ø§Ù…Ù†ÙŠØª Ùˆ Ø§Ø³ØªØ­ÙƒØ§Ù…  Ø¨Ø¯ÙˆÙ†  ØªØ¹Ù…ÙŠØ± Ùˆ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ø±Ø§  Ø¯Ø§Ø±Ù†Ø¯  . Ø§ÙŠÙ† Ø¨Ù‡ØªØ±ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡ Ø§Ø³Øª. Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù…ØªØ¹Ø¯Ø¯ Ø¨Ø§ Ø­Ø¯Ø§Ù‚Ù„ Ù‚ÙŠÙ…',0),(309712,8604,'tr','GÃ¼venlik, istikrar ve herhangi bir bakÄ±m talep eden iÅŸletmeler iÃ§in bu mÃ¼kemmel seÃ§enektir.  DÃ¼ÅŸÃ¼k 9,99 $/ mo olarak kullanÄ±labilir planlÄ±yor.',0),(309713,8604,'pl','Dla firm, ktÃ³rzy wymagajÄ… zabezpieczeÅ„, stabilnoÅ›ci i nie wymaga konserwacji jest idealnym rozwiÄ…zaniem.  Plany dostÄ™pne w tak niskie, jak $9.99 miesiÄ™cznie.',0),(309714,8604,'bg','Ð—Ð° Ñ„Ð¸Ñ€Ð¼Ð¸, ÐºÐ¾Ð¸Ñ‚Ð¾ Ð¸ÑÐºÐ°Ñ‚ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚, ÑÑ‚Ð°Ð±Ð¸Ð»Ð½Ð¾ÑÑ‚ Ð¸ Ð±ÐµÐ· Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ñ‚Ð¾Ð²Ð° Ðµ Ð´Ð¾Ð±Ñ€Ð° Ð¾Ð¿Ñ†Ð¸Ñ.  ÐŸÐ»Ð°Ð½Ð¾Ð²Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ñ‚Ð¾Ð»ÐºÐ¾Ð²Ð° Ð½Ð¸ÑÐºÐ°, ÐºÐ¾Ð»ÐºÐ¾Ñ‚Ð¾ $9.99/mo.',0),(309715,8604,'ur','Ú©Û’ Ù„Ø¦Û’ Ø§Ù† Ú©Ø§Ø±ÙˆØ¨Ø§Ø± Ú©Û’ Ø¬Ùˆ Ø³Ù„Ø§Ù…ØªÛŒØŒ Ø§Ø³ØªØ­Ú©Ø§Ù… Ø§ÙˆØ± Ú©ÙˆØ¦ÛŒ Ø¯ÛŒÚ©Ú¾ Ø¨Ú¾Ø§Ù„ Ú©Ø§ Ù…Ø·Ø§Ù„Ø¨Û ÛÛ’ØŒ Ø§Ø³ Ú©Ø§ Ú©Ø§Ù…Ù„ Ø§Ø®ØªÛŒØ§Ø± ÛÛ’ Û”  $9.99/mo Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø·ÙˆØ± Ù¾Ø± Ú©Ù… Ø¯Ø³ØªÛŒØ§Ø¨ Ø§Ø±Ø§Ø¯Û Ø±Ú©Ú¾ØªÛŒ ÛÛ’ ',0),(309716,8604,'sr','Ð—Ð° Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð° ÐºÐ¾Ñ˜Ð° Ñ‚Ñ€Ð°Ð¶Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚, ÑÑ‚Ð°Ð±Ð¸Ð»Ð½Ð¾ÑÑ‚ Ð¸ Ð±ÐµÐ· Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐ°, Ð¾Ð²Ð¾ Ñ˜Ðµ ÑÐ°Ð²Ñ€ÑˆÐµÐ½Ð¾ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°.  ÐŸÐ»Ð°Ð½Ð¾Ð²Ð¸ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸ Ð½Ð¸ÑÐºÐ¾ ÐºÐ°Ð¾ $ 9.99/Ð¼Ð¾.',0),(309717,8604,'vi','Náº¿u báº¡n cáº§n an toÃ n, á»•n Ä‘á»‹nh & khÃ´ng cáº§n báº£o trÃ¬  Ä‘Ã¢y chÃ­nh lÃ  lá»±c chá»n cá»§a báº¡n. Nhiá»u káº¿ hoáº¡ch chá»‰ báº¯t Ä‘áº§u vá»›i $17/pháº§n. ',0),(309718,8604,'af','Vir ondernemings wat aandrang op beveiliging, stabiliteit en geen onderhoud, is dit die ideale opsie. Verskeie planne is beskikbaar so min as $ 17/mnd. ',0),(309719,8604,'ro','Pentru firmele care au nevoie de securitate, stabilitate si nici o Ã®ntreÅ£inere, aceasta este opÅ£iunea perfectÄƒ.  Planuri disponibile cÃ¢t mai scÄƒzut ca 9,99 $/ luna.',0),(309720,8604,'et','EttevÃµtetele, kes nÃµuavad turvalisuse, stabiilsuse ja kÃµrvale, see on tÃ¤iuslik valik.  Plaanid saadaval nii madal kui $9.99/mo.',0),(309721,8604,'si','Za podjetja, ki zahtevajo varnost, stabilnost in brez vzdrÅ¾evanja, to je vzoren predkupna pravica.  NaÄrti na voljo tako nizko, kot $9.99/mo.',0),(309722,8604,'ba','Untuk bisnis yang menuntut keamanan, stabilitas dan tidak ada pemeliharaan, ini adalah pilihan yang sempurna.  Rencana tersedia sebagai rendah sebagai $9.99/mo.',0),(309723,8604,'nl','Voor bedrijven die eisen van veiligheid, stabiliteit en geen onderhoud, is dit de perfecte optie.  Plannen beschikbaar zo laag als $9.99/mo.',0),(309724,8604,'fi','Yrityksille, jotka vaativat turvallisuuden, vakauden ja yllÃ¤pitoa tÃ¤mÃ¤ on tÃ¤ydellinen vaihtoehto.  Suunnitelmia niin alhainen kuin 9,99 dollaria/kk.',0),(309725,8604,'no','For bedrifter som krever sikkerhet, stabilitet og ingen vedlikehold, er dette det perfekte valget.  Planer tilgjengelig sÃ¥ lavt som $ 9,99/mo.',0),(309726,8604,'da','For virksomheder, der krÃ¦ver sikkerhed, stabilitet og ingen vedligeholdelse, er dette den perfekte lÃ¸sning.  Planer tilgÃ¦ngelige sÃ¥ lavt som $9.99/mo.',0),(309727,8604,'ko','ë³´ì•ˆ, ì•ˆì •ì„± ë° ì •ë¹„ë¥¼ ìš”êµ¬ í•˜ëŠ” ê¸°ì—…ì— ëŒ€ í•œ ì™„ë²½ í•œ ì˜µì…˜ìž…ë‹ˆë‹¤.  ë‚®ì€ $9.99/m oë¡œ ì‚¬ìš©í•  ê³„íš ì´ë‹¤.',0),(309728,8604,'he','×¢×‘×•×¨ ×¢×¡×§×™× ××©×¨ ×“×•×¨×©×™× ×™×¦×™×‘×•×ª ×•×‘×™×˜×—×•×Ÿ, ××™×Ÿ ×¦×•×¨×š ×‘×ª×—×–×•×§×”, ×–×• ×”××•×¤×¦×™×” ×”×ž×•×©×œ×ž×ª.  ×ª×•×›× ×™×•×ª ×–×ž×™×Ÿ ×™×”×™×” × ×ž×•×š ×›×›×œ $9.99/×ž×•.',0),(309729,8604,'el','Î“Î¹Î± ÎµÏ€Î¹Ï‡ÎµÎ¹ÏÎ®ÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½ Î±ÏƒÏ†Î¬Î»ÎµÎ¹Î±, ÏƒÏ„Î±Î¸ÎµÏÏŒÏ„Î·Ï„Î± ÎºÎ±Î¹ ÎºÎ±Î¼Î¯Î± ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ·, Î±Ï…Ï„Î® ÎµÎ¯Î½Î±Î¹ Î· Ï„Î­Î»ÎµÎ¹Î± ÎµÏ€Î¹Î»Î¿Î³Î®.  Î£Ï‡Î­Î´Î¹Î± Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± Ï„ÏŒÏƒÎ¿ Ï‡Î±Î¼Î·Î»Î¬ ÏŒÏƒÎ¿ $9.99/',0),(309730,8604,'zh','å¯¹äºŽè¦æ±‚å®‰å…¨ï¼Œç¨³å®šå’Œå…ç»´æŠ¤çš„ä¼ä¸šï¼Œæ­¤é¡¹åªè¦$17/æœˆ\r\n',0),(309731,8604,'sv','FÃ¶r fÃ¶retag som krÃ¤ver sÃ¤kerhet, stabilitet och inget underhÃ¥ll, Ã¤r detta det perfekta alternativet.  Planer finns sÃ¥ lÃ¥gt som $9.99/mo.',0),(309732,8604,'it','Per le aziende che richiedono sicurezza, stabilitÃ  e nessuna manutenzione, questa Ã¨ l\'opzione perfetta.  Piani disponibili basso come $9.99/mo.',0),(309733,8604,'tl','',0),(309734,8604,'th','For businesses who demand security, stability and no maintenance, this is the perfect option.  Multiple plans available as low as $17/mo.',0),(309735,8604,'hi','à¤•à¤¾à¤°à¥‹à¤¬à¤¾à¤°, à¤œà¥‹ à¤¸à¥à¤°à¤•à¥à¤·à¤¾, à¤¸à¥à¤¥à¤¿à¤°à¤¤à¤¾ à¤”à¤° à¤•à¥‹à¤ˆ à¤°à¤–à¤°à¤–à¤¾à¤µ à¤•à¥€ à¤®à¤¾à¤‚à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹ à¤à¤•à¤¦à¤® à¤¸à¤¹à¥€ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¹à¥ˆà¥¤  9.99 à¤¡à¥‰à¤²à¤° à¤ªà¥à¤°à¤¤à¤¿ à¤®à¤¾à¤¹ à¤•',0),(309736,8604,'ms','Bagi perniagaan yang menuntut Keselamatan, kestabilan dan penyelenggaraan tidak, ini adalah pilihan yang sempurna.  Pelan disediakan serendah $ 9,99/bln.',0),(309737,8604,'ar','Ù„Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø°ÙŠÙ† ÙŠØ·Ø§Ù„Ø¨ÙˆÙ† Ø¨Ø§Ù„Ø£Ù…Ù† ÙˆØ§Ù„Ø§Ø³ØªÙ‚Ø±Ø§Ø± ÙˆÙ„Ø§ Ø§Ù„ØµÙŠØ§Ù†Ø©ØŒ ÙˆÙ‡Ø°Ø§ Ù‡Ùˆ Ø§Ù„Ø®ÙŠØ§Ø± Ø§Ù„Ù…Ø«Ø§Ù„ÙŠ.  Ø§Ù„Ø®Ø·Ø· Ø§Ù„Ù…ØªØ§Ø­Ø© Ù…Ù†Ø®ÙØ¶Ø© ØªØµÙ„ Ø¥Ù„Ù‰ 9.99 Ø¯ÙˆÙ„Ø§Ø±/Ø´Ù‡Ø±.',0),(309738,8604,'fr','Pour les entreprises qui demandent pas dâ€™entretien, la stabilitÃ© et la sÃ©curitÃ©, câ€™est lâ€™option parfaite.  Plans disponibles aussi bas que $ 9,99/mois.',0),(309739,8604,'jp','ã“ã‚Œã¯ã€ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£ã€å®‰å®šæ€§ã€ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹ ãƒ•ãƒªãƒ¼ã‚’æ±‚ã‚ã‚‹ä¼æ¥­ã€æœ€é©ãªã‚ªãƒ—ã‚·ãƒ§ãƒ³ã§ã™ã€‚ åˆ©ç”¨ã§ãã‚‹è¨ˆç”»ã® $9.99/mo ã¨ã—ã¦ä½Žã„ã€‚',0),(309740,8604,'pt','Para as empresas que exigem seguranÃ§a, estabilidade e sem manutenÃ§Ã£o, esta Ã© a opÃ§Ã£o perfeita.  Planos disponÃ­veis tÃ£o baixo quanto $ 9,99/mo.',0),(309741,8604,'ru','Ð”Ð»Ñ Ñ„Ð¸Ñ€Ð¼, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ñ‚Ñ€ÐµÐ±ÑƒÑŽÑ‚ Ð±ÐµÐ·Ð¾Ð¿Ð°ÑÐ½Ð¾ÑÑ‚ÑŒ, ÑƒÑÑ‚Ð¾Ð¹Ñ‡Ð¸Ð²Ð¾ÑÑ‚ÑŒ Ð¸ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²Ð¸Ðµ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ, ÑÑ‚Ð¾ - ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ð°Ñ Ð¾Ð¿Ñ†Ð¸Ñ. ÐœÐ½Ð¾Ð³Ð¾ÐºÑ€Ð°Ñ‚Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ð½Ñ‹,Ð·Ð° $17/Ð¼ÐµÑÑÑ†.',0),(309742,8604,'es','Para negocios que demandan seguridad, estabilidad, y sin mantenamiento, estÃ¡ es la opciÃ³n perfecta. Planes multiples disponibles empezando desde $17/mes',0),(309743,8604,'de','FÃ¼r Unternehmen, die Sicherheit, StabilitÃ¤t und keine Wartung erfordern, ist dies die perfekte Wahl.  PlÃ¤ne zur VerfÃ¼gung so niedrig wie $9,99 pro Monat.',0),(309744,8604,'en','For businesses who demand security, stability and no maintenance, this is the perfect option.  Plans available as low as $9.99/mo.',0),(309745,8605,'is','',0),(309746,8605,'dr','2: Ø±Ø§Ù‡ Ø­Ù„Ù‡Ø§ÙŠ Ø¨Ù‡ Ù…Ø¬Ø±Ø¯ ØªÙ‚Ø§Ø¶Ø§ Ù…ÙŠØ²Ø¨Ø§Ù† ',0),(309747,8605,'pr','Ø¹Ù†ÙˆØ§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ 2: Ø±Ø§Ù‡ Ø­Ù„Ù‡Ø§ÙŠ Ø¨Ù‡ Ù…Ø¬Ø±Ø¯ ØªÙ‚Ø§Ø¶Ø§ Ù…ÙŠØ²Ø¨Ø§Ù† ',0),(309748,8605,'tr','Cloud barÄ±ndÄ±rÄ±lan Ã§Ã¶zÃ¼m',0),(309749,8605,'pl','Hostowany w chmurze',0),(309750,8605,'bg','ÐžÐ±Ð»Ð°Ðº Ñ…Ð¾ÑÑ‚Ð²Ð°Ð½Ð¾ Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ',0),(309751,8605,'ur','Ù…ÛŒØ²Ø¨Ø§Ù† Ø­Ù„ Ø¨Ø§Ø¯Ù„',0),(309752,8605,'sr','ÐžÐ±Ð»Ð°Ðº Ñ˜Ð°Ð²Ð½Ð¸Ñ… Ñ€ÐµÑˆÐµÑšÐµ',0),(309753,8605,'vi','Giáº£i PhÃ¡p Hosting Theo Nhu Cáº§u',0),(309754,8605,'af','Op Aanvraag Gasheer Oplossing',0),(309755,8605,'ro','Nor gazduit soluÅ£ie',0),(309756,8605,'et','Pilv isÃ¤nnÃ¶ity lahendus',0),(309757,8605,'si','GostiÅ¡Äe raztopina v oblaku',0),(309758,8605,'ba','Awan solusi host',0),(309759,8605,'nl','Cloud gehoste oplossing',0),(309760,8605,'fi','Cloud isÃ¤nnÃ¶i ratkaisu',0),(309761,8605,'no','Sky vertsbasert lÃ¸sning',0),(309762,8605,'da','Cloud Hosted lÃ¸sning',0),(309763,8605,'ko','í´ë¼ìš°ë“œ í˜¸ìŠ¤íŒ…ëœ ì†”ë£¨ì…˜',0),(309764,8605,'he','×¢× ×Ÿ ×¤×ª×¨×•×Ÿ ×ž×ª××¨×—',0),(309765,8605,'el','Î£ÏÎ½Î½ÎµÏ†Î¿ Ï†Î¹Î»Î¿Î¾ÎµÎ½Î·Î¼Î­Î½Î· Î»ÏÏƒÎ·',0),(309766,8605,'zh','æŒ‰éœ€æ‰˜ç®¡è§£å†³æ–¹æ¡ˆæ˜¯æœ€å¥½çš„é€‰æ‹©ã€‚å¤šä¸ªè®¡åˆ’æœ‰æ•ˆã€‚\r\n',0),(309767,8605,'sv','Cloud hostad lÃ¶sning',0),(309768,8605,'it','Soluzione Hosted il cloud',0),(309769,8605,'tl','',0),(309770,8605,'th','&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3648;&#3623;&#3655;&#3610;&#3650;&#3630;&#3626;&#3605;&#3636;&#3657;&#3591;',0),(309771,8605,'hi','à¤¹à¥‹à¤¸à¥à¤Ÿà¥‡à¤¡ à¤¹à¤² à¤¬à¤¾à¤¦à¤²',0),(309772,8605,'ms','Awan penyelesaian yang dihos',0),(309773,8605,'ar','Ø³Ø­Ø§Ø¨Ø© Ø§Ø³ØªØ¶Ø§ÙØ© Ø§Ù„Ø­Ù„',0),(309774,8605,'fr','Solution hÃ©bergÃ©e de nuages',0),(309775,8605,'jp','ãƒ›ã‚¹ãƒˆã•ã‚Œã‚‹ã‚½ãƒªãƒ¥ãƒ¼ã‚·ãƒ§ãƒ³ã‚’ã‚¯ãƒ©ã‚¦ãƒ‰ã—ã¾ã™ã€‚',0),(309776,8605,'pt','SoluÃ§Ã£o hospedada em nuvem',0),(309777,8605,'ru','Ð¥Ð¾ÑÑ‚Ð¸Ð½Ð¸Ð³ Ð ÐµÑˆÐµÐ½Ð¸Ñ',0),(309778,8605,'es','En-Demanda SoluciÃ³n Hospedada',0),(309779,8605,'de','Cloud gehostete LÃ¶sung',0),(309780,8605,'en','Cloud Hosted Solution',0),(309781,8606,'is','',0),(309782,8606,'dr','3:Ø¨Ø§ Ø§ÙŠÙ† Ù…Ù†Ø§Ø¨Ø¹ Ø±Ø³Ù…ÙŠ ÙƒØªØ§Ø¨Ù‡Ø§ÙŠ  Ø±Ø§Ù‡Ù†Ù…Ø§ Ø®ÙŠÙ„ÙŠ Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø§ÙŠÙ† Ø³Ø§ÙØª ÙˆÛŒØ± Ø¨Ø¯Ø§Ù†ÙŠØ¯ .Ù‡Ù… Ø§ÙƒÙ†ÙˆÙ† ÙŠÙƒ Ù†Ø³Ø®Ù‡ Ø¯ÙŠØ¬ÙŠØªØ§Ù„ÙŠ Ø±Ø§ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒÙ†ÙŠØ¯ ÙŠØ§ ÙƒÙ¾ÙŠ Ø³Ø±ÙŠØ¹  ÙƒÙ‡ Ù…Ø³Øª',0),(309783,8606,'pr','Ø´Ø±Ø­ Ø±Ø§Ù‡Ù†Ù…Ø§ 3:Ø¨Ø§ Ø§ÙŠÙ† Ù…Ù†Ø§Ø¨Ø¹ Ø±Ø³Ù…ÙŠ ÙƒØªØ§Ø¨Ù‡Ø§ÙŠ  Ø±Ø§Ù‡Ù†Ù…Ø§ Ø®ÙŠÙ„ÙŠ Ø¨ÙŠØ´ØªØ± Ø§Ø² Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø¨Ø¯Ø§Ù†ÙŠØ¯ .Ù‡Ù… Ø§ÙƒÙ†ÙˆÙ† ÙŠÙƒ Ù†Ø³Ø®Ù‡ Ø¯ÙŠØ¬ÙŠØªØ§Ù„ÙŠ Ø±Ø§ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙƒÙ†ÙŠØ¯ ÙŠØ§ ÙƒÙ¾ÙŠ Ø³Ø±ÙŠØ¹  ÙƒÙ‡ Ù…Ø³Øªï',0),(309784,8606,'tr','NolaPro bu resmi baÅŸvuru kÄ±lavuzlarÄ±na ile en iyi ÅŸekilde almak.  AnÄ±nda bir dijital sÃ¼rÃ¼mÃ¼nÃ¼ indirmenizi veya sabit doÄŸrudan sevk sahip.',0),(309785,8606,'pl','UzyskaÄ‡ jak najwiÄ™cej z NolaPro z tych oficjalnych instrukcji obsÅ‚ugi.  Od razu pobraÄ‡ wersjÄ™ cyfrowÄ… lub wydruk wysyÅ‚ane bezpoÅ›rednio.',0),(309786,8606,'bg','Ð˜Ð·Ð²Ð»ÐµÑ‡ÐµÑ‚Ðµ Ð¼Ð°ÐºÑÐ¸Ð¼ÑƒÐ¼Ð° Ð¾Ñ‚ NolaPro Ñ Ñ‚ÐµÐ·Ð¸ Ð¾Ñ„Ð¸Ñ†Ð¸Ð°Ð»Ð½Ð¸ ÑÐ¿Ñ€Ð°Ð²Ð¾Ñ‡Ð½Ð¸Ñ†Ð¸.  Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° Ñ†Ð¸Ñ„Ñ€Ð¾Ð²Ð° Ð²ÐµÑ€ÑÐ¸Ñ Ð½ÐµÐ·Ð°Ð±Ð°Ð²Ð½Ð¾ Ð¸Ð»Ð¸ ÑÐ° Ð½Ð° Ñ…Ð°Ñ€Ñ‚Ð¸ÐµÐ½ Ð½Ð¾ÑÐ¸Ñ‚ÐµÐ», Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð´Ð¸Ñ€ÐµÐº',0),(309787,8606,'ur','Ø§Ù† Ø³Ø±Ú©Ø§Ø±ÛŒ Ø­ÙˆØ§Ù„Û Ú©ØªØ§Ø¨Ú†Û’ Ú©Û’ Ø³Ø§ØªÚ¾ NolaPro Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº Û”  ÙÙˆØ±ÛŒ Ø·ÙˆØ± Ù¾Ø± Ø§ÛŒÚ© ÚˆÛŒØ¬ÛŒÙ¹Ù„ ÙˆØ±Ú˜Ù† ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº ÛŒØ§ Ø§ÛŒÚ© ÛØ§Ø±Úˆ Ú©Ø§Ù¾ÛŒ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ',0),(309788,8606,'sr','Ð˜ÑÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð½Ð° NolaPro ÑÐ° Ð¾Ð²Ð¸Ð¼ Ð·Ð²Ð°Ð½Ð¸Ñ‡Ð½Ð¸ Ñ€ÐµÑ„ÐµÑ€ÐµÐ½Ñ‚Ð½Ðµ Ð¿Ñ€Ð¸Ñ€ÑƒÑ‡Ð½Ð¸ÐºÐµ.  ÐžÐ´Ð¼Ð°Ñ… Ð¿Ñ€ÐµÑƒÐ·Ð¼Ð¸Ñ‚Ðµ Ð´Ð¸Ð³Ð¸Ñ‚Ð°Ð»Ð½Ñƒ Ð²ÐµÑ€Ð·Ð¸Ñ˜Ñƒ Ð¸Ð»Ð¸ Ð¸Ð¼Ð°Ñ˜Ñƒ Ð¾Ð²Ñƒ Ñ‚Ð²Ñ€Ð´Ñƒ ÐºÐ¾Ð¿Ð¸Ñ˜Ñƒ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸ Ð´Ð¸Ñ€ÐµÐº',0),(309789,8606,'vi','DÃ¹ng báº£n hÆ°á»›ng dáº«n chÃ­nh thá»©c Ä‘á»ƒ hiá»ƒu rÃµ NolaPro. Táº£i báº£n ká»¹ thuáº­t sá»‘ bÃ¢y giá» hay yÃªu cáº§u gá»§i 1 báº£n in trá»±c tiáº¿p.',0),(309790,8606,'af','Kry die maksimum vanuit NolaPro met hierdie offisiele verwysingshand-leidings.  Laai onmiddelik \'n digitale weergawe af of verkry \'n hardeband kopiÃ« wat direk aan u versend word.',0),(309791,8606,'ro','ObÅ£ine maximum de NolaPro cu aceste manuale de referinÅ£Äƒ oficial.  DescÄƒrcaÅ£i o versiune digitalÄƒ instantaneu sau au o copie expediate direct.',0),(309792,8606,'et','Saada maksimaalne NolaPro nende ametlik viide juhendid.  Digitaalse versiooni kohe alla laadida vÃµi on veetud otse koopia.',0),(309793,8606,'si','Izkoristite NolaPro s teh uradnih referenÄnih priroÄnikih.  Prenesite digitalno razliÄico takoj ali so tiskani odpremljeno neposredno.',0),(309794,8606,'ba','Dapatkan hasil maksimal dari NolaPro dengan manual referensi resmi ini.  Men-download versi digital langsung atau memiliki hard copy dikirim langsung.',0),(309795,8606,'nl','Haal het meest uit NolaPro met deze officiÃ«le referentiehandleidingen.  Een digitale versie direct downloaden of hebben een hard-copy direct verzonden.',0),(309796,8606,'fi','Irti NolaPro virallinen kÃ¤sikirjoista.  Lataa digitaalinen versio hetkessÃ¤ tai on toimitettu suoraan paperiversion.',0),(309797,8606,'no','FÃ¥ mest mulig ut av NolaPro med disse offisielle referansehÃ¥ndbÃ¸ker.  Last ned en digital versjon umiddelbart eller har en papirkopi leveres direkte.',0),(309798,8606,'da','FÃ¥ mest ud af NolaPro med disse officielle referencemanualer.  Hent en digital version Ã¸jeblikkeligt eller have en papirkopi, afsendt direkte.',0),(309799,8606,'ko','ì´ëŸ¬í•œ ê³µì‹ ì°¸ì¡° ì„¤ëª…ì„œ NolaProë¥¼ ìµœëŒ€í•œ ì–»ì„.  ì¦‰ì‹œ ë””ì§€í„¸ ë²„ì „ì„ ë‹¤ìš´ë¡œë“œ ë˜ëŠ” ì§ì ‘ ë°°ì†¡ í•˜ë“œ ë³µì‚¬ë³¸ì„ê°€ì§€ê³ .',0),(309800,8606,'he','×œ×”×¤×™×§ ××ª ×”×ž×¨×‘ NolaPro ×¢× ×”×ž×“×¨×™×›×™× ×”××œ×• ×”×¤× ×™×” ×”×¨×©×ž×™×ª.  ×œ×”×•×¨×™×“ ×’×¨×¡×” ×“×™×’×™×˜×œ×™×ª ×‘××•×¤×Ÿ ×ž×™×™×“×™ ××• ×¢×•×ª×§ ×§×©×™×— ×©× ×©×œ×—×• ×™×©×™×¨×•×ª.',0),(309801,8606,'el','Î‘Î¾Î¹Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ ÏƒÏ„Î¿ Î­Ï€Î±ÎºÏÎ¿ Ï„Î·Î½ NolaPro Î¼Îµ Î±Ï…Ï„Î¬ Ï„Î± ÎµÎ³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î± ÎµÏ€Î¯ÏƒÎ·Î¼Î· Î±Î½Î±Ï†Î¿ÏÎ¬.  ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÎµÏ„Îµ Î¬Î¼ÎµÏƒÎ± Î¼Î¹Î± ÏˆÎ·Ï†Î¹Î±ÎºÎ® Î­ÎºÎ´Î¿ÏƒÎ· Î® Î½Î± Î­Ï‡Î¿Ï…Î½ Î­Î½Î± Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Ï€Î¿Ï… Î±Ï€Î¿',0),(309802,8606,'zh','èŽ·å–è¿™äº›å®˜æ–¹å‚è€ƒæ‰‹å†Œçš„NolaProçš„æœ€å¤§æ•ˆç›Šã€‚\r\n',0),(309803,8606,'sv','FÃ¥ ut mesta mÃ¶jliga av NolaPro med dessa officiella referensmanualer.  HÃ¤mta en digital version direkt eller ha en papperskopia skickat direkt.',0),(309804,8606,'it','Ottenere il massimo da NolaPro con questi manuali ufficiali di riferimento.  Scaricare una versione digitale istantaneamente o avere una copia cartacea spedita direttamente.',0),(309805,8606,'tl','',0),(309806,8606,'th','Get the most out of NolaPro with these official reference manuals.  Download a digital version instantly or have a hard copy shipped direct.',0),(309807,8606,'hi','à¤¸à¤¬à¤¸à¥‡ à¤‡à¤¨ à¤†à¤§à¤¿à¤•à¤¾à¤°à¤¿à¤• à¤¸à¤‚à¤¦à¤°à¥à¤­ à¤®à¥ˆà¤¨à¥à¤…à¤² à¤•à¥‡ à¤¸à¤¾à¤¥ NolaPro à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤¨à¤¿à¤•à¤²à¤¨à¤¾à¥¤  à¤¤à¥à¤°à¤¨à¥à¤¤ à¤à¤• à¤¡à¤¿à¤œà¤¿à¤Ÿà¤² à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤¯à¤¾ à¤à¤• à',0),(309808,8606,'ms','Mendapat yang terbaik daripada NolaPro dengan manual rujukan rasmi ini.  Muat turun versi digital serta-merta atau mempunyai salinan dihantar langsung.',0),(309809,8606,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø£Ù‚ØµÙ‰ Ø§Ø³ØªÙØ§Ø¯Ø© Ù…Ù† NolaPro Ù…Ø¹ Ù‡Ø°Ù‡ Ø§Ù„Ø£Ø¯Ù„Ø© Ø§Ù„Ù…Ø±Ø¬Ø¹ÙŠØ© Ø§Ù„Ø±Ø³Ù…ÙŠØ©.  ØªØ­Ù…ÙŠÙ„ Ù†Ø³Ø®Ø© Ø±Ù‚Ù…ÙŠØ© Ø¹Ù„Ù‰ Ø§Ù„ÙÙˆØ± Ø£Ùˆ Ù†Ø³Ø®Ø© Ù…Ø·Ø¨ÙˆØ¹Ø© ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ù…Ø¨Ø§Ø´Ø±Ø©.',0),(309810,8606,'fr','Tirer le meilleur parti des NolaPro avec ces manuels de rÃ©fÃ©rence officielle.  TÃ©lÃ©charger une version numÃ©rique instantanÃ©ment ou avoir une copie papier, directement expÃ©diÃ©e.',0),(309811,8606,'jp','ã“ã‚Œã‚‰ã®å…¬å¼ã®ãƒªãƒ•ã‚¡ãƒ¬ãƒ³ã‚¹ ãƒžãƒ‹ãƒ¥ã‚¢ãƒ«ã¨ NolaPro ã‚’æœ€å¤§é™ã«å¾—ã‚‹ã€‚ å³åº§ã«ãƒ‡ã‚¸ã‚¿ãƒ«ç‰ˆã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã¾ãŸã¯ãƒãƒ¼ãƒ‰ ã‚³ãƒ”ãƒ¼ã‚’å‡ºè·ã—ã¾ã™ã€‚',0),(309812,8606,'pt','Tire o mÃ¡ximo de NolaPro com estes manuais de referÃªncia oficial.  Baixe uma versÃ£o digital instantaneamente ou ter uma cÃ³pia enviada direto.',0),(309813,8606,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð±Ð¾Ð»ÑŒÑˆÐµ Ð¾Ñ‚ NolaPro Ñ ÑÑ‚Ð¸Ð¼Ð¸ Ð¾Ñ„Ð¸Ñ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¼Ð¸ ÑÐ¿Ñ€Ð°Ð²Ð¾Ñ‡Ð½Ð¸ÐºÐ°Ð¼Ð¸. Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚Ðµ Ñ†Ð¸Ñ„Ñ€Ð¾Ð²ÑƒÑŽ Ð²ÐµÑ€ÑÐ¸ÑŽ ÑÑ€Ð°Ð·Ñƒ Ð¸Ð»Ð¸ Ð·Ð°ÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¿ÐµÑ‡Ð°Ñ‚Ð½ÑƒÑŽ ÐºÐ¾Ð¿Ð¸ÑŽ.',0),(309814,8606,'es','Obtener el mejor de NolaPro con estes manuales oficiales de referencia. Descargar una versiÃ³n digital instantaneamente u ordenar una cÃ³pia de CD enviada directa. ',0),(309815,8606,'de','Hole das Beste aus NolaPro mit diesen offiziellen HandbÃ¼cher.  Sofort eine digitale Version herunterladen oder ein gedrucktes Exemplar direkt versendet haben.',0),(309816,8606,'en','Get the most out of NolaPro with these official reference manuals.  Download a digital version instantly or have a hard copy shipped direct.',0),(309817,8607,'is','',0),(309818,8607,'dr','3: ÙƒØªØ¨ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø¯ÙŠØ¬ÙŠØªØ§Ù„ÙŠ ÙŠØ§ Ú†Ø§Ù¾ÙŠ',0),(309819,8607,'pr','Ø¹Ù†ÙˆØ§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ 3: ÙƒØªØ¨ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø¯ÙŠØ¬ÙŠØªØ§Ù„ÙŠ ÙŠØ§ Ú†Ø§Ù¾ÙŠ',0),(309820,8607,'tr','Dijital ve yazdÄ±rma kÄ±lavuzlarÄ±',0),(309821,8607,'pl','Cyfrowy i drukowania podrÄ™cznikÃ³w',0),(309822,8607,'bg','Ð”Ð¸Ð³Ð¸Ñ‚Ð°Ð»Ð½Ð¸ Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð½Ð¸ Ð½Ð°Ñ€ÑŠÑ‡Ð½Ð¸Ñ†Ð¸',0),(309823,8607,'ur','ÚˆÛŒØ¬ÛŒÙ¹Ù„ Ø§ÙˆØ± Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ú©ØªØ§Ø¨Ú†Û’',0),(309824,8607,'sr','Ð”Ð¸Ð³Ð¸Ñ‚Ð°Ð»Ð½Ð¸ Ð¸ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ñ€Ð¸Ñ€ÑƒÑ‡Ð½Ð¸ÐºÐ°',0),(309825,8607,'vi','HÆ°á»›ng dáº«n In & Ká»¹ Thuáº­t Sá»‘',0),(309826,8607,'af','Digitale en Gedrukte Handleidings',0),(309827,8607,'ro','Digitale ÅŸi imprimare manuale',0),(309828,8607,'et','Digitaalne ja Prindi juhendid',0),(309829,8607,'si','Digitalni in tiskanih priroÄnikov',0),(309830,8607,'ba','Manual digital dan cetak',0),(309831,8607,'nl','Handleidingen voor digitale en afdrukken',0),(309832,8607,'fi','Digitaalisen ja tulostaa ohjeet',0),(309833,8607,'no','Digital og trykt hÃ¥ndbÃ¸ker',0),(309834,8607,'da','Digitale og trykte manualer',0),(309835,8607,'ko','ë””ì§€í„¸ ë° ì¸ì‡„ ë§¤ë‰´ì–¼',0),(309836,8607,'he','×ž×“×¨×™×›×™×, ×”×“×¤×¡×” ×“×™×’×™×˜×œ×™×ª',0),(309837,8607,'el','Î¨Î·Ï†Î¹Î±ÎºÎ®Ï‚ ÎºÎ±Î¹ Î­Î½Ï„Ï…Ï€Î·Ï‚ ÎµÎ³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î±',0),(309838,8607,'zh','æ•°å­—å’Œå°åˆ·æ‰‹å†Œ\r\n',0),(309839,8607,'sv','Digitala och tryckta manualer',0),(309840,8607,'it','Digitale e stampa manuali',0),(309841,8607,'tl','',0),(309842,8607,'th','&#3588;&#3641;&#3656;&#3617;&#3639;&#3629;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3648;&#3611;&#3655;&#3609;&#3604;&#3636;&#3592;&#3636;&#3605;&#3633;&#3621;&#3649;&#3621;&#3632;&#3616;&#3634;&#3614;',0),(309843,8607,'hi','à¤¡à¤¿à¤œà¤¿à¤Ÿà¤² à¤”à¤° à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤¨à¤¿à¤¯à¤®à¤¾à¤µà¤²à¥€',0),(309844,8607,'ms','Manual digital dan cetak',0),(309845,8607,'ar','ÙƒØªÙŠØ¨Ø§Øª Ù…Ø·Ø¨ÙˆØ¹Ø© ÙˆØ±Ù‚Ù…ÙŠØ©',0),(309846,8607,'fr','Manuels imprimÃ©s et numÃ©riques',0),(309847,8607,'jp','ãƒ‡ã‚¸ã‚¿ãƒ«ã¨å°åˆ·ãƒžãƒ‹ãƒ¥ã‚¢ãƒ«',0),(309848,8607,'pt','Manuais impressos e digitais',0),(309849,8607,'ru','Ð”Ð¸Ð³Ð¸Ñ‚Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð¸ ÐŸÐµÑ‡Ð°Ñ‚Ð½Ñ‹Ðµ Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(309850,8607,'es','Manuales Digitales y de ImpresiÃ³n',0),(309851,8607,'de','Digitale und gedruckte HandbÃ¼cher',0),(309852,8607,'en','Digital and Print Manuals',0),(309853,8608,'is','',0),(309854,8608,'dr','4: Ù¾ÙƒÙŠØ¬ Ù‡Ø§ÙŠ ÙƒÙ…ÙƒÙŠ Ù…Ø§ Ø¨Ø§ Ù‡Ø± Ù†ÙˆØ¹ Ø¨ÙˆØ¯Ø¬Ù‡ Ø§ÙŠ Ø§Ø² Ù†Ø¸Ø± Ù…Ø§Ù„ÙŠ Ù…ØªÙ†Ø§Ø³Ø¨ Ù‡Ø³ØªÙ†Ø¯ ØªØ§ ÙƒÙ…Ùƒ Ù‡Ø§ÙŠ Ø´Ø®ØµÙŠ Ø±Ø§ ÙƒÙ‡ Ø´Ù…Ø§ Ù†ÙŠØ§Ø² Ø¯Ø§Ø±ÙŠØ¯ Ø±Ø§ Ù…Ù‡ÙŠØ§ ÙƒÙ†Ù†Ø¯ .Ù‡Ù… Ø§ÙŠÙ…ÙŠÙ„ Ùˆ Ù‡Ù… Ø·Ø±Ø­ Ù‡Ø§',0),(309855,8608,'pr','Ø´Ø±Ø­ Ø±Ø§Ù‡Ù†Ù…Ø§ 4: Ù¾ÙƒÙŠØ¬ Ù‡Ø§ÙŠ ÙƒÙ…ÙƒÙŠ Ù…Ø§ Ø¨Ø§ Ù‡Ø± Ù†ÙˆØ¹ Ø¨ÙˆØ¯Ø¬Ù‡ Ø§ÙŠ Ø§Ø² Ù†Ø¸Ø± Ù…Ø§Ù„ÙŠ Ù…ØªÙ†Ø§Ø³Ø¨ Ù‡Ø³ØªÙ†Ø¯ ØªØ§ ÙƒÙ…Ùƒ Ù‡Ø§ÙŠ Ø´Ø®ØµÙŠ Ø±Ø§ ÙƒÙ‡ Ø´Ù…Ø§ Ù†ÙŠØ§Ø² Ø¯Ø§Ø±ÙŠØ¯ Ø±Ø§ Ù…Ù‡ÙŠØ§ ÙƒÙ†Ù†Ø¯ .Ù‡Ù… Ø§ÙŠÙ…ÙŠÙ„ Ùˆ Ù‡Ù… Ø·Ø±Ø­ Ù‡Ø§',0),(309856,8608,'tr','Bizim ekonomik yardÄ±m paketleri duyduÄŸunuz kiÅŸisel yardÄ±mÄ± saÄŸlamak iÃ§in her bÃ¼tÃ§eye uygun.  Hem e-posta ve canlÄ± destek planlarÄ± mevcut.',0),(309857,8608,'pl','Naszej pomocy niedrogie pakiety dopasowanie kaÅ¼dego budÅ¼etu do sprawowania osobistej pomocy potrzebujesz.  E-mail, jak i pomoc techniczna na Å¼ywo plany dostÄ™pne.',0),(309858,8608,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ Ð½Ð¸ Ð´Ð¾ÑÑ‚ÑŠÐ¿Ð½Ð¸ Ð¿Ð°ÐºÐµÑ‚Ð¸ Ð¾Ñ‚Ð³Ð¾Ð²Ð°Ñ€ÑÑ‚ Ð½Ð° Ð²ÑÐµÐºÐ¸ Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð´Ð° Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²ÑÑ‚ Ð»Ð¸Ñ‡Ð½Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð¸Ð¼Ð°Ñ‚Ðµ Ð½ÑƒÐ¶Ð´Ð°.  Ð˜ Ð´Ð²Ð°Ñ‚Ð° Ð¸Ð¼ÐµÐ¹Ð» Ð¸ Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð½Ð° Ð¶Ð¸Ð²Ð¾ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ Ð½Ð° Ñ€Ð°Ð·',0),(309859,8608,'ur','ÛÙ…Ø§Ø±ÛŒ Ø³Ø³ØªÛŒ Ù…Ø¯Ø¯ Ù¾ÛŒÚ©Ø¬ÙˆÚº Ú©Û’ Ú©Ø³ÛŒ Ø¨Ú¾ÛŒ Ø¨Ø¬Ù¹ Ú©Ùˆ Ø¢Ù¾ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Ø°Ø§ØªÛŒ Ù…Ø¹Ø§ÙˆÙ†Øª ÙØ±Ø§ÛÙ… Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…ÙˆØ²ÙˆÚº ÛÛ’ Û”  Ø¯ÙˆÙ†ÙˆÚº Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÙˆØ± ØªØ¹Ø§ÙˆÙ† Ù…Ù†ØµÙˆØ¨Û’ Ø¯Ø³ØªÛŒØ§Ø¨ Ø±ÛØªÛ’ ÛÛŒÚº Û',0),(309860,8608,'sr','ÐÐ°ÑˆÐ° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð°Ñ‡Ð½Ñƒ Ð¿Ð¾Ð¼Ð¾Ñ› Ð¿Ð°ÐºÐµÑ‚Ðµ Ð·Ð°Ð´Ð¾Ð²Ð¾Ñ™Ð¸Ñ‚Ð¸ ÑÐ²Ð°ÐºÐ¸ Ð±ÑƒÑŸÐµÑ‚ Ð»Ð¸Ñ‡Ð½Ñƒ Ð¿Ð¾Ð¼Ð¾Ñ› Ñ‚Ñ€ÐµÐ±Ð°.  Ð• -Ð¿Ð¾ÑˆÑ‚Ð° Ð¸ Ð¿Ð¾Ð´Ñ€ÑˆÐºÑƒ ÑƒÐ¶Ð¸Ð²Ð¾ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ ÐºÐ¾Ñ˜Ð¸ ÑÑƒ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸.',0),(309861,8608,'vi','CÃ¡c gÃ³i trá»£ giÃºp cá»§a chÃºng tÃ´i phÃ¹ há»£o má»i ngÃ¢n sÃ¡ch vÃ  cung cáº¥p trá»£ giÃºp cho má»i nhu cáº§u cá»§a báº¡n. Báº¡n cÃ³ thá»ƒ chá»n há»— trá»£ qua email hay trá»±c tiáº¿p',0),(309862,8608,'af','Ons bekostigbare hulppakkette pas enige begroting om die persoonlike steun te bied wat u nodig het.  Daar is beide e-pos en lewendige ondersteuningsplanne beskikbaar.',0),(309863,8608,'ro','Ajutorul nostru accesibile pachete potrivi orice buget pentru a oferi asistenÅ£Äƒ personalÄƒ pe care aveÅ£i nevoie.  E-mail ÅŸi planurile de suport live disponibil.',0),(309864,8608,'et','Meie taskukohane abi paketid sobivad iga eelarvest isiklik abi vajate.  E-posti ja tugiteenuseid kavad.',0),(309865,8608,'si','NaÅ¡o cenovno pomoÄ paketov prilega kateri koli proraÄuna zagotoviti osebne asistence, ki jih potrebujete.  E-poÅ¡ta in Å¾ive podporo naÄrti na voljo.',0),(309866,8608,'ba','Bantuan kami terjangkau paket fit setiap anggaran untuk memberikan bantuan pribadi yang Anda butuhkan.  Email dan dukungan hidup rencana tersedia.',0),(309867,8608,'nl','Onze betaalbare hulp pakketten passen elk budget zodat de persoonlijke begeleiding die u nodig hebt.  Zowel e-mail en live ondersteuningsplannen beschikbaar.',0),(309868,8608,'fi','Edullinen apuamme pakettiin soveltuu mihin tahansa talousarviosta tarjota henkilÃ¶kohtaista apua tarvitset.  SÃ¤hkÃ¶posti ja live tukea suunnitelmia saatavilla.',0),(309869,8608,'no','VÃ¥r rimelige hjelp pakker passer til ethvert budsjett Ã¥ tilby personlig assistanse mÃ¥.  BÃ¥de epost og live stÃ¸tteplaner tilgjengelig.',0),(309870,8608,'da','Vores overkommelig hjÃ¦lp pakker passer til ethvert budget til at yde personlig assistance du har brug for.  BÃ¥de e-mail og live support planer til rÃ¥dighed.',0),(309871,8608,'ko','ìš°ë¦¬ì˜ ì €ë ´ í•œ ë„ì›€ë§ íŒ¨í‚¤ì§€ í•„ìš”í•œ ê°œì¸ ì§€ì›ì„ ì œê³µ í•˜ëŠ” ëª¨ë“  ì˜ˆì‚°ì— ë§žëŠ”.  ë‘˜ ë‹¤ ì´ë©”ì¼ ë° í•´ë‹¹ í•˜ëŠ” ë¼ì´ë¸Œ ì§€ì› ê³„íšìž…ë‹ˆë‹¤.',0),(309872,8608,'he','×œ×¢×–×¨×ª× ×• ×¡×‘×™×¨×™× ×—×‘×™×œ×•×ª ×œ×”×ª××™× ×œ×›×œ ×›×™×¡ ×›×“×™ ×œ×¡×¤×§ ××ª ×”×¡×™×•×¢ ×”××™×©×™ ×”×“×¨×•×© ×œ×š.  ×“×•××¨ ××œ×§×˜×¨×•× ×™ ×•×”×Ÿ ×ª×•×›× ×™×•×ª ×ª×ž×™×›×” ×‘×©×™×“×•×¨ ×—×™ ×–×ž×™×Ÿ.',0),(309873,8608,'el','Î’Î¿Î®Î¸ÎµÎ¹Î¬ Î¼Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¹Ï„Î­Ï‚ Ï€Î±ÎºÎ­Ï„Î± ÎµÎ³ÎºÎ±Ï„Î±ÏƒÏ„Î®ÏƒÎ¿Ï…Î½ Î¿Ï€Î¿Î¹Î¿Î´Î®Ï€Î¿Ï„Îµ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î½Î± Ï€Î±ÏÎ­Ï‡Î¿Ï…Î½ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ® Î²Î¿Î®Î¸ÎµÎ¹Î± Ï€Î¿Ï… Ï‡ÏÎµÎ¹Î¬Î¶ÎµÏƒÏ„Îµ.  Î¤ÏŒÏƒÎ¿ Ï„Î¿ email ÎºÎ±Î¹ live Ï',0),(309874,8608,'zh','æˆ‘ä»¬æä¾›çš„å¸®åŠ©åŒ…é€‚åˆä»»ä½•é¢„ç®—ï¼Œä»¥æä¾›ä½ éœ€è¦çš„ä¸ªäººååŠ©ã€‚ç”µå­é‚®ä»¶å’Œå®žæ—¶æ”¯æŒè®¡åˆ’å‡æœ‰æ•ˆã€‚\r\n',0),(309875,8608,'sv','VÃ¥r prisvÃ¤rda hjÃ¤lp paket passar alla plÃ¥nbÃ¶cker att tillhandahÃ¥lla personlig assistans du behÃ¶ver.  BÃ¥de e-post och live-supportplaner tillgÃ¤ngliga.',0),(309876,8608,'it','Nostro aiuto convenienti pacchetti per ogni budget per fornire l\'assistenza personale Ã¨ necessario.  Entrambi email e supporto live piani disponibili.',0),(309877,8608,'tl','',0),(309878,8608,'th','Our affordable help packages fit any budget to provide the personal assistance you need.  Both email and live support plans available.',0),(309879,8608,'hi','à¤¹à¤®à¤¾à¤°à¥‡ à¤¸à¤¸à¥à¤¤à¥€ à¤®à¤¦à¤¦ à¤¸à¤‚à¤•à¥à¤² à¤†à¤ª à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤®à¥‡à¤‚ à¤¨à¤¿à¤œà¥€ à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾ à¤ªà¥à¤°à¤¦à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤¬à¤œà¤Ÿ à¤«à¤¿à¤Ÿà¥¤  à¤¦à¥‹à¤¨à¥‹à¤‚ à¤ˆà¤®à¥‡à¤² à¤”',0),(309880,8608,'ms','Bantuan kami dengan harga yang berpatutan pakej patut mengutamakan untuk memberikan bantuan peribadi yang anda perlukan.  Kedua-dua e-mel dan pelan-pelan sokongan secara langsung yang disediakan.',0),(309881,8608,'ar','Ù„Ø¯ÙŠÙ†Ø§ ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø¨Ø£Ø³Ø¹Ø§Ø± Ù…Ø¹Ù‚ÙˆÙ„Ø© Ø­Ø²Ù… ØªÙ†Ø§Ø³Ø¨ Ø£ÙŠ Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù„ØªÙ‚Ø¯ÙŠÙ… Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø© Ø§Ù„Ø´Ø®ØµÙŠØ© Ø§Ù„ØªÙŠ ØªØ­ØªØ§Ø¬ Ø¥Ù„ÙŠÙ‡Ø§.  Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ ÙˆØ®Ø·Ø· Ø¯Ø¹Ù… Ø§Ù„Ø¹ÙŠØ´ Ø§Ù„Ù…ØªØ§Ø­Ø©.',0),(309882,8608,'fr','Notre aide abordable paquets sâ€™adapter nâ€™importe quel budget pour fournir lâ€™assistance personnelle, vous avez besoin.  Les deux email et vivent les plans dâ€™assistance disponibles.',0),(309883,8608,'jp','ç§ãŸã¡ã®ç¾å®Ÿçš„ãªãƒ˜ãƒ«ãƒ— ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™å€‹äººçš„ãªæ´åŠ©ã‚’æä¾›ã™ã‚‹ãŸã‚ã«äºˆç®—ã«åˆã„ã¾ã™ã€‚ ãƒ¡ãƒ¼ãƒ«ã‚‚åˆ©ç”¨ã§ãã‚‹ãƒ©ã‚¤ãƒ– ã‚µãƒãƒ¼ãƒˆè¨ˆç”»ã€‚',0),(309884,8608,'pt','Nossa ajuda acessÃ­veis pacotes cabem qualquer orÃ§amento para fornecer a assistÃªncia pessoal que vocÃª precisa.  Tanto o e-mail e o suporte ao vivo planos disponÃ­veis.',0),(309885,8608,'ru','ÐÐ°ÑˆÐ¸ Ð¿Ð°ÐºÐµÑ‚Ñ‹ Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð²ÑÐµÑ… ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡Ð¸Ð²Ð°ÑŽÑ‚ Ð¸Ð½Ð´Ð¸Ð²Ð¸Ð´ÑƒÐ°Ð»ÑŒÐ½ÑƒÑŽ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒ, ÐºÐ¾Ñ‚Ð¾Ñ€Ð°Ñ Ð²Ð°Ð¼ Ð½ÑƒÐ¶Ð½Ð°. Ð¢Ð°ÐºÐ¶Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ° Ð¿Ð¾ email.',0),(309886,8608,'es','Nuestros paquetes costeables de ayuda caben dentro de cualquier presupuesto para proporcionar la asistencia personal que necesita. Planes tanto por email como apoya en vivo son disponibles',0),(309887,8608,'de','Unsere erschwinglichen Hilfe Pakete passen jedes Budget auf die persÃ¶nliche Betreuung bieten Sie benÃ¶tigen.  E-Mail und live-Support-PlÃ¤ne zur VerfÃ¼gung.',0),(309888,8608,'en','Our affordable help packages fit any budget to provide the personal assistance you need.  Both email and live support plans available.',0),(309889,8609,'is','',0),(309890,8609,'dr','4: Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(309891,8609,'pr','Ø¹Ù†ÙˆØ§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ 4: Ù¾Ø´ØªÙŠØ¨Ø§Ù†ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(309892,8609,'tr','Premium destek',0),(309893,8609,'pl','Wsparcie Premium',0),(309894,8609,'bg','ÐŸÑ€ÐµÐ¼Ð¸Ñ Ð¿Ð¾Ð´ÐºÑ€ÐµÐ¿Ð°',0),(309895,8609,'ur','Ù¾Ø±ÛŒÙ…ÛŒÙ… Ú©ÛŒ Ø­Ù…Ø§ÛŒØª',0),(309896,8609,'sr','ÐŸÑ€ÐµÐ¼Ð¸ÑƒÐ¼ Ð¿Ð¾Ð´Ñ€ÑˆÐºÐ°',0),(309897,8609,'vi','Trá»£ giÃºp cao cáº¥p',0),(309898,8609,'af','Premium Ondersteuning',0),(309899,8609,'ro','AsistenÅ£Äƒ Premium',0),(309900,8609,'et','Premium Support',0),(309901,8609,'si','Premium podpora',0),(309902,8609,'ba','Premium dukungan',0),(309903,8609,'nl','Premium-ondersteuning',0),(309904,8609,'fi','Premium-tuki',0),(309905,8609,'no','Premium-stÃ¸tte',0),(309906,8609,'da','Premium Support',0),(309907,8609,'ko','í”„ë¦¬ë¯¸ì—„ ì§€ì›',0),(309908,8609,'he','×ª×ž×™×›×ª ×¤×¨×ž×™×•×',0),(309909,8609,'el','Î¥Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î· Î±ÏƒÏ†Î±Î»Î¯ÏƒÏ„ÏÎ¿Ï…',0),(309910,8609,'zh','é«˜çº§æ”¯æŒ\r\n',0),(309911,8609,'sv','Premium-Support',0),(309912,8609,'it','Supporto Premium',0),(309913,8609,'tl','',0),(309914,8609,'th','&#3626;&#3609;&#3633;&#3610;&#3626;&#3609;&#3640;&#3609;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;(&#3648;&#3626;&#3637;&#3618;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;)',0),(309915,8609,'hi','à¤ªà¥à¤°à¥€à¤®à¤¿à¤¯à¤® à¤¸à¤®à¤°à¥à¤¥à¤¨',0),(309916,8609,'ms','Sokongan premium',0),(309917,8609,'ar','Ù‚Ø³Ø· Ø§Ù„Ø¯Ø¹Ù…',0),(309918,8609,'fr','Support Premium',0),(309919,8609,'jp','ãƒ—ãƒ¬ãƒŸã‚¢ãƒ  ãƒ» ã‚µãƒãƒ¼ãƒˆ',0),(309920,8609,'pt','Suporte Premium',0),(309921,8609,'ru','ÐŸÑ€ÐµÐ¼Ð¸ÑƒÐ¼ ÐŸÐ¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ°',0),(309922,8609,'es','Soporte Premium',0),(309923,8609,'de','Premium-Support',0),(309924,8609,'en','Premium Support',0),(309925,8610,'is','',0),(309926,8610,'dr','5: Ø§ÙŠÙ†Ø¬Ø§ Ø´Ù…Ø§ Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ ØªÚ©Øª Ù‡Ø§( Ù…Ø¬ÙˆØ²Ù‡Ø§) Ø±Ø§ Ø§Ø±Ø§Ø¦Ù‡ ÙƒÙ†ÙŠØ¯  Ùˆ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†ÙŠØ¯ ÙŠØ§ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª  Ø¢Ù†-Ù„Ø§ÙŠÙ† Ø±Ø§ Ù…Ø±ÙˆØ± ÙƒÙ†ÙŠØ¯  ÙŠØ§ Ø¨Ø±Ø§ÙŠ Ø§Ù†ØªØ´Ø§Ø±Ø§Øª Ø¢ÙŠÙ†Ø¯Ù‡ Ø§',0),(309927,8610,'pr','Ø´Ø±Ø­ Ø±Ø§Ù‡Ù†Ù…Ø§ 5: Ø§ÙŠÙ†Ø¬Ø§ Ø´Ù…Ø§ Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ø¨Ù„ÙŠØ· Ù‡Ø§( Ù…Ø¬ÙˆØ²Ù‡Ø§) Ø±Ø§ Ø§Ø±Ø§Ø¦Ù‡ ÙƒÙ†ÙŠØ¯  Ùˆ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†ÙŠØ¯ ÙŠØ§ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª  Ø¢Ù†-Ù„Ø§ÙŠÙ† Ø±Ø§ Ù…Ø±ÙˆØ± ÙƒÙ†ÙŠØ¯  ÙŠØ§ Ø¨Ø±Ø§ÙŠ Ø§Ù†ØªØ´Ø§Ø±Ø§Øª Ø¢ÙŠÙ†Ø¯Ù‡ Ø§',0),(309928,8610,'tr','Burada sen-ebilmek boyun eÄŸmek ve destek biletleri online Bilgi BankasÄ± gÃ¶zden geÃ§irmek veya izlemek gelecek NolaPro sÃ¼rÃ¼mler iÃ§in Ã¶neriler bÄ±rakÄ±n.',0),(309929,8610,'pl','Tutaj moÅ¼na zgÅ‚aszaÄ‡ & Å›ledzenie bilety wsparcia, opisz bazy wiedzy online lub zostawiÄ‡ sugestie dla przyszÅ‚ych wersjach NolaPro.',0),(309930,8610,'bg','Ð¢ÑƒÐº Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¿Ð¾Ð´Ð°Ð´ÐµÑ‚Ðµ & ÑÐ»ÐµÐ´Ð¸Ñ‚Ðµ Ð±Ð¸Ð»ÐµÑ‚Ð¸ Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°, Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð¾Ð½Ð»Ð°Ð¹Ð½ Ð±Ð°Ð·Ð° Ð¾Ñ‚ Ð·Ð½Ð°Ð½Ð¸Ñ Ð¸Ð»Ð¸ Ð¾ÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð·Ð° Ð±ÑŠÐ´ÐµÑ‰Ð¸ NolaPro Ð¸Ð·Ð´Ð°Ð½Ð¸Ñ.',0),(309931,8610,'ur','ÛŒÛØ§Úº Ø¢Ù¾ Ø¬Ù…Ø¹ Ú©Ø±ÙˆØ§Ø¦ÛŒÚº & Ù¹Ø±ÛŒÚ© Ø³Ù¾ÙˆØ±Ù¹ Ù¹Ú©Ù¹ØŒ Ø¢Ù† Ù„Ø§Ø¦Ù† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù¾Ø± Ù…Ø¨Ù†ÛŒ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº ÛŒØ§ ØªØ¬Ø§ÙˆÛŒØ² Ù…Ø³ØªÙ‚Ø¨Ù„ NolaPro Ø±ÛŒÙ„ÛŒØ² Ú©Û’ Ù„ÛŒÛ’ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº Û”',0),(309932,8610,'sr','ÐžÐ²Ð´Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´Ð¸Ñ‚Ð¸ & Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ Ð¿Ð¾Ð´Ñ€ÑˆÐºÑƒ ÐºÐ°Ñ€Ñ‚Ðµ, Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð¾Ð½Ð»Ð¸Ð½Ðµ Ð±Ð°Ð·Ðµ Ð·Ð½Ð°ÑšÐ°, Ð¸Ð»Ð¸ Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ ÑÑƒÐ³ÐµÑÑ‚Ð¸Ñ˜Ðµ Ð·Ð° Ð±ÑƒÐ´ÑƒÑ›Ðµ NolaPro Ð¸Ð·Ð´Ð°ÑšÐ°.',0),(309933,8610,'vi','HÃ£y tham gia vÃ o cá»™ng Ä‘á»“ng NolaPro. Má»i cÃ¢u há»i cá»§a báº¡n sáº½ Ä‘Æ°á»£c cÃ¡c chuyÃªn gia phÃ¡t triá»ƒn pháº§n má»m & ngÆ°á»i sá»­ dá»¥ng chuyÃªn nghiá»‡p tráº£ lá»i hÃ ng ngÃ y. ',0),(309934,8610,'af','Sluit aan by die NolaPro gemeenskap en kry u vrae beantwoord deur sagteware ontwikkelaars en ervare gebruikers wat die forums daagliks besoek.',0),(309935,8610,'ro','Aici puteÅ£i trimite & urmÄƒri bilete de sprijin, Ã®n baza de cunoÅŸtinÅ£e online de revizuire, sau lÄƒsaÅ£i sugestii pentru versiuni viitoare de NolaPro.',0),(309936,8610,'et','Liitu NolaPro foorumi kasutajatega ja saa oma kÃ¼simustele vastused, mida tarkvara arendajad ja ekspert kasutajad jÃ¤tavad, kes kasutavad foorumit igapÃ¤evaselt.',0),(309937,8610,'si','Tukaj lahko oddate & sledenje podporo vstopnic, pregled online znanja, ali pustite predloge za prihodnje NolaPro za javnost.',0),(309938,8610,'ba','Di sini Anda dapat mengirimkan & melacak dukungan Tiket, meninjau Pangkalan Pengetahuan online, atau meninggalkan saran untuk masa depan pers NolaPro.',0),(309939,8610,'nl','Hier kunt u indienen & support ticket bijhouden, de online knowledge base bekijken of laat suggesties voor toekomstige versies van de NolaPro.',0),(309940,8610,'fi','TÃ¤Ã¤llÃ¤ voit lÃ¤hettÃ¤Ã¤ & seurata tukea lippuja, tarkistaa online tietopohja tai jÃ¤ttÃ¤Ã¤ ehdotuksia NolaPro versioissa.',0),(309941,8610,'no','Her kan du sende & spore stÃ¸ttebilletter, vurdere kunnskapsbasen eller la forslag for fremtidige NolaPro utgivelser.',0),(309942,8610,'da','Her kan du indsende & spore support billetter, gennemse den online vidensbase eller forlade forslag til fremtidige NolaPro udgivelser.',0),(309943,8610,'ko','ì—¬ê¸° ì œì¶œí•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤ ë° ì§€ì› í‹°ì¼“ì„ ì¶”ì , ì˜¨ë¼ì¸ ê¸°ìˆ  ìžë£Œ ê²€í†  ë˜ëŠ” í–¥í›„ NolaPro ë¦´ë¦¬ìŠ¤ì— ëŒ€ í•œ ì œì•ˆì„ ë‘ê³ .',0),(309944,8610,'he','×›××Ÿ ××ª×” ×™×›×•×œ ×œ×©×œ×•×— & ×œ×¢×§×•×‘ ××—×¨ ×ª×ž×™×›×” ×›×¨×˜×™×¡×™×, ×œ×¡×§×•×¨ ××ª ×ž××’×¨ ×”×™×“×¢ ×”×ž×§×•×•×Ÿ ××• ×œ×”×©××™×¨ ×”×¦×¢×•×ª ×¢×ª×™×“×™×•×ª NolaPro.',0),(309945,8610,'el','Î•Î´ÏŽ Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Ï…Ï€Î¿Î²Î¬Î»Î¿Ï…Î½ & Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿Ï…Î¸ÎµÎ¯Ï„Îµ ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î± Ï…Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î·, Î½Î± ÎµÎ¾ÎµÏ„Î¬ÏƒÎµÏ„Îµ ÏƒÏ„Î·Î½ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ® Î“Î½Ï‰ÏƒÎ¹Î±ÎºÎ® Î²Î¬ÏƒÎ· Î® Î±Ï†Î®ÏƒÎµÏ„Îµ Ï€ÏÎ¿Ï„Î¬ÏƒÎµÎ¹Ï‚ Î³Î¹Î± Î¼ÎµÎ»Î»Î',0),(309946,8610,'zh','åŠ å…¥NolaProç¤¾åŒºï¼Œè®©æ¯å¤©è®¿é—®ç•™è¨€æ¿çš„è½¯ä»¶å¼€å‘è€…å’Œä¸“å®¶ç”¨æˆ·å›žç­”ä½ çš„é—®é¢˜ã€‚\r\n',0),(309947,8610,'sv','HÃ¤r kan du lÃ¤mna & spÃ¥ra supportÃ¤renden, granska den online-kunskapsbasen eller lÃ¤mna fÃ¶rslag pÃ¥ framtida NolaPro versioner.',0),(309948,8610,'it','Qui si possono presentare & traccia ticket di supporto, esaminare la knowledge base online o lasciare suggerimenti per le versioni future di NolaPro.',0),(309949,8610,'tl','',0),(309950,8610,'th','Join the NolaPro community and get your questions answered by software developers and expert users who visit the message boards daily.',0),(309951,8610,'hi','à¤¯à¤¹à¤¾à¤ à¤†à¤ª à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚ & à¤Ÿà¥à¤°à¥ˆà¤• à¤¸à¤®à¤°à¥à¤¥à¤¨ à¤Ÿà¤¿à¤•à¤Ÿ, à¤‘à¤¨à¤²à¤¾à¤‡à¤¨ à¤œà¥à¤žà¤¾à¤¨à¤•à¥‹à¤· à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¥‡à¤‚, à¤¯à¤¾ à¤­à¤µà¤¿à¤·à¥à¤¯ NolaPro à¤µà¤¿à¤œà¥à¤žà¤',0),(309952,8610,'ms','Di sini anda boleh menghantar & menjejaki Tiket sokongan, mengkaji asas pengetahuan dalam talian, atau biarkan cadangan untuk keluaran NolaPro di masa hadapan.',0),(309953,8610,'ar','Ù‡Ù†Ø§ ÙŠÙ…ÙƒÙ†Ùƒ Ø¥Ø±Ø³Ø§Ù„ & ØªØªØ¨Ø¹ ØªØ°Ø§ÙƒØ± Ø§Ù„Ø¯Ø¹Ù… Ø£Ùˆ Ù…Ø±Ø§Ø¬Ø¹Ø© Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ù…Ø¹Ø§Ø±Ù Ø¹Ù„Ù‰ Ø§Ù„Ø¥Ù†ØªØ±Ù†ØªØŒ Ø£Ùˆ ØªØ±Ùƒ Ø§Ù„Ø§Ù‚ØªØ±Ø§Ø­Ø§Øª Ù„Ù„Ø¥ØµØ¯Ø§Ø±Ø§Øª Ø§Ù„Ù…Ø³ØªÙ‚Ø¨Ù„ÙŠØ© NolaPro.',0),(309954,8610,'fr','Ici, vous pouvez soumettre & suivre les tickets de support, de vÃ©rifier la base de connaissances en ligne ou laisser des suggestions pour les futures versions de NolaPro.',0),(309955,8610,'jp','ã“ã“ã§é€ä¿¡ã§ãã¾ã™ãƒ» ã‚µãƒãƒ¼ãƒˆ ãƒã‚±ãƒƒãƒˆã‚’è¿½è·¡ã€ã‚ªãƒ³ãƒ©ã‚¤ãƒ³ã®çŸ¥è­˜ãƒ™ãƒ¼ã‚¹ã‚’ç¢ºèªã¾ãŸã¯ NolaPro å°†æ¥ã®ææ¡ˆã‚’æ®‹ã—ã¾ã™ã€‚',0),(309956,8610,'pt','Aqui vocÃª pode enviar & acompanhar tickets de suporte, rever a base de conhecimento on-line ou deixe sugestÃµes para futuros NolaPro lanÃ§amentos.',0),(309957,8610,'ru','ÐŸÑ€Ð¸ÑÐ¾ÐµÐ´Ð¸Ð½Ð¸Ñ‚ÐµÑÑŒ Ðº  NolaPro Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¾Ñ‚Ð²ÐµÑ‚Ñ‹ Ð½Ð° Ð²Ð¾Ð¿Ñ€Ð¾ÑÑ‹ Ð¾Ñ‚ Ñ€Ð°Ð·Ñ€Ð°Ð±Ð¾Ñ‚Ñ‡Ð¸ÐºÐ¾Ð² Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ð½Ð¾Ð³Ð¾ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ñ Ð¸ Ð¾Ð¿Ñ‹Ñ‚Ð½Ñ‹Ñ… Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹.',0),(309958,8610,'es','Inscribe en la comunidad de NolaPro y sus preguntas se contestarÃ¡n por desarrolladores de programas y usuarios expertos quienes revisan los tableros de noticias diariamente',0),(309959,8610,'de','Hier kÃ¶nnen Sie einreichen & verfolgen Sie Support-Tickets, die Online-Knowledge-Base Ã¼berprÃ¼fen oder lassen Sie VorschlÃ¤ge fÃ¼r zukÃ¼nftige NolaPro Versionen.',0),(309960,8610,'en','Here you can submit & track support tickets, review the online knowledge base, or leave suggestions for future NolaPro releases.',0),(309961,8611,'is','',0),(309962,8611,'dr','5: Ø³Ø§ÙŠØª Ù¾Ø´ØªÙŠØ¨Ø§Ù†  Ø³Ø§ÙØª ÙˆÛŒØ± ',0),(309963,8611,'pr','Ø¹Ù†ÙˆØ§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ 5: Ø³Ø§ÙŠØª Ù¾Ø´ØªÙŠØ¨Ø§Ù†  Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ',0),(309964,8611,'tr','NolaPro destek sitesi',0),(309965,8611,'pl','NolaPro wsparcie witryny',0),(309966,8611,'bg','NolaPro Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð½Ð° ÑÐ°Ð¹Ñ‚Ð°',0),(309967,8611,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ø³Ù¾ÙˆØ±Ù¹ Ø³Ø§Ø¦Ù¹',0),(309968,8611,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð¿Ð¾Ð´Ñ€ÑˆÐºÐµ',0),(309969,8611,'vi','Diá»…n Ä‘Ã n NolaPro',0),(309970,8611,'af','NolaPro Forum',0),(309971,8611,'ro','Site-ul NolaPro sprijin',0),(309972,8611,'et','NolaPro foorum',0),(309973,8611,'si','Mestu za podporo NolaPro',0),(309974,8611,'ba','Situs NolaPro dukungan',0),(309975,8611,'nl','NolaPro Support Site',0),(309976,8611,'fi','NolaPro tukisivustolla',0),(309977,8611,'no','NolaPro stÃ¸tte',0),(309978,8611,'da','NolaPro Support-websted',0),(309979,8611,'ko','NolaPro ì§€ì› ì‚¬ì´íŠ¸',0),(309980,8611,'he','××ª×¨ ×ª×ž×™×›×ª NolaPro',0),(309981,8611,'el','NolaPro Ï…Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î· ÏƒÏ„Î¿Î½ Ï„ÏŒÏ€Î¿ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(309982,8611,'zh','NolaProæ”¯æŒç«™ç‚¹\r\n',0),(309983,8611,'sv','NolaPro supportwebbplats',0),(309984,8611,'it','Sito di supporto NolaPro',0),(309985,8611,'tl','',0),(309986,8611,'th','&#3585;&#3632;&#3607;&#3641;&#3657;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610; NolaPro',0),(309987,8611,'hi','NolaPro à¤¸à¤®à¤°à¥à¤¥à¤¨ à¤¸à¤¾à¤‡à¤Ÿ',0),(309988,8611,'ms','NolaPro sokongan Site',0),(309989,8611,'ar','Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø¯Ø¹Ù… Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ',0),(309990,8611,'fr','Site de Support NolaPro',0),(309991,8611,'jp','NolaPro ã‚µãƒãƒ¼ãƒˆ ã‚µã‚¤ãƒˆ',0),(309992,8611,'pt','NolaPro suporte Site',0),(309993,8611,'ru','Ð¤Ð¾Ñ€ÑƒÐ¼ NolaPro',0),(309994,8611,'es','NolaPro FÃ³rum',0),(309995,8611,'de','Artikel-Support-Website',0),(309996,8611,'en','NolaPro Support Site',0),(309997,8612,'is','',0),(309998,8612,'dr','6: Ø¨Ø±Ø§ÙŠ ÙƒØ³Ø§Ù†ÙŠ ÙƒÙ‡ ÙŠÙƒ Ø±ÙˆØ´ Ø¹Ù…Ù„ÙŠ Ø±Ø§ Ù…Ø¯ Ù†Ø¸Ø± Ø¯Ø§Ø±Ù†Ø¯ Ø§ÙŠÙ† Ø¢Ù…ÙˆØ²Ø´Ù‡Ø§ÙŠ ÙˆÙŠØ¯Ø¦ÙˆÙŠÙŠ Ø¨Ù‡ Ø´Ù…Ø§ Ø¯Ø± ÙŠØ§Ø¯Ú¯ÙŠØ±ÙŠ Ø³Ø±ÙŠØ¹ Ø¨Ø³ÙŠØ§Ø±ÙŠ Ø§Ø² Ø¬Ù†Ø¨Ù‡ Ù‡Ø§ÙŠ Ø§ÙŠÙ† Ø³Ø§ÙŠØª ÙƒÙ…Ùƒ Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯ ',0),(309999,8612,'pr','Ø´Ø±Ø­ Ø±Ø§Ù‡Ù†Ù…Ø§ 6: Ø¨Ø±Ø§ÙŠ ÙƒØ³Ø§Ù†ÙŠ ÙƒÙ‡ ÙŠÙƒ Ø±ÙˆØ´ Ø¹Ù…Ù„ÙŠ Ø±Ø§ Ù…Ø¯ Ù†Ø¸Ø± Ø¯Ø§Ø±Ù†Ø¯ Ø§ÙŠÙ† Ø¢Ù…ÙˆØ²Ø´Ù‡Ø§ÙŠ ÙˆÙŠØ¯Ø¦ÙˆÙŠÙŠ Ø¨Ù‡ Ø´Ù…Ø§ Ø¯Ø± ÙŠØ§Ø¯Ú¯ÙŠØ±ÙŠ Ø³Ø±ÙŠØ¹ Ø¨Ø³ÙŠØ§Ø±ÙŠ Ø§Ø² Ø¬Ù†Ø¨Ù‡ Ù‡Ø§ÙŠ Ø§ÙŠÙ† Ø³Ø§ÙŠØª ÙƒÙ…Ùƒ Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯ ',0),(310000,8612,'tr','Olanlar lehine daha pratik bir yaklaÅŸÄ±m iÃ§in bu videolarÄ± NolaPro Oda Ã§ok yÃ¶nlÃ¼ hÄ±zlÄ± bir ÅŸekilde Ã¶ÄŸrenmenize yardÄ±mcÄ± olacaktÄ±r.',0),(310001,8612,'pl','Dla tych, ktÃ³rzy sprzyjajÄ… bardziej praktyczne podejÅ›cie te filmy pomoÅ¼e Ci szybko dowiedzieÄ‡ siÄ™ wiele aspektÃ³w pakietu NolaPro.',0),(310002,8612,'bg','Ð—Ð° Ñ‚ÐµÐ·Ð¸, ÐºÐ¾Ð¸Ñ‚Ð¾ Ð¿Ð¾Ð´ÐºÑ€ÐµÐ¿ÑÑ‚ Ð¿Ð¾-Ð¿Ñ€Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ Ñ‚ÐµÐ·Ð¸ ÐºÐ»Ð¸Ð¿Ð¾Ð²Ðµ Ñ‰Ðµ Ð²Ð¸ Ð¿Ð¾Ð¼Ð¾Ð³Ð½Ðµ Ð´Ð° Ð±ÑŠÑ€Ð·Ð¾ Ð´Ð° ÑÐµ Ð½Ð°ÑƒÑ‡Ð°Ñ‚ Ð¼Ð½Ð¾Ð³Ð¾ Ð°ÑÐ¿ÐµÐºÑ‚Ð¸ Ð½Ð° Ð¿Ð°ÐºÐµÑ‚Ð° NolaPro.',0),(310003,8612,'ur','ÙˆÛ Ù„ÙˆÚ¯ Ø¬Ùˆ ØªØ­ÙÛ Ø§ÛŒÚ© Ø²ÛŒØ§Ø¯Û Ø¹Ù…Ù„ÛŒ Ù†Ù‚Ø·Û Ù†Ø¸Ø± Ú©Û’ Ù„Ø¦Û’, ÛŒÛ ÙˆÛŒÚˆÛŒÙˆØ² Ø¬Ù„Ø¯ Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ø³ÙˆÙ¹ Ú©Û’ Ø¨ÛØª Ø³Û’ Ù¾ÛÙ„ÙˆØ¤Úº Ú©Û’ Ù…ØªØ¹Ù„Ù‚ Ø¬Ø§Ù†ÛŒÚº Ù…Ø¯Ø¯ Ú©Ø±Û’ Ú¯Ø§ Û”',0),(310004,8612,'sr','Ð—Ð° Ð¾Ð½Ðµ ÐºÐ¾Ñ˜Ð¸ Ð²Ð¾Ð»Ðµ Ð¼Ð°Ð»Ð¾ Ð¿Ñ€Ð°ÐºÑ‚Ð¸Ñ‡Ð½Ð¸Ñ˜Ð¸ Ð¿Ñ€Ð¸Ð»Ð°Ð·, Ð¾Ð²Ð¸ ÑÐ½Ð¸Ð¼Ñ†Ð¸ Ñ›Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸ Ð´Ð° Ð±Ñ€Ð·Ð¾ Ð½Ð°ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¼Ð½Ð¾Ð³Ð¸Ð¼ Ð°ÑÐ¿ÐµÐºÑ‚Ð¸Ð¼Ð° Ñƒ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð°Ð¿Ð°Ñ€Ñ‚Ð¼Ð°Ð½Ñƒ.',0),(310005,8612,'vi','Náº¿u báº¡n thá»±c táº¿ video hÆ°á»›ng dáº«n cá»§a NolaPro sáº½ giÃºp báº¡n tÃ¬m hiá»ƒu NolaPro nhanh chÃ³ng. ',0),(310006,8612,'af','Vir diegene wat ten gunste is van \'n meer praktiese benadering, sal hierdie opleidingsvideo help om die vele fassete van die NolaPro groep vinnig baas te raak.',0),(310007,8612,'ro','Pentru cei care favorizeazÄƒ o abordare mai practice, aceste clipuri video va ajuta sÄƒ Ã®nveÅ£i repede multe faÅ£ete de NolaPro suite.',0),(310008,8612,'et','Neile, kes pooldavad pigem praktiline lÃ¤henemine, need videod abil saate kiiresti teada, mitu tahku NolaPro sviit.',0),(310009,8612,'si','Za tiste, ki dajejo prednost bolj praktiÄen pristop, ti videi vam bo pomagal hitro nauÄili Å¡tevilnih vidikov NolaPro suite.',0),(310010,8612,'ba','Bagi mereka yang mendukung suatu pendekatan yang lebih praktis, video ini akan membantu Anda dengan cepat belajar banyak segi NolaPro suite.',0),(310011,8612,'nl','Voor degenen die een meer praktische aanpak gunst, zal deze video\'s helpen je snel leren de vele facetten van de NolaPro suite.',0),(310012,8612,'fi','Niille, jotka kannattavat lÃ¤hestymistapa nÃ¤itÃ¤ videoita avulla opit nopeasti monia puolia NolaPro suite.',0),(310013,8612,'no','For de som foretrekker en praktisk tilnÃ¦rming, vil disse videoene hjelpe deg raskt lÃ¦re mange fasetter av NolaPro suiten.',0),(310014,8612,'da','For dem, der foretrÃ¦kker en mere praktisk tilgang, vil disse videoer hjÃ¦lpe dig hurtigt lÃ¦re de mange facetter af NolaPro suite.',0),(310015,8612,'ko','ë³´ë‹¤ ì‹¤ìš©ì ì¸ ì ‘ê·¼ì„ ì„ í˜¸ í•˜ëŠ” ì‚¬ëžŒë“¤ì„ ìœ„í•´ì´ ë™ì˜ìƒ ë¹¨ë¦¬ NolaPro ì œí’ˆêµ°ì˜ ë‹¤ì–‘ í•œ ì¸¡ë©´ì„ ë°°ìš¸ ë„ì›€ì´ ë©ë‹ˆë‹¤.',0),(310016,8612,'he','×œ××œ×• ×”×ž×¢×“×™×¤×™× ×‘×’×™×©×” ×ž×¢×©×™×ª ×™×•×ª×¨, ×¡×¨×˜×™ ×”×•×•×™×“××• ×”××œ×” ×™×¢×–×•×¨ ×œ×š ×œ×œ×ž×•×“ ×‘×ž×”×™×¨×•×ª ××ª ×”×¦×“×“×™× ×”×¨×‘×™× ×©×œ ×”×¡×•×•×™×˜×” NolaPro.',0),(310017,8612,'el','Î“Î¹Î± ÎµÎºÎµÎ¯Î½Î¿Ï…Ï‚ Ï€Î¿Ï… ÎµÏ…Î½Î¿Î¿ÏÎ½ Î¼Î¹Î± Ï€Î¹Î¿ Ï€ÏÎ±ÎºÏ„Î¹ÎºÎ® Ï€ÏÎ¿ÏƒÎ­Î³Î³Î¹ÏƒÎ·, Î±Ï…Ï„Î¬ Ï„Î± Î²Î¯Î½Ï„ÎµÎ¿ Î¸Î± ÏƒÎ±Ï‚ Î²Î¿Î·Î¸Î®ÏƒÎµÎ¹ Î½Î± Î¼Î¬Î¸ÎµÏ„Îµ Î³ÏÎ®Î³Î¿ÏÎ± Ï„Î¹Ï‚ Ï€Î¿Î»Î»Î­Ï‚ Ï€Ï„Ï…Ï‡Î­Ï‚ Ï„Î·Ï‚ ÏƒÎ¿Ï…Î¯Ï„Î±Ï‚ NolaPro.',0),(310018,8612,'zh','å¯¹äºŽé‚£äº›æ”¯æŒæ›´å®žé™…çš„åšæ³•çš„ç”¨æˆ·ï¼Œè¿™äº›åŸ¹è®­è§†é¢‘ä¼šå¸®åŠ©ä½ å¿«é€Ÿå­¦ä¼šNolaProç³»åˆ—ç•Œé¢ã€‚\r\n',0),(310019,8612,'sv','FÃ¶r dem som fÃ¶redrar ett mer praktiskt tillvÃ¤gagÃ¥ngssÃ¤tt, hjÃ¤lper dessa filmer dig att snabbt lÃ¤ra sig de mÃ¥nga aspekterna av NolaPro sviten.',0),(310020,8612,'it','Per coloro che favoriscono un approccio piÃ¹ pratico, questi video vi aiuterÃ  a imparare velocemente le molteplici sfaccettature della suite NolaPro.',0),(310021,8612,'tl','',0),(310022,8612,'th','For those who favor a more practical approach, these training videos will help you quickly learn the many facets of the NolaPro suite.',0),(310023,8612,'hi','à¤œà¥‹ à¤à¤• à¤”à¤° à¤…à¤§à¤¿à¤• à¤µà¥à¤¯à¤¾à¤µà¤¹à¤¾à¤°à¤¿à¤• à¤¦à¥ƒà¤·à¥à¤Ÿà¤¿à¤•à¥‹à¤£ à¤à¤¹à¤¸à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤, à¤†à¤ª à¤œà¤²à¥à¤¦à¥€ à¤¸à¥‡ à¤¸à¥€à¤– NolaPro à¤¸à¥à¤‡à¤Ÿ à¤•à¥‡ à¤•à¤ˆ à¤ªà¤¹à¤²à¥à¤“à¤‚ à¤‡à¤¨ à¤µà¥€à¤¡à¤¿à¤¯à¥‹ à¤®à¥‡à¤',0),(310024,8612,'ms','Bagi mereka yang memihak kepada pendekatan yang lebih praktikal, video ini akan membantu anda belajar dengan cepat dalam banyak aspek, NolaPro suite.',0),(310025,8612,'ar','Ù„Ø£ÙˆÙ„Ø¦Ùƒ Ø§Ù„Ø°ÙŠÙ† ÙŠÙØ¶Ù„ÙˆÙ† Ø§ØªØ¨Ø§Ø¹ Ù†Ù‡Ø¬ Ø¹Ù…Ù„ÙŠ Ø£ÙƒØ«Ø±ØŒ Ø³ÙˆÙ Ø£Ø´Ø±Ø·Ø© Ø§Ù„ÙÙŠØ¯ÙŠÙˆ Ù‡Ø°Ù‡ ØªØ³Ø§Ø¹Ø¯Ùƒ Ø¹Ù„Ù‰ ØªØ¹Ù„Ù… Ø§Ù„ÙƒØ«ÙŠØ± Ù…Ù† Ø¬ÙˆØ§Ù†Ø¨ Ø¬Ù†Ø§Ø­ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ø¨Ø³Ø±Ø¹Ø©.',0),(310026,8612,'fr','Pour ceux qui favorisent une approche plus pratique, ces vidÃ©os vous aideront Ã  apprendre rapidement les nombreuses facettes de la suite NolaPro.',0),(310027,8612,'jp','å®Ÿç”¨çš„ãªã‚¢ãƒ—ãƒ­ãƒ¼ãƒã‚’å¥½ã‚€äººã®ãŸã‚ã“ã‚Œã‚‰ã®ãƒ“ãƒ‡ã‚ªã¯ã™ãã«å­¦ç¿’ã§ãã¾ã™ NolaPro ã‚¹ã‚¤ãƒ¼ãƒˆã®å¤šãã®å´é¢ã€‚',0),(310028,8612,'pt','Para aqueles que preferem uma abordagem mais prÃ¡tica, estes vÃ­deos irÃ£o ajudÃ¡-lo a aprender rapidamente as muitas facetas do NolaPro suite.',0),(310029,8612,'ru','Ð”Ð»Ñ Ñ‚ÐµÑ…, ÐºÑ‚Ð¾ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°ÐµÑ‚ Ð±Ð¾Ð»ÐµÐµ Ð¿Ñ€Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ - ÑÑ‚Ð¸ ÑƒÑ‡ÐµÐ±Ð½Ñ‹Ðµ Ð²Ð¸Ð´ÐµÐ¾ Ð¿Ð¾Ð¼Ð¾Ð³ÑƒÑ‚ Ð’Ð°Ð¼ Ð±Ñ‹ÑÑ‚Ñ€Ð¾ Ð¸Ð·ÑƒÑ‡Ð¸Ñ‚ÑŒ  NolaPro.',0),(310030,8612,'es','Para los que prefieren un enfoque mÃ¡s prÃ¡ctico, Estos videos de entrenamiento ayudarÃ¡n a usted aprender rapidamente las facetas varias del suite de NolaPro',0),(310031,8612,'de','FÃ¼r diejenigen, die einen praktischeren Ansatz bevorzugen, hilft Ihnen schnell zu lernen, die vielen Facetten der Artikel Suite diese Videos.',0),(310032,8612,'en','For those who favor a more practical approach, these videos will help you quickly learn the many facets of the NolaPro suite.',0),(310033,8613,'is','',0),(310034,8613,'dr','6: Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÙŠ Ø¢Ù…ÙˆØ²Ø´ ÙˆÙŠØ¯Ø¦ÙˆÙŠÙŠ',0),(310035,8613,'pr','Ø¹Ù†ÙˆØ§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ 6: Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÙŠ Ø¢Ù…ÙˆØ²Ø´ ÙˆÙŠØ¯Ø¦ÙˆÙŠÙŠ',0),(310036,8613,'tr','Video EÄŸitim kÃ¼tÃ¼phane (sÃ¼rÃ¼m 4)',0),(310037,8613,'pl','Biblioteki wideo szkolenia (wersja 4)',0),(310038,8613,'bg','Ð’Ð¸Ð´ÐµÐ¾ Ð¾Ð±ÑƒÑ‡ÐµÐ½Ð¸Ðµ Ð±Ð¸Ð±Ð»Ð¸Ð¾Ñ‚ÐµÐºÐ° (Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ 4)',0),(310039,8613,'ur','ÙˆÛŒÚˆÛŒÙˆ Ù¹Ø±ÛŒÙ†Ù†Ú¯ Ù„Ø§Ø¦Ø¨Ø±ÛŒØ±ÛŒ (ÙˆØ±Ú˜Ù† 4)',0),(310040,8613,'sr','Ð’Ð¸Ð´ÐµÐ¾Ñ‚ÐµÐºÐ° Ð¾Ð±ÑƒÐºÑƒ (Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð° 4)',0),(310041,8613,'vi','ThÆ° viá»‡n hÆ°á»›ng dáº«n qua Video',0),(310042,8613,'af','Video Opleiding Biblioteek',0),(310043,8613,'ro','Biblioteca video de instruire (versiune 4)',0),(310044,8613,'et','Video koolitus Raamatukogu (versioon 4)',0),(310045,8613,'si','Video usposabljanje knjiÅ¾nice (razliÄica 4)',0),(310046,8613,'ba','Perpustakaan video pelatihan',0),(310047,8613,'nl','Video Training bibliotheek (versie 4)',0),(310048,8613,'fi','Video koulutus-kirjasto (versio 4)',0),(310049,8613,'no','Video trening biblioteket (versjon 4)',0),(310050,8613,'da','Video uddannelse Library (version 4)',0),(310051,8613,'ko','ë¹„ë””ì˜¤ êµìœ¡ ë¼ì´ë¸ŒëŸ¬ë¦¬ (ë²„ì „ 4)',0),(310052,8613,'he','×¡×¤×¨×™×™×ª ×”×“×¨×›×” ×•×™×“××• (×’×™×¨×¡×” 4)',0),(310053,8613,'el','Î’Î¯Î½Ï„ÎµÎ¿ Î²Î¹Î²Î»Î¹Î¿Î¸Î®ÎºÎ· ÎºÎ±Ï„Î¬ÏÏ„Î¹ÏƒÎ·Ï‚ (Î­ÎºÎ´Î¿ÏƒÎ· 4)',0),(310054,8613,'zh','åŸ¹è®­è§†é¢‘å›¾ä¹¦é¦†\r\n',0),(310055,8613,'sv','Video Training Library (version 4)',0),(310056,8613,'it','Formazione video Library',0),(310057,8613,'tl','',0),(310058,8613,'th','&#3623;&#3637;&#3604;&#3637;&#3650;&#3629;&#3626;&#3629;&#3609;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(310059,8613,'hi','à¤µà¥€à¤¡à¤¿à¤¯à¥‹ à¤ªà¥à¤°à¤¶à¤¿à¤•à¥à¤·à¤£ à¤ªà¥à¤¸à¥à¤¤à¤•à¤¾à¤²à¤¯ (4 à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£)',0),(310060,8613,'ms','Video Latihan Perpustakaan (versi 4)',0),(310061,8613,'ar','Ù…ÙƒØªØ¨Ø© Ø§Ù„ÙÙŠØ¯ÙŠÙˆ Ù„Ù„ØªØ¯Ø±ÙŠØ¨ (Ø§Ù„Ø¥ØµØ¯Ø§Ø± 4)',0),(310062,8613,'fr','VidÃ©othÃ¨que de formation (version 4)',0),(310063,8613,'jp','ãƒ“ãƒ‡ã‚ª ãƒˆãƒ¬ãƒ¼ãƒ‹ãƒ³ã‚° ãƒ» ãƒ©ã‚¤ãƒ–ãƒ©ãƒª (ãƒãƒ¼ã‚¸ãƒ§ãƒ³ 4)',0),(310064,8613,'pt','Videoteca de formaÃ§Ã£o (versÃ£o 4)',0),(310065,8613,'ru','Ð£Ñ‡ÐµÐ±Ð½Ð°Ñ Ð’Ð¸Ð´ÐµÐ¾ Ð‘Ð¸Ð±Ð»Ð¸Ð¾Ñ‚ÐµÐºÐ°',0),(310066,8613,'es','Biblioteca de Entrenamiento por Video',0),(310067,8613,'de','Video-Training-Bibliothek (Version 4)',0),(310068,8613,'en','Video Training Library (version 4)',0),(310069,8614,'is','',0),(310070,8614,'dr','7 :Ø§ÙŠÙ† Ø±Ø¦ÙˆØ³ Ù…Ø·Ø§Ù„Ø¨ Ø¢Ø³Ø§Ù† ÙƒÙ‡ Ø´Ù…Ø§ Ù…ÙŠØªÙˆØ§Ù†ÙŠØ¯ Ø¯Ø± Ø¹Ø±Ø¶ Ú†Ù†Ø¯ Ø¯Ù‚ÙŠÙ‚Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¢Ù†Ø±Ø§ Ø§Ø¬Ø±Ø§ ÙŠØ§ Ø®Ø§Ù…ÙˆØ´ ÙƒÙ†ÙŠØ¯ ',0),(310071,8614,'pr','Ø´Ø±Ø­ Ø±Ø§Ù‡Ù†Ù…Ø§ 7 :Ø§ÙŠÙ† Ø±Ø¦ÙˆØ³ Ù…Ø·Ø§Ù„Ø¨ Ø¢Ø³Ø§Ù† ÙƒÙ‡ Ø´Ù…Ø§ Ù…ÙŠØªÙˆØ§Ù†ÙŠØ¯ Ø¯Ø± Ø¹Ø±Ø¶ Ú†Ù†Ø¯ Ø¯Ù‚ÙŠÙ‚Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¢Ù†Ø±Ø§ Ø§Ø¬Ø±Ø§ ÙŠØ§ Ø®Ø§Ù…ÙˆØ´ ÙƒÙ†ÙŠØ¯ ',0),(310072,8614,'tr','Bu kolay anahat baÅŸarÄ±yla kadar olacak ve NolaPro ile Ã§alÄ±ÅŸan sadece birkaÃ§ dakika uzakta. (PDF formatÄ±nda)',0),(310073,8614,'pl','To proste konspektu bÄ™dÄ… czy pomyÅ›lnie siÄ™ i dziaÅ‚a z NolaPro jest zaledwie kilka minut. (PDF format)',0),(310074,8614,'bg','Ð¢Ð¾Ð·Ð¸ Ð»ÐµÑÐµÐ½ ÑÑ‚Ñ€ÑƒÐºÑ‚ÑƒÑ€Ð° Ñ‰Ðµ Ð²Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð½Ð°Ð³Ð¾Ñ€Ðµ Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð¸ Ñ NolaPro Ðµ ÑÐ°Ð¼Ð¾ Ð½Ð° Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð¸. (PDF Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚)',0),(310075,8614,'ur','ÛŒÛ Ø¢Ø³Ø§Ù† Ø¢Ø¤Ù¹ Ù„Ø§Ø¦Ù† Ø¢Ù¾ ØªÚ© Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ ÛÙˆ Ú¯ÛŒ Ø§ÙˆØ± ØµØ±Ù Ú†Ù†Ø¯ Ù…Ù†Ù¹ Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ú©Û’ Ø³Ø§ØªÚ¾ Ú†Ù„ Ø±ÛØ§ ÛÛ’ Û” (Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ø±Ù…ÛŒÙ¹)',0),(310076,8614,'sr','ÐžÐ²Ð°Ñ˜ Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚Ð°Ð²Ð°Ð½ Ð¿Ñ€Ð¸ÐºÐ°Ð· ÑÑ‚Ñ€ÑƒÐºÑ‚ÑƒÑ€Ðµ Ñ›Ðµ Ñ‚Ð¸ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð³Ð¾Ñ€Ðµ Ð¸ ÑÑƒÑÑ€ÐµÑ‚ Ñ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ñ˜Ðµ ÑÐ°Ð¼Ð¾ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð°. (ÐŸÐ”Ð¤ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚)',0),(310077,8614,'vi','HÆ°á»›ng dáº«n nÃ y sáº½ giÃºp báº¡n cháº¡y NolaPro chá»‰ trong vÃ i phÃºt. (PDF format)',0),(310078,8614,'af','Hierdie maklike oorsig sal u help om NolaPro in \'n paar minute suksesvol te loop.<br> (PDF formaat)',0),(310079,8614,'ro','AceastÄƒ schiÅ£Äƒ uÅŸor va avea tu cu succes pÃ¢nÄƒ ÅŸi rularea cu NolaPro este doar cÃ¢teva minute. (PDF format)',0),(310080,8614,'et','Selle lihtne Ã¼levaade on teil edukalt Ã¼les ja jooksis NolaPro on vaid mÃµne minuti. (PDF formaadis)',0),(310081,8614,'si','To enostavno oris ste uspeÅ¡no gor in teÄe s NolaPro je le nekaj minut. (PDF format)',0),(310082,8614,'ba','Garis besar ini mudah akan memiliki Anda berhasil sampai dan berjalan dengan NolaPro adalah hanya beberapa menit.  (PDF format)',0),(310083,8614,'nl','Dit gemakkelijk overzicht heb je met succes tot en uitvoeren met NolaPro is slechts een paar minuten. (PDF-formaat)',0),(310084,8614,'fi','TÃ¤mÃ¤ helppo luonnos olet onnistuneesti jopa ja ajetaan NolaPro on vain muutaman minuutin. (PDF-muodossa)',0),(310085,8614,'no','Lett disposisjonen vil ha deg vellykket opp og kjÃ¸rer med NolaPro er bare noen fÃ¥ minutter. (PDF-format)',0),(310086,8614,'da','Denne let disposition vil have dig med held op og kÃ¸rer med NolaPro er blot et par minutter. (PDF-format)',0),(310087,8614,'ko','ì´ ì‰¬ìš´ ê°œìš”ê¹Œì§€ ì„±ê³µì ìœ¼ë¡œ ìžˆëŠ” ê²ƒ ì´ë©° NolaPro ì‹¤í–‰ ë‹¨ì§€ ëª‡ ë¶„. (PDF í˜•ì‹)',0),(310088,8614,'he','×–×• ×—×œ×•×§×” ×œ×¨×ž×•×ª ×§×œ ×™×”×™×” ×œ×š ×‘×”×¦×œ×—×” ×œ×ž×¢×œ×” ×•×”×•× ×¨×™×¦×” ×¢× NolaPro ×¨×§ ×›×ž×” ×“×§×•×ª. (×‘×¤×•×¨×ž×˜ PDF)',0),(310089,8614,'el','Î‘Ï…Ï„ÏŒ ÎµÏÎºÎ¿Î»Î¿ Î´Î¹Î¬ÏÎ¸ÏÏ‰ÏƒÎ·Ï‚ Î¸Î± Î­Ï‡ÎµÏ„Îµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚ Î¼Î­Ï‡ÏÎ¹ ÎºÎ±Î¹ Ï„Î¿ Ï„ÏÎ­Î¾Î¹Î¼Î¿ Î¼Îµ NolaPro ÎµÎ¯Î½Î±Î¹ Î¼ÏŒÎ»Î¹Ï‚ Î»Î¯Î³Î± Î»ÎµÏ€Ï„Î¬. (ÎœÎ¿ÏÏ†Î® PDF)',0),(310090,8614,'zh','è¿™ç§ç®€ä¾¿å¤§çº²å°†è®©æ‚¨æˆåŠŸåœ°åœ¨å‡ åˆ†é’Ÿå†…å¼€å§‹å’Œè¿è¡ŒNolaPro.\r\n',0),(310091,8614,'sv','Denna lÃ¤tt Ã¶versikt fÃ¥r du framgÃ¥ngsrikt upp och kÃ¶r med NolaPro Ã¤r bara nÃ¥gra minuter. (PDF format)',0),(310092,8614,'it','Questo contorno facile avrÃ  successo fino e corsa con NolaPro Ã¨ a pochi minuti.  (Formato PDF)',0),(310093,8614,'tl','',0),(310094,8614,'th','This easy outline will have you successfully off and running with NolaPro is just a few minutes.<br> (PDF format)',0),(310095,8614,'hi','à¤‡à¤¸ à¤†à¤¸à¤¾à¤¨ à¤¬à¤¾à¤¹à¥à¤¯ à¤°à¥‡à¤–à¤¾ à¤†à¤ª à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¤à¤• à¤¹à¥ˆ à¤”à¤° à¤¬à¤¸ à¤•à¥à¤› à¤¹à¥€ à¤®à¤¿à¤¨à¤Ÿà¥‹à¤‚ à¤•à¥‡ NolaPro à¤•à¥‡ à¤¸à¤¾à¤¥ à¤šà¤² à¤°à¤¹à¥‡ à¤¹à¥ˆà¥¤ (PDF à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª)',0),(310096,8614,'ms','Rangka ini mudah akan membuat anda berjaya sehingga dan berjalan dengan NolaPro hanya beberapa minit. (PDF format)',0),(310097,8614,'ar','Ø³ÙŠÙƒÙˆÙ† Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø·Ø· Ø³Ù‡Ù„Ø© Ù„ÙƒÙ… Ø¨Ù†Ø¬Ø§Ø­ Ø­ØªÙ‰ ÙˆØ¹Ù„Ù‰ Ø§Ù„ØªÙˆØ§Ù„ÙŠ Ù…Ø¹ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ø¨Ø¶Ø¹ Ø¯Ù‚Ø§Ø¦Ù‚ ÙÙ‚Ø·. (ØªÙ†Ø³ÙŠÙ‚ PDF)',0),(310098,8614,'fr','Ce schÃ©ma simple vous aurez avec succÃ¨s jusqu\'Ã  et en cours d\'exÃ©cution avec NolaPro est Ã  quelques minutes.  (Format PDF)',0),(310099,8614,'jp','ã“ã®ç°¡å˜ãªæ¦‚è¦ã‚’æ­£å¸¸ã«ã¾ã§ã€NolaPro ã¨å®Ÿè¡Œã¯ã»ã‚“ã®æ•°åˆ†ã€‚ï¼ˆPDF å½¢å¼ï¼‰',0),(310100,8614,'pt','Este esboÃ§o fÃ¡cil vocÃª terÃ¡ Ãªxito atÃ©... e correr com NolaPro Ã© apenas alguns minutos. (Formato PDF)',0),(310101,8614,'ru','Ð­Ñ‚Ð° Ð¿Ñ€Ð¾ÑÑ‚Ð°Ñ ÑÑ…ÐµÐ¼Ð° Ð¿Ð¾Ð·Ð²Ð¾Ð»Ð¸Ñ‚ Ð²Ð°Ð¼Ð½Ð°Ñ‡Ð°Ñ‚ÑŒ ÑƒÑÐ¿ÐµÑˆÐ½ÑƒÑŽ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ñ NolaPro Ð²ÑÐµÐ³Ð¾ Ð·Ð° Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚..<br> (PDF Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚)',0),(310102,8614,'es','Esta esquema asegura que se puede instalar y manejar exitosamente el programa NolaPro en unos minutos.<br>(formato PDF)',0),(310103,8614,'de','Einfache Gliederung haben Sie erfolgreich bis und mit Artikel ist nur wenige Minuten. (PDF-Format)',0),(310104,8614,'en','This easy outline will have you successfully up and running with NolaPro is just a few minutes. (PDF format)',0),(310105,8615,'is','',0),(310106,8615,'dr','7 : Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø´Ø±ÙˆØ¹ Ø³Ø±ÙŠØ¹ ',0),(310107,8615,'pr','Ø¹Ù†ÙˆØ§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ 7 : Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø´Ø±ÙˆØ¹ Ø³Ø±ÙŠØ¹ ',0),(310108,8615,'tr','HÄ±zlÄ± BaÅŸlangÄ±Ã§ KÄ±lavuzu',0),(310109,8615,'pl','Przewodnik Szybki Start',0),(310110,8615,'bg','Ð ÑŠÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ Ð·Ð° Ð±ÑŠÑ€Ð· ÑÑ‚Ð°Ñ€Ñ‚',0),(310111,8615,'ur','ÙÙˆØ±ÛŒ Ø´Ø±ÙˆØ¹Ø§Øª Ú©Ø§ ÛØ¯Ø§ÛŒØª Ù†Ø§Ù…Û',0),(310112,8615,'sr','Ð’Ð¾Ð´Ð¸Ñ‡ Ð·Ð° Ð±Ñ€Ð·Ð¾ Ð¿Ð¾ÐºÑ€ÐµÑ‚Ð°ÑšÐµ',0),(310113,8615,'vi','HÆ°á»›ng Dáº«n Khá»Ÿi Äá»™ng Nhanh',0),(310114,8615,'af','Blits Beginnersgids',0),(310115,8615,'ro','Ghid de iniÅ£iere rapidÄƒ',0),(310116,8615,'et','LÃ¼hitutvustus',0),(310117,8615,'si','VodiÄ za hiter zaÄetek',0),(310118,8615,'ba','Panduan Ringkas',0),(310119,8615,'nl','Quick Start Guide',0),(310120,8615,'fi','Pika-aloitusopas',0),(310121,8615,'no','Hurtigstartveiledning',0),(310122,8615,'da','Vejledningen Hurtigstart',0),(310123,8615,'ko','ë¹ ë¥¸ ì‹œìž‘ ê°€ì´ë“œ',0),(310124,8615,'he','×ž×“×¨×™×š ×”×ª×—×œ×” ×ž×”×™×¨×”',0),(310125,8615,'el','ÎŸÎ´Î·Î³ÏŒÏ‚ Î³ÏÎ®Î³Î¿ÏÎ·Ï‚ Î­Î½Î±ÏÎ¾Î·Ï‚',0),(310126,8615,'zh','å¿«é€Ÿå…¥é—¨æŒ‡å—\r\n',0),(310127,8615,'sv','Quick Start Guide',0),(310128,8615,'it','Guida rapida all\'avvio',0),(310129,8615,'tl','',0),(310130,8615,'th','&#3588;&#3635;&#3649;&#3609;&#3632;&#3609;&#3635;&#3585;&#3634;&#3619;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;',0),(310131,8615,'hi','à¤¤à¥à¤µà¤°à¤¿à¤¤ à¤†à¤°à¤‚à¤­ à¤—à¤¾à¤‡à¤¡',0),(310132,8615,'ms','Panduan mula pantas',0),(310133,8615,'ar','Ø¯Ù„ÙŠÙ„ Ø§Ù„Ø¨Ø¯Ø¡ Ø§Ù„Ø³Ø±ÙŠØ¹',0),(310134,8615,'fr','Guide de dÃ©marrage rapide',0),(310135,8615,'jp','ã‚¯ã‚¤ãƒƒã‚¯ ã‚¹ã‚¿ãƒ¼ãƒˆ ã‚¬ã‚¤ãƒ‰',0),(310136,8615,'pt','Guia de inÃ­cio rÃ¡pido',0),(310137,8615,'ru','Ð ÑƒÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ ÐŸÐ¾ Ð‘Ñ‹ÑÑ‚Ñ€Ð¾Ð¼Ñƒ Ð¡Ñ‚Ð°Ñ€Ñ‚Ñƒ',0),(310138,8615,'es','Guia de Comienzo Rapido',0),(310139,8615,'de','Kurzanleitung',0),(310140,8615,'en','Quick Start Guide',0),(310141,8616,'is','',0),(310142,8616,'dr','8: Ø¨Ø±Ø§ÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„  ØªØ±Ø¬Ù…Ù‡ Ù‡Ø§ ÙŠØ§ Ù…Ø´Ø§Ø±ÙƒØª Ù‡Ø§ Ø¨Ø§ Ù…Ø§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(310143,8616,'pr','Ø´Ø±Ø­ Ø±Ø§Ù‡Ù†Ù…Ø§ 8: Ø¨Ø±Ø§ÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„  ØªØ±Ø¬Ù…Ù‡ Ù‡Ø§ ÙŠØ§ Ù…Ø´Ø§Ø±ÙƒØª Ù‡Ø§ Ø¨Ø§ Ù…Ø§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(310144,8616,'tr','Ã‡evirileri, ortaklÄ±klar ve Ã¶zel istekleri iÃ§in bize ulaÅŸÄ±n.  Muhasebe/teknik yardÄ±m iÃ§in NP destek sitesini ziyaret edin.',0),(310145,8616,'pl','TÅ‚umaczenia, partnerstwa lub niestandardowe proÅ›by skontaktuj siÄ™ z nami.  Pomocy rachunkowoÅ›ci techniczne OdwiedÅº stronÄ™ wsparcia NP.',0),(310146,8616,'bg','Ð—Ð° Ð¿Ñ€ÐµÐ²Ð¾Ð´Ð¸, Ð¿Ð°Ñ€Ñ‚Ð½ÑŒÐ¾Ñ€ÑÑ‚Ð²Ð° Ð¸Ð»Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð·Ð°ÑÐ²ÐºÐ¸ ÑÐ²ÑŠÑ€Ð¶ÐµÑ‚Ðµ ÑÐµ Ñ Ð½Ð°Ñ.  Ð—Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾/Ñ‚ÐµÑ…Ð½Ð¸Ñ‡ÐµÑÐºÐ° Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð¿Ð¾ÑÐµÑ‚ÐµÑ‚Ðµ ÑÐ°Ð¹Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð½Ð° NP.',0),(310147,8616,'ur','ØªØ±Ø¬Ù…ÛØŒ Ø´Ø±Ø§Ú©Øª Ø¯Ø§Ø±ÛŒ ÛŒØ§ Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÙˆÚº Ú©Û’ Ù„Ø¦Û’ ÛÙ… Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº Û”  Ø§Ú©Ø§Ø¤Ù†Ù¹Ù†Ú¯/ØªÚ©Ù†ÛŒÚ©ÛŒ Ù…Ø¯Ø¯ Ú©Û’ Ù„ÛŒÛ’ØŒ NP Ø³Ù¾ÙˆØ±Ù¹ Ø³Ø§Ø¦Ù¹ Ù…Ù„Ø§Ø­Ø¸Û Ú©ÛŒØ¬Ø¦ÛŒÛ’ Û”',0),(310148,8616,'sr','Ð—Ð° Ð¿Ñ€ÐµÐ²Ð¾Ð´Ðµ, Ð¿Ð°Ñ€Ñ‚Ð½ÐµÑ€ÑÑ‚Ð²Ð° Ð¸Ð»Ð¸ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ðµ Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ, ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð°Ñ.  Ð Ð°Ñ‡ÑƒÐ½Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ /Ñ‚ÐµÑ…Ð½Ð¸Ñ‡ÐºÐ° Ð¿Ð¾Ð¼Ð¾Ñ›, Ð¿Ð¾ÑÐµÑ‚Ð¸Ñ‚Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð¿Ð¾Ð´Ñ€ÑˆÐºÐµ ÐÐŸ.',0),(310149,8616,'vi','Äá»‘i vá»›i nhá»¯ng cÃ¢u há»i chung, phiÃªn dá»‹ch, hay chÆ°Æ¡ng trÃ¬nh Ä‘á»‘i tÃ¡c vui lÃ²ng liÃªn há»‡ á»Ÿ Ä‘Ã¢y. LÃ m tháº¿ nÃ o Ä‘á»ƒ liÃªn há»‡ vui lÃ²ng vÃ o NolaPro Forum.',0),(310150,8616,'af','Vir algemene vrae, vertalings, of vernootskapinfo kontak ons hier.  Vir \"hoe-om\" ondersteuning, besoek asseblief die NolaPro Forum.',0),(310151,8616,'ro','Pentru traduceri, parteneriate sau personalizate solicitÄƒri, contactaÅ£i-ne.  Ajutor contabilitate/tehnice, vizitaÅ£i site-ul suport NP.',0),(310152,8616,'et','TÃµlked, partnerlus vÃµi kohandatud taotlused, vÃµtke meiega Ã¼hendust.  Raamatupidamine/tehniline abi, kÃ¼lastage NP abi lehekÃ¼ljelt.',0),(310153,8616,'si','Za prevode, partnerstva ali zahteve po meri, se obrnite na nas.  RaÄunovodstvo/tehniÄno pomoÄ, obisk NP zaslomba poloÅ¾aj.',0),(310154,8616,'ba','Untuk terjemahan, kemitraan atau permintaan kustom, hubungi kami.  Untuk bantuan akuntansi teknis, kunjungi situs dukungan NP.',0),(310155,8616,'nl','Voor vertalingen, partnerschappen of aangepaste verzoeken, contact opnemen met ons.  Bezoek de NP-ondersteuningswebsite voor boekhouding/technische hulp.',0),(310156,8616,'fi','KÃ¤Ã¤nnÃ¶kset kumppanuuksien tai mukautettujen pyyntÃ¶jen yhteyttÃ¤.  Kirjanpito ja teknistÃ¤ apua kÃ¤y NP-tukisivustossa.',0),(310157,8616,'no','Oversettelser, partnerskap eller egendefinerte forespÃ¸rsler, kan du kontakte oss.  Regnskap og teknisk hjelp, kan du besÃ¸ke stÃ¸ttestedet NP.',0),(310158,8616,'da','For oversÃ¦ttelser kontakt partnerskaber eller brugerdefinerede anmodninger, os.  Regnskab og tekniske hjÃ¦lp, du pÃ¥ supportwebstedet NP.',0),(310159,8616,'ko','ë²ˆì—­, íŒŒíŠ¸ë„ˆ ê´€ê³„ ë˜ëŠ” ì‚¬ìš©ìž ì§€ì • ìš”ì²­ì— ëŒ€ í•œ ì €í¬ì— ê²Œ ì—°ë½.  íšŒê³„/ê¸°ìˆ  ë„ì›€ NP ì§€ì› ì‚¬ì´íŠ¸ë¥¼ ì°¸ì¡° í•˜ì‹­ì‹œì˜¤.',0),(310160,8616,'he','×ª×¨×’×•×ž×™×, ×©×•×ª×¤×•×™×•×ª ××• ×‘×§×©×•×ª ×ž×•×ª×× ××™×©×™×ª, ×¦×•×¨ ×§×©×¨.  ×œ×§×‘×œ×ª ×¢×–×¨×” ×˜×›× ×™×ª/×—×©×‘×•× ××•×ª, ×‘×§×¨ ×‘××ª×¨ ×”×ª×ž×™×›×” ×©×œ NP.',0),(310161,8616,'el','Î“Î¹Î± Î¼ÎµÏ„Î±Ï†ÏÎ¬ÏƒÎµÎ¹Ï‚, ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ­Ï‚ ÏƒÏ‡Î­ÏƒÎµÎ¹Ï‚ Î® Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· Î±Î¹Ï„Î®Î¼Î±Ï„Î±, ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î®ÏƒÏ„Îµ Î¼Î±Î¶Î¯ Î¼Î±Ï‚.  Î“Î¹Î± Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®/Ï„ÎµÏ‡Î½Î¹ÎºÎ® Î²Î¿Î®Î¸ÎµÎ¹Î±, ÎµÏ€Î¹ÏƒÎºÎµÏ†Î¸ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï„Î¿Ï€Î¿',0),(310162,8616,'zh','å¯¹äºŽä¸€èˆ¬æ€§é—®é¢˜ï¼Œç¿»è¯‘ï¼Œæˆ–åˆä¼™ä¿¡æ¯ï¼Œè¯·åœ¨è¿™é‡Œè”ç³»æˆ‘ä»¬ã€‚å¯¹äºŽâ€œå¦‚ä½•â€é—®é¢˜çš„æ”¯æŒï¼Œè¯·æŸ¥çœ‹NolaProè®ºå›ã€‚\r\n',0),(310163,8616,'sv','FÃ¶r Ã¶versÃ¤ttningar kontakta partnerskap eller egna Ã¶nskemÃ¥l, oss.  FÃ¶r redovisning och tekniska hjÃ¤lp, besÃ¶k supportwebbplatsen NP.',0),(310164,8616,'it','Per traduzioni, collaborazioni o richieste personalizzate, contattaci.  Aiuto contabile/tecnico, visitare il sito di supporto di NP.',0),(310165,8616,'tl','',0),(310166,8616,'th','For general questions, translations, or partnership info contact us here.  For \"how-to\" support, please visit the <a href=\"http://www.nolapro.com/forum\" target=\"_blank\">NolaPro Forum</a>.',0),(310167,8616,'hi','à¤…à¤¨à¥à¤µà¤¾à¤¦, à¤­à¤¾à¤—à¥€à¤¦à¤¾à¤°à¥€ à¤¯à¤¾ à¤•à¤¸à¥à¤Ÿà¤® à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤, à¤¹à¤®à¤¸à¥‡ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚à¥¤  à¤²à¥‡à¤–à¤¾/à¤¤à¤•à¤¨à¥€à¤•à¥€ à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤, NP à¤¸à¤®à¤°à¥à¤¥à¤¨ à¤¸à',0),(310168,8616,'ms','Untuk terjemahan, perkongsian atau adat permintaan, hubungi kami.  Untuk bantuan perakaunan/teknikal, lawati tapak sokongan NP.',0),(310169,8616,'ar','Ù„ØªØ±Ø¬Ù…Ø© Ø£Ùˆ Ø§Ù„Ø´Ø±Ø§ÙƒØ§Øª Ø£Ùˆ Ø·Ù„Ø¨Ø§Øª Ù…Ø®ØµØµØ©ØŒ Ø§ØªØµÙ„ Ø¨Ù†Ø§.  Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù…Ø³Ø§Ø¹Ø¯Ø© ØªÙ‚Ù†ÙŠØ© Ø§Ù„Ù…Ø­Ø§Ø³Ø¨Ø©ØŒ Ù‚Ù… Ø¨Ø²ÙŠØ§Ø±Ø© Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø¯Ø¹Ù… NP.',0),(310170,8616,'fr','Pour les traductions, les partenariats ou les requÃªtes personnalisÃ©es, contactez-nous.  Aide comptable/technique, visitez le Site de Support de NP.',0),(310171,8616,'jp','ç¿»è¨³ã€ãƒ‘ãƒ¼ãƒˆãƒŠãƒ¼ã‚·ãƒƒãƒ—ã¾ãŸã¯ã‚«ã‚¹ã‚¿ãƒ è¦æ±‚ã¯ã€ãŠå•ã„åˆã‚ã›ãã ã•ã„ã€‚ä¼šè¨ˆ/ãƒ†ã‚¯ãƒ‹ã‚«ãƒ« ãƒ˜ãƒ«ãƒ— NP ã‚µãƒãƒ¼ãƒˆ ã‚µã‚¤ãƒˆã‚’å‚ç…§ã—ã¦ãã ã•ã„ã€‚',0),(310172,8616,'pt','Para traduÃ§Ãµes, parcerias ou pedidos personalizados, contacte-nos.  Contabilidade/tÃ©cnico ajuda, visite o Site de suporte do NP.',0),(310173,8616,'ru','Ð”Ð»Ñ Ð¾Ð±Ñ‰Ð¸Ñ… Ð²Ð¾Ð¿Ñ€Ð¾ÑÐ¾Ð², Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ð°, Ð¿Ð°Ñ€Ñ‚Ð½ÐµÑ€ÑÑ‚Ð²Ðµ ÑÐ²ÑÐ¶Ð¸Ñ‚ÐµÑÑŒ Ñ Ð½Ð°Ð¼Ð¸. Ð”Ð»Ñ \"Ð¿Ñ€Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ð¹\" Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ¸, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°,Ð¿Ð¾ÑÐµÑ‚Ð¸Ñ‚Ðµ Ð¤Ð¾Ñ€ÑƒÐ¼ NolaPro.',0),(310174,8616,'es','Para cuestiones generales, traducciones, o informaciÃ³n de como puede asociar con nosotros, contacta a nosotros aqui. Para apoyo de \"como hacer\", por favor visita al <a href=\"http:www.nolapro.com/forum\" Target=\"_blank\">NolPro',0),(310175,8616,'de','Kontaktieren Sie fÃ¼r Ãœbersetzungen, Partnerschaften oder benutzerdefinierte Anfragen uns.  Buchhaltung/technische Hilfe finden Sie in der NP-Support-Website.',0),(310176,8616,'en','For translations, partnerships or custom requests, contact us.  For accounting/technical help, visit the NP SupportÂ Site.',0),(310177,8617,'is','',0),(310178,8617,'dr','ØªÙ…Ø§Ù… Ø¢Ù¾ Ú¯Ø±ÛŒØ¯Ù‡Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ù…Ø³ØªÙ…Ø± Ø¯Ø± Ø¢ÛŒÙ†Ø¯Ù‡ Ø¨Ù‡ Ù…Ø­Ø¶ Ø§Ù†ØªØ´Ø§Ø±ØµÙˆØ±Øª Ù…ÛŒ Ú¯ÛŒØ±Ø¯',0),(310179,8617,'pr','ØªÙ…Ø§Ù… Ø¢Ù¾ Ú¯Ø±ÛŒØ¯Ù‡Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ù…Ø³ØªÙ…Ø± Ø¯Ø± Ø¢ÛŒÙ†Ø¯Ù‡ Ø¨Ù‡ Ù…Ø­Ø¶ Ø§Ù†ØªØ´Ø§Ø±ØµÙˆØ±Øª Ù…ÛŒ Ú¯ÛŒØ±Ø¯',0),(310180,8617,'tr','onlar are serbest bÄ±rakmak gibi tÃ¼m gelecek sorunsuz bir ÅŸekilde yÃ¼kseltir.',0),(310181,8617,'pl','wszystkie przyszÅ‚e uaktualnienia bezproblemowo, jak sÄ… one uwalniane.',0),(310182,8617,'bg','Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð±ÑŠÐ´ÐµÑ‰Ð¸ ÑŠÐ¿Ð³Ñ€ÐµÐ¹Ð´Ð¸ Ð±ÐµÐ·Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð½Ð¾, Ñ‚ÑŠÐ¹ ÐºÐ°Ñ‚Ð¾ Ñ‚Ðµ ÑÐ° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð´ÐµÐ½Ð¸.',0),(310183,8617,'ur','ØªÙ…Ø§Ù… Ù…Ø³ØªÙ‚Ø¨Ù„ Ú¯Ø§Ø±ÚˆÙ† Ø§Ù¾Ú¯Ø±ÛŒÚˆ Ø¬ÛŒØ³Û’ Ø§Ù†Ú¾ÛŒÚº Ø±ÛØ§ Ú©Ø±Ø¯ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(310184,8617,'sr','Ð¡Ð²Ð° Ð±ÑƒÐ´ÑƒÑ›Ð½Ð¾ÑÑ‚ Ð½Ð°Ð´Ð¾Ð³Ñ€Ð°Ñ’ÑƒÑ˜Ðµ Ð½ÐµÐ¿Ñ€Ð¸Ð¼ÐµÑ‚Ð½Ð¾ Ð¿Ð¾ ÑšÐ¸Ñ…Ð¾Ð²Ð¾Ð¼ Ð¾Ð±Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÑƒ.',0),(310185,8617,'vi','táº¥t cáº£ cÃ¡c nÃ¢ng cáº¥p trong tÆ°Æ¡ng lai khÃ´ng liá»n má»™t má»‘i khi chÅ©ng bá»‹ phÃ¡ bá»',0),(310186,8617,'af','alle toekoms opsies saamsmelt as hulle vrygestel is.',0),(310187,8617,'ro','toate viitor upgrade fÄƒrÄƒ probleme Ã®n care acestea sunt eliberate.',0),(310188,8617,'et','KÃµik tulevikus uuendused sujuvalt need vabastab.',0),(310189,8617,'si','vse prihodnje nadgradnje nevidno, kot so sproÅ¡Äeni.',0),(310190,8617,'ba','masa depan semua upgrade secara lancar karena mereka dilepaskan.',0),(310191,8617,'nl','alle toekomst upgrades naadloos zodra deze worden vrijgegeven.',0),(310192,8617,'fi','kaikkia tulevia pÃ¤ivityksiÃ¤ saumattomasti koska he aari esittÃ¤mislupa.',0),(310193,8617,'no','alle fremtidige oppgraderinger sÃ¸mlÃ¸st de utgis.',0),(310194,8617,'da','alle fremtidige opgraderinger problemfrit som de er frigivet.',0),(310195,8617,'ko','ëª¨ë“  ë¯¸ëž˜ëŠ” ê·¸ë“¤ì„ í’€ì–´ ëŒ€ë¡œ ì›í™œ í•˜ ê²Œ ì—…ê·¸ë ˆì´ë“œ í•©ë‹ˆë‹¤.',0),(310196,8617,'he','×”×¢×ª×™×“ ×›×œ ×©×“×¨×•×’×™× ×‘×¦×•×¨×” ×—×œ×§×” ×›×¤×™ ×©×”× ×ž×ª×¤×¨×¡×ž×™×.',0),(310197,8617,'el','Î¿Ï€Î¿Î¹Î±Î´Î®Ï€Î¿Ï„Îµ Î¼ÎµÎ»Î»Î¿Î½Ï„Î¹ÎºÎ® Î±Î½Î±Î²Î±Î¸Î¼Î¯Î¶ÎµÎ¹ Ï‡Ï‰ÏÎ¯Ï‚ ÏÎ±Ï†Î® Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Ï„ÎµÎ¸ÎµÎ¯.',0),(310198,8617,'zh','æ‰€æœ‰æœªæ¥æ— ç—•æ›´æ–°å¦‚å‘å¸ƒæ—¶ä¸€æ ·',0),(310199,8617,'sv','alla framtida uppgraderingar sÃ¶mlÃ¶st som de slÃ¤pps.',0),(310200,8617,'it','futuro tutti gli aggiornamenti senza soluzione di continuitÃ  che vengono rilasciati.',0),(310201,8617,'tl','',0),(310202,8617,'th','à¹ƒà¸™à¸­à¸™à¸²à¸„à¸•à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸­à¸±à¸žà¹€à¸à¸£à¸”à¸­à¸¢à¹ˆà¸²à¸‡à¸£à¸²à¸šà¸£à¸·à¹ˆà¸™à¹€à¸›à¹‡à¸™à¸—à¸µà¹ˆà¸™à¸³à¸­à¸­à¸à¹ƒà¸Šà¹‰',0),(310203,8617,'hi','à¤¸à¤­à¥€ à¤­à¤µà¤¿à¤·à¥à¤¯ seamlessly à¤‰à¤¨à¥à¤¨à¤¯à¤¨ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤µà¥‡ à¤œà¤¾à¤°à¥€ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(310204,8617,'ms','masa depan semua peningkatan lancar kerana mereka akan dibebaskan.',0),(310205,8617,'ar','Ù…Ø³ØªÙ‚Ø¨Ù„ Ø¬Ù…ÙŠØ¹ Ø§Ù„ØªØ±Ù‚ÙŠØ§Øª Ø¨Ø³Ù„Ø§Ø³Ø© ÙƒÙ…Ø§ ÙŠØªÙ… Ø¥Ø·Ù„Ø§Ù‚ Ø³Ø±Ø§Ø­Ù‡Ù….',0),(310206,8617,'fr','avenir de toutes les mises Ã  niveau en toute transparence qu\'elles se libÃ¨rent.',0),(310207,8617,'jp','ãƒªãƒªãƒ¼ã‚¹ã•ã‚Œã¦ã„ã‚‹ã™ã¹ã¦ã®æœªæ¥ã‚’ã‚·ãƒ¼ãƒ ãƒ¬ã‚¹ã«ã‚¢ãƒƒãƒ—ã‚°ãƒ¬ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(310208,8617,'pt','todo futuro upgrades perfeitamente como eles sÃ£o liberados.',0),(310209,8617,'ru','Ð²ÑÐµ Ð±ÑƒÐ´ÑƒÑ‰Ð¸Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ð»Ð°Ð²Ð½Ð¾ ÐºÐ°Ðº Ð¾Ð½Ð¸ Ð±ÑƒÐ´ÑƒÑ‚ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ñ‹.',0),(310210,8617,'es','Todas Actualizaciones Futuros Estan Automaticamente integrada en el Programa',0),(310211,8617,'de','alle zukÃ¼nftigen nahtlos aktualisiert, sobald sie freigegeben werden.',0),(310212,8617,'en','all future upgrades seamlessly as they are released.',0),(310213,8618,'is','',0),(310214,8618,'dr','8: Ø§ÙŠÙ…ÙŠÙ„ Ø¯Ø± Ø®ÙˆØ§Ø³Øª Ù‡Ø§ ',0),(310215,8618,'pr','Ø¹Ù†ÙˆØ§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ 8: Ø§ÙŠÙ…ÙŠÙ„ Ø¯Ø± Ø®ÙˆØ§Ø³Øª Ù‡Ø§ ',0),(310216,8618,'tr','E-posta sorular',0),(310217,8618,'pl','Zapytania dotyczÄ…ce poczty e-mail',0),(310218,8618,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð·Ð°Ð¿Ð¸Ñ‚Ð²Ð°Ð½Ð¸Ñ',0),(310219,8618,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø§Ù†Ú©ÙˆØ§Ø¦Ø±ÛŒ',0),(310220,8618,'sr','Ð•Ð¼Ð°Ð¸Ð» Ð¸ÑÑ‚Ñ€Ð°Ð³Ðµ',0),(310221,8618,'vi','Gá»­i email yÃªu cáº§u',0),(310222,8618,'af','E-pos Navrae',0),(310223,8618,'ro','E-mail anchete',0),(310224,8618,'et','E-posti pÃ¤ringud',0),(310225,8618,'si','E-poÅ¡ta poizvedb',0),(310226,8618,'ba','Email pertanyaan',0),(310227,8618,'nl','E-mail onderzoeken',0),(310228,8618,'fi','SÃ¤hkÃ¶postikyselyiden',0),(310229,8618,'no','E-post henvendelser',0),(310230,8618,'da','E-mail henvendelser',0),(310231,8618,'ko','ì´ë©”ì¼ ë¬¸ì˜',0),(310232,8618,'he','×¤× ×™×•×ª ×“×•×',0),(310233,8618,'el','ÎˆÏÎµÏ…Î½ÎµÏ‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(310234,8618,'zh','ç”µå­é‚®ä»¶æŸ¥è¯¢\r\n',0),(310235,8618,'sv','E-post fÃ¶rfrÃ¥gningar',0),(310236,8618,'it','Domande via e-mail',0),(310237,8618,'tl','',0),(310238,8618,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3626;&#3629;&#3610;&#3606;&#3634;&#3617;',0),(310239,8618,'hi','à¤ˆà¤®à¥‡à¤² Inquiries',0),(310240,8618,'ms','E-mel pertanyaan',0),(310241,8618,'ar','Ø§Ø³ØªÙØ³Ø§Ø±Ø§Øª Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(310242,8618,'fr','Demandes de renseignements par courriel',0),(310243,8618,'jp','ãƒ¡ãƒ¼ãƒ«ãŠå•ã„åˆã‚ã›',0),(310244,8618,'pt','InquÃ©ritos de e-mail',0),(310245,8618,'ru','Email Ð—Ð°Ð¿Ñ€Ð¾ÑÑ‹',0),(310246,8618,'es','Consultas Por Email ',0),(310247,8618,'de','E-Mail-Anfragen',0),(310248,8618,'en','Email Inquiries',0),(310249,8619,'is','',0),(310250,8619,'dr','9 :Ø§ÙŠÙ† ÙƒØ§ØªØ§Ù„ÙˆÚ¯ Ø¬Ø§Ù…Ø¹ ØªÙ…Ø§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø§ÙØª ÙˆÛŒØ± Ø±Ø§ Ø¯Ø± ÙŠÙƒ Ù…ÙƒØ§Ù† Ù…Ù‡ÙŠØ§ Ù…ÙŠ ÙƒÙ†Ø¯ .Ø¨Ø±Ø§ÙŠ ÙŠØ§Ø¯Ú¯ÙŠØ±ÙŠ ÙˆØ³ÙŠØ¹ ØªØ±  ÙØ±Ø§ÙŠÙ†Ø¯Ù‡Ø§ÙŠ Ø§ÙŠÙ† Ø³Ø§ÙØª ÙˆÛŒØ± Ø¨Ø³ÙŠØ§Ø± Ù…ÙØ§Ø¯Ù…Ù†Ø¯ Ø§Ø³Øª',0),(310251,8619,'pr','Ø´Ø±Ø­ Ø±Ø§Ù‡Ù†Ù…Ø§ 9 :Ø§ÙŠÙ† ÙƒØ§ØªØ§Ù„ÙˆÚ¯ Ø¬Ø§Ù…Ø¹ ØªÙ…Ø§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø±Ø§ Ø¯Ø± ÙŠÙƒ Ù…ÙƒØ§Ù† Ù…Ù‡ÙŠØ§ Ù…ÙŠ ÙƒÙ†Ø¯ .Ø¨Ø±Ø§ÙŠ ÙŠØ§Ø¯Ú¯ÙŠØ±ÙŠ ÙˆØ³ÙŠØ¹ ØªØ±  ÙØ±Ø§ÙŠÙ†Ø¯Ù‡Ø§ÙŠ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø¨Ø³ÙŠØ§Ø± Ø³ÙˆØ¯Ù…Ù†Ø¯ Ø§Ø³Øª',0),(310252,8619,'tr','Metin olarak NolaPro bu kapsamlÄ± katalog saÄŸlar bilgileri tek bir konumda.  BÃ¼yÃ¼k NolaPro sÃ¼reÃ§lerin daha geniÅŸ Ã¶ÄŸrenme iÃ§in.',0),(310253,8619,'pl','Ten kompleksowy katalog zawiera tekstowy NolaPro informacje w jednym miejscu.  Idealne do nauki szerszego procesu NolaPro.',0),(310254,8619,'bg','Ð¢Ð¾Ð·Ð¸ Ð¿Ð¾Ð´Ñ€Ð¾Ð±ÐµÐ½ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ñ Ñ‚ÐµÐºÑÑ‚Ð¾Ð²Ð¸ NolaPro Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð½Ð° ÐµÐ´Ð½Ð¾ Ð¼ÑÑÑ‚Ð¾.  Ð§ÑƒÐ´ÐµÑÐ½Ð¾ Ð·Ð° Ð¿Ð¾-ÑˆÐ¸Ñ€Ð¾ÐºÐ¾ Ð¾Ð±ÑƒÑ‡ÐµÐ½Ð¸Ðµ Ð½Ð° NolaPro Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¸.',0),(310255,8619,'ur','Ø§Ø³ Ø¬Ø§Ù…Ø¹ Ú©ÛŒÙ¹Ù„Ø§Ú¯ Ù…ØªÙ†ÛŒ Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ ÙØ±Ø§ÛÙ… Ú©Ø±ØªØ§ ÛÛ’ Ø§ÛŒÚ© Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…ÛŒÚº ØªÙ…Ø§Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ÛÛ’ Û”  Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ú©Û’ Ø¹Ù…Ù„ Ú©Û’ ÙˆØ³ÛŒØ¹ ØªØ± Ø³ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø¨ÛØª Ø§Ú†Ú¾Ø§ ÛÛ’ Û”',0),(310256,8619,'sr','ÐžÐ²Ð°Ñ˜ ÑÐ²ÐµÐ¾Ð±ÑƒÑ…Ð²Ð°Ñ‚Ð½Ð¸ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð¿Ñ€ÑƒÐ¶Ð° ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ñ‚ÐµÐºÑÑ‚ÑƒÐ°Ð»Ð½Ð¸Ñ… Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° ÑÐ²Ðµ Ð½Ð° Ñ˜ÐµÐ´Ð½Ð¾Ñ˜ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸.  Ð¡ÑƒÐ¿ÐµÑ€ Ð¼Ð¸ Ñ˜Ðµ Ð·Ð° ÑˆÐ¸Ñ€Ðµ ÑƒÑ‡ÐµÑšÐµ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ°.',0),(310257,8619,'vi','Cuá»‘n catalog nÃ y cung cáº¥p má»i thÃ´ng tin cá»§a NolaPro nÃªn ráº¥t há»¯u Ã­ch Ä‘á»ƒ há»c cÃ¡c tiáº¿n trÃ¬nh trong NolaPro',0),(310258,8619,'af','Hierdie omvattende katalogus bied tekstuele NolaPro inligting alles-op-een plek. Dis uitstekend om breÃ«r kennis van die NolaPro prosesse te bekom.',0),(310259,8619,'ro','Acest catalog cuprinzÄƒtor oferÄƒ textuale NolaPro informaÅ£ii toate Ã®ntr-o singurÄƒ locaÅ£ie.  Mare pentru Ã®nvÄƒÅ£are mai largÄƒ a proceselor NolaPro.',0),(310260,8619,'et','PÃµhjalik kataloog pakub tekstiline NolaPro teavet kÃµik Ã¼hest kohast.  Suur laiema Ãµppe NolaPro protsesse.',0),(310261,8619,'si','Ta obseÅ¾en katalog zagotavlja besedilni NolaPro informacij na enem mestu.  Super za Å¡irÅ¡e uÄenje NolaPro procesov.',0),(310262,8619,'ba','Katalog ini komprehensif menyediakan tekstual NolaPro informasi semua dalam satu lokasi.  Besar untuk belajar yang lebih luas dari proses NolaPro.',0),(310263,8619,'nl','Deze uitgebreide catalogus biedt tekstuele NolaPro gegevens op Ã©Ã©n locatie.  Ideaal voor bredere leren van de NolaPro processen.',0),(310264,8619,'fi','Kattava luettelo tarjoaa tekstin NolaPro tiedot samaan paikkaan.  Great laajempaa oppimisen NolaPro prosesseja.',0),(310265,8619,'no','Denne omfattende katalog gir tekstlig NolaPro informasjon pÃ¥ ett sted.  Flott for bredere lÃ¦ring NolaPro prosesser.',0),(310266,8619,'da','Denne omfattende katalog giver tekstmÃ¦ssige NolaPro oplysninger pÃ¥ Ã©t sted.  Fantastisk til bredere indlÃ¦ring af NolaPro processer.',0),(310267,8619,'ko','ì´ í¬ê´„ì ì¸ ì¹´íƒˆë¡œê·¸ ì œê³µ í…ìŠ¤íŠ¸ NolaPro í•œ ìœ„ì¹˜ì— ëª¨ë“  ì •ë³´.  NolaPro í”„ë¡œì„¸ìŠ¤ì˜ ê´‘ë²”ìœ„ í•œ í•™ìŠµì„ ìœ„í•œ í›Œë¥­í•œ.',0),(310268,8619,'he','×§×˜×œ×•×’ ×ž×§×™×£ ×–×” ×ž×¡×¤×§ NolaPro ×˜×§×¡×˜×•××œ×™×™× ×ž×™×“×¢ ×”×›×œ ×‘×ž×§×•× ××—×“.  ×ž×¢×•×œ×” ×¢×‘×•×¨ ×œ×ž×™×“×” ×¨×—×‘×” ×™×•×ª×¨ ×©×œ ×ª×”×œ×™×›×™ NolaPro.',0),(310269,8619,'el','Î‘Î½Î±Î»Ï…Ï„Î¹ÎºÏŒÏ‚ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î±Ï…Ï„Î® Ï€Î±ÏÎ­Ï‡ÎµÎ¹ ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… NolaPro Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÎµ Î¼Î¯Î± Î¸Î­ÏƒÎ·.  ÎœÎµÎ³Î¬Î»Î· Î³Î¹Î± ÎµÏ…ÏÏÏ„ÎµÏÎ· Î¼Î¬Î¸Î·ÏƒÎ· Ï„Ï‰Î½ NolaPro Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¹ÏŽÎ½.',0),(310270,8619,'zh','è¿™ä¸€ç»¼åˆæ€§ç›®å½•åœ¨ä¸€ä¸ªä½ç½®æä¾›äº†NolaProæ–‡æœ¬ä¿¡æ¯ã€‚æ›´å¥½æ›´å¹¿æ³›åœ°å­¦ä¹ NolaProè¿‡ç¨‹å¤„ç†ã€‚\r\n',0),(310271,8619,'sv','Denna omfattande katalog ger textbaserade NolaPro information pÃ¥ ett stÃ¤lle.  Bra fÃ¶r vidare lÃ¤rande NolaPro processer.',0),(310272,8619,'it','Questo catalogo completo fornisce testuale NolaPro informazioni in un\'unica posizione.  Grande per un apprendimento piÃ¹ ampio dei processi NolaPro.',0),(310273,8619,'tl','',0),(310274,8619,'th','This comprehensive catalog provides textual NolaPro information all in one location.  Great for broader learning of the NolaPro processes.',0),(310275,8619,'hi','à¤‡à¤¸ à¤µà¥à¤¯à¤¾à¤ªà¤• à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤°à¤¦à¤¾à¤¨ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤Ÿà¥‡à¤•à¥à¤¸à¥à¤Ÿ NolaPro à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤à¤• à¤¹à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¸à¤­à¥€à¥¤  NolaPro à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾à¤“à¤‚ à¤•à¥€ à¤µà¥à¤¯à¤¾à¤ªà¤• à¤…',0),(310276,8619,'ms','Katalog lengkap ini menyediakan NolaPro teks maklumat semua dalam satu lokasi.  Bagus untuk pembelajaran yang lebih luas daripada proses NolaPro.',0),(310277,8619,'ar','ÙŠÙ‚Ø¯Ù… Ù‡Ø°Ø§ Ø§Ù„ÙƒØªØ§Ù„ÙˆØ¬ Ø§Ù„Ø´Ø§Ù…Ù„ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ø§Ù„Ù†ØµÙŠØ© ÙƒØ§ÙØ© Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ÙÙŠ Ù…ÙƒØ§Ù† ÙˆØ§Ø­Ø¯.  ÙƒØ¨ÙŠØ±Ø© Ù„Ù„ØªØ¹Ù„Ù… Ø£ÙˆØ³Ø¹ Ù…Ù† Ø§Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ.',0),(310278,8619,'fr','Ce catalogue trÃ¨s complet fournit textuelle NolaPro informations en un seul endroit.  IdÃ©al pour un apprentissage plus large des processus NolaPro.',0),(310279,8619,'jp','ã“ã®åŒ…æ‹¬çš„ãªã‚«ã‚¿ãƒ­ã‚°ã¯ãƒ†ã‚­ã‚¹ãƒˆ NolaPro 1 ã¤ã®å ´æ‰€ã§ã™ã¹ã¦ã®æƒ…å ±ã€‚NolaPro ãƒ—ãƒ­ã‚»ã‚¹ã®ã‚ˆã‚Šåºƒç¯„ãªå­¦ç¿’ã«æœ€é©ã§ã™ã€‚',0),(310280,8619,'pt','Este catÃ¡logo abrangente fornece NolaPro textual informaÃ§Ãµes tudo em um Ãºnico local.  Ã“timo para aprendizagem mais abrangente dos processos NolaPro.',0),(310281,8619,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð²ÑÐµÑÑ‚Ð¾Ñ€Ð¾Ð½Ð½Ð¸Ð¹ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÑÐµÑ‚ Ñ‚ÐµÐºÑÑ‚Ð¾Ð²ÑƒÑŽ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð¾ NolaPro- Ð²ÑÐµ Ð² Ð¾Ð´Ð½Ð¾Ð¼, Ð´Ð»Ñ Ð±Ð¾Ð»ÐµÐµ ÑˆÐ¸Ñ€Ð¾ÐºÐ¾Ð³Ð¾ Ð¸Ð·ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ð² NolaPro.',0),(310282,8619,'es','Este catÃ¡logo comprensivo proporciona informaciÃ³n textual de NolaPro todo en una locaciÃ³n',0),(310283,8619,'de','Diese umfassende Katalog stellt textuelle Artikel Informationen an einem Ort.  Ideal fÃ¼r breitere lernen der Artikel Prozesse.',0),(310284,8619,'en','This comprehensive catalog provides textual NolaPro information all in one location.  Great for broader learning of the NolaPro processes.',0),(310285,8620,'is','',0),(310286,8620,'dr','9 : Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù…ØªÙ†ÙŠ',0),(310287,8620,'pr','Ø¹Ù†ÙˆØ§Ù† Ø±Ø§Ù‡Ù†Ù…Ø§ 9 : Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù…ØªÙ†ÙŠ',0),(310288,8620,'tr','Metin tabanlÄ± yardÄ±m',0),(310289,8620,'pl','Pomocy opartej na tekst',0),(310290,8620,'bg','Ð¢ÐµÐºÑÑ‚Ð¾Ð²Ð¾ Ð±Ð°Ð·Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(310291,8620,'ur','Ù…ØªÙ† Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø± Ù…Ø¯Ø¯',0),(310292,8620,'sr','Ð—Ð°ÑÐ½Ð¾Ð²Ð°Ð½ Ð½Ð° Ñ‚ÐµÐºÑÑ‚Ñƒ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸',0),(310293,8620,'vi','Trá»£ giÃºp dáº¡ng vÄƒn báº£n',0),(310294,8620,'af','Teksgebaseerde Hulp',0),(310295,8620,'ro','Ajutor bazat pe text',0),(310296,8620,'et','TekstipÃµhine spikker',0),(310297,8620,'si','Besedilni pomoÄ',0),(310298,8620,'ba','Bantuan berbasis teks',0),(310299,8620,'nl','Tekst gebaseerde Help',0),(310300,8620,'fi','Teksti-pohjainen ohje',0),(310301,8620,'no','Tekstbaserte hjelp',0),(310302,8620,'da','Tekst-baseret hjÃ¦lp',0),(310303,8620,'ko','í…ìŠ¤íŠ¸ ê¸°ë°˜ ë„ì›€ë§',0),(310304,8620,'he','×¢×–×¨×” ×ž×‘×•×¡×¡×ª-×˜×§×¡×˜',0),(310305,8620,'el','Î’Î¿Î®Î¸ÎµÎ¹Î± Ï€Î¿Ï… Î²Î±ÏƒÎ¯Î¶Î¿Î½Ï„Î±Î¹ ÏƒÎµ ÎºÎµÎ¯Î¼ÎµÎ½Î¿',0),(310306,8620,'zh','åŸºäºŽæ–‡æœ¬çš„å¸®åŠ©\r\n',0),(310307,8620,'sv','Text-baserade hjÃ¤lp',0),(310308,8620,'it','Guida basata su testo',0),(310309,8620,'tl','',0),(310310,8620,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(310311,8620,'hi','à¤ªà¤¾à¤ -à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾',0),(310312,8620,'ms','Bantuan berasaskan teks',0),(310313,8620,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª ØªØ³ØªÙ†Ø¯ Ø¥Ù„Ù‰ Ø§Ù„Ù†Øµ',0),(310314,8620,'fr','Aide textuelle',0),(310315,8620,'jp','ãƒ†ã‚­ã‚¹ãƒˆ ãƒ™ãƒ¼ã‚¹ã®ãƒ˜ãƒ«ãƒ—',0),(310316,8620,'pt','Ajuda baseada em texto',0),(310317,8620,'ru','ÐšÐ°Ñ‚Ð°Ð»Ð¾Ð³ ÐŸÐ¾Ð¼Ð¾Ñ‰Ð¸',0),(310318,8620,'es','Ayuda Basada en Texto',0),(310319,8620,'de','Text-basierte Hilfe',0),(310320,8620,'en','Text-Based Help',0),(310321,8621,'is','',0),(310322,8621,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ \r\n',0),(310323,8621,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ \r\n',0),(310324,8621,'tr','Kategori Ekle',0),(310325,8621,'pl','Dodaj kategoriÄ™',0),(310326,8621,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(310327,8621,'ur','Ø²Ù…Ø±Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(310328,8621,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(310329,8621,'vi','ThÃªm PhÃ¢n Loáº¡i',0),(310330,8621,'af','Voeg \'n Kategorie by',0),(310331,8621,'ro','Adauga Categorie',0),(310332,8621,'et','Kategooria lisamine',0),(310333,8621,'si','Dodaj kategorijo',0),(310334,8621,'ba','Tambahkan Kategori',0),(310335,8621,'nl','Categorie toevoegen',0),(310336,8621,'fi','LisÃ¤Ã¤ luokka',0),(310337,8621,'no','Legge til kategori',0),(310338,8621,'da','TilfÃ¸j kategori',0),(310339,8621,'ko','ì¹´í…Œê³ ë¦¬ ì¶”ê°€',0),(310340,8621,'he','×”×•×¡×£ ×§×˜×’×•×¨×™×”',0),(310341,8621,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(310342,8621,'zh','å¢žåŠ åˆ†ç±»\r\n',0),(310343,8621,'sv','LÃ¤gg till kategori',0),(310344,8621,'it','Aggiungi categoria',0),(310345,8621,'tl','',0),(310346,8621,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3617;&#3623;&#3604;',0),(310347,8621,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(310348,8621,'ms','Tambah Kategori',0),(310349,8621,'ar','Ø¥Ø¶Ø§ÙØ© ØªØµÙ†ÙŠÙ',0),(310350,8621,'fr','Ajouter CatÃ©gorie',0),(310351,8621,'jp','ã‚«ãƒ†ã‚´ãƒªã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(310352,8621,'pt','Adicionar categoria',0),(310353,8621,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(310354,8621,'es','Agregar CategorÃ­a',0),(310355,8621,'de','Kategorie hinzufÃ¼gen',0),(310356,8621,'en','Add Category',0),(310357,8622,'is','',0),(310358,8622,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§  ÙŠÙƒ Ú¯Ø±ÙˆÙ‡ Ù¾ÙŠØºØ§Ù… Ø±Ø§ Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(310359,8622,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§  ÙŠÙƒ Ú¯Ø±ÙˆÙ‡ Ù¾ÙŠØºØ§Ù… Ø±Ø§ Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(310360,8622,'tr','Ã–nce bir mesaj Kategori oluÅŸturmanÄ±z gerekir.',0),(310361,8622,'pl','Najpierw naleÅ¼y utworzyÄ‡ kategoriÄ™ wiadomoÅ›ci.',0),(310362,8622,'bg','ÐŸÑŠÑ€Ð²Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ.',0),(310363,8622,'ur','Ø¢Ù¾ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§ÛŒÚ© Ù¾ÛŒØºØ§Ù… Ú©ÛŒ Ø²Ù…Ø±Û Ø¨Ù†Ø§Ø¦ÛŒÚº Û”',0),(310364,8622,'sr','ÐŸÑ€Ð²Ð¾ Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ð¾Ñ€ÑƒÐºÐµ.',0),(310365,8622,'vi','HÃ£y táº¡o thá»ƒ loáº¡i tin nháº¯n trÆ°á»›c',0),(310366,8622,'af','U moet eers \'n BOODSKAPKATEGORIE skep.',0),(310367,8622,'ro','Trebuie sa creati mai intai o categorie de mesaje',0),(310368,8622,'et','Te peate ennem tekitama teate kategooria',0),(310369,8622,'si','Najprej morate ustvariti sporoÄilo Kategorija.',0),(310370,8622,'ba','Anda harus terlebih dahulu membuat kategori pesan.',0),(310371,8622,'nl','U moet eerst een categorie bericht maken.',0),(310372,8622,'fi','Sinun on luotava message luokka.',0),(310373,8622,'no','Du mÃ¥ fÃ¸rst opprette en meldingskategorien.',0),(310374,8622,'da','Du skal fÃ¸rst oprette en besked kategori.',0),(310375,8622,'ko','ë¨¼ì € ë©”ì‹œì§€ ë¶„ë¥˜ë¥¼ ë§Œë“¤ì–´ì•¼ í•©ë‹ˆë‹¤.',0),(310376,8622,'he','×ª×—×™×œ×” ×¢×œ×™×š ×œ×™×¦×•×¨ ×§×˜×’×•×¨×™×” ×œ×”×•×“×¢×”.',0),(310377,8622,'el','Î ÏÎ­Ï€ÎµÎ¹ Ï€ÏÏŽÏ„Î± Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î­Î½Î± Î¼Î®Î½Ï…Î¼Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±.',0),(310378,8622,'zh','æ‚¨å¿…é¡»å…ˆå»ºç«‹ä¸€ä¸ªä¿¡æ¯ç±»åˆ«ã€‚\r\n',0),(310379,8622,'sv','Du mÃ¥ste fÃ¶rst skapa en meddelandekategori.',0),(310380,8622,'it','Ãˆ innanzitutto necessario creare una categoria di messaggio.',0),(310381,8622,'tl','',0),(310382,8622,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3626;&#3619;&#3657;&#3634;&#3591;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;&#3648;&#3611;&#3655;&#3609;&#3629;&#3618;&#3656;&#3634;&#3591;&#3',0),(310383,8622,'hi','à¤¤à¥à¤® à¤ªà¤¹à¤²à¥‡ à¤à¤• à¤¸à¤‚à¤¦à¥‡à¤¶ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¬à¤¨à¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(310384,8622,'ms','Anda mesti mencipta kategori mesej terlebih dahulu.',0),(310385,8622,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø£ÙˆÙ„Ø§Ù‹ Ø¥Ù†Ø´Ø§Ø¡ ÙØ¦Ø© Ø±Ø³Ø§Ù„Ø©.',0),(310386,8622,'fr','Vous devez d\'abord crÃ©er une catÃ©gorie de message.',0),(310387,8622,'jp','ã¾ãšã€ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ ã‚«ãƒ†ã‚´ãƒªã‚’ä½œæˆã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(310388,8622,'pt','VocÃª deve primeiro criar uma categoria de mensagem.',0),(310389,8622,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð²Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹.',0),(310390,8622,'es','Debe crear una categorÃ­a de mensaje primero.',0),(310391,8622,'de','Sie mÃ¼ssen zuerst eine Nachrichtenkategorie erstellen.',0),(310392,8622,'en','You must first create a message category.',0),(310393,8623,'is','',0),(310394,8623,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾ÙŠØºØ§Ù… Ø¬Ø¯ÙŠØ¯  ',0),(310395,8623,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾ÙŠØºØ§Ù… Ø¬Ø¯ÙŠØ¯  ',0),(310396,8623,'tr','Yeni mesaj Ekle',0),(310397,8623,'pl','Dodaj nowÄ… wiadomoÅ›Ä‡',0),(310398,8623,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(310399,8623,'ur','Ù†ÛŒØ§ Ù¾ÛŒØºØ§Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(310400,8623,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€ÑƒÐºÑƒ',0),(310401,8623,'vi','ThÃªm Tin Nháº¯n Má»›i',0),(310402,8623,'af','Nuwe Boodskap Byvoeg',0),(310403,8623,'ro','Adauga mesaj nou',0),(310404,8623,'et','Lisa uus teade',0),(310405,8623,'si','Dodajte novo sporoÄilo',0),(310406,8623,'ba','Menambahkan pesan baru',0),(310407,8623,'nl','Nieuw bericht toevoegen',0),(310408,8623,'fi','LisÃ¤Ã¤ uusi viesti',0),(310409,8623,'no','Legge til',0),(310410,8623,'da','TilfÃ¸j ny meddelelse',0),(310411,8623,'ko','ìƒˆ ë©”ì‹œì§€ë¥¼ ì¶”ê°€',0),(310412,8623,'he','×”×•×¡×£ ×”×•×“×¢×” ×—×“×©×”',0),(310413,8623,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Î¼Î®Î½Ï…Î¼Î±',0),(310414,8623,'zh','å¢žåŠ æ–°æ¶ˆæ¯\r\n',0),(310415,8623,'sv','LÃ¤gg till nytt meddelande',0),(310416,8623,'it','Aggiungi nuovo messaggio',0),(310417,8623,'tl','',0),(310418,8623,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(310419,8623,'hi','à¤¨à¤ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(310420,8623,'ms','Tambah mesej baru',0),(310421,8623,'ar','Ø¥Ø¶Ø§ÙØ© Ø±Ø³Ø§Ù„Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(310422,8623,'fr','Ajouter un nouveau Message',0),(310423,8623,'jp','æ–°ã—ã„ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(310424,8623,'pt','Adicionar nova mensagem',0),(310425,8623,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ðµ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(310426,8623,'es','Agregar Nuevo Mensaje',0),(310427,8623,'de','Neue Nachricht hinzufÃ¼gen',0),(310428,8623,'en','Add New Message',0),(310429,8624,'is','',0),(310430,8624,'dr','Ú¯Ø±ÙØªÙ† Ù¾ÙŠØºØ§Ù… ',0),(310431,8624,'pr','Ú¯Ø±ÙØªÙ† Ù¾ÙŠØºØ§Ù… ',0),(310432,8624,'tr','Ä°letileri alma',0),(310433,8624,'pl','UzyskaÄ‡ wiadomoÅ›ci',0),(310434,8624,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(310435,8624,'ur','Ù¾ÛŒØºØ§Ù…Ø§Øª Ù„Ø§Ø¦ÛŒÚº',0),(310436,8624,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð¿Ð¾Ñ€ÑƒÐºÐ°',0),(310437,8624,'vi','Nháº­n tin nháº¯n',0),(310438,8624,'af','Kry Boodskappe',0),(310439,8624,'ro','Primi mesaje',0),(310440,8624,'et','Saada sÃµnumid',0),(310441,8624,'si','Dobili sporoÄila',0),(310442,8624,'ba','Mendapatkan pesan',0),(310443,8624,'nl','Berichten ophalen',0),(310444,8624,'fi','Hae viestit',0),(310445,8624,'no','FÃ¥ meldinger',0),(310446,8624,'da','FÃ¥ beskeder',0),(310447,8624,'ko','ë©”ì‹œì§€ë¥¼ ë°›ì„',0),(310448,8624,'he','×ž×§×‘×œ ×”×•×“×¢×•×ª',0),(310449,8624,'el','Î›Î¬Î²ÎµÏ„Îµ Î¼Î·Î½ÏÎ¼Î±Ï„Î±',0),(310450,8624,'zh','èŽ·å–ä¿¡æ¯\r\n',0),(310451,8624,'sv','FÃ¥ meddelanden',0),(310452,8624,'it','Ottenere messaggi',0),(310453,8624,'tl','',0),(310454,8624,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(310455,8624,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¥‡à¤‚',0),(310456,8624,'ms','Dapatkan mesej-mesej',0),(310457,8624,'ar','Ø¬Ù„Ø¨ Ø§Ù„Ø±Ø³Ø§Ø¦Ù„',0),(310458,8624,'fr','ReÃ§ois des Messages',0),(310459,8624,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’å–å¾—ã—ã¾ã™ã€‚',0),(310460,8624,'pt','Receber mensagens',0),(310461,8624,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(310462,8624,'es','Conseguir Mensajes',0),(310463,8624,'de','Nachrichten abrufen',0),(310464,8624,'en','Get Messages',0),(310465,8625,'is','',0),(310466,8625,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ù…Ø´ØªØ±ÙŠ ',0),(310467,8625,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ Ù…Ø´ØªØ±ÙŠ ',0),(310468,8625,'tr','MÃ¼ÅŸteri notlarÄ±',0),(310469,8625,'pl','Uwagi klienta',0),(310470,8625,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(310471,8625,'ur','ÙˆØµÙˆÙ„ Ú©Ø§Ø± Ù†ÙˆÙ¹',0),(310472,8625,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(310473,8625,'vi','Ghi chÃº KhÃ¡ch hÃ ng',0),(310474,8625,'af','KliÃ«nt Notas',0),(310475,8625,'ro','Note de client',0),(310476,8625,'et','Kliendi mÃ¤rked',0),(310477,8625,'si','Odjemalec opombe',0),(310478,8625,'ba','Catatan klien',0),(310479,8625,'nl','Client notities',0),(310480,8625,'fi','-Asiakas-huomautuksia',0),(310481,8625,'no','Klienten notater',0),(310482,8625,'da','Kundenoter',0),(310483,8625,'ko','í´ë¼ì´ì–¸íŠ¸ ë…¸íŠ¸',0),(310484,8625,'he','×”×¢×¨×•×ª ×œ×§×•×—',0),(310485,8625,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(310486,8625,'zh','å®¢æˆ·ç«¯è¯´æ˜Ž\r\n',0),(310487,8625,'sv','Klienten anteckningar',0),(310488,8625,'it','Client Notes',0),(310489,8625,'tl','',0),(310490,8625,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3612;&#3641;&#3657;&#3592;&#3657;&#3634;&#3591;',0),(310491,8625,'hi','à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(310492,8625,'ms','Nota-Nota klien',0),(310493,8625,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(310494,8625,'fr','Client Notes',0),(310495,8625,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆã«é–¢ã™ã‚‹æ³¨æ„äº‹é …',0),(310496,8625,'pt','Notas do cliente',0),(310497,8625,'ru','Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(310498,8625,'es','Cliente Notas',0),(310499,8625,'de','Notes Client',0),(310500,8625,'en','Client Notes',0),(310501,8626,'is','',0),(310502,8626,'dr','ÙƒÙ¾ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(310503,8626,'pr','ÙƒÙ¾ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(310504,8626,'tr','BaÅŸarÄ±sÄ±z kopya',0),(310505,8626,'pl','Kopia nie powiodÅ‚o siÄ™',0),(310506,8626,'bg','ÐšÐ¾Ð¿Ð¸Ðµ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(310507,8626,'ur','Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§ Ù†Ù‚Ù„',0),(310508,8626,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(310509,8626,'vi','Sao chÃ©p tháº¥t báº¡i',0),(310510,8626,'af','Kopieer het misluk',0),(310511,8626,'ro','Copiere nereusita',0),(310512,8626,'et','Kopeerimine nurjus',0),(310513,8626,'si','Kopiranje ni uspelo',0),(310514,8626,'ba','Copy gagal',0),(310515,8626,'nl','Mislukte kopiÃ«ren',0),(310516,8626,'fi','Kopiointi ei onnistunut',0),(310517,8626,'no','Kopier mislyktes',0),(310518,8626,'da','Kopi mislykkedes',0),(310519,8626,'ko','ë³µì‚¬ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤',0),(310520,8626,'he','×”×¢×ª×§ × ×›×©×œ',0),(310521,8626,'el','Î‘Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(310522,8626,'zh','å¤åˆ¶å¤±è´¥\r\n',0),(310523,8626,'sv','Kopiera misslyckades',0),(310524,8626,'it','Copia non riuscita',0),(310525,8626,'tl','',0),(310526,8626,'th','&#3585;&#3634;&#3619;&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(310527,8626,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤µà¤¿à¤«à¤²',0),(310528,8626,'ms','Salinan yang gagal',0),(310529,8626,'ar','ÙØ´Ù„ Ø§Ù„Ù†Ø³Ø®',0),(310530,8626,'fr','Copie a Ã©chouÃ©',0),(310531,8626,'jp','ã‚³ãƒ”ãƒ¼ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(310532,8626,'pt','CÃ³pia falhada',0),(310533,8626,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(310534,8626,'es','Copiar FallÃ³',0),(310535,8626,'de','Kopie fehlgeschlagen',0),(310536,8626,'en','Copy Failed',0),(310537,8627,'is','',0),(310538,8627,'dr','ÙƒÙ¾ÙŠ Ø§Ø² ',0),(310539,8627,'pr','ÙƒÙ¾ÙŠ Ø§Ø² ',0),(310540,8627,'tr','KopyasÄ±',0),(310541,8627,'pl','KopiÄ™',0),(310542,8627,'bg','ÐšÐ¾Ð¿Ð¸Ðµ Ð½Ð°',0),(310543,8627,'ur','Ú©ÛŒ Ù†Ù‚Ù„',0),(310544,8627,'sr','ÐšÐ¾Ð¿Ð¸Ñ˜Ð° Ð¾Ð´',0),(310545,8627,'vi','Sao chÃ©p cá»§a',0),(310546,8627,'af','KopiÃ« Van',0),(310547,8627,'ro','Copie ',0),(310548,8627,'et','Koopia',0),(310549,8627,'si','Izvod',0),(310550,8627,'ba','Salinan',0),(310551,8627,'nl','Kopie van',0),(310552,8627,'fi','Kopio',0),(310553,8627,'no','Kopi av',0),(310554,8627,'da','Kopi af',0),(310555,8627,'ko','ë³µì‚¬',0),(310556,8627,'he','×¢×•×ª×§ ×©×œ',0),(310557,8627,'el','Î‘Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Ï„Î¿Ï…',0),(310558,8627,'zh','å¤åˆ¶\r\n',0),(310559,8627,'sv','Kopia av',0),(310560,8627,'it','Copia di',0),(310561,8627,'tl','',0),(310562,8627,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3586;&#3629;&#3591;',0),(310563,8627,'hi','à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(310564,8627,'ms','Salinan',0),(310565,8627,'ar','Ù†Ø³Ø®Ø© Ù…Ù†',0),(310566,8627,'fr','Copie de',0),(310567,8627,'jp','ã‚³ãƒ”ãƒ¼',0),(310568,8627,'pt','CÃ³pia de',0),(310569,8627,'ru','ÐšÐ¾Ð¿Ð¸Ñ',0),(310570,8627,'es','Copia de ',0),(310571,8627,'de','Kopie des',0),(310572,8627,'en','Copy Of',0),(310573,8628,'is','',0),(310574,8628,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù¾ÙŠØºØ§Ù… ',0),(310575,8628,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù¾ÙŠØºØ§Ù… ',0),(310576,8628,'tr','Mesaj Kategoriler',0),(310577,8628,'pl','Kategorie wiadomoÅ›ci',0),(310578,8628,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(310579,8628,'ur','Ù¾ÛŒØºØ§Ù… Ø²Ù…Ø±Û’',0),(310580,8628,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(310581,8628,'vi','Thá»ƒ Loáº¡i Tin Nháº¯n',0),(310582,8628,'af','Boodskap KategoriÃ«',0),(310583,8628,'ro','Categorii mesaj',0),(310584,8628,'et','SÃµnumite kategooriad',0),(310585,8628,'si','SporoÄilo kategorije',0),(310586,8628,'ba','Kategori Pesan',0),(310587,8628,'nl','Bericht CategorieÃ«n',0),(310588,8628,'fi','Viestiluokat',0),(310589,8628,'no','Meldingskategorier',0),(310590,8628,'da','Meddelelseskategorier',0),(310591,8628,'ko','ë©”ì‹œì§€ ë²”ì£¼',0),(310592,8628,'he','×§×˜×’×•×¨×™×•×ª ×”×•×“×¢×”',0),(310593,8628,'el','ÎœÎ®Î½Ï…Î¼Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(310594,8628,'zh','æ¶ˆæ¯åˆ†ç±»\r\n',0),(310595,8628,'sv','Meddelande kategorier',0),(310596,8628,'it','Categorie messaggio',0),(310597,8628,'tl','',0),(310598,8628,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(310599,8628,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(310600,8628,'ms','Kategori mesej',0),(310601,8628,'ar','ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„Ø±Ø³Ø§Ø¦Ù„',0),(310602,8628,'fr','CatÃ©gories de messages',0),(310603,8628,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®ã‚«ãƒ†ã‚´ãƒª',0),(310604,8628,'pt','Categorias de mensagens',0),(310605,8628,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹',0),(310606,8628,'es','CategorÃ­as de Mensajes',0),(310607,8628,'de','Nachrichtenkategorien',0),(310608,8628,'en','Message Categories',0),(310609,8629,'is','',0),(310610,8629,'dr','ÙƒÙ„ÙŠØ¯ Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯ÙŠ',0),(310611,8629,'pr','ÙƒÙ„ÙŠØ¯ Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯ÙŠ',0),(310612,8629,'tr','API anahtarÄ±',0),(310613,8629,'pl','Klucz API',0),(310614,8629,'bg','API ÐºÐ»ÑŽÑ‡',0),(310615,8629,'ur','API Ú©Ù„ÛŒØ¯',0),(310616,8629,'sr','ÐÐŸÐ˜ ÐºÑ™ÑƒÑ‡',0),(310617,8629,'vi','ChÃ¬a API',0),(310618,8629,'af','API Sleutel',0),(310619,8629,'ro','API-cheie',0),(310620,8629,'et','API vÃµti',0),(310621,8629,'si','API kljuÄ',0),(310622,8629,'ba','Kunci API',0),(310623,8629,'nl','API-sleutel',0),(310624,8629,'fi','API-avain',0),(310625,8629,'no','API-nÃ¸kkel',0),(310626,8629,'da','API-nÃ¸gle',0),(310627,8629,'ko','API í‚¤',0),(310628,8629,'he','API ×ž×¤×ª×—',0),(310629,8629,'el','ÎšÎ»ÎµÎ¹Î´Î¯ API',0),(310630,8629,'zh','åº”ç”¨ç¨‹åºæŽ¥å£å¯†é’¥\r\n',0),(310631,8629,'sv','API-nyckel',0),(310632,8629,'it','Chiave API',0),(310633,8629,'tl','',0),(310634,8629,'th','API Key',0),(310635,8629,'hi','API à¤•à¥à¤‚à¤œà¥€',0),(310636,8629,'ms','Kekunci API',0),(310637,8629,'ar','API Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(310638,8629,'fr','ClÃ© API',0),(310639,8629,'jp','API ã‚­ãƒ¼',0),(310640,8629,'pt','Chave de API',0),(310641,8629,'ru','ÐšÐ»ÑŽÑ‡ API',0),(310642,8629,'es','Clave de API',0),(310643,8629,'de','API-SchlÃ¼ssel',0),(310644,8629,'en','API Key',0),(310645,8630,'is','',0),(310646,8630,'dr','Ù…Ø¯ÙŠØ±ÙŠØª ÙƒÙ„ÙŠØ¯ Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯ÙŠ',0),(310647,8630,'pr','Ù…Ø¯ÙŠØ±ÙŠØª ÙƒÙ„ÙŠØ¯ Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯ÙŠ',0),(310648,8630,'tr','API anahtarÄ± yÃ¶netimi',0),(310649,8630,'pl','Klucz API zarzÄ…dzania',0),(310650,8630,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° API ÐºÐ»ÑŽÑ‡',0),(310651,8630,'ur','API Ú©Ù„ÛŒØ¯ Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù…',0),(310652,8630,'sr','ÐÐŸÐ˜ ÐšÐµy ÐœÐ°Ð½Ð°Ð³ÐµÐ¼ÐµÐ½Ñ‚',0),(310653,8630,'vi','ChÃ¬a KhÃ³a Quáº£n LÃ½ API',0),(310654,8630,'af','API Sleutelbestuur',0),(310655,8630,'ro','Gestionare a API-cheie',0),(310656,8630,'et','API Key Management',0),(310657,8630,'si','API Key Management',0),(310658,8630,'ba','Manajemen kunci API',0),(310659,8630,'nl','API-sleutel Management',0),(310660,8630,'fi','API Key Management',0),(310661,8630,'no','API-nÃ¸kkel ledelse',0),(310662,8630,'da','API Key Management',0),(310663,8630,'ko','API í‚¤ ê´€ë¦¬',0),(310664,8630,'he','×”×ž×¤×ª×— ×©×œ × ×™×”×•×œ',0),(310665,8630,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· API ÎºÎ»ÎµÎ¹Î´Î¯',0),(310666,8630,'zh','åº”ç”¨ç¨‹åºæŽ¥å£å¯†é’¥ç®¡ç†\r\n',0),(310667,8630,'sv','API Key Management',0),(310668,8630,'it','API Key Management',0),(310669,8630,'tl','',0),(310670,8630,'th','&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619; API Key',0),(310671,8630,'hi','API à¤•à¥à¤‚à¤œà¥€ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨',0),(310672,8630,'ms','Pengurusan kunci API',0),(310673,8630,'ar','Ø¥Ø¯Ø§Ø±Ø© Ù…ÙØªØ§Ø­ API',0),(310674,8630,'fr','Gestion de clÃ© API',0),(310675,8630,'jp','API ã‚­ãƒ¼ç®¡ç†',0),(310676,8630,'pt','Gerenciamento de chave de API',0),(310677,8630,'ru','ÐšÐ»ÑŽÑ‡ API ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(310678,8630,'es','API SupervisiÃ³n de Llave',0),(310679,8630,'de','API-Key Management',0),(310680,8630,'en','API Key Management',0),(310681,8631,'is','',0),(310682,8631,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø± Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯ÙŠ',0),(310683,8631,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø± Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯ÙŠ',0),(310684,8631,'tr','API kullanÄ±cÄ± kimliÄŸi',0),(310685,8631,'pl','Identyfikator uÅ¼ytkownika API',0),(310686,8631,'bg','API Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(310687,8631,'ur','API ØµØ§Ø±Ù Ú©ÛŒ Ø¢Ø¦ÛŒ ÚˆÛŒ',0),(310688,8631,'sr','ÐÐŸÐ˜ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾Ð³ Ð˜Ð”',0),(310689,8631,'vi','API ID NgÆ°á»i Sá»­ Dá»¥ng',0),(310690,8631,'af','API Gebruiker ID',0),(310691,8631,'ro','ID utilizator API',0),(310692,8631,'et','API kasutaja ID',0),(310693,8631,'si','ID uporabnika API',0),(310694,8631,'ba','ID pengguna API',0),(310695,8631,'nl','API gebruikers-ID',0),(310696,8631,'fi','API-kÃ¤yttÃ¤jÃ¤tunnus',0),(310697,8631,'no','API bruker-ID',0),(310698,8631,'da','API bruger-ID',0),(310699,8631,'ko','API ì‚¬ìš©ìž ID',0),(310700,8631,'he','×ž×–×”×” ×ž×©×ª×ž×© API',0),(310701,8631,'el','ID Ï‡ÏÎ®ÏƒÏ„Î· API',0),(310702,8631,'zh','åº”ç”¨ç¨‹åºæŽ¥å£ç”¨æˆ·çš„èº«ä»½è¯\r\n\r\n',0),(310703,8631,'sv','API-anvÃ¤ndare-ID',0),(310704,8631,'it','ID utente API',0),(310705,8631,'tl','',0),(310706,8631,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657; API ',0),(310707,8631,'hi','API à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ ID',0),(310708,8631,'ms','ID pengguna API',0),(310709,8631,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… API',0),(310710,8631,'fr','ID utilisateur de l\'API',0),(310711,8631,'jp','API ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ ID',0),(310712,8631,'pt','ID de usuÃ¡rio API',0),(310713,8631,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ API',0),(310714,8631,'es','CPI Usuario ID',0),(310715,8631,'de','API-Benutzer-ID',0),(310716,8631,'en','API User ID',0),(310717,8632,'is','',0),(310718,8632,'dr','API Key',0),(310719,8632,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ÙƒÙ„ÙŠØ¯ Ø±Ø§Ø¨Ø· ÙŠØ§ Ù…ÙŠØ§Ù†Ø¬Ù‰ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯Ù‰ Ø¬Ø¯ÙŠØ¯  API Key',0),(310720,8632,'tr','Yeni API anahtarÄ± oluÅŸturmak',0),(310721,8632,'pl','Generuje nowy klucz API',0),(310722,8632,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ API ÐºÐ»ÑŽÑ‡',0),(310723,8632,'ur','Ù†Ø¦Û’ API Ú©Ù„ÛŒØ¯ Ù†Ú©Ø§Ù„ÛŒÚº',0),(310724,8632,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ ÐÐŸÐ˜ ÐºÑ™ÑƒÑ‡',0),(310725,8632,'vi','Táº¡o 1 chÃ¬a khÃ³a API',0),(310726,8632,'af','Genereer Nuwe API Sleutel',0),(310727,8632,'ro','Genera noi API-cheie',0),(310728,8632,'et','Loo uus API vÃµti',0),(310729,8632,'si','Ustvari nov API kljuÄ',0),(310730,8632,'ba','Menghasilkan kunci API baru',0),(310731,8632,'nl','Nieuwe API-sleutel genereren',0),(310732,8632,'fi','Luo uusi API avain',0),(310733,8632,'no','Generere nye API-nÃ¸kkel',0),(310734,8632,'da','Generere nye API-nÃ¸gle',0),(310735,8632,'ko','ìƒˆë¡œìš´ API í‚¤ ìƒì„±',0),(310736,8632,'he','×¦×•×¨ ×ž×¤×ª×— API ×—×“×©',0),(310737,8632,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î½Î­Î¿ ÎºÎ»ÎµÎ¹Î´Î¯ API',0),(310738,8632,'zh','ç”Ÿæˆæ–°çš„åº”ç”¨ç¨‹åºç•Œé¢å¯†é’¥\r\n',0),(310739,8632,'sv','Generera nya API-nyckel',0),(310740,8632,'it','Generare nuove API Key',0),(310741,8632,'tl','',0),(310742,8632,'th','&#3626;&#3619;&#3657;&#3634;&#3591; API &#3588;&#3637;&#3618;&#3660; ',0),(310743,8632,'hi','à¤¨à¤ˆ à¤à¤ªà¥€à¤†à¤ˆ à¤•à¥à¤‚à¤œà¥€ à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(310744,8632,'ms','Menjana kekunci API baru',0),(310745,8632,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙØªØ§Ø­ Ø¬Ø¯ÙŠØ¯ API',0),(310746,8632,'fr','GÃ©nÃ©rer de nouvelles API Key',0),(310747,8632,'jp','æ–°ã—ã„ API ã‚­ãƒ¼ã‚’ç”Ÿæˆã—ã¾ã™ã€‚',0),(310748,8632,'pt','Gerar nova chave de API',0),(310749,8632,'ru','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ ÐºÐ»ÑŽÑ‡ API',0),(310750,8632,'es','Generar Nuevo Llave API',0),(310751,8632,'de','Neue API-Key zu generieren',0),(310752,8632,'en','Generate New API Key',0),(310753,8633,'is','',0),(310754,8633,'dr','Ø­Ø°Ù ÙƒÙ„ÙŠØ¯ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§Ø¨Ø· ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ \r\n API Key',0),(310755,8633,'pr','Ø­Ø°Ù ÙƒÙ„ÙŠØ¯ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§Ø¨Ø· ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ \r\n API Key',0),(310756,8633,'tr','API anahtarÄ± KaldÄ±r',0),(310757,8633,'pl','UsuÅ„ klucz API',0),(310758,8633,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ Ð½Ð° API ÐºÐ»ÑŽÑ‡',0),(310759,8633,'ur','API Ú©Ù„ÛŒØ¯ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(310760,8633,'sr','Ð£ÐºÐ»Ð¾Ð½Ð¸Ñ‚Ðµ ÐÐŸÐ˜ ÐºÑ™ÑƒÑ‡',0),(310761,8633,'vi','Bá» chÃ¬a khÃ³a API',0),(310762,8633,'af','Verwyder API Sleutel',0),(310763,8633,'ro','Elimina API-cheie',0),(310764,8633,'et','Eemalda API vÃµti',0),(310765,8633,'si','Odstranite API kljuÄ',0),(310766,8633,'ba','Menghapus kunci API',0),(310767,8633,'nl','API-sleutel verwijderen',0),(310768,8633,'fi','Poista API avain',0),(310769,8633,'no','Fjerne API-nÃ¸kkel',0),(310770,8633,'da','Fjerne API-nÃ¸gle',0),(310771,8633,'ko','API í‚¤ ì œê±°',0),(310772,8633,'he','×”×¡×¨ API ×ž×¤×ª×—',0),(310773,8633,'el','Î‘Ï†Î±Î¹ÏÎ­ÏƒÏ„Îµ Ï„Î¿ ÎºÎ»ÎµÎ¹Î´Î¯ API',0),(310774,8633,'zh','ç§»é™¤åº”ç”¨ç¨‹åºç•Œé¢å¯†é’¥\r\n',0),(310775,8633,'sv','Ta bort API-nyckel',0),(310776,8633,'it','Rimuovere la chiave API',0),(310777,8633,'tl','',0),(310778,8633,'th','&#3621;&#3610; API &#3588;&#3637;&#3618;&#3660;',0),(310779,8633,'hi','API à¤•à¥à¤‚à¤œà¥€ à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚',0),(310780,8633,'ms','Alih Keluar API kekunci',0),(310781,8633,'ar','Ø¥Ø²Ø§Ù„Ø© Ù…ÙØªØ§Ø­ API',0),(310782,8633,'fr','Supprimer la clÃ© API',0),(310783,8633,'jp','API ã‚­ãƒ¼ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(310784,8633,'pt','Remover a chave de API',0),(310785,8633,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÐºÐ»ÑŽÑ‡ API',0),(310786,8633,'es','Eliminar Llave API',0),(310787,8633,'de','API-SchlÃ¼ssel zu entfernen',0),(310788,8633,'en','Remove API Key',0),(310789,8634,'is','',0),(310790,8634,'dr','Ø§ÙŠÙ† ÙØ¶Ø§ÙŠ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ Ø§Ú¯Ø± ÙŠÙƒ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ø¯',0),(310791,8634,'pr','Ø§ÙŠÙ† ÙØ¶Ø§ÙŠ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ Ø§Ú¯Ø± ÙŠÙƒ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ø¯',0),(310792,8634,'tr','Bu bir vergi tÃ¼rÃ¼ seÃ§iliyse boÅŸ bÄ±rakabilirsiniz',0),(310793,8634,'pl','MoÅ¼na zostawiÄ‡ puste, jeÅ›li zostanie wybrany typ podatku',0),(310794,8634,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ñ‚Ð¾Ð²Ð° Ð¿Ð¾Ð»Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð°ÐºÐ¾ Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½ Ñ‚Ð¸Ð¿ Ð´Ð°Ð½ÑŠÐº',0),(310795,8634,'ur','ÛŒÛ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø§ÛŒÚ© Ù‚Ø³Ù… Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ ØªÙˆ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(310796,8634,'sr','ÐžÐ²Ð¾ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð°ÐºÐ¾ Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð° Ñ˜Ðµ Ð²Ñ€ÑÑ‚Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(310797,8634,'vi','cÃ³ thá»ƒ Ä‘á»ƒ trá»‘ng náº¿u loáº¡i thuáº¿ cÃ³ thá»ƒ chá»n',0),(310798,8634,'af','Kan Hierdie Oop Los Indien \'n Belastingtipe Geselekteer Is',0),(310799,8634,'ro','Poate lasi aceasta necompletat dacÄƒ este selectat un text fiscale',0),(310800,8634,'et','Selle vÃµib tÃ¼hjaks jÃ¤tta, kui maksuliik on valitud',0),(310801,8634,'si','Lahko pustite prazno, Äe je izbrana vrsta davka',0),(310802,8634,'ba','Dapat dibiarkan kosong jika jenis pajak yang dipilih',0),(310803,8634,'nl','Kan laat dit leeg als een belasting-Type Is geselecteerd',0),(310804,8634,'fi','JÃ¤tÃ¤ tÃ¤mÃ¤ tyhjÃ¤ksi, jos ALV-tyyppi on valittuna',0),(310805,8634,'no','Kan la dette stÃ¥ tomt hvis en mva-Type er valgt',0),(310806,8634,'da','Kan lade dette vÃ¦re tomt, hvis du er en skat Type',0),(310807,8634,'ko','ì´ ì„¸ ìœ í˜•ì„ ì„ íƒ í•˜ëŠ” ê²½ìš°ì— ë¹„ì›Œ ë‘˜ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(310808,8634,'he','×‘××¤×©×¨×•×ª×š ×œ×”×©××™×¨ ××ª ×–×” ×¨×™×§ ×× × ×‘×—×¨ ×¡×•×’ ×ž×¡',0),(310809,8634,'el','ÎÎ± Ï„Î¿ Î±Ï†Î®ÏƒÎµÏ„Îµ ÎºÎµÎ½ÏŒ, ÎµÎ¬Î½ ÎµÎ¯Î½Î±Î¹ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î­Î½Î± ÎµÎ¯Î´Î¿Ï‚ Ï†ÏŒÏÎ¿Ï…',0),(310810,8634,'zh','å¦‚æžœä¸€ä¸ªç¨ŽåŠ¡ç±»åž‹è¢«é€‰ä¸­å¯ä»¥ç•™ç©º\r\n',0),(310811,8634,'sv','Kan lÃ¤mna den tom om en skatt typ vÃ¤ljs',0),(310812,8634,'it','Questo puÃ² lasciare vuoto se si seleziona un tipo di tassa',0),(310813,8634,'tl','',0),(310814,8634,'th','&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3606;&#3657;&#3634;&#3648;&#3621;&#3639;&#3629;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;',0),(310815,8634,'hi','à¤¯à¤¹ à¤…à¤—à¤° à¤à¤• à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤šà¤¯à¤¨à¤¿à¤¤ à¤¹à¥ˆ à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼ à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(310816,8634,'ms','Boleh tinggalkan ini kosong jika jenis cukai yang dipilih',0),(310817,8634,'ar','ÙŠÙ…ÙƒÙ†Ùƒ ØªØ±Ùƒ Ù‡Ø°Ù‡ Ø§Ù„Ø®Ø§Ù†Ø© ÙØ§Ø±ØºØ© Ø¥Ø°Ø§ Ù‚Ù…Øª Ø¨Ø§Ø®ØªÙŠØ§Ø± Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(310818,8634,'fr','Pouvez laissez ce champ vide si un Type d\'impÃ´t est sÃ©lectionnÃ©',0),(310819,8634,'jp','ã“ã‚ŒãŒç¨Žã®ç¨®é¡žãŒé¸æŠžã•ã‚Œã¦ã„ã‚‹å ´åˆã¯ã€ç©ºç™½ã«æ®‹ã™ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(310820,8634,'pt','Pode deixar em branco se for selecionado um tipo de imposto',0),(310821,8634,'ru','ÐœÐ¾Ð¶ÐµÑ‚Ðµ ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ð¹ Ð‘Ð»Ð°Ð½Ðº Ð•ÑÐ»Ð¸ Ð¢Ð¸Ð¿ ÐÐ°Ð»Ð¾Ð³Ð° Ð’Ñ‹Ð±Ñ€Ð°Ð½',0),(310822,8634,'es','Se puede dejar este en Blanco si un Tipo de Impuesto esta Seleccionado',0),(310823,8634,'de','KÃ¶nnen dies leer lassen, wenn eine Steuerart ausgewÃ¤hlt ist',0),(310824,8634,'en','Can Leave This Blank If a Tax Type Is Selected',0),(310825,8635,'is','',0),(310826,8635,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(310827,8635,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(310828,8635,'tr','Kredi kartÄ± satÄ±n alma tÃ¼rÃ¼ Ekle',0),(310829,8635,'pl','DodaÄ‡ typ zakup karty kredytowej',0),(310830,8635,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(310831,8635,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(310832,8635,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ñ‚Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(310833,8635,'vi','ThÃªm Loáº¡i Giao Dá»‹ch Mua HÃ ng Qua Tháº» TÃ­n Dá»¥ng',0),(310834,8635,'af','Kredietkaartaankope Tipe Byvoeg',0),(310835,8635,'ro','Adauga tip de cumpÄƒrare Card de credit',0),(310836,8635,'et','Krediitkaardi ostu tÃ¼Ã¼p lisamine',0),(310837,8635,'si','Kreditne kartice nakup vrsto dodati',0),(310838,8635,'ba','Menambahkan jenis pembelian kartu kredit',0),(310839,8635,'nl','Creditcard Type inkoop toevoegen',0),(310840,8635,'fi','Luottokorttityyppi osto lisÃ¤Ã¤',0),(310841,8635,'no','KjÃ¸p kredittkorttype legge',0),(310842,8635,'da','Kreditkort KÃ¸b Type tilfÃ¸je',0),(310843,8635,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ ìœ í˜• ì¶”ê°€',0),(310844,8635,'he','×”×•×¡×£ ×¡×•×’ ×”×¨×›×™×©×” ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(310845,8635,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„ÏÏ€Î¿Ï… Î±Î³Î¿ÏÎ¬ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(310846,8635,'zh','æ–°å¢žä¿¡ç”¨å¡è´­ä¹°ç±»åž‹\r\n',0),(310847,8635,'sv','Kreditkort inkÃ¶pstyp lÃ¤gga till',0),(310848,8635,'it','Aggiungi tipo di acquisto di carta di credito',0),(310849,8635,'tl','',0),(310850,8635,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(310851,8635,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(310852,8635,'ms','Tambah jenis pembelian kad kredit',0),(310853,8635,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(310854,8635,'fr','Ajouter Type achat de carte de crÃ©dit',0),(310855,8635,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰è³¼å…¥ã®ç¨®é¡žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(310856,8635,'pt','Adicionar o tipo de compra de cartÃ£o de crÃ©dito',0),(310857,8635,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(310858,8635,'es','Tarjeta de CrÃ©dito Agregar Tipo de Compras',0),(310859,8635,'de','Kreditkarte kaufen Typ hinzufÃ¼gen',0),(310860,8635,'en','Credit Card Purchase Type Add',0),(310861,8636,'is','',0),(310862,8636,'dr','Ø´Ø±Ø­ Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(310863,8636,'pr','Ø´Ø±Ø­ Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(310864,8636,'tr','Kredi kartÄ± satÄ±n alma tÃ¼rÃ¼ aÃ§Ä±klamasÄ±',0),(310865,8636,'pl','Opis typu zakup karty kredytowej',0),(310866,8636,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ñ‚Ð¸Ð¿Ð° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(310867,8636,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(310868,8636,'sr','ÐžÐ¿Ð¸Ñ Ð²Ñ€ÑÑ‚Ðµ Ð½Ð°Ð±Ð°Ð²ÐºÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(310869,8636,'vi','MÃ´ Táº£ Loáº¡i Giao Dá»‹ch Mua HÃ ng Qua Tháº» TÃ­n Dá»¥ng',0),(310870,8636,'af','Kredietkaartaankope Tipe Beskrywing',0),(310871,8636,'ro','Descriere de tip carte de credit cumpÄƒrare',0),(310872,8636,'et','Krediitkaardi ostu tÃ¼Ã¼p kirjeldus',0),(310873,8636,'si','Opis vrste nakup kreditni kartici',0),(310874,8636,'ba','Kartu kredit pembelian jenis Deskripsi',0),(310875,8636,'nl','Creditcard aankoop Type Beschrijving',0),(310876,8636,'fi','Luottokortti ostojen tyypin kuvaus',0),(310877,8636,'no','Kredittkort kjÃ¸p beskrivelsen',0),(310878,8636,'da','Kreditkort KÃ¸b Type beskrivelse',0),(310879,8636,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ ìœ í˜• ì„¤ëª…',0),(310880,8636,'he','×ª×™××•×¨ ×©×œ ×¡×•×’ ×¨×›×™×©×” ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(310881,8636,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Î±Î³Î¿ÏÏŽÎ½ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„ÏÏ€Î¿Ï…',0),(310882,8636,'zh','ä¿¡ç”¨å¡è´­ä¹°ç±»åž‹è¯´æ˜Ž\r\n',0),(310883,8636,'sv','Kreditkort kÃ¶p typ Beskrivning',0),(310884,8636,'it','Descrizione del tipo di acquisto carta di credito',0),(310885,8636,'tl','',0),(310886,8636,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(310887,8636,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤µà¤¿à¤µà¤°à¤£',0),(310888,8636,'ms','Kad kredit pembelian jenis keterangan',0),(310889,8636,'ar','ÙˆØµÙ Ù†ÙˆØ¹ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(310890,8636,'fr','Achat de carte de crÃ©dit Type Description',0),(310891,8636,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰è³¼å…¥ã®ç¨®é¡žã®èª¬æ˜Ž',0),(310892,8636,'pt','DescriÃ§Ã£o do tipo de cartÃ£o de crÃ©dito compra',0),(310893,8636,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(310894,8636,'es','Tarjeta de CrÃ©dito DescripciÃ³n de Tipo de Compras',0),(310895,8636,'de','Kreditkarte kaufen Typenbeschreibung',0),(310896,8636,'en','Credit Card Purchase Type Description',0),(310897,8637,'is','',0),(310898,8637,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ÙŠØ§ Ø­Ø³Ø§Ø¨  Ø¨Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ÙŠ ÙØ±ÙˆØ´ Ø±ÙØªÙ‡',0),(310899,8637,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ÙŠØ§ Ø­Ø³Ø§Ø¨  Ø¨Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ÙŠ ÙØ±ÙˆØ´ Ø±ÙØªÙ‡',0),(310900,8637,'tr','GL gider veya mamul maliyeti hesabÄ± sattÄ±',0),(310901,8637,'pl','Koszt GL lub koszt towarÃ³w sprzedanych konta',0),(310902,8637,'bg','GL Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¸Ð»Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð° ÑÑ‚Ð¾ÐºÐ¸ Ð¿Ñ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(310903,8637,'ur','Ø¬ÛŒØ¬Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª ÛŒØ§ Ø³Ø§Ù…Ø§Ù† Ú©ÛŒ Ù„Ø§Ú¯Øª Ù…ÛŒÚº Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(310904,8637,'sr','Ð“Ð› Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¸Ð»Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ñ€Ð¾Ð±Ðµ, Ð¿Ñ€Ð¾Ð´Ð°Ð¾ Ñ˜Ðµ Ñ€Ð°Ñ‡ÑƒÐ½',0),(310905,8637,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Chi PhÃ­ Hay GiÃ¡ ThÃ nh HÃ ng BÃ¡n',0),(310906,8637,'af','AG Uitgawerekening vir Koste van Verkope Herverkooprekening',0),(310907,8637,'ro','GL cheltuieli sau costul mÄƒrfurilor vÃ¢ndute cont',0),(310908,8637,'et','GL kulu vÃµi kauba maksumusest mÃ¼Ã¼dud konto',0),(310909,8637,'si','GL stroÅ¡ke ali stroÅ¡ke blaga prodajajo raÄun',0),(310910,8637,'ba','GL biaya atau biaya barang dijual Account',0),(310911,8637,'nl','GL kosten of kosten van goederen verkocht Account',0),(310912,8637,'fi','GL kustannuksella tai tuotteiden kustannukset myyty',0),(310913,8637,'no','GL kostnad eller kostnader for varer solgt konto',0),(310914,8637,'da','GL udgifter eller omkostninger for varer solgt konto',0),(310915,8637,'ko','GL ë¹„ìš© ë˜ëŠ” ìƒí’ˆì˜ ë¹„ìš©ì€ íŒë§¤ ê³„ì •',0),(310916,8637,'he','×”×•×¦××•×ª GL ××• ×¢×œ×•×ª ×”×¡×—×•×¨×•×ª ×©× ×ž×›×¨×• ×—×©×‘×•×Ÿ',0),(310917,8637,'el','GL Î´Î±Ï€Î¬Î½Î· Î® ÎšÎŸÎ£Î¤ÎŸÎ£ Î Î©Î›Î—Î˜Î•ÎÎ¤Î©Î Ï€Ï‰Î»Î¿ÏÎ½Ï„Î±Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(310918,8637,'zh','æ€»å¸è´¹ç”¨æˆ–å•†å“é”€å”®æˆæœ¬å¸æˆ·\r\n',0),(310919,8637,'sv','GL bekostnad eller kostnad fÃ¶r varor sÃ¤ljs konto',0),(310920,8637,'it','GL spesa o costo delle merci vendute conto',0),(310921,8637,'tl','',0),(310922,8637,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3627;&#3619;&#3639;&#3629;&#3610;&#3633;&#3597;&#3594;&#3637;&#3605;&#3657;&#3609;&#3',0),(310923,8637,'hi','à¤œà¥€à¤à¤² à¤µà¥à¤¯à¤¯ à¤¯à¤¾ à¤µà¤¸à¥ à¤¤à¥à¤“à¤‚ à¤•à¥€ à¤²à¤¾à¤—à¤¤ à¤–à¤¾à¤¤à¤¾ à¤¬à¥‡à¤šà¤¾',0),(310924,8637,'ms','GL perbelanjaan atau kos barangan dijual akaun',0),(310925,8637,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª Ø£Ùˆ ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ÙÙŠ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(310926,8637,'fr','GL dÃ©pense ou le coÃ»t des marchandises vendues compte',0),(310927,8637,'jp','GL è²»ç”¨ã‚„å•†å“ã®ã‚³ã‚¹ãƒˆè²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(310928,8637,'pt','GL despesa ou custo de mercadorias vendidas conta',0),(310929,8637,'ru','GL Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð¸Ð»Ð¸ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð² Ð¿Ñ€Ð¾Ð´Ð°Ð½Ð¾ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(310930,8637,'es','LM Cuenta de Gastos o Costo de Bienes Vendidos',0),(310931,8637,'de','GL Kosten oder Warenaufwand vermittelten Account',0),(310932,8637,'en','GL Expense or Cost of Goods Sold Account',0),(310933,8638,'is','',0),(310934,8638,'dr','Ø­Ø³Ø§Ø¨ Ú©Ø§Ù‡Ù†Ø¯Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(310935,8638,'pr','Ø­Ø³Ø§Ø¨ Ú©Ø§Ù‡Ù†Ø¯Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(310936,8638,'tr','GL BorÃ§lar Contra hesabÄ±',0),(310937,8638,'pl','Koncie Contra zobowiÄ…zaÅ„ GL',0),(310938,8638,'bg','GL ÐºÐ¾Ð½Ñ‚Ñ€Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(310939,8638,'ur','Ø¬ÛŒØ¬Û’ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø¨Ø§Ù„Ø¹Ú©Ø³ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(310940,8638,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð¦Ð¾Ð½Ñ‚Ñ€Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð“Ð›',0),(310941,8638,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Pháº£i Tráº£ Theo PhÆ°Æ¡ng Thá»©c HÃ ng Äá»•i HÃ ng',0),(310942,8638,'af','AG Betaalbaar Kontra Rekening',0),(310943,8638,'ro','Contul de Contra GL datorii',0),(310944,8638,'et','Contra pearaamatukontole vÃµlad',0),(310945,8638,'si','Kontu Contra GL',0),(310946,8638,'ba','GL hutang Contra Account',0),(310947,8638,'nl','Centralisatierekening Contra GL',0),(310948,8638,'fi','GL Contra ostovelkatilille',0),(310949,8638,'no','GL samlekontoen Contra',0),(310950,8638,'da','GL samlekonto Contra',0),(310951,8638,'ko','GL ë¯¸ì§€ê¸‰ê¸ˆ ì°¨ê° ê³„ì •',0),(310952,8638,'he','GL ×–×›××™× ×§×•× ×˜×¨×” ×—×©×‘×•×Ÿ',0),(310953,8638,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î¤Î¡Î™Î¤ÎŸÎ¥Î£ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ GL',0),(310954,8638,'zh','æ€»å¸åº”ä»˜æŠµæ¶ˆå¸æˆ·\r\n',0),(310955,8638,'sv','GL kontot fÃ¶r leverantÃ¶rsskulder Contra',0),(310956,8638,'it','Conto di contropartita debiti GL',0),(310957,8638,'tl','',0),(310958,8638,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3605;&#3619;&#3591;&#3585;&#3633;&#3609;&#3586;&#3657;&#3634;&#3617;',0),(310959,8638,'hi','GL Payables Contra à¤–à¤¾à¤¤à¥‡',0),(310960,8638,'ms','GL pemiutang kontra akaun',0),(310961,8638,'ar','Ø­Ø³Ø§Ø¨ Contra Ø§Ù„Ù…Ù‚Ø¨ÙˆØ¶Ø§Øª GL',0),(310962,8638,'fr','Compte de contrepartie des comptes fournisseurs GL',0),(310963,8638,'jp','GL å‚µå‹™è² ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(310964,8638,'pt','GL dÃ­vidas Contra conta',0),(310965,8638,'ru','GL ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Contra ÑÑ‡ÐµÑ‚Ð°',0),(310966,8638,'es','Contracuenta de LM Cuentas por Pagar ',0),(310967,8638,'de','Verbindlichkeitskonto Contra GL',0),(310968,8638,'en','GL Payables Contra Account',0),(310969,8639,'is','',0),(310970,8639,'dr','Ø§Ú¯Ø± Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø³Øª',0),(310971,8639,'pr','Ø§Ú¯Ø± Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø³Øª',0),(310972,8639,'tr','Vergi tÃ¼rÃ¼ ise',0),(310973,8639,'pl','JeÅ›li typ jest podatek',0),(310974,8639,'bg','ÐÐºÐ¾ Ð²Ð¸Ð´ÑŠÑ‚ Ðµ Ð´Ð°Ð½ÑŠÐº',0),(310975,8639,'ur','Ø§Ú¯Ø± Ù‚Ø³Ù… Ù¹ÛŒÚ©Ø³ ÛÛ’ Û”',0),(310976,8639,'sr','ÐÐºÐ¾ Ñ˜Ðµ Ð²Ñ€ÑÑ‚Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(310977,8639,'vi','Náº¿u loáº¡i lÃ  Thuáº¿',0),(310978,8639,'af','Indien Tipe Belasting is',0),(310979,8639,'ro','DacÄƒ tipul este fiscale',0),(310980,8639,'et','Kui tÃ¼Ã¼p on maks',0),(310981,8639,'si','ÄŒe je vrsta davka',0),(310982,8639,'ba','Jika jenis pajak',0),(310983,8639,'nl','Als Type belasting is',0),(310984,8639,'fi','Jos tyyppi on vero',0),(310985,8639,'no','Hvis typen er skatt',0),(310986,8639,'da','Hvis typen er skat',0),(310987,8639,'ko','í˜•ì‹ì´ ì„¸ê¸ˆ',0),(310988,8639,'he','×× ×”×¡×•×’ ×”×•× ×ž×¡',0),(310989,8639,'el','Î‘Î½ Î¿ Ï„ÏÏ€Î¿Ï‚ ÎµÎ¯Î½Î±Î¹ Ï†ÏŒÏÎ¿Ï‚',0),(310990,8639,'zh','å¦‚æžœç±»åž‹ä¸ºç¨Žæ”¶\r\n',0),(310991,8639,'sv','Om typen Ã¤r skatt',0),(310992,8639,'it','Se il tipo Ã¨ imposta',0),(310993,8639,'tl','',0),(310994,8639,'th','&#3606;&#3657;&#3634;&#3648;&#3611;&#3655;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;',0),(310995,8639,'hi','à¤¯à¤¦à¤¿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(310996,8639,'ms','Jika jenis cukai',0),(310997,8639,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ù†ÙˆØ¹ Ø¶Ø±ÙŠØ¨Ø©',0),(310998,8639,'fr','Si le Type est impÃ´t',0),(310999,8639,'jp','åž‹ãŒç¨Žã®å ´åˆ',0),(311000,8639,'pt','Se o tipo Ã© imposto',0),(311001,8639,'ru','Ð•ÑÐ»Ð¸ Ñ‚Ð¸Ð¿ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð½Ð°Ð»Ð¾Ð³',0),(311002,8639,'es','If Tipo es Impuesto',0),(311003,8639,'de','Wenn Typ Steuer',0),(311004,8639,'en','If Type is Tax',0),(311005,8640,'is','',0),(311006,8640,'dr','Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ù…Ø§Ù†Ù†Ø¯ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(311007,8640,'pr','Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ù…Ø§Ù†Ù†Ø¯ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(311008,8640,'tr','Eskisi gibi borÃ§ hesaplarÄ± olabilir',0),(311009,8640,'pl','MogÄ… byÄ‡ takie Same, jak Rozrachunki',0),(311010,8640,'bg','ÐœÐ¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ ÑÑŠÑ‰Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚Ð¾ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(311011,8640,'ur','ÛŒÚ©Ø³Ø§Úº Ø·ÙˆØ± Ù¾Ø± Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†ÛÛŒÚº ÛÙˆØ³Ú©ØªØ§ ÛÛ’',0),(311012,8640,'sr','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð±ÑƒÐ´Ðµ Ð¸ÑÑ‚Ð° ÐºÐ°Ð¾ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(311013,8640,'vi','CÃ³ thá»ƒ giá»‘ng nhÆ° TK Pháº£i Tráº£',0),(311014,8640,'af','Mag Dieselfde wees as Rekeninge Betaalbaar',0),(311015,8640,'ro','Poate fi acelaÅŸi lucru ca ÅŸi conturi de plÄƒtit',0),(311016,8640,'et','VÃµib olla sama mis Kreditoorne vÃµlgnevus',0),(311017,8640,'si','Lahko isto, kot obveznosti do dobav.',0),(311018,8640,'ba','Mungkin sama seperti Hutang Dagang',0),(311019,8640,'nl','Hetzelfde als schulden kunnen worden',0),(311020,8640,'fi','Voi olla sama kuin lyhytaikaiset velat',0),(311021,8640,'no','Kan vÃ¦re lik leverandÃ¸rer',0),(311022,8640,'da','Kan vÃ¦re samme som kreditor',0),(311023,8640,'ko','ì§€ê¸‰ ê³„ì •ìœ¼ë¡œ ë™ì¼í•œ ìžˆì„ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(311024,8640,'he','×¢×©×•×™×™× ×œ×”×™×•×ª ×–×”×™× ×—×©×‘×•× ×•×ª ×–×›××™×',0),(311025,8640,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ Ï„Î¿ Î¯Î´Î¹Î¿ ÏŒÏ€Ï‰Ï‚ Î¿Î¹ Ï€Î»Î·ÏÏ‰Ï„Î­Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(311026,8640,'zh','ä¹Ÿè®¸ä¸Žåº”ä»˜è´¦æ¬¾å¸æˆ·ä¸€æ ·\r\n',0),(311027,8640,'sv','Kan vara samma som fÃ¶r leverantÃ¶rsreskontra',0),(311028,8640,'it','PuÃ² essere stesso come contabilitÃ  fornitori',0),(311029,8640,'tl','',0),(311030,8640,'th','&#3629;&#3634;&#3592;&#3592;&#3632;&#3648;&#3627;&#3617;&#3639;&#3629;&#3609;&#3585;&#3633;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3592;&#3656;&#3634;&#3618;',0),(311031,8640,'hi','à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ à¤‰à¤¸à¥€ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤²à¥‡à¤–à¤¾ à¤¦à¥‡à¤¯',0),(311032,8640,'ms','Mungkin sama seperti akaun belum bayar',0),(311033,8640,'ar','Ù‚Ø¯ ØªÙƒÙˆÙ† Ù†ÙØ³ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ÙƒØ­Ø³Ø§Ø¨Ø§Øª Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(311034,8640,'fr','Peut Ãªtre mÃªme que les comptes crÃ©diteurs',0),(311035,8640,'jp','è²·æŽ›é‡‘ã¨åŒã˜å¯èƒ½æ€§ãŒã‚ã‚Šã¾ã™ã€‚',0),(311036,8640,'pt','Pode ser mesmo como contas a pagar',0),(311037,8640,'ru','ÐœÐ¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ñ‚Ð°ÐºÐ¾Ð¹ Ð¶Ðµ, ÐºÐ°Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ',0),(311038,8640,'es','Puede Ser Lo Mismo Como Cuentas por Pagar',0),(311039,8640,'de','Gleich kann sein wie die zu zahlenden Konten',0),(311040,8640,'en','May Be Same As Accounts Payable',0),(311041,8641,'is','',0),(311042,8641,'dr','Ù‚Ø§Ø¨Ù„ Ø§Ø¬Ø±Ø§ Ù†ÙŠØ³Øª ',0),(311043,8641,'pr','Ù‚Ø§Ø¨Ù„ Ø§Ø¬Ø±Ø§ Ù†ÙŠØ³Øª ',0),(311044,8641,'tr','GeÃ§erli deÄŸil',0),(311045,8641,'pl','Nie dotyczy',0),(311046,8641,'bg','ÐÐµ Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸Ð¼Ð¾',0),(311047,8641,'ur','Ù‚Ø§Ø¨Ù„ Ø§Ø·Ù„Ø§Ù‚ Ù†ÛÛŒÚº',0),(311048,8641,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ñ™Ð¸Ð²Ð¾',0),(311049,8641,'vi','KhÃ´ng Ã¡p dá»¥ng',0),(311050,8641,'af','Nie Toepaslik',0),(311051,8641,'ro','Nu este cazul',0),(311052,8641,'et','Pole kohaldatav',0),(311053,8641,'si','Se ne uporablja',0),(311054,8641,'ba','Tidak berlaku',0),(311055,8641,'nl','Niet van toepassing',0),(311056,8641,'fi','Ei sovelleta',0),(311057,8641,'no','Ikke aktuelt',0),(311058,8641,'da','Ikke relevant',0),(311059,8641,'ko','ì ìš© ë˜ì§€ ì•ŠìŒ',0),(311060,8641,'he','×œ× ×™×©×™×',0),(311061,8641,'el','Î”ÎµÎ½ Î¹ÏƒÏ‡ÏÎµÎ¹',0),(311062,8641,'zh','ä¸é€‚ç”¨\r\n',0),(311063,8641,'sv','Ej tillÃ¤mpligt',0),(311064,8641,'it','Non applicabile',0),(311065,8641,'tl','',0),(311066,8641,'th','&#3652;&#3617;&#3656;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591;',0),(311067,8641,'hi','à¤²à¤¾à¤—à¥‚ à¤¨à¤¹à¥€à¤‚',0),(311068,8641,'ms','Tidak berkenaan',0),(311069,8641,'ar','ØºÙŠØ± Ù‚Ø§Ø¨Ù„ Ù„Ù„ØªØ·Ø¨ÙŠÙ‚',0),(311070,8641,'fr','Ne s\'applique pas',0),(311071,8641,'jp','è©²å½“ã—ã¾ã›ã‚“ã€‚',0),(311072,8641,'pt','NÃ£o aplicÃ¡vel',0),(311073,8641,'ru','ÐÐµ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ð¼Ð¾',0),(311074,8641,'es','No Aplicable',0),(311075,8641,'de','Nicht zutreffend',0),(311076,8641,'en','Not Applicable',0),(311077,8642,'is','',0),(311078,8642,'dr','Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(311079,8642,'pr','Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(311080,8642,'tr','Kredi kartÄ± satÄ±n alma tÃ¼rÃ¼',0),(311081,8642,'pl','Typ zakup karty kredytowej',0),(311082,8642,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ñ‚Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(311083,8642,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(311084,8642,'sr','ÐÐ°Ð±Ð°Ð²ÐºÐµ Ñ‚Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(311085,8642,'vi','Loáº¡i Giao Dá»‹ch Mua HÃ ng Qua Tháº» TÃ­n Dá»¥ng',0),(311086,8642,'af','Kredietkaartaankope Tipe',0),(311087,8642,'ro','Tip de cumpÄƒrare Card de credit',0),(311088,8642,'et','Krediitkaardi ostu tÃ¼Ã¼p',0),(311089,8642,'si','Nakup kreditne kartice vrste',0),(311090,8642,'ba','Jenis kartu kredit pembelian',0),(311091,8642,'nl','Creditcard Type inkoop',0),(311092,8642,'fi','Luottokortilla oston tyyppi',0),(311093,8642,'no','KjÃ¸p kredittkorttype',0),(311094,8642,'da','Kreditkort KÃ¸b Type',0),(311095,8642,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ ìœ í˜•',0),(311096,8642,'he','×¡×•×’ ×¨×›×™×©×” ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(311097,8642,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Ï„ÏÏ€Î¿Ï… Î±Î³Î¿ÏÎ¬',0),(311098,8642,'zh','ä¿¡ç”¨å¡è´­ä¹°ç±»åž‹\r\n',0),(311099,8642,'sv','KÃ¶p kreditkortstyp',0),(311100,8642,'it','Tipo di acquisto di carta di credito',0),(311101,8642,'tl','',0),(311102,8642,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(311103,8642,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(311104,8642,'ms','Jenis pembelian kad kredit',0),(311105,8642,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(311106,8642,'fr','Type d\'achat de carte de crÃ©dit',0),(311107,8642,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰è³¼å…¥ã®ç¨®é¡ž',0),(311108,8642,'pt','Tipo de compra de cartÃ£o de crÃ©dito',0),(311109,8642,'ru','Ð¢Ð¸Ð¿ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(311110,8642,'es','Tarjeta de CrÃ©dito Tipo de Compras',0),(311111,8642,'de','Kreditkartentyp kaufen',0),(311112,8642,'en','Credit Card Purchase Type',0),(311113,8643,'is','',0),(311114,8643,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(311115,8643,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(311116,8643,'tr','Kredi kartÄ± satÄ±n alma tÃ¼rÃ¼ gÃ¼ncelleÅŸtirme',0),(311117,8643,'pl','Aktualizacji typu zakup karty kredytowej',0),(311118,8643,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ñ‚Ð¸Ð¿ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(311119,8643,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù… ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(311120,8643,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ð¸Ð¿ Ð½Ð°Ð±Ð°Ð²ÐºÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(311121,8643,'vi','Cáº­p Nháº­p Loáº¡i Giao Dá»‹ch Mua HÃ ng Qua Tháº» TÃ­n Dá»¥ng',0),(311122,8643,'af','Kredietkaartaankope Tipe Opdateer',0),(311123,8643,'ro','Actualizare de tip carte de credit cumpÄƒrare',0),(311124,8643,'et','Krediitkaardi ostu tÃ¼Ã¼p vÃ¤rskendamine',0),(311125,8643,'si','Kreditne kartice nakup vrste posodobitev',0),(311126,8643,'ba','Kartu kredit pembelian jenis Update',0),(311127,8643,'nl','Creditcard aankoop Type Update',0),(311128,8643,'fi','Luottokortilla oston tyyppi pÃ¤ivitys',0),(311129,8643,'no','Kredittkort kjÃ¸p Type oppdatering',0),(311130,8643,'da','Kreditkort KÃ¸b Type opdatering',0),(311131,8643,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ í˜•ì‹ ì—…ë°ì´íŠ¸',0),(311132,8643,'he','×¢×“×›×•×Ÿ ×¡×•×’ ×¨×›×™×©×” ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(311133,8643,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Ï… Î±Î³Î¿ÏÎ¬ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(311134,8643,'zh','ä¿¡ç”¨å¡è´­ä¹°æœ€æ–°åž‹\r\n',0),(311135,8643,'sv','Kreditkort kÃ¶p typ uppdatering',0),(311136,8643,'it','Carta di credito acquisto tipo aggiornamento',0),(311137,8643,'tl','',0),(311138,8643,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(311139,8643,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(311140,8643,'ms','Kad kredit pembelian jenis Kemaskini',0),(311141,8643,'ar','ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(311142,8643,'fr','Mise Ã  jour de carte de crÃ©dit achat Type',0),(311143,8643,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰è³¼å…¥ã‚¿ã‚¤ãƒ—æ›´æ–°',0),(311144,8643,'pt','CartÃ£o de crÃ©dito compra tipo atualizaÃ§Ã£o',0),(311145,8643,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(311146,8643,'es','Tarjeta de CrÃ©dito Actualizar Tipo de Compras',0),(311147,8643,'de','Kreditkarte kaufen Typ Update',0),(311148,8643,'en','Credit Card Purchase Type Update',0),(311149,8644,'is','',0),(311150,8644,'dr','Ù†Ø§Ù… Ùˆ Ø´Ø±Ø­ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(311151,8644,'pr','Ù†Ø§Ù… Ùˆ Ø´Ø±Ø­ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(311152,8644,'tr','Kredi kartÄ± adÄ± veya aÃ§Ä±klamasÄ±',0),(311153,8644,'pl','Nazwa karty kredytowej lub opis',0),(311154,8644,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¸Ð¼Ðµ Ð¸Ð»Ð¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(311155,8644,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Ø§ Ù†Ø§Ù… ÛŒØ§ ØªÙØµÛŒÙ„',0),(311156,8644,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð¸Ð¼Ðµ Ð¸Ð»Ð¸ Ð¾Ð¿Ð¸Ñ',0),(311157,8644,'vi','TÃªn & MÃ´ Táº£ Tháº» TÃ­n Dá»¥ng',0),(311158,8644,'af','Kredietkaartnaam of Beskrywing',0),(311159,8644,'ro','Card de credit nume sau Descriere',0),(311160,8644,'et','Krediitkaardi omaniku nimi vÃµi kirjeldus',0),(311161,8644,'si','Kreditno kartico ime ali opis',0),(311162,8644,'ba','Kartu nama atau keterangan',0),(311163,8644,'nl','Creditcard naam of beschrijving',0),(311164,8644,'fi','Luottokortin nimi tai kuvaus',0),(311165,8644,'no','Kredittkort navnet eller beskrivelsen',0),(311166,8644,'da','Kreditkort navn eller beskrivelse',0),(311167,8644,'ko','ì‹ ìš© ì¹´ë“œ ì´ë¦„ ë˜ëŠ” ì„¤ëª…',0),(311168,8644,'he','×©× ××• ×ª×™××•×¨ ×›×¨×˜×™×¡ ××©×¨××™',0),(311169,8644,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÏŒÎ½Î¿Î¼Î± Î® Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(311170,8644,'zh','ä¿¡ç”¨å¡åç§°æˆ–è¯´æ˜Ž\r\n',0),(311171,8644,'sv','Kreditkort namn eller beskrivning',0),(311172,8644,'it','Carta di credito nome o descrizione',0),(311173,8644,'tl','',0),(311174,8644,'th','&#3594;&#3639;&#3656;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605; &#3627;&#3619;&#3639;&#3629; &#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;',0),(311175,8644,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤µà¤°à¥à¤£à¤¨',0),(311176,8644,'ms','Kad kredit nama atau perihalan',0),(311177,8644,'ar','Ø§Ø³Ù… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø£Ùˆ Ø§Ù„ÙˆØµÙ',0),(311178,8644,'fr','Nom de la carte de crÃ©dit ou de la Description',0),(311179,8644,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®åå‰ã¾ãŸã¯èª¬æ˜Ž',0),(311180,8644,'pt','Nome do cartÃ£o de crÃ©dito ou descriÃ§Ã£o',0),(311181,8644,'ru','Ð˜Ð¼Ñ Ð¸Ð»Ð¸ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ñ‹',0),(311182,8644,'es','Tarjeta de CrÃ©dito Nombre o DescripciÃ³n',0),(311183,8644,'de','Name der Kreditkarte oder Beschreibung',0),(311184,8644,'en','Credit Card Name or Description',0),(311185,8645,'is','',0),(311186,8645,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(311187,8645,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(311188,8645,'tr','Kredi kartÄ± satÄ±cÄ± Ekle',0),(311189,8645,'pl','DodaÄ‡ dostawca karty kredytowej',0),(311190,8645,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(311191,8645,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(311192,8645,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(311193,8645,'vi','ThÃªm NhÃ  Cung Cáº¥p Tháº» TÃ­n Dá»¥ng',0),(311194,8645,'af','Kredietkaart Verskaffer Byvoeg',0),(311195,8645,'ro','Card de credit furnizor Adauga',0),(311196,8645,'et','Krediit kaardi lisamine',0),(311197,8645,'si','Kreditno kartico dobavitelja dodate',0),(311198,8645,'ba','Menambahkan kartu kredit Vendor',0),(311199,8645,'nl','Credit Card leverancier toevoegen',0),(311200,8645,'fi','Luottokortin toimittajan lisÃ¤ys',0),(311201,8645,'no','Kredittkort leverandÃ¸ren legge',0),(311202,8645,'da','Kreditkort kreditor tilfÃ¸je',0),(311203,8645,'ko','ì‹ ìš© ì¹´ë“œ ê³µê¸‰ ì—…ì²´ ì¶”ê°€',0),(311204,8645,'he','×”×•×¡×£ ×¡×¤×§ ×›×¨×˜×™×¡ ××©×¨××™',0),(311205,8645,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(311206,8645,'zh','æ–°å¢žä¿¡ç”¨å¡ä¾›åº”å•†\r\n',0),(311207,8645,'sv','Kreditkort om leverantÃ¶rstillÃ¤gg',0),(311208,8645,'it','Aggiungi carta di credito fornitore',0),(311209,8645,'tl','',0),(311210,8645,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(311211,8645,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(311212,8645,'ms','Penjual kad kredit Tambah',0),(311213,8645,'ar','Ø¥Ø¶Ø§ÙØ© Ø¬Ù‡Ø© Ø¥ØµØ¯Ø§Ø± Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(311214,8645,'fr','Ajouter le fournisseur de carte de crÃ©dit',0),(311215,8645,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(311216,8645,'pt','Adicionar o fornecedor de cartÃ£o de crÃ©dito',0),(311217,8645,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(311218,8645,'es','Tarjeta de CrÃ©dito Agregar Proveedor',0),(311219,8645,'de','Kreditkarten-Anbieter hinzufÃ¼gen',0),(311220,8645,'en','Credit Card Vendor Add',0),(311221,8646,'is','',0),(311222,8646,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(311223,8646,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(311224,8646,'tr','Kredi kartÄ± satÄ±cÄ± GÃ¼ncelleÅŸtirmesi',0),(311225,8646,'pl','Aktualizacja dostawcy karty kredytowej',0),(311226,8646,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(311227,8646,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ ÙˆÛŒÙ†ÚˆØ± ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(311228,8646,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(311229,8646,'vi','Cáº­p Nháº­t NhÃ  Cung Cáº¥p Tháº» TÃ­n Dá»¥ng',0),(311230,8646,'af','Kredietkaart Verskaffer Opdateer',0),(311231,8646,'ro','Card de credit furnizor Update',0),(311232,8646,'et','Krediitkaardi hankija vÃ¤rskendus',0),(311233,8646,'si','Kreditno kartico dobavitelja posodobitev',0),(311234,8646,'ba','Kartu kredit Vendor Update',0),(311235,8646,'nl','Credit Card leverancier Update',0),(311236,8646,'fi','Luottokortin toimittajan pÃ¤ivitys',0),(311237,8646,'no','Kredittkort leverandÃ¸ren Update',0),(311238,8646,'da','Kreditkort kreditor opdatering',0),(311239,8646,'ko','ì‹ ìš© ì¹´ë“œ ê³µê¸‰ ì—…ì²´ ì—…ë°ì´íŠ¸',0),(311240,8646,'he','×¢×“×›×•×Ÿ ×¡×¤×§ ×›×¨×˜×™×¡ ×”××©×¨××™',0),(311241,8646,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(311242,8646,'zh','ä¿¡ç”¨å¡ä¾›åº”å•†æ›´æ–°\r\n',0),(311243,8646,'sv','Kreditkort leverantÃ¶r uppdatering',0),(311244,8646,'it','Aggiornamento del fornitore di carta di credito',0),(311245,8646,'tl','',0),(311246,8646,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(311247,8646,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(311248,8646,'ms','Kemas kini kad kredit pembekal',0),(311249,8646,'ar','ØªØ­Ø¯ÙŠØ« Ø¬Ù‡Ø© Ø¥ØµØ¯Ø§Ø± Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(311250,8646,'fr','Mise Ã  jour de carte de crÃ©dit fournisseur',0),(311251,8646,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ ãƒ™ãƒ³ãƒ€ãƒ¼ã«ã‚ˆã‚‹æ›´æ–°',0),(311252,8646,'pt','AtualizaÃ§Ã£o de fornecedor de cartÃ£o de crÃ©dito',0),(311253,8646,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(311254,8646,'es','Tarjeta de CrÃ©dito Actualizar Proveedor',0),(311255,8646,'de','Kreditkarten-Anbieter Update',0),(311256,8646,'en','Credit Card Vendor Update',0),(311257,8647,'is','',0),(311258,8647,'dr','Ù†ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(311259,8647,'pr','Ù†ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(311260,8647,'tr','Ãœcret tÃ¼rÃ¼',0),(311261,8647,'pl','Typ opÅ‚aty',0),(311262,8647,'bg','Ð’Ð¸Ð´ Ñ‚Ð°ÐºÑÐ°',0),(311263,8647,'ur','Ú†Ø§Ø±Ø¬ Ú©ÛŒ Ù‚Ø³Ù…',0),(311264,8647,'sr','Ð’Ñ€ÑÑ‚Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(311265,8647,'vi','Loáº¡i phÃ­',0),(311266,8647,'af','Heffing Tipe',0),(311267,8647,'ro','Taxa de tip',0),(311268,8647,'et','Tasu tÃ¼Ã¼p',0),(311269,8647,'si','Vrsta stroÅ¡ka',0),(311270,8647,'ba','Jenis biaya',0),(311271,8647,'nl','Betaling Type',0),(311272,8647,'fi','Maksun tyyppi',0),(311273,8647,'no','Gratis Type',0),(311274,8647,'da','Gebyr Type',0),(311275,8647,'ko','ìš”ê¸ˆ ìœ í˜•',0),(311276,8647,'he','×¡×•×’ ×ª×©×œ×•×',0),(311277,8647,'el','Î§ÏÎ­Ï‰ÏƒÎ· Ï„ÏÏ€Î¿Ï…',0),(311278,8647,'zh','è´¹ç”¨ç±»åž‹\r\n',0),(311279,8647,'sv','Laddning typ',0),(311280,8647,'it','Tipo di carica',0),(311281,8647,'tl','',0),(311282,8647,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(311283,8647,'hi','à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(311284,8647,'ms','Jenis caj',0),(311285,8647,'ar','Ù†ÙˆØ¹ Ø§Ù„ØªÙ‡Ù…Ø©',0),(311286,8647,'fr','Type de charge',0),(311287,8647,'jp','æ–™é‡‘ã‚¿ã‚¤ãƒ—',0),(311288,8647,'pt','Tipo de carga',0),(311289,8647,'ru','Ð¢Ð¸Ð¿ Ð·Ð°Ñ€ÑÐ´Ð°',0),(311290,8647,'es','Tipo de Carga',0),(311291,8647,'de','Kostenlos-Typ',0),(311292,8647,'en','Charge Type',0),(311293,8648,'is','',0),(311294,8648,'dr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ â€“ Ø§ÙØ²ÙˆØ¯Ù†',0),(311295,8648,'pr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ â€“ Ø§ÙØ²ÙˆØ¯Ù†',0),(311296,8648,'tr','Kredi kartÄ± SatÄ±nalmalar - Ekle',0),(311297,8648,'pl','Zakup kartÄ… kredytowÄ… - Dodaj',0),(311298,8648,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°-',0),(311299,8648,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø³ÙˆØ¯ÙˆÚº - Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(311300,8648,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ðµ-',0),(311301,8648,'vi','ThÃªm Giao Dá»‹ch Mua HÃ ng Qua Tháº» TÃ­n Dá»¥ng',0),(311302,8648,'af','Kredietkaartaankope - Byvoeg',0),(311303,8648,'ro','Card de credit cumpÄƒrÄƒri - Adauga',0),(311304,8648,'et','Krediitkaardiga ostmisel - lisamine',0),(311305,8648,'si','Nakup s kreditno kartico - dodati',0),(311306,8648,'ba','Kartu kredit pembelian - Tambahkan',0),(311307,8648,'nl','Credit Card aankopen - toevoegen',0),(311308,8648,'fi','Luottokortti ostot - lisÃ¤Ã¤',0),(311309,8648,'no','KredittkortkjÃ¸p - legges',0),(311310,8648,'da','Kreditkort KÃ¸b - tilfÃ¸je',0),(311311,8648,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤-ì¶”ê°€',0),(311312,8648,'he','×¨×›×™×©×•×ª ×‘×›×¨×˜×™×¡×™ ××©×¨××™ - ×œ×”×•×¡×™×£',0),(311313,8648,'el','Î‘Î³Î¿ÏÎ­Ï‚ Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± - Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(311314,8648,'zh','ä¿¡ç”¨å¡è´­ä¹°- æ·»åŠ \r\n',0),(311315,8648,'sv','KreditkortskÃ¶p - LÃ¤gg till',0),(311316,8648,'it','Gli acquisti di carta di credito - Aggiungi',0),(311317,8648,'tl','',0),(311318,8648,'th','&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605; - &#3648;&#3614;&#3636;&#3656;&#3617;',0),(311319,8648,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤–à¤°à¥€à¤¦ - à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(311320,8648,'ms','Pembelian kad kredit - Tambah',0),(311321,8648,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø´ØªØ±ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(311322,8648,'fr','Achats par carte de crÃ©dit - ajouter',0),(311323,8648,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã§ã®è³¼å…¥ - è¿½åŠ ã—ã¾ã™ã€‚',0),(311324,8648,'pt','Compras com cartÃ£o de crÃ©dito - adicionar',0),(311325,8648,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹ - Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(311326,8648,'es','Tarjeta de CrÃ©dito Compras - Agregar',0),(311327,8648,'de','KreditkartenkÃ¤ufe - hinzufÃ¼gen',0),(311328,8648,'en','Credit Card Purchases - Add',0),(311329,8649,'is','',0),(311330,8649,'dr','Ø®Ø±ÙŠØ¯ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ',0),(311331,8649,'pr','Ø®Ø±ÙŠØ¯ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ',0),(311332,8649,'tr','TarafÄ±ndan satÄ±n',0),(311333,8649,'pl','Zakup przez',0),(311334,8649,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð¾Ñ‚',0),(311335,8649,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(311336,8649,'sr','ÐÐ°Ð±Ð°Ð²ÐºÐµ Ñ‚Ð°ÐºÐ¾ ÑˆÑ‚Ð¾ Ñ›ÐµÑ‚Ðµ',0),(311337,8649,'vi','Mua bá»Ÿi',0),(311338,8649,'af','Aankoop By',0),(311339,8649,'ro','AchiziÅ£ionarea de',0),(311340,8649,'et','Ostu',0),(311341,8649,'si','Nakup z',0),(311342,8649,'ba','Membeli',0),(311343,8649,'nl','Koop door',0),(311344,8649,'fi','Ostaa',0),(311345,8649,'no','KjÃ¸pe ved',0),(311346,8649,'da','KÃ¸b af',0),(311347,8649,'ko','ì—¬ êµ¬ë§¤',0),(311348,8649,'he','×œ×¨×›×•×© ×¢×œ ×™×“×™',0),(311349,8649,'el','Î‘Î³Î¿ÏÎ¬ Î±Ï€ÏŒ',0),(311350,8649,'zh','è´­ä¹°æ–¹å¼\r\n',0),(311351,8649,'sv','KÃ¶p av',0),(311352,8649,'it','Acquisto di',0),(311353,8649,'tl','',0),(311354,8649,'th','&#3595;&#3639;&#3657;&#3629;&#3650;&#3604;&#3618;',0),(311355,8649,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤–à¤°à¥€à¤¦',0),(311356,8649,'ms','Pembelian dengan',0),(311357,8649,'ar','Ø´Ø±Ø§Ø¡ Ø¹Ù† Ø·Ø±ÙŠÙ‚',0),(311358,8649,'fr','Achat par',0),(311359,8649,'jp','è³¼å…¥ã—ã¾ã™ã€‚',0),(311360,8649,'pt','Compra por',0),(311361,8649,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸ Ð¿Ð¾',0),(311362,8649,'es','Compra Por',0),(311363,8649,'de','Kauf durch',0),(311364,8649,'en','Purchase By',0),(311365,8650,'is','',0),(311366,8650,'dr','ØªØ§Ø±ÙŠØ® Ø®Ø±ÙŠØ¯ ',0),(311367,8650,'pr','ØªØ§Ø±ÙŠØ® Ø®Ø±ÙŠØ¯ ',0),(311368,8650,'tr','SatÄ±n alma tarihi',0),(311369,8650,'pl','Data zakupu',0),(311370,8650,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(311371,8650,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(311372,8650,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(311373,8650,'vi','NgÃ y Mua',0),(311374,8650,'af','Aankoop Datum',0),(311375,8650,'ro','Data de cumpÄƒrare',0),(311376,8650,'et','Ostutellimuse kuupÃ¤ev',0),(311377,8650,'si','Datum nakupa',0),(311378,8650,'ba','Tanggal pembelian',0),(311379,8650,'nl','Aankoopdatum',0),(311380,8650,'fi','OstopÃ¤ivÃ¤stÃ¤',0),(311381,8650,'no','KjÃ¸psdatoen',0),(311382,8650,'da','KÃ¸bsdato',0),(311383,8650,'ko','êµ¬ìž… ë‚ ì§œ',0),(311384,8650,'he','×ª××¨×™×š ×¨×›×™×©×”',0),(311385,8650,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(311386,8650,'zh','è´­ä¹°æ—¥æœŸ\r\n',0),(311387,8650,'sv','InkÃ¶psdatum',0),(311388,8650,'it','Data di acquisto',0),(311389,8650,'tl','',0),(311390,8650,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3595;&#3639;&#3657;&#3629;',0),(311391,8650,'hi','à¤–à¤°à¥€à¤¦ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(311392,8650,'ms','Tarikh pembelian',0),(311393,8650,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø´Ø±Ø§Ø¡',0),(311394,8650,'fr','Date d\'achat',0),(311395,8650,'jp','è³¼å…¥æ—¥',0),(311396,8650,'pt','Data da compra',0),(311397,8650,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(311398,8650,'es','Fecha de Compra',0),(311399,8650,'de','Kaufdatum',0),(311400,8650,'en','Purchase Date',0),(311401,8651,'is','',0),(311402,8651,'dr','Ø®Ø±ÙŠØ¯ Ø§Ø² ',0),(311403,8651,'pr','Ø®Ø±ÙŠØ¯ Ø§Ø² ',0),(311404,8651,'tr','SatÄ±n',0),(311405,8651,'pl','Zakup od',0),(311406,8651,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð¾Ñ‚',0),(311407,8651,'ur','Ø³Û’ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(311408,8651,'sr','ÐšÑƒÐ¿Ð¸Ñ‚Ðµ Ð¾Ð´',0),(311409,8651,'vi','Mua Tá»«',0),(311410,8651,'af','Aankoop Vanaf',0),(311411,8651,'ro','CumpÄƒra de la',0),(311412,8651,'et','Osta',0),(311413,8651,'si','Nakup od',0),(311414,8651,'ba','Membeli dari',0),(311415,8651,'nl','Kopen van',0),(311416,8651,'fi','Ostaa',0),(311417,8651,'no','KjÃ¸pe fra',0),(311418,8651,'da','KÃ¸b fra',0),(311419,8651,'ko','êµ¬ìž…',0),(311420,8651,'he','×¨×›×•×© ×ž××ª',0),(311421,8651,'el','Î‘Î³Î¿ÏÎ¬ Î±Ï€ÏŒ',0),(311422,8651,'zh','è´­ä¹°æ¥è‡ª\r\n',0),(311423,8651,'sv','KÃ¶pa',0),(311424,8651,'it','Acquistare da',0),(311425,8651,'tl','',0),(311426,8651,'th','&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;',0),(311427,8651,'hi','à¤¸à¥‡ à¤–à¤°à¥€à¤¦',0),(311428,8651,'ms','Membeli daripada',0),(311429,8651,'ar','Ø´Ø±Ø§Ø¡ Ù…Ù†',0),(311430,8651,'fr','Acheter',0),(311431,8651,'jp','è³¼å…¥ã—ã¾ã™ã€‚',0),(311432,8651,'pt','Compra de',0),(311433,8651,'ru','ÐŸÑ€Ð¸Ð¾Ð±Ñ€ÐµÑÑ‚Ð¸',0),(311434,8651,'es','Comprar De',0),(311435,8651,'de','Kaufen von',0),(311436,8651,'en','Purchase From',0),(311437,8652,'is','',0),(311438,8652,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø§ Ù…Ø¨Ù„Øº ØªÙˆØ²ÙŠØ¹ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ù†ÙŠØ³Øª ',0),(311439,8652,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø§ Ù…Ø¨Ù„Øº ØªÙˆØ²ÙŠØ¹ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ù†ÙŠØ³Øª ',0),(311440,8652,'tr','Toplam Sum daÄŸÄ±lÄ±mlarÄ± eÅŸleÅŸmiyor',0),(311441,8652,'pl','Sumie nie odpowiada sumÄ… dystrybucji',0),(311442,8652,'bg','ÐžÐ±Ñ‰Ð¾ Ð½Ðµ ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð° Ð½Ð° ÑÐ±Ð¾Ñ€Ð° Ð¾Ñ‚ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ†Ð¸Ð¸',0),(311443,8652,'ur','Ú©Ù„ Ø±Ù‚Ù… ØªÙ‚Ø³ÛŒÙ… Ú©Û’ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº',0),(311444,8652,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÑÐµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐ° Ð·Ð±Ð¸Ñ€ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ†Ð¸Ñ˜Ð°Ð¼Ð°',0),(311445,8652,'vi','Tá»•ng cá»™ng khÃ´ng cÃ¢n vá»›i tá»•ng sá»‘ phÃ¢n phá»‘i',0),(311446,8652,'af','Totaal Stem nie Ooreen met Verspreidings',0),(311447,8652,'ro','Total nu se potriveÅŸte cu suma de distribuÅ£ii',0),(311448,8652,'et','Kokku sobitada vÃ¤ljamaksete summa',0),(311449,8652,'si','Skupaj se ne ujema z vsoto distribucij',0),(311450,8652,'ba','Total tidak cocok dengan jumlah distribusi',0),(311451,8652,'nl','Totaal komt niet overeen met de som van distributies',0),(311452,8652,'fi','YhteensÃ¤ ei vastaa jakelujen summa',0),(311453,8652,'no','Totalt tilsvarer ikke summen av distribusjoner',0),(311454,8652,'da','Alt stemmer ikke overens med summen af distributioner',0),(311455,8652,'ko','ì´ì€ ë°°í¬íŒì˜ í•©ê³„ì™€ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(311456,8652,'he','×¡×” ×› ××™× ×• ×ª×•×× ×¡×›×•× ×©×œ ×”×¤×¦×•×ª',0),(311457,8652,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î¼Îµ Î¬Î¸ÏÎ¿Î¹ÏƒÎ¼Î± Ï„Ï‰Î½ Î´Î¹Î±Î½Î¿Î¼Î­Ï‚',0),(311458,8652,'zh','æ€»è®¡ä¸Žåˆ†é…ä¸åŒ¹é…çš„æ€»é¢\r\n',0),(311459,8652,'sv','Totalt matchar inte summan av distributioner',0),(311460,8652,'it','Totale non corrisponde la somma delle distribuzioni',0),(311461,8652,'tl','',0),(311462,8652,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3605;&#3619;&#3591;&#3585;&#3633;&#3610;&#3612;&#3621;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3592;&#3635;&#3627;&#3609;&#3656;&#3',0),(311463,8652,'hi','à¤•à¥à¤² à¤µà¤¿à¤¤à¤°à¤£ à¤•à¤¾ à¤¯à¥‹à¤— à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(311464,8652,'ms','Jumlah keseluruhan tidak sepadan dengan jumlah pengagihan',0),(311465,8652,'ar','Ù„Ø§ ÙŠØ·Ø§Ø¨Ù‚ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ØªÙˆØ²ÙŠØ¹Ø§Øª',0),(311466,8652,'fr','Total ne correspond pas Ã  la somme des Distributions',0),(311467,8652,'jp','åˆè¨ˆãŒãƒ‡ã‚£ã‚¹ãƒˆãƒªãƒ“ãƒ¥ãƒ¼ã‚·ãƒ§ãƒ³ã®åˆè¨ˆã¨ä¸€è‡´ã—ã¾ã›ã‚“',0),(311468,8652,'pt','Total nÃ£o corresponde a soma das distribuiÃ§Ãµes',0),(311469,8652,'ru','Ð’ÑÐµÐ³Ð¾ Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÑÑƒÐ¼Ð¼Ðµ Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ð¹',0),(311470,8652,'es','Total No se Empareja la Suma de los Distrbuciones',0),(311471,8652,'de','Insgesamt entspricht die Summe der AusschÃ¼ttungen nicht',0),(311472,8652,'en','Total Does Not Match Sum of Distributions',0),(311473,8653,'is','',0),(311474,8653,'dr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(311475,8653,'pr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(311476,8653,'tr','Kredi kartÄ± SatÄ±nalmalar',0),(311477,8653,'pl','Zakup kartÄ… kredytowÄ…',0),(311478,8653,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(311479,8653,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(311480,8653,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ðµ',0),(311481,8653,'vi','Giao Dá»‹ch Mua HÃ ng Qua Tháº» TÃ­n Dá»¥ng',0),(311482,8653,'af','Kredietkaartaankope',0),(311483,8653,'ro','Card de credit cumpÄƒrÄƒri',0),(311484,8653,'et','Krediitkaardiga ostmisel',0),(311485,8653,'si','Nakup s kreditno kartico',0),(311486,8653,'ba','Kartu kredit pembelian',0),(311487,8653,'nl','Credit Card aankopen',0),(311488,8653,'fi','Luottokorttiostoissa',0),(311489,8653,'no','Kredittkort',0),(311490,8653,'da','Kreditkort kÃ¸b',0),(311491,8653,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤',0),(311492,8653,'he','×¨×›×™×©×•×ª ×‘×›×¨×˜×™×¡×™ ××©×¨××™',0),(311493,8653,'el','Î‘Î³Î¿ÏÎ­Ï‚ Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(311494,8653,'zh','ä¿¡ç”¨å¡è´­ä¹°\r\n',0),(311495,8653,'sv','KreditkortskÃ¶p',0),(311496,8653,'it','Acquisti di carta di credito',0),(311497,8653,'tl','',0),(311498,8653,'th','&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(311499,8653,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤–à¤°à¥€à¤¦',0),(311500,8653,'ms','Pembelian kad kredit',0),(311501,8653,'ar','Ù…Ø´ØªØ±ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(311502,8653,'fr','Achats par carte de crÃ©dit',0),(311503,8653,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è³¼å…¥',0),(311504,8653,'pt','Compras com cartÃ£o de crÃ©dito',0),(311505,8653,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(311506,8653,'es','Tarjeta de CrÃ©dito Compras',0),(311507,8653,'de','KreditkarteneinkÃ¤ufe',0),(311508,8653,'en','Credit Card Purchases',0),(311509,8654,'is','',0),(311510,8654,'dr','Ú†Ù‡ ÙƒØ³ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ±Ø¯ ',0),(311511,8654,'pr','Ú†Ù‡ ÙƒØ³ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ±Ø¯ ',0),(311512,8654,'tr','Kim Ã¼cret',0),(311513,8654,'pl','KtÃ³ry opÅ‚ata',0),(311514,8654,'bg','ÐšÐ¾Ð¹Ñ‚Ð¾ Ñ‚Ð°ÐºÑÑƒÐ²Ð°',0),(311515,8654,'ur','Ø¬Ø³ Ú©Ø§ Ø§Ù„Ø²Ø§Ù… Ù„Ú¯Ø§ÛŒØ§',0),(311516,8654,'sr','ÐšÐ¾ Ñ˜Ðµ Ð¾Ð¿Ñ‚ÑƒÐ¶ÐµÐ½',0),(311517,8654,'vi','Ai tÃ­nh phÃ­',0),(311518,8654,'af','Wie Het Gehef',0),(311519,8654,'ro','Care plÄƒtesc',0),(311520,8654,'et','Kes maksustas',0),(311521,8654,'si','Ki zaraÄunavajo',0),(311522,8654,'ba','Yang dikenakan biaya',0),(311523,8654,'nl','Die belast',0),(311524,8654,'fi','Joka veloitetaan',0),(311525,8654,'no','Som belastet',0),(311526,8654,'da','Der opkrÃ¦ves',0),(311527,8654,'ko','ëˆ„ê°€ ì²­êµ¬',0),(311528,8654,'he','×ž×™ ×ž×—×•×™×‘',0),(311529,8654,'el','Î Î¿Ï… Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹',0),(311530,8654,'zh','è°å˜æ›´\r\n',0),(311531,8654,'sv','Som laddat',0),(311532,8654,'it','Chi paga',0),(311533,8654,'tl','',0),(311534,8654,'th','&#3651;&#3588;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(311535,8654,'hi','à¤œà¥‹ à¤†à¤°à¥‹à¤ª à¤²à¤—à¤¾à¤¯à¤¾',0),(311536,8654,'ms','Yang dikenakan',0),(311537,8654,'ar','Ø§ØªÙ‡Ù…Øª Ù…Ù†Ø¸Ù…Ø© Ø§Ù„ØµØ­Ø© Ø§Ù„Ø¹Ø§Ù„Ù…ÙŠØ©',0),(311538,8654,'fr','Qui accusÃ©',0),(311539,8654,'jp','äººãŒèµ·è¨´',0),(311540,8654,'pt','Quem Ã© cobrado',0),(311541,8654,'ru','ÐšÑ‚Ð¾ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(311542,8654,'es','Quien CargÃ³',0),(311543,8654,'de','Wer berechnet',0),(311544,8654,'en','Who Charged',0),(311545,8655,'is','',0),(311546,8655,'dr','. Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø¹Ø¯ Ø§Ø² Ø§Ø¯ØºØ§Ù… Ø¨Ø§ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§Ù„Ø§ Ù…Ø±ØªØ¨Ø· Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(311547,8655,'pr','Ù‡Ù…Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª â€“ ÙØ§ÙƒØªÙˆØ± â€“ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ùˆ ØºÙŠØ±Ù‡ . Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø¹Ø¯ Ø§Ø² Ø§Ø¯ØºØ§Ù… Ø¨Ø§ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§Ù„Ø§ Ù…Ø±ØªØ¨Ø· Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(311548,8655,'tr','TÃ¼m hareketler iÃ§in yeni mÃ¼ÅŸteri kaydÄ± da taÅŸÄ±nÄ±r',0),(311549,8655,'pl','Wszystkie transakcje zostanÄ… przeniesione do nowego rekordu klienta rÃ³wnieÅ¼',0),(311550,8655,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ñ‰Ðµ Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ñ€ÐµÐ¼ÐµÑÑ‚ÐµÐ½Ð¸ Ð² Ð½Ð¾Ð² Ð·Ð°Ð¿Ð¸Ñ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑŠÑ‰Ð¾',0),(311551,8655,'ur','ØªÙ…Ø§Ù… Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ù†Ø¦Û’ Ú¯Ø§ÛÚ© Ø±ÛŒÚ©Ø§Ø±Úˆ Ø¨Ú¾ÛŒ Ø¨Ú‘Ú¾Ø§ Ø¯ÛŒ Ø¬Ø§Ø¦Û’ Ú¯ÛŒ',0),(311552,8655,'sr','Ð¡Ð²Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ñ›Ðµ Ñ‚Ð°ÐºÐ¾Ñ’Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾Ð¼Ñ˜ÐµÑ€ÐµÐ½Ðµ Ñƒ Ð½Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð¸Ñ ÐºÑƒÐ¿Ñ†Ð°',0),(311553,8655,'vi','Táº¥t Cáº£ ÄÆ¡n Äáº·t HÃ ng, HÃ³a ÄÆ¡n, Thanh ToÃ¡n vv Cho Nhá»¯ng KhÃ¡ch HÃ ng NÃ y Sáº½ KÃ¨m Theo KhÃ¡ch HÃ ng TrÃªn Sau Khi Há»£p Nháº¥t',0),(311554,8655,'af','Alle Bestellings, Fakture, Betalings, ens. vir hierdie KLIÃ«nt / KLANT sal geassosieer word met die bogenoemde KLIÃ«nt / KLANT na afloop van die Vereniging',0),(311555,8655,'ro','Toate tranzacÅ£iile vor fi mutate Ã®n noua Ã®nregistrare client, de asemenea',0),(311556,8655,'et','KÃµik nende klientide tellimused, arved, maksed jne seostatakse Ã¼laloleva kliendiga peale Ã¼hendamist',0),(311557,8655,'si','Vse transakcije se bodo preselili v nov zapis kupca tudi',0),(311558,8655,'ba','Semua transaksi akan dipindahkan ke catatan pelanggan baru juga',0),(311559,8655,'nl','Alle transacties zullen worden verplaatst naar de nieuwe klantrecord ook',0),(311560,8655,'fi','Kaikki tapahtumat siirretÃ¤Ã¤n myÃ¶s uusi asiakastietue',0),(311561,8655,'no','Alle transaksjoner vil bli flyttet til den nye kundeposten ogsÃ¥',0),(311562,8655,'da','Alle transaktioner vil blive flyttet til den nye kundepost ogsÃ¥',0),(311563,8655,'ko','ëª¨ë“  ê±°ëž˜ ë˜í•œ ìƒˆ ê³ ê° ë ˆì½”ë“œë¥¼ ì´ë™ í•©ë‹ˆë‹¤.',0),(311564,8655,'he','×›×œ ×”×¢×¡×§××•×ª ×ª×•×¢×‘×¨ ××œ ×¨×©×•×ž×ª ×”×œ×§×•×— ×”×—×“×© ×’×',0),(311565,8655,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ Î¸Î± Î¼ÎµÏ„Î±Ï†ÎµÏÎ¸Î¿ÏÎ½ ÏƒÎµ Î¼Î¹Î± Î½Î­Î± ÎµÎ³Î³ÏÎ±Ï†Î® Ï€ÎµÎ»Î¬Ï„Î· ÎµÏ€Î¯ÏƒÎ·Ï‚',0),(311566,8655,'zh','è¿™äº›å®¢æˆ·çš„è®¢å•ï¼Œå‘ç¥¨ï¼Œä»˜æ¬¾ç­‰å‡ºçŽ°åŽå°†ä¼šä¸Žä¹‹å‰çš„å®¢æˆ·åˆå¹¶\r\n',0),(311567,8655,'sv','Alla transaktioner kommer att flyttas till den nya kundposten ocksÃ¥',0),(311568,8655,'it','Tutte le transazioni verranno spostate anche il nuovo record del cliente',0),(311569,8655,'tl','',0),(311570,8655,'th','All Orders, Invoice, Payments, Etc For These Customers Will Be Associated With The Above Customer After Merge',0),(311571,8655,'hi','à¤¸à¤­à¥€ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤­à¥€ à¤¨à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¿à¤•à¤¾à¤°à¥à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾',0),(311572,8655,'ms','Semua transaksi akan berpindah ke rekod pelanggan baru juga',0),(311573,8655,'ar','Ø³ÙŠØªÙ… Ù†Ù‚Ù„ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¥Ù„Ù‰ Ø³Ø¬Ù„ Ø¹Ù…ÙŠÙ„ Ø¬Ø¯ÙŠØ¯ Ø£ÙŠØ¶Ø§',0),(311574,8655,'fr','Toutes les transactions seront dÃ©placÃ©es vers le nouvel enregistrement de client aussi',0),(311575,8655,'jp','ã™ã¹ã¦ã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã¯ã¾ãŸã€æ–°ã—ã„é¡§å®¢ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ã«ç§»å‹•ã—ã¾ã™ã€‚',0),(311576,8655,'pt','Todas as transaÃ§Ãµes serÃ£o movidas para o novo registro de cliente tambÃ©m',0),(311577,8655,'ru','Ð’ÑÐµ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð±ÑƒÐ´ÑƒÑ‚ Ð¿ÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ñ‹ Ð² Ð½Ð¾Ð²ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ñ‚Ð°ÐºÐ¶Ðµ',0),(311578,8655,'es','Todo los Pedidos, Facturas, Etc. para Estos Clientes serÃ¡n Asociados con el Cliente ArrÃ­ba Mencionado DespuÃ©s de Incorporar',0),(311579,8655,'de','Alle Transaktionen werden in den neuen Kundendatensatz auch verschoben',0),(311580,8655,'en','All transactions will be moved to the new customer record also',0),(311581,8656,'is','',0),(311582,8656,'dr','( Ø¯ÙØ§ØªØ±  ) Ø®Ø±ÙŠØ¯Ø§Ø±',0),(311583,8656,'pr','Ø§Ø¯ØºØ§Ù…  Ø§Ø³Ù†Ø§Ø¯( Ø¯ÙØ§ØªØ±  ) Ø®Ø±ÙŠØ¯Ø§Ø±',0),(311584,8656,'tr','MÃ¼ÅŸteri kaydÄ± birleÅŸtirme',0),(311585,8656,'pl','Klienta rekord korespondencji seryjnej',0),(311586,8656,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð·Ð°Ð¿Ð¸Ñ Ð¾Ð±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ',0),(311587,8656,'ur','Ú©Ø³Ù¹Ù…Ø± Ø±ÛŒÚ©Ø§Ø±Úˆ Ø¶Ù… Ú©Ø±ÛŒÚº',0),(311588,8656,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð·Ð°Ð¿Ð¸ÑÐ° Ð¾Ð±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐ°',0),(311589,8656,'vi','Nháº­p há»“ sÆ¡ KhÃ¡ch hÃ ng',0),(311590,8656,'af','Verenig KliÃ«nt/Klant Rekord ',0),(311591,8656,'ro','ÃŽmbinare Ã®nregistrare client',0),(311592,8656,'et','Kliendi andmete Ã¼hendamine',0),(311593,8656,'si','Kupec zapis spajanja',0),(311594,8656,'ba','Merge catatan pelanggan',0),(311595,8656,'nl','Klant Record samenvoegen',0),(311596,8656,'fi','Asiakas tietueen yhdistÃ¤misen',0),(311597,8656,'no','Kunden registrere flettingen',0),(311598,8656,'da','Kunde optage Flet',0),(311599,8656,'ko','ê³ ê° ë ˆì½”ë“œ ë³‘í•©',0),(311600,8656,'he','×ž×™×–×•×’ ×¨×©×•×ž×ª ×”×œ×§×•×—',0),(311601,8656,'el','Î¡ÎµÎºÏŒÏ ÏƒÏ…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ·Ï‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(311602,8656,'zh','å®¢æˆ·è®°å½•åˆå¹¶\r\n',0),(311603,8656,'sv','Kunden registrera dokument',0),(311604,8656,'it','Fondere dati del cliente',0),(311605,8656,'tl','',0),(311606,8656,'th','&#3619;&#3623;&#3617;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(311607,8656,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤…à¤­à¤¿à¤²à¥‡à¤– à¤®à¤°à¥à¤œ',0),(311608,8656,'ms','Gabungan rekod pelanggan',0),(311609,8656,'ar','Ø¯Ù…Ø¬ Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(311610,8656,'fr','Client Record Merge',0),(311611,8656,'jp','é¡§å®¢ãƒ¬ã‚³ãƒ¼ãƒ‰ã®ãƒžãƒ¼ã‚¸',0),(311612,8656,'pt','Mesclagem de registro do cliente',0),(311613,8656,'ru','Ð¡Ð»Ð¸ÑÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(311614,8656,'es','Cliente FusiÃ³n de Records',0),(311615,8656,'de','Kunde Datensatz zusammenfÃ¼hren',0),(311616,8656,'en','Customer Record Merge',0),(311617,8657,'is','',0),(311618,8657,'dr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø§Ø² Ø§Ø³Ù†Ø§Ø¯ Ø§Ø¯ØºØ§Ù… Ø´Ø¯Ù‡ ',0),(311619,8657,'pr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø§Ø² Ø§Ø³Ù†Ø§Ø¯ Ø§Ø¯ØºØ§Ù… Ø´Ø¯Ù‡ ',0),(311620,8657,'tr','BirleÅŸtirilen kayÄ±tlardan Ã¶zel alanlar',0),(311621,8657,'pl','Niestandardowe pola z scalone rekordy',0),(311622,8657,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð¾Ñ‚ ÐžÐ±ÐµÐ´Ð¸Ð½ÐµÐ½Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(311623,8657,'ur','Ø¶Ù… Ø±ÛŒÚ©Ø§Ø±Úˆ Ø³Û’ Ù…Ø®ØµÙˆØµ Ù‚Ø·Ø¹Ø§Øª',0),(311624,8657,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ñ™Ð° Ð¸Ð· Ð·Ð°Ð¿Ð¸ÑÐ° Ð¾ Ð¾Ð±Ñ˜ÐµÐ´Ð¸ÑšÐµÐ½Ð¸Ð¼',0),(311625,8657,'vi','TrÆ°á»ng tá»± táº¡o tá»« há»“ sÆ¡ nháº­p',0),(311626,8657,'af','Aangepasde Velde vanaf Verenigde Rekords',0),(311627,8657,'ro','CÃ¢mpuri particularizate din Ã®nregistrÄƒrile Ã®mbinate',0),(311628,8657,'et','Ãœhendatud kirjete kohandatud vÃ¤ljade',0),(311629,8657,'si','Polja po meri iz spojene zapise',0),(311630,8657,'ba','Bidang kustom dari gabungan catatan',0),(311631,8657,'nl','Aangepaste velden van samengevoegde Records',0),(311632,8657,'fi','Mukautetut kentÃ¤t yhdistetyt tietueet',0),(311633,8657,'no','Egendefinerte felt fra flettede poster',0),(311634,8657,'da','Brugerdefinerede felter fra flettede poster',0),(311635,8657,'ko','ë³‘í•© ëœ ë ˆì½”ë“œì—ì„œ ì‚¬ìš©ìž ì •ì˜ í•„ë“œ',0),(311636,8657,'he','×©×“×•×ª ×ž×•×ª××ž×™× ××™×©×™×ª ×©×œ ×”×¨×©×•×ž×•×ª ×©×ž×•×–×’×•',0),(311637,8657,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î± Ï€ÎµÎ´Î¯Î± Î±Ï€ÏŒ Ï„Î¹Ï‚ ÏƒÏ…Î³Ï‡Ï‰Î½ÎµÏ…Î¼Î­Î½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(311638,8657,'zh','ä»Žåˆå¹¶çš„è®°å½•è‡ªå®šä¹‰å­—æ®µ\r\n',0),(311639,8657,'sv','Anpassade fÃ¤lt frÃ¥n kopplade poster',0),(311640,8657,'it','Campi personalizzati da record Uniti',0),(311641,8657,'tl','',0),(311642,8657,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3619;&#3623;&#3617;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;',0),(311643,8657,'hi','à¤®à¤°à¥à¤œ à¤•à¤¿à¤ à¤—à¤ à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¸à¥‡ à¤•à¤¸à¥à¤Ÿà¤® à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸',0),(311644,8657,'ms','Bidang-bidang adat dari rekod-rekod yang bergabung',0),(311645,8657,'ar','Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ø®ØµØµØ© Ù…Ù† Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ù…Ø¯Ù…Ø¬Ø©',0),(311646,8657,'fr','Champs personnalisÃ©s d\'enregistrements fusionnÃ©s',0),(311647,8657,'jp','å·®ã—è¾¼ã¿å°åˆ·ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ã®ã‚«ã‚¹ã‚¿ãƒ  ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(311648,8657,'pt','Campos personalizados de registros mesclados',0),(311649,8657,'ru','ÐÐ°ÑÑ‚Ñ€Ð°Ð¸Ð²Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ð¾Ð»Ñ Ð¸Ð· Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(311650,8657,'es','Campos Personalizados de Recods Fusionados',0),(311651,8657,'de','Benutzerdefinierte Felder aus zusammengefÃ¼hrten DatensÃ¤tze',0),(311652,8657,'en','Custom Fields from Merged Records',0),(311653,8658,'is','',0),(311654,8658,'dr','ÙˆÙŠØ±Ø§ÙŠØ´Ù‡Ø§ÙŠ Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯Ù‡ Ø¯Ø± ÙÙŠÙ„Ø¯Ù‡Ø§ ÙŠ Ø²ÙŠØ± Ø°Ø®ÙŠØ±Ù‡ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(311655,8658,'pr','ÙˆÙŠØ±Ø§ÙŠØ´Ù‡Ø§ÙŠ Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯Ù‡ Ø¯Ø± ÙÙŠÙ„Ø¯Ù‡Ø§ ÙŠ Ø²ÙŠØ± Ø°Ø®ÙŠØ±Ù‡ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(311656,8658,'tr','AÅŸaÄŸÄ±daki alanlara yapÄ±lan dÃ¼zenlemeler KAYDEDÄ°LMEYECEK',0),(311657,8658,'pl','Zmiany wprowadzone w polach poniÅ¼ej nie zostanie zapisane',0),(311658,8658,'bg','Ð ÐµÐ´Ð°ÐºÑ†Ð¸Ð¸ ÐºÑŠÐ¼ Ð¿Ð¾Ð»ÐµÑ‚Ð°Ñ‚Ð° Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ Ð½ÑÐ¼Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð—ÐÐŸÐ˜Ð¡ÐÐÐ˜',0),(311659,8658,'ur','Ù†ÛŒÚ†Û’ Ù‚Ø·Ø¹Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ø¨Ù†Ø§ÛŒØ§ ØªØ¯ÙˆÛŒÙ† Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº ÛÙˆÚº Ú¯Û’',0),(311660,8658,'sr','Ð˜Ð·Ð¼ÐµÐ½Ðµ Ð½Ð°Ð¿Ñ€Ð°Ð²Ñ™ÐµÐ½Ðµ Ð´Ð° Ð¿Ð¾Ñ™Ð° Ð¸ÑÐ¿Ð¾Ð´ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¡ÐÐ§Ð£Ð’ÐÐÐ˜',0),(311661,8658,'vi','Chá»‰nh Sá»­a Cho CÃ¡c TrÆ°á»ng DÆ°á»›i ÄÃ¢y Sáº¼ KHÃ”NG SAO LÆ¯U',0),(311662,8658,'af','Veranderinge Gemaak aan die Velde Hieronder SAL NIE GESTOOR WORD NIE',0),(311663,8658,'ro','EditÄƒrile efectuate Ã®n cÃ¢mpurile de mai jos nu vor fi salvate',0),(311664,8658,'et','Allolevatel vÃ¤ljadel tehtud muudatusi EI SALVESTATA',0),(311665,8658,'si','Spremembe polja spodaj ni bilo mogoÄe SHRANITI',0),(311666,8658,'ba','Suntingan yang dibuat untuk bidang di bawah ini tidak akan disimpan',0),(311667,8658,'nl','Bewerkingen van onderstaande velden worden niet opgeslagen',0),(311668,8658,'fi','Kenttiin tehdyt muutokset eivÃ¤t TALLENNU',0),(311669,8658,'no','Redigeringer i feltene nedenfor vil ikke bli lagret',0),(311670,8658,'da','Ã†ndringer foretaget til felterne nedenfor vil ikke blive gemt',0),(311671,8658,'ko','í•„ë“œ ì•„ëž˜ì˜ ëŒ€ í•œ íŽ¸ì§‘ ë‚´ìš©ì€ ì €ìž¥ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(311672,8658,'he','×”×¢×¨×™×›×•×ª ×©×‘×•×¦×¢×• ×”×©×“×•×ª ×©×œ×”×œ×Ÿ ×œ× ×™×™×©×ž×¨×•',0),(311673,8658,'el','Î”Î·Î¼Î¿ÏƒÎ¹ÎµÏÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î­Î³Î¹Î½Î±Î½ ÏƒÏ„Î± Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Ï€ÎµÎ´Î¯Î± Î´ÎµÎ½ Î¸Î± Î‘Î ÎŸÎ˜Î—ÎšÎ•Î¥Î¤ÎŸÎŽÎ',0),(311674,8658,'zh','ä»¥ä¸‹å­—æ®µä¸­æ‰€åšçš„ç¼–è¾‘å°†ä¸ä¿å­˜\r\n',0),(311675,8658,'sv','FÃ¤lten nedan Ã¤ndringarna sparas inte',0),(311676,8658,'it','Le modifiche apportate ai campi sottostanti non verranno salvate',0),(311677,8658,'tl','',0),(311678,8658,'th','&#3607;&#3635;&#3585;&#3634;&#3619;&#3649;&#3585;&#3657;&#3652;&#3586;&#3649;&#3621;&#3657;&#3623; &#3594;&#3656;&#3629;&#3591;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;&#3609;&#3637;&#3657;&#3592;&#3632;&#3652;&#3617;&#3656;&#3606;&#3641;&#',0),(311679,8658,'hi','à¤¨à¥€à¤šà¥‡ à¤¦à¥€ à¤—à¤ˆ à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤ à¤—à¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤¸à¤¹à¥‡à¤œà¥‡ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾à¤à¤à¤—à¥‡',0),(311680,8658,'ms','Suntingan dibuat kepada bidang-bidang yang berikut tidak boleh disimpan',0),(311681,8658,'ar','Ù„Ù† ÙŠØªÙ… Ø­ÙØ¸ Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„ØªØ­Ø±ÙŠØ± Ø§Ù„ØªÙŠ Ù‚Ø¯Ù…Øª Ø¥Ù„Ù‰ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø£Ø¯Ù†Ø§Ù‡',0),(311682,8658,'fr','Les modifications apportÃ©es aux champs ci-dessous ne seront pas enregistrÃ©es',0),(311683,8658,'jp','ä¸‹ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã«è¡Œã‚ã‚ŒãŸç·¨é›†å†…å®¹ã¯ä¿å­˜ã•ã‚Œã¾ã›ã‚“ã€‚',0),(311684,8658,'pt','As ediÃ§Ãµes feitas aos campos abaixo nÃ£o serÃ£o salvos',0),(311685,8658,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¡Ð´ÐµÐ»Ð°Ð½Ð½Ñ‹Ðµ Ð² ÐŸÐ¾Ð»Ñ ÐÐ¸Ð¶Ðµ ÐÐ• Ð‘Ð£Ð”Ð£Ð¢ Ð¡ÐžÐ¥Ð ÐÐÐ•ÐÐ«',0),(311686,8658,'es','Ediciones Hechos a Campos Abajo NO SERAN GUARDADAS',0),(311687,8658,'de','Bearbeitungen zu untenstehenden Felder werden nicht gespeichert',0),(311688,8658,'en','Edits Made to Fields Below WILL NOT BE SAVED',0),(311689,8659,'is','',0),(311690,8659,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ø±Ø§ ÙÙ‚Ø·  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø«Ø¨Øª Ø§Ù†Ø¬Ø§Ù… Ø¨Ø¯Ù‡ÙŠØ¯       ',0),(311691,8659,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ø±Ø§ ÙÙ‚Ø·  Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø«Ø¨Øª Ø§Ù†Ø¬Ø§Ù… Ø¨Ø¯Ù‡ÙŠØ¯       ',0),(311692,8659,'tr','YalnÄ±zca bu kayÄ±t iÃ§in deÄŸiÅŸiklik yapmak',0),(311693,8659,'pl','Zmiany do tego rekordu tylko',0),(311694,8659,'bg','Ð”Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Ñ‚Ð¾Ð·Ð¸ Ð·Ð°Ð¿Ð¸Ñ',0),(311695,8659,'ur','ÛŒÛ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø±Ù†Û’ Ù…ÛŒÚº ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(311696,8659,'sr','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Ð¾Ð²Ð°Ñ˜ Ð·Ð°Ð¿Ð¸Ñ',0),(311697,8659,'vi','Chá»‰ thay Ä‘á»•i há»“ sÆ¡ nÃ y',0),(311698,8659,'af','Maak veranderinge aan hierdie rekord slegs',0),(311699,8659,'ro','ModificÄƒri la aceastÄƒ Ã®nregistrare numai',0),(311700,8659,'et','Muuta ainult selle kirje',0),(311701,8659,'si','Spreminjati ta zapis le',0),(311702,8659,'ba','Membuat perubahan pada Catatan ini hanya',0),(311703,8659,'nl','Wijzigingen in deze Record alleen',0),(311704,8659,'fi','TehdÃ¤ muutoksia vain tÃ¤mÃ¤ tietue',0),(311705,8659,'no','GjÃ¸re endringer i denne oppfÃ¸ringen bare',0),(311706,8659,'da','Foretage Ã¦ndringer i denne Record kun',0),(311707,8659,'ko','ë§Œì´ ë ˆì½”ë“œë¥¼ ë³€ê²½ í•˜',0),(311708,8659,'he','×©×™× ×•×™×™× ×œ×¨×©×•×ž×” ×–×• ×‘×œ×‘×“',0),(311709,8659,'el','ÎšÎ¬Î½ÎµÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚ ÏƒÎµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÎ³Î³ÏÎ±Ï†Î® Î¼ÏŒÎ½Î¿',0),(311710,8659,'zh','ä¿®è®¢æœ¬åªè®°å½•\r\n',0),(311711,8659,'sv','GÃ¶ra Ã¤ndringar i denna post endast',0),(311712,8659,'it','Apportare modifiche a questo Record solo',0),(311713,8659,'tl','',0),(311714,8659,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3609;&#3637;&#3657; &#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(311715,8659,'hi','à¤‡à¤¸ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‡à¤µà¤² à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(311716,8659,'ms','Membuat perubahan kepada rekod ini hanya',0),(311717,8659,'ar','Ø¥Ø¬Ø±Ø§Ø¡ ØªØºÙŠÙŠØ±Ø§Øª Ø¹Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ø³Ø¬Ù„ ÙÙ‚Ø·',0),(311718,8659,'fr','Apporter des modifications Ã  ce dossier uniquement',0),(311719,8659,'jp','ã“ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ã®ã¿ã«å¤‰æ›´ã‚’åŠ ãˆã‚‹',0),(311720,8659,'pt','Fazer alteraÃ§Ãµes a este registro somente',0),(311721,8659,'ru','Ð’Ð½ÐµÑÑ‚Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð² ÑÑ‚Ñƒ Ð·Ð°Ð¿Ð¸ÑÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(311722,8659,'es','Hacer Cambios a Este Record Solamente',0),(311723,8659,'de','Ã„nderungen Sie an diesen Datensatz nur',0),(311724,8659,'en','Make Changes to This Record Only',0),(311725,8660,'is','',0),(311726,8660,'dr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† ',0),(311727,8660,'pr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† ',0),(311728,8660,'tr','BirleÅŸtirme',0),(311729,8660,'pl','Korespondencji seryjnej',0),(311730,8660,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ',0),(311731,8660,'ur','Ø¶Ù… Ú©Ø±ÛŒÚº',0),(311732,8660,'sr','ÐžÐ±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐµ Ð¿Ð¾ÑˆÑ‚Ðµ',0),(311733,8660,'vi','SÃ¡t nháº­p',0),(311734,8660,'af','Saamvoeg',0),(311735,8660,'ro','ÃŽmbinare',0),(311736,8660,'et','Ãœhenda',0),(311737,8660,'si','Spajanje',0),(311738,8660,'ba','Gabung',0),(311739,8660,'nl','Samenvoegen',0),(311740,8660,'fi','YhdistÃ¤',0),(311741,8660,'no','Flette',0),(311742,8660,'da','Flet',0),(311743,8660,'ko','ë³‘í•©',0),(311744,8660,'he','×ž×™×–×•×’',0),(311745,8660,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ·',0),(311746,8660,'zh','åˆå¹¶\r\n',0),(311747,8660,'sv','Sammanfoga',0),(311748,8660,'it','Unire',0),(311749,8660,'tl','',0),(311750,8660,'th','&#3619;&#3623;&#3617;&#3585;&#3633;&#3609;',0),(311751,8660,'hi','à¤®à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(311752,8660,'ms','Gabungan',0),(311753,8660,'ar','Ø¯Ù…Ø¬',0),(311754,8660,'fr','Fusion',0),(311755,8660,'jp','å·®ã—è¾¼ã¿å°åˆ·',0),(311756,8660,'pt','Mesclagem',0),(311757,8660,'ru','ÐžÐ±ÑŠÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒ',0),(311758,8660,'es','Combinar',0),(311759,8660,'de','Merge',0),(311760,8660,'en','Merge',0),(311761,8661,'is','',0),(311762,8661,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ø¯ØºØ§Ù… Ø´Ø¯Ù‡ ',0),(311763,8661,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ø¯ØºØ§Ù… Ø´Ø¯Ù‡ ',0),(311764,8661,'tr','BirleÅŸtirilmiÅŸ mÃ¼ÅŸteri',0),(311765,8661,'pl','Scalone klienta',0),(311766,8661,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÐµÐ½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(311767,8661,'ur','Ø¶Ù… Ú¯Ø§ÛÚ©',0),(311768,8661,'sr','ÐžÐ±Ñ˜ÐµÐ´Ð¸ÑšÐµÐ½Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(311769,8661,'vi','SÃ¡t nháº­p KhÃ¡ch hÃ ng ',0),(311770,8661,'af','Verenigde Klant/KliÃ«nt',0),(311771,8661,'ro','ÃŽmbinate client',0),(311772,8661,'et','Ãœhendatud klient',0),(311773,8661,'si','Spojene kupca',0),(311774,8661,'ba','Nasabah gabungan',0),(311775,8661,'nl','Samengevoegde klant',0),(311776,8661,'fi','Yhdistetty asiakas',0),(311777,8661,'no','Flettede kunde',0),(311778,8661,'da','Flettede kunde',0),(311779,8661,'ko','ë³‘í•© ëœ ê³ ê°',0),(311780,8661,'he','×œ×§×•×—×•×ª ×”×ž×ž×•×–×’',0),(311781,8661,'el','Î£Ï…Î³Ï‡Ï‰Î½ÎµÏ…Î¼Î­Î½Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(311782,8661,'zh','åˆå¹¶åŽçš„å®¢æˆ·\r\n',0),(311783,8661,'sv','Kopplade kund',0),(311784,8661,'it','Cliente unita',0),(311785,8661,'tl','',0),(311786,8661,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3619;&#3623;&#3617;',0),(311787,8661,'hi','à¤®à¤°à¥à¤œ à¤•à¤¿à¤ à¤—à¤ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(311788,8661,'ms','Pelanggan yang bergabung',0),(311789,8661,'ar','Ø¯Ù…Ø¬ Ø²Ø¨ÙˆÙ†',0),(311790,8661,'fr','Client fusionnÃ©',0),(311791,8661,'jp','ãƒžãƒ¼ã‚¸ã•ã‚ŒãŸé¡§å®¢',0),(311792,8661,'pt','Cliente mesclado',0),(311793,8661,'ru','ÐžÐ±ÑŠÐµÐ´Ð¸Ð½ÐµÐ½Ð½Ñ‹Ðµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹',0),(311794,8661,'es','Cliente Combinado',0),(311795,8661,'de','ZusammengefÃ¼hrten Kunden',0),(311796,8661,'en','Merged Customer',0),(311797,8662,'is','',0),(311798,8662,'dr','Ø§Ø¯ØºØ§Ù… Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(311799,8662,'pr','Ø§Ø¯ØºØ§Ù… Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(311800,8662,'tr','BirleÅŸtirme baÅŸarÄ±lÄ± deÄŸildi.',0),(311801,8662,'pl','Korespondencji seryjnej nie zostaÅ‚ zakoÅ„czyÅ‚a siÄ™ pomyÅ›lnie',0),(311802,8662,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð½Ðµ Ðµ Ð±Ð¸Ð» ÑƒÑÐ¿ÐµÑˆÐµÐ½',0),(311803,8662,'ur','Ø¶Ù… Ø³Ú©ÛŒØ³ÙÙˆÙ„Ù„ Ù†ÛÛŒÚº ØªÚ¾Ø§ Û”',0),(311804,8662,'sr','ÐžÐ±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐµ Ð¿Ð¾ÑˆÑ‚Ðµ Ð½Ð¸Ñ˜Ðµ Ð±Ð¸Ð¾ Ð¡ÑƒÑ†Ñ†ÐµÑÑÑ„ÑƒÐ»Ð»',0),(311805,8662,'vi','SÃ¡t nháº­p khÃ´ng thÃ nh cÃ´ng',0),(311806,8662,'af','Saamsmelting Was Nie Suksesvol',0),(311807,8662,'ro','ÃŽmbinare nu a fost succes',0),(311808,8662,'et','Ãœhenda ei olnud vastus',0),(311809,8662,'si','Spajanja ni bil uspeÅ¡en',0),(311810,8662,'ba','Gabung bukanlah sukses',0),(311811,8662,'nl','Samenvoegen Was niet succesvolle',0),(311812,8662,'fi','YhdistÃ¤minen ei ollut Successfull',0),(311813,8662,'no','Flett var ikke vellykket',0),(311814,8662,'da','Flet var ikke held',0),(311815,8662,'ko','ë³‘í•©ì´ ì„±ê³µì ì¸',0),(311816,8662,'he','×ž×™×–×•×’ ×œ× ×”×™×” Successfull',0),(311817,8662,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· Î´ÎµÎ½ Î®Ï„Î±Î½ ÎµÏ€Î¹Ï„Ï…Ï‡Î®Ï‚',0),(311818,8662,'zh','æˆåŠŸå¤±è´¥\r\n',0),(311819,8662,'sv','Koppla var inte framgÃ¥ngsrik',0),(311820,8662,'it','Unione non era CARIERE di successo',0),(311821,8662,'tl','',0),(311822,8662,'th','&#3619;&#3623;&#3617;&#3652;&#3617;&#3656;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(311823,8662,'hi','à¤†à¤ª à¤®à¤°à¥à¤œ à¤¨à¤¹à¥€à¤‚ à¤¥à¤¾',0),(311824,8662,'ms','Gabungan adalah yang tidak berjaya',0),(311825,8662,'ar','Ø§Ù„Ø¯Ù…Ø¬ Ù„Ù… ÙŠÙƒÙ† Ù†Ø§Ø¬Ø­Ø§',0),(311826,8662,'fr','Fusion n\'a pas rÃ©ussi',0),(311827,8662,'jp','ãƒžãƒ¼ã‚¸ãŒæˆåŠŸã—ã¾ã›ã‚“ã€‚',0),(311828,8662,'pt','Mesclagem nÃ£o foi bem sucedido',0),(311829,8662,'ru','ÐžÐ±ÑŠÐµÐ´Ð¸Ð½ÐµÐ½Ð¸Ðµ ÐÐµ Ð‘Ñ‹Ð»Ð¾ Ð£ÑÐ¿ÐµÑˆÐ½Ñ‹Ð¼',0),(311830,8662,'es','Combinar No TenÃ­a Exito',0),(311831,8662,'de','Merge war nicht erfolgreich',0),(311832,8662,'en','Merge Was Not Successfull',0),(311833,8663,'is','',0),(311834,8663,'dr','Ø§Ø¯ØºØ§Ù… Ø§Ø³Ù†Ø§Ø¯ Ø®Ø±ÙŠØ¯Ø§Ø±  Ø¯Ø±  Ø§ÙŠÙ† Ø«Ø¨Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(311835,8663,'pr','Ø§Ø¯ØºØ§Ù… Ø§Ø³Ù†Ø§Ø¯ Ø®Ø±ÙŠØ¯Ø§Ø±  Ø¯Ø±  Ø§ÙŠÙ† Ø«Ø¨Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(311836,8663,'tr','Bu mÃ¼ÅŸteri kayÄ±t mÃ¼ÅŸteri kayÄ±tlarÄ± birleÅŸtirme',0),(311837,8663,'pl','Scalanie rekordÃ³w klientÃ³w do tego rekordu klienta',0),(311838,8663,'bg','Ð¡Ð»Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð² Ñ‚Ð¾Ð·Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(311839,8663,'ur','Ú©Ø³Ù¹Ù…Ø± Ø±ÛŒÚ©Ø§Ø±Úˆ ÛŒÛ Ú¯Ø§ÛÚ© Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ù…ÛŒÚº Ø¶Ù…',0),(311840,8663,'sr','Ð¡Ð¿Ð°Ñ˜Ð°ÑšÐµ Ð·Ð°Ð¿Ð¸ÑÐµ Ð¾ ÐºÑƒÐ¿Ñ†Ð¸Ð¼Ð° Ñƒ Ð¾Ð²Ð°Ñ˜ Ð·Ð°Ð¿Ð¸Ñ ÐºÑƒÐ¿Ñ†Ð°',0),(311841,8663,'vi','SÃ¡t nháº­p Há»“ sÆ¡ KhÃ¡ch hÃ ng vÃ o há»“ sÆ¡ khÃ¡ch hÃ ng nÃ y',0),(311842,8663,'af','Verenig Klante/KliÃ«nte Rekords BINNE Hierdie Klante/KliÃ«nte Rekord',0),(311843,8663,'ro','Fuzionarea client de Ã®nregistrÄƒri Ã®n aceastÄƒ Ã®nregistrare de client',0),(311844,8663,'et','Klientide kirjed Ã¼hendatakse selle kliendi kirje',0),(311845,8663,'si','Spajanje zapisov kupcev v zapis kupca',0),(311846,8663,'ba','Penggabungan catatan pelanggan ke catatan pelanggan ini',0),(311847,8663,'nl','Klantrecords samenvoegen dit Record van de klant',0),(311848,8663,'fi','Asiakastietueiden yhdistÃ¤minen asiakastietueen',0),(311849,8663,'no','SlÃ¥ sammen kundeoppfÃ¸ringer i denne kundepost',0),(311850,8663,'da','Flette kundeposter til denne kundepost',0),(311851,8663,'ko','ì´ ê³ ê° ë ˆì½”ë“œë¥¼ ê³ ê° ë ˆì½”ë“œë¥¼ ë³‘í•©',0),(311852,8663,'he','×ž×™×–×•×’ ×¨×©×•×ž×•×ª ×©×œ ×œ×§×•×—×•×ª ××œ ×¨×©×•×ž×ª ×”×œ×§×•×— ×”×–×”',0),(311853,8663,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· ÎºÎ±ÏÏ„Î­Î»ÎµÏ‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ ÏƒÎµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÎ³Î³ÏÎ±Ï†Î® Ï€ÎµÎ»Î¬Ï„Î·',0),(311854,8663,'zh','å®¢æˆ·è®°å½•åˆå¹¶åˆ°å®¢æˆ·è®°å½•æœ¬\r\n',0),(311855,8663,'sv','SamgÃ¥ende kundposter i denna kundposten',0),(311856,8663,'it','Fusione record clienti in questo Record cliente',0),(311857,8663,'tl','',0),(311858,8663,'th','Merging Customer Records INTO This Customer Record',0),(311859,8663,'hi','à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤®à¥‡à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤• à¤…à¤­à¤¿à¤²à¥‡à¤– à¤®à¤°à¥à¤œ',0),(311860,8663,'ms','Gabungan rekod-rekod pelanggan ke dalam rekod pelanggan ini',0),(311861,8663,'ar','Ø¯Ù…Ø¬ Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ø³Ø¬Ù„ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(311862,8663,'fr','Fusionner les enregistrements clients dans cet enregistrement de client',0),(311863,8663,'jp','ã“ã®é¡§å®¢ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ã«é¡§å®¢ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ãƒžãƒ¼ã‚¸',0),(311864,8663,'pt','Mesclar registros de cliente neste registro de cliente',0),(311865,8663,'ru','Ð¡Ð»Ð¸ÑÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð² ÑÑ‚Ñƒ Ð·Ð°Ð¿Ð¸ÑÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(311866,8663,'es','Combinando Records de Clientes DENTRO de Este Record de Cliente',0),(311867,8663,'de','KundendatensÃ¤tze in diesem Kunden-Datensatz zusammenfÃ¼hren',0),(311868,8663,'en','Merging Customer Records INTO This Customer Record',0),(311869,8664,'is','',0),(311870,8664,'dr','Ø§Ø¯ØºØ§Ù… Ø§Ø² Ø§ÙŠÙ† Ø§Ø³Ù†Ø§Ø¯  Ø®Ø±ÙŠØ¯Ø§Ø±  Ø¯Ø± Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ù„Ø§ ',0),(311871,8664,'pr','Ø§Ø¯ØºØ§Ù… Ø§Ø² Ø§ÙŠÙ† Ø§Ø³Ù†Ø§Ø¯  Ø®Ø±ÙŠØ¯Ø§Ø±  Ø¯Ø± Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ù„Ø§ ',0),(311872,8664,'tr','YukarÄ±da seÃ§ilen mÃ¼ÅŸteri iÃ§ine bu mÃ¼ÅŸteri kayÄ±tlarÄ± birleÅŸtirme',0),(311873,8664,'pl','Scalenie od tych rekordÃ³w klienta klienta wybranego powyÅ¼ej',0),(311874,8664,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð¾Ñ‚ Ñ‚ÐµÐ·Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚, Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ',0),(311875,8664,'ur','Ø¯Ø±Ø¬ Ø¨Ø§Ù„Ø§ Ù…Ù†ØªØ®Ø¨ Ú¯Ø§ÛÚ© Ú©Ùˆ Ø§Ù† Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø³Û’ Ø¶Ù…',0),(311876,8664,'sr','ÐžÐ±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐµ Ð¸Ð· Ð¾Ð²Ðµ Ð·Ð°Ð¿Ð¸ÑÐµ Ð¾ ÐºÑƒÐ¿Ñ†Ð¸Ð¼Ð° Ñƒ ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½ Ð³Ð¾Ñ€Ðµ',0),(311877,8664,'vi','SÃ¡t nháº­p Há»“ sÆ¡ KhÃ¡ch hÃ ng nÃ y vÃ o khÃ¡ch hÃ ng Ä‘Ã£ chá»n á»Ÿ trÃªn',0),(311878,8664,'af','Verenig VANAF Hierdie Klante/KliÃ«nte Rekords BINNE Klante/KliÃ«nte soos Bo Geselekteer',0),(311879,8664,'ro','Fuzionarea din aceste Ã®nregistrÄƒri de client Ã®n client selectat mai sus',0),(311880,8664,'et','Nende klientide kirjed Ã¼hendatakse Ã¼lal valitud kliendi',0),(311881,8664,'si','Spajanje od teh strank zapisov v kupca izbrali zgoraj',0),(311882,8664,'ba','Penggabungan dari catatan pelanggan ini menjadi Pelanggan yang dipilih di atas',0),(311883,8664,'nl','Klant hierboven hebt geselecteerd samenvoegen vanuit deze klantrecords',0),(311884,8664,'fi','YhdistÃ¤Ã¤ nÃ¤mÃ¤ ASIAKASTIETUEISIIN edellÃ¤ valitun asiakkaan',0),(311885,8664,'no','SammenslÃ¥ing kunden POSTENE til kunden som er valgt ovenfor',0),(311886,8664,'da','Fletning fra disse kundeposter til kunde markeret ovenfor',0),(311887,8664,'ko','ìœ„ì—ì„œ ì„ íƒí•œ ê³ ê°ì— ì´ëŸ¬í•œ ê³ ê° ë ˆì½”ë“œ ë³‘í•©',0),(311888,8664,'he','×ž×™×–×•×’ ×ž×¨×©×•×ž×•×ª ××œ×” ×œ×§×•×—×•×ª ××œ ×œ×§×•×—×•×ª ×©× ×‘×—×¨ ×œ×¢×™×œ',0),(311889,8664,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· Î±Ï€ÏŒ Î±Ï…Ï„Î­Ï‚ Ï„Î¹Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Ï€ÎµÎ»Î¬Ï„Î· ÏƒÎµ Ï€ÎµÎ»Î¬Ï„Î· Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î¾Î±Ï„Îµ ÏƒÏ„Î¿ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î¿ Î²Î®Î¼Î±',0),(311890,8664,'zh','åˆå¹¶æ¥è‡ªä¸Šé¢é€‰æ‹©åˆ°å®¢æˆ·è¿™äº›å®¢æˆ·è®°å½•\r\n',0),(311891,8664,'sv','Sammanfoga frÃ¥n dessa kundposter till kunden valt ovan',0),(311892,8664,'it','Fusione da questi record di cliente in cliente selezionato sopra',0),(311893,8664,'tl','',0),(311894,8664,'th','Merging FROM These Customer Records Into Customer Selected Above',0),(311895,8664,'hi','à¤‡à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤¸à¥‡ à¤•à¥‡ à¤Šà¤ªà¤° à¤šà¤¯à¤¨à¤¿à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¥‡à¤‚ à¤µà¤¿à¤²à¤¯',0),(311896,8664,'ms','Gabungan dari rekod-rekod pelanggan kepada pelanggan yang dipilih di atas',0),(311897,8664,'ar','Ø¯Ù…Ø¬ Ù…Ù† Ù‡Ø°Ù‡ Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ù…Ø­Ø¯Ø¯ Ø£Ø¹Ù„Ø§Ù‡',0),(311898,8664,'fr','Fusion de ces enregistrements de client en client sÃ©lectionnÃ© ci-dessus',0),(311899,8664,'jp','ä¸Šã§é¸æŠžã—ãŸé¡§å®¢ã«ã“ã‚Œã‚‰ã®é¡§å®¢ãƒ¬ã‚³ãƒ¼ãƒ‰ã‹ã‚‰ãƒžãƒ¼ã‚¸',0),(311900,8664,'pt','Mesclar esses registros de cliente em cliente selecionado acima',0),(311901,8664,'ru','Ð¡Ð»Ð¸ÑÐ½Ð¸Ðµ Ð¸Ð· ÑÑ‚Ð¸Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°, Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð²Ñ‹ÑˆÐµ',0),(311902,8664,'es','Combinando DESDE Estos Records de Clientes DENTRO de  Cliente Arriba Seleccionado',0),(311903,8664,'de','ZusammenfÃ¼hren von diesen KundendatensÃ¤tze in oben ausgewÃ¤hlten Kunden',0),(311904,8664,'en','Merging FROM These Customer Records Into Customer Selected Above',0),(311905,8665,'is','',0),(311906,8665,'dr','_Ø­Ù…Ù„ Ø¨Ù‡ ',0),(311907,8665,'pr','Ú†Ø´Ù… Ù¾ÙˆØ´ÙŠ Ø§Ø² Ø§Ø¯ØºØ§Ù… Ø®Ø±ÙŠØ¯Ø§Ø± Ùˆ Ø±ÙØªÙ† Ø¨Ù‡ Ø§Ø¯ØºØ§Ù… _Ø­Ù…Ù„ Ø¨Ù‡ ',0),(311908,8665,'tr','Skip mÃ¼ÅŸteri birleÅŸtirmek ve birleÅŸtirmek iÃ§in gemiye gitmek',0),(311909,8665,'pl','PomiÅ„ klienta korespondencji seryjnej i przejdÅº do statku do korespondencji seryjnej',0),(311910,8665,'bg','ÐŸÑ€Ð¾Ð¿ÑƒÑÐ½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¾Ð±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð¸ Ð´Ð° Ð¿Ñ€ÐµÐ¼Ð¸Ð½ÐµÑ‚Ðµ ÐºÑŠÐ¼ ÐºÐ¾Ñ€Ð°Ð±Ð° Ð·Ð° Ð¾Ð±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ',0),(311911,8665,'ur','Ø§Ú†Ù¹ÛŒÚº Ú©Ø³Ù¹Ù…Ø± Ø¶Ù… Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø¬ÛØ§Ø² Ú©Ùˆ Ø¶Ù… Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¬Ø§Ù†Ø§',0),(311912,8665,'sr','ÐŸÑ€ÐµÑÐºÐ¾Ñ‡Ð¸ ÐºÑƒÐ¿Ñ†Ð° Ð¾Ð±Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ‚Ð¸ Ð¸ Ð¸Ð´Ð¸ Ð½Ð° Ð±Ñ€Ð¾Ð´ Ð·Ð° Ð¾Ð±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐµ',0),(311913,8665,'vi','Bá» qua nháº­p khÃ¡ch hÃ ng & Ä‘áº¿n nháº­p chuyá»ƒn Ä‘áº¿n',0),(311914,8665,'af','Slaan kliÃ«nt saamvoeg en gaan na die skip saamvoeg',0),(311915,8665,'ro','Skip client Ã®mbinare ÅŸi du-te la nava sÄƒ fuzioneze',0),(311916,8665,'et','Skip kliendi Ã¼hendada ja minna laeva Ã¼hendamine',0),(311917,8665,'si','PreskoÄi kupca spoji in pojdite na ladjo za spajanje',0),(311918,8665,'ba','Skip pelanggan menggabungkan dan pergi ke kapal untuk menggabungkan',0),(311919,8665,'nl','Skip klant samenvoegen en ga naar schip samen te voegen',0),(311920,8665,'fi','Ohita YhdistÃ¤ ja siirry aluksen yhdistÃ¤Ã¤',0),(311921,8665,'no','Hopp over kunden flette og gÃ¥ til skipet flette',0),(311922,8665,'da','Spring kunde flette og gÃ¥ til skibet for at flette',0),(311923,8665,'ko','ê±´ë„ˆë›°ê¸° ê³ ê° ë³‘í•© í•˜ ê³  ë³‘í•© í•˜ëŠ” ìš°ì£¼ì„ ì—ê°€ ì„œ',0),(311924,8665,'he','×“×œ×’ ×¢×œ ×”×œ×§×•×— ×œ×ž×–×’ ×•×œ×œ×›×ª ×”×¡×¤×™× ×” ×œ×ž×™×–×•×’',0),(311925,8665,'el','Î Î±ÏÎ¬Î»ÎµÎ¹ÏˆÎ· Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· ÏƒÏ…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· ÎºÎ±Î¹ Ï€Î·Î³Î±Î¯Î½ÎµÏ„Îµ ÏƒÏ„Î¿ Ï€Î»Î¿Î¯Î¿ Î½Î± ÏƒÏ…Î³Ï‡Ï‰Î½ÎµÏÏƒÎµÏ„Îµ',0),(311926,8665,'zh','è·³è¿‡å®¢æˆ·çš„åˆå¹¶å‰å¾€èˆ¹èˆ¶è¦åˆå¹¶\r\n',0),(311927,8665,'sv','SKIP kund sammanfoga och gÃ¥ till fartyget att gÃ¥ samman',0),(311928,8665,'it','Skip cliente unire e andare alla nave per unire',0),(311929,8665,'tl','',0),(311930,8665,'th','&#3586;&#3657;&#3634;&#3617;&#3585;&#3634;&#3619;&#3619;&#3623;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3649;&#3621;&#3632;&#3652;&#3611;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3',0),(311931,8665,'hi','à¤›à¥‹à¤¡à¤¼à¥‡à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤®à¤°à¥à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤“',0),(311932,8665,'ms','Baca Langkau bergabung dan pergi ke kapal untuk bergabung',0),(311933,8665,'ar','ØªØ®Ø·ÙŠ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¯Ù…Ø¬ ÙˆØ§Ù„Ø°Ù‡Ø§Ø¨ Ø¥Ù„Ù‰ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¯Ù…Ø¬',0),(311934,8665,'fr','Skip client fusionner et aller au navire de fusionner',0),(311935,8665,'jp','ã‚¹ã‚­ãƒƒãƒ—é¡§å®¢ã‚’ãƒžãƒ¼ã‚¸ã—ã€ãƒžãƒ¼ã‚¸ã™ã‚‹èˆ¹ã«è¡Œã',0),(311936,8665,'pt','Skip cliente mesclar e ir Ã  nave para mesclar',0),(311937,8665,'ru','ÐŸÑ€Ð¾Ð¿ÑƒÑÑ‚Ð¸Ñ‚ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² ÑÐ»Ð¸ÑÐ½Ð¸Ñ Ð¸ Ð¿ÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ ÑÐ»Ð¸ÑÐ½Ð¸Ñ',0),(311938,8665,'es','Saltar FusiÃ³n de Clientes y Ir A FusiÃ³n de Enviar-A',0),(311939,8665,'de','Skip Kunden zusammenfÃ¼hren und ins Schiff zusammenfÃ¼hren',0),(311940,8665,'en','Skip Customer Merge and Go To Ship To Merge',0),(311941,8666,'is','',0),(311942,8666,'dr','-Ùˆ ØºÙŠØ±Ù‡ . Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø§Ø³Ù†Ø§Ø¯ _ Ø­Ù…Ù„ Ø¨Ù‡ _ Ø¨Ø¹Ø¯ Ø§Ø² Ø§Ø¯ØºØ§Ù… Ø¨Ø§ Ø«Ø¨Øª _Ø­Ù…Ù„ Ø¨Ù‡ _ Ø¨Ø§Ù„Ø§  Ù…Ø±ØªØ¨Ø· Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(311943,8666,'pr','Ù‡Ù…Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª â€“ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§-Ùˆ ØºÙŠØ±Ù‡ . Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø§Ø³Ù†Ø§Ø¯ _ Ø­Ù…Ù„ Ø¨Ù‡ _ Ø¨Ø¹Ø¯ Ø§Ø² Ø§Ø¯ØºØ§Ù… Ø¨Ø§ Ø«Ø¨Øª _Ø­Ù…Ù„ Ø¨Ù‡ _ Ø¨Ø§Ù„Ø§  Ù…Ø±ØªØ¨Ø· Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(311944,8666,'tr','TÃ¼m sipariÅŸler, faturalar, Etc. Bu gemi kayÄ±tlarÄ± iÃ§in birleÅŸtirme sonra kaydetmek iÃ§in yukarÄ±daki gemi ile iliÅŸkili olacaktÄ±r',0),(311945,8666,'pl','Wszystkie zamÃ³wienia, faktur, itp. Dla tych statkÃ³w do rekordÃ³w zostanÄ… skojarzone z powyÅ¼szych statku do rekordu po korespondencji seryjnej',0),(311946,8666,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¸ Ð´Ñ€. Ð—Ð° Ñ‚ÐµÐ·Ð¸ ÐºÐ¾Ñ€Ð°Ð± ÐºÑŠÐ¼ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ñ‰Ðµ Ð±ÑŠÐ´Ð°Ñ‚ ÑÐ²ÑŠÑ€Ð·Ð°Ð½Ð¸ Ñ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ ÐºÐ¾Ñ€Ð°Ð± Ð·Ð° Ð·Ð°Ð¿Ð¸Ñ ÑÐ»ÐµÐ´ Ð¾Ð±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ',0),(311947,8666,'ur','ØªÙ…Ø§Ù… Ø§Ø­Ú©Ø§Ù…Ø§ØªØŒ ÙˆØºÛŒØ±Û Û” ÛŒÛ Ø¬ÛØ§Ø² Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¶Ù… Ú©Û’ Ø¨Ø¹Ø¯ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Û’ Ù„ÛŒÛ’ Ø§ÙˆÙ¾Ø± Ø¬ÛØ§Ø² Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ù†Ø³Ù„Ú© ÛÙˆ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(311948,8666,'sr','Ð¡Ð²Ð¸Ð¼ Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð°, Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð° Ð¸Ñ‚Ð´. Ð—Ð° Ð¾Ð²Ðµ Ð±Ñ€Ð¾Ð´ ÑÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸Ð¼Ð° Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸Ð´Ñ€ÑƒÐ¶ÐµÐ½ Ð¸Ð·Ð½Ð°Ð´ Ð±Ñ€Ð¾Ð´Ð° Ñƒ Ð·Ð°Ð¿Ð¸Ñ Ð½Ð°ÐºÐ¾Ð½ Ð¾Ð±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐ°',0),(311949,8666,'vi','Táº¥t Cáº£ ÄÆ¡n Äáº·t HÃ ng, HÃ³a ÄÆ¡n, vv Cho Láº§n Ghi ChÃ©p NÃ y Sáº½ KÃ¨m Theo Ghi ChÃ©p TrÃªn Sau Khi Há»£p Nháº¥t',0),(311950,8666,'af','Alle Bestellings, Fakture, ens. vir hierdie Versend Aan Rekords sal geassosieer word met die bogenoemde VERSEND AAN na afloop van die Vereniging',0),(311951,8666,'ro','Toate comenzile, facturile, Etc. Pentru aceste nave la Ã®nregistrÄƒrile vor fi asociate cu nava de mai sus pentru a Ã®nregistra dupÄƒ Ã®mbinare',0),(311952,8666,'et','KÃµik nende tarneaadresside jaoks salvestunud tellimused, arved jne seostatakse Ã¼laloleva tarneaadressi andmetega peale Ã¼hendamist',0),(311953,8666,'si','Vse naloge, raÄune, itd. Za te ladje zapisov bo povezan z zgoraj ladje z zapisom po spajanje',0),(311954,8666,'ba','Semua pesanan, faktur, dll. Kapal ini untuk data akan dikaitkan dengan kapal di atas untuk merekam setelah penggabungan',0),(311955,8666,'nl','Alle bestellingen, facturen, enz. Voor deze schip aan Records geassocieerd met het bovenstaande schip naar Record na samenvoegen worden zal',0),(311956,8666,'fi','Kaikki tilaukset, laskut, jne. NÃ¤iden alusten tietueet liitetÃ¤Ã¤n edellÃ¤ alus tietueeseen kun yhdistÃ¤minen',0),(311957,8666,'no','Alle bestillinger, fakturaer, Etc. For disse skipet poster vil bli forbundet med over skipet til oppfÃ¸ring etter flettingen',0),(311958,8666,'da','Alle ordrer, fakturaer, Etc. For disse skib til poster vil vÃ¦re forbundet med ovennÃ¦vnte skibet til post efter Flet',0),(311959,8666,'ko','ëª¨ë“  ì£¼ë¬¸, ì†¡ìž¥, ë“±ë“±ìž…ë‹ˆë‹¤. ì´ëŸ¬í•œ ë°° ë ˆì½”ë“œë¥¼ ë³‘í•© í›„ ë ˆì½”ë“œ ìœ„ì˜ ë°°ì™€ ì—°ê²° ë  ê²ƒìž…ë‹ˆë‹¤',0),(311960,8666,'he','×›×œ ×”×–×ž× ×•×ª, ×—×©×‘×•× ×™×•×ª, ×•×›×• \'. ××œ×” ×”×¡×¤×™× ×” ×œ×¨×©×•×ž×•×ª ×™×©×•×™×›×• ×”×¡×¤×™× ×” ×œ×¢×™×œ ×œ×¨×©×•×ž×” ×œ××—×¨ ×ž×™×–×•×’',0),(311961,8666,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚, Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±, Ï„Î± ÎºÎ»Ï€. Î“Î¹Î± Î±Ï…Ï„Î¬ Ï„Î± Ï€Î»Î¿Î¯Î¿ Î³Î¹Î± ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î¸Î± ÏƒÏ…ÏƒÏ‡ÎµÏ„Î¹ÏƒÏ„ÎµÎ¯ Î¼Îµ Ï„Î¿ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ Ï€Î»Î¿Î¯Î¿ ÎµÎ³Î³ÏÎ±Ï†Î® Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ ÏƒÏ…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ·',0),(311962,8666,'zh','æ‰€æœ‰è®¢å•ï¼Œå‘ç¥¨ç­‰ã€‚è¿™äº›äº¤è´§åœ°ç›®å½•å‡ºçŽ°åŽå°†ä¸Žä»¥ä¸Šäº¤è´§åœ°åˆå¹¶',0),(311963,8666,'sv','Alla order, fakturor, Etc. FÃ¶r dessa fartyg till poster kommer att associeras med ovanstÃ¥ende fartyget till post efter koppling',0),(311964,8666,'it','Tutti gli ordini, fatture, ecc. Per queste nave ai record verrÃ  associata la nave sopra al Record dopo fusione',0),(311965,8666,'tl','',0),(311966,8666,'th','All Orders, Invoices, Etc. For These Ship To Records Will Be Associated With the Above Ship To Record After Merge',0),(311967,8666,'hi','à¤¸à¤­à¥€ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚, à¤šà¤¾à¤²à¤¾à¤¨, à¤†à¤¦à¤¿à¥¤ à¤¯à¥‡ à¤œà¤¹à¤¾à¤œ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤œà¤¹à¤¾à¤œ à¤•à¥‡',0),(311968,8666,'ms','Semua pesanan, invois, dll. Bagi kapal ini kepada rekod-rekod akan dikaitkan dengan kapal di atas untuk rekod selepas gabungan',0),(311969,8666,'ar','Ø¬Ù…ÙŠØ¹ Ø£ÙˆØ§Ù…Ø±ØŒ Ø§Ù„ÙÙˆØ§ØªÙŠØ±ØŒ Ø¥Ù„Ø®. Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ø³ÙˆÙ ØªÙƒÙˆÙ† Ù…Ø±ØªØ¨Ø·Ø© Ù…Ø¹ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„Ù…Ø°ÙƒÙˆØ±Ø© Ø£Ø¹Ù„Ø§Ù‡ Ø¥Ù„Ù‰ Ø³Ø¬Ù„ Ø¨Ø¹Ø¯ Ø¯Ù…Ø¬',0),(311970,8666,'fr','Toutes les commandes, factures, etc.. Pour ces navires d\'enregistrements sera associÃ© le navire ci-dessus pour enregistrer aprÃ¨s fusion',0),(311971,8666,'jp','ã™ã¹ã¦ã®æ³¨æ–‡ã€è«‹æ±‚æ›¸ã€ç­‰ã€‚ã“ã‚Œã‚‰èˆ¹ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ã«é–¢é€£ä»˜ã‘ã‚‹ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ä¸Šè¨˜ã®èˆ¹ã‚’ãƒžãƒ¼ã‚¸ã—ãŸå¾Œ',0),(311972,8666,'pt','Todas as encomendas, facturas, Etc. Para estes navios para registros serÃ¡ associado com o navio acima de registro apÃ³s a mesclagem',0),(311973,8666,'ru','Ð’ÑÐµ Ð·Ð°ÐºÐ°Ð·Ñ‹, ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð¸ Ð¢.Ð´. Ð”Ð»Ñ ÑÑ‚Ð¸Ñ… ÑÑƒÐ´Ð¾Ð² Ðº Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð±ÑƒÐ´ÐµÑ‚ ÑÐ²ÑÐ·Ð°Ð½Ð¾ Ñ Ð²Ñ‹ÑˆÐµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð¾ÑÐ»Ðµ ÑÐ»Ð¸ÑÐ½Ð¸Ñ',0),(311974,8666,'es','Todo los Pedidos, Facturas, Etc. Para Estos Records de \"Enviar a\" SerÃ¡n Asociados con el record de \"Enviar a\" DespuÃ©s de Incorporar',0),(311975,8666,'de','Alle Bestellungen, Rechnungen, etc. FÃ¼r diese Schiff auf DatensÃ¤tze nach verschmelzen mit dem oben genannten Schiff Datensatz zugeordnet werden',0),(311976,8666,'en','All Orders, Invoices, Etc. For These Ship To Records Will Be Associated With the Above Ship To Record After Merge',0),(311977,8667,'is','',0),(311978,8667,'dr','Ø§Ø² Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ ',0),(311979,8667,'pr','Ø§Ø² Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ ',0),(311980,8667,'tr','Gemiye',0),(311981,8667,'pl','Od statku',0),(311982,8667,'bg','ÐžÑ‚ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾',0),(311983,8667,'ur','Ú©Ø´ØªÛŒ Ù¾Ø± Ø³Û’',0),(311984,8667,'sr','Ð¡Ð° Ð±Ñ€Ð¾Ð´Ð° Ð½Ð°',0),(311985,8667,'vi','Tá»« Ä‘á»‹a chá»‰ váº­n chuyá»ƒn ',0),(311986,8667,'af','Vanaf Versend na',0),(311987,8667,'ro','De pe navÄƒ sÄƒ',0),(311988,8667,'et','Alates laeva',0),(311989,8667,'si','Iz ladje za',0),(311990,8667,'ba','Dari kapal untuk',0),(311991,8667,'nl','Van schip',0),(311992,8667,'fi','PÃ¤Ã¤ssÃ¤ aluksen',0),(311993,8667,'no','Fra skip',0),(311994,8667,'da','Fra skib til',0),(311995,8667,'ko','ìš°ì£¼ì„ ì—ì„œ',0),(311996,8667,'he','×”×¡×¤×™× ×” ×›×“×™',0),(311997,8667,'el','Î‘Ï€ÏŒ Ï„Î¿ Ï€Î»Î¿Î¯Î¿ Î½Î±',0),(311998,8667,'zh','ä»Žæ”¶è´§åœ°\r\n',0),(311999,8667,'sv','FrÃ¥n skepp till',0),(312000,8667,'it','Dalla nave a',0),(312001,8667,'tl','',0),(312002,8667,'th','&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(312003,8667,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤¸à¥‡',0),(312004,8667,'ms','Dari kapal',0),(312005,8667,'ar','Ù…Ù† Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(312006,8667,'fr','Du navire au',0),(312007,8667,'jp','èˆ¹ã‹ã‚‰',0),(312008,8667,'pt','Do navio Ã ',0),(312009,8667,'ru','ÐžÑ‚ ÐºÐ¾Ñ€Ð°Ð±Ð»Ñ Ð´Ð¾',0),(312010,8667,'es','De Enviar a',0),(312011,8667,'de','Vom Schiff bis zum',0),(312012,8667,'en','From Ship To',0),(312013,8668,'is','',0),(312014,8668,'dr','_ Ø­Ù…Ù„ Ø¨Ù‡ ..._  Ø¯Ø± _ Ø­Ù…Ù„ Ø¨Ù‡ .._ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ù„Ø§ ',0),(312015,8668,'pr','Ø§Ø¯ØºØ§Ù… Ø§Ø² Ø§ÙŠÙ† Ø§Ø³Ù†Ø§Ø¯   _ Ø­Ù…Ù„ Ø¨Ù‡ ..._  Ø¯Ø± _ Ø­Ù…Ù„ Ø¨Ù‡ .._ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ù„Ø§ ',0),(312016,8668,'tr','Bu gemiden kayÄ±tlarÄ± iÃ§in gemiye iÃ§ine yukarÄ±da seÃ§ili birleÅŸtirme ',0),(312017,8668,'pl','Scalenie od tych statkÃ³w do rekordÃ³w w statku do wybranego powyÅ¼ej ',0),(312018,8668,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð¾Ñ‚ Ñ‚ÐµÐ·Ð¸ ÐºÐ¾Ñ€Ð°Ð± ÐºÑŠÐ¼ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² ÐºÐ¾Ñ€Ð°Ð± Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ ',0),(312019,8668,'ur','Ø§Ù† Ú©Û’ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ø³Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ù…ÛŒÚº Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ø¯Ø±Ø¬ Ø¨Ø§Ù„Ø§ Ù…Ù†ØªØ®Ø¨ Ø¶Ù… Ú©Ø± ',0),(312020,8668,'sr','Ð¡Ð¿Ð°Ñ˜Ð°ÑšÐµ ÑÐ° Ð¾Ð²Ð¸Ð¼ Ð±Ñ€Ð¾Ð´Ð° ÑÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸Ð¼Ð° Ñƒ Ð±Ñ€Ð¾Ð´ Ð´Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½ Ð³Ð¾Ñ€Ðµ ',0),(312021,8668,'vi','Nháº­p tá»« há»“ sÆ¡ chuyá»ƒn tá»›i nÃ y vÃ o há»“ sÆ¡ chuyá»ƒn tá»›i Ä‘Ã£ chá»n á»Ÿ trÃªn',0),(312022,8668,'af','Samesmelting van hierdie skip om rekords in skip na bo gekies ',0),(312023,8668,'ro','Fuzionarea la aceste nave la Ã®nregistrÄƒrile Ã®n nava sÄƒ selectatÄƒ deasupra ',0),(312024,8668,'et','Ãœhendatakse need LAEVALT Records laeva Ã¼lal valitud ',0),(312025,8668,'si','Spajanje od te ladje zapise v ladji, izbrali zgoraj ',0),(312026,8668,'ba','Penggabungan dari kapal ini catatan ke kapal untuk dipilih di atas ',0),(312027,8668,'nl','Samenvoegen van deze schip aan Records in een schip hierboven hebt geselecteerd ',0),(312028,8668,'fi','YhdistÃ¤Ã¤ nÃ¤mÃ¤ LAIVASTA tietueisiin alus valittu edellÃ¤ ',0),(312029,8668,'no','Flette fra disse skip poster inn skipet til merket ovenfor ',0),(312030,8668,'da','Fletning fra disse skib til poster i skib til markeret ovenfor ',0),(312031,8668,'ko','ì´ëŸ¬í•œ ìš°ì£¼ì„ ì—ì„œ ë ˆì½”ë“œì— ë³‘í•© ë°°ë¥¼ ìœ„ì—ì„œ ì„ íƒí•œ ',0),(312032,8668,'he','×ž×™×–×•×’ ×ž×¡×¤×™× ×ª ××œ×” ×‘×¨×©×•×ž×•×ª ×œ×ª×•×š ×”×¡×¤×™× ×” ×›×“×™ ×©× ×‘×—×¨ ×œ×¢×™×œ ',0),(312033,8668,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· Î±Ï€ÏŒ Î±Ï…Ï„Î­Ï‚ Ï„Î¿ Ï€Î»Î¿Î¯Î¿ ÏƒÎµ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÏƒÎµ Ï€Î»Î¿Î¯Î¿ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î¾Î±Ï„Îµ ÏƒÏ„Î¿ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î¿ Î²Î®Î¼Î± ',0),(312034,8668,'zh','åˆå¹¶ä»Žè¿™äº›èˆ¹èˆ¶è¿›å…¥èˆ¹èˆ¶çš„è®°å½•ä¸Šé¢æ‰€é€‰\r\n',0),(312035,8668,'sv','Sammanfoga frÃ¥n dessa fartyg till poster till fartyget att valt ovan ',0),(312036,8668,'it','Fusione da queste nave Records in nave a selezionato sopra ',0),(312037,8668,'tl','',0),(312038,8668,'th','Merging FROM These Shipto Records Into Shipto Selected Above ',0),(312039,8668,'hi','à¤¯à¥‡ à¤œà¤¹à¤¾à¤œ à¤¸à¥‡ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤Šà¤ªà¤° à¤šà¤¯à¤¨à¤¿à¤¤ à¤®à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ ',0),(312040,8668,'ms','Gabungan dari kapal ini kepada rekod-rekod ke dalam kapal untuk dipilih di atas ',0),(312041,8668,'ar','Ø¯Ù…Ø¬ Ù…Ù† Ù‡Ø°Ù‡ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù„Ù„Ø³Ø¬Ù„Ø§Øª ÙÙŠ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø­Ø¯Ø¯ Ø£Ø¹Ù„Ø§Ù‡ ',0),(312042,8668,'fr','Fusion de ces navires aux enregistrements en navire Ã  sÃ©lectionnÃ© ci-dessus ',0),(312043,8668,'jp','ã“ã‚Œã‚‰ã®èˆ¹ã‹ã‚‰ãƒ¬ã‚³ãƒ¼ãƒ‰ã«ãƒžãƒ¼ã‚¸èˆ¹ã‚’ä¸Šè¨˜ã®é¸æŠž',0),(312044,8668,'pt','Mesclar essas nave para registros no navio para selecionado acima ',0),(312045,8668,'ru','Ð¡Ð»Ð¸ÑÐ½Ð¸Ðµ Ð¸Ð· ÑÑ‚Ð¸Ñ… ÑÑƒÐ´Ð¾Ð² Ðº Ð·Ð°Ð¿Ð¸ÑÑÐ¼ Ð² ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð²Ñ‹ÑˆÐµ ',0),(312046,8668,'es','Combinando DESDE Estos Records de EnvÃ­o Dentro de Los Arriba Seleccionados',0),(312047,8668,'de','ZusammenfÃ¼hren von diesen Schiff Records zu Schiff nach oben ausgewÃ¤hlten ',0),(312048,8668,'en','Merging FROM These Ship To Records Into Ship To Selected Above ',0),(312049,8669,'is','',0),(312050,8669,'dr','_ Ø­Ù…Ù„ Ø¨Ù‡ ..._  Ø¯Ø± Ø§ÙŠÙ† Ø«Ø¨Øª  _ Ø­Ù…Ù„ Ø¨Ù‡ ..._',0),(312051,8669,'pr','Ø§Ø¯ØºØ§Ù… Ø§Ø³Ù†Ø§Ø¯_ Ø­Ù…Ù„ Ø¨Ù‡ ..._  Ø¯Ø± Ø§ÙŠÙ† Ø«Ø¨Øª  _ Ø­Ù…Ù„ Ø¨Ù‡ ..._',0),(312052,8669,'tr','Bu gemiyi kayda gemi kayÄ±tlarÄ±na birleÅŸtirmekte',0),(312053,8669,'pl','Scalanie statku do rekordÃ³w do tego statku do rekordu',0),(312054,8669,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð± ÐºÑŠÐ¼ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ñ‚Ð¾Ð·Ð¸ ÐºÐ¾Ñ€Ð°Ð± ÐºÑŠÐ¼ Ð·Ð°Ð¿Ð¸Ñ',0),(312055,8669,'ur','Ø§Ø³ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ù¾Ø± Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ùˆ Ø¬ÛØ§Ø² Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ùˆ Ø¶Ù…',0),(312056,8669,'sr','Ð¡Ð¿Ð°Ñ˜Ð°ÑšÐµ Ð±Ñ€Ð¾Ð´ ÑÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸Ð¼Ð° Ñƒ Ð¾Ð²Ð¾Ð¼ Ð±Ñ€Ð¾Ð´Ñƒ ÑÐ° Ð·Ð°Ð¿Ð¸ÑÐ¾Ð¼',0),(312057,8669,'vi','Nháº­p há»“ sÆ¡ chuyá»ƒn tá»›i vÃ o há»“ sÆ¡ chuyá»ƒn tá»›i nÃ y',0),(312058,8669,'af','Samesmelting skip om rekords in hierdie skip om rekord',0),(312059,8669,'ro','Fuzionarea navei la Ã®nregistrÄƒrile Ã®n aceastÄƒ navÄƒ pentru a Ã®nregistra',0),(312060,8669,'et','Laeva andmed Ã¼hendatakse see laev kirjele',0),(312061,8669,'si','ZdruÅ¾itev ladje z zapisi v ta ladja za rekord',0),(312062,8669,'ba','Menggabungkan kapal catatan ke kapal ini untuk merekam',0),(312063,8669,'nl','Schip aan Records samenvoegen dit schip naar Record',0),(312064,8669,'fi','Laiva tietueiden yhdistÃ¤minen tÃ¤mÃ¤n aluksen tietueeseen',0),(312065,8669,'no','Flette skipet poster inn dette skipet til post',0),(312066,8669,'da','Flette skib til poster til dette skib til post',0),(312067,8669,'ko','ê¸°ë¡ì´ ìš°ì£¼ì„ ìœ¼ë¡œ ìš°ì£¼ì„ ì„ ë ˆì½”ë“œ ë³‘í•©',0),(312068,8669,'he','×ž×™×–×•×’ ×”×¡×¤×™× ×” ×œ×¨×©×•×ž×•×ª ×œ×ª×•×š ×”×¡×¤×™× ×” ×œ×¨×©×•×ž×”',0),(312069,8669,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· Ï€Î»Î¿Î¯Î¿ ÏƒÎµ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï€Î»Î¿Î¯Î¿ ÏƒÎµ ÎµÎ³Î³ÏÎ±Ï†Î®',0),(312070,8669,'zh','åˆå¹¶åˆ°æœ¬èˆ¹èˆ¹çš„è®°å½•è¦è®°å½•\r\n',0),(312071,8669,'sv','SamgÃ¥ende fartyget till poster i detta fartyg till post',0),(312072,8669,'it','Fusione nave ai record in questa nave da Record',0),(312073,8669,'tl','',0),(312074,8669,'th','Merging Shipto Records INTO This Shipto Record',0),(312075,8669,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤œà¤¹à¤¾à¤œ à¤®à¥‡à¤‚ à¤œà¤¹à¤¾à¤œ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤•à¥‹ à¤®à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾',0),(312076,8669,'ms','Penggabungan kapal kepada rekod-rekod ke dalam kapal ini untuk rekod',0),(312077,8669,'ar','Ø¯Ù…Ø¬ Ù‡Ø°Ù‡ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø³Ø¬Ù„ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù„Ù„Ø³Ø¬Ù„Ø§Øª',0),(312078,8669,'fr','Fusion de navire aux dossiers dans ce navire Ã  enregistrement',0),(312079,8669,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ã“ã®èˆ¹ã«ãƒ¬ã‚³ãƒ¼ãƒ‰ã«èˆ¹ã‚’ãƒžãƒ¼ã‚¸',0),(312080,8669,'pt','Mesclando o navio para registros nesta nave para registro',0),(312081,8669,'ru','Ð¡Ð»Ð¸ÑÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² ÑÑ‚Ð¾Ñ‚ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ðº Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(312082,8669,'es','Combinando Records de Enviar-a DENTRO de Este Recod de Enviar-a',0),(312083,8669,'de','Schiff auf DatensÃ¤tze in dieses Schiff zu Datensatz zusammenfÃ¼hren',0),(312084,8669,'en','Merging Ship To Records INTO This Ship To Record',0),(312085,8670,'is','',0),(312086,8670,'dr','Ø´Ø±Ø­ Ù‡Ø± Ù‚Ø³Ù…Øª ',0),(312087,8670,'pr','Ø´Ø±Ø­ Ù‡Ø± Ù‚Ø³Ù…Øª ',0),(312088,8670,'tr','AÃ§Ä±klama herhangi bir bÃ¶lÃ¼mÃ¼',0),(312089,8670,'pl','Opis dowolnej czÄ™Å›ci',0),(312090,8670,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð²ÑÑÐºÐ° Ñ‡Ð°ÑÑ‚',0),(312091,8670,'ur','Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª Ú©Ø³ÛŒ Ø­ØµÛ’',0),(312092,8670,'sr','ÐžÐ¿Ð¸Ñ Ð±Ð¸Ð»Ð¾ ÐºÐ¾Ñ˜Ð¸ Ð´ÐµÐ¾',0),(312093,8670,'vi','Diá»…n giáº£i báº¥t cá»© pháº§n nÃ o',0),(312094,8670,'af','Enige Gedeelte van Beskrywing',0),(312095,8670,'ro','Descriere orice parte',0),(312096,8670,'et','Kirjeldus iga osa',0),(312097,8670,'si','Opis vseh del',0),(312098,8670,'ba','Deskripsi setiap bagian',0),(312099,8670,'nl','Beschrijving een deel',0),(312100,8670,'fi','Kuvaus tahansa',0),(312101,8670,'no','Beskrivelse deler',0),(312102,8670,'da','Beskrivelse nogen del',0),(312103,8670,'ko','ì„¤ëª… ì¼ë¶€',0),(312104,8670,'he','×ª×™××•×¨ ×›×œ ×—×œ×§',0),(312105,8670,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î¿Ï€Î¿Î¹Î¿Î´Î®Ï€Î¿Ï„Îµ Î¼Î­ÏÎ¿Ï‚',0),(312106,8670,'zh','è¯´æ˜Žä»»ä½•éƒ¨åˆ†\r\n',0),(312107,8670,'sv','Beskrivning nÃ¥gon del',0),(312108,8670,'it','Descrizione qualsiasi parte',0),(312109,8670,'tl','',0),(312110,8670,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;',0),(312111,8670,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤­à¤¾à¤—',0),(312112,8670,'ms','Keterangan mana-mana bahagian',0),(312113,8670,'ar','ÙˆØµÙ Ø£ÙŠ Ø¬Ø²Ø¡',0),(312114,8670,'fr','Description toute partie',0),(312115,8670,'jp','èª¬æ˜Žä»»æ„ã®éƒ¨åˆ†',0),(312116,8670,'pt','DescriÃ§Ã£o qualquer parte',0),(312117,8670,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð›ÑŽÐ±Ð¾Ð¹ Ð§Ð°ÑÑ‚Ð¸',0),(312118,8670,'es','DescripciÃ³n Cualquier Parte',0),(312119,8670,'de','Beschreibung jeder Teil',0),(312120,8670,'en','Description Any Part',0),(312121,8671,'is','',0),(312122,8671,'dr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù‡Ø± Ù‚Ø³Ù…Øª',0),(312123,8671,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ù‡Ø± Ù‚Ø³Ù…Øª',0),(312124,8671,'tr','Herhangi bir yerine fiÅŸ',0),(312125,8671,'pl','Kupon jakiejkolwiek czÄ™Å›ci',0),(312126,8671,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð²ÑÑÐºÐ° Ñ‡Ð°ÑÑ‚',0),(312127,8671,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ú¾ÛŒ Ø­ØµÛ ÙˆÙˆÙˆÚ†Ø§Ø±',0),(312128,8671,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð±Ð¸Ð»Ð¾ ÐºÐ¾Ñ˜Ð¸ Ð´ÐµÐ¾',0),(312129,8671,'vi','Báº¥t ká»³ pháº§n nÃ o cá»§a phiáº¿u',0),(312130,8671,'af','Enige Gedeelte van Bewysstuk',0),(312131,8671,'ro','Voucher orice parte',0),(312132,8671,'et','Voucher Any Part',0),(312133,8671,'si','Voucher katerikoli del',0),(312134,8671,'ba','Voucher bagian',0),(312135,8671,'nl','Bon een deel',0),(312136,8671,'fi','Tositteen tahansa',0),(312137,8671,'no','Bilag deler',0),(312138,8671,'da','Voucher nogen del',0),(312139,8671,'ko','ì´ìš©ê¶Œì€ ì–´ë–¤ ë¶€ë¶„',0),(312140,8671,'he','×©×•×‘×¨ ×›×œ ×—×œ×§',0),(312141,8671,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Î¿Ï€Î¿Î¹Î¿Î´Î®Ï€Î¿Ï„Îµ Î¼Î­ÏÎ¿Ï‚',0),(312142,8671,'zh','å‡­å•çš„ä»»ä½•éƒ¨åˆ†\r\n',0),(312143,8671,'sv','Kupongen nÃ¥gon del',0),(312144,8671,'it','Buono di qualsiasi parte',0),(312145,8671,'tl','',0),(312146,8671,'th','&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;&#3586;&#3629;&#3591;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(312147,8671,'hi','à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤­à¤¾à¤— à¤µà¤¾à¤‰à¤šà¤°',0),(312148,8671,'ms','Baucer mana-mana bahagian',0),(312149,8671,'ar','Ø£ÙŠ Ø¬Ø²Ø¡ Ù…Ù† Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(312150,8671,'fr','N\'importe quelle partie en chÃ¨ques-cadeaux',0),(312151,8671,'jp','ä»»æ„ã®éƒ¨åˆ†ã‚’ä¼ç¥¨ã—ã¾ã™ã€‚',0),(312152,8671,'pt','Comprovante de qualquer parte',0),(312153,8671,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð½Ð° Ð»ÑŽÐ±ÑƒÑŽ Ñ‡Ð°ÑÑ‚ÑŒ',0),(312154,8671,'es','Voucher Cualquier Parte',0),(312155,8671,'de','Gutschein einen Teil',0),(312156,8671,'en','Voucher Any Part',0),(312157,8672,'is','',0),(312158,8672,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª',0),(312159,8672,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø¯Ø± Ù‡Ø± Ø³Ø§Ø¹Øª',0),(312160,8672,'tr','Ortalama saat',0),(312161,8672,'pl','Åšrednia na godzinÄ™',0),(312162,8672,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð¾ Ð½Ð° Ñ‡Ð°Ñ',0),(312163,8672,'ur','Avg. ÙÛŒ Ú¯Ú¾Ù†Ù¹Û',0),(312164,8672,'sr','ÐŸÐ¾Ð»Ð°Ð·Ð¸ÑˆÑ‚Ðµ Ð½Ð° ÑÐ°Ñ‚',0),(312165,8672,'vi','Trung BÃ¬nh Má»—i Giá»',0),(312166,8672,'af','Gemidd. Per Uur',0),(312167,8672,'ro','Medie pe orÄƒ',0),(312168,8672,'et','Keskmine tunnis',0),(312169,8672,'si','AVG. na uro',0),(312170,8672,'ba','Rata-rata Per jam',0),(312171,8672,'nl','Gemiddelde Per uur',0),(312172,8672,'fi','KeskimÃ¤Ã¤rÃ¤inen tunnissa',0),(312173,8672,'no','Gj.snittlig Per time',0),(312174,8672,'da','AVG. pr. time',0),(312175,8672,'ko','ì‹œê°„ë‹¹ í‰ê· ',0),(312176,8672,'he','×ž×ž×•×¦×¢ ×œ×©×¢×”',0),(312177,8672,'el','Îœ.Î¿. Î±Î½Î¬ ÏŽÏÎ±',0),(312178,8672,'zh','å¹³å‡ã€‚æ¯å°æ—¶\r\n',0),(312179,8672,'sv','Per timme i snitt',0),(312180,8672,'it','Media oraria',0),(312181,8672,'tl','',0),(312182,8672,'th','&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(312183,8672,'hi','à¤”à¤¸à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾',0),(312184,8672,'ms','Purata setiap jam',0),(312185,8672,'ar','Ù…ØªÙˆØ³Ø· ÙƒÙ„ Ø³Ø§Ø¹Ø©',0),(312186,8672,'fr','Prix moyen par heure',0),(312187,8672,'jp','1 æ™‚é–“ã‚ãŸã‚Šã®å¹³å‡ã€‚',0),(312188,8672,'pt','MÃ©dia por hora',0),(312189,8672,'ru','Ð¡Ñ€ÐµÐ´Ð½ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð² Ñ‡Ð°Ñ',0),(312190,8672,'es','Prom. por Hora',0),(312191,8672,'de','AVG pro Stunde',0),(312192,8672,'en','Avg. Per Hour',0),(312193,8673,'is','',0),(312194,8673,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø³Ø§Ø¨ ',0),(312195,8673,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø­Ø³Ø§Ø¨ ',0),(312196,8673,'tr','Hesap bilgileri',0),(312197,8673,'pl','Konta',0),(312198,8673,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð°',0),(312199,8673,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(312200,8673,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¾ Ð½Ð°Ð»Ð¾Ð³Ñƒ',0),(312201,8673,'vi','Chi Tiáº¿t TK',0),(312202,8673,'af','Rekening Besonderhede',0),(312203,8673,'ro','Detalii cont',0),(312204,8673,'et','Konto Ã¼ksikasjad',0),(312205,8673,'si','RaÄun podrobnosti',0),(312206,8673,'ba','Rincian Akun',0),(312207,8673,'nl','Accountgegevens',0),(312208,8673,'fi','Tilin tiedot',0),(312209,8673,'no','Kontodetaljer',0),(312210,8673,'da','Kontooplysninger',0),(312211,8673,'ko','ê³„ì • ì„¸ë¶€ ì •ë³´',0),(312212,8673,'he','×¤×¨×˜×™ ×—×©×‘×•×Ÿ',0),(312213,8673,'el','Î¤Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(312214,8673,'zh','å¸æˆ·æ˜Žç»†\r\n',0),(312215,8673,'sv','Kontouppgifter',0),(312216,8673,'it','Dettagli del conto',0),(312217,8673,'tl','',0),(312218,8673,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(312219,8673,'hi','à¤–à¤¾à¤¤à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(312220,8673,'ms','Butir-butir akaun',0),(312221,8673,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(312222,8673,'fr','DÃ©tail du compte',0),(312223,8673,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®è©³ç´°',0),(312224,8673,'pt','Detalhes da conta',0),(312225,8673,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(312226,8673,'es','Detalles de Cuenta',0),(312227,8673,'de','Kontodetails',0),(312228,8673,'en','Account Details',0),(312229,8674,'is','',0),(312230,8674,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ Ø³ÙØ§Ø±Ø´ ',0),(312231,8674,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ Ø³ÙØ§Ø±Ø´ ',0),(312232,8674,'tr','Ek dÃ¼zen seÃ§enekleri',0),(312233,8674,'pl','Opcje dodatkowe zamÃ³wienia',0),(312234,8674,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(312235,8674,'ur','Ø§Ø¶Ø§ÙÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(312236,8674,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(312237,8674,'vi','CÃ¡c Lá»±a Chá»n Äáº·t HÃ ng ThÃªm',0),(312238,8674,'af','Addisionele Bestellingsopsies',0),(312239,8674,'ro','Optiuni comanda suplimentare',0),(312240,8674,'et','TÃ¤iendav tellimus Valikud',0),(312241,8674,'si','NaroÄilo dodatne moÅ¾nosti',0),(312242,8674,'ba','Pilihan Tambahan Pesanan',0),(312243,8674,'nl','Extra bestellen opties',0),(312244,8674,'fi','LisÃ¤Ã¤ vaihtoehtoja',0),(312245,8674,'no','Flere alternativer',0),(312246,8674,'da','Ekstra ordre indstillinger',0),(312247,8674,'ko','ì¶”ê°€ ì£¼ë¬¸ ì˜µì…˜',0),(312248,8674,'he','××¤×©×¨×•×™×•×ª ×”×–×ž× ×” × ×•×¡×¤×•×ª',0),(312249,8674,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏ‰Î¼Î±Ï„Î¹ÎºÎ® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(312250,8674,'zh','å¢žåŠ è¨‚è³¼é¸æ“‡\r\n',0),(312251,8674,'sv','Alternativ ytterligare fÃ¶r',0),(312252,8674,'it','Opzioni addizionali dell\'ordine',0),(312253,8674,'tl','',0),(312254,8674,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(312255,8674,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤†à¤¦à¥‡à¤¶ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(312256,8674,'ms','Opsyen pesanan tambahan',0),(312257,8674,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ© Ù„Ù„Ø·Ù„Ø¨',0),(312258,8674,'fr','Options de Commande Additionelle',0),(312259,8674,'jp','è¿½åŠ æ³¨æ–‡ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(312260,8674,'pt','OpÃ§Ãµes adicionais de ordem',0),(312261,8674,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð—Ð°ÐºÐ°Ð·Ð°',0),(312262,8674,'es','Opciones Adicionales de Pedido',0),(312263,8674,'de','Weitere Bestelloptionen',0),(312264,8674,'en','Additional Order Options',0),(312265,8675,'is','',0),(312266,8675,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ Ø³Ø·Ø±',0),(312267,8675,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠÙƒ Ø³Ø·Ø±',0),(312268,8675,'tr','Ã‡izgi ekleme',0),(312269,8675,'pl','Dodaj liniÄ™',0),(312270,8675,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»Ð¸Ð½Ð¸Ñ',0),(312271,8675,'ur','Ø§ÛŒÚ© Ù„Ø§Ø¦Ù† Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(312272,8675,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð»Ð¸Ð½Ð¸Ñ˜Ðµ',0),(312273,8675,'vi','ThÃªm 1 DÃ²ng',0),(312274,8675,'af','Voeg \'n Lyn by',0),(312275,8675,'ro','Adauga un rand',0),(312276,8675,'et','Lisa rida',0),(312277,8675,'si','Dodati vrstico',0),(312278,8675,'ba','Tambahkan baris',0),(312279,8675,'nl','Een lijn toevoegen',0),(312280,8675,'fi','LisÃ¤Ã¤ rivi',0),(312281,8675,'no','Legge til en linje',0),(312282,8675,'da','TilfÃ¸je en linje',0),(312283,8675,'ko','ì¤„ì„ ì¶”ê°€ í•©ë‹ˆë‹¤',0),(312284,8675,'he','×”×•×¡×£ ×©×•×¨×”',0),(312285,8675,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î³ÏÎ±Î¼Î¼Î®',0),(312286,8675,'zh','å¢žåŠ ä¸€è¡Œ\r\n',0),(312287,8675,'sv','LÃ¤gga till en rad',0),(312288,8675,'it','Aggiungere una riga',0),(312289,8675,'tl','',0),(312290,8675,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;',0),(312291,8675,'hi','à¤•à¥‹à¤ˆ à¤°à¥‡à¤–à¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(312292,8675,'ms','Tambah satu garisan',0),(312293,8675,'ar','Ø¥Ø¶Ø§ÙØ© Ø³Ø·Ø±',0),(312294,8675,'fr','Ajouter une Ligne',0),(312295,8675,'jp','è¡Œã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(312296,8675,'pt','Adicione uma linha',0),(312297,8675,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡Ñ‚Ñ€Ð¾ÐºÑƒ',0),(312298,8675,'es','Agregar una LÃ­nea',0),(312299,8675,'de','FÃ¼gen Sie eine Zeile',0),(312300,8675,'en','Add a Line',0),(312301,8676,'is','',0),(312302,8676,'dr','Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(312303,8676,'pr','Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(312304,8676,'tr','Dikkat',0),(312305,8676,'pl','Uwagi',0),(312306,8676,'bg','Ð’Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ',0),(312307,8676,'ur','ØªÙˆØ¬Û',0),(312308,8676,'sr','ÐŸÐ°Ð¶ÑšÐ°',0),(312309,8676,'vi','ChÃº Ã½',0),(312310,8676,'af','Aandag',0),(312311,8676,'ro','AtenÅ£ia',0),(312312,8676,'et','TÃ¤helepanu',0),(312313,8676,'si','Pozornost',0),(312314,8676,'ba','Perhatian',0),(312315,8676,'nl','Aandacht',0),(312316,8676,'fi','Huomiota',0),(312317,8676,'no','Oppmerksomhet',0),(312318,8676,'da','OpmÃ¦rksomhed',0),(312319,8676,'ko','ì£¼ì˜',0),(312320,8676,'he','×ª×©×•×ž×ª ×œ×‘',0),(312321,8676,'el','Î ÏÎ¿ÏƒÎ¿Ï‡Î®',0),(312322,8676,'zh','æ³¨æ„\r\n',0),(312323,8676,'sv','UppmÃ¤rksamhet',0),(312324,8676,'it','Attenzione',0),(312325,8676,'tl','',0),(312326,8676,'th','&#3586;&#3657;&#3629;&#3588;&#3623;&#3619;&#3588;&#3635;&#3609;&#3638;&#3591;',0),(312327,8676,'hi','à¤§à¥à¤¯à¤¾à¤¨',0),(312328,8676,'ms','Perhatian',0),(312329,8676,'ar','Ø§Ù„Ø§Ù‡ØªÙ…Ø§Ù…',0),(312330,8676,'fr','Attention',0),(312331,8676,'jp','æ³¨æ„',0),(312332,8676,'pt','AtenÃ§Ã£o',0),(312333,8676,'ru','Ð’Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ',0),(312334,8676,'es','AtenciÃ³n',0),(312335,8676,'de','Aufmerksamkeit',0),(312336,8676,'en','Attention',0),(312337,8677,'is','',0),(312338,8677,'dr','Ù…ÙŠØ§Ù†ÙŠ',0),(312339,8677,'pr','Ù…ÙŠØ§Ù†ÙŠ',0),(312340,8677,'tr','Orta',0),(312341,8677,'pl','Bliskim',0),(312342,8677,'bg','Ð¡Ñ€ÐµÐ´Ð°Ñ‚Ð°',0),(312343,8677,'ur','ÙˆØ³Ø·ÛŒÙ°',0),(312344,8677,'sr','Ð¡Ñ€ÐµÐ´ÑšÐµ',0),(312345,8677,'vi','Giá»¯a',0),(312346,8677,'af','Tweede Naam',0),(312347,8677,'ro','Orientul Mijlociu',0),(312348,8677,'et','Teine eesnimi',0),(312349,8677,'si','Srednji',0),(312350,8677,'ba','Tengah',0),(312351,8677,'nl','Midden',0),(312352,8677,'fi','LÃ¤hi',0),(312353,8677,'no','Midten',0),(312354,8677,'da','Midten',0),(312355,8677,'ko','ì¤‘ê°„',0),(312356,8677,'he','××ž×¦×¢×™',0),(312357,8677,'el','ÎœÎ­ÏƒÎ·',0),(312358,8677,'zh','ä¸­é—´\r\n',0),(312359,8677,'sv','Mitten',0),(312360,8677,'it','Medio',0),(312361,8677,'tl','',0),(312362,8677,'th','&#3585;&#3621;&#3634;&#3591;',0),(312363,8677,'hi','à¤®à¤§à¥à¤¯',0),(312364,8677,'ms','Tengah-tengah',0),(312365,8677,'ar','Ø§Ù„Ø£ÙˆØ³Ø·',0),(312366,8677,'fr','Middle',0),(312367,8677,'jp','ä¸­é–“',0),(312368,8677,'pt','MÃ©dio',0),(312369,8677,'ru','Ð¡Ñ€ÐµÐ´Ð½Ð¸Ð¹',0),(312370,8677,'es','Medio',0),(312371,8677,'de','Mitte',0),(312372,8677,'en','Middle',0),(312373,8678,'is','',0),(312374,8678,'dr','Ø³Ø·Ø± Ø¬Ø¯ÙŠØ¯ ÙƒØ§Ù„Ø§ ',0),(312375,8678,'pr','Ø³Ø·Ø± Ø¬Ø¯ÙŠØ¯ ÙƒØ§Ù„Ø§ ',0),(312376,8678,'tr','Yeni satÄ±r Ã¶ÄŸesi',0),(312377,8678,'pl','Nowa pozycja',0),(312378,8678,'bg','ÐÐ¾Ð² ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(312379,8678,'ur','Ù†Ø¦ÛŒ Ù„Ø§Ø¦Ù† Ø´Û’',0),(312380,8678,'sr','ÐÐ¾Ð²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(312381,8678,'vi','DÃ²ng hÃ ng má»›i',0),(312382,8678,'af','Nuwe Lyn Item',0),(312383,8678,'ro','Noul element rÃ¢nd',0),(312384,8678,'et','Uus rida',0),(312385,8678,'si','Novo postavko',0),(312386,8678,'ba','Item baris baru',0),(312387,8678,'nl','Nieuwe regelitem',0),(312388,8678,'fi','Uusi rivinimike',0),(312389,8678,'no','Nye linjeelement',0),(312390,8678,'da','Nye linjepost',0),(312391,8678,'ko','ìƒˆ í–‰ í•­ëª©',0),(312392,8678,'he','×¤×¨×™×˜ ×©×•×¨×” ×—×“×©×”',0),(312393,8678,'el','ÎÎ­Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(312394,8678,'zh','æ–°è¡Œé¡¹ç›®\r\n',0),(312395,8678,'sv','Ny radartikel',0),(312396,8678,'it','Nuovo elemento di linea',0),(312397,8678,'tl','',0),(312398,8678,'th','&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(312399,8678,'hi','à¤¨à¤ˆ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤®',0),(312400,8678,'ms','Baru Line Item',0),(312401,8678,'ar','Ø¹Ù†ØµØ± Ø³Ø·Ø± Ø¬Ø¯ÙŠØ¯',0),(312402,8678,'fr','Nouvelle ligne de facturation',0),(312403,8678,'jp','æ–°è¦ã®è¡Œã‚¢ã‚¤ãƒ†ãƒ ',0),(312404,8678,'pt','Novo Item de linha',0),(312405,8678,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÑÑ‚Ñ€Ð¾ÐºÐ¸',0),(312406,8678,'es','Nuevo Item de Linea',0),(312407,8678,'de','Neue Posten',0),(312408,8678,'en','New Line Item',0),(312409,8679,'is','',0),(312410,8679,'dr','Ø­Ù…Ù„ Ø¬Ø¯ÙŠØ¯ Ø¨Ù‡  ',0),(312411,8679,'pr','Ø­Ù…Ù„ Ø¬Ø¯ÙŠØ¯ Ø¨Ù‡  ',0),(312412,8679,'tr','Yeni gemiye',0),(312413,8679,'pl','Nowy statek',0),(312414,8679,'bg','ÐÐ¾Ð² ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(312415,8679,'ur','Ù†Ø¦Û’ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ø³Û’',0),(312416,8679,'sr','ÐÐ¾Ð²Ð¸ Ð±Ñ€Ð¾Ð´ Ð½Ð°',0),(312417,8679,'vi','Chuyáº¿n hÃ ng má»›i tá»›i',0),(312418,8679,'af','Nuwe Versend Aan',0),(312419,8679,'ro','NavÄƒ nouÄƒ sÄƒ',0),(312420,8679,'et','Uus tarneaadress',0),(312421,8679,'si','Novo ladjo',0),(312422,8679,'ba','Kapal baru untuk',0),(312423,8679,'nl','Nieuwe schip',0),(312424,8679,'fi','Uuden aluksen',0),(312425,8679,'no','Nye skip til',0),(312426,8679,'da','Nyt skib til',0),(312427,8679,'ko','ìƒˆë¡œìš´ ë°°ë¥¼',0),(312428,8679,'he','×¡×¤×™× ×” ×—×“×©×” ×›×“×™',0),(312429,8679,'el','ÎÎ­Î¿ Ï€Î»Î¿Î¯Î¿',0),(312430,8679,'zh','æ–°æ”¶è´§åœ°\r\n',0),(312431,8679,'sv','Nytt fartyg till',0),(312432,8679,'it','Nuova nave per',0),(312433,8679,'tl','',0),(312434,8679,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(312435,8679,'hi','à¤¨à¤¯à¤¾ à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(312436,8679,'ms','Kapal baru',0),(312437,8679,'ar','Ø³ÙÙŠÙ†Ø© Ø¬Ø¯ÙŠØ¯Ø© Ø¥Ù„Ù‰',0),(312438,8679,'fr','Nouveau navire Ã ',0),(312439,8679,'jp','æ–°ã—ã„èˆ¹',0),(312440,8679,'pt','Novo navio para',0),(312441,8679,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ',0),(312442,8679,'es','Nuevo Enviar a',0),(312443,8679,'de','Neues Schiff',0),(312444,8679,'en','New Ship To',0),(312445,8680,'is','',0),(312446,8680,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙØ±Ù…Ø§ÛŒØ´ ',0),(312447,8680,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(312448,8680,'tr','SipariÅŸ Ekle/GÃ¼ncelle',0),(312449,8680,'pl','Aby dodaÄ‡/aktualizacja',0),(312450,8680,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(312451,8680,'ur','Ø­Ú©Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(312452,8680,'sr','Ð ÐµÐ´/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(312453,8680,'vi','ThÃªm/Cáº­p Nháº­t ÄÆ¡n HÃ ng',0),(312454,8680,'af','Bestelling Skep/Opdateer',0),(312455,8680,'ro','Ordinul AdÄƒugaÅ£i/actualizaÅ£i',0),(312456,8680,'et','Tellimuse lisamine/uuendamine',0),(312457,8680,'si','Naloga Dodaj/posodobi',0),(312458,8680,'ba','Urutan Tambahkan/Perbarui',0),(312459,8680,'nl','Bestelling toevoegen/bijwerken',0),(312460,8680,'fi','Tilaa lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(312461,8680,'no','Bestilling/Oppdater',0),(312462,8680,'da','RÃ¦kkefÃ¸lge TilfÃ¸j/opdater',0),(312463,8680,'ko','ì£¼ë¬¸ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(312464,8680,'he','×¡×“×¨ ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(312465,8680,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(312466,8680,'zh','è®¢è´­æ–°å¢ž/æ›´æ–°\r\n',0),(312467,8680,'sv','FÃ¶r LÃ¤gg till/uppdatera',0),(312468,8680,'it','Ordine aggiungere/aggiornare',0),(312469,8680,'tl','',0),(312470,8680,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(312471,8680,'hi','à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(312472,8680,'ms','Perintah Tambah/Kemaskini',0),(312473,8680,'ar','Ø£Ù…Ø± Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(312474,8680,'fr','Ordre ajouter/mettre Ã  jour',0),(312475,8680,'jp','æ³¨æ–‡ã‚’è¿½åŠ /æ›´æ–°',0),(312476,8680,'pt','Adicionar/atualizar a ordem',0),(312477,8680,'ru','Ð—Ð°ÐºÐ°Ð· Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(312478,8680,'es','Orden Agregar/Actualizar',0),(312479,8680,'de','Bestellung hinzufÃ¼gen/aktualisieren',0),(312480,8680,'en','Order Add/Update',0),(312481,8681,'is','',0),(312482,8681,'dr','Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡',0),(312483,8681,'pr','Ø§Ø² Ù…ÙˆØ¹Ø¯ Ú¯Ø°Ø´ØªÙ‡',0),(312484,8681,'tr','Vadesi geÃ§miÅŸ',0),(312485,8681,'pl','ZalegÅ‚ych',0),(312486,8681,'bg','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸',0),(312487,8681,'ur','Ù…ÙˆØ®Ø±',0),(312488,8681,'sr','Ð¡Ð° Ð¿Ñ€ÐµÐºÐ¾Ñ€Ð°Ñ‡ÐµÐ½Ð¸Ð¼ Ñ€Ð¾ÐºÐ¾Ð¼',0),(312489,8681,'vi','QuÃ¡ háº¡n',0),(312490,8681,'af','Agterstallig',0),(312491,8681,'ro','Restante',0),(312492,8681,'et','TÃ¤htaja Ã¼letanud',0),(312493,8681,'si','Zapadle',0),(312494,8681,'ba','Jatuh tempo',0),(312495,8681,'nl','Achterstallige',0),(312496,8681,'fi','MyÃ¶hÃ¤ssÃ¤',0),(312497,8681,'no','Forfalt',0),(312498,8681,'da','Forfaldne',0),(312499,8681,'ko','ì—°ì²´',0),(312500,8681,'he','××™×—×•×¨',0),(312501,8681,'el','Î•ÎºÏ€ÏÏŒÎ¸ÎµÏƒÎ¼ÎµÏ‚',0),(312502,8681,'zh','é€¾æœŸ\r\n',0),(312503,8681,'sv','FÃ¶rfallna',0),(312504,8681,'it','In ritardo',0),(312505,8681,'tl','',0),(312506,8681,'th','&#3648;&#3585;&#3636;&#3609;&#3585;&#3635;&#3627;&#3609;&#3604;&#3594;&#3635;&#3619;&#3632;',0),(312507,8681,'hi','à¤…à¤¤à¤¿à¤¦à¥‡à¤¯',0),(312508,8681,'ms','Lampau tempoh',0),(312509,8681,'ar','ØªØ£Ø®Ø±',0),(312510,8681,'fr','En retard',0),(312511,8681,'jp','æœŸé™åˆ‡ã‚Œ',0),(312512,8681,'pt','Em atraso',0),(312513,8681,'ru','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ',0),(312514,8681,'es','Vencido',0),(312515,8681,'de','ÃœberfÃ¤llig',0),(312516,8681,'en','Overdue',0),(312517,8682,'is','',0),(312518,8682,'dr','Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(312519,8682,'pr','Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(312520,8682,'tr','MÃ¼ÅŸteri iÃ§in arama',0),(312521,8682,'pl','Szukaj dla klienta',0),(312522,8682,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(312523,8682,'ur','Ú¯Ø§ÛÚ© Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(312524,8682,'sr','Ð¢Ñ€Ð°Ð¶ÐµÑšÐµ ÐºÑƒÐ¿Ñ†Ð°',0),(312525,8682,'vi','TÃ¬m kiáº¿m khÃ¡ch hÃ ng',0),(312526,8682,'af','Soek vir KliÃ«nt/Klant',0),(312527,8682,'ro','CÄƒutare pentru client',0),(312528,8682,'et','Otsi klienti',0),(312529,8682,'si','Iskanje za kupca',0),(312530,8682,'ba','Mencari pelanggan',0),(312531,8682,'nl','Zoeken naar klant',0),(312532,8682,'fi','Etsi asiakas',0),(312533,8682,'no','SÃ¸k etter kunde',0),(312534,8682,'da','SÃ¸g efter kunde',0),(312535,8682,'ko','ê³ ê°ì— ëŒ€ í•œ ê²€ìƒ‰',0),(312536,8682,'he','×—×¤×© ×œ×§×•×—',0),(312537,8682,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(312538,8682,'zh','æœç´¢å®¢æˆ·\r\n',0),(312539,8682,'sv','SÃ¶k efter kund',0),(312540,8682,'it','Ricerca per cliente',0),(312541,8682,'tl','',0),(312542,8682,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(312543,8682,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ',0),(312544,8682,'ms','Cari pelanggan',0),(312545,8682,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(312546,8682,'fr','Recherche pour client',0),(312547,8682,'jp','é¡§å®¢ã®æ¤œç´¢',0),(312548,8682,'pt','Pesquisa para o cliente',0),(312549,8682,'ru','ÐŸÐ¾Ð¸ÑÐº ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(312550,8682,'es','Buscar Cliente',0),(312551,8682,'de','Suche fÃ¼r Kunden',0),(312552,8682,'en','Search for Customer',0),(312553,8683,'is','',0),(312554,8683,'dr','(Ú†Ùƒ) Ù†ÙŠØ§Ø² Ø¯Ø§Ø±Ø¯ ',0),(312555,8683,'pr','Ø¨Ø±Ø±Ø³ÙŠ (Ú†Ùƒ) Ù†ÙŠØ§Ø² Ø¯Ø§Ø±Ø¯ ',0),(312556,8683,'tr','Onay iste',0),(312557,8683,'pl','Wyboru wymaga',0),(312558,8683,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¸Ð·Ð¸ÑÐºÐ²Ð°',0),(312559,8683,'ur','Ú†ÛŒÚ© Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÙˆØªÛŒ ÛÛ’',0),(312560,8683,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°Ñ˜ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(312561,8683,'vi','YÃªu cáº§u SÃ©c',0),(312562,8683,'af','Kontroleer vereis',0),(312563,8683,'ro','Selectare necesitÄƒ',0),(312564,8683,'et','Sisse nÃµuda',0),(312565,8683,'si','Pregled zahtevajo',0),(312566,8683,'ba','Memerlukan Check',0),(312567,8683,'nl','Selectievakje vereisen',0),(312568,8683,'fi','Uloskirjautuminen edellyttÃ¤Ã¤',0),(312569,8683,'no','Sjekk krever',0),(312570,8683,'da','Check krÃ¦ver',0),(312571,8683,'ko','í™•ì¸ í•„ìš”',0),(312572,8683,'he','×”×¡×™×ž×•×Ÿ ×“×•×¨×©×•×ª',0),(312573,8683,'el','Î•Î»Î­Î³Ï‡Î¿Ï… Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½',0),(312574,8683,'zh','æ£€æŸ¥è¦æ±‚\r\n',0),(312575,8683,'sv','Kontrollera krÃ¤ver',0),(312576,8683,'it','Controllo richiedono',0),(312577,8683,'tl','',0),(312578,8683,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3648;&#3594;&#3655;&#3588;',0),(312579,8683,'hi','à¤œà¤¾à¤‚à¤š à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(312580,8683,'ms','Semak memerlukan',0),(312581,8683,'ar','ØªØªØ·Ù„Ø¨ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(312582,8683,'fr','Cocher exiger',0),(312583,8683,'jp','ãƒã‚§ãƒƒã‚¯ã‚’å¿…è¦ã¨ã—ã¾ã™ã€‚',0),(312584,8683,'pt','SeleÃ§Ã£o requerem',0),(312585,8683,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ñ‚Ñ€ÐµÐ±ÑƒÑŽÑ‚',0),(312586,8683,'es','Marcar Requerir ',0),(312587,8683,'de','Checks erforderlich',0),(312588,8683,'en','Check Require',0),(312589,8684,'is','',0),(312590,8684,'dr','ÙˆØ±ÙˆØ¯ Ù…Ø¬Ø¯Ø¯ Ø¯Ø± ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù„Ø§Ø²Ù… Ø§Ø³Øª  ',0),(312591,8684,'pr','ÙˆØ±ÙˆØ¯ Ù…Ø¬Ø¯Ø¯ Ø¯Ø± ØµÙØ­Ù‡ Ù†Ù…Ø§ÙŠØ´ ÙƒØ§Ø±Ù…Ù†Ø¯ Ù„Ø§Ø²Ù… Ø§Ø³Øª  ',0),(312592,8684,'tr','Re-giriÅŸ Ã§alÄ±ÅŸan ekran gÃ¶ster Ã¼zerinde gerekir',0),(312593,8684,'pl','WymagajÄ… Re-zgÅ‚oÅ› siÄ™ do systemu na pracownika widok ekranu',0),(312594,8684,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ñ€Ðµ-Login Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» ÐŸÐžÐšÐÐ–Ð˜ ÐµÐºÑ€Ð°Ð½',0),(312595,8684,'ur','Re-Ù„Ø§Ú¯ Ø§Ù† Ù…Ù„Ø§Ø²Ù… Ù…Ù†Ø¸Ø± Ø³Ú©Ø±ÛŒÙ† Ù¾Ø± Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÙˆØªÛŒ ÛÛ’',0),(312596,8684,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°Ñ˜Ñƒ Ð Ðµ-Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð½Ð° ÐµÐºÑ€Ð°Ð½Ñƒ Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(312597,8684,'vi','YÃªu cáº§u Ä‘Äƒng nháº­p láº¡i vá»›i mÃ n hÃ¬nh nhÃ¢n viÃªn',0),(312598,8684,'af','U Nodig om weer by die Werknemer OORSIG Skerm te Heraanmeld',0),(312599,8684,'ro','NecesitÄƒ Re-Login ecran de vedere angajat',0),(312600,8684,'et','NÃµuda Re-Login tÃ¶Ã¶taja VIEW ekraan',0),(312601,8684,'si','Zahtevati drugi ton oktave-prepriÄevalnost na zaposlenega pogled zaslon',0),(312602,8684,'ba','Memerlukan Re-Login pada layar Lihat karyawan',0),(312603,8684,'nl','Re-Login scherm weergave de werknemer vereist',0),(312604,8684,'fi','Vaadi uudelleen kirjautuminen tyÃ¶ntekijÃ¤n NÃ¤ytÃ¤ nÃ¤yttÃ¶',0),(312605,8684,'no','Kreve logge pÃ¥ ansatt Vis skjerm',0),(312606,8684,'da','KrÃ¦ve Re-Login pÃ¥ medarbejder se skÃ¦rmen',0),(312607,8684,'ko','ì§ì› ë³´ê¸° í™”ë©´ì—ì„œ ë‹¤ì‹œ ë¡œê·¸ì¸ í•„ìš”',0),(312608,8684,'he','×“×•×¨×©×™× ×”×ª×—×‘×¨ ×ž×—×“×© ×¢×œ ×”×ž×¡×š ×ª×¦×•×’×” ×”×¢×•×‘×“',0),(312609,8684,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½ ÎµÎº Î½Î­Î¿Ï… ÏƒÏÎ½Î´ÎµÏƒÎ· ÏƒÏ„Î·Î½ Î¿Î¸ÏŒÎ½Î· Î Î¡ÎŸÎ’ÎŸÎ›Î‰ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(312610,8684,'zh','éœ€è¦é‡æ–°ç™»å½•åˆ°å‘˜å·¥æŸ¥çœ‹é¡µé¢\r\n',0),(312611,8684,'sv','KrÃ¤ver Re-logik pÃ¥ anstÃ¤lld Visa skÃ¤rmen',0),(312612,8684,'it','Richiedere il Re-Login su schermo di visualizzazione del dipendente',0),(312613,8684,'tl','',0),(312614,8684,'th','&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3621;&#3655;&#3629;&#3585;&#3629;&#3636;&#3609;&#3586;&#3629;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591; &#3604;&#',0),(312615,8684,'hi','Re-à¤²à¥‰à¤—à¤¿à¤¨ à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤¦à¥‡à¤–à¥‡à¤‚ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤ªà¤° à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(312616,8684,'ms','Memerlukan Re-Login skrin paparan pekerja',0),(312617,8684,'ar','ØªØªØ·Ù„Ø¨ Ø¥Ø¹Ø§Ø¯Ø©-ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø¹Ù„Ù‰ Ø´Ø§Ø´Ø© Ø¹Ø±Ø¶ Ø§Ù„Ù…ÙˆØ¸Ù',0),(312618,8684,'fr','Besoin de Re-connexion sur l\'Ã©cran de vue employÃ©',0),(312619,8684,'jp','å¾“æ¥­å“¡ãƒ“ãƒ¥ãƒ¼ç”»é¢ã§å†ãƒ­ã‚°ã‚¤ãƒ³ãŒå¿…è¦ã§ã™ã€‚',0),(312620,8684,'pt','Exigem Re-entrar na tela de exibiÃ§Ã£o do empregado',0),(312621,8684,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ñ€Ðµ Ð²Ñ…Ð¾Ð´Ð° Ð½Ð° ÑÐºÑ€Ð°Ð½Ðµ Ð¼Ð½ÐµÐ½Ð¸Ðµ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(312622,8684,'es','Re-Login En La Pantalla de Empleado requerido',0),(312623,8684,'de','Erfordern Sie Re-Login auf Mitarbeiter-Ansicht',0),(312624,8684,'en','Require Re-Login On Employee VIEW Screen',0),(312625,8685,'is','',0),(312626,8685,'dr','ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¨Ø±Ø§ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±ÛŒ',0),(312627,8685,'pr','ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¨Ø±Ø§ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±ÛŒ',0),(312628,8685,'tr','ParÃ§a baÅŸÄ± iÅŸ fazla mesai iÃ§in ilave',0),(312629,8685,'pl','Praca akordowa dodatek za nadgodziny',0),(312630,8685,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð·Ð° Ð¸Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´ÐµÐ½ Ñ‚Ñ€ÑƒÐ´',0),(312631,8685,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ø§ÙˆÙˆØ±Ù¹Ø§Ø¦Ù… Ú©Û’ Ù„Ø¦Û’ Ø§Ø¶Ø§ÙÛŒ',0),(312632,8685,'sr','Ð—Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ð¾ Ð·Ð° Ð¿Ñ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ñ€Ð°Ð´',0),(312633,8685,'vi','KhoÃ¡n thÃªm cho lÃ m thÃªm giá»',0),(312634,8685,'af','Stukwerk Bykomend vir Oortyd',0),(312635,8685,'ro','Acord suplimentare pentru ore suplimentare',0),(312636,8685,'et','TÃ¼kitÃ¶Ã¶ eest Ã¼letunnitÃ¶Ã¶',0),(312637,8685,'si','Akord ekstra za nadure',0),(312638,8685,'ba','Piecework tambahan untuk lembur',0),(312639,8685,'nl','Stukloon Extra voor overuren',0),(312640,8685,'fi','Urakka kun ylityÃ¶',0),(312641,8685,'no','StykkavlÃ¸nning ekstra for overtid',0),(312642,8685,'da','Akkordarbejde ekstra for overarbejde',0),(312643,8685,'ko','Piecework ì´ˆê³¼ ê·¼ë¬´ì— ëŒ€ í•œ ì¶”ê°€',0),(312644,8685,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª ×ª×•×¡×¤×ª ×¢×œ ×©×¢×•×ª × ×•×¡×¤×•×ª',0),(312645,8685,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Î³Î¹Î± Ï„Î¹Ï‚ Ï…Ï€ÎµÏÏ‰ÏÎ¯ÎµÏ‚',0),(312646,8685,'zh','é¢å¤–çš„åŠ ç­è´¹è®¡ä»¶\r\n',0),(312647,8685,'sv','Ackord Extra fÃ¶r Ã¶vertid',0),(312648,8685,'it','Lavoro a cottimo aggiuntivo per lavoro straordinario',0),(312649,8685,'tl','',0),(312650,8685,'th','&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;&#3614;&#3636;&#3648;&#3624;&#3625;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3607;&#3635;&#3609;&#3629;&#3585;&#3648;&#3623;&#3621;&#3634;',0),(312651,8685,'hi','Piecework à¤¸à¤®à¤¯à¥‹à¤ªà¤°à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤',0),(312652,8685,'ms','Piecework tambahan untuk kerja lebih masa',0),(312653,8685,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø© Ø¥Ø¶Ø§ÙÙŠØ© Ù„Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ',0),(312654,8685,'fr','PiÃ¨ce supplÃ©mentaire pour les heures supplÃ©mentaires',0),(312655,8685,'jp','å‡ºæ¥é«˜æ‰•ã„æ®‹æ¥­ã®ãŸã‚ä½™åˆ†ãª',0),(312656,8685,'pt','Trabalho por tarefa Extra para horas extras',0),(312657,8685,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½Ð¾Ð¹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… ÑÐ²ÐµÑ€Ñ…ÑƒÑ€Ð¾Ñ‡Ð½Ñ‹Ñ…',0),(312658,8685,'es','Trabajo por Pieza Extra para Horas Extras',0),(312659,8685,'de','Akkordarbeit Extra fÃ¼r Ãœberstunden',0),(312660,8685,'en','Piecework Extra for Overtime',0),(312661,8686,'is','',0),(312662,8686,'dr','Ø§Ú¯Ø± Ø§Ø³ØªØ§Ù† Ø¯Ø± Ù„ÙŠØ³Øª Ù†Ø¨Ø§Ø´Ø¯ ',0),(312663,8686,'pr','Ø§Ú¯Ø± Ø§Ø³ØªØ§Ù† Ø¯Ø± Ù„ÙŠØ³Øª Ù†Ø¨Ø§Ø´Ø¯ ',0),(312664,8686,'tr','EÄŸer devlet listede bulunmayan',0),(312665,8686,'pl','JeÅ›li PaÅ„stwo nie na liÅ›cie',0),(312666,8686,'bg','ÐÐºÐ¾ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°Ñ‚Ð° Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(312667,8686,'ur','Ø§Ú¯Ø± Ø±ÛŒØ§Ø³Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ù¾Ø± Ù†ÛÛŒÚº',0),(312668,8686,'sr','ÐÐºÐ¾ ÑÑ‚Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ Ð½Ð° Ð»Ð¸ÑÑ‚Ð¸',0),(312669,8686,'vi','Náº¿u tiá»ƒu bang khÃ´ng trong danh sÃ¡ch',0),(312670,8686,'af','Indien Staat (Landsgebied) Nie op Lys is',0),(312671,8686,'ro','DacÄƒ statului nu pe lista',0),(312672,8686,'et','Kui maakond ei ole nimekirjas',0),(312673,8686,'si','ÄŒe stanje ni na seznamu',0),(312674,8686,'ba','Jika negara tidak pada daftar',0),(312675,8686,'nl','Als staat niet op de lijst',0),(312676,8686,'fi','Jos valtio ole',0),(312677,8686,'no','Hvis staten ikke pÃ¥ listen',0),(312678,8686,'da','Hvis staten ikke pÃ¥ listen',0),(312679,8686,'ko','ë§Œì•½ ëª©ë¡ì— ì—†ëŠ” êµ­ê°€',0),(312680,8686,'he','×× ×”×ž×“×™× ×” ×œ× ×‘×¨×©×™×ž×”',0),(312681,8686,'el','Î•Î¬Î½ Î¼Î­Î»Î¿Ï‚ Î´ÎµÎ½ ÏƒÏ„Î¿Î½ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(312682,8686,'zh','å¦‚æžœå›½å®¶ä¸åœ¨åå•\r\n',0),(312683,8686,'sv','Om staten inte pÃ¥ listan',0),(312684,8686,'it','Se stato non in elenco',0),(312685,8686,'tl','',0),(312686,8686,'th','&#3606;&#3657;&#3634;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;&#3652;&#3617;&#3656;&#3617;&#3637;&#3651;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(312687,8686,'hi','à¤¯à¤¦à¤¿ à¤°à¤¾à¤œà¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤ªà¤° à¤¨à¤¹à¥€à¤‚',0),(312688,8686,'ms','Jika keadaan tidak dalam senarai',0),(312689,8686,'ar','Ø§Ù„ÙˆÙ„Ø§ÙŠØ© - Ø¥Ù† Ù„Ù… ØªÙƒÙ† ÙÙŠ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø£Ø¹Ù„Ø§Ù‡',0),(312690,8686,'fr','Si Ã‰tat pas sur la liste',0),(312691,8686,'jp','å ´åˆã¯ä¸€è¦§ã«ãªã„çŠ¶æ…‹',0),(312692,8686,'pt','Se o estado nÃ£o estÃ¡ na lista',0),(312693,8686,'ru','Ð•ÑÐ»Ð¸ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð¾ Ð½Ðµ Ð² ÑÐ¿Ð¸ÑÐºÐµ',0),(312694,8686,'es','Si Estado No Esta en la Lista',0),(312695,8686,'de','Wenn nicht auf der Liste',0),(312696,8686,'en','If State Not on List',0),(312697,8687,'is','',0),(312698,8687,'dr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(312699,8687,'pr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(312700,8687,'tr','MÃ¼ÅŸteriler birleÅŸtirme',0),(312701,8687,'pl','Scalanie klientÃ³w',0),(312702,8687,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(312703,8687,'ur','Ú¯Ø§ÛÚ© Ø¶Ù… Ú©Ø±ÛŒÚº',0),(312704,8687,'sr','ÐžÐ±Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ‚Ðµ ÐºÑƒÐ¿Ñ†Ðµ',0),(312705,8687,'vi','SÃ¡t nháº­p KhÃ¡ch hÃ ng ',0),(312706,8687,'af','Verenigde Klante/KliÃ«nte',0),(312707,8687,'ro','ÃŽmbinare clienÅ£ii',0),(312708,8687,'et','Ãœhenda kliendid',0),(312709,8687,'si','Spoji stranke',0),(312710,8687,'ba','Menggabungkan pelanggan',0),(312711,8687,'nl','Samenvoegen van klanten',0),(312712,8687,'fi','YhdistÃ¤Ã¤ asiakkaat',0),(312713,8687,'no','Flette kunder',0),(312714,8687,'da','Flette kunder',0),(312715,8687,'ko','ê³ ê°ì„ ë³‘í•©',0),(312716,8687,'he','×ž×–×’ ×œ×§×•×—×•×ª',0),(312717,8687,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(312718,8687,'zh','åˆå¹¶å®¢æˆ·\r\n',0),(312719,8687,'sv','Koppla kunder',0),(312720,8687,'it','Unire i clienti',0),(312721,8687,'tl','',0),(312722,8687,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3619;&#3623;&#3617;',0),(312723,8687,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤®à¤°à¥à¤œ',0),(312724,8687,'ms','Menggabungkan pelanggan',0),(312725,8687,'ar','Ø¯Ù…Ø¬ Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(312726,8687,'fr','Fusionner des clients',0),(312727,8687,'jp','é¡§å®¢ã‚’ãƒžãƒ¼ã‚¸ã—ã¾ã™ã€‚',0),(312728,8687,'pt','Mesclar os clientes',0),(312729,8687,'ru','ÐžÐ±ÑŠÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(312730,8687,'es','Combinar Clientes',0),(312731,8687,'de','ZusammenfÃ¼hren von Kunden',0),(312732,8687,'en','Merge Customers',0),(312733,8688,'is','',0),(312734,8688,'dr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù†  Ø§Ø³Ù†Ø§Ø¯ Ù…ØªØ¹Ø¯Ø¯ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(312735,8688,'pr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù†  Ø§Ø³Ù†Ø§Ø¯ Ù…ØªØ¹Ø¯Ø¯ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(312736,8688,'tr','Birden fazla mÃ¼ÅŸteri kaydÄ± birleÅŸtirme',0),(312737,8688,'pl','Scalanie wielu rekordÃ³w klientÃ³w',0),(312738,8688,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð½ÑÐºÐ¾Ð»ÐºÐ¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(312739,8688,'ur','Ú©Ø«ÛŒØ± Ú©Ø³Ù¹Ù…Ø± Ø±ÛŒÚ©Ø§Ø±Úˆ Ø¶Ù… Ú©Ø±ÛŒÚº',0),(312740,8688,'sr','ÐžÐ±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐµ Ð²Ð¸ÑˆÐµ Ð·Ð°Ð¿Ð¸ÑÐ° Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(312741,8688,'vi','Nháº­p khÃ¡ch hÃ ng cÃ³ nhiá»u há»“ sÆ¡',0),(312742,8688,'af','Verenig Verskeie Klante/KliÃ«nte Rekords',0),(312743,8688,'ro','ÃŽmbina mai multe Ã®nregistrÄƒri client',0),(312744,8688,'et','Ãœhenda mitme kliendi andmed',0),(312745,8688,'si','Spajanja spojite zapise kupcev',0),(312746,8688,'ba','Menggabungkan beberapa catatan pelanggan',0),(312747,8688,'nl','Meerdere klantrecords samenvoegen',0),(312748,8688,'fi','Useiden asiakastietueiden yhdistÃ¤minen',0),(312749,8688,'no','Flette flere kundeoppfÃ¸ringer',0),(312750,8688,'da','Flette flere kundeposter',0),(312751,8688,'ko','ì—¬ëŸ¬ ê³ ê° ë ˆì½”ë“œ ë³‘í•©',0),(312752,8688,'he','×ž×™×–×•×’ ×¨×©×•×ž×•×ª ×ž×¨×•×‘×•×ª ×©×œ ×œ×§×•×—×•×ª',0),(312753,8688,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· Ï€Î¿Î»Î»Î±Ï€Î»ÏŽÎ½ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(312754,8688,'zh','åˆå¹¶å¤šä¸ªå®¢æˆ·è®°å½•\r\n',0),(312755,8688,'sv','Sammanfoga flera kundposter',0),(312756,8688,'it','Unire piÃ¹ record cliente',0),(312757,8688,'tl','',0),(312758,8688,'th','Merge Multiple Customer Records',0),(312759,8688,'hi','à¤à¤•à¤¾à¤§à¤¿à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤…à¤­à¤¿à¤²à¥‡à¤– à¤®à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(312760,8688,'ms','Menggabungkan rekod pelanggan berbilang',0),(312761,8688,'ar','Ø¯Ù…Ø¬ Ø¹Ø¯Ø© Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(312762,8688,'fr','Fusionner plusieurs enregistrements de client',0),(312763,8688,'jp','è¤‡æ•°ã®é¡§å®¢ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ãƒžãƒ¼ã‚¸ã—ã¾ã™ã€‚',0),(312764,8688,'pt','Mesclar vÃ¡rios registros de cliente',0),(312765,8688,'ru','Ð¡Ð»Ð¸ÑÐ½Ð¸Ðµ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¸Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(312766,8688,'es','Combinar Expedientes de Clientes Multiples',0),(312767,8688,'de','Mehrere KundendatensÃ¤tze zusammenfÃ¼hren',0),(312768,8688,'en','Merge Multiple Customer Records',0),(312769,8689,'is','',0),(312770,8689,'dr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ø§Ø³Ù†Ø§Ø¯ Ù…ØªØ¹Ø¯Ø¯',0),(312771,8689,'pr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ø§Ø³Ù†Ø§Ø¯ Ù…ØªØ¹Ø¯Ø¯',0),(312772,8689,'tr','MÃ¼ÅŸteriler ile birden Ã§ok kaydÄ± birleÅŸtirme',0),(312773,8689,'pl','Scalanie klientÃ³w z wielu rekordÃ³w',0),(312774,8689,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ñ Ð¼Ð½Ð¾Ð¶ÐµÑÑ‚Ð²Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(312775,8689,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©Ø¦ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Û’ Ø³Ø§ØªÚ¾ Ø¶Ù… Ú©Ø±ÛŒÚº',0),(312776,8689,'sr','ÐžÐ±Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ‚Ðµ ÐºÑƒÐ¿Ñ†Ðµ ÑÐ° Ð²Ð¸ÑˆÐµ Ð·Ð°Ð¿Ð¸ÑÐ°',0),(312777,8689,'vi','Nháº­p khÃ¡ch hÃ ng cÃ³ nhiá»u há»“ sÆ¡ ',0),(312778,8689,'af','Verenigde Klante/KliÃ«nte met Verskeie Rekords',0),(312779,8689,'ro','ÃŽmbinare clienÅ£ii cu mai multe Ã®nregistrÄƒri',0),(312780,8689,'et','Merge mitu kirjet klientidele',0),(312781,8689,'si','Spoji stranke z veÄ zapisov',0),(312782,8689,'ba','Menggabungkan pelanggan dengan beberapa catatan',0),(312783,8689,'nl','Klanten met meerdere Records samenvoegen',0),(312784,8689,'fi','YhdistÃ¤Ã¤ useita tietueita asiakkaat',0),(312785,8689,'no','Flette kunder med flere poster',0),(312786,8689,'da','Flette kunder med flere poster',0),(312787,8689,'ko','ê³ ê°ì— ê²Œ ì—¬ëŸ¬ ë ˆì½”ë“œ ë³‘í•©',0),(312788,8689,'he','×œ×ž×–×’ ××ª ×”×œ×§×•×—×•×ª ×¢× ×¨×©×•×ž×•×ª ×ž×¨×•×‘×•×ª',0),(312789,8689,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î¼Îµ Ï€Î¿Î»Î»Î­Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(312790,8689,'zh','ä»¥å¤šä¸ªè®°å½•åˆå¹¶å®¢æˆ·\r\n',0),(312791,8689,'sv','Koppla kunder med flera poster',0),(312792,8689,'it','Unire i clienti con piÃ¹ record',0),(312793,8689,'tl','',0),(312794,8689,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3619;&#3623;&#3617;&#3585;&#3633;&#3610;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3629;&#3639;&#3656;&#3609;&#3654;',0),(312795,8689,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤•à¤¾à¤§à¤¿à¤• à¤…à¤­à¤¿à¤²à¥‡à¤– à¤®à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(312796,8689,'ms','Menggabungkan pelanggan yang mempunyai rekod-rekod pelbagai',0),(312797,8689,'ar','Ø¯Ù…Ø¬ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…Ø¹ Ø³Ø¬Ù„Ø§Øª Ù…ØªØ¹Ø¯Ø¯Ø©',0),(312798,8689,'fr','Clients avec plusieurs enregistrements de fusion',0),(312799,8689,'jp','è¤‡æ•°ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’æŒã¤é¡§å®¢ã‚’ãƒžãƒ¼ã‚¸ã—ã¾ã™ã€‚',0),(312800,8689,'pt','Mesclar os clientes com vÃ¡rios registros',0),(312801,8689,'ru','ÐžÐ±ÑŠÐµÐ´Ð¸Ð½ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ñ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¸Ð¼Ð¸ Ð·Ð°Ð¿Ð¸ÑÑÐ¼Ð¸',0),(312802,8689,'es','Combinar Clientes Con Recods Multiples',0),(312803,8689,'de','Kunden, die mehrere DatensÃ¤tze zusammenfÃ¼hren',0),(312804,8689,'en','Merge Customers With Multiple Records',0),(312805,8690,'is','',0),(312806,8690,'dr','ØªØ¨ØµØ±Ù‡ Ø±Ø¯ÙŠÙ ',0),(312807,8690,'pr','ØªØ¨ØµØ±Ù‡ Ø±Ø¯ÙŠÙ ',0),(312808,8690,'tr','SatÄ±r Not',0),(312809,8690,'pl','Uwaga linii',0),(312810,8690,'bg','Ð›Ð¸Ð½Ð¸Ñ Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(312811,8690,'ur','Ù„Ø§Ø¦Ù† Ù†ÙˆÙ¹',0),(312812,8690,'sr','Ð ÐµÐ´ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(312813,8690,'vi','DÃ²ng ghi chÃº',0),(312814,8690,'af','Lynnota',0),(312815,8690,'ro','Linie NotÄƒ',0),(312816,8690,'et','Line MÃ¤rkus',0),(312817,8690,'si','Opomba vrstica',0),(312818,8690,'ba','Catatan baris',0),(312819,8690,'nl','Lijn Opmerking',0),(312820,8690,'fi','Huomautus linja',0),(312821,8690,'no','Linje Note',0),(312822,8690,'da','Line BemÃ¦rk',0),(312823,8690,'ko','ë¼ì¸ ë…¸íŠ¸',0),(312824,8690,'he','×”×¢×¨×” ×”×©×•×¨×”',0),(312825,8690,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· Î³ÏÎ±Î¼Î¼Î®',0),(312826,8690,'zh','è¡Œæ³¨\r\n',0),(312827,8690,'sv','Linje anmÃ¤rkning',0),(312828,8690,'it','Linea Nota',0),(312829,8690,'tl','',0),(312830,8690,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3626;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(312831,8690,'hi','à¤²à¤¾à¤‡à¤¨ à¤¨à¥‹à¤Ÿ',0),(312832,8690,'ms','Nota talian',0),(312833,8690,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø®Ø·',0),(312834,8690,'fr','Note de la ligne',0),(312835,8690,'jp','ãƒ©ã‚¤ãƒ³ã®ãƒ¡ãƒ¢',0),(312836,8690,'pt','Nota de linha',0),(312837,8690,'ru','Ð›Ð¸Ð½Ð¸Ñ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(312838,8690,'es','Nota de Linea',0),(312839,8690,'de','Linie Anmerkung',0),(312840,8690,'en','Line Note',0),(312841,8691,'is','',0),(312842,8691,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ†  Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ Ø¯Ø± Ø³Ø§Ø¹Øª',0),(312843,8691,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ†  Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ Ø¯Ø± Ø³Ø§Ø¹Øª',0),(312844,8691,'tr','Saat baÅŸÄ±na ortalama parÃ§a baÅŸÄ± Ã¶deme',0),(312845,8691,'pl','Åšrednia pracy akordowej pÅ‚acy za godzinÄ™',0),(312846,8691,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð° Ð±Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ñ‡Ð°Ñ',0),(312847,8691,'ur','Ø§ÙˆØ³Ø· Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© ØªÙ†Ø®ÙˆØ§Û ÙÛŒ Ú¯Ú¾Ù†Ù¹Û',0),(312848,8691,'sr','ÐŸÑ€Ð¾ÑÐµÑ‡Ð½Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ð¾ ÑÐ°Ñ‚Ñƒ',0),(312849,8691,'vi','LÆ°Æ¡ng KhoÃ¡n Trung BÃ¬nh Theo Giá»',0),(312850,8691,'af','Gemiddelde Stukswerk Loon Per Uur',0),(312851,8691,'ro','Acord de mediu plata pe orÄƒ',0),(312852,8691,'et','Keskmise tÃ¼kitÃ¶Ã¶ tasu tunnis',0),(312853,8691,'si','Akord povpreÄna plaÄa na uro',0),(312854,8691,'ba','Gaji rata-rata Piecework Per jam',0),(312855,8691,'nl','Gemiddelde stukloon Pay Per uur',0),(312856,8691,'fi','KeskimÃ¤Ã¤rÃ¤inen urakkapalkka tunnissa',0),(312857,8691,'no','Gjennomsnittlig stykkavlÃ¸nning Per time',0),(312858,8691,'da','Gennemsnitlige akkordlÃ¸n pr. time',0),(312859,8691,'ko','ì‹œê°„ ë‹¹ í‰ê·  Piecework ì§€ë¶ˆ',0),(312860,8691,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª ×ž×ž×•×¦×¢ ×”×©×›×¨ ×œ×©×¢×”',0),(312861,8691,'el','ÎœÎ­ÏƒÎ· ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î±Î½Î¬ ÏŽÏÎ±',0),(312862,8691,'zh','å¹³å‡æ¯å°æ—¶è®¡ä»¶å·¥èµ„\r\n',0),(312863,8691,'sv','Genomsnittliga AckordsersÃ¤ttning Per timme',0),(312864,8691,'it','Cottimo medio paga oraria',0),(312865,8691,'tl','',0),(312866,8691,'th','&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3591;&#3634;&#3609;&#3605;&#3656;&#3629;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(312867,8691,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾ à¤”à¤¸à¤¤ Piecework à¤ªà¥‡',0),(312868,8691,'ms','Piecework purata gaji sejam',0),(312869,8691,'ar','Ø§Ù„Ù‚Ø·Ø¹Ø© Ù…ØªÙˆØ³Ø· Ø§Ù„Ø£Ø¬Ø± Ù„Ù„Ø³Ø§Ø¹Ø© Ø§Ù„ÙˆØ§Ø­Ø¯Ø©',0),(312870,8691,'fr','Salaire moyen Ã  la piÃ¨ce par heure',0),(312871,8691,'jp','1 æ™‚é–“ã‚ãŸã‚Šã®å¹³å‡å‡ºæ¥é«˜æ‰•ã„è³ƒé‡‘',0),(312872,8691,'pt','Trabalho por tarefa mÃ©dia paga por hora',0),(312873,8691,'ru','Ð¡Ñ€ÐµÐ´Ð½ÑÑ ÑÐ´ÐµÐ»ÑŒÐ½Ð°Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ð° Ð² Ñ‡Ð°Ñ',0),(312874,8691,'es','Pago Promedio por Hora para Trabajo por Pieza',0),(312875,8691,'de','Durchschnittliche Akkordarbeit Lohn pro Stunde',0),(312876,8691,'en','Average Piecework Pay Per Hour',0),(312877,8692,'is','',0),(312878,8692,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø³Ø§Ø¹Øª',0),(312879,8692,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø³Ø§Ø¹Øª',0),(312880,8692,'tr','Ortalama saat Ã¼creti',0),(312881,8692,'pl','Co godzinÄ™ AVG.',0),(312882,8692,'bg','Ð¡Ñ€ÐµÐ´ÐµÐ½ Ñ‡Ð°Ñ',0),(312883,8692,'ur','Avg. ÙÛŒ Ú¯Ú¾Ù†Ù¹Û',0),(312884,8692,'sr','ÐŸÐ¾Ð»Ð°Ð·Ð¸ÑˆÑ‚Ðµ ÑÐ°Ñ‚Ð½Ð¸Ñ†Ð°',0),(312885,8692,'vi','Giá» Trung BÃ¬nh',0),(312886,8692,'af','Gemidd. Uurliks',0),(312887,8692,'ro','Medie pe orÄƒ',0),(312888,8692,'et','Keskmine tunnitasu',0),(312889,8692,'si','PovpreÄno urno postavko',0),(312890,8692,'ba','Rata-rata per jam',0),(312891,8692,'nl','AVG. per uur',0),(312892,8692,'fi','KeskimÃ¤Ã¤rÃ¤inen tuntikorvaukset',0),(312893,8692,'no','Gj.snittlig time',0),(312894,8692,'da','Gennemsnitlig timelÃ¸n',0),(312895,8692,'ko','í‰ê·  ì‹œê°„ë‹¹',0),(312896,8692,'he','×ž×“×™ ×©×¢×” ×ž×ž×•×¦×¢×ª ×©×œ',0),(312897,8692,'el','Î©ÏÎ¹Î±Î¯Î± AVG.',0),(312898,8692,'zh','å¹³å‡æ¯å°æ—¶\r\n',0),(312899,8692,'sv','Genomsnittlig timlÃ¶n',0),(312900,8692,'it','Ogni ora AVG.',0),(312901,8692,'tl','',0),(312902,8692,'th','&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3619;&#3634;&#3618;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;',0),(312903,8692,'hi','à¤”à¤¸à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾',0),(312904,8692,'ms','Purata jam',0),(312905,8692,'ar','Ù…ØªÙˆØ³Ø· Ø£Ø¬Ø± Ø§Ù„Ø³Ø§Ø¹Ø©',0),(312906,8692,'fr','Horaire de moy.',0),(312907,8692,'jp','å¹³å‡æ™‚çµ¦',0),(312908,8692,'pt','MÃ©dia horÃ¡ria',0),(312909,8692,'ru','Ð¡Ñ€ÐµÐ´Ð½ÑÑ Ð¿Ð¾Ñ‡Ð°ÑÐ¾Ð²Ð°Ñ',0),(312910,8692,'es','Prom. por Hora',0),(312911,8692,'de','AVG stÃ¼ndlich',0),(312912,8692,'en','Avg. Hourly',0),(312913,8693,'is','',0),(312914,8693,'dr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø§Ø¶Ø§ÙÙ‡ ÙƒØ§Ø±ÙŠ',0),(312915,8693,'pr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø§Ø¶Ø§ÙÙ‡ ÙƒØ§Ø±ÙŠ',0),(312916,8693,'tr','ParÃ§a baÅŸÄ± iÅŸ fazla mesai',0),(312917,8693,'pl','Za pracÄ™ w nadgodzinach pracy akordowej',0),(312918,8693,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ Ð¸Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´ÐµÐ½ Ñ‚Ñ€ÑƒÐ´',0),(312919,8693,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ø§ÙˆÙˆØ±Ù¹Ø§Ø¦Ù…',0),(312920,8693,'sr','ÐŸÑ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ñ€Ð°Ð´ Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(312921,8693,'vi','ThÃªm giá» Viá»‡c khoÃ¡n',0),(312922,8693,'af','Stukwerk Oortyd',0),(312923,8693,'ro','Acord orele suplimentare',0),(312924,8693,'et','TÃ¼kitÃ¶Ã¶ Ã¼letunnitÃ¶Ã¶',0),(312925,8693,'si','Akord nadure',0),(312926,8693,'ba','Piecework lembur',0),(312927,8693,'nl','Stukloon overuren',0),(312928,8693,'fi','Urakka ylityÃ¶',0),(312929,8693,'no','StykkavlÃ¸nning overtid',0),(312930,8693,'da','Akkordarbejde overarbejde',0),(312931,8693,'ko','Piecework ì´ˆê³¼',0),(312932,8693,'he','×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª ×©×¢×•×ª × ×•×¡×¤×•×ª',0),(312933,8693,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹ Ï…Ï€ÎµÏÏ‰ÏÎ¯ÎµÏ‚',0),(312934,8693,'zh','è®¡ä»¶åŠ ç­è´¹\r\n',0),(312935,8693,'sv','Ackord Ã¶vertid',0),(312936,8693,'it','Lavoro straordinario lavoro a cottimo',0),(312937,8693,'tl','',0),(312938,8693,'th','&#3607;&#3635;&#3609;&#3629;&#3585;&#3648;&#3623;&#3621;&#3634;&#3591;&#3634;&#3609;&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;',0),(312939,8693,'hi','Piecework à¤“à¤µà¤°à¤Ÿà¤¾à¤‡à¤®',0),(312940,8693,'ms','Kerja lebih masa piecework',0),(312941,8693,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ ÙÙŠ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(312942,8693,'fr','Heures supplÃ©mentaires de travail Ã  la piÃ¨ce',0),(312943,8693,'jp','å‡ºæ¥é«˜æ‰•ã„æ®‹æ¥­',0),(312944,8693,'pt','Horas extras de trabalho por tarefa',0),(312945,8693,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½Ð¾Ð¹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÐ²ÐµÑ€Ñ…ÑƒÑ€Ð¾Ñ‡Ð½Ñ‹Ñ…',0),(312946,8693,'es','Horas Extras de Trabajo por Pieza',0),(312947,8693,'de','Akkord Ãœberstunden',0),(312948,8693,'en','Piecework Overtime',0),(312949,8694,'is','',0),(312950,8694,'dr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(312951,8694,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(312952,8694,'tr','EÄŸer Bill Ã§eke',0),(312953,8694,'pl','SprawdÅº, czy na rachunku',0),(312954,8694,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ð»Ð¸ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð°',0),(312955,8694,'ur','Ø§Ú¯Ø± Ø¨Ù„ Ù¾Ø± Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(312956,8694,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°ÐºÐ¾ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(312957,8694,'vi','Kiá»ƒm Tra náº¿u cÃ³ trÃªn hÃ³a Ä‘Æ¡n',0),(312958,8694,'af','Bestudeer as Wetsontwerp',0),(312959,8694,'ro','Verifica daca pe factura',0),(312960,8694,'et','Kui arvel sisse',0),(312961,8694,'si','Preverite, Äe na raÄunu',0),(312962,8694,'ba','Memeriksa jika tagihan',0),(312963,8694,'nl','Selectievakje als op factuur',0),(312964,8694,'fi','Tarkistaa, jos Bill',0),(312965,8694,'no','Sjekk Hvis pÃ¥ Bill',0),(312966,8694,'da','Check hvis pÃ¥ Bill',0),(312967,8694,'ko','ë¹Œ í•˜ëŠ” ê²½ìš°ì— í™•ì¸',0),(312968,8694,'he','×œ×‘×“×•×§ ×× ×‘×™×œ',0),(312969,8694,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÎµÎ¬Î½ ÏƒÏ„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(312970,8694,'zh','æ£€æŸ¥æ˜¯å¦åœ¨å¸å•ä¸Š\r\n',0),(312971,8694,'sv','Kontrollera om Bill',0),(312972,8694,'it','Controllo se il disegno di legge',0),(312973,8694,'tl','',0),(312974,8694,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3651;&#3609;&#3610;&#3636;&#3621;',0),(312975,8694,'hi','à¤…à¤—à¤° à¤¬à¤¿à¤² à¤ªà¤° à¤šà¥‡à¤•',0),(312976,8694,'ms','Periksa jika Rang undang-undang',0),(312977,8694,'ar','ØªØ­Ù‚Ù‚ Ø¥Ø°Ø§ ÙƒØ§Ù† Ø¹Ù„Ù‰ Ø¨ÙŠÙ„',0),(312978,8694,'fr','VÃ©rifier si le projet de loi',0),(312979,8694,'jp','ãƒ“ãƒ«ã®å ´åˆã¯ãƒã‚§ãƒƒã‚¯',0),(312980,8694,'pt','Verifique se na conta',0),(312981,8694,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ, ÐµÑÐ»Ð¸ Ð‘Ð¸Ð»Ð»',0),(312982,8694,'es','Comprobar si en la Factura',0),(312983,8694,'de','Wenn auf Rechnung',0),(312984,8694,'en','Check if On Bill',0),(312985,8695,'is','',0),(312986,8695,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(312987,8695,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(312988,8695,'tr','Kredi kartÄ± hesabÄ± ekleme',0),(312989,8695,'pl','Rachunek karty kredytowej dodaÄ‡',0),(312990,8695,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(312991,8695,'ur','Ø¨Ù„ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(312992,8695,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ð±Ð¸Ð»Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ðµ',0),(312993,8695,'vi','ThÃªm HÃ³a ÄÆ¡n Tháº» TÃ­n Dá»¥ng',0),(312994,8695,'af','Kredietkaart rekening voeg',0),(312995,8695,'ro','Card de credit Bill Adauga',0),(312996,8695,'et','Krediitkaardi arve lisa',0),(312997,8695,'si','Kreditno kartico, raÄun dodati',0),(312998,8695,'ba','Tagihan kartu kredit menambahkan',0),(312999,8695,'nl','Creditcard factuur toevoegen',0),(313000,8695,'fi','Luottokorttilasku lisÃ¤Ã¤',0),(313001,8695,'no','Kredittkortregningen legge',0),(313002,8695,'da','Kreditkort regningen tilfÃ¸je',0),(313003,8695,'ko','ì‹ ìš© ì¹´ë“œ ì²­êµ¬ì„œ ì¶”ê°€',0),(313004,8695,'he','×—×©×‘×•×Ÿ ×”××©×¨××™ ×œ×”×•×¡×™×£',0),(313005,8695,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï„Î·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(313006,8695,'zh','ä¿¡ç”¨å¡è´¦å•åœ°å€\r\n',0),(313007,8695,'sv','KreditkortsrÃ¤kning lÃ¤gga till',0),(313008,8695,'it','Carte di credito aggiungere',0),(313009,8695,'tl','',0),(313010,8695,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3636;&#3621;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(313011,8695,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¬à¤¿à¤² à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(313012,8695,'ms','Bil kredit kad tambah',0),(313013,8695,'ar','ÙØ§ØªÙˆØ±Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¥Ø¶Ø§ÙØ©',0),(313014,8695,'fr','Facture de carte de crÃ©dit ajoute',0),(313015,8695,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è«‹æ±‚æ›¸ã‚’è¿½åŠ ',0),(313016,8695,'pt','CartÃ£o de crÃ©dito adicionar',0),(313017,8695,'ru','Ð¡Ñ‡ÐµÑ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(313018,8695,'es','Tarjeta de CrÃ©dito Agregar Recibo',0),(313019,8695,'de','Kreditkartenabrechnung hinzufÃ¼gen',0),(313020,8695,'en','Credit Card Bill Add',0),(313021,8696,'is','',0),(313022,8696,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®Ø±ÙŠØ¯Ø§Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(313023,8696,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®Ø±ÙŠØ¯Ø§Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(313024,8696,'tr','MÃ¼ÅŸteri ÅŸifre girildi',0),(313025,8696,'pl','Wprowadzono hasÅ‚a klienta',0),(313026,8696,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ° Ð¿Ð°Ñ€Ð¾Ð»Ð° Ðµ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð°',0),(313027,8696,'ur','Ú¯Ø§ÛÚ© Ú©Û’ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¯Ø§Ø®Ù„ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(313028,8696,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÐ½ÐµÑÐµÐ½Ð° Ð»Ð¾Ð·Ð¸Ð½ÐºÐ° ÐºÑƒÐ¿Ñ†Ð°',0),(313029,8696,'vi','Máº­t kháº©u KhÃ¡ch hÃ ng Ä‘Ã£ nháº­p',0),(313030,8696,'af','Klant / KliÃ«nt Wagwoord is Ingevoer',0),(313031,8696,'ro','A fost introdus parola clientului',0),(313032,8696,'et','Kliendi salasÃµna on sisestatud',0),(313033,8696,'si','Kupec geslo vnesli',0),(313034,8696,'ba','Password Nasabah telah dimasukkan',0),(313035,8696,'nl','Klant wachtwoord is ingevoerd',0),(313036,8696,'fi','Asiakkaan salasana on syÃ¶tetty',0),(313037,8696,'no','Kunden passord er angitt',0),(313038,8696,'da','Kunde adgangskoden er blevet indtastet',0),(313039,8696,'ko','ê³ ê° ë¹„ë°€ ë²ˆí˜¸ë¥¼ ìž…ë ¥',0),(313040,8696,'he','×”×•×–× ×” ×¡×™×¡×ž×” ×œ×œ×§×•×—',0),(313041,8696,'el','ÎˆÏ‡ÎµÎ¹ ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(313042,8696,'zh','å®¢æˆ·è¾“å…¥å¯†ç \r\n',0),(313043,8696,'sv','Kundens lÃ¶senord har angetts',0),(313044,8696,'it','La password del cliente Ã¨ stata inserita',0),(313045,8696,'tl','',0),(313046,8696,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3606;&#3641;&#3585;&#3611;&#3657;&#3629;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(313047,8696,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(313048,8696,'ms','Kata laluan pelanggan telah dimasukkan',0),(313049,8696,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„ ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(313050,8696,'fr','Client mot de passe a Ã©tÃ© entrÃ©',0),(313051,8696,'jp','ãŠå®¢æ§˜ã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(313052,8696,'pt','Cliente senha foi inserida',0),(313053,8696,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð‘Ñ‹Ð» Ð’Ð²ÐµÐ´ÐµÐ½',0),(313054,8696,'es','ContraseÃ±a de Cliente Ha Sido Entrado',0),(313055,8696,'de','Kundenkennwort wurde eingegeben',0),(313056,8696,'en','Customer Password Has Been Entered',0),(313057,8697,'is','',0),(313058,8697,'dr','Ù‡ÙŠÚ† Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±ÙŠ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ ',0),(313059,8697,'pr','Ù‡ÙŠÚ† Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±ÙŠ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ ',0),(313060,8697,'tr','Girilen parola',0),(313061,8697,'pl','Nie hasÅ‚o',0),(313062,8697,'bg','ÐÑÐ¼Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð²Ð»Ð¸Ð·Ð°Ð¼',0),(313063,8697,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(313064,8697,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ° Ð½Ð¸Ñ˜Ðµ ÑƒÐ½ÐµÑ‚Ð°',0),(313065,8697,'vi','ChÆ°a nháº­p máº­t kháº©u',0),(313066,8697,'af','Geen Wagwoord Ingevoer',0),(313067,8697,'ro','Nici o parola introduse',0),(313068,8697,'et','SalasÃµna ei sisestatud',0),(313069,8697,'si','Brez gesla, vstopil',0),(313070,8697,'ba','Tidak ada kata sandi yang dimasukkan',0),(313071,8697,'nl','Geen wachtwoord ingevoerd',0),(313072,8697,'fi','Ei salasanaa',0),(313073,8697,'no','Ingen passordet',0),(313074,8697,'da','Ingen adgangskode angivet',0),(313075,8697,'ko','ìž…ë ¥ í•œ ë¹„ë°€ ë²ˆí˜¸',0),(313076,8697,'he','×œ× ×”×•×›× ×¡×” ×¡×™×¡×ž×”',0),(313077,8697,'el','Î”ÎµÎ½ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï€Î¿Ï… Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÎ±Ï„Îµ',0),(313078,8697,'zh','æ²¡æœ‰è¾“å…¥çš„å¯†ç \r\n',0),(313079,8697,'sv','Inga lÃ¶senord som anges',0),(313080,8697,'it','Nessuna Password immessa',0),(313081,8697,'tl','',0),(313082,8697,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3607;&#3637;&#3656;&#3611;&#3657;&#3629;&#3609;',0),(313083,8697,'hi','à¤•à¥‹à¤ˆ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾',0),(313084,8697,'ms','Tiada kata laluan yang dimasukkan',0),(313085,8697,'ar','Ù„Ù… ØªØ¯Ø®Ù„ ÙƒÙ„Ù…Ø© Ø§Ù„Ø³Ø±Ù‘',0),(313086,8697,'fr','Aucun mot de passe entrÃ©',0),(313087,8697,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã—ã¦',0),(313088,8697,'pt','Nenhuma senha digitada',0),(313089,8697,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ ÐÐµ Ð’Ð²ÐµÐ´ÐµÐ½ ',0),(313090,8697,'es','Ningun Clave Entrado',0),(313091,8697,'de','Kein Passwort eingegeben',0),(313092,8697,'en','No Password Entered',0),(313093,8698,'is','',0),(313094,8698,'dr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¯Ø± Ø§ÙŠÙ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(313095,8698,'pr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¯Ø± Ø§ÙŠÙ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(313096,8698,'tr','Bu tasarÄ±nÄ±n alÄ±ÅŸveriÅŸte kredi kartÄ±',0),(313097,8698,'pl','Zakup kartÄ… kredytowÄ… na ten rachunek',0),(313098,8698,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð² Ñ‚Ð¾Ð·Ð¸ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(313099,8698,'ur','Ø§Ø³ Ø¨Ù„ Ù¾Ø± Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(313100,8698,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ðµ Ð¾Ð²Ð¾Ð³ Ð·Ð°ÐºÐ¾Ð½Ð°',0),(313101,8698,'vi','Giao Dá»‹ch Mua HÃ ng Qua Tháº» TÃ­n Dá»¥ng TrÃªn HÃ³a ÄÆ¡n NÃ y',0),(313102,8698,'af','Kredietkaartaankope op Hierdie Rekening',0),(313103,8698,'ro','Card de credit cumpÄƒrÄƒri pe acest proiect de lege',0),(313104,8698,'et','Krediitkaardiga ostmisel see seaduseelnÃµu',0),(313105,8698,'si','Nakup s kreditno kartico na ta raÄun',0),(313106,8698,'ba','Kartu kredit pembelian pada RUU ini',0),(313107,8698,'nl','Credit Card aankopen op dit wetsvoorstel',0),(313108,8698,'fi','Luottokorttiostoissa Bill',0),(313109,8698,'no','KredittkortkjÃ¸p pÃ¥ denne regningen',0),(313110,8698,'da','Kreditkort kÃ¸b pÃ¥ dette lovforslag',0),(313111,8698,'ko','ì´ ë²•ì•ˆì— ì‹ ìš© ì¹´ë“œ êµ¬ë§¤',0),(313112,8698,'he','×¨×›×™×©×•×ª ×‘×›×¨×˜×™×¡×™ ××©×¨××™ ×‘×—×©×‘×•×Ÿ ×”×–×”',0),(313113,8698,'el','Î‘Î³Î¿ÏÎ­Ï‚ Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(313114,8698,'zh','å°±æœ¬å¸å•çš„ä¿¡ç”¨å¡è´­ç‰©\r\n',0),(313115,8698,'sv','KreditkortskÃ¶p om detta lagfÃ¶rslag',0),(313116,8698,'it','Acquisti di carta di credito su questo disegno di legge',0),(313117,8698,'tl','',0),(313118,8698,'th','&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3586;&#3629;&#3591;&#3610;&#3636;&#3621;&#3609;&#3637;&#3657;',0),(313119,8698,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤‡à¤¸ à¤¬à¤¿à¤² à¤ªà¤°',0),(313120,8698,'ms','Pembelian kad kredit pada Rang undang-undang ini',0),(313121,8698,'ar','Ù…Ø´ØªØ±ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¹Ù„Ù‰ Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ù‡Ø°Ø§',0),(313122,8698,'fr','Achats par carte de crÃ©dit sur ce projet de loi',0),(313123,8698,'jp','ã“ã®è«‹æ±‚æ›¸ã«ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è³¼å…¥',0),(313124,8698,'pt','Compras com cartÃ£o de crÃ©dito na conta',0),(313125,8698,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹ Ð½Ð° ÑÑ‚Ð¾Ñ‚ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(313126,8698,'es','Tarjeta de CrÃ©dito Compras en Este Recibo',0),(313127,8698,'de','Kreditkartenzahlungen auf dieses Gesetz',0),(313128,8698,'en','Credit Card Purchases on This Bill',0),(313129,8699,'is','',0),(313130,8699,'dr','Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø·Ø¨Ù‚ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(313131,8699,'pr','Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø·Ø¨Ù‚ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(313132,8699,'tr','DiÄŸer masraflar faturasÄ±',0),(313133,8699,'pl','Inne opÅ‚aty na rachunek',0),(313134,8699,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(313135,8699,'ur','Ø¯ÛŒÚ¯Ø± Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Û’ Ø¨Ù„ Ù¾Ø±',0),(313136,8699,'sr','Ð”Ñ€ÑƒÐ³Ðµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(313137,8699,'vi','Chi PhÃ­ KhÃ¡c TrÃªn HÃ³a ÄÆ¡n',0),(313138,8699,'af','Ander Kostes op Rekening',0),(313139,8699,'ro','Alte taxe pe factura',0),(313140,8699,'et','Muude maksude arvel',0),(313141,8699,'si','Druge dajatve na raÄun',0),(313142,8699,'ba','Biaya lainnya pada tagihan',0),(313143,8699,'nl','Andere kosten op factuur',0),(313144,8699,'fi','Bill maksut',0),(313145,8699,'no','Gebyrer pÃ¥ Bill',0),(313146,8699,'da','Andre afgifter pÃ¥ Bill',0),(313147,8699,'ko','ë‹¤ë¥¸ ìš”ê¸ˆ ì²­êµ¬ì„œì—',0),(313148,8699,'he','×—×™×•×‘ ××—×¨ ×¢×œ ×—×©×‘×•×Ÿ',0),(313149,8699,'el','Î›Î¿Î¹Ï€ÏŽÎ½ ÎµÏ€Î¹Î²Î±ÏÏÎ½ÏƒÎµÏ‰Î½ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(313150,8699,'zh','å¸å•çš„å…¶ä»–è´¹ç”¨\r\n',0),(313151,8699,'sv','Andra avgifter pÃ¥ faktura',0),(313152,8699,'it','Altri oneri su Bill',0),(313153,8699,'tl','',0),(313154,8699,'th','&#3588;&#3656;&#3634;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3629;&#3639;&#3656;&#3609;&#3586;&#3629;&#3591;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(313155,8699,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤ªà¤° à¤…à¤¨à¥à¤¯ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(313156,8699,'ms','Caj-caj lain pada Rang undang-undang',0),(313157,8699,'ar','Ø±Ø³ÙˆÙ… Ø£Ø®Ø±Ù‰ Ø¹Ù„Ù‰ Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ†',0),(313158,8699,'fr','Autres frais sur facture',0),(313159,8699,'jp','ãã®ä»–ã®æ–™é‡‘ã®è«‹æ±‚æ›¸ã«',0),(313160,8699,'pt','Outros encargos na conta',0),(313161,8699,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð½Ð° ÑÑ‡ÐµÑ‚',0),(313162,8699,'es','Otros Cargos en el Recibo\n',0),(313163,8699,'de','Abgaben auf Rechnung',0),(313164,8699,'en','Other Charges on Bill',0),(313165,8700,'is','',0),(313166,8700,'dr','ÙƒÙ„ Ø¯ÙŠÚ¯Ø± ',0),(313167,8700,'pr','ÙƒÙ„ Ø¯ÙŠÚ¯Ø± ',0),(313168,8700,'tr','Toplam diÄŸer',0),(313169,8700,'pl','OgÃ³Å‚em inne',0),(313170,8700,'bg','ÐžÐ±Ñ‰Ð¾ Ð´Ñ€ÑƒÐ³Ð¸',0),(313171,8700,'ur','Ø¯ÛŒÚ¯Ø± Ú©Ù„',0),(313172,8700,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¾ÑÑ‚Ð°Ð»Ðµ',0),(313173,8700,'vi','Tá»•ng cá»™ng khÃ¡c',0),(313174,8700,'af','Ander Totaal',0),(313175,8700,'ro','Total alte',0),(313176,8700,'et','Kokku muud',0),(313177,8700,'si','Skupaj drugi',0),(313178,8700,'ba','Jumlah lain',0),(313179,8700,'nl','Totaal andere',0),(313180,8700,'fi','YhteensÃ¤ muut',0),(313181,8700,'no','Totalt andre',0),(313182,8700,'da','Alt andet',0),(313183,8700,'ko','ì´ ë‹¤ë¥¸',0),(313184,8700,'he','×¡×” ×› ××—×¨×™×',0),(313185,8700,'el','Î£ÏÎ½Î¿Î»Î¿ Î¬Î»Î»Ï‰Î½',0),(313186,8700,'zh','æ€»è®¡å…¶ä»–\r\n',0),(313187,8700,'sv','Totalt andra',0),(313188,8700,'it','Totale altri',0),(313189,8700,'tl','',0),(313190,8700,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3629;&#3639;&#3656;&#3609;&#3654;',0),(313191,8700,'hi','à¤•à¥à¤² à¤…à¤¨à¥à¤¯',0),(313192,8700,'ms','Jumlah lain-lain',0),(313193,8700,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø£Ø®Ø±Ù‰',0),(313194,8700,'fr','Total autre',0),(313195,8700,'jp','ãã®ä»–åˆè¨ˆ',0),(313196,8700,'pt','Total outro',0),(313197,8700,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾, Ð´Ñ€ÑƒÐ³Ð¸Ðµ',0),(313198,8700,'es','Total Otro',0),(313199,8700,'de','Total andere',0),(313200,8700,'en','Total Other',0),(313201,8701,'is','',0),(313202,8701,'dr','ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(313203,8701,'pr','ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(313204,8701,'tr','SeÃ§ili toplam',0),(313205,8701,'pl','Liczba wybranych',0),(313206,8701,'bg','ÐžÐ±Ñ‰Ð¾ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(313207,8701,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©Ù„',0),(313208,8701,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾',0),(313209,8701,'vi','Tá»•ng cá»™ng Ä‘Ã£ chá»n',0),(313210,8701,'af','Totaal Geselekteer',0),(313211,8701,'ro','Total selectat',0),(313212,8701,'et','Kokku mÃ¤rgitud',0),(313213,8701,'si','Skupno izbranih',0),(313214,8701,'ba','Total yang dipilih',0),(313215,8701,'nl','Totaal geselecteerd',0),(313216,8701,'fi','YhteensÃ¤ valitun',0),(313217,8701,'no','Totalt valgt',0),(313218,8701,'da','Alt valgt',0),(313219,8701,'ko','ì„ íƒ í•˜ì‹œ',0),(313220,8701,'he','×‘×¡×›×•× ×”× ×‘×—×¨',0),(313221,8701,'el','Î£ÏÎ½Î¿Î»Î¿ Ï€Î¿Ï… Î­Ï‡ÎµÏ„Îµ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î­Î¾ÎµÎ¹',0),(313222,8701,'zh','æ€»é€‰å–\r\n',0),(313223,8701,'sv','Total vald',0),(313224,8701,'it','Totale selezionato',0),(313225,8701,'tl','',0),(313226,8701,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(313227,8701,'hi','à¤•à¥à¤² à¤šà¤¯à¤¨à¤¿à¤¤',0),(313228,8701,'ms','Jumlah yang dipilih',0),(313229,8701,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ù…Ø®ØªØ§Ø±Ø©',0),(313230,8701,'fr','Total sÃ©lectionnÃ©',0),(313231,8701,'jp','é¸æŠžã—ãŸåˆè¨ˆ',0),(313232,8701,'pt','Total selecionado',0),(313233,8701,'ru','Ð’ÑÐµÐ³Ð¾ Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð¾',0),(313234,8701,'es','Total Seleccionado',0),(313235,8701,'de','Insgesamt ausgewÃ¤hlt',0),(313236,8701,'en','Total Selected',0),(313237,8702,'is','',0),(313238,8702,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(313239,8702,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(313240,8702,'tr','Bill',0),(313241,8702,'pl','Bill',0),(313242,8702,'bg','Ð‘Ð¸Ð»',0),(313243,8702,'ur','Ø¨Ù„',0),(313244,8702,'sr','Ð‘Ð¸Ð»',0),(313245,8702,'vi','HÃ³a ÄÆ¡n',0),(313246,8702,'af','Wetsontwerp',0),(313247,8702,'ro','Proiect de lege',0),(313248,8702,'et','Bill',0),(313249,8702,'si','Bill',0),(313250,8702,'ba','Bill',0),(313251,8702,'nl','Bill',0),(313252,8702,'fi','Bill',0),(313253,8702,'no','Bill',0),(313254,8702,'da','Bill',0),(313255,8702,'ko','ë¹Œ',0),(313256,8702,'he','×—×©×‘×•×Ÿ',0),(313257,8702,'el','Bill',0),(313258,8702,'zh','å¸å•\r\n',0),(313259,8702,'sv','Bill',0),(313260,8702,'it','Bill',0),(313261,8702,'tl','',0),(313262,8702,'th','&#3610;&#3636;&#3621;',0),(313263,8702,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤•',0),(313264,8702,'ms','Rang undang-undang',0),(313265,8702,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ù…ÙˆØ±Ù‘Ø¯',0),(313266,8702,'fr','Projet de loi',0),(313267,8702,'jp','ãƒ“ãƒ«',0),(313268,8702,'pt','Bill',0),(313269,8702,'ru','Ð‘Ð¸Ð»Ð»',0),(313270,8702,'es','Factura (Nota)',0),(313271,8702,'de','Bill',0),(313272,8702,'en','Bill',0),(313273,8703,'is','',0),(313274,8703,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(313275,8703,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(313276,8703,'tr','Bill bulunamadÄ±',0),(313277,8703,'pl','Bill nie znaleziono',0),(313278,8703,'bg','Ð—Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(313279,8703,'ur','Ø¨Ù„ Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(313280,8703,'sr','Ð‘Ð¸Ð»Ð» Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(313281,8703,'vi','KhÃ´ng tháº¥y hÃ³a Ä‘Æ¡n',0),(313282,8703,'af','Wetsontwerp nie gevind nie',0),(313283,8703,'ro','Proiectul de lege nu a fost gÄƒsit',0),(313284,8703,'et','Bill ei leitud',0),(313285,8703,'si','Zakona ni mogoÄe najti',0),(313286,8703,'ba','Bill tidak ditemukan',0),(313287,8703,'nl','Bill niet gevonden',0),(313288,8703,'fi','Bill ei lÃ¶ydy',0),(313289,8703,'no','Bill ikke funnet',0),(313290,8703,'da','Bill ikke fundet',0),(313291,8703,'ko','ë¹Œì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(313292,8703,'he','×—×©×‘×•×Ÿ ×œ× × ×ž×¦×',0),(313293,8703,'el','Bill Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(313294,8703,'zh','å¸å•æœªæ‰¾åˆ°\r\n',0),(313295,8703,'sv','Bill hittades inte',0),(313296,8703,'it','Bill non trovato',0),(313297,8703,'tl','',0),(313298,8703,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3610;&#3636;&#3621;',0),(313299,8703,'hi','à¤¬à¤¿à¤² à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(313300,8703,'ms','Rang undang-undang tidak dijumpai',0),(313301,8703,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(313302,8703,'fr','Bill introuvable',0),(313303,8703,'jp','æ³•æ¡ˆãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(313304,8703,'pt','Bill nÃ£o encontrado',0),(313305,8703,'ru','Ð‘Ð¸Ð»Ð» Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(313306,8703,'es','Factura No encontrada',0),(313307,8703,'de','Bill wurde nicht gefunden.',0),(313308,8703,'en','Bill Not Found',0),(313309,8704,'is','',0),(313310,8704,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313311,8704,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313312,8704,'tr','Kredi kartÄ± fatura gÃ¼ncelleÅŸtirme',0),(313313,8704,'pl','Karta kredytowa Bill aktualizacji',0),(313314,8704,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(313315,8704,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø¨Ù„ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(313316,8704,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð‘Ð¸Ð» ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(313317,8704,'vi','Cáº­p Nháº­t HÃ³a ÄÆ¡n Tháº» TÃ­n Dá»¥ng',0),(313318,8704,'af','Kredietkaart Wetsontwerp bywerking',0),(313319,8704,'ro','Actualizare de factura cardului de credit',0),(313320,8704,'et','Krediitkaardi arve uuendamine',0),(313321,8704,'si','Posodobitev zakona kreditne kartice',0),(313322,8704,'ba','Update tagihan kartu kredit',0),(313323,8704,'nl','Credit Card Bill Update',0),(313324,8704,'fi','Luottokortilla Bill pÃ¤ivitys',0),(313325,8704,'no','Kredittkort regningen oppdatering',0),(313326,8704,'da','Kreditkort regningen opdatering',0),(313327,8704,'ko','ì‹ ìš© ì¹´ë“œ ë¹Œ ì—…ë°ì´íŠ¸',0),(313328,8704,'he','×¢×“×›×•×Ÿ ×—×©×‘×•×Ÿ ×›×¨×˜×™×¡ ×”××©×¨××™',0),(313329,8704,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Bill Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(313330,8704,'zh','ä¿¡ç”¨å¡è´¦å•æ›´æ–°\r\n',0),(313331,8704,'sv','Kreditkort Bill uppdatering',0),(313332,8704,'it','Credit Card Bill aggiornamento',0),(313333,8704,'tl','',0),(313334,8704,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3610;&#3636;&#3621;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(313335,8704,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¬à¤¿à¤² à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(313336,8704,'ms','Kemas kini bil kad kredit',0),(313337,8704,'ar','ØªØ­Ø¯ÙŠØ« ÙØ§ØªÙˆØ±Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(313338,8704,'fr','Mise Ã  jour de facture de carte de crÃ©dit',0),(313339,8704,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è«‹æ±‚æ›¸ã®æ›´æ–°',0),(313340,8704,'pt','AtualizaÃ§Ã£o de conta de cartÃ£o de crÃ©dito',0),(313341,8704,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(313342,8704,'es','Tarjeta de CrÃ©dito Actualizar Recibo',0),(313343,8704,'de','Kreditkarte Bill Update',0),(313344,8704,'en','Credit Card Bill Update',0),(313345,8705,'is','',0),(313346,8705,'dr','Ù„ØºÙˆ ÙƒØ±Ø¯Ù†  ',0),(313347,8705,'pr','Ù„ØºÙˆ ÙƒØ±Ø¯Ù†  ',0),(313348,8705,'tr','Ters Ã§evir',0),(313349,8705,'pl','OdwrÃ³ciÄ‡',0),(313350,8705,'bg','Ð—Ð°Ð´ÐµÐ½ Ñ…Ð¾Ð´',0),(313351,8705,'ur','Ù…Ø¹Ú©ÙˆØ³ Ú©Ø±ÛŒÚº',0),(313352,8705,'sr','Ð Ð¸ÐºÐ²ÐµÑ€Ñ†',0),(313353,8705,'vi','Viáº¿t ngÆ°á»£c',0),(313354,8705,'af','Omgekeerde',0),(313355,8705,'ro','Inversa',0),(313356,8705,'et','Reverse',0),(313357,8705,'si','Povratne',0),(313358,8705,'ba','Terbalik',0),(313359,8705,'nl','Omgekeerde',0),(313360,8705,'fi','KÃ¤Ã¤ntÃ¤Ã¤',0),(313361,8705,'no','Omvendt',0),(313362,8705,'da','Omvendt',0),(313363,8705,'ko','ë¦¬ë²„ìŠ¤',0),(313364,8705,'he','×”×¤×•×š',0),(313365,8705,'el','Î‘Î½Ï„Î¯ÏƒÏ„ÏÎ¿Ï†Î·',0),(313366,8705,'zh','åå‘\r\n',0),(313367,8705,'sv','OmvÃ¤nd',0),(313368,8705,'it','Invertire',0),(313369,8705,'tl','',0),(313370,8705,'th','&#3585;&#3621;&#3633;&#3610;&#3604;&#3657;&#3634;&#3609;',0),(313371,8705,'hi','à¤°à¤¿à¤µà¤°à¥à¤¸',0),(313372,8705,'ms','Belakang',0),(313373,8705,'ar','Ø¹ÙƒØ³',0),(313374,8705,'fr','Inverser',0),(313375,8705,'jp','ãƒªãƒãƒ¼ã‚¹',0),(313376,8705,'pt','Inverter',0),(313377,8705,'ru','Ð ÐµÐ²ÐµÑ€Ñ',0),(313378,8705,'es','Reversar',0),(313379,8705,'de','RÃ¼ckseite',0),(313380,8705,'en','Reverse',0),(313381,8706,'is','',0),(313382,8706,'dr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313383,8706,'pr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313384,8706,'tr','Kredi kartÄ± SatÄ±nalmalar listesi',0),(313385,8706,'pl','Lista zakupÃ³w kartÄ… kredytowÄ…',0),(313386,8706,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(313387,8706,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø³ÙˆØ¯ÙˆÚº Ú©ÛŒ ÙÛØ±Ø³Øª',0),(313388,8706,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(313389,8706,'vi','Danh SÃ¡ch Giao Dá»‹ch Mua HÃ ng Qua Tháº» TÃ­n Dá»¥ng',0),(313390,8706,'af','Kredietkaartaankope Lys',0),(313391,8706,'ro','Lista de achiziÅ£ii Card de credit',0),(313392,8706,'et','Krediitkaardiga ostude nimekirja',0),(313393,8706,'si','Kreditne kartice nakupe seznam',0),(313394,8706,'ba','Kartu kredit pembelian daftar',0),(313395,8706,'nl','Credit Card aankopen lijst',0),(313396,8706,'fi','Luottokortti ostot luettelo',0),(313397,8706,'no','Kredittkort kjÃ¸p liste',0),(313398,8706,'da','Kreditkort KÃ¸b liste',0),(313399,8706,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ ëª©ë¡',0),(313400,8706,'he','×¨×©×™×ž×ª ×”×¨×›×™×©×•×ª ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(313401,8706,'el','Î›Î¯ÏƒÏ„Î± Î±Î³Î¿ÏÎ­Ï‚ Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(313402,8706,'zh','ä¿¡ç”¨å¡è´­ä¹°åå•\r\n',0),(313403,8706,'sv','Kreditkort inkÃ¶p lista',0),(313404,8706,'it','Elenco acquisti di carta di credito',0),(313405,8706,'tl','',0),(313406,8706,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(313407,8706,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦ à¤¸à¥‚à¤šà¥€',0),(313408,8706,'ms','Senarai pembelian kad kredit',0),(313409,8706,'ar','Ù‚Ø§Ø¦Ù…Ø© Ù…Ø´ØªØ±ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(313410,8706,'fr','Liste d\'achats de carte de crÃ©dit',0),(313411,8706,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰è³¼å…¥ã®ãƒªã‚¹ãƒˆ',0),(313412,8706,'pt','Lista de compras do cartÃ£o de crÃ©dito',0),(313413,8706,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(313414,8706,'es','Tarjeta de CrÃ©dito Lista de Compras',0),(313415,8706,'de','Kreditkarten EinkÃ¤ufe Liste',0),(313416,8706,'en','Credit Card Purchases List',0),(313417,8707,'is','',0),(313418,8707,'dr','Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†ÙŠØ³Øª ',0),(313419,8707,'pr','Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†ÙŠØ³Øª ',0),(313420,8707,'tr','TasarÄ± Ã¼zerinde deÄŸil',0),(313421,8707,'pl','Nie na rachunek',0),(313422,8707,'bg','ÐÐµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð°',0),(313423,8707,'ur','Ø¨Ù„ Ù¾Ø± Ù†ÛÛŒÚº',0),(313424,8707,'sr','ÐÐµ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(313425,8707,'vi','KhÃ´ng CÃ³ TrÃªn HÃ³a ÄÆ¡n',0),(313426,8707,'af','Nie op die Wetsontwerp',0),(313427,8707,'ro','Nu pe factura',0),(313428,8707,'et','Mitte arvel',0),(313429,8707,'si','Ne na raÄun',0),(313430,8707,'ba','Tidak tagihan',0),(313431,8707,'nl','Niet op factuur',0),(313432,8707,'fi','Ei laskussa',0),(313433,8707,'no','Ikke pÃ¥ Bill',0),(313434,8707,'da','Ikke pÃ¥ Bill',0),(313435,8707,'ko','ë¹Œì—',0),(313436,8707,'he','×œ× ×¢×œ ×—×©×‘×•×Ÿ',0),(313437,8707,'el','ÎŒÏ‡Î¹ ÏƒÏ„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(313438,8707,'zh','ä¸åœ¨å¸å•ä¸Š\r\n',0),(313439,8707,'sv','Inte pÃ¥ Bill',0),(313440,8707,'it','Non su Bill',0),(313441,8707,'tl','',0),(313442,8707,'th','&#3652;&#3617;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3610;&#3636;&#3621;',0),(313443,8707,'hi','à¤¬à¤¿à¤² à¤ªà¤° à¤¨à¤¹à¥€à¤‚',0),(313444,8707,'ms','Bukan pada Rang undang-undang',0),(313445,8707,'ar','Ù„Ø§ ÙÙŠ Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ†',0),(313446,8707,'fr','Pas sur la facture',0),(313447,8707,'jp','æ³•æ¡ˆã§ã¯ãªã',0),(313448,8707,'pt','NÃ£o, na conta',0),(313449,8707,'ru','ÐÐµ Ð½Ð° Ð‘Ð¸Ð»Ð»Ð°',0),(313450,8707,'es','No en el Recibo',0),(313451,8707,'de','Nicht auf Rechnung',0),(313452,8707,'en','Not on Bill',0),(313453,8708,'is','',0),(313454,8708,'dr','Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(313455,8708,'pr','Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(313456,8708,'tr','TasarÄ± Ã¼zerinde',0),(313457,8708,'pl','Na rachunku',0),(313458,8708,'bg','ÐÐ° ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð°',0),(313459,8708,'ur','Ø¨Ù„ Ù¾Ø±',0),(313460,8708,'sr','ÐÐ° Ñ€Ð°Ñ‡ÑƒÐ½',0),(313461,8708,'vi','TrÃªn hÃ³a Ä‘Æ¡n',0),(313462,8708,'af','Op die Wetsontwerp',0),(313463,8708,'ro','Pe factura',0),(313464,8708,'et','Arve',0),(313465,8708,'si','Na raÄun',0),(313466,8708,'ba','Pada tagihan',0),(313467,8708,'nl','Over Bill',0),(313468,8708,'fi','Bill',0),(313469,8708,'no','PÃ¥ Bill',0),(313470,8708,'da','PÃ¥ Bill',0),(313471,8708,'ko','ì²­êµ¬ì„œì—',0),(313472,8708,'he','×¢×œ ×‘×™×œ',0),(313473,8708,'el','Î£Ï‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(313474,8708,'zh','å¸å•\r\n',0),(313475,8708,'sv','PÃ¥ faktura',0),(313476,8708,'it','Su Bill',0),(313477,8708,'tl','',0),(313478,8708,'th','&#3651;&#3609;&#3610;&#3636;&#3621;',0),(313479,8708,'hi','à¤¬à¤¿à¤² à¤ªà¤°',0),(313480,8708,'ms','Bil',0),(313481,8708,'ar','ÙÙŠ Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ†',0),(313482,8708,'fr','Le projet de loi',0),(313483,8708,'jp','è«‹æ±‚æ›¸ã«',0),(313484,8708,'pt','Na conta',0),(313485,8708,'ru','ÐÐ° ÑÑ‡ÐµÑ‚',0),(313486,8708,'es','En el Recibo',0),(313487,8708,'de','Auf Rechnung',0),(313488,8708,'en','On Bill',0),(313489,8709,'is','',0),(313490,8709,'dr','Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø¨Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(313491,8709,'pr','Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø¨Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(313492,8709,'tr','Fatura gÃ¶nderildi',0),(313493,8709,'pl','ZaksiÄ™gowane na rachunku',0),(313494,8709,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾ Ð½Ð° Ð±Ð¸Ð»',0),(313495,8709,'ur','Ø¨Ù„ Ù…ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(313496,8709,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(313497,8709,'vi','Káº¿t Chuyá»ƒn Sang Láº­p HÃ³a ÄÆ¡n',0),(313498,8709,'af','Wetsontwerp by',0),(313499,8709,'ro','AdÄƒugatÄƒ la factura',0),(313500,8709,'et','Konteeritud arve',0),(313501,8709,'si','Objavljeno v Bill',0),(313502,8709,'ba','Dikirim ke tagihan',0),(313503,8709,'nl','Geplaatst op Bill',0),(313504,8709,'fi','LÃ¤hetetty lasku',0),(313505,8709,'no','Postert til Bill',0),(313506,8709,'da','Sendt til Bill',0),(313507,8709,'ko','ë¹Œì— ê²Œì‹œ ë¨',0),(313508,8709,'he','×¤×•×¨×¡× ×œ×‘×™×œ',0),(313509,8709,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®Î¸Î·ÎºÎµ ÏƒÏ„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(313510,8709,'zh','å‘å¸ƒåˆ°å¸å•\r\n',0),(313511,8709,'sv','Postat till Bill',0),(313512,8709,'it','Inviato da Bill',0),(313513,8709,'tl','',0),(313514,8709,'th','&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3652;&#3611;&#3618;&#3633;&#3591;&#3610;&#3636;&#3621;&#3649;&#3621;&#3657;&#3623;',0),(313515,8709,'hi','à¤¬à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(313516,8709,'ms','Kepada Rang undang-undang',0),(313517,8709,'ar','Ø£Ø±Ø³Ù„Øª Ø¥Ù„Ù‰ Ø¨ÙŠÙ„',0),(313518,8709,'fr','AffectÃ© au projet de loi',0),(313519,8709,'jp','è«‹æ±‚æ›¸ã«æŽ²ç¤ºã•ã‚Œã¾ã™ã€‚',0),(313520,8709,'pt','Postado para Bill',0),(313521,8709,'ru','Ð’Ñ‹Ð²ÐµÑˆÐµÐ½Ð¾ Ð‘Ð¸Ð»Ð»',0),(313522,8709,'es','Asentado a Recibo',0),(313523,8709,'de','Posted to Bill',0),(313524,8709,'en','Posted to Bill',0),(313525,8710,'is','',0),(313526,8710,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ø´Ø¯Ù‡ Ø§Ø² ',0),(313527,8710,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ø´Ø¯Ù‡ Ø§Ø² ',0),(313528,8710,'tr','SatÄ±n',0),(313529,8710,'pl','Zakupione od',0),(313530,8710,'bg','Ð—Ð°ÐºÑƒÐ¿ÐµÐ½ Ð¾Ñ‚',0),(313531,8710,'ur','Ø³Û’ Ø®Ø±ÛŒØ¯Û’',0),(313532,8710,'sr','ÐšÑƒÐ¿Ñ™ÐµÐ½Ðµ Ð¾Ð´',0),(313533,8710,'vi','Mua tá»«',0),(313534,8710,'af','Aangekoop Vanaf',0),(313535,8710,'ro','AchiziÅ£ionate de la',0),(313536,8710,'et','Ostetud',0),(313537,8710,'si','Kupljene od',0),(313538,8710,'ba','Dibeli dari',0),(313539,8710,'nl','Gekocht bij',0),(313540,8710,'fi','Ostettu',0),(313541,8710,'no','KjÃ¸pt fra',0),(313542,8710,'da','KÃ¸bt fra',0),(313543,8710,'ko','êµ¬ìž…',0),(313544,8710,'he','× ×¨×›×© ×ž××ª',0),(313545,8710,'el','Î‘Î³Î¿ÏÎ¬Î¶Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ',0),(313546,8710,'zh','è´­ä¹°\r\n',0),(313547,8710,'sv','KÃ¶pt frÃ¥n',0),(313548,8710,'it','Acquistato da',0),(313549,8710,'tl','',0),(313550,8710,'th','&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;',0),(313551,8710,'hi','à¤¸à¥‡ à¤–à¤°à¥€à¤¦à¥€',0),(313552,8710,'ms','Dibeli daripada',0),(313553,8710,'ar','ØªÙ… Ø´Ø±Ø§Ø¤Ù‡Ø§ Ù…Ù†',0),(313554,8710,'fr','AchetÃ© chez',0),(313555,8710,'jp','è³¼å…¥',0),(313556,8710,'pt','Comprado de',0),(313557,8710,'ru','ÐšÑƒÐ¿Ð¸Ð» Ð¾Ñ‚',0),(313558,8710,'es','Comprado de',0),(313559,8710,'de','Gekaufte',0),(313560,8710,'en','Purchased From',0),(313561,8711,'is','',0),(313562,8711,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø¨Ø§Ø·Ù„ Ù‡Ø§',0),(313563,8711,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø¨Ø§Ø·Ù„ Ù‡Ø§',0),(313564,8711,'tr','Sadece boÅŸluklarÄ± gÃ¶ster',0),(313565,8711,'pl','PokaÅ¼ wyrobiskach tylko',0),(313566,8711,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÐºÑƒÑ…Ð¸Ð½Ð¸',0),(313567,8711,'ur','ØµØ±Ù Ø¯Ø±Ø¬Ø§Øª Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(313568,8711,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ð°.',0),(313569,8711,'vi','Chá»‰ Hiá»ƒn thá»‹ há»§y',0),(313570,8711,'af','Wys enigste leemtes',0),(313571,8711,'ro','AratÄƒ doar golurile',0),(313572,8711,'et','NÃ¤ita ainult tÃ¼himike',0),(313573,8711,'si','PokaÅ¾i samo praznin',0),(313574,8711,'ba','Tampilkan hanya void',0),(313575,8711,'nl','Toon alleen vernietigt',0),(313576,8711,'fi','NÃ¤ytÃ¤ vain mitÃ¤tÃ¶i',0),(313577,8711,'no','Vis bare tomrom',0),(313578,8711,'da','Vis kun hulrum',0),(313579,8711,'ko','í‘œì‹œë§Œ ë¹„ìš´ ë‹¤',0),(313580,8711,'he','×”×¦×’ ×¨×§ ×—×œ×œ×™×',0),(313581,8711,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ ÎºÎµÎ½Î¬',0),(313582,8711,'zh','ä»…æ˜¾ç¤ºæ— æ•ˆé¡¹\r\n',0),(313583,8711,'sv','Visa endast hÃ¥ligheter',0),(313584,8711,'it','Visualizza solo vuoti',0),(313585,8711,'tl','',0),(313586,8711,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3607;&#3637;&#3656;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;',0),(313587,8711,'hi','à¤•à¥‡à¤µà¤² Voids à¤¦à¤¿à¤–à¤¾à¤à¤',0),(313588,8711,'ms','Menunjukkan hanya lompang',0),(313589,8711,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙØ±Ø§ØºØ§Øª ÙÙ‚Ø·',0),(313590,8711,'fr','Spectacle annule uniquement',0),(313591,8711,'jp','ãƒœã‚¤ãƒ‰ã ã‘ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(313592,8711,'pt','Mostrar apenas vazios',0),(313593,8711,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ',0),(313594,8711,'es','Mostrar Solo Anulados',0),(313595,8711,'de','Zeigen nur HohlrÃ¤ume',0),(313596,8711,'en','Show Only Voids',0),(313597,8712,'is','',0),(313598,8712,'dr','Ú†Ù‡ ÙƒØ³ÙŠ Ø®Ø±ÙŠØ¯ ',0),(313599,8712,'pr','Ú†Ù‡ ÙƒØ³ÙŠ Ø®Ø±ÙŠØ¯ ',0),(313600,8712,'tr','Kim satÄ±n aldÄ±',0),(313601,8712,'pl','Kto kupiÅ‚',0),(313602,8712,'bg','ÐšÐ¾Ð¹Ñ‚Ð¾ ÑÐ¸ ÐºÑƒÐ¿Ð¸Ð»',0),(313603,8712,'ur','Ø¬Ùˆ Ø®Ø±ÛŒØ¯Û’',0),(313604,8712,'sr','ÐšÐ¾ Ñ˜Ðµ ÐºÑƒÐ¿Ð¸Ð¾',0),(313605,8712,'vi','Ai Ä‘Ã£ mua',0),(313606,8712,'af','Wie Het Aangekoop',0),(313607,8712,'ro','Care a achizitionat',0),(313608,8712,'et','Kes ostis',0),(313609,8712,'si','Ki kupili',0),(313610,8712,'ba','Yang dibeli',0),(313611,8712,'nl','Die gekocht',0),(313612,8712,'fi','Jotka ovat ostaneet',0),(313613,8712,'no','Hvem kjÃ¸pt',0),(313614,8712,'da','Der kÃ¸bes',0),(313615,8712,'ko','ëˆ„ê°€ êµ¬ë§¤',0),(313616,8712,'he','×ž×™ ×¨×›×©',0),(313617,8712,'el','Î Î¿Ï… Î±Î³Î¿ÏÎ¬Î¶Î¿Î½Ï„Î±Î¹',0),(313618,8712,'zh','è°è´­ä¹°\r\n',0),(313619,8712,'sv','Som kÃ¶pt',0),(313620,8712,'it','Che acquistato',0),(313621,8712,'tl','',0),(313622,8712,'th','&#3651;&#3588;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(313623,8712,'hi','à¤œà¥‹ à¤–à¤°à¥€à¤¦à¥€',0),(313624,8712,'ms','Yang dibeli',0),(313625,8712,'ar','Ø§Ù„Ø°ÙŠÙ† Ø§Ø´ØªØ±ÙˆØ§',0),(313626,8712,'fr','Qui a achetÃ©',0),(313627,8712,'jp','èª°ãŒè³¼å…¥',0),(313628,8712,'pt','Quem comprou',0),(313629,8712,'ru','ÐšÑ‚Ð¾ ÐºÑƒÐ¿Ð¸Ð»',0),(313630,8712,'es','Quien ComprÃ³',0),(313631,8712,'de','Gekauft',0),(313632,8712,'en','Who Purchased',0),(313633,8713,'is','',0),(313634,8713,'dr','ØªØ¹ÙŠÙŠÙ† Ø§ÙŠÙ†ÙƒÙ‡ ÙƒØ¯Ø§Ù… Ø®Ø±ÙŠØ¯Ù‡Ø§ ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø³ØªÙ†Ø¯',0),(313635,8713,'pr','ØªØ¹ÙŠÙŠÙ† Ø§ÙŠÙ†ÙƒÙ‡ ÙƒØ¯Ø§Ù… Ø®Ø±ÙŠØ¯Ù‡Ø§ ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø³ØªÙ†Ø¯',0),(313636,8713,'tr','TasarÄ± Ã¼zerinde kredi kartÄ± SatÄ±nalmalar olan atama',0),(313637,8713,'pl','PrzypisaÄ‡ co zakup kartÄ… kredytowÄ… sÄ… na rachunku',0),(313638,8713,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð¸Ñ‚Ð¾ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(313639,8713,'ur','Ø¬Ùˆ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø³ÙˆØ¯ÙˆÚº Ø¨Ù„ Ù¾Ø± ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(313640,8713,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ ÐºÐ¾Ñ˜Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ðµ ÑÑƒ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(313641,8713,'vi','Chá»‰ Äá»‹nh Loáº¡i Tháº» TÃ­n Dá»¥ng DÃ¹ng Thanh ToÃ¡n',0),(313642,8713,'af','*** Watter Kredietkaartaankope is op Faktuur',0),(313643,8713,'ro','AsociaÅ£i care Card de Credit cumpÄƒrÄƒri sunt Bill',0),(313644,8713,'et','MÃ¤Ã¤rata arvel olevad krediitkaardiga ostude',0),(313645,8713,'si','Dodeliti za katere nakup s kreditno kartico raÄun',0),(313646,8713,'ba','Menetapkan kartu kredit pembelian yang tagihan',0),(313647,8713,'nl','Toewijzen die creditcardaankopen op Bill',0),(313648,8713,'fi','MÃ¤Ã¤ritÃ¤ mikÃ¤ luottokorttiostoissa on Bill',0),(313649,8713,'no','Tilordne som kredittkort pÃ¥ Bill',0),(313650,8713,'da','Tildele som kreditkort kÃ¸b pÃ¥ regning',0),(313651,8713,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ ë¹Œì— ìžˆëŠ” í• ë‹¹',0),(313652,8713,'he','×œ×”×§×¦×•×ª ××©×¨ ×¨×›×™×©×•×ª ×‘×›×¨×˜×™×¡×™ ××©×¨××™ ×¢×œ ×—×©×‘×•×Ÿ',0),(313653,8713,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ Ï€Î¿Ï… Î±Î³Î¿ÏÎ­Ï‚ Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÏƒÏ„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(313654,8713,'zh','æŒ‡å®šæŸä¸ªä¿¡ç”¨å¡ä½œä¸ºæ¬ è´¦ä»˜æ¬¾',0),(313655,8713,'sv','Tilldela som kreditkortskÃ¶p Ã¤r Bill',0),(313656,8713,'it','Assegnare che gli acquisti di carta di credito sono su Bill',0),(313657,8713,'tl','',0),(313658,8713,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3623;&#3656;&#3634;&#3651;&#3594;&#3657;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3652;&#3627;&#3609;&#3651;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3610;&#3',0),(313659,8713,'hi','à¤œà¥‹ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤–à¤°à¥€à¤¦ à¤ªà¤° à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤¹à¥ˆà¤‚ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(313660,8713,'ms','Peruntukkan yang pembelian kad kredit pada Rang undang-undang',0),(313661,8713,'ar','ØªØ¹ÙŠÙŠÙ† Ù‡ÙŠ Ù…Ø´ØªØ±ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¹Ù„Ù‰ Ø¨ÙŠÙ„',0),(313662,8713,'fr','Assigner qui sont des achats par carte de crÃ©dit sur facture',0),(313663,8713,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è³¼å…¥ã«ãªã£ã¦ã„ã‚‹æ³•æ¡ˆã‚’å‰²ã‚Šå½“ã¦ã‚‹',0),(313664,8713,'pt','Atribuir que compras com cartÃ£o de crÃ©dito na conta',0),(313665,8713,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ ÐºÐ°ÐºÐ¸Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð½Ð° ÑÑ‡ÐµÑ‚',0),(313666,8713,'es','Asignar cuales Compras de Tarjeta de CrÃ©dito esta en la Factura',0),(313667,8713,'de','Weisen Sie die KreditkartenkÃ¤ufe auf Rechnung',0),(313668,8713,'en','Assign Which Credit Card Purchases are on Bill',0),(313669,8714,'is','',0),(313670,8714,'dr','(Ø´Ø§Ø±Ú˜) ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313671,8714,'pr','Ù†ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡(Ø´Ø§Ø±Ú˜) ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313672,8714,'tr','Kredi kartÄ± Ã¼cret tÃ¼rÃ¼',0),(313673,8714,'pl','Karta kredytowa za typ',0),(313674,8714,'bg','Ð¢Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ñ‚Ð°ÐºÑÐ°',0),(313675,8714,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú†Ø§Ø±Ø¬ Ú©ÛŒ Ù‚Ø³Ù…',0),(313676,8714,'sr','Ð“Ð»Ð°Ð²Ð½Ð¸ Ñ‚Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(313677,8714,'vi','Loáº¡i phÃ­ Tháº» tÃ­n dá»¥ng',0),(313678,8714,'af','Kredietkaarte Fooi Tipe',0),(313679,8714,'ro','Tip de taxa de carduri de credit',0),(313680,8714,'et','Krediitkaardi tasu tÃ¼Ã¼p',0),(313681,8714,'si','Vrsto dajatev kreditno kartico',0),(313682,8714,'ba','Jenis biaya kartu kredit',0),(313683,8714,'nl','Type van creditcard Charge',0),(313684,8714,'fi','Luottokortti maksun tyyppi',0),(313685,8714,'no','Gratis kredittkorttype',0),(313686,8714,'da','Kreditkort gebyr Type',0),(313687,8714,'ko','ì‹ ìš© ì¹´ë“œ ì¶©ì „ ìž…ë ¥',0),(313688,8714,'he','×¡×•×’ ×—×™×•×‘ ×›×¨×˜×™×¡ ××©×¨××™',0),(313689,8714,'el','Î¤ÏÏ€Î¿Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(313690,8714,'zh','ä¿¡ç”¨å¡è´¹ç”¨ç±»åž‹\r\n',0),(313691,8714,'sv','Avgift fÃ¶r kreditkortstyp',0),(313692,8714,'it','Tipo di pagamento carta di credito',0),(313693,8714,'tl','',0),(313694,8714,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(313695,8714,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥à¤²à¥à¤• à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(313696,8714,'ms','Jenis caj kad kredit',0),(313697,8714,'ar','Ù†ÙˆØ¹ Ø±Ø³ÙˆÙ… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(313698,8714,'fr','Type de frais de carte de crÃ©dit',0),(313699,8714,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ–™é‡‘ã®ç¨®é¡ž',0),(313700,8714,'pt','Tipo de carga do cartÃ£o de crÃ©dito',0),(313701,8714,'ru','Ð¢Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(313702,8714,'es','Tarjeta de CrÃ©dito Tipo de Cargo',0),(313703,8714,'de','Kreditkarte kostenlos-Typ',0),(313704,8714,'en','Credit Card Charge Type',0),(313705,8715,'is','',0),(313706,8715,'dr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313707,8715,'pr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313708,8715,'tr','Kredi kartÄ± SatÄ±nalmalar',0),(313709,8715,'pl','Zakup kartÄ… kredytowÄ…',0),(313710,8715,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(313711,8715,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(313712,8715,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ðµ',0),(313713,8715,'vi','Mua Qua Tháº» TÃ­n Dá»¥ng',0),(313714,8715,'af','Kredietkaartaankope',0),(313715,8715,'ro','Card de credit cumpÄƒrÄƒri',0),(313716,8715,'et','Krediidkaardi ostud',0),(313717,8715,'si','Nakup s kreditno kartico',0),(313718,8715,'ba','Kartu kredit pembelian',0),(313719,8715,'nl','Credit Card aankopen',0),(313720,8715,'fi','Luottokorttiostoissa',0),(313721,8715,'no','Kredittkort',0),(313722,8715,'da','Kreditkort kÃ¸b',0),(313723,8715,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤',0),(313724,8715,'he','×¨×›×™×©×•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(313725,8715,'el','Î‘Î³Î¿ÏÎ­Ï‚ Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(313726,8715,'zh','ä¿¡ç”¨å¡è´­ä¹°\r\n',0),(313727,8715,'sv','KreditkortskÃ¶p',0),(313728,8715,'it','Acquisti di carta di credito',0),(313729,8715,'tl','',0),(313730,8715,'th','&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(313731,8715,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤–à¤°à¥€à¤¦',0),(313732,8715,'ms','Pembelian kad kredit',0),(313733,8715,'ar','Ù…Ø´ØªØ±ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(313734,8715,'fr','Achats par carte de crÃ©dit',0),(313735,8715,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è³¼å…¥',0),(313736,8715,'pt','Compras com cartÃ£o de crÃ©dito',0),(313737,8715,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(313738,8715,'es','Tarjeta de CrÃ©dito Compras',0),(313739,8715,'de','KreditkarteneinkÃ¤ufe',0),(313740,8715,'en','Credit Card Purchases',0),(313741,8716,'is','',0),(313742,8716,'dr','Ø±Ø¯ÙŠØ§Ø¨ÙŠ Ø®Ø±ÙŠØ¯ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313743,8716,'pr','Ø±Ø¯ÙŠØ§Ø¨ÙŠ Ø®Ø±ÙŠØ¯ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313744,8716,'tr','Kredi kartÄ± satÄ±nalma izleme',0),(313745,8716,'pl','Zakup kartÄ… kredytowÄ…, Å›ledzenia',0),(313746,8716,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(313747,8716,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Ø§ Ú©Ú¾ÙˆØ¬ Ù„Ú¯Ø§Ù†Ø§',0),(313748,8716,'sr','ÐŸÑ€Ð°Ñ›ÐµÑšÐµ Ð½Ð°Ð±Ð°Ð²ÐºÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(313749,8716,'vi','TÃ¬m CÃ¡c Giao Dá»‹ch Mua Qua Tháº» TÃ­n Dá»¥ng',0),(313750,8716,'af','Kredietkaartaankope Opsporing',0),(313751,8716,'ro','Card de credit de cumpÄƒrare de urmÄƒrire',0),(313752,8716,'et','Krediitkaardi ostu jÃ¤lgimine',0),(313753,8716,'si','Nakup kreditni kartici sledenje',0),(313754,8716,'ba','Kartu kredit pembelian pelacakan',0),(313755,8716,'nl','Creditcard aankoop bijhouden',0),(313756,8716,'fi','Luottokortti ostojen seuranta',0),(313757,8716,'no','Kredittkort kjÃ¸p sporing',0),(313758,8716,'da','Kreditkort KÃ¸b Tracking',0),(313759,8716,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ ì¶”ì ',0),(313760,8716,'he','×ž×¢×§×‘ ×¨×›×™×©×•×ª ×›×¨×˜×™×¡×™ ××©×¨××™',0),(313761,8716,'el','Î‘Î³Î¿ÏÎ¬ Î¼Î­ÏƒÏ‰ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚',0),(313762,8716,'zh','ä¿¡ç”¨å¡è´­ä¹°è¿½è¸ª\r\n',0),(313763,8716,'sv','Kreditkort kÃ¶p spÃ¥rning',0),(313764,8716,'it','Acquisto di carta di credito di rilevamento',0),(313765,8716,'tl','',0),(313766,8716,'th','&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(313767,8716,'hi','à¤ªà¤° à¤¨à¤œà¤¼à¤° à¤°à¤–à¤¨à¥‡ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦',0),(313768,8716,'ms','Pembelian kad kredit yang Penjejakan',0),(313769,8716,'ar','Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„ØªÙŠ ØªØªØ¨Ø¹',0),(313770,8716,'fr','Achat de carte de crÃ©dit de suivi',0),(313771,8716,'jp','è¿½è·¡ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã§è³¼å…¥',0),(313772,8716,'pt','CartÃ£o de crÃ©dito compra de rastreamento',0),(313773,8716,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(313774,8716,'es','Tarjeta de CrÃ©dito Rastreando Compras',0),(313775,8716,'de','Kreditkartenkauf Tracking',0),(313776,8716,'en','Credit Card Purchase Tracking',0),(313777,8717,'is','',0),(313778,8717,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313779,8717,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313780,8717,'tr','Kredi kartÄ± faturalarÄ± DÃ¼zenle',0),(313781,8717,'pl','Edytuj rachunki kart kredytowych',0),(313782,8717,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(313783,8717,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø¨Ù„ÙˆÚº Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(313784,8717,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(313785,8717,'vi','Sá»­a HÃ³a ÄÆ¡n Tháº» TÃ­n Dá»¥ng',0),(313786,8717,'af','Redigeer Kredietkaart Rekeninge',0),(313787,8717,'ro','Edita facturi Card de Credit',0),(313788,8717,'et','Redigeeri krediitkaardi arveid',0),(313789,8717,'si','Urejanje kreditne kartice menice',0),(313790,8717,'ba','Mengedit tagihan kartu kredit',0),(313791,8717,'nl','Bewerken van Credit Card rekeningen',0),(313792,8717,'fi','Muokkaa luottokortti laskut',0),(313793,8717,'no','Redigere kredittkort regninger',0),(313794,8717,'da','Redigere kreditkort regninger',0),(313795,8717,'ko','ì‹ ìš© ì¹´ë“œ ì²­êµ¬ì„œë¥¼ íŽ¸ì§‘',0),(313796,8717,'he','×¢×¨×•×š ×—×©×‘×•× ×•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(313797,8717,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(313798,8717,'zh','ä¿®æ”¹ä¿¡ç”¨å¡å¸å•\r\n',0),(313799,8717,'sv','Redigera kreditkort rÃ¤kningar',0),(313800,8717,'it','Modificare fatture della carta di credito',0),(313801,8717,'tl','',0),(313802,8717,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(313803,8717,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¬à¤¿à¤² à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(313804,8717,'ms','Edit bil kad kredit',0),(313805,8717,'ar','ØªØ­Ø±ÙŠØ± ÙÙˆØ§ØªÙŠØ± Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(313806,8717,'fr','Ã‰diter les factures de carte de crÃ©dit',0),(313807,8717,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è«‹æ±‚æ›¸ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(313808,8717,'pt','Editar contas de cartÃ£o de crÃ©dito',0),(313809,8717,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(313810,8717,'es','Editar Recibos de Tarjeta de CrÃ©dito',0),(313811,8717,'de','Kreditkarten-Rechnungen zu bearbeiten',0),(313812,8717,'en','Edit Credit Card Bills',0),(313813,8718,'is','',0),(313814,8718,'dr','Ø«Ø¨Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(313815,8718,'pr','Ø«Ø¨Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(313816,8718,'tr','Kredi kartÄ± faturalarÄ± girin',0),(313817,8718,'pl','Wpisz rachunki kart kredytowych',0),(313818,8718,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(313819,8718,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø¨Ù„ÙˆÚº Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(313820,8718,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°Ð¼Ð°',0),(313821,8718,'vi','Nháº­p HÃ³a Ä‘Æ¡n tháº» tÃ­n dá»¥ng',0),(313822,8718,'af','Invoer van Kredietkaart Rekeninge',0),(313823,8718,'ro','IntroduceÅ£i cardul facturile',0),(313824,8718,'et','Sisestage krediitkaardi arveid',0),(313825,8718,'si','Vnesite raÄune kreditnih kartic',0),(313826,8718,'ba','Masukkan tagihan kartu kredit',0),(313827,8718,'nl','Voert Credit Card rekeningen',0),(313828,8718,'fi','Anna luottokortti laskut',0),(313829,8718,'no','Angi kredittkort regninger',0),(313830,8718,'da','Indtast kreditkort regninger',0),(313831,8718,'ko','ì‹ ìš© ì¹´ë“œ ì²­êµ¬ì„œë¥¼ ìž…ë ¥',0),(313832,8718,'he','×”×›× ×¡ ×—×©×‘×•× ×•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(313833,8718,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(313834,8718,'zh','è¾“å…¥ä¿¡ç”¨å¡å¸å•',0),(313835,8718,'sv','Ange kreditkort rÃ¤kningar',0),(313836,8718,'it','Immettere fatture della carta di credito',0),(313837,8718,'tl','',0),(313838,8718,'th','&#3611;&#3657;&#3629;&#3609;&#3610;&#3636;&#3621;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(313839,8718,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¬à¤¿à¤² à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶',0),(313840,8718,'ms','Masukkan bil kad kredit',0),(313841,8718,'ar','Ø¥Ø¯Ø®Ø§Ù„ ÙÙˆØ§ØªÙŠØ± Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(313842,8718,'fr','Entrez des factures de carte de crÃ©dit',0),(313843,8718,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è«‹æ±‚æ›¸ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(313844,8718,'pt','Insira o cartÃ£o de crÃ©dito',0),(313845,8718,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÑ‡ÐµÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(313846,8718,'es','Introducir Recibos de Tarjetas de CrÃ©dito',0),(313847,8718,'de','Geben Sie Kreditkarten-Rechnungen',0),(313848,8718,'en','Enter Credit Card Bills',0),(313849,8719,'is','',0),(313850,8719,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙƒØ§Ø±ØªÙ‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313851,8719,'pr',' Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±ØªÙ‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313852,8719,'tr','Kredi kartlarÄ± girin/gÃ¼ncelleme',0),(313853,8719,'pl','WprowadÅº/Aktualizacja kart kredytowych',0),(313854,8719,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(313855,8719,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(313856,8719,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(313857,8719,'vi','Nháº­p/Cáº­p Nháº­t Tháº» TÃ­n Dá»¥ng',0),(313858,8719,'af','Invoer/Opdateer Kredietkaarte',0),(313859,8719,'ro','IntroduceÅ£i/actualizare carduri de Credit',0),(313860,8719,'et','Krediitkaardid sisestamine/ajakohastamine',0),(313861,8719,'si','Vnos/posodobitev kreditne kartice',0),(313862,8719,'ba','Masukkan/Perbarui kartu kredit',0),(313863,8719,'nl','Invoeren/bijwerken creditcards',0),(313864,8719,'fi','PÃ¤ivittÃ¤minen luottokortit',0),(313865,8719,'no','Angi/Oppdater kredittkort',0),(313866,8719,'da','Indtaste/opdatere kreditkort',0),(313867,8719,'ko','ì‹ ìš© ì¹´ë“œ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(313868,8719,'he','×”×›× ×¡/×¢×“×›×Ÿ ×›×¨×˜×™×¡×™ ××©×¨××™',0),(313869,8719,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(313870,8719,'zh','è¾“å…¥/æ›´æ–°ä¿¡ç”¨å¡',0),(313871,8719,'sv','Ange/uppdatera kreditkort',0),(313872,8719,'it','Inserire o aggiornare le carte di credito',0),(313873,8719,'tl','',0),(313874,8719,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(313875,8719,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(313876,8719,'ms','Masukkan/Kemaskini kad kredit',0),(313877,8719,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(313878,8719,'fr','Inscrire/mettre Ã  jour les cartes de crÃ©dit',0),(313879,8719,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®å…¥åŠ›/æ›´æ–°',0),(313880,8719,'pt','Inserir/atualizar os cartÃµes de crÃ©dito',0),(313881,8719,'ru','Ð’Ð²ÐµÑÑ‚Ð¸/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐšÐ°Ñ€Ñ‚Ñ‹',0),(313882,8719,'es','Introducir/Actualizar Tarjetas de CrÃ©dito',0),(313883,8719,'de','Geben Sie/Update Kreditkarten',0),(313884,8719,'en','Enter/Update Credit Cards',0),(313885,8720,'is','',0),(313886,8720,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø®Ø±ÙŠØ¯Ù‡Ø§ ',0),(313887,8720,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø®Ø±ÙŠØ¯Ù‡Ø§ ',0),(313888,8720,'tr','SatÄ±nalmalar girin/gÃ¼ncelleme',0),(313889,8720,'pl','WprowadÅº/aktualizacja zakupÃ³w',0),(313890,8720,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(313891,8720,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(313892,8720,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð½Ð°Ð±Ð°Ð²ÐºÐ¸',0),(313893,8720,'vi','Nháº­p/Cáº­p Nháº­t Giao Dá»‹ch Mua HÃ ng',0),(313894,8720,'af','Invoer/Opdateer Aankope',0),(313895,8720,'ro','IntroduceÅ£i/actualizare achiziÅ£ii',0),(313896,8720,'et','Ostu sisestamine/ajakohastamine',0),(313897,8720,'si','Vnos/posodobitev nakupi',0),(313898,8720,'ba','Masukkan/Update pembelian',0),(313899,8720,'nl','Invoeren/bijwerken aankopen',0),(313900,8720,'fi','PÃ¤ivittÃ¤minen ostot',0),(313901,8720,'no','Angi/Oppdater kjÃ¸p',0),(313902,8720,'da','Indtast/Opdater kÃ¸b',0),(313903,8720,'ko','êµ¬ë§¤ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(313904,8720,'he','×”×›× ×¡/×¢×“×›×Ÿ ×¨×›×™×©×•×ª',0),(313905,8720,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Î³Î¿ÏÏŽÎ½',0),(313906,8720,'zh','è¾“å…¥/æ›´æ–°é‡‡è´­',0),(313907,8720,'sv','Ange/uppdatera inkÃ¶p',0),(313908,8720,'it','Inserisci/Aggiorna gli acquisti',0),(313909,8720,'tl','',0),(313910,8720,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(313911,8720,'hi','à¤–à¤°à¥€à¤¦ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(313912,8720,'ms','Masukkan/Kemaskini pembelian',0),(313913,8720,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ù…Ø´ØªØ±ÙŠØ§Øª',0),(313914,8720,'fr','Inscrire/mettre Ã  jour des achats',0),(313915,8720,'jp','è³¼å…¥ã®å…¥åŠ›/æ›´æ–°',0),(313916,8720,'pt','Inserir/atualizar compras',0),(313917,8720,'ru','Ð’Ð²Ð¾Ð´/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(313918,8720,'es','Introducir/Actualizar Compras',0),(313919,8720,'de','Geben Sie/Update EinkÃ¤ufe',0),(313920,8720,'en','Enter/Update Purchases',0),(313921,8721,'is','',0),(313922,8721,'dr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(313923,8721,'pr','Ù„ÙŠØ³Øª Ù‡Ø§ÙŠÙŠ Ø§Ø² Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(313924,8721,'tr','Kredi kartÄ± SatÄ±nalmalar listesi',0),(313925,8721,'pl','Listy zakupÃ³w kartÄ… kredytowÄ…',0),(313926,8721,'bg','Ð¡Ð¿Ð¸ÑÑŠÑ†Ð¸ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(313927,8721,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(313928,8721,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð° ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°Ð¼Ð°',0),(313929,8721,'vi','Danh sÃ¡ch mua qua tháº» tÃ­n dá»¥ng ',0),(313930,8721,'af','Lys van Kredietkaart Aankope',0),(313931,8721,'ro','Listele de achiziÅ£ii de Card de Credit',0),(313932,8721,'et','Krediitkaardiga ostude nimekirja',0),(313933,8721,'si','Seznami nakup s kreditno kartico',0),(313934,8721,'ba','Daftar kartu kredit pembelian',0),(313935,8721,'nl','Lijsten van Credit Card aankopen',0),(313936,8721,'fi','Luettelo luottokorttiostoissa',0),(313937,8721,'no','Lister over kredittkortkjÃ¸p',0),(313938,8721,'da','Lister over kreditkort kÃ¸b',0),(313939,8721,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ì˜ ëª©ë¡',0),(313940,8721,'he','×¨×©×™×ž×•×ª ×©×œ ×¨×›×™×©×•×ª ×‘×›×¨×˜×™×¡×™ ××©×¨××™',0),(313941,8721,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹ Î±Î³Î¿ÏÎ­Ï‚ Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(313942,8721,'zh','ä¿¡ç”¨å¡è´­ä¹°åˆ—è¡¨\r\n',0),(313943,8721,'sv','Listor Ã¶ver kreditkortskÃ¶p',0),(313944,8721,'it','Elenchi degli acquisti di carta di credito',0),(313945,8721,'tl','',0),(313946,8721,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3604;&#3657;&#3623;&#3618;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(313947,8721,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤–à¤°à¥€à¤¦ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(313948,8721,'ms','Senarai pembelian kad kredit',0),(313949,8721,'ar','Ù‚Ø§Ø¦Ù…Ø© Ù…Ø´ØªØ±ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(313950,8721,'fr','Listes des achats par carte de crÃ©dit',0),(313951,8721,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰è³¼å…¥ã®ãƒªã‚¹ãƒˆ',0),(313952,8721,'pt','Listas de compras com cartÃ£o de crÃ©dito',0),(313953,8721,'ru','Ð¡Ð¿Ð¸ÑÐºÐ¸ Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(313954,8721,'es','Listas de Compras por Tarjeta de CrÃ©dito',0),(313955,8721,'de','Listen der KreditkartenkÃ¤ufe',0),(313956,8721,'en','Lists of Credit Card Purchases',0),(313957,8722,'is','',0),(313958,8722,'dr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(313959,8722,'pr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(313960,8722,'tr','CC SatÄ±nalmalar listesi',0),(313961,8722,'pl','Lista zakupÃ³w CC',0),(313962,8722,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° CC Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(313963,8722,'ur','CC Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(313964,8722,'sr','Ð¡Ð¿Ð¸ÑÐ°Ðº Ð¦Ð¦ Ð½Ð°Ð±Ð°Ð²ÐºÐ¸',0),(313965,8722,'vi','Danh sÃ¡ch mua qua tháº» tÃ­n dá»¥ng ',0),(313966,8722,'af','Lys van KK Aankope',0),(313967,8722,'ro','Lista de achiziÅ£ii CC',0),(313968,8722,'et','CC ostude loend',0),(313969,8722,'si','Seznam Kp nakupov',0),(313970,8722,'ba','Daftar pembelian CC',0),(313971,8722,'nl','Lijst van CC aankopen',0),(313972,8722,'fi','Luettelo CC ostoista',0),(313973,8722,'no','Liste over CC kjÃ¸p',0),(313974,8722,'da','Liste over CC kÃ¸b',0),(313975,8722,'ko','CC êµ¬ë§¤ ëª©ë¡',0),(313976,8722,'he','×¨×©×™×ž×ª ×”×¨×›×™×©×•×ª CC',0),(313977,8722,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿ Î±Î³Î¿ÏÏŽÎ½ CC',0),(313978,8722,'zh','ä¿¡ç”¨å¡é‡‡è´­åå•\r\n',0),(313979,8722,'sv','Lista Ã¶ver CC inkÃ¶p',0),(313980,8722,'it','Elenco degli acquisti CC',0),(313981,8722,'tl','',0),(313982,8722,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3626;&#3635;&#3648;&#3609;&#3634;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(313983,8722,'hi','CC à¤–à¤°à¥€à¤¦ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(313984,8722,'ms','Senarai pembelian CC',0),(313985,8722,'ar','Ù‚Ø§Ø¦Ù…Ø© Ù…Ø´ØªØ±ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(313986,8722,'fr','Liste d\'achats CC',0),(313987,8722,'jp','CC è³¼å…¥ã®ãƒªã‚¹ãƒˆ',0),(313988,8722,'pt','Lista de compras CC',0),(313989,8722,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº CC',0),(313990,8722,'es','Lista de Compras de Tarjeta',0),(313991,8722,'de','Liste der CC-EinkÃ¤ufe',0),(313992,8722,'en','List of CC Purchases',0),(313993,8723,'is','',0),(313994,8723,'dr','ÙƒØ§Ø±ØªÙ‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313995,8723,'pr','ÙƒØ§Ø±ØªÙ‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(313996,8723,'tr','Kredi kartlarÄ±',0),(313997,8723,'pl','Karty kredytowe',0),(313998,8723,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(313999,8723,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ',0),(314000,8723,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(314001,8723,'vi','Tháº» tÃ­n dá»¥ng',0),(314002,8723,'af','Kredietkaarte',0),(314003,8723,'ro','Carduri de credit',0),(314004,8723,'et','Maksekaardid',0),(314005,8723,'si','Kreditne kartice',0),(314006,8723,'ba','Kartu kredit',0),(314007,8723,'nl','Credit Cards',0),(314008,8723,'fi','Luottokortit',0),(314009,8723,'no','Kredittkort',0),(314010,8723,'da','Kreditkort',0),(314011,8723,'ko','ì‹ ìš© ì¹´ë“œ',0),(314012,8723,'he','×›×¨×˜×™×¡×™ ××©×¨××™',0),(314013,8723,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(314014,8723,'zh','ä¿¡ç”¨å¡\r\n',0),(314015,8723,'sv','Kreditkort',0),(314016,8723,'it','Carte di credito',0),(314017,8723,'tl','',0),(314018,8723,'th','&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(314019,8723,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡',0),(314020,8723,'ms','Kad-kad kredit',0),(314021,8723,'ar','Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(314022,8723,'fr','Cartes de crÃ©dit',0),(314023,8723,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰',0),(314024,8723,'pt','CartÃµes de crÃ©dito',0),(314025,8723,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(314026,8723,'es','Tarjetas de CrÃ©dito',0),(314027,8723,'de','Kreditkarten',0),(314028,8723,'en','Credit Cards',0),(314029,8724,'is','',0),(314030,8724,'dr','(Ø´Ø§Ø±Ú˜) ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(314031,8724,'pr','Ø§Ù†ÙˆØ§Ø¹ Ù‡Ø²ÙŠÙ†Ù‡(Ø´Ø§Ø±Ú˜) ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(314032,8724,'tr','Kredi kartÄ± Ã¼cret tÃ¼rleri',0),(314033,8724,'pl','Karta kredytowa za typy',0),(314034,8724,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð²Ð¸Ð´Ð¾Ð²Ðµ',0),(314035,8724,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú†Ø§Ø±Ø¬ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(314036,8724,'sr','Ð’Ñ€ÑÑ‚Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(314037,8724,'vi','Loáº¡i phÃ­ Tháº» tÃ­n dá»¥ng',0),(314038,8724,'af','Kredietkaarte Fooi Tipes',0),(314039,8724,'ro','Tipuri de taxa de carduri de credit',0),(314040,8724,'et','Krediitkaardi tasu liigid',0),(314041,8724,'si','Vrste dajatev kreditno kartico',0),(314042,8724,'ba','Jenis biaya kartu kredit',0),(314043,8724,'nl','Creditcard Charge typen',0),(314044,8724,'fi','Luottokortin maksutyypit',0),(314045,8724,'no','Kredittkort kostnader typer',0),(314046,8724,'da','Kreditkort gebyr typer',0),(314047,8724,'ko','ì‹ ìš© ì¹´ë“œ ì¶©ì „ ì¢…ë¥˜',0),(314048,8724,'he','×¡×•×’×™ ×ª×©×œ×•× ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(314049,8724,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Ï„ÏÏ€Ï‰Î½ ÎµÏ€Î¹Î²Î±ÏÏÎ½ÏƒÎµÏ‰Î½',0),(314050,8724,'zh','ä¿¡ç”¨å¡æ”¶è´¹ç§ç±»\r\n',0),(314051,8724,'sv','Kreditkort avgift typer',0),(314052,8724,'it','Tipi di pagamento carta di credito',0),(314053,8724,'tl','',0),(314054,8724,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(314055,8724,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥à¤²à¥à¤• à¤ªà¥à¤°à¤•à¤¾à¤°',0),(314056,8724,'ms','Jenis-jenis caj kad kredit',0),(314057,8724,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø±Ø³ÙˆÙ… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(314058,8724,'fr','Types de frais de carte de crÃ©dit',0),(314059,8724,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ–™é‡‘ã®ç¨®é¡ž',0),(314060,8724,'pt','Tipos de carga do cartÃ£o de crÃ©dito',0),(314061,8724,'ru','Ð¢Ð¸Ð¿Ñ‹ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚ Ð·Ð°Ñ€ÑÐ´Ð°',0),(314062,8724,'es','Tarjeta de CrÃ©dito Tipos de Cargo',0),(314063,8724,'de','Kostenlos Kreditkarten',0),(314064,8724,'en','Credit Card Charge Types',0),(314065,8725,'is','',0),(314066,8725,'dr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(314067,8725,'pr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(314068,8725,'tr','CC alÄ±mlarÄ±',0),(314069,8725,'pl','CC zakupy',0),(314070,8725,'bg','CC Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(314071,8725,'ur','CC Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(314072,8725,'sr','Ð¦Ð¦ Ð½Ð°Ð±Ð°Ð²ÐºÐ¸',0),(314073,8725,'vi','Äá»“ng gá»­i NgÆ°á»i mua',0),(314074,8725,'af','KK Aankope',0),(314075,8725,'ro','CC achiziÅ£ii',0),(314076,8725,'et','CC ostud',0),(314077,8725,'si','CC nakupi',0),(314078,8725,'ba','Pembelian CC',0),(314079,8725,'nl','CC aankopen',0),(314080,8725,'fi','CC ostot',0),(314081,8725,'no','CC kjÃ¸p',0),(314082,8725,'da','CC kÃ¸b',0),(314083,8725,'ko','CC êµ¬ë§¤',0),(314084,8725,'he','×¨×›×™×©×•×ª CC',0),(314085,8725,'el','CC Î±Î³Î¿ÏÎ­Ï‚',0),(314086,8725,'zh','ä¿¡ç”¨å¡é‡‡è´­\r\n',0),(314087,8725,'sv','CC inkÃ¶p',0),(314088,8725,'it','Acquisti CC',0),(314089,8725,'tl','',0),(314090,8725,'th','&#3626;&#3635;&#3648;&#3609;&#3634;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(314091,8725,'hi','CC à¤–à¤°à¥€à¤¦',0),(314092,8725,'ms','Pembelian CC',0),(314093,8725,'ar','Ù…Ø´ØªØ±ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(314094,8725,'fr','Achats CC',0),(314095,8725,'jp','CC ã®è³¼å…¥',0),(314096,8725,'pt','Compras CC',0),(314097,8725,'ru','CC Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(314098,8725,'es','TC Compras',0),(314099,8725,'de','CC-EinkÃ¤ufe',0),(314100,8725,'en','CC Purchases',0),(314101,8726,'is','',0),(314102,8726,'dr','Ø§Ù†ÙˆØ§Ø¹ Ù‡Ø²ÙŠÙ†Ù‡',0),(314103,8726,'pr','Ø§Ù†ÙˆØ§Ø¹ Ù‡Ø²ÙŠÙ†Ù‡',0),(314104,8726,'tr','Ãœcret tÃ¼rÃ¼',0),(314105,8726,'pl','Rodzaje opÅ‚at',0),(314106,8726,'bg','Ð’Ð¸Ð´Ð¾Ð²Ðµ',0),(314107,8726,'ur','Ú†Ø§Ø±Ø¬ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(314108,8726,'sr','Ð“Ð»Ð°Ð²Ð½Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸',0),(314109,8726,'vi','Loáº¡i phÃ­',0),(314110,8726,'af','Beheer tipes',0),(314111,8726,'ro','Tipuri de taxa',0),(314112,8726,'et','Kulu tÃ¼Ã¼bid',0),(314113,8726,'si','Vrste dajatev',0),(314114,8726,'ba','Jenis biaya',0),(314115,8726,'nl','Gratis typen',0),(314116,8726,'fi','Maksutyypit',0),(314117,8726,'no','Gratis typer',0),(314118,8726,'da','Afgift typer',0),(314119,8726,'ko','ìš”ê¸ˆ ìœ í˜•',0),(314120,8726,'he','×¡×•×’×™ ×—×™×•×‘',0),(314121,8726,'el','Î¤ÏÏ€Ï‰Î½ ÎµÏ€Î¹Î²Î±ÏÏÎ½ÏƒÎµÏ‰Î½',0),(314122,8726,'zh','æ”¶è´¹ç±»åž‹\r\n',0),(314123,8726,'sv','Avgift typer',0),(314124,8726,'it','Tipi di carica',0),(314125,8726,'tl','',0),(314126,8726,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(314127,8726,'hi','à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(314128,8726,'ms','Jenis caj',0),(314129,8726,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø´Ø­Ù†',0),(314130,8726,'fr','Types de frais',0),(314131,8726,'jp','æ–™é‡‘ã‚¿ã‚¤ãƒ—',0),(314132,8726,'pt','Tipos de carga',0),(314133,8726,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð·Ð°Ñ€ÑÐ´Ð°',0),(314134,8726,'es','Tipos de Carga',0),(314135,8726,'de','Kostenlos-Typen',0),(314136,8726,'en','Charge Types',0),(314137,8727,'is','',0),(314138,8727,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(314139,8727,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(314140,8727,'tr','Yeni kredi kartÄ± faturalarÄ±',0),(314141,8727,'pl','Nowe rachunki kart kredytowych',0),(314142,8727,'bg','ÐÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(314143,8727,'ur','Ù†Ø¦Û’ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø¨Ù„Ø²',0),(314144,8727,'sr','ÐÐ¾Ð²Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(314145,8727,'vi','HÃ³a ÄÆ¡n Tháº» TÃ­n Dá»¥ng Má»›i',0),(314146,8727,'af','Nuwe Kredietkaart Rekeninge',0),(314147,8727,'ro','Noi facturile Card de Credit',0),(314148,8727,'et','Uue krediitkaardi arveid',0),(314149,8727,'si','Nove raÄune kreditnih kartic',0),(314150,8727,'ba','Tagihan kartu kredit baru',0),(314151,8727,'nl','Nieuwe Credit Card rekeningen',0),(314152,8727,'fi','Uusi luottokortti laskut',0),(314153,8727,'no','Nye kredittkort regninger',0),(314154,8727,'da','Nye kreditkort regninger',0),(314155,8727,'ko','ìƒˆë¡œìš´ ì‹ ìš© ì¹´ë“œ ìš”ê¸ˆ',0),(314156,8727,'he','×—×™×•×‘×™ ×›×¨×˜×™×¡ ××©×¨××™ ×—×“×©×™×',0),(314157,8727,'el','ÎÎ­Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(314158,8727,'zh','æ–°çš„ä¿¡ç”¨å¡ç¥¨æ®\r\n',0),(314159,8727,'sv','Nya kreditkort rÃ¤kningar',0),(314160,8727,'it','Nuove fatture della carta di credito',0),(314161,8727,'tl','',0),(314162,8727,'th','&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3651;&#3627;&#3617;&#3656;',0),(314163,8727,'hi','à¤¨à¤ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¬à¤¿à¤²',0),(314164,8727,'ms','Bil-bil kad kredit yang baru',0),(314165,8727,'ar','ÙÙˆØ§ØªÙŠØ± Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù† Ø¬Ø¯ÙŠØ¯Ø©',0),(314166,8727,'fr','Nouvelles factures de carte de crÃ©dit',0);
INSERT INTO `langdef` VALUES (314167,8727,'jp','æ–°ã—ã„ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è«‹æ±‚æ›¸',0),(314168,8727,'pt','Novas contas de cartÃ£o de crÃ©dito',0),(314169,8727,'ru','ÐÐ¾Ð²Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(314170,8727,'es','Nuevos Recibos de Tarjetas de CrÃ©dito',0),(314171,8727,'de','Neue Kreditkarten-Rechnungen',0),(314172,8727,'en','New Credit Card Bills',0),(314173,8728,'is','',0),(314174,8728,'dr','Ù…ÙØ§Ø¯Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(314175,8728,'pr','Ù…ÙØ§Ø¯Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(314176,8728,'tr','AmaÃ§ iÃ§in kullanÄ±lan',0),(314177,8728,'pl','Wykorzystywane do celÃ³w',0),(314178,8728,'bg','Ð¦ÐµÐ», Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð·Ð°',0),(314179,8728,'ur','Ù…Ù‚ØµØ¯ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(314180,8728,'sr','Ð¡Ð²Ñ€Ñ…Ñƒ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ðµ Ð·Ð°',0),(314181,8728,'vi','Má»¥c Ä‘Ã­ch dÃ¹ng cho',0),(314182,8728,'af','Doel gebruik vir',0),(314183,8728,'ro','Scop pentru',0),(314184,8728,'et','Selleks kasutatakse',0),(314185,8728,'si','Namen, ki se uporabljajo za',0),(314186,8728,'ba','Tujuan yang digunakan untuk',0),(314187,8728,'nl','Doel gebruikt voor',0),(314188,8728,'fi','Tarkoitus',0),(314189,8728,'no','FormÃ¥let som brukes For',0),(314190,8728,'da','FormÃ¥l bruges til',0),(314191,8728,'ko','ì‚¬ìš© ëª©ì ',0),(314192,8728,'he','×ž×˜×¨×” ×ž×©×ž×©',0),(314193,8728,'el','Î£ÎºÎ¿Ï€ÏŒÏ‚ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î±',0),(314194,8728,'zh','ç”¨é€”ä¸º\r\n',0),(314195,8728,'sv','Ã„ndamÃ¥l anvÃ¤nds fÃ¶r',0),(314196,8728,'it','Scopo utilizzato per',0),(314197,8728,'tl','',0),(314198,8728,'th','&#3648;&#3614;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(314199,8728,'hi','à¤‰à¤¦à¥à¤¦à¥‡à¤¶à¥à¤¯ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(314200,8728,'ms','Maksud yang digunakan untuk',0),(314201,8728,'ar','ØªØ³ØªØ®Ø¯Ù… Ù„Ù„ØºØ±Ø¶',0),(314202,8728,'fr','Objet utilisÃ© pour',0),(314203,8728,'jp','ä½¿ç”¨ã™ã‚‹ç›®çš„',0),(314204,8728,'pt','Finalidade utilizada para',0),(314205,8728,'ru','Ð¦ÐµÐ»Ð¸, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ñ… Ð´Ð»Ñ',0),(314206,8728,'es','PropÃ³sito Usado Para',0),(314207,8728,'de','Zweck verwendet, fÃ¼r',0),(314208,8728,'en','Purpose Used For',0),(314209,8729,'is','',0),(314210,8729,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø±Ø§ Ø§Ø¯ØºØ§Ù… ÙƒÙ†ÙŠØ¯ØŸ',0),(314211,8729,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø±Ø§ Ø§Ø¯ØºØ§Ù… ÙƒÙ†ÙŠØ¯ØŸ',0),(314212,8729,'tr','Bu mÃ¼ÅŸterilerin birleÅŸtirmek istiyor musunuz',0),(314213,8729,'pl','Czy na pewno chcesz poÅ‚Ä…czyÄ‡ tych klientÃ³w',0),(314214,8729,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¾Ð±ÐµÐ´Ð¸Ð½Ð¸Ñ‚Ðµ Ñ‚ÐµÐ·Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(314215,8729,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ù† Ú¯Ø§ÛÚ©ÙˆÚº Ú©Ùˆ Ø¶Ù… Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº',0),(314216,8729,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¾Ð±Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ‚Ðµ Ñ‚Ðµ ÐºÑƒÐ¿Ñ†Ðµ',0),(314217,8729,'vi','Há»£p Nháº¥t Nhá»¯ng KhÃ¡ch HÃ ng NÃ y?',0),(314218,8729,'af','Is u seker u wil die geselekteerde Klante/KliÃ«nte Verenig?',0),(314219,8729,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ Ã®mbinaÅ£i aceste clienÅ£ii',0),(314220,8729,'et','Oled kindel, et soovid need kliendid Ã¼hendada?',0),(314221,8729,'si','Ali ste prepriÄani, da Å¾elite zdruÅ¾iti te stranke',0),(314222,8729,'ba','Apakah Anda yakin Anda ingin menggabungkan pelanggan tersebut',0),(314223,8729,'nl','Weet u zeker dat u wilt samenvoegen van deze klanten',0),(314224,8729,'fi','Oletko varma, ettÃ¤ haluat yhdistÃ¤Ã¤ nÃ¤mÃ¤ asiakkaat',0),(314225,8729,'no','Er du sikker pÃ¥ at du vil flette disse kundene',0),(314226,8729,'da','Er du sikker pÃ¥, du vil flette disse kunder',0),(314227,8729,'ko','ë‹¹ì‹ ì€ ì´ëŸ¬í•œ ê³ ê° ë³‘í•© í•˜ ì‹œê² ìŠµë‹ˆê¹Œ',0),(314228,8729,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×–×’ ×œ×§×•×—×•×ª ××œ×”',0),(314229,8729,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÏƒÏ…Î³Ï‡Ï‰Î½ÎµÏÏƒÎµÏ„Îµ Î±Ï…Ï„Î¿ÏÏ‚ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(314230,8729,'zh','æ‚¨ç¡®å®šè¦åˆå¹¶è¿™äº›å®¢æˆ·ï¼Ÿ\r\n',0),(314231,8729,'sv','Ã„r du sÃ¤ker du vill sammanfoga dessa kunder',0),(314232,8729,'it','Sei sicuro di che voler unire questi clienti',0),(314233,8729,'tl','',0),(314234,8729,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3619;&#3623;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3648;&#3627;&#3',0),(314235,8729,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤®à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(314236,8729,'ms','Adakah anda pasti anda mahu gabungkan pelanggan-pelanggan',0),(314237,8729,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¯Ù…Ø¬ Ù‡Ø¤Ù„Ø§Ø¡ Ø§Ù„Ø²Ø¨Ø§Ø¦Ù† ØŸ',0),(314238,8729,'fr','ÃŠtes-vous certain de que vouloir fusionner ces clients',0),(314239,8729,'jp','ã“ã‚Œã‚‰ã®é¡§å®¢ã‚’ãƒžãƒ¼ã‚¸ã™ã‚‹ã‚ˆã‚ã—ã„ã§ã™ã€‚',0),(314240,8729,'pt','Tens a certeza de que vocÃª deseja mesclar esses clientes',0),(314241,8729,'ru','Ð’Ñ‹ Ð£Ð²ÐµÑ€ÐµÐ½Ñ‹ Ð§Ñ‚Ð¾ Ð¥Ð¾Ñ‚Ð¸Ñ‚Ðµ ÐžÐ±ÑŠÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒ Ð­Ñ‚Ð¸Ñ… ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(314242,8729,'es','Â¿Esta Seguro que Quiere Adjuntar Estos Clientes?',0),(314243,8729,'de','Sind Sie sicher, dass Sie diese Kunden zusammenfÃ¼hren mÃ¶chten',0),(314244,8729,'en','Are You Sure You Want to Merge These Customers',0),(314245,8730,'is','',0),(314246,8730,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(314247,8730,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(314248,8730,'tr','MÃ¼ÅŸteri No',0),(314249,8730,'pl','Identyfikator klienta',0),(314250,8730,'bg','Ð˜Ð” Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(314251,8730,'ur','Ø´Ù†Ø§Ø®Øª Ú¯Ø§ÛÚ©',0),(314252,8730,'sr','Ð˜Ð” ÐºÑƒÐ¿Ñ†Ð°',0),(314253,8730,'vi','ID KhÃ¡ch hÃ ng',0),(314254,8730,'af','Klant / KliÃ«nt ID',0),(314255,8730,'ro','ID de client',0),(314256,8730,'et','Kliendi ID',0),(314257,8730,'si','ID stranke',0),(314258,8730,'ba','ID pelanggan',0),(314259,8730,'nl','Klant-ID',0),(314260,8730,'fi','Asiakkaan tunnus',0),(314261,8730,'no','Kunde-ID',0),(314262,8730,'da','Kunde-ID',0),(314263,8730,'ko','ê³ ê° ID',0),(314264,8730,'he','×ž×–×”×” ×œ×§×•×—',0),(314265,8730,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(314266,8730,'zh','å®¢æˆ·ID\r\n',0),(314267,8730,'sv','Kund-ID',0),(314268,8730,'it','ID cliente',0),(314269,8730,'tl','',0),(314270,8730,'th','&#3619;&#3627;&#3633;&#3626;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(314271,8730,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• ID',0),(314272,8730,'ms','ID pelanggan',0),(314273,8730,'ar','Ù…Ø¹Ø±Ù‘Ù Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(314274,8730,'fr','ID de client',0),(314275,8730,'jp','é¡§å®¢ ID',0),(314276,8730,'pt','ID do cliente',0),(314277,8730,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(314278,8730,'es','Cliente ID',0),(314279,8730,'de','Kunden-ID',0),(314280,8730,'en','Customer ID',0),(314281,8731,'is','',0),(314282,8731,'dr','_Ø­Ù…Ù„ Ø¨Ù‡ _ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±',0),(314283,8731,'pr','Ú†Ø´Ù… Ù¾ÙˆØ´ÙŠ Ø§Ø² Ø§Ø¯ØºØ§Ù… Ø®Ø±ÙŠØ¯Ø§Ø± Ùˆ Ø±ÙØªÙ† Ø¨Ù‡ Ø§Ø¯ØºØ§Ù… _Ø­Ù…Ù„ Ø¨Ù‡ _ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯Ø§Ø±',0),(314284,8731,'tr','MÃ¼ÅŸteri birleÅŸtirme atlamak ve bu mÃ¼ÅŸteri iÃ§in gitmek iÃ§in gemiye birleÅŸtirmek iÃ§in',0),(314285,8731,'pl','PominÄ…Ä‡ klienta korespondencji seryjnej i przejdÅº do statku do scalania dla tego klienta',0),(314286,8731,'bg','ÐŸÑ€Ð¾Ð¿ÑƒÑÐ½ÐµÑ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¾Ð±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð¸ Ð¾Ñ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð± Ð·Ð° Ð¾Ð±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(314287,8731,'ur','Ø§Ú†Ù¹ÛŒÚº Ú©Ø³Ù¹Ù…Ø± Ø¶Ù… Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø§Ø³ Ú©Û’ Ú¯Ø§ÛÚ© Ú©Û’ Ù„Ø¦Û’ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Ùˆ Ø¶Ù… Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø¬Ø§Ø¤',0),(314288,8731,'sr','ÐŸÑ€ÐµÑÐºÐ¾Ñ‡Ð¸ ÐºÑƒÐ¿Ñ†Ð° Ð·Ð° Ð¾Ð±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐµ Ð¸ Ð¸Ð´Ð¸ Ð½Ð° Ð±Ñ€Ð¾Ð´ Ð´Ð° ÐžÐ±Ñ˜ÐµÐ´Ð¸Ð½Ð¸ Ð·Ð° Ð¾Ð²Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð°',0),(314289,8731,'vi','Bá» qua nháº­p khÃ¡ch hÃ ng & Ä‘áº¿n nháº­p chuyá»ƒn Ä‘áº¿n cho khÃ¡ch hÃ ng nÃ y',0),(314290,8731,'af','Oorstaan van Klant/KliÃ«nt Vereniging en gaan na Versend Aan Vereniging vir hierdie Klant/KliÃ«nt',0),(314291,8731,'ro','SÄƒriÅ£i client Ã®mbinare ÅŸi du-te la nava pentru a Merge pentru acest client',0),(314292,8731,'et','Otse kliendi kooste ja minna laeva Ã¼hendamine selle kliendi',0),(314293,8731,'si','PreskoÄite kupca spajanje in pojdite na ladjo za spajanje za kupca',0),(314294,8731,'ba','Skip Merge pelanggan dan pergi ke kapal untuk menggabungkan untuk pelanggan ini',0),(314295,8731,'nl','Skip klant samenvoegen en ga naar het schip te samenvoegen voor deze klant',0),(314296,8731,'fi','Ohittaa asiakkaan yhdistÃ¤misen ja siirtyÃ¤ aluksen yhdistÃ¤Ã¤ asiakkaan',0),(314297,8731,'no','Hoppe kunden flettingen og gÃ¥ til skipet Ã¥ flette til kunden',0),(314298,8731,'da','Springe kunde katalogfletning og gÃ¥ til skibet at flette for denne kunde',0),(314299,8731,'ko','ê³ ê° ë³‘í•©ì„ ìƒëžµ í•˜ ê³ ì´ ê³ ê°ì— ëŒ€ í•œ ë°° ë³‘í•©ì„',0),(314300,8731,'he','×œ×“×œ×’ ×”×œ×§×•×— ×ž×™×–×•×’ ×•×œ×¢×‘×•×¨ ×”×¡×¤×™× ×” ×›×“×™ ×œ×ž×–×’ ×¢×‘×•×¨ ×œ×§×•×— ×–×”',0),(314301,8731,'el','Î Î±ÏÎ±Î»ÎµÎ¯ÏˆÏ„Îµ Ï€ÎµÎ»Î¬Ï„Î· ÏƒÏ…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ·Ï‚ ÎºÎ±Î¹ Ï€Î·Î³Î±Î¯Î½ÎµÏ„Îµ ÏƒÏ„Î¿ Ï€Î»Î¿Î¯Î¿ Î½Î± ÏƒÏ…Î³Ï‡Ï‰Î½ÎµÏÏƒÎµÏ„Îµ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(314302,8731,'zh','è·³è¿‡å®¢æˆ·åˆå¹¶ï¼Œåˆ°æ­¤å®¢æˆ·æ”¶è´§åˆå¹¶\r\n',0),(314303,8731,'sv','Hoppa Ã¶ver kund sammanfoga och gÃ¥ till fartyget att gÃ¥ ihop fÃ¶r kunden',0),(314304,8731,'it','Cliente Merge di saltare e passare alla nave a fondersi per questo cliente',0),(314305,8731,'tl','',0),(314306,8731,'th','&#3586;&#3657;&#3634;&#3617;&#3585;&#3634;&#3619;&#3619;&#3623;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3649;&#3621;&#3632;&#3652;&#3611;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3',0),(314307,8731,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¤°à¥à¤œ à¤›à¥‹à¤¡à¤¼à¥‡à¤‚ à¤”à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤®à¤°à¥à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤“',0),(314308,8731,'ms','Langkau gabungan pelanggan dan pergi ke kapal untuk bergabung untuk pelanggan',0),(314309,8731,'ar','ØªØ®Ø·ÙŠ Ø¯Ù…Ø¬ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ÙˆØ§Ù„Ø°Ù‡Ø§Ø¨ Ø¥Ù„Ù‰ \"Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù„Ø¯Ù…Ø¬\" Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(314310,8731,'fr','Sauter fusion client et aller Ã  navire Ã  fusionner pour ce client',0),(314311,8731,'jp','ã‚¹ã‚­ãƒƒãƒ—é¡§å®¢ã‚’ãƒžãƒ¼ã‚¸ã¨ãƒžãƒ¼ã‚¸ã™ã‚‹èˆ¹ã«ã“ã®é¡§å®¢ã®ãŸã‚ã«è¡Œã',0),(314312,8731,'pt','Skip cliente mesclar e ir para a nave para mesclar para este cliente',0),(314313,8731,'ru','ÐŸÑ€Ð¾Ð¿ÑƒÑÑ‚Ð¸Ñ‚ÑŒ ÑÐ»Ð¸ÑÐ½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸ Ð¿ÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ ÑÐ»Ð¸ÑÐ½Ð¸Ñ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(314314,8731,'es','Saltar FusiÃ³n de Clientes y ir a FusiÃ³n de Enviar-A para este Cliente',0),(314315,8731,'de','Ãœberspringen Sie Kunden zusammenfÃ¼hren und zum Schiff zu verschmelzen fÃ¼r diesen Kunden',0),(314316,8731,'en','Skip Customer Merge and go to Ship To Merge for this customer',0),(314317,8732,'is','',0),(314318,8732,'dr','Ù†Ù…Ø§ÙŠØ´ Ø­Ù…Ù„ Ø¨Ù‡ ',0),(314319,8732,'pr','Ù†Ù…Ø§ÙŠØ´ Ø­Ù…Ù„ Ø¨Ù‡ ',0),(314320,8732,'tr','GÃ¶rÃ¼nÃ¼m gemiye',0),(314321,8732,'pl','Widok statku',0),(314322,8732,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(314323,8732,'ur','Ù…Ù†Ø¸Ø± Ú©Ø´ØªÛŒ Ù¾Ø±',0),(314324,8732,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð±Ñ€Ð¾Ð´Ð° Ð´Ð°',0),(314325,8732,'vi','Xem chuyá»ƒn Ä‘áº¿n',0),(314326,8732,'af','Besigtig Versend Na',0),(314327,8732,'ro','Vezi nava sÄƒ',0),(314328,8732,'et','Vaata tarneaadressi',0),(314329,8732,'si','Ladjo in pogled',0),(314330,8732,'ba','Lihat kapal untuk',0),(314331,8732,'nl','Weergave schip',0),(314332,8732,'fi','Katso aluksen',0),(314333,8732,'no','Vis skip',0),(314334,8732,'da','Se skibet til at',0),(314335,8732,'ko','ë³´ê¸° ë°°ë¥¼',0),(314336,8732,'he','×ª×¦×•×’×ª ×œ×¡×¤×™× ×”',0),(314337,8732,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€Î»Î¿Î¯Î¿ Î½Î±',0),(314338,8732,'zh','æŸ¥çœ‹æ”¶èŽ·åœ°\r\n',0),(314339,8732,'sv','Visa fartyg',0),(314340,8732,'it','Nave vista a',0),(314341,8732,'tl','',0),(314342,8732,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(314343,8732,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(314344,8732,'ms','Lihat kapal',0),(314345,8732,'ar','Ø¹Ø±Ø¶ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø­Ù†',0),(314346,8732,'fr','Vue navire Ã ',0),(314347,8732,'jp','ãƒ“ãƒ¥ãƒ¼ã®èˆ¹',0),(314348,8732,'pt','Vista nave para',0),(314349,8732,'ru','Ð’Ð¸Ð´ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(314350,8732,'es','Visionar Enviar A',0),(314351,8732,'de','Ansicht Schiff',0),(314352,8732,'en','View Ship To',0),(314353,8733,'is','',0),(314354,8733,'dr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ§Ø± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(314355,8733,'pr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ§Ø± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(314356,8733,'tr','GÃ¶rÃ¼nÃ¼m parÃ§a baÅŸÄ± iÅŸ',0),(314357,8733,'pl','Zobacz pracy akordowej',0),(314358,8733,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð±Ñ€Ð¾Ð¹ÐºÐ°',0),(314359,8733,'ur','Ù…Ù†Ø¸Ø± Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú©',0),(314360,8733,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(314361,8733,'vi','Xem viá»‡c khoÃ¡n',0),(314362,8733,'af','Besigtig Stukswerk',0),(314363,8733,'ro','Vezi acord',0),(314364,8733,'et','Vaade tÃ¼kitÃ¶Ã¶',0),(314365,8733,'si','Pogled akord',0),(314366,8733,'ba','Lihat Piecework',0),(314367,8733,'nl','Weergave stukloon',0),(314368,8733,'fi','Katso urakka',0),(314369,8733,'no','Vis stykkavlÃ¸nning',0),(314370,8733,'da','Se akkordarbejde',0),(314371,8733,'ko','ë³´ê¸° Piecework',0),(314372,8733,'he','×ª×¦×•×’×ª ×‘×§×‘×œ× ×•×ª',0),(314373,8733,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(314374,8733,'zh','æŸ¥çœ‹è®¡ä»¶\r\n',0),(314375,8733,'sv','Visa ackordet',0),(314376,8733,'it','Vista a cottimo',0),(314377,8733,'tl','',0),(314378,8733,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(314379,8733,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ Piecework',0),(314380,8733,'ms','Pandangan Piecework',0),(314381,8733,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(314382,8733,'fr','Vue Ã  la piÃ¨ce',0),(314383,8733,'jp','å‡ºæ¥é«˜æ‰•ã„ãƒ“ãƒ¥ãƒ¼',0),(314384,8733,'pt','Sistema de visÃ£o!',0),(314385,8733,'ru','Ð’Ð¸Ð´ ÑÐ´ÐµÐ»ÑŒÐ½Ð¾Ð¹',0),(314386,8733,'es','Visionar Trabajo por Pieza',0),(314387,8733,'de','Ansicht Akkordarbeit',0),(314388,8733,'en','View Piecework',0),(314389,8734,'is','',0),(314390,8734,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ø± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(314391,8734,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ø± Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(314392,8734,'tr','ParÃ§a baÅŸÄ± iÅŸ ayrÄ±ntÄ±larÄ±',0),(314393,8734,'pl','SzczegÃ³Å‚y pracy akordowej',0),(314394,8734,'bg','Ð”Ð°Ð½Ð½Ð¸ Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ñ€Ñ‡Ðµ',0),(314395,8734,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© Ø¬Ø§Ø¨ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(314396,8734,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¿Ð¾ÑÐ»Ð° Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(314397,8734,'vi','Chi tiáº¿t Job khoÃ¡n',0),(314398,8734,'af','Stukwerk Werkstuk Besonderhede',0),(314399,8734,'ro','Acord detalii Job',0),(314400,8734,'et','TÃ¼kitÃ¶Ã¶ tÃ¶Ã¶ Ã¼ksikasjad',0),(314401,8734,'si','Akord Job podrobnosti',0),(314402,8734,'ba','Rincian pekerjaan piecework',0),(314403,8734,'nl','Stukloon baan Details',0),(314404,8734,'fi','Urakka tyÃ¶n tiedot',0),(314405,8734,'no','StykkavlÃ¸nning Jobbdetaljer',0),(314406,8734,'da','Akkordarbejde Jobdetaljer',0),(314407,8734,'ko','Piecework ìž‘ì—… ì„¸ë¶€ ì‚¬í•­',0),(314408,8734,'he','×¤×¨×˜×™ ×”×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(314409,8734,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(314410,8734,'zh','è®¡ä»¶ä½œä¸šè¯¦ç»†ä¿¡æ¯\r\n',0),(314411,8734,'sv','Ackord jobbinformation',0),(314412,8734,'it','Particolari di lavoro a cottimo',0),(314413,8734,'tl','',0),(314414,8734,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3594;&#3636;&#3657;&#3609;',0),(314415,8734,'hi','Piecework à¤¨à¥Œà¤•à¤°à¥€ à¤µà¤¿à¤µà¤°à¤£',0),(314416,8734,'ms','Butir-butir kerja piecework',0),(314417,8734,'ar','ØªÙØ§ØµÙŠÙ„ Ù…Ù‡Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(314418,8734,'fr','DÃ©tails du travail Ã  la piÃ¨ce',0),(314419,8734,'jp','å‡ºæ¥é«˜æ‰•ã„ã®ä»•äº‹ã®è©³ç´°',0),(314420,8734,'pt','Detalhes de trabalho trabalho por tarefa',0),(314421,8734,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½Ð°Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(314422,8734,'es','Detalles de Trabajo de Trabajo por Pieza',0),(314423,8734,'de','Akkord-Job-Details',0),(314424,8734,'en','Piecework Job Details',0),(314425,8735,'is','',0),(314426,8735,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…ØºØ§ÙŠØ±Øª Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(314427,8735,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…ØºØ§ÙŠØ±Øª Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(314428,8735,'tr','ParÃ§a baÅŸÄ± iÅŸ Ã§akÄ±ÅŸma raporu',0),(314429,8735,'pl','Raport konflikty w pracy akordowej',0),(314430,8735,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ ÐºÐ¾Ð½Ñ„Ð»Ð¸ÐºÑ‚ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(314431,8735,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© ØªÙ†Ø§Ø²Ø¹Û’ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(314432,8735,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÑÑƒÐºÐ¾Ð±Ñƒ ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(314433,8735,'vi','BÃ¡o cÃ¡o chÃªnh lá»‡ch cÃ´ng viá»‡c bÃ¡n thá»i gian ',0),(314434,8735,'af','Stukwerk Konflik Verslag',0),(314435,8735,'ro','Raport de Conflict acord',0),(314436,8735,'et','TÃ¼kitÃ¶Ã¶ konflikti aruanne',0),(314437,8735,'si','Akord konflikt poroÄilo',0),(314438,8735,'ba','Piecework konflik laporan',0),(314439,8735,'nl','Stukloon Conflict verslag',0),(314440,8735,'fi','UrakkatyÃ¶n konfliktin raporttiin',0),(314441,8735,'no','StykkavlÃ¸nning konflikt rapport',0),(314442,8735,'da','Akkordarbejde konflikt rapport',0),(314443,8735,'ko','Piecework ì¶©ëŒ ë³´ê³ ì„œ',0),(314444,8735,'he','×“×•×— ×¡×›×¡×•×š ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(314445,8735,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹ ÏƒÏÎ³ÎºÏÎ¿Ï…ÏƒÎ· Î­ÎºÎ¸ÎµÏƒÎ·',0),(314446,8735,'zh','è®¡ä»¶å†²çªçš„æŠ¥å‘Š\r\n',0),(314447,8735,'sv','Ackord konflikt rapport',0),(314448,8735,'it','Rapporto di lavoro a cottimo conflitto',0),(314449,8735,'tl','',0),(314450,8735,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3586;&#3633;&#3604;&#3649;&#3618;&#3657;&#3591;',0),(314451,8735,'hi','Piecework à¤¸à¤‚à¤˜à¤°à¥à¤· à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(314452,8735,'ms','Piecework konflik Laporan',0),(314453,8735,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØµØ±Ø§Ø¹ Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(314454,8735,'fr','Rapport de conflits de travail Ã  la piÃ¨ce',0),(314455,8735,'jp','å‡ºæ¥é«˜æ‰•ã„ç«¶åˆãƒ¬ãƒãƒ¼ãƒˆ',0),(314456,8735,'pt','RelatÃ³rio de conflitos de trabalho por tarefa',0),(314457,8735,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½Ð°Ñ ÐºÐ¾Ð½Ñ„Ð»Ð¸ÐºÑ‚Ð° Ð´Ð¾ÐºÐ»Ð°Ð´',0),(314458,8735,'es','Informe de Conflicto de Trabajo por Pieza',0),(314459,8735,'de','Akkord-Konflikt-Bericht',0),(314460,8735,'en','Piecework Conflict Report',0),(314461,8736,'is','',0),(314462,8736,'dr','PW OT  (Ù…ØªÙ† Ù‚Ø¯ÙŠÙ…ÙŠ( Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±',0),(314463,8736,'pr','PW OT  (Ù…ØªÙ† Ù‚Ø¯ÙŠÙ…ÙŠ( Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±',0),(314464,8736,'tr','PW OT',0),(314465,8736,'pl','PW OT',0),(314466,8736,'bg','PW OT',0),(314467,8736,'ur','PW OT',0),(314468,8736,'sr','ÐŸW Ð˜ÐˆÐ•',0),(314469,8736,'vi','PW OT',0),(314470,8736,'af','P.W NIE',0),(314471,8736,'ro','PW OT',0),(314472,8736,'et','PW OT',0),(314473,8736,'si','PW OT',0),(314474,8736,'ba','PL PW',0),(314475,8736,'nl','PW OT',0),(314476,8736,'fi','PW OT',0),(314477,8736,'no','PW OT',0),(314478,8736,'da','PW OT',0),(314479,8736,'ko','ë¹„ë°€ ë²ˆí˜¸ OT',0),(314480,8736,'he','PW OT',0),(314481,8736,'el','PW OT',0),(314482,8736,'zh','æ¯å‘¨é€¾æ—¶\r\n',0),(314483,8736,'sv','PW OT',0),(314484,8736,'it','OT PW',0),(314485,8736,'tl','',0),(314486,8736,'th','PW OT',0),(314487,8736,'hi','PW OT',0),(314488,8736,'ms','PW OT',0),(314489,8736,'ar','PW Ø¨Ø¹Ø¯ Ø§Ù„ØªÙ…Ø¯ÙŠØ¯',0),(314490,8736,'fr','OT DE PW',0),(314491,8736,'jp','PW OT',0),(314492,8736,'pt','OT DE PW',0),(314493,8736,'ru','PW OT',0),(314494,8736,'es','PW OT',0),(314495,8736,'de','PW-OT',0),(314496,8736,'en','PW OT',0),(314497,8737,'is','',0),(314498,8737,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(314499,8737,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(314500,8737,'tr','MÃ¼ÅŸteri parolasÄ±',0),(314501,8737,'pl','HasÅ‚o klienta',0),(314502,8737,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ° Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(314503,8737,'ur','Ú¯Ø§ÛÚ© Ú©Û’ Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(314504,8737,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ° ÐºÑƒÐ¿Ñ†Ð°',0),(314505,8737,'vi','Máº­t kháº©u KhÃ¡ch hÃ ng',0),(314506,8737,'af','Klant / KliÃ«nt Wagwoord',0),(314507,8737,'ro','Parola de client',0),(314508,8737,'et','Kliendi salasÃµna',0),(314509,8737,'si','Kupec geslo',0),(314510,8737,'ba','Password Nasabah',0),(314511,8737,'nl','Klant wachtwoord',0),(314512,8737,'fi','Asiakkaan salasana',0),(314513,8737,'no','Kunden passord',0),(314514,8737,'da','Kunde adgangskoden',0),(314515,8737,'ko','ê³ ê° ì•”í˜¸',0),(314516,8737,'he','×¡×™×¡×ž×ª ×œ×§×•×—',0),(314517,8737,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(314518,8737,'zh','å®¢æˆ·å¯†ç \r\n',0),(314519,8737,'sv','Kundens lÃ¶senord',0),(314520,8737,'it','Password del cliente',0),(314521,8737,'tl','',0),(314522,8737,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(314523,8737,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡',0),(314524,8737,'ms','Kata laluan pelanggan',0),(314525,8737,'ar','ÙƒÙ„Ù…Ø© Ø³Ø± Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(314526,8737,'fr','Mot de passe client',0),(314527,8737,'jp','é¡§å®¢ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰',0),(314528,8737,'pt','Senha do cliente',0),(314529,8737,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(314530,8737,'es','Cliente ContraseÃ±a',0),(314531,8737,'de','Kundenkennwort',0),(314532,8737,'en','Customer Password',0),(314533,8738,'is','',0),(314534,8738,'dr','2',0),(314535,8738,'pr','Ø´Ø±Ø­ Ø§ÙŠÙ…ÙŠÙ„   2',0),(314536,8738,'tr','E-posta 2 aÃ§Ä±klamasÄ±',0),(314537,8738,'pl','E-mail 2 opis',0),(314538,8738,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð» 2',0),(314539,8738,'ur','Ø§ÛŒ Ù…ÛŒÙ„ 2 ØªØµØ±ÛŒØ­',0),(314540,8738,'sr','ÐžÐ¿Ð¸Ñ Ðµ-Ð°Ð´Ñ€ÐµÑÐ° 2',0),(314541,8738,'vi','Diá»…n Giáº£i Email 2',0),(314542,8738,'af','E-pos 2 Beskrywing',0),(314543,8738,'ro','E-mail 2 Descriere',0),(314544,8738,'et','E-mail 2 kirjeldus',0),(314545,8738,'si','Email 2 opis',0),(314546,8738,'ba','Deskripsi email 2',0),(314547,8738,'nl','E-mail 2 Beschrijving',0),(314548,8738,'fi','SÃ¤hkÃ¶posti 2 Kuvaus',0),(314549,8738,'no','E-2 beskrivelse',0),(314550,8738,'da','E-mail 2 Beskrivelse',0),(314551,8738,'ko','ì´ë©”ì¼ 2 ì„¤ëª…',0),(314552,8738,'he','×ª×™××•×¨ ×“×•× ×œ 2',0),(314553,8738,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ 2 Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(314554,8738,'zh','ç”µå­é‚®ä»¶2æè¿°\r\n',0),(314555,8738,'sv','E-2 Beskrivning',0),(314556,8738,'it','E-mail 2 Descrizione',0),(314557,8738,'tl','',0),(314558,8738,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3607;&#3637;&#3656; 2',0),(314559,8738,'hi','à¤ˆà¤®à¥‡à¤² 2 à¤µà¤¿à¤µà¤°à¤£',0),(314560,8738,'ms','E-mel 2 Penerangan',0),(314561,8738,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(314562,8738,'fr','Courriel 2 Description',0),(314563,8738,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« 2 ã®èª¬æ˜Ž',0),(314564,8738,'pt','E-mail 2 DescriÃ§Ã£o',0),(314565,8738,'ru','Email 2 ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(314566,8738,'es','Email 2 DescripciÃ³n',0),(314567,8738,'de','E-Mail 2 Beschreibung',0),(314568,8738,'en','Email 2 Description',0),(314569,8739,'is','',0),(314570,8739,'dr','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø±ÙŠÙ† ØªØºÙŠÙŠØ± ',0),(314571,8739,'pr','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø±ÙŠÙ† ØªØºÙŠÙŠØ± ',0),(314572,8739,'tr','Son deÄŸiÅŸiklik tarihi',0),(314573,8739,'pl','Data ostatniej zmiany',0),(314574,8739,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(314575,8739,'ur','Ø¢Ø®Ø±ÛŒ ØªØ§Ø±ÛŒØ® ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(314576,8739,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(314577,8739,'vi','NgÃ y thay Ä‘á»•i cuá»‘i',0),(314578,8739,'af','Laaste Datum Verander',0),(314579,8739,'ro','Ultima modificare data',0),(314580,8739,'et','Viimase muutuse kuupÃ¤ev',0),(314581,8739,'si','Datum zadnje spremembe',0),(314582,8739,'ba','Tanggal perubahan terakhir',0),(314583,8739,'nl','Laatste wijzigingsdatum',0),(314584,8739,'fi','Viimeksi muokattu',0),(314585,8739,'no','Siste endringsdato',0),(314586,8739,'da','Sidste Ã¦ndringsdato',0),(314587,8739,'ko','ë§ˆì§€ë§‰ ë³€ê²½ ë‚ ì§œ',0),(314588,8739,'he','×ª××¨×™×š ×©×™× ×•×™ ××—×¨×•×Ÿ',0),(314589,8739,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î±Î»Î»Î±Î³Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(314590,8739,'zh','æœ€åŽæ›´æ”¹æ—¥æœŸ\r\n',0),(314591,8739,'sv','Senaste Ã¤ndringsdatum',0),(314592,8739,'it','Data ultima modifica',0),(314593,8739,'tl','',0),(314594,8739,'th','&#3623;&#3633;&#3618;&#3607;&#3637;&#3656;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(314595,8739,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¤à¤¿à¤¥à¤¿',0),(314596,8739,'ms','Tarikh perubahan',0),(314597,8739,'ar','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø± ØªØ¹Ø¯ÙŠÙ„',0),(314598,8739,'fr','Date de derniÃ¨re modification',0),(314599,8739,'jp','æœ€çµ‚å¤‰æ›´æ—¥',0),(314600,8739,'pt','Data da Ãºltima alteraÃ§Ã£o',0),(314601,8739,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(314602,8739,'es','Ãšltima Fecha de Cambio',0),(314603,8739,'de','Ã„nderungsdatum der letzten',0),(314604,8739,'en','Last Change Date',0),(314605,8740,'is','',0),(314606,8740,'dr','4',0),(314607,8740,'pr','Ø´Ø±Ø­ ØªÙ„ÙÙ† 4',0),(314608,8740,'tr','Telefon 4 aÃ§Ä±klamasÄ±',0),(314609,8740,'pl','Opis telefon 4',0),(314610,8740,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 4 Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(314611,8740,'ur','ÙÙˆÙ† 4 Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(314612,8740,'sr','ÐžÐ¿Ð¸Ñ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ 4',0),(314613,8740,'vi','MÃ´ táº£ phone 4',0),(314614,8740,'af','Telefoon 4 Beskrywing',0),(314615,8740,'ro','Telefon 4 Descriere',0),(314616,8740,'et','Telefoni 4 kirjeldus',0),(314617,8740,'si','Telefon 4 Opis',0),(314618,8740,'ba','Deskripsi telepon 4',0),(314619,8740,'nl','Telefoon 4 Beschrijving',0),(314620,8740,'fi','Puhelimen 4 kuvaus',0),(314621,8740,'no','Telefon 4 beskrivelse',0),(314622,8740,'da','Phone 4 beskrivelse',0),(314623,8740,'ko','ì „í™” 4 ì„¤ëª…',0),(314624,8740,'he','×ª×™××•×¨ ×”×˜×œ×¤×•×Ÿ 4',0),(314625,8740,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ 4 Î ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(314626,8740,'zh','ç”µè¯4æè¿°\r\n',0),(314627,8740,'sv','Telefon 4 Beskrivning',0),(314628,8740,'it','Telefono 4 Descrizione',0),(314629,8740,'tl','',0),(314630,8740,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3607;&#3637;&#3656; 4',0),(314631,8740,'hi','à¤«à¤¼à¥‹à¤¨ 4 à¤µà¤¿à¤µà¤°à¤£',0),(314632,8740,'ms','Description/kawalan telefon 4',0),(314633,8740,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ø±Ø§Ø¨Ø¹',0),(314634,8740,'fr','TÃ©lÃ©phone 4 Description',0),(314635,8740,'jp','é›»è©± 4 èª¬æ˜Ž',0),(314636,8740,'pt','DescriÃ§Ã£o de telefone 4',0),(314637,8740,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ 4 ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(314638,8740,'es','TelÃ©fono 4 DescripciÃ³n',0),(314639,8740,'de','Telefon 4 Beschreibung',0),(314640,8740,'en','Phone 4 Description',0),(314641,8741,'is','',0),(314642,8741,'dr','1',0),(314643,8741,'pr','Ø´Ø±Ø­ ØªÙ„ÙÙ†   1',0),(314644,8741,'tr','Telefon 1 aÃ§Ä±klama',0),(314645,8741,'pl','Opis telefon 1',0),(314646,8741,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ 1',0),(314647,8741,'ur','ÙÙˆÙ† 1 ØªØµØ±ÛŒØ­',0),(314648,8741,'sr','ÐžÐ¿Ð¸Ñ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ 1',0),(314649,8741,'vi','MÃ´ táº£ phone 1',0),(314650,8741,'af','Telefoon 1 Beskrywing',0),(314651,8741,'ro','Telefon 1 Descriere',0),(314652,8741,'et','Telefoni 1 kirjeldu',0),(314653,8741,'si','Telefon 1 opis',0),(314654,8741,'ba','Deskripsi telepon 1',0),(314655,8741,'nl','Telefoon 1 Beschrijving',0),(314656,8741,'fi','Puhelin 1 kuvaus',0),(314657,8741,'no','Telefonnummer 1 beskrivelse',0),(314658,8741,'da','Telefon 1 Beskrivelse',0),(314659,8741,'ko','ì „í™” 1 ì„¤ëª…',0),(314660,8741,'he','×ª×™××•×¨ ×”×˜×œ×¤×•×Ÿ 1',0),(314661,8741,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ 1 Î ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(314662,8741,'zh','ç”µè¯1æè¿°\r\n',0),(314663,8741,'sv','Telefon 1 Beskrivning',0),(314664,8741,'it','Descrizione telefono 1',0),(314665,8741,'tl','',0),(314666,8741,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3607;&#3637;&#3656; 1',0),(314667,8741,'hi','à¤«à¤¼à¥‹à¤¨ 1 à¤µà¤¿à¤µà¤°à¤£',0),(314668,8741,'ms','Telefon 1 Herba ubat',0),(314669,8741,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ø£ÙˆÙ„',0),(314670,8741,'fr','TÃ©lÃ©phone 1 Description',0),(314671,8741,'jp','é›»è©± 1 ã®èª¬æ˜Ž',0),(314672,8741,'pt','DescriÃ§Ã£o de telefone 1',0),(314673,8741,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ 1 ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(314674,8741,'es','TelÃ©fono 1 Descripcion',0),(314675,8741,'de','Telefon 1 Beschreibung',0),(314676,8741,'en','Phone 1 Description',0),(314677,8742,'is','',0),(314678,8742,'dr','3',0),(314679,8742,'pr','Ø´Ø±Ø­  ØªÙ„ÙÙ†   3',0),(314680,8742,'tr','Telefon 3 aÃ§Ä±klamasÄ±',0),(314681,8742,'pl','Opis telefon 3',0),(314682,8742,'bg','3 Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(314683,8742,'ur','ÙÙˆÙ† 3 ØªØµØ±ÛŒØ­',0),(314684,8742,'sr','ÐžÐ¿Ð¸Ñ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ 3',0),(314685,8742,'vi','MÃ´ táº£ phone 3',0),(314686,8742,'af','Telefoon 3 Beskrywing',0),(314687,8742,'ro','Telefon 3 Descriere',0),(314688,8742,'et','Telefoni 3 kirjeldus',0),(314689,8742,'si','Opis telefona 3',0),(314690,8742,'ba','Deskripsi telepon 3',0),(314691,8742,'nl','Telefoon 3 Beschrijving',0),(314692,8742,'fi','Puhelimen 3 kuvaus',0),(314693,8742,'no','Telefonen 3 beskrivelse',0),(314694,8742,'da','Telefonen 3 beskrivelse',0),(314695,8742,'ko','ì „í™” 3 ì„¤ëª…',0),(314696,8742,'he','×ª×™××•×¨ ×”×˜×œ×¤×•×Ÿ 3',0),(314697,8742,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î·Î»Î­Ï†Ï‰Î½Î¿ 3',0),(314698,8742,'zh','ç”µè¯3æè¿°\r\n',0),(314699,8742,'sv','Telefonen 3 Beskrivning',0),(314700,8742,'it','Descrizione telefono 3',0),(314701,8742,'tl','',0),(314702,8742,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3607;&#3637;&#3656; 3',0),(314703,8742,'hi','à¤«à¤¼à¥‹à¤¨ 3 à¤µà¤¿à¤µà¤°à¤£',0),(314704,8742,'ms','Description/kawalan telefon 3',0),(314705,8742,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ø«Ø§Ù„Ø«',0),(314706,8742,'fr','TÃ©lÃ©phone 3 Description',0),(314707,8742,'jp','é›»è©± 3 ã®èª¬æ˜Ž',0),(314708,8742,'pt','DescriÃ§Ã£o telefone 3',0),(314709,8742,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ 3 ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(314710,8742,'es','TelÃ©fono 3 Descripcion',0),(314711,8742,'de','Telefon 3 Beschreibung',0),(314712,8742,'en','Phone 3 Description',0),(314713,8743,'is','',0),(314714,8743,'dr','2',0),(314715,8743,'pr','Ø´Ø±Ø­  ØªÙ„ÙÙ†   2',0),(314716,8743,'tr','Telefon 2 aÃ§Ä±klamasÄ±',0),(314717,8743,'pl','Opis telefon 2',0),(314718,8743,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 2 Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(314719,8743,'ur','ÙÙˆÙ† 2 ØªØµØ±ÛŒØ­',0),(314720,8743,'sr','ÐžÐ¿Ð¸Ñ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ 2',0),(314721,8743,'vi','MÃ´ táº£ phone 2',0),(314722,8743,'af','Telefoon 2 Beskrywing',0),(314723,8743,'ro','Telefon 2 Descriere',0),(314724,8743,'et','Telefoni 2 kirjeldus',0),(314725,8743,'si','Telefon 2 opis',0),(314726,8743,'ba','Deskripsi telepon 2',0),(314727,8743,'nl','Telefoon 2 Beschrijving',0),(314728,8743,'fi','Puhelin 2 Kuvaus',0),(314729,8743,'no','Telefon 2 beskrivelse',0),(314730,8743,'da','Telefon 2 Beskrivelse',0),(314731,8743,'ko','ì „í™” 2 ì„¤ëª…',0),(314732,8743,'he','×ª×™××•×¨ ×”×˜×œ×¤×•×Ÿ 2',0),(314733,8743,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ 2 Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(314734,8743,'zh','ç”µè¯2æè¿°\r\n',0),(314735,8743,'sv','Telefon 2 Beskrivning',0),(314736,8743,'it','Telefono 2 Descrizione',0),(314737,8743,'tl','',0),(314738,8743,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3607;&#3637;&#3656; 2',0),(314739,8743,'hi','à¤«à¤¼à¥‹à¤¨ 2 à¤µà¤¿à¤µà¤°à¤£',0),(314740,8743,'ms','Description/kawalan telefon 2',0),(314741,8743,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(314742,8743,'fr','TÃ©lÃ©phone 2 Description',0),(314743,8743,'jp','é›»è©± 2 ã®èª¬æ˜Ž',0),(314744,8743,'pt','DescriÃ§Ã£o de telefone 2',0),(314745,8743,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ 2 ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(314746,8743,'es','TelÃ©fono 2 Descripcion',0),(314747,8743,'de','Telefon 2 Beschreibung',0),(314748,8743,'en','Phone 2 Description',0),(314749,8744,'is','',0),(314750,8744,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø³Ù†Ø¯ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(314751,8744,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø³Ù†Ø¯ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(314752,8744,'tr','KayÄ±t ID',0),(314753,8744,'pl','Rec ID podatku od sprzedaÅ¼y',0),(314754,8744,'bg','Ð˜Ð” Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Rec',0),(314755,8744,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø¢Ø± Ø§ÛŒ Ø³ÛŒ Ø¢Ø¦ÛŒ ÚˆÛŒ',0),(314756,8744,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð·Ð° Ñ€ÐµÐºÑ€ÐµÐ°Ñ†Ð¸Ñ˜Ñƒ Ð˜Ð”',0),(314757,8744,'vi','ID Há»“ sÆ¡ thuáº¿ bÃ¡n hÃ ng',0),(314758,8744,'af','Verkoopsbelasting Rec ID',0),(314759,8744,'ro','Impozit pe vÃ¢nzÄƒri Rec ID',0),(314760,8744,'et','KÃ¤ibemaksu Rec ID',0),(314761,8744,'si','Prometni davek Rec ID',0),(314762,8744,'ba','Pajak penjualan Rec ID',0),(314763,8744,'nl','Sales Tax Rec ID',0),(314764,8744,'fi','ArvonlisÃ¤veron Rec tunnus',0),(314765,8744,'no','Mva-Rec ID',0),(314766,8744,'da','Sales Tax Rec-ID',0),(314767,8744,'ko','íŒë§¤ì„¸ Rec ID',0),(314768,8744,'he','×ž×–×”×” ×ž×¢ ×ž',0),(314769,8744,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Rec Î‘Î¦Îœ',0),(314770,8744,'zh','é”€å”®ç¨Žè®°å½•ç¼–å·\r\n',0),(314771,8744,'sv','Moms Rec-ID',0),(314772,8744,'it','Sales Tax ID Rec',0),(314773,8744,'tl','',0),(314774,8744,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3619;&#3633;&#3610;&#3616;&#3634;&#3625;&#3637;&#3586;&#3634;&#3618;',0),(314775,8744,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤†à¤°à¤ˆà¤¸à¥€ ID',0),(314776,8744,'ms','Cukai jualan Rec ID',0),(314777,8744,'ar','Ù…Ø¹Ø±Ù Rec Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(314778,8744,'fr','Taxe de vente Rec ID',0),(314779,8744,'jp','Rec ID ã‚’å£²ä¸Šç¨Žã—ã¾ã™ã€‚',0),(314780,8744,'pt','Imposto sobre vendas Rec ID',0),(314781,8744,'ru','ÐÐ°Ð»Ð¾Ð³ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Rec ID',0),(314782,8744,'es','IVA Records ID',0),(314783,8744,'de','Umsatzsteuer-ID Rec',0),(314784,8744,'en','Sales Tax Rec ID',0),(314785,8745,'is','',0),(314786,8745,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø·Ø¨Ù‚ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(314787,8745,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø·Ø¨Ù‚ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(314788,8745,'tr','MÃ¼ÅŸteriden parola kullanÄ±n',0),(314789,8745,'pl','UÅ¼yj hasÅ‚a klienta',0),(314790,8745,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð¾Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(314791,8745,'ur','Ú¯Ø§ÛÚ© Ø³Û’ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(314792,8745,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ð¾Ð´ ÐºÑƒÐ¿Ñ†Ð°',0),(314793,8745,'vi','DÃ¹ng máº­t kháº©u tá»« khÃ¡ch hÃ ng',0),(314794,8745,'af','Gebruik Wagwoord Van KliÃ«nt/Klant',0),(314795,8745,'ro','Folosesc parola de la client',0),(314796,8745,'et','Kasutamiseks kliendilt parooli',0),(314797,8745,'si','Uporabite geslo iz kupca',0),(314798,8745,'ba','Gunakan Password dari nasabah',0),(314799,8745,'nl','Wachtwoord van het gebruik van klant',0),(314800,8745,'fi','Asiakkaan salasana',0),(314801,8745,'no','Bruke passordet fra kunde',0),(314802,8745,'da','Brug adgangskode fra kunde',0),(314803,8745,'ko','ê³ ê° ìœ¼ë¡œë¶€í„° ë¹„ë°€ ë²ˆí˜¸ ì‚¬ìš©',0),(314804,8745,'he','×”×©×ª×ž×© ×‘×¡×™×¡×ž×” ×©×œ ×”×œ×§×•×—',0),(314805,8745,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï‡ÏÎ®ÏƒÎ·Ï‚ Î±Ï€ÏŒ Ï„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(314806,8745,'zh','ä½¿ç”¨æ¥è‡ªå®¢æˆ·å¯†ç \r\n',0),(314807,8745,'sv','AnvÃ¤nd lÃ¶senord frÃ¥n kund',0),(314808,8745,'it','Utilizzare Password dal cliente',0),(314809,8745,'tl','',0),(314810,8745,'th','&#3651;&#3594;&#3657;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3592;&#3634;&#3585;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(314811,8745,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(314812,8745,'ms','Gunakan kata laluan daripada pelanggan',0),(314813,8745,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ù…Ù† Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(314814,8745,'fr','Utilisez le mot de passe du client',0),(314815,8745,'jp','é¡§å®¢ã‹ã‚‰ã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(314816,8745,'pt','Use a senha do cliente',0),(314817,8745,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð¾Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(314818,8745,'es','Usar ContraseÃ±a de Cliente',0),(314819,8745,'de','Verwenden Sie Passwort Kunde',0),(314820,8745,'en','Use Password From Customer',0),(314821,8746,'is','',0),(314822,8746,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÙŠÙ† Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±',0),(314823,8746,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÙŠÙ† Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±',0),(314824,8746,'tr','Bu parola kullanÄ±n',0),(314825,8746,'pl','Za pomocÄ… tego hasÅ‚a',0),(314826,8746,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹ Ñ‚Ð°Ð·Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(314827,8746,'ur','ÛŒÛ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(314828,8746,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ',0),(314829,8746,'vi','DÃ¹ng máº­t kháº©u nÃ y',0),(314830,8746,'af','Gebruik Hierdie Wagwoord',0),(314831,8746,'ro','UtilizaÅ£i aceastÄƒ parolÄƒ',0),(314832,8746,'et','Kasuta seda salasÃµna',0),(314833,8746,'si','Uporabite to geslo',0),(314834,8746,'ba','Menggunakan sandi ini',0),(314835,8746,'nl','Dit wachtwoord gebruiken',0),(314836,8746,'fi','KÃ¤ytÃ¤ tÃ¤tÃ¤ salasanaa',0),(314837,8746,'no','Bruk dette passordet',0),(314838,8746,'da','Brug denne adgangskode',0),(314839,8746,'ko','ì´ ì•”í˜¸ë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(314840,8746,'he','×”×©×ª×ž×© ×‘×¡×™×¡×ž×” ×–×•',0),(314841,8746,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(314842,8746,'zh','ä½¿ç”¨æ­¤å¯†ç \r\n',0),(314843,8746,'sv','AnvÃ¤nda detta lÃ¶senord',0),(314844,8746,'it','Utilizzare questa Password',0),(314845,8746,'tl','',0),(314846,8746,'th','&#3651;&#3594;&#3657;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(314847,8746,'hi','à¤‡à¤¸ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(314848,8746,'ms','Gunakan kata laluan ini',0),(314849,8746,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ù‡Ø°Ù‡',0),(314850,8746,'fr','Utilisez ce mot de passe',0),(314851,8746,'jp','ã“ã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(314852,8746,'pt','Use esta senha',0),(314853,8746,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ð¹ ÐŸÐ°Ñ€Ð¾Ð»ÑŒ',0),(314854,8746,'es','Usar Esta ContraseÃ±a',0),(314855,8746,'de','Verwenden Sie dieses Kennwort',0),(314856,8746,'en','Use This Password',0),(314857,8747,'is','',0),(314858,8747,'dr','Ù…ØºØ§ÙŠØ±Øª Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(314859,8747,'pr','Ù…ØºØ§ÙŠØ±Øª Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(314860,8747,'tr','ParÃ§a baÅŸÄ± iÅŸ Ã§akÄ±ÅŸmalarÄ±',0),(314861,8747,'pl','Konflikty praca akordowa',0),(314862,8747,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ ÐºÐ¾Ð½Ñ„Ð»Ð¸ÐºÑ‚Ð¸',0),(314863,8747,'ur','Ù¾ÛŒØ³ÛŒÙˆÙˆØ±Ú© ØªÙ†Ø§Ø²Ø¹Ø§Øª',0),(314864,8747,'sr','Ð—Ð° ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð½ÐµÑƒÑÐ°Ð³Ð»Ð°ÑˆÐµÐ½Ð¾ÑÑ‚Ð¸',0),(314865,8747,'vi','Giá» khoÃ¡n khÃ´ng tÆ°Æ¡ng thÃ­ch',0),(314866,8747,'af','Stukwerk Konflikte',0),(314867,8747,'ro','Conflictele de acord',0),(314868,8747,'et','TÃ¼kitÃ¶Ã¶ konfliktid',0),(314869,8747,'si','Akord konfliktov',0),(314870,8747,'ba','Konflik piecework',0),(314871,8747,'nl','Stukloon conflicten',0),(314872,8747,'fi','Urakka ristiriidat',0),(314873,8747,'no','StykkavlÃ¸nning konflikter',0),(314874,8747,'da','Akkordarbejde konflikter',0),(314875,8747,'ko','Piecework ì¶©ëŒ',0),(314876,8747,'he','×§×•× ×¤×œ×™×§×˜×™× ×¢×‘×•×“×” ×‘×§×‘×œ× ×•×ª',0),(314877,8747,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹ ÏƒÏ…Î³ÎºÏÎ¿ÏÏƒÎµÎ¹Ï‚',0),(314878,8747,'zh','è®¡ä»¶å†²çª\r\n',0),(314879,8747,'sv','Ackord konflikter',0),(314880,8747,'it','Conflitti di lavoro a cottimo',0),(314881,8747,'tl','',0),(314882,8747,'th','&#3594;&#3636;&#3657;&#3609;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3586;&#3633;&#3604;&#3649;&#3618;&#3657;&#3591;',0),(314883,8747,'hi','Piecework à¤µà¤¿à¤°à¥‹à¤§',0),(314884,8747,'ms','Piecework konflik',0),(314885,8747,'ar','Ù†Ø²Ø§Ø¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„ Ø¨Ø§Ù„Ù‚Ø·Ø¹Ø©',0),(314886,8747,'fr','Conflits de travail Ã  la piÃ¨ce',0),(314887,8747,'jp','å‡ºæ¥é«˜æ‰•ã„ã®ç«¶åˆ',0),(314888,8747,'pt','Conflitos de trabalho por tarefa',0),(314889,8747,'ru','Ð¡Ð´ÐµÐ»ÑŒÐ½Ð°Ñ ÐºÐ¾Ð½Ñ„Ð»Ð¸ÐºÑ‚Ñ‹',0),(314890,8747,'es','Conflictos de Trabajo por Pieza',0),(314891,8747,'de','Akkord-Konflikte',0),(314892,8747,'en','Piecework Conflicts',0),(314893,8748,'is','',0),(314894,8748,'dr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ø­Ù‚ÙˆÙ‚',0),(314895,8748,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªÙ…Ø§Ù… Ø­Ù‚ÙˆÙ‚',0),(314896,8748,'tr','TÃ¼m Ã¶deme toplam',0),(314897,8748,'pl','Suma wszystkich zapÅ‚aciÄ‡',0),(314898,8748,'bg','ÐžÐ±Ñ‰Ð¾ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð»Ð°Ñ‚Ð¸',0),(314899,8748,'ur','ØªÙ…Ø§Ù… Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ù„',0),(314900,8748,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÑÐ²Ð¸ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸',0),(314901,8748,'vi','Tá»•ng cá»™ng táº¥t cáº£ lÆ°Æ¡ng',0),(314902,8748,'af','Bereken Totale Besoldiging',0),(314903,8748,'ro','Total de plata tuturor',0),(314904,8748,'et','Kokku kÃµik maksma',0),(314905,8748,'si','Skupaj vse plaÄati',0),(314906,8748,'ba','Jumlah semua Pay',0),(314907,8748,'nl','Total alle Pay',0),(314908,8748,'fi','YhteensÃ¤ kaikki Pay',0),(314909,8748,'no','Sum alle betale',0),(314910,8748,'da','Alle lÃ¸n i alt',0),(314911,8748,'ko','ëª¨ë“  ì§€ë¶ˆì„ ì´',0),(314912,8748,'he','×¡×š ×›×œ ×”×©×›×¨',0),(314913,8748,'el','Î£ÏÎ½Î¿Î»Î¿ Ï€Î»Î·ÏÏŽÏƒÎ¿Ï…Î¼Îµ ÏŒÎ»Î¿Î¹',0),(314914,8748,'zh','æ€»è®¡æ‰€æœ‰æ”¯ä»˜\r\n',0),(314915,8748,'sv','Totalt alla betala',0),(314916,8748,'it','Totale pagano tutti',0),(314917,8748,'tl','',0),(314918,8748,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(314919,8748,'hi','à¤¸à¤­à¥€ à¤µà¥‡à¤¤à¤¨ à¤•à¥à¤²',0),(314920,8748,'ms','Jumlah semua gaji',0),(314921,8748,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø£Ø¬Ø± Ø¬Ù…ÙŠØ¹',0),(314922,8748,'fr','Tous les salaire total',0),(314923,8748,'jp','ã™ã¹ã¦ã®æ”¯æ‰•ã„ã‚’åˆè¨ˆã—ã¾ã™ã€‚',0),(314924,8748,'pt','Total a pagar todos os',0),(314925,8748,'ru','Ð’ÑÐµÐ³Ð¾ Ð²ÑÐµ ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ðµ',0),(314926,8748,'es','Total Todos los Pagos',0),(314927,8748,'de','Insgesamt alle Pay',0),(314928,8748,'en','Total All Pay',0),(314929,8749,'is','',0),(314930,8749,'dr','Ø¬Ù…Ø¹ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³Ø§Ø¹ØªÙŠ ',0),(314931,8749,'pr','Ø¬Ù…Ø¹ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³Ø§Ø¹ØªÙŠ ',0),(314932,8749,'tr','Saatlik Ã¼cret toplam',0),(314933,8749,'pl','Godzinowe wynagrodzenie ogÃ³Å‚em',0),(314934,8749,'bg','ÐŸÐ¾Ñ‡Ð°ÑÐ¾Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð° Ð¾Ð±Ñ‰Ð¾',0),(314935,8749,'ur','Ú¯Ú¾Ù†Ù¹Û Ú¯Ú¾Ø± Ú©ÛŒ ÙˆÛŒØ¬ Ú©Ù„',0),(314936,8749,'sr','ÐÐ° ÑÐ²Ð°ÐºÐ¸ ÑÐ°Ñ‚ ÑƒÐºÑƒÐ¿Ð½Ð¾ Ð¿Ð»Ð°Ñ‚Ð°',0),(314937,8749,'vi','Tá»•ng cá»™ng LÆ°Æ¡ng giá»',0),(314938,8749,'af','Uurlikse Besoldigingstotaal',0),(314939,8749,'ro','Orare salariul Total',0),(314940,8749,'et','Tunni keskmiste palkade kogusumma',0),(314941,8749,'si','Urnih plaÄ skupaj',0),(314942,8749,'ba','Total upah per jam',0),(314943,8749,'nl','Per uur loon totaal',0),(314944,8749,'fi','Tunnin palkka yhteensÃ¤',0),(314945,8749,'no','Timebasert lÃ¸nn totalt',0),(314946,8749,'da','Hver time lÃ¸n i alt',0),(314947,8749,'ko','ì‹œê°„ë‹¹ ìž„ê¸ˆ ì´',0),(314948,8749,'he','×¡×” ×› ×©×›×¨ ×©×¢×ª×™',0),(314949,8749,'el','Î©ÏÎ¹Î±Î¯Î± ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬ Î¼Î¹ÏƒÎ¸ÏŒ',0),(314950,8749,'zh','æ¯å°æ—¶å·¥èµ„æ€»é¢\r\n',0),(314951,8749,'sv','Tim lÃ¶n totalt',0),(314952,8749,'it','Totale di retribuzione oraria',0),(314953,8749,'tl','',0),(314954,8749,'th','&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3619;&#3634;&#3618;&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3619;&#3623;&#3617;',0),(314955,8749,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾ à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤•à¥à¤²',0),(314956,8749,'ms','Ganda gaji jumlah',0),(314957,8749,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø£Ø¬ÙˆØ± ÙƒÙ„ Ø³Ø§Ø¹Ø©',0),(314958,8749,'fr','Total de salaire horaire',0),(314959,8749,'jp','1 æ™‚é–“ã”ã¨ã®è³ƒé‡‘åˆè¨ˆ',0),(314960,8749,'pt','Total de salÃ¡rio por hora',0),(314961,8749,'ru','ÐŸÐ¾Ñ‡Ð°ÑÐ¾Ð²Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð²ÑÐµÐ³Ð¾',0),(314962,8749,'es','Total de sueldos por hora',0),(314963,8749,'de','StÃ¼ndlicher Lohn Total',0),(314964,8749,'en','Hourly Wage Total',0),(314965,8750,'is','',0),(314966,8750,'dr','ÙƒÙ„ Ø²Ù…Ø§Ù† ÙƒØ§Ø±Ø´Ø¯Ù‡ ',0),(314967,8750,'pr','ÙƒÙ„ Ø²Ù…Ø§Ù† ÙƒØ§Ø±Ø´Ø¯Ù‡ ',0),(314968,8750,'tr','Toplam sÃ¼re Ã§alÄ±ÅŸtÄ±',0),(314969,8750,'pl','CaÅ‚kowity czas pracowaÅ‚',0),(314970,8750,'bg','ÐžÐ±Ñ‰Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð¸',0),(314971,8750,'ur','Ú©Ù„ ÙˆÙ‚Øª Ú©Ø§Ù… Ú©ÛŒØ§ Û”',0),(314972,8750,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ñ€Ð°Ð´Ð¸Ð¾',0),(314973,8750,'vi','Tá»•ng cá»™ng thá»i gian lÃ m viá»‡c',0),(314974,8750,'af','Totale Tyd Gewerk',0),(314975,8750,'ro','Timpul total a lucrat',0),(314976,8750,'et','TÃ¶Ã¶tas koguaeg',0),(314977,8750,'si','Skupni Äas delal',0),(314978,8750,'ba','Total waktu, bekerja',0),(314979,8750,'nl','Totale tijd gewerkt',0),(314980,8750,'fi','Koko tyÃ¶aika',0),(314981,8750,'no','Total tid arbeidet',0),(314982,8750,'da','Samlede arbejdstid',0),(314983,8750,'ko','ì¼ í•œ ì´ ì‹œê°„',0),(314984,8750,'he','×”×–×ž×Ÿ ×”×›×•×œ×œ ×¢×‘×“',0),(314985,8750,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒÏ‚ Ï‡ÏÏŒÎ½Î¿Ï‚ Î»ÎµÎ¹Ï„Î¿ÏÏÎ³Î·ÏƒÎµ',0),(314986,8750,'zh','æ€»å·¥ä½œæ—¶é—´\r\n',0),(314987,8750,'sv','Total tid arbetat',0),(314988,8750,'it','Totale tempo lavorato',0),(314989,8750,'tl','',0),(314990,8750,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3648;&#3623;&#3621;&#3634;&#3607;&#3635;&#3591;&#3634;&#3609;',0),(314991,8750,'hi','à¤•à¥à¤² à¤¸à¤®à¤¯ à¤•à¤¾à¤® à¤•à¤¿à¤¯à¤¾',0),(314992,8750,'ms','Jumlah masa bekerja',0),(314993,8750,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ ÙˆÙ‚Øª Ø§Ù„Ø¹Ù…Ù„',0),(314994,8750,'fr','Temps total de travail',0),(314995,8750,'jp','ä½œæ¥­æ™‚é–“ã®åˆè¨ˆ',0),(314996,8750,'pt','Tempo total trabalhado',0),(314997,8750,'ru','ÐžÐ±Ñ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð»',0),(314998,8750,'es','Tiempo Total Trabajado',0),(314999,8750,'de','Gesamtzeit gearbeitet',0),(315000,8750,'en','Total Time Worked',0),(315001,8751,'is','',0),(315002,8751,'dr','Ø¯ÙŠÚ¯Ø± Ø­Ù‚ÙˆÙ‚ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(315003,8751,'pr','Ø¯ÙŠÚ¯Ø± Ø­Ù‚ÙˆÙ‚ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª',0),(315004,8751,'tr','DiÄŸer vergiden maaÅŸ',0),(315005,8751,'pl','Inne wynagrodzenia niepodlegajÄ…cym opodatkowaniu',0),(315006,8751,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð½ÐµÐ·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸ Ð¿Ð»Ð°Ñ‚Ð¸',0),(315007,8751,'ur','Ø¯ÛŒÚ¯Ø± Ù…Ø³ØªØ«Ù†Ù°ÛŒ ØªÙ†Ø®ÙˆØ§Û',0),(315008,8751,'sr','Ð”Ñ€ÑƒÐ³Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ðµ Ð¾Ð¿Ð¾Ñ€ÐµÐ·ÑƒÑ˜Ðµ',0),(315009,8751,'vi','LÆ°Æ¡ng khÃ´ng Ä‘Ã¡nh thuáº¿ KhÃ¡c',0),(315010,8751,'af','Ander Nie-Belasbare Besoldiging',0),(315011,8751,'ro','Alte plata neimpozabile',0),(315012,8751,'et','Muu mittemaksukohustuslasest tasu',0),(315013,8751,'si','Drugi davÄni zavezanec plaÄati',0),(315014,8751,'ba','Bayar tidak kena pajak lainnya',0),(315015,8751,'nl','Ander niet-belastbare loon',0),(315016,8751,'fi','Muille kuin verovelvollisille maksu',0),(315017,8751,'no','Andre ikke-skattepliktige betale',0),(315018,8751,'da','Andre ikke-afgiftspligtige lÃ¸n',0),(315019,8751,'ko','ë‹¤ë¥¸ ë¹„ ê³¼ì„¸ ê¸‰ì—¬',0),(315020,8751,'he','××—×¨×™× ×”×©×›×¨ ×©××™× ×• ×—×™×™×‘ ×œ×©×œ×',0),(315021,8751,'el','Î†Î»Î»ÎµÏ‚ Î±Î¼Î¿Î¹Î²Î­Ï‚ Î¼Î· Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿',0),(315022,8751,'zh','å…¶ä»–éžåº”ç¨Žè–ªé…¬\r\n',0),(315023,8751,'sv','Andra icke beskattningsbara lÃ¶n',0),(315024,8751,'it','Altro paga Non soggetti passivi',0),(315025,8751,'tl','',0),(315026,8751,'th','&#3629;&#3639;&#3656;&#3609;&#3654; &#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;&#3648;&#3626;&#3637;&#3618;&#3616;&#3634;&#3625;&#3637;',0),(315027,8751,'hi','à¤…à¤¨à¥à¤¯ à¤—à¥ˆà¤°-à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨',0),(315028,8751,'ms','Lain-lain bayaran tidak dikenakan cukai',0),(315029,8751,'ar','Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø£Ø®Ø±Ù‰ ØºÙŠØ± Ø§Ù„Ø®Ø§Ø¶Ø¹Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(315030,8751,'fr','Autre rÃ©munÃ©ration Non imposable',0),(315031,8751,'jp','ä»–ã®éžèª²ç¨Žã®æ”¯æ‰•',0),(315032,8751,'pt','Outro pagamento nÃ£o-tributÃ¡veis',0),(315033,8751,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ð¿Ð»Ð°Ñ‚ÑÑ‚ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼',0),(315034,8751,'es','Otro Pago No Imponible',0),(315035,8751,'de','Anderer nicht-steuerpflichtige Lohn',0),(315036,8751,'en','Other Nonttaxable Pay',0),(315037,8752,'is','',0),(315038,8752,'dr','Ø¯ÙŠÚ¯Ø± Ø­Ù‚ÙˆÙ‚ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(315039,8752,'pr','Ø¯ÙŠÚ¯Ø± Ø­Ù‚ÙˆÙ‚ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(315040,8752,'tr','Vergiye tabi diÄŸer Ã¶deme',0),(315041,8752,'pl','Inne opodatkowania wynagrodzenia',0),(315042,8752,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸ Ð¿Ð»Ð°Ñ‚Ð¸',0),(315043,8752,'ur','Ø¯ÛŒÚ¯Ø± Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ ØªÙ†Ø®ÙˆØ§Û',0),(315044,8752,'sr','Ð”Ñ€ÑƒÐ³Ð¸ Ð¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ',0),(315045,8752,'vi','Tráº£ thuáº¿ khÃ¡c',0),(315046,8752,'af','Ander Belasbare Besoldiging',0),(315047,8752,'ro','Alte plata impozabile',0),(315048,8752,'et','Muud maksustatava tÃ¶Ã¶tasu',0),(315049,8752,'si','Drugi davÄni plaÄati',0),(315050,8752,'ba','Membayar pajak lainnya',0),(315051,8752,'nl','Ander belastbare loon',0),(315052,8752,'fi','Muut veron maksu',0),(315053,8752,'no','Andre skattepliktige betale',0),(315054,8752,'da','Andre skattepligtige lÃ¸n',0),(315055,8752,'ko','ë‹¤ë¥¸ ê³¼ì„¸ ëŒ€ìƒ ê¸‰ì—¬',0),(315056,8752,'he','××—×¨×™× ×—×™×™×‘ ×‘×ž×¡ ×©×›×¨',0),(315057,8752,'el','Î†Î»Î»Î¿ Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½',0),(315058,8752,'zh','å…¶ä»–å¾ç¨Žæ”¶è´¹\r\n',0),(315059,8752,'sv','Andra beskattningsbara lÃ¶n',0),(315060,8752,'it','Altro paga passivo',0),(315061,8752,'tl','',0),(315062,8752,'th','&#3616;&#3634;&#3625;&#3637;&#3629;&#3639;&#3656;&#3609;&#3654;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;',0),(315063,8752,'hi','à¤…à¤¨à¥à¤¯ à¤•à¤°à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨',0),(315064,8752,'ms','Membayar cukai lain',0),(315065,8752,'ar','Ø§Ù„Ø£Ø®Ø±Ù‰ Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(315066,8752,'fr','Autre rÃ©munÃ©ration imposable',0),(315067,8752,'jp','èª²ç¨Žã®ä»–ã®æ”¯æ‰•',0),(315068,8752,'pt','Outro pagamento tributÃ¡vel',0),(315069,8752,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð¾Ð³Ð¾ Ð²Ð¾Ð·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(315070,8752,'es','Otro Pago Imponible',0),(315071,8752,'de','Anderer Steuerpflichtiger Lohn',0),(315072,8752,'en','Other Taxable Pay',0),(315073,8753,'is','',0),(315074,8753,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙˆÙŠÚ˜Ú¯ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ùˆ Ø§Ø±ØªÙ‚Ø§Ø¹ Ø¯Ù‡Ù†Ø¯Ù‡ Ø¨Ø±Ù†Ø§Ù…Ù‡ ',0),(315075,8753,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙˆÙŠÚ˜Ú¯ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ùˆ Ø§Ø±ØªÙ‚Ø§Ø¹ Ø¯Ù‡Ù†Ø¯Ù‡ Ø¨Ø±Ù†Ø§Ù…Ù‡ ',0),(315076,8753,'tr','Eklentileri etkinleÅŸtirin',0),(315077,8753,'pl','AktywowaÄ‡ Dodatki',0),(315078,8753,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(315079,8753,'ur','Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(315080,8753,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(315081,8753,'vi','Cá»™ng ThÃªm & Cáº¯m VÃ o',0),(315082,8753,'af','Byvoegings & Inproppe',0),(315083,8753,'ro','Add-ons & Plug-ins',0),(315084,8753,'et','Lisad ja pluginad',0),(315085,8753,'si','Aktiviranje dodatkov',0),(315086,8753,'ba','Add-ons & Plug-ins',0),(315087,8753,'nl','Activeren van Add-Ons',0),(315088,8753,'fi','Aktivoi lisÃ¤osat',0),(315089,8753,'no','Aktivere tillegg',0),(315090,8753,'da','Aktivere tilfÃ¸jelser',0),(315091,8753,'ko','ì¶”ê°€ ê¸°ëŠ¥ í™œì„±í™”',0),(315092,8753,'he','×ª×•×¡×¤×•×ª ×•×ª×•×¡×¤×™×',0),(315093,8753,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î±',0),(315094,8753,'zh','é™„åŠ ç»„ä»¶å’Œæ’ä»¶\r\n',0),(315095,8753,'sv','Aktivera tillÃ¤gg',0),(315096,8753,'it','Attivare i componenti aggiuntivi',0),(315097,8753,'tl','',0),(315098,8753,'th','Add-ons & Plug-ins',0),(315099,8753,'hi','à¤à¤¡-à¤‘à¤¨à¥à¤¸ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(315100,8753,'ms','Aktifkan tambahan',0),(315101,8753,'ar','ØªÙ†Ø´ÙŠØ· Ø§Ù„Ø¥Ø¶Ø§ÙØ§Øª',0),(315102,8753,'fr','Activer les modules',0),(315103,8753,'jp','ã‚¢ãƒ‰ã‚ªãƒ³ã‚’æœ‰åŠ¹ã«ã—ã¾ã™ã€‚',0),(315104,8753,'pt','Ativar Add-ons',0),(315105,8753,'ru','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(315106,8753,'es','Dispositivos de AmpliaciÃ³n & de Complementos',0),(315107,8753,'de','Add-ons aktivieren',0),(315108,8753,'en','Activate Add-Ons',0),(315109,8754,'is','',0),(315110,8754,'dr','ÙˆÙŠÚ˜Ú¯ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ùˆ Ø§ØªØµØ§Ù„ Ø¨Ù‡ Ø¯ÙˆØ´Ø§Ø®Ù‡ Ø®Ø±ÙŠØ¯ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª \r\n Add-ons & Plug-ins',0),(315111,8754,'pr','ÙˆÙŠÚ˜Ú¯ÙŠ Ø§ÙØ²ÙˆØ¯Ù†ÙŠ Ùˆ Ø§ØªØµØ§Ù„ Ø¨Ù‡ Ø¯ÙˆØ´Ø§Ø®Ù‡ Ø®Ø±ÙŠØ¯ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª \r\n Add-ons & Plug-ins',0),(315112,8754,'tr','SatÄ±n alma ve eklentileri yÃ¶net',0),(315113,8754,'pl','Zakupu i zarzÄ…dzania dodatkami',0),(315114,8754,'bg','Ð—Ð°ÐºÑƒÐ¿ÑƒÐ²Ð°Ð½Ðµ Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸Ñ‚Ðµ',0),(315115,8754,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ø§ÙˆØ± Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº ons Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±ÛŒÚº',0),(315116,8754,'sr','ÐÐ°Ð±Ð°Ð²ÐºÐµ Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°Ñ˜Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ†Ð¸Ð¼Ð°',0),(315117,8754,'vi','Mua & Quáº£n lÃ½ cá»™ng thÃªm & cáº¯m vÃ o',0),(315118,8754,'af','Aankoop en Inrig van Byvoegings & Inproppe',0),(315119,8754,'ro','CumpÄƒrare ÅŸi de a gestiona Suplimente',0),(315120,8754,'et','Osta ja halda lisasid ja pluginaid',0),(315121,8754,'si','Nakup in upravljanje dodatkov',0),(315122,8754,'ba','Membeli dan mengelola Pengaya',0),(315123,8754,'nl','Kopen en invoegtoepassingen beheren',0),(315124,8754,'fi','Osto- ja hallitse lisÃ¤osia',0),(315125,8754,'no','KjÃ¸pe og administrere tillegg',0),(315126,8754,'da','KÃ¸be og administrere tilfÃ¸jelser',0),(315127,8754,'ko','êµ¬ë§¤ í•˜ ê³  ì¶”ê°€ ê¸°ëŠ¥ì„ ê´€ë¦¬',0),(315128,8754,'he','×œ×¨×›×•×© ×•×œ× ×”×œ ×ª×•×¡×¤×•×ª',0),(315129,8754,'el','Î‘Î³Î¿ÏÎ¬ ÎºÎ±Î¹ Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Ï€ÏÏŒÏƒÎ¸ÎµÏ„Ï‰Î½',0),(315130,8754,'zh','è´­ä¹°å’Œç®¡ç†åŠ è½½é¡¹å’Œæ’ä»¶\r\n',0),(315131,8754,'sv','KÃ¶pa och hantera tillÃ¤gg',0),(315132,8754,'it','Acquisto e gestione componenti aggiuntivi',0),(315133,8754,'tl','',0),(315134,8754,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619; Add-ons & Plug-ins',0),(315135,8754,'hi','à¤–à¤°à¥€à¤¦ à¤”à¤° à¤à¤¡-à¤‘à¤¨à¥à¤¸ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(315136,8754,'ms','Membeli dan menguruskan tambahan',0),(315137,8754,'ar','Ø´Ø±Ø§Ø¡ ÙˆØ¥Ø¯Ø§Ø±Ø© Ø§Ù„Ø¥Ø¶Ø§ÙØ§Øª',0),(315138,8754,'fr','Acheter et gÃ©rer les modules complÃ©mentaires',0),(315139,8754,'jp','è³¼å…¥ã—ã€ã‚¢ãƒ‰ã‚ªãƒ³ã®ç®¡ç†',0),(315140,8754,'pt','Adquirir e Gerenciar Complementos',0),(315141,8754,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð°Ð´ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°Ð¼Ð¸',0),(315142,8754,'es','Comprar y Supervisar Add-ons y Plug-ins',0),(315143,8754,'de','Kaufen und Verwalten von Add-ons',0),(315144,8754,'en','Purchase and Manage Add-Ons',0),(315145,8755,'is','',0),(315146,8755,'dr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(315147,8755,'pr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(315148,8755,'tr','Kredi kartÄ± ile Ã¶n Ã¶demeli',0),(315149,8755,'pl','PrzedpÅ‚ata kartÄ… kredytowÄ…',0),(315150,8755,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð»Ð°Ñ‚ÐµÐ½ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(315151,8755,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ (Ù„Ø§Ù†Ú¯ ÚˆØ³Ù¹Ù†Ø³)',0),(315152,8755,'sr','ÐÐ²Ð°Ð½ÑÐ½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(315153,8755,'vi','Tráº£ trÆ°á»›c báº±ng tháº» tÃ­n dá»¥ng',0),(315154,8755,'af','Vooruitbetaal per Kredietkaart',0),(315155,8755,'ro','Prepaid Card de Credit',0),(315156,8755,'et','Ettemakstud krediitkaardi',0),(315157,8755,'si','PredplaÄila s kreditno kartico',0),(315158,8755,'ba','Prabayar menggunakan kartu kredit',0),(315159,8755,'nl','Vooruitbetaling per Credit Card',0),(315160,8755,'fi','Prepaid Luottokortti',0),(315161,8755,'no','ForhÃ¥ndsbetalt kredittkort',0),(315162,8755,'da','Forudbetaling med kreditkort',0),(315163,8755,'ko','ì‹ ìš© ì¹´ë“œë¡œ ì„ ë¶ˆ',0),(315164,8755,'he','×ª×©×œ×•× ×ž×¨××© ×‘××ž×¦×¢×•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(315165,8755,'el','Î ÏÎ¿Ï€Î»Î·ÏÏ‰Î¼Î­Î½Î· Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(315166,8755,'zh','ä»¥ä¿¡ç”¨å¡é¢„ä»˜\r\n',0),(315167,8755,'sv','FÃ¶rutbetalda kreditkort',0),(315168,8755,'it','Prepagata con carta di credito',0),(315169,8755,'tl','',0),(315170,8755,'th','&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3585;&#3656;&#3629;&#3609;&#3612;&#3656;&#3634;&#3609;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(315171,8755,'hi','à¤ªà¥à¤°à¥€à¤ªà¥‡à¤¡ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(315172,8755,'ms','Prabayar dengan kad kredit',0),(315173,8755,'ar','Ù…Ø¯ÙÙˆØ¹ Ù…Ø³Ø¨Ù‚Ø§ Ø¨Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(315174,8755,'fr','PayÃ© par carte de crÃ©dit',0),(315175,8755,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã«ã‚ˆã‚‹å‰æ‰•ã„',0),(315176,8755,'pt','PrÃ©-pagamento por cartÃ£o de crÃ©dito',0),(315177,8755,'ru','ÐŸÑ€ÐµÐ´Ð¾Ð¿Ð»Ð°Ñ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(315178,8755,'es','Prepagado por Tarjeta de CrÃ©dito',0),(315179,8755,'de','Prepaid Kreditkarte',0),(315180,8755,'en','Prepaid by Credit Card',0),(315181,8756,'is','',0),(315182,8756,'dr','Ø¯Ø± Ø«Ø¨Øª Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(315183,8756,'pr','Ø¯Ø± Ø«Ø¨Øª Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(315184,8756,'tr','Teklif giriÅŸinin Ã¼zerinde gÃ¶sterme',0),(315185,8756,'pl','Nie pokazuj na ofertÄ™ wpisu',0),(315186,8756,'bg','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(315187,8756,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ù†Û Ú©Ø±ÛŒÚº',0),(315188,8756,'sr','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·ÑƒÑ˜ Ð½Ð° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° ÑƒÐ½Ð¾Ñ',0),(315189,8756,'vi','KhÃ´ng Hiá»ƒn Thá»‹ Entry BÃ¡o GiÃ¡',0),(315190,8756,'af','Moenie Op Kwotasie-inskrywing Wys ',0),(315191,8756,'ro','Nu aratÄƒ intrarea citat',0),(315192,8756,'et','NÃ¤ita pakkumise sisenemisel',0),(315193,8756,'si','Ne kaÅ¾ejo na ponudbo vstop',0),(315194,8756,'ba','Tidak menunjukkan pada entri kutipan',0),(315195,8756,'nl','Heb niet weergegeven op offerte Entry',0),(315196,8756,'fi','NÃ¤ytÃ¤ tarjouspyynnÃ¶n merkintÃ¤',0),(315197,8756,'no','Ikke Vis pÃ¥ tilbud oppfÃ¸ring',0),(315198,8756,'da','Vis ikke pÃ¥ tilbud post',0),(315199,8756,'ko','ê²¬ì  í•­ëª©ì— í‘œì‹œ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(315200,8756,'he','×œ× ×ž×¨××™× ×¢×œ ×”×¦×¢×ª ×ž×—×™×¨ ×›× ×™×¡×”',0),(315201,8756,'el','ÎÎ± Î¼Î·Î½ ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ¯ÏƒÎ¿Î´Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(315202,8756,'zh','ä¸ä¼šå‡ºçŽ°åœ¨æŠ¥ä»·æ¡ç›®\r\n',0),(315203,8756,'sv','Visa inte pÃ¥ citat post',0),(315204,8756,'it','Non mostrare sulla voce del preventivo',0),(315205,8756,'tl','',0),(315206,8756,'th','&#3629;&#3618;&#3656;&#3634;&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;',0),(315207,8756,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤ªà¤° à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(315208,8756,'ms','Jangan tunjuk pada entri Quote',0),(315209,8756,'ar','Ù„Ø§ ØªØ¸Ù‡Ø± Ø¹Ù„Ù‰ Ø¯Ø®ÙˆÙ„ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(315210,8756,'fr','Ne montrez pas Ã  l\'entrÃ©e de la citation',0),(315211,8756,'jp','å¼•ç”¨ã‚¨ãƒ³ãƒˆãƒªã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(315212,8756,'pt','NÃ£o mostrar na entrada de citaÃ§Ã£o',0),(315213,8756,'ru','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð½Ð° Ð²Ñ…Ð¾Ð´ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(315214,8756,'es','No Muestra en la Entrada de la CotizaciÃ³n',0),(315215,8756,'de','Nicht auf Zitat Eintrag anzeigen',0),(315216,8756,'en','Do Not Show On Quote Entry',0),(315217,8757,'is','',0),(315218,8757,'dr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(315219,8757,'pr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(315220,8757,'tr','Sadece emirleri',0),(315221,8757,'pl','ZamÃ³wienia tylko',0),(315222,8757,'bg','Ð¡Ð°Ð¼Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(315223,8757,'ur','ØµØ±Ù Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(315224,8757,'sr','Ð¡Ð°Ð¼Ð¾ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(315225,8757,'vi','Chá»‰ ÄÆ¡n Äáº·t HÃ ng',0),(315226,8757,'af','Slegs Bestellings',0),(315227,8757,'ro','Comenzile numai',0),(315228,8757,'et','Ainult tellimused',0),(315229,8757,'si','NaroÄila samo',0),(315230,8757,'ba','Perintah hanya',0),(315231,8757,'nl','Bestellingen',0),(315232,8757,'fi','Tilauksia vain',0),(315233,8757,'no','Bestillinger bare',0),(315234,8757,'da','Ordrer kun',0),(315235,8757,'ko','ì£¼ë¬¸ì—ë§Œ í•´ë‹¹',0),(315236,8757,'he','×”×–×ž× ×•×ª ×‘×œ×‘×“',0),(315237,8757,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î¼ÏŒÎ½Î¿',0),(315238,8757,'zh','åªæœ‰è®¢å•\r\n',0),(315239,8757,'sv','Order endast',0),(315240,8757,'it','Ordini solo',0),(315241,8757,'tl','',0),(315242,8757,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(315243,8757,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡à¤µà¤²',0),(315244,8757,'ms','Pesanan sahaja',0),(315245,8757,'ar','Ø£ÙˆØ§Ù…Ø± ÙÙ‚Ø·',0),(315246,8757,'fr','Commandes seulement',0),(315247,8757,'jp','æ³¨æ–‡ã®ã¿',0),(315248,8757,'pt','Ordens sÃ³',0),(315249,8757,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(315250,8757,'es','Ordenes Solo',0),(315251,8757,'de','Bestellungen nur',0),(315252,8757,'en','Orders Only',0),(315253,8758,'is','',0),(315254,8758,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø²Ù…Ø§Ù† Ù‡Ø§ ',0),(315255,8758,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø²Ù…Ø§Ù† Ù‡Ø§ ',0),(315256,8758,'tr','ZamanlarÄ± gÃ¶rÃ¼ntÃ¼le\'nÄ±n ana ekranÄ±na geri dÃ¶nÃ¼n',0),(315257,8758,'pl','PowrÃ³t do gÅ‚Ã³wnego ekranu do widoku razy',0),(315258,8758,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð³Ð»Ð°Ð²ÐµÐ½ Ð¿Ð°Ñ€Ð°Ð²Ð°Ð½ Ð´Ð¾ Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¿ÑŠÑ‚Ð¸',0),(315259,8758,'ur','Ù…Ø±Ú©Ø²ÛŒ Ø³Ú©Ø±ÛŒÙ† Ù…Ù†Ø¸Ø± Ø¨Ø§Ø± Ú©Ùˆ ÙˆØ§Ù¾Ø³',0),(315260,8758,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ñƒ Ð³Ð»Ð°Ð²Ð½Ð¸ ÐµÐºÑ€Ð°Ð½ Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(315261,8758,'vi','Trá»Ÿ láº¡i mÃ n hÃ¬nh chÃ­nh Ä‘á»ƒ xem thá»i gian',0),(315262,8758,'af','Terugkeer na Hoofskerm om Tye te Besigtig',0),(315263,8758,'ro','A reveni la ecranul principal-Vezi ori',0),(315264,8758,'et','Vaata aegu pÃµhikuvale naasmiseks',0),(315265,8758,'si','Vrnitev glavni zaslon za ogled krat',0),(315266,8758,'ba','Kembali ke layar utama untuk melihat kali',0),(315267,8758,'nl','Terug te keren naar het hoofdscherm te keer',0),(315268,8758,'fi','Palata pÃ¤Ã¤nÃ¤yttÃ¶ NÃ¤ytÃ¤ ajat',0),(315269,8758,'no','GÃ¥ tilbake til hovedskjermbildet visning ganger',0),(315270,8758,'da','Vende tilbage til hovedskÃ¦rmen for visning gange',0),(315271,8758,'ko','ë³´ê¸° ë²ˆ ë©”ì¸ í™”ë©´ìœ¼ë¡œ ëŒì•„ê°‘ë‹ˆë‹¤',0),(315272,8758,'he','×œ×—×–×•×¨ ×œ×ž×¡×š ×”×¨××©×™ ×ª×¦×•×’×” ×¤×¢×ž×™×',0),(315273,8758,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÏƒÏ„Î·Î½ ÎºÏÏÎ¹Î± Î¿Î¸ÏŒÎ½Î· Î³Î¹Î± Ï€ÏÎ¿Î²Î¿Î»Î® Ï†Î¿ÏÎ­Ï‚',0),(315274,8758,'zh','è¿”å›žåˆ°ä¸»ç”»é¢æŸ¥çœ‹æ¬¡æ•°\r\n',0),(315275,8758,'sv','Ã…tergÃ¥ till huvudskÃ¤rmen till Visa gÃ¥nger',0),(315276,8758,'it','Tornare alla schermata principale di vista volte',0),(315277,8758,'tl','',0),(315278,8758,'th','&#3588;&#3639;&#3609;&#3626;&#3641;&#3656;&#3627;&#3609;&#3657;&#3634;&#3592;&#3629;&#3627;&#3621;&#3633;&#3585;&#3651;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;&#3607;&#3637;&#3656;&#3604;&#3641;',0),(315279,8758,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤Ÿà¤¾à¤‡à¤®à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥à¤–à¥à¤¯ à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤ªà¤° à¤µà¤¾à¤ªà¤¸ à¤œà¤¾à¤à¤',0),(315280,8758,'ms','Kembali ke skrin utama untuk paparan Times',0),(315281,8758,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ù„Ø´Ø§Ø´Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ù„Ø¹Ø±Ø¶ Ø§Ù„Ø£ÙˆÙ‚Ø§Øª',0),(315282,8758,'fr','Revenir Ã  l\'Ã©cran principal Ã  vue fois',0),(315283,8758,'jp','æ™‚é–“ã‚’è¡¨ç¤ºã™ã‚‹ãƒ¡ã‚¤ãƒ³ç”»é¢ã«æˆ»ã‚Šã¾ã™',0),(315284,8758,'pt','Regressar ao ecrÃ£ principal para ver os tempos',0),(315285,8758,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ð½Ð° Ð“Ð»Ð°Ð²Ð½Ñ‹Ð¹ Ð­ÐºÑ€Ð°Ð½ Ð´Ð»Ñ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð’Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(315286,8758,'es','Regresar a Pantalla Principal para Visionar Tiempos',0),(315287,8758,'de','ZurÃ¼ck zum Hauptbildschirm Ansicht mal',0),(315288,8758,'en','Return to Main Screen to View Times',0),(315289,8759,'is','',0),(315290,8759,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù‡Ù… Ø§ÙƒÙ†ÙˆÙ† Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(315291,8759,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù‡Ù… Ø§ÙƒÙ†ÙˆÙ† Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(315292,8759,'tr','Åžimdi eklemek iÃ§in burayÄ± tÄ±klatÄ±n',0),(315293,8759,'pl','Kliknij tutaj, aby dodaÄ‡ teraz',0),(315294,8759,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ ÑÐµÐ³Ð°',0),(315295,8759,'ur','Ø§Ø¨ Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(315296,8759,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ ÑÐ°Ð´Ð°',0),(315297,8759,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ ThÃªm bÃ¢y giá»',0),(315298,8759,'af','Klik hier om nou te voeg',0),(315299,8759,'ro','Click aici pentru a Adauga acum',0),(315300,8759,'et','NÃ¼Ã¼d lisamiseks klÃµpsake siin',0),(315301,8759,'si','Kliknite tukaj, da dodate zdaj',0),(315302,8759,'ba','Klik disini untuk menambahkan sekarang',0),(315303,8759,'nl','Klik hier om toe te voegen nu',0),(315304,8759,'fi','Klikkaa tÃ¤stÃ¤ lisÃ¤Ã¤ nyt',0),(315305,8759,'no','Klikk her for Ã¥ legge til nÃ¥',0),(315306,8759,'da','Klik her for at tilfÃ¸je nu',0),(315307,8759,'ko','ì§€ê¸ˆ ì¶”ê°€ í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(315308,8759,'he','×œ×—×¥ ×›××Ÿ ×œ×”×•×¡×™×£ ×›×¢×ª',0),(315309,8759,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ, Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï„ÏŽÏÎ±',0),(315310,8759,'zh','ç‚¹å‡»è¿™é‡Œç«‹å³æ·»åŠ \r\n',0),(315311,8759,'sv','Klicka hÃ¤r fÃ¶r att lÃ¤gga till nu',0),(315312,8759,'it','Fai clic qui per aggiungere ora',0),(315313,8759,'tl','',0),(315314,8759,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(315315,8759,'hi','à¤…à¤¬ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(315316,8759,'ms','Klik di sini untuk menambah kini',0),(315317,8759,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ù„Ø¥Ø¶Ø§ÙØ© Ø­Ø§Ù„Ø§Ù‹',0),(315318,8759,'fr','Cliquez ici pour ajouter maintenant',0),(315319,8759,'jp','ä»Šã™ãè¿½åŠ ã™ã‚‹ã«ã¯ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(315320,8759,'pt','Clique aqui para adicionar agora',0),(315321,8759,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð¡ÑŽÐ´Ð° Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡ÐµÐ¹Ñ‡Ð°Ñ',0),(315322,8759,'es','Click aquÃ­ para Agregar Ahora',0),(315323,8759,'de','Klicken Sie hier, um jetzt hinzufÃ¼gen',0),(315324,8759,'en','Click Here to Add Now',0),(315325,8760,'is','',0),(315326,8760,'dr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ â€“ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ ',0),(315327,8760,'pr','Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ â€“ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ ',0),(315328,8760,'tr','Genel bilgiler - kredi kartlarÄ±',0),(315329,8760,'pl','Informacje ogÃ³lne - karty kredytowe',0),(315330,8760,'bg','ÐžÐ±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ - ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(315331,8760,'ur','Ø¬Ù†Ø±Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª - Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ',0),(315332,8760,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð˜Ð½Ñ„Ð¾ - ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(315333,8760,'vi','Mua Qua Tháº» TÃ­n Dá»¥ng - ThÃ´ng Tin Chung',0),(315334,8760,'af','Kredietkaaraankope - Algemene Inligting',0),(315335,8760,'ro','Informatii generale - carduri de Credit',0),(315336,8760,'et','Ãœldinfo - krediitkaardid',0),(315337,8760,'si','SploÅ¡ne informacije - kreditne kartice',0),(315338,8760,'ba','General Info - kartu kredit',0),(315339,8760,'nl','Algemene Info - creditcards',0),(315340,8760,'fi','Yleistiedot - luottokortit',0),(315341,8760,'no','General Info - kredittkort',0),(315342,8760,'da','General Info - kreditkort',0),(315343,8760,'ko','ì¼ë°˜ ì •ë³´-ì‹ ìš© ì¹´ë“œ',0),(315344,8760,'he','×¨×›×™×©×•×ª ×‘×›×¨×˜×™×¡ ××©×¨××™ - ×ž×™×“×¢ ×›×œ×œ×™',0),(315345,8760,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ - Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(315346,8760,'zh','ä¿¡ç”¨å¡è´­ä¹°- ç®€è¦ä¿¡æ¯\r\n',0),(315347,8760,'sv','AllmÃ¤n information - kreditkort',0),(315348,8760,'it','General Info - carte di credito',0),(315349,8760,'tl','',0),(315350,8760,'th','&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605; - &#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(315351,8760,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ - à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡',0),(315352,8760,'ms','Maklumat am - kad kredit',0),(315353,8760,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø© - Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(315354,8760,'fr','Infos gÃ©nÃ©rales - cartes de crÃ©dit',0),(315355,8760,'jp','ä¸€èˆ¬çš„ãªæƒ…å ± - ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰',0),(315356,8760,'pt','InformaÃ§Ãµes gerais - cartÃµes de crÃ©dito',0),(315357,8760,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ - ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(315358,8760,'es','Tarjeta de CrÃ©dito Compras - Info General',0),(315359,8760,'de','Allgemeine Informationen - Kreditkarten',0),(315360,8760,'en','General Info - Credit Cards',0),(315361,8761,'is','',0),(315362,8761,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(315363,8761,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(315364,8761,'tr','VarsayÄ±lan PO SatÄ±nalma tÃ¼rÃ¼',0),(315365,8761,'pl','DomyÅ›lnie PO zakup typu',0),(315366,8761,'bg','Ð¢Ð¸Ð¿ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ PO Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(315367,8761,'ur','Ø·Û’ Ø´Ø¯Û Ù¾Ùˆ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(315368,8761,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ñ‚Ð¸Ð¿ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ ÐŸÐž',0),(315369,8761,'vi','Loáº¡i mua ÄÆ¡n mua hÃ ng Máº·c Ä‘á»‹nh',0),(315370,8761,'af','Verstekte AB Aankooptipe',0),(315371,8761,'ro','Tipul implicit de cumpÄƒrare a PO',0),(315372,8761,'et','Vaikimisi PO ostu tÃ¼Ã¼p',0),(315373,8761,'si','Privzeta vrsta nabave PO',0),(315374,8761,'ba','Jenis default PO pembelian',0),(315375,8761,'nl','Standaardtype PO aankoop',0),(315376,8761,'fi','PO osto oletustyyppi',0),(315377,8761,'no','Standard PO bestillingstype',0),(315378,8761,'da','Standard PO indkÃ¸bstypen',0),(315379,8761,'ko','ê¸°ë³¸ í¬ êµ¬ë§¤ ìœ í˜•',0),(315380,8761,'he','×¡×•×’ ×”×¨×›×™×©×” ×¤×• ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(315381,8761,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï‚ Ï„ÏÏ€Î¿Ï‚ Î±Î³Î¿ÏÎ¬ PO',0),(315382,8761,'zh','é»˜è®¤è®¢å•è®¢è´­åž‹å·\r\n',0),(315383,8761,'sv','Standardtypen PO kÃ¶p',0),(315384,8761,'it','Tipo di acquisto PO predefinito',0),(315385,8761,'tl','',0),(315386,8761,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(315387,8761,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤ªà¥‹ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(315388,8761,'ms','Lalai PO beli jenis',0),(315389,8761,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø¨Ùˆ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(315390,8761,'fr','Type d\'achat par dÃ©faut PO',0),(315391,8761,'jp','æ—¢å®šã® PO ã®è³¼å…¥ã®ç¨®é¡ž',0),(315392,8761,'pt','Tipo de compra padrÃ£o PO',0),(315393,8761,'ru','Ð¢Ð¸Ð¿ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ PO Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(315394,8761,'es','OC Tipo de Compra por Defecto',0),(315395,8761,'de','Standardtyp PO kaufen',0),(315396,8761,'en','Default PO Purchase Type',0),(315397,8762,'is','',0),(315398,8762,'dr','Ù‡ÙŠÚ† Ù†ÙˆØ¹ ØªØºÙŠÙŠØ±ÙŠ ØªØ§ÙƒÙ†ÙˆÙ† ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(315399,8762,'pr','Ù‡ÙŠÚ† Ù†ÙˆØ¹ ØªØºÙŠÙŠØ±ÙŠ ØªØ§ÙƒÙ†ÙˆÙ† ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(315400,8762,'tr','HiÃ§bir Ã¼cret tÃ¼rÃ¼ henÃ¼z girdiniz',0),(315401,8762,'pl','Nie rodzaj opÅ‚aty zostaÅ‚y wprowadzone jeszcze',0),(315402,8762,'bg','ÐÑÐ¼Ð° Ñ‚Ð°ÐºÑÐ° Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ ÑÐ° Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸ Ð¾Ñ‰Ðµ',0),(315403,8762,'ur','Ø§Ø¨Ú¾ÛŒ ØªÚ© Ú©ÙˆØ¦ÛŒ Ú†Ø§Ø±Ø¬ Ø§Ù‚Ø³Ø§Ù… Ø¯Ø§Ø®Ù„ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(315404,8762,'sr','ÐÐµÐ¼Ð° Ð³Ð»Ð°Ð²Ð½Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸ ÑÑƒ ÑƒÐ½ÐµÑ‚Ðµ',0),(315405,8762,'vi','ChÆ°a nháº­p loáº¡i phÃ­',0),(315406,8762,'af','Geen las tipes het nog ingeskryf is',0),(315407,8762,'ro','Nu tipuri de taxe au fost introduse inca',0),(315408,8762,'et','Sisestatud tasu tÃ¼Ã¼pe pole veel',0),(315409,8762,'si','Nobenih vrst dajatev vnesli Å¡e',0),(315410,8762,'ba','Ada jenis biaya telah memasuki',0),(315411,8762,'nl','Nog zijn geen gratis Types ingevoerd',0),(315412,8762,'fi','Ei maksutyypit tullut vielÃ¤',0),(315413,8762,'no','Noen typer som kostnad er lagt inn ennÃ¥',0),(315414,8762,'da','Ingen afgift typer er indtastet endnu',0),(315415,8762,'ko','ì¶©ì „ í˜•ì‹ì€ ì•„ì§ ìž…ë ¥',0),(315416,8762,'he','×¡×•×’×™ ×ª×©×œ×•× ×œ× ×”×•×–×Ÿ ×¢×“×™×™×Ÿ',0),(315417,8762,'el','ÎšÎ±Î¼Î¯Î± Ï‡ÏÎ­Ï‰ÏƒÎ· ÎµÎ¯Î´Î· Î­Ï‡Î¿Ï…Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¸ÎµÎ¯ Î±ÎºÏŒÎ¼Î·',0),(315418,8762,'zh','è¿˜æ²¡æœ‰ä¸æ”¶è´¹ç±»åž‹è¾“å…¥\r\n',0),(315419,8762,'sv','Ingen avgift typer har registrerats Ã¤nnu',0),(315420,8762,'it','Nessun tipo di addebito Ã¨ stato inserito ancora',0),(315421,8762,'tl','',0),(315422,8762,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3656;&#3634;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3611;&#3657;&#3629;&#3609;',0),(315423,8762,'hi','à¤•à¥‹à¤ˆ à¤šà¤¾à¤°à¥à¤œ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤­à¥€ à¤¤à¤• à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(315424,8762,'ms','Jenis-jenis caj yang ada telah dijalankan namun',0),(315425,8762,'ar','Ù„Ø§ Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø§ØªÙ‡Ø§Ù… Ù‚Ø¯ Ø£Ø¯Ø®Ù„Øª Ø¨Ø¹Ø¯',0),(315426,8762,'fr','Aucun type de Charge n\'ont Ã©tÃ© encore entrÃ©',0),(315427,8762,'jp','é›»è·ã®ç¨®é¡žãŒå…¥åŠ›ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(315428,8762,'pt','NÃ£o hÃ¡ tipos de carga foram inseridos ainda',0),(315429,8762,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð½Ðµ Ð·Ð°Ñ€ÑÐ´Ð° Ð±Ñ‹Ð»Ð¸ Ð²Ð²ÐµÐ´ÐµÐ½Ñ‹ ÐµÑ‰Ðµ',0),(315430,8762,'es','Tipos Sin Cargos Ya No Se HabÃ­a Entrados',0),(315431,8762,'de','Keine GebÃ¼hr-Typen wurden noch eingegeben',0),(315432,8762,'en','No Charge Types Have Been Entered Yet',0),(315433,8763,'is','',0),(315434,8763,'dr','Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(315435,8763,'pr','Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(315436,8763,'tr','PO navlun SatÄ±nalma tÃ¼rÃ¼',0),(315437,8763,'pl','Typ zakupu towarÃ³w PO',0),(315438,8763,'bg','PO Ñ‚Ð¾Ð²Ð°Ñ€ÐµÐ½ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ñ‚Ð¸Ð¿',0),(315439,8763,'ur','Ù¾Ùˆ Ø³Ø§Ù…Ø§Ù† Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(315440,8763,'sr','ÐŸÐž Ñ‚ÐµÑ€ÐµÑ‚Ð½Ð¸ Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ñ‚Ð¸Ð¿',0),(315441,8763,'vi','Loáº¡i hÃ¬nh váº­n chuyá»ƒn Ä‘Æ¡n mua hÃ ng',0),(315442,8763,'af','AB Freight Aankooptipe',0),(315443,8763,'ro','Tip de cumpÄƒrare PO marfÄƒ',0),(315444,8763,'et','PO kauba ostu tÃ¼Ã¼p',0),(315445,8763,'si','PO tovorni nakup tipa',0),(315446,8763,'ba','PO Freight pembelian Type',0),(315447,8763,'nl','Type PO vracht inkoop',0),(315448,8763,'fi','PO tavaraliikenteen oston tyyppi',0),(315449,8763,'no','PO frakt bestillingstype',0),(315450,8763,'da','PO fragt indkÃ¸bstypen',0),(315451,8763,'ko','í¬ í™”ë¬¼ êµ¬ìž… ìœ í˜•',0),(315452,8763,'he','×¡×•×’ ×”×¨×›×™×©×” ×ž×©× ×¤×•',0),(315453,8763,'el','PO Ï„ÏÏ€Î¿Ï… Î±Î³Î¿ÏÎ¬ ÎµÎ¼Ï€Î¿ÏÎµÏ…Î¼Î±Ï„Î¹ÎºÏŽÎ½ Î¼ÎµÏ„Î±Ï†Î¿ÏÏŽÎ½',0),(315454,8763,'zh','è®¢å•è´§è¿é‡‡è´­ç±»åž‹\r\n',0),(315455,8763,'sv','PO frakt KÃ¶p typ',0),(315456,8763,'it','Tipo di acquisto merci PO',0),(315457,8763,'tl','',0),(315458,8763,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(315459,8763,'hi','PO à¤®à¤¾à¤² à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(315460,8763,'ms','PO barang pembelian jenis',0),(315461,8763,'ar','Øµ. Ø¨ Ø§Ù„Ø´Ø­Ù† Ù†ÙˆØ¹ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(315462,8763,'fr','Fournisseur de fret PO Type',0),(315463,8763,'jp','PO è²¨ç‰©ç™ºæ³¨ã‚¿ã‚¤ãƒ—',0),(315464,8763,'pt','PO tipo de compra de mercadorias',0),(315465,8763,'ru','Ð¢Ð¸Ð¿ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð³Ñ€ÑƒÐ·Ð¾Ð²Ñ‹Ñ… PO',0),(315466,8763,'es','OC Tipo de Compra de Flete',0),(315467,8763,'de','PO-Fracht-Kauf-Typ',0),(315468,8763,'en','PO Freight Purchase Type',0),(315469,8764,'is','',0),(315470,8764,'dr','Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯  Ù…Ø§Ù„ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(315471,8764,'pr','Ù†ÙˆØ¹ Ø®Ø±ÙŠØ¯  Ù…Ø§Ù„ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(315472,8764,'tr','PO vergi SatÄ±nalma tÃ¼rÃ¼',0),(315473,8764,'pl','PO podatku od zakupu typu',0),(315474,8764,'bg','PO Ð´Ð°Ð½ÑŠÐº Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ñ‚Ð¸Ð¿',0),(315475,8764,'ur','Ù¾Ùˆ Ù¹ÛŒÚ©Ø³ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(315476,8764,'sr','ÐŸÐž Ð²Ñ€ÑÑ‚Ð° ÐŸÐ”Ð’-Ð° Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ',0),(315477,8764,'vi','Loáº¡i thuáº¿ mua hÃ ng cá»§a Ä‘Æ¡n mua hÃ ng ',0),(315478,8764,'af','AB Belasting Aankooptipe',0),(315479,8764,'ro','Tip de cumpÄƒrare PO fiscale',0),(315480,8764,'et','PO maksu ostu tÃ¼Ã¼p',0),(315481,8764,'si','Izstavljenih nabave PO',0),(315482,8764,'ba','PO pajak pembelian Type',0),(315483,8764,'nl','Type PO belasting inkoop',0),(315484,8764,'fi','PO vero oston tyyppi',0),(315485,8764,'no','PO skatt bestillingstype',0),(315486,8764,'da','PO afgiftstype kÃ¸b.',0),(315487,8764,'ko','í¬ ì„¸ê¸ˆ êµ¬ë§¤ ìœ í˜•',0),(315488,8764,'he','×¡×•×’ ×¤×• ×ž×¡ ×”×¨×›×™×©×”',0),(315489,8764,'el','Î¤ÏÏ€Î¿Ï‚ Î±Î³Î¿ÏÎ¬ Î¦Î Î‘ PO',0),(315490,8764,'zh','è®¢å•ç¨Žè®¢è´­åž‹å·\r\n',0),(315491,8764,'sv','PO skatt inkÃ¶pstyp',0),(315492,8764,'it','PO fiscale acquisto tipo',0),(315493,8764,'tl','',0),(315494,8764,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3616;&#3634;&#3625;&#3637;&#3595;&#3639;&#3657;&#3629;',0),(315495,8764,'hi','PO à¤Ÿà¥ˆà¤•à¥à¤¸ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(315496,8764,'ms','Jenis pembelian PO cukai',0),(315497,8764,'ar','Øµ. Ø¨. Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø´Ø±Ø§Ø¡ Ù†ÙˆØ¹',0),(315498,8764,'fr','Mode d\'achat PO TVA',0),(315499,8764,'jp','PO ç¨Žè³¼å…¥ã‚¿ã‚¤ãƒ—',0),(315500,8764,'pt','PO tipo compra de imposto',0),(315501,8764,'ru','Ð¢Ð¸Ð¿ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð½Ð°Ð»Ð¾Ð³ PO',0),(315502,8764,'es','OC Tipo de Impuesto de Compra',0),(315503,8764,'de','PO Steuerart kaufen',0),(315504,8764,'en','PO Tax Purchase Type',0),(315505,8765,'is','',0),(315506,8765,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(315507,8765,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(315508,8765,'tr','Ä°zleme PO Ã¶deme iÃ§in kredi kartÄ± kullanÄ±n',0),(315509,8765,'pl','UÅ¼ywaÄ‡ Å›ledzenia PO pÅ‚atnoÅ›ci kartÄ… kredytowÄ…',0),(315510,8765,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð·Ð° PO Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(315511,8765,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Ú¾ÙˆØ¬ Ù¾Ùˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(315512,8765,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ ÐŸÐž',0),(315513,8765,'vi','DÃ¹ng TÃ¬m Tháº» TÃ­n Dá»¥ng Ä‘á»ƒ thanh toÃ¡n ÄÆ¡n Mua HÃ ng',0),(315514,8765,'af','Gebruik Kredietkaart Sporing vir AB Betaling',0),(315515,8765,'ro','UtilizaÅ£i cardul de Credit de urmÄƒrire pentru plata PO',0),(315516,8765,'et','Kasutage jÃ¤lgimise PO maksmiseks krediitkaarti',0),(315517,8765,'si','Uporabite kreditno kartico, sledenje za plaÄilo PO',0),(315518,8765,'ba','Menggunakan pelacakan untuk PO pembayaran kartu kredit',0),(315519,8765,'nl','Use Credit-Card Tracking voor PO betaling',0),(315520,8765,'fi','KÃ¤ytÃ¤ luottokorttia seuranta PO maksun',0),(315521,8765,'no','Bruke kredittkort sporing for PO betaling',0),(315522,8765,'da','Brug kreditkort Tracking for PO betaling',0),(315523,8765,'ko','ì‹ ìš© ì¹´ë“œê°€ ê²°ì œì— ëŒ€ í•œ ì¶”ì ì„ ì‚¬ìš© í•˜ ì—¬',0),(315524,8765,'he','×œ×”×©×ª×ž×© ×‘×›×¨×˜×™×¡ ×”××©×¨××™ ×ž×¢×§×‘ ×œ×ª×©×œ×•× ×¤×•',0),(315525,8765,'el','Î§ÏÎ®ÏƒÎ· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚ Î³Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î® Î±Î½Î¬',0),(315526,8765,'zh','ä½¿ç”¨ä¿¡ç”¨å¡è·Ÿè¸ªé‡‡è´­è®¢å•ä»˜æ¬¾\r\n',0),(315527,8765,'sv','AnvÃ¤nda kreditkort spÃ¥rning fÃ¶r PO betalning',0),(315528,8765,'it','Utilizzare monitoraggio per PO pagamento carta di credito',0),(315529,8765,'tl','',0),(315530,8765,'th','&#3651;&#3594;&#3657;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3',0),(315531,8765,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤° à¤¨à¤œà¤¼à¤° à¤°à¤–à¤¨à¥‡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(315532,8765,'ms','Menggunakan kad kredit yang Penjejakan untuk pembayaran PO',0),(315533,8765,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„ØªÙŠ ØªØªØ¨Ø¹ Ù„Ø¯ÙØ¹ Ø¨Ùˆ',0),(315534,8765,'fr','Utiliser la carte de crÃ©dit suivi de paiement PO',0),(315535,8765,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ PO æ”¯æ‰•ã„ã®è¿½è·¡ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(315536,8765,'pt','Usar o rastreamento para PO pagamento de cartÃ£o de crÃ©dito',0),(315537,8765,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð´Ð»Ñ PO Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(315538,8765,'es','Usar Rastreo de Tarjeta de CrÃ©dito para Pago de OC',0),(315539,8765,'de','Tracking fÃ¼r PO Zahlung Kreditkarte benutzen',0),(315540,8765,'en','Use Credit Card Tracking for PO Payment',0),(315541,8766,'is','',0),(315542,8766,'dr','Ù†Ù…Ø§ÙŠØ´ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¯Ø± Ù¾Ø§ÙŠÙŠÙ† ',0),(315543,8766,'pr','Ù†Ù…Ø§ÙŠØ´ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¯Ø± Ù¾Ø§ÙŠÙŠÙ† ',0),(315544,8766,'tr','Show Notlar alt',0),(315545,8766,'pl','PokaÅ¼ notatki na dole',0),(315546,8766,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸Ñ‚Ðµ Ð² ÐºÑ€Ð°Ñ',0),(315547,8766,'ur','Ù¾Ø§ÛŒØ§Ù† Ù¾Ø± Ø´Ùˆ Ù†ÙˆÙ¹',0),(315548,8766,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð½Ð° Ð´Ð½Ñƒ',0),(315549,8766,'vi','Hiá»ƒn thá»‹ ghi chÃº phÃ­a dÆ°á»›i',0),(315550,8766,'af','Wys Notas Onderaan',0),(315551,8766,'ro','Note de la partea de jos',0),(315552,8766,'et','NÃ¤ita mÃ¤rgib alt',0),(315553,8766,'si','PrikaÅ¾ite opombe na dnu',0),(315554,8766,'ba','Catatan menunjukkan di bawah',0),(315555,8766,'nl','Toon Notes onderaan',0),(315556,8766,'fi','NÃ¤ytÃ¤ toteaa alareunassa',0),(315557,8766,'no','Show noter nederst',0),(315558,8766,'da','Vis noter nederst',0),(315559,8766,'ko','ì•„ëž˜ì—ì„œ ë…¸íŠ¸ ë³´ê¸°',0),(315560,8766,'he','×”×¦×’ ×”×¢×¨×•×ª ×‘×ª×—×ª×™×ª',0),(315561,8766,'el','Show Î£Î—ÎœÎ•Î™Î©Î£Î•Î™Î£ ÏƒÏ„Î¿ ÎºÎ¬Ï„Ï‰ Î¼Î­ÏÎ¿Ï‚',0),(315562,8766,'zh','åœ¨åº•éƒ¨æ˜¾ç¤ºå¤‡æ³¨\r\n',0),(315563,8766,'sv','Visa anteckningar lÃ¤ngst ned',0),(315564,8766,'it','Vedi note a fondo',0),(315565,8766,'tl','',0),(315566,8766,'th','&#3649;&#3626;&#3604;&#3591;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3607;&#3637;&#3656;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;',0),(315567,8766,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤®à¥‡à¤‚ à¤¨à¥€à¤šà¥‡',0),(315568,8766,'ms','Papar Nota-nota di bawah',0),(315569,8766,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª ÙÙŠ Ø§Ù„Ø£Ø³ÙÙ„',0),(315570,8766,'fr','Montrer les Notes au bas',0),(315571,8766,'jp','ä¸‹éƒ¨ã«è¡¨ç¤ºã™ã‚‹ãƒŽãƒ¼ãƒˆ',0),(315572,8766,'pt','Mostrar notas no fundo',0),(315573,8766,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ Ð²Ð½Ð¸Ð·Ñƒ',0),(315574,8766,'es','Mostrar Notas Abajo',0),(315575,8766,'de','Shownotes unten',0),(315576,8766,'en','Show Notes at Bottom',0),(315577,8767,'is','',0),(315578,8767,'dr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø§Ø¹Ø¯Ø§Ø¯ Ø¨Ø±Ø§ÙŠ\r\n SSN',0),(315579,8767,'pr','Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø§Ø¹Ø¯Ø§Ø¯ Ø¨Ø±Ø§ÙŠ\r\n SSN',0),(315580,8767,'tr','SSN iÃ§in maksimum basamak',0),(315581,8767,'pl','Max cyfr dla SSN',0),(315582,8767,'bg','ÐœÐ°ÐºÑ Ñ†Ð¸Ñ„Ñ€Ð¸ Ð·Ð° SSN',0),(315583,8767,'ur','Ø§ÛŒØ³Ø§ÛŒØ³ÛŒÙ† Ú©Û’ Ù„Ø¦Û’ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø§Ø¹Ø¯Ø§Ø¯',0),(315584,8767,'sr','ÐœÐ°x Ñ†Ð¸Ñ„Ñ€Ðµ Ð·Ð° Ð¡Ð¡Ð',0),(315585,8767,'vi','Há»‡ sá»‘ tá»‘i Ä‘a cho SSN',0),(315586,8767,'af','Max syfers vir SSN',0),(315587,8767,'ro','Max cifre pentru SSN',0),(315588,8767,'et','Max numbrit SSN',0),(315589,8767,'si','Max Å¡tevk za SSN',0),(315590,8767,'ba','Max digit untuk SSN',0),(315591,8767,'nl','Max cijfers voor SSN',0),(315592,8767,'fi','Max numeroiden SSN',0),(315593,8767,'no','Max sifre for Personnummer',0),(315594,8767,'da','Max cifre for SSN',0),(315595,8767,'ko','SSNì— ëŒ€ í•œ ìµœëŒ€ ìžë¦¿ìˆ˜',0),(315596,8767,'he','×ž×§×¡ ×¡×¤×¨×•×ª ×¢×‘×•×¨ ×ž×¡×¤×¨ ×ª×¢×•×“×ª ×–×”×•×ª',0),(315597,8767,'el','Max ÏˆÎ·Ï†Î¯Î± Î³Î¹Î± SSN',0),(315598,8767,'zh','ç¤¾ä¼šä¿éšœå·æœ€å¤§ä½æ•°\r\n',0),(315599,8767,'sv','Max siffror fÃ¶r SSN',0),(315600,8767,'it','Cifre max per SSN',0),(315601,8767,'tl','',0),(315602,8767,'th','Max Digits for SSN',0),(315603,8767,'hi','à¤à¤¸à¤à¤¸à¤à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤…à¤‚à¤•',0),(315604,8767,'ms','Max digit bagi SSN',0),(315605,8767,'ar','Ø£Ù‚ØµÙ‰ Ø­Ø¯Ù‘ Ù„Ø¹Ø¯Ø¯ Ø®Ø§Ù†Ø§Øª Ø§Ù„Ø±Ù‚Ù… Ø§Ù„ÙˆØ·Ù†ÙŠ',0),(315606,8767,'fr','Chiffres max pour SSN',0),(315607,8767,'jp','SSN ã®æœ€å¤§æ¡æ•°',0),(315608,8767,'pt','Max dÃ­gitos para SSN',0),(315609,8767,'ru','ÐœÐ°ÐºÑ Ñ†Ð¸Ñ„Ñ€Ñ‹ SSN',0),(315610,8767,'es','Max Digitos para SSN',0),(315611,8767,'de','Max Ziffern fÃ¼r SSN',0),(315612,8767,'en','Max Digits for SSN',0),(315613,8768,'is','',0),(315614,8768,'dr','ØªØºÙŠÙŠØ± Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(315615,8768,'pr','ØªØºÙŠÙŠØ± Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(315616,8768,'tr','Servis sipariÅŸine dÃ¶nÃ¼ÅŸtÃ¼rme',0),(315617,8768,'pl','Konwersja do zlecenia serwisowego',0),(315618,8768,'bg','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð² Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(315619,8768,'ur','Ø®Ø¯Ù…Øª Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…ÛŒÚº Ø¨Ø¯Ù„ÛŒÚº',0),(315620,8768,'sr','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ð²Ð°ÑšÐµ Ñƒ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(315621,8768,'vi','Chuyá»ƒn sang Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥',0),(315622,8768,'af','Omskakeling na Diens Bestelling',0),(315623,8768,'ro','Conversia Ã®n comandÄƒ de Service',0),(315624,8768,'et','Hooldustellimuse teisendamine',0),(315625,8768,'si','Pretvarjanje v servisni nalog',0),(315626,8768,'ba','Mengkonversi ke Service Order',0),(315627,8768,'nl','Omzetten in serviceorder',0),(315628,8768,'fi','Muuntaa huoltotilaukseksi',0),(315629,8768,'no','Konvertere til serviceordre',0),(315630,8768,'da','Konvertere til serviceordre',0),(315631,8768,'ko','ì„œë¹„ìŠ¤ ì˜¤ë”ë¡œ ë³€í™˜',0),(315632,8768,'he','×œ×”×ž×™×¨ ×œ×”×–×ž× ×ª ×©×™×¨×•×ª',0),(315633,8768,'el','ÎœÎµÏ„Î±Ï„ÏÎ¿Ï€Î® ÏƒÎµ ÎµÎ½Ï„Î¿Î»Î® Ï„ / Ï…',0),(315634,8768,'zh','è½¬æ¢ä¸ºæœåŠ¡è®¢å•\r\n',0),(315635,8768,'sv','Konvertera till serviceorder',0),(315636,8768,'it','Convertire in ordine di servizio',0),(315637,8768,'tl','',0),(315638,8768,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3652;&#3611;&#3618;&#3633;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(315639,8768,'hi','à¤•à¤¨à¥à¤µà¤°à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶',0),(315640,8768,'ms','Menukar kepada pesanan Perkhidmatan',0),(315641,8768,'ar','ØªØ­ÙˆÙŠÙ„ Ø¥Ù„Ù‰ Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(315642,8768,'fr','Convertir en commande Service',0),(315643,8768,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã«å¤‰æ›ã—ã¾ã™ã€‚',0),(315644,8768,'pt','Converter a ordem de serviÃ§o',0),(315645,8768,'ru','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ Ð² Ð·Ð°ÐºÐ°Ð·',0),(315646,8768,'es','Convertir a un Orden de Servicio',0),(315647,8768,'de','Serviceauftrag umwandeln',0),(315648,8768,'en','Convert to Service Order',0),(315649,8769,'is','',0),(315650,8769,'dr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(315651,8769,'pr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(315652,8769,'tr','Kredi kartÄ± ile Ã¶n Ã¶demeli',0),(315653,8769,'pl','PrzedpÅ‚ata kartÄ… kredytowÄ…',0),(315654,8769,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð»Ð°Ñ‚ÐµÐ½ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(315655,8769,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ (Ù„Ø§Ù†Ú¯ ÚˆØ³Ù¹Ù†Ø³)',0),(315656,8769,'sr','ÐÐ²Ð°Ð½ÑÐ½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(315657,8769,'vi','Tráº£ trÆ°á»›c báº±ng tháº» tÃ­n dá»¥ng',0),(315658,8769,'af','Vooruitbetaal per Kredietkaart',0),(315659,8769,'ro','Prepaid Card de Credit',0),(315660,8769,'et','Ettemakstud krediitkaardi',0),(315661,8769,'si','PredplaÄila s kreditno kartico',0),(315662,8769,'ba','Prabayar menggunakan kartu kredit',0),(315663,8769,'nl','Vooruitbetaling per Credit Card',0),(315664,8769,'fi','Prepaid Luottokortti',0),(315665,8769,'no','ForhÃ¥ndsbetalt kredittkort',0),(315666,8769,'da','Forudbetaling med kreditkort',0),(315667,8769,'ko','ì‹ ìš© ì¹´ë“œë¡œ ì„ ë¶ˆ',0),(315668,8769,'he','×ª×©×œ×•× ×ž×¨××© ×‘××ž×¦×¢×•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(315669,8769,'el','Î ÏÎ¿Ï€Î»Î·ÏÏ‰Î¼Î­Î½Î· Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(315670,8769,'zh','ä»¥ä¿¡ç”¨å¡é¢„ä»˜\r\n',0),(315671,8769,'sv','FÃ¶rutbetalda kreditkort',0),(315672,8769,'it','Prepagata con carta di credito',0),(315673,8769,'tl','',0),(315674,8769,'th','&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3585;&#3656;&#3629;&#3609;&#3612;&#3656;&#3634;&#3609;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(315675,8769,'hi','à¤ªà¥à¤°à¥€à¤ªà¥‡à¤¡ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(315676,8769,'ms','Prabayar dengan kad kredit',0),(315677,8769,'ar','Ù…Ø¯ÙÙˆØ¹ Ù…Ø³Ø¨Ù‚Ø§ Ø¨Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(315678,8769,'fr','PayÃ© par carte de crÃ©dit',0),(315679,8769,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã«ã‚ˆã‚‹å‰æ‰•ã„',0),(315680,8769,'pt','PrÃ©-pagamento por cartÃ£o de crÃ©dito',0),(315681,8769,'ru','ÐŸÑ€ÐµÐ´Ð¾Ð¿Ð»Ð°Ñ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(315682,8769,'es','Prepagado por Tarjeta de CrÃ©dito',0),(315683,8769,'de','Prepaid Kreditkarte',0),(315684,8769,'en','Prepaid by Credit Card',0),(315685,8770,'is','',0),(315686,8770,'dr','ÙŠÙƒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(315687,8770,'pr','ÙŠÙƒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(315688,8770,'tr','Ã–deme zaten oluÅŸturulmuÅŸ',0),(315689,8770,'pl','StworzyÅ‚ juÅ¼ pÅ‚atnoÅ›ci',0),(315690,8770,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´ÐµÐ½ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð²ÐµÑ‡Ðµ',0),(315691,8770,'ur','Ø§ÛŒÚ© Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ùˆ Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(315692,8770,'sr','Ð¡Ñ‚Ð²Ð¾Ñ€Ð¸Ð¾ Ñ˜Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ Ð²ÐµÑ›',0),(315693,8770,'vi','ÄÃ£ táº¡o 1 thanh toÃ¡n',0),(315694,8770,'af','\'N betaling reeds geskep',0),(315695,8770,'ro','Creat deja o platÄƒ',0),(315696,8770,'et','Makse juba loodud',0),(315697,8770,'si','Ustvaril je plaÄilo Å¾e',0),(315698,8770,'ba','Pembayaran yang sudah dibuat',0),(315699,8770,'nl','Een betaling reeds gemaakt',0),(315700,8770,'fi','Luotu maksu jo',0),(315701,8770,'no','Opprettet en betaling allerede',0),(315702,8770,'da','Lavet en betaling allerede',0),(315703,8770,'ko','ì´ë¯¸ ì§€ë¶ˆì„ ë§Œë“ ',0),(315704,8770,'he','× ×•×¦×¨ ×ª×©×œ×•× ×›×‘×¨',0),(315705,8770,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î¼Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î® Î®Î´Î·',0),(315706,8770,'zh','å·²å»ºç«‹ä¸€ä¸ªä»˜æ¬¾\r\n',0),(315707,8770,'sv','Skapat en betalning redan',0),(315708,8770,'it','Creato un pagamento giÃ ',0),(315709,8770,'tl','',0),(315710,8770,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3594;&#3635;&#3619;&#3632;&#3606;&#3641;&#3585;&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(315711,8770,'hi','à¤à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¬à¤¨à¤¾à¤ à¤—à¤',0),(315712,8770,'ms','Bayaran telah dibuat',0),(315713,8770,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¯ÙØ¹ Ù…Ø³Ø¨Ù‚Ø§Ù‹',0),(315714,8770,'fr','CrÃ©Ã© un paiement dÃ©jÃ ',0),(315715,8770,'jp','æ—¢ã«æ”¯æ‰•ã„ã‚’ä½œæˆ',0),(315716,8770,'pt','Criado um pagamento jÃ¡',0),(315717,8770,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ ÑƒÐ¶Ðµ',0),(315718,8770,'es','Pago Ya Creado',0),(315719,8770,'de','Erstellt eine Zahlung bereits',0),(315720,8770,'en','Created a Payment Already',0),(315721,8771,'is','',0),(315722,8771,'dr','Ù‡ÙŠÚ† ØªØ§Ù…ÙŠÙ† ÙƒÙ†Ù†Ø¯Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(315723,8771,'pr','Ù‡ÙŠÚ† ØªØ§Ù…ÙŠÙ† ÙƒÙ†Ù†Ø¯Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(315724,8771,'tr','Girilen herhangi bir kredi kartÄ± satÄ±n alma saÄŸlayÄ±cÄ±sÄ±',0),(315725,8771,'pl','Brak dostawcÃ³w zakup karty kredytowej wprowadzone',0),(315726,8771,'bg','ÐÑÐ¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸',0),(315727,8771,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø®Ø±ÛŒØ¯ Ù…ÛÛŒØ§ Ú©Ø§Ø±',0),(315728,8771,'sr','ÐžÐ¿ÑÐºÑ€Ð±Ñ™Ð¸Ð²Ð°ÑšÐµ Ð½Ð°Ð±Ð°Ð²ÐºÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ ÐºÐ¾Ñ˜Ð° Ñ˜Ðµ ÑƒÐ½ÐµÑ‚Ð°',0),(315729,8771,'vi','ChÆ°a Nháº­p NhÃ  Cung Cáº¥p Giao Dá»‹ch Mua HÃ ng Qua Tháº» TÃ­n Dá»¥ng',0),(315730,8771,'af','Geen Kredietkaartaankope Voorsienings Ingevoer',0),(315731,8771,'ro','Nici un Card de Credit cumpÄƒrare furnizorii intrat',0),(315732,8771,'et','Krediitkaardi ostu pakkujad sisestatud',0),(315733,8771,'si','Brez kreditne kartice nakup ponudniki zaÄel',0),(315734,8771,'ba','Tidak ada kartu kredit pembelian penyedia masuk',0),(315735,8771,'nl','Geen creditcard aankoop Providers ingevoerd',0),(315736,8771,'fi','Ei luottokortti sÃ¤hkÃ¶nhankintasopimuksista tarjoajien tuli',0),(315737,8771,'no','Ingen kredittkort kjÃ¸p leverandÃ¸rer angitt',0),(315738,8771,'da','Ingen kreditkort KÃ¸b udbydere indtastet',0),(315739,8771,'ko','ìž…ë ¥ í•œ ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ ê³µê¸‰ìž ì—†ìŒ',0),(315740,8771,'he','××™×Ÿ ×¡×¤×§×™ ×¨×›×© ×›×¨×˜×™×¡ ××©×¨××™ × ×›× ×¡×•',0),(315741,8771,'el','ÎšÎ±Î¼Î¯Î± Ï€Î±ÏÏŒÏ‡Î¿Ï…Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½ Î±Î³Î¿ÏÎ¬ Ï€Î¿Ï… Ï„Î­Î¸Î·ÎºÎµ',0),(315742,8771,'zh','æ²¡æœ‰è¾“å…¥ä¿¡ç”¨å¡è´­ä¹°ä¾›åº”å•†\r\n',0),(315743,8771,'sv','Inga kreditkort inkÃ¶p leverantÃ¶rer anges',0),(315744,8771,'it','Nessun provider di acquisto di carta di credito immesso',0),(315745,8771,'tl','',0),(315746,8771,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3604;&#3657;&#3623;&#3618;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3592;&#3634;&#3585;&#3612;&#3641;&#3657;&#3651;&#3627;&#3657;&#3610;&#3',0),(315747,8771,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦ à¤ªà¥à¤°à¤¦à¤¾à¤¤à¤¾à¤“à¤‚ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(315748,8771,'ms','Pembekal pembelian kad kredit yang tidak dimasukkan',0),(315749,8771,'ar','Ø£ÙŠØ© Ù…ÙˆÙØ±Ø§Øª Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¯Ø®Ù„Øª',0),(315750,8771,'fr','Aucun fournisseur dâ€™achat de carte de crÃ©dit entrÃ©',0),(315751,8771,'jp','å…¥åŠ›ã•ã‚ŒãŸã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰è³¼å…¥ãƒ—ãƒ­ãƒã‚¤ãƒ€ãƒ¼ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(315752,8771,'pt','NÃ£o hÃ¡ provedores de compra de cartÃ£o de crÃ©dito entrados',0),(315753,8771,'ru','ÐÐµÑ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð¿Ñ€Ð¾Ð²Ð°Ð¹Ð´ÐµÑ€Ð¾Ð² Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»Ð¸',0),(315754,8771,'es','No se IngresÃ³ Ningun Comprador de Tarjetas de CrÃ©dito',0),(315755,8771,'de','Keine Kreditkarte Kauf Anbieter eingetragen',0),(315756,8771,'en','No Credit Card Purchase Providers Entered',0),(315757,8772,'is','',0),(315758,8772,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(315759,8772,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(315760,8772,'tr','PO numarasÄ±',0),(315761,8772,'pl','Numer zamÃ³wienia',0),(315762,8772,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(315763,8772,'ur','Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø±',0),(315764,8772,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐÐ°Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ðµ',0),(315765,8772,'vi','ÄÆ¡n mua hÃ ng sá»‘',0),(315766,8772,'af','AB Nommer',0),(315767,8772,'ro','NumÄƒrul bonului de comandÄƒ',0),(315768,8772,'et','PO Number',0),(315769,8772,'si','Å tevilka NaroÄilnice',0),(315770,8772,'ba','Nomor PO',0),(315771,8772,'nl','PO-nummer',0),(315772,8772,'fi','Ostotilauksen numero',0),(315773,8772,'no','InnkjÃ¸psordrenummer',0),(315774,8772,'da','PO-nummer',0),(315775,8772,'ko','ì£¼ë¬¸ì„œ ë²ˆí˜¸',0),(315776,8772,'he','×ž×¡×¤×¨ ×¡× ×™×£ ×“×•××¨',0),(315777,8772,'el','Î‘Ï Î Î±ÏÎ±Î³Î³',0),(315778,8772,'zh','è®¢å•å·\r\n',0),(315779,8772,'sv','InkÃ¶psordernummer',0),(315780,8772,'it','Numero di PO',0),(315781,8772,'tl','',0),(315782,8772,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(315783,8772,'hi','PO à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(315784,8772,'ms','Nombor PO',0),(315785,8772,'ar','Ø±Ù‚Ù… Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(315786,8772,'fr','Nombre de PO',0),(315787,8772,'jp','PO ç•ªå·',0),(315788,8772,'pt','NÃºmero de PO',0),(315789,8772,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(315790,8772,'es','NÃºmero de OC',0),(315791,8772,'de','Bestellnummer',0),(315792,8772,'en','PO Number',0),(315793,8773,'is','',0),(315794,8773,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(315795,8773,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(315796,8773,'tr','Kredi kartÄ±yla Ã¶deme PO',0),(315797,8773,'pl','PO zapÅ‚aciÄ‡ kartÄ… kredytowÄ…',0),(315798,8773,'bg','PO Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(315799,8773,'ur','Ù¾Ùˆ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(315800,8773,'sr','ÐŸÐž Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(315801,8773,'vi','ÄÆ¡n Mua HÃ ng tráº£ báº±ng tháº» tÃ­n dá»¥ng',0),(315802,8773,'af','AB Betaal per Kredietkaart',0),(315803,8773,'ro','PO plata prin Card de Credit',0),(315804,8773,'et','PO maksta krediitkaardiga',0),(315805,8773,'si','PO plaÄilu s kreditno kartico',0),(315806,8773,'ba','PO membayar dengan kartu kredit',0),(315807,8773,'nl','PO betalen per creditcard',0),(315808,8773,'fi','PO Maksu luottokortilla',0),(315809,8773,'no','PO betale med kredittkort',0),(315810,8773,'da','PO betale via kreditkort',0),(315811,8773,'ko','ì‹ ìš© ì¹´ë“œì— ì˜í•˜ì—¬ í¬ ì§€ë¶ˆ',0),(315812,8773,'he','×¤×• ×œ×©×œ× ×‘××ž×¦×¢×•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(315813,8773,'el','PO Ï€Î»Î·ÏÏ‰Î¼Î® Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(315814,8773,'zh','é‡‡è´­è®¢å•ä»¥ä¿¡ç”¨å¡ä»˜æ¬¾\r\n',0),(315815,8773,'sv','PO betala av kreditkort',0),(315816,8773,'it','Pagare di po con carta di credito',0),(315817,8773,'tl','',0),(315818,8773,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3612;&#3656;&#3634;&#3609;&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(315819,8773,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥‹ à¤ªà¥‡',0),(315820,8773,'ms','PO membayar dengan kad kredit',0),(315821,8773,'ar','Øµ. Ø¨. Ø§Ù„Ø¯ÙØ¹ Ø¨Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(315822,8773,'fr','PO payer par carte de crÃ©dit',0),(315823,8773,'jp','PO ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã§æ”¯æ‰•ã†',0),(315824,8773,'pt','PO pagar com cartÃ£o de crÃ©dito',0),(315825,8773,'ru','PO ÐžÐ¿Ð»Ð°Ñ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(315826,8773,'es','OC Pago por Tarjeta de CrÃ©dito',0),(315827,8773,'de','PO per Kreditkarte bezahlen',0),(315828,8773,'en','PO Pay by Credit Card',0),(315829,8774,'is','',0),(315830,8774,'dr','Ø³Ù†Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(315831,8774,'pr','Ø³Ù†Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(315832,8774,'tr','KayÄ±t Ã¶deme',0),(315833,8774,'pl','Rekord pÅ‚atnoÅ›ci',0),(315834,8774,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(315835,8774,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(315836,8774,'sr','Ð—Ð°Ð¿Ð¸ÑÐ° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(315837,8774,'vi','Há»“ sÆ¡ thanh toÃ¡n',0),(315838,8774,'af','Betaling Boekstaaf',0),(315839,8774,'ro','Record de platÄƒ',0),(315840,8774,'et','Rekord makse',0),(315841,8774,'si','Evidenco plaÄilnih',0),(315842,8774,'ba','Rekam pembayaran',0),(315843,8774,'nl','Record betaling',0),(315844,8774,'fi','EnnÃ¤tyksellisen maksu',0),(315845,8774,'no','Registrere betaling',0),(315846,8774,'da','Registrere betaling',0),(315847,8774,'ko','ê¸°ë¡ ì§€ë¶ˆ',0),(315848,8774,'he','×”×ª×©×œ×•× ×”×¨×©×•×ž×”',0),(315849,8774,'el','Î¡ÎµÎºÏŒÏ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(315850,8774,'zh','è®°å½•ä»˜æ¬¾\r\n',0),(315851,8774,'sv','Registrera betalning',0),(315852,8774,'it','Registrare pagamento',0),(315853,8774,'tl','',0),(315854,8774,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(315855,8774,'hi','à¤°à¤¿à¤•à¤¾à¤°à¥à¤¡ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(315856,8774,'ms','Rekod pembayaran',0),(315857,8774,'ar','Ø³Ø¬Ù„ Ø§Ù„Ø¯ÙØ¹',0),(315858,8774,'fr','Paiement record',0),(315859,8774,'jp','æ”¯æ‰•ã®è¨˜éŒ²',0),(315860,8774,'pt','Registro pagamento',0),(315861,8774,'ru','Ð ÐµÐºÐ¾Ñ€Ð´Ð½Ñ‹Ðµ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹',0),(315862,8774,'es','Pago de Record',0),(315863,8774,'de','Rekord-Zahlung',0),(315864,8774,'en','Record Payment',0),(315865,8775,'is','',0),(315866,8775,'dr','ÙƒÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(315867,8775,'pr','ÙƒÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(315868,8775,'tr','Toplam Ã¶deme',0),(315869,8775,'pl','CaÅ‚kowita kwota pÅ‚atnoÅ›ci',0),(315870,8775,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(315871,8775,'ur','Ú©Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(315872,8775,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¸ÑÐ¿Ð»Ð°Ñ‚Ð°',0),(315873,8775,'vi','Tá»•ng cá»™ng thanh toÃ¡n',0),(315874,8775,'af','Totale Betaling',0),(315875,8775,'ro','Plata totala',0),(315876,8775,'et','Kogu tasu',0),(315877,8775,'si','Celotno plaÄilo',0),(315878,8775,'ba','Jumlah pembayaran',0),(315879,8775,'nl','Totale betaling',0),(315880,8775,'fi','Suuruinen',0),(315881,8775,'no','Betaling totalt',0),(315882,8775,'da','Samlede betaling',0),(315883,8775,'ko','ì´ ì§€ë¶ˆ',0),(315884,8775,'he','×¡×” ×› ×ª×©×œ×•×',0),(315885,8775,'el','Î— ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ® Ï€Î»Î·ÏÏ‰Î¼Î®',0),(315886,8775,'zh','æ€»ä»˜è´¹\r\n',0),(315887,8775,'sv','Totala betalning',0),(315888,8775,'it','Pagamento totale',0),(315889,8775,'tl','',0),(315890,8775,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(315891,8775,'hi','à¤•à¥à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(315892,8775,'ms','Jumlah pembayaran',0),(315893,8775,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(315894,8775,'fr','Paiement total',0),(315895,8775,'jp','ç·æ”¯æ‰•ã„',0),(315896,8775,'pt','Pagamento total',0),(315897,8775,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑƒÐ¼Ð¼Ð° Ð²Ñ‹Ð¿Ð»Ð°Ñ‚',0),(315898,8775,'es','Total Pago',0),(315899,8775,'de','Gesamtzahlung',0),(315900,8775,'en','Total Payment',0),(315901,8776,'is','',0),(315902,8776,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(315903,8776,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(315904,8776,'tr','KDV vergisi',0),(315905,8776,'pl','Podatek VAT',0),(315906,8776,'bg','Ð”Ð°Ð½ÑŠÐº Ð”Ð”Ð¡',0),(315907,8776,'ur','ÙˆØ§Ù¹ Ù¹ÛŒÚ©Ø³',0),(315908,8776,'sr','ÐŸÐ”Ð’ -Ð° Ð¿Ð¾Ñ€ÐµÐ·',0),(315909,8776,'vi','Thuáº¿ VAT',0),(315910,8776,'af','BTW Belasting',0),(315911,8776,'ro','TVA',0),(315912,8776,'et','KÃ¤ibemaks',0),(315913,8776,'si','DDV davÄna',0),(315914,8776,'ba','PPN',0),(315915,8776,'nl','BTW',0),(315916,8776,'fi','ALV',0),(315917,8776,'no','Mva',0),(315918,8776,'da','Moms',0),(315919,8776,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸',0),(315920,8776,'he','×ž×¢',0),(315921,8776,'el','Î¦Î Î‘',0),(315922,8776,'zh','å¢žå€¼ç¨Žç¨Žæ”¶',0),(315923,8776,'sv','Moms',0),(315924,8776,'it','IVA',0),(315925,8776,'tl','',0),(315926,8776,'th','&#3616;&#3634;&#3625;&#3637; VAT',0),(315927,8776,'hi','à¤µà¥ˆà¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(315928,8776,'ms','Cukai VAT',0),(315929,8776,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©',0),(315930,8776,'fr','Imposition de la TVA',0),(315931,8776,'jp','ä»˜åŠ ä¾¡å€¤ç¨Ž',0),(315932,8776,'pt','IVA',0),(315933,8776,'ru','ÐÐ°Ð»Ð¾Ð³ ÐÐ”Ð¡',0),(315934,8776,'es','IVA Impuesto',0),(315935,8776,'de','MwSt.',0),(315936,8776,'en','VAT Tax',0),(315937,8777,'is','',0),(315938,8777,'dr','(Ù…ØªØ¯Ø§ÙˆÙ„',0),(315939,8777,'pr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¹Ù…ÙˆÙ…ÙŠ(Ù…ØªØ¯Ø§ÙˆÙ„',0),(315940,8777,'tr','Genel bilgi',0),(315941,8777,'pl','DW ogÃ³lne',0),(315942,8777,'bg','CC Ð¾Ð±Ñ‰Ð¸',0),(315943,8777,'ur','Ø¹Ø§Ù… Ø³ÛŒ Ø³ÛŒ',0),(315944,8777,'sr','Ð¦Ð¦ Ð¾Ð¿ÑˆÑ‚Ðµ',0),(315945,8777,'vi','Äá»“ng gá»­i Chung',0),(315946,8777,'af','KK Algemeen',0),(315947,8777,'ro','CC generale',0),(315948,8777,'et','CC Ã¼ldist',0),(315949,8777,'si','CC sploÅ¡na',0),(315950,8777,'ba','CC Umum',0),(315951,8777,'nl','CC algemene',0),(315952,8777,'fi','CC ehdot',0),(315953,8777,'no','KOPI-generelt',0),(315954,8777,'da','CC generelle',0),(315955,8777,'ko','ì¼ë°˜ ì°¸ì¡°',0),(315956,8777,'he','×¢×•×ª×§ ×œ×™×“×™×¢×” ×›×œ×œ×™×ª',0),(315957,8777,'el','CC Î³ÎµÎ½Î¹ÎºÎ®',0),(315958,8777,'zh','æ€»ä¿¡ç”¨å¡\r\n',0),(315959,8777,'sv','CC allmÃ¤nna',0),(315960,8777,'it','CC generale',0),(315961,8777,'tl','',0),(315962,8777,'th','&#3626;&#3635;&#3648;&#3609;&#3634;&#3607;&#3633;&#3623;&#3652;&#3611;',0),(315963,8777,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤­à¥‡à¤œà¥‡à¤‚',0),(315964,8777,'ms','CC besar',0),(315965,8777,'ar','Ù†Ø³Ø®Ø© Ø¹Ø§Ù…Ø©',0),(315966,8777,'fr','CC gÃ©nÃ©rales',0),(315967,8777,'jp','ä¸€èˆ¬çš„ãª CC ã—ã¾ã™ã€‚',0),(315968,8777,'pt','CC geral',0),(315969,8777,'ru','ÐšÐžÐŸÐ˜Ð¯ Ð¾Ð±Ñ‰ÐµÐ³Ð¾',0),(315970,8777,'es','TJ General',0),(315971,8777,'de','CC allgemeine',0),(315972,8777,'en','CC General',0),(315973,8778,'is','',0),(315974,8778,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙƒØ§Ø±Ø§ÙƒØªØ±Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹Ù‰ Ø¨Ø§ÙŠØ¯ Ø¨Ø§Ø´Ø¯ ',0),(315975,8778,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙƒØ§Ø±Ø§ÙƒØªØ±Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø´Ù…Ø§Ø±Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹Ù‰ Ø¨Ø§ÙŠØ¯ Ø¨Ø§Ø´Ø¯ ',0),(315976,8778,'tr','Sosyal GÃ¼venlik numarasÄ± iÃ§in toplam karakter olmalÄ±dÄ±r ',0),(315977,8778,'pl','CaÅ‚kowita znaki numeru Social Security musi byÄ‡ ',0),(315978,8778,'bg','ÐžÐ±Ñ‰Ð¾ Ð³ÐµÑ€Ð¾Ð¸ Ð·Ð° Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° ÑÐ¾Ñ†Ð¸Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÐ¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ ',0),(315979,8778,'ur','Ú©Ù„ Ø­Ø±ÙˆÙ Ú©Ùˆ Ø³ÙˆØ´Ù„ Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ Ù†Ù…Ø¨Ø± ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ ',0),(315980,8778,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° ÑÐ¸ Ñ‚Ð¾Ñ‚Ð°Ð»Ð½Ð¸ Ð·Ð½Ð°ÐºÐ¾Ð²Ðµ Ð·Ð° Ð±Ñ€Ð¾Ñ˜ ÑÐ¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾Ð³ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ° ',0),(315981,8778,'vi','Táº¥t cáº£ kÃ½ tá»± cho sá»‘ an sinh xÃ£ há»™i pháº£i lÃ ',0),(315982,8778,'af','Die totale karakters vir die sosiale sekerheid nommer moet word ',0),(315983,8778,'ro','Caractere totalÄƒ pentru numÄƒrul de securitate socialÄƒ trebuie sÄƒ fie ',0),(315984,8778,'et','Kokku tÃ¤hemÃ¤rki Social Security Number peab olema ',0),(315985,8778,'si','Skupaj znakov za Å¡tevilko socialnega zavarovanja mora biti ',0),(315986,8778,'ba','Tokoh-tokoh untuk nomor jaminan sosial harus ',0),(315987,8778,'nl','De totale tekens voor het sofi-nummer moeten worden ',0),(315988,8778,'fi','Sosiaaliturvatunnus yhteensÃ¤ merkkien on oltava ',0),(315989,8778,'no','Det totale antallet tegn for personnummer mÃ¥ vÃ¦re ',0),(315990,8778,'da','De samlede tegn for CPR-nummer skal vÃ¦re ',0),(315991,8778,'ko','ì‚¬íšŒ ë³´ìž¥ ë²ˆí˜¸ì— ëŒ€ í•œ ì´ ë¬¸ìž ìˆ˜ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤. ',0),(315992,8778,'he','×”×“×ž×•×™×•×ª ×”×›×•×œ×œ ×¢×‘×•×¨ ×”×ž×¡×¤×¨ ×—×™×™×‘ ×œ×”×™×•×ª ',0),(315993,8778,'el','Î¤Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÏ‰Î½ Î³Î¹Î± Ï„Î¿ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÎºÎ®Ï‚ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ',0),(315994,8778,'zh','ç¤¾ä¼šä¿éšœå·ç æ€»å­—ç¬¦å¿…é¡»æ˜¯\r\n',0),(315995,8778,'sv','De totala tecken fÃ¶r personnumret mÃ¥ste vara ',0),(315996,8778,'it','I personaggi in totali per il numero di sicurezza sociale devono essere ',0),(315997,8778,'tl','',0),(315998,8778,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3629;&#3633;&#3585;&#3625;&#3619;&#3586;&#3629;&#3591;&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3585;&#3629;&#3591;&#3607;&#3640;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3626;&#3633;&#3591;&#3588;&#3',0),(315999,8778,'hi','à¤¸à¤¾à¤®à¤¾à¤œà¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤•à¥à¤°à¤®à¤¾à¤‚à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤² à¤…à¤•à¥à¤·à¤°à¥‹à¤‚ à¤•à¤¾ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤ ',0),(316000,8778,'ms','Watak-watak yang jumlah bagi nombor jaminan sosial mestilah ',0),(316001,8778,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙƒÙˆÙ† Ø§Ù„Ø£Ø­Ø±Ù Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ© Ù„Ø±Ù‚Ù… Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ ',0),(316002,8778,'fr','Les total des caractÃ¨res pour le numÃ©ro de sÃ©curitÃ© sociale doivent Ãªtre ',0),(316003,8778,'jp','ç¤¾ä¼šä¿éšœç•ªå·ã®åˆè¨ˆã®æ–‡å­—ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(316004,8778,'pt','Os totais caracteres para o nÃºmero de SeguranÃ§a Social devem ser ',0),(316005,8778,'ru','Ð’ÑÐµÐ³Ð¾ ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¾Ð² Ð´Ð»Ñ Ð½Ð¾Ð¼ÐµÑ€Ð° ÑÐ¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ñ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ ',0),(316006,8778,'es','Los carÃ¡cteres totales para el nÃºmero de Seguro Social debe ser',0),(316007,8778,'de','Die gesamten Zeichen fÃ¼r die Sozialversicherungsnummer mÃ¼ssen sein ',0),(316008,8778,'en','The total characters for the Social Security Number must be ',0),(316009,8779,'is','',0),(316010,8779,'dr','(ØªØ§Ø¨Ø¹) Ø«Ø¨Øª Ú˜ÙˆØ±Ù†Ø§Ù„ Ø§ÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(316011,8779,'pr','Ø§ÙŠÙ† Ø´ØºÙ„ Ø§Ø®ÙŠØ±Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª (ØªØ§Ø¨Ø¹) Ø«Ø¨Øª Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ø§ÙŠ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(316012,8779,'tr','Bu iÅŸ iÃ§in bu iÅŸlevi son oturum',0),(316013,8779,'pl','To zadanie niedawno rejestrowane dla tej funkcji',0),(316014,8779,'bg','Ð¢Ð¾Ð²Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ, Ð½Ð°ÑÐºÐ¾Ñ€Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(316015,8779,'ur','Ø§Ø³ Ú©Ø§Ù… Ù†Û’ Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº Ø§Ø³ ÙØ¹Ù„ Ú©Û’ Ù„Ø¦Û’ Ù„Ø§Ú¯ Ø§Ù†',0),(316016,8779,'sr','ÐžÐ²Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾ Ñ˜Ðµ Ð½ÐµÐ´Ð°Ð²Ð½Ð¾ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™ÐµÐ½ Ð·Ð° Ð¾Ð²Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ',0),(316017,8779,'vi','Job nÃ y Ä‘Ã£ chá»n chá»©c nÄƒng nÃ y',0),(316018,8779,'af','Hierdie Projek is Pas Gemagtig Vir hierdie Doel',0),(316019,8779,'ro','Acest loc de muncÄƒ recent autentificat pentru aceastÄƒ funcÅ£ie',0),(316020,8779,'et','Selle tÃ¶Ã¶ hiljuti sisse loginud selle funktsiooni',0),(316021,8779,'si','Ta posel pred kratkim prijavljeni za to funkcijo',0),(316022,8779,'ba','Pekerjaan ini baru saja login untuk fungsi ini',0),(316023,8779,'nl','Deze baan onlangs aangemeld voor deze functie',0),(316024,8779,'fi','TÃ¤mÃ¤n tyÃ¶n viimeksi kirjattujen tÃ¤tÃ¤ toimintoa',0),(316025,8779,'no','Denne jobben nylig logget For denne funksjonen',0),(316026,8779,'da','Dette Job seneste logget For denne funktion',0),(316027,8779,'ko','ì´ ì¼ì´ì´ í•¨ìˆ˜ì— ëŒ€ í•œ ìµœê·¼ ê¸°ë¡',0),(316028,8779,'he','×”×¢×‘×•×“×” ×”×–××ª ×©× ×¨×©× ×œ××—×¨×•× ×” ×¢×‘×•×¨ ×¤×•× ×§×¦×™×” ×–×•',0),(316029,8779,'el','Î‘Ï…Ï„Î® Î· ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÏŒÏƒÏ†Î±Ï„Î± ÏƒÏ…Î½Î´ÎµÎ´ÎµÎ¼Î­Î½Î¿Ï‚ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(316030,8779,'zh','è¿™é¡¹å·¥ä½œæœ€è¿‘ç™»å½•æ­¤åŠŸèƒ½\r\n',0),(316031,8779,'sv','Detta jobb nyligen loggas fÃ¶r den hÃ¤r funktionen',0),(316032,8779,'it','Questo lavoro ha recentemente registrato per questa funzione',0),(316033,8779,'tl','',0),(316034,8779,'th','&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3619;&#3632;&#3610;&#3610;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;&#3586;&#3629;&#3591;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3609;&#3609;&#3637;&#3',0),(316035,8779,'hi','à¤‡à¤¸ à¤¨à¥Œà¤•à¤°à¥€ à¤¨à¥‡ à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤‡à¤¸ à¤¸à¤®à¤¾à¤°à¥‹à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥‰à¤— à¤‡à¤¨',0),(316036,8779,'ms','Kerja ini Tempahan log untuk fungsi ini',0),(316037,8779,'ar','Ù‡Ø°Ù‡ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ù…Ø¤Ø®Ø±Ø§ ØªØ³Ø¬ÙŠÙ„ Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø¯Ø§Ù„Ø©',0),(316038,8779,'fr','Ce travail rÃ©cemment enregistrÃ© pour cette fonction',0),(316039,8779,'jp','ã“ã®é–¢æ•°ã®æœ€è¿‘è¨˜éŒ²ã•ã‚ŒãŸã“ã®ä»•äº‹',0),(316040,8779,'pt','Este trabalho recentemente registrado para esta funÃ§Ã£o.',0),(316041,8779,'ru','Ð­Ñ‚Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ, Ð½ÐµÐ´Ð°Ð²Ð½Ð¾ Ð¶ÑƒÑ€Ð½Ð°Ð» Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(316042,8779,'es','Este Trabajo Recientemente Anotado Para Esta FunciÃ³n',0),(316043,8779,'de','Diesen Job vor kurzem angemeldet fÃ¼r diese Funktion',0),(316044,8779,'en','This Job Recently Logged For This Function',0),(316045,8780,'is','',0),(316046,8780,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„ ',0),(316047,8780,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙƒÙ„ ',0),(316048,8780,'tr','Toplam miktar',0),(316049,8780,'pl','CaÅ‚kowita iloÅ›Ä‡',0),(316050,8780,'bg','ÐžÐ±Ñ‰Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(316051,8780,'ur','Ú©Ù„ Ù‚ÛŒ',0),(316052,8780,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÐºÐ¾Ð».',0),(316053,8780,'vi','Tá»•ng cá»™ng sá»‘ lÆ°á»£ng',0),(316054,8780,'af','Totale Hoev.',0),(316055,8780,'ro','Cantitate totalÄƒ',0),(316056,8780,'et','Kokku kogus',0),(316057,8780,'si','Skupna koliÄina',0),(316058,8780,'ba','Total Qty',0),(316059,8780,'nl','Totaal aantal',0),(316060,8780,'fi','YhteensÃ¤ kpl',0),(316061,8780,'no','Totalt antall',0),(316062,8780,'da','Samlede antal',0),(316063,8780,'ko','ì´ ìˆ˜ëŸ‰',0),(316064,8780,'he','×¡×” ×› ×›×ž×•×ª',0),(316065,8780,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(316066,8780,'zh','æ€»æ•°é‡\r\n',0),(316067,8780,'sv','Totalt antal',0),(316068,8780,'it','Q. tÃ  totale',0),(316069,8780,'tl','',0),(316070,8780,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(316071,8780,'hi','à¤•à¥à¤² à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(316072,8780,'ms','Qty jumlah',0),(316073,8780,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(316074,8780,'fr','QtÃ© totale',0),(316075,8780,'jp','åˆè¨ˆæ•°é‡',0),(316076,8780,'pt','Qtde total',0),(316077,8780,'ru','ÐžÐ±Ñ‰ÐµÐµ ÐšÐ¾Ð»-Ð²Ð¾',0),(316078,8780,'es','Cant. Total',0),(316079,8780,'de','Total Qty',0),(316080,8780,'en','Total Qty',0),(316081,8781,'is','',0),(316082,8781,'dr','Ù…Ù†Ø·Ù‚Ù‡ ÙˆØ±ÙˆØ¯ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(316083,8781,'pr','Ù…Ù†Ø·Ù‚Ù‡ ÙˆØ±ÙˆØ¯ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(316084,8781,'tr','Alan alma',0),(316085,8781,'pl','Nie importuj pola',0),(316086,8781,'bg','ÐÐµ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð¹ Ð¿Ð¾Ð»Ðµ',0),(316087,8781,'ur','Ù‚Ø·Ø¹Û Ù…Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(316088,8781,'sr','ÐÐµÐ¼Ð¾Ñ˜ Ð´Ð° ÑƒÐ²ÐµÐ·ÐµÑˆ Ð¿Ð¾Ñ™Ðµ',0),(316089,8781,'vi','KhÃ´ng nháº­p trÆ°á»ng',0),(316090,8781,'af','Moenie Velde Invoer nie',0),(316091,8781,'ro','Nu se importÄƒ cÃ¢mpul',0),(316092,8781,'et','Ã„ra impordi vÃ¤lja',0),(316093,8781,'si','Ne uvaÅ¾aj polje',0),(316094,8781,'ba','Jangan impor Field',0),(316095,8781,'nl','Veld niet importeren',0),(316096,8781,'fi','Ã„lÃ¤ tuo kenttÃ¤Ã¤',0),(316097,8781,'no','Ikke Import felt',0),(316098,8781,'da','Import ikke feltet',0),(316099,8781,'ko','í•„ë“œë¥¼ ê°€ì ¸ì˜¤ì§€ ì•ŠìŒ',0),(316100,8781,'he','××œ ×ª×™×™×‘× ×©×“×”',0),(316101,8781,'el','ÎÎ± Î¼Î·Î½ ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯ Ï„Î¿ Ï€ÎµÎ´Î¯Î¿',0),(316102,8781,'zh','ä¸å¯¼å…¥å­—æ®µ\r\n',0),(316103,8781,'sv','Ingen Import av fÃ¤lt',0),(316104,8781,'it','Non importare campo',0),(316105,8781,'tl','',0),(316106,8781,'th','&#3629;&#3618;&#3656;&#3634;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3615;&#3636;&#3621;&#3604;&#3660;',0),(316107,8781,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤†à¤¯à¤¾à¤¤ à¤¨ à¤•à¤°à¥‡à¤‚',0),(316108,8781,'ms','Jangan mengimport Field',0),(316109,8781,'ar','Ø¹Ø¯Ù… Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø­Ù‚Ù„',0),(316110,8781,'fr','Ne pas importer le champ',0),(316111,8781,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã›ã‚“ã€‚',0),(316112,8781,'pt','NÃ£o importar o campo',0),(316113,8781,'ru','ÐÐµ ÑÐ»ÐµÐ´ÑƒÐµÑ‚ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð¾Ð»Ðµ',0),(316114,8781,'es','No importar un Campo',0),(316115,8781,'de','Feld nicht importieren',0),(316116,8781,'en','Do Not Import Field',0),(316117,8782,'is','',0),(316118,8782,'dr','ÙÙ‚Ø· Ø³Ø± ÙØµÙ„',0),(316119,8782,'pr','ÙÙ‚Ø· Ø³Ø± ÙØµÙ„',0),(316120,8782,'tr','YalnÄ±zca baÅŸlÄ±k',0),(316121,8782,'pl','Pozycja tylko',0),(316122,8782,'bg','Ð¡Ð°Ð¼Ð¾ Ð·Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ',0),(316123,8782,'ur','ØµØ±Ù Ø³Ø±Ø®ÛŒ',0),(316124,8782,'sr','Ð¡Ð°Ð¼Ð¾ Ð½Ð°ÑÐ»Ð¾Ð²',0),(316125,8782,'vi','Chá»‰ LÃ£nh Ä‘áº¡o',0),(316126,8782,'af','Opskrif slegs',0),(316127,8782,'ro','Doar la poziÅ£ia',0),(316128,8782,'et','Ainult pealkiri',0),(316129,8782,'si','Samo naslov',0),(316130,8782,'ba','Menuju hanya',0),(316131,8782,'nl','Rubriek alleen',0),(316132,8782,'fi','Vain otsikko',0),(316133,8782,'no','Bare overskrift',0),(316134,8782,'da','Kun pÃ¥ vej',0),(316135,8782,'ko','ì œëª©ë§Œ',0),(316136,8782,'he','×›×•×ª×¨×ª ×‘×œ×‘×“',0),(316137,8782,'el','ÎšÎ»Î¬ÏƒÎ· Î¼ÏŒÎ½Î¿',0),(316138,8782,'zh','åªæœ‰æ ‡é¢˜\r\n',0),(316139,8782,'sv','Rubrik endast',0),(316140,8782,'it','Solo voce',0),(316141,8782,'tl','',0),(316142,8782,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;',0),(316143,8782,'hi','à¤•à¥‡à¤µà¤² à¤¶à¥€à¤°à¥à¤·à¤•',0),(316144,8782,'ms','Tajuk sahaja',0),(316145,8782,'ar','Ø§Ù„Ø¹Ù†ÙˆØ§Ù† ÙÙ‚Ø·',0),(316146,8782,'fr','Rubrique seulement',0),(316147,8782,'jp','è¦‹å‡ºã—ã®ã¿',0),(316148,8782,'pt','TÃ­tulo somente',0),(316149,8782,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²Ð¾Ðº',0),(316150,8782,'es','Encabezado Solo',0),(316151,8782,'de','Nur Ãœberschrift',0),(316152,8782,'en','Heading Only',0),(316153,8783,'is','',0),(316154,8783,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¬Ø¹Ø¨Ù‡ Ù¾ÙŠØ§Ù… Ø±Ø§Ø¯ÙŠÙˆÙŠÙŠ',0),(316155,8783,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¬Ø¹Ø¨Ù‡ Ù¾ÙŠØ§Ù… Ø±Ø§Ø¯ÙŠÙˆÙŠÙŠ',0),(316156,8783,'tr','Radyo dÃ¼ÄŸmesi',0),(316157,8783,'pl','Przycisk radiowy',0),(316158,8783,'bg','Ð Ð°Ð´Ð¸Ð¾ Ð±ÑƒÑ‚Ð¾Ð½',0),(316159,8783,'ur','Ø±ÛŒÚˆÛŒÙˆ Ø¨Ù¹Ù†',0),(316160,8783,'sr','Ð Ð°Ð´Ð¸Ð¾ Ð´ÑƒÐ³Ð¼Ðµ',0),(316161,8783,'vi','NÃºt Radio',0),(316162,8783,'af','Radio-knoppie',0),(316163,8783,'ro','Buton radio',0),(316164,8783,'et','Nupp',0),(316165,8783,'si','Izbirni gumb',0),(316166,8783,'ba','Tombol radio',0),(316167,8783,'nl','Keuzerondje',0),(316168,8783,'fi','Valintanappi',0),(316169,8783,'no','Alternativknappen',0),(316170,8783,'da','Alternativknappen',0),(316171,8783,'ko','ë¼ë””ì˜¤ ë²„íŠ¼',0),(316172,8783,'he','×œ×—×¦×Ÿ ××¤×©×¨×•×™×•×ª',0),(316173,8783,'el','ÎšÎ¿Ï…Î¼Ï€Î¯ ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚',0),(316174,8783,'zh','å•é€‰æŒ‰é’®\r\n',0),(316175,8783,'sv','Alternativknapp',0),(316176,8783,'it','Pulsante radio',0),(316177,8783,'tl','',0),(316178,8783,'th','Radio Button',0),(316179,8783,'hi','à¤°à¥‡à¤¡à¤¿à¤¯à¥‹ à¤¬à¤Ÿà¤¨',0),(316180,8783,'ms','Butang radio',0),(316181,8783,'ar','Ø²Ø± Ø±Ø§Ø¯ÙŠÙˆ',0),(316182,8783,'fr','Bouton radio',0),(316183,8783,'jp','ãƒ©ã‚¸ã‚ª ãƒœã‚¿ãƒ³',0),(316184,8783,'pt','BotÃ£o de opÃ§Ã£o',0),(316185,8783,'ru','ÐšÐ½Ð¾Ð¿ÐºÐ° Ð Ð°Ð´Ð¸Ð¾',0),(316186,8783,'es','BotÃ³n de Radio',0),(316187,8783,'de','Radio-Button',0),(316188,8783,'en','Radio Button',0),(316189,8784,'is','',0),(316190,8784,'dr','ÙÙ‚Ø· Ø®ÙˆØ§Ù†Ø¯Ù† ',0),(316191,8784,'pr','ÙÙ‚Ø· Ø®ÙˆØ§Ù†Ø¯Ù† ',0),(316192,8784,'tr','Salt okunur',0),(316193,8784,'pl','Tylko do odczytu',0),(316194,8784,'bg','Ð¡Ð°Ð¼Ð¾ Ð·Ð° Ñ‡ÐµÑ‚ÐµÐ½Ðµ',0),(316195,8784,'ur','ÙÙ‚Ø· Ù…Ø·Ø§Ù„Ø¹Û',0),(316196,8784,'sr','Ð¡Ð°Ð¼Ð¾ Ð·Ð° Ñ‡Ð¸Ñ‚Ð°ÑšÐµ',0),(316197,8784,'vi','Chá»‰ Äá»c',0),(316198,8784,'af','Lees-Alleen',0),(316199,8784,'ro','Doar Ã®n citire',0),(316200,8784,'et','Loe ainult',0),(316201,8784,'si','Samo za branje',0),(316202,8784,'ba','Hanya membaca',0),(316203,8784,'nl','Alleen-lezen',0),(316204,8784,'fi','Vain luku',0),(316205,8784,'no','Skrivebeskyttet',0),(316206,8784,'da','LÃ¦s kun',0),(316207,8784,'ko','ì½ê¸° ì „ìš©',0),(316208,8784,'he','×œ×§×¨×™××” ×‘×œ×‘×“',0),(316209,8784,'el','ÎœÏŒÎ½Î¿ Î³Î¹Î± Î±Î½Î¬Î³Î½Ï‰ÏƒÎ·',0),(316210,8784,'zh','åªè¯»\r\n',0),(316211,8784,'sv','Endast lÃ¤sning',0),(316212,8784,'it','Sola lettura',0),(316213,8784,'tl','',0),(316214,8784,'th','&#3629;&#3656;&#3634;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(316215,8784,'hi','à¤•à¥‡à¤µà¤² à¤ªà¤¢à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(316216,8784,'ms','Baca sahaja',0),(316217,8784,'ar','Ù‚Ø±Ø§Ø¡Ø© ÙÙ‚Ø· ØŸ',0),(316218,8784,'fr','Lecture seule',0),(316219,8784,'jp','èª­ã¿å–ã‚Šå°‚ç”¨ã§ã™ã€‚',0),(316220,8784,'pt','Somente leitura',0),(316221,8784,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ñ‡Ñ‚ÐµÐ½Ð¸Ðµ',0),(316222,8784,'es','Leer Solo',0),(316223,8784,'de','Nur lesen',0),(316224,8784,'en','Read Only',0),(316225,8785,'is','',0),(316226,8785,'dr','Ø¯ÙˆØ¯ÙŠ',0),(316227,8785,'pr','Ø¯ÙˆØ¯ÙŠ',0),(316228,8785,'tr','Duman',0),(316229,8785,'pl','Dym',0),(316230,8785,'bg','Ð”Ð¸Ð¼',0),(316231,8785,'ur','Ø¯Ú¾ÙˆØ§Úº',0),(316232,8785,'sr','Ð”Ð¸Ð¼',0),(316233,8785,'vi','KhÃ³i',0),(316234,8785,'af','Rook',0),(316235,8785,'ro','Fum',0),(316236,8785,'et','Suitsu',0),(316237,8785,'si','Dima',0),(316238,8785,'ba','Asap',0),(316239,8785,'nl','Rook',0),(316240,8785,'fi','Savua',0),(316241,8785,'no','RÃ¸yk',0),(316242,8785,'da','RÃ¸g',0),(316243,8785,'ko','ì—°ê¸°',0),(316244,8785,'he','×¢×©×Ÿ',0),(316245,8785,'el','ÎšÎ±Ï€Î½ÏŒÏ‚',0),(316246,8785,'zh','çƒŸ\r\n',0),(316247,8785,'sv','RÃ¶k',0),(316248,8785,'it','Fumo',0),(316249,8785,'tl','',0),(316250,8785,'th','&#3626;&#3637;&#3588;&#3623;&#3633;&#3609;&#3610;&#3640;&#3627;&#3619;&#3637;&#3656;',0),(316251,8785,'hi','à¤§à¥à¤†à¤',0),(316252,8785,'ms','Asap',0),(316253,8785,'ar','Ø¯Ø®Ø§Ù†ÙŠÙ‘',0),(316254,8785,'fr','FumÃ©e',0),(316255,8785,'jp','ç…™',0),(316256,8785,'pt','FumaÃ§a',0),(316257,8785,'ru','Ð”Ñ‹Ð¼Ñ‡Ð°Ñ‚Ñ‹Ð¹',0),(316258,8785,'es','Humo',0),(316259,8785,'de','Rauch',0),(316260,8785,'en','Smoke',0),(316261,8786,'is','',0),(316262,8786,'dr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¯Ø§Ø®Ù„ÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø­Ø°Ù Ø´ÙˆØ¯ ',0),(316263,8786,'pr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¯Ø§Ø®Ù„ÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø­Ø°Ù Ø´ÙˆØ¯ ',0),(316264,8786,'tr','Ä°Ã§ Ã¶zel alanlar silinemez',0),(316265,8786,'pl','Nie moÅ¼na usunÄ…Ä‡ wewnÄ™trzne pola niestandardowe',0),(316266,8786,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð½Ðµ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸',0),(316267,8786,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ù…Ø®ØµÙˆØµ Ù‚Ø·Ø¹Ø§Øª Ú©Ùˆ Ø­Ø°Ù Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§',0),(316268,8786,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ñ™Ð° ÑÐµ Ð½Ðµ Ð¼Ð¾Ð³Ñƒ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸.',0),(316269,8786,'vi','TrÆ°á»ng tá»± táº¡o ná»™i bá»™ khÃ´ng thá»ƒ xÃ³a',0),(316270,8786,'af','Interne Aangepasde Velde Kan nie Geskrap word nie',0),(316271,8786,'ro','Interne personalizat domenii nu pot fi ÅŸterse',0),(316272,8786,'et','Sisemise kohandatud vÃ¤lju ei saa kustutada',0),(316273,8786,'si','Notranja polja po meri ni mogoÄe izbrisati',0),(316274,8786,'ba','Bidang kustom internal tidak dapat dihapus',0),(316275,8786,'nl','Interne aangepaste velden kunnen niet worden verwijderd',0),(316276,8786,'fi','SisÃ¤isiÃ¤ mukautettuja kenttiÃ¤ ei voi poistaa',0),(316277,8786,'no','Intern egendefinerte felt kan ikke slettes',0),(316278,8786,'da','Interne brugerdefinerede felter kan ikke slettes',0),(316279,8786,'ko','ë‚´ë¶€ ì‚¬ìš©ìž ì •ì˜ í•„ë“œë¥¼ ì‚­ì œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(316280,8786,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×—×•×§ ×©×“×•×ª ×ž×•×ª××ž×™× ××™×©×™×ª ×¤× ×™×ž×™×ª',0),(316281,8786,'el','Î•Î¯Î½Î±Î¹ Î±Î´ÏÎ½Î±Ï„Î· Î· ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î± Ï€ÎµÎ´Î¯Î±',0),(316282,8786,'zh','å†…éƒ¨è‡ªå®šä¹‰å­—æ®µä¸èƒ½åˆ é™¤\r\n',0),(316283,8786,'sv','Inre anpassade fÃ¤lt kan inte tas bort',0),(316284,8786,'it','Campi interni personalizzati non possono essere eliminati',0),(316285,8786,'tl','',0),(316286,8786,'th','&#3616;&#3634;&#3618;&#3651;&#3609;&#3611;&#3619;&#3633;&#3610;&#3649;&#3605;&#3656;&#3591;&#3615;&#3636;&#3621;&#3604;&#3660;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3621;&#3610;&#3652;&#3604;&#3657;',0),(316287,8786,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤•à¤¸à¥à¤Ÿà¤® à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(316288,8786,'ms','Bidang adat dalaman tidak dapat dihapuskan',0),(316289,8786,'ar','Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ© Ø§Ù„Ù…Ø®ØµÙ‘ØµØ© Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø­Ø°ÙÙ‡Ø§',0),(316290,8786,'fr','Impossible de supprimer des champs personnalisÃ©s internes',0),(316291,8786,'jp','å†…éƒ¨ã®ã‚«ã‚¹ã‚¿ãƒ  ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã¯å‰Šé™¤ã§ãã¾ã›ã‚“ã€‚',0),(316292,8786,'pt','Campos personalizados internos nÃ£o podem ser excluÃ­dos.',0),(316293,8786,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ðµ Ð¿Ð¾Ð»Ñ Ð½Ðµ Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(316294,8786,'es','Campos Personalizados Internales no se Puede Eliminar',0),(316295,8786,'de','Interne benutzerdefinierte Felder kÃ¶nnen nicht gelÃ¶scht werden',0),(316296,8786,'en','Internal Custom Fields Cannot Be Deleted',0),(316297,8787,'is','',0),(316298,8787,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡',0),(316299,8787,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡',0),(316300,8787,'tr','Fulfillment sipariÅŸler izin ver',0),(316301,8787,'pl','UmoÅ¼liwienia realizacji zamÃ³wienia',0),(316302,8787,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»ÑÐ²Ð°Ñ‚ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(316303,8787,'ur','ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(316304,8787,'sr','ÐžÐ¼Ð¾Ð³ÑƒÑ›Ð¸Ñ‚Ð¸ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(316305,8787,'vi','Cho PhÃ©p ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(316306,8787,'af','Laat Uitvoeringsbestelling toe',0),(316307,8787,'ro','Permite realizarea comenzilor',0),(316308,8787,'et','Luba kaubatellimused',0),(316309,8787,'si','OmogoÄi izpolnitev naroÄila',0),(316310,8787,'ba','Mengijinkan Pemenuhan Pesanan',0),(316311,8787,'nl','Vervulling Orders toestaan',0),(316312,8787,'fi','Salli tÃ¤yttÃ¤minen tilaukset',0),(316313,8787,'no','Tillate fullfÃ¸ringen bestillinger',0),(316314,8787,'da','Giver mulighed for Fulfillment ordrer',0),(316315,8787,'ko','í–‰ ì£¼ë¬¸ í—ˆìš©',0),(316316,8787,'he','×œ××¤×©×¨ ×ž×™×ž×•×© ×”×–×ž× ×•×ª',0),(316317,8787,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î·Î½ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(316318,8787,'zh','å…è®¸å±¥è¡Œè®¢å•\r\n',0),(316319,8787,'sv','TillÃ¥ta uppfyllelse order',0),(316320,8787,'it','Consentire l\'ordini di evasione',0),(316321,8787,'tl','',0),(316322,8787,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(316323,8787,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(316324,8787,'ms','Membolehkan perlaksanaan perintah',0),(316325,8787,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨ØªÙ†ÙÙŠØ° Ø£ÙˆØ§Ù…Ø±',0),(316326,8787,'fr','Permettre Ã  des ordres de',0),(316327,8787,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ãƒ» ã‚ªãƒ¼ãƒ€ãƒ¼ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(316328,8787,'pt','Permitir o ordens de cumprimento',0),(316329,8787,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(316330,8787,'es','Permitir Ordenes de Cumplimiento',0),(316331,8787,'de','Fulfillment-Bestellungen zu ermÃ¶glichen',0),(316332,8787,'en','Allow Fulfillment Orders',0),(316333,8788,'is','',0),(316334,8788,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª',0),(316335,8788,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª',0),(316336,8788,'tr','Servis sipariÅŸlerini izin ver',0),(316337,8788,'pl','PozwalajÄ… zleceÅ„ serwisowych',0),(316338,8788,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(316339,8788,'ur','Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(316340,8788,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(316341,8788,'vi','Cho PhÃ©p ÄÆ¡n Äáº·t HÃ ng Dá»‹ch Vá»¥',0),(316342,8788,'af','Laat Diensbestellings toe',0),(316343,8788,'ro','Permite comenzi de Service',0),(316344,8788,'et','Luba hooldustellimuste',0),(316345,8788,'si','OmogoÄajo servisnih nalogov',0),(316346,8788,'ba','Mengijinkan Pesanan Jasa',0),(316347,8788,'nl','Toestaan van serviceorders',0),(316348,8788,'fi','Salli huoltotilaukset',0),(316349,8788,'no','Tillate serviceordrer',0),(316350,8788,'da','Tillad serviceordrer',0),(316351,8788,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ í—ˆìš©',0),(316352,8788,'he','××¤×©×¨ ×”×–×ž× ×•×ª ×©×™×¨×•×ª',0),(316353,8788,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î¹Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï…',0),(316354,8788,'zh','å…è®¸æœåŠ¡è®¢å•\r\n',0),(316355,8788,'sv','TillÃ¥t serviceorder',0),(316356,8788,'it','Consentire gli ordini di servizio',0),(316357,8788,'tl','',0),(316358,8788,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(316359,8788,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(316360,8788,'ms','Membolehkan perkhidmatan pesanan',0),(316361,8788,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(316362,8788,'fr','Permettre aux commandes de Service',0),(316363,8788,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(316364,8788,'pt','Permitir que as ordens de serviÃ§o',0),(316365,8788,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(316366,8788,'es','Permitir Ordenes de Servicio',0),(316367,8788,'de','ServiceauftrÃ¤ge zu ermÃ¶glichen',0),(316368,8788,'en','Allow Service Orders',0),(316369,8789,'is','',0),(316370,8789,'dr','ÙƒÙ†ØªØ±Ù„ ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÙŠ',0),(316371,8789,'pr','ÙƒÙ†ØªØ±Ù„ ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÙŠ',0),(316372,8789,'tr','Denetim mÃ¼ÅŸteri sayfa',0),(316373,8789,'pl','Strona klienta sterowania',0),(316374,8789,'bg','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð» Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(316375,8789,'ur','Ú©Ù†Ù¹Ø±ÙˆÙ„ Ú©Ø³Ù¹Ù…Ø± ØµÙØ­Û',0),(316376,8789,'sr','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(316377,8789,'vi','Äiá»u khiá»ƒn Trang khÃ¡ch hÃ ng',0),(316378,8789,'af','Beheer KliÃ«nt/Klant Blad',0),(316379,8789,'ro','Controlul clientului filme',0),(316380,8789,'et','Kontrolli kliendi leht',0),(316381,8789,'si','Nadzor strani kupca',0),(316382,8789,'ba','Kontrol pelanggan Halaman',0),(316383,8789,'nl','Besturingselement klantenpagina',0),(316384,8789,'fi','Asiakkaan sivu',0),(316385,8789,'no','Kontrollside som kunde',0),(316386,8789,'da','Kontrol kunde side',0),(316387,8789,'ko','ì œì–´ ê³ ê° íŽ˜ì´ì§€',0),(316388,8789,'he','×“×£ ×œ×œ×§×•×— ×©×œ×™×˜×”',0),(316389,8789,'el','Î ÎµÎ»Î¬Ï„Î· ÏƒÎµÎ»Î¯Î´Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(316390,8789,'zh','æŽ§åˆ¶å®¢æˆ·é¡µé¢\r\n',0),(316391,8789,'sv','Kontroll kund sida',0),(316392,8789,'it','Pagina di controllo cliente',0),(316393,8789,'tl','',0),(316394,8789,'th','&#3627;&#3609;&#3657;&#3634;&#3588;&#3623;&#3610;&#3588;&#3640;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(316395,8789,'hi','à¤¨à¤¿à¤¯à¤‚à¤¤à¥à¤°à¤£ à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¥ƒà¤·à¥à¤ ',0),(316396,8789,'ms','Kawalan pelanggan Laman',0),(316397,8789,'ar','ØµÙØ­Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„ØªØ­ÙƒÙ…',0),(316398,8789,'fr','ContrÃ´le client Page',0),(316399,8789,'jp','åˆ¶å¾¡é¡§å®¢ãƒšãƒ¼ã‚¸',0),(316400,8789,'pt','PÃ¡gina de controle do cliente',0),(316401,8789,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(316402,8789,'es','PÃ¡gina de Cliente de Control',0),(316403,8789,'de','Control-Kunden-Seite',0),(316404,8789,'en','Control Customer Page',0),(316405,8790,'is','',0),(316406,8790,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ù†ÙŠØ³Øª',0),(316407,8790,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ù†ÙŠØ³Øª',0),(316408,8790,'tr','Engelleyemezsiniz',0),(316409,8790,'pl','Nie moÅ¼na zablokowaÄ‡',0),(316410,8790,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°',0),(316411,8790,'ur','Ø¨Ù„Ø§Ú© Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(316412,8790,'sr','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°',0),(316413,8790,'vi','KhÃ´ng thá»ƒ giá»¯ trÆ°á»›c',0),(316414,8790,'af','Kan blokkeer',0),(316415,8790,'ro','Nu pot bloca',0),(316416,8790,'et','Ei saa blokeerida',0),(316417,8790,'si','Ne morete blokirati',0),(316418,8790,'ba','Tidak dapat memblokir',0),(316419,8790,'nl','Niet blokkeren',0),(316420,8790,'fi','Ei voi estÃ¤Ã¤',0),(316421,8790,'no','Kan ikke blokkere',0),(316422,8790,'da','Kan ikke blokere',0),(316423,8790,'ko','ì°¨ë‹¨í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(316424,8790,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×—×¡×•×',0),(316425,8790,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï€Î±Î³ÏŽÏƒÎµÎ¹',0),(316426,8790,'zh','ä¸èƒ½é˜»æ­¢\r\n',0),(316427,8790,'sv','Inte kan blockera',0),(316428,8790,'it','Non Ã¨ possibile bloccare',0),(316429,8790,'tl','',0),(316430,8790,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3610;&#3621;&#3655;&#3629;&#3585;&#3652;&#3604;&#3657;',0),(316431,8790,'hi','à¤¬à¥à¤²à¥‰à¤• à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(316432,8790,'ms','Tidak dapat menyekat',0),(316433,8790,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø­Ø¬Ø¨',0),(316434,8790,'fr','Ne peut pas bloquer',0),(316435,8790,'jp','ãƒ–ãƒ­ãƒƒã‚¯ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(316436,8790,'pt','NÃ£o pode bloquear',0),(316437,8790,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð—Ð°Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(316438,8790,'es','No se puede Bloquear',0),(316439,8790,'de','Kann nicht blocken',0),(316440,8790,'en','Cannot Block',0),(316441,8791,'is','',0),(316442,8791,'dr','Ø¨Ø±Ø±Ø³ÙŠ  Ø¬Ù‡Øª Ù…Ø§Ù†Ø¹ Ø´Ø¯Ù†  Ø§Ø² ØµÙØ­Ø§Øª ÙˆØ±ÙˆØ¯ÙŠ',0),(316443,8791,'pr','Ø¨Ø±Ø±Ø³ÙŠ  Ø¬Ù‡Øª Ù…Ø§Ù†Ø¹ Ø´Ø¯Ù†  Ø§Ø² ØµÙØ­Ø§Øª ÙˆØ±ÙˆØ¯ÙŠ',0),(316444,8791,'tr','Engellemek iÃ§in kontrol edin<br>GiriÅŸ ekranlarÄ±',0),(316445,8791,'pl','SprawdÅº, blok<br>od wprowadzania ekrany',0),(316446,8791,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð±Ð»Ð¾Ðº<br>Ð¾Ñ‚ Ð²Ñ…Ð¾Ð´Ð½Ð¸Ñ‚Ðµ ÐµÐºÑ€Ð°Ð½Ð¸',0),(316447,8791,'ur','Ø¨Ù„Ø§Ú© Ø³Û’ Ø¨Ù„Ø§Ú© Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº<br>Ø§Ù† Ù¾Ù¹ Ú©ÛŒ Ø³Ú©Ø±ÛŒÙ† Ø³Û’',0),(316448,8791,'sr','ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð»Ð¾Ðº<br>Ð¸Ð· ÐµÐºÑ€Ð°Ð½Ð° Ð·Ð° ÑƒÐ½Ð¾Ñ',0),(316449,8791,'vi','ÄÃ¡nh dáº¥u Ä‘á»ƒ Ä‘áº·t tá»« mÃ n hÃ¬nh vÃ o',0),(316450,8791,'af','Merk om Invoerskerms te blokkeer',0),(316451,8791,'ro','Verifica la bloc<br>la intrare ecrane',0),(316452,8791,'et','MÃ¤rkige see ruut Blokeeri<br>alates sisestamise',0),(316453,8791,'si','Preverite blok<br>iz vhodnega zasloni',0),(316454,8791,'ba','Periksa untuk blok<br>dari layar Input',0),(316455,8791,'nl','Controleren op blokkeren<br>van Input schermen',0),(316456,8791,'fi','Tarkista lohko<br>Input nÃ¤ytÃ¶istÃ¤',0),(316457,8791,'no','Sjekk for Ã¥ blokkere<br>fra Input skjermer',0),(316458,8791,'da','Check til blok<br>fra Input skÃ¦rme',0),(316459,8791,'ko','ë¸”ë¡ í™•ì¸<br>ìž…ë ¥ëœ í™”ë©´ì—ì„œ',0),(316460,8791,'he','×‘×“×•×§ ×›×“×™ ×œ×—×¡×•×<br>×”×ž×¡×›×™× ×§×œ×˜',0),(316461,8791,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÏƒÎµ Î¼Ï€Î»Î¿Îº<br>Î±Ï€ÏŒ Î¿Î¸ÏŒÎ½ÎµÏ‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(316462,8791,'zh','æ£€æŸ¥ä»¥é˜»æ­¢è¾“å…¥ç•Œé¢\r\n',0),(316463,8791,'sv','Kolla pÃ¥ blocket<br>frÃ¥n ingÃ¥ng skÃ¤rmar',0),(316464,8791,'it','Verifica al blocco<br>da ingresso schermi',0),(316465,8791,'tl','',0),(316466,8791,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3648;&#3614;&#3639;&#3656;&#3629;&#3611;&#3657;&#3629;&#3591;&#3585;&#3633;&#3609;&#3585;&#3634;&#3619;&#3629;&#3636;&#3609;&#3614;&#3640;&#3605;&#3592;&#3634;&#3585;&#3627;&#3609;&#3657;&#3634;&#3592;&#3',0),(316467,8791,'hi','à¤¬à¥à¤²à¥‰à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚<br>à¤‡à¤¨à¤ªà¥à¤Ÿ à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤¸à¥‡',0),(316468,8791,'ms','Semak untuk blok<br>dari skrin Input',0),(316469,8791,'ar','Ø¶Ø¹ Ø¹Ù„Ø§Ù…Ø© Ù„Ù„Ø­Ø¬Ø¨ ÙÙŠ Ø´Ø§Ø´Ø§Øª Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(316470,8791,'fr','VÃ©rifier au bloc<br>des Ã©crans de saisie',0),(316471,8791,'jp','ãƒ–ãƒ­ãƒƒã‚¯ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚<br>å…¥åŠ›ç”»é¢ã‹ã‚‰',0),(316472,8791,'pt','Verificar ao bloco<br>de telas de entrada',0),(316473,8791,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð±Ð»Ð¾Ðº<br>Ð¾Ñ‚ Ð²Ñ…Ð¾Ð´Ð½Ñ‹Ñ… ÑÐºÑ€Ð°Ð½Ð¾Ð²',0),(316474,8791,'es','Checar para Bloquear de las Pantallas de Input',0),(316475,8791,'de','ÃœberprÃ¼fen Sie auf Block<br>von Eingabe-Masken',0),(316476,8791,'en','Check to Block<br>from Input Screens',0),(316477,8792,'is','',0),(316478,8792,'dr','Ù†Ø§Ù… Ø³ØªÙˆÙ† ',0),(316479,8792,'pr','Ù†Ø§Ù… Ø³ØªÙˆÙ† ',0),(316480,8792,'tr','SÃ¼tun adÄ±',0),(316481,8792,'pl','Nazwa kolumna',0),(316482,8792,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¾Ð½Ð°',0),(316483,8792,'ur','Ú©Ø§Ù„Ù… Ú©Ø§ Ù†Ø§Ù…',0),(316484,8792,'sr','Ð˜Ð¼Ðµ ÐºÐ¾Ð»Ð¾Ð½Ðµ',0),(316485,8792,'vi','TÃªn cá»™t',0),(316486,8792,'af','Kolomnaam',0),(316487,8792,'ro','Nume coloanÄƒ',0),(316488,8792,'et','Veeru nimi',0),(316489,8792,'si','Ime stolpca',0),(316490,8792,'ba','Nama kolom',0),(316491,8792,'nl','Kolomnaam',0),(316492,8792,'fi','Sarakkeen nimi',0),(316493,8792,'no','Kolonnenavn',0),(316494,8792,'da','Kolonnenavnet',0),(316495,8792,'ko','ì—´ ì´ë¦„',0),(316496,8792,'he','×©× ×¢×ž×•×“×”',0),(316497,8792,'el','ÎŒÎ½Î¿Î¼Î± ÏƒÏ„Î®Î»Î·Ï‚',0),(316498,8792,'zh','åˆ—å\r\n',0),(316499,8792,'sv','Kolumnnamn',0),(316500,8792,'it','Nome di colonna',0),(316501,8792,'tl','',0),(316502,8792,'th','&#3594;&#3639;&#3656;&#3629;&#3649;&#3606;&#3623;',0),(316503,8792,'hi','à¤¸à¥à¤¤à¤‚à¤­ à¤¨à¤¾à¤®',0),(316504,8792,'ms','Nama kolum',0),(316505,8792,'ar','Ø¥Ø³Ù… Ø§Ù„Ø¹Ù…ÙˆØ¯/Ø§Ù„Ø®Ø§Ù†Ø©',0),(316506,8792,'fr','Nom de colonne',0),(316507,8792,'jp','åˆ—å',0),(316508,8792,'pt','Nome da coluna',0),(316509,8792,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐšÐ¾Ð»Ð¾Ð½ÐºÐ¸',0),(316510,8792,'es','Columna Nombre',0),(316511,8792,'de','Spaltenname',0),(316512,8792,'en','Column Name',0),(316513,8793,'is','',0),(316514,8793,'dr','ÙƒÙ†ØªØ±Ù„ ØµÙØ­Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(316515,8793,'pr','ÙƒÙ†ØªØ±Ù„ ØµÙØ­Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(316516,8793,'tr','MÃ¼ÅŸteri sayfa denetimi',0),(316517,8793,'pl','Formantu strony klienta',0),(316518,8793,'bg','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(316519,8793,'ur','Ú©Ø³Ù¹Ù…Ø± ØµÙØ­Û Ú©Ù†Ù¹Ø±ÙˆÙ„',0),(316520,8793,'sr','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(316521,8793,'vi','Äiá»u khiá»ƒn Trang khÃ¡ch hÃ ng',0),(316522,8793,'af','Klant / KliÃ«nt Bladsykontrole',0),(316523,8793,'ro','Control de pagina de client',0),(316524,8793,'et','Kliendi lehe kontroll',0),(316525,8793,'si','Kontrolnikom strani kupca',0),(316526,8793,'ba','Pelanggan halaman kontrol',0),(316527,8793,'nl','Besturingselement voor pagina-klant',0),(316528,8793,'fi','Asiakkaan sivun ohjausobjekti',0),(316529,8793,'no','Siden kundekontroll',0),(316530,8793,'da','Kunde Page Control',0),(316531,8793,'ko','ê³ ê° íŽ˜ì´ì§€ ì»¨íŠ¸ë¡¤',0),(316532,8793,'he','×”×œ×§×•×— ×“×£ ×”×‘×§×¨×”',0),(316533,8793,'el','Î£ÎµÎ»Î¯Î´Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(316534,8793,'zh','å®¢æˆ·é¡µé¢æŽ§åˆ¶\r\n',0),(316535,8793,'sv','Kunden sidkontroll',0),(316536,8793,'it','Controllo pagina cliente',0),(316537,8793,'tl','',0),(316538,8793,'th','&#3627;&#3609;&#3657;&#3634;&#3588;&#3623;&#3610;&#3588;&#3640;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(316539,8793,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¥ƒà¤·à¥à¤  à¤¨à¤¿à¤¯à¤‚à¤¤à¥à¤°à¤£',0),(316540,8793,'ms','Kawalan halaman pelanggan',0),(316541,8793,'ar','Ø¹Ù†ØµØ± ØªØ­ÙƒÙ… ÙÙŠ ØµÙØ­Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(316542,8793,'fr','ContrÃ´le de la Page client',0),(316543,8793,'jp','ãŠå®¢æ§˜ãƒšãƒ¼ã‚¸ ã‚³ãƒ³ãƒˆãƒ­ãƒ¼ãƒ«',0),(316544,8793,'pt','Controle de pÃ¡gina de cliente',0),(316545,8793,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(316546,8793,'es','Cliente Control de PÃ¡gina',0),(316547,8793,'de','Kunden-Page-Steuerelement',0),(316548,8793,'en','Customer Page Control',0),(316549,8794,'is','',0),(316550,8794,'dr','5',0),(316551,8794,'pr','Ø·Ø±Ø­ 5',0),(316552,8794,'tr','BeÅŸ planÄ±',0),(316553,8794,'pl','PiÄ™Ä‡ planu',0),(316554,8794,'bg','ÐŸÐ»Ð°Ð½ Ð·Ð° Ð¿ÐµÑ‚',0),(316555,8794,'ur','Ù¾Ø§Ù†Ú† Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(316556,8794,'sr','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°ÑšÐµ Ð¿ÐµÑ‚ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(316557,8794,'vi','NhÃ  mÃ¡y 5',0),(316558,8794,'af','Plan Vyf',0),(316559,8794,'ro','Planul de cinci',0),(316560,8794,'et','Kavas viis',0),(316561,8794,'si','NaÄrt pet',0),(316562,8794,'ba','Rencana lima',0),(316563,8794,'nl','Plan vijf',0),(316564,8794,'fi','Suunnitelma viisi',0),(316565,8794,'no','Planlegge fem',0),(316566,8794,'da','PlanlÃ¦gge fem',0),(316567,8794,'ko','5 ê³„íš',0),(316568,8794,'he','×ª×›× ×™×ª 5',0),(316569,8794,'el','Î£Ï‡Î­Î´Î¹Î¿ Ï€Î­Î½Ï„Îµ',0),(316570,8794,'zh','è®¡åˆ’äº”\r\n',0),(316571,8794,'sv','Planera fem',0),(316572,8794,'it','Piano di cinque',0),(316573,8794,'tl','',0),(316574,8794,'th','&#3649;&#3612;&#3609;&#3627;&#3657;&#3634;',0),(316575,8794,'hi','à¤ªà¤¾à¤‚à¤š à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(316576,8794,'ms','Rancangan lima',0),(316577,8794,'ar','Ø§Ù„Ø®Ø·Ø© Ø§Ù„Ø®Ø§Ù…Ø³Ø©',0),(316578,8794,'fr','Plan de cinq',0),(316579,8794,'jp','5 è¨ˆç”»ã—ã¾ã™ã€‚',0),(316580,8794,'pt','Plano de cinco anos',0),(316581,8794,'ru','ÐŸÐ»Ð°Ð½ 5',0),(316582,8794,'es','Plan Cinco',0),(316583,8794,'de','Planen Sie fÃ¼nf',0),(316584,8794,'en','Plan Five',0),(316585,8795,'is','',0),(316586,8795,'dr','4',0),(316587,8795,'pr','Ø·Ø±Ø­  4',0),(316588,8795,'tr','DÃ¶rt planÄ±',0),(316589,8795,'pl','Cztery planu',0),(316590,8795,'bg','ÐŸÐ»Ð°Ð½ Ð·Ð° Ñ‡ÐµÑ‚Ð¸Ñ€Ð¸',0),(316591,8795,'ur','Ú†Ø§Ø± Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(316592,8795,'sr','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°ÑšÐµ 4',0),(316593,8795,'vi','NhÃ  mÃ¡y 4',0),(316594,8795,'af','Plan Vier',0),(316595,8795,'ro','Planul de patru',0),(316596,8795,'et','Kavas neli',0),(316597,8795,'si','NaÄrt Å¡tiri',0),(316598,8795,'ba','Rencana empat',0),(316599,8795,'nl','Plan vier',0),(316600,8795,'fi','Suunnitelma neljÃ¤',0),(316601,8795,'no','Planlegge fire',0),(316602,8795,'da','PlanlÃ¦gge fire',0),(316603,8795,'ko','4 ê³„íš',0),(316604,8795,'he','×ª×›× ×™×ª ××¨×‘×¢',0),(316605,8795,'el','Î£Ï‡Î­Î´Î¹Î¿ Ï„Î­ÏƒÏƒÎµÏÎ¹Ï‚',0),(316606,8795,'zh','è®¡åˆ’å››\r\n',0),(316607,8795,'sv','Planera fyra',0),(316608,8795,'it','Prevede quattro',0),(316609,8795,'tl','',0),(316610,8795,'th','&#3649;&#3612;&#3609;&#3626;&#3637;&#3656;',0),(316611,8795,'hi','à¤šà¤¾à¤° à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(316612,8795,'ms','Pelan empat',0),(316613,8795,'ar','Ø§Ù„Ø®Ø·Ø© Ø§Ù„Ø±Ø§Ø¨Ø¹Ø©',0),(316614,8795,'fr','Plan Ã  quatre',0),(316615,8795,'jp','4 è¨ˆç”»ã—ã¾ã™ã€‚',0),(316616,8795,'pt','Plano quatro',0),(316617,8795,'ru','ÐŸÐ»Ð°Ð½ 4',0),(316618,8795,'es','Plan Cuatro',0),(316619,8795,'de','Vier planen',0),(316620,8795,'en','Plan Four',0),(316621,8796,'is','',0),(316622,8796,'dr','3',0),(316623,8796,'pr','Ø·Ø±Ø­  3',0),(316624,8796,'tr','ÃœÃ§ plan',0),(316625,8796,'pl','Plan trzy',0),(316626,8796,'bg','ÐŸÐ»Ð°Ð½ Ð·Ð° Ñ‚Ñ€Ð¸',0),(316627,8796,'ur','ØªÛŒÙ† Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(316628,8796,'sr','Ð¢Ñ€Ð¸ Ð¿Ð»Ð°Ð½Ð°',0),(316629,8796,'vi','Káº¿ hoáº¡ch 3',0),(316630,8796,'af','Plan Drie',0),(316631,8796,'ro','Planul de trei',0),(316632,8796,'et','Kavas kolm',0),(316633,8796,'si','NaÄrt treh',0),(316634,8796,'ba','Rencana tiga',0),(316635,8796,'nl','Plan drie',0),(316636,8796,'fi','Plan kolme',0),(316637,8796,'no','Planlegge tre',0),(316638,8796,'da','PlanlÃ¦g tre',0),(316639,8796,'ko','3 ê³„íš',0),(316640,8796,'he','×ª×•×›× ×™×ª ×©×œ×•×©',0),(316641,8796,'el','Î£Ï‡Î­Î´Î¹Î¿ Ï„ÏÎ¹ÏŽÎ½',0),(316642,8796,'zh','è®¡åˆ’ä¸‰\r\n',0),(316643,8796,'sv','Plan tre',0),(316644,8796,'it','Piano di tre',0),(316645,8796,'tl','',0),(316646,8796,'th','&#3649;&#3612;&#3609;&#3626;&#3634;&#3617;',0),(316647,8796,'hi','à¤¤à¥€à¤¨ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(316648,8796,'ms','Pelan tiga',0),(316649,8796,'ar','Ø§Ù„Ø®Ø·Ø© Ø§Ù„Ø«Ø§Ù„Ø«Ø©',0),(316650,8796,'fr','Plan Ã  trois',0),(316651,8796,'jp','3 ã¤ã‚’è¨ˆç”»ã—ã¾ã™ã€‚',0),(316652,8796,'pt','Plano de trÃªs',0),(316653,8796,'ru','ÐŸÐ»Ð°Ð½ 3',0),(316654,8796,'es','Plan Tres',0),(316655,8796,'de','Planen Sie drei',0),(316656,8796,'en','Plan Three',0),(316657,8797,'is','',0),(316658,8797,'dr','2',0),(316659,8797,'pr','Ø¢Ø¯Ø±Ø³   2',0),(316660,8797,'tr','Adres 2',0),(316661,8797,'pl','Adres 2',0),(316662,8797,'bg','ÐÐ´Ñ€ÐµÑ 2',0),(316663,8797,'ur','Ù¾ØªÛ’ 2',0),(316664,8797,'sr','ÐÐ´Ñ€ÐµÑÐ° 2',0),(316665,8797,'vi','Äá»‹a Chá»‰ 2',0),(316666,8797,'af','Adres 2',0),(316667,8797,'ro','Adresa 2',0),(316668,8797,'et','Aadress 2',0),(316669,8797,'si','Naslov 2',0),(316670,8797,'ba','Alamat 2',0),(316671,8797,'nl','Adres 2',0),(316672,8797,'fi','Osoite 2',0),(316673,8797,'no','Adresse 2',0),(316674,8797,'da','Adresse 2',0),(316675,8797,'ko','ì£¼ì†Œ 2',0),(316676,8797,'he','×›×ª×•×‘×ª 2',0),(316677,8797,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· 2',0),(316678,8797,'zh','åœ°å€2\r\n',0),(316679,8797,'sv','Adress 2',0),(316680,8797,'it','Indirizzo 2',0),(316681,8797,'tl','',0),(316682,8797,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656; 2',0),(316683,8797,'hi','à¤ªà¤¤à¤¾ 2',0),(316684,8797,'ms','Alamat 2',0),(316685,8797,'ar','Ø§Ù„Ø¹Ù†ÙˆØ§Ù† 2',0),(316686,8797,'fr','Adresse 2',0),(316687,8797,'jp','ä½æ‰€ 2',0),(316688,8797,'pt','EndereÃ§o 2',0),(316689,8797,'ru','ÐÐ´Ñ€ÐµÑ 2',0),(316690,8797,'es','DirecciÃ³n 2',0),(316691,8797,'de','Adresse 2',0),(316692,8797,'en','Address 2',0),(316693,8798,'is','',0),(316694,8798,'dr','Ø¯ÙƒÙ…Ù‡ Ù„ØºÙˆ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´ÙˆØ¯',0),(316695,8798,'pr','Ø¯ÙƒÙ…Ù‡ Ù„ØºÙˆ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´ÙˆØ¯',0),(316696,8798,'tr','Tekrar deÄŸil kaydetmek iÃ§in Ä°ptal\'i tÄ±klatÄ±n',0),(316697,8798,'pl','Kliknij przycisk Anuluj, aby nie zapisaÄ‡ ponownie',0),(316698,8798,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ \"ÐžÑ‚ÐºÐ°Ð·\", Ð·Ð° Ð´Ð° Ð½Ðµ Ð·Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(316699,8798,'ur','Ù¾Ú¾Ø± Ù…Ø­ÙÙˆØ¸ Ù†Û Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†Ø³ÙˆØ® Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(316700,8798,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ \"ÐžÑ‚ÐºÐ°Ð¶Ð¸\" Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð´Ð° ÑÐ°Ñ‡ÑƒÐ²Ð°Ñ‚Ðµ',0),(316701,8798,'vi','Nháº¥n Há»§y Ä‘á»ƒ khÃ´ng sao lÆ°u láº¡i',0),(316702,8798,'af','Kliek Kanseleer om NIE weer te stoor',0),(316703,8798,'ro','FaceÅ£i clic pe Revocare pentru a nu salva din nou',0),(316704,8798,'et','KlÃµpsake Loobu uuesti salvestada',0),(316705,8798,'si','Kliknite PrekliÄi ne znova shraniti',0),(316706,8798,'ba','Klik Batal untuk tidak menyimpan lagi',0),(316707,8798,'nl','Klik op Annuleren om op te slaan niet opnieuw',0),(316708,8798,'fi','Peruuta ei tallenna uudelleen',0),(316709,8798,'no','Klikk Avbryt for Ã¥ ikke lagre igjen',0),(316710,8798,'da','Klik pÃ¥ Annuller for at ikke gemme igen',0),(316711,8798,'ko','í´ë¦­ ì·¨ì†Œë¥¼ ë‹¤ì‹œ ì €ìž¥ í•˜ì§€',0),(316712,8798,'he','×œ×—×¥ ×¢×œ ×‘×™×˜×•×œ ×›×“×™ ×œ× ×œ×”×¦×™×œ ×©×•×‘',0),(316713,8798,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÎºÎ¿Ï…Î¼Ï€Î¯ \"Î†ÎºÏ…ÏÎ¿\" Î³Î¹Î± Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ ÎºÎ±Î¹ Ï€Î¬Î»Î¹',0),(316714,8798,'zh','ç‚¹å‡»å–æ¶ˆä¸å†æ¬¡ä¿å­˜\r\n',0),(316715,8798,'sv','Klicka pÃ¥ Avbryt om du vill spara inte igen',0),(316716,8798,'it','Fare clic su Annulla per non salvare di nuovo',0),(316717,8798,'tl','',0),(316718,8798,'th','&#3588;&#3621;&#3636;&#3585;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3652;&#3617;&#3656;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(316719,8798,'hi','à¤«à¤¿à¤° à¤¸à¥‡ à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ \' à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚ \' à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(316720,8798,'ms','Klik Batal untuk Simpan lagi',0),(316721,8798,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ \"Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø£Ù…Ø±\" Ø¹Ø¯Ù… Ø­ÙØ¸ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(316722,8798,'fr','Cliquez sur annuler Ã  ne pas enregistrer Ã  nouveau',0),(316723,8798,'jp','ã‚‚ã†ä¸€åº¦ã‚’ä¿å­˜ã—ãªã„ã‚ˆã†ã« [ã‚­ãƒ£ãƒ³ã‚»ãƒ«] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(316724,8798,'pt','Clique em Cancel para nÃ£o salvar novamente',0),(316725,8798,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐÐ• ÑÐ¾Ñ…Ñ€Ð°Ð½ÑÑ‚ÑŒ ÑÐ½Ð¾Ð²Ð°',0),(316726,8798,'es','Click Cancelar para NO guardar otra vez',0),(316727,8798,'de','Klicken Sie auf \"Abbrechen\", um nicht erneut speichern',0),(316728,8798,'en','Click Cancel to NOT save again',0),(316729,8799,'is','',0),(316730,8799,'dr','ÙƒÙ…Ù‡ ØªØ§ÙŠÙŠØ¯ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø«Ø¨Øª Ø¯ÙˆÙ… Ø°Ø®ÙŠØ±Ù‡ Ø´ÙˆØ¯',0),(316731,8799,'pr','ÙƒÙ…Ù‡ ØªØ§ÙŠÙŠØ¯ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø«Ø¨Øª Ø¯ÙˆÙ… Ø°Ø®ÙŠØ±Ù‡ Ø´ÙˆØ¯',0),(316732,8799,'tr','Ä°kinci giriÅŸi kaydetmek iÃ§in Tamam\'Ä± tÄ±klatÄ±n',0),(316733,8799,'pl','Kliknij przycisk OK, aby zapisaÄ‡ drugi wpis',0),(316734,8799,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ OK, Ð·Ð° Ð´Ð° Ð¡ÐŸÐÐ¡Ð˜ Ð²Ñ‚Ð¾Ñ€Ð¸Ñ Ð·Ð°Ð¿Ð¸Ñ',0),(316735,8799,'ur','Ø¯ÙˆØ³Ø±Ø§ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù¹Ú¾ÛŒÚ© ÛÛ’ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(316736,8799,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ñƒ Ñ€ÐµÐ´Ñƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¡ÐÐ§Ð£Ð’ÐÐ›Ð˜ Ð´Ñ€ÑƒÐ³Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(316737,8799,'vi','Nháº¥n OK Ä‘á»ƒ Sao LÆ°u bÃºt toÃ¡n thá»© hai',0),(316738,8799,'af','Kliek OK om volgende inskrywing te STOOR',0),(316739,8799,'ro','FaceÅ£i clic pe OK pentru a salva a doua intrare',0),(316740,8799,'et','Teine kirje salvestamiseks klÃµpsake OK',0),(316741,8799,'si','Kliknite OK, da shranite drugi vnos',0),(316742,8799,'ba','Klik OK untuk menyimpan entri kedua',0),(316743,8799,'nl','Klik op OK om het tweede item opslaan',0),(316744,8799,'fi','Klikkaa OK tallentaaksesi toinen merkintÃ¤',0),(316745,8799,'no','Klikk OK for Ã¥ lagre andre oppfÃ¸ringen',0),(316746,8799,'da','Klik pÃ¥ OK for at gemme anden post',0),(316747,8799,'ko','ë‘ ë²ˆì§¸ í•­ëª©ì„ ì €ìž¥ í•˜ë ¤ë©´ í™•ì¸ì„ í´ë¦­ í•©ë‹ˆë‹¤',0),(316748,8799,'he','×œ×—×¥ ×¢×œ ××™×©×•×¨ ×›×“×™ ×œ×©×ž×•×¨ ××ª ×”×¤×•×¡×˜ ×”×©× ×™',0),(316749,8799,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÎºÎ¿Ï…Î¼Ï€Î¯ OK Î³Î¹Î± Î½Î± Î‘Î ÎŸÎ˜Î—ÎšÎ•ÎŽÎ£Î•Î¤Î• Ï„Î· Î´ÎµÏÏ„ÎµÏÎ· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·',0),(316750,8799,'zh','å•å‡»ç¡®å®šä»¥ä¿å­˜ç¬¬äºŒä¸ªæ¡ç›®\r\n',0),(316751,8799,'sv','Klicka pÃ¥ OK fÃ¶r att spara andra posten',0),(316752,8799,'it','Fare clic su OK per salvare la seconda voce',0),(316753,8799,'tl','',0),(316754,8799,'th','&#3588;&#3621;&#3636;&#3585;&#3605;&#3585;&#3621;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3626;&#3629;&#3591;',0),(316755,8799,'hi','à¤¦à¥‚à¤¸à¤°à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ à¥€à¤• à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(316756,8799,'ms','Klik OK untuk Simpan entri kedua',0),(316757,8799,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ \"Ù…ÙˆØ§ÙÙ‚\" Ù„Ø­ÙØ¸ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(316758,8799,'fr','Cliquez sur OK pour enregistrer la deuxiÃ¨me entrÃ©e',0),(316759,8799,'jp','2 ç•ªç›®ã®ã‚¨ãƒ³ãƒˆãƒªã‚’ä¿å­˜ã™ã‚‹ [ok] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(316760,8799,'pt','Clique em OK para salvar a segunda entrada',0),(316761,8799,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐºÐ½Ð¾Ð¿ÐºÑƒ ÐžÐš, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð²Ñ‚Ð¾Ñ€ÑƒÑŽ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸ÑŽ',0),(316762,8799,'es','Click OK para GUARDAR la Segunda Entrada',0),(316763,8799,'de','Klicken Sie auf OK, um den zweiten Eintrag speichern',0),(316764,8799,'en','Click OK to SAVE second entry',0),(316765,8800,'is','',0),(316766,8800,'dr','Ø³ÙØ§Ø±Ø´ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ØµÙØ­Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(316767,8800,'pr','Ø³ÙØ§Ø±Ø´ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ØµÙØ­Ù‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(316768,8800,'tr','MÃ¼ÅŸteri sayfa Customizer',0),(316769,8800,'pl','Klienta Strona konfiguratora',0),(316770,8800,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð¸Ð·Ð°Ñ‚Ð¾Ñ€',0),(316771,8800,'ur','Ú©Ø³Ù¹Ù…Ø± ØµÙØ­Û Ú©Ø³Ù¹ÙˆÙ…ÛŒØ²Ø±',0),(316772,8800,'sr','ÐšÑƒÐ¿Ð°Ñ† ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼ Ð·Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’Ð°Ð²Ð°ÑšÐµ',0),(316773,8800,'vi','Chá»‰nh sá»­a Trang khÃ¡ch hÃ ng',0),(316774,8800,'af','Klant / KliÃ«nt Bladsyaanpassings',0),(316775,8800,'ro','Setarea paginii client',0),(316776,8800,'et','Kliendilehe kujundamine',0),(316777,8800,'si','Kupec strani Customizer',0),(316778,8800,'ba','Pelanggan halaman Customizer',0),(316779,8800,'nl','Klant pagina Customizer',0),(316780,8800,'fi','Asiakkaan sivun mukauttaja',0),(316781,8800,'no','Kunden siden Customizer',0),(316782,8800,'da','Kunden side Customizer',0),(316783,8800,'ko','ê³ ê° íŽ˜ì´ì§€ ì§€ì •ìž',0),(316784,8800,'he','×”×œ×§×•×— ×“×£ ××—×¨××™ ×¢×œ ×”×ª××ž×” ××™×©×™×ª',0),(316785,8800,'el','Î¤Î¿Î½ Ï…Ï€ÎµÏÎ¸Ï…Î½Î¿ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· ÏƒÎµÎ»Î¯Î´Î±',0),(316786,8800,'zh','å®¢æˆ·é¡µé¢å®šåˆ¶\r\n',0),(316787,8800,'sv','Kund sida Customizer',0),(316788,8800,'it','Personalizzazione pagina cliente',0),(316789,8800,'tl','',0),(316790,8800,'th','&#3612;&#3641;&#3657;&#3611;&#3619;&#3633;&#3610;&#3649;&#3605;&#3656;&#3591;&#3627;&#3609;&#3657;&#3634;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(316791,8800,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¥ƒà¤·à¥à¤  Customizer',0),(316792,8800,'ms','Baca Laman Customizer',0),(316793,8800,'ar','ØªØ®ØµÙŠØµ ØµÙØ­Ø© Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(316794,8800,'fr','Client Page Customizer',0),(316795,8800,'jp','ãŠå®¢æ§˜ãƒšãƒ¼ã‚¸ ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚¶ãƒ¼',0),(316796,8800,'pt','PÃ¡gina de CustomizaÃ§Ã£o de Cliente',0),(316797,8800,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹Ñ‰Ð¸Ðº ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(316798,8800,'es','Cliente Personalizador de PÃ¡gina',0),(316799,8800,'de','Kunden Seite Customizer',0),(316800,8800,'en','Customer Page Customizer',0),(316801,8801,'is','',0),(316802,8801,'dr','Ù†Ù‡Ø§ÙŠÙŠ ÙƒØ±Ø¯Ù† ØªØºÙŠÙŠØ±Ø§Øª Ù†ÙˆØ¹ Ø³ÙØ§Ø±Ø´ ',0),(316803,8801,'pr','Ù†Ù‡Ø§ÙŠÙŠ ÙƒØ±Ø¯Ù† ØªØºÙŠÙŠØ±Ø§Øª Ù†ÙˆØ¹ Ø³ÙØ§Ø±Ø´ ',0),(316804,8801,'tr','SipariÅŸ tÃ¼rÃ¼ deÄŸiÅŸiklikleri son haline getir',0),(316805,8801,'pl','Sfinalizowania zamÃ³wienia typu zmiany',0),(316806,8801,'bg','Ð¤Ð¸Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ‚Ð¸Ð¿ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(316807,8801,'ur','Ø­Ú©Ù… Ù‚Ø³Ù… Ú©ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©Ùˆ Ø¢Ø®Ø±ÛŒ Ø´Ú©Ù„ Ø¯ÛŒÚº',0),(316808,8801,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐµ Ð¼ÐµÑšÐ° Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(316809,8801,'vi','Káº¿t thÃºc thay Ä‘á»•i loáº¡i ÄÆ¡n Ä‘áº·t hÃ ng',0),(316810,8801,'af','POMA orde tipe veranderinge',0),(316811,8801,'ro','Finaliza modificÄƒrile de tip comanda',0),(316812,8801,'et','Vormistab tellimuse tÃ¼Ã¼p muutub',0),(316813,8801,'si','DokonÄanje nalog vrsta spremembe',0),(316814,8801,'ba','Menyelesaikan pesanan jenis perubahan',0),(316815,8801,'nl','Finaliseren Type Bestelwijzigingen',0),(316816,8801,'fi','Viimeistele tilaus muuttuu',0),(316817,8801,'no','FullfÃ¸re bestillingen endres',0),(316818,8801,'da','FÃ¦rdiggÃ¸re ordren Type Ã¦ndringer',0),(316819,8801,'ko','ì£¼ë¬¸ ìœ í˜• ë³€ê²½ ì™„ë£Œ',0),(316820,8801,'he','×’×™×‘×•×© ×¡×•×¤×™ ×©×œ ×¡×“×¨ ×¡×•×’ ×”×©×™× ×•×™×™×',0),(316821,8801,'el','ÎŸÎ»Î¿ÎºÎ»Î·ÏÏŽÏƒÎµÎ¹ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï„ÏÏ€Î¿Ï… Î±Î»Î»Î±Î³Î­Ï‚',0),(316822,8801,'zh','æ•²å®šè®¢å•ç±»åž‹çš„å˜åŒ–\r\n',0),(316823,8801,'sv','SlutfÃ¶ra Order typ fÃ¶rÃ¤ndringar',0),(316824,8801,'it','Finalizzare le modifiche di tipo ordine',0),(316825,8801,'tl','',0),(316826,8801,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3640;&#3604;&#3607;&#3657;&#3634;&#3618;',0),(316827,8801,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª',0),(316828,8801,'ms','Memuktamadkan perintah jenis perubahan',0),(316829,8801,'ar','ÙˆØ¶Ø¹ Ø§Ù„ØµÙŠØºØ© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© Ù„ØªØ±ØªÙŠØ¨ Ù†ÙˆØ¹ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(316830,8801,'fr','Finaliser les modifications du Type de commande',0),(316831,8801,'jp','æ³¨æ–‡ã®ç¨®é¡žã®å¤‰æ›´ã‚’ç¢ºå®šã—ã¾ã™ã€‚',0),(316832,8801,'pt','Finalize ModificaÃ§Ãµes de Tipo de Ordem',0),(316833,8801,'ru','Ð”Ð¾Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ñ‚Ð¸Ð¿Ð°',0),(316834,8801,'es','Finalizar Cambios de Tipos de Ordenes',0),(316835,8801,'de','Finalisieren Typ AuftragsÃ¤nderungen',0),(316836,8801,'en','Finalize Order Type Changes',0),(316837,8802,'is','',0),(316838,8802,'dr',' Ø³ÙØ§Ø±Ø´ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ØµÙØ­Ù‡ ÙƒØ§Ù„Ø§ ',0),(316839,8802,'pr',' Ø³ÙØ§Ø±Ø´ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ØµÙØ­Ù‡ ÙƒØ§Ù„Ø§ ',0),(316840,8802,'tr','Madde Sayfa Customizer',0),(316841,8802,'pl','Element strony konfiguratora',0),(316842,8802,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð¸Ð·Ð°Ñ‚Ð¾Ñ€',0),(316843,8802,'ur','Ø´Û’ ØµÙØ­Û Ú©Ø³Ù¹ÙˆÙ…ÛŒØ²Ø±',0),(316844,8802,'sr','ÐŸÑ€Ð¾Ð³Ñ€Ð°Ð¼ Ð·Ð° ÑÑ‚Ð°Ð²ÐºÐµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’Ð°Ð²Ð°ÑšÐµ',0),(316845,8802,'vi','Trang HÃ ng HÃ³a tá»± táº¡o',0),(316846,8802,'af','Item Bladsy Aanpasser',0),(316847,8802,'ro','Element filme Customizer',0),(316848,8802,'et','Tootelehe kohandamine',0),(316849,8802,'si','Element strani Customizer',0),(316850,8802,'ba','Item halaman Customizer',0),(316851,8802,'nl','Object pagina Customizer',0),(316852,8802,'fi','Kohteen sivulla mukauttaja',0),(316853,8802,'no','Elementet siden Customizer',0),(316854,8802,'da','Vare side Customizer',0),(316855,8802,'ko','í•­ëª© íŽ˜ì´ì§€ ì§€ì •ìž',0),(316856,8802,'he','×¤×¨×™×˜ ×”×ª××ž×” ××™×©×™×ª ×©×œ ×“×£ ×©×‘×•',0),(316857,8802,'el','Î¤Î¿Î½ Ï…Ï€ÎµÏÎ¸Ï…Î½Î¿ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚ Ï„Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… ÏƒÎµÎ»Î¯Î´Î±Ï‚',0),(316858,8802,'zh','é¡¹ç›®ç½‘é¡µå®šåˆ¶\r\n',0),(316859,8802,'sv','Artikel sidan Customizer',0),(316860,8802,'it','Elemento pagina Customizer',0),(316861,8802,'tl','',0),(316862,8802,'th','&#3627;&#3609;&#3657;&#3634;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(316863,8802,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¥ƒà¤·à¥à¤  Customizer',0),(316864,8802,'ms','Perkara Laman Customizer',0),(316865,8802,'ar','ØªØ®ØµÙŠØµ ØµÙØ­Ø© Ø§Ù„ØµÙ†Ù',0),(316866,8802,'fr','Article Page Customizer',0),(316867,8802,'jp','é …ç›®ãƒšãƒ¼ã‚¸ã®ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚¶ãƒ¼',0),(316868,8802,'pt','Item pÃ¡gina Customizer',0),(316869,8802,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹Ñ‰Ð¸Ðº',0),(316870,8802,'es','Personalizador de PÃ¡gina de Item',0),(316871,8802,'de','Element Seite Customizer',0),(316872,8802,'en','Item Page Customizer',0),(316873,8803,'is','',0),(316874,8803,'dr','ÙÙŠÙ„ØªØ± Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ±',0),(316875,8803,'pr','ÙÙŠÙ„ØªØ± Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ±',0),(316876,8803,'tr','Fatura ÅŸartlarÄ± filtresi',0),(316877,8803,'pl','Faktura warunkÃ³w filtru',0),(316878,8803,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ñ„Ð¸Ð»Ñ‚ÑŠÑ€',0),(316879,8803,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª ÙÙ„Ù¹Ø±',0),(316880,8803,'sr','Ð¤Ð¸Ð»Ñ‚ÐµÑ€ ÑƒÑÐ»Ð¾Ð²Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(316881,8803,'vi','Lá»c Äiá»u khoáº£n hÃ³a Ä‘Æ¡n ',0),(316882,8803,'af','Faktuur Terme Filtreer',0),(316883,8803,'ro','Filtru de termeni facturÄƒ',0),(316884,8803,'et','Maksetingimuste filter',0),(316885,8803,'si','RaÄuna izraze filtra',0),(316886,8803,'ba','Faktur istilah Filter',0),(316887,8803,'nl','Factuur voorwaarden Filter',0),(316888,8803,'fi','Laskun ehdot suodatin',0),(316889,8803,'no','Faktura vilkÃ¥rene Filter',0),(316890,8803,'da','Faktura vilkÃ¥r Filter',0),(316891,8803,'ko','ì†¡ìž¥ ê¸°ê°„ í•„í„°',0),(316892,8803,'he','×—×©×‘×•× ×™×ª ×ª× ××™ ×¡×™× ×•×Ÿ',0),(316893,8803,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏŒÏÎ¿Ï…Ï‚ Ï†Î¯Î»Ï„ÏÎ¿',0),(316894,8803,'zh','å‘ç¥¨æ¡æ¬¾è¿‡æ»¤\r\n',0),(316895,8803,'sv','Faktura villkor Filter',0),(316896,8803,'it','Filtro termini di fattura',0),(316897,8803,'tl','',0),(316898,8803,'th','&#3605;&#3633;&#3623;&#3585;&#3619;&#3629;&#3591;&#3648;&#3591;&#3639;&#3656;&#3629;&#3609;&#3652;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(316899,8803,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤°',0),(316900,8803,'ms','Invois terma penapis',0),(316901,8803,'ar','ØªØµÙÙŠØ© Ø¨Ù†ÙˆØ¯ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(316902,8803,'fr','Filtre de termes de facture',0),(316903,8803,'jp','è«‹æ±‚æ›¸æ¡ä»¶ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼',0),(316904,8803,'pt','Filtro de termos de factura',0),(316905,8803,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ñ„Ð¸Ð»ÑŒÑ‚Ñ€Ð°',0),(316906,8803,'es','Filtro de TÃ©rminos de Factura',0),(316907,8803,'de','Rechnung Begriffe Filter',0),(316908,8803,'en','Invoice Terms Filter',0),(316909,8804,'is','',0),(316910,8804,'dr','Ù„ÙŠØ³Øª ÙÙŠÙ„ØªØ±Ù‡Ø§ ',0),(316911,8804,'pr','Ù„ÙŠØ³Øª ÙÙŠÙ„ØªØ±Ù‡Ø§ ',0),(316912,8804,'tr','Liste filtreler',0),(316913,8804,'pl','Lista filtrÃ³w',0),(316914,8804,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ñ„Ð¸Ð»Ñ‚Ñ€Ð¸Ñ‚Ðµ',0),(316915,8804,'ur','ÙÛØ±Ø³Øª ÙÙ„Ù¹Ø±',0),(316916,8804,'sr','Ð›Ð¸ÑÑ‚Ðµ Ñ„Ð¸Ð»Ñ‚ÐµÑ€Ð°',0),(316917,8804,'vi','Danh sÃ¡ch lá»c',0),(316918,8804,'af','Lys Filters',0),(316919,8804,'ro','Lista de filtre',0),(316920,8804,'et','Nimekirja filtrid',0),(316921,8804,'si','Seznam filtrov',0),(316922,8804,'ba','Daftar Filter',0),(316923,8804,'nl','Lijst Filters',0),(316924,8804,'fi','Luettelon suodattimet',0),(316925,8804,'no','Listen filtre',0),(316926,8804,'da','Listefiltre',0),(316927,8804,'ko','ëª©ë¡ í•„í„°',0),(316928,8804,'he','×¨×©×™×ž×ª ×ž×¡× × ×™×',0),(316929,8804,'el','Î›Î¯ÏƒÏ„Î± Ï†Î¯Î»Ï„ÏÎ±',0),(316930,8804,'zh','åˆ—è¡¨è¿‡æ»¤å™¨\r\n',0),(316931,8804,'sv','Listan filter',0),(316932,8804,'it','Elenco filtri',0),(316933,8804,'tl','',0),(316934,8804,'th','&#3605;&#3633;&#3623;&#3585;&#3619;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(316935,8804,'hi','à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤° à¤¸à¥‚à¤šà¥€à¤¬à¤¦à¥à¤§ à¤•à¤°à¥‡',0),(316936,8804,'ms','Senarai penapis',0),(316937,8804,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¹ÙˆØ§Ù…Ù„ ØªØµÙÙŠØ©',0),(316938,8804,'fr','Liste des filtres',0),(316939,8804,'jp','ãƒªã‚¹ãƒˆã®ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼',0),(316940,8804,'pt','Lista de filtros',0),(316941,8804,'ru','Ð¤Ð¸Ð»ÑŒÑ‚Ñ€ Ð¡Ð¿Ð¸ÑÐºÐ°',0),(316942,8804,'es','Listar Filtros',0),(316943,8804,'de','Liste filtern',0),(316944,8804,'en','List Filters',0),(316945,8805,'is','',0),(316946,8805,'dr','ÙÙŠÙ„ØªØ± Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(316947,8805,'pr','ÙÙŠÙ„ØªØ± Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(316948,8805,'tr','Fiyat dÃ¼zeyi filtresi',0),(316949,8805,'pl','Cena poziom filtrowania',0),(316950,8805,'bg','Ð¤Ð¸Ð»Ñ‚ÑŠÑ€ Ð·Ð° Ð½Ð¸Ð²Ð¾ Ð½Ð° Ñ†ÐµÐ½Ð°',0),(316951,8805,'ur','Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ ÙÙ„Ù¹Ø±',0),(316952,8805,'sr','Ð¦ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾Ð° Ñ„Ð¸Ð»Ñ‚ÐµÑ€Ð°',0),(316953,8805,'vi','Lá»c Má»©c giÃ¡',0),(316954,8805,'af','Prysvlakbeskrywing Filter',0),(316955,8805,'ro','Pret nivel filtru',0),(316956,8805,'et','Hinnataseme filter',0),(316957,8805,'si','Cena ravni Filter',0),(316958,8805,'ba','Filter tingkat harga',0),(316959,8805,'nl','Prijs niveau Filter',0),(316960,8805,'fi','Hinta suodatus',0),(316961,8805,'no','Pris nivÃ¥ Filter',0),(316962,8805,'da','Pris niveau Filter',0),(316963,8805,'ko','ê°€ê²© ìˆ˜ì¤€ í•„í„°',0),(316964,8805,'he','×¡×™× ×•×Ÿ ×‘×¨×ž×ª ×ž×—×™×¨',0),(316965,8805,'el','Î¤Î¹Î¼Î® ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï†Î¯Î»Ï„ÏÎ¿',0),(316966,8805,'zh','ä»·æ ¼æ°´å¹³ç­›é€‰\r\n',0),(316967,8805,'sv','Pris nivÃ¥ Filter',0),(316968,8805,'it','Prezzo livello filtro',0),(316969,8805,'tl','',0),(316970,8805,'th','&#3605;&#3633;&#3623;&#3585;&#3619;&#3629;&#3591;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(316971,8805,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤°',0),(316972,8805,'ms','Harga penapis peringkat',0),(316973,8805,'ar','ØªØµÙÙŠØ© Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(316974,8805,'fr','Filtre de niveau de prix',0),(316975,8805,'jp','ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«ã®ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼',0),(316976,8805,'pt','Filtro do nÃ­vel de preÃ§o',0),(316977,8805,'ru','Ð¤Ð¸Ð»ÑŒÑ‚Ñ€ Ð£Ñ€Ð¾Ð²Ð½Ñ Ð¦ÐµÐ½',0),(316978,8805,'es','Filtro de Nivel de Precios ',0),(316979,8805,'de','Preis-Niveau-Filter',0),(316980,8805,'en','Price Level Filter',0),(316981,8806,'is','',0),(316982,8806,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚Ù„Ù… Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§ ',0),(316983,8806,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚Ù„Ù… Ø¨Ø±Ø§ÙŠ Ø«Ø¨Øª Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§ ',0),(316984,8806,'tr','GiriÅŸ kutularÄ± iÃ§in yazÄ± tipi boyutu',0),(316985,8806,'pl','Rozmiar czcionki dla skrzynki wjazdu',0),(316986,8806,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° ÑˆÑ€Ð¸Ñ„Ñ‚Ð° Ð·Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð±Ð¾ÐºÑÑŒÐ¾Ñ€',0),(316987,8806,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø®Ø§Ù†ÙˆÚº Ú©Û’ Ù„ÛŒÛ’ ÙØ§Ù†Ù¹ Ø³Ø§Ø¦Ø²',0),(316988,8806,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ Ñ„Ð¾Ð½Ñ‚Ð° Ñƒ Ð¿Ð¾Ñ™Ð¸Ð¼Ð° Ð·Ð° ÑƒÐ½Ð¾Ñ',0),(316989,8806,'vi','Font Chá»¯ Cho Há»™p Entry',0),(316990,8806,'af','Lettergrootte vir Inskrywingsbokse',0),(316991,8806,'ro','Dimensiunea fontului pentru cutii de intrare',0),(316992,8806,'et','TekstisisestusvÃ¤ljadel Kirjasuurus',0),(316993,8806,'si','Velikost pisave za postavko polj',0),(316994,8806,'ba','Ukuran font untuk kotak masuk',0),(316995,8806,'nl','Tekengrootte voor invoervakken',0),(316996,8806,'fi','Fonttikokoa laatikot',0),(316997,8806,'no','SkriftstÃ¸rrelsen for registreringsboksene',0),(316998,8806,'da','SkriftstÃ¸rrelsen for post kasser',0),(316999,8806,'ko','ìž…ë ¥ ìƒìžì— ëŒ€ í•œ ê¸€ê¼´ í¬ê¸°',0),(317000,8806,'he','×’×•×“×œ ×”×’×•×¤×Ÿ ×¢×‘×•×¨ ×ª×™×‘×•×ª ×›× ×™×¡×”',0),(317001,8806,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Î³ÏÎ±Î¼Î¼Î±Ï„Î¿ÏƒÎµÎ¹ÏÎ¬Ï‚ Î³Î¹Î± Ï€Î»Î±Î¯ÏƒÎ¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(317002,8806,'zh','å­—ä½“å¤§å°è¾“å…¥æ¡†\r\n',0),(317003,8806,'sv','Teckenstorlek fÃ¶r inmatningsfÃ¤lten',0),(317004,8806,'it','Dimensione del carattere per caselle di immissione',0),(317005,8806,'tl','',0),(317006,8806,'th','&#3586;&#3609;&#3634;&#3604;&#3649;&#3610;&#3610;&#3629;&#3633;&#3585;&#3625;&#3619;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3594;&#3656;&#3629;&#3591;',0),(317007,8806,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¬à¤•à¥à¤¸à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¥‰à¤¨à¥à¤Ÿ à¤†à¤•à¤¾à¤°',0),(317008,8806,'ms','Saiz fon untuk masuk kotak',0),(317009,8806,'ar','Ø­Ø¬Ù… Ø§Ù„Ø®Ø· Ù„Ù…Ø±Ø¨Ø¹Ø§Øª Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(317010,8806,'fr','Taille de la police pour les zones de saisie',0),(317011,8806,'jp','å…¥åŠ›ãƒœãƒƒã‚¯ã‚¹ã®ãƒ•ã‚©ãƒ³ãƒˆ ã‚µã‚¤ã‚º',0),(317012,8806,'pt','Tamanho da fonte para caixas de entrada',0),(317013,8806,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ ÑˆÑ€Ð¸Ñ„Ñ‚Ð° Ð´Ð»Ñ Ð²ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ ÐºÐ¾Ñ€Ð¾Ð±ÐºÐ¸',0),(317014,8806,'es','TamaÃ±o de Fuente para Cajas de Entrada',0),(317015,8806,'de','SchriftgrÃ¶ÃŸe fÃ¼r Eingabefelder',0),(317016,8806,'en','Font Size for Entry Boxes',0),(317017,8807,'is','',0),(317018,8807,'dr','FIFO  ÙØ§ÙŠÙÙˆ     ',0),(317019,8807,'pr','FIFO  ÙØ§ÙŠÙÙˆ     ',0),(317020,8807,'tr','FIFO',0),(317021,8807,'pl','FIFO',0),(317022,8807,'bg','FIFO',0),(317023,8807,'ur','FIFO',0),(317024,8807,'sr','Ð¤Ð˜Ð¤Ðž',0),(317025,8807,'vi','VÃ o trÆ°á»›c ra trÆ°á»›c (FIFO)',0),(317026,8807,'af','FIFO',0),(317027,8807,'ro','FIFO',0),(317028,8807,'et','FIFO',0),(317029,8807,'si','FIFO',0),(317030,8807,'ba','FIFO',0),(317031,8807,'nl','FIFO',0),(317032,8807,'fi','FIFO',0),(317033,8807,'no','FIFO',0),(317034,8807,'da','FIFO',0),(317035,8807,'ko','FIFO',0),(317036,8807,'he','× ×›× ×¡ ×¨××©×•×Ÿ ×™×•×¦× ×¨××©×•×Ÿ',0),(317037,8807,'el','FIFO',0),(317038,8807,'zh','å…ˆè¿›å…ˆå‡º\r\n',0),(317039,8807,'sv','FIFO',0),(317040,8807,'it','FIFO',0),(317041,8807,'tl','',0),(317042,8807,'th','FIFO',0),(317043,8807,'hi','à¤«à¥€à¤«à¥‹',0),(317044,8807,'ms','FIFO',0),(317045,8807,'ar','FIFO',0),(317046,8807,'fr','FIFO',0),(317047,8807,'jp','FIFO',0),(317048,8807,'pt','FIFO',0),(317049,8807,'ru','FIFO',0),(317050,8807,'es','FIFO',0),(317051,8807,'de','FIFO',0),(317052,8807,'en','FIFO',0),(317053,8808,'is','',0),(317054,8808,'dr','Ø±ÙˆØ´ Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(317055,8808,'pr','Ø±ÙˆØ´ Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(317056,8808,'tr','Stok maliyet yÃ¶ntemi',0),(317057,8808,'pl','Metoda kosztÃ³w zapasÃ³w',0),(317058,8808,'bg','Ð¡ÐºÐ»Ð°Ð´ Ñ†ÐµÐ½Ð° Ð¼ÐµÑ‚Ð¾Ð´',0),(317059,8808,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù„Ø§Ú¯Øª Ø·Ø±ÛŒÙ‚Û',0),(317060,8808,'sr','ÐœÐµÑ‚Ð¾Ð´ Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(317061,8808,'vi','PhÆ°Æ¡ng Thá»©c TÃ­nh GiÃ¡ HÃ ng Trong Kho',0),(317062,8808,'af','Voorraad Aankoop Metode',0),(317063,8808,'ro','Metoda cost Inventar',0),(317064,8808,'et','Varude soetusmaksumuse meetod',0),(317065,8808,'si','StroÅ¡kovno naÄin inventure',0),(317066,8808,'ba','Metode biaya persediaan',0),(317067,8808,'nl','Inventaris Cost, methode',0),(317068,8808,'fi','Varaston kustannusten menetelmÃ¤',0),(317069,8808,'no','Kostnader innholdslistemetoden',0),(317070,8808,'da','Pris for en biblioteksoversigt',0),(317071,8808,'ko','ìž¬ê³  ë¹„ìš©ëœ ë©”ì„œë“œ',0),(317072,8808,'he','×©×™×˜×ª ×¢×œ×•×ª ×”×ž×œ××™',0),(317073,8808,'el','ÎšÏŒÏƒÏ„Î¿Ï…Ï‚ Î¼ÎµÎ¸ÏŒÎ´Î¿Ï… Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(317074,8808,'zh','åº“å­˜æˆæœ¬æ–¹æ³•\r\n',0),(317075,8808,'sv','Kostnad-metoden',0),(317076,8808,'it','Metodo costo di inventario',0),(317077,8808,'tl','',0),(317078,8808,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(317079,8808,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤²à¤¾à¤—à¤¤ à¤µà¤¿à¤§à¤¿',0),(317080,8808,'ms','Kaedah kos inventori',0),(317081,8808,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø­Ø³Ø§Ø¨ ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(317082,8808,'fr','MÃ©thode coÃ»t de l\'inventaire',0),(317083,8808,'jp','åœ¨åº«ã‚³ã‚¹ãƒˆ ãƒ¡ã‚½ãƒƒãƒ‰',0),(317084,8808,'pt','MÃ©todo do custo de inventÃ¡rio',0),(317085,8808,'ru','ÐœÐµÑ‚Ð¾Ð´ ÑƒÑ‡ÐµÑ‚Ð° Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(317086,8808,'es','MÃ©todo de Costos de Inventario',0),(317087,8808,'de','Kosten Inventurmethode',0),(317088,8808,'en','Inventory Cost Method',0),(317089,8809,'is','',0),(317090,8809,'dr','LIFO Ù„Ø§ÙŠÙÙˆ (Ø§ÙˆÙ„ÙŠÙ† ØµØ§Ø¯Ø±Ù‡ Ø§Ø² Ø§Ø®Ø±ÙŠÙ† ÙˆØ§Ø±Ø¯Ù‡',0),(317091,8809,'pr','LIFO Ù„Ø§ÙŠÙÙˆ (Ø§ÙˆÙ„ÙŠÙ† ØµØ§Ø¯Ø±Ù‡ Ø§Ø² Ø§Ø®Ø±ÙŠÙ† ÙˆØ§Ø±Ø¯Ù‡',0),(317092,8809,'tr','LIFO',0),(317093,8809,'pl','OBRACHUNKOWEJ KOLEJKI LIFO',0),(317094,8809,'bg','LIFO',0),(317095,8809,'ur','Ù„Ø§ÙØ§',0),(317096,8809,'sr','Ð›Ð˜Ð¤Ðž',0),(317097,8809,'vi','VÃ o cuá»‘i ra trÆ°á»›c (LIFO)',0),(317098,8809,'af','\"LIFO\"',0),(317099,8809,'ro','LIFO',0),(317100,8809,'et','FINANTS-LIFO',0),(317101,8809,'si','LIFO',0),(317102,8809,'ba','LIFO',0),(317103,8809,'nl','LIFO',0),(317104,8809,'fi','KIRJANPIDON LIFO',0),(317105,8809,'no','LIFO',0),(317106,8809,'da','LIFO',0),(317107,8809,'ko','LIFO',0),(317108,8809,'he','× ×›× ×¡ ××—×¨×•×Ÿ ×™×•×¦× ×¨××©×•×Ÿ',0),(317109,8809,'el','LIFO',0),(317110,8809,'zh','åŽè¿›å…ˆå‡º\r\n',0),(317111,8809,'sv','LIFO',0),(317112,8809,'it','LIFO',0),(317113,8809,'tl','',0),(317114,8809,'th','LIFO',0),(317115,8809,'hi','LIFO',0),(317116,8809,'ms','LIFO',0),(317117,8809,'ar','LIFO',0),(317118,8809,'fr','LIFO',0),(317119,8809,'jp','LIFO',0),(317120,8809,'pt','LIFO',0),(317121,8809,'ru','Ð›Ð˜Ð¤Ðž',0),(317122,8809,'es','LIFO',0),(317123,8809,'de','LIFO',0),(317124,8809,'en','LIFO',0),(317125,8810,'is','',0),(317126,8810,'dr','(ÙˆØ²Ù†ÙŠ',0),(317127,8810,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù…ÙˆØ²ÙˆÙ†(ÙˆØ²Ù†ÙŠ',0),(317128,8810,'tr','AÄŸÄ±rlÄ±klÄ± ortalama',0),(317129,8810,'pl','Åšrednia waÅ¼ona',0),(317130,8810,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð¾ Ð¿Ñ€ÐµÑ‚ÐµÐ³Ð»ÐµÐ½Ð°Ñ‚Ð°',0),(317131,8810,'ur','Ø¨Ø§Ø±Øª Ø§ÙˆØ³Ø·',0),(317132,8810,'sr','ÐŸÐ¾Ð½Ð´ÐµÑ€Ð¸ÑÐ°Ð½Ð¸ Ð¿Ñ€Ð¾ÑÐµÐº',0),(317133,8810,'vi','Trá»ng lÆ°á»£ng trung bÃ¬nh',0),(317134,8810,'af','Geweegde Gemiddeld',0),(317135,8810,'ro','Media ponderatÄƒ',0),(317136,8810,'et','Kaalutud keskmine',0),(317137,8810,'si','Tehtano povpreÄje',0),(317138,8810,'ba','Rata-rata tertimbang',0),(317139,8810,'nl','Gewogen gemiddelde',0),(317140,8810,'fi','Painotettu keskiarvo',0),(317141,8810,'no','Avveid gjennomsnitt',0),(317142,8810,'da','VÃ¦gtet gennemsnit',0),(317143,8810,'ko','ê°€ ì¤‘ëœ í‰ê· ',0),(317144,8810,'he','×ž×ž×•×¦×¢ ×ž×©×•×§×œ×œ',0),(317145,8810,'el','Î£Ï„Î±Î¸Î¼Î¹ÏƒÎ¼Î­Î½Î¿Ï‚ Î¼Î­ÏƒÎ¿Ï‚ ÏŒÏÎ¿Ï‚',0),(317146,8810,'zh','åŠ æƒå¹³å‡\r\n',0),(317147,8810,'sv','VÃ¤gt genomsnitt',0),(317148,8810,'it','Media ponderata',0),(317149,8810,'tl','',0),(317150,8810,'th','&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;',0),(317151,8810,'hi','à¤­à¤¾à¤°à¤¿à¤¤ à¤”à¤¸à¤¤',0),(317152,8810,'ms','Purata berwajaran',0),(317153,8810,'ar','Ù…ØªÙˆØ³Ø· Ù…Ø±Ø¬Ø­',0),(317154,8810,'fr','Moyenne pondÃ©rÃ©e',0),(317155,8810,'jp','åŠ é‡å¹³å‡',0),(317156,8810,'pt','MÃ©dia ponderada',0),(317157,8810,'ru','Ð’Ð·Ð²ÐµÑˆÐµÐ½Ð½Ð¾Ðµ ÑÑ€ÐµÐ´Ð½ÐµÐµ',0),(317158,8810,'es','Promedio Ponderado',0),(317159,8810,'de','Gewichteter Durchschnitt',0),(317160,8810,'en','Weighted Average',0),(317161,8811,'is','',0),(317162,8811,'dr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†  Ùˆ  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ø¹Ø¯Ù… Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(317163,8811,'pr','Ø®Ø§Ø±Ø¬ ÙƒØ±Ø¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†  Ùˆ  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÙŠ Ø´Ø¯Ù‡ Ø¬Ù‡Øª Ø¹Ø¯Ù… Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(317164,8811,'tr','SatÄ±cÄ±lar ve faturalarÄ± Ã¶demek iÃ§in deÄŸil iÅŸaretli dÄ±ÅŸlamak',0),(317165,8811,'pl','WykluczyÄ‡ dostawcÃ³w & oznaczony nie zapÅ‚aciÄ‡ rachunki',0),(317166,8811,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ & ÑÐ¼ÐµÑ‚ÐºÐ¸, Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ð¸ Ð´Ð° Ð½Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚',0),(317167,8811,'ur','ÙˆÛŒÙ†ÚˆØ±Ø² & Ø¨Ù„ Ù†ÛÛŒÚº ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ù„ÛŒÛ’ Ù†Ø´Ø§Ù† Ø²Ø¯ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(317168,8811,'sr','Ð˜Ð·ÑƒÐ·Ð¼Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½Ðµ Ð´Ð° Ð½Ðµ Ð¿Ð»Ð°Ñ‚Ðµ',0),(317169,8811,'vi','KhÃ´ng bao gá»“m ngÆ°á»i bÃ¡n & nhá»¯ng hÃ³a Ä‘Æ¡n Ä‘Ã£ Ä‘Ã¡nh dáº¥u khÃ´ng thanh toÃ¡n',0),(317170,8811,'af','Uitsluiting van Verskaffers & Rekeninge Gemerk Om Nie te Betaal',0),(317171,8811,'ro','Exclude furnizori & facturile marcate nu sÄƒ plÄƒteascÄƒ',0),(317172,8811,'et','VÃ¤lista hankijad & varustatud ei maksa arveid',0),(317173,8811,'si','IzkljuÄi prodajalci & oznaÄiti ne za plaÄilo menice',0),(317174,8811,'ba','Mengecualikan vendor & ditandai untuk tidak membayar tagihan',0),(317175,8811,'nl','Uitsluiten van leveranciers & gemarkeerd niet te betalen rekeningen',0),(317176,8811,'fi','Sulje toimittajat & merkitty ei maksamaan laskut',0),(317177,8811,'no','Utelate leverandÃ¸rer & regninger merket ikke Ã¥ betale',0),(317178,8811,'da','Udelukke leverandÃ¸rer & regninger markeret ikke at betale',0),(317179,8811,'ko','ê³µê¸‰ ì—…ì²´ ë° ì²­êµ¬ì„œ ì§€ë¶ˆ í•˜ì§€ í‘œì‹œ ì œì™¸',0),(317180,8811,'he','××œ ×ª×›×œ×•×œ ×¡×¤×§×™× & ×ž×¡×•×ž×Ÿ ×œ× ×œ×©×œ× ××ª ×”×—×©×‘×•× ×•×ª',0),(317181,8811,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¯Î¿Ï…Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ & Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î± Ï€Î¿Ï… ÏƒÎ·Î¼ÎµÎ¹ÏŽÎ½Î¿Î½Ï„Î±Î¹ Î³Î¹Î± Î½Î± Î¼Î·Î½ Ï€Î»Î·ÏÏŽÏƒÎµÎ¹',0),(317182,8811,'zh','æŽ’é™¤å–æˆ¿åŠæ ‡ç¤ºä¸æ”¯ä»˜å¸å•\r\n',0),(317183,8811,'sv','Utesluta leverantÃ¶rer & rÃ¤kningar mÃ¤rkt inte att betala',0),(317184,8811,'it','Escludere i fornitori & contrassegnate di non pagare le bollette',0),(317185,8811,'tl','',0),(317186,8811,'th','&#3652;&#3617;&#3656;&#3619;&#3623;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618; & &#3610;&#3636;&#3621;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;',0),(317187,8811,'hi','à¤›à¥‹à¤¡à¤¼à¤¨à¥‡ à¤µà¤¾à¤²à¥€ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ & à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¹à¥€à¤‚ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤',0),(317188,8811,'ms','Mengecualikan vendor & bil-bil yang ditandakan tidak untuk membayar',0),(317189,8811,'ar','Ø§Ø³ØªØ¨Ø¹Ø§Ø¯ Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ† & Ø¹Ù„Ø§Ù…Ø© Ù„Ø§ Ù„Ø¯ÙØ¹ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(317190,8811,'fr','Exclure les vendeurs & ne marquÃ©s pas de paiement de factures',0),(317191,8811,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ãƒ»æ‰‹å½¢æ”¯æ‰•ã†ã¹ããƒžãƒ¼ã‚¯ã‚’é™¤å¤–ã—ã¾ã™ã€‚',0),(317192,8811,'pt','Excluir fornecedores & marcadas para nÃ£o pagamento de contas',0),(317193,8811,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² & Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ñ‹, Ð¾Ñ‚Ð¼ÐµÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð½Ðµ Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(317194,8811,'es','Excluir Proveedores y Facturas Marcadas para No pagar',0),(317195,8811,'de','AusschlieÃŸen von Anbieter & Rechnungen nicht zu zahlen markiert',0),(317196,8811,'en','Exclude Vendors & Bills Marked Not To Pay',0),(317197,8812,'is','',0),(317198,8812,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ø³ÙØ§Ø±Ø´Ø§Øª Ø²ÙŠØ±Ø§',0),(317199,8812,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ø³ÙØ§Ø±Ø´Ø§Øª Ø²ÙŠØ±Ø§',0),(317200,8812,'tr','MÃ¼ÅŸteriler sipariÅŸ beri',0),(317201,8812,'pl','ZamÃ³wienia od klientÃ³w',0),(317202,8812,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¾Ñ‚',0),(317203,8812,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ø¨Ø¹Ø¯ Ø³Û’ Ú©Û’ Ø³Ø§ØªÚ¾',0),(317204,8812,'sr','ÐšÑƒÐ¿Ñ†Ð¸ ÑÐ° Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð¾Ð´',0),(317205,8812,'vi','KhÃ¡ch hÃ ng vá»›i Ä‘Æ¡n Ä‘áº·t hÃ ng tá»«',0),(317206,8812,'af','Klante/KliÃ«nte met Bestellings Sedert',0),(317207,8812,'ro','ClienÅ£ii cu comenzi de',0),(317208,8812,'et','Kliendid, kellel on tellimusi alates',0),(317209,8812,'si','Stranke z naroÄil od',0),(317210,8812,'ba','Pelanggan dengan Pesanan Sejak',0),(317211,8812,'nl','Klanten met bestellingen sinds',0),(317212,8812,'fi','Asiakkaiden tilaukset',0),(317213,8812,'no','Kunder med ordrer siden',0),(317214,8812,'da','Kunder med ordrer siden',0),(317215,8812,'ko','ì´í›„ ì£¼ë¬¸ ê³ ê°',0),(317216,8812,'he','×œ×§×•×—×•×ª ×‘×¢×œ×™ ×”×–×ž× ×•×ª ×ž××–',0),(317217,8812,'el','Î¤Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î¼Îµ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Ï€ÏŒ Ï„Î¿',0),(317218,8812,'zh','ä¸Žè®¢å•çš„å®¢æˆ·è‡ª\r\n',0),(317219,8812,'sv','Kunder med bestÃ¤llningar sedan',0),(317220,8812,'it','Clienti con ordini dal',0),(317221,8812,'tl','',0),(317222,8812,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3604;&#3657;&#3623;&#3618;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3633;&#3657;&#3591;&#3649;&#3605;&#3656;',0),(317223,8812,'hi','à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(317224,8812,'ms','Pelanggan dengan perintah sejak',0),(317225,8812,'ar','Ø²Ø¨Ø§Ø¦Ù† Ø¨Ø¯ÙˆÙ† Ø·Ù„Ø¨ÙŠØ§Øª Ù…Ù†Ø° ',0),(317226,8812,'fr','Clients avec commandes depuis',0),(317227,8812,'jp','é¡§å®¢ã‹ã‚‰ã®æ³¨æ–‡ã‚’',0),(317228,8812,'pt','Clientes com pedidos desde',0),(317229,8812,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹ Ð¡ Ð—Ð°ÐºÐ°Ð·Ð°Ð¼Ð¸ ÐÐ°Ñ‡Ð¸Ð½Ð°Ñ Ð¡',0),(317230,8812,'es','Clientes Con Pedidos Desde Que',0),(317231,8812,'de','Kunden Bestellungen seit',0),(317232,8812,'en','Customers With Orders Since',0),(317233,8813,'is','',0),(317234,8813,'dr','ÙÙ‚Ø· Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†ÙŠ Ø±Ø§ ÙƒÙ‡ Ø§Ø±ØªÙ‚Ø§Ø¡ Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒØ±Ø¯Ù‡ Ø§Ù†Ø¯ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´ÙˆÙ†Ø¯ ',0),(317235,8813,'pr','ÙÙ‚Ø· Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†ÙŠ Ø±Ø§ ÙƒÙ‡ Ø§Ø±ØªÙ‚Ø§Ø¡ Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒØ±Ø¯Ù‡ Ø§Ù†Ø¯ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´ÙˆÙ†Ø¯ ',0),(317236,8813,'tr','Sadece promosyonlar onaylama mÃ¼ÅŸteriler gÃ¶ster',0),(317237,8813,'pl','PokaÅ¼ tylko klienci, ktÃ³rzy zatwierdzajÄ… promocje',0),(317238,8813,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð¹ ÑÐ°Ð¼Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸, ÐºÐ¾Ð¸Ñ‚Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÑÐ²Ð°Ñ‚ Ð¿Ñ€Ð¾Ð¼Ð¾Ñ†Ð¸Ð¸',0),(317239,8813,'ur','ÙˆÛ ØµØ§Ø±ÙÛŒÙ† Ø¬Ù† Ú©ÛŒ Ù¾Ø±ÙˆÙ…ÙˆØ´Ù†Ø² Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(317240,8813,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÐºÑƒÐ¿Ñ†Ð¸ ÐºÐ¾Ñ˜Ð¸ Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°Ñ˜Ñƒ Ð¿Ñ€Ð¾Ð¼Ð¾Ñ†Ð¸Ñ˜Ðµ',0),(317241,8813,'vi','Chá»‰ hiá»ƒn thá»‹ khÃ¡ch hÃ ng lÃ m khuyáº¿n máº¡i',0),(317242,8813,'af','Wys Alleenlik Klante/KliÃ«nte Wie Promosies Goedkeur',0),(317243,8813,'ro','AratÄƒ numai clienÅ£ii care aproba promotii',0),(317244,8813,'et','Kuva ainult kÃ¼lastajad, kes kinnitab tutvustusi',0),(317245,8813,'si','PokaÅ¾i samo stranke, ki odobri promocije',0),(317246,8813,'ba','Hanya menunjukkan pelanggan yang menyetujui promosi',0),(317247,8813,'nl','Toon alleen klanten die promoties goedkeuren',0),(317248,8813,'fi','NÃ¤ytÃ¤ vain Asiakkaat, jotka hyvÃ¤ksyvÃ¤t tarjouksia',0),(317249,8813,'no','Bare vise kunder som godkjenner kampanjer',0),(317250,8813,'da','Vis kun kunder, der godkender kampagner',0),(317251,8813,'ko','ê³ ê° í”„ë¡œ ëª¨ì…˜ ìŠ¹ì¸ í‘œì‹œ',0),(317252,8813,'he','×”×¦×’ ×¨×§ ×œ×§×•×—×•×ª ××©×¨ ×ž×‘×¦×¢×™×',0),(317253,8813,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¿Ï… ÎµÎ³ÎºÏÎ¯Î½Î¿Ï…Î½ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ­Ï‚',0),(317254,8813,'zh','åªæ˜¾ç¤ºæ‰¹å‡†å®£ä¼ çš„å®¢æˆ·\r\n',0),(317255,8813,'sv','Visa endast kunder som godkÃ¤nner kampanjer',0),(317256,8813,'it','Visualizza solo i clienti che approvano promozioni',0),(317257,8813,'tl','',0),(317258,8813,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3650;&#3611;&#3619;&#3650;&#3617;&#3607;&#3594;&#3633;&#3656;&#3609;',0),(317259,8813,'hi','à¤¸à¤¿à¤°à¥à¤« à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤œà¥‹ à¤ªà¥à¤°à¤šà¤¾à¤° à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€',0),(317260,8813,'ms','Hanya menunjukkan pelanggan yang meluluskan promosi',0),(317261,8813,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø²Ø¨Ø§Ø¦Ù† Ø§Ù„Ù…ÙˆØ§ÙÙ‚ÙŠÙ† Ø¹Ù„Ù‰ Ø¥Ø³ØªÙ„Ø§Ù… Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø¯Ø¹Ø§ÙŠØ© ÙÙ‚Ø·',0),(317262,8813,'fr','Afficher uniquement les utilisateurs achetant approuvent des Promotions',0),(317263,8813,'jp','ãƒ—ãƒ­ãƒ¢ãƒ¼ã‚·ãƒ§ãƒ³æ‰¿èªãŠå®¢æ§˜ã®ã¿è¡¨ç¤ºã—ã¾ã™ã€‚',0),(317264,8813,'pt','Mostrar apenas os clientes que aprovam as promoÃ§Ãµes',0),(317265,8813,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐŸÐ¾ÑÐµÑ‚Ð¸Ñ‚ÐµÐ»Ð¸, ÑƒÑ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Ð°ÐºÑ†Ð¸Ð¸',0),(317266,8813,'es','Solo Muestra Clientes Que Aprueban Promociones',0),(317267,8813,'de','Zeigen Sie nur Kunden, die Angebote zu genehmigen',0),(317268,8813,'en','Only Show Customers Who Approve Promotions',0),(317269,8814,'is','',0),(317270,8814,'dr','ÙÙ‚Ø· Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ø³ÙØ§Ø±Ø´Ø§Øª Ø±Ø§ Ù†Ø´Ø§Ù† Ø¨Ø¯Ù‡ÙŠØ¯  ÙˆÙ‚ØªÙŠ ',0),(317271,8814,'pr','ÙÙ‚Ø· Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø§ Ø³ÙØ§Ø±Ø´Ø§Øª Ø±Ø§ Ù†Ø´Ø§Ù† Ø¨Ø¯Ù‡ÙŠØ¯  ÙˆÙ‚ØªÙŠ ',0),(317272,8814,'tr','MÃ¼ÅŸteriler sipariÅŸ beri yalnÄ±zca gÃ¶ster',0),(317273,8814,'pl','PokaÅ¼ tylko klienci z zamÃ³wieÅ„ od',0),(317274,8814,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð¹ ÑÐ°Ð¼Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¾Ñ‚',0),(317275,8814,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ø¨Ø¹Ø¯ Ø³Û’ ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(317276,8814,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÐºÑƒÐ¿Ñ†Ðµ ÑÐ° Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð¾Ð´',0),(317277,8814,'vi','Chá»‰ hiá»ƒn thá»‹ khÃ¡ch hÃ ng vá»›i Ä‘Æ¡n hÃ ng tá»«',0),(317278,8814,'af','Wys Net KliÃ«nte / Klante met Bestellings sedert',0),(317279,8814,'ro','Numai clienÅ£ii AratÄƒ comenzile din',0),(317280,8814,'et','NÃ¤ita ainult kliente, kellel on tellimusi alates',0),(317281,8814,'si','PokaÅ¾i le uporabniki z naroÄil od',0),(317282,8814,'ba','Hanya menunjukkan pelanggan pesanan sejak',0),(317283,8814,'nl','Toon alleen klanten met bestellingen sinds',0),(317284,8814,'fi','NÃ¤ytÃ¤ vain asiakkaat ja tilaukset',0),(317285,8814,'no','Vis bare kunder med ordrer siden',0),(317286,8814,'da','Kun vise kunder med ordrer siden',0),(317287,8814,'ko','ì´í›„ ì£¼ë¬¸ ê³ ê° í‘œì‹œ',0),(317288,8814,'he','×¨×§ ×œ×”×¨××•×ª ×œ×œ×§×•×—×•×ª ×¢× ×”×–×ž× ×•×ª ×ž××–',0),(317289,8814,'el','ÎœÏŒÎ½Î¿ ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î¼Îµ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Ï€ÏŒ Ï„Î¿',0),(317290,8814,'zh','åªæ˜¾ç¤ºæœ‰è®¢å•çš„å®¢æˆ·è‡ª\r\n',0),(317291,8814,'sv','Visa endast kunder med bestÃ¤llningar sedan',0),(317292,8814,'it','Visualizza solo i clienti con ordini dal',0),(317293,8814,'tl','',0),(317294,8814,'th','&#3649;&#3626;&#3604;&#3591;&#3648;&#3593;&#3614;&#3634;&#3632;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3585;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3633;&#3657;&#3591;&#3649;&#3605;&#3656;',0),(317295,8814,'hi','à¤•à¥‡à¤µà¤² à¤¦à¤¿à¤–à¤¾à¤¤à¤¾ à¤¹à¥ˆ à¤œà¥‹ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(317296,8814,'ms','Hanya menunjukkan pelanggan dengan perintah sejak',0),(317297,8814,'ar','ÙÙ‚Ø· Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…Ø¹ Ø£ÙˆØ§Ù…Ø± Ù…Ù†Ø°',0),(317298,8814,'fr','Afficher uniquement les clients dont les commandes depuis',0),(317299,8814,'jp','é¡§å®¢ã‹ã‚‰ã®æ³¨æ–‡ã®ã¿è¡¨ç¤ºã—ã¾ã™ã€‚',0),(317300,8814,'pt','Mostrar apenas os clientes com pedidos desde',0),(317301,8814,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¡ Ð—Ð°ÐºÐ°Ð·Ð°Ð¼Ð¸ ÐÐ°Ñ‡Ð¸Ð½Ð°Ñ Ð¡',0),(317302,8814,'es','Solo Muestra Clientes Con Ordenes Desde',0),(317303,8814,'de','Zeigen Sie nur Kunden mit Bestellungen seit',0),(317304,8814,'en','Only Show Customers With Orders Since',0),(317305,8815,'is','',0),(317306,8815,'dr','ÙÙŠÙ„ØªØ± ØªØ§Ø±ÙŠØ® Ø³ÙØ§Ø±Ø´ ',0),(317307,8815,'pr','ÙÙŠÙ„ØªØ± ØªØ§Ø±ÙŠØ® Ø³ÙØ§Ø±Ø´ ',0),(317308,8815,'tr','SipariÅŸ Tarihi Filtresi',0),(317309,8815,'pl','Filtr daty zamÃ³wienia',0),(317310,8815,'bg','Ð¤Ð¸Ð»Ñ‚ÑŠÑ€ Ð¿Ð¾ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(317311,8815,'ur','ØªØ±ØªÛŒØ¨ ØªØ§Ø±ÛŒØ® ÙÙ„Ù¹Ø±',0),(317312,8815,'sr','Ð¤Ð¸Ð»Ñ‚ÐµÑ€ Ð·Ð° Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(317313,8815,'vi','Lá»c ngÃ y Ä‘áº·t hÃ ng',0),(317314,8815,'af','Filter Besteldatum',0),(317315,8815,'ro','Pentru data de filtru',0),(317316,8815,'et','Tellimuse kuupÃ¤eva filter',0),(317317,8815,'si','Filter datuma naloga',0),(317318,8815,'ba','Urutan tanggal Filter',0),(317319,8815,'nl','De Filter van de datum van de bestelling',0),(317320,8815,'fi','Tilaus Pvm-suodatus',0),(317321,8815,'no','Datofilter for ordre',0),(317322,8815,'da','Ordre Datofilter',0),(317323,8815,'ko','ì£¼ë¬¸ ë‚ ì§œ í•„í„°',0),(317324,8815,'he','×ž×¡× ×Ÿ ×ª××¨×™×›×™× ×¡×“×¨',0),(317325,8815,'el','Î¦Î¯Î»Ï„ÏÎ± \"Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚\"',0),(317326,8815,'zh','è®¢è´­æ—¥æœŸç­›é€‰\r\n',0),(317327,8815,'sv','Ordning Datumfilter',0),(317328,8815,'it','Filtro Data ordine',0),(317329,8815,'tl','',0),(317330,8815,'th','&#3605;&#3633;&#3623;&#3585;&#3619;&#3629;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(317331,8815,'hi','à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤°',0),(317332,8815,'ms','Penapis tarikh perintah',0),(317333,8815,'ar','ØªØ±ØªÙŠØ¨ ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØµÙÙŠØ©',0),(317334,8815,'fr','Filtre de Date de commande',0),(317335,8815,'jp','é †åºã®æ—¥ä»˜ã®ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼',0),(317336,8815,'pt','Filtro de data de ordem',0),(317337,8815,'ru','Ð¤Ð¸Ð»ÑŒÑ‚Ñ€ Ð—Ð°ÐºÐ°Ð·Ð° ÐŸÐ¾ Ð”Ð°Ñ‚Ðµ',0),(317338,8815,'es','Filtro de Fecha de Pedido',0),(317339,8815,'de','Bestellung-Datumsfilter',0),(317340,8815,'en','Order Date Filter',0),(317341,8816,'is','',0),(317342,8816,'dr','Ù‚Ø¨ÙˆÙ„ Ø§Ø±ØªÙ‚Ø§Ø¡  ÙÙŠÙ„ØªØ±',0),(317343,8816,'pr','Ù‚Ø¨ÙˆÙ„ Ø§Ø±ØªÙ‚Ø§Ø¡  ÙÙŠÙ„ØªØ±',0),(317344,8816,'tr','Promosyonlar Tamam filtresi',0),(317345,8816,'pl','Promocje OK filtr',0),(317346,8816,'bg','ÐŸÑ€Ð¾Ð¼Ð¾Ñ†Ð¸Ð¸ OK Ñ„Ð¸Ð»Ñ‚ÑŠÑ€',0),(317347,8816,'ur','ÙÙ„Ù¹Ø± Ù¾Ø±ÙˆÙ…ÙˆØ´Ù†Ø² Ù¹Ú¾ÛŒÚ© ÛÛ’ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(317348,8816,'sr','ÐŸÑ€Ð¾Ð¼Ð¾Ñ†Ð¸Ñ˜Ðµ Ñƒ Ñ€ÐµÐ´Ñƒ Ð¤Ð¸Ð»Ñ‚ÐµÑ€',0),(317349,8816,'vi','Lá»c Khuyáº¿n máº¡i OK ',0),(317350,8816,'af','Bevorderings OK Filter',0),(317351,8816,'ro','Promotii OK filtru',0),(317352,8816,'et','Tutvustusi OK Filter',0),(317353,8816,'si','Promocije OK Filter',0),(317354,8816,'ba','Promosi OK Filter',0),(317355,8816,'nl','Promoties OK Filter',0),(317356,8816,'fi','Tarjouksia OK suodatin',0),(317357,8816,'no','Kampanjer OK Filter',0),(317358,8816,'da','Kampagner OK Filter',0),(317359,8816,'ko','í”„ë¡œ ëª¨ì…˜ í™•ì¸ í•„í„°',0),(317360,8816,'he','×ž×‘×¦×¢×™× ××™×©×•×¨ ×ž×¡× ×Ÿ',0),(317361,8816,'el','Î ÏÎ¿Ï‰Î¸Î®ÏƒÎµÎ¹Ï‚ OK Ï†Î¯Î»Ï„ÏÎ¿',0),(317362,8816,'zh','åŒæ„ä¿ƒé”€è¿‡æ»¤\r\n',0),(317363,8816,'sv','Kampanjer OK Filter',0),(317364,8816,'it','Promozioni OK filtro',0),(317365,8816,'tl','',0),(317366,8816,'th','&#3585;&#3619;&#3629;&#3591;&#3650;&#3611;&#3619;&#3650;&#3617;&#3594;&#3633;&#3656;&#3609; OK',0),(317367,8816,'hi','à¤ªà¥à¤°à¥‹à¤¨à¥à¤¨à¤¤à¤¿ à¤ à¥€à¤• à¤«à¤¿à¤²à¥à¤Ÿà¤°',0),(317368,8816,'ms','Promosi OK penapis',0),(317369,8816,'ar','Ù…Ø±Ø´Ù‘Ø­ Ø§Ù„Ø­Ù…Ù„Ø§Øª Ø§Ù„Ø¯Ø¹Ø§Ø¦ÙŠØ©',0),(317370,8816,'fr','Promotions OK filtre',0),(317371,8816,'jp','[Ok] ã®ãƒ—ãƒ­ãƒ¢ãƒ¼ã‚·ãƒ§ãƒ³ ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼',0),(317372,8816,'pt','Filtro de promoÃ§Ãµes OK',0),(317373,8816,'ru','ÐÐºÑ†Ð¸Ð¸ ÐžÐš Ñ„Ð¸Ð»ÑŒÑ‚Ñ€',0),(317374,8816,'es','Filtro de Promociones OK',0),(317375,8816,'de','Angebote OK Filter',0),(317376,8816,'en','Promotions OK Filter',0),(317377,8817,'is','',0),(317378,8817,'dr','(ÙˆØ²Ù†ÙŠ',0),(317379,8817,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù…ÙˆØ²ÙˆÙ†(ÙˆØ²Ù†ÙŠ',0),(317380,8817,'tr','AÄŸÄ±rlÄ±klÄ± ort',0),(317381,8817,'pl','Åšrednia waÅ¼ona',0),(317382,8817,'bg','ÐŸÑ€ÐµÑ‚ÐµÐ³Ð»ÐµÐ½Ð° Avg',0),(317383,8817,'ur','Ø¨Ø§Ø±Øª Ø§ÙˆØ³Ø·',0),(317384,8817,'sr','Ð£Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð¸ ÐÐ²Ð³',0),(317385,8817,'vi','Trá»ng lÆ°á»£ng trung bÃ¬nh',0),(317386,8817,'af','Geweegde Avg',0),(317387,8817,'ro','Avg ponderatÄƒ',0),(317388,8817,'et','Kaalutud keskmine',0),(317389,8817,'si','Tehtano Avg',0),(317390,8817,'ba','Avg tertimbang',0),(317391,8817,'nl','Gewogen Avg',0),(317392,8817,'fi','Painotettu Avg',0),(317393,8817,'no','Vektet Avg',0),(317394,8817,'da','Vejede Avg',0),(317395,8817,'ko','ê°€ ì¤‘ëœ í‰ê· ',0),(317396,8817,'he','×ž×ž×•×¦×¢ ×ž×©×•×§×œ×œ',0),(317397,8817,'el','Î£Ï„Î±Î¸Î¼Î¹ÏƒÎ¼Î­Î½Î¿ Avg',0),(317398,8817,'zh','åŠ æƒå¹³å‡\r\n',0),(317399,8817,'sv','VÃ¤gda Avg',0),(317400,8817,'it','Avg ponderata',0),(317401,8817,'tl','',0),(317402,8817,'th','&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;',0),(317403,8817,'hi','à¤­à¤¾à¤°à¤¿à¤¤ à¤”à¤¸à¤¤',0),(317404,8817,'ms','Avg wajaran',0),(317405,8817,'ar','Ù…ØªÙˆØ³Ø· Ù…Ø±Ø¬Ø­',0),(317406,8817,'fr','Moyenne pondÃ©rÃ©e',0),(317407,8817,'jp','åŠ é‡å¹³å‡',0),(317408,8817,'pt','Avg ponderada',0),(317409,8817,'ru','Ð’Ð·Ð²ÐµÑˆÐµÐ½Ð½Ð°Ñ Avg',0),(317410,8817,'es','Promedio Ponderado',0),(317411,8817,'de','Gewichtete Avg',0),(317412,8817,'en','Weighted Avg',0),(317413,8818,'is','',0),(317414,8818,'dr','(ÙˆØ²Ù†ÙŠ',0),(317415,8818,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù…ÙˆØ²ÙˆÙ†(ÙˆØ²Ù†ÙŠ',0),(317416,8818,'tr','AÄŸÄ±rlÄ±klÄ± ortalama maliyet',0),(317417,8818,'pl','Åšredni waÅ¼ony koszt',0),(317418,8818,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð¾Ð¿Ñ€ÐµÑ‚ÐµÐ³Ð»ÐµÐ½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð°',0),(317419,8818,'ur','Ø¨Ø§Ø±Øª Ø§ÙˆØ³Ø· Ù„Ø§Ú¯Øª',0),(317420,8818,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¾Ð³ Ð¿Ñ€Ð¾ÑÐµÑ‡Ð½Ð¾Ð³ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(317421,8818,'vi','GiÃ¡ thÃ nh trá»ng lÆ°á»£ng trung bÃ¬nh',0),(317422,8818,'af','Geweegde Gemiddelde Koste ',0),(317423,8818,'ro','Costul mediu ponderat',0),(317424,8818,'et','Kaalutud keskmise maksumus',0),(317425,8818,'si','Tehtani povpreÄni stroÅ¡ek',0),(317426,8818,'ba','Biaya rata-rata tertimbang',0),(317427,8818,'nl','Gewogen gemiddelde kosten',0),(317428,8818,'fi','Painotettu keskiarvo',0),(317429,8818,'no','Vektet gjennomsnittlig kostnad',0),(317430,8818,'da','Vejet gennemsnitspris',0),(317431,8818,'ko','ê°€ ì¤‘ëœ í‰ê·  ë¹„ìš©',0),(317432,8818,'he','×ž×—×™×¨ ×ž×ž×•×¦×¢ ×ž×©×•×§×œ×œ',0),(317433,8818,'el','Î£Ï„Î±Î¸Î¼Î¹ÏƒÎ¼Î­Î½Î¿ Î¼Î­ÏƒÎ¿ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(317434,8818,'zh','åŠ æƒå¹³å‡æˆæœ¬\r\n',0),(317435,8818,'sv','VÃ¤gda kostnaden',0),(317436,8818,'it','Costo medio ponderato',0),(317437,8818,'tl','',0),(317438,8818,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;',0),(317439,8818,'hi','à¤­à¤¾à¤°à¤¿à¤¤ à¤”à¤¸à¤¤ à¤²à¤¾à¤—à¤¤',0),(317440,8818,'ms','Kos purata',0),(317441,8818,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø±Ø¬Ø­Ø©',0),(317442,8818,'fr','CoÃ»t moyen pondÃ©rÃ©',0),(317443,8818,'jp','åŠ é‡å¹³å‡ã‚³ã‚¹ãƒˆ',0),(317444,8818,'pt','Custo mÃ©dio ponderado',0),(317445,8818,'ru','Ð’Ð·Ð²ÐµÑˆÐµÐ½Ð½Ð°Ñ ÑÑ€ÐµÐ´Ð½ÑÑ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(317446,8818,'es','Costo de Promedio Ponderado',0),(317447,8818,'de','Weighted Average Cost',0),(317448,8818,'en','Weighted Average Cost',0),(317449,8819,'is','',0),(317450,8819,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(317451,8819,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(317452,8819,'tr','Girilen veriler',0),(317453,8819,'pl','Dane wprowadzone',0),(317454,8819,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸Ñ‚Ðµ Ð´Ð°Ð½Ð½Ð¸',0),(317455,8819,'ur','Ú©ÙˆØ§Ø¦Ù Ø¯Ø§Ø®Ù„',0),(317456,8819,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸ ÑƒÐ½ÐµÑÐµÐ½Ð¸',0),(317457,8819,'vi','ÄÃ£ nháº­p Dá»¯ liá»‡u',0),(317458,8819,'af','Data Ingevoer',0),(317459,8819,'ro','Datele introduse',0),(317460,8819,'et','Sisestatud andmed',0),(317461,8819,'si','Vneseni podatki',0),(317462,8819,'ba','Data yang dimasukkan',0),(317463,8819,'nl','Gegevens die worden ingevoerd',0),(317464,8819,'fi','SyÃ¶tetyt tiedot',0),(317465,8819,'no','Data som skrives inn',0),(317466,8819,'da','Data, der indtastes',0),(317467,8819,'ko','ìž…ë ¥ í•œ ë°ì´í„°',0),(317468,8819,'he','×”× ×ª×•× ×™× ×©×”×•×–× ×•',0),(317469,8819,'el','Î”ÎµÎ´Î¿Î¼Î­Î½Î± Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¸ÎµÎ¯',0),(317470,8819,'zh','è¾“å…¥çš„æ•°æ®\r\n',0),(317471,8819,'sv','Data som anges',0),(317472,8819,'it','Dati immessi',0),(317473,8819,'tl','',0),(317474,8819,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3606;&#3641;&#3585;&#3611;&#3657;&#3629;&#3609;&#3649;&#3621;&#3657;&#3623;',0),(317475,8819,'hi','à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¡à¥‡à¤Ÿà¤¾',0),(317476,8819,'ms','Data yang dimasukkan',0),(317477,8819,'ar','Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§',0),(317478,8819,'fr','DonnÃ©es saisies',0),(317479,8819,'jp','å…¥åŠ›ã•ã‚ŒãŸãƒ‡ãƒ¼ã‚¿',0),(317480,8819,'pt','Dados inseridos',0),(317481,8819,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ Ð’Ð²ÐµÐ´ÐµÐ½Ñ‹',0),(317482,8819,'es','Fecha Entrada',0),(317483,8819,'de','Eingegebenen Daten',0),(317484,8819,'en','Data Entered',0),(317485,8820,'is','',0),(317486,8820,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† ÙˆØ±ÙˆØ¯ Ù†ÙŠØ³Øª',0),(317487,8820,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† ÙˆØ±ÙˆØ¯ Ù†ÙŠØ³Øª',0),(317488,8820,'tr','Alma tamamlanamÄ±yor',0),(317489,8820,'pl','Nie moÅ¼na zakoÅ„czyÄ‡ importowanie',0),(317490,8820,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸ Ð²Ð½Ð¾Ñ',0),(317491,8820,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ú©Ù…Ù„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(317492,8820,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐ¸Ñ‚Ð¸ ÑƒÐ²Ð¾Ð·',0),(317493,8820,'vi','QuÃ¡ trÃ¬nh nháº­p khÃ´ng hoÃ n táº¥t',0),(317494,8820,'af','Kan nie Invoer Voltooi',0),(317495,8820,'ro','Imposibil de terminat Import',0),(317496,8820,'et','Importimist ei saa lÃµpetada',0),(317497,8820,'si','Uvoza ni mogoÄe dokonÄati',0),(317498,8820,'ba','Tidak dapat menyelesaikan impor',0),(317499,8820,'nl','Importeren kan niet worden voltooid',0),(317500,8820,'fi','Ei voi suorittaa tuonti',0),(317501,8820,'no','Kan ikke fullfÃ¸re Import',0),(317502,8820,'da','Kan ikke fuldfÃ¸re Import',0),(317503,8820,'ko','ê°€ì ¸ì˜¤ê¸° ì™„ë£Œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(317504,8820,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×©×œ×™× ×™×™×‘×•×',0),(317505,8820,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÏƒÎµÎ¹ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(317506,8820,'zh','ä¸èƒ½å®Œæˆå¯¼å…¥\r\n',0),(317507,8820,'sv','Kan inte slutfÃ¶ra importen',0),(317508,8820,'it','Non Ã¨ possibile completare l\'importazione',0),(317509,8820,'tl','',0),(317510,8820,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3652;&#3617;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(317511,8820,'hi','à¤†à¤¯à¤¾à¤¤ à¤ªà¥‚à¤°à¥à¤£ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(317512,8820,'ms','Tidak dapat melengkapkan Import',0),(317513,8820,'ar','ØªØ¹Ø°Ø± Ø¥ÙƒÙ…Ø§Ù„ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(317514,8820,'fr','Ne peut pas terminer l\'importation',0),(317515,8820,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã‚’å®Œäº†ã§ãã¾ã›ã‚“ã€‚',0),(317516,8820,'pt','NÃ£o Ã© possÃ­vel concluir a importaÃ§Ã£o',0),(317517,8820,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð—Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(317518,8820,'es','No se Puede Completar la ImportaciÃ³n',0),(317519,8820,'de','Der Import kann nicht abgeschlossen werden.',0),(317520,8820,'en','Cannot Complete Import',0),(317521,8821,'is','',0),(317522,8821,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(317523,8821,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(317524,8821,'tr','GL hesaplarÄ±',0),(317525,8821,'pl','GL kont',0),(317526,8821,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(317527,8821,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(317528,8821,'sr','ÐšÐ¾Ð½Ñ‚Ð° Ð“Ð›',0),(317529,8821,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p ',0),(317530,8821,'af','AG Rekeninge',0),(317531,8821,'ro','GL conturi',0),(317532,8821,'et','Pearaamatu kontod',0),(317533,8821,'si','GL raÄunov',0),(317534,8821,'ba','GL account',0),(317535,8821,'nl','GL Accounts',0),(317536,8821,'fi','GL tilit',0),(317537,8821,'no','GL-kontoer',0),(317538,8821,'da','GL konti',0),(317539,8821,'ko','GL ê³„ì •',0),(317540,8821,'he','×—×©×‘×•× ×•×ª GL',0),(317541,8821,'el','GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(317542,8821,'zh','æ€»å¸å¸æˆ·\r\n',0),(317543,8821,'sv','GL-konton',0),(317544,8821,'it','Conti GL',0),(317545,8821,'tl','',0),(317546,8821,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(317547,8821,'hi','GL à¤–à¤¾à¤¤à¥‹à¤‚',0),(317548,8821,'ms','GL akaun',0),(317549,8821,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(317550,8821,'fr','Comptes GL',0),(317551,8821,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(317552,8821,'pt','Contas GL',0),(317553,8821,'ru','GL ÑÑ‡ÐµÑ‚Ð°',0),(317554,8821,'es','Cuentas de LM',0),(317555,8821,'de','GL-Konten',0),(317556,8821,'en','GL Accounts',0),(317557,8822,'is','',0),(317558,8822,'dr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ ',0),(317559,8822,'pr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± ÙƒÙ„ ',0),(317560,8822,'tr','GL hareketleri',0),(317561,8822,'pl','GL transakcji',0),(317562,8822,'bg','GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸Ñ‚Ðµ',0),(317563,8822,'ur','Ø¬ÛŒØ¬Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ†',0),(317564,8822,'sr','Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(317565,8822,'vi','Giao dá»‹ch sá»• cÃ¡i',0),(317566,8822,'af','AG Transaksies',0),(317567,8822,'ro','GL tranzacÅ£ii',0),(317568,8822,'et','GL tehingute',0),(317569,8822,'si','GL transakcije',0),(317570,8822,'ba','GL transaksi',0),(317571,8822,'nl','GL transacties',0),(317572,8822,'fi','GL tapahtumat',0),(317573,8822,'no','GL transaksjoner',0),(317574,8822,'da','GL transaktioner',0),(317575,8822,'ko','GL íŠ¸ëžœìž­ì…˜',0),(317576,8822,'he','×ª× ×•×¢×•×ª GL',0),(317577,8822,'el','GL ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚',0),(317578,8822,'zh','æ€»å¸äº¤æ˜“\r\n',0),(317579,8822,'sv','GL transaktioner',0),(317580,8822,'it','Transazioni GL',0),(317581,8822,'tl','',0),(317582,8822,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(317583,8822,'hi','à¤œà¥€à¤à¤² à¤²à¥‡à¤¨à¤¦à¥‡à¤¨',0),(317584,8822,'ms','Urus niaga GL',0),(317585,8822,'ar','Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª GL',0),(317586,8822,'fr','Transactions de GL',0),(317587,8822,'jp','GL ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³',0),(317588,8822,'pt','TransaÃ§Ãµes de GL',0),(317589,8822,'ru','GL ÑÐ´ÐµÐ»Ð¾Ðº',0),(317590,8822,'es','LM Transacciones',0),(317591,8822,'de','GL-Transaktionen',0),(317592,8822,'en','GL Transactions',0),(317593,8823,'is','',0),(317594,8823,'dr','Ù…Ø¯Ù„ Ù‡Ø§',0),(317595,8823,'pr','Ù…Ø¯Ù„ Ù‡Ø§',0),(317596,8823,'tr','ModÃ¼ller',0),(317597,8823,'pl','ModuÅ‚y',0),(317598,8823,'bg','ÐœÐ¾Ð´ÑƒÐ»Ð¸',0),(317599,8823,'ur','Ù…Ø§ÚˆÛŒÙˆÙ„',0),(317600,8823,'sr','ÐœÐ¾Ð´ÑƒÐ»Ð¸',0),(317601,8823,'vi','Modun',0),(317602,8823,'af','Modules',0),(317603,8823,'ro','Module',0),(317604,8823,'et','Moodulid',0),(317605,8823,'si','Moduli',0),(317606,8823,'ba','Modul',0),(317607,8823,'nl','Modules',0),(317608,8823,'fi','Moduulit',0),(317609,8823,'no','Moduler',0),(317610,8823,'da','Moduler',0),(317611,8823,'ko','ëª¨ë“ˆ',0),(317612,8823,'he','×ž×•×“×•×œ×™×',0),(317613,8823,'el','Î•Î½ÏŒÏ„Î·Ï„ÎµÏ‚',0),(317614,8823,'zh','æ¨¡å—\r\n',0),(317615,8823,'sv','Moduler',0),(317616,8823,'it','Moduli',0),(317617,8823,'tl','',0),(317618,8823,'th','&#3650;&#3617;&#3604;&#3641;&#3621;',0),(317619,8823,'hi','à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤²',0),(317620,8823,'ms','Modul-Modul',0),(317621,8823,'ar','Ø§Ù„ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù†Ù…Ø·ÙŠØ©',0),(317622,8823,'fr','Modules',0),(317623,8823,'jp','ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«',0),(317624,8823,'pt','MÃ³dulos',0),(317625,8823,'ru','ÐœÐ¾Ð´ÑƒÐ»Ð¸',0),(317626,8823,'es','MÃ³dulos',0),(317627,8823,'de','Module',0),(317628,8823,'en','Modules',0),(317629,8824,'is','',0),(317630,8824,'dr','Ø³Ø·ÙˆØ­ Ù‚ÙŠÙ…Øª',0),(317631,8824,'pr','Ø³Ø·ÙˆØ­ Ù‚ÙŠÙ…Øª',0),(317632,8824,'tr','Fiyat dÃ¼zeyleri',0),(317633,8824,'pl','Poziomy cen',0),(317634,8824,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð¸Ñ‚Ðµ Ð½Ð¸Ð²Ð°',0),(317635,8824,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­',0),(317636,8824,'sr','ÐÐ¸Ð²Ð¾Ð° Ñ†ÐµÐ½Ð°',0),(317637,8824,'vi','Má»©c giÃ¡',0),(317638,8824,'af','Prysvlakke',0),(317639,8824,'ro','Nivelurile de preÅ£',0),(317640,8824,'et','Hinnatase',0),(317641,8824,'si','Ravni cen',0),(317642,8824,'ba','Tingkat harga',0),(317643,8824,'nl','Prijsniveaus',0),(317644,8824,'fi','Hintataso',0),(317645,8824,'no','PrisnivÃ¥',0),(317646,8824,'da','Prisniveau',0),(317647,8824,'ko','ê°€ê²© ìˆ˜ì¤€',0),(317648,8824,'he','×¨×ž×•×ª ×ž×—×™×¨',0),(317649,8824,'el','Î•Ï€Î¯Ï€ÎµÎ´Î± Ï„Î¹Î¼ÏŽÎ½',0),(317650,8824,'zh','ä»·æ ¼æ°´å¹³\r\n',0),(317651,8824,'sv','PrisnivÃ¥er',0),(317652,8824,'it','Livelli di prezzo',0),(317653,8824,'tl','',0),(317654,8824,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;',0),(317655,8824,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°',0),(317656,8824,'ms','Paras harga',0),(317657,8824,'ar','Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(317658,8824,'fr','Niveaux de prix',0),(317659,8824,'jp','ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«',0),(317660,8824,'pt','NÃ­veis de preÃ§os',0),(317661,8824,'ru','Ð£Ñ€Ð¾Ð²Ð½Ð¸ Ð¦ÐµÐ½',0),(317662,8824,'es','Niveles de Precios',0),(317663,8824,'de','Das Preisniveau',0),(317664,8824,'en','Price Levels',0),(317665,8825,'is','',0),(317666,8825,'dr','ÙØ§ÙŠÙ„ ØµØ¯ÙˆØ± ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(317667,8825,'pr','ÙØ§ÙŠÙ„ ØµØ¯ÙˆØ± ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(317668,8825,'tr','QuickBooks ihracat dosyasÄ± yok',0),(317669,8825,'pl','QuickBooks wyeksportowany plik nie istnieje',0),(317670,8825,'bg','QuickBooks ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚ÐµÐ½ Ñ„Ð°Ð¹Ð» Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(317671,8825,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ù…Ø³Ù„ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº',0),(317672,8825,'sr','QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ Ð¸Ð·Ð²Ð¾Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(317673,8825,'vi','Há»“ sÆ¡ xuáº¥t QuickBooks khÃ´ng tá»“n táº¡i',0),(317674,8825,'af','QuickBooks UitvoerlÃªer Bestaan Nie',0),(317675,8825,'ro','QuickBooks Export fiÅŸier nu exista',0),(317676,8825,'et','QuickBooks-i ekspordifaili ei eksisteeri',0),(317677,8825,'si','QuickBooks izvozne datoteke ne obstaja',0),(317678,8825,'ba','QuickBooks ekspor File tidak ada',0),(317679,8825,'nl','QuickBooks Export bestand bestaat niet',0),(317680,8825,'fi','QuickBooks vientitiedoston ei ole',0),(317681,8825,'no','QuickBooks eksportfil finnes ikke',0),(317682,8825,'da','QuickBooks eksportfil findes ikke',0),(317683,8825,'ko','QuickBooks ë‚´ë³´ë‚´ê¸° íŒŒì¼ì´ ì¡´ìž¬ í•˜ì§€ ì•ŠìŒ',0),(317684,8825,'he','×§×•×‘×¥ ×”×™×™×¦×•× QuickBooks ××™× ×• ×§×™×™×',0),(317685,8825,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î±ÏÏ‡ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ QuickBooks',0),(317686,8825,'zh','QuickBooksçš„å¯¼å‡ºæ–‡ä»¶ä¸å­˜åœ¨\r\n',0),(317687,8825,'sv','QuickBooks Export-filen finns inte',0),(317688,8825,'it','QuickBooks esportazione File non esiste',0),(317689,8825,'tl','',0),(317690,8825,'th','&#3652;&#3615;&#3621;&#3660;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;&#3588;&#3641;&#3656;&#3617;&#3639;&#3629;&#3648;&#3619;&#3656;&#3591;&#3604;&#3656;&#3623;&#3609;&#3652;&#3617;&#3656;&#3617;&#3637;',0),(317691,8825,'hi','QuickBooks à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤² à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(317692,8825,'ms','QuickBooks eksport fail tidak wujud',0),(317693,8825,'ar','Ù‚Ø±Ø§Ø¡ ØªØµØ¯ÙŠØ± Ø§Ù„Ù…Ù„Ù ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(317694,8825,'fr','QuickBooks exportation fichier n\'existe pas',0),(317695,8825,'jp','QuickBooks ã®ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«ãŒå­˜åœ¨ã—ã¾ã›ã‚“',0),(317696,8825,'pt','NÃ£o existe arquivo de exportaÃ§Ã£o de QuickBooks',0),(317697,8825,'ru','QuickBooks ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° Ñ„Ð°Ð¹Ð» Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(317698,8825,'es','File de ExportaciÃ³n de Quickbooks No Existe',0),(317699,8825,'de','QuickBooks-Export-Datei ist nicht vorhanden.',0),(317700,8825,'en','QuickBooks Export File Does Not Exist',0),(317701,8826,'is','',0),(317702,8826,'dr','ÙØ§ÙŠÙ„ ØµØ¯ÙˆØ± ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹ Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ø²ÙŠØ± Ù†ÙŠØ³Øª ',0),(317703,8826,'pr','ÙØ§ÙŠÙ„ ØµØ¯ÙˆØ± ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹ Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ø²ÙŠØ± Ù†ÙŠØ³Øª ',0),(317704,8826,'tr','QuickBooks verme dosyasÄ±nÄ±n XML biÃ§imi geÃ§erli deÄŸil',0),(317705,8826,'pl','Plik QuickBooks eksportu nie jest w formacie XML',0),(317706,8826,'bg','QuickBooks ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚ÐµÐ½ Ñ„Ð°Ð¹Ð» Ð½Ðµ Ðµ Ð² XML Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(317707,8826,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ù…Ø³Ù„ XML ÙˆØ¶Ø¹ Ù…ÛŒÚº Ù†ÛÛŒÚº ÛÛ’ Û”',0),(317708,8826,'sr','QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ Ð¸Ð·Ð²Ð¾Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð¸Ñ˜Ðµ Ñƒ XÐœÐ› Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(317709,8826,'vi','Há»“ sÆ¡ xuáº¥t QuickBooks khÃ´ng pháº£i dáº¡ng XML',0),(317710,8826,'af','QuickBooks UitvoerlÃªer Is Nie in XML Formaat',0),(317711,8826,'ro','QuickBooks Export fiÅŸier nu este Ã®n XML Format',0),(317712,8826,'et','QuickBooks-i ekspordifaili ei ole nÃµutud XML formaadis',0),(317713,8826,'si','QuickBooks izvozno datoteko ni v XML obliki',0),(317714,8826,'ba','QuickBooks ekspor File ini tidak dalam XML Format',0),(317715,8826,'nl','QuickBooks exportbestand Is niet In XML-indeling',0),(317716,8826,'fi','QuickBooks vienti tiedosto ei ole XML-muodossa',0),(317717,8826,'no','QuickBooks eksportfilen er ikke i XML-Format',0),(317718,8826,'da','QuickBooks eksportfilen er ikke i XML-Format',0),(317719,8826,'ko','QuickBooks ë‚´ë³´ë‚´ê¸° íŒŒì¼ì€ XML í˜•ì‹',0),(317720,8826,'he','QuickBooks ×™×™×¦×•× ×”×§×•×‘×¥ ××™× ×• ×‘×ª×‘× ×™×ª XML',0),(317721,8826,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ QuickBooks Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÎµ Î¼Î¿ÏÏ†Î® XML',0),(317722,8826,'zh','QuickBooksçš„å¯¼å‡ºæ–‡ä»¶ä¸æ˜¯XMLæ ¼å¼\r\n',0),(317723,8826,'sv','QuickBooks Export-filen finns inte i XML-Format',0),(317724,8826,'it','QuickBooks esportazione File non Ã¨ In formato XML',0),(317725,8826,'tl','',0),(317726,8826,'th','&#3652;&#3615;&#3621;&#3660;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;&#3588;&#3641;&#3656;&#3617;&#3639;&#3629;&#3648;&#3619;&#3656;&#3591;&#3604;&#3656;&#3623;&#3609;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610; XM',0),(317727,8826,'hi','QuickBooks à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤² XML à¤¸à¥à¤µà¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(317728,8826,'ms','QuickBooks eksport fail ini tidak dalam XML Format',0),(317729,8826,'ar','Ù‚Ø±Ø§Ø¡ ØªØµØ¯ÙŠØ± Ù…Ù„Ù Ù„ÙŠØ³Øª Ø¨ØªÙ†Ø³ÙŠÙ‚ XML',0),(317730,8826,'fr','Fichier d\'exportation de QuickBooks n\'est pas au Format XML',0),(317731,8826,'jp','QuickBooks ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«ã¯ XML å½¢å¼ã§ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(317732,8826,'pt','Arquivo de exportaÃ§Ã£o de QuickBooks nÃ£o estÃ¡ no formato XML',0),(317733,8826,'ru','QuickBooks ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° Ñ„Ð°Ð¹Ð» Ð½Ð°Ñ…Ð¾Ð´Ð¸Ñ‚ÑÑ Ð½Ðµ Ð² Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ XML',0),(317734,8826,'es','File de ExportaciÃ³n de Quickbooks No Esta en el Formato de XML',0),(317735,8826,'de','QuickBooks-Export-Datei ist nicht im XML-Format',0),(317736,8826,'en','QuickBooks Export File Is Not In XML Format',0),(317737,8827,'is','',0),(317738,8827,'dr','(Ù¾Ø§ÙŠÚ¯Ø§Ù‡) ØµØ¯ÙˆØ± ÙØ§ÙŠÙ„ ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹ ',0),(317739,8827,'pr','ÙˆØ¶Ø¹ÙŠØª(Ù¾Ø§ÙŠÚ¯Ø§Ù‡) ØµØ¯ÙˆØ± ÙØ§ÙŠÙ„ ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹ ',0),(317740,8827,'tr','QuickBooks dosya verme durumu',0),(317741,8827,'pl','Stan eksportu pliku QuickBooks',0),(317742,8827,'bg','QuickBooks Ñ„Ð°Ð¹Ð» Ð¸Ð·Ð½Ð¾ÑÐ° ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(317743,8827,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ù…Ø³Ù„ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ø­Ø§Ù„Øª',0),(317744,8827,'sr','QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð¸Ð·Ð²Ð¾Ð·Ð½Ð¾Ð³ ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(317745,8827,'vi','TÃ¬nh tráº¡ng xuáº¥t há»“ sÆ¡ QuickBooks',0),(317746,8827,'af','QuickBooks LÃªer Uitvoer Status',0),(317747,8827,'ro','Statutul de Export QuickBooks fiÅŸier',0),(317748,8827,'et','QuickBooksi fail ekspordi olek',0),(317749,8827,'si','QuickBooks pila izvoz stanja',0),(317750,8827,'ba','Status ekspor QuickBooks berkas',0),(317751,8827,'nl','Uitvoer QuickBooks bestandsstatus',0),(317752,8827,'fi','QuickBooks viennin tila',0),(317753,8827,'no','QuickBooks filstatus eksport',0),(317754,8827,'da','QuickBooks fil eksport Status',0),(317755,8827,'ko','QuickBooks íŒŒì¼ ë‚´ë³´ë‚´ê¸° ìƒíƒœ',0),(317756,8827,'he','×ž×¦×‘ ×™×™×¦×•× ×”×§×•×‘×¥ QuickBooks',0),(317757,8827,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï„Î·Ï‚ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ Ï„Î¿Ï… Î±ÏÏ‡ÎµÎ¯Î¿Ï… QuickBooks',0),(317758,8827,'zh','QuickBooksçš„æ–‡ä»¶å¯¼å‡ºçŠ¶æ€\r\n',0),(317759,8827,'sv','QuickBooks Export filstatus',0),(317760,8827,'it','QuickBooks File Export Status',0),(317761,8827,'tl','',0),(317762,8827,'th','&#3652;&#3615;&#3621;&#3660;&#3626;&#3606;&#3634;&#3609;&#3632;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;&#3588;&#3641;&#3656;&#3617;&#3639;&#3629;&#3648;&#3619;&#3656;&#3591;&#3604;&#3656;&#3623;&#3609;',0),(317763,8827,'hi','QuickBooks à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(317764,8827,'ms','Status eksport fail QuickBooks',0),(317765,8827,'ar','Ø­Ø§Ù„Ø© ØªØµØ¯ÙŠØ± Ù…Ù„Ù Ù‚Ø±Ø§Ø¡',0),(317766,8827,'fr','Ã‰tat d\'exportation fichier de QuickBooks',0),(317767,8827,'jp','QuickBooks ãƒ•ã‚¡ã‚¤ãƒ« ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(317768,8827,'pt','QuickBooks arquivo Status de exportaÃ§Ã£o',0),(317769,8827,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ QuickBooks Ñ„Ð°Ð¹Ð»Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(317770,8827,'es','File de Quickbooks Status de ExportaciÃ³n',0),(317771,8827,'de','QuickBooks Dateistatus Export',0),(317772,8827,'en','QuickBooks File Export Status',0),(317773,8828,'is','',0),(317774,8828,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹ ',0),(317775,8828,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹ ',0),(317776,8828,'tr','QuickBooks alma',0),(317777,8828,'pl','QuickBooks Import',0),(317778,8828,'bg','QuickBooks Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(317779,8828,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(317780,8828,'sr','QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ ÑƒÐ²Ð¾Ð·Ð°',0),(317781,8828,'vi','Nháº­p Quickbooks',0),(317782,8828,'af','QuickBooks Invoerder',0),(317783,8828,'ro','QuickBooks Import',0),(317784,8828,'et','QuickBooks-i import',0),(317785,8828,'si','QuickBooks uvoznih',0),(317786,8828,'ba','QuickBooks impor',0),(317787,8828,'nl','QuickBooks importeren',0),(317788,8828,'fi','QuickBooks tuonti',0),(317789,8828,'no','QuickBooks Import',0),(317790,8828,'da','QuickBooks Import',0),(317791,8828,'ko','QuickBooks ê°€ì ¸ì˜¤ê¸°',0),(317792,8828,'he','×™×™×‘×•× QuickBooks',0),(317793,8828,'el','QuickBooks ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(317794,8828,'zh','QuickBooksçš„è¿›å£\r\n',0),(317795,8828,'sv','QuickBooks Import',0),(317796,8828,'it','QuickBooks Import',0),(317797,8828,'tl','',0),(317798,8828,'th','&#3610;&#3635;&#3648;&#3586;&#3657;&#3634;&#3588;&#3641;&#3656;&#3617;&#3639;&#3629;&#3648;&#3619;&#3656;&#3591;&#3604;&#3656;&#3623;&#3609;',0),(317799,8828,'hi','QuickBooks à¤†à¤¯à¤¾à¤¤',0),(317800,8828,'ms','QuickBooks Import',0),(317801,8828,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù‚Ø±Ø§Ø¡',0),(317802,8828,'fr','Importation de QuickBooks',0),(317803,8828,'jp','QuickBooks ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(317804,8828,'pt','ImportaÃ§Ã£o de QuickBooks',0),(317805,8828,'ru','QuickBooks Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(317806,8828,'es','Importar Quickbooks',0),(317807,8828,'de','QuickBooks importieren',0),(317808,8828,'en','QuickBooks Import',0),(317809,8829,'is','',0),(317810,8829,'dr','Ú¯Ø²Ù„Ø±Ø´Ø§Øª ÙØ±ÙˆØ´ ',0),(317811,8829,'pr','Ú¯Ø²Ù„Ø±Ø´Ø§Øª ÙØ±ÙˆØ´ ',0),(317812,8829,'tr','SatÄ±ÅŸ temsilcileri',0),(317813,8829,'pl','Przedstawiciele handlowi',0),(317814,8829,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÐµÐ½Ð¸Ñ',0),(317815,8829,'ur','Ø³ÛŒÙ„Ø² Ø±ÛŒÙ¾Ø³',0),(317816,8829,'sr','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð½Ð¸ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(317817,8829,'vi','NhÃ¢n viÃªn kinh doanh',0),(317818,8829,'af','Verkoopsverteenwoordigers',0),(317819,8829,'ro','Repetari de vÃ¢nzÄƒri',0),(317820,8829,'et','MÃ¼Ã¼k Reps',0),(317821,8829,'si','Prodajalcih',0),(317822,8829,'ba','Agen penjualan',0),(317823,8829,'nl','Verkopers',0),(317824,8829,'fi','Myyjien',0),(317825,8829,'no','Selgere',0),(317826,8829,'da','SalgsreprÃ¦sentanter',0),(317827,8829,'ko','íŒë§¤ ë‹´ë‹¹ìž',0),(317828,8829,'he','× ×¦×™×’×™ ×”×ž×›×™×¨×•×ª',0),(317829,8829,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Ï…Ï†Î±ÏƒÎ¼Î¬Ï„Ï‰Î½',0),(317830,8829,'zh','é”€å”®ä»£è¡¨\r\n',0),(317831,8829,'sv','SÃ¤ljare',0),(317832,8829,'it','Sales Reps',0),(317833,8829,'tl','',0),(317834,8829,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(317835,8829,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿',0),(317836,8829,'ms','Wakil jualan',0),(317837,8829,'ar','Ù…Ù†Ø¯ÙˆØ¨ÙŠ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(317838,8829,'fr','ReprÃ©sentants des ventes',0),(317839,8829,'jp','å–¶æ¥­æ‹…å½“è€…',0),(317840,8829,'pt','Representantes de vendas',0),(317841,8829,'ru','Ð¢Ð¾Ñ€Ð³Ð¾Ð²Ñ‹Ðµ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»Ð¸',0),(317842,8829,'es','Rep. de Ventas',0),(317843,8829,'de','Vertriebsmitarbeiter',0),(317844,8829,'en','Sales Reps',0),(317845,8830,'is','',0),(317846,8830,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÙŠ   ÙƒØªØ§Ø¨ Ø±Ø§Ù‡Ù†Ù…Ø§  Ø±Ø§ Ø¨Ù‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø§Ø±Ø³Ø§Ù„  ÙƒÙ†ÙŠØ¯ØŸ',0),(317847,8830,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÙŠ   ÙƒØªØ§Ø¨ Ø±Ø§Ù‡Ù†Ù…Ø§  Ø±Ø§ Ø¨Ù‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø§Ø±Ø³Ø§Ù„  ÙƒÙ†ÙŠØ¯ØŸ',0),(317848,8830,'tr','Sisteme QuickBooks kayÄ±tlarÄ± almak istediÄŸinizden emin misiniz?',0),(317849,8830,'pl','Czy na pewno chcesz importowaÄ‡ rekordy QuickBooks do systemu?',0),(317850,8830,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ‚Ðµ QuickBooks Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°?',0),(317851,8830,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ø±ÛŒÚ©Ø§Ø±Úˆ Ù†Ø¸Ø§Ù… Ù…ÛŒÚº Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(317852,8830,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° ÑƒÐ²ÐµÐ·ÐµÑ‚Ðµ QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ Ð·Ð°Ð¿Ð¸ÑÐµ Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ?',0),(317853,8830,'vi','Nháº­p há»“ sÆ¡ trong QuickBooks vÃ o NolaPro?',0),(317854,8830,'af','Is u seker u wil Quickbooks se rekords in NolaPro invoer?',0),(317855,8830,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ importaÅ£i QuickBooks Ã®nregistrÄƒri Ã®n sistem?',0),(317856,8830,'et','Kas Te olete kindel, et soovite importida QuickBooks-i andmed NolaPro sÃ¼steemi?',0),(317857,8830,'si','Ali ste prepriÄani, da Å¾elite uvoziti QuickBooks zapisov v sistemu?',0),(317858,8830,'ba','Apakah Anda yakin Anda ingin mengimpor QuickBooks catatan ke dalam sistem?',0),(317859,8830,'nl','Weet u zeker dat u wilt importeren QuickBooks records in het systeem?',0),(317860,8830,'fi','Oletko varma, ettÃ¤ haluat tuoda QuickBooks tietueiden jÃ¤rjestelmÃ¤Ã¤n?',0),(317861,8830,'no','Er du sikker du vil importere QuickBooks poster i systemet?',0),(317862,8830,'da','Er du sikker pÃ¥, du vil importere QuickBooks poster i systemet?',0),(317863,8830,'ko','ë‹¹ì‹ ì€ ì‹œìŠ¤í…œì— QuickBooks ë ˆì½”ë“œë¥¼ ê°€ì ¸ì˜¬ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(317864,8830,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×™×™×‘× ×¨×©×•×ž×•×ª QuickBooks ×œ×ª×•×š ×”×ž×¢×¨×›×ª?',0),(317865,8830,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ ÎºÎ±ÏÏ„Î­Î»ÎµÏ‚ QuickBooks ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±;',0),(317866,8830,'zh','ä½ ç¡®å®šè¦å°†ä¼šè®¡ç°¿çš„è®°å½•æ±‡å…¥ç³»ç»Ÿï¼Ÿ\r\n',0),(317867,8830,'sv','Ã„r du sÃ¤ker du vill importera QuickBooks poster i systemet?',0),(317868,8830,'it','Sei sicuro di che voler importare QuickBooks record nel sistema?',0),(317869,8830,'tl','',0),(317870,8830,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634; QuickBooks records &#3651;&#3609; Nol',0),(317871,8830,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª QuickBooks à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤®à¥‡à¤‚ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(317872,8830,'ms','Adakah awda pasti yang awda ingin import QuickBooks rekod ke dalam sistem?',0),(317873,8830,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø³Ø¬Ù„Ø§Øª Ù‚Ø±Ø§Ø¡ ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…ØŸ',0),(317874,8830,'fr','ÃŠtes-vous certain de que vouloir importer des dossiers de QuickBooks dans le systÃ¨me ?',0),(317875,8830,'jp','QuickBooks ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ã‚·ã‚¹ãƒ†ãƒ ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¦ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(317876,8830,'pt','Tens a certeza de que vocÃª deseja importar registros de QuickBooks para o sistema?',0),(317877,8830,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ QuickBooks Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ?',0),(317878,8830,'es','Esta seguro que quiere importar records de Quickbooks a NolaPro',0),(317879,8830,'de','Bist du sicher, dass Sie QuickBooks Aufzeichnungen in das System importieren mÃ¶chten?',0),(317880,8830,'en','Are you sure you want to import QuickBooks records into the system?',0),(317881,8831,'is','',0),(317882,8831,'dr','ØµÙØ­Ù‡ ÙˆØ¶Ø¹ÙŠØª ',0),(317883,8831,'pr','ØµÙØ­Ù‡ ÙˆØ¶Ø¹ÙŠØª ',0),(317884,8831,'tr','Durum sayfasÄ±',0),(317885,8831,'pl','Status strony',0),(317886,8831,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾',0),(317887,8831,'ur','Ø­Ø§Ù„Øª ØµÙØ­Û',0),(317888,8831,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(317889,8831,'vi','TÃ¬nh tráº¡ng trang',0),(317890,8831,'af','Status Blad',0),(317891,8831,'ro','Pagina stare',0),(317892,8831,'et','Lehe olek',0),(317893,8831,'si','Status stran',0),(317894,8831,'ba','Halaman status',0),(317895,8831,'nl','Statuspagina',0),(317896,8831,'fi','Tila-sivu',0),(317897,8831,'no','Statussiden',0),(317898,8831,'da','Statusside',0),(317899,8831,'ko','ìƒíƒœ íŽ˜ì´ì§€',0),(317900,8831,'he','×“×£ ×ž×¦×‘',0),(317901,8831,'el','Î£ÎµÎ»Î¯Î´Î± \"ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·\"',0),(317902,8831,'zh','çŠ¶æ€é¡µ\r\n',0),(317903,8831,'sv','Status fÃ¶r',0),(317904,8831,'it','Pagina di stato',0),(317905,8831,'tl','',0),(317906,8831,'th','&#3626;&#3606;&#3634;&#3609;&#3632;&#3648;&#3614;&#3592;',0),(317907,8831,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤ªà¥ƒà¤·à¥à¤ ',0),(317908,8831,'ms','Laman status',0),(317909,8831,'ar','ØµÙØ­Ø© Ø­Ø§Ù„Ø©',0),(317910,8831,'fr','Page d\'Ã‰tat',0),(317911,8831,'jp','ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ ãƒšãƒ¼ã‚¸',0),(317912,8831,'pt','PÃ¡gina de status',0),(317913,8831,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(317914,8831,'es','PÃ¡gina de Status',0),(317915,8831,'de','Seite \"Status\"',0),(317916,8831,'en','Status Page',0),(317917,8832,'is','',0),(317918,8832,'dr','(Ø§Ø³Ù†Ø§Ø¯',0),(317919,8832,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯ÙØ§ØªØ±(Ø§Ø³Ù†Ø§Ø¯',0),(317920,8832,'tr','KayÄ±tlarÄ± gÃ¶rÃ¼ntÃ¼le',0),(317921,8832,'pl','WyÅ›wietl rekordy',0),(317922,8832,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(317923,8832,'ur','Ù…Ù†Ø¸Ø± Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(317924,8832,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð·Ð°Ð¿Ð¸ÑÐ°',0),(317925,8832,'vi','Xem há»“ sÆ¡',0),(317926,8832,'af','Besigtig Rekords',0),(317927,8832,'ro','Vezi Records',0),(317928,8832,'et','Vaata andmeid',0),(317929,8832,'si','Ogled zapisov',0),(317930,8832,'ba','Lihat catatan',0),(317931,8832,'nl','Records weergeven',0),(317932,8832,'fi','Tietueiden tarkasteleminen',0),(317933,8832,'no','Vise poster',0),(317934,8832,'da','Se poster',0),(317935,8832,'ko','ë ˆì½”ë“œ ë³´ê¸°',0),(317936,8832,'he','×¨×©×•×ž×•×ª ×©×œ ×ª×¦×•×’×•×ª',0),(317937,8832,'el','ÎšÎ±ÏÏ„Î­Î»ÎµÏ‚ Ï€ÏÎ¿Î²Î¿Î»Î®Ï‚',0),(317938,8832,'zh','æŸ¥çœ‹è®°å½•\r\n',0),(317939,8832,'sv','Visa poster',0),(317940,8832,'it','Visualizzazione record',0),(317941,8832,'tl','',0),(317942,8832,'th','&#3649;&#3626;&#3604;&#3591;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;',0),(317943,8832,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤…à¤­à¤¿à¤²à¥‡à¤–',0),(317944,8832,'ms','Paparan rekod',0),(317945,8832,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø³Ø¬Ù„Ù‘Ø§Øª',0),(317946,8832,'fr','Vue Records',0),(317947,8832,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(317948,8832,'pt','Ver os registros',0),(317949,8832,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(317950,8832,'es','Visionar Records',0),(317951,8832,'de','Anzeigen von DatensÃ¤tzen',0),(317952,8832,'en','View Records',0),(317953,8833,'is','',0),(317954,8833,'dr','Ø¢Ø¯Ø±Ø³ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(317955,8833,'pr','Ø¢Ø¯Ø±Ø³ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(317956,8833,'tr','Fatura adresi',0),(317957,8833,'pl','Bill adres',0),(317958,8833,'bg','ÐÐ´Ñ€ÐµÑ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(317959,8833,'ur','Ø¨Ù„ Ø¹Ù†ÙˆØ§Ù†',0),(317960,8833,'sr','Ð‘Ð¸Ð» Ð°Ð´Ñ€ÐµÑÐ°',0),(317961,8833,'vi','Äá»‹a Chá»‰ Gá»­i HÃ³a ÄÆ¡n',0),(317962,8833,'af','Wetsontwerp adres',0),(317963,8833,'ro','Bill adresa',0),(317964,8833,'et','Maksja aadress',0),(317965,8833,'si','Bill naslov',0),(317966,8833,'ba','Alamat tagihan',0),(317967,8833,'nl','Bill adres',0),(317968,8833,'fi','Laskun osoite',0),(317969,8833,'no','Bill adresse',0),(317970,8833,'da','Faktureringsadresse',0),(317971,8833,'ko','ë¹Œ ì£¼ì†Œ',0),(317972,8833,'he','×›×ª×•×‘×ª ×—×©×‘×•×Ÿ',0),(317973,8833,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(317974,8833,'zh','å¸å•åœ°å€\r\n',0),(317975,8833,'sv','Bill adress',0),(317976,8833,'it','Indirizzo fattura',0),(317977,8833,'tl','',0),(317978,8833,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3610;&#3636;&#3621;',0),(317979,8833,'hi','à¤¬à¤¿à¤² à¤ªà¤¤à¥‡',0),(317980,8833,'ms','Alamat bil',0),(317981,8833,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(317982,8833,'fr','Adresse de la facture',0),(317983,8833,'jp','è«‹æ±‚ä½æ‰€',0),(317984,8833,'pt','Bill endereÃ§o',0),(317985,8833,'ru','Ð‘Ð¸Ð»Ð» Ð°Ð´Ñ€ÐµÑ',0),(317986,8833,'es','DirecciÃ³n de Recibo',0),(317987,8833,'de','Bill-Adresse',0),(317988,8833,'en','Bill Address',0),(317989,8834,'is','',0),(317990,8834,'dr','( Ø¯ÙØ§ØªØ±  ) Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(317991,8834,'pr','Ø§Ø³Ù†Ø§Ø¯( Ø¯ÙØ§ØªØ±  ) Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(317992,8834,'tr','MÃ¼ÅŸteri kayÄ±tlarÄ± alma',0),(317993,8834,'pl','Rekordy klientÃ³w do importu',0),(317994,8834,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(317995,8834,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ú¯Ø§ÛÚ© Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(317996,8834,'sr','Ð—Ð°Ð¿Ð¸ÑÐµ Ð¾ ÐºÑƒÐ¿Ñ†Ð¸Ð¼Ð° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(317997,8834,'vi','Danh sÃ¡ch khÃ¡ch hÃ ng Ä‘á»ƒ nháº­p',0),(317998,8834,'af','Klant/KliÃ«nt Rekords om In te voer',0),(317999,8834,'ro','ÃŽnregistrÄƒri client de Import',0),(318000,8834,'et','Kliendi andmed, et Import',0),(318001,8834,'si','Podatki o strankah na uvoz',0),(318002,8834,'ba','Catatan pelanggan untuk impor',0),(318003,8834,'nl','Klantrecords importeren',0),(318004,8834,'fi','Asiakastietueita tuo',0),(318005,8834,'no','KundeoppfÃ¸ringer Importer',0),(318006,8834,'da','Kundeposter til Import',0),(318007,8834,'ko','ê³ ê° ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(318008,8834,'he','×¨×©×•×ž×•×ª ×©×œ ×œ×§×•×—×•×ª ×œ ×™×™×‘×•×',0),(318009,8834,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(318010,8834,'zh','å®¢æˆ·è®°å½•å¯¼å…¥\r\n',0),(318011,8834,'sv','Kundposter import',0),(318012,8834,'it','Dati del cliente da importare',0),(318013,8834,'tl','',0),(318014,8834,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(318015,8834,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤…à¤­à¤¿à¤²à¥‡à¤–',0),(318016,8834,'ms','Rekod-rekod pelanggan untuk Import',0),(318017,8834,'ar','Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(318018,8834,'fr','Enregistrements de client pour l\'importation',0),(318019,8834,'jp','é¡§å®¢ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹',0),(318020,8834,'pt','Registros de cliente para importaÃ§Ã£o',0),(318021,8834,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(318022,8834,'es','Records de Clientes para Importar',0),(318023,8834,'de','Kunden-DatensÃ¤tze zu importieren',0),(318024,8834,'en','Customer Records to Import',0),(318025,8835,'is','',0),(318026,8835,'dr','- Ù…ÙŠØ§Ù†ÙŠ - Ø¢Ø®Ø±',0),(318027,8835,'pr','Ø§ÙˆÙ„ - Ù…ÙŠØ§Ù†ÙŠ - Ø¢Ø®Ø±',0),(318028,8835,'tr','Ä°lk-orta-son',0),(318029,8835,'pl','Pierwszy bliski Ostatni',0),(318030,8835,'bg','ÐŸÑŠÑ€Ð²Ð¾-ÑÑ€ÐµÐ´Ð°Ñ‚Ð°-Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾',0),(318031,8835,'ur','Ù¾ÛÙ„Ø§ Ø¯Ø±Ù…ÛŒØ§Ù†ÛŒ Ø¢Ø®Ø±ÛŒ',0),(318032,8835,'sr','ÐŸÑ€Ð²Ð¸ ÑÑ€ÐµÐ´ÑšÐµ-Ð¿Ð¾ÑÑ™ÐµÐ´ÑšÐ°',0),(318033,8835,'vi','Äáº§u tiÃªn-Giá»¯a-Cuá»‘i cÃ¹ng',0),(318034,8835,'af','Voornaam-Tweedenaam-Van',0),(318035,8835,'ro','Prima-mijloc-ultima',0),(318036,8835,'et','Ees- keskmine- ja perekonnanimi',0),(318037,8835,'si','Prvi-srednji-zadnji',0),(318038,8835,'ba','Pertama-tengah-terakhir',0),(318039,8835,'nl','Eerste-Midden-laatste',0),(318040,8835,'fi','EnsimmÃ¤inen LÃ¤hi viimeinen',0),(318041,8835,'no','FÃ¸rste-midten-siste',0),(318042,8835,'da','FÃ¸rste-midten-sidste',0),(318043,8835,'ko','ì²« ë²ˆì§¸-ì¤‘ê°„-ë§ˆì§€ë§‰',0),(318044,8835,'he','×¨××©×•×Ÿ-×”×ª×™×›×•×Ÿ-××—×¨×•×Ÿ',0),(318045,8835,'el','Î ÏÏŽÏ„Î¿-Î¼Î­ÏƒÎ·-Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿',0),(318046,8835,'zh','é¦–å…ˆ-ä¸­é—´-æœ€åŽ\r\n',0),(318047,8835,'sv','FÃ¶rsta-mitten-sista',0),(318048,8835,'it','Primo-medio-ultimo',0),(318049,8835,'tl','',0),(318050,8835,'th','&#3649;&#3619;&#3585;-&#3585;&#3621;&#3634;&#3591;-&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(318051,8835,'hi','à¤ªà¥à¤°à¤¥à¤®-à¤®à¤§à¥à¤¯à¤®-à¤…à¤‚à¤¤à¤¿à¤®',0),(318052,8835,'ms','Pertama-tengah-kali terakhir',0),(318053,8835,'ar','Ø§Ù„Ø£ÙˆÙ„-Ø§Ù„Ø£ÙˆØ³Ø·-Ø§Ù„Ø£Ø®ÙŠØ±',0),(318054,8835,'fr','Middle-premier-dernier',0),(318055,8835,'jp','æœ€åˆä¸­é–“æœ€å¾Œ',0),(318056,8835,'pt','Primeiro-mÃ©dio-Ãºltimo',0),(318057,8835,'ru','ÐŸÐµÑ€Ð²Ð¾Ðµ-Ð¡Ñ€ÐµÐ´Ð½ÐµÐµ-ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ',0),(318058,8835,'es','Primero-Medio-Final',0),(318059,8835,'de','Erster-Mitte-Letzter',0),(318060,8835,'en','First-Middle-Last',0),(318061,8836,'is','',0),(318062,8836,'dr','Ø¢Ø¯Ø±Ø³ Ø­Ù…Ù„',0),(318063,8836,'pr','Ø¢Ø¯Ø±Ø³ Ø­Ù…Ù„',0),(318064,8836,'tr','Sevk adresi',0),(318065,8836,'pl','Adres',0),(318066,8836,'bg','ÐÐ´Ñ€ÐµÑ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(318067,8836,'ur','Ø¬ÛØ§Ø² Ù¾ØªÛ',0),(318068,8836,'sr','Ð‘Ñ€Ð¾Ð´ Ð°Ð´Ñ€ÐµÑÐ°',0),(318069,8836,'vi','Äá»‹a chá»‰ váº­n chuyá»ƒn ',0),(318070,8836,'af','Versende Adres',0),(318071,8836,'ro','Adresa de livrare',0),(318072,8836,'et','Tarneaadress',0),(318073,8836,'si','Ladja naslov',0),(318074,8836,'ba','Alamat kapal',0),(318075,8836,'nl','Schip adres',0),(318076,8836,'fi','Aluksen osoite',0),(318077,8836,'no','Skipet adresse',0),(318078,8836,'da','Skibet adresse',0),(318079,8836,'ko','ì„ ë°• ì£¼ì†Œ',0),(318080,8836,'he','×”×¡×¤×™× ×” ×›×ª×•×‘×ª',0),(318081,8836,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Ï€Î»Î¿Î¯Î¿',0),(318082,8836,'zh','è¿é€åœ°å€\r\n',0),(318083,8836,'sv','Fartyget adress',0),(318084,8836,'it','Indirizzo di nave',0),(318085,8836,'tl','',0),(318086,8836,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(318087,8836,'hi','à¤œà¤¹à¤¾à¤œ à¤ªà¤¤à¥‡',0),(318088,8836,'ms','Alamat kapal',0),(318089,8836,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(318090,8836,'fr','Adresse de navire',0),(318091,8836,'jp','ç™ºé€å…ˆä½æ‰€',0),(318092,8836,'pt','EndereÃ§o do navio',0),(318093,8836,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð°Ð´Ñ€ÐµÑ',0),(318094,8836,'es','DirecciÃ³n de EnvÃ­o',0),(318095,8836,'de','Schiff-Adresse',0),(318096,8836,'en','Ship Address',0),(318097,8837,'is','',0),(318098,8837,'dr','(ÙŠØ¯ÙƒÙŠ)',0),(318099,8837,'pr','Ø´Ù…Ø§Ø±Ù‡ ØªÙ„ÙÙ† Ø°Ø®ÙŠØ±Ù‡(ÙŠØ¯ÙƒÙŠ)',0),(318100,8837,'tr','Alt telefon',0),(318101,8837,'pl','Alt telefon',0),(318102,8837,'bg','ALT Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(318103,8837,'ur','Alt ÙÙˆÙ†',0),(318104,8837,'sr','Ð”Ñ€ÑƒÐ³Ð¸ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(318105,8837,'vi','Chá»‰nh sá»­a Phone',0),(318106,8837,'af','Alt. Telefoon',0),(318107,8837,'ro','Alt telefon',0),(318108,8837,'et','Alt telefoni',0),(318109,8837,'si','ALT telefon',0),(318110,8837,'ba','Alt telepon',0),(318111,8837,'nl','ALT telefoon',0),(318112,8837,'fi','Vaihtoehtoinen puhelinnumero',0),(318113,8837,'no','Alt telefon',0),(318114,8837,'da','Alt telefon',0),(318115,8837,'ko','ëŒ€ì²´ ì „í™”',0),(318116,8837,'he','×˜×œ×¤×•×Ÿ',0),(318117,8837,'el','ALT Ï„Î·Î»Î­Ï†Ï‰Î½Î¿',0),(318118,8837,'zh','å¤‡ç”¨ç”µè¯\r\n',0),(318119,8837,'sv','Alt telefon',0),(318120,8837,'it','Telefono Alt',0),(318121,8837,'tl','',0),(318122,8837,'th','&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;&#3607;&#3634;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(318123,8837,'hi','à¤‘à¤²à¥à¤Ÿ à¤«à¥‹à¤¨',0),(318124,8837,'ms','Alt telefon',0),(318125,8837,'ar','Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ø¨Ø¯ÙŠÙ„',0),(318126,8837,'fr','TÃ©lÃ©phone Alt',0),(318127,8837,'jp','Alt ã®é›»è©±',0),(318128,8837,'pt','Telefone Alt',0),(318129,8837,'ru','ÐÐ»ÑŒÑ‚ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(318130,8837,'es','Alt TelÃ©fono',0),(318131,8837,'de','Alt Telefon',0),(318132,8837,'en','Alt Phone',0),(318133,8838,'is','',0),(318134,8838,'dr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯',0),(318135,8838,'pr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯',0),(318136,8838,'tr','DoÄŸum tarihi',0),(318137,8838,'pl','Data urodzenia',0),(318138,8838,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ',0),(318139,8838,'ur','Ø¨Ø§Ø±Ù¹ÛØ¯Ø§Ù¹ÛŒ',0),(318140,8838,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ€Ð¾Ñ’ÐµÑšÐ°',0),(318141,8838,'vi','NgÃ y sinh',0),(318142,8838,'af','Geboortedatum',0),(318143,8838,'ro','Data naÅŸterii',0),(318144,8838,'et','SÃ¼nnipÃ¤ev',0),(318145,8838,'si','Datum rojstva',0),(318146,8838,'ba','Tanggal Lahir',0),(318147,8838,'nl','Geboortedatum',0),(318148,8838,'fi','SyntymÃ¤pÃ¤ivÃ¤',0),(318149,8838,'no','FÃ¸dselsdato',0),(318150,8838,'da','FÃ¸dselsdato',0),(318151,8838,'ko','ìƒë…„ì›”ì¼',0),(318152,8838,'he','×ª××¨×™×š ×œ×™×“×”',0),(318153,8838,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î³Î­Î½Î½Î·ÏƒÎ·Ï‚',0),(318154,8838,'zh','å‡ºç”Ÿæ—¥æœŸ\r\n',0),(318155,8838,'sv','FÃ¶delsedatum',0),(318156,8838,'it','Data di nascita',0),(318157,8838,'tl','',0),(318158,8838,'th','&#3623;&#3633;&#3609;&#3648;&#3585;&#3636;&#3604;',0),(318159,8838,'hi','à¤œà¤¨à¥à¤®à¤¤à¤¿à¤¥à¤¿',0),(318160,8838,'ms','Tarikh lahir',0),(318161,8838,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ÙŠÙ„Ø§Ø¯',0),(318162,8838,'fr','Date de naissance',0),(318163,8838,'jp','ç”Ÿå¹´æœˆæ—¥',0),(318164,8838,'pt','Data de nascimento',0),(318165,8838,'ru','Ð”Ð°Ñ‚Ð° Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(318166,8838,'es','Fecha de Nacimiento',0),(318167,8838,'de','Geburtsdatum',0),(318168,8838,'en','Birthdate',0),(318169,8839,'is','',0),(318170,8839,'dr','ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡',0),(318171,8839,'pr','ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡',0),(318172,8839,'tr','Cep telefonu',0),(318173,8839,'pl','Telefon komÃ³rkowy',0),(318174,8839,'bg','ÐœÐ¾Ð±Ð¸Ð»ÐµÐ½ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(318175,8839,'ur','Ù…ÙˆØ¨Ø§Ø¦Ù„ ÙÙˆÙ†',0),(318176,8839,'sr','ÐœÐ¾Ð±Ð¸Ð»Ð½Ð¸ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(318177,8839,'vi','Äiá»‡n thoáº¡i di Ä‘á»™ng',0),(318178,8839,'af','Selfoon',0),(318179,8839,'ro','Telefon mobil',0),(318180,8839,'et','Mobiiltelefon',0),(318181,8839,'si','Mobitel',0),(318182,8839,'ba','Ponsel',0),(318183,8839,'nl','Mobiele telefoon',0),(318184,8839,'fi','Matkapuhelin',0),(318185,8839,'no','Mobiltelefon',0),(318186,8839,'da','Cell Phone',0),(318187,8839,'ko','íœ´ëŒ€ ì „í™”',0),(318188,8839,'he','×˜×œ×¤×•×Ÿ ×¡×œ×•×œ×¨×™',0),(318189,8839,'el','ÎšÎ¹Î½Î·Ï„ÏŒ Ï„Î·Î»Î­Ï†Ï‰Î½Î¿',0),(318190,8839,'zh','æ‰‹æœº\r\n',0),(318191,8839,'sv','Mobiltelefon',0),(318192,8839,'it','Telefono cellulare',0),(318193,8839,'tl','',0),(318194,8839,'th','&#3617;&#3639;&#3629;&#3606;&#3639;&#3629;',0),(318195,8839,'hi','à¤¸à¥‡à¤² à¤«à¤¼à¥‹à¤¨',0),(318196,8839,'ms','Telefon bimbit',0),(318197,8839,'ar','Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ø®Ù„ÙŠÙˆÙŠ',0),(318198,8839,'fr','TÃ©lÃ©phone cellulaire',0),(318199,8839,'jp','æºå¸¯é›»è©±',0),(318200,8839,'pt','Telefone celular',0),(318201,8839,'ru','ÐœÐ¾Ð±Ð¸Ð»ÑŒÐ½Ñ‹Ð¹ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(318202,8839,'es','TelÃ©fono Celular',0),(318203,8839,'de','Handy',0),(318204,8839,'en','Cell Phone',0),(318205,8840,'is','',0),(318206,8840,'dr','( Ø¢ÙˆÛŒØ²Ù‡Ø§ÛŒ ) ÙƒØ§Ø±Ù…Ù†Ø¯  Ø¬Ù‡Øª ÙˆØ±ÙˆØ¯ ',0),(318207,8840,'pr','Ø³ÙˆØ§Ø¨Ù‚ ( Ù…Ø¯Ø§Ø±Ùƒ ) ÙƒØ§Ø±Ù…Ù†Ø¯  Ø¬Ù‡Øª ÙˆØ±ÙˆØ¯ ',0),(318208,8840,'tr','Personel kayÄ±tlarÄ± alma',0),(318209,8840,'pl','Pracownikach do importu',0),(318210,8840,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(318211,8840,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù„Ø§Ø²Ù… Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(318212,8840,'sr','ÐŸÐ¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ð¼Ð° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(318213,8840,'vi','Danh sÃ¡ch nhÃ¢n viÃªn Ä‘á»ƒ nháº­p',0),(318214,8840,'af','Werknemer Rekords om in te voer',0),(318215,8840,'ro','ÃŽnregistrÄƒrile angajaÅ£ilor pentru Import',0),(318216,8840,'et','TÃ¶Ã¶taja kirjete importimine',0),(318217,8840,'si','Zapisi o zaposlenih za uvoz',0),(318218,8840,'ba','Catatan karyawan untuk impor',0),(318219,8840,'nl','Werknemersrecords importeren',0),(318220,8840,'fi','TyÃ¶ntekijÃ¤tietueita tuo',0),(318221,8840,'no','Ansattposter Importer',0),(318222,8840,'da','Medarbejderposter til Import',0),(318223,8840,'ko','ì§ì› ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(318224,8840,'he','×¨×©×•×ž×•×ª ×¢×•×‘×“×™× ×¢×œ ×™×‘×',0),(318225,8840,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ Ï…Ï€Î±Î»Î»Î®Î»Ï‰Î½ Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(318226,8840,'zh','å‘˜å·¥è®°å½•å¯¼å…¥\r\n',0),(318227,8840,'sv','Medarbetarposter import',0),(318228,8840,'it','Record dei dipendenti per importazione',0),(318229,8840,'tl','',0),(318230,8840,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3648;&#3614;&#3639;&#3656;&#3629;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(318231,8840,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸',0),(318232,8840,'ms','Rekod pekerja Import',0),(318233,8840,'ar','Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ù…ÙˆØ¸Ù Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(318234,8840,'fr','Enregistrements d\'employÃ© Ã  l\'importation',0),(318235,8840,'jp','å¾“æ¥­å“¡ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹',0),(318236,8840,'pt','Registros de funcionÃ¡rios para importaÃ§Ã£o',0),(318237,8840,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð´Ð»Ñ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(318238,8840,'es','Empleado Records para Importar',0),(318239,8840,'de','MitarbeiterdatensÃ¤tze importieren',0),(318240,8840,'en','Employee Records to Import',0),(318241,8841,'is','',0),(318242,8841,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(318243,8841,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(318244,8841,'tr','Ã‡alÄ±ÅŸan tipi',0),(318245,8841,'pl','Typ pracownika',0),(318246,8841,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ñ‚Ð¸Ð¿',0),(318247,8841,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ù‚Ø³Ù…',0),(318248,8841,'sr','Ð¢Ð¸Ð¿ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(318249,8841,'vi','Loáº¡i NhÃ¢n viÃªn',0),(318250,8841,'af','Werknemer Tipe',0),(318251,8841,'ro','Angajat de tip',0),(318252,8841,'et','TÃ¶Ã¶taja tÃ¼Ã¼p',0),(318253,8841,'si','Vrsta delavca',0),(318254,8841,'ba','Jenis karyawan',0),(318255,8841,'nl','Werknemer Type',0),(318256,8841,'fi','TyÃ¶ntekijÃ¤tyyppi',0),(318257,8841,'no','Ansattype',0),(318258,8841,'da','Medarbejdertype',0),(318259,8841,'ko','ì§ì› ìœ í˜•',0),(318260,8841,'he','×¡×•×’ ×¢×•×‘×“',0),(318261,8841,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Ï„ÏÏ€Î¿Ï…',0),(318262,8841,'zh','å‘˜å·¥ç±»åž‹\r\n',0),(318263,8841,'sv','Medarbetartypen',0),(318264,8841,'it','Tipo di dipendente',0),(318265,8841,'tl','',0),(318266,8841,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(318267,8841,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(318268,8841,'ms','Jenis pekerja',0),(318269,8841,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù…ÙˆØ¸Ù',0),(318270,8841,'fr','Type d\'employÃ©',0),(318271,8841,'jp','å¾“æ¥­å“¡ã‚¿ã‚¤ãƒ—',0),(318272,8841,'pt','Tipo de empregado',0),(318273,8841,'ru','Ð¢Ð¸Ð¿ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(318274,8841,'es','Empleado Tipo',0),(318275,8841,'de','Mitarbeitertyp',0),(318276,8841,'en','Employee Type',0),(318277,8842,'is','',0),(318278,8842,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(318279,8842,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(318280,8842,'tr','Gider hesabÄ±',0),(318281,8842,'pl','Koszt konta',0),(318282,8842,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(318283,8842,'ur','Ø®Ø±Ú†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(318284,8842,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(318285,8842,'vi','TK Chi PhÃ­',0),(318286,8842,'af','Uitgawe Rekening',0),(318287,8842,'ro','Cont cheltuialÄƒ',0),(318288,8842,'et','Kulukonto',0),(318289,8842,'si','Konto stroÅ¡kov',0),(318290,8842,'ba','Rekening pengeluaran',0),(318291,8842,'nl','Kostenrekening',0),(318292,8842,'fi','Kulutili',0),(318293,8842,'no','Konto for vedlikeholdsutgifter',0),(318294,8842,'da','Udgiftskonto',0),(318295,8842,'ko','ë¹„ìš© ê³„ì •',0),(318296,8842,'he','×—×©×‘×•×Ÿ ×”×•×¦××•×ª',0),(318297,8842,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÎµÎ¾ÏŒÎ´Ï‰Î½',0),(318298,8842,'zh','è´¹ç”¨å¸æˆ·\r\n',0),(318299,8842,'sv','Utgiftskonto',0),(318300,8842,'it','Conto spese',0),(318301,8842,'tl','',0),(318302,8842,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(318303,8842,'hi','à¤µà¥à¤¯à¤¯ à¤–à¤¾à¤¤à¥‡',0),(318304,8842,'ms','Akaun belanja',0),(318305,8842,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª',0),(318306,8842,'fr','Compte de dÃ©penses',0),(318307,8842,'jp','çµŒè²»å‹˜å®š',0),(318308,8842,'pt','Conta de despesas',0),(318309,8842,'ru','Ð¡Ñ‡ÐµÑ‚ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(318310,8842,'es','Cuenta de Gastos',0),(318311,8842,'de','Aufwandskonto',0),(318312,8842,'en','Expense Account',0),(318313,8843,'is','',0),(318314,8843,'dr','Ø³Ø§Ø¹Ø§Øª Ø¨ÙŠÙ…Ø§Ø±ÙŠ Ø¬Ù…Ø¹ Ø´Ø¯Ù‡',0),(318315,8843,'pr','Ø³Ø§Ø¹Ø§Øª Ø¨ÙŠÙ…Ø§Ø±ÙŠ Ø¬Ù…Ø¹ Ø´Ø¯Ù‡',0),(318316,8843,'tr','Hasta saatler tahakkuk',0),(318317,8843,'pl','Chore godziny naliczone',0),(318318,8843,'bg','Ð‘Ð¾Ð»Ð½Ð¸Ñ‚Ðµ Ñ‡Ð°ÑÐ¾Ð²Ðµ Ð½Ð°Ñ‚Ñ€ÑƒÐ¿Ð°Ð½Ð¸',0),(318319,8843,'ur','Ø§ÙˆÙ‚Ø§Øª ØªÙ…Ø§Ù… ÛÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ø¨ÛŒÙ…Ø§Ø±',0),(318320,8843,'sr','ÐœÑƒÐºÐ° Ð¼Ð¸ Ñ˜Ðµ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ ÑÐ°Ñ‚Ð¸ Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°Ð½Ð¸Ñ…',0),(318321,8843,'vi','Cá»™ng dá»“n giá» nghá»‰ bá»‡nh',0),(318322,8843,'af','Opgeloopte Siek Ure',0),(318323,8843,'ro','Bolnav ore acumulate',0),(318324,8843,'et','Haiguspuhkuse tunde kogunenud',0),(318325,8843,'si','Bolne, ure, obraÄunane',0),(318326,8843,'ba','Sakit jam Diperoleh',0),(318327,8843,'nl','Zieken uren opgebouwde',0),(318328,8843,'fi','Sairas tunteja kertynyt',0),(318329,8843,'no','Syk timer pÃ¥lÃ¸pt',0),(318330,8843,'da','Syge timer periodiseret',0),(318331,8843,'ko','ì•„í”ˆ ì‹œê°„ ë°œìƒ',0),(318332,8843,'he','×—×•×œ×” ×œ×¦×‘×•×¨ ×©×¢×•×ª',0),(318333,8843,'el','Î‘Î½Î±ÏÏÏ‰Ï„Î¹ÎºÎ® Ï„Ï‰Î½ Î´ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Ï‰Î½ Ï‰ÏÏŽÎ½',0),(318334,8843,'zh','ç”Ÿç—…çš„æ—¶é—´ç´¯è®¡\r\n',0),(318335,8843,'sv','Sjuka timmar upplupna',0),(318336,8843,'it','Malati ore maturati',0),(318337,8843,'tl','',0),(318338,8843,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3611;&#3656;&#3623;&#3618;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3604;&#3586;&#3638;&#3657;&#3609;',0),(318339,8843,'hi','à¤¬à¥€à¤®à¤¾à¤° à¤¸à¤®à¤¯ à¤¤à¤• à¤…à¤°à¥à¤œà¤¿à¤¤',0),(318340,8843,'ms','Sakit waktu terakru',0),(318341,8843,'ar','Ø§Ù„Ù…Ø±Ø¶ÙŠØ© Ø§Ù„Ù…ØªØ±Ø§ÙƒÙ…Ø© Ø³Ø§Ø¹Ø§Øª',0),(318342,8843,'fr','Malades heures accumulÃ©es',0),(318343,8843,'jp','ç—…æ°—ã®çµŒéŽæ™‚é–“',0),(318344,8843,'pt','Doente horas acumuladas',0),(318345,8843,'ru','Ð‘Ð¾Ð»ÑŒÐ½Ñ‹Ñ… Ñ‡Ð°ÑÑ‹ Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÑŽÑ‚ÑÑ',0),(318346,8843,'es','Horas Enfermo Acumulada',0),(318347,8843,'de','Kranken Stunden angefallen',0),(318348,8843,'en','Sick Hours Accrued',0),(318349,8844,'is','',0),(318350,8844,'dr','( Ø¯ÙØ§ØªØ± ) Ø¯Ø± Ø§ÙŠÙ† Ø³Ø§ÙØª ÙˆÛŒØ± ',0),(318351,8844,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯ ( Ø¯ÙØ§ØªØ± ) Ø¯Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ',0),(318352,8844,'tr','Sisteme kayÄ±t alma hatasÄ±',0),(318353,8844,'pl','BÅ‚Ä…d importowania rekordÃ³w do systemu',0),(318354,8844,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(318355,8844,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ù†Ø¸Ø§Ù… Ù…ÛŒÚº Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ØªÛ’ ÛÙˆÛ“ Ù†Ù‚Øµ',0),(318356,8844,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ²Ð¾Ð·Ñƒ Ð·Ð°Ð¿Ð¸ÑÐ° Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼',0),(318357,8844,'vi','Lá»—i khi nháº­p dá»¯ liá»‡u vÃ o NolaPro',0),(318358,8844,'af','Fout met Invoer van Rekords Binne NolaPro',0),(318359,8844,'ro','Eroare importul de Ã®nregistrÄƒri Ã®n sistem',0),(318360,8844,'et','Andmete importimisel NolaPro-sse ilmnes viga',0),(318361,8844,'si','Napaka pri uvozu zapise v sistem',0),(318362,8844,'ba','Kesalahan mengimpor data ke dalam sistem',0),(318363,8844,'nl','Fout Records te importeren in systeem',0),(318364,8844,'fi','Virhe tuotaessa tietueiden jÃ¤rjestelmÃ¤Ã¤n',0),(318365,8844,'no','Feil importerer poster i systemet',0),(318366,8844,'da','Fejl importerer poster i systemet',0),(318367,8844,'ko','ì‹œìŠ¤í…œìœ¼ë¡œ ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸° ì˜¤ë¥˜',0),(318368,8844,'he','×©×’×™××ª ×™×™×‘×•× ×¨×©×•×ž×•×ª ×œ×ª×•×š ×”×ž×¢×¨×›×ª',0),(318369,8844,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ ÏƒÎµ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(318370,8844,'zh','é”™è¯¯å¯¼å…¥è®°å½•åˆ°ç³»ç»Ÿ',0),(318371,8844,'sv','Fel importerar poster i systemet',0),(318372,8844,'it','Errore durante l\'importazione di record nel sistema',0),(318373,8844,'tl','',0),(318374,8844,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;&#3651;&#3609; NolaPro',0),(318375,8844,'hi','à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤®à¥‡à¤‚ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(318376,8844,'ms','Ralat mengimport rekod ke dalam sistem',0),(318377,8844,'ar','Ø®Ø·Ø£ Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ø¥Ù„Ù‰ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(318378,8844,'fr','Erreur importation de dossiers dans le systÃ¨me',0),(318379,8844,'jp','ã‚·ã‚¹ãƒ†ãƒ ã¸ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ã‚¨ãƒ©ãƒ¼',0),(318380,8844,'pt','Erro ao importar registros no sistema',0),(318381,8844,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ðµ Ð—Ð°Ð¿Ð¸ÑÐµÐ¹ Ð’ NolaPro',0),(318382,8844,'es','Error Importando Records a NolaPro',0),(318383,8844,'de','Fehler beim Importieren von DatensÃ¤tzen in System',0),(318384,8844,'en','Error Importing Records Into System',0),(318385,8845,'is','',0),(318386,8845,'dr','(Ø³ÙˆØ§Ø¨Ù‚) Ù¾ÙŠØ¯Ø§ Ø´Ø¯ ',0),(318387,8845,'pr','Ø§Ø³Ù†Ø§Ø¯ (Ø³ÙˆØ§Ø¨Ù‚) Ù¾ÙŠØ¯Ø§ Ø´Ø¯ ',0),(318388,8845,'tr','KayÄ±t bulundu',0),(318389,8845,'pl','Znaleziono rekordÃ³w',0),(318390,8845,'bg','ÐÐ°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ°',0),(318391,8845,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ù…Ù„Ø§ ÛÛ’',0),(318392,8845,'sr','ÐŸÑ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð¸Ñ… Ð·Ð°Ð¿Ð¸ÑÐ°',0),(318393,8845,'vi','TÃ¬m tháº¥y há»“ sÆ¡',0),(318394,8845,'af','Rekords Gevind',0),(318395,8845,'ro','Inregistrari gasite',0),(318396,8845,'et','Leitud dokumendid',0),(318397,8845,'si','Zapisov, najdeni',0),(318398,8845,'ba','Catatan di Temukan',0),(318399,8845,'nl','Records zijn gevonden',0),(318400,8845,'fi','MerkintÃ¤Ã¤ lÃ¶ytynyt',0),(318401,8845,'no','Finner poster',0),(318402,8845,'da','Oplysninger fundet',0),(318403,8845,'ko','ë ˆì½”ë“œê°€ ì—†ìŠµë‹ˆë‹¤.',0),(318404,8845,'he','× ×ž×¦××• ×¨×©×•×ž×•×ª',0),(318405,8845,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(318406,8845,'zh','æ‰¾åˆ°è®°å½•\r\n',0),(318407,8845,'sv','Hittade poster',0),(318408,8845,'it','Record trovati',0),(318409,8845,'tl','',0),(318410,8845,'th','&#3614;&#3610;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;',0),(318411,8845,'hi','à¤…à¤­à¤¿à¤²à¥‡à¤– à¤ªà¤¾à¤',0),(318412,8845,'ms','Rekod-rekod yang dijumpai',0),(318413,8845,'ar','ØªÙˆØ¬Ø¯ Ø³Ø¬Ù„Ù‘Ø§Øª',0),(318414,8845,'fr','Enregistrements trouvÃ©s',0),(318415,8845,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸã€‚',0),(318416,8845,'pt','Registros encontrados',0),(318417,8845,'ru','ÐÐ°Ð¹Ð´ÐµÐ½Ð¾ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(318418,8845,'es','Records Se EncontrÃ³',0),(318419,8845,'de','DatensÃƒ Â¤ tze gefunden',0),(318420,8845,'en','Records Found',0),(318421,8846,'is','',0),(318422,8846,'dr','(Ø³ÙˆØ§Ø¨Ù‚) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(318423,8846,'pr','Ø§Ø³Ù†Ø§Ø¯ (Ø³ÙˆØ§Ø¨Ù‚) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(318424,8846,'tr','BaÅŸarÄ±yla alÄ±nan kayÄ±tlar',0),(318425,8846,'pl','Rekordy zostaÅ‚y zaimportowane pomyÅ›lnie',0),(318426,8846,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(318427,8846,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯',0),(318428,8846,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸',0),(318429,8846,'vi','Nháº­p thÃ nh cÃ´ng',0),(318430,8846,'af','Rekords Is Suksesvol Ingevoer',0),(318431,8846,'ro','ÃŽnregistrÄƒrile importat cu succes',0),(318432,8846,'et','Imporditud kirjed',0),(318433,8846,'si','UspeÅ¡no uvoÅ¾eni zapisi',0),(318434,8846,'ba','Catatan yang berhasil diimpor',0),(318435,8846,'nl','Records geÃ¯mporteerd',0),(318436,8846,'fi','Tietueiden tuonti onnistui',0),(318437,8846,'no','Poster importert',0),(318438,8846,'da','Poster, der importeres med succes',0),(318439,8846,'ko','ì„±ê³µì ìœ¼ë¡œ ê°€ì ¸ì˜¨ ë ˆì½”ë“œ',0),(318440,8846,'he','×¨×©×•×ž×•×ª ×™×•×‘××• ×‘×”×¦×œ×—×”',0),(318441,8846,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(318442,8846,'zh','æˆåŠŸå¯¼å…¥è®°å½•\r\n',0),(318443,8846,'sv','Poster har importerats',0),(318444,8846,'it','Record importato correttamente',0),(318445,8846,'tl','',0),(318446,8846,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(318447,8846,'hi','à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤¯à¤¾à¤¤',0),(318448,8846,'ms','Rekod-rekod yang berjaya diimport',0),(318449,8846,'ar','Ø£Ø³ØªÙŠØ±Ø¯Øª Ø§Ù„Ø³Ø¬Ù„Ù‘Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(318450,8846,'fr','Enregistrements importÃ©s avec succÃ¨s',0),(318451,8846,'jp','æ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚ŒãŸãƒ¬ã‚³ãƒ¼ãƒ‰',0),(318452,8846,'pt','Registros importados com Ãªxito',0),(318453,8846,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(318454,8846,'es','Records Importados Exitosamente',0),(318455,8846,'de','DatensÃ¤tze, die erfolgreich importiert',0),(318456,8846,'en','Records Imported Successfully',0),(318457,8847,'is','',0),(318458,8847,'dr','.',0),(318459,8847,'pr','Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù‚Ø¯Ø§Ù…  Ù„Ø·ÙØ§ Ù¾ÙŠØ´ ÙØ±Ù Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ø¨Ø§ ÙƒÙ„ÙŠÙƒ ÙƒØ±Ø¯Ù† Ù„ÙŠÙ†Ùƒ Ù‡Ø§ÙŠ Ø²ÙŠØ±  Ø¨Ù‡ Ø±ÙˆØ² ÙƒÙ†ÙŠØ¯.',0),(318460,8847,'tr','Devam etmeden Ã¶nce lÃ¼tfen aÅŸaÄŸÄ±daki linkleri tÄ±klayarak varsayÄ±lan GL hesaplarÄ±nÄ± gÃ¼ncelleÅŸtirir.',0),(318461,8847,'pl','Przed przystÄ…pieniem, ProszÄ™ zaktualizowaÄ‡ GL domyÅ›lnych kont klikajÄ…c na poniÅ¼sze linki.',0),(318462,8847,'bg','ÐŸÑ€ÐµÐ´Ð¸ Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸Ñ‚Ðµ, Ð¼Ð¾Ð»Ñ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ GL ÑÐ¼ÐµÑ‚ÐºÐ¸ ÐºÐ°Ñ‚Ð¾ ÐºÐ»Ð¸ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð²Ñ€ÑŠÐ·ÐºÐ¸Ñ‚Ðµ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ.',0),(318463,8847,'ur','Ø¢Ú¯Û’ Ø¨Ú‘Ú¾Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ø·Û’ Ø´Ø¯Û Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ù†ÛŒÚ†Û’ Ø¯ÛŒØ¦Û’ Ú¯Ø¦Û’ Ù„Ù†Ú©Ø³ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±Ú©Û’ ØªØ§Ø²Û Ú©Ø±ÛŒÚº Û”',0),(318464,8847,'sr','ÐŸÑ€Ð¸Ñ˜Ðµ Ð½ÐµÐ³Ð¾ ÑˆÑ‚Ð¾ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ, Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð› ÐºÐ»Ð¸ÐºÐ¾Ð¼ Ð½Ð° Ð»Ð¸Ð½ÐºÐ¾Ð²Ðµ Ð¸ÑÐ¿Ð¾Ð´.',0),(318465,8847,'vi','Vui lÃ²ng nháº¥n vÃ o Ä‘Æ°á»ng dáº«n dÆ°á»›i Ä‘Ã¢y Ä‘á»ƒ cáº­p nháº­t TK Sá»• CÃ¡i Tá»•ng Há»£p Máº·c Äá»‹nh trÆ°á»›c khi xá»­ lÃ½. ',0),(318466,8847,'af','Alvorens u verder gaan, opdateer asb. die verstekte AG Rekeninge deur op die skakels hieronder te kliek.',0),(318467,8847,'ro','ÃŽnainte de a continua, vÄƒ rugÄƒm sÄƒ actualizaÅ£i conturi de GL implicit fÄƒcÃ¢nd clic pe linkurile de mai jos.',0),(318468,8847,'et','Ennem jÃ¤tkamist palun uuenda alljÃ¤rgnevaid pearaamatu kontosid',0),(318469,8847,'si','Preden nadaljujete, posodobite privzete GL raÄunov s klikom na spodnje povezave.',0),(318470,8847,'ba','Sebelum melanjutkan, perbarui default GL akun dengan mengeklik tautan di bawah.',0),(318471,8847,'nl','Voordat u verdergaat, kunt u bijwerken GL standaardaccounts door te klikken op de links hieronder.',0),(318472,8847,'fi','Ennen kuin jatkat, PÃ¤ivitÃ¤ GL oletustilit klikkaamalla alla olevia linkkejÃ¤.',0),(318473,8847,'no','FÃ¸r du fortsetter, mÃ¥ du oppdatere standard GL kontoer ved Ã¥ klikke pÃ¥ linkene nedenfor.',0),(318474,8847,'da','FÃ¸r du fortsÃ¦tter, skal du opdatere standard GL konti ved at klikke pÃ¥ nedenstÃ¥ende links.',0),(318475,8847,'ko','ê³„ì† í•˜ê¸° ì „ì— ì•„ëž˜ ë§í¬ë¥¼ í´ë¦­ í•˜ ì—¬ ê¸°ë³¸ GL ê³„ì •ì„ ì—…ë°ì´íŠ¸ í•˜ì‹­ì‹œì˜¤.',0),(318476,8847,'he','×œ×¤× ×™ ×©×ª×ž×©×™×š, × × ×œ×¢×“×›×Ÿ ×—×©×‘×•× ×•×ª GL ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×œ ×™×“×™ ×œ×—×™×¦×” ×¢×œ ×”×§×™×©×•×¨×™× ×©×œ×”×œ×Ÿ.',0),(318477,8847,'el','Î ÏÎ¹Î½ Ï€ÏÎ¿Ï‡Ï‰ÏÎ®ÏƒÎµÏ„Îµ, ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÏ„Îµ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ GL ÎºÎ¬Î½Î¿Î½Ï„Î±Ï‚ ÎºÎ»Î¹Îº ÏƒÏ„Î¿Ï…Ï‚ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ ÏƒÏ…Î½Î´Î­ÏƒÎ¼Î¿Ï…Ï‚.',0),(318478,8847,'zh','åœ¨ç»§ç»­ä¹‹å‰ï¼Œè¯·ç‚¹å‡»ä¸‹é¢çš„é“¾æŽ¥æ›´æ–°é»˜è®¤æ€»å¸å¸æˆ·ã€‚\r\n',0),(318479,8847,'sv','Innan du fortsÃ¤tter uppdatera standard GL konton genom att klicka pÃ¥ lÃ¤nkarna nedan.',0),(318480,8847,'it','Prima di procedere, si prega di aggiornare conti GL predefinita facendo clic sul link qui sotto.',0),(318481,8847,'tl','',0),(318482,8847,'th','Before proceeding, please update default GL Accounts by clicking on the links below.',0),(318483,8847,'hi','à¤†à¤—à¥‡ à¤¬à¤¢à¤¼à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡, à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ à¤²à¤¿à¤‚à¤• à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¤•à¥‡ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚à¥¤',0),(318484,8847,'ms','Sebelum meneruskan, sila Kemaskini akaun GL lalai dengan klik pada pautan di bawah.',0),(318485,8847,'ar','Ù‚Ø¨Ù„ Ø§Ù„Ù…ØªØ§Ø¨Ø¹Ø©ØŒ Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª GL Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¨Ø§Ù„Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø© Ø£Ø¯Ù†Ø§Ù‡.',0),(318486,8847,'fr','Avant de poursuivre, veuillez mettre Ã  jour comptes GL par dÃ©faut en cliquant sur les liens ci-dessous.',0),(318487,8847,'jp','é€²ã‚€å‰ã«ã€ä»¥ä¸‹ã®ãƒªãƒ³ã‚¯ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦æ—¢å®šã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’æ›´æ–°ã—ã¦ãã ã•ã„ã€‚',0),(318488,8847,'pt','Antes de prosseguir, por favor, atualize o padrÃ£o GL contas clicando nos links abaixo.',0),(318489,8847,'ru','ÐŸÑ€ÐµÐ¶Ð´Ðµ Ñ‡ÐµÐ¼ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÑŒ, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚Ðµ GL ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ, Ð½Ð°Ð¶Ð°Ð² Ð½Ð° ÑÑÑ‹Ð»ÐºÐ¸ Ð½Ð¸Ð¶Ðµ.',0),(318490,8847,'es','Antes que proceder, por favor actualizar cuentas de LM por defecto por hacer click en los enlaces abajo',0),(318491,8847,'de','Bevor Sie fortfahren, bitte aktualisieren Sie Standard-GL-Konten durch Klicken auf die unten stehenden Links.',0),(318492,8847,'en','Before proceeding, please update default GL Accounts by clicking on the links below.',0),(318493,8848,'is','',0),(318494,8848,'dr','Ø¯ÙØ§ØªØ± Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(318495,8848,'pr','Ø¯ÙØ§ØªØ± Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(318496,8848,'tr','GL firma kayÄ±tlarÄ± alma',0),(318497,8848,'pl','GL zapisy kont do importu',0),(318498,8848,'bg','GL Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(318499,8848,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(318500,8848,'sr','Ð“Ð› Ð·Ð°Ð¿Ð¸ÑÐ¸Ð¼Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(318501,8848,'vi','Giao Dá»‹ch TK Sá»• CÃ¡i Tá»•ng Há»£p Chá» Káº¿t Chuyá»ƒn',0),(318502,8848,'af','AG Rekening rekords vir Invoering',0),(318503,8848,'ro','GL cont Ã®nregistrÄƒrile la Import',0),(318504,8848,'et','GL kontole kirjete importimine',0),(318505,8848,'si','GL raÄun zapisov za uvoz',0),(318506,8848,'ba','Catatan akun GL impor',0),(318507,8848,'nl','GL accountrecords te importeren',0),(318508,8848,'fi','GL asiakastietueeseen tuonti',0),(318509,8848,'no','GL forretningsforbindelsesoppfÃ¸ringer Importer',0),(318510,8848,'da','GL firmaposter til Import',0),(318511,8848,'ko','GL ê³„ì • ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(318512,8848,'he','GL ×¨×©×•×ž×•×ª ×ª×™×§ ×œ×§×•×— ×¢×œ ×™×‘×',0),(318513,8848,'el','GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î±ÏÏ‡ÎµÎ¯Î± Ï€ÏÎ¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(318514,8848,'zh','æ€»å¸å¸æˆ·æ±‡å…¥çš„çºªå½•\r\n',0),(318515,8848,'sv','GL kontoposter import',0),(318516,8848,'it','GL conto record di importazione',0),(318517,8848,'tl','',0),(318518,8848,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(318519,8848,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(318520,8848,'ms','Rekod-rekod akaun GL untuk Import',0),(318521,8848,'ar','Ø³Ø¬Ù„Ù‘Ø§Øª Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ù„Ù„Ø¥Ø³ØªÙŠØ±Ø§Ø¯',0),(318522,8848,'fr','Enregistrements compte GL d\'importation',0),(318523,8848,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹',0),(318524,8848,'pt','Registros de conta GL para importaÃ§Ã£o',0),(318525,8848,'ru','GL ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(318526,8848,'es','Cuenta LM Records para Importar',0),(318527,8848,'de','GL Konto DatensÃ¤tze importieren',0),(318528,8848,'en','GL Account Records to Import',0),(318529,8849,'is','',0),(318530,8849,'dr','NolaPro Ù†Ù…ÙˆÙ†Ù‡',0),(318531,8849,'pr','NolaPro Ù†Ù…ÙˆÙ†Ù‡',0),(318532,8849,'tr','Sistem modÃ¼lÃ¼',0),(318533,8849,'pl','ModuÅ‚ systemu',0),(318534,8849,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼ÐµÐ½ Ð¼Ð¾Ð´ÑƒÐ»',0),(318535,8849,'ur','Ù†Ø¸Ø§Ù… Ù…Ø§ÚˆÛŒÙˆÙ„',0),(318536,8849,'sr','Ð¡Ð¸ÑÑ‚ÐµÐ¼ Ð¼Ð¾Ð´ÑƒÐ»Ð°',0),(318537,8849,'vi','Module NolaPro',0),(318538,8849,'af','NolaPro Module',0),(318539,8849,'ro','Sistemului modulul',0),(318540,8849,'et','Moodul',0),(318541,8849,'si','Modul sistema',0),(318542,8849,'ba','Sistem modul',0),(318543,8849,'nl','Systeemmodule',0),(318544,8849,'fi','Moduuli',0),(318545,8849,'no','Systemmodul',0),(318546,8849,'da','System modul',0),(318547,8849,'ko','ì‹œìŠ¤í…œ ëª¨ë“ˆ',0),(318548,8849,'he','×ž×•×“×•×œ ×ž×¢×¨×›×ª',0),(318549,8849,'el','Î•Î½ÏŒÏ„Î·Ï„Î± ÏƒÏÏƒÏ„Î·Î¼Î±',0),(318550,8849,'zh','ç³»ç»Ÿæ¨¡å—\r\n',0),(318551,8849,'sv','System modul',0),(318552,8849,'it','Sistema modulo',0),(318553,8849,'tl','',0),(318554,8849,'th','&#3650;&#3617;&#3604;&#3641;&#3621; NolaPro ',0),(318555,8849,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤²',0),(318556,8849,'ms','Modul sistem',0),(318557,8849,'ar','Ø§Ù„ÙˆØ­Ø¯Ø© Ø§Ù„Ù†Ù…Ø·ÙŠØ© Ù„Ù„Ù†Ø¸Ø§Ù…',0),(318558,8849,'fr','Module systÃ¨me',0),(318559,8849,'jp','ã‚·ã‚¹ãƒ†ãƒ  ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«',0),(318560,8849,'pt','MÃ³dulo de sistema',0),(318561,8849,'ru','ÐœÐ¾Ð´ÑƒÐ»ÑŒ NolaPro',0),(318562,8849,'es','NolaPro MÃ³dulo',0),(318563,8849,'de','Systemmodul',0),(318564,8849,'en','System Module',0),(318565,8850,'is','',0),(318566,8850,'dr','NolaPro Ù†ÙˆØ¹',0),(318567,8850,'pr','NolaPro Ù†ÙˆØ¹',0),(318568,8850,'tr','Sistem tÃ¼rÃ¼',0),(318569,8850,'pl','Typ systemu',0),(318570,8850,'bg','Ð¢Ð¸Ð¿ Ð½Ð° ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(318571,8850,'ur','Ù†Ø¸Ø§Ù… Ù‚Ø³Ù…',0),(318572,8850,'sr','Ð¢Ð¸Ð¿ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(318573,8850,'vi','Loáº¡i NolaPro',0),(318574,8850,'af','NolaPro Tipe',0),(318575,8850,'ro','Tipul de sistem',0),(318576,8850,'et','SÃ¼steemi tÃ¼Ã¼p',0),(318577,8850,'si','Vrsta sistema',0),(318578,8850,'ba','Jenis sistem',0),(318579,8850,'nl','Systeemtype',0),(318580,8850,'fi','JÃ¤rjestelmÃ¤n tyyppi',0),(318581,8850,'no','Systemtype',0),(318582,8850,'da','Systemtype',0),(318583,8850,'ko','ì‹œìŠ¤í…œ ì¢…ë¥˜',0),(318584,8850,'he','×¡×•×’ ×ž×¢×¨×›×ª',0),(318585,8850,'el','Î¤ÏÏ€Î¿Ï‚ ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚',0),(318586,8850,'zh','ç³»ç»Ÿç±»åž‹\r\n\r\n',0),(318587,8850,'sv','Systemtyp',0),(318588,8850,'it','Tipo di sistema',0),(318589,8850,'tl','',0),(318590,8850,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607; NolaPro ',0),(318591,8850,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤ªà¥à¤°à¤•à¤¾à¤°',0),(318592,8850,'ms','Jenis sistem',0),(318593,8850,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(318594,8850,'fr','Type de systÃ¨me',0),(318595,8850,'jp','ã‚·ã‚¹ãƒ†ãƒ ã®ç¨®é¡ž',0),(318596,8850,'pt','Tipo de sistema',0),(318597,8850,'ru','Ð¢Ð¸Ð¿ NolaPro',0),(318598,8850,'es','NolaPro Tipo',0),(318599,8850,'de','Systemtyp',0),(318600,8850,'en','System Type',0),(318601,8851,'is','',0),(318602,8851,'dr','Ù†ÙˆØ¹ ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹',0),(318603,8851,'pr','Ù†ÙˆØ¹ ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹',0),(318604,8851,'tr','QuickBooks tÃ¼rÃ¼',0),(318605,8851,'pl','Typ QuickBooks',0),(318606,8851,'bg','QuickBooks Ñ‚Ð¸Ð¿',0),(318607,8851,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù…',0),(318608,8851,'sr','QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ Ñ‚Ð¸Ð¿',0),(318609,8851,'vi','Loáº¡i QuickBooks',0),(318610,8851,'af','QuickBooks Tipe',0),(318611,8851,'ro','QuickBooks tip',0),(318612,8851,'et','QuickBooks-i tÃ¼Ã¼p',0),(318613,8851,'si','QuickBooks tipa',0),(318614,8851,'ba','Jenis QuickBooks',0),(318615,8851,'nl','QuickBooks Type',0),(318616,8851,'fi','QuickBooks tyyppi',0),(318617,8851,'no','QuickBooks Type',0),(318618,8851,'da','QuickBooks Type',0),(318619,8851,'ko','QuickBooks ìœ í˜•',0),(318620,8851,'he','×¡×•×’ QuickBooks',0),(318621,8851,'el','QuickBooks Ï„ÏÏ€Î¿Ï…',0),(318622,8851,'zh','QuickBooksçš„ç±»åž‹\r\n',0),(318623,8851,'sv','QuickBooks typ',0),(318624,8851,'it','QuickBooks tipo',0),(318625,8851,'tl','',0),(318626,8851,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3641;&#3656;&#3617;&#3639;&#3629;&#3648;&#3619;&#3656;&#3591;&#3604;&#3656;&#3623;&#3609;',0),(318627,8851,'hi','QuickBooks à¤ªà¥à¤°à¤•à¤¾à¤°',0),(318628,8851,'ms','Jenis QuickBooks',0),(318629,8851,'ar','Ù†ÙˆØ¹ Ù‚Ø±Ø§Ø¡',0),(318630,8851,'fr','Type de QuickBooks',0),(318631,8851,'jp','QuickBooks ã®ç¨®é¡ž',0),(318632,8851,'pt','Tipo de QuickBooks',0),(318633,8851,'ru','Ð¢Ð¸Ð¿ QuickBooks',0),(318634,8851,'es','Tipo de Quickbooks',0),(318635,8851,'de','QuickBooks-Typ',0),(318636,8851,'en','QuickBooks Type',0),(318637,8852,'is','',0),(318638,8852,'dr','Ø­Ø³Ø§Ø¨ Ø®Ù„Ø§ØµÙ‡ ',0),(318639,8852,'pr','Ø­Ø³Ø§Ø¨ Ø®Ù„Ø§ØµÙ‡ ',0),(318640,8852,'tr','Hesap Ã–zeti',0),(318641,8852,'pl','Podsumowanie konta',0),(318642,8852,'bg','Ð ÐµÐºÐ°Ð¿Ð¸Ñ‚ÑƒÐ»Ð°Ñ†Ð¸Ñ',0),(318643,8852,'ur','Ø®Ù„Ø§ØµÛ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(318644,8852,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(318645,8852,'vi','Tá»•ng Há»£p TK',0),(318646,8852,'af','Opsommingsrekening',0),(318647,8852,'ro','Rezumat cont',0),(318648,8852,'et','Summakonto',0),(318649,8852,'si','Povzetek raÄuna',0),(318650,8852,'ba','Ringkasan Rekening',0),(318651,8852,'nl','Samenvattende rekening',0),(318652,8852,'fi','Reskontratili',0),(318653,8852,'no','Samlekonto',0),(318654,8852,'da','Samlekonto',0),(318655,8852,'ko','ìš”ì•½ ê³„ì •',0),(318656,8852,'he','×¡×™×›×•× ×—×©×‘×•×Ÿ',0),(318657,8852,'el','Î‘Î½Î±ÎºÎµÏ†Î±Î»Î±Î¹Ï‰Ï„Î¹ÎºÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚',0),(318658,8852,'zh','æ±‡æ€»å¸æˆ·\r\n',0),(318659,8852,'sv','Samlingskonto',0),(318660,8852,'it','Conto riepilogativo',0),(318661,8852,'tl','',0),(318662,8852,'th','&#3626;&#3619;&#3640;&#3611;&#3610;&#3637;&#3597;&#3594;&#3637;',0),(318663,8852,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(318664,8852,'ms','Ringkasan akaun',0),(318665,8852,'ar','Ù…Ù„Ø®Øµ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(318666,8852,'fr','Compte collectif',0),(318667,8852,'jp','é›†è¨ˆå‹˜å®š',0),(318668,8852,'pt','Conta Resumo',0),(318669,8852,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ ÑÑ‡ÐµÑ‚',0),(318670,8852,'es','Cuenta Sumarizada',0),(318671,8852,'de','Sammelkonto',0),(318672,8852,'en','Summary Account',0),(318673,8853,'is','',0),(318674,8853,'dr','Ø´Ø±Ø­ ÙÙ‡Ø±Ø³Øª',0),(318675,8853,'pr','Ø´Ø±Ø­ ÙÙ‡Ø±Ø³Øª',0),(318676,8853,'tr','Katalog aÃ§Ä±klamasÄ±',0),(318677,8853,'pl','Â«KatalogÂ» opis',0),(318678,8853,'bg','ÐšÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(318679,8853,'ur','Ú©ÛŒÙ¹Ù„Ø§Ú¯ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(318680,8853,'sr','ÐžÐ¿Ð¸Ñ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³',0),(318681,8853,'vi','MÃ´ táº£ Catalog',0),(318682,8853,'af','Katalogus Beskrywing',0),(318683,8853,'ro','Descriere catalog',0),(318684,8853,'et','Kataloogi kirjeldus',0),(318685,8853,'si','Katalog opis',0),(318686,8853,'ba','Deskripsi Katalog',0),(318687,8853,'nl','Catalogus beschrijving',0),(318688,8853,'fi','Luettelon kuvaus',0),(318689,8853,'no','Katalogen beskrivelse',0),(318690,8853,'da','Forside beskrivelse',0),(318691,8853,'ko','ì¹´íƒˆë¡œê·¸ ì„¤ëª…',0),(318692,8853,'he','×ª×™××•×¨ ×§×˜×œ×•×’',0),(318693,8853,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(318694,8853,'zh','ç›®å½•è¯´æ˜Ž\r\n',0),(318695,8853,'sv','Katalogen Beskrivning',0),(318696,8853,'it','Descrizione del catalogo',0),(318697,8853,'tl','',0),(318698,8853,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3649;&#3588;&#3655;&#3605;&#3605;&#3634;&#3621;&#3655;&#3629;&#3585;',0),(318699,8853,'hi','à¤•à¥ˆà¤Ÿà¤²à¥‰à¤— à¤µà¤¿à¤µà¤°à¤£',0),(318700,8853,'ms','Keterangan Katalog',0),(318701,8853,'ar','ÙˆØµÙ Ø§Ù„Ù†Ø´Ø±Ø© Ø§Ù„Ù…ØµÙˆØ±Ø©',0),(318702,8853,'fr','Description du catalogue',0),(318703,8853,'jp','ã‚«ã‚¿ãƒ­ã‚°ã®èª¬æ˜Ž',0),(318704,8853,'pt','DescriÃ§Ã£o de catÃ¡logo',0),(318705,8853,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐšÐ°Ñ‚Ð°Ð»Ð¾Ð³Ð°',0),(318706,8853,'es','DescripciÃ³n de CatÃ¡logo',0),(318707,8853,'de','Katalogbeschreibung',0),(318708,8853,'en','Catalog Description',0),(318709,8854,'is','',0),(318710,8854,'dr','Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(318711,8854,'pr','Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(318712,8854,'tr','Fatura hesabÄ±',0),(318713,8854,'pl','Konto inv',0),(318714,8854,'bg','INV ÑÐ¼ÐµÑ‚ÐºÐ°',0),(318715,8854,'ur','Ø§Ù†Ùˆ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(318716,8854,'sr','Ð˜Ð½Ð² Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(318717,8854,'vi','TK HÃ ng Tá»“n Kho',0),(318718,8854,'af','Fakt Rekening',0),(318719,8854,'ro','Cont de inv',0),(318720,8854,'et','Inv konto',0),(318721,8854,'si','Inv raÄun',0),(318722,8854,'ba','INV Account',0),(318723,8854,'nl','INV Account',0),(318724,8854,'fi','Laskun tili',0),(318725,8854,'no','Inv-konto',0),(318726,8854,'da','Inv konto',0),(318727,8854,'ko','Inv ê³„ì •',0),(318728,8854,'he','×—×©×‘×•×Ÿ Inv',0),(318729,8854,'el','Inv Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(318730,8854,'zh','å‘ç¥¨å¸æˆ·\r\n',0),(318731,8854,'sv','Inv konto',0),(318732,8854,'it','Conto inv',0),(318733,8854,'tl','',0),(318734,8854,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(318735,8854,'hi','Inv à¤–à¤¾à¤¤à¥‡',0),(318736,8854,'ms','Akaun songsang',0),(318737,8854,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø§Ø³ØªØ«Ù…Ø§Ø±Ø§Øª',0),(318738,8854,'fr','Inv compte',0),(318739,8854,'jp','æœ¬æŠ•è³‡æ³•äººã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(318740,8854,'pt','Conta de inv',0),(318741,8854,'ru','Ð¡Ñ‡ÐµÑ‚ Inv',0),(318742,8854,'es','Cuenta de Inv.',0),(318743,8854,'de','Inv-Konto',0),(318744,8854,'en','Inv Account',0),(318745,8855,'is','',0),(318746,8855,'dr','Ø§Ø³Ù†Ø§Ø¯  ÙƒØ§Ù„Ø§ Ø¬Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(318747,8855,'pr','Ø§Ø³Ù†Ø§Ø¯  ÙƒØ§Ù„Ø§ Ø¬Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(318748,8855,'tr','Madde kayÄ±tlarÄ± alma',0),(318749,8855,'pl','Element rekordÃ³w do importu',0),(318750,8855,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(318751,8855,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ø´Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(318752,8855,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð·Ð°Ð¿Ð¸ÑÐ° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(318753,8855,'vi','Danh sÃ¡ch hÃ ng Ä‘á»ƒ nháº­p',0),(318754,8855,'af','Item Rekords vir Invoering',0),(318755,8855,'ro','ÃŽnregistrÄƒri element de Import',0),(318756,8855,'et','Kauba kirjete importimine',0),(318757,8855,'si','Element zapisov za uvoz',0),(318758,8855,'ba','Item catatan untuk impor',0),(318759,8855,'nl','Object Records importeren',0),(318760,8855,'fi','Nimiketietueiden tuominen',0),(318761,8855,'no','Vareposter Importer',0),(318762,8855,'da','Punkt poster til Import',0),(318763,8855,'ko','í•­ëª© ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(318764,8855,'he','×¤×¨×™×˜ ×¨×©×•×ž×•×ª ×¢×œ ×™×‘×',0),(318765,8855,'el','Î•Î³Î³ÏÎ±Ï•Î­Ï‚ Î±Î½Ï„Î¹Ï„ÏÏ€Ï‰Î½ Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(318766,8855,'zh','é¡¹ç›®è®°å½•å¯¼å…¥\r\n',0),(318767,8855,'sv','Poster fÃ¶r att importera',0),(318768,8855,'it','Elemento record di importazione',0),(318769,8855,'tl','',0),(318770,8855,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3617;&#3637;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3586;&#3657;&#3634;&#3617;&#3634;&#3648;&#3614;&#3639;&#3656;&#3629;&#3609;&#3635;&#3648;&#3',0),(318771,8855,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤‡à¤Ÿà¤® à¤…à¤­à¤¿à¤²à¥‡à¤–',0),(318772,8855,'ms','Rekod barang Import',0),(318773,8855,'ar','Ø³Ø¬Ù„Ù‘Ø§Øª Ø§Ù„Ø£ØµÙ†Ø§Ù Ù„Ù„Ø¥Ø³ØªÙŠØ±Ø§Ø¯',0),(318774,8855,'fr','Enregistrements d\'article d\'importation',0),(318775,8855,'jp','å“ç›®ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹',0),(318776,8855,'pt','Registros de itens de importaÃ§Ã£o',0),(318777,8855,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(318778,8855,'es','Item Records a Importar',0),(318779,8855,'de','Item-DatensÃ¤tze zu importieren',0),(318780,8855,'en','Item Records to Import',0),(318781,8856,'is','',0),(318782,8856,'dr','(Ø§Ø³Ù†Ø§Ø¯ ) Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø­Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(318783,8856,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ (Ø§Ø³Ù†Ø§Ø¯ ) Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø­Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(318784,8856,'tr','Fiyat dÃ¼zeyi kayÄ±tlarÄ± alma',0),(318785,8856,'pl','Poziom rekordy cenowe do importu',0),(318786,8856,'bg','Ð¦ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(318787,8856,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(318788,8856,'sr','Ð¦ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾Ð° Ð·Ð°Ð¿Ð¸ÑÐ° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(318789,8856,'vi','CÃ¡c má»©c giÃ¡ Ä‘á»ƒ nháº­p',0),(318790,8856,'af','Prysvlakke Rekord vir Invoering',0),(318791,8856,'ro','Pret Ã®nregistrÄƒri nivel de Import',0),(318792,8856,'et','Hind tasemel kirjete importimine',0),(318793,8856,'si','Cena ravni zapisov za uvoz',0),(318794,8856,'ba','Catatan tingkat harga impor',0),(318795,8856,'nl','Prijs niveau Records importeren',0),(318796,8856,'fi','Hinta taso tietueiden tuonti',0),(318797,8856,'no','NivÃ¥ poster skal importeres',0),(318798,8856,'da','Pris niveau poster til Import',0),(318799,8856,'ko','ê°€ê²© ìˆ˜ì¤€ ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(318800,8856,'he','×”×¨×©×•×ž×•×ª ×‘×¨×ž×ª ×ž×—×™×¨ ×¢×œ ×™×‘×',0),(318801,8856,'el','Î¤Î¹Î¼Î® ÎµÏ€Î¯Ï€ÎµÎ´Î¿ ÏÎµÎºÏŒÏ Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(318802,8856,'zh','ä»·æ ¼æ°´å¹³è®°å½•å¯¼å…¥\r\n',0),(318803,8856,'sv','Pris nivÃ¥ poster att importera',0),(318804,8856,'it','Livello record di prezzo all\'importazione',0),(318805,8856,'tl','',0),(318806,8856,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3607;&#3637;&#3656;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(318807,8856,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥€à¤®à¤¤ à¤¤à¤° à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸',0),(318808,8856,'ms','Rekod tahap harga Import',0),(318809,8856,'ar','Ø³Ø¬Ù„Ø§Øª Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(318810,8856,'fr','Documents niveau prix Ã  l\'importation',0),(318811,8856,'jp','ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹',0),(318812,8856,'pt','Registros de nÃ­vel de preÃ§o de importaÃ§Ã£o',0),(318813,8856,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð£Ñ€Ð¾Ð²Ð½Ñ Ð¦ÐµÐ½ Ð´Ð»Ñ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° ',0),(318814,8856,'es','Nivel de Precios Records para Importar',0),(318815,8856,'de','Preis Stufe DatensÃ¤tze importieren',0),(318816,8856,'en','Price Level Records to Import',0),(318817,8857,'is','',0),(318818,8857,'dr','Ø§Ø³Ù†Ø§Ø¯ Ú¯Ø²Ø§Ø±Ø´ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(318819,8857,'pr','Ø§Ø³Ù†Ø§Ø¯ Ú¯Ø²Ø§Ø±Ø´ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(318820,8857,'tr','SatÄ±ÅŸ temsilcisi kayÄ±tlarÄ± alma',0),(318821,8857,'pl','Przedstawicielem rejestry do importu',0),(318822,8857,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ» Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(318823,8857,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ„Ø² Ø¬Ù…ÛÙˆØ±ÛŒÛ Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(318824,8857,'sr','Ð—Ð°Ð¿Ð¸ÑÐµ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð½Ð¸Ðº Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(318825,8857,'vi','Danh sÃ¡ch nhÃ¢n viÃªn kinh doanh Ä‘á»ƒ nháº­p',0),(318826,8857,'af','Verkoopspersone Rekords vir Invoering',0),(318827,8857,'ro','Reprezentant de vÃ¢nzÄƒri Ã®nregistrÄƒri de Import',0),(318828,8857,'et','MÃ¼Ã¼giesindaja kirjete importimine',0),(318829,8857,'si','Prodajni zastopnik zapisov za uvoz',0),(318830,8857,'ba','Perwakilan penjualan catatan untuk impor',0),(318831,8857,'nl','Sales Rep Records importeren',0),(318832,8857,'fi','Myyntiedustaja tietueiden tuonti',0),(318833,8857,'no','Selger poster skal importeres',0),(318834,8857,'da','Salg Rep poster til Import',0),(318835,8857,'ko','ì˜ì—… ë‹´ë‹¹ìž ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(318836,8857,'he','× ×¦×™×’ ×ž×›×™×¨×•×ª ×¨×©×•×ž×•×ª ×¢×œ ×™×‘×',0),(318837,8857,'el','Î‘Î½Ï„Î¹Ï€ÏÏŒÏƒÏ‰Ï€Î¿Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(318838,8857,'zh','é”€å”®ä»£è¡¨è®°å½•å¯¼å…¥\r\n',0),(318839,8857,'sv','SÃ¤ljare poster att importera',0),(318840,8857,'it','Rappresentante vendite record per importazione',0),(318841,8857,'tl','',0),(318842,8857,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3648;&#3614;&#3639;&#3656;&#3629;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(318843,8857,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸',0),(318844,8857,'ms','Wakil jualan rekod untuk Import',0),(318845,8857,'ar','Ø³Ø¬Ù„Ø§Øª Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(318846,8857,'fr','ReprÃ©sentant des ventes Records d\'importation',0),(318847,8857,'jp','å–¶æ¥­æ‹…å½“è€…ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹',0),(318848,8857,'pt','Representante de vendas registros para importaÃ§Ã£o',0),(318849,8857,'ru','ÐžÑ‚Ð´ÐµÐ»Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(318850,8857,'es','Records de Rep. de Ventas para Importar',0),(318851,8857,'de','Vertriebsmitarbeiter DatensÃ¤tze importieren',0),(318852,8857,'en','Sales Rep Records to Import',0),(318853,8858,'is','',0),(318854,8858,'dr','Ø§Ø³Ù†Ø§Ø¯ Ø´Ø±Ø§ÙŠØ· Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(318855,8858,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø´Ø±Ø§ÙŠØ· Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(318856,8858,'tr','DÃ¶nem kayÄ±tlarÄ± alma',0),(318857,8858,'pl','Warunki zapisÃ³w do importu',0),(318858,8858,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(318859,8858,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ø´Ø±Ø§Ø¦Ø· Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(318860,8858,'sr','Ð¢ÐµÑ€Ð¼Ð¸Ð½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(318861,8858,'vi','Danh má»¥c hÃ ng Ä‘á»ƒ nháº­p',0),(318862,8858,'af','Terme Rekords vir Invoering',0),(318863,8858,'ro','Termeni de Ã®nregistrÄƒri la Import',0),(318864,8858,'et','Tingimused kirjete importimine',0),(318865,8858,'si','Zapisi pogojev uvoz',0),(318866,8858,'ba','Istilah catatan untuk impor',0),(318867,8858,'nl','Voorwaarden Records importeren',0),(318868,8858,'fi','Ehdot tietueiden tuonti',0),(318869,8858,'no','VilkÃ¥rene poster skal importeres',0),(318870,8858,'da','VilkÃ¥r poster til Import',0),(318871,8858,'ko','ì¡°ê±´ ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(318872,8858,'he','×ª× ××™ ×¨×©×•×ž×•×ª ×¢×œ ×™×‘×',0),(318873,8858,'el','ÎŒÏÎ¿Ï…Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(318874,8858,'zh','æ¡æ¬¾è®°å½•å¯¼å…¥\r\n',0),(318875,8858,'sv','Villkor poster att importera',0),(318876,8858,'it','Record di termini di importazione',0),(318877,8858,'tl','',0),(318878,8858,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3586;&#3657;&#3629;&#3605;&#3585;&#3621;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(318879,8858,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸',0),(318880,8858,'ms','Syarat-syarat rekod untuk Import',0),(318881,8858,'ar','Ø´Ø±ÙˆØ· Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(318882,8858,'fr','Records de conditions d\'importation',0),(318883,8858,'jp','æ¡ä»¶ãƒ¬ã‚³ãƒ¼ãƒ‰ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(318884,8858,'pt','Registros de termos de importaÃ§Ã£o',0),(318885,8858,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(318886,8858,'es','Recods de TÃ©rminos para Importar',0),(318887,8858,'de','Bedingungen DatensÃ¤tze importieren',0),(318888,8858,'en','Terms Records to Import',0),(318889,8859,'is','',0),(318890,8859,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø§Ù„ÙŠØ§Øª ',0),(318891,8859,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø§Ù„ÙŠØ§Øª ',0),(318892,8859,'tr','Vergi kimlik numarasÄ±',0),(318893,8859,'pl','NIP',0),(318894,8859,'bg','Ð”Ð°Ð½ÑŠÑ‡ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(318895,8859,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(318896,8859,'sr','ÐŸÐ˜Ð‘',0),(318897,8859,'vi','ID thuáº¿',0),(318898,8859,'af','Belasting ID',0),(318899,8859,'ro','Taxa ID',0),(318900,8859,'et','Maksu ID',0),(318901,8859,'si','Davek ID',0),(318902,8859,'ba','ID pajak',0),(318903,8859,'nl','Belastingnummer',0),(318904,8859,'fi','Tax ID',0),(318905,8859,'no','Skatte-ID',0),(318906,8859,'da','Skatte-ID',0),(318907,8859,'ko','ì„¸ê¸ˆ ID',0),(318908,8859,'he','×ž×–×”×” ×ž×¡',0),(318909,8859,'el','Î‘Î¦Îœ',0),(318910,8859,'zh','ç¨ŽåŠ¡ID\r\n',0),(318911,8859,'sv','Skatte-ID',0),(318912,8859,'it','ID fiscale',0),(318913,8859,'tl','',0),(318914,8859,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3616;&#3634;&#3625;&#3637;',0),(318915,8859,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤†à¤ˆà¤¡à¥€',0),(318916,8859,'ms','ID cukai',0),(318917,8859,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(318918,8859,'fr','Identification fiscale',0),(318919,8859,'jp','ç¨Žé‡‘ ID',0),(318920,8859,'pt','ID de imposto',0),(318921,8859,'ru','ID ÐÐ°Ð»Ð¾Ð³Ð°',0),(318922,8859,'es','ID de Impuestos',0),(318923,8859,'de','Steuer-ID',0),(318924,8859,'en','Tax ID',0),(318925,8860,'is','',0),(318926,8860,'dr','Ø§Ø³Ù†Ø§Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ÙˆØ±ÙˆØ¯',0),(318927,8860,'pr','Ø§Ø³Ù†Ø§Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ÙˆØ±ÙˆØ¯',0),(318928,8860,'tr','SatÄ±cÄ± kayÄ±tlarÄ± alma',0),(318929,8860,'pl','Zapisy dostawcy do importu',0),(318930,8860,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(318931,8860,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ ÙˆÛŒÙ†ÚˆØ± Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(318932,8860,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð·Ð°Ð¿Ð¸ÑÐ° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(318933,8860,'vi','Danh sÃ¡ch ngÆ°á»i bÃ¡n Ä‘á»ƒ nháº­p',0),(318934,8860,'af','Verskaffer Rekords vir Invoer',0),(318935,8860,'ro','Furnizor Ã®nregistrÄƒri de Import',0),(318936,8860,'et','Hankija kirjetega impordiks',0),(318937,8860,'si','Prodajalec zapisov za uvoz',0),(318938,8860,'ba','Vendor catatan impor',0),(318939,8860,'nl','Leveranciersrecords importeren',0),(318940,8860,'fi','Toimittajatietueiden tuo',0),(318941,8860,'no','LeverandÃ¸rposter Importer',0),(318942,8860,'da','LeverandÃ¸rposter til Import',0),(318943,8860,'ko','ê³µê¸‰ ì—…ì²´ ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(318944,8860,'he','×¨×©×•×ž×•×ª ×¡×¤×§ ×œ×™×‘×•×',0),(318945,8860,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(318946,8860,'zh','ä¾›åº”å•†è®°å½•å¯¼å…¥\r\n',0),(318947,8860,'sv','LeverantÃ¶rsposter import',0),(318948,8860,'it','Record del fornitore di importazione',0),(318949,8860,'tl','',0),(318950,8860,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3648;&#3614;&#3639;&#3656;&#3629;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(318951,8860,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(318952,8860,'ms','Rekod pembekal Import',0),(318953,8860,'ar','Ø³Ø¬Ù„Ù‘Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ† Ù„Ù„Ø¥Ø³ØªÙŠØ±Ø§Ø¯',0),(318954,8860,'fr','Enregistrements de fournisseurs Ã  lâ€™Import',0),(318955,8860,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹ãƒ™ãƒ³ãƒ€ãƒ¼ ãƒ¬ã‚³ãƒ¼ãƒ‰',0),(318956,8860,'pt','Registros de fornecedores para importaÃ§Ã£o',0),(318957,8860,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð´Ð»Ñ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(318958,8860,'es','Proveedor Records para Importar',0),(318959,8860,'de','Lieferantendaten zu importieren',0),(318960,8860,'en','Vendor Records to Import',0),(318961,8861,'is','',0),(318962,8861,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø³Øª ',0),(318963,8861,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø³Øª ',0),(318964,8861,'tr','Mesaj tarihi',0),(318965,8861,'pl','Data nadesÅ‚ania',0),(318966,8861,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ',0),(318967,8861,'ur','Ù¾ÙˆØ³Ù¹ ØªØ§Ø±ÛŒØ®',0),(318968,8861,'sr','ÐŸÐ¾ÑÑ‚ Ð´Ð°Ñ‚ÑƒÐ¼',0),(318969,8861,'vi','NgÃ y Káº¿t chuyá»ƒn ',0),(318970,8861,'af','Pos Datum',0),(318971,8861,'ro','Post data',0),(318972,8861,'et','Sisesta kuupÃ¤ev',0),(318973,8861,'si','Datum poÅ¡iljanja',0),(318974,8861,'ba','Tanggal posting',0),(318975,8861,'nl','Post datum',0),(318976,8861,'fi','Julkaistu',0),(318977,8861,'no','Innlegg dato',0),(318978,8861,'da','BogfÃ¸re dato',0),(318979,8861,'ko','ê²Œì‹œ ë‚ ì§œ',0),(318980,8861,'he','×ª××¨×™×š ×”×”×•×“×¢×”',0),(318981,8861,'el','Î—Î¼ÎµÏ/Î½Î¯Î± Î­ÎºÎ´Î¿ÏƒÎ·Ï‚',0),(318982,8861,'zh','å‘å¸ƒæ—¥æœŸ\r\n',0),(318983,8861,'sv','BokfÃ¶r datum',0),(318984,8861,'it','Data di inserimento:',0),(318985,8861,'tl','',0),(318986,8861,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(318987,8861,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(318988,8861,'ms','Tarikh pos',0),(318989,8861,'ar','Ø¢Ø®Ø± ØªØ§Ø±ÙŠØ®',0),(318990,8861,'fr','PostÃ©rieure Ã  la Date',0),(318991,8861,'jp','æŠ•ç¨¿æ—¥',0),(318992,8861,'pt','Data do post',0),(318993,8861,'ru','Ð”Ð°Ñ‚Ð° Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(318994,8861,'es','Fecha de Asentar',0),(318995,8861,'de','Beitragsdatum',0),(318996,8861,'en','Post Date',0),(318997,8862,'is','',0),(318998,8862,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§',0),(318999,8862,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§',0),(319000,8862,'tr','FaturalarÄ±',0),(319001,8862,'pl','Rachunki',0),(319002,8862,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸',0),(319003,8862,'ur','Ø¨Ù„',0),(319004,8862,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ',0),(319005,8862,'vi','HÃ³a ÄÆ¡n',0),(319006,8862,'af','Rekeninge',0),(319007,8862,'ro','Facturile',0),(319008,8862,'et','Arved',0),(319009,8862,'si','Menice',0),(319010,8862,'ba','Tagihan',0),(319011,8862,'nl','Rekeningen',0),(319012,8862,'fi','Laskut',0),(319013,8862,'no','Regninger',0),(319014,8862,'da','Regninger',0),(319015,8862,'ko','ì²­êµ¬ì„œ',0),(319016,8862,'he','×—×©×‘×•× ×•×ª',0),(319017,8862,'el','Î¤Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(319018,8862,'zh','å¸å•\r\n',0),(319019,8862,'sv','RÃ¤kningar',0),(319020,8862,'it','Bollette',0),(319021,8862,'tl','',0),(319022,8862,'th','&#3610;&#3636;&#3621;',0),(319023,8862,'hi','à¤¬à¤¿à¤²',0),(319024,8862,'ms','Bil-bil',0),(319025,8862,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(319026,8862,'fr','Projets de loi',0),(319027,8862,'jp','æ‰‹å½¢',0),(319028,8862,'pt','Contas',0),(319029,8862,'ru','Ð—Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ñ‹',0),(319030,8862,'es','Recibos',0),(319031,8862,'de','Rechnungen',0),(319032,8862,'en','Bills',0),(319033,8863,'is','',0),(319034,8863,'dr','Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(319035,8863,'pr','Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(319036,8863,'tr','BitmiÅŸ',0),(319037,8863,'pl','ZrobiÄ‡',0),(319038,8863,'bg','Ð¡ÑŠÑÑ‚Ð°Ð²ÐµÐ½Ð¾',0),(319039,8863,'ur','Ú©ÛŒØ§ Ú©ÛŒØ§',0),(319040,8863,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¾',0),(319041,8863,'vi','ÄÃ£ xong',0),(319042,8863,'af','Gedoen',0),(319043,8863,'ro','FÄƒcut',0),(319044,8863,'et','Teinud',0),(319045,8863,'si','Opravljeno',0),(319046,8863,'ba','Dilakukan',0),(319047,8863,'nl','Gedaan',0),(319048,8863,'fi','Tehnyt',0),(319049,8863,'no','Gjort',0),(319050,8863,'da','Gjort',0),(319051,8863,'ko','ì™„ë£Œ',0),(319052,8863,'he','×¢×©×™×ª×™',0),(319053,8863,'el','Î“Î¯Î½ÎµÎ¹',0),(319054,8863,'zh','å®Œæˆ\r\n',0),(319055,8863,'sv','Gjort',0),(319056,8863,'it','Fatto',0),(319057,8863,'tl','',0),(319058,8863,'th','&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3636;&#3657;&#3609;',0),(319059,8863,'hi','à¤•à¤¿à¤¯à¤¾',0),(319060,8863,'ms','Dilakukan',0),(319061,8863,'ar','Ø¹Ù…Ù„Ù‡',0),(319062,8863,'fr','Fait',0),(319063,8863,'jp','è¡Œã‚',0),(319064,8863,'pt','Feito',0),(319065,8863,'ru','Ð¡Ð´ÐµÐ»Ð°Ð½Ð¾',0),(319066,8863,'es','Hecho',0),(319067,8863,'de','Fertig',0),(319068,8863,'en','Done',0),(319069,8864,'is','',0),(319070,8864,'dr','Ø¢Ù…Ø§Ø¯Ù‡',0),(319071,8864,'pr','Ø¢Ù…Ø§Ø¯Ù‡',0),(319072,8864,'tr','HazÄ±r',0),(319073,8864,'pl','Gotowy',0),(319074,8864,'bg','Ð“Ð¾Ñ‚Ð¾Ð²',0),(319075,8864,'ur','ØªÛŒØ§Ø±',0),(319076,8864,'sr','Ð¡Ð¿Ñ€ÐµÐ¼Ð°Ð½',0),(319077,8864,'vi','Sáºµn sÃ ng',0),(319078,8864,'af','Gereed',0),(319079,8864,'ro','Gata',0),(319080,8864,'et','Valmis',0),(319081,8864,'si','Pripravljen',0),(319082,8864,'ba','Siap',0),(319083,8864,'nl','Klaar',0),(319084,8864,'fi','Valmis',0),(319085,8864,'no','Klar',0),(319086,8864,'da','Klar',0),(319087,8864,'ko','ì¤€ë¹„',0),(319088,8864,'he','×ž×•×›×Ÿ',0),(319089,8864,'el','ÎˆÏ„Î¿Î¹Î¼Î¿',0),(319090,8864,'zh','å‡†å¤‡\r\n',0),(319091,8864,'sv','Redo',0),(319092,8864,'it','Pronto',0),(319093,8864,'tl','',0),(319094,8864,'th','&#3614;&#3619;&#3657;&#3629;&#3617;',0),(319095,8864,'hi','à¤¤à¥ˆà¤¯à¤¾à¤°',0),(319096,8864,'ms','Sedia',0),(319097,8864,'ar','Ø§Ø³ØªØ¹Ø¯Ø§Ø¯',0),(319098,8864,'fr','PrÃªt',0),(319099,8864,'jp','æº–å‚™ãŒã§ãã¦',0),(319100,8864,'pt','Pronto',0),(319101,8864,'ru','Ð“Ð¾Ñ‚Ð¾Ð²',0),(319102,8864,'es','Listo',0),(319103,8864,'de','Bereit',0),(319104,8864,'en','Ready',0),(319105,8865,'is','',0),(319106,8865,'dr','Ø§Ø³Ù†Ø§Ø¯ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ù‡Øª ÙˆØ±ÙˆØ¯',0),(319107,8865,'pr','Ø§Ø³Ù†Ø§Ø¯ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ù‡Øª ÙˆØ±ÙˆØ¯',0),(319108,8865,'tr','Fatura kayÄ±tlarÄ± alma',0),(319109,8865,'pl','Bill rekordÃ³w do importu',0),(319110,8865,'bg','Ð‘Ð¸Ð» Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(319111,8865,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ø¨Ù„ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(319112,8865,'sr','Ð‘Ð¸Ð» Ð·Ð°Ð¿Ð¸ÑÐ° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(319113,8865,'vi','Giao Dá»‹ch HÃ³a ÄÆ¡n Ä‘á»ƒ nháº­p',0),(319114,8865,'af','Rekeninge Rekords om In te voer',0),(319115,8865,'ro','ÃŽnregistrÄƒri factura de Import',0),(319116,8865,'et','Bill kirjete importimine',0),(319117,8865,'si','Bill zapisov za uvoz',0),(319118,8865,'ba','Bill catatan untuk impor',0),(319119,8865,'nl','Bill Records importeren',0),(319120,8865,'fi','Bill tietueiden tuonti',0),(319121,8865,'no','Bill poster skal importeres',0),(319122,8865,'da','Bill poster til Import',0),(319123,8865,'ko','ë¹Œ ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(319124,8865,'he','×¨×©×•×ž×•×ª ×—×©×‘×•×Ÿ ×œ×™×‘×•×',0),(319125,8865,'el','Bill ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(319126,8865,'zh','å¸å•è®°å½•å¯¼å…¥\r\n',0),(319127,8865,'sv','Bill poster att importera',0),(319128,8865,'it','Bill Records di importazione',0),(319129,8865,'tl','',0),(319130,8865,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3649;&#3621;&#3657;&#3623;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3610;&#3636;&#3621;',0),(319131,8865,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸',0),(319132,8865,'ms','Rekod bil Import',0),(319133,8865,'ar','Ø³Ø¬Ù„Ø§Øª Ø¨ÙŠÙ„ Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(319134,8865,'fr','Bill documents d\'importation',0),(319135,8865,'jp','è«‹æ±‚æ›¸ãƒ¬ã‚³ãƒ¼ãƒ‰ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(319136,8865,'pt','Bill registros para importaÃ§Ã£o',0),(319137,8865,'ru','Ð‘Ð¸Ð»Ð» Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(319138,8865,'es','Records de Recibos para Importar',0),(319139,8865,'de','Bill DatensÃ¤tze importieren',0),(319140,8865,'en','Bill Records to Import',0),(319141,8866,'is','',0),(319142,8866,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  ÙØ±ÙˆØ´Ù†Ø¯Ù‡  Ù†ÙŠØ³Øª',0),(319143,8866,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  ÙØ±ÙˆØ´Ù†Ø¯Ù‡  Ù†ÙŠØ³Øª',0),(319144,8866,'tr','SatÄ±cÄ± bulunamadÄ±',0),(319145,8866,'pl','Nie moÅ¼na odnaleÅºÄ‡ dostawcy',0),(319146,8866,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(319147,8866,'ur','ÙˆÛŒÙ†ÚˆØ± Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§',0),(319148,8866,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(319149,8866,'vi','KhÃ´ng tÃ¬m tháº¥y ngÆ°á»i bÃ¡n',0),(319150,8866,'af','Handelaar nie kon vind',0),(319151,8866,'ro','Nu am putut gÄƒsi furnizor',0),(319152,8866,'et','Ei leitud tarnijat',0),(319153,8866,'si','Ni bilo mogoÄe najti prodajalca',0),(319154,8866,'ba','Tidak dapat menemukan Penjual',0),(319155,8866,'nl','Konden niet vondst leverancier',0),(319156,8866,'fi','Toimittajaa ei lÃ¶ytynyt',0),(319157,8866,'no','Finner ikke leverandÃ¸r',0),(319158,8866,'da','Kunne ikke finde leverandÃ¸ren',0),(319159,8866,'ko','ê³µê¸‰ ì—…ì²´ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(319160,8866,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×”×¡×¤×§',0),(319161,8866,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(319162,8866,'zh','æ‰¾ä¸åˆ°é”€å”®å•†\r\n',0),(319163,8866,'sv','Kunde inte hitta leverantÃ¶r',0),(319164,8866,'it','Non poteva trovare il fornitore',0),(319165,8866,'tl','',0),(319166,8866,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3588;&#3657;&#3609;&#3627;&#3634;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3652;&#3604;&#3657;',0),(319167,8866,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(319168,8866,'ms','Tidak dapat mencari penjual.',0),(319169,8866,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥ÙŠØ¬Ø§Ø¯ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(319170,8866,'fr','N\'a pas trouvÃ© de fournisseur',0),(319171,8866,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’è¦‹ã¤ã‘ã‚‹ã“ã¨ãŒã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(319172,8866,'pt','NÃ£o foi possÃ­vel encontrar o fornecedor',0),(319173,8866,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÐÐ°Ð¹Ñ‚Ð¸ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(319174,8866,'es','No se EncontrÃ³ el Proveedor',0),(319175,8866,'de','Hersteller konnte nicht gefunden werden.',0),(319176,8866,'en','Could Not Find Vendor',0),(319177,8867,'is','',0),(319178,8867,'dr','Ø³Ø·Ø± Ø§ÙˆÙ„',0),(319179,8867,'pr','Ø³Ø·Ø± Ø§ÙˆÙ„',0),(319180,8867,'tr','Ä°lk satÄ±r',0),(319181,8867,'pl','Pierwszy wiersz',0),(319182,8867,'bg','ÐŸÑŠÑ€Ð²Ð° Ð»Ð¸Ð½Ð¸Ñ',0),(319183,8867,'ur','Ù¾ÛÙ„ÛŒ Ù„Ø§Ø¦Ù†',0),(319184,8867,'sr','ÐŸÑ€Ð²Ð° Ð»Ð¸Ð½Ð¸Ñ˜Ð°',0),(319185,8867,'vi','DÃ²ng Äáº§u tiÃªn',0),(319186,8867,'af','Eerste Lyn',0),(319187,8867,'ro','Prima linie',0),(319188,8867,'et','Esimene rida',0),(319189,8867,'si','Prva vrstica',0),(319190,8867,'ba','Baris pertama',0),(319191,8867,'nl','Eerste regel',0),(319192,8867,'fi','EnsimmÃ¤inen rivi',0),(319193,8867,'no','FÃ¸rste linje',0),(319194,8867,'da','FÃ¸rste linje',0),(319195,8867,'ko','ì²« ë²ˆì§¸ ì¤„',0),(319196,8867,'he','×”×©×•×¨×” ×”×¨××©×•× ×”',0),(319197,8867,'el','Î ÏÏŽÏ„Î· Î³ÏÎ±Î¼Î¼Î®',0),(319198,8867,'zh','ç¬¬ä¸€è¡Œ\r\n',0),(319199,8867,'sv','FÃ¶rsta raden',0),(319200,8867,'it','Prima linea',0),(319201,8867,'tl','',0),(319202,8867,'th','&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3649;&#3619;&#3585;',0),(319203,8867,'hi','à¤ªà¤¹à¤²à¥€ à¤ªà¤‚à¤•à¥à¤¤à¤¿',0),(319204,8867,'ms','Laluan pertama',0),(319205,8867,'ar','Ø§Ù„Ø³Ø·Ø± Ø§Ù„Ø£ÙˆÙ„',0),(319206,8867,'fr','PremiÃ¨re ligne',0),(319207,8867,'jp','æœ€åˆã®è¡Œ',0),(319208,8867,'pt','Primeira linha',0),(319209,8867,'ru','ÐŸÐµÑ€Ð²Ð°Ñ Ð¡Ñ‚Ñ€Ð¾ÐºÐ°',0),(319210,8867,'es','Primera Linea',0),(319211,8867,'de','Erste Zeile',0),(319212,8867,'en','First Line',0),(319213,8868,'is','',0),(319214,8868,'dr','(Ø¯ÙØ§ØªØ±) Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù†Ù…ÙˆÙ†Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(319215,8868,'pr','Ø§Ø³Ù†Ø§Ø¯(Ø¯ÙØ§ØªØ±) Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù†Ù…ÙˆÙ†Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(319216,8868,'tr','Bu modÃ¼l kayÄ±tlarÄ± zaten alÄ±ndÄ±',0),(319217,8868,'pl','JuÅ¼ zostaÅ‚y zaimportowane rekordy dla tego moduÅ‚u',0),(319218,8868,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸Ñ‚Ðµ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð¼Ð¾Ð´ÑƒÐ» Ð²ÐµÑ‡Ðµ ÑÐ° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸',0),(319219,8868,'ur','Ø§Ø³ Ù…Ø§ÚˆÛŒÙˆÙ„ Ú©Û’ Ù„Ø¦Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ù¾ÛÙ„Û’ ÛÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©ÛŒÛ’ Ú¯Ø¦Û’',0),(319220,8868,'sr','Ð—Ð°Ð¿Ð¸ÑÐµ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð¼Ð¾Ð´ÑƒÐ» ÑÑƒ Ð²ÐµÑ› ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸.',0),(319221,8868,'vi','Dá»¯ liá»‡u Cho Modul nÃ y Ä‘Ã£ nháº­p',0),(319222,8868,'af','Rekords Vir Hierdie Module Is Alreeds Ingevoer',0),(319223,8868,'ro','ÃŽnregistrÄƒrile pentru acest modul deja au fost importate',0),(319224,8868,'et','Kirjed KÃ¤esolevas moodulis on juba imporditud',0),(319225,8868,'si','Å½e uvoÅ¾eni zapisi za ta modul',0),(319226,8868,'ba','Catatan untuk modul ini sudah telah diimpor',0),(319227,8868,'nl','Records voor deze Module zijn al ingevoerd',0),(319228,8868,'fi','Kirjaa tÃ¤mÃ¤ moduuli on jo tuotu',0),(319229,8868,'no','Poster For denne modulen er allerede importert',0),(319230,8868,'da','Poster til dette modul er blevet importeret',0),(319231,8868,'ko','ì´ ëª¨ë“ˆì— ëŒ€ í•œ ê¸°ë¡ ì´ë¯¸ ê°€ì ¸ì˜¨',0),(319232,8868,'he','×¨×©×•×ž×•×ª ×¢×‘×•×¨ ×ž×•×“×•×œ ×–×” ×›×‘×¨ ×™×•×‘××•',0),(319233,8868,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î·Î½ ÎµÎ½ÏŒÏ„Î·Ï„Î± Î­Ï‡Î¿Ï…Î½ Î®Î´Î· ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯',0),(319234,8868,'zh','æ­¤æ¨¡å—çš„è®°å½•å·²ç»å¯¼å…¥\r\n',0),(319235,8868,'sv','Poster fÃ¶r den hÃ¤r modulen har redan importerats',0),(319236,8868,'it','Record per questo modulo sono giÃ  stati importati',0),(319237,8868,'tl','',0),(319238,8868,'th','Records For This Module Have Already Been Imported',0),(319239,8868,'hi','à¤‡à¤¸ à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤†à¤¯à¤¾à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(319240,8868,'ms','Rekod-rekod bagi modul ini telah telah diimport',0),(319241,8868,'ar','Ø³Ø¬Ù„Ø§Øª Ù„Ù‡Ø°Ù‡ Ø§Ù„ÙˆØ­Ø¯Ø© ØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯Ù‡Ø§ Ø¨Ø§Ù„ÙØ¹Ù„',0),(319242,8868,'fr','Enregistrements pour ce Module ont dÃ©jÃ  Ã©tÃ© importÃ©s',0),(319243,8868,'jp','ã“ã®ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ãŒæ—¢ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã¦ã„ã¾ã™',0),(319244,8868,'pt','Registros para este mÃ³dulo jÃ¡ foram importados',0),(319245,8868,'ru','Ð—Ð°Ð¿Ð¸ÑÐµÐ¹ Ð´Ð»Ñ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð¼Ð¾Ð´ÑƒÐ»Ñ ÑƒÐ¶Ðµ Ð±Ñ‹Ð»Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹',0),(319246,8868,'es','Records Para Este MÃ³dulo Ya Han Sido Importados',0),(319247,8868,'de','DatensÃ¤tze fÃ¼r dieses Modul wurden bereits importiert',0),(319248,8868,'en','Records For This Module Have Already Been Imported',0),(319249,8869,'is','',0),(319250,8869,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  Ø®Ø±ÙŠØ¯Ø§Ø±  Ù†ÙŠØ³Øª',0),(319251,8869,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  Ø®Ø±ÙŠØ¯Ø§Ø±  Ù†ÙŠØ³Øª',0),(319252,8869,'tr','MÃ¼ÅŸteri bulamadÄ±',0),(319253,8869,'pl','Nie mogÅ‚em znaleÅºÄ‡ klienta',0),(319254,8869,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(319255,8869,'ur','Ú¯Ø§ÛÚ© Ù…Ù„ Ù†Û Ø³Ú©Ø§',0),(319256,8869,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ ÐºÑƒÐ¿Ñ†Ð°',0),(319257,8869,'vi','KhÃ´ng tÃ¬m tháº¥y khÃ¡ch hÃ ng',0),(319258,8869,'af','Was Nie Staat om KliÃ«nt/Klant te Vind',0),(319259,8869,'ro','Nu am putut gÄƒsi client',0),(319260,8869,'et','Klienti ei leitud',0),(319261,8869,'si','Ni naÅ¡el kupca',0),(319262,8869,'ba','Tidak bisa menemukan pelanggan',0),(319263,8869,'nl','Konden niet vondst klant',0),(319264,8869,'fi','Ei lÃ¶ydy asiakkaan',0),(319265,8869,'no','Finner ikke kunden',0),(319266,8869,'da','Kunne ikke finde kunde',0),(319267,8869,'ko','ê³ ê°ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(319268,8869,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×”×œ×§×•×—',0),(319269,8869,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï€ÎµÎ»Î¬Ï„Î·',0),(319270,8869,'zh','æ‰¾ä¸åˆ°å®¢æˆ·\r\n',0),(319271,8869,'sv','Kunde inte hitta kunden',0),(319272,8869,'it','Non poteva trovare il cliente',0),(319273,8869,'tl','',0),(319274,8869,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3652;&#3604;&#3657;',0),(319275,8869,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤² à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(319276,8869,'ms','Tidak dapat mencari pelanggan',0),(319277,8869,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(319278,8869,'fr','Client est introuvable',0),(319279,8869,'jp','é¡§å®¢ã‚’è¦‹ã¤ã‘ã‚‹ã“ã¨ãŒã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(319280,8869,'pt','NÃ£o foi possÃ­vel localizar o cliente',0),(319281,8869,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÐÐ°Ð¹Ñ‚Ð¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(319282,8869,'es','No se EncontrÃ³ el Cliente',0),(319283,8869,'de','Kunde konnte nicht gefunden werden.',0),(319284,8869,'en','Could Not Find Customer',0),(319285,8870,'is','',0),(319286,8870,'dr','(Ø§Ø³Ù†Ø§Ø¯ ) Ø¬Ù‡Øª ÙˆØ±ÙˆØ¯ ',0),(319287,8870,'pr','ÙØ§ÙƒØªÙˆØ± Ø¯ÙØ§ØªØ±(Ø§Ø³Ù†Ø§Ø¯ ) Ø¬Ù‡Øª ÙˆØ±ÙˆØ¯ ',0),(319288,8870,'tr','Fatura kayÄ±tlarÄ± alma',0),(319289,8870,'pl','Faktura rekordÃ³w do importu',0),(319290,8870,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(319291,8870,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(319292,8870,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(319293,8870,'vi','Danh sÃ¡ch hÃ³a Ä‘Æ¡n Ä‘á»ƒ nháº­p',0),(319294,8870,'af','Faktuur Rekords vir Invoering',0),(319295,8870,'ro','ÃŽnregistrÄƒri facturii de Import',0),(319296,8870,'et','Arve andmete Import',0),(319297,8870,'si','RaÄun zapisov za uvoz',0),(319298,8870,'ba','Faktur catatan untuk impor',0),(319299,8870,'nl','Factuurrecords importeren',0),(319300,8870,'fi','Laskutietueita tuo',0),(319301,8870,'no','Fakturaposter Importer',0),(319302,8870,'da','Fakturaposter til Import',0),(319303,8870,'ko','ì†¡ìž¥ ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(319304,8870,'he','×—×©×‘×•× ×™×ª ×¨×©×•×ž×•×ª ×¢×œ ×™×‘×',0),(319305,8870,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(319306,8870,'zh','å‘ç¥¨è®°å½•å¯¼å…¥\r\n',0),(319307,8870,'sv','Fakturaposter import',0),(319308,8870,'it','Record di fattura di importazione',0),(319309,8870,'tl','',0),(319310,8870,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(319311,8870,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(319312,8870,'ms','Rekod-rekod invois untuk Import',0),(319313,8870,'ar','Ø³Ø¬Ù„Ø§Øª Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(319314,8870,'fr','Records de la facture d\'importation',0),(319315,8870,'jp','è«‹æ±‚æ›¸ãƒ¬ã‚³ãƒ¼ãƒ‰ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(319316,8870,'pt','Registros de factura de importaÃ§Ã£o',0),(319317,8870,'ru','Ð¡Ñ‡ÐµÑ‚ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(319318,8870,'es','Records de Facturas para Importar',0),(319319,8870,'de','Rechnung EintrÃ¤ge importieren',0),(319320,8870,'en','Invoice Records to Import',0),(319321,8871,'is','',0),(319322,8871,'dr','Ø§Ø³Ù†Ø§Ø¯ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(319323,8871,'pr','Ø§Ø³Ù†Ø§Ø¯ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(319324,8871,'tr','Vergi kayÄ±tlarÄ± alma',0),(319325,8871,'pl','Ewidencji podatku importu',0),(319326,8871,'bg','Ð”Ð°Ð½ÑŠÐº Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(319327,8871,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(319328,8871,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð·Ð°Ð¿Ð¸ÑÐ° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(319329,8871,'vi','Danh sÃ¡ch thuáº¿ kinh doanh Ä‘á»ƒ nháº­p',0),(319330,8871,'af','Verkoopsbelasting Rekords vir Invoering',0),(319331,8871,'ro','ÃŽnregistrÄƒri TVA Import',0),(319332,8871,'et','Impordi kÃ¤ibemaksu arvestust',0),(319333,8871,'si','Prometni davek zapisov za uvoz',0),(319334,8871,'ba','Catatan penjualan pajak impor',0),(319335,8871,'nl','Sales Tax Records importeren',0),(319336,8871,'fi','ArvonlisÃ¤veron tietueiden tuonti',0),(319337,8871,'no','Mva-poster skal importeres',0),(319338,8871,'da','Sales Tax poster til Import',0),(319339,8871,'ko','íŒë§¤ ì„¸ê¸ˆ ë ˆì½”ë“œ ê°€ì ¸ì˜¤ê¸°',0),(319340,8871,'he','×ž×¢ ×ž ×¨×©×•×ž×•×ª ×¢×œ ×™×‘×',0),(319341,8871,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ¬ Î¼Î·Ï„ÏÏŽÎ± Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(319342,8871,'zh','è¥ä¸šç¨Žçš„è®°å½•å¯¼å…¥\r\n',0),(319343,8871,'sv','Moms poster att importera',0),(319344,8871,'it','Record di IVA da importazione',0),(319345,8871,'tl','',0),(319346,8871,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3616;&#3634;&#3625;&#3637;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3648;&#3614;&#3639;&#3656;&#3629;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(319347,8871,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(319348,8871,'ms','Rekod cukai jualan Import',0),(319349,8871,'ar','Ø³Ø¬Ù„Ù‘Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„Ù„Ø¥Ø³ØªÙŠØ±Ø§Ø¯',0),(319350,8871,'fr','Records de taxe Ã  l\'importation',0),(319351,8871,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹å£²ä¸Šç¨Žãƒ¬ã‚³ãƒ¼ãƒ‰',0),(319352,8871,'pt','Registros de imposto sobre vendas a importaÃ§Ã£o',0),(319353,8871,'ru','ÐÐ°Ð»Ð¾Ð³ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(319354,8871,'es','Records de IVA para Importar',0),(319355,8871,'de','Umsatzsteuer DatensÃ¤tze importieren',0),(319356,8871,'en','Sales Tax Records to Import',0),(319357,8872,'is','',0),(319358,8872,'dr','Ø³ÙØ§Ø±Ø´ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ØµÙØ­Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(319359,8872,'pr','Ø³ÙØ§Ø±Ø´ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ØµÙØ­Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(319360,8872,'tr','SatÄ±cÄ± sayfa Customizer',0),(319361,8872,'pl','Dostawcy stronÄ™ konfiguratora',0),(319362,8872,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð¸Ð·Ð°Ñ‚Ð¾Ñ€',0),(319363,8872,'ur','ÙˆÛŒÙ†ÚˆØ± ØµÙØ­Û Ú©Ø³Ù¹ÙˆÙ…ÛŒØ²Ø±',0),(319364,8872,'sr','ÐŸÑ€Ð¾Ð³Ñ€Ð°Ð¼ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’Ð°Ð²Ð°ÑšÐµ',0),(319365,8872,'vi','Trang ngÆ°á»i bÃ¡n tá»± chá»‰nh sá»­a',0),(319366,8872,'af','Verskaffer Bladsy Aanpasser',0),(319367,8872,'ro','Setare pagina furnizor',0),(319368,8872,'et','Tarnija lehe kohandamine',0),(319369,8872,'si','Prodajalec strani Customizer',0),(319370,8872,'ba','Penjual halaman Customizer',0),(319371,8872,'nl','Leverancier pagina Customizer',0),(319372,8872,'fi','Toimittajan sivun mukauttaja',0),(319373,8872,'no','LeverandÃ¸ren siden Customizer',0),(319374,8872,'da','Kreditor side Customizer',0),(319375,8872,'ko','ê³µê¸‰ ì—…ì²´ íŽ˜ì´ì§€ ì§€ì •ìž',0),(319376,8872,'he','×”×¡×¤×§ ×“×£ ××—×¨××™ ×¢×œ ×”×ª××ž×” ××™×©×™×ª',0),(319377,8872,'el','Î¥Ï€ÎµÏÎ¸Ï…Î½Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚ ÏƒÎµÎ»Î¯Î´Î±Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(319378,8872,'zh','ä¾›åº”å•†é¡µé¢å®šåˆ¶\r\n',0),(319379,8872,'sv','LeverantÃ¶rens sida Customizer',0),(319380,8872,'it','Fornitore pagina Customizer',0),(319381,8872,'tl','',0),(319382,8872,'th','&#3627;&#3609;&#3657;&#3634;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(319383,8872,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥ƒà¤·à¥à¤  à¤…à¤¨à¥à¤•à¥‚à¤²à¤•',0),(319384,8872,'ms','Penjual Laman Customizer',0),(319385,8872,'ar','ØªØ®ØµÙŠØµ ØµÙØ­Ø© Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(319386,8872,'fr','Vendeur Page Customizer',0),(319387,8872,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ãƒšãƒ¼ã‚¸ ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚¶ãƒ¼',0),(319388,8872,'pt','Personalizador de pÃ¡gina do fornecedor',0),(319389,8872,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ \"ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹Ñ‰Ð¸Ðº\"',0),(319390,8872,'es','Personalizador de PÃ¡gina de Proveedor ',0),(319391,8872,'de','Hersteller Seite Customizer',0),(319392,8872,'en','Vendor Page Customizer',0),(319393,8873,'is','',0),(319394,8873,'dr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡   Ø±Ø³ÙŠØ¯ Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø§Ø³Øª',0),(319395,8873,'pr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡   Ø±Ø³ÙŠØ¯ Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø§Ø³Øª',0),(319396,8873,'tr','BaÄŸlÄ± olduÄŸunu Your emri alÄ±ndÄ± bildirimi',0),(319397,8873,'pl','DoÅ‚Ä…czony jest Twoje potwierdzenie zamÃ³wienia',0),(319398,8873,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¾ Ðµ Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(319399,8873,'ur','Ø§Ù¾Ù†Ø§ Ø¢Ø±ÚˆØ± Ø±Ø³ÛŒØ¯ Ù…Ù†Ø³Ù„Ú© ÛÛ’',0),(319400,8873,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ Ñ˜Ðµ Ð²Ð°ÑˆÐµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(319401,8873,'vi','KÃ¨m Theo lÃ  BiÃªn Nháº­n ÄÃ£ Nháº­n ÄÆ¡n Äáº·t HÃ ng Cá»§a Báº¡n',0),(319402,8873,'af','Aangeheg is U Bestellingserkening',0),(319403,8873,'ro','AtaÅŸat este ta pentru confirmare',0),(319404,8873,'et','Lisatud on sinu Tellimuse kinnitus',0),(319405,8873,'si','PriloÅ¾en je vaÅ¡a potrditev naloga',0),(319406,8873,'ba','Terlampir adalah pengakuan pesanan Anda',0),(319407,8873,'nl','Bijgevoegd is uw bevestiging van uw bestelling',0),(319408,8873,'fi','LiitteenÃ¤ on Your tilausvahvistuksen',0),(319409,8873,'no','Vedlagt er din ordre anerkjennelse',0),(319410,8873,'da','VedhÃ¦ftet er din ordrebekrÃ¦ftelse',0),(319411,8873,'ko','ì²¨ë¶€ëŠ” ë‹¹ì‹ ì˜ ìˆœì„œ í™•ì¸',0),(319412,8873,'he','×ž×¦×•×¨×¤×ª ××™×©×•×¨ ×”×”×–×ž× ×” ×©×œ×š',0),(319413,8873,'el','Î•Ï€Î¹ÏƒÏ…Î½Î¬Ï€Ï„ÎµÏ„Î±Î¹ ÏƒÎ±Ï‚ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(319414,8873,'zh','éšä¿¡é™„ä¸Šæ‚¨çš„è®¢å•ç¡®è®¤\r\n',0),(319415,8873,'sv','Bifogat Ã¤r din Order bekrÃ¤ftelse',0),(319416,8873,'it','Ãˆ allegata la conferma d\'ordine',0),(319417,8873,'tl','',0),(319418,8873,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;&#3649;&#3621;&#3657;&#3623;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3649;&#3609;&#3610;&#3649;&#3',0),(319419,8873,'hi','à¤¸à¤‚à¤²à¤—à¥à¤¨ à¤¹à¥ˆ à¤†à¤ªà¤•à¤¾ à¤†à¤¦à¥‡à¤¶ à¤ªà¤¾à¤µà¤¤à¥€',0),(319420,8873,'ms','Berikut adalah pengakuan pesanan anda',0),(319421,8873,'ar','ÙŠØ¹Ù„Ù‚ Ù‡Ùˆ \"Ø¥Ù‚Ø±Ø§Ø± Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ\"',0),(319422,8873,'fr','AttachÃ© est votre confirmation de commande',0),(319423,8873,'jp','ã‚ãªãŸã®æ³¨æ–‡ã®æ‰¿èªã¯ã€æŽ¥ç¶šã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(319424,8873,'pt','Em anexo estÃ¡ o seu pedido de reconhecimento',0),(319425,8873,'ru','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ Ð²Ð°ÑˆÐµ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(319426,8873,'es','Anexado es la Reconocimiento de Su Pedido',0),(319427,8873,'de','Angeschlossen ist der AuftragsbestÃ¤tigung',0),(319428,8873,'en','Attached is Your Order Acknowledgement',0),(319429,8874,'is','',0),(319430,8874,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø´ØªØ±ÙŠ Ø´Ù…Ø§',0),(319431,8874,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø´ØªØ±ÙŠ Ø´Ù…Ø§',0),(319432,8874,'tr','MÃ¼ÅŸterinizin PO',0),(319433,8874,'pl','PO klienta',0),(319434,8874,'bg','ÐÐ° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° PO',0),(319435,8874,'ur','Ø¢Ù¾ Ú©Û’ Ú¯Ø§ÛÚ© Ú©Û’ Ù¾Ùˆ',0),(319436,8874,'sr','Ð’Ð°Ñˆ ÐºÑƒÐ¿Ð°Ñ† ÐŸÐž',0),(319437,8874,'vi','ÄÆ¡n mua hÃ ng khÃ¡ch hÃ ng cá»§a báº¡n',0),(319438,8874,'af','U KliÃªnt/Klant(e) AB',0),(319439,8874,'ro','Clientii dumneavoastra PO',0),(319440,8874,'et','Teie kliendi ostutellimus',0),(319441,8874,'si','VaÅ¡e stranke PO',0),(319442,8874,'ba','PO pelanggan Anda',0),(319443,8874,'nl','Uw klant PO',0),(319444,8874,'fi','Asiakkaan PO',0),(319445,8874,'no','Kundens PO',0),(319446,8874,'da','Kundens PO',0),(319447,8874,'ko','ê³ ê°ì˜ í¬',0),(319448,8874,'he','×”×¤×• ×©×œ ×”×œ×§×•×— ×©×œ×š',0),(319449,8874,'el','Î¤Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· ÏƒÎ±Ï‚ PO',0),(319450,8874,'zh','æ‚¨çš„å®¢æˆ·çš„è®¢å•\r\n',0),(319451,8874,'sv','Kundens PO',0),(319452,8874,'it','PO del cliente',0),(319453,8874,'tl','',0),(319454,8874,'th','&#3651;&#3610;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(319455,8874,'hi','à¤…à¤ªà¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤ªà¥€à¤“',0),(319456,8874,'ms','PO pelanggan anda',0),(319457,8874,'ar','Øµ. Ø¨. Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(319458,8874,'fr','PO votre client',0),(319459,8874,'jp','ã‚ãªãŸã®é¡§å®¢ã® PO',0),(319460,8874,'pt','PO do seu cliente.',0),(319461,8874,'ru','Ð’Ð°Ñˆ ÐºÐ»Ð¸ÐµÐ½Ñ‚ PO',0),(319462,8874,'es','Su OC de cliente es',0),(319463,8874,'de','Ihr Kunde PO',0),(319464,8874,'en','Your Customer\'s PO',0),(319465,8875,'is','',0),(319466,8875,'dr','ÙŠÙƒ Ø®Ø·Ø§ Ø±ÙˆÙŠ Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª',0),(319467,8875,'pr','ÙŠÙƒ Ø®Ø·Ø§ Ø±ÙˆÙŠ Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª',0),(319468,8875,'tr','Bir hata oluÅŸtu',0),(319469,8875,'pl','WystÄ…piÅ‚ bÅ‚Ä…d',0),(319470,8875,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð° Ð³Ñ€ÐµÑˆÐºÐ°',0),(319471,8875,'ur','Ø§ÛŒÚ© Ù†Ù‚Øµ ÛÙˆ Ú¯ÛŒØ§',0),(319472,8875,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð³Ñ€ÐµÑˆÐºÐµ',0),(319473,8875,'vi','CÃ³ lá»—i',0),(319474,8875,'af','\'n Fout het Voorgekom',0),(319475,8875,'ro','A apÄƒrut o eroare',0),(319476,8875,'et','Ilmnes tÃµrge',0),(319477,8875,'si','Napaka',0),(319478,8875,'ba','Terjadi kesalahan',0),(319479,8875,'nl','Er is een fout opgetreden',0),(319480,8875,'fi','Virhe',0),(319481,8875,'no','Feil',0),(319482,8875,'da','Der opstod en fejl',0),(319483,8875,'ko','ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(319484,8875,'he','××™×¨×¢×” ×©×’×™××”',0),(319485,8875,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î±',0),(319486,8875,'zh','å‘ç”Ÿé”™è¯¯\r\n',0),(319487,8875,'sv','Ett fel uppstod',0),(319488,8875,'it','Si Ã¨ verificato un errore',0),(319489,8875,'tl','',0),(319490,8875,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;',0),(319491,8875,'hi','à¤•à¥‹à¤ˆ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤¹à¥à¤ˆ',0),(319492,8875,'ms','Satu ralat telah berlaku',0),(319493,8875,'ar','Ø­ØµÙ„ Ø®Ø·Ø£',0),(319494,8875,'fr','Une erreur s\'est produite',0),(319495,8875,'jp','ã‚¨ãƒ©ãƒ¼ãŒç™ºç”Ÿã—ã¾ã—ãŸ',0),(319496,8875,'pt','Ocorreu um erro',0),(319497,8875,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð° ÐžÑˆÐ¸Ð±ÐºÐ°',0),(319498,8875,'es','Se OcurriÃ³ un Error',0),(319499,8875,'de','Ist ein Fehler aufgetreten',0),(319500,8875,'en','An Error Occurred',0),(319501,8876,'is','',0),(319502,8876,'dr','Ù„Ø·ÙØ§ Ù‡Ø± Ú¯ÙˆÙ†Ù‡ Ø§ØµÙ„Ø§Ø­Ø§Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² ÙƒÙ‡ ØªÙˆØ³Ø· Ù¾ÙŠØºØ§Ù… Ø®Ø·Ø§ Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø±Ø§ Ø§Ù†Ø¬Ø§Ù… Ø¯Ù‡ÙŠØ¯  Ùˆ Ù…Ø¨Ø¯Ù„ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹ Ø§ÙŠÙ† Ù†Ø±Ù…Ø§ÙØ²Ø§Ø± Ø±Ø§ Ø§Ø¬Ø±Ø§ ÙƒÙ†ÙŠØ¯ ',0),(319503,8876,'pr','Ù„Ø·ÙØ§ Ù‡Ø± Ú¯ÙˆÙ†Ù‡ Ø§ØµÙ„Ø§Ø­Ø§Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² ÙƒÙ‡ ØªÙˆØ³Ø· Ù¾ÙŠØºØ§Ù… Ø®Ø·Ø§ Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø±Ø§ Ø§Ù†Ø¬Ø§Ù… Ø¯Ù‡ÙŠØ¯  Ùˆ Ù…Ø¨Ø¯Ù„ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹ Ø§ÙŠÙ† Ù†Ø±Ù…Ø§ÙØ²Ø§Ø± Ø±Ø§ Ø§Ø¬Ø±Ø§ ÙƒÙ†ÙŠØ¯ ',0),(319504,8876,'tr','LÃ¼tfen hata iletisi tarafÄ±ndan gerekli ayarlamalarÄ± yapÄ±n ve QuickBooks dÃ¶nÃ¼ÅŸtÃ¼rÃ¼cÃ¼yÃ¼ yeniden Ã§alÄ±ÅŸtÄ±rÄ±n',0),(319505,8876,'pl','ProszÄ™ o wszelkich dostosowaÅ„ wymaganych przez komunikat o bÅ‚Ä™dzie i ponownie uruchomiÄ‡ konwertera programu QuickBooks',0),(319506,8876,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸, Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ð¸ Ð¾Ñ‚ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð·Ð° Ð³Ñ€ÐµÑˆÐºÐ° Ð¸ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ñ€Ð° Ð½Ð° QuickBooks Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(319507,8876,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù†Ù‚Øµ Ù¾ÛŒØºØ§Ù… Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ø·Ù„ÙˆØ¨ Ú©ÙˆØ¦ÛŒ ÛÙ… Ø¢ÛÙ†Ú¯ÛŒ Ù¾ÛŒØ¯Ø§ Ú©Ø±Ù†Û’ Ø§ÙˆØ± Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ú©Ù†ÙˆØ±Ù¹Ø± Ø¯ÙˆØ¨Ø§Ø±Û Ú†Ù„Ø§Ø¦ÛŒÚº',0),(319508,8876,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð½ÐµÐºÐµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ñ…Ñ‚Ð¸Ñ˜ÐµÐ²Ð° Ð¿Ð¾Ñ€ÑƒÐºÑƒ Ð¾ Ð³Ñ€ÐµÑˆÑ†Ð¸ Ð¸ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð¿Ð¾ÐºÑ€ÐµÐ½Ð¸Ñ‚Ðµ QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ñ€',0),(319509,8876,'vi','Vui lÃ²ng sá»­a láº¡i theo ná»™i dung trong tin nháº¯n bÃ¡o lá»—i & cháº¡y láº¡i bá»™ chuyá»ƒn Ä‘á»•i NolaPro Quickbooks',0),(319510,8876,'af','Doen asb. enige aansuiwerings soos benodig deur die foutboodskap en loop weer die NolaPro Quickbooks omskepper ',0),(319511,8876,'ro','VÄƒ rugÄƒm sÄƒ face ajustÄƒrile cerut de mesajul de eroare ÅŸi a alerga Convertor QuickBooks din nou',0),(319512,8876,'et','Palun teha vajalikud tÃµrketeate ja kÃ¤ivitage QuickBooks converter uuesti',0),(319513,8876,'si','Prosim vse prilagoditve zahteva sporoÄilo o napaki in znova zaÅ¾enite QuickBooks pretvornik',0),(319514,8876,'ba','Silakan membuat penyesuaian apapun yang diperlukan oleh pesan kesalahan dan menjalankan Konverter QuickBooks lagi',0),(319515,8876,'nl','Maak eventuele aanpassingen die nodig zijn door het foutbericht en het QuickBooks-conversieprogramma opnieuw uitvoeren',0),(319516,8876,'fi','Varmista virhesanoma tarvittavat mukautukset ja suorita QuickBooks muunnin uudelleen',0),(319517,8876,'no','Vennligst foreta justeringer kreves av feilmeldingen og KjÃ¸r QuickBooks converter igjen',0),(319518,8876,'da','Du skal foretage justeringer krÃ¦ves af fejlmeddelelsen og kÃ¸re QuickBooks-Konverter igen',0),(319519,8876,'ko','ì˜¤ë¥˜ ë©”ì‹œì§€ì— í•„ìš”í•œ ì¡°ì •ì„ í•˜ ê³  QuickBooks ë³€í™˜ê¸°ë¥¼ ë‹¤ì‹œ ì‹¤í–‰ í•˜ì‹­ì‹œì˜¤',0),(319520,8876,'he','×‘×‘×§×©×” ×œ×”×¤×•×š ×›×œ ×”×”×ª××ž×•×ª ×”× ×“×¨×©×•×ª ×¢×œ-×™×“×™ ×”×•×“×¢×ª ×”×©×’×™××” ×•×œ×”×¤×¢×™×œ ××ª ×”×ž×ž×™×¨ QuickBooks ×©×•×‘',0),(319521,8876,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎºÎ¬Î½Ï„Îµ Ï„Î¹Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚ Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹ Î±Ï€ÏŒ Ï„Î¿ Î¼Î®Î½Ï…Î¼Î± Î»Î¬Î¸Î¿Ï…Ï‚ ÎºÎ±Î¹ ÎµÎºÏ„ÎµÎ»Î­ÏƒÏ„Îµ Î¾Î±Î½Î¬ Ï„Î¿ QuickBooks Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î­Î±',0),(319522,8876,'zh','è¯·æŒ‰é”™è¯¯ä¿¡æ¯è¦æ±‚è¿›è¡Œä»»ä½•è°ƒæ•´ï¼Œå¹¶é‡æ–°è¿è¡ŒQuickBooksçš„è½¬æ¢å™¨\r\n',0),(319523,8876,'sv','VÃ¤nligen gÃ¶r eventuella justeringar som krÃ¤vs av felmeddelandet och kÃ¶r SPCS converter igen',0),(319524,8876,'it','Per favore eventuali adeguamenti richiesti dal messaggio di errore ed eseguire di nuovo il convertitore QuickBooks',0),(319525,8876,'tl','',0),(319526,8876,'th','Please make any adjustments required by the error message and run the NolaPro QuickBooks converter again',0),(319527,8876,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤•à¤°à¤•à¥‡ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤…à¤ªà¥‡à¤•à¥à¤·à¤¿à¤¤ à¤”à¤° QuickBooks à¤•à¤¨à¤µà¤°à¥à¤Ÿà¤° à¤•à¥‹ à¤«à¤¿à¤° à¤¸à¥‡ à¤šà¤²à¤¾à¤à¤',0),(319528,8876,'ms','Sila membuat apa-apa pelarasan yang diperlukan oleh mesej ralat dan jalankan penukar QuickBooks semula',0),(319529,8876,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø£ÙŠ ØªØ¹Ø¯ÙŠÙ„Ø§Øª ØªØªØ·Ù„Ø¨Ù‡Ø§ Ø±Ø³Ø§Ù„Ø© Ø§Ù„Ø¥Ø¹Ù„Ø§Ù… Ø¨Ø§Ù„Ø®Ø·Ø£ ÙˆØªØ´ØºÙŠÙ„ Ø§Ù„Ù…Ø­ÙˆÙ„ Ù‚Ø±Ø§Ø¡ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(319530,8876,'fr','Veuillez apporter tous les ajustements requis par le message d\'erreur et exÃ©cutez de nouveau le convertisseur de QuickBooks',0),(319531,8876,'jp','ã‚¨ãƒ©ãƒ¼ ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã«ã‚ˆã£ã¦å¿…è¦ãªèª¿æ•´ã‚’è¡Œã„ã€QuickBooks ã‚³ãƒ³ãƒãƒ¼ã‚¿ãƒ¼ã‚’å†åº¦å®Ÿè¡Œã—ã¦ãã ã•ã„ã€‚',0),(319532,8876,'pt','Por favor, fazer os ajustes necessÃ¡rios com a mensagem de erro e executar o conversor de QuickBooks novamente',0),(319533,8876,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¿Ñ€ÐµÐ´ÑƒÑÐ¼Ð¾Ñ‚Ñ€ÐµÐ½Ð¾ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¾Ð± Ð¾ÑˆÐ¸Ð±ÐºÐµ Ð¸ ÑÐ½Ð¾Ð²Ð° Ð·Ð°Ð¿ÑƒÑÑ‚Ð¸Ñ‚Ðµ QuickBooks ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚ÐµÑ€',0),(319534,8876,'es','Por favor hacer unos ajustes requeridos por el mensaje de errores y iniciar el convertidor de NolaPro QuickBooks otra vez',0),(319535,8876,'de','Bitte Anpassungen Sie erforderlich, die durch die Fehlermeldung und fÃ¼hren Sie erneut den QuickBooks-Konverter',0),(319536,8876,'en','Please make any adjustments required by the error message and run the QuickBooks converter again',0),(319537,8877,'is','',0),(319538,8877,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ø±Ø±Ø³ÙŠ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„',0),(319539,8877,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ø±Ø±Ø³ÙŠ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„',0),(319540,8877,'tr','Hata denetimi Ã¶zel alanlar',0),(319541,8877,'pl','BÅ‚Ä…d sprawdzania pÃ³l niestandardowych',0),(319542,8877,'bg','ÐŸÐ¾Ð»ÐµÑ‚Ð° Ð¿Ð¾ Ð¸Ð·Ð±Ð¾Ñ€ Ð·Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð° Ð³Ñ€ÐµÑˆÐºÐ¸',0),(319543,8877,'ur','Ù…Ø®ØµÙˆØµ Ù‚Ø·Ø¹Ø§Øª Ù¾Ú‘ØªØ§Ù„ Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(319544,8877,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ñ™Ð° Ð³Ñ€ÐµÑˆÐ°ÐºÐ°',0),(319545,8877,'vi','Kiá»ƒm tra trÆ°á»ng tá»± táº¡o bá»‹ lá»—i',0),(319546,8877,'af','Fout met Nasien van Aangepasde Velde',0),(319547,8877,'ro','Eroare verificarea cÃ¢mpuri particularizate',0),(319548,8877,'et','Veakontrolli kohandatud vÃ¤ljad',0),(319549,8877,'si','Polja po meri preverjanje napak',0),(319550,8877,'ba','Bidang kustom pengecekan error',0),(319551,8877,'nl','Aangepaste velden voor foutcontrole',0),(319552,8877,'fi','Virheentarkistuksen mukautetut kentÃ¤t',0),(319553,8877,'no','Feilkontroll egendefinerte felt',0),(319554,8877,'da','Fejlkontrol brugerdefinerede felter',0),(319555,8877,'ko','ì˜¤ë¥˜ ê²€ì‚¬ ì‚¬ìš©ìž ì •ì˜ í•„ë“œ',0),(319556,8877,'he','×‘×“×™×§×ª ×©×“×•×ª ×ž×•×ª××ž×™× ××™×©×™×ª ×©×’×™××•×ª',0),(319557,8877,'el','Î£Ï†Î¬Î»Î¼Î± Î­Î»ÎµÎ³Ï‡Î¿ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î± Ï€ÎµÎ´Î¯Î±',0),(319558,8877,'zh','é”™è¯¯æ£€æŸ¥è‡ªå®šä¹‰å­—æ®µ\r\n',0),(319559,8877,'sv','Felkontroll anpassade fÃ¤lt',0),(319560,8877,'it','Errore controllo campi personalizzati',0),(319561,8877,'tl','',0),(319562,8877,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3611;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3615;&#3636;&#3621;&#3604;&#3660;',0),(319563,8877,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤«à¤¼à¥€à¤²à¥à¤¡à¥ à¤¸ à¤•à¥€ à¤œà¤¾à¤à¤š à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(319564,8877,'ms','Semakan bidang adat ralat',0),(319565,8877,'ar','Ø®Ø·Ø£ ÙÙŠ ÙØ­Øµ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ø®ØµÙ‘ØµØ©',0),(319566,8877,'fr','VÃ©rification des champs personnalisÃ©s d\'erreur',0),(319567,8877,'jp','ã‚«ã‚¹ã‚¿ãƒ  ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã®ç¢ºèªã‚¨ãƒ©ãƒ¼',0),(319568,8877,'pt','Erro de verificaÃ§Ã£o de campos personalizados',0),(319569,8877,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ñ… Ð¿Ð¾Ð»ÐµÐ¹',0),(319570,8877,'es','Error Checando Campos Personalizados',0),(319571,8877,'de','Benutzerdefinierte Felder fÃ¼r die FehlerÃ¼berprÃ¼fung',0),(319572,8877,'en','Error Checking Custom Fields',0),(319573,8878,'is','',0),(319574,8878,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„',0),(319575,8878,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„',0),(319576,8878,'tr','Ã–zel alanlar oluÅŸturulurken hata oluÅŸtu',0),(319577,8878,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas tworzenia pÃ³l niestandardowych',0),(319578,8878,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(319579,8878,'ur','Ù…Ø®ØµÙˆØµ Ù‚Ø·Ø¹Ø§Øª Ø¨Ù†Ø§Ù†Û’ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(319580,8878,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¸Ñ… Ð¿Ð¾Ñ™Ð°',0),(319581,8878,'vi','Lá»—i táº¡o trÆ°á»ng tá»± táº¡o',0),(319582,8878,'af','Fout met Skepping van Aangepasde Velde',0),(319583,8878,'ro','Eroare la crearea Custom domenii',0),(319584,8878,'et','Ei Ãµnnestu luua kohandatud vÃ¤ljad',0),(319585,8878,'si','Napaka pri ustvarjanju polj po meri',0),(319586,8878,'ba','Error membuat kolom kustom',0),(319587,8878,'nl','Fout bij het maken van aangepaste velden',0),(319588,8878,'fi','Virhe luotaessa mukautetut kentÃ¤t',0),(319589,8878,'no','Feil under oppretting av egendefinerte felt',0),(319590,8878,'da','Fejl under oprettelse af brugerdefinerede felter',0),(319591,8878,'ko','ì‚¬ìš©ìž ì •ì˜ í•„ë“œë¥¼ ë§Œë“œëŠ” ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤',0),(319592,8878,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×©×“×•×ª ×ž×•×ª××ž×™× ××™×©×™×ª',0),(319593,8878,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Ï‰Î½ Ï€ÎµÎ´Î¯Ï‰Î½',0),(319594,8878,'zh','åˆ›å»ºè‡ªå®šä¹‰å­—æ®µé”™è¯¯\r\n',0),(319595,8878,'sv','Fel vid skapande av anpassade fÃ¤lt',0),(319596,8878,'it','Errore durante la creazione di campi personalizzati',0),(319597,8878,'tl','',0),(319598,8878,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3611;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3615;&#3636;&#3621;&#3604;&#3660;',0),(319599,8878,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤«à¤¼à¥€à¤²à¥à¤¡à¥ à¤¸ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(319600,8878,'ms','Ralat ketika mencipta bidang adat',0),(319601,8878,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ø®ØµÙ‘ØµØ©',0),(319602,8878,'fr','Erreur de crÃ©ation de champs personnalisÃ©s',0),(319603,8878,'jp','ã‚«ã‚¹ã‚¿ãƒ  ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ä½œæˆæ™‚ã®ã‚¨ãƒ©ãƒ¼',0),(319604,8878,'pt','Erro ao criar campos personalizados',0),(319605,8878,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ Ð½Ð°ÑÑ‚Ñ€Ð°Ð¸Ð²Ð°ÐµÐ¼Ñ‹Ñ… Ð¿Ð¾Ð»ÐµÐ¹',0),(319606,8878,'es','Error Creando Campos Personalizados',0),(319607,8878,'de','Fehler beim Erstellen von benutzerdefinierter Feldern',0),(319608,8878,'en','Error Creating Custom Fields',0),(319609,8879,'is','',0),(319610,8879,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ø§ÙŠÙ† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(319611,8879,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ø§ÙŠÙ† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(319612,8879,'tr','Bu Ã¶deme tipi izin ver',0),(319613,8879,'pl','PozwalajÄ… na tego typu pÅ‚atnoÅ›ci',0),(319614,8879,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»ÑÐ²Ð° Ñ‚Ð¾Ð·Ð¸ Ñ‚Ð¸Ð¿ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(319615,8879,'ur','Ø§Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(319616,8879,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð¾Ð²Ðµ Ð²Ñ€ÑÑ‚Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(319617,8879,'vi','Cho PhÃ©p Loáº¡i Thanh ToÃ¡n nÃ y',0),(319618,8879,'af','Laat Hierdie Betalings Tipe toe',0),(319619,8879,'ro','Permite acest tip de platÄƒ',0),(319620,8879,'et','Luba seda tÃ¼Ã¼pi makse',0),(319621,8879,'si','OmogoÄajo ta vrsta plaÄila',0),(319622,8879,'ba','Memungkinkan jenis pembayaran',0),(319623,8879,'nl','Dit betalingstype toestaan',0),(319624,8879,'fi','Maksun tietyn',0),(319625,8879,'no','Tillate denne betalingsmÃ¥ten',0),(319626,8879,'da','Tillad denne betalingstype',0),(319627,8879,'ko','ì´ ì§€ë¶ˆ ìœ í˜•ì„ í—ˆìš©í•©ë‹ˆë‹¤',0),(319628,8879,'he','××¤×©×¨ ××ª ×¦×•×¨×ª ×ª×©×œ×•× ×–×•',0),(319629,8879,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€ÎµÎ¹ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎµÎ¯Î´Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(319630,8879,'zh','å…è®¸è¿™ç§ä»˜æ¬¾æ–¹å¼\r\n',0),(319631,8879,'sv','TillÃ¥ta denna betalningstyp',0),(319632,8879,'it','Consentire questo tipo di pagamento',0),(319633,8879,'tl','',0),(319634,8879,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(319635,8879,'hi','à¤‡à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(319636,8879,'ms','Membenarkan jenis bayaran ini',0),(319637,8879,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ù‡Ø°Ø§ Ø§Ù„Ù†ÙˆØ¹ Ù…Ù† Ø§Ù„Ø¯ÙØ¹',0),(319638,8879,'fr','Permettre Ã  ce Type de paiement',0),(319639,8879,'jp','ã“ã®æ”¯æ‰•ã‚¿ã‚¤ãƒ—ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(319640,8879,'pt','Permitir este tipo de pagamento',0),(319641,8879,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ð¹ Ð¢Ð¸Ð¿ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(319642,8879,'es','Permitir Este Tipo de Pago',0),(319643,8879,'de','Diese Zahlungsart zu ermÃ¶glichen',0),(319644,8879,'en','Allow This Payment Type',0),(319645,8880,'is','',0),(319646,8880,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(319647,8880,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(319648,8880,'tr','VarsayÄ±lan gider GL hesabÄ±',0),(319649,8880,'pl','DomyÅ›lny koszt GL konta',0),(319650,8880,'bg','GL Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(319651,8880,'ur','Ø·Û’ Ø´Ø¯Û Ø®Ø±Ú†Û’ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(319652,8880,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð“Ð› Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð°',0),(319653,8880,'vi','TK Chi PhÃ­ Sá»• CÃ¡i Tá»•ng Há»£p Máº·c Äá»‹nh',0),(319654,8880,'af','Verstekte Uitgawe AG Rekening',0),(319655,8880,'ro','Cont de GL implicit cheltuieli',0),(319656,8880,'et','Vaikimisi GL Kulukonto',0),(319657,8880,'si','Privzeti Konto stroÅ¡kov GL',0),(319658,8880,'ba','Akun bawaan biaya GL',0),(319659,8880,'nl','Standaard GL kostenrekening',0),(319660,8880,'fi','Oletusarvoinen kulutili GL',0),(319661,8880,'no','Standard Motkonto GL',0),(319662,8880,'da','GL Standardudgiftskontoen',0),(319663,8880,'ko','ê¸°ë³¸ ê²½ë¹„ GL ê³„ì •',0),(319664,8880,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×—×©×‘×•×Ÿ ×”×”×•×¦××•×ª GL',0),(319665,8880,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î´Î±Ï€Î¬Î½Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(319666,8880,'zh','é»˜è®¤è´¹ç”¨æ€»å¸å¸æˆ·\r\n',0),(319667,8880,'sv','Standard utgiftskonto GL',0),(319668,8880,'it','Account predefinito di spesa GL',0),(319669,8880,'tl','',0),(319670,8880,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(319671,8880,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤µà¥à¤¯à¤¯ GL à¤–à¤¾à¤¤à¥‡',0),(319672,8880,'ms','Lalai perbelanjaan GL akaun',0),(319673,8880,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠ',0),(319674,8880,'fr','Compte GL pour le frais par dÃ©faut',0),(319675,8880,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã®çµŒè²» GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(319676,8880,'pt','PadrÃ£o conta GL',0),(319677,8880,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÑÑ‡ÐµÑ‚ GL',0),(319678,8880,'es','Cuenta LM de Gastos por Defecto',0),(319679,8880,'de','Standard GL Aufwandskonto',0),(319680,8880,'en','Default Expense GL Account',0),(319681,8881,'is','',0),(319682,8881,'dr','2',0),(319683,8881,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø²  Ø¢Ø¯Ø±Ø³  2',0),(319684,8881,'tr','SipariÅŸ adresi 2',0),(319685,8881,'pl','ZamÃ³wienia z adresem 2',0),(319686,8881,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ Ð°Ð´Ñ€ÐµÑ 2',0),(319687,8881,'ur','ØªØ±ØªÛŒØ¨ Ø³Û’ Ù¾ØªÛ’ 2',0),(319688,8881,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¾Ð´ Ð°Ð´Ñ€ÐµÑÐµ 2',0),(319689,8881,'vi','Äáº·t hÃ ng tá»« Ä‘á»‹a chá»‰ 2',0),(319690,8881,'af','Bestelling Van Adres 2',0),(319691,8881,'ro','Comanda de la adresa 2',0),(319692,8881,'et','Tellimuse aadress 2',0),(319693,8881,'si','Nalog iz naslova 2',0),(319694,8881,'ba','Order dari alamat 2',0),(319695,8881,'nl','Volgorde van adres 2',0),(319696,8881,'fi','Jotta osoite 2',0),(319697,8881,'no','Bestill fra adresse 2',0),(319698,8881,'da','Ordre fra adresse 2',0),(319699,8881,'ko','ì£¼ë¬¸ ì£¼ì†Œ 2',0),(319700,8881,'he','×¡×“×¨ ×ž×›×ª×•×‘×ª 2',0),(319701,8881,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Ï€ÏŒ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· 2',0),(319702,8881,'zh','è®¢è´­æ¥è‡ªåœ°å€2\r\n',0),(319703,8881,'sv','BestÃ¤llning frÃ¥n adress 2',0),(319704,8881,'it','Ordine dall\'indirizzo 2',0),(319705,8881,'tl','',0),(319706,8881,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656; 2',0),(319707,8881,'hi','à¤ªà¤¤à¤¾ 2 à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶',0),(319708,8881,'ms','Pesanan dari alamat 2',0),(319709,8881,'ar','Ø£Ù…Ø± Ù…Ù† Ø§Ù„Ø¹Ù†ÙˆØ§Ù† 2',0),(319710,8881,'fr','Ordre d\'adresse 2',0),(319711,8881,'jp','ã‚¢ãƒ‰ãƒ¬ã‚¹ 2 ã‹ã‚‰ã®é †åº',0),(319712,8881,'pt','Ordem de endereÃ§o 2',0),(319713,8881,'ru','Ð—Ð°ÐºÐ°Ð· Ð¡ ÐÐ´Ñ€ÐµÑÐ° 2',0),(319714,8881,'es','Pedido De DirecciÃ³n 2',0),(319715,8881,'de','Bestellung von Adresse 2',0),(319716,8881,'en','Order From Address 2',0),(319717,8882,'is','',0),(319718,8882,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø´Ù‡Ø± ',0),(319719,8882,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø´Ù‡Ø± ',0),(319720,8882,'tr','SipariÅŸ City',0),(319721,8882,'pl','KolejnoÅ›ci od miasta',0),(319722,8882,'bg','Ð ÐµÐ´ Ð¾Ñ‚ Ð³Ñ€Ð°Ð´',0),(319723,8882,'ur','Ø´ÛØ± Ø³Û’ ØªØ±ØªÛŒØ¨',0),(319724,8882,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¸Ð· Ð³Ñ€Ð°Ð´Ð°',0),(319725,8882,'vi','Äáº·t hÃ ng tá»« thÃ nh phá»‘',0),(319726,8882,'af','Bestelling Van Dorp/Stad',0),(319727,8882,'ro','Comanda de la City',0),(319728,8882,'et','Tellimuse linnast',0),(319729,8882,'si','Nalog iz mesta',0),(319730,8882,'ba','Order dari kota',0),(319731,8882,'nl','Volgorde van stad',0),(319732,8882,'fi','Tilaa City',0),(319733,8882,'no','Bestill fra byen',0),(319734,8882,'da','Ordre fra byen',0),(319735,8882,'ko','ë„ì‹œì—ì„œ ì£¼ë¬¸',0),(319736,8882,'he','×¡×“×¨ ×¡×™×˜×™',0),(319737,8882,'el','Î£ÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ Ï€ÏŒÎ»Î·',0),(319738,8882,'zh','è®¢è´­æ¥è‡ªåŸŽå¸‚\r\n',0),(319739,8882,'sv','BestÃ¤llning frÃ¥n staden',0),(319740,8882,'it','Ordine da cittÃ ',0),(319741,8882,'tl','',0),(319742,8882,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3629;&#3635;&#3648;&#3616;&#3629;',0),(319743,8882,'hi','à¤•à¥à¤°à¤® à¤¶à¤¹à¤° à¤¸à¥‡',0),(319744,8882,'ms','Pesanan dari bandar',0),(319745,8882,'ar','Ø£Ù…Ø± Ù…Ù† Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(319746,8882,'fr','Ordre de ville',0),(319747,8882,'jp','å¸‚ã‹ã‚‰ã®é †åº',0),(319748,8882,'pt','Ordem de cidade',0),(319749,8882,'ru','Ð—Ð°ÐºÐ°Ð· Ð˜Ð· Ð“Ð¾Ñ€Ð¾Ð´Ð°',0),(319750,8882,'es','Ordenar De Ciudad',0),(319751,8882,'de','Bestellung von Stadt',0),(319752,8882,'en','Order From City',0),(319753,8883,'is','',0),(319754,8883,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ù†Ø§Ù… Ø´Ø±ÙƒØª ',0),(319755,8883,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ù†Ø§Ù… Ø´Ø±ÙƒØª ',0),(319756,8883,'tr','Åžirket adÄ±nÄ± sÄ±rasÄ±ndan',0),(319757,8883,'pl','KolejnoÅ›ci od nazwy firmy',0),(319758,8883,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð°',0),(319759,8883,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù†Ø§Ù… Ø³Û’ ØªØ±ØªÛŒØ¨',0),(319760,8883,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¸Ð· Ð¸Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(319761,8883,'vi','Äáº·t hÃ ng tá»« Cty - TÃªn',0),(319762,8883,'af','Bestelling Van Onderneming Naam',0),(319763,8883,'ro','Ordine, de la numele companiei',0),(319764,8883,'et','Tellimus alates ettevÃµtte nimi',0),(319765,8883,'si','Nalog iz ime podjetja',0),(319766,8883,'ba','Order dari nama perusahaan',0),(319767,8883,'nl','Volgorde van bedrijfsnaam',0),(319768,8883,'fi','Jotta yrityksen nimi',0),(319769,8883,'no','Bestill fra firmanavn',0),(319770,8883,'da','Ordre fra virksomhedens navn',0),(319771,8883,'ko','íšŒì‚¬ ì´ë¦„ì—ì„œ ìˆœì„œ',0),(319772,8883,'he','×”×–×ž× ×” ×ž ×©× ×”×—×‘×¨×”',0),(319773,8883,'el','Î£ÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(319774,8883,'zh','æŒ‰å…¬å¸åç§°æŽ’åº\r\n',0),(319775,8883,'sv','Order frÃ¥n fÃ¶retagets namn',0),(319776,8883,'it','Ordine dal nome dell\'azienda',0),(319777,8883,'tl','',0),(319778,8883,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3594;&#3639;&#3656;&#3629;',0),(319779,8883,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤¨à¤¾à¤® à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶',0),(319780,8883,'ms','Pesanan daripada nama Syarikat',0),(319781,8883,'ar','Ø£Ù…Ø± Ù…Ù† Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ©',0),(319782,8883,'fr','Ordre de nom de l\'entreprise',0),(319783,8883,'jp','ä¼šç¤¾åã‹ã‚‰æ³¨æ–‡',0),(319784,8883,'pt','Ordem do nome da empresa',0),(319785,8883,'ru','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¾Ñ‚ Ð¸Ð¼ÐµÐ½Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(319786,8883,'es','Ordenar De Nombre de la Empresa',0),(319787,8883,'de','Bestellung von Firmennamen',0),(319788,8883,'en','Order From Company Name',0),(319789,8884,'is','',0),(319790,8884,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ÙƒØ´ÙˆØ± ',0),(319791,8884,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ÙƒØ´ÙˆØ± ',0),(319792,8884,'tr','Ãœlkeden sipariÅŸ',0),(319793,8884,'pl','ZamÃ³wienia z kraju',0),(319794,8884,'bg','Ð ÐµÐ´ Ð¾Ñ‚ ÑÑ‚Ñ€Ð°Ð½Ð°',0),(319795,8884,'ur','Ù…Ù„Ú© Ø³Û’ ØªØ±ØªÛŒØ¨',0),(319796,8884,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¸Ð· Ð·ÐµÐ¼Ñ™Ðµ',0),(319797,8884,'vi','Äáº·t hÃ ng tá»« nÆ°á»›c',0),(319798,8884,'af','Bestellings Vanaf Land',0),(319799,8884,'ro','Comanda de la tara',0),(319800,8884,'et','Telli riigist',0),(319801,8884,'si','Nalog iz drÅ¾ave',0),(319802,8884,'ba','Order dari negara',0),(319803,8884,'nl','Volgorde van land',0),(319804,8884,'fi','Jotta maasta',0),(319805,8884,'no','Ordre fra land',0),(319806,8884,'da','Ordre fra land',0),(319807,8884,'ko','ë‚˜ë¼ì—ì„œ ì£¼ë¬¸',0),(319808,8884,'he','×¡×“×¨ ×ž×Ÿ ×”×ž×“×™× ×”',0),(319809,8884,'el','Î£ÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ Ï‡ÏŽÏÎ±',0),(319810,8884,'zh','æŒ‰å›½å®¶æŽ’åº\r\n',0),(319811,8884,'sv','BestÃ¤llning frÃ¥n land',0),(319812,8884,'it','Ordine dal paese',0),(319813,8884,'tl','',0),(319814,8884,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3611;&#3619;&#3632;&#3648;&#3607;&#3624;',0),(319815,8884,'hi','à¤¦à¥‡à¤¶ à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶',0),(319816,8884,'ms','Pesanan dari negara',0),(319817,8884,'ar','ØªØ±ØªÙŠØ¨ Ù…Ù† Ø§Ù„Ø¨Ù„Ø¯',0),(319818,8884,'fr','Ordre de pays',0),(319819,8884,'jp','å›½ã‹ã‚‰ã®é †åº',0),(319820,8884,'pt','Ordem de paÃ­s',0),(319821,8884,'ru','Ð—Ð°ÐºÐ°Ð· Ð˜Ð· Ð¡Ñ‚Ñ€Ð°Ð½Ñ‹',0),(319822,8884,'es','Ordenar Del PaÃ­s',0),(319823,8884,'de','Bestellung von Land',0),(319824,8884,'en','Order From Country',0),(319825,8885,'is','',0),(319826,8885,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø´Ø±Ø­ Ø§ÙŠÙ…ÙŠÙ„ ',0),(319827,8885,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø´Ø±Ø­ Ø§ÙŠÙ…ÙŠÙ„ ',0),(319828,8885,'tr','SipariÅŸ Ã¼zerinden e-posta aÃ§Ä±klamasÄ±',0),(319829,8885,'pl','ZamÃ³wiÄ‡ Email opis',0),(319830,8885,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ Ð¸Ð¼ÐµÐ¹Ð» Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(319831,8885,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª Ø³Û’ ØªØ±ØªÛŒØ¨',0),(319832,8885,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¸Ð· Ð•Ð¼Ð°Ð¸Ð» Ð¾Ð¿Ð¸Ñ',0),(319833,8885,'vi','Äáº·t hÃ ng tá»« email mÃ´ táº£',0),(319834,8885,'af','Bestellings Van E-pos Beskrywing',0),(319835,8885,'ro','Comanda la E-mail Descriere',0),(319836,8885,'et','Tellida e-posti kirjeldus',0),(319837,8885,'si','Nalog iz Email opis',0),(319838,8885,'ba','Order dari deskripsi Email',0),(319839,8885,'nl','Volgorde van E-mail beschrijving',0),(319840,8885,'fi','Tilauksen sÃ¤hkÃ¶posti kuvaus',0),(319841,8885,'no','Bestill fra e-beskrivelse',0),(319842,8885,'da','Ordre fra E-mail beskrivelse',0),(319843,8885,'ko','ì´ë©”ì¼ ì„¤ëª…ì—ì„œ ìˆœì„œ',0),(319844,8885,'he','×”×–×ž× ×” ×ž×ª×™××•×¨ ×“×•× ×œ',0),(319845,8885,'el','Î£ÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ Email Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(319846,8885,'zh','æŒ‰ç”µé‚®ä»‹ç»æŽ’åº\r\n',0),(319847,8885,'sv','BestÃ¤llning frÃ¥n e-Beskrivning',0),(319848,8885,'it','Ordine da Email Descrizione',0),(319849,8885,'tl','',0),(319850,8885,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3634;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(319851,8885,'hi','à¤†à¤¦à¥‡à¤¶ à¤ˆà¤®à¥‡à¤² à¤µà¤°à¥à¤£à¤¨ à¤¸à¥‡',0),(319852,8885,'ms','Pesanan daripada penerangan e-mel',0),(319853,8885,'ar','Ø£Ù…Ø± Ù…Ù† ÙˆØµÙ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(319854,8885,'fr','Ordre de Description Email',0),(319855,8885,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«ã®èª¬æ˜Žã‹ã‚‰ã®é †åº',0),(319856,8885,'pt','Ordem de descriÃ§Ã£o de E-mail',0),(319857,8885,'ru','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¾Ñ‚ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(319858,8885,'es','Ordenar De DescripciÃ³n de Email',0),(319859,8885,'de','Bestellung von E-Mail-Beschreibung',0),(319860,8885,'en','Order From Email Description',0),(319861,8886,'is','',0),(319862,8886,'dr','(Ø¨Ø§Ø²Ø¯ÙŠØ¯) Ù†Ø§Ù…Ù‡(Ù…Ø±Ø§Ø³Ù„Ø§Øª',0),(319863,8886,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø²  Ø§ÙŠØ³ØªÚ¯Ø§Ù‡(Ø¨Ø§Ø²Ø¯ÙŠØ¯) Ù†Ø§Ù…Ù‡(Ù…Ø±Ø§Ø³Ù„Ø§Øª',0),(319864,8886,'tr','SipariÅŸ posta duraÄŸÄ±',0),(319865,8886,'pl','ZamÃ³wienia od przystanku poczty',0),(319866,8886,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ Ð¿Ð¾Ñ‰Ð° ÑÑ‚Ð¾Ð¿',0),(319867,8886,'ur','ÚˆØ§Ú© Ø³Ù¹Ø§Ù¾ Ø³Û’ ØªØ±ØªÛŒØ¨',0),(319868,8886,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¸Ð· Ð¿Ð¾ÑˆÑ‚Ðµ ÑÑ‚Ð°Ð½Ð¸Ñ†Ð°',0),(319869,8886,'vi','Äáº·t hÃ ng tá»« bÆ°u Ä‘iá»‡n',0),(319870,8886,'af','Volgorde van e-pos Stop',0),(319871,8886,'ro','Ordine de staÅ£ie de Mail',0),(319872,8886,'et','Tellimuse posti peatus',0),(319873,8886,'si','Nalog iz poÅ¡te Stop',0),(319874,8886,'ba','Order dari Mail Stop',0),(319875,8886,'nl','Orde vanaf \"Stop\" Mail',0),(319876,8886,'fi','Postilokeron jÃ¤rjestyksessÃ¤',0),(319877,8886,'no','Ordre fra Mail stopp',0),(319878,8886,'da','Ordre fra Mail Stop',0),(319879,8886,'ko','ë©”ì¼ì—ì„œ ì£¼ë¬¸',0),(319880,8886,'he','×¡×“×¨ ×ž×ª×—× ×ª ×“×•××¨',0),(319881,8886,'el','Î£ÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ ÏƒÏ„Î¬ÏƒÎ· Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚',0),(319882,8886,'zh','æŒ‰é‚®ä»¶ç«™æŽ’åº\r\n',0),(319883,8886,'sv','BestÃ¤llning frÃ¥n e-Stop',0),(319884,8886,'it','Ordine da Mail Stop',0),(319885,8886,'tl','',0),(319886,8886,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3634;&#3591;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;',0),(319887,8886,'hi','à¤•à¥à¤°à¤® à¤¸à¥‡ à¤®à¥‡à¤² à¤°à¥‹à¤•à¥‡à¤‚',0),(319888,8886,'ms','Pesanan dari mel',0),(319889,8886,'ar','Ø£Ù…Ø± Ù…Ù† Ø¥ÙŠÙ‚Ø§Ù Ø§Ù„Ø¨Ø±ÙŠØ¯',0),(319890,8886,'fr','Ordre d\'arrÃªt de Mail',0),(319891,8886,'jp','ãƒ¡ãƒ¼ãƒ« ã‚¹ãƒˆãƒƒãƒ—ã‹ã‚‰ã®é †åº',0),(319892,8886,'pt','Ordem de paragem de correio',0),(319893,8886,'ru','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¾Ñ‚ Ð¾ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð¿Ð¾Ñ‡Ñ‚Ð°',0),(319894,8886,'es','Ordenar De Correo Stop',0),(319895,8886,'de','Bestellung von Mail-Haltestelle',0),(319896,8886,'en','Order From Mail Stop',0),(319897,8887,'is','',0),(319898,8887,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ù…Ø´Ø®ØµØ§Øª ØªÙ„ÙÙ† ',0),(319899,8887,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ù…Ø´Ø®ØµØ§Øª ØªÙ„ÙÙ† ',0),(319900,8887,'tr','SipariÅŸ telefon aÃ§Ä±klamalar',0),(319901,8887,'pl','ZamÃ³wiÄ‡ telefon opis',0),(319902,8887,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(319903,8887,'ur','ÙÙˆÙ† Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª Ø³Û’ ØªØ±ØªÛŒØ¨',0),(319904,8887,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¸Ð· Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð° Ð¾Ð¿Ð¸Ñ',0),(319905,8887,'vi','Äáº·t hÃ ng tá»« phone mÃ´ táº£',0),(319906,8887,'af','Bestelling Van Foon Beskrywing',0),(319907,8887,'ro','Comanda la telefon Descriere',0),(319908,8887,'et','Tellimuse telefoni kirjeldus',0),(319909,8887,'si','Nalog iz opisa telefon',0),(319910,8887,'ba','Order dari deskripsi telepon',0),(319911,8887,'nl','Volgorde van telefoon beschrijving',0),(319912,8887,'fi','JÃ¤rjestyksessÃ¤ puhelimen kuvaus',0),(319913,8887,'no','Bestill fra telefonen beskrivelse',0),(319914,8887,'da','Ordre fra telefon beskrivelse',0),(319915,8887,'ko','ì „í™” ì„¤ëª…ì—ì„œ ìˆœì„œ',0),(319916,8887,'he','×¡×“×¨ ×ž×Ÿ ×”×˜×œ×¤×•×Ÿ ×ª×™××•×¨',0),(319917,8887,'el','Î£ÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ Ï„Î·Î»Î­Ï†Ï‰Î½Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(319918,8887,'zh','æŒ‰æ‰‹æœºä»‹ç»æŽ’åº\r\n',0),(319919,8887,'sv','BestÃ¤llning frÃ¥n telefonen Beskrivning',0),(319920,8887,'it','Ordine da telefono Descrizione',0),(319921,8887,'tl','',0),(319922,8887,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3634;&#3591;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(319923,8887,'hi','à¤«à¤¼à¥‹à¤¨ à¤µà¤¿à¤µà¤°à¤£ à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶',0),(319924,8887,'ms','Pesanan daripada penerangan telefon',0),(319925,8887,'ar','Ø£Ù…Ø± Ù…Ù† ÙˆØµÙ Ø§Ù„Ù‡Ø§ØªÙ',0),(319926,8887,'fr','Ordre de Description du tÃ©lÃ©phone',0),(319927,8887,'jp','æºå¸¯é›»è©±ã®èª¬æ˜Žã‹ã‚‰ã®é †åº',0),(319928,8887,'pt','Ordem de descriÃ§Ã£o de telefone',0),(319929,8887,'ru','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¾Ñ‚ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(319930,8887,'es','Ordenar De DescripciÃ³n de TelÃ©fono',0),(319931,8887,'de','Bestellung von Telefon-Beschreibung',0),(319932,8887,'en','Order From Phone Description',0),(319933,8888,'is','',0),(319934,8888,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(319935,8888,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² ÙƒØ¯ Ù¾Ø³ØªÙŠ ',0),(319936,8888,'tr','Posta kodu sipariÅŸi',0),(319937,8888,'pl','ZamÃ³wiÄ‡ kod pocztowy',0),(319938,8888,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(319939,8888,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÙˆÚˆ Ø³Û’ ØªØ±ØªÛŒØ¨',0),(319940,8888,'sr','ÐÐ°Ñ€ÐµÑ’ÐµÑšÐµ : Ð¿Ð¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(319941,8888,'vi','Äáº·t hÃ ng tá»« hÃ²m thÆ°',0),(319942,8888,'af','Bestelling Vanaf Poskode',0),(319943,8888,'ro','Comanda de la cod poÅŸtal',0),(319944,8888,'et','Tellimusele reserveeritava sihtnumber',0),(319945,8888,'si','Nalog iz poÅ¡tne',0),(319946,8888,'ba','Order dari kode pos',0),(319947,8888,'nl','Volgorde van postcode',0),(319948,8888,'fi','Tilauksen postinumero',0),(319949,8888,'no','Bestill fra postnummer',0),(319950,8888,'da','Ordre fra postnummer',0),(319951,8888,'ko','ìš°íŽ¸ ë²ˆí˜¸ì—ì„œ ìˆœì„œ',0),(319952,8888,'he','×”×–×ž× ×” ×ž×ž×™×§×•×“',0),(319953,8888,'el','Î£ÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ Î¤Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(319954,8888,'zh','æŒ‰é‚®æ”¿ç¼–ç æŽ’åº\r\n',0),(319955,8888,'sv','BestÃ¤llning frÃ¥n postnummer',0),(319956,8888,'it','Ordine dal codice postale',0),(319957,8888,'tl','',0),(319958,8888,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3619;&#3627;&#3633;&#3626;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;',0),(319959,8888,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿà¤² à¤•à¥‹à¤¡ à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶',0),(319960,8888,'ms','Pesanan dari Poskod',0),(319961,8888,'ar','Ø£Ù…Ø± Ù…Ù† Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(319962,8888,'fr','Ordre de Code Postal',0),(319963,8888,'jp','éƒµä¾¿ç•ªå·ã‹ã‚‰ã®æ³¨æ–‡',0),(319964,8888,'pt','Ordem de CÃ³digo Postal',0),(319965,8888,'ru','Ð—Ð°ÐºÐ°Ð· Ð¡ ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ð¾Ð³Ð¾ Ð˜Ð½Ð´ÐµÐºÑÐ°',0),(319966,8888,'es','Ordenar De CÃ³digo Postal',0),(319967,8888,'de','Reihenfolge von Postleitzahl',0),(319968,8888,'en','Order From Postal Code',0),(319969,8889,'is','',0),(319970,8889,'dr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø§Ø³ØªØ§Ù†',0),(319971,8889,'pr','Ø³ÙØ§Ø±Ø´ Ø§Ø² Ø§Ø³ØªØ§Ù†',0),(319972,8889,'tr','SipariÅŸ durumu',0),(319973,8889,'pl','KolejnoÅ›ci od PaÅ„stwa',0),(319974,8889,'bg','Ð ÐµÐ´ Ð¾Ñ‚ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°Ñ‚Ð°',0),(319975,8889,'ur','Ø±ÛŒØ§Ø³Øª Ø³Û’ ØªØ±ØªÛŒØ¨',0),(319976,8889,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¸Ð· ÑÑ‚Ð°ÑšÐ°',0),(319977,8889,'vi','Äáº·t hÃ ng tá»« tiá»ƒu bang',0),(319978,8889,'af','Bestelling Van Staat (Landsgebied)',0),(319979,8889,'ro','Comanda de la stat',0),(319980,8889,'et','Tellimuse riik',0),(319981,8889,'si','Nalog iz drÅ¾avne',0),(319982,8889,'ba','Order dari negara',0),(319983,8889,'nl','Bestelling van staat',0),(319984,8889,'fi','Tilauksen tila',0),(319985,8889,'no','Bestill fra staten',0),(319986,8889,'da','Ordre fra staten',0),(319987,8889,'ko','ìƒíƒœì—ì„œ ì£¼ë¬¸',0),(319988,8889,'he','×¡×“×¨ ×ž×ž×¦×‘',0),(319989,8889,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Ï€ÏŒ Ï„Î¿ ÎºÏÎ¬Ï„Î¿Ï‚',0),(319990,8889,'zh','æŒ‰å·žæŽ’åº\r\n',0),(319991,8889,'sv','BestÃ¤llning frÃ¥n staten',0),(319992,8889,'it','Ordine di stato',0),(319993,8889,'tl','',0),(319994,8889,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3592;&#3634;&#3585;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(319995,8889,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶',0),(319996,8889,'ms','Pesanan dari Negeri',0),(319997,8889,'ar','Ø£Ù…Ø± Ù…Ù† Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(319998,8889,'fr','Ordre de l\'Ã‰tat',0),(319999,8889,'jp','çŠ¶æ…‹ã‹ã‚‰ã®é †åº',0),(320000,8889,'pt','Ordem de estado',0),(320001,8889,'ru','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¾Ñ‚ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð°',0),(320002,8889,'es','Ordenar De Estado',0),(320003,8889,'de','Auftrag von Staat',0),(320004,8889,'en','Order From State',0),(320005,8890,'is','',0),(320006,8890,'dr','Ú†Ø§Ù¾ ÙŠØ§ Ø§ÙŠÙ…ÙŠÙ„ Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ±',0),(320007,8890,'pr','Ú†Ø§Ù¾ ÙŠØ§ Ø§ÙŠÙ…ÙŠÙ„ Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ±',0),(320008,8890,'tr','Bas veya e-posta bu fatura',0),(320009,8890,'pl','Drukuj lub E-mail tej faktury',0),(320010,8890,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¸Ð»Ð¸ Email Ñ‚Ð°Ð·Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(320011,8890,'ur','Ù¾Ø±Ù†Ù¹ Ú©Ø±Ù†Û’ ÛŒØ§ Ø§Ø³ Ú©Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(320012,8890,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ðµ-Ð¼Ð°Ð¸Ð»Ð¾Ð¼ Ð¾Ð²Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(320013,8890,'vi','In hay Email hÃ³a Ä‘Æ¡n nÃ y',0),(320014,8890,'af','Druk of E-pos hierdie Faktuur',0),(320015,8890,'ro','Imprimare sau E-mail aceastÄƒ facturÄƒ',0),(320016,8890,'et','Prindi see arve vÃµi saada e-kirjaga',0),(320017,8890,'si','Tiskanje ali Email tega raÄuna',0),(320018,8890,'ba','Cetak atau Email faktur ini',0),(320019,8890,'nl','Print of Email deze factuur',0),(320020,8890,'fi','Tulosta tai sÃ¤hkÃ¶postitse tÃ¤hÃ¤n laskuun',0),(320021,8890,'no','Avtrykk eller Email denne fakturaen',0),(320022,8890,'da','Print eller Email denne faktura',0),(320023,8890,'ko','ì¸ì‡„ ë˜ëŠ” ì´ë©”ì¼ì´ì´ ì†¡ìž¥',0),(320024,8890,'he','×”×“×¤×¡ ××• ×©×œ×— ×‘×•×“×\"×œ ×—×©×‘×•× ×™×ª ×–×•',0),(320025,8890,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· \"Î®\" Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(320026,8890,'zh','æ‰“å°æˆ–é€šè¿‡ç”µå­é‚®ä»¶å‘é€å‘ç¥¨\r\n',0),(320027,8890,'sv','Skriva ut eller e-fakturan',0),(320028,8890,'it','Stampare o E-mail questa fattura',0),(320029,8890,'tl','',0),(320030,8890,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3627;&#3619;&#3639;&#3629;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(320031,8890,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤¯à¤¾ à¤ˆà¤®à¥‡à¤² à¤‡à¤¸ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸',0),(320032,8890,'ms','Cetak atau e-mel invois ini',0),(320033,8890,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø£Ùˆ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù‡Ø°Ù‡ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(320034,8890,'fr','Imprimer ou envoyer cette facture',0),(320035,8890,'jp','å°åˆ·ã¾ãŸã¯ã“ã®è«‹æ±‚æ›¸ã®é›»å­ãƒ¡ãƒ¼ãƒ«',0),(320036,8890,'pt','ImpressÃ£o ou E-mail esta fatura',0),(320037,8890,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¸Ð»Ð¸ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ ÑÑ‡ÐµÑ‚',0),(320038,8890,'es','Imprimir o Email esta Factura',0),(320039,8890,'de','Drucken oder per E-Mail diese Rechnung',0),(320040,8890,'en','Print or Email this Invoice',0),(320041,8891,'is','',0),(320042,8891,'dr','ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯ ',0),(320043,8891,'pr','ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯ ',0),(320044,8891,'tr','Eklemek iÃ§in tÄ±klatÄ±n',0),(320045,8891,'pl','Kliknij, aby dodaÄ‡',0),(320046,8891,'bg','ÐÐ°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð±ÑƒÑ‚Ð¾Ð½Ð° Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(320047,8891,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(320048,8891,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸',0),(320049,8891,'vi','Nháº¥n Ä‘á»ƒ thÃªm',0),(320050,8891,'af','Kliek vir Byvoeging',0),(320051,8891,'ro','FaceÅ£i clic pentru a adÄƒuga',0),(320052,8891,'et','Kliki lisamiseks',0),(320053,8891,'si','Kliknite, Äe Å¾elite dodati',0),(320054,8891,'ba','Klik untuk menambahkan',0),(320055,8891,'nl','Klik om toe te voegen',0),(320056,8891,'fi','LisÃ¤Ã¤ napsauttamalla',0),(320057,8891,'no','Klikk for Ã¥ legge til',0),(320058,8891,'da','Klik for at tilfÃ¸je',0),(320059,8891,'ko','ì¶”ê°€ í•˜ë ¤ë©´ í´ë¦­',0),(320060,8891,'he','×œ×—×¥ ×›×“×™ ×œ×”×•×¡×™×£',0),(320061,8891,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(320062,8891,'zh','ç‚¹å‡»æ·»åŠ \r\n',0),(320063,8891,'sv','Klicka fÃ¶r att lÃ¤gga till',0),(320064,8891,'it','Fare clic per aggiungere',0),(320065,8891,'tl','',0),(320066,8891,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(320067,8891,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(320068,8891,'ms','Klik untuk menambah',0),(320069,8891,'ar','Ø£Ù†Ù‚Ø± Ù„Ù„Ø¥Ø¶Ø§ÙØ©',0),(320070,8891,'fr','Cliquez ici pour ajouter',0),(320071,8891,'jp','ã‚¯ãƒªãƒƒã‚¯ã—ã¦ã‚’è¿½åŠ ã™ã‚‹ã«ã¯',0),(320072,8891,'pt','Clique para adicionar',0),(320073,8891,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð§Ñ‚Ð¾Ð±Ñ‹ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(320074,8891,'es','Hace Click para Agregar',0),(320075,8891,'de','Klicken Sie auf HinzufÃ¼gen',0),(320076,8891,'en','Click to Add',0),(320077,8892,'is','',0),(320078,8892,'dr','Ø­Ø°Ù Ù†ÙˆØ¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(320079,8892,'pr','Ø­Ø°Ù Ù†ÙˆØ¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(320080,8892,'tr','SatÄ±cÄ± tÃ¼rÃ¼ baÅŸarÄ±yla silindi',0),(320081,8892,'pl','UsuniÄ™ty typ dostawcy',0),(320082,8892,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ñ‚Ð¸Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(320083,8892,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ ÙˆÛŒÙ†ÚˆØ± Ù‚Ø³Ù…',0),(320084,8892,'sr','Ð¢Ð¸Ð¿ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(320085,8892,'vi','XÃ³a Loáº¡i NgÆ°á»i bÃ¡n thÃ nh cÃ´ng',0),(320086,8892,'af','Verskaffertipe Suksesvol Geskrap',0),(320087,8892,'ro','Tip furnizor eliminÄƒ cu succes',0),(320088,8892,'et','Hankija tÃ¼Ã¼pi edukalt kustutatud',0),(320089,8892,'si','Prodajalec vrsto uspeÅ¡no izbrisana',0),(320090,8892,'ba','Penjual jenis dihapus berhasil',0),(320091,8892,'nl','Fabrikanttype succesvol verwijderd',0),(320092,8892,'fi','Toimittajan tyyppi poistettu',0),(320093,8892,'no','LeverandÃ¸rtypen slettet',0),(320094,8892,'da','Kreditortype slettet',0),(320095,8892,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ê³µê¸‰ ì—…ì²´ ìœ í˜•',0),(320096,8892,'he','×¡×•×’ ×¡×¤×§ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(320097,8892,'el','Î¤ÏÏ€Î¿Ï‚ Ï€Ï‰Î»Î·Ï„Î® Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(320098,8892,'zh','ä¾›åº”å•†ç±»åž‹æˆåŠŸåˆ é™¤\r\n',0),(320099,8892,'sv','LeverantÃ¶rstyp raderades',0),(320100,8892,'it','Tipo di fornitore eliminato con successo',0),(320101,8892,'tl','',0),(320102,8892,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(320103,8892,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾',0),(320104,8892,'ms','Jenis pembekal yang telah dihapuskan dengan jayanya',0),(320105,8892,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(320106,8892,'fr','Type de fournisseur supprimÃ© avec succÃ¨s',0),(320107,8892,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ã‚¿ã‚¤ãƒ—ã«ã‚ˆã£ã¦å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(320108,8892,'pt','Tipo de fornecedor apagado com sucesso',0),(320109,8892,'ru','Ð¢Ð¸Ð¿ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½',0),(320110,8892,'es','Tipo de Proveedor Eliminado Exitosamente',0),(320111,8892,'de','Herstellertyp erfolgreich gelÃ¶scht',0),(320112,8892,'en','Vendor Type Deleted Successfully',0),(320113,8893,'is','',0),(320114,8893,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(320115,8893,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(320116,8893,'tr','SatÄ±cÄ± tÃ¼rÃ¼ gÃ¼ncelleÅŸtirme',0),(320117,8893,'pl','Dostawcy typu aktualizacji',0),(320118,8893,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ñ‚Ð¸Ð¿ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(320119,8893,'ur','ÙˆÛŒÙ†ÚˆØ± Ù‚Ø³Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(320120,8893,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ð¸Ð¿ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(320121,8893,'vi','Cáº­p Nháº­t loáº¡i NgÆ°á»i BÃ¡n',0),(320122,8893,'af','Verskaffer Tipe Opdateer',0),(320123,8893,'ro','Actualizare de tip furnizor',0),(320124,8893,'et','Hankija tÃ¼Ã¼pi vÃ¤rskendus',0),(320125,8893,'si','Prodajalec vrste posodobitev',0),(320126,8893,'ba','Penjual jenis Update',0),(320127,8893,'nl','Leverancier Type Update',0),(320128,8893,'fi','Toimittajan tyypin pÃ¤ivitys',0),(320129,8893,'no','LeverandÃ¸ren Type oppdatering',0),(320130,8893,'da','Kreditor Type opdatering',0),(320131,8893,'ko','ê³µê¸‰ ì—…ì²´ í˜•ì‹ ì—…ë°ì´íŠ¸',0),(320132,8893,'he','×¢×“×›×•×Ÿ ×¡×•×’ ×”×¡×¤×§',0),(320133,8893,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(320134,8893,'zh','ä¾›åº”å•†ç±»åž‹æ›´æ–°\r\n',0),(320135,8893,'sv','LeverantÃ¶r typ uppdatering',0),(320136,8893,'it','Aggiornamento del tipo di fornitore',0),(320137,8893,'tl','',0),(320138,8893,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(320139,8893,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(320140,8893,'ms','Kemaskini jenis Penjual',0),(320141,8893,'ar','ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(320142,8893,'fr','Mise Ã  jour du Type de fournisseur',0),(320143,8893,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®ç¨®é¡žæ›´æ–°',0),(320144,8893,'pt','ActualizaÃ§Ã£o do tipo de fornecedor',0),(320145,8893,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(320146,8893,'es','Tipo de Proveedor Actualizar',0),(320147,8893,'de','Hersteller Typ Update',0),(320148,8893,'en','Vendor Type Update',0),(320149,8894,'is','',0),(320150,8894,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(320151,8894,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(320152,8894,'tr','SatÄ±cÄ± tÃ¼rÃ¼ Ekle',0),(320153,8894,'pl','Dodaj typ dostawcy',0),(320154,8894,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(320155,8894,'ur','ÙˆÛŒÙ†ÚˆØ± Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(320156,8894,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ñ‚Ð¸Ð¿',0),(320157,8894,'vi','ThÃªm Loáº¡i NgÆ°á»i bÃ¡n',0),(320158,8894,'af','Verskaffer Tipe Byvoeg',0),(320159,8894,'ro','Adauga furnizor de tip',0),(320160,8894,'et','Hankija tÃ¼Ã¼pi lisada',0),(320161,8894,'si','Vrsta dobavitelja dodate',0),(320162,8894,'ba','Jenis Penjual menambahkan',0),(320163,8894,'nl','Fabrikanttype toevoegen',0),(320164,8894,'fi','ToimittajatyyppiÃ¤ lisÃ¤Ã¤',0),(320165,8894,'no','LeverandÃ¸rtypen legge',0),(320166,8894,'da','Kreditortype tilfÃ¸je',0),(320167,8894,'ko','ê³µê¸‰ ì—…ì²´ ìœ í˜• ì¶”ê°€',0),(320168,8894,'he','×¡×•×’ ×¡×¤×§ ×œ×”×•×¡×™×£',0),(320169,8894,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„ÏÏ€Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(320170,8894,'zh','ä¾›åº”å•†ç±»åž‹æ·»åŠ \r\n',0),(320171,8894,'sv','LeverantÃ¶rstyp lÃ¤gga',0),(320172,8894,'it','Aggiungi tipo fornitore',0),(320173,8894,'tl','',0),(320174,8894,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(320175,8894,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(320176,8894,'ms','Tambah jenis Penjual',0),(320177,8894,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ù…ÙˆØ±Ø¯',0),(320178,8894,'fr','Type de fournisseur ajouter',0),(320179,8894,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ã‚¿ã‚¤ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(320180,8894,'pt','Adicionar o tipo de fornecedor',0),(320181,8894,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¸Ð¿ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(320182,8894,'es','Agregar Tipo de Proveedor',0),(320183,8894,'de','Herstellertyp hinzufÃ¼gen',0),(320184,8894,'en','Vendor Type Add',0),(320185,8895,'is','',0),(320186,8895,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù…Ø´ØªØ±ÙŠ',0),(320187,8895,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù…Ø´ØªØ±ÙŠ',0),(320188,8895,'tr','Ä°stemci arama',0),(320189,8895,'pl','Wyszukiwania klienta',0),(320190,8895,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(320191,8895,'ur','ÙˆØµÙˆÙ„ Ú©Ø§Ø± Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(320192,8895,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(320193,8895,'vi','TÃ¬m KhÃ¡ch hÃ ng',0),(320194,8895,'af','KliÃ«nt opsoek',0),(320195,8895,'ro','Client de cÄƒutare',0),(320196,8895,'et','Kliendi otsing',0),(320197,8895,'si','Odjemalec za iskanje',0),(320198,8895,'ba','Klien Lookup',0),(320199,8895,'nl','Client Lookup',0),(320200,8895,'fi','Asiakkaan haku',0),(320201,8895,'no','Klienten oppslag',0),(320202,8895,'da','Klienten opslag',0),(320203,8895,'ko','í´ë¼ì´ì–¸íŠ¸ ì¡°íšŒ',0),(320204,8895,'he','×‘×“×™×§×ª ×ž×™×“×¢ ×œ×œ×§×•×—',0),(320205,8895,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Ï€ÎµÎ»Î¬Ï„Î·',0),(320206,8895,'zh','å®¢æˆ·æŸ¥è¯¢\r\n',0),(320207,8895,'sv','Klienten Lookup',0),(320208,8895,'it','Ricerca del cliente',0),(320209,8895,'tl','',0),(320210,8895,'th','&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;&#3612;&#3641;&#3657;&#3592;&#3657;&#3634;&#3591;',0),(320211,8895,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤²à¥à¤•à¤…à¤ª',0),(320212,8895,'ms','Cari pelanggan',0),(320213,8895,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(320214,8895,'fr','Recherche client',0),(320215,8895,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆæ¤œç´¢',0),(320216,8895,'pt','Pesquisa do cliente',0),(320217,8895,'ru','ÐŸÐ¾Ð¸ÑÐº ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(320218,8895,'es','Buscar Cliente',0),(320219,8895,'de','Client-Lookup',0),(320220,8895,'en','Client Lookup',0),(320221,8896,'is','',0),(320222,8896,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±ÙˆÚ˜Ù‡',0),(320223,8896,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±ÙˆÚ˜Ù‡',0),(320224,8896,'tr','Proje Ekle',0),(320225,8896,'pl','Dodaj projekt',0),(320226,8896,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(320227,8896,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(320228,8896,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(320229,8896,'vi','ThÃªm Dá»± Ã¡n',0),(320230,8896,'af','Projek Byvoeg',0),(320231,8896,'ro','Adauga proiect',0),(320232,8896,'et','Projekti lisamine',0),(320233,8896,'si','Projekt dodate',0),(320234,8896,'ba','Tambahkan proyek',0),(320235,8896,'nl','Project toevoegen',0),(320236,8896,'fi','Project lisÃ¤Ã¤',0),(320237,8896,'no','Project legger til',0),(320238,8896,'da','Projektet tilfÃ¸je',0),(320239,8896,'ko','í”„ë¡œì íŠ¸ ì¶”ê°€',0),(320240,8896,'he','×”×•×¡×¤×ª ×¤×¨×•×™×™×§×˜',0),(320241,8896,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î­ÏÎ³Î¿Ï…',0),(320242,8896,'zh','æ–°å¢žé¡¹ç›®\r\n',0),(320243,8896,'sv','Projektet lÃ¤gga till',0),(320244,8896,'it','Aggiungi progetto',0),(320245,8896,'tl','',0),(320246,8896,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(320247,8896,'hi','à¤ªà¥à¤°à¥‹à¤œà¥‡à¤•à¥à¤Ÿ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(320248,8896,'ms','Projek menambah',0),(320249,8896,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(320250,8896,'fr','Projet ajouter',0),(320251,8896,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(320252,8896,'pt','Adicionar o projeto',0),(320253,8896,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(320254,8896,'es','Agregar Proyecto',0),(320255,8896,'de','Projekt hinzufÃ¼gen',0),(320256,8896,'en','Project Add',0),(320257,8897,'is','',0),(320258,8897,'dr','Ù†Ø§Ù… Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(320259,8897,'pr','Ù†Ø§Ù… Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(320260,8897,'tr','Proje adÄ±',0),(320261,8897,'pl','Nazwa projektu',0),(320262,8897,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(320263,8897,'ur','Ù†Ø§Ù… Ù¾Ø±ÙˆØ¬ÛŒÚ©Ù¹',0),(320264,8897,'sr','Ð˜Ð¼Ðµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(320265,8897,'vi','TÃªn Dá»± Ã¡n',0),(320266,8897,'af','Projek Naam',0),(320267,8897,'ro','Numele proiectului',0),(320268,8897,'et','Projekti nimi',0),(320269,8897,'si','Ime projekta',0),(320270,8897,'ba','Nama proyek',0),(320271,8897,'nl','Naam van het project',0),(320272,8897,'fi','Projektinimi',0),(320273,8897,'no','Prosjektnavnet',0),(320274,8897,'da','Projektnavn',0),(320275,8897,'ko','í”„ë¡œì íŠ¸ ì´ë¦„',0),(320276,8897,'he','×©× ×¤×¨×•×™×™×§×˜',0),(320277,8897,'el','ÎŒÎ½Î¿Î¼Î± Î­ÏÎ³Î¿Ï…',0),(320278,8897,'zh','é¡¹ç›®åç§°\r\n',0),(320279,8897,'sv','Projektets namn',0),(320280,8897,'it','Nome del progetto',0),(320281,8897,'tl','',0),(320282,8897,'th','&#3594;&#3639;&#3656;&#3629;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(320283,8897,'hi','à¤ªà¥à¤°à¥‹à¤œà¥‡à¤•à¥à¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(320284,8897,'ms','Nama projek',0),(320285,8897,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(320286,8897,'fr','Nom du projet',0),(320287,8897,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆå',0),(320288,8897,'pt','Nome do projeto',0),(320289,8897,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(320290,8897,'es','Nombre de Proyecto',0),(320291,8897,'de','Projektname',0),(320292,8897,'en','Project Name',0),(320293,8898,'is','',0),(320294,8898,'dr','Ù‚Ø§Ù„Ø¨ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(320295,8898,'pr','Ù‚Ø§Ù„Ø¨ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(320296,8898,'tr','Proje ÅŸablonu',0),(320297,8898,'pl','Szablon projektu',0),(320298,8898,'bg','Ð¨Ð°Ð±Ð»Ð¾Ð½ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(320299,8898,'ur','Ù¾Ø±ÙˆØ¬ÛŒÚ©Ù¹ Ø³Ø§Ù†Ú†Û’',0),(320300,8898,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(320301,8898,'vi','Báº£n máº«u Dá»± Ã¡n',0),(320302,8898,'af','Projek Sjabloon (\"template\")',0),(320303,8898,'ro','Proiect ÅŸablon',0),(320304,8898,'et','Projekti Mall',0),(320305,8898,'si','Projectova predloga',0),(320306,8898,'ba','Proyek Template',0),(320307,8898,'nl','Project-sjabloon',0),(320308,8898,'fi','Projektimalli',0),(320309,8898,'no','Prosjektmal',0),(320310,8898,'da','Project-skabelon',0),(320311,8898,'ko','í”„ë¡œì íŠ¸ ì„œì‹ íŒŒì¼',0),(320312,8898,'he','×ª×‘× ×™×ª ×¤×¨×•×™×§×˜',0),(320313,8898,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ Î­ÏÎ³Î¿Ï…',0),(320314,8898,'zh','é¡¹ç›®æ¨¡æ¿\r\n',0),(320315,8898,'sv','Projektmall',0),(320316,8898,'it','Modello di progetto',0),(320317,8898,'tl','',0),(320318,8898,'th','&#3648;&#3607;&#3655;&#3617;&#3648;&#3614;&#3621;&#3605;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(320319,8898,'hi','à¤ªà¥à¤°à¥‹à¤œà¥‡à¤•à¥à¤Ÿ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ',0),(320320,8898,'ms','Template projek',0),(320321,8898,'ar','Ù‚Ø§Ù„Ø¨ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(320322,8898,'fr','ModÃ¨le de projet',0),(320323,8898,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆ ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ',0),(320324,8898,'pt','Modelo de projeto',0),(320325,8898,'ru','Ð¨Ð°Ð±Ð»Ð¾Ð½ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(320326,8898,'es','Plantilla de Proyecto',0),(320327,8898,'de','Projektvorlage',0),(320328,8898,'en','Project Template',0),(320329,8899,'is','',0),(320330,8899,'dr','Ù†ÙˆØ¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(320331,8899,'pr','Ù†ÙˆØ¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(320332,8899,'tr','SatÄ±cÄ± tÃ¼rÃ¼',0),(320333,8899,'pl','Typ dostawcy',0),(320334,8899,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(320335,8899,'ur','ÙˆÛŒÙ†ÚˆØ± Ù‚Ø³Ù…',0),(320336,8899,'sr','Ð¢Ð¸Ð¿ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(320337,8899,'vi','Loáº¡i NgÆ°á»i bÃ¡n',0),(320338,8899,'af','Verskaffer Tipe',0),(320339,8899,'ro','Tip furnizor',0),(320340,8899,'et','Tarnija tÃ¼Ã¼p',0),(320341,8899,'si','Vrsta dobavitelja',0),(320342,8899,'ba','Jenis Penjual',0),(320343,8899,'nl','Fabrikanttype',0),(320344,8899,'fi','Toimittajan tyyppi',0),(320345,8899,'no','LeverandÃ¸rtypen',0),(320346,8899,'da','Kreditortype',0),(320347,8899,'ko','ê³µê¸‰ ì—…ì²´ ìœ í˜•',0),(320348,8899,'he','×¡×•×’ ×¡×¤×§',0),(320349,8899,'el','Î¤ÏÏ€Î¿Ï‚ Ï€Ï‰Î»Î·Ï„Î®',0),(320350,8899,'zh','ä¾›åº”å•†ç±»åž‹\r\n',0),(320351,8899,'sv','LeverantÃ¶rstyp',0),(320352,8899,'it','Tipo fornitore',0),(320353,8899,'tl','',0),(320354,8899,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(320355,8899,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(320356,8899,'ms','Jenis pembekal',0),(320357,8899,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(320358,8899,'fr','Type de fournisseur',0),(320359,8899,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ã‚¿ã‚¤ãƒ—',0),(320360,8899,'pt','Tipo de fornecedor',0),(320361,8899,'ru','Ð¢Ð¸Ð¿ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(320362,8899,'es','Tipo de Proveedor',0),(320363,8899,'de','Herstellertyp',0),(320364,8899,'en','Vendor Type',0),(320365,8900,'is','',0),(320366,8900,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø§Ù†ÙˆØ§Ø¹ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†',0),(320367,8900,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†ÙˆØ§Ø¹ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†',0),(320368,8900,'tr','Tipleri satÄ±cÄ±larÄ±nÄ±n girin/gÃ¼ncelleme',0),(320369,8900,'pl','WprowadÅº/zaktualizuj typy dostawcÃ³w',0),(320370,8900,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(320371,8900,'ur','Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù… Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(320372,8900,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð²Ñ€ÑÑ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(320373,8900,'vi','Nháº­p/Cáº­p Nháº­t Loáº¡i NgÆ°á»i BÃ¡n',0),(320374,8900,'af','Invoer/Opdateer tipes Verskaffers',0),(320375,8900,'ro','IntroduceÅ£i/actualizare tipuri de furnizori',0),(320376,8900,'et','Sisesta/uuenda tarnijate tÃ¼Ã¼pi',0),(320377,8900,'si','Vnos/posodobitev vrste prodajalcev',0),(320378,8900,'ba','Masukkan/Update jenis vendor',0),(320379,8900,'nl','Soorten leveranciers invoeren/bijwerken',0),(320380,8900,'fi','PÃ¤ivittÃ¤minen tyyppisiÃ¤ ovat toimittajat',0),(320381,8900,'no','Angi/Oppdater typer leverandÃ¸rer',0),(320382,8900,'da','Indtaste/opdatere typer af leverandÃ¸rer',0),(320383,8900,'ko','ê³µê¸‰ ì—…ì²´ì˜ ì¢…ë¥˜ë¥¼ ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(320384,8900,'he','×”×›× ×¡/×¢×“×›×Ÿ ×¡×•×’×™ ×¡×¤×§×™×',0),(320385,8900,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Î¹ Ï„Ï‰Î½ Ï€Ï‰Î»Î·Ï„ÏŽÎ½',0),(320386,8900,'zh','è¾“å…¥/æ›´æ–°çš„ä¾›åº”å•†ç±»åž‹',0),(320387,8900,'sv','Ange/uppdatera typer av leverantÃ¶rer',0),(320388,8900,'it','Inserisci/Aggiorna tipi di fornitori',0),(320389,8900,'tl','',0),(320390,8900,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(320391,8900,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(320392,8900,'ms','Masukkan/Kemaskini jenis vendor',0),(320393,8900,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ†',0),(320394,8900,'fr','Entrez/mise Ã  jour des Types de fournisseurs',0),(320395,8900,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®ç¨®é¡žã®å…¥åŠ›/æ›´æ–°',0),(320396,8900,'pt','Inserir/atualizar tipos de fornecedores',0),(320397,8900,'ru','Ð’Ð²Ð¾Ð´/ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¢Ð¸Ð¿Ð° ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(320398,8900,'es','Introducir/Actualizar Tipos de Proveedores',0),(320399,8900,'de','Arten von Anbietern geben Sie/Update',0),(320400,8900,'en','Enter/Update Types of Vendors',0),(320401,8901,'is','',0),(320402,8901,'dr','Ø§Ù†ÙˆØ§Ø¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(320403,8901,'pr','Ø§Ù†ÙˆØ§Ø¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(320404,8901,'tr','SatÄ±cÄ± tÃ¼rÃ¼',0),(320405,8901,'pl','Dostawcy typÃ³w',0),(320406,8901,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(320407,8901,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§Ù‚Ø³Ø§Ù…',0),(320408,8901,'sr','Ð¢Ð¸Ð¿Ð¾Ð²Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(320409,8901,'vi','Loáº¡i NgÆ°á»i bÃ¡n',0),(320410,8901,'af','Verskaffer Tipes',0),(320411,8901,'ro','Tipuri furnizor',0),(320412,8901,'et','Hankija tÃ¼Ã¼bid',0),(320413,8901,'si','Vrste dobavitelja',0),(320414,8901,'ba','Jenis Penjual',0),(320415,8901,'nl','Leveranciertypen',0),(320416,8901,'fi','Toimittajat',0),(320417,8901,'no','LeverandÃ¸ren typer',0),(320418,8901,'da','Kreditor typer',0),(320419,8901,'ko','ê³µê¸‰ ì—…ì²´ ìœ í˜•',0),(320420,8901,'he','×¡×•×’×™ ×¡×¤×§×™×',0),(320421,8901,'el','Î¤ÏÏ€Î¿Î¹ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(320422,8901,'zh','ä¾›åº”å•†ç±»åž‹\r\n',0),(320423,8901,'sv','LeverantÃ¶rstyper',0),(320424,8901,'it','Tipi di fornitore',0),(320425,8901,'tl','',0),(320426,8901,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(320427,8901,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(320428,8901,'ms','Jenis pembekal',0),(320429,8901,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ†',0),(320430,8901,'fr','Types de fournisseur',0),(320431,8901,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ã‚¿ã‚¤ãƒ—',0),(320432,8901,'pt','Tipos de fornecedor',0),(320433,8901,'ru','Ð¢Ð¸Ð¿Ñ‹ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(320434,8901,'es','Tipos de Proveedores',0),(320435,8901,'de','VerkÃ¤ufer-Typen',0),(320436,8901,'en','Vendor Types',0),(320437,8902,'is','',0),(320438,8902,'dr','ØªØ§ÙŠÙŠØ¯ Ø­Ø°Ù Ø³Ø·Ø± ',0),(320439,8902,'pr','ØªØ§ÙŠÙŠØ¯ Ø­Ø°Ù Ø³Ø·Ø± ',0),(320440,8902,'tr','SatÄ±r Silmeyi Onayla',0),(320441,8902,'pl','PotwierdziÄ‡ usunÄ…Ä‡ wiersz',0),(320442,8902,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð½Ð¸Ñ',0),(320443,8902,'ur','Ù„Ø§Ø¦Ù† Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(320444,8902,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÐµ Ñ€ÐµÐ´Ð°',0),(320445,8902,'vi','XÃ¡c nháº­n hÃ ng xÃ³a',0),(320446,8902,'af','Bevestig om Lyn te Skrap',0),(320447,8902,'ro','ConfirmaÅ£i pentru a ÅŸterge linia',0),(320448,8902,'et','Kinnita rea kustutamine',0),(320449,8902,'si','Potrdite, Äe Å¾elite izbrisati Ärto',0),(320450,8902,'ba','Pastikan untuk menghapus baris',0),(320451,8902,'nl','Bevestigen om regel te verwijderen',0),(320452,8902,'fi','Vahvista rivi poistetaan',0),(320453,8902,'no','Bekreft for Ã¥ slette linjen',0),(320454,8902,'da','BekrÃ¦ft for at slette linjen',0),(320455,8902,'ko','ì„  ì‚­ì œ í™•ì¸',0),(320456,8902,'he','×œ××©×¨ ×œ×ž×—×•×§ ×§×•',0),(320457,8902,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÏ„Îµ Î³Î¹Î± Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î· Î³ÏÎ±Î¼Î¼Î®',0),(320458,8902,'zh','ç¡®è®¤è¦åˆ é™¤è¡Œ\r\n',0),(320459,8902,'sv','BekrÃ¤fta att ta bort rad',0),(320460,8902,'it','Confermare per eliminare la riga',0),(320461,8902,'tl','',0),(320462,8902,'th','&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;',0),(320463,8902,'hi','à¤°à¥‡à¤–à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(320464,8902,'ms','Mengesahkan untuk memadam baris',0),(320465,8902,'ar','ØªØ£ÙƒÙŠØ¯ Ø­Ø°Ù Ø§Ù„Ø®Ø·',0),(320466,8902,'fr','Confirmer pour supprimer la ligne',0),(320467,8902,'jp','è¡Œã®å‰Šé™¤ã‚’ç¢ºèªã—ã¾ã™',0),(320468,8902,'pt','Confirme para apagar linha',0),(320469,8902,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ñ Ð¡Ñ‚Ñ€Ð¾ÐºÐ¸',0),(320470,8902,'es','Confirmar para Eliminar Linea',0),(320471,8902,'de','Zeile lÃ¶schen bestÃ¤tigen',0),(320472,8902,'en','Confirm to Delete Line',0),(320473,8903,'is','',0),(320474,8903,'dr','ÙÙŠÙ„Ø¯ Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„  Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(320475,8903,'pr','ÙÙŠÙ„Ø¯ Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„  Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(320476,8903,'tr','MÃ¼ÅŸteri Ã¶zel alanlar',0),(320477,8903,'pl','Pola niestandardowe',0),(320478,8903,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(320479,8903,'ur','Ú¯Ø§ÛÚ© Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù‚Ø·Ø¹Ø§Øª',0),(320480,8903,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ñ™Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(320481,8903,'vi','TrÆ°á»ng KhÃ¡ch hÃ ng tá»± táº¡o',0),(320482,8903,'af','Klant / KliÃ«nt Aangepasde Velde',0),(320483,8903,'ro','CÃ¢mpuri personalizate client',0),(320484,8903,'et','Kliendile kohandatud vÃ¤ljad',0),(320485,8903,'si','Polja po meri kupca',0),(320486,8903,'ba','Bidang kustom pelanggan',0),(320487,8903,'nl','Aangepaste velden voor klant',0),(320488,8903,'fi','Kaikki mukautetut kentÃ¤t',0),(320489,8903,'no','Kunden egendefinerte felt',0),(320490,8903,'da','Kunde brugerdefinerede felter',0),(320491,8903,'ko','ê³ ê° ì‚¬ìš©ìž ì •ì˜ í•„ë“œ',0),(320492,8903,'he','×©×“×•×ª ×ž×•×ª××ž×™× ××™×©×™×ª ×œ×œ×§×•×—',0),(320493,8903,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î± Ï€ÎµÎ´Î¯Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(320494,8903,'zh','å®¢æˆ·è‡ªå®šä¹‰å­—æ®µ\r\n',0),(320495,8903,'sv','Kund anpassade fÃ¤lt',0),(320496,8903,'it','Campi personalizzati del cliente',0),(320497,8903,'tl','',0),(320498,8903,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3615;&#3636;&#3621;&#3604;&#3660;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(320499,8903,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¸à¥à¤Ÿà¤® à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸',0),(320500,8903,'ms','Bidang adat pelanggan',0),(320501,8903,'ar','Ø­Ù‚ÙˆÙ„ Ø§Ù„Ø²Ø¨ÙˆÙ† Ø§Ù„Ù…Ø®ØµÙ‘ØµØ©',0),(320502,8903,'fr','Client des champs personnalisÃ©s',0),(320503,8903,'jp','ãŠå®¢æ§˜ã®ã‚«ã‚¹ã‚¿ãƒ  ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(320504,8903,'pt','Campos personalizados do cliente',0),(320505,8903,'ru','ÐÐ°ÑÑ‚Ñ€Ð°Ð¸Ð²Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ð¾Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(320506,8903,'es','Campos Personalizados de Clientes',0),(320507,8903,'de','Kunden benutzerdefinierte Felder',0),(320508,8903,'en','Customer Custom Fields',0),(320509,8904,'is','',0),(320510,8904,'dr','Ø¯Ø±ØµØ¯ ØªØ®ÙÙŠÙ ',0),(320511,8904,'pr','Ø¯Ø±ØµØ¯ ØªØ®ÙÙŠÙ ',0),(320512,8904,'tr','Disk %',0),(320513,8904,'pl','Dysk %',0),(320514,8904,'bg','Ð”Ð¸ÑÐº %',0),(320515,8904,'ur','ÚˆØ³Ú© %',0),(320516,8904,'sr','Ð”Ð¸ÑÐº %',0),(320517,8904,'vi','% Chiáº¿t kháº¥u',0),(320518,8904,'af','Kort. %',0),(320519,8904,'ro','Disc %',0),(320520,8904,'et','AH %',0),(320521,8904,'si','Disk %',0),(320522,8904,'ba','Disc %',0),(320523,8904,'nl','Schijf %',0),(320524,8904,'fi','Levy %',0),(320525,8904,'no','Platen %',0),(320526,8904,'da','Disk %',0),(320527,8904,'ko','ë””ìŠ¤í¬ %',0),(320528,8904,'he','×“×™×¡×§ %',0),(320529,8904,'el','Î”Î¯ÏƒÎºÎ¿Ï‚ %',0),(320530,8904,'zh','æŠ˜æ‰£ï¼…\r\n',0),(320531,8904,'sv','Skiva %',0),(320532,8904,'it','Disco %',0),(320533,8904,'tl','',0),(320534,8904,'th','&#3626;&#3656;&#3623;&#3609;&#3621;&#3604; %',0),(320535,8904,'hi','à¤¡à¤¿à¤¸à¥à¤• %',0),(320536,8904,'ms','Cakera %',0),(320537,8904,'ar','Ø§Ù„Ù‚Ø±Øµ %',0),(320538,8904,'fr','Disque %',0),(320539,8904,'jp','ãƒ‡ã‚£ã‚¹ã‚¯ %',0),(320540,8904,'pt','Disco %',0),(320541,8904,'ru','Ð”Ð¸ÑÐº %',0),(320542,8904,'es','Desc. %',0),(320543,8904,'de','CD %',0),(320544,8904,'en','Disc %',0),(320545,8905,'is','',0),(320546,8905,'dr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ÙŠØ¯ ØªÙ†Ø¸ÙŠÙ… Ø´ÙˆØ¯ ',0),(320547,8905,'pr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ÙŠØ¯ ØªÙ†Ø¸ÙŠÙ… Ø´ÙˆØ¯ ',0),(320548,8905,'tr','GL satÄ±ÅŸ hesabÄ± ayarlamanÄ±z gerekir',0),(320549,8905,'pl','GL sprzedaÅ¼y konta musi byÄ‡ ustawiona',0),(320550,8905,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»Ð¸',0),(320551,8905,'ur','Ø¬ÛŒØ¬Û’ Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(320552,8905,'sr','Ð“Ð› Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°.',0),(320553,8905,'vi','Pháº£i CÃ³ TK Sá»• CÃ¡i Tá»•ng Há»£p Doanh Thu HÃ ng BÃ¡n',0),(320554,8905,'af','AG Verkope Rekening Moet Gestel Word',0),(320555,8905,'ro','GL vÃ¢nzÄƒri cont trebuie sÄƒ fie setat',0),(320556,8905,'et','GL mÃ¼Ã¼gikontole tuleb seada',0),(320557,8905,'si','Nastavite prodajni raÄun GL',0),(320558,8905,'ba','GL penjualan Account harus ditetapkan',0),(320559,8905,'nl','GL verkooprekening moet worden ingesteld',0),(320560,8905,'fi','GL: n myyntitilille on mÃ¤Ã¤ritettÃ¤vÃ¤',0),(320561,8905,'no','GL salgskontoen mÃ¥ angis',0),(320562,8905,'da','GL salgskontoen skal angives',0),(320563,8905,'ko','GL íŒë§¤ ê³„ì •ì´ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(320564,8905,'he','×œ×”×’×“×™×¨ ×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª GL',0),(320565,8905,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î», Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(320566,8905,'zh','å¿…é¡»è®¾ç½®æ€»å¸é”€å”®å¸æˆ·\r\n',0),(320567,8905,'sv','GL fÃ¶rsÃ¤ljningskontot mÃ¥ste anges',0),(320568,8905,'it','GL Sales Account deve essere impostata',0),(320569,8905,'tl','',0),(320570,8905,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3605;&#3657;&#3629;&#3591;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;',0),(320571,8905,'hi','à¤œà¥€à¤à¤² à¤µà¤¿à¤•à¥à¤°à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(320572,8905,'ms','Akaun jualan GL mesti disetkan',0),(320573,8905,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† ØªØ­Ø¯ÙŠØ¯ Ø­Ø³Ø§Ø¨ Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(320574,8905,'fr','Compte de vente GL doit avoir la valeur',0),(320575,8905,'jp','GL è²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(320576,8905,'pt','Conta de vendas de GL deve ser definida',0),(320577,8905,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ GL Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(320578,8905,'es','Cuenta de Ventas LM Debe Estar Configurada',0),(320579,8905,'de','GL Sales Account muss festgelegt werden',0),(320580,8905,'en','GL Sales Account Must Be Set',0),(320581,8906,'is','',0),(320582,8906,'dr','(ÙØ±ÙˆØ´) Ø§ÙŠØ¬Ø§Ø¯ Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯',0),(320583,8906,'pr','Ø³ÙŠØ³ØªÙ… ÙŠÙƒ ÙØ§ÙƒØªÙˆØ± Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø­Ø±Ø§Ø¬(ÙØ±ÙˆØ´) Ø§ÙŠØ¬Ø§Ø¯ Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯',0),(320584,8906,'tr','Sistem-ecek yaratmak iÃ§in bu satÄ±ÅŸ fatura',0),(320585,8906,'pl','System utworzy fakturÄ™ za sprzedaÅ¼ ta',0),(320586,8906,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ñ‰Ðµ ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(320587,8906,'ur','Ù†Ø¸Ø§Ù… Ø§Ø³ ÙØ±ÙˆØ®Øª Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¨Ù†Ø§Ø¦ÛŒÚº Ú¯Û’',0),(320588,8906,'sr','Ð¡Ð¸ÑÑ‚ÐµÐ¼ Ñ›Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð·Ð° Ð¾Ð²Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(320589,8906,'vi','Há»‡ thá»‘ng sáº½ táº¡o 1 hÃ³a Ä‘Æ¡n cho giao dá»‹ch bÃ¡n nÃ y',0),(320590,8906,'af','Die stelsel sal skep \'n faktuur vir die veiling',0),(320591,8906,'ro','Sistemul va crea o facturÄƒ pentru aceastÄƒ vÃ¢nzare',0),(320592,8906,'et','SÃ¼steem loob arve selle mÃ¼Ã¼giks',0),(320593,8906,'si','Sistem bo ustvarite raÄun za te prodaje',0),(320594,8906,'ba','Sistem akan membuat faktur ini dijual',0),(320595,8906,'nl','Het systeem zal Maak een factuur voor deze verkoop',0),(320596,8906,'fi','JÃ¤rjestelmÃ¤ luo laskun myynti',0),(320597,8906,'no','Vil systemet opprette en faktura For dette salget',0),(320598,8906,'da','Systemet vil oprette en faktura For dette salg',0),(320599,8906,'ko','ì‹œìŠ¤í…œì´ì´ íŒë§¤ì— ëŒ€ í•œ ì²­êµ¬ì„œë¥¼ ë§Œë“¤ ê²ƒìž…ë‹ˆë‹¤.',0),(320600,8906,'he','×”×ž×¢×¨×›×ª ×ª×™×¦×•×¨ ×—×©×‘×•× ×™×ª ×œ×ž×‘×¦×¢ ×”×–×”',0),(320601,8906,'el','Î¤Î¿ ÏƒÏÏƒÏ„Î·Î¼Î± Î¸Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Î­Î½Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î³Î¹Î± Ï„Î·Î½ Ï€ÏŽÎ»Î·ÏƒÎ·',0),(320602,8906,'zh','è¯¥ç³»ç»Ÿå°†ä¸ºè¿™é¡¹é”€å”®å»ºç«‹ä¸€ä¸ªå‘ç¥¨\r\n',0),(320603,8906,'sv','Systemet kommer att skapa en faktura fÃ¶r denna fÃ¶rsÃ¤ljning',0),(320604,8906,'it','Il sistema crea una fattura per questa vendita',0),(320605,8906,'tl','',0),(320606,8906,'th','&#3619;&#3632;&#3610;&#3610;&#3592;&#3632;&#3626;&#3619;&#3657;&#3634;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(320607,8906,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤‡à¤¸ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤šà¤¾à¤²à¤¾à¤¨ à¤¬à¤¨à¤¾à¤à¤—à¤¾',0),(320608,8906,'ms','Sistem ini akan membuat invois untuk dijual ini',0),(320609,8906,'ar','Ø§Ù„Ù†Ø¸Ø§Ù… Ø³ÙŠÙ‚ÙˆÙ… Ø¨Ø¥Ù†Ø´Ø§Ø¡ ÙØ§ØªÙˆØ±Ø© Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¨ÙŠØ¹',0),(320610,8906,'fr','Le systÃ¨me crÃ©era une facture pour cette vente',0),(320611,8906,'jp','ã“ã®è²©å£²ã®è«‹æ±‚æ›¸ãŒä½œæˆã•ã‚Œã¾ã™ã€‚',0),(320612,8906,'pt','O sistema irÃ¡ criar uma factura para essa venda',0),(320613,8906,'ru','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð° Ð±ÑƒÐ´ÐµÑ‚ ÑÐ¾Ð·Ð´Ð°Ð²Ð°Ñ‚ÑŒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(320614,8906,'es','El Sistema CrearÃ¡ Una Factura para Esta Venta',0),(320615,8906,'de','Das System wird eine Rechnung fÃ¼r diesen Verkauf erstellen.',0),(320616,8906,'en','The System Will Create An Invoice For This Sale',0),(320617,8907,'is','',0),(320618,8907,'dr','Ø³ÙŠØ³ØªÙ… ÙŠÙƒ Ø³ÙØ§Ø±Ø´ ØªÙƒÙ…ÙŠÙ„ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯ Ùˆ Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ±ÙŠ ',0),(320619,8907,'pr','Ø³ÙŠØ³ØªÙ… ÙŠÙƒ Ø³ÙØ§Ø±Ø´ ØªÙƒÙ…ÙŠÙ„ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯ Ùˆ Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ±ÙŠ ',0),(320620,8907,'tr','Sistem bir karÅŸÄ±lama sipariÅŸi ve hiÃ§bir fatura oluÅŸturur',0),(320621,8907,'pl','System utworzy realizacji zamÃ³wienia i nie faktury',0),(320622,8907,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ñ‰Ðµ ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¸ Ð½ÑÐ¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(320623,8907,'ur','Ø§ÛŒÚ© Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ø§ÙˆØ± Ú©ÙˆØ¦ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ø¸Ø§Ù… Ù‚Ø§Ø¦Ù… Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(320624,8907,'sr','Ð¡Ð¸ÑÑ‚ÐµÐ¼ Ñ›Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ \"Ð¸\" ÐÐµÐ¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(320625,8907,'vi','Há»‡ thá»‘ng sáº½ táº¡o ra 1 Ä‘Æ¡n hÃ ng giao táº­n nÆ¡i vÃ  khÃ´ng cÃ³ hÃ³a Ä‘Æ¡n',0),(320626,8907,'af','Die Sisteem Sal \'n Uitvoeringsbestelling Skep en Geen Faktuur',0),(320627,8907,'ro','Sistemul va crea o comandÄƒ de Ã®mplinire ÅŸi nici o facturÄƒ',0),(320628,8907,'et','SÃ¼steem loob plaanitud tellimus ja arve',0),(320629,8907,'si','Sistem bo ustvarite izpolnitev nalog in ne raÄuna',0),(320630,8907,'ba','Sistem akan membuat pemenuhan Order dan faktur tidak',0),(320631,8907,'nl','Het systeem zal een vervulling orde en geen factuur maken',0),(320632,8907,'fi','JÃ¤rjestelmÃ¤ luo suunnitellun tilauksen ja laskua',0),(320633,8907,'no','Systemet oppretter en planlagt bestilling og ingen faktura',0),(320634,8907,'da','Systemet vil oprette en opfyldning og ingen faktura',0),(320635,8907,'ko','ì‹œìŠ¤í…œ í–‰ ìˆœì„œì™€ ì•„ë¬´ ì†¡ìž¥ ìƒì„± ë©ë‹ˆë‹¤.',0),(320636,8907,'he','×”×ž×¢×¨×›×ª ×ª×™×¦×•×¨ ×¦×• ×ž×™×ž×•×© ×•×—×©×‘×•× ×™×ª ××™×Ÿ',0),(320637,8907,'el','Î¤Î¿ ÏƒÏÏƒÏ„Î·Î¼Î± Î¸Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Î¼Î¹Î± ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎºÎ±Î¹ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Î´ÎµÎ½',0),(320638,8907,'zh','è¯¥ç³»ç»Ÿä¼šåˆ›å»ºä¸€ä¸ªå±¥è¡Œè®¢å•ï¼Œæ²¡æœ‰å‘ç¥¨\r\n',0),(320639,8907,'sv','Systemet skapar en uppfyllelseorder och ingen faktura',0),(320640,8907,'it','Il sistema crea un ordine di evasione e nessuna fattura',0),(320641,8907,'tl','',0),(320642,8907,'th','&#3619;&#3632;&#3610;&#3610;&#3592;&#3632;&#3626;&#3619;&#3657;&#3634;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3649;&#3621;&#3632;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3',0),(320643,8907,'hi','à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤à¤• à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤”à¤° à¤•à¥‹à¤ˆ à¤šà¤¾à¤²à¤¾à¤¨ à¤¬à¤¨à¤¾à¤à¤—à¤¾',0),(320644,8907,'ms','Sistem akan membuat suatu perintah memenuhi dan invois tiada',0),(320645,8907,'ar','Ø³ÙŠØªÙ… Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ù†Ø¸Ø§Ù… Ø£Ù…Ø± ÙˆÙØ§Ø¡ ÙˆÙ„Ø§ ÙØ§ØªÙˆØ±Ø©',0),(320646,8907,'fr','Le systÃ¨me crÃ©era un ordre de traitement et aucune facture',0),(320647,8907,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼ã¨ãªã„è«‹æ±‚æ›¸ãŒä½œæˆã•ã‚Œã¾ã™ã€‚',0),(320648,8907,'pt','O sistema criarÃ¡ uma ordem de cumprimento e sem factura',0),(320649,8907,'ru','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð° ÑÐ¾Ð·Ð´Ð°ÑÑ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð¸ Ð±ÐµÐ· ÑÑ‡ÐµÑ‚Ð°',0),(320650,8907,'es','El Sistema CrearÃ¡ Un Orden de Cumplimiento Y No Una Factura',0),(320651,8907,'de','Das System wird ein Bestellvorschlag und keine Rechnung erstellen.',0),(320652,8907,'en','The System Will Create A Fulfillment Order And No Invoice',0),(320653,8908,'is','',0),(320654,8908,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø´Ø±ÙƒØª ÙŠØ§ Ù†Ø§Ù… Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(320655,8908,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø´Ø±ÙƒØª ÙŠØ§ Ù†Ø§Ù… Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(320656,8908,'tr','Bir ÅŸirket adÄ± veya ilk ve son adÄ± girmelisiniz',0),(320657,8908,'pl','NaleÅ¼y wprowadziÄ‡ nazwÄ™ firmy lub imiÄ™ i nazwisko',0),(320658,8908,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ',0),(320659,8908,'ur','Ø¢Ù¾ Ú©Ø³ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… ÛŒØ§ Ù¾ÛÙ„Û’ Ø§ÙˆØ± Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(320660,8908,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð¸ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(320661,8908,'vi','Pháº£i nháº­p tÃªn cty hay tÃªn & há»',0),(320662,8908,'af','U moet \'n Ondernemingnaam of \'n Voornaam en Van invoer',0),(320663,8908,'ro','Trebuie sÄƒ introduceÅ£i un nume de companie sau Nume si prenume',0),(320664,8908,'et','Pead sisestama ettevÃµtte nime vÃµi ees- ja perekonnanime',0),(320665,8908,'si','Vnesite ime podjetja ali ime in priimek',0),(320666,8908,'ba','Anda harus memasukkan nama perusahaan atau nama pertama dan terakhir',0),(320667,8908,'nl','een bedrijfsnaam of voor en achter naam moet ingevoerd worden',0),(320668,8908,'fi','Kirjoita yrityksen nimi tai etu- ja sukunimi',0),(320669,8908,'no','Du mÃ¥ angi et firmanavn eller fornavn og etternavn',0),(320670,8908,'da','Du skal angive et firmanavn eller fornavn og efternavn',0),(320671,8908,'ko','íšŒì‚¬ ì´ë¦„ì´ ë‚˜ ì„±ê³¼ ì´ë¦„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(320672,8908,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×©× ×—×‘×¨×” ××• ×©× ×¤×¨×˜×™ ×•×ž×©×¤×—×”',0),(320673,8908,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î® ÏŒÎ½Î¿Î¼Î± ÎºÎ±Î¹ ÎµÏ€ÏŽÎ½Ï…Î¼Î¿',0),(320674,8908,'zh','ä½ å¿…é¡»è¾“å…¥å…¬å¸åç§°æˆ–å§“æ°å’Œåå­—\r\n',0),(320675,8908,'sv','Du mÃ¥ste ange ett fÃ¶retagsnamn eller fÃ¶rnamn och efternamn',0),(320676,8908,'it','Ãˆ necessario immettere un nome di societÃ  o nome e cognome',0),(320677,8908,'tl','',0),(320678,8908,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3611;&#3657;&#3629;&#3609;&#3594;&#3639;&#3656;&#3629;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3627;&#3619;&#3639;&#3629;&#3594;&#3639;&#3656;&#3629;&#3649;&#3621;&#3632;&#3609;&#3634;&#3617;&#3626;&#3',0),(320679,8908,'hi','à¤†à¤ª à¤à¤• à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® à¤”à¤° à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(320680,8908,'ms','Awda mesti masukkan nama Syarikat atau nama pertama dan akhir',0),(320681,8908,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø¥Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø£Ùˆ Ø¥Ø³Ù… Ùˆ Ù„Ù‚Ø¨ Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(320682,8908,'fr','Vous devez entrer un nom de sociÃ©tÃ© ou un nom et un prÃ©nom.',0),(320683,8908,'jp','ä¼šç¤¾åã¾ãŸã¯æœ€åˆã¨æœ€å¾Œã®åå‰ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(320684,8908,'pt','VocÃª deve digitar um nome de empresa ou nome e sobrenome',0),(320685,8908,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð˜Ð»Ð¸ Ð˜Ð¼Ñ Ð˜ Ð¤Ð°Ð¼Ð¸Ð»Ð¸ÑŽ',0),(320686,8908,'es','Debe Introducir Un Nombre de Empresa O Primer Nombre Y Apellido',0),(320687,8908,'de','Sie mÃ¼ssen einen Firmennamen oder vor-und Nachnamen eingeben.',0),(320688,8908,'en','You Must Enter A Company Name Or First And Last Name',0),(320689,8909,'is','',0),(320690,8909,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(320691,8909,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(320692,8909,'tr','Ã–deme kaydedilirken hata oluÅŸtu',0),(320693,8909,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania pÅ‚atnoÅ›ci',0),(320694,8909,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(320695,8909,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(320696,8909,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ¿Ñ€ÐµÐ¼Ð°ÑšÐ° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(320697,8909,'vi','Lá»—i sao lÆ°u thanh toÃ¡n',0),(320698,8909,'af','Fout het ontstaan met die Stoor van Betaling',0),(320699,8909,'ro','Eroare la salvarea plata',0),(320700,8909,'et','Makse salvestamisel ilmnes tÃµrge',0),(320701,8909,'si','Napaka pri shranjevanju plaÄilo',0),(320702,8909,'ba','Kesalahan menyimpan pembayaran',0),(320703,8909,'nl','Fout bij het opslaan van betaling',0),(320704,8909,'fi','Virhe tallennettaessa maksu',0),(320705,8909,'no','Feil under lagring av betaling',0),(320706,8909,'da','Fejl under lagring af betaling',0),(320707,8909,'ko','ì§€ë¶ˆì„ ì €ìž¥ í•˜ëŠ” ì˜¤ë¥˜',0),(320708,8909,'he','××™×¨×¢×” ×©×’×™××” ×‘×©×ž×™×¨×ª ×”×ª×©×œ×•×',0),(320709,8909,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï„Î·Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(320710,8909,'zh','é”™è¯¯ä¿å­˜ä»˜æ¬¾',0),(320711,8909,'sv','Fel vid sparande av betalning',0),(320712,8909,'it','Errore durante il salvataggio di pagamento',0),(320713,8909,'tl','',0),(320714,8909,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(320715,8909,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(320716,8909,'ms','Ralat Menyimpan pembayaran',0),(320717,8909,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸ Ø§Ù„Ø¯ÙØ¹',0),(320718,8909,'fr','Erreur d\'enregistrement de paiement',0),(320719,8909,'jp','ãŠæ”¯æ‰•ã„ã®ä¿å­˜ã‚¨ãƒ©ãƒ¼',0),(320720,8909,'pt','Erro ao salvar o pagamento',0),(320721,8909,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð°',0),(320722,8909,'es','Error Guardando Pago',0),(320723,8909,'de','Fehler beim Speichern der Zahlung',0),(320724,8909,'en','Error Saving Payment',0),(320725,8910,'is','',0),(320726,8910,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(320727,8910,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(320728,8910,'tr','Ã–deme baÅŸarÄ±yla kaydedildi',0),(320729,8910,'pl','PÅ‚atnoÅ›ci zapisane',0),(320730,8910,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(320731,8910,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ù…ÛŒÚº Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(320732,8910,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(320733,8910,'vi','Sao lÆ°u Thanh ToÃ¡n thÃ nh cÃ´ng',0),(320734,8910,'af','Betalings Suksesvol Gestoor',0),(320735,8910,'ro','PlatÄƒ salvat cu succes',0),(320736,8910,'et','Makse salvestati edukalt',0),(320737,8910,'si','PlaÄilo uspeÅ¡no shranjen',0),(320738,8910,'ba','Pembayaran yang berhasil diselamatkan',0),(320739,8910,'nl','Betaling succesvol opgeslagen',0),(320740,8910,'fi','Maksun tallentaminen onnistui',0),(320741,8910,'no','Betaling lagret',0),(320742,8910,'da','Betaling gemt med succes',0),(320743,8910,'ko','ê²°ì œë¥¼ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(320744,8910,'he','×”×ª×©×œ×•× ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(320745,8910,'el','Î Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(320746,8910,'zh','ä»˜æ¬¾å·²æˆåŠŸä¿å­˜\r\n',0),(320747,8910,'sv','Betalning som sparats',0),(320748,8910,'it','Pagamento salvato correttamente',0),(320749,8910,'tl','',0),(320750,8910,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3606;&#3641;&#3585;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3649;&#3621;&#3657;&#3623;',0),(320751,8910,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(320752,8910,'ms','Pembayaran berjaya disimpan',0),(320753,8910,'ar','Ø¯ÙØ¹ Ø­ÙØ¸Ù‡ Ø¨Ù†Ø¬Ø§Ø­',0),(320754,8910,'fr','Paiement enregistrÃ© avec succÃ¨s',0),(320755,8910,'jp','ãŠæ”¯æ‰•ã„ãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(320756,8910,'pt','Pagamento com sucesso',0),(320757,8910,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(320758,8910,'es','Pago Guardado Exitosamente',0),(320759,8910,'de','Zahlung erfolgreich gespeichert',0),(320760,8910,'en','Payment Saved Successfully',0),(320761,8911,'is','',0),(320762,8911,'dr','(Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡ ',0),(320763,8911,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª (Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(320764,8911,'tr','Ã–deme Ekle',0),(320765,8911,'pl','DodaÄ‡ pÅ‚atnoÅ›ci',0),(320766,8911,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(320767,8911,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(320768,8911,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(320769,8911,'vi','ThÃªm Thanh ToÃ¡n',0),(320770,8911,'af','Betaling Byvoeg',0),(320771,8911,'ro','Adauga plata',0),(320772,8911,'et','Lisa makse',0),(320773,8911,'si','Dodaj plaÄilo',0),(320774,8911,'ba','Tambahkan pembayaran',0),(320775,8911,'nl','Toevoegen van betaling',0),(320776,8911,'fi','LisÃ¤Ã¤ maksu',0),(320777,8911,'no','Legge til betaling',0),(320778,8911,'da','TilfÃ¸je betaling',0),(320779,8911,'ko','ê²°ì œ ì¶”ê°€',0),(320780,8911,'he','×”×•×¡×£ ×ª×©×œ×•×',0),(320781,8911,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(320782,8911,'zh','å¢žåŠ ä»˜æ¬¾\r\n',0),(320783,8911,'sv','LÃ¤gg till betalning',0),(320784,8911,'it','Aggiungi pagamento',0),(320785,8911,'tl','',0),(320786,8911,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(320787,8911,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(320788,8911,'ms','Menambah pembayaran',0),(320789,8911,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¯ÙØ¹',0),(320790,8911,'fr','Ajouter le paiement',0),(320791,8911,'jp','ãŠæ”¯æ‰•ã„ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(320792,8911,'pt','Adicionar o pagamento',0),(320793,8911,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶',0),(320794,8911,'es','Agregar Pago',0),(320795,8911,'de','HinzufÃ¼gen der Zahlung',0),(320796,8911,'en','Add Payment',0),(320797,8912,'is','',0),(320798,8912,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(320799,8912,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(320800,8912,'tr','Ã–deme tutarÄ±',0),(320801,8912,'pl','Kwota pÅ‚atnoÅ›ci',0),(320802,8912,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(320803,8912,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù‚Ù…',0),(320804,8912,'sr','Ð˜Ð·Ð½Ð¾Ñ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(320805,8912,'vi','Sá»‘ tiá»n Thanh ToÃ¡n',0),(320806,8912,'af','Betalingsbedrag',0),(320807,8912,'ro','Suma de platÄƒ',0),(320808,8912,'et','Makse summa',0),(320809,8912,'si','Znesek plaÄila',0),(320810,8912,'ba','Jumlah pembayaran',0),(320811,8912,'nl','Betalingsbedrag',0),(320812,8912,'fi','Maksusumma',0),(320813,8912,'no','BetalingsbelÃ¸pet',0),(320814,8912,'da','BetalingsbelÃ¸bet',0),(320815,8912,'ko','ì§€ë¶ˆ ê¸ˆì•¡',0),(320816,8912,'he','×¡×›×•× ×ª×©×œ×•×',0),(320817,8912,'el','Î Î¿ÏƒÏŒ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(320818,8912,'zh','ä»˜æ¬¾é‡‘é¢\r\n',0),(320819,8912,'sv','Betalningsbeloppet',0),(320820,8912,'it','Importo del pagamento',0),(320821,8912,'tl','',0),(320822,8912,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(320823,8912,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿',0),(320824,8912,'ms','Amaun bayaran',0),(320825,8912,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(320826,8912,'fr','Montant du paiement',0),(320827,8912,'jp','æ”¯æ‰•é¡',0),(320828,8912,'pt','Valor do pagamento',0),(320829,8912,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(320830,8912,'es','Monto de Pago',0),(320831,8912,'de','Zahlungsbetrag',0),(320832,8912,'en','Payment Amount',0),(320833,8913,'is','',0),(320834,8913,'dr','Ø°Ø®ÙŠØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(320835,8913,'pr','Ø°Ø®ÙŠØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(320836,8913,'tr','Ã–deme kurtarmak',0),(320837,8913,'pl','Zapisz pÅ‚atnoÅ›ci',0),(320838,8913,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(320839,8913,'ur','Ø±Ù‚Ù… Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(320840,8913,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(320841,8913,'vi','Sao lÆ°u thanh toÃ¡n',0),(320842,8913,'af','Stoor Betaling',0),(320843,8913,'ro','Salvare platÄƒ',0),(320844,8913,'et','Salvesta makse',0),(320845,8913,'si','Shranjevanje plaÄilnih',0),(320846,8913,'ba','Simpan pembayaran',0),(320847,8913,'nl','Opslaan van betaling',0),(320848,8913,'fi','Tallenna maksu',0),(320849,8913,'no','Lagre betaling',0),(320850,8913,'da','Gemme betaling',0),(320851,8913,'ko','ì§€ë¶ˆì„ ì €ìž¥',0),(320852,8913,'he','×©×ž×•×¨ ×ª×©×œ×•×',0),(320853,8913,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(320854,8913,'zh','ä¿å­˜ä»˜æ¬¾\r\n',0),(320855,8913,'sv','Spara betalning',0),(320856,8913,'it','Salvare il pagamento',0),(320857,8913,'tl','',0),(320858,8913,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(320859,8913,'hi','à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(320860,8913,'ms','Menjimatkan pembayaran',0),(320861,8913,'ar','Ø­ÙØ¸ Ø§Ù„Ø¯ÙØ¹',0),(320862,8913,'fr','Enregistrer le paiement',0),(320863,8913,'jp','æ”¯æ‰•ã„ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(320864,8913,'pt','Salvar o pagamento',0),(320865,8913,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(320866,8913,'es','Guardar Pago',0),(320867,8913,'de','Zahlung zu speichern',0),(320868,8913,'en','Save Payment',0),(320869,8914,'is','',0),(320870,8914,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(320871,8914,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(320872,8914,'tr','Bir miktar girmeniz gerekir',0),(320873,8914,'pl','NaleÅ¼y wprowadziÄ‡ kwotÄ™',0),(320874,8914,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÑƒÐ¼Ð°',0),(320875,8914,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø±Ù‚Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(320876,8914,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ ÑƒÐ½ÐµÑ‚Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(320877,8914,'vi','Báº¡n pháº£i nháº­p 1 TK',0),(320878,8914,'af','U Moet \'n BEDRAG invoer.',0),(320879,8914,'ro','Trebuie sÄƒ introduceÅ£i o sumÄƒ',0),(320880,8914,'et','Te peate sisestama koguse',0),(320881,8914,'si','Vnesite znesek',0),(320882,8914,'ba','Anda harus memasukkan jumlah',0),(320883,8914,'nl','U moet een bedrag opgeven',0),(320884,8914,'fi','On annettava summa',0),(320885,8914,'no','Du mÃ¥ angi et belÃ¸p',0),(320886,8914,'da','Du skal indtaste et belÃ¸b',0),(320887,8914,'ko','ê¸ˆì•¡ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(320888,8914,'he','×¢×œ×™×š ×œ×”×›× ×™×¡ ×¡×›×•×',0),(320889,8914,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Ï€Î¿ÏƒÏŒ',0),(320890,8914,'zh','æ‚¨å¿…é¡»è¾“å…¥é‡‘é¢\r\n',0),(320891,8914,'sv','Du mÃ¥ste ange ett belopp',0),(320892,8914,'it','Ãˆ necessario immettere un importo',0),(320893,8914,'tl','',0),(320894,8914,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3611;&#3657;&#3629;&#3609;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(320895,8914,'hi','à¤†à¤ª à¤à¤• à¤°à¤¾à¤¶à¤¿ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(320896,8914,'ms','Awda mesti masukkan amaun yang',0),(320897,8914,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø¨Ù„Øº',0),(320898,8914,'fr','Vous devez saisir un montant',0),(320899,8914,'jp','é‡‘é¡ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(320900,8914,'pt','VocÃª deve digitar uma quantidade',0),(320901,8914,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ ÑÑƒÐ¼Ð¼Ñƒ',0),(320902,8914,'es','Debe Introducir Una Cantidad',0),(320903,8914,'de','Sie mÃ¼ssen einen Betrag eingeben.',0),(320904,8914,'en','You Must Enter An Amount',0),(320905,8915,'is','',0),(320906,8915,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(320907,8915,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ú†Ùƒ  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(320908,8915,'tr','Ã‡ek numarasÄ± girmelisiniz',0),(320909,8915,'pl','NaleÅ¼y wprowadziÄ‡ numer czeku',0),(320910,8915,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(320911,8915,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ú†ÛŒÚ© Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(320912,8915,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ',0),(320913,8915,'vi','Pháº£i nháº­p sá»‘ SÃ©c',0),(320914,8915,'af','U moet \'n TJEKNOMMER invoer.',0),(320915,8915,'ro','Trebuie sa introduceti un numar de CEC',0),(320916,8915,'et','Te peate sisestama tseki numbri',0),(320917,8915,'si','Vnesite potrditveno Å¡tevilko',0),(320918,8915,'ba','Anda harus memasukkan nomor Check',0),(320919,8915,'nl','U moet een chequenummer invoeren',0),(320920,8915,'fi','Kirjoita sekin numero',0),(320921,8915,'no','Du mÃ¥ angi et sjekknummer',0),(320922,8915,'da','Du skal angive et checknummer',0),(320923,8915,'ko','í™•ì¸ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(320924,8915,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ž×¡×¤×¨ ×©×™×§',0),(320925,8915,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ Î±ÏÎ¹Î¸Î¼ÏŒ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(320926,8915,'zh','ä½ å¿…é¡»è¾“å…¥éªŒè¯ç \r\n',0),(320927,8915,'sv','Du mÃ¥ste ange ett checknummer.',0),(320928,8915,'it','Ãˆ necessario immettere un numero di controllo',0),(320929,8915,'tl','',0),(320930,8915,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3611;&#3657;&#3629;&#3609;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3648;&#3594;&#3655;&#3588;',0),(320931,8915,'hi','à¤†à¤ª à¤šà¥‡à¤• à¤•à¥€ à¤•à¥‹à¤ˆ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤•',0),(320932,8915,'ms','Awda mesti masukkan nombor Daftar',0),(320933,8915,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø´ÙŠÙƒ',0),(320934,8915,'fr','Vous devez entrer un numÃ©ro de chÃ¨que.',0),(320935,8915,'jp','å°åˆ‡æ‰‹ç•ªå·ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(320936,8915,'pt','VocÃª deve digitar um nÃºmero de verificaÃ§Ã£o',0),(320937,8915,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ ÐÐ¾Ð¼ÐµÑ€ Ð§ÐµÐºÐ°',0),(320938,8915,'es','Debe Introducir Un NÃºmero de Cheque',0),(320939,8915,'de','Sie mÃ¼ssen eine Schecknummer eingeben.',0),(320940,8915,'en','You Must Enter A Check Number',0),(320941,8916,'is','',0),(320942,8916,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(320943,8916,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(320944,8916,'tr','Bir fiÅŸ girmeniz gerekir',0),(320945,8916,'pl','NaleÅ¼y wprowadziÄ‡ kupon',0),(320946,8916,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(320947,8916,'ur','Ø¢Ù¾ Ø§ÛŒÚ© ÙˆØ§Ø¤Ú†Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(320948,8916,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð½ÐµÐºÐ¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(320949,8916,'vi','Báº¡n pháº£i nháº­p 1 phiáº¿u',0),(320950,8916,'af','U moet \'n Bewysstuk invoer.',0),(320951,8916,'ro','Trebuie sa introduceti o chitanta',0),(320952,8916,'et','Te peate sisestama kviitungi',0),(320953,8916,'si','Vnesite kupon',0),(320954,8916,'ba','Anda harus memasukkan Voucher',0),(320955,8916,'nl','U moet een bon invoeren',0),(320956,8916,'fi','Kirjoita tositteen',0),(320957,8916,'no','Du mÃ¥ angi et bilag',0),(320958,8916,'da','Du skal angive en Voucher',0),(320959,8916,'ko','ë°”ìš°ì²˜ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(320960,8916,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×©×•×‘×¨',0),(320961,8916,'el','Î˜Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(320962,8916,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªå‡­è¯\r\n',0),(320963,8916,'sv','Du mÃ¥ste ange en kupong',0),(320964,8916,'it','Ãˆ necessario immettere un Voucher',0),(320965,8916,'tl','',0),(320966,8916,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3619;&#3629;&#3585;&#3594;&#3639;&#3656;&#3629;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;',0),(320967,8916,'hi','à¤†à¤ª à¤à¤• Voucher à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(320968,8916,'ms','Awda mesti masukkan baucar',0),(320969,8916,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ Ù‚Ø³ÙŠÙ…Ø©',0),(320970,8916,'fr','Vous devez entrer un bon d\'achat.',0),(320971,8916,'jp','ä¼ç¥¨ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(320972,8916,'pt','VocÃª deve digitar um Voucher',0),(320973,8916,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(320974,8916,'es','Debe Introducir Un Voucher',0),(320975,8916,'de','Sie mÃ¼ssen einen Gutschein eingeben.',0),(320976,8916,'en','You Must Enter A Voucher',0),(320977,8917,'is','',0),(320978,8917,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ ',0),(320979,8917,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ ',0),(320980,8917,'tr','SipariÅŸ kaydedilirken hata oluÅŸtu',0),(320981,8917,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania zamÃ³wienia',0),(320982,8917,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´',0),(320983,8917,'ur','Ø­Ú©Ù… Ù…Ø­ÙÙˆØ¸ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(320984,8917,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ¿Ñ€ÐµÐ¼Ð°ÑšÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(320985,8917,'vi','Sao lÆ°u Ä‘Æ¡n Ä‘áº·t hÃ ng bá»‹ lá»—i',0),(320986,8917,'af','Fout met die stoor van orde',0),(320987,8917,'ro','Eroare la salvarea ordinii',0),(320988,8917,'et','Tellimuse salvestamise tÃµrge',0),(320989,8917,'si','Napaka, reÅ¡evanje nalog',0),(320990,8917,'ba','Kesalahan menyimpan Order',0),(320991,8917,'nl','Fout bij het opslaan van de bestelling',0),(320992,8917,'fi','Virhe tallennettaessa tilauksen',0),(320993,8917,'no','Feil under lagring av ordre',0),(320994,8917,'da','Fejl under lagring af ordre',0),(320995,8917,'ko','ìˆœì„œë¥¼ ì €ìž¥ í•˜ëŠ” ì˜¤ë¥˜',0),(320996,8917,'he','××™×¨×¢×” ×©×’×™××” ×‘×©×ž×™×¨×ª ×”×¡×“×¨',0),(320997,8917,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(320998,8917,'zh','é”™è¯¯ä¿å­˜è®¢å•',0),(320999,8917,'sv','Fel vid sparande av Order',0),(321000,8917,'it','Errore durante il salvataggio di ordine',0),(321001,8917,'tl','',0),(321002,8917,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(321003,8917,'hi','à¤•à¥à¤°à¤® à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(321004,8917,'ms','Ralat Menyimpan perintah',0),(321005,8917,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(321006,8917,'fr','Erreur de sauvegarde d\'ordre',0),(321007,8917,'jp','æ³¨æ–‡ã®ä¿å­˜ã‚¨ãƒ©ãƒ¼',0),(321008,8917,'pt','Erro ao salvar a ordem',0),(321009,8917,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ Ð—Ð°ÐºÐ°Ð·Ð°',0),(321010,8917,'es','Error Guardando Orden',0),(321011,8917,'de','Fehler beim Speichern der Order',0),(321012,8917,'en','Error Saving Order',0),(321013,8918,'is','',0),(321014,8918,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(321015,8918,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(321016,8918,'tr','SipariÅŸ baÅŸarÄ±yla kaydedildi',0),(321017,8918,'pl','Aby pomyÅ›lnie zapisany',0),(321018,8918,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(321019,8918,'ur','Ø¢Ø±ÚˆØ± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(321020,8918,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(321021,8918,'vi','Sao lÆ°u Ä‘Æ¡n hÃ ng thÃ nh cÃ´ng',0),(321022,8918,'af','Bestelling Suksesvol Gestoor',0),(321023,8918,'ro','Ordinul salvat cu succes',0),(321024,8918,'et','Tellimus salvestati edukalt',0),(321025,8918,'si','Vrstni red shranjen',0),(321026,8918,'ba','Order yang berhasil diselamatkan',0),(321027,8918,'nl','Bestelling succesvol opgeslagen',0),(321028,8918,'fi','Tilauksen tallentaminen onnistui',0),(321029,8918,'no','Bestill lagret',0),(321030,8918,'da','Bestil gemt med succes',0),(321031,8918,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” ìˆœì„œ',0),(321032,8918,'he','×”×¡×“×¨ × ×©×ž×¨ ×‘×”×¦×œ×—×”',0),(321033,8918,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(321034,8918,'zh','è®¢å•ä¿å­˜æˆåŠŸ\r\n',0),(321035,8918,'sv','Ordning som sparats',0),(321036,8918,'it','Ordine salvato correttamente',0),(321037,8918,'tl','',0),(321038,8918,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(321039,8918,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(321040,8918,'ms','Perintah yang berjaya disimpan',0),(321041,8918,'ar','Ø­ÙØ¸Øª Ø§Ù„Ø·Ù„Ø¨ÙŠÙ‘Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(321042,8918,'fr','Ordre enregistrÃ© avec succÃ¨s',0),(321043,8918,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚Œã‚‹é †åº',0),(321044,8918,'pt','Ordem salvo com sucesso',0),(321045,8918,'ru','Ð—Ð°ÐºÐ°Ð· Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½',0),(321046,8918,'es','Orden Guardado Exitosamente',0),(321047,8918,'de','Bestellung erfolgreich gespeichert',0),(321048,8918,'en','Order Saved Successfully',0),(321049,8919,'is','',0),(321050,8919,'dr','Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(321051,8919,'pr','Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(321052,8919,'tr','Proje tÃ¼rÃ¼',0),(321053,8919,'pl','Typ projektu',0),(321054,8919,'bg','Ð¢Ð¸Ð¿ Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(321055,8919,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ Ù‚Ø³Ù…',0),(321056,8919,'sr','Ð¢Ð¸Ð¿ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(321057,8919,'vi','Loáº¡i Dá»± Ã¡n',0),(321058,8919,'af','Projek Tipe',0),(321059,8919,'ro','Proiect tip',0),(321060,8919,'et','Projekti tÃ¼Ã¼p',0),(321061,8919,'si','Vrsta projekta',0),(321062,8919,'ba','Jenis proyek',0),(321063,8919,'nl','Projecttype',0),(321064,8919,'fi','Projektityyppi',0),(321065,8919,'no','Prosjekttype',0),(321066,8919,'da','Projekttypen',0),(321067,8919,'ko','í”„ë¡œì íŠ¸ í˜•ì‹',0),(321068,8919,'he','×¡×•×’ ×¤×¨×•×™×™×§×˜',0),(321069,8919,'el','Î¤ÏÏ€Î¿Ï‚ Î­ÏÎ³Î¿Ï…',0),(321070,8919,'zh','é¡¹ç›®ç±»åž‹\r\n',0),(321071,8919,'sv','Projekttypen',0),(321072,8919,'it','Tipo di progetto',0),(321073,8919,'tl','',0),(321074,8919,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(321075,8919,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(321076,8919,'ms','Jenis projek',0),(321077,8919,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(321078,8919,'fr','Type de projet',0),(321079,8919,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®ç¨®é¡ž',0),(321080,8919,'pt','Tipo de projeto',0),(321081,8919,'ru','Ð¢Ð¸Ð¿ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(321082,8919,'es','Tipo de Proyecto',0),(321083,8919,'de','Projekttyp',0),(321084,8919,'en','Project Type',0),(321085,8920,'is','',0),(321086,8920,'dr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(321087,8920,'pr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(321088,8920,'tr','AylÄ±k fatura',0),(321089,8920,'pl','Naliczane co miesiÄ…c',0),(321090,8920,'bg','ÐÐ°Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ñ‚ ÐµÐ¶ÐµÐ¼ÐµÑÐµÑ‡Ð½Ð¾',0),(321091,8920,'ur','Ù…Ø§ÛØ§Ù†Û Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(321092,8920,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð¼Ñ˜ÐµÑÐµÑ‡Ð½Ð¾',0),(321093,8920,'vi','Láº­p HÃ³a ÄÆ¡n HÃ ng ThÃ¡ng',0),(321094,8920,'af','Maandeliks weerspieÃ«l',0),(321095,8920,'ro','Facturat lunar',0),(321096,8920,'et','Arve esitatakse igakuiselt',0),(321097,8920,'si','ZaraÄunavajo meseÄno',0),(321098,8920,'ba','Ditagih per bulan',0),(321099,8920,'nl','Maandelijks worden gefactureerd',0),(321100,8920,'fi','Laskutetaan kuukausittain',0),(321101,8920,'no','Fakturert mÃ¥nedlig',0),(321102,8920,'da','Faktureret mÃ¥nedligt',0),(321103,8920,'ko','ë§¤ì›” ì²­êµ¬ ë©ë‹ˆë‹¤.',0),(321104,8920,'he','×ž×—×•×™×‘ ×‘××•×¤×Ÿ ×—×•×“×©×™',0),(321105,8920,'el','Î§ÏÎµÏŽÎ½ÎµÏ„Î±Î¹ ÎºÎ¬Î¸Îµ Î¼Î®Î½Î±',0),(321106,8920,'zh','æ¯æœˆå¸å•\r\n',0),(321107,8920,'sv','Faktureras mÃ¥nadsvis',0),(321108,8920,'it','Fatturati mensilmente',0),(321109,8920,'tl','',0),(321110,8920,'th','&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3611;&#3619;&#3632;&#3592;&#3635;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(321111,8920,'hi','à¤®à¤¾à¤¸à¤¿à¤• à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾',0),(321112,8920,'ms','Dibilkan secara bulanan',0),(321113,8920,'ar','ÙÙˆØ§ØªÙŠØ± Ø´Ù‡Ø±ÙŠØ©',0),(321114,8920,'fr','FacturÃ© mensuellement',0),(321115,8920,'jp','æ¯Žæœˆã€è«‹æ±‚',0),(321116,8920,'pt','CobranÃ§a mensal',0),(321117,8920,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÐµÐ¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ð¾',0),(321118,8920,'es','Facturado Mensualmente',0),(321119,8920,'de','Monatlich in Rechnung gestellt',0),(321120,8920,'en','Billed Monthly',0),(321121,8921,'is','',0),(321122,8921,'dr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ Ù‡ÙØªÚ¯ÙŠ',0),(321123,8921,'pr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ Ù‡ÙØªÚ¯ÙŠ',0),(321124,8921,'tr','HaftalÄ±k faturalandÄ±rÄ±lÄ±r',0),(321125,8921,'pl','Zapowiadane co tydzieÅ„',0),(321126,8921,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð²ÐµÐ´Ð½ÑŠÐ¶ ÑÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð¾',0),(321127,8921,'ur','ÛÙØªÛ ÙˆØ§Ø± Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(321128,8921,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÐµÐ½ ÑÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð¾',0),(321129,8921,'vi','Láº­p HÃ³a ÄÆ¡n HÃ ng Tuáº§n',0),(321130,8921,'af','Weeklikse weerspieÃ«l',0),(321131,8921,'ro','Facturat sÄƒptÄƒmÃ¢nal',0),(321132,8921,'et','Arve esitatakse iganÃ¤dalaselt',0),(321133,8921,'si','ZaraÄunali tedensko',0),(321134,8921,'ba','Ditagih mingguan',0),(321135,8921,'nl','Wekelijks gefactureerd',0),(321136,8921,'fi','Laskutetaan viikoittain',0),(321137,8921,'no','Fakturert ukentlig',0),(321138,8921,'da','Faktureret ugentligt',0),(321139,8921,'ko','ë§¤ì£¼ ì²­êµ¬',0),(321140,8921,'he','×ž×—×•×™×‘ ×‘××•×¤×Ÿ ×©×‘×•×¢×™',0),(321141,8921,'el','Î§ÏÎµÏŽÎ½ÎµÏ„Î±Î¹ ÎµÎ²Î´Î¿Î¼Î±Î´Î¹Î±Î¯Î±Ï‚',0),(321142,8921,'zh','æ¯å‘¨å¸å•\r\n',0),(321143,8921,'sv','Faktureras varje vecka',0),(321144,8921,'it','Fatturati settimanali',0),(321145,8921,'tl','',0),(321146,8921,'th','&#3619;&#3634;&#3618;&#3648;&#3585;&#3655;&#3610;&#3619;&#3634;&#3618;&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(321147,8921,'hi','à¤¸à¤¾à¤ªà¥à¤¤à¤¾à¤¹à¤¿à¤• à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾',0),(321148,8921,'ms','Dibilkan mingguan',0),(321149,8921,'ar','ÙˆØµÙØª Ø£Ø³Ø¨ÙˆØ¹ÙŠØ©',0),(321150,8921,'fr','FacturÃ© par semaine',0),(321151,8921,'jp','æ¯Žé€±ã®è«‹æ±‚',0),(321152,8921,'pt','Faturado semanalmente',0),(321153,8921,'ru','Ð’Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚ Ð·Ð° Ð½ÐµÐ´ÐµÐ»ÑŽ',0),(321154,8921,'es','Facturado Semanalmente',0),(321155,8921,'de','WÃ¶chentlich in Rechnung gestellt',0),(321156,8921,'en','Billed Weekly',0),(321157,8922,'is','',0),(321158,8922,'dr','Ù…Ø±Ø§Ø­Ù„ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(321159,8922,'pr','Ù…Ø±Ø§Ø­Ù„ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(321160,8922,'tr','Fatura aÅŸamalarÄ±',0),(321161,8922,'pl','Rozliczanie etapÃ³w',0),(321162,8922,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ ÐµÑ‚Ð°Ð¿Ð¸',0),(321163,8922,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù…Ø±Ø§Ø­Ù„',0),(321164,8922,'sr','Ð¤Ð°Ð·Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(321165,8922,'vi','QuÃ¡ TrÃ¬nh Gá»­p hÃ³i HÃ³a ÄÆ¡n',0),(321166,8922,'af','Verekening Misluk',0),(321167,8922,'ro','Facturare fazele',0),(321168,8922,'et','Arved etapid',0),(321169,8922,'si','ZaraÄunavanje fazah',0),(321170,8922,'ba','Tahap penagihan',0),(321171,8922,'nl','Fasen facturering',0),(321172,8922,'fi','Laskutus vaiheet',0),(321173,8922,'no','Fakturering stadier',0),(321174,8922,'da','Fakturering faser',0),(321175,8922,'ko','ê²°ì œ ë‹¨ê³„',0),(321176,8922,'he','×—×™×•×‘ ×©×œ×‘×™×',0),(321177,8922,'el','Î£Ï„Î¬Î´Î¹Î± Ï„Î·Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(321178,8922,'zh','ç»“ç®—é˜¶æ®µ\r\n',0),(321179,8922,'sv','Fakturering stadier',0),(321180,8922,'it','Fasi di fatturazione',0),(321181,8922,'tl','',0),(321182,8922,'th','&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;&#3623;&#3634;&#3591;&#3610;&#3636;&#3621;',0),(321183,8922,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤šà¤°à¤£à¥‹à¤‚',0),(321184,8922,'ms','Bil peringkat',0),(321185,8922,'ar','Ù…Ø±Ø§Ø­Ù„ Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(321186,8922,'fr','Ã‰tapes de la facturation',0),(321187,8922,'jp','æ”¯æ‰•ã„ã‚¹ãƒ†ãƒ¼ã‚¸',0),(321188,8922,'pt','EstÃ¡gios de faturamento',0),(321189,8922,'ru','Ð­Ñ‚Ð°Ð¿Ñ‹ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³Ð°',0),(321190,8922,'es','Fases de FacturaciÃ³n',0),(321191,8922,'de','Abrechnung-Stufen',0),(321192,8922,'en','Billing Stages',0),(321193,8923,'is','',0),(321194,8923,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯Ø± Ù…Ø±Ø§Ø­Ù„ Ù‚Ø·Ø¹ÙŠ Ø´Ø¯Ù†',0),(321195,8923,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯Ø± Ù…Ø±Ø§Ø­Ù„ Ù‚Ø·Ø¹ÙŠ Ø´Ø¯Ù†',0),(321196,8923,'tr','Bill, sabit aÅŸamalÄ±',0),(321197,8923,'pl','Bill w fazie staÅ‚ej',0),(321198,8923,'bg','Ð‘Ð¸Ð» Ð² Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ ÑÑ‚Ð°Ð´Ð¸Ð¹',0),(321199,8923,'ur','Ø¨Ù„ Ù…Ù‚Ø±Ø±Û Ù…Ø±Ø§Ø­Ù„ Ù…ÛŒÚº',0),(321200,8923,'sr','Ð‘Ð¸Ð» Ñƒ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¸Ð¼ Ñ„Ð°Ð·Ð°Ð¼Ð°',0),(321201,8923,'vi','Láº­p HÃ³a ÄÆ¡n Theo CÃ¡c BÆ°á»›c Äá»‹nh Sáºµn',0),(321202,8923,'af','Wetsontwerp in vaste stadiums',0),(321203,8923,'ro','Proiect de lege Ã®n fazele fixe',0),(321204,8923,'et','Bill fikseeritud etappe',0),(321205,8923,'si','Zakona v osnovnih fazah',0),(321206,8923,'ba','Bill dalam tahap tetap',0),(321207,8923,'nl','Bill in vaste fasen',0),(321208,8923,'fi','Bill kiinteÃ¤ vaiheittain',0),(321209,8923,'no','Bill i fast stadier',0),(321210,8923,'da','Bill i faste stadier',0),(321211,8923,'ko','ê³ ì •ëœ ë‹¨ê³„ì—ì„œ ë¹Œ',0),(321212,8923,'he','×‘×™×œ ×‘×©×œ×‘×™× ×§×‘×•×¢×™×',0),(321213,8923,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ ÏƒÏ„Î¿ ÏƒÏ„Î±Î¸ÎµÏÏŒ ÏƒÏ„Î¬Î´Î¹Î±',0),(321214,8923,'zh','å¸å•ä¿®æ­£é˜¶æ®µ\r\n',0),(321215,8923,'sv','Bill i fasta steg',0),(321216,8923,'it','Bill in fasi fisse',0),(321217,8923,'tl','',0),(321218,8923,'th','Bill in Fixed Stages',0),(321219,8923,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤šà¤°à¤£à¥‹à¤‚ à¤®à¥‡à¤‚',0),(321220,8923,'ms','Rang undang-undang secara berperingkat-peringkat tetap',0),(321221,8923,'ar','Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† ÙÙŠ Ø§Ù„Ù…Ø±Ø§Ø­Ù„ Ø§Ù„Ø«Ø§Ø¨ØªØ©',0),(321222,8923,'fr','Projet de loi dans les stades fixes',0),(321223,8923,'jp','å›ºå®šæ®µéšŽã§æ³•æ¡ˆ',0),(321224,8923,'pt','Bill em estÃ¡gios fixos',0),(321225,8923,'ru','Ð‘Ð¸Ð»Ð» Ð² Ñ„Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… ÑÑ‚Ð°Ð¿Ð¾Ð²',0),(321226,8923,'es','Facturar en Niveles Fijos',0),(321227,8923,'de','Bill in festen Stufen',0),(321228,8923,'en','Bill in Fixed Stages',0),(321229,8924,'is','',0),(321230,8924,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(321231,8924,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(321232,8924,'tr','Komisyon GL hesabÄ±',0),(321233,8924,'pl','Komisja GL konta',0),(321234,8924,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° GL Ð¿Ñ€Ð¾Ñ„Ð¸Ð»',0),(321235,8924,'ur','Ú©Ù…ÛŒØ´Ù† Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(321236,8924,'sr','ÐŸÑ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ñƒ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(321237,8924,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Hoa Há»“ng',0),(321238,8924,'af','Kommissie AG Rekening',0),(321239,8924,'ro','Comisia GL cont',0),(321240,8924,'et','Komisjoni pearaamatukontole',0),(321241,8924,'si','Komisija raÄun GL',0),(321242,8924,'ba','Komisi rekening GL',0),(321243,8924,'nl','Commissie GL Account',0),(321244,8924,'fi','Komission Kirjanpitotilin pÃ¤Ã¤tilin',0),(321245,8924,'no','GL konto',0),(321246,8924,'da','Kommissionen GL konto',0),(321247,8924,'ko','ìœ„ì›íšŒ GL ê³„ì •',0),(321248,8924,'he','×”× ×¦×™×‘×•×ª GL ×—×©×‘×•×Ÿ',0),(321249,8924,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(321250,8924,'zh','ä½£é‡‘æ€»å¸å¸æˆ·\r\n',0),(321251,8924,'sv','Kommissionen GL konto',0),(321252,8924,'it','Commissione GL Account',0),(321253,8924,'tl','',0),(321254,8924,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(321255,8924,'hi','à¤†à¤¯à¥‹à¤— GL à¤–à¤¾à¤¤à¥‡',0),(321256,8924,'ms','Akaun GL Suruhanjaya',0),(321257,8924,'ar','Ø­Ø³Ø§Ø¨ Ø¹Ù…ÙˆÙ„Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ÙÙŠ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(321258,8924,'fr','Compte GL Conseil',0),(321259,8924,'jp','å§”å“¡ä¼šã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(321260,8924,'pt','ComissÃ£o GL conta',0),(321261,8924,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ñ ÑÑ‡ÐµÑ‚ GL',0),(321262,8924,'es','Cuenta LM de Comisiones',0),(321263,8924,'de','Kommission Sako',0),(321264,8924,'en','Commission GL Account',0),(321265,8925,'is','',0),(321266,8925,'dr','Ø¯Ø±ØµØ¯ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(321267,8925,'pr','Ø¯Ø±ØµØ¯ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(321268,8925,'tr','Komisyon yÃ¼zdesi',0),(321269,8925,'pl','Procent Komisji',0),(321270,8925,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(321271,8925,'ur','Ú©Ù…ÛŒØ´Ù† ÙÛŒØµØ¯',0),(321272,8925,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¿Ð¾ÑÑ‚Ð¾',0),(321273,8925,'vi','% Hoa há»“ng ',0),(321274,8925,'af','Kommissie Persentasie',0),(321275,8925,'ro','Comisia la sutÄƒ',0),(321276,8925,'et','Komisjoni protsenti',0),(321277,8925,'si','Komisija odstotkov',0),(321278,8925,'ba','Komisi persen',0),(321279,8925,'nl','Commissie procent',0),(321280,8925,'fi','Komission prosenttia',0),(321281,8925,'no','Kommisjonen prosent',0),(321282,8925,'da','Kommissionen procent',0),(321283,8925,'ko','ìœ„ì›íšŒ %',0),(321284,8925,'he','××—×•×– ×¢×ž×œ×”',0),(321285,8925,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(321286,8925,'zh','ä½£é‡‘ç™¾åˆ†æ¯”\r\n',0),(321287,8925,'sv','Kommissionen procent',0),(321288,8925,'it','Commissione percentuale',0),(321289,8925,'tl','',0),(321290,8925,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(321291,8925,'hi','à¤•à¤®à¥€à¤¶à¤¨ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(321292,8925,'ms','Peratus komisen',0),(321293,8925,'ar','Ù†Ø³Ø¨Ø© Ø§Ù„Ø¹Ù…ÙˆÙ„Ø©',0),(321294,8925,'fr','Pour cent de Commission',0),(321295,8925,'jp','æ­©åˆ (%)',0),(321296,8925,'pt','Por cento de ComissÃ£o',0),(321297,8925,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(321298,8925,'es','Porciento de ComisÃ³n',0),(321299,8925,'de','Kommission Prozent',0),(321300,8925,'en','Commission Percent',0),(321301,8926,'is','',0),(321302,8926,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù‚ÙŠÙ…Øª ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§Ù‰ ÙØ±ÙˆØ´ Ø±ÙØªÙ‡',0),(321303,8926,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù‚ÙŠÙ…Øª ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§Ù‰ ÙØ±ÙˆØ´ Ø±ÙØªÙ‡',0),(321304,8926,'tr','SatÄ±ÅŸ GL hesap maliyeti',0),(321305,8926,'pl','Koszt konta sprzedaÅ¼y GL',0),(321306,8926,'bg','Ð¡ÐµÐ±ÐµÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(321307,8926,'ur','Ù‚ÛŒÙ…Øª ÙØ±ÙˆØ®Øª Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’',0),(321308,8926,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(321309,8926,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Chi PhÃ­ BÃ¡n HÃ ng',0),(321310,8926,'af','Koste van Verkope AG Rekening',0),(321311,8926,'ro','Costul de vÃ¢nzare GL cont',0),(321312,8926,'et','MÃ¼Ã¼gi pearaamatukontole kulu',0),(321313,8926,'si','StroÅ¡ki prodaje GL raÄun',0),(321314,8926,'ba','Biaya penjualan GL account',0),(321315,8926,'nl','Kosten van verkoop GL Account',0),(321316,8926,'fi','Kustannukset myynti Kirjanpitotilin pÃ¤Ã¤tilin',0),(321317,8926,'no','Kostnaden for salg gi-konto',0),(321318,8926,'da','Udgifterne til salg GL konto',0),(321319,8926,'ko','íŒë§¤ GL ê³„ì •ì˜ ë¹„ìš©',0),(321320,8926,'he','×¢×œ×•×ª ×©×œ ×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª GL',0),(321321,8926,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï„Î·Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³/Î»',0),(321322,8926,'zh','é”€å”®æˆæœ¬æ€»å¸å¸æˆ·\r\n',0),(321323,8926,'sv','Kostnaden fÃ¶r fÃ¶rsÃ¤ljning GL konto',0),(321324,8926,'it','Costo del conto vendita GL',0),(321325,8926,'tl','',0),(321326,8926,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(321327,8926,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ GL à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤²à¤¾à¤—à¤¤',0),(321328,8926,'ms','Kos akaun jualan GL',0),(321329,8926,'ar','Ø­Ø³Ø§Ø¨ ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(321330,8926,'fr','CoÃ»t des ventes GL compte',0),(321331,8926,'jp','è²©å£²ã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ã‚³ã‚¹ãƒˆ',0),(321332,8926,'pt','Custo da conta de vendas GL',0),(321333,8926,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÑÑ‡ÐµÑ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶ GL',0),(321334,8926,'es','Cuenta LM de Costo de Ventas',0),(321335,8926,'de','Kosten fÃ¼r Verkauf Sako',0),(321336,8926,'en','Cost of Sales GL Account',0),(321337,8927,'is','',0),(321338,8927,'dr','ØªÙƒØ±Ø§Ø± ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…Ø´ØªØ±ÙŠ',0),(321339,8927,'pr','ØªÙƒØ±Ø§Ø± ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…Ø´ØªØ±ÙŠ',0),(321340,8927,'tr','Ã–zel fatura sÄ±klÄ±ÄŸÄ±',0),(321341,8927,'pl','NiestandardowÄ… czÄ™stotliwoÅ›Ä‡ rozliczeÅ„',0),(321342,8927,'bg','ÐžÐ±Ð¸Ñ‡Ð°Ð¹ Ñ‡ÐµÑÑ‚Ð¾Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(321343,8927,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ØªØ¹Ø¯Ø¯',0),(321344,8927,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¸ ÑƒÑ‡ÐµÑÑ‚Ð°Ð»Ð¾ÑÑ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐ°',0),(321345,8927,'vi','Táº§n Suáº¥t Láº­p HÃ³a ÄÆ¡n Tá»± Táº¡o',0),(321346,8927,'af','Aangepasde Verekeningsfrekewensie',0),(321347,8927,'ro','FrecvenÅ£a de facturare personalizate',0),(321348,8927,'et','Vali arve esitamise sagedus',0),(321349,8927,'si','Meri pogostost zaraÄunavanja',0),(321350,8927,'ba','Kustom penagihan frekuensi',0),(321351,8927,'nl','Aangepaste Factureringsfrequentie',0),(321352,8927,'fi','Mukautetun laskutus taajuus',0),(321353,8927,'no','Egendefinerte fakturering frekvens',0),(321354,8927,'da','Brugerdefinerede fakturering frekvens',0),(321355,8927,'ko','ì‚¬ìš©ìž ì§€ì • ê²°ì œ ì£¼íŒŒìˆ˜',0),(321356,8927,'he','×ª×“×™×¨×•×ª ×”×—×™×•×‘ ×ž×•×ª×× ××™×©×™×ª',0),(321357,8927,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· ÏƒÏ…Ï‡Î½ÏŒÏ„Î·Ï„Î± Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(321358,8927,'zh','è‡ªå®šä¹‰å¸å•é¢‘çŽ‡\r\n',0),(321359,8927,'sv','Anpassade Billing frekvens',0),(321360,8927,'it','Frequenza fatturazione cliente',0),(321361,8927,'tl','',0),(321362,8927,'th','&#3588;&#3623;&#3634;&#3617;&#3606;&#3637;&#3656;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;',0),(321363,8927,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤†à¤µà¥ƒà¤¤à¥à¤¤à¤¿',0),(321364,8927,'ms','Adat bil kekerapan',0),(321365,8927,'ar','Ù…Ø®ØµØµ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªØ±Ø¯Ø¯',0),(321366,8927,'fr','FrÃ©quence de facturation personnalisÃ©',0),(321367,8927,'jp','ã‚«ã‚¹ã‚¿ãƒ ã®è«‹æ±‚é »åº¦',0),(321368,8927,'pt','FreqÃ¼Ãªncia de cobranÃ§a personalizada',0),(321369,8927,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ñ‡Ð°ÑÑ‚Ð¾Ñ‚Ñ‹ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(321370,8927,'es','Frecuencia de FacturaciÃ³n de Cliente',0),(321371,8927,'de','Benutzerdefinierte Billing-Frequenz',0),(321372,8927,'en','Custom Billing Frequency',0),(321373,8928,'is','',0),(321374,8928,'dr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(321375,8928,'pr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(321376,8928,'tr','VarsayÄ±lan AracÄ±sÄ± iÃ§in komisyon',0),(321377,8928,'pl','DomyÅ›lnie Agent dla Komisji',0),(321378,8928,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð°Ð³ÐµÐ½Ñ‚ Ð·Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(321379,8928,'ur','Ø·Û’ Ø´Ø¯Û Ø§ÛŒØ¬Ù†Ù¹ Ú©Û’ Ú©Ù…ÛŒØ´Ù† Ú©Û’ Ù„Ø¦Û’',0),(321380,8928,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ ÐÐ³ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ðµ Ð·Ð°',0),(321381,8928,'vi','Äáº¡i lÃ½ máº·c Ä‘á»‹nh cho hoa há»“ng',0),(321382,8928,'af','Verstekte Agent vir Kommissie',0),(321383,8928,'ro','Implicit Agent pentru Comisia',0),(321384,8928,'et','Vaikimisi Agent komisjoni',0),(321385,8928,'si','Privzeti Agent za Komisijo',0),(321386,8928,'ba','Default agen untuk Komisi',0),(321387,8928,'nl','Standaard Agent voor de Commissie',0),(321388,8928,'fi','Oletuksena agentti komission',0),(321389,8928,'no','Standard Agent For kommisjonen',0),(321390,8928,'da','Standard Agent For Kommissionen',0),(321391,8928,'ko','ìœ„ì›íšŒì— ëŒ€ í•œ ê¸°ë³¸ ì—ì´ì „íŠ¸',0),(321392,8928,'he','×¡×•×›×Ÿ ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×‘×•×¨ ×”× ×¦×™×‘×•×ª',0),(321393,8928,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î± Î³Î¹Î± Ï„Î·Î½ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®',0),(321394,8928,'zh','é»˜è®¤ä»£ç†çš„ä½£é‡‘\r\n',0),(321395,8928,'sv','Standardagent fÃ¶r kommissionen',0),(321396,8928,'it','Agente predefinito per Commissione',0),(321397,8928,'tl','',0),(321398,8928,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(321399,8928,'hi','à¤†à¤¯à¥‹à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤à¤œà¥‡à¤‚à¤Ÿ',0),(321400,8928,'ms','Lalai ejen komisen',0),(321401,8928,'ar','ÙˆÙƒÙŠÙ„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù„Ø¬Ù†Ø©',0),(321402,8928,'fr','Agent par dÃ©faut pour la Commission',0),(321403,8928,'jp','æ—¢å®šã®ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã®æ‰‹æ•°æ–™',0),(321404,8928,'pt','Agente padrÃ£o para ComissÃ£o',0),(321405,8928,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð°Ð³ÐµÐ½Ñ‚ Ð´Ð»Ñ ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(321406,8928,'es','Agente Predeterminado para la ComisiÃ³n',0),(321407,8928,'de','Standard-Agent fÃ¼r die Kommission',0),(321408,8928,'en','Default Agent For Commission',0),(321409,8929,'is','',0),(321410,8929,'dr','Ø´Ø±Ø­ Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(321411,8929,'pr','Ø´Ø±Ø­ Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(321412,8929,'tr','Proje tipinin aÃ§Ä±klamasÄ±',0),(321413,8929,'pl','Opis projektu typu',0),(321414,8929,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð½Ð¾Ñ‚Ð¾',0),(321415,8929,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(321416,8929,'sr','ÐžÐ¿Ð¸Ñ Ñ‚Ð¸Ð¿ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(321417,8929,'vi','MÃ´ táº£ loáº¡i dá»± Ã¡n',0),(321418,8929,'af','Beskrywing van Projek Tipe',0),(321419,8929,'ro','Descriere a tipului de proiect',0),(321420,8929,'et','Projekti tÃ¼Ã¼bi kirjeldus',0),(321421,8929,'si','Opis vrste projekta',0),(321422,8929,'ba','Deskripsi jenis proyek',0),(321423,8929,'nl','Beschrijving van projecttype',0),(321424,8929,'fi','Projektin kuvaus',0),(321425,8929,'no','Beskrivelse av prosjektet',0),(321426,8929,'da','Beskrivelse af projektet',0),(321427,8929,'ko','í”„ë¡œì íŠ¸ í˜•ì‹ì˜ ì„¤ëª…',0),(321428,8929,'he','×ª×™××•×¨ ×©×œ ×¡×•×’ ×¤×¨×•×™×™×§×˜',0),(321429,8929,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Ï„ÏÏ€Î¿Ï… Ï„Î¿Ï… Î­ÏÎ³Î¿Ï…',0),(321430,8929,'zh','é¡¹ç›®ç±»åž‹è¯´æ˜Ž\r\n',0),(321431,8929,'sv','Beskrivning av projektet',0),(321432,8929,'it','Descrizione del tipo di progetto',0),(321433,8929,'tl','',0),(321434,8929,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(321435,8929,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(321436,8929,'ms','Keterangan mengenai jenis projek',0),(321437,8929,'ar','ÙˆØµÙ Ù„Ù†ÙˆØ¹ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(321438,8929,'fr','Description du Type de projet',0),(321439,8929,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®ç¨®é¡žã®èª¬æ˜Ž',0),(321440,8929,'pt','DescriÃ§Ã£o do tipo de projeto',0),(321441,8929,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(321442,8929,'es','DescripciÃ³n de Tipo de Proyecto',0),(321443,8929,'de','Beschreibung des Projekttyps',0),(321444,8929,'en','Description of Project Type',0),(321445,8930,'is','',0),(321446,8930,'dr','Ø§Ú¯Ø± ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ù‡Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨  Ú†Ù†Ø¯ Ø±ÙˆØ² ',0),(321447,8930,'pr','Ø§Ú¯Ø± ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ù‡Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨  Ú†Ù†Ø¯ Ø±ÙˆØ² ',0),(321448,8930,'tr','Her gÃ¼n Ã¶zel fatura sÄ±klÄ±ÄŸÄ± faturalamak isterseniz',0),(321449,8930,'pl','JeÅ›li niestandardowe czÄ™stotliwoÅ›Ä‡ pÅ‚atnoÅ›ci rachunek co ile dni',0),(321450,8930,'bg','ÐÐºÐ¾ Ð¾Ð±Ð¸Ñ‡Ð°Ð¹ Ñ‡ÐµÑÑ‚Ð¾Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð±Ð¸Ð» Ð²ÑÐµÐºÐ¸ ÐºÐ¾Ð»ÐºÐ¾ Ð´Ð½Ð¸',0),(321451,8930,'ur','Ø§Ú¯Ø± Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ØªØ¹Ø¯Ø¯ ÛØ± Ú©Ø³ Ø·Ø±Ø­ Ø¨ÛØª Ø¯Ù†ÙˆÚº ØªÚ© Ø¨Ù„',0),(321452,8930,'sr','ÐÐºÐ¾ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¸ ÑƒÑ‡ÐµÑÑ‚Ð°Ð»Ð¾ÑÑ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐ° Ð‘Ð¸Ð» ÑÐ²Ð°ÐºÐ¸ ÐºÐ¾Ð»Ð¸ÐºÐ¾ Ð´Ð°Ð½Ð°',0),(321453,8930,'vi','Náº¿u táº§n suáº¥t hÃ³a Ä‘Æ¡n tá»± táº¡o sáº½ láº­p hÃ³a Ä‘Æ¡n bao nhiÃªu ngÃ y',0),(321454,8930,'af','As pasgemaakte fakturering frekwensie Bill elke hoeveel dae',0),(321455,8930,'ro','ÃŽn cazul Ã®n care personalizate facturare frecvenÅ£a factura fiecare cÃ¢te zile',0),(321456,8930,'et','Kui valid ise arve esitamise sageduse, siis mitme pÃ¤eva tagant?',0),(321457,8930,'si','ÄŒe meri pogostost zaraÄunavanja Bill vsakih koliko dni',0),(321458,8930,'ba','Jika kustom penagihan frekuensi tagihan setiap berapa hari',0),(321459,8930,'nl','Als aangepaste Factureringsfrequentie om hoeveel dagen factureren',0),(321460,8930,'fi','Jos mukautetun laskutus taajuus Bill joka kuinka monta pÃ¤ivÃ¤Ã¤',0),(321461,8930,'no','Hvis egendefinert fakturering frekvens fakturere hver hvor mange dager',0),(321462,8930,'da','Hvis brugerdefineret fakturering frekvens fakturerer hver hvor mange dage',0),(321463,8930,'ko','ì‚¬ìš©ìž ì§€ì • ê²°ì œ ì£¼íŒŒìˆ˜ ë¹Œ ëª¨ë“  ì–¼ë§ˆë‚˜ ë§Žì€ ì¼ í•˜ëŠ” ê²½ìš°',0),(321464,8930,'he','×× ×ª×“×™×¨×•×ª ×”×—×™×•×‘ ×ž×•×ª×× ××™×©×™×ª ×‘×™×œ ×›×œ ×›×ž×” ×™×ž×™×',0),(321465,8930,'el','Î•Î¬Î½ Î· Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· ÏƒÏ…Ï‡Î½ÏŒÏ„Î·Ï„Î± Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ ÎºÎ¬Î¸Îµ Ï€ÏŒÏƒÎµÏ‚ Î·Î¼Î­ÏÎµÏ‚',0),(321466,8930,'zh','å¦‚æžœè‡ªå®šä¹‰å¸å•é¢‘çŽ‡ç»™æ¯ä¸€é¡¹å¼€å¤šå°‘å¤©è´¦å•\r\n',0),(321467,8930,'sv','Om anpassade Billing frekvens var hur mÃ¥nga dagar',0),(321468,8930,'it','Se la frequenza di fatturazione personalizzata fattura ogni quanti giorni',0),(321469,8930,'tl','',0),(321470,8930,'th','&#3627;&#3634;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3588;&#3623;&#3634;&#3617;&#3606;&#3637;&#3656;&#3610;&#3636;&#3621;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3607;&#3640;&#3',0),(321471,8930,'hi','à¤¯à¤¦à¤¿ à¤•à¤¸à¥à¤Ÿà¤® à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤†à¤µà¥ƒà¤¤à¥à¤¤à¤¿ à¤¬à¤¿à¤² à¤¹à¤° à¤•à¤¿à¤¤à¤¨à¥‡ à¤¦à¤¿à¤¨',0),(321472,8930,'ms','Jika adat kekerapan bil bil setiap hari berapa banyak',0),(321473,8930,'ar','Ø¥Ø°Ø§ ÙØ§ØªÙˆØ±Ø© Ù…Ø®ØµØµ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªØ±Ø¯Ø¯ ÙƒÙ„ ÙƒÙ… Ø¹Ø¯Ø¯ Ø§Ù„Ø£ÙŠØ§Ù…',0),(321474,8930,'fr','Si la frÃ©quence de facturation personnalisÃ© facture chaque combien de jours',0),(321475,8930,'jp','ã‚«ã‚¹ã‚¿ãƒ è«‹æ±‚é »åº¦æ•°æ—¥ã”ã¨ã«è«‹æ±‚ã™ã‚‹å ´åˆ',0),(321476,8930,'pt','Se a frequÃªncia de faturamento personalizado conta em quantos dias',0),(321477,8930,'ru','Ð•ÑÐ»Ð¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ñ‡Ð°ÑÑ‚Ð¾Ñ‚Ñ‹ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð² Ð‘Ð¸Ð»Ð» ÐºÐ°Ð¶Ð´Ñ‹Ðµ ÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð´Ð½ÐµÐ¹',0),(321478,8930,'es','Si es la Frecuencia de FacturaciÃ³n Personalizada, Facturar Cada Cuantos DÃ­as',0),(321479,8930,'de','Wenn benutzerdefinierte Billing-Frequenz alle wieviele Tage Rechnung',0),(321480,8930,'en','If Custom Billing Frequency Bill Every How Many Days',0),(321481,8931,'is','',0),(321482,8931,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙŠÚ¯Ø± Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(321483,8931,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙŠÚ¯Ø± Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(321484,8931,'tr','DiÄŸer GL hesap',0),(321485,8931,'pl','Inne bezpÅ‚atne konto GL',0),(321486,8931,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(321487,8931,'ur','Ø¯ÙˆØ³Ø±Û’ Ú†Ø§Ø±Ø¬ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(321488,8931,'sr','Ð”Ñ€ÑƒÐ³Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð¸ Ð“Ð›',0),(321489,8931,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p Chi PhÃ­ KhÃ¡c',0),(321490,8931,'af','Ander \"Charge\" AG Rekening',0),(321491,8931,'ro','Alte taxe GL cont',0),(321492,8931,'et','Muud tasu pearaamatukontole',0),(321493,8931,'si','RaÄun drugih dajatev GL',0),(321494,8931,'ba','Account GL biaya lainnya',0),(321495,8931,'nl','Andere rekening Charge GL',0),(321496,8931,'fi','Muut GL tilille',0),(321497,8931,'no','Andre GL konto',0),(321498,8931,'da','Andre omkostningskonto GL',0),(321499,8931,'ko','ë‹¤ë¥¸ ì¶©ì „ GL ê³„ì •',0),(321500,8931,'he','×—×©×‘×•×Ÿ ××—×¨×™× GL',0),(321501,8931,'el','Î†Î»Î»Î± Ï‡ÏÎ­Ï‰ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(321502,8931,'zh','æ€»å¸å¸æˆ·å…¶ä»–è´¹ç”¨\r\n',0),(321503,8931,'sv','Andra kostnadsfritt GL konto',0),(321504,8931,'it','Altri Account di carica GL',0),(321505,8931,'tl','',0),(321506,8931,'th','&#3588;&#3656;&#3634;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3629;&#3639;&#3656;&#3609;',0),(321507,8931,'hi','à¤…à¤¨à¥à¤¯ à¤ªà¥à¤°à¤­à¤¾à¤° GL à¤–à¤¾à¤¤à¥‡',0),(321508,8931,'ms','Lain-lain caj GL akaun',0),(321509,8931,'ar','Ø­Ø³Ø§Ø¨ GL ØªÙ‡Ù…Ø© Ø£Ø®Ø±Ù‰',0),(321510,8931,'fr','Autre dÃ©biter un compte GL',0),(321511,8931,'jp','ãã®ä»–æ–™é‡‘ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(321512,8931,'pt','Outra conta GL',0),(321513,8931,'ru','Ð”Ñ€ÑƒÐ³Ð°Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ GL Ð·Ð°Ñ€ÑÐ´Ð°',0),(321514,8931,'es','Otro Costo Cuenta LM',0),(321515,8931,'de','Andere GL-Kundenkonto',0),(321516,8931,'en','Other Charge GL Account',0),(321517,8932,'is','',0),(321518,8932,'dr','Ù†Ø§Ù… Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ ',0),(321519,8932,'pr','Ù†Ø§Ù… Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ ',0),(321520,8932,'tr','DiÄŸer yetkili adÄ±',0),(321521,8932,'pl','Inna nazwa bezpÅ‚atnie',0),(321522,8932,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ Ð¸Ð¼Ðµ',0),(321523,8932,'ur','Ø¯ÙˆØ³Ø±Ø§ Ø§Ù„Ø²Ø§Ù… Ú©Û’ Ù†Ø§Ù…',0),(321524,8932,'sr','Ð”Ñ€ÑƒÐ³Ð¾ Ð¸Ð¼Ðµ Ð·Ð° Ð¿ÑƒÑšÐµÑšÐµ',0),(321525,8932,'vi','TÃªn phÃ­ KhÃ¡c',0),(321526,8932,'af','Ander Heffing Naam',0),(321527,8932,'ro','Alte nume de taxa',0),(321528,8932,'et','Muu maksu nimetus',0),(321529,8932,'si','Drugo ime za brezplaÄno',0),(321530,8932,'ba','Nama biaya lain',0),(321531,8932,'nl','Andere gratis naam',0),(321532,8932,'fi','Muu maksu nimi',0),(321533,8932,'no','Andre gratis navn',0),(321534,8932,'da','Andre afgift navn',0),(321535,8932,'ko','ë‹¤ë¥¸ ì¶©ì „ ì´ë¦„',0),(321536,8932,'he','×©× ××—×¨ ×ª×©×œ×•×',0),(321537,8932,'el','Î†Î»Î»Î¿ ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(321538,8932,'zh','å…¶ä»–æ”¶è´¹å§“å\r\n',0),(321539,8932,'sv','Andra avgift namn',0),(321540,8932,'it','Altro nome di carica',0),(321541,8932,'tl','',0),(321542,8932,'th','&#3588;&#3656;&#3634;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3594;&#3639;&#3656;&#3629;&#3629;&#3639;&#3656;&#3609;',0),(321543,8932,'hi','à¤…à¤¨à¥à¤¯ à¤†à¤°à¥‹à¤ª à¤•à¤¾ à¤¨à¤¾à¤®',0),(321544,8932,'ms','Nama caj lain',0),(321545,8932,'ar','Ø§Ø³Ù… ØªÙ‡Ù…Ø© Ø£Ø®Ø±Ù‰',0),(321546,8932,'fr','Autre nom de Charge',0),(321547,8932,'jp','ãã®ä»–æ–™é‡‘å',0),(321548,8932,'pt','Outro nome de carga',0),(321549,8932,'ru','Ð”Ñ€ÑƒÐ³Ð¾Ðµ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð·Ð°Ñ€ÑÐ´Ð°',0),(321550,8932,'es','Nombre e Otro Costo',0),(321551,8932,'de','Anderer Name kostenlos',0),(321552,8932,'en','Other Charge Name',0),(321553,8933,'is','',0),(321554,8933,'dr','Ø¯Ø±ØµØ¯ Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ ',0),(321555,8933,'pr','Ø¯Ø±ØµØ¯ Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ ',0),(321556,8933,'tr','DiÄŸer ÅŸarj yÃ¼zde',0),(321557,8933,'pl','Inny procent opÅ‚aty',0),(321558,8933,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ %',0),(321559,8933,'ur','Ø¯ÛŒÚ¯Ø± Ú†Ø§Ø±Ø¬ ÙÛŒØµØ¯',0),(321560,8933,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ð´Ñ€ÑƒÐ³Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(321561,8933,'vi','% PhÃ­ KhÃ¡c',0),(321562,8933,'af','Ander Heffing Persentasie',0),(321563,8933,'ro','Alte taxe la sutÄƒ',0),(321564,8933,'et','Muu maksu protsent',0),(321565,8933,'si','Odstotkov drugih dajatev',0),(321566,8933,'ba','Persen biaya lainnya',0),(321567,8933,'nl','Andere gratis procent',0),(321568,8933,'fi','Muut ilmaiseksi prosenttia',0),(321569,8933,'no','Andre gratis prosent',0),(321570,8933,'da','Ã˜vrige gebyr procent',0),(321571,8933,'ko','ë‹¤ë¥¸ ì¶©ì „ %',0),(321572,8933,'he','××—×•×– ×ª×©×œ×•× ××—×¨×™×',0),(321573,8933,'el','Î†Î»Î»Î± Ï‡ÏÎ­Ï‰ÏƒÎ· Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(321574,8933,'zh','å…¶ä»–æ”¶è´¹ç™¾åˆ†æ¯”\r\n',0),(321575,8933,'sv','Andra avgift procent',0),(321576,8933,'it','Altra carica per cento',0),(321577,8933,'tl','',0),(321578,8933,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3609;&#3605;&#3660;&#3588;&#3656;&#3634;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3629;&#3639;&#3656;&#3609;',0),(321579,8933,'hi','à¤…à¤¨à¥à¤¯ à¤¶à¥à¤²à¥à¤• à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(321580,8933,'ms','Peratus caj lain',0),(321581,8933,'ar','Ø¨Ø§Ù„Ù…Ø¦Ø© Ù…Ù‚Ø§Ø¨Ù„ Ø§Ù„Ø£Ø®Ø±Ù‰',0),(321582,8933,'fr','Autres pour cent de Charge',0),(321583,8933,'jp','ãã®ä»–æ–™é‡‘ã® ï¼…',0),(321584,8933,'pt','Outros % de carga',0),(321585,8933,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð² Ð·Ð°Ñ€ÑÐ´Ð°',0),(321586,8933,'es','Porcentaje de Otro Costo',0),(321587,8933,'de','Andere kostenlos Prozent',0),(321588,8933,'en','Other Charge Percent',0),(321589,8934,'is','',0),(321590,8934,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(321591,8934,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(321592,8934,'tr','Proje tÃ¼rÃ¼ Ekle',0),(321593,8934,'pl','DodaÄ‡ typ projektu',0),(321594,8934,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(321595,8934,'ur','Ù¾Ø±Ø§Ø¬ÛŒÚ©Ù¹ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(321596,8934,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ñ‚Ð¸Ð¿ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(321597,8934,'vi','ThÃªm loáº¡i Dá»± Ã¡n',0),(321598,8934,'af','Projek Tipe Byvoeg',0),(321599,8934,'ro','Proiect tip Adauga',0),(321600,8934,'et','ProjektitÃ¼Ã¼bi lisamine',0),(321601,8934,'si','Dodati vrsto projekta',0),(321602,8934,'ba','Menambahkan jenis proyek',0),(321603,8934,'nl','Projecttype toevoegen',0),(321604,8934,'fi','Projektityypin lisÃ¤Ã¤',0),(321605,8934,'no','Prosjekttypen legge',0),(321606,8934,'da','Projekttypen tilfÃ¸je',0),(321607,8934,'ko','í”„ë¡œì íŠ¸ í˜•ì‹ ì¶”ê°€',0),(321608,8934,'he','×”×•×¡×£ ×¡×•×’ ×¤×¨×•×™×™×§×˜',0),(321609,8934,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„ÏÏ€Î¿Ï‚ Î­ÏÎ³Î¿Ï…',0),(321610,8934,'zh','é¡¹ç›®ç±»åž‹æ·»åŠ \r\n',0),(321611,8934,'sv','Projekttypen lÃ¤gga till',0),(321612,8934,'it','Aggiungi tipo di progetto',0),(321613,8934,'tl','',0),(321614,8934,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(321615,8934,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(321616,8934,'ms','Tambah jenis projek',0),(321617,8934,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(321618,8934,'fr','Type de projet ajouter',0),(321619,8934,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®ç¨®é¡žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(321620,8934,'pt','Adicionar o tipo de projeto',0),(321621,8934,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(321622,8934,'es','Tipo de Proyecto Agregar',0),(321623,8934,'de','Projekttyp hinzufÃ¼gen',0),(321624,8934,'en','Project Type Add',0),(321625,8935,'is','',0),(321626,8935,'dr','Ù…ØªÙˆØ³Ø· Ø¨Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡',0),(321627,8935,'pr','Ù…ØªÙˆØ³Ø· Ø¨Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡',0),(321628,8935,'tr','AVG maliyet',0),(321629,8935,'pl','Koszt AVG',0),(321630,8935,'bg','AVG Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(321631,8935,'ur','Ø§ÙˆØ³Ø· Ù„Ø§Ú¯Øª',0),(321632,8935,'sr','ÐÐ²Ð³ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(321633,8935,'vi','Chi PhÃ­ Trung BÃ¬nh',0),(321634,8935,'af','Gemidd. Koste',0),(321635,8935,'ro','AVG Cost',0),(321636,8935,'et','AVG kulu',0),(321637,8935,'si','AVG stroÅ¡ki',0),(321638,8935,'ba','AVG biaya',0),(321639,8935,'nl','AVG kosten',0),(321640,8935,'fi','AVG kustannukset',0),(321641,8935,'no','AVG kostnader',0),(321642,8935,'da','AVG omkostninger',0),(321643,8935,'ko','í‰ê·  ë¹„ìš©',0),(321644,8935,'he','×¢×œ×•×ª Avg',0),(321645,8935,'el','AVG ÎºÏŒÏƒÏ„Î¿Ï‚',0),(321646,8935,'zh','å¹³å‡æˆæœ¬\r\n',0),(321647,8935,'sv','AVG kostnad',0),(321648,8935,'it','Costo di AVG',0),(321649,8935,'tl','',0),(321650,8935,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;',0),(321651,8935,'hi','à¤”à¤¸à¤¤ à¤²à¤¾à¤—à¤¤',0),(321652,8935,'ms','Kos AVG',0),(321653,8935,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„ØªÙƒÙ„ÙØ©',0),(321654,8935,'fr','CoÃ»t de AVG',0),(321655,8935,'jp','å¹³å‡ã‚³ã‚¹ãƒˆ',0),(321656,8935,'pt','Custo do AVG',0),(321657,8935,'ru','Ð¡Ñ€ÐµÐ´Ð½Ð¸Ðµ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹',0),(321658,8935,'es','Costo Prom.',0),(321659,8935,'de','AVG-Kosten',0),(321660,8935,'en','Avg Cost',0),(321661,8936,'is','',0),(321662,8936,'dr','Ø®Ø·Ø§ÙŠ Ø§Ø¬Ø±Ø§ÙŠ Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ ',0),(321663,8936,'pr','Ø®Ø·Ø§ÙŠ Ø§Ø¬Ø±Ø§ÙŠ Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ ',0),(321664,8936,'tr','Sorgu yÃ¼rÃ¼tÃ¼lÃ¼rken hata oluÅŸtu ',0),(321665,8936,'pl','BÅ‚Ä…d podczas wykonywania kwerendy ',0),(321666,8936,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ° ',0),(321667,8936,'ur','Ù†Ø§ÙØ° ÛÙˆÙ†Û’ ÙˆØ§Ù„ÛŒ Ø·Ù„Ø¨ Ù†Ù‚Øµ ',0),(321668,8936,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ Ð¸Ð·Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐ° ÑƒÐ¿Ð¸Ñ‚Ð° ',0),(321669,8936,'vi','Truy váº¥n bá»‹ lá»—i',0),(321670,8936,'af','Fout uitvoering navraag ',0),(321671,8936,'ro','Eroare la executarea interogÄƒrii ',0),(321672,8936,'et','TÃµrge kÃ¤ivitamisel pÃ¤ring ',0),(321673,8936,'si','Napaka pri zagonu poizvedbe ',0),(321674,8936,'ba','Kesalahan yang mengeksekusi Query ',0),(321675,8936,'nl','Fout bij het uitvoeren van de Query ',0),(321676,8936,'fi','Virhe suoritettaessa kyselyÃ¤ ',0),(321677,8936,'no','Feil under utfÃ¸ring av spÃ¸rring ',0),(321678,8936,'da','Fejl udfÃ¸rer forespÃ¸rgslen ',0),(321679,8936,'ko','ì¿¼ë¦¬ ì‹¤í–‰ ì˜¤ë¥˜ ',0),(321680,8936,'he','×©×’×™××” ×‘×‘×™×¦×•×¢ ×©××™×œ×ª×”',0),(321681,8936,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎºÏ„Î­Î»ÎµÏƒÎ· Ï„Î¿Ï… ÎµÏÏ‰Ï„Î®Î¼Î±Ï„Î¿Ï‚ ',0),(321682,8936,'zh','é”™è¯¯æ‰§è¡ŒæŸ¥è¯¢\r\n',0),(321683,8936,'sv','Fel exekvera frÃ¥ga ',0),(321684,8936,'it','Errore durante l\'esecuzione di Query ',0),(321685,8936,'tl','',0),(321686,8936,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3626;&#3629;&#3610;&#3606;&#3634;&#3617;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3592;&#3634;&#3585;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(321687,8936,'hi','à¤•à¥à¤µà¥‡à¤°à¥€ à¤¨à¤¿à¤·à¥à¤ªà¤¾à¤¦à¤¿à¤¤ à¤¤à¥à¤°à¥à¤Ÿà¤¿ ',0),(321688,8936,'ms','Ralat yang melaksanakan pertanyaan ',0),(321689,8936,'ar','Ø®Ø·Ø£ ÙÙŠ ØªÙ†ÙÙŠØ° Ø§Ù„Ø¥Ø³ØªÙØ³Ø§Ø±',0),(321690,8936,'fr','Erreur d\'exÃ©cution de requÃªte ',0),(321691,8936,'jp','ã‚¯ã‚¨ãƒªã®å®Ÿè¡Œã‚¨ãƒ©ãƒ¼',0),(321692,8936,'pt','Erro ao executar consulta ',0),(321693,8936,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ð¸ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° ',0),(321694,8936,'es','Error Ejecutando la CotizaciÃ³n',0),(321695,8936,'de','Fehler beim AusfÃ¼hren der Abfrage ',0),(321696,8936,'en','Error Executing Query ',0),(321697,8937,'is','',0),(321698,8937,'dr','Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ ',0),(321699,8937,'pr','Ù„ÙŠØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ ',0),(321700,8937,'tr','Madde SatÄ±cÄ± listesi',0),(321701,8937,'pl','Lista dostawcÃ³w towaru',0),(321702,8937,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(321703,8937,'ur','Ø´Û’ ÙˆÛŒÙ†ÚˆØ± ÙÛØ±Ø³Øª',0),(321704,8937,'sr','Ð›Ð¸ÑÑ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(321705,8937,'vi','Danh sÃ¡ch ngÆ°á»i bÃ¡n hÃ ng',0),(321706,8937,'af','Item Verskaffer Lys',0),(321707,8937,'ro','Lista furnizori',0),(321708,8937,'et','Toote hankijate nimekiri',0),(321709,8937,'si','Seznam dobaviteljev artikla',0),(321710,8937,'ba','Daftar Vendor item',0),(321711,8937,'nl','Lijst van de leverancier van de objecten',0),(321712,8937,'fi','Toimittajan Nimikeluettelo',0),(321713,8937,'no','Elementlisten leverandÃ¸r',0),(321714,8937,'da','Vare Vendor List',0),(321715,8937,'ko','í•­ëª© ê³µê¸‰ ì—…ì²´ ëª©ë¡',0),(321716,8937,'he','×¨×©×™×ž×ª ×¡×¤×§×™ ×¤×¨×™×˜',0),(321717,8937,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½ ÎµÎ¹Î´ÏŽÎ½',0),(321718,8937,'zh','é¡¹ç›®ä¾›åº”å•†åå•\r\n',0),(321719,8937,'sv','Artikellista fÃ¶r leverantÃ¶r',0),(321720,8937,'it','Elenco di elementi di fornitore',0),(321721,8937,'tl','',0),(321722,8937,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(321723,8937,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥‚à¤šà¥€',0),(321724,8937,'ms','Senarai penjual barangan',0),(321725,8937,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ† Ù„Ù„ØµÙ†Ù',0),(321726,8937,'fr','Liste dâ€™Ã©lÃ©ments du vendeur',0),(321727,8937,'jp','é …ç›®ã®ãƒ™ãƒ³ãƒ€ãƒ¼ ãƒªã‚¹ãƒˆ',0),(321728,8937,'pt','Lista de fornecedores de itens',0),(321729,8937,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(321730,8937,'es','Lista de Proveedores de Item',0),(321731,8937,'de','Objekt-Anbieter-Liste',0),(321732,8937,'en','Item Vendor List',0),(321733,8938,'is','',0),(321734,8938,'dr','Mid Cost(Ù‡Ø²ÙŠÙ†Ù‡ Ù…ØªÙˆØ³Ø·)',0),(321735,8938,'pr','Mid Cost(Ù‡Ø²ÙŠÙ†Ù‡ Ù…ØªÙˆØ³Ø·)',0),(321736,8938,'tr','Orta maliyet',0),(321737,8938,'pl','Åšredni koszt',0),(321738,8938,'bg','Ð¡Ñ€ÐµÐ´Ð°Ñ‚Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(321739,8938,'ur','ÙˆØ³Ø· Ù„Ø§Ú¯Øª',0),(321740,8938,'sr','Ð¡Ñ€ÐµÐ´Ð¸Ð½Ð¾Ð¼ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(321741,8938,'vi','GiÃ¡ thÃ nh MID',0),(321742,8938,'af','Middel koste',0),(321743,8938,'ro','Mijlocul Cost',0),(321744,8938,'et','Keskmine kulu',0),(321745,8938,'si','Sredi stroÅ¡kov',0),(321746,8938,'ba','Biaya pertengahan',0),(321747,8938,'nl','Mid kosten',0),(321748,8938,'fi','PuolivÃ¤lissÃ¤ hinta',0),(321749,8938,'no','Midten av kostnader',0),(321750,8938,'da','Midten af omkostninger',0),(321751,8938,'ko','ì¤‘ê°„ ë¹„ìš©',0),(321752,8938,'he','×¢×œ×•×ª ×‘××ž×¦×¢',0),(321753,8938,'el','ÎœÎ­ÏƒÎ± Ï„Î¿Ï… ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(321754,8938,'zh','ä¸­é—´æˆæœ¬\r\n',0),(321755,8938,'sv','Mitten av kostnaden',0),(321756,8938,'it','Costo medio',0),(321757,8938,'tl','',0),(321758,8938,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3585;&#3621;&#3634;&#3591;',0),(321759,8938,'hi','à¤®à¤¿à¤¡ à¤²à¤¾à¤—à¤¤',0),(321760,8938,'ms','Kos pertengahan',0),(321761,8938,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„ØªÙƒÙ„ÙØ©',0),(321762,8938,'fr','CoÃ»t moyen',0),(321763,8938,'jp','åŠã°ã®ã‚³ã‚¹ãƒˆ',0),(321764,8938,'pt','Custo mÃ©dio',0),(321765,8938,'ru','Ð¡ÐµÑ€ÐµÐ´Ð¸Ð½Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(321766,8938,'es','Medio Costo',0),(321767,8938,'de','Mitte Kosten',0),(321768,8938,'en','Mid Cost',0),(321769,8939,'is','',0),(321770,8939,'dr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(321771,8939,'pr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(321772,8939,'tr','SatÄ±cÄ± aralÄ±ÄŸÄ±',0),(321773,8939,'pl','WybÃ³r dostawcy',0),(321774,8939,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(321775,8939,'ur','ÙˆÛŒÙ†ÚˆØ± Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(321776,8939,'sr','ÐžÐ¿ÑÐµÐ³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(321777,8939,'vi','Pháº¡m vi NgÆ°á»i bÃ¡n',0),(321778,8939,'af','Verskaffer Reeks',0),(321779,8939,'ro','Gama de furnizor',0),(321780,8939,'et','Hankija valikut',0),(321781,8939,'si','Prodajalec obseg',0),(321782,8939,'ba','Berbagai vendor',0),(321783,8939,'nl','Leverancier bereik',0),(321784,8939,'fi','Toimittajan alue',0),(321785,8939,'no','LeverandÃ¸ren utvalg',0),(321786,8939,'da','Forhandler sortiment',0),(321787,8939,'ko','ê³µê¸‰ ì—…ì²´ ë²”ìœ„',0),(321788,8939,'he','×˜×•×•×— ×”×¡×¤×§',0),(321789,8939,'el','Î•ÏÏÎ¿Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(321790,8939,'zh','ä¾›åº”å•†èŒƒå›´\r\n',0),(321791,8939,'sv','LeverantÃ¶rens utbud',0),(321792,8939,'it','Fascia fornitore',0),(321793,8939,'tl','',0),(321794,8939,'th','&#3594;&#3656;&#3623;&#3591;&#3586;&#3634;&#3618;',0),(321795,8939,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤°à¥‡à¤‚à¤œ',0),(321796,8939,'ms','Pelbagai vendor',0),(321797,8939,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ù…ÙˆØ±Ø¯',0),(321798,8939,'fr','Gamme du vendeur',0),(321799,8939,'jp','ä»•å…¥å…ˆç¯„å›²',0),(321800,8939,'pt','Gama de fornecedores',0),(321801,8939,'ru','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(321802,8939,'es','Rango de Proveedores',0),(321803,8939,'de','HÃ¤ndler Bereich',0),(321804,8939,'en','Vendor Range',0),(321805,8940,'is','',0),(321806,8940,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(321807,8940,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(321808,8940,'tr','Envanter madde tedarikÃ§ileri',0),(321809,8940,'pl','ZapasÃ³w towaru dostawcÃ³w',0),(321810,8940,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(321811,8940,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº',0),(321812,8940,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(321813,8940,'vi','NgÆ°á»i Cung Cáº¥p HÃ ng HÃ³a',0),(321814,8940,'af','Inventaris Item Verskaffers',0),(321815,8940,'ro','Furnizori de articol inventar',0),(321816,8940,'et','Laotoote tarnijad',0),(321817,8940,'si','Zaloge artikla prodajalci',0),(321818,8940,'ba','Persediaan barang vendor',0),(321819,8940,'nl','Inventaris Artikelleveranciers',0),(321820,8940,'fi','Varaston nimikkeen toimittajat',0),(321821,8940,'no','Lager vareleverandÃ¸rer',0),(321822,8940,'da','Lageret vareleverandÃ¸rer',0),(321823,8940,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ê³µê¸‰ ì—…ì²´',0),(321824,8940,'he','×¡×¤×§×™ ×¤×¨×™×˜ ×ž×œ××™',0),(321825,8940,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(321826,8940,'zh','åº“å­˜ç‰©å“ä¾›åº”å•†\r\n',0),(321827,8940,'sv','Inventering artikelfÃ¶rsÃ¤ljare',0),(321828,8940,'it','Fornitori di elemento di inventario',0),(321829,8940,'tl','',0),(321830,8940,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(321831,8940,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(321832,8940,'ms','Vendor Item inventori',0),(321833,8940,'ar','Ù…ÙˆØ±Ù‘Ø¯Ùˆ Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(321834,8940,'fr','Article lâ€™inventaire des fournisseurs',0),(321835,8940,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒª ã‚¢ã‚¤ãƒ†ãƒ  ãƒ™ãƒ³ãƒ€ãƒ¼',0),(321836,8940,'pt','Fornecedores de Item de inventÃ¡rio',0),(321837,8940,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿ÑƒÐ½ÐºÑ‚ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸',0),(321838,8940,'es','Proveedores de Items de Inventario',0),(321839,8940,'de','Inventar-Element-Anbieter',0),(321840,8940,'en','Inventory Item Vendors',0),(321841,8941,'is','',0),(321842,8941,'dr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ ØªØ®Ù…ÙŠÙ†ÙŠ',0),(321843,8941,'pr','ØªØ§Ø±ÙŠØ® Ø­Ù…Ù„ ØªØ®Ù…ÙŠÙ†ÙŠ',0),(321844,8941,'tr','Tahmini kargo tarihi',0),(321845,8941,'pl','Szacunkowe daty',0),(321846,8941,'bg','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð»Ð¾ ÐºÐ¾Ñ€Ð°Ð±Ð°',0),(321847,8941,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(321848,8941,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð±Ñ€Ð¾Ð´ Ð´Ð°Ñ‚ÑƒÐ¼',0),(321849,8941,'vi','Dá»± trÃ¹ ngÃ y váº­n chuyá»ƒn ',0),(321850,8941,'af','Geskatte Versende Datum',0),(321851,8941,'ro','Data estimatÄƒ navei',0),(321852,8941,'et','Hinnanguline tarnekuupÃ¤ev',0),(321853,8941,'si','Ocenjena ladja datum',0),(321854,8941,'ba','Tanggal perkiraan kapal',0),(321855,8941,'nl','Geschatte verzenddatum',0),(321856,8941,'fi','Arvioitu lÃ¤hetyspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(321857,8941,'no','Beregnet forsendelsesdato',0),(321858,8941,'da','AnslÃ¥ede afsendelsesdato',0),(321859,8941,'ko','ì˜ˆìƒëœ ë°°ì†¡ì¼',0),(321860,8941,'he','×ª××¨×™×š ×ž×©×œ×•×— ×ž×©×•×¢×¨',0),(321861,8941,'el','Î Î»Î¿Î¯Î¿ ÎµÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(321862,8941,'zh','é¢„è®¡äº¤è´§æ—¥æœŸ\r\n',0),(321863,8941,'sv','Uppskattat transportdatum',0),(321864,8941,'it','Data stimata di spedizione',0),(321865,8941,'tl','',0),(321866,8941,'th','&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3585;&#3634;&#3619;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(321867,8941,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤•à¥‡ à¤…à¤¨à¥à¤¸à¤¾à¤° à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(321868,8941,'ms','Tarikh anggaran kapal',0),(321869,8941,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù…Ù‚Ø¯Ø±Ø©',0),(321870,8941,'fr','Date d\'expÃ©dition estimÃ©e',0),(321871,8941,'jp','å‡ºè·äºˆå®šæ—¥',0),(321872,8941,'pt','Data de envio estimado',0),(321873,8941,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ð¾Ðµ ÑÑƒÐ´Ð½Ð¾ Ð”Ð°Ñ‚Ð°',0),(321874,8941,'es','Fecha Estimada de EnvÃ­o',0),(321875,8941,'de','Voraussichtliches Lieferdatum',0),(321876,8941,'en','Estimated Ship Date',0),(321877,8942,'is','',0),(321878,8942,'dr','ØªØ§Ø±ÙŠØ® ØµØ¯ÙˆØ±',0),(321879,8942,'pr','ØªØ§Ø±ÙŠØ® ØµØ¯ÙˆØ±',0),(321880,8942,'tr','YayÄ±mlanma tarihi',0),(321881,8942,'pl','Data wydania',0),(321882,8942,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ð´Ð°Ð²Ð°Ð½Ðµ',0),(321883,8942,'ur','Ù…Ø³Ø¦Ù„Û Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(321884,8942,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸Ð·Ð´Ð°Ð²Ð°ÑšÐ°',0),(321885,8942,'vi','NgÃ y phÃ¡t hÃ nh',0),(321886,8942,'af','Datum Uitgereik',0),(321887,8942,'ro','Data emiterii',0),(321888,8942,'et','VÃ¤ljalaskmisest alates',0),(321889,8942,'si','Datum izdaje',0),(321890,8942,'ba','Tanggal penerbitan',0),(321891,8942,'nl','Datum van uitgifte',0),(321892,8942,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(321893,8942,'no','Utstedelsesdatoen',0),(321894,8942,'da','Udstedelsesdato',0),(321895,8942,'ko','ë°œí–‰ ì¼ìž',0),(321896,8942,'he','×ª××¨×™×š ×”×”× ×¤×§×”',0),(321897,8942,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­ÎºÎ´Î¿ÏƒÎ·Ï‚',0),(321898,8942,'zh','å‘è¡Œæ—¥æœŸ\r\n',0),(321899,8942,'sv','Utgivningsdag',0),(321900,8942,'it','Data di emissione',0),(321901,8942,'tl','',0),(321902,8942,'th','&#3593;&#3610;&#3633;&#3610;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(321903,8942,'hi','à¤®à¥à¤¦à¥à¤¦à¤¾ à¤¤à¤¿à¤¥à¤¿',0),(321904,8942,'ms','Tarikh dikeluarkan',0),(321905,8942,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥ØµØ¯Ø§Ø±',0),(321906,8942,'fr','Date d\'Ã©mission',0),(321907,8942,'jp','ç™ºè¡Œæ—¥',0),(321908,8942,'pt','Data de emissÃ£o',0),(321909,8942,'ru','Ð”Ð°Ñ‚Ð° Ð²Ñ‹Ð¿ÑƒÑÐºÐ°',0),(321910,8942,'es','Fecha de EmisiÃ³n',0),(321911,8942,'de','Ausstellungsdatum',0),(321912,8942,'en','Issue Date',0),(321913,8943,'is','',0),(321914,8943,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯ÙŠÚ¯Ø±',0),(321915,8943,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯ÙŠÚ¯Ø±',0),(321916,8943,'tr','Bir tane daha ekleyin',0),(321917,8943,'pl','Dodaj kolejny',0),(321918,8943,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³',0),(321919,8943,'ur','Ø¯ÙˆØ³Ø±Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(321920,8943,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ñ€ÑƒÐ³Ð¾Ð³',0),(321921,8943,'vi','Äá»‹a Chá»‰ KhÃ¡c',0),(321922,8943,'af','Voeg \'n Ander By',0),(321923,8943,'ro','Adauga altul',0),(321924,8943,'et','Lisada teise',0),(321925,8943,'si','Dodaj drugo',0),(321926,8943,'ba','Tambah Lain',0),(321927,8943,'nl','Andere toevoegen',0),(321928,8943,'fi','LisÃ¤Ã¤ toinen',0),(321929,8943,'no','Legge til en annen',0),(321930,8943,'da','TilfÃ¸je en anden',0),(321931,8943,'ko','ë‹¤ë¥¸ ì¶”ê°€',0),(321932,8943,'he','×”×•×¡×£ ×¢×•×“',0),(321933,8943,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î¬Î»Î»Î·',0),(321934,8943,'zh','å¢žåŠ å¦ä¸€ä¸ª\r\n',0),(321935,8943,'sv','LÃ¤gga till en annan',0),(321936,8943,'it','Aggiungere un altro',0),(321937,8943,'tl','',0),(321938,8943,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3629;&#3639;&#3656;&#3609;&#3654;',0),(321939,8943,'hi','à¤à¤• à¤”à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(321940,8943,'ms','Tambah satu lagi',0),(321941,8943,'ar','Ø¥Ø¶Ø§ÙØ© Ø¢Ø®Ø±',0),(321942,8943,'fr','Ajouter un Autre',0),(321943,8943,'jp','ã‚‚ã† 1 ã¤è¿½åŠ ã—ã¾ã™ã€‚',0),(321944,8943,'pt','Adicionar outro',0),(321945,8943,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð”Ñ€ÑƒÐ³Ð¾Ð¹',0),(321946,8943,'es','Agregar Otro',0),(321947,8943,'de','FÃ¼ge noch einen',0),(321948,8943,'en','Add Another',0),(321949,8944,'is','',0),(321950,8944,'dr','1',0),(321951,8944,'pr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù…Ø¬Ø§Ø²   1',0),(321952,8944,'tr','Komisyonsuz Ajan 1',0),(321953,8944,'pl','Prowizji agenta 1',0),(321954,8944,'bg','Commissionable Ð°Ð³ÐµÐ½Ñ‚ 1',0),(321955,8944,'ur','Ú©ÙˆÙ…Ø§Ø³Ø´Ù†Ø¨Ù„ÛŒ Ø§ÛŒØ¬Ù†Ù¹ 1',0),(321956,8944,'sr','Ð¦Ð¾Ð¼Ð¼Ð¸ÑÑÐ¸Ð¾Ð½Ð°Ð±Ð»Ðµ ÐÐ³ÐµÐ½Ñ‚ 1',0),(321957,8944,'vi','Äáº¡i lÃ½ Äƒn hoa há»“ng 1',0),(321958,8944,'af','Kommissie-verdienbare Agent 1',0),(321959,8944,'ro','Commissionable Agent 1',0),(321960,8944,'et','Commissionable esindaja 1',0),(321961,8944,'si','Commissionable Agent 1',0),(321962,8944,'ba','Commissionable agen 1',0),(321963,8944,'nl','Geheven Agent 1',0),(321964,8944,'fi','Palkkioon agentti 1',0),(321965,8944,'no','Provisjon Agent 1',0),(321966,8944,'da','Commissionable Agent 1',0),(321967,8944,'ko','í˜„ê¸ˆí™” ì—ì´ì „íŠ¸ 1',0),(321968,8944,'he','×”×¡×•×›×Ÿ commissionable 1',0),(321969,8944,'el','Commissionable Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î±Ï‚ 1',0),(321970,8944,'zh','ä½£é‡‘ä»£ç†1\r\n',0),(321971,8944,'sv','Provisionsbaserad Agent 1',0),(321972,8944,'it','Agente commissionabili 1',0),(321973,8944,'tl','',0),(321974,8944,'th','&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609; 1',0),(321975,8944,'hi','Commissionable à¤à¤œà¥‡à¤‚à¤Ÿ 1',0),(321976,8944,'ms','Komisen ejen 1',0),(321977,8944,'ar','ÙˆÙƒÙŠÙ„ Ø§Ù„Ø£Ø³ÙØ§Ø± 1',0),(321978,8944,'fr','Commissionable Agent 1',0),(321979,8944,'jp','ã‚³ãƒŸãƒƒã‚·ãƒ§ãƒ³ã®ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆ 1',0),(321980,8944,'pt','Agente comissionado 1',0),(321981,8944,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¾Ð½Ð½Ñ‹Ðµ Ð°Ð³ÐµÐ½Ñ‚Ð° 1',0),(321982,8944,'es','Comisionable Agente 1',0),(321983,8944,'de','Provisionspflichtig Agent 1',0),(321984,8944,'en','Commissionable Agent 1',0),(321985,8945,'is','',0),(321986,8945,'dr','2',0),(321987,8945,'pr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù…Ø¬Ø§Ø²  2',0),(321988,8945,'tr','Komisyonsuz Ajan 2',0),(321989,8945,'pl','Prowizji agenta 2',0),(321990,8945,'bg','Commissionable Ð°Ð³ÐµÐ½Ñ‚ 2',0),(321991,8945,'ur','Ú©ÙˆÙ…Ø§Ø³Ø´Ù†Ø¨Ù„ÛŒ Ø§ÛŒØ¬Ù†Ù¹ 2',0),(321992,8945,'sr','Ð¦Ð¾Ð¼Ð¼Ð¸ÑÑÐ¸Ð¾Ð½Ð°Ð±Ð»Ðµ ÐÐ³ÐµÐ½Ñ‚ 2',0),(321993,8945,'vi','Äáº¡i lÃ½ Äƒn hoa há»“ng 2',0),(321994,8945,'af','Kommissie-verdienbare Agent 1',0),(321995,8945,'ro','Commissionable Agent 2',0),(321996,8945,'et','Commissionable Agent 2',0),(321997,8945,'si','Commissionable Agent 2',0),(321998,8945,'ba','Commissionable agen 2',0),(321999,8945,'nl','Geheven Agent 2',0),(322000,8945,'fi','Palkkioon agentti 2',0),(322001,8945,'no','Provisjon Agent 2',0),(322002,8945,'da','Commissionable Agent 2',0),(322003,8945,'ko','í˜„ê¸ˆí™” ì—ì´ì „íŠ¸ 2',0),(322004,8945,'he','×”×¡×•×›×Ÿ commissionable 2',0),(322005,8945,'el','Commissionable Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î±Ï‚ 2',0),(322006,8945,'zh','ä½£é‡‘ä»£ç†2\r\n',0),(322007,8945,'sv','Provisionsbaserad Agent 2',0),(322008,8945,'it','Agente commissionabili 2',0),(322009,8945,'tl','',0),(322010,8945,'th','&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609; 2',0),(322011,8945,'hi','Commissionable à¤à¤œà¥‡à¤‚à¤Ÿ 2',0),(322012,8945,'ms','Komisen agen 2',0),(322013,8945,'ar','ÙˆÙƒÙŠÙ„ Ø§Ù„Ø£Ø³ÙØ§Ø± 2',0),(322014,8945,'fr','Agent commissionable 2',0),(322015,8945,'jp','ã‚³ãƒŸãƒƒã‚·ãƒ§ãƒ³ã®ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆ 2',0),(322016,8945,'pt','Comissionadas agente 2',0),(322017,8945,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¾Ð½Ð½Ñ‹Ðµ Ð°Ð³ÐµÐ½Ñ‚ 2',0),(322018,8945,'es','Comisionable Agente 2',0),(322019,8945,'de','Provisionspflichtig Agent 2',0),(322020,8945,'en','Commissionable Agent 2',0),(322021,8946,'is','',0),(322022,8946,'dr','Ù†Ø§Ù… Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù¾ÙŠØ´ ÙØ±Ø¶',0),(322023,8946,'pr','Ù†Ø§Ù… Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù¾ÙŠØ´ ÙØ±Ø¶',0),(322024,8946,'tr','VarsayÄ±lan AracÄ±sÄ± adÄ±',0),(322025,8946,'pl','Nazwa agenta',0),(322026,8946,'bg','Ð˜Ð¼ÐµÑ‚Ð¾ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð°Ð³ÐµÐ½Ñ‚',0),(322027,8946,'ur','Ø·Û’ Ø´Ø¯Û Ø§ÛŒØ¬Ù†Ù¹ Ú©Ø§ Ù†Ø§Ù…',0),(322028,8946,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾ Ð¸Ð¼Ðµ Ð·Ð° Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(322029,8946,'vi','TÃªn Äáº¡i lÃ½ máº·c Ä‘á»‹nh',0),(322030,8946,'af','Verstekte Agent Naam',0),(322031,8946,'ro','Numele implicit de Agent',0),(322032,8946,'et','Agent vaikenimi',0),(322033,8946,'si','Agent privzeti ime',0),(322034,8946,'ba','Nama agen default',0),(322035,8946,'nl','Standaardnaam Agent',0),(322036,8946,'fi','Agentti oletusnimi',0),(322037,8946,'no','Agent standardnavnet',0),(322038,8946,'da','Standardnavnet Agent',0),(322039,8946,'ko','ê¸°ë³¸ ì—ì´ì „íŠ¸ ì´ë¦„',0),(322040,8946,'he','×©× ×¡×•×›×Ÿ ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(322041,8946,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¬ÎºÏ„Î¿ÏÎ±',0),(322042,8946,'zh','é»˜è®¤ä»£ç†åç§°\r\n',0),(322043,8946,'sv','Agent standardnamnet',0),(322044,8946,'it','Nome agente predefinito',0),(322045,8946,'tl','',0),(322046,8946,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3594;&#3639;&#3656;&#3629;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;',0),(322047,8946,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤à¤œà¥‡à¤‚à¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(322048,8946,'ms','Nama ejen lalai',0),(322049,8946,'ar','Ø§Ø³Ù… Ø§Ù„ÙˆÙƒÙŠÙ„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(322050,8946,'fr','Nom de l\'Agent par dÃ©faut',0),(322051,8946,'jp','æ—¢å®šã®ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã®åå‰',0),(322052,8946,'pt','Nome do agente de padrÃ£o',0),(322053,8946,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¸Ð¼Ñ Ð°Ð³ÐµÐ½Ñ‚Ð°',0),(322054,8946,'es','Nombre de Agente Predeterminado',0),(322055,8946,'de','Standardnamen Agent',0),(322056,8946,'en','Default Agent Name',0),(322057,8947,'is','',0),(322058,8947,'dr','Ø´Ø±Ø­ Ø¨Ø±Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(322059,8947,'pr','Ø´Ø±Ø­ Ø¨Ø±Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(322060,8947,'tr','Fatura AÃ§Ä±klamasÄ±',0),(322061,8947,'pl','Opis dla pÅ‚atnoÅ›ci',0),(322062,8947,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(322063,8947,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’ ØªØµØ±ÛŒØ­',0),(322064,8947,'sr','ÐžÐ¿Ð¸Ñ Ð·Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ñƒ',0),(322065,8947,'vi','Diá»ƒn Giáº£i cho hÃ³a Ä‘Æ¡n',0),(322066,8947,'af','Beskrywing vir Verekening',0),(322067,8947,'ro','Descriere pentru facturare',0),(322068,8947,'et','Kirjeldus arveldamine',0),(322069,8947,'si','Opis za zaraÄunavanje',0),(322070,8947,'ba','Deskripsi untuk penagihan',0),(322071,8947,'nl','Beschrijving voor facturering',0),(322072,8947,'fi','Kuvaus laskutus',0),(322073,8947,'no','Beskrivelse for fakturering',0),(322074,8947,'da','Beskrivelse for Billing',0),(322075,8947,'ko','ê²°ì œì— ëŒ€ í•œ ì„¤ëª…',0),(322076,8947,'he','×ª×™××•×¨ ×¢×‘×•×¨ ×—×™×•×‘',0),(322077,8947,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î³Î¹Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(322078,8947,'zh','è¯´æ˜Žå¸å•\r\n',0),(322079,8947,'sv','Beskrivning fÃ¶r fakturering',0),(322080,8947,'it','Descrizione per la fatturazione',0),(322081,8947,'tl','',0),(322082,8947,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3585;&#3634;&#3619;&#3623;&#3634;&#3591;&#3610;&#3636;&#3621;',0),(322083,8947,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤µà¤°à¤£',0),(322084,8947,'ms','Keterangan bagi bil',0),(322085,8947,'ar','ÙˆØµÙ Ù„Ù„ÙÙˆØ§ØªÙŠØ±',0),(322086,8947,'fr','Description pour la facturation',0),(322087,8947,'jp','è«‹æ±‚æ›¸ã®èª¬æ˜Ž',0),(322088,8947,'pt','DescriÃ§Ã£o para o faturamento',0),(322089,8947,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð´Ð»Ñ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(322090,8947,'es','DescripciÃ³n para FacturaciÃ³n',0),(322091,8947,'de','Beschreibung fÃ¼r die Abrechnung',0),(322092,8947,'en','Description for Billing',0),(322093,8948,'is','',0),(322094,8948,'dr','( Ù‚Ø·Ø¹ÙŠ',0),(322095,8948,'pr','Ù…Ø±Ø§Ø­Ù„ Ø«Ø§Ø¨Øª Ø´Ø¯Ù‡ ( Ù‚Ø·Ø¹ÙŠ',0),(322096,8948,'tr','Sabit aÅŸamalarÄ±',0),(322097,8948,'pl','StaÅ‚e etapy',0),(322098,8948,'bg','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ð° ÐµÑ‚Ð°Ð¿Ð¸',0),(322099,8948,'ur','Ù…Ù‚Ø±Ø±Û Ù…Ø±Ø§Ø­Ù„',0),(322100,8948,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð¾ Ñ„Ð°Ð·Ðµ',0),(322101,8948,'vi','CÃ¡c bÆ°á»›c cá»‘ Ä‘á»‹nh',0),(322102,8948,'af','Vaste stadiums',0),(322103,8948,'ro','Fazele fixe',0),(322104,8948,'et','Fikseeritud etappe',0),(322105,8948,'si','Osnovnih fazah',0),(322106,8948,'ba','Tetap tahap',0),(322107,8948,'nl','Vaste fasen',0),(322108,8948,'fi','KiinteÃ¤ vaiheet',0),(322109,8948,'no','Fast stadier',0),(322110,8948,'da','Faste stadier',0),(322111,8948,'ko','ì¡°ì •ëœ ë‹¨ê³„',0),(322112,8948,'he','×©×œ×‘×™× ×§×‘×•×¢×™×',0),(322113,8948,'el','Î£Ï„Î±Î¸ÎµÏÏŒ ÏƒÏ„Î¬Î´Î¹Î±',0),(322114,8948,'zh','å›ºå®šé˜¶æ®µ\r\n',0),(322115,8948,'sv','Fasta faser',0),(322116,8948,'it','Fasi fisse',0),(322117,8948,'tl','',0),(322118,8948,'th','&#3619;&#3632;&#3618;&#3632;&#3588;&#3591;&#3607;&#3637;&#3656;',0),(322119,8948,'hi','à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤šà¤°à¤£à¥‹à¤‚',0),(322120,8948,'ms','Berperingkat-peringkat tetap',0),(322121,8948,'ar','Ù…Ø±Ø§Ø­Ù„ Ø«Ø§Ø¨ØªØ©',0),(322122,8948,'fr','Ã‰tapes fixes',0),(322123,8948,'jp','å›ºå®šæ®µéšŽ',0),(322124,8948,'pt','EstÃ¡gios fixos',0),(322125,8948,'ru','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÑÑ‚Ð°Ð¿Ñ‹',0),(322126,8948,'es','Etapas Fijas',0),(322127,8948,'de','Festen Phasen',0),(322128,8948,'en','Fixed Stages',0),(322129,8949,'is','',0),(322130,8949,'dr','Ø¯Ø±ØµØ¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(322131,8949,'pr','Ø¯Ø±ØµØ¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(322132,8949,'tr','SÃ¶zleÅŸme yÃ¼zde',0),(322133,8949,'pl','Procent umowy',0),(322134,8949,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° Ð½Ð° Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(322135,8949,'ur','Ù…Ø¹Ø§ÛØ¯Û’ Ú©Ø§ ÙÛŒØµØ¯',0),(322136,8949,'sr','ÐŸÐ¾ÑÑ‚Ð¾ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð° Ð¾',0),(322137,8949,'vi','% cá»§a há»£p Ä‘á»“ng',0),(322138,8949,'af','Persent van kontrak',0),(322139,8949,'ro','La sutÄƒ din Contract',0),(322140,8949,'et','Lepingu protsenti',0),(322141,8949,'si','Odstotkov pogodb',0),(322142,8949,'ba','Persen dari kontrak',0),(322143,8949,'nl','Procent van Contract',0),(322144,8949,'fi','Prosenttia sopimuksen',0),(322145,8949,'no','Prosent av kontrakt',0),(322146,8949,'da','Procent af kontrakt',0),(322147,8949,'ko','ê³„ì•½ì˜ %',0),(322148,8949,'he','××—×•×– ×©×œ ×—×•×–×”',0),(322149,8949,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï„Î·Ï‚ ÏƒÏÎ¼Î²Î±ÏƒÎ·Ï‚',0),(322150,8949,'zh','åˆåŒç™¾åˆ†æ¯”\r\n',0),(322151,8949,'sv','Procent av kontrakt',0),(322152,8949,'it','Per cento del contratto',0),(322153,8949,'tl','',0),(322154,8949,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3586;&#3629;&#3591;&#3626;&#3633;&#3597;&#3597;&#3634;',0),(322155,8949,'hi','à¤…à¤¨à¥à¤¬à¤‚à¤§ à¤•à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(322156,8949,'ms','Peratus daripada kontrak',0),(322157,8949,'ar','Ø¨Ø§Ù„Ù…Ø¦Ø© Ù…Ù† Ø§Ù„Ø¹Ù‚ÙˆØ¯',0),(322158,8949,'fr','Pour cent du contrat',0),(322159,8949,'jp','å¥‘ç´„ã®ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ',0),(322160,8949,'pt','Por cento do contrato',0),(322161,8949,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð² Ð¾Ñ‚ ÐºÐ¾Ð½Ñ‚Ñ€Ð°ÐºÑ‚Ð°',0),(322162,8949,'es','Porciento de Contrato',0),(322163,8949,'de','Prozent der Vertrag',0),(322164,8949,'en','Percent of Contract',0),(322165,8950,'is','',0),(322166,8950,'dr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯ÙˆØ±Ù‡ Ø§ÙŠ Ø¨Ø§ Ø·ÙˆÙ„ Ù…Ø¯Øª Ù¾Ø±ÙˆÚ˜Ù‡ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯ ',0),(322167,8950,'pr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯ÙˆØ±Ù‡ Ø§ÙŠ Ø¨Ø§ Ø·ÙˆÙ„ Ù…Ø¯Øª Ù¾Ø±ÙˆÚ˜Ù‡ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯ ',0),(322168,8950,'tr','DÃ¼zenli fatura projesi uzunluÄŸuyla belirlenir',0),(322169,8950,'pl','Okresowe pÅ‚atnoÅ›ci okreÅ›lana dÅ‚ugoÅ›Ä‡ projektu',0),(322170,8950,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ, Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(322171,8950,'ur','Ù…Ø¹ÛŒØ§Ø¯ÛŒ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾Ø±Ø§Ø¬ÛŒÚ©Ù¹ Ú©ÛŒ Ù„Ù…Ø¨Ø§Ø¦ÛŒ Ú©Ø§ Ø¹Ø²Ù…',0),(322172,8950,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¾Ð´Ñ€ÐµÑ’ÑƒÑ˜Ðµ Ð´ÑƒÐ¶Ð¸Ð½Ñƒ Ð¾Ð´ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(322173,8950,'vi','HÃ³a Ä‘Æ¡n theo tiáº¿n trÃ¬nh phá»¥ thuá»™c vÃ o thá»i gian dá»± Ã¡n',0),(322174,8950,'af','Periodieke Fakturering Bepaal deur die Lengte van Projek',0),(322175,8950,'ro','Facturare periodicÄƒ determinatÄƒ de lungimea de proiect',0),(322176,8950,'et','Perioodiliste arvete mÃ¤Ã¤rab projekti pikkus',0),(322177,8950,'si','PeriodiÄni obraÄun doloÄi trajanje projekta',0),(322178,8950,'ba','Penagihan periodik yang ditentukan oleh panjang proyek',0),(322179,8950,'nl','Periodieke facturering bepaald door lengte van Project',0),(322180,8950,'fi','MÃ¤Ã¤rÃ¤ajoin laskutus mÃ¤Ã¤rÃ¤ytyy projektin pituutta',0),(322181,8950,'no','Periodiske fakturering bestemmes av lengden pÃ¥ prosjektet',0),(322182,8950,'da','Periodiske fakturering bestemmes af lÃ¦ngden af projekt',0),(322183,8950,'ko','ì •ê¸° ê²°ì œ í”„ë¡œì íŠ¸ì˜ ê¸¸ì´ ì˜í•´ ê²°ì •',0),(322184,8950,'he','×—×™×•×‘ ×ª×§×•×¤×ª×™ × ×§×‘×¢ ×¢×œ ×™×“×™ ××•×¨×š ×”×¤×¨×•×™×™×§×˜',0),(322185,8950,'el','Î ÎµÏÎ¹Î¿Î´Î¹ÎºÎ® Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚ Ï€Î¿Ï… ÎºÎ±Î¸Î¿ÏÎ¯Î¶ÎµÏ„Î±Î¹ Î±Ï€ÏŒ Ï„Î¿ Î¼Î®ÎºÎ¿Ï‚ Ï„Î¿Ï… Î­ÏÎ³Î¿Ï…',0),(322186,8950,'zh','ç»“ç®—å‘¨æœŸç”±å·¥ç¨‹é•¿åº¦ç¡®å®š\r\n',0),(322187,8950,'sv','Periodisk fakturering bestÃ¤ms av lÃ¤ngden av projektet',0),(322188,8950,'it','Fatturazione periodica determinata dalla lunghezza del progetto',0),(322189,8950,'tl','',0),(322190,8950,'th','Periodic Billing Determined by Length of Project',0),(322191,8950,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥€ à¤²à¤®à¥à¤¬à¤¾à¤ˆ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤¿à¤¤',0),(322192,8950,'ms','Bil berkala yang ditentukan oleh panjang projek',0),(322193,8950,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø¯ÙˆØ±ÙŠØ© ÙŠØ­Ø¯Ø¯Ù‡Ø§ Ø·ÙˆÙ„ ÙØªØ±Ø© Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(322194,8950,'fr','Facturation pÃ©riodique dÃ©terminÃ©e par la longueur du projet',0),(322195,8950,'jp','å®šæœŸè«‹æ±‚ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®é•·ã•ã«ã‚ˆã£ã¦æ±ºå®šã•ã‚Œã¾ã™ã€‚',0),(322196,8950,'pt','FacturaÃ§Ã£o periÃ³dica determinada pelo comprimento do projeto',0),(322197,8950,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡ÐµÑÐºÐ¾Ð³Ð¾ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³Ð°, Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÑÐµÑ‚ÑÑ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚ÑŒ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(322198,8950,'es','FacturaciÃ³n PeriÃ³dica se Determina por Tiempo de Proyecto',0),(322199,8950,'de','Periodische Fakturierung durch LÃ¤nge des Projekts bestimmt',0),(322200,8950,'en','Periodic Billing Determined by Length of Project',0),(322201,8951,'is','',0),(322202,8951,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(322203,8951,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(322204,8951,'tr','Proje tÃ¼rÃ¼ DÃ¼zenle',0),(322205,8951,'pl','Edytuj typ projektu',0),(322206,8951,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚ Ñ‚Ð¸Ð¿ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(322207,8951,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ Ù‚Ø³Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(322208,8951,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ‚Ð¸Ð¿ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(322209,8951,'vi','Sá»­a Loáº¡i Dá»± Ãn',0),(322210,8951,'af','Projek Tipe Redigeer',0),(322211,8951,'ro','Editare de tip proiect',0),(322212,8951,'et','Projekti tÃ¼Ã¼p Edit',0),(322213,8951,'si','Projekt tipa Uredi',0),(322214,8951,'ba','Edit jenis proyek',0),(322215,8951,'nl','Project Type bewerken',0),(322216,8951,'fi','Projektin tyyppi muokkaus',0),(322217,8951,'no','Prosjektet Type Rediger',0),(322218,8951,'da','Projekt Type Rediger',0),(322219,8951,'ko','í”„ë¡œì íŠ¸ í˜•ì‹ íŽ¸ì§‘',0),(322220,8951,'he','×¢×¨×•×š ×¡×•×’ ×”×¤×¨×•×™×™×§×˜',0),(322221,8951,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï… Î­ÏÎ³Î¿Ï…',0),(322222,8951,'zh','é¡¹ç›®ç±»åž‹ç¼–è¾‘\r\n',0),(322223,8951,'sv','Projektet typ redigera',0),(322224,8951,'it','Progetto tipo modifica',0),(322225,8951,'tl','',0),(322226,8951,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(322227,8951,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(322228,8951,'ms','Edit jenis projek',0),(322229,8951,'ar','ØªØ­Ø±ÙŠØ± Ù†ÙˆØ¹ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(322230,8951,'fr','Projet Type Edit',0),(322231,8951,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®ç¨®é¡žã®ç·¨é›†',0),(322232,8951,'pt','Projeto tipo editar',0),(322233,8951,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(322234,8951,'es','Tipo de Proyecto Editar',0),(322235,8951,'de','Projekt Typ bearbeiten',0),(322236,8951,'en','Project Type Edit',0),(322237,8952,'is','',0),(322238,8952,'dr','Ù†Ø§Ù… Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(322239,8952,'pr','Ù†Ø§Ù… Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(322240,8952,'tr','Proje tÃ¼rÃ¼ adÄ±',0),(322241,8952,'pl','Nazwa typ projektu',0),(322242,8952,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ',0),(322243,8952,'ur','Ù†Ø§Ù… Ù¾Ø±ÙˆØ¬ÛŒÚ©Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(322244,8952,'sr','Ð£Ð¿Ð¸ÑˆÐ¸Ñ‚Ðµ Ð¸Ð¼Ðµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(322245,8952,'vi','TÃªn loáº¡i Dá»± Ã¡n',0),(322246,8952,'af','Projek Tipe Naam',0),(322247,8952,'ro','Nume de tip proiect',0),(322248,8952,'et','Projekti nimi',0),(322249,8952,'si','Ime vrste projekta',0),(322250,8952,'ba','Nama jenis proyek',0),(322251,8952,'nl','Project typenaam',0),(322252,8952,'fi','Projektityypin nimi',0),(322253,8952,'no','Navn',0),(322254,8952,'da','Projektnavn',0),(322255,8952,'ko','í”„ë¡œì íŠ¸ í˜•ì‹ ì´ë¦„',0),(322256,8952,'he','×©× ×¡×•×’ ×©×œ ×¤×¨×•×™×™×§×˜',0),(322257,8952,'el','ÎŒÎ½Î¿Î¼Î± Ï„ÏÏ€Î¿Ï… Î­ÏÎ³Î¿Ï…',0),(322258,8952,'zh','é¡¹ç›®ç±»åž‹åç§°\r\n',0),(322259,8952,'sv','Namn pÃ¥',0),(322260,8952,'it','Nome del tipo di progetto',0),(322261,8952,'tl','',0),(322262,8952,'th','&#3594;&#3639;&#3656;&#3629;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(322263,8952,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾ à¤¨à¤¾à¤®',0),(322264,8952,'ms','Nama jenis projek',0),(322265,8952,'ar','Ø§Ø³Ù… Ù†ÙˆØ¹ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(322266,8952,'fr','Nom du Type de projet',0),(322267,8952,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®ç¨®é¡žå',0),(322268,8952,'pt','Nome do tipo de projeto',0),(322269,8952,'ru','Ð˜Ð¼Ñ Ñ‚Ð¸Ð¿Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(322270,8952,'es','Nombre de Tipo de Proyecto',0),(322271,8952,'de','Typ Projektnamen',0),(322272,8952,'en','Project Type Name',0),(322273,8953,'is','',0),(322274,8953,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(322275,8953,'pr','Ø§ÙŠÙ…ÙŠÙ„ ØªÙ‡ Ú†Ùƒ Ù‡Ø§ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ (Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(322276,8953,'tr','E-posta doÄŸrudan yatÄ±rma taslaklarÄ±',0),(322277,8953,'pl','E-mail kierowaÄ‡ zastaw Kategoria:',0),(322278,8953,'bg','ÐœÑŠÐ½Ð¸Ñ‡ÐµÑ‚Ð°, ÑÐ²ÑŠÑ€Ð·Ð°Ð½Ð¸ Ñ Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð»',0),(322279,8953,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ú©Ø¦',0),(322280,8953,'sr','Ð•Ð¼Ð°Ð¸Ð» Ð¾Ð´ÑÐµÑ‡Ñ†Ð¸Ð¼Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(322281,8953,'vi','Email thanh toÃ¡n trá»±c tiáº¿p',0),(322282,8953,'af','E-pos Direkte Deposito Teenblaadjie',0),(322283,8953,'ro','Cioturi legate Direct de depozit de e-mail',0),(322284,8953,'et','E-posti otsene hoiuste Kategooriad:',0),(322285,8953,'si','Email neposredno depozit Å¡krbin',0),(322286,8953,'ba','Rintisan bertopik Deposit langsung email',0),(322287,8953,'nl','E-mail directe storting Stubs',0),(322288,8953,'fi','SÃ¤hkÃ¶posti suoraan tallettaa Luokka:',0),(322289,8953,'no','E-post direkte innskudd stubber',0),(322290,8953,'da','E-mail direkte indbetaling stubbe',0),(322291,8953,'ko','ì´ë©”ì¼ ì´ì²´ ëª…ì„¸ì„œ',0),(322292,8953,'he','×“×•× ×œ ×”×¤×§×“×” ×™×©×™×¨×” ×”×¡×¤×—×™×',0),(322293,8953,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÏ€Î­ÎºÏ„Î±ÏƒÎ· Ï„Î¿Ï… Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(322294,8953,'zh','ç”µå­é‚®ä»¶ç›´æŽ¥å­˜æ¬¾å­˜æ ¹\r\n',0),(322295,8953,'sv','E-post direkt insÃ¤ttning-stubbar',0),(322296,8953,'it','Stub deposito diretto e-mail',0),(322297,8953,'tl','',0),(322298,8953,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3649;&#3592;&#3657;&#3591;&#3605;&#3633;&#3604;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(322299,8953,'hi','à¤ˆà¤®à¥‡à¤² à¤¸à¥€à¤§à¥‡ à¤œà¤®à¤¾ Stubs',0),(322300,8953,'ms','Tunas Deposit terus e-mel',0),(322301,8953,'ar','Ø¨Ø°Ø±Ø© Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(322302,8953,'fr','Talons de dÃ©pÃ´t Direct e-mail',0),(322303,8953,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«ã®ç›´æŽ¥é é‡‘ã‚’é–¢é€£ã®ã‚¹ã‚¿ãƒ–é …ç›®',0),(322304,8953,'pt','EsboÃ§os sobre depÃ³sito direto de e-mail',0),(322305,8953,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ð¾ Ð°Ð»Ñ„Ð°Ð²Ð¸Ñ‚Ñƒ',0),(322306,8953,'es','Email Talones de de DepÃ³sitos Directos',0),(322307,8953,'de','E-Mail direkte Ablagerung Stubs',0),(322308,8953,'en','Email Direct Deposit Stubs',0),(322309,8954,'is','',0),(322310,8954,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(322311,8954,'pr','Ù†ØªÙŠØ¬Ù‡ Ø§ÙŠÙ…ÙŠÙ„ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(322312,8954,'tr','DoÄŸrudan yatÄ±rma e-posta sonuÃ§',0),(322313,8954,'pl','BezpoÅ›redni depozyt E-mail wynik',0),(322314,8954,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¸Ð¼ÐµÐ¹Ð» Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚',0),(322315,8954,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ú©Û’ Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ù†ØªÛŒØ¬Û’',0),(322316,8954,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð•Ð¼Ð°Ð¸Ð» Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚',0),(322317,8954,'vi','Káº¿t quáº£ Email thanh toÃ¡n trá»±c tiáº¿p ',0),(322318,8954,'af','Direkte Deposito E-pos Resultate',0),(322319,8954,'ro','Rezultatul de E-mail direct de depozit',0),(322320,8954,'et','Panga Ã¼lekanne Email tulemus',0),(322321,8954,'si','Neposredni polog Email rezultat',0),(322322,8954,'ba','Deposit langsung Email hasil',0),(322323,8954,'nl','Directe storting E-mail resultaat',0),(322324,8954,'fi','Suora talletus Email tulos',0),(322325,8954,'no','Direkte innskudd Email resultat',0),(322326,8954,'da','Direkte depositum E-mail resultat',0),(322327,8954,'ko','ì§ì ‘ ìž…ê¸ˆ ì´ë©”ì¼ ê²°ê³¼',0),(322328,8954,'he','×”×¤×§×“×” ×™×©×™×¨×” ×“×•× ×œ ×ª×•×¦××”',0),(322329,8954,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Email Î±Ï€Î¿Ï„Î­Î»ÎµÏƒÎ¼Î±',0),(322330,8954,'zh','ç›´æŽ¥å­˜æ¬¾ç”µé‚®ç»“æžœ\r\n',0),(322331,8954,'sv','Direkt insÃ¤ttning e-resultat',0),(322332,8954,'it','Deposito diretto risultato di Email',0),(322333,8954,'tl','',0),(322334,8954,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3612;&#3621;&#3621;&#3633;&#3614;&#3608;&#3660;&#3585;&#3634;&#3619;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(322335,8954,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤ˆà¤®à¥‡à¤² à¤ªà¤°à¤¿à¤£à¤¾à¤®',0),(322336,8954,'ms','Deposit terus e-mel hasil',0),(322337,8954,'ar','Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù†ØªÙŠØ¬Ø©',0),(322338,8954,'fr','DÃ©pÃ´t direct E-mail rÃ©sultat',0),(322339,8954,'jp','ç›´æŽ¥é é‡‘ãƒ¡ãƒ¼ãƒ«çµæžœ',0),(322340,8954,'pt','DepÃ³sito direto E-mail resultado',0),(322341,8954,'ru','Ð ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(322342,8954,'es','Resultado de Email de DepÃ³sito Directo',0),(322343,8954,'de','Direkte Ablagerung Email Ergebnis',0),(322344,8954,'en','Direct Deposit Email Result',0),(322345,8955,'is','',0),(322346,8955,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(322347,8955,'pr','Ø§ÙŠÙ…ÙŠÙ„ ØªØ°ÙƒØ±Ø§Øª Ø³Ù¾Ø±Ø¯Ù‡ (Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(322348,8955,'tr','E-posta doÄŸrudan yatÄ±rma bildirimleri',0),(322349,8955,'pl','BezpoÅ›redniego zÅ‚oÅ¼enia powiadomienia e-mail',0),(322350,8955,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ñ Ð¿Ð¾ Ð¸Ð¼ÐµÐ¹Ð»',0),(322351,8955,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹',0),(322352,8955,'sr','Ð•Ð¼Ð°Ð¸Ð» Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ°',0),(322353,8955,'vi','Email thÃ´ng bÃ¡o thanh toÃ¡n trá»±c tiáº¿p',0),(322354,8955,'af','E-pos Direkte Deposito Kennisgewings',0),(322355,8955,'ro','NotificÄƒri de depozit directe prin e-mail',0),(322356,8955,'et','Panga Ã¼lekanne E-mail',0),(322357,8955,'si','E-obvestila neposredno depozit',0),(322358,8955,'ba','Deposit langsung email pemberitahuan',0),(322359,8955,'nl','E-mailmeldingen voor directe storting',0),(322360,8955,'fi','Suora talletus sÃ¤hkÃ¶postiisi',0),(322361,8955,'no','Beskjeder direkte innskudd',0),(322362,8955,'da','E-mail direkte indbetaling anmeldelser',0),(322363,8955,'ko','ì´ë©”ì¼ ì§ì ‘ ìž…ê¸ˆ ì•Œë¦¼',0),(322364,8955,'he','×”×•×“×¢×•×ª ×“×•× ×œ ×”×¤×§×“×” ×™×©×™×¨×”',0),(322365,8955,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î±Î½Î±ÎºÎ¿Î¹Î½ÏŽÏƒÎµÎ¹Ï‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(322366,8955,'zh','ç”µå­é‚®ä»¶ç›´æŽ¥å­˜æ¬¾çš„é€šçŸ¥\r\n',0),(322367,8955,'sv','E-post direkt insÃ¤ttning anmÃ¤lningar',0),(322368,8955,'it','Notifiche deposito diretto e-mail',0),(322369,8955,'tl','',0),(322370,8955,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3649;&#3592;&#3657;&#3591;&#3585;&#3634;&#3619;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(322371,8955,'hi','à¤ˆà¤®à¥‡à¤² à¤¸à¥€à¤§à¥‡ à¤œà¤®à¤¾ à¤¸à¥‚à¤šà¤¨à¤¾',0),(322372,8955,'ms','Pemberitahuan Deposit terus e-mel',0),(322373,8955,'ar','Ø¥Ø´Ø¹Ø§Ø±Ø§Øª Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± Ø¨Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(322374,8955,'fr','Notifications de dÃ©pÃ´t Direct par courriel',0),(322375,8955,'jp','ç›´æŽ¥æ²ˆæ®¿ç‰©ã®é›»å­ãƒ¡ãƒ¼ãƒ«é€šçŸ¥',0),(322376,8955,'pt','DepÃ³sito direto notificaÃ§Ãµes por e-mail',0),(322377,8955,'ru','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(322378,8955,'es','Email Notificaciones de DepÃ³sitos Directos',0),(322379,8955,'de','E-Mail-Benachrichtigungen fÃ¼r direkte Ablagerung',0),(322380,8955,'en','Email Direct Deposit Notifications',0),(322381,8956,'is','',0),(322382,8956,'dr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ø§ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(322383,8956,'pr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ø§ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(322384,8956,'tr','KimliÄŸi HenÃ¼z belirlenmedi',0),(322385,8956,'pl','Brak identyfikatora zostaÅ‚a ustawiona',0),(322386,8956,'bg','Ð˜Ð” Ð½Ðµ Ðµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½',0),(322387,8956,'ur','Ú©ÙˆØ¦ÛŒ Ø´Ù†Ø§Ø®Øª Ù…Ù‚Ø±Ø± Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(322388,8956,'sr','ÐÐµÐ¼Ð° Ð˜Ð” Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(322389,8956,'vi','ChÆ°a Ä‘áº·t ID',0),(322390,8956,'af','Geen ID is opgestel',0),(322391,8956,'ro','S-a stabilit nici o identitate',0),(322392,8956,'et','ID mÃ¤Ã¤ratud',0),(322393,8956,'si','Je bil doloÄen noben ID',0),(322394,8956,'ba','ID ada telah ditetapkan',0),(322395,8956,'nl','Geen ID is vastgesteld',0),(322396,8956,'fi','Ei tunnusta ei ole mÃ¤Ã¤ritetty',0),(322397,8956,'no','Ingen ID er angitt',0),(322398,8956,'da','Ingen ID er angivet',0),(322399,8956,'ko','ID ì„¤ì •',0),(322400,8956,'he','××™×Ÿ ×ª×¢×•×“×ª ×–×”×•×ª ×”×•×’×“×¨',0),(322401,8956,'el','Î¤Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(322402,8956,'zh','æ²¡æœ‰èº«ä»½è¯å·²è®¾ç½®\r\n',0),(322403,8956,'sv','Inget ID har angetts',0),(322404,8956,'it','Non Ã¨ stato impostato alcun ID',0),(322405,8956,'tl','',0),(322406,8956,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3652;&#3623;&#3657;',0),(322407,8956,'hi','à¤•à¥‹à¤ˆ ID à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚.',0),(322408,8956,'ms','ID tidak ditetapkan',0),(322409,8956,'ar','ÙˆÙ‚Ø¯ ØªÙ… ØªØ¹ÙŠÙŠÙ† Ù„Ø§ Ù…Ø¹Ø±Ù',0),(322410,8956,'fr','Aucun ID n\'a Ã©tÃ© dÃ©fini',0),(322411,8956,'jp','ID ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(322412,8956,'pt','O ID nÃ£o foi definido',0),(322413,8956,'ru','ID ÐÐµ Ð‘Ñ‹Ð» Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(322414,8956,'es','No Se ConfigurÃ³ el ID',0),(322415,8956,'de','Keine ID wurde festgelegt.',0),(322416,8956,'en','No ID Has Been Set',0),(322417,8957,'is','',0),(322418,8957,'dr','Ø§Ú¯Ø± Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¯Ø± Ù…Ø±Ø§Ø­Ù„ Ø«Ø§Ø¨Øª Ù†ÙŠØ³Øª â€“ Ø³Ù¾Ø³ ØªØ¹Ø¯Ø§Ø¯ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ ',0),(322419,8957,'pr','Ø§Ú¯Ø± Ù†ÙˆØ¹ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¯Ø± Ù…Ø±Ø§Ø­Ù„ Ø«Ø§Ø¨Øª Ù†ÙŠØ³Øª â€“ Ø³Ù¾Ø³ ØªØ¹Ø¯Ø§Ø¯ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ ',0),(322420,8957,'tr','EÄŸer proje tÃ¼rÃ¼ iÃ§inde sabit aÅŸamalarÄ±, sonra fatura dÃ¶nemleri numarasÄ± deÄŸil',0),(322421,8957,'pl','JeÅ›li typu projektu nie jest w fazie staÅ‚ej, a nastÄ™pnie liczba okresÃ³w rozliczeniowych',0),(322422,8957,'bg','ÐÐºÐ¾ Ñ‚Ð¸Ð¿ Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð½Ðµ Ðµ Ð² Ð´ÑŠÐ»Ð³Ð¾Ñ‚Ñ€Ð°Ð¹Ð½Ð¸ ÐµÑ‚Ð°Ð¿Ð¸, Ñ‚Ð¾Ð³Ð°Ð²Ð° Ð±Ñ€Ð¾ÑÑ‚ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸',0),(322423,8957,'ur','Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ Ù‚Ø³Ù… Ù†Û Ù…ÛŒÚº Ù…Ù‚Ø±Ø±Û Ù…Ø±Ø§Ø­Ù„ØŒ Ù†Ù…Ø¨Ø± Ú©Û’ Ø§Ø¯ÙˆØ§Ø± Ú©ÛŒ Ø¨Ù„Ù†Ú¯ Ø³Û’ Ù…ØªØ¹Ù„Ù‚ ÛÛ’ ØªÙˆ Ù¾Ú¾Ø±',0),(322424,8957,'sr','ÐÐºÐ¾ Ñ‚Ð¸Ð¿ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð° Ð½Ð¸Ñ˜Ðµ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾ Ñƒ Ñ„Ð°Ð·Ð°Ð¼Ð°, Ð° Ð¾Ð½Ð´Ð° Ð±Ñ€Ð¾Ñ˜ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð¾Ð´ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(322425,8957,'vi','Náº¿u Loáº¡i Dá»± Ãn khÃ´ng theo chu trÃ¬nh dá»‹nh sáºµn thÃ¬ sau Ä‘Ã³ Sá»‘ Cá»§a Tá»«ng Ká»³ HÃ³a ÄÆ¡n',0),(322426,8957,'af','As projek tipe nie in vaste stadiums, dan nommer van fakturering periodes',0),(322427,8957,'ro','ÃŽn cazul Ã®n care tipul de proiect nu este Ã®n fazele fixe, atunci numÄƒrul de perioade de facturare',0),(322428,8957,'et','Kui projekt pole Ãœmbruskonnas fikseeritud etapid, siis perioodide arvete arv',0),(322429,8957,'si','ÄŒe Vrsta projekta ni v osnovnih fazah, potem Å¡tevilo zaraÄunavanje obdobja',0),(322430,8957,'ba','Jika jenis proyek tidak di tahap tetap, maka nomor periode penagihan',0),(322431,8957,'nl','Als projecttype niet in vaste stadia, dan nummer van facturering periodes',0),(322432,8957,'fi','Jos projektityyppi ei ole kaupungissa kiinteÃ¤ vaiheet niin laskutus jaksojen mÃ¤Ã¤rÃ¤',0),(322433,8957,'no','Hvis typen ikke er i fast stadier, sÃ¥ antallet av fakturering perioder',0),(322434,8957,'da','Hvis projekttypen ikke er i faste faser, sÃ¥ antallet af Billing perioder',0),(322435,8957,'ko','í”„ë¡œì íŠ¸ í˜•ì‹ì— ê³ ì • ë‹¨ê³„, ë‹¤ìŒ ì²­êµ¬ ê¸°ê°„ ìˆ˜ ê²½ìš°',0),(322436,8957,'he','×× ×¡×•×’ ×¤×¨×•×™×™×§×˜ ××™× ×• ×‘×ª×•×š ×©×œ×‘×™× ×§×‘×•×¢×™×, ×•×œ××—×¨ ×ž×›×Ÿ ×”×ž×¡×¤×¨ ×©×œ ×ª×§×•×¤×•×ª ×—×™×•×‘',0),(322437,8957,'el','Î•Î¬Î½ Î¤ÏÏ€Î¿Ï‚ Î­ÏÎ³Î¿Ï… Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ in ÏƒÏ„Î±Î¸ÎµÏÎ¬ ÏƒÏ„Î¬Î´Î¹Î±, ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î±, ÏƒÏ„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Ï‰Î½ Ï€ÎµÏÎ¹ÏŒÎ´Ï‰Î½ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(322438,8957,'zh','å¦‚æžœé¡¹ç›®ç±»åž‹ä¸åœ¨å›ºå®šé˜¶æ®µï¼Œé‚£ä¹ˆæ˜¯è®¡è´¹å‘¨æœŸ\r\n',0),(322439,8957,'sv','Om projekttyp inte i fasta steg, sedan numrera av fakturering perioder',0),(322440,8957,'it','Se il tipo di progetto non Ã¨ nelle fasi fisse, quindi il numero di periodi di fatturazione',0),(322441,8957,'tl','',0),(322442,8957,'th','If Project Type is not in Fixed Stages, then Number of Billing Periods',0),(322443,8957,'hi','à¤ªà¥à¤°à¥‹à¤œà¥‡à¤•à¥à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤¸à¥à¤¥à¤¿à¤° à¤…à¤µà¤¸à¥à¤¥à¤¾ à¤®à¥‡à¤‚ à¤¹à¥ˆ, à¤¤à¥‹ à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤…à¤µà¤§à¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¹à¥ˆ, à¤¤à¥‹',0),(322444,8957,'ms','Jika jenis projek bukanlah pada tahap yang tetap, maka jumlah tempoh bil',0),(322445,8957,'ar','Ø¥Ø°Ø§ Ù„Ù… ÙŠÙƒÙ† \"Ù†ÙˆØ¹ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹\" ÙÙŠ Ù…Ø±Ø§Ø­Ù„ Ù…Ø­Ø¯Ø¯Ø©ØŒ Ø«Ù… Ø¹Ø¯Ø¯ ÙØªØ±Ø§Øª Ø§Ù„ÙÙˆØªØ±Ø©',0),(322446,8957,'fr','Si le Type de projet nâ€™est pas en Ã©tapes fixe, alors le nombre de pÃ©riodes de facturation',0),(322447,8957,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®ç¨®é¡žãŒã®å›ºå®šã‚¹ãƒ†ãƒ¼ã‚¸ã€è«‹æ±‚æœŸé–“ã®å˜ä½ã§ã¯ãªã„å ´åˆ',0),(322448,8957,'pt','Se o tipo de projeto nÃ£o Ã© em estÃ¡gios fixos, entÃ£o o nÃºmero de perÃ­odos de faturamento',0),(322449,8957,'ru','Ð•ÑÐ»Ð¸ Ñ‚Ð¸Ð¿ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° Ð½Ðµ Ð² Ñ„Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… ÑÑ‚Ð°Ð´Ð¸ÑÑ…, Ñ‚Ð¾ Ñ‡Ð¸ÑÐ»Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¾Ð² Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(322450,8957,'es','Si el Tipo de Proyecto no esta en Etapas Fijas, entonces el NÃºmero de PerÃ­odos de FacturaciÃ³n',0),(322451,8957,'de','Wenn Projekttyp nicht in festen Stufen, dann Anzahl der Billing-Perioden',0),(322452,8957,'en','If Project Type is not in Fixed Stages, then Number of Billing Periods',0),(322453,8958,'is','',0),(322454,8958,'dr','Ø¯Ø±ØµØ¯ ',0),(322455,8958,'pr','Ø¯Ø±ØµØ¯ ',0),(322456,8958,'tr','YÃ¼zde',0),(322457,8958,'pl','Procent',0),(322458,8958,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(322459,8958,'ur','ÙÛŒ ØµØ¯',0),(322460,8958,'sr','ÐŸÐ¾ÑÑ‚Ð¾',0),(322461,8958,'vi','Pháº§n trÄƒm',0),(322462,8958,'af','Persent',0),(322463,8958,'ro','La sutÄƒ',0),(322464,8958,'et','Protsenti',0),(322465,8958,'si','Odstotkov',0),(322466,8958,'ba','Persen',0),(322467,8958,'nl','Procent',0),(322468,8958,'fi','Prosenttia',0),(322469,8958,'no','Prosent',0),(322470,8958,'da','Procent',0),(322471,8958,'ko','%',0),(322472,8958,'he','××—×•×–',0),(322473,8958,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(322474,8958,'zh','ç™¾åˆ†ä¹‹\r\n',0),(322475,8958,'sv','Procent',0),(322476,8958,'it','Per cento',0),(322477,8958,'tl','',0),(322478,8958,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;',0),(322479,8958,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(322480,8958,'ms','Peratus',0),(322481,8958,'ar','ÙÙŠ Ø§Ù„Ù…Ø§Ø¦Ø©',0),(322482,8958,'fr','Pour cent',0),(322483,8958,'jp','ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ',0),(322484,8958,'pt','Por cento',0),(322485,8958,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(322486,8958,'es','Porciento',0),(322487,8958,'de','Prozent',0),(322488,8958,'en','Percent',0),(322489,8959,'is','',0),(322490,8959,'dr','Ù¾Ø±ÙˆÚ˜Ù‡',0),(322491,8959,'pr','Ù¾Ø±ÙˆÚ˜Ù‡',0),(322492,8959,'tr','Proje',0),(322493,8959,'pl','Projekt',0),(322494,8959,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚',0),(322495,8959,'ur','Ù…Ù†ØµÙˆØ¨Û',0),(322496,8959,'sr','ÐŸÑ€Ð¾Ñ˜ÐµÐºÐ°Ñ‚',0),(322497,8959,'vi','Dá»± Ã¡n',0),(322498,8959,'af','Projek',0),(322499,8959,'ro','Proiect',0),(322500,8959,'et','Projekti',0),(322501,8959,'si','Projekt',0),(322502,8959,'ba','Proyek',0),(322503,8959,'nl','Project',0),(322504,8959,'fi','Hankkeen',0),(322505,8959,'no','Prosjektet',0),(322506,8959,'da','Projekt',0),(322507,8959,'ko','í”„ë¡œì íŠ¸',0),(322508,8959,'he','×¤×¨×•×™×§×˜',0),(322509,8959,'el','ÎˆÏÎ³Î¿Ï…',0),(322510,8959,'zh','é¡¹ç›®\r\n',0),(322511,8959,'sv','Projektet',0),(322512,8959,'it','Progetto',0),(322513,8959,'tl','',0),(322514,8959,'th','&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(322515,8959,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾',0),(322516,8959,'ms','Projek',0),(322517,8959,'ar','Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(322518,8959,'fr','Projet',0),(322519,8959,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆ',0),(322520,8959,'pt','Projeto',0),(322521,8959,'ru','ÐŸÑ€Ð¾ÐµÐºÑ‚',0),(322522,8959,'es','Proyecto',0),(322523,8959,'de','Projekt',0),(322524,8959,'en','Project',0),(322525,8960,'is','',0),(322526,8960,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±ÙˆÚ˜Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(322527,8960,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±ÙˆÚ˜Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(322528,8960,'tr','Proje baÅŸarÄ±yla eklendi',0),(322529,8960,'pl','Projekt pomyÅ›lnie dodane',0),(322530,8960,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(322531,8960,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©Û’ Ù¾Ø±ÙˆØ¬ÛŒÚ©Ù¹',0),(322532,8960,'sr','ÐŸÑ€Ð¾Ñ˜ÐµÐºÑ‚ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(322533,8960,'vi','ThÃªm Dá»± Ã¡n thÃ nh cÃ´ng',0),(322534,8960,'af','Projek Suksesvol Bygevoeg',0),(322535,8960,'ro','Proiect adÄƒugat cu succes',0),(322536,8960,'et','Lisatud projekti',0),(322537,8960,'si','Projekt uspeÅ¡no dodani',0),(322538,8960,'ba','Proyek yang berhasil ditambahkan',0),(322539,8960,'nl','Project toegevoegd',0),(322540,8960,'fi','Projektin lisÃ¤Ã¤minen onnistui',0),(322541,8960,'no','Prosjektet ble lagt til',0),(322542,8960,'da','Projekt tilfÃ¸jet',0),(322543,8960,'ko','í”„ë¡œì íŠ¸ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(322544,8960,'he','×¤×¨×•×™×§×˜ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(322545,8960,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Ï„Î¿ Î­ÏÎ³Î¿',0),(322546,8960,'zh','é¡¹ç›®æˆåŠŸæ·»åŠ \r\n',0),(322547,8960,'sv','Projektet lagts',0),(322548,8960,'it','Progetto aggiunto con successo',0),(322549,8960,'tl','',0),(322550,8960,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(322551,8960,'hi','à¤ªà¥à¤°à¥‹à¤œà¥‡à¤•à¥à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(322552,8960,'ms','Projek yang berjaya menambah',0),(322553,8960,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹ Ø¨Ù†Ø¬Ø§Ø­',0),(322554,8960,'fr','Projet ajoutÃ© avec succÃ¨s',0),(322555,8960,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(322556,8960,'pt','Projeto adicionado com sucesso',0),(322557,8960,'ru','ÐŸÑ€Ð¾ÐµÐºÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(322558,8960,'es','Proyecto Agregado Exitosamente',0),(322559,8960,'de','Projekt erfolgreich hinzugefÃ¼gt',0),(322560,8960,'en','Project Added Successfully',0),(322561,8961,'is','',0),(322562,8961,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(322563,8961,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(322564,8961,'tr','Proje numarasÄ±',0),(322565,8961,'pl','Numer projektu',0),(322566,8961,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(322567,8961,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(322568,8961,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(322569,8961,'vi','Sá»‘ Dá»± Ã¡n',0),(322570,8961,'af','Projek Nommer',0),(322571,8961,'ro','Proiectul numarul',0),(322572,8961,'et','Projekti Number',0),(322573,8961,'si','Å tevilka projekta',0),(322574,8961,'ba','Jumlah proyek',0),(322575,8961,'nl','Projectnummer',0),(322576,8961,'fi','Projektinumero',0),(322577,8961,'no','Prosjektnummeret',0),(322578,8961,'da','Projektnummer',0),(322579,8961,'ko','í”„ë¡œì íŠ¸ ë²ˆí˜¸',0),(322580,8961,'he','×ž×¡×¤×¨ ×¤×¨×•×™×™×§×˜',0),(322581,8961,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î­ÏÎ³Î¿Ï…',0),(322582,8961,'zh','é¡¹ç›®ç¼–å·\r\n',0),(322583,8961,'sv','Projektnummer',0),(322584,8961,'it','Numero progetto',0),(322585,8961,'tl','',0),(322586,8961,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(322587,8961,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(322588,8961,'ms','Nombor projek',0),(322589,8961,'ar','Ø±Ù‚Ù… Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(322590,8961,'fr','NumÃ©ro du projet',0),(322591,8961,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆç•ªå·',0),(322592,8961,'pt','NÃºmero do projeto',0),(322593,8961,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(322594,8961,'es','NÃºmero de Proyecto',0),(322595,8961,'de','Projektnummer',0),(322596,8961,'en','Project Number',0),(322597,8962,'is','',0),(322598,8962,'dr','Ø§Ø±Ø²Ø´ ÙƒÙ„ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(322599,8962,'pr','Ø§Ø±Ø²Ø´ ÙƒÙ„ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(322600,8962,'tr','Proje toplam deÄŸeri',0),(322601,8962,'pl','CaÅ‚kowita wartoÅ›Ä‡ projektu',0),(322602,8962,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(322603,8962,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ Ú©Ù„ Ù‚Ø¯Ø±',0),(322604,8962,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(322605,8962,'vi','GiÃ¡ trá»‹ Tá»•ng cá»™ng Dá»± Ã¡n',0),(322606,8962,'af','Projek Totale Waarde',0),(322607,8962,'ro','Valoarea totalÄƒ a proiectului',0),(322608,8962,'et','Projekti kogumaksumus',0),(322609,8962,'si','Skupna vrednost projekta',0),(322610,8962,'ba','Proyek Total nilai',0),(322611,8962,'nl','Totale waarde van de project',0),(322612,8962,'fi','Hankkeen kokonaisarvo',0),(322613,8962,'no','Totalverdien for prosjekt',0),(322614,8962,'da','Projektet samlede vÃ¦rdi',0),(322615,8962,'ko','í”„ë¡œì íŠ¸ ì´ ê°€ì¹˜',0),(322616,8962,'he','×”×¢×¨×š ×”×›×•×œ×œ ×©×œ ×”×¤×¨×•×™×™×§×˜',0),(322617,8962,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® Î±Î¾Î¯Î± Ï„Î¿Ï… Î­ÏÎ³Î¿Ï…',0),(322618,8962,'zh','é¡¹ç›®çš„æ€»ä»·å€¼\r\n',0),(322619,8962,'sv','Projektets totala vÃ¤rde',0),(322620,8962,'it','Valore totale del progetto',0),(322621,8962,'tl','',0),(322622,8962,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(322623,8962,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‡ à¤•à¥à¤² à¤®à¥‚à¤²à¥à¤¯',0),(322624,8962,'ms','Nilai keseluruhan projek',0),(322625,8962,'ar','Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ© Ù„Ù„Ù…Ø´Ø§Ø±ÙŠØ¹',0),(322626,8962,'fr','Valeur totale du projet',0),(322627,8962,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆç·é¡',0),(322628,8962,'pt','Valor Total do projeto',0),(322629,8962,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(322630,8962,'es','Valor Total de Proyecto',0),(322631,8962,'de','Projekt-Gesamtwert',0),(322632,8962,'en','Project Total Value',0),(322633,8963,'is','',0),(322634,8963,'dr','Ø¯Ø± Ø­Ø§Ù„ÙŠ ÙƒÙ‡ Ø§Ø¶Ø§ÙÙ‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(322635,8963,'pr','Ø¯Ø± Ø­Ø§Ù„ÙŠ ÙƒÙ‡ Ø§Ø¶Ø§ÙÙ‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(322636,8963,'tr','Ekleme sÄ±rasÄ±nda',0),(322637,8963,'pl','Podczas dodawania',0),(322638,8963,'bg','ÐŸÑ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð°',0),(322639,8963,'ur','Ø¬Ø¨Ú©Û Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(322640,8963,'sr','ÐŸÑ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ°',0),(322641,8963,'vi','Khi thÃªm vÃ o',0),(322642,8963,'af','Terwyl die toevoeging van',0),(322643,8963,'ro','Adaugand in acelasi timp',0),(322644,8963,'et','While Adding',0),(322645,8963,'si','Med dodajanjem',0),(322646,8963,'ba','Sambil menambahkan',0),(322647,8963,'nl','Terwijl het toevoegen van',0),(322648,8963,'fi','LisÃ¤ttÃ¤essÃ¤',0),(322649,8963,'no','Mens',0),(322650,8963,'da','Samtidig med at tilfÃ¸je',0),(322651,8963,'ko','ì¶”ê°€ í•˜ëŠ” ë™ì•ˆ',0),(322652,8963,'he','×‘×¢×ª ×”×•×¡×¤×ª',0),(322653,8963,'el','ÎšÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(322654,8963,'zh','åŒæ—¶å¢žåŠ \r\n',0),(322655,8963,'sv','NÃ¤r du lÃ¤gger till',0),(322656,8963,'it','Mentre l\'aggiunta di',0),(322657,8963,'tl','',0),(322658,8963,'th','&#3586;&#3603;&#3632;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(322659,8963,'hi','à¤œà¤¬à¤•à¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(322660,8963,'ms','Sambil menambah',0),(322661,8963,'ar','Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ©',0),(322662,8963,'fr','Lors de l\'ajout',0),(322663,8963,'jp','è¿½åŠ ä¸­',0),(322664,8963,'pt','Ao adicionar',0),(322665,8963,'ru','ÐŸÑ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸',0),(322666,8963,'es','Mientras que Agregar',0),(322667,8963,'de','Beim HinzufÃ¼gen von',0),(322668,8963,'en','While Adding',0),(322669,8964,'is','',0),(322670,8964,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(322671,8964,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(322672,8964,'tr','Ã–deme kodu',0),(322673,8964,'pl','Identyfikator pÅ‚atnoÅ›ci',0),(322674,8964,'bg','Ð˜Ð” Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(322675,8964,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(322676,8964,'sr','Ð˜Ð” Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(322677,8964,'vi','ID Thanh ToÃ¡n',0),(322678,8964,'af','Betaling ID',0),(322679,8964,'ro','Plata ID',0),(322680,8964,'et','Makse ID',0),(322681,8964,'si','PlaÄilo ID',0),(322682,8964,'ba','Pembayaran ID',0),(322683,8964,'nl','Betaling ID',0),(322684,8964,'fi','Maksutunnus',0),(322685,8964,'no','Betalings-ID',0),(322686,8964,'da','Betalings-ID',0),(322687,8964,'ko','ê²°ì œ ID',0),(322688,8964,'he','×ž×–×”×” ×ª×©×œ×•×',0),(322689,8964,'el','Î Î»Î·ÏÏ‰Î¼Î® ID',0),(322690,8964,'zh','ä»˜æ¬¾èº«ä»½è¯\r\n\r\n',0),(322691,8964,'sv','Betalnings-ID',0),(322692,8964,'it','ID pagamento',0),(322693,8964,'tl','',0),(322694,8964,'th','&#3619;&#3627;&#3633;&#3626;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(322695,8964,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ ID',0),(322696,8964,'ms','ID pembayaran',0),(322697,8964,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ø¯ÙØ¹',0),(322698,8964,'fr','ID paiement',0),(322699,8964,'jp','æ”¯æ‰•ã„ ID',0),(322700,8964,'pt','ID de pagamento',0),(322701,8964,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(322702,8964,'es','ID de Pago',0),(322703,8964,'de','Kontonummer',0),(322704,8964,'en','Payment ID',0),(322705,8965,'is','',0),(322706,8965,'dr','...  Ù†ÙŠØ³Øª',0),(322707,8965,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø±Ø§ÙŠ ...  Ù†ÙŠØ³Øª',0),(322708,8965,'tr','E-posta adresi bulunamadÄ±',0),(322709,8965,'pl','Nie moÅ¼na odnaleÅºÄ‡ adres E-mail',0),(322710,8965,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð°Ñ… Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ñ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ Ð·Ð°',0),(322711,8965,'ur','Ú©ÛŒÙ„Ø¦Û’ Ø§ÛŒ Ù…ÛŒÙ„ Ù¾ØªÛ Ù†ÛÛŒÚº Ù…Ù„ Ø³Ú©Ø§',0),(322712,8965,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ðµ-Ð°Ð´Ñ€ÐµÑÑƒ Ð·Ð°',0),(322713,8965,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘á»‹a chá»‰ Email cho',0),(322714,8965,'af','Kan nie E-pos Adresse Vind Vir',0),(322715,8965,'ro','Nu am putut gÄƒsi adresa de E-mail pentru',0),(322716,8965,'et','Ei leia e-posti aadress',0),(322717,8965,'si','Ni bilo mogoÄe najti e-poÅ¡tni naslov za',0),(322718,8965,'ba','Tidak dapat menemukan alamat Email untuk',0),(322719,8965,'nl','E-mailadres voor kon niet vinden',0),(322720,8965,'fi','Ei lÃ¶ytÃ¤nyt sÃ¤hkÃ¶postiosoite',0),(322721,8965,'no','Finner ikke e-postadressen For',0),(322722,8965,'da','Kunne ikke finde E-mail-adresse For',0),(322723,8965,'ko','ì´ë©”ì¼ ì£¼ì†Œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(322724,8965,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×›×ª×•×‘×ª ×”×“×•× ×œ',0),(322725,8965,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î³Î¹Î±',0),(322726,8965,'zh','æ‰¾ä¸åˆ°ç”µå­é‚®ä»¶åœ°å€\r\n',0),(322727,8965,'sv','Kunde inte hitta e-postadress fÃ¶r',0),(322728,8965,'it','Non poteva trovare l\'indirizzo di posta elettronica per',0),(322729,8965,'tl','',0),(322730,8965,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3586;&#3629;&#3591;',0),(322731,8965,'hi','à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤² à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(322732,8965,'ms','Tidak dapat mencari alamat e-mel bagi',0),(322733,8965,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(322734,8965,'fr','Pas pu trouver d\'adresse E-mail pour',0),(322735,8965,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(322736,8965,'pt','NÃ£o foi possÃ­vel encontrar o endereÃ§o de E-mail para',0),(322737,8965,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÐÐ°Ð¹Ñ‚Ð¸ Email ÐÐ´Ñ€ÐµÑ',0),(322738,8965,'es','No se EncontrÃ³ DirecciÃ³n de Email Para',0),(322739,8965,'de','E-Mail-Adresse konnte nicht gefunden werden.',0),(322740,8965,'en','Could Not Find Email Address For',0),(322741,8966,'is','',0),(322742,8966,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(322743,8966,'pr','ØªØ§Ø±ÙŠØ® Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù…Ø³ØªÙ‚ÙŠÙ…',0),(322744,8966,'tr','DoÄŸrudan yatÄ±rma tarihi',0),(322745,8966,'pl','Data przelewu',0),(322746,8966,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð´Ð°Ñ‚Ð°',0),(322747,8966,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(322748,8966,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð´Ð°Ñ‚ÑƒÐ¼',0),(322749,8966,'vi','NgÃ y giao dá»‹ch trá»±c tiáº¿p',0),(322750,8966,'af','Direkte Deposito Datum',0),(322751,8966,'ro','Data direct de depozit',0),(322752,8966,'et','Panga Ã¼lekanne kuupÃ¤ev',0),(322753,8966,'si','Neposreden vloga datum',0),(322754,8966,'ba','Deposit langsung tanggal',0),(322755,8966,'nl','Directe storting datum',0),(322756,8966,'fi','Tilisiirron pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n',0),(322757,8966,'no','Direkte innskudd dato',0),(322758,8966,'da','Direkte depositum dato',0),(322759,8966,'ko','ì§ì ‘ ìž…ê¸ˆ ë‚ ì§œ',0),(322760,8966,'he','×ª××¨×™×š ×”×¤×§×“×” ×™×©×™×¨×”',0),(322761,8966,'el','Î†Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(322762,8966,'zh','ç›´æŽ¥å­˜æ¬¾æ—¥æœŸ\r\n',0),(322763,8966,'sv','Direkt insÃ¤ttning datum',0),(322764,8966,'it','Data di deposito diretto',0),(322765,8966,'tl','',0),(322766,8966,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3613;&#3634;&#3585;&#3648;&#3591;&#3636;&#3609;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(322767,8966,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(322768,8966,'ms','Tarikh Deposit terus',0),(322769,8966,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(322770,8966,'fr','Date de dÃ©pÃ´t direct',0),(322771,8966,'jp','ç›´æŽ¥æ²ˆæ®¿ç‰©ã®æ—¥ä»˜',0),(322772,8966,'pt','Data de depÃ³sito direto',0),(322773,8966,'ru','Ð”Ð°Ñ‚Ð° ÐŸÑ€ÑÐ¼Ð¾Ð³Ð¾ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(322774,8966,'es','Fecha de DepÃ³sito Directo',0),(322775,8966,'de','Direkte Einzahlungsdatum',0),(322776,8966,'en','Direct Deposit Date',0),(322777,8967,'is','',0),(322778,8967,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(322779,8967,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(322780,8967,'tr','E-posta baÅŸarÄ±yla gÃ¶nderildi',0),(322781,8967,'pl','E-mail wysÅ‚any pomyÅ›lnie',0),(322782,8967,'bg','Ð˜Ð¼ÐµÐ¹Ð»ÑŠÑ‚ Ð±ÐµÑˆÐµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(322783,8967,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ú¾ÛŒØ¬ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒ Ù…ÛŒÙ„',0),(322784,8967,'sr','Ð• -Ð¿Ð¾ÑˆÑ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ð¾ÑÐ»Ð°Ñ‚',0),(322785,8967,'vi','Email gá»­i thÃ nh cÃ´ng cho',0),(322786,8967,'af','E-pos Suksesvol Gestuur Vir',0),(322787,8967,'ro','E-mail trimis cu succes',0),(322788,8967,'et','E-post saadeti edukalt',0),(322789,8967,'si','Email poslan',0),(322790,8967,'ba','Email yang berhasil dikirim',0),(322791,8967,'nl','E-mail verzonden voor',0),(322792,8967,'fi','SÃ¤hkÃ¶postiviesti lÃ¤hetettiin onnistuneesti',0),(322793,8967,'no','E-post sendt',0),(322794,8967,'da','E-mail sendt',0),(322795,8967,'ko','ì„±ê³µì ìœ¼ë¡œ ë³´ë‚¸ ì´ë©”ì¼',0),(322796,8967,'he','×”××™×ž×™×™×œ × ×©×œ×— ×‘×”×¦×œ×—×”',0),(322797,8967,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Ï€Î¿Ï… ÏƒÏ„Î­Î»Î½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(322798,8967,'zh','ç”µå­é‚®ä»¶å‘é€æˆåŠŸ\r\n',0),(322799,8967,'sv','E-post som skickats',0),(322800,8967,'it','Email inviata con successo',0),(322801,8967,'tl','',0),(322802,8967,'th','&#3626;&#3656;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(322803,8967,'hi','à¤ˆà¤®à¥‡à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(322804,8967,'ms','E-mel yang dihantar telah berjaya untuk',0),(322805,8967,'ar','Ø£Ø±Ø³Ù„ Ø¨Ù†Ø¬Ø§Ø­ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(322806,8967,'fr','E-mail envoyÃ© avec succÃ¨s',0),(322807,8967,'jp','æ­£å¸¸ã«é€ä¿¡ã•ã‚ŒãŸé›»å­ãƒ¡ãƒ¼ãƒ«',0),(322808,8967,'pt','E-mail enviado com sucesso',0),(322809,8967,'ru','Email Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½ ',0),(322810,8967,'es','Email Enviado Exitosamente Para',0),(322811,8967,'de','E-Mail erfolgreich gesendet, fÃ¼r',0),(322812,8967,'en','Email Sent Successfully For',0),(322813,8968,'is','',0),(322814,8968,'dr','Ø®Ø·Ø§ Ø¯Ø± Ú¯Ø±ÙØªÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(322815,8968,'pr','Ø®Ø·Ø§ Ø¯Ø± Ú¯Ø±ÙØªÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(322816,8968,'tr','Hata alma e-posta adresi',0),(322817,8968,'pl','BÅ‚Ä…d pobierania adresu E-mail',0),(322818,8968,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ',0),(322819,8968,'ur','Ù†Ù‚Øµ Ú©Ø§ Ø­ØµÙˆÙ„ Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÛŒÚˆØ±ÛŒØ³',0),(322820,8968,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð¸Ñ˜Ð°ÑšÑƒ Ð•Ð¼Ð°Ð¸Ð» Ð°Ð´Ñ€ÐµÑÑƒ',0),(322821,8968,'vi','TÃ¬m Ä‘á»‹a chá»‰ Email bá»‹ lá»—i',0),(322822,8968,'af','Fout met Verkryging van E-pos Adres',0),(322823,8968,'ro','Eroare NoÅ£iuni de bazÄƒ adresa de Email',0),(322824,8968,'et','Viga saada e-posti aadress',0),(322825,8968,'si','Napaka pri pridobivanju e-poÅ¡tni naslov',0),(322826,8968,'ba','Alamat Email mendapatkan kesalahan',0),(322827,8968,'nl','Fout krijgt e-mailadres',0),(322828,8968,'fi','Virhe haettaessa sÃ¤hkÃ¶postiosoite',0),(322829,8968,'no','Feil Ã¥ fÃ¥ e-postadresse',0),(322830,8968,'da','Fejl at fÃ¥ E-mail-adresse',0),(322831,8968,'ko','ì˜¤ë¥˜ ì–»ëŠ” ì´ë©”ì¼ ì£¼ì†Œ',0),(322832,8968,'he','×›×ª×•×‘×ª ×”×“×•× ×œ ×ž×§×‘×œ ×©×’×™××”',0),(322833,8968,'el','Î£Ï†Î¬Î»Î¼Î± Î½Î± Ï€Î¬ÏÎµÎ¹ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(322834,8968,'zh','é”™è¯¯èŽ·å–ç”µå­é‚®ä»¶åœ°å€\r\n',0),(322835,8968,'sv','Fel att fÃ¥ e-postadress',0),(322836,8968,'it','Errore ricevendo Email indirizzo',0),(322837,8968,'tl','',0),(322838,8968,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(322839,8968,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¹à¥‹ à¤°à¤¹à¥€ à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¥‡',0),(322840,8968,'ms','Alamat e-mel mendapat ralat',0),(322841,8968,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(322842,8968,'fr','Erreur Getting Email adresse',0),(322843,8968,'jp','ã‚¨ãƒ©ãƒ¼å–å¾—ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹',0),(322844,8968,'pt','EndereÃ§o de E-mail recebendo erro',0),(322845,8968,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Email ÐÐ´Ñ€ÐµÑÐ°',0),(322846,8968,'es','Error Agarrando la DirecciÃ³n de Email',0),(322847,8968,'de','Fehler immer E-Mail-Adresse',0),(322848,8968,'en','Error Getting Email Address',0),(322849,8969,'is','',0),(322850,8969,'dr','Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ Ø¯Ø± ÙØ±Ø³ØªØ§Ø¯Ù†  Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡   ',0),(322851,8969,'pr','Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ Ø¯Ø± ÙØ±Ø³ØªØ§Ø¯Ù†  Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡   ',0),(322852,8969,'tr','GÃ¶nderen e-posta iÃ§in baÅŸarÄ±sÄ±z oldu',0),(322853,8969,'pl','WysyÅ‚anie maila do nie powiodÅ‚o siÄ™',0),(322854,8969,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð» Ð·Ð°',0),(322855,8969,'ur','Ø¨Ú¾ÛŒØ¬Ù†Û’ Ú©Û’ Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ù„Ø¦Û’ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯Ø¦ÛŒ',0),(322856,8969,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾ ÑˆÐ°Ñ™Ðµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ñƒ Ð·Ð°',0),(322857,8969,'vi','KhÃ´ng gá»­i Ä‘Æ°á»£c Email cho',0),(322858,8969,'af','Faal in Stuur van E-pos Vir',0),(322859,8969,'ro','Nu a reuÈ™it trimiterea E-mail pentru',0),(322860,8969,'et','E-kirja saatmine ebaÃµnnestus',0),(322861,8969,'si','Ni uspelo poÅ¡iljanje e-poÅ¡te za',0),(322862,8969,'ba','Gagal mengirim Email untuk',0),(322863,8969,'nl','Verzenden verzenden voor mislukt',0),(322864,8969,'fi','SÃ¤hkÃ¶postin lÃ¤hettÃ¤minen epÃ¤onnistui',0),(322865,8969,'no','Kan ikke sende e-post For',0),(322866,8969,'da','Det lykkedes ikke at sende E-mail til',0),(322867,8969,'ko','ë³´ë‚´ëŠ” ì´ë©”ì¼ì— ëŒ€ í•œ ì‹¤íŒ¨',0),(322868,8969,'he','× ×›×©×œ ×©×œ×™×—×ª ×“×•× ×œ',0),(322869,8969,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î³Î¹Î±',0),(322870,8969,'zh','æ— æ³•å‘é€ç”µå­é‚®ä»¶\r\n',0),(322871,8969,'sv','Gick inte att skicka e-post fÃ¶r',0),(322872,8969,'it','Impossibile invio Email per',0),(322873,8969,'tl','',0),(322874,8969,'th','&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;&#3651;&#3609;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(322875,8969,'hi','à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ˆà¤®à¥‡à¤² à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(322876,8969,'ms','Gagal menghantar Email bagi',0),(322877,8969,'ar','ÙØ´Ù„ ÙÙŠ Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„',0),(322878,8969,'fr','Ã‰chec d\'envoi d\'Email pour',0),(322879,8969,'jp','ãŸã‚ã®é›»å­ãƒ¡ãƒ¼ãƒ«ã®é€ä¿¡ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(322880,8969,'pt','Falha de envio de E-mail para',0),(322881,8969,'ru','Ð¡Ð±Ð¾Ð¹ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð´Ð»Ñ',0),(322882,8969,'es','Se FallÃ³ Mandar Email Para',0),(322883,8969,'de','Fehler beim Senden von E-Mails fÃ¼r',0),(322884,8969,'en','Failed Sending Email For',0),(322885,8970,'is','',0),(322886,8970,'dr','Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ Ø¯Ø±  Ú¯Ø±ÙØªÙ† ØªÙ‡ Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(322887,8970,'pr','Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ Ø¯Ø±  Ú¯Ø±ÙØªÙ† ØªÙ‡ Ú†Ùƒ Ø³Ù¾Ø±Ø¯Ù‡ Ù…Ø³ØªÙ‚ÙŠÙ… ',0),(322888,8970,'tr','DoÄŸrudan yatÄ±rma saplama alÄ±namadÄ±',0),(322889,8970,'pl','UdaÅ‚o siÄ™ uzyskaÄ‡ bezpoÅ›redni depozyt Stub',0),(322890,8970,'bg','ÐÐµ ÑƒÑÐ¿Ñ Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸ Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿ÑŠÐ½',0),(322891,8970,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆÙ¾Ø§Ø²Ù¹ Ø¯Ø§Ú‘Ú¾ Ø­Ø§ØµÙ„ Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(322892,8970,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð° Ð´Ð° Ð´Ð¾Ð±Ð¸Ñ˜Ðµ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¾Ð´ÑÐµÑ‡Ð°Ðº',0),(322893,8970,'vi','KhÃ´ng vÃ o Ä‘Æ°á»£c giao dá»‹ch trá»±c tiáº¿p',0),(322894,8970,'af','Verkryging Direkte Deposito Teenblaadjie het gefaal',0),(322895,8970,'ro','Nu pentru a obÅ£ine Direct de depozit ciot',0),(322896,8970,'et','Ei saa otse hoiule VÃ¤lislingid',0),(322897,8970,'si','Uspelo dobiti neposredno depozit Å¡tor',0),(322898,8970,'ba','Gagal mendapatkan Deposit langsung rintisan',0),(322899,8970,'nl','Failed To Get directe storting Stub',0),(322900,8970,'fi','Ei saanut suoraa tallettaa tynkÃ¤',0),(322901,8970,'no','Kan ikke hente direkte innskudd Stub',0),(322902,8970,'da','Kan ikke fÃ¥ direkte indbetaling Stub',0),(322903,8970,'ko','ì§ì ‘ ìž…ê¸ˆ ìŠ¤í… ê°€ì ¸ì˜¤ëŠ” ë° ì‹¤íŒ¨',0),(322904,8970,'he','×§×‘×œ×ª ×¡×¤×— ×”×¤×§×“×” ×™×©×™×¨×” × ×›×©×œ×”',0),(322905,8970,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· Î»Î®ÏˆÎ· Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÏ„Î­Î»ÎµÏ‡Î¿Ï‚',0),(322906,8970,'zh','æ— æ³•å–å¾—ç›´æŽ¥å­˜æ¬¾å­˜æ ¹\r\n',0),(322907,8970,'sv','Det gick inte att fÃ¥ direkt insÃ¤ttning Stub',0),(322908,8970,'it','Impossibile ottenere il deposito diretto Stub',0),(322909,8970,'tl','',0),(322910,8970,'th','&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;&#3651;&#3609;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;',0),(322911,8970,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤œà¤®à¤¾ à¤¸à¥à¤Ÿà¤¬ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(322912,8970,'ms','Gagal mendapatkan Deposit terus tunas',0),(322913,8970,'ar','ÙØ´Ù„ ÙÙŠ Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ ÙƒØ¹Ø¨ Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(322914,8970,'fr','Impossible d\'obtenir le dÃ©pÃ´t Direct Stub',0),(322915,8970,'jp','ç›´æŽ¥é é‡‘ã‚¹ã‚¿ãƒ–ã®å–å¾—ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(322916,8970,'pt','Falha ao obter o esboÃ§o do depÃ³sito direto',0),(322917,8970,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð·Ð°Ð³Ð»ÑƒÑˆÐºÐ¸',0),(322918,8970,'es','Se FallÃ³ Agarrar TalÃ³n de DepÃ³sito Directo',0),(322919,8970,'de','Fehler beim Abrufen der direkte Ablagerung Stub',0),(322920,8970,'en','Failed To Get Direct Deposit Stub',0),(322921,8971,'is','',0),(322922,8971,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ù…Ø³ØªÙ‚ÙŠÙ… Ø´Ù…Ø§ Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(322923,8971,'pr','Ø§Ø¹Ù„Ø§Ù… Ø³Ù¾Ø±Ø¯Ù‡(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ù…Ø³ØªÙ‚ÙŠÙ… Ø´Ù…Ø§ Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(322924,8971,'tr','DoÄŸrudan yatÄ±rma bildirim iliÅŸtirilir.',0),(322925,8971,'pl','Twoje zgÅ‚oszenie przelewu jest doÅ‚Ä…czony.',0),(322926,8971,'bg','Ð’Ð°ÑˆÐ¸ÑÑ‚ Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑƒÐ²ÐµÐ´Ð¾Ð¼ÑÐ²Ð°Ð½Ðµ Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½.',0),(322927,8971,'ur','Ø¢Ù¾ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬Ù…Ø¹ Ú©Û’ Ø§Ø¹Ù„Ø§Ù† Ø³Û’ Ù…Ù†Ø³Ù„Ú© ÛÛ’ Û”',0),(322928,8971,'sr','Ð¢Ð²Ð¾Ñ˜ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ˜Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½.',0),(322929,8971,'vi','KÃ¨m theo lÃ  thÃ´ng bÃ¡o vá» tiá»n cá»c trá»±c tiáº¿p cá»§a báº¡n',0),(322930,8971,'af','U DIREKTE DEPOSITO KENNISGEWING is aangeheg.',0),(322931,8971,'ro','Notificarea depozitului dumneavoastra este atasat',0),(322932,8971,'et','Teie otsekorralduse',0),(322933,8971,'si','Je pritrjena neposredno depozit obvestila.',0),(322934,8971,'ba','Pemberitahuan deposit langsung Anda terpasang.',0),(322935,8971,'nl','Uw directe storting kennisgeving is gekoppeld.',0),(322936,8971,'fi','Suora talletus ilmoituksen liitteenÃ¤.',0),(322937,8971,'no','Din direkte innskudd melding er festet.',0),(322938,8971,'da','Din direkte indbetaling anmeldelse er fastgjort.',0),(322939,8971,'ko','ì§ì ‘ ìž…ê¸ˆ ì•Œë¦¼ ì²¨ë¶€ ë©ë‹ˆë‹¤.',0),(322940,8971,'he','×”×”×•×“×¢×” ×©×œ×š ×”×¤×§×“×” ×™×©×™×¨×” ×ž×¦×•×¨×¤×ª.',0),(322941,8971,'el','Î•Ï€Î¹ÏƒÏ…Î½Î¬Ï€Ï„ÎµÏ„Î±Î¹ Î· ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ® ÏƒÎ±Ï‚ Î¬Î¼ÎµÏƒÎ· ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·.',0),(322942,8971,'zh','æ‚¨çš„ç›´æŽ¥å­˜æ¬¾é€šçŸ¥ä¹¦é™„åŽã€‚\r\n',0),(322943,8971,'sv','Din direkt insÃ¤ttning anmÃ¤lan bifogas.',0),(322944,8971,'it','La notifica del deposito diretto Ã¨ attaccato.',0),(322945,8971,'tl','',0),(322946,8971,'th','&#3613;&#3634;&#3585;&#3650;&#3604;&#3618;&#3605;&#3619;&#3591;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3649;&#3592;&#3657;&#3591;&#3648;&#3611;&#3655;&#3609;&#3652;&#3615;&#3621;&#3660;&#3649;&#3609;&#3610;',0),(322947,8971,'hi','à¤†à¤ªà¤•à¥‡ à¤¸à¥€à¤§à¥‡ à¤œà¤®à¤¾ à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾ à¤¸à¥‡ à¤œà¥à¤¡à¤¼à¥€ à¤¹à¥ˆà¥¤',0),(322948,8971,'ms','Pemberitahuan deposit terus anda ditempatkan.',0),(322949,8971,'ar','ÙŠØªÙ… Ø¥Ø±ÙØ§Ù‚ Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ.',0),(322950,8971,'fr','Votre notification de dÃ©pÃ´t direct est attachÃ©e.',0),(322951,8971,'jp','ç›´æŽ¥é é‡‘é€šçŸ¥ãŒæ·»ä»˜ã•ã‚Œã¾ã™ã€‚',0),(322952,8971,'pt','Sua notificaÃ§Ã£o de depÃ³sito direto Ã© anexada.',0),(322953,8971,'ru','Ð’Ð°ÑˆÐ¸ Ð¿Ñ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ñ Ð´Ð»Ñ Ð¿Ñ€ÑÐ¼Ð¾Ð³Ð¾ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¿Ñ€Ð¸ÐºÑ€ÐµÐ¿Ð»ÐµÐ½Ñ‹.',0),(322954,8971,'es','Su notificaciÃ³n de depÃ³sito directo esta anexada',0),(322955,8971,'de','Ihre direkte Ablagerung-Benachrichtigung ist beigefÃ¼gt.',0),(322956,8971,'en','Your direct deposit notification is attached.',0),(322957,8972,'is','',0),(322958,8972,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(322959,8972,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(322960,8972,'tr','Stok GL girdileri ekleme',0),(322961,8972,'pl','Dodaj wpisy inwentaryzacji GL',0),(322962,8972,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð·Ð°Ð¿Ð°ÑÐ¸ GL',0),(322963,8972,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(322964,8972,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð“Ð›',0),(322965,8972,'vi','ThÃªm Danh Má»¥c Cho Entry Tá»•ng Há»£p ',0),(322966,8972,'af','AG Vooraadinkskrywings Byvoeg',0),(322967,8972,'ro','Adauga intrari contabile de gestiune',0),(322968,8972,'et','Varude GL kirjeid lisada',0),(322969,8972,'si','Dodaj zaloge GL postavke',0),(322970,8972,'ba','Menambahkan persediaan GL entri',0),(322971,8972,'nl','Inventaris GL vermeldingen toevoegen',0),(322972,8972,'fi','LisÃ¤Ã¤ varaston GL merkinnÃ¤t',0),(322973,8972,'no','Legge til lager GL oppfÃ¸ringer',0),(322974,8972,'da','TilfÃ¸j lageret GL poster',0),(322975,8972,'ko','ìž¬ê³  GL í•­ëª© ì¶”ê°€',0),(322976,8972,'he','×œ×”×•×¡×™×£ ×¢×¨×›×™× GL ×ž×œ××™',0),(322977,8972,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ GL ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(322978,8972,'zh','å¢žåŠ åˆ†å½•åº“å­˜æ€»å¸\r\n',0),(322979,8972,'sv','LÃ¤gg till lagerposter GL',0),(322980,8972,'it','Aggiungere le voci di inventario GL',0),(322981,8972,'tl','',0),(322982,8972,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591; GL',0),(322983,8972,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(322984,8972,'ms','Menambah inventori GL entri',0),(322985,8972,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø¯Ø®Ø§Ù„Ø§Øª GL Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(322986,8972,'fr','Ajouter Ecriture Grand Livre pour Inventaire',0),(322987,8972,'jp','åœ¨åº« GL ã‚¨ãƒ³ãƒˆãƒªã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(322988,8972,'pt','Adicionar entradas GL do inventÃ¡rio',0),(322989,8972,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ GL',0),(322990,8972,'es','Agregar Entradas de LM de Inventario',0),(322991,8972,'de','Inventar GL EintrÃ¤ge hinzufÃ¼gen',0),(322992,8972,'en','Add Inventory GL Entries',0),(322993,8973,'is','',0),(322994,8973,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ùˆ Ù‡Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨  Ø¨Ù‡ Ù‚ÙŠÙ…Øª ÙƒØ§Ù„Ø§ ',0),(322995,8973,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ùˆ Ù‡Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨  Ø¨Ù‡ Ù‚ÙŠÙ…Øª ÙƒØ§Ù„Ø§ ',0),(322996,8973,'tr','Vergi ve nakliye PO BorÃ§lar faturasÄ± madde maliyetine eklemek',0),(322997,8973,'pl','DodaÄ‡ podatek i Å‚adunkÃ³w z PO Bill zobowiÄ…zania do kosztu towaru',0),(322998,8973,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð¸ Ð¾Ñ‚ PO Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ ÐºÑŠÐ¼ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(322999,8973,'ur','Ù¹ÛŒÚ©Ø³ Ø§ÙˆØ± Ù…Ø§Ù„ Ú©ÛŒ Ú‘Ù„Ø§Ø¦ Ù¾Ùˆ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø¨Ù„ Ø³Û’ Ø´Û’ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº Û”',0),(323000,8973,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð¸ Ð¿Ð¾Ñ€ÐµÐ·Ð° \"Ð¸\" Ñ‚Ð¾Ð²Ð°Ñ€ Ð¾Ð´ Ð‘Ð¸Ð»Ð»Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° ÐŸÐž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(323001,8973,'vi','ThÃªm Thuáº¿ & Chi PhÃ­ Váº­n Chuyá»ƒn VÃ o GiÃ¡ ThÃ nh HÃ ng HÃ³a Trong HÃ³a ÄÆ¡n Thanh ToÃ¡n ÄÆ¡n HÃ ng ',0),(323002,8973,'af','Belasting en vrag van PO Waardedalingstoetse Wetsontwerp by voeg Item koste',0),(323003,8973,'ro','AdÄƒugaÅ£i fiscale ÅŸi de transport de marfÄƒ de la PO ÅŸi datorii Bill la Cost articol',0),(323004,8973,'et','Maksu ja kaubavedu PO vÃµlad arve kauba kulu lisada',0),(323005,8973,'si','Dodati davek in tovora od obveznosti zakon PO stroÅ¡ek artikla',0),(323006,8973,'ba','Tambahkan pajak dan barang dari tagihan hutang PO untuk Item biaya',0),(323007,8973,'nl','Belasting- en vracht uit PO schulden Bill toevoegen aan kostprijs',0),(323008,8973,'fi','LisÃ¤Ã¤ vero- ja tavaraliikenteen PO velat Bill kustannukset',0),(323009,8973,'no','Legge til skatte- og fraktkostnader fra PO leverandÃ¸rgjeld Bill varekostnader',0),(323010,8973,'da','TilfÃ¸je moms og fragt fra PO kreditorstyring regningen til vareomkostningerne',0),(323011,8973,'ko','í•­ëª© ë¹„ìš© í¬ ë¯¸ì§€ê¸‰ê¸ˆ ë¹Œì—ì„œ ì„¸ê¸ˆ ë° ìš´ìž„ ì¶”ê°€',0),(323012,8973,'he','×œ×”×•×¡×™×£ ×ž×¡ ×•- Freight ×ž×‘×™×œ ×–×›××™× ×¤×• ×ž×—×™×¨ ×œ×™×—×™×“×”',0),(323013,8973,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï†ÏŒÏÎ¿Ï… ÎºÎ±Î¹ ÎµÎ¼Ï€Î¿ÏÎµÏ…Î¼Î±Ï„Î¹ÎºÏŽÎ½ Î¼ÎµÏ„Î±Ï†Î¿ÏÏŽÎ½ Î±Ï€ÏŒ PO Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÎµÎ¯Î´Î¿Ï…Ï‚',0),(323014,8973,'zh','å¢žåŠ ä»Žè®¢å•åº”ä»˜æ¬¾é¡¹è´¦å•åˆ°é¡¹ç›®æˆæœ¬ä¸­çš„ç¨Žæ”¶åŠè¿è´¹\r\n',0),(323015,8973,'sv','LÃ¤gga till skatt och frakt frÃ¥n PO LeverantÃ¶rsskulder Bill artikelkostnad',0),(323016,8973,'it','Aggiungi IVA e trasporto da PO debiti Bill per voce di costo',0),(323017,8973,'tl','',0),(323018,8973,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3616;&#3634;&#3625;&#3637;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3592;&#3634;&#3585;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3',0),(323019,8973,'hi','PO à¤¸à¥‡ Payables à¤¬à¤¿à¤² à¤†à¤‡à¤Ÿà¤® à¤²à¤¾à¤—à¤¤ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼ à¤•à¤° à¤”à¤° Freight',0),(323020,8973,'ms','Tambah cukai dan penghantaran dari PO pemiutang bil kos Item',0),(323021,8973,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© ÙˆØ§Ù„Ø´Ø­Ù† Ù…Ù† Ø¨Ùˆ Ø§Ù„Ù…Ù‚Ø¨ÙˆØ¶Ø§Øª Ø¨ÙŠÙ„ Ù„ØªÙƒÙ„ÙØ© Ø§Ù„ØµÙ†Ù',0),(323022,8973,'fr','Ajouter taxe et transport de PO des comptes fournisseurs facture au coÃ»t de lâ€™article',0),(323023,8973,'jp','å“ç›®åŽŸä¾¡ã« PO å‚µå‹™æ³•æ¡ˆã‹ã‚‰ç¨Žé‡‘ã‚„é‹é€ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(323024,8973,'pt','Adicionar imposto e frete de PO Bill de contas a pagar, ao custo de Item',0),(323025,8973,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð¸ Ñ„Ñ€Ð°Ñ…Ñ‚ Ð¸Ð· ÑÑ‡ÐµÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(323026,8973,'es','Agregar Impuesto y Flete de OC Recibo de Proveedores al Costo del Item',0),(323027,8973,'de','Steuer und Fracht zu Artikelkosten aus PO Verbindlichkeiten Rechnung hinzufÃ¼gen',0),(323028,8973,'en','Add Tax and Freight from PO Payables Bill to Item Cost',0),(323029,8974,'is','',0),(323030,8974,'dr','( Ù‡Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„',0),(323031,8974,'pr','Ù…Ø§Ù„ÙŠØ§Øª ØªÙ‚Ø³ÙŠÙ… Ø´Ø¯Ù‡ Ùˆ Ù…Ø­Ù…ÙˆÙ„Ù‡ ( Ù‡Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„',0),(323032,8974,'tr','Vergi ve kargo DaÄŸÄ±t',0),(323033,8974,'pl','Podatku i Fracht',0),(323034,8974,'bg','Ð Ð°Ð·Ð¿Ñ€Ð¾ÑÑ‚Ñ€Ð°Ð½ÑÐ²Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¸ Ð½Ð°Ð²Ð»Ð¾',0),(323035,8974,'ur','Ù¹ÛŒÚ©Ø³ Ø§ÙˆØ± Ø³Ø§Ù…Ø§Ù† Ú©ÛŒ ØªÙ‚Ø³ÛŒÙ…',0),(323036,8974,'sr','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ†Ð¸Ñ˜Ñƒ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð¸ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð°',0),(323037,8974,'vi','Thuáº¿ & cÆ°á»›c váº­n chuyá»ƒn PhÃ¢n phá»‘i',0),(323038,8974,'af','Versprei belasting en vrag',0),(323039,8974,'ro','Distribui fiscale ÅŸi de transport de marfÄƒ',0),(323040,8974,'et','Maksu ja kaubavedu',0),(323041,8974,'si','Distribucijo davka in tovorni',0),(323042,8974,'ba','Mendistribusikan pajak dan pengiriman',0),(323043,8974,'nl','Distribueren van belasting- en goederenvervoer',0),(323044,8974,'fi','ALV ja rahdin',0),(323045,8974,'no','Distribuere skatte- og fraktkostnader',0),(323046,8974,'da','Distribuere moms og fragt',0),(323047,8974,'ko','ì„¸ê¸ˆ ë° ìš´ìž„',0),(323048,8974,'he','×œ×”×¤×™×¥ ×ž×¡ ×•- Freight',0),(323049,8974,'el','Î”Î¹Î±Î½Î¿Î¼Î® Ï†ÏŒÏÎ¿Ï… \"ÎºÎ±Î¹\" Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¹ÎºÎ¬',0),(323050,8974,'zh','åˆ†å‘ç¨Žå’Œè¿è´¹\r\n',0),(323051,8974,'sv','Distribuera skatt och frakt',0),(323052,8974,'it','Distribuire merci e fiscali',0),(323053,8974,'tl','',0),(323054,8974,'th','&#3616;&#3634;&#3625;&#3637;&#3592;&#3633;&#3604;&#3592;&#3635;&#3627;&#3609;&#3656;&#3634;&#3618;&#3649;&#3621;&#3632;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(323055,8974,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤”à¤° à¤®à¤¾à¤² à¤¢à¥à¤²à¤¾à¤ˆ à¤µà¤¿à¤¤à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(323056,8974,'ms','Mengagihkan cukai dan pengangkutan',0),(323057,8974,'ar','ØªÙˆØ²ÙŠØ¹ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ ÙˆØ§Ù„Ø´Ø­Ù†',0),(323058,8974,'fr','Distribuer les taxes et frais de transport',0),(323059,8974,'jp','ç¨Žé‡‘ã‚„é‹é€ã‚’é…å¸ƒã—ã¾ã™ã€‚',0),(323060,8974,'pt','Distribuir os impostos e frete',0),(323061,8974,'ru','Ð Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»Ð¸Ñ‚ÑŒ Ð½Ð°Ð»Ð¾Ð³ Ð¸ ÐºÐ¾Ð½Ñ‚ÐµÐ¹Ð½ÐµÑ€Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·ÐºÐ¸',0),(323062,8974,'es','Distribuir Impuestos y Flete',0),(323063,8974,'de','Verteilen, MwSt. und Fracht',0),(323064,8974,'en','Distribute Tax and Freight',0),(323065,8975,'is','',0),(323066,8975,'dr','Ù…ØºØ§ÙŠØ±Øª  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(323067,8975,'pr','Ù…ØºØ§ÙŠØ±Øª  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(323068,8975,'tr','Stok sapmasÄ±',0),(323069,8975,'pl','Odchylenie zapasÃ³w',0),(323070,8975,'bg','Ð”Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ñ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(323071,8975,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ ØªØºÛŒØ±',0),(323072,8975,'sr','ÐžÐ´ÑÑ‚ÑƒÐ¿Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(323073,8975,'vi','ChÃªnh Lá»‡ch HÃ ng Trong Kho',0),(323074,8975,'af','Voorraad Afwyking',0),(323075,8975,'ro','VariaÅ£iile de inventar',0),(323076,8975,'et','Varude dispersioon',0),(323077,8975,'si','Zaloge Variance',0),(323078,8975,'ba','Varians persediaan',0),(323079,8975,'nl','Inventaris variantie',0),(323080,8975,'fi','Varaston varianssi',0),(323081,8975,'no','Lager avvik',0),(323082,8975,'da','Lageret varians',0),(323083,8975,'ko','ìž¬ê³  ì°¨ì´',0),(323084,8975,'he','×”×ž×œ××™ ×”×©×•× ×•×ª',0),(323085,8975,'el','Î”Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ· Ï„Î·Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(323086,8975,'zh','å­˜è´§å·®å¼‚\r\n',0),(323087,8975,'sv','Inventering variansen',0),(323088,8975,'it','Varianza di inventario',0),(323089,8975,'tl','',0),(323090,8975,'th','&#3588;&#3623;&#3634;&#3617;&#3649;&#3611;&#3619;&#3611;&#3619;&#3623;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;\n',0),(323091,8975,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤µà¤¿à¤šà¤°à¤£',0),(323092,8975,'ms','Perbezaan inventori',0),(323093,8975,'ar','Ø§Ù„ÙØ±Ù‚ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(323094,8975,'fr','Variance de l\'inventaire',0),(323095,8975,'jp','åœ¨åº«å·®ç•°',0),(323096,8975,'pt','VariaÃ§Ã£o de inventÃ¡rio',0),(323097,8975,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð´Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ñ',0),(323098,8975,'es','Diferencia de Inventario',0),(323099,8975,'de','Lagerbestand Varianz',0),(323100,8975,'en','Inventory Variance',0),(323101,8976,'is','',0),(323102,8976,'dr','Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø±Ø§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ ØªØ¨Ø¯ÙŠÙ„ ÙƒØ±Ø¯ÙŠØ¯   ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(323103,8976,'pr','Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø±Ø§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ ØªØ¨Ø¯ÙŠÙ„ ÙƒØ±Ø¯ÙŠØ¯   ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ',0),(323104,8976,'tr','Ne zaman dÃ¶nÃ¼ÅŸtÃ¼rme PO iÃ§in Ã¶denecek fatura hesaplarÄ±',0),(323105,8976,'pl','Kiedy PO konwersji do konta pÅ‚atne rachunek',0),(323106,8976,'bg','ÐšÐ¾Ð³Ð°Ñ‚Ð¾ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ PO Ð´Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¿Ð»Ð°Ñ‚Ð¸Ð¼Ð¸ Ð±Ð¸Ð»',0),(323107,8976,'ur','Ø¬Ø¨ ØªØ¨Ø¯ÛŒÙ„ Ù¾Ùˆ Ú©Ùˆ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ø¨Ù„ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(323108,8976,'sr','ÐšÐ°Ð´Ð° Ñ˜Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ð²Ð°ÑšÑƒ ÐŸÐž Ð´Ð° ÐºÐ¾Ð½Ñ‚Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð‘Ð¸Ð»',0),(323109,8976,'vi','Khi Chuyá»ƒn tá»« ÄÆ¡n Mua HÃ ng Sang HÃ³a ÄÆ¡n Cá»§a TK Pháº£i Tráº£',0),(323110,8976,'af','Wanneer AB na Rekeninge Betaalbare Rekening Omgeskakel Word',0),(323111,8976,'ro','CÃ¢nd PO conversie la conturi de plÄƒtit factura',0),(323112,8976,'et','*When Converting ostutellimus to Accounts Payable Bill',0),(323113,8976,'si','Kdaj pretvorbo po vedno raÄune plaÄati raÄun',0),(323114,8976,'ba','Kapan PO konversi untuk akun tagihan yang harus dibayar',0),(323115,8976,'nl','Wanneer omzetten PO om rekeningen te betalen Bill',0),(323116,8976,'fi','Kun muuntaa PO osuus maksetaan Bill',0),(323117,8976,'no','NÃ¥r konvertering PO Ã¥ kontoer betales Bill',0),(323118,8976,'da','NÃ¥r konvertering PO til konti skal betales regningen',0),(323119,8976,'ko','ë•Œ ë³€í™˜ ì‚¬ì„œí•¨ ê³„ì • ì§€ê¸‰ ì²­êµ¬ì„œ',0),(323120,8976,'he','×‘×¢×ª ×”×ž×¨×ª ×œ×¤×• ×—×©×‘×•× ×•×ª ×–×›××™× ×‘×™×œ',0),(323121,8976,'el','ÎŒÏ„Î±Î½ Ï„Î· Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î® PO Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ Ï€Î»Î·ÏÏ‰Ï„Î­Î± Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(323122,8976,'zh','å½“è½¬æ¢è®¢å•åˆ°åº”ä»˜è´¦æ¬¾å¸å•\r\n',0),(323123,8976,'sv','NÃ¤r konvertera PO till konton betalas rÃ¤kningen',0),(323124,8976,'it','Quando PO convertentesi a conti da pagare bolletta',0),(323125,8976,'tl','',0),(323126,8976,'th','&#3648;&#3617;&#3639;&#3656;&#3629;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3651;&#3610;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;&#3652;&#3611;&#3618;&#3633;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3610;&#3',0),(323127,8976,'hi','à¤œà¤¬ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤ªà¥‹ à¤²à¥‡à¤–à¤¾ à¤¦à¥‡à¤¯ à¤¬à¤¿à¤²',0),(323128,8976,'ms','Bilakah menukar PO untuk akaun bil yang perlu dibayar',0),(323129,8976,'ar','Ø¹Ù†Ø¯ ØªØ­ÙˆÙŠÙ„ Øµ. Ø¨ Ø¥Ù„Ù‰ Ø­Ø³Ø§Ø¨Ø§Øª ÙØ§ØªÙˆØ±Ø© Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(323130,8976,'fr','Quelle conversion PO Ã  comptes Payable Bill',0),(323131,8976,'jp','å¤‰æ›ã™ã‚‹ PO ã‚’ã¨ãæ”¯æ‰•ã†æ³•æ¡ˆã‚’ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(323132,8976,'pt','Quando convertendo PO para contas pagÃ¡vel Bill',0),(323133,8976,'ru','ÐšÐ¾Ð³Ð´Ð° Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ðµ PO Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð¾Ð² ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð‘Ð¸Ð»Ð»',0),(323134,8976,'es','Cuando Convierte el OC a Factura de Cuentas por Pagar',0),(323135,8976,'de','Beim Konvertieren von PO bis zu zahlenden Rechnung Konten',0),(323136,8976,'en','When Converting PO to Accounts Payable Bill',0),(323137,8977,'is','',0),(323138,8977,'dr','ÙˆÙ‚ØªÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¯Ø±ÙŠØ§ÙØª Ù…ÙŠ Ø´ÙˆØ¯',0),(323139,8977,'pr','ÙˆÙ‚ØªÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¯Ø±ÙŠØ§ÙØª Ù…ÙŠ Ø´ÙˆØ¯',0),(323140,8977,'tr','PO alma',0),(323141,8977,'pl','Gdy PO otrzymaniu',0),(323142,8977,'bg','ÐŸÑ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° PO',0),(323143,8977,'ur','Ø¬Ø¨ Ù¾Ùˆ ÙˆØµÙˆÙ„ Ú©Ø±Ù†Ø§',0),(323144,8977,'sr','ÐŸÑ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð° ÐŸÐž',0),(323145,8977,'vi','Khi nháº­n Ä‘Æ¡n mua hÃ ng',0),(323146,8977,'af','Wanneer ontvang PO',0),(323147,8977,'ro','CÃ¢nd primiÅ£i PO',0),(323148,8977,'et','Kui tuli ostutellimus',0),(323149,8977,'si','Ko prejemajo PO',0),(323150,8977,'ba','Ketika menerima PO',0),(323151,8977,'nl','Bij het ontvangen van PO',0),(323152,8977,'fi','Kun saa PO',0),(323153,8977,'no','NÃ¥r du mottar PO',0),(323154,8977,'da','NÃ¥r du modtager PO',0),(323155,8977,'ko','í¬ë¥¼ ë°›ì„ ë•Œ',0),(323156,8977,'he','×‘×¢×ª ×§×‘×œ×ª ×“×•××¨',0),(323157,8977,'el','ÎšÎ±Ï„Î¬ Ï„Î· Î»Î®ÏˆÎ· PO',0),(323158,8977,'zh','å½“æŽ¥æ”¶è®¢å•\r\n',0),(323159,8977,'sv','NÃ¤r du tar emot PO',0),(323160,8977,'it','Quando si riceve il PO',0),(323161,8977,'tl','',0),(323162,8977,'th','&#3648;&#3617;&#3639;&#3656;&#3629;&#3585;&#3635;&#3621;&#3633;&#3591;&#3619;&#3633;&#3610;&#3651;&#3610;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;',0),(323163,8977,'hi','à¤œà¤¬ à¤ªà¥‹ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¤¾',0),(323164,8977,'ms','Apabila menerima PO',0),(323165,8977,'ar','Ø¹Ù†Ø¯ ØªÙ„Ù‚ÙŠ Ø¨Ø±ÙŠØ¯',0),(323166,8977,'fr','Lorsqu\'il reÃ§oit des PO',0),(323167,8977,'jp','PO ã®å—ä¿¡æ™‚',0),(323168,8977,'pt','Quando receber PO',0),(323169,8977,'ru','ÐŸÑ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ PO',0),(323170,8977,'es','Cuando Recibe OC',0),(323171,8977,'de','Beim Empfang von PO',0),(323172,8977,'en','When Receiving PO',0),(323173,8978,'is','',0),(323174,8978,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(323175,8978,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(323176,8978,'tr','VarsayÄ±lan YardÄ±m ana sayfa',0),(323177,8978,'pl','DomyÅ›lnie strona pomocy',0),(323178,8978,'bg','Ð”Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(323179,8978,'ur','Ù…Ø¯Ø¯ Ú©Û’ ÛÙˆÙ… Ù¾ÛŒØ¬ Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û',0),(323180,8978,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¿Ð¾Ð¼Ð¾Ñ› Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(323181,8978,'vi','Máº·c Ä‘á»‹nh Tá»›i Trang Trá»£ GiÃºp',0),(323182,8978,'af','Verstek na Hulp Tuisblad',0),(323183,8978,'ro','Implicit la Pagina Principala de Ajutor ',0),(323184,8978,'et','Vaikimisi abi Avaleht',0),(323185,8978,'si','Privzeto pomoÄ domaÄa stran',0),(323186,8978,'ba','Default ke beranda bantuan',0),(323187,8978,'nl','Standaard naar Help Home Page',0),(323188,8978,'fi','Oletus ohjeen kotisivulle',0),(323189,8978,'no','Standard hjemmesiden for hjelp',0),(323190,8978,'da','HjÃ¦lp startsiden som standard',0),(323191,8978,'ko','ë„ì›€ë§ í™ˆ íŽ˜ì´ì§€ë¥¼ ê¸°ë³¸ê°’ìœ¼ë¡œ',0),(323192,8978,'he','×›×‘×¨×™×¨×ª ×ž×—×“×œ ×‘×“×£ ×”×‘×™×ª ×¢×–×¨×”',0),(323193,8978,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î²Î¿Î®Î¸ÎµÎ¹Î± Î‘ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î±',0),(323194,8978,'zh','é»˜è®¤ä¸»é¡µå¸®åŠ©\r\n',0),(323195,8978,'sv','Standard till hjÃ¤lp hem sida',0),(323196,8978,'it','Aiuto Home page di default',0),(323197,8978,'tl','',0),(323198,8978,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3609;&#3657;&#3634;&#3649;&#3619;&#3585;&#3648;&#3611;&#3655;&#3609;&#3627;&#3609;&#3657;&#3634;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(323199,8978,'hi','à¤®à¤¦à¤¦ à¤®à¥à¤– à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(323200,8978,'ms','Lalai untuk bantuan Laman',0),(323201,8978,'ar','Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(323202,8978,'fr','Par dÃ©faut Ã  la Page d\'accueil de l\'aide',0),(323203,8978,'jp','æ—¢å®šã®ãƒ˜ãƒ«ãƒ—ã®ãƒ›ãƒ¼ãƒ  ãƒšãƒ¼ã‚¸ã¸',0),(323204,8978,'pt','PadrÃ£o para a pÃ¡gina inicial de ajuda',0),(323205,8978,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ° Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(323206,8978,'es','PÃ¡gina Hogar Ayudo por Defecto',0),(323207,8978,'de','Standard zur Hilfe-Startseite',0),(323208,8978,'en','Default to Help Home Page',0),(323209,8979,'is','',0),(323210,8979,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨Ù‰ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(323211,8979,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨Ù‰ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(323212,8979,'tr','Pazarlama Ã¶ÄŸeleri gÃ¶sterme',0),(323213,8979,'pl','Nie pokazuj elementÃ³w marketingu',0),(323214,8979,'bg','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð¹ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ñ Ð¼Ð°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³',0),(323215,8979,'ur','Ù…Ø§Ø±Ú©ÛŒÙ¹Ù†Ú¯ Ø§Ø´ÛŒØ§ Ù†Ù…Ø§ÛŒØ´ Ù†Û Ú©Ø±ÛŒÚº',0),(323216,8979,'sr','ÐÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜ ÐœÐ°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³ ÑÑ‚Ð°Ð²ÐºÐµ',0),(323217,8979,'vi','KhÃ´ng thá»ƒ hiá»‡n hÃ ng Maketing',0),(323218,8979,'af','Moenie Bemarkingsitems Wys nie',0),(323219,8979,'ro','Nu afiÈ™a elemente de Marketing',0),(323220,8979,'et','Ã„ra kuva Marketing Teemad',0),(323221,8979,'si','Ne PokaÅ¾i elementov trÅ¾enja',0),(323222,8979,'ba','Jangan Tampilkan item pemasaran',0),(323223,8979,'nl','Marketing Items niet weergeven',0),(323224,8979,'fi','Ã„lÃ¤ NÃ¤ytÃ¤ markkinointi tuotteet',0),(323225,8979,'no','Ikke Vis markedsfÃ¸ring elementer',0),(323226,8979,'da','Vis ikke markedsfÃ¸ring elementer',0),(323227,8979,'ko','ë§ˆì¼€íŒ… í•­ëª©ì„ í‘œì‹œ í•˜ì§€ ì•ŠìŒ',0),(323228,8979,'he','××œ ×ª×¦×™×’ ×¤×¨×™×˜×™× ×©×™×•×•×§',0),(323229,8979,'el','ÎÎ± Î¼Î·Î½ ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î¼Î¬ÏÎºÎµÏ„Î¹Î½Î³Îº',0),(323230,8979,'zh','ä¸æ˜¾ç¤ºè¥é”€é¡¹ç›®\r\n',0),(323231,8979,'sv','Visa inte marknadsfÃ¶ring artiklar',0),(323232,8979,'it','Non mostrano elementi di Marketing',0),(323233,8979,'tl','',0),(323234,8979,'th','&#3652;&#3617;&#3656;&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3605;&#3621;&#3634;&#3604;',0),(323235,8979,'hi','à¤µà¤¿à¤ªà¤£à¤¨ à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(323236,8979,'ms','Jangan tunjuk barang-barang pemasaran',0),(323237,8979,'ar','Ù„Ø§ ØªØ¸Ù‡Ø± Ø¹Ù†Ø§ØµØ± Ø§Ù„ØªØ³ÙˆÙŠÙ‚',0),(323238,8979,'fr','Ne pas afficher les Ã©lÃ©ments de Marketing',0),(323239,8979,'jp','ãƒžãƒ¼ã‚±ãƒ†ã‚£ãƒ³ã‚° ã‚¢ã‚¤ãƒ†ãƒ ã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(323240,8979,'pt','NÃ£o mostrar itens de Marketing',0),(323241,8979,'ru','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¼Ð°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³Ð°',0),(323242,8979,'es','No Muestran Items de Mercado TÃ©cnico',0),(323243,8979,'de','Nicht die Marketing-Elemente anzeigen',0),(323244,8979,'en','Don\'t Show Marketing Items',0),(323245,8980,'is','',0),(323246,8980,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ ØµÙØ­Ù‡ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ',0),(323247,8980,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ ØµÙØ­Ù‡ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ',0),(323248,8980,'tr','Sayfa pazarlama yardÄ±m',0),(323249,8980,'pl','Pomoc Strona obrotu',0),(323250,8980,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¼Ð°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³',0),(323251,8980,'ur','ØµÙØ­Û Ù…Ø§Ø±Ú©ÛŒÙ¹Ù†Ú¯ Ù…ÛŒÚº Ù…Ø¯Ø¯',0),(323252,8980,'sr','ÐŸÐ¾Ð¼Ð¾Ð·Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÐœÐ°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³',0),(323253,8980,'vi','Marketing trang trá»£ giÃºp',0),(323254,8980,'af','Hulp Bladsy Bemarking',0),(323255,8980,'ro','Ajuta la pagina de Marketing',0),(323256,8980,'et','Aidata Page turundus',0),(323257,8980,'si','PomoÄ stran trÅ¾enje',0),(323258,8980,'ba','Membantu pemasaran Halaman',0),(323259,8980,'nl','Help pagina Marketing',0),(323260,8980,'fi','Auttaa sivu markkinointi',0),(323261,8980,'no','Hjelpe siden markedsfÃ¸ring',0),(323262,8980,'da','HjÃ¦lpe side markedsfÃ¸ring',0),(323263,8980,'ko','íŽ˜ì´ì§€ ë§ˆì¼€íŒ… ë„ì›€ë§',0),(323264,8980,'he','×œ×¢×–×•×¨ ×“×£ ×©×™×•×•×§',0),(323265,8980,'el','Î’Î¿Î·Î¸Î®ÏƒÎµÎ¹ ÏƒÎµÎ»Î¯Î´Î± Î¼Î¬ÏÎºÎµÏ„Î¹Î½Î³Îº',0),(323266,8980,'zh','å¸®åŠ©é¡µçš„è¥é”€\r\n',0),(323267,8980,'sv','HjÃ¤lpa sidan marknadsfÃ¶ring',0),(323268,8980,'it','Aiuto pagina Marketing',0),(323269,8980,'tl','',0),(323270,8980,'th','&#3588;&#3623;&#3634;&#3617;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3627;&#3609;&#3657;&#3634;&#3585;&#3634;&#3619;&#3605;&#3621;&#3634;&#3604;',0),(323271,8980,'hi','à¤ªà¥ƒà¤·à¥à¤  à¤µà¤¿à¤ªà¤£à¤¨ à¤®à¥‡à¤‚ à¤®à¤¦à¤¦',0),(323272,8980,'ms','Membantu pemasaran laman',0),(323273,8980,'ar','Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø© ÙÙŠ ØªØ³ÙˆÙŠÙ‚ ØµÙØ­Ø©',0),(323274,8980,'fr','Aide Page Marketing',0),(323275,8980,'jp','ãƒšãƒ¼ã‚¸ã®ãƒžãƒ¼ã‚±ãƒ†ã‚£ãƒ³ã‚°ã‚’ãƒ˜ãƒ«ãƒ—ã—ã¾ã™ã€‚',0),(323276,8980,'pt','Ajudar a pÃ¡gina Marketing',0),(323277,8980,'ru','ÐŸÐ¾Ð¼Ð¾Ñ‡ÑŒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ð¼Ð°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³Ð°',0),(323278,8980,'es','Marketing de PÃ¡gina de Ayudo',0),(323279,8980,'de','Hilfe Seite-Marketing',0),(323280,8980,'en','Help Page Marketing',0),(323281,8981,'is','',0),(323282,8981,'dr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† ØµÙØ­Ù‡ Ø´Ø±ÙˆØ¹ \r\n Splash Page',0),(323283,8981,'pr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† ØµÙØ­Ù‡ Ø´Ø±ÙˆØ¹ \r\n Splash Page',0),(323284,8981,'tr','KarÅŸÄ±lama sayfasÄ±nÄ± gizle',0),(323285,8981,'pl','Ukrywanie strona powitalna',0),(323286,8981,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¸Ð·Ð¿Ñ€ÑŠÑÐºÐ²Ð°Ð¼ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(323287,8981,'ur','Ø³Ù¾Ù„ÛŒØ´ ØµÙØ­Û Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(323288,8981,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð£Ð²Ð¾Ð´Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(323289,8981,'vi','Giáº¥u trang ná»•i',0),(323290,8981,'af','Verberg Spatbladsy',0),(323291,8981,'ro','Ascunde Splash paginÄƒ',0),(323292,8981,'et','Peida Splash Page',0),(323293,8981,'si','Skrij Splash strani',0),(323294,8981,'ba','Menyembunyikan halaman Splash',0),(323295,8981,'nl','Splashpagina verbergen',0),(323296,8981,'fi','Piilota Splash Page',0),(323297,8981,'no','Skjule velkomstside',0),(323298,8981,'da','Skjule Splash side',0),(323299,8981,'ko','ìŠ¤í”Œëž˜ì‹œ íŽ˜ì´ì§€ ìˆ¨ê¸°ê¸°',0),(323300,8981,'he','×”×¡×ª×¨ ××ª ×¢×ž×•×“ ×”×¤×ª×™×—×”',0),(323301,8981,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÏƒÎµÎ»Î¯Î´Î±Ï‚ Ï€Î±Ï†Î»Î±ÏƒÎ¼ÏŽÎ½',0),(323302,8981,'zh','éšè—å› äººæ³¨ç›®çš„ç½‘é¡µ\r\n',0),(323303,8981,'sv','DÃ¶lja Splash sida',0),(323304,8981,'it','Nascondere la pagina iniziale',0),(323305,8981,'tl','',0),(323306,8981,'th','&#3595;&#3656;&#3629;&#3609; Splash Page',0),(323307,8981,'hi','à¤›à¤ª à¤ªà¥ƒà¤·à¥à¤  à¤›à¥à¤ªà¤¾à¤à¤',0),(323308,8981,'ms','Sembunyikan Laman Utama',0),(323309,8981,'ar','Ø¥Ø®ÙØ§Ø¡ ØµÙØ­Ø© Ø§Ù„Ø¨Ø¯Ø§ÙŠØ©',0),(323310,8981,'fr','Masquer Splash Page',0),(323311,8981,'jp','ã‚¹ãƒ—ãƒ©ãƒƒã‚·ãƒ¥ ãƒšãƒ¼ã‚¸ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(323312,8981,'pt','Ocultar pÃ¡gina inicial',0),(323313,8981,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð·Ð°ÑÑ‚Ð°Ð²ÐºÐ¸',0),(323314,8981,'es','Esconder la PÃ¡gina Splash',0),(323315,8981,'de','Splash-Seite ausblenden',0),(323316,8981,'en','Hide Splash Page',0),(323317,8982,'is','',0),(323318,8982,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ø¯Ù‡ÙŠØ¯ ÙƒØ§Ø±Ø¨Ø± Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†Ø¯ ',0),(323319,8982,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ø¯Ù‡ÙŠØ¯ ÙƒØ§Ø±Ø¨Ø± Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†Ø¯ ',0),(323320,8982,'tr','KullanÄ±cÄ± seÃ§in izin',0),(323321,8982,'pl','Niech wybierz uÅ¼ytkownikÃ³w',0),(323322,8982,'bg','ÐÐµÐºÐ° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð¸Ð·Ð±Ð¾Ñ€',0),(323323,8982,'ur','ØµØ§Ø±Ù Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(323324,8982,'sr','ÐÐµÐºÐ° Ð¾Ð´Ð°Ð±Ð¸Ñ€ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(323325,8982,'vi','HÃ£y Chá»n NgÆ°á»i Sá»­ Dá»¥ng',0),(323326,8982,'af','Laat Gebruiker toe om te kies',0),(323327,8982,'ro','SÄƒ selectaÅ£i de utilizator',0),(323328,8982,'et','Las kasutaja valida',0),(323329,8982,'si','Pustiti uporabnik izberite',0),(323330,8982,'ba','Biarkan pengguna pilih',0),(323331,8982,'nl','Laat gebruiker selecteren',0),(323332,8982,'fi','Anna kÃ¤yttÃ¤jÃ¤n valita',0),(323333,8982,'no','La brukeren velge',0),(323334,8982,'da','Lad brugeren vÃ¦lge',0),(323335,8982,'ko','ì‚¬ìš©ìž ì„ íƒ í•˜ìž',0),(323336,8982,'he','×ª×Ÿ ×œ×ž×©×ª×ž×© ×‘×—×™×¨×”',0),(323337,8982,'el','Î•Ï€Î¹Ï„ÏÎ­ÏˆÏ„Îµ Î½Î± ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Ï‡ÏÎ®ÏƒÏ„Î·',0),(323338,8982,'zh','è®©ä½¿ç”¨è€…é€‰æ‹©\r\n',0),(323339,8982,'sv','LÃ¥t anvÃ¤ndaren att vÃ¤lja',0),(323340,8982,'it','Lasciare che l\'utente seleziona',0),(323341,8982,'tl','',0),(323342,8982,'th','&#3651;&#3627;&#3657;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(323343,8982,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤šà¤²à¥‹',0),(323344,8982,'ms','Biarkan pengguna Pilih',0),(323345,8982,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¨ØªØ­Ø¯ÙŠØ¯',0),(323346,8982,'fr','Laisser l\'utilisateur sÃ©lectionner',0),(323347,8982,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’é¸æŠžã™ã‚‹ã‚ˆã†ã«',0),(323348,8982,'pt','Deixe o usuÃ¡rio selecione',0),(323349,8982,'ru','ÐŸÑƒÑÑ‚ÑŒ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð’Ñ‹Ð±Ð¸Ñ€Ð°ÐµÑ‚',0),(323350,8982,'es','Dejar el Usuario Seleccionar',0),(323351,8982,'de','Lassen Sie Benutzer auswÃ¤hlen',0),(323352,8982,'en','Let User Select',0),(323353,8983,'is','',0),(323354,8983,'dr','ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…',0),(323355,8983,'pr','ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…',0),(323356,8983,'tr','GiriÅŸ ana sayfa',0),(323357,8983,'pl','Strona logowania',0),(323358,8983,'bg','Ð’Ñ…Ð¾Ð´ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(323359,8983,'ur','Ù„Ø§Ú¯ Ø§Ù† Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØµÙØ­Û',0),(323360,8983,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð° Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(323361,8983,'vi','Trang chá»§ Ä‘Äƒng nháº­p',0),(323362,8983,'af','Aantekening Tuisblad',0),(323363,8983,'ro','Conectare Home Page',0),(323364,8983,'et','Logi sisse kodulehekÃ¼lg',0),(323365,8983,'si','Prijava domaÄa stran',0),(323366,8983,'ba','Halaman Login',0),(323367,8983,'nl','Login-Home Page',0),(323368,8983,'fi','Kirjaudu sisÃ¤Ã¤n etusivulle',0),(323369,8983,'no','Logikk hjemmeside',0),(323370,8983,'da','Login hjemmeside',0),(323371,8983,'ko','ë¡œê·¸ì¸ í™ˆ íŽ˜ì´ì§€',0),(323372,8983,'he','×¢×ž×•×“ ×¨××©×™ ×”×ª×—×‘×¨×•×ª',0),(323373,8983,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Î‘ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î±',0),(323374,8983,'zh','ç™»å½•ä¸»é¡µ\r\n',0),(323375,8983,'sv','Inloggning hemsida',0),(323376,8983,'it','Pagina iniziale di login',0),(323377,8983,'tl','',0),(323378,8983,'th','&#3621;&#3655;&#3629;&#3585;&#3629;&#3636;&#3609;&#3627;&#3609;&#3657;&#3634;&#3627;&#3621;&#3633;&#3585;',0),(323379,8983,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤®à¥à¤– à¤ªà¥ƒà¤·à¥à¤ ',0),(323380,8983,'ms','Log masuk Laman',0),(323381,8983,'ar','Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(323382,8983,'fr','Page d\'accueil de connexion',0),(323383,8983,'jp','ãƒ­ã‚°ã‚¤ãƒ³ ãƒ›ãƒ¼ãƒ  ãƒšãƒ¼ã‚¸',0),(323384,8983,'pt','PÃ¡gina inicial de login',0),(323385,8983,'ru','Ð’Ñ…Ð¾Ð´ Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(323386,8983,'es','Login PÃ¡gina Hogar',0),(323387,8983,'de','Login Startseite',0),(323388,8983,'en','Login Home Page',0),(323389,8984,'is','',0),(323390,8984,'dr','ØµÙØ­Ù‡  ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…\r\n Splash Page',0),(323391,8984,'pr','ØµÙØ­Ù‡  ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…\r\n Splash Page',0),(323392,8984,'tr','GiriÅŸ tanÄ±tÄ±m sayfasÄ±',0),(323393,8984,'pl','Zaloguj siÄ™ Strona powitalna',0),(323394,8984,'bg','Ð’Ñ…Ð¾Ð´ Ñ†Ð¾Ð¿Ð²Ð°Ð¼ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(323395,8984,'ur','Ù„Ø§Ú¯ Ø§Ù† Ø³Ù¾Ù„ÛŒØ´ ØµÙØ­Û',0),(323396,8984,'sr','Ð£Ð²Ð¾Ð´Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ',0),(323397,8984,'vi','Trang Ä‘Äƒng nháº­p ná»•i',0),(323398,8984,'af','Aantekening Spatblad',0),(323399,8984,'ro','Pagina de pornire login',0),(323400,8984,'et','Login Splash Page',0),(323401,8984,'si','Prijava Splash strani',0),(323402,8984,'ba','Halaman Splash login',0),(323403,8984,'nl','Login splashpagina',0),(323404,8984,'fi','Splash kirjautumissivulle',0),(323405,8984,'no','Splash pÃ¥loggingssiden',0),(323406,8984,'da','Login Splash side',0),(323407,8984,'ko','ë¡œê·¸ì¸ ìŠ¤í”Œëž˜ì‹œ íŽ˜ì´ì§€',0),(323408,8984,'he','×¢×ž×•×“ ×”×¤×ª×™×—×” ×›× ×™×¡×”',0),(323409,8984,'el','Splash ÏƒÎµÎ»Î¯Î´Î± ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚',0),(323410,8984,'zh','ç™»å½•é†’ç›®ç½‘é¡µ\r\n',0),(323411,8984,'sv','Splash inloggningssidan',0),(323412,8984,'it','Pagina iniziale di login',0),(323413,8984,'tl','',0),(323414,8984,'th','Login Splash Page',0),(323415,8984,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤¸à¥à¤ªà¤²à¥ˆà¤¶ à¤ªà¥‡à¤œ',0),(323416,8984,'ms','Laman Utama login',0),(323417,8984,'ar','ØµÙØ­Ø© Ø§Ù„Ø¨Ø¯Ø§ÙŠØ© ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(323418,8984,'fr','Page de dÃ©marrage de connexion',0),(323419,8984,'jp','ãƒ­ã‚°ã‚¤ãƒ³ã®ã‚¹ãƒ—ãƒ©ãƒƒã‚·ãƒ¥ ãƒšãƒ¼ã‚¸',0),(323420,8984,'pt','PÃ¡gina inicial de login',0),(323421,8984,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð·Ð°ÑÑ‚Ð°Ð²ÐºÐ¸ Ð²Ñ…Ð¾Ð´Ð°',0),(323422,8984,'es','Login PÃ¡gina Splash',0),(323423,8984,'de','Login-Splash-Seite',0),(323424,8984,'en','Login Splash Page',0),(323425,8985,'is','',0),(323426,8985,'dr','ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø± Ù…Ø¯ÙŠØ±ÙŠØªÙŠ',0),(323427,8985,'pr','ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø± Ù…Ø¯ÙŠØ±ÙŠØªÙŠ',0),(323428,8985,'tr','YalnÄ±zca yÃ¶netici kullanÄ±cÄ± iÃ§in',0),(323429,8985,'pl','Tylko dla administratora',0),(323430,8985,'bg','Ð¡Ð°Ð¼Ð¾ Ð·Ð° Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(323431,8985,'ur','ØµØ±Ù Ù…Ù†ØªØ¸Ù… ØµØ§Ø±Ù Ú©Û’ Ù„ÛŒÛ’',0),(323432,8985,'sr','Ð¡Ð°Ð¼Ð¾ Ð·Ð° ÐÐ´Ð¼Ð¸Ð½ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº',0),(323433,8985,'vi','Chá»‰ DÃ nh Cho Quáº£n Trá»‹ User',0),(323434,8985,'af','Slegs Vir Admin Gebruiker',0),(323435,8985,'ro','Exclusiv pentru utilizator Admin',0),(323436,8985,'et','Ainult administraatorile',0),(323437,8985,'si','Samo za Admin uporabnika',0),(323438,8985,'ba','Hanya untuk pengguna Admin',0),(323439,8985,'nl','alleen voor ADMIN gebruiker',0),(323440,8985,'fi','Ainoastaan ajaksi Admin kÃ¤yttÃ¤jÃ¤',0),(323441,8985,'no','Bare For administrator',0),(323442,8985,'da','Kun For Admin-brugeren',0),(323443,8985,'ko','Admin ì‚¬ìš©ìžì— ëŒ€ í•œ',0),(323444,8985,'he','×¨×§ ×¢×‘×•×¨ ×”×ž×©×ª×ž×© Admin',0),(323445,8985,'el','ÎœÏŒÎ½Î¿ Î³Î¹Î± Ï„Î¿ Admin Ï‡ÏÎ®ÏƒÏ„Î·',0),(323446,8985,'zh','ä»…ä¸ºç®¡ç†ç”¨æˆ·\r\n',0),(323447,8985,'sv','Bara fÃ¶r Admin-anvÃ¤ndaren',0),(323448,8985,'it','Solo per l\'utente Admin',0),(323449,8985,'tl','',0),(323450,8985,'th','Only For Admin User',0),(323451,8985,'hi','à¤•à¥‡à¤µà¤² à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤',0),(323452,8985,'ms','Hanya untuk pengguna Tadbir',0),(323453,8985,'ar','ÙÙ‚Ø· Ù…Ù† Ø£Ø¬Ù„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ù…Ø³Ø¤ÙˆÙ„',0),(323454,8985,'fr','Uniquement pour l\'utilisateur Admin',0),(323455,8985,'jp','ç®¡ç†è€…ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«å¯¾ã—ã¦ã®ã¿',0),(323456,8985,'pt','Somente para o usuÃ¡rio Admin',0),(323457,8985,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Admin',0),(323458,8985,'es','Solo para Usuario Admin',0),(323459,8985,'de','Nur fÃ¼r Admin Benutzer',0),(323460,8985,'en','Only For Admin User',0),(323461,8986,'is','',0),(323462,8986,'dr','ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(323463,8986,'pr','ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(323464,8986,'tr','AyarlarÄ± baÅŸarÄ±yla kaydedildi',0),(323465,8986,'pl','Ustawienia zapisane',0),(323466,8986,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(323467,8986,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº',0),(323468,8986,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐºÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(323469,8986,'vi','Cháº¿ Ä‘á»™ cÃ i Ä‘áº·t sao lÆ°u thÃ nh cÃ´ng',0),(323470,8986,'af','Vestellings Suksesvol Gestoor',0),(323471,8986,'ro','SetÄƒrile de salvat cu succes',0),(323472,8986,'et','Seaded salvestati edukalt',0),(323473,8986,'si','Nastavitve uspeÅ¡no shranjen',0),(323474,8986,'ba','Pengaturan tersimpan berhasil',0),(323475,8986,'nl','Instellingen succesvol opgeslagen',0),(323476,8986,'fi','Asetukset tallennettu',0),(323477,8986,'no','Innstillingene lagret',0),(323478,8986,'da','Indstillinger gemt med succes',0),(323479,8986,'ko','ì„¤ì •ì´ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(323480,8986,'he','×”×”×’×“×¨×•×ª × ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(323481,8986,'el','ÎŸÎ¹ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Î±Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎ±Î½ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(323482,8986,'zh','è®¾å®šä¿å­˜æˆåŠŸ\r\n',0),(323483,8986,'sv','InstÃ¤llningarna sparats',0),(323484,8986,'it','Impostazioni salvate con successo',0),(323485,8986,'tl','',0),(323486,8986,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3585;&#3635;&#3627;&#3609;&#3604;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(323487,8986,'hi','à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(323488,8986,'ms','Seting yang berjaya disimpan',0),(323489,8986,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª ØªÙ… Ø­ÙØ¸Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(323490,8986,'fr','ParamÃ¨tres enregistrÃ©s avec succÃ¨s',0),(323491,8986,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚ŒãŸè¨­å®š',0),(323492,8986,'pt','ConfiguraÃ§Ãµes salvas com sucesso',0),(323493,8986,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(323494,8986,'es','Configuraciones Guardadas Exitosamente',0),(323495,8986,'de','Einstellungen erfolgreich gespeichert',0),(323496,8986,'en','Settings Saved Successfully',0),(323497,8987,'is','',0),(323498,8987,'dr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ',0),(323499,8987,'pr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ',0),(323500,8987,'tr','Pazarlama Ã¶ÄŸeleri gÃ¶ster',0),(323501,8987,'pl','PokaÅ¼ elementy marketingu',0),(323502,8987,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð¼Ð°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³',0),(323503,8987,'ur','Ù…Ø§Ø±Ú©ÛŒÙ¹Ù†Ú¯ Ø§Ø´ÛŒØ§ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(323504,8987,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ Ð·Ð° ÐœÐ°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³',0),(323505,8987,'vi','Hiá»ƒn thá»‹ hÃ ng Marketing',0),(323506,8987,'af','Wys Bemarkingsitems',0),(323507,8987,'ro','AfiÈ™are elemente de Marketing',0),(323508,8987,'et','Kuva turundus Ã¼ksused',0),(323509,8987,'si','PokaÅ¾i elemente trÅ¾enja',0),(323510,8987,'ba','Tampilkan item pemasaran',0),(323511,8987,'nl','Marketing Items weergeven',0),(323512,8987,'fi','NÃ¤ytÃ¤ kohteet, markkinointi',0),(323513,8987,'no','Vis markedsfÃ¸ring elementer',0),(323514,8987,'da','Vis Marketing elementer',0),(323515,8987,'ko','ë§ˆì¼€íŒ… í•­ëª© í‘œì‹œ',0),(323516,8987,'he','×”×¦×’ ×¤×¨×™×˜×™× ×©×™×•×•×§',0),(323517,8987,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î¼Î¬ÏÎºÎµÏ„Î¹Î½Î³Îº',0),(323518,8987,'zh','æ˜¾ç¤ºå¸‚åœºé¡¹ç›®\r\n',0),(323519,8987,'sv','Visa marknadsfÃ¶ring objekt',0),(323520,8987,'it','Visualizza elementi di Marketing',0),(323521,8987,'tl','',0),(323522,8987,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(323523,8987,'hi','à¤µà¤¿à¤ªà¤£à¤¨ à¤†à¤‡à¤Ÿà¤® à¤¦à¤¿à¤–à¤¾à¤à¤',0),(323524,8987,'ms','Menunjukkan item-item pemasaran',0),(323525,8987,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø¹Ù†Ø§ØµØ± Ø§Ù„ØªØ³ÙˆÙŠÙ‚',0),(323526,8987,'fr','Afficher les Ã©lÃ©ments de Marketing',0),(323527,8987,'jp','ãƒžãƒ¼ã‚±ãƒ†ã‚£ãƒ³ã‚° ã‚¢ã‚¤ãƒ†ãƒ ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(323528,8987,'pt','Mostrar itens de Marketing',0),(323529,8987,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¼Ð°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³Ð°',0),(323530,8987,'es','Mostrar Items de Marketing',0),(323531,8987,'de','Marketing-Elemente anzeigen',0),(323532,8987,'en','Show Marketing Items',0),(323533,8988,'is','',0),(323534,8988,'dr','Ù†Ù…Ø§ÙŠØ´ ØµÙØ­Ù‡\r\n Splash Page',0),(323535,8988,'pr','Ù†Ù…Ø§ÙŠØ´ ØµÙØ­Ù‡\r\n Splash Page',0),(323536,8988,'tr','KarÅŸÄ±lama sayfasÄ±nÄ± gÃ¶ster',0),(323537,8988,'pl','PokaÅ¼ Strona powitalna',0),(323538,8988,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¸Ð·Ð¿Ñ€ÑŠÑÐºÐ²Ð°Ð¼ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(323539,8988,'ur','Ø³Ù¾Ù„ÛŒØ´ ØµÙØ­Û Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(323540,8988,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð£Ð²Ð¾Ð´Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(323541,8988,'vi','Hiá»ƒn thá»‹ trang ná»•i',0),(323542,8988,'af','Spatsel bladsy wys nie',0),(323543,8988,'ro','AfiÈ™aÈ›i pagina Splash',0),(323544,8988,'et','Kuva Splash Page',0),(323545,8988,'si','PrikaÅ¾ite stran Splash',0),(323546,8988,'ba','Tampilkan Halaman Splash',0),(323547,8988,'nl','Toon splashpagina',0),(323548,8988,'fi','NÃ¤ytÃ¤ hotelli Splash Page',0),(323549,8988,'no','Vis velkomstside',0),(323550,8988,'da','Vis velkomstside',0),(323551,8988,'ko','ì‹œìž‘ íŽ˜ì´ì§€ í‘œì‹œ',0),(323552,8988,'he','×”×¦×’ ×“×£ ×”×¤×ª×™×—×”',0),(323553,8988,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÎµÎ»Î¯Î´Î±Ï‚ \"Splash\"',0),(323554,8988,'zh','æ˜¾ç¤ºå¯åŠ¨é¡µ\r\n',0),(323555,8988,'sv','Visa startsidan',0),(323556,8988,'it','Visualizza la pagina di Splash',0),(323557,8988,'tl','',0),(323558,8988,'th','&#3649;&#3626;&#3604;&#3591; Splash Page',0),(323559,8988,'hi','à¤›à¤ª à¤ªà¥ƒà¤·à¥à¤  à¤¦à¤¿à¤–à¤¾à¤à¤',0),(323560,8988,'ms','Menunjukkan Laman Utama',0),(323561,8988,'ar','Ø¥Ø¸Ù‡Ø§Ø± ØµÙØ­Ø© Ø§Ù„Ø¨Ø¯Ø§ÙŠØ©',0),(323562,8988,'fr','Voir la Page d\'accueil',0),(323563,8988,'jp','ã‚¹ãƒ—ãƒ©ãƒƒã‚·ãƒ¥ ãƒšãƒ¼ã‚¸ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(323564,8988,'pt','Mostrar a pÃ¡gina inicial',0),(323565,8988,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ð·Ð°ÑÑ‚Ð°Ð²ÐºÐ¸',0),(323566,8988,'es','Mostra PÃ¡gina Splash',0),(323567,8988,'de','Splash-Seite anzeigen',0),(323568,8988,'en','Show Splash Page',0),(323569,8989,'is','',0),(323570,8989,'dr','ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø³ÙŠØ³ØªÙ… ',0),(323571,8989,'pr','ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø³ÙŠØ³ØªÙ… ',0),(323572,8989,'tr','Sistem ayarlarÄ±',0),(323573,8989,'pl','Ustawienia systemu',0),(323574,8989,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð½Ð¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸',0),(323575,8989,'ur','Ù†Ø¸Ø§Ù… Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº',0),(323576,8989,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐºÐµ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(323577,8989,'vi','CÃ i Äáº·t Há»‡ Thá»‘ng',0),(323578,8989,'af','Sisteem Verstellings',0),(323579,8989,'ro','Setari sistem',0),(323580,8989,'et','SÃ¼steemi seaded',0),(323581,8989,'si','Sistemske nastavitve',0),(323582,8989,'ba','Pengaturan sistem',0),(323583,8989,'nl','Systeeminstellingen',0),(323584,8989,'fi','JÃ¤rjestelmÃ¤asetukset',0),(323585,8989,'no','Systeminnstillinger',0),(323586,8989,'da','Systemindstillinger',0),(323587,8989,'ko','ì‹œìŠ¤í…œ ì„¤ì •',0),(323588,8989,'he','×”×’×“×¨×•×ª ×ž×¢×¨×›×ª',0),(323589,8989,'el','Î¡Ï…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚',0),(323590,8989,'zh','ç³»ç»Ÿè®¾ç½®\r\n',0),(323591,8989,'sv','SysteminstÃ¤llningar',0),(323592,8989,'it','Impostazioni di sistema',0),(323593,8989,'tl','',0),(323594,8989,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3619;&#3632;&#3610;&#3610;',0),(323595,8989,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸',0),(323596,8989,'ms','Seting sistem',0),(323597,8989,'ar','ØªØ¹Ø¯ÙŠÙ„Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù…',0),(323598,8989,'fr','Panneau de configuration',0),(323599,8989,'jp','ã‚·ã‚¹ãƒ†ãƒ ã®è¨­å®š',0),(323600,8989,'pt','ConfiguraÃ§Ãµes do sistema',0),(323601,8989,'ru','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð½Ñ‹Ðµ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(323602,8989,'es','ConfiguraciÃ³n de Sistema',0),(323603,8989,'de','Systemeinstellungen',0),(323604,8989,'en','System Settings',0),(323605,8990,'is','',0),(323606,8990,'dr','ÙˆØ²Ù† Ø³ÙØ§Ø±Ø´ ',0),(323607,8990,'pr','ÙˆØ²Ù† Ø³ÙØ§Ø±Ø´ ',0),(323608,8990,'tr','SipariÅŸ aÄŸÄ±rlÄ±k',0),(323609,8990,'pl','Waga zamÃ³wienia',0),(323610,8990,'bg','Ð¢ÐµÐ³Ð»Ð¾ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(323611,8990,'ur','ØªØ±ØªÛŒØ¨ ÙˆØ²Ù†',0),(323612,8990,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ñ‚ÐµÐ¶Ð¸Ð½Ð°',0),(323613,8990,'vi','Trá»ng lÆ°á»£ng Ä‘Æ¡n hÃ ng',0),(323614,8990,'af','Bestelling Gewig',0),(323615,8990,'ro','Ordinul greutate',0),(323616,8990,'et','JÃ¤rjekorras massi',0),(323617,8990,'si','Naloga teÅ¾e',0),(323618,8990,'ba','Urutan berat',0),(323619,8990,'nl','Gewicht van de bestelling',0),(323620,8990,'fi','Tilauksen kokonaispainon',0),(323621,8990,'no','For vekt',0),(323622,8990,'da','Bestil vÃ¦gt',0),(323623,8990,'ko','ìˆœì„œ ê°€ì¤‘ì¹˜',0),(323624,8990,'he','×¡×“×¨ ×ž×©×§×œ',0),(323625,8990,'el','Î£ÎµÎ¹ÏÎ¬ Î²Î¬ÏÎ¿Ï…Ï‚',0),(323626,8990,'zh','è®¢è´­é‡é‡\r\n',0),(323627,8990,'sv','Ordning vikt',0),(323628,8990,'it','Ordine di peso',0),(323629,8990,'tl','',0),(323630,8990,'th','&#3588;&#3656;&#3634;&#3609;&#3635;&#3657;&#3627;&#3609;&#3633;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(323631,8990,'hi','à¤•à¥à¤°à¤® à¤µà¤œà¤¨',0),(323632,8990,'ms','Perintah berat',0),(323633,8990,'ar','ÙˆØ²Ù† Ø§Ù„Ù†Ø¸Ø§Ù…',0),(323634,8990,'fr','Poids de l\'ordre',0),(323635,8990,'jp','é †åºã®é‡ã¿',0),(323636,8990,'pt','Peso da ordem',0),(323637,8990,'ru','Ð’ÐµÑ Ð·Ð°ÐºÐ°Ð·Ð°',0),(323638,8990,'es','Peso de Orden',0),(323639,8990,'de','Bestellung-Gewicht',0),(323640,8990,'en','Order Weight',0),(323641,8991,'is','',0),(323642,8991,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙˆØ²Ù† Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø² ',0),(323643,8991,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙˆØ²Ù† Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø² ',0),(323644,8991,'tr','SipariÅŸleri aÃ§ - aÄŸÄ±rlÄ±k gÃ¶rÃ¼nÃ¼mÃ¼',0),(323645,8991,'pl','ZamÃ³wienia otwarte - waga widok',0),(323646,8991,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Open - Ñ‚ÐµÐ³Ð»Ð¾ Ð¸Ð·Ð³Ð»ÐµÐ´',0),(323647,8991,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ú¾ÙˆÙ„ÛŒÚº - ÙˆØ²Ù† Ù…Ù†Ø¸Ø±',0),(323648,8991,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸ - Ñ‚ÐµÐ¶Ð¸Ð½Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·',0),(323649,8991,'vi','Xem Ä‘Æ¡n hÃ ng má»Ÿ',0),(323650,8991,'af','Oop Bestelling Gewig Besigtig',0),(323651,8991,'ro','Ordinele deschise - greutate Vezi',0),(323652,8991,'et','Tellimuste Open - kaal vaade',0),(323653,8991,'si','NaroÄila Open - teÅ¾a pogled',0),(323654,8991,'ba','Perintah Open - berat View',0),(323655,8991,'nl','Bestellingen Open - gewicht weergave',0),(323656,8991,'fi','Tilaukset Avaa - paino nÃ¤kymÃ¤',0),(323657,8991,'no','Bestillinger Ã¥pen - vekt visning',0),(323658,8991,'da','Ordrer Open - vÃ¦gt Se',0),(323659,8991,'ko','ì£¼ë¬¸ ì˜¤í”ˆ-ë¬´ê²Œ ë³´ê¸°',0),(323660,8991,'he','×”×–×ž× ×•×ª ×”×¤×ª×•×—×” - ×ž×©×§×œ ×ª×¦×•×’×”',0),(323661,8991,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Open - Î²Î¬ÏÎ¿Ï‚ Î¸Î­Î±',0),(323662,8991,'zh','æœªç»“è®¢å•é‡é‡æŸ¥çœ‹\r\n',0),(323663,8991,'sv','BestÃ¤llningar Ã¶ppna - vikt Visa',0),(323664,8991,'it','Ordini aperti - visualizzazione del peso',0),(323665,8991,'tl','',0),(323666,8991,'th','&#3604;&#3641;&#3588;&#3656;&#3634;&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3648;&#3611;&#3636;&#3604;',0),(323667,8991,'hi','à¤†à¤¦à¥‡à¤¶ à¤“à¤ªà¤¨ - à¤µà¤œà¤¨ à¤¦à¥ƒà¤¶à¥à¤¯',0),(323668,8991,'ms','Perintah terbuka - lihat berat badan',0),(323669,8991,'ar','Ø£ÙˆØ§Ù…Ø± ÙØªØ­-Ø¹Ø±Ø¶ Ø§Ù„ÙˆØ²Ù†',0),(323670,8991,'fr','Commandes ouvertes - vue de poids',0),(323671,8991,'jp','æ³¨æ–‡ã‚ªãƒ¼ãƒ—ãƒ³ - é‡é‡ãƒ“ãƒ¥ãƒ¼',0),(323672,8991,'pt','Ordens Open - View de peso',0),(323673,8991,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Open - Ð²ÐµÑ Ð²Ð¸Ð´',0),(323674,8991,'es','Vista de Peso de Pedido Abierto',0),(323675,8991,'de','Bestellungen Open - Gewicht anzeigen',0),(323676,8991,'en','Orders Open - Weight View',0),(323677,8992,'is','',0),(323678,8992,'dr','Ø´Ù‡Ø± Ø­Ù…Ù„ ',0),(323679,8992,'pr','Ø´Ù‡Ø± Ø­Ù…Ù„ ',0),(323680,8992,'tr','Sevk ÅŸehir',0),(323681,8992,'pl','Miasto odbiorcy',0),(323682,8992,'bg','Ð“Ñ€Ð°Ð´ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(323683,8992,'ur','Ø¬ÛØ§Ø² Ø´ÛØ±',0),(323684,8992,'sr','Ð“Ñ€Ð°Ð´ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ðµ',0),(323685,8992,'vi','Chuyá»ƒn Ä‘áº¿n thÃ nh phá»‘ ',0),(323686,8992,'af','Versendingsdorp',0),(323687,8992,'ro','Nava City',0),(323688,8992,'et','Tarne linn',0),(323689,8992,'si','Kraj prejemnika',0),(323690,8992,'ba','Kota kapal',0),(323691,8992,'nl','Verzendplaats',0),(323692,8992,'fi','Toimipaikka',0),(323693,8992,'no','Mottakers poststed',0),(323694,8992,'da','Skibet City',0),(323695,8992,'ko','ë„ì‹œëª…',0),(323696,8992,'he','×”×¡×¤×™× ×” ×”×¢×™×¨',0),(323697,8992,'el','Î ÏŒÎ»Î· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(323698,8992,'zh','èˆªè¿åŸŽå¸‚\r\n',0),(323699,8992,'sv','Leveransort',0),(323700,8992,'it','CittÃ  di nave',0),(323701,8992,'tl','',0),(323702,8992,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3629;&#3635;&#3648;&#3616;&#3629;',0),(323703,8992,'hi','à¤œà¤¹à¤¾à¤œ à¤¶à¤¹à¤°',0),(323704,8992,'ms','Bandar kapal',0),(323705,8992,'ar','Ù…Ø¯Ø¨Ù†Ø© Ø§Ù„Ø´Ø­Ù†',0),(323706,8992,'fr','Ville d\'expÃ©dition',0),(323707,8992,'jp','å‡ºè·å…ˆå¸‚åŒºç”ºæ‘',0),(323708,8992,'pt','Cidade de navio',0),(323709,8992,'ru','Ð“Ð¾Ñ€Ð¾Ð´ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(323710,8992,'es','Ciudad de EnvÃ­o',0),(323711,8992,'de','Lieferort',0),(323712,8992,'en','Ship City',0),(323713,8993,'is','',0),(323714,8993,'dr','Ù†Ø§Ù… Ø­Ù…Ù„ ',0),(323715,8993,'pr','Ù†Ø§Ù… Ø­Ù…Ù„ ',0),(323716,8993,'tr','Gemi adÄ±',0),(323717,8993,'pl','Nazwa statku',0),(323718,8993,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð°',0),(323719,8993,'ur','Ø¬ÛØ§Ø² Ú©Ø§ Ù†Ø§Ù…',0),(323720,8993,'sr','Ð˜Ð¼Ðµ Ð±Ñ€Ð¾Ð´Ð°',0),(323721,8993,'vi','TÃªn chuyá»ƒn',0),(323722,8993,'af','Versend Naam',0),(323723,8993,'ro','Numele navei',0),(323724,8993,'et','Laeva nimi',0),(323725,8993,'si','Ime prejemnika',0),(323726,8993,'ba','Nama kapal',0),(323727,8993,'nl','Schip naam',0),(323728,8993,'fi','Aluksen nimi',0),(323729,8993,'no','Mottakers navn',0),(323730,8993,'da','Skibets navn',0),(323731,8993,'ko','ì„ ë°• ì´ë¦„',0),(323732,8993,'he','×©× ×”×¡×¤×™× ×”',0),(323733,8993,'el','ÎŒÎ½Î¿Î¼Î± Ï€Î»Î¿Î¯Î¿Ï…',0),(323734,8993,'zh','è¿é€åç§°\r\n',0),(323735,8993,'sv','Fartygets namn',0),(323736,8993,'it','Nome della nave',0),(323737,8993,'tl','',0),(323738,8993,'th','&#3594;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(323739,8993,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤¾ à¤¨à¤¾à¤®',0),(323740,8993,'ms','Nama kapal',0),(323741,8993,'ar','Ø§Ø³Ù… Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(323742,8993,'fr','Nom de navire',0),(323743,8993,'jp','èˆ¹ã®åå‰',0),(323744,8993,'pt','Nome do navio',0),(323745,8993,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»Ñ',0),(323746,8993,'es','Nombre de EnvÃ­o',0),(323747,8993,'de','Schiffsname',0),(323748,8993,'en','Ship Name',0),(323749,8994,'is','',0),(323750,8994,'dr','ÙˆØ¶Ø¹ÙŠØª Ø­Ù…Ù„',0),(323751,8994,'pr','ÙˆØ¶Ø¹ÙŠØª Ø­Ù…Ù„',0),(323752,8994,'tr','Geminin durumu',0),(323753,8994,'pl','Statek PaÅ„stwa',0),(323754,8994,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð°',0),(323755,8994,'ur','Ø¬ÛØ§Ø² Ø±ÛŒØ§Ø³Øª',0),(323756,8994,'sr','Ð¡Ñ‚Ð°ÑšÐµ Ð±Ñ€Ð¾Ð´Ð°',0),(323757,8994,'vi','Chuyá»ƒn Ä‘áº¿n bang',0),(323758,8994,'af','Versend Staat (Landsgebied)',0),(323759,8994,'ro','NavÄƒ de stat',0),(323760,8994,'et','Tarne osariik',0),(323761,8994,'si','Zvezna drÅ¾ava prejemnika',0),(323762,8994,'ba','Kapal negara',0),(323763,8994,'nl','Schip staat',0),(323764,8994,'fi','Aluksen valtion',0),(323765,8994,'no','Mottakers',0),(323766,8994,'da','Skibets tilstand',0),(323767,8994,'ko','ë°° ìƒíƒœ',0),(323768,8994,'he','×ž×“×™× ×ª ×ž×©×œ×•×—',0),(323769,8994,'el','Î Î»Î¿Î¯Î¿ ÎºÏÎ¬Ï„Î¿Ï…Ï‚',0),(323770,8994,'zh','è¿é€çŠ¶æ€\r\n',0),(323771,8994,'sv','Fartyget tillstÃ¥nd',0),(323772,8994,'it','Stato di nave',0),(323773,8994,'tl','',0),(323774,8994,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(323775,8994,'hi','à¤œà¤¹à¤¾à¤œ à¤°à¤¾à¤œà¥à¤¯',0),(323776,8994,'ms','Keadaan kapal',0),(323777,8994,'ar','Ø³ÙÙŠÙ†Ø© Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(323778,8994,'fr','Ã‰tat du navire',0),(323779,8994,'jp','ç™ºé€å…ˆéƒ½é“åºœçœŒ',0),(323780,8994,'pt','Estado de navio',0),(323781,8994,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ ÑÑƒÐ´Ð½Ð°',0),(323782,8994,'es','Estado de EnvÃ­o',0),(323783,8994,'de','Schiff Zustand',0),(323784,8994,'en','Ship State',0),(323785,8995,'is','',0),(323786,8995,'dr','( Ø§Ø±Ø³Ø§Ù„ ) Ú©ÙˆØ¯ Ù¾Ø³ØªÙŠ',0),(323787,8995,'pr','Ø­Ù…Ù„( Ø§Ø±Ø³Ø§Ù„ ) ÙƒØ¯ Ù¾Ø³ØªÙŠ',0),(323788,8995,'tr','Gemi ZIP',0),(323789,8995,'pl','Statek Zip',0),(323790,8995,'bg','ÐšÐ¾Ñ€Ð°Ð± Zip',0),(323791,8995,'ur','Ø¬ÛØ§Ø² Ø²Ù¾',0),(323792,8995,'sr','Ð‘Ñ€Ð¾Ð´ Ð—Ð¸Ð¿',0),(323793,8995,'vi','Zip chuyá»ƒn Ä‘áº¿n',0),(323794,8995,'af','Versend Zip',0),(323795,8995,'ro','Nava Zip',0),(323796,8995,'et','Laeva Zip',0),(323797,8995,'si','Ladji Zip',0),(323798,8995,'ba','Kapal Zip',0),(323799,8995,'nl','Schip Zip',0),(323800,8995,'fi','Aluksen Zip',0),(323801,8995,'no','Skipet Zip',0),(323802,8995,'da','Skibet Zip',0),(323803,8995,'ko','ì„ ë°• ìš°íŽ¸',0),(323804,8995,'he','×”×¡×¤×™× ×” Zip',0),(323805,8995,'el','Î Î»Î¿Î¯Î¿ Zip',0),(323806,8995,'zh','èˆªè¿é‚®ç¼–\r\n',0),(323807,8995,'sv','Fartyget Zip',0),(323808,8995,'it','Nave Zip',0),(323809,8995,'tl','',0),(323810,8995,'th','&#3586;&#3609;&#3626;&#3656;&#3591;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;',0),(323811,8995,'hi','à¤œà¤¹à¤¾à¤œ à¤œà¤¼à¤¿à¤ª',0),(323812,8995,'ms','Kapal Zip',0),(323813,8995,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(323814,8995,'fr','Navire Zip',0),(323815,8995,'jp','Zip ã‚’å‡ºè·ã—ã¾ã™ã€‚',0),(323816,8995,'pt','Navio Zip',0),(323817,8995,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Zip',0),(323818,8995,'es','CÃ³digo Postal de EnvÃ­o',0),(323819,8995,'de','Schiff-Zip',0),(323820,8995,'en','Ship Zip',0),(323821,8996,'is','',0),(323822,8996,'dr','Ø±Ø³ÙŠØ¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(323823,8996,'pr','Ø±Ø³ÙŠØ¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(323824,8996,'tr','PO makbuz',0),(323825,8996,'pl','PO otrzymaniu',0),(323826,8996,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ° Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ°',0),(323827,8996,'ur','Ù¾Ùˆ Ø±Ø³ÛŒØ¯',0),(323828,8996,'sr','ÐŸÐž Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ñ†Ð°',0),(323829,8996,'vi','BiÃªn nháº­n Ä‘Æ¡n mua hÃ ng',0),(323830,8996,'af','Posbus ontvangs',0),(323831,8996,'ro','Primirea PO',0),(323832,8996,'et','PO kÃ¤tte',0),(323833,8996,'si','PO prejemu',0),(323834,8996,'ba','Terima PO',0),(323835,8996,'nl','PO ontvangst',0),(323836,8996,'fi','PO kuitti',0),(323837,8996,'no','PO mottak',0),(323838,8996,'da','PO modtagelse',0),(323839,8996,'ko','PO ì˜ìˆ˜ì¦',0),(323840,8996,'he','×¤×• ×§×‘×œ×”',0),(323841,8996,'el','Î Î±ÏÎ±Î»Î±Î²Î® PO',0),(323842,8996,'zh','è®¢å•æ”¶æ®\r\n',0),(323843,8996,'sv','PO kvitto',0),(323844,8996,'it','PO ricevuta',0),(323845,8996,'tl','',0),(323846,8996,'th','&#3619;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(323847,8996,'hi','PO à¤°à¤¸à¥€à¤¦',0),(323848,8996,'ms','Resit PO',0),(323849,8996,'ar','ØªØ³Ù„Ù… Ø¨Ùˆ',0),(323850,8996,'fr','RÃ©ception de PO',0),(323851,8996,'jp','PO ã®å—é ˜',0),(323852,8996,'pt','Recibo de PO',0),(323853,8996,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ðµ PO',0),(323854,8996,'es','PDV Recibo',0),(323855,8996,'de','PO-Eingang',0),(323856,8996,'en','PO Receipt',0),(323857,8997,'is','',0),(323858,8997,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¹Ø¶Ø§ÙŠ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(323859,8997,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¹Ø¶Ø§ÙŠ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(323860,8997,'tr','Madde aile Ã¼yeleri Ekle',0),(323861,8997,'pl','Dodaj element czÅ‚onkÃ³w rodziny',0),(323862,8997,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ Ñ‡Ð»ÐµÐ½Ð¾Ð²Ðµ Ð½Ð° ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(323863,8997,'ur','Ø´Û’ Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Û’ Ø§ÙØ±Ø§Ø¯ Ù…ÛŒÚº Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(323864,8997,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ‡Ð»Ð°Ð½Ð¾Ð²Ð° Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(323865,8997,'vi','ThÃªm Danh Má»¥c Cho DÃ²ng HÃ ng HÃ³a Gia ÄÃ¬nh ',0),(323866,8997,'af','Item Familielede Byvoeg',0),(323867,8997,'ro','Adauga articol membrii familiei',0),(323868,8997,'et','Kirje perekonna liikmete lisamine',0),(323869,8997,'si','Dodajte element druÅ¾inskih Älanov',0),(323870,8997,'ba','Tambahkan Item anggota keluarga',0),(323871,8997,'nl','Item familie leden toevoegen',0),(323872,8997,'fi','LisÃ¤Ã¤ kohteen perheenjÃ¤senet',0),(323873,8997,'no','Legg til element familiemedlemmer',0),(323874,8997,'da','TilfÃ¸j vare familiemedlemmer',0),(323875,8997,'ko','í•­ëª© ê°€ì¡± êµ¬ì„±ì› ì¶”ê°€',0),(323876,8997,'he','×”×•×¡×£ ×¤×¨×™×˜ ×‘× ×™ ×ž×©×¤×—×”',0),(323877,8997,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¼Î­Î»Î· Ï„Î·Ï‚ Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î±Ï‚',0),(323878,8997,'zh','å¢žåŠ é¡¹ç›®æˆå“¡ç³»åˆ—\r\n',0),(323879,8997,'sv','LÃ¤gga till objekt familjemedlemmar',0),(323880,8997,'it','Aggiungi elemento familiari',0),(323881,8997,'tl','',0),(323882,8997,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3617;&#3634;&#3594;&#3636;&#3585;&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3633;&#3623;',0),(323883,8997,'hi','à¤ªà¤°à¤¿à¤µà¤¾à¤° à¤•à¥‡ à¤¸à¤¦à¤¸à¥à¤¯à¥‹à¤‚ à¤•à¥‹ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(323884,8997,'ms','Tambah ahli keluarga Item',0),(323885,8997,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¨Ù†Ø¯ Ø£ÙØ±Ø§Ø¯ Ø§Ù„Ø£Ø³Ø±Ø©',0),(323886,8997,'fr','Ajouter Membres de Famille',0),(323887,8997,'jp','é …ç›®ã®å®¶æ—ã®ãƒ¡ãƒ³ãƒãƒ¼ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(323888,8997,'pt','Adicionar Item de familiares',0),(323889,8997,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ‡Ð»ÐµÐ½Ð¾Ð² ÑÐµÐ¼ÑŒÐ¸',0),(323890,8997,'es','Agregar Item Miembros de la Familia',0),(323891,8997,'de','Element Familienmitglieder hinzufÃ¼gen',0),(323892,8997,'en','Add Item Family Members',0),(323893,8998,'is','',0),(323894,8998,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(323895,8998,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ',0),(323896,8998,'tr','Aile Ã¶ÄŸeler',0),(323897,8998,'pl','Rodzina elementÃ³w',0),(323898,8998,'bg','Ð¡ÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(323899,8998,'ur','Ø®Ø§Ù†Ø¯Ø§Ù† Ø§Ø´ÛŒØ§Ø¡',0),(323900,8998,'sr','ÐŸÐ¾Ñ€Ð¾Ð´Ð¸Ñ†Ð° ÑÑ‚Ð°Ð²ÐºÐµ',0),(323901,8998,'vi','DÃ²ng hÃ ng gia Ä‘Ã¬nh',0),(323902,8998,'af','Familie Items',0),(323903,8998,'ro','Elemente de familie',0),(323904,8998,'et','Pere Ã¼ksused',0),(323905,8998,'si','DruÅ¾inski elementov',0),(323906,8998,'ba','Barang-barang keluarga',0),(323907,8998,'nl','Familie Items',0),(323908,8998,'fi','Family kohteita',0),(323909,8998,'no','Familie elementer',0),(323910,8998,'da','Familie elementer',0),(323911,8998,'ko','ê°€ì¡± ìƒí’ˆ',0),(323912,8998,'he','×¤×¨×™×˜×™× ×ž×©×¤×—×”',0),(323913,8998,'el','ÎŸÎ¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(323914,8998,'zh','å®¶åº­é¡¹ç›®\r\n',0),(323915,8998,'sv','Familjen objekt',0),(323916,8998,'it','Voci di famiglia',0),(323917,8998,'tl','',0),(323918,8998,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3633;&#3623;',0),(323919,8998,'hi','à¤ªà¤¾à¤°à¤¿à¤µà¤¾à¤°à¤¿à¤• à¤†à¤‡à¤Ÿà¤®',0),(323920,8998,'ms','Butiran keluarga',0),(323921,8998,'ar','Ø£ØµÙ†Ø§Ù Ø§Ù„ÙØµÙŠÙ„Ø©',0),(323922,8998,'fr','Ã‰lÃ©ments de la familles',0),(323923,8998,'jp','å®¶æ—ã®é …ç›®',0),(323924,8998,'pt','FamÃ­lia itens',0),(323925,8998,'ru','Ð¡ÐµÐ¼ÑŒÐ¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹',0),(323926,8998,'es','Items de Familia',0),(323927,8998,'de','Familie Elemente',0),(323928,8998,'en','Family Items',0),(323929,8999,'is','',0),(323930,8999,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(323931,8999,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(323932,8999,'tr','SipariÅŸ iÃ§in Ã¶ÄŸeler ekleme',0),(323933,8999,'pl','Dodaj elementy na zamÃ³wienie',0),(323934,8999,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ ÐºÑŠÐ¼ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(323935,8999,'ur','Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§Ø´ÛŒØ§Ø¡ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(323936,8999,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ñƒ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´Ñƒ',0),(323937,8999,'vi','ThÃªm HÃ ng cho ÄÆ¡n Äáº·t HÃ ng',0),(323938,8999,'af','Items om te Bestel Byvoeg',0),(323939,8999,'ro','Adauga articole la Comanda',0),(323940,8999,'et','Lisa tellimusele tooteid',0),(323941,8999,'si','Dodajte elemente v vrstnem redu',0),(323942,8999,'ba','Menambahkan item ke urutan',0),(323943,8999,'nl','Items toevoegen aan bestelling',0),(323944,8999,'fi','LisÃ¤Ã¤ nimikkeet tilaukseen',0),(323945,8999,'no','Legge til varer i ordre',0),(323946,8999,'da','FÃ¸je varer til ordre',0),(323947,8999,'ko','ì£¼ë¬¸ í•­ëª© ì¶”ê°€',0),(323948,8999,'he','×”×•×¡×£ ×¤×¨×™×˜×™× ×œ×”×–×ž× ×”',0),(323949,8999,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î·',0),(323950,8999,'zh','å¢žåŠ è¨‚è³¼é¡¹ç›®\r\n',0),(323951,8999,'sv','LÃ¤gga till objekt i ordning',0),(323952,8999,'it','Aggiungere elementi all\'ordine',0),(323953,8999,'tl','',0),(323954,8999,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(323955,8999,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(323956,8999,'ms','Menambah item ke perintah',0),(323957,8999,'ar','Ø¥Ø¶Ø§ÙØ© Ø£ØµÙ†Ø§Ù Ø¥Ù„Ù‰ Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(323958,8999,'fr','Ajouter Items a une Commande',0),(323959,8999,'jp','æ³¨æ–‡ã«ã‚¢ã‚¤ãƒ†ãƒ ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(323960,8999,'pt','Adicionar itens Ã  ordem',0),(323961,8999,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€ Ð² Ð—Ð°ÐºÐ°Ð·',0),(323962,8999,'es','Agregar Items para Pedir',0),(323963,8999,'de','HinzufÃ¼gen von Elementen zur Bestellung',0),(323964,8999,'en','Add Items to Order',0),(323965,9000,'is','',0),(323966,9000,'dr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ù„Ø§ÙŠÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(323967,9000,'pr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ù„Ø§ÙŠÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(323968,9000,'tr','HiÃ§bir Ã¶ÄŸe kimliÄŸi henÃ¼z belirlenmedi',0),(323969,9000,'pl','Brak identyfikatora elementu zostaÅ‚a ustawiona',0),(323970,9000,'bg','ÐÑÐ¼Ð° Ð˜Ð” Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ðµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð°',0),(323971,9000,'ur','Ú©Ø³ÛŒ Ø´Û’ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª Ù…Ù‚Ø±Ø± Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(323972,9000,'sr','ÐÐµÐ¼Ð° Ð˜Ð” ÑÑ‚Ð°Ð²ÐºÐµ Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(323973,9000,'vi','ChÆ°a láº­p ID hÃ ng ',0),(323974,9000,'af','Geen Item ID is opgestel',0),(323975,9000,'ro','S-a stabilit nici un ID element',0),(323976,9000,'et','MÃ¤Ã¤ra kirje ID',0),(323977,9000,'si','Je bil doloÄen noben ID elementa',0),(323978,9000,'ba','Ada ID Item telah ditetapkan',0),(323979,9000,'nl','Geen object-ID is ingesteld',0),(323980,9000,'fi','Ei kohteen tunnusta ei ole mÃ¤Ã¤ritetty',0),(323981,9000,'no','Ingen vare-ID er angitt',0),(323982,9000,'da','Ingen vare-ID er angivet',0),(323983,9000,'ko','í•­ëª© IDëŠ” ì„¤ì •',0),(323984,9000,'he','×ž×–×”×” ×¤×¨×™×˜ ×œ× ×”×•×’×“×¨',0),(323985,9000,'el','Î˜Î­ÏƒÎ· ID Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(323986,9000,'zh','æ²¡æœ‰è®¾å®šé¡¹ç›®ç¼–å·\r\n',0),(323987,9000,'sv','Inget objekt-ID har angetts',0),(323988,9000,'it','Non Ã¨ stato impostato un ID per questo oggetto.',0),(323989,9000,'tl','',0),(323990,9000,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3652;&#3623;&#3657;',0),(323991,9000,'hi','à¤•à¥‹à¤ˆ à¤†à¤‡à¤Ÿà¤® ID à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚.',0),(323992,9000,'ms','Tiada ID Item telah ditetapkan',0),(323993,9000,'ar','ÙˆÙ‚Ø¯ ØªÙ… ØªØ¹ÙŠÙŠÙ† Ù„Ø§ Ù…Ø¹Ø±Ù Ø¹Ù†ØµØ±',0),(323994,9000,'fr','Aucun ID de l\'Ã©lÃ©ment n\'a Ã©tÃ© dÃ©fini',0),(323995,9000,'jp','é …ç›® ID ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(323996,9000,'pt','Nenhuma ID de Item tiver sido definido.',0),(323997,9000,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð½Ðµ Ð±Ñ‹Ð» ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(323998,9000,'es','No HabÃ­a Item ID Configurado',0),(323999,9000,'de','Keine Element-ID wurde festgelegt.',0),(324000,9000,'en','No Item ID Has Been Set',0),(324001,9001,'is','',0),(324002,9001,'dr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø±',0),(324003,9001,'pr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø±',0),(324004,9001,'tr','Fatura her',0),(324005,9001,'pl','Zapowiadane co',0),(324006,9001,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸ Ð²ÑÐµÐºÐ¸',0),(324007,9001,'ur','Ø¨Ø§Ù„Ù„Ø§Ø¯ ÛØ±',0),(324008,9001,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÐµÐ½ ÑÐ²Ð°ÐºÐ¸',0),(324009,9001,'vi','Láº­p HÃ³a ÄÆ¡n Táº¥t Cáº£',0),(324010,9001,'af','WeerspieÃ«l elke',0),(324011,9001,'ro','Facturat fiecare',0),(324012,9001,'et','Arve iga',0),(324013,9001,'si','ZaraÄunali vsak',0),(324014,9001,'ba','Ditagih setiap',0),(324015,9001,'nl','Gefactureerd elke',0),(324016,9001,'fi','Laskutetaan jokaisen',0),(324017,9001,'no','Fakturert hver',0),(324018,9001,'da','Faktureret hver',0),(324019,9001,'ko','ì²­êµ¬ ëœ ëª¨ë“ ',0),(324020,9001,'he','×—×•×™×‘ ×›×œ',0),(324021,9001,'el','Î§ÏÎµÏŽÎ½ÎµÏ„Î±Î¹ ÎºÎ¬Î¸Îµ',0),(324022,9001,'zh','å¸å•æ¯\r\n',0),(324023,9001,'sv','Faktureras varje',0),(324024,9001,'it','Fatturati ogni',0),(324025,9001,'tl','',0),(324026,9001,'th','&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3607;&#3640;&#3585;&#3654;',0),(324027,9001,'hi','à¤¬à¤¿à¤² à¤•à¤¿à¤¯à¤¾ à¤¹à¤°',0),(324028,9001,'ms','Dibilkan setiap',0),(324029,9001,'ar','ÙˆØµÙØª ÙƒÙ„',0),(324030,9001,'fr','A facturÃ© Ã  chaque',0),(324031,9001,'jp','è«‹æ±‚æ¯Ž',0),(324032,9001,'pt','Faturado cada',0),(324033,9001,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÐºÐ°Ð¶Ð´Ñ‹Ðµ',0),(324034,9001,'es','Facturado cada',0),(324035,9001,'de','Rechnung gestellt alle',0),(324036,9001,'en','Billed every',0),(324037,9002,'is','',0),(324038,9002,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(324039,9002,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(324040,9002,'tr','SÃ¶zleÅŸmenin toplam',0),(324041,9002,'pl','Suma zamÃ³wienia',0),(324042,9002,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð° Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(324043,9002,'ur','Ù…Ø¹Ø§ÛØ¯Û’ Ú©ÛŒ Ú©Ù„',0),(324044,9002,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð° ÑƒÐ³Ð¾Ð²Ð¾Ñ€',0),(324045,9002,'vi','Tá»•ng cá»™ng há»£p Ä‘á»“ng',0),(324046,9002,'af','Kontrak Totaal',0),(324047,9002,'ro','Contractul Total',0),(324048,9002,'et','Kokku arveks',0),(324049,9002,'si','Pogodbe skupno',0),(324050,9002,'ba','Total kontrak',0),(324051,9002,'nl','Contract totaal',0),(324052,9002,'fi','Sopimus yhteensÃ¤',0),(324053,9002,'no','Kontrakten totalt',0),(324054,9002,'da','Kontraktens samlede',0),(324055,9002,'ko','ê³„ì•½ ì´',0),(324056,9002,'he','×¡×” ×› ×”×—×•×–×”',0),(324057,9002,'el','Î£ÏÎ¼Î²Î±ÏƒÎ· ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(324058,9002,'zh','åˆåŒæ€»\r\n',0),(324059,9002,'sv','Kontrakt totalt',0),(324060,9002,'it','Totale del contratto',0),(324061,9002,'tl','',0),(324062,9002,'th','&#3626;&#3633;&#3597;&#3597;&#3634;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(324063,9002,'hi','à¤…à¤¨à¥à¤¬à¤‚à¤§ à¤•à¥à¤²',0),(324064,9002,'ms','Jumlah kontrak',0),(324065,9002,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø¹Ù‚ÙˆØ¯',0),(324066,9002,'fr','Contrat Total',0),(324067,9002,'jp','å¥‘ç´„ã®åˆè¨ˆ',0),(324068,9002,'pt','Total do contrato',0),(324069,9002,'ru','Ð’ÑÐµÐ³Ð¾ ÐºÐ¾Ð½Ñ‚Ñ€Ð°ÐºÑ‚Ð°',0),(324070,9002,'es','Total de Contrato',0),(324071,9002,'de','Vertrag insgesamt',0),(324072,9002,'en','Contract Total',0),(324073,9003,'is','',0),(324074,9003,'dr','Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†ÙƒÙ†ÙŠØ¯ ',0),(324075,9003,'pr','Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†ÙƒÙ†ÙŠØ¯ ',0),(324076,9003,'tr','Arama iÃ§in kullanmayÄ±n',0),(324077,9003,'pl','Nie naleÅ¼y uÅ¼ywaÄ‡ do wyszukiwania',0),(324078,9003,'bg','ÐÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(324079,9003,'ur','Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù†ÛÛŒÚº Ú©Ø±ØªÛ’ Û”',0),(324080,9003,'sr','ÐÐµÐ¼Ð¾Ñ˜Ñ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(324081,9003,'vi','Äá»«ng dÃ¹ng cho tÃ¬m kiáº¿m',0),(324082,9003,'af','Moenie die Soekfuksie Gebruik',0),(324083,9003,'ro','Nu utilizaÅ£i de cÄƒutare',0),(324084,9003,'et','Kasuta otsinguks',0),(324085,9003,'si','Ne uporabljajte za iskanje',0),(324086,9003,'ba','Jangan gunakan untuk Cari',0),(324087,9003,'nl','Gebruik geen voor zoeken',0),(324088,9003,'fi','KÃ¤ytÃ¤ Etsi',0),(324089,9003,'no','Ikke bruk for sÃ¸k',0),(324090,9003,'da','Brug ikke for sÃ¸gning',0),(324091,9003,'ko','ê²€ìƒ‰ì„ ì‚¬ìš© í•˜ì§€ ë§ˆì‹­ì‹œì˜¤',0),(324092,9003,'he','××œ ×ª×©×ª×ž×© ×¢×‘×•×¨ ×—×™×¤×•×©',0),(324093,9003,'el','ÎœÎ·Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Î³Î¹Î± Ï„Î·Î½ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(324094,9003,'zh','ä¸ç”¨ä½œæœç´¢\r\n',0),(324095,9003,'sv','AnvÃ¤nd inte fÃ¶r SÃ¶k',0),(324096,9003,'it','Non utilizzare per la ricerca',0),(324097,9003,'tl','',0),(324098,9003,'th','&#3629;&#3618;&#3656;&#3634;&#3651;&#3594;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;&#3588;&#3657;&#3609;&#3627;&#3634;',0),(324099,9003,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤¨ à¤•à¤°à¥‡à¤‚',0),(324100,9003,'ms','Jangan gunakan untuk carian',0),(324101,9003,'ar','Ù„Ø§ ØªØ³ØªØ®Ø¯Ù… Ù„Ù„Ø¨Ø­Ø«',0),(324102,9003,'fr','Ne pas utiliser pour la recherche',0),(324103,9003,'jp','æ¤œç´¢ã‚’ä½¿ç”¨ã—ã¾ã›ã‚“ã€‚',0),(324104,9003,'pt','NÃ£o Use para Pesquisar',0),(324105,9003,'ru','ÐÐµ Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ð»Ñ ÐŸÐ¾Ð¸ÑÐºÐ°',0),(324106,9003,'es','No Usa para la Busqueda',0),(324107,9003,'de','Verwenden Sie nicht fÃ¼r die Suche',0),(324108,9003,'en','Do Not Use for Search',0),(324109,9004,'is','',0),(324110,9004,'dr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬ÙˆÙŠ Ù¾Ø±ÙˆÚ˜Ù‡',0),(324111,9004,'pr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬ÙˆÙŠ Ù¾Ø±ÙˆÚ˜Ù‡',0),(324112,9004,'tr','Proje arama iÃ§in arama bilgi girin',0),(324113,9004,'pl','WprowadÅº informacje o wyszukiwania dla wyszukiwania projektu',0),(324114,9004,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(324115,9004,'ur','Ú©Û’ Ù…Ù†ØµÙˆØ¨Û’ Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº ØªÙ„Ø§Ø´ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(324116,9004,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð˜Ð½Ñ„Ð¾ Ð·Ð° Ð¿Ñ€Ð¾Ñ˜ÐµÐºÐ°Ñ‚ Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(324117,9004,'vi','Nháº­p thÃ´ng tin tÃ¬m kiáº¿m dá»± Ã¡n',0),(324118,9004,'af','Voer Soektog Inligting in vir Projek Opsoek',0),(324119,9004,'ro','IntroduceÅ£i informaÅ£ii de cÄƒutare pentru proiectul Lookup',0),(324120,9004,'et','Sisestage Otsi Info projekti otsing',0),(324121,9004,'si','Vnesite iskanje informacij za projekt za iskanje',0),(324122,9004,'ba','Masukkan Cari Info untuk proyek Lookup',0),(324123,9004,'nl','Zoek Info Voer voor Project Lookup',0),(324124,9004,'fi','Kirjoita haku Info Projektihaku',0),(324125,9004,'no','Angi sÃ¸k Info for prosjektet oppslag',0),(324126,9004,'da','Indtast sÃ¸gning Info for projektet opslag',0),(324127,9004,'ko','í”„ë¡œì íŠ¸ ì¡°íšŒì— ëŒ€ í•œ ê²€ìƒ‰ ì •ë³´ë¥¼ ìž…ë ¥',0),(324128,9004,'he','×”×–×Ÿ ×—×™×¤×•×© ×ž×™×“×¢ ×¢×‘×•×¨ ×¤×¨×•×™×™×§×˜ ×‘×“×™×§×ª ×ž×™×“×¢',0),(324129,9004,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î·Î½ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î­ÏÎ³Î¿Ï…',0),(324130,9004,'zh','è¾“å…¥æœç´¢é¡¹ç›®æŸ¥è¯¢ä¿¡æ¯\r\n',0),(324131,9004,'sv','Ange SÃ¶k information fÃ¶r projektet Lookup',0),(324132,9004,'it','Inserisci i dati di ricerca per progetto di ricerca',0),(324133,9004,'tl','',0),(324134,9004,'th','&#3611;&#3657;&#3629;&#3609;&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3604;&#3641;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(324135,9004,'hi','à¤ªà¥à¤°à¥‹à¤œà¥‡à¤•à¥à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥à¤•à¤…à¤ª à¤–à¥‹à¤œ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(324136,9004,'ms','Masukkan maklumat carian untuk Lookup projek',0),(324137,9004,'ar','Ø£Ø¯Ø®Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¨Ø­Ø« Ù„Ø¨Ø­Ø« Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(324138,9004,'fr','Entrez la recherche dâ€™informations pour les recherches de projets',0),(324139,9004,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆå‚ç…§ã®æ¤œç´¢æƒ…å ±ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(324140,9004,'pt','Digite busca informaÃ§Ã£o para projeto de pesquisa',0),(324141,9004,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐŸÐ¾Ð¸ÑÐº Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð´Ð»Ñ Ð¿Ð¾Ð¸ÑÐºÐ° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(324142,9004,'es','Introducir Info de Busqueda Para Encontrar el Proyecto ',0),(324143,9004,'de','Geben Sie Suche Info fÃ¼r Projekt-Lookup',0),(324144,9004,'en','Enter Search Info for Project Lookup',0),(324145,9005,'is','',0),(324146,9005,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(324147,9005,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(324148,9005,'tr','Proje GÃ¼ncelleÅŸtir',0),(324149,9005,'pl','Projekt aktualizacji',0),(324150,9005,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(324151,9005,'ur','Ù¾Ø±ÙˆØ¬ÛŒÚ©Ù¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(324152,9005,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(324153,9005,'vi','Cáº­p Nháº­t Dá»± Ãn',0),(324154,9005,'af','Projek Opdateer',0),(324155,9005,'ro','Proiect Update',0),(324156,9005,'et','Projekti uuendamine',0),(324157,9005,'si','Posodobitev projekta',0),(324158,9005,'ba','Perkembangan proyek',0),(324159,9005,'nl','Update voor project',0),(324160,9005,'fi','Project pÃ¤ivitys',0),(324161,9005,'no','Prosjektoppdatering',0),(324162,9005,'da','Projekt Update',0),(324163,9005,'ko','í”„ë¡œì íŠ¸ ì—…ë°ì´íŠ¸',0),(324164,9005,'he','×¢×“×›×•×Ÿ project',0),(324165,9005,'el','Î•Ï€Î¹ÎºÎ±Î¹ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ· Ï„Î¿Ï… ÏƒÏ‡ÎµÎ´Î¯Î¿Ï…',0),(324166,9005,'zh','é¡¹ç›®æ›´æ–°\r\n',0),(324167,9005,'sv','Project Update',0),(324168,9005,'it','Aggiornamento del progetto',0),(324169,9005,'tl','',0),(324170,9005,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(324171,9005,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(324172,9005,'ms','Update projek',0),(324173,9005,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(324174,9005,'fr','Mise Ã  jour du projet',0),(324175,9005,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®æ›´æ–°',0),(324176,9005,'pt','AtualizaÃ§Ã£o de projeto',0),(324177,9005,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(324178,9005,'es','ActualizaciÃ³n de Proyecto',0),(324179,9005,'de','Projekt-Update',0),(324180,9005,'en','Project Update',0),(324181,9006,'is','',0),(324182,9006,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(324183,9006,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(324184,9006,'tr','Proje baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(324185,9006,'pl','Projekt pomyÅ›lnie zaktualizowana',0),(324186,9006,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚ÑŠÑ‚ Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(324187,9006,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(324188,9006,'sr','ÐŸÑ€Ð¾Ñ˜ÐµÐºÐ°Ñ‚ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(324189,9006,'vi','Cáº­p Nháº­t Dá»± Ãn ThÃ nh CÃ´ng',0),(324190,9006,'af','Projek Suksesvol Opdateer',0),(324191,9006,'ro','Proiect actualizat cu succes',0),(324192,9006,'et','Projekt on edukalt vÃ¤rskendatud',0),(324193,9006,'si','Projekt uspeÅ¡no posodobljena',0),(324194,9006,'ba','Proyek yang berhasil',0),(324195,9006,'nl','Project bijgewerkt',0),(324196,9006,'fi','Projekti on pÃ¤ivitetty onnistuneesti',0),(324197,9006,'no','Prosjektet oppdatert',0),(324198,9006,'da','Projekt opdateret',0),(324199,9006,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” í”„ë¡œì íŠ¸',0),(324200,9006,'he','×¤×¨×•×™×™×§×˜ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(324201,9006,'el','Î¤Î¿ Î­ÏÎ³Î¿ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(324202,9006,'zh','é¡¹ç›®æˆåŠŸæ›´æ–°\r\n',0),(324203,9006,'sv','Projektet uppdaterats',0),(324204,9006,'it','Progetto aggiornato con successo',0),(324205,9006,'tl','',0),(324206,9006,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(324207,9006,'hi','à¤ªà¥à¤°à¥‹à¤œà¥‡à¤•à¥à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(324208,9006,'ms','Projek yang berjaya dikemas kini',0),(324209,9006,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ù…Ø´Ø±ÙˆØ¹ Ø¨Ù†Ø¬Ø§Ø­',0),(324210,9006,'fr','Projet mis Ã  jour avec succÃ¨s',0),(324211,9006,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(324212,9006,'pt','Projeto atualizado com sucesso',0),(324213,9006,'ru','ÐŸÑ€Ð¾ÐµÐºÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(324214,9006,'es','Proyecto Actualizado Exitosamente',0),(324215,9006,'de','Projekt erfolgreich aktualisiert',0),(324216,9006,'en','Project Updated Successfully',0),(324217,9007,'is','',0),(324218,9007,'dr','Ø¨Ø±Ú¯Ø´Øª',0),(324219,9007,'pr','Ø¨Ø±Ú¯Ø´Øª',0),(324220,9007,'tr','Tersine Ã§evirme',0),(324221,9007,'pl','OdwrÃ³cenie',0),(324222,9007,'bg','ÐžÐ±Ñ€ÑŠÑ‰Ð°Ð½Ðµ',0),(324223,9007,'ur','Ø§Ù„Ù¹',0),(324224,9007,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ',0),(324225,9007,'vi','Viáº¿t ngÆ°á»£c',0),(324226,9007,'af','Ommekeer',0),(324227,9007,'ro','Inversare',0),(324228,9007,'et','PÃ¶Ã¶rdumise',0),(324229,9007,'si','Preobrat',0),(324230,9007,'ba','Pembalikan',0),(324231,9007,'nl','Omkering',0),(324232,9007,'fi','KÃ¤Ã¤ntyminen',0),(324233,9007,'no','Reversering',0),(324234,9007,'da','TilbagefÃ¸rsel',0),(324235,9007,'ko','ë°˜ì „',0),(324236,9007,'he','×”×™×¤×•×š',0),(324237,9007,'el','Î‘Î½Ï„Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(324238,9007,'zh','ç¿»è½¬\r\n',0),(324239,9007,'sv','Ã…terfÃ¶ring',0),(324240,9007,'it','Inversione',0),(324241,9007,'tl','',0),(324242,9007,'th','&#3588;&#3623;&#3634;&#3617;&#3612;&#3585;&#3612;&#3633;&#3609;',0),(324243,9007,'hi','à¤‰à¤¤à¥à¤•à¥à¤°à¤®à¤£',0),(324244,9007,'ms','Pembalikan',0),(324245,9007,'ar','Ø¹ÙƒØ³',0),(324246,9007,'fr','Inversion',0),(324247,9007,'jp','åè»¢',0),(324248,9007,'pt','ReversÃ£o',0),(324249,9007,'ru','Ð Ð°Ð·Ð²Ð¾Ñ€Ð¾Ñ‚',0),(324250,9007,'es','RevocaciÃ³n',0),(324251,9007,'de','Umkehr',0),(324252,9007,'en','Reversal',0),(324253,9008,'is','',0),(324254,9008,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡  Ù†ÙŠØ³Øª',0),(324255,9008,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´Ù†Ø¯Ù‡  Ù†ÙŠØ³Øª',0),(324256,9008,'tr','SatÄ±cÄ± eklenemedi',0),(324257,9008,'pl','Nie moÅ¼na dodaÄ‡ dostawcy',0),(324258,9008,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(324259,9008,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(324260,9008,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(324261,9008,'vi','KhÃ´ng thÃªm ngÆ°á»i bÃ¡n má»›i Ä‘Æ°á»£c',0),(324262,9008,'af','Kon handelaar byvoeg nie',0),(324263,9008,'ro','Nu ar putea adÄƒuga furnizor',0),(324264,9008,'et','Ei saanud tarnijat lisada',0),(324265,9008,'si','Ni bilo mogoÄe dodati dobavitelja',0),(324266,9008,'ba','Tidak dapat menambahkan Vendor',0),(324267,9008,'nl','Er kon geen leverancier toegevoegd',0),(324268,9008,'fi','Ei voi lisÃ¤tÃ¤ toimittajan',0),(324269,9008,'no','Kan ikke legge til leverandÃ¸r',0),(324270,9008,'da','Kunne ikke tilfÃ¸je kreditor',0),(324271,9008,'ko','ê³µê¸‰ ì—…ì²´ë¥¼ ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(324272,9008,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×”×•×¡×™×£ ×¡×¤×§',0),(324273,9008,'el','Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(324274,9008,'zh','æ— æ³•åŠ å…¥ä¾›åº”å•†\r\n',0),(324275,9008,'sv','Kunde inte lÃ¤gga till leverantÃ¶r',0),(324276,9008,'it','Impossibile aggiungere Vendor',0),(324277,9008,'tl','',0),(324278,9008,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3614;&#3636;&#3656;&#3617;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3652;&#3604;&#3657;',0),(324279,9008,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼ à¤¸à¤•à¤¤à¤¾',0),(324280,9008,'ms','Tidak dapat menambah penjual.',0),(324281,9008,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(324282,9008,'fr','Ne peut pas ajouter du vendeur',0),(324283,9008,'jp','ä»•å…¥å…ˆã‚’è¿½åŠ ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(324284,9008,'pt','NÃ£o foi possÃ­vel adicionar o fornecedor',0),(324285,9008,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(324286,9008,'es','No PodÃ­a Agregar un Proveedor',0),(324287,9008,'de','Hersteller konnte nicht hinzugefÃ¼gt werden.',0),(324288,9008,'en','Could Not Add Vendor',0),(324289,9009,'is','',0),(324290,9009,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ Ù†ÙŠØ³Øª',0),(324291,9009,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ Ù†ÙŠØ³Øª',0),(324292,9009,'tr','Yeni mÃ¼ÅŸteri eklenemedi',0),(324293,9009,'pl','Nie moÅ¼na dodaÄ‡ nowego klienta',0),(324294,9009,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(324295,9009,'ur','Ù†Ø¦Û’ Ú¯Ø§ÛÚ©ÙˆÚº Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(324296,9009,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð½Ð¾Ð²Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð°',0),(324297,9009,'vi','KhÃ´ng thÃªm khÃ¡ch hÃ ng má»›i Ä‘Æ°á»£c',0),(324298,9009,'af','Was Nie Staat om Nuwe KliÃ«nt/Klant te Skep',0),(324299,9009,'ro','Nu ar putea adÄƒuga client nou',0),(324300,9009,'et','Ei saanud lisada uut klienti',0),(324301,9009,'si','Ni mogoÄe dodati novega kupca',0),(324302,9009,'ba','Tidak dapat menambahkan pelanggan baru',0),(324303,9009,'nl','Kan niet toevoegen van nieuwe klant',0),(324304,9009,'fi','Ei voi lisÃ¤tÃ¤ uuden asiakkaan',0),(324305,9009,'no','Kan ikke legge til ny kunde',0),(324306,9009,'da','Kunne ikke tilfÃ¸je ny kunde',0),(324307,9009,'ko','ìƒˆ ê³ ê°ì„ ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(324308,9009,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×”×•×¡×™×£ ×œ×§×•×— ×—×“×©',0),(324309,9009,'el','Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î½Î­Î¿ Ï€ÎµÎ»Î¬Ï„Î·',0),(324310,9009,'zh','æ— æ³•æ·»åŠ æ–°å®¢æˆ·\r\n',0),(324311,9009,'sv','Kunde inte lÃ¤gga till ny kund',0),(324312,9009,'it','Impossibile aggiungere nuovo cliente',0),(324313,9009,'tl','',0),(324314,9009,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3614;&#3636;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3652;&#3604;&#3657;',0),(324315,9009,'hi','à¤¨à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼ à¤¸à¤•à¤¤à¤¾',0),(324316,9009,'ms','Tidak dapat menambah pelanggan baru',0),(324317,9009,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø¹Ù…ÙŠÙ„ Ø¬Ø¯ÙŠØ¯',0),(324318,9009,'fr','Ne peut pas ajouter nouveau client',0),(324319,9009,'jp','æ–°ã—ã„é¡§å®¢ã‚’è¿½åŠ ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(324320,9009,'pt','NÃ£o foi possÃ­vel adicionar o novo cliente',0),(324321,9009,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²Ð¾Ð³Ð¾ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(324322,9009,'es','No PodÃ­a Agregar un Nuevo Cliente',0),(324323,9009,'de','Neuen Kunde konnte nicht hinzugefÃ¼gt werden.',0),(324324,9009,'en','Could Not Add New Customer',0),(324325,9010,'is','',0),(324326,9010,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù†  Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡  Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ Ù†ÙŠØ³Øª',0),(324327,9010,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù†  Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡  Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ø¯ÙŠØ¯ Ù†ÙŠØ³Øª',0),(324328,9010,'tr','Yeni mÃ¼ÅŸteri gemiye eklenemedi',0),(324329,9010,'pl','Nie moÅ¼na dodaÄ‡ nowy statek klienta do',0),(324330,9010,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(324331,9010,'ur','Ù†Ø¦Û’ Ú¯Ø§ÛÚ© Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(324332,9010,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð½Ð¾Ð²Ð¸ Ð±Ñ€Ð¾Ð´ ÐºÑƒÐ¿Ñ†Ð° Ð´Ð°',0),(324333,9010,'vi','KhÃ´ng thÃªm Ä‘Æ°á»£c Ä‘á»‹a chá»‰ váº­n chuyá»ƒn hÃ ng má»›i cá»§a khÃ¡ch hÃ ng',0),(324334,9010,'af','Was Nie Staat om Nuwe KliÃ«nt/Klant Versend Aan by te voeg nie',0),(324335,9010,'ro','Nu ar putea adÄƒuga navÄƒ nouÄƒ de client pentru',0),(324336,9010,'et','Ei saanud lisada uut kliendi tarneaadressi',0),(324337,9010,'si','Ni bilo mogoÄe dodati novo ladjo kupca',0),(324338,9010,'ba','Tidak dapat menambahkan kapal pelanggan baru untuk',0),(324339,9010,'nl','Er kon geen nieuwe klant schip toegevoegd',0),(324340,9010,'fi','Ei voi lisÃ¤tÃ¤ uuden asiakkaan aluksen',0),(324341,9010,'no','Kan ikke legge til nye kunde skipet til',0),(324342,9010,'da','Kunne ikke tilfÃ¸je nye kunde skib',0),(324343,9010,'ko','ìƒˆë¡œìš´ ê³ ê° ë°°ë¥¼ ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(324344,9010,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×”×•×¡×™×£ ×œ×§×•×—×•×ª ×—×“×©×™× ×œ×¡×¤×™× ×”',0),(324345,9010,'el','Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î½Î­Î¿ Ï€ÎµÎ»Î¬Ï„Î· Ï€Î»Î¿Î¯Î¿',0),(324346,9010,'zh','æ— æ³•æ·»åŠ æ–°å®¢æˆ·æ”¶è´§\r\n',0),(324347,9010,'sv','Kunde inte lÃ¤gga till ny kund fartyg',0),(324348,9010,'it','Impossibile aggiungere nuovi cliente nave a',0),(324349,9010,'tl','',0),(324350,9010,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3614;&#3636;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3586;&#3609;&#3626;&#3656;&#3591;&#3606;&#3638;&#3591;&#3652;&#3604;&#3657;',0),(324351,9010,'hi','à¤¨à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤¸à¤•à¤¾',0),(324352,9010,'ms','Tidak dapat menambah kapal pelanggan baru',0),(324353,9010,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø³ÙÙŠÙ†Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø¬Ø¯ÙŠØ¯ Ø¥Ù„Ù‰',0),(324354,9010,'fr','Ne peut pas ajouter nouveau client navire Ã ',0),(324355,9010,'jp','æ–°ã—ã„é¡§å®¢èˆ¹ã‚’è¿½åŠ ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(324356,9010,'pt','NÃ£o foi possÃ­vel adicionar o novo navio de cliente para',0),(324357,9010,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(324358,9010,'es','No PodÃ­a Agregar un Nuevo Cliente Enviar a',0),(324359,9010,'de','Neue Kunden Schiff konnte nicht hinzugefÃ¼gt werden.',0),(324360,9010,'en','Could Not Add New Customer Ship To',0),(324361,9011,'is','',0),(324362,9011,'dr','Ø¢Ø®Ø±ÙŠÙ† Ø¯ÙŠØ¯Ø§Ø± Ø§Ø² ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(324363,9011,'pr','Ø¢Ø®Ø±ÙŠÙ† Ø¯ÙŠØ¯Ø§Ø± Ø§Ø² ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ ',0),(324364,9011,'tr','Son ziyaret edilen ana sayfa',0),(324365,9011,'pl','Ostatni odwiedzanej strony gÅ‚Ã³wnej',0),(324366,9011,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð¿Ð¾ÑÐµÑ‰Ð°Ð²Ð°Ð½Ð¸ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(324367,9011,'ur','Ø¢Ø®Ø±ÛŒ Ø¯ÛŒÚ©Ú¾Û’ Ú¯Ø¦Û’ Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØµÙØ­Û',0),(324368,9011,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿Ð¾ÑÐµÑ‚Ð¸Ð»Ð¸ Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(324369,9011,'vi','Láº§n cuá»‘i vÃ o trang chá»§',0),(324370,9011,'af','Laaste Besoekte Tuisblad',0),(324371,9011,'ro','Ultima pagina de pornire vizitate',0),(324372,9011,'et','Viimati kÃ¼lastatud kodulehekÃ¼lg',0),(324373,9011,'si','Zadnje obiskanih domaÄa stran',0),(324374,9011,'ba','Terakhir dikunjungi halaman rumah',0),(324375,9011,'nl','Laatste bezochte Startpagina',0),(324376,9011,'fi','Viimeinen kÃ¤ynti kotisivulle',0),(324377,9011,'no','Siste besÃ¸kte hjemmeside',0),(324378,9011,'da','Sidste besÃ¸gte hjemmeside',0),(324379,9011,'ko','ìµœê·¼ ë°©ë¬¸í•œ í™ˆ íŽ˜ì´ì§€',0),(324380,9011,'he','×“×£ ×”×‘×™×ª ×”××—×¨×•×Ÿ ×‘×™×§×¨',0),(324381,9011,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÏƒÎµÎ»Î¯Î´Î± Ï€Î¿Ï… ÎµÏ€Î¹ÏƒÎºÎµÏ†Î¸Î®ÎºÎ±Ï„Îµ Ï„Î¿ ÏƒÏ€Î¯Ï„Î¹',0),(324382,9011,'zh','ä¸Šæ¬¡è®¿é—®ä¸»é¡µ\r\n',0),(324383,9011,'sv','Senaste besÃ¶kta startsidan',0),(324384,9011,'it','Ultima pagina visitata Home',0),(324385,9011,'tl','',0),(324386,9011,'th','&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;&#3648;&#3618;&#3637;&#3656;&#3618;&#3617;&#3594;&#3617;&#3627;&#3609;&#3657;&#3634;&#3649;&#3619;&#3585;',0),(324387,9011,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¦à¥‡à¤–à¥€ à¤—à¤ˆ à¤®à¥à¤– à¤ªà¥ƒà¤·à¥à¤ ',0),(324388,9011,'ms','Lepas Laman utama yang dilawati',0),(324389,9011,'ar','ØªØ§Ø±ÙŠØ® Ø¢Ø®Ø± Ø²ÙŠØ§Ø±Ø© Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(324390,9011,'fr','DerniÃ¨re Page dâ€™accueil visitÃ©s',0),(324391,9011,'jp','æœ€å¾Œã«è¨ªã‚ŒãŸãƒ›ãƒ¼ãƒ  ãƒšãƒ¼ã‚¸',0),(324392,9011,'pt','Ãšltima pÃ¡gina visitada',0),(324393,9011,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð¿Ð¾ÑÐµÑ‚Ð¸Ð» Ð”Ð¾Ð¼Ð°ÑˆÐ½ÑÑ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(324394,9011,'es','La Ultima PÃ¡gina Hogar Visitado',0),(324395,9011,'de','Letzte besuchte Homepage',0),(324396,9011,'en','Last Visited Home Page',0),(324397,9012,'is','',0),(324398,9012,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ ØµÙØ­Ù‡',0),(324399,9012,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ ØµÙØ­Ù‡',0),(324400,9012,'tr','VarsayÄ±lan ana sayfa',0),(324401,9012,'pl','DomyÅ›lna Strona gÅ‚Ã³wna',0),(324402,9012,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(324403,9012,'ur','Ø·Û’ Ø´Ø¯Û ÛÙˆÙ… Ù¾ÛŒØ¬',0),(324404,9012,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(324405,9012,'vi','Trang chá»§ máº·c Ä‘á»‹nh',0),(324406,9012,'af','Verstekte Tuisblad',0),(324407,9012,'ro','Pagina de pornire implicitÄƒ',0),(324408,9012,'et','Vaikimisi koduleht',0),(324409,9012,'si','Privzeto domaÄo stran',0),(324410,9012,'ba','Default Homepage',0),(324411,9012,'nl','Standaardhomepage',0),(324412,9012,'fi','LaiminlyÃ¶minen Homepage',0),(324413,9012,'no','Startside',0),(324414,9012,'da','Standard hjemmeside',0),(324415,9012,'ko','ê¸°ë³¸ í™ˆíŽ˜ì´ì§€',0),(324416,9012,'he','×“×£ ×”×‘×™×ª ×”×ž×•×’×“×¨ ×›×‘×¨×™×¨×ª ×ž×—×“×œ',0),(324417,9012,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î±ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î±',0),(324418,9012,'zh','é»˜è®¤ä¸»é¡µ\r\n',0),(324419,9012,'sv','Standard hemsida',0),(324420,9012,'it','Home page predefinita',0),(324421,9012,'tl','',0),(324422,9012,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3609;&#3657;&#3634;&#3627;&#3621;&#3633;&#3585;',0),(324423,9012,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¥à¤–à¤ªà¥ƒà¤·à¥à¤ ',0),(324424,9012,'ms','Laman Utama lalai',0),(324425,9012,'ar','Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠØ©',0),(324426,9012,'fr','Page d\'accueil par dÃ©faut',0),(324427,9012,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã®ãƒ›ãƒ¼ãƒ ãƒšãƒ¼ã‚¸',0),(324428,9012,'pt','PÃ¡gina inicial padrÃ£o',0),(324429,9012,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(324430,9012,'es','PÃ¡gina Hogar por Defecto',0),(324431,9012,'de','Standard-Homepage',0),(324432,9012,'en','Default Homepage',0),(324433,9013,'is','',0),(324434,9013,'dr','ØªÙÙƒÙŠÙƒ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(324435,9013,'pr','ØªÙÙƒÙŠÙƒ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª',0),(324436,9013,'tr','Fiyat dÃ¼zeyi daÄŸÄ±lÄ±mÄ±',0),(324437,9013,'pl','Poziom podziaÅ‚u ceny',0),(324438,9013,'bg','Ð¦ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾ Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(324439,9013,'ur','Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚',0),(324440,9013,'sr','Ð¦ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾Ð° ÑÐ»Ð¾Ð¼',0),(324441,9013,'vi','PhÃ¢n chia Má»©c giÃ¡',0),(324442,9013,'af','Prysvlak Ontleding',0),(324443,9013,'ro','Pret nivel defalcare',0),(324444,9013,'et','Hindade taseme jaotus',0),(324445,9013,'si','Cena ravni razÄlenitve',0),(324446,9013,'ba','Harga tingkat rincian',0),(324447,9013,'nl','Prijs niveau verdeling',0),(324448,9013,'fi','Tason erittely',0),(324449,9013,'no','NivÃ¥ sammenbrudd',0),(324450,9013,'da','Pris niveau opdeling',0),(324451,9013,'ko','ê°€ê²© ìˆ˜ì¤€ ë¶„ì„',0),(324452,9013,'he','×”×ª×¤×œ×’×•×ª ×¨×ž×ª ×ž×—×™×¨',0),(324453,9013,'el','Î¤Î¹Î¼Î® ÎµÏ€Î¹Ï€Î­Î´Î¿Ï… Î±Î½Î¬Î»Ï…ÏƒÎ·',0),(324454,9013,'zh','ä»·æ ¼æ°´å¹³å´©æºƒ\r\n',0),(324455,9013,'sv','Pris nivÃ¥n uppdelning',0),(324456,9013,'it','Prezzo livello ripartizione',0),(324457,9013,'tl','',0),(324458,9013,'th','&#3619;&#3632;&#3604;&#3633;&#3610;&#3619;&#3634;&#3588;&#3634;&#3648;&#3610;&#3619;&#3588;&#3604;&#3634;&#3623;&#3609;&#3660;',0),(324459,9013,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤Ÿà¥‚à¤Ÿà¤¨à¥‡',0),(324460,9013,'ms','Harga tahap kerosakan',0),(324461,9013,'ar','Ø§Ù†Ù‡ÙŠØ§Ø± Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(324462,9013,'fr','Niveau ventilation du prix',0),(324463,9013,'jp','ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«ã®å†…è¨³',0),(324464,9013,'pt','Quebra de nÃ­vel de preÃ§o',0),(324465,9013,'ru','Ð¦ÐµÐ½Ð° ÑƒÑ€Ð¾Ð²Ð½Ñ Ð¿Ñ€Ð¾Ð±Ð¾Ñ',0),(324466,9013,'es','Detalle de Nivel de Precio',0),(324467,9013,'de','Ebene PreisaufschlÃ¼sselung',0),(324468,9013,'en','Price Level Breakdown',0),(324469,9014,'is','',0),(324470,9014,'dr','1: Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ Ø¨Ø±Ø¢ÙˆØ±Ø¯Ù‡Ø§ ( Ù…Ø­Ø§Ø³Ø¨Ø§Øª) Ø§Ù…Ø§ Ú†Ùƒ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø¯Ø± Ù…Ø¬Ù…ÙˆØ¹  Ø±Ø§ Ø´Ø§Ù…Ù„ Ù…ÙŠ Ø´ÙˆØ¯ â€“ ØªÙˆØ¬Ù‡: Ù…Ø¬Ù…ÙˆØ¹ ....   Ø´Ø§Ù…Ù„ Ù…Ù‚Ø§Ø¯ÙŠØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø¯Ø± Ø§ÙŠÙ† Ú¯Ø²Ø§Ø±Ø´ Ù†Ù…ÙŠ Ø´Ùˆ',0),(324471,9014,'pr','Ø°ÙƒØ± 1: Ø®Ù„Ø§ØµÙ‡ Ú†Ùƒ Ø¨Ø±Ø¢ÙˆØ±Ø¯Ù‡Ø§ ( Ù…Ø­Ø§Ø³Ø¨Ø§Øª) Ø§Ù…Ø§ Ú†Ùƒ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø¯Ø± Ù…Ø¬Ù…ÙˆØ¹  Ø±Ø§ Ø´Ø§Ù…Ù„ Ù…ÙŠ Ø´ÙˆØ¯ â€“ ØªÙˆØ¬Ù‡: Ù…Ø¬Ù…ÙˆØ¹ ....   Ø´Ø§Ù…Ù„ Ù…Ù‚Ø§Ø¯ÙŠØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø¯Ø± Ø§ÙŠÙ† Ú¯Ø²Ø§Ø±Ø´ Ù†Ù…ÙŠ Ø´Ùˆ',0),(324472,9014,'tr','Kontrol Ã–zeti hesaplanan ama Ã–DENMEMÄ°Åž Ã§ek toplamlarÄ± iÃ§erir.<br><br>Dikkat, YTD toplamlarÄ± bir bu Ã–DENMEMÄ°Åž tutarlar dahil deÄŸildir raporu. Ancak, Ã¶deme geÃ§miÅŸi yalnÄ±zca hesaplanan ve Ã¶denen denetimleri iÃ§erir.',0),(324473,9014,'pl','SprawdÅº podsumowanie bÄ™dzie zawieraÄ‡ obliczeniowy, lecz NIEWYPÅACONYCH kontroli sumy.<br><br>Uwaga, sumy od poczÄ…tku roku nie bÄ™dzie zawieraÄ‡ NIEZAPÅACONYCH kwot na ten raport. Jednak historia zapÅ‚aciÄ‡ tylko bÄ™dzie obejmowaÄ‡ kontrole obliczona',0),(324474,9014,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ñ€ÐµÐ·ÑŽÐ¼ÐµÑ‚Ð¾ Ñ‰Ðµ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð° Ð½Ð¾ ÐÐ•ÐŸÐ›ÐÐ¢Ð•ÐÐ˜ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð² Ð¾Ð±Ñ‰Ð¸Ñ‚Ðµ ÑÑƒÐ¼Ð¸.<br><br>ÐžÐ±ÑŠÑ€Ð½ÐµÑ‚Ðµ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ, Ñ‡Ðµ Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð¸ Ð½ÑÐ¼Ð° Ð´Ð° Ð²Ð',0),(324475,9014,'ur','Ú†ÛŒÚ© Ø®Ù„Ø§ØµÛ Ù…Ø­Ø³ÙˆØ¨ Ù„ÛŒÚ©Ù† Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û Ú†ÛŒÚ© Ù…ÛŒØ²Ø§Ù† Ù…ÛŒÚº Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº Ú¯Û’ Û”<br><br>Ù†ÙˆÙ¹ ÛŒÙ¹Ø¯ Ù…ÛŒØ²Ø§Ù† Ø§ÛŒÚ© Ø§Ø³ Ù¾Ø± Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û Ù…Ù‚Ø¯Ø§Ø± Ù†Û Ø´Ø§Ù…Ù„ ÛÙˆÚº Ú¯Û’ Ø±Ù¾ÙˆØ±Ù¹ Û” ØªØ§ÛÙ…ØŒ Ø§Ø¯Ø§ ØªØ§Ø±ÛŒ',0),(324476,9014,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ñ›Ðµ ÑƒÐºÑ™ÑƒÑ‡Ð¸Ð²Ð°Ñ‚Ð¸ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚Ð°, Ð°Ð»Ð¸ ÐÐ•ÐŸÐ›ÐÐ‹Ð•ÐÐ• Ñ‡ÐµÐºÐ¾Ð²Ðµ Ñƒ ÑƒÐºÑƒÐ¿Ð½Ðµ Ð¸Ð·Ð½Ð¾ÑÐµ.<br><br>Ð˜Ð¼Ð°Ñ˜Ñ‚Ðµ Ð½Ð° ÑƒÐ¼Ñƒ Ð´Ð° ÑƒÐºÑƒÐ¿Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð½ÐµÑ›Ðµ ÑƒÐºÑ™ÑƒÑ‡Ð¸Ð²Ð°',0),(324477,9014,'vi','Tá»•ng há»£p SÃ©c sáº½ tÃ­nh cáº£ nhá»¯ng sÃ©c chÆ°a tráº£. Ghi nhá»›, tá»•ng sá»‘ Ä‘áº¿n thá»i Ä‘iá»ƒm hiá»‡n táº¡i sáº½ khÃ´ng bao gá»“m sá»‘ tiá»n chÆ°a tráº£ trong bÃ¡o cÃ¡o nÃ y. Tuy nhiÃªn, lá»‹ch sá»­ thanh toÃ¡n sáº½ chá»‰ bao gá»“m sÃ©c',0),(324478,9014,'af','Die kontroleer opsomming sal berekende maar ONBETAALDE tjeks in die totale insluit.<br><br>Let op die YTD totale sal sluit in ONBETAALDE bedrae op hierdie verslag. Tog, die betaal geskiedenis sal slegs sluit ondersoeke bereken en betaal.',0),(324479,9014,'ro','Verifica rezumatul va include controale calculate, dar NEPLÄ‚TITE Ã®n totaluri.<br><br>ReÅ£ineÅ£i, YTD totaluri nu va include sumele NEACHITATE pe o acest raport. Cu toate acestea, istoria plata va include doar controale calculate ÅŸi plÄƒtite.',0),(324480,9014,'et','Kontrollige KokkuvÃµte sisaldab arvutatud kuid maksmata kontrolli kogusummad.<br><br>TÃ¤hele, YTD kogusummades ei kajastu tasumata summad selle kohta aruande. Siiski maksta ajalugu kaasatakse ainult kontrolli makstakse.',0),(324481,9014,'si','Preverite Povzetek bodo izraÄunani pa NEPLAÄŒANE pregledov v vsote.<br><br>Opomba, YTD vsote ne bodo vsebovale NEPLAÄŒANE zneske na to poroÄilo. Vendar, plaÄilo zgodovino vkljuÄilo le kontrolo izraÄuna in plaÄa.',0),(324482,9014,'ba','Periksa ringkasan akan mencakup pemeriksaan dihitung tetapi tidak dibayar dalam total.<br><br>Catatan, Total YTD tidak akan menyertakan tidak dibayar jumlah ini laporan. Namun, sejarah membayar hanya akan mencakup pemeriksaan menghitung dan membayar.',0),(324483,9014,'nl','De samenvatting controleren zal berekend maar onbetaalde controles opgenomen in de totalen.<br><br>Let op, de YTD totalen bevatten geen onbetaalde bedragen hierover een verslag. De geschiedenis van betalen bevat echter alleen controles berekend en betaald',0),(324484,9014,'fi','Tarkista Yhteenveto sisÃ¤ltÃ¤Ã¤ lasketun mutta MAKSAMATON tarkastusten summat.<br><br>Huomioon, ettÃ¤ vuoden alusta summat eivÃ¤t sisÃ¤llÃ¤ MAKSAMATTOMAT mÃ¤Ã¤rÃ¤t koskevat tÃ¤mÃ¤n mietinnÃ¶n. Kuitenkin maksaa historia sisÃ¤ltÃ¤Ã¤ vain tarkastusten lasket',0),(324485,9014,'no','Se sammendraget vil inkludere beregnet men UBETALTE sjekker i totalene.<br><br>Merk YTD totalene ikke vil inkludere UBETALTE denne rapporten. Imidlertid vil betale historien bare inneholde sjekker beregnes og betales.',0),(324486,9014,'da','At kontrollere ResumÃ© vil omfatte beregnede men ubetalte kontrol i totalerne.<br><br>BemÃ¦rk, YTD totaler ikke vil omfatte ubetalte belÃ¸b pÃ¥ denne betÃ¦nkning. Dog vil betale historie kun omfatte kontrol beregnet og betalt.',0),(324487,9014,'ko','ê²€ì‚¬ ìš”ì•½ í•©ê³„ ê³„ì‚° í•˜ì§€ë§Œ ë¬´ë£Œ ê²€ì‚¬ í¬í•¨ ë©ë‹ˆë‹¤.<br><br>ì°¸ê³ , YTD í•©ê³„ ê¸ˆì•¡ì—ëŠ” í¬í•¨ ë˜ì§€ ê²ƒìž…ë‹ˆë‹¤ ë³´ê³ ì„œ. ê·¸ëŸ¬ë‚˜, ì§€ë¶ˆ ì—­ì‚¬ë§Œ ê²€ì‚¬ ê³„ì‚° ë° ì§€ê¸‰ì„ í¬í•¨í•  ê²ƒ ì´ë‹¤.',0),(324488,9014,'he','×”×ª×§×¦×™×¨ ×œ×‘×“×•×§ ×™×›×œ×•×œ ×‘×“×™×§×•×ª ×ž×—×•×©×‘ ××‘×œ ×©×œ× ×©×•×œ×ž×• ×”×¡×›×•×ž×™×.<br><br>×©×™×ž×• ×œ×‘, ×”×¡×›×•×ž×™× ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•× ×œ× ×›×•×œ×œ×•×ª ××ª ×”×¡×›×•×ž×™× ×©×œ× ×©×•×œ×ž×• ×¢×œ ×–×” ×“×• ×—. ×¢× ×–',0),(324489,9014,'el','Î— Ï€ÎµÏÎ¯Î»Î·ÏˆÎ· ÎµÎ»Î­Î³Ï‡ÎµÎ¹ Î¸Î± Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î±Î»Î»Î¬ Î´ÎµÎ½ ÎšÎ‘Î¤Î‘Î’Î›Î‰Î˜Î—ÎšÎ‘Î ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ ÏƒÏ„Î± ÏƒÏÎ½Î¿Î»Î±.<br><br>Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·, Ï„Î± ÏƒÏÎ½Î¿Î»Î± YTD Î´ÎµÎ½ Î¸Î± Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Ï„',0),(324490,9014,'zh','æ£€æŸ¥æ‘˜è¦å°†åŒ…æ‹¬æ€»æ•°ä¸­å·²è®¡ç®—ä½†å°šæœªåœ¨ä»˜æ¬¾çš„æ£€æŸ¥ã€‚ è¯·æ³¨æ„ï¼Œåœ¨å¹´åˆè‡³ä»Šæ€»è®¡å°†ä¸åŒ…æ‹¬åœ¨æœ¬æŠ¥å‘Šæœªä»˜æ¬¾é¡¹ã€‚ä¸è¿‡ï¼Œæœ‰å…³è–ªé…¬åŽ†å²å°†åªåŒ…æ‹¬æ£€æŸ¥ï¼Œè®¡ç®—å’Œæ”¯ä»˜ã€‚\r\n',0),(324491,9014,'sv','Kontrollera sammanfattningen innehÃ¥ller berÃ¤knade men obetalda kontroller i summorna.<br><br>Observera, YTD summorna inte kommer att innehÃ¥lla obetalda beloppen pÃ¥ detta betÃ¤nkande. Betala historia kommer dock endast att inkludera kontroller berÃ¤kna',0),(324492,9014,'it','Il riepilogo Verifica comprenderÃ  controlli calcolati ma non pagati nei totali.<br><br>Notare che i totali YTD non includerÃ  gli importi non pagati su un questo rapporto. Tuttavia, la storia di pagare includerÃ  solo controlli calcolati e pagati.',0),(324493,9014,'tl','',0),(324494,9014,'th','The Check Summary will include calculated but UNPAID checks in the totals.<br><br>Note, the YTD totals will NOT include UNPAID amounts on a this report. However, the Pay History will only include checks calculated and paid.',0),(324495,9014,'hi','à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤•à¥€ à¤—à¤£à¤¨à¤¾, à¤²à¥‡à¤•à¤¿à¤¨ à¤…à¤¦à¤¤à¥à¤¤ à¤œà¤¾à¤à¤š à¤¯à¥‹à¤— à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥‹à¤‚à¤—à¥‡à¥¤<br><br>à¤§à¥à¤¯à¤¾à¤¨ à¤¦à¥‡à¤‚, à¤¤à¥‹ à¤à¤• à¤‡à¤¸ à¤ªà¤° à¤…à¤µà¥ˆà¤¤à¤¨à¤¿à¤',0),(324496,9014,'ms','Ringkasan semakan akan menyertakan pemeriksaan dikira tetapi tidak dibayar dalam jumlah.<br><br>Maklum bahawa jumlah THK akan termasuk amaun belum bayar yang ini laporan. Walau bagaimanapun, sejarah membayar hanya akan merangkumi pemeriksaan dikira dan di',0),(324497,9014,'ar','ÙˆØ³ØªØ´Ù…Ù„ \"Ù…Ù„Ø®Øµ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù†\" Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ù…Ø­Ø³ÙˆØ¨Ø© ÙˆÙ„ÙƒÙ† ØºÙŠØ± Ù…Ø¯ÙÙˆØ¹Ø© Ø§Ù„Ø£Ø¬Ø± ÙÙŠ Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹.<br><br>Ù…Ù„Ø§Ø­Ø¸Ø©ØŒ Ù„Ù† ØªØªØ¶Ù…Ù† Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø¹Ø§Ù… Ø§Ù„Ù…Ø¨Ø§Ù„Øº ØºÙŠØ± Ø§Ù„Ù…Ø³',0),(324498,9014,'fr','Le rÃ©sumÃ© VÃ©rifiez comprendra des contrÃ´les calculÃ©s mais non acquittÃ©es dans les totaux.<br><br>Noter que les totaux de CDA nâ€™inclura pas les montants impayÃ©s sur ce rapport. Cependant, lâ€™histoire de payer nâ€™inclut que les contrÃ´les calculÃ',0),(324499,9014,'jp','ãƒã‚§ãƒƒã‚¯æ¦‚è¦åˆè¨ˆã§è¨ˆç®—ã•ã‚Œã‚‹ãŒã€æœªæ‰•ã„ãƒã‚§ãƒƒã‚¯ãŒå«ã¾ã‚Œã¾ã™ã€‚<br><br>æ³¨æ„ã—ã¦ãã ã•ã„ã€YTD åˆè¨ˆã«ã“ã®æœªæ‰•ã„é‡‘é¡ã¯å«ã¾ã‚Œã¾ã›ã‚“ãƒ¬ãƒãƒ¼ãƒˆã€‚ãŸã ã—ã€æ”¯æ‰•ã„å±¥æ­´ã«ã¯ã€ãƒã‚§ãƒƒã‚¯ã€ãŠã‚ˆã³',0),(324500,9014,'pt','O resumo verificar incluirÃ¡ controlos calculados mas nÃ£o pagos no total.<br><br>Note que o total acumulado no ano nÃ£o incluirÃ¡ montantes nÃ£o pagos sobre um este relatÃ³rio. No entanto, a histÃ³ria de pagar sÃ³ irÃ¡ incluir controlos calculados e pago',0),(324501,9014,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ Ð±ÑƒÐ´ÐµÑ‚ Ð²ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÑÐµÐ¼Ñ‹Ðµ, Ð½Ð¾ Ð½ÐµÐ¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ñ‡ÐµÐºÐ¸ Ð² Ð¸Ñ‚Ð¾Ð³Ð¾Ð²Ñ‹Ñ… Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚ÐµÐ»ÑÑ….<br><br>ÐžÐ±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ, YTD Ð¸Ñ‚Ð¾Ð³Ð¸ Ð½Ðµ Ð±ÑƒÐ´ÑƒÑ‚ Ð²ÐºÐ»ÑŽÑ‡Ð°Ñ‚Ñ',0),(324502,9014,'es','El Resumen de Cheques incluirÃ¡ cheques calculados pero NO PAGADOS en los totales.<br><br> Nota, los totales NO incluirÃ¡n los montos NO PAGADOS en el presente informe. Sin embargo, la Historia de Pagos sÃ³lo incluirÃ¡n los cheques calculados y pagados.',0),(324503,9014,'de','Die Zusammenfassung Ã¼berprÃ¼fen gehÃ¶ren berechnete aber unbezahlten Schecks in die Summen.<br><br>Beachten Sie, dass die YTD-Summen enthalten keine ausstehenden BetrÃ¤ge auf eine dieser Bericht. Jedoch enthalten die Zahlen Geschichte nur Schecks berechn',0),(324504,9014,'en','The Check Summary will include calculated but UNPAID checks in the totals.<br><br>Note, the YTD totals will NOT include UNPAID amounts on a this report. However, the Pay History will only include checks calculated and paid.',0),(324505,9015,'is','',0),(324506,9015,'dr','2 :Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± Ù†Ù…Ø§ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø´Ù…Ø§ Ø¯Ø± ØµÙˆØ±Øª Ø§Ø®ØªÙ„Ø§Ù Ø¨Ø§Ù†ÙƒÙŠ  Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯_ Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†ÙƒÙŠ ÙƒÙ‡ Ø§ÙŠÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ Ø´Ø§Ù…Ù„ Ù…ÙŠ Ø´ÙˆØ¯_ Ø±Ø§ Ø§Ø¬Ø±Ø§ Ùƒ',0),(324507,9015,'pr','ØªØ°ÙƒØ±  2 :Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± Ù†Ù…Ø§ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø´Ù…Ø§ Ø¯Ø± ØµÙˆØ±Øª Ù…ØºØ§ÙŠØ±Øª Ø¨Ø§Ù†ÙƒÙŠ  Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯_ Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†ÙƒÙŠ ÙƒÙ‡ Ø§ÙŠÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ Ø´Ø§Ù…Ù„ Ù…ÙŠ Ø´ÙˆØ¯_ Ø±Ø§ Ø§Ø¬Ø±Ø§ Ùƒ',0),(324508,9015,'tr','MÃ¼ÅŸteri Ã¶demelerinizi banka mutabakatÄ± gÃ¶stermek, sen Ã§alÄ±ÅŸtÄ±rmanÄ±z gerekir bu Ã¶deme iÃ§eren bir banka mevduat oluÅŸturun. ',0),(324509,9015,'pl','W kolejnoÅ›ci pÅ‚atnoÅ›ci klienta na uzgodnienia bankowego, naleÅ¼y uruchomiÄ‡ tworzenia lokat bankowych zawierajÄ…cych tej pÅ‚atnoÅ›ci. ',0),(324510,9015,'bg','Ð—Ð° Ð´Ð° ÑÐ¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð¶Ðµ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð°Ñ‚Ð° ÑÑŠÐ¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ°, Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½Ð¸Ñ‚Ðµ ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð² Ð±Ð°Ð½ÐºÐ°, ÑÑŠÐ´ÑŠÑ€Ð¶Ð°Ñ‰Ð° Ñ‚Ð¾Ð²Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ. ',0),(324511,9015,'ur','Ø¢Ù¾ Ú©Ø§ Ø¢Ù¾ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¨ÛŒÙ†Ú© Ù…ÙØ§ÛÙ…Øª Ù¾Ø± Ø¯Ú©Ú¾Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú¯Ø§ÛÚ© Ú©Û’ Ù„Ø¦Û’ ØªØ±ØªÛŒØ¨ Ù…ÛŒÚº Ú†Ù„Ù†Ø§ Ú†Ø§ÛÛŒÛ’ Ú©Û Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù¾Ø± Ù…Ø´ØªÙ…Ù„ Ø§ÛŒÚ© Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ Ø¨Ù†Ø§Ø¦ÛŒÚº Û” ',0),(324512,9015,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ð·Ð° Ñ‚Ð²Ð¾Ñ˜Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ ÐºÑƒÐ¿Ñ†Ð° Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð½Ð° ÑÑ€Ð°Ð²ÑšÐµÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸, Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾ÐºÑ€ÐµÐ½ÑƒÑ‚Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð±Ð°Ð½ÐºÐµ ÐºÐ¾Ñ˜Ð° ÑÐ°Ð´Ñ€Ð¶Ð¸ Ñ‚Ñƒ ÑƒÐ¿Ð»Ð°Ñ‚Ñƒ. ',0),(324513,9015,'vi','Äá»ƒ thanh toÃ¡n cá»§a khÃ¡ch hÃ ng hiá»ƒn thá»‹ trong pháº§n cÃ¢n Ä‘á»‘i TK ngÃ¢n hÃ ng, báº¡n pháº£i Táº¡o má»›i 1 giao dá»‹ch ngÃ¢n hÃ ng cho thanh toÃ¡n nÃ y.',0),(324514,9015,'af','Vir \'n Klantbetaling om te reflekteer op die Bankrekonsiliasie, moet u Skep Bank Deposito loop wat die betaling insluit.',0),(324515,9015,'ro','ÃŽn ordine pentru plÄƒÅ£ile de client pentru a arÄƒta pe reconcilierea bancarÄƒ, trebuie sÄƒ executaÅ£i crea un depozit bancar cu plata. ',0),(324516,9015,'et','Et oma kliendi maksed nÃ¤idata pangakonto sobitamise, peate kÃ¤ivitama luua pangahoiuste, mis sisaldab makse. ',0),(324517,9015,'si','Da bi vaÅ¡a plaÄila strank razkazati banÄnega usklajevanja, morate zagnati ustvariti banÄni depozit, ki vsebujejo to plaÄilo. ',0),(324518,9015,'ba','Agar pembayaran pelanggan Anda untuk menunjukkan pada rekonsiliasi Bank, Anda harus menjalankan membuat deposito Bank yang mengandung pembayaran itu. ',0),(324519,9015,'nl','Om de betalingen van uw klanten te tonen op de verzoening van de Bank, moet u een storting van de Bank dat de betaling met maken. ',0),(324520,9015,'fi','Jotta asiakasmaksuja nÃ¤yttÃ¤mÃ¤Ã¤n pankkitÃ¤smÃ¤ytyksen, sinun tÃ¤ytyy ajaa luoda pankkitalletus, joka sisÃ¤ltÃ¤Ã¤ kyseisen maksun. ',0),(324521,9015,'no','Du mÃ¥ kjÃ¸re for at kundenes betalinger pÃ¥ bankavstemmingen, oppretter et bankinnskudd som inneholder at. ',0),(324522,9015,'da','For at din debitorbetalinger til Vis pÃ¥ det bankkontoafstemningen, skal du kÃ¸re oprette et bankindestÃ¥ende, der indeholder denne betaling. ',0),(324523,9015,'ko','ì€í–‰ í™”í•´ì— ê³ ê° ì§€ë¶ˆì— ëŒ€ í•œ ìˆœì„œë¡œ ì‹¤í–‰ í•´ì•¼ í•©ë‹ˆë‹¤ ê·¸ ì§€ë¶ˆì„ í¬í•¨ í•˜ëŠ” ì€í–‰ ì˜ˆê¸ˆ ë§Œë“¤. ',0),(324524,9015,'he','×¢×œ ×ž× ×ª ×ª×©×œ×•×ž×™× ×œ×œ×§×•×— ×©×œ×š ×œ×”×¨××•×ª ×¢×œ ×”×¤×™×•×¡ ×”×‘× ×§, ×¢×œ×™×š ×œ×”×¤×¢×™×œ ×œ×™×¦×•×¨ ×‘×¤×§×“×•×Ÿ ×‘×‘× ×§ ×”×ž×›×™×œ ×”×ª×©×œ×•×. ',0),(324525,9015,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î³Î¹Î± Ï„Î¹Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï„Ï‰Î½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î³Î¹Î± Ï„Î·Î½ ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î·Î½ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ® ÏƒÏ…Î¼Ï†Ï‰Î½Î¯Î±, Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎºÏ„ÎµÎ»Î­ÏƒÎµÏ„Îµ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ®Ï‚ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚ Ï€Î¿',0),(324526,9015,'zh','ä¸ºä½¿æ‚¨çš„å®¢æˆ·æ”¯ä»˜æ˜¾ç¤ºåœ¨é“¶è¡Œå¯¹å¸ä¸­ï¼Œä½ å¿…é¡»è¿è¡Œåˆ›å»ºä¸€ä¸ªåŒ…å«è¯¥è½¬å¸æ”¯ä»˜çš„é“¶è¡Œå­˜æ¬¾ã€‚\r\n',0),(324527,9015,'sv','FÃ¶r kundbetalningarna Visa pÃ¥ bankkontoavstÃ¤mningen, mÃ¥ste du kÃ¶ra skapa insÃ¤ttning pÃ¥ en Bank som innehÃ¥ller denna betalning. ',0),(324528,9015,'it','In ordine per i pagamenti del cliente mostrare la riconciliazione bancaria, Ã¨ necessario eseguire creare un deposito bancario contenente tale pagamento. ',0),(324529,9015,'tl','',0),(324530,9015,'th','In order for your Customer Payments to show on the Bank Reconciliation, you must run Create a Bank Deposit containing that payment. ',0),(324531,9015,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¬à¥ˆà¤‚à¤• à¤¸à¤¾à¤®à¤‚à¤œà¤¸à¥à¤¯ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤ªà¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚, à¤†à¤ª à¤šà¤²à¤¾à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ à¤à¤• à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤•',0),(324532,9015,'ms','Dalam perintah untuk pembayaran pelanggan anda untuk menunjukkan pada dalam Penyata penyesuaian Bank, anda harus menjalankan membuat Deposit Bank mengandungi bahawa pembayaran. ',0),(324533,9015,'ar','ÙÙŠ ØªØ±ØªÙŠØ¨ \"Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„\" Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù„Ø¥Ø¸Ù‡Ø§Ø± Ø¹Ù„Ù‰ \"ØªØ³ÙˆÙŠØ© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ\"ØŒ ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ´ØºÙŠÙ„ Ø¥Ù†Ø´Ø§Ø¡ \"ÙˆØ¯ÙŠØ¹Ø© Ø§Ù„Ø¨Ù†Ùƒ\" Ø§Ù„ØªÙŠ ØªØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ø¯ÙØ¹. ',0),(324534,9015,'fr','Pour vos paiements de client de montrer sur le rapprochement bancaire, vous devez exÃ©cuter crÃ©er un contenant que le paiement des dÃ©pÃ´ts bancaires. ',0),(324535,9015,'jp','éŠ€è¡Œå‹˜å®šèª¿æ•´è¡¨ã«è¡¨ç¤ºã™ã‚‹ã‚ãªãŸã®é¡§å®¢ã®æ”¯æ‰•ã®ãŸã‚ã®é †åºã§å®Ÿè¡Œã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ãã®æ”¯æ‰•ã„ã‚’å«ã‚€éŠ€è¡Œé é‡‘ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(324536,9015,'pt','Em ordem para seus pagamentos de cliente mostrar sobre a reconciliaÃ§Ã£o bancÃ¡ria, vocÃª deve executar criar um depÃ³sito bancÃ¡rio, contendo o pagamento. ',0),(324537,9015,'ru','Ð’ Ð¿Ð¾Ñ€ÑÐ´ÐºÐµ Ð´Ð»Ñ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ Ð²Ð°ÑˆÐ¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð´Ð»Ñ Ð¿Ð¾ÐºÐ°Ð·Ð° Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð¹ Ð²Ñ‹Ð²ÐµÑ€ÐºÐ¸, Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð·Ð°Ð¿ÑƒÑÑ‚Ð¸Ñ‚ÑŒ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚, ÑÐ¾Ð´ÐµÑ€Ð¶Ð°Ñ‰Ð¸Ð¹ ÑÑ‚Ð¾Ñ‚ Ð',0),(324538,9015,'es','Para que sus pagos de clientes aparecen en la ReconciliaciÃ³n Bancaria, debe ejecutar Crear DepÃ³sito Bancario que contiene este pago.',0),(324539,9015,'de','In Reihenfolge fÃ¼r Ihre Zahlungen des Kunden auf die Bank Reconciliation zeigen, fÃ¼hren Sie ein Bankdepot mit, dass die Zahlung zu erstellen. ',0),(324540,9015,'en','In order for your Customer Payments to show on the Bank Reconciliation, you must run Create a Bank Deposit containing that payment. ',0),(324541,9016,'is','',0),(324542,9016,'dr','3 : Ø§Ú¯Ø± ÙŠÙƒ Ø­Ø³Ø§Ø¨ ÙØ¹Ø§Ù„ÙŠØª Ù†Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ Ø­Ø³Ø§Ø¨ Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´ÙŠ ÙƒÙ‡ Ø´Ù…Ø§ Ø§Ø² ØªÙ…Ø§Ù… Ø­Ø³Ø§Ø¨Ù‡Ø§ ÙŠØ§ Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ Ú†Ø§Ù¾ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ Ø¸Ø§Ù‡Ø± Ù†Ù…ÙŠ Ø´ÙˆØ¯ â€“ ÙŠÙƒ Ø­Ø³Ø§Ø¨ ØºÙŠØ± ÙØ¹Ø§Ù„ Ø¯Ø± ÙŠÙƒ ',0),(324543,9016,'pr','ØªØ°ÙƒØ±  3 : Ø§Ú¯Ø± ÙŠÙƒ Ø­Ø³Ø§Ø¨ ÙØ¹Ø§Ù„ÙŠØª Ù†Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ Ø­Ø³Ø§Ø¨ Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´ÙŠ ÙƒÙ‡ Ø´Ù…Ø§ Ø§Ø² ØªÙ…Ø§Ù… Ø­Ø³Ø§Ø¨Ù‡Ø§ ÙŠØ§ Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ Ú†Ø§Ù¾ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ Ø¸Ø§Ù‡Ø± Ù†Ù…ÙŠ Ø´ÙˆØ¯ â€“ ÙŠÙƒ Ø­Ø³Ø§Ø¨ ØºÙŠØ± ÙØ¹Ø§Ù„ Ø¯Ø± ÙŠÙƒ ',0),(324544,9016,'tr','Bir hesap hiÃ§bir etkinlik varsa, hesabÄ±n Ã¼zerinde gÃ¶rÃ¼nmez yazdÄ±rma bÃ¼tÃ¼n hesabÄ± veya hesap aralÄ±ÄŸÄ± rapordur.<br><br>Belirli bir dÃ¶nem iÃ§in hiÃ§bir etkinlik ile hesap belirli bir hesap isteyen gÃ¶rÃ¼nÃ¼r.',0),(324545,9016,'pl','JeÅ›li konto ma brak aktywnoÅ›ci, konta nie bÄ™dÄ… wyÅ›wietlane w raporcie jest drukowanie wszystkich kont lub zakres kont.<br><br>Konto z brak aktywnoÅ›ci w jednym okresie pojawi siÄ™, jeÅ›li Å¼Ä…danie okreÅ›lonego konta.',0),(324546,9016,'bg','ÐÐºÐ¾ ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð° Ð¸Ð¼Ð° Ð½Ð¸ÐºÐ°ÐºÐ²Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚, Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð° Ð½ÑÐ¼Ð° Ð´Ð° ÑÐµ Ð¿Ð¾ÑÐ²Ð¸ Ð½Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°Ñ‚Ð° Ðµ Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¸Ð»Ð¸ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸.<br><br>Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð±ÐµÐ· Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ ',0),(324547,9016,'ur','Ú©ÙˆØ¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ø§ÛŒÚ© Ø§Ú©Ø§Ø¤Ù†Ù¹ ÛÛ’ ØªÙˆØŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾Ø± Ø¸Ø§ÛØ± Ù†ÛÛŒÚº ÛÙˆÚ¯Ø§ Ú©Û Ø¢Ù¾ Ú©Ùˆ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ ÛÛ’ ØªÙ…Ø§Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹ ÛŒØ§ Ø§ÛŒÚ© Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ ÛÛŒÚº Ø±Ù¾ÙˆØ±Ù¹ ÛÛ’ Û”<br><br>Ø§ÛŒÚ© Ù…Ø¯Øª ØªÚ© Ú',0),(324548,9016,'sr','ÐÐºÐ¾ Ñ€Ð°Ñ‡ÑƒÐ½ Ð½ÐµÐ¼Ð° Ð½Ð¸ÐºÐ°ÐºÐ²Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸, Ð½Ð°Ð»Ð¾Ð³ Ð½ÐµÑ›Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð¿Ð¾Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸ Ð½Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ñ˜Ðµ Ð´Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ‚Ðµ ÑÐ²Ðµ Ð¸Ð»Ð¸ Ð·Ð° Ð¾Ð¿ÑÐµÐ³ ÐºÐ¾Ð½Ñ‚Ð°.<br><br>Ð Ð°Ñ‡ÑƒÐ½ ÑÐ° Ð½ÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(324549,9016,'vi','Náº¿u khÃ´ng cÃ³ hoáº¡t Ä‘á»™ng TK sáº½ khÃ´ng hiá»ƒn thá»‹ trong bÃ¡o cÃ¡o Táº¥t cáº£ cÃ¡c TK hay Pháº¡m vi cá»§a TK TK khÃ´ng cÃ³ hoáº¡t Ä‘á»™ng sáº½ hiá»ƒn thá»‹ khi yÃªu cáº§u 1 TK cá»¥ thá»ƒ',0),(324550,9016,'af','Indien \'n rekening het geen aktiwiteit, die rekening sal nie verskyn op die verslag is jy is druk alle rekening of \'n reeks van rekeninge.<br><br>\'N rekening met geen aktiwiteit vir een periode sal verskyn as \'n spesifieke rekening versoek.',0),(324551,9016,'ro','DacÄƒ un cont are nici o activitate, contul nu va apÄƒrea pe raportul este imprimaÅ£i toate cont sau o serie de conturi.<br><br>Un cont cu nici o activitate pentru o perioadÄƒ va apÄƒrea Ã®n cazul Ã®n care solicitÄƒ un anumit cont.',0),(324552,9016,'et','Kui konto on mingit tegevust, kontot ei kuvata kohta aruanne on kÃµigi pangakonto vÃµi -kontode vahemiku printimiseks.<br><br>Tegevuseks on Ã¼ks konto ilmub kui taotlev kindla konto.',0),(324553,9016,'si','ÄŒe raÄun ni dejavnost, raÄun ne bo pojavil na poroÄilo je tiskate vse raÄun ali obseg raÄunov.<br><br>RaÄun s ni dejavnost za eno obdobje se prikaÅ¾e, Äe zahteva doloÄene konte.',0),(324554,9016,'ba','Jika tidak ada aktivitas account, account tidak akan muncul pada laporan yang Anda mencetak semua Account atau kisaran account.<br><br>Akun tanpa aktivitas untuk satu periode akan muncul jika meminta account tertentu.',0),(324555,9016,'nl','Als een account geen activiteit heeft, wordt de account niet weergegeven op het verslag is u afdrukt alle of een bereik van Accounts.<br><br>Een account met geen activiteit voor een periode wordt weergegeven als een specifieke account aanvragen.',0),(324556,9016,'fi','Jos tili ei ole toimintaa, tili ei nÃ¤y mietintÃ¶ on tulostat kaikki tilin tai useita tilejÃ¤.<br><br>Tilin passiiviset yhden nÃ¤kyy jos tietylle tilille.',0),(324557,9016,'no','Hvis en forretningsforbindelse har ingen aktivitet, vil kontoen vises ikke pÃ¥ rapporten er du skriver ut alle regningen eller et utvalg av kontoer.<br><br>En konto uten aktivitet i en gitt periode vises hvis ber om en bestemt konto.',0),(324558,9016,'da','Hvis en konto har ingen aktivitet, kontoen ikke vises pÃ¥ rapporten er du udskriver alle konto eller en vifte af konti.<br><br>En konto med ingen aktivitet i en periode vil vises hvis anmoder om en bestemt konto.',0),(324559,9016,'ko','ê³„ì • ê³„ì • í™œë™ì´ ì—†ëŠ” ê²½ìš°ì— í‘œì‹œ ë˜ì§€ ê²ƒìž…ë‹ˆë‹¤ ë³´ê³ ì„œëŠ” ëª¨ë“  ê³„ì • ë˜ëŠ” ê³„ì • ë²”ìœ„ë¥¼ ì¸ì‡„ í•˜ëŠ”.<br><br>í•œ ë™ì•ˆ í™œë™ ì—†ì´ ê³„ì •ì„ íŠ¹ì • ê³„ì •ì„ ìš”ì²­ í•˜ëŠ” ê²½ìš° í‘œì‹œ ë©ë‹ˆë‹¤.',0),(324560,9016,'he','×× ×—×©×‘×•×Ÿ ×œ×œ× ×¤×¢×™×œ×•×ª, ×”×—×©×‘×•×Ÿ ×œ× ×™×•×¤×™×¢×• ×¢×œ ×”×“×•×— ×”×•× ×”×“×¤×¡×ª ×›×œ ×ª×™×§ ×”×œ×§×•×— ××• ×©×œ ×˜×•×•×— ×©×œ ×—×©×‘×•× ×•×ª.<br><br>×—×©×‘×•×Ÿ ×‘×¢×œ ××™×Ÿ ×¤×¢×™×œ×•×ª ×œ×ª×§×•×¤×” ××—×ª ×ª×•×¤×™×¢ ×× ×‘×§×©×ª ×œ',0),(324561,9016,'el','Î•Î¬Î½ Î­Î½Î±Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î­Ï‡ÎµÎ¹ ÎºÎ±Î¼Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±, Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î´ÎµÎ½ Î¸Î± ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î¿ Î­ÎºÎ¸ÎµÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹ Î½Î± ÎµÎºÏ„Ï…Ï€ÏŽÎ½ÎµÏ„Îµ ÏŒÎ»ÎµÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î® Î¼Î¹Î± ÏƒÎµÎ¹',0),(324562,9016,'zh','å¦‚æžœå¸æˆ·æ²¡æœ‰æ´»åŠ¨ï¼Œè¯¥å¸æˆ·å°†ä¸ä¼šå‡ºçŽ°åœ¨è¿™ä»½æ‚¨è¦æ‰“å°æ‰€æœ‰å¸æˆ·æˆ–å¸æˆ·èŒƒå›´çš„æŠ¥å‘Šä¸Šã€‚  å¦‚æžœè¦æ±‚ä¸€ä¸ªç‰¹å®šçš„å¸æˆ·ï¼Œä¸€ä¸ªæ— æ´»åŠ¨çš„å¸æˆ·å°†åœ¨ä¸€ä¸ªæ—¶æœŸä¸­å‡ºçŽ°ï¼Œ\r\n',0),(324563,9016,'sv','Om ett konto har ingen aktivitet, kontot visas inte pÃ¥ rapporten Ã¤r du skriver ut alla konto- eller ett intervall av konton.<br><br>Ett konto utan aktivitet fÃ¶r en period visas om begÃ¤r ett visst konto.',0),(324564,9016,'it','Se un account non ha attivitÃ , l\'account non verrÃ  visualizzato il report Ã¨ si stampa tutti gli Account o una gamma di conti.<br><br>Un account con nessuna attivitÃ  per un periodo apparirÃ  se richiedendo un account specifico.',0),(324565,9016,'tl','',0),(324566,9016,'th',' If an account has no activity, the account will not appear on the report is you are printing All Account or a Range of Accounts. <br><br>An account with no activity for one period will appear if requesting a specific account. ',0),(324567,9016,'hi','à¤¯à¤¦à¤¿ à¤•à¥‹à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤à¤• à¤–à¤¾à¤¤à¤¾ à¤¹à¥ˆ, à¤¤à¥‹ à¤‰à¤¸ à¤–à¤¾à¤¤à¥‡ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤ˆ à¤¨à¤¹à¥€à¤‚ à¤¦à¥‡à¤—à¤¾ à¤¸à¤­à¥€ à¤–à¤¾à¤¤à¥‡ à¤¯à¤¾ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥€ à¤à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤†à¤ª à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆ',0),(324568,9016,'ms','Jika akaun tiada aktiviti, akaun tidak akan muncul dalam laporan ini anda akan mencetak semua akaun atau pelbagai akaun.<br><br>Akaun dengan tiada aktiviti bagi satu tempoh akan muncul jika meminta akaun tertentu.',0),(324569,9016,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø­Ø³Ø§Ø¨ Ù„Ù„Ø§ Ù†Ø´Ø§Ø·ØŒ Ø§Ù„Ø­Ø³Ø§Ø¨ Ù„Ù† ØªØ¸Ù‡Ø± ÙÙŠ Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø£Ù†Ùƒ ØªØ·Ø¨Ø¹ ÙƒÙ„ Ø­Ø³Ø§Ø¨ Ø£Ùˆ Ù…Ù† Ù…Ø¬Ù…ÙˆØ¹Ø© Ø­Ø³Ø§Ø¨Ø§Øª.<br><br>Ø³ÙˆÙ ØªØ¸Ù‡Ø± Ø­Ø³Ø§Ø¨ Ù…Ø¹ Ù„Ø§ Ù†Ø´Ø§Ø· Ù„ÙØªØ±Ø© ÙˆØ§Ø­Ø¯Ø© Ø¥Ø°Ø§ Ø·Ù„Ø¨ Ø­Ø³Ø§Ø¨ Ù…Ø¹',0),(324570,9016,'fr','Si un compte n\'exerce aucune activitÃ©, le compte n\'apparaÃ®tra pas sur le rapport, c\'est que vous imprimez tous les compte ou une gamme de comptes.<br><br>Un compte sans activitÃ© pour une pÃ©riode donnÃ©e apparaÃ®tra si demandant un compte spÃ©cifique.',0),(324571,9016,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã¯è¡¨ç¤ºã•ã‚Œã¾ã›ã‚“ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒæ´»å‹•ã‚’æŒã£ã¦ã„ãªã„å ´åˆã€ãƒ¬ãƒãƒ¼ãƒˆã¯ã™ã¹ã¦ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã¾ãŸã¯ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ç¯„å›²ã‚’å°åˆ·ã—ã¾ã™ã€‚<br><br>ç‰¹å®šã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¦æ±‚ã™ã‚‹ 1 ã¤ã®æœŸé–“ã‚¢ã',0),(324572,9016,'pt','Se uma conta nÃ£o tem atividade, a conta nÃ£o aparecerÃ¡ no relatÃ³rio Ã© imprimir todas contas ou um intervalo de contas.<br><br>Uma conta sem atividade por um perÃ­odo aparecerÃ£o se solicitando uma conta especÃ­fica.',0),(324573,9016,'ru','Ð•ÑÐ»Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½ÐµÑ‚ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸, ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð½Ðµ Ð±ÑƒÐ´ÐµÑ‚ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒÑÑ Ð½Ð° Ð´Ð¾ÐºÐ»Ð°Ð´ Ð½Ð°Ñ…Ð¾Ð´Ð¸Ñ‚ÑÑ Ð² Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð²ÑÐµ ÑÑ‡ÐµÑ‚Ð° Ð¸Ð»Ð¸ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ ÑÑ‡ÐµÑ‚Ð¾Ð².<br><br>Ð•Ñ',0),(324574,9016,'es','Si una cuenta no tiene actividad, la cuenta no aparecerÃ¡n en el informe se va a imprimir todas las cuentas o un rango de cuentas. <br><br>Una cuenta con ninguna actividad para un perÃ­odo aparecerÃ¡ si solicita una cuenta especÃ­fica.',0),(324575,9016,'de','Wenn ein Konto keine AktivitÃ¤t hat, das Konto wird nicht angezeigt auf der Bericht ist Sie drucken alle oder eine Auswahl von Konten.<br><br>Ein Konto ohne AktivitÃ¤t pro Periode wird angezeigt, wenn ein bestimmtes Konto anfordern.',0),(324576,9016,'en',' If an account has no activity, the account will not appear on the report is you are printing All Account or a Range of Accounts. <br><br>An account with no activity for one period will appear if requesting a specific account. ',0),(324577,9017,'is','',0),(324578,9017,'dr','4: Ù‡Ù… ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø®Ø¯Ù…Ø§Øª  Ùˆ Ù‡Ù… ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø§Ø¬Ø±Ø§  Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø²  Ù¾Ø±Ø¯Ø§Ø²Ø´  ØªÙˆØ³Ø· Ù…Ø¯Ù„ ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø³Ø§ÙØª ÙˆÛŒØ± ØªØ§ÙŠÙŠØ¯ Ø´ÙˆÙ†Ø¯ . Ú¯Ø²Ø§Ø±Ø´ ÙØ±Ù…Ø§ÛŒØ´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ Ø±Ø§ Ø¼/textarea><input t',0),(324579,9017,'pr','ØªØ°ÙƒØ± 4: Ù‡Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø¯Ù…Ø§Øª  Ùˆ Ù‡Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§  Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø²  Ù¾Ø±Ø¯Ø§Ø²Ø´  ØªÙˆØ³Ø· Ù…Ø¯Ù„ Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ØªØ§ÙŠÙŠØ¯ Ø´ÙˆÙ†Ø¯ . Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ Ø±Ø§ Ø¼/textarea><input t',0),(324580,9017,'tr','Servis sipariÅŸlerini ve Fulfillment sipariÅŸler sistemin emirleri modÃ¼lÃ¼ ile iÅŸlenebilir Ã¶nce onaylanmalÄ±dÄ±r.<br><br>DoÄŸrulanmayan sipariÅŸleri gÃ¶rmek iÃ§in raporu Ã§alÄ±ÅŸtÄ±rÄ±n.',0),(324581,9017,'pl','ZarÃ³wno zleceÅ„ serwisowych, jak i realizacji zamÃ³wienia musi byÄ‡ potwierdzone, zanim zostanÄ… one przetworzone przez moduÅ‚ systemu zamÃ³wieÅ„.<br><br>Uruchom niepotwierdzone zamÃ³wienia raport, aby zobaczyÄ‡ listÄ™.',0),(324582,9017,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð· Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¸, Ð¿Ñ€ÐµÐ´Ð¸ Ñ‚Ðµ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ Ñ‡Ñ€ÐµÐ· ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¼Ð¾Ð´ÑƒÐ».<br><br>Ð¡Ñ‚Ð°Ñ€Ñ‚Ð¸',0),(324583,9017,'ur','Ø§Ø³ Ø³Û’ Ù¾ÛÙ„Û’ Ú©Û ÙˆÛ Ø§Ø³ Ù†Ø¸Ø§Ù… Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù…Ø§ÚˆÛŒÙˆÙ„ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ø¹Ù…Ù„Ø¯Ø±Ø¢Ù…Ø¯ Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø§ÙˆØ± Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª ØªÙˆØ«ÛŒÙ‚ Ú©Ø±Ù†ÛŒ Ú†Ø§ÛÛŒÛ’ Û”<b',0),(324584,9017,'sr','ÐÐ°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ, ÐºÐ°Ð¾ Ð¸ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð¼Ð¾Ñ€Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ð¸ Ð¿Ñ€Ðµ Ð½ÐµÐ³Ð¾ ÑˆÑ‚Ð¾ Ð¾Ð½Ð¸ Ð¼Ð¾Ð³Ñƒ Ð¾Ð±Ñ€Ð°Ð´Ð¸Ñ‚Ð¸ ÐºÑ€Ð¾Ð· Ð¼Ð¾Ð´ÑƒÐ» Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°.<br><br>ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸Ñ‚Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ',0),(324585,9017,'vi','ÄÆ¡n hÃ ng Dá»‹ch vá»¥ & Ä‘Æ¡n hÃ ng giao táº­n nÆ¡i pháº£i Ä‘Æ°á»£c xÃ¡c nháº­n trÆ°á»›c khi xá»­ lÃ½ trÃªn Modun NolaPro Ä‘áº·t hÃ ng.  Cháº¡y bÃ¡o cÃ¡o Ä‘Æ¡n hÃ ng chÆ°a xÃ¡c nháº­n Ä‘á»ƒ xem danh sÃ¡ch.',0),(324586,9017,'af','Beide Diens Bestellings en Vervullingsbestelling moet bevestig word, alvorens hul geprosesser word deur NolaPro se Bestellings Module.  <br><br>Loop die Onbevestigde Bestellings Verslag om die Lys te sien.',0),(324587,9017,'ro','Comenzi de Service ÅŸi de Ã®mplinire comenzile trebuie sÄƒ fie confirmate Ã®nainte ca acestea pot fi prelucrate prin modul de comenzi al sistemului.<br><br>Raportul Comenzi neconfirmate pentru a vedea o listÄƒ a alerga.',0),(324588,9017,'et','Hooldustellimuste ja plaanitud tellimusi tuleb kinnitada enne tÃ¶Ã¶tlemist sÃ¼steemi tellimuste moodul.<br><br>Kinnitamata korralduste aruande loendi kÃ¤ivitamine.',0),(324589,9017,'si','Servisnih nalogov in izpolnitev naroÄila mora biti potrjena, preden jih lahko obdela preko sistema naroÄila modul.<br><br>TeÄi nepotrjenih naroÄil poroÄilo za prikaz seznama.',0),(324590,9017,'ba','Layanan pesanan dan pemenuhan order harus dikonfirmasi sebelum mereka dapat diproses melalui sistem order modul.<br><br>Jalankan laporan pesanan belum dikonfirmasi untuk melihat daftar.',0),(324591,9017,'nl','Zowel serviceorders en vervulling Orders moet worden bevestigd voordat ze kunnen worden verwerkt door het systeem Orders Module.<br><br>De onbevestigde Orders rapport om te zien een lijst uitvoeren.',0),(324592,9017,'fi','Huoltotilausten ja tÃ¤yttÃ¤Ã¤ tilaukset on vahvistettava, ennen kuin ne voidaan kÃ¤sitellÃ¤ kautta tilaukset ajurimodulit.<br><br>Suorita vahvistamattomat Tilaukset-raportti nÃ¤hdÃ¤ksesi luettelon.',0),(324593,9017,'no','BÃ¥de serviceordrer og fullfÃ¸ringen bestillinger mÃ¥ bekreftes fÃ¸r de kan behandles gjennom systemets ordrer modul.<br><br>KjÃ¸r rapporten for ubekreftede ordrer Ã¥ se en liste.',0),(324594,9017,'da','BÃ¥de serviceordrer og Fulfillment ordrer skal bekrÃ¦ftes, fÃ¸r de kan blive behandlet gennem systemets ordrer modul.<br><br>KÃ¸r rapporten ubekrÃ¦ftede ordrer til at se en liste.',0),(324595,9017,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ë° ì£¼ë¬¸ì´ í–‰ ì‹œìŠ¤í…œì˜ ì£¼ë¬¸ ëª¨ë“ˆì„ í†µí•´ ì²˜ë¦¬ ë  ìˆ˜ ìžˆìŠµë‹ˆë‹¤ ì „ì— í™•ì¸ ë˜ì–´ì•¼ í•œë‹¤.<br><br>ëª©ë¡ì„ ë³´ë ¤ë©´ ë¯¸í™•ì¸ ì£¼ë¬¸ ë³´ê³ ì„œë¥¼ ì‹¤í–‰ í•©ë‹ˆë‹¤.',0),(324596,9017,'he','×”×–×ž× ×•×ª ×©×™×¨×•×ª ×•×”×–×ž× ×•×ª ×”×’×©×ž×” ×™×© ×œ××©×¨ ×œ×¤× ×™ ×©×”×Ÿ ×ž×¢×•×‘×“×•×ª ×‘××ž×¦×¢×•×ª ×ž×•×“×•×œ ×”×–×ž× ×•×ª ×©×œ ×”×ž×¢×¨×›×ª.<br><br>×œ×”×¤×¢×™×œ ××ª ×”×“×•×— ×”×–×ž× ×•×ª ×©×œ× ××•×©×¨×• ×›×“×™ ×œ×¨××•×ª ×¨×©×™×ž×”.',0),(324597,9017,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ ÎºÎ±Î¹ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï… Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯ Ï€ÏÎ¿Ï„Î¿Ï ÎºÎ±Ï„Î±ÏƒÏ„ÎµÎ¯ Î´Ï…Î½Î±Ï„Î® Î· ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼Î­ÏƒÏ‰ Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÎµÎ½ÏŒÏ„Î·Ï',0),(324598,9017,'zh','æ‰€æœ‰æœåŠ¡è®¢å•å’Œå±¥è¡Œè®¢å•å¿…é¡»åœ¨å®ƒä»¬é€šè¿‡NolaProå‘½ä»¤æ¨¡å—å¤„ç†å‰ç¡®è®¤ã€‚  è¿è¡Œæœªç»ç¡®è®¤çš„è®¢å•æŠ¥è¡¨ä»¥æŸ¥çœ‹ä¸€ä¸ªåˆ—è¡¨ã€‚\r\n',0),(324599,9017,'sv','BÃ¥de serviceorder och uppfyllelse order mÃ¥ste bekrÃ¤ftas innan de kan bearbetas genom systemets order modul.<br><br>KÃ¶r rapporten obekrÃ¤ftade order att se en lista.',0),(324600,9017,'it','Entrambi gli ordini di servizio ed evasione ordini devono essere confermati prima che possono essere elaborati attraverso modulo del sistema ordini.<br><br>Eseguire il Report ordini non confermati per vedere un elenco.',0),(324601,9017,'tl','',0),(324602,9017,'th','Both Service Orders and Fulfillment Orders must be confirmed before they can be processed through NolaPro\'s Orders Module. <br><br>Run the Unconfirmed Orders Report to see a List.',0),(324603,9017,'hi','à¤‡à¤¸à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤•à¤¿ à¤µà¥‡ à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¦à¥‹à¤¨à¥‹à¤‚ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤”à¤° à¤ªà¥‚à¤°à¥à¤¤à¤',0),(324604,9017,'ms','Arahan Perkhidmatan dan arahan memenuhi mesti disahkan sebelum mereka dapat diproses melalui Sistem Tempahan modul.<br><br>Jalankan laporan pesanan belum disahkan untuk melihat senarai.',0),(324605,9017,'ar','ÙŠØ¬Ø¨ ØªØ£ÙƒÙŠØ¯ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© ÙˆØ£ÙˆØ§Ù…Ø± Ø§Ù„ÙˆÙØ§Ø¡ Ù‚Ø¨Ù„ Ø£Ù†Ù‡Ø§ ÙŠÙ…ÙƒÙ† Ù…Ø¹Ø§Ù„Ø¬ØªÙ‡Ø§ Ù…Ù† Ø®Ù„Ø§Ù„ \"Ø£ÙˆØ§Ù…Ø± Ø§Ù„ÙˆØ­Ø¯Ø© Ø§Ù„Ù†Ù…Ø·ÙŠØ©\" Ø§Ù„Ù†Ø¸Ø§Ù….<br><br>Ù‚Ù… Ø¨ØªØ´ØºÙŠÙ„ \"Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø£ÙˆØ§Ù…Ø± ØºÙŠØ± Ù…Ø¤ÙƒØ¯Ø©\" Ù„Ù…Ø',0),(324606,9017,'fr','Les commandes de Service et des ordres doivent Ãªtre confirmÃ©es avant qu\'ils peuvent Ãªtre traitÃ©es par Module du systÃ¨me de commandes.<br><br>ExÃ©cutez le rapport de commandes non confirmÃ©es pour afficher la liste.',0),(324607,9017,'jp','ã‚·ã‚¹ãƒ†ãƒ ã®æ³¨æ–‡ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã‚’ä½¿ç”¨ã—ã¦å‡¦ç†ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™å‰ã«ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ãŠã‚ˆã³ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ãƒ» ã‚ªãƒ¼ãƒ€ãƒ¼ã‚’ç¢ºèªã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚<br><br>ä¸€è¦§ã‚’è¡¨ç¤ºã™ã‚‹æœªç¢ºèªã®æ³¨æ–‡ãƒ¬ãƒãƒ¼ãƒ',0),(324608,9017,'pt','Tanto as ordens de serviÃ§o e cumprimento de ordens devem ser confirmadas antes que eles possam ser processados atravÃ©s do mÃ³dulo de ordens do sistema.<br><br>Execute o relatÃ³rio de pedidos nÃ£o confirmados para ver uma lista.',0),(324609,9017,'ru','Ð¡Ð»ÑƒÐ¶Ð±Ð° Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¸ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð°, Ð¿Ñ€ÐµÐ¶Ð´Ðµ Ñ‡ÐµÐ¼ Ð¾Ð½Ð¸ Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½Ñ‹ Ñ‡ÐµÑ€ÐµÐ· Ð¼Ð¾Ð´ÑƒÐ»ÑŒ ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð¾Ð².<br><br>Ð—Ð°Ð¿ÑƒÑ',0),(324610,9017,'es','Tanto Ã“rdenes de Servicio como del Cumplimiento deben ser confirmados antes de que puedan ser procesados a travÃ©s del MÃ³dulo de Ã³rdenes de NolaPro . <br> <br> Abre el Informe de Ã“rdenes no Confirmados para ver una Lista.',0),(324611,9017,'de','ServiceauftrÃ¤ge und Fulfillment-Bestellungen muss bestÃ¤tigt werden, bevor sie durch des Systems Bestellmodul verarbeitet werden kÃ¶nnen.<br><br>FÃ¼hren Sie den nicht bestÃ¤tigte Bestellungen-Bericht um eine Liste anzuzeigen.',0),(324612,9017,'en','Both Service Orders and Fulfillment Orders must be confirmed before they can be processed through the system\'s Orders Module. <br><br>Run the Unconfirmed Orders Report to see a List.',0),(324613,9018,'is','',0),(324614,9018,'dr','ØªØ°ÙƒØ±  5 : Ø§Ø­ØªÙ…Ø§Ù„Ø§ Ú†ÙˆÙ† Ø¯ÙŠÚ¯Ø± Ø¨ÛŒØ¬Ú©  Ø¯Ø± ÙˆØ¶Ø¹ÙŠØª  \" Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ \" Ù†ÙŠØ³Øª . Ø´Ù…Ø§ Ù†ÙŠØ§Ø² Ø¯Ø§Ø±ÙŠØ¯ ÙƒÙ‡ Ø§ØµÙ„Ø§Ø­  Ø¨ÛŒØ¬Ú©Ù‡Ø§ Ø±Ø§ Ø¨ÙŠØ§ÙˆØ±ÙŠØ¯ Ùˆ Ø¬Ø¹Ø¨Ù‡ Ø±Ø§ Ú†Ùƒ ÙƒÙ†ÙŠØ¯ . ÙÙ‚Ø· Ø¨ÛŒØ¬Ú©Ù‡Ø§ÙŠ  ',0),(324615,9018,'pr','ØªØ°ÙƒØ±  5 : Ø§Ø­ØªÙ…Ø§Ù„Ø§ Ú†ÙˆÙ† Ø¯ÙŠÚ¯Ø± ÙØ§ÙƒØªÙˆØ±  Ø¯Ø± ÙˆØ¶Ø¹ÙŠØª  \" Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ \" Ù†ÙŠØ³Øª . Ø´Ù…Ø§ Ù†ÙŠØ§Ø² Ø¯Ø§Ø±ÙŠØ¯ ÙƒÙ‡ ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ø±Ø§ Ø¨ÙŠØ§ÙˆØ±ÙŠØ¯ Ùˆ Ø¬Ø¹Ø¨Ù‡ Ø±Ø§ Ú†Ùƒ ÙƒÙ†ÙŠØ¯ . ÙÙ‚Ø· ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ  ',0),(324616,9018,'tr','Fatura artÄ±k \"bitmiÅŸ\" bir durum olduÄŸundan bu. DÃ¼zenleme faturalar getirmek ve onay kutusunu gerekir: <ul>gÃ¶stermek sadece terk edilmiÅŸ, eksik fatura</ul>. Bu eksik durum faturalarÄ±nÄ±n listesini getirecektir.',0),(324617,9018,'pl','To prawdopodobnie, poniewaÅ¼ faktura jest juÅ¼ w statusie \"gotowy\". Trzeba przywoÅ‚aÄ‡ edycja faktur i zaznacz pole wyboru: <ul>PokaÅ¼ tylko porzucony, faktury niekompletny</ul>. Spowoduje to wyÅ›wietlenie listy faktury niekompletny statusu.',0),(324618,9018,'bg','Ð¢Ð¾Ð²Ð° Ðµ Ð²ÐµÑ€Ð¾ÑÑ‚Ð½Ð¾, Ð·Ð°Ñ‰Ð¾Ñ‚Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð²ÐµÑ‡Ðµ Ð½Ðµ Ðµ Ð² ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° \"Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð°\". Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð²ÐµÐ´Ðµ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¾Ñ‚Ð¼ÐµÑ‚ÐºÐ° Ð² ÐºÐ²Ð°Ð´Ñ€Ð°Ñ',0),(324619,9018,'ur','ÛŒÛ Ø´Ø§ÛŒØ¯ ÛÛ’ Ú©ÛŒÙˆÙ†Ú©Û Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…ÛŒÚº Ø§ÛŒÚ© \"Ø®ØªÙ…\" Ú©ÛŒ Ø­ÛŒØ«ÛŒØª Ù…ÛŒÚº Ù†ÛÛŒÚº ÛÛ’ Û” Ø¢Ù¾ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† ÙˆØ¨Ø¬Ù„ÛŒ Ø§Ù¾ Ù„Ø§ Ú©Ø± Ø®Ø§Ù†Û Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’: <ul>ØŒ Ù†Ø§Ù…Ú©Ù…Ù„ ÙˆØ¨Ø¬Ù„ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚ',0),(324620,9018,'sr','ÐžÐ²Ð¾ Ñ˜Ðµ Ð²ÐµÑ€Ð¾Ð²Ð°Ñ‚Ð½Ð¾ Ñ˜ÐµÑ€ Ñ˜Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¸Ñ˜Ðµ Ñƒ \"Ð³Ð¾Ñ‚Ð¾Ð²\" ÑÑ‚Ð°Ñ‚ÑƒÑ. Ð¢Ñ€ÐµÐ±Ð° Ð´Ð° ÑÐ¿Ð¾Ð¼ÐµÐ½ÐµÐ¼ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ð¾Ñ€ Ñƒ Ð¿Ð¾Ñ™Ñƒ: <ul>ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð½Ð°Ð¿ÑƒÑÑ‚Ð¸Ð»Ð',0),(324621,9018,'vi','CÃ³ thá»ƒ hÃ³a Ä‘Æ¡n nÃ y khÃ´ng cÃ²n trong tÃ¬nh tráº¡ng hoÃ n thÃ nh ná»¯a. Báº¡n pháº£i Chá»‰nh Sá»­a HÃ³a ÄÆ¡n, Ä‘Ã¡nh dáº¥u há»™p: <ul>Chá»‰ hiá»ƒn thá»‹ hÃ³a Ä‘Æ¡n bá», chÆ°a hoÃ n táº¥t</ul> Ä‘á»ƒ xem danh sÃ¡ch hÃ³a Ä‘Æ¡n trong tÃ¬nh tráº¡ng chï',0),(324622,9018,'af','Dit is waarskynlik omdat die faktuur is nie meer in \'n \"voltooide\" status. Moet jy redigeer fakture bring, en merk die blokkie: <ul>Wys net verlate, onvolledige fakture</ul>. Dit sal \'n lys van fakture in die onvolledige status bring.',0),(324623,9018,'ro','Acest lucru este, probabil, deoarece factura nu mai este Ã®n starea \"terminat\". AveÅ£i nevoie pentru a aduce edita facturi, ÅŸi bifaÅ£i caseta: <ul>AratÄƒ numai abandonat, facturi Incomplete</ul>. Acest lucru va aduce o listÄƒ de facturi Ã®n starea incomp',0),(324624,9018,'et','See on ilmselt seetÃµttu arve enam ei \"lÃµpetatud\" olek. Peate redigeerida arvete avab ja linnuke kasti: <ul>nÃ¤idata ainult mahajÃ¤etud, puudulik arved</ul>. See avab loendi arvete puudulik olek.',0),(324625,9018,'si','To je verjetno ker raÄun ni veÄ \"konÄal\" status. Boste morali bruhati urejanje raÄunov, ter Äek Å¡katla: <ul>PokaÅ¾i samo opustili, nepopolne raÄune</ul>. To hoteti bruhati seznam raÄunov v nepopolni status.',0),(324626,9018,'ba','Hal ini mungkin karena faktur tidak lagi dalam status \"selesai\". Anda perlu membawa mengedit faktur, dan centang kotak: <ul>Tampilkan hanya ditinggalkan, faktur tidak lengkap</ul>. Ini akan memunculkan daftar tagihan dalam status tidak lengkap.',0),(324627,9018,'nl','Dit is waarschijnlijk omdat de factuur niet langer in een status \'Gereedgemeld is\'. U wilt facturen bewerken opvoeden, en vink het vakje: <ul>Toon alleen verlaten, onvolledige facturen</ul>. Dit zal omhoog een lijst van facturen in de status Onvolledige b',0),(324628,9018,'fi','TÃ¤mÃ¤ johtuu todennÃ¤kÃ¶isesti laskun ei enÃ¤Ã¤ ole \"valmis\"-tila. Sinun tÃ¤ytyy tuoda esille muokata laskuja, ja ruudullinen lyÃ¶dÃ¤: <ul>NÃ¤ytÃ¤ vain hylÃ¤tty, puutteellinen laskuja</ul>. TÃ¤mÃ¤ tuo esiin luettelon laskuista epÃ¤tÃ¤ydellisen statuksen.',0),(324629,9018,'no','Dette er sannsynligvis fordi fakturaen er ikke lenger en \"ferdig\" status. Du mÃ¥ bringe redigere fakturaer, og Merk: <ul>Vis bare forlatt, ufullstendig fakturaer</ul>. Dette vil fÃ¥ opp en liste over fakturaer i ufullstendige status.',0),(324630,9018,'da','Dette skyldes sandsynligvis, at fakturaen er ikke lÃ¦ngere i en \"fÃ¦rdig\" status. Du skal opdrage redigere fakturaer, og Marker afkrydsningsfeltet: <ul>Vis kun opgivet, ufuldstÃ¦ndige fakturaer</ul>. Dette vil opdrage en liste over fakturaer i ufuldstÃ¦nd',0),(324631,9018,'ko','ì´ê²ƒì€ ì•„ë§ˆë„ ì†¡ìž¥ \"ì™„ë£Œ\" ìƒíƒœì— ë” ì´ìƒ ìžˆê¸° ë•Œë¬¸ ì—ìž…ë‹ˆë‹¤. íŽ¸ì§‘ ì¸ë³´ì´ìŠ¤ë¥¼ ê°€ì ¸ì˜¤ê³  í™•ì¸ëž€ì„ ì„ íƒ í•´ì•¼: <ul>í¬ê¸°ë§Œ í‘œì‹œ, ë¶ˆì™„ì „ í•œ ì†¡ìž¥</ul>. ì´ ë¶ˆì™„ì „ í•œ ìƒíƒœì—ì„œ ì¸ë³´ì´ìŠ¤ì˜ ëª©ë¡ì„ ',0),(324632,9018,'he','×–×” ×›× ×¨××” ×‘×’×œ×œ ×”×—×©×‘×•× ×™×ª ×›×‘×¨ ×œ× × ×ž×¦××ª ×‘×ž×¦×‘ \"×ž×•×’×ž×¨×ª\". ××ª×” ×¦×¨×™×š ×œ×”×¢×œ×•×ª ××ª ×—×©×‘×•× ×™×•×ª ×œ×¢×¨×•×š, ×•×¡×ž×Ÿ ××ª ×”×ª×™×‘×”: <ul>×œ×”×¨××•×ª ×¨×§ × ×˜×•×©, ×—×©×‘×•× ×™×•×ª ×©×œ× ×”×•×©×œ×ž×•</ul>. ×',0),(324633,9018,'el','Î‘Ï…Ï„ÏŒ ÎµÎ¯Î½Î±Î¹ Ï€Î¹Î¸Î±Î½ÏŽÏ‚ ÎµÏ€ÎµÎ¹Î´Î® Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎµÎ¯Î½Î±Î¹ Ï€Î»Î­Î¿Î½ ÏƒÎµ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· \"Ï„ÎµÎ»Î¹ÎºÏŒ\". Î˜Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï†Î­ÏÎµÎ¹ ÎµÏ€Î¬Î½Ï‰ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±, ÎºÎ±Î¹ ÎµÎ»Î­Î³Ï‡Ï‰ the ÎºÎ',0),(324634,9018,'zh','è¿™å¯èƒ½æ˜¯å› ä¸ºå‘ç¥¨æ¯”â€œå·²å®Œæˆâ€œçŠ¶æ€æ›´çŸ­ã€‚æ‚¨éœ€è¦å¸¦ç¼–è¾‘å‘ç¥¨ï¼Œå¹¶é€‰ä¸­è¯¥æ¡†ï¼š<ul>åªæ˜¾ç¤ºè¢«é—å¼ƒçš„ï¼Œä¸å®Œæ•´çš„å‘ç¥¨ã€‚åœ¨è¿™å°†å¸¦æ¥ä¸€ä¸ªä¸å®Œæ•´çš„çŠ¶æ€çš„å‘ç¥¨æ¸…å•ã€‚\r\n',0),(324635,9018,'sv','Detta Ã¤r fÃ¶rmodligen eftersom fakturan Ã¤r inte lÃ¤ngre i en \"fÃ¤rdig\" status. Du behÃ¶ver fÃ¥ upp redigera fakturor, och markera rutan: <ul>Visa bara Ã¶vergav, ofullstÃ¤ndiga fakturor</ul>. Detta kommer att ta upp en lista med fakturor i ofullstÃ¤ndig ',0),(324636,9018,'it','Questo Ã¨ probabilmente perchÃ© la fattura non Ã¨ piÃ¹ in uno stato di \"finito\". Ãˆ necessario portare la modifica fatture e la casella di controllo: <ul>mostrare solo abbandonata, fatture incompleta</ul>. Questo farÃ  apparire un elenco di fatture in sta',0),(324637,9018,'tl','',0),(324638,9018,'th','This is probably because the invoice is no longer in a \"finished\" status. You need to bring up Edit Invoices, and check the box: <ul>Show Only Abandoned, Incomplete Invoices</ul>. This will bring up a list of invoices in the incomplete status.',0),(324639,9018,'hi','à¤¯à¤¹ à¤¶à¤¾à¤¯à¤¦ à¤¹à¥ˆ à¤•à¥à¤¯à¥‹à¤‚à¤•à¤¿ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤…à¤¬ à¤•à¥‹à¤ˆ à¤à¤• \"à¤¸à¤®à¤¾à¤ªà¥à¤¤\" à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤®à¥‡à¤‚ à¤¹à¥ˆà¥¤ à¤†à¤ª à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤šà¤¾à¤²à¤¾à¤¨ à¤Šà¤ªà¤° à¤²à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤”à',0),(324640,9018,'ms','Ini adalah mungkin kerana invois tidak lagi dalam status \"selesai\". Anda perlu membawa Edit invois, dan tandakan kotak semak: <ul>menunjukkan hanya ditinggalkan, invois yang lengkap</ul>. Ini akan membuka senarai invois dalam status tidak lengkap.',0),(324641,9018,'ar','ÙˆÙ‡Ø°Ø§ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ø±Ø¬Ø­ Ù„Ø£Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù„Ù… ÙŠØ¹Ø¯ ÙÙŠ Ø­Ø§Ù„Ø© \"Ø§Ù†ØªÙ‡Ø§Ø¡\". ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ Ø¥Ø­Ø¶Ø§Ø± \"ØªØ­Ø±ÙŠØ± Ø§Ù„ÙÙˆØ§ØªÙŠØ±\"ØŒ ÙˆØ­Ø¯Ø¯ Ø§Ù„Ù…Ø±Ø¨Ø¹ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±: <ul>Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ØªØ®Ù„ÙŠ Ø¹Ù†Ù‡Ø§ ÙÙ‚Ø·ØŒ ÙˆØ§Ù„ÙÙˆØ§Ø',0),(324642,9018,'fr','C\'est probablement parce que la facture n\'est plus dans un Ã©tat Â« fini Â». Vous avez besoin afficher Ã©diter des factures et cochez la case : <ul>Afficher seulement abandonnÃ©, factures incomplÃ¨tes</ul>. Cela fera apparaÃ®tre une liste de factures dans',0),(324643,9018,'jp','ã“ã‚Œã¯ãŠãã‚‰ãã€è«‹æ±‚æ›¸ã¯ã‚‚ã¯ã‚„ã€Œå®Œæˆã—ãŸã€çŠ¶æ…‹ã§ã™ã€‚è«‹æ±‚æ›¸ã®ç·¨é›†ã‚’æŒã¡å‡ºã™ã¨ã€ãƒã‚§ãƒƒã‚¯ ãƒœãƒƒã‚¯ã‚¹ã‚’ã‚ªãƒ³ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ï¼š<ul>è¡¨ç¤ºã®ã¿æ”¾æ£„ã•ã‚ŒãŸã€ä¸å®Œå…¨ãªè«‹æ±‚æ›¸</ul>ã€‚ã“ã‚Œã¯ä¸',0),(324644,9018,'pt','Isto Ã© provavelmente porque a factura nÃ£o estÃ¡ em um status \"acabado\". VocÃª precisa trazer editar facturas e marque a caixa: <ul>Mostrar apenas abandonado, facturas incompletas</ul>. Isso irÃ¡ abrir uma lista de facturas no status incompleto.',0),(324645,9018,'ru','Ð­Ñ‚Ð¾, Ð²ÐµÑ€Ð¾ÑÑ‚Ð½Ð¾, Ð¿Ð¾Ñ‚Ð¾Ð¼Ñƒ Ñ‡Ñ‚Ð¾ ÑÑ‡ÐµÑ‚ ÑƒÐ¶Ðµ Ð½Ðµ Ð² ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ð¸ Â«Ð·Ð°ÐºÐ¾Ð½Ñ‡Ð¸Ð»Ð¸ÑÑŒÂ». Ð’Ð°Ð¼ Ð½ÑƒÐ¶Ð½Ð¾ Ð´Ð¾Ð²ÐµÑÑ‚Ð¸ Ð´Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð° Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ñ„Ð»Ð°Ð¶Ð¾Ðº: <ul>Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ð¾Ð',0),(324646,9018,'es','La factura ya no estÃ¡ en un \"acabado\" el estatuto. Usted necesidad de llevar hasta Editar facturas, y marque la casilla: Mostrar sÃ³lo <ul> abandonados, facturas incompletas </ ul>. Se abrirÃ¡ una lista de las facturas en el estado incompleto.',0),(324647,9018,'de','Dies ist wahrscheinlich, weil die Rechnung nicht mehr im Status \"beendet\". Sie brauchen, um Rechnungen bearbeiten, und aktivieren Sie das KontrollkÃ¤stchen: <ul>zeigen nur aufgegeben, unvollstÃ¤ndige Rechnungen</ul>. Dieses holt oben eine Liste von Rechnu',0),(324648,9018,'en','This is probably because the invoice is no longer in a \"finished\" status. You need to bring up Edit Invoices, and check the box: <ul>Show Only Abandoned, Incomplete Invoices</ul>. This will bring up a list of invoices in the incomplete status.',0),(324649,9019,'is','',0),(324650,9019,'dr','6',0),(324651,9019,'pr','ØªØ°ÙƒØ±  6',0),(324652,9019,'tr','Ä°pucu 6',0),(324653,9019,'pl','WskazÃ³wka 6',0),(324654,9019,'bg','Ð¡ÑŠÐ²ÐµÑ‚ 6',0),(324655,9019,'ur','Ø§Ø´Ø§Ø±Û 6',0),(324656,9019,'sr','ÐŸÐ¾Ð´ÑÐµÑ‚Ð½Ð¸Ðº Ð·Ð° 6',0),(324657,9019,'vi','Gá»£i Ã 6',0),(324658,9019,'af','Wenk 6',0),(324659,9019,'ro','Indiciu 6',0),(324660,9019,'et','Vihje 6',0),(324661,9019,'si','Namig 6',0),(324662,9019,'ba','Petunjuk 6',0),(324663,9019,'nl','Tip 6',0),(324664,9019,'fi','Vihje 6',0),(324665,9019,'no','Tips 6',0),(324666,9019,'da','Tip 6',0),(324667,9019,'ko','ížŒíŠ¸ 6',0),(324668,9019,'he','×¨×ž×– 6',0),(324669,9019,'el','Î£Ï…Î¼Î²Î¿Ï…Î»Î® 6',0),(324670,9019,'zh','æç¤º6\r\n',0),(324671,9019,'sv','Tips 6',0),(324672,9019,'it','Suggerimento 6',0),(324673,9019,'tl','',0),(324674,9019,'th','Hint 6',0),(324675,9019,'hi','à¤¸à¤‚à¤•à¥‡à¤¤ 6',0),(324676,9019,'ms','Petunjuk 6',0),(324677,9019,'ar','ØªÙ„Ù…ÙŠØ­ 6',0),(324678,9019,'fr','Astuce 6',0),(324679,9019,'jp','6 ã®ãƒ’ãƒ³ãƒˆ',0),(324680,9019,'pt','Dica 6',0),(324681,9019,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ° 6',0),(324682,9019,'es','Indicio 6',0),(324683,9019,'de','Tipp 6',0),(324684,9019,'en','Hint 6',0),(324685,9020,'is','',0),(324686,9020,'dr','7',0),(324687,9020,'pr','ØªØ°ÙƒØ± 7',0),(324688,9020,'tr','Ä°pucu 7',0),(324689,9020,'pl','WskazÃ³wka 7',0),(324690,9020,'bg','Ð¡ÑŠÐ²ÐµÑ‚ 7',0),(324691,9020,'ur','Ø§Ø´Ø§Ø±Û 7',0),(324692,9020,'sr','ÐŸÐ¾Ð´ÑÐµÑ‚Ð½Ð¸Ðº Ð·Ð° 7',0),(324693,9020,'vi','Gá»£i Ã 7',0),(324694,9020,'af','Wenk 7',0),(324695,9020,'ro','Indiciu 7',0),(324696,9020,'et','Vihje 7',0),(324697,9020,'si','Namig 7',0),(324698,9020,'ba','Petunjuk 7',0),(324699,9020,'nl','Tip 7',0),(324700,9020,'fi','Vihje 7',0),(324701,9020,'no','Tips 7',0),(324702,9020,'da','Tip 7',0),(324703,9020,'ko','ížŒíŠ¸ 7',0),(324704,9020,'he','×¨×ž×– 7',0),(324705,9020,'el','Î¥Ï€ÏŒÎ´ÎµÎ¹Î¾Î· 7',0),(324706,9020,'zh','æç¤º7\r\n',0),(324707,9020,'sv','Tips 7',0),(324708,9020,'it','Suggerimento 7',0),(324709,9020,'tl','',0),(324710,9020,'th','Hint 7',0),(324711,9020,'hi','à¤¸à¤‚à¤•à¥‡à¤¤ 7',0),(324712,9020,'ms','Pembayang 7',0),(324713,9020,'ar','ØªÙ„Ù…ÙŠØ­ 7',0),(324714,9020,'fr','Astuce 7',0),(324715,9020,'jp','7 ã®ãƒ’ãƒ³ãƒˆ',0),(324716,9020,'pt','Dica 7',0),(324717,9020,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ° 7',0),(324718,9020,'es','Indicio 7',0),(324719,9020,'de','Tipp 7',0),(324720,9020,'en','Hint 7',0),(324721,9021,'is','',0),(324722,9021,'dr','8',0),(324723,9021,'pr','ØªØ°ÙƒØ± 8',0),(324724,9021,'tr','Ä°pucu 8',0),(324725,9021,'pl','WskazÃ³wka 8',0),(324726,9021,'bg','Ð¡ÑŠÐ²ÐµÑ‚ 8',0),(324727,9021,'ur','Ø§Ø´Ø§Ø±Û 8',0),(324728,9021,'sr','ÐŸÐ¾Ð´ÑÐµÑ‚Ð½Ð¸Ðº Ð·Ð° 8',0),(324729,9021,'vi','Gá»£i Ã 8',0),(324730,9021,'af','Wenk 8',0),(324731,9021,'ro','Indiciu 8',0),(324732,9021,'et','Vihje 8',0),(324733,9021,'si','Namig 8',0),(324734,9021,'ba','Petunjuk 8',0),(324735,9021,'nl','Tip 8',0),(324736,9021,'fi','Vihje 8',0),(324737,9021,'no','Tips 8',0),(324738,9021,'da','Tip 8',0),(324739,9021,'ko','ížŒíŠ¸ 8',0),(324740,9021,'he','×¨×ž×– 8',0),(324741,9021,'el','Î£Ï…Î¼Î²Î¿Ï…Î»Î® 8',0),(324742,9021,'zh','æç¤º8\r\n',0),(324743,9021,'sv','Tips 8',0),(324744,9021,'it','Suggerimento 8',0),(324745,9021,'tl','',0),(324746,9021,'th','Hint 8',0),(324747,9021,'hi','à¤¸à¤‚à¤•à¥‡à¤¤ 8',0),(324748,9021,'ms','Pembayang 8',0),(324749,9021,'ar','ØªÙ„Ù…ÙŠØ­ 8',0),(324750,9021,'fr','Astuce 8',0),(324751,9021,'jp','8 ã®ãƒ’ãƒ³ãƒˆ',0),(324752,9021,'pt','Dica 8',0),(324753,9021,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ° 8',0),(324754,9021,'es','Indicio 8',0),(324755,9021,'de','Tipp 8',0),(324756,9021,'en','Hint 8',0),(324757,9022,'is','',0),(324758,9022,'dr','9 ',0),(324759,9022,'pr','ØªØ°ÙƒØ± 9 ',0),(324760,9022,'tr','Ä°pucu 9',0),(324761,9022,'pl','WskazÃ³wka 9',0),(324762,9022,'bg','Ð¡ÑŠÐ²ÐµÑ‚ 9',0),(324763,9022,'ur','Ø§Ø´Ø§Ø±Û 9',0),(324764,9022,'sr','ÐŸÐ¾Ð´ÑÐµÑ‚Ð½Ð¸Ðº Ð·Ð° 9',0),(324765,9022,'vi','Gá»£i Ã 9',0),(324766,9022,'af','Wenk 9',0),(324767,9022,'ro','Indiciu 9',0),(324768,9022,'et','Vihje 9',0),(324769,9022,'si','Namig 9',0),(324770,9022,'ba','Petunjuk 9',0),(324771,9022,'nl','Tip 9',0),(324772,9022,'fi','Vihje 9',0),(324773,9022,'no','Tips 9',0),(324774,9022,'da','Vink 9',0),(324775,9022,'ko','ížŒíŠ¸ 9',0),(324776,9022,'he','×¨×ž×– 9',0),(324777,9022,'el','Î¥Ï€ÏŒÎ´ÎµÎ¹Î¾Î· 9',0),(324778,9022,'zh','æç¤º9\r\n',0),(324779,9022,'sv','Tips 9',0),(324780,9022,'it','Suggerimento 9',0),(324781,9022,'tl','',0),(324782,9022,'th','Hint 9',0),(324783,9022,'hi','à¤¸à¤‚à¤•à¥‡à¤¤ 9',0),(324784,9022,'ms','Pembayang 9',0),(324785,9022,'ar','ØªÙ„Ù…ÙŠØ­ 9',0),(324786,9022,'fr','Astuce 9',0),(324787,9022,'jp','ãƒ’ãƒ³ãƒˆ 9',0),(324788,9022,'pt','Dica 9',0),(324789,9022,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ° 9',0),(324790,9022,'es','Indicio 9',0),(324791,9022,'de','Tipp 9',0),(324792,9022,'en','Hint 9',0),(324793,9023,'is','',0),(324794,9023,'dr','Ø¬ÙˆØ§Ø¨',0),(324795,9023,'pr','Ø¬ÙˆØ§Ø¨',0),(324796,9023,'tr','Cevap',0),(324797,9023,'pl','OdpowiedÅº',0),(324798,9023,'bg','ÐžÑ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(324799,9023,'ur','Ø¬ÙˆØ§Ø¨',0),(324800,9023,'sr','ÐžÐ´Ð³Ð¾Ð²Ð¾Ñ€',0),(324801,9023,'vi','Tráº£ lá»i',0),(324802,9023,'af','Antwoord',0),(324803,9023,'ro','RÄƒspunsul',0),(324804,9023,'et','Vastus',0),(324805,9023,'si','Odgovor',0),(324806,9023,'ba','Jawaban',0),(324807,9023,'nl','Antwoord',0),(324808,9023,'fi','Vastaus',0),(324809,9023,'no','Svar',0),(324810,9023,'da','Svar',0),(324811,9023,'ko','ëŒ€ë‹µ',0),(324812,9023,'he','×”×ª×©×•×‘×”',0),(324813,9023,'el','Î‘Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(324814,9023,'zh','ç­”æ¡ˆ\r\n',0),(324815,9023,'sv','Svar',0),(324816,9023,'it','Risposta',0),(324817,9023,'tl','',0),(324818,9023,'th','&#3588;&#3635;&#3605;&#3629;&#3610;',0),(324819,9023,'hi','à¤‰à¤¤à¥à¤¤à¤°',0),(324820,9023,'ms','Jawapan',0),(324821,9023,'ar','Ø¬ÙˆØ§Ø¨',0),(324822,9023,'fr','RÃ©ponse',0),(324823,9023,'jp','ç­”ãˆ',0),(324824,9023,'pt','Resposta',0),(324825,9023,'ru','ÐžÑ‚Ð²ÐµÑ‚',0),(324826,9023,'es','Respuesta',0),(324827,9023,'de','Antwort',0),(324828,9023,'en','Answer',0),(324829,9024,'is','',0),(324830,9024,'dr','1 : Ú†Ù‡ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡ Ùˆ ØªØ®ÙÙŠÙØ§ØªÙŠ  Ø¯Ø±Ø®Ù„Ø§ØµÙ‡  Ú†Ùƒ Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ù†Ø¯ ØŸ',0),(324831,9024,'pr','ØªØ°ÙƒØ± 1 : Ú†Ù‡ Ø¯Ø³ØªÙ…Ø²Ø¯ Ùˆ ØªØ®ÙÙŠÙØ§ØªÙŠ  Ø¯Ø±Ø®Ù„Ø§ØµÙ‡  Ú†Ùƒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ù†Ø¯ ØŸ',0),(324832,9024,'tr','Ne Ã¼cret ve kesintiler bir bordro Ã–zet kontrol dahildir?',0),(324833,9024,'pl','Jakie zarobki i odliczeÅ„ znajdujÄ… siÄ™ na Podsumowanie sprawdÅº listy pÅ‚ac?',0),(324834,9024,'bg','ÐšÐ°ÐºÐ²Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¸ ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸ ÑÐ° Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð²ÑŠÐ² Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ñ‚Ð° ÑˆÐ°Ñ… Ð ÐµÐ·ÑŽÐ¼Ðµ?',0),(324835,9024,'ur','Ú©ÛŒØ§ Ø§Ø¬Ø±Øª Ø§ÙˆØ± Ú©Ù¹ÙˆØªÛŒÙˆÚº Ù¾Û’ Ø±ÙˆÙ„ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ø®Ù„Ø§ØµÛ Ù¾Ø± Ø´Ø§Ù…Ù„ ÛÛŒÚºØŸ',0),(324836,9024,'sr','ÐšÐ°ÐºÐ²Ðµ Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ Ð½Ð°Ð»Ð°Ð·Ðµ ÑÐµ Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ñ€ÐµÐ·Ð¸Ð¼Ðµ?',0),(324837,9024,'vi','Loáº¡i lÆ°Æ¡ng & giáº£m trá»« nÃ o sáº½ bao gá»“m trong tá»•ng há»£p sÃ©c lÆ°Æ¡ng?',0),(324838,9024,'af','Watter besoldigings en aftrekkings is ingesluit op \'n Loonrol Tjek Opsomming?',0),(324839,9024,'ro','Ce salarii si deduceri sunt incluse pe o salarizare verifica Rezumat?',0),(324840,9024,'et','Kuidas palgad ja kinnipidamised on kantud palgaarvestuse kontrollida KokkuvÃµte?',0),(324841,9024,'si','Kaj plaÄe in olajÅ¡ave, ki so vkljuÄeni na izplaÄane plaÄe preverite Povzetek?',0),(324842,9024,'ba','Apa upah dan pengurangan disertakan pada penggajian cek ringkasan?',0),(324843,9024,'nl','Welke lonen en inhoudingen zijn opgenomen op een samenvatting voor het controleren van Payroll?',0),(324844,9024,'fi','MitÃ¤ palkat ja maksut kuuluvat palkkahallinnon Tarkista Yhteenveto?',0),(324845,9024,'no','Hvilken lÃ¸nn og fradrag er inkludert pÃ¥ en lÃ¸nn sjekk Sammendrag?',0),(324846,9024,'da','Hvad lÃ¸n og fradrag er inkluderet pÃ¥ en lÃ¸nningslisten kontrollere ResumÃ©?',0),(324847,9024,'ko','ì–´ë–¤ ìž„ê¸ˆ ë° ê³µì œ ê¸‰ì—¬ í™•ì¸ ìš”ì•½ì— í¬í•¨ ë˜ì–´ ìžˆìŠµë‹ˆê¹Œ?',0),(324848,9024,'he','××™×–×” ×©×›×¨ ×•× ×™×›×•×™×™× ×›×œ×•×œ×™× ×‘×¡×™×›×•× ×‘×“×•×§ ×ž×©×›×•×¨×•×ª?',0),(324849,9024,'el','Î¤Î¹ Î¼Î¹ÏƒÎ¸Î¿ÏÏ‚ ÎºÎ±Î¹ ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½ Ï€Î¿Ï… Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹ ÏƒÎµ Î¼Î¹Î± ÏƒÏÎ½Î¿ÏˆÎ· Î­Î»ÎµÎ³Ï‡Î¿Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚;',0),(324850,9024,'zh','ä»€ä¹ˆå·¥èµ„å’Œæ‰£é™¤å°†åŒ…æ‹¬åœ¨å·¥èµ„æ”¯ç¥¨ä¸Šçš„æ€»ç»“ä¸­ï¼Ÿ\r\n',0),(324851,9024,'sv','En lÃ¶n kontrollera sammanfattning innehÃ¥ller vad lÃ¶ner och avdrag?',0),(324852,9024,'it','Quali stipendi e detrazioni sono inclusi su una sintesi di verifica delle retribuzioni?',0),(324853,9024,'tl','',0),(324854,9024,'th','What wages and deductions are included on a Payroll Check Summary?',0),(324855,9024,'hi','à¤•à¥à¤¯à¤¾ à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤”à¤° à¤•à¤Ÿà¥Œà¤¤à¥€ à¤ªà¤° à¤à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤‚à¤¬à¤§à¥€ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥‹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(324856,9024,'ms','Apakah gaji dan potongan yang disertakan pada ringkasan semak gaji?',0),(324857,9024,'ar','Ù…Ø§ Ù‡ÙŠ Ø§Ù„Ø£Ø¬ÙˆØ± ÙˆØ§Ù„Ø§Ø³ØªÙ‚Ø·Ø§Ø¹Ø§Øª Ù…Ø¯Ø±Ø¬Ø© ÙÙŠ \"Ù…Ù„Ø®Øµ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø±ÙˆØ§ØªØ¨\"ØŸ',0),(324858,9024,'fr','Les salaires et retenues inclus sur un rÃ©sumÃ© de vÃ©rifier la masse salarialeÂ ?',0),(324859,9024,'jp','ã©ã®ã‚ˆã†ãªè³ƒé‡‘ã¨æŽ§é™¤ã¯ã€çµ¦ä¸Žãƒã‚§ãƒƒã‚¯ã®æ¦‚è¦ã«å«ã¾ã‚Œã¾ã™ã‹ã€‚',0),(324860,9024,'pt','Que salÃ¡rio e deduÃ§Ãµes estÃ£o incluÃ­das em um resumo de cheque de folha de pagamento?',0),(324861,9024,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ ÐºÐ°ÐºÐ¸Ðµ Ð·Ð°Ñ€Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¸ Ð²Ñ‹Ñ‡ÐµÑ‚Ñ‹?',0),(324862,9024,'es','Â¿Cuales sueldos y deducciones se incluyen en una Resumen de Cheques de Nomina?',0),(324863,9024,'de','Welche LÃ¶hne und Abgaben auf eine Lohn-und Gehaltsabrechnung Ã¼berprÃ¼fen Zusammenfassung enthalten sind?',0),(324864,9024,'en','What wages and deductions are included on a Payroll Check Summary?',0),(324865,9025,'is','',0),(324866,9025,'dr','2 : Ú†Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ù…Ù† Ø¯Ø± ØµÙˆØ±Øª Ø§Ø®ØªÙ„Ø§Ù Ø¨Ø§Ù†ÙƒÙŠ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ù†Ù…ÙŠ Ø´ÙˆØ¯ ØŸ',0),(324867,9025,'pr','ØªØ°ÙƒØ± 2 : Ú†Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ù…Ù† Ø¯Ø± ØµÙˆØ±Øª Ù…ØºØ§ÙŠØ±Øª Ø¨Ø§Ù†ÙƒÙŠ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ù†Ù…ÙŠ Ø´ÙˆØ¯ ØŸ',0),(324868,9025,'tr','Neden benim mÃ¼ÅŸteri Ã¶demeleri banka mutabakatÄ± gÃ¶stermiyorsun?',0),(324869,9025,'pl','Dlaczego mÃ³j klient pÅ‚atnoÅ›ci nie pokazuj na uzgodnienia bankowego?',0),(324870,9025,'bg','Ð—Ð°Ñ‰Ð¾ Ð½Ðµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚ Ð¼Ð¾Ð¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð¿Ð¾ Ð±Ð°Ð½ÐºÐ¾Ð²Ð°Ñ‚Ð° ÑÑŠÐ¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ°?',0),(324871,9025,'ur','Ù…ÛŒØ±Û’ Ú¯Ø§ÛÚ© Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¨ÛŒÙ†Ú© Ù…ÙØ§ÛÙ…Øª Ù¾Ø± Ø¯Ú©Ú¾Ø§ØªÛ’ Ú©ÛŒÙˆÚº Ù†ÛÛŒÚº',0),(324872,9025,'sr','Ð—Ð°ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð¼Ð¾Ñ˜Ð° Ð¼ÑƒÑˆÑ‚ÐµÑ€Ð¸Ñ˜Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð½Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜ Ð½Ð° ÑÑ€Ð°Ð²ÑšÐµÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸?',0),(324873,9025,'vi','Táº¡i sao thanh toÃ¡n cá»§a khÃ¡ch hÃ ng cá»§a tÃ´i khÃ´ng xuáº¥t hiá»‡n trong pháº§n cÃ¢n Ä‘á»‘i TK ngÃ¢n hÃ ng?',0),(324874,9025,'af','Waarom wys my Klante Betaling nie op die Bankrekonsiliasie nie?',0),(324875,9025,'ro','De ce nu aratÄƒ clientului meu plÄƒÅ£i pe reconcilierea bancarÄƒ?',0),(324876,9025,'et','Miks ei NÃ¤ita minu kliendimaksete pangakonto sobitamise?',0),(324877,9025,'si','Zakaj ne moje stranke plaÄila PrikaÅ¾i na banÄnega?',0),(324878,9025,'ba','Mengapa tidak pembayaran pelanggan saya menampilkan rekonsiliasi Bank?',0),(324879,9025,'nl','Waarom niet van mijn klant betalingen weergeven op de verzoening van de Bank?',0),(324880,9025,'fi','Miksi ei minun asiakasmaksut NÃ¤ytÃ¤ Pankkitilin tÃ¤smÃ¤ytyksen?',0),(324881,9025,'no','Hvorfor vises ikke min kundes betalinger pÃ¥ bankavstemmingen?',0),(324882,9025,'da','Hvorfor viser min debitorbetalinger ikke pÃ¥ det bankkontoafstemningen?',0),(324883,9025,'ko','ì™œ ë‚´ ê³ ê°ì˜ ê²°ì œ ì€í–‰ í™”í•´ì— í‘œì‹œ?',0),(324884,9025,'he','×œ×ž×” ×”×ª×©×œ×•×ž×™× ×©×œ ×”×œ×§×•×— ×©×œ×™ ×œ× ×ž×•×¤×™×¢ ×”×ª××ž×ª ×‘× ×§?',0),(324885,9025,'el','Î“Î¹Î±Ï„Î¯ Î´ÎµÎ½ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· Î¼Î¿Ï… Î´ÎµÎ¯Ï‡Î½Î¿Ï…Î½ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î·Î½ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ® ÏƒÏ…Î¼Ï†Ï‰Î½Î¯Î±;',0),(324886,9025,'zh','ä¸ºä»€ä¹ˆæˆ‘çš„å®¢æˆ·ä»˜æ¬¾æœªæ˜¾ç¤ºåœ¨é“¶è¡Œå¯¹å¸ï¼Ÿ\r\n',0),(324887,9025,'sv','VarfÃ¶r visar inte min kundens betalningar pÃ¥ bankavstÃ¤mningen?',0),(324888,9025,'it','PerchÃ© non mostrano i pagamenti del mio cliente sulla riconciliazione bancaria?',0),(324889,9025,'tl','',0),(324890,9025,'th','Why don\'t my Customer\'s payments show on the Bank Reconciliation?',0),(324891,9025,'hi','à¤•à¥à¤¯à¥‹à¤‚ à¤®à¥‡à¤°à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤° à¤¬à¥ˆà¤‚à¤• à¤¸à¤¾à¤®à¤‚à¤œà¤¸à¥à¤¯ à¤¦à¤¿à¤–à¤¾ à¤¨à¤¹à¥€à¤‚?',0),(324892,9025,'ms','Mengapa bayaran saya baca tidak Tunjuk dalam Penyata penyesuaian Bank?',0),(324893,9025,'ar','Ù„Ù…Ø§Ø°Ø§ Ù„Ø§ ØªØ¸Ù‡Ø± Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¨Ù„Ø¯ÙŠ Ø¹Ù„Ù‰ \"ØªØ³ÙˆÙŠØ© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ\"ØŸ',0),(324894,9025,'fr','Pourquoi ne pas montrer les paiements de mon client sur le rapprochement bancaireÂ ?',0),(324895,9025,'jp','ç§ã®é¡§å®¢ã®æ”¯æ‰•ãŒéŠ€è¡Œå‹˜å®šèª¿æ•´è¡¨ã«è¡¨ç¤ºã•ã‚Œãªã„ç†ç”±',0),(324896,9025,'pt','Os pagamentos do meu cliente nÃ£o mostram sobre a reconciliaÃ§Ã£o bancÃ¡ria?',0),(324897,9025,'ru','ÐŸÐ¾Ñ‡ÐµÐ¼Ñƒ Ð½Ðµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°ÑŽÑ‚ Ð¼Ð¾ÐµÐ³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð¿Ð¾ Ð¿Ñ€Ð¸Ð¼Ð¸Ñ€ÐµÐ½Ð¸ÑŽ Ð±Ð°Ð½ÐºÐ°?',0),(324898,9025,'es','Â¿Por quÃ© no aparecen los pagos de mi cliente  en la ReconciliaciÃ³n Bancaria?',0),(324899,9025,'de','Warum zeigen nicht mein Kunde Zahlungen an die Bank Reconciliation?',0),(324900,9025,'en','Why don\'t my Customer\'s payments show on the Bank Reconciliation?',0),(324901,9026,'is','',0),(324902,9026,'dr','3: Ú†Ø±Ø§ Ù…Ù† ØªÙ…Ø§Ù… Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠÙ… Ø±Ø§ Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª Ø­Ø³Ø§Ø¨ Ù†Ù…ÙŠ Ø¨ÙŠÙ†Ù… ØŸ ',0),(324903,9026,'pr','ØªØ°ÙƒØ±  3: Ú†Ø±Ø§ Ù…Ù† ØªÙ…Ø§Ù… Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠÙ… Ø±Ø§ Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´ ÙØ¹Ø§Ù„ÙŠØª Ø­Ø³Ø§Ø¨ Ù†Ù…ÙŠ Ø¨ÙŠÙ†Ù… ØŸ ',0),(324904,9026,'tr','Neden benim hesaplarÄ±nda hesap etkinliÄŸi raporu gÃ¶remiyorum?',0),(324905,9026,'pl','Dlaczego nie widaÄ‡ wszystko mÃ³j zestawienie rachunkowe w sprawozdaniu z dziaÅ‚alnoÅ›ci konta?',0),(324906,9026,'bg','Ð—Ð°Ñ‰Ð¾ Ð½Ðµ Ð¼Ð¾Ð³Ð° Ð´Ð° Ð²Ð¸Ð´Ñ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¼Ð¾Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚?',0),(324907,9026,'ur','Ú©ÛŒÙˆÚº Ù…ÛŒÚº Ø§Ù¾Ù†Û’ ØªÙ…Ø§Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ù…ÛŒÚº Ù†ÛÛŒÚº Ø¯ÛŒÚ©Ú¾ Ø³Ú©ØªØ§ØŸ',0),(324908,9026,'sr','Ð—Ð°ÑˆÑ‚Ð¾ Ð½Ðµ Ð²Ð¸Ð´Ð¸Ð¼ ÑÐ²Ðµ Ð¼Ð¾Ñ˜Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ñƒ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸Ð¼Ð° Ð½Ð°Ð»Ð¾Ð³?',0),(324909,9026,'vi','Táº¡i sao tÃ´i khÃ´ng tháº¥y táº¥t cáº£ cÃ¡c TK trong BÃ¡o CÃ¡o Hoáº¡t Äá»™ng TK?',0),(324910,9026,'af','Waarom sien ek nie al my rekeninge in die Rekening Aktiwiteitsverslag?',0),(324911,9026,'ro','De ce nu vÄƒd toate conturile mele Ã®n raportul de activitate cont?',0),(324912,9026,'et','Miks ei kuvata kÃµiki minu kontod konto tegevusaruandes?',0),(324913,9026,'si','Zakaj ne vidim vse moje raÄune v poroÄilu dejavnost raÄuna?',0),(324914,9026,'ba','Mengapa saya tidak melihat semua account dalam laporan aktivitas rekening?',0),(324915,9026,'nl','Waarom zie ik niet alle mijn accounts in het activiteitenverslag Account?',0),(324916,9026,'fi','Miksi en nÃ¤e minun tilejÃ¤ tili toimintakertomuksessa?',0),(324917,9026,'no','Hvorfor vises ikke alle mine kontoer i aktivitetsrapporten konto?',0),(324918,9026,'da','Hvorfor kan jeg ikke se alle mine konti i rapporten konto aktivitet?',0),(324919,9026,'ko','ì™œ ë‚´ ëª¨ë“  ê³„ì • ê³„ì • í™œë™ ë³´ê³ ì„œì— í‘œì‹œ ë˜ì§€ ì•ŠëŠ”?',0),(324920,9026,'he','×ž×“×•×¢ ××™× ×™ ×¨×•××” ×›×œ ×”×—×©×‘×•× ×•×ª ×©×œ×™ ×‘×“×• ×— ×¤×¢×™×œ×•×ª ×”×—×©×‘×•×Ÿ?',0),(324921,9026,'el','Î“Î¹Î±Ï„Î¯ Î´ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î´Ï‰ ÏŒÎ»Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î¼Î¿Ï… ÏƒÏ„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ· Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï„Î®Ï„Ï‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ;',0),(324922,9026,'zh','ä¸ºä»€ä¹ˆä¸è®©æˆ‘åœ¨å¸æˆ·æ´»åŠ¨æŠ¥è¡¨ä¸­çœ‹åˆ°æˆ‘æ‰€æœ‰çš„å¸æˆ·ï¼Ÿ\r\n',0),(324923,9026,'sv','VarfÃ¶r visas inte alla mina konton i aktivitetsrapporten konto?',0),(324924,9026,'it','PerchÃ© non vedere tutti i miei account nella relazione attivitÃ  Account?',0),(324925,9026,'tl','',0),(324926,9026,'th','Why don\'t I see all my accounts in the Account Activity Report?',0),(324927,9026,'hi','à¤•à¥à¤¯à¥‹à¤‚ à¤®à¥ˆà¤‚ à¤…à¤ªà¤¨à¥‡ à¤¸à¤­à¥€ à¤–à¤¾à¤¤à¥‹à¤‚ à¤–à¤¾à¤¤à¤¾ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤®à¥‡à¤‚ à¤¦à¥‡à¤– à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ?',0),(324928,9026,'ms','Mengapa saya tidak nampak semua akaun saya dalam Laporan aktiviti akaun?',0),(324929,9026,'ar','Ù„Ù…Ø§Ø°Ø§ Ù„Ø§ Ø£Ø±Ù‰ Ø¬Ù…ÙŠØ¹ Ø­Ø³Ø§Ø¨Ø§ØªÙŠ ÙÙŠ \"ØªÙ‚Ø±ÙŠØ± Ù†Ø´Ø§Ø· Ø§Ù„Ø­Ø³Ø§Ø¨\"ØŸ',0),(324930,9026,'fr','Pourquoi je ne vois pas tous mes comptes dans le rapport d\'activitÃ© de compte ?',0),(324931,9026,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ ãƒ¬ãƒãƒ¼ãƒˆã«ã™ã¹ã¦ã®ç§ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã¯ãªãœè¦‹ãªã„ã‹ã€‚',0),(324932,9026,'pt','Por que nÃ£o vejo todas as minhas contas no relatÃ³rio de atividade de conta?',0),(324933,9026,'ru','ÐŸÐ¾Ñ‡ÐµÐ¼Ñƒ Ð½Ðµ Ð²Ð¸Ð¶Ñƒ Ð²ÑÐµ Ð¼Ð¾Ð¸ ÑÑ‡ÐµÑ‚Ð° Ð² Ð´Ð¾ÐºÐ»Ð°Ð´Ðµ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸?',0),(324934,9026,'es','Â¿Por quÃ© no puedo ver todas mis cuentas en el Informe sobre la actividad de una cuenta?',0),(324935,9026,'de','Warum sehe ich nicht alle meine Konten in der Konto-TÃ¤tigkeitsbericht?',0),(324936,9026,'en','Why don\'t I see all my accounts in the Account Activity Report?',0),(324937,9027,'is','',0),(324938,9027,'dr','4- :  Ø®Ø±ÙŠØ¯Ø§Ø± Ù…Ù† ÙŠÙƒ ÙØ±Ù…Ø§ÛŒØ´ Ø§Ø¬Ø±Ø§  Ø±Ø§ Ø§Ø²  Ø·Ø±ÙŠÙ‚ Ù…Ø¯Ù„ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ  Ø«Ø¨Øª ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª .Ø§Ù…Ø§ Ú†Ø±Ø§ Ø¢Ù† Ø¯Ø± Ù„ÙŠØ³Øª ÙˆØ¶Ø¹ÙŠØª ÙØ±Ù…Ø§ÛŒØ´ Ù…Ù† Ù†ÙŠØ³Øª ØŸ',0),(324939,9027,'pr','ØªØ°ÙƒØ±  4- :  Ø®Ø±ÙŠØ¯Ø§Ø± Ù…Ù† ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§  Ø±Ø§ Ø§Ø²  Ø·Ø±ÙŠÙ‚ Ù…Ø¯Ù„ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ  Ø«Ø¨Øª ÙƒØ±Ø¯Ù‡ Ø§Ø³Øª .Ø§Ù…Ø§ Ú†Ø±Ø§ Ø¢Ù† Ø¯Ø± Ù„ÙŠØ³Øª ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ù…Ù† Ù†ÙŠØ³Øª ØŸ',0),(324940,9027,'tr','Benim mÃ¼ÅŸteri karÅŸÄ±lama sipariÅŸi B2B modÃ¼lÃ¼ aracÄ±lÄ±ÄŸÄ±yla girilen ama neden sipariÅŸ durumu listemde deÄŸil mi?',0),(324941,9027,'pl','MÃ³j klient wszedÅ‚ realizacji zamÃ³wienia poprzez moduÅ‚ B2B, ale dlaczego nie jest na liÅ›cie Status mojego zamÃ³wienia?',0),(324942,9027,'bg','ÐœÐ¾ÑÑ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ð°Ð²Ð»ÐµÐ·Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ñ‡Ñ€ÐµÐ· B2B Ð¼Ð¾Ð´ÑƒÐ», Ð½Ð¾ Ð·Ð°Ñ‰Ð¾ Ð½Ðµ Ðµ Ð² ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð¼Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑÑ‚Ð°Ñ‚ÑƒÑ?',0),(324943,9027,'ur','Ù…ÛŒØ±Û’ Ú¯Ø§ÛÚ© B2B Ú©Û’ Ù…Ø§ÚˆÛŒÙˆÙ„ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ø§ÛŒÚ© Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ø¯Ø§Ø®Ù„ ÛÙˆØ¦Û’ Ù„ÛŒÚ©Ù† Ú©ÛŒÙˆÚº Ù†ÛÛŒÚº ÛÛ’ ÛŒÛ Ù…ÛŒØ±Ø§ Ø­Ú©Ù… Ø­Ø§Ù„Øª ÙÛØ±Ø³Øª Ù¾Ø±ØŸ',0),(324944,9027,'sr','ÐœÐ¾Ñ˜ ÐºÑƒÐ¿Ð°Ñ† Ñ˜Ðµ ÑƒÐ½ÐµÑ‚ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ ÐºÑ€Ð¾Ð· Ð‘2Ð‘ Ð¼Ð¾Ð´ÑƒÐ», Ð°Ð»Ð¸ Ð·Ð°ÑÑ‚Ð¾ Ð½Ð¸Ñ˜Ðµ Ð½Ð° Ð¼Ð¾Ñ˜Ð¾Ñ˜ Ð»Ð¸ÑÑ‚Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð°Ð»Ð¾Ð³Ð°?',0),(324945,9027,'vi','KhÃ¡ch hÃ ng cá»§a tÃ´i Ä‘Ã£ nháº­p 1 Ä‘Æ¡n hÃ ng giao táº­n nÆ¡i qua B2B Modul. Táº¡i sao nÃ³ khÃ´ng xuáº¥t hiá»‡n trÃªn Danh sÃ¡ch tÃ¬nh tráº¡ng Ä‘Æ¡n hÃ ng cá»§a tÃ´i?',0),(324946,9027,'af','My kliÃ«nt ingesleutel het \'n vervulling orde deur die B2B module, maar Hoekom is dit nie op my bestelling Status lys?',0),(324947,9027,'ro','Clientului meu a intrat un ordin de Ã®mplinire prin modulul de B2B, dar de ce nu este pe lista mea de statutul de ordine?',0),(324948,9027,'et','Minu kliendi sisestatud plaanitud tellimus B2B moodul, aga miks pole see minu tellimuse olek?',0),(324949,9027,'si','Svoj Å¡ega zaÄel izpolnitev naroÄila preko B2B modul, ampak zakaj ni na seznamu nalog Status?',0),(324950,9027,'ba','Pelanggan saya memasuki pemenuhan Order melalui modul B2B, tetapi mengapa bukan daftar Status pesanan saya?',0),(324951,9027,'nl','Mijn klant trad een orde van de vervulling door de B2B-module, maar waarom is het niet op mijn Order Status lijst?',0),(324952,9027,'fi','Minun asiakas tuli suunnitellun tilauksen kautta B2B-moduuli, mutta miksi ei ole sitÃ¤ listallani tilauksen tila?',0),(324953,9027,'no','Meg kunden har angitt en innfrielsesordre gjennom B2B modulen, men hvorfor er det ikke pÃ¥ listen min ordre Status?',0),(324954,9027,'da','Min kunde trÃ¥dte en opfyldelsesordre gennem B2B modul, men hvorfor er det ikke pÃ¥ min ordre Status liste?',0),(324955,9027,'ko','ë‚´ ê³ ê° ìž…ë ¥ B2B ëª¨ë“ˆì„ í†µí•´ ì„±ì·¨ ì£¼ë¬¸ í•˜ì§€ë§Œ ì™œ ë‚´ ì£¼ë¬¸ ìƒíƒœ ëª©ë¡ì—?',0),(324956,9027,'he','×”×œ×§×•×— ×©×œ×™ × ×›× ×¡ ×¦×• ×ž×™×ž×•×© ×“×¨×š ×”×ž×•×“×•×œ B2B, ××‘×œ ×œ×ž×” ×–×” ×œ× ×¢×œ ×¨×©×™×ž×ª ×ž×¦×‘ ×”×”×–×ž× ×” ×©×œ×™?',0),(324957,9027,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ Î¼Î¿Ï… Î¼Ï€Î®ÎºÎµ Î¼Î¹Î± ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î¼Î­ÏƒÏ‰ Ï„Î·Ï‚ ÎµÎ½ÏŒÏ„Î·Ï„Î±Ï‚ B2B, Î±Î»Î»Î¬ Î³Î¹Î±Ï„Î¯ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÏ„Î· Î»Î¯ÏƒÏ„Î± Î¼Î¿Ï… Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚;',0),(324958,9027,'zh','æˆ‘çš„å®¢æˆ·é€šè¿‡å•†ä¸šå¯¹å•†ä¸šçš„æ¨¡å—è¿›å…¥å±¥è¡Œè®¢å•ï¼Œä½†ä¸ºä»€ä¹ˆä¸åœ¨æˆ‘çš„è®¢å•çŠ¶æ€åˆ—è¡¨ï¼Ÿ\r\n',0),(324959,9027,'sv','Min kund har angett en uppfyllelseorder genom B2B modulen, men varfÃ¶r Ã¤r det inte pÃ¥ min Order statuslista?',0),(324960,9027,'it','Il mio cliente immesso un ordine di evasione attraverso il modulo B2B, ma perchÃ© non Ã¨ sulla mia lista di stato ordine?',0),(324961,9027,'tl','',0),(324962,9027,'th','My customer entered a Fulfillment Order through the B2B module, but why isn\'t it on my Order Status List?',0),(324963,9027,'hi','à¤…à¤ªà¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤à¤• à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ B2B à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾, à¤²à¥‡à¤•à¤¿à¤¨ à¤•à¥à¤¯à¥‹à¤‚ à¤®à¥‡à¤°à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¸à¥‚à¤šà¥€ à¤',0),(324964,9027,'ms','Pelanggan saya memasuki suatu perintah dipenuhi melalui modul B2B, tetapi kenapa tidak pada senarai Status pesanan saya?',0),(324965,9027,'ar','Ø¯Ø®Ù„Øª Ø¨Ù„Ø§Ø¯ÙŠ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ \"Ø£Ù…Ø± Ø§Ù„Ø§Ø³ØªÙŠÙØ§Ø¡\" Ù…Ù† Ø®Ù„Ø§Ù„ ÙˆØ­Ø¯Ø© B2BØŒ ÙˆÙ„ÙƒÙ† Ù„Ù…Ø§Ø°Ø§ Ø£Ù„ÙŠØ³ ÙÙŠ \"Ù‚Ø§Ø¦Ù…ØªÙŠ Ù…Ø±ÙƒØ² Ø§Ù„Ù†Ø¸Ø§Ù…\"ØŸ',0),(324966,9027,'fr','Mon client est entrÃ© un ordre de traitement via le module de B2B, mais pourquoi nâ€™est-il pas sur ma liste de statut de commandeÂ ?',0),(324967,9027,'jp','ç§ã®é¡§å®¢ã¯ B2B ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã‚’é€šã˜ã¦è¨ˆç”»ã‚ªãƒ¼ãƒ€ãƒ¼ã‚’å…¥åŠ›ç§ã®æ³¨æ–‡çŠ¶æ³ãƒªã‚¹ãƒˆã«ãªãœãã‚Œã§ã™ã‹?',0),(324968,9027,'pt','Meu cliente entrou uma ordem de cumprimento atravÃ©s do mÃ³dulo de B2B, mas por que nÃ£o Ã© na minha lista de Status de ordem?',0),(324969,9027,'ru','ÐœÐ¾Ð¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð²Ð¾ÑˆÐµÐ» Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ñ‡ÐµÑ€ÐµÐ· Ð¼Ð¾Ð´ÑƒÐ»ÑŒ B2B, Ð½Ð¾ Ð¿Ð¾Ñ‡ÐµÐ¼Ñƒ Ð¾Ð½Ð° Ð½Ðµ Ð² Ð¼Ð¾ÐµÐ¼ ÑÐ¿Ð¸ÑÐºÐµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°?',0),(324970,9027,'es','Â¿Mi cliente ingresÃ³ un Orden de Cumplimiento a travÃ©s del mÃ³dulo B2B, pero por quÃ© no estÃ¡ en mi lista del Estatus del Orden?',0),(324971,9027,'de','Mein Kunde eingegeben AusfÃ¼hrungsauftrag Ã¼ber das B2B-Modul, aber warum ist es nicht auf meiner Bestell-Status-Liste?',0),(324972,9027,'en','My customer entered a Fulfillment Order through the B2B module, but why isn\'t it on my Order Status List?',0),(324973,9028,'is','',0),(324974,9028,'dr','5 - : Ù…Ù† ÙŠÙƒ Ø¨ÛŒØ¬Ú© Ø±Ø§ Ø§ØµÙ„Ø§Ø­  ÙƒØ±Ø¯Ù‡ Ø§Ù… Ø§Ù…Ø§ Ø¨Ù‡ Ù†Ø¸Ø± Ù…ÙŠ Ø±Ø³Ø¯ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ù… Ø¢Ù†Ø±Ø§ Ù¾ÙŠØ¯Ø§ ÙƒÙ†Ù… ØŸ',0),(324975,9028,'pr','ØªØ°ÙƒØ± 5 - : Ù…Ù† ÙŠÙƒ ÙØ§ÙƒØªÙˆØ± Ø±Ø§ ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ±Ø¯Ù‡ Ø§Ù… Ø§Ù…Ø§ Ø¨Ù‡ Ù†Ø¸Ø± Ù…ÙŠ Ø±Ø³Ø¯ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ù… Ø¢Ù†Ø±Ø§ Ù¾ÙŠØ¯Ø§ ÙƒÙ†Ù… ØŸ',0),(324976,9028,'tr','Fatura dÃ¼zenlenmiÅŸ ve ÅŸimdi onu bulmak iÃ§in gÃ¶rÃ¼nmÃ¼yor olabilir.',0),(324977,9028,'pl','EdytowaÅ‚em fakturÄ™, i teraz nie wydaje siÄ™ znaleÅºÄ‡.',0),(324978,9028,'bg','ÐÐ· Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð¸ ÑÐµÐ³Ð° Ð½Ðµ Ð¼Ð¾Ð³Ð° Ð´Ð° Ð³Ð¾ Ð½Ð°Ð¼ÐµÑ€Ð¸Ñ‚Ðµ.',0),(324979,9028,'ur','Ù…ÛŒÚº Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ù†ÛÛŒÚº Ú©ÛŒØŒ Ø§ÙˆØ± Ø§Ø¨ Ù…ÛŒÚº Ø§Ø³Û’ ØªÙ„Ø§Ø´ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù†ÛÛŒÚº Ú©Ø± Ù¾Ø§ Ø±ÛÛ’ ÛÛŒÚº Û”',0),(324980,9028,'sr','Ð£Ñ€ÐµÑ’ÐµÐ½Ð¸Ð¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ, Ð° ÑÐ°Ð´Ð° Ð¸Ð·Ð³Ð»ÐµÐ´Ð° Ð´Ð° Ð½Ðµ Ð¼Ð¾Ð³Ñƒ Ð½Ð°Ñ›Ð¸ Ñ‚Ð¾.',0),(324981,9028,'vi','TÃ´i sá»­a 1 hÃ³a Ä‘Æ¡n. BÃ¢y giá» nÃ³ Ä‘Ã£ biáº¿n máº¥t.',0),(324982,9028,'af','Ek het \'n faktuur geredigeer, en nou blyk dit dat ek dit nie vind nie.',0),(324983,9028,'ro','Am editat-o facturÄƒ, ÅŸi acum eu nu pot par sÄƒ-l gÄƒsiÅ£i.',0),(324984,9028,'et','Muutsin arve ja nÃ¼Ã¼d ma ei saa ilmselt leida seda.',0),(324985,9028,'si','Sem snemal raÄun, in zdaj jaz vekanje zdeti se najti to.',0),(324986,9028,'ba','Aku edited faktur, dan sekarang saya tidak bisa menemukannya.',0),(324987,9028,'nl','Ik heb een factuur bewerkt, en nu ik kan niet schijnen om het te vinden.',0),(324988,9028,'fi','Muokkasin laskun, ja nyt en voi nÃ¤yttÃ¤Ã¤ lÃ¶ytÃ¤Ã¤ se.',0),(324989,9028,'no','Jeg redigerte en faktura, og nÃ¥ jeg skrÃ¥nende synes Ã¥ finne den.',0),(324990,9028,'da','Jeg har redigeret en faktura, og nu jeg kan ikke synes at finde den.',0),(324991,9028,'ko','ë‚˜ëŠ” ì¸ë³´ì´ìŠ¤ íŽ¸ì§‘ í•˜ ê³  ì§€ê¸ˆ ê·¸ê²ƒì„ ì°¾ì„ ìˆ˜ëŠ” ì—†ëŠ” ê²ƒ.',0),(324992,9028,'he','. ×× ×™ ×¢×¨×›×ª×™ ×—×©×‘×•× ×™×ª, ×¢×›×©×™×• ×× ×™ ×œ× ×ž×¦×œ×™×— ×œ×ž×¦×•× ××ª ×–×”.',0),(324993,9028,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î¬ÏƒÏ„Î·ÎºÎ± Î­Î½Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿, ÎºÎ±Î¹ Ï„ÏŽÏÎ± Î´ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Ï†Î±Î¯Î½ÎµÏ„Î±Î¹ Î³Î¹Î± Î½Î± Ï„Î¿ Î²ÏÎµÎ¯Ï„Îµ.',0),(324994,9028,'zh','æˆ‘ç¼–è¾‘çš„å‘ç¥¨ï¼ŒçŽ°åœ¨æˆ‘ä¼¼ä¹Žæ— æ³•æ‰¾åˆ°å®ƒã€‚\r\n',0),(324995,9028,'sv','Jag redigerade en faktura, och nu jag skrÃ¤nande verkar hitta den.',0),(324996,9028,'it','A cura di una fattura, e ora io non riesco a trovarlo.',0),(324997,9028,'tl','',0),(324998,9028,'th','I edited an invoice, and now I can\'t seem to find it.',0),(324999,9028,'hi','à¤®à¥ˆà¤‚ à¤à¤• à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾, à¤”à¤° à¤…à¤¬ à¤®à¥ˆà¤‚ à¤‡à¤¸à¥‡ à¤–à¥‹à¤œà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¤à¥€à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡à¥¤',0),(325000,9028,'ms','Saya Kemaskini invois, dan sekarang saya tidak boleh kelihatan untuk mencari.',0),(325001,9028,'ar','Ø£Ù†Ø§ Ø¨ØªØ­Ø±ÙŠØ± ÙØ§ØªÙˆØ±Ø©ØŒ ÙˆÙ„Ø§ ØªØ¨Ø¯Ùˆ Ø§Ù„Ø¢Ù† Ù„Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„ÙŠÙ‡.',0),(325002,9028,'fr','J\'ai Ã©ditÃ© une facture, et maintenant je n\'arrive pas Ã  le trouver.',0),(325003,9028,'jp','è«‹æ±‚æ›¸ã‚’ç·¨é›†ã—ã€ä»Šç§ã¯ãã‚Œã‚’è¦‹ã¤ã‘ã‚‹ã‚ˆã†ã§ã‚ã‚‹ã§ãã¾ã›ã‚“ã€‚',0),(325004,9028,'pt','Eu editei uma fatura, e agora nÃ£o consigo encontrÃ¡-lo.',0),(325005,9028,'ru','Ð¯ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð» Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ, Ð¸ Ñ‚ÐµÐ¿ÐµÑ€ÑŒ Ñ Ð½Ðµ Ð¼Ð¾Ð³Ñƒ Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚ÑŒÑÑ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð½Ð°Ð¹Ñ‚Ð¸ ÐµÐ³Ð¾.',0),(325006,9028,'es','Yo editado una factura, y ahora no puedo parecen encontrarlo.',0),(325007,9028,'de','Ich habe eine Rechnung und jetzt ich kann nicht scheinen, um es zu finden.',0),(325008,9028,'en','I edited an invoice, and now I can\'t seem to find it.',0),(325009,9029,'is','',0),(325010,9029,'dr','6-',0),(325011,9029,'pr','ØªØ°ÙƒØ± 6-\r\n Q',0),(325012,9029,'tr','Ä°pucu 6 Q',0),(325013,9029,'pl','WskazÃ³wka 6 Q',0),(325014,9029,'bg','Ð¡ÑŠÐ²ÐµÑ‚ 6 Q',0),(325015,9029,'ur','Ø§Ø´Ø§Ø±Û 6 Ù‚',0),(325016,9029,'sr','ÐŸÐ¾Ð´ÑÐµÑ‚Ð½Ð¸Ðº Ð·Ð° 6 Q',0),(325017,9029,'vi','Gá»£i Ã 6 Q',0),(325018,9029,'af','Wenk 6 V',0),(325019,9029,'ro','Indiciu 6 Q',0),(325020,9029,'et','Vihje 6 Q',0),(325021,9029,'si','Namig 6 Q',0),(325022,9029,'ba','Petunjuk 6 Q',0),(325023,9029,'nl','Tip 6 Q',0),(325024,9029,'fi','Vihje 6 Q',0),(325025,9029,'no','Tips 6 Q',0),(325026,9029,'da','Tip 6 Q',0),(325027,9029,'ko','ížŒíŠ¸ 6 Q',0),(325028,9029,'he','×¨×ž×– 6 Q',0),(325029,9029,'el','Î£Ï…Î¼Î²Î¿Ï…Î»Î® 6 Q',0),(325030,9029,'zh','æç¤º6ï¼Œé—®\r\n',0),(325031,9029,'sv','Tips 6 Q',0),(325032,9029,'it','Suggerimento 6 Q',0),(325033,9029,'tl','',0),(325034,9029,'th','Hint 6 Q',0),(325035,9029,'hi','à¤¸à¤‚à¤•à¥‡à¤¤ 6 Q',0),(325036,9029,'ms','Q petunjuk 6',0),(325037,9029,'ar','ØªÙ„Ù…ÙŠØ­ 6 Q',0),(325038,9029,'fr','Astuce 6 Q',0),(325039,9029,'jp','ãƒ’ãƒ³ãƒˆ 6 Q',0),(325040,9029,'pt','Q Dica 6',0),(325041,9029,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ° 6 Q',0),(325042,9029,'es','Indicio 6 Q',0),(325043,9029,'de','Tipp 6 Q',0),(325044,9029,'en','Hint 6 Q',0),(325045,9030,'is','',0),(325046,9030,'dr','7-',0),(325047,9030,'pr','ØªØ°ÙƒØ± 7-',0),(325048,9030,'tr','Ä°pucu 7 Q',0),(325049,9030,'pl','WskazÃ³wka 7 Q',0),(325050,9030,'bg','Ð¡ÑŠÐ²ÐµÑ‚ 7 Q',0),(325051,9030,'ur','Ø§Ø´Ø§Ø±Û 7 Q',0),(325052,9030,'sr','ÐŸÐ¾Ð´ÑÐµÑ‚Ð½Ð¸Ðº Ð·Ð° 7 Q',0),(325053,9030,'vi','Gá»£i Ã 7 Q',0),(325054,9030,'af','Wenk 7 V',0),(325055,9030,'ro','Indiciu 7 Q',0),(325056,9030,'et','Vihje 7 Q',0),(325057,9030,'si','Namig 7 Q',0),(325058,9030,'ba','Petunjuk 7 Q',0),(325059,9030,'nl','Tip 7 Q',0),(325060,9030,'fi','Vihje 7 Q',0),(325061,9030,'no','Tips 7 Q',0),(325062,9030,'da','Tip 7 Q',0),(325063,9030,'ko','ížŒíŠ¸ 7 Q',0),(325064,9030,'he','×¨×ž×– 7 Q',0),(325065,9030,'el','Q Ï…Ï€ÏŒÎ´ÎµÎ¹Î¾Î· 7',0),(325066,9030,'zh','æç¤º7é—®\r\n',0),(325067,9030,'sv','Tips 7 Q',0),(325068,9030,'it','Suggerimento 7 Q',0),(325069,9030,'tl','',0),(325070,9030,'th','Hint 7 Q',0),(325071,9030,'hi','à¤¸à¤‚à¤•à¥‡à¤¤ 7 à¤•à¥à¤·',0),(325072,9030,'ms','Q pembayang 7',0),(325073,9030,'ar','ØªÙ„Ù…ÙŠØ­ 7 Q',0),(325074,9030,'fr','Astuce 7 Q',0),(325075,9030,'jp','ãƒ’ãƒ³ãƒˆ 7 Q',0),(325076,9030,'pt','Q Dica 7',0),(325077,9030,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ° 7 Q',0),(325078,9030,'es','Indicio 7 Q',0),(325079,9030,'de','Tipp 7-Q',0),(325080,9030,'en','Hint 7 Q',0),(325081,9031,'is','',0),(325082,9031,'dr','8',0),(325083,9031,'pr','ØªØ°ÙƒØ± 8\r\n Q',0),(325084,9031,'tr','Ä°pucu 8 Q',0),(325085,9031,'pl','WskazÃ³wka 8 Q',0),(325086,9031,'bg','Ð¡ÑŠÐ²ÐµÑ‚ 8 Q',0),(325087,9031,'ur','Ø§Ø´Ø§Ø±Û 8 Q',0),(325088,9031,'sr','ÐŸÐ¾Ð´ÑÐµÑ‚Ð½Ð¸Ðº Ð·Ð° 8 Q',0),(325089,9031,'vi','Gá»£i Ã 8 Q',0),(325090,9031,'af','Wenk 8 V',0),(325091,9031,'ro','Indiciu 8 Q',0),(325092,9031,'et','Vihje 8 Q',0),(325093,9031,'si','Namig 8 Q',0),(325094,9031,'ba','Petunjuk 8 Q',0),(325095,9031,'nl','Tip 8 Q',0),(325096,9031,'fi','Vihje 8 Q',0),(325097,9031,'no','Tips 8 Q',0),(325098,9031,'da','Tip 8 Q',0),(325099,9031,'ko','ížŒíŠ¸ 8 Q',0),(325100,9031,'he','×¨×ž×– 8 Q',0),(325101,9031,'el','Î£Ï…Î¼Î²Î¿Ï…Î»Î® 8 Q',0),(325102,9031,'zh','æç¤º8é—®\r\n',0),(325103,9031,'sv','Tips 8 Q',0),(325104,9031,'it','Suggerimento 8 Q',0),(325105,9031,'tl','',0),(325106,9031,'th','Hint 8 Q',0),(325107,9031,'hi','à¤¸à¤‚à¤•à¥‡à¤¤ 8 à¤•à¥à¤·',0),(325108,9031,'ms','Pembayang 8 Q',0),(325109,9031,'ar','Q ØªÙ„Ù…ÙŠØ­ 8',0),(325110,9031,'fr','Astuce 8 Q',0),(325111,9031,'jp','ãƒ’ãƒ³ãƒˆ 8 Q',0),(325112,9031,'pt','Q Dica 8',0),(325113,9031,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ° 8 Q',0),(325114,9031,'es','Indicio 8 Q',0),(325115,9031,'de','Tipp 8-Q',0),(325116,9031,'en','Hint 8 Q',0),(325117,9032,'is','',0),(325118,9032,'dr','9',0),(325119,9032,'pr','ØªØ°ÙƒØ± 9\r\n Q',0),(325120,9032,'tr','Ä°pucu 9 Q',0),(325121,9032,'pl','WskazÃ³wka 9 Q',0),(325122,9032,'bg','Ð¡ÑŠÐ²ÐµÑ‚ 9 Q',0),(325123,9032,'ur','Ø§Ø´Ø§Ø±Û 9 Q',0),(325124,9032,'sr','ÐŸÐ¾Ð´ÑÐµÑ‚Ð½Ð¸Ðº Ð·Ð° 9 Q',0),(325125,9032,'vi','Gá»£i Ã 9 Q',0),(325126,9032,'af','Wenk 9 V',0),(325127,9032,'ro','Indiciu 9 Q',0),(325128,9032,'et','Vihje 9 Q',0),(325129,9032,'si','Namig 9 Q',0),(325130,9032,'ba','Petunjuk 9 Q',0),(325131,9032,'nl','Tip 9 Q',0),(325132,9032,'fi','Vihje 9 Q',0),(325133,9032,'no','Tips 9 Q',0),(325134,9032,'da','Vink 9 Q',0),(325135,9032,'ko','ížŒíŠ¸ 9 Q',0),(325136,9032,'he','Q ×¨×ž×– 9',0),(325137,9032,'el','Î¥Ï€ÏŒÎ´ÎµÎ¹Î¾Î· 9 Q',0),(325138,9032,'zh','æç¤º9é—®\r\n',0),(325139,9032,'sv','Tips 9 Q',0),(325140,9032,'it','Suggerimento 9 Q',0),(325141,9032,'tl','',0),(325142,9032,'th','Hint 9 Q',0),(325143,9032,'hi','à¤¸à¤‚à¤•à¥‡à¤¤ 9 à¤•à¥à¤¯à¥‚',0),(325144,9032,'ms','Q pembayang 9',0),(325145,9032,'ar','Q ØªÙ„Ù…ÙŠØ­ 9',0),(325146,9032,'fr','Astuce 9 Q',0),(325147,9032,'jp','ãƒ’ãƒ³ãƒˆ 9 Q',0),(325148,9032,'pt','Q Dica 9',0),(325149,9032,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ° 9 Q',0),(325150,9032,'es','Indicio 9 Q',0),(325151,9032,'de','Tipp 9 Q',0),(325152,9032,'en','Hint 9 Q',0),(325153,9033,'is','',0),(325154,9033,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶  ØªØºÙŠÙŠØ± Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ',0),(325155,9033,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶  ØªØºÙŠÙŠØ± Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ',0),(325156,9033,'tr','VarsayÄ±lan Alter maliyeti hesabÄ±',0),(325157,9033,'pl','DomyÅ›lne konto Alter koszty',0),(325158,9033,'bg','ÐÐ»Ñ‚ÐµÑ€-Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(325159,9033,'ur','Ø·Û’ Ø´Ø¯Û Alter Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(325160,9033,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÐÐ»Ñ‚ÐµÑ€-Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(325161,9033,'vi','TK Thay Äá»•i GiÃ¡ ThÃ nh Máº·c Äá»‹nh',0),(325162,9033,'af','Verstek Alter-koste rekening',0),(325163,9033,'ro','Cont de costurile de Alter implicit',0),(325164,9033,'et','Vaikekonto Alter-kulud',0),(325165,9033,'si','Privzeti raÄun za Alter-stroÅ¡ki',0),(325166,9033,'ba','Akun bawaan Alter-biaya',0),(325167,9033,'nl','Standaardaccount Alter-kosten',0),(325168,9033,'fi','Alter-kustannukset oletustili',0),(325169,9033,'no','Standardkontoen Alter-kostnader',0),(325170,9033,'da','Standardkontoen Alter-omkostninger',0),(325171,9033,'ko','ê¸°ë³¸ ë³€ê²½ ë¹„ìš© ê³„ì •',0),(325172,9033,'he','×—×©×‘×•×Ÿ ×‘×¨×™×¨×ª ×”×ž×—×“×œ ××œ×ª×¨-×¢×œ×•×™×•×ª',0),(325173,9033,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Alter-ÎºÏŒÏƒÏ„Î¿Ï‚',0),(325174,9033,'zh','é»˜è®¤é˜¿å°”ç‰¹é—´æŽ¥è´¹ç”¨å¸æˆ·\r\n',0),(325175,9033,'sv','Standardkontot Alter-kostnader',0),(325176,9033,'it','Account predefinito di Alter-costi',0),(325177,9033,'tl','',0),(325178,9033,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;-&#3610;&#3633;&#3597;&#3594;&#3637;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(325179,9033,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤…à¥‰à¥‰à¤²à¥à¤Ÿà¤°-à¤²à¤¾à¤—à¤¤ à¤–à¤¾à¤¤à¤¾',0),(325180,9033,'ms','Lalai Alter-kos akaun',0),(325181,9033,'ar','Ø­Ø³Ø§Ø¨ ØªÙƒØ§Ù„ÙŠÙ ØªØºÙŠÙŠØ± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(325182,9033,'fr','Compte Alter-coÃ»ts par dÃ©faut',0),(325183,9033,'jp','æ—¢å®šå¤‰æ›´ã‚³ã‚¹ãƒˆã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(325184,9033,'pt','Conta de Alter-custos padrÃ£o',0),(325185,9033,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð°Ð»ÑŒÑ‚ÐµÑ€ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(325186,9033,'es','Cuenta de Modificar-Costos por Defecto',0),(325187,9033,'de','Standardkonto Alter-Kosten',0),(325188,9033,'en','Default Alter-Costs Account',0),(325189,9034,'is','',0),(325190,9034,'dr','Ø¯Ø±ØµØ¯ Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ â€“ Ù…Ø´ØªØ±ÙŠ ',0),(325191,9034,'pr','Ø¯Ø±ØµØ¯ Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ â€“ Ù…Ø´ØªØ±ÙŠ ',0),(325192,9034,'tr','DiÄŸer giderleri yÃ¼zde - mÃ¼ÅŸteri',0),(325193,9034,'pl','Inny procent opÅ‚aty - klient',0),(325194,9034,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° - ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(325195,9034,'ur','Ø¯ÛŒÚ¯Ø± Ú†Ø§Ø±Ø¬ ÙÛŒØµØ¯ - ÙˆØµÙˆÙ„ Ú©Ø§Ø±',0),(325196,9034,'sr','ÐžÑÑ‚Ð°Ð»Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° % - ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚',0),(325197,9034,'vi','% PhÃ­ KhÃ¡c - KhÃ¡ch hÃ ng',0),(325198,9034,'af','Ander Heffing Persentasie - Klient',0),(325199,9034,'ro','Alte procente de Ã®ncÄƒrcare - Client',0),(325200,9034,'et','Muud tasu protsenti - klient',0),(325201,9034,'si','Drugih dajatev odstotkov - odjemalec',0),(325202,9034,'ba','Persen biaya lain - klien',0),(325203,9034,'nl','Andere gratis procent - Client',0),(325204,9034,'fi','Muut ilmaiseksi prosenttia - Client',0),(325205,9034,'no','Andre gratis prosent - klient',0),(325206,9034,'da','Ã˜vrige gebyr procent - klient',0),(325207,9034,'ko','ë‹¤ë¥¸ ì¶©ì „ %-í´ë¼ì´ì–¸íŠ¸',0),(325208,9034,'he','××—×•×– ×ª×©×œ×•× ××—×¨×™× - ×œ×§×•×—',0),(325209,9034,'el','Î†Î»Î»Î± Ï‡ÏÎ­Ï‰ÏƒÎ· Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ - Ï€ÎµÎ»Î¬Ï„Î·',0),(325210,9034,'zh','å…¶ä»–æ”¶è´¹çš„ç™¾åˆ†æ¯”- å®¢æˆ·ç«¯\r\n',0),(325211,9034,'sv','Andra avgift procent - klient',0),(325212,9034,'it','Altra carica per cento - Client',0),(325213,9034,'tl','',0),(325214,9034,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3609;&#3605;&#3660;&#3588;&#3656;&#3634;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3629;&#3639;&#3656;&#3609; - &#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(325215,9034,'hi','à¤…à¤¨à¥à¤¯ à¤¶à¥à¤²à¥à¤• à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ - à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ',0),(325216,9034,'ms','Lain-lain caj peratus - pelanggan',0),(325217,9034,'ar','Ø¨Ø§Ù„Ù…Ø¦Ø© Ù…Ù‚Ø§Ø¨Ù„ Ø§Ù„Ø£Ø®Ø±Ù‰-Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(325218,9034,'fr','Autres pour cent de Charge - Client',0),(325219,9034,'jp','ãã®ä»–æ–™é‡‘ã®ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ - ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆ',0),(325220,9034,'pt','Outros por cento de carga - cliente',0),(325221,9034,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð² Ð·Ð°Ñ€ÑÐ´Ð° - ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(325222,9034,'es','Otro Porcentaje de Cargo - Cliente',0),(325223,9034,'de','Andere kostenlos Prozent - Client',0),(325224,9034,'en','Other Charge Percent - Client',0),(325225,9035,'is','',0),(325226,9035,'dr','Ù…Ø§Ù‡ Ø¢ÙˆØ±ÙŠÙ„',0),(325227,9035,'pr','Ù…Ø§Ù‡ Ø¢ÙˆØ±ÙŠÙ„',0),(325228,9035,'tr','Nisan',0),(325229,9035,'pl','APR',0),(325230,9035,'bg','ÐÐ¿Ñ€Ð¸Ð»',0),(325231,9035,'ur','Ø§Ù¾Ø±ÛŒÙ„',0),(325232,9035,'sr','ÐÐŸÐ ',0),(325233,9035,'vi','ThÃ¡ng TÆ°',0),(325234,9035,'af','Apr',0),(325235,9035,'ro','Apr',0),(325236,9035,'et','Apr',0),(325237,9035,'si','APR',0),(325238,9035,'ba','Apr',0),(325239,9035,'nl','Apr',0),(325240,9035,'fi','Huhtikuu',0),(325241,9035,'no','April',0),(325242,9035,'da','Apr',0),(325243,9035,'ko','4 ì›”',0),(325244,9035,'he','××¤×¨×™×œ',0),(325245,9035,'el','Î‘Ï€Ï',0),(325246,9035,'zh','å››æœˆ\r\n',0),(325247,9035,'sv','Apr',0),(325248,9035,'it','Apr',0),(325249,9035,'tl','',0),(325250,9035,'th','Apr',0),(325251,9035,'hi','à¤…à¤ªà¥à¤°à¥ˆà¤²',0),(325252,9035,'ms','Apr',0),(325253,9035,'ar','Ø£Ø¨Ø±ÙŠÙ„',0),(325254,9035,'fr','Avr',0),(325255,9035,'jp','4 æœˆ',0),(325256,9035,'pt','Abr',0),(325257,9035,'ru','ÐÐ¿Ñ€',0),(325258,9035,'es','Abr',0),(325259,9035,'de','Apr',0),(325260,9035,'en','Apr',0),(325261,9036,'is','',0),(325262,9036,'dr','Ù…Ø§Ù‡ Ø¢Ú¯ÙˆØ³Øª ',0),(325263,9036,'pr','Ù…Ø§Ù‡ Ø¢Ú¯ÙˆØ³Øª ',0),(325264,9036,'tr','AÄŸustos',0),(325265,9036,'pl','Sierpnia',0),(325266,9036,'bg','ÐÐ²Ð³ÑƒÑÑ‚',0),(325267,9036,'ur','Aug',0),(325268,9036,'sr','ÐÑƒÐ³',0),(325269,9036,'vi','ThÃ¡ng TÃ¡m',0),(325270,9036,'af','Aug',0),(325271,9036,'ro','Aug',0),(325272,9036,'et','Aug',0),(325273,9036,'si','Avgust',0),(325274,9036,'ba','Agustus',0),(325275,9036,'nl','Aug',0),(325276,9036,'fi','Elokuu',0),(325277,9036,'no','August',0),(325278,9036,'da','Aug',0),(325279,9036,'ko','8 ì›”',0),(325280,9036,'he','××•×’×•×¡×˜',0),(325281,9036,'el','Î‘Ï…Î³Î¿ÏÏƒÏ„Î¿Ï…',0),(325282,9036,'zh','å…«æœˆ\r\n',0),(325283,9036,'sv','Aug',0),(325284,9036,'it','Ad agosto',0),(325285,9036,'tl','',0),(325286,9036,'th','Aug',0),(325287,9036,'hi','à¤…à¤—à¤¸à¥à¤¤',0),(325288,9036,'ms','Ogos',0),(325289,9036,'ar','Ø£ØºØ³Ø·Ø³',0),(325290,9036,'fr','Aug',0),(325291,9036,'jp','8 æœˆ',0),(325292,9036,'pt','Ago',0),(325293,9036,'ru','ÐÐ²Ð³',0),(325294,9036,'es','Ago',0),(325295,9036,'de','Aug',0),(325296,9036,'en','Aug',0),(325297,9037,'is','',0),(325298,9037,'dr','Ù…Ø§Ù‡ Ø¯Ø³Ø§Ù…Ø¨Ø±',0),(325299,9037,'pr','Ù…Ø§Ù‡ Ø¯Ø³Ø§Ù…Ø¨Ø±',0),(325300,9037,'tr','AralÄ±k',0),(325301,9037,'pl','DEC',0),(325302,9037,'bg','Dec',0),(325303,9037,'ur','Ø¯Ø³Ù…Ø¨Ø±',0),(325304,9037,'sr','Ð”ÐµÑ†',0),(325305,9037,'vi','ThÃ¡ng MÆ°á»i Hai',0),(325306,9037,'af','Des',0),(325307,9037,'ro','Dec',0),(325308,9037,'et','Dets',0),(325309,9037,'si','Dec',0),(325310,9037,'ba','Desember',0),(325311,9037,'nl','Dec',0),(325312,9037,'fi','Joulukuu',0),(325313,9037,'no','Desember',0),(325314,9037,'da','Dec',0),(325315,9037,'ko','12 ì›”',0),(325316,9037,'he','×“×¦×ž×‘×¨',0),(325317,9037,'el','Î”ÎµÎº',0),(325318,9037,'zh','åäºŒæœˆ\r\n',0),(325319,9037,'sv','Dec',0),(325320,9037,'it','DEC',0),(325321,9037,'tl','',0),(325322,9037,'th','Dec',0),(325323,9037,'hi','Dec',0),(325324,9037,'ms','Dis',0),(325325,9037,'ar','Ø¯ÙŠØ³Ù…Ø¨Ø±',0),(325326,9037,'fr','DEC',0),(325327,9037,'jp','12 æœˆ',0),(325328,9037,'pt','Dec',0),(325329,9037,'ru','Ð”ÐµÐº',0),(325330,9037,'es','Dic',0),(325331,9037,'de','Dec',0),(325332,9037,'en','Dec',0),(325333,9038,'is','',0),(325334,9038,'dr','Ù…Ø§Ù‡ ÙÙˆØ±ÙŠÙ‡ ',0),(325335,9038,'pr','Ù…Ø§Ù‡ ÙÙˆØ±ÙŠÙ‡ ',0),(325336,9038,'tr','Åžubat',0),(325337,9038,'pl','Luty',0),(325338,9038,'bg','Ð¤ÐµÐ²Ñ€ÑƒÐ°Ñ€Ð¸',0),(325339,9038,'ur','ÙØ±ÙˆØ±ÛŒ',0),(325340,9038,'sr','Ð¤ÐµÐ±',0),(325341,9038,'vi','ThÃ¡ng Hai',0),(325342,9038,'af','Febr',0),(325343,9038,'ro','Februarie',0),(325344,9038,'et','Veeb',0),(325345,9038,'si','Februar',0),(325346,9038,'ba','Feb',0),(325347,9038,'nl','Feb',0),(325348,9038,'fi','Helmikuu',0),(325349,9038,'no','Februar',0),(325350,9038,'da','Feb',0),(325351,9038,'ko','2 ì›”',0),(325352,9038,'he','×¤×‘×¨×•××¨',0),(325353,9038,'el','Î¦ÎµÎ²',0),(325354,9038,'zh','äºŒæœˆ\r\n',0),(325355,9038,'sv','Feb',0),(325356,9038,'it','Feb',0),(325357,9038,'tl','',0),(325358,9038,'th','Feb',0),(325359,9038,'hi','à¤«à¤¼à¤°à¤µà¤°à¥€',0),(325360,9038,'ms','Feb',0),(325361,9038,'ar','ÙØ¨Ø±Ø§ÙŠØ±',0),(325362,9038,'fr','FÃ©v',0),(325363,9038,'jp','2 æœˆ',0),(325364,9038,'pt','Fev',0),(325365,9038,'ru','Ð¤ÐµÐ²',0),(325366,9038,'es','Feb',0),(325367,9038,'de','Feb',0),(325368,9038,'en','Feb',0),(325369,9039,'is','',0),(325370,9039,'dr','Ù…Ø§Ù‡ Ú˜Ø§Ù†ÙˆÙŠÙ‡',0),(325371,9039,'pr','Ù…Ø§Ù‡ Ú˜Ø§Ù†ÙˆÙŠÙ‡',0),(325372,9039,'tr','Jan',0),(325373,9039,'pl','Jan',0),(325374,9039,'bg','Ð¯Ð½',0),(325375,9039,'ur','Ø¬Ø§Ù†',0),(325376,9039,'sr','ÐˆÐ°Ð½',0),(325377,9039,'vi','ThÃ¡ng GiÃªng',0),(325378,9039,'af','Jan',0),(325379,9039,'ro','Jan',0),(325380,9039,'et','Jaan',0),(325381,9039,'si','Jan',0),(325382,9039,'ba','Jan',0),(325383,9039,'nl','Jan',0),(325384,9039,'fi','Jan',0),(325385,9039,'no','Jan',0),(325386,9039,'da','Jan',0),(325387,9039,'ko','1 ì›”',0),(325388,9039,'he','×™××Ÿ',0),(325389,9039,'el','Î™Î±Î½',0),(325390,9039,'zh','ä¸€æœˆ\r\n',0),(325391,9039,'sv','Jan',0),(325392,9039,'it','Jan',0),(325393,9039,'tl','',0),(325394,9039,'th','Jan',0),(325395,9039,'hi','à¤œà¤¨',0),(325396,9039,'ms','Jan',0),(325397,9039,'ar','ÙŠÙ†Ø§ÙŠØ±',0),(325398,9039,'fr','Jan',0),(325399,9039,'jp','1 æœˆ',0),(325400,9039,'pt','Jan',0),(325401,9039,'ru','Ð¯Ð½Ð²',0),(325402,9039,'es','Ene',0),(325403,9039,'de','Jan',0),(325404,9039,'en','Jan',0),(325405,9040,'is','',0),(325406,9040,'dr','Ù…Ø§Ù‡ Ø¬ÙˆÙ„Ø§ÙŠ',0),(325407,9040,'pr','Ù…Ø§Ù‡ Ø¬ÙˆÙ„Ø§ÙŠ',0),(325408,9040,'tr','Tem',0),(325409,9040,'pl','Lip',0),(325410,9040,'bg','Ð®Ð»Ð¸',0),(325411,9040,'ur','Jul',0),(325412,9040,'sr','ÐˆÑƒÐ»',0),(325413,9040,'vi','ThÃ¡ng Báº£y',0),(325414,9040,'af','Jul',0),(325415,9040,'ro','Iul',0),(325416,9040,'et','Juuli',0),(325417,9040,'si','Jul',0),(325418,9040,'ba','Juli',0),(325419,9040,'nl','Jul',0),(325420,9040,'fi','HeinÃ¤kuu',0),(325421,9040,'no','Juli',0),(325422,9040,'da','Jul',0),(325423,9040,'ko','7 ì›”',0),(325424,9040,'he','×™×•×œ×™',0),(325425,9040,'el','Î™Î¿Ï…Î»',0),(325426,9040,'zh','ä¸ƒæœˆ\r\n',0),(325427,9040,'sv','Jul',0),(325428,9040,'it','Lug',0),(325429,9040,'tl','',0),(325430,9040,'th','Jul',0),(325431,9040,'hi','à¤œà¥à¤²à¤¾à¤ˆ',0),(325432,9040,'ms','Julai',0),(325433,9040,'ar','ÙŠÙˆÙ„ÙŠÙˆ',0),(325434,9040,'fr','Jul',0),(325435,9040,'jp','7 æœˆ',0),(325436,9040,'pt','Jul',0),(325437,9040,'ru','Ð˜ÑŽÐ»ÑŒ',0),(325438,9040,'es','Jul',0),(325439,9040,'de','Jul',0),(325440,9040,'en','Jul',0),(325441,9041,'is','',0),(325442,9041,'dr','Ù…Ø§Ù‡ Ú˜ÙˆØ¦Ù†',0),(325443,9041,'pr','Ù…Ø§Ù‡ Ú˜ÙˆØ¦Ù†',0),(325444,9041,'tr','Haz',0),(325445,9041,'pl','Cze',0),(325446,9041,'bg','Ð®Ð½Ð¸',0),(325447,9041,'ur','Jun',0),(325448,9041,'sr','ÐˆÑƒÐ½',0),(325449,9041,'vi','ThÃ¡ng SÃ¡u',0),(325450,9041,'af','Jun',0),(325451,9041,'ro','Jun',0),(325452,9041,'et','Juuni',0),(325453,9041,'si','Junij',0),(325454,9041,'ba','Jun',0),(325455,9041,'nl','Jun',0),(325456,9041,'fi','KesÃ¤kuu',0),(325457,9041,'no','Juni',0),(325458,9041,'da','Jun',0),(325459,9041,'ko','6 ì›”',0),(325460,9041,'he','×™×•× ',0),(325461,9041,'el','Î™Î¿Ï…Î½',0),(325462,9041,'zh','å…­æœˆ\r\n',0),(325463,9041,'sv','Jun',0),(325464,9041,'it','Jun',0),(325465,9041,'tl','',0),(325466,9041,'th','Jun',0),(325467,9041,'hi','à¤œà¥‚à¤¨',0),(325468,9041,'ms','Jun',0),(325469,9041,'ar','ÙŠÙˆÙ†ÙŠÙˆ',0),(325470,9041,'fr','Jun',0),(325471,9041,'jp','6 æœˆ',0),(325472,9041,'pt','Jun',0),(325473,9041,'ru','Ð˜ÑŽÐ½ÑŒ',0),(325474,9041,'es','Jun',0),(325475,9041,'de','Jun',0),(325476,9041,'en','Jun',0),(325477,9042,'is','',0),(325478,9042,'dr','Ù…Ø§Ù‡ Ù…Ø§Ø±Ø³',0),(325479,9042,'pr','Ù…Ø§Ù‡ Ù…Ø§Ø±Ø³',0),(325480,9042,'tr','Ma',0),(325481,9042,'pl','Mar',0),(325482,9042,'bg','ÐœÐ°Ñ€',0),(325483,9042,'ur','Ù…Ø§Ø±Ú†',0),(325484,9042,'sr','ÐœÐ°Ñ€',0),(325485,9042,'vi','ThÃ¡ng 3',0),(325486,9042,'af','Mrt',0),(325487,9042,'ro','Mar',0),(325488,9042,'et','MÃ¤rts',0),(325489,9042,'si','Mar',0),(325490,9042,'ba','Mar',0),(325491,9042,'nl','Mar',0),(325492,9042,'fi','Mar',0),(325493,9042,'no','Mar',0),(325494,9042,'da','Mar',0),(325495,9042,'ko','3 ì›”',0),(325496,9042,'he','×ž××¨',0),(325497,9042,'el','ÎœÎ±Ï',0),(325498,9042,'zh','ä¸‰æœˆ\r\n',0),(325499,9042,'sv','Mar',0),(325500,9042,'it','Mar',0),(325501,9042,'tl','',0),(325502,9042,'th','Mar',0),(325503,9042,'hi','à¤®à¤¾à¤°à¥à¤š',0),(325504,9042,'ms','Mar',0),(325505,9042,'ar','Ù…Ø§Ø±Ø³',0),(325506,9042,'fr','Mar',0),(325507,9042,'jp','3 æœˆ',0),(325508,9042,'pt','Mar',0),(325509,9042,'ru','ÐœÐ°Ñ€Ñ‚',0),(325510,9042,'es','Mar',0),(325511,9042,'de','Mar',0),(325512,9042,'en','Mar',0),(325513,9043,'is','',0),(325514,9043,'dr','Ù…Ø§Ù‡ Ù…ÙŠ ',0),(325515,9043,'pr','Ù…Ø§Ù‡ Ù…ÙŠ ',0),(325516,9043,'tr','MayÄ±s',0),(325517,9043,'pl','MoÅ¼e',0),(325518,9043,'bg','ÐœÐ°Ð¹',0),(325519,9043,'ur','Ù…Ø¦ÛŒ',0),(325520,9043,'sr','ÐœÐ°Ñ˜Ð°',0),(325521,9043,'vi','ThÃ¡ng 5',0),(325522,9043,'af','Mei',0),(325523,9043,'ro','Poate',0),(325524,9043,'et','Mai',0),(325525,9043,'si','Maja',0),(325526,9043,'ba','Mungkin',0),(325527,9043,'nl','Mei',0),(325528,9043,'fi','Voi',0),(325529,9043,'no','Mai',0),(325530,9043,'da','Maj',0),(325531,9043,'ko','5 ì›”',0),(325532,9043,'he','×ž××™',0),(325533,9043,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î½Î±',0),(325534,9043,'zh','äº”æœˆ\r\n',0),(325535,9043,'sv','Kan',0),(325536,9043,'it','Maggio',0),(325537,9043,'tl','',0),(325538,9043,'th','May',0),(325539,9043,'hi','à¤®à¤ˆ',0),(325540,9043,'ms','Mungkin',0),(325541,9043,'ar','Ù…Ø§ÙŠÙˆ',0),(325542,9043,'fr','Mai',0),(325543,9043,'jp','5 æœˆ',0),(325544,9043,'pt','Maio',0),(325545,9043,'ru','ÐœÐ°Ð¹',0),(325546,9043,'es','May',0),(325547,9043,'de','Mai',0),(325548,9043,'en','May',0),(325549,9044,'is','',0),(325550,9044,'dr','Ù…Ø§Ù‡ Ù†ÙˆØ§Ù…Ø¨Ø± ',0),(325551,9044,'pr','Ù…Ø§Ù‡ Ù†ÙˆØ§Ù…Ø¨Ø± ',0),(325552,9044,'tr','KasÄ±m',0),(325553,9044,'pl','Lis',0),(325554,9044,'bg','ÐÐ¾ÐµÐ¼Ð²Ñ€Ð¸',0),(325555,9044,'ur','Ù†ÙˆÙ…Ø¨Ø±',0),(325556,9044,'sr','ÐÐ¾Ð²',0),(325557,9044,'vi','ThÃ¡ng 11',0),(325558,9044,'af','Nov',0),(325559,9044,'ro','Noiembrie',0),(325560,9044,'et','Nov',0),(325561,9044,'si','November',0),(325562,9044,'ba','Nov',0),(325563,9044,'nl','Nov',0),(325564,9044,'fi','Marraskuu',0),(325565,9044,'no','November',0),(325566,9044,'da','Nov',0),(325567,9044,'ko','11 ì›”',0),(325568,9044,'he','× ×•×‘',0),(325569,9044,'el','ÎÎ¿Îµ',0),(325570,9044,'zh','åä¸€æœˆ\r\n',0),(325571,9044,'sv','Nov',0),(325572,9044,'it','Nov',0),(325573,9044,'tl','',0),(325574,9044,'th','Nov',0),(325575,9044,'hi','à¤¨à¤µà¤®à¥à¤¬à¤°',0),(325576,9044,'ms','Nov',0),(325577,9044,'ar','Ù†ÙˆÙÙ…Ø¨Ø±',0),(325578,9044,'fr','Nov',0),(325579,9044,'jp','11 æœˆ',0),(325580,9044,'pt','Nov',0),(325581,9044,'ru','ÐÐ¾ÑÐ±',0),(325582,9044,'es','Nov',0),(325583,9044,'de','Nov',0),(325584,9044,'en','Nov',0),(325585,9045,'is','',0),(325586,9045,'dr','Ù…Ø§Ù‡ Ø§ÙƒØªØ¨Ø±',0),(325587,9045,'pr','Ù…Ø§Ù‡ Ø§ÙƒØªØ¨Ø±',0),(325588,9045,'tr','Ekim',0),(325589,9045,'pl','KTZ',0),(325590,9045,'bg','ÐžÐ¡Ð¢',0),(325591,9045,'ur','Ø§Ú©ØªÙˆØ¨Ø±',0),(325592,9045,'sr','ÐžÑ†Ñ‚',0),(325593,9045,'vi','ThÃ¡ng MÆ°á»i',0),(325594,9045,'af','Okt',0),(325595,9045,'ro','Octombrie',0),(325596,9045,'et','Okt',0),(325597,9045,'si','ÄŒDO',0),(325598,9045,'ba','Oktober',0),(325599,9045,'nl','LGO',0),(325600,9045,'fi','Lokakuu',0),(325601,9045,'no','Oktober',0),(325602,9045,'da','Okt',0),(325603,9045,'ko','10 ì›”',0),(325604,9045,'he','Oct',0),(325605,9045,'el','ÎŸÎºÏ„',0),(325606,9045,'zh','åæœˆ\r\n',0),(325607,9045,'sv','Okt',0),(325608,9045,'it','Ott',0),(325609,9045,'tl','',0),(325610,9045,'th','Oct',0),(325611,9045,'hi','à¤…à¤•à¥à¤Ÿà¥‚à¤¬à¤°',0),(325612,9045,'ms','Okt',0),(325613,9045,'ar','Ø£ÙƒØªÙˆØ¨Ø±',0),(325614,9045,'fr','Oct',0),(325615,9045,'jp','10 æœˆ',0),(325616,9045,'pt','Oct',0),(325617,9045,'ru','ÐžÐºÑ‚',0),(325618,9045,'es','Oct',0),(325619,9045,'de','Okt',0),(325620,9045,'en','Oct',0),(325621,9046,'is','',0),(325622,9046,'dr','Ù…Ø§Ù‡ Ø³Ù¾ØªØ§Ù…Ø¨Ø±',0),(325623,9046,'pr','Ù…Ø§Ù‡ Ø³Ù¾ØªØ§Ù…Ø¨Ø±',0),(325624,9046,'tr','Ka',0),(325625,9046,'pl','Sep',0),(325626,9046,'bg','Ð¡ÐµÐ¿Ñ‚ÐµÐ¼Ð²Ñ€Ð¸',0),(325627,9046,'ur','Sep',0),(325628,9046,'sr','Ð¡ÐµÐ¿',0),(325629,9046,'vi','ThÃ¡ng ChÃ­n',0),(325630,9046,'af','Sep',0),(325631,9046,'ro','Sep',0),(325632,9046,'et','Sept',0),(325633,9046,'si','Sep',0),(325634,9046,'ba','Sep',0),(325635,9046,'nl','Sep',0),(325636,9046,'fi','Syyskuu',0),(325637,9046,'no','September',0),(325638,9046,'da','Sep',0),(325639,9046,'ko','9 ì›”',0),(325640,9046,'he','×¡×¤',0),(325641,9046,'el','Î£ÎµÏ€',0),(325642,9046,'zh','ä¹æœˆ\r\n',0),(325643,9046,'sv','Sep',0),(325644,9046,'it','Sep',0),(325645,9046,'tl','',0),(325646,9046,'th','Sep',0),(325647,9046,'hi','Sep',0),(325648,9046,'ms','Sep',0),(325649,9046,'ar','Ø³Ø¨ØªÙ…Ø¨Ø±',0),(325650,9046,'fr','Sep',0),(325651,9046,'jp','9 æœˆ',0),(325652,9046,'pt','Sep',0),(325653,9046,'ru','Ð¡ÐµÐ½Ñ‚',0),(325654,9046,'es','Sep',0),(325655,9046,'de','Sep',0),(325656,9046,'en','Sep',0),(325657,9047,'is','',0),(325658,9047,'dr','Ø§ÙŠÙ† Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ø§Ø´Ø¯ ',0),(325659,9047,'pr','Ø§ÙŠÙ† Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ø§Ø´Ø¯ ',0),(325660,9047,'tr','O-ebilmek var olmak',0),(325661,9047,'pl','To moÅ¼e byÄ‡',0),(325662,9047,'bg','Ð¢Ñ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ',0),(325663,9047,'ur','ÛŒÛ ÛÙˆ Ø³Ú©ØªÛŒ ÛÛ’',0),(325664,9047,'sr','Ð¢Ð¾ Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸',0),(325665,9047,'vi','NÃ³ cÃ³ thá»ƒ lÃ ',0),(325666,9047,'af','Dit Kan',0),(325667,9047,'ro','Acesta poate fi',0),(325668,9047,'et','See vÃµib olla',0),(325669,9047,'si','To je lahko',0),(325670,9047,'ba','Hal ini dapat',0),(325671,9047,'nl','Het kan worden',0),(325672,9047,'fi','Se voi olla',0),(325673,9047,'no','Det kan vÃ¦re',0),(325674,9047,'da','Det kan vÃ¦re',0),(325675,9047,'ko','ê·¸ê²ƒì€ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(325676,9047,'he','×–×” ×™×›×•×œ ×œ×”×™×•×ª',0),(325677,9047,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹',0),(325678,9047,'zh','å®ƒå¯\r\n',0),(325679,9047,'sv','Det kan vara',0),(325680,9047,'it','PuÃ² essere',0),(325681,9047,'tl','',0),(325682,9047,'th','&#3617;&#3633;&#3609;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3607;&#3635;&#3652;&#3604;&#3657;',0),(325683,9047,'hi','à¤¯à¤¹ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(325684,9047,'ms','Ia boleh menjadi',0),(325685,9047,'ar','ÙŠÙ…ÙƒÙ† Ø£Ù† ÙŠÙƒÙˆÙ†',0),(325686,9047,'fr','Il peut Ãªtre',0),(325687,9047,'jp','ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(325688,9047,'pt','Pode ser',0),(325689,9047,'ru','Ð­Ñ‚Ð¾ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ',0),(325690,9047,'es','Lo Puede ser',0),(325691,9047,'de','Es kann sein',0),(325692,9047,'en','It can be',0),(325693,9048,'is','',0),(325694,9048,'dr',': Ø§ÙŠÙ† Ø§ØªØµØ§Ù„ Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ù‡ Ù…Ù†Ø¨Ø¹  Ø¯Ø± Ø®Ø¯Ù…Ø§Øª Ù…ÙŠØ²Ø¨Ø§Ù†ÙŠ ÙˆÙ„Ø§ÛŒØª Ø¯Ø§Ø±Ø¯ Ø§ÙŠÙ† Ø³Ø§ÙØª ÙˆÛŒØ± Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(325695,9048,'pr','ØªÙˆØ¬Ù‡ ÙƒÙ†ÙŠØ¯  ÙƒÙ‡: Ø§ÙŠÙ† Ø§ØªØµØ§Ù„ Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ù‡ Ù…Ù†Ø¨Ø¹  Ø¯Ø± Ø®Ø¯Ù…Ø§Øª Ù…ÙŠØ²Ø¨Ø§Ù†ÙŠ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(325696,9048,'tr','Bu eklenti otomatik olarak standart ile barÄ±ndÄ±rma hizmeti dahil deÄŸildir.',0),(325697,9048,'pl','NaleÅ¼y zauwaÅ¼yÄ‡, Å¼e ten dodatek nie jest uwzglÄ™dniane automatycznie ze standardem usÅ‚ugi hostingowej.',0),(325698,9048,'bg','Ð˜Ð¼Ð°Ð¹Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð²Ð¸Ð´, Ñ‡Ðµ Ñ‚Ð°Ð·Ð¸ Ð´Ð¾Ð±Ð°Ð²ÐºÐ° Ð½Ðµ Ðµ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ ÑÑŠÑ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð° Ñ…Ð¾ÑÑ‚Ð¸Ð½Ð³ ÑƒÑÐ»ÑƒÐ³Ð°.',0),(325699,9048,'ur','ÛŒÛ Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ÛÙˆØ³Ù¹Ù†Ú¯ Ø³Ø±ÙˆØ³ Ú©Û’ Ù…Ø¹ÛŒØ§Ø± Ú©Û’ Ø³Ø§ØªÚ¾ Ø´Ø§Ù…Ù„ Ù†ÛÛŒÚº ÛÛ’ Ú©Û Ù†ÙˆÙ¹ Ú©Ø±ÛŒÚº Û”',0),(325700,9048,'sr','Ð˜Ð¼Ð°Ñ˜Ñ‚Ðµ Ð½Ð° ÑƒÐ¼Ñƒ Ð´Ð° Ð¾Ð²Ð°Ñ˜ Ð´Ð¾Ð´Ð°Ñ‚Ð°Ðº Ð½Ð¸Ñ˜Ðµ ÑƒÐºÑ™ÑƒÑ‡ÐµÐ½Ð° Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸, ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸Ð¼ Ñ…Ð¾ÑÑ‚Ð¸Ð½Ð³ ÑÐµÑ€Ð²Ð¸Ñ.',0),(325701,9048,'vi','Dá»‹ch vá»¥ cáº¯m vÃ o nÃ y khÃ´ng bao gá»“m trong gÃ³i dá»‹ch vá»¥ Hosting NolaPro chuáº©n',0),(325702,9048,'af','Neem kennis dat hierdie inprop nie outomaties ingesluit is indie standaard NolaPro gasheerdiens.',0),(325703,9048,'ro','ReÅ£ineÅ£i cÄƒ acest supliment nu este inclusÄƒ automat cu standardul gazduieste imagini.',0),(325704,9048,'et','Juhime Teie tÃ¤helepanu sellele, et see plugin ei sisaldu standardse NolaPro majutusteenuse hinnas.',0),(325705,9048,'si','UpoÅ¡tevajte, da ta dodatek ni vkljuÄen samodejno z standard storitev gostovanja.',0),(325706,9048,'ba','Perhatikan bahwa Pengaya ini tidak disertakan secara otomatis dengan standar layanan hosting.',0),(325707,9048,'nl','Merk op dat deze Add-On is niet opgenomen automatisch met de standaard hostingservice.',0),(325708,9048,'fi','Huomaa, ettÃ¤ tÃ¤mÃ¤ apuohjelma ei sisÃ¤lly automaattisesti standardin hosting-palvelun.',0),(325709,9048,'no','Merk at dette tillegget ikke inkludert automatisk med standard vertstjenesten.',0),(325710,9048,'da','BemÃ¦rk, at denne tilfÃ¸jelse ikke er inkluderet automatisk med den standard hosting service.',0),(325711,9048,'ko','Noteì´ ë¶€ê°€ ì•„ë‹ˆë‹¤ëŠ” ê²ƒì„ í¬í•¨ ìžë™ìœ¼ë¡œ í‘œì¤€ í˜¸ìŠ¤íŒ… ì„œë¹„ìŠ¤.',0),(325712,9048,'he','×©×™×ž×• ×œ×‘ ×›×™ ×©×”×¨×—×‘×” ×œ× × ×›×œ×œ ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™ ×¢× ×ª×§×Ÿ ×©×™×¨×•×ª ××™×¨×•×—.',0),(325713,9048,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÏ„Îµ ÏŒÏ„Î¹ Ï„Î¿ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î¿ Î´ÎµÎ½ Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÏ„Î±Î¹ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î± Î¼Îµ Ï„Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ Ï†Î¹Î»Î¿Î¾ÎµÎ½Î¯Î±Ï‚.',0),(325714,9048,'zh','è¯·æ³¨æ„ï¼Œæ­¤æ’ä»¶ä¸è‡ªåŠ¨é™„å¸¦æ ‡å‡†æ‰˜ç®¡æœåŠ¡\r\n',0),(325715,9048,'sv','Observera att detta tillÃ¤gg inte ingÃ¥r automatiskt med standard fientlig tjÃ¤nst.',0),(325716,9048,'it','Si noti che questo componente aggiuntivo non Ã¨ incluso automaticamente con lo standard di servizio di hosting.',0),(325717,9048,'tl','',0),(325718,9048,'th','Note that this plug-in is not included automatically with the standard NolaPro hosting service.',0),(325719,9048,'hi','à¤‡à¤¸ à¤à¤¡-à¤‘à¤¨ à¤¸à¥à¤µà¤¤à¤ƒ à¤®à¤¾à¤¨à¤• à¤¹à¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤— à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¶à¤¾à¤®à¤¿à¤² à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ à¤•à¤¿ à¤§à¥à¤¯à¤¾à¤¨ à¤¦à¥‡à¤‚à¥¤',0),(325720,9048,'ms','Ambil perhatian bahawa tambahan ini tidak termasuk secara automatik dengan standard perkhidmatan hosting.',0),(325721,9048,'ar','Ù„Ø§Ø­Ø¸ Ø£Ù† Ù‡Ø°Ù‡ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ© Ù„Ù… ÙŠØªÙ… ØªØ¶Ù…ÙŠÙ† ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ù…Ø¹ Ù…Ø³ØªÙˆÙ‰ Ø®Ø¯Ù…Ø© Ø§Ø³ØªØ¶Ø§ÙØ©.',0),(325722,9048,'fr','Notez que ce module n\'est pas inclus automatiquement avec la norme de service d\'hÃ©bergement.',0),(325723,9048,'jp','ã“ã®ã‚¢ãƒ‰ã‚ªãƒ³ã¯å«ã¾ã‚Œãªã„ã“ã¨ã«è‡ªå‹•çš„ã«æ¨™æº–ã®ãƒ›ã‚¹ãƒ†ã‚£ãƒ³ã‚° ã‚µãƒ¼ãƒ“ã‚¹ã«æ³¨æ„ã—ã¦ãã ã•ã„ã€‚',0),(325724,9048,'pt','Note que este complemento nÃ£o Ã© incluÃ­do automaticamente com o padrÃ£o de serviÃ§o de hospedagem.',0),(325725,9048,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ, Ñ‡Ñ‚Ð¾ ÑÑ‚Ð¾ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð½Ðµ Ð²Ñ…Ð¾Ð´Ð¸Ñ‚ Ð² Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ñ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð¾Ð¼, Ñ…Ð¾ÑÑ‚Ð¸Ð½Ð³.',0),(325726,9048,'es','Ojo que este plug-in no esta incluido automaticamente con el servicio de hosting estÃ¡ndar de NolaPro',0),(325727,9048,'de','Beachten Sie, dass dieses Add-on nicht enthalten automatisch mit dem Standard-hosting-Service ist.',0),(325728,9048,'en','Note that this Add-On is not included automatically with the standard hosting service.',0),(325729,9049,'is','',0),(325730,9049,'dr','Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ø´Ø¯Ù‡  Ø§Ø² Ø§ÙŠÙ†Ø¬Ø§ ',0),(325731,9049,'pr','Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ø´Ø¯Ù‡  Ø§Ø² Ø§ÙŠÙ†Ø¬Ø§ ',0),(325732,9049,'tr','Burada satÄ±n',0),(325733,9049,'pl','kupiÄ‡ tutaj',0),(325734,9049,'bg','Ð·Ð°ÐºÑƒÐ¿ÐµÐ½Ð¸ Ñ‚ÑƒÐº',0),(325735,9049,'ur','ÛŒÛØ§Úº Ø®Ø±ÛŒØ¯Ø§',0),(325736,9049,'sr','ÐžÐ²Ð´Ðµ Ñ˜Ðµ ÐºÑƒÐ¿Ð¸Ð¾',0),(325737,9049,'vi','Ä‘Ã£ mua á»Ÿ Ä‘Ã¢y',0),(325738,9049,'af','Hier aangekoop',0),(325739,9049,'ro','cumpÄƒrat aici',0),(325740,9049,'et','osta siit',0),(325741,9049,'si','kupili tukaj',0),(325742,9049,'ba','dibeli di sini',0),(325743,9049,'nl','hier gekocht',0),(325744,9049,'fi','ostaa tÃ¤Ã¤ltÃ¤',0),(325745,9049,'no','kjÃ¸pt her',0),(325746,9049,'da','kÃ¸bes her',0),(325747,9049,'ko','ì—¬ê¸°ì— êµ¬ìž…',0),(325748,9049,'he','× ×¨×›×© ×›××Ÿ',0),(325749,9049,'el','Î±Î³Î¿ÏÎ¬ÏƒÎµÎ¹ ÎµÎ´ÏŽ',0),(325750,9049,'zh','åœ¨è¿™é‡Œè´­ä¹°\r\n',0),(325751,9049,'sv','kÃ¶pt hÃ¤r',0),(325752,9049,'it','acquistato qui',0),(325753,9049,'tl','',0),(325754,9049,'th','&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;',0),(325755,9049,'hi','à¤¯à¤¹à¤¾à¤ à¤–à¤°à¥€à¤¦à¤¾',0),(325756,9049,'ms','dibeli di sini',0),(325757,9049,'ar','Ø´Ø±Ø§Ø¡ Ù‡Ù†Ø§',0),(325758,9049,'fr','achetÃ© ici',0),(325759,9049,'jp','ã“ã“ã§è³¼å…¥',0),(325760,9049,'pt','comprado aqui',0),(325761,9049,'ru','Ð¿Ñ€Ð¸Ð¾Ð±Ñ€ÐµÑÑ‚Ð¸ Ð·Ð´ÐµÑÑŒ',0),(325762,9049,'es','Comprado aqui',0),(325763,9049,'de','hier gekauft',0),(325764,9049,'en','purchased here',0),(325765,9050,'is','',0),(325766,9050,'dr','Ø´Ù…Ø§ Ù‡Ù†ÙˆØ² Ø§ÙØ²ÙˆÙ†Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø²Ù…Ø§Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø±Ø§ Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ù†ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(325767,9050,'pr','Ø´Ù…Ø§ Ù‡Ù†ÙˆØ² Ø§ÙØ²ÙˆÙ†Ù‡ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø²Ù…Ø§Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ Ø±Ø§ Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ù†ÙƒØ±Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(325768,9050,'tr','HenÃ¼z bir yaÅŸ zaman izleme eklentisi satÄ±n deÄŸil.',0),(325769,9050,'pl','Nie nabyli jeszcze dodatek Å›ledzenie czasu pracownika.',0),(325770,9050,'bg','Ð’ÑÐµ Ð¾Ñ‰Ðµ Ð½Ðµ ÑÑ‚Ðµ ÐºÑƒÐ¿Ð¸Ð»Ð¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð²Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐºÐ°Ñ‚Ð°.',0),(325771,9050,'ur','Ø¢Ù¾ Ø§Ø¨Ú¾ÛŒ ØªÚ© Ù…Ù„Ø§Ø²Ù… ÙˆÙ‚Øª Ø³Ø±Ø§Øº Ø±Ø§Û Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ú©Ùˆ Ø®Ø±ÛŒØ¯Ø§ ÛÛ’ Ù†ÛÛŒÚº Û”',0),(325772,9050,'sr','Ð’Ð¸ Ñ˜Ð¾Ñˆ Ð½Ð¸ÑÑ‚Ðµ Ð½Ð°Ð±Ð°Ð²Ð¸Ð»Ð¸ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ Ð´Ð¾Ð´Ð°Ñ‚Ð°Ðº Ð¿Ñ€Ð°Ñ›ÐµÑšÐ° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°.',0),(325773,9050,'vi','Báº¡n chÆ°a mua ChÆ°Æ¡ng TrÃ¬nh Kiá»ƒm SoÃ¡t Thá»i Gian NhÃ¢n ViÃªn',0),(325774,9050,'af','U het nog nie die WERKNEMERS-TYDSPORINGS INPROP aangekoop nie.',0),(325775,9050,'ro','Nu ati cumparat inca angajat timp de urmÄƒrire supliment.',0),(325776,9050,'et','Te ei ole ostnud TÃ¶Ã¶taja tÃ¶Ã¶aja jÃ¤gimise moodulit',0),(325777,9050,'si','Å e niste kupili zaposlenega Äasu sledenja dodatek.',0),(325778,9050,'ba','Anda belum membeli karyawan waktu pelacakan Add-On.',0),(325779,9050,'nl','U hebt de werknemer Time Tracking Add-On nog niet gekocht.',0),(325780,9050,'fi','Et ole vielÃ¤ ostanut tyÃ¶suhde aika seuranta Add-On.',0),(325781,9050,'no','Du ennÃ¥ ikke har kjÃ¸pt ansattes tid sporing tillegget.',0),(325782,9050,'da','Du har endnu ikke kÃ¸bt medarbejder tid Tracking tilfÃ¸jelse.',0),(325783,9050,'ko','ì§ì› ì‹œê°„ ì¶”ì  ë¶€ê°€ ê¸°ëŠ¥ì„ ì•„ì§ êµ¬ìž… í•˜ì§€ ì•Šì€.',0),(325784,9050,'he','×œ× ×¨×›×©×ª ×¢×“×™×™×Ÿ ×¢×•×‘×“ ×–×ž×Ÿ ×ž×¢×§×‘ ×”×”×¨×—×‘×”.',0),(325785,9050,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Î±Î³Î¿ÏÎ¬ÏƒÎµÎ¹ Î±ÎºÏŒÎ¼Î· Ï„Î¿ Add-On Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Ï‡ÏÏŒÎ½Î¿ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚.',0),(325786,9050,'zh','æ‚¨è¿˜æ²¡æœ‰è´­ä¹°çš„å‘˜å·¥æ—¶é—´è·Ÿè¸ªæ’ä»¶\r\n',0),(325787,9050,'sv','Du har Ã¤nnu inte kÃ¶pt anstÃ¤lld tid spÃ¥rning tillÃ¤gg.',0),(325788,9050,'it','Non avete ancora acquistato l\'add-on della Tracking tempo dipendente.',0),(325789,9050,'tl','',0),(325790,9050,'th','You have not yet purchased the Employee Time Tracking Plug-in.',0),(325791,9050,'hi','à¤¤à¥à¤® à¤…à¤­à¥€ à¤¤à¤• à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤®à¤¯ à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤à¤¡-à¤‘à¤¨ à¤¨à¤¹à¥€à¤‚ à¤–à¤°à¥€à¤¦à¤¾ à¤¹à¥ˆà¥¤',0),(325792,9050,'ms','Anda tidak lagi membeli tambahan Penjejakan masa pekerja.',0),(325793,9050,'ar','Ù„Ù… ØªØ´ØªØ±ÙŠ Ø¨Ø¹Ø¯ \"Ø§Ù„Ø¥Ø¶Ø§ÙØ© ØªØªØ¨Ø¹ ÙˆÙ‚Øª Ø§Ù„Ù…ÙˆØ¸Ù\".',0),(325794,9050,'fr','Vous n\'avez pas encore achetÃ© le module de suivi de temps employÃ©.',0),(325795,9050,'jp','å¾“æ¥­å“¡ã®æ™‚é–“ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚° ã‚¢ãƒ‰ã‚ªãƒ³ã¾ã è³¼å…¥ã—ã¦ã„ã¾ã›ã‚“ã€‚',0),(325796,9050,'pt','VocÃª ainda nÃ£o comprou o complemento de rastreamento de tempo empregado.',0),(325797,9050,'ru','Ð’Ñ‹ ÐµÑ‰Ðµ Ð½Ðµ Ð¿Ñ€Ð¸Ð¾Ð±Ñ€ÐµÐ»Ð¸ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°.',0),(325798,9050,'es','Ya No HabÃ­a Comprado el Plug-In de Rastreo de Tiempo de Empleado',0),(325799,9050,'de','Sie haben noch nicht das Employee Time Tracking Add-On gekauft.',0),(325800,9050,'en','You have not yet purchased the Employee Time Tracking Add-On.',0),(325801,9051,'is','',0),(325802,9051,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÙŠØ´ØªØ± Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø§Ø±ØªÙ‚Ø§Ø¹ Ø¯Ù‡Ù†Ø¯Ù‡ Ø³ÙŠØ³ØªÙ… Ø±Ø¯ ÙŠØ§Ø¨ÙŠ Ø²Ù…Ø§Ù†ÙŠ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(325803,9051,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÙŠØ´ØªØ± Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø§Ø±ØªÙ‚Ø§Ø¹ Ø¯Ù‡Ù†Ø¯Ù‡ Ø³ÙŠØ³ØªÙ… Ø±Ø¯ ÙŠØ§Ø¨ÙŠ Ø²Ù…Ø§Ù†ÙŠ Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(325804,9051,'tr','Zaman izleme sistemi eklentisi hakkÄ±nda daha fazla bilgi iÃ§in burayÄ± tÄ±klatÄ±n',0),(325805,9051,'pl','Kliknij tutaj wiÄ™cej informacji na temat Time Tracking System plug-in',0),(325806,9051,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº Ð·Ð° Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð²Ñ€ÐµÐ¼Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð·Ð° ÑÐ»ÐµÐ´ÐµÐ½Ðµ Ð½Ð° plug-in',0),(325807,9051,'ur','Ø§Ø³ ÙˆÙ‚Øª Ø³Ø±Ø§Øº Ú©Ø§Ø±ÛŒ Ù†Ø¸Ø§Ù… Ù¾Ù„Ú¯-Ø§Ù† Ú©Û’ Ø¨Ø§Ø±Û’ Ù…ÛŒÚº Ù…Ø²ÛŒØ¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(325808,9051,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð·Ð° Ð²Ð¸ÑˆÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ ÑÐ¸ÑÑ‚ÐµÐ¼ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ðµ',0),(325809,9051,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ cÃ³ thÃªm thÃ´ng tin vá» bá»™ dÃ² thá»i gian cáº¯m vÃ o há»‡ thá»‘ng cá»§a NolaPro',0),(325810,9051,'af','Kliek hier vir meer inligting omtrent die NolaPro Time Tracking System plug-in (\"NolaPro Tydklokkaart Inprop-sisteem\")',0),(325811,9051,'ro','Click aici pentru mai multe informaÅ£ii despre timp de urmÄƒrire sistem plug-in-',0),(325812,9051,'et','Vajuta siia rohkem infot aega jÃ¤lgimise sÃ¼steemi plug-in',0),(325813,9051,'si','Kliknite tukaj za veÄ informacij o Äasu Tracking System, plug-in',0),(325814,9051,'ba','Klik di sini untuk info lebih lanjut tentang waktu pelacakan sistem plug-in',0),(325815,9051,'nl','Klik hier voor meer info over het Time Tracking System plug-in',0),(325816,9051,'fi','Klikkaa tÃ¤stÃ¤ lisÃ¤tietoja Time Tracking System plug-in',0),(325817,9051,'no','Klikk her for mer info om tid sporing systemet plug-in',0),(325818,9051,'da','Klik her for mere info om den tid Tracking System plug-in',0),(325819,9051,'ko','ì‹œê°„ ì¶”ì  ì‹œìŠ¤í…œ í”ŒëŸ¬ê·¸ ì¸ì— ëŒ€ í•œ ë” ë§Žì€ ì •ë³´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì„¸ìš”',0),(325820,9051,'he','×œ×—×¥ ×›××Ÿ ×œ×§×‘×œ×ª ×ž×™×“×¢ × ×•×¡×£ ××•×“×•×ª ×–×ž×Ÿ ×ž×¢×§×‘ ×ž×¢×¨×›×ª ×™×™×©×•× plug-in',0),(325821,9051,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î¿ Ï‡ÏÏŒÎ½Î¿ Î±ÎºÎ¿Î»Î¿Ï…Î¸ÏŽÎ½Ï„Î±Ï‚ ÏƒÏÏƒÏ„Î·Î¼Î± plug-in',0),(325822,9051,'zh','ç‚¹å‡»è¿™é‡ŒèŽ·å–æ›´å¤šä¿¡æ¯æœ‰å…³æ—¶è·Ÿè¸ªç³»ç»Ÿæ’ä»¶\r\n',0),(325823,9051,'sv','Klicka hÃ¤r fÃ¶r mer info om den tid Tracking System plug-in',0),(325824,9051,'it','Clicca qui per maggiori informazioni circa il sistema di Tracking tempo plug-in',0),(325825,9051,'tl','',0),(325826,9051,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3637;&#3656;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3648;&#3585;&#3637;&#3',0),(325827,9051,'hi','à¤¸à¤®à¤¯ à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤ªà¥à¤²à¤—-à¤‡à¤¨ à¤•à¥‡ à¤¬à¤¾à¤°à¥‡ à¤®à¥‡à¤‚ à¤…à¤§à¤¿à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(325828,9051,'ms','Klik di sini untuk maklumat lebih lanjut mengenai masa pengesanan sistem Pemalam',0),(325829,9051,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ù…Ø²ÙŠØ¯ Ù…Ù† Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø­ÙˆÙ„ \"Ù†Ø¸Ø§Ù… ØªØ¹Ù‚Ø¨ Ø§Ù„ÙˆÙ‚Øª\" Ø§Ù„Ù…ÙƒÙˆÙ† Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ',0),(325830,9051,'fr','Cliquez ici pour plus d\'informations sur le plug-in Time Tracking System',0),(325831,9051,'jp','ãƒ—ãƒ©ã‚°ã‚¤ãƒ³ã®æ™‚é–“è¿½è·¡ã‚·ã‚¹ãƒ†ãƒ ã«é–¢ã™ã‚‹è©³ç´°æƒ…å ±ã¯ã€ã“ã¡ã‚‰ã‚’ã”è¦§ãã ã•ã„ã€‚',0),(325832,9051,'pt','Clique aqui para mais informaÃ§Ãµes sobre o sistema de rastreamento tempo plug-in',0),(325833,9051,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ Ð´Ð»Ñ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð¹ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ ÑÐ¸ÑÑ‚ÐµÐ¼Ðµ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð¿Ð»Ð°Ð³Ð¸Ð½',0),(325834,9051,'es','Hace Click aqui para mÃ¡s info sobre el plug-in de NolaPro Sistema de Rastrear el Tiempo',0),(325835,9051,'de','Klicken Sie hier fÃ¼r mehr Info Ã¼ber das Plug-in-Time Tracking System',0),(325836,9051,'en','Click here for more info about the Time Tracking System plug-in',0),(325837,9052,'is','',0),(325838,9052,'dr',':  Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†ÙŠ ÙƒÙ‡ Ø±Ø§Ù‡ Ø­Ù„Ù‡Ø§ÙŠ Ø¨Ù‡ Ù…Ø­Ø¶ ØªÙ‚Ø§Ø¶Ø§ÙŠ Ù…ÙŠØ²Ø¨Ø§Ù† Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ù…ÙŠÙƒÙ†Ù†Ø¯ Ù…Ø²Ø§ÙŠØ§ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡  Ø±Ø§ Ø¨Ø¯ÙˆÙ† Ù‡ÙŠÚ† Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø®ÙˆØ§Ù‡Ù†Ø¯ ÙƒØ±Ø¯ ',0),(325839,9052,'pr','ØªÙˆØ¬Ù‡ ÙƒÙ†ÙŠØ¯ ÙƒÙ‡ :  Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†ÙŠ ÙƒÙ‡ Ø±Ø§Ù‡ Ø­Ù„Ù‡Ø§ÙŠ Ø¨Ù‡ Ù…Ø­Ø¶ ØªÙ‚Ø§Ø¶Ø§ÙŠ Ù…ÙŠØ²Ø¨Ø§Ù† Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ù…ÙŠÙƒÙ†Ù†Ø¯ Ù…Ø²Ø§ÙŠØ§ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡  Ø±Ø§ Ø¨Ø¯ÙˆÙ† Ù‡ÙŠÚ† Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙŠ Ø¯Ø±ÙŠØ§ÙØª Ø®ÙˆØ§Ù‡Ù†Ø¯ ÙƒØ±Ø¯ ',0),(325840,9052,'tr','<b>Ä°steÄŸe baÄŸlÄ± Ã§Ã¶zÃ¼m Hosting</b> seÃ§imi mÃ¼ÅŸteriler alacaksÄ±nÄ±z unutmayÄ±n',0),(325841,9052,'pl','NaleÅ¼y zauwaÅ¼yÄ‡, Å¼e otrzymajÄ… klienci wybierajÄ…c <b>Hosting rozwiÄ…zanie na Å¼Ä…danie</b>',0),(325842,9052,'bg','ÐžÐ±ÑŠÑ€Ð½ÐµÑ‚Ðµ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ, Ñ‡Ðµ Ñ‰Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ð¾Ñ€ <b>ÐŸÑ€Ð¸ Ð¿Ð¾Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ñ…Ð¾ÑÑ‚Ð¸Ð½Ð³ Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ</b>',0),(325843,9052,'ur','Ù†ÙˆÙ¹ Ú©Ø±ÛŒÚº Ú©Û Ú¯Ø§ÛÚ©ÙˆÚº Ù†Û’ <b>Ø¨Ø±-Ø·Ù„Ø¨ Ø­Ù„ Ú©ÛŒ Ù…ÛŒØ²Ø¨Ø§Ù†ÛŒ</b> Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙˆØµÙˆÙ„ Ú©Ø±ÛŒÚº Ú¯Û’',0),(325844,9052,'sr','Ð˜Ð¼Ð°Ñ˜Ñ‚Ðµ Ð½Ð° ÑƒÐ¼Ñƒ Ð´Ð° Ñ›Ðµ Ð´Ð¾Ð±Ð¸Ñ‚Ð¸ ÐºÑƒÐ¿Ñ†Ð¸ Ð±Ð¸Ñ€Ð°ÑšÐµ <b>ÐÐ° Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ² Ñ€ÐµÑˆÐµÑšÐµ Ð·Ð° Ð¥Ð¾ÑÑ‚Ð¸Ð½Ð³</b>',0),(325845,9052,'vi','KhÃ¡ch hÃ ng chá»n <b>Giáº£i PhÃ¡p Hosting Theo Nhu Cáº§u </b>sáº½ nháº­n Ä‘Æ°á»£c 1 gÃ³i khuyáº¿n máº¡i \"ThÃªm VÃ o\" khÃ´ng tÃ­nh thÃªm phÃ­.',0),(325846,9052,'af','Neem kennis dat kliente/klante wat die <b>On-Demand Hosting Solution (\"Op Aanvraag Gasheer Oplossing\")</b><br>kies sal alle premium Byvoegings ontvang teen geen ekstra koste nie.',0),(325847,9052,'ro','ReÅ£ineÅ£i cÄƒ va primi clienÅ£ii alegerea <b>On-Demand Hosting Solution</b>',0),(325848,9052,'et','Pange tÃ¤hele, valides <b>NÃµudmisel Virtuaalserver Solution</b> kliendid saavad',0),(325849,9052,'si','UpoÅ¡tevajte, da bodo prejeli izbiri <b>ReÅ¡itev za gostovanje na zahtevo</b> stranke',0),(325850,9052,'ba','Dicatat bahwa pelanggan memilih <b>On-Demand Hosting solusi</b> akan menerima',0),(325851,9052,'nl','Merk op dat de klanten kiezen van de <b>On-Demand Hosting oplossing</b> krijgt',0),(325852,9052,'fi','Huomaa, ettÃ¤ asiakkaat valitsevat <b>PyydettÃ¤essÃ¤ Hosting ratkaisu</b> saa',0),(325853,9052,'no','Merk at kundene Ã¥ velge <b>Behovsbetinget Hosting lÃ¸sning</b> vil motta',0),(325854,9052,'da','BemÃ¦rk at kunder vÃ¦lger <b>On-Demand Hosting lÃ¸sning</b> vil fÃ¥',0),(325855,9052,'ko','ê³ ê° <b>ìš”ì²­ ì‹œ í˜¸ìŠ¤íŒ… ì†”ë£¨ì…˜</b> ì„ ì„ íƒ ë°›ê²Œ ë©ë‹ˆë‹¤ note',0),(325856,9052,'he','×©×™×ž×• ×œ×‘ ×›×™ ×”×œ×§×•×—×•×ª ×‘×•×—×¨×™× ××ª <b>×¤×ª×¨×•×Ÿ ××™×¨×•×— ×¢×œ ×¤×™ ×“×¨×™×©×”</b> ×™×§×‘×œ×•',0),(325857,9052,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÏ„Îµ ÏŒÏ„Î¹ Î¿Î¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÎµÏ€Î¹Î»Î­Î³Î¿Ï…Î½ Ï„Î¿ <b>On-Demand Î»ÏÏƒÎ· Ï†Î¹Î»Î¿Î¾ÎµÎ½Î¯Î±</b> Î¸Î± Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½',0),(325858,9052,'zh','è¯·æ³¨æ„ï¼Œå®¢æˆ·é€‰æ‹©çš„<b>æŒ‰éœ€æ‰˜ç®¡è§£å†³æ–¹æ¡ˆ\r\n',0),(325859,9052,'sv','Observera att kunder att vÃ¤lja <b>On-Demand Hosting Solution</b> fÃ¥r',0),(325860,9052,'it','Si noti che riceveranno i clienti scegliendo la <b>Soluzione di Hosting On-Demand</b>',0),(325861,9052,'tl','',0),(325862,9052,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¹ƒà¸«à¹‰ à¹€à¸¥à¸·à¸­à¸<b>à¹‚à¸‹à¸¥à¸¹à¸Šà¸±à¸™à¸—à¸µà¹ˆà¹‚à¸®à¸ªà¸•à¸´à¹‰à¸‡à¸•à¸²à¸¡à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£</b>à¸¥à¸¹à¸à¸„à¹‰à¸²à¸ˆà¸°à¹„à¸”à¹‰à¸£à¸±à¸š',0),(325863,9052,'hi','à¤§à¥à¤¯à¤¾à¤¨ à¤¦à¥‡à¤‚ à¤•à¤¿ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ <b>à¤®à¤¾à¤‚à¤— à¤ªà¤° à¤¸à¤®à¤¾à¤§à¤¾à¤¨ à¤¹à¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤—</b> à¤šà¥à¤¨à¤¨à¥‡ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤—à¤¾',0),(325864,9052,'ms','Ambil perhatian bahawa memilih <b>Penyelesaian Hosting atas permintaan</b> pelanggan akan menerima',0),(325865,9052,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø£Ù† Ø³ÙˆÙ ØªØªÙ„Ù‚Ù‰ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ø®ØªÙŠØ§Ø± <b>Ø§Ù„Ø­Ù„ Ø§Ø³ØªØ¶Ø§ÙØ© Ø­Ø³Ø¨ Ø§Ù„Ø·Ù„Ø¨</b>',0),(325866,9052,'fr','Notez que le choix de la <b>Solution d\'hÃ©bergement Ã  la demande</b> de clients recevront',0),(325867,9052,'jp','<b>ã‚ªãƒ³ãƒ‡ãƒžãƒ³ãƒ‰ã§ãƒ›ã‚¹ãƒ†ã‚£ãƒ³ã‚° ã‚½ãƒªãƒ¥ãƒ¼ã‚·ãƒ§ãƒ³</b>ã‚’é¸æŠžã™ã‚‹é¡§å®¢ãŒå—ã‘å–ã‚‹ã“ã¨ã«æ³¨æ„ã—ã¦ãã ã•ã„ã€‚',0),(325868,9052,'pt','Observe que os clientes a escolha da <b>SoluÃ§Ã£o de hospedagem On-Demand</b> receberÃ£o',0),(325869,9052,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ, Ñ‡Ñ‚Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ Ð²Ñ‹Ð±Ð¾Ñ€ <b>Ð¥Ð¾ÑÑ‚Ð¸Ð½Ð³Ð° Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð¿Ð¾ Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸ÑŽ</b> ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(325870,9052,'es','Ojo que clientes escogiendo la <b>SoluciÃ³n de Hosting por Demanda</b> recibirÃ¡n',0),(325871,9052,'de','Beachten Sie, dass Kunden, die Wahl der <b>On-Demand-Hosting-LÃ¶sung</b> erhalten',0),(325872,9052,'en','Note that customers choosing the <b>On-Demand Hosting Solution</b> will receive',0),(325873,9053,'is','',0),(325874,9053,'dr','Ø¬Ù…Ø¹Ù‡ ',0),(325875,9053,'pr','Ø¬Ù…Ø¹Ù‡ ',0),(325876,9053,'tr','Cum',0),(325877,9053,'pl','Pt',0),(325878,9053,'bg','ÐŸÑ‚',0),(325879,9053,'ur','Ø¬Ù…Ø¹Û',0),(325880,9053,'sr','Ð¤Ñ€Ð¸',0),(325881,9053,'vi','Thá»© sÃ¡u',0),(325882,9053,'af','Vry',0),(325883,9053,'ro','Vineri',0),(325884,9053,'et','R',0),(325885,9053,'si','PE',0),(325886,9053,'ba','Jumat',0),(325887,9053,'nl','Vr',0),(325888,9053,'fi','PE',0),(325889,9053,'no','Fr',0),(325890,9053,'da','Fre',0),(325891,9053,'ko','(ê¸ˆ)',0),(325892,9053,'he','×©×™×©×™',0),(325893,9053,'el','Î Î±Ï',0),(325894,9053,'zh','å‘¨äº”\r\n',0),(325895,9053,'sv','Fre',0),(325896,9053,'it','Ven',0),(325897,9053,'tl','',0),(325898,9053,'th','&#3624;&#3640;&#3585;&#3619;&#3660;',0),(325899,9053,'hi','à¤¶à¥à¤•à¥à¤°',0),(325900,9053,'ms','Jumaat',0),(325901,9053,'ar','Ø§Ù„Ø¬Ù…Ø¹Ø©',0),(325902,9053,'fr','Ven',0),(325903,9053,'jp','(é‡‘)',0),(325904,9053,'pt','Sexta-feira',0),(325905,9053,'ru','ÐŸÑÑ‚Ð½',0),(325906,9053,'es','Vie',0),(325907,9053,'de','Fr',0),(325908,9053,'en','Fri',0),(325909,9054,'is','',0),(325910,9054,'dr','Ø¯ÙˆØ´Ù†Ø¨Ù‡ ',0),(325911,9054,'pr','Ø¯ÙˆØ´Ù†Ø¨Ù‡ ',0),(325912,9054,'tr','Pzt',0),(325913,9054,'pl','Mon',0),(325914,9054,'bg','Mon',0),(325915,9054,'ur','Ù¾ÛŒØ±',0),(325916,9054,'sr','ÐœÐ¾Ð½',0),(325917,9054,'vi','Thá»© hai',0),(325918,9054,'af','Maan',0),(325919,9054,'ro','Mon',0),(325920,9054,'et','E',0),(325921,9054,'si','Mon',0),(325922,9054,'ba','Mon',0),(325923,9054,'nl','Mon',0),(325924,9054,'fi','Ma',0),(325925,9054,'no','Man',0),(325926,9054,'da','Mon',0),(325927,9054,'ko','ì›”',0),(325928,9054,'he','×©× ×™',0),(325929,9054,'el','Î”ÎµÏ…Ï„',0),(325930,9054,'zh','å‘¨ä¸€\r\n',0),(325931,9054,'sv','Mon',0),(325932,9054,'it','Mon',0),(325933,9054,'tl','',0),(325934,9054,'th','&#3592;&#3633;&#3609;&#3607;&#3619;&#3660;',0),(325935,9054,'hi','à¤¸à¥‹à¤®',0),(325936,9054,'ms','Mon',0),(325937,9054,'ar','Ø§Ù„Ø¥Ø«Ù†ÙŠÙ†',0),(325938,9054,'fr','Lun',0),(325939,9054,'jp','(æœˆ)',0),(325940,9054,'pt','Mon',0),(325941,9054,'ru','ÐŸÐ¾Ð½ÐµÐ´',0),(325942,9054,'es','Lun',0),(325943,9054,'de','Mo',0),(325944,9054,'en','Mon',0),(325945,9055,'is','',0),(325946,9055,'dr','Ø´Ù†Ø¨Ù‡ ',0),(325947,9055,'pr','Ø´Ù†Ø¨Ù‡ ',0),(325948,9055,'tr','Cts',0),(325949,9055,'pl','SAT',0),(325950,9055,'bg','Ð¡Ð±',0),(325951,9055,'ur','Ø¨ÛŒÙ¹Ú¾Ø§',0),(325952,9055,'sr','Ð¡ÐµÐ¾',0),(325953,9055,'vi','Thá»© báº£y',0),(325954,9055,'af','Sat',0),(325955,9055,'ro','Sat',0),(325956,9055,'et','L',0),(325957,9055,'si','SAT',0),(325958,9055,'ba','Sat',0),(325959,9055,'nl','SAT',0),(325960,9055,'fi','SAT',0),(325961,9055,'no','LÃ¸r',0),(325962,9055,'da','LÃ¸r',0),(325963,9055,'ko','í† ',0),(325964,9055,'he','×©×‘×ª',0),(325965,9055,'el','Î£Î¬Î²',0),(325966,9055,'zh','æ˜ŸæœŸå…­\r\n',0),(325967,9055,'sv','LÃ¶r',0),(325968,9055,'it','SAT',0),(325969,9055,'tl','',0),(325970,9055,'th','&#3648;&#3626;&#3634;&#3619;&#3660;',0),(325971,9055,'hi','à¤¶à¤¨à¤¿',0),(325972,9055,'ms','Sat',0),(325973,9055,'ar','Ø§Ù„Ø³Ø¨Øª',0),(325974,9055,'fr','Sam',0),(325975,9055,'jp','åœŸ',0),(325976,9055,'pt','SAT',0),(325977,9055,'ru','Ð¡ÑƒÐ±',0),(325978,9055,'es','Sab',0),(325979,9055,'de','Sa',0),(325980,9055,'en','Sat',0),(325981,9056,'is','',0),(325982,9056,'dr','ÙŠÙƒØ´Ù†Ø¨Ù‡ ',0),(325983,9056,'pr','ÙŠÙƒØ´Ù†Ø¨Ù‡ ',0),(325984,9056,'tr','GÃ¼neÅŸ',0),(325985,9056,'pl','SÅ‚oÅ„ce',0),(325986,9056,'bg','Ð¡Ð»ÑŠÐ½Ñ†Ðµ',0),(325987,9056,'ur','Ø³ÙˆØ±Ø¬',0),(325988,9056,'sr','Ð¡ÑƒÐ½Ñ†Ðµ',0),(325989,9056,'vi','Chá»§ nháº­t',0),(325990,9056,'af','So',0),(325991,9056,'ro','Soare',0),(325992,9056,'et','P',0),(325993,9056,'si','Sonce',0),(325994,9056,'ba','Sun',0),(325995,9056,'nl','Sun',0),(325996,9056,'fi','Sun',0),(325997,9056,'no','Solen',0),(325998,9056,'da','Solen',0),(325999,9056,'ko','íƒœì–‘',0),(326000,9056,'he','×¨××©×•×Ÿ',0),(326001,9056,'el','Î‰Î»Î¹Î¿',0),(326002,9056,'zh','å‘¨æ—¥\r\n',0),(326003,9056,'sv','Sun',0),(326004,9056,'it','Sun',0),(326005,9056,'tl','',0),(326006,9056,'th','&#3629;&#3634;&#3607;&#3636;&#3605;&#3618;&#3660;',0),(326007,9056,'hi','à¤¸à¥‚à¤°à¤œ',0),(326008,9056,'ms','Matahari.',0),(326009,9056,'ar','Ø§Ù„Ø£Ø­Ø¯',0),(326010,9056,'fr','Sun',0),(326011,9056,'jp','å¤ªé™½',0),(326012,9056,'pt','Sol',0),(326013,9056,'ru','Ð’Ð¾ÑÐºÑ€',0),(326014,9056,'es','Dom',0),(326015,9056,'de','Sun',0),(326016,9056,'en','Sun',0),(326017,9057,'is','',0),(326018,9057,'dr','Ù¾Ù†Ø¬  Ø´Ù†Ø¨Ù‡ ',0),(326019,9057,'pr','Ù¾Ù†Ø¬  Ø´Ù†Ø¨Ù‡ ',0),(326020,9057,'tr','PrÅŸ',0),(326021,9057,'pl','Czw',0),(326022,9057,'bg','Ð§Ñ‚',0),(326023,9057,'ur','Ø¬Ù…Ø¹Ø±Ø§Øª Ú©Û’ Ù„Ø¦Û’',0),(326024,9057,'sr','Ð§ÐµÑ‚.',0),(326025,9057,'vi','Thá»© nÄƒm',0),(326026,9057,'af','Do',0),(326027,9057,'ro','Joi',0),(326028,9057,'et','N',0),(326029,9057,'si','ÄŒet',0),(326030,9057,'ba','Kamis',0),(326031,9057,'nl','Do',0),(326032,9057,'fi','To',0),(326033,9057,'no','Tor',0),(326034,9057,'da','Skrevet tors',0),(326035,9057,'ko','ëª©',0),(326036,9057,'he','×—×ž×™×©×™',0),(326037,9057,'el','Î Î­Î¼',0),(326038,9057,'zh','å‘¨å››\r\n',0),(326039,9057,'sv','Tor',0),(326040,9057,'it','Gio',0),(326041,9057,'tl','',0),(326042,9057,'th','&#3614;&#3620;&#3627;&#3633;&#3626;',0),(326043,9057,'hi','à¤—à¥à¤°à¥‚',0),(326044,9057,'ms','Thu',0),(326045,9057,'ar','Ø§Ù„Ø®Ù…ÙŠØ³',0),(326046,9057,'fr','Jeu',0),(326047,9057,'jp','æœ¨',0),(326048,9057,'pt','Quinta-feira',0),(326049,9057,'ru','Ð§ÐµÑ‚Ð²',0),(326050,9057,'es','Jue',0),(326051,9057,'de','Do',0),(326052,9057,'en','Thu',0),(326053,9058,'is','',0),(326054,9058,'dr','Ø³Ù‡ Ø´Ù†Ø¨Ù‡ ',0),(326055,9058,'pr','Ø³Ù‡ Ø´Ù†Ø¨Ù‡ ',0),(326056,9058,'tr','Sal',0),(326057,9058,'pl','WT',0),(326058,9058,'bg','Ð’Ñ‚Ð¾',0),(326059,9058,'ur','Ù…Ù†Ú¯Ù„',0),(326060,9058,'sr','Ð£Ñ‚Ð¾',0),(326061,9058,'vi','Thá»© ba',0),(326062,9058,'af','Di',0),(326063,9058,'ro','Marti',0),(326064,9058,'et','T',0),(326065,9058,'si','Tor',0),(326066,9058,'ba','Selasa',0),(326067,9058,'nl','Tue',0),(326068,9058,'fi','Ti',0),(326069,9058,'no','Tir',0),(326070,9058,'da','Tue',0),(326071,9058,'ko','í™”',0),(326072,9058,'he','×©×œ×™×©×™',0),(326073,9058,'el','Î¤ÏÎ¯',0),(326074,9058,'zh','æ—¥å‘¨äºŒ\r\n',0),(326075,9058,'sv','Tis',0),(326076,9058,'it','Mar',0),(326077,9058,'tl','',0),(326078,9058,'th','&#3629;&#3633;&#3591;&#3588;&#3634;&#3619;',0),(326079,9058,'hi','à¤®à¤‚à¤—à¤²',0),(326080,9058,'ms','Tue',0),(326081,9058,'ar','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡',0),(326082,9058,'fr','Mar',0),(326083,9058,'jp','ç«',0),(326084,9058,'pt','TerÃ§a-feira',0),(326085,9058,'ru','Ð’Ñ‚Ð¾Ñ€',0),(326086,9058,'es','Mar',0),(326087,9058,'de','Di',0),(326088,9058,'en','Tue',0),(326089,9059,'is','',0),(326090,9059,'dr','Ú†Ù‡Ø§Ø± Ø´Ù†Ø¨Ù‡ ',0),(326091,9059,'pr','Ú†Ù‡Ø§Ø± Ø´Ù†Ø¨Ù‡ ',0),(326092,9059,'tr','Tarih Ã‡rÅŸ',0),(326093,9059,'pl','Åšroda',0),(326094,9059,'bg','Ð¡Ñ€',0),(326095,9059,'ur','Ø¨ÛŒØ§ÛÙ†Ø§',0),(326096,9059,'sr','Ð¡Ñ€Ðµ',0),(326097,9059,'vi','Thá»© tÆ°',0),(326098,9059,'af','Wo',0),(326099,9059,'ro','Miercuri',0),(326100,9059,'et','K',0),(326101,9059,'si','Sre',0),(326102,9059,'ba','Menikah',0),(326103,9059,'nl','Wo',0),(326104,9059,'fi','Ke',0),(326105,9059,'no','Ons',0),(326106,9059,'da','Ons',0),(326107,9059,'ko','ê²°í˜¼',0),(326108,9059,'he','×¨×‘×™×¢×™',0),(326109,9059,'el','Î¤ÎµÏ„',0),(326110,9059,'zh','å‘¨ä¸‰\r\n',0),(326111,9059,'sv','Ons',0),(326112,9059,'it','Mer',0),(326113,9059,'tl','',0),(326114,9059,'th','&#3614;&#3640;&#3608;',0),(326115,9059,'hi','à¤¬à¥à¤§',0),(326116,9059,'ms','Berkahwin',0),(326117,9059,'ar','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡',0),(326118,9059,'fr','Mer',0),(326119,9059,'jp','æ°´',0),(326120,9059,'pt','Quarta-feira',0),(326121,9059,'ru','Ð¡Ñ€ÐµÐ´Ð°',0),(326122,9059,'es','Mie',0),(326123,9059,'de','Mi',0),(326124,9059,'en','Wed',0),(326125,9060,'is','',0),(326126,9060,'dr','Ø§Ù…Ø±ÙˆØ² Ø§Ø³Øª ',0),(326127,9060,'pr','Ø§Ù…Ø±ÙˆØ² Ø§Ø³Øª ',0),(326128,9060,'tr','BugÃ¼n',0),(326129,9060,'pl','Dzisiaj jest',0),(326130,9060,'bg','Ð”Ð½ÐµÑ Ðµ',0),(326131,9060,'ur','Ø¢Ø¬ ÛÛ’',0),(326132,9060,'sr','Ð”Ð°Ð½Ð°Ñ Ñ˜Ðµ',0),(326133,9060,'vi','HÃ´m nay lÃ ',0),(326134,9060,'af','Vandag is',0),(326135,9060,'ro','AstÄƒzi este',0),(326136,9060,'et','TÃ¤na on',0),(326137,9060,'si','Danes je',0),(326138,9060,'ba','Hari ini',0),(326139,9060,'nl','Vandaag is',0),(326140,9060,'fi','TÃ¤nÃ¤Ã¤n on',0),(326141,9060,'no','I dag er',0),(326142,9060,'da','I dag er',0),(326143,9060,'ko','ì˜¤ëŠ˜ì€',0),(326144,9060,'he','×”×™×•× ×”×•×',0),(326145,9060,'el','Î£Î®Î¼ÎµÏÎ± ÎµÎ¯Î½Î±Î¹',0),(326146,9060,'zh','ä»Šå¤©æ˜¯\r\n',0),(326147,9060,'sv','Idag Ã¤r',0),(326148,9060,'it','Oggi Ã¨ il',0),(326149,9060,'tl','',0),(326150,9060,'th','&#3623;&#3633;&#3609;&#3609;&#3637;&#3657;&#3588;&#3639;&#3629;',0),(326151,9060,'hi','à¤†à¤œ à¤¹à¥ˆ',0),(326152,9060,'ms','Hari ini',0),(326153,9060,'ar','Ø§Ù„ÙŠÙˆÙ… Ù‡Ùˆ ',0),(326154,9060,'fr','Aujourd\'hui, c\'est',0),(326155,9060,'jp','ä»Šæ—¥ã¯',0),(326156,9060,'pt','Hoje Ã©',0),(326157,9060,'ru','Ð¡ÐµÐ³Ð¾Ð´Ð½Ñ',0),(326158,9060,'es','Hoy es',0),(326159,9060,'de','Heute ist',0),(326160,9060,'en','Today is',0),(326161,9061,'is','',0),(326162,9061,'dr','Ú¯Ø±Ø§ÙÙŠÙƒ Ø³Ø± ØµÙØ­Ù‡ Ø´Ø±ÙƒØª   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(326163,9061,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ Ø³Ø± ØµÙØ­Ù‡ Ø´Ø±ÙƒØª   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(326164,9061,'tr','B2B ÅŸirket baÅŸlÄ±k grafik',0),(326165,9061,'pl','Firma B2B nagÅ‚Ã³wek graficzny',0),(326166,9061,'bg','B2B ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Header Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÐ½',0),(326167,9061,'ur','B2B Ú©Ù…Ù¾Ù†ÛŒ Ø³Ø±ØªØ­Ø±ÛŒØ± Ú¯Ø±Ø§ÙÛŒ',0),(326168,9061,'sr','Ð‘2Ð‘ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(326169,9061,'vi','TiÃªu Äá» CÃ´ng Ty B2B',0),(326170,9061,'af','B2B Onderneming Koppenend Grafika',0),(326171,9061,'ro','B2B companiei antet grafic',0),(326172,9061,'et','B2B ettevÃµtte pÃ¤ise graafika',0),(326173,9061,'si','Header grafiÄno podjetje B2B',0),(326174,9061,'ba','B2B Perusahaan Header grafis',0),(326175,9061,'nl','B2B Company Header Graphic',0),(326176,9061,'fi','B2B-yritykset otsikon graafinen',0),(326177,9061,'no','B2B selskapet Header grafikk',0),(326178,9061,'da','B2B virksomhed Header grafik',0),(326179,9061,'ko','B2B íšŒì‚¬ í—¤ë” ê·¸ëž˜í”½',0),(326180,9061,'he','×—×‘×¨×ª B2B ×¢×œ×™×•× ×” ×’×¨×¤×™×§×”',0),(326181,9061,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î±Ï‚ B2B ÎºÎµÏ†Î±Î»Î¯Î´Î± Î³ÏÎ±Ï†Î¹ÎºÏŽÎ½',0),(326182,9061,'zh','å•†ä¸šå¯¹å•†ä¸šå…¬å¸æ ‡é¢˜å›¾ç¤º\r\n',0),(326183,9061,'sv','B2B fÃ¶retag Header grafik',0),(326184,9061,'it','Header grafico azienda B2B',0),(326185,9061,'tl','',0),(326186,9061,'th','&#3649;&#3610;&#3609;&#3648;&#3609;&#3629;&#3619;&#3660;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607; B2B',0),(326187,9061,'hi','B2B à¤•à¤‚à¤ªà¤¨à¥€ à¤—à¥à¤°à¤¾à¤«à¤¿à¤• à¤¶à¥€à¤°à¥à¤·à¤•',0),(326188,9061,'ms','Syarikat B2B Header grafik',0),(326189,9061,'ar','Ø´Ø±ÙƒØ© B2B Ø±Ø£Ø³ Ø¨ÙŠØ§Ù†ÙŠØ©',0),(326190,9061,'fr','B2B entreprise en-tÃªte graphique',0),(326191,9061,'jp','B2B ä¼æ¥­ãƒ˜ãƒƒãƒ€ãƒ¼ ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã‚¹',0),(326192,9061,'pt','B2B empresa cabeÃ§alho grÃ¡fico',0),(326193,9061,'ru','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²Ð¾Ðº B2B ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(326194,9061,'es','N2N GrÃ¡fica de Encabezado de la Empresa',0),(326195,9061,'de','B2B-Unternehmen-Header-Grafik',0),(326196,9061,'en','B2B Company Header Graphic',0),(326197,9062,'is','',0),(326198,9062,'dr','B2B Ù„ÙˆÚ¯Ùˆ  Ú†Ø§Ù¾ÙŠ Ø´Ø± ÙƒØª    ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(326199,9062,'pr','B2B Ù„ÙˆÚ¯Ùˆ  Ú†Ø§Ù¾ÙŠ Ø´Ø± ÙƒØª    ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(326200,9062,'tr','YazdÄ±rma B2B ÅŸirket logosu',0),(326201,9062,'pl','Wydruku Logo firmy B2B',0),(326202,9062,'bg','B2B Ð»Ð¾Ð³Ð¾ Ð¿ÐµÑ‡Ð°Ñ‚',0),(326203,9062,'ur','B2B Ú©Ù…Ù¾Ù†ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ)',0),(326204,9062,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð‘2Ð‘',0),(326205,9062,'vi','In Logo CÃ´ng Ty B2B',0),(326206,9062,'af','B2B Onderneming Druk Embleem',0),(326207,9062,'ro','B2B companie imprimare logo-ul',0),(326208,9062,'et','B2B ettevÃµtte prinditav logo',0),(326209,9062,'si','Tiskanje logotip B2B podjetja',0),(326210,9062,'ba','B2B Perusahaan cetak Logo',0),(326211,9062,'nl','B2B bedrijfslogo afdrukken',0),(326212,9062,'fi','B2B-yritykset Logo ja',0),(326213,9062,'no','B2B firmalogoen ut',0),(326214,9062,'da','B2B virksomhed Print Logo',0),(326215,9062,'ko','B2B íšŒì‚¬ ì¸ì‡„ ë¡œê³ ',0),(326216,9062,'he','×¡×ž×œ ×”×”×“×¤×¡×” ×”×—×‘×¨×” B2B',0),(326217,9062,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Î»Î¿Î³ÏŒÏ„Ï…Ï€Î¿ Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ B2B',0),(326218,9062,'zh','å•†ä¸šå¯¹å•†ä¸šå…¬å¸æ‰“å°å¾½æ ‡\r\n',0),(326219,9062,'sv','Skriv ut B2B fÃ¶retagslogotyp',0),(326220,9062,'it','Logo di stampa azienda B2B',0),(326221,9062,'tl','',0),(326222,9062,'th','&#3650;&#3621;&#3650;&#3585;&#3657;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607; B2B',0),(326223,9062,'hi','B2B à¤•à¤‚à¤ªà¤¨à¥€ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤²à¥‹à¤—à¥‹',0),(326224,9062,'ms','B2B syarikat cetakan Logo',0),(326225,9062,'ar','Ø´Ø¹Ø§Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø´Ø±ÙƒØ© B2B',0),(326226,9062,'fr','B2B entreprise impression Logo',0),(326227,9062,'jp','B2B ä¼æ¥­ã®å°åˆ·ã®ãƒ­ã‚´',0),(326228,9062,'pt','ImpressÃ£o logotipo empresa B2B',0),(326229,9062,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ B2B',0),(326230,9062,'es','N2N Empresa Logo de ImpresiÃ³n',0),(326231,9062,'de','B2B Firmenlogo drucken',0),(326232,9062,'en','B2B Company Print Logo',0),(326233,9063,'is','',0),(326234,9063,'dr','B2B Ú¯Ø±Ø§ÙÙŠÙƒ ÙˆØ±ÙˆØ¯ÙŠ Ø´Ø±ÙƒØª   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(326235,9063,'pr','B2B Ú¯Ø±Ø§ÙÙŠÙƒ ÙˆØ±ÙˆØ¯ÙŠ Ø´Ø±ÙƒØª   ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(326236,9063,'tr','B2B oturum aÃ§ma grafiÄŸi',0),(326237,9063,'pl','Grafika zgÅ‚oÅ› siÄ™ do systemu B2B',0),(326238,9063,'bg','B2B Ð²Ñ…Ð¾Ð´ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(326239,9063,'ur','B2B Ù„Ø§Ú¯ Ø§Ù† Ú¯Ø±Ø§ÙÛŒ',0),(326240,9063,'sr','Ð‘2Ð‘ Ð›Ð¾Ð³Ð¸Ð½ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(326241,9063,'vi','Äá»“ Há»a ÄÄƒng Nháº­p B2B',0),(326242,9063,'af','B2B Aantekening Grafika',0),(326243,9063,'ro','B2B Login grafic',0),(326244,9063,'et','B2B login graafika',0),(326245,9063,'si','B2B prijava grafiÄnih',0),(326246,9063,'ba','B2B Login grafis',0),(326247,9063,'nl','B2B Login afbeelding',0),(326248,9063,'fi','B2B Kirjaudu kuva',0),(326249,9063,'no','B2B logikk grafikk',0),(326250,9063,'da','B2B Login grafik',0),(326251,9063,'ko','B2B ë¡œê·¸ì¸ ê·¸ëž˜í”½',0),(326252,9063,'he','×’×¨×¤×™×§×” ×›× ×™×¡×” B2B',0),(326253,9063,'el','B2B Î³ÏÎ±Ï†Î¹ÎºÏŒ Login',0),(326254,9063,'zh','å•†ä¸šå¯¹å•†ä¸šç™»å½•å›¾è¡¨\r\n',0),(326255,9063,'sv','B2B Login bild',0),(326256,9063,'it','Grafica di login B2B',0),(326257,9063,'tl','',0),(326258,9063,'th','B2B Login Graphic',0),(326259,9063,'hi','B2B à¤²à¥‰à¤—à¤¿à¤¨ à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤•',0),(326260,9063,'ms','Grafik Login B2B',0),(326261,9063,'ar','Ø±Ø³Ù… Ø§Ù„Ø¯Ø®ÙˆÙ„ B2B',0),(326262,9063,'fr','B2B Login graphique',0),(326263,9063,'jp','B2B ãƒ­ã‚°ã‚¤ãƒ³ ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯',0),(326264,9063,'pt','B2B Login grÃ¡fico',0),(326265,9063,'ru','B2B Ð»Ð¾Ð³Ð¸Ð½ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹',0),(326266,9063,'es','N2N GrÃ¡fica de Login',0),(326267,9063,'de','B2B-Login-Grafik',0),(326268,9063,'en','B2B Login Graphic',0),(326269,9064,'is','',0),(326270,9064,'dr','B2B Ù†ØªÙŠØ¬Ù‡ Ú†Ø§Ù¾ÙŠ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(326271,9064,'pr','B2B Ù†ØªÙŠØ¬Ù‡ Ú†Ø§Ù¾ÙŠ ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(326272,9064,'tr','B2B Ã§Ä±ktÄ±lar',0),(326273,9064,'pl','Wydruki B2B',0),(326274,9064,'bg','B2B Ñ€Ð°Ð·Ð¿ÐµÑ‡Ð°Ñ‚ÐºÐ¸',0),(326275,9064,'ur','B2B Ù¾Ø±Ø§Ù†Ù¹Ø¹Ø«Ø³',0),(326276,9064,'sr','Ð‘2Ð‘ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ°',0),(326277,9064,'vi','Báº£n In B2B',0),(326278,9064,'af','B2B Uitdrukke',0),(326279,9064,'ro','B2B-materiale tipÄƒrite',0),(326280,9064,'et','B2B vÃ¤ljaprindid',0),(326281,9064,'si','B2B izpisi',0),(326282,9064,'ba','B2B cetakan',0),(326283,9064,'nl','B2B afdrukken',0),(326284,9064,'fi','B2B tulosteet',0),(326285,9064,'no','B2B utskrifter',0),(326286,9064,'da','B2B udskrifter',0),(326287,9064,'ko','B2B ì¶œë ¥ë¬¼',0),(326288,9064,'he','×ª×“×¤×™×¡×™× B2B',0),(326289,9064,'el','B2B ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚',0),(326290,9064,'zh','å•†ä¸šå¯¹å•†ä¸šçš„æ‰“å°è¾“å‡º\r\n',0),(326291,9064,'sv','B2B utskrifter',0),(326292,9064,'it','Stampe di B2B',0),(326293,9064,'tl','',0),(326294,9064,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3629;&#3629;&#3585; B2B',0),(326295,9064,'hi','B2B à¤ªà¥à¤°à¤¿à¤‚à¤Ÿà¤†à¤‰à¤Ÿ',0),(326296,9064,'ms','Cetakan B2B',0),(326297,9064,'ar','Ù…Ø·Ø¨ÙˆØ¹Ø§Øª B2B',0),(326298,9064,'fr','Impressions de B2B',0),(326299,9064,'jp','B2B ã®ãƒ—ãƒªãƒ³ãƒˆ ã‚¢ã‚¦ãƒˆ',0),(326300,9064,'pt','ImpressÃµes de B2B',0),(326301,9064,'ru','B2B Ñ€Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚ÐºÐ¸',0),(326302,9064,'es','N2N Impresiones',0),(326303,9064,'de','B2B-Ausdrucke',0),(326304,9064,'en','B2B Printouts',0),(326305,9065,'is','',0),(326306,9065,'dr','Ø²Ù…ÙŠÙ†Ù‡   ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù  Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡',0),(326307,9065,'pr','Ø²Ù…ÙŠÙ†Ù‡   ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù  Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡',0),(326308,9065,'tr','Arka planda PDF dosyasÄ±nÄ± e-postayla gÃ¶nderilen faturalar iÃ§in',0),(326309,9065,'pl','Plik PDF tÅ‚o dla faktur pocztÄ… elektronicznÄ…',0),(326310,9065,'bg','Ð¤Ð¾Ð½ PDF Ñ„Ð°Ð¹Ð» Ð·Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾Ñ‚Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(326311,9065,'ur','Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ø³ Ù…Ù†Ø¸Ø± Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ø¦Ù„',0),(326312,9065,'sr','ÐŸÐ¾Ð·Ð°Ð´Ð¸Ð½Ð° ÐŸÐ”Ð¤ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ð¿Ð¾ÑˆÑ‚Ð¾Ð¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(326313,9065,'vi','HÃ¬nh ná»n file PDF Ä‘á»ƒ gá»­i Email hÃ³a Ä‘Æ¡n',0),(326314,9065,'af','Agtergrond PDF LÃªer Vir geE-posde Fakture',0),(326315,9065,'ro','Fundal fiÅŸier PDF pentru facturilor prin E-mail',0),(326316,9065,'et','Tausta PDF faili saadetud arved',0),(326317,9065,'si','Ozadje PDF datoteke za poslano raÄunov',0),(326318,9065,'ba','File PDF latar belakang untuk faktur diemail',0),(326319,9065,'nl','Achtergrond PDF-bestand voor maild facturen',0),(326320,9065,'fi','Taustalla PDF-tiedoston sÃ¤hkÃ¶postitse laskujen',0),(326321,9065,'no','Bakgrunn PDF-fil For sendt fakturaer',0),(326322,9065,'da','Baggrund PDF fil sendt fakturaer',0),(326323,9065,'ko','ì´ë©”ì¼ë¡œ ì¸ë³´ì´ìŠ¤ì— ëŒ€ í•œ ë°°ê²½ PDF íŒŒì¼',0),(326324,9065,'he','×¨×§×¢ ×§×•×‘×¥ PDF ×¢×‘×•×¨ ×—×©×‘×•× ×™×•×ª ×‘×“×•××¨',0),(326325,9065,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î±ÏÏ‡ÎµÎ¯Î¿ PDF Î³Î¹Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎµÏƒÏ„Î¬Î»Î·ÏƒÎ±Î½ Î¼Îµ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(326326,9065,'zh','ä¸ºé€šè¿‡é‚®ä»¶å‘é€çš„å‘ç¥¨å®šä»¥PDFæ–‡ä»¶ä¸ºèƒŒæ™¯',0),(326327,9065,'sv','Bakgrunden PDF-fil fÃ¶r mailade fakturor',0),(326328,9065,'it','File PDF di sfondo per fatture inviate via email',0),(326329,9065,'tl','',0),(326330,9065,'th','&#3614;&#3639;&#3657;&#3609;&#3627;&#3621;&#3633;&#3591;&#3652;&#3615;&#3621;&#3660; PDF &#3586;&#3629;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(326331,9065,'hi','à¤ˆà¤®à¥‡à¤² à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥ƒà¤·à¥à¤ à¤­à¥‚à¤®à¤¿ PDF à¤«à¤¼à¤¾à¤‡à¤²',0),(326332,9065,'ms','Latar belakang fail PDF untuk e-melkan invois',0),(326333,9065,'ar','Ø®Ù„ÙÙŠØ© Ø§Ù„Ù…Ù„Ù PDF Ù„Ù„ÙÙˆØ§ØªÙŠØ± Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(326334,9065,'fr','Fichier PDF de fond pour les factures par courriel',0),(326335,9065,'jp','ãƒ¡ãƒ¼ãƒ«ã§ã®è«‹æ±‚æ›¸ã® PDF ãƒ•ã‚¡ã‚¤ãƒ«ã‚’èƒŒæ™¯',0),(326336,9065,'pt','Arquivo PDF de fundo para as facturas por correio electrÃ³nico',0),(326337,9065,'ru','Ð¡Ð¿Ñ€Ð°Ð²Ð¾Ñ‡Ð½Ñ‹Ð¹ Ñ„Ð°Ð¹Ð» PDF Ð´Ð»Ñ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(326338,9065,'es','File PDF de Fondo para Facturas que se Mandan por Email',0),(326339,9065,'de','Hintergrund-PDF-Datei per E-Mail Rechnungen',0),(326340,9065,'en','Background PDF File For Emailed Invoices',0),(326341,9066,'is','',0),(326342,9066,'dr','ÙƒØ§Ø± ØµÙ†Ø¹ØªÙŠ  ÙØ¹Ù„ÙŠ  Ø¯Ø± ÙØ§ÙŠÙ„ Ùˆ Ø¢Ù¾Ù„ÙˆØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ ',0),(326343,9066,'pr','ÙƒØ§Ø± ØµÙ†Ø¹ØªÙŠ  ÙØ¹Ù„ÙŠ  Ø¯Ø± ÙØ§ÙŠÙ„ Ùˆ Ø¢Ù¾Ù„ÙˆØ¯ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ ',0),(326344,9066,'tr','Dosya & yÃ¼klenen POs Ã¼zerinde gÃ¼ncel sanat',0),(326345,9066,'pl','BieÅ¼Ä…cej kompozycji na plik & przesÅ‚ane POs',0),(326346,9066,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¿Ñ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð¸Ñ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° & ÐºÐ°Ñ‡ÐµÐ½Ð¸Ñ‚Ðµ POs',0),(326347,9066,'ur','Ø­Ø§Ù„ÛŒÛ Ø¢Ø±Ù¹ ÙˆØ±Ú© Ù¾Ø± Ù…Ø³Ù„ & Ø§Ù¾ Ù„ÙˆÚˆ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù†',0),(326348,9066,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð¸Ð»ÑƒÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ðµ Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ & Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ðµ ÐŸÐžÑ',0),(326349,9066,'vi','Thiáº¿t káº¿ hiá»‡n thá»i trong há»“ sÆ¡ & táº£i Ä‘Æ¡n mua hÃ ng',0),(326350,9066,'af','Huidige Kunswerk op LÃªer & Opgelaaide ABs',0),(326351,9066,'ro','Opera de arta curent pe fiÅŸier & Ã®ncÄƒrcat POs',0),(326352,9066,'et','Praegune Artwork faili & Ã¼leslaaditud POs',0),(326353,9066,'si','Trenutni umetnine na datoteko & Uploaded POs',0),(326354,9066,'ba','Karya seni saat ini pada File & upload POs',0),(326355,9066,'nl','Huidige illustratie op bestand & geÃ¼ploade POs',0),(326356,9066,'fi','Nykyinen kuvamateriaali tiedoston & ladattu POs',0),(326357,9066,'no','Gjeldende kunstverk pÃ¥ filen & opplastede POs',0),(326358,9066,'da','NuvÃ¦rende kunstvÃ¦rker pÃ¥ fil & uploadede POs',0),(326359,9066,'ko','íŒŒì¼ & ì—…ë¡œë“œ ëœ POsì— í˜„ìž¬ ì•„íŠ¸ ì›Œí¬',0),(326360,9066,'he','×™×¦×™×¨×•×ª ××ž× ×•×ª ×”× ×•×›×—×™ ×¢×œ ×§×•×‘×¥ & ×©×”×•×¢×œ×” POs',0),(326361,9066,'el','Î¤ÏÎ­Ï‡Î¿Î½ Î³ÏÎ±Ï†Î¹ÎºÏŒ ÏƒÏ„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ & Î­Ï‡ÎµÏ„Îµ Î¼ÎµÏ„Î±Ï†Î¿ÏÏ„ÏŽÏƒÎµÎ¹ POs',0),(326362,9066,'zh','å½“å‰æ–‡ä»¶ä¸Šçš„è‰ºæœ¯å“å’Œä¸Šä¼ é‡‡è´­è®¢å•\r\n',0),(326363,9066,'sv','Nuvarande konstverk pÃ¥ filen & uppladdade POs',0),(326364,9066,'it','Opera d\'arte corrente su File & caricato POs',0),(326365,9066,'tl','',0),(326366,9066,'th','&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3591;&#3634;&#3609;&#3624;&#3636;&#3621;&#3611;&#3632;&#3651;&#3609;&#3652;&#3615;&#3621;&#3660;&#3649;&#3621;&#3632;&#3629;&#3633;&#3611;&#3650;&#3627;&#3621;&#3604; POs',0),(326367,9066,'hi','à¤«à¤¼à¤¾à¤‡à¤² & à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¥€ à¤—à¤ˆ POs à¤ªà¤° à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤²à¤¾à¤•à¥ƒà¤¤à¤¿',0),(326368,9066,'ms','Karya seni semasa pada fail & upload POs',0),(326369,9066,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ÙÙ†ÙŠ Ø§Ù„Ø­Ø§Ù„ÙŠ Ø¹Ù„Ù‰ Ø§Ù„Ù…Ù„Ù Ø¢Ù†Ø¯ Ø§Ù„Ø°ÙŠ ØªÙ… ØªØ­Ù…ÙŠÙ„Ù‡ ÙÙŠ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹',0),(326370,9066,'fr','Art actuel sur le fichier & tÃ©lÃ©chargÃ©s POs',0),(326371,9066,'jp','ãƒ•ã‚¡ã‚¤ãƒ« & ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã—ãŸ POs ã®ç¾åœ¨ã®ã‚¢ãƒ¼ãƒˆãƒ¯ãƒ¼ã‚¯',0),(326372,9066,'pt','Arte-final atual no arquivo & POs carregados',0),(326373,9066,'ru','Ð¢ÐµÐºÑƒÑ‰ÐµÐ¹ Ð¸Ð»Ð»ÑŽÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸ Ð½Ð° Ñ„Ð°Ð¹Ð» & Ð·Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ðµ POs',0),(326374,9066,'es','Dibujos Actuales Archivados & OCs Subidos',0),(326375,9066,'de','Aktuelle Gestaltungsarbeit auf Datei & hochgeladen POs',0),(326376,9066,'en','Current Artwork on File & Uploaded POs',0),(326377,9067,'is','',0),(326378,9067,'dr','Ù„ÙˆÚ¯Ùˆ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ Ù¾Ø§ÙŠÙŠÙ† ØµÙØ­Ù‡ ',0),(326379,9067,'pr','Ù„ÙˆÚ¯Ùˆ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ Ù¾Ø§ÙŠÙŠÙ† ØµÙØ­Ù‡ ',0),(326380,9067,'tr','Altbilgi iÃ§in Ã¶zel Logo',0),(326381,9067,'pl','WÅ‚asne Logo na stopce',0),(326382,9067,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð»Ð¾Ð³Ð¾ Ð·Ð° Ð´Ð¾Ð»ÐµÐ½ ÐºÐ¾Ð»Ð¾Ð½Ñ‚Ð¸Ñ‚ÑƒÐ»',0),(326383,9067,'ur','Ø°ÛŒÙ„ ØªØ­Ø±ÛŒØ± Ú©Û’ Ù„ÛŒÛ’ Ù…Ø®ØµÙˆØµ Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ)',0),(326384,9067,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¸ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿ Ð·Ð° Ð¿Ð¾Ð´Ð½Ð¾Ð¶Ñ˜Ðµ',0),(326385,9067,'vi','Logo tá»± táº¡o cho chÃ¢n trang',0),(326386,9067,'af','Aangepasde Embleem vir Voetenend',0),(326387,9067,'ro','Logo-ul personalizat pentru subsol',0),(326388,9067,'et','Logo jaluse jaoks',0),(326389,9067,'si','Custom Logo za nogo',0),(326390,9067,'ba','Custom Logo untuk Footer',0),(326391,9067,'nl','Aangepast Logo voor voettekst',0),(326392,9067,'fi','Oma Logo alatunniste',0),(326393,9067,'no','Tilpasset Logo for bunntekst',0),(326394,9067,'da','Brugerdefineret Logo til sidefoden',0),(326395,9067,'ko','ë°”ë‹¥ê¸€ì— ëŒ€ í•œ ì‚¬ìš©ìž ì •ì˜ ë¡œê³ ',0),(326396,9067,'he','×¡×ž×œ ×ž×•×ª×× ××™×©×™×ª ×¢×‘×•×¨ ×›×•×ª×¨×ª ×ª×—×ª×•× ×”',0),(326397,9067,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î¿ Î»Î¿Î³ÏŒÏ„Ï…Ï€Î¿ Î³Î¹Î± Ï„Î¿ Ï…Ï€Î¿ÏƒÎ­Î»Î¹Î´Î¿',0),(326398,9067,'zh','è‡ªå®šä¹‰é¡µè„šå¾½æ ‡\r\n',0),(326399,9067,'sv','Anpassad logotyp fÃ¶r sidfot',0),(326400,9067,'it','Logo personalizzato per il piÃ¨ di pagina',0),(326401,9067,'tl','',0),(326402,9067,'th','&#3611;&#3619;&#3633;&#3610;&#3649;&#3605;&#3656;&#3591;&#3650;&#3621;&#3650;&#3585;&#3657;&#3586;&#3629;&#3591;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;&#3648;&#3614;&#3592;',0),(326403,9067,'hi','à¤ªà¤¾à¤¦ à¤²à¥‡à¤– à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¸à¥à¤Ÿà¤® à¤²à¥‹à¤—à¥‹',0),(326404,9067,'ms','Rekabentuk Logo untuk Footer',0),(326405,9067,'ar','Ø§Ù„Ø´Ø¹Ø§Ø± Ø§Ù„Ù…Ø®ØµØµ Ù„Ù€(Ø°ÙŠÙ„) Ø§Ù„ØµÙØ­Ø§Øª',0),(326406,9067,'fr','Logo personnalisÃ© pour le pied de page',0),(326407,9067,'jp','ãƒ•ãƒƒã‚¿ãƒ¼ã«ç‹¬è‡ªã®ãƒ­ã‚´',0),(326408,9067,'pt','Logotipo personalizado para rodapÃ©',0),(326409,9067,'ru','Ð›Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿ Ð´Ð»Ñ Ð½Ð¸Ð¶Ð½ÐµÐ³Ð¾ ÐºÐ¾Ð»Ð¾Ð½Ñ‚Ð¸Ñ‚ÑƒÐ»Ð°',0),(326410,9067,'es','Logo Personalizado para Pie de PÃ¡gina',0),(326411,9067,'de','Kundenlogo Footer',0),(326412,9067,'en','Custom Logo for Footer',0),(326413,9068,'is','',0),(326414,9068,'dr','Ù„ÙˆÚ¯Ùˆ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ ØµÙØ­Ù‡ ÙˆØ±ÙˆØ¯ ',0),(326415,9068,'pr','Ù„ÙˆÚ¯Ùˆ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ Ø¨Ø±Ø§ÙŠ ØµÙØ­Ù‡ ÙˆØ±ÙˆØ¯ ',0),(326416,9068,'tr','GiriÅŸ sayfasÄ± iÃ§in Ã¶zel Logo',0),(326417,9068,'pl','WÅ‚asne Logo na stronÄ™ logowania',0),(326418,9068,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð»Ð¾Ð³Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð° Ð²Ñ…Ð¾Ð´',0),(326419,9068,'ur','Ù„Ø§Ú¯ Ø§Ù† ØµÙØ­Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø®ØµÙˆØµ Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ)',0),(326420,9068,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¸ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿ Ð·Ð° Ð»Ð¾Ð³Ð¾Ð²Ð°ÑšÐµ',0),(326421,9068,'vi','Chá»‰nh sá»­a logo cho trang Ä‘Äƒng nháº­p',0),(326422,9068,'af','Verstekte Embleem vir Aanteken Bladsy',0),(326423,9068,'ro','Logo-ul personalizat pentru pagina de Login',0),(326424,9068,'et','Logo Login lehe jaoks',0),(326425,9068,'si','Custom Logo za prijavo',0),(326426,9068,'ba','Custom Logo untuk halaman Login',0),(326427,9068,'nl','Aangepaste Logo voor loginpagina',0),(326428,9068,'fi','Oma Logo kirjautumissivulle',0),(326429,9068,'no','Tilpasset Logo for pÃ¥loggingssiden',0),(326430,9068,'da','Brugerdefineret Logo til Login-siden',0),(326431,9068,'ko','ë¡œê·¸ì¸ íŽ˜ì´ì§€ì— ëŒ€ í•œ ì‚¬ìš©ìž ì •ì˜ ë¡œê³ ',0),(326432,9068,'he','×¡×ž×œ ×ž×•×ª×× ××™×©×™×ª ×¢×‘×•×¨ ×¢×ž×•×“ ×›× ×™×¡×”',0),(326433,9068,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î¿ Î»Î¿Î³ÏŒÏ„Ï…Ï€Î¿ Î³Î¹Î± ÏƒÎµÎ»Î¯Î´Î± ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚',0),(326434,9068,'zh','è‡ªå®šä¹‰ç™»å½•é¡µé¢å¾½æ ‡\r\n',0),(326435,9068,'sv','Anpassad logotyp fÃ¶r inloggningssidan',0),(326436,9068,'it','Logo personalizzato per la pagina di Login',0),(326437,9068,'tl','',0),(326438,9068,'th','&#3611;&#3619;&#3633;&#3610;&#3649;&#3605;&#3656;&#3591;&#3650;&#3621;&#3650;&#3585;&#3657;&#3586;&#3629;&#3591;&#3621;&#3655;&#3629;&#3585;&#3629;&#3636;&#3609;&#3648;&#3614;&#3592;',0),(326439,9068,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¸à¥à¤Ÿà¤® à¤²à¥‹à¤—à¥‹',0),(326440,9068,'ms','Rekabentuk Logo untuk laman Login',0),(326441,9068,'ar','Ø§Ù„Ø´Ø¹Ø§Ø± Ø§Ù„Ù…Ø®ØµØµ Ù„ØµÙØ­Ø© Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(326442,9068,'fr','Logo personnalisÃ© pour la Page de connexion',0),(326443,9068,'jp','ãƒ­ã‚°ã‚¤ãƒ³ ãƒšãƒ¼ã‚¸ã«ç‹¬è‡ªã®ãƒ­ã‚´',0),(326444,9068,'pt','Logotipo personalizado para a pÃ¡gina de Login',0),(326445,9068,'ru','Ð›Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿ Ð´Ð»Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ð²Ñ…Ð¾Ð´Ð° Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ',0),(326446,9068,'es','Logo Personalizado para Log-in PÃ¡gina',0),(326447,9068,'de','Individuelles Logo fÃ¼r Login-Seite',0),(326448,9068,'en','Custom Logo for Login Page',0),(326449,9069,'is','',0),(326450,9069,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(326451,9069,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(326452,9069,'tr','Personel dosyalarÄ±',0),(326453,9069,'pl','Pracownik plikÃ³w',0),(326454,9069,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(326455,9069,'ur','Ù…Ù„Ø§Ø²Ù… Ù…Ø³Ù„ÛŒÚº',0),(326456,9069,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(326457,9069,'vi','Há»“ sÆ¡ NhÃ¢n viÃªn ',0),(326458,9069,'af','Werknemer LÃªers',0),(326459,9069,'ro','Angajat fiÅŸiere',0),(326460,9069,'et','TÃ¶Ã¶tajate toimikute',0),(326461,9069,'si','Zaposlenega datotek',0),(326462,9069,'ba','Karyawan file',0),(326463,9069,'nl','Werknemer bestanden',0),(326464,9069,'fi','TyÃ¶ntekijÃ¤n tiedostot',0),(326465,9069,'no','Personalregisteret',0),(326466,9069,'da','Medarbejder filer',0),(326467,9069,'ko','ì§ì› íŒŒì¼',0),(326468,9069,'he','×§×‘×¦×™ ×¢×•×‘×“',0),(326469,9069,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î±ÏÏ‡ÎµÎ¯Î±',0),(326470,9069,'zh','å‘˜å·¥æ–‡ä»¶',0),(326471,9069,'sv','Medarbetare-filer',0),(326472,9069,'it','File dei dipendenti',0),(326473,9069,'tl','',0),(326474,9069,'th','&#3649;&#3615;&#3657;&#3617;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;',0),(326475,9069,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(326476,9069,'ms','Fail-fail pekerja',0),(326477,9069,'ar','Ù…Ù„ÙØ§Øª Ø§Ù„Ù…ÙˆØ¸Ù',0),(326478,9069,'fr','Dossiers des employÃ©s',0),(326479,9069,'jp','å¾“æ¥­å“¡ãƒ•ã‚¡ã‚¤ãƒ«',0),(326480,9069,'pt','Arquivos de empregado',0),(326481,9069,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(326482,9069,'es','Archivos de Empleados',0),(326483,9069,'de','Mitarbeiter-Dateien',0),(326484,9069,'en','Employee Files',0),(326485,9070,'is','',0),(326486,9070,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(326487,9070,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(326488,9070,'tr','MÃ¼ÅŸteri iÃ§in dosyalar',0),(326489,9070,'pl','Pliki dla klientÃ³w',0),(326490,9070,'bg','Ð¤Ð°Ð¹Ð»Ð¾Ð²Ðµ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(326491,9070,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù„ÛŒÛ’ Ù…Ø³Ù„ÛŒÚº',0),(326492,9070,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(326493,9070,'vi','Há»“ sÆ¡ cho khÃ¡ch hÃ ng',0),(326494,9070,'af','LÃªers vir KliÃ«nt / Klant',0),(326495,9070,'ro','FiÅŸiere pentru client',0),(326496,9070,'et','Kliendi dokumendid',0),(326497,9070,'si','Datoteke za kupca',0),(326498,9070,'ba','File untuk pelanggan',0),(326499,9070,'nl','Bestanden voor klant',0),(326500,9070,'fi','Tiedostot asiakkaan',0),(326501,9070,'no','Filer for kunde',0),(326502,9070,'da','Filer til kunden',0),(326503,9070,'ko','ê³ ê°ì— ëŒ€ í•œ íŒŒì¼',0),(326504,9070,'he','×§×‘×¦×™× ×¢×‘×•×¨ ×œ×§×•×—',0),(326505,9070,'el','Î‘ÏÏ‡ÎµÎ¯Î± Î³Î¹Î± Ï„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(326506,9070,'zh','å®¢æˆ·æ¡£æ¡ˆ\r\n',0),(326507,9070,'sv','Filer fÃ¶r kund',0),(326508,9070,'it','File per il cliente',0),(326509,9070,'tl','',0),(326510,9070,'th','&#3652;&#3615;&#3621;&#3660;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(326511,9070,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(326512,9070,'ms','Fail pelanggan',0),(326513,9070,'ar','Ù…Ù„ÙØ§Øª Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(326514,9070,'fr','Fichiers pour le client',0),(326515,9070,'jp','é¡§å®¢ã®ãŸã‚ã®ãƒ•ã‚¡ã‚¤ãƒ«',0),(326516,9070,'pt','Arquivos para o cliente',0),(326517,9070,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ Ð´Ð»Ñ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(326518,9070,'es','Files para Clientes',0),(326519,9070,'de','Dateien fÃ¼r Kunden',0),(326520,9070,'en','Files for Customer',0),(326521,9071,'is','',0),(326522,9071,'dr','(Ú¯Ø±Ø§Ù ) Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(326523,9071,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ (Ù†Ù…ÙˆØ¯Ø§Ø± ) Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(326524,9071,'tr','MÃ¼ÅŸteri grubu iÃ§in grafik',0),(326525,9071,'pl','Grafika dla grupy odbiorcÃ³w',0),(326526,9071,'bg','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ð·Ð° Ð³Ñ€ÑƒÐ¿Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(326527,9071,'ur','Ú©Ø³Ù¹Ù…Ø± Ú¯Ø±ÙˆÙ¾ Ú©Û’ Ù„ÛŒÛ’ Ú¯Ø±Ø§ÙÛŒ',0),(326528,9071,'sr','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐµ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ðµ ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(326529,9071,'vi','Äá»“ há»a cho nhÃ³m khÃ¡ch hÃ ng',0),(326530,9071,'af','Grafika vir KliÃ«nt/Klant Groep',0),(326531,9071,'ro','Grafic pentru grup de client',0),(326532,9071,'et','Kliendigrupi graafika',0),(326533,9071,'si','Grafika za skupino kupcev',0),(326534,9071,'ba','Grafis untuk kelompok pelanggan',0),(326535,9071,'nl','Afbeelding voor klantgroep',0),(326536,9071,'fi','Graafinen asiakasryhmÃ¤lle',0),(326537,9071,'no','Grafikk for kundegruppen',0),(326538,9071,'da','Grafisk for debitorgruppe',0),(326539,9071,'ko','ê³ ê° ê·¸ë£¹ì— ëŒ€ í•œ ê·¸ëž˜í”½',0),(326540,9071,'he','×’×¨×¤×™×§×” ×¢×‘×•×¨ ×§×‘×•×¦×ª ×œ×œ×§×•×—',0),(326541,9071,'el','Î“ÏÎ±Ï†Î¹ÎºÏŒ Î³Î¹Î± Î¿Î¼Î¬Î´Î± Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(326542,9071,'zh','å®¢æˆ·ç¾¤çš„å›¾å½¢\r\n',0),(326543,9071,'sv','Grafik fÃ¶r kundgruppen',0),(326544,9071,'it','Grafica per gruppo di clienti',0),(326545,9071,'tl','',0),(326546,9071,'th','&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3586;&#3629;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(326547,9071,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤«à¤¿à¤•',0),(326548,9071,'ms','Grafik untuk Kumpulan pelanggan',0),(326549,9071,'ar','Ø§Ù„Ø±Ø³Ù… Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(326550,9071,'fr','Graphique pour groupe de clients',0),(326551,9071,'jp','é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—ã®ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯',0),(326552,9071,'pt','GrÃ¡fico para o grupo de clientes',0),(326553,9071,'ru','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ð´Ð»Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(326554,9071,'es','GrÃ¡fica para Grupo de Clientes',0),(326555,9071,'de','Grafik fÃ¼r Kundengruppe',0),(326556,9071,'en','Graphic for Customer Group',0),(326557,9072,'is','',0),(326558,9072,'dr','Ú¯Ø±Ø§ÙÙŠÙƒ  Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(326559,9072,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ  Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(326560,9072,'tr','Fatura iÃ§in grafik',0),(326561,9072,'pl','Grafika dla faktury',0),(326562,9072,'bg','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(326563,9072,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ Ú¯Ø±Ø§ÙÛŒ',0),(326564,9072,'sr','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(326565,9072,'vi','Äá»“ há»a cho hÃ³a Ä‘Æ¡n',0),(326566,9072,'af','Grafika vir Faktuur',0),(326567,9072,'ro','Grafic pentru facturÄƒ',0),(326568,9072,'et','Arve graafika',0),(326569,9072,'si','Grafika za raÄun',0),(326570,9072,'ba','Grafis untuk faktur',0),(326571,9072,'nl','Afbeelding voor factuur',0),(326572,9072,'fi','Graafinen laskun',0),(326573,9072,'no','Grafikk for faktura',0),(326574,9072,'da','Grafisk for faktura',0),(326575,9072,'ko','ì†¡ìž¥ì— ëŒ€ í•œ ê·¸ëž˜í”½',0),(326576,9072,'he','×’×¨×¤×™×§×” ×¢×‘×•×¨ ×—×©×‘×•× ×™×ª',0),(326577,9072,'el','Î“ÏÎ±Ï†Î¹ÎºÏŒ Î³Î¹Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(326578,9072,'zh','å‘ç¥¨å›¾å½¢\r\n',0),(326579,9072,'sv','Grafik fÃ¶r faktura',0),(326580,9072,'it','Grafica per fattura',0),(326581,9072,'tl','',0),(326582,9072,'th','&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(326583,9072,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤«à¤¿à¤•',0),(326584,9072,'ms','Grafik untuk invois',0),(326585,9072,'ar','Ø§Ù„Ø±Ø³Ù… Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(326586,9072,'fr','Graphique pour la facture',0),(326587,9072,'jp','è«‹æ±‚æ›¸ã®ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯',0),(326588,9072,'pt','GrÃ¡fico de fatura',0),(326589,9072,'ru','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð°',0),(326590,9072,'es','GrÃ¡fica para Factura',0),(326591,9072,'de','Grafik fÃ¼r Rechnung',0),(326592,9072,'en','Graphic for Invoice',0),(326593,9073,'is','',0),(326594,9073,'dr','Ú¯Ø±Ø§ÙÙŠÙƒ  Ø¨Ø±Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡',0),(326595,9073,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ  Ø¨Ø±Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡',0),(326596,9073,'tr','Grafik seÃ§eneÄŸi',0),(326597,9073,'pl','Grafika dla opcji',0),(326598,9073,'bg','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ð·Ð° Ð¾Ð¿Ñ†Ð¸Ñ',0),(326599,9073,'ur','Ú¯Ø±Ø§ÙÚ© Ø§Ø®ØªÛŒØ§Ø± Ú©Û’ Ù„Ø¦Û’',0),(326600,9073,'sr','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐµ Ð·Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ',0),(326601,9073,'vi','Äá»“ há»a cho lá»±a chá»n',0),(326602,9073,'af','Grafika vir Opsie',0),(326603,9073,'ro','Grafic pentru opÅ£iunea',0),(326604,9073,'et','Pildi valik',0),(326605,9073,'si','Grafika za moÅ¾nost',0),(326606,9073,'ba','Grafis untuk pilihan',0),(326607,9073,'nl','Afbeelding voor optie',0),(326608,9073,'fi','Graafinen vaihtoehto',0),(326609,9073,'no','Grafikk for alternativ',0),(326610,9073,'da','Grafisk for indstilling',0),(326611,9073,'ko','ì˜µì…˜ì— ëŒ€ í•œ ê·¸ëž˜í”½',0),(326612,9073,'he','×’×¨×¤×™×§×” ×œ××¤×©×¨×•×ª',0),(326613,9073,'el','Î“ÏÎ±Ï†Î¹ÎºÏŒ Î³Î¹Î± ÎµÏ€Î¹Î»Î¿Î³Î®',0),(326614,9073,'zh','é€‰é¡¹å›¾å½¢\r\n',0),(326615,9073,'sv','Grafik fÃ¶r alternativet',0),(326616,9073,'it','Grafica per opzione',0),(326617,9073,'tl','',0),(326618,9073,'th','&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3586;&#3629;&#3591;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(326619,9073,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤«à¤¿à¤•',0),(326620,9073,'ms','Grafik untuk pilihan',0),(326621,9073,'ar','ØµÙˆØ±Ø© Ø§Ù„Ø®ÙŠØ§Ø±',0),(326622,9073,'fr','Graphique pour l\'Option',0),(326623,9073,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã®ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯',0),(326624,9073,'pt','GrÃ¡fico para a opÃ§Ã£o',0),(326625,9073,'ru','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚',0),(326626,9073,'es','GrÃ¡fica para la OpciÃ³n',0),(326627,9073,'de','Grafik fÃ¼r die Option',0),(326628,9073,'en','Graphic for Option',0),(326629,9074,'is','',0),(326630,9074,'dr','Ú¯Ø±Ø§ÙÙŠÙƒ  Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡',0),(326631,9074,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ  Ø¨Ø±Ø§ÙŠ Ú¯Ø±ÙˆÙ‡ Ú¯Ø²ÙŠÙ†Ù‡',0),(326632,9074,'tr','SeÃ§enek grubu iÃ§in grafiÄŸi',0),(326633,9074,'pl','Grafika dla grupy opcji',0),(326634,9074,'bg','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ð·Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð¾Ñ‚ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(326635,9074,'ur','Ú¯Ø±Ø§ÙÚ© Ø§Ø®ØªÛŒØ§Ø± Ú¯Ø±ÙˆÙ¾ Ú©Û’ Ù„ÛŒÛ’',0),(326636,9074,'sr','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐµ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ñƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(326637,9074,'vi','Äá»“ há»a cho nhÃ³m lá»±a chá»n',0),(326638,9074,'af','Grafika vir Opsie Groep',0),(326639,9074,'ro','Grafic pentru grupul de opÈ›iuni',0),(326640,9074,'et','SuvandirÃ¼hma graafikana',0),(326641,9074,'si','Grafika za skupino moÅ¾nosti',0),(326642,9074,'ba','Grafis untuk kelompok pilihan',0),(326643,9074,'nl','Afbeelding voor het groepsvak',0),(326644,9074,'fi','Kuvan ohjausobjekti on lÃ¤pinÃ¤kyvÃ¤',0),(326645,9074,'no','Grafikken for alternativgruppe',0),(326646,9074,'da','Grafisk for gruppeboks.',0),(326647,9074,'ko','ì˜µì…˜ ê·¸ë£¹ì— ëŒ€ í•œ ê·¸ëž˜í”½',0),(326648,9074,'he','×’×¨×¤×™×§×” ×¢×‘×•×¨ ×§×‘×•×¦×ª ×”××¤×©×¨×•×™×•×ª',0),(326649,9074,'el','Î“ÏÎ±Ï†Î¹ÎºÏŒ Î³Î¹Î± Î¿Î¼Î¬Î´Î± ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(326650,9074,'zh','é€‰é¡¹ç»„çš„å›¾å½¢\r\n',0),(326651,9074,'sv','Grafik fÃ¶r gruppruta',0),(326652,9074,'it','Grafica per il gruppo di opzioni',0),(326653,9074,'tl','',0),(326654,9074,'th','&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3588;&#3586;&#3629;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(326655,9074,'hi','à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤®à¥‚à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤«à¤¿à¤•',0),(326656,9074,'ms','Grafik untuk opsyen Kumpulan',0),(326657,9074,'ar','ØµÙˆØ±Ø© Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª',0),(326658,9074,'fr','Graphique pour le groupe d\'options',0),(326659,9074,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ ã‚°ãƒ«ãƒ¼ãƒ—ã®ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯',0),(326660,9074,'pt','GrÃ¡fico para o grupo de opÃ§Ãµes',0),(326661,9074,'ru','Ð“Ñ€Ð°Ñ„Ð¸ÐºÐ° Ð´Ð»Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð¿ÐµÑ€ÐµÐºÐ»ÑŽÑ‡Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(326662,9074,'es','GrÃ¡fica para el Grupo de Opciones',0),(326663,9074,'de','Grafik zur Optionsgruppe',0),(326664,9074,'en','Graphic for Option Group',0),(326665,9075,'is','',0),(326666,9075,'dr','(Ø¯Ø± ÙÙŠÙ„Ø¯ ØªÚ©Øª Ù‡Ø§ÙŠ Ø´ØºÙ„  Ù¾Ø± Ø´ÙˆØ¯-ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÙŠØ¯ Ù…Ø´ØªØ±ÙŠ',0),(326667,9075,'pr','Ù…Ø¯Ø§Ø±Ùƒ Ø´ØºÙ„ Ø¯Ø§Ø®Ù„ÙŠ  (Ø¯Ø± ÙÙŠÙ„Ø¯ Ø¨Ù„ÙŠØ· Ù‡Ø§ÙŠ Ø´ØºÙ„  Ù¾Ø± Ø´ÙˆØ¯-Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…Ø´ØªØ±ÙŠ',0),(326668,9075,'tr','Ä°Ã§ iÅŸ belgeleri (dolu iÅŸ bilet, mÃ¼ÅŸteri PO)',0),(326669,9075,'pl','Dokumenty wewnÄ™trzne pracy (wypeÅ‚nione w pracy bilety, klient PO)',0),(326670,9075,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸Ñ‚Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸ (Ð¿Ð¾Ð¿ÑŠÐ»Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð±Ð¸Ð»ÐµÑ‚Ð¸, ÐºÐ»Ð¸ÐµÐ½Ñ‚ PO)',0),(326671,9075,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ú©Ø§Ù… Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª (Ø¨Ú¾Ø± Ù…ÛŒÚº Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù¹Ú©Ù¹ Ú©Ø³Ù¹Ù…Ø± Ù¾Ùˆ)',0),(326672,9075,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ¸ Ð¿Ð¾ÑÐ°Ð¾ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸ (Ð¿Ð¾Ð¿ÑƒÑšÐµÐ½Ðµ Ð¿Ð¾ÑÐ°Ð¾ ÐºÐ°Ñ€Ñ‚Ðµ, ÐºÑƒÐ¿Ñ†Ð° ÐŸÐž)',0),(326673,9075,'vi','TÃ i liá»‡u Job ná»™i bá»™ (Äiá»n vÃ o phiáº¿u Job, ÄÆ¡n mua hÃ ng cá»§a khÃ¡ch hÃ ng)',0),(326674,9075,'af','Interne Werkstuk Dokumente (Ingevulde Werkstuk Kaartjies, Klient AB)',0),(326675,9075,'ro','Job intern documente (completate Job bilete, client PO)',0),(326676,9075,'et','Sise tÃ¶Ã¶ dokumendid (tÃ¤idetud tÃ¶Ã¶ piletid, kliendi PO)',0),(326677,9075,'si','Notranje delo dokumente (izpolnjeno sluÅ¾bo vstopnic, kupca PO)',0),(326678,9075,'ba','Internal Job dokumen (terisi pekerjaan Tiket, pelanggan PO)',0),(326679,9075,'nl','Interne functies documenten (ingevuld baan Tickets, klant PO)',0),(326680,9075,'fi','TyÃ¶tehtÃ¤vÃ¤t asiakirjat (tÃ¤ytetty tyÃ¶liput, asiakkaan PO)',0),(326681,9075,'no','Interne jobber dokumenter (utfylt jobb billetter, kunden PO)',0),(326682,9075,'da','Interne Job dokumenter (udfyldt Job billetter, kunden PO)',0),(326683,9075,'ko','ë‚´ë¶€ ì—…ë¬´ ë¬¸ì„œ (ê³ ê° PO ì±„ì›Œì§„ ì¼ í‹°ì¼“)',0),(326684,9075,'he','×ž×¡×ž×›×™ ×¢×‘×•×“×” ×¤× ×™×ž×™×ª (×›×¨×˜×™×¡×™× ×ž×œ××™× ×‘×¢×‘×•×“×”, ×œ×§×•×—×•×ª ×¤×•)',0),(326685,9075,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÏŽÎ½ Î¸Î­ÏƒÎµÏ‰Î½ Î­Î³Î³ÏÎ±Ï†Î± (ÏƒÏ…Î¼Ï€Î»Î·ÏÏ‰Î¼Î­Î½Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î±, Î±Î½Î¬ Ï€ÎµÎ»Î¬Ï„Î·)',0),(326686,9075,'zh','å†…éƒ¨å·¥ä½œæ–‡ä»¶ï¼ˆå¡«å†™çš„å·¥ä½œç¥¨ï¼Œå®¢æˆ·è®¢å•ï¼‰\r\n',0),(326687,9075,'sv','Interna jobb dokument (ifylld jobb biljetter, kundens InkÃ¶psordernummer)',0),(326688,9075,'it','Documenti di lavoro interno (biglietti riempita in lavoro, cliente PO)',0),(326689,9075,'tl','',0),(326690,9075,'th','&#3648;&#3629;&#3585;&#3626;&#3634;&#3619;&#3591;&#3634;&#3609;&#3616;&#3634;&#3618;&#3651;&#3609; (Filled-in Job Tickets, Customer PO)',0),(326691,9075,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¨à¥Œà¤•à¤°à¥€ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚ (à¤¨à¥Œà¤•à¤°à¥€ à¤®à¥‡à¤‚ à¤­à¤°à¤¾ à¤Ÿà¤¿à¤•à¤Ÿ, à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¥‹)',0),(326692,9075,'ms','Dokumen-dokumen kerja Dalaman (diisi dalam kerja Tiket, Baca PO)',0),(326693,9075,'ar','Ø§Ù„ÙˆØ«Ø§Ø¦Ù‚ Ø§Ù„Ù…Ù‡Ù…Ø© Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ© (ØªØ°Ø§ÙƒØ± ÙÙŠ Ø´ØºÙ„ Ø§Ù„ÙˆØ¸ÙŠÙØ©ØŒ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ PO)',0),(326694,9075,'fr','Documents de travail internes (billets remplis Ã  Job, client PO)',0),(326695,9075,'jp','å†…éƒ¨ã‚¸ãƒ§ãƒ–æ–‡æ›¸ ï¼ˆã‚«ã‚¹ã‚¿ãƒžãƒ¼ PO ã§æº€ãŸã•ã‚ŒãŸã‚¸ãƒ§ãƒ– ãƒã‚±ãƒƒãƒˆï¼‰',0),(326696,9075,'pt','Documentos de trabalho interno (bilhetes preenchidos emprego, cliente PO)',0),(326697,9075,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹ (Ð·Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð±Ð¸Ð»ÐµÑ‚Ñ‹, Customer PO)',0),(326698,9075,'es','Documentos de Trabajo Internales (Boletos de Trabajo Llenados, OC de Cliente)',0),(326699,9075,'de','Interne Stelle Dokumente (ausgefÃ¼llt Jobtickets, Kunde PO)',0),(326700,9075,'en','Internal Job Documents (Filled-in Job Tickets, Customer PO)',0),(326701,9076,'is','',0),(326702,9076,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(326703,9076,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(326704,9076,'tr','Stok Ã¶ÄŸesi dosya',0),(326705,9076,'pl','Spis pozycji pliki',0),(326706,9076,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(326707,9076,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ù…Ø³Ù„ÛŒÚº',0),(326708,9076,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(326709,9076,'vi','Há»“ SÆ¡ Danh Má»¥c hÃ ng hÃ³a',0),(326710,9076,'af','Voorraaditem LÃªers',0),(326711,9076,'ro','Inventarul element fiÅŸiere',0),(326712,9076,'et','Lao kirje failid',0),(326713,9076,'si','Zaloge artikla datotek',0),(326714,9076,'ba','Persediaan Item file',0),(326715,9076,'nl','Item voorraadbestanden',0),(326716,9076,'fi','Varaston tuote-tiedostoja',0),(326717,9076,'no','Elementet innholdsfiler',0),(326718,9076,'da','Lager vare filer',0),(326719,9076,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© íŒŒì¼',0),(326720,9076,'he','×§×‘×¦×™× ×¤×¨×™×˜ ×ž×œ××™',0),(326721,9076,'el','Î‘ÏÏ‡ÎµÎ¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(326722,9076,'zh','åº“å­˜é¡¹ç›®æ–‡ä»¶\r\n',0),(326723,9076,'sv','Inventering post filer',0),(326724,9076,'it','File di elemento di inventario',0),(326725,9076,'tl','',0),(326726,9076,'th','&#3652;&#3615;&#3621;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(326727,9076,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(326728,9076,'ms','Fail Item inventori',0),(326729,9076,'ar','Ù…Ù„ÙØ§Øª ØµÙ†Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(326730,9076,'fr','Fichiers d\'Ã©lÃ©ment de l\'inventaire',0),(326731,9076,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªé …ç›®ãƒ•ã‚¡ã‚¤ãƒ«',0),(326732,9076,'pt','Arquivos de Item de inventÃ¡rio',0),(326733,9076,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(326734,9076,'es','Files de Item de Inventario',0),(326735,9076,'de','Inventar-Element-Dateien',0),(326736,9076,'en','Inventory Item Files',0),(326737,9077,'is','',0),(326738,9077,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(326739,9077,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(326740,9077,'tr','Envanter madde satÄ±cÄ± dosyalarÄ±',0),(326741,9077,'pl','Pliki dostawcy element spisu',0),(326742,9077,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(326743,9077,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ ÙˆÛŒÙ†ÚˆØ± Ù…Ø³Ù„ÛŒÚº',0),(326744,9077,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(326745,9077,'vi','Há»“ SÆ¡ NgÆ°á»i BÃ¡n HÃ ng',0),(326746,9077,'af','Inventaris Item Verskaffer LÃªers',0),(326747,9077,'ro','Inventar articol furnizor fiÅŸiere',0),(326748,9077,'et','Kauba hankija failide',0),(326749,9077,'si','Zaloge artikla dobavitelja datoteke',0),(326750,9077,'ba','Persediaan Item Vendor file',0),(326751,9077,'nl','Item leverancier voorraadbestanden',0),(326752,9077,'fi','Varaston nimikkeen toimittajan tiedostoja',0),(326753,9077,'no','Lageret varen leverandÃ¸r filer',0),(326754,9077,'da','Lager vare kreditor filer',0),(326755,9077,'ko','ì¸ë²¤í† ë¦¬ í•­ëª© ê³µê¸‰ ì—…ì²´ íŒŒì¼',0),(326756,9077,'he','×§×‘×¦×™ ×¡×¤×§ ×¤×¨×™×˜ ×ž×œ××™',0),(326757,9077,'el','Î‘ÏÏ‡ÎµÎ¯Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(326758,9077,'zh','ä¾›åº”å•†åº“å­˜é¡¹ç›®æ–‡ä»¶\r\n',0),(326759,9077,'sv','Inventering post leverantÃ¶r filer',0),(326760,9077,'it','File di inventario voce fornitore',0),(326761,9077,'tl','',0),(326762,9077,'th','&#3652;&#3615;&#3621;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(326763,9077,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(326764,9077,'ms','Fail penjual Item inventori',0),(326765,9077,'ar','Ù…Ù„ÙÙ‘Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ÙŠÙ† Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(326766,9077,'fr','Fichiers dâ€™inventaire point du vendeur',0),(326767,9077,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªé …ç›®ã®ãƒ™ãƒ³ãƒ€ãƒ¼ ãƒ•ã‚¡ã‚¤ãƒ«',0),(326768,9077,'pt','Arquivos de fornecedor do Item de inventÃ¡rio',0),(326769,9077,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(326770,9077,'es','Files de Proveedor de Item de Inventario',0),(326771,9077,'de','Inventar-Element-Vendor-Dateien',0),(326772,9077,'en','Inventory Item Vendor Files',0),(326773,9078,'is','',0),(326774,9078,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(326775,9078,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(326776,9078,'tr','Fatura dosyalarÄ±',0),(326777,9078,'pl','Pliki faktury',0),(326778,9078,'bg','Ð¤Ð°Ð¹Ð»Ð¾Ð²Ðµ Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(326779,9078,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ø³Ù„ÛŒÚº',0),(326780,9078,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÑÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð°',0),(326781,9078,'vi','Há»“ sÆ¡ HÃ³a Ä‘Æ¡n ',0),(326782,9078,'af','FaktuurlÃªers',0),(326783,9078,'ro','Fisiere factura',0),(326784,9078,'et','Arvete failid',0),(326785,9078,'si','RaÄun datotek',0),(326786,9078,'ba','Faktur file',0),(326787,9078,'nl','Factuur bestanden',0),(326788,9078,'fi','Laskun tiedostot',0),(326789,9078,'no','Faktura-filer',0),(326790,9078,'da','Fakturafiler',0),(326791,9078,'ko','ì†¡ìž¥ íŒŒì¼',0),(326792,9078,'he','×§×‘×¦×™ ×—×©×‘×•× ×™×ª',0),(326793,9078,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±ÏÏ‡ÎµÎ¯Î±',0),(326794,9078,'zh','å‘ç¥¨æ–‡ä»¶\r\n',0),(326795,9078,'sv','Faktura-filer',0),(326796,9078,'it','File fattura',0),(326797,9078,'tl','',0),(326798,9078,'th','&#3652;&#3615;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(326799,9078,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(326800,9078,'ms','Fail invois',0),(326801,9078,'ar','Ù…Ù„ÙØ§Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(326802,9078,'fr','Fichiers de facture',0),(326803,9078,'jp','è«‹æ±‚æ›¸ãƒ•ã‚¡ã‚¤ãƒ«',0),(326804,9078,'pt','Arquivos de fatura',0),(326805,9078,'ru','Ð¡Ñ‡ÐµÑ‚ Ñ„Ð°Ð¹Ð»Ð¾Ð²',0),(326806,9078,'es','Files de Factura',0),(326807,9078,'de','Rechnungsdateien',0),(326808,9078,'en','Invoice Files',0),(326809,9079,'is','',0),(326810,9079,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(326811,9079,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(326812,9079,'tr','SipariÅŸ dosyalarÄ±',0),(326813,9079,'pl','KolejnoÅ›Ä‡ plikÃ³w',0),(326814,9079,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(326815,9079,'ur','ØªØ±ØªÛŒØ¨ Ù…Ø³Ù„ÛŒÚº',0),(326816,9079,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(326817,9079,'vi','Há»“ sÆ¡ ÄÆ¡n HÃ ng',0),(326818,9079,'af','Bestelling LÃªers',0),(326819,9079,'ro','FiÅŸiere de comandÄƒ',0),(326820,9079,'et','Tellimuse failid',0),(326821,9079,'si','Vrstni red datotek',0),(326822,9079,'ba','Perintah file',0),(326823,9079,'nl','Volgorde bestanden',0),(326824,9079,'fi','Jotta tiedostot',0),(326825,9079,'no','For filer',0),(326826,9079,'da','Bestil filer',0),(326827,9079,'ko','ìˆœì„œ íŒŒì¼',0),(326828,9079,'he','×¡×“×¨ ×”×§×‘×¦×™×',0),(326829,9079,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±ÏÏ‡ÎµÎ¯Î±',0),(326830,9079,'zh','è®¢å•æ–‡ä»¶\r\n',0),(326831,9079,'sv','FÃ¶r filer',0),(326832,9079,'it','Ordine Files',0),(326833,9079,'tl','',0),(326834,9079,'th','&#3652;&#3615;&#3621;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(326835,9079,'hi','à¤•à¥à¤°à¤® à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(326836,9079,'ms','Susunan fail',0),(326837,9079,'ar','Ù…Ù„ÙØ§Øª Ø§Ù„Ø·Ù„Ø¨ÙŠØ©',0),(326838,9079,'fr','Fichiers d\'ordres',0),(326839,9079,'jp','ã‚ªãƒ¼ãƒ€ãƒ¼ ãƒ•ã‚¡ã‚¤ãƒ«',0),(326840,9079,'pt','Arquivos de ordem',0),(326841,9079,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ Ð—Ð°ÐºÐ°Ð·Ð°',0),(326842,9079,'es','Files de Pedido',0),(326843,9079,'de','Bestellung-Dateien',0),(326844,9079,'en','Order Files',0),(326845,9080,'is','',0),(326846,9080,'dr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(326847,9080,'pr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(326848,9080,'tr','SatÄ±nalma sipariÅŸi dosyalarÄ±',0),(326849,9080,'pl','Pliki zamÃ³wienia zakupu',0),(326850,9080,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ñ€ÐµÐ´ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(326851,9080,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ Ù…Ø³Ù„ÛŒÚº',0),(326852,9080,'sr','Ð˜Ð·Ð»Ð°Ð·Ð½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(326853,9080,'vi','Há»“ sÆ¡ ÄÆ¡n Mua HÃ ng',0),(326854,9080,'af','Aankoopbestelling LÃªers',0),(326855,9080,'ro','FiÅŸiere de comandÄƒ cumpÄƒrare',0),(326856,9080,'et','Ostu tellimuse failid',0),(326857,9080,'si','Nabavni nalog datotek',0),(326858,9080,'ba','Pembelian Order file',0),(326859,9080,'nl','Aankoop Order bestanden',0),(326860,9080,'fi','Osto jÃ¤rjestyksessÃ¤ tiedostot',0),(326861,9080,'no','KjÃ¸p for filer',0),(326862,9080,'da','KÃ¸b Bestil filer',0),(326863,9080,'ko','êµ¬ë§¤ ì£¼ë¬¸ íŒŒì¼',0),(326864,9080,'he','×”×¨×›×™×©×” ×¡×“×¨ ×”×§×‘×¦×™×',0),(326865,9080,'el','Î‘Î³Î¿ÏÎ¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±ÏÏ‡ÎµÎ¯Î±',0),(326866,9080,'zh','é‡‡è´­è®¢å•æ–‡ä»¶\r\n',0),(326867,9080,'sv','KÃ¶p fÃ¶r filer',0),(326868,9080,'it','File di ordine di acquisto',0),(326869,9080,'tl','',0),(326870,9080,'th','&#3652;&#3615;&#3621;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(326871,9080,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(326872,9080,'ms','Fail pesanan pembelian',0),(326873,9080,'ar','Ù…Ù„ÙØ§Øª Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(326874,9080,'fr','Achat ordre fichiers',0),(326875,9080,'jp','è³¼å…¥ã‚ªãƒ¼ãƒ€ãƒ¼ ãƒ•ã‚¡ã‚¤ãƒ«',0),(326876,9080,'pt','Arquivos de ordem de compra',0),(326877,9080,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð·Ð°ÐºÐ°Ð· Ñ„Ð°Ð¹Ð»Ð¾Ð²',0),(326878,9080,'es','Files de Ordenes de Compra',0),(326879,9080,'de','Kauf-Order-Dateien',0),(326880,9080,'en','Purchase Order Files',0),(326881,9081,'is','',0),(326882,9081,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(326883,9081,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(326884,9081,'tr','SatÄ±ÅŸ kiÅŸi dosyalarÄ±',0),(326885,9081,'pl','Osoby sprzedaÅ¼y plikÃ³w',0),(326886,9081,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð»Ð¸Ñ†Ðµ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(326887,9081,'ur','Ø³ÛŒÙ„Ø² Ø´Ø®Øµ Ù…Ø³Ù„ÛŒÚº',0),(326888,9081,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ† Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(326889,9081,'vi','Há»“ sÆ¡ NhÃ¢n viÃªn kinh doanh',0),(326890,9081,'af','VerkoopspersoonlÃªers',0),(326891,9081,'ro','FiÅŸiere de persoanÄƒ de vÃ¢nzÄƒri',0),(326892,9081,'et','MÃ¼Ã¼gimehe dokumedid',0),(326893,9081,'si','Pultom datotek',0),(326894,9081,'ba','Orang penjualan file',0),(326895,9081,'nl','Verkoop persoon bestanden',0),(326896,9081,'fi','MyyjÃ¤ tiedostot',0),(326897,9081,'no','Selger filer',0),(326898,9081,'da','Salg Person filer',0),(326899,9081,'ko','ì˜ì—… ì‚¬ì› íŒŒì¼',0),(326900,9081,'he','×§×‘×¦×™ ××™×© ×ž×›×™×¨×•×ª',0),(326901,9081,'el','Î ÏÏŒÏƒÏ‰Ï€Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î±ÏÏ‡ÎµÎ¯Î±',0),(326902,9081,'zh','é”€å”®äººå‘˜æ¡£æ¡ˆ\r\n',0),(326903,9081,'sv','SÃ¤ljare filer',0),(326904,9081,'it','Persona di vendite file',0),(326905,9081,'tl','',0),(326906,9081,'th','&#3652;&#3615;&#3621;&#3660;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(326907,9081,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(326908,9081,'ms','Fail-fail orang jualan',0),(326909,9081,'ar','Ù…Ù„ÙØ§Øª Ù…ÙˆØ¸Ù Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(326910,9081,'fr','Fichiers de personne de ventes',0),(326911,9081,'jp','å–¶æ¥­æ‹…å½“è€…ã®ãƒ•ã‚¡ã‚¤ãƒ«',0),(326912,9081,'pt','Arquivos de vendas pessoa',0),(326913,9081,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(326914,9081,'es','Files de Vendedor',0),(326915,9081,'de','Vertriebsmitarbeiter-Dateien',0),(326916,9081,'en','Sales Person Files',0),(326917,9082,'is','',0),(326918,9082,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(326919,9082,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(326920,9082,'tr','SatÄ±cÄ± fatura dosyalarÄ±',0),(326921,9082,'pl','Pliki dostawcy Bill',0),(326922,9082,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð±Ð¸Ð» Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(326923,9082,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ù…Ø³Ù„ÛŒÚº',0),(326924,9082,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ñ€Ð°Ñ‡ÑƒÐ½ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(326925,9082,'vi','Há»“ SÆ¡ HÃ³a ÄÆ¡n NgÆ°á»i bÃ¡n ',0),(326926,9082,'af','Handelaar Wetsontwerp lÃªers',0),(326927,9082,'ro','FiÅŸiere de factura furnizor',0),(326928,9082,'et','Tarnijate arvete failid formateeritud veergudena',0),(326929,9082,'si','Datoteke za raÄun dobavitelja',0),(326930,9082,'ba','Penjual Bill file',0),(326931,9082,'nl','Leverancier Bill bestanden',0),(326932,9082,'fi','Toimittajan laskun tiedostoja',0),(326933,9082,'no','LeverandÃ¸ren Bill filer',0),(326934,9082,'da','Kreditor Bill filer',0),(326935,9082,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ íŒŒì¼',0),(326936,9082,'he','×§×‘×¦×™ ×—×©×‘×•×Ÿ ×¡×¤×§',0),(326937,9082,'el','Î‘ÏÏ‡ÎµÎ¯Î± Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(326938,9082,'zh','é”€å”®æ–¹å¸å•æ–‡ä»¶\r\n',0),(326939,9082,'sv','LeverantÃ¶r Bill filer',0),(326940,9082,'it','File di fattura fornitore',0),(326941,9082,'tl','',0),(326942,9082,'th','&#3652;&#3615;&#3621;&#3660;&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(326943,9082,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(326944,9082,'ms','Penjual bil fail',0),(326945,9082,'ar','Ù…Ù„ÙØ§Øª Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(326946,9082,'fr','Fichiers de projet de loi du vendeur',0),(326947,9082,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸ãƒ•ã‚¡ã‚¤ãƒ«ã—ã¾ã™ã€‚',0),(326948,9082,'pt','Arquivos de conta de fornecedor',0),(326949,9082,'ru','Ð‘Ð¸Ð»Ð» Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°Ñ…',0),(326950,9082,'es','Files de FacturaciÃ³n de Proveedor',0),(326951,9082,'de','Kreditor-Zahlung-Dateien',0),(326952,9082,'en','Vendor Bill Files',0),(326953,9083,'is','',0),(326954,9083,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(326955,9083,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(326956,9083,'tr','Harici dosyalarÄ±',0),(326957,9083,'pl','Pliki dostawcy',0),(326958,9083,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(326959,9083,'ur','ÙˆÛŒÙ†ÚˆØ± Ù…Ø³Ù„ÛŒÚº',0),(326960,9083,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(326961,9083,'vi','Há»“ sÆ¡ NgÆ°á»i bÃ¡n',0),(326962,9083,'af','Verskaffer LÃªers',0),(326963,9083,'ro','Furnizor de fiÅŸiere',0),(326964,9083,'et','Tarnija failid',0),(326965,9083,'si','Prodajalec datoteke',0),(326966,9083,'ba','Penjual file',0),(326967,9083,'nl','Leverancier-bestanden',0),(326968,9083,'fi','Toimittajan tiedostoja',0),(326969,9083,'no','LeverandÃ¸r-filer',0),(326970,9083,'da','Kreditor filer',0),(326971,9083,'ko','ê³µê¸‰ ì—…ì²´ íŒŒì¼',0),(326972,9083,'he','×§×‘×¦×™ ×¡×¤×§',0),(326973,9083,'el','Î‘ÏÏ‡ÎµÎ¯Î± Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(326974,9083,'zh','ä¾›åº”å•†æ¡£æ¡ˆ\r\n',0),(326975,9083,'sv','LeverantÃ¶r-filer',0),(326976,9083,'it','File vendor',0),(326977,9083,'tl','',0),(326978,9083,'th','&#3652;&#3615;&#3621;&#3660;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(326979,9083,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(326980,9083,'ms','Penjual fail',0),(326981,9083,'ar','Ù…Ù„ÙÙ‘Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(326982,9083,'fr','Fichiers du vendeur',0),(326983,9083,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®ãƒ•ã‚¡ã‚¤ãƒ«',0),(326984,9083,'pt','Arquivos de fornecedor',0),(326985,9083,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(326986,9083,'es','Files de Proveedor',0),(326987,9083,'de','Vendor-Dateien',0),(326988,9083,'en','Vendor Files',0),(326989,9084,'is','',0),(326990,9084,'dr','Ø§ÙˆÙ„ÙŠÙ† ØªØ§Ø±ÙŠØ® ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø§Ú¯Ø± Ù…Ø¹Ù„ÙˆÙ… Ø§Ø³Øª ',0),(326991,9084,'pr','Ø§ÙˆÙ„ÙŠÙ† ØªØ§Ø±ÙŠØ® ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø§Ú¯Ø± Ù…Ø¹Ù„ÙˆÙ… Ø§Ø³Øª ',0),(326992,9084,'tr','Ä°lk tarihi biliniyorsa FaturalandÄ±rma',0),(326993,9084,'pl','Pierwszy rozliczeniowe data, jeÅ›li sÄ… znane',0),(326994,9084,'bg','ÐŸÑŠÑ€Ð²Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð°, Ð°ÐºÐ¾ ÑÐ° Ð¸Ð·Ð²ÐµÑÑ‚Ð½Ð¸',0),(326995,9084,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ù…Ø¹Ù„ÙˆÙ… ØªÙˆ Ø­Ø³Ø§Ø¨ Ú©Ø±Ù†Ø§',0),(326996,9084,'sr','ÐŸÑ€Ð²Ð¾ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð°ÐºÐ¾ Ñ˜Ðµ Ð¿Ð¾Ð·Ð½Ð°Ñ‚Ð°',0),(326997,9084,'vi','NgÃ y Ra HÃ³a ÄÆ¡n Ä‘áº§u tiÃªn náº¿u biáº¿t',0),(326998,9084,'af','Eerste Verekeningsdatum Indien Bekend',0),(326999,9084,'ro','Facturare prima datÄƒ dacÄƒ se cunoaÅŸte',0),(327000,9084,'et','Esimene arve kuupÃ¤ev kui teada',0),(327001,9084,'si','Prvi obraÄun dneva, Äe je znano',0),(327002,9084,'ba','Pertama tanggal tagihan jika diketahui',0),(327003,9084,'nl','Eerst betaling bepalen indien bekend',0),(327004,9084,'fi','Ensin laskutus pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤, jos tiedossa',0),(327005,9084,'no','FÃ¸rste fakturering dato hvis kjent',0),(327006,9084,'da','FÃ¸rst fakturerings dato, hvis kendt',0),(327007,9084,'ko','ì•Œ ìˆ˜ ìžˆëŠ” ê²½ìš° ì²« ë²ˆì§¸ ë‚ ì§œë¥¼ ê²°ì œ',0),(327008,9084,'he','×ª×—×™×œ×” ×—×™×•×‘ ×ª××¨×™×š ×× ×™×“×•×¢',0),(327009,9084,'el','Î ÏÏŽÏ„Î± Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±, ÎµÎ¬Î½ ÎµÎ¯Î½Î±Î¹ Î³Î½Ï‰ÏƒÏ„Î®',0),(327010,9084,'zh','å¦‚æžœå·²çŸ¥ï¼Œé¦–ä¸ªç»“ç®—æ—¥æœŸ\r\n',0),(327011,9084,'sv','FÃ¶rst fakturering datum om kÃ¤nt',0),(327012,9084,'it','Prima data di fatturazione se noto',0),(327013,9084,'tl','',0),(327014,9084,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3588;&#3619;&#3633;&#3657;&#3591;&#3649;&#3619;&#3585;&#3627;&#3634;&#3585;&#3619;&#3641;&#3657;',0),(327015,9084,'hi','à¤ªà¤¹à¤²à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤…à¤—à¤° à¤œà¤¾à¤¨à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¬à¤¿à¤²à¤¿à¤‚à¤—',0),(327016,9084,'ms','Pertama bil tarikh jika diketahui',0),(327017,9084,'ar','Ø£ÙˆÙ„ Ø§Ù„ÙÙˆØ§ØªÙŠØ± ØªØ§Ø±ÙŠØ® Ø¥Ø°Ø§ ÙƒØ§Ù† Ù…Ø¹Ø±ÙˆÙØ§',0),(327018,9084,'fr','Tout d\'abord Date de facturation si elle est connue',0),(327019,9084,'jp','çŸ¥ã‚‰ã‚Œã¦ã„ã‚‹å ´åˆã€æœ€åˆã®æ—¥ä»˜ã‚’è«‹æ±‚',0),(327020,9084,'pt','Primeiro encontro de faturamento se conhecido',0),(327021,9084,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³Ð° Ð”Ð°Ñ‚Ð°, ÐµÑÐ»Ð¸ Ð¸Ð·Ð²ÐµÑÑ‚Ð½Ð°',0),(327022,9084,'es','Primera Fecha de FacturaciÃ³n, si esta Conocida',0),(327023,9084,'de','Erste Abrechnung Datum, wenn bekannt',0),(327024,9084,'en','First Billing Date If Known',0),(327025,9085,'is','',0),(327026,9085,'dr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(327027,9085,'pr','ÙØ§ÙƒØªÙˆØ± Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(327028,9085,'tr','Proje faturasÄ±',0),(327029,9085,'pl','Projekt faktury',0),(327030,9085,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(327031,9085,'ur','Ù¾Ø±Ø§Ø¬ÛŒÚ©Ù¹ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(327032,9085,'sr','ÐŸÑ€Ð¾Ñ˜ÐµÐºÐ°Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(327033,9085,'vi','HÃ³a Ä‘Æ¡n Dá»± Ã¡n',0),(327034,9085,'af','Projek faktuur',0),(327035,9085,'ro','Proiect de facturÄƒ',0),(327036,9085,'et','Projekti arve',0),(327037,9085,'si','Projekt raÄuna',0),(327038,9085,'ba','Proyek faktur',0),(327039,9085,'nl','Project factuur',0),(327040,9085,'fi','Projektin laskuun',0),(327041,9085,'no','Prosjektfakturaen',0),(327042,9085,'da','Projektfaktura',0),(327043,9085,'ko','í”„ë¡œì íŠ¸ ì²­êµ¬ì„œ',0),(327044,9085,'he','×—×©×‘×•× ×™×ª ×¤×¨×•×™×§×˜',0),(327045,9085,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î­ÏÎ³Î¿Ï…',0),(327046,9085,'zh','é¡¹ç›®å‘ç¥¨\r\n',0),(327047,9085,'sv','Projektfaktura',0),(327048,9085,'it','Progetto fattura',0),(327049,9085,'tl','',0),(327050,9085,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(327051,9085,'hi','à¤ªà¥à¤°à¥‹à¤œà¥‡à¤•à¥à¤Ÿ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸',0),(327052,9085,'ms','Projek invois',0),(327053,9085,'ar','ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(327054,9085,'fr','Facture de projet',0),(327055,9085,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆè«‹æ±‚æ›¸',0),(327056,9085,'pt','Projeto nota fiscal',0),(327057,9085,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ð¾ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°Ð¼',0),(327058,9085,'es','Factura de Proyecto',0),(327059,9085,'de','Projektrechnung',0),(327060,9085,'en','Project Invoice',0),(327061,9086,'is','',0),(327062,9086,'dr','ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹',0),(327063,9086,'pr','ÙƒØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø³Ø±ÙŠØ¹',0),(327064,9086,'tr','QuickBooks',0),(327065,9086,'pl','QuickBooks',0),(327066,9086,'bg','QuickBooks',0),(327067,9086,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³',0),(327068,9086,'sr','QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ',0),(327069,9086,'vi','QuickBooks',0),(327070,9086,'af','QuickBooks',0),(327071,9086,'ro','QuickBooks',0),(327072,9086,'et','QuickBooks',0),(327073,9086,'si','QuickBooks',0),(327074,9086,'ba','QuickBooks',0),(327075,9086,'nl','QuickBooks',0),(327076,9086,'fi','QuickBooks',0),(327077,9086,'no','QuickBooks',0),(327078,9086,'da','QuickBooks',0),(327079,9086,'ko','QuickBooks',0),(327080,9086,'he','QuickBooks',0),(327081,9086,'el','QuickBooks',0),(327082,9086,'zh','QuickBooks ç³»åˆ—\r\n',0),(327083,9086,'sv','QuickBooks',0),(327084,9086,'it','QuickBooks',0),(327085,9086,'tl','',0),(327086,9086,'th','&#3588;&#3641;&#3656;&#3617;&#3639;&#3629;&#3648;&#3619;&#3656;&#3591;&#3604;&#3656;&#3623;&#3609;',0),(327087,9086,'hi','QuickBooks',0),(327088,9086,'ms','QuickBooks',0),(327089,9086,'ar','Ù‚Ø±Ø§Ø¡',0),(327090,9086,'fr','QuickBooks',0),(327091,9086,'jp','QuickBooks',0),(327092,9086,'pt','QuickBooks',0),(327093,9086,'ru','QuickBooks',0),(327094,9086,'es','Quickbooks',0),(327095,9086,'de','QuickBooks',0),(327096,9086,'en','QuickBooks',0),(327097,9087,'is','',0),(327098,9087,'dr','-Ù‡Ø± Ø¯Ùˆ Ù‡ÙØªÙ‡ ',0),(327099,9087,'pr','   Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´ØºÙ„ÙŠ-Ù‡Ø± Ø¯Ùˆ Ù‡ÙØªÙ‡ ',0),(327100,9087,'tr','Ä°ki haftalÄ±k',0),(327101,9087,'pl','Dwa razy w tygodniu',0),(327102,9087,'bg','Ð”Ð²Ð° Ð¿ÑŠÑ‚Ð¸ ÑÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð¾',0),(327103,9087,'ur','Ø¯ÙˆÛÙØªÙˆÚº',0),(327104,9087,'sr','Ð”Ð²Ð¾Ð½ÐµÐ´ÐµÑ™Ð½Ð¸',0),(327105,9087,'vi','Hai láº§n 1 tuáº§n',0),(327106,9087,'af','Tweeweekliks',0),(327107,9087,'ro','Bi-sÄƒptÄƒmÃ¢nal',0),(327108,9087,'et','KahenÃ¤dalane periood',0),(327109,9087,'si','Dvakrat tedensko',0),(327110,9087,'ba','Dwi-mingguan',0),(327111,9087,'nl','Bi-wekelijkse',0),(327112,9087,'fi','Toinen viikko',0),(327113,9087,'no','Bi-ukentlig',0),(327114,9087,'da','Bi-ugentlige',0),(327115,9087,'ko','ê²©ì£¼',0),(327116,9087,'he','×“×•-×©×‘×•×¢×™',0),(327117,9087,'el','Î”ÏÎ¿ Ï†Î¿ÏÎ­Ï‚ Ï„Î·Î½ ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(327118,9087,'zh','åŒå‘¨åˆŠ\r\n',0),(327119,9087,'sv','Varannan vecka',0),(327120,9087,'it','Bi-settimanale',0),(327121,9087,'tl','',0),(327122,9087,'th','&#3619;&#3634;&#3618;&#3611;&#3633;&#3585;&#3625;&#3660;',0),(327123,9087,'hi','à¤¦à¥à¤µà¤¿-à¤¸à¤¾à¤ªà¥à¤¤à¤¾à¤¹à¤¿à¤•',0),(327124,9087,'ms','Bi-Mingguan',0),(327125,9087,'ar','Ù…Ø±ØªÙŠÙ† Ø£Ø³Ø¨ÙˆØ¹ÙŠØ§',0),(327126,9087,'fr','Toutes les deux semaines',0),(327127,9087,'jp','éš”é€±',0),(327128,9087,'pt','Bi-semanal',0),(327129,9087,'ru','Ð”Ð²Ð° Ñ€Ð°Ð·Ð° Ð² Ð½ÐµÐ´ÐµÐ»ÑŽ',0),(327130,9087,'es','Quincenal',0),(327131,9087,'de','ZweiwÃ¶chentlich',0),(327132,9087,'en','Bi-Weekly',0),(327133,9088,'is','',0),(327134,9088,'dr','Ù…Ø§Ù‡Ø§Ù†Ù‡ ',0),(327135,9088,'pr','Ù…Ø§Ù‡Ø§Ù†Ù‡ ',0),(327136,9088,'tr','AylÄ±k',0),(327137,9088,'pl','MiesiÄ™czne',0),(327138,9088,'bg','ÐœÐµÑÐµÑ‡ÐµÐ½',0),(327139,9088,'ur','Ù…Ø§ÛØ§Ù†Û',0),(327140,9088,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¸',0),(327141,9088,'vi','HÃ ng thÃ¡ng',0),(327142,9088,'af','Maandelikse Periode',0),(327143,9088,'ro','Lunar',0),(327144,9088,'et','Kuuajane periood',0),(327145,9088,'si','MeseÄno',0),(327146,9088,'ba','Bulanan',0),(327147,9088,'nl','Maandelijkse',0),(327148,9088,'fi','Kuukausittain',0),(327149,9088,'no','MÃ¥nedlig',0),(327150,9088,'da','MÃ¥nedlige',0),(327151,9088,'ko','ì›”ê°„',0),(327152,9088,'he','×—×•×“×©×™',0),(327153,9088,'el','ÎœÎ·Î½Î¹Î±Î¯Î±',0),(327154,9088,'zh','æ¯æœˆ\r\n',0),(327155,9088,'sv','MÃ¥natliga',0),(327156,9088,'it','Mensile',0),(327157,9088,'tl','',0),(327158,9088,'th','&#3619;&#3634;&#3618;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(327159,9088,'hi','à¤®à¤¾à¤¸à¤¿à¤•',0),(327160,9088,'ms','Bulanan',0),(327161,9088,'ar','Ø§Ù„Ø´Ù‡Ø±ÙŠ',0),(327162,9088,'fr','Mensuel',0),(327163,9088,'jp','æ¯Žæœˆ',0),(327164,9088,'pt','Mensal',0),(327165,9088,'ru','Ð•Ð¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ð¾',0),(327166,9088,'es','Mensual',0),(327167,9088,'de','Monatliche',0),(327168,9088,'en','Monthly',0),(327169,9089,'is','',0),(327170,9089,'dr','Ø¯ÙˆØ±Ù‡ Ù¾Ø§Ù†Ø²Ø¯Ù‡ Ø±ÙˆØ²ÙŠÚ©Ø¨Ø§Ø±',0),(327171,9089,'pr','Ø¯ÙˆØ±Ù‡ Ù¾Ø§Ù†Ø²Ø¯Ù‡ Ø±ÙˆØ²ÙŠÚ©Ø¨Ø§Ø±',0),(327172,9089,'tr','YarÄ± aylÄ±k',0),(327173,9089,'pl','PÃ³Å‚-miesiÄ™czne',0),(327174,9089,'bg','ÐŸÐ¾Ð»Ñƒ-Ð¼ÐµÑÐµÑ‡ÐµÐ½',0),(327175,9089,'ur','Ø³ÛŒÙ…ÛŒ Ù…Ø§ÛØ§Ù†Û',0),(327176,9089,'sr','ÐŸÐ¾Ð»Ñƒ -Ñ˜ÐµÐ´Ð½Ð¾Ð¼ Ð¼ÐµÑÐµÑ‡Ð½Ð¾',0),(327177,9089,'vi','Giá»¯a thÃ¡ng',0),(327178,9089,'af','Semi-Maandeliks',0),(327179,9089,'ro','Semi-lunar',0),(327180,9089,'et','Poolekuine periood',0),(327181,9089,'si','Pol-meseÄno',0),(327182,9089,'ba','Semi bulanan',0),(327183,9089,'nl','Semi-maandelijks',0),(327184,9089,'fi','Toinen kuukausi',0),(327185,9089,'no','Semi-mÃ¥nedlige',0),(327186,9089,'da','Semi-mÃ¥nedlige',0),(327187,9089,'ko','ë°˜ ì›”',0),(327188,9089,'he','×—×•×“×©×™ ×œ×ž×—×¦×”',0),(327189,9089,'el','Î—Î¼Î¹-Î¼Î·Î½Î¹Î±Î¯Î±',0),(327190,9089,'zh','åŠæœˆ\r\n',0),(327191,9089,'sv','Semi-monthly',0),(327192,9089,'it','Semi-mensile',0),(327193,9089,'tl','',0),(327194,9089,'th','&#3588;&#3619;&#3638;&#3656;&#3591;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(327195,9089,'hi','à¤…à¤°à¥à¤¦à¥à¤§-à¤®à¤¾à¤¸à¤¿à¤•',0),(327196,9089,'ms','Setengah bulanan',0),(327197,9089,'ar','Ù†ØµÙ Ø´Ù‡Ø±ÙŠ',0),(327198,9089,'fr','Deux fois par mois',0),(327199,9089,'jp','åŠæœˆåˆŠ',0),(327200,9089,'pt','Semi-mensal',0),(327201,9089,'ru','Ð Ð°Ð·Ð° Ð² Ð¼ÐµÑÑÑ†',0),(327202,9089,'es','Quincenal',0),(327203,9089,'de','Halbmonatlich',0),(327204,9089,'en','Semi-Monthly',0),(327205,9090,'is','',0),(327206,9090,'dr','Ø¯ÙˆØ±Ù‡ Ù‡ÙØªÚ¯ÙŠ ',0),(327207,9090,'pr','Ø¯ÙˆØ±Ù‡ Ù‡ÙØªÚ¯ÙŠ ',0),(327208,9090,'tr','HaftalÄ±k',0),(327209,9090,'pl','Tygodniowy',0),(327210,9090,'bg','Ð¡ÐµÐ´Ð¼Ð¸Ñ‡ÐµÐ½',0),(327211,9090,'ur','ÛÙØªÛ ÙˆØ§Ø±',0),(327212,9090,'sr','Ð¡ÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð¾',0),(327213,9090,'vi','HÃ ng tuáº§n',0),(327214,9090,'af','Weekliks',0),(327215,9090,'ro','SÄƒptÄƒmÃ¢nal',0),(327216,9090,'et','NÃ¤dalane periood',0),(327217,9090,'si','Tedenski',0),(327218,9090,'ba','Mingguan',0),(327219,9090,'nl','Per',0),(327220,9090,'fi','Viikoittain',0),(327221,9090,'no','Ukentlig',0),(327222,9090,'da','Ugentlige',0),(327223,9090,'ko','ì£¼ê°„',0),(327224,9090,'he','×©×‘×•×¢×™',0),(327225,9090,'el','Î•Î²Î´Î¿Î¼Î±Î´Î¹Î±Î¯Î±',0),(327226,9090,'zh','æ¯å‘¨\r\n',0),(327227,9090,'sv','Varje vecka',0),(327228,9090,'it','Settimanale',0),(327229,9090,'tl','',0),(327230,9090,'th','&#3619;&#3634;&#3618;&#3626;&#3633;&#3611;&#3604;&#3634;&#3627;&#3660;',0),(327231,9090,'hi','à¤¸à¤¾à¤ªà¥à¤¤à¤¾à¤¹à¤¿à¤•',0),(327232,9090,'ms','Mingguan',0),(327233,9090,'ar','Ø£Ø³Ø¨ÙˆØ¹ÙŠ',0),(327234,9090,'fr','Hebdomadaire',0),(327235,9090,'jp','æ¯Žé€±',0),(327236,9090,'pt','Semanal',0),(327237,9090,'ru','ÐÐµÐ´ÐµÐ»ÑŒÐ½Ñ‹Ð¹',0),(327238,9090,'es','Semanal',0),(327239,9090,'de','Pro',0),(327240,9090,'en','Weekly',0),(327241,9091,'is','',0),(327242,9091,'dr','( Ø®Ø±Ø§Ø¨ÙŠ) Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³-Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¶Ø§ÙŠØ¹Ø§Øª Ø±Ø§ Ø·Ø¨Ù‚ ÙˆØ²Ù† Ø¨Ù‡ Ø¬Ù†Ø³Ù‡Ø§ÙŠ ÙØ±Ø¹ÙŠ Ù¾Ø³Øª ÙƒÙ†ÙŠØ¯ ',0),(327243,9091,'pr','ØªÙÙƒÙŠÙƒ ( Ø®Ø±Ø§Ø¨ÙŠ) Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§-Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¶Ø§ÙŠØ¹Ø§Øª Ø±Ø§ Ø·Ø¨Ù‚ ÙˆØ²Ù† Ø¨Ù‡ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ±Ø¹ÙŠ Ù¾Ø³Øª ÙƒÙ†ÙŠØ¯ ',0),(327244,9091,'tr','Envanter dÃ¶kÃ¼mÃ¼ - Post hurda maliyetleri kilo alan alt Ã¶ÄŸeler iÃ§in',0),(327245,9091,'pl','PodziaÅ‚ magazynu - koszty Post Scrap podelementy na podstawie wagi',0),(327246,9091,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ° - Ð¿Ð¾ÑÑ‚ ÑÐºÑ€Ð°Ð¿ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð¿Ð¾Ð´ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð° Ñ‚ÐµÐ³Ð»Ð¾Ñ‚Ð¾',0),(327247,9091,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø·Ø§Ø¨Ù‚ - ÙˆØ²Ù† Ù¾Ø± Ù…Ø¨Ù†ÛŒ Ø³ÙˆØ¨Ø§Ù¹Ù…Ø³ Ú©ÛŒ Ù¾ÙˆØ³Ù¹ Ø³Ú©Ø±ÛŒÙ¾ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(327248,9091,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° ÑÐ»Ð¾Ð¼ - Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ ÑˆÐºÐ°Ñ€Ñ‚Ð° ÐŸÐ¾ÑÑ‚ Ð´Ð° ÑÑƒÐ±Ð¸Ñ‚ÐµÐ¼Ñ Ð¾ÑÐ½Ð¾Ð²Ñƒ Ñ‚ÐµÐ¶Ð¸Ð½Ð°',0),(327249,9091,'vi','PhÃ¢n Chia hÃ ng hÃ³a - Káº¿t chuyá»ƒn chi phÃ­ pháº¿ liá»‡u vÃ o danh má»¥c phá»¥ dá»±a trÃªn trá»ng lÆ°á»£ng',0),(327250,9091,'af','Inventaris Ontleding - Pos \"Scrap\" kostes na sub-items gebasseer op gewig',0),(327251,9091,'ro','Inventarul defalcare - costurile de Post resturi subelementele bazat pe greutatea',0),(327252,9091,'et','Kaubavaru jaotamine - Post jÃ¤Ã¤gid maksab alamÃ¼ksused pÃµhineb kaal',0),(327253,9091,'si','Zaloge razÄlenitev - Post ostanki stroÅ¡kov na podlagi teÅ¾e podelemente',0),(327254,9091,'ba','Persediaan Breakdown - biaya pos Scrap subitems berdasarkan berat',0),(327255,9091,'nl','Inventaris Breakdown - kladje plaatsen kosten voor subitems op basis van gewicht',0),(327256,9091,'fi','VarastoerittelyÃ¤ - viesti romu kustannukset subitems painon',0),(327257,9091,'no','Lager nedbryting - innlegget ditt kostnader underelementer basert pÃ¥ vekt',0),(327258,9091,'da','Lageret opdeling - Post skrot omkostninger til underelementer baseret pÃ¥ vÃ¦gt',0),(327259,9091,'ko','ìž¬ê³  ë‚´ì—­-ë¬´ê²Œì— ë”°ë¼ í•˜ìœ„ í•­ëª©ì— ê²Œì‹œë¬¼ ìŠ¤í¬ëž© ë¹„ìš©',0),(327260,9091,'he','×ž×œ××™ ×”×ª×ž×•×˜×˜×•×ª - ×¢×œ×•×™×•×ª ×’×¨×•×˜××•×ª ×¤×•×¡×˜ ×¤×¨×™×˜×™ ×ž×©× ×” ×¢×œ ×‘×¡×™×¡ ×ž×©×§×œ',0),(327261,9091,'el','ÎšÎ±Ï„Î±Î½Î¿Î¼Î® Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ - Î¸Î­ÏƒÎ· Î¸ÏÎ±ÏÏƒÎ¼Î±Ï„Î± ÎºÏŒÏƒÏ„Î¿Ï‚ Î½Î± Î´ÎµÏ…Ï„ÎµÏÎµÏÎ¿Î½Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¿ Î²Î¬ÏÎ¿Ï‚',0),(327262,9091,'zh','åº“å­˜å´©æºƒ -é‚®æ”¿åºŸé’¢æˆæœ¬çš„åŸºç¡€ä¸Šé‡å­é¡¹ç›®\r\n',0),(327263,9091,'sv','Inventering uppdelning - Post skrot kostnader till underavdelningar baserat pÃ¥ vikt',0),(327264,9091,'it','Ripartizione di inventario - costi Post rottami per elementi secondari basati sul peso',0),(327265,9091,'tl','',0),(327266,9091,'th','Inventory Breakdown - Post Scrap costs to subitems based on weight',0),(327267,9091,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤Ÿà¥‚à¤Ÿà¤¨à¥‡ - à¤ªà¤¦ à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª à¤²à¤¾à¤—à¤¤ à¤¸à¤¬à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤µà¤œà¤¨ à¤ªà¤° à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(327268,9091,'ms','Pecahan inventori - kos pos sekerap yang subitems berdasarkan berat badan',0),(327269,9091,'ar','Ø§Ù†Ù‡ÙŠØ§Ø± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†-ØªÙƒØ§Ù„ÙŠÙ ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø®Ø±Ø¯Ø© Ø¥Ù„Ù‰ Ø¹Ù†Ø§ØµØ± ÙØ±Ø¹ÙŠØ© Ø§Ø³ØªÙ†Ø§Ø¯Ø§Ù‹ Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ²Ù†',0),(327270,9091,'fr','L\'inventaire Breakdown - frais de poste Scrap Ã  sous-Ã©lÃ©ments selon le poids',0),(327271,9091,'jp','åœ¨åº«è©³ç´° - ãƒã‚¹ãƒˆ ã‚¹ã‚¯ãƒ©ãƒƒãƒ— ã‚³ã‚¹ãƒˆé‡é‡ã«åŸºã¥ã„ã¦ã‚µãƒ–é …ç›®ã‚’',0),(327272,9091,'pt','RepartiÃ§Ã£o de inventÃ¡rio - custos Post sucata para subitens com base no peso',0),(327273,9091,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ° - Ð¿Ð¾ÑÑ‚ Ð»Ð¾Ð¼ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð¿Ð¾Ð´ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð², Ð¾ÑÐ½Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹ Ð½Ð° Ð²ÐµÑ',0),(327274,9091,'es','Detalle de Inventario - Contabiliza Costos de Desechas al Subitems basados en su peso',0),(327275,9091,'de','Inventory Breakdown - Post Schrott Kosten, die Unterelemente basierend auf Gewicht',0),(327276,9091,'en','Inventory Breakdown - Post Scrap costs to subitems based on weight',0),(327277,9092,'is','',0),(327278,9092,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(327279,9092,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(327280,9092,'tr','Maliyet/birim stok',0),(327281,9092,'pl','Koszt/akcji jednostki',0),(327282,9092,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸/ÑÐºÐ»Ð°Ð´ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(327283,9092,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚ÛŒÙ…Øª/Ø§Ø³Ù¹Ø§Ú©',0),(327284,9092,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº /Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(327285,9092,'vi','GiÃ¡ / 1 Ä‘Æ¡n vá»‹ hÃ ng',0),(327286,9092,'af','Koste/Voorraad Eenheid',0),(327287,9092,'ro','Costul/stoc unitate',0),(327288,9092,'et','Kulu/Stock Ã¼ksus',0),(327289,9092,'si','StroÅ¡ki/Stock enote',0),(327290,9092,'ba','Biaya saham Unit',0),(327291,9092,'nl','Kosten/voorraad Unit',0),(327292,9092,'fi','Kustannuksista/Stock yksikkÃ¶',0),(327293,9092,'no','Kostnad/lager enhet',0),(327294,9092,'da','Omkostninger/lager enhed',0),(327295,9092,'ko','ë¹„ìš©/ìž¬ê³  ë‹¨ìœ„',0),(327296,9092,'he','×¢×œ×•×ª/×ž× ×™×” ×™×—×™×“×”',0),(327297,9092,'el','ÎšÏŒÏƒÏ„Î¿Ï‚/Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î¼Î¿Î½Î¬Î´Î±',0),(327298,9092,'zh','æˆæœ¬/å•ä½è‚¡\r\n',0),(327299,9092,'sv','Kostnad/lager enhet',0),(327300,9092,'it','UnitÃ  di costo/Stock',0),(327301,9092,'tl','',0),(327302,9092,'th','&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;/&#3627;&#3609;&#3656;&#3623;&#3618;&#3626;&#3605;&#3655;&#3629;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(327303,9092,'hi','à¤²à¤¾à¤—à¤¤/à¤¶à¥‡à¤¯à¤° à¤‡à¤•à¤¾à¤ˆ',0),(327304,9092,'ms','Unit kos/saham',0),(327305,9092,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„ØªÙƒÙ„ÙØ©/Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(327306,9092,'fr','UnitÃ© de coÃ»t/Stock',0),(327307,9092,'jp','ã‚³ã‚¹ãƒˆ/åœ¨åº«å˜ä½',0),(327308,9092,'pt','Unidade de custo/estoque',0),(327309,9092,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ/Ñ„Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ð¹ Ð±Ð»Ð¾Ðº',0),(327310,9092,'es','Cost/Unidad de Stock',0),(327311,9092,'de','Kosten/Stock Einheit',0),(327312,9092,'en','Cost/Stock Unit',0),(327313,9093,'is','',0),(327314,9093,'dr','( Ø®Ø±Ø§Ø¨ÙŠ) Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³',0),(327315,9093,'pr','ØªÙÙƒÙŠÙƒ ( Ø®Ø±Ø§Ø¨ÙŠ) Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(327316,9093,'tr','Envanter dÃ¶kÃ¼mÃ¼',0),(327317,9093,'pl','PodziaÅ‚ magazynu',0),(327318,9093,'bg','Ð Ð°Ð·Ð±Ð¸Ð²ÐºÐ° Ð½Ð° Ð¾Ð¿Ð¸ÑÐ°',0),(327319,9093,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø·Ø§Ø¨Ù‚',0),(327320,9093,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° ÑÐ»Ð¾Ð¼',0),(327321,9093,'vi','PhÃ¢n Chia hÃ ng hÃ³a',0),(327322,9093,'af','Inventaris Ontleding',0),(327323,9093,'ro','Inventarul defalcare',0),(327324,9093,'et','Kaubavaru jaotamine',0),(327325,9093,'si','RazÄlenitev popisa',0),(327326,9093,'ba','Rincian persediaan',0),(327327,9093,'nl','Inventaris verdeling',0),(327328,9093,'fi','VarastoerittelyÃ¤',0),(327329,9093,'no','Lager sammenbrudd',0),(327330,9093,'da','Lageret opdeling',0),(327331,9093,'ko','ìž¬ê³  ë‚´ì—­',0),(327332,9093,'he','×¤×™×¨×•×˜ ×¨×©×™×ž×ª ×ž×œ××™',0),(327333,9093,'el','ÎšÎ±Ï„Î±Î½Î¿Î¼Î® Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(327334,9093,'zh','åº“å­˜å‡»ç©¿\r\n',0),(327335,9093,'sv','Inventering uppdelning',0),(327336,9093,'it','Ripartizione di inventario',0),(327337,9093,'tl','',0),(327338,9093,'th','&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;&#3648;&#3610;&#3619;&#3588;&#3604;&#3634;&#3623;&#3609;&#3660;',0),(327339,9093,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤Ÿà¥‚à¤Ÿà¤¨à¥‡',0),(327340,9093,'ms','Pecahan inventori',0),(327341,9093,'ar','Ø§Ù†Ù‡ÙŠØ§Ø± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(327342,9093,'fr','Rupture de stock',0),(327343,9093,'jp','åœ¨åº«ã®å†…è¨³',0),(327344,9093,'pt','Ruptura de estoque',0),(327345,9093,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(327346,9093,'es','Detalle de Inventario',0),(327347,9093,'de','Inventar-AufschlÃ¼sselung',0),(327348,9093,'en','Inventory Breakdown',0),(327349,9094,'is','',0),(327350,9094,'dr','(ØªÙÙƒÙŠÙƒ) Ø¬Ù†Ø³  Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(327351,9094,'pr','Ø®Ø±Ø§Ø¨ÙŠ (ØªÙÙƒÙŠÙƒ) ÙƒØ§Ù„Ø§  Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(327352,9094,'tr','Maddenin krizi baÅŸarÄ±sÄ±z oldu',0),(327353,9094,'pl','PodziaÅ‚ elementu nie powiodÅ‚o siÄ™',0),(327354,9094,'bg','Ð¢Ð¾Ñ‡ÐºÐ° Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ° Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(327355,9094,'ur','Ø´Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§',0),(327356,9094,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» ÑÐ»Ð¾Ð¼ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(327357,9094,'vi','PhÃ¢n chia hÃ ng tháº¥t báº¡i',0),(327358,9094,'af','Item Ontleding het Gefaal',0),(327359,9094,'ro','Defalcare de element nu a reuÈ™it',0),(327360,9094,'et','Toote lÃµhkumine ebaÃµnnestus',0),(327361,9094,'si','Postavkah ni uspela',0),(327362,9094,'ba','Rincian item yang gagal',0),(327363,9094,'nl','Item verdeling is mislukt',0),(327364,9094,'fi','Nimike-erittely epÃ¤onnistui',0),(327365,9094,'no','Elementet sammenbrudd mislyktes',0),(327366,9094,'da','Vare opdeling mislykkedes',0),(327367,9094,'ko','ì‹¤íŒ¨ í•­ëª© ë‚´ì—­',0),(327368,9094,'he','×”×ª×¤×œ×’×•×ª ×¤×¨×™×˜ × ×›×©×œ',0),(327369,9094,'el','ÎšÎ±Ï„Î±Î½Î¿Î¼Î® Ï„Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(327370,9094,'zh','é¡¹ç›®åˆ†é¡¹å¤±è´¥\r\n',0),(327371,9094,'sv','Objektet uppdelning misslyckades',0),(327372,9094,'it','Elemento di ripartizione non riuscita',0),(327373,9094,'tl','',0),(327374,9094,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3648;&#3610;&#3619;&#3588;&#3604;&#3634;&#3623;&#3609;&#3660;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(327375,9094,'hi','à¤†à¤‡à¤Ÿà¤® à¤Ÿà¥‚à¤Ÿà¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(327376,9094,'ms','Pecahan item yang gagal',0),(327377,9094,'ar','ÙØ´Ù„ ØªÙÙƒÙŠÙƒ ØµÙ†Ù',0),(327378,9094,'fr','Point de rupture n\'a pas',0),(327379,9094,'jp','å¤±æ•—ã—ãŸé …ç›®ã®å†…è¨³',0),(327380,9094,'pt','Item discriminaÃ§Ã£o falhada',0),(327381,9094,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ° Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(327382,9094,'es','Detalle de Item FallÃ³',0),(327383,9094,'de','Element AufschlÃ¼sselung ist fehlgeschlagen',0),(327384,9094,'en','Item Breakdown Failed',0),(327385,9095,'is','',0),(327386,9095,'dr','ÙƒØ§Ù„Ø§ÙŠ Ø´ÙƒØ³ØªÙ‡ Ø´Ø¯Ù‡  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ',0),(327387,9095,'pr','ÙƒØ§Ù„Ø§ÙŠ Ø´ÙƒØ³ØªÙ‡ Ø´Ø¯Ù‡  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ',0),(327388,9095,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde ayrÄ±lmÄ±ÅŸ Ã¶ÄŸe',0),(327389,9095,'pl','Element podziale pomyÅ›lnie',0),(327390,9095,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ», Ñ€Ð°Ð·Ð±Ð¸Ñ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(327391,9095,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ù¹ÙˆÙ¹ Ø´Û’',0),(327392,9095,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ð¿Ð¾ÐºÐ²Ð°Ñ€Ð¸Ð¾ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(327393,9095,'vi','HÃ ng chia thÃ nh cÃ´ng',0),(327394,9095,'af','Item suksesvol afgebreek',0),(327395,9095,'ro','Element defalcate cu succes',0),(327396,9095,'et','Toode lÃµhuti edukalt',0),(327397,9095,'si','Artikel odpovedal uspeÅ¡no',0),(327398,9095,'ba','Item rusak berhasil',0),(327399,9095,'nl','Object met succes uitgesplitst',0),(327400,9095,'fi','Nimikkeen eriteltyinÃ¤ onnistuneesti',0),(327401,9095,'no','Elementet inndelt vellykket',0),(327402,9095,'da','Varen nedbrydes med succes',0),(327403,9095,'ko','í•­ëª©ì´ ì„±ê³µì ìœ¼ë¡œ ì„¸ë¶„í™”',0),(327404,9095,'he','×¤×¨×™×˜ ×”×ª×§×œ×§×œ×” ×‘×”×¦×œ×—×”',0),(327405,9095,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î¿Ï… Î±Î½Î±Î»ÏÎ¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(327406,9095,'zh','é¡¹ç›®åˆ†é¡¹æˆåŠŸ\r\n',0),(327407,9095,'sv','Objektet uppdelade framgÃ¥ngsrikt',0),(327408,9095,'it','Elemento ripartito correttamente',0),(327409,9095,'tl','',0),(327410,9095,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3627;&#3633;&#3585;&#3621;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(327411,9095,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¥€à¤šà¥‡ à¤Ÿà¥‚à¤Ÿà¥€ à¤¹à¥à¤ˆ à¤¹à¥ˆ',0),(327412,9095,'ms','Item yang dipecahkan berjaya',0),(327413,9095,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ù…ÙˆØ²Ø¹Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(327414,9095,'fr','Ã‰lÃ©ment dÃ©composÃ© avec succÃ¨s',0),(327415,9095,'jp','é …ç›®ãŒæ­£å¸¸ã«åˆ†è§£',0),(327416,9095,'pt','Item discriminado com sucesso',0),(327417,9095,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ñ€Ð°Ð·Ð±Ð¸Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(327418,9095,'es','Item Detallado Exitosamente',0),(327419,9095,'de','Element erfolgreich aufgeschlÃ¼sselt',0),(327420,9095,'en','Item Broken Down Successfully',0),(327421,9096,'is','',0),(327422,9096,'dr','(Ù‚Ø³Ù…Øª',0),(327423,9096,'pr','Ù‚Ø·Ø¹Ù‡ (Ù‚Ø³Ù…Øª',0),(327424,9096,'tr','ParÃ§a',0),(327425,9096,'pl','KawaÅ‚ek',0),(327426,9096,'bg','ÐŸÐ°Ñ€Ñ‡Ðµ',0),(327427,9096,'ur','Ù¹Ú©Ú‘Ø§',0),(327428,9096,'sr','ÐšÐ¾Ð¼Ð°Ð´',0),(327429,9096,'vi','Miáº¿ng',0),(327430,9096,'af','Stuk',0),(327431,9096,'ro','BucatÄƒ',0),(327432,9096,'et','TÃ¼kk',0),(327433,9096,'si','Kos',0),(327434,9096,'ba','Sepotong',0),(327435,9096,'nl','Stuk',0),(327436,9096,'fi','Pala',0),(327437,9096,'no','Stykke',0),(327438,9096,'da','Stykke',0),(327439,9096,'ko','ì¡°ê°',0),(327440,9096,'he','×—×ª×™×›×”',0),(327441,9096,'el','ÎšÎ¿Î¼Î¼Î¬Ï„Î¹',0),(327442,9096,'zh','ç‰‡\r\n\r\n',0),(327443,9096,'sv','Bit',0),(327444,9096,'it','Pezzo',0),(327445,9096,'tl','',0),(327446,9096,'th','&#3594;&#3636;&#3657;&#3609;',0),(327447,9096,'hi','à¤Ÿà¥à¤•à¤¡à¤¼à¤¾',0),(327448,9096,'ms','Sekeping',0),(327449,9096,'ar','Ù‚Ø·Ø¹Ø©',0),(327450,9096,'fr','PiÃ¨ce',0),(327451,9096,'jp','ãƒ¯ãƒ³ãƒ”ãƒ¼ã‚¹',0),(327452,9096,'pt','PeÃ§a',0),(327453,9096,'ru','ÐšÑƒÑÐ¾Ðº',0),(327454,9096,'es','Pieza',0),(327455,9096,'de','StÃ¼ck',0),(327456,9096,'en','Piece',0),(327457,9097,'is','',0),(327458,9097,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ ',0),(327459,9097,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ ',0),(327460,9097,'tr','OluÅŸturulan miktarÄ±',0),(327461,9097,'pl','IloÅ›Ä‡ utworzonych',0),(327462,9097,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½',0),(327463,9097,'ur','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(327464,9097,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½',0),(327465,9097,'vi','Sá»‘ lÆ°á»£ng táº¡o ra',0),(327466,9097,'af','Hoeveelheid Geskep',0),(327467,9097,'ro','Cantitatea creat',0),(327468,9097,'et','Loodud kogus',0),(327469,9097,'si','KoliÄina ustvarjene',0),(327470,9097,'ba','Jumlah dibuat',0),(327471,9097,'nl','Hoeveelheid gemaakt',0),(327472,9097,'fi','MÃ¤Ã¤rÃ¤ luotu',0),(327473,9097,'no','Antall opprettet',0),(327474,9097,'da','Antal oprettet',0),(327475,9097,'ko','ìž‘ì„± í•˜ëŠ” ìˆ˜ëŸ‰',0),(327476,9097,'he','×›×ž×•×ª ×©× ×•×¦×¨×•',0),(327477,9097,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ',0),(327478,9097,'zh','æ•°é‡åˆ›å»º\r\n',0),(327479,9097,'sv','Antal skapade',0),(327480,9097,'it','QuantitÃ  creata',0),(327481,9097,'tl','',0),(327482,9097,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3626;&#3619;&#3657;&#3634;&#3591;&#3586;&#3638;&#3657;&#3609;\n',0),(327483,9097,'hi','à¤¬à¤¨à¤¾à¤ˆ à¤—à¤ˆ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(327484,9097,'ms','Kuantiti yang dicipta',0),(327485,9097,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§',0),(327486,9097,'fr','QuantitÃ© crÃ©Ã©e',0),(327487,9097,'jp','ä½œæˆã•ã‚ŒãŸæ•°é‡',0),(327488,9097,'pt','Quantidade criada',0),(327489,9097,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð½Ð¾Ðµ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(327490,9097,'es','Cantidad Creado',0),(327491,9097,'de','Menge erstellt',0),(327492,9097,'en','Quantity Created',0),(327493,9098,'is','',0),(327494,9098,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(327495,9098,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(327496,9098,'tr','KullanÄ±lan miktar',0),(327497,9098,'pl','IloÅ›Ä‡ uÅ¼ywane',0),(327498,9098,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(327499,9098,'ur','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§',0),(327500,9098,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ ÐºÐ¾Ñ˜Ð° Ñ˜Ðµ ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÐ½Ð°',0),(327501,9098,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ dÃ¹ng',0),(327502,9098,'af','Hoeveelheid gebruik',0),(327503,9098,'ro','Cantitatea utilizatÄƒ',0),(327504,9098,'et','Kasutatud kogus',0),(327505,9098,'si','Uporabljeno koliÄino',0),(327506,9098,'ba','Kuantitas yang digunakan',0),(327507,9098,'nl','Gebruikte hoeveelheid',0),(327508,9098,'fi','KÃ¤ytetty mÃ¤Ã¤rÃ¤',0),(327509,9098,'no','Antallet som er brukt',0),(327510,9098,'da','MÃ¦ngde',0),(327511,9098,'ko','ì‚¬ìš© ìˆ˜ëŸ‰',0),(327512,9098,'he','×›×ž×•×ª ×‘×©×™×ž×•×©',0),(327513,9098,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹',0),(327514,9098,'zh','ä½¿ç”¨é‡\r\n',0),(327515,9098,'sv','Kvantitet som anvÃ¤nds',0),(327516,9098,'it','QuantitÃ  utilizzata',0),(327517,9098,'tl','',0),(327518,9098,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3651;&#3594;&#3657;',0),(327519,9098,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(327520,9098,'ms','Kuantiti digunakan',0),(327521,9098,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(327522,9098,'fr','QuantitÃ© utilisÃ©e',0),(327523,9098,'jp','ä½¿ç”¨é‡',0),(327524,9098,'pt','Quantidade utilizada',0),(327525,9098,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ñ…',0),(327526,9098,'es','Cantidad Usada',0),(327527,9098,'de','Menge verwendet',0),(327528,9098,'en','Quantity Used',0),(327529,9099,'is','',0),(327530,9099,'dr','ÙˆØ²Ù† Ù‡Ø± Ù‚Ø·Ø¹Ù‡ ',0),(327531,9099,'pr','ÙˆØ²Ù† Ù‡Ø± Ù‚Ø·Ø¹Ù‡ ',0),(327532,9099,'tr','ParÃ§a baÅŸÄ±na aÄŸÄ±rlÄ±k',0),(327533,9099,'pl','Waga za sztukÄ™',0),(327534,9099,'bg','Ð¢ÐµÐ³Ð»Ð¾ Ð½Ð° Ð±Ñ€Ð¾Ð¹ÐºÐ°',0),(327535,9099,'ur','Ù¹Ú©Ú‘Ø§ ÙÛŒ ÙˆØ²Ù†',0),(327536,9099,'sr','Ð¢ÐµÐ¶Ð¸Ð½Ð° Ð¿Ð¾ ÐºÐ¾Ð¼Ð°Ð´Ñƒ',0),(327537,9099,'vi','Trá»ng lÆ°á»£ng má»—i cÃ¡i',0),(327538,9099,'af','Gewig per Stuk',0),(327539,9099,'ro','Greutate Per bucata',0),(327540,9099,'et','Kaal Ã¼hiku kohta',0),(327541,9099,'si','TeÅ¾a na kos',0),(327542,9099,'ba','Berat Per buah',0),(327543,9099,'nl','Gewicht Per stuk',0),(327544,9099,'fi','Paino Per kappale',0),(327545,9099,'no','Vekt Per brikke',0),(327546,9099,'da','VÃ¦gt pr. stk.',0),(327547,9099,'ko','ê°œë‹¹ ì¤‘ëŸ‰',0),(327548,9099,'he','×ž×©×§×œ ×œ×›×œ ×—×ª×™×›×”',0),(327549,9099,'el','Î’Î¬ÏÎ¿Ï‚ Î±Î½Î¬ Ï„ÎµÎ¼Î¬Ï‡Î¹Î¿',0),(327550,9099,'zh','æ¯ä»¶é‡é‡\r\n',0),(327551,9099,'sv','Vikt Per St',0),(327552,9099,'it','Peso al pezzo',0),(327553,9099,'tl','',0),(327554,9099,'th','&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;&#3605;&#3656;&#3629;&#3594;&#3636;&#3657;&#3609;',0),(327555,9099,'hi','à¤Ÿà¥à¤•à¤¡à¤¼à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤œà¤¨',0),(327556,9099,'ms','Berat sebiji',0),(327557,9099,'ar','Ø§Ù„ÙˆØ²Ù† Ù„ÙƒÙ„ Ù‚Ø·Ø¹Ø©',0),(327558,9099,'fr','Poids par piÃ¨ce',0),(327559,9099,'jp','1 å€‹ã‚ãŸã‚Šã®é‡é‡',0),(327560,9099,'pt','Peso por peÃ§a',0),(327561,9099,'ru','Ð’ÐµÑ Ð¾Ð´Ð½Ð¾Ð³Ð¾',0),(327562,9099,'es','Peso Por Pieza',0),(327563,9099,'de','Gewicht pro StÃ¼ck',0),(327564,9099,'en','Weight Per Piece',0),(327565,9100,'is','',0),(327566,9100,'dr','Ø®Ø§Ù…ÙˆØ´ ÙƒØ±Ø¯Ù† ØªØ¨Ø¯ÙŠÙ„ ÙƒÙ†Ù†Ø¯Ù‡ Ø®ÙˆØ¯ÙƒØ§Ø± ÙˆØ§Ø­Ø¯ Ø¨Ø±Ø§ÙŠ Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(327567,9100,'pr','Ø®Ø§Ù…ÙˆØ´ ÙƒØ±Ø¯Ù† ØªØ¨Ø¯ÙŠÙ„ ÙƒÙ†Ù†Ø¯Ù‡ Ø®ÙˆØ¯ÙƒØ§Ø± ÙˆØ§Ø­Ø¯ Ø¨Ø±Ø§ÙŠ Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(327568,9100,'tr','Devre dÄ±ÅŸÄ± Auto-birim dÃ¶nÃ¼ÅŸtÃ¼rme iÃ§in PO Ã¼zerinde alÄ±nan miktar',0),(327569,9100,'pl','WyÅ‚Ä…cz Auto jednostki konwersji do iloÅ›ci otrzymanych na PO',0),(327570,9100,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð² PO',0),(327571,9100,'ur','Ø®ÙˆØ¯Ú©Ø§Ø±-ÛŒÙˆÙ†Ù¹ ØªØ¨Ø§Ø¯Ù„ÙˆÚº Ù¾Ø± Ù¾Ùˆ Ù…Ù„ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©Û’ Ù„ÛŒÛ’ Ø¢Ù Ú©Ø±ÛŒÚº',0),(327572,9100,'sr','Ð˜ÑÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ñƒ ÐÑƒÑ‚Ð¾-Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ ÐŸÐž',0),(327573,9100,'vi','Táº¯t tá»± Ä‘á»™ng chuyá»ƒn Ä‘á»•i cho sá»‘ lÆ°á»£ng nháº­n trÃªn Ä‘Æ¡n mua hÃ ng',0),(327574,9100,'af','Skakel Outo-Eenheid Oorskakeling Af vir Hoeveelheid Ontvang op AB',0),(327575,9100,'ro','DezactivaÈ›i Auto-unitatea de conversie pentru cantitatea primitÄƒ pe PO',0),(327576,9100,'et','LÃ¼litage Auto-Unit Conversion PO saadud kogus',0),(327577,9100,'si','Izklopiti pretvorbo Auto-enota za koliÄino prejetih na PO',0),(327578,9100,'ba','Menonaktifkan Auto-Unit konversi untuk jumlah yang diterima pada PO',0),(327579,9100,'nl','Auto-eenheid conversie voor hoeveelheid ontvangen op PO uitschakelen',0),(327580,9100,'fi','Hapantua lÃ¤hettÃ¤Ã¤ Auto-yksikÃ¶n muuntamisen PO vastaanotettu mÃ¤Ã¤rÃ¤',0),(327581,9100,'no','SlÃ¥ av Auto-konvertering for antall mottatt pÃ¥ PO',0),(327582,9100,'da','Slukke Auto-Unit Conversion for antal modtaget pÃ¥ PO',0),(327583,9100,'ko','ì–‘ í¬ì— ìˆ˜ì‹ ì— ëŒ€ í•œ ìžë™ ë‹¨ìœ„ ë³€í™˜ í•´ì œ',0),(327584,9100,'he','×œ×‘×˜×œ ××ª ×”×”×ž×¨×” ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™-×™×—×™×“×ª ×¢×‘×•×¨ ×”×›×ž×•×ª ×©×”×ª×§×‘×œ×” ×‘×¤×•',0),(327585,9100,'el','Î‘Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ· Auto-Î¼Î¿Î½Î¬Î´Î± Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î®Ï‚ Î³Î¹Î± Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… ÎµÎ»Î®Ï†Î¸Î· ÏƒÏ„Î¹Ï‚ PO',0),(327586,9100,'zh','è‡ªåŠ¨å…³é—­è®¢å•ä¸Šçš„æ”¶è´§æ•°é‡å•ä½è½¬æ¢\r\n',0),(327587,9100,'sv','StÃ¤ng av Auto-Unit Conversion fÃ¶r kvantitet mottagen PO',0),(327588,9100,'it','Spegnere Auto-unitÃ  conversione per quantitativo ricevuto sul PO',0),(327589,9100,'tl','',0),(327590,9100,'th','&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3649;&#3611;&#3621;&#3591;&#3627;&#3609;&#3656;&#3623;&#3618;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;&#3586;&#3629;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3',0),(327591,9100,'hi','à¤‘à¤Ÿà¥‹-à¤‡à¤•à¤¾à¤ˆ à¤•à¤¨à¤µà¤°à¥à¤œà¤¼à¤¨ à¤ªà¥‹ à¤ªà¤° à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤‚à¤¦',0),(327592,9100,'ms','Memadam penukaran Auto-Unit bagi kuantiti yang diterima pada PO',0),(327593,9100,'ar','Ø¥ÙŠÙ‚Ø§Ù Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª--ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ­ÙˆÙŠÙ„ Ù„Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø³ØªÙ„Ù…Ø© ÙÙŠ Ø¨Ùˆ',0),(327594,9100,'fr','DÃ©sactiver Auto-unitÃ© Conversion pour la quantitÃ© reÃ§ue sur PO',0),(327595,9100,'jp','PO ã«å…¥åº«ã—ãŸæ•°é‡ã®è‡ªå‹•å˜ä½å¤‰æ›ã‚’ã‚ªãƒ•ã«',0),(327596,9100,'pt','Desativar Auto-unidade conversÃ£o para quantidade recebida em PO',0),(327597,9100,'ru','Ð’Ñ‹ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð°Ð²Ñ‚Ð¾ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹ Ð¸Ð·Ð¼ÐµÑ€ÐµÐ½Ð¸Ñ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ… Ð½Ð° PO',0),(327598,9100,'es','Apagar ConversiÃ³n Auto de Unidad para Cantidad Recibido en el OC ',0),(327599,9100,'de','Deaktivieren Sie die Auto-Umrechnung fÃ¼r Wareneingangsmenge am PO',0),(327600,9100,'en','Turn Off Auto-Unit Conversion for Quantity Received on PO',0),(327601,9101,'is','',0),(327602,9101,'dr','Ø§ÙƒÙ†ÙˆÙ† ÙØ§ÙƒØªÙˆØ± Ø¨Ø¹Ø¯ÙŠ ',0),(327603,9101,'pr','Ø§ÙƒÙ†ÙˆÙ† ÙØ§ÙƒØªÙˆØ± Ø¨Ø¹Ø¯ÙŠ ',0),(327604,9101,'tr','Åžimdi sonraki fatura',0),(327605,9101,'pl','Faktury nastÄ™pny teraz',0),(327606,9101,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° ÑÐ»ÐµÐ´ ÑÐµÐ³Ð°',0),(327607,9101,'ur','Ø§Ø¨ Ø§Ú¯Ù„Ø§ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(327608,9101,'sr','Ð¡Ð°Ð´Ð° Ð´Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµÑ‚Ðµ Ð´Ð°Ñ™Ðµ',0),(327609,9101,'vi','HÃ³a Ä‘Æ¡n tiáº¿p theo bÃ¢y giá»',0),(327610,9101,'af','Faktuur Volgende Nou',0),(327611,9101,'ro','Factura continuare acum',0),(327612,9101,'et','Arve jÃ¤rgmine nÃ¼Ã¼d',0),(327613,9101,'si','Naslednji raÄun zdaj',0),(327614,9101,'ba','Faktur selanjutnya sekarang',0),(327615,9101,'nl','Factuur nu volgende',0),(327616,9101,'fi','Laskuta seuraavaksi nyt',0),(327617,9101,'no','Fakturere neste nÃ¥',0),(327618,9101,'da','Fakturere nÃ¦ste nu',0),(327619,9101,'ko','ì§€ê¸ˆ ë‹¤ìŒ ì†¡ìž¥',0),(327620,9101,'he','×”×—×©×‘×•× ×™×ª ×”×‘××” ×¢×›×©×™×•',0),(327621,9101,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î± Ï„ÏŽÏÎ±',0),(327622,9101,'zh','çŽ°åœ¨å‘ç¥¨ä¸‹ä¸€æ­¥\r\n',0),(327623,9101,'sv','Fakturera nÃ¤sta nu',0),(327624,9101,'it','Successivamente la fattura ora',0),(327625,9101,'tl','',0),(327626,9101,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3606;&#3633;&#3604;&#3652;&#3611;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(327627,9101,'hi','à¤…à¤—à¤²à¥‡ à¤…à¤¬ à¤šà¤¾à¤²à¤¾à¤¨',0),(327628,9101,'ms','Invois seterusnya kini',0),(327629,9101,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„ØªØ§Ù„ÙŠØ© Ø§Ù„Ø¢Ù†',0),(327630,9101,'fr','La facture ensuite maintenant',0),(327631,9101,'jp','ä»Šã™ãæ¬¡ã®è«‹æ±‚ã—ã¾ã™ã€‚',0),(327632,9101,'pt','Fatura prÃ³ximo agora',0),(327633,9101,'ru','Ð”Ð°Ð»ÐµÐµ ÑÑ‡ÐµÑ‚ ÑÐµÐ¹Ñ‡Ð°Ñ',0),(327634,9101,'es','Factura Proxima Ahora',0),(327635,9101,'de','Rechnung jetzt weiter',0),(327636,9101,'en','Invoice Next Now',0),(327637,9102,'is','',0),(327638,9102,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø¢Ø®Ø±ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(327639,9102,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø¢Ø®Ø±ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(327640,9102,'tr','Son fatura numarasÄ±',0),(327641,9102,'pl','Ostatni numer faktury',0),(327642,9102,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(327643,9102,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ú¯Ø°Ø´ØªÛ Ù†Ù…Ø¨Ø±',0),(327644,9102,'sr','Ð—Ð°Ð´ÑšÐ¸ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(327645,9102,'vi','Sá»‘ HÃ³a Ä‘Æ¡n cuá»‘i',0),(327646,9102,'af','Laaste Faktuurnommer',0),(327647,9102,'ro','Ultimele numÄƒrul facturii',0),(327648,9102,'et','Viimase arve Number',0),(327649,9102,'si','Zadnja Å¡tevilka raÄuna',0),(327650,9102,'ba','Nomor faktur terakhir',0),(327651,9102,'nl','Laatste factuurnummer',0),(327652,9102,'fi','Viimeisen laskunumero',0),(327653,9102,'no','Siste fakturanummer',0),(327654,9102,'da','Sidste fakturanummer',0),(327655,9102,'ko','ë§ˆì§€ë§‰ ì†¡ìž¥ ë²ˆí˜¸',0),(327656,9102,'he','×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª ××—×¨×•× ×”',0),(327657,9102,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(327658,9102,'zh','æœ€åŽå‘ç¥¨å·ç \r\n',0),(327659,9102,'sv','Senaste fakturanumret',0),(327660,9102,'it','Ultimo numero di fattura',0),(327661,9102,'tl','',0),(327662,9102,'th','&#3627;&#3621;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(327663,9102,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(327664,9102,'ms','Nombor invois terakhir',0),(327665,9102,'ar','Ø±Ù‚Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(327666,9102,'fr','Dernier numÃ©ro de la facture',0),(327667,9102,'jp','æœ€å¾Œã®è«‹æ±‚æ›¸ç•ªå·',0),(327668,9102,'pt','Ãšltimo nÃºmero de factura',0),(327669,9102,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(327670,9102,'es','Ultimo NÃºmero de la Factura',0),(327671,9102,'de','Letzte Rechnungsnummer',0),(327672,9102,'en','Last Invoice Number',0),(327673,9103,'is','',0),(327674,9103,'dr','ÙƒØ§Ù„Ø§ÙŠ Ø¨Ø¹Ø¯ÙŠ Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù† ',0),(327675,9103,'pr','ÙƒØ§Ù„Ø§ÙŠ Ø¨Ø¹Ø¯ÙŠ Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯Ù† ',0),(327676,9103,'tr','Faturalanacak sonraki Ã¶ÄŸe',0),(327677,9103,'pl','Nastepny do zafakturowania',0),(327678,9103,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð°',0),(327679,9103,'ur','Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ø¬Ø§ Ù„ÛŒÛ’ Ø§Ú¯Ù„ÛŒ Ø´Û’',0),(327680,9103,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(327681,9103,'vi','Ra hÃ³a Ä‘Æ¡n cho hÃ ng má»›i',0),(327682,9103,'af','Volgende Item om Gefaktureer moet word',0),(327683,9103,'ro','UrmÄƒtorul element sÄƒ fie facturate',0),(327684,9103,'et','JÃ¤rgmise Ã¼ksuse valmisolevad',0),(327685,9103,'si','Naslednji element za fakturiranje',0),(327686,9103,'ba','Item berikutnya untuk dikenakan tagihan',0),(327687,9103,'nl','Orde worden gefactureerd',0),(327688,9103,'fi','Esityslistalla Laskutettava',0),(327689,9103,'no','Neste element skal faktureres',0),(327690,9103,'da','NÃ¦ste punkt pÃ¥ dagsordenen skal faktureres',0),(327691,9103,'ko','ë‹¤ìŒ í•­ëª© ì²­êµ¬',0),(327692,9103,'he','×”×¤×¨×™×˜ ×”×‘× ×œ×”× ×¤×§×ª ×—×©×‘×•× ×™×ª',0),(327693,9103,'el','Î—Î¼ÎµÏÎ®ÏƒÎ¹Î± Î½Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î·Î¸Î¿ÏÎ½',0),(327694,9103,'zh','ä¸‹ä¸€ä¸ªè¦å¼€å‘ç¥¨çš„é¡¹ç›®\r\n',0),(327695,9103,'sv','NÃ¤sta punkt pÃ¥ fÃ¶redragningslistan som ska faktureras',0),(327696,9103,'it','Elemento successivo da fatturare',0),(327697,9103,'tl','',0),(327698,9103,'th','&#3606;&#3633;&#3604;&#3652;&#3611;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(327699,9103,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤—à¤²à¤¾ à¤†à¤‡à¤Ÿà¤®',0),(327700,9103,'ms','Item yang seterusnya untuk dapat invois',0),(327701,9103,'ar','Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„ØªØ§Ù„ÙŠ Ù„Ù„ÙÙˆØªØ±Ø©',0),(327702,9103,'fr','Ordre du jour Ã  facturer',0),(327703,9103,'jp','è«‹æ±‚ã•ã‚Œã‚‹æ¬¡ã®é …ç›®',0),(327704,9103,'pt','PrÃ³ximo Item a ser facturado',0),(327705,9103,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ðº Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐµ',0),(327706,9103,'es','El PrÃ³ximo Item que se Factura',0),(327707,9103,'de','Tagesordnung zu fakturierende',0),(327708,9103,'en','Next Item to be Invoiced',0),(327709,9104,'is','',0),(327710,9104,'dr','(Ø§Ø´Ø§Ø±Ù‡',0),(327711,9104,'pr','ØªØ°ÙƒØ±(Ø§Ø´Ø§Ø±Ù‡',0),(327712,9104,'tr','Ä°pucu',0),(327713,9104,'pl','WskazÃ³wka',0),(327714,9104,'bg','ÐŸÐ¾Ð´ÑÐºÐ°Ð·Ð²Ð°Ð½Ðµ',0),(327715,9104,'ur','Ø§Ø´Ø§Ø±Û',0),(327716,9104,'sr','ÐŸÐ¾Ð´ÑÐµÑ‚Ð½Ð¸Ðº',0),(327717,9104,'vi','Gá»£i Ã',0),(327718,9104,'af','Wenk',0),(327719,9104,'ro','Sugestie',0),(327720,9104,'et','Vihje',0),(327721,9104,'si','Namig',0),(327722,9104,'ba','Petunjuk',0),(327723,9104,'nl','Hint',0),(327724,9104,'fi','Vihje',0),(327725,9104,'no','Hint',0),(327726,9104,'da','Vink',0),(327727,9104,'ko','ížŒíŠ¸',0),(327728,9104,'he','×¨×ž×–',0),(327729,9104,'el','Î¥Ï€ÏŒÎ´ÎµÎ¹Î¾Î·',0),(327730,9104,'zh','æš—ç¤º\r\n',0),(327731,9104,'sv','Tips',0),(327732,9104,'it','Suggerimento',0),(327733,9104,'tl','',0),(327734,9104,'th','&#3585;&#3634;&#3619;&#3610;&#3629;&#3585;&#3651;&#3610;&#3657;',0),(327735,9104,'hi','à¤¸à¤‚à¤•à¥‡à¤¤',0),(327736,9104,'ms','Petunjuk',0),(327737,9104,'ar','ØªÙ„Ù…ÙŠØ­',0),(327738,9104,'fr','Astuce',0),(327739,9104,'jp','ãƒ’ãƒ³ãƒˆ',0),(327740,9104,'pt','Dica',0),(327741,9104,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ°',0),(327742,9104,'es','Indicio',0),(327743,9104,'de','Hinweis',0),(327744,9104,'en','Hint',0),(327745,9105,'is','',0),(327746,9105,'dr','( Ø®Ø±Ø§Ø¨ÙŠ) Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø¬Ù†Ø³-Ø¬Ù†Ø³ Ø§ØµÙ„ÙŠ Ø±Ø§ Ø¨Ù‡ Ø§Ø¬Ø²Ø§Ø¡ ÙØ±Ø¹ÙŠ ØªÙ‚Ø³ÙŠÙ… ÙƒÙ†ÙŠØ¯ ',0),(327747,9105,'pr','ØªÙÙƒÙŠÙƒ ( Ø®Ø±Ø§Ø¨ÙŠ) Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§-ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø±Ø§ Ø¨Ù‡ Ø§Ø¬Ø²Ø§Ø¡ ÙØ±Ø¹ÙŠ ØªÙ‚Ø³ÙŠÙ… ÙƒÙ†ÙŠØ¯ ',0),(327748,9105,'tr','Envanter dÃ¶kÃ¼mÃ¼ - alt bileÅŸenleri iÃ§ine bÃ¶lmek ana Ã¶ÄŸe',0),(327749,9105,'pl','Spis podziaÅ‚ - podzieliÄ‡ gÅ‚Ã³wny element podskÅ‚adnikÃ³w',0),(327750,9105,'bg','Ð Ð°Ð·Ð±Ð¸Ð²ÐºÐ° Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸ - Ð¾ÑÐ½Ð¾Ð²ÐµÐ½ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÑÐµ Ñ€Ð°Ð·Ð´ÐµÐ»ÑÑ‚ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð°',0),(327751,9105,'ur','Ø°ÛŒÙ„ÛŒ Ø§Ø¬Ø²Ø§ Ù…ÛŒÚº ØªÙ‚Ø³ÛŒÙ… Ø¨Ù†ÛŒØ§Ø¯ÛŒ Ø´Û’ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø·Ø§Ø¨Ù‚-',0),(327752,9105,'sr','Ð—Ð°Ð»Ð¸Ñ…Ðµ ÑÐ»Ð¾Ð¼ - Ð¿Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ð³Ð»Ð°Ð²Ð½Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ñƒ Ð¿Ð¾Ñ‚ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ðµ',0),(327753,9105,'vi','PhÃ¢n Chia HÃ ng hÃ³a - Chia Danh Má»¥c ChÃ­ thÃ nh tá»«ng nhÃ³m nhá»',0),(327754,9105,'af','Voorraad Indeling - verdeel hoofitems in sub-komponente',0),(327755,9105,'ro','Defalcare de inventar - Ã®mpÄƒrÅ£i element principal Ã®n subcomponente',0),(327756,9105,'et','Inventuuri lÃµhkumine - jaga peatoode komponentideks',0),(327757,9105,'si','Popis razÄlenitev - glavni element razdelimo podkomponent',0),(327758,9105,'ba','Persediaan Breakdown - membagi item utama menjadi subkomponen',0),(327759,9105,'nl','Inventaris Breakdown - kloof belangrijkste item subonderdelen',0),(327760,9105,'fi','Varaston erittely - jakaa tÃ¤rkeimpÃ¤nÃ¤ alikomponentit',0),(327761,9105,'no','Lager nedbryting - dele viktigste elementet i delkomponenter',0),(327762,9105,'da','Lageret opdeling - klÃ¸ft vigtigste element i delkomponenter',0),(327763,9105,'ko','ìž¬ê³  ë‚´ì—­-ë¶„í•  ì£¼ìš” í•­ëª© í•˜ìœ„ êµ¬ì„± ìš”ì†Œ',0),(327764,9105,'he','×ž×œ××™ ×”×ª×ž×•×˜×˜×•×ª - ×œ×—×œ×§ ××ª ×”×¤×¨×™×˜ ×”×¢×™×§×¨×™ ×¨×›×™×‘×™ ×ž×©× ×”',0),(327765,9105,'el','ÎšÎ±Ï„Î±Î½Î¿Î¼Î® Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ - Ï‡Î¬ÏƒÎ¼Î± ÎºÏÏÎ¹Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÎµ Î´ÎµÏ…Ï„ÎµÏÎµÏÎ¿Î½Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(327766,9105,'zh','åº“å­˜å´©æºƒ -ä¸»è¦é¡¹ç›®åˆ†ä¸ºå­é¡¹ç›®\r\n',0),(327767,9105,'sv','Inventering uppdelning - dela huvudpunkten i delkomponenter',0),(327768,9105,'it','Ripartizione dell\'inventario - dividere l\'elemento principale in sottocomponenti',0),(327769,9105,'tl','',0),(327770,9105,'th','Inventory Breakdown - divide main item into subcomponents',0),(327771,9105,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤Ÿà¥‚à¤Ÿ - à¤«à¥‚à¤Ÿ à¤¡à¤¾à¤²à¥‹ à¤‰à¤ªà¤˜à¤Ÿà¤• à¤®à¥‡à¤‚ à¤®à¥à¤–à¥à¤¯ à¤†à¤‡à¤Ÿà¤®',0),(327772,9105,'ms','Inventori pecahan - membahagikan item utama kepada subcomponents',0),(327773,9105,'ar','ØªÙÙƒÙŠÙƒ ØµÙ†Ù Ù…Ø®Ø²ÙˆÙ† - ØªØ¬Ø²Ø¦Ø© ØµÙ†Ù Ø¥Ù„Ù‰ Ù…ÙƒÙˆÙ‘Ù†Ø§ØªÙ‡ Ù…Ù† Ø£ØµÙ†Ø§Ù ÙØ±Ø¹ÙŠÙ‘Ø©',0),(327774,9105,'fr','L\'inventaire Breakdown - fossÃ© principal Ã©lÃ©ment dans sous-composants',0),(327775,9105,'jp','åœ¨åº«è©³ç´° - ã‚µãƒ–ã‚³ãƒ³ãƒãƒ¼ãƒãƒ³ãƒˆã«åˆ†å‰²ã®ä¸»ãªé …ç›®',0),(327776,9105,'pt','Ruptura de estoque - divida o item principal em subcomponentes',0);
INSERT INTO `langdef` VALUES (327777,9105,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ° - Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ€Ð°Ð·Ñ€Ñ‹Ð²Ð° Ð² ÑÐ¾ÑÑ‚Ð°Ð²',0),(327778,9105,'es','Detalle de Inventario - Partir item principal a sub componentes',0),(327779,9105,'de','Inventory Breakdown - Hauptsache in Unterkomponenten unterteilen',0),(327780,9105,'en','Inventory Breakdown - divide main item into subcomponents',0),(327781,9106,'is','',0),(327782,9106,'dr','(ØªÙÙƒÙŠÙƒ) Ø¬Ù†Ø³',0),(327783,9106,'pr','Ø®Ø±Ø§Ø¨ÙŠ (ØªÙÙƒÙŠÙƒ) ÙƒØ§Ù„Ø§',0),(327784,9106,'tr','Maddenin krizi',0),(327785,9106,'pl','Element podziaÅ‚u',0),(327786,9106,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(327787,9106,'ur','Ø´Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚',0),(327788,9106,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» ÑÐ»Ð¾Ð¼',0),(327789,9106,'vi','PhÃ¢n chia hÃ ng',0),(327790,9106,'af','Item Ontleding',0),(327791,9106,'ro','Element de descompunere',0),(327792,9106,'et','Toote lÃµhkumine',0),(327793,9106,'si','Postavkah',0),(327794,9106,'ba','Rincian item',0),(327795,9106,'nl','Item verdeling',0),(327796,9106,'fi','Nimike-erittely',0),(327797,9106,'no','Elementet sammenbrudd',0),(327798,9106,'da','Vare opdeling',0),(327799,9106,'ko','í•­ëª© ë‚´ì—­',0),(327800,9106,'he','×”×ª×¤×œ×’×•×ª ×¤×¨×™×˜',0),(327801,9106,'el','Î ÏÎ¿Î²Î»Î­Ï€ÎµÎ¹ ÎºÎ±Ï„Î±Î½Î¿Î¼Î®',0),(327802,9106,'zh','é¡¹ç›®åˆ†é¡¹æ•°å­—\r\n',0),(327803,9106,'sv','Objektet uppdelning',0),(327804,9106,'it','Elemento di ripartizione',0),(327805,9106,'tl','',0),(327806,9106,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3648;&#3610;&#3619;&#3588;&#3604;&#3634;&#3623;&#3609;&#3660;',0),(327807,9106,'hi','à¤†à¤‡à¤Ÿà¤® à¤Ÿà¥‚à¤Ÿà¤¨à¥‡',0),(327808,9106,'ms','Pecahan perkara',0),(327809,9106,'ar','ØªÙÙƒÙŠÙƒ ØµÙ†Ù',0),(327810,9106,'fr','Point de rupture',0),(327811,9106,'jp','å“ç›®ã®è©³ç´°',0),(327812,9106,'pt','Item discriminaÃ§Ã£o',0),(327813,9106,'ru','Ð Ð°Ð·Ð±Ð¸Ð²ÐºÐ° Ð¿ÑƒÐ½ÐºÑ‚Ð°',0),(327814,9106,'es','Detalle de Item',0),(327815,9106,'de','Element-AufschlÃ¼sselung',0),(327816,9106,'en','Item Breakdown',0),(327817,9107,'is','',0),(327818,9107,'dr','(ØªÙØ§Ø¶Ù„ )  Ù‡Ø²ÙŠÙ†Ù‡ ',0),(327819,9107,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø§Ø®ØªÙ„Ø§Ù(ØªÙØ§Ø¶Ù„ )  Ù‡Ø²ÙŠÙ†Ù‡ ',0),(327820,9107,'tr','Maliyet farkÄ± hesaba GL',0),(327821,9107,'pl','GL konto za rÃ³Å¼nica kosztÃ³w',0),(327822,9107,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° Ñ€Ð°Ð·Ð»Ð¸ÐºÐ° Ð² Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(327823,9107,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù„Ø§Ú¯Øª ÙØ±Ù‚ Ú©Û’ Ù„ÛŒÛ’',0),(327824,9107,'sr','Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ñ€Ð°Ð·Ð»Ð¸ÐºÐ° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(327825,9107,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p cho giÃ¡ thÃ nh KhÃ¡c Nhau',0),(327826,9107,'af','AG Rekening vir Koste Verskil',0),(327827,9107,'ro','GL cont pentru diferenÅ£a de Cost',0),(327828,9107,'et','Maksumuse erinevus pearaamatukontole',0),(327829,9107,'si','GL raÄun za stroÅ¡ek razlika',0),(327830,9107,'ba','GL Account untuk perbedaan biaya',0),(327831,9107,'nl','GL Account voor kosten verschil',0),(327832,9107,'fi','Kirjanpitotilin pÃ¤Ã¤tilin kustannusero',0),(327833,9107,'no','GI-konto pris differansen',0),(327834,9107,'da','GL hensyn til pris forskellen',0),(327835,9107,'ko','ë¹„ìš©ëœ ì°¨ì´ ëŒ€ í•œ GL ê³„ì •',0),(327836,9107,'he','GL ×—×©×‘×•×Ÿ ×”×¤×¨×© ×¢×œ×•×ª',0),(327837,9107,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± Î´Î¹Î±Ï†Î¿ÏÎ¬ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(327838,9107,'zh','æ€»å¸å¸æˆ·çš„æˆæœ¬å·®å¼‚\r\n',0),(327839,9107,'sv','GL stÃ¥r fÃ¶r kostnaden skillnaden',0),(327840,9107,'it','Account GL per la differenza di costo',0),(327841,9107,'tl','',0),(327842,9107,'th','&#3592;&#3633;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3586;&#3629;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3607;&#3637;&#3656;&#3649;&#3',0),(327843,9107,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤²à¤¾à¤—à¤¤ à¤…à¤‚à¤¤à¤° à¤•à¥‡ à¤²à¤¿à¤',0),(327844,9107,'ms','Akaun GL untuk perbezaan kos',0),(327845,9107,'ar','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆÙ‚Ø§Øª Ø§Ù„ØªÙƒÙ„ÙØ© ÙÙŠ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(327846,9107,'fr','Compte GL pour la diffÃ©rence de coÃ»t',0),(327847,9107,'jp','ã‚³ã‚¹ãƒˆã®å·®ã‚’ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(327848,9107,'pt','GL conta para a diferenÃ§a de custo',0),(327849,9107,'ru','Ð¡Ñ‡ÐµÑ‚ GL Ð´Ð»Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ€Ð°Ð·Ð½Ð¸Ñ†Ð°',0),(327850,9107,'es','Cuenta de LM para Diferencia en el Costo',0),(327851,9107,'de','GL-entfallen Kosten Unterschied',0),(327852,9107,'en','GL Account for Cost Difference',0),(327853,9108,'is','',0),(327854,9108,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ØªØºÙŠÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(327855,9108,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ØªØºÙŠÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(327856,9108,'tr','Stok Alter maliyeti',0),(327857,9108,'pl','Koszty zmiany zapasÃ³w',0),(327858,9108,'bg','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(327859,9108,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Alter Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(327860,9108,'sr','ÐÐ»Ñ‚ÐµÑ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(327861,9108,'vi','Chá»‰nh Sá»­a GiÃ¡ ThÃ nh HÃ ng Kho',0),(327862,9108,'af','Inventaris Alter koste',0),(327863,9108,'ro','Costurile de Alter inventar',0),(327864,9108,'et','Varude Alter kulud',0),(327865,9108,'si','StroÅ¡ki popisa Alter',0),(327866,9108,'ba','Persediaan Alter biaya',0),(327867,9108,'nl','Alter voorraadkosten',0),(327868,9108,'fi','Alter varastokustannukset',0),(327869,9108,'no','Alter lagerkostnader',0),(327870,9108,'da','Alter lageromkostninger',0),(327871,9108,'ko','ìž¬ê³  ë³€ê²½ ë¹„ìš©',0),(327872,9108,'he','×¢×œ×•×™×•×ª ×”×ž×œ××™ ××œ×ª×¨',0),(327873,9108,'el','Alter ÎºÏŒÏƒÏ„Î¿Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚.',0),(327874,9108,'zh','é˜¿å°”ç‰¹åº“å­˜æˆæœ¬\r\n',0),(327875,9108,'sv','Alter lagerkostnader',0),(327876,9108,'it','Costi di magazzino Alter',0),(327877,9108,'tl','',0),(327878,9108,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;',0),(327879,9108,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤…à¥‰à¥‰à¤²à¥à¤Ÿà¤° à¤²à¤¾à¤—à¤¤',0),(327880,9108,'ms','Alter inventori bayaran',0),(327881,9108,'ar','ØªÙƒØ§Ù„ÙŠÙ ØªØºÙŠÙŠØ± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(327882,9108,'fr','CoÃ»ts d\'inventaire Alter',0),(327883,9108,'jp','åœ¨åº«å¤‰æ›´ã‚³ã‚¹ãƒˆ',0),(327884,9108,'pt','Custos de inventÃ¡rio Alter',0),(327885,9108,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Alter Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(327886,9108,'es','Costos de AlteraciÃ³n de Inventario',0),(327887,9108,'de','Alter Lagerkosten',0),(327888,9108,'en','Inventory Alter Costs',0),(327889,9109,'is','',0),(327890,9109,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØªØºÙŠÙŠØ±',0),(327891,9109,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØªØºÙŠÙŠØ±',0),(327892,9109,'tr','DeÄŸiÅŸim miktarÄ±na',0),(327893,9109,'pl','IloÅ›Ä‡ zmian',0),(327894,9109,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(327895,9109,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(327896,9109,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñƒ',0),(327897,9109,'vi','Sá»‘ lÆ°á»£ng Ä‘á»ƒ thay Ä‘á»•i',0),(327898,9109,'af','Hoeveelheid verandering',0),(327899,9109,'ro','Cantitatea de schimbare',0),(327900,9109,'et','Koguse muutus',0),(327901,9109,'si','KoliÄina spremembam',0),(327902,9109,'ba','Kuantitas untuk perubahan',0),(327903,9109,'nl','Hoeveelheid wijzigen',0),(327904,9109,'fi','MÃ¤Ã¤rÃ¤n muutos',0),(327905,9109,'no','Antall endring',0),(327906,9109,'da','MÃ¦ngde Ã¦ndring',0),(327907,9109,'ko','ìˆ˜ëŸ‰ ë³€ê²½ í•˜ê¸°',0),(327908,9109,'he','×›×ž×•×ª ×œ×©×™× ×•×™',0),(327909,9109,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± ÏƒÏ„Î·Î½ Î±Î»Î»Î±Î³Î®',0),(327910,9109,'zh','æ•°é‡å˜åŒ–\r\n',0),(327911,9109,'sv','Kvantitet till fÃ¶rÃ¤ndring',0),(327912,9109,'it','QuantitÃ  di cambiamento',0),(327913,9109,'tl','',0),(327914,9109,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;',0),(327915,9109,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(327916,9109,'ms','Kuantiti perubahan',0),(327917,9109,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ù„Ù„ØªØºÙŠÙŠØ±',0),(327918,9109,'fr','QuantitÃ© de changement',0),(327919,9109,'jp','æ•°é‡ã‚’å¤‰æ›´ã™ã‚‹',0),(327920,9109,'pt','Quantidade de mudanÃ§a',0),(327921,9109,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(327922,9109,'es','Cantidad para Cambiar',0),(327923,9109,'de','Menge Ã¤ndern',0),(327924,9109,'en','Quantity to Change',0),(327925,9110,'is','',0),(327926,9110,'dr','/ ÙƒØ³Ø± ÙƒØ±Ø¯Ù† Ø§Ø² Ø¬Ù†Ø³Ù‡Ø§ ',0),(327927,9110,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ú©Ù„ Ø¬Ù‡Øª Ø§ÙØ²ÙˆØ¯Ù†  / ÙƒØ³Ø± ÙƒØ±Ø¯Ù† Ø§Ø² ÙƒØ§Ù„Ø§Ù‡Ø§ ',0),(327928,9110,'tr','Eklemek/Ã§Ä±karmak iÃ§in toplam maliyet<br>Ã–ÄŸeleri',0),(327929,9110,'pl','CaÅ‚kowity koszt do dodaÄ‡ odliczenia<br>Z elementÃ³w',0),(327930,9110,'bg','ÐžÐ±Ñ‰Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð´Ð° ÑÐµ Ð´Ð¾Ð±Ð°Ð²Ð¸/Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°<br>ÐžÑ‚ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(327931,9110,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/Ú©Ø§Ù¹Ù†Ø§ Ú©ÛŒ Ú©Ù„ Ù„Ø§Ú¯Øª<br>Ø§Ø´ÛŒØ§Ø¡ Ø§Ø²',0),(327932,9110,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð·Ð° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð¾Ð´Ð±Ð¸Ñ˜Ð°ÑšÐµ<br>Ð˜Ð· ÑÑ‚Ð°Ð²ÐºÐµ',0),(327933,9110,'vi','Tá»•ng cá»™ng giÃ¡ thÃ nh cá»™ng vÃ o trá»« ra tá»« Ä‘Æ¡n hÃ ng',0),(327934,9110,'af','Totale Koste om Bymekaar te Tel / Aftrek vanaf Items',0),(327935,9110,'ro','Costul total pentru a adÄƒuga/deducere<br>De la articole',0),(327936,9110,'et','Kogumaksumus lisada/maha<br>Kirjed',0),(327937,9110,'si','Skupni stroÅ¡ek za dodajanje/odbitka<br>Iz postavk',0),(327938,9110,'ba','Total biaya untuk menambahkan/mengurangi<br>Dari item',0),(327939,9110,'nl','Totale kosten voor toevoegen/aftrekken<br>Van Items',0),(327940,9110,'fi','Kokonaiskustannukset lisÃ¤tÃ¤/vÃ¤hentÃ¤Ã¤<br>Kohteista',0),(327941,9110,'no','Totale kostnaden for Ã¥ legge til/trekke<br>Fra elementer',0),(327942,9110,'da','Samlede omkostninger til at tilfÃ¸je/trÃ¦kke<br>Fra elementer',0),(327943,9110,'ko','ì´ ë¹„ìš©ì„ ì¶”ê°€ ê³µì œ<br>í•­ëª©ì—ì„œ',0),(327944,9110,'he','×”×¢×œ×•×ª ×”×›×•×œ×œ×ª ×›×“×™ ×œ×”×•×¡×™×£/×œ×”×¤×—×™×ª<br>×¤×¨×™×˜×™×',0),(327945,9110,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚ Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎ¿Ï…Î½/Î±Ï†Î±Î¹ÏÎ­ÏƒÎ¿Ï…Î½<br>Î‘Ï€ÏŒ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(327946,9110,'zh','æ€»æˆæœ¬ä»Žé¡¹ç›®ä¸­æ·»åŠ /å‡åŽ»\r\n',0),(327947,9110,'sv','Total kostnad att lÃ¤gga till/dra<br>FrÃ¥n objekt',0),(327948,9110,'it','Costo totale per aggiungere/sottrarre<br>Da elementi',0),(327949,9110,'tl','',0),(327950,9110,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3607;&#3637;&#3656;&#3648;&#3614;&#3636;&#3656;&#3617;/&#3627;&#3633;&#3585;&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(327951,9110,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤˜à¤Ÿà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤² à¤²à¤¾à¤—à¤¤<br>à¤¸à¥‡ à¤†à¤‡à¤Ÿà¤®',0),(327952,9110,'ms','Jumlah kos untuk menambah/menolak<br>Daripada item-item',0),(327953,9110,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ© Ø¥Ø¶Ø§ÙØ© Ø£Ùˆ Ø®ØµÙ…<br>Ù…Ù† Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(327954,9110,'fr','CoÃ»t total Ã  ajouter/dÃ©duction<br>Des Ã©lÃ©ments',0),(327955,9110,'jp','è¿½åŠ æŽ§é™¤ã™ã‚‹ç·ã‚³ã‚¹ãƒˆ<br>é …ç›®ã‹ã‚‰',0),(327956,9110,'pt','Custo total para adicionar/deduzir<br>De itens',0),(327957,9110,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð²Ñ‹Ñ‡ÐµÑÑ‚ÑŒ<br>Ð˜Ð· ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(327958,9110,'es','Costo Total para Sumar/Restar de Los Items',0),(327959,9110,'de','Gesamtkosten hinzufÃ¼gen/abziehen<br>Von Elementen',0),(327960,9110,'en','Total Cost to Add/Deduct<br>From Items',0),(327961,9111,'is','',0),(327962,9111,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ØªØºÙŠÙŠØ± ÙƒØ§Ù„Ø§',0),(327963,9111,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ØªØºÙŠÙŠØ± ÙƒØ§Ù„Ø§',0),(327964,9111,'tr','Madde Alter maliyeti',0),(327965,9111,'pl','Koszty zmiany pozycji',0),(327966,9111,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Ð°Ð»Ñ‚ÐµÑ€ ÑÑ‚Ñ€ÑƒÐ²Ð°',0),(327967,9111,'ur','Ø´Û’ Alter Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(327968,9111,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° ÐÐ»Ñ‚ÐµÑ€',0),(327969,9111,'vi','HÃ ng Ä‘Ã£ sá»­a giÃ¡ thÃ nh',0),(327970,9111,'af','Item Kostes Gewysig',0),(327971,9111,'ro','Element Alter costurile',0),(327972,9111,'et','Kauba Alter maksab',0),(327973,9111,'si','StroÅ¡ke artikla Alter',0),(327974,9111,'ba','Item Alter biaya',0),(327975,9111,'nl','Item Alter kost',0),(327976,9111,'fi','Nimikkeen Alter maksaa',0),(327977,9111,'no','Elementet Alter koster',0),(327978,9111,'da','Vare Alter koster',0),(327979,9111,'ko','í•­ëª© ë³€ê²½ ë¹„ìš©',0),(327980,9111,'he','×¤×¨×™×˜ ×”×¤×™×¦×•×œ ×¢×•×œ×”',0),(327981,9111,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Alter ÎºÎ¿ÏƒÏ„Î¯Î¶ÎµÎ¹',0),(327982,9111,'zh','é¡¹ç›®é˜¿å°”ç‰¹æˆæœ¬\r\n',0),(327983,9111,'sv','Objektet Alter kostar',0),(327984,9111,'it','Elemento Alter costa',0),(327985,9111,'tl','',0),(327986,9111,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(327987,9111,'hi','à¤†à¤‡à¤Ÿà¤® à¤…à¥‰à¥‰à¤²à¥à¤Ÿà¤° à¤²à¤¾à¤—à¤¤',0),(327988,9111,'ms','Alter butiran bayaran',0),(327989,9111,'ar','ØªØºÙŠÙŠØ± Ø¹Ù†ØµØ± Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(327990,9111,'fr','Ã‰lÃ©ment Alter coÃ»te',0),(327991,9111,'jp','é …ç›®å¤‰æ›´ã‚’è²»ç”¨ã—ã¾ã™ã€‚',0),(327992,9111,'pt','Item Alter custa',0),(327993,9111,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Alter ÑÑ‚Ð¾Ð¸Ñ‚',0),(327994,9111,'es','Item Costos de AlteraciÃ³n',0),(327995,9111,'de','Element Alter kostet',0),(327996,9111,'en','Item Alter Costs',0),(327997,9112,'is','',0),(327998,9112,'dr','Ø¶Ø§ÙŠØ¹Ø§Øª Ø®Ø±Ø§Ø¨ÙŠ ÙƒØ§Ù„Ø§',0),(327999,9112,'pr','Ø¶Ø§ÙŠØ¹Ø§Øª Ø®Ø±Ø§Ø¨ÙŠ ÙƒØ§Ù„Ø§',0),(328000,9112,'tr','Maddenin krizi hurda',0),(328001,9112,'pl','Element podziaÅ‚u zÅ‚om',0),(328002,9112,'bg','Ð¢Ð¾Ñ‡ÐºÐ° Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ° ÑÐºÑ€Ð°Ð¿',0),(328003,9112,'ur','Ø´Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø³Ú©Ø±ÛŒÙ¾',0),(328004,9112,'sr','Ð¨ÐºÐ°Ñ€Ñ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° ÑÐ»Ð¾Ð¼',0),(328005,9112,'vi','HÃ ng chia pháº¿ liá»‡u',0),(328006,9112,'af','Item Ontleding Skraap',0),(328007,9112,'ro','Resturi de defalcare element',0),(328008,9112,'et','HooldusÃ¼ksuse jaotuse jÃ¤Ã¤gid',0),(328009,9112,'si','Element razÄlenitev ostanki',0),(328010,9112,'ba','Item Breakdown Scrap',0),(328011,9112,'nl','Item verdeling schroot',0),(328012,9112,'fi','Nimikkeen erittely romu',0),(328013,9112,'no','Elementet sammenbrudd skrap',0),(328014,9112,'da','Vare opdeling skrot',0),(328015,9112,'ko','í•­ëª© ë‚´ì—­ ìŠ¤í¬ëž©',0),(328016,9112,'he','×’×¨×•×˜××•×ª ×”×ª×¤×œ×’×•×ª ×¤×¨×™×˜',0),(328017,9112,'el','Î ÏÎ¿Î²Î»Î­Ï€ÎµÎ¹ ÎºÎ±Ï„Î±Î½Î¿Î¼Î® Î¸ÏÎ±ÏÏƒÎ¼Î±Ï„Î±',0),(328018,9112,'zh','é¡¹ç›®åˆ†é¡¹åºŸå¼ƒ\r\n',0),(328019,9112,'sv','Objektet uppdelning skrot',0),(328020,9112,'it','Elemento ripartizione rottami',0),(328021,9112,'tl','',0),(328022,9112,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3648;&#3610;&#3619;&#3588;&#3604;&#3634;&#3623;&#3609;&#3660;&#3648;&#3621;&#3655;&#3585;&#3609;&#3657;&#3629;&#3618;',0),(328023,9112,'hi','à¤†à¤‡à¤Ÿà¤® à¤Ÿà¥‚à¤Ÿ à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª',0),(328024,9112,'ms','Sekerap pecahan item',0),(328025,9112,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù†Ù‡ÙŠØ§Ø± Ø§Ù„Ø®Ø±Ø¯Ø©',0),(328026,9112,'fr','Question ventilation Scrap',0),(328027,9112,'jp','å“ç›®å†…è¨³ã‚¹ã‚¯ãƒ©ãƒƒãƒ—',0),(328028,9112,'pt','Sucata de discriminaÃ§Ã£o do item',0),(328029,9112,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÑƒ Ð»Ð¾Ð¼Ð°',0),(328030,9112,'es','Detalle de Item de Desechas',0),(328031,9112,'de','Element AufschlÃ¼sselung Schrott',0),(328032,9112,'en','Item Breakdown Scrap',0),(328033,9113,'is','',0),(328034,9113,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¶Ø§ÙŠØ¹Ø§Øª Ù…ÙˆØ§Ø¯ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø«Ø¨Øª Ø¬Ø¯Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(328035,9113,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¶Ø§ÙŠØ¹Ø§Øª Ù…ÙˆØ§Ø¯ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø«Ø¨Øª Ø¬Ø¯Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(328036,9113,'tr','Hurda ayrÄ± GL giriÅŸi deftere nakledebilir.',0),(328037,9113,'pl','Po zÅ‚om jako oddzielne GL wpis',0),(328038,9113,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð±Ñ€Ð°Ðº ÐºÐ°Ñ‚Ð¾ Ð¾Ñ‚Ð´ÐµÐ»ÐµÐ½ GL Ð·Ð°Ð¿Ð¸Ñ',0),(328039,9113,'ur','Ø§ÛŒÚ© Ø¹Ù„ÛŒØ­Ø¯Û Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø³Ú©Ø±ÛŒÙ¾ Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº',0),(328040,9113,'sr','ÐšÑšÐ¸Ð¶Ð¸Ñ‚Ð¸ ÑˆÐºÐ°Ñ€Ñ‚ ÐºÐ°Ð¾ Ð·Ð°ÑÐµÐ±Ð½Ðµ Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐ°',0),(328041,9113,'vi','Káº¿t chuyá»ƒn pháº¿ liá»‡u nhÆ° lÃ  má»™t bÃºt toÃ¡n sá»• cÃ¡i tá»•ng há»£p riÃªng biá»‡t',0),(328042,9113,'af','Pos Afvalmateriaal (Skroot) as \'n Aparte AG Inskrywing',0),(328043,9113,'ro','Fier vechi post ca o intrare separatÄƒ GL',0),(328044,9113,'et','Konteerima jÃ¤Ã¤gid eraldi GL kandena',0),(328045,9113,'si','Kot loÄene GL postavko knjiÅ¾iti izmet',0),(328046,9113,'ba','Scrap posting sebagai entri terpisah GL',0),(328047,9113,'nl','Kladje plaatsen als een aparte GL-fragment',0),(328048,9113,'fi','HÃ¤vikki kirjataan erillinen GL tapahtumana',0),(328049,9113,'no','Innlegget ditt som en separat GL-oppfÃ¸ring',0),(328050,9113,'da','BogfÃ¸rer skrot som en separat GL post',0),(328051,9113,'ko','ë³„ë„ GL í•­ëª©ìœ¼ë¡œ ê²Œì‹œë¬¼ ìŠ¤í¬ëž©',0),(328052,9113,'he','×¤×•×¡×˜ ×’×¨×•×˜××•×ª ×›×¢×¨×š × ×¤×¨×“ GL',0),(328053,9113,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÏ„Îµ Ï†ÏÏÎ± Ï‰Ï‚ Î¾ÎµÏ‡Ï‰ÏÎ¹ÏƒÏ„ÏŒ GL ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(328054,9113,'zh','å‘å¸ƒç¢Žç‰‡ä½œä¸ºä¸€ä¸ªå•ç‹¬æ€»å¸æ¡ç›®\r\n',0),(328055,9113,'sv','Post skrot som ett separat GL',0),(328056,9113,'it','Post rottami come voce separata GL',0),(328057,9113,'tl','',0),(328058,9113,'th','Post Scrap As A Separate GL Entry',0),(328059,9113,'hi','à¤à¤• à¤ªà¥ƒà¤¥à¤• GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤ªà¤¦ à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª',0),(328060,9113,'ms','Post sekerap sebagai satu penyertaan GL berasingan',0),(328061,9113,'ar','ØªØ±Ø­ÙŠÙ„ Ø§Ù„Ø®Ø±Ø¯Ø© ÙƒØ¥Ø¯Ø®Ø§Ù„ Ù…Ù†ÙØµÙ„ GL',0),(328062,9113,'fr','Scrap post comme une entrÃ©e distincte GL',0),(328063,9113,'jp','åˆ¥ã® GL ã‚¨ãƒ³ãƒˆãƒªã¨ã—ã¦ãƒã‚¹ãƒˆ ã‚¹ã‚¯ãƒ©ãƒƒãƒ—',0),(328064,9113,'pt','Sucata de post como uma entrada separada GL',0),(328065,9113,'ru','Ð›Ð¾Ð¼ Ð¿Ð¾ÑÑ‚ ÐºÐ°Ðº Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¾Ñ‚Ð´ÐµÐ»ÑŒÐ½Ð¾Ð¹ GL',0),(328066,9113,'es','Contabiliza Desechas Como Una Entrada LM Separada',0),(328067,9113,'de','Post Schrott als Separate GL Eintrag',0),(328068,9113,'en','Post Scrap As A Separate GL Entry',0),(328069,9114,'is','',0),(328070,9114,'dr','ØªÙˆØ²ÙŠØ¹ Ù‡Ø²ÙŠÙ†Ù‡ Ø¶Ø§ÙŠØ¹Ø§Øª Ø¨Ù‡ Ø¯ÙŠÚ¯Ø± ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø± Ø·Ø¨Ù‚ ÙˆØ²Ù† ',0),(328071,9114,'pr','ØªÙˆØ²ÙŠØ¹ Ù‡Ø²ÙŠÙ†Ù‡ Ø¶Ø§ÙŠØ¹Ø§Øª Ø¨Ù‡ Ø¯ÙŠÚ¯Ø± ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø± Ø·Ø¨Ù‚ ÙˆØ²Ù† ',0),(328072,9114,'tr','DiÄŸer Ã¶ÄŸelere gÃ¶re kilo hurda maliyet yaymak',0),(328073,9114,'pl','Rozprzestrzeniania siÄ™ koszt zÅ‚omu do innych elementÃ³w na podstawie wagi',0),(328074,9114,'bg','Ð Ð°Ð·Ð¿Ñ€Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð½Ð° ÑÐºÑ€Ð°Ð¿ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð´Ñ€ÑƒÐ³Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð° Ñ‚ÐµÐ³Ð»Ð¾Ñ‚Ð¾',0),(328075,9114,'ur','Ø³Ú©Ø±ÛŒÙ¾ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ù¾Ø± ÙˆØ²Ù† Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø± Ø¯ÛŒÚ¯Ø± Ø§Ø´ÛŒØ§ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú¾ÛŒÙ„ Ú¯Ø¦ÛŒ',0),(328076,9114,'sr','Ð¨Ð¸Ñ€Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÑˆÐºÐ°Ñ€Ñ‚Ð° Ñƒ Ð´Ñ€ÑƒÐ³Ð¸Ð¼ ÑÑ‚Ð°Ð²ÐºÐ°Ð¼Ð° Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ Ñ‚ÐµÐ¶Ð¸Ð½Ð°',0),(328077,9114,'vi','Chia phÃ­ pháº¿ liá»‡u cho cÃ¡c hÃ ng khÃ¡c dá»±a trÃªn trá»ng lÆ°á»£ng',0),(328078,9114,'af','Knipsel koste om ander Items gebaseer op gewig te versprei',0),(328079,9114,'ro','RÄƒspÃ¢ndirea resturi Cost pentru alte elemente pe bazÄƒ de greutate',0),(328080,9114,'et','Levinud vanaraua maksumus kaalu muude kirjetega',0),(328081,9114,'si','Å irjenje ostanki stroÅ¡kov za druge elemente, na podlagi teÅ¾e',0),(328082,9114,'ba','Menyebarkan Scrap biaya untuk barang-barang lainnya berdasarkan berat',0),(328083,9114,'nl','Verspreiden van schroot kosten aan andere artikelen op basis van gewicht',0),(328084,9114,'fi','Jakaa romu kustannuksia muihin eriin painon',0),(328085,9114,'no','Spre skrap kostnader til andre elementer basert pÃ¥ vekt',0),(328086,9114,'da','Sprede skrot omkostninger til andre varer, der er baseret pÃ¥ vÃ¦gt',0),(328087,9114,'ko','ë¬´ê²Œì— ë”°ë¼ ë‹¤ë¥¸ í•­ëª©ì— ìŠ¤í¬ëž© ë¹„ìš©ì„ í™•ì‚°',0),(328088,9114,'he','×œ×”×¤×™×¥ ××ª ×¢×œ×•×ª ×’×¨×•×˜××•×ª ×œ×¤×¨×™×˜×™× ××—×¨×™× ×¢×œ ×‘×¡×™×¡ ×ž×©×§×œ',0),(328089,9114,'el','Î•Î¾Î±Ï€Î»Ï‰Î¸ÎµÎ¯ Ï„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ Ï†ÏÏÎ±Ï‚ Î³Î¹Î± Î¬Î»Î»Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¿ Î²Î¬ÏÎ¿Ï‚',0),(328090,9114,'zh','åœ¨é‡é‡åŸºç¡€ä¸Šåˆ†é“ºåºŸæ–™æˆæœ¬åˆ°å…¶ä»–è´§å“\r\n',0),(328091,9114,'sv','Sprida skrot kostnad till andra poster baserat pÃ¥ vikt',0),(328092,9114,'it','Ripartire i costi rottami di altri oggetti basato sul peso',0),(328093,9114,'tl','',0),(328094,9114,'th','Spread Scrap Cost To Other Items Based On Weight',0),(328095,9114,'hi','à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª à¤²à¤¾à¤—à¤¤ à¤µà¤œà¤¨ à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤° à¤…à¤¨à¥à¤¯ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤«à¥ˆà¤²',0),(328096,9114,'ms','Menyebarkan sekerap kos untuk perkara-perkara lain yang berdasarkan berat badan',0),(328097,9114,'ar','ØªÙ†ØªØ´Ø± ØªÙƒÙ„ÙØ© Ø§Ù„Ø®Ø±Ø¯Ø© Ø¥Ù„Ù‰ Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„Ø£Ø®Ø±Ù‰ Ø§Ø³ØªÙ†Ø§Ø¯Ø§Ù‹ Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ²Ù†',0),(328098,9114,'fr','RÃ©pandre la ferraille coÃ»t pour d\'autres envois selon le poids',0),(328099,9114,'jp','é‡é‡ã«åŸºã¥ããã®ä»–ã®ã‚¢ã‚¤ãƒ†ãƒ ã‚’ã‚¹ã‚¯ãƒ©ãƒƒãƒ— ã‚³ã‚¹ãƒˆã‚’åºƒã’ã‚‹',0),(328100,9114,'pt','Espalhar o custo de sucata para outros itens com base no peso',0),(328101,9114,'ru','Ð Ð°ÑÐ¿Ñ€Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð»Ð¾Ð¼Ð° Ð½Ð° Ð´Ñ€ÑƒÐ³Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹, Ð¾ÑÐ½Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð½Ð° Ð²ÐµÑ',0),(328102,9114,'es','Regar Costos de Desechos a Otros Items Basados en el Peso',0),(328103,9114,'de','Schrott Kosten auf andere Elemente auf der Grundlage von Gewicht zu verbreiten',0),(328104,9114,'en','Spread Scrap Cost To Other Items Based On Weight',0),(328105,9115,'is','',0),(328106,9115,'dr','(Ø§ØµÙ„Ø§Ø­ ) Ù‡Ø²ÙŠÙ†Ù‡ ',0),(328107,9115,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ ØªØ¹Ø¯ÙŠÙ„ (Ø§ØµÙ„Ø§Ø­ ) Ù‡Ø²ÙŠÙ†Ù‡ ',0),(328108,9115,'tr','VarsayÄ±lan maliyet ayarlama hesabÄ±',0),(328109,9115,'pl','DomyÅ›lnie konto kosztÃ³w dostosowania',0),(328110,9115,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð¾ Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(328111,9115,'ur','Ø·Û’ Ø´Ø¯Û Ù„Ø§Ú¯Øª Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(328112,9115,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(328113,9115,'vi','TK Thay Äá»•i GiÃ¡ ThÃ nh Máº·c Äá»‹nh',0),(328114,9115,'af','Verstekte Koste Aansuiweringsrekening',0),(328115,9115,'ro','Cont ajustare Cost implicit',0),(328116,9115,'et','Vaikekonto kulude korrigeerimine',0),(328117,9115,'si','Privzeti raÄun stroÅ¡kov prilagoditve',0),(328118,9115,'ba','Akun bawaan penyesuaian biaya',0),(328119,9115,'nl','Standaardaccount kosten aanpassing',0),(328120,9115,'fi','Hinnan muutos oletustili',0),(328121,9115,'no','Standard kostnader Lagerjusteringskonto',0),(328122,9115,'da','Standard omkostninger reguleringskontoen',0),(328123,9115,'ko','ê¸°ë³¸ ë¹„ìš©ëœ ì¡°ì • ê³„ì •',0),(328124,9115,'he','×”×ª××ž×ª ×¢×œ×•×ª ×›×—×©×‘×•×Ÿ ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(328125,9115,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÎºÏŒÏƒÏ„Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚',0),(328126,9115,'zh','è¿çº¦æˆæœ¬è°ƒæ•´å¸æˆ·\r\n',0),(328127,9115,'sv','Standardkontot kostnad justering',0),(328128,9115,'it','Adeguamento costo Account predefinito',0),(328129,9115,'tl','',0),(328130,9115,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(328131,9115,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤²à¤¾à¤—à¤¤ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤–à¤¾à¤¤à¤¾',0),(328132,9115,'ms','Pelarasan kos akaun lalai',0),(328133,9115,'ar','Ø­Ø³Ø§Ø¨ ØªÙƒÙ„ÙØ© Ø§Ù„ØªÙƒÙŠÙ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(328134,9115,'fr','Compte des coÃ»ts d\'ajustement par dÃ©faut',0),(328135,9115,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆ ã‚³ã‚¹ãƒˆã®èª¿æ•´å‹˜å®š',0),(328136,9115,'pt','Conta de ajuste de custo padrÃ£o',0),(328137,9115,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(328138,9115,'es','Cuenta por Defecto de Ajuste de Costos',0),(328139,9115,'de','KostengÃ¼nstige Anpassung Standardkonto',0),(328140,9115,'en','Default Cost Adjustment Account',0),(328141,9116,'is','',0),(328142,9116,'dr','ÙŠÙƒ ÙƒØ§Ù„Ø§ Ùˆ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ÙŠØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆØ¯',0),(328143,9116,'pr','ÙŠÙƒ ÙƒØ§Ù„Ø§ Ùˆ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ÙŠØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆØ¯',0),(328144,9116,'tr','Bir Ã¶ÄŸe ve GL hesap seÃ§ilmelidir',0),(328145,9116,'pl','Musi byÄ‡ wybrany element i konto GL',0),(328146,9116,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¸ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½',0),(328147,9116,'ur','Ø§ÛŒÚ© Ø´Û’ Ø§ÙˆØ± Ø§ÛŒÚ© Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©ÛŒØ§ Ø¬Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(328148,9116,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð¸ Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½',0),(328149,9116,'vi','Pháº£i Chá»n 1 Má»¥c & Má»™t TK Sá»• CÃ¡i Tá»•ng Há»£p',0),(328150,9116,'af','\'n Item en \'n AG Rekening Moet Gekies word',0),(328151,9116,'ro','Trebuie ales un element ÅŸi un cont de GL',0),(328152,9116,'et','Toode ja PR konto peavad olema valitud',0),(328153,9116,'si','Element in GL raÄun je treba izbrati',0),(328154,9116,'ba','Item dan GL Account harus dipilih',0),(328155,9116,'nl','Een Item en een GL-Account moeten worden gekozen',0),(328156,9116,'fi','Nimikkeen ja Kirjanpitotilin pÃ¤Ã¤tilin on valittava',0),(328157,9116,'no','Et element og en GL-konto mÃ¥ velges',0),(328158,9116,'da','En vare og en GL konto skal vÃ¦lges',0),(328159,9116,'ko','í•­ëª© ë° GL ê³„ì •ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(328160,9116,'he','×¤×¨×™×˜ ×•×—×©×‘×•×Ÿ GL ×œ×”×™×‘×—×¨',0),(328161,9116,'el','ÎˆÎ½Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÎ±Î¹ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î», Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(328162,9116,'zh','å¿…é¡»é€‰æ‹©ä¸€ä¸ªé¡¹ç›®å’Œä¸€ä¸ªæ€»å¸\r\n',0),(328163,9116,'sv','Ett objekt och ett GL-konto mÃ¥ste vÃ¤ljas',0),(328164,9116,'it','Deve essere scelto un elemento e un Account GL',0),(328165,9116,'tl','',0),(328166,9116,'th','&#3605;&#3657;&#3629;&#3591;&#3648;&#3621;&#3636;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3621;&#3632;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(328167,9116,'hi','à¤à¤• à¤†à¤‡à¤Ÿà¤® à¤”à¤° à¤à¤• GL à¤–à¤¾à¤¤à¥‡ à¤šà¥à¤¨à¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(328168,9116,'ms','Item dan akaun GL mestilah dipilih',0),(328169,9116,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø¥Ø®ØªÙŠØ§Ø± ØµÙ†Ù Ùˆ Ø­Ø³Ø§Ø¨ Ø£Ø³ØªØ§Ø° Ø¹Ø§Ù…',0),(328170,9116,'fr','Un Ã©lÃ©ment et un compte GL sont choisis',0),(328171,9116,'jp','é …ç›®ãŠã‚ˆã³ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(328172,9116,'pt','Um Item e uma conta GL devem ser escolhidos',0),(328173,9116,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ GL',0),(328174,9116,'es','Un Item y una Cuenta LM se Debe Seleccionar',0),(328175,9116,'de','Ein Element und ein GL-Konto mÃ¼ssen gewÃ¤hlt werden',0),(328176,9116,'en','An Item and a GL Account Must Be Chosen',0),(328177,9117,'is','',0),(328178,9117,'dr','Ø§ØµÙ„Ø§Ø­Ø§Øª Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(328179,9117,'pr','Ø§ØµÙ„Ø§Ø­Ø§Øª Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(328180,9117,'tr','Stok Maliyet ayarlamalarÄ±',0),(328181,9117,'pl','Koszt korekty magazynu',0),(328182,9117,'bg','Ð¦ÐµÐ½Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°',0),(328183,9117,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù„Ø§Ú¯Øª Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(328184,9117,'sr','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(328185,9117,'vi','Chá»‰nh Sá»­a GiÃ¡ HÃ ng Trong Kho',0),(328186,9117,'af','Inventaris Aankoop Aansuiwerings',0),(328187,9117,'ro','AjustÄƒrile de stocuri de Cost',0),(328188,9117,'et','Varude maksumuse korrigeerimised',0),(328189,9117,'si','Popravki vrednosti zaloge stroÅ¡ek',0),(328190,9117,'ba','Penyesuaian biaya persediaan',0),(328191,9117,'nl','Kosten voorraadherwaarderingen',0),(328192,9117,'fi','Varaston kustannusten muutokset',0),(328193,9117,'no','Kostnader lagerjusteringer',0),(328194,9117,'da','Omkostninger lagerreguleringer',0),(328195,9117,'ko','ìž¬ê³  ë¹„ìš©ëœ ì¡°ì •',0),(328196,9117,'he','×”×ª××ž×•×ª ×¢×œ×•×ª ×”×ž×œ××™',0),(328197,9117,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(328198,9117,'zh','åº“å­˜æˆæœ¬è°ƒæ•´\r\n',0),(328199,9117,'sv','Kostnad lagerjusteringar',0),(328200,9117,'it','Rettifiche di costo di magazzino',0),(328201,9117,'tl','',0),(328202,9117,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(328203,9117,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤²à¤¾à¤—à¤¤ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(328204,9117,'ms','Pelarasan kos inventori',0),(328205,9117,'ar','ØªØ³ÙˆÙŠØ§Øª ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(328206,9117,'fr','Rajustements de coÃ»t des stocks',0),(328207,9117,'jp','åœ¨åº«ã‚³ã‚¹ãƒˆèª¿æ•´',0),(328208,9117,'pt','Ajustes de custo de inventÃ¡rio',0),(328209,9117,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(328210,9117,'es','Ajustes en los Costos de Inventario',0),(328211,9117,'de','Kosten Lagerregulierungen',0),(328212,9117,'en','Inventory Cost Adjustments',0),(328213,9118,'is','',0),(328214,9118,'dr','ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ØµÙ„Ø§Ø­ Ø´Ø¯ ',0),(328215,9118,'pr','ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ØµÙ„Ø§Ø­ Ø´Ø¯ ',0),(328216,9118,'tr','Madde baÅŸarÄ±yla ayarlandÄ±',0),(328217,9118,'pl','Pozycja skorygowana pomyÅ›lnie',0),(328218,9118,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ»Ð° ÐºÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(328219,9118,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚˆØ¬Ø³Ù¹ Ø´Û’',0),(328220,9118,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ»Ð° ÐºÐ¾Ñ€Ð¸Ð³Ð¾Ð²Ð°Ð½ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(328221,9118,'vi','Chá»‰nh hÃ ng thÃ nh cÃ´ng',0),(328222,9118,'af','Item suksesvol Aangepas',0),(328223,9118,'ro','Elementul ajustat cu succes',0),(328224,9118,'et','Toode kohandatud edukalt',0),(328225,9118,'si','Element, ki se uspeÅ¡no prilagodi',0),(328226,9118,'ba','Item disesuaikan berhasil',0),(328227,9118,'nl','Object met succes aangepast',0),(328228,9118,'fi','Nimikkeen sÃ¤Ã¤tÃ¤Ã¤ onnistuneesti',0),(328229,9118,'no','Elementet justert vellykket',0),(328230,9118,'da','Element justeret med succes',0),(328231,9118,'ko','í•­ëª©ì´ ì„±ê³µì ìœ¼ë¡œ ì¡°ì •',0),(328232,9118,'he','×¤×¨×™×˜ ×ž×•×ª×× ×‘×”×¦×œ×—×”',0),(328233,9118,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î¿Ï… Ï€ÏÎ¿ÏƒÎ±ÏÎ¼ÏŒÎ¶ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(328234,9118,'zh','é¡¹ç›®è°ƒæ•´æˆåŠŸ\r\n',0),(328235,9118,'sv','Objektet justeras framgÃ¥ngsrikt',0),(328236,9118,'it','Elemento regolato correttamente',0),(328237,9118,'tl','',0),(328238,9118,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(328239,9118,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤',0),(328240,9118,'ms','Item yang diselaraskan berjaya',0),(328241,9118,'ar','Ø§Ù„Ø¨Ù†Ø¯ ØªØ¹Ø¯ÙŠÙ„Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(328242,9118,'fr','Point rÃ©glÃ© avec succÃ¨s',0),(328243,9118,'jp','é …ç›®ãŒæ­£å¸¸ã«èª¿æ•´',0),(328244,9118,'pt','Item ajustado com sucesso',0),(328245,9118,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð°',0),(328246,9118,'es','Item Ajustado Exitosamente',0),(328247,9118,'de','Element erfolgreich angepasst',0),(328248,9118,'en','Item Adjusted Successfully',0),(328249,9119,'is','',0),(328250,9119,'dr','ØªØ¹Ø¯Ø§Ø¯ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ØªØ­Øª ØªØ§Ø«ÙŠØ±',0),(328251,9119,'pr','ØªØ¹Ø¯Ø§Ø¯ ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ØªØ­Øª ØªØ§Ø«ÙŠØ±',0),(328252,9119,'tr','Ã–ÄŸe sayÄ±sÄ±<br>Etkilenen',0),(328253,9119,'pl','# elementÃ³w<br>WpÅ‚yw',0),(328254,9119,'bg','# Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸<br>Ð—Ð°ÑÐµÐ³Ð½Ð°Ñ‚Ð¸',0),(328255,9119,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ #<br>Ù…ØªØ§Ø«Ø±',0),(328256,9119,'sr','# ÑÑ‚Ð°Ð²ÐºÐ¸<br>Ð£Ñ‚Ð¸Ñ†Ð°Ð¾ Ð½Ð°',0),(328257,9119,'vi','Sá»‘ hÃ ng bá»‹ áº£nh hÆ°á»Ÿng',0),(328258,9119,'af','# Items Geaffekteer',0),(328259,9119,'ro','# de articole<br>Afectate',0),(328260,9119,'et','# Teemad<br>MÃµjutatud',0),(328261,9119,'si','# elementov<br>Prizadeti',0),(328262,9119,'ba','# item<br>Terpengaruh',0),(328263,9119,'nl','# van Items<br>Getroffen',0),(328264,9119,'fi','# Kohteet<br>Vaikuttaa',0),(328265,9119,'no','antall elementer<br>BerÃ¸rt',0),(328266,9119,'da','# af elementer<br>PÃ¥virket',0),(328267,9119,'ko','í•­ëª© #<br>ì˜í–¥ì„ ë°›ëŠ”',0),(328268,9119,'he','# ×©×œ ×¤×¨×™×˜×™×<br>×ž×•×©×¤×¢×•×ª',0),(328269,9119,'el','# Ï„Ï‰Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½<br>Î•Ï€Î·ÏÎµÎ¬Î¶Î¿Î½Ï„Î±Î¹',0),(328270,9119,'zh','å¯¹å—å½±å“çš„é¡¹ç›®æ•°\r\n',0),(328271,9119,'sv','# av objekt<br>PÃ¥verkas',0),(328272,9119,'it','# di elementi<br>Colpite',0),(328273,9119,'tl','',0),(328274,9119,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3612;&#3621;&#3585;&#3619;&#3632;&#3607;&#3610;',0),(328275,9119,'hi','à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥€ #<br>à¤ªà¥à¤°à¤­à¤¾à¤µà¤¿à¤¤',0),(328276,9119,'ms','# item-item<br>Terjejas',0),(328277,9119,'ar','# Ø¹Ù†Ø§ØµØ±<br>Ø§Ù„Ù…ØªØ¶Ø±Ø±Ø©',0),(328278,9119,'fr','Nbre d\'Ã©lÃ©ments<br>TouchÃ©s',0),(328279,9119,'jp','ï¼ƒ ã®é …ç›®<br>å½±éŸ¿ã‚’å—ã‘ã‚‹',0),(328280,9119,'pt','n Âº de itens<br>Afetados',0),(328281,9119,'ru','ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²<br>ÐŸÐ¾ÑÑ‚Ñ€Ð°Ð´Ð°Ð²ÑˆÐ¸Ñ…',0),(328282,9119,'es','# de Items Afectados',0),(328283,9119,'de','Anzahl der Elemente<br>Betroffen',0),(328284,9119,'en','# of Items<br>Affected',0),(328285,9120,'is','',0),(328286,9120,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØªØºÙŠÙŠØ± Ùˆ Ø¨Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ù„ Ù†Ø¨Ø§ÙŠØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(328287,9120,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØªØºÙŠÙŠØ± Ùˆ Ø¨Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ù„ Ù†Ø¨Ø§ÙŠØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(328288,9120,'tr','# BileÅŸen etkilenen ve toplam maliyet sÄ±fÄ±r olmalÄ±dÄ±r',0),(328289,9120,'pl','Liczba elementÃ³w dotkniÄ™tych i caÅ‚kowity koszt nie moÅ¼e byÄ‡ Zero',0),(328290,9120,'bg','# Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð°ÑÐµÐ³Ð½Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¸ Ð¾Ð±Ñ‰Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ð½ÑƒÐ»Ð°',0),(328291,9120,'ur','# Ø§Ø´ÛŒØ§Ø¡ Ù…ØªØ§Ø«Ø±Û Ø§ÙˆØ± Ú©Ù„ Ù„Ø§Ú¯Øª ØµÙØ± Ù†ÛÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(328292,9120,'sr','# Ð¾Ð´ Ð¿Ð¾Ð³Ð¾Ñ’ÐµÐ½Ð¸Ñ… Ð¸ ÑƒÐºÑƒÐ¿Ð°Ð½ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº ÑÑ‚Ð°Ð²ÐºÐµ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð½ÑƒÐ»Ð°',0),(328293,9120,'vi','Sá»‘ hÃ ng bá»‹ áº£nh hÆ°á»Ÿng & tá»•ng giÃ¡ thÃ nh khÃ´ng thá»ƒ báº±ng khÃ´ng',0),(328294,9120,'af','# van Items geraak en totale koste moet nul wees nie',0),(328295,9120,'ro','# de elementele afectate si Total Cost nu trebuie sÄƒ fie Zero',0),(328296,9120,'et','# Kaupade mÃµjutatud ja kogukulu peab olema null',0),(328297,9120,'si','# Elemente prizadetih in skupni stroÅ¡ki ne smejo biti niÄ',0),(328298,9120,'ba','# Item terkena dan Total biaya tidak harus nol',0),(328299,9120,'nl','# van onderdelen waarin dit probleem optreedt en totale kosten moet niet nul',0),(328300,9120,'fi','# Kohteita vaikuttaa ja yhteensÃ¤ kustannukset ei saa olla nolla',0),(328301,9120,'no','antall elementer berÃ¸rt og totale kostnader kan ikke vÃ¦re null',0),(328302,9120,'da','# Emner berÃ¸rt og samlede omkostninger mÃ¥ ikke vÃ¦re nul',0),(328303,9120,'ko','# í•­ëª© ì˜í–¥ì„ ë°›ëŠ” ë° ì´ ë¹„ìš©ì˜ 0 í•´ì„œëŠ” ì•ˆ',0),(328304,9120,'he','# ×©×œ ×¢×œ×•×ª ×”×ž×•×©×¤×¢×ª, ×”×›×•×œ×œ ×¤×¨×™×˜×™× ××™× ×” ×™×›×•×œ×” ×œ×”×™×•×ª ××¤×¡',0),(328305,9120,'el','# Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± ÎµÏ€Î·ÏÎµÎ¬Î¶Î¿Î½Ï„Î±Î¹ ÎºÎ±Î¹ ÏƒÏ…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚ Î´ÎµÎ½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼Î·Î´Î­Î½',0),(328306,9120,'zh','å¯¹å—å½±å“çš„é¡¹ç›®å’Œæ€»è´¹ç”¨å¿…é¡»ä¸ä¸º0ï¼ƒ\r\n',0),(328307,9120,'sv','# av objekt pÃ¥verkas och Total kostnad fÃ¥r inte vara noll',0),(328308,9120,'it','# di oggetti commoventi e totale costo non deve essere Zero',0),(328309,9120,'tl','',0),(328310,9120,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3617;&#3637;&#3612;&#3621;&#3585;&#3619;&#3632;&#3607;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3649;&#3621;&#3632;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3619;&#3623;&#3617;&#3605;&#3',0),(328311,9120,'hi','# à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤­à¤¾à¤µà¤¿à¤¤ à¤”à¤° à¤•à¥à¤² à¤²à¤¾à¤—à¤¤ à¤•à¤¾ à¤¶à¥‚à¤¨à¥à¤¯ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(328312,9120,'ms','# kos terlibat dan jumlah item hendaklah tidak sifar',0),(328313,9120,'ar','# Ù…Ù† Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…ØªØ£Ø«Ø±Ø© ÙˆÙ…Ø¬Ù…ÙˆØ¹ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ ÙŠØ¬Ø¨ Ø£Ù† Ù„Ø§ ØªÙƒÙˆÙ† ØµÙØ±Ø§Ù‹',0),(328314,9120,'fr','nombre de points touchÃ©s et Total des coÃ»ts ne doit pas Ãªtre zÃ©ro',0),(328315,9120,'jp','ï¼ƒ ã®é …ç›®ã®å½±éŸ¿ã‚’å—ã‘ã‚‹ã¨ç·ã‚³ã‚¹ãƒˆã¯ã‚¼ãƒ­ã§ãªã‘ã‚Œã°ãªã‚Šã¾ã›ã‚“',0),(328316,9120,'pt','n Âº de itens afetados e Total custo nÃ£o deve ser Zero',0),(328317,9120,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾ÑÑ‚Ñ€Ð°Ð´Ð°Ð²ÑˆÐ¸Ñ… Ð¸ Ð¾Ð±Ñ‰Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð¾Ð² Ð½Ðµ Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð²Ð½Ð¾ Ð½ÑƒÐ»ÑŽ',0),(328318,9120,'es','# de Items Afectados y Costo Total No Debe Ser Zero',0),(328319,9120,'de','Anzahl der betroffenen und Total Artikelkosten darf nicht NULL sein.',0),(328320,9120,'en','# of Items Affected and Total Cost Must Not Be Zero',0),(328321,9121,'is','',0),(328322,9121,'dr','(Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú¯Ø¯Ø§Ù…',0),(328323,9121,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØªØºÙŠÙŠØ±Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…(Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±',0),(328324,9121,'tr','# Etkilenen Ã¶ÄŸeleri eldeki miktardan daha bÃ¼yÃ¼k olamaz',0),(328325,9121,'pl','# elementÃ³w wpÅ‚yw nie moÅ¼e byÄ‡ wiÄ™ksza niÅ¼ iloÅ›Ä‡ na strony',0),(328326,9121,'bg','# Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð°ÑÐµÐ³Ð½Ð°Ñ‚Ð¸ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ð¾-Ð³Ð¾Ð»ÑÐ¼Ð¾ Ð¾Ñ‚ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° Ñ€ÑŠÐºÐ°',0),(328327,9121,'ur','# Ù…ØªØ§Ø«Ø±Û Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ø¬Ø§Ù†Ø¨ Ù…Ù‚Ø¯Ø§Ø± Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø¨Ú‘Ø§ Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©ØªØ§',0),(328328,9121,'sr','# ÑÑ‚Ð°Ð²ÐºÐ¸ ÑƒÑ‚Ð¸Ñ‡Ðµ Ð½Ð° Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð²ÐµÑ›Ð¸ Ð¾Ð´ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(328329,9121,'vi','Sá»‘ cá»§a hÃ ng áº£nh hÆ°á»Ÿng khÃ´ng thá»ƒ lá»›n hÆ¡n Sá»‘ lÆ°á»£ng cÃ³ sáºµn',0),(328330,9121,'af','# items geraak kan word nie groter hoeveelheid aan kant',0),(328331,9121,'ro','# de articole afectate nu poate fi mai mare decÃ¢t cantitatea pe o parte',0),(328332,9121,'et','# MÃµjutatud Ã¼ksused ei tohi olla suurem kui kogus kÃ¤si',0),(328333,9121,'si','# Prizadeti elementi ne sme biti veÄja od koliÄine na strani',0),(328334,9121,'ba','# item yang terkena tidak dapat lebih besar daripada kuantitas di tangan',0),(328335,9121,'nl','# van Items beÃ¯nvloed kan niet groter zijn dan de hoeveelheid aan kant',0),(328336,9121,'fi','# Kohteista, joihin ei voi olla suurempi kuin mÃ¤Ã¤rÃ¤ kÃ¤sillÃ¤',0),(328337,9121,'no','# av varene som pÃ¥virkes ikke vÃ¦re stÃ¸rre enn antall pÃ¥ side',0),(328338,9121,'da','# af emner berÃ¸rt mÃ¥ ikke vÃ¦re stÃ¸rre end antallet pÃ¥ side',0),(328339,9121,'ko','ì˜í–¥ì„ ë°›ëŠ” í•­ëª©ì˜ # í•œíŽ¸ ìˆ˜ëŸ‰ ë³´ë‹¤ í´ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(328340,9121,'he','# ×©×œ ×¤×¨×™×˜×™× ×ž×•×©×¤×¢×•×ª ××™× ×” ×™×›×•×œ×” ×œ×”×™×•×ª ×’×“×•×œ×” ×ž×”×›×ž×•×ª ×¢×œ ×™×“',0),(328341,9121,'el','# Ï„Ï‰Î½ Î±Î½Ï„Î¹ÎºÎµÎ¹Î¼Î­Î½Ï‰Î½ Ï€Î¿Ï… ÎµÏ€Î·ÏÎµÎ¬Î¶Î¿Î½Ï„Î±Î¹ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼ÎµÎ³Î±Î»ÏÏ„ÎµÏÎ· Î±Ï€ÏŒ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Ï†',0),(328342,9121,'zh','ï¼ƒçš„å—å½±å“çš„é¡¹ç›®ä¸èƒ½æ¯”çŽ°æœ‰æ•°é‡å¤š\r\n',0),(328343,9121,'sv','# objekt pÃ¥verkas inte vara stÃ¶rre Ã¤n kvantitet Ã¥',0),(328344,9121,'it','# di elementi interessati non puÃ² essere maggiore quantitÃ  d\' parte',0),(328345,9121,'tl','',0),(328346,9121,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3617;&#3637;&#3612;&#3621;&#3585;&#3619;&#3632;&#3607;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3617;&#3634;&#3585;&#3585;&#3',0),(328347,9121,'hi','# à¤ªà¥à¤°à¤­à¤¾à¤µà¤¿à¤¤ à¤®à¤¦à¥‹à¤‚ à¤•à¥‡ à¤¹à¤¾à¤¥ à¤ªà¤° à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¥€',0),(328348,9121,'ms','# item-item yang terlibat tidak boleh lebih besar daripada kuantiti di tangan',0),(328349,9121,'ar','# Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…ØªØ£Ø«Ø±Ø© Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ÙŠÙƒÙˆÙ† Ø£ÙƒØ¨Ø± Ù…Ù† Ø§Ù„ÙƒÙ…ÙŠØ© Ù…Ù† Ù†Ø§Ø­ÙŠØ©',0),(328350,9121,'fr','Nbre d\'Ã©lÃ©ments affectÃ©s ne peut pas Ãªtre supÃ©rieure Ã  la quantitÃ© sur place',0),(328351,9121,'jp','å½±éŸ¿ã‚’å—ã‘ãŸé …ç›®ã®æ•°ã¯ä¸€æ–¹ã§æ•°é‡ã‚ˆã‚Šã‚‚å¤§ãã„ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(328352,9121,'pt','n Âº de itens afetados nÃ£o pode ser maior do que a quantidade por lado',0),(328353,9121,'ru','# ÐŸÐ¾ÑÑ‚Ñ€Ð°Ð´Ð°Ð²ÑˆÐ¸Ñ… ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð±Ð¾Ð»ÑŒÑˆÐµ, Ñ‡ÐµÐ¼ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð´ Ñ€ÑƒÐºÐ¾Ð¹',0),(328354,9121,'es','# de Items Afectados No Debe Ser MÃ¡s que la Cantidad en Mano',0),(328355,9121,'de','Anzahl der Elemente, die betroffenen sein nicht auf Seite grÃ¶ÃŸer als Menge.',0),(328356,9121,'en','# of Items Affected Cannot Be Greater Than Quantity On Hand',0),(328357,9122,'is','',0),(328358,9122,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØªØºÙŠÙŠØ± Ø¨Ø§ÙŠØ¯ Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(328359,9122,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ØªØºÙŠÙŠØ± Ø¨Ø§ÙŠØ¯ Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(328360,9122,'tr','Etkilenen bileÅŸen sayÄ±sÄ± sÄ±fÄ±rdan bÃ¼yÃ¼k olmalÄ±dÄ±r',0),(328361,9122,'pl','# WpÅ‚yw elementÃ³w musi byÄ‡ wiÄ™ksza niÅ¼ Zero',0),(328362,9122,'bg','# Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð°ÑÐµÐ³Ð½Ð°Ñ‚Ð¸ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ð¾-Ð³Ð¾Ð»ÑÐ¼Ð¾ Ð¾Ñ‚ Ð½ÑƒÐ»Ð°',0),(328363,9122,'ur','# Ù…ØªØ§Ø«Ø±Û Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ ØµÙØ± Ø³Û’ Ø¨Ú‘Ø§ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(328364,9122,'sr','# ÑÑ‚Ð°Ð²ÐºÐ¸ ÑƒÑ‚Ð¸Ñ‡Ðµ Ð½Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð²ÐµÑ›Ð¸ Ð¾Ð´ Ð½ÑƒÐ»Ðµ',0),(328365,9122,'vi','Sá»‘ cá»§a hÃ ng áº£nh hÆ°á»Ÿng pháº£i lá»›n hÆ¡n Zero ',0),(328366,9122,'af','# items geraak moet meer as nul wees',0),(328367,9122,'ro','# de articole afectate trebuie sÄƒ fie mai mare decÃ¢t Zero',0),(328368,9122,'et','# MÃµjutatud Ã¼ksus peab olema suurem kui null',0),(328369,9122,'si','# Prizadeti elementi mora biti veÄje kot niÄ.',0),(328370,9122,'ba','# item yang terkena dampak harus lebih besar dari nol',0),(328371,9122,'nl','# van Items getroffen moet groter zijn dan nul',0),(328372,9122,'fi','# Kohteista, joihin on oltava suurempi kuin nolla',0),(328373,9122,'no','antall elementer pÃ¥virket mÃ¥ vÃ¦re stÃ¸rre enn null',0),(328374,9122,'da','# af emner berÃ¸rt skal vÃ¦re stÃ¸rre end nul',0),(328375,9122,'ko','ì˜í–¥ì„ ë°›ëŠ” í•­ëª© # 0 ë³´ë‹¤ ì»¤ì•¼ í•©ë‹ˆë‹¤.',0),(328376,9122,'he','# ×©×œ ×¤×¨×™×˜×™× ×ž×•×©×¤×¢×•×ª ×—×™×™×‘ ×œ×”×™×•×ª ×’×“×•×œ ×ž××¤×¡',0),(328377,9122,'el','# Ï„Î¿Ï… Î¸Î­ÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… ÎµÏ€Î»Î®Î³Î·ÏƒÎ±Î½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼ÎµÎ³Î±Î»ÏÏ„ÎµÏÎ· Ï„Î¿Ï… Î¼Î·Î´ÎµÎ½ÏŒÏ‚',0),(328378,9122,'zh','ï¼ƒçš„å—å½±å“é¡¹ç›®å¿…é¡»å¤§äºŽé›¶\r\n',0),(328379,9122,'sv','# objekt pÃ¥verkas mÃ¥ste vara stÃ¶rre Ã¤n noll',0),(328380,9122,'it','# di elementi interessati deve essere maggiore di Zero',0),(328381,9122,'tl','',0),(328382,9122,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3617;&#3637;&#3612;&#3621;&#3585;&#3619;&#3632;&#3607;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3605;&#3657;&#3629;&#3591;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634;&#3624;&#3641;&#3',0),(328383,9122,'hi','# à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤­à¤¾à¤µà¤¿à¤¤ à¤•à¤¾ à¤¶à¥‚à¤¨à¥à¤¯ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(328384,9122,'ms','# item-item yang terlibat mesti lebih besar dari sifar',0),(328385,9122,'ar','# Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…ØªØ£Ø«Ø±Ø© ÙŠØ¬Ø¨ Ø£Ù† ØªÙƒÙˆÙ† Ø£ÙƒØ¨Ø± Ù…Ù† Ø§Ù„ØµÙØ±',0),(328386,9122,'fr','Nbre d\'Ã©lÃ©ments affectÃ©s doit Ãªtre supÃ©rieur Ã  zÃ©ro',0),(328387,9122,'jp','å½±éŸ¿ã‚’å—ã‘ãŸé …ç›®ã®æ•°ãŒ 0 ã‚ˆã‚Šå¤§ãããªã‘ã‚Œã°ãªã‚Šã¾ã›ã‚“',0),(328388,9122,'pt','n Âº de itens afetados deve ser maior que Zero',0),(328389,9122,'ru','# Ð—Ð°Ñ‚Ñ€Ð°Ð³Ð¸Ð²Ð°ÐµÐ¼Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ Ð±Ð¾Ð»ÑŒÑˆÐµ Ð½ÑƒÐ»Ñ',0),(328390,9122,'es','# de Items Afectados Debe Ser MÃ¡s Que Zero',0),(328391,9122,'de','Anzahl der Elemente, die betroffenen mÃ¼ssen grÃ¶ÃŸer als NULL sein.',0),(328392,9122,'en','# of Items Affected Must Be Greater Than Zero',0),(328393,9123,'is','',0),(328394,9123,'dr','Ø§ØµÙ„Ø§Ø­Ø§Øª Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ ',0),(328395,9123,'pr','Ø§ØµÙ„Ø§Ø­Ø§Øª Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ù„Ø§ ',0),(328396,9123,'tr','Madde maliyet ayarlamalarÄ±',0),(328397,9123,'pl','Element kosztÃ³w dostosowania',0),(328398,9123,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Ñ†ÐµÐ½Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸',0),(328399,9123,'ur','Ø´Û’ Ù„Ø§Ú¯Øª Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(328400,9123,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’Ð°Ð²Ð°ÑšÐ°',0),(328401,9123,'vi','HÃ ng Ä‘Ã£ sá»­a giÃ¡ thÃ nh',0),(328402,9123,'af','Item Koste Aansuiwerings',0),(328403,9123,'ro','Element de Cost ajustÄƒri',0),(328404,9123,'et','Toodete hindade kohandamine',0),(328405,9123,'si','Element stroÅ¡kov prilagoditve',0),(328406,9123,'ba','Item biaya penyesuaian',0),(328407,9123,'nl','Object kosten aanpassingen',0),(328408,9123,'fi','Tuotteen kustannusten oikaisut',0),(328409,9123,'no','Element bekostning justeringer',0),(328410,9123,'da','Item Cost justeringer',0),(328411,9123,'ko','í•­ëª© ë¹„ìš©ëœ ì¡°ì •',0),(328412,9123,'he','×”×ª××ž×•×ª ×¢×œ×•×ª ×¤×¨×™×˜',0),(328413,9123,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚',0),(328414,9123,'zh','é¡¹ç›®æˆæœ¬è°ƒæ•´\r\n',0),(328415,9123,'sv','Post kostnad justeringar',0),(328416,9123,'it','Regolazioni voce costi',0),(328417,9123,'tl','',0),(328418,9123,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(328419,9123,'hi','à¤®à¤¦ à¤²à¤¾à¤—à¤¤ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(328420,9123,'ms','Pelarasan item kos',0),(328421,9123,'ar','ØªØ¹Ø¯ÙŠÙ„ ØªÙƒÙ„ÙØ© ØµÙ†Ù',0),(328422,9123,'fr','Question coÃ»t des ajustements',0),(328423,9123,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®ã‚³ã‚¹ãƒˆèª¿æ•´',0),(328424,9123,'pt','Item custos ajustes',0),(328425,9123,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(328426,9123,'es','Item Ajustes de Costos',0),(328427,9123,'de','Element Kosten Anpassungen',0),(328428,9123,'en','Item Cost Adjustments',0),(328429,9124,'is','',0),(328430,9124,'dr','Ø²Ù…ÙŠÙ†Ù‡   ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù  Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡  Ø¨Ø¹Ø¯ Ø§Ø² ØµÙØ­Ù‡ Ø§ÙˆÙ„  ÙØ§ÙƒØªÙˆØ±',0),(328431,9124,'pr','Ø²Ù…ÙŠÙ†Ù‡   ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù  Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡  Ø¨Ø¹Ø¯ Ø§Ø² ØµÙØ­Ù‡ Ø§ÙˆÙ„  ÙØ§ÙƒØªÙˆØ±',0),(328432,9124,'tr','Arka planda PDF dosyasÄ±nÄ± e-postayla gÃ¶nderilen faturalarÄ± sonra sayfa bir fatura iÃ§in',0),(328433,9124,'pl','Plik PDF tÅ‚o dla faktur pocztÄ… elektronicznÄ… po stronie jednej faktury',0),(328434,9124,'bg','Ð¤Ð¾Ð½ PDF Ñ„Ð°Ð¹Ð» Ð·Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾Ñ‚Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ ÑÐ»ÐµÐ´ ÐµÐ´Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(328435,9124,'ur','Ù¾Ø³ Ù…Ù†Ø¸Ø±ÛŒ Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ø¦Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© ÙˆØ¨Ø¬Ù„ÛŒ ØµÙØ­Û Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…ÛŒÚº Ø³Û’ Ø§ÛŒÚ© Ú©Û’ Ø¨Ø¹Ø¯',0),(328436,9124,'sr','ÐŸÐ¾Ð·Ð°Ð´Ð¸Ð½Ð° ÐŸÐ”Ð¤ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ð¿Ð¾ÑˆÑ‚Ð¾Ð¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð½Ð°ÐºÐ¾Ð½ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð¾Ð´ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(328437,9124,'vi','HÃ¬nh ná»n file PDF Ä‘á»ƒ gá»­i Email hÃ³a Ä‘Æ¡n sau trang 1 cá»§a hÃ³a Ä‘Æ¡n',0),(328438,9124,'af','Agtergrond PDF LÃªer Vir geE-posde Fakture nadat Bladsy Een van Fakture',0),(328439,9124,'ro','Fundal fiÅŸier PDF pentru facturile trimise prin E-mail dupÄƒ pagina unul de facturÄƒ',0),(328440,9124,'et','Tausta PDF faili saadetud arvete lehel Ã¼ks arve pÃ¤rast',0),(328441,9124,'si','Ozadje PDF datoteke za poslano raÄunov po strani od raÄuna',0),(328442,9124,'ba','File PDF latar belakang untuk diemail faktur setelah halaman satu dari faktur',0),(328443,9124,'nl','Achtergrond PDF-bestand voor maild facturen na pagina van factuur',0),(328444,9124,'fi','Taustalla PDF-tiedoston sÃ¤hkÃ¶postitse laskujen sivun yhden laskun jÃ¤lkeen',0),(328445,9124,'no','Bakgrunn PDF-fil for sendt fakturaer etter siden av faktura',0),(328446,9124,'da','Baggrund PDF fil sendt fakturaer efter side af faktura',0),(328447,9124,'ko','ë°°ê²½ íŽ˜ì´ì§€ ì†¡ìž¥ í•˜ë‚˜ í›„ ì´ë©”ì¼ë¡œ ì¸ë³´ì´ìŠ¤ì— ëŒ€ í•œ PDF íŒŒì¼',0),(328448,9124,'he','×¨×§×¢ ×§×•×‘×¥ PDF ×¢×‘×•×¨ ×—×©×‘×•× ×™×•×ª ×‘×“×•××¨ ×œ××—×¨ ×“×£ ××—×“ ×©×œ ×—×©×‘×•× ×™×ª',0),(328449,9124,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î±ÏÏ‡ÎµÎ¯Î¿ PDF Î³Î¹Î± Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Ï„Î·Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ Ï„Î· ÏƒÎµÎ»Î¯Î´Î± Î­Î½Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„/Ï…',0),(328450,9124,'zh','å‘ç¥¨ç¬¬ä¸€é¡µåŽä¸ºé€šè¿‡é‚®ä»¶å‘é€çš„å‘ç¥¨å®šä»¥PDFæ–‡ä»¶ä¸ºèƒŒæ™¯',0),(328451,9124,'sv','Bakgrunden PDF-fil fÃ¶r mailade fakturor efter sidan av faktura',0),(328452,9124,'it','File PDF di sfondo per le pagine successive alla prima di fatture inviate via email',0),(328453,9124,'tl','',0),(328454,9124,'th','&#3614;&#3639;&#3657;&#3609;&#3627;&#3621;&#3633;&#3591;&#3652;&#3615;&#3621;&#3660; PDF &#3586;&#3629;&#3591;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3627;&#3621;&#3633;&#3591;&#362',0),(328455,9124,'hi','à¤ªà¥ƒà¤·à¥à¤ à¤­à¥‚à¤®à¤¿ à¤ªà¥ƒà¤·à¥à¤  à¤à¤• à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤ˆà¤®à¥‡à¤² à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ PDF à¤«à¤¼à¤¾à¤‡à¤²',0),(328456,9124,'ms','Latar belakang fail PDF untuk e-melkan invois selepas Laman salah satu invois',0),(328457,9124,'ar','Ø®Ù„ÙÙŠØ© Ø§Ù„Ù…Ù„Ù PDF Ù„Ù„ÙÙˆØ§ØªÙŠØ± Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¨Ø¹Ø¯ ØµÙØ­Ø© ÙˆØ§Ø­Ø¯Ø© Ù…Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(328458,9124,'fr','Fichier PDF de fond pour des factures par courriel aprÃ¨s la Page de la facture',0),(328459,9124,'jp','è«‹æ±‚æ›¸ã® 1 ã¤ã®ãƒšãƒ¼ã‚¸ã®å¾Œãƒ¡ãƒ¼ãƒ«ã§è«‹æ±‚æ›¸ã® PDF ãƒ•ã‚¡ã‚¤ãƒ«ã‚’èƒŒæ™¯',0),(328460,9124,'pt','Arquivo PDF de fundo para as facturas por E-mail apÃ³s a pÃ¡gina de factura',0),(328461,9124,'ru','Ð¤Ð¾Ð½ PDF-Ñ„Ð°Ð¹Ð» Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð¿Ð¾ÑÐ»Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ð¾Ð´Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(328462,9124,'es','File de PDF de Fondo para Facturas Mandadas por Email DespuÃ©s de PÃ¡gina Uno de la Factura',0),(328463,9124,'de','Hintergrund-PDF-Datei per E-Mail Rechnungen nach Seite der Rechnung',0),(328464,9124,'en','Background PDF File for Emailed Invoices After Page One of Invoice',0),(328465,9125,'is','',0),(328466,9125,'dr','. Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§',0),(328467,9125,'pr','Ø®Ø§Ù…ÙˆØ´ ÙƒØ±Ø¯Ù† ØªØ¨Ø¯ÙŠÙ„ ÙƒÙ†Ù†Ø¯Ù‡ Ø®ÙˆØ¯ÙƒØ§Ø± ÙˆØ§Ø­Ø¯ Ø¨Ø±Ø§ÙŠ Ù…Ù‚Ø¯Ø§Ø±. Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§',0),(328468,9125,'tr','Devre dÄ±ÅŸÄ± otomatik birim dÃ¶nÃ¼ÅŸtÃ¼rme Mkt. kutularÄ± iÃ§in',0),(328469,9125,'pl','WyÅ‚Ä…czyÄ‡ Auto konwersji jednostek dla pola iloÅ›Ä‡.',0),(328470,9125,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾Ñ‚Ð¾ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð½Ð° Ð¼ÐµÑ€Ð½Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(328471,9125,'ur','Ø®ÙˆØ¯ ÛŒÙˆÙ†Ù¹ ØªØ¨Ø§Ø¯Ù„ÙˆÚº Ø³Û’ Qty. Ø®Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¢Ù Ú©Ø±ÛŒÚº',0),(328472,9125,'sr','Ð£Ð³Ð°ÑÐ¸ ÐÑƒÑ‚Ð¾ ÐšÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ð¾Ñ™Ð° ÐšÐ¾Ð».',0),(328473,9125,'vi','Táº¯t tá»± Ä‘á»™ng chuyá»ƒn Ä‘á»•i cho sá»‘ lÆ°á»£ng thÃ¹ng',0),(328474,9125,'af','Skakel Outo-Eenheid Oorskakeling Af vir Hoev. Bokse',0),(328475,9125,'ro','Opri automat unitatea de conversie pentru cutii de cant.',0),(328476,9125,'et','LÃ¼lita automaatne Ã¼hikuteisenduse kogus kastid',0),(328477,9125,'si','Izklopite samodejno koliÄnik za polja KoliÄina',0),(328478,9125,'ba','Menonaktifkan Auto Unit konversi untuk kotak Qty.',0),(328479,9125,'nl','Uitschakelen automatische eenheidconversie voor aantal dozen',0),(328480,9125,'fi','Hapantua lÃ¤hettÃ¤Ã¤ Auto yksikÃ¶n muuntaminen mÃ¤Ã¤rÃ¤ laatikot',0),(328481,9125,'no','SlÃ¥ av automatisk Enhetsomregning for antall bokser',0),(328482,9125,'da','Slukke Auto Unit Conversion for antal kasser',0),(328483,9125,'ko','ìˆ˜ëŸ‰ ë°•ìŠ¤ì— ëŒ€ í•œ ìžë™ ë‹¨ìœ„ ë³€í™˜ í•´ì œ',0),(328484,9125,'he','×›×‘×” ××•×˜×•×ž×˜×™×ª ×”×ž×¨×” ×™×—×™×“×ª ×¢×‘×•×¨ ×›×ž×•×ª ×ª×™×‘×•×ª',0),(328485,9125,'el','Î‘Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Î¼Î¿Î½Î¬Î´Î± Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î®Ï‚ Î³Î¹Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎºÎ¿Ï…Ï„Î¹Î¬',0),(328486,9125,'zh','è‡ªåŠ¨å…³é—­æ•°é‡æ¡†å•ä½è½¬æ¢\r\n',0),(328487,9125,'sv','StÃ¤ng av Auto Enhetskonvertering fÃ¶r Ant. lÃ¥dor',0),(328488,9125,'it','Disattivare la conversione unitÃ  automatica per scatole Qty.',0),(328489,9125,'tl','',0),(328490,9125,'th','&#3611;&#3636;&#3604;&#3585;&#3634;&#3619;&#3649;&#3611;&#3621;&#3591;&#3627;&#3609;&#3656;&#3623;&#3618;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;&#3586;&#3629;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;',0),(328491,9125,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¬à¤•à¥à¤¸à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤‘à¤Ÿà¥‹ à¤‡à¤•à¤¾à¤ˆ à¤•à¤¨à¤µà¤°à¥à¤œà¤¼à¤¨ à¤¬à¤‚à¤¦',0),(328492,9125,'ms','Memadam penukaran Unit Auto untuk kotak Qty.',0),(328493,9125,'ar','Ø¥ÙŠÙ‚Ø§Ù Ø§Ù„ØªØ­ÙˆÙŠÙ„ Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ Ù„ÙˆØ­Ø¯Ø© Ù„Ù…Ø±Ø¨Ø¹Ø§Øª Qty.',0),(328494,9125,'fr','Mettez hors tension Auto Conversion d\'unitÃ© pour les boÃ®tes de QtÃ©',0),(328495,9125,'jp','è‡ªå‹•å˜ä½å¤‰æ›ã®æ•°é‡ãƒœãƒƒã‚¯ã‚¹ã‚’ã‚ªãƒ•ã«',0),(328496,9125,'pt','Desligar conversÃ£o de automÃ¡tico de unidade para caixas de Qtd.',0),(328497,9125,'ru','ÐžÑ‚ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð°Ð²Ñ‚Ð¾ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹ Ð´Ð»Ñ ÐšÐ¾Ð»-Ð²Ð¾ ÐºÐ¾Ñ€Ð¾Ð±Ð¾Ðº',0),(328498,9125,'es','Apagar ConversiÃ³n Auto de Unidad para Cajas de Cant. ',0),(328499,9125,'de','Deaktivieren Sie die automatische Einheitenumrechnung fÃ¼r Menge Boxen',0),(328500,9125,'en','Turn Off Auto Unit Conversion for Qty. Boxes',0),(328501,9126,'is','',0),(328502,9126,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ø³ÙØ§Ø±Ø´ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÙŠ Ù†ÙŠØ³Øª',0),(328503,9126,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ø³ÙØ§Ø±Ø´ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÙŠ Ù†ÙŠØ³Øª',0),(328504,9126,'tr','DeÄŸil bulmak istediÄŸiniz sipariÅŸ verebilir',0),(328505,9126,'pl','Kulisy nie znaleÅºÄ‡ wymagane Order',0),(328506,9126,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð½Ðµ Ð½Ð°Ð¼ÐµÑ€Ð¸Ñ‚Ðµ Ð¸ÑÐºÐ°Ð½Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(328507,9126,'ur','ØªÙ„Ø§Ø´ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ø³Û’ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(328508,9126,'sr','ÐœÐ¾Ð³Ð°Ð¾ Ð½Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°Ð½Ð¸ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´',0),(328509,9126,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n Ä‘áº·t hÃ ng yÃªu cáº§u',0),(328510,9126,'af','Kan nie vind versoek orde',0),(328511,9126,'ro','Ar putea nu gÄƒsi solicitat ordin',0),(328512,9126,'et','Kas ei leia nÃµutud tellimuse',0),(328513,9126,'si','Strjena lava ne odkriti zahtevanih nalog',0),(328514,9126,'ba','Bisa tidak menemukan diminta Order',0),(328515,9126,'nl','Kan niet vinden gevraagde Order',0),(328516,9126,'fi','Voisi lÃ¶ytÃ¤Ã¤ pyydetty tilaa',0),(328517,9126,'no','Kan ikke finne Ã¸nsket rekkefÃ¸lge',0),(328518,9126,'da','Kunne ikke finde Ã¸nskede rÃ¦kkefÃ¸lge',0),(328519,9126,'ko','ìš”ì²­ ì£¼ë¬¸ í•˜ì§€ ì°¾ì„ ìˆ˜',0),(328520,9126,'he','×ª×•×›×œ ×œ×ž×¦×•× ××ª ×”×¦×’×ª ×¡×“×¨ ×”×ž×‘×•×§×© ×œ×',0),(328521,9126,'el','Î˜Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î´ÎµÎ½ Î²ÏÎµÎ¯Ï„Îµ Î¶Î®Ï„Î·ÏƒÎµ ÏƒÎµÎ¹ÏÎ¬',0),(328522,9126,'zh','æ‰¾ä¸åˆ°è¯·æ±‚çš„é¡ºåº\r\n',0),(328523,9126,'sv','Kunde inte hitta begÃ¤rt ordning',0),(328524,9126,'it','Potrebbe non trovare richiesto ordine',0),(328525,9126,'tl','',0),(328526,9126,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3588;&#3657;&#3609;&#3627;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3652;&#3604;&#3',0),(328527,9126,'hi','à¤¸à¤•à¤¾ à¤¨à¤¹à¥€à¤‚ à¤–à¥‹à¤œà¥‡à¤‚ à¤…à¤¨à¥à¤°à¥‹à¤§à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶',0),(328528,9126,'ms','Boleh tidak mencari diminta perintah',0),(328529,9126,'ar','Ø§Ù„Ø¹Ø«ÙˆØ± Ù„ÙŠØ³ \"Ø¹Ù„Ù‰ ØªØ±ØªÙŠØ¨ ÙˆØ·Ù„Ø¨\"',0),(328530,9126,'fr','Pourrait pas trouver les ordre demandÃ©',0),(328531,9126,'jp','è¦æ±‚ã•ã‚ŒãŸå‘½ä»¤ã‚’è¦‹ã¤ã‘ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(328532,9126,'pt','Poderia nÃ£o encontrar requisitado a ordem',0),(328533,9126,'ru','ÐœÐ¾Ð¶ÐµÑ‚ Ð½Ðµ Ð½Ð°Ð¹Ñ‚Ð¸ Ð¿Ñ€Ð¾ÑÐ¸Ð»Ð¸ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°',0),(328534,9126,'es','No PodÃ­a Encontrar el Orden Pedido',0),(328535,9126,'de','Angeforderte Reihenfolge nicht finden konnte',0),(328536,9126,'en','Could not Find Requested Order',0),(328537,9127,'is','',0),(328538,9127,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ ',0),(328539,9127,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´ ',0),(328540,9127,'tr','Hata alma emri',0),(328541,9127,'pl','BÅ‚Ä…d pobierania zamÃ³wienia',0),(328542,9127,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(328543,9127,'ur','Ù†Ù‚Øµ ØªØ±ØªÛŒØ¨ Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(328544,9127,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(328545,9127,'vi','Lá»—i khi truy váº¥n Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(328546,9127,'af','Fout herwinning van orde',0),(328547,9127,'ro','Eroare de preluarea comenzii',0),(328548,9127,'et','TÃµrge allalaadimisel jÃ¤rjekorras',0),(328549,9127,'si','Napaka pri pridobivanju nalog',0),(328550,9127,'ba','Kesalahan mengambil pesanan',0),(328551,9127,'nl','Fout ophalen van orde',0),(328552,9127,'fi','Virhe noudettaessa tilaus',0),(328553,9127,'no','Feil under henting av ordre',0),(328554,9127,'da','Fejl under hentning af ordre',0),(328555,9127,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ìˆœì„œ',0),(328556,9127,'he','×©×’×™××” ×‘××—×–×•×¨ ×¡×“×¨',0),(328557,9127,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï„Î¬Î¾Î·Ï‚',0),(328558,9127,'zh','é”™è¯¯æ£€ç´¢è®¢å•',0),(328559,9127,'sv','Fel hÃ¤mtar ordning',0),(328560,9127,'it','Ordine di recupero di errore',0),(328561,9127,'tl','',0),(328562,9127,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(328563,9127,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥‹ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(328564,9127,'ms','Ralat mendapatkan perintah',0),(328565,9127,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(328566,9127,'fr','Ordre de rÃ©cupÃ©ration erreur',0),(328567,9127,'jp','ã‚¨ãƒ©ãƒ¼ã‚’å–å¾—ã™ã‚‹é †åº',0),(328568,9127,'pt','Ordem de recuperaÃ§Ã£o de erro',0),(328569,9127,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð’Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð—Ð°ÐºÐ°Ð·Ð°',0),(328570,9127,'es','Error Recuperando el Pedido',0),(328571,9127,'de','Fehler beim Abrufen Reihenfolge',0),(328572,9127,'en','Error Retrieving Order',0),(328573,9128,'is','',0),(328574,9128,'dr','Ú¯Ø±ÙØªÙ† Ø³ÙØ§Ø±Ø´ ',0),(328575,9128,'pr','Ú¯Ø±ÙØªÙ† Ø³ÙØ§Ø±Ø´ ',0),(328576,9128,'tr','SipariÅŸ almak',0),(328577,9128,'pl','UzyskaÄ‡ zamÃ³wienie',0),(328578,9128,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(328579,9128,'ur','Ø¢Ø±ÚˆØ± Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(328580,9128,'sr','ÐÐ°Ð»Ð¾Ð³',0),(328581,9128,'vi','Láº¥y ÄÆ¡n Äáº·t HÃ ng',0),(328582,9128,'af','Kry Bestelling',0),(328583,9128,'ro','Ia pentru',0),(328584,9128,'et','Saada tellimus',0),(328585,9128,'si','Dobili naroÄilo',0),(328586,9128,'ba','Mendapatkan pesanan',0),(328587,9128,'nl','Orde krijgen',0),(328588,9128,'fi','Get jÃ¤rjestyksessÃ¤',0),(328589,9128,'no','FÃ¥ orden',0),(328590,9128,'da','FÃ¥ ordre',0),(328591,9128,'ko','ì£¼ë¬¸ íŒë§¤',0),(328592,9128,'he','×œ×§×‘×œ ×”×–×ž× ×”',0),(328593,9128,'el','Î Î¬ÏÎµÎ¹ ÏƒÎµÎ¹ÏÎ¬',0),(328594,9128,'zh','èŽ·å–è®¢å•\r\n',0),(328595,9128,'sv','FÃ¥ bestÃ¤llning',0),(328596,9128,'it','Ottenere ordine',0),(328597,9128,'tl','',0),(328598,9128,'th','&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(328599,9128,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(328600,9128,'ms','Mendapatkan perintah',0),(328601,9128,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø£Ù…Ø±',0),(328602,9128,'fr','Mettre en ordre',0),(328603,9128,'jp','æ³¨æ–‡ã‚’å—ã‘ã‚‹',0),(328604,9128,'pt','Ordem',0),(328605,9128,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·',0),(328606,9128,'es','Recupera el Pedido',0),(328607,9128,'de','Reihenfolge zu erhalten',0),(328608,9128,'en','Get Order',0),(328609,9129,'is','',0),(328610,9129,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ÙƒÙ…ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ø¯ ',0),(328611,9129,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ÙƒÙ…ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø­Ù…Ù„ Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ø¯ ',0),(328612,9129,'tr','SipariÅŸ edilen miktarÄ± sevk miktarÄ± az olamaz',0),(328613,9129,'pl','IloÅ›Ä‡ zamÃ³wiona nie moÅ¼e byÄ‡ mniejsza niÅ¼ iloÅ›Ä‡ juÅ¼ wysÅ‚ane',0),(328614,9129,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¾Ñ‚ Ð²ÐµÑ‡Ðµ Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(328615,9129,'ur','ÛØ¯Ø§ÛŒØª Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù¾ÛÙ„Û’ ÛÛŒ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ù…Ù‚Ø¯Ø§Ø± Ø³Û’ Ú©Ù… Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©ØªØ§',0),(328616,9129,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ ÐœÐÐŠÐ˜ Ð¾Ð´ Ð²ÐµÑ› Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(328617,9129,'vi','Sá»‘ lÆ°á»£ng Ä‘áº·t hÃ ng khÃ´ng thá»ƒ THáº¤P hÆ¡n sá»‘ lÆ°á»£ng Ä‘Ã£ chuyá»ƒn',0),(328618,9129,'af','Die Hoeveelheid Bestel Kan nie MINDER WEES as die Hoeveelheid Alreeds Versend',0),(328619,9129,'ro','Cantitatea comandata nu poate fi mai micÄƒ decÃ¢t cantitatea livratÄƒ deja',0),(328620,9129,'et','Tellitud kogust ei tohi olla vÃ¤iksem kui juba lÃ¤hetatud kogus',0),(328621,9129,'si','NaroÄena koliÄina ne sme biti MANJÅ A od Å¾e dobavljena koliÄina',0),(328622,9129,'ba','Kuantitas yang dipesan tidak bisa kurang dari kuantitas sudah dikirimkan',0),(328623,9129,'nl','De bestelde hoeveelheid mag niet minder dan het aantal reeds verzonden',0),(328624,9129,'fi','Tilattua mÃ¤Ã¤rÃ¤Ã¤ ei voi olla pienempi kuin aiemmin toimitettu',0),(328625,9129,'no','Det bestilte antallet kan ikke vÃ¦re mindre enn antallet som allerede er sendt',0),(328626,9129,'da','Det bestilte antal kan ikke vÃ¦re mindre end den mÃ¦ngde, der allerede er leveret',0),(328627,9129,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰ ì´ë¯¸ ì¶œí•˜ ìˆ˜ëŸ‰ ë³´ë‹¤ ìž‘ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(328628,9129,'he','×”×›×ž×•×ª ×”×ž×•×–×ž× ×ª ×œ× ×™×›×•×œ ×œ×”×™×•×ª ×¤×—×•×ª ×”×›×ž×•×ª ×ž×›×¨×” ×›×‘×¨',0),(328629,9129,'el','Î¤Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¸ÎµÎ¯ÏƒÎ± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎœÎ™ÎšÎ¡ÎŒÎ¤Î•Î¡Î— Î±Ï€ÏŒ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Î­Ï‡ÎµÎ¹ Î®Î´Î· Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯',0),(328630,9129,'zh','è®¢è´­çš„æ•°é‡ä¸èƒ½è¶…è¿‡å‘è´§é‡\r\n',0),(328631,9129,'sv','BestÃ¤lld kvantitet kan inte vara mindre Ã¤n den kvantitet som redan levererats',0),(328632,9129,'it','La quantitÃ  ordinata non puÃ² essere inferiore alla quantitÃ  giÃ  spedita',0),(328633,9129,'tl','',0),(328634,9129,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3617;&#3656;&#3605;&#3656;&#3635;&#3585;&#3623;&#3656;&#3634;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3626;&#3656;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(328635,9129,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶ à¤ªà¤¹à¤²à¥‡ à¤¹à¥€ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¥‡ à¤•à¤® à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(328636,9129,'ms','Kuantiti yang dipesan tidak boleh kurang daripada kuantiti yang telah dihantar',0),(328637,9129,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªÙƒÙˆÙ† Ø£Ù‚Ù„ Ù…Ù† Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ù…Ø³Ø¨Ù‚Ø§Ù‹',0),(328638,9129,'fr','La quantitÃ© commandÃ©e ne peut Ãªtre infÃ©rieure Ã  la quantitÃ© dÃ©jÃ  expÃ©diÃ©e',0),(328639,9129,'jp','æ³¨æ–‡æ•°é‡ã¯æ—¢ã«å‡ºè·æ•°é‡æœªæº€ã«ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(328640,9129,'pt','A quantidade encomendada nÃ£o pode ser inferior Ã  quantidade jÃ¡ embarcada',0),(328641,9129,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð½Ð¾Ðµ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐÐµ ÐœÐ¾Ð¶ÐµÑ‚ Ð‘Ñ‹Ñ‚ÑŒ ÐœÐ•ÐÐ¬Ð¨Ð•, Ñ‡ÐµÐ¼ Ð£Ð¶Ðµ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ð¾Ðµ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(328642,9129,'es','La Cantidad que se OrdenÃ³ no Puede Ser MENOS Que La Cantidad Ya Se EnviÃ³',0),(328643,9129,'de','Die Bestellmenge kann nicht kleiner als die Menge, die bereits ausgeliefert sein',0),(328644,9129,'en','The Quantity Ordered Cannot Be LESS than the Quantity Already Shipped',0),(328645,9130,'is','',0),(328646,9130,'dr','Ø´Ù…Ø§ Ù‡Ø± ØªØºÙŠÙŠØ± Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ø±Ø§ Ø§Ø² Ø¯Ø³Øª Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø¯Ø§Ø¯ ',0),(328647,9130,'pr','Ø´Ù…Ø§ Ù‡Ø± ØªØºÙŠÙŠØ± Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯Ù‡ Ø§ÙŠ Ø±Ø§ Ø§Ø² Ø¯Ø³Øª Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø¯Ø§Ø¯ ',0),(328648,9130,'tr','KaydedilmemiÅŸ tÃ¼m deÄŸiÅŸiklikler kaybolur',0),(328649,9130,'pl','Stracisz wszystkie niezapisane zmiany',0),(328650,9130,'bg','Ð’Ð¸Ðµ Ñ‰Ðµ Ð·Ð°Ð³ÑƒÐ±Ð¸Ñ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð½ÐµÐ·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(328651,9130,'ur','Ø¢Ù¾ ØºÛŒØ± Ù…Ø­ÙÙˆØ¸ Ø´Ø¯Û ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ø¶Ø§Ø¦Ø¹ Ú©Ø± Ø¯ÛŒÚº Ú¯Û’',0),(328652,9130,'sr','Ð˜Ð·Ð³ÑƒÐ±Ð¸Ñ›ÐµÑ‚Ðµ ÑÐ²Ðµ Ð½ÐµÑÐ°Ñ‡ÑƒÐ²Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(328653,9130,'vi','Báº¡n sáº½ máº¥t nhá»¯ng thay Ä‘á»•i chÆ°a sao lÆ°u',0),(328654,9130,'af','U sal enige ongestoorde inligting verloor.',0),(328655,9130,'ro','VeÅ£i pierde orice modificÄƒri nesalvate',0),(328656,9130,'et','Kaotad kÃµik salvestamata muudatused',0),(328657,9130,'si','Boste izgubili vse neshranjene spremembe',0),(328658,9130,'ba','Semua perubahan yang belum disimpan akan hilang',0),(328659,9130,'nl','U verliest alle niet-opgeslagen wijzigingen',0),(328660,9130,'fi','MenetÃ¤t kaikki tallentamattomat muutokset',0),(328661,9130,'no','Du vil miste alle endringer',0),(328662,9130,'da','Du vil miste ugemte Ã¦ndringer',0),(328663,9130,'ko','ì €ìž¥ ë˜ì§€ ì•Šì€ ë³€ê²½ ë‚´ìš©ì„ ìžƒê²Œ ë©ë‹ˆë‹¤.',0),(328664,9130,'he','×©×™× ×•×™×™× ×©×œ× × ×©×ž×¨×• ×™××‘×“×•',0),(328665,9130,'el','Î˜Î± Ï‡Î¬ÏƒÎµÏ„Îµ Î¿Ï€Î¿Î¹ÎµÏƒÎ´Î®Ï€Î¿Ï„Îµ Î¼Î· Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Î¼Î­Î½ÎµÏ‚ Î±Î»Î»Î±Î³Î­Ï‚',0),(328666,9130,'zh','ä½ å°†ä¸¢å¤±æœªä¿å­˜çš„ä¿®æ”¹',0),(328667,9130,'sv','Du kommer att fÃ¶rlora alla osparade Ã¤ndringar',0),(328668,9130,'it','Perderai ogni modifica non salvata',0),(328669,9130,'tl','',0),(328670,9130,'th','&#3588;&#3640;&#3603;&#3592;&#3632;&#3626;&#3641;&#3597;&#3648;&#3626;&#3637;&#3618;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3618;&#3633;&#3591;&#3',0),(328671,9130,'hi','à¤†à¤ª à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤¨ à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤–à¥‹ à¤œà¤¾à¤à¤—à¤¾',0),(328672,9130,'ms','Anda akan kehilangan sebarang perubahan yang tidak disimpan',0),(328673,9130,'ar','Ø³ÙˆÙ ØªÙÙ‚Ø¯ Ø£ÙŠ ØªØºÙŠÙŠØ±Ø§Øª ØºÙŠØ± Ù…Ø®Ø²Ù†Ø©',0),(328674,9130,'fr','Vous perdrez tous les changements non sauvegardÃ©s.',0),(328675,9130,'jp','ä¿å­˜ã•ã‚Œã¦ã„ãªã„å¤‰æ›´ã¯å¤±ã‚ã‚Œã¾ã™',0),(328676,9130,'pt','VocÃª perderÃ¡ as alteraÃ§Ãµes nÃ£o salvas',0),(328677,9130,'ru','Ð’Ñ‹ ÐŸÐ¾Ñ‚ÐµÑ€ÑÐµÑ‚Ðµ Ð’ÑÐµ ÐÐµÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ðµ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(328678,9130,'es','PerderÃ¡ Algunos Cambios No Guardados',0),(328679,9130,'de','Sie werden alle nicht gespeicherten Ã„nderungen verlieren.',0),(328680,9130,'en','You Will Lose Any Unsaved Changes',0),(328681,9131,'is','',0),(328682,9131,'dr','Ù¾ÙŠØ¯Ø§ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(328683,9131,'pr','Ù¾ÙŠØ¯Ø§ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(328684,9131,'tr','Emirleri bul',0),(328685,9131,'pl','ZnaleÅºÄ‡ zamÃ³wienia',0),(328686,9131,'bg','ÐÐ°Ð¼ÐµÑ€Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(328687,9131,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(328688,9131,'sr','ÐŸÑ€Ð¾Ð½Ð°Ñ’ÐµÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(328689,9131,'vi','TÃ¬m ÄÆ¡n Ä‘áº·t hÃ ng',0),(328690,9131,'af','Vind Bestellings',0),(328691,9131,'ro','GÄƒsi comenzi',0),(328692,9131,'et','Leia tellimusi',0),(328693,9131,'si','PoiÅ¡Äi naroÄila',0),(328694,9131,'ba','Mencari Pesanan',0),(328695,9131,'nl','Orders vinden',0),(328696,9131,'fi','Etsi tilauksia',0),(328697,9131,'no','Finne ordrer',0),(328698,9131,'da','Find ordrer',0),(328699,9131,'ko','ì£¼ë¬¸ì„ ì°¾ìŠµë‹ˆë‹¤',0),(328700,9131,'he','×ž×¦× ×”×–×ž× ×•×ª',0),(328701,9131,'el','Î’ÏÎµÎ¯Ï„Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(328702,9131,'zh','æŸ¥æ‰¾ä»¤\r\n',0),(328703,9131,'sv','Hitta order',0),(328704,9131,'it','Trovare gli ordini',0),(328705,9131,'tl','',0),(328706,9131,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(328707,9131,'hi','à¤†à¤¦à¥‡à¤¶ à¤–à¥‹à¤œà¥‡à¤‚',0),(328708,9131,'ms','Mencari pesanan',0),(328709,9131,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø£ÙˆØ§Ù…Ø±',0),(328710,9131,'fr','Trouver commandes',0),(328711,9131,'jp','æ³¨æ–‡ã‚’æ¤œç´¢ã—ã¾ã™ã€‚',0),(328712,9131,'pt','Localizar pedidos',0),(328713,9131,'ru','ÐÐ°Ð¹Ñ‚Ð¸ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(328714,9131,'es','Encontrar Pedidos',0),(328715,9131,'de','Finden Sie AuftrÃ¤ge',0),(328716,9131,'en','Find Orders',0),(328717,9132,'is','',0),(328718,9132,'dr','.Ø²ÙŠØ±Ø§ Ø¬Ù†Ø³  Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠÙŠ Ø¯Ø§Ø±Ø¯ ',0),(328719,9132,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø­Ø°Ù Ø³Ø·Ø± Ù†ÙŠØ³Øª.Ø²ÙŠØ±Ø§ ÙƒØ§Ù„Ø§  Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÙŠÙŠ Ø¯Ø§Ø±Ø¯ ',0),(328720,9132,'tr','SatÄ±r Ã¶ÄŸesi olduÄŸundan silinemez gÃ¶nderiler.',0),(328721,9132,'pl','Nie moÅ¼na usunÄ…Ä‡ wiersza poniewaÅ¼ przedmiot wysyÅ‚ki.',0),(328722,9132,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ð»Ð¸Ð½Ð¸Ñ, Ð·Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»ÑŠÑ‚ Ð¸Ð¼Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸.',0),(328723,9132,'ur','Ø³Ø·Ø± Ø­Ø°Ù Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§ Ú©ÛŒÙˆÙ†Ú©Û Ø´Û’ Ù„ÛŒØªÛŒ ÛÛ’ Û”',0),(328724,9132,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ñ€ÐµÐ´ Ñ˜ÐµÑ€ Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ.',0),(328725,9132,'vi','KhÃ´ng thá»ƒ xÃ³a dÃ²ng vÃ¬ hÃ ng Ä‘Ã£ chyá»ƒn',0),(328726,9132,'af','Kan nie lyn skrap nie, omdat item versending het.',0),(328727,9132,'ro','Imposibil de ÅŸters linie deoarece elementul a transporturilor.',0),(328728,9132,'et','Ei saa rida kustutada, kuna toote kohta on tarneid.',0),(328729,9132,'si','Ne more izbrisati vrstice, ker ima element poÅ¡iljke.',0),(328730,9132,'ba','Tidak dapat menghapus baris karena item memiliki pengiriman.',0),(328731,9132,'nl','Regel niet verwijderen omdat item heeft zendingen.',0),(328732,9132,'fi','RiviÃ¤ ei voi poistaa, koska kohteella siirtoja.',0),(328733,9132,'no','Kan ikke slette linjen fordi varen har forsendelser.',0),(328734,9132,'da','Kan ikke slette linje, fordi varen har forsendelser.',0),(328735,9132,'ko','í•­ëª© ë•Œë¬¸ì— ë¼ì¸ì„ ì‚­ì œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ì¶œí•˜.',0),(328736,9132,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×—×•×§ ×©×•×¨×” ×‘×’×œ×œ ×¤×¨×™×˜ ×™×© ×ž×©×œ×•×—×™×.',0),(328737,9132,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÎ¹ Ï„Î· Î³ÏÎ±Î¼Î¼Î® ÎµÏ€ÎµÎ¹Î´Î® Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î­Ï‡ÎµÎ¹ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚.',0),(328738,9132,'zh','æ— æ³•åˆ é™¤çº¿è·¯ï¼Œå› ä¸ºé¡¹ç›®å·²ç»å‘è´§ã€‚\r\n',0),(328739,9132,'sv','Kan inte radera raden eftersom artikeln har transporter.',0),(328740,9132,'it','Non Ã¨ possibile eliminare la linea perchÃ© elemento ha le spedizioni.',0),(328741,9132,'tl','',0),(328742,9132,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3621;&#3610;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604; &#3648;&#3614;&#3619;&#3634;&#3632;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3617;&#3637;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#',0),(328743,9132,'hi','à¤°à¥‡à¤–à¤¾ à¤•à¥‹ à¤¨à¤¹à¥€à¤‚ à¤¹à¤Ÿà¤¾ à¤¸à¤•à¤¤à¥‡ à¤•à¥à¤¯à¥‹à¤‚à¤•à¤¿ à¤†à¤‡à¤Ÿà¤® à¤¹à¥ˆ à¤²à¤¦à¤¾à¤¨à¥¤',0),(328744,9132,'ms','Tidak dapat menghapuskan garisan kerana item telah penghantaran.',0),(328745,9132,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø­Ø°Ù Ø§Ù„Ø³Ø·Ø± Ù„Ø£Ù† Ø§Ù„Ø¨Ù†Ø¯ Ù‚Ø¯ Ø§Ù„Ø´Ø­Ù†Ø§Øª.',0),(328746,9132,'fr','Impossible de supprimer ligne parce que l\'Ã©lÃ©ment a livraisons.',0),(328747,9132,'jp','é …ç›®ãŒã„ã‚‹è¡Œã‚’å‰Šé™¤ã§ãã¾ã›ã‚“å‡ºè·ã€‚',0),(328748,9132,'pt','NÃ£o Ã© possÃ­vel excluir a linha, porque o item tem carregamentos.',0),(328749,9132,'ru','ÐÐµÐ»ÑŒÐ·Ñ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾ÐºÑƒ, Ð¿Ð¾Ñ‚Ð¾Ð¼Ñƒ Ñ‡Ñ‚Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸.',0),(328750,9132,'es','No se puede eliminar la linea porque el item tiene envÃ­os',0),(328751,9132,'de','Linie kann nicht gelÃ¶scht werden, da Artikel hat Sendungen.',0),(328752,9132,'en','Cannot delete line because item has shipments.',0),(328753,9133,'is','',0),(328754,9133,'dr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(328755,9133,'pr','Ø³ÙØ§Ø±Ø´ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(328756,9133,'tr','Faturalanan sipariÅŸ',0),(328757,9133,'pl','ZamÃ³wienia zostaÅ‚ rozliczani',0),(328758,9133,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ðµ Ð±Ð¸Ð»Ð° Ð¾ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ÐµÐ½Ð°',0),(328759,9133,'ur','ØªØ±ØªÛŒØ¨ Ù…ÛŒÚº Ø¨Ø§Ù„Ù„Ø§Ø¯ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(328760,9133,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð°.',0),(328761,9133,'vi','ÄÆ¡n HÃ ng Ä‘Ã£ ra hÃ³a Ä‘Æ¡n ',0),(328762,9133,'af','Bestelling is Gefaktureer',0),(328763,9133,'ro','Comanda facturata',0),(328764,9133,'et','Tellimuse arve',0),(328765,9133,'si','Vrstni red je bil zaraÄunani',0),(328766,9133,'ba','Urutan telah ditagih',0),(328767,9133,'nl','Volgorde is gefactureerd',0),(328768,9133,'fi','Tilaus laskutetaan',0),(328769,9133,'no','Ordren er fakturert',0),(328770,9133,'da','Ordren er blevet faktureret',0),(328771,9133,'ko','ìˆœì„œê°€ ì²­êµ¬',0),(328772,9133,'he','×—×•×™×‘×”',0),(328773,9133,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î­Ï‡ÎµÎ¹ Ï‡ÏÎµÏ‰Î¸ÎµÎ¯',0),(328774,9133,'zh','è®¢å•å·²å…¥è´¦\r\n',0),(328775,9133,'sv','Order som har debiterats',0),(328776,9133,'it','Ordine ha stati fatturati',0),(328777,9133,'tl','',0),(328778,9133,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3610;&#3636;&#3621;',0),(328779,9133,'hi','à¤•à¥à¤°à¤® à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(328780,9133,'ms','Perintah telah dibilkan',0),(328781,9133,'ar','ÙˆÙ‚Ø¯ ØªÙ… ÙÙˆØªØ±Ø© Ø£Ù…Ø±',0),(328782,9133,'fr','Ordre a Ã©tÃ© facturÃ©',0),(328783,9133,'jp','æ³¨æ–‡ã‚’è«‹æ±‚ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(328784,9133,'pt','Ordem tem sido faturado',0),(328785,9133,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(328786,9133,'es','Pedido se FacturÃ³',0),(328787,9133,'de','Hat die Bestellung in Rechnung gestellt, wurde',0),(328788,9133,'en','Order Has Been Billed',0),(328789,9134,'is','',0),(328790,9134,'dr','Ø³ÙØ§Ø±Ø´ ØªØ§ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯',0),(328791,9134,'pr','Ø³ÙØ§Ø±Ø´ ØªØ§ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø§ÙŠ Ø­Ù…Ù„ Ø´Ø¯',0),(328792,9134,'tr','KÄ±smen sevk emri',0),(328793,9134,'pl','Aby czÄ™Å›ciowo wydane',0),(328794,9134,'bg','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(328795,9134,'ur','ØªØ±ØªÛŒØ¨ Ø¬Ø²ÙˆÛŒ Ø·ÙˆØ± Ù¾Ø± Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(328796,9134,'sr','Ð”ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð¾ Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°',0),(328797,9134,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ váº­n chuyá»ƒn 1 pháº§n',0),(328798,9134,'af','Bestelling Gedeeltelik Versend',0),(328799,9134,'ro','ComandÄƒ livrat parÅ£ial',0),(328800,9134,'et','Tellimuse osaliselt lÃ¤hetatud',0),(328801,9134,'si','NaroÄilo delno poslano',0),(328802,9134,'ba','Pesanan dikirim sebagian',0),(328803,9134,'nl','Volgorde gedeeltelijk verzonden',0),(328804,9134,'fi','Tilaus toimitetaan osittain',0),(328805,9134,'no','For delvis levert',0),(328806,9134,'da','Ordren delvist leveret',0),(328807,9134,'ko','ë¶€ë¶„ì ìœ¼ë¡œ ë°œì†¡ í•˜ëŠ” ì£¼ë¬¸',0),(328808,9134,'he','×¡×“×¨ ×—×œ×§×™ ×©× ×©×œ×—×•',0),(328809,9134,'el','Î£ÎµÎ¹ÏÎ¬ Î¼ÎµÏÎ¹ÎºÎ® Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(328810,9134,'zh','è®¢å•éƒ¨åˆ†å‘è´§\r\n',0),(328811,9134,'sv','Ordning Delutlevererad',0),(328812,9134,'it','Ordine spedito parzialmente',0),(328813,9134,'tl','',0),(328814,9134,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3610;&#3634;&#3591;&#3626;&#3656;&#3623;&#3609;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(328815,9134,'hi','à¤†à¤‚à¤¶à¤¿à¤• à¤°à¥‚à¤ª à¤¸à¥‡ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶',0),(328816,9134,'ms','Perintah yang sebahagiannya dihantar',0),(328817,9134,'ar','Ø´Ø­Ù† Ù…Ø¬Ø²Ù‘Ø£ Ù„Ù„Ø·Ù„Ø¨ÙŠÙ‘Ø©',0),(328818,9134,'fr','Commande partiellement expÃ©diÃ©e',0),(328819,9134,'jp','éƒ¨åˆ†çš„ã«å‡ºè·æ³¨æ–‡',0),(328820,9134,'pt','Ordem parcialmente enviado',0),(328821,9134,'ru','Ð—Ð°ÐºÐ°Ð· Ñ‡Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½',0),(328822,9134,'es','Pedido Parcialmente Enviado',0),(328823,9134,'de','Teilweise versandte Bestellung',0),(328824,9134,'en','Order Partially Shipped',0),(328825,9135,'is','',0),(328826,9135,'dr','Ø¬Ø³ØªØ¬Ùˆ Ø·Ø¨Ù‚ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙŠØ§ Ù†Ø§Ù… Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(328827,9135,'pr','Ø¬Ø³ØªØ¬Ùˆ Ø·Ø¨Ù‚ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙŠØ§ Ù†Ø§Ù… Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(328828,9135,'tr','Arama emri ile # veya mÃ¼ÅŸteri adÄ±',0),(328829,9135,'pl','Wg kolejnoÅ›ci # lub nazwa klienta',0),(328830,9135,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° # Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(328831,9135,'ur','ØªÙ„Ø§Ø´ ØªØ±ØªÛŒØ¨ ÙˆØ§Ø± # ÛŒØ§ Ú¯Ø§ÛÚ© Ú©Û’ Ù†Ø§Ù…',0),(328832,9135,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð³Ð° Ð¿Ð¾ Ð½Ð°Ñ€ÐµÐ´Ð±Ð¸ # Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(328833,9135,'vi','TÃ¬m theo sá»‘ Ä‘Æ¡n hÃ ng hay tÃªn khÃ¡ch hÃ ng',0),(328834,9135,'af','Soek per Bestelling # Of KliÃ«nt/Klant Naam',0),(328835,9135,'ro','CÄƒutaÅ£i comanda # sau numele clientului',0),(328836,9135,'et','Otsi tellimuse numbri vÃµi kliendi nime jÃ¤rgi',0),(328837,9135,'si','Iskanje po vrstnem redu # ali ime kupca',0),(328838,9135,'ba','Cari berdasarkan urutan # atau nama pelanggan',0),(328839,9135,'nl','Zoeken op bestelling # of naam van klant',0),(328840,9135,'fi','Etsi tilauksesta # tai asiakkaan nimi',0),(328841,9135,'no','SÃ¸k etter ordre # eller kundenavn',0),(328842,9135,'da','SÃ¸g efter ordre # eller Kundenavn',0),(328843,9135,'ko','ëª…ë ¹ì— ì˜í•´ ê²€ìƒ‰ # ë˜ëŠ” ê³ ê° ì´ë¦„',0),(328844,9135,'he','×—×™×¤×•×© ×¢×œ ×¤×™ ×¡×“×¨ # ××• ×©× ×”×œ×§×•×—',0),(328845,9135,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎºÎ±Ï„Î¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± # Î® ÏŒÎ½Î¿Î¼Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(328846,9135,'zh','é€šè¿‡è®¢å•å·æˆ–å®¢æˆ·åç§°æœç´¢\r\n',0),(328847,9135,'sv','SÃ¶k pÃ¥ Order # eller kundens namn',0),(328848,9135,'it','Ricerca di ordine # o nome cliente',0),(328849,9135,'tl','',0),(328850,9135,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3650;&#3604;&#3618;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; &#3627;&#3619;&#3639;&#3629; &#3594;&#3639;&#3656;&#3629;&#3621;&#3641;&#3585;&',0),(328851,9135,'hi','à¤–à¥‹à¤œ à¤•à¥à¤°à¤® à¤¦à¥à¤µà¤¾à¤°à¤¾ # à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤¨à¤¾à¤®',0),(328852,9135,'ms','Cari mengikut perintah # atau nama pelanggan',0),(328853,9135,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¨Ø¥Ø³ØªØ®Ø¯Ø§Ù… Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨ÙŠØ© Ø£Ùˆ Ø¥Ø³Ù… Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(328854,9135,'fr','Recherche par ordre # ou le nom du client',0),(328855,9135,'jp','æ¤œç´¢é † # ã¾ãŸã¯é¡§å®¢å',0),(328856,9135,'pt','Busca por ordem # ou nome do cliente',0),(328857,9135,'ru','Ð˜ÑÐºÐ°Ñ‚ÑŒ ÐŸÐ¾ Ð—Ð°ÐºÐ°Ð·Ð° # Ð˜Ð»Ð¸ ÐÐ°Ð·Ð²Ð°Ð½Ð¸ÑŽ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(328858,9135,'es','Buscar por # de Orden O Por Nombre de Cliente',0),(328859,9135,'de','Suche nach Bestellung # oder Kundenname',0),(328860,9135,'en','Search By Order # or Customer Name',0),(328861,9136,'is','',0),(328862,9136,'dr','Ú†Ùƒ Ù…Ø´ØªØ±ÙŠ',0),(328863,9136,'pr','Ú†Ùƒ Ù…Ø´ØªØ±ÙŠ',0),(328864,9136,'tr','Ä°stemci onay',0),(328865,9136,'pl','Wyboru klienta',0),(328866,9136,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(328867,9136,'ur','ÙˆØµÙˆÙ„ Ú©Ø§Ø± Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(328868,9136,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(328869,9136,'vi','SÃ©c khÃ¡ch hÃ ng',0),(328870,9136,'af','KliÃ«nt / Klant Tjek',0),(328871,9136,'ro','Clientul verifica',0),(328872,9136,'et','Kliendi sisse',0),(328873,9136,'si','Odjemalec preveri',0),(328874,9136,'ba','Klien Check',0),(328875,9136,'nl','Client Check',0),(328876,9136,'fi','Asiakkaan uloskirjautuminen',0),(328877,9136,'no','Klienten sjekk',0),(328878,9136,'da','Klienten Check',0),(328879,9136,'ko','í´ë¼ì´ì–¸íŠ¸ í™•ì¸',0),(328880,9136,'he','×”×¡×™×ž×•×Ÿ ×œ×§×•×—',0),(328881,9136,'el','Î•Î»Î­Î³Ï‡Î¿Ï… Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(328882,9136,'zh','å®¢æˆ·æ£€æŸ¥\r\n',0),(328883,9136,'sv','Klientens kontroll',0),(328884,9136,'it','Controllo del cliente',0),(328885,9136,'tl','',0),(328886,9136,'th','&#3648;&#3594;&#3655;&#3588;&#3612;&#3641;&#3657;&#3592;&#3657;&#3634;&#3591;',0),(328887,9136,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤šà¥‡à¤•',0),(328888,9136,'ms','Semakan pelanggan',0),(328889,9136,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(328890,9136,'fr','Client vÃ©rifie',0),(328891,9136,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆ ãƒã‚§ãƒƒã‚¯',0),(328892,9136,'pt','SeleÃ§Ã£o de cliente',0),(328893,9136,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(328894,9136,'es','Cheque de Cliente',0),(328895,9136,'de','ÃœberprÃ¼fung des Clients',0),(328896,9136,'en','Client Check',0),(328897,9137,'is','',0),(328898,9137,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ§ÙƒØªÙˆØ±',0),(328899,9137,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ§ÙƒØªÙˆØ±',0),(328900,9137,'tr','Fatura tutarÄ±',0),(328901,9137,'pl','Kwota faktury',0),(328902,9137,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(328903,9137,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø±Ù‚Ù…',0),(328904,9137,'sr','Ð˜Ð·Ð½Ð¾Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(328905,9137,'vi','Sá»‘ tiá»n HÃ³a Ä‘Æ¡n',0),(328906,9137,'af','Faktuurbedrag',0),(328907,9137,'ro','Suma factura',0),(328908,9137,'et','Arve summa',0),(328909,9137,'si','Znesek raÄuna',0),(328910,9137,'ba','Faktur jumlah',0),(328911,9137,'nl','Factuurbedrag',0),(328912,9137,'fi','Laskutussumma',0),(328913,9137,'no','FakturabelÃ¸pet',0),(328914,9137,'da','FakturabelÃ¸bet',0),(328915,9137,'ko','ì†¡ìž¥ ê¸ˆì•¡',0),(328916,9137,'he','×¡×›×•× ×—×©×‘×•× ×™×ª',0),(328917,9137,'el','Î Î¿ÏƒÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(328918,9137,'zh','å‘ç¥¨é‡‘é¢\r\n',0),(328919,9137,'sv','Fakturabeloppet',0),(328920,9137,'it','Importo fattura',0),(328921,9137,'tl','',0),(328922,9137,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3651;&#3609;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(328923,9137,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿',0),(328924,9137,'ms','Invois amaun',0),(328925,9137,'ar','Ù…Ø¨Ù„Øº Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(328926,9137,'fr','Montant de la facture',0),(328927,9137,'jp','è«‹æ±‚é‡‘é¡',0),(328928,9137,'pt','Montante da factura',0),(328929,9137,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÑ‡ÐµÑ‚Ð°',0),(328930,9137,'es','Monto de Factura',0),(328931,9137,'de','Rechnungsbetrag',0),(328932,9137,'en','Invoice Amount',0),(328933,9138,'is','',0),(328934,9138,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(328935,9138,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(328936,9138,'tr','Fatura deÄŸil',0),(328937,9138,'pl','Nie rozliczone',0),(328938,9138,'bg','ÐÐµ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸',0),(328939,9138,'ur','Ù†ÛÛŒÚº Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(328940,9138,'sr','ÐÐ¸Ñ˜Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ð»Ð°',0),(328941,9138,'vi','ChÆ°a Ra HÃ³a ÄÆ¡n',0),(328942,9138,'af','WeerspieÃ«l nie',0),(328943,9138,'ro','Nu facturat',0),(328944,9138,'et','Mitte arve',0),(328945,9138,'si','Ne zaraÄunavajo',0),(328946,9138,'ba','Tidak ditagih',0),(328947,9138,'nl','Niet gefactureerd',0),(328948,9138,'fi','Ei laskutettu',0),(328949,9138,'no','Ikke fakturert',0),(328950,9138,'da','Ikke faktureret',0),(328951,9138,'ko','ë¹„ìš©ì´ ì²­êµ¬ ë˜ì§€',0),(328952,9138,'he','×”×—×™×•×‘ ××™× ×• ×ž×™×™×“×™',0),(328953,9138,'el','Î”ÎµÎ½ Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹',0),(328954,9138,'zh','æœªç»“å¸\r\n',0),(328955,9138,'sv','Faktureras inte',0),(328956,9138,'it','Non fatturati',0),(328957,9138,'tl','',0),(328958,9138,'th','&#3652;&#3617;&#3656;&#3651;&#3594;&#3656;&#3648;&#3594;&#3655;&#3588;',0),(328959,9138,'hi','à¤¬à¤¿à¤² à¤¨à¤¹à¥€à¤‚',0),(328960,9138,'ms','Tidak dibil',0),(328961,9138,'ar','Ù„Ø§ ØªÙˆØµÙ',0),(328962,9138,'fr','Pas facturÃ©s',0),(328963,9138,'jp','è«‹æ±‚ã•ã‚Œã¾ã›ã‚“ã€‚',0),(328964,9138,'pt','NÃ£o faturado',0),(328965,9138,'ru','ÐÐµ Ñ‚Ð°Ñ€Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€ÑƒÐµÑ‚ÑÑ',0),(328966,9138,'es','No Facturado',0),(328967,9138,'de','Nicht in Rechnung gestellt',0),(328968,9138,'en','Not Billed',0),(328969,9139,'is','',0),(328970,9139,'dr','Ø­Ø°Ù Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(328971,9139,'pr','Ø­Ø°Ù Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ',0),(328972,9139,'tr','Teklif silme',0),(328973,9139,'pl','UsuÅ„ ofertÄ™',0),(328974,9139,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(328975,9139,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(328976,9139,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(328977,9139,'vi','XÃ³a bÃ¡o giÃ¡',0),(328978,9139,'af','Skrap Kwotasie',0),(328979,9139,'ro','ÅžtergeÅ£i citat',0),(328980,9139,'et','Pakkumise kustutamine',0),(328981,9139,'si','Izbrisati citat',0),(328982,9139,'ba','Menghapus kutipan',0),(328983,9139,'nl','Offerte verwijderen',0),(328984,9139,'fi','Poista tarjous',0),(328985,9139,'no','Slette tilbud',0),(328986,9139,'da','Slette tilbud',0),(328987,9139,'ko','ê²¬ì ì„ ì‚­ì œ',0),(328988,9139,'he','×ž×—×™×§×ª ×”×¦×¢×ª ×ž×—×™×¨',0),(328989,9139,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(328990,9139,'zh','åˆ é™¤æŠ¥ä»·\r\n',0),(328991,9139,'sv','Ta bort citat',0),(328992,9139,'it','Eliminare la citazione',0),(328993,9139,'tl','',0),(328994,9139,'th','&#3621;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3588;&#3634;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(328995,9139,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£ à¤¹à¤Ÿà¤¾',0),(328996,9139,'ms','Menghapuskan Quote',0),(328997,9139,'ar','Ø­Ø°Ù Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(328998,9139,'fr','Supprimer Devis',0),(328999,9139,'jp','å¼•ç”¨ç¬¦ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(329000,9139,'pt','Excluir a citaÃ§Ã£o',0),(329001,9139,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(329002,9139,'es','Eliminar CotizaciÃ³n',0),(329003,9139,'de','Zitat zu lÃ¶schen',0),(329004,9139,'en','Delete Quote',0),(329005,9140,'is','',0),(329006,9140,'dr','Ø³ÙØ§Ø±Ø´ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(329007,9140,'pr','Ø³ÙØ§Ø±Ø´ ØªØ§ÙŠÙŠØ¯ Ù†Ø´Ø¯Ù‡ ',0),(329008,9140,'tr','Onaylanmayan sipariÅŸ',0),(329009,9140,'pl','Niepotwierdzone zamÃ³wienia',0),(329010,9140,'bg','ÐÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(329011,9140,'ur','ØºÛŒØ± Ù…ØµØ¯Ù‚Û Ø§Ù…Ø§Ù†',0),(329012,9140,'sr','ÐÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð¸Ð¼ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(329013,9140,'vi','ÄÆ¡n HÃ ng chÆ°a xÃ¡c nháº­n',0),(329014,9140,'af','Onbevestigende Bestelling',0),(329015,9140,'ro','ComandÄƒ neconfirmatÄƒ',0),(329016,9140,'et','Kinnitamata tellimus',0),(329017,9140,'si','Nepotrjen nalog',0),(329018,9140,'ba','Order belum dikonfirmasi',0),(329019,9140,'nl','Niet-bevestigde Order',0),(329020,9140,'fi','Vahvistamattomien jÃ¤rjestyksessÃ¤',0),(329021,9140,'no','Ubekreftet bestilling',0),(329022,9140,'da','UbekrÃ¦ftet ordre',0),(329023,9140,'ko','ë¯¸í™•ì¸ëœ ìˆœì„œ',0),(329024,9140,'he','×¡×“×¨ ×œ× ×ž××•×©×¨×•×ª',0),(329025,9140,'el','ÎœÎ· ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹Ï‰Î¼Î­Î½Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(329026,9140,'zh','æœªç¡®è®¤çš„è®¢å•\r\n',0),(329027,9140,'sv','ObekrÃ¤ftade Order',0),(329028,9140,'it','Ordine confermato',0),(329029,9140,'tl','',0),(329030,9140,'th','&#3651;&#3610;&#3648;&#3626;&#3609;&#3629;&#3619;&#3634;&#3588;&#3634;',0),(329031,9140,'hi','à¤…à¤ªà¥à¤·à¥à¤Ÿ à¤•à¥à¤°à¤®',0),(329032,9140,'ms','Perintah yang belum disahkan',0),(329033,9140,'ar','Ø·Ù„Ø¨ÙŠØ© ØºÙŠØ± Ù…Ø¤ÙƒÙ‘Ø¯Ø©',0),(329034,9140,'fr','Commande non confirmÃ©e',0),(329035,9140,'jp','æœªç¢ºèªã®é †åº',0),(329036,9140,'pt','Ordem nÃ£o confirmado',0),(329037,9140,'ru','ÐÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ð¹ Ð—Ð°ÐºÐ°Ð·',0),(329038,9140,'es','Pedido No Confirmado',0),(329039,9140,'de','Nicht bestÃ¤tigte Bestellung',0),(329040,9140,'en','Unconfirmed Order',0),(329041,9141,'is','',0),(329042,9141,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(329043,9141,'pr','Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(329044,9141,'tr','Mevduat baÅŸarÄ±yla kaydedildi',0),(329045,9141,'pl','Depozyt zapisane',0),(329046,9141,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(329047,9141,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ ÚˆÙ¾Ø§Ø²Ù¹',0),(329048,9141,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(329049,9141,'vi','Sao lÆ°u Äáº·t cá»c thÃ nh cÃ´ng',0),(329050,9141,'af','Deposito suksesvolg Gestoor',0),(329051,9141,'ro','Depozit salvat cu succes',0),(329052,9141,'et','Tagatisraha edukalt salvestatud',0),(329053,9141,'si','Depozit, ki uspeÅ¡no shranjen',0),(329054,9141,'ba','Deposit yang berhasil diselamatkan',0),(329055,9141,'nl','Storting succesvol opgeslagen',0),(329056,9141,'fi','Talletus tallennettu',0),(329057,9141,'no','Innskudd lagret',0),(329058,9141,'da','Depositum gemt med succes',0),(329059,9141,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” ì˜ˆê¸ˆ',0),(329060,9141,'he','×¤×™×§×“×•×Ÿ ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(329061,9141,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(329062,9141,'zh','å­˜æ¬¾å·²æˆåŠŸä¿å­˜\r\n',0),(329063,9141,'sv','InsÃ¤ttning sparats',0),(329064,9141,'it','Deposito salvato correttamente',0),(329065,9141,'tl','',0),(329066,9141,'th','&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3606;&#3641;&#3585;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3649;&#3621;&#3657;&#3623;',0),(329067,9141,'hi','à¤œà¤®à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(329068,9141,'ms','Deposit yang berjaya disimpan',0),(329069,9141,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø­ÙØ¸Ù‡ Ø¨Ù†Ø¬Ø§Ø­',0),(329070,9141,'fr','DÃ©pÃ´t enregistrÃ© avec succÃ¨s',0),(329071,9141,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚ŒãŸæ²ˆæ®¿ç‰©',0),(329072,9141,'pt','DepÃ³sito com sucesso',0),(329073,9141,'ru','Ð—Ð°Ð»Ð¾Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(329074,9141,'es','DepÃ³sito Guardado Exitosamente ',0),(329075,9141,'de','Einzahlung erfolgreich gespeichert',0),(329076,9141,'en','Deposit Saved Successfully',0),(329077,9142,'is','',0),(329078,9142,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(329079,9142,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† Ø³Ù¾Ø±Ø¯Ù‡( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(329080,9142,'tr','Mevduat kaydedilirken hata oluÅŸtu',0),(329081,9142,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania depozytu',0),(329082,9142,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(329083,9142,'ur','Ø°Ø®ÛŒØ±Û’ Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(329084,9142,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ¿Ñ€ÐµÐ¼Ð°ÑšÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(329085,9142,'vi','Lá»—i sao lÆ°u tiá»n cá»c',0),(329086,9142,'af','Fout met die stoor van deposito',0),(329087,9142,'ro','Eroare la salvarea depozit',0),(329088,9142,'et','Tagatisraha salvestamise tÃµrge',0),(329089,9142,'si','Napaka pri shranjevanju depozit',0),(329090,9142,'ba','Kesalahan Deposit tabungan',0),(329091,9142,'nl','Fout bij het opslaan van storting',0),(329092,9142,'fi','Virhe tallennettaessa Internet',0),(329093,9142,'no','Feil under lagring av innskudd',0),(329094,9142,'da','Fejl under lagring af depositum',0),(329095,9142,'ko','ë³´ì¦ê¸ˆì„ ì €ìž¥ ì˜¤ë¥˜',0),(329096,9142,'he','××™×¨×¢×” ×©×’×™××” ×‘×©×ž×™×¨×ª ×¤×™×§×“×•×Ÿ',0),(329097,9142,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï„Î·Ï‚ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(329098,9142,'zh','é”™è¯¯ä¿å­˜å­˜æ¬¾',0),(329099,9142,'sv','Fel vid sparande av insÃ¤ttning',0),(329100,9142,'it','Errore durante il salvataggio di deposito',0),(329101,9142,'tl','',0),(329102,9142,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;',0),(329103,9142,'hi','à¤œà¤®à¤¾ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(329104,9142,'ms','Ralat Menyimpan Deposit',0),(329105,9142,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹',0),(329106,9142,'fr','Erreur d\'enregistrement de dÃ©pÃ´t',0),(329107,9142,'jp','æ²ˆæ®¿ç‰©ã®ä¿å­˜ã‚¨ãƒ©ãƒ¼',0),(329108,9142,'pt','Erro ao salvar o depÃ³sito',0),(329109,9142,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(329110,9142,'es','Error Guardando el DepÃ³sito',0),(329111,9142,'de','Fehler beim Speichern der Einzahlung',0),(329112,9142,'en','Error Saving Deposit',0),(329113,9143,'is','',0),(329114,9143,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(329115,9143,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù†  Ø³Ù¾Ø±Ø¯Ù‡ (Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(329116,9143,'tr','SipariÅŸ mevduat',0),(329117,9143,'pl','ZÅ‚oÅ¼enia zamÃ³wienia',0),(329118,9143,'bg','Ð—Ð°ÑÐ²ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(329119,9143,'ur','Ø¢Ø±ÚˆØ± Ø¬Ù…Ø¹',0),(329120,9143,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(329121,9143,'vi','Äáº·t cá»c Ä‘Æ¡n hÃ ng',0),(329122,9143,'af','Bestelling Deposito',0),(329123,9143,'ro','Ordinul depozit',0),(329124,9143,'et','Tellimuse tagatisraha',0),(329125,9143,'si','NaroÄilo depozita',0),(329126,9143,'ba','Urutan Deposit',0),(329127,9143,'nl','Volgorde storting',0),(329128,9143,'fi','Jotta talletus',0),(329129,9143,'no','For innskudd',0),(329130,9143,'da','Bestil depositum',0),(329131,9143,'ko','ì£¼ë¬¸ ìž…ê¸ˆ',0),(329132,9143,'he','×¦×• ×”×¤×§×“×”',0),(329133,9143,'el','Î£ÎµÎ¹ÏÎ¬ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½',0),(329134,9143,'zh','è®¢å•å­˜æ¬¾\r\n',0),(329135,9143,'sv','Ordning insÃ¤ttning',0),(329136,9143,'it','Ordine di deposito',0),(329137,9143,'tl','',0),(329138,9143,'th','&#3648;&#3591;&#3636;&#3609;&#3617;&#3633;&#3604;&#3592;&#3635;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(329139,9143,'hi','à¤•à¥à¤°à¤® à¤œà¤®à¤¾',0),(329140,9143,'ms','Deposit perintah',0),(329141,9143,'ar','Ø£Ù…Ø± Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(329142,9143,'fr','DÃ©pÃ´t de l\'ordonnance',0),(329143,9143,'jp','ä¾›è¨—',0),(329144,9143,'pt','DepÃ³sito da ordem',0),(329145,9143,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(329146,9143,'es','DepÃ³sito de Pedido',0),(329147,9143,'de','Bestellung Anzahlung',0),(329148,9143,'en','Order Deposit',0),(329149,9144,'is','',0),(329150,9144,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(329151,9144,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ù‚ÙŠÙ…Øª Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ',0),(329152,9144,'tr','Geri teklif iÃ§in',0),(329153,9144,'pl','PowrÃ³t do oferty',0),(329154,9144,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÐºÑŠÐ¼ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(329155,9144,'ur','Ù¾ÛŒÚ†Ú¾Û’ Ø³Û’ Ø§Ù‚ØªØ¨Ø§Ø³',0),(329156,9144,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ñƒ Ð·Ð°',0),(329157,9144,'vi','Quay láº¡i bÃ¡o giÃ¡',0),(329158,9144,'af','Terug na Kwotasie',0),(329159,9144,'ro','ÃŽnapoi la citat',0),(329160,9144,'et','Aastasse Quote',0),(329161,9144,'si','Nazaj na ponudbo',0),(329162,9144,'ba','Kembali ke kutipan',0),(329163,9144,'nl','Terug naar Quote',0),(329164,9144,'fi','Takaisin lainatakseni',0),(329165,9144,'no','Tilbake til tilbud',0),(329166,9144,'da','Tilbage til citat',0),(329167,9144,'ko','ê²¬ì ì„ ë‹¤ì‹œ',0),(329168,9144,'he','×—×–×¨×” ×œ×¦×˜×˜',0),(329169,9144,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(329170,9144,'zh','å›žåˆ°æŠ¥ä»·\r\n',0),(329171,9144,'sv','Tillbaka till citat',0),(329172,9144,'it','Torna a citare',0),(329173,9144,'tl','',0),(329174,9144,'th','&#3585;&#3621;&#3633;&#3610;&#3626;&#3641;&#3656;&#3585;&#3634;&#3619;&#3649;&#3592;&#3657;&#3591;',0),(329175,9144,'hi','à¤µà¤¾à¤ªà¤¸ à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(329176,9144,'ms','Kembali kepada sebut harga',0),(329177,9144,'ar','Ø§Ù„Ø±Ø¬ÙˆØ¹ Ø¥Ù„Ù‰ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ',0),(329178,9144,'fr','Retour Ã  cite',0),(329179,9144,'jp','å¼•ç”¨ã™ã‚‹',0),(329180,9144,'pt','Voltar Ã  citaÃ§Ã£o',0),(329181,9144,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(329182,9144,'es','Regresar a la CotizaciÃ³n',0),(329183,9144,'de','ZurÃ¼ck zu zitieren',0),(329184,9144,'en','Back to Quote',0),(329185,9145,'is','',0),(329186,9145,'dr','.ÙØ±Ù…Ø§ÛŒØ´ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ ÙŠØ§ Ø¯Ø±ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(329187,9145,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ Ù†ÙŠØ³Øª.Ø³ÙØ§Ø±Ø´ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ ÙŠØ§ Ø¯Ø±ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(329188,9145,'tr','SipariÅŸ silemezsiniz. SipariÅŸ sevk veya fatura.',0),(329189,9145,'pl','Nie moÅ¼na usunÄ…Ä‡ zamÃ³wienia. ZamÃ³wienie zostaÅ‚o wysÅ‚ane lub zapowiadane.',0),(329190,9145,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ðµ Ñ€ÐµÐ´. ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ðµ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð° Ð¸Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð°.',0),(329191,9145,'ur','ØªØ±ØªÛŒØ¨ Ø­Ø°Ù Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§ Û” Ø­Ú©Ù… Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ ÛŒØ§ Ø¨Ø§Ù„Ù„Ø§Ø¯ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(329192,9145,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ñ€ÐµÐ´. ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸ Ð¸Ð»Ð¸ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½.',0),(329193,9145,'vi','KhÃ´ng há»§y Ä‘Æ°á»£c Ä‘Æ¡n Ä‘áº·t hÃ ng. ÄÆ¡n Ä‘áº·t HÃ ng Ä‘Ã£ váº­n chuyá»ƒn hoáº·c Ä‘Ã£ ra hÃ³a Ä‘Æ¡n',0),(329194,9145,'af','Kan nie Bestelling skrap.  Bestelling is alreeds versend of gefaktureer.',0),(329195,9145,'ro','Imposibil de È™ters ordine. Ordinul a fost expediat sau facturat.',0),(329196,9145,'et','Ei saa tellimust kustutada. Tellimus on tarnitud vÃµi on selle kohta arve koostatud.',0),(329197,9145,'si','Naloga ne morete izbrisati. Nalog je dobavljen ali zaraÄunali.',0),(329198,9145,'ba','Tidak dapat menghapus Order. Pesanan dikirim atau ditagih.',0),(329199,9145,'nl','Order kan niet verwijderen. Bestelling is verzonden of gefactureerd.',0),(329200,9145,'fi','Ei voi poistaa tilauksen. Tilaus on toimitettu tai laskutettu.',0),(329201,9145,'no','Kan ikke slette ordre. Bestillingen er levert eller fakturert.',0),(329202,9145,'da','Kan ikke slette orden. Ordren er blevet leveret eller faktureret.',0),(329203,9145,'ko','ìˆœì„œë¥¼ ì‚­ì œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤. ì£¼ë¬¸ ë°°ì†¡ ë˜ê±°ë‚˜ ì²­êµ¬.',0),(329204,9145,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×—×•×§ ×”×–×ž× ×”. ×”×–×ž× ×” ×©×‘×•×¦×¢×” ×©× ×©×œ×—×• ××• ×”×—×™×•×‘.',0),(329205,9145,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î·Î½ ÎµÎ½Ï„Î¿Î»Î®. Î£ÎµÎ¹ÏÎ¬ Î­Ï‡ÎµÎ¹ Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯ Î® Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹.',0),(329206,9145,'zh','ä¸èƒ½åˆ é™¤è®¢å•ã€‚è®¢å•å·²ç»è£…è¿æˆ–è€…ç»“ç®—..\r\n',0),(329207,9145,'sv','Kan inte ta bort Order. BestÃ¤llning har levererats eller faktureras.',0),(329208,9145,'it','Non Ã¨ possibile eliminare l\'ordine. Ordine Ã¨ stato spedito o fatturati.',0),(329209,9145,'tl','',0),(329210,9145,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3621;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; &#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3617;&#3637;&#3585;&#3634;&#3619;&#',0),(329211,9145,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¨à¤¹à¥€à¤‚ à¤¹à¤Ÿà¤¾ à¤¸à¤•à¤¤à¥‡à¥¤ à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤¯à¤¾ à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(329212,9145,'ms','Tidak dapat menghapuskan perintah. Pesanan telah dihantar atau dibilkan.',0),(329213,9145,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø­Ø°Ù Ù…Ù† Ø§Ù„Ù†Ø¸Ø§Ù…. Ø£Ù…Ø± ØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ø£Ùˆ ÙÙˆØ§ØªÙŠØ±.',0),(329214,9145,'fr','Ne pouvez pas supprimer l\'ordre. Commande a Ã©tÃ© expÃ©diÃ©e ou facturÃ©.',0),(329215,9145,'jp','æ³¨æ–‡ã‚’å‰Šé™¤ã§ãã¾ã›ã‚“ã€‚æ³¨æ–‡ã‚’å‡ºè·ã¾ãŸã¯è«‹æ±‚ã•ã‚Œã¾ã—ãŸã€‚',0),(329216,9145,'pt','NÃ£o Ã© possÃ­vel excluir a ordem. Ordem tem sido enviado ou faturado.',0),(329217,9145,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·. Ð—Ð°ÐºÐ°Ð· Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½ Ð¸Ð»Ð¸ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚.',0),(329218,9145,'es','No se puede eliminar el Orden. El Orden se enviÃ³ o se FacturÃ³',0),(329219,9145,'de','Bestellung kann nicht gelÃ¶scht werden. Bestellung hat ausgeliefert oder in Rechnung gestellt.',0),(329220,9145,'en','Cannot Delete Order. Order has been shipped or billed.',0),(329221,9146,'is','',0),(329222,9146,'dr','.Ø²ÙŠØ±Ø§ ÙØ±Ù…Ø§ÛŒØ´ ÙŠÙƒ Ø³Ù¾Ø±Ø¯Ù‡(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ø¶Ù…ÙŠÙ…Ù‡ Ø¯Ø§Ø±Ø¯',0),(329223,9146,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ Ù†ÙŠØ³Øª.Ø²ÙŠØ±Ø§ Ø³ÙØ§Ø±Ø´ ÙŠÙƒ Ø³Ù¾Ø±Ø¯Ù‡(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ø¶Ù…ÙŠÙ…Ù‡ Ø¯Ø§Ø±Ø¯',0),(329224,9146,'tr','SipariÅŸ silemezsiniz. Ekli bir Ã¶deme sahiptir.',0),(329225,9146,'pl','Nie moÅ¼na usunÄ…Ä‡ zamÃ³wienia. ZamÃ³wienie ma depozyt doÅ‚Ä…czone.',0),(329226,9146,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ðµ Ñ€ÐµÐ´. ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¸Ð¼Ð° Ð¿Ñ€Ð¸ÐºÑ€ÐµÐ¿ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚.',0),(329227,9146,'ur','ØªØ±ØªÛŒØ¨ Ø­Ø°Ù Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§ Û” ØªØ±ØªÛŒØ¨ Ø³Û’ Ù…Ù†Ø³Ù„Ú© Ø§ÛŒÚ© Ø¬Ù…Ø¹ ÛÛ’ Û”',0),(329228,9146,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ñ€ÐµÐ´. ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð²ÐµÐ·Ð°Ð½.',0),(329229,9146,'vi','KhÃ´ng há»§y Ä‘Æ°á»£c Ä‘Æ¡n Ä‘áº·t hÃ ng. ÄÆ¡n Ä‘áº·t HÃ ng cÃ³ tiá»n cá»c kÃ¨m theo',0),(329230,9146,'af','Kan nie skrap orde. Orde het \'n deposito aangeheg.',0),(329231,9146,'ro','Imposibil de È™ters ordine. Ordinul are un depozit ataÅŸat.',0),(329232,9146,'et','Ei saa kustutada. Tellimus on kinnitatud maardla.',0),(329233,9146,'si','Naloga ne morete izbrisati. Reda je priloÅ¾eno depozit.',0),(329234,9146,'ba','Tidak dapat menghapus Order. Urutan memiliki deposit terpasang.',0),(329235,9146,'nl','Order kan niet verwijderen. Order heeft een storting gekoppeld.',0),(329236,9146,'fi','Ei voi poistaa tilauksen. On kiinnitetty talletus.',0),(329237,9146,'no','Kan ikke slette ordre. Ordre har et innskudd knyttet.',0),(329238,9146,'da','Kan ikke slette orden. Ordren har en indbetaling knyttet.',0),(329239,9146,'ko','ìˆœì„œë¥¼ ì‚­ì œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤. ìˆœì„œëŠ” ì—°ê²° ëœ ì˜ˆê¸ˆì´ ìžˆë‹¤.',0),(329240,9146,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×—×•×§ ×”×–×ž× ×”. ×”×¡×“×¨ ×›×•×œ×œ ×¤×™×§×“×•×Ÿ ×¦×ž×•×“.',0),(329241,9146,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î·Î½ ÎµÎ½Ï„Î¿Î»Î®. Î£ÎµÎ¹ÏÎ¬ Î­Ï‡ÎµÎ¹ Î¼Î¹Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï€Î¿Ï… ÎµÏ€Î¹ÏƒÏ…Î½Î¬Ï€Ï„ÎµÏ„Î±Î¹.',0),(329242,9146,'zh','ä¸èƒ½åˆ é™¤è®¢å•ã€‚æœ‰ä¸€ä¸ªå­˜æ¬¾é™„åŽã€‚\r\n',0),(329243,9146,'sv','Kan inte ta bort Order. Order har en insÃ¤ttning som bifogas.',0),(329244,9146,'it','Non Ã¨ possibile eliminare l\'ordine. Ordine ha un deposito collegato.',0),(329245,9146,'tl','',0),(329246,9146,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3621;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; &#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3649;&#3609;&#',0),(329247,9146,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¨à¤¹à¥€à¤‚ à¤¹à¤Ÿà¤¾ à¤¸à¤•à¤¤à¥‡à¥¤ à¤•à¥à¤°à¤® à¤¸à¥‡ à¤œà¥à¤¡à¤¼à¥€ à¤à¤• à¤œà¤®à¤¾ à¤¹à¥ˆà¥¤',0),(329248,9146,'ms','Tidak dapat menghapuskan perintah. Pesanan mempunyai deposit yang dilampirkan.',0),(329249,9146,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø­Ø°Ù Ù…Ù† Ø§Ù„Ù†Ø¸Ø§Ù…. ÙˆÙ‚Ø¯ Ø£Ù…Ø± ÙˆØ¯ÙŠØ¹Ø© Ø§Ù„Ù…Ø±ÙÙ‚Ø©.',0),(329250,9146,'fr','Ne pouvez pas supprimer l\'ordre. Ordre a un dÃ©pÃ´t attachÃ©.',0),(329251,9146,'jp','æ³¨æ–‡ã‚’å‰Šé™¤ã§ãã¾ã›ã‚“ã€‚é †åºã¯ã€æŽ¥ç¶šã•ã‚Œã¦ã„ã‚‹é é‡‘ã€‚',0),(329252,9146,'pt','NÃ£o Ã© possÃ­vel excluir a ordem. A ordem tem um depÃ³sito anexado.',0),(329253,9146,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·. Ðš Ð—Ð°ÐºÐ°Ð·Ñƒ Ð¿Ñ€Ð¸ÐºÑ€ÐµÐ¿Ð»ÐµÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚.',0),(329254,9146,'es','No se Puede Eliminar el Orden. El Orden Tiene un depÃ³sito adjunto',0),(329255,9146,'de','Bestellung kann nicht gelÃ¶scht werden. Auftrag hat eine Anzahlung verbunden.',0),(329256,9146,'en','Cannot Delete Order. Order has a deposit attached.',0),(329257,9147,'is','',0),(329258,9147,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(329259,9147,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(329260,9147,'tr','SipariÅŸ baÅŸarÄ±yla silindi',0),(329261,9147,'pl','Aby pomyÅ›lnie usuniÄ™ty',0),(329262,9147,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(329263,9147,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(329264,9147,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(329265,9147,'vi','XÃ³a Ä‘Æ¡n hÃ ng thÃ nh cÃ´ng',0),(329266,9147,'af','Bestelling Suksesvol Geskrap',0),(329267,9147,'ro','ComandÄƒ eliminÄƒ cu succes',0),(329268,9147,'et','Et edukalt kustutatud',0),(329269,9147,'si','Naloga uspeÅ¡no izbrisana',0),(329270,9147,'ba','Order yang dihapus berhasil',0),(329271,9147,'nl','Volgorde met succes verwijderd',0),(329272,9147,'fi','Tilaus poistettiin onnistuneesti',0),(329273,9147,'no','Bestill slettet',0),(329274,9147,'da','Bestil slettet',0),(329275,9147,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ìˆœì„œ',0),(329276,9147,'he','×¡×“×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(329277,9147,'el','Î£ÎµÎ¹ÏÎ¬ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(329278,9147,'zh','è®¢å•æˆåŠŸåˆ é™¤\r\n',0),(329279,9147,'sv','Ordning raderades',0),(329280,9147,'it','Ordine cancellato con successo',0),(329281,9147,'tl','',0),(329282,9147,'th','&#3621;&#3610;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3649;&#3621;&#3657;&#3623;',0),(329283,9147,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(329284,9147,'ms','Perintah yang dihapuskan dengan jayanya',0),(329285,9147,'ar','Ø­Ø°ÙØª Ø§Ù„Ø·Ù„Ø¨ÙŠÙ‘Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(329286,9147,'fr','Ordre supprimÃ© avec succÃ¨s',0),(329287,9147,'jp','æ³¨æ–‡ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(329288,9147,'pt','Ordem apagado com sucesso',0),(329289,9147,'ru','Ð—Ð°ÐºÐ°Ð· Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½',0),(329290,9147,'es','Pedido Eliminado Exitosamente',0),(329291,9147,'de','Bestellung erfolgreich gelÃ¶scht',0),(329292,9147,'en','Order Deleted Successfully',0),(329293,9148,'is','',0),(329294,9148,'dr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø§Ø² Ø§Ø³Ù†Ø§Ø¯  Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ù†Ø§Ø®ÙˆØ§Ø³ØªÙ‡ ',0),(329295,9148,'pr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø§Ø² Ø§Ø³Ù†Ø§Ø¯  Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ù†Ø§Ø®ÙˆØ§Ø³ØªÙ‡ ',0),(329296,9148,'tr','Ã–zel alanlardan istenmeyen mÃ¼ÅŸteri kayÄ±tlarÄ±',0),(329297,9148,'pl','Niestandardowe pola z rekordÃ³w klientÃ³w niepoÅ¼Ä…danych',0),(329298,9148,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð¾Ñ‚ Ð½ÐµÐ¶ÐµÐ»Ð°Ð½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(329299,9148,'ur','Ù†Ø§Ù¾Ø³Ù†Ø¯ÛŒØ¯Û Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø³Û’ Ù…Ø®ØµÙˆØµ Ù‚Ø·Ø¹Ø§Øª',0),(329300,9148,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ñ™Ð° Ð¸Ð· Ð·Ð°Ð¿Ð¸ÑÐ° Ð¾ ÐÐ•Ð–Ð•Ð‰Ð•ÐÐ˜Ðœ ÐºÑƒÐ¿Ñ†Ð°',0),(329301,9148,'vi','TrÆ°á»ng tá»± táº¡o tá»« há»“ sÆ¡ khÃ¡ch hÃ ng khÃ´ng cáº§n',0),(329302,9148,'af','Aangepasde Velde vanaf ONGEWENSDE Klant / KliÃ«ntRekords',0),(329303,9148,'ro','CÃ¢mpuri particularizate la nedorite client de Ã®nregistrÄƒri',0),(329304,9148,'et','Kohandatud SOOVIMATU kliendi kirjete vÃ¤ljade',0),(329305,9148,'si','Polja po meri od NEZAÅ½ELEN kupca zapisov',0),(329306,9148,'ba','Bidang kustom dari catatan yang tidak diinginkan pelanggan',0),(329307,9148,'nl','Aangepaste velden van ongewenste klantrecords',0),(329308,9148,'fi','Mukautetut kentÃ¤t ei-TOIVOTTUJA asiakastietueita',0),(329309,9148,'no','Egendefinerte felt fra uÃ¸nskede kundeoppfÃ¸ringer',0),(329310,9148,'da','Brugerdefinerede felter fra uÃ¸nskede kundeposter',0),(329311,9148,'ko','ì›ì¹˜ ì•ŠëŠ” ê³ ê° ë ˆì½”ë“œì—ì„œ ì‚¬ìš©ìž ì •ì˜ í•„ë“œ',0),(329312,9148,'he','×©×“×•×ª ×ž×•×ª××ž×™× ××™×©×™×ª ×©×œ ×¨×©×•×ž×•×ª ×©×œ ×œ×§×•×—×•×ª ×œ× ×¨×¦×•×™×™×',0),(329313,9148,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î± Ï€ÎµÎ´Î¯Î± Î±Ï€ÏŒ Ï„Î¹Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Ï€ÎµÎ»Î¬Ï„Î· Î‘ÎÎ•Î Î™Î˜ÎŽÎœÎ—Î¤Î‘',0),(329314,9148,'zh','ä»Žä¸å¿…è¦çš„å®¢æˆ·è®°å½•ä¸­è‡ªå®šä¹‰å­—æ®µ\r\n',0),(329315,9148,'sv','Anpassade fÃ¤lt frÃ¥n oÃ¶nskade kundposter',0),(329316,9148,'it','Campi personalizzati da record clienti indesiderati',0),(329317,9148,'tl','',0),(329318,9148,'th','&#3611;&#3619;&#3633;&#3610;&#3649;&#3605;&#3656;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3592;&#3634;&#3585;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3',0),(329319,9148,'hi','à¤…à¤µà¤¾à¤‚à¤›à¤¿à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤¸à¥‡ à¤•à¤¸à¥à¤Ÿà¤® à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸',0),(329320,9148,'ms','Bidang-bidang adat dari rekod-rekod pelanggan yang tidak diingini',0),(329321,9148,'ar','Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ø®ØµØµØ© Ù…Ù† Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ØºÙŠØ± Ø§Ù„Ù…Ø±ØºÙˆØ¨ ÙÙŠÙ‡Ø§',0),(329322,9148,'fr','Champs personnalisÃ©s de dossiers clients indÃ©sirables',0),(329323,9148,'jp','ä¸è¦ãªé¡§å®¢ãƒ¬ã‚³ãƒ¼ãƒ‰ã®ã‚«ã‚¹ã‚¿ãƒ  ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(329324,9148,'pt','Campos personalizados de registros de clientes indesejados',0),(329325,9148,'ru','ÐÐ°ÑÑ‚Ñ€Ð°Ð¸Ð²Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ð¾Ð»Ñ Ð¸Ð· Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ Ð½ÐµÐ¶ÐµÐ»Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(329326,9148,'es','Campos Personalizados de Records del Cliente NO QUERIDO',0),(329327,9148,'de','Benutzerdefinierte Felder aus unerwÃ¼nschten KundendatensÃ¤tze',0),(329328,9148,'en','Custom Fields From UNWANTED Customer Records',0),(329329,9149,'is','',0),(329330,9149,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø§ØµÙ„ÙŠ',0),(329331,9149,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø§ØµÙ„ÙŠ',0),(329332,9149,'tr','Ana mÃ¼ÅŸteri',0),(329333,9149,'pl','Master klienta',0),(329334,9149,'bg','ÐœÐ°Ð³Ð¸ÑÑ‚ÑŠÑ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(329335,9149,'ur','Ú©Ø³Ù¹Ù…Ø± Ù…Ø§Ø³Ù¹Ø±',0),(329336,9149,'sr','Ð“Ð¾ÑÐ¿Ð¾Ð´Ð°Ñ€ ÐºÑƒÐ¿Ñ†Ð°',0),(329337,9149,'vi','KhÃ¡ch hÃ ng chá»§',0),(329338,9149,'af','Meester Klant/KliÃ«nt',0),(329339,9149,'ro','Master client',0),(329340,9149,'et','Kapten kliendi',0),(329341,9149,'si','Master kupca',0),(329342,9149,'ba','Pelanggan Master',0),(329343,9149,'nl','Master klant',0),(329344,9149,'fi','Master asiakkaan',0),(329345,9149,'no','Master kunde',0),(329346,9149,'da','Master kunde',0),(329347,9149,'ko','ë§ˆìŠ¤í„° ê³ ê°',0),(329348,9149,'he','×‘×¡×™×¡ ×œ×§×•×—×•×ª',0),(329349,9149,'el','Master Ï€ÎµÎ»Î¬Ï„Î·',0),(329350,9149,'zh','æŽŒæ¡å®¢æˆ·\r\n',0),(329351,9149,'sv','Master kund',0),(329352,9149,'it','Cliente Master',0),(329353,9149,'tl','',0),(329354,9149,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3627;&#3621;&#3633;&#3585;',0),(329355,9149,'hi','à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤—à¥à¤°à¤¾à¤¹à¤•',0),(329356,9149,'ms','Pelanggan utama',0),(329357,9149,'ar','Ø§Ù„Ø²Ø¨ÙˆÙ† Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ',0),(329358,9149,'fr','Master client',0),(329359,9149,'jp','é¡§å®¢ãƒžã‚¹ã‚¿ãƒ¼',0),(329360,9149,'pt','Mestre de cliente',0),(329361,9149,'ru','ÐœÐ°ÑÑ‚ÐµÑ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(329362,9149,'es','Cliente Maestro',0),(329363,9149,'de','Master-Kunden',0),(329364,9149,'en','Master Customer',0),(329365,9150,'is','',0),(329366,9150,'dr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯  Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  Ø¯Ø± Ø§ÙŠÙ† Ø«Ø¨Øª Ø§ØµÙ„ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(329367,9150,'pr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯  Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  Ø¯Ø± Ø§ÙŠÙ† Ø«Ø¨Øª Ø§ØµÙ„ÙŠ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(329368,9150,'tr','Bu ana mÃ¼ÅŸteri kaydÄ± birleÅŸtirme',0),(329369,9150,'pl','ScaliÄ‡ ten rekord klienta MASTER',0),(329370,9150,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð² Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ñ‚Ð¾Ð·Ð¸ Ð¾Ð±Ñ€Ð°Ð·ÐµÑ†',0),(329371,9150,'ur','ÛŒÛ Ù…Ø§Ø³Ù¹Ø± Ú¯Ø§ÛÚ© Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ù…ÛŒÚº Ø¶Ù… Ú©Ø±ÛŒÚº',0),(329372,9150,'sr','ÐžÐ±Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ‚Ðµ Ñƒ Ð¾Ð²Ð°Ñ˜ Ð³Ð»Ð°Ð²Ð½Ð¸ Ð·Ð°Ð¿Ð¸Ñ ÐºÑƒÐ¿Ñ†Ð°',0),(329373,9150,'vi','SÃ¡t nháº­p Há»“ sÆ¡ KhÃ¡ch hÃ ng vÃ o há»“ sÆ¡ khÃ¡ch hÃ ng Chá»§ nÃ y',0),(329374,9150,'af','Verenig Klante/KliÃ«nte Rekords BINNE Hierdie Klant/KliÃ«nt Rekord',0),(329375,9150,'ro','ÃŽmbinare Ã®n aceastÄƒ Ã®nregistrare client MASTER',0),(329376,9150,'et','Koosta kliendi pÃµhikirje',0),(329377,9150,'si','Spojite zapis o kupcu MASTER',0),(329378,9150,'ba','Menggabungkan ke dalam Catatan ini pelanggan MASTER',0),(329379,9150,'nl','Deze MASTER klant Record samenvoegen',0),(329380,9150,'fi','YhdistÃ¤ tÃ¤mÃ¤ MASTER asiakastietue',0),(329381,9150,'no','Flette i denne MASTER kundepost',0),(329382,9150,'da','Flette ind i denne MASTER kundepost',0),(329383,9150,'ko','ì´ ë§ˆìŠ¤í„° ê³ ê° ë ˆì½”ë“œ ë³‘í•©',0),(329384,9150,'he','×œ×ž×–×’ ××ª ×¨×©×•×ž×ª ×”×œ×§×•×—',0),(329385,9150,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· ÏƒÎµ Î±Ï…Ï„ÏŒ ÎºÏÏÎ¹Î± ÎµÎ³Î³ÏÎ±Ï†Î® Ï€ÎµÎ»Î¬Ï„Î·',0),(329386,9150,'zh','åˆå¹¶å®¢æˆ·è®°å½•åˆ°æ­¤å®¢æˆ·è®°å½•ç®¡ç†\r\n',0),(329387,9150,'sv','Koppla till detta MASTER kundposten',0),(329388,9150,'it','Unire in questo MASTER Record cliente',0),(329389,9150,'tl','',0),(329390,9150,'th','&#3619;&#3623;&#3617;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3648;&#3586;&#3657;&#3634;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3617;&#3634;&#3626;&#3648;&#3',0),(329391,9150,'hi','à¤‡à¤¸ à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤®à¥‡à¤‚ à¤®à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(329392,9150,'ms','Menggabungkan ke dalam rekod pelanggan Induk ini',0),(329393,9150,'ar','Ø¯Ù…Ø¬ Ø³Ø¬Ù„Ù‘Ø§Øª Ø§Ù„Ø²Ø¨Ø§Ø¦Ù† ÙÙŠ Ø³Ø¬Ù„Ù‘ Ø§Ù„Ø²Ø¨ÙˆÙ† Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ',0),(329394,9150,'fr','Fusionner dans cet enregistrement de client maÃ®tre',0),(329395,9150,'jp','ã“ã®ãƒžã‚¹ã‚¿ãƒ¼ã®é¡§å®¢ãƒ¬ã‚³ãƒ¼ãƒ‰ã«ãƒžãƒ¼ã‚¸ã—ã¾ã™ã€‚',0),(329396,9150,'pt','Mesclar esse registro mestre do cliente',0),(329397,9150,'ru','ÐžÐ±ÑŠÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒ Ð² ÑÑ‚Ð¾Ñ‚ Ð¼Ð°ÑÑ‚ÐµÑ€ Ð·Ð°Ð¿Ð¸ÑÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(329398,9150,'es','Fusionar Records de Clientes EN este Record de Cliente MAESTRO',0),(329399,9150,'de','MIT diesem MASTER-Kunden-Datensatz zusammenfÃ¼hren',0),(329400,9150,'en','Merge INTO this MASTER Customer Record',0),(329401,9151,'is','',0),(329402,9151,'dr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† Ø§Ø² Ø§Ø³Ù†Ø§Ø¯ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ù†Ø§ Ø®ÙˆØ§Ø³ØªÙ‡  Ø¯Ø± Ø®Ø±ÙŠØ¯Ø§Ø± Ø§ØµÙ„ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ù„Ø§ ',0),(329403,9151,'pr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† Ø§Ø² Ø§Ø³Ù†Ø§Ø¯ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ù†Ø§ Ø®ÙˆØ§Ø³ØªÙ‡  Ø¯Ø± Ø®Ø±ÙŠØ¯Ø§Ø± Ø§ØµÙ„ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ù„Ø§ ',0),(329404,9151,'tr','Bu istenmeyen mÃ¼ÅŸteri kayÄ±tlarÄ± birleÅŸtirme',0),(329405,9151,'pl','Scal z tych rekordÃ³w NIECHCIANEGO klienta',0),(329406,9151,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð¾Ñ‚ Ñ‚ÐµÐ·Ð¸ Ð½ÐµÐ¶ÐµÐ»Ð°Ð½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(329407,9151,'ur','Ø§Ù† Ù†Ø§Ù¾Ø³Ù†Ø¯ÛŒØ¯Û Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø³Û’ Ø¶Ù… Ú©Ø±ÛŒÚº',0),(329408,9151,'sr','ÐžÐ±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐµ Ð¿Ð¾ÑˆÑ‚Ðµ Ð¸Ð· Ð¾Ð²Ðµ Ð·Ð°Ð¿Ð¸ÑÐµ ÐÐ•Ð–Ð•Ð‰Ð•ÐÐ˜ ÐºÑƒÐ¿Ñ†Ð°',0),(329409,9151,'vi','SÃ¡t nháº­p Há»“ sÆ¡ KhÃ¡ch hÃ ng khÃ´ng muá»‘n vÃ o há»“ sÆ¡ khÃ¡ch hÃ ng Chá»§ Ä‘Ã£ chá»n á»Ÿ trÃªn',0),(329410,9151,'af','Verenig VANAF Hierdie ONGEWENSDE Klante/KliÃ«nte Rekords Binne-In die Meester Klante/KliÃ«nte soos Bo Geselekteer',0),(329411,9151,'ro','ÃŽmbinare din aceste Ã®nregistrÄƒri client nedorite',0),(329412,9151,'et','Neid SOOVIMATU klient kirjete Ã¼hendamine',0),(329413,9151,'si','Spoji iz teh evidenc NEZAÅ½ELEN kupca',0),(329414,9151,'ba','Menggabungkan dari catatan yang tidak diinginkan pelanggan ini',0),(329415,9151,'nl','VANUIT deze ongewenste klantrecords samenvoegen',0),(329416,9151,'fi','YhdistÃ¤Ã¤ nÃ¤mÃ¤ ei-toivotut ASIAKASTIETUEISIIN',0),(329417,9151,'no','Flette fra disse uÃ¸nskede kundeoppfÃ¸ringer',0),(329418,9151,'da','Flette fra disse uÃ¸nskede kundeposter',0),(329419,9151,'ko','ì´ëŸ¬í•œ ì›ì¹˜ ì•ŠëŠ” ê³ ê° ë ˆì½”ë“œ ë³‘í•©',0),(329420,9151,'he','×ž×™×–×•×’ ×ž×¨×©×•×ž×•×ª ××œ×” ×œ×§×•×—×•×ª ×œ× ×¨×¦×•×™×™×',0),(329421,9151,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· Î±Ï€ÏŒ Î±Ï…Ï„Î¬ Ï„Î± Î±ÏÏ‡ÎµÎ¯Î± Î‘ÎÎ•Î Î™Î˜ÎŽÎœÎ—Î¤Î‘ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(329422,9151,'zh','ä»Žè¿™äº›æ— ç”¨å®¢æˆ·è®°å½•åˆå¹¶åˆ°ä¸Šé¢é€‰æ‹©çš„é¡¾å®¢ç®¡ç†\r\n',0),(329423,9151,'sv','Koppla frÃ¥n dessa oÃ¶nskade kundposter',0),(329424,9151,'it','Unire da questi record clienti indesiderati',0),(329425,9151,'tl','',0),(329426,9151,'th','Merge FROM These UNWANTED Customer Records Into The Master Customer Selected Above',0),(329427,9151,'hi','à¤‡à¤¨ à¤…à¤µà¤¾à¤‚à¤›à¤¿à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤¸à¥‡ à¤®à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(329428,9151,'ms','Gabungkan dari rekod-rekod ini tidak diingini pelanggan',0),(329429,9151,'ar','Ø¯Ù…Ø¬ Ù…Ù† Ù‡Ø°Ù‡ Ø§Ù„Ø³Ø¬Ù„Ø§Øª ØºÙŠØ± Ø§Ù„Ù…Ø±ØºÙˆØ¨ ÙÙŠÙ‡Ø§ Ù…Ù† Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(329430,9151,'fr','Fusion de ces enregistrements de clients indÃ©sirables',0),(329431,9151,'jp','ã“ã‚Œã‚‰ã®ä¸è¦ãªé¡§å®¢ãƒ¬ã‚³ãƒ¼ãƒ‰ã‹ã‚‰å·®ã—è¾¼ã¿å°åˆ·ã—ã¾ã™ã€‚',0),(329432,9151,'pt','Mesclar a partir destes registros de clientes indesejados',0),(329433,9151,'ru','Ð¡Ð»Ð¸ÑÐ½Ð¸Ðµ Ð¸Ð· Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ ÑÑ‚Ð¸Ñ… Ð½ÐµÐ¶ÐµÐ»Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(329434,9151,'es','Fusionar DE Estes Records de Clientes NO QUERIDOS EN este Cliente MAESTRO Arriba Seleccionado',0),(329435,9151,'de','ZusammenfÃ¼hren von diesen unerwÃ¼nschten KundendatensÃ¤tze',0),(329436,9151,'en','Merge FROM These UNWANTED Customer Records',0),(329437,9152,'is','',0),(329438,9152,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ù†Ø§Ø®ÙˆØ§Ø³ØªÙ‡ ',0),(329439,9152,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ù†Ø§Ø®ÙˆØ§Ø³ØªÙ‡ ',0),(329440,9152,'tr','Ä°stenmeyen mÃ¼ÅŸteri',0),(329441,9152,'pl','Niechcianego klienta',0),(329442,9152,'bg','ÐÐµÐ¶ÐµÐ»Ð°Ð½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(329443,9152,'ur','Ù†Ø§Ù¾Ø³Ù†Ø¯ÛŒØ¯Û Ú¯Ø§ÛÚ©ÙˆÚº',0),(329444,9152,'sr','ÐÐµÐ¶ÐµÑ™ÐµÐ½Ð¸ ÐºÑƒÐ¿Ñ†Ð°',0),(329445,9152,'vi','KhÃ¡ch hÃ ng khÃ´ng mong muá»‘n',0),(329446,9152,'af','Ongewensde Klant / KliÃ«nt',0),(329447,9152,'ro','Nedorite client',0),(329448,9152,'et','Soovimatu klient',0),(329449,9152,'si','NezaÅ¾elen kupca',0),(329450,9152,'ba','Pelanggan yang tidak diinginkan',0),(329451,9152,'nl','Ongewenste klant',0),(329452,9152,'fi','Ei-toivottu asiakas',0),(329453,9152,'no','UÃ¸nsket kunde',0),(329454,9152,'da','UÃ¸nskede kunde',0),(329455,9152,'ko','ì›ì¹˜ ì•ŠëŠ” ê³ ê°',0),(329456,9152,'he','×œ×§×•×— ×œ× ×¨×¦×•×™',0),(329457,9152,'el','Î‘Î½ÎµÏ€Î¹Î¸ÏÎ¼Î·Ï„Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(329458,9152,'zh','ä¸éœ€è¦çš„å®¢æˆ·\r\n',0),(329459,9152,'sv','OÃ¶nskade kund',0),(329460,9152,'it','Cliente indesiderato',0),(329461,9152,'tl','',0),(329462,9152,'th','&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(329463,9152,'hi','à¤…à¤µà¤¾à¤‚à¤›à¤¿à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(329464,9152,'ms','Pelanggan yang tidak diingini',0),(329465,9152,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ØºÙŠØ± Ø§Ù„Ù…Ø±ØºÙˆØ¨ ÙÙŠÙ‡Ø§',0),(329466,9152,'fr','Client non dÃ©sirÃ©',0),(329467,9152,'jp','ä¸è¦ãªé¡§å®¢',0),(329468,9152,'pt','Cliente indesejado',0),(329469,9152,'ru','ÐÐµÐ¶ÐµÐ»Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(329470,9152,'es','Client No Querido',0),(329471,9152,'de','UnerwÃ¼nschte Kunden',0),(329472,9152,'en','Unwanted Customer',0),(329473,9153,'is','',0),(329474,9153,'dr','_ Ø­Ù…Ù„ Ø¨Ù‡ ..._  Ø¯Ø± _ Ø­Ù…Ù„ Ø¨Ù‡ ..._ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ù„Ø§ ',0),(329475,9153,'pr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† Ø§Ø² Ø§ÙŠÙ† Ø§Ø³Ù†Ø§Ø¯_ Ø­Ù…Ù„ Ø¨Ù‡ ..._  Ø¯Ø± _ Ø­Ù…Ù„ Ø¨Ù‡ ..._ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø¨Ø§Ù„Ø§ ',0),(329476,9153,'tr','YukarÄ±da seÃ§ilen gÃ¶nderilecek iÃ§ine bu gÃ¶nderilecek kayÄ±tlarÄ± birleÅŸtirme',0),(329477,9153,'pl','ScaliÄ‡ z tych statkÃ³w do rekordÃ³w w statku do wybranego powyÅ¼ej',0),(329478,9153,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð¾Ñ‚ Ñ‚ÐµÐ·Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð± Ð² ÐºÐ¾Ñ€Ð°Ð± Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ',0),(329479,9153,'ur','ÛŒÛ Ø¬ÛØ§Ø² Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø³Û’ Ù…ÛŒÚº Ú©Ø´ØªÛŒ-Ø¯Ø±Ø¬ Ø¨Ø§Ù„Ø§ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ø¶Ù… Ú©Ø±ÛŒÚº',0),(329480,9153,'sr','ÐžÐ±Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ‚Ðµ Ð¸Ð· Ð¾Ð²Ð¸Ñ… Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð° Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½ Ð³Ð¾Ñ€Ðµ',0),(329481,9153,'vi','Nháº­p tá»« há»“ sÆ¡ chuyá»ƒn tá»›i vÃ o há»“ sÆ¡ chuyá»ƒn tá»›i Ä‘Ã£ chá»n á»Ÿ trÃªn',0),(329482,9153,'af','Saamvoeg van hierdie skip-om rekords in skip-na bo gekies',0),(329483,9153,'ro','ÃŽmbinare din aceste Ã®nregistrÄƒri Ã®n livrare-la selectatÄƒ deasupra',0),(329484,9153,'et','Sulanduvad nende saaja kirjete laeva-et Ã¼lal valitud',0),(329485,9153,'si','Spojiti iz teh evidenc dobave za dobavo izbrali zgoraj',0),(329486,9153,'ba','Menggabungkan dari kapal ke catatan-catatan ini ke dalam kapal-untuk dipilih di atas',0),(329487,9153,'nl','Samenvoegen van deze Records Verzendcode in schip-To hierboven hebt geselecteerd',0),(329488,9153,'fi','YhdistÃ¤Ã¤ nÃ¤mÃ¤ Toimitusasiakkaan TIETUEISTA Toimitusasiakkaan valittu edellÃ¤',0),(329489,9153,'no','Flette skipet til POSTENE i lever til-merket ovenfor',0),(329490,9153,'da','Flette poster til skib-til markeret ovenfor',0),(329491,9153,'ko','ìš´ì†¡ì§€ ìœ„ì—ì„œ ì„ íƒí•œì— ì´ëŸ¬í•œ ë°°ì†¡ ë ˆì½”ë“œ ë³‘í•©',0),(329492,9153,'he','×œ×ž×–×’ ×ž×¨×©×•×ž×•×ª ××œ×” ×œ×ž×©×œ×•×— ×œ×ž×©×œ×•×— ×©× ×‘×—×¨ ×œ×¢×™×œ',0),(329493,9153,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· Î±Ï€ÏŒ Ï„Î± Î¼Î·Ï„ÏÏŽÎ± Î±Ï…Ï„Î¬ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ ÏƒÎµ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ ÎµÏ€Î¹Î»Î­Î¾Î±Ï„Îµ ÏƒÏ„Î¿ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î¿ Î²Î®Î¼Î±',0),(329494,9153,'zh','ä»Žè¿™äº›æ”¶è´§è®°å½•åˆå¹¶åˆ°ä¸Šé¢æ‰€é€‰çš„æ”¶è´§åœ°\r\n',0),(329495,9153,'sv','Koppla frÃ¥n dessa fartyg-till-poster till leveransadress valts ovan',0),(329496,9153,'it','Immettersi da questi record di spedire a spedire a selezionato sopra',0),(329497,9153,'tl','',0),(329498,9153,'th','Merge FROM These Ship-To Records Into Ship-To Selected Above',0),(329499,9153,'hi','à¤œà¤¹à¤¾à¤œ-à¤‡à¤¸à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‡à¤‚ à¤‡à¤¨ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤¸à¥‡ à¤®à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(329500,9153,'ms','Menggabungkan rekod kapal untuk ini ke dalam kapal-untuk dipilih di atas',0),(329501,9153,'ar','Ø¯Ù…Ø¬ Ù…Ù† Ù‡Ø°Ù‡ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù„Ù„Ø³Ø¬Ù„Ø§Øª ÙÙŠ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø­Ø¯Ø¯ Ø£Ø¹Ù„Ø§Ù‡',0),(329502,9153,'fr','Fusionner de ces enregistrements Ship-To Ship-To sÃ©lectionnÃ© ci-dessus',0),(329503,9153,'jp','èˆ¹ã«ä¸Šè¨˜ã®é¸æŠžã«ã“ã‚Œã‚‰ã®èˆ¹ã‚’ãƒ¬ã‚³ãƒ¼ãƒ‰ã‹ã‚‰ãƒžãƒ¼ã‚¸ã—ã¾ã™ã€‚',0),(329504,9153,'pt','Mesclar a partir destes registros de envio-a para envio-a acima selecionada.',0),(329505,9153,'ru','Ð¡Ð»Ð¸ÑÐ½Ð¸Ðµ Ð¸Ð· ÑÑ‚Ð¸Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð² ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð²Ñ‹ÑˆÐµ',0),(329506,9153,'es','Fusionar de Estos Records de Enviar-A En estes Record Enviar-A Arriba Seleccionado',0),(329507,9153,'de','AUS diesen Aufzeichnungen Lieferadresse mit Schiff-zu-oben ausgewÃ¤hlten zusammenfÃ¼hren',0),(329508,9153,'en','Merge FROM These Ship-To Records Into Ship-To Selected Above',0),(329509,9154,'is','',0),(329510,9154,'dr','_ Ø­Ù…Ù„ Ø¨Ù‡ ..._   Ø¯Ø± Ø§ÙŠÙ† Ø«Ø¨Øª _ Ø­Ù…Ù„ Ø¨Ù‡ ..._ ',0),(329511,9154,'pr','Ø§Ø¯ØºØ§Ù… ÙƒØ±Ø¯Ù† Ø§Ø³Ù†Ø§Ø¯  _ Ø­Ù…Ù„ Ø¨Ù‡ ..._   Ø¯Ø± Ø§ÙŠÙ† Ø«Ø¨Øª _ Ø­Ù…Ù„ Ø¨Ù‡ ..._ ',0),(329512,9154,'tr','Bu gemi iÃ§in kayÄ±t gÃ¶nderilecek kayÄ±tlarÄ± birleÅŸtirme',0),(329513,9154,'pl','ScaliÄ‡ statku do rekordÃ³w tego statku do rekordu',0),(329514,9154,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ñ‚Ð¾Ð·Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(329515,9154,'ur','Ø§Ø³ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Ùˆ Ø±ÛŒÚ©Ø§Ø±Úˆ Ù…ÛŒÚº Ø¬ÛØ§Ø² Ú©Ùˆ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø¶Ù… Ú©Ø±ÛŒÚº',0),(329516,9154,'sr','ÐžÐ±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐµ Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð° Ñƒ Ð¾Ð²Ð°Ñ˜ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(329517,9154,'vi','Nháº­p há»“ sÆ¡ chuyá»ƒn tá»›i vÃ o há»“ sÆ¡ chuyá»ƒn tá»›i nÃ y',0),(329518,9154,'af','Saamvoeg skip-om rekords in hierdie skip-om rekord',0),(329519,9154,'ro','ÃŽmbinare livrare-la Ã®nregistrÄƒrile Ã®n acest Record',0),(329520,9154,'et','Ãœhenda kirjete kirje saaja',0),(329521,9154,'si','Dobave zapisov spojite zapis za dobavo',0),(329522,9154,'ba','Menggabungkan kapal ke catatan ke catatan kapal-untuk ini',0),(329523,9154,'nl','Verzendcode Records samenvoegen in dit schip-naar een andere Record',0),(329524,9154,'fi','Toimitusasiakkaan tietueiden yhdistÃ¤minen Toimitusasiakkaan tietue',0),(329525,9154,'no','Flette skipet til postene til lever til-posten',0),(329526,9154,'da','Flette leveringsadressen poster til denne post',0),(329527,9154,'ko','ì´ ë°°ë¥¼ ê¸°ë¡ìœ¼ë¡œ ë°°ì†¡ ë ˆì½”ë“œ ë³‘í•©',0),(329528,9154,'he','×œ×ž×–×’ ××ª ×”×¨×©×•×ž×•×ª ×œ×ž×©×œ×•×— ×œ×ª×•×š ×¨×©×•×ž×” ×–×• ×œ×ž×©×œ×•×—',0),(329529,9154,'el','Î£Ï…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÏƒÎµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ ÎµÎ³Î³ÏÎ±Ï†Î®',0),(329530,9154,'zh','åˆå¹¶æ”¶è´§è®°å½•åˆ°æ­¤æ”¶è´§è®°å½•\r\n',0),(329531,9154,'sv','Koppla leveransadress poster till postens leveransadress',0),(329532,9154,'it','Spedire a record si fondono in questo Record di spedire a',0),(329533,9154,'tl','',0),(329534,9154,'th','Merge Ship-To Records INTO This Ship-To Record',0),(329535,9154,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤‡à¤¸ à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤®à¥‡à¤‚ à¤®à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(329536,9154,'ms','Menggabungkan kapal untuk rekod ke dalam rekod kapal untuk ini',0),(329537,9154,'ar','Ø¯Ù…Ø¬ Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ø³Ø¬Ù„ Ø¥Ù„Ù‰ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(329538,9154,'fr','Fusionner destinataire Records dans cet enregistrement de destinataire',0),(329539,9154,'jp','ã“ã®èˆ¹ã‚’ãƒ¬ã‚³ãƒ¼ãƒ‰ã«èˆ¹ã«ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ãƒžãƒ¼ã‚¸ã—ã¾ã™ã€‚',0),(329540,9154,'pt','Mesclar registros de envio-a para este registro de envio-a',0),(329541,9154,'ru','ÐžÐ±ÑŠÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² ÑÑ‚Ð¾Ñ‚ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(329542,9154,'es','Fusionar Records de Enviar-A EN Este Record de Enviar-A',0),(329543,9154,'de','Lieferadresse Records in dieses Schiff-zu-Datensatz zusammenfÃ¼hren',0),(329544,9154,'en','Merge Ship-To Records INTO This Ship-To Record',0),(329545,9155,'is','',0),(329546,9155,'dr','Ù…ØªÙˆÙ‚Ù ÙƒØ±Ø¯Ù† Ú†Ø§Ù¾ Ø´Ù…Ø§Ø±Ù‡ Ø³Ø·Ø± Ø±ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(329547,9155,'pr','Ù…ØªÙˆÙ‚Ù ÙƒØ±Ø¯Ù† Ú†Ø§Ù¾ Ø´Ù…Ø§Ø±Ù‡ Ø³Ø·Ø± Ø±ÙˆÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(329548,9155,'tr','SatÄ±r yazdÄ±r bastÄ±rmak PO Ã¼zerinde #',0),(329549,9155,'pl','PomiÅ„ drukowanie linii # na PO',0),(329550,9155,'bg','ÐŸÐ¾Ñ‚Ð¸ÑÐºÐ°Ñ‚ Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð»Ð¸Ð½Ð¸Ñ Ð½Ð° PO',0),(329551,9155,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù„Ø§Ø¦Ù† Ø¯Ø¨Ø§Ù†Û’ Ù¾Ø± Ù¾Ùˆ #',0),(329552,9155,'sr','ÐŸÐ¾Ñ‚Ð¸ÑÐ½ÑƒÑ‚Ð¸ ÐŸÑ€Ð¸Ð½Ñ‚ Ð»Ð¸Ð½Ð¸Ñ˜Ðµ # Ð½Ð° Ð¿Ð¾-Ð°',0),(329553,9155,'vi','Bá» in dÃ²ng sá»‘ cá»§a Ä‘Æ¡n mua hÃ ng',0),(329554,9155,'af','Onderdruk druk van lyn # op PO',0),(329555,9155,'ro','Suprima Print de linie # pe PO',0),(329556,9155,'et','TÃµkesta Print Line # PO',0),(329557,9155,'si','Zatiranje Natisni vrstico # na PO',0),(329558,9155,'ba','Menekan cetak garis # pada PO',0),(329559,9155,'nl','Afdrukken van lijn onderdrukken # op PO',0),(329560,9155,'fi','Tukahduttaa Tulosta rivi # PO',0),(329561,9155,'no','Undertrykke ut av linjen # pÃ¥ PO',0),(329562,9155,'da','Undertrykke Print af linje # pÃ¥ PO',0),(329563,9155,'ko','ì¸ì‡„ ë¼ì¸ì˜ ì–µì œê°€ #',0),(329564,9155,'he','×”×¢×œ× ×”×“×¤×¡×” ×©×œ ×§×• # ×¢×œ ×¤×•',0),(329565,9155,'el','ÎšÎ±Ï„Î±ÏƒÏ„Î­Î»Î»Î¿Ï…Î½ Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î³ÏÎ±Î¼Î¼Î®Ï‚ # ÏƒÎµ PO',0),(329566,9155,'zh','è®¢å•ä¸Šçš„#è¡Œç¦æ­¢æ‰“å°\r\n',0),(329567,9155,'sv','Undertrycka utskrift av linje # pÃ¥ PO',0),(329568,9155,'it','Sopprimere la stampa della linea # sul PO',0),(329569,9155,'tl','',0),(329570,9155,'th','Suppress Print of Line# on PO',0),(329571,9155,'hi','à¤°à¥‡à¤–à¤¾ à¤•à¥‡ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¥‹ à¤¦à¤¬à¤¾à¤¨à¥‡ à¤ªà¥‹ à¤ªà¤° #',0),(329572,9155,'ms','Menyekat cetak barisan # pada PO',0),(329573,9155,'ar','Ù…Ù†Ø¹ Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø³Ø·Ø± # ÙÙŠ Ø¨Ùˆ',0),(329574,9155,'fr','Supprimer l\'impression de la ligne # sur PO',0),(329575,9155,'jp','ç·šã®å°åˆ·ã‚’æŠ‘åˆ¶ã™ã‚‹ PO #',0),(329576,9155,'pt','Suprimir ImpressÃ£o da Liha# na OC',0),(329577,9155,'ru','ÐŸÐ¾Ð´Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð»Ð¸Ð½Ð¸Ð¸ # Ð½Ð° PO',0),(329578,9155,'es','Suprimir ImpresiÃ³n de # de Linea en OC',0),(329579,9155,'de','Print Line unterdrÃ¼cken # am PO',0),(329580,9155,'en','Suppress Print of Line # on PO',0),(329581,9156,'is','',0),(329582,9156,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø±ÙˆØ²',0),(329583,9156,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø±ÙˆØ²',0),(329584,9156,'tr','GÃ¼nlÃ¼k ortalama sipariÅŸ',0),(329585,9156,'pl','Åšrednia liczba zamÃ³wieÅ„ dziennie',0),(329586,9156,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð° Ð´ÐµÐ½',0),(329587,9156,'ur','Avg. Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª ÙÛŒ Ø¯Ù†',0),(329588,9156,'sr','ÐŸÐ¾Ð»Ð°Ð·Ð¸ÑˆÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð¿Ð¾ Ð´Ð°Ð½Ñƒ',0),(329589,9156,'vi','ÄÆ¡n Äáº·t HÃ ng Trung BÃ¬nh Má»—i NgÃ y',0),(329590,9156,'af','Gemiddelde Bestelllings per Dag',0),(329591,9156,'ro','Comenzi medie pe zi',0),(329592,9156,'et','Keskm tellimuste pÃ¤evas',0),(329593,9156,'si','AVG. naroÄil na dan',0),(329594,9156,'ba','Rata-rata Pesanan per-Hari',0),(329595,9156,'nl','AVG. Bestellingen Per dag',0),(329596,9156,'fi','KeskimÃ¤Ã¤rÃ¤inen tilaukset pÃ¤ivÃ¤ssÃ¤',0),(329597,9156,'no','Gjennomsnittlig antall ordrer Per dag',0),(329598,9156,'da','Gennemsnitligt antal ordrer pr. dag',0),(329599,9156,'ko','í•˜ë£¨ í‰ê·  ì£¼ë¬¸',0),(329600,9156,'he','×”×–×ž× ×•×ª ×ž×ž×•×¦×¢ ×œ×™×•×',0),(329601,9156,'el','Îœ.Î¿. Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Î±Î½Î¬ Î·Î¼Î­ÏÎ±',0),(329602,9156,'zh','å¹³å‡ã€‚æ¯æ—¥è®¢å•\r\n',0),(329603,9156,'sv','Genomsnittligt antal bestÃ¤llningar Per dag',0),(329604,9156,'it','Ordini Giornalieri Media',0),(329605,9156,'tl','',0),(329606,9156,'th','&#3648;&#3593;&#3621;&#3637;&#3656;&#3618; &#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3605;&#3656;&#3629;&#3623;&#3633;&#3609;',0),(329607,9156,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤¦à¤¿à¤¨ à¤”à¤¸à¤¤ à¤†à¤¦à¥‡à¤¶',0),(329608,9156,'ms','Purata pesanan setiap hari',0),(329609,9156,'ar','Ù…ØªÙˆØ³Ø· Ø¹Ø¯Ø¯ Ø§Ù„Ø£ÙˆØ§Ù…Ø± ÙÙŠ Ø§Ù„ÙŠÙˆÙ… Ø§Ù„ÙˆØ§Ø­Ø¯',0),(329610,9156,'fr','Prix moyen commandes par jour',0),(329611,9156,'jp','1 æ—¥ã‚ãŸã‚Šå¹³å‡æ³¨æ–‡',0),(329612,9156,'pt','Pedidos de mÃ©dia por dia',0),(329613,9156,'ru','Ð¡Ñ€ÐµÐ´Ð½ÐµÐµ Ñ‡Ð¸ÑÐ»Ð¾ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð² Ð´ÐµÐ½ÑŒ',0),(329614,9156,'es','Promedio de Pedidos por DÃ­a',0),(329615,9156,'de','AVG Bestellungen pro Tag',0),(329616,9156,'en','Avg. Orders Per Day',0),(329617,9157,'is','',0),(329618,9157,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ø±ÙˆØ²Ø§Ù†Ù‡ ',0),(329619,9157,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ø±ÙˆØ²Ø§Ù†Ù‡ ',0),(329620,9157,'tr','GÃ¼nlÃ¼k ortalama satÄ±ÅŸ tutarÄ±',0),(329621,9157,'pl','Åšrednia kwota sprzedaÅ¼y dziennie',0),(329622,9157,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÐµÐ½',0),(329623,9157,'ur','Avg. Ø³ÛŒÙ„Ø² Ø±Ù‚Ù… ÙÛŒ Ø¯Ù†',0),(329624,9157,'sr','ÐŸÑ€Ð¾Ñ . Ð¸Ð·Ð½Ð¾Ñ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¿Ð¾ Ð´Ð°Ð½Ñƒ',0),(329625,9157,'vi','Doanh Sá»‘ BÃ¡n HÃ ng Trung BÃ¬nh Má»—i NgÃ y',0),(329626,9157,'af','Bew.-gem. verkope bedrag Per dag',0),(329627,9157,'ro','SumÄƒ vÃ¢nzÄƒri medie pe zi',0),(329628,9157,'et','Keskm mÃ¼Ã¼gi summalt pÃ¤evas',0),(329629,9157,'si','PovpreÄen znesek prodaje na dan',0),(329630,9157,'ba','Jumlah penjualan rata-rata Per hari',0),(329631,9157,'nl','Gemiddelde omzet Per dag',0),(329632,9157,'fi','KeskimÃ¤Ã¤rÃ¤inen Myyntisumma pÃ¤ivÃ¤ssÃ¤',0),(329633,9157,'no','Gj.snittlig salgsbelÃ¸p Per dag',0),(329634,9157,'da','AVG. salgsbelÃ¸b pr. dag',0),(329635,9157,'ko','í•˜ë£¨ í‰ê·  íŒë§¤ ê¸ˆì•¡',0),(329636,9157,'he','×›×ž×•×ª ×”×ž×›×™×¨×•×ª ×ž×ž×•×¦×¢ ×œ×™×•×',0),(329637,9157,'el','Îœ.Î¿. Ï€Î¿ÏƒÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î±Î½Î¬ Î·Î¼Î­ÏÎ±',0),(329638,9157,'zh','å¹³å‡ã€‚é”€å”®é‡‘é¢æ¯æ—¥\r\n',0),(329639,9157,'sv','AVG. fÃ¶rsÃ¤ljningsbelopp Per dag',0),(329640,9157,'it','Importo delle vendite al giorno AVG.',0),(329641,9157,'tl','',0),(329642,9157,'th','&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618; &#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3605;&#3656;&#3629;&#3623;&#3633;&#3609;',0),(329643,9157,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤¦à¤¿à¤¨ à¤”à¤¸à¤¤ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤°à¤¾à¤¶à¤¿',0),(329644,9157,'ms','Purata jumlah jualan setiap hari',0),(329645,9157,'ar','Ù…ØªÙˆØ³Ø· ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ÙÙŠ Ø§Ù„ÙŠÙˆÙ… Ø§Ù„ÙˆØ§Ø­Ø¯',0),(329646,9157,'fr','Montant de vente prix moyen par jour',0),(329647,9157,'jp','1 æ—¥ã‚ãŸã‚Šã®å¹³å‡å£²ä¸Šé‡‘é¡',0),(329648,9157,'pt','Valor da venda mÃ©dia por dia',0),(329649,9157,'ru','Ð¡Ñ€ÐµÐ´Ð½Ð¸Ð¹ Ð¾Ð±ÑŠÐµÐ¼ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð² Ð´ÐµÐ½ÑŒ',0),(329650,9157,'es','Monto Promedio de Ventas Por DÃ­a',0),(329651,9157,'de','AVG-Umsatz pro Tag',0),(329652,9157,'en','Avg. Sales Amount Per Day',0),(329653,9158,'is','',0),(329654,9158,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´',0),(329655,9158,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´',0),(329656,9158,'tr','Ortalama satÄ±ÅŸ tutarÄ±',0),(329657,9158,'pl','Åšredni czas sprzedaÅ¼y kwoty',0),(329658,9158,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(329659,9158,'ur','Avg. ÙØ±ÙˆØ®Øª Ú©ÛŒ Ø±Ù‚Ù…',0),(329660,9158,'sr','ÐŸÐ¾Ð»Ð°Ð·Ð¸ÑˆÑ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð¸Ð·Ð½Ð¾Ñ',0),(329661,9158,'vi','Doanh Sá»‘ BÃ¡n HÃ ng Trung BÃ¬nh',0),(329662,9158,'af','Bew.-gem. verkoop bedrag',0),(329663,9158,'ro','Suma de vÃ¢nzare AVG.',0),(329664,9158,'et','Keskm mÃ¼Ã¼gi summa',0),(329665,9158,'si','AVG. Sale Amount',0),(329666,9158,'ba','Jumlah rata-rata penjualan',0),(329667,9158,'nl','AVG. verkoopbedrag',0),(329668,9158,'fi','KeskimÃ¤Ã¤rÃ¤inen Myyntisumma',0),(329669,9158,'no','Gj.snittlig salgsbelÃ¸p',0),(329670,9158,'da','AVG. salgsbelÃ¸b',0),(329671,9158,'ko','í‰ê·  íŒë§¤ ê¸ˆì•¡',0),(329672,9158,'he','×›×ž×•×ª ×ž×ž×•×¦×¢×ª ×©×œ ×ž×›×™×¨×”',0),(329673,9158,'el','Î Î¿ÏƒÏŒ Ï€ÏŽÎ»Î·ÏƒÎ· AVG.',0),(329674,9158,'zh','å¹³å‡æ°´å¹³ã€‚é”€å”®é‡‘é¢\r\n',0),(329675,9158,'sv','AVG. fÃ¶rsÃ¤ljningsbelopp',0),(329676,9158,'it','Importo di vendita AVG.',0),(329677,9158,'tl','',0),(329678,9158,'th','&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(329679,9158,'hi','à¤”à¤¸à¤¤ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤°à¤¾à¤¶à¤¿',0),(329680,9158,'ms','Jumlah jualan purata',0),(329681,9158,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¨ÙŠØ¹ Ù…ØªÙˆØ³Ø·.',0),(329682,9158,'fr','Montant des ventes de moy.',0),(329683,9158,'jp','å¹³å‡è²©å£²é‡',0),(329684,9158,'pt','Quantidade de venda do AVG.',0),(329685,9158,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ AVG.',0),(329686,9158,'es','Monto Promedio de Ventas',0),(329687,9158,'de','AVG-Umsatz',0),(329688,9158,'en','Avg. Sale Amount',0),(329689,9159,'is','',0),(329690,9159,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(329691,9159,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(329692,9159,'tr','SMM GL hesabÄ±',0),(329693,9159,'pl','Konto KWS GL',0),(329694,9159,'bg','ÐžÐ¡ÐŸ GL ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð°',0),(329695,9159,'ur','Ú©Ø§ÙˆÚ¯Ø³ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(329696,9159,'sr','Ð¢ÐŸÐ  Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(329697,9159,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p giÃ¡ thÃ nh hÃ ng bÃ¡n',0),(329698,9159,'af','KVV AG Rekening',0),(329699,9159,'ro','Cont de GL ROTIÅ¢E',0),(329700,9159,'et','GL kaubakontole',0),(329701,9159,'si','Konto porabe GL',0),(329702,9159,'ba','RODA GL Account',0),(329703,9159,'nl','KPV GL Account',0),(329704,9159,'fi','GL myyt',0),(329705,9159,'no','VAREFORBRUK gi-konto',0),(329706,9159,'da','GL vareforbrugskontoen',0),(329707,9159,'ko','í†±ë‹ˆ GL ê³„ì •',0),(329708,9159,'he','×ž×ª×§× ×™× ×ž×¢×‘×“×™ ×—×¨×™×˜×” ×•×©×Ÿ GL ×—×©×‘×•×Ÿ',0),(329709,9159,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î Î©Î›Î—Î˜ÎˆÎÎ¤Î©Î',0),(329710,9159,'zh','é”€å”®æˆæœ¬æ€»å¸å¸æˆ·\r\n',0),(329711,9159,'sv','KSV GL',0),(329712,9159,'it','INGRANAGGI GL Account',0),(329713,9159,'tl','',0),(329714,9159,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3634;&#3618;',0),(329715,9159,'hi','COGS GL à¤–à¤¾à¤¤à¥‡',0),(329716,9159,'ms','Salah satu alat GL akaun',0),(329717,9159,'ar','Ø­Ø³Ø§Ø¨ ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(329718,9159,'fr','CMV GL compte',0),(329719,9159,'jp','ã‚³ã‚° GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(329720,9159,'pt','CPV GL conta',0),(329721,9159,'ru','Ð—Ð£Ð‘Ð¦Ð« GL ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(329722,9159,'es','Cuenta LM de CBV',0),(329723,9159,'de','ZahnrÃ¤der Sako',0),(329724,9159,'en','COGS GL Account',0),(329725,9160,'is','',0),(329726,9160,'dr','(Ø¨Ø±Ø§ÙŠ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ Ø¬Ù†Ø³',0),(329727,9160,'pr','ÙƒØ¯ ÙƒØ§Ù„Ø§ÙŠ Ø§ØµÙ„ÙŠ (Ø¨Ø±Ø§ÙŠ Ø®Ø§Ù†ÙˆØ§Ø¯Ù‡ ÙƒØ§Ù„Ø§',0),(329728,9160,'tr','Ãœst Itemcode (madde aile iÃ§in)',0),(329729,9160,'pl','Itemcode rodzicÃ³w (dla rodziny pozycji)',0),(329730,9160,'bg','ÐœÐ°Ð¹ÐºÐ° Itemcode (Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÑÐµÐ¼ÐµÐ¹ÑÑ‚Ð²Ð¾)',0),(329731,9160,'ur','Ø¬Ø¯ Ø§Ù¹ÛŒÙ…Ú©ÙˆØ¯ÛŒ (Ø®Ø§Ù†Ø¯Ø§Ù† Ú©Û’ Ù„ÛŒÛ’ Ø´Û’)',0),(329732,9160,'sr','Ð Ð¾Ð´Ð¸Ñ‚ÐµÑ™ Ð˜Ñ‚ÐµÐ¼Ñ†Ð¾Ð´Ðµ (Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð¿Ð¾Ñ€Ð¾Ð´Ð¸Ñ†Ð°)',0),(329733,9160,'vi','MÃ£ hÃ ng cha máº¹ (dÃ¹ng cho gia Ä‘Ã¬nh)',0),(329734,9160,'af','Ouer Itemkode (Vir Familie Items)',0),(329735,9160,'ro','Itemcode pÄƒrinte (pentru elementul de familie)',0),(329736,9160,'et','Vanem Itemcode (eest kauba pere)',0),(329737,9160,'si','StarÅ¡ev Itemcode (za element druÅ¾ine)',0),(329738,9160,'ba','Orangtua Itemcode (untuk keluarga Item)',0),(329739,9160,'nl','Bovenliggende Itemcode (voor Item familie)',0),(329740,9160,'fi','Vanhemman Itemcode (kohde perheille)',0),(329741,9160,'no','Overordnet Itemcode (For elementet familien)',0),(329742,9160,'da','Overordnede Itemcode (For vare familie)',0),(329743,9160,'ko','(í•­ëª© ê°€ì¡±)ì— ëŒ€ í•œ ìƒìœ„ Itemcode',0),(329744,9160,'he','Itemcode ×”××‘ (×¢×‘×•×¨ ×¤×¨×™×˜ ×ž×©×¤×—×”)',0),(329745,9160,'el','Itemcode Î³Î¿Î½Î­Î± (Î³Î¹Î± Î¿Î¹ÎºÎ¿Î³Î­Î½ÎµÎ¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿)',0),(329746,9160,'zh','çˆ¶é¡¹ä»£ç ï¼ˆé¡¹ç›®ç³»åˆ—ï¼‰\r\n',0),(329747,9160,'sv','Ã–verordnad Itemcode (fÃ¶r objektet familj)',0),(329748,9160,'it','Padre Itemcode (per elemento famiglia)',0),(329749,9160,'tl','',0),(329750,9160,'th','&#3619;&#3627;&#3633;&#3626;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;(&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3633;&#3623;)',0),(329751,9160,'hi','à¤œà¤¨à¤• Itemcode (à¤®à¤¦ à¤ªà¤°à¤¿à¤µà¤¾à¤°) à¤•à¥‡ à¤²à¤¿à¤',0),(329752,9160,'ms','Itemcode induk (untuk keluarga Item)',0),(329753,9160,'ar','Ø¥ÙŠØªÙŠÙ…ÙƒÙˆØ¯ÙŠ Ø§Ù„Ø£ØµÙ„ (Ù„Ù„Ø¨Ù†Ø¯ Ø§Ù„Ø£Ø³Ø±Ø©)',0),(329754,9160,'fr','Itemcode parent (pour la famille de l\'ordre du jour)',0),(329755,9160,'jp','è¦ªå“ç›® ï¼ˆé …ç›®ãƒ•ã‚¡ãƒŸãƒªç”¨ï¼‰',0),(329756,9160,'pt','Pai Itemcode (para famÃ­lia de Item)',0),(329757,9160,'ru','Ð Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒ Itemcode (Ð´Ð»Ñ Ð¿ÑƒÐ½ÐºÑ‚Ð° ÑÐµÐ¼ÑŒÐ¸)',0),(329758,9160,'es','CÃ³digo de Item Original (Para Familia de Item)',0),(329759,9160,'de','Ãœbergeordnete Itemcode (fÃ¼r Element-Familie)',0),(329760,9160,'en','Parent Itemcode (For Item Family)',0),(329761,9161,'is','',0),(329762,9161,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ Ø®Ø±ÙŠØ¯ ',0),(329763,9161,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø±  Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ Ø®Ø±ÙŠØ¯ ',0),(329764,9161,'tr','SatÄ±nalma birimi baÅŸÄ±na stok birimi',0),(329765,9161,'pl','PieÅ„ jednostek na jednostkÄ™ zakupu',0),(329766,9161,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð²Ð¸Ñ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(329767,9161,'ur','Ø§Ø³Ù¹Ø§Ú© ÛŒÙˆÙ†Ù¹Ø³ ÙÛŒ ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(329768,9161,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(329769,9161,'vi','ÄÆ¡n vá»‹ HÃ ng tá»“n má»—i Ä‘Æ¡n vá»‹ mua',0),(329770,9161,'af','Voorraadeenhede Per Aankoop Eenheid',0),(329771,9161,'ro','UnitÄƒÅ£ile de stoc pe unitate de cumpÄƒrare',0),(329772,9161,'et','Varude Ã¼hikut ostuÃ¼hiku kohta',0),(329773,9161,'si','Zalog enot po nabavni',0),(329774,9161,'ba','Saham unit Per Pembelian Unit',0),(329775,9161,'nl','Voorraad eenheden Per aankoop eenheid',0),(329776,9161,'fi','Varastossa yksikkÃ¶Ã¤ ostoyksikkÃ¶Ã¤ kohden',0),(329777,9161,'no','Lager enheter pr. innkjÃ¸psenhet',0),(329778,9161,'da','Lager enheder pr. KÃ¸bsenhed',0),(329779,9161,'ko','êµ¬ë§¤ ë‹¨ìœ„ ë‹¹ ìž¬ê³  ë‹¨ìœ„',0),(329780,9161,'he','×™×—×™×“×•×ª ×‘×ž×œ××™ ×œ×™×—×™×“×ª ×”×¨×›×©',0),(329781,9161,'el','Î‘Ï€ÏŒÎ¸ÎµÎ¼Î± Î¼Î¿Î½Î¬Î´Ï‰Î½ Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Î±Î³Î¿ÏÎ¬',0),(329782,9161,'zh','æ¯è´­ä¹°å•ä½åº“å­˜å•ä½\r\n',0),(329783,9161,'sv','Aktier Per inkÃ¶psenhet',0),(329784,9161,'it','UnitÃ  di riserva Per acquisto di unitÃ ',0),(329785,9161,'tl','',0),(329786,9161,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3626;&#3605;&#3658;&#3629;&#3588;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;',0),(329787,9161,'hi','à¤–à¤°à¥€à¤¦ à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿ à¤¶à¥‡à¤¯à¤° à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(329788,9161,'ms','Unit-unit saham setiap Unit pembelian',0),(329789,9161,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„ØªØ®Ø²ÙŠÙ† Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø© Ù…Ø´ØªØ±ÙŠØ§Øª',0),(329790,9161,'fr','UnitÃ©s de stockage par unitÃ© d\'achat',0),(329791,9161,'jp','è³¼è²·å˜ä½ã‚ãŸã‚Šã®åœ¨åº«',0),(329792,9161,'pt','Estoque unidades por unidade de compra',0),(329793,9161,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ñ… ÐµÐ´Ð¸Ð½Ð¸Ñ† Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(329794,9161,'es','Unidades de Stock por Unidad de Compra',0),(329795,9161,'de','Stock Units pro Bestelleinheit',0),(329796,9161,'en','Stock Units Per Purchase Unit',0),(329797,9162,'is','',0),(329798,9162,'dr','ÙˆØ§Ø­Ø¯ Ø®Ø±ÙŠØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(329799,9162,'pr','ÙˆØ§Ø­Ø¯ Ø®Ø±ÙŠØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(329800,9162,'tr','SatÄ±cÄ± satÄ±nalma birimi',0),(329801,9162,'pl','Jednostka zakupu sprzedawca',0),(329802,9162,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(329803,9162,'ur','ÙˆÛŒÙ†ÚˆØ± Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ ÛŒÙˆÙ†Ù¹',0),(329804,9162,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(329805,9162,'vi','ÄÆ¡n vá»‹ mua NgÆ°á»i bÃ¡n',0),(329806,9162,'af','Verskaffer Aankoopeenheid',0),(329807,9162,'ro','Unitate de cumpÄƒrare furnizor',0),(329808,9162,'et','Hankija ostuÃ¼hikus',0),(329809,9162,'si','Prodajalec enote',0),(329810,9162,'ba','Penjual Pembelian Unit',0),(329811,9162,'nl','Leverancier aankoop eenheid',0),(329812,9162,'fi','Toimittajan ostoyksikkÃ¶',0),(329813,9162,'no','LeverandÃ¸ren innkjÃ¸psenhet',0),(329814,9162,'da','Kreditor KÃ¸bsenhed',0),(329815,9162,'ko','ê³µê¸‰ ì—…ì²´ êµ¬ë§¤ ë‹¨ìœ„',0),(329816,9162,'he','×™×—×™×“×ª ×¨×›×™×©×” ×©×œ ×¡×¤×§',0),(329817,9162,'el','Î‘Î³Î¿ÏÎ¬ Î¼Î¿Î½Î¬Î´Î±Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(329818,9162,'zh','ä¾›åº”å•†è´­ä¹°å•ä½\r\n',0),(329819,9162,'sv','LeverantÃ¶r inkÃ¶psenhet',0),(329820,9162,'it','UnitÃ  di acquisto del fornitore',0),(329821,9162,'tl','',0),(329822,9162,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(329823,9162,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤–à¤°à¥€à¤¦ à¤‡à¤•à¤¾à¤ˆ',0),(329824,9162,'ms','Penjual pembelian Unit',0),(329825,9162,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„Ø´Ø±Ø§Ø¡ Ù„Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(329826,9162,'fr','UnitÃ© dâ€™achat fournisseur',0),(329827,9162,'jp','ä»•å…¥å…ˆè³¼è²·å˜ä½',0),(329828,9162,'pt','Unidade de compra de fornecedor',0),(329829,9162,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(329830,9162,'es','Unidad de Compra de Proveedor',0),(329831,9162,'de','Kreditor Bestelleinheit',0),(329832,9162,'en','Vendor Purchase Unit',0),(329833,9163,'is','',0),(329834,9163,'dr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÙŠ ÙØ¹Ø§Ù„ÙŠØª ',0),(329835,9163,'pr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÙŠ ÙØ¹Ø§Ù„ÙŠØª ',0),(329836,9163,'tr','Arama bulu etkinlik iÃ§in girin',0),(329837,9163,'pl','WprowadÅº Infor wyszukiwania dla dziaÅ‚alnoÅ›ci',0),(329838,9163,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Infor Ð·Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(329839,9163,'ur','Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ø§Ù†ÙØ§ÙˆØ± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(329840,9163,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð˜Ð½Ñ„Ð¾Ñ€ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ðµ Ð·Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(329841,9163,'vi','Nháº­p thÃ´ng tin tÃ¬m kiáº¿m hoáº¡t Ä‘á»™ng',0),(329842,9163,'af','Voer Soektog Inligting in vir Aktiwiteit',0),(329843,9163,'ro','IntroduceÅ£i informaÅ£ii de cÄƒutare pentru activitate',0),(329844,9163,'et','Sisestage Otsi teavet tegevuse',0),(329845,9163,'si','Vnesite iskanje informacij za dejavnost',0),(329846,9163,'ba','Masukkan Infor Cari untuk kegiatan',0),(329847,9163,'nl','Zoek Infor voor activiteit invoeren',0),(329848,9163,'fi','Kirjoita Etsi tietoja tehtÃ¤vÃ¤lle',0),(329849,9163,'no','Angi sÃ¸k Infor For aktivitet',0),(329850,9163,'da','Indtast sÃ¸gning Infor For aktivitet',0),(329851,9163,'ko','í™œë™ì— ëŒ€ í•œ ê²€ìƒ‰ ì •ë³´ë¥¼ ìž…ë ¥',0),(329852,9163,'he','×”×–×Ÿ ×¨××™×ª×™ ×—×™×¤×•×© ×¢×‘×•×¨ ×¤×¢×™×œ×•×ª',0),(329853,9163,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î·Î½ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ Î³Î¹Î± Ï„Î· Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(329854,9163,'zh','è¾“å…¥æœç´¢æ´»åŠ¨ä¿¡æ¯',0),(329855,9163,'sv','Ange SÃ¶k Infor fÃ¶r aktivitet',0),(329856,9163,'it','Immettere Infor ricerca per attivitÃ ',0),(329857,9163,'tl','',0),(329858,9163,'th','&#3611;&#3657;&#3629;&#3609;&#3585;&#3634;&#3619;&#3588;&#3657;&#3609;&#3627;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;',0),(329859,9163,'hi','à¤–à¥‹à¤œ à¤¸à¥‚à¤šà¤¨à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(329860,9163,'ms','Masukkan carian Infor untuk aktiviti',0),(329861,9163,'ar','Ø£Ø¯Ø®Ù„ Infor Ø§Ù„Ø¨Ø­Ø« Ù„Ù„Ù†Ø´Ø§Ø·',0),(329862,9163,'fr','Entrez Infor recherche pour activitÃ©',0),(329863,9163,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ã®æ¤œç´¢æƒ…å ±ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(329864,9163,'pt','Digite a pesquisa Infor para atividade',0),(329865,9163,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐŸÐ¾Ð¸ÑÐº Infor Ð´Ð»Ñ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(329866,9163,'es','Introducir Info de Busqueda Para la Actividad',0),(329867,9163,'de','Geben Sie Suche Infor fÃ¼r AktivitÃ¤t',0),(329868,9163,'en','Enter Search Infor For Activity',0),(329869,9164,'is','',0),(329870,9164,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ø§Ø¨Ø·Ø§Ù„ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(329871,9164,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ† Ø§Ø¨Ø·Ø§Ù„ Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(329872,9164,'tr','Fatura numarasÄ± geÃ§ersiz kÄ±lma izin ver',0),(329873,9164,'pl','UmoÅ¼liwia nadpisanie numer faktury',0),(329874,9164,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸ Ð¿Ñ€Ð¸Ð¿Ð¾ÐºÑ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(329875,9164,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø³Û’ ØªØ¬Ø§ÙˆØ² Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(329876,9164,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð¿Ñ€ÐµÐ¼Ð¾ÑˆÑ›Ð°Ð²Ð°ÑšÐµ Ð¾Ð´ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(329877,9164,'vi','Cho PhÃ©p Ghi ÄÃ¨ Sá»‘ HÃ³a ÄÆ¡n',0),(329878,9164,'af','Laat Ignorering van Faktuurnommer toe',0),(329879,9164,'ro','Permite suprascrie de numÄƒrul facturii',0),(329880,9164,'et','Luba Ã¼le kirjutada arvenumbrit',0),(329881,9164,'si','Dovoli preglasitev Å¡tevilko raÄuna',0),(329882,9164,'ba','Memungkinkan Override nomor faktur',0),(329883,9164,'nl','Overschrijven factuurno. toestaan',0),(329884,9164,'fi','Salli ohitusasetukset laskunumero',0),(329885,9164,'no','Tillat overstyring av fakturanummer',0),(329886,9164,'da','Tillad tilsidesÃ¦ttelse af fakturanummer',0),(329887,9164,'ko','ì†¡ìž¥ ë²ˆí˜¸ì˜ ìž¬ì •ì˜ í—ˆìš©',0),(329888,9164,'he','×œ××¤×©×¨ ×¢×§×™×¤×” ×©×œ ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(329889,9164,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î·Î½ Ï€Î±ÏÎ¬ÎºÎ±Î¼ÏˆÎ· Ï„Î·Ï‚ Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(329890,9164,'zh','å…è®¸è¦†ç›–å‘ç¥¨å·ç \r\n',0),(329891,9164,'sv','TillÃ¥t Ã¥sidosÃ¤ttning av fakturanummer',0),(329892,9164,'it','Consentire l\'Override di numero fattura',0),(329893,9164,'tl','',0),(329894,9164,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3649;&#3607;&#3609;&#3607;&#3637;&#3656;&#3586;&#3629;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(329895,9164,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤“à¤µà¤°à¤°à¤¾à¤‡à¤¡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(329896,9164,'ms','Membenarkan menimpa nombor invois',0),(329897,9164,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨ØªØ¬Ø§ÙˆØ² Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(329898,9164,'fr','Permettre la substitution de numÃ©ro de facture',0),(329899,9164,'jp','è«‹æ±‚æ›¸ç•ªå·ã‚’ä¸Šæ›¸ãã‚’ã—ã¾ã™ã€‚',0),(329900,9164,'pt','Permitir a substituiÃ§Ã£o do nÃºmero da fatura',0),(329901,9164,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÐ¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(329902,9164,'es','Permitir ModificaciÃ³n Manual del Numero de la Factura',0),(329903,9164,'de','Ãœberschreibung der Rechnungsnummer zu ermÃ¶glichen',0),(329904,9164,'en','Allow Override of Invoice Number',0),(329905,9165,'is','',0),(329906,9165,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(329907,9165,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ ',0),(329908,9165,'tr','Fatura numarasÄ±nÄ± kullanmak iÃ§in',0),(329909,9165,'pl','Numer faktury do wykorzystania',0),(329910,9165,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(329911,9165,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(329912,9165,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ',0),(329913,9165,'vi','Sá»‘ hÃ³a Ä‘Æ¡n sá»­ dá»¥ng',0),(329914,9165,'af','Faktuurnommer om te Gebruik',0),(329915,9165,'ro','NumÄƒrul facturii la utilizare',0),(329916,9165,'et','Arve numbri kasutamine',0),(329917,9165,'si','Å tevilka raÄuna za uporabo',0),(329918,9165,'ba','Faktur jumlah penggunaan',0),(329919,9165,'nl','Factuurnummer voor gebruik',0),(329920,9165,'fi','Laskunumero kÃ¤yttÃ¶Ã¶n',0),(329921,9165,'no','Fakturanummeret til bruk',0),(329922,9165,'da','Fakturanummeret til brug',0),(329923,9165,'ko','ì†¡ìž¥ ë²ˆí˜¸ ì‚¬ìš©',0),(329924,9165,'he','×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª ×œ×©×™×ž×•×©',0),(329925,9165,'el','Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£ Ï‡ÏÎ®ÏƒÎ·',0),(329926,9165,'zh','å‘ç¥¨å·ç ä½¿ç”¨\r\n',0),(329927,9165,'sv','Fakturanummer fÃ¶r anvÃ¤ndning',0),(329928,9165,'it','Numero di fattura per uso',0),(329929,9165,'tl','',0),(329930,9165,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;',0),(329931,9165,'hi','à¤•à¤¾ à¤ªà¥à¤°à¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚ à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(329932,9165,'ms','Nombor invois untuk kegunaan',0),(329933,9165,'ar','Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù„Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(329934,9165,'fr','NumÃ©ro de la facture Ã  usage',0),(329935,9165,'jp','ä½¿ç”¨ã™ã‚‹è«‹æ±‚æ›¸ç•ªå·',0),(329936,9165,'pt','NÃºmero de factura para uso',0),(329937,9165,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(329938,9165,'es','Numero de Factura de usar',0),(329939,9165,'de','Rechnungsnummer zu verwenden',0),(329940,9165,'en','Invoice Number to Use',0),(329941,9166,'is','',0),(329942,9166,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¬Ù‡Øª  Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(329943,9166,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¬Ù‡Øª  Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(329944,9166,'tr','Fatura numarasÄ± iÃ§in sÄ±rasÄ±nÄ± kullan',0),(329945,9166,'pl','Numer faktury do wykorzystania na zamÃ³wienie',0),(329946,9166,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(329947,9166,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù†Ù…Ø¨Ø± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(329948,9166,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(329949,9166,'vi','Sá»‘ hÃ³a Ä‘Æ¡n dÃ¹ng cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(329950,9166,'af','Faktuurnommer om te Gebruik vir Bestelling',0),(329951,9166,'ro','NumÄƒrul facturii la utilizare pentru comanda',0),(329952,9166,'et','Arve Number Kasuta tellimuse',0),(329953,9166,'si','Å tevilka raÄuna za uporabo za nalog',0),(329954,9166,'ba','Faktur jumlah untuk gunakan untuk Order',0),(329955,9166,'nl','Factuurnummer voor gebruik voor Order',0),(329956,9166,'fi','Laskunumeroa kÃ¤ytetÃ¤Ã¤n tilauksen',0),(329957,9166,'no','Fakturanummeret til bruk for ordre',0),(329958,9166,'da','Fakturanummeret til brug for ordre',0),(329959,9166,'ko','ì‚¬ìš© ìˆœì„œì— ëŒ€ í•œ ì†¡ìž¥ ë²ˆí˜¸',0),(329960,9166,'he','×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª ×œ×©×™×ž×•×© ×¢×‘×•×¨ ×”×–×ž× ×”',0),(329961,9166,'el','Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£ Ï‡ÏÎ®ÏƒÎ· Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(329962,9166,'zh','ç”¨äºŽè®¢å•çš„å‘ç¥¨å·ç ä½¿ç”¨\r\n',0),(329963,9166,'sv','Fakturanummer fÃ¶r anvÃ¤ndning fÃ¶r bestÃ¤llning',0),(329964,9166,'it','Numero di fattura per uso per ordine',0),(329965,9166,'tl','',0),(329966,9166,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(329967,9166,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤—',0),(329968,9166,'ms','Nombor invois digunakan untuk pesanan',0),(329969,9166,'ar','Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…Ù‡Ø§ Ù„ØªØ±ØªÙŠØ¨',0),(329970,9166,'fr','NumÃ©ro de la facture Ã  utiliser pour la commande',0),(329971,9166,'jp','æ³¨æ–‡ã§ä½¿ç”¨ã™ã‚‹è«‹æ±‚æ›¸ç•ªå·',0),(329972,9166,'pt','NÃºmero de factura para uso por ordem',0),(329973,9166,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(329974,9166,'es','Numero de Factura de usar para el Orden',0),(329975,9166,'de','Rechnungsnummer zur Verwendung fÃ¼r Bestellung',0),(329976,9166,'en','Invoice Number to Use for Order',0),(329977,9167,'is','',0),(329978,9167,'dr','Ø¬Ù‡Øª ØªØ¹ÙŠÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯ÙƒØ§Ø± ØªÙˆØ³Ø· ÙƒØ§Ù…Ù¾ÙŠÙˆ ØªØ± Ø´Ù…Ø§Ø±Ù‡  Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(329979,9167,'pr','Ø¬Ù‡Øª ØªØ¹ÙŠÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯ÙƒØ§Ø± ØªÙˆØ³Ø· ÙƒØ§Ù…Ù¾ÙŠÙˆ ØªØ± Ø´Ù…Ø§Ø±Ù‡  Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(329980,9167,'tr','BilgisayarÄ±n otomatik olarak numara atamak numara boÅŸ bÄ±rakÄ±n',0),(329981,9167,'pl','Pozostaw puste numer, aby komputer automatycznie przypisaÄ‡ numer',0),(329982,9167,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° ÐºÐ¾Ð¼Ð¿ÑŽÑ‚ÑŠÑ€, Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¸ÑÐ²Ð¾ÑÐ²Ð° Ð½Ð¾Ð¼ÐµÑ€Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾',0),(329983,9167,'ur','Ù†Ù…Ø¨Ø± Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªÙÙˆÛŒØ¶ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù…Ù¾ÛŒÙˆÙ¹Ø± Ú©Û’ Ù„ÛŒÛ’ Ù†Ù…Ø¨Ø± Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(329984,9167,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° ÐºÐ¾Ð¼Ð¿Ñ˜ÑƒÑ‚ÐµÑ€ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð´Ð¾Ð´Ð¸Ñ˜ÐµÐ»Ð¸Ñ‚Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(329985,9167,'vi','Äá»ƒ sá»‘ trá»‘ng Ä‘á»ƒ mÃ¡y tÃ­nh tá»± Ä‘á»™ng cáº¥p sá»‘',0),(329986,9167,'af','Laat Nommer Oop vir Rekenaar om Nommer Outomaties Toe te Staan',0),(329987,9167,'ro','LÄƒsaÅ£i necompletat numÄƒr pentru Computer pentru a asocia numÄƒrul automat',0),(329988,9167,'et','JÃ¤ta Number tÃ¼hi arvuti automaatselt numbri mÃ¤Ã¤ramiseks',0),(329989,9167,'si','Pustite prazno Å¡tevilko za raÄunalnik samodejno dodeli Å¡tevilko',0),(329990,9167,'ba','Kosongkan nomor untuk komputer untuk menetapkan nomor secara otomatis',0),(329991,9167,'nl','Laat u nummer leeg voor Computer nummer automatisch toewijzen',0),(329992,9167,'fi','JÃ¤tÃ¤ numero tyhjÃ¤ tietokone voidaan mÃ¤Ã¤rittÃ¤Ã¤ numero automaattisesti',0),(329993,9167,'no','La nummer tom for datamaskinen Ã¥ tildele nummer automatisk',0),(329994,9167,'da','Efterlade nummer tom for Computer til at tildele nummeret automatisk',0),(329995,9167,'ko','ìžë™ìœ¼ë¡œ ë²ˆí˜¸ë¥¼ í• ë‹¹ í•˜ëŠ” ì»´í“¨í„°ì— ëŒ€ í•œ ìˆ˜ ë¹ˆì„ ë– ë‚˜',0),(329996,9167,'he','×ª×©××™×¨ ×ž×¡×¤×¨ ×¨×™×§ ×¢×‘×•×¨ ×”×ž×—×©×‘ ×œ×”×§×¦×•×ª ×ž×¡×¤×¨ ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(329997,9167,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½Î¬ Î³Î¹Î± Î±ÏÎ¹Î¸Î¼Î¿Ï Î³Î¹Î± Î½Î± Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ Î­Î½Î±Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î± Ï„Î¿Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„Î®',0),(329998,9167,'zh','ä¸ºå…¬å¸è‡ªåŠ¨åˆ†é…ç¼–å·ç•™ç©ºç¼–å·\r\n',0),(329999,9167,'sv','LÃ¤mna nummer tom fÃ¶r datorn automatiskt tilldela nummer',0),(330000,9167,'it','Lasciare vuoto numero per Computer assegnare automaticamente il numero',0),(330001,9167,'tl','',0),(330002,9167,'th','&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3652;&#3623;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3588;&#3629;&#3617;&#3614;&#3636;&#3623;&#3648;&#3605;&#3629;&#3619;&#3660;&#3648;&#3',0),(330003,9167,'hi','à¤•à¥à¤°à¤®à¤¾à¤‚à¤• à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤‚à¤ªà¥à¤¯à¥‚à¤Ÿà¤° à¤•à¥‡ à¤²à¤¿à¤ à¤–à¤¾à¤²à¥€ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‹',0),(330004,9167,'ms','Meninggalkan nombor kosong untuk komputer untuk memperuntukkan nombor secara automatik',0),(330005,9167,'ar','Ø§ØªØ±Ùƒ Ø±Ù‚Ù… ÙØ§Ø±ØºØ© Ù„Ù„ÙƒÙ…Ø¨ÙŠÙˆØªØ± Ù„ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø±Ù‚Ù… ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹',0),(330006,9167,'fr','Laisser en blanc numÃ©ro pour ordinateur attribuer le numÃ©ro automatiquement',0),(330007,9167,'jp','ã‚³ãƒ³ãƒ”ãƒ¥ãƒ¼ã‚¿ãƒ¼ã«è‡ªå‹•çš„ã«ç•ªå·ã‚’å‰²ã‚Šå½“ã¦ã‚‹ãŸã‚ã®æ•°ã®ç©ºç™½ã®ã¾ã¾ã«',0),(330008,9167,'pt','Deixar o nÃºmero em branco para computador atribuir automaticamente o nÃºmero',0),(330009,9167,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð¿ÑƒÑÑ‚Ñ‹Ð¼ Ð´Ð»Ñ ÐºÐ¾Ð¼Ð¿ÑŒÑŽÑ‚ÐµÑ€Ð°, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð¿Ñ€Ð¸ÑÐ²Ð¾Ð¸Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€',0),(330010,9167,'es','Dejar en Blanco el Numero para que la Computadora asignar el Numero Automaticamente',0),(330011,9167,'de','Lassen Sie Anzahl leer fÃ¼r Computer automatisch zuweisen',0),(330012,9167,'en','Leave Number Blank for Computer to Assign Number Automatically',0),(330013,9168,'is','',0),(330014,9168,'dr','ÙÙ‚Ø· Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(330015,9168,'pr','ÙÙ‚Ø· Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(330016,9168,'tr','Sadece POS',0),(330017,9168,'pl','POS tylko',0),(330018,9168,'bg','POS ÑÐ°Ð¼Ð¾',0),(330019,9168,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† ØµØ±Ù',0),(330020,9168,'sr','Ð¡Ð°Ð¼Ð¾ ÐŸÐžÐ¡',0),(330021,9168,'vi','Chá»‰ Ä‘iá»ƒm bÃ¡n hÃ ng',0),(330022,9168,'af','PVV Alleenlik',0),(330023,9168,'ro','POS numai',0),(330024,9168,'et','POS ainult',0),(330025,9168,'si','POS le',0),(330026,9168,'ba','POS hanya',0),(330027,9168,'nl','POS alleen',0),(330028,9168,'fi','POS vain',0),(330029,9168,'no','POS bare',0),(330030,9168,'da','POS kun',0),(330031,9168,'ko','í¬ìŠ¤ë§Œ',0),(330032,9168,'he','×§×•×¤×” ×‘×œ×‘×“',0),(330033,9168,'el','Î Î©Î£ Î¼ÏŒÎ½Î¿',0),(330034,9168,'zh','ä»…é”€å”®ç‚¹\r\n',0),(330035,9168,'sv','POS endast',0),(330036,9168,'it','Solo POS',0),(330037,9168,'tl','',0),(330038,9168,'th','&#3603; &#3592;&#3640;&#3604;&#3586;&#3634;&#3618;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(330039,9168,'hi','POS à¤•à¥‡à¤µà¤²',0),(330040,9168,'ms','POS sahaja',0),(330041,9168,'ar','Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹ ÙÙ‚Ø·',0),(330042,9168,'fr','POS seulement',0),(330043,9168,'jp','POS ã®ã¿',0),(330044,9168,'pt','POS sÃ³',0),(330045,9168,'ru','ÐšÐÐ¡Ð¡Ð Ð¢Ð¾Ð»ÑŒÐºÐ¾',0),(330046,9168,'es','PDV Solo',0),(330047,9168,'de','POS nur',0),(330048,9168,'en','POS Only',0),(330049,9169,'is','',0),(330050,9169,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§  ØªØ¹Ø¯Ø§Ø¯ÙŠ Ù…Ø¹ÙŠØ§Ø± Ø¬Ø³ØªØ¬Ùˆ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(330051,9169,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§  ØªØ¹Ø¯Ø§Ø¯ÙŠ Ù…Ø¹ÙŠØ§Ø± Ø¬Ø³ØªØ¬Ùˆ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(330052,9169,'tr','BazÄ± arama Ã¶lÃ§Ã¼tlerinin Ã¶nce girmeniz gerekir',0),(330053,9169,'pl','Najpierw naleÅ¼y wprowadziÄ‡ niektÃ³re kryteria wyszukiwania',0),(330054,9169,'bg','ÐŸÑŠÑ€Ð²Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½ÑÐºÐ¾Ð¸ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ð¸ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(330055,9169,'ur','Ú©Ú†Ú¾ ØªÙ„Ø§Ø´ Ú©Ø³ÙˆÙ¹ÛŒ Ù¾ÛÙ„Û’ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(330056,9169,'sr','ÐŸÑ€Ð²Ð¾ Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð½ÐµÐºÐµ ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ñ˜ÑƒÐ¼Ðµ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(330057,9169,'vi','Báº¡n pháº£i nháº­p tiÃªu chÃ­ tÃ¬m kiáº¿m trÆ°á»›c',0),(330058,9169,'af','U moet eers \'n soort van SOEKKRITERIA invoer.',0),(330059,9169,'ro','Trebuie mai intai sÄƒ introduceÅ£i cÃ¢teva criterii de cÄƒutare ',0),(330060,9169,'et','Te peate sisestama ennem otsingukriteeriumid',0),(330061,9169,'si','Morate vnesti nekatere iskalne kriterije najprej',0),(330062,9169,'ba','Anda harus memasukkan beberapa kriteria pencarian pertama',0),(330063,9169,'nl','U moet eerst enkele zoekcriteria invoeren',0),(330064,9169,'fi','Kirjoita hakuehdot ensin',0),(330065,9169,'no','Du mÃ¥ angi sÃ¸kekriteriene fÃ¸rst',0),(330066,9169,'da','Du skal angive nogle sÃ¸gekriterier fÃ¸rst',0),(330067,9169,'ko','ë¨¼ì € ëª‡ ê°€ì§€ ê²€ìƒ‰ ê¸°ì¤€ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(330068,9169,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×§×¨×™×˜×¨×™×•× ×™ ×”×—×™×¤×•×© ×§×¦×ª ×§×•×“×',0),(330069,9169,'el','Î ÏÏŽÏ„Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ ÎºÏÎ¹Ï„Î®ÏÎ¹Î± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(330070,9169,'zh','ä½ å¿…é¡»é¦–å…ˆè¾“å…¥ä¸€äº›æœç´¢æ ‡å‡†\r\n',0),(330071,9169,'sv','Du mÃ¥ste ange vissa sÃ¶kvillkor fÃ¶rst',0),(330072,9169,'it','Ãˆ necessario inserire alcuni criteri di ricerca prima',0),(330073,9169,'tl','',0),(330074,9169,'th','You Must Enter Some Search Criteria First',0),(330075,9169,'hi','à¤†à¤ªà¤•à¥‹ à¤•à¥à¤› à¤–à¥‹à¤œ à¤®à¤¾à¤ªà¤¦à¤‚à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(330076,9169,'ms','Anda mesti memasukkan beberapa kriteria carian pertama',0),(330077,9169,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø¥Ø¯Ø®Ø§Ù„ Ø¨Ø¹Ø¶ Ù…Ø¹Ø§ÙŠÙŠØ± Ø§Ù„Ø¨Ø­Ø« Ø£ÙˆÙ„Ø§',0),(330078,9169,'fr','Vous devez entrer des critÃ¨res de recherche d\'abord.',0),(330079,9169,'jp','æœ€åˆã«ã„ãã¤ã‹ã®æ¤œç´¢æ¡ä»¶ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(330080,9169,'pt','Primeiro tem de introduzir alguns critÃ©rios de pesquisa',0),(330081,9169,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð’Ð°Ð¼ ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð’Ð²ÐµÑÑ‚Ð¸ ÐšÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ð¸ ÐŸÐ¾Ð¸ÑÐºÐ°',0),(330082,9169,'es','Debe Introducir Alguno Criterio de Busqueda Primero',0),(330083,9169,'de','Sie mÃ¼ssen zuerst einige Suchkriterien eingeben.',0),(330084,9169,'en','You Must Enter Some Search Criteria First',0),(330085,9170,'is','',0),(330086,9170,'dr','ØµÙØ­Ù‡ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(330087,9170,'pr','ØµÙØ­Ù‡ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(330088,9170,'tr','POS sayfa',0),(330089,9170,'pl','Strona POS',0),(330090,9170,'bg','POS ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(330091,9170,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† ØµÙØ­Û',0),(330092,9170,'sr','ÐŸÐžÐ¡ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(330093,9170,'vi','Trang Ä‘iá»ƒm bÃ¡n hÃ ng',0),(330094,9170,'af','PVV Bladsy',0),(330095,9170,'ro','Pagina POS',0),(330096,9170,'et','POS leht',0),(330097,9170,'si','POS strani',0),(330098,9170,'ba','POS Halaman',0),(330099,9170,'nl','POS pagina',0),(330100,9170,'fi','POS sivu',0),(330101,9170,'no','POS-siden',0),(330102,9170,'da','POS side',0),(330103,9170,'ko','POS íŽ˜ì´ì§€',0),(330104,9170,'he','×“×£ ×§×•×¤×”',0),(330105,9170,'el','Î Î©Î£ ÏƒÎµÎ»Î¯Î´Î±',0),(330106,9170,'zh','é”€å”®ç‚¹é¡µ\r\n',0),(330107,9170,'sv','POS sida',0),(330108,9170,'it','Pagina POS',0),(330109,9170,'tl','',0),(330110,9170,'th','&#3627;&#3609;&#3657;&#3634;&#3592;&#3640;&#3604;&#3586;&#3634;&#3618;',0),(330111,9170,'hi','POS à¤ªà¥ƒà¤·à¥à¤ ',0),(330112,9170,'ms','Laman POS',0),(330113,9170,'ar','ØµÙØ­Ø© Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(330114,9170,'fr','Page de POS',0),(330115,9170,'jp','POS ã®ãƒšãƒ¼ã‚¸',0),(330116,9170,'pt','PÃ¡gina de POS',0),(330117,9170,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° POS',0),(330118,9170,'es','PDV PÃ¡gina',0),(330119,9170,'de','POS-Seite',0),(330120,9170,'en','POS Page',0),(330121,9171,'is','',0),(330122,9171,'dr','Ø³ÙŠØ³ØªÙ… Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(330123,9171,'pr','Ø³ÙŠØ³ØªÙ… Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(330124,9171,'tr','POS sistemi',0),(330125,9171,'pl','POS System',0),(330126,9171,'bg','POS ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(330127,9171,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø³Ø³Ù¹Ù…',0),(330128,9171,'sr','ÐŸÐžÐ¡ ÑÐ¸ÑÑ‚ÐµÐ¼',0),(330129,9171,'vi','Há»‡ thá»‘ng Ä‘iá»ƒm bÃ¡n hÃ ng',0),(330130,9171,'af','PVV Sisteem',0),(330131,9171,'ro','Sistem POS',0),(330132,9171,'et','POS sÃ¼steem',0),(330133,9171,'si','POS sistem',0),(330134,9171,'ba','POS sistem',0),(330135,9171,'nl','POS-systeem',0),(330136,9171,'fi','KassajÃ¤rjestelmÃ¤',0),(330137,9171,'no','POS System',0),(330138,9171,'da','POS-System',0),(330139,9171,'ko','POS ì‹œìŠ¤í…œ',0),(330140,9171,'he','POS System',0),(330141,9171,'el','POS ÏƒÏÏƒÏ„Î·Î¼Î±',0),(330142,9171,'zh','é”€å”®ç‚¹ç³»ç»Ÿ\r\n',0),(330143,9171,'sv','POS-System',0),(330144,9171,'it','Sistema POS',0),(330145,9171,'tl','',0),(330146,9171,'th','&#3619;&#3632;&#3610;&#3610; POS',0),(330147,9171,'hi','POS à¤ªà¥à¤°à¤£à¤¾à¤²à¥€',0),(330148,9171,'ms','Sistem POS',0),(330149,9171,'ar','Ù†Ø¸Ø§Ù… Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(330150,9171,'fr','SystÃ¨me d\'encaissement',0),(330151,9171,'jp','POS ã‚·ã‚¹ãƒ†ãƒ ',0),(330152,9171,'pt','Sistema de POS',0),(330153,9171,'ru','POS-ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹',0),(330154,9171,'es','PDV Sistema',0),(330155,9171,'de','POS-System',0),(330156,9171,'en','POS System',0),(330157,9172,'is','',0),(330158,9172,'dr','Ø¬Ù‡Øª ØªØ¹ÙŠÙŠÙ† Ø®ÙˆØ¯ÙƒØ§Ø± Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(330159,9172,'pr','Ø¬Ù‡Øª ØªØ¹ÙŠÙŠÙ† Ø®ÙˆØ¯ÙƒØ§Ø± Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(330160,9172,'tr','Auto-ata iÃ§in boÅŸ bÄ±rakÄ±n.',0),(330161,9172,'pl','Zostaw puste dla automatycznego przypisywania',0),(330162,9172,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° Ð°Ð²Ñ‚Ð¾-Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(330163,9172,'ur','Ø®ÙˆØ¯Ú©Ø§Ø±-ØªÙÙˆÛŒØ¶ Ú©Ø±Ù†Û’ Ú©Ùˆ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(330164,9172,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð´Ð¾Ð´ÐµÑ™Ð¸Ð²Ð°ÑšÐµ',0),(330165,9172,'vi','Äá»ƒ trá»‘ng náº¿u chá»‰ Ä‘á»‹nh tá»± Ä‘á»™ng',0),(330166,9172,'af','Laat Oop vir Outo-toekenning',0),(330167,9172,'ro','LÄƒsaÅ£i necompletat pentru a Auto-atribui',0),(330168,9172,'et','JÃ¤tke tÃ¼hjaks Auto mÃ¤Ã¤ramiseks',0),(330169,9172,'si','Auto-dodelijo pustite prazno',0),(330170,9172,'ba','Kosongkan menugaskan secara otomatis',0),(330171,9172,'nl','Laat leeg om Auto-toewijzen',0),(330172,9172,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi automaattinen Assign',0),(330173,9172,'no','Tomt for Auto-tildele',0),(330174,9172,'da','Tomt for Auto-tildele',0),(330175,9172,'ko','ìžë™ í• ë‹¹ì„ ë¹„ì›Œ',0),(330176,9172,'he','×ª×©××™×¨ ×¨×™×§ ×›×“×™ ×œ×”×§×¦×•×ª ××•×˜×•×ž×˜×™×ª',0),(330177,9172,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ Auto-ÎœÎµÏÎ¹ÏƒÎ¼ÏŒÏ‚',0),(330178,9172,'zh','ç•™ç©ºåˆ°è‡ªåŠ¨åˆ†é…\r\n',0),(330179,9172,'sv','LÃ¤mna tomt till Auto-tilldela',0),(330180,9172,'it','Lasciare vuoto per assegnazione automatica',0),(330181,9172,'tl','',0),(330182,9172,'th','&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3635;&#3627;&#3609;&#3604;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;',0),(330183,9172,'hi','à¤‘à¤Ÿà¥‹-à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚',0),(330184,9172,'ms','Biarkan kosong untuk Auto-peruntukkan',0),(330185,9172,'ar','Ø§ØªØ±Ùƒ Ø§Ù„Ù…Ø³Ø§Ø­Ø© ÙØ§Ø±ØºØ© Ù„Ù„Ø³ÙŠØ§Ø±Ø§Øª-ØªØ¹ÙŠÙŠÙ†',0),(330186,9172,'fr','Laissez vide pour affecter automatiquement',0),(330187,9172,'jp','è‡ªå‹•å‰²ã‚Šå½“ã¦ã‚’ç©ºç™½ã®ã¾ã¾ã«',0),(330188,9172,'pt','Deixe em branco para atribuir automaticamente',0),(330189,9172,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼ Ð´Ð»Ñ Ð°Ð²Ñ‚Ð¾ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(330190,9172,'es','Dejar en Blanco para Auto-asignar',0),(330191,9172,'de','Freilassen Sie, automatisch zuweisen',0),(330192,9172,'en','Leave Blank to Auto-assign',0),(330193,9173,'is','',0),(330194,9173,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø±Ø­Ø§Ù„ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù†Ø§Ø¨Ø±Ø§ÙŠÙ† Ø¢Ù†Ø±Ø§ ØªØºÙŠÙŠØ± Ø¯Ù‡ÙŠØ¯ Ø¨Ù‡ \r\n',0),(330195,9173,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø±Ø­Ø§Ù„ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù†Ø§Ø¨Ø±Ø§ÙŠÙ† Ø¢Ù†Ø±Ø§ ØªØºÙŠÙŠØ± Ø¯Ù‡ÙŠØ¯ Ø¨Ù‡ \r\n',0),(330196,9173,'tr','Fatura numarasÄ± zaten kullanÄ±mda Ã§ok deÄŸiÅŸti:',0),(330197,9173,'pl','Numer faktury juÅ¼ w uÅ¼yciu tak zmieniony na:',0),(330198,9173,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð²ÐµÑ‡Ðµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ñ‚Ð¾Ð»ÐºÐ¾Ð²Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð¾ Ð½Ð°:',0),(330199,9173,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø± Ù¾ÛÙ„Û’ ÛÛŒ Ø²ÛŒØ± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø§Ø³ Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§:',0),(330200,9173,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð±Ñ€Ð¾Ñ˜ Ð²ÐµÑ› Ñƒ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸ Ñ‚Ð°ÐºÐ¾ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð¾ Ñƒ:',0),(330201,9173,'vi','Sá»‘ hÃ³a Ä‘Æ¡n Ä‘Ã£ cÃ³ nÃªn Ä‘á»•i sang',0),(330202,9173,'af','Faktuurnommer Alreeds in Gebruik so Verander na:',0),(330203,9173,'ro','NumÄƒr facturÄƒ deja Ã®n uz Deci schimbat la:',0),(330204,9173,'et','Arve number on juba kasutuses, seega muudeti:',0),(330205,9173,'si','RaÄun Å¡tevilka Å¾e v uporabi tako spremenila, da:',0),(330206,9173,'ba','Faktur jumlah sudah digunakan sehingga berubah menjadi:',0),(330207,9173,'nl','Factuur nummer al in gebruik dus gewijzigd in:',0),(330208,9173,'fi','Laskun numero jo kÃ¤ytÃ¶ssÃ¤ niin muuttunut:',0),(330209,9173,'no','Faktura nummer allerede i bruk sÃ¥ endret til:',0),(330210,9173,'da','Faktura nummeret allerede i brug sÃ¥ Ã¦ndret til:',0),(330211,9173,'ko','ì†¡ìž¥ ë²ˆí˜¸ ì´ë¯¸ ì‚¬ìš©ì—ì„œ ë„ˆë¬´ ë³€ê²½ ë¨:',0),(330212,9173,'he','×—×©×‘×•× ×™×ª ×ž×¡ ×›×‘×¨ ×‘×©×™×ž×•×© ×›×œ ×›×š ×©×•× ×”:',0),(330213,9173,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Î®Î´Î· ÏƒÎµ Ï‡ÏÎ®ÏƒÎ·, Î­Ï„ÏƒÎ¹ Î¬Î»Î»Î±Î¾Îµ ÏƒÎµ:',0),(330214,9173,'zh','çŽ°ç”¨å‘ç¥¨å·ç å·²æ›´æ”¹ä¸ºï¼š\r\n',0),(330215,9173,'sv','Faktura nummer redan i bruk sÃ¥ Ã¤ndras till:',0),(330216,9173,'it','Fattura numero giÃ  in uso, cosÃ¬ cambiato in:',0),(330217,9173,'tl','',0),(330218,9173,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3614;&#3619;&#3657;&#3629;&#3617;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3649;&#3621;&#3657;&#3623;&#3648;&#3611;&#3621;&#3637;&#3',0),(330219,9173,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‰à¤ªà¤¯à¥‹à¤— à¤®à¥‡à¤‚ à¤¹à¥ˆ à¤¤à¥‹ à¤¬à¤¦à¤² à¤¦à¤¿à¤¯à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤:',0),(330220,9173,'ms','Invois nombor telah digunakan sehingga ditukar kepada:',0),(330221,9173,'ar','Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© \"Ù…Ø³Ø¨Ù‚Ø§Ù‹\" Ù‚ÙŠØ¯ Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­ØªÙ‰ ÙŠØªØºÙŠØ± Ø¥Ù„Ù‰:',0),(330222,9173,'fr','NumÃ©ro de facture dÃ©jÃ  utilisÃ© donc changÃ© Ã  :',0),(330223,9173,'jp','è«‹æ±‚æ›¸ã®æ•°ã¯æ—¢ã«ä½¿ç”¨ä¸­ã«å¤‰æ›´ã•ã‚ŒãŸã®ã§ï¼š',0),(330224,9173,'pt','Fatura nÃºmero jÃ¡ em uso, entÃ£o mudou para:',0),(330225,9173,'ru','Ð¡Ñ‡ÐµÑ‚ Ð½Ð¾Ð¼ÐµÑ€ ÑƒÐ¶Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ñ‚Ð°Ðº Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¾ Ð½Ð°:',0),(330226,9173,'es','Numero de Factura Ya se Usa entonces Cambiado a:',0),(330227,9173,'de','Rechnung Nummer bereits im Einsatz in so geÃ¤ndert:',0),(330228,9173,'en','Invoice Number Already in Use so Changed to:',0),(330229,9174,'is','',0),(330230,9174,'dr','ÙÙ‚Ø· Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(330231,9174,'pr','ÙÙ‚Ø· Ø¯Ø³ØªØ±Ø³ÙŠ Ø¨Ù‡ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(330232,9174,'tr','POS eriÅŸim sadece',0),(330233,9174,'pl','POS dostÄ™p tylko',0),(330234,9174,'bg','POS Ð´Ð¾ÑÑ‚ÑŠÐ¿ ÑÐ°Ð¼Ð¾',0),(330235,9174,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ ØµØ±Ù',0),(330236,9174,'sr','Ð¡Ð°Ð¼Ð¾ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ ÐŸÐžÐ¡',0),(330237,9174,'vi','Chá»‰ truy cáº­p tá»« Ä‘iá»ƒm bÃ¡n hÃ ng',0),(330238,9174,'af','PVV Toegang Alleenlik',0),(330239,9174,'ro','POS acces numai',0),(330240,9174,'et','POS juurdepÃ¤Ã¤s ainult',0),(330241,9174,'si','POS dostop samo',0),(330242,9174,'ba','POS akses hanya',0),(330243,9174,'nl','POS alleen toegang',0),(330244,9174,'fi','POS pÃ¤Ã¤sy vain',0),(330245,9174,'no','POS tilgang bare',0),(330246,9174,'da','POS adgang kun',0),(330247,9174,'ko','POS ì•¡ì„¸ìŠ¤ ì „ìš©',0),(330248,9174,'he','×’×™×©×” ×§×•×¤×” ×‘×œ×‘×“',0),(330249,9174,'el','Î Î©Î£ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· Î¼ÏŒÎ½Î¿',0),(330250,9174,'zh','ä»…é”€å”®ç‚¹è®¿é—®',0),(330251,9174,'sv','POS tillgÃ¥ng endast',0),(330252,9174,'it','Solo accesso POS',0),(330253,9174,'tl','',0),(330254,9174,'th','&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621; &#3603; &#3592;&#3640;&#3604;&#3586;&#3634;&#3618;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(330255,9174,'hi','POS à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¥‡à¤µà¤²',0),(330256,9174,'ms','Capaian POS sahaja',0),(330257,9174,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹ ÙÙ‚Ø·',0),(330258,9174,'fr','POS accÃ¨s uniquement',0),(330259,9174,'jp','POS ã‚¢ã‚¯ã‚»ã‚¹ã®ã¿',0),(330260,9174,'pt','POS acesso somente',0),(330261,9174,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿ Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ðº ÐšÐÐ¡Ð¡Ð•',0),(330262,9174,'es','PDV Acceso Solo',0),(330263,9174,'de','POS Zugang nur',0),(330264,9174,'en','POS Access Only',0),(330265,9175,'is','',0),(330266,9175,'dr','Ø­Ù‚ÙˆÙ‚ ÙˆÙŠÚ˜Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ',0),(330267,9175,'pr','Ø­Ù‚ÙˆÙ‚ ÙˆÙŠÚ˜Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ',0),(330268,9175,'tr','Ã–zel eriÅŸim haklarÄ±',0),(330269,9175,'pl','Specjalnych praw dostÄ™pu',0),(330270,9175,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(330271,9175,'ur','Ø®Ø§Øµ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ú©Û’ Ø­Ù‚ÙˆÙ‚',0),(330272,9175,'sr','ÐŸÐ¾ÑÐµÐ±Ð°Ð½ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¿Ñ€Ð°Ð²Ð¸Ð¼Ð°',0),(330273,9175,'vi','Quyá»n truy cáº­p Ä‘áº·c biá»‡t',0),(330274,9175,'af','Spesiale Toegangsregte',0),(330275,9175,'ro','Drepturi speciale de acces',0),(330276,9175,'et','JuurdepÃ¤Ã¤su Ãµigused',0),(330277,9175,'si','Posebnimi pravicami dostopa',0),(330278,9175,'ba','Hak akses khusus',0),(330279,9175,'nl','Speciale rechten op toegang',0),(330280,9175,'fi','ErityistÃ¤ kÃ¤yttÃ¶oikeudet',0),(330281,9175,'no','Spesielle tilgangsrettigheter',0),(330282,9175,'da','SÃ¦rlige adgangsrettigheder',0),(330283,9175,'ko','íŠ¹ë³„ ì•¡ì„¸ìŠ¤ ê¶Œí•œ',0),(330284,9175,'he','×–×›×•×™×•×ª ×’×™×©×” ×ž×™×•×—×“×ª',0),(330285,9175,'el','Î•Î¹Î´Î¹ÎºÎ¬ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(330286,9175,'zh','ç‰¹æ®Šè®¿é—®æƒé™\r\n',0),(330287,9175,'sv','SÃ¤rskilda rÃ¤ttigheter',0),(330288,9175,'it','Diritti di accesso speciali',0),(330289,9175,'tl','',0),(330290,9175,'th','&#3626;&#3636;&#3607;&#3608;&#3636;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(330291,9175,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤ªà¤¹à¥à¤à¤š à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(330292,9175,'ms','Hak-hak akses Khas',0),(330293,9175,'ar','Ø­Ù‚ÙˆÙ‚ Ø§Ù„ÙˆØµÙˆÙ„ Ø§Ù„Ø®Ø§ØµØ©',0),(330294,9175,'fr','Droits d\'accÃ¨s spÃ©ciaux',0),(330295,9175,'jp','ç‰¹åˆ¥ãªã‚¢ã‚¯ã‚»ã‚¹æ¨©',0),(330296,9175,'pt','Direitos de acesso especiais',0),(330297,9175,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¼Ð¸ Ð¿Ñ€Ð°Ð²Ð°Ð¼Ð¸ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°',0),(330298,9175,'es','Derechos Especiales de Acceso',0),(330299,9175,'de','Besondere Zugriffsrechte',0),(330300,9175,'en','Special Access Rights',0),(330301,9176,'is','',0),(330302,9176,'dr','Ø³Ø·Ø± ÙŠØ§Ø¯Ø§Ø´Øªâ€Œ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚',0),(330303,9176,'pr','Ø³Ø·Ø± ÙŠØ§Ø¯Ø§Ø´Øªâ€Œ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ú†Ùƒ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚',0),(330304,9176,'tr','TÃ¼m Ã§ekleri Ã¶demek iÃ§in faturasÄ±',0),(330305,9176,'pl','Wiersz dla wszystkich zapÅ‚aciÄ‡ sprawdza',0),(330306,9176,'bg','Ð ÐµÐ´Ð° Ð½Ð° Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(330307,9176,'ur','ØªÙ…Ø§Ù… Ù¾Ú‘ØªØ§Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…ÛŒÙ…Ùˆ Ù„Ø§Ø¦Ù†',0),(330308,9176,'sr','Ð ÐµÐ´ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐ° Ð·Ð° ÑÐ²Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ.',0),(330309,9176,'vi','DÃ²ng ghi chÃº cho táº¥t cáº£ SÃ©c lÆ°Æ¡ng',0),(330310,9176,'af','Memo Lyn vir alle Uitbetaalde Tjeks',0),(330311,9176,'ro','Linie de NotÄƒ pentru toate plÄƒteascÄƒ controalelor',0),(330312,9176,'et','Viivisarve rida kÃµik maksma tÅ¡ekid',0),(330313,9176,'si','Vrstica dobropisa za vse plaÄati Äeke',0),(330314,9176,'ba','Baris memo untuk semua membayar cek',0),(330315,9176,'nl','Memo lijn voor alle betalen cheques',0),(330316,9176,'fi','ViivÃ¤styskululaskun rivin kaikki maksaa sekit',0),(330317,9176,'no','Notat linje for alle betale sjekker',0),(330318,9176,'da','Notatet linje for alle betale kontrollerer',0),(330319,9176,'ko','ëª¨ë“  ì§€ë¶ˆ í™•ì¸ì— ëŒ€ í•œ ë©”ëª¨ ë¼ì¸',0),(330320,9176,'he','×”×”×¢×¨×” ×¢×œ ×©×œ× ×›×œ ×‘×•×“×§',0),(330321,9176,'el','Î“ÏÎ±Î¼Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Î³Î¹Î± ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ Ï€Î»Î·ÏÏŽÏƒÎµÎ¹ ÎµÏ€Î¹Ï„Î±Î³ÏŽÎ½',0),(330322,9176,'zh','å¤‡å¿˜å½•æ‰€æœ‰æ”¶è´¹æ”¯ç¥¨è¡Œ\r\n',0),(330323,9176,'sv','Memo linje fÃ¶r alla betala checkar',0),(330324,9176,'it','Linea memo per tutti i controlli di pagare',0),(330325,9176,'tl','',0),(330326,9176,'th','&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;&#3649;&#3617;&#3617;&#3650;&#3617;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3594;&#3655;&#3588;',0),(330327,9176,'hi','à¤¸à¤­à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤šà¥‡à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥à¤žà¤¾à¤ªà¤¨ à¤²à¤¾à¤‡à¤¨',0),(330328,9176,'ms','Talian memo untuk semua membayar menyemak',0),(330329,9176,'ar','Ø¨Ù†Ø¯ Ø§Ù„Ù…Ø°ÙƒØ±Ø© Ù„Ø¯ÙØ¹ Ø¬Ù…ÙŠØ¹ \"Ø§Ù„Ø´ÙŠÙƒØ§Øª\"',0),(330330,9176,'fr','Ligne facture pour tous les contrÃ´les de payer',0),(330331,9176,'jp','ã™ã¹ã¦ã®æ”¯æ‰•ãƒã‚§ãƒƒã‚¯ã®ãƒ¡ãƒ¢ã®è¡Œ',0),(330332,9176,'pt','Linha Memo para pagar todos os cheques',0),(330333,9176,'ru','ÐŸÐ°Ð¼ÑÑ‚ÐºÐ° Ð»Ð¸Ð½Ð¸Ñ Ð´Ð»Ñ Ð²ÑÐµÑ… ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚',0),(330334,9176,'es','Linea memo para todos los cheques de nÃ³mina',0),(330335,9176,'de','Memo Line fÃ¼r alle Zahlen Ã¼berprÃ¼ft',0),(330336,9176,'en','Memo Line for all Pay Checks',0),(330337,9177,'is','',0),(330338,9177,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø§ÙŠÙ‡',0),(330339,9177,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø§ÙŠÙ‡',0),(330340,9177,'tr','Matrah',0),(330341,9177,'pl','Kwoty bazowej',0),(330342,9177,'bg','Ð‘Ð°Ð·Ð¾Ð²Ð° ÑÑƒÐ¼Ð°',0),(330343,9177,'ur','Ø¨ÛŒØ³ Ø±Ù‚Ù…',0),(330344,9177,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¾ÑÐ½Ð¾Ð²Ð¸Ñ†Ðµ',0),(330345,9177,'vi','Sá»‘ tiá»n gá»‘c',0),(330346,9177,'af','Basisbedrag',0),(330347,9177,'ro','Suma bazÄƒ',0),(330348,9177,'et','Baassumma',0),(330349,9177,'si','Znesek osnove',0),(330350,9177,'ba','Jumlah dasar',0),(330351,9177,'nl','Basisbedrag',0),(330352,9177,'fi','Perussumma',0),(330353,9177,'no','GrunnbelÃ¸p',0),(330354,9177,'da','GrundbelÃ¸bet',0),(330355,9177,'ko','ê¸°ë³¸ ê¸ˆì•¡',0),(330356,9177,'he','×¡×›×•× ×‘×¡×™×¡',0),(330357,9177,'el','Î Î¿ÏƒÏŒ Î²Î¬ÏƒÎ·Ï‚',0),(330358,9177,'zh','åŸºæ•°\r\n',0),(330359,9177,'sv','Basbelopp',0),(330360,9177,'it','Importo base',0),(330361,9177,'tl','',0),(330362,9177,'th','&#3600;&#3634;&#3609;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(330363,9177,'hi','à¤†à¤§à¤¾à¤° à¤°à¤¾à¤¶à¤¿',0),(330364,9177,'ms','Jumlah asas',0),(330365,9177,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ø£Ø³Ø§Ø³ÙŠ',0),(330366,9177,'fr','Montant de base',0),(330367,9177,'jp','åŸºæº–é¡',0),(330368,9177,'pt','Quantidade de base',0),(330369,9177,'ru','Ð‘Ð°Ð·Ð¾Ð²Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(330370,9177,'es','Monto Base',0),(330371,9177,'de','Grundbetrag',0),(330372,9177,'en','Base Amount',0),(330373,9178,'is','',0),(330374,9178,'dr','Ú†Ùƒ Ù‡Ø§ÙŠ Ù…Ø´ØªØ±ÙŠ',0),(330375,9178,'pr','Ú†Ùƒ Ù‡Ø§ÙŠ Ù…Ø´ØªØ±ÙŠ',0),(330376,9178,'tr','Ä°stemci denetimleri',0),(330377,9178,'pl','Klient kontroli',0),(330378,9178,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»',0),(330379,9178,'ur','ÙˆØµÙˆÙ„ Ú©Ø§Ø± Ú†ÛŒÚ©',0),(330380,9178,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(330381,9178,'vi','SÃ©c khÃ¡ch hÃ ng',0),(330382,9178,'af','KliÃ«nt / Klant Tjeks',0),(330383,9178,'ro','Clientul controale',0),(330384,9178,'et','Kliendi kontrolli',0),(330385,9178,'si','Stranka pregledov',0),(330386,9178,'ba','Cek klien',0),(330387,9178,'nl','Client controleert',0),(330388,9178,'fi','Tarkistavat',0),(330389,9178,'no','Klienten sjekker',0),(330390,9178,'da','Klienten kontrol',0),(330391,9178,'ko','í´ë¼ì´ì–¸íŠ¸ ê²€ì‚¬',0),(330392,9178,'he','×œ×§×•×— ×¦\'×§×™×',0),(330393,9178,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Î¹ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(330394,9178,'zh','å®¢æˆ·ç«¯æ£€æŸ¥\r\n',0),(330395,9178,'sv','Klienten kontroller',0),(330396,9178,'it','Controlli client',0),(330397,9178,'tl','',0),(330398,9178,'th','&#3648;&#3594;&#3655;&#3588;&#3612;&#3641;&#3657;&#3592;&#3657;&#3634;&#3591;',0),(330399,9178,'hi','à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ à¤•à¥€ à¤œà¤¾à¤‚à¤š',0),(330400,9178,'ms','Semakan pelanggan',0),(330401,9178,'ar','ÙŠØªØ­Ù‚Ù‚ Ø¹Ù…ÙŠÙ„',0),(330402,9178,'fr','ContrÃ´les client',0),(330403,9178,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆã®ç¢ºèª',0),(330404,9178,'pt','VerificaÃ§Ãµes de cliente',0),(330405,9178,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚',0),(330406,9178,'es','Cheques de Clientes',0),(330407,9178,'de','Der Client Ã¼berprÃ¼ft',0),(330408,9178,'en','Client Checks',0),(330409,9179,'is','',0),(330410,9179,'dr','ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(330411,9179,'pr','ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(330412,9179,'tr','Komisyon',0),(330413,9179,'pl','Komisja',0),(330414,9179,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(330415,9179,'ur','Ú©Ù…ÛŒØ´Ù†',0),(330416,9179,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð°',0),(330417,9179,'vi','Hoa há»“ng',0),(330418,9179,'af','Kommissie ',0),(330419,9179,'ro','Comisia',0),(330420,9179,'et','Komisjon',0),(330421,9179,'si','Komisija',0),(330422,9179,'ba','Komisi',0),(330423,9179,'nl','Commissie',0),(330424,9179,'fi','Komissio',0),(330425,9179,'no','Kommisjonen',0),(330426,9179,'da','Kommissionen',0),(330427,9179,'ko','ìœ„ì›íšŒ',0),(330428,9179,'he','×”× ×¦×™×‘×•×ª',0),(330429,9179,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®',0),(330430,9179,'zh','ä½£é‡‘\r\n',0),(330431,9179,'sv','Kommissionen',0),(330432,9179,'it','Commissione',0),(330433,9179,'tl','',0),(330434,9179,'th','&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(330435,9179,'hi','à¤†à¤¯à¥‹à¤—',0),(330436,9179,'ms','Suruhanjaya',0),(330437,9179,'ar','Ø¹Ù…ÙˆÙ„Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(330438,9179,'fr','Commission',0),(330439,9179,'jp','å§”å“¡ä¼š',0),(330440,9179,'pt','ComissÃ£o',0),(330441,9179,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ñ',0),(330442,9179,'es','ComisiÃ³n',0),(330443,9179,'de','Kommission',0),(330444,9179,'en','Commission',0),(330445,9180,'is','',0),(330446,9180,'dr','GST Ù…Ø§Ù„ÙŠØ§Øª Ø®Ø¯Ù…Ø§Øª Ùˆ Ø¬Ù†Ø³ Ø¯Ø± ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(330447,9180,'pr','GST Ù…Ø§Ù„ÙŠØ§Øª Ø®Ø¯Ù…Ø§Øª Ùˆ ÙƒØ§Ù„Ø§ Ø¯Ø± ÙƒÙ…ÙŠØ³ÙŠÙˆÙ†',0),(330448,9180,'tr','GST Tarih Komisyonu',0),(330449,9180,'pl','Podatek GST od Komisji',0),(330450,9180,'bg','GST Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(330451,9180,'ur','Ú©Ù…ÛŒØ´Ù† Ù¾Ø± GST',0),(330452,9180,'sr','Ð“Ð¡Ð¢ Ñƒ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð¸',0),(330453,9180,'vi','Thuáº¿ GST trÃªn hoa há»“ng',0),(330454,9180,'af','BTW op Kommissie',0),(330455,9180,'ro','GST pe comision',0),(330456,9180,'et','Komisjoni GST',0),(330457,9180,'si','GST na Komisiji',0),(330458,9180,'ba','GST pada Komisi',0),(330459,9180,'nl','GST op Commissie',0),(330460,9180,'fi','GST komission',0),(330461,9180,'no','MVA pÃ¥ Commission',0),(330462,9180,'da','GST pÃ¥ Kommissionens',0),(330463,9180,'ko','ìœ„ì›íšŒì—ëŠ” GST',0),(330464,9180,'he','GST ×¢×œ ×¢×ž×œ×•×ª',0),(330465,9180,'el','GST ÏƒÏ„Î·Î½ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®',0),(330466,9180,'zh','å•†å“åŠä½£é‡‘æœåŠ¡ç¨Ž\r\n',0),(330467,9180,'sv','GST pÃ¥ kommissionen',0),(330468,9180,'it','GST su Commissione',0),(330469,9180,'tl','',0),(330470,9180,'th','GST on Commission',0),(330471,9180,'hi','à¤†à¤¯à¥‹à¤— à¤ªà¤° à¤œà¥€à¤à¤¸à¤Ÿà¥€',0),(330472,9180,'ms','GST pada Suruhanjaya',0),(330473,9180,'ar','Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ù…ÙˆÙ„Ø§Øª',0),(330474,9180,'fr','TPS sur Commission',0),(330475,9180,'jp','å§”å“¡ä¼šã« GST',0),(330476,9180,'pt','GST na ComissÃ£o',0),(330477,9180,'ru','GST Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(330478,9180,'es','GST en ComisiÃ³n',0),(330479,9180,'de','GST auf Kommission',0),(330480,9180,'en','GST on Commission',0),(330481,9181,'is','',0),(330482,9181,'dr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(330483,9181,'pr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(330484,9181,'tr','Ã–denen faturalar',0),(330485,9181,'pl','ZapÅ‚aconej faktury',0),(330486,9181,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(330487,9181,'ur','ØªÙ†Ø®ÙˆØ§Û ÙˆØ¨Ø¬Ù„ÛŒ',0),(330488,9181,'sr','ÐŸÐ»Ð°Ñ›ÐµÐ½Ð¸Ñ… Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(330489,9181,'vi','Tráº£ hÃ³a Ä‘Æ¡n',0),(330490,9181,'af','Betaalde Fakture',0),(330491,9181,'ro','Facturile plÄƒtite',0),(330492,9181,'et','Tasutud arved',0),(330493,9181,'si','PlaÄanih raÄunov',0),(330494,9181,'ba','Dibayar faktur',0),(330495,9181,'nl','Betaalde facturen',0),(330496,9181,'fi','Maksettujen laskujen',0),(330497,9181,'no','Betalte fakturaer',0),(330498,9181,'da','Betalte fakturaer',0),(330499,9181,'ko','ì§€ë¶ˆëœ ì²­êµ¬ì„œ',0),(330500,9181,'he','×—×©×‘×•× ×™×•×ª ×©×©×•×œ×ž×•',0),(330501,9181,'el','Î Î»Î·ÏÏ‰Î¼Î­Î½Î· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(330502,9181,'zh','æ”¯ä»˜å‘ç¥¨\r\n',0),(330503,9181,'sv','Betalda fakturor',0),(330504,9181,'it','Fatture pagate',0),(330505,9181,'tl','',0),(330506,9181,'th','&#3592;&#3656;&#3634;&#3618;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3649;&#3621;&#3657;&#3623;',0),(330507,9181,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(330508,9181,'ms','Invois-invois dibayar',0),(330509,9181,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø³Ø¯Ø¯Ø©',0),(330510,9181,'fr','Factures payÃ©es',0),(330511,9181,'jp','æœ‰æ–™ã®è«‹æ±‚æ›¸',0),(330512,9181,'pt','Facturas pagas',0),(330513,9181,'ru','ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð¡Ñ‡ÐµÑ‚Ð°',0),(330514,9181,'es','Facturas Pagados',0),(330515,9181,'de','Bezahlter Rechnungen',0),(330516,9181,'en','Paid Invoices',0),(330517,9182,'is','',0),(330518,9182,'dr','(Ù…Ø§Ø¨Ù‡ Ø§Ù„ØªÙØ§ÙˆØª - Ù…ÙØ§Ø¯ Ù†Ø§ÙˆÙŠÚ˜Ù‡ WGC ',0),(330519,9182,'pr','Ù…Ø§Ù„ÙŠØ§Øª  Ùˆ  Ø­Ø¯(Ù…Ø§Ø¨Ù‡ Ø§Ù„ØªÙØ§ÙˆØª - Ø³ÙˆØ¯ Ù†Ø§ÙˆÙŠÚ˜Ù‡ WGC ',0),(330520,9182,'tr','Vergi & WGC saÃ§aklar',0),(330521,9182,'pl','Podatek & WGC frÄ™dzlami',0),(330522,9182,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ & WGC Ñ€ÐµÑÐ½Ð¸',0),(330523,9182,'ur','Ù¹ÛŒÚ©Ø³ & ÙˆÚ¯Ú© Ø¬Ú¾Ø§Ù„Ø±',0),(330524,9182,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° & WÐ“Ð¦ Ñ€ÐµÑÐµ',0),(330525,9182,'vi','Thuáº¿ & lá»£i Ã­ch WGC',0),(330526,9182,'af','Belasting & WGC fraiings',0),(330527,9182,'ro','Taxa & WGC franjuri',0),(330528,9182,'et','Maksu & WGC narmad',0),(330529,9182,'si','Davek & WGC resice',0),(330530,9182,'ba','Pajak & WGC pinggiran',0),(330531,9182,'nl','Fiscale & WGC marge',0),(330532,9182,'fi','Vero & WGC hapsut',0),(330533,9182,'no','Skatt & WGC frynser',0),(330534,9182,'da','Skat & WGC frynser',0),(330535,9182,'ko','ì„¸ê¸ˆ & WGC ë³€ë‘ë¦¬',0),(330536,9182,'he','×ž×¡ & WGC ×‘×©×•×œ×™',0),(330537,9182,'el','Î¦ÏŒÏÎ¿Ï… & WGC ÎºÏÏŒÏƒÏƒÎ¹Î±',0),(330538,9182,'zh','ç¨ŽåŠ¡åŠWGCé¢å¤–è¡¥è´´\r\n',0),(330539,9182,'sv','Skatt & WGC fransar',0),(330540,9182,'it','Fiscale & WGC frange',0),(330541,9182,'tl','',0),(330542,9182,'th','Tax & WGC Fringes',0),(330543,9182,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ & WGC à¤•à¤¿à¤¨à¤¾à¤°à¥‡',0),(330544,9182,'ms','Cukai & WGC pinggiran',0),(330545,9182,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø¢Ù†Ø¯ Ù‡Ø§Ù…Ø´ Ù…Ø¬Ù„Ø³ Ø§Ù„Ø°Ù‡Ø¨ Ø§Ù„Ø¹Ø§Ù„Ù…ÙŠ',0),(330546,9182,'fr','Taxe & WGC franges',0),(330547,9182,'jp','ç¨Ž & WGC ç¸ž',0),(330548,9182,'pt','Imposto & WGC franjas',0),(330549,9182,'ru','ÐÐ°Ð»Ð¾Ð³ & WGC Ð¿Ð¾Ð»Ð¾Ñ',0),(330550,9182,'es','Impuestos & WGC Fringes',0),(330551,9182,'de','Steuer & WGC Fransen',0),(330552,9182,'en','Tax & WGC Fringes',0),(330553,9183,'is','',0),(330554,9183,'dr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ ',0),(330555,9183,'pr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ ',0),(330556,9183,'tr','Ã–denmemiÅŸ faturalar',0),(330557,9183,'pl','NiezapÅ‚acone faktury',0),(330558,9183,'bg','ÐÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(330559,9183,'ur','Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û ÙˆØ¨Ø¬Ù„ÛŒ',0),(330560,9183,'sr','ÐÐµÐ¿Ð»Ð°Ñ›ÐµÐ½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(330561,9183,'vi','HÃ³a Ä‘Æ¡n chÆ°a tráº£',0),(330562,9183,'af','Onbetaalde Fakture',0),(330563,9183,'ro','Facturile neplÄƒtite',0),(330564,9183,'et','Tasumata arved',0),(330565,9183,'si','NeplaÄani raÄuni',0),(330566,9183,'ba','Tagihan yang belum dibayar',0),(330567,9183,'nl','Openstaande facturen',0),(330568,9183,'fi','Maksamattomat laskut',0),(330569,9183,'no','Ubetalte fakturaer',0),(330570,9183,'da','Ubetalte fakturaer',0),(330571,9183,'ko','ë¯¸ë‚©ëœ ì²­êµ¬ì„œ',0),(330572,9183,'he','×—×©×‘×•× ×™×•×ª ×©×œ× ×©×•×œ×ž×•',0),(330573,9183,'el','Î‘Ï€Î»Î®ÏÏ‰Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(330574,9183,'zh','æœªæ”¯ä»˜çš„å‘ç¥¨\r\n',0),(330575,9183,'sv','Obetalda fakturor',0),(330576,9183,'it','Fatture non pagate',0),(330577,9183,'tl','',0),(330578,9183,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3618;&#3633;&#3591;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(330579,9183,'hi','à¤…à¤µà¥ˆà¤¤à¤¨à¤¿à¤• à¤šà¤¾à¤²à¤¾à¤¨',0),(330580,9183,'ms','Invois-invois tidak berbayar',0),(330581,9183,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± ØºÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(330582,9183,'fr','Factures impayÃ©es',0),(330583,9183,'jp','æœªæ‰•ã„ã®è«‹æ±‚æ›¸',0),(330584,9183,'pt','Faturas nÃ£o-pagas',0),(330585,9183,'ru','ÐÐµÐ¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð¡Ñ‡ÐµÑ‚Ð°',0),(330586,9183,'es','Facturas No Pagadas',0),(330587,9183,'de','Unbezahlte Rechnungen',0),(330588,9183,'en','Unpaid Invoices',0),(330589,9184,'is','',0),(330590,9184,'dr','WGC ØªØ®ÙÙŠÙ ',0),(330591,9184,'pr','WGC ØªØ®ÙÙŠÙ ',0),(330592,9184,'tr','WGC kesinti',0),(330593,9184,'pl','WGC odliczenia',0),(330594,9184,'bg','WGC Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(330595,9184,'ur','ÙˆÚ¯Ú© Ù†ØªÛŒØ¬Û',0),(330596,9184,'sr','WÐ“Ð¦ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð°',0),(330597,9184,'vi','Giáº£m trá»« WGC',0),(330598,9184,'af','WGC aftrekking',0),(330599,9184,'ro','WGC deducerea',0),(330600,9184,'et','*WGC Deduction',0),(330601,9184,'si','WGC odbitek',0),(330602,9184,'ba','WGC pengurangan',0),(330603,9184,'nl','WGC aftrek',0),(330604,9184,'fi','WGC vÃ¤hennys',0),(330605,9184,'no','WGC fradrag',0),(330606,9184,'da','WGC fradrag',0),(330607,9184,'ko','WGC ê³µì œ',0),(330608,9184,'he','WGC × ×™×›×•×™',0),(330609,9184,'el','WGC Î±Ï†Î±Î¯ÏÎµÏƒÎ·',0),(330610,9184,'zh','ä¸–ç•Œé»„é‡‘åä¼šæ‰£é™¤\r\n',0),(330611,9184,'sv','WGC avdrag',0),(330612,9184,'it','WGC deduzione',0),(330613,9184,'tl','',0),(330614,9184,'th','&#3585;&#3634;&#3619;&#3627;&#3633;&#3585; WGC',0),(330615,9184,'hi','WGC à¤•à¤Ÿà¥Œà¤¤à¥€',0),(330616,9184,'ms','WGC potongan',0),(330617,9184,'ar','Ø®ØµÙ… Ù…Ø¬Ù„Ø³ Ø§Ù„Ø°Ù‡Ø¨ Ø§Ù„Ø¹Ø§Ù„Ù…ÙŠ',0),(330618,9184,'fr','DÃ©duction de la WGC',0),(330619,9184,'jp','WGC æŽ§é™¤',0),(330620,9184,'pt','WGC deduÃ§Ã£o',0),(330621,9184,'ru','WGC Ð²Ñ‹Ñ‡ÐµÑ‚',0),(330622,9184,'es','DeducciÃ³n de WGC',0),(330623,9184,'de','WGC-Abzug',0),(330624,9184,'en','WGC Deduction',0),(330625,9185,'is','',0),(330626,9185,'dr','( Ø³Ø±Ù…Ø§ÙŠÙ‡ ) Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ',0),(330627,9185,'pr','Ú¯Ø²Ø§Ø±Ø´ ØµÙ†Ø¯ÙˆÙ‚( Ø³Ø±Ù…Ø§ÙŠÙ‡ ) Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ',0),(330628,9185,'tr','Pazarlama fonu raporu',0),(330629,9185,'pl','Raport Funduszu gospodarczego',0),(330630,9185,'bg','ÐœÐ°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³ Ñ„Ð¾Ð½Ð´ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(330631,9185,'ur','Ù…Ø§Ø±Ú©ÛŒÙ¹Ù†Ú¯ ÙÙ†Úˆ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(330632,9185,'sr','ÐœÐ°Ñ€ÐºÐµÑ‚Ð¸Ð½ÑˆÐºÐ¸ Ñ„Ð¾Ð½Ð´ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(330633,9185,'vi','BÃ¡o cÃ¡o quá»¹ Marketing',0),(330634,9185,'af','Bemarkingsfondsverslag',0),(330635,9185,'ro','Marketing Fondul raport',0),(330636,9185,'et','Turunduse fondi aruanne',0),(330637,9185,'si','TrÅ¾no poroÄilo sklada',0),(330638,9185,'ba','Pemasaran laporan dana',0),(330639,9185,'nl','Marketing Fonds verslag',0),(330640,9185,'fi','Markkinointi mietintÃ¶Ã¤',0),(330641,9185,'no','MarkedsfÃ¸ring fondet rapport',0),(330642,9185,'da','MarkedsfÃ¸ring fonden rapport',0),(330643,9185,'ko','ë§ˆì¼€íŒ… íŽ€ë“œ ë³´ê³ ì„œ',0),(330644,9185,'he','×”×“×• ×— ×§×¨×Ÿ ×©×™×•×•×§',0),(330645,9185,'el','ÎœÎ¬ÏÎºÎµÏ„Î¹Î½Î³Îº Î¤Î±Î¼ÎµÎ¯Î¿ Î­ÎºÎ¸ÎµÏƒÎ·',0),(330646,9185,'zh','å¸‚åœºæŽ¨å¹¿åŸºé‡‘çš„æŠ¥å‘Š\r\n',0),(330647,9185,'sv','MarknadsfÃ¶ring fondrapporten',0),(330648,9185,'it','Marketing relazione di fondo',0),(330649,9185,'tl','',0),(330650,9185,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3591;&#3636;&#3609;&#3585;&#3634;&#3619;&#3607;&#3635;&#3605;&#3621;&#3634;&#3604;',0),(330651,9185,'hi','à¤µà¤¿à¤ªà¤£à¤¨ à¤¨à¤¿à¤§à¤¿ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(330652,9185,'ms','Pemasaran dana Laporan',0),(330653,9185,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØµÙ†Ø¯ÙˆÙ‚ Ø§Ù„ØªØ³ÙˆÙŠÙ‚',0),(330654,9185,'fr','Rapport de Fond Commerciaux',0),(330655,9185,'jp','ãƒ•ã‚¡ãƒ³ãƒ‰ã®ãƒžãƒ¼ã‚±ãƒ†ã‚£ãƒ³ã‚° ãƒ¬ãƒãƒ¼ãƒˆ',0),(330656,9185,'pt','RelatÃ³rio de fundo de marketing',0),(330657,9185,'ru','ÐœÐ°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³Ð¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ñ„Ð¾Ð½Ð´Ð°',0),(330658,9185,'es','Informe de Fondo de Marketing',0),(330659,9185,'de','Marketing Fonds-Report',0),(330660,9185,'en','Marketing Fund Report',0),(330661,9186,'is','',0),(330662,9186,'dr','Ø¨Ø§ Ø¯ÙŠÚ¯Ø± Ø¯ÙˆØ±Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ÙŠÙƒÙŠ ÙƒÙ†ÙŠØ¯ ',0),(330663,9186,'pr','Ø¨Ø§ Ø¯ÙŠÚ¯Ø± Ø¯ÙˆØ±Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ù…Ø§Ù„ÙŠØ§ØªÙŠ ÙŠÙƒÙŠ ÙƒÙ†ÙŠØ¯ ',0),(330664,9186,'tr','BaÅŸka bir dÃ¶nem iÃ§in vergi hesaplamalarÄ± birleÅŸtirmek',0),(330665,9186,'pl','PoÅ‚Ä…czyÄ‡ z innego okresu do obliczenia podatku',0),(330666,9186,'bg','ÐšÐ¾Ð¼Ð±Ð¸Ð½Ð¸Ñ€Ð°Ð½Ðµ Ñ Ð´Ñ€ÑƒÐ³ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð·Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(330667,9186,'ur','Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø­Ø³Ø§Ø¨ Ú©Û’ Ù„Ø¦Û’ Ø¯ÙˆØ³Ø±Û’ Ø¯ÙˆØ± Ú©Û’ Ø³Ø§ØªÚ¾ ÛŒÚ©Ø¬Ø§',0),(330668,9186,'sr','ÐšÐ¾Ð¼Ð±Ð¸Ð½ÑƒÑ˜Ðµ ÑÐ° Ð´Ñ€ÑƒÐ³Ð¸Ð¼ ÐŸÐµÑ€Ð¸Ð¾Ð´ Ð·Ð° Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(330669,9186,'vi','Gá»™p chung vá»›i ká»³ khÃ¡ch Ä‘á»ƒ tÃ­nh thuáº¿',0),(330670,9186,'af','Kombineer Met Ander Periode Vir Belasting Berekenings',0),(330671,9186,'ro','Combina cu alte perioade pentru calcule fiscale',0),(330672,9186,'et','Kombineerida teiste perioodi kÃ¤ibemaksu arvutamiseks',0),(330673,9186,'si','ZdruÅ¾ite z drugo obdobje za davke',0),(330674,9186,'ba','Menggabungkan dengan periode lain untuk perhitungan pajak',0),(330675,9186,'nl','Combineren met andere periode voor belasting berekeningen',0),(330676,9186,'fi','YhdistÃ¤Ã¤ muun ajan vero laskelmat',0),(330677,9186,'no','Kombiner med andre periode For skatt beregninger',0),(330678,9186,'da','Kombiner med andre periode For momsberegninger',0),(330679,9186,'ko','ì„¸ê¸ˆ ê³„ì‚°ì„ ìœ„í•œ ë‹¤ë¥¸ ê¸°ê°„ ê²°í•©',0),(330680,9186,'he','×œ×©×œ×‘ ×¢× ××—×¨×™× ×ª×§×•×¤×” ×œ×—×™×©×•×‘×™ ×ž×¡',0),(330681,9186,'el','Î£Ï…Î½Î´Ï…Î¬ÏƒÏ„Îµ Î¼Îµ Î¬Î»Î»Î· Ï€ÎµÏÎ¯Î¿Î´Î¿ Î³Î¹Î± Ï„Î¿Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï…',0),(330682,9186,'zh','ç»“åˆå…¶ä»–æœŸé—´è®¡ç¨Ž\r\n',0),(330683,9186,'sv','Kombinera med andra Period fÃ¶r momsberÃ¤kningarna',0),(330684,9186,'it','Combinare con altri periodo per il calcolo delle tasse',0),(330685,9186,'tl','',0),(330686,9186,'th','&#3619;&#3623;&#3617;&#3585;&#3633;&#3610;&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3629;&#3639;&#3656;&#3609;&#3654; &#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3588;&#3635;&#3609;&#3623;&#3603;&#3616;&#3634;&#3625;&#',0),(330687,9186,'hi','à¤…à¤¨à¥à¤¯ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤—à¤ à¤¬à¤‚à¤§à¤¨ à¤•à¤° à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤',0),(330688,9186,'ms','Menggabungkan dengan tempoh lain bagi Pengiraan cukai',0),(330689,9186,'ar','Ø§Ù„Ø¬Ù…Ø¹ Ø¨ÙŠÙ† ÙØªØ±Ø© Ø£Ø®Ø±Ù‰ Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(330690,9186,'fr','Combiner avec une autre pÃ©riode pour le calcul des taxes',0),(330691,9186,'jp','ç¨Žã®è¨ˆç®—ã®ä»–ã®æœŸé–“ã¨çµ„ã¿åˆã‚ã›ã‚‹',0),(330692,9186,'pt','Combinar com outro perÃ­odo para cÃ¡lculos de impostos',0),(330693,9186,'ru','ÐžÐ±ÑŠÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒ Ñ Ð´Ñ€ÑƒÐ³Ð¸Ð¼ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¾Ð¼ Ð´Ð»Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ñ… Ñ€Ð°ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(330694,9186,'es','Combinar Con Otro PerÃ­odo Para CÃ¡lculo de Impuestos',0),(330695,9186,'de','Kombinieren Sie mit anderen Zeitraum fÃ¼r Steuerberechnungen',0),(330696,9186,'en','Combine With Other Period For Tax Calculations',0),(330697,9187,'is','',0),(330698,9187,'dr','Ø¨Ø§ Ù‡Ù… Ø§Ø¯ØºØ§Ù… Ù†ÙƒÙ†ÙŠØ¯ ',0),(330699,9187,'pr','Ø¨Ø§ Ù‡Ù… Ø§Ø¯ØºØ§Ù… Ù†ÙƒÙ†ÙŠØ¯ ',0),(330700,9187,'tr','BirleÅŸtirmek deÄŸil',0),(330701,9187,'pl','Nie Å‚Ä…czÄ… siÄ™',0),(330702,9187,'bg','ÐÐµ ÑÐµ ÐºÐ¾Ð¼Ð±Ð¸Ð½Ð¸Ñ€Ð°Ñ‚',0),(330703,9187,'ur','Ù†ÛÛŒÚº Ø¬ÙˆÚ‘ØªÛ’ ÛÛŒÚº',0),(330704,9187,'sr','ÐÐµ ÑÐ¿Ð¾Ñ˜Ð¸.',0),(330705,9187,'vi','Äá»«ng gá»™p vÃ o',0),(330706,9187,'af','Moet Nie Kombineer',0),(330707,9187,'ro','Nu combina',0),(330708,9187,'et','Kombineeri',0),(330709,9187,'si','Ne zdruÅ¾ujte logotipa',0),(330710,9187,'ba','Jangan menggabungkan',0),(330711,9187,'nl','Niet combineren',0),(330712,9187,'fi','Ã„lÃ¤ yhdistÃ¤',0),(330713,9187,'no','Kombiner ikke',0),(330714,9187,'da','Kombiner ikke',0),(330715,9187,'ko','ê²°í•© í•˜ì§€',0),(330716,9187,'he','××œ ×ª×©×œ×‘×•',0),(330717,9187,'el','Î”ÎµÎ½ ÏƒÏ…Î½Î´Ï…Î¬Î¶Î¿Î½Ï„Î±Î¹',0),(330718,9187,'zh','ä¸åˆå¹¶\r\n',0),(330719,9187,'sv','Inte kombinera',0),(330720,9187,'it','Non combinare',0),(330721,9187,'tl','',0),(330722,9187,'th','&#3629;&#3618;&#3656;&#3634;&#3619;&#3623;&#3617;',0),(330723,9187,'hi','à¤—à¤ à¤¬à¤‚à¤§à¤¨ à¤¨à¤¹à¥€à¤‚',0),(330724,9187,'ms','Tidak menggabungkan',0),(330725,9187,'ar','Ø¹Ø¯Ù… Ø§Ù„Ø¬Ù…Ø¹ Ø¨ÙŠÙ†',0),(330726,9187,'fr','Ne pas combiner',0),(330727,9187,'jp','çµ„ã¿åˆã‚ã›ã¦ä½¿ç”¨ã—ãªã„ã§ãã ã•ã„ã€‚',0),(330728,9187,'pt','NÃ£o combinam',0),(330729,9187,'ru','ÐÐµ ÑÐ»ÐµÐ´ÑƒÐµÑ‚ ÑÐ¾Ñ‡ÐµÑ‚Ð°Ñ‚ÑŒ',0),(330730,9187,'es','No Combina',0),(330731,9187,'de','Nicht kombinieren',0),(330732,9187,'en','Do Not Combine',0),(330733,9188,'is','',0),(330734,9188,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(330735,9188,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(330736,9188,'tr','Yeni anket eklemek',0),(330737,9188,'pl','Dodaj nowe badania',0),(330738,9188,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(330739,9188,'ur','Ù†Ø¦Û’ Ø³Ø±ÙˆÛ’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(330740,9188,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¾ Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(330741,9188,'vi','ThÃªm Kháº£o SÃ¡t Má»›i',0),(330742,9188,'af','Nuwe Opname Byvoeg',0),(330743,9188,'ro','Adauga nou sondaj',0),(330744,9188,'et','Lisa uus kÃ¼sitlus',0),(330745,9188,'si','Dodate novo anketo',0),(330746,9188,'ba','Tambahkan survei baru',0),(330747,9188,'nl','Toevoegen van nieuwe enquÃªte',0),(330748,9188,'fi','LisÃ¤Ã¤ uusi tutkimus',0),(330749,9188,'no','Legg til ny undersÃ¸kelse',0),(330750,9188,'da','TilfÃ¸j ny undersÃ¸gelse',0),(330751,9188,'ko','ìƒˆë¡œìš´ ì„¤ë¬¸ ì¡°ì‚¬ë¥¼ ì¶”ê°€',0),(330752,9188,'he','×”×•×¡×£ ×¡×§×¨ ×—×“×©',0),(330753,9188,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î­ÏÎµÏ…Î½Î±',0),(330754,9188,'zh','å¢žåŠ æ–°è°ƒæŸ¥\r\n',0),(330755,9188,'sv','LÃ¤gg till ny undersÃ¶kning',0),(330756,9188,'it','Aggiungi nuovo sondaggio',0),(330757,9188,'tl','',0),(330758,9188,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(330759,9188,'hi','à¤¨à¤ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(330760,9188,'ms','Tambah kaji selidik baru',0),(330761,9188,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø³ØªØ¨ÙŠØ§Ù† Ø¬Ø¯ÙŠØ¯',0),(330762,9188,'fr','Ajouter nouveau sondage',0),(330763,9188,'jp','æ–°ã—ã„ã‚¢ãƒ³ã‚±ãƒ¼ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(330764,9188,'pt','Adicionar nova pesquisa',0),(330765,9188,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¾Ð¿Ñ€Ð¾Ñ',0),(330766,9188,'es','Agregar Nuevo Estudio',0),(330767,9188,'de','Neue Umfrage hinzufÃ¼gen',0),(330768,9188,'en','Add New Survey',0),(330769,9189,'is','',0),(330770,9189,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙˆØ§Ù„ ',0),(330771,9189,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙˆØ§Ù„ ',0),(330772,9189,'tr','Soru Ekle',0),(330773,9189,'pl','Dodaj pytanie',0),(330774,9189,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²ÑŠÐ¿Ñ€Ð¾Ñ',0),(330775,9189,'ur','Ø³ÙˆØ§Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(330776,9189,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð¿Ð¸Ñ‚Ð°ÑšÐµ',0),(330777,9189,'vi','ThÃªm CÃ¢u Há»i',0),(330778,9189,'af','Vraag Byvoeg',0),(330779,9189,'ro','Adauga Ã®ntrebare',0),(330780,9189,'et','Lisa kÃ¼simus',0),(330781,9189,'si','Dodati vpraÅ¡anje',0),(330782,9189,'ba','Tambah pertanyaan',0),(330783,9189,'nl','Vraag toevoegen',0),(330784,9189,'fi','LisÃ¤Ã¤ kysymys',0),(330785,9189,'no','Legge til spÃ¸rsmÃ¥l',0),(330786,9189,'da','TilfÃ¸j spÃ¸rgsmÃ¥l',0),(330787,9189,'ko','ì§ˆë¬¸ ì¶”ê°€',0),(330788,9189,'he','×”×•×¡×£ ×©××œ×”',0),(330789,9189,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ ÎµÏÏŽÏ„Î·ÏƒÎ·',0),(330790,9189,'zh','å¢žåŠ é—®é¢˜\r\n',0),(330791,9189,'sv','LÃ¤gga till frÃ¥ga',0),(330792,9189,'it','Aggiungi domanda',0),(330793,9189,'tl','',0),(330794,9189,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3606;&#3634;&#3617;',0),(330795,9189,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(330796,9189,'ms','Tambah soalan',0),(330797,9189,'ar','Ø¥Ø¶Ø§ÙØ© Ø³Ø¤Ø§Ù„',0),(330798,9189,'fr','Ajouter Question',0),(330799,9189,'jp','è³ªå•ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(330800,9189,'pt','Adicionar pergunta',0),(330801,9189,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð’Ð¾Ð¿Ñ€Ð¾Ñ',0),(330802,9189,'es','Agregar Pregunta',0),(330803,9189,'de','Frage hinzufÃ¼gen',0),(330804,9189,'en','Add Question',0),(330805,9190,'is','',0),(330806,9190,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙˆØ§Ù„ Ø¨Ø±Ø§ÙŠ',0),(330807,9190,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙˆØ§Ù„ Ø¨Ø±Ø§ÙŠ',0),(330808,9190,'tr','Soru Ekle',0),(330809,9190,'pl','Dodaj pytanie do',0),(330810,9190,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð²ÑŠÐ¿Ñ€Ð¾Ñ Ð·Ð°',0),(330811,9190,'ur','Ø³ÙˆØ§Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(330812,9190,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð¿Ð¸Ñ‚Ð°ÑšÐµ Ð·Ð°',0),(330813,9190,'vi','ThÃªm CÃ¢u Há»i cho',0),(330814,9190,'af','Vraag Byvoeg Vir ',0),(330815,9190,'ro','Adauga Ã®ntrebare pentru',0),(330816,9190,'et','Lisa kÃ¼simus',0),(330817,9190,'si','Dodati vpraÅ¡anje za',0),(330818,9190,'ba','Menambahkan pertanyaan untuk',0),(330819,9190,'nl','Vraag voor toevoegen',0),(330820,9190,'fi','LisÃ¤Ã¤ kysymys',0),(330821,9190,'no','Legge til spÃ¸rsmÃ¥l For',0),(330822,9190,'da','TilfÃ¸j spÃ¸rgsmÃ¥l For',0),(330823,9190,'ko','ì§ˆë¬¸ì— ëŒ€ í•œ ì¶”ê°€',0),(330824,9190,'he','×”×•×¡×¤×ª ×©××œ×”',0),(330825,9190,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ ÎµÏÏŽÏ„Î·Î¼Î± Î³Î¹Î±',0),(330826,9190,'zh','å¢žåŠ è®®é¢˜\r\n',0),(330827,9190,'sv','LÃ¤gga till frÃ¥ga fÃ¶r',0),(330828,9190,'it','Aggiungi domanda per',0),(330829,9190,'tl','',0),(330830,9190,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3606;&#3634;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;',0),(330831,9190,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¶à¥à¤¨',0),(330832,9190,'ms','Tambah soalan untuk',0),(330833,9190,'ar','Ø¥Ø¶Ø§ÙØ© Ø³Ø¤Ø§Ù„ Ù„Ù„Ù€',0),(330834,9190,'fr','Ajouter Question pour',0),(330835,9190,'jp','ãŸã‚ã®è³ªå•ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(330836,9190,'pt','Adicionar pergunta para',0),(330837,9190,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð’Ð¾Ð¿Ñ€Ð¾Ñ Ð”Ð»Ñ',0),(330838,9190,'es','Agregar Pregunta Para',0),(330839,9190,'de','Frage hinzufÃ¼gen',0),(330840,9190,'en','Add Question For',0),(330841,9191,'is','',0),(330842,9191,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø³ÙˆØ§Ù„Ø§Øª Ø¨Ø±Ø§ÙŠ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ',0),(330843,9191,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙˆØ§Ù„Ø§Øª Ø¨Ø±Ø§ÙŠ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ',0),(330844,9191,'tr','Anket sorularÄ± ekleyin/gÃ¼ncelleyin',0),(330845,9191,'pl','Dodaj/Aktualizuj pytania o badania',0),(330846,9191,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²ÑŠÐ¿Ñ€Ð¾ÑÐ¸ Ð·Ð° Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(330847,9191,'ur','Ø³Ø±ÙˆÛ’ Ú©Û’ Ù„Ø¦Û’ Ø³ÙˆØ§Ù„Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(330848,9191,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¸Ñ‚Ð°ÑšÐ° Ð·Ð° Ð°Ð½ÐºÐµÑ‚Ñƒ',0),(330849,9191,'vi','ThÃªm/Cáº­p Nháº­t CÃ¢u Há»i Cho Kháº£o SÃ¡t',0),(330850,9191,'af','Vrae vir Opname Byvoeg/Opdateer',0),(330851,9191,'ro','AdÄƒugaÅ£i/actualizaÅ£i Ã®ntrebÄƒrile pentru ancheta',0),(330852,9191,'et','Uuringu kÃ¼simuste lisamine/uuendamine',0),(330853,9191,'si','Dodaj/posodobi vpraÅ¡anja za raziskavo',0),(330854,9191,'ba','Tambahkan/Perbarui pertanyaan untuk survei',0),(330855,9191,'nl','Vragen voor de enquÃªte toevoegen/bijwerken',0),(330856,9191,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ kysymyksiÃ¤ tutkimuksen',0),(330857,9191,'no','Legg til/Oppdater spÃ¸rsmÃ¥l For undersÃ¸kelsen',0),(330858,9191,'da','TilfÃ¸j/opdater spÃ¸rgsmÃ¥l til undersÃ¸gelsen',0),(330859,9191,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ì§ˆë¬¸ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(330860,9191,'he','×”×•×¡×£/×¢×“×›×Ÿ ×©××œ×•×ª ×”×¡×§×¨',0),(330861,9191,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏÏ‰Ï„Î®ÏƒÎµÎ¹Ï‚ Î³Î¹Î± Î­ÏÎµÏ…Î½Î±',0),(330862,9191,'zh','å¢žåŠ /æ›´æ–°è°ƒæŸ¥é—®é¢˜\r\n',0),(330863,9191,'sv','LÃ¤gg till/uppdatera frÃ¥gor fÃ¶r undersÃ¶kning',0),(330864,9191,'it','Aggiungere o aggiornare le domande per sondaggio',0),(330865,9191,'tl','',0),(330866,9191,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3588;&#3635;&#3606;&#3634;&#3617;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(330867,9191,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(330868,9191,'ms','Tambah/Kemaskini soalan untuk kaji selidik',0),(330869,9191,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£Ø³Ø¦Ù„Ø© Ù„Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù†',0),(330870,9191,'fr','Ajouter/mettre Ã  jour des Questions de sondage',0),(330871,9191,'jp','èª¿æŸ»ã®ãŸã‚ã®è³ªå•ã‚’è¿½åŠ /æ›´æ–°',0),(330872,9191,'pt','Adicionar/atualizar questÃµes para pesquisa',0),(330873,9191,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð’Ð¾Ð¿Ñ€Ð¾Ñ Ð”Ð»Ñ ÐžÐ¿Ñ€Ð¾ÑÐ°',0),(330874,9191,'es','Agregar/Actualizar Preguntas Para el Estudio',0),(330875,9191,'de','Fragen zur Umfrage hinzufÃ¼gen/aktualisieren',0),(330876,9191,'en','Add/Update Questions For Survey',0),(330877,9192,'is','',0),(330878,9192,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¬Ø¯ÙŠØ¯',0),(330879,9192,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¬Ø¯ÙŠØ¯',0),(330880,9192,'tr','Yeni Anket oluÅŸturma',0),(330881,9192,'pl','UtworzyÄ‡ nowy sondaÅ¼',0),(330882,9192,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(330883,9192,'ur','Ø§ÛŒÚ© Ù†Ø¦Û’ Ø³Ø±ÙˆÛ’ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(330884,9192,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð°Ð½ÐºÐµÑ‚Ñƒ',0),(330885,9192,'vi','Táº¡o kháº£o sÃ¡t má»›i',0),(330886,9192,'af','\'n Nuwe Opname Skep',0),(330887,9192,'ro','Crea un sondaj nou',0),(330888,9192,'et','Loo uus kÃ¼sitlus',0),(330889,9192,'si','Ustvarite novo anketo',0),(330890,9192,'ba','Membuat sebuah survei baru',0),(330891,9192,'nl','Een nieuwe enquÃªte maken',0),(330892,9192,'fi','Luoda uuden tutkimuksen',0),(330893,9192,'no','Opprette en ny undersÃ¸kelse',0),(330894,9192,'da','Oprette en ny undersÃ¸gelse',0),(330895,9192,'ko','ìƒˆë¡œìš´ ì„¤ë¬¸ ì¡°ì‚¬ë¥¼ ë§Œë“¤',0),(330896,9192,'he','×¦×•×¨ ×¡×§×¨ ×—×“×©',0),(330897,9192,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î¼Î¹Î± Î½Î­Î± Î­ÏÎµÏ…Î½Î±',0),(330898,9192,'zh','åˆ›å»ºä¸€ä¸ªæ–°çš„è°ƒæŸ¥\r\n',0),(330899,9192,'sv','Skapa en ny undersÃ¶kning',0),(330900,9192,'it','Creare un nuovo sondaggio',0),(330901,9192,'tl','',0),(330902,9192,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3635;&#3619;&#3623;&#3592;',0),(330903,9192,'hi','à¤à¤• à¤¨à¤ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤¬à¤¨à¤¾à¤à¤',0),(330904,9192,'ms','Membuat kaji selidik baru',0),(330905,9192,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¥Ø³ØªØ¨ÙŠØ§Ù† Ø¬Ø¯ÙŠØ¯',0),(330906,9192,'fr','CrÃ©er un nouveau sondage',0),(330907,9192,'jp','æ–°ã—ã„ã‚¢ãƒ³ã‚±ãƒ¼ãƒˆã‚’ä½œæˆã—ã¾ã™ã€‚',0),(330908,9192,'pt','Criar uma nova pesquisa',0),(330909,9192,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¾Ð¿Ñ€Ð¾Ñ',0),(330910,9192,'es','Crear Un Nuevo Estudio',0),(330911,9192,'de','Eine neue Umfrage erstellen',0),(330912,9192,'en','Create A New Survey',0),(330913,9193,'is','',0),(330914,9193,'dr','Ø³ÙˆØ§Ù„Ø§Øª Ø¬Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ',0),(330915,9193,'pr','Ø³ÙˆØ§Ù„Ø§Øª Ø¬Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ',0),(330916,9193,'tr','GeÃ§erli sorular iÃ§in',0),(330917,9193,'pl','Aktualne pytania',0),(330918,9193,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð²ÑŠÐ¿Ñ€Ð¾ÑÐ¸ Ð·Ð°',0),(330919,9193,'ur','Ø­Ø§Ù„ÛŒÛ Ø¬ÙˆØ§Ø¨Ø§Øª Ú©Û’ Ù„Ø¦Û’',0),(330920,9193,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð¿Ð¸Ñ‚Ð°ÑšÐ° Ð·Ð°',0),(330921,9193,'vi','CÃ¢u há»i hiá»‡n thá»i cho',0),(330922,9193,'af','Huidige Vrae Vir',0),(330923,9193,'ro','ÃŽntrebÄƒri curent pentru',0),(330924,9193,'et','Praegune kÃ¼simused',0),(330925,9193,'si','Trenutna vpraÅ¡anja za',0),(330926,9193,'ba','Saat ini pertanyaan untuk',0),(330927,9193,'nl','Huidige vragen voor',0),(330928,9193,'fi','Nykyinen kysymykset',0),(330929,9193,'no','Gjeldende spÃ¸rsmÃ¥l For',0),(330930,9193,'da','Aktuelle spÃ¸rgsmÃ¥l til',0),(330931,9193,'ko','í˜„ìž¬ ê´€ë ¨ ì§ˆë¬¸',0),(330932,9193,'he','×©××œ×•×ª ×”× ×•×›×—×™',0),(330933,9193,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎµÏÏ‰Ï„Î®ÏƒÎµÎ¹Ï‚ Î³Î¹Î±',0),(330934,9193,'zh','å¯¹äºŽçŽ°æœ‰é—®é¢˜\r\n',0),(330935,9193,'sv','Aktuella frÃ¥gor fÃ¶r',0),(330936,9193,'it','Domande attuali per',0),(330937,9193,'tl','',0),(330938,9193,'th','&#3588;&#3635;&#3606;&#3634;&#3617;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3586;&#3629;&#3591;',0),(330939,9193,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ªà¥à¤°à¤¶à¥à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤',0),(330940,9193,'ms','Soalan-soalan semasa untuk',0),(330941,9193,'ar','Ø§Ù„Ø£Ø³Ø¦Ù„Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ© Ù„Ù„Ù€',0),(330942,9193,'fr','Questions courantes pour',0),(330943,9193,'jp','ç¾åœ¨ã®è³ªå•',0),(330944,9193,'pt','QuestÃµes atuais para',0),(330945,9193,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð’Ð¾Ð¿Ñ€Ð¾ÑÑ‹ ÐŸÐ¾',0),(330946,9193,'es','Preguntas Actuales Para',0),(330947,9193,'de','Aktuelle Fragen zum',0),(330948,9193,'en','Current Questions For',0),(330949,9194,'is','',0),(330950,9194,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(330951,9194,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(330952,9194,'tr','Hata yeni anket ekleme',0),(330953,9194,'pl','BÅ‚Ä…d dodawania nowych badaÅ„',0),(330954,9194,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(330955,9194,'ur','Ù†Ù‚Øµ Ø§Ø¶Ø§ÙÛ Ù†ÛŒØ§ Ø³Ø±ÙˆÛ’',0),(330956,9194,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð½Ð¾Ð²Ð¾ Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(330957,9194,'vi','ThÃªm kháº£o sÃ¡t bá»‹ lá»—i',0),(330958,9194,'af','Fout met Byvoeging van Nuwe Opname',0),(330959,9194,'ro','Eroare de adÄƒugare nou sondaj',0),(330960,9194,'et','Uue kÃ¼sitluse lisamisel tekkis viga',0),(330961,9194,'si','Napaka dodal novo anketo',0),(330962,9194,'ba','Survei baru menambahkan kesalahan',0),(330963,9194,'nl','Fout toe te voegen nieuwe enquÃªte',0),(330964,9194,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ uusi tutkimus',0),(330965,9194,'no','Feil Ã¥ legge ny undersÃ¸kelse',0),(330966,9194,'da','Fejl tilfÃ¸jer ny undersÃ¸gelse',0),(330967,9194,'ko','ì˜¤ë¥˜ ì¶”ê°€ ìƒˆ ì„¤ë¬¸ ì¡°ì‚¬',0),(330968,9194,'he','×”×•×¡×¤×ª ×¡×§×¨ ×—×“×© ×©×’×™××”',0),(330969,9194,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ Î½Î­Î± Î­ÏÎµÏ…Î½Î±',0),(330970,9194,'zh','é”™è¯¯æ·»åŠ æ–°è°ƒæŸ¥',0),(330971,9194,'sv','Fel att lÃ¤gga ny undersÃ¶kning',0),(330972,9194,'it','Errore aggiungendo nuovo sondaggio',0),(330973,9194,'tl','',0),(330974,9194,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3651;&#3627;&#3617;&#3656;',0),(330975,9194,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¨à¤ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£',0),(330976,9194,'ms','Ralat menambah kaji selidik baru',0),(330977,9194,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø¥Ø³ØªØ¨ÙŠØ§Ù† Ø¬Ø¯ÙŠØ¯',0),(330978,9194,'fr','Erreur ajout nouveau sondage',0),(330979,9194,'jp','ã‚¨ãƒ©ãƒ¼ã®è¿½åŠ ã®æ–°ã—ã„èª¿æŸ»',0),(330980,9194,'pt','Erro adicionando nova pesquisa',0),(330981,9194,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð¾Ð²Ð¾Ð³Ð¾ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(330982,9194,'es','Error Agregando un Nuevo Estudio',0),(330983,9194,'de','Fehler hinzufÃ¼gen neue Umfrage',0),(330984,9194,'en','Error Adding New Survey',0),(330985,9195,'is','',0),(330986,9195,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ÙˆØ¨ Ø³Ø§ÙŠØª\r\n',0),(330987,9195,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ ÙˆØ¨ Ø³Ø§ÙŠØª\r\n',0),(330988,9195,'tr','Bir URL oluÅŸturun',0),(330989,9195,'pl','WygenerowaÄ‡ adres URL',0),(330990,9195,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° URL Ð°Ð´Ñ€ÐµÑ',0),(330991,9195,'ur','Ø§ÛŒÚ© URL ØªØ®Ù„ÛŒÙ‚',0),(330992,9195,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°ÑšÐµ Ð£Ð Ð›-Ð°',0),(330993,9195,'vi','Táº¡o má»™t Ä‘Æ°á»ng dáº«n',0),(330994,9195,'af','Genereer \'n BA (\"URL\")',0),(330995,9195,'ro','Genera un URL',0),(330996,9195,'et','Loo URL',0),(330997,9195,'si','Ustvari URL',0),(330998,9195,'ba','Menghasilkan URL',0),(330999,9195,'nl','Genereer een URL',0),(331000,9195,'fi','Luoda URL-osoitteen',0),(331001,9195,'no','Generere en URL',0),(331002,9195,'da','Generere en URL',0),(331003,9195,'ko','URL ìƒì„±',0),(331004,9195,'he','×¦×•×¨ ×§×™×©×•×¨',0),(331005,9195,'el','Î Î±ÏÎ±Î³Î¬Î³ÎµÎ¹ Î­Î½Î± URL',0),(331006,9195,'zh','ç”Ÿæˆä¸€ä¸ªç½‘å€\r\n',0),(331007,9195,'sv','Generera en URL',0),(331008,9195,'it','Generare un URL',0),(331009,9195,'tl','',0),(331010,9195,'th','à¸ªà¸£à¹‰à¸²à¸‡ URL',0),(331011,9195,'hi','à¤à¤• à¤¯à¥‚à¤†à¤°à¤à¤² à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨',0),(331012,9195,'ms','Menjana URL',0),(331013,9195,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¹Ù†ÙˆØ§Ù† URL',0),(331014,9195,'fr','GÃ©nÃ©rer une URL',0),(331015,9195,'jp','URL ã‚’ç”Ÿæˆã—ã¾ã™ã€‚',0),(331016,9195,'pt','Gerar uma URL',0),(331017,9195,'ru','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ URL',0),(331018,9195,'es','Generaar Un URL',0),(331019,9195,'de','Eine URL generieren',0),(331020,9195,'en','Generate A URL',0),(331021,9196,'is','',0),(331022,9196,'dr','Ø³Ø± ÙØµÙ„ ',0),(331023,9196,'pr','Ø³Ø± ÙØµÙ„ ',0),(331024,9196,'tr','BaÅŸlÄ±k',0),(331025,9196,'pl','Pozycji',0),(331026,9196,'bg','Ð—Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ',0),(331027,9196,'ur','Ø³Ø±Ø®ÛŒ',0),(331028,9196,'sr','ÐÐ°ÑÐ»Ð¾Ð²',0),(331029,9196,'vi','LÃ£nh Ä‘áº¡o',0),(331030,9196,'af','Opskrif',0),(331031,9196,'ro','Rubrica',0),(331032,9196,'et','Rubriik',0),(331033,9196,'si','Naslov',0),(331034,9196,'ba','Judul',0),(331035,9196,'nl','Rubriek',0),(331036,9196,'fi','Otsikko',0),(331037,9196,'no','Overskrift',0),(331038,9196,'da','Overskrift',0),(331039,9196,'ko','ì œëª©',0),(331040,9196,'he','×›×•×ª×¨×ª',0),(331041,9196,'el','ÎšÎ»Î¬ÏƒÎ·',0),(331042,9196,'zh','æ ‡é¢˜\r\n',0),(331043,9196,'sv','Rubrik',0),(331044,9196,'it','Rubrica',0),(331045,9196,'tl','',0),(331046,9196,'th','&#3627;&#3633;&#3623;&#3586;&#3657;&#3629;',0),(331047,9196,'hi','à¤¶à¥€à¤°à¥à¤·',0),(331048,9196,'ms','Tajuk',0),(331049,9196,'ar','Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(331050,9196,'fr','Rubrique',0),(331051,9196,'jp','è¦‹å‡ºã—',0),(331052,9196,'pt','Rubrica',0),(331053,9196,'ru','Ð—Ð°Ð³Ð¾Ð»Ð¾Ð²Ð¾Ðº',0),(331054,9196,'es','Encabecera',0),(331055,9196,'de','Ãœberschrift',0),(331056,9196,'en','Heading',0),(331057,9197,'is','',0),(331058,9197,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(331059,9197,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(331060,9197,'tr','Anket baÅŸarÄ±yla eklendi',0),(331061,9197,'pl','Ankieta dodana pomyÅ›lnie',0),(331062,9197,'bg','ÐÐ½ÐºÐµÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(331063,9197,'ur','Ø³Ø±ÙˆÛ’ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(331064,9197,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(331065,9197,'vi','ThÃªm Kháº£o SÃ¡t thÃ nh cÃ´ng',0),(331066,9197,'af','Opname Suksesvol Bygevoeg',0),(331067,9197,'ro','Sondaj adÄƒugat cu succes',0),(331068,9197,'et','KÃ¼sitlus edukalt lisatud',0),(331069,9197,'si','Raziskava uspeÅ¡no dodani',0),(331070,9197,'ba','Survei ditambahkan berhasil',0),(331071,9197,'nl','EnquÃªte toegevoegd',0),(331072,9197,'fi','Tutkimuksen lisÃ¤Ã¤minen onnistui',0),(331073,9197,'no','UndersÃ¸kelsen ble lagt til',0),(331074,9197,'da','UndersÃ¸gelsen tilfÃ¸jet',0),(331075,9197,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì¡°ì‚¬',0),(331076,9197,'he','×¡×§×¨ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(331077,9197,'el','ÎˆÏÎµÏ…Î½Î± Ï€Î¿Ï… Ï€ÏÎ¿ÏƒÏ„Î¯Î¸ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(331078,9197,'zh','è°ƒæŸ¥æˆåŠŸæ·»åŠ \r\n',0),(331079,9197,'sv','UndersÃ¶kning som lagts',0),(331080,9197,'it','Sondaggio aggiunto con successo',0),(331081,9197,'tl','',0),(331082,9197,'th','&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(331083,9197,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(331084,9197,'ms','Kaji-selidik yang berjaya menambah',0),(331085,9197,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù† Ø¨Ù†Ø¬Ø§Ø­',0),(331086,9197,'fr','Sondage ajoutÃ© avec succÃ¨s',0),(331087,9197,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸèª¿æŸ»',0),(331088,9197,'pt','Pesquisa adicionada com sucesso',0),(331089,9197,'ru','ÐžÐ±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(331090,9197,'es','Estudio Agregado Exitosamente',0),(331091,9197,'de','Umfrage erfolgreich hinzugefÃ¼gt',0),(331092,9197,'en','Survey Added Successfully',0),(331093,9198,'is','',0),(331094,9198,'dr','Ù…Ø¯ÙŠØ± Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ',0),(331095,9198,'pr','Ù…Ø¯ÙŠØ± Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ',0),(331096,9198,'tr','Anket YÃ¶neticisi',0),(331097,9198,'pl','Kierownik badaÅ„',0),(331098,9198,'bg','ÐœÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(331099,9198,'ur','Ø³Ø±ÙˆÛ’ Ù…ÛŒÙ†ÛŒØ¬Ø±',0),(331100,9198,'sr','ÐœÐµÐ½Ð°ÑŸÐµÑ€ Ð·Ð° Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(331101,9198,'vi','Quáº£n LÃ½ Kháº£o SÃ¡t',0),(331102,9198,'af','Opname Bestuurder',0),(331103,9198,'ro','Sondaj Manager',0),(331104,9198,'et','Uuringu juht',0),(331105,9198,'si','Raziskava Manager',0),(331106,9198,'ba','Survei Manajer',0),(331107,9198,'nl','SurveyBeheerder',0),(331108,9198,'fi','Tutkimuksen johtaja',0),(331109,9198,'no','UndersÃ¸kelsen Manager',0),(331110,9198,'da','UndersÃ¸gelsen Manager',0),(331111,9198,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ê´€ë¦¬ìž',0),(331112,9198,'he','×ž× ×”×œ ×¡×§×¨',0),(331113,9198,'el','Î”Î¹ÎµÏ…Î¸Ï…Î½Ï„Î®Ï‚ Î­ÏÎµÏ…Î½Î±Ï‚',0),(331114,9198,'zh','è°ƒæŸ¥ç®¡ç†\r\n',0),(331115,9198,'sv','Survey Manager',0),(331116,9198,'it','Sondaggio Manager',0),(331117,9198,'tl','',0),(331118,9198,'th','&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(331119,9198,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤•',0),(331120,9198,'ms','Kaji selidik Pengurus',0),(331121,9198,'ar','Ù…Ø¯ÙŠØ± Ø§Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù†Ø§Øª',0),(331122,9198,'fr','Gestionnaire d\'enquÃªte',0),(331123,9198,'jp','èª¿æŸ»ã®ãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼',0),(331124,9198,'pt','Survey Manager',0),(331125,9198,'ru','ÐžÐ¿Ñ€Ð¾Ñ Ð¼ÐµÐ½ÐµÐ´Ð¶ÐµÑ€',0),(331126,9198,'es','Supervisor de Estudios',0),(331127,9198,'de','Umfrage Manager',0),(331128,9198,'en','Survey Manager',0),(331129,9199,'is','',0),(331130,9199,'dr','Ù†Ø§Ù… Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ',0),(331131,9199,'pr','Ù†Ø§Ù… Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ',0),(331132,9199,'tr','Anket adÄ±',0),(331133,9199,'pl','Nazwa badania',0),(331134,9199,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½ÐµÑ‚Ð¾',0),(331135,9199,'ur','Ø³Ø±ÙˆÛ’ Ú©Ø§ Ù†Ø§Ù…',0),(331136,9199,'sr','Ð˜Ð¼Ðµ Ð°Ð½ÐºÐµÑ‚Ðµ',0),(331137,9199,'vi','TÃªn kháº£o sÃ¡t',0),(331138,9199,'af','Opname Naam',0),(331139,9199,'ro','Sondaj nume',0),(331140,9199,'et','KÃ¼sitluse nimi',0),(331141,9199,'si','Raziskava ime',0),(331142,9199,'ba','Nama survei',0),(331143,9199,'nl','EnquÃªte naam',0),(331144,9199,'fi','Tutkimuksen nimi',0),(331145,9199,'no','Navn pÃ¥ undersÃ¸kelse',0),(331146,9199,'da','UndersÃ¸gelsen navn',0),(331147,9199,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ì´ë¦„',0),(331148,9199,'he','×©× ×”×¡×§×¨',0),(331149,9199,'el','ÎŒÎ½Î¿Î¼Î± Î­ÏÎµÏ…Î½Î±',0),(331150,9199,'zh','è°ƒæŸ¥åç§°\r\n',0),(331151,9199,'sv','UndersÃ¶kningen namn',0),(331152,9199,'it','Sondaggio nome',0),(331153,9199,'tl','',0),(331154,9199,'th','&#3594;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(331155,9199,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤•à¤¾ à¤¨à¤¾à¤®',0),(331156,9199,'ms','Kaji selidik nama',0),(331157,9199,'ar','Ø¥Ø³Ù… Ø§Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù†',0),(331158,9199,'fr','Nom de l\'enquÃªte',0),(331159,9199,'jp','èª¿æŸ»å',0),(331160,9199,'pt','Pesquisa nome',0),(331161,9199,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¾Ð¿Ñ€Ð¾ÑÐ°',0),(331162,9199,'es','Nombre de Estudio',0),(331163,9199,'de','Umfrage-Name',0),(331164,9199,'en','Survey Name',0),(331165,9200,'is','',0),(331166,9200,'dr','Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(331167,9200,'pr','Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(331168,9200,'tr','Anket baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(331169,9200,'pl','Ankieta zostaâ”‚a zaktualizowana',0),(331170,9200,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(331171,9200,'ur','Ø³Ø±ÙˆÛ’ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(331172,9200,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(331173,9200,'vi','Cáº­p Nháº­t Kháº£o SÃ¡t ThÃ nh CÃ´ng',0),(331174,9200,'af','Opname Suksesvol Opdateer',0),(331175,9200,'ro','Studiu actualizat cu succes',0),(331176,9200,'et','VÃ¤rskendatud uuring',0),(331177,9200,'si','Raziskava, ki je uspeÅ¡no posodobljena',0),(331178,9200,'ba','Survei yang berhasil',0),(331179,9200,'nl','EnquÃªte bijgewerkt',0),(331180,9200,'fi','PÃ¤ivitetty tutkimus',0),(331181,9200,'no','UndersÃ¸kelsen oppdatert',0),(331182,9200,'da','UndersÃ¸gelsen opdateret',0),(331183,9200,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(331184,9200,'he','×¡×§×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(331185,9200,'el','ÎˆÏÎµÏ…Î½Î± Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(331186,9200,'zh','è°ƒæŸ¥æˆåŠŸæ›´æ–°\r\n',0),(331187,9200,'sv','UndersÃ¶kning uppdaterats',0),(331188,9200,'it','Sondaggio aggiornato con successo',0),(331189,9200,'tl','',0),(331190,9200,'th','&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(331191,9200,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(331192,9200,'ms','Kaji-selidik yang berjaya dikemas kini',0),(331193,9200,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù† Ø¨Ù†Ø¬Ø§Ø­',0),(331194,9200,'fr','Sondage mis Ã  jour avec succÃ¨s',0),(331195,9200,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸèª¿æŸ»',0),(331196,9200,'pt','Levantamento atualizado com sucesso',0),(331197,9200,'ru','ÐžÐ±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(331198,9200,'es','Estudio Actualizado Exitosamente',0),(331199,9200,'de','Umfrage erfolgreich aktualisiert',0),(331200,9200,'en','Survey Updated Successfully',0),(331201,9201,'is','',0),(331202,9201,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ù…ØªÙ† ',0),(331203,9201,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ù…ØªÙ† ',0),(331204,9201,'tr','Metin alanÄ±',0),(331205,9201,'pl','Obszar tekstowy',0),(331206,9201,'bg','ÐžÐ±Ð»Ð°ÑÑ‚ Ð½Ð° Ñ‚ÐµÐºÑÑ‚',0),(331207,9201,'ur','Ù…ØªÙ† Ø¹Ù„Ø§Ù‚Û',0),(331208,9201,'sr','ÐžÐ±Ð»Ð°ÑÑ‚ Ñ‚ÐµÐºÑÑ‚Ð°',0),(331209,9201,'vi','Khu vá»±c VÄƒn báº£n',0),(331210,9201,'af','Teksarea',0),(331211,9201,'ro','Zona de text',0),(331212,9201,'et','Tekstiala',0),(331213,9201,'si','Besedilno obmoÄje',0),(331214,9201,'ba','Area teks',0),(331215,9201,'nl','Tekstgebied',0),(331216,9201,'fi','Tekstialueen',0),(331217,9201,'no','TekstomrÃ¥de',0),(331218,9201,'da','TekstomrÃ¥de',0),(331219,9201,'ko','í…ìŠ¤íŠ¸ ì˜ì—­',0),(331220,9201,'he','××–×•×¨ ×˜×§×¡×˜',0),(331221,9201,'el','Î ÎµÏÎ¹Î¿Ï‡Î® ÎºÎµÎ¹Î¼Î­Î½Î¿Ï…',0),(331222,9201,'zh','æ–‡æœ¬åŒºåŸŸ\r\n',0),(331223,9201,'sv','TextomrÃ¥det',0),(331224,9201,'it','Area di testo',0),(331225,9201,'tl','',0),(331226,9201,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(331227,9201,'hi','à¤ªà¤¾à¤  à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(331228,9201,'ms','Kawasan teks',0),(331229,9201,'ar','Ù†Ø§Ø­ÙŠØ© Ø§Ù„Ù†Øµ',0),(331230,9201,'fr','Zone de texte',0),(331231,9201,'jp','ãƒ†ã‚­ã‚¹ãƒˆ ã‚¨ãƒªã‚¢',0),(331232,9201,'pt','Ãrea de texto',0),(331233,9201,'ru','Ð¢ÐµÐºÑÑ‚Ð¾Ð²Ð°Ñ Ð¾Ð±Ð»Ð°ÑÑ‚ÑŒ',0),(331234,9201,'es','Ãrea de Texto',0),(331235,9201,'de','Textbereich',0),(331236,9201,'en','Text Area',0),(331237,9202,'is','',0),(331238,9202,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(331239,9202,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(331240,9202,'tr','Anket iÃ§in bir ad girmeniz gerekir.',0),(331241,9202,'pl','NaleÅ¼y wprowadziÄ‡ nazwÄ™ badania.',0),(331242,9202,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð·Ð° Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½ÐµÑ‚Ð¾.',0),(331243,9202,'ur','Ø¢Ù¾ Ø§Ø³ Ø³Ø±ÙˆÛ’ Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’ Û”',0),(331244,9202,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð·Ð° Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ.',0),(331245,9202,'vi','Pháº£i nháº­p tÃªn kháº£o sÃ¡t ',0),(331246,9202,'af','U moet \'n naam invoer vir hierdie Opname',0),(331247,9202,'ro','Trebuie sa introduceti un nume pentru studiu',0),(331248,9202,'et','Te peate sisestama nime kÃ¼sitlusele',0),(331249,9202,'si','Vnesti morate ime za raziskave.',0),(331250,9202,'ba','Anda harus memasukkan nama untuk survei.',0),(331251,9202,'nl','U moet een naam voor de enquÃªte opgeven.',0),(331252,9202,'fi','Kirjoita kyselyn nimi.',0),(331253,9202,'no','Du mÃ¥ angi et navn for undersÃ¸kelsen.',0),(331254,9202,'da','Du skal angive et navn til undersÃ¸gelsen.',0),(331255,9202,'ko','ì„¤ë¬¸ ì¡°ì‚¬ì— ëŒ€ í•œ ì´ë¦„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(331256,9202,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×©× ×¢×‘×•×¨ ×”×¡×§×¨.',0),(331257,9202,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± Î³Î¹Î± Ï„Î·Î½ Î­ÏÎµÏ…Î½Î±.',0),(331258,9202,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªè°ƒæŸ¥çš„åç§°ã€‚\r\n',0),(331259,9202,'sv','Du mÃ¥ste ange ett namn fÃ¶r undersÃ¶kningen.',0),(331260,9202,'it','Ãˆ necessario immettere un nome per l\'indagine.',0),(331261,9202,'tl','',0),(331262,9202,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3619;&#3629;&#3585;&#3594;&#3639;&#3656;&#3629;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(331263,9202,'hi','à¤†à¤ª à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(331264,9202,'ms','Awda mesti masukkan nama untuk kaji selidik.',0),(331265,9202,'ar','Ù„Ø§Ø¨Ø¯ Ù…Ù† Ø¥Ø¯Ø®Ø§Ù„ Ø¥Ø³Ù… Ù„Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù†',0),(331266,9202,'fr','Vous devez entrer un nom pour l\'enquÃªte.',0),(331267,9202,'jp','ã‚¢ãƒ³ã‚±ãƒ¼ãƒˆã®åå‰ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(331268,9202,'pt','VocÃª deve digitar um nome para a pesquisa.',0),(331269,9202,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¸Ð¼Ñ Ð´Ð»Ñ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ.',0),(331270,9202,'es','Debe ingresar un nombre para el survey',0),(331271,9202,'de','Sie mÃ¼ssen einen Namen fÃ¼r die Umfrage eingeben.',0),(331272,9202,'en','You must enter a name for the survey.',0),(331273,9203,'is','',0),(331274,9203,'dr','Ø§ÙŠØ¬Ø§Ø¯  ÙƒØ¯ ÙˆØ¨ Ø³Ø§ÙŠØª \r\n',0),(331275,9203,'pr','Ø§ÙŠØ¬Ø§Ø¯  ÙƒØ¯ ÙˆØ¨ Ø³Ø§ÙŠØª \r\n',0),(331276,9203,'tr','URL oluÅŸturun',0),(331277,9203,'pl','UtworzyÄ‡ adres URL',0),(331278,9203,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° URL Ð°Ð´Ñ€ÐµÑ',0),(331279,9203,'ur','URL ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(331280,9203,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð£Ð Ð›',0),(331281,9203,'vi','Táº¡o Ä‘Æ°á»ng dáº«n',0),(331282,9203,'af','Skep BA (\"URL\")',0),(331283,9203,'ro','CreeazÄƒ URL',0),(331284,9203,'et','Loo URL',0),(331285,9203,'si','Ustvari URL',0),(331286,9203,'ba','Membuat URL',0),(331287,9203,'nl','URL maken',0),(331288,9203,'fi','Luo URL-osoite',0),(331289,9203,'no','Opprette URL',0),(331290,9203,'da','Opret URL',0),(331291,9203,'ko','URL ë§Œë“¤ê¸°',0),(331292,9203,'he','×œ×™×¦×•×¨ ×›×ª×•×‘×ª URL',0),(331293,9203,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± URL',0),(331294,9203,'zh','åˆ›å»ºç½‘å€\r\n\r\n',0),(331295,9203,'sv','Skapa URL',0),(331296,9203,'it','Creare URL',0),(331297,9203,'tl','',0),(331298,9203,'th','&#3626;&#3619;&#3657;&#3634;&#3591; URL',0),(331299,9203,'hi','à¤¯à¥‚à¤†à¤°à¤à¤² à¤¬à¤¨à¤¾à¤à¤',0),(331300,9203,'ms','Mencipta URL',0),(331301,9203,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¹Ù†ÙˆØ§Ù† URL',0),(331302,9203,'fr','CrÃ©er des URL',0),(331303,9203,'jp','URL ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(331304,9203,'pt','Criar URL',0),(331305,9203,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ URL-Ð°Ð´Ñ€ÐµÑ',0),(331306,9203,'es','Crear URL',0),(331307,9203,'de','URL erstellen',0),(331308,9203,'en','Create URL',0),(331309,9204,'is','',0),(331310,9204,'dr','Ø¢ÙŠØ§ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ØªØ¹Ø¯Ø§Ø¯ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ù‡Ø§ÙŠ ÙƒÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ù†Ø¯ Ø¨Ø§ Ø§ÙŠÙ† ÙˆØ¨ Ø³Ø§ÙŠØª Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆÙ†Ø¯ Ø±Ø§ Ù…Ø­Ø¯ÙˆØ¯ ÙƒÙ†ÙŠØ¯ ØŸ',0),(331311,9204,'pr','Ø¢ÙŠØ§ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ØªØ¹Ø¯Ø§Ø¯ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ù‡Ø§ÙŠ ÙƒÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ù†Ø¯ Ø¨Ø§ Ø§ÙŠÙ† ÙˆØ¨ Ø³Ø§ÙŠØª Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆÙ†Ø¯ Ø±Ø§ Ù…Ø­Ø¯ÙˆØ¯ ÙƒÙ†ÙŠØ¯ ØŸ',0),(331312,9204,'tr','Bu URL ile gerÃ§ekleÅŸtirilen anketler sÄ±nÄ±rlamak istiyor musunuz?',0),(331313,9204,'pl','Czy chcesz ograniczyÄ‡ liczbÄ™ badaÅ„, ktÃ³re mogÄ… byÄ‡ podjÄ™te z tego adresu URL?',0),(331314,9204,'bg','Ð˜ÑÐºÐ°Ñ‚Ðµ Ð»Ð¸ Ð´Ð° Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ Ð½Ð° ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ñ‚Ðµ Ð¸Ð·ÑÐ»ÐµÐ´Ð²Ð°Ð½Ð¸Ñ, ÐºÐ¾Ð¸Ñ‚Ð¾ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð²Ð·ÐµÑ‚Ð¸ Ñ Ñ‚Ð¾Ð·Ð¸ URL Ð°Ð´Ñ€ÐµÑ?',0),(331315,9204,'ur','Ø¢Ù¾ Ú©Û ÛŒÛ URL Ú©Û’ Ø³Ø§ØªÚ¾ Ù„ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ ÛÛ’ Ø³Ø±ÙˆÛ’ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ú©Ùˆ Ù…Ø­Ø¯ÙˆØ¯ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(331316,9204,'sr','Ð¢Ð¸ Ñ…Ð¾Ñ›ÐµÑˆ Ð´Ð° ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° ÐºÐ¾Ñ˜Ð° ÑÐµ Ð¼Ð¾Ð¶Ðµ ÑƒÐ·ÐµÑ‚Ð¸ ÑÐ° Ð¾Ð²Ð°Ñ˜ Ð£Ð Ð›',0),(331317,9204,'vi','Báº¡n cÃ³ muá»‘n giá»›i háº¡n sá»‘ kháº£o sÃ¡t cÃ³ thá»ƒ lÃ m vá»›i Ä‘Æ°á»ng dáº«n nÃ y',0),(331318,9204,'af','Wil u die aantal opnames wat geneem kan word met hierdie BA (\"URL\") beperk?',0),(331319,9204,'ro','Vrei pentru a limita numÄƒrul de anchete care pot fi luate cu acest URL?',0),(331320,9204,'et','Kas soovite piirata mitmed uurimused, koos sellele URL-ile omast?',0),(331321,9204,'si','Ali Å¾elite omejiti Å¡tevilo raziskav, ki jih je mogoÄe sprejeti s to URL?',0),(331322,9204,'ba','Apakah Anda ingin membatasi jumlah survei yang dapat diambil dengan URL ini?',0),(331323,9204,'nl','Wilt u het aantal enquÃªtes die kunnen worden genomen met deze URL beperken?',0),(331324,9204,'fi','Haluat rajoittaa useissa tutkimuksissa, joita voidaan kÃ¤yttÃ¤Ã¤ tÃ¤llÃ¤ URL-osoitteella?',0),(331325,9204,'no','Vil du begrense antall undersÃ¸kelser som kan tas med denne URL?',0),(331326,9204,'da','Vil du begrÃ¦nse antallet af undersÃ¸gelser, der kan tages med denne URL-adresse?',0),(331327,9204,'ko','ì„¤ë¬¸ ì¡°ì‚¬ urlì´ ì·¨í•  ìˆ˜ ìžˆëŠ” ìˆ˜ë¥¼ ì œí•œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(331328,9204,'he','×”×× ×‘×¨×¦×•× ×š ×œ×”×’×‘×™×œ ××ª ×ž×¡×¤×¨ ×¡×§×¨×™× ×©××¤×©×¨ ×œ×§×—×ª ×¢× ×›×ª×•×‘×ª URL ×–×•?',0),(331329,9204,'el','Î˜Î­Î»ÎµÏ„Îµ Î½Î± Ï€ÎµÏÎ¹Î¿ÏÎ¯ÏƒÎµÏ„Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Ï‰Î½ ÎµÏÎµÏ…Î½ÏŽÎ½ Ï€Î¿Ï… Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Î»Î·Ï†Î¸Î¿ÏÎ½ Î¼Îµ Î±Ï…Ï„Î®Î½ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· URL;',0),(331330,9204,'zh','æ˜¯å¦è¦é™åˆ¶å¯ä¸Žæ­¤ç½‘å€è¿›è¡Œçš„è°ƒæŸ¥æ•°ï¼Ÿ\r\n',0),(331331,9204,'sv','Vill du begrÃ¤nsa antalet undersÃ¶kningar som kan tas med denna URL?',0),(331332,9204,'it','Si desidera limitare il numero di sondaggi che puÃ² essere assunto con questo URL?',0),(331333,9204,'tl','',0),(331334,9204,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3635;&#3585;&#3633;&#3604;&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3607;&#3637;&#3656;&#3626;&#3634;&#3',0),(331335,9204,'hi','à¤•à¥à¤¯à¤¾ à¤†à¤ª à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤•à¤¿ à¤‡à¤¸ URL à¤•à¥‡ à¤¸à¤¾à¤¥ à¤²à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‹ à¤¸à¥€à¤®à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(331336,9204,'ms','Adakah anda mahu membataskan kajian yang boleh diambil dengan URL ini?',0),(331337,9204,'ar','Ù‡Ù„ ØªØ±ÙŠØ¯ Ø£Ù† ØªØ­Ø¯ Ù…Ù† Ø§Ù„Ø¹Ø¯Ø¯ Ù…Ù† Ø§Ù„Ø¯Ø±Ø§Ø³Ø§Øª Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¦ÙŠØ© Ø§Ù„ØªÙŠ ÙŠÙ…ÙƒÙ† Ø§ØªØ®Ø§Ø°Ù‡Ø§ Ù…Ø¹ Ø¹Ù†ÙˆØ§Ù† URL Ù‡Ø°Ø§ØŸ',0),(331338,9204,'fr','Vous voulez limiter le nombre de questionnaires qui peuvent Ãªtre prises avec cette URL ?',0),(331339,9204,'jp','ã“ã® URL ã§æ’®å½±ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™èª¿æŸ»ã®æ•°ã‚’åˆ¶é™ã—ã¾ã™ã‹ã€‚',0),(331340,9204,'pt','VocÃª quer limitar o nÃºmero de pesquisas que podem ser tomados com essa URL?',0),(331341,9204,'ru','Ð’Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡Ð¸Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾Ð¿Ñ€Ð¾ÑÐ¾Ð², ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¿Ñ€Ð¸Ð½ÑÑ‚Ñ‹ Ñ ÑÑ‚Ð¸Ð¼ URL?',0),(331342,9204,'es','Quiere limitar el nÃºmero de estudios que se pueden tomar con este URL',0),(331343,9204,'de','MÃ¶chten Sie die Anzahl der Umfragen zu beschrÃ¤nken, die Ã¼ber diese URL erfolgen kann?',0),(331344,9204,'en','Do you want to limit the number of surveys that can be taken with this URL?',0),(331345,9205,'is','',0),(331346,9205,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙˆØ¨ Ø³Ø§ÙŠØª Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ \r\n',0),(331347,9205,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙˆØ¨ Ø³Ø§ÙŠØª Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ \r\n',0),(331348,9205,'tr','Anket URL oluÅŸturmak',0),(331349,9205,'pl','WygenerowaÄ‡ adres URL badania',0),(331350,9205,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð° Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ URL',0),(331351,9205,'ur','Ø³Ø±ÙˆÛ’ URL ØªØ®Ù„ÛŒÙ‚',0),(331352,9205,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°ÑšÐµ Ð£Ð Ð› Ð·Ð° Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(331353,9205,'vi','Táº¡o Ä‘Æ°á»ng dáº«n kháº£o sÃ¡t',0),(331354,9205,'af','Genereer Opname BA (\"URL\")',0),(331355,9205,'ro','Genera URL-ul sondaj',0),(331356,9205,'et','Loo uuring URL',0),(331357,9205,'si','Ustvari anketo URL',0),(331358,9205,'ba','Menghasilkan URL survei',0),(331359,9205,'nl','Genereer enquÃªte-URL',0),(331360,9205,'fi','Luo kyselyn URL',0),(331361,9205,'no','Generere undersÃ¸kelse URL',0),(331362,9205,'da','Generere undersÃ¸gelse URL',0),(331363,9205,'ko','ì„¤ë¬¸ ì¡°ì‚¬ URL ìƒì„±',0),(331364,9205,'he','×¦×•×¨ ×¡×§×¨ URL',0),(331365,9205,'el','Î Î±ÏÎ±Î³Î¬Î³ÎµÎ¹ Î­ÏÎµÏ…Î½Î± URL',0),(331366,9205,'zh','ç”Ÿæˆè°ƒæŸ¥ç½‘å€',0),(331367,9205,'sv','Generera undersÃ¶kning URL',0),(331368,9205,'it','Generare URL sondaggio',0),(331369,9205,'tl','',0),(331370,9205,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592; URL',0),(331371,9205,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ URL à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨',0),(331372,9205,'ms','Menjana URL kaji selidik',0),(331373,9205,'ar','ØªÙˆÙ„ÙŠØ¯ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¯Ø±Ø§Ø³Ø© Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¦ÙŠØ©',0),(331374,9205,'fr','GÃ©nÃ©rer des URL de sondage',0),(331375,9205,'jp','èª¿æŸ» URL ã‚’ç”Ÿæˆã—ã¾ã™ã€‚',0),(331376,9205,'pt','Gerar URL de pesquisa',0),(331377,9205,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¾Ð¿Ñ€Ð¾Ñ URL',0),(331378,9205,'es','Generar Estudio URL',0),(331379,9205,'de','Umfrage-URL generieren',0),(331380,9205,'en','Generate Survey URL',0),(331381,9206,'is','',0),(331382,9206,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(331383,9206,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙØ§ÙƒØªÙˆØ± ',0),(331384,9206,'tr','Fatura numarasÄ±',0),(331385,9206,'pl','Identyfikator faktury',0),(331386,9206,'bg','Ð˜Ð” Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(331387,9206,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(331388,9206,'sr','Ð˜Ð” Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(331389,9206,'vi','ID hÃ³a Ä‘Æ¡n',0),(331390,9206,'af','Faktuur ID',0),(331391,9206,'ro','ID factura',0),(331392,9206,'et','Arve ID',0),(331393,9206,'si','ID raÄuna',0),(331394,9206,'ba','Faktur ID',0),(331395,9206,'nl','Factuur-ID',0),(331396,9206,'fi','Laskun tunnus',0),(331397,9206,'no','Faktura-IDen',0),(331398,9206,'da','Faktura-ID',0),(331399,9206,'ko','ì†¡ìž¥ ID',0),(331400,9206,'he','×§×•×“ ×–×™×”×•×™ ×—×©×‘×•× ×™×ª',0),(331401,9206,'el','ÎšÏ‰Î´ Î¤Î¹Î¼Î¿Î»',0),(331402,9206,'zh','å‘ç¥¨ID\r\n',0),(331403,9206,'sv','Faktura-ID',0),(331404,9206,'it','ID fattura',0),(331405,9206,'tl','',0),(331406,9206,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(331407,9206,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤†à¤ˆà¤¡à¥€',0),(331408,9206,'ms','ID invois',0),(331409,9206,'ar','Ù…Ø¹Ø±Ù‘Ù Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(331410,9206,'fr','De facture',0),(331411,9206,'jp','è«‹æ±‚æ›¸ ID',0),(331412,9206,'pt','ID da fatura',0),(331413,9206,'ru','ID Ð¡Ñ‡ÐµÑ‚Ð°',0),(331414,9206,'es','ID de Factura',0),(331415,9206,'de','Rechnungs-ID',0),(331416,9206,'en','Invoice ID',0),(331417,9207,'is','',0),(331418,9207,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ÙŠØ§ Ù†Ø§Ù… Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(331419,9207,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ÙŠØ§ Ù†Ø§Ù… Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(331420,9207,'tr','Fatura numarasÄ± veya mÃ¼ÅŸteri adÄ±',0),(331421,9207,'pl','Numer faktury lub nazwa klienta',0),(331422,9207,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(331423,9207,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø± ÛŒØ§ Ú¯Ø§ÛÚ© Ú©Û’ Ù†Ø§Ù…',0),(331424,9207,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(331425,9207,'vi','Sá»‘ hÃ³a Ä‘Æ¡n hay tÃªn khÃ¡ch hÃ ng',0),(331426,9207,'af','Faktuurnommer of KliÃ«nt/Klant Naam',0),(331427,9207,'ro','NumÄƒrul facturii sau numele clientului',0),(331428,9207,'et','Arve number vÃµi kliendi nimi',0),(331429,9207,'si','Å tevilka raÄuna ali ime kupca',0),(331430,9207,'ba','Nomor Invoice atau nama pelanggan',0),(331431,9207,'nl','Factuurnummer of de klantnaam',0),(331432,9207,'fi','Laskunumeron tai asiakkaan nimi',0),(331433,9207,'no','Fakturanummer eller kundenavn',0),(331434,9207,'da','Fakturanummeret eller kundenavnet',0),(331435,9207,'ko','ì†¡ìž¥ ë²ˆí˜¸ ë˜ëŠ” ê³ ê° ì´ë¦„',0),(331436,9207,'he','×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª ××• ×©× ×”×œ×§×•×—',0),(331437,9207,'el','Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£ Î® ÏŒÎ½Î¿Î¼Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(331438,9207,'zh','å‘ç¥¨å·ç æˆ–å®¢æˆ·åç§°\r\n',0),(331439,9207,'sv','Fakturanummer eller kundens namn',0),(331440,9207,'it','Numero fattura o nome cliente',0),(331441,9207,'tl','',0),(331442,9207,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3627;&#3619;&#3639;&#3629;&#3594;&#3639;&#3656;&#3629;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(331443,9207,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤¨à¤¾à¤®',0),(331444,9207,'ms','Nombor invois atau nama pelanggan',0),(331445,9207,'ar','Ø±Ù‚Ù… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø£Ùˆ Ø¥Ø³Ù… Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(331446,9207,'fr','NumÃ©ro de la facture ou le nom du client',0),(331447,9207,'jp','è«‹æ±‚æ›¸ç•ªå·ã‚„é¡§å®¢å',0),(331448,9207,'pt','NÃºmero da factura ou o nome do cliente',0),(331449,9207,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¡Ñ‡ÐµÑ‚Ð° Ð¸Ð»Ð¸ Ð˜Ð¼Ñ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(331450,9207,'es','NÃºmero de Factura o Nombre e Cliente',0),(331451,9207,'de','Rechnungsnummer oder Kundenname',0),(331452,9207,'en','Invoice Number or Customer Name',0),(331453,9208,'is','',0),(331454,9208,'dr','Ø§ÙŠØ¬Ø§Ø¯   Ù„ÙŠÙ†Ùƒ ÙˆÙŠÚ˜Ù‡',0),(331455,9208,'pr','Ø§ÙŠØ¬Ø§Ø¯   Ù„ÙŠÙ†Ùƒ ÙˆÙŠÚ˜Ù‡',0),(331456,9208,'tr','BaÄŸlantÄ± benzersiz olun',0),(331457,9208,'pl','WyjÄ…tkowoÅ›ci Link',0),(331458,9208,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²ÐµÑ‚Ðµ Ð²Ñ€ÑŠÐ·ÐºÐ° ÑƒÐ½Ð¸ÐºÐ°Ð»Ð½Ð¸',0),(331459,9208,'ur','Ù„Ù†Ú© Ú©Ùˆ Ù…Ù†ÙØ±Ø¯ Ø¨Ù†Ø§ØªÛ’',0),(331460,9208,'sr','Ð’ÐµÐ·Ñƒ Ð´Ð° ÐˆÐµÐ´Ð¸Ð½ÑÑ‚Ð²ÐµÐ½Ð¸',0),(331461,9208,'vi','Táº¡o ÄÆ°á»ng Dáº«n Äá»™c ÄÃ¡o',0),(331462,9208,'af','Maak Skakel Uniek',0),(331463,9208,'ro','Fac Link unic',0),(331464,9208,'et','Tee Link ainulaadne',0),(331465,9208,'si','Da Link edinstven',0),(331466,9208,'ba','Membuat Link unik',0),(331467,9208,'nl','Link uniek maken',0),(331468,9208,'fi','Tee linkki ainutlaatuinen',0),(331469,9208,'no','Lage Link unike',0),(331470,9208,'da','GÃ¸re Link unikke',0),(331471,9208,'ko','ë§í¬ë¥¼ ê³ ìœ  í•˜ ê²Œ ë§Œë“¤ê¸°',0),(331472,9208,'he','×œ×”×¤×•×š ××ª ×”×§×™×©×•×¨ ×”×™×™×—×•×“×™',0),(331473,9208,'el','ÎšÎ¬Î½ÎµÎ¹ Î¼Î¿Î½Î±Î´Î¹ÎºÎ® Ï„Î·Î½ ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(331474,9208,'zh','åˆ¶ä½œç‹¬ç‰¹çš„é“¾æŽ¥\r\n',0),(331475,9208,'sv','GÃ¶ra lÃ¤nk unika',0),(331476,9208,'it','Fare Link unico',0),(331477,9208,'tl','',0),(331478,9208,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3621;&#3636;&#3591;&#3588;&#3660;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3595;&#3657;&#3635;',0),(331479,9208,'hi','à¤²à¤¿à¤‚à¤• à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤…à¤¦à¥à¤µà¤¿à¤¤à¥€à¤¯',0),(331480,9208,'ms','Membuat pautan yang unik',0),(331481,9208,'ar','Ø¬Ø¹Ù„ ØµÙ„Ø© ÙØ±ÙŠØ¯Ø© Ù…Ù† Ù†ÙˆØ¹Ù‡Ø§',0),(331482,9208,'fr','Faire lien Unique',0),(331483,9208,'jp','ãƒ¦ãƒ‹ãƒ¼ã‚¯ãªãƒªãƒ³ã‚¯ã‚’ä½œã‚‹',0),(331484,9208,'pt','Fazer o Link original',0),(331485,9208,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ ÑƒÐ½Ð¸ÐºÐ°Ð»ÑŒÐ½ÑƒÑŽ ÑÑÑ‹Ð»ÐºÑƒ',0),(331486,9208,'es','Hace Ãšnico el VÃ­nculo',0),(331487,9208,'de','Link einzigartig machen',0),(331488,9208,'en','Make Link Unique',0),(331489,9209,'is','',0),(331490,9209,'dr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(331491,9209,'pr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(331492,9209,'tr','HiÃ§bir anket kimliÄŸi kÃ¼mesi',0),(331493,9209,'pl','Nie zestaw ID badania',0),(331494,9209,'bg','ÐÐµ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ Ð˜Ð” Ð½Ð° Ð½Ð°Ð±Ð¾Ñ€',0),(331495,9209,'ur','ID Ø³ÛŒÙ¹ Ù†ÛÛŒÚº Ø³Ø±ÙˆÛ’',0),(331496,9209,'sr','ÐÐµÐ¼Ð° Ð¡ÐµÑ‚ Ð˜Ð” Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(331497,9209,'vi','KhÃ´ng cÃ³ ID kháº£o sÃ¡t',0),(331498,9209,'af','Geen Opname ID Gestel',0),(331499,9209,'ro','Nici un studiu ID Set',0),(331500,9209,'et','Ãœkski uuring komplekti',0),(331501,9209,'si','Nobena raziskava ID Set',0),(331502,9209,'ba','Tidak ada survei ID Set',0),(331503,9209,'nl','Geen enquÃªte ID Set',0),(331504,9209,'fi','Ole tutkimuksen ID asetettu',0),(331505,9209,'no','Ingen undersÃ¸kelse ID sett',0),(331506,9209,'da','Ingen undersÃ¸gelse ID sÃ¦t',0),(331507,9209,'ko','ì¡°ì‚¬ ID ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(331508,9209,'he','×œ× ×”×•×’×“×¨×• ×ž×–×”×” ×¡×§×¨',0),(331509,9209,'el','ÎšÎ±Î½Î­Î½Î± ÏƒÏÎ½Î¿Î»Î¿ ID Î­ÏÎµÏ…Î½Î±',0),(331510,9209,'zh','æ²¡æœ‰è°ƒæŸ¥IDé›†\r\n',0),(331511,9209,'sv','Ingen undersÃ¶kning ID Set',0),(331512,9209,'it','Nessun sondaggio ID impostato',0),(331513,9209,'tl','',0),(331514,9209,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3627;&#3633;&#3626;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;&#3652;&#3623;&#3657;',0),(331515,9209,'hi','à¤•à¥‹à¤ˆ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ ID à¤¸à¥‡à¤Ÿ',0),(331516,9209,'ms','Set ID tiada kajian',0),(331517,9209,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø³Ø­',0),(331518,9209,'fr','Aucun sondage ID Set',0),(331519,9209,'jp','ã‚¢ãƒ³ã‚±ãƒ¼ãƒˆ ID ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(331520,9209,'pt','Nenhum conjunto de ID de levantamento',0),(331521,9209,'ru','ID Ð½Ð°Ð±Ð¾Ñ€Ð° Ð½Ðµ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(331522,9209,'es','No EstableciÃ³ un ID del Estudio',0),(331523,9209,'de','Keine Umfrage-ID-Set',0),(331524,9209,'en','No Survey ID Set',0),(331525,9210,'is','',0),(331526,9210,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙŠØ§ Ù†Ø§Ù… Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(331527,9210,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙŠØ§ Ù†Ø§Ù… Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(331528,9210,'tr','SipariÅŸ numarasÄ± veya mÃ¼ÅŸteri adÄ±',0),(331529,9210,'pl','Numer lub nazwa klienta',0),(331530,9210,'bg','ÐŸÐ¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(331531,9210,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± ÛŒØ§ Ú¯Ø§ÛÚ© Ú©Û’ Ù†Ø§Ù…',0),(331532,9210,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(331533,9210,'vi','ÄÆ¡n hÃ ng sá»‘ & TÃªn KhÃ¡ch hÃ ng',0),(331534,9210,'af','Bestelling Nommer of Klient / Klantnaam',0),(331535,9210,'ro','NumÄƒrul de ordine sau numele clientului',0),(331536,9210,'et','Tellimuse number vÃµi kliendi nimi',0),(331537,9210,'si','Zaporedno Å¡tevilko ali ime kupca',0),(331538,9210,'ba','Nomor pesanan atau nama pelanggan',0),(331539,9210,'nl','Nummer of naam van klant',0),(331540,9210,'fi','Tilausnumero tai asiakkaan nimi',0),(331541,9210,'no','Ordrenummer eller kundenavn',0),(331542,9210,'da','Ordrenummeret eller Kundenavn',0),(331543,9210,'ko','ì£¼ë¬¸ ë²ˆí˜¸ ë˜ëŠ” ê³ ê° ì´ë¦„',0),(331544,9210,'he','×ž×¡×¤×¨ ×”×–×ž× ×” ××• ×©× ×”×œ×§×•×—',0),(331545,9210,'el','Î‘ÏÎ¾Ï‰Î½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î® ÏŒÎ½Î¿Î¼Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(331546,9210,'zh','è®¢å•å·æˆ–å®¢æˆ·åç§°\r\n',0),(331547,9210,'sv','Ordernummer eller kundens namn',0),(331548,9210,'it','Numero ordine o nome cliente',0),(331549,9210,'tl','',0),(331550,9210,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3627;&#3619;&#3639;&#3629;&#3594;&#3639;&#3656;&#3629;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(331551,9210,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤¨à¤¾à¤®',0),(331552,9210,'ms','Nombor pesanan atau nama pelanggan',0),(331553,9210,'ar','Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨ÙŠØ© Ø£Ùˆ Ø¥Ø³Ù… Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(331554,9210,'fr','NumÃ©ro de commande ou nom du client',0),(331555,9210,'jp','æ³¨æ–‡ç•ªå·ã‚„é¡§å®¢å',0),(331556,9210,'pt','NÃºmero do pedido ou nome do cliente',0),(331557,9210,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð—Ð°ÐºÐ°Ð·Ð° Ð˜Ð»Ð¸ ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(331558,9210,'es','NÃºmero de Orden o Nombre de Cliente',0),(331559,9210,'de','Bestellnummer oder Kundenname',0),(331560,9210,'en','Order Number or Customer Name',0),(331561,9211,'is','',0),(331562,9211,'dr','Ø§Ù†ØªØ®Ø§Ø¨  Ú¯ÙŠØ±Ù†Ø¯Ù‡  Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¯Ø± Ø²ÙŠØ±  ÙŠØ§ Ø®Ø§Ù„ÙŠ Ú¯Ø°Ø§Ø´ØªÙ† Ù…Ø­Ù„',0),(331563,9211,'pr','Ø§Ù†ØªØ®Ø§Ø¨  Ú¯ÙŠØ±Ù†Ø¯Ù‡  Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¯Ø± Ø²ÙŠØ±  ÙŠØ§ Ø®Ø§Ù„ÙŠ Ú¯Ø°Ø§Ø´ØªÙ† Ù…Ø­Ù„',0),(331564,9211,'tr','AÅŸaÄŸÄ±daki anket alÄ±cÄ± seÃ§in veya boÅŸ bÄ±rakÄ±n',0),(331565,9211,'pl','Wybierz poniÅ¼ej odbiorcy badania lub zostawiÄ‡ puste',0),(331566,9211,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ Ð¸Ð·ÑÐ»ÐµÐ´Ð²Ð°Ð½Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ» Ð¸Ð»Ð¸ Ð¾ÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾',0),(331567,9211,'ur','Ø§ÛŒÚ© Ø³Ø±ÙˆÛ’ ÙˆØµÙˆÙ„Ù†Ø¯Û Ú©Û’ Ù†ÛŒÚ†Û’ Ú†Ù†ÛŒÚº ÛŒØ§ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(331568,9211,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸ Ð°Ð½ÐºÐµÑ‚Ñƒ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð° Ð¸ÑÐ¿Ð¾Ð´ Ð¸Ð»Ð¸ Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾',0),(331569,9211,'vi','Chá»n 1 ngÆ°á»i nháº­n kháº£o sÃ¡t dÆ°á»›i Ä‘Ã¢y hay bá» trá»‘ng',0),(331570,9211,'af','Kies \'n Opname Ontvanger Hieronder Of Laat Oop',0),(331571,9211,'ro','Alege un destinatar sondaj mai jos sau lÄƒsaÅ£i necompletat',0),(331572,9211,'et','Vali kÃ¼sitlus saaja allpool vÃµi jÃ¤ta tÃ¼hjaks',0),(331573,9211,'si','Kramp spodaj anketo prejemnika ali pustite prazno',0),(331574,9211,'ba','Memilih Penerima survei di bawah ini atau kosongkan',0),(331575,9211,'nl','Kies een enquÃªte ontvanger hieronder of laat blanco',0),(331576,9211,'fi','Valitse tutkimuksen vastaanottajan alla tai jÃ¤tÃ¤ tyhjÃ¤ksi',0),(331577,9211,'no','Velg en undersÃ¸kelse mottaker nedenfor eller tomt',0),(331578,9211,'da','VÃ¦lge en undersÃ¸gelse modtager nedenfor eller er tomt',0),(331579,9211,'ko','ì•„ëž˜ ì„¤ë¬¸ ì¡°ì‚¬ ë°›ëŠ” ë‚˜ë¥¼ ë¹„ì›Œí•©ë‹ˆë‹¤',0),(331580,9211,'he','×œ×‘×—×•×¨ × ×ž×¢×Ÿ ×¡×§×¨ ×©×œ×”×œ×Ÿ ××• ×œ×”×©××™×¨ ×¨×™×§',0),(331581,9211,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î±Ï€Î¿Î´Î­ÎºÏ„Î·Ï‚ Î­ÏÎµÏ…Î½Î± Î® Î±Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ',0),(331582,9211,'zh','é€‰æ‹©ä¸€ä¸ªä»¥ä¸‹è°ƒæŸ¥æ”¶ä»¶äººæˆ–ç•™ç©º\r\n',0),(331583,9211,'sv','Plocka en undersÃ¶kning mottagare nedan eller lÃ¤mna tomt',0),(331584,9211,'it','Scegliere un destinatario sondaggio qui sotto oppure lasciare vuoto',0),(331585,9211,'tl','',0),(331586,9211,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3612;&#3641;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591; &#3627;&#3619;&#3639;&#3629; &#3648;&#3623;&#3657;&#3609;&#3623;&',0),(331587,9211,'hi','à¤‰à¤ à¤¾à¤“ à¤à¤• à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤•à¤°à¥à¤¤à¤¾ à¤¯à¤¾ à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚',0),(331588,9211,'ms','Pilih penerima Ukur di bawah atau biarkan kosong',0),(331589,9211,'ar','Ø§Ø®ØªÙŠØ§Ø± Ù…Ø³ØªÙ„Ù… Ù…Ø³Ø­ Ø£Ø¯Ù†Ø§Ù‡ Ø£Ùˆ Ø§ØªØ±Ùƒ Ø§Ù„Ù…Ø³Ø§Ø­Ø© ÙØ§Ø±ØºØ©',0),(331590,9211,'fr','Choisir un destinataire de sondage ci-dessous ou laisser en blanc',0),(331591,9211,'jp','ä»¥ä¸‹èª¿æŸ»å—ä¿¡è€…ã‚’é¸æŠžã™ã‚‹ã‹ã€ã¾ãŸã¯ç©ºç™½',0),(331592,9211,'pt','Escolha um destinatÃ¡rio de pesquisa abaixo ou deixar em branco',0),(331593,9211,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»Ñ Ð¾Ð¿Ñ€Ð¾Ñ Ð½Ð¸Ð¶Ðµ Ð¸Ð»Ð¸ Ð¾ÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿Ð¾Ð»Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼',0),(331594,9211,'es','Escoge un Recipiente del Estudio Abajo o Deja en Blanco',0),(331595,9211,'de','WÃ¤hlen Sie einen Umfrage-EmpfÃ¤nger unten oder lassen leer',0),(331596,9211,'en','Pick A Survey Recipient Below Or Leave Blank',0),(331597,9212,'is','',0),(331598,9212,'dr','URL  ',0),(331599,9212,'pr','Ø¨Ù†Ø§Ø¨Ø±Ø§ÙŠÙ† Ø§ÙŠÙ† ÙØ§ÙŠÙ„ ÙˆØ¨ Ø³Ø§ÙŠØª  ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ ÙŠÙƒ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ URL  \r\n',0),(331600,9212,'tr','Yani bu URL\'nin yalnÄ±zca 1 anket iÃ§in kullanÄ±labilir.',0),(331601,9212,'pl','WiÄ™c ten adres URL moÅ¼e byÄ‡ uÅ¼ywane tylko dla 1 badanie.',0),(331602,9212,'bg','Ð¢Ð°ÐºÐ° Ñ‡Ðµ Ñ‚Ð¾Ð·Ð¸ URL Ð°Ð´Ñ€ÐµÑ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° ÑÐ°Ð¼Ð¾ Ð·Ð° 1 Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ.',0),(331603,9212,'ur','Ù¾Ø³ ÛŒÛ URL ØµØ±Ù 1 Ø³Ø±ÙˆÛ’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ ÛÛ’ Û”',0),(331604,9212,'sr','Ð”Ð°ÐºÐ»Ðµ Ð¾Ð²Ð°Ñ˜ Ð£Ð Ð› Ð¼Ð¾Ð¶Ðµ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð·Ð° 1 Ð°Ð½ÐºÐµÑ‚Ñƒ.',0),(331605,9212,'vi','ÄÆ°á»ng dáº«n nÃ y chá»‰ cÃ³ thá»ƒ dÃ¹ng cho 1 kháº£o sÃ¡t',0),(331606,9212,'af','So hierdie BA (\"URL\") kan slegs gebruik word vir 1 opname.',0),(331607,9212,'ro','Deci acest URL pot fi utilizate numai pentru 1 sondaj.',0),(331608,9212,'et','Nii saate selle URL-i kasutada ainult 1 uuringu.',0),(331609,9212,'si','Tako ta URL lahko uporabijo samo za 1 anketo.',0),(331610,9212,'ba','Jadi URL ini hanya dapat digunakan untuk 1 survey.',0),(331611,9212,'nl','Dus kan deze URL alleen worden gebruikt voor 1 enquÃªte.',0),(331612,9212,'fi','TÃ¤mÃ¤n URL-osoitteen vain niin voidaan 1 kyselyn.',0),(331613,9212,'no','SÃ¥ kan denne URL bare brukes for 1 undersÃ¸kelsen.',0),(331614,9212,'da','Denne URL kan sÃ¥ kun bruges til 1 undersÃ¸gelse.',0),(331615,9212,'ko','ê·¸ëž˜ì„œì´ URLì€ 1 ì¡°ì‚¬ë¥¼ ìœ„í•´ ì‚¬ìš©í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(331616,9212,'he','××– ×›×ª×•×‘×ª URL ×–×• ×™×›×•×œ ×œ×©×ž×© ×¨×§ ×¢×‘×•×¨ ×¡×§×¨ 1.',0),(331617,9212,'el','ÎˆÏ„ÏƒÎ¹ Î±Ï…Ï„Î® Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· URL Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ Î¼ÏŒÎ½Î¿ Î³Î¹Î± 1 Î­ÏÎµÏ…Î½Î±.',0),(331618,9212,'zh','æ‰€ä»¥è¿™ä¸ªç½‘å€åªèƒ½ç”¨äºŽä¸€è°ƒæŸ¥ã€‚\r\n',0),(331619,9212,'sv','SÃ¥ kan denna URL endast anvÃ¤ndas fÃ¶r 1 undersÃ¶kning.',0),(331620,9212,'it','CosÃ¬ questo URL puÃ² essere utilizzato solo per 1 studio.',0),(331621,9212,'tl','',0),(331622,9212,'th','&#3604;&#3633;&#3591;&#3609;&#3633;&#3657;&#3609; URL &#3609;&#3637;&#3657;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;&#3648;&#3593;&#3614;&#3634;&#3632; 1 &#3626;&#3635;&#3619;&#3623;&#3592;',0),(331623,9212,'hi','à¤¤à¥‹ à¤‡à¤¸ URL à¤•à¥‡à¤µà¤² 1 à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾à¥¤',0),(331624,9212,'ms','Jadi URL ini hanya boleh digunakan untuk kajian 1.',0),(331625,9212,'ar','Ø­ØªÙ‰ ÙŠÙ…ÙƒÙ† ÙÙ‚Ø· Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¹Ù†ÙˆØ§Ù† URL Ù‡Ø°Ø§ Ù„Ù…Ø³Ø­ 1.',0),(331626,9212,'fr','Si cette URL utilisable uniquement pour 1 enquÃªte.',0),(331627,9212,'jp','ã ã‹ã‚‰ã“ã® URL ã¯ 1 ã®èª¿æŸ»ã®ãŸã‚ã®ã¿ä½¿ç”¨ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(331628,9212,'pt','EntÃ£o este URL sÃ³ pode ser usado para 1 pesquisa.',0),(331629,9212,'ru','Ð¢Ð°Ðº Ñ‡Ñ‚Ð¾ ÑÑ‚Ð¾Ñ‚ URL-Ð°Ð´Ñ€ÐµÑ Ð¼Ð¾Ð¶ÐµÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒÑÑ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ 1 Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ.',0),(331630,9212,'es','Entonces este URL solo se puede usar para 1 estudio',0),(331631,9212,'de','Diese URL kann also nur fÃ¼r 1 Umfrage verwendet werden.',0),(331632,9212,'en','So this URL can only be used for 1 survey.',0),(331633,9213,'is','',0),(331634,9213,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ\r\n',0),(331635,9213,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ\r\n',0),(331636,9213,'tr','Anket URL',0),(331637,9213,'pl','Badania URL',0),(331638,9213,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ URL',0),(331639,9213,'ur','Ø³Ø±ÙˆÛ’ ÛŒÙˆ Ø¢Ø± Ø§ÛŒÙ„',0),(331640,9213,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð£Ð Ð›',0),(331641,9213,'vi','ÄÆ°á»ng dáº«n kháº£o sÃ¡t',0),(331642,9213,'af','Opname BA (\"URL\")',0),(331643,9213,'ro','Sondaj URL',0),(331644,9213,'et','Uuringu URL',0),(331645,9213,'si','Raziskava URL',0),(331646,9213,'ba','Survei URL',0),(331647,9213,'nl','EnquÃªte-URL',0),(331648,9213,'fi','Kysely-URL',0),(331649,9213,'no','UndersÃ¸kelsen URL',0),(331650,9213,'da','UndersÃ¸gelsen URL',0),(331651,9213,'ko','ì„¤ë¬¸ ì¡°ì‚¬ URL',0),(331652,9213,'he','×¡×§×¨ URL',0),(331653,9213,'el','ÎˆÏÎµÏ…Î½Î± URL',0),(331654,9213,'zh','è°ƒæŸ¥ç½‘å€\r\n',0),(331655,9213,'sv','UndersÃ¶kning URL',0),(331656,9213,'it','URL sondaggio',0),(331657,9213,'tl','',0),(331658,9213,'th','&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592; URL',0),(331659,9213,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤¯à¥‚à¤†à¤°à¤à¤²',0),(331660,9213,'ms','Kaji selidik URL',0),(331661,9213,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¯Ø±Ø§Ø³Ø© Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¦ÙŠØ©',0),(331662,9213,'fr','URL de sondage',0),(331663,9213,'jp','èª¿æŸ»ã® URL',0),(331664,9213,'pt','URL de pesquisa',0),(331665,9213,'ru','ÐžÐ±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ URL-Ð°Ð´Ñ€ÐµÑ',0),(331666,9213,'es','Estudio URL',0),(331667,9213,'de','Umfrage-URL',0),(331668,9213,'en','Survey URL',0),(331669,9214,'is','',0),(331670,9214,'dr','Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙŠØ§ ÙØ§ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ ',0),(331671,9214,'pr','Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙŠØ§ ÙØ§ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ ',0),(331672,9214,'tr','URL baÅŸarÄ±yla oluÅŸturuldu',0),(331673,9214,'pl','Adres URL wygenerowany pomyÅ›lnie',0),(331674,9214,'bg','URL, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(331675,9214,'ur','URL Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÛŒØ¯Ø§',0),(331676,9214,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° Ð³ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ð½Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(331677,9214,'vi','Táº¡o ÄÆ°á»ng dáº«n thÃ nh cÃ´ng',0),(331678,9214,'af','BA (\"URL\") Suksesvol Gegenereer',0),(331679,9214,'ro','URL-ul generat cu succes',0),(331680,9214,'et','URL-i genereerimine Ãµnnestus',0),(331681,9214,'si','URL, ki so ustvarila uspeÅ¡no',0),(331682,9214,'ba','URL yang dihasilkan berhasil',0),(331683,9214,'nl','URL gegenereerd met succes',0),(331684,9214,'fi','URL-osoitteen luominen onnistui',0),(331685,9214,'no','URL er fullfÃ¸rt.',0),(331686,9214,'da','URL genereret med succes',0),(331687,9214,'ko','ì„±ê³µì ìœ¼ë¡œ ìƒì„± ëœ URL',0),(331688,9214,'he','×›×ª×•×‘×ª URL ×©× ×•×¦×¨×• ×‘×”×¦×œ×—×”',0),(331689,9214,'el','URL Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(331690,9214,'zh','æˆåŠŸç”Ÿæˆçš„ç½‘å€',0),(331691,9214,'sv','URL genereras framgÃ¥ngsrikt',0),(331692,9214,'it','URL generato con successo',0),(331693,9214,'tl','',0),(331694,9214,'th','&#3626;&#3619;&#3657;&#3634;&#3591; URL &#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(331695,9214,'hi','URL à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨',0),(331696,9214,'ms','URL yang dihasilkan berjaya',0),(331697,9214,'ar','URL Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(331698,9214,'fr','URL gÃ©nÃ©rÃ©e avec succÃ¨s',0),(331699,9214,'jp','æ­£å¸¸ã«ç”Ÿæˆã•ã‚ŒãŸ URL',0),(331700,9214,'pt','URL gerado com sucesso',0),(331701,9214,'ru','URL-Ð°Ð´Ñ€ÐµÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½',0),(331702,9214,'es','URL Generado Exitosamente',0),(331703,9214,'de','Erfolgreich erzeugte URL',0),(331704,9214,'en','URL Generated Successfully',0),(331705,9215,'is','',0),(331706,9215,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ',0),(331707,9215,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ',0),(331708,9215,'tr','Hata alma Anketi',0),(331709,9215,'pl','BÅ‚Ä…d pobierania badania',0),(331710,9215,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(331711,9215,'ur','Ù†Ù‚Øµ Ø³Ø±ÙˆÛ’ Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(331712,9215,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐ° Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(331713,9215,'vi','Truy váº¥n kháº£o sÃ¡t bá»‹ lá»—i',0),(331714,9215,'af','Fout met Herwinning van Opname',0),(331715,9215,'ro','Eroare recuperare sondaj',0),(331716,9215,'et','TÃµrge allalaadimisel uuring',0),(331717,9215,'si','Napaka pri pridobivanju raziskave',0),(331718,9215,'ba','Kesalahan mengambil survei',0),(331719,9215,'nl','Fout ophalen van enquÃªte',0),(331720,9215,'fi','Virhe noudettaessa tutkimus',0),(331721,9215,'no','Feil under henting av undersÃ¸kelsen',0),(331722,9215,'da','Fejl under hentning af undersÃ¸gelsen',0),(331723,9215,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ì¡°ì‚¬',0),(331724,9215,'he','×©×’×™××” ×‘××—×–×•×¨ ×¡×§×¨',0),(331725,9215,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Î­ÏÎµÏ…Î½Î±',0),(331726,9215,'zh','é”™è¯¯æ£€ç´¢è°ƒæŸ¥',0),(331727,9215,'sv','Fel hÃ¤mtar undersÃ¶kning',0),(331728,9215,'it','Errore recuperando Survey',0),(331729,9215,'tl','',0),(331730,9215,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3585;&#3641;&#3657;&#3588;&#3639;&#3609;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(331731,9215,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£',0),(331732,9215,'ms','Ralat mengambil kaji selidik',0),(331733,9215,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø³Ø­',0),(331734,9215,'fr','Erreur rÃ©cupÃ©rer Survey',0),(331735,9215,'jp','ã‚¨ãƒ©ãƒ¼ã‚’å–å¾—ã™ã‚‹èª¿æŸ»',0),(331736,9215,'pt','Pesquisa de recuperaÃ§Ã£o de erro',0),(331737,9215,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ñ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(331738,9215,'es','Error Recuperando el studio',0),(331739,9215,'de','Fehler beim Abrufen Umfrage',0),(331740,9215,'en','Error Retrieving Survey',0),(331741,9216,'is','',0),(331742,9216,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ',0),(331743,9216,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ',0),(331744,9216,'tr','Anket kaydedilirken hata oluÅŸtu',0),(331745,9216,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania badania',0),(331746,9216,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(331747,9216,'ur','Ø³Ø±ÙˆÛ’ Ù…ÛŒÚº Ù…Ø­ÙÙˆØ¸ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(331748,9216,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ¿Ñ€ÐµÐ¼Ð°ÑšÐ° Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(331749,9216,'vi','Sao lÆ°u kháº£o sÃ¡t bá»‹ lá»—i',0),(331750,9216,'af','Fout met Stoor van Opname',0),(331751,9216,'ro','Eroare la salvarea sondaj',0),(331752,9216,'et','Uuringu salvestamise tÃµrge',0),(331753,9216,'si','Napaka pri shranjevanju raziskava',0),(331754,9216,'ba','Kesalahan menyimpan survei',0),(331755,9216,'nl','Fout bij het opslaan van enquÃªte',0),(331756,9216,'fi','Virhe tallennettaessa tutkimus',0),(331757,9216,'no','Feil under lagring av undersÃ¸kelsen',0),(331758,9216,'da','Fejl under lagring af undersÃ¸gelsen',0),(331759,9216,'ko','ì„¤ë¬¸ì„ ì €ìž¥ ì˜¤ë¥˜',0),(331760,9216,'he','××™×¨×¢×” ×©×’×™××” ×‘×©×ž×™×¨×ª ×¡×§×¨',0),(331761,9216,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Î­ÏÎµÏ…Î½Î±',0),(331762,9216,'zh','é”™è¯¯ä¿å­˜è°ƒæŸ¥',0),(331763,9216,'sv','Fel vid sparande av undersÃ¶kning',0),(331764,9216,'it','Errore durante il salvataggio di indagine',0),(331765,9216,'tl','',0),(331766,9216,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(331767,9216,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(331768,9216,'ms','Ralat Menyimpan kaji selidik',0),(331769,9216,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸ Ø§Ù„Ù…Ø³Ø­',0),(331770,9216,'fr','EnquÃªte sur une erreur',0),(331771,9216,'jp','èª¿æŸ»ã®ä¿å­˜ã‚¨ãƒ©ãƒ¼',0),(331772,9216,'pt','Erro ao salvar pesquisa',0),(331773,9216,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(331774,9216,'es','Error Guardando el Estudio',0),(331775,9216,'de','Fehler beim Speichern der Umfrage',0),(331776,9216,'en','Error Saving Survey',0),(331777,9217,'is','',0),(331778,9217,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ù…Ø§ ',0),(331779,9217,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ù…Ø§ ',0),(331780,9217,'tr','Bilgilerinizi kaydetme hatasÄ±',0),(331781,9217,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania informacji',0),(331782,9217,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(331783,9217,'ur','Ø¢Ù¾ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø­ÙÙˆØ¸ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(331784,9217,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ñ‡ÑƒÐ²Ð°ÑšÐ° Ð²Ð°ÑˆÐ¸Ñ… Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°',0),(331785,9217,'vi','Lá»—i khi sao lÆ°u thÃ´ng tin cá»§a báº¡n',0),(331786,9217,'af','Fout met Stoor van U Inligting',0),(331787,9217,'ro','Eroare la salvarea informaÅ£iile dumneavoastrÄƒ',0),(331788,9217,'et','Teie teabe salvestamise tÃµrge',0),(331789,9217,'si','Napaka pri shranjevanju vaÅ¡ih podatkov',0),(331790,9217,'ba','Kesalahan menyimpan informasi Anda',0),(331791,9217,'nl','Fout bij het opslaan van uw gegevens',0),(331792,9217,'fi','Virhe tallennettaessa tietoja',0),(331793,9217,'no','Feil under lagring av informasjon',0),(331794,9217,'da','Fejl under lagring af dine oplysninger',0),(331795,9217,'ko','ê·€í•˜ì˜ ì •ë³´ë¥¼ ì €ìž¥ í•˜ëŠ” ì˜¤ë¥˜',0),(331796,9217,'he','×©×’×™××” ×‘×¢×ª ×©×ž×™×¨×ª ×”×ž×™×“×¢ ×©×œ×š',0),(331797,9217,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ ÏƒÎ±Ï‚',0),(331798,9217,'zh','ä¿å­˜æ‚¨çš„ä¿¡æ¯é”™è¯¯',0),(331799,9217,'sv','Fel vid sparande av din Information',0),(331800,9217,'it','Errore durante il salvataggio dei tuoi dati',0),(331801,9217,'tl','',0),(331802,9217,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(331803,9217,'hi','à¤…à¤ªà¤¨à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(331804,9217,'ms','Ralat menyimpan maklumat anda',0),(331805,9217,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ®Ø²ÙŠÙ† Ù…Ø¹Ù„ÙˆÙ…Ø§ØªÙƒ',0),(331806,9217,'fr','Erreur d\'enregistrement de vos informations',0),(331807,9217,'jp','ãŠå®¢æ§˜ã®æƒ…å ±ã‚’ä¿å­˜ä¸­ã«ã‚¨ãƒ©ãƒ¼',0),(331808,9217,'pt','Erro ao salvar suas informaÃ§Ãµes',0),(331809,9217,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ Ð’Ð°ÑˆÐµÐ¹ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸',0),(331810,9217,'es','Error Guardando Su InformaciÃ³n',0),(331811,9217,'de','Fehler beim Speichern Ihrer Daten',0),(331812,9217,'en','Error Saving Your Information',0),(331813,9218,'is','',0),(331814,9218,'dr','Ù„ÙŠÙ†Ùƒ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(331815,9218,'pr','Ù„ÙŠÙ†Ùƒ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª ',0),(331816,9218,'tr','Anket linki geÃ§ersiz',0),(331817,9218,'pl','Link badania jest nieprawidÅ‚owy',0),(331818,9218,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ Ð»Ð¸Ð½Ðº Ðµ Ð½ÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½',0),(331819,9218,'ur','Ø³Ø±ÙˆÛ’ Ù„Ù†Ú© Ù†Ø§Ø¬Ø§Ø¦Ø² ÛÛ’ Û”',0),(331820,9218,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð²ÐµÐ·Ð° Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð¸',0),(331821,9218,'vi','Kháº£o SÃ¡t ÄÆ°á»ng Dáº«n VÃ´ Hiá»‡u',0),(331822,9218,'af','Opname Skakel is Ongeldig',0),(331823,9218,'ro','Link-ul de studiu este nevalidÄƒ',0),(331824,9218,'et','KÃ¼sitluse Link on vigane',0),(331825,9218,'si','Raziskava Link je neveljaven',0),(331826,9218,'ba','Link survei adalah valid',0),(331827,9218,'nl','EnquÃªte-Link is ongeldig',0),(331828,9218,'fi','Tutkimuksen linkki ei kelpaa',0),(331829,9218,'no','UndersÃ¸kelsen koblingen er ugyldig',0),(331830,9218,'da','Survey Link er ugyldig',0),(331831,9218,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ë§í¬ëŠ” ìœ íš¨ í•˜ì§€ ì•ŠìŒ',0),(331832,9218,'he','×¡×§×¨ ×”×§×™×©×•×¨ ××™× ×• ×—×•×§×™',0),(331833,9218,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Î­ÏÎµÏ…Î½Î± ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ·',0),(331834,9218,'zh','è°ƒæŸ¥é“¾æŽ¥æ˜¯æ— æ•ˆçš„\r\n',0),(331835,9218,'sv','UndersÃ¶kning lÃ¤nk Ã¤r felaktig',0),(331836,9218,'it','Sondaggio Link Ã¨ invalido',0),(331837,9218,'tl','',0),(331838,9218,'th','&#3621;&#3636;&#3591;&#3588;&#3660;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(331839,9218,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤²à¤¿à¤‚à¤• à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤¹à¥ˆ',0),(331840,9218,'ms','Pautan kajian adalah tidak sah',0),(331841,9218,'ar','Ù…Ø³Ø­ Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø· Ù‡Ùˆ ØµØ§Ù„Ø­',0),(331842,9218,'fr','Sondage lien est invalide',0),(331843,9218,'jp','èª¿æŸ»ã®ãƒªãƒ³ã‚¯ã¯ç„¡åŠ¹ã§ã™ã€‚',0),(331844,9218,'pt','Pesquisa Link Ã© invÃ¡lido',0),(331845,9218,'ru','ÐžÐ¿Ñ€Ð¾Ñ ÑÑÑ‹Ð»ÐºÐ° ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð½ÐµÐ´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼',0),(331846,9218,'es','Enlace de Estudio es InvÃ¡lido',0),(331847,9218,'de','Umfrage-Link ist ungÃ¼ltig',0),(331848,9218,'en','Survey Link is Invalid',0),(331849,9219,'is','',0),(331850,9219,'dr','Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(331851,9219,'pr','Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(331852,9219,'tr','Anket bulunamadÄ±',0),(331853,9219,'pl','Badania nie znaleziono',0),(331854,9219,'bg','Ð˜Ð·ÑÐ»ÐµÐ´Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(331855,9219,'ur','Ø³Ø±ÙˆÛ’ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(331856,9219,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(331857,9219,'vi','Kháº£o sÃ¡t khÃ´ng tÃ¬m tháº¥y',0),(331858,9219,'af','Opname Nie Gevind',0),(331859,9219,'ro','Ancheta nu a fost gÄƒsit',0),(331860,9219,'et','Uuring ei leitud',0),(331861,9219,'si','Raziskava ni mogoÄe najti',0),(331862,9219,'ba','Survei tidak ditemukan',0),(331863,9219,'nl','EnquÃªte niet gevonden',0),(331864,9219,'fi','Tutkimuksessa ei lÃ¶ytynyt',0),(331865,9219,'no','UndersÃ¸kelsen ikke funnet',0),(331866,9219,'da','UndersÃ¸gelsen blev ikke fundet',0),(331867,9219,'ko','ì„¤ë¬¸ ì¡°ì‚¬ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(331868,9219,'he','×¡×§×¨ ×œ× × ×ž×¦×',0),(331869,9219,'el','ÎˆÏÎµÏ…Î½Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(331870,9219,'zh','è°ƒæŸ¥æœªæ‰¾åˆ°\r\n',0),(331871,9219,'sv','UndersÃ¶kningen hittades inte',0),(331872,9219,'it','Indagine non trovato',0),(331873,9219,'tl','',0),(331874,9219,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(331875,9219,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(331876,9219,'ms','Kajian yang tidak dijumpai',0),(331877,9219,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¡',0),(331878,9219,'fr','Sondage introuvable',0),(331879,9219,'jp','èª¿æŸ»ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(331880,9219,'pt','Pesquisa nÃ£o encontrada',0),(331881,9219,'ru','ÐžÐ¿Ñ€Ð¾Ñ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(331882,9219,'es','Estudio No Se EncontrÃ³',0),(331883,9219,'de','Umfrage nicht gefunden',0),(331884,9219,'en','Survey Not Found',0),(331885,9220,'is','',0),(331886,9220,'dr','ØµØ­Øª Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(331887,9220,'pr','ØµØ­Øª Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(331888,9220,'tr','Anket doÄŸrulama baÅŸarÄ±sÄ±z oldu',0),(331889,9220,'pl','Nie moÅ¼na sprawdziÄ‡ poprawnoÅ›ci badania',0),(331890,9220,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(331891,9220,'ur','Ø³Ø±ÙˆÛ’ Ú©ÛŒ Ø¬ÙˆØ§Ø² Ø¯ÛÛŒ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(331892,9220,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð²Ð°Ñ™Ð°Ð½Ð¾ÑÑ‚Ð¸ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð°',0),(331893,9220,'vi','XÃ¡c nháº­n kháº£o sÃ¡t tháº¥t báº¡i',0),(331894,9220,'af','Opname Geldigheid het Gefaal',0),(331895,9220,'ro','Sondaj validarea nu a reuÈ™it',0),(331896,9220,'et','Uuringu kontrollimine nurjus',0),(331897,9220,'si','Raziskava preverjanje veljavnosti ni uspelo',0),(331898,9220,'ba','Survei validasi gagal',0),(331899,9220,'nl','EnquÃªte validatie mislukt',0),(331900,9220,'fi','Kyselyn validointi epÃ¤onnistui',0),(331901,9220,'no','UndersÃ¸kelsen validering mislyktes',0),(331902,9220,'da','UndersÃ¸gelsen validering mislykkedes',0),(331903,9220,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ìœ íš¨ì„± ê²€ì‚¬ ì‹¤íŒ¨',0),(331904,9220,'he','×¡×§×¨ ×”××™×ž×•×ª × ×›×©×œ',0),(331905,9220,'el','ÎˆÏÎµÏ…Î½Î± Î· ÎµÏ€Î¹ÎºÏÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(331906,9220,'zh','è°ƒæŸ¥éªŒè¯å¤±è´¥\r\n',0),(331907,9220,'sv','UndersÃ¶kning validering misslyckades',0),(331908,9220,'it','Convalida di indagine non riuscita',0),(331909,9220,'tl','',0),(331910,9220,'th','&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(331911,9220,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¨ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(331912,9220,'ms','Kaji selidik pengesahan gagal',0),(331913,9220,'ar','ÙØ´Ù„ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† ØµØ­Ø© Ø§Ù„Ø¯Ø±Ø§Ø³Ø© Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¦ÙŠØ©',0),(331914,9220,'fr','Ã‰tude Validation a Ã©chouÃ©',0),(331915,9220,'jp','èª¿æŸ»æ¤œè¨¼ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(331916,9220,'pt','Pesquisa validaÃ§Ã£o falhada',0),(331917,9220,'ru','Ð¡Ð±Ð¾Ð¹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(331918,9220,'es','ValidaciÃ³n de Estudio FallÃ³',0),(331919,9220,'de','Umfrage-Validierung fehlgeschlagen',0),(331920,9220,'en','Survey Validation Failed',0),(331921,9221,'is','',0),(331922,9221,'dr','Ø§ÙŠÙ† Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù‚Ø¨Ù„Ø§ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª  ',0),(331923,9221,'pr','Ø§ÙŠÙ† Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù‚Ø¨Ù„Ø§ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª  ',0),(331924,9221,'tr','Bu ankete zaten tamamlandÄ±.',0),(331925,9221,'pl','Badanie to zostaÅ‚o juÅ¼ zakoÅ„czone.',0),(331926,9221,'bg','Ð¢Ð¾Ð²Ð° Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ Ðµ Ð²ÐµÑ‡Ðµ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð°.',0),(331927,9221,'ur','ÛŒÛ Ø³Ø±ÙˆÛ’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(331928,9221,'sr','ÐžÐ²Ñƒ Ð°Ð½ÐºÐµÑ‚Ñƒ Ñ˜Ðµ Ð²ÐµÑ› Ð±Ð¸Ð»Ð¾ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½Ð¾.',0),(331929,9221,'vi','Kháº£o sÃ¡t nÃ y dÃ£ hoÃ n táº¥t',0),(331930,9221,'af','Hierdie Opname is alreeds voltooi.',0),(331931,9221,'ro','Acest sondaj a fost deja finalizate.',0),(331932,9221,'et','Selle kÃ¼sitluse juba lÃµpetatud.',0),(331933,9221,'si','Ta raziskava je dokonÄano.',0),(331934,9221,'ba','Survei ini telah selesai.',0),(331935,9221,'nl','Dit onderzoek is reeds afgerond.',0),(331936,9221,'fi','TÃ¤mÃ¤ tutkimus on jo valmiiksi.',0),(331937,9221,'no','Denne undersÃ¸kelsen er allerede fullfÃ¸rt.',0),(331938,9221,'da','Denne undersÃ¸gelse er allerede afsluttet.',0),(331939,9221,'ko','ì´ ì„¤ë¬¸ ì¡°ì‚¬ëŠ” ì´ë¯¸ ì™„ë£Œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(331940,9221,'he','×¡×§×¨ ×–×” ×›×‘×¨ ×”×•×©×œ×.',0),(331941,9221,'el','Î‘Ï…Ï„Î® Î· Î­ÏÎµÏ…Î½Î± Î­Ï‡ÎµÎ¹ Î®Î´Î· Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯.',0),(331942,9221,'zh','è¿™é¡¹è°ƒæŸ¥å·²ç»å®Œæˆã€‚\r\n',0),(331943,9221,'sv','Denna undersÃ¶kning har redan slutfÃ¶rts.',0),(331944,9221,'it','Questa indagine Ã¨ giÃ  stata completata.',0),(331945,9221,'tl','',0),(331946,9221,'th','&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3609;&#3637;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;',0),(331947,9221,'hi','à¤‡à¤¸ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤•à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤ªà¥‚à¤°à¥à¤£ à¤¹à¥‹ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(331948,9221,'ms','Kaji selidik ini telah selesai.',0),(331949,9221,'ar','ÙˆÙ‚Ø¯ Ø§ÙƒØªÙ…Ù„ ÙØ¹Ù„Ø§ Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³Ø­.',0),(331950,9221,'fr','Cette enquÃªte a dÃ©jÃ  Ã©tÃ© rÃ©alisÃ©e.',0),(331951,9221,'jp','ã“ã®èª¿æŸ»ã¯æ—¢ã«å®Œäº†ã§ã™ã€‚',0),(331952,9221,'pt','Esta pesquisa jÃ¡ foi concluÃ­da.',0),(331953,9221,'ru','Ð­Ñ‚Ð¾ Ð¸ÑÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑƒÐ¶Ðµ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¾.',0),(331954,9221,'es','Est Estudio ya se FinalizÃ³',0),(331955,9221,'de','Diese Umfrage wurde bereits beendet.',0),(331956,9221,'en','This survey has already been completed.',0),(331957,9222,'is','',0),(331958,9222,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ù…Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(331959,9222,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ù…Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(331960,9222,'tr','Bilgilerinizi baÅŸarÄ±yla kaydedildi',0),(331961,9222,'pl','Dane zostaÅ‚ pomyÅ›lnie zapisany',0),(331962,9222,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ðµ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(331963,9222,'ur','Ø¢Ù¾ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(331964,9222,'sr','Ð’Ð°ÑˆÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(331965,9222,'vi','Sao lÆ°u thÃ nh cÃ´ng ThÃ´ng Tin cá»§a báº¡n',0),(331966,9222,'af','U Inligting is Suksesvol Gestoor',0),(331967,9222,'ro','Informatia introdusa a fost salvata cu succes',0),(331968,9222,'et','Sinu informatsioon salvestati eduakalt',0),(331969,9222,'si','VaÅ¡ih podatkov je bila uspeÅ¡no shranjena',0),(331970,9222,'ba','Informasi Anda telah disimpan berhasil',0),(331971,9222,'nl','Uw informatie is opgeslagen',0),(331972,9222,'fi','Tietosi on tallennettu',0),(331973,9222,'no','Informasjonen er lagret',0),(331974,9222,'da','Dine oplysninger er blevet gemt med succes',0),(331975,9222,'ko','ì •ë³´ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(331976,9222,'he','×”×ž×™×“×¢ ×©×œ×š × ×©×ž×¨×” ×‘×”×¦×œ×—×”',0),(331977,9222,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÎ±Ï‚ Î­Ï‡ÎµÎ¹ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(331978,9222,'zh','æ‚¨çš„ä¿¡æ¯å·²æˆåŠŸä¿å­˜\r\n',0),(331979,9222,'sv','Din Information har sparats',0),(331980,9222,'it','L\'informazione sono stati salvati con successo',0),(331981,9222,'tl','',0),(331982,9222,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3610;&#3633;&#3609;&#3638;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(331983,9222,'hi','à¤†à¤ªà¤•à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(331984,9222,'ms','Maklumat anda telah berjaya disimpan',0),(331985,9222,'ar','Ø­ÙØ¸Øª Ù…Ø¹Ù„ÙˆÙ…Ø§ØªÙƒ Ø¨Ù†Ø¬Ø§Ø­',0),(331986,9222,'fr','Votre Information n\'a Ã©tÃ© enregistrÃ©e',0),(331987,9222,'jp','ã‚ãªãŸã®æƒ…å ±ãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(331988,9222,'pt','Sua informaÃ§Ã£o foi salvo com sucesso',0),(331989,9222,'ru','Ð’Ð°ÑˆÐ° Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð‘Ñ‹Ð»Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð°',0),(331990,9222,'es','Su InformaciÃ³n se GuardÃ³ Exitosamente',0),(331991,9222,'de','Ihre Informationen wurden erfolgreich gespeichert',0),(331992,9222,'en','Your Information Has Been Saved Successfully',0),(331993,9223,'is','',0),(331994,9223,'dr','Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø§ÙŠÙ† ØµÙØ­Ù‡ Ø±Ø§ Ø§ÙƒÙ†ÙˆÙ† Ø¨Ø¨Ù†Ø¯ÙŠØ¯ ',0),(331995,9223,'pr','Ù…Ù…ÙƒÙ† Ø§Ø³Øª Ø§ÙŠÙ† ØµÙØ­Ù‡ Ø±Ø§ Ø§ÙƒÙ†ÙˆÙ† Ø¨Ø¨Ù†Ø¯ÙŠØ¯ ',0),(331996,9223,'tr','Bu sayfa ÅŸimdi kapatabilirsiniz',0),(331997,9223,'pl','MoÅ¼esz teraz zamknÄ…Ä‡ tÄ™ stronÄ™',0),(331998,9223,'bg','Ð¡ÐµÐ³Ð° Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð·Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(331999,9223,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ø§Ø³ ØµÙØ­Û’ Ú©Ùˆ Ø§Ø¨ Ø¨Ù†Ø¯ ÛÙˆ',0),(332000,9223,'sr','Ð¡Ð°Ð´Ð° Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð·Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(332001,9223,'vi','BÃ¢y giá» báº¡n cÃ³ thá»ƒ Ä‘Ã³ng trang nÃ y láº¡i',0),(332002,9223,'af','U mag nou hierdie Bladsy toemaak.',0),(332003,9223,'ro','Acum puteti inchide aceasta pagina',0),(332004,9223,'et','Te vÃµite nÃ¼Ã¼d sulgeda selle lehe',0),(332005,9223,'si','Lahko zaprete to stran',0),(332006,9223,'ba','Anda sekarang dapat menutup Halaman ini',0),(332007,9223,'nl','U kunt deze pagina nu sluiten',0),(332008,9223,'fi','Voit nyt sulkea tÃ¤mÃ¤n sivun',0),(332009,9223,'no','Du kan nÃ¥ lukke denne siden',0),(332010,9223,'da','Du kan nu lukke denne side',0),(332011,9223,'ko','ì´ì œì´ íŽ˜ì´ì§€ë¥¼ ë‹«ì„ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(332012,9223,'he','×›×¢×ª ×‘××¤×©×¨×•×ª×š ×œ×¡×’×•×¨ ×“×£ ×–×”',0),(332013,9223,'el','Î¤ÏŽÏÎ± Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± ÎºÎ»ÎµÎ¯ÏƒÎµÏ„Îµ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ»Î¯Î´Î±',0),(332014,9223,'zh','æ‚¨å¯ä»¥çŽ°åœ¨å…³é—­æ­¤é¡µ\r\n',0),(332015,9223,'sv','Du kan nu stÃ¤nga denna sida',0),(332016,9223,'it','Ora si puÃ² chiudere questa pagina',0),(332017,9223,'tl','',0),(332018,9223,'th','&#3588;&#3640;&#3603;&#3629;&#3634;&#3592;&#3592;&#3632;&#3611;&#3636;&#3604;&#3627;&#3609;&#3657;&#3634;&#3609;&#3637;&#3657;&#3605;&#3629;&#3609;&#3609;&#3637;&#3657;',0),(332019,9223,'hi','à¤†à¤ª à¤…à¤¬ à¤‡à¤¸ à¤ªà¥ƒà¤·à¥à¤  à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(332020,9223,'ms','Anda kini boleh menutup Laman ini',0),(332021,9223,'ar','ÙŠÙ…ÙƒÙ†Ùƒ Ø§Ù„Ø¢Ù† Ø¥ØºÙ„Ø§Ù‚ Ù‡Ø°Ù‡ Ø§Ù„ØµÙØ­Ø©',0),(332022,9223,'fr','Vous pouvez maintenant fermer cette Page',0),(332023,9223,'jp','ä»Šã“ã®ãƒšãƒ¼ã‚¸ã‚’é–‰ã˜ã‚‹ã“ã¨ãŒã‚ã‚Šã¾ã™ã€‚',0),(332024,9223,'pt','Agora vocÃª pode fechar esta pÃ¡gina',0),(332025,9223,'ru','Ð¢ÐµÐ¿Ñ€ÑŒ Ð’Ñ‹ ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð—Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ Ð”Ð°Ð½Ð½ÑƒÑŽ Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(332026,9223,'es','Ya Se Puede Cerrar Esta PÃ¡gina',0),(332027,9223,'de','Sie kÃ¶nnen jetzt diese Seite schlieÃŸen.',0),(332028,9223,'en','You May Now Close This Page',0),(332029,9224,'is','',0),(332030,9224,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(332031,9224,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡ Ø¨Ù‡ ',0),(332032,9224,'tr','E-postayla',0),(332033,9224,'pl','E-mailem',0),(332034,9224,'bg','Ð•Ð¼Ð°Ð¹Ð»',0),(332035,9224,'ur','Ú©Û’ Ù„ÛŒÛ’ Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú©',0),(332036,9224,'sr','Ð£Ð¿ÑƒÑ›ÐµÐ½',0),(332037,9224,'vi','Email tá»›i',0),(332038,9224,'af','geE-pos Aan',0),(332039,9224,'ro','Prin e-mail la',0),(332040,9224,'et','Meilitsi',0),(332041,9224,'si','Po e-poÅ¡ti',0),(332042,9224,'ba','Diemail ke',0),(332043,9224,'nl','Per e-mail naar',0),(332044,9224,'fi','SÃ¤hkÃ¶postitse',0),(332045,9224,'no','Sendt til',0),(332046,9224,'da','E-mailes til',0),(332047,9224,'ko','ì´ë©”ì¼ë¡œ ì „ì†¡',0),(332048,9224,'he','× ×©×œ×— ×‘×“×•×\"×œ ××œ',0),(332049,9224,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ ÏƒÎµ',0),(332050,9224,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€ç»™\r\n',0),(332051,9224,'sv','Mailade till',0),(332052,9224,'it','Inviato via email a',0),(332053,9224,'tl','',0),(332054,9224,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3606;&#3638;&#3591;',0),(332055,9224,'hi','à¤•à¥‹ à¤ˆà¤®à¥‡à¤² à¤•à¤° à¤¦à¥€',0),(332056,9224,'ms','Melalui e-mel kepada',0),(332057,9224,'ar','Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¥Ù„Ù‰',0),(332058,9224,'fr','Evoyer a',0),(332059,9224,'jp','ãƒ¡ãƒ¼ãƒ«ã§é€ä¿¡',0),(332060,9224,'pt','Enviado por email para',0),(332061,9224,'ru','ÐŸÐ¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(332062,9224,'es','Mandado por Email A',0),(332063,9224,'de','Per e-Mail an',0),(332064,9224,'en','Emailed To',0),(332065,9225,'is','',0),(332066,9225,'dr','Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ',0),(332067,9225,'pr','Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ',0),(332068,9225,'tr','Anket',0),(332069,9225,'pl','Badanie',0),(332070,9225,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(332071,9225,'ur','Ø³Ø±ÙˆÛ’',0),(332072,9225,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(332073,9225,'vi','Kháº£o SÃ¡t',0),(332074,9225,'af','Opname',0),(332075,9225,'ro','Sondaj',0),(332076,9225,'et','KÃ¼sitlus',0),(332077,9225,'si','Raziskava',0),(332078,9225,'ba','Survei',0),(332079,9225,'nl','EnquÃªte',0),(332080,9225,'fi','Tutkimus',0),(332081,9225,'no','UndersÃ¸kelse',0),(332082,9225,'da','UndersÃ¸gelse',0),(332083,9225,'ko','ì„¤ë¬¸ ì¡°ì‚¬',0),(332084,9225,'he','×¡×§×¨',0),(332085,9225,'el','ÎˆÏÎµÏ…Î½Î±',0),(332086,9225,'zh','è°ƒæŸ¥\r\n',0),(332087,9225,'sv','UndersÃ¶kning',0),(332088,9225,'it','Sondaggio',0),(332089,9225,'tl','',0),(332090,9225,'th','&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(332091,9225,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£',0),(332092,9225,'ms','Kaji selidik',0),(332093,9225,'ar','Ø¥Ø³ØªØ¨ÙŠØ§Ù†',0),(332094,9225,'fr','Sondage',0),(332095,9225,'jp','èª¿æŸ»',0),(332096,9225,'pt','Pesquisa',0),(332097,9225,'ru','ÐžÐ¿Ñ€Ð¾Ñ',0),(332098,9225,'es','Estudio',0),(332099,9225,'de','Umfrage',0),(332100,9225,'en','Survey',0),(332101,9226,'is','',0),(332102,9226,'dr','Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯ ',0),(332103,9226,'pr','Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯ ',0),(332104,9226,'tr','E-postayla gÃ¶nderilen anket',0),(332105,9226,'pl','Ankiety e-mailem',0),(332106,9226,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ ÐµÐ¼Ð°Ð¹Ð»',0),(332107,9226,'ur','Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© Ø³Ø±ÙˆÛ’',0),(332108,9226,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð»',0),(332109,9226,'vi','Kháº£o sÃ¡t Ä‘Ã£ Email',0),(332110,9226,'af','Opname versend per E-pos',0),(332111,9226,'ro','Sondaj prin E-mail',0),(332112,9226,'et','KÃ¼sitlus edastatud e-postiga',0),(332113,9226,'si','Raziskava po e-poÅ¡ti',0),(332114,9226,'ba','Survei diemail',0),(332115,9226,'nl','EnquÃªte e-mailde',0),(332116,9226,'fi','Kyselyn sÃ¤hkÃ¶postitse',0),(332117,9226,'no','UndersÃ¸kelsen sendt',0),(332118,9226,'da','UndersÃ¸gelsen mailede',0),(332119,9226,'ko','ì´ë©”ì¼ë¡œ ì„¤ë¬¸ ì¡°ì‚¬',0),(332120,9226,'he','×¡×§×¨ ×‘×“×•×',0),(332121,9226,'el','ÎˆÏÎµÏ…Î½Î± Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(332122,9226,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€çš„è°ƒæŸ¥\r\n',0),(332123,9226,'sv','UndersÃ¶kning mailade',0),(332124,9226,'it','Sondaggio inviato via email',0),(332125,9226,'tl','',0),(332126,9226,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(332127,9226,'hi','à¤ˆà¤®à¥‡à¤² à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£',0),(332128,9226,'ms','Kaji selidik melalui e-mel',0),(332129,9226,'ar','Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¡ Ø¨Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(332130,9226,'fr','EnquÃªte par courriel',0),(332131,9226,'jp','ã‚¢ãƒ³ã‚±ãƒ¼ãƒˆã‚’ãƒ¡ãƒ¼ãƒ«ã§é€ä¿¡',0),(332132,9226,'pt','Pesquisa por E-mail',0),(332133,9226,'ru','ÐžÐ±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(332134,9226,'es','Estudio Enviado por Email',0),(332135,9226,'de','Umfrage per E-Mail',0),(332136,9226,'en','Survey Emailed',0),(332137,9227,'is','',0),(332138,9227,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ ',0),(332139,9227,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ ',0),(332140,9227,'tr','Anket isteÄŸi',0),(332141,9227,'pl','Badanie wniosku',0),(332142,9227,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð·Ð°ÑÐ²ÐºÐ°',0),(332143,9227,'ur','Ø³Ø±ÙˆÛ’ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(332144,9227,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(332145,9227,'vi','YÃªu cáº§u kháº£o sÃ¡t',0),(332146,9227,'af','Opname Versoek',0),(332147,9227,'ro','Cerere de sondaj',0),(332148,9227,'et','Uuringu taotluse',0),(332149,9227,'si','Raziskava zahtevo',0),(332150,9227,'ba','Survei permintaan',0),(332151,9227,'nl','EnquÃªte verzoek',0),(332152,9227,'fi','Tutkimus pyynnÃ¶n',0),(332153,9227,'no','UndersÃ¸kelsen forespÃ¸rsel',0),(332154,9227,'da','UndersÃ¸gelse anmodning',0),(332155,9227,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ìš”ì²­',0),(332156,9227,'he','×¡×§×¨ ×‘×§×©×”',0),(332157,9227,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î­ÏÎµÏ…Î½Î±Ï‚',0),(332158,9227,'zh','è°ƒæŸ¥è¯·æ±‚\r\n',0),(332159,9227,'sv','UndersÃ¶kning begÃ¤ran',0),(332160,9227,'it','Richiesta di indagine',0),(332161,9227,'tl','',0),(332162,9227,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(332163,9227,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(332164,9227,'ms','Permintaan Ukur',0),(332165,9227,'ar','Ø·Ù„Ø¨ Ù…Ø³Ø­',0),(332166,9227,'fr','Demande d\'enquÃªte',0),(332167,9227,'jp','èª¿æŸ»ä¾é ¼',0),(332168,9227,'pt','Pedido de levantamento',0),(332169,9227,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ ÐžÐ±Ð·Ð¾Ñ€',0),(332170,9227,'es','SolicitaciÃ³n para un Estudio',0),(332171,9227,'de','Umfrage-Anfrage',0),(332172,9227,'en','Survey Request',0),(332173,9228,'is','',0),(332174,9228,'dr','(Ø¨Ø±Ø±Ø³ÙŠ)  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(332175,9228,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ (Ø¨Ø±Ø±Ø³ÙŠ)  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(332176,9228,'tr','Bu anketi silmek istediÄŸinizden emin misiniz?',0),(332177,9228,'pl','Czy na pewno chcesz usunÄ…Ä‡ tego badania?',0),(332178,9228,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ‚Ð¾Ð²Ð° Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ?',0),(332179,9228,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ÛŒÛ Ø³Ø±ÙˆÛ’ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(332180,9228,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð±Ñ€Ð¸ÑˆÐµÑ‚Ðµ Ð¾Ð²Ñƒ Ð°Ð½ÐºÐµÑ‚Ñƒ?',0),(332181,9228,'vi','XÃ³a kháº£o sÃ¡t nÃ y?',0),(332182,9228,'af','Is u seker u wil hierdie opname skrap?',0),(332183,9228,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ ÅŸtergeÅ£i acest sondaj?',0),(332184,9228,'et','Oled kindel, et soovid selle kÃ¼sitluse kustutada?',0),(332185,9228,'si','Ali ste prepriÄani, da Å¾elite izbrisati ta raziskava?',0),(332186,9228,'ba','Apakah Anda yakin Anda ingin menghapus survei ini?',0),(332187,9228,'nl','Weet u zeker dat u wilt verwijderen van deze enquÃªte?',0),(332188,9228,'fi','Oletko varma, ettÃ¤ haluat poistaa tÃ¤mÃ¤n kyselyn?',0),(332189,9228,'no','Er du sikker pÃ¥ at du vil slette denne undersÃ¸kelsen?',0),(332190,9228,'da','Er du sikker pÃ¥ du vil slette denne undersÃ¸gelse?',0),(332191,9228,'ko','ë‹¹ì‹ ì€ì´ ì„¤ë¬¸ ì¡°ì‚¬ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(332192,9228,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ××ª ×”×¡×§×¨ ×”×–×”?',0),(332193,9228,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î­ÏÎµÏ…Î½Î±;',0),(332194,9228,'zh','ä½ ç¡®å®šè¦åˆ é™¤è¿™ä¸ªè°ƒæŸ¥å—ï¼Ÿ\r\n',0),(332195,9228,'sv','Ã„r du sÃ¤ker du vill ta bort denna undersÃ¶kning?',0),(332196,9228,'it','Sei sicuro di che voler eliminare questo sondaggio?',0),(332197,9228,'tl','',0),(332198,9228,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3609;&#3',0),(332199,9228,'hi','à¤¤à¥à¤®à¥à¤¹à¥‡à¤‚ à¤¯à¤•à¥€à¤¨ à¤¹à¥ˆ à¤•à¤¿ à¤¤à¥à¤® à¤‡à¤¸ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(332200,9228,'ms','Adakah anda pasti anda mahu menghapuskan kaji selidik ini?',0),(332201,9228,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¥Ù„ØºØ§Ø¡ Ù‡Ø°Ø§ Ø§Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù† ØŸ',0),(332202,9228,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer ce sondage ?',0),(332203,9228,'jp','ã“ã®ã‚¢ãƒ³ã‚±ãƒ¼ãƒˆã®å‰Šé™¤ã—ã¦ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(332204,9228,'pt','Tem certeza que deseja excluir esta pesquisa?',0),(332205,9228,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¾Ð¿Ñ€Ð¾Ñ?',0),(332206,9228,'es','Esta seguro que quiere eliminar este estudio',0),(332207,9228,'de','Bist du sicher, dass Sie diese Umfrage lÃ¶schen mÃ¶chten?',0),(332208,9228,'en','Are you sure you want to delete this survey?',0),(332209,9229,'is','',0),(332210,9229,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù…ØªÙ† Ø§ÙŠÙ…ÙŠÙ„  ',0),(332211,9229,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù…ØªÙ† Ø§ÙŠÙ…ÙŠÙ„  ',0),(332212,9229,'tr','VarsayÄ±lan e-posta metni',0),(332213,9229,'pl','DomyÅ›lnie tekst wiadomoÅ›ci',0),(332214,9229,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð¼ÐµÐ¹Ð» Ñ‚ÐµÐºÑÑ‚',0),(332215,9229,'ur','Ø·Û’ Ø´Ø¯Û Ø§ÛŒ Ù…ÛŒÙ„ Ù…ØªÙ†',0),(332216,9229,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ñ‚ÐµÐºÑÑ‚ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(332217,9229,'vi','Ná»™i dung Email máº·c Ä‘á»‹nh',0),(332218,9229,'af','Verstekte E-pos Teks',0),(332219,9229,'ro','Textul de Email implicit',0),(332220,9229,'et','Vaikimisi e-kirja tekst',0),(332221,9229,'si','Privzeto besedilo e-poÅ¡te',0),(332222,9229,'ba','Teks Email standar',0),(332223,9229,'nl','Standaard E-mail tekst',0),(332224,9229,'fi','SÃ¤hkÃ¶posti oletusteksti',0),(332225,9229,'no','Standardteksten for e-post',0),(332226,9229,'da','Standard E-mail tekst',0),(332227,9229,'ko','ê¸°ë³¸ ì´ë©”ì¼ í…ìŠ¤íŠ¸',0),(332228,9229,'he','×˜×§×¡×˜ ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×”×“×•×',0),(332229,9229,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(332230,9229,'zh','é»˜è®¤çš„ç”µå­é‚®ä»¶æ–‡æœ¬\r\n',0),(332231,9229,'sv','Standard e-Text',0),(332232,9229,'it','Testo Email predefinito',0),(332233,9229,'tl','',0),(332234,9229,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(332235,9229,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤ˆà¤®à¥‡à¤² à¤ªà¤¾à¤ ',0),(332236,9229,'ms','Mesej e-mel lalai',0),(332237,9229,'ar','Ù†Øµ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(332238,9229,'fr','Text du courriel de defaut',0),(332239,9229,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«ã®æ—¢å®šã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(332240,9229,'pt','Texto de E-mail padrÃ£o',0),(332241,9229,'ru','Ð¢ÐµÐºÑÑ‚ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(332242,9229,'es','Texto de Email por Defecto',0),(332243,9229,'de','Standard E-Mail-Text',0),(332244,9229,'en','Default Email Text',0),(332245,9230,'is','',0),(332246,9230,'dr','Ø­Ø°Ù  Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(332247,9230,'pr','Ø­Ø°Ù  Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(332248,9230,'tr','Anket baÅŸarÄ±yla silindi',0),(332249,9230,'pl','Badania przesâ”‚anie',0),(332250,9230,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(332251,9230,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø³Ø±ÙˆÛ’',0),(332252,9230,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(332253,9230,'vi','XÃ³a kháº£o sÃ¡t thÃ nh cÃ´ng',0),(332254,9230,'af','Opname Suksesvol Geskrap',0),(332255,9230,'ro','Sondaj eliminÄƒ cu succes',0),(332256,9230,'et','Ãœlevaatuse edukalt kustutatud',0),(332257,9230,'si','Raziskava uspeÅ¡no izbrisana',0),(332258,9230,'ba','Survei dihapus berhasil',0),(332259,9230,'nl','EnquÃªte met succes verwijderd',0),(332260,9230,'fi','Tutkimus poistettu',0),(332261,9230,'no','UndersÃ¸kelsen ble slettet',0),(332262,9230,'da','UndersÃ¸gelsen slettet',0),(332263,9230,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì„¤ë¬¸ ì¡°ì‚¬',0),(332264,9230,'he','×¡×§×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(332265,9230,'el','ÎˆÏÎµÏ…Î½Î± Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(332266,9230,'zh','è°ƒæŸ¥æˆåŠŸåˆ é™¤\r\n',0),(332267,9230,'sv','UndersÃ¶kning raderades',0),(332268,9230,'it','Sondaggio eliminato con successo',0),(332269,9230,'tl','',0),(332270,9230,'th','&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3606;&#3641;&#3585;&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(332271,9230,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(332272,9230,'ms','Kaji-selidik yang dihapuskan dengan jayanya',0),(332273,9230,'ar','Ø­Ø°Ù Ø§Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù† Ø¨Ù†Ø¬Ø§Ø­',0),(332274,9230,'fr','Sondage supprimÃ© avec succÃ¨s',0),(332275,9230,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸèª¿æŸ»',0),(332276,9230,'pt','Pesquisa apagada com sucesso',0),(332277,9230,'ru','ÐžÐ±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(332278,9230,'es','Estudio Eliminado Exitosamente',0),(332279,9230,'de','Umfrage erfolgreich gelÃ¶scht',0),(332280,9230,'en','Survey Deleted Successfully',0),(332281,9231,'is','',0),(332282,9231,'dr','Ù†ÙˆØ¹ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ',0),(332283,9231,'pr','Ù†ÙˆØ¹ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ',0),(332284,9231,'tr','Liste tÃ¼rÃ¼',0),(332285,9231,'pl','Badania typu',0),(332286,9231,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ Ñ‚Ð¸Ð¿',0),(332287,9231,'ur','Ø³Ø±ÙˆÛ’ Ú©ÛŒ Ù‚Ø³Ù…',0),(332288,9231,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ñ‚Ð¸Ð¿',0),(332289,9231,'vi','Loáº¡i kháº£o sÃ¡t',0),(332290,9231,'af','Opname Tipe',0),(332291,9231,'ro','Sondaj de tip',0),(332292,9231,'et','Uuringu tÃ¼Ã¼p',0),(332293,9231,'si','Vrsta raziskave',0),(332294,9231,'ba','Jenis survei',0),(332295,9231,'nl','EnquÃªte-Type',0),(332296,9231,'fi','Kyselyn tyyppi',0),(332297,9231,'no','UndersÃ¸kelsen Type',0),(332298,9231,'da','UndersÃ¸gelsen Type',0),(332299,9231,'ko','ì¡°ì‚¬ ìœ í˜•',0),(332300,9231,'he','×¡×§×¨ ×¡×•×’',0),(332301,9231,'el','ÎˆÏÎµÏ…Î½Î± Ï„ÏÏ€Î¿Ï…',0),(332302,9231,'zh','è°ƒæŸ¥ç±»åž‹\r\n',0),(332303,9231,'sv','UndersÃ¶kning typ',0),(332304,9231,'it','Tipo di indagine',0),(332305,9231,'tl','',0),(332306,9231,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(332307,9231,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(332308,9231,'ms','Jenis kaji selidik',0),(332309,9231,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù†',0),(332310,9231,'fr','Type de sondage',0),(332311,9231,'jp','èª¿æŸ»ã®ç¨®é¡ž',0),(332312,9231,'pt','Tipo de pesquisa',0),(332313,9231,'ru','Ð¢Ð¸Ð¿ Ð¸ÑÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(332314,9231,'es','Tipo de Estudio',0),(332315,9231,'de','Umfrage-Typ',0),(332316,9231,'en','Survey Type',0),(332317,9232,'is','',0),(332318,9232,'dr','Ù†Ù…Ø§ÙŠØ´ Ù†ØªØ§ÙŠØ¬ ',0),(332319,9232,'pr','Ù†Ù…Ø§ÙŠØ´ Ù†ØªØ§ÙŠØ¬ ',0),(332320,9232,'tr','SonuÃ§larÄ± gÃ¶rÃ¼ntÃ¼le',0),(332321,9232,'pl','Zobacz wyniki',0),(332322,9232,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸Ñ‚Ðµ',0),(332323,9232,'ur','Ù†ØªØ§Ø¦Ø¬ Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(332324,9232,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð°',0),(332325,9232,'vi','Xem káº¿t quáº£',0),(332326,9232,'af','Besigtig Reslutate',0),(332327,9232,'ro','Vezi rezultate',0),(332328,9232,'et','Vaata tulemusi',0),(332329,9232,'si','Ogled rezultatov',0),(332330,9232,'ba','Lihat hasil',0),(332331,9232,'nl','Bekijk resultaten',0),(332332,9232,'fi','NÃ¤ytÃ¤ tulokset',0),(332333,9232,'no','Vis resultater',0),(332334,9232,'da','Se resultater',0),(332335,9232,'ko','ê²°ê³¼ ë³´ê¸°',0),(332336,9232,'he','×”×¦×’ ×ª×•×¦××•×ª',0),(332337,9232,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï„Ï‰Î½ Î±Ï€Î¿Ï„ÎµÎ»ÎµÏƒÎ¼Î¬Ï„Ï‰Î½ Ï„Î·Ï‚',0),(332338,9232,'zh','æŸ¥çœ‹ç»“æžœ\r\n',0),(332339,9232,'sv','Visa resultat',0),(332340,9232,'it','Visualizza i risultati',0),(332341,9232,'tl','',0),(332342,9232,'th','&#3649;&#3626;&#3604;&#3591;&#3612;&#3621;&#3621;&#3633;&#3614;&#3608;&#3660;',0),(332343,9232,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤ªà¤°à¤¿à¤£à¤¾à¤®',0),(332344,9232,'ms','Lihat keputusan',0),(332345,9232,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù†ØªØ§Ø¦Ø¬',0),(332346,9232,'fr','Afficher les rÃ©sultats',0),(332347,9232,'jp','çµæžœã®è¡¨ç¤º',0),(332348,9232,'pt','Ver resultados',0),(332349,9232,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ð¾Ð²',0),(332350,9232,'es','Vistar Resultados',0),(332351,9232,'de','Ergebnisse anzeigen',0),(332352,9232,'en','View Results',0),(332353,9233,'is','',0),(332354,9233,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø§Ø¬Ø±Ø§',0),(332355,9233,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø§Ø¬Ø±Ø§',0),(332356,9233,'tr','Tamamlama kodu',0),(332357,9233,'pl','ZakoÅ„czenie ID',0),(332358,9233,'bg','Ð˜Ð” Ð½Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ',0),(332359,9233,'ur','ØªÚ©Ù…ÛŒÙ„ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(332360,9233,'sr','Ð˜Ð” Ð´Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐ°',0),(332361,9233,'vi','ID hoÃ n thÃ nh',0),(332362,9233,'af','Voltooiing ID',0),(332363,9233,'ro','Finalizarea ID',0),(332364,9233,'et','KÃµnelÃµpetamise ID',0),(332365,9233,'si','ZakljuÄku ID',0),(332366,9233,'ba','Penyelesaian ID',0),(332367,9233,'nl','Voltooiing ID',0),(332368,9233,'fi','PÃ¤Ã¤tÃ¶kseen tunnus',0),(332369,9233,'no','Ferdigstillelse ID',0),(332370,9233,'da','Afslutning-ID',0),(332371,9233,'ko','ì™„ë£Œ ID',0),(332372,9233,'he','×”×©×œ×ž×ª ×–×™×”×•×™',0),(332373,9233,'el','ÎŸÎ»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ· ID',0),(332374,9233,'zh','å®Œæˆç¼–å·\r\n',0),(332375,9233,'sv','Avslutning-ID',0),(332376,9233,'it','Completamento ID',0),(332377,9233,'tl','',0),(332378,9233,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3607;&#3637;&#3656;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(332379,9233,'hi','à¤ªà¥‚à¤°à¥à¤£à¤¤à¤¾ ID',0),(332380,9233,'ms','Siap ID',0),(332381,9233,'ar','Ù…Ø¹Ø±Ù Ø¥ØªÙ…Ø§Ù…',0),(332382,9233,'fr','RÃ©alisation ID',0),(332383,9233,'jp','å®Œäº† ID',0),(332384,9233,'pt','ID de conclusÃ£o',0),(332385,9233,'ru','ÐšÐžÐ” Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ',0),(332386,9233,'es','ID de TerminaciÃ³n',0),(332387,9233,'de','Abschluss-ID',0),(332388,9233,'en','Completion ID',0),(332389,9234,'is','',0),(332390,9234,'dr','ØªØ§Ø±ÙŠØ® ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(332391,9234,'pr','ØªØ§Ø±ÙŠØ® ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(332392,9234,'tr','BaÅŸlama/BitiÅŸ tarihi',0),(332393,9234,'pl','Daty ukoÅ„czenia',0),(332394,9234,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð°',0),(332395,9234,'ur','ØªØ§Ø±ÛŒØ® Ù…Ú©Ù…Ù„',0),(332396,9234,'sr','Ð¡Ð°ÑÑ‚Ð°Ð½Ð°Ðº Ñ˜Ðµ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½',0),(332397,9234,'vi','NgÃ y hoÃ n táº¥t',0),(332398,9234,'af','Datum Gevoltooi',0),(332399,9234,'ro','Data finalizÄƒrii',0),(332400,9234,'et','LÃµpetatud kuupÃ¤ev',0),(332401,9234,'si','Datum izpolnjen',0),(332402,9234,'ba','Tanggal selesai',0),(332403,9234,'nl','Datum voltooid',0),(332404,9234,'fi','Suorittamisesta',0),(332405,9234,'no','Datoen fullfÃ¸rt',0),(332406,9234,'da','Dato udfÃ¸rt',0),(332407,9234,'ko','ì™„ë£Œ ë‚ ì§œ',0),(332408,9234,'he','×ª××¨×™×š ×”×©×œ×ž×”',0),(332409,9234,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(332410,9234,'zh','å®Œæˆæ—¥æœŸ\r\n',0),(332411,9234,'sv','Datum slutfÃ¶rd',0),(332412,9234,'it','Data di completamento',0),(332413,9234,'tl','',0),(332414,9234,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;&#3649;&#3621;&#3657;&#3623;',0),(332415,9234,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(332416,9234,'ms','Tarikh siap',0),(332417,9234,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ù†ØªÙ‡Ø§Ø¡',0),(332418,9234,'fr','Date d\'achÃ¨vement',0),(332419,9234,'jp','çµ‚äº†æ—¥',0),(332420,9234,'pt','Data concluÃ­da',0),(332421,9234,'ru','Ð”Ð°Ñ‚Ð° Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ',0),(332422,9234,'es','Fecha de FinalizaciÃ³n',0),(332423,9234,'de','Datum abgeschlossen',0),(332424,9234,'en','Date Completed',0),(332425,9235,'is','',0),(332426,9235,'dr','Ø´Ù†Ø§Ø³Ù‡ ØªÙƒÙ…ÙŠÙ„ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ',0),(332427,9235,'pr','Ø´Ù†Ø§Ø³Ù‡ ØªÙƒÙ…ÙŠÙ„ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ',0),(332428,9235,'tr','Anketin tamamlanmasÄ± kimliÄŸi',0),(332429,9235,'pl','ID zakoÅ„czenia badania',0),(332430,9235,'bg','Ð˜Ð” Ð½Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·ÑÐ»ÐµÐ´Ð²Ð°Ð½ÐµÑ‚Ð¾',0),(332431,9235,'ur','Ø³Ø±ÙˆÛ’ Ú©ÛŒ ØªÚ©Ù…ÛŒÙ„ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(332432,9235,'sr','Ð˜Ð” Ð´Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐ° Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(332433,9235,'vi','ID kháº£o sÃ¡t thÃ nh cÃ´ng',0),(332434,9235,'af','Opname Voltooide ID',0),(332435,9235,'ro','ID de finalizarea anchetei',0),(332436,9235,'et','Uuringu lÃµpuleviimine ID',0),(332437,9235,'si','Raziskava zakljuÄku ID',0),(332438,9235,'ba','Survei penyelesaian ID',0),(332439,9235,'nl','EnquÃªte voltooiing ID',0),(332440,9235,'fi','Tutkimuksen loppuun tunnus',0),(332441,9235,'no','UndersÃ¸kelsen ferdigstillelse ID',0),(332442,9235,'da','UndersÃ¸gelsen afsluttet-ID',0),(332443,9235,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ì™„ë£Œ ID',0),(332444,9235,'he','×ž×¡×¤×¨ ×¡×™×•× ×”×¡×§×¨',0),(332445,9235,'el','ÎˆÏÎµÏ…Î½Î± Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ· ID',0),(332446,9235,'zh','è°ƒæŸ¥å®ŒæˆID\r\n',0),(332447,9235,'sv','UndersÃ¶kningen slutfÃ¶rts ID',0),(332448,9235,'it','Sondaggio completamento ID',0),(332449,9235,'tl','',0),(332450,9235,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3607;&#3637;&#3656;&#3648;&#3626;&#3619;&#3655;&#3592;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(332451,9235,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤ªà¥‚à¤°à¥à¤£à¤¤à¤¾ ID',0),(332452,9235,'ms','Kaji selidik siap ID',0),(332453,9235,'ar','Ù…Ø¹Ø±Ù Ø¥ØªÙ…Ø§Ù… Ø§Ù„Ø¯Ø±Ø§Ø³Ø© Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¦ÙŠØ©',0),(332454,9235,'fr','Sondage achÃ¨vement ID',0),(332455,9235,'jp','èª¿æŸ»å®Œäº† ID',0),(332456,9235,'pt','ID de conclusÃ£o do inquÃ©rito',0),(332457,9235,'ru','ÐžÐ¿Ñ€Ð¾Ñ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ ID',0),(332458,9235,'es','ID de TerminaciÃ³n del Estudio',0),(332459,9235,'de','Umfrage-Abschluss-ID',0),(332460,9235,'en','Survey Completion ID',0),(332461,9236,'is','',0),(332462,9236,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ',0),(332463,9236,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ',0),(332464,9236,'tr','YÃ¼zey araÅŸtÄ±rma raporlarÄ±',0),(332465,9236,'pl','Badanie sprawozdania',0),(332466,9236,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(332467,9236,'ur','Ø³Ø±ÙˆÛ’ Ø±Ù¾ÙˆØ±Ù¹',0),(332468,9236,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(332469,9236,'vi','BÃ¡o cÃ¡o kháº£o sÃ¡t',0),(332470,9236,'af','Opname Verslae',0),(332471,9236,'ro','Rapoartelor de expertizÄƒ',0),(332472,9236,'et','Uuringu aruanded',0),(332473,9236,'si','Pregled poroÄil',0),(332474,9236,'ba','Survei',0),(332475,9236,'nl','EnquÃªterapportages',0),(332476,9236,'fi','Tutkimusraportit',0),(332477,9236,'no','UndersÃ¸kelsen rapporter',0),(332478,9236,'da','UndersÃ¸gelse rapporter',0),(332479,9236,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ë³´ê³ ì„œ',0),(332480,9236,'he','×“×•×—×•×ª ×¡×§×¨',0),(332481,9236,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¿Î³Î½Ï‰Î¼Î¿ÏƒÏÎ½ÎµÏ‚',0),(332482,9236,'zh','è°ƒæŸ¥æŠ¥å‘Š\r\n',0),(332483,9236,'sv','UndersÃ¶kning rapporter',0),(332484,9236,'it','Rapporti di indagine',0),(332485,9236,'tl','',0),(332486,9236,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(332487,9236,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥‡à¤‚',0),(332488,9236,'ms','Laporan kaji selidik',0),(332489,9236,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù†Ø§Øª',0),(332490,9236,'fr','Rapports d\'Ã©tudes',0),(332491,9236,'jp','èª¿æŸ»å ±å‘Šæ›¸',0),(332492,9236,'pt','RelatÃ³rios de pesquisa',0),(332493,9236,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¾Ð²',0),(332494,9236,'es','Informes de Estudios',0),(332495,9236,'de','Berichte der',0),(332496,9236,'en','Survey Reports',0),(332497,9237,'is','',0),(332498,9237,'dr','ÙƒÙ„ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù‡Ø§ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(332499,9237,'pr','ÙƒÙ„ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù‡Ø§ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(332500,9237,'tr','Toplam yÃ¼zey araÅŸtÄ±rmasÄ± tamamlandÄ±',0),(332501,9237,'pl','CaÅ‚kowita badania zakoÅ„czone',0),(332502,9237,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ð¸Ñ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½',0),(332503,9237,'ur','Ú©Ù„ Ø³Ø±ÙˆÛ’ Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§',0),(332504,9237,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð°',0),(332505,9237,'vi','Táº¥t cáº£ kháº£o sÃ¡t hoÃ n táº¥t',0),(332506,9237,'af','Totale Opnames Voltooi',0),(332507,9237,'ro','Total anchetelor finalizate',0),(332508,9237,'et','Kokku uuringute lÃµpule',0),(332509,9237,'si','Skupne raziskave zakljuÄili',0),(332510,9237,'ba','Total survei selesai',0),(332511,9237,'nl','Totale enquÃªtes voltooid',0),(332512,9237,'fi','YhteensÃ¤ tutkimukset pÃ¤Ã¤tÃ¶kseen',0),(332513,9237,'no','Totalt undersÃ¸kelser fullfÃ¸rt',0),(332514,9237,'da','Samlede undersÃ¸gelser afsluttet',0),(332515,9237,'ko','ì´ ì„¤ë¬¸ ì¡°ì‚¬ ì™„ë£Œ',0),(332516,9237,'he','×¡×” ×› ×”×¡×§×¨×™×',0),(332517,9237,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Î­ÏÎµÏ…Î½ÎµÏ‚ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(332518,9237,'zh','å·²å®Œæˆæ€»è°ƒæŸ¥\r\n',0),(332519,9237,'sv','Totala undersÃ¶kningar avslutade',0),(332520,9237,'it','Totale sondaggi completati',0),(332521,9237,'tl','',0),(332522,9237,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3607;&#3637;&#3656;&#3626;&#3617;&#3610;&#3641;&#3619;&#3603;&#3660;',0),(332523,9237,'hi','à¤•à¥à¤² à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤—à¤¯à¤¾',0),(332524,9237,'ms','Jumlah Ukur yang siap',0),(332525,9237,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø¯Ø±Ø§Ø³Ø§Øª Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¦ÙŠØ© Ø§Ù„ØªÙŠ Ø£Ù†Ø¬Ø²Øª',0),(332526,9237,'fr','Totales sondages remplis',0),(332527,9237,'jp','å®Œäº†ã™ã‚‹ç·èª¿æŸ»',0),(332528,9237,'pt','Totais inquÃ©ritos concluÃ­dos',0),(332529,9237,'ru','Ð’ÑÐµÐ³Ð¾ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ð¹ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¾',0),(332530,9237,'es','Todos los Estudios Finalizaron',0),(332531,9237,'de','Total Umfragen abgeschlossen',0),(332532,9237,'en','Total Surveys Completed',0),(332533,9238,'is','',0),(332534,9238,'dr','(Ù†ÙˆØ´ØªÙ†) Ù†Ù…Ø¨Ø± ',0),(332535,9238,'pr','Ù†ÙˆØ¹(Ù†ÙˆØ´ØªÙ†) Ø´Ù†Ø§Ø³Ù‡ ',0),(332536,9238,'tr','TÃ¼r kodu',0),(332537,9238,'pl','Identyfikator typu',0),(332538,9238,'bg','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð½Ð° Ñ‚Ð¸Ð¿',0),(332539,9238,'ur','Ù‚Ø³Ù… Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(332540,9238,'sr','Ð’Ñ€ÑÑ‚Ð° Ð˜Ð”',0),(332541,9238,'vi','ID Loáº¡i',0),(332542,9238,'af','Tipe ID',0),(332543,9238,'ro','Tip ID',0),(332544,9238,'et','TÃ¼Ã¼bi ID',0),(332545,9238,'si','ID vrste',0),(332546,9238,'ba','Jenis ID',0),(332547,9238,'nl','Type-ID',0),(332548,9238,'fi','Lajin tunnus',0),(332549,9238,'no','Type-ID',0),(332550,9238,'da','Type-ID',0),(332551,9238,'ko','ìœ í˜• ID',0),(332552,9238,'he','×ž×–×”×” ×¡×•×’',0),(332553,9238,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï„ÏÏ€Î¿Ï…',0),(332554,9238,'zh','ç±»åž‹å¸å·\r\n',0),(332555,9238,'sv','Typ-ID',0),(332556,9238,'it','Tipo ID',0),(332557,9238,'tl','',0),(332558,9238,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(332559,9238,'hi','à¤ªà¥à¤°à¤•à¤¾à¤° ID',0),(332560,9238,'ms','Jenis ID',0),(332561,9238,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù†ÙˆØ¹',0),(332562,9238,'fr','ID de type',0),(332563,9238,'jp','ã‚¿ã‚¤ãƒ— ID',0),(332564,9238,'pt','ID do tipo',0),(332565,9238,'ru','Ð¢Ð¸Ð¿ ID',0),(332566,9238,'es','Escribe ID',0),(332567,9238,'de','Typ ID',0),(332568,9238,'en','Type ID',0),(332569,9239,'is','',0),(332570,9239,'dr','Ù†Ù…Ø§ÙŠØ´ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ ',0),(332571,9239,'pr','Ù†Ù…Ø§ÙŠØ´ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ ',0),(332572,9239,'tr','View Anket',0),(332573,9239,'pl','Widok badania',0),(332574,9239,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¸Ð·ÑÐ»ÐµÐ´Ð²Ð°Ð½ÐµÑ‚Ð¾',0),(332575,9239,'ur','Ù…Ù†Ø¸Ø± Ø³Ø±ÙˆÛ’',0),(332576,9239,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð°Ð½ÐºÐµÑ‚Ðµ',0),(332577,9239,'vi','Xem kháº£o sÃ¡t',0),(332578,9239,'af','Besigtig Opname',0),(332579,9239,'ro','Vezi Sondaj',0),(332580,9239,'et','Vaata kÃ¼sitlust',0),(332581,9239,'si','Pogled ankete',0),(332582,9239,'ba','Lihat survei',0),(332583,9239,'nl','Weergave enquÃªte',0),(332584,9239,'fi','NÃ¤ytÃ¤ Survey',0),(332585,9239,'no','Vis undersÃ¸kelse',0),(332586,9239,'da','Se undersÃ¸gelse',0),(332587,9239,'ko','ë³´ê¸° ì„¤ë¬¸ ì¡°ì‚¬',0),(332588,9239,'he','×¡×§×¨ × ×•×£',0),(332589,9239,'el','Î ÏÎ¿Î²Î¿Î»Î® Î­ÏÎµÏ…Î½Î±',0),(332590,9239,'zh','æŸ¥çœ‹è°ƒæŸ¥\r\n',0),(332591,9239,'sv','Visa undersÃ¶kning',0),(332592,9239,'it','Indagine di visualizzazione',0),(332593,9239,'tl','',0),(332594,9239,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(332595,9239,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£',0),(332596,9239,'ms','Kaji selidik pandangan',0),(332597,9239,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù†',0),(332598,9239,'fr','Sondage d\'opinion',0),(332599,9239,'jp','ãƒ“ãƒ¥ãƒ¼èª¿æŸ»',0),(332600,9239,'pt','Pesquisa de opiniÃ£o',0),(332601,9239,'ru','Ð’Ð¸Ð´ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(332602,9239,'es','Vistar el Estudio',0),(332603,9239,'de','Ansicht-Umfrage',0),(332604,9239,'en','View Survey',0),(332605,9240,'is','',0),(332606,9240,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ',0),(332607,9240,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ ',0),(332608,9240,'tr','E-posta anket',0),(332609,9240,'pl','E badania',0),(332610,9240,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(332611,9240,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø³Ø±ÙˆÛ’',0),(332612,9240,'sr','Ð•Ð¼Ð°Ð¸Ð» Ð°Ð½ÐºÐµÑ‚Ðµ',0),(332613,9240,'vi','Email kháº£o sÃ¡t',0),(332614,9240,'af','E-pos Opname',0),(332615,9240,'ro','E-mail sondaj',0),(332616,9240,'et','E-posti uuring',0),(332617,9240,'si','Raziskava e-poÅ¡te',0),(332618,9240,'ba','Survei email',0),(332619,9240,'nl','E-mail enquÃªte',0),(332620,9240,'fi','Email Survey',0),(332621,9240,'no','E-undersÃ¸kelse',0),(332622,9240,'da','E-mail-undersÃ¸gelse',0),(332623,9240,'ko','ì´ë©”ì¼ ì„¤ë¬¸ ì¡°ì‚¬',0),(332624,9240,'he','×¡×§×¨ ×“×•××¨ ××œ×§×˜×¨×•× ×™',0),(332625,9240,'el','ÎˆÏÎµÏ…Î½Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(332626,9240,'zh','ç”µå­é‚®ä»¶è°ƒæŸ¥\r\n',0),(332627,9240,'sv','E-undersÃ¶kning',0),(332628,9240,'it','Sondaggio e-mail',0),(332629,9240,'tl','',0),(332630,9240,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(332631,9240,'hi','à¤ˆà¤®à¥‡à¤² à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£',0),(332632,9240,'ms','Kajian e-mel',0),(332633,9240,'ar','Ù…Ø³Ø­ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(332634,9240,'fr','EnquÃªte par courriel',0),(332635,9240,'jp','E ãƒ¡ãƒ¼ãƒ«èª¿æŸ»',0),(332636,9240,'pt','Pesquisa e-mail',0),(332637,9240,'ru','ÐžÐ±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(332638,9240,'es','Encuesta o Estudio por Email',0),(332639,9240,'de','E-Mail-Umfrage',0),(332640,9240,'en','Email Survey',0),(332641,9241,'is','',0),(332642,9241,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ',0),(332643,9241,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ',0),(332644,9241,'tr','Anket seÃ§in',0),(332645,9241,'pl','Wybierz badania',0),(332646,9241,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(332647,9241,'ur','Ø³Ø±ÙˆÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(332648,9241,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸ Ð°Ð½ÐºÐµÑ‚Ñƒ',0),(332649,9241,'vi','Chá»n kháº£o sÃ¡t',0),(332650,9241,'af','Kies Opname',0),(332651,9241,'ro','SelectaÅ£i sondaj',0),(332652,9241,'et','Vali kÃ¼sitlus',0),(332653,9241,'si','Izberite anketo',0),(332654,9241,'ba','Memilih Survey',0),(332655,9241,'nl','Selecteer enquÃªte',0),(332656,9241,'fi','Valitse kysely',0),(332657,9241,'no','Velg undersÃ¸kelse',0),(332658,9241,'da','VÃ¦lg undersÃ¸gelse',0),(332659,9241,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ì„ íƒ',0),(332660,9241,'he','×‘×—×¨ ×¡×§×¨',0),(332661,9241,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ Î­ÏÎµÏ…Î½Î±',0),(332662,9241,'zh','é€‰æ‹©è°ƒæŸ¥\r\n',0),(332663,9241,'sv','VÃ¤lj undersÃ¶kning',0),(332664,9241,'it','Seleziona il sondaggio',0),(332665,9241,'tl','',0),(332666,9241,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(332667,9241,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(332668,9241,'ms','Pilih kaji selidik',0),(332669,9241,'ar','Ø­Ø¯Ø¯ Ù…Ø³Ø­',0),(332670,9241,'fr','SÃ©lectionnez Survey',0),(332671,9241,'jp','èª¿æŸ»ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(332672,9241,'pt','Selecione a pesquisa',0),(332673,9241,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿Ñ€Ð¾Ñ',0),(332674,9241,'es','Seleccionar Estudio',0),(332675,9241,'de','WÃ¤hlen Sie die Umfrage',0),(332676,9241,'en','Select Survey',0),(332677,9242,'is','',0),(332678,9242,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ù…Ø´ØªØ±ÙŠØ§Ù† ',0),(332679,9242,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ù…Ø´ØªØ±ÙŠØ§Ù† ',0),(332680,9242,'tr','MÃ¼ÅŸteri Ã¶demeleri iÃ§in varsayÄ±lan onay hesabÄ±',0),(332681,9242,'pl','Wyboru domyÅ›lnego konta dla pÅ‚atnoÅ›ci klienta',0),(332682,9242,'bg','Ð§ÐµÐº Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(332683,9242,'ur','Ú©Ù„Ø§Ø¦Ù†Ù¹ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û Ú†ÛŒÚ© Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(332684,9242,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(332685,9242,'vi','TK SÃ©c Thanh ToÃ¡n Cá»§a KhÃ¡ch HÃ ng Máº·c Äá»‹nh',0),(332686,9242,'af','Verstekte Kontrolerekening vir KliÃ«nt / Klant Betalings',0),(332687,9242,'ro','Cont de verificare implicit pentru Client plÄƒÅ£i',0),(332688,9242,'et','Kliendi maksed sisse vaikekonto',0),(332689,9242,'si','Privzeto preveriti raÄun za plaÄila odjemalec',0),(332690,9242,'ba','Akun bawaan Check untuk klien pembayaran',0),(332691,9242,'nl','Selectievakje standaardaccount voor Client betalingen',0),(332692,9242,'fi','Uloskirjautuminen oletustili asiakkaan maksut',0),(332693,9242,'no','Sjekk standardkontoen for klienten betalinger',0),(332694,9242,'da','Standard Check konto for klienten betalinger',0),(332695,9242,'ko','ê¸°ë³¸ ì²´í¬ ê³„ì • í´ë¼ì´ì–¸íŠ¸ ê²°ì œ',0),(332696,9242,'he','×—×©×‘×•×Ÿ ×”×¡×™×ž×•×Ÿ ×”×ž×•×’×“×¨ ×›×‘×¨×™×¨×ª ×ž×—×“×œ ×¢×‘×•×¨ ×ª×©×œ×•×ž×™ ×œ×§×•×—',0),(332697,9242,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(332698,9242,'zh','é»˜è®¤ä¸ºå®¢æˆ·ä»˜æ¬¾æ”¯ç¥¨è´¦æˆ·\r\n',0),(332699,9242,'sv','Kontrollera standardkontot fÃ¶r klienten betalningar',0),(332700,9242,'it','Account predefinito di controllo per i pagamenti del cliente',0),(332701,9242,'tl','',0),(332702,9242,'th','&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3',0),(332703,9242,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤šà¥‡à¤• à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤',0),(332704,9242,'ms','Lalai Daftar akaun bagi pembayaran pelanggan',0),(332705,9242,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(332706,9242,'fr','Compte chÃ¨que par dÃ©faut pour les paiements du Client',0),(332707,9242,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆã®æ”¯æ‰•ã„ã®ãŸã‚ã®æ—¢å®šã®ãƒã‚§ãƒƒã‚¯ ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(332708,9242,'pt','Conta de seleÃ§Ã£o padrÃ£o para pagamentos do cliente',0),(332709,9242,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(332710,9242,'es','Cuenta de Cheques por Defecto para Pagos de Clientes',0),(332711,9242,'de','Check Standardkonto fÃ¼r Client Zahlungen',0),(332712,9242,'en','Default Check Account for Client Payments',0),(332713,9243,'is','',0),(332714,9243,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(332715,9243,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(332716,9243,'tr','Proje VarsayÄ±lanlarÄ±',0),(332717,9243,'pl','Projekt wartoÅ›ci domyÅ›lne',0),(332718,9243,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(332719,9243,'ur','Ù…Ù†ØµÙˆØ¨Û Ø·Û’ Ø´Ø¯Û',0),(332720,9243,'sr','ÐŸÑ€Ð¾Ñ˜ÐµÐºÑ‚Ð¾Ð¼ Ð·Ð°Ð´Ð°Ð½Ðµ Ð²Ñ€Ð¸Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(332721,9243,'vi','Dá»± Ã¡n máº·c Ä‘á»‹nh',0),(332722,9243,'af','Projek Verstektes',0),(332723,9243,'ro','Proiect implicite',0),(332724,9243,'et','Projekti vaikesÃ¤tted',0),(332725,9243,'si','Projekt neplaÄil',0),(332726,9243,'ba','Proyek default',0),(332727,9243,'nl','Project standaard',0),(332728,9243,'fi','Hankkeen oletukset',0),(332729,9243,'no','Project Standard',0),(332730,9243,'da','Project Standard',0),(332731,9243,'ko','í”„ë¡œì íŠ¸ ê¸°ë³¸ê°’',0),(332732,9243,'he','×‘×¨×™×¨×•×ª ×ž×—×“×œ ×‘×¤×¨×•×™×™×§×˜',0),(332733,9243,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Ï„Î¿Ï… Î­ÏÎ³Î¿Ï…',0),(332734,9243,'zh','é¡¹ç›®é»˜è®¤\r\n',0),(332735,9243,'sv','Projektet Defaults',0),(332736,9243,'it','Impostazioni predefinite del progetto',0),(332737,9243,'tl','',0),(332738,9243,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(332739,9243,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤šà¥‚à¤•',0),(332740,9243,'ms','Projek lalai',0),(332741,9243,'ar','Ø§ÙØªØ±Ø§Ø¶ÙŠØ§Øª Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(332742,9243,'fr','Valeurs par dÃ©faut du projet',0),(332743,9243,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®æ—¢å®šå€¤',0),(332744,9243,'pt','PadrÃµes de projeto',0),(332745,9243,'ru','ÐŸÑ€Ð¾ÐµÐºÑ‚Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(332746,9243,'es','Opciones de Proyecto por Defecto',0),(332747,9243,'de','Projektstandards',0),(332748,9243,'en','Project Defaults',0),(332749,9244,'is','',0),(332750,9244,'dr','Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ù‡Ø§',0),(332751,9244,'pr','Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ù‡Ø§',0),(332752,9244,'tr','Anketler',0),(332753,9244,'pl','Badania',0),(332754,9244,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ð¸Ñ',0),(332755,9244,'ur','Ø³Ø±ÙˆÛ’',0),(332756,9244,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(332757,9244,'vi','Kháº£o SÃ¡t',0),(332758,9244,'af','Opnames',0),(332759,9244,'ro','Sondaje',0),(332760,9244,'et','KÃ¼sitlused',0),(332761,9244,'si','Raziskovanj',0),(332762,9244,'ba','Survei',0),(332763,9244,'nl','EnquÃªtes',0),(332764,9244,'fi','Tutkimukset',0),(332765,9244,'no','UndersÃ¸kelser',0),(332766,9244,'da','UndersÃ¸gelser',0),(332767,9244,'ko','ì„¤ë¬¸ ì¡°ì‚¬',0),(332768,9244,'he','×¡×§×¨×™×',0),(332769,9244,'el','ÎˆÏÎµÏ…Î½ÎµÏ‚',0),(332770,9244,'zh','è°ƒæŸ¥\r\n',0),(332771,9244,'sv','UndersÃ¶kningar',0),(332772,9244,'it','Sondaggi',0),(332773,9244,'tl','',0),(332774,9244,'th','&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;',0),(332775,9244,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£',0),(332776,9244,'ms','Kaji selidik',0),(332777,9244,'ar','Ø§Ù„Ø¥Ø³ØªØ¨ÙŠØ§Ù†Ø§Øª',0),(332778,9244,'fr','Sondages',0),(332779,9244,'jp','èª¿æŸ»',0),(332780,9244,'pt','InquÃ©ritos',0),(332781,9244,'ru','ÐžÐ¿Ñ€Ð¾ÑÑ‹',0),(332782,9244,'es','Estudios',0),(332783,9244,'de','Umfragen',0),(332784,9244,'en','Surveys',0),(332785,9245,'is','',0),(332786,9245,'dr','Ú¯Ø±Ø§ÙÙŠÙƒ Ø³Ø± ØµÙØ­Ù‡ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ',0),(332787,9245,'pr','Ú¯Ø±Ø§ÙÙŠÙƒ Ø³Ø± ØµÙØ­Ù‡ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ',0),(332788,9245,'tr','Anket baÅŸlÄ±k grafik',0),(332789,9245,'pl','Badania nagÅ‚Ã³wek graficzny',0),(332790,9245,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ Header Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÐ½',0),(332791,9245,'ur','Ø³Ø±ÙˆÛ’ Ø³Ø±ØªØ­Ø±ÛŒØ± Ú¯Ø±Ø§ÙÛŒ',0),(332792,9245,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(332793,9245,'vi','Kháº£o sÃ¡t Ä‘á»“ há»a tiÃªu Ä‘á»',0),(332794,9245,'af','Opname Koppenend Grafika',0),(332795,9245,'ro','Sondaj antet grafic',0),(332796,9245,'et','Uuringu Header Graphic',0),(332797,9245,'si','Raziskava Header grafiÄno',0),(332798,9245,'ba','Survei Header grafis',0),(332799,9245,'nl','EnquÃªte Header Graphic',0),(332800,9245,'fi','Tutkimuksen otsikon graafinen',0),(332801,9245,'no','UndersÃ¸kelsen Header grafikk',0),(332802,9245,'da','UndersÃ¸gelsen Header grafik',0),(332803,9245,'ko','ì„¤ë¬¸ ì¡°ì‚¬ í—¤ë” ê·¸ëž˜í”½',0),(332804,9245,'he','×’×¨×¤×™×§×” ×œ×›×•×ª×¨×ª ×”×¡×§×¨',0),(332805,9245,'el','ÎˆÏÎµÏ…Î½Î± ÎºÎµÏ†Î±Î»Î¯Î´Î± Î³ÏÎ±Ï†Î¹ÎºÏŽÎ½',0),(332806,9245,'zh','è°ƒæŸ¥å¤´å›¾\r\n',0),(332807,9245,'sv','UndersÃ¶kning Header grafik',0),(332808,9245,'it','Sondaggio intestazione grafica',0),(332809,9245,'tl','',0),(332810,9245,'th','&#3585;&#3634;&#3619;&#3626;&#3635;&#3619;&#3623;&#3592;&#3627;&#3633;&#3623;&#3585;&#3619;&#3634;&#3615;&#3615;&#3636;&#3585;',0),(332811,9245,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤¶à¥€à¤°à¥à¤·à¤• à¤—à¥à¤°à¤¾à¤«à¤¿à¤•',0),(332812,9245,'ms','Kaji selidik Header grafik',0),(332813,9245,'ar','Ù…Ø³Ø­ Ø±Ø£Ø³ Ø¨ÙŠØ§Ù†ÙŠØ©',0),(332814,9245,'fr','Sondage en-tÃªte graphique',0),(332815,9245,'jp','èª¿æŸ»ã®ãƒ˜ãƒƒãƒ€ãƒ¼ ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯',0),(332816,9245,'pt','Pesquisa cabeÃ§alho grÃ¡fico',0),(332817,9245,'ru','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²Ð¾Ðº Ð¾Ð¿Ñ€Ð¾ÑÐ°',0),(332818,9245,'es','GrÃ¡fica Encabecera del Estudio',0),(332819,9245,'de','Umfrage-Header-Grafik',0),(332820,9245,'en','Survey Header Graphic',0),(332821,9246,'is','',0),(332822,9246,'dr',' ÙˆØ¨ Ø³Ø§ÙŠØª Ù…Ø¨Ù†Ø§',0),(332823,9246,'pr',' ÙˆØ¨ Ø³Ø§ÙŠØª Ù…Ø¨Ù†Ø§',0),(332824,9246,'tr','Temel URL',0),(332825,9246,'pl','Podstawowy adres URL',0),(332826,9246,'bg','ÐžÑÐ½Ð¾Ð²Ð° URL',0),(332827,9246,'ur','Ø¨ÛŒØ³ URL',0),(332828,9246,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð¸ Ð£Ð Ð›',0),(332829,9246,'vi','ÄÆ°á»ng dáº«n gá»‘c',0),(332830,9246,'af','Basis BA (\"URL\")',0),(332831,9246,'ro','URL-ul de bazÄƒ',0),(332832,9246,'et','Baas-URL',0),(332833,9246,'si','Osnovni URL',0),(332834,9246,'ba','Base URL',0),(332835,9246,'nl','Basis-URL',0),(332836,9246,'fi','Perus-URL',0),(332837,9246,'no','Basiswebadressen',0),(332838,9246,'da','Base URL',0),(332839,9246,'ko','ê¸°ë³¸ URL',0),(332840,9246,'he','×›×ª×•×‘×ª URL ×‘×¡×™×¡×™×ª',0),(332841,9246,'el','Î¤Î·Ï‚ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·Ï‚ URL Î²Î¬ÏƒÎ·Ï‚',0),(332842,9246,'zh','åŸºæœ¬ç»Ÿä¸€èµ„æºå®šå€å™¨\r\n',0),(332843,9246,'sv','Bas-URL',0),(332844,9246,'it','URL di base',0),(332845,9246,'tl','',0),(332846,9246,'th','&#3600;&#3634;&#3609; URL',0),(332847,9246,'hi','à¤†à¤§à¤¾à¤° URL',0),(332848,9246,'ms','Asas URL',0),(332849,9246,'ar','Ù…Ø­Ø¯Ø¯ Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø£Ø³Ø§Ø³ÙŠ',0),(332850,9246,'fr','URL de base',0),(332851,9246,'jp','ãƒ™ãƒ¼ã‚¹ URL',0),(332852,9246,'pt','URL base',0),(332853,9246,'ru','Ð‘Ð°Ð·Ð¾Ð²Ñ‹Ð¹ URL-Ð°Ð´Ñ€ÐµÑ',0),(332854,9246,'es','URL Base',0),(332855,9246,'de','Basis-URL',0),(332856,9246,'en','Base URL',0),(332857,9247,'is','',0),(332858,9247,'dr','Ø¶Ø±Ø¨ ÙƒØ±Ø¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ',0),(332859,9247,'pr','Ø¶Ø±Ø¨ ÙƒØ±Ø¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨ÙˆØ³ÙŠÙ„Ù‡ ',0),(332860,9247,'tr','Ãœcretleri ile Ã§arpÄ±n',0),(332861,9247,'pl','OpÅ‚aty naleÅ¼y pomnoÅ¼yÄ‡ przez',0),(332862,9247,'bg','Ð£Ð¼Ð½Ð¾Ð¶ÐµÑ‚Ðµ Ñ‚Ð°ÐºÑÐ¸ Ð¾Ñ‚',0),(332863,9247,'ur','Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¶Ø±Ø¨',0),(332864,9247,'sr','ÐœÐ½Ð¾Ð¶ÐµÑšÐµ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ ÐºÐ¾Ñ˜Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ›ÑƒÑ˜Ðµ',0),(332865,9247,'vi','PhÃ­ Ä‘a táº§ng bá»Ÿi',0),(332866,9247,'af','Vermenigvuldig Kostes Per',0),(332867,9247,'ro','Multiplica taxe de',0),(332868,9247,'et','Korruta sÃ¼Ã¼distusest',0),(332869,9247,'si','PomnoÅ¾ite dajatve',0),(332870,9247,'ba','Kalikan biaya oleh',0),(332871,9247,'nl','Kosten door vermenigvuldigen',0),(332872,9247,'fi','Moninkertaistaa maksut',0),(332873,9247,'no','Multipliser kostnader ved',0),(332874,9247,'da','Multiplicer afgifter af',0),(332875,9247,'ko','ê³±í•˜ê¸° ìš”ê¸ˆ',0),(332876,9247,'he','×›×¤×œ ×—×™×•×‘×™× ×¢×œ ×™×“×™',0),(332877,9247,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î¬ÏƒÏ„Îµ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚ ÎµÎ¯Î½Î±Î¹ Î±Î½Î¬Î»Î¿Î³ÎµÏ‚ Î¼Îµ',0),(332878,9247,'zh','æ”¶è´¹ä¹˜ä»¥\r\n',0),(332879,9247,'sv','Multiplicera avgifter av',0),(332880,9247,'it','Moltiplicare le cariche di',0),(332881,9247,'tl','',0),(332882,9247,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3604;&#3657;&#3623;&#3618;',0),(332883,9247,'hi','à¤†à¤°à¥‹à¤ªà¥‹à¤‚ à¤¸à¥‡ à¤—à¥à¤£à¤¾ à¤•à¤°à¥‡à¤‚',0),(332884,9247,'ms','Membiak caj oleh',0),(332885,9247,'ar','Ù…Ø¶Ø§Ø¹ÙØ© Ø±Ø³ÙˆÙ… Ù…Ù† Ù‚Ø¨Ù„',0),(332886,9247,'fr','Multiplier les frais par',0),(332887,9247,'jp','ä¹—ç®—ã®æ–™é‡‘',0),(332888,9247,'pt','Multiplicar as acusaÃ§Ãµes por',0),(332889,9247,'ru','Ð£Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚ÑŒ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ Ð¿Ð¾',0),(332890,9247,'es','Multiplica los Cargos Por',0),(332891,9247,'de','Multiplizieren von GebÃ¼hren',0),(332892,9247,'en','Multiply Charges By',0),(332893,9248,'is','',0),(332894,9248,'dr','ÙØ§ÙƒØªÙˆØ± Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯',0),(332895,9248,'pr','ÙØ§ÙƒØªÙˆØ± Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯',0),(332896,9248,'tr','Fatura e-posta ile',0),(332897,9248,'pl','Faktury e-mailem',0),(332898,9248,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° ÐµÐ¼Ð°Ð¹Ð»',0),(332899,9248,'ur','Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© Ø§Ù†ÙˆØ§Ø¦Ø³',0),(332900,9248,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð»',0),(332901,9248,'vi','HÃ³a Ä‘Æ¡n Ä‘Ã£ gá»­i Email',0),(332902,9248,'af','Faktuur geE-pos',0),(332903,9248,'ro','Factura trimisa pe email',0),(332904,9248,'et','Arve saadetud e-posti teel',0),(332905,9248,'si','RaÄuna po e-poÅ¡ti',0),(332906,9248,'ba','Faktur diemail',0),(332907,9248,'nl','Factuur per E-mail',0),(332908,9248,'fi','Lasku lÃ¤hetetÃ¤Ã¤n',0),(332909,9248,'no','Faktura sendt',0),(332910,9248,'da','Faktura sendt',0),(332911,9248,'ko','ì´ë©”ì¼ ì²­êµ¬ì„œ',0),(332912,9248,'he','×—×©×‘×•× ×™×ª ×‘×“×•××¨ ××œ×§×˜×¨×•× ×™',0),(332913,9248,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(332914,9248,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€å‘ç¥¨\r\n',0),(332915,9248,'sv','Fakturan mailas',0),(332916,9248,'it','Fattura via E-mail',0),(332917,9248,'tl','',0),(332918,9248,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(332919,9248,'hi','à¤ˆà¤®à¥‡à¤² à¤šà¤¾à¤²à¤¾à¤¨',0),(332920,9248,'ms','Invois melalui e-mel',0),(332921,9248,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(332922,9248,'fr','Facture par courriel',0),(332923,9248,'jp','è«‹æ±‚æ›¸ã‚’ãƒ¡ãƒ¼ãƒ«ã§é€ä¿¡',0),(332924,9248,'pt','Fatura por E-mail',0),(332925,9248,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(332926,9248,'es','Factura Enviada por Email',0),(332927,9248,'de','Rechnung per E-Mail',0),(332928,9248,'en','Invoice Emailed',0),(332929,9249,'is','',0),(332930,9249,'dr','Ø³ÙØ§Ø±Ø´ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡ ',0),(332931,9249,'pr','Ø³ÙØ§Ø±Ø´ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡ ',0),(332932,9249,'tr','E-posta ile sipariÅŸ',0),(332933,9249,'pl','ZamÃ³wienie e-mailem',0),(332934,9249,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° ÐµÐ¼Ð°Ð¹Ð»',0),(332935,9249,'ur','Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(332936,9249,'sr','Ð ÐµÐ´ Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð»',0),(332937,9249,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ gá»­i Email',0),(332938,9249,'af','Bestelling gestuur per E-pos',0),(332939,9249,'ro','Comanda prin E-mail',0),(332940,9249,'et','Tellimus e-postiga',0),(332941,9249,'si','NaroÄilo po e-poÅ¡ti',0),(332942,9249,'ba','Pesanan dikirim melalui email',0),(332943,9249,'nl','Bestelling per E-mail',0),(332944,9249,'fi','Tilaa sÃ¤hkÃ¶postitse',0),(332945,9249,'no','Ordren sendt',0),(332946,9249,'da','Ordre sendt',0),(332947,9249,'ko','ì´ë©”ì¼ ì£¼ë¬¸',0),(332948,9249,'he','×”×–×ž× ×” ×‘×“×•×',0),(332949,9249,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(332950,9249,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€è®¢å•\r\n',0),(332951,9249,'sv','BestÃ¤llning via e-post',0),(332952,9249,'it','Ordine via email',0),(332953,9249,'tl','',0),(332954,9249,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(332955,9249,'hi','à¤†à¤¦à¥‡à¤¶ à¤ˆà¤®à¥‡à¤²',0),(332956,9249,'ms','Pesanan melalui e-mel',0),(332957,9249,'ar','Ø£Ù…Ø± Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(332958,9249,'fr','Commande par courriel',0),(332959,9249,'jp','ãƒ¡ãƒ¼ãƒ«ã§æ³¨æ–‡',0),(332960,9249,'pt','Ordem por E-mail',0),(332961,9249,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(332962,9249,'es','Orden Enviado por Email',0),(332963,9249,'de','Bestellung per E-Mail',0),(332964,9249,'en','Order Emailed',0),(332965,9250,'is','',0),(332966,9250,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯ ',0),(332967,9250,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯ ',0),(332968,9250,'tr','E-postayla gÃ¶nderilen alÄ±ntÄ±',0),(332969,9250,'pl','Oferta e-mailem',0),(332970,9250,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° ÐµÐ¼Ð°Ð¹Ð»',0),(332971,9250,'ur','Ø§Ù…ÛŒÙ„Ø§Ø¯ Ø§Ù‚ØªØ¨Ø§Ø³',0),(332972,9250,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ð¿Ð¾ÑˆÑ‚Ð¾Ð¼',0),(332973,9250,'vi','BÃ¡o giÃ¡ Ä‘Ã£ gá»­i Email',0),(332974,9250,'af','Kwotasie geE-pos',0),(332975,9250,'ro','Citat prin E-mail',0),(332976,9250,'et','Tsitaat saadetud',0),(332977,9250,'si','Ponudba e-poÅ¡ti',0),(332978,9250,'ba','Mengutip diemail',0),(332979,9250,'nl','Offerte per E-mail',0),(332980,9250,'fi','Tarjous sÃ¤hkÃ¶postitse',0),(332981,9250,'no','Sitere sendt',0),(332982,9250,'da','Citere sendt',0),(332983,9250,'ko','ì´ë©”ì¼ë¡œ ê²¬ì ',0),(332984,9250,'he','×”×¦×¢×ª ×ž×—×™×¨ ×œ×©×™×¤×•×¥',0),(332985,9250,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ ÎµÏƒÏ„Î¬Î»Î·ÏƒÎ±Î½ Î¼Îµ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(332986,9250,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€æŠ¥ä»·\r\n',0),(332987,9250,'sv','Citera mailade',0),(332988,9250,'it','Preventivo via E-mail',0),(332989,9250,'tl','',0),(332990,9250,'th','&#3649;&#3592;&#3657;&#3591;&#3612;&#3656;&#3634;&#3609;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(332991,9250,'hi','à¤ˆà¤®à¥‡à¤² à¤¬à¥‹à¤²à¥€',0),(332992,9250,'ms','Sebut harga e-melkan',0),(332993,9250,'ar','Ø£Ø±Ø³Ù„ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠ Ø¨Ø§Ù„Ø±Ø¨ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(332994,9250,'fr','Cite par courriel',0),(332995,9250,'jp','ãƒ¡ãƒ¼ãƒ«ã‚’å¼•ç”¨ã—ã¾ã™ã€‚',0),(332996,9250,'pt','CitaÃ§Ã£o por E-mail',0),(332997,9250,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(332998,9250,'es','CotizaciÃ³n Enviada por Email',0),(332999,9250,'de','Angebot per E-Mail',0),(333000,9250,'en','Quote Emailed',0),(333001,9251,'is','',0),(333002,9251,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡ ',0),(333003,9251,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡ ',0),(333004,9251,'tr','E-posta ile servis sipariÅŸi',0),(333005,9251,'pl','Zlecenie serwisowe, e-mailem',0),(333006,9251,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð· ÐµÐ¼Ð°Ð¹Ð»',0),(333007,9251,'ur','Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© Ø®Ø¯Ù…Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(333008,9251,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð»',0),(333009,9251,'vi','ÄÃ£ Email ÄÆ¡n hÃ ng dá»‹ch vá»¥',0),(333010,9251,'af','Diensbestelling geE-pos',0),(333011,9251,'ro','ComandÄƒ de service, prin E-mail',0),(333012,9251,'et','Teenuse tellimine e-postiga',0),(333013,9251,'si','Servisni nalog, po e-poÅ¡ti',0),(333014,9251,'ba','Service Order diemail',0),(333015,9251,'nl','Serviceorder e-mailde',0),(333016,9251,'fi','Huoltotilauksen sÃ¤hkÃ¶postitse',0),(333017,9251,'no','Serviceordren sendt',0),(333018,9251,'da','Serviceordren mailede',0),(333019,9251,'ko','ì´ë©”ì¼ ì„œë¹„ìŠ¤ ìˆœì„œ',0),(333020,9251,'he','×”×–×ž× ×ª ×©×¨×•×ª × ×©×œ×—×” ×‘×“×•×\"×œ',0),(333021,9251,'el','Î•Î½Ï„Î¿Î»Î® Ï„ / Ï… Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(333022,9251,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€æœåŠ¡è®¢å•\r\n',0),(333023,9251,'sv','Serviceordern mailade',0),(333024,9251,'it','Ordine di servizio via E-mail',0),(333025,9251,'tl','',0),(333026,9251,'th','&#3629;&#3633;&#3648;&#3617;&#3621;&#3660;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(333027,9251,'hi','à¤ˆà¤®à¥‡à¤² à¤¸à¥‡à¤µà¤¾ à¤•à¥à¤°à¤®',0),(333028,9251,'ms','Pesanan melalui e-mel',0),(333029,9251,'ar','Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(333030,9251,'fr','Commande de service par courriel',0),(333031,9251,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã‚’ãƒ¡ãƒ¼ãƒ«ã§é€ä¿¡',0),(333032,9251,'pt','Ordem de serviÃ§o por E-mail',0),(333033,9251,'ru','Ð¡ÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð· ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(333034,9251,'es','Orden de Servicio Enviado por Email',0),(333035,9251,'de','Service-Auftrag per E-Mail',0),(333036,9251,'en','Service Order Emailed',0),(333037,9252,'is','',0),(333038,9252,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡ ',0),(333039,9252,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø§ÙŠÙ…ÙŠÙ„ Ø´Ø¯Ù‡ ',0),(333040,9252,'tr','E-posta bildirimi',0),(333041,9252,'pl','Instrukcja e-mailem',0),(333042,9252,'bg','Ð”ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ Ð¿Ð¾ ÐµÐ¼Ð°Ð¹Ð»',0),(333043,9252,'ur','Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(333044,9252,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð»',0),(333045,9252,'vi','Báº£ng thanh toÃ¡n Ä‘Ã£ Email',0),(333046,9252,'af','E-pos vsn Staat',0),(333047,9252,'ro','DeclaraÅ£ie prin E-mail',0),(333048,9252,'et','Avaldus saadetakse',0),(333049,9252,'si','Izjava po e-poÅ¡ti',0),(333050,9252,'ba','Pernyataan diemail',0),(333051,9252,'nl','Verklaring per E-mail',0),(333052,9252,'fi','Ilmoitus sÃ¤hkÃ¶postitse',0),(333053,9252,'no','Uttalelse sendt',0),(333054,9252,'da','ErklÃ¦ring mailede',0),(333055,9252,'ko','ì´ë©”ì¼ ë¬¸ì˜',0),(333056,9252,'he','×”×”×¦×”×¨×” ×‘×“×•×',0),(333057,9252,'el','Î”Î®Î»Ï‰ÏƒÎ· Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(333058,9252,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€çš„å£°æ˜Ž\r\n',0),(333059,9252,'sv','Uttalande mailade',0),(333060,9252,'it','Dichiarazione via E-mail',0),(333061,9252,'tl','',0),(333062,9252,'th','&#3649;&#3592;&#3657;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(333063,9252,'hi','à¤ˆà¤®à¥‡à¤² à¤¬à¤¯à¤¾à¤¨',0),(333064,9252,'ms','Kenyataan melalui e-mel',0),(333065,9252,'ar','Ø¨ÙŠØ§Ù† Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(333066,9252,'fr','DÃ©claration par courriel',0),(333067,9252,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã‚’ãƒ¡ãƒ¼ãƒ«ã§é€ä¿¡',0),(333068,9252,'pt','DeclaraÃ§Ã£o por E-mail',0),(333069,9252,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(333070,9252,'es','Constancia Enviada por Email',0),(333071,9252,'de','Anweisung per E-Mail',0),(333072,9252,'en','Statement Emailed',0),(333073,9253,'is','',0),(333074,9253,'dr','Ú¯Ø±ÙˆÙ‡ ØªÙÚ©ÙŠÚ©',0),(333075,9253,'pr','Ú¯Ø±ÙˆÙ‡ ØªÙÚ©ÙŠÚ©',0),(333076,9253,'tr','ArÄ±za grubu',0),(333077,9253,'pl','PodziaÅ‚ grupy',0),(333078,9253,'bg','Ð Ð°Ð·Ð±Ð¸Ð²ÐºÐ° Ð³Ñ€ÑƒÐ¿Ð°',0),(333079,9253,'ur','Ù…Ø·Ø§Ø¨Ù‚ Ú¯Ø±ÙˆÙ¾',0),(333080,9253,'sr','Ð¡Ð»Ð¾Ð¼ Ð³Ñ€ÑƒÐ¿Ðµ',0),(333081,9253,'vi','PhÃ¢n chia nhÃ³m',0),(333082,9253,'af','Ontledingsgroep',0),(333083,9253,'ro','Defalcarea grup',0),(333084,9253,'et','Rikke grupp',0),(333085,9253,'si','RazÄlenitev skupine',0),(333086,9253,'ba','Rincian grup',0),(333087,9253,'nl','Verdeling groep',0),(333088,9253,'fi','Jaottelu ryhmÃ¤',0),(333089,9253,'no','Nedbryting-gruppen',0),(333090,9253,'da','Opdeling gruppe',0),(333091,9253,'ko','ë¶„ì„ ê·¸ë£¹',0),(333092,9253,'he','×¤×™×¨×•×§ ×§×‘×•×¦×”',0),(333093,9253,'el','ÎšÎ±Ï„Î±Î½Î¿Î¼Î® Î¿Î¼Î¬Î´Î±',0),(333094,9253,'zh','æ‰“ç ´é›†å›¢\r\n',0),(333095,9253,'sv','Uppdelning grupp',0),(333096,9253,'it','Gruppo di ripartizione',0),(333097,9253,'tl','',0),(333098,9253,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3648;&#3610;&#3619;&#3588;&#3604;&#3634;&#3623;&#3609;&#3660;',0),(333099,9253,'hi','à¤Ÿà¥‚à¤Ÿà¤¨à¥‡ à¤¸à¤®à¥‚à¤¹',0),(333100,9253,'ms','Pecahan Kumpulan',0),(333101,9253,'ar','Ø§Ù†Ù‡ÙŠØ§Ø± Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(333102,9253,'fr','Groupe de ventilation',0),(333103,9253,'jp','å†…è¨³ã‚°ãƒ«ãƒ¼ãƒ—',0),(333104,9253,'pt','Grupo de avaria',0),(333105,9253,'ru','Ð Ð°ÑÐ¿Ð°Ð´ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(333106,9253,'es','Detalle Completo del Grupo',0),(333107,9253,'de','AufschlÃ¼sselung Gruppe',0),(333108,9253,'en','Breakdown Group',0),(333109,9254,'is','',0),(333110,9254,'dr','(Ø§Ø¹ØªØ¨Ø§Ø±)Ø­Ø³Ø§Ø¨ Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ',0),(333111,9254,'pr','Ø§Ù…Ø§Ù†Øª(Ø§Ø¹ØªØ¨Ø§Ø±)Ø­Ø³Ø§Ø¨ Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ',0),(333112,9254,'tr','Transfer hesap gÃ¼ven',0),(333113,9254,'pl','Przeniesienie rachunku powierniczego',0),(333114,9254,'bg','Ð”Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÐµÐ»Ð½Ð°Ñ‚Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ',0),(333115,9254,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾Ø± Ø§Ø¹ØªÙ…Ø§Ø¯',0),(333116,9254,'sr','Ð’ÐµÑ€ÑƒÑ˜ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(333117,9254,'vi','TK á»¦y ThÃ¡c',0),(333118,9254,'af','Trust Oorplasingsrekening',0),(333119,9254,'ro','Trust cont de transferul',0),(333120,9254,'et','Ãœlekande usalduskonto',0),(333121,9254,'si','SkrbniÅ¡ki raÄun za prenos',0),(333122,9254,'ba','Mempercayai Transfer rekening',0),(333123,9254,'nl','Vertrouwen overdracht Account',0),(333124,9254,'fi','Siirto luottotili',0),(333125,9254,'no','Klareringskonto for overfÃ¸ring',0),(333126,9254,'da','OverfÃ¸rsel kontoen',0),(333127,9254,'ko','ê³„ì¢Œ ì´ì²´ë¥¼ ì‹ ë¢°',0),(333128,9254,'he','×”×¢×‘×¨×ª ×—×©×‘×•×Ÿ ×™×—×¡×™ ××ž×•×Ÿ',0),(333129,9254,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚',0),(333130,9254,'zh','ä¿¡ä»»ä¼ é€’å¸æˆ·\r\n',0),(333131,9254,'sv','Lita Ã¶verfÃ¶ring konto',0),(333132,9254,'it','Trasferimento conto fiduciario',0),(333133,9254,'tl','',0),(333134,9254,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3585;&#3634;&#3619;&#3650;&#3629;&#3609;&#3648;&#3591;&#3636;&#3609;&#3607;&#3637;&#3656;&#3617;&#3633;&#3656;&#3609;&#3651;&#3592;&#3611;&#3621;&#3629;&#3604;&#3616;&#3633;&#3618;',0),(333135,9254,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤–à¤¾à¤¤à¥‡ à¤ªà¤° à¤­à¤°à¥‹à¤¸à¤¾',0),(333136,9254,'ms','Pemindahan akaun amanah',0),(333137,9254,'ar','Ù†Ù‚Ù„ Ø­Ø³Ø§Ø¨ Ø«Ù‚Ø©',0),(333138,9254,'fr','Transfert de compte en fiducie',0),(333139,9254,'jp','æŒ¯æ›¿å£åº§ã‚’ä¿¡é ¼ã—ã¾ã™ã€‚',0),(333140,9254,'pt','TransferÃªncia conta fiduciÃ¡ria',0),(333141,9254,'ru','Ð”Ð¾Ð²ÐµÑ€ÑÑ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(333142,9254,'es','Cuenta de Transferencia de Trust',0),(333143,9254,'de','Transfer Treuhandkonto',0),(333144,9254,'en','Trust Transfer Account',0),(333145,9255,'is','',0),(333146,9255,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª Ù…ÙˆÙÙ‚ Ù†Ø¨ÙˆØ¯',0),(333147,9255,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±ÙƒØª Ù…ÙˆÙÙ‚ Ù†Ø¨ÙˆØ¯',0),(333148,9255,'tr','Firma ekleme baÅŸarÄ±lÄ± deÄŸil',0),(333149,9255,'pl','Firma dodaÄ‡ nie udane',0),(333150,9255,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(333151,9255,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ù†ÛÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(333152,9255,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð°',0),(333153,9255,'vi','ThÃªm Cty khÃ´ng thÃ nh cÃ´ng',0),(333154,9255,'af','Onderneming Nie suksesvolg Bygevoeg',0),(333155,9255,'ro','Esec adaugare companie',0),(333156,9255,'et','EttevÃµtte lisamine ebaÃµnnestus',0),(333157,9255,'si','Podjetju Dodaj niso uspeÅ¡ni',0),(333158,9255,'ba','Perusahaan menambahkan tidak berhasil',0),(333159,9255,'nl','Bedrijf toevoegen niet geslaagd',0),(333160,9255,'fi','Yrityksen lisÃ¤Ã¤minen ei onnistunut',0),(333161,9255,'no','Selskapet legger ikke vellykket',0),(333162,9255,'da','Virksomheden tilfÃ¸jer ikke vellykket',0),(333163,9255,'ko','íšŒì‚¬ ì¶”ê°€ ì‹¤íŒ¨',0),(333164,9255,'he','×”×—×‘×¨×” ×œ×”×•×¡×™×£ ×œ× ×ž×•×¦×œ×—',0),(333165,9255,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÎµÏ€Î¹Ï„Ï…Ï‡Î®Ï‚',0),(333166,9255,'zh','å…¬å¸åœ°å€ä¸æˆåŠŸ\r\n',0),(333167,9255,'sv','FÃ¶retaget lÃ¤gga inte lyckat',0),(333168,9255,'it','Azienda aggiungere non riuscita',0),(333169,9255,'tl','',0),(333170,9255,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3652;&#3617;&#3656;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(333171,9255,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¨à¤¹à¥€à¤‚ à¤¸à¤«à¤² à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(333172,9255,'ms','Syarikat menambah tidak berjaya',0),(333173,9255,'ar','ÙØ´Ù„ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø´Ø±ÙƒØ©',0),(333174,9255,'fr','Entreprise ajouter ne rÃ©ussit pas',0),(333175,9255,'jp','ä¼šç¤¾ã¯æˆåŠŸã—ã¦ã„ãªã„è¿½åŠ ã—ã¾ã™ã€‚',0),(333176,9255,'pt','Empresa adicionar nÃ£o bem sucedida',0),(333177,9255,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ ÐÐµ Ð£Ð´Ð°Ð»Ð¾ÑÑŒ',0),(333178,9255,'es','Agregar Empresa no fue exitoso',0),(333179,9255,'de','Firma hinzufÃ¼gen nicht erfolgreich',0),(333180,9255,'en','Company Add Not Successful',0),(333181,9256,'is','',0),(333182,9256,'dr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø¬Ø¯ÙŠØ¯ ',0),(333183,9256,'pr','Ù†Ù…Ø§ÙŠØ´ Ù„ÙŠØ³Øª Ø¬Ø¯ÙŠØ¯ ',0),(333184,9256,'tr','Yeni listeyi gÃ¶ster',0),(333185,9256,'pl','PokaÅ¼ nowÄ… listÄ™',0),(333186,9256,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð½Ð¾Ð² ÑÐ¿Ð¸ÑÑŠÐº',0),(333187,9256,'ur','Ù†Ø¦ÛŒ ÙÛØ±Ø³Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(333188,9256,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð¾Ð²Ñƒ Ð»Ð¸ÑÑ‚Ñƒ',0),(333189,9256,'vi','Hiá»ƒn thá»‹ danh sÃ¡ch má»›i',0),(333190,9256,'af','Wys Nuwe Lys',0),(333191,9256,'ro','AratÄƒ Lista noua',0),(333192,9256,'et','NÃ¤ita uut nimekirja',0),(333193,9256,'si','PokaÅ¾i nov seznam',0),(333194,9256,'ba','Daftar baru',0),(333195,9256,'nl','De nieuwe lijst weergeven',0),(333196,9256,'fi','NÃ¤ytÃ¤ uusi luettelo',0),(333197,9256,'no','Vis ny liste',0),(333198,9256,'da','Vis nye liste',0),(333199,9256,'ko','ìƒˆ ëª©ë¡ í‘œì‹œ',0),(333200,9256,'he','×”×¦×’ ×¨×©×™×ž×” ×—×“×©×”',0),(333201,9256,'el','ÎÎ­Î± Î»Î¯ÏƒÏ„Î± \"Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·\"',0),(333202,9256,'zh','æ˜¾ç¤ºæ–°åå•\r\n',0),(333203,9256,'sv','Visa ny lista',0),(333204,9256,'it','Visualizza il nuovo elenco',0),(333205,9256,'tl','',0),(333206,9256,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(333207,9256,'hi','à¤¨à¤ˆ à¤¸à¥‚à¤šà¥€ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(333208,9256,'ms','Menunjukkan senarai baru',0),(333209,9256,'ar','ØªØ¸Ù‡Ø± Ù‚Ø§Ø¦Ù…Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(333210,9256,'fr','Voir la nouvelle liste',0),(333211,9256,'jp','æ–°ã—ã„ãƒªã‚¹ãƒˆã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(333212,9256,'pt','Mostrar a nova lista',0),(333213,9256,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐÐ¾Ð²Ñ‹Ð¹ Ð¡Ð¿Ð¸ÑÐ¾Ðº',0),(333214,9256,'es','Muestra Nueva Lista',0),(333215,9256,'de','Neue Liste anzeigen',0),(333216,9256,'en','Show New List',0),(333217,9257,'is','',0),(333218,9257,'dr','Ù„ÙŠØ³Øª Ø¨Ø§Ø±ÙƒØ¯',0),(333219,9257,'pr','Ù„ÙŠØ³Øª Ø¨Ø§Ø±ÙƒØ¯',0),(333220,9257,'tr','Barkod listesi',0),(333221,9257,'pl','Lista kodÃ³w kreskowych',0),(333222,9257,'bg','Ð‘Ð°Ñ€ÐºÐ¾Ð´ ÑÐ¿Ð¸ÑÑŠÐº',0),(333223,9257,'ur','Ø¨Ø§Ø±Ú©ÙˆÚˆ ÙÛØ±Ø³Øª',0),(333224,9257,'sr','Ð›Ð¸ÑÑ‚Ð° Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð°',0),(333225,9257,'vi','Danh sÃ¡ch mÃ£ váº¡ch',0),(333226,9257,'af','Strepieskode Lys',0),(333227,9257,'ro','Lista de coduri de bare',0),(333228,9257,'et','VÃ¶Ã¶tkoodi loend',0),(333229,9257,'si','ÄŒrtna koda seznam',0),(333230,9257,'ba','Daftar barcode',0),(333231,9257,'nl','Barcode lijst',0),(333232,9257,'fi','Viivakoodi List',0),(333233,9257,'no','Strekkode-listen',0),(333234,9257,'da','Stregkode liste',0),(333235,9257,'ko','ë°”ì½”ë“œ ëª©ë¡',0),(333236,9257,'he','×¨×©×™×ž×ª ×‘×¨×§×•×“',0),(333237,9257,'el','Î›Î¯ÏƒÏ„Î± barcode',0),(333238,9257,'zh','æ¡ç åå•\r\n',0),(333239,9257,'sv','Barcode lista',0),(333240,9257,'it','Elenco di codici a barre',0),(333241,9257,'tl','',0),(333242,9257,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3634;&#3619;&#3660;&#3650;&#3588;&#3657;&#3604;',0),(333243,9257,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤¸à¥‚à¤šà¥€',0),(333244,9257,'ms','Senarai kod Bar',0),(333245,9257,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¨Ø§Ø±ÙƒÙˆØ¯',0),(333246,9257,'fr','Liste de codes Ã  barres',0),(333247,9257,'jp','[ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ ãƒªã‚¹ãƒˆ]',0),(333248,9257,'pt','Lista de cÃ³digo de barras',0),(333249,9257,'ru','Ð¨Ñ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(333250,9257,'es','Lista de CÃ³digo de Barras',0),(333251,9257,'de','Barcode-Liste',0),(333252,9257,'en','Barcode List',0),(333253,9258,'is','',0),(333254,9258,'dr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆÙ†Ø¯',0),(333255,9258,'pr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆÙ†Ø¯',0),(333256,9258,'tr','KullanÄ±cÄ±lar iÃ§in tÃ¼m ÅŸirketlerin dahil',0),(333257,9258,'pl','ObejmujÄ… uÅ¼ytkownikÃ³w dla wszystkich firm',0),(333258,9258,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸ Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(333259,9258,'ur','ØµØ§Ø±ÙÛŒÚº Ú©Û’ Ù„Ø¦Û’ ØªÙ…Ø§Ù… Ú©Ù…Ù¾Ù†ÛŒØ§Úº Ø¨Ú¾ÛŒ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(333260,9258,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐµ Ð·Ð° ÑÐ²Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(333261,9258,'vi','Bao Gá»“m NgÆ°á»i Sá»­ Dá»¥ng Cho Táº¥t Cáº£ CÃ¡c Cty',0),(333262,9258,'af','Sluit Gebruikers vir Alle Besighede in',0),(333263,9258,'ro','Include utilizatorii tuturor companiilor',0),(333264,9258,'et','Kaasa kasutajad kÃµigile ettevÃµtetele',0),(333265,9258,'si','So uporabniki za vsa podjetja',0),(333266,9258,'ba','Termasuk pengguna untuk semua perusahaan',0),(333267,9258,'nl','Gebruikers opnemen voor alle bedrijven',0),(333268,9258,'fi','SisÃ¤llytÃ¤ kaikkien yritysten kÃ¤yttÃ¤jÃ¤t',0),(333269,9258,'no','Inkludere brukere for alle selskaper',0),(333270,9258,'da','Omfatte brugere for alle regnskaber',0),(333271,9258,'ko','ëª¨ë“  íšŒì‚¬ì— ëŒ€ í•œ ì‚¬ìš©ìžë¥¼ í¬í•¨',0),(333272,9258,'he','×›×œ×•×œ ×ž×©×ª×ž×©×™× ×¢×‘×•×¨ ×›×œ ×—×‘×¨×•×ª',0),(333273,9258,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Î³Î¹Î± ÏŒÎ»Î± ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚',0),(333274,9258,'zh','åŒ…æ‹¬æ‰€æœ‰å…¬å¸ç”¨æˆ·\r\n',0),(333275,9258,'sv','Inkludera anvÃ¤ndare fÃ¶r alla fÃ¶retag',0),(333276,9258,'it','Includere gli utenti per tutte le aziende',0),(333277,9258,'tl','',0),(333278,9258,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3612;&#3641;&#3655;&#3651;&#3594;&#3657;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(333279,9258,'hi','à¤¸à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(333280,9258,'ms','Termasuk pengguna untuk semua syarikat',0),(333281,9258,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´Ø±ÙƒØ§Øª',0),(333282,9258,'fr','Inclure les utilisateurs pour toutes les entreprises',0),(333283,9258,'jp','ã™ã¹ã¦ã®ä¼æ¥­ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’å«ã‚ã‚‹',0),(333284,9258,'pt','Incluir usuÃ¡rios para empresas de todos os',0),(333285,9258,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ Ð´Ð»Ñ Ð²ÑÐµÑ… ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¹',0),(333286,9258,'es','Incluir Usuarios para Todas las Empresas',0),(333287,9258,'de','SchlieÃŸen Sie Benutzer fÃ¼r alle Mandanten',0),(333288,9258,'en','Include Users for All Companies',0),(333289,9259,'is','',0),(333290,9259,'dr','Ø¹Ø¯Ù… ØµÙ„Ø§Ø­ÙŠØª',0),(333291,9259,'pr','Ø¹Ø¯Ù… ØµÙ„Ø§Ø­ÙŠØª',0),(333292,9259,'tr','Herhangi bir hak',0),(333293,9259,'pl','Nie ma prawa',0),(333294,9259,'bg','ÐÑÐ¼Ð° Ð¿Ñ€Ð°Ð²Ð°',0),(333295,9259,'ur','Ú©ÙˆØ¦ÛŒ Ø­Ù‚ÙˆÙ‚',0),(333296,9259,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€Ð°Ð²Ð°',0),(333297,9259,'vi','KhÃ´ng cÃ³ quyá»n',0),(333298,9259,'af','Geen Regte',0),(333299,9259,'ro','Nici un drept',0),(333300,9259,'et','Ã•igusi ei',0),(333301,9259,'si','Nima pravice',0),(333302,9259,'ba','Tidak ada hak',0),(333303,9259,'nl','Geen rechten',0),(333304,9259,'fi','MitÃ¤Ã¤n oikeuksia',0),(333305,9259,'no','Ingen rettigheter',0),(333306,9259,'da','Ingen rettigheder',0),(333307,9259,'ko','ê¶Œí•œ ì—†ìŒ',0),(333308,9259,'he','××™×Ÿ ×–×›×•×™×•×ª',0),(333309,9259,'el','Î§Ï‰ÏÎ¯Ï‚ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î±',0),(333310,9259,'zh','æ²¡æœ‰æƒåˆ©\r\n',0),(333311,9259,'sv','Inga rÃ¤ttigheter',0),(333312,9259,'it','Senza diritti',0),(333313,9259,'tl','',0),(333314,9259,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3626;&#3636;&#3607;&#3608;&#3636;',0),(333315,9259,'hi','à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¨à¤¹à¥€à¤‚',0),(333316,9259,'ms','Tiada hak',0),(333317,9259,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø­Ù‚ÙˆÙ‚',0),(333318,9259,'fr','Pas de droits',0),(333319,9259,'jp','ã‚¢ã‚¯ã‚»ã‚¹æ¨©ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(333320,9259,'pt','NÃ£o hÃ¡ direitos',0),(333321,9259,'ru','ÐÐµÑ‚ ÐŸÑ€Ð°Ð²Ð°',0),(333322,9259,'es','No hay Derechos',0),(333323,9259,'de','Keine Rechte',0),(333324,9259,'en','No Rights',0),(333325,9260,'is','',0),(333326,9260,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† ÙŠÙƒ Ø³ØªÙˆÙ† Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´',0),(333327,9260,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† ÙŠÙƒ Ø³ØªÙˆÙ† Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´',0),(333328,9260,'tr','Bir sÃ¼tun iÃ§in bu rapora dahil etmek iÃ§in iÅŸaretleyin',0),(333329,9260,'pl','Zaznacz, aby zawieraÄ‡ kolumna do tego raportu',0),(333330,9260,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¾Ð½Ð° Ð·Ð° Ñ‚Ð¾Ð²Ð° Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(333331,9260,'ur','Ø§ÛŒÚ© Ú©Ø§Ù„Ù… Ø§Ø³ Ú©Û’ Ù„Ø¦Û’ Ø±Ù¾ÙˆØ±Ù¹ Ù¾Ø± Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(333332,9260,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð·Ð° Ð¾Ð²Ð¾ Ñƒ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ñƒ',0),(333333,9260,'vi','ÄÃ¡nh dáº¥u Ä‘á»ƒ thÃªm 1 cá»™t cho bÃ¡o cÃ¡o nÃ y',0),(333334,9260,'af','Merk om \'n kolom vir hierdie verslag in te sluit',0),(333335,9260,'ro','VerificaÅ£i pentru a include o coloanÄƒ pentru acest raport',0),(333336,9260,'et','Sisse lisada veeru selle aruande kohta',0),(333337,9260,'si','Preverite dodati stolpec za to poroÄilo',0),(333338,9260,'ba','Periksa untuk sertakan kolom ini pada laporan',0),(333339,9260,'nl','Controleert u een kolom opnemen voor dit op het verslag',0),(333340,9260,'fi','Tarkista raporttiin sisÃ¤llytettÃ¤vÃ¤ tÃ¤mÃ¤ sarake',0),(333341,9260,'no','Sjekk med en kolonne for dette i rapporten',0),(333342,9260,'da','Check at medtage en kolonne for denne betÃ¦nkning',0),(333343,9260,'ko','ë³´ê³ ì„œì—ì´ ëŒ€ í•œ ì—´ì„ í¬í•¨ í•˜ë„ë¡ í™•ì¸',0),(333344,9260,'he','×”×¡×™×ž×•×Ÿ ×›×“×™ ×œ×›×œ×•×œ ×¢×ž×•×“×” ×¢×‘×•×¨ ×–×” ×¢×œ ×”×“×• ×—',0),(333345,9260,'el','Î•Î»Î­Î³Ï‡Î¿Ï… Î³Î¹Î± Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î¼Î¹Î± ÏƒÏ„Î®Î»Î· Î³Î¹Î± Î±Ï…Ï„ÏŒ Î³Î¹Î± Ï„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ·',0),(333346,9260,'zh','æ£€æŸ¥åŒ…æ‹¬å¯¹è¿™ä¸ªæŠ¥å‘Šåˆ—\r\n',0),(333347,9260,'sv','Kontrollera fÃ¶r att inkludera en kolumn fÃ¶r detta betÃ¤nkande',0),(333348,9260,'it','Controllare per includere una colonna per questo sulla relazione',0),(333349,9260,'tl','',0),(333350,9260,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3588;&#3629;&#3621;&#3633;&#3617;&#3617;&#3660;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(333351,9260,'hi','à¤à¤• à¤¸à¥à¤¤à¤‚à¤­ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤ªà¤° à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(333352,9260,'ms','Semak untuk memasukkan lajur ini mengenai laporan',0),(333353,9260,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† ØªØ¶Ù…ÙŠÙ† Ø¹Ù…ÙˆØ¯ Ù„Ù‡Ø°Ø§ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(333354,9260,'fr','Cochez pour inclure une colonne pour cela sur le rapport',0),(333355,9260,'jp','ãƒ¬ãƒãƒ¼ãƒˆã«ã“ã®åˆ—ã‚’å«ã‚ã‚‹ã«ãƒã‚§ãƒƒã‚¯',0),(333356,9260,'pt','SeleÃ§Ã£o para incluir uma coluna para isso sobre o relatÃ³rio',0),(333357,9260,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ð»Ð±ÐµÑ† Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(333358,9260,'es','Marcar para incluir una columna para este en el informe',0),(333359,9260,'de','ÃœberprÃ¼fen Sie, um eine Spalte fÃ¼r das im Bericht enthalten',0),(333360,9260,'en','Check to include a column for this on the report',0),(333361,9261,'is','',0),(333362,9261,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø²Ø¡ Ø¨Ù‡ Ø¬Ø²Ø¡ ',0),(333363,9261,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø²Ø¡ Ø¨Ù‡ Ø¬Ø²Ø¡ ',0),(333364,9261,'tr','AyrÄ±ntÄ±lÄ± raporu',0),(333365,9261,'pl','SzczegÃ³Å‚owy raport',0),(333366,9261,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±ÐµÐ½ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(333367,9261,'ur','ØªÙØµÛŒÙ„ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(333368,9261,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð°Ð½ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(333369,9261,'vi','BÃ¡o cÃ¡o chi tiáº¿t',0),(333370,9261,'af','Gedetaileerde Verslag',0),(333371,9261,'ro','Raport detaliat',0),(333372,9261,'et','Ãœksikasjalik aruanne',0),(333373,9261,'si','Podrobno poroÄilo',0),(333374,9261,'ba','Laporan rinci',0),(333375,9261,'nl','Gedetailleerd verslag',0),(333376,9261,'fi','Yksityiskohtainen raportti',0),(333377,9261,'no','Detaljert rapport',0),(333378,9261,'da','Detaljeret rapport',0),(333379,9261,'ko','ìƒì„¸í•œ ë³´ê³ ì„œ',0),(333380,9261,'he','×“×•×— ×ž×¤×•×¨×˜',0),(333381,9261,'el','Î›ÎµÏ€Ï„Î¿Î¼ÎµÏÎ® Î­ÎºÎ¸ÎµÏƒÎ·',0),(333382,9261,'zh','è¯¦ç»†æŠ¥å‘Š\r\n',0),(333383,9261,'sv','Detaljerad rapport',0),(333384,9261,'it','Rapporto dettagliato',0),(333385,9261,'tl','',0),(333386,9261,'th','&#3585;&#3634;&#3619;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;',0),(333387,9261,'hi','à¤µà¤¿à¤¸à¥à¤¤à¥ƒà¤¤ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(333388,9261,'ms','Laporan terperinci',0),(333389,9261,'ar','Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…ÙØµÙ‘Ù„',0),(333390,9261,'fr','Rapport dÃ©taillÃ©',0),(333391,9261,'jp','è©³ç´°ãƒ¬ãƒãƒ¼ãƒˆ',0),(333392,9261,'pt','RelatÃ³rio detalhado',0),(333393,9261,'ru','Ð”ÐµÑ‚Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÐžÑ‚Ñ‡ÐµÑ‚',0),(333394,9261,'es','Informe Detallado',0),(333395,9261,'de','AusfÃ¼hrlicher Bericht',0),(333396,9261,'en','Detailed Report',0),(333397,9262,'is','',0),(333398,9262,'dr','Ø´Ø§Ø®ØµÙ‡Ø§ÙŠ  ÙÙŠÙ„ØªØ± ',0),(333399,9262,'pr','Ø´Ø§Ø®ØµÙ‡Ø§ÙŠ  ÙÙŠÙ„ØªØ± ',0),(333400,9262,'tr','Filtre deÄŸerleri',0),(333401,9262,'pl','Filtr wartoÅ›ci',0),(333402,9262,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸Ñ‚Ðµ Ð½Ð° Ñ„Ð¸Ð»Ñ‚ÑŠÑ€Ð°',0),(333403,9262,'ur','Ø§Ù‚Ø¯Ø§Ø± Ú©Ùˆ ÙÙ„Ù¹Ø± Ú©Ø±ÛŒÚº',0),(333404,9262,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ñ„Ð¸Ð»Ñ‚ÐµÑ€Ð°',0),(333405,9262,'vi','GiÃ¡ trá»‹ lá»c',0),(333406,9262,'af','Filtreer Waardes',0),(333407,9262,'ro','Filtru valori',0),(333408,9262,'et','Filtri vÃ¤Ã¤rtused',0),(333409,9262,'si','Vrednosti filtrov',0),(333410,9262,'ba','Menyaring nilai-nilai',0),(333411,9262,'nl','Filterwaarden',0),(333412,9262,'fi','Suodata arvot',0),(333413,9262,'no','Filterverdier',0),(333414,9262,'da','FiltervÃ¦rdier',0),(333415,9262,'ko','í•„í„° ê°’',0),(333416,9262,'he','×¡×™× ×•×Ÿ ×¢×¨×›×™×',0),(333417,9262,'el','Î¦Î¯Î»Ï„ÏÎ¿ Ï„Î¹Î¼ÏŽÎ½',0),(333418,9262,'zh','è¿‡æ»¤å€¼\r\n',0),(333419,9262,'sv','FiltervÃ¤rden',0),(333420,9262,'it','Valori di filtro',0),(333421,9262,'tl','',0),(333422,9262,'th','&#3588;&#3656;&#3634;&#3605;&#3633;&#3623;&#3585;&#3619;&#3629;&#3591;',0),(333423,9262,'hi','à¤®à¤¾à¤¨ à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤° à¤•à¤°à¥‡à¤‚',0),(333424,9262,'ms','Nilai penapis',0),(333425,9262,'ar','ØªØµÙÙŠØ© Ø§Ù„Ù‚ÙŠÙ…',0),(333426,9262,'fr','Valeurs de filtre',0),(333427,9262,'jp','ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼ã®å€¤',0),(333428,9262,'pt','Valores de filtro',0),(333429,9262,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ñ„Ð¸Ð»ÑŒÑ‚Ñ€Ð°',0),(333430,9262,'es','Valores de Filtro',0),(333431,9262,'de','Filterwerte',0),(333432,9262,'en','Filter Values',0),(333433,9263,'is','',0),(333434,9263,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(333435,9263,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(333436,9263,'tr','Stok satÄ±ÅŸ geÃ§miÅŸi',0),(333437,9263,'pl','Historia sprzedaÅ¼y zapasÃ³w',0),(333438,9263,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°Ñ‚Ð° Ð·Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(333439,9263,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø³ÛŒÙ„Ø² ØªØ§Ø±ÛŒØ®',0),(333440,9263,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(333441,9263,'vi','Lá»‹ch Sá»­ BÃ¡n HÃ ng',0),(333442,9263,'af','Voorraad Verkoopsgeskiedenis',0),(333443,9263,'ro','Inventarul istoric vÃ¢nzÄƒri',0),(333444,9263,'et','Varude mÃ¼Ã¼k ajalugu',0),(333445,9263,'si','Zgodovina prodaje zaloge',0),(333446,9263,'ba','Sejarah penjualan persediaan',0),(333447,9263,'nl','Inventaris Verkoophistorie',0),(333448,9263,'fi','Varaston myynti historia',0),(333449,9263,'no','Lager Salgshistorikk',0),(333450,9263,'da','Lageret salgshistorik',0),(333451,9263,'ko','ìž¬ê³  íŒë§¤ ì—­ì‚¬',0),(333452,9263,'he','×”×™×¡×˜×•×¨×™×™×ª ×ž×›×™×¨×•×ª ×ž×œ××™',0),(333453,9263,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î¹ÏƒÏ„Î¿ÏÎ¯Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(333454,9263,'zh','åº“å­˜é”€å”®åŽ†å²\r\n',0),(333455,9263,'sv','Inventering fÃ¶rsÃ¤ljning historia',0),(333456,9263,'it','Cronologia delle vendite di inventario',0),(333457,9263,'tl','',0),(333458,9263,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(333459,9263,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(333460,9263,'ms','Sejarah jualan inventori',0),(333461,9263,'ar','Ø­Ø±ÙƒØ© Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(333462,9263,'fr','L\'inventaire historique des ventes',0),(333463,9263,'jp','åœ¨åº«è²©å£²å±¥æ­´',0),(333464,9263,'pt','InventÃ¡rio histÃ³rico de vendas',0),(333465,9263,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(333466,9263,'es','Historia de Ventas de Inventario',0),(333467,9263,'de','Inventar Vertriebshistorie',0),(333468,9263,'en','Inventory Sales History',0),(333469,9264,'is','',0),(333470,9264,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ',0),(333471,9264,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø±Ø§ÙŠ',0),(333472,9264,'tr','Stok satÄ±ÅŸ geÃ§miÅŸi',0),(333473,9264,'pl','Historia sprzedaÅ¼y zapasÃ³w',0),(333474,9264,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°Ñ‚Ð° Ð·Ð° Ð·Ð°Ð¿Ð°ÑÐ¸ Ð·Ð°',0),(333475,9264,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ø³ÛŒÙ„Ø² ØªØ§Ø±ÛŒØ®',0),(333476,9264,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð·Ð°',0),(333477,9264,'vi','Lá»‹ch Sá»­ BÃ¡n HÃ ng cho',0),(333478,9264,'af','Voorraad Verkoopsgeskiedenis Vir',0),(333479,9264,'ro','Inventarul istoric vÃ¢nzÄƒri pentru',0),(333480,9264,'et','Varude mÃ¼Ã¼gi ajalugu',0),(333481,9264,'si','Zgodovina prodaje zaloge za',0),(333482,9264,'ba','Sejarah penjualan persediaan untuk',0),(333483,9264,'nl','Inventaris verkoophistorie voor',0),(333484,9264,'fi','Varaston myynti historia',0),(333485,9264,'no','Lager Salgshistorikk For',0),(333486,9264,'da','Lageret salgshistorik For',0),(333487,9264,'ko','ìž¬ê³  íŒë§¤ ì—­ì‚¬ì— ëŒ€ í•œ',0),(333488,9264,'he','×”×™×¡×˜×•×¨×™×™×ª ×ž×›×™×¨×•×ª ×ž×œ××™ ×¢×‘×•×¨',0),(333489,9264,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î¹ÏƒÏ„Î¿ÏÎ¯Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³Î¹Î±',0),(333490,9264,'zh','åº“å­˜é”€å”®åŽ†å²è®°å½•\r\n',0),(333491,9264,'sv','Inventering FÃ¶rsÃ¤ljningshistorik fÃ¶r',0),(333492,9264,'it','Cronologia delle vendite di inventario per',0),(333493,9264,'tl','',0),(333494,9264,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;&#3586;&#3629;&#3591;',0),(333495,9264,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(333496,9264,'ms','Sejarah jualan Inventori bagi',0),(333497,9264,'ar','Ø­Ø±ÙƒØ© Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù„Ù€',0),(333498,9264,'fr','L\'inventaire historique des ventes pour',0),(333499,9264,'jp','åœ¨åº«ã®è²©å£²å±¥æ­´',0),(333500,9264,'pt','InventÃ¡rio histÃ³rico de vendas para',0),(333501,9264,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð´Ð»Ñ',0),(333502,9264,'es','Historia de Ventas de Inventario Para',0),(333503,9264,'de','Inventar Vertriebshistorie fÃ¼r',0),(333504,9264,'en','Inventory Sales History For',0),(333505,9265,'is','',0),(333506,9265,'dr','ÙØ±ÙˆØ´ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(333507,9265,'pr','ÙØ±ÙˆØ´ Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(333508,9265,'tr','EÅŸleÅŸen hiÃ§bir satÄ±ÅŸ bulundu',0),(333509,9265,'pl','Nie pasujÄ…ce sprzedaÅ¼y Znalezione',0),(333510,9265,'bg','ÐÑÐ¼Ð° ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð°Ñ‰Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(333511,9265,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø³ÛŒÙ„Ø² Ù¾Ø§ÛŒØ§',0),(333512,9265,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(333513,9265,'vi','KhÃ´ng tÃ¬m tháº¥y Ä‘Æ¡n mua hÃ ng phÃ¹ há»£p',0),(333514,9265,'af','Geen ooreenstemmende verkope gevind',0),(333515,9265,'ro','Nici o vÃ¢nzare de potrivire gÄƒsit',0),(333516,9265,'et','Leitud sobitamine mÃ¼Ã¼k',0),(333517,9265,'si','Ujemanje prodaje naÅ¡el',0),(333518,9265,'ba','Tidak ada penjualan pencocokan yang ditemukan',0),(333519,9265,'nl','Geen overeenkomende verkoop gevonden',0),(333520,9265,'fi','Ei ole vastaavaa myyntiÃ¤ lÃ¶ytyi',0),(333521,9265,'no','Ingen samsvarende salg funnet',0),(333522,9265,'da','Ingen matchende salg fundet',0),(333523,9265,'ko','ì°¾ì„ ì¼ì¹˜ í•˜ íŒë§¤',0),(333524,9265,'he','×œ× × ×ž×¦××• ×ž×›×™×¨×•×ª ×ª×•××ž×•×ª',0),(333525,9265,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(333526,9265,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„é”€å”®\r\n',0),(333527,9265,'sv','Ingen matchande fÃ¶rsÃ¤ljning hittade',0),(333528,9265,'it','Nessuna vendita corrispondente trovata',0),(333529,9265,'tl','',0),(333530,9265,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(333531,9265,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤ªà¤¾à¤¯à¤¾',0),(333532,9265,'ms','Tiada jualan padanan yang ditemui',0),(333533,9265,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ø¨ÙŠØ¹Ø§Øª Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(333534,9265,'fr','Aucune vente correspondant trouvÃ©',0),(333535,9265,'jp','è¦‹ã¤ã‹ã£ãŸä¸€è‡´ã™ã‚‹ãªã—è²©å£²',0),(333536,9265,'pt','Vendas nÃ£o correspondÃªncia encontradas',0),(333537,9265,'ru','Ð¡Ð¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(333538,9265,'es','No se EncontrÃ³ Ventas Pareadas',0),(333539,9265,'de','Keine passenden VerkÃ¤ufe gefunden',0),(333540,9265,'en','No Matching Sales Found',0),(333541,9266,'is','',0),(333542,9266,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙˆØ¯ ',0),(333543,9266,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙˆØ¯ ',0),(333544,9266,'tr','Kar tutarÄ±',0),(333545,9266,'pl','Kwota zysku',0),(333546,9266,'bg','ÐžÐ±ÐµÐ¼ Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°Ñ‚Ð°',0),(333547,9266,'ur','Ù…Ù†Ø§ÙØ¹ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(333548,9266,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð´Ð¾Ð±Ð¸Ñ‚Ð¸',0),(333549,9266,'vi','Sá»‘ tiá»n Lá»£i nhuáº­n',0),(333550,9266,'af','Bedrag Wins',0),(333551,9266,'ro','Suma profitului',0),(333552,9266,'et','Kasumi summa',0),(333553,9266,'si','Znesek dobiÄka',0),(333554,9266,'ba','Jumlah keuntungan',0),(333555,9266,'nl','Winstbedrag',0),(333556,9266,'fi','Tuottosumma',0),(333557,9266,'no','BruttofortjenestebelÃ¸p',0),(333558,9266,'da','AvancebelÃ¸b',0),(333559,9266,'ko','ì´ìµ ê¸ˆì•¡',0),(333560,9266,'he','×¡×›×•× ×”×¨×•×•×—',0),(333561,9266,'el','Î Î¿ÏƒÏŒ ÎºÎ­ÏÎ´Î¿Ï…Ï‚',0),(333562,9266,'zh','åˆ©æ¶¦æ€»é¢\r\n',0),(333563,9266,'sv','TB-belopp',0),(333564,9266,'it','QuantitÃ  di profitto',0),(333565,9266,'tl','',0),(333566,9266,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3635;&#3652;&#3619;',0),(333567,9266,'hi','à¤²à¤¾à¤­ à¤°à¤¾à¤¶à¤¿',0),(333568,9266,'ms','Jumlah keuntungan',0),(333569,9266,'ar','Ù…Ù‚Ø¯Ø§Ø± Ø§Ù„Ø±Ø¨Ø­',0),(333570,9266,'fr','Montant des bÃ©nÃ©fices',0),(333571,9266,'jp','åˆ©ç›Šé¡',0),(333572,9266,'pt','Valor do lucro',0),(333573,9266,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸',0),(333574,9266,'es','Monto de Utilidad',0),(333575,9266,'de','Deckungsbeitrag',0),(333576,9266,'en','Profit Amount',0),(333577,9267,'is','',0),(333578,9267,'dr','Ø¯Ø±ØµØ¯ Ø³ÙˆØ¯ ',0),(333579,9267,'pr','Ø¯Ø±ØµØ¯ Ø³ÙˆØ¯ ',0),(333580,9267,'tr','Kar %',0),(333581,9267,'pl','% Zysku',0),(333582,9267,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð° %',0),(333583,9267,'ur','Ù…Ù†Ø§ÙØ¹ %',0),(333584,9267,'sr','% Ð”Ð¾Ð±Ð¸Ñ‚ÐºÐ°',0),(333585,9267,'vi','% Lá»£i nhuáº­n ',0),(333586,9267,'af','Wins %',0),(333587,9267,'ro','Profit %',0),(333588,9267,'et','Kasumi %',0),(333589,9267,'si','DobiÄek %',0),(333590,9267,'ba','Profit %',0),(333591,9267,'nl','Winst %',0),(333592,9267,'fi','Tuotto %',0),(333593,9267,'no','Bruttofortjeneste %',0),(333594,9267,'da','Avance i %',0),(333595,9267,'ko','ì´ìµ %',0),(333596,9267,'he','% ×—×•×•×¨',0),(333597,9267,'el','ÎšÎ­ÏÎ´Î¿Ï‚ %',0),(333598,9267,'zh','åˆ©æ¶¦çš„ç™¾åˆ†æ¯”\r\n',0),(333599,9267,'sv','TG',0),(333600,9267,'it','% Di profitto',0),(333601,9267,'tl','',0),(333602,9267,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3585;&#3635;&#3652;&#3619;',0),(333603,9267,'hi','à¤²à¤¾à¤­ %',0),(333604,9267,'ms','% Keuntungan',0),(333605,9267,'ar','% Ø§Ù„Ø£Ø±Ø¨Ø§Ø­',0),(333606,9267,'fr','Pourcentage de marge',0),(333607,9267,'jp','åˆ©ç›Š %',0),(333608,9267,'pt','% De lucro',0),(333609,9267,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ %',0),(333610,9267,'es','Utilidad %',0),(333611,9267,'de','Profit %',0),(333612,9267,'en','Profit %',0),(333613,9268,'is','',0),(333614,9268,'dr','Ø¯Ø±ØµØ¯ Ø³ÙˆØ¯ ',0),(333615,9268,'pr','Ø¯Ø±ØµØ¯ Ø³ÙˆØ¯ ',0),(333616,9268,'tr','Kar %',0),(333617,9268,'pl','% Zysku',0),(333618,9268,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð° %',0),(333619,9268,'ur','Ù…Ù†Ø§ÙØ¹ %',0),(333620,9268,'sr','% Ð”Ð¾Ð±Ð¸Ñ‚ÐºÐ°',0),(333621,9268,'vi','% Lá»£i nhuáº­n ',0),(333622,9268,'af','Wins %',0),(333623,9268,'ro','Profit %',0),(333624,9268,'et','Kasumi %',0),(333625,9268,'si','DobiÄek %',0),(333626,9268,'ba','Profit %',0),(333627,9268,'nl','Winst %',0),(333628,9268,'fi','Tuotto %',0),(333629,9268,'no','Bruttofortjeneste %',0),(333630,9268,'da','Avance i %',0),(333631,9268,'ko','ì´ìµ %',0),(333632,9268,'he','% ×—×•×•×¨',0),(333633,9268,'el','ÎšÎ­ÏÎ´Î¿Ï‚ %',0),(333634,9268,'zh','ï¼…çš„åˆ©æ¶¦\r\n',0),(333635,9268,'sv','TG',0),(333636,9268,'it','% Di profitto',0),(333637,9268,'tl','',0),(333638,9268,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3585;&#3635;&#3652;&#3619;',0),(333639,9268,'hi','à¤²à¤¾à¤­ %',0),(333640,9268,'ms','% Keuntungan',0),(333641,9268,'ar','% Ø§Ù„Ø£Ø±Ø¨Ø§Ø­',0),(333642,9268,'fr','Pourcentage de marge',0),(333643,9268,'jp','åˆ©ç›Š %',0),(333644,9268,'pt','% De lucro',0),(333645,9268,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ %',0),(333646,9268,'es','Utilidad %',0),(333647,9268,'de','Profit %',0),(333648,9268,'en','Profit %',0),(333649,9269,'is','',0),(333650,9269,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ú¯Ø²Ø§Ø±Ø´',0),(333651,9269,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ú¯Ø²Ø§Ø±Ø´',0),(333652,9269,'tr','Rapor ayrÄ±ntÄ±',0),(333653,9269,'pl','SzczegÃ³Å‚owy raport',0),(333654,9269,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð´ÐµÑ‚Ð°Ð¹Ð»',0),(333655,9269,'ur','Ø±Ù¾ÙˆØ±Ù¹ ØªÙØµÛŒÙ„',0),(333656,9269,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð´ÐµÑ‚Ð°Ñ™Ð¸Ð¼Ð°',0),(333657,9269,'vi','BÃ¡o cÃ¡o chi tiáº¿t',0),(333658,9269,'af','Verslag Detail',0),(333659,9269,'ro','Raport detaliat',0),(333660,9269,'et','Aruande Ã¼ksikasjad',0),(333661,9269,'si','Podrobno poroÄilo',0),(333662,9269,'ba','Laporan rinci',0),(333663,9269,'nl','Verslag Detail',0),(333664,9269,'fi','Raportin tiedot',0),(333665,9269,'no','Rapporten detaljer',0),(333666,9269,'da','Rapporten detaljeret',0),(333667,9269,'ko','ë³´ê³ ì„œ ì„¸ë¶€ ì‚¬í•­',0),(333668,9269,'he','×“×• ×— ×ž×¤×•×¨×˜',0),(333669,9269,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î­ÎºÎ¸ÎµÏƒÎ·',0),(333670,9269,'zh','æŠ¥å‘Šè¯¦ç»†\r\n',0),(333671,9269,'sv','Rapporten i detalj',0),(333672,9269,'it','Report dettaglio',0),(333673,9269,'tl','',0),(333674,9269,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(333675,9269,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤µà¤¿à¤µà¤°à¤£',0),(333676,9269,'ms','Laporan terperinci',0),(333677,9269,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(333678,9269,'fr','Rapport en dÃ©tail',0),(333679,9269,'jp','ãƒ¬ãƒãƒ¼ãƒˆã®è©³ç´°',0),(333680,9269,'pt','Detalhe do relatÃ³rio',0),(333681,9269,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ ÐžÑ‚Ñ‡ÐµÑ‚Ð°',0),(333682,9269,'es','Detalle de Informe',0),(333683,9269,'de','Bericht-Detail',0),(333684,9269,'en','Report Detail',0),(333685,9270,'is','',0),(333686,9270,'dr','Ù…Ù†Ø§Ø¨Ø¹ Ú¯Ø²Ø§Ø±Ø´ ',0),(333687,9270,'pr','Ù…Ù†Ø§Ø¨Ø¹ Ú¯Ø²Ø§Ø±Ø´ ',0),(333688,9270,'tr','Rapor tercihleri',0),(333689,9270,'pl','Ustawienia raportu',0),(333690,9270,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½Ð¸Ñ Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(333691,9270,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú©ÛŒ ØªØ±Ø¬ÛŒØ­Ø§Øª',0),(333692,9270,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¿Ñ€ÐµÑ„ÐµÑ€ÐµÐ½Ñ†Ðµ',0),(333693,9270,'vi','BÃ¡o cÃ¡o sá»Ÿ thÃ­ch',0),(333694,9270,'af','Verslag Voorkeure',0),(333695,9270,'ro','Raport PreferinÅ£e',0),(333696,9270,'et','Aruande eelistuste',0),(333697,9270,'si','Nastavitve poroÄila',0),(333698,9270,'ba','Laporan preferensi',0),(333699,9270,'nl','Verslag voorkeuren',0),(333700,9270,'fi','Raportin asetukset',0),(333701,9270,'no','Rapporten innstillinger',0),(333702,9270,'da','BetÃ¦nkningen prÃ¦ferencer',0),(333703,9270,'ko','ë³´ê³ ì„œ ì„¤ì •',0),(333704,9270,'he','×“×•×— ×”×¢×“×¤×•×ª',0),(333705,9270,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï€ÏÎ¿Ï„Î¹Î¼Î®ÏƒÎµÎ¹Ï‚',0),(333706,9270,'zh','æŠ¥å‘Šé¦–é€‰é¡¹\r\n',0),(333707,9270,'sv','Rapport-instÃ¤llningar',0),(333708,9270,'it','Relazione preferenze',0),(333709,9270,'tl','',0),(333710,9270,'th','&#3648;&#3626;&#3609;&#3629;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(333711,9270,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤µà¤°à¥€à¤¯à¤¤à¤¾à¤à¤',0),(333712,9270,'ms','Laporan pilihan',0),(333713,9270,'ar','ØªÙØ¶ÙŠÙ„Ø§Øª Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(333714,9270,'fr','PrÃ©fÃ©rences de rapport',0),(333715,9270,'jp','ãƒ¬ãƒãƒ¼ãƒˆè¨­å®š',0),(333716,9270,'pt','PreferÃªncias de relatÃ³rio',0),(333717,9270,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚ÐµÐ½Ð¸Ñ ÐžÑ‚Ñ‡ÐµÑ‚Ð°',0),(333718,9270,'es','Preferencias de Informe',0),(333719,9270,'de','Bericht \"Einstellungen\"',0),(333720,9270,'en','Report Preferences',0),(333721,9271,'is','',0),(333722,9271,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡   ÙØ±ÙˆØ´ ',0),(333723,9271,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡   ÙØ±ÙˆØ´ ',0),(333724,9271,'tr','SatÄ±ÅŸ deÄŸeri',0),(333725,9271,'pl','WartoÅ›Ä‡ sprzedaÅ¼y',0),(333726,9271,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(333727,9271,'ur','ÙØ±ÙˆØ®Øª Ú©ÛŒ Ù‚Ø¯Ø±',0),(333728,9271,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(333729,9271,'vi','GiÃ¡ trá»‹ bÃ¡n hÃ ng',0),(333730,9271,'af','Verkoopswaarde',0),(333731,9271,'ro','Valoarea de vÃ¢nzare',0),(333732,9271,'et','MÃ¼Ã¼gi vÃ¤Ã¤rtus',0),(333733,9271,'si','Vrednost prodaje',0),(333734,9271,'ba','Nilai penjualan',0),(333735,9271,'nl','Verkoopwaarde',0),(333736,9271,'fi','Myyntiarvoa',0),(333737,9271,'no','Salgsverdi',0),(333738,9271,'da','SalgsvÃ¦rdi',0),(333739,9271,'ko','íŒë§¤ ê°’',0),(333740,9271,'he','×¢×¨×š ×ž×›×™×¨×”',0),(333741,9271,'el','Î‘Î¾Î¯Î± Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(333742,9271,'zh','é”€å”®å€¼\r\n',0),(333743,9271,'sv','FÃ¶rsÃ¤ljningsvÃ¤rde',0),(333744,9271,'it','Valore di vendita',0),(333745,9271,'tl','',0),(333746,9271,'th','&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(333747,9271,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤®à¥‚à¤²à¥à¤¯',0),(333748,9271,'ms','Nilai jualan',0),(333749,9271,'ar','Ù‚ÙŠÙ…Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(333750,9271,'fr','Valeur de vente',0),(333751,9271,'jp','è²©å£²å€¤',0),(333752,9271,'pt','Valor de venda',0),(333753,9271,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(333754,9271,'es','Monto de Venta',0),(333755,9271,'de','Verkaufswert',0),(333756,9271,'en','Sale Value',0),(333757,9272,'is','',0),(333758,9272,'dr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚ ',0),(333759,9272,'pr','Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ú¯Ø²Ø§Ø±Ø´ Ø·Ø¨Ù‚ ',0),(333760,9272,'tr','GÃ¶re sÄ±ralama raporu',0),(333761,9272,'pl','Raport sortowania',0),(333762,9272,'bg','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð¾Ñ‚',0),(333763,9272,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø±Ù¾ÙˆØ±Ù¹ Ú†Ú¾Ø§Ù†Ù¹ÛŒÚº',0),(333764,9272,'sr','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°ÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(333765,9272,'vi','Sáº¯p xáº¿p bÃ¡o cÃ¡o theo',0),(333766,9272,'af','Sorteer Verslag Per',0),(333767,9272,'ro','Un fel de raport de',0),(333768,9272,'et','Sorteeri Raport',0),(333769,9272,'si','PoroÄilo razvrÅ¡Äanja',0),(333770,9272,'ba','Jenis laporan',0),(333771,9272,'nl','Soort verslag van',0),(333772,9272,'fi','Lajittele mietintÃ¶',0),(333773,9272,'no','Sortere rapporten etter',0),(333774,9272,'da','Sortere rapporten af',0),(333775,9272,'ko','ì •ë ¬ ë³´ê³ ì„œ',0),(333776,9272,'he','×ž×™×•×Ÿ ×”×“×•×— ×¢×œ-×™×“×™',0),(333777,9272,'el','Î•Î¯Î´Î¿Ï‚ Î­ÎºÎ¸ÎµÏƒÎ·Ï‚ Ï„Î¿Ï…',0),(333778,9272,'zh','åˆ†ç±»æŠ¥å‘Šæ–¹å¼\r\n',0),(333779,9272,'sv','Sortera betÃ¤nkande av',0),(333780,9272,'it','Relazione del tipo',0),(333781,9272,'tl','',0),(333782,9272,'th','&#3592;&#3633;&#3604;&#3648;&#3619;&#3637;&#3618;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3650;&#3604;&#3618;',0),(333783,9272,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(333784,9272,'ms','Jenis laporan oleh',0),(333785,9272,'ar','ÙØ±Ø² ØªÙ‚Ø±ÙŠØ±',0),(333786,9272,'fr','Rapport de la sorte par',0),(333787,9272,'jp','ä¸¦ã¹æ›¿ãˆã®å ±å‘Šæ›¸',0),(333788,9272,'pt','RelatÃ³rio de classificaÃ§Ã£o por',0),(333789,9272,'ru','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐžÑ‚Ñ‡ÐµÑ‚ ÐŸÐ¾',0),(333790,9272,'es','Sortea Informe Por',0),(333791,9272,'de','Art-Bericht von',0),(333792,9272,'en','Sort Report By',0),(333793,9273,'is','',0),(333794,9273,'dr','Ø¬Ù…Ø¹ Ø¬Ø²Ø¡ ØªÙˆØ³Ø·',0),(333795,9273,'pr','Ø¬Ù…Ø¹ Ø¬Ø²Ø¡ ØªÙˆØ³Ø·',0),(333796,9273,'tr','TarafÄ±ndan alt toplamÄ±',0),(333797,9273,'pl','Suma czÄ™Å›ciowa przez',0),(333798,9273,'bg','ÐœÐµÐ¶Ð´Ð¸Ð½Ð½Ð° ÑÑƒÐ¼Ð° Ð¾Ñ‚',0),(333799,9273,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø°ÛŒÙ„ÛŒ Ù…ÛŒØ²Ø§Ù†',0),(333800,9273,'sr','ÐŸÐ¾Ð´Ð·Ð±Ð¸Ñ€ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(333801,9273,'vi','Tá»•ng cá»™ng phá»¥ bá»Ÿi',0),(333802,9273,'af','Subtotaal Per',0),(333803,9273,'ro','Subtotal de',0),(333804,9273,'et','Vahesumma â€“ poolt',0),(333805,9273,'si','SeÅ¡tevek z',0),(333806,9273,'ba','Subtotal oleh',0),(333807,9273,'nl','Subtotaal door',0),(333808,9273,'fi','MennessÃ¤ yhteensÃ¤',0),(333809,9273,'no','Delsum ved',0),(333810,9273,'da','Subtotal af',0),(333811,9273,'ko','ì˜í•´ ë¶€ë¶„í•©',0),(333812,9273,'he','×¡×›×•× ×‘×™× ×™×™× ×¢×œ-×™×“×™',0),(333813,9273,'el','ÎœÎµÏÎ¹ÎºÏŒ ÏƒÏÎ½Î¿Î»Î¿ Î±Ï€ÏŒ',0),(333814,9273,'zh','é€šè¿‡å°è®¡\r\n',0),(333815,9273,'sv','Delsumma av',0),(333816,9273,'it','Totale parziale di',0),(333817,9273,'tl','',0),(333818,9273,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3618;&#3656;&#3629;&#3618;&#3650;&#3604;&#3618;',0),(333819,9273,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‰à¤ª-à¤¯à¥‹à¤— à¤•à¤°à¤¨à¤¾',0),(333820,9273,'ms','Jumlah kecil oleh',0),(333821,9273,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ Ù„Ø·Ø±ÙŠÙ‚',0),(333822,9273,'fr','Sous-total par',0),(333823,9273,'jp','å°è¨ˆã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(333824,9273,'pt','Subtotal por',0),(333825,9273,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾ Ð¿Ð¾',0),(333826,9273,'es','Subtotal Por',0),(333827,9273,'de','Zwischensumme nach',0),(333828,9273,'en','Subtotal By',0),(333829,9274,'is','',0),(333830,9274,'dr','ÙÙ‚Ø· Ø®Ù„Ø§ØµÙ‡ ',0),(333831,9274,'pr','ÙÙ‚Ø· Ø®Ù„Ø§ØµÙ‡ ',0),(333832,9274,'tr','YalnÄ±zca Ã–zet',0),(333833,9274,'pl','Tylko podsumowanie',0),(333834,9274,'bg','Ð ÐµÐ·ÑŽÐ¼Ðµ ÑÐ°Ð¼Ð¾',0),(333835,9274,'ur','ÙÙ‚Ø· Ø®Ù„Ø§ØµÛ',0),(333836,9274,'sr','Ð¡Ð°Ð¼Ð¾ Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(333837,9274,'vi','Chá»‰ tá»•ng há»£p',0),(333838,9274,'af','Opsomming Alleenlik',0),(333839,9274,'ro','Rezumat numai',0),(333840,9274,'et','Nult KokkuvÃµte',0),(333841,9274,'si','Samo Povzetek',0),(333842,9274,'ba','Ringkasan hanya',0),(333843,9274,'nl','Alleen totalen',0),(333844,9274,'fi','Vain Yhteenveto',0),(333845,9274,'no','Bare Sammendrag',0),(333846,9274,'da','ResumÃ© kun',0),(333847,9274,'ko','ìš”ì•½ë§Œ',0),(333848,9274,'he','×”×¡×™×›×•× ×‘×œ×‘×“',0),(333849,9274,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Î¼ÏŒÎ½Î¿',0),(333850,9274,'zh','ä»…æ‘˜è¦\r\n',0),(333851,9274,'sv','Sammanfattning endast',0),(333852,9274,'it','Solo riepilogo',0),(333853,9274,'tl','',0),(333854,9274,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3626;&#3619;&#3640;&#3611;',0),(333855,9274,'hi','à¤•à¥‡à¤µà¤² à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(333856,9274,'ms','Ringkasan sahaja',0),(333857,9274,'ar','Ù…Ù„Ø®Ù‘Øµ ÙÙ‚Ø·',0),(333858,9274,'fr','RÃ©sumÃ© seulement',0),(333859,9274,'jp','è¦ç´„ã®ã¿',0),(333860,9274,'pt','Resumo apenas',0),(333861,9274,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(333862,9274,'es','Resumen Solamente',0),(333863,9274,'de','Nur Zusammenfassung',0),(333864,9274,'en','Summary Only',0),(333865,9275,'is','',0),(333866,9275,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ Ú¯Ø²Ø§Ø±Ø´ ',0),(333867,9275,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÙŠ Ú¯Ø²Ø§Ø±Ø´ ',0),(333868,9275,'tr','Rapor toplamÄ±',0),(333869,9275,'pl','ÅÄ…cznie dla raportu',0),(333870,9275,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(333871,9275,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„',0),(333872,9275,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(333873,9275,'vi','Tá»•ng cá»™ng cho bÃ¡o cÃ¡o',0),(333874,9275,'af','Totaal vir Verslag',0),(333875,9275,'ro','Total pentru raport',0),(333876,9275,'et','Kokku aruandele',0),(333877,9275,'si','Skupno poroÄilo',0),(333878,9275,'ba','Total untuk laporan',0),(333879,9275,'nl','Totaal voor rapport',0),(333880,9275,'fi','Raportin kokonaissumma',0),(333881,9275,'no','Totalt for rapport',0),(333882,9275,'da','Totalen for rapport',0),(333883,9275,'ko','ë³´ê³ ì„œì— ëŒ€ í•œ ì´',0),(333884,9275,'he','×¡×” ×¢×‘×•×¨ ×“×•×—',0),(333885,9275,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î³Î¹Î± Ï„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ·',0),(333886,9275,'zh','æ€»è®¡æŠ¥å‘Š\r\n',0),(333887,9275,'sv','Totalt fÃ¶r rapport',0),(333888,9275,'it','Totale per relazione',0),(333889,9275,'tl','',0),(333890,9275,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(333891,9275,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²',0),(333892,9275,'ms','Jumlah keseluruhan Laporan',0),(333893,9275,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ù„Ù„ØªÙ‚Ø±ÙŠØ±',0),(333894,9275,'fr','Total pour le rapport',0),(333895,9275,'jp','ãƒ¬ãƒãƒ¼ãƒˆã®åˆè¨ˆ',0),(333896,9275,'pt','Total para o relatÃ³rio',0),(333897,9275,'ru','Ð’ÑÐµÐ³Ð¾ Ð´Ð»Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(333898,9275,'es','Total para Informe',0),(333899,9275,'de','Insgesamt fÃ¼r Bericht',0),(333900,9275,'en','Total for Report',0),(333901,9276,'is','',0),(333902,9276,'dr','Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯  Ú†Ù†Ø§Ù†Ú†Ù‡  Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†Ø¯',0),(333903,9276,'pr','Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯  Ú†Ù†Ø§Ù†Ú†Ù‡  Ø®Ø±ÙŠØ¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†Ø¯',0),(333904,9276,'tr','EÄŸer boÅŸ bÄ±rakÄ±n mÃ¼ÅŸteri alma',0),(333905,9276,'pl','Pozostaw puste JeÅ›li klient Pickup',0),(333906,9276,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð°ÐºÐ¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¿Ð¸ÐºÐ°Ð¿',0),(333907,9276,'ur','Ø§Ú¯Ø± Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ú©Ø³Ù¹Ù…Ø± Ø§Ù¹Ú¾Ø§ Ù„ÛŒÙ†Ø§',0),(333908,9276,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð°ÐºÐ¾ ÐºÑƒÐ¿Ð°Ñ† Ð¿Ð¸ÐºÐ°Ð¿',0),(333909,9276,'vi','Äá»ƒ trá»‘ng náº¿u khÃ¡ch hÃ ng Ä‘áº¿n nháº­n hÃ ng',0),(333910,9276,'af','LeÃ« verlaat as kliÃ«nt bakkie',0),(333911,9276,'ro','LÄƒsaÅ£i necompletat dacÄƒ clientul Pickup',0),(333912,9276,'et','JÃ¤ta tÃ¼hjaks, kui klient tuleb jÃ¤rgi',0),(333913,9276,'si','Pustite prazno, Äe kupec Pickup',0),(333914,9276,'ba','Kosongkan jika pelanggan Pickup',0),(333915,9276,'nl','Leeg laten als klant Pickup',0),(333916,9276,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi, jos asiakkaan noudettavissa',0),(333917,9276,'no','La stÃ¥ tomt hvis kunden Pickup',0),(333918,9276,'da','Efterlad Blank hvis kunden Pickup',0),(333919,9276,'ko','ë§Œì•½ ë¹ˆì„ ë– ë‚˜ ê³ ê° í”½ì—…',0),(333920,9276,'he','×œ×”×©××™×¨ ×¨×™×§ ×× ×”×œ×§×•×— ××™×¡×•×£',0),(333921,9276,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ ÎµÎ¬Î½ Ï€ÎµÎ»Î¬Ï„Î· Pickup',0),(333922,9276,'zh','å¦‚æžœå®¢æˆ·å–ä»¶ç•™ç©º\r\n',0),(333923,9276,'sv','LÃ¤mna tomt om kunden Pickup',0),(333924,9276,'it','Lasciare vuoto se cliente Pickup',0),(333925,9276,'tl','',0),(333926,9276,'th','&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3606;&#3657;&#3634;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3586;&#3609;&#3648;&#3629;&#3591;',0),(333927,9276,'hi','à¤–à¤¾à¤²à¥€ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚ à¤¯à¤¦à¤¿ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¬à¤Ÿà¥‹à¤°à¤¨à¤¾',0),(333928,9276,'ms','Biarkan kosong jika pelanggan pikap',0),(333929,9276,'ar','ØªØ±Ùƒ ÙØ§Ø±ØºØ§Ù‹ Ø¥Ø°Ø§ ÙƒØ§Ù† \"Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø¨ÙŠÙƒ Ø¢Ø¨\"',0),(333930,9276,'fr','Laisser en blanc si client Pickup',0),(333931,9276,'jp','å ´åˆã¯ç©ºç™½ã®ã¾ã¾ã«é¡§å®¢ã®ãƒ”ãƒƒã‚¯ã‚¢ãƒƒãƒ—',0),(333932,9276,'pt','Deixe em branco se cliente Pickup',0),(333933,9276,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, ÐµÑÐ»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ð¸ÐºÐ°Ð¿',0),(333934,9276,'es','Deja en Blanco si Recoge el Cliente',0),(333935,9276,'de','Leer lassen, wenn Kunden Pickup',0),(333936,9276,'en','Leave Blank if Customer Pickup',0),(333937,9277,'is','',0),(333938,9277,'dr','Ø¢ÙŠØ§ ÙƒÙ…ØªØ± Ø§Ø² ÙˆØ²Ù† Ù‚Ø·Ø¹Ø§Øª ÙØ±Ø¹ÙŠ  Ø§Ø² ',0),(333939,9277,'pr','Ø¢ÙŠØ§ ÙƒÙ…ØªØ± Ø§Ø² ÙˆØ²Ù† Ù‚Ø·Ø¹Ø§Øª ÙØ±Ø¹ÙŠ  Ø§Ø² ',0),(333940,9277,'tr','alt kÄ±sÄ±mlarÄ± aÄŸÄ±rlÄ±ÄŸÄ±nÄ± kÃ¼Ã§Ã¼ktÃ¼r:',0),(333941,9277,'pl','jest mniejsza niÅ¼ waga elementÃ³w podrzÄ™dnych:',0),(333942,9277,'bg','Ðµ Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¾Ñ‚ Ñ‚ÐµÐ³Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð¿Ð¾Ð´-Ñ‡Ð°ÑÑ‚Ð¸ Ð¾Ñ‚:',0),(333943,9277,'ur','Ø°ÛŒÙ„ÛŒ Ø­ØµÙˆÚº Ú©Û’ ÙˆØ²Ù† Ø³Û’ Ú©Ù… ÛÛ’ Û”',0),(333944,9277,'sr','Ð¼Ð°ÑšÐ° Ñ˜Ðµ Ð¾Ð´ Ñ‚ÐµÐ¶Ð¸Ð½Ñƒ Ð¿Ð¾Ð´-Ð´ÐµÐ»Ð¾Ð²Ð°:',0),(333945,9277,'vi','nháº¹ hÆ¡n trá»ng lÆ°á»£ng cá»§a phá»¥ tÃ¹ng phá»¥ cá»§a:',0),(333946,9277,'af','minder is as die gewig van sub dele van:',0),(333947,9277,'ro','este la mai puÅ£in de greutate de sub-pÄƒrÅ£i ale:',0),(333948,9277,'et','on Alam osa mass on vÃ¤iksem kui:',0),(333949,9277,'si','je manjÅ¡a od teÅ¾e sub-delov:',0),(333950,9277,'ba','berjarak kurang dari berat sub bagian:',0),(333951,9277,'nl','is minder dan het gewicht van sub delen van:',0),(333952,9277,'fi','on pienempi kuin paino osa osat:',0),(333953,9277,'no','er mindre enn vekten av sub deler av:',0),(333954,9277,'da','er mindre end vÃ¦gten af underordnede dele af:',0),(333955,9277,'ko','í•˜ìœ„ ë¶€í’ˆì˜ ë¬´ê²Œ ë³´ë‹¤ëŠ” ë” ì ì€ ì´ë‹¤.',0),(333956,9277,'he','×”×•× ×¤×—×•×ª ×ž×©×§×œ ×—×œ×§×™ ×ž×©× ×”:',0),(333957,9277,'el','ÎµÎ¯Î½Î±Î¹ Î¼Î¹ÎºÏÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ Ï„Î¿ Î²Î¬ÏÎ¿Ï‚ Ï„Ï‰Î½ ÎµÏ€Î¹Î¼Î­ÏÎ¿Ï…Ï‚ Ï„Î¼Î·Î¼Î¬Ï„Ï‰Î½ Ï„Î¿Ï…:',0),(333958,9277,'zh','æ¯”å­éƒ¨åˆ†çš„é‡é‡å°‘ï¼Ÿ\r\n',0),(333959,9277,'sv','Ã¤r mindre Ã¤n sub delar av vikt:',0),(333960,9277,'it','Ã¨ minore del peso del sub-parti di:',0),(333961,9277,'tl','',0),(333962,9277,'th','&#3588;&#3639;&#3629;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;&#3586;&#3629;&#3591;&#3626;&#3656;&#3623;&#3609;&#3618;&#3656;&#3629;&#3618;&#3586;&#3629;&#3591;:',0),(333963,9277,'hi','à¤•à¥€ à¤‰à¤ª-à¤­à¤¾à¤—à¥‹à¤‚ à¤•à¥‡ à¤µà¤œà¤¨ à¤¸à¥‡ à¤•à¤® à¤¹à¥ˆ:',0),(333964,9277,'ms','adalah kurang daripada berat bahagian-bahagian kecil:',0),(333965,9277,'ar','Ø£Ù‚Ù„ Ù…Ù† ÙˆØ²Ù† Ø§Ù„Ø£Ø¬Ø²Ø§Ø¡ Ø§Ù„ÙØ±Ø¹ÙŠØ© Ù…Ù†:',0),(333966,9277,'fr','est infÃ©rieure au poids des sous-parties de :',0),(333967,9277,'jp','ã‚‚å°ã•ã„ã®ã‚µãƒ–éƒ¨å“ã®é‡é‡ã€‚',0),(333968,9277,'pt','Ã© menor do que o peso do sub partes de:',0),(333969,9277,'ru','Ð¼ÐµÐ½ÑŒÑˆÐµ, Ñ‡ÐµÐ¼ Ð²ÐµÑ Ð±Ð»Ð¾ÐºÐ¸:',0),(333970,9277,'es','es menos que el peso de los Sub-Partes de:',0),(333971,9277,'de','ist kleiner als das Gewicht des Sub Teilen:',0),(333972,9277,'en','is less than the weight of Sub-Parts of:',0),(333973,9278,'is','',0),(333974,9278,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§ØµÙ„ÙŠ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¨Ù‡Ø§ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(333975,9278,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ØµÙ„ÙŠ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¨Ù‡Ø§ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(333976,9278,'tr','Orijinal miktarÄ± bir deÄŸeri olmalÄ±dÄ±r',0),(333977,9278,'pl','Oryginalny iloÅ›Ä‡ musi mieÄ‡ wartoÅ›Ä‡',0),(333978,9278,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(333979,9278,'ur','Ø§ØµÙ„ Ù…Ù‚Ø¯Ø§Ø± Ù„Ø§Ø²Ù…ÛŒ Ø§ÛŒÚ© Ù‚Ø¯Ø± ÛÛ’ Û”',0),(333980,9278,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¼Ð¾Ñ€Ð° Ð¸Ð¼Ð°Ñ‚Ð¸ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(333981,9278,'vi','Sá»‘ lÆ°á»£ng gá»‘c pháº£i cÃ³ 1 giÃ¡ trá»‹',0),(333982,9278,'af','Oorspronklike hoeveelheid moet \'n waarde hÃª',0),(333983,9278,'ro','Original cantitatea trebuie sÄƒ aibÄƒ o valoare',0),(333984,9278,'et','Algne kogus peab olema vÃ¤Ã¤rtus',0),(333985,9278,'si','Original koliÄina mora imeti vrednost',0),(333986,9278,'ba','Asli kuantitas harus memiliki nilai',0),(333987,9278,'nl','Oorspronkelijke hoeveelheid moet hebben een waarde',0),(333988,9278,'fi','AlkuperÃ¤inen mÃ¤Ã¤rÃ¤ on oltava arvo',0),(333989,9278,'no','Opprinnelige antallet mÃ¥ ha en verdi',0),(333990,9278,'da','Oprindelige mÃ¦ngde skal have en vÃ¦rdi',0),(333991,9278,'ko','ì›ëž˜ ì–‘ ê°€ì¹˜ê°€ ìžˆì–´ì•¼',0),(333992,9278,'he','×›×ž×•×ª ×”×ž×§×•×¨×™ ×—×™×™×‘ ×œ×”×™×•×ª ×‘×¢×œ ×¢×¨×š',0),(333993,9278,'el','Î‘ÏÏ‡Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÎ¹ Ï„Î¹Î¼Î®',0),(333994,9278,'zh','åŽŸæ•°é‡å¿…é¡»æœ‰ä¸€ä¸ªå€¼\r\n',0),(333995,9278,'sv','Ursprungliga kvantitet mÃ¥ste ha ett vÃ¤rde',0),(333996,9278,'it','QuantitÃ  originale deve avere un valore',0),(333997,9278,'tl','',0),(333998,9278,'th','&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3604;&#3633;&#3657;&#3591;&#3648;&#3604;&#3636;&#3617;&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3585;&#3634;&#3619;&#3651;&#3626;&#3656;&#3588;&#3656;&#3634;',0),(333999,9278,'hi','à¤®à¥‚à¤² à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤šà¤¾à¤¹à¤¿à¤ à¤à¤• à¤®à¥‚à¤²à¥à¤¯ à¤¹à¥ˆ',0),(334000,9278,'ms','Kuantiti asal mesti mempunyai nilai yang',0),(334001,9278,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø£ØµÙ„ÙŠØ© \"ÙŠØ¬Ø¨\" Ø£Ù† ØªØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ Ù‚ÙŠÙ…Ø©',0),(334002,9278,'fr','Original quantitÃ© doit avoir une valeur',0),(334003,9278,'jp','å€¤ã‚’æŒã¤å¿…è¦ãŒã‚ã‚Šã¾ã™å…ƒã®æ•°é‡',0),(334004,9278,'pt','Original quantidade deve ter um valor',0),(334005,9278,'ru','ÐŸÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð¼ÐµÑ‚ÑŒ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(334006,9278,'es','Cantidad Original DEBE tener un Valor',0),(334007,9278,'de','UrsprÃ¼nglichen muss Menge einen Wert',0),(334008,9278,'en','Original Quantity MUST have a Value',0),(334009,9279,'is','',0),(334010,9279,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙˆØ²Ù† Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ',0),(334011,9279,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙˆØ²Ù† Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ',0),(334012,9279,'tr','Toplam baÅŸlayan aÄŸÄ±rlÄ±k',0),(334013,9279,'pl','CaÅ‚kowita waga',0),(334014,9279,'bg','ÐžÐ±Ñ‰Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ñ‚ÐµÐ³Ð»Ð¾',0),(334015,9279,'ur','Ú©Ù„ Ø¢ØºØ§Ø² ÙˆØ²Ù†',0),(334016,9279,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ ÑƒÐºÑƒÐ¿Ð½Ñƒ Ñ‚ÐµÐ¶Ð¸Ð½Ñƒ',0),(334017,9279,'vi','Tá»•ng cá»™ng trá»ng lÆ°á»£ng ban Ä‘áº§u',0),(334018,9279,'af','Totale Begin Gewig',0),(334019,9279,'ro','Greutatea totalÄƒ de start',0),(334020,9279,'et','Kokku alustades Kaal',0),(334021,9279,'si','Skupni odhod obteÅ¾iti',0),(334022,9279,'ba','Total berat awal',0),(334023,9279,'nl','Totale basisgewicht',0),(334024,9279,'fi','Alkaa kokonaispaino',0),(334025,9279,'no','Start totalvekt',0),(334026,9279,'da','Samlede startvÃ¦gt',0),(334027,9279,'ko','ì´ ì‹œìž‘ ë¬´ê²Œ',0),(334028,9279,'he','×¡×” ×› ×ž×©×§×œ ×”×ª×—×œ×ª×™',0),(334029,9279,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Î²Î¬ÏÎ¿Ï‚ ÎµÎºÎºÎ¯Î½Î·ÏƒÎ·Ï‚',0),(334030,9279,'zh','æ€»å§‹é‡\r\n',0),(334031,9279,'sv','Total startvikt',0),(334032,9279,'it','Totale peso di partenza',0),(334033,9279,'tl','',0),(334034,9279,'th','&#3612;&#3621;&#3619;&#3623;&#3617;&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(334035,9279,'hi','à¤•à¥à¤² à¤®à¥‚à¤²à¥à¤¯ à¤‰à¤¸ à¤µà¤œà¤¨',0),(334036,9279,'ms','Jumlah berat permulaan',0),(334037,9279,'ar','Ø§Ù„ÙˆØ²Ù† Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(334038,9279,'fr','Poids de dÃ©part total',0),(334039,9279,'jp','ç·é‡é‡',0),(334040,9279,'pt','Peso total inicial',0),(334041,9279,'ru','ÐžÐ±Ñ‰Ð¸Ð¹ Ð²ÐµÑ',0),(334042,9279,'es','Peso Inicio Total',0),(334043,9279,'de','Gesamt Gewicht',0),(334044,9279,'en','Total Starting Weight',0),(334045,9280,'is','',0),(334046,9280,'dr','Ø¢ÙŠØ§ Ù†ÙØ·Ù‡ ÙØ±ÙˆØ´ ÙƒÙ„Ø§Ø³ÙŠÙƒ ØªØ±Ø¬ÙŠØ­ Ø¯Ø§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ØŸ  Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(334047,9280,'pr','Ø¢ÙŠØ§ Ù†ÙØ·Ù‡ ÙØ±ÙˆØ´ ÙƒÙ„Ø§Ø³ÙŠÙƒ ØªØ±Ø¬ÙŠØ­ Ø¯Ø§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ØŸ  Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(334048,9280,'tr','Klasik POS tercih ediyorsunuz? Buraya tÄ±klayÄ±n',0),(334049,9280,'pl','WolÄ… klasyczne POS? Kliknij tutaj',0),(334050,9280,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð¼ ÐºÐ»Ð°ÑÐ¸Ñ‡ÐµÑÐºÐ¸ POS? Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð°',0),(334051,9280,'ur','Ú©Ù„Ø§Ø³Ú© Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Ùˆ ØªØ±Ø¬ÛŒØ­ Ø¯ÛŒØªÛ’ ÛÛŒÚºØŸ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(334052,9280,'sr','Ð Ð°Ð´Ð¸Ñ˜Ðµ ÐºÐ»Ð°ÑÐ¸Ñ‡Ð½Ð¸ ÐŸÐžÐ¡? ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ',0),(334053,9280,'vi','ThÃ­ch dÃ¹ng Ä‘iá»ƒm bÃ¡n hÃ ng cá»• Ä‘iá»ƒn? Nháº¥n vÃ o Ä‘Ã¢y',0),(334054,9280,'af','Verkies U die Klasieke PVV?  Kliek dan Hier',0),(334055,9280,'ro','Prefera clasic POS? FaceÅ£i clic aici',0),(334056,9280,'et','Eelistad klassikalist POS-i? Kliki siia',0),(334057,9280,'si','Raje klasiÄno POS? Kliknite tukaj',0),(334058,9280,'ba','Lebih suka klasik POS? Klik di sini',0),(334059,9280,'nl','Liever klassieke POS? Klik hier',0),(334060,9280,'fi','Mieluummin klassinen POS? Klikkaa tÃ¤stÃ¤',0),(334061,9280,'no','Foretrekker klassisk POS? Klikk her',0),(334062,9280,'da','ForetrÃ¦kker klassiske POS? Klik her',0),(334063,9280,'ko','ê³ ì „ì ì¸ POSë¥¼ ì„ í˜¸? ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì„¸ìš”',0),(334064,9280,'he','×ž×¢×“×™×£ ×§×•×¤×” ×§×œ××¡×™×ª? ×œ×—×¥ ×›××Ÿ',0),(334065,9280,'el','Î ÏÎ¿Ï„Î¹Î¼Î¿ÏÎ½ ÎºÎ»Î±ÏƒÎ¹ÎºÏŒ POS; ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ',0),(334066,9280,'zh','å–œæ¬¢ç»å…¸é”€å”®ç‚¹ï¼Ÿç‚¹å‡»è¿™é‡Œ\r\n',0),(334067,9280,'sv','FÃ¶redrar klassiska POS? Klicka hÃ¤r',0),(334068,9280,'it','Preferisco il classico POS? Clicca qui',0),(334069,9280,'tl','',0),(334070,9280,'th','&#3605;&#3657;&#3629;&#3591;&#3592;&#3640;&#3604;&#3586;&#3634;&#3618;&#3588;&#3621;&#3634;&#3626;&#3626;&#3636;&#3585;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;? &#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;',0),(334071,9280,'hi','à¤•à¥à¤²à¤¾à¤¸à¤¿à¤• POS à¤ªà¤¸à¤‚à¤¦ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚? à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(334072,9280,'ms','Lebih suka POS klasik? Klik di sini',0),(334073,9280,'ar','Ù‡Ù„ Ù†ÙØ¶Ù„ Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„ØªÙ‚Ù„ÙŠØ¯ÙŠØ© ØŸ Ø£Ù†Ù‚Ø± Ù‡Ù†Ø§',0),(334074,9280,'fr','PrÃ©fÃ©rez POS classique ? Cliquez ici',0),(334075,9280,'jp','å¤å…¸çš„ãª POS ã‚’å¥½ãã§ã™ã‹ï¼Ÿã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™ã€‚',0),(334076,9280,'pt','Prefiro o clÃ¡ssico POS? Clique aqui',0),(334077,9280,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°ÑŽÑ‚ ÐºÐ»Ð°ÑÑÐ¸Ñ‡ÐµÑÐºÐ¸Ðµ POS? ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ',0),(334078,9280,'es','Prefiere PDV Clasico? Click Aqui',0),(334079,9280,'de','Lieber klassische POS? Klicken Sie hier',0),(334080,9280,'en','Prefer Classic POS? Click Here',0),(334081,9281,'is','',0),(334082,9281,'dr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(334083,9281,'pr','ØªØ§Ø±ÙŠØ®Ú†Ù‡ ÙØ±ÙˆØ´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(334084,9281,'tr','Stok satÄ±ÅŸ geÃ§miÅŸi',0),(334085,9281,'pl','Historia sprzedaÅ¼y zapasÃ³w',0),(334086,9281,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°Ñ‚Ð° Ð·Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(334087,9281,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø³ÛŒÙ„Ø² ØªØ§Ø±ÛŒØ®',0),(334088,9281,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(334089,9281,'vi','Nháº­t KÃ½ HÃ ng HÃ³a',0),(334090,9281,'af','Voorraad Geskiedenis',0),(334091,9281,'ro','Istoric Inventar',0),(334092,9281,'et','Varude mÃ¼Ã¼k ajalugu',0),(334093,9281,'si','Zgodovina prodaje zaloge',0),(334094,9281,'ba','Sejarah penjualan persediaan',0),(334095,9281,'nl','Inventaris Verkoophistorie',0),(334096,9281,'fi','Varaston myynti historia',0),(334097,9281,'no','Lager Salgshistorikk',0),(334098,9281,'da','Lageret salgshistorik',0),(334099,9281,'ko','ìž¬ê³  íŒë§¤ ì—­ì‚¬',0),(334100,9281,'he','×”×™×¡×˜×•×¨×™×™×ª ×ž×›×™×¨×•×ª ×ž×œ××™',0),(334101,9281,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î¹ÏƒÏ„Î¿ÏÎ¯Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(334102,9281,'zh','åº“å­˜é”€å”®åŽ†å²\r\n',0),(334103,9281,'sv','Inventering fÃ¶rsÃ¤ljning historia',0),(334104,9281,'it','Cronologia delle vendite di inventario',0),(334105,9281,'tl','',0),(334106,9281,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;',0),(334107,9281,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(334108,9281,'ms','Sejarah jualan inventori',0),(334109,9281,'ar','Ø­Ø±ÙƒØ© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(334110,9281,'fr','L\'inventaire historique des ventes',0),(334111,9281,'jp','åœ¨åº«è²©å£²å±¥æ­´',0),(334112,9281,'pt','InventÃ¡rio histÃ³rico de vendas',0),(334113,9281,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(334114,9281,'es','Historia de Inventario',0),(334115,9281,'de','Inventar Vertriebshistorie',0),(334116,9281,'en','Inventory Sales History',0),(334117,9282,'is','',0),(334118,9282,'dr','Ø¨Ù‡ ÙŠÙƒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø­Ø¯ÙˆØ¯ Ù†Ø´Ø¯Ù‡ ',0),(334119,9282,'pr','Ø¨Ù‡ ÙŠÙƒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø­Ø¯ÙˆØ¯ Ù†Ø´Ø¯Ù‡ ',0),(334120,9282,'tr','Bir satÄ±ÅŸÃ§Ä±ya baÄŸlÄ± deÄŸil',0),(334121,9282,'pl','Nie zwiÄ…zany z handlowcem',0),(334122,9282,'bg','ÐÐµ ÑÐ° Ð¾Ð±Ð²ÑŠÑ€Ð·Ð°Ð½Ð¸ Ñ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(334123,9282,'ur','Ø§ÛŒÚ© Ù¾Ø±Ø³Ù† Ú©Û’ Ù¾Ø§Ø¨Ù†Ø¯ Ù†ÛÛŒÚº',0),(334124,9282,'sr','ÐÐ¸ÑÑƒ Ð¿Ð¾Ð²ÐµÐ·Ð°Ð½Ð¸ ÑÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(334125,9282,'vi','KhÃ´ng gáº¯n vÃ o 1 nhÃ¢n viÃªn kinh doanh',0),(334126,9282,'af','Nie verbind aan \'n Verkoopspersoon nie',0),(334127,9282,'ro','Nu sunt legate de un agent de vanzari',0),(334128,9282,'et','Ole seotud mÃ¼Ã¼giesindaja',0),(334129,9282,'si','Niso vezani na prodajalca',0),(334130,9282,'ba','Tidak terikat pada Penjual',0),(334131,9282,'nl','Niet gebonden aan een verkoper',0),(334132,9282,'fi','Ole sidottu myyjÃ¤',0),(334133,9282,'no','Ikke knyttet til en selger',0),(334134,9282,'da','Ikke bundet til en sÃ¦lger',0),(334135,9282,'ko','ì˜ì—…ì— ì—°ê²° ë˜ì§€',0),(334136,9282,'he','×œ× ×§×©×•×¨ ×œ××™×© ×ž×›×™×¨×•×ª',0),(334137,9282,'el','Î”ÎµÎ½ Î´Î­Î½ÎµÏ„Î±Î¹ ÏƒÎµ Î­Î½Î±Î½ Ï€Ï‰Î»Î·Ï„Î®',0),(334138,9282,'zh','ä¸ä¾èµ–äºŽé”€å”®äººå‘˜\r\n',0),(334139,9282,'sv','Inte bunden till en sÃ¤ljare',0),(334140,9282,'it','Non legato ad un venditore',0),(334141,9282,'tl','',0),(334142,9282,'th','&#3652;&#3617;&#3656;&#3612;&#3641;&#3585;&#3651;&#3627;&#3657;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(334143,9282,'hi','à¤à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤‚à¤§à¥‡ à¤¨à¤¹à¥€à¤‚',0),(334144,9282,'ms','Tidak terikat kepada jurujual',0),(334145,9282,'ar','ØºÙŠØ± Ù…Ø±ØªØ¨Ø· Ø¨Ù…ÙˆØ¸Ù Ù…Ø¨ÙŠØ¹Ø§Øª',0),(334146,9282,'fr','Pas liÃ© Ã  un vendeur',0),(334147,9282,'jp','å–¶æ¥­æ‹…å½“è€…ã«é–¢é€£ä»˜ã‘ã‚‰ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(334148,9282,'pt','NÃ£o vinculado a um vendedor',0),(334149,9282,'ru','ÐÐµ Ð¿Ñ€Ð¸Ð²ÑÐ·Ð°Ð½ Ðº Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ñƒ',0),(334150,9282,'es','No Conectado a un Proveedor',0),(334151,9282,'de','Nicht gebunden an einen VerkÃ¤ufer',0),(334152,9282,'en','Not Tied to a Salesperson',0),(334153,9283,'is','',0),(334154,9283,'dr','ÙƒØ§Ø±Ø¨Ø± Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø³Øª ',0),(334155,9283,'pr','ÙƒØ§Ø±Ø¨Ø± Ø§ÙŠÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø³Øª ',0),(334156,9283,'tr','Bu satÄ±ÅŸ temsilcisi kullanÄ±cÄ±dÄ±r',0),(334157,9283,'pl','UÅ¼ytkownik jest ten sprzedawca',0),(334158,9283,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ðµ Ñ‚Ð¾Ð·Ð¸ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(334159,9283,'ur','ØµØ§Ø±Ù Ø§Ø³ Ù¾Ø±Ø³Ù† ÛÛ’ Û”',0),(334160,9283,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ñ˜Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(334161,9283,'vi','NgÆ°á»i Sá»­ Dá»¥ng lÃ  nhÃ¢n viÃªn kinh doanh nÃ y',0),(334162,9283,'af','Gebruiker is die Verkoopspersoon',0),(334163,9283,'ro','Utilizatorul este acest agent de vÃ¢nzÄƒri',0),(334164,9283,'et','Kasutaja on selle mÃ¼Ã¼giisiku',0),(334165,9283,'si','Uporabnik je prodajalec',0),(334166,9283,'ba','Pengguna adalah penjual ini',0),(334167,9283,'nl','Gebruiker Is deze verkoper',0),(334168,9283,'fi','KÃ¤yttÃ¤jÃ¤ on myyjÃ¤n',0),(334169,9283,'no','Brukeren er denne selgeren',0),(334170,9283,'da','Brugeren er denne sÃ¦lger',0),(334171,9283,'ko','ì‚¬ìš©ìžëŠ”ì´ íŒë§¤ì›',0),(334172,9283,'he','×”×ž×©×ª×ž×© ×”×•× ××™×© ×ž×›×™×¨×•×ª ×–×”',0),(334173,9283,'el','ÎŸ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ ÎµÎ¯Î½Î±Î¹ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï€Ï‰Î»Î·Ï„Î®',0),(334174,9283,'zh','ç”¨æˆ·æ˜¯è¿™åé”€å”®äººå‘˜\r\n',0),(334175,9283,'sv','AnvÃ¤ndaren Ã¤r denna sÃ¤ljare',0),(334176,9283,'it','Utente Ã¨ questo venditore',0),(334177,9283,'tl','',0),(334178,9283,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3588;&#3639;&#3629;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;&#3609;&#3637;&#3657;',0),(334179,9283,'hi','à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¤¯à¤•à¤°à¥à¤¤à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¹à¥ˆ',0),(334180,9283,'ms','Pengguna adalah jurujual ini',0),(334181,9283,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù‡Ùˆ Ù‡Ø°Ø§ Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(334182,9283,'fr','Lâ€™utilisateur est de ce vendeur',0),(334183,9283,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ãŒã“ã®å–¶æ¥­æ‹…å½“è€…ã§ã™ã€‚',0),(334184,9283,'pt','UsuÃ¡rio Ã© este vendedor',0),(334185,9283,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ ÑÐ²Ð»ÑÐµÑ‚ÑÑ ÑÑ‚Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(334186,9283,'es','Usuario es Este Proveedor',0),(334187,9283,'de','Benutzer ist dieser VerkÃ¤ufer',0),(334188,9283,'en','User Is This Salesperson',0),(334189,9284,'is','',0),(334190,9284,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² Ù…Ù† ',0),(334191,9284,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² Ù…Ù† ',0),(334192,9284,'tr','Benim aÃ§Ä±k sipariÅŸler',0),(334193,9284,'pl','MÃ³j otwartych zamÃ³wieÅ„',0),(334194,9284,'bg','ÐœÐ¾Ð¸Ñ‚Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(334195,9284,'ur','Ù…ÛŒØ±Û’ Ú©Ú¾Ù„Û’ Ø¢Ø±ÚˆØ±Ø²',0),(334196,9284,'sr','ÐœÐ¾Ñ˜Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(334197,9284,'vi','ÄÆ¡n hÃ ng má»Ÿ cá»§a tÃ´i',0),(334198,9284,'af','My Open Bestellings',0),(334199,9284,'ro','Meu ordinele deschise',0),(334200,9284,'et','Minu avatud tellimused',0),(334201,9284,'si','Moje odprte naloge',0),(334202,9284,'ba','Pesanan saya terbuka',0),(334203,9284,'nl','Mijn Open Orders',0),(334204,9284,'fi','Avoimet tilaukset',0),(334205,9284,'no','Mine Ã¥pne ordrer',0),(334206,9284,'da','Mit Ã¥bne ordrer',0),(334207,9284,'ko','ë‚´ ì—´ê¸° ëª…ë ¹',0),(334208,9284,'he','×”×”×–×ž× ×•×ª ×”×¤×ª×•×—×•×ª ×©×œ×™',0),(334209,9284,'el','ÎœÎ¿Ï… Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î±',0),(334210,9284,'zh','æˆ‘çš„å·²å¼€å®šå•',0),(334211,9284,'sv','Min Ã¶ppna order',0),(334212,9284,'it','Miei ordini aperti',0),(334213,9284,'tl','',0),(334214,9284,'th','&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3593;&#3633;&#3609;',0),(334215,9284,'hi','à¤®à¥‡à¤°à¥€ à¤–à¥‹à¤²à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(334216,9284,'ms','Pesanan saya terbuka',0),(334217,9284,'ar','Ø¨Ù„Ø¯ÙŠ Ø£ÙˆØ§Ù…Ø± Ù…ÙØªÙˆØ­Ø©',0),(334218,9284,'fr','Mes commandes en cours',0),(334219,9284,'jp','ç§ã®ã‚ªãƒ¼ãƒ—ãƒ³ ã‚ªãƒ¼ãƒ€ãƒ¼',0),(334220,9284,'pt','Meus pedidos abertos',0),(334221,9284,'ru','ÐœÐ¾Ð¸ ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(334222,9284,'es','Mis Ordenes Abiertos',0),(334223,9284,'de','Meine offene AuftrÃ¤ge',0),(334224,9284,'en','My Open Orders',0),(334225,9285,'is','',0),(334226,9285,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² Ù…Ù†',0),(334227,9285,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² Ù…Ù†',0),(334228,9285,'tr','Benim aÃ§Ä±k sipariÅŸlerini rapora gÃ¶ster',0),(334229,9285,'pl','Zobacz mÃ³j raport otwartych zamÃ³wieÅ„',0),(334230,9285,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¼Ð¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(334231,9285,'ur','Ù…ÛŒØ±Û’ Ú©Ú¾Ù„Û’ Ø¢Ø±ÚˆØ±Ø² Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(334232,9285,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¼Ð¾Ñ˜Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(334233,9285,'vi','Xem bÃ¡o cÃ¡o Ä‘Æ¡n hÃ ng má»Ÿ cá»§a tÃ´i',0),(334234,9285,'af','Besigtig My Oop Bestellingsverslag',0),(334235,9285,'ro','Vezi raportul meu ordinele deschise',0),(334236,9285,'et','Vaata minu avatud tellimuste aruanne',0),(334237,9285,'si','Poglej si moj Open Orders poroÄilo',0),(334238,9285,'ba','Lihat laporan perintah yang terbuka',0),(334239,9285,'nl','Mijn Open Orders rapport weergeven',0),(334240,9285,'fi','Avoimet tilaukset-raportin tarkasteleminen',0),(334241,9285,'no','Vis rapporten Ã¥pne ordrer',0),(334242,9285,'da','Se min Ã¥bne ordrer rapport',0),(334243,9285,'ko','ë‚´ ì˜¤í”ˆ ì£¼ë¬¸ ë³´ê³ ì„œ ë³´ê¸°',0),(334244,9285,'he','×”×¦×’ ××ª ×”×“×•×— ×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª',0),(334245,9285,'el','Î”ÎµÏ‚ Ï„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ® Î¼Î¿Ï… Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î±',0),(334246,9285,'zh','æŸ¥çœ‹æˆ‘çš„æŠ¥å‘Šæœªç»“è®¢å•\r\n',0),(334247,9285,'sv','Visa min Ã¶ppna order rapport',0),(334248,9285,'it','Mostra la mia relazione ordini aperti',0),(334249,9285,'tl','',0),(334250,9285,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(334251,9285,'hi','à¤®à¥‡à¤°à¤¾ à¤–à¥à¤²à¤¾ à¤†à¤¦à¥‡à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(334252,9285,'ms','Lihat laporan terbuka pesanan saya',0),(334253,9285,'ar','Ø¹Ø±Ø¶ ØªÙ‚Ø±ÙŠØ±ÙŠ Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…ÙØªÙˆØ­Ø©',0),(334254,9285,'fr','Consulter mes commandes en cours',0),(334255,9285,'jp','ç§ã®ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡ã®ãƒ¬ãƒãƒ¼ãƒˆã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(334256,9285,'pt','Ver os meu relatÃ³rio de pedidos abertos',0),(334257,9285,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐžÑ‚Ñ‡ÐµÑ‚Ð° ÐœÐ¾Ð¸Ñ… ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(334258,9285,'es','Vistar Mi Informe de Ordenes Abiertos',0),(334259,9285,'de','Meine offene AuftrÃ¤ge-Bericht anzeigen',0),(334260,9285,'en','View My Open Orders Report',0),(334261,9286,'is','',0),(334262,9286,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ù†',0),(334263,9286,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ù†',0),(334264,9286,'tr','Bana verilen emir',0),(334265,9286,'pl','Moje rozkazy',0),(334266,9286,'bg','ÐœÐ¾Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(334267,9286,'ur','Ù…ÛŒØ±Ø§ Ø­Ú©Ù…',0),(334268,9286,'sr','ÐœÐ¾Ñ˜Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(334269,9286,'vi','ÄÆ¡n hÃ ng cá»§a tÃ´i',0),(334270,9286,'af','My Bestellings',0),(334271,9286,'ro','Comenzile mele',0),(334272,9286,'et','Minu tellimused',0),(334273,9286,'si','Moja naroÄila',0),(334274,9286,'ba','Pesanan saya',0),(334275,9286,'nl','Mijn bestellingen',0),(334276,9286,'fi','Omat tilaukset',0),(334277,9286,'no','Min ordre',0),(334278,9286,'da','Mine ordrer',0),(334279,9286,'ko','ë‚´ ì£¼ë¬¸',0),(334280,9286,'he','×”×”×–×ž× ×•×ª ×©×œ×™',0),(334281,9286,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î¼Î¿Ï…',0),(334282,9286,'zh','æˆ‘çš„å®šå•',0),(334283,9286,'sv','Min order',0),(334284,9286,'it','Miei ordini',0),(334285,9286,'tl','',0),(334286,9286,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3593;&#3633;&#3609;',0),(334287,9286,'hi','à¤®à¥‡à¤°à¥‡ à¤‘à¤°à¥à¤¡à¤°',0),(334288,9286,'ms','Pesanan saya',0),(334289,9286,'ar','Ø¨Ù„Ø¯ÙŠ Ø£ÙˆØ§Ù…Ø±',0),(334290,9286,'fr','Ma commandes',0),(334291,9286,'jp','ç§ã®æ³¨æ–‡',0),(334292,9286,'pt','Minhas ordens',0),(334293,9286,'ru','ÐœÐ¾Ð¸ Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(334294,9286,'es','Mis Ordenes',0),(334295,9286,'de','Meine Bestellungen',0),(334296,9286,'en','My Orders',0),(334297,9287,'is','',0),(334298,9287,'dr','Ø§ÙŠÙ…ÙŠÙ„ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø³Ø§Ø¯Ù‡',0),(334299,9287,'pr','Ø§ÙŠÙ…ÙŠÙ„ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø³Ø§Ø¯Ù‡',0),(334300,9287,'tr','Basit e-posta bildirimi',0),(334301,9287,'pl','Prosta instrukcja e-mail',0),(334302,9287,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð¿Ñ€Ð¾ÑÑ‚Ð¾ Ð¸Ð·ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(334303,9287,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø¢Ø³Ø§Ù† Ø¨ÛŒØ§Ù†',0),(334304,9287,'sr','ÐˆÐµÐ´Ð½Ð¾ÑÑ‚Ð°Ð²Ð½Ð° Ð¸Ð·Ñ˜Ð°Ð²Ð° Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(334305,9287,'vi','Email bÃ¡o cÃ¡o Ä‘Æ¡n giáº£n',0),(334306,9287,'af','E-pos Eenvoudige Staat',0),(334307,9287,'ro','Email declaraÅ£ie simplÄƒ',0),(334308,9287,'et','Saada lihtne vÃ¤ljavÃµte e-postiga',0),(334309,9287,'si','Email preprosto izjavo',0),(334310,9287,'ba','Pernyataan sederhana email',0),(334311,9287,'nl','E-mail eenvoudige verklaring',0),(334312,9287,'fi','SÃ¤hkÃ¶posti yksinkertainen ilmoitus',0),(334313,9287,'no','E-enkel uttalelse',0),(334314,9287,'da','E-mail simpel erklÃ¦ring',0),(334315,9287,'ko','ì´ë©”ì¼ ê°„ë‹¨í•œ ì„±ëª…',0),(334316,9287,'he','×ž×©×¤×˜ ×¤×©×•×˜ ×“×•×',0),(334317,9287,'el','Î— Î±Ï€Î»Î® Î´Î®Î»Ï‰ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(334318,9287,'zh','ç”µå­é‚®ä»¶ç®€å•çš„å£°æ˜Ž\r\n',0),(334319,9287,'sv','E-post enkelt uttalande',0),(334320,9287,'it','E-mail semplice dichiarazione',0),(334321,9287,'tl','',0),(334322,9287,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3605;&#3633;&#3623;&#3629;&#3618;&#3656;&#3634;&#3591;',0),(334323,9287,'hi','à¤ˆà¤®à¥‡à¤² à¤¸à¤°à¤² à¤¬à¤¯à¤¾à¤¨',0),(334324,9287,'ms','Penyata ringkas e-mel',0),(334325,9287,'ar','Ø¥Ø±Ø³Ø§Ù„ ÙƒØ´Ù Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(334326,9287,'fr','Courriel Simple dÃ©claration',0),(334327,9287,'jp','ãƒ¡ãƒ¼ãƒ«ã®å˜ç´”ãªã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆ',0),(334328,9287,'pt','DeclaraÃ§Ã£o simples de e-mail',0),(334329,9287,'ru','ÐŸÑ€Ð¾ÑÑ‚Ð¾Ðµ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(334330,9287,'es','Email DeclaraciÃ³n Sencillo',0),(334331,9287,'de','Einfache e-Mail-Anweisung',0),(334332,9287,'en','Email Simple Statement',0),(334333,9288,'is','',0),(334334,9288,'dr','Ú†Ø§Ù¾ Ù†Ù…ÙˆÙ†Ù‡ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ',0),(334335,9288,'pr','Ú†Ø§Ù¾ Ù†Ù…ÙˆÙ†Ù‡ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ',0),(334336,9288,'tr','Basit tablo yazdÄ±rmak',0),(334337,9288,'pl','WydrukowaÄ‡ prosty instrukcja',0),(334338,9288,'bg','ÐŸÑ€Ð¾ÑÑ‚Ð° Ð´ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(334339,9288,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¢Ø³Ø§Ù† Ø¨ÛŒØ§Ù†',0),(334340,9288,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚Ð°Ð²Ð½Ñƒ Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(334341,9288,'vi','Sao kÃª in Ä‘Æ¡n giáº£n',0),(334342,9288,'af','Druk Eenvoudige Staat',0),(334343,9288,'ro','DeclaraÅ£ie de simplÄƒ imprimare',0),(334344,9288,'et','Prindi lihtne vÃ¤ljavÃµte',0),(334345,9288,'si','Tiskanje preprosto izjavo',0),(334346,9288,'ba','Mencetak pernyataan sederhana',0),(334347,9288,'nl','Eenvoudige print-Statement',0),(334348,9288,'fi','Tulosta yksinkertainen ilmoitus',0),(334349,9288,'no','Skrive ut enkle utsagnet',0),(334350,9288,'da','Udskrive simpel erklÃ¦ring',0),(334351,9288,'ko','ê°„ë‹¨í•œ ê³„ì‚° ì„œ ì¸ì‡„',0),(334352,9288,'he','×œ×”×“×¤×™×¡ ×ž×©×¤×˜ ×¤×©×•×˜',0),(334353,9288,'el','Î‘Ï€Î»Î® Î´Î®Î»Ï‰ÏƒÎ· ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(334354,9288,'zh','æ‰“å°ç®€è¿°\r\n',0),(334355,9288,'sv','Skriva ut enkelt uttalande',0),(334356,9288,'it','Stampa semplice dichiarazione',0),(334357,9288,'tl','',0),(334358,9288,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3591;&#3610;&#3605;&#3633;&#3623;&#3629;&#3618;&#3656;&#3634;&#3591;',0),(334359,9288,'hi','à¤¸à¤¾à¤§à¤¾à¤°à¤£ à¤•à¤¥à¤¨ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(334360,9288,'ms','Cetakan penyata yang mudah',0),(334361,9288,'ar','Ø·Ø¨Ø§Ø¹Ø© ÙƒØ´Ù Ø§Ù„Ø­Ø³Ø§Ø¨',0),(334362,9288,'fr','Impression Simple dÃ©claration',0),(334363,9288,'jp','å˜ç´”ãªã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(334364,9288,'pt','Imprimir declaraÃ§Ã£o simples',0),(334365,9288,'ru','ÐŸÐ¸Ñ‡Ð°Ñ‚ÑŒ ÐŸÑ€Ð¾ÑÑ‚Ð¾Ð¹ Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(334366,9288,'es','Imprime DeclaraciÃ³n Sencillo',0),(334367,9288,'de','Einfachen Druckanweisung',0),(334368,9288,'en','Print Simple Statement',0),(334369,9289,'is','',0),(334370,9289,'dr','45 Ø±ÙˆØ²',0),(334371,9289,'pr','45 Ø±ÙˆØ²',0),(334372,9289,'tr','45 gÃ¼n',0),(334373,9289,'pl','45 dni',0),(334374,9289,'bg','45 Ð´Ð½Ð¸',0),(334375,9289,'ur','Ù¾ÛŒÙ†ØªØ§Ù„ÛŒØ³ Ø¯Ù†',0),(334376,9289,'sr','45 Ð´Ð°Ð½Ð°',0),(334377,9289,'vi','45 NgÃ y',0),(334378,9289,'af','45 Dae',0),(334379,9289,'ro','45 de zile',0),(334380,9289,'et','45 pÃ¤eva',0),(334381,9289,'si','45 dni',0),(334382,9289,'ba','45 Hari',0),(334383,9289,'nl','45 dagen',0),(334384,9289,'fi','45 pÃ¤ivÃ¤Ã¤',0),(334385,9289,'no','45 dager',0),(334386,9289,'da','45 dage',0),(334387,9289,'ko','45 ì¼',0),(334388,9289,'he','45 ×™×•×',0),(334389,9289,'el','45 Î—Î¼Î­ÏÎµÏ‚',0),(334390,9289,'zh','45å¤©',0),(334391,9289,'sv','45 Dagar',0),(334392,9289,'it','45 Giorni',0),(334393,9289,'tl','',0),(334394,9289,'th','45 à¸§à¸±à¸™',0),(334395,9289,'hi','45 à¤¦à¤¿à¤¨',0),(334396,9289,'ms','45 hari',0),(334397,9289,'ar','45 ÙŠÙˆÙ…Ø§',0),(334398,9289,'fr','45 Jours',0),(334399,9289,'jp','45 æ—¥é–“',0),(334400,9289,'pt','45 dias',0),(334401,9289,'ru','45 Ð”Ð½ÐµÐ¹',0),(334402,9289,'es','45 DÃ­as',0),(334403,9289,'de','45 Tage',0),(334404,9289,'en','45 Days',0),(334405,9290,'is','',0),(334406,9290,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø±',0),(334407,9290,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø®Ø±ÙŠØ¯Ø§Ø±',0),(334408,9290,'tr','Hata alma mÃ¼ÅŸteri',0),(334409,9290,'pl','BÅ‚Ä…d klienta przywozu',0),(334410,9290,'bg','Ð’Ð½Ð¾ÑÐ¸Ñ‚ÐµÐ» ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð³Ñ€ÐµÑˆÐºÐ°',0),(334411,9290,'ur','Ù†Ù‚Øµ Ø¯Ø±Ø¢Ù…Ø¯ Ú¯Ø§ÛÚ©',0),(334412,9290,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑƒÐ²Ð¾Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(334413,9290,'vi','Lá»—i khi nháº­p khÃ¡ch hÃ ng',0),(334414,9290,'af','Fout met KliÃ«nt/Klant Invoere',0),(334415,9290,'ro','Eroare client importatoare',0),(334416,9290,'et','Kliendi importimisel tekkis viga',0),(334417,9290,'si','Napake uvoznice kupca',0),(334418,9290,'ba','Kesalahan mengimpor pelanggan',0),(334419,9290,'nl','Fout importerende klant',0),(334420,9290,'fi','Virhe tuovan asiakkaan',0),(334421,9290,'no','Feil import kunde',0),(334422,9290,'da','Fejl importerende kunde',0),(334423,9290,'ko','ì˜¤ë¥˜ ê°€ì ¸ì˜¤ëŠ” ê³ ê°',0),(334424,9290,'he','×©×’×™××ª ×™×™×‘×•× ×”×œ×§×•×—',0),(334425,9290,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(334426,9290,'zh','é”™è¯¯å¯¼å…¥å®¢æˆ·\r\n',0),(334427,9290,'sv','Fel importerande kund',0),(334428,9290,'it','Errore importazione cliente',0),(334429,9290,'tl','',0),(334430,9290,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(334431,9290,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤†à¤¯à¤¾à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(334432,9290,'ms','Ralat mengimport pelanggan',0),(334433,9290,'ar','Ø®Ø·Ø£ Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(334434,9290,'fr','Erreur client importateur',0),(334435,9290,'jp','ã‚¨ãƒ©ãƒ¼ ã‚¤ãƒ³ãƒãƒ¼ãƒˆé¡§å®¢',0),(334436,9290,'pt','Cliente de erro importadora',0),(334437,9290,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ðµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(334438,9290,'es','Error Importando Cliente',0),(334439,9290,'de','Fehler Import Kunde',0),(334440,9290,'en','Error Importing Customer',0),(334441,9291,'is','',0),(334442,9291,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø´ØªØ¨Ø§Ù‡Ø§Øª ',0),(334443,9291,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø§Ø´ØªØ¨Ø§Ù‡Ø§Øª ',0),(334444,9291,'tr','HatalarÄ± alma hatasÄ±',0),(334445,9291,'pl','BÅ‚Ä…d importowania bÅ‚Ä™dy',0),(334446,9291,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð³Ñ€ÐµÑˆÐºÐ¸',0),(334447,9291,'ur','Ù†Ù‚Øµ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ØªÛ’ ÛÙˆÛ“ Ù†Ù‚Øµ',0),(334448,9291,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ²Ð¾Ð·Ñƒ Ð³Ñ€ÐµÑˆÐ°ÐºÐ°',0),(334449,9291,'vi','Lá»—i khi nháº­p',0),(334450,9291,'af','Fout met Invoerfoute',0),(334451,9291,'ro','Eroare importul de erori',0),(334452,9291,'et','Vigade importimisel ilmnes viga',0),(334453,9291,'si','Napaka pri uvozu napake',0),(334454,9291,'ba','Kesalahan mengimpor kesalahan',0),(334455,9291,'nl','Fout fouten importeren',0),(334456,9291,'fi','Virhe tuotaessa virheitÃ¤',0),(334457,9291,'no','Feil importerer feil',0),(334458,9291,'da','Fejl import fejl',0),(334459,9291,'ko','ì˜¤ë¥˜ ê°€ì ¸ì˜¤ê¸° ì˜¤ë¥˜',0),(334460,9291,'he','×©×’×™××” ×‘×™×™×‘×•× ×©×’×™××•×ª',0),(334461,9291,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½',0),(334462,9291,'zh','é”™è¯¯å¯¼å…¥é”™è¯¯',0),(334463,9291,'sv','Fel importerar fel',0),(334464,9291,'it','Errore durante l\'importazione di Errori',0),(334465,9291,'tl','',0),(334466,9291,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;',0),(334467,9291,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(334468,9291,'ms','Ralat mengimport ralat',0),(334469,9291,'ar','Ø®Ø·Ø£ Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£Ø®Ø·Ø§Ø¡',0),(334470,9291,'fr','Erreur importation Erreurs',0),(334471,9291,'jp','ã‚¨ãƒ©ãƒ¼ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ã‚¨ãƒ©ãƒ¼',0),(334472,9291,'pt','Erro ao importar erros',0),(334473,9291,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ðµ ÐžÑˆÐ¸Ð±Ð¾Ðº',0),(334474,9291,'es','Error Importando Errores',0),(334475,9291,'de','Fehler beim Importieren der StÃ¶rungen',0),(334476,9291,'en','Error Importing Errors',0),(334477,9292,'is','',0),(334478,9292,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(334479,9292,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(334480,9292,'tr','Ä°thalat sipariÅŸleri',0),(334481,9292,'pl','ZamÃ³wieÅ„ przywozowych',0),(334482,9292,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(334483,9292,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(334484,9292,'sr','Ð£Ð²Ð¾Ð· Ð½Ð°Ð»Ð¾Ð³Ð°',0),(334485,9292,'vi','Nháº­p Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(334486,9292,'af','Voer Bestellings in',0),(334487,9292,'ro','Comenzi de import',0),(334488,9292,'et','Impordi tellimused',0),(334489,9292,'si','Uvoz naroÄil',0),(334490,9292,'ba','Import Pesanan',0),(334491,9292,'nl','Import Orders',0),(334492,9292,'fi','Tuo tilaukset',0),(334493,9292,'no','Importer ordrer',0),(334494,9292,'da','Import ordrer',0),(334495,9292,'ko','ê°€ì ¸ì˜¤ê¸° ëª…ë ¹',0),(334496,9292,'he','×”×™×™×‘×•× ×”×–×ž× ×•×ª',0),(334497,9292,'el','Î•Î½Ï„Î¿Î»Î­Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(334498,9292,'zh','å¯¼å…¥è®¢å•\r\n',0),(334499,9292,'sv','BestÃ¤llning',0),(334500,9292,'it','Importazione ordini',0),(334501,9292,'tl','',0),(334502,9292,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(334503,9292,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶',0),(334504,9292,'ms','Perintah-perintah import',0),(334505,9292,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(334506,9292,'fr','Commandes d\'importation',0),(334507,9292,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®é †åº',0),(334508,9292,'pt','Pedidos de importaÃ§Ã£o',0),(334509,9292,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(334510,9292,'es','Ordenes de ImportaciÃ³n',0),(334511,9292,'de','Import-Bestellungen',0),(334512,9292,'en','Import Orders',0),(334513,9293,'is','',0),(334514,9293,'dr','ÙØ§ÙŠÙ„ Ø³ÙØ§Ø±Ø´ Ø§ØµÙ„ÙŠ ',0),(334515,9293,'pr','ÙØ§ÙŠÙ„ Ø³ÙØ§Ø±Ø´ Ø§ØµÙ„ÙŠ ',0),(334516,9293,'tr','Ana sÄ±ra dosyasÄ±',0),(334517,9293,'pl','ZamÃ³wienie gÅ‚Ã³wnego pliku',0),(334518,9293,'bg','ÐžÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ„Ð°Ð¹Ð»',0),(334519,9293,'ur','Ø¨Ù†ÛŒØ§Ø¯ÛŒ ØªØ±ØªÛŒØ¨ ÙØ§Ø¦Ù„',0),(334520,9293,'sr','Ð“Ð»Ð°Ð²Ð½Ð¸ Ñ„Ð°Ñ˜Ð»',0),(334521,9293,'vi','Há»“ sÆ¡ Ä‘Æ¡n hÃ ng chÃ­nh',0),(334522,9293,'af','Hoof BestellingslÃªer',0),(334523,9293,'ro','Principalele ordinea fiÅŸier',0),(334524,9293,'et','Peamised tellimuse faili',0),(334525,9293,'si','Glavna naloga datoteke',0),(334526,9293,'ba','File utama Order',0),(334527,9293,'nl','Belangrijkste volgorde bestand',0),(334528,9293,'fi','TÃ¤rkein JÃ¤rjestystiedoston',0),(334529,9293,'no','Viktigste ordrefil',0),(334530,9293,'da','StÃ¸rste ordre fil',0),(334531,9293,'ko','ì£¼ìš” ìˆœì„œ íŒŒì¼',0),(334532,9293,'he','×§×•×‘×¥ ×”×¡×™×“×•×¨ ×”×¨××©×™',0),(334533,9293,'el','ÎšÏÏÎ¹Î± ÏƒÎµÎ¹ÏÎ¬ Î±ÏÏ‡ÎµÎ¯Î¿',0),(334534,9293,'zh','ä¸»è¦è®¢å•æ–‡ä»¶\r\n',0),(334535,9293,'sv','Huvudsakliga orderfil',0),(334536,9293,'it','Ordine principale File',0),(334537,9293,'tl','',0),(334538,9293,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3627;&#3621;&#3633;&#3585;',0),(334539,9293,'hi','à¤®à¥à¤–à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤«à¤¼à¤¾à¤‡à¤²',0),(334540,9293,'ms','Fail utama perintah',0),(334541,9293,'ar','Ù…Ù„Ù Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø£Ø³Ø§Ø³ÙŠ',0),(334542,9293,'fr','Dossier de commande principal',0),(334543,9293,'jp','ä¸»è¦ãªé †åºãƒ•ã‚¡ã‚¤ãƒ«',0),(334544,9293,'pt','Arquivo principal da ordem',0),(334545,9293,'ru','Ð¤Ð°Ð¹Ð» Ð“Ð»Ð°Ð²Ð½Ð¾Ð³Ð¾ Ð—Ð°ÐºÐ°Ð·Ð°',0),(334546,9293,'es','Archivo de Orden Principal',0),(334547,9293,'de','Wichtigsten Anordnungsdatei',0),(334548,9293,'en','Main Order File',0),(334549,9294,'is','',0),(334550,9294,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(334551,9294,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(334552,9294,'tr','SipariÅŸ baÅŸarÄ±yla alÄ±ndÄ±',0),(334553,9294,'pl','ZamÃ³wienia poprawnie zaimportowane',0),(334554,9294,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(334555,9294,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(334556,9294,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ²ÐµÐ·ÐµÐ½Ðµ',0),(334557,9294,'vi','Nháº­p Ä‘Æ¡n hÃ ng thÃ nh cÃ´ng',0),(334558,9294,'af','Bestellings Suksesvol Ingevoer',0),(334559,9294,'ro','Comenzi importat cu succes',0),(334560,9294,'et','Tellimused edukalt imporditud',0),(334561,9294,'si','NaroÄila uspeÅ¡no uvoÅ¾en',0),(334562,9294,'ba','Perintah yang berhasil diimpor',0),(334563,9294,'nl','Bestellingen geÃ¯mporteerd',0),(334564,9294,'fi','Tilaukset tuonti onnistui',0),(334565,9294,'no','Bestillinger importert',0),(334566,9294,'da','Ordrer importeret',0),(334567,9294,'ko','ëª…ë ¹ì„ ì„±ê³µì ìœ¼ë¡œ ê°€ì ¸ì˜¨',0),(334568,9294,'he','×”×”×–×ž× ×•×ª ×™×•×‘××• ×‘×”×¦×œ×—×”',0),(334569,9294,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(334570,9294,'zh','å®šå•å¯¼å…¥æˆåŠŸ',0),(334571,9294,'sv','Order som har importerats',0),(334572,9294,'it','Ordini importati correttamente',0),(334573,9294,'tl','',0),(334574,9294,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3641;&#3585;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3649;&#3621;&#3657;&#3623;',0),(334575,9294,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤¯à¤¾à¤¤',0),(334576,9294,'ms','Perintah-perintah yang berjaya diimport',0),(334577,9294,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(334578,9294,'fr','Commandes ont bien Ã©tÃ© importÃ©es',0),(334579,9294,'jp','æ³¨æ–‡ãŒæ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã¾ã—ãŸ',0),(334580,9294,'pt','Ordens importadas com Ãªxito',0),(334581,9294,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½',0),(334582,9294,'es','Ordenes Importados Exitosamente',0),(334583,9294,'de','Bestellungen, die erfolgreich importiert',0),(334584,9294,'en','Orders Imported Successfully',0),(334585,9295,'is','',0),(334586,9295,'dr','ÙØ§ÙŠÙ„ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ ',0),(334587,9295,'pr','ÙØ§ÙŠÙ„ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ ',0),(334588,9295,'tr','SipariÅŸ ayrÄ±ntÄ±larÄ± dosya',0),(334589,9295,'pl','ZamÃ³wienia szczegÃ³Å‚y pliku',0),(334590,9295,'bg','Ð ÐµÐ´ Ð´Ð°Ð½Ð½Ð¸ Ñ„Ð°Ð¹Ð»',0),(334591,9295,'ur','Ø¢Ø±ÚˆØ± ØªÙØ§ØµÛŒÙ„ Ù…Ø³Ù„',0),(334592,9295,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÑÐ° Ð´ÐµÑ‚Ð°Ñ™Ð¸Ð¼Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(334593,9295,'vi','Há»“ sÆ¡ Chi tiáº¿t Ä‘Æ¡n hÃ ng',0),(334594,9295,'af','Bestelling Besonderhede LÃªer',0),(334595,9295,'ro','FiÅŸier de detalii comanda',0),(334596,9295,'et','Tellimuse Ã¼ksikasjad faili',0),(334597,9295,'si','Naloga podrobnosti datoteke',0),(334598,9295,'ba','Urutan rincian File',0),(334599,9295,'nl','Volgorde Details bestand',0),(334600,9295,'fi','JÃ¤rjestystiedoston tiedot',0),(334601,9295,'no','RekkefÃ¸lgefilen detaljer',0),(334602,9295,'da','Ordre detaljer fil',0),(334603,9295,'ko','ì£¼ë¬¸ ì„¸ë¶€ ì •ë³´ íŒŒì¼',0),(334604,9295,'he','×¡×“×¨ ×¤×¨×˜×™ ×§×•×‘×¥',0),(334605,9295,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(334606,9295,'zh','è®¢å•æ˜Žç»†æ¡£æ¡ˆ\r\n',0),(334607,9295,'sv','Sorteringsfilen Detaljer',0),(334608,9295,'it','File di dettagli ordine',0),(334609,9295,'tl','',0),(334610,9295,'th','&#3652;&#3615;&#3621;&#3660;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(334611,9295,'hi','à¤‘à¤°à¥à¤¡à¤° à¤µà¤¿à¤µà¤°à¤£ à¤«à¤¼à¤¾à¤‡à¤²',0),(334612,9295,'ms','Pesanan maklumat fail',0),(334613,9295,'ar','ØªØ±ØªÙŠØ¨ ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ù„Ù',0),(334614,9295,'fr','Dossier de dÃ©tails de commande',0),(334615,9295,'jp','æ³¨æ–‡è©³ç´°ãƒ•ã‚¡ã‚¤ãƒ«',0),(334616,9295,'pt','Arquivo de detalhes de ordem',0),(334617,9295,'ru','Ð¤Ð°Ð¹Ð» Ð”ÐµÑ‚Ð°Ð»ÐµÐ¹ Ð—Ð°ÐºÐ°Ð·Ð°',0),(334618,9295,'es','Archivo de Detalles de Ordenes',0),(334619,9295,'de','Bestellung Informationen Datei',0),(334620,9295,'en','Order Details File',0),(334621,9296,'is','',0),(334622,9296,'dr','ÙØ§ÙŠÙ„ Ø³ÙØ§Ø±Ø´ Ø§ØµÙ„ÙŠ Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ù…Ù†Ø§Ø³Ø¨ÙŠ Ù†ÙŠØ³Øª ',0),(334623,9296,'pr','ÙØ§ÙŠÙ„ Ø³ÙØ§Ø±Ø´ Ø§ØµÙ„ÙŠ Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ù…Ù†Ø§Ø³Ø¨ÙŠ Ù†ÙŠØ³Øª ',0),(334624,9296,'tr','Ana sipariÅŸ dosya doÄŸru biÃ§imde deÄŸil',0),(334625,9296,'pl','Plik zamÃ³wienia gÅ‚Ã³wnego nie jest w odpowiednim formacie',0),(334626,9296,'bg','Ð“Ð»Ð°Ð²Ð½Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ„Ð°Ð¹Ð»ÑŠÑ‚ Ð½Ðµ Ðµ Ð² Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¸Ñ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(334627,9296,'ur','Ø³Ø¨ Ø³Û’ Ø§ÛÙ… Ø­Ú©Ù… Ù…Ø³Ù„ Ù…Ù†Ø§Ø³Ø¨ ÙˆØ¶Ø¹ Ù…ÛŒÚº Ù†ÛÛŒÚº',0),(334628,9296,'sr','Ð“Ð»Ð°Ð²Ð½Ð° Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð¸Ñ˜Ðµ Ñƒ Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¾Ð¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(334629,9296,'vi','Há»“ sÆ¡ Ä‘Æ¡n hÃ ng chÃ­nh khÃ´ng cÃ³ Ä‘á»‹nh dáº¡ng chuáº©n',0),(334630,9296,'af','Die Hoof BestellingslÃªer is nie in die Regte Formaat',0),(334631,9296,'ro','FiÅŸierul de ordine principal nu este Ã®n formatul corect',0),(334632,9296,'et','Peamine fail pole Ãµiges vormingus',0),(334633,9296,'si','Glavna naloga datoteka ni v pravilni obliki',0),(334634,9296,'ba','Main Order File ini tidak dalam Format yang tepat',0),(334635,9296,'nl','Het bestand Main Order is niet de juiste indeling',0),(334636,9296,'fi','Main tilauksen tiedosto ei ole oikeassa muodossa',0),(334637,9296,'no','RekkefÃ¸lgefilen Main er ikke riktig format',0),(334638,9296,'da','Main ordre fil er ikke i korrekt Format',0),(334639,9296,'ko','ë©”ì¸ ì£¼ë¬¸ íŒŒì¼ì€ ì ì ˆ í•œ í˜•ì‹',0),(334640,9296,'he','×§×•×‘×¥ ×”×¡×™×“×•×¨ ×”×¨××©×™ ××™× ×• ×‘×ª×‘× ×™×ª ×ž×ª××™×ž×”',0),(334641,9296,'el','Î¤Î¿ ÎºÎµÎ½Ï„ÏÎ¹ÎºÏŒ Î±ÏÏ‡ÎµÎ¯Î¿ Ï€ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÏ„Î· ÏƒÏ‰ÏƒÏ„Î® Î¼Î¿ÏÏ†Î®',0),(334642,9296,'zh','ä¸»è¦è®¢å•æ–‡ä»¶ä¸æ˜¯æ­£ç¡®çš„æ ¼å¼\r\n',0),(334643,9296,'sv','Main Sorteringsfilen Ã¤r inte i rÃ¤tt Format',0),(334644,9296,'it','Il File principale dell\'ordine non Ã¨ nel formato corretto',0),(334645,9296,'tl','',0),(334646,9296,'th','&#3652;&#3615;&#3621;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3627;&#3621;&#3633;&#3585;&#3652;&#3617;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3607;&#3637;&#3656;&#3',0),(334647,9296,'hi','à¤®à¥à¤–à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤«à¤¼à¤¾à¤‡à¤² à¤‰à¤šà¤¿à¤¤ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(334648,9296,'ms','Fail pesanan utama ini tidak dalam Format yang betul',0),(334649,9296,'ar','Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ø£Ù…Ø± Ø§Ù„Ù…Ù„Ù Ù„ÙŠØ³ ÙÙŠ \"Ø§Ù„ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„ØµØ­ÙŠØ­\"',0),(334650,9296,'fr','Le fichier de commande principal n\'est pas au bon format',0),(334651,9296,'jp','ãƒ¡ã‚¤ãƒ³é †åºãƒ•ã‚¡ã‚¤ãƒ«ã¯é©åˆ‡ãªå½¢å¼ã§ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(334652,9296,'pt','O arquivo de ordem principal nÃ£o estÃ¡ no formato adequado',0),(334653,9296,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ñ„Ð°Ð¹Ð» Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð² Ð½ÑƒÐ¶Ð½Ð¾Ð¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ',0),(334654,9296,'es','el File del Orden Principal no esta en el Formato Correcto',0),(334655,9296,'de','Die Main-Bestellung-Datei ist nicht im richtigen Format',0),(334656,9296,'en','The Main Order File is not in the Proper Format',0),(334657,9297,'is','',0),(334658,9297,'dr','ÙØ§ÙŠÙ„ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ù…Ù†Ø§Ø³Ø¨ÙŠ Ù†ÙŠØ³Øª ',0),(334659,9297,'pr','ÙØ§ÙŠÙ„ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ù…Ù†Ø§Ø³Ø¨ÙŠ Ù†ÙŠØ³Øª ',0),(334660,9297,'tr','SipariÅŸ ayrÄ±ntÄ±larÄ± dosya doÄŸru biÃ§imde deÄŸil',0),(334661,9297,'pl','Plik szczegÃ³Å‚y zamÃ³wienia nie jest w odpowiednim formacie',0),(334662,9297,'bg','Ð ÐµÐ´ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ñ„Ð°Ð¹Ð»ÑŠÑ‚ Ð½Ðµ Ðµ Ð² Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¸Ñ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(334663,9297,'ur','Ø¢Ø±ÚˆØ± ØªÙØ§ØµÛŒÙ„ Ù…Ø³Ù„ Ù…Ù†Ø§Ø³Ø¨ ÙˆØ¶Ø¹ Ù…ÛŒÚº Ù†ÛÛŒÚº ÛÛ’ Û”',0),(334664,9297,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð¸Ñ˜Ðµ Ñƒ Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¾Ð¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(334665,9297,'vi','Há»“ sÆ¡ Ä‘Æ¡n hÃ ng chi tiáº¿t',0),(334666,9297,'af','Die Bestellingsbesonderhede LÃªer is nie in die Regte Formaat',0),(334667,9297,'ro','Ordinul detalii fiÅŸierul nu este Ã®n Format corect',0),(334668,9297,'et','Tellimuse Ã¼ksikasjad fail pole Ãµiges vormingus',0),(334669,9297,'si','Naloga podrobnosti datoteka ni v pravilni obliki',0),(334670,9297,'ba','Order rincian File ini tidak dalam Format yang tepat',0),(334671,9297,'nl','Het Order Details bestand is niet in de juiste indeling',0),(334672,9297,'fi','Tilauksen tiedot-tiedosto ei ole oikeassa muodossa',0),(334673,9297,'no','RekkefÃ¸lgefilen detaljer er ikke riktig format',0),(334674,9297,'da','Ordre detaljer fil er ikke i korrekt Format',0),(334675,9297,'ko','ì£¼ë¬¸ ì„¸ë¶€ ì •ë³´ íŒŒì¼ì€ ì ì ˆ í•œ í˜•ì‹',0),(334676,9297,'he','×¡×“×¨ ×¤×¨×˜×™ ×”×§×•×‘×¥ ××™× ×• ×‘×ª×‘× ×™×ª ×ž×ª××™×ž×”',0),(334677,9297,'el','Î¤Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÏ„Î· ÏƒÏ‰ÏƒÏ„Î® Î¼Î¿ÏÏ†Î®',0),(334678,9297,'zh','è®¢å•è¯¦ç»†ä¿¡æ¯æ–‡ä»¶ä¸æ˜¯æ­£ç¡®çš„æ ¼å¼\r\n',0),(334679,9297,'sv','Filen fÃ¶r detaljer Ã¤r inte i rÃ¤tt Format',0),(334680,9297,'it','Il File di dettagli ordine non Ã¨ nel formato corretto',0),(334681,9297,'tl','',0),(334682,9297,'th','&#3652;&#3615;&#3621;&#3660;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3652;&#3617;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3641;&#3611;&#3',0),(334683,9297,'hi','à¤‘à¤°à¥à¤¡à¤° à¤µà¤¿à¤µà¤°à¤£ à¤«à¤¼à¤¾à¤‡à¤² à¤‰à¤šà¤¿à¤¤ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(334684,9297,'ms','Pesanan maklumat fail ini tidak dalam Format yang betul',0),(334685,9297,'ar','ØªØ±ØªÙŠØ¨ ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ù„Ù Ù„ÙŠØ³ ÙÙŠ \"Ø§Ù„ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„ØµØ­ÙŠØ­\"',0),(334686,9297,'fr','Le dossier de dÃ©tails de la commande n\'est pas au bon format',0),(334687,9297,'jp','æ³¨æ–‡è©³ç´°ãƒ•ã‚¡ã‚¤ãƒ«ãŒã€é©åˆ‡ãªå½¢å¼ã§ãªã„ã§ã™ã€‚',0),(334688,9297,'pt','O arquivo de detalhes de ordem nÃ£o estÃ¡ no formato adequado',0),(334689,9297,'ru','Ð—Ð°ÐºÐ°Ð· Ð´ÐµÑ‚Ð°Ð»Ð¸ Ñ„Ð°Ð¹Ð» Ð½Ðµ Ð½Ð°Ñ…Ð¾Ð´Ð¸Ñ‚ÑÑ Ð² Ð½ÑƒÐ¶Ð½Ð¾Ð¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ',0),(334690,9297,'es','el File del Detalles de Orden no esta en el Formato Correcto',0),(334691,9297,'de','Die Order Details-Datei ist nicht im richtigen Format',0),(334692,9297,'en','The Order Details File is not in the Proper Format',0),(334693,9298,'is','',0),(334694,9298,'dr','Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(334695,9298,'pr','Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ ',0),(334696,9298,'tr','SipariÅŸ dosya yÃ¼klemek',0),(334697,9298,'pl','PrzesyÅ‚anie plikÃ³w zamÃ³wienia',0),(334698,9298,'bg','ÐšÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(334699,9298,'ur','ØªØ±ØªÛŒØ¨ Ù…Ø³Ù„ÛŒÚº Ø§Ø¨ Ù„ÙˆÚˆ',0),(334700,9298,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(334701,9298,'vi','Táº£i há»“ sÆ¡ Ä‘áº·t hÃ ng',0),(334702,9298,'af','Oplaai van BestellingslÃªers',0),(334703,9298,'ro','ÃŽncÄƒrcaÅ£i fiÅŸiere de comandÄƒ',0),(334704,9298,'et','Et faile Ã¼les laadida',0),(334705,9298,'si','Nalaganje datotek nalog',0),(334706,9298,'ba','Meng-upload file Order',0),(334707,9298,'nl','Volgorde bestanden uploaden',0),(334708,9298,'fi','Jotta tiedostojen lataaminen',0),(334709,9298,'no','Laste opp for filer',0),(334710,9298,'da','Uploade ordre filer',0),(334711,9298,'ko','ìˆœì„œ ëŒ€ë¡œ íŒŒì¼ì„ ì—…ë¡œë“œ',0),(334712,9298,'he','×œ×”×¢×œ×•×ª ×§×‘×¦×™× ×¡×“×¨',0),(334713,9298,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î±ÏÏ‡ÎµÎ¯Ï‰Î½',0),(334714,9298,'zh','ä¸Šä¼ è®¢å•æ–‡ä»¶\r\n',0),(334715,9298,'sv','Ladda upp fÃ¶r filer',0),(334716,9298,'it','Caricare file di ordine',0),(334717,9298,'tl','',0),(334718,9298,'th','&#3629;&#3657;&#3614;&#3650;&#3627;&#3621;&#3604;&#3652;&#3615;&#3621;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(334719,9298,'hi','à¤•à¥à¤°à¤® à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(334720,9298,'ms','Meng-upload file perintah',0),(334721,9298,'ar','ØªØ­Ù…ÙŠÙ„ Ù…Ù„ÙØ§Øª Ø§Ù„Ù†Ø¸Ø§Ù…',0),(334722,9298,'fr','TÃ©lÃ©charger des fichiers de commande',0),(334723,9298,'jp','ã‚ªãƒ¼ãƒ€ãƒ¼ ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(334724,9298,'pt','Upload de arquivos de ordem',0),(334725,9298,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ð¤Ð°Ð¹Ð»Ñ‹ Ð—Ð°ÐºÐ°Ð·Ð°',0),(334726,9298,'es','Sube Files de Ordenes',0),(334727,9298,'de','Bestellung Dateien hochladen',0),(334728,9298,'en','Upload Order Files',0),(334729,9299,'is','',0),(334730,9299,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯ ',0),(334731,9299,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ Ø¬Ø²Ø¦ÙŠØ§Øª Ø³ÙØ§Ø±Ø´ Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯ ',0),(334732,9299,'tr','Bir sipariÅŸ ayrÄ±ntÄ±larÄ± dosyasÄ± gÃ¶ndermeniz gerekir',0),(334733,9299,'pl','Musisz przesÅ‚aÄ‡ plik szczegÃ³Å‚y zamÃ³wienia',0),(334734,9299,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð´Ð°Ð´ÐµÑ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ñ„Ð°Ð¹Ð»',0),(334735,9299,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø¢Ø±ÚˆØ± ØªÙØ§ØµÛŒÙ„ ÙØ§Ø¦Ù„ Ø¬Ù…Ø¹ Ú©Ø±ÙˆØ§Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(334736,9299,'sr','ÐÐµÐ¾Ð¿Ñ…Ð¾Ð´Ð½Ð¾ Ñ˜Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(334737,9299,'vi','Báº¡n pháº£i ná»™p 1 há»“ sÆ¡ Ä‘áº·t hÃ ng chi tiáº¿t',0),(334738,9299,'af','U moet \'n Bestellingsbesonderhede LÃªer inhandig.',0),(334739,9299,'ro','Trebuie sÄƒ trimiteÅ£i un fiÅŸier de detalii comanda',0),(334740,9299,'et','Te peate sisestama tellimuse detailide faili',0),(334741,9299,'si','Morate poslati datoteko nalog podrobnosti',0),(334742,9299,'ba','Anda harus mengirimkan File rincian pesanan',0),(334743,9299,'nl','U dient een bestelling Details bestand',0),(334744,9299,'fi','LÃ¤hetÃ¤t tilauksen tiedot sisÃ¤ltÃ¤vÃ¤Ã¤ tiedostoa',0),(334745,9299,'no','Du mÃ¥ sende en detaljer ordrefil',0),(334746,9299,'da','Du skal sende en ordre detaljer fil',0),(334747,9299,'ko','ì£¼ë¬¸ ì„¸ë¶€ ì‚¬í•­ íŒŒì¼ì„ ì œì¶œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(334748,9299,'he','×¢×œ×™×š ×œ×”×’×™×© ×§×•×‘×¥ ×¤×¨×˜×™ ×”×–×ž× ×”',0),(334749,9299,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï…Ï€Î¿Î²Î¬Î»ÎµÏ„Îµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿ Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(334750,9299,'zh','ä½ å¿…é¡»æäº¤ä¸€ä¸ªè®¢å•æ˜Žç»†æ¡£æ¡ˆ\r\n',0),(334751,9299,'sv','Du mÃ¥ste lÃ¤mna in en bestÃ¤llning Detaljer fil',0),(334752,9299,'it','Ãˆ necessario inviare un File di dettagli ordine',0),(334753,9299,'tl','',0),(334754,9299,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3618;&#3629;&#3617;&#3619;&#3633;&#3610;&#3652;&#3615;&#3621;&#3660;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3',0),(334755,9299,'hi','à¤†à¤ª à¤à¤• à¤†à¤¦à¥‡à¤¶ à¤µà¤¿à¤µà¤°à¤£ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(334756,9299,'ms','Anda mesti menyerahkan fail maklumat pesanan',0),(334757,9299,'ar','ÙŠØ¬Ø¨ Ø¥Ø±Ø³Ø§Ù„ Ù…Ù„Ù ØªÙØ§ØµÙŠÙ„ ØªØ±ØªÙŠØ¨',0),(334758,9299,'fr','Vous devez soumettre un fichier de dÃ©tail de commande',0),(334759,9299,'jp','æ³¨æ–‡è©³ç´°ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é€ä¿¡ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(334760,9299,'pt','VocÃª deve enviar um arquivo de detalhes de ordem',0),(334761,9299,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð·Ð°ÐºÐ°Ð·Ð°',0),(334762,9299,'es','Debe someter y Ordenar el File de Detalles',0),(334763,9299,'de','Sie mÃ¼ssen eine bestellen-Details-Datei einreichen.',0),(334764,9299,'en','You Must Submit an Order Details File',0),(334765,9300,'is','',0),(334766,9300,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ Ø³ÙØ§Ø±Ø´ Ø§ØµÙ„ÙŠ Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯',0),(334767,9300,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ Ø³ÙØ§Ø±Ø´ Ø§ØµÙ„ÙŠ Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯',0),(334768,9300,'tr','Ana sÄ±ra dosyasÄ± gÃ¶ndermeniz gerekir',0),(334769,9300,'pl','Musi zÅ‚oÅ¼yÄ‡ zamÃ³wienie gÅ‚Ã³wnego pliku',0),(334770,9300,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð´Ð°Ð´ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð» Ñ Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(334771,9300,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø®Ø§Øµ ØªØ±ØªÛŒØ¨ ÙØ§Ø¦Ù„ Ø¬Ù…Ø¹ Ú©Ø±ÙˆØ§Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(334772,9300,'sr','ÐÐµÐ¾Ð¿Ñ…Ð¾Ð´Ð½Ð¾ Ñ˜Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð³Ð»Ð°Ð²Ð½Ð¾Ð³ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(334773,9300,'vi','Báº¡n pháº£i ná»™p 1 há»“ sÆ¡ Ä‘áº·t hÃ ng chÃ­nh',0),(334774,9300,'af','U moet \'n HoofbestellingslÃªer inhandig.',0),(334775,9300,'ro','Trebuie sa depuneti un dosar de ordine principal',0),(334776,9300,'et','Te peate sisestama Main Order Faili',0),(334777,9300,'si','Glavna naloga datoteko morate predloÅ¾iti',0),(334778,9300,'ba','Anda harus mengirimkan File utama Order',0),(334779,9300,'nl','U dient een belangrijkste volgorde bestand',0),(334780,9300,'fi','TÃ¤rkein JÃ¤rjestystiedoston on jÃ¤tettÃ¤vÃ¤',0),(334781,9300,'no','Du mÃ¥ sende en viktigste ordrefil',0),(334782,9300,'da','Du skal indsende en stÃ¸rste ordre fil',0),(334783,9300,'ko','ì£¼ìš” ìˆœì„œ íŒŒì¼ì„ ì œì¶œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(334784,9300,'he','×¢×œ×™×š ×œ×”×’×™×© ×§×•×‘×¥ ×”×”×–×ž× ×” ×”×¨××©×™',0),(334785,9300,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï…Ï€Î¿Î²Î¬Î»ÎµÏ„Îµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿ ÎºÏÏÎ¹Î± ÏƒÎµÎ¹ÏÎ¬',0),(334786,9300,'zh','ä½ å¿…é¡»æäº¤ä¸€ä»½ä¸»è¦è®¢å•æ–‡ä»¶\r\n',0),(334787,9300,'sv','Du mÃ¥ste skicka en huvudsakliga orderfil',0),(334788,9300,'it','Ãˆ necessario inviare un File di ordine principale',0),(334789,9300,'tl','',0),(334790,9300,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3618;&#3629;&#3617;&#3619;&#3633;&#3610;&#3652;&#3615;&#3621;&#3660;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3627;&#3621;&#3633;&#3585;',0),(334791,9300,'hi','à¤†à¤ª à¤•à¤¿à¤¸à¥€ à¤®à¥à¤–à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(334792,9300,'ms','Anda mesti menghantar fail utama perintah',0),(334793,9300,'ar','ÙŠØ¬Ø¨ Ø¥Ø±Ø³Ø§Ù„ Ù…Ù„Ù Ù†Ø¸Ø§Ù… Ø§Ù„Ø£Ø³Ø§Ø³ÙŠ',0),(334794,9300,'fr','Vous devez soumettre un fichier de commande principale',0),(334795,9300,'jp','ä¸»è¦ãªé †åºãƒ•ã‚¡ã‚¤ãƒ«ã‚’æå‡ºã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(334796,9300,'pt','VocÃª deve enviar um arquivo principal da ordem',0),(334797,9300,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» Ð³Ð»Ð°Ð²Ð½Ð¾Ð¹ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°',0),(334798,9300,'es','Debe someter un File Principal de Detalles',0),(334799,9300,'de','Sie mÃ¼ssen eine Haupt-Order-Datei einreichen.',0),(334800,9300,'en','You Must Submit a Main Order File',0),(334801,9301,'is','',0),(334802,9301,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² ',0),(334803,9301,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² ',0),(334804,9301,'tr','AÃ§Ä±k satÄ±ÅŸ sipariÅŸleri',0),(334805,9301,'pl','Sprzedawca otwartych zamÃ³wieÅ„',0),(334806,9301,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ‡ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(334807,9301,'ur','Ø¨Ù†Ø§Ú©Ø± Ú©Ú¾Ù„Û’ Ø¢Ø±ÚˆØ±Ø²',0),(334808,9301,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ† Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(334809,9301,'vi','NhÃ¢n viÃªn kinh doanh má»Ÿ Ä‘Æ¡n hÃ ng',0),(334810,9301,'af','Verkoopspersoon Oop Bestellings',0),(334811,9301,'ro','Ordinele deschise de vÃ¢nzÄƒtor',0),(334812,9301,'et','MÃ¼Ã¼gimees avatud tellimused',0),(334813,9301,'si','Prodajalec odprte naloge',0),(334814,9301,'ba','Salesman perintah yang terbuka',0),(334815,9301,'nl','Verkoper Open Orders',0),(334816,9301,'fi','Myyntimies avoimet tilaukset',0),(334817,9301,'no','Selger Ã¥pne ordrer',0),(334818,9301,'da','SÃ¦lger Ã¥bne ordrer',0),(334819,9301,'ko','ì„¸ì¼ì¦ˆ ë§¨ ì˜¤í”ˆ ì£¼ë¬¸',0),(334820,9301,'he','×ž×•×›×¨ ×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª',0),(334821,9301,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î±',0),(334822,9301,'zh','æŽ¨é”€å‘˜æœªç»“è®¢å•\r\n',0),(334823,9301,'sv','FÃ¶rsÃ¤ljare Ã¶ppna order',0),(334824,9301,'it','Venditore ordini aperti',0),(334825,9301,'tl','',0),(334826,9301,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(334827,9301,'hi','à¤¸à¥‡à¤²à¥à¤¸à¤®à¥‡à¤¨ à¤–à¥‹à¤²à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(334828,9301,'ms','Perintah terbuka jurujual',0),(334829,9301,'ar','Ø¨Ø§Ø¦Ø¹ Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…ÙØªÙˆØ­Ø©',0),(334830,9301,'fr','Vendeur commandes ouvertes',0),(334831,9301,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³ ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡',0),(334832,9301,'pt','Pedidos de vendedor abertos',0),(334833,9301,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð—Ð°ÐºÐ°Ð·Ñ‹ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(334834,9301,'es','Ordenes Abiertos de Vendedor',0),(334835,9301,'de','VerkÃ¤ufer offene AuftrÃ¤ge',0),(334836,9301,'en','Salesman Open Orders',0),(334837,9302,'is','',0),(334838,9302,'dr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(334839,9302,'pr','Ù†Ù…Ø§ÙŠØ´ Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(334840,9302,'tr','SatÄ±cÄ± aÃ§Ä±k sipariÅŸler raporu gÃ¶rÃ¼ntÃ¼le',0),(334841,9302,'pl','WyÅ›wietl raport otwartych zamÃ³wieÅ„ sprzedawca',0),(334842,9302,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡',0),(334843,9302,'ur','Ù…Ù†Ø¸Ø± Ø¨Ù†Ø§Ú©Ø± Ú©Ú¾Ù„Û’ Ø¢Ø±ÚˆØ±Ø² Ø±Ù¾ÙˆØ±Ù¹',0),(334844,9302,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ† Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð¸Ð·Ð²Ñ˜ÐµÑˆÑ‚Ð°Ñ˜',0),(334845,9302,'vi','Xem bÃ¡o cÃ¡o Ä‘Æ¡n hÃ ng má»Ÿ cá»§a nhÃ¢n viÃªn kinh doanh',0),(334846,9302,'af','Besigtig Verkoopspersoon Oop Bestellingsverslag',0),(334847,9302,'ro','Vezi vanzator ordinele deschise raport',0),(334848,9302,'et','Vaata mÃ¼Ã¼gimehe avatud tellimuste aruannet',0),(334849,9302,'si','Ogled prodajalec odprte naloge poroÄila',0),(334850,9302,'ba','Lihat Penjual perintah yang terbuka laporan',0),(334851,9302,'nl','Verkoper Open Orders-rapport weergeven',0),(334852,9302,'fi','NÃ¤ytÃ¤ myyjÃ¤ avoimet tilaukset-raportti',0),(334853,9302,'no','Vis selger Ã¥pne rapport',0),(334854,9302,'da','Vis sÃ¦lger Ã¥bne ordrer rapport',0),(334855,9302,'ko','ì„¸ì¼ì¦ˆ ë§¨ ì˜¤í”ˆ ì£¼ë¬¸ ë³´ê³ ì„œ ë³´ê¸°',0),(334856,9302,'he','×”×¦×’ ×“×•×— ×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª ×ž×›×™×¨×•×ª',0),(334857,9302,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î± Ï€Ï‰Î»Î·Ï„Î®Ï‚',0),(334858,9302,'zh','æŸ¥çœ‹æŽ¨é”€å‘˜å…¬å¼€è®¢å•æŠ¥è¡¨\r\n',0),(334859,9302,'sv','Visa fÃ¶rsÃ¤ljare Ã¶ppna order rapport',0),(334860,9302,'it','Relazione di vista venditore ordini aperti',0),(334861,9302,'tl','',0),(334862,9302,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(334863,9302,'hi','à¤¸à¥‡à¤²à¥à¤¸à¤®à¥‡à¤¨ à¤–à¥à¤²à¤¾ à¤†à¤¦à¥‡à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(334864,9302,'ms','Lihat jurujual pesanan terbuka Laporan',0),(334865,9302,'ar','Ø¹Ø±Ø¶ Ø¨Ø§Ø¦Ø¹ Ø£ÙˆØ§Ù…Ø± ÙØªØ­ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(334866,9302,'fr','Afficher le vendeur rapport commandes ouvertes',0),(334867,9302,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³ ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡ãƒ¬ãƒãƒ¼ãƒˆã®è¡¨ç¤º',0),(334868,9302,'pt','Exibir relatÃ³rio de pedidos abertos do vendedor',0),(334869,9302,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐžÑ‚Ñ‡ÐµÑ‚Ð° ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð² ÐŸÑ€Ð¾Ð´Ð²Ñ†Ð°',0),(334870,9302,'es','Vistar Informe de Ordenes Abiertos del Vendedor',0),(334871,9302,'de','VerkÃ¤ufer-offene Bestellungen-Bericht anzeigen',0),(334872,9302,'en','View Salesman Open Orders Report',0),(334873,9303,'is','',0),(334874,9303,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(334875,9303,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(334876,9303,'tr','AÃ§Ä±k SipariÅŸler satÄ±cÄ±',0),(334877,9303,'pl','Otwarte zamÃ³wienia sprzedawca',0),(334878,9303,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡',0),(334879,9303,'ur','Ú©Ú¾Ù„Û’ Ø¢Ø±ÚˆØ±Ø² Ø¨Ù†Ø§Ú©Ø±',0),(334880,9303,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(334881,9303,'vi','NhÃ¢n viÃªn kinh doanh cá»§a Ä‘Æ¡n hÃ ng má»Ÿ',0),(334882,9303,'af','Oop Bestellings Verkoopspersoon',0),(334883,9303,'ro','Ordinele deschise vanzator',0),(334884,9303,'et','Avatud tellimused mÃ¼Ã¼gimees',0),(334885,9303,'si','Odprte naloge prodajalec',0),(334886,9303,'ba','Salesman perintah yang terbuka',0),(334887,9303,'nl','Open Orders verkoper',0),(334888,9303,'fi','Avoimet tilaukset myyjÃ¤',0),(334889,9303,'no','Ã…pne ordrer selger',0),(334890,9303,'da','Ã…bne ordrer sÃ¦lger',0),(334891,9303,'ko','ì˜¤í”ˆ ì£¼ë¬¸ ì„¸ì¼ì¦ˆ ë§¨',0),(334892,9303,'he','×ž×•×›×¨ ×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª',0),(334893,9303,'el','Î‘Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î± ÎµÎ½Ï„Î¬Î»Î¼Î±Ï„Î± Ï€Ï‰Î»Î·Ï„Î®Ï‚',0),(334894,9303,'zh','æœªç»“è®¢å•æŽ¨é”€å‘˜\r\n',0),(334895,9303,'sv','Ã–ppna order sÃ¤ljare',0),(334896,9303,'it','Venditore di ordini aperti',0),(334897,9303,'tl','',0),(334898,9303,'th','&#3648;&#3611;&#3636;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;',0),(334899,9303,'hi','à¤–à¥à¤²à¤¾ à¤†à¤¦à¥‡à¤¶ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(334900,9303,'ms','Perintah terbuka jurujual',0),(334901,9303,'ar','Ø¨Ø§Ø¦Ø¹ Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…ÙØªÙˆØ­Ø©',0),(334902,9303,'fr','Vendeur de commandes ouvertes',0),(334903,9303,'jp','ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡ã®ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³',0),(334904,9303,'pt','Vendedor de pedidos abertos',0),(334905,9303,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ† ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(334906,9303,'es','Proveedor de Ordenes Abiertos',0),(334907,9303,'de','Offene Orders VerkÃ¤ufers',0),(334908,9303,'en','Open Orders Salesman',0),(334909,9304,'is','',0),(334910,9304,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙˆØ¯ Ùˆ ØµÙØ­Ù‡ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(334911,9304,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙˆØ¯ Ùˆ ØµÙØ­Ù‡ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(334912,9304,'tr','POS kar gÃ¶rÃ¼ntÃ¼lemek',0),(334913,9304,'pl','WyÅ›wietl zysk na stronie POS',0),(334914,9304,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° Ð½Ð° POS ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(334915,9304,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ ØµÙØ­Û Ù¾Ø± ÚˆØ³Ù¾Ù„Û’ Ù…Ù†Ø§ÙØ¹',0),(334916,9304,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÐŸÐžÐ¡',0),(334917,9304,'vi','Hiá»ƒn thá»‹ lá»£i nhuáº­n trÃªn trang Ä‘iá»ƒm bÃ¡n hÃ ng',0),(334918,9304,'af','Wys Wins op PVV Bladsy',0),(334919,9304,'ro','Profit de afiÅŸare pe pagina POS',0),(334920,9304,'et','POS lehel kuvada kasum',0),(334921,9304,'si','Prikaz dobiÄka na strani POS',0),(334922,9304,'ba','Menampilkan keuntungan pada halaman POS',0),(334923,9304,'nl','Winst op POS pagina weergeven',0),(334924,9304,'fi','NÃ¤yttÃ¤Ã¤ voittoa POS-sivulla',0),(334925,9304,'no','Vise profitt pÃ¥ POS',0),(334926,9304,'da','FÃ¥ vist overskud pÃ¥ POS side',0),(334927,9304,'ko','POS íŽ˜ì´ì§€ì— í‘œì‹œ í•˜ëŠ” ì´ìµ',0),(334928,9304,'he','×œ×”×¦×™×’ ×¨×•×•×— ×‘×“×£ POS',0),(334929,9304,'el','ÎŸÎ¸ÏŒÎ½Î· ÎºÎ­ÏÎ´Î¿Ï‚ ÏƒÏ„Î· ÏƒÎµÎ»Î¯Î´Î± POS',0),(334930,9304,'zh','åœ¨æœåŠ¡ç‚¹é¡µæ˜¾ç¤ºç›ˆåˆ©\r\n',0),(334931,9304,'sv','Visa vinst pÃ¥ POS sida',0),(334932,9304,'it','Profitto di visualizzazione pagina POS',0),(334933,9304,'tl','',0),(334934,9304,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3635;&#3652;&#3619;&#3610;&#3609;&#3627;&#3609;&#3657;&#3634; POS',0),(334935,9304,'hi','POS à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤²à¤¾à¤­',0),(334936,9304,'ms','Keuntungan paparan halaman POS',0),(334937,9304,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø±Ø¨Ø­ ÙÙŠ ØµÙØ­Ø© Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(334938,9304,'fr','Afficher les bÃ©nÃ©fices Ã lapage POS',0),(334939,9304,'jp','POS ãƒšãƒ¼ã‚¸ã«åˆ©ç›Šã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(334940,9304,'pt','Lucro de exibir na pÃ¡gina de POS',0),(334941,9304,'ru','ÐžÑ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ POS',0),(334942,9304,'es','Desplegar Utilidad en la PÃ¡gina PDV',0),(334943,9304,'de','Gewinn der POS-Seite anzeigen',0),(334944,9304,'en','Display Profit on POS Page',0),(334945,9305,'is','',0),(334946,9305,'dr','Ù…Ù†Ø·Ù‚Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ø´Ø±ÙƒØª ',0),(334947,9305,'pr','Ù…Ù†Ø·Ù‚Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ø´Ø±ÙƒØª ',0),(334948,9305,'tr','Åžirket saat dilimi',0),(334949,9305,'pl','Firma strefy czasowej',0),(334950,9305,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ñ‡Ð°ÑÐ¾Ð²Ð°Ñ‚Ð° Ð·Ð¾Ð½Ð°',0),(334951,9305,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ù¹Ø§Ø¦Ù… Ø²ÙˆÙ†',0),(334952,9305,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð²Ñ€ÐµÐ¼ÐµÐ½ÑÐºÐµ Ð—Ð¾Ð½Ðµ',0),(334953,9305,'vi','VÃ¹ng thá»i gian cá»§a Cty',0),(334954,9305,'af','Onderneming Tydsone',0),(334955,9305,'ro','Compania fusul orar',0),(334956,9305,'et','EttevÃµtte ajatsoon',0),(334957,9305,'si','Podjetje Äasovnega pasu',0),(334958,9305,'ba','Zona waktu perusahaan',0),(334959,9305,'nl','Bedrijf tijdzone',0),(334960,9305,'fi','Yrityksen aikavyÃ¶hyke',0),(334961,9305,'no','Firmaets tidssone',0),(334962,9305,'da','Virksomheden tidszone',0),(334963,9305,'ko','íšŒì‚¬ í‘œì¤€ ì‹œê°„ëŒ€',0),(334964,9305,'he','××–×•×¨ ×”×–×ž×Ÿ ×©×œ ×”×—×‘×¨×”',0),(334965,9305,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± Î¶ÏŽÎ½Î· ÏŽÏÎ±Ï‚',0),(334966,9305,'zh','å…¬å¸æ—¶åŒº\r\n',0),(334967,9305,'sv','FÃ¶retaget tidszon',0),(334968,9305,'it','Azienda fuso orario',0),(334969,9305,'tl','',0),(334970,9305,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(334971,9305,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¤®à¤¯ à¤œà¤¼à¥‹à¤¨',0),(334972,9305,'ms','Zon masa Syarikat',0),(334973,9305,'ar','Ø§Ù„Ù…Ù†Ø·Ù‚Ø© Ø²Ù…Ù†ÙŠØ© Ù„Ù„Ø´Ø±ÙƒØ©',0),(334974,9305,'fr','Fuseau horaire entreprise',0),(334975,9305,'jp','ä¼šç¤¾ã‚¿ã‚¤ãƒ  ã‚¾ãƒ¼ãƒ³',0),(334976,9305,'pt','Fuso horÃ¡rio empresa',0),(334977,9305,'ru','Ð§Ð°ÑÐ¾Ð²Ð¾Ð¹ ÐŸÐ¾ÑÑ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(334978,9305,'es','Zona de Tiempo de Empresa',0),(334979,9305,'de','Unternehmen-Zeitzone',0),(334980,9305,'en','Company Time Zone',0),(334981,9306,'is','',0),(334982,9306,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø²Ù…Ø§Ù† Ø³ÙŠØ³ØªÙ… ',0),(334983,9306,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø²Ù…Ø§Ù† Ø³ÙŠØ³ØªÙ… ',0),(334984,9306,'tr','Sistem saatini kullan',0),(334985,9306,'pl','Czas uÅ¼ytkowania systemu',0),(334986,9306,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(334987,9306,'ur','Ù†Ø¸Ø§Ù… ÙˆÙ‚Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(334988,9306,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼ÑÐºÐ¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(334989,9306,'vi','DÃ¹ng thá»i gian há»‡ thá»‘ng',0),(334990,9306,'af','Gebruik Sisteemtyd',0),(334991,9306,'ro','Utilizarea sistemului de timp',0),(334992,9306,'et','SÃ¼steemi kord',0),(334993,9306,'si','Uporabo sistema Äas',0),(334994,9306,'ba','Menggunakan sistem waktu',0),(334995,9306,'nl','Gebruik systeemtijd',0),(334996,9306,'fi','KÃ¤ytÃ¤ jÃ¤rjestelmÃ¤aika',0),(334997,9306,'no','Bruk systemtid',0),(334998,9306,'da','Brug systemtid',0),(334999,9306,'ko','ì‹œìŠ¤í…œ ì‹œê°„ì„ ì‚¬ìš© í•˜ ì—¬',0),(335000,9306,'he','×”×©×ª×ž×© ×‘×–×ž×Ÿ ×”×ž×¢×¨×›×ª',0),(335001,9306,'el','Î§ÏÎ®ÏƒÎ· ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚ Ï‡ÏÏŒÎ½Î¿',0),(335002,9306,'zh','ä½¿ç”¨ç³»ç»Ÿæ—¶é—´\r\n',0),(335003,9306,'sv','AnvÃ¤nda systemtid',0),(335004,9306,'it','Tempo di utilizzo del sistema',0),(335005,9306,'tl','',0),(335006,9306,'th','&#3651;&#3594;&#3657;&#3619;&#3632;&#3610;&#3610;&#3648;&#3623;&#3621;&#3634;',0),(335007,9306,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤¸à¤®à¤¯ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(335008,9306,'ms','Gunakan masa sistem',0),(335009,9306,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… ÙˆÙ‚Øª Ø§Ù„Ù†Ø¸Ø§Ù…',0),(335010,9306,'fr','DurÃ©e d\'utilisation de systÃ¨me',0),(335011,9306,'jp','ã‚·ã‚¹ãƒ†ãƒ æ™‚é–“ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(335012,9306,'pt','Tempo de uso do sistema',0),(335013,9306,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð½Ð¾Ðµ Ð’Ñ€ÐµÐ¼Ñ',0),(335014,9306,'es','Usa Tiempo del Sistema',0),(335015,9306,'de','Systemzeit verwenden',0),(335016,9306,'en','Use System Time',0),(335017,9307,'is','',0),(335018,9307,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ ',0),(335019,9307,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ù„Ø§ ',0),(335020,9307,'tr','Hata Ã¶ÄŸelerini ekleme',0),(335021,9307,'pl','BÅ‚Ä…d dodawania elementÃ³w',0),(335022,9307,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(335023,9307,'ur','Ù†Ù‚Øµ Ø§Ø´ÛŒØ§ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(335024,9307,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° ÑÑ‚Ð°Ð²ÐºÐ¸',0),(335025,9307,'vi','ThÃªm hÃ ng bá»‹ lá»—i',0),(335026,9307,'af','Fout met Skep van item',0),(335027,9307,'ro','Eroare adÄƒugÃ¢nd elemente',0),(335028,9307,'et','Toodete lisamisel ilmnes viga',0),(335029,9307,'si','Napaka dodajanje elementov',0),(335030,9307,'ba','Kesalahan menambahkan item',0),(335031,9307,'nl','Fout toevoegen Items',0),(335032,9307,'fi','LisÃ¤Ã¤minen kohteet',0),(335033,9307,'no','Feil Ã¥ legge til elementer',0),(335034,9307,'da','Fejl tilfÃ¸jelse af elementer',0),(335035,9307,'ko','ì˜¤ë¥˜ í•­ëª© ì¶”ê°€',0),(335036,9307,'he','×©×’×™××” ×”×•×¡×¤×ª ×¤×¨×™×˜×™×',0),(335037,9307,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(335038,9307,'zh','é”™è¯¯ï¼šæ–°å¢žé¡¹ç›®',0),(335039,9307,'sv','Fel att lÃ¤gga till objekt',0),(335040,9307,'it','Aggiunta di elementi di errore',0),(335041,9307,'tl','',0),(335042,9307,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(335043,9307,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(335044,9307,'ms','Ralat menambah item',0),(335045,9307,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(335046,9307,'fr','Erreur ajout dâ€™Ã©lÃ©ments',0),(335047,9307,'jp','ã‚¨ãƒ©ãƒ¼ã®é …ç›®ã®è¿½åŠ ',0),(335048,9307,'pt','Erro adicionando itens',0),(335049,9307,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(335050,9307,'es','Error Agregando los Items',0),(335051,9307,'de','Fehler-Elemente hinzufÃ¼gen',0),(335052,9307,'en','Error Adding Items',0),(335053,9308,'is','',0),(335054,9308,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ Ø§Ø² ÙØ§ÙŠÙ„ Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„\r\n UPC File',0),(335055,9308,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ Ø§Ø² ÙØ§ÙŠÙ„ Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„\r\n UPC File',0),(335056,9308,'tr','Ã–ÄŸeleri UPC dosyasÄ±ndan alma',0),(335057,9308,'pl','Importowanie elementÃ³w z pliku UPC',0),(335058,9308,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð¹ Ð¾Ñ‚ Ñ„Ð°Ð¹Ð» Ñ UPC',0),(335059,9308,'ur','Ø§Ø´ÛŒØ§ UPC Ù…Ø³Ù„ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(335060,9308,'sr','Ð£Ð²Ð¾Ð· ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¸Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð£ÐŸÐ¦',0),(335061,9308,'vi','Nháº­p hÃ ng tá»« há»“ sÆ¡ UPC',0),(335062,9308,'af','Ivoer van Items vanaf UPC LÃªer',0),(335063,9308,'ro','Import elemente din dosar UPC',0),(335064,9308,'et','Ãœksuste importimine failist UPC',0),(335065,9308,'si','Uvozite elemente iz datoteke UPC',0),(335066,9308,'ba','Mengimpor barang dari UPC File',0),(335067,9308,'nl','Items importeren uit bestand van UPC',0),(335068,9308,'fi','Kohteiden tuominen tiedostosta UPC',0),(335069,9308,'no','Importer elementer fra UPC-fil',0),(335070,9308,'da','Importere emnerne fra UPC',0),(335071,9308,'ko','ì˜¤ìˆœì ˆ íŒŒì¼ì—ì„œ ê°€ì ¸ì˜¤ê¸° í•­ëª©',0),(335072,9308,'he','×™×™×‘×•× ×¤×¨×™×˜×™× ×ž×§×•×‘×¥ UPC',0),(335073,9308,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î±Ï€ÏŒ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ UPC',0),(335074,9308,'zh','ä»Žé€šç”¨äº§å“ç æ–‡ä»¶ä¸­å¯¼å…¥é¡¹ç›®\r\n',0),(335075,9308,'sv','Importera objekt frÃ¥n UPC fil',0),(335076,9308,'it','Importare elementi dal File di UPC',0),(335077,9308,'tl','',0),(335078,9308,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3592;&#3634;&#3585;&#3652;&#3615;&#3621;&#3660; UPC ',0),(335079,9308,'hi','UPC à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥‡ à¤†à¤‡à¤Ÿà¤® à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(335080,9308,'ms','Mengimport barangan dari fail UPC',0),(335081,9308,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ù…Ù† Ù…Ù„Ù Ø§ØªØ­Ø§Ø¯ Ø§Ù„ÙˆØ·Ù†ÙŠÙŠÙ† Ø§Ù„ÙƒÙˆÙ†ØºÙˆÙ„ÙŠÙŠÙ†',0),(335082,9308,'fr','Importer des Ã©lÃ©ments du fichier de lâ€™UPC',0),(335083,9308,'jp','UPC ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰é …ç›®ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(335084,9308,'pt','Importar itens do arquivo de UPC',0),(335085,9308,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð¸Ð· Ñ„Ð°Ð¹Ð»Ð° Ð¡ÐšÐŸ',0),(335086,9308,'es','Importa Items del File de UPC',0),(335087,9308,'de','Elemente aus UPC-Datei importieren',0),(335088,9308,'en','Import Items from UPC File',0),(335089,9309,'is','',0),(335090,9309,'dr','ÙØ§ÙŠÙ„ Ù†Ø§ Ø¯Ø±Ø³ØªÙŠ Ø§Ø² Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(335091,9309,'pr','ÙØ§ÙŠÙ„ Ù†Ø§ Ø¯Ø±Ø³ØªÙŠ Ø§Ø² Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(335092,9309,'tr','GeÃ§ersiz UPC dosya gÃ¶nderilmiÅŸ',0),(335093,9309,'pl','Plik nieprawidÅ‚owy UPC dodano',0),(335094,9309,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ UPC ÐŸÐ¾Ð´Ð°Ð´ÐµÐ½Ð¸ÑÑ‚',0),(335095,9309,'ur','Ø¹Ø±Ø¶ Ú©ÛŒØ§ Ù†Ø§Ø¬Ø§Ø¦Ø² UPC Ù…Ø³Ù„',0),(335096,9309,'sr','ÐŸÐ¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ Ð£ÐŸÐ¦',0),(335097,9309,'vi','Ná»™p há»“ sÆ¡ UPC vÃ´ hiá»‡u',0),(335098,9309,'af','Ongeldige \"UPC\" LÃªer Ingedien',0),(335099,9309,'ro','FiÅŸier nevalid UPC transmise',0),(335100,9309,'et','Sobimatu UPC toimikust',0),(335101,9309,'si','Neveljaven UPC datoteko',0),(335102,9309,'ba','File tidak valid UPC disampaikan',0),(335103,9309,'nl','Ongeldige UPC bestand afkomstig',0),(335104,9309,'fi','Virheellinen UPC asiakirja-',0),(335105,9309,'no','Ugyldig UPC-fil som sendes',0),(335106,9309,'da','Ugyldig UPC fil indsendt',0),(335107,9309,'ko','ìž˜ëª» ëœ ì˜¤ìˆœì ˆ íŒŒì¼ ì œì¶œ',0),(335108,9309,'he','×§×•×‘×¥ ×œ× ×—×•×§×™ UPC × ××¡×¤×•',0),(335109,9309,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· UPC Î´Î¹ÎºÎ¿Î³ÏÎ±Ï†Î¯Î±',0),(335110,9309,'zh','æ— æ•ˆçš„é€šç”¨äº§å“ä»£ç çš„æ–‡ä»¶æäº¤\r\n',0),(335111,9309,'sv','Ogiltig UPC fil skickat',0),(335112,9309,'it','Fascicolo di UPC non valido',0),(335113,9309,'tl','',0),(335114,9309,'th','&#3626;&#3656;&#3591;&#3617;&#3629;&#3610;&#3652;&#3615;&#3621;&#3660; UPC &#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(335115,9309,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ UPC à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤¬à¤®à¤¿à¤Ÿ',0),(335116,9309,'ms','Fail tidak sah UPC yang dikemukakan',0),(335117,9309,'ar','Ø§Ù„Ù…Ù„Ù ØºÙŠØ± ØµØ§Ù„Ø­ Ø§ØªØ­Ø§Ø¯ Ø§Ù„ÙˆØ·Ù†ÙŠÙŠÙ† Ø§Ù„ÙƒÙˆÙ†ØºÙˆÙ„ÙŠÙŠÙ† Ø§Ù„Ù…Ù‚Ø¯Ù…Ø©',0),(335118,9309,'fr','Fichier non valide UPC soumis',0),(335119,9309,'jp','æå‡ºã•ã‚ŒãŸç„¡åŠ¹ãª UPC',0),(335120,9309,'pt','UPC invÃ¡lido arquivo enviado',0),(335121,9309,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ Ð¡ÐšÐŸ Ñ„Ð°Ð¹Ð» Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ð¹',0),(335122,9309,'es','File de UPC Presentado es InvÃ¡lido',0),(335123,9309,'de','UngÃ¼ltige UPC vorgelegten Akten',0),(335124,9309,'en','Invalid UPC File Submitted',0),(335125,9310,'is','',0),(335126,9310,'dr','ÙØ§ÙŠÙ„ Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„',0),(335127,9310,'pr','ÙØ§ÙŠÙ„ Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„',0),(335128,9310,'tr','UPC dosya',0),(335129,9310,'pl','Plik UPC',0),(335130,9310,'bg','UPC Ñ„Ð°Ð¹Ð»',0),(335131,9310,'ur','UPC Ù…Ø³Ù„',0),(335132,9310,'sr','Ð£ÐŸÐ¦ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(335133,9310,'vi','Há»“ sÆ¡ UPC',0),(335134,9310,'af','UPC LÃªer',0),(335135,9310,'ro','UPC fiÅŸier',0),(335136,9310,'et','UPC faili',0),(335137,9310,'si','UPC datoteke',0),(335138,9310,'ba','UPC File',0),(335139,9310,'nl','UPC bestand',0),(335140,9310,'fi','UPC-tiedosto',0),(335141,9310,'no','UPC fil',0),(335142,9310,'da','UPC fil',0),(335143,9310,'ko','ì˜¤ìˆœì ˆ íŒŒì¼',0),(335144,9310,'he','UPC ×§×•×‘×¥',0),(335145,9310,'el','UPC Î±ÏÏ‡ÎµÎ¯Î¿',0),(335146,9310,'zh','é€šç”¨äº§å“ä»£ç æ–‡ä»¶\r\n',0),(335147,9310,'sv','UPC fil',0),(335148,9310,'it','UPC File',0),(335149,9310,'tl','',0),(335150,9310,'th','&#3652;&#3615;&#3621;&#3660; UPC ',0),(335151,9310,'hi','UPC à¤«à¤¼à¤¾à¤‡à¤²',0),(335152,9310,'ms','Fail UPC',0),(335153,9310,'ar','Ù…Ù„Ù Ø§ØªØ­Ø§Ø¯ Ø§Ù„ÙˆØ·Ù†ÙŠÙŠÙ† Ø§Ù„ÙƒÙˆÙ†ØºÙˆÙ„ÙŠÙŠÙ†',0),(335154,9310,'fr','Fichier de lâ€™UPC',0),(335155,9310,'jp','UPC ãƒ•ã‚¡ã‚¤ãƒ«',0),(335156,9310,'pt','Arquivo de UPC',0),(335157,9310,'ru','Ð¡ÐšÐŸ Ñ„Ð°Ð¹Ð»',0),(335158,9310,'es','File de UPC',0),(335159,9310,'de','UPC-Datei',0),(335160,9310,'en','UPC File',0),(335161,9311,'is','',0),(335162,9311,'dr','Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„(Ø¨Ø§Ø±Ú©Ø¯',0),(335163,9311,'pr','Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„',0),(335164,9311,'tr','UPC dosya yÃ¼kle',0),(335165,9311,'pl','PrzeÅ›lij plik UPC',0),(335166,9311,'bg','ÐšÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð» Ñ UPC',0),(335167,9311,'ur','UPC ÙØ§Ø¦Ù„ Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(335168,9311,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð£ÐŸÐ¦',0),(335169,9311,'vi','Táº£i há»“ sÆ¡ UPC',0),(335170,9311,'af','Oplaai van UPC LÃªer',0),(335171,9311,'ro','ÃŽncÄƒrcaÅ£i fiÅŸier UPC',0),(335172,9311,'et','UPC faili Ã¼les laadida',0),(335173,9311,'si','Upload pila UPC',0),(335174,9311,'ba','Meng-upload UPC File',0),(335175,9311,'nl','UPC-bestand uploaden',0),(335176,9311,'fi','UPC lahjoitukset',0),(335177,9311,'no','UPC filopplasting',0),(335178,9311,'da','Uploade UPC fil',0),(335179,9311,'ko','ì˜¤ìˆœì ˆ íŒŒì¼ ì—…ë¡œë“œ',0),(335180,9311,'he','×”×¢×œ××ª ×§×•×‘×¥ UPC',0),(335181,9311,'el','Î‘ÎÎ•Î’Î‘Î£Î¤Î• UPC',0),(335182,9311,'zh','ä¸Šä¼ é€šç”¨äº§å“ä»£ç æ–‡ä»¶\r\n',0),(335183,9311,'sv','Ladda upp UPC fil',0),(335184,9311,'it','Caricare File di UPC',0),(335185,9311,'tl','',0),(335186,9311,'th','&#3629;&#3657;&#3614;&#3650;&#3627;&#3621;&#3604;&#3652;&#3615;&#3621;&#3660; UPC ',0),(335187,9311,'hi','UPC à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(335188,9311,'ms','Muat naik fail UPC',0),(335189,9311,'ar','ØªØ­Ù…ÙŠÙ„ Ù…Ù„Ù Ø§ØªØ­Ø§Ø¯ Ø§Ù„ÙˆØ·Ù†ÙŠÙŠÙ† Ø§Ù„ÙƒÙˆÙ†ØºÙˆÙ„ÙŠÙŠÙ†',0),(335190,9311,'fr','TÃ©lÃ©charger fichier UPC',0),(335191,9311,'jp','UPC ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(335192,9311,'pt','Upload de arquivo UPC',0),(335193,9311,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» Ð¡ÐšÐŸ',0),(335194,9311,'es','Sube el File UPC',0),(335195,9311,'de','UPC-Datei hochladen',0),(335196,9311,'en','Upload UPC File',0),(335197,9312,'is','',0),(335198,9312,'dr','UPC File',0),(335199,9312,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ Ú©Ø¯ Ø¬Ø§Ù…Ø¹ Ù…Ø­ØµÙˆÙ„ Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯ UPC File',0),(335200,9312,'tr','Bir UPC dosyasÄ± gÃ¶ndermeniz gerekir',0),(335201,9312,'pl','NaleÅ¼y przesÅ‚aÄ‡ plik UPC',0),(335202,9312,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð´Ð°Ð´ÐµÑ‚Ðµ UPC Ñ„Ð°Ð¹Ð»',0),(335203,9312,'ur','Ø¢Ù¾ Ø§ÛŒÚ© UPC ÙØ§Ø¦Ù„ Ù…ÛŒÚº Ø¬Ù…Ø¹ Ú©Ø±ÙˆØ§Ø¦ÛŒÚº',0),(335204,9312,'sr','ÐÐµÐ¾Ð¿Ñ…Ð¾Ð´Ð½Ð¾ Ñ˜Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð£ÐŸÐ¦',0),(335205,9312,'vi','Báº¡n pháº£i ná»™p 1 há»“ sÆ¡ UPC',0),(335206,9312,'af','U moet \'n UPC LÃªer verskaf.',0),(335207,9312,'ro','Trebuie sa depuneti un dosar de UPC',0),(335208,9312,'et','Te peate sisestama UPC faili',0),(335209,9312,'si','Morate poslati datoteko UPC',0),(335210,9312,'ba','Anda harus mengirimkan UPC File',0),(335211,9312,'nl','U dient een UPC-bestand',0),(335212,9312,'fi','UPC-tiedosto on jÃ¤tettÃ¤vÃ¤',0),(335213,9312,'no','Du mÃ¥ sende en UPC-fil',0),(335214,9312,'da','Du skal indsende en UPC fil',0),(335215,9312,'ko','ì˜¤ìˆœì ˆ íŒŒì¼ì„ ì œì¶œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(335216,9312,'he','×¢×œ×™×š ×œ×”×’×™×© ×§×•×‘×¥ UPC',0),(335217,9312,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï…Ï€Î¿Î²Î¬Î»ÎµÏ„Îµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿ UPC',0),(335218,9312,'zh','ä½ å¿…é¡»æäº¤ä¸€ä¸ªUPCæ–‡ä»¶\r\n',0),(335219,9312,'sv','Du mÃ¥ste skicka en UPC fil',0),(335220,9312,'it','Ãˆ necessario inviare un File di UPC',0),(335221,9312,'tl','',0),(335222,9312,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3618;&#3629;&#3617;&#3619;&#3633;&#3610;&#3652;&#3615;&#3621;&#3660; UPC ',0),(335223,9312,'hi','à¤†à¤ª à¤à¤• UPC à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(335224,9312,'ms','Anda mesti menyerahkan fail UPC',0),(335225,9312,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø±Ø³Ø§Ù„ Ù…Ù„Ù Ø§ØªØ­Ø§Ø¯ Ø§Ù„ÙˆØ·Ù†ÙŠÙŠÙ† Ø§Ù„ÙƒÙˆÙ†ØºÙˆÙ„ÙŠÙŠÙ†',0),(335226,9312,'fr','Vous devez soumettre un fichier UPC',0),(335227,9312,'jp','UPC ãƒ•ã‚¡ã‚¤ãƒ«ã‚’æå‡ºã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(335228,9312,'pt','VocÃª deve enviar um arquivo de UPC',0),(335229,9312,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡ÐšÐŸ Ñ„Ð°Ð¹Ð»',0),(335230,9312,'es','Debe Presentar un File UPC',0),(335231,9312,'de','Sie mÃ¼ssen eine UPC-Datei einreichen.',0),(335232,9312,'en','You Must Submit a UPC File',0),(335233,9313,'is','',0),(335234,9313,'dr','(Ù…Ù†ØªÙ‚Ù„ ) Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(335235,9313,'pr','Ù‡ÙŠÚ† ÙƒØ§Ù„Ø§ÙŠÙŠ ØªØµÙˆÙŠØ¨(Ù…Ù†ØªÙ‚Ù„ ) Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(335236,9313,'tr','GeÃ§irilen Ã¶ÄŸe yok',0),(335237,9313,'pl','Nie elementÃ³w przekazany w',0),(335238,9313,'bg','ÐÑÐ¼Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð¿Ñ€Ð¸ÐµÑ‚ Ð¿Ñ€ÐµÐ·',0),(335239,9313,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ù…ÛŒÚº Ú¯Ø²Ø±Ø§ Û”',0),(335240,9313,'sr','ÐÐµÐ¼Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð¸ ÑƒÑˆÐ»Ð¸ Ñƒ',0),(335241,9313,'vi','HÃ ng chÆ°a qua',0),(335242,9313,'af','Geen Items *******',0),(335243,9313,'ro','Nici un produs Ã®n',0),(335244,9313,'et','MÃ¶Ã¶dunud aastal Ã¼ksusi',0),(335245,9313,'si','Ni elementov, ki v',0),(335246,9313,'ba','Tidak ada item yang berlalu dalam',0),(335247,9313,'nl','Geen objecten doorgegeven In',0),(335248,9313,'fi','Kohteita ei vÃ¤litetty',0),(335249,9313,'no','Ingen elementer i',0),(335250,9313,'da','Ingen poster gÃ¥et i',0),(335251,9313,'ko','ì „ë‹¬ ëœ í•­ëª© ì—†ìŒ',0),(335252,9313,'he','××™×Ÿ ×¤×¨×™×˜×™× ×©×”×•×¢×‘×¨',0),(335253,9313,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Ï€Î­ÏÎ±ÏƒÎµ',0),(335254,9313,'zh','æ²¡æœ‰é€šè¿‡çš„é¡¹ç›®\r\n',0),(335255,9313,'sv','Inga objekt som passerade i',0),(335256,9313,'it','Nessun elementi passati',0),(335257,9313,'tl','',0),(335258,9313,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3612;&#3656;&#3634;&#3609;&#3651;&#3609;',0),(335259,9313,'hi','à¤®à¥‡à¤‚ à¤•à¥‹à¤ˆ à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(335260,9313,'ms','Tiada item yang diluluskan pada',0),(335261,9313,'ar','Ù„Ø§ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„ØªÙŠ ØªÙ… ØªÙ…Ø±ÙŠØ±Ù‡Ø§ ÙÙŠ',0),(335262,9313,'fr','Aucun Ã©lÃ©ments passÃ©s dans',0),(335263,9313,'jp','æ¸¡ã•ã‚ŒãŸã‚¢ã‚¤ãƒ†ãƒ ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(335264,9313,'pt','NÃ£o hÃ¡ itens passados',0),(335265,9313,'ru','ÐÐµÑ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð², Ð²',0),(335266,9313,'es','No hay Items que Pasaron',0),(335267,9313,'de','Keine Elemente Ã¼bergeben',0),(335268,9313,'en','No Items Passed In',0),(335269,9314,'is','',0),(335270,9314,'dr','(Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ú¯Ø¯Ø§Ù…) Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(335271,9314,'pr','ÙÙ‚Ø· ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ(Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø±) Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(335272,9314,'tr','Sadece eldeki maddeleri dahil',0),(335273,9314,'pl','Obejmuje tylko pozycje, na rÄ™kÄ™',0),(335274,9314,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÑÐ°Ð¼Ð¾ Ð½Ð° Ñ€ÑŠÐºÐ° Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(335275,9314,'ur','ØµØ±Ù ÛØ§ØªÚ¾ Ù¾Ø± Ø§Ø´ÛŒØ§Ø¡ Ù…ÛŒÚº Ø´Ø§Ù…Ù„',0),(335276,9314,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ ÑÐ°Ð¼Ð¾ Ð¾Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð° Ñ€ÑƒÐºÑƒ',0),(335277,9314,'vi','Chá»‰ bao gá»“m hÃ ng Ä‘ang cÃ³ sáºµn',0),(335278,9314,'af','Sluit slegs Op Hande Items in',0),(335279,9314,'ro','Include numai elemente de pe-o parte',0),(335280,9314,'et','Sisaldab ainult vaba punkte',0),(335281,9314,'si','VkljuÄujejo samo elemente na strani',0),(335282,9314,'ba','Termasuk hanya barang-barang di tangan',0),(335283,9314,'nl','Alleen op de Hand Items opnemen',0),(335284,9314,'fi','SisÃ¤llytÃ¤ vain varastonimikkeet',0),(335285,9314,'no','Inkluder bare varer pÃ¥ lager',0),(335286,9314,'da','Omfatte kun disponible varer',0),(335287,9314,'ko','ë§Œ í•­ëª©ì„ í¬í•¨',0),(335288,9314,'he','×œ×›×œ×•×œ ×¨×§ ×¤×¨×™×˜×™× ×‘× ×ž×¦×',0),(335289,9314,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î¼ÏŒÎ½Î¿ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏ„Î¿ Ï‡Î­ÏÎ¹',0),(335290,9314,'zh','ä»…åŒ…æ‹¬çŽ°æœ‰é¡¹ç›®\r\n',0),(335291,9314,'sv','Inkludera endast artiklar i lager',0),(335292,9314,'it','Includere solo gli elementi a portata di mano',0),(335293,9314,'tl','',0),(335294,9314,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3617;&#3637;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(335295,9314,'hi','à¤•à¥‡à¤µà¤² à¤¹à¤¾à¤¥ à¤ªà¤° à¤†à¤‡à¤Ÿà¤® à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(335296,9314,'ms','Meliputi perkara-perkara atas tangan sahaja',0),(335297,9314,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„ÙØ¹Ù„ÙŠØ© ÙÙ‚Ø·',0),(335298,9314,'fr','Inclure uniquement les Ã©lÃ©ments Ã  portÃ©e de main',0),(335299,9314,'jp','æ‰‹æŒã®ã‚¢ã‚¤ãƒ†ãƒ ã®ã¿ãŒå«ã¾ã‚Œã¾ã™',0),(335300,9314,'pt','Incluir apenas os itens Ã  mÃ£o',0),(335301,9314,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð½Ð° Ñ€ÑƒÐºÐ¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹',0),(335302,9314,'es','Incluye Items Solamente En Reserva',0),(335303,9314,'de','Enthalten Sie nur verfÃ¼gbare Artikel',0),(335304,9314,'en','Include Only On-Hand Items',0),(335305,9315,'is','',0),(335306,9315,'dr','Ø¨Ø§Ø±ÙƒØ¯ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯',0),(335307,9315,'pr','Ø¨Ø§Ø±ÙƒØ¯ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯',0),(335308,9315,'tr','Barkodlar baÅŸarÄ±yla oluÅŸturuldu',0),(335309,9315,'pl','Kody kreskowe zostaÅ‚ wygenerowany pomyÅ›lnie',0),(335310,9315,'bg','Ð©Ñ€Ð¸Ñ…ÐºÐ¾Ð´Ð¾Ð²Ðµ, Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(335311,9315,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÛŒØ¯Ø§ Ú©Ø±ØªØ§ ÛÛ’',0),(335312,9315,'sr','Ð‘Ð°Ñ€ ÐºÐ¾Ð´Ð¾Ð²Ð¸ ÑÑƒ Ð³ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ð½Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(335313,9315,'vi','Táº¡o mÃ£ váº¡ch thÃ nh cÃ´ng',0),(335314,9315,'af','Strepieskodes Suksesvol Gegenereer',0),(335315,9315,'ro','Coduri de bare generate cu succes',0),(335316,9315,'et','Triipkoodid on edukalt loodud',0),(335317,9315,'si','ÄŒrtne kode, ki uspeÅ¡no',0),(335318,9315,'ba','Barcode yang dihasilkan berhasil',0),(335319,9315,'nl','Streepjescodes gegenereerd met succes',0),(335320,9315,'fi','Viivakoodien luonti onnistui',0),(335321,9315,'no','Strekkoder er fullfÃ¸rt.',0),(335322,9315,'da','Stregkoder genereret med succes',0),(335323,9315,'ko','ì„±ê³µì ìœ¼ë¡œ ìƒì„± í•˜ëŠ” ë°”ì½”ë“œ',0),(335324,9315,'he','×‘×¨×§×•×“×™× ×©× ×•×¦×¨×• ×‘×”×¦×œ×—×”',0),(335325,9315,'el','Î“ÏÎ±Î¼Î¼Ï‰Ï„Î¿Î¯ ÎºÏŽÎ´Î¹ÎºÎµÏ‚ Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(335326,9315,'zh','æ¡ç æˆåŠŸç”Ÿæˆ\r\n',0),(335327,9315,'sv','Streckkoder genereras framgÃ¥ngsrikt',0),(335328,9315,'it','Codici a barre generato con successo',0),(335329,9315,'tl','',0),(335330,9315,'th','&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3610;&#3634;&#3619;&#3660;&#3650;&#3588;&#3657;&#3604;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(335331,9315,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡à¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨',0),(335332,9315,'ms','Kod Bar yang dijana berjaya',0),(335333,9315,'ar','Ø§Ù„Ø±Ù…ÙˆØ² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠØ© Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(335334,9315,'fr','Codes Ã  barres gÃ©nÃ©rÃ© avec succÃ¨s',0),(335335,9315,'jp','æ­£å¸¸ã«ç”Ÿæˆã•ã‚ŒãŸãƒãƒ¼ã‚³ãƒ¼ãƒ‰',0),(335336,9315,'pt','CÃ³digos de barras gerados com sucesso',0),(335337,9315,'ru','Ð¨Ñ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½',0),(335338,9315,'es','CÃ³digos de Barras Generados Exitosamente',0),(335339,9315,'de','Barcodes erfolgreich generiert',0),(335340,9315,'en','Barcodes Generated Successfully',0),(335341,9316,'is','',0),(335342,9316,'dr',' Ø§ÙŠØ¬Ø§Ø¯  Ø¨Ø§Ø±ÙƒØ¯ Ù‡Ø§',0),(335343,9316,'pr',' Ø§ÙŠØ¬Ø§Ø¯  Ø¨Ø§Ø±ÙƒØ¯ Ù‡Ø§',0),(335344,9316,'tr','Barkodlar oluÅŸturmak',0),(335345,9316,'pl','Tworzenie kodÃ³w kreskowych',0),(335346,9316,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´Ðµ Ð±Ð°Ñ€ÐºÐ¾Ð´Ð¾Ð²Ðµ',0),(335347,9316,'ur','ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ØªØ§ ÛÛ’',0),(335348,9316,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ Ð‘Ð°Ñ€ ÐºÐ¾Ð´Ð¾Ð²Ð¸',0),(335349,9316,'vi','Táº¡o mÃ£ váº¡ch',0),(335350,9316,'af','Skep Strepieskodes',0),(335351,9316,'ro','Crea coduri de bare',0),(335352,9316,'et','Triipkoodid',0),(335353,9316,'si','Ustvari Ärtne kode',0),(335354,9316,'ba','Membuat barcode',0),(335355,9316,'nl','Maak Barcodes',0),(335356,9316,'fi','Luo viivakoodeja',0),(335357,9316,'no','Lage strekkoder',0),(335358,9316,'da','Opret stregkoder',0),(335359,9316,'ko','ë°”ì½”ë“œ ë§Œë“¤ê¸°',0),(335360,9316,'he','×œ×™×¦×•×¨ ×‘×¨×§×•×“×™×',0),(335361,9316,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ ÏÎ±Î²Î´Î¿ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(335362,9316,'zh','åˆ›å»ºæ¡ç \r\n',0),(335363,9316,'sv','Skapa streckkoder',0),(335364,9316,'it','Creare codici a barre',0),(335365,9316,'tl','',0),(335366,9316,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3610;&#3634;&#3619;&#3660;&#3650;&#3588;&#3657;&#3604;',0),(335367,9316,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤¬à¤¨à¤¾à¤¨à¥‡',0),(335368,9316,'ms','Mewujudkan Kod Bar',0),(335369,9316,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø±Ù…ÙˆØ² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠØ©',0),(335370,9316,'fr','CrÃ©er des codes Ã  barres',0),(335371,9316,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(335372,9316,'pt','Criar cÃ³digos de barras',0),(335373,9316,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´Ð¾Ð²',0),(335374,9316,'es','Crea CÃ³digos de Barras',0),(335375,9316,'de','Erstellen Sie Barcodes',0),(335376,9316,'en','Create Barcodes',0),(335377,9317,'is','',0),(335378,9317,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø§Ø±ÙƒØ¯Ù‡Ø§',0),(335379,9317,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø§Ø±ÙƒØ¯Ù‡Ø§',0),(335380,9317,'tr','Barkod numarasÄ±',0),(335381,9317,'pl','Liczba kodÃ³w kreskowych',0),(335382,9317,'bg','Ð‘Ñ€Ð¾ÑÑ‚ Ð½Ð° Ð±Ð°Ñ€ÐºÐ¾Ð´Ð¾Ð²Ðµ',0),(335383,9317,'ur','Ø¶Ø§Ø¨Ø·Û’ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(335384,9317,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð‘Ð°Ñ€ ÐºÐ¾Ð´Ð¾Ð²Ð¸',0),(335385,9317,'vi','Sá»‘ mÃ£ váº¡ch',0),(335386,9317,'af','Aantal Strepieskodes',0),(335387,9317,'ro','NumÄƒrul de coduri de bare',0),(335388,9317,'et','VÃ¶Ã¶tkoodid arv',0),(335389,9317,'si','Å tevilka Ärtne kode',0),(335390,9317,'ba','Jumlah barcode',0),(335391,9317,'nl','Aantal Barcodes',0),(335392,9317,'fi','MÃ¤Ã¤rÃ¤ viivakoodeja',0),(335393,9317,'no','Antall strekkoder',0),(335394,9317,'da','Antallet af stregkoder',0),(335395,9317,'ko','ë°”ì½”ë“œì˜ ë²ˆí˜¸',0),(335396,9317,'he','×ž×¡×¤×¨ ×”×‘×¨×§×•×“×™×',0),(335397,9317,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Ï„Ï‰Î½ Barcodes',0),(335398,9317,'zh','æ¡ç æ•°\r\n',0),(335399,9317,'sv','Antal streckkoder',0),(335400,9317,'it','Numero di codici a barre',0),(335401,9317,'tl','',0),(335402,9317,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3586;&#3586;&#3629;&#3591;&#3610;&#3634;&#3619;&#3660;&#3650;&#3588;&#3657;&#3604;',0),(335403,9317,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡à¥à¤¸ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(335404,9317,'ms','Nombor Kod Bar yang',0),(335405,9317,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø±Ù…ÙˆØ² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠØ©',0),(335406,9317,'fr','Nombre de codes Ã  barres',0),(335407,9317,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã®æ•°',0),(335408,9317,'pt','NÃºmero de cÃ³digos de barras',0),(335409,9317,'ru','Ð§Ð¸ÑÐ»Ð¾ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´Ð¾Ð²',0),(335410,9317,'es','NÃºmero de CÃ³digos de Barras',0),(335411,9317,'de','Anzahl der Barcodes',0),(335412,9317,'en','Number of Barcodes',0),(335413,9318,'is','',0),(335414,9318,'dr','Ú†Ø§Ù¾ Ø¨Ø§Ø±ÙƒØ¯Ù‡Ø§ ',0),(335415,9318,'pr','Ú†Ø§Ù¾ Ø¨Ø§Ø±ÙƒØ¯Ù‡Ø§ ',0),(335416,9318,'tr','Bar kodlarÄ± yazdÄ±rma',0),(335417,9318,'pl','Drukowanie kodÃ³w kreskowych',0),(335418,9318,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð±Ð°Ñ€ÐºÐ¾Ð´Ð¾Ð²Ðµ',0),(335419,9318,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Ø±ØªØ§ ÛÛ’ Û”',0),(335420,9318,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð¾Ð²Ð°',0),(335421,9318,'vi','In mÃ£ váº¡ch',0),(335422,9318,'af','Druk Strepieskodes',0),(335423,9318,'ro','Imprima coduri de bare',0),(335424,9318,'et','Prindi vÃ¶Ã¶tkoodid',0),(335425,9318,'si','Tiskanje Ärtne kode',0),(335426,9318,'ba','Mencetak barcode',0),(335427,9318,'nl','Afdrukken van Barcodes',0),(335428,9318,'fi','Tulostaa viivakoodeja',0),(335429,9318,'no','Skrive ut strekkoder',0),(335430,9318,'da','Udskrive stregkoder',0),(335431,9318,'ko','ë°”ì½”ë“œ ì¸ì‡„',0),(335432,9318,'he','×œ×”×“×¤×™×¡ ×‘×¨×§×•×“×™×',0),(335433,9318,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Barcodes',0),(335434,9318,'zh','æ‰“å°æ¡ç \r\n',0),(335435,9318,'sv','Skriva ut streckkoder',0),(335436,9318,'it','Stampa codici a barre',0),(335437,9318,'tl','',0),(335438,9318,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3610;&#3634;&#3619;&#3660;&#3650;&#3588;&#3657;&#3604;',0),(335439,9318,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(335440,9318,'ms','Cetak Kod Bar',0),(335441,9318,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø±Ù…ÙˆØ² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠØ©',0),(335442,9318,'fr','Imprimer des codes barres',0),(335443,9318,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(335444,9318,'pt','Imprimir cÃ³digos de barras',0),(335445,9318,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´Ð¾Ð²',0),(335446,9318,'es','Imprimir CÃ³digos de Barras',0),(335447,9318,'de','Drucken von Barcodes',0),(335448,9318,'en','Print Barcodes',0),(335449,9319,'is','',0),(335450,9319,'dr','Ø­Ø³Ø§Ø¨â€ŒÙ‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ÙƒÙ„ÙŠ ',0),(335451,9319,'pr','Ø­Ø³Ø§Ø¨â€ŒÙ‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ ÙƒÙ„ÙŠ ',0),(335452,9319,'tr','Genel BorÃ§lar',0),(335453,9319,'pl','OgÃ³lne zobowiÄ…zania',0),(335454,9319,'bg','ÐžÐ±Ñ‰Ð¸ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(335455,9319,'ur','Ø¬Ù†Ø±Ù„ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³',0),(335456,9319,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(335457,9319,'vi','Pháº£i Tráº£ Chung',0),(335458,9319,'af','Algemene Uitgawes (RB)',0),(335459,9319,'ro','General ÅŸi datorii',0),(335460,9319,'et','Ãœldised kohustused',0),(335461,9319,'si','SploÅ¡ne obveznosti',0),(335462,9319,'ba','Kewajiban Umum',0),(335463,9319,'nl','Algemene inkoop',0),(335464,9319,'fi','Yleiset velat',0),(335465,9319,'no','General leverandÃ¸rgjeld',0),(335466,9319,'da','General kreditorstyring',0),(335467,9319,'ko','ì¼ë°˜ ë¯¸ì§€ê¸‰ê¸ˆ',0),(335468,9319,'he','×’× ×¨×œ ×–×›××™×',0),(335469,9319,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï…Ï€Î¿Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(335470,9319,'zh','ä¸€èˆ¬åº”ä»˜æ¬¾\r\n',0),(335471,9319,'sv','General LeverantÃ¶rsskulder',0),(335472,9319,'it','Generale i debiti',0),(335473,9319,'tl','',0),(335474,9319,'th','&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(335475,9319,'hi','à¤œà¤¨à¤°à¤² Payables',0),(335476,9319,'ms','Am pemiutang',0),(335477,9319,'ar','Ø§Ù„Ø¹Ø§Ù…Ø© Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(335478,9319,'fr','GÃ©nÃ©ral des comptes fournisseurs',0),(335479,9319,'jp','ä¸€èˆ¬å‚µå‹™',0),(335480,9319,'pt','Contas a pagar geral',0),(335481,9319,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ Ð¾Ð±Ñ‰ÐµÐ³Ð¾',0),(335482,9319,'es','Cuentas por Pagar Generales',0),(335483,9319,'de','Allgemeine Verbindlichkeiten',0),(335484,9319,'en','General Payables',0),(335485,9320,'is','',0),(335486,9320,'dr','Ù…Ø·Ø§Ù„Ø¨Ø§Øª ÙƒÙ„ÙŠ ',0),(335487,9320,'pr','Ù…Ø·Ø§Ù„Ø¨Ø§Øª ÙƒÙ„ÙŠ ',0),(335488,9320,'tr','Genel fatura',0),(335489,9320,'pl','OgÃ³lne, fakturowanie',0),(335490,9320,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(335491,9320,'ur','Ø¬Ù†Ø±Ù„ Ø¨Ù„Ù†Ú¯',0),(335492,9320,'sr','ÐžÐ¿ÑˆÑ‚Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(335493,9320,'vi','Pháº£i Thu Chung',0),(335494,9320,'af','Algemene fakturering',0),(335495,9320,'ro','Generale de facturare',0),(335496,9320,'et','Ãœldine, arveldamine',0),(335497,9320,'si','SploÅ¡na zaraÄunavanje',0),(335498,9320,'ba','Umum penagihan',0),(335499,9320,'nl','Algemene facturatie',0),(335500,9320,'fi','Ehdot laskutus',0),(335501,9320,'no','De generelle fakturering',0),(335502,9320,'da','Generelle fakturering',0),(335503,9320,'ko','ì¼ë°˜ ê²°ì œ',0),(335504,9320,'he','×—×™×•×‘ ×›×œ×œ×™',0),(335505,9320,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(335506,9320,'zh','ä¸€èˆ¬åº”æ”¶æ¬¾\r\n',0),(335507,9320,'sv','De allmÃ¤nna fakturering',0),(335508,9320,'it','Fatturazione generale',0),(335509,9320,'tl','',0),(335510,9320,'th','&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(335511,9320,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤¬à¤¿à¤²à¤¿à¤‚à¤—',0),(335512,9320,'ms','Am bil',0),(335513,9320,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø¹Ø§Ù…Ø©',0),(335514,9320,'fr','Facturation gÃ©nÃ©rale',0),(335515,9320,'jp','ä¸€èˆ¬çš„ãªè«‹æ±‚',0),(335516,9320,'pt','Faturamento geral',0),(335517,9320,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ð°',0),(335518,9320,'es','Cuentas por Cobrar Generales',0),(335519,9320,'de','Allgemeine Abrechnung',0),(335520,9320,'en','General Billing',0),(335521,9321,'is','',0),(335522,9321,'dr','Ù…Ø¯Ù„ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(335523,9321,'pr','Ù…Ø¯Ù„ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡',0),(335524,9321,'tr','Yerine getirilmesi sipariÅŸ modu',0),(335525,9321,'pl','Tryb realizacji zlecenia',0),(335526,9321,'bg','Ð ÐµÐ¶Ð¸Ð¼ Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(335527,9321,'ur','ØªÚ©Ù…ÛŒÙ„ ØªØ±ØªÛŒØ¨ Ù…ÙˆÚˆ',0),(335528,9321,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ€ÐµÐ¶Ð¸Ð¼',0),(335529,9321,'vi','Tráº¡ng thÃ¡i ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(335530,9321,'af','Uitvoeringsbestelling Modus',0),(335531,9321,'ro','Modul de ordinea Ã®mplinirea',0),(335532,9321,'et','Kaubatellimuse reÅ¾iim',0),(335533,9321,'si','NaÄin za izpolnitev nalog',0),(335534,9321,'ba','Pemenuhan Order Mode',0),(335535,9321,'nl','Vervulling volgorde modus',0),(335536,9321,'fi','TÃ¤yttÃ¤minen tilauksen tila',0),(335537,9321,'no','Oppfyllelse for modus',0),(335538,9321,'da','Opfyldelse for Mode',0),(335539,9321,'ko','í–‰ ìˆœì„œ ëª¨ë“œ',0),(335540,9321,'he','×ž×¦×‘ ×”×–×ž× ×” ×”×’×©×ž×”',0),(335541,9321,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(335542,9321,'zh','å±¥è¡Œè®¢è´­æ¨¡å¼\r\n',0),(335543,9321,'sv','Fulfillment ordning lÃ¤ge',0),(335544,9321,'it','ModalitÃ  di evasione ordine',0),(335545,9321,'tl','',0),(335546,9321,'th','&#3650;&#3627;&#3617;&#3604;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(335547,9321,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤®à¥‹à¤¡',0),(335548,9321,'ms','Memenuhi perintah mod',0),(335549,9321,'ar','ÙˆØ¶Ø¹ ØªØ±ØªÙŠØ¨ Ø§Ù„ÙˆÙØ§Ø¡',0),(335550,9321,'fr','Mode de commande de rÃ©alisation',0),(335551,9321,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼ ãƒ¢ãƒ¼ãƒ‰',0),(335552,9321,'pt','Modo de ordem de cumprimento',0),(335553,9321,'ru','Ð ÐµÐ¶Ð¸Ð¼ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(335554,9321,'es','Modo de Pedido de Cumplimiento',0),(335555,9321,'de','ErfÃ¼llung-Order-Modus',0),(335556,9321,'en','Fulfillment Order Mode',0),(335557,9322,'is','',0),(335558,9322,'dr','Ù…Ø¯Ù„ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´',0),(335559,9322,'pr','Ù…Ø¯Ù„ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´',0),(335560,9322,'tr','SatÄ±ÅŸ noktasÄ± modu',0),(335561,9322,'pl','Tryb punkt sprzedaÅ¼y',0),(335562,9322,'bg','Ð¢Ð¾Ñ‡ÐºÐ° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ñ€ÐµÐ¶Ð¸Ð¼',0),(335563,9322,'ur','ÙØ±ÙˆØ®Øª Ú©Û’ Ù¾ÙˆØ§Ø¦Ù†Ù¹ Ù…ÙˆÚˆ',0),(335564,9322,'sr','ÐŸÐ¾Ð¸Ð½Ñ‚ Ð¾Ñ„ Ð¡Ð°Ð»Ðµ Ñ€ÐµÐ¶Ð¸Ð¼',0),(335565,9322,'vi','PhÆ°Æ¡ng thá»©c Ä‘iá»ƒm bÃ¡n hÃ ng',0),(335566,9322,'af','Punt van Verkope Modus',0),(335567,9322,'ro','Modul de punctul de vÃ¢nzare',0),(335568,9322,'et','POS',0),(335569,9322,'si','Prodajnih naÄin',0),(335570,9322,'ba','Point of Sale Mode',0),(335571,9322,'nl','Point of Sale Mode',0),(335572,9322,'fi','Point of Sale-tilassa',0),(335573,9322,'no','Point of Sale modus',0),(335574,9322,'da','Point of Sale tilstand',0),(335575,9322,'ko','í¬ì¸íŠ¸ì˜ íŒë§¤ ëª¨ë“œ',0),(335576,9322,'he','×ž×¦×‘ × ×§×•×“×ª ×”×ž×›×™×¨×”',0),(335577,9322,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± ÏƒÎ·Î¼ÎµÎ¯Î¿Ï… Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(335578,9322,'zh','é”€å”®ç‚¹æ¨¡å¼\r\n',0),(335579,9322,'sv','Point of Sale-lÃ¤ge',0),(335580,9322,'it','ModalitÃ  di punto vendita',0),(335581,9322,'tl','',0),(335582,9322,'th','&#3650;&#3627;&#3617;&#3604; &#3603; &#3592;&#3640;&#3604;&#3586;&#3634;&#3618;',0),(335583,9322,'hi','à¤ªà¥‹à¤‡à¤‚à¤Ÿ à¤‘à¤« à¤¸à¥‡à¤² à¤®à¥‹à¤¡',0),(335584,9322,'ms','Point of Sale mod',0),(335585,9322,'ar','ÙˆØ¶Ø¹ Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(335586,9322,'fr','Point de vente Mode',0),(335587,9322,'jp','è²©å£²ãƒã‚¤ãƒ³ãƒˆ ãƒ¢ãƒ¼ãƒ‰',0),(335588,9322,'pt','Modo de ponto de venda',0),(335589,9322,'ru','Ð ÐµÐ¶Ð¸Ð¼ Ñ‚Ð¾Ñ‡ÐºÐ¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(335590,9322,'es','Modo de Punto de Venta',0),(335591,9322,'de','Point of Sale-Modus',0),(335592,9322,'en','Point of Sale Mode',0),(335593,9323,'is','',0),(335594,9323,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(335595,9323,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(335596,9323,'tr','VarsayÄ±lan Ã¶deme yÃ¶ntemi',0),(335597,9323,'pl','DomyÅ›lna metoda pÅ‚atnoÅ›ci',0),(335598,9323,'bg','ÐÐ°Ñ‡Ð¸Ð½ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(335599,9323,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø§ Ø·Ø±ÛŒÙ‚Û',0),(335600,9323,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ñ‡Ð¸Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(335601,9323,'vi','PhÆ°Æ¡ng thá»©c thanh toÃ¡n Máº·c Ä‘á»‹nh',0),(335602,9323,'af','Verstekte Betalingsmetode',0),(335603,9323,'ro','MetodÄƒ de platÄƒ prestabilitÄƒ',0),(335604,9323,'et','Vaikimisi makse meetod',0),(335605,9323,'si','Privzeti naÄin plaÄila',0),(335606,9323,'ba','Metode pembayaran standar',0),(335607,9323,'nl','Standaard betalingsmethode',0),(335608,9323,'fi','Oletusmaksutapa',0),(335609,9323,'no','Standard betalingsmÃ¥te',0),(335610,9323,'da','Standardbetalingsmetode',0),(335611,9323,'ko','ê¸°ë³¸ ê²°ì œ ë°©ë²•',0),(335612,9323,'he','×©×™×˜×ª ×ª×©×œ×•× ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(335613,9323,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¼Î­Î¸Î¿Î´Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(335614,9323,'zh','é»˜è®¤ä»˜æ¬¾æ–¹å¼\r\n',0),(335615,9323,'sv','Standardbetalningsmetod',0),(335616,9323,'it','Metodo di pagamento predefinito',0),(335617,9323,'tl','',0),(335618,9323,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3648;&#3591;&#3636;&#3609;',0),(335619,9323,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤§à¤¿',0),(335620,9323,'ms','Kaedah pembayaran lalai',0),(335621,9323,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(335622,9323,'fr','Mode de paiement par dÃ©faut',0),(335623,9323,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã®æ”¯æ‰•ã„æ–¹æ³•',0),(335624,9323,'pt','MÃ©todo de Pagamento PadrÃ£o',0),(335625,9323,'ru','Ð¡Ð¿Ð¾ÑÐ¾Ð± Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(335626,9323,'es','MÃ©todo de Pago por Defecto',0),(335627,9323,'de','Standard-Zahlungsart',0),(335628,9323,'en','Default Payment Method',0),(335629,9324,'is','',0),(335630,9324,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙˆØ¯ ',0),(335631,9324,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙˆØ¯ ',0),(335632,9324,'tr','Kar gÃ¶rÃ¼ntÃ¼lemek',0),(335633,9324,'pl','WyÅ›wietliÄ‡ zysk',0),(335634,9324,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(335635,9324,'ur','Ù…Ù†Ø§ÙØ¹ Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(335636,9324,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚',0),(335637,9324,'vi','Hiá»ƒn thá»‹ lá»£i nhuáº­n',0),(335638,9324,'af','Wys Wins',0),(335639,9324,'ro','Profit de afiÅŸare',0),(335640,9324,'et','Kuva kasum',0),(335641,9324,'si','Prikaz dobiÄka',0),(335642,9324,'ba','Menampilkan keuntungan',0),(335643,9324,'nl','Weer winst',0),(335644,9324,'fi','NÃ¤yttÃ¤Ã¤ voittoa',0),(335645,9324,'no','Vise profitt',0),(335646,9324,'da','FÃ¥ vist overskud',0),(335647,9324,'ko','ë””ìŠ¤í”Œë ˆì´ ì´ìµ',0),(335648,9324,'he','×œ×”×¦×™×’ ×¨×•×•×—',0),(335649,9324,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î±Ï€Î¿Ï„ÎµÎ»ÎµÏƒÎ¼Î¬Ï„Ï‰Î½',0),(335650,9324,'zh','æ˜¾ç¤ºç›ˆåˆ©\r\n',0),(335651,9324,'sv','Visa resultat',0),(335652,9324,'it','Visualizzare il profitto',0),(335653,9324,'tl','',0),(335654,9324,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3635;&#3652;&#3619;',0),(335655,9324,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤²à¤¾à¤­',0),(335656,9324,'ms','Paparan keuntungan',0),(335657,9324,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø±Ø¨Ø­',0),(335658,9324,'fr','Profit de lâ€™affichage',0),(335659,9324,'jp','åˆ©ç›Šã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(335660,9324,'pt','Mostrar Lucro',0),(335661,9324,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ',0),(335662,9324,'es','Desplega la Utilidad',0),(335663,9324,'de','Display-Gewinn',0),(335664,9324,'en','Display Profit',0),(335665,9325,'is','',0),(335666,9325,'dr','Ù†Ù…Ø§ÙŠØ´ ÙˆØ²Ù† ',0),(335667,9325,'pr','Ù†Ù…Ø§ÙŠØ´ ÙˆØ²Ù† ',0),(335668,9325,'tr','AÄŸÄ±rlÄ±k gÃ¶rÃ¼ntÃ¼leme',0),(335669,9325,'pl','WyÅ›wietlacz wagi',0),(335670,9325,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐ³Ð»Ð¾',0),(335671,9325,'ur','ÙˆØ²Ù† Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(335672,9325,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ñ‚ÐµÐ¶Ð¸Ð½Ð°',0),(335673,9325,'vi','Hiá»ƒn thá»‹ trá»ng lÆ°á»£ng',0),(335674,9325,'af','Wys Gewig',0),(335675,9325,'ro','Greutate de afiÅŸare',0),(335676,9325,'et','Ekraan kaal',0),(335677,9325,'si','Prikaz teÅ¾e',0),(335678,9325,'ba','Menampilkan berat',0),(335679,9325,'nl','Gewicht weergeven',0),(335680,9325,'fi','NÃ¤yttÃ¤Ã¤ paino',0),(335681,9325,'no','Vise vekt',0),(335682,9325,'da','Vise vÃ¦gt',0),(335683,9325,'ko','ë””ìŠ¤í”Œë ˆì´ ì¤‘ëŸ‰',0),(335684,9325,'he','×œ×”×¦×™×’ ×ž×©×§×œ',0),(335685,9325,'el','Î•Î¼Ï†Î±Î½Î¯ÏƒÎµÏ„Îµ Ï„Î¿ Î²Î¬ÏÎ¿Ï‚',0),(335686,9325,'zh','æ˜¾ç¤ºé‡é‡\r\n',0),(335687,9325,'sv','Visa vikt',0),(335688,9325,'it','Visualizza il peso',0),(335689,9325,'tl','',0),(335690,9325,'th','&#3649;&#3626;&#3604;&#3591;&#3588;&#3656;&#3634;&#3609;&#3657;&#3635;&#3627;&#3609;&#3633;&#3585;',0),(335691,9325,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤µà¤œà¤¨',0),(335692,9325,'ms','Berat paparan',0),(335693,9325,'ar','Ø¹Ø±Ø¶ Ø§Ù„ÙˆØ²Ù†',0),(335694,9325,'fr','Afficher le poids',0),(335695,9325,'jp','é‡é‡ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(335696,9325,'pt','Mostrar Peso',0),(335697,9325,'ru','Ð’ÐµÑ Ð´Ð¸ÑÐ¿Ð»ÐµÑ',0),(335698,9325,'es','Desplega el Peso',0),(335699,9325,'de','Display Gewicht',0),(335700,9325,'en','Display Weight',0),(335701,9326,'is','',0),(335702,9326,'dr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø«Ø¨Øª ØªØ®ÙÙŠÙØ§Øª ',0),(335703,9326,'pr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø«Ø¨Øª ØªØ®ÙÙŠÙØ§Øª ',0),(335704,9326,'tr','Ä°ndirimler giriÅŸ gizle',0),(335705,9326,'pl','Ukryj rabaty wpis',0),(335706,9326,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ð·Ð°Ð¿Ð¸Ñ',0),(335707,9326,'ur','Ú†Ú¾ÙˆÙ¹ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(335708,9326,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(335709,9326,'vi','Giáº¥u Entry Chiáº¿t Kháº¥u',0),(335710,9326,'af','Verberg Kortings Inskrywing',0),(335711,9326,'ro','Ascundere: Reduceri la intrare',0),(335712,9326,'et','Peida allahindlusi kanne',0),(335713,9326,'si','Skrij popusti vnos',0),(335714,9326,'ba','Sembunyikan diskon entri',0),(335715,9326,'nl','Kortingen item verbergen',0),(335716,9326,'fi','Piilota alennukset merkintÃ¤',0),(335717,9326,'no','Skjul rabatter oppfÃ¸ring',0),(335718,9326,'da','Skjule rabatter post',0),(335719,9326,'ko','í• ì¸ í•­ëª© ìˆ¨ê¸°ê¸°',0),(335720,9326,'he','×”×¡×ª×¨ ×”× ×—×•×ª ×›× ×™×¡×”',0),(335721,9326,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(335722,9326,'zh','éšè—æŠ˜æ‰£æ¡ç›®\r\n',0),(335723,9326,'sv','DÃ¶lja rabatter intrÃ¤de',0),(335724,9326,'it','Nascondere la voce Sconti',0),(335725,9326,'tl','',0),(335726,9326,'th','&#3595;&#3656;&#3629;&#3609;&#3585;&#3634;&#3619;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(335727,9326,'hi','à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤›à¥à¤ªà¤¾à¤à¤',0),(335728,9326,'ms','Sembunyi diskaun penyertaan',0),(335729,9326,'ar','Ø¥Ø®ÙØ§Ø¡ Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª',0),(335730,9326,'fr','Cacher lâ€™entrÃ©e de remises',0),(335731,9326,'jp','å‰²å¼•ã‚¨ãƒ³ãƒˆãƒªã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(335732,9326,'pt','Ocultar Desconto de Entrada',0),(335733,9326,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ ÑÐºÐ¸Ð´ÐºÐ¸',0),(335734,9326,'es','Esconde Entradas de Descuentos',0),(335735,9326,'de','Rabatte-Eintrag ausblenden',0),(335736,9326,'en','Hide Discounts Entry',0),(335737,9327,'is','',0),(335738,9327,'dr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø¢Ù…Ø§Ø± ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(335739,9327,'pr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø¢Ù…Ø§Ø± ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(335740,9327,'tr','Stok istatistikleri gizle',0),(335741,9327,'pl','UkryÄ‡ zapasÃ³w statystyki',0),(335742,9327,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð·Ð°Ð¿Ð°ÑÐ¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(335743,9327,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ÙˆØ´Ù…Ø§Ø± Ú©ÛŒ ØªØµÙˆÛŒØ± Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(335744,9327,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(335745,9327,'vi','Giáº¥u Sá»‘ Liá»‡u Thá»‘ng KÃª HÃ ng hÃ³a',0),(335746,9327,'af','Verberg Inventaris Stats',0),(335747,9327,'ro','Ascunde statistic inventar',0),(335748,9327,'et','Peida varude statistika',0),(335749,9327,'si','Skriti zalogi statistika',0),(335750,9327,'ba','Menyembunyikan Statistik persediaan',0),(335751,9327,'nl','Inventaris Stats te verbergen',0),(335752,9327,'fi','Piilota varaston tilastot',0),(335753,9327,'no','Skjule lager statistikk',0),(335754,9327,'da','Skjule lager statistik',0),(335755,9327,'ko','ìž¬ê³  í†µê³„ ìˆ¨ê¸°ê¸°',0),(335756,9327,'he','×œ×”×¡×ª×™×¨ ××ª ×”×ž×œ××™ ×¡×˜×˜×™×¡×˜×™×§×”',0),(335757,9327,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬',0),(335758,9327,'zh','éšè—åº“å­˜ç»Ÿè®¡\r\n',0),(335759,9327,'sv','DÃ¶lja lager statistik',0),(335760,9327,'it','Nascondere le statistiche di inventario',0),(335761,9327,'tl','',0),(335762,9327,'th','&#3595;&#3656;&#3629;&#3609;&#3626;&#3606;&#3636;&#3605;&#3636;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;',0),(335763,9327,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤†à¤à¤•à¤¡à¤¼à¥‡ à¤›à¥à¤ªà¤¾à¤à¤',0),(335764,9327,'ms','Sorok statistik inventori',0),(335765,9327,'ar','Ø¥Ø®ÙØ§Ø¡ Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(335766,9327,'fr','Masquer les Stats de lâ€™inventaire',0),(335767,9327,'jp','åœ¨åº«çµ±è¨ˆã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(335768,9327,'pt','Ocultar EstatÃ­stica de InventÃ¡rio',0),(335769,9327,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÑƒ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(335770,9327,'es','Esconde EstadÃ­sticas de Inventario',0),(335771,9327,'de','Inventar-Statistik ausblenden',0),(335772,9327,'en','Hide Inventory Stats',0),(335773,9328,'is','',0),(335774,9328,'dr','/ Ø³ÙˆÙŠÙŠÚ† ÙØ±Ù…Ø§Ù† Ø§Ø¬Ø±Ø§ ',0),(335775,9328,'pr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ / Ø³ÙˆÙŠÙŠÚ† ÙØ±Ù…Ø§Ù† Ø§Ø¬Ø±Ø§ ',0),(335776,9328,'tr','POS/yerine getirilmesi Mod dÃ¼ÄŸmesini gizle',0),(335777,9328,'pl','Ukryj przeÅ‚Ä…cznik trybu POS/realizacja',0),(335778,9328,'bg','Ð¡ÐºÑ€Ð¸Ð¹ POS/Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ñ€ÐµÐ¶Ð¸Ð¼ Ð¿Ñ€ÐµÐ²ÐºÐ»ÑŽÑ‡Ð²Ð°Ð½Ðµ',0),(335779,9328,'ur','Ù¾ÙˆØ²ÛŒØ´Ù†/ØªÚ©Ù…ÛŒÙ„ Ù…ÙˆÚˆ Ø³ÙˆØ¦Ú† Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(335780,9328,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÐŸÐžÐ¡/Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð¿Ñ€ÐµÐ»Ð°Ð·Ð°Ðº Ñƒ Ñ€ÐµÐ¶Ð¸Ð¼',0),(335781,9328,'vi','Giáº¥u Äiá»ƒm BÃ¡n HÃ ng/NÃºt PhÆ°Æ¡ng Thá»©c Giao Táº­n NÆ¡i ',0),(335782,9328,'af','Verberg PVV/Uitvoering Modus Skakelaar',0),(335783,9328,'ro','Ascunde POS/Ã®mplinire comutatorul',0),(335784,9328,'et','Peida POS/tÃ¤itmise lÃ¼liti',0),(335785,9328,'si','Skriti POS/izpolnitev stikalo za izbiro naÄina',0),(335786,9328,'ba','Sembunyikan beralih modus POS pemenuhan',0),(335787,9328,'nl','POS/Fulfillment-modus-schakelaar verbergen',0),(335788,9328,'fi','Piilota POS/tÃ¤yttÃ¤minen Mode-kytkin',0),(335789,9328,'no','Skjule POS/oppfyllelse modusbryter',0),(335790,9328,'da','Skjule POS/opfyldelse funktionsknappen',0),(335791,9328,'ko','í¬ìŠ¤/í–‰ ëª¨ë“œ ìŠ¤ìœ„ì¹˜ë¥¼ ìˆ¨ê¸°ê¸°',0),(335792,9328,'he','×œ×”×¡×ª×™×¨ ××ª ×‘×•×¨×¨ ×ž×¦×‘ ×§×•×¤×”/×”×’×©×ž×”',0),(335793,9328,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· POS/ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Î´Î¹Î±ÎºÏŒÏ€Ï„Î· Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±Ï‚',0),(335794,9328,'zh','éšè—é”€å”®ç‚¹/å®žè·µæ¨¡å¼å¼€å…³\r\n',0),(335795,9328,'sv','DÃ¶lja POS/uppfyllelse Mode-omkopplaren',0),(335796,9328,'it','Nascondere l\'interruttore di modalitÃ  POS/evasione degli ordini',0),(335797,9328,'tl','',0),(335798,9328,'th','&#3595;&#3656;&#3629;&#3609; &#3603; &#3592;&#3640;&#3604;&#3586;&#3634;&#3618;/&#3626;&#3636;&#3609;&#3588;&#3657;&#3634; &#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3650;&#3627;&#3617;&#3604;',0),(335799,9328,'hi','POS/à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤®à¥‹à¤¡ à¤¸à¥à¤µà¤¿à¤š à¤›à¥à¤ªà¤¾à¤à¤',0),(335800,9328,'ms','Sembunyi suis mod POS/memenuhi',0),(335801,9328,'ar','Ø¥Ø®ÙØ§Ø¡ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹/Ø§Ù„ÙˆÙØ§Ø¡ Ø¨ÙˆØ¶Ø¹ Ø±Ù…Ø² Ø§Ù„ØªØ¨Ø¯ÙŠÙ„',0),(335802,9328,'fr','Masquer le sÃ©lecteur de Mode de POS/exÃ©cution',0),(335803,9328,'jp','POS/ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ãƒ¢ãƒ¼ãƒ‰ ã‚¹ã‚¤ãƒƒãƒã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(335804,9328,'pt','Esconder o interruptor de modo de POS/cumprimento',0),(335805,9328,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÐºÐ»ÑŽÑ‡Ð°Ñ‚ÐµÐ»ÑŒ Ñ€ÐµÐ¶Ð¸Ð¼Ð° POS/Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(335806,9328,'es','Esconde PDV/Apagador de Modo de Cumpimiento',0),(335807,9328,'de','POS/ErfÃ¼llung Modusschalter ausblenden',0),(335808,9328,'en','Hide POS/Fulfillment Mode Switch',0),(335809,9329,'is','',0),(335810,9329,'dr','ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø¬Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ø¬Ø§Ø±ÙŠ ',0),(335811,9329,'pr','ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø¬Ø§ÙŠ ØªØ§Ø±ÙŠØ® Ø¬Ø§Ø±ÙŠ ',0),(335812,9329,'tr','GeÃ§erli tarihi yerine kullanarak sipariÅŸ tarihi fatura',0),(335813,9329,'pl','Faktury za pomocÄ… Data zamÃ³wienia, a nie Data bieÅ¼Ä…ca',0),(335814,9329,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹ÐºÐ¸ Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°, Ð° Ð½Ðµ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(335815,9329,'ur','Ø­Ø§Ù„ÛŒÛ ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø¨Ø¬Ø§Ø¦Û’ ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(335816,9329,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›Ñƒ Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð°Ð»Ð¾Ð³Ð°, ÑƒÐ¼ÐµÑÑ‚Ð¾ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾Ð³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(335817,9329,'vi','HÃ³a Ä‘Æ¡n sá»­ dá»¥ng ngÃ y Ä‘áº·t hÃ ng, khÃ´ng dÃ¹ng ngÃ y hiá»‡n táº¡i',0),(335818,9329,'af','Faktuur gebruike Bestellingsdatum Eerder as Huidige Datum',0),(335819,9329,'ro','Factura utilizÃ¢nd comanda data decat data curenta',0),(335820,9329,'et','Arve kasutades tellimuse kuupÃ¤eva asemel kuupÃ¤eva',0),(335821,9329,'si','RaÄun uporabi datum naloga kot trenutni datum',0),(335822,9329,'ba','Faktur menggunakan tanggal Order daripada tanggal sekarang',0),(335823,9329,'nl','Factuur Orderdatum gebruiken in plaats van huidige datum',0),(335824,9329,'fi','Laskuttaa tilauksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ kuin nykyinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(335825,9329,'no','Faktura ved hjelp av ordredatoen i stedet for gjeldende dato',0),(335826,9329,'da','Faktura ved hjÃ¦lp af Ordredato snarere end dags dato',0),(335827,9329,'ko','í˜„ìž¬ ë‚ ì§œ ë³´ë‹¤ëŠ” ì£¼ë¬¸ ë‚ ì§œë¥¼ ì‚¬ìš© í•˜ ì—¬ ì†¡ìž¥',0),(335828,9329,'he','×—×©×‘×•× ×™×ª ×‘××ž×¦×¢×•×ª ×ª××¨×™×š ×”×–×ž× ×” ×‘×ž×§×•× ×”×ª××¨×™×š ×”× ×•×›×—×™',0),(335829,9329,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎºÎ±Î¹ ÏŒÏ‡Î¹ Î±Ï€ÏŒ Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(335830,9329,'zh','å‘ç¥¨ä½¿ç”¨è®¢å•æ—¥æœŸï¼Œè€Œä¸æ˜¯å½“å‰æ—¥æœŸ\r\n',0),(335831,9329,'sv','Fakturera med Orderdatum i stÃ¤llet fÃ¶r dagens datum',0),(335832,9329,'it','La fattura utilizzando Data ordine piuttosto che la data corrente',0),(335833,9329,'tl','',0),(335834,9329,'th','&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3649;&#3607;&#3609;&#3607;&#3',0),(335835,9329,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤¬à¤œà¤¾à¤¯ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤šà¤¾à¤²à¤¾à¤¨',0),(335836,9329,'ms','Invois menggunakan tarikh perintah dan bukannya tarikh semasa',0),(335837,9329,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªØ±ØªÙŠØ¨ Ø§Ù„ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ù„Ø§Ù‹ Ù…Ù† Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(335838,9329,'fr','La facture Date Ã  lâ€™aide de la commande plutÃ´t que la Date actuelle',0),(335839,9329,'jp','è«‹æ±‚æ›¸ã®ç¾åœ¨ã®æ—¥ä»˜ã§ã¯ãªãã€å—æ³¨æ—¥ã‚’ä½¿ç”¨ã—ã¦',0),(335840,9329,'pt','Fatura usando a data do pedido, ao invÃ©s de data atual',0),(335841,9329,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸ÐµÐ¼ Ð´Ð°Ñ‚Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð°, Ð²Ð¼ÐµÑÑ‚Ð¾ Ñ‚Ð¾Ð³Ð¾, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ Ð´Ð°Ñ‚Ð°',0),(335842,9329,'es','Factura Usando Fecha de Pedido en Lugar de Fecha Actual',0),(335843,9329,'de','Rechnung mit Bestelldatum anstatt Tagesdatum',0),(335844,9329,'en','Invoice Using Order Date Rather Than Current Date',0),(335845,9330,'is','',0),(335846,9330,'dr','/ ØµÙØ­Ù‡ ÙØ±Ù…Ø§ÛŒØ´ Ø§Ø¬Ø±Ø§  ',0),(335847,9330,'pr','Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ / ØµÙØ­Ù‡ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§  ',0),(335848,9330,'tr','POS/yerine getirilmesi sipariÅŸ sayfasÄ±',0),(335849,9330,'pl','POS/realizacji zamÃ³wienia strony',0),(335850,9330,'bg','POS/Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð¾Ð²ÐµÐ´ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(335851,9330,'ur','Ù¾ÙˆØ²ÛŒØ´Ù†/ØªÚ©Ù…ÛŒÙ„ ØªØ±ØªÛŒØ¨ ØµÙØ­Û',0),(335852,9330,'sr','ÐŸÐžÐ¡ /Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(335853,9330,'vi','Äiá»ƒm bÃ¡n hÃ ng/trang Ä‘Æ¡n hÃ ng giao táº­n nÆ¡i',0),(335854,9330,'af','PVV/Uitvoeringsbestelling Bladsy',0),(335855,9330,'ro','Pagina de comandÄƒ POS/Ã®mplinire',0),(335856,9330,'et','POS/Kaubatellimuse leht',0),(335857,9330,'si','POS/izpolnitev vrstni red strani',0),(335858,9330,'ba','Halaman POS pemenuhan Order',0),(335859,9330,'nl','POS/vervulling bestelpagina',0),(335860,9330,'fi','POS/tÃ¤yttÃ¤minen tilaussivulle',0),(335861,9330,'no','POS/oppfyllelse bestillingssiden',0),(335862,9330,'da','POS/opfyldelse bestillingssiden',0),(335863,9330,'ko','í¬ìŠ¤/ì„±ì·¨ ì£¼ë¬¸ íŽ˜ì´ì§€',0),(335864,9330,'he','×“×£ ×§×•×¤×”/×”×’×©×ž×”',0),(335865,9330,'el','POS/ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏƒÎµÎ»Î¯Î´Î±',0),(335866,9330,'zh','é”€å”®ç‚¹/å±¥è¡Œè®¢å•é¡µ\r\n',0),(335867,9330,'sv','POS/uppfyllelse bestÃ¤llningssida',0),(335868,9330,'it','Pagina ordine POS/evasione degli ordini',0),(335869,9330,'tl','',0),(335870,9330,'th','&#3627;&#3609;&#3657;&#3634;&#3592;&#3640;&#3604;&#3586;&#3634;&#3618;/&#3627;&#3609;&#3657;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(335871,9330,'hi','POS/à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤ªà¥ƒà¤·à¥à¤ ',0),(335872,9330,'ms','Laman pesanan POS/memenuhi',0),(335873,9330,'ar','Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹/ÙˆÙØ§Ø¡ ØªØ±ØªÙŠØ¨ Ø§Ù„ØµÙØ­Ø§Øª',0),(335874,9330,'fr','Page de commande POS/exÃ©cution',0),(335875,9330,'jp','POS/ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆæ³¨æ–‡ãƒšãƒ¼ã‚¸',0),(335876,9330,'pt','PÃ¡gina de pedido de POS/cumprimento',0),(335877,9330,'ru','POS/Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(335878,9330,'es','PÃ¡gina de Orden PDV/Cumplimiento',0),(335879,9330,'de','POS/ErfÃ¼llung Bestellseite',0),(335880,9330,'en','POS/Fulfillment Order Page',0),(335881,9331,'is','',0),(335882,9331,'dr','ØµÙØ­Ù‡ Ø³ÙØ§Ø±Ø´ Ù…ØªØ­Ø±Ùƒ',0),(335883,9331,'pr','ØµÙØ­Ù‡ Ø³ÙØ§Ø±Ø´ Ù…ØªØ­Ø±Ùƒ',0),(335884,9331,'tr','Dinamik sipariÅŸ sayfasÄ±',0),(335885,9331,'pl','Strony dynamiczne zamÃ³wienia',0),(335886,9331,'bg','Ð”Ð¸Ð½Ð°Ð¼Ð¸Ñ‡ÐµÐ½ Ñ€ÐµÐ´ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(335887,9331,'ur','Ù…ØªØ­Ø±Ú© ØªØ±ØªÛŒØ¨ ØµÙØ­Û',0),(335888,9331,'sr','Ð”Ð¸Ð½Ð°Ð¼Ð¸Ñ‡ÐºÐ¸ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(335889,9331,'vi','Trang Äáº·t HÃ ng Äá»™ng',0),(335890,9331,'af','Dinamiese Order bladsy',0),(335891,9331,'ro','Pagina de comandÄƒ dinamic',0),(335892,9331,'et','DÃ¼naamiline tellimisleht',0),(335893,9331,'si','DinamiÄna stran',0),(335894,9331,'ba','Halaman dinamis Order',0),(335895,9331,'nl','Dynamische bestelpagina',0),(335896,9331,'fi','Dynaaminen tilaussivulle',0),(335897,9331,'no','Dynamisk bestillingssiden',0),(335898,9331,'da','Dynamisk bestillingssiden',0),(335899,9331,'ko','ë™ì  ì£¼ë¬¸ íŽ˜ì´ì§€',0),(335900,9331,'he','×“×£ ×“×™× ×ž×™',0),(335901,9331,'el','Î”Ï…Î½Î±Î¼Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î±',0),(335902,9331,'zh','åŠ¨æ€è®¢è´­é¡µé¢\r\n',0),(335903,9331,'sv','Dynamiska bestÃ¤llningssida',0),(335904,9331,'it','Pagina di ordine dinamico',0),(335905,9331,'tl','',0),(335906,9331,'th','&#3627;&#3609;&#3657;&#3634;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3629;&#3618;&#3641;&#3656;&#3609;&#3636;&#3656;&#3591;',0),(335907,9331,'hi','à¤—à¤¤à¤¿à¤¶à¥€à¤² à¤†à¤¦à¥‡à¤¶ à¤ªà¥ƒà¤·à¥à¤ ',0),(335908,9331,'ms','Laman pesanan dinamik',0),(335909,9331,'ar','Ø§Ù„ØµÙØ­Ø© Ø£Ù…Ø± Ø­ÙŠÙˆÙŠ',0),(335910,9331,'fr','Page de commande dynamique',0),(335911,9331,'jp','å‹•çš„æ³¨æ–‡ãƒšãƒ¼ã‚¸',0),(335912,9331,'pt','PÃ¡gina de pedido dinÃ¢mico',0),(335913,9331,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð´Ð¸Ð½Ð°Ð¼Ð¸Ñ‡ÐµÑÐºÐ¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(335914,9331,'es','PÃ¡gina DinÃ¡mica del Orden',0),(335915,9331,'de','Dynamische Bestellseite',0),(335916,9331,'en','Dynamic Order Page',0),(335917,9332,'is','',0),(335918,9332,'dr','Ø§ØµÙ„Ø§Ø­ Ù‡Ø²ÙŠÙ†Ù‡ Ú©Ù„',0),(335919,9332,'pr','Ø§ØµÙ„Ø§Ø­ Ù‡Ø²ÙŠÙ†Ù‡ Ú©Ù„',0),(335920,9332,'tr','Toplam maliyet ayarlama',0),(335921,9332,'pl','CaÅ‚kowite Rozliczenie kosztÃ³w',0),(335922,9332,'bg','ÐžÐ±Ñ‰Ð° Ñ†ÐµÐ½Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ',0),(335923,9332,'ur','Ú©Ù„ Ù„Ø§Ú¯Øª Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(335924,9332,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(335925,9332,'vi','Tá»•ng cá»™ng giÃ¡ thÃ nh chá»‰nh sá»­a',0),(335926,9332,'af','Totale koste aanpassing',0),(335927,9332,'ro','Ajustare Cost total',0),(335928,9332,'et','Kulude korrigeerimine kokku',0),(335929,9332,'si','Skupni ceno popravek',0),(335930,9332,'ba','Total biaya penyesuaian',0),(335931,9332,'nl','Totale kosten aanpassing',0),(335932,9332,'fi','Hinnan muutos yhteensÃ¤',0),(335933,9332,'no','Korrigering av totale kostnader',0),(335934,9332,'da','Samlede omkostninger justering',0),(335935,9332,'ko','ì´ ë¹„ìš©ëœ ì¡°ì •',0),(335936,9332,'he','×”×ª××ž×ª ×¢×œ×•×ª ×¡×”',0),(335937,9332,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚',0),(335938,9332,'zh','æ€»æˆæœ¬è°ƒæ•´\r\n',0),(335939,9332,'sv','Total kostnad justering',0),(335940,9332,'it','Rettifica dei costi totale',0),(335941,9332,'tl','',0),(335942,9332,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(335943,9332,'hi','à¤•à¥à¤² à¤²à¤¾à¤—à¤¤ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(335944,9332,'ms','Jumlah pelarasan kos',0),(335945,9332,'ar','Ù…Ø¬Ù…ÙˆØ¹ ØªÙƒÙ„ÙØ© Ø§Ù„ØªØ³ÙˆÙŠØ©',0),(335946,9332,'fr','Ajustement de coÃ»t total',0),(335947,9332,'jp','å·®é¡åˆè¨ˆ',0),(335948,9332,'pt','Ajuste de custo total',0),(335949,9332,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(335950,9332,'es','Ajuste de Costo Total',0),(335951,9332,'de','Total Kosten Anpassung',0),(335952,9332,'en','Total Cost Adjustment',0),(335953,9333,'is','',0),(335954,9333,'dr','1 ØªØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡   2  Ø±Ø§ ÙƒÙ¾ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(335955,9333,'pr','ØªÙ…Ø§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ 1 ØªØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡   2  Ø±Ø§ ÙƒÙ¾ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(335956,9333,'tr','TÃœM madde-TedarikÃ§i bilgileri bir satÄ±cÄ±dan satÄ±cÄ±ya iki kopyalayÄ±n.',0),(335957,9333,'pl','Skopiuj wszystkie Dostawca zapasu informacji od dostawcy, jeden do dostawcy, dwa',0),(335958,9333,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ‚Ðµ Ñ†ÑÐ»Ð°Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð¾Ñ‚ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, ÐµÐ´Ð¸Ð½ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, Ð´Ð²Ðµ',0),(335959,9333,'ur','Ø³Ø¨ Ø´Û’-ÙØ±ÙˆØ´Ù†Ø¯Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Û Ø³Û’ Ø¯Ùˆ ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ Ø¬Ø§Ù†Ø¨ Ø³Û’ Ø§ÛŒÚ© Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(335960,9333,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ‚Ðµ ÑÐ²Ðµ Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾Ð´ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ñ˜ÐµÐ´Ð½Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° 2',0),(335961,9333,'vi','Sao chÃ©p toÃ n bá»™ thÃ´ng tin danh sÃ¡ch ngÆ°á»i bÃ¡n hÃ ng tá»« NgÆ°á»i bÃ¡n 1 sang ngÆ°á»i bÃ¡n 2',0),(335962,9333,'af','Kopieer ALLE Item-Verskaffer Inligting vanaf Verskaffer EEN tot Verskaffer TWEE',0),(335963,9333,'ro','Copia toate informaÅ£iile de furnizor articol la furnizor una furnizor douÄƒ',0),(335964,9333,'et','KÃµik kauba hankija teabe kopeerimise vÃ¤ljalt Hankija, Ã¼ks hankija, kaks',0),(335965,9333,'si','Ulitek vsi podatki o dobavitelju artikla dobavitelja, eden dobavitelju, dva',0),(335966,9333,'ba','Menyalin semua Item-Vendor informasi dari Vendor salah satu vendor dua',0),(335967,9333,'nl','ALLE Artikelleverancier informatie kopiÃ«ren van leverancier een aan leverancier twee',0),(335968,9333,'fi','Kopioi kaikki Nimikkeen toimittaja tiedot toimittajan, yksi toimittaja, kaksi',0),(335969,9333,'no','Kopier alle VareleverandÃ¸r informasjon fra leverandÃ¸ren en leverandÃ¸ren to',0),(335970,9333,'da','Kopiere alle vare-leverandÃ¸r oplysninger fra kreditor, en kreditor, to',0),(335971,9333,'ko','ë‘ ê³µê¸‰ ì—…ì²´ë¥¼ ê³µê¸‰ ì—…ì²´ ì¤‘ í•˜ë‚˜ì—ì„œ ëª¨ë“  í•­ëª©-ì—…ì²´ ì •ë³´ ë³µì‚¬',0),(335972,9333,'he','×œ×”×¢×ª×™×§ ×›×œ ×¤×¨×™×˜-×¡×¤×§ ×”×ž×™×“×¢ ×ž×™×¦×¨×Ÿ ××—×“ ×œ×¡×¤×§ ×©× ×™',0),(335973,9333,'el','Î‘Î½Ï„Î¹Î³ÏÎ±Ï†Î® ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ Î Î»Î·ÏÎ¿Ï† ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿-Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Ï€ÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î•ÎÎŒÎ£ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´ÏÎ¿',0),(335974,9333,'zh','å¤åˆ¶æ‰€æœ‰é¡¹ç›®ï¼Œä¾›åº”å•†ä¿¡æ¯ä¾›åº”å•†ä»Žä¾›åº”å•†ä¹‹ä¸€åˆ°äºŒ\r\n',0),(335975,9333,'sv','Kopiera alla objekt-leverantÃ¶r Information frÃ¥n leverantÃ¶ren en till leverantÃ¶ren tvÃ¥',0),(335976,9333,'it','Copiare tutte le informazioni sull\'elemento-fornitore da fornitore uno fornitore due',0),(335977,9333,'tl','',0),(335978,9333,'th','&#3588;&#3633;&#3621;&#3621;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3592;&#3634;&#3585; &#3612;&#3641;&#',0),(335979,9333,'hi','à¤¸à¤­à¥€ à¤†à¤‡à¤Ÿà¤®-à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¥‹ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥‡ à¤à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥‡ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(335980,9333,'ms','Menyalin semua maklumat penjual barang daripada penjual salah satu penjual dua',0),(335981,9333,'ar','Ù†Ø³Ø® ÙƒØ§ÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¨Ù†Ø¯-Ø§Ù„Ù…ÙˆØ±Ø¯ Ù…Ù† Ù…ÙˆØ±Ø¯ ÙˆØ§Ø­Ø¯ Ù„Ù„Ø¨Ø§Ø¦Ø¹ Ø§Ø«Ù†Ø§Ù†',0),(335982,9333,'fr','Copier toutes les informations de lâ€™article-fournisseur du vendeur un vendeur deux',0),(335983,9333,'jp','1 ã¤ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã‹ã‚‰ 2 ã¤ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã«ã‚¢ã‚¤ãƒ†ãƒ  ãƒ™ãƒ³ãƒ€ãƒ¼ã®ã™ã¹ã¦ã®æƒ…å ±ã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(335984,9333,'pt','Copie todas as informaÃ§Ãµes do Item-fornecedor do fornecedor um ao fornecedor de dois',0),(335985,9333,'ru','Ð¡ÐºÐ¾Ð¿Ð¸Ñ€ÑƒÐ¹Ñ‚Ðµ Ð²ÑÐµ Ð´Ð°Ð½Ð½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¾Ñ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¾Ð´Ð½Ð¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°, 2',0),(335986,9333,'es','Copia TODA la InformaciÃ³n de Item-Proveedor del Proveedor UNO al Proveedor DOS',0),(335987,9333,'de','Kopieren Sie alle Element-Herstellerinformationen vom Hersteller eine VerkÃ¤ufer zwei',0),(335988,9333,'en','Copy ALL Item-Vendor Information from Vendor ONE to Vendor TWO',0),(335989,9334,'is','',0),(335990,9334,'dr','ÙƒÙ¾ÙŠ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(335991,9334,'pr','ÙƒÙ¾ÙŠ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(335992,9334,'tr','Veri kopyalama',0),(335993,9334,'pl','Kopiowanie danych',0),(335994,9334,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸',0),(335995,9334,'ur','Ú©ÙˆØ§Ø¦Ù Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(335996,9334,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(335997,9334,'vi','Dá»¯ liá»‡u sao chÃ©p',0),(335998,9334,'af','KopiÃ«er Data',0),(335999,9334,'ro','Copia datele',0),(336000,9334,'et','Andmete kopeerimine',0),(336001,9334,'si','Kopiraj podatke',0),(336002,9334,'ba','Menyalin Data',0),(336003,9334,'nl','Gegevens kopiÃ«ren',0),(336004,9334,'fi','Tietojen kopiointi',0),(336005,9334,'no','Kopiere Data',0),(336006,9334,'da','Kopiere Data',0),(336007,9334,'ko','ë°ì´í„° ë³µì‚¬',0),(336008,9334,'he','×”×¢×ª×§×ª × ×ª×•× ×™×',0),(336009,9334,'el','Î‘Î½Ï„Î¹Î³ÏÎ±Ï†Î® Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(336010,9334,'zh','å¤åˆ¶æ•°æ®\r\n',0),(336011,9334,'sv','Kopiera Data',0),(336012,9334,'it','Copiare i dati',0),(336013,9334,'tl','',0),(336014,9334,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(336015,9334,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(336016,9334,'ms','Menyalin Data',0),(336017,9334,'ar','Ù†Ø³Ø® Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(336018,9334,'fr','Copier des donnÃ©es',0),(336019,9334,'jp','ãƒ‡ãƒ¼ã‚¿ã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(336020,9334,'pt','Copiar dados',0),(336021,9334,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ðµ',0),(336022,9334,'es','Copia Datos',0),(336023,9334,'de','Kopieren von Daten',0),(336024,9334,'en','Copy Data',0),(336025,9335,'is','',0),(336026,9335,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙŠÙƒ ÙƒØ§Ù„Ø§',0),(336027,9335,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙŠÙƒ ÙƒØ§Ù„Ø§',0),(336028,9335,'tr','GÃ¼ncelleÅŸtirme tek madde-TedarikÃ§i',0),(336029,9335,'pl','Aktualizacja jednego elementu dostawcy',0),(336030,9335,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½ÑÑ‚Ð²ÐµÐ½ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(336031,9335,'ur','ÙˆØ§Ø­Ø¯ Ø´Û’ ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(336032,9335,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ñ˜ÐµÐ´Ð°Ð½ Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(336033,9335,'vi','Cáº­p Nháº­t NgÆ°á»i BÃ¡n 1 Máº·t HÃ ng',0),(336034,9335,'af','Opdateer \'n Enkel Item-Verskaffer',0),(336035,9335,'ro','Update singur element-furnizor',0),(336036,9335,'et','Update Ã¼he kauba mÃ¼Ã¼ja',0),(336037,9335,'si','Posodobitev posamezen dobavitelj artikla',0),(336038,9335,'ba','Memperbarui satu Item-Vendor',0),(336039,9335,'nl','Bijwerken van Ã©Ã©n Item-leverancier',0),(336040,9335,'fi','PÃ¤ivittÃ¤Ã¤ yhden nimiketoimittaja',0),(336041,9335,'no','Oppdater vare-leverandÃ¸rer',0),(336042,9335,'da','Opdatere enkelt element-leverandÃ¸r',0),(336043,9335,'ko','ì—…ë°ì´íŠ¸ í•­ëª© ë‹¨ì¼-ê³µê¸‰ ì—…ì²´',0),(336044,9335,'he','×¢×“×›×Ÿ ×¤×¨×™×˜ ×™×—×™×“-×¡×¤×§',0),(336045,9335,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…-Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(336046,9335,'zh','æ›´æ–°å•ä¸ªé¡¹ç›®ä¾›åº”å•†\r\n',0),(336047,9335,'sv','Uppdatera enda objekt-leverantÃ¶r',0),(336048,9335,'it','Aggiornamento singolo elemento-fornitore',0),(336049,9335,'tl','',0),(336050,9335,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3648;&#3604;&#3637;&#3618;&#3623;',0),(336051,9335,'hi','à¤à¤•à¤² à¤†à¤‡à¤Ÿà¤®-à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(336052,9335,'ms','Kemaskini Terakhir Item-pembekal tunggal',0),(336053,9335,'ar','ØªØ­Ø¯ÙŠØ« Ù…ÙˆØ±Ù‘Ø¯ ØµÙ†Ù',0),(336054,9335,'fr','Mise Ã  jour unique article-fournisseur',0),(336055,9335,'jp','å˜ä¸€ã‚¢ã‚¤ãƒ†ãƒ  ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(336056,9335,'pt','Atualizar Item Ãºnico-fornecedor',0),(336057,9335,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð´Ð½Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(336058,9335,'es','Actualiza Item-Proveedor Singular',0),(336059,9335,'de','Einzelanbieter Element aktualisieren',0),(336060,9335,'en','Update Single Item-Vendor',0),(336061,9336,'is','',0),(336062,9336,'dr','1',0),(336063,9336,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡  ÙŠÙƒ  1',0),(336064,9336,'tr','SatÄ±cÄ± bir',0),(336065,9336,'pl','Dostawcy, jeden',0),(336066,9336,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, ÐµÐ´Ð¸Ð½',0),(336067,9336,'ur','Ø§ÛŒÚ© ÙØ±ÙˆØ´Ù†Ø¯Û',0),(336068,9336,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ñ˜ÐµÐ´Ð°Ð½',0),(336069,9336,'vi','NgÆ°á»i bÃ¡n Má»™t',0),(336070,9336,'af','Verskaffer EEN',0),(336071,9336,'ro','Furnizor de unul',0),(336072,9336,'et','Tarnija ÃœKS',0),(336073,9336,'si','Dobavitelja, eden',0),(336074,9336,'ba','Penjual satu',0),(336075,9336,'nl','Leverancier een',0),(336076,9336,'fi','Toimittaja, yksi',0),(336077,9336,'no','LeverandÃ¸ren en',0),(336078,9336,'da','Kreditor, en',0),(336079,9336,'ko','í•˜ë‚˜ëŠ” ê³µê¸‰ ì—…ì²´',0),(336080,9336,'he','×¡×¤×§ ××—×“',0),(336081,9336,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î¼Î¯Î±',0),(336082,9336,'zh','ä¾›åº”å•†ä¸€\r\n',0),(336083,9336,'sv','LeverantÃ¶ren en',0),(336084,9336,'it','Fornitore di uno',0),(336085,9336,'tl','',0),(336086,9336,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3588;&#3609;&#3607;&#3637;&#3656;&#3627;&#3609;&#3638;&#3656;&#3591;',0),(336087,9336,'hi','à¤à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(336088,9336,'ms','Penjual salah satu',0),(336089,9336,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø§Ù„Ø£ÙˆÙ„',0),(336090,9336,'fr','Nom du vendeur un',0),(336091,9336,'jp','1 ã¤ã®ãƒ™ãƒ³ãƒ€ãƒ¼',0),(336092,9336,'pt','Fornecedor de um',0),(336093,9336,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº ÐžÐ”Ð˜Ð',0),(336094,9336,'es','Proveedor UNO',0),(336095,9336,'de','Anbieter einer',0),(336096,9336,'en','Vendor ONE',0),(336097,9337,'is','',0),(336098,9337,'dr','2',0),(336099,9337,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡  Ø¯Ùˆ 2',0),(336100,9337,'tr','SatÄ±cÄ± iki',0),(336101,9337,'pl','Dostawcy dwa',0),(336102,9337,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð´Ð²Ðµ',0),(336103,9337,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¯Ùˆ',0),(336104,9337,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° 2',0),(336105,9337,'vi','NgÆ°á»i bÃ¡n Hai',0),(336106,9337,'af','Verskaffer TWEE',0),(336107,9337,'ro','Furnizor de douÄƒ',0),(336108,9337,'et','Hankija kaks',0),(336109,9337,'si','Prodajalec dva',0),(336110,9337,'ba','Penjual dua',0),(336111,9337,'nl','Leverancier twee',0),(336112,9337,'fi','Toimittajan kaksi',0),(336113,9337,'no','LeverandÃ¸ren to',0),(336114,9337,'da','Kreditor to',0),(336115,9337,'ko','ê³µê¸‰ ì—…ì²´ 2',0),(336116,9337,'he','×¡×¤×§ ×©× ×™',0),(336117,9337,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´ÏÎ¿',0),(336118,9337,'zh','ä¾›åº”å•†äºŒ\r\n',0),(336119,9337,'sv','LeverantÃ¶r tvÃ¥',0),(336120,9337,'it','Vendor due',0),(336121,9337,'tl','',0),(336122,9337,'th','&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3626;&#3629;&#3591;',0),(336123,9337,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¦à¥‹',0),(336124,9337,'ms','Penjual dua',0),(336125,9337,'ar','Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(336126,9337,'fr','Vendeur deux',0),(336127,9337,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ 2',0),(336128,9337,'pt','Vendedor de dois',0),(336129,9337,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð”Ð’Ð',0),(336130,9337,'es','Proveedor DOS',0),(336131,9337,'de','ZWEI Anbieter',0),(336132,9337,'en','Vendor TWO',0),(336133,9338,'is','',0),(336134,9338,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø±Ø² Ø¬Ø¯ÙŠØ¯ ',0),(336135,9338,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø±Ø² Ø¬Ø¯ÙŠØ¯ ',0),(336136,9338,'tr','Yeni para birimi ekleme',0),(336137,9338,'pl','Dodawanie nowej waluty',0),(336138,9338,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(336139,9338,'ur','Ù†Ø¦ÛŒ Ú©Ø±Ù†Ø³ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(336140,9338,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ðµ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(336141,9338,'vi','ThÃªm Tiá»n Tá»‡ Má»›i',0),(336142,9338,'af','Nuwe Geldeenheid Byvoeg',0),(336143,9338,'ro','Adauga valuta noua',0),(336144,9338,'et','Lisa uus valuuta',0),(336145,9338,'si','Dodajanje nove valute',0),(336146,9338,'ba','Menambahkan mata uang baru',0),(336147,9338,'nl','Toevoegen van de nieuwe munt',0),(336148,9338,'fi','LisÃ¤Ã¤ uusi valuutta',0),(336149,9338,'no','Legge til ny valuta',0),(336150,9338,'da','TilfÃ¸j ny valuta',0),(336151,9338,'ko','ìƒˆ í†µí™” ì¶”ê°€',0),(336152,9338,'he','×”×•×¡×£ ×ž×˜×‘×¢ ×—×“×©',0),(336153,9338,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(336154,9338,'zh','å¢žåŠ æ–°çš„è´§å¸\r\n',0),(336155,9338,'sv','LÃ¤gg till ny valuta',0),(336156,9338,'it','Aggiungi nuova valuta',0),(336157,9338,'tl','',0),(336158,9338,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(336159,9338,'hi','à¤¨à¤ˆ à¤®à¥à¤¦à¥à¤°à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(336160,9338,'ms','Tambah Mata Wang baru',0),(336161,9338,'ar','Ø£Ø¶Ù Ø¹Ù…Ù„Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(336162,9338,'fr','Ajouter la nouvelle monnaie',0),(336163,9338,'jp','æ–°ã—ã„é€šè²¨ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(336164,9338,'pt','Adicionar nova moeda',0),(336165,9338,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ¾Ð²ÑƒÑŽ Ð’Ð°Ð»ÑŽÑ‚Ñƒ',0),(336166,9338,'es','Agregar Nueva Divisa',0),(336167,9338,'de','Neue WÃ¤hrung hinzufÃ¼gen',0),(336168,9338,'en','Add New Currency',0),(336169,9339,'is','',0),(336170,9339,'dr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø§Ø±Ø²  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(336171,9339,'pr','Ø¢ÙŠØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÙŠØ¯ ÙƒÙ‡ Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ Ø§ÙŠÙ† Ø§Ø±Ø²  Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ØŸ',0),(336172,9339,'tr','Bu para birimi silmek istediÄŸinizden emin misiniz?',0),(336173,9339,'pl','Czy na pewno chcesz usunÄ…Ä‡ tÄ™ walutÄ™?',0),(336174,9339,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð²Ð°Ð»ÑƒÑ‚Ð°?',0),(336175,9339,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ÛŒÛ Ú©Ø±Ù†Ø³ÛŒ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(336176,9339,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð±Ñ€Ð¸ÑˆÐµÑ‚Ðµ Ð¾Ð²Ñƒ Ð²Ð°Ð»ÑƒÑ‚Ñƒ?',0),(336177,9339,'vi','XÃ³a loáº¡i tiá»n tá»‡ nÃ y?',0),(336178,9339,'af','Is u seker u wil hierdie geldeenheid skrap?',0),(336179,9339,'ro','Sigur È™tergeÈ›i aceastÄƒ monedÄƒ?',0),(336180,9339,'et','Oled kindel, et soovid selle valuuta kustutada?',0),(336181,9339,'si','Ali ste prepriÄani, da Å¾elite izbrisati to valuto?',0),(336182,9339,'ba','Apakah Anda yakin Anda ingin menghapus mata uang ini?',0),(336183,9339,'nl','Weet u zeker dat u wilt verwijderen van deze munt?',0),(336184,9339,'fi','Oletko varma, ettÃ¤ haluat poistaa tÃ¤mÃ¤n valuutan?',0),(336185,9339,'no','Er du sikker pÃ¥ at du vil slette denne valutaen?',0),(336186,9339,'da','Er du sikker pÃ¥ du vil slette denne valuta?',0),(336187,9339,'ko','ë‹¹ì‹ ì€ì´ í†µí™”ë¥¼ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(336188,9339,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ××ª ×”×ž×˜×‘×¢ ×”×–×”?',0),(336189,9339,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±;',0),(336190,9339,'zh','ä½ ç¡®å®šè¦åˆ é™¤æ­¤è´§å¸ï¼Ÿ\r\n',0),(336191,9339,'sv','Ã„r du sÃ¤ker du vill ta bort denna valuta?',0),(336192,9339,'it','Sei sicuro di che voler eliminare questa valuta?',0),(336193,9339,'tl','',0),(336194,9339,'th','&#3588;&#3640;&#3603;&#3649;&#3609;&#3656;&#3651;&#3592;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;&#3623;&#3656;&#3634;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3621;&#3610;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;&#3609;&#3',0),(336195,9339,'hi','à¤•à¥à¤¯à¤¾ à¤µà¤¾à¤•à¤ˆ à¤†à¤ª à¤‡à¤¸ à¤®à¥à¤¦à¥à¤°à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(336196,9339,'ms','Adakah anda pasti anda mahu menghapus Mata Wang ini?',0),(336197,9339,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¥Ù„ØºØ§Ø¡ Ù‡Ø°Ù‡ Ø§Ù„Ø¹Ù…Ù„Ø© ØŸ',0),(336198,9339,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer cette monnaieÂ ?',0),(336199,9339,'jp','ã“ã®é€šè²¨ã‚’å‰Šé™¤ã™ã‚‹ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(336200,9339,'pt','Tem certeza que deseja excluir esta moeda?',0),(336201,9339,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹ Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ Ð²Ð°Ð»ÑŽÑ‚Ñƒ?',0),(336202,9339,'es','Â¿Esta seguro que quiere eliminar esta divisa?',0),(336203,9339,'de','Sind Sie sicher, dass Sie diese WÃ¤hrung lÃ¶schen mÃ¶chten?',0),(336204,9339,'en','Are you sure you want to delete this currency?',0),(336205,9340,'is','',0),(336206,9340,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø±Ø² Ù†ÙŠØ³Øª',0),(336207,9340,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø±Ø² Ù†ÙŠØ³Øª',0),(336208,9340,'tr','Para birimi eklenemiyor',0),(336209,9340,'pl','Nie moÅ¼na dodaÄ‡ waluty',0),(336210,9340,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(336211,9340,'ur','Ú©Ø±Ù†Ø³ÛŒ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(336212,9340,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(336213,9340,'vi','KhÃ´ng thá»ƒ thÃªm tiá»n tá»‡',0),(336214,9340,'af','Nie Instaat om Geldeeheid By te Voeg',0),(336215,9340,'ro','Nu puteÅ£i adÄƒuga valuta',0),(336216,9340,'et','Ei sa valuutat lisada',0),(336217,9340,'si','Ni mogoÄe dodati valute',0),(336218,9340,'ba','Tidak dapat menambahkan mata uang',0),(336219,9340,'nl','Geen toevoegen valuta',0),(336220,9340,'fi','Ei voi lisÃ¤tÃ¤ valuutta',0),(336221,9340,'no','Kan ikke legge til valuta',0),(336222,9340,'da','Kan ikke tilfÃ¸je valuta',0),(336223,9340,'ko','í†µí™”ë¥¼ ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(336224,9340,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×•×¡×™×£ ×ž×˜×‘×¢',0),(336225,9340,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„ÏŒ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(336226,9340,'zh','æ— æ³•æ–°å¢žè´§å¸\r\n',0),(336227,9340,'sv','Kan inte lÃ¤gga till valuta',0),(336228,9340,'it','Non Ã¨ possibile aggiungere valuta',0),(336229,9340,'tl','',0),(336230,9340,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;&#3652;&#3604;&#3657;',0),(336231,9340,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(336232,9340,'ms','Tidak dapat menambah Mata Wang',0),(336233,9340,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¹Ù…Ù„Ø©',0),(336234,9340,'fr','Impossible dâ€™ajouter la monnaie',0),(336235,9340,'jp','é€šè²¨ã‚’è¿½åŠ ã§ãã¾ã›ã‚“ã€‚',0),(336236,9340,'pt','NÃ£o Ã© possÃ­vel adicionar moeda',0),(336237,9340,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð’Ð°Ð»ÑŽÑ‚Ñƒ',0),(336238,9340,'es','No se Puede Agregar Divisa',0),(336239,9340,'de','WÃ¤hrung kann nicht hinzugefÃ¼gt werden.',0),(336240,9340,'en','Cannot Add Currency',0),(336241,9341,'is','',0),(336242,9341,'dr','Ø§Ø±Ø²',0),(336243,9341,'pr','Ø§Ø±Ø²',0),(336244,9341,'tr','Para birimi',0),(336245,9341,'pl','Waluta',0),(336246,9341,'bg','Ð’Ð°Ð»ÑƒÑ‚Ð°',0),(336247,9341,'ur','Ú©Ø±Ù†Ø³ÛŒ',0),(336248,9341,'sr','Ð’Ð°Ð»ÑƒÑ‚Ð°',0),(336249,9341,'vi','Tiá»n tá»‡',0),(336250,9341,'af','Geldeenheid',0),(336251,9341,'ro','Moneda',0),(336252,9341,'et','Valuuta',0),(336253,9341,'si','Valute',0),(336254,9341,'ba','Mata uang',0),(336255,9341,'nl','Valuta',0),(336256,9341,'fi','Valuutta',0),(336257,9341,'no','Valuta',0),(336258,9341,'da','Valuta',0),(336259,9341,'ko','í†µí™”',0),(336260,9341,'he','×ž×˜×‘×¢',0),(336261,9341,'el','ÎÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(336262,9341,'zh','è´§å¸\r\n',0),(336263,9341,'sv','Valuta',0),(336264,9341,'it','Valuta',0),(336265,9341,'tl','',0),(336266,9341,'th','&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(336267,9341,'hi','à¤®à¥à¤¦à¥à¤°à¤¾',0),(336268,9341,'ms','Mata Wang',0),(336269,9341,'ar','Ø§Ù„Ø¹Ù…Ù„Ø©',0),(336270,9341,'fr','Devise',0),(336271,9341,'jp','é€šè²¨',0),(336272,9341,'pt','Moeda',0),(336273,9341,'ru','Ð’Ð°Ð»ÑŽÑ‚Ð°',0),(336274,9341,'es','Divisa',0),(336275,9341,'de','WÃ¤hrung',0),(336276,9341,'en','Currency',0),(336277,9342,'is','',0),(336278,9342,'dr','Ø§Ø±Ø² Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(336279,9342,'pr','Ø§Ø±Ø² Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(336280,9342,'tr','Para birimi baÅŸarÄ±yla eklendi',0),(336281,9342,'pl','Waluty dodany pomyÅ›lnie',0),(336282,9342,'bg','Ð’Ð°Ð»ÑƒÑ‚Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(336283,9342,'ur','Ú©Ø±Ù†Ø³ÛŒ Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(336284,9342,'sr','Ð’Ð°Ð»ÑƒÑ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(336285,9342,'vi','ThÃªm Tiá»n tá»‡ thÃ nh cÃ´ng',0),(336286,9342,'af','Geldeenheid Suksesvol Bygevoeg',0),(336287,9342,'ro','Moneda adÄƒugat cu succes',0),(336288,9342,'et','Valuuta lisati edukalt',0),(336289,9342,'si','Valute, ki so dodani',0),(336290,9342,'ba','Mata uang yang ditambahkan berhasil',0),(336291,9342,'nl','Valuta toegevoegd',0),(336292,9342,'fi','Valuutan lisÃ¤Ã¤minen onnistui',0),(336293,9342,'no','Valuta lagt',0),(336294,9342,'da','Valuta tilfÃ¸jet',0),(336295,9342,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” í†µí™”',0),(336296,9342,'he','×ž×˜×‘×¢ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(336297,9342,'el','Î ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(336298,9342,'zh','è´§å¸æ·»åŠ æˆåŠŸ\r\n',0),(336299,9342,'sv','Valuta som lagts',0),(336300,9342,'it','Valuta aggiunto con successo',0),(336301,9342,'tl','',0),(336302,9342,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(336303,9342,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(336304,9342,'ms','Mata Wang yang berjaya menambah',0),(336305,9342,'ar','Ø£Ø¶ÙŠÙØª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¨Ù†Ø¬Ø§Ø­',0),(336306,9342,'fr','Devise ajoutÃ©e avec succÃ¨s',0),(336307,9342,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸé€šè²¨',0),(336308,9342,'pt','Moeda adicionada com sucesso',0),(336309,9342,'ru','Ð’Ð°Ð»ÑŽÑ‚Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(336310,9342,'es','Divisa Agregada Exitosamente',0),(336311,9342,'de','WÃ¤hrung erfolgreich hinzugefÃ¼gt',0),(336312,9342,'en','Currency Added Successfully',0),(336313,9343,'is','',0),(336314,9343,'dr','/ Ø¢Ù¾Ø¯ÛŒØª  Ø§Ø±Ø²',0),(336315,9343,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø§Ø±Ø²',0),(336316,9343,'tr','Para birimi Ekle/GÃ¼ncelle',0),(336317,9343,'pl','Waluty Dodaj/Aktualizuj',0),(336318,9343,'bg','Ð’Ð°Ð»ÑƒÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(336319,9343,'ur','Ú©Ø±Ù†Ø³ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(336320,9343,'sr','Ð’Ð°Ð»ÑƒÑ‚Ð°/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(336321,9343,'vi','ThÃªm/Cáº­p Nháº­t tiá»n tá»‡',0),(336322,9343,'af','Geldeenheid Byvoeg/Opdateer',0),(336323,9343,'ro','Moneda AdÄƒugaÅ£i/actualizaÅ£i',0),(336324,9343,'et','Lisa/Uuenda valuuta',0),(336325,9343,'si','Valuta Dodaj/posodobi',0),(336326,9343,'ba','Mata uang Tambahkan/Perbarui',0),(336327,9343,'nl','Valuta toevoegen/bijwerken',0),(336328,9343,'fi','Valuutan lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(336329,9343,'no','Valuta/Oppdater',0),(336330,9343,'da','Valuta TilfÃ¸j/opdater',0),(336331,9343,'ko','í†µí™” ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(336332,9343,'he','×ž×˜×‘×¢ ×”×•×¡×£/×¢×“×›×Ÿ',0),(336333,9343,'el','ÎÏŒÎ¼Î¹ÏƒÎ¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(336334,9343,'zh','è´§å¸æ–°å¢ž/æ›´æ–°\r\n',0),(336335,9343,'sv','LÃ¤gg till valuta/uppdatera',0),(336336,9343,'it','Valuta aggiungere/aggiornare',0),(336337,9343,'tl','',0),(336338,9343,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(336339,9343,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(336340,9343,'ms','Mata Wang Tambah/Kemaskini',0),(336341,9343,'ar','Ø§Ù„Ø¹Ù…Ù„Ø© Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(336342,9343,'fr','Monnaie ajouter/mettre Ã  jour',0),(336343,9343,'jp','é€šè²¨ã®è¿½åŠ /æ›´æ–°',0),(336344,9343,'pt','Adicionar/atualizar de moeda',0),(336345,9343,'ru','Ð’Ð°Ð»ÑŽÑ‚Ð° Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(336346,9343,'es','Divisa Agregar/Actualizar',0),(336347,9343,'de','WÃ¤hrung hinzufÃ¼gen/aktualisieren',0),(336348,9343,'en','Currency Add/Update',0),(336349,9344,'is','',0),(336350,9344,'dr','ÙƒØ¯ Ø§Ø±Ø² Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±  Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(336351,9344,'pr','ÙƒØ¯ Ø§Ø±Ø² Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±  Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯',0),(336352,9344,'tr','Para birimi kodu zaten kullanÄ±lÄ±yor',0),(336353,9344,'pl','Kod waluty jest juÅ¼ w uÅ¼yciu',0),(336354,9344,'bg','ÐšÐ¾Ð´ Ð²Ð°Ð»ÑƒÑ‚Ð° Ðµ Ð²ÐµÑ‡Ðµ Ð² ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(336355,9344,'ur','Ú©Ø±Ù†Ø³ÛŒ Ú©ÙˆÚˆ Ù¾ÛÙ„Û’ ÛÛŒ Ø²ÛŒØ± Ø§Ø³ØªØ¹Ù…Ø§Ù„ ÛÛ’ Û”',0),(336356,9344,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð²Ð°Ð»ÑƒÑ‚Ðµ Ñ˜Ðµ Ð²ÐµÑ› Ñƒ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸',0),(336357,9344,'vi','MÃ£ Tiá»n tá»‡ Ä‘ang sá»­ dá»¥ng',0),(336358,9344,'af','Geldeenheidkode Is Alreeds In Gebruik',0),(336359,9344,'ro','Cod valutÄƒ este deja Ã®n uz',0),(336360,9344,'et','ValuutatÃ¤his on juba kasutusel',0),(336361,9344,'si','Å ifra valute je Å¾e v uporabi',0),(336362,9344,'ba','Kode mata uang ini telah digunakan',0),(336363,9344,'nl','Valutacode Is al In gebruik',0),(336364,9344,'fi','Valuuttakoodi on jo kÃ¤ytÃ¶ssÃ¤',0),(336365,9344,'no','Valutakoden er allerede i bruk',0),(336366,9344,'da','Valutakode er allerede i brug',0),(336367,9344,'ko','í†µí™” ì½”ë“œëŠ” ì´ë¯¸ ì‚¬ìš©',0),(336368,9344,'he','×§×•×“ ×ž×˜×‘×¢ ×–×” ×›×‘×¨ × ×ž×¦× ×‘×©×™×ž×•×©',0),(336369,9344,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î½Î¿Î¼Î¯ÏƒÎ¼Î±Ï„Î¿Ï‚ ÎµÎ¯Î½Î±Î¹ Î®Î´Î· ÏƒÎµ Ï‡ÏÎ®ÏƒÎ·',0),(336370,9344,'zh','è´§å¸ä»£ç å·²è¢«ä½¿ç”¨\r\n',0),(336371,9344,'sv','Valutakoden Ã¤r redan i bruk',0),(336372,9344,'it','Codice di valuta Ã¨ giÃ  In uso',0),(336373,9344,'tl','',0),(336374,9344,'th','&#3619;&#3627;&#3633;&#3626;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609; &#3614;&#3619;&#3657;&#3629;&#3617;&#3651;&#3594;&#3657;',0),(336375,9344,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤•à¥‹à¤¡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‰à¤ªà¤¯à¥‹à¤— à¤®à¥‡à¤‚ à¤¹à¥ˆ',0),(336376,9344,'ms','Kod Mata Wang sudah pun digunakan',0),(336377,9344,'ar','Ø±Ù…Ø² Ø§Ù„Ø¹Ù…Ù„Ø© Ù…Ø³Ø¨Ù‚Ø§Ù‹ Ù‚ÙŠØ¯ Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(336378,9344,'fr','Code devise est dÃ©jÃ  en cours dâ€™utilisation',0),(336379,9344,'jp','é€šè²¨ã‚³ãƒ¼ãƒ‰ã¯æ—¢ã«ä½¿ç”¨ã§ã™ã€‚',0),(336380,9344,'pt','CÃ³digo da moeda jÃ¡ estÃ¡ em uso',0),(336381,9344,'ru','ÐšÐ¾Ð´ Ð²Ð°Ð»ÑŽÑ‚Ñ‹ ÑƒÐ¶Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ',0),(336382,9344,'es','CÃ³digo de Divisa Ya Esta en Uso',0),(336383,9344,'de','WÃ¤hrungs-Code wird bereits verwendet',0),(336384,9344,'en','Currency Code Is Already In Use',0),(336385,9345,'is','',0),(336386,9345,'dr','Ø§Ø±Ø² Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(336387,9345,'pr','Ø§Ø±Ø² Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(336388,9345,'tr','Para birimi baÅŸarÄ±yla silindi',0),(336389,9345,'pl','Waluty, usuniÄ™ty',0),(336390,9345,'bg','Ð’Ð°Ð»ÑƒÑ‚Ð°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(336391,9345,'ur','Ú©Ø±Ù†Ø³ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(336392,9345,'sr','Ð’Ð°Ð»ÑƒÑ‚Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(336393,9345,'vi','XÃ³a Tiá»n tá»‡ thÃ nh cÃ´ng',0),(336394,9345,'af','Geldeenheid Suksesvol Geskrap',0),(336395,9345,'ro','Moneda eliminÄƒ cu succes',0),(336396,9345,'et','Valuuta kustutati edukalt',0),(336397,9345,'si','Valute, ki uspeÅ¡no izbrisana',0),(336398,9345,'ba','Mata uang yang dihapus berhasil',0),(336399,9345,'nl','Munt met succes verwijderd',0),(336400,9345,'fi','Valuutan poistettu',0),(336401,9345,'no','Valuta slettet',0),(336402,9345,'da','Valuta slettet',0),(336403,9345,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” í†µí™”',0),(336404,9345,'he','×ž×˜×‘×¢ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(336405,9345,'el','ÎÏŒÎ¼Î¹ÏƒÎ¼Î± Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(336406,9345,'zh','è´§å¸æˆåŠŸåˆ é™¤\r\n',0),(336407,9345,'sv','Valuta som raderades',0),(336408,9345,'it','Valuta eliminato con successo',0),(336409,9345,'tl','',0),(336410,9345,'th','&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;&#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(336411,9345,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾',0),(336412,9345,'ms','Mata Wang yang dihapuskan dengan jayanya',0),(336413,9345,'ar','Ø­Ø°ÙØª Ø§Ù„Ø¹Ù…Ù„Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(336414,9345,'fr','Monnaie, supprimÃ© avec succÃ¨s',0),(336415,9345,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸé€šè²¨',0),(336416,9345,'pt','Moeda apagada com sucesso',0),(336417,9345,'ru','Ð’Ð°Ð»ÑŽÑ‚Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½Ð°',0),(336418,9345,'es','Divisa Eliminada Exitosamente',0),(336419,9345,'de','WÃ¤hrung erfolgreich gelÃ¶scht',0),(336420,9345,'en','Currency Deleted Successfully',0),(336421,9346,'is','',0),(336422,9346,'dr','Ø§Ø±Ø² Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(336423,9346,'pr','Ø§Ø±Ø² Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(336424,9346,'tr','Para birimi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(336425,9346,'pl','Waluty pomyÅ›lnie zaktualizowana',0),(336426,9346,'bg','Ð’Ð°Ð»ÑƒÑ‚Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(336427,9346,'ur','Ú©Ø±Ù†Ø³ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(336428,9346,'sr','Ð’Ð°Ð»ÑƒÑ‚Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(336429,9346,'vi','Cáº­p nháº­t tiá»n tá»‡ thÃ nh cÃ´ng',0),(336430,9346,'af','Geldeenheid Suksesvol Opdateer',0),(336431,9346,'ro','Moneda actualizat cu succes',0),(336432,9346,'et','VÃ¤rskendatud valuuta',0),(336433,9346,'si','Valute, ki je uspeÅ¡no posodobljena',0),(336434,9346,'ba','Mata uang yang berhasil',0),(336435,9346,'nl','Munt met succes bijgewerkt',0),(336436,9346,'fi','Valuutan pÃ¤ivitetty',0),(336437,9346,'no','Valuta oppdatert',0),(336438,9346,'da','Valuta opdateret',0),(336439,9346,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” í†µí™”',0),(336440,9346,'he','×ž×˜×‘×¢ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(336441,9346,'el','ÎÏŒÎ¼Î¹ÏƒÎ¼Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(336442,9346,'zh','è´§å¸æ›´æ–°æˆåŠŸ\r\n',0),(336443,9346,'sv','Valuta som uppdaterats',0),(336444,9346,'it','Valuta aggiornato con successo',0),(336445,9346,'tl','',0),(336446,9346,'th','&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(336447,9346,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤®à¥à¤¦à¥à¤°à¤¾',0),(336448,9346,'ms','Mata Wang yang berjaya dikemas kini',0),(336449,9346,'ar','Ø­Ø¯Ù‘Ø«Øª Ø§Ù„Ø¹Ù…Ù„Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(336450,9346,'fr','Monnaie mise Ã  jour rÃ©ussie',0),(336451,9346,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸé€šè²¨',0),(336452,9346,'pt','Moeda atualizada com sucesso',0),(336453,9346,'ru','Ð’Ð°Ð»ÑŽÑ‚Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(336454,9346,'es','Divisa Actualizada Exitosamente',0),(336455,9346,'de','WÃ¤hrung, die erfolgreich aktualisiert',0),(336456,9346,'en','Currency Updated Successfully',0),(336457,9347,'is','',0),(336458,9347,'dr','Ù…Ø­Ù„ Ù‡Ø§ÙŠ Ø§Ø¹Ø´Ø§Ø± ',0),(336459,9347,'pr','Ù…Ø­Ù„ Ù‡Ø§ÙŠ Ø§Ø¹Ø´Ø§Ø± ',0),(336460,9347,'tr','OndalÄ±k basamak',0),(336461,9347,'pl','Miejsca dziesiÄ™tne',0),(336462,9347,'bg','Ð”ÐµÑÐµÑ‚Ð¸Ñ‡Ð½Ð¸',0),(336463,9347,'ur','Ø§Ø¹Ø´Ø§Ø±ÛŒ Ù…Ù‚Ø§Ù…Ø§Øª',0),(336464,9347,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð´ÐµÑ†Ð¸Ð¼Ð°Ð»Ð°',0),(336465,9347,'vi','Dáº¥u tháº­p phÃ¢n',0),(336466,9347,'af','Desimale Plekke',0),(336467,9347,'ro','Zecimale',0),(336468,9347,'et','Komakohti',0),(336469,9347,'si','Decimalnih mest',0),(336470,9347,'ba','Desimal',0),(336471,9347,'nl','Decimalen',0),(336472,9347,'fi','Desimaalin',0),(336473,9347,'no','Desimaler',0),(336474,9347,'da','Decimaler',0),(336475,9347,'ko','ì†Œìˆ˜ ìžë¦¿ìˆ˜',0),(336476,9347,'he','×ž×§×•×ž×•×ª ×¢×©×¨×•× ×™×™×',0),(336477,9347,'el','Î”ÎµÎºÎ±Î´Î¹ÎºÎ¬ ÏˆÎ·Ï†Î¯Î±',0),(336478,9347,'zh','å°æ•°ä½\r\n',0),(336479,9347,'sv','Decimaler',0),(336480,9347,'it','Posizioni decimali',0),(336481,9347,'tl','',0),(336482,9347,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3624;&#3609;&#3636;&#3618;&#3617;',0),(336483,9347,'hi','à¤¦à¤¶à¤®à¤²à¤µ à¤¸à¥à¤¥à¤¾à¤¨',0),(336484,9347,'ms','Tempat perpuluhan',0),(336485,9347,'ar','Ø§Ù„Ù…Ù†Ø§Ø²Ù„ Ø§Ù„Ø¹Ø´Ø±ÙŠØ©',0),(336486,9347,'fr','Chiffres aprÃ¨s la virgule',0),(336487,9347,'jp','å°æ•°ç‚¹ä»¥ä¸‹ã®æ¡æ•°',0),(336488,9347,'pt','Casas decimais',0),(336489,9347,'ru','Ð”ÐµÑÑÑ‚Ð¸Ñ‡Ð½Ñ‹Ñ… Ð·Ð½Ð°ÐºÐ¾Ð²',0),(336490,9347,'es','Puntos Decimales',0),(336491,9347,'de','Dezimalstellen',0),(336492,9347,'en','Decimal Places',0),(336493,9348,'is','',0),(336494,9348,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø±Ø²',0),(336495,9348,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø±Ø²',0),(336496,9348,'tr','Hata ekleme para birimi',0),(336497,9348,'pl','BÅ‚Ä…d dodawania waluty',0),(336498,9348,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(336499,9348,'ur','Ù†Ù‚Øµ Ú©Ø±Ù†Ø³ÛŒ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(336500,9348,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(336501,9348,'vi','ThÃªm tiá»n tá»‡ bá»‹ lá»—i',0),(336502,9348,'af','Fout voeg geldeenheid',0),(336503,9348,'ro','Eroare adÄƒugÃ¢nd moneda',0),(336504,9348,'et','Valuuta lisamisel tekkis viga',0),(336505,9348,'si','Napaka seÅ¡tevanje valute',0),(336506,9348,'ba','Kesalahan menambahkan mata uang',0),(336507,9348,'nl','Fout toe te voegen valuta',0),(336508,9348,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ valuutta',0),(336509,9348,'no','Feil Ã¥ legge valuta',0),(336510,9348,'da','Fejl tilfÃ¸je valuta',0),(336511,9348,'ko','ì˜¤ë¥˜ ì¶”ê°€ í†µí™”',0),(336512,9348,'he','×©×’×™××” ×”×•×¡×¤×ª ×ž×˜×‘×¢',0),(336513,9348,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(336514,9348,'zh','é”™è¯¯ï¼šæ–°å¢žè´§å¸',0),(336515,9348,'sv','Fel att lÃ¤gga till valuta',0),(336516,9348,'it','Errore aggiunta valuta',0),(336517,9348,'tl','',0),(336518,9348,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(336519,9348,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥à¤¦à¥à¤°à¤¾',0),(336520,9348,'ms','Ralat menambah Mata Wang',0),(336521,9348,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¹Ù…Ù„Ø©',0),(336522,9348,'fr','Erreur ajout de monnaie',0),(336523,9348,'jp','ã‚¨ãƒ©ãƒ¼ã‚’è¿½åŠ ã™ã‚‹é€šè²¨',0),(336524,9348,'pt','Erro adicionando moeda',0),(336525,9348,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð’Ð°Ð»ÑŽÑ‚Ñ‹',0),(336526,9348,'es','Error Agregando la Divisa',0),(336527,9348,'de','Fehler hinzufÃ¼gen WÃ¤hrung',0),(336528,9348,'en','Error Adding Currency',0),(336529,9349,'is','',0),(336530,9349,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø§Ø±Ø²',0),(336531,9349,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø§Ø±Ø²',0),(336532,9349,'tr','Hata silme para birimi',0),(336533,9349,'pl','BÅ‚Ä…d usuwania waluty',0),(336534,9349,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(336535,9349,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©Ø±Ù†Ø³ÛŒ',0),(336536,9349,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(336537,9349,'vi','Lá»—i khi xÃ³a tiá»n tá»‡',0),(336538,9349,'af','Fout skrap geldeenheid',0),(336539,9349,'ro','Eroare ÅŸtergerea moneda',0),(336540,9349,'et','Valuuta kustutamisel tekkis viga',0),(336541,9349,'si','Napaka brisanja valute',0),(336542,9349,'ba','Error menghapus mata uang',0),(336543,9349,'nl','Fout verwijderen valuta',0),(336544,9349,'fi','Virhe poistettaessa valuutta',0),(336545,9349,'no','Feil slette valuta',0),(336546,9349,'da','Fejl slette valuta',0),(336547,9349,'ko','ì˜¤ë¥˜ ì‚­ì œ í†µí™”',0),(336548,9349,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ž×˜×‘×¢',0),(336549,9349,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(336550,9349,'zh','é”™è¯¯åˆ é™¤è´§å¸\r\n',0),(336551,9349,'sv','Misstag utplÃ¥nande valuta',0),(336552,9349,'it','Valuta l\'eliminazione errore',0),(336553,9349,'tl','',0),(336554,9349,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(336555,9349,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥à¤¦à¥à¤°à¤¾',0),(336556,9349,'ms','Mata Wang menghapuskan kesilapan',0),(336557,9349,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø¹Ù…Ù„Ø©',0),(336558,9349,'fr','Erreur suppression monnaie',0),(336559,9349,'jp','ã‚¨ãƒ©ãƒ¼å‰Šé™¤ã™ã‚‹é€šè²¨',0),(336560,9349,'pt','Erro excluindo moeda',0),(336561,9349,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð’Ð°Ð»ÑŽÑ‚Ñ‹',0),(336562,9349,'es','Error Eliminado la Divisa',0),(336563,9349,'de','Fehler lÃ¶schen WÃ¤hrung',0),(336564,9349,'en','Error Deleting Currency',0),(336565,9350,'is','',0),(336566,9350,'dr','Ø®Ø·Ø§ Ø¯ Ø±Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø±Ø² ',0),(336567,9350,'pr','Ø®Ø·Ø§ Ø¯ Ø±Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø±Ø² ',0),(336568,9350,'tr','Para birimini arÄ±yorum hata',0),(336569,9350,'pl','BÅ‚Ä…d, patrzÄ…c w gÃ³rÄ™ waluta',0),(336570,9350,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(336571,9350,'ur','Ø§Ù¾ Ú©ÛŒ Ú©Ø±Ù†Ø³ÛŒ Ú©ÛŒ ØªÙ„Ø§Ø´ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(336572,9350,'sr','Ð“Ñ€ÐµÑˆÐºÐµ Ð¿Ð¾Ð¿Ñ€Ð°Ð²Ñ™Ð°Ñ˜Ñƒ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(336573,9350,'vi','Lá»—i tÃ¬m tiá»n tá»‡',0),(336574,9350,'af','Fout soek op valuta',0),(336575,9350,'ro','Eroare cÄƒutÃ¢nd moneda',0),(336576,9350,'et','TÃµrge soojaks valuuta',0),(336577,9350,'si','Napaka ozrl valute',0),(336578,9350,'ba','Kesalahan yang mencari mata uang',0),(336579,9350,'nl','Fout opzoeken van valuta',0),(336580,9350,'fi','Virhe etsii valuutta',0),(336581,9350,'no','Feilen ser opp valuta',0),(336582,9350,'da','Fejl ved opslag efter valuta',0),(336583,9350,'ko','í†µí™” ì¡°íšŒ ì˜¤ë¥˜',0),(336584,9350,'he','×©×’×™××” ×œ×—×¤×© ×ž×˜×‘×¢',0),(336585,9350,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ¿Î¹Ï„ÏŽÎ½Ï„Î±Ï‚ ÏˆÎ·Î»Î¬ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(336586,9350,'zh','é”™è¯¯æŸ¥æ‰¾è´§å¸\r\n',0),(336587,9350,'sv','Fel som tittar upp valuta',0),(336588,9350,'it','Errore durante la ricerca valuta',0),(336589,9350,'tl','',0),(336590,9350,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3627;&#3634;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(336591,9350,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤•à¥‹ à¤¦à¥‡à¤– à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(336592,9350,'ms','Ralat melihat Mata Wang',0),(336593,9350,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø¹Ù…Ù„Ø©',0),(336594,9350,'fr','Erreur en levant monnaie',0),(336595,9350,'jp','é€šè²¨ã‚’æ¤œç´¢ä¸­ã«ã‚¨ãƒ©ãƒ¼',0),(336596,9350,'pt','Erro, olhando para cima a moeda',0),(336597,9350,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾Ð¸ÑÐºÐ° Ð²Ð°Ð»ÑŽÑ‚Ñ‹',0),(336598,9350,'es','Error Buscando la Divisa',0),(336599,9350,'de','Fehler bei der Suche WÃ¤hrung',0),(336600,9350,'en','Error Looking Up Currency',0),(336601,9351,'is','',0),(336602,9351,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø±Ø²',0),(336603,9351,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø±Ø²',0),(336604,9351,'tr','Hata gÃ¼ncelleÅŸtirme para birimi',0),(336605,9351,'pl','BÅ‚Ä…d aktualizacji waluty',0),(336606,9351,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(336607,9351,'ur','Ù†Ù‚Øµ Ú©Ø±Ù†Ø³ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(336608,9351,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(336609,9351,'vi','Lá»—i cáº­p nháº­t tiá»n tá»‡',0),(336610,9351,'af','Fout met Opdatering van Geldeenheid.',0),(336611,9351,'ro','Eroare de actualizare moneda',0),(336612,9351,'et','Valuuta uuendamisel tekkis viga',0),(336613,9351,'si','Napaka posodabljanje valute',0),(336614,9351,'ba','Kesalahan update mata uang',0),(336615,9351,'nl','Fout bijwerken valuta',0),(336616,9351,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ valuutta',0),(336617,9351,'no','Feil oppdatering valuta',0),(336618,9351,'da','Fejl opdatering valuta',0),(336619,9351,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ í†µí™”',0),(336620,9351,'he','×ž×˜×‘×¢ ×”×ž×¢×“×›× ×ª ×©×’×™××”',0),(336621,9351,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(336622,9351,'zh','é”™è¯¯æ›´æ–°è´§å¸\r\n',0),(336623,9351,'sv','Fel uppdatering valuta',0),(336624,9351,'it','Errore aggiornamento valuta',0),(336625,9351,'tl','',0),(336626,9351,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(336627,9351,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤®à¥à¤¦à¥à¤°à¤¾',0),(336628,9351,'ms','Mata Wang pengemaskinian ralat',0),(336629,9351,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¹Ù…Ù„Ø©',0),(336630,9351,'fr','Erreur de monnaie mise Ã  jour',0),(336631,9351,'jp','ã‚¨ãƒ©ãƒ¼æ›´æ–°é€šè²¨',0),(336632,9351,'pt','Moeda de atualizaÃ§Ã£o de erro',0),(336633,9351,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð’Ð°Ð»ÑŽÑ‚Ñ‹',0),(336634,9351,'es','Error Actualizando la Divisa',0),(336635,9351,'de','Fehler Update WÃ¤hrung',0),(336636,9351,'en','Error Updating Currency',0),(336637,9352,'is','',0),(336638,9352,'dr','Ù†Ø´Ø§Ù†Ù‡ Ø¨Ø¹Ø¯ Ø§Ø² Ù…Ù‚Ø¯Ø§Ø±',0),(336639,9352,'pr','Ù†Ø´Ø§Ù†Ù‡ Ø¨Ø¹Ø¯ Ø§Ø² Ù…Ù‚Ø¯Ø§Ø±',0),(336640,9352,'tr','SÃ¼reden sonra sembolÃ¼',0),(336641,9352,'pl','Symbol po kwota',0),(336642,9352,'bg','Ð¡Ð¸Ð¼Ð²Ð¾Ð» ÑÐ»ÐµÐ´ ÑÑƒÐ¼Ð°',0),(336643,9352,'ur','Ø±Ù‚Ù… Ú©Û’ Ø¨Ø¹Ø¯ Ø¹Ù„Ø§Ù…Øª',0),(336644,9352,'sr','Ð¡Ð¸Ð¼Ð±Ð¾Ð» Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(336645,9352,'vi','Biá»ƒu tÆ°á»£ng sau sá»‘ tiá»n',0),(336646,9352,'af','Simbool Na Bedrag',0),(336647,9352,'ro','Simbol dupÄƒ suma',0),(336648,9352,'et','PÃ¤rast sÃ¼mbol',0),(336649,9352,'si','Simbol po znesek',0),(336650,9352,'ba','Simbol setelah jumlah',0),(336651,9352,'nl','Symbool na bedrag',0),(336652,9352,'fi','Symboli ajan',0),(336653,9352,'no','Symbolet etter',0),(336654,9352,'da','Symbol efter belÃ¸b',0),(336655,9352,'ko','ì–‘ í›„ ê¸°í˜¸',0),(336656,9352,'he','×¡×ž×œ ×œ××—×¨ ×¤×¨×§',0),(336657,9352,'el','Î£ÏÎ¼Î²Î¿Î»Î¿ Î¼ÎµÏ„Î¬ Ï„Î¿ Ï€Î¿ÏƒÏŒ',0),(336658,9352,'zh','é‡‘é¢åŽç¬¦å·\r\n',0),(336659,9352,'sv','Symbol efter belopp',0),(336660,9352,'it','Simbolo dopo quantitÃ ',0),(336661,9352,'tl','',0),(336662,9352,'th','&#3626;&#3633;&#3597;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;&#3627;&#3621;&#3633;&#3591;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(336663,9352,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤ªà¥à¤°à¤¤à¥€à¤•',0),(336664,9352,'ms','Simbol selepas jumlah',0),(336665,9352,'ar','Ø±Ù…Ø² Ø¨Ø¹Ø¯ Ø§Ù„Ù…Ø¨Ù„Øº',0),(336666,9352,'fr','Symbole aprÃ¨s montant',0),(336667,9352,'jp','é‡ã®å¾Œã®è¨˜å·',0),(336668,9352,'pt','SÃ­mbolo apÃ³s a quantidade',0),(336669,9352,'ru','Ð¡Ð¸Ð¼Ð²Ð¾Ð» Ð¿Ð¾ÑÐ»Ðµ ÑÑƒÐ¼Ð¼Ñ‹',0),(336670,9352,'es','SÃ­mbolo DespuÃ©s de Cantidad',0),(336671,9352,'de','Symbol nach Betrag',0),(336672,9352,'en','Symbol After Amount',0),(336673,9353,'is','',0),(336674,9353,'dr','Ù†Ø´Ø§Ù†Ù‡ Ù‚Ø¨Ù„  Ø§Ø² Ù…Ù‚Ø¯Ø§Ø±',0),(336675,9353,'pr','Ù†Ø´Ø§Ù†Ù‡ Ù‚Ø¨Ù„  Ø§Ø² Ù…Ù‚Ø¯Ø§Ø±',0),(336676,9353,'tr','SembolÃ¼ daha Ã¶nce tutarÄ±',0),(336677,9353,'pl','Symbol przed kwota',0),(336678,9353,'bg','Ð¡Ð¸Ð¼Ð²Ð¾Ð» Ð¿Ñ€ÐµÐ´Ð¸ ÑÑƒÐ¼Ð°',0),(336679,9353,'ur','Ø¹Ù„Ø§Ù…Øª Ø±Ù‚Ù… Ø³Û’ Ù¾ÛÙ„Û’',0),(336680,9353,'sr','Ð¡Ð¸Ð¼Ð±Ð¾Ð» Ñ€Ð°Ð½Ð¸Ñ˜Ðµ Ð¸Ð·Ð½Ð¾Ñ',0),(336681,9353,'vi','Biá»ƒu tÆ°á»£ng trÆ°á»›c sá»‘ tiá»n',0),(336682,9353,'af','Simbool Voor Bedrag',0),(336683,9353,'ro','Simbol Ã®nainte de suma',0),(336684,9353,'et','Summa sÃ¼mbol',0),(336685,9353,'si','Simbol pred znesek',0),(336686,9353,'ba','Simbol sebelum jumlah',0),(336687,9353,'nl','Symbool voor bedrag',0),(336688,9353,'fi','Symboli ennen summa',0),(336689,9353,'no','Symbolet fÃ¸r belÃ¸p',0),(336690,9353,'da','Symbolet fÃ¸r belÃ¸bet',0),(336691,9353,'ko','ê¸ˆì•¡ ì•žì— ê¸°í˜¸',0),(336692,9353,'he','×”×¡×ž×œ ×‘×¢×‘×¨ ×¡×›×•×',0),(336693,9353,'el','Î£ÏÎ¼Î²Î¿Î»Î¿ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î¿ Ï€Î¿ÏƒÏŒ',0),(336694,9353,'zh','é‡‘é¢å‰ç¬¦å·\r\n',0),(336695,9353,'sv','Symbol fÃ¶re beloppet',0),(336696,9353,'it','Simbolo prima di quantitÃ ',0),(336697,9353,'tl','',0),(336698,9353,'th','&#3626;&#3633;&#3597;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;&#3585;&#3656;&#3629;&#3609;&#3592;&#3635;&#3609;&#3623;&#3609;',0),(336699,9353,'hi','à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤ªà¥à¤°à¤¤à¥€à¤•',0),(336700,9353,'ms','Simbol sebelum jumlah',0),(336701,9353,'ar','Ø§Ù„Ø±Ù…Ø² Ù‚Ø¨Ù„ Ø§Ù„Ù…Ø¨Ù„Øº',0),(336702,9353,'fr','Un symbole avant quantitÃ©',0),(336703,9353,'jp','é‡‘é¡ã®å‰ã«è¨˜å·',0),(336704,9353,'pt','SÃ­mbolo quantidade',0),(336705,9353,'ru','Ð¡Ð¸Ð¼Ð²Ð¾Ð» Ð´Ð¾ ÑÑƒÐ¼Ð¼Ñ‹',0),(336706,9353,'es','SÃ­mbolo Antes de Cantidad',0),(336707,9353,'de','Symbol vor dem Betrag',0),(336708,9353,'en','Symbol Before Amount',0),(336709,9354,'is','',0),(336710,9354,'dr','Ù…Ø­Ù„ Ø§Ø¹Ø´Ø§Ø± ÙˆØ§Ø­Ø¯ ',0),(336711,9354,'pr','Ù…Ø­Ù„ Ø§Ø¹Ø´Ø§Ø± ÙˆØ§Ø­Ø¯ ',0),(336712,9354,'tr','Birimi ondalÄ±k basamak',0),(336713,9354,'pl','Miejsc dziesiÄ™tnych jednostki',0),(336714,9354,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð´ÐµÑÐµÑ‚Ð¸Ñ‡Ð½Ð¸',0),(336715,9354,'ur','ÛŒÙˆÙ†Ù¹ Ø§Ø¹Ø´Ø§Ø±ÛŒ Ù…Ù‚Ø§Ù…Ø§Øª',0),(336716,9354,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð±Ñ€Ð¾Ñ˜ Ð´ÐµÑ†Ð¸Ð¼Ð°Ð»Ð°',0),(336717,9354,'vi','Chá»— ÄÆ¡n vá»‹ tháº­p phÃ¢n',0),(336718,9354,'af','Eenheid Desimale Plekke',0),(336719,9354,'ro','Unitate de zecimale',0),(336720,9354,'et','Ãœhiku komakohti',0),(336721,9354,'si','Enota decimalnih mest',0),(336722,9354,'ba','Satuan desimal',0),(336723,9354,'nl','Eenheid decimalen',0),(336724,9354,'fi','YksikkÃ¶ desimaalin',0),(336725,9354,'no','Enheten desimaler',0),(336726,9354,'da','Enhed decimaler',0),(336727,9354,'ko','ë‹¨ìœ„ ì†Œìˆ˜ ìžë¦¿ìˆ˜',0),(336728,9354,'he','×™×—×™×“×” ×ž×™×ž×™×Ÿ ×œ× ×§×•×“×” ×”×¢×©×¨×•× ×™×ª',0),(336729,9354,'el','ÎœÎ¿Î½Î¬Î´Î± Î´ÎµÎºÎ±Î´Î¹ÎºÎ¬',0),(336730,9354,'zh','å•ä½å°æ•°ä½\r\n',0),(336731,9354,'sv','Enheten decimaler',0),(336732,9354,'it','UnitÃ  decimali',0),(336733,9354,'tl','',0),(336734,9354,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3627;&#3609;&#3656;&#3623;&#3618;&#3607;&#3624;&#3609;&#3636;&#3618;&#3617;',0),(336735,9354,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¦à¤¶à¤®à¤²à¤µ à¤¸à¥à¤¥à¤¾à¤¨',0),(336736,9354,'ms','Unit perpuluhan',0),(336737,9354,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„Ø¹Ø´Ø±ÙŠØ©',0),(336738,9354,'fr','UnitÃ© dÃ©cimale',0),(336739,9354,'jp','å˜ä½ã®å°æ•°ç‚¹ä»¥ä¸‹ã®æ¡æ•°',0),(336740,9354,'pt','Unidade de decimais',0),(336741,9354,'ru','Ð”ÐµÑÑÑ‚Ð¸Ñ‡Ð½Ñ‹Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(336742,9354,'es','Puntos Decimales de Unidad',0),(336743,9354,'de','Einheit-Dezimalstellen',0),(336744,9354,'en','Unit Decimal Places',0),(336745,9355,'is','',0),(336746,9355,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙƒØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(336747,9355,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙƒØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(336748,9355,'tr','Bir kod girmeniz gerekir',0),(336749,9355,'pl','Musisz wprowadziÄ‡ kod',0),(336750,9355,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ð´',0),(336751,9355,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø¶Ø§Ø¨Ø·Û Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(336752,9355,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑˆÐ¸Ñ„Ñ€Ñƒ',0),(336753,9355,'vi','Báº¡n pháº£i nháº­p 1 mÃ£',0),(336754,9355,'af','U moet \'n KODE invoer',0),(336755,9355,'ro','trebuie sa introduceti un cod',0),(336756,9355,'et','Pead sisestama koodi',0),(336757,9355,'si','Vnesite Å¡ifro',0),(336758,9355,'ba','Anda harus memasukkan kode',0),(336759,9355,'nl','U moet een Code invoeren',0),(336760,9355,'fi','Anna koodi',0),(336761,9355,'no','Du mÃ¥ angi en kode',0),(336762,9355,'da','Du skal angive en kode',0),(336763,9355,'ko','ì½”ë“œë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(336764,9355,'he','×¢×œ×™×š ×œ×”×›× ×™×¡ ×§×•×“',0),(336765,9355,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ ÎºÏ‰Î´Î¹ÎºÏŒ',0),(336766,9355,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªä»£ç \r\n',0),(336767,9355,'sv','Du mÃ¥ste ange en kod',0),(336768,9355,'it','Ãˆ necessario inserire un codice',0),(336769,9355,'tl','',0),(336770,9355,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3611;&#3657;&#3629;&#3609;&#3619;&#3627;&#3633;&#3626;',0),(336771,9355,'hi','à¤†à¤ª à¤à¤• à¤•à¥‹à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤•',0),(336772,9355,'ms','Awda mesti masukkan kod',0),(336773,9355,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ¯Ø®Ù„ Ø±Ù…Ø²Ø§',0),(336774,9355,'fr','Vous devez entrer un code.',0),(336775,9355,'jp','ã‚³ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(336776,9355,'pt','VocÃª deve digitar um cÃ³digo',0),(336777,9355,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ ÐºÐ¾Ð´',0),(336778,9355,'es','Debe Introducir un CÃ³digo',0),(336779,9355,'de','Sie mÃ¼ssen einen Code eingeben.',0),(336780,9355,'en','You Must Enter A Code',0),(336781,9356,'is','',0),(336782,9356,'dr','/ Ø§ØµÙ„Ø§Ø­   / ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ø§Ø±Ø²Ù‡Ø§',0),(336783,9356,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / ÙˆÙŠØ±Ø§ÙŠØ´  / ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÙŠ Ø§Ø±Ø²Ù‡Ø§',0),(336784,9356,'tr','Ekle/DÃ¼zenle/etkinleÅŸtirmek para birimleri',0),(336785,9356,'pl','Dodaj/Edytuj/aktywowaÄ‡ walut',0),(336786,9356,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ/Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ Ð²Ð°Ð»ÑƒÑ‚Ð¸',0),(336787,9356,'ur','Ú©Ø±Ù†Ø³ÛŒÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ¯ÙˆÛŒÙ†/Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(336788,9356,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ /Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ð¸ Ð²Ð°Ð»ÑƒÑ‚Ð°Ð¼Ð°',0),(336789,9356,'vi','ThÃªm/Sá»­a/KÃ­ch Hoáº¡t Loáº¡i Tiá»n Tá»‡',0),(336790,9356,'af','Geldeenhede Byvoeg/Redigeer/Aktiveer',0),(336791,9356,'ro','Adauga/edita/activa valute',0),(336792,9356,'et','Lisa/muuda/aktiveeri valuutasid',0),(336793,9356,'si','Dodajanje/urejanje/aktiviranje valute',0),(336794,9356,'ba','Tambah/Edit/mengaktifkan mata uang',0),(336795,9356,'nl','Toevoegen/wijzigen valutasoorten',0),(336796,9356,'fi','LisÃ¤Ã¤/Muokkaa/Aktivoi valuutat',0),(336797,9356,'no','Legge til/redigere/aktivere valutaer',0),(336798,9356,'da','TilfÃ¸j/Rediger/aktivere valutaer',0),(336799,9356,'ko','ì¶”ê°€/íŽ¸ì§‘/í™œì„±í™” í†µí™”',0),(336800,9356,'he','×”×•×¡×£/×¢×¨×•×š/×œ×”×¤×¢×™×œ ×‘×ž×˜×‘×¢×•×ª',0),(336801,9356,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±/ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î½Î¿Î¼Î¯ÏƒÎ¼Î±Ï„Î±',0),(336802,9356,'zh','å¢žåŠ /ç¼–è¾‘/æ¿€æ´»è´§å¸\r\n',0),(336803,9356,'sv','LÃ¤gg till/redigera/aktivera valutor',0),(336804,9356,'it','Aggiungi/modifica/attivare valute',0),(336805,9356,'tl','',0),(336806,9356,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586;/&#3648;&#3611;&#3636;&#3604;&#3651;&#3594;&#3657;&#3591;&#3634;&#3609; &#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(336807,9356,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚/à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤®à¥à¤¦à¥à¤°à¤¾à¤“à¤‚',0),(336808,9356,'ms','Matawang Tambah/Edit/mengaktifkan',0),(336809,9356,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ±/ØªÙØ¹ÙŠÙ„ Ø§Ù„Ø¹Ù…Ù„Ø§Øª',0),(336810,9356,'fr','Ajouter/Modifier/Activer Devises',0),(336811,9356,'jp','é€šè²¨ã®è¿½åŠ /ç·¨é›†/ã‚¢ã‚¯ãƒ†ã‚£ãƒ–åŒ–',0),(336812,9356,'pt','Adicionar/editar/ativar moedas',0),(336813,9356,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ/Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²Ð°Ð»ÑŽÑ‚',0),(336814,9356,'es','Agregar/Editar/Activar Divisas',0),(336815,9356,'de','HinzufÃ¼gen/bearbeiten/aktivieren WÃ¤hrungen',0),(336816,9356,'en','Add/Edit/Activate Currencies',0),(336817,9357,'is','',0),(336818,9357,'dr','(Ù…Ø¨Ù†Ø§',0),(336819,9357,'pr','Ø§Ø±Ø² Ù¾Ø§ÙŠÙ‡(Ù…Ø¨Ù†Ø§',0),(336820,9357,'tr','Baz para birimi',0),(336821,9357,'pl','Waluta bazowa',0),(336822,9357,'bg','ÐžÑÐ½Ð¾Ð²Ð½Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(336823,9357,'ur','Ø¨ÛŒØ³ Ú©Ø±Ù†Ø³ÛŒ',0),(336824,9357,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ñƒ Ð²Ð°Ð»ÑƒÑ‚Ñƒ',0),(336825,9357,'vi','Tiá»n tá»‡ gá»‘c',0),(336826,9357,'af','Basisgeldeenheid',0),(336827,9357,'ro','MonedÄƒ de bazÄƒ',0),(336828,9357,'et','Baasvaluutas',0),(336829,9357,'si','Osnovno valuto',0),(336830,9357,'ba','Mata uang dasar',0),(336831,9357,'nl','Basisvaluta',0),(336832,9357,'fi','Perusvaluutta',0),(336833,9357,'no','Standardvalutaen',0),(336834,9357,'da','Grundvalutaen',0),(336835,9357,'ko','ê¸°ë³¸ í†µí™”',0),(336836,9357,'he','×ž×˜×‘×¢ ×”×‘×¡×™×¡',0),(336837,9357,'el','ÎÏŒÎ¼Î¹ÏƒÎ¼Î± Î²Î¬ÏƒÎ·Ï‚',0),(336838,9357,'zh','åŸºç¡€è´§å¸\r\n',0),(336839,9357,'sv','Basvalutan',0),(336840,9357,'it','Valuta di base',0),(336841,9357,'tl','',0),(336842,9357,'th','&#3600;&#3634;&#3609;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(336843,9357,'hi','à¤®à¥‚à¤² à¤®à¥à¤¦à¥à¤°à¤¾',0),(336844,9357,'ms','Mata Wang asas',0),(336845,9357,'ar','Ø§Ù„Ø¹Ù…Ù„Ø© Ø§Ù„Ø£Ø³Ø§Ø³',0),(336846,9357,'fr','Devise de base',0),(336847,9357,'jp','åŸºæœ¬é€šè²¨',0),(336848,9357,'pt','Moeda base',0),(336849,9357,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð°Ñ Ð’Ð°Ð»ÑŽÑ‚Ð°',0),(336850,9357,'es','Divisa Base',0),(336851,9357,'de','BasiswÃ¤hrung',0),(336852,9357,'en','Base Currency',0),(336853,9358,'is','',0),(336854,9358,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(336855,9358,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ ÙØ§ÙƒØªÙˆØ±',0),(336856,9358,'tr','Genel fatura bilgilerini kaydet',0),(336857,9358,'pl','Zapisz informacje ogÃ³lne faktury',0),(336858,9358,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð¾Ð±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(336859,9358,'ur','Ø¬Ù†Ø±Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(336860,9358,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð³ÐµÐ½ÐµÑ€Ð°Ð»Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(336861,9358,'vi','Sao lÆ°u ThÃ´ng Tin hÃ³a Ä‘Æ¡n chung',0),(336862,9358,'af','Stoor Algemene Faktuur Inligting',0),(336863,9358,'ro','SalvaÅ£i General Info facturÄƒ',0),(336864,9358,'et','Salvestada arve Ãœldinfo',0),(336865,9358,'si','Shranite sploÅ¡ni raÄun Info',0),(336866,9358,'ba','Menyelamatkan Jenderal faktur Info',0),(336867,9358,'nl','Algemeen factuur Info opslaan',0),(336868,9358,'fi','Tallenna laskun perustiedot',0),(336869,9358,'no','Lagre General faktura Info',0),(336870,9358,'da','Gemme almindelige faktura Info',0),(336871,9358,'ko','ì¼ë°˜ ì†¡ìž¥ ì •ë³´ë¥¼ ì €ìž¥',0),(336872,9358,'he','×©×ž×•×¨ ×ž×™×“×¢ ×›×œ×œ×™ ×©×œ ×—×©×‘×•× ×™×ª',0),(336873,9358,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Î³ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(336874,9358,'zh','ä¿å­˜æ™®é€šå‘ç¥¨ä¿¡æ¯\r\n',0),(336875,9358,'sv','Spara General faktura information',0),(336876,9358,'it','Salva le informazioni di fattura generale',0),(336877,9358,'tl','',0),(336878,9358,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;',0),(336879,9358,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(336880,9358,'ms','Menyimpan maklumat invois am',0),(336881,9358,'ar','Ø­ÙØ¸ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¹Ø§Ù…Ø©',0),(336882,9358,'fr','Enregistrer infos facture gÃ©nÃ©rales',0),(336883,9358,'jp','ä¸€èˆ¬çš„ãªè«‹æ±‚æ›¸æƒ…å ±ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(336884,9358,'pt','Salvar informaÃ§Ã£o de nota fiscal geral',0),(336885,9358,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð¾Ð±Ñ‰ÐµÐ³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(336886,9358,'es','Guardar Info de Factura General',0),(336887,9358,'de','Allgemeine Rechnung Info speichern',0),(336888,9358,'en','Save General Invoice Info',0),(336889,9359,'is','',0),(336890,9359,'dr','Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(336891,9359,'pr','Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù¾Ø³Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(336892,9359,'tr','Bu Fatura Ã¶nceden deftere nakledilmiÅŸ.',0),(336893,9359,'pl','Faktura ta juÅ¼ zostaÅ‚a zaksiÄ™gowana.',0),(336894,9359,'bg','Ð¢Ð°Ð·Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð²ÐµÑ‡Ðµ Ðµ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð°.',0),(336895,9359,'ur','Ø§Ø³ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ù¾ÛÙ„Û’ ÛÛŒ Ù¾ÙˆØ³Ù¹ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(336896,9359,'sr','ÐžÐ²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð²ÐµÑ› Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð°.',0),(336897,9359,'vi','HÃ³a Ä‘Æ¡n nÃ y Ä‘Ã£ káº¿t chuyá»ƒn',0),(336898,9359,'af','Hierdie faktuur is alreeds gepos.',0),(336899,9359,'ro','Aceasta factura a fost deja Ã®nregistratÄƒ.',0),(336900,9359,'et','See arve on juba konteeritud.',0),(336901,9359,'si','Ta raÄun Å¾e knjiÅ¾ili.',0),(336902,9359,'ba','Faktur ini sudah telah diposting.',0),(336903,9359,'nl','Deze factuur is al geboekt.',0),(336904,9359,'fi','TÃ¤mÃ¤ lasku on jo kirjattu.',0),(336905,9359,'no','Denne fakturaen er allerede bokfÃ¸rt.',0),(336906,9359,'da','Denne fakturaen er allerede bogfÃ¸rt.',0),(336907,9359,'ko','ì´ ì†¡ìž¥ ì´ë¯¸ ê²Œì‹œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(336908,9359,'he','×—×©×‘×•× ×™×ª ×–×• ×›×‘×¨ × ×¨×©×.',0),(336909,9359,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î­Ï‡ÎµÎ¹ Î®Î´Î· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¸ÎµÎ¯.',0),(336910,9359,'zh','è¿™å¼ å‘ç¥¨å·²ç»å‘å¸ƒã€‚\r\n',0),(336911,9359,'sv','Denna faktura Ã¤r bokfÃ¶rd.',0),(336912,9359,'it','Questa fattura Ã¨ giÃ  stata registrata.',0),(336913,9359,'tl','',0),(336914,9359,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3609;&#3637;&#3657;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3621;&#3657;&#3623;',0),(336915,9359,'hi','à¤‡à¤¸ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¤à¥ˆà¤¨à¤¾à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(336916,9359,'ms','Invois ini telah dipaparkan.',0),(336917,9359,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø¨Ø§Ù„ÙØ¹Ù„ Ù†Ø´Ø± Ù‡Ø°Ù‡ Ø§Ù„ÙØ§ØªÙˆØ±Ø©.',0),(336918,9359,'fr','Cette facture a dÃ©jÃ  Ã©tÃ© reportÃ©e.',0),(336919,9359,'jp','ã“ã®è«‹æ±‚æ›¸ã¯æ—¢ã«æŽ²è¼‰ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(336920,9359,'pt','Essa fatura jÃ¡ foi postada.',0),(336921,9359,'ru','Ð­Ñ‚Ð¾Ñ‚ ÑÑ‡ÐµÑ‚ ÑƒÐ¶Ðµ Ð±Ñ‹Ð» ÑƒÑ‡Ñ‚ÐµÐ½.',0),(336922,9359,'es','Esta factura ya se habÃ­a contabilizado',0),(336923,9359,'de','Diese Rechnung wurde bereits gebucht.',0),(336924,9359,'en','This invoice has already been posted.',0),(336925,9360,'is','',0),(336926,9360,'dr','Ø§ÙŠÙ† ÙÙ‚Ø· Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ ÙƒÙ„ÙŠ Ø­Ø§ÙˆÙŠ Ù…Ø·Ø§Ù„Ø¨ Ø¨Ø§Ù„Ø§ Ø±Ø§ Ø°Ø®ÙŠØ±Ù‡ Ù…ÙŠ ÙƒÙ†Ø¯ ',0),(336927,9360,'pr','Ø§ÙŠÙ† ÙÙ‚Ø· Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ ÙƒÙ„ÙŠ Ø­Ø§ÙˆÙŠ Ù…Ø·Ø§Ù„Ø¨ Ø¨Ø§Ù„Ø§ Ø±Ø§ Ø°Ø®ÙŠØ±Ù‡ Ù…ÙŠ ÙƒÙ†Ø¯ ',0),(336928,9360,'tr','Bu sadece yukarÄ±da yer alan genel fatura bilgileri kurtarÄ±r.',0),(336929,9360,'pl','ZaoszczÄ™dzi to tylko ogÃ³lne faktury informacje zawartych powyÅ¼ej.',0),(336930,9360,'bg','Ð¢Ð¾Ð²Ð° ÑÐ°Ð¼Ð¾ Ñ‰Ðµ ÑÐ¿ÐµÑÑ‚Ð¸ Ð½Ð° Ð¾Ð±Ñ‰Ð¸Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ, ÑÑŠÐ´ÑŠÑ€Ð¶Ð°Ñ‰Ð¸ ÑÐµ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ.',0),(336931,9360,'ur','ÛŒÛ ØµØ±Ù Ø§ÙˆÙ¾Ø± Ù…Ø°Ú©ÙˆØ± Ú©Ùˆ Ø¬Ù†Ø±Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø­ÙÙˆØ¸ Ú©Ø±Û’ Ú¯Ø§ Û”',0),(336932,9360,'sr','ÐžÐ²Ð¾ Ñ›Ðµ ÑÐ°Ð¼Ð¾ ÑÐ¿Ð°ÑÐ¸Ñ‚Ð¸ ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ ÐºÐ¾Ñ˜Ðµ ÑÐµ Ð½Ð°Ð»Ð°Ð·Ðµ Ð¸Ð·Ð½Ð°Ð´.',0),(336933,9360,'vi','Chá»‰ sao lÆ°u thÃ´ng tin hÃ³a Ä‘Æ¡n chung á»Ÿ trÃªn',0),(336934,9360,'af','Hierdie sal slegs die algemene faktuur inligting soos hierbo vervat stoor',0),(336935,9360,'ro','Acest lucru va salva numai info facturÄƒ generale conÅ£inute de mai sus.',0),(336936,9360,'et','See sÃ¤Ã¤stab vaid Ã¼ldine arve info eespool esitatud.',0),(336937,9360,'si','To bo samo shranite sploÅ¡ni raÄun info iz zgoraj.',0),(336938,9360,'ba','Ini hanya akan menghemat info umum faktur yang tercantum di atas.',0),(336939,9360,'nl','Dit bespaart alleen de algemene factuur-info hierboven bevatte.',0),(336940,9360,'fi','TÃ¤mÃ¤ sÃ¤Ã¤stÃ¤Ã¤ vain mainitut ehdot laskun tiedot.',0),(336941,9360,'no','Dette vil bare lagre alminnelige fakturaen informasjon inneholdt over.',0),(336942,9360,'da','Dette vil kun gemme den almindelige faktura info indeholdt ovenfor.',0),(336943,9360,'ko','ì´ ìœ„ì— í¬í•¨ ëœ ì¼ë°˜ ì†¡ìž¥ ì •ë³´ë¥¼ ì €ìž¥ í•©ë‹ˆë‹¤.',0),(336944,9360,'he','×–×” ×™×—×¡×•×š ×¨×§ ××ª ×¤×¨×˜×™ ×”×—×©×‘×•× ×™×ª ×›×œ×œ×™ ×”×›×œ×•×œ ×œ×¢×™×œ.',0),(336945,9360,'el','Î‘Ï…Ï„ÏŒ Î¸Î± ÏƒÏŽÏƒÎµÎ¹ Î¼ÏŒÎ½Î¿ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³ÎµÎ½Î¹ÎºÎ¿Ï Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€Î¿Ï… Ï€ÎµÏÎ¹Î­Ï‡Î¿Î½Ï„Î±Î¹ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰.',0),(336946,9360,'zh','è¿™å°†åªä¿å­˜åŒ…å«ä»¥ä¸Šçš„æ™®é€šå‘ç¥¨ã€‚\r\n',0),(336947,9360,'sv','Detta kommer att endast spara allmÃ¤nna faktura info som finns ovan.',0),(336948,9360,'it','Questo salverÃ  solo le informazioni di fattura generale contenute sopra.',0),(336949,9360,'tl','',0),(336950,9360,'th','&#3609;&#3637;&#3657;&#3592;&#3632;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3593;&#3614;&#3634;&#3632;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3633;&#3656;&#3623;&#3',0),(336951,9360,'hi','à¤¯à¤¹ à¤•à¥‡à¤µà¤² à¤Šà¤ªà¤° à¤¨à¤¿à¤¹à¤¿à¤¤ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¥‡à¤—à¤¾à¥¤',0),(336952,9360,'ms','Ini hanya akan menyimpan maklumat invois am yang terkandung di atas.',0),(336953,9360,'ar','Ø¥Ù„Ø§ Ø£Ù† Ù‡Ø°Ø§ Ø³ÙŠÙˆÙØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¹Ø§Ù…Ø© Ø§Ù„ÙˆØ§Ø±Ø¯Ø© Ø£Ø¹Ù„Ø§Ù‡.',0),(336954,9360,'fr','Cela permettra de ne sauvegarder les infos gÃ©nÃ©rales facture figurant ci-dessus.',0),(336955,9360,'jp','ã“ã‚Œã¯ã€ä¸Šè¨˜ã®å«ã¾ã‚Œã¦ã„ã‚‹ä¸€èˆ¬çš„ãªè«‹æ±‚æ›¸æƒ…å ±ã‚’ã®ã¿ä¿å­˜ã•ã‚Œã¾ã™ã€‚',0),(336956,9360,'pt','Isto sÃ³ irÃ¡ poupar a informaÃ§Ã£o geral fatura contida acima.',0),(336957,9360,'ru','Ð­Ñ‚Ð¾ Ð±ÑƒÐ´ÐµÑ‚ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¾Ð±Ñ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ, Ð¿Ñ€Ð¸Ð²ÐµÐ´ÐµÐ½Ð½ÑƒÑŽ Ð²Ñ‹ÑˆÐµ.',0),(336958,9360,'es','Esta acciÃ³n solo guardarÃ¡ la informaciÃ³n de factura que se arriba contiene',0),(336959,9360,'de','Dieses speichert nur die allgemeine Rechnung Info oben enthalten.',0),(336960,9360,'en','This will only save the general invoice info contained above.',0),(336961,9361,'is','',0),(336962,9361,'dr','Ø´Ù…Ø§ Ù†Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§ Ù¾Ø³Øª ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ØªØºÙŠÙŠØ±Ø§Øª Ø³Ø·Ø± ÙƒØ§Ù„Ø§ Ø±Ø§ Ø°Ø®ÙŠØ±Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(336963,9361,'pr','Ø´Ù…Ø§ Ù†Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§ Ù¾Ø³Øª ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù…ÙŠ Ø®ÙˆØ§Ù‡ÙŠØ¯ ØªØºÙŠÙŠØ±Ø§Øª Ø³Ø·Ø± ÙƒØ§Ù„Ø§ Ø±Ø§ Ø°Ø®ÙŠØ±Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(336964,9361,'tr','SatÄ±r Ã¶ÄŸesi deÄŸiÅŸiklikleri kaydetmek istiyorsanÄ±z, ilk Ã¶nce UNPOST gerekir.',0),(336965,9361,'pl','Musi najpierw UNPOST, jeÅ›li chcesz zapisaÄ‡ zmiany pozycji.',0),(336966,9361,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° UNPOST Ð¿ÑŠÑ€Ð²Ð¾, Ð°ÐºÐ¾ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð·Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸.',0),(336967,9361,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ù„Ø§Ø¦Ù† Ø´Û’ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº ØªÙˆ Ø¢Ù¾ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§Ù†Ù¾ÙˆØ³Ù¹ Ú†Ø§ÛÛŒÛ’ Û”',0),(336968,9361,'sr','ÐœÐ¾Ñ€Ð° Ð¿Ñ€Ð²Ð¾ Ð´Ð° ÐŸÐžÐ’Ð£Ð˜Ð• Ð°ÐºÐ¾ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° ÑÐ°Ñ‡ÑƒÐ²Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°.',0),(336969,9361,'vi','Pháº£i khÃ´ng káº¿t chuyá»ƒn trÆ°á»›c náº¿u báº¡n muá»‘n sao lÆ°u thay Ä‘á»•i cá»§a dÃ²ng hÃ ng',0),(336970,9361,'af','U moet eers ONPOS indien u die lynitem verwanderinge wil stoor.',0),(336971,9361,'ro','Trebuie sÄƒ UNPOST mai Ã®ntÃ¢i dacÄƒ doriÅ£i sÄƒ salvaÅ£i modificÄƒrile element rÃ¢nd.',0),(336972,9361,'et','Te peate eemaldama postituse kui soovite salvestada muutusi',0),(336973,9361,'si','Mora najprej UNPOST, Äe Å¾elite shraniti spremembe vrstiÄne postavke.',0),(336974,9361,'ba','Anda harus UNPOST terlebih dahulu jika Anda ingin menyimpan item baris perubahan.',0),(336975,9361,'nl','U moet eerst UNPOST desgewenst lijnitem wijzigingen op te slaan.',0),(336976,9361,'fi','Sinun on UNPOST ensin, jos haluat tallentaa nimikkeen muutokset.',0),(336977,9361,'no','Du mÃ¥ UNPOST fÃ¸rst hvis du vil lagre linjeelement endringer.',0),(336978,9361,'da','Du skal UNPOST fÃ¸rst hvis du vil gemme linjeelement Ã¦ndringer.',0),(336979,9361,'ko','í•­ëª© ë³€ê²½ ë‚´ìš©ì„ ì €ìž¥ í•˜ë ¤ë©´ ë¨¼ì € UNPOST í•´ì•¼ í•©ë‹ˆë‹¤.',0),(336980,9361,'he','××ª×” ×—×™×™×‘ UNPOST ×ª×—×™×œ×” ×× ×‘×¨×¦×•× ×š ×œ×©×ž×•×¨ ××ª ×”×©×™× ×•×™×™× ×¤×¨×™×˜ ×©×•×¨×”.',0),(336981,9361,'el','Î£Î±Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± UNPOST Ï€ÏÏŽÏ„Î± ÎµÎ¬Î½ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚.',0),(336982,9361,'zh','å¦‚æžœä½ æƒ³ä¿å­˜çº¿é¡¹ç›®å˜æ›´ï¼Œä½ å¿…é¡»é¦–å…ˆä¸å‘å¸ƒã€‚\r\n',0),(336983,9361,'sv','Du mÃ¥ste UNPOST fÃ¶rst om du vill spara Ã¤ndringar av radartikel.',0),(336984,9361,'it','Deve UNPOST in primo luogo, se si desidera salvare le modifiche dell\'elemento di linea.',0),(336985,9361,'tl','',0),(336986,9361,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3652;&#3617;&#3656;&#3612;&#3656;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3649;&#3619;&#3585; &#3606;&#3657;&#3634;&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#',0),(336987,9361,'hi','à¤†à¤ª à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¥‹à¤‚ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚, à¤¤à¥‹ à¤†à¤ª à¤¸à¤¬à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ UNPOST à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(336988,9361,'ms','Anda mesti UNPOST terlebih dahulu jika anda ingin menyimpan perubahan garisan butiran.',0),(336989,9361,'ar','ÙŠØ¬Ø¨ Ø£Ù† Ø£ÙˆÙ†Ø¨ÙˆØ³Øª Ø£ÙˆÙ„Ø§Ù‹ Ø¥Ø°Ø§ ÙƒÙ†Øª ØªØ±ÙŠØ¯ Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø¨Ù†Ø¯.',0),(336990,9361,'fr','Vous devez d\'abord \"UNPOST\", retirer si vous voulez sauvegarder les changements de la ligne de l\'article.',0),(336991,9361,'jp','ã‚ãªãŸã¯å“ç›®å¤‰æ›´ã‚’ä¿å­˜ã™ã‚‹å ´åˆã¯æœ€åˆã«é–¢é€£ä»˜ã‘ãŸã‚Šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(336992,9361,'pt','VocÃª deve UNPOST primeiro se vocÃª deseja salvar as alteraÃ§Ãµes do item de linha.',0),(336993,9361,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐ½Ð°Ñ‡Ð°Ð»Ð° UNPOST, ÐµÑÐ»Ð¸ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ ÑÑ‚Ñ€Ð¾ÐºÐ¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°.',0),(336994,9361,'es','Debe DESCONTABILIZAR primero si quiere guardar cambios de item linea',0),(336995,9361,'de','Sie mÃ¼ssen zuerst UNPOST wenn Sie Einzelposten Ã„nderungen speichern mÃ¶chten.',0),(336996,9361,'en','You must UNPOST first if you want to save line item changes.',0),(336997,9362,'is','',0),(336998,9362,'dr','ØªØ±Ø§Ø² Ø¨Ù†Ø¯ÙŠ  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(336999,9362,'pr','ØªØ±Ø§Ø² Ø¨Ù†Ø¯ÙŠ  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(337000,9362,'tr','Stok yeniden dÃ¼zenlenmesi',0),(337001,9362,'pl','Przegrupowanie zapasÃ³w',0),(337002,9362,'bg','ÐŸÑ€ÐµÑƒÑÑ‚Ñ€Ð¾Ð¹ÑÑ‚Ð²Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(337003,9362,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø±ÛŒØ§Ù„Ø§Ú¯Ù†Ù…Ø§Ù†Ù¹',0),(337004,9362,'sr','Ð ÐµÐ¾Ñ€Ð³Ð°Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(337005,9362,'vi','CÃ¢n Äá»‘i HÃ ng',0),(337006,9362,'af','Inventaris herbelyning',0),(337007,9362,'ro','Inventar realiniere',0),(337008,9362,'et','Varude Ã¼mberkavandamine',0),(337009,9362,'si','Zaloge preureditve',0),(337010,9362,'ba','Mereposisi persediaan',0),(337011,9362,'nl','Inventaris herschikking',0),(337012,9362,'fi','Varaston uudelleen suuntaaminen',0),(337013,9362,'no','Lager omstilling',0),(337014,9362,'da','Lageret kursjustering',0),(337015,9362,'ko','ìž¬ê³  ìž¬ë°°ì¹˜',0),(337016,9362,'he','×ž×œ××™ ×”×”×ª×›× ×¡×•×ª',0),(337017,9362,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÏ€Î±Î½ÎµÏ…Î¸Ï…Î³ÏÎ¬Î¼Î¼Î¹ÏƒÎ·',0),(337018,9362,'zh','åº“å­˜é‡æ•´\r\n',0),(337019,9362,'sv','Inventering utrÃ¤tning',0),(337020,9362,'it','Riallineamento di inventario',0),(337021,9362,'tl','',0),(337022,9362,'th','Inventory Realignment',0),(337023,9362,'hi','à¤®à¤¾à¤² à¤«à¤¿à¤° à¤¸à¥‡ à¤¸à¤‚à¤—à¤ à¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(337024,9362,'ms','Penjajaran inventori',0),(337025,9362,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªÙ†Ø¸ÙŠÙ… Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ø±Ø¯',0),(337026,9362,'fr','RÃ©alignement de lâ€™inventaire',0),(337027,9362,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®å†ç·¨æˆ',0),(337028,9362,'pt','Realinhamento de inventÃ¡rio',0),(337029,9362,'ru','Ð ÐµÐ¾Ñ€Ð³Ð°Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(337030,9362,'es','ReorganizaciÃ³n de Inventario',0),(337031,9362,'de','Inventar-Neuausrichtung',0),(337032,9362,'en','Inventory Realignment',0),(337033,9363,'is','',0),(337034,9363,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(337035,9363,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(337036,9363,'tr','PO gÃ¼ncelleÅŸtirme iÅŸlemi baÅŸarÄ±sÄ±z oldu',0),(337037,9363,'pl','PO aktualizacji nie powiodÅ‚o siÄ™',0),(337038,9363,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° PO',0),(337039,9363,'ur','Ù¾Ùˆ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(337040,9363,'sr','ÐŸÐž Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(337041,9363,'vi','Cáº­p Nháº­t ÄÆ¡n Mua HÃ ng tháº¥t báº¡i',0),(337042,9363,'af','AB Opdateer het Gefaal',0),(337043,9363,'ro','PO Update nu a reuÈ™it',0),(337044,9363,'et','PO vÃ¤rskendamine nurjus',0),(337045,9363,'si','PO posodobitev ni uspela',0),(337046,9363,'ba','Gagal Update PO',0),(337047,9363,'nl','PO-Update mislukt',0),(337048,9363,'fi','PO pÃ¤ivitys epÃ¤onnistui',0),(337049,9363,'no','PO oppdateringen mislyktes',0),(337050,9363,'da','PO opdatering mislykkedes',0),(337051,9363,'ko','í¬ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(337052,9363,'he','×¤×• ×”×¢×“×›×•×Ÿ × ×›×©×œ',0),(337053,9363,'el','PO ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(337054,9363,'zh','è®¢å•æ›´æ–°å¤±è´¥\r\n',0),(337055,9363,'sv','PO uppdateringen misslyckades',0),(337056,9363,'it','PO di aggiornamento non riuscito',0),(337057,9363,'tl','',0),(337058,9363,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3621;&#3657;&#3617;&#3648;&#3627;&#3621;&#3623;',0),(337059,9363,'hi','PO à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(337060,9363,'ms','Kemas kini PO yang gagal',0),(337061,9363,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø¨Ùˆ',0),(337062,9363,'fr','Mise Ã  jour de PO a Ã©chouÃ©',0),(337063,9363,'jp','PO ã‚’æ›´æ–°ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(337064,9363,'pt','Falhado na atualizaÃ§Ã£o PO',0),(337065,9363,'ru','Ð¡Ð±Ð¾Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ PO',0),(337066,9363,'es','OC ActualizaciÃ³n FallÃ³',0),(337067,9363,'de','PO-Update fehlgeschlagen',0),(337068,9363,'en','PO Update Failed',0),(337069,9364,'is','',0),(337070,9364,'dr','Ø§Ø±Ø² ÙƒØ§Ù†Ø§Ø¯Ø§',0),(337071,9364,'pr','Ø§Ø±Ø² ÙƒØ§Ù†Ø§Ø¯Ø§',0),(337072,9364,'tr','Kanada para birimi',0),(337073,9364,'pl','WalutÄ… jest Dolar kanadyjski',0),(337074,9364,'bg','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ°Ñ‚Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(337075,9364,'ur','Ú©ÛŒÙ†ÛŒÚˆØ§ Ú©ÛŒ Ú©Ø±Ù†Ø³ÛŒ',0),(337076,9364,'sr','ÐšÐ°Ð½Ð°Ð´ÑÐºÐµ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(337077,9364,'vi','Tiá»n Canada',0),(337078,9364,'af','Kanadese Geldeenheid',0),(337079,9364,'ro','MonedÄƒ canadianÄƒ',0),(337080,9364,'et','Kanada valuuta',0),(337081,9364,'si','Kanadski valute',0),(337082,9364,'ba','Mata uang Kanada',0),(337083,9364,'nl','Canadese dollar',0),(337084,9364,'fi','Kanadan valuutta',0),(337085,9364,'no','Kanadiske valuta',0),(337086,9364,'da','Canadisk valuta',0),(337087,9364,'ko','ìºë‚˜ë‹¤ í†µí™”',0),(337088,9364,'he','×”×ž×˜×‘×¢ ×”×§× ×“×™',0),(337089,9364,'el','ÎšÎ±Î½Î±Î´Î¹ÎºÏŒ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(337090,9364,'zh','åŠ æ‹¿å¤§çš„è´§å¸\r\n',0),(337091,9364,'sv','Kanadensiska valutan',0),(337092,9364,'it','Valuta canadese',0),(337093,9364,'tl','',0),(337094,9364,'th','&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;&#3649;&#3588;&#3609;&#3634;&#3604;&#3634;',0),(337095,9364,'hi','à¤•à¤¨à¤¾à¤¡à¤¾ à¤•à¥€ à¤®à¥à¤¦à¥à¤°à¤¾',0),(337096,9364,'ms','Mata Wang Kanada',0),(337097,9364,'ar','Ø§Ù„Ø¹Ù…Ù„Ø© Ø§Ù„ÙƒÙ†Ø¯ÙŠØ©',0),(337098,9364,'fr','Monnaie canadienne',0),(337099,9364,'jp','ã‚«ãƒŠãƒ€ã®é€šè²¨',0),(337100,9364,'pt','Moeda canadense',0),(337101,9364,'ru','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ°Ñ Ð’Ð°Ð»ÑŽÑ‚Ð°',0),(337102,9364,'es','Divisa Canadiense',0),(337103,9364,'de','Kanadische WÃ¤hrung',0),(337104,9364,'en','Canadian Currency',0),(337105,9365,'is','',0),(337106,9365,'dr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ¯Ø§Ù… ',0),(337107,9365,'pr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ¯Ø§Ù… ',0),(337108,9365,'tr','Show',0),(337109,9365,'pl','PokaÅ¼ co',0),(337110,9365,'bg','ÐšÐ¾Ð¸Ñ‚Ð¾ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚',0),(337111,9365,'ur','Ø¬Ø³ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(337112,9365,'sr','ÐšÐ¾Ñ˜Ð¸ Ð¿Ð¾ÐºÐ°Ð·ÑƒÑ˜Ñƒ',0),(337113,9365,'vi','Hiá»ƒn thá»‹ cÃ¡i nÃ o',0),(337114,9365,'af','Wys wat',0),(337115,9365,'ro','Care AratÄƒ',0),(337116,9365,'et','NÃ¤ita, mis',0),(337117,9365,'si','Razstava, ki',0),(337118,9365,'ba','Show yang',0),(337119,9365,'nl','Show die',0),(337120,9365,'fi','Show joka',0),(337121,9365,'no','Vis som',0),(337122,9365,'da','Vis som',0),(337123,9365,'ko','ì‡¼',0),(337124,9365,'he','×”×¦×’ ××ª ××©×¨',0),(337125,9365,'el','Show Ï€Î¿Ï…',0),(337126,9365,'zh','æ˜¾ç¤ºå“ªäº›\r\n',0),(337127,9365,'sv','Visa som',0),(337128,9365,'it','Show che',0),(337129,9365,'tl','',0),(337130,9365,'th','&#3649;&#3626;&#3604;&#3591;&#3629;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(337131,9365,'hi','à¤œà¥‹ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(337132,9365,'ms','Menunjukkan yang',0),(337133,9365,'ar','ÙˆØªØ¸Ù‡Ø± ÙÙŠÙ‡Ø§',0),(337134,9365,'fr','Show qui',0),(337135,9365,'jp','ã‚·ãƒ§ãƒ¼ã¯',0),(337136,9365,'pt','Mostrar que',0),(337137,9365,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐšÐ°ÐºÐ¾Ðµ',0),(337138,9365,'es','Muestra Cual',0),(337139,9365,'de','Zeigen Sie, die',0),(337140,9365,'en','Show Which',0),(337141,9366,'is','',0),(337142,9366,'dr','Ù¾ÙˆÙ„ Ø±Ø§ÙŠØ¬ Ø¢Ù…Ø±ÙŠÙƒØ§',0),(337143,9366,'pr','Ù¾ÙˆÙ„ Ø±Ø§ÙŠØ¬ Ø¢Ù…Ø±ÙŠÙƒØ§',0),(337144,9366,'tr','ABD para birimi',0),(337145,9366,'pl','Waluty amerykaÅ„skiej',0),(337146,9366,'bg','ÐÐ¼ÐµÑ€Ð¸ÐºÐ°Ð½ÑÐºÐ°Ñ‚Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(337147,9366,'ur','Ø§Ù…Ø±ÛŒÚ©ÛŒ Ú©Ø±Ù†Ø³ÛŒ',0),(337148,9366,'sr','ÐÐœÐ•Ð Ð˜Ð§ÐšÐ£ Ð²Ð°Ð»ÑƒÑ‚Ñƒ',0),(337149,9366,'vi','Tiá»n US',0),(337150,9366,'af','VSA Geldeenheid',0),(337151,9366,'ro','Moneda SUA',0),(337152,9366,'et','USA valuuta',0),(337153,9366,'si','AMERIÅ KE valute',0),(337154,9366,'ba','Mata uang AS',0),(337155,9366,'nl','Amerikaanse munt',0),(337156,9366,'fi','Yhdysvaltain valuutan',0),(337157,9366,'no','Amerikanske valutaen',0),(337158,9366,'da','Amerikanske valuta',0),(337159,9366,'ko','ë¯¸êµ­ í†µí™”',0),(337160,9366,'he','×ž×˜×‘×¢ ××¨×”\"×‘',0),(337161,9366,'el','ÎÏŒÎ¼Î¹ÏƒÎ¼Î± Ï„Ï‰Î½ Î—Î Î‘',0),(337162,9366,'zh','ç¾Žå›½è´§å¸\r\n',0),(337163,9366,'sv','Amerikanska valutan',0),(337164,9366,'it','Valuta degli Stati Uniti',0),(337165,9366,'tl','',0),(337166,9366,'th','&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609; US',0),(337167,9366,'hi','à¤…à¤®à¥‡à¤°à¤¿à¤•à¥€ à¤®à¥à¤¦à¥à¤°à¤¾',0),(337168,9366,'ms','Mata Wang AS',0),(337169,9366,'ar','Ø§Ù„Ø¹Ù…Ù„Ø© Ø§Ù„Ø£Ù…Ø±ÙŠÙƒÙŠØ©',0),(337170,9366,'fr','Devise amÃ©ricaine',0),(337171,9366,'jp','ç±³å›½ã®é€šè²¨',0),(337172,9366,'pt','Moeda americana',0),(337173,9366,'ru','Ð’Ð°Ð»ÑŽÑ‚Ð° Ð¡Ð¨Ð',0),(337174,9366,'es','Divisa EEUU',0),(337175,9366,'de','US-WÃ¤hrung',0),(337176,9366,'en','US Currency',0),(337177,9367,'is','',0),(337178,9367,'dr','Ø³Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(337179,9367,'pr','Ø³Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(337180,9367,'tr','Zaman giriÅŸ servis sipariÅŸi iÃ§in sipariÅŸ',0),(337181,9367,'pl','ZamawiaÄ‡ czas wejÅ›cia dla zlecenia serwisowego',0),(337182,9367,'bg','ÐžÑÑŠÐ¶Ð´Ð° Ð²Ñ€ÐµÐ¼Ðµ Ð·Ð°Ð¿Ð¸ÑÑŠÑ‚ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(337183,9367,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ ÙˆÙ‚Øª Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Ø§ Ø­Ú©Ù… Ø¯Û’ Ø¯ÛŒØ§',0),(337184,9367,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸Ð¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð° Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(337185,9367,'vi','Nháº­p thá»i gian Ä‘áº·t hÃ ng cho má»™t Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(337186,9367,'af','Bestelde Tydinskrywing vir Diensbestelling',0),(337187,9367,'ro','Comandate timp intrarea pentru comanda de Service',0),(337188,9367,'et','Tellitud rÃ¼hmatreeningutes hooldustellimuse eest',0),(337189,9367,'si','NaloÅ¾i vnos Äasa za servisni nalog',0),(337190,9367,'ba','Memerintahkan kali masuk untuk Service Order',0),(337191,9367,'nl','Tijd post besteld voor serviceorder',0),(337192,9367,'fi','MÃ¤Ã¤rÃ¤si aikamerkintÃ¤ huoltotilaukselle',0),(337193,9367,'no','Bestilte tidsoppfÃ¸ring for serviceordren',0),(337194,9367,'da','Bestilt tid posten for serviceordre',0),(337195,9367,'ko','ì„œë¹„ìŠ¤ ì˜¤ë”ì— ëŒ€ í•œ ì‹œê°„ í•­ëª©ì„ ì£¼ë¬¸',0),(337196,9367,'he','×”×•×¨×” ×”×–× ×ª ×–×ž× ×™× ×¢×‘×•×¨ ×”×–×ž× ×ª ×©×™×¨×•×ª',0),(337197,9367,'el','Î”Î¹Î­Ï„Î±Î¾Îµ Ï‡ÏÏŒÎ½Î¿ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î³Î¹Î± ÎµÎ½Ï„Î¿Î»Î® Ï„/Ï…',0),(337198,9367,'zh','æœåŠ¡è®¢å•çš„æœ‰åºæ—¶é—´è¾“å…¥\r\n',0),(337199,9367,'sv','BestÃ¤llde tid posten fÃ¶r serviceorder',0),(337200,9367,'it','Ordinato la voce ora per ordine di servizio',0),(337201,9367,'tl','',0),(337202,9367,'th','&#3648;&#3623;&#3621;&#3634;&#3611;&#3657;&#3629;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3594;&#3639;&#3657;&#3',0),(337203,9367,'hi','à¤¸à¤®à¤¯ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤',0),(337204,9367,'ms','Telah masuk waktu pesanan Perkhidmatan',0),(337205,9367,'ar','Ø£Ù…Ø± Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„ÙˆÙ‚Øª Ù„Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(337206,9367,'fr','ClassÃ©s en temps entrÃ©e pour commande de Service',0),(337207,9367,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã®æ™‚é–“ã‚¨ãƒ³ãƒˆãƒªã‚’æ³¨æ–‡',0),(337208,9367,'pt','Ordenou a entrada do tempo para a ordem de serviÃ§o',0),(337209,9367,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ð» Ð²Ð²Ð¾Ð´ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð´Ð»Ñ ÑÐµÑ€Ð²Ð¸ÑÐ½Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(337210,9367,'es','Entrada de Tiempo de Orden para Orden de Servicio',0),(337211,9367,'de','Zeiterfassung fÃ¼r Serviceauftrag bestellt',0),(337212,9367,'en','Ordered Time Entry for Service Order',0),(337213,9368,'is','',0),(337214,9368,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ',0),(337215,9368,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ',0),(337216,9368,'tr','Kredi raporu',0),(337217,9368,'pl','Raport z kredytÃ³w',0),(337218,9368,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(337219,9368,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ø±Ù¾ÙˆØ±Ù¹',0),(337220,9368,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸Ð¼Ð°',0),(337221,9368,'vi','BÃ¡o CÃ¡o TÃ­n Dá»¥ng',0),(337222,9368,'af','Verslag van Krediete',0),(337223,9368,'ro','Raportul credite',0),(337224,9368,'et','Krediidi aruanne',0),(337225,9368,'si','Krediti poroÄilo',0),(337226,9368,'ba','Laporan kredit',0),(337227,9368,'nl','Verslag van de kredieten',0),(337228,9368,'fi','Luottojen raportti',0),(337229,9368,'no','Kreditt rapporten',0),(337230,9368,'da','Credits rapport',0),(337231,9368,'ko','ì‹ ìš© ë³´ê³ ì„œ',0),(337232,9368,'he','×§×¨×“×™×˜×™× ×—',0),(337233,9368,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï€Î¹ÏƒÏ„ÏŽÏƒÎµÎ¹Ï‚',0),(337234,9368,'zh','ä¿¡ç”¨æŠ¥å‘Š\r\n',0),(337235,9368,'sv','HP rapport',0),(337236,9368,'it','Report di crediti',0),(337237,9368,'tl','',0),(337238,9368,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(337239,9368,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(337240,9368,'ms','Laporan kredit',0),(337241,9368,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø§Ø¹ØªÙ…Ø§Ø¯Ø§Øª',0),(337242,9368,'fr','Rapport de CrÃ©dits',0),(337243,9368,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ãƒ¬ãƒãƒ¼ãƒˆ',0),(337244,9368,'pt','RelatÃ³rio de crÃ©ditos',0),(337245,9368,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¹ ÐžÑ‚Ñ‡ÐµÑ‚',0),(337246,9368,'es','Informe de CrÃ©ditos',0),(337247,9368,'de','Credits-Bericht',0),(337248,9368,'en','Credits Report',0),(337249,9369,'is','',0),(337250,9369,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ± ',0),(337251,9369,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ± ',0),(337252,9369,'tr','Fatura Ã–zet raporu',0),(337253,9369,'pl','Raport Podsumowanie faktury',0),(337254,9369,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(337255,9369,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø®Ù„Ø§ØµÛ Ø±Ù¾ÙˆØ±Ù¹',0),(337256,9369,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÑÐ° Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ¾Ð¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(337257,9369,'vi','BÃ¡o cÃ¡o tá»•ng há»£p hÃ³a Ä‘Æ¡n',0),(337258,9369,'af','Faktuur Opsommingsverslag',0),(337259,9369,'ro','Raport facturi',0),(337260,9369,'et','Arve koondaruanne',0),(337261,9369,'si','PoroÄilo raÄuna',0),(337262,9369,'ba','Laporan ringkasan faktur',0),(337263,9369,'nl','Samenvatting factuurrapport',0),(337264,9369,'fi','Laskun yhteenvetoraportti',0),(337265,9369,'no','Faktura sammendragsrapport',0),(337266,9369,'da','Faktura sammenfattende rapport',0),(337267,9369,'ko','ì†¡ìž¥ ìš”ì•½ ë³´ê³ ì„œ',0),(337268,9369,'he','×“×•×— ×¡×™×›×•× ×—×©×‘×•× ×™×ª',0),(337269,9369,'el','Î£Ï…Î½Î¿Ï€Ï„Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(337270,9369,'zh','å‘ç¥¨æ‘˜è¦æŠ¥å‘Š\r\n',0),(337271,9369,'sv','Sammanfattningsrapport fÃ¶r faktura',0),(337272,9369,'it','Report di riepilogo fattura',0),(337273,9369,'tl','',0),(337274,9369,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3626;&#3619;&#3640;&#3611;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(337275,9369,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(337276,9369,'ms','Laporan rumusan invois',0),(337277,9369,'ar','ØªÙ‚Ø±ÙŠØ± Ù…Ù„Ø®Øµ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(337278,9369,'fr','Rapport AbbrÃ©gÃ© de Facture',0),(337279,9369,'jp','è«‹æ±‚æ›¸ã®æ¦‚è¦ãƒ¬ãƒãƒ¼ãƒˆ',0),(337280,9369,'pt','RelatÃ³rio resumido de factura',0),(337281,9369,'ru','Ð¡Ð²Ð¾Ð´Ð½Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(337282,9369,'es','Informe Sumario de Facturas',0),(337283,9369,'de','Zusammenfassender Rechnungsbericht',0),(337284,9369,'en','Invoice Summary Report',0),(337285,9370,'is','',0),(337286,9370,'dr','(Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ) Ø§Ø¹ØªØ¨Ø§Ø±Ø§Øª',0),(337287,9370,'pr','Ù„ÙŠØ³Øª(Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ) Ø§Ø¹ØªØ¨Ø§Ø±Ø§Øª',0),(337288,9370,'tr','Kredi listesi',0),(337289,9370,'pl','Lista kredytÃ³w',0),(337290,9370,'bg','ÐÐ°Ð´Ð¿Ð¸ÑÐ¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(337291,9370,'ur','Ú©Ø±ÛŒÚˆÛŒÙ¹Ø³ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(337292,9370,'sr','Ð¨Ð¿Ð¸Ñ†Ð° Ð»Ð¸ÑÑ‚Ð°',0),(337293,9370,'vi','Danh SÃ¡ch TÃ­n Dá»¥ng',0),(337294,9370,'af','Kredietelys',0),(337295,9370,'ro','Lista credite',0),(337296,9370,'et','Autorid lisanud',0),(337297,9370,'si','Krediti seznam',0),(337298,9370,'ba','Daftar kredit',0),(337299,9370,'nl','Lijst van de kredieten',0),(337300,9370,'fi','Luottojen luettelo',0),(337301,9370,'no','Kreditt liste',0),(337302,9370,'da','Credits liste',0),(337303,9370,'ko','í¬ë ˆë”§ ëª©ë¡',0),(337304,9370,'he','×¨×©×™×ž×ª ×§×¨×“×™×˜×™×',0),(337305,9370,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(337306,9370,'zh','ç§¯åˆ†è¡¨\r\n',0),(337307,9370,'sv','Credits listan',0),(337308,9370,'it','Elenco di crediti',0),(337309,9370,'tl','',0),(337310,9370,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(337311,9370,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¸à¥‚à¤šà¥€',0),(337312,9370,'ms','Senarai penghargaan',0),(337313,9370,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø§Ø¹ØªÙ…Ø§Ø¯Ø§Øª',0),(337314,9370,'fr','Liste des crÃ©dits',0),(337315,9370,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆä¸€è¦§',0),(337316,9370,'pt','Lista de crÃ©ditos',0),(337317,9370,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ð²',0),(337318,9370,'es','Lista de CrÃ©ditos',0),(337319,9370,'de','Credits-Liste',0),(337320,9370,'en','Credits List',0),(337321,9371,'is','',0),(337322,9371,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª ÙÙ‚Ø· Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(337323,9371,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª ÙÙ‚Ø· Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(337324,9371,'tr','Ãœzerinde tutun sadece Ã¶demek iÃ§in onay',0),(337325,9371,'pl','Zaznacz, aby pÅ‚aciÄ‡ tylko przytrzymaj klawisz',0),(337326,9371,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð¿Ð¾-Ð½Ð¸ÑÐºÐ° ÑÐ°Ð¼Ð¾',0),(337327,9371,'ur','Ù¾Ø± Ù¾Ú©Ú‘ ØµØ±Ù Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(337328,9371,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´Ð° Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð° Ð´Ñ€Ð¶Ð¸ ÑÐ°Ð¼Ð¾',0),(337329,9371,'vi','ÄÃ¡nh dáº¥u Ä‘á»ƒ thanh toÃ¡n táº¡m ngÆ°ng',0),(337330,9371,'af','Kontroleer om te betaal op-hou net',0),(337331,9371,'ro','Check sÄƒ plÄƒteascÄƒ pe-Hold numai',0),(337332,9371,'et','Vaadata On-Hold ainult maksma',0),(337333,9371,'si','Preveri plaÄilo na drÅ¾i le',0),(337334,9371,'ba','Periksa untuk membayar pada terus hanya',0),(337335,9371,'nl','Selectievakje On-Hold alleen betalen',0),(337336,9371,'fi','Tarkistaa maksamaan vain pidossa',0),(337337,9371,'no','Sjekk for Ã¥ betale pÃ¥ Hold bare',0),(337338,9371,'da','Check til at betale pÃ¥ Hold kun',0),(337339,9371,'ko','ëŒ€ê¸°ë§Œ ì§€ë¶ˆ í™•ì¸',0),(337340,9371,'he','×›×“×™ ×œ×©×œ× ×¢×œ-×œ×”×—×–×™×§ ×¨×§ ×œ×‘×“×•×§',0),(337341,9371,'el','Î•Î»Î­Î³Ï‡Î¿Ï… Î½Î± Ï€Î»Î·ÏÏŽÏƒÎµÏ„Îµ On-Hold, Î¼ÏŒÎ½Î¿',0),(337342,9371,'zh','æ”¯ç¥¨æ”¯ä»˜ä¸Šåªä¿ç•™\r\n',0),(337343,9371,'sv','Check fÃ¶r att betala pÃ¥ HÃ¥ll bara',0),(337344,9371,'it','Assegno per pagare in attesa solo',0),(337345,9371,'tl','',0),(337346,9371,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(337347,9371,'hi','à¤ªà¤° à¤ªà¤•à¤¡à¤¼ à¤•à¥‡à¤µà¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(337348,9371,'ms','Semak untuk membayar pada mengadakan hanya',0),(337349,9371,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø£Ù† ØªØ¯ÙØ¹ ÙÙŠ Ø§Ù„Ø§Ù†ØªØ¸Ø§Ø± ÙÙ‚Ø·',0),(337350,9371,'fr','ChÃ¨que Ã  payer en attente seulement',0),(337351,9371,'jp','ä¿ç•™ã®ã¿ã‚’æ”¯æ‰•ã†ã“ã¨ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(337352,9371,'pt','Cheque para pagar em espera apenas',0),(337353,9371,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð½Ð° ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ðµ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(337354,9371,'es','Cheque de Pagar Solamente En Espera',0),(337355,9371,'de','Warteschleifen-nur Zahlen Ã¼berprÃ¼fen',0),(337356,9371,'en','Check to Pay On-Hold Only',0),(337357,9372,'is','',0),(337358,9372,'dr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ   ',0),(337359,9372,'pr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ   ',0),(337360,9372,'tr','B2B sipariÅŸlerdeki blok kullanÄ±mÄ±',0),(337361,9372,'pl','UÅ¼ycie bloku na zamÃ³wienia B2B',0),(337362,9372,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð±Ð»Ð¾Ðº Ð½Ð° B2B Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(337363,9372,'ur','B2B Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ø¨Ù„Ø§Ú© Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(337364,9372,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð±Ð»Ð¾Ðº Ð‘2Ð‘ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(337365,9372,'vi','Khá»‘i sá»­ dá»¥ng trÃªn ÄÆ¡n Äáº·t HÃ ng B2B',0),(337366,9372,'af','Blokeer die Gebruik op B2B Bestellings',0),(337367,9372,'ro','Bloc de utilizare pe ordinele de B2B',0),(337368,9372,'et','Grupierandi kasutamine B2B tellimuste',0),(337369,9372,'si','Blok navada na B2B naroÄila',0),(337370,9372,'ba','Tutup Penggunaan Pesanan pada B2B',0),(337371,9372,'nl','Blok gebruik op B2B bestellingen',0),(337372,9372,'fi','EstÃ¤ kÃ¤yttÃ¶ B2B tilaukset',0),(337373,9372,'no','Blokkere bruk pÃ¥ B2B ordrer',0),(337374,9372,'da','Blok skik pÃ¥ B2B ordrer',0),(337375,9372,'ko','B2B ì£¼ë¬¸ì— ë¸”ë¡ ì‚¬ìš©',0),(337376,9372,'he','×œ×—×¡×•× ×©×™×ž×•×© ×‘×¤×§×•×“×ª B2B',0),(337377,9372,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¹ÏƒÎ¼ÏŒÏ‚ Ï‡ÏÎ®ÏƒÎ·Ï‚ Î³Î¹Î± B2B Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(337378,9372,'zh','å°é”å¯¹å•†ä¸šå¯¹å•†ä¸šå‘½ä»¤çš„ä½¿ç”¨\r\n',0),(337379,9372,'sv','Block-anvÃ¤ndning pÃ¥ B2B order',0),(337380,9372,'it','Utilizzo di blocco su ordini B2B',0),(337381,9372,'tl','',0),(337382,9372,'th','&#3585;&#3634;&#3619;&#3610;&#3621;&#3655;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591; B2B ',0),(337383,9372,'hi','B2B à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤¬à¥à¤²à¥‰à¤• à¤•à¥‡ à¤‰à¤ªà¤¯à¥‹à¤—',0),(337384,9372,'ms','Penggunaan blok pada B2B pesanan',0),(337385,9372,'ar','Ù…Ù†Ø¹ Ø§Ù„Ø¥Ø³ØªØ¹Ù…Ø§Ù„ ÙÙŠ Ø·Ù„Ø¨ÙŠØ§Øª Ø§Ù„Ù€ B2B',0),(337386,9372,'fr','Utilisation du bloc sur commandes B2B',0),(337387,9372,'jp','B2B å—æ³¨ãƒ–ãƒ­ãƒƒã‚¯ä½¿ç”¨é‡',0),(337388,9372,'pt','Uso de bloco em B2B pedidos',0),(337389,9372,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð±Ð»Ð¾ÐºÐ° Ð½Ð° B2B Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(337390,9372,'es','Bloquea Uso de Pedidos de N2N',0),(337391,9372,'de','Block-Nutzung auf B2B Bestellungen',0),(337392,9372,'en','Block Usage on B2B&nbsp;Orders',0),(337393,9373,'is','',0),(337394,9373,'dr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´',0),(337395,9373,'pr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´',0),(337396,9373,'tr','Blok kullanÄ±mÄ± POS sipariÅŸler',0),(337397,9373,'pl','UÅ¼ycie bloku na POS zamÃ³wieÅ„',0),(337398,9373,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð±Ð»Ð¾Ðº Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÐŸÐžÐ¡',0),(337399,9373,'ur','Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ø¨Ù„Ø§Ú© Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(337400,9373,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð±Ð»Ð¾Ðº Ð½Ð° ÐŸÐžÐ¡ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(337401,9373,'vi','Khá»‘i sá»­ dá»¥ng trÃªn ÄÆ¡n Äáº·t HÃ ng POS',0),(337402,9373,'af','Blokeer die Gebruik op PVV (\"POS\") Bestellings',0),(337403,9373,'ro','Bloc de utilizare POS comenzi',0),(337404,9373,'et','Grupierandi kasutamine POS tellimustele',0),(337405,9373,'si','Blok navada na nalogi POS',0),(337406,9373,'ba','Tutup Penggunaan pada Pesanan POS',0),(337407,9373,'nl','Blok zede voort POS Orders',0),(337408,9373,'fi','EstÃ¤ kÃ¤yttÃ¶ POS tilauksia',0),(337409,9373,'no','Blokkere bruk POS ordrer',0),(337410,9373,'da','Blok skik pÃ¥ POS ordrer',0),(337411,9373,'ko','í¬ìŠ¤ ì£¼ë¬¸ì— ë¸”ë¡ ì‚¬ìš©',0),(337412,9373,'he','×œ×—×¡×•× ×©×™×ž×•×© ×‘×¤×§×•×“×ª POS',0),(337413,9373,'el','Î§ÏÎ®ÏƒÎ· POS ÎµÎ½Ï„Î¿Î»Î­Ï‚ Î¼Ï€Î»Î¿Îº',0),(337414,9373,'zh','å°é”åœ¨é”€å”®ç‚¹è®¢å•çš„ä½¿ç”¨\r\n',0),(337415,9373,'sv','Block-anvÃ¤ndning pÃ¥ POS order',0),(337416,9373,'it','Utilizzo di blocco su ordini di POS',0),(337417,9373,'tl','',0),(337418,9373,'th','&#3585;&#3634;&#3619;&#3610;&#3621;&#3655;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591; &#3603; &#3592;&#3640;&#3604;&#3586;&#3634;&#3618;',0),(337419,9373,'hi','POS à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¥‹ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤‚à¤§à¤¿à¤¤',0),(337420,9373,'ms','Penggunaan blok pada pesanan POS',0),(337421,9373,'ar','Ù…Ù†Ø¹ Ø§Ù„Ø¥Ø³ØªØ¹Ù…Ø§Ù„ ÙÙŠ Ø·Ù„Ø¨ÙŠØ§Øª Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(337422,9373,'fr','Utilisation de bloc sur les ordres de POS',0),(337423,9373,'jp','POS å‘½ä»¤ã§ãƒ–ãƒ­ãƒƒã‚¯ä½¿ç”¨é‡',0),(337424,9373,'pt','Uso de bloco em ordens de POS',0),(337425,9373,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð±Ð»Ð¾ÐºÐ° Ð¿Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°Ð¼ POS',0),(337426,9373,'es','Bloquea Uso de Pedidos de PDV',0),(337427,9373,'de','Block-Nutzung auf POS AuftrÃ¤ge',0),(337428,9373,'en','Block Usage on POS&nbsp;Orders',0),(337429,9374,'is','',0),(337430,9374,'dr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(337431,9374,'pr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ¬Ø§Ø±Øª Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(337432,9374,'tr','B2B sipariÅŸlerdeki blok kullanÄ±mÄ±',0),(337433,9374,'pl','UÅ¼ycie bloku na zamÃ³wienia B2B',0),(337434,9374,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð±Ð»Ð¾Ðº Ð½Ð° B2B Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(337435,9374,'ur','B2B Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ø¨Ù„Ø§Ú© Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(337436,9374,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð±Ð»Ð¾Ðº Ð‘2Ð‘ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(337437,9374,'vi','Khá»‘i sá»­ dá»¥ng trÃªn ÄÆ¡n Äáº·t HÃ ng B2B',0),(337438,9374,'af','Blokeer die Gebruik Op B2B Bestellings',0),(337439,9374,'ro','Bloc de utilizare pe ordinele de B2B',0),(337440,9374,'et','Grupierandi kasutamine B2B tellimuste',0),(337441,9374,'si','Blok navada na B2B naroÄila',0),(337442,9374,'ba','Tutup Penggunaan Pesanan B2B',0),(337443,9374,'nl','Blok gebruik op B2B bestellingen',0),(337444,9374,'fi','EstÃ¤ kÃ¤yttÃ¶ B2B tilaukset',0),(337445,9374,'no','Blokkere bruk pÃ¥ B2B ordrer',0),(337446,9374,'da','Blok skik pÃ¥ B2B ordrer',0),(337447,9374,'ko','B2B ì£¼ë¬¸ì— ë¸”ë¡ ì‚¬ìš©',0),(337448,9374,'he','×œ×—×¡×•× ×©×™×ž×•×© ×‘×¤×§×•×“×ª B2B',0),(337449,9374,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¹ÏƒÎ¼ÏŒÏ‚ Ï‡ÏÎ®ÏƒÎ·Ï‚ Î³Î¹Î± B2B Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(337450,9374,'zh','å°é”å¯¹å•†ä¸šå¯¹å•†ä¸šè®¢å•çš„ä½¿ç”¨\r\n',0),(337451,9374,'sv','Block-anvÃ¤ndning pÃ¥ B2B order',0),(337452,9374,'it','Utilizzo di blocco su ordini B2B',0),(337453,9374,'tl','',0),(337454,9374,'th','&#3585;&#3634;&#3619;&#3610;&#3621;&#3655;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591; B2B ',0),(337455,9374,'hi','B2B à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤¬à¥à¤²à¥‰à¤• à¤•à¥‡ à¤‰à¤ªà¤¯à¥‹à¤—',0),(337456,9374,'ms','Penggunaan blok pada B2B pesanan',0),(337457,9374,'ar','Ù…Ù†Ø¹ Ø§Ù„Ø¥Ø³ØªØ¹Ù…Ø§Ù„ ÙÙŠ Ø·Ù„Ø¨ÙŠØ§Øª Ø§Ù„Ù€ B2B',0),(337458,9374,'fr','Utilisation du bloc sur commandes B2B',0),(337459,9374,'jp','B2B å—æ³¨ãƒ–ãƒ­ãƒƒã‚¯ä½¿ç”¨é‡',0),(337460,9374,'pt','Uso de bloco em B2B pedidos',0),(337461,9374,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð±Ð»Ð¾ÐºÐ° Ð½Ð° B2B Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(337462,9374,'es','Bloquea Uso de Pedidos de N2N',0),(337463,9374,'de','Block-Nutzung auf B2B Bestellungen',0),(337464,9374,'en','Block Usage On B2B&nbsp;Orders',0),(337465,9375,'is','',0),(337466,9375,'dr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´',0),(337467,9375,'pr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²Ø³ÙØ§Ø±Ø´Ø§Øª Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´',0),(337468,9375,'tr','Blok kullanÄ±mÄ± POS sipariÅŸler',0),(337469,9375,'pl','UÅ¼ycie bloku na POS zamÃ³wieÅ„',0),(337470,9375,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð±Ð»Ð¾Ðº Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÐŸÐžÐ¡',0),(337471,9375,'ur','Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ø¨Ù„Ø§Ú© Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(337472,9375,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð±Ð»Ð¾Ðº Ð½Ð° ÐŸÐžÐ¡ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(337473,9375,'vi','Khá»‘i sá»­ dá»¥ng trÃªn ÄÆ¡n Äáº·t HÃ ng POS',0),(337474,9375,'af','Blokeer die Gebruik op PVV (\"POS\") Bestellings',0),(337475,9375,'ro','Bloc de utilizare POS comenzi',0),(337476,9375,'et','Grupierandi kasutamine POS tellimustele',0),(337477,9375,'si','Blok navada na nalogi POS',0),(337478,9375,'ba','Tutup penggunaan Pesanan POS',0),(337479,9375,'nl','Blok zede voort POS Orders',0),(337480,9375,'fi','EstÃ¤ kÃ¤yttÃ¶ POS tilauksia',0),(337481,9375,'no','Blokkere bruk POS ordrer',0),(337482,9375,'da','Blok skik pÃ¥ POS ordrer',0),(337483,9375,'ko','í¬ìŠ¤ ì£¼ë¬¸ì— ë¸”ë¡ ì‚¬ìš©',0),(337484,9375,'he','×œ×—×¡×•× ×©×™×ž×•×© ×‘×¤×§×•×“×ª POS',0),(337485,9375,'el','Î§ÏÎ®ÏƒÎ· POS ÎµÎ½Ï„Î¿Î»Î­Ï‚ Î¼Ï€Î»Î¿Îº',0),(337486,9375,'zh','å°é”åœ¨é”€å”®ç‚¹è®¢å•çš„ä½¿ç”¨\r\n',0),(337487,9375,'sv','Block-anvÃ¤ndning pÃ¥ POS order',0),(337488,9375,'it','Utilizzo di blocco su ordini di POS',0),(337489,9375,'tl','',0),(337490,9375,'th','&#3585;&#3634;&#3619;&#3610;&#3621;&#3655;&#3629;&#3585;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591; &#3603; &#3592;&#3640;&#3604;&#3586;&#3634;&#3618;',0),(337491,9375,'hi','POS à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¥‹ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤‚à¤§à¤¿à¤¤',0),(337492,9375,'ms','Penggunaan blok pada pesanan POS',0),(337493,9375,'ar','Ù…Ù†Ø¹ Ø§Ù„Ø¥Ø³ØªØ¹Ù…Ø§Ù„ ÙÙŠ Ø·Ù„Ø¨ÙŠØ§Øª Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(337494,9375,'fr','Utilisation de bloc sur les ordres de POS',0),(337495,9375,'jp','POS å‘½ä»¤ã§ãƒ–ãƒ­ãƒƒã‚¯ä½¿ç”¨é‡',0),(337496,9375,'pt','Uso de bloco em ordens de POS',0),(337497,9375,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð±Ð»Ð¾ÐºÐ° Ð¿Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°Ð¼ POS',0),(337498,9375,'es','Bloquea Uso de Pedidos de PDV',0),(337499,9375,'de','Block-Nutzung auf POS AuftrÃ¤ge',0),(337500,9375,'en','Block Usage On POS&nbsp;Orders',0),(337501,9376,'is','',0),(337502,9376,'dr','ÙƒØ¯ Ø§Ø¬Ø§Ø²Ù‡ Ø¨Ø§Ù†Ùƒ',0),(337503,9376,'pr','ÙƒØ¯ Ø§Ø¬Ø§Ø²Ù‡ Ø¨Ø§Ù†Ùƒ',0),(337504,9376,'tr','Banka onay kodu',0),(337505,9376,'pl','Kod autoryzacji banku',0),(337506,9376,'bg','Ð‘Ð°Ð½ÐºÐ°Ñ‚Ð° Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ ÐºÐ¾Ð´',0),(337507,9376,'ur','Ø¨ÛŒÙ†Ú© Ú©Ø§ Ø§Ø¬Ø§Ø²Øª Ù†Ø§Ù…Û Ú©ÙˆÚˆ',0),(337508,9376,'sr','Ð‘Ð°Ð½ÐºÐ° Ð°ÑƒÑ‚Ð¾Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(337509,9376,'vi','MÃ£ cáº¥p quyá»n NgÃ¢n hÃ ng',0),(337510,9376,'af','Bank Magtigingskode',0),(337511,9376,'ro','Codul de autorizare BÄƒncii',0),(337512,9376,'et','Panga kood',0),(337513,9376,'si','Banke dovoljenjem kodo',0),(337514,9376,'ba','Kode otorisasi Bank',0),(337515,9376,'nl','Code van de vergunning van de Bank',0),(337516,9376,'fi','Pankin lupa ilmaista koodikielellÃ¤',0),(337517,9376,'no','Banken autorisasjonen koden',0),(337518,9376,'da','Bank autorisationskode',0),(337519,9376,'ko','ì€í–‰ ì¸ì¦ ì½”ë“œ',0),(337520,9376,'he','×§×•×“ ××™×©×•×¨ ×”×‘× ×§',0),(337521,9376,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ ÎµÎ¾Î¿Ï…ÏƒÎ¹Î¿Î´ÏŒÏ„Î·ÏƒÎ·Ï‚',0),(337522,9376,'zh','é“¶è¡ŒæŽˆæƒç \r\n',0),(337523,9376,'sv','Bank behÃ¶righetskod',0),(337524,9376,'it','Codice di autorizzazione della banca',0),(337525,9376,'tl','',0),(337526,9376,'th','&#3619;&#3627;&#3633;&#3626;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3586;&#3629;&#3591;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(337527,9376,'hi','à¤¬à¥ˆà¤‚à¤• à¤ªà¥à¤°à¤¾à¤§à¤¿à¤•à¤°à¤£ à¤•à¥‹à¤¡',0),(337528,9376,'ms','Kod kebenaran Bank',0),(337529,9376,'ar','Ø±Ù…Ø² ØªØ®ÙˆÙŠÙ„ Ø§Ù„Ù…ØµØ±Ù',0),(337530,9376,'fr','Code dâ€™autorisation de la Banque',0),(337531,9376,'jp','éŠ€è¡Œã®èªè¨¼ã‚³ãƒ¼ãƒ‰',0),(337532,9376,'pt','CÃ³digo de autorizaÃ§Ã£o do banco',0),(337533,9376,'ru','ÐšÐ¾Ð´ ÐÐ²Ñ‚Ð¾Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð‘Ð°Ð½ÐºÐ°',0),(337534,9376,'es','CÃ³digo de AutorizaciÃ³n de Banco',0),(337535,9376,'de','Bank-Authorisierungs-Code',0),(337536,9376,'en','Bank Authorization Code',0),(337537,9377,'is','',0),(337538,9377,'dr','Ø¢Ø¯Ø±Ø³ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(337539,9377,'pr','Ø¢Ø¯Ø±Ø³ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(337540,9377,'tr','Fatura adresi',0),(337541,9377,'pl','Adres do faktury',0),(337542,9377,'bg','ÐÐ´Ñ€ÐµÑ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(337543,9377,'ur','Ø¨Ù„Ù†Ú¯ Ù¾ØªÛ',0),(337544,9377,'sr','ÐÐ´Ñ€ÐµÑÐ° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(337545,9377,'vi','Äá»‹a Chá»‰ Gá»­i HÃ³a ÄÆ¡n',0),(337546,9377,'af','Verekening (RO) Adres',0),(337547,9377,'ro','Adresa de facturare',0),(337548,9377,'et','Arve esitamise aadress',0),(337549,9377,'si','Naslov',0),(337550,9377,'ba','Alamat penagihan',0),(337551,9377,'nl','Factuuradres',0),(337552,9377,'fi','Laskutusosoite',0),(337553,9377,'no','Faktureringsadresse',0),(337554,9377,'da','Faktureringsadresse',0),(337555,9377,'ko','ì²­êµ¬ ì£¼ì†Œ',0),(337556,9377,'he','×›×ª×•×‘×ª ×—×™×•×‘',0),(337557,9377,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(337558,9377,'zh','å¸å•åœ°å€\r\n',0),(337559,9377,'sv','Faktureringsadress',0),(337560,9377,'it','Indirizzo di fatturazione',0),(337561,9377,'tl','',0),(337562,9377,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3607;&#3637;&#3656;&#3623;&#3634;&#3591;&#3610;&#3636;&#3621;',0),(337563,9377,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤ªà¤¤à¤¾',0),(337564,9377,'ms','Alamat bil',0),(337565,9377,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„ÙÙˆØªØ±Ø©',0),(337566,9377,'fr','Adresse de facturation',0),(337567,9377,'jp','è«‹æ±‚å…ˆä½æ‰€',0),(337568,9377,'pt','EndereÃ§o de facturaÃ§Ã£o',0),(337569,9377,'ru','ÐÐ´Ñ€ÐµÑ Ð´Ð»Ñ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°',0),(337570,9377,'es','DirecciÃ³n de FacturaciÃ³n',0),(337571,9377,'de','Rechnungsadresse',0),(337572,9377,'en','Billing Address',0),(337573,9378,'is','',0),(337574,9378,'dr','Ø´Ù‡Ø± ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(337575,9378,'pr','Ø´Ù‡Ø± ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(337576,9378,'tr','Fatura ÅŸehri',0),(337577,9378,'pl','Rozliczenia City',0),(337578,9378,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ, Ð³Ñ€Ð°Ð´',0),(337579,9378,'ur','Ø¨Ù„Ù†Ú¯ Ø´ÛØ±',0),(337580,9378,'sr','Ð“Ñ€Ð°Ð´ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(337581,9378,'vi','ThÃ nh Phá»‘ Gá»­i HÃ³a ÄÆ¡n',0),(337582,9378,'af','Verekening Stad/Dorp',0),(337583,9378,'ro','Facturare City',0),(337584,9378,'et','Arved City',0),(337585,9378,'si','Naslov plaÄnika â€“ mesto',0),(337586,9378,'ba','Kota penagihan',0),(337587,9378,'nl','Facturering stad',0),(337588,9378,'fi','Laskutusosoitteen postitoimipaikka',0),(337589,9378,'no','Faktureringsadresse, poststed',0),(337590,9378,'da','Fakturering byen',0),(337591,9378,'ko','ê²°ì œ ì‹œ',0),(337592,9378,'he','×¢×™×¨ ×—×™×•×‘',0),(337593,9378,'el','Î ÏŒÎ»Î· Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(337594,9378,'zh','å¸å•åŸŽå¸‚\r\n',0),(337595,9378,'sv','Fakturering staden',0),(337596,9378,'it','CittÃ  di fatturazione',0),(337597,9378,'tl','',0),(337598,9378,'th','&#3629;&#3635;&#3648;&#3616;&#3629;&#3607;&#3637;&#3656;&#3623;&#3634;&#3591;&#3610;&#3636;&#3621;',0),(337599,9378,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤¶à¤¹à¤°',0),(337600,9378,'ms','Bil bandar',0),(337601,9378,'ar','Ù…Ø¯ÙŠÙ†Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(337602,9378,'fr','Ville de facturation',0),(337603,9378,'jp','è«‹æ±‚å¸‚',0),(337604,9378,'pt','Cidade de faturamento',0),(337605,9378,'ru','Ð“Ð¾Ñ€Ð¾Ð´ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(337606,9378,'es','Ciudad de FacturaciÃ³n',0),(337607,9378,'de','Abrechnung-Stadt',0),(337608,9378,'en','Billing City',0),(337609,9379,'is','',0),(337610,9379,'dr','Ø§Ø³ØªØ§Ù† ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(337611,9379,'pr','Ø§Ø³ØªØ§Ù† ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(337612,9379,'tr','Fatura durumu',0),(337613,9379,'pl','Stan rozliczeÅ„',0),(337614,9379,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ, Ñ‰Ð°Ñ‚',0),(337615,9379,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø±ÛŒØ§Ø³Øª',0),(337616,9379,'sr','Ð¡Ñ‚Ð°ÑšÐµ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(337617,9379,'vi','Tiá»ƒu Bang Gá»­i HÃ³a ÄÆ¡n',0),(337618,9379,'af','Verekening Staat',0),(337619,9379,'ro','Stat de facturare',0),(337620,9379,'et','Arveldusaadressi osariik',0),(337621,9379,'si','Naslov plaÄnika â€“ drÅ¾ava',0),(337622,9379,'ba','Penagihan negara',0),(337623,9379,'nl','Facturering staat',0),(337624,9379,'fi','Laskutusosoitteen osavaltio',0),(337625,9379,'no','Fakturering tilstand',0),(337626,9379,'da','Fakturering stat',0),(337627,9379,'ko','ê²°ì œ ìƒíƒœ',0),(337628,9379,'he','×ž×“×™× ×ª ×—×™×•×‘',0),(337629,9379,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(337630,9379,'zh','å¸å•çŠ¶æ€\r\n',0),(337631,9379,'sv','Fakturering staten',0),(337632,9379,'it','Stato di fatturazione',0),(337633,9379,'tl','',0),(337634,9379,'th','&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;&#3607;&#3637;&#3656;&#3623;&#3634;&#3591;&#3610;&#3636;&#3621;',0),(337635,9379,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤°à¤¾à¤œà¥à¤¯',0),(337636,9379,'ms','Bil Negeri',0),(337637,9379,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(337638,9379,'fr','Ã‰tat de la facturation',0),(337639,9379,'jp','èª²é‡‘çŠ¶æ…‹',0),(337640,9379,'pt','Estado de faturamento',0),(337641,9379,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(337642,9379,'es','Estado de FacturaciÃ³n',0),(337643,9379,'de','Abrechnung-Zustand',0),(337644,9379,'en','Billing State',0),(337645,9380,'is','',0),(337646,9380,'dr','ÙƒØ¯ Ù¾Ø³ØªÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(337647,9380,'pr','ÙƒØ¯ Ù¾Ø³ØªÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(337648,9380,'tr','Fatura ZIP',0),(337649,9380,'pl','Rozliczenia Zip',0),(337650,9380,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Zip',0),(337651,9380,'ur','Ø¨Ù„Ù†Ú¯ Ø²Ù¾',0),(337652,9380,'sr','ÐÐ°Ð¿Ð»Ð°Ñ‚Ðµ Ð—Ð¸Ð¿',0),(337653,9380,'vi','MÃ£ Zip Gá»­i HÃ³a ÄÆ¡n',0),(337654,9380,'af','Verekening Poskode',0),(337655,9380,'ro','Facturare Zip',0),(337656,9380,'et','Arved Zip',0),(337657,9380,'si','ZaraÄunavanje Zip',0),(337658,9380,'ba','Penagihan Zip',0),(337659,9380,'nl','Facturering Zip',0),(337660,9380,'fi','Laskutus Zip',0),(337661,9380,'no','Fakturering Zip',0),(337662,9380,'da','Fakturering Zip',0),(337663,9380,'ko','ëŒ€ê¸ˆ ì²­êµ¬ ìš°íŽ¸',0),(337664,9380,'he','×ž×™×§×•×“ ×—×™×•×‘',0),(337665,9380,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· Î¼Îµ Ï†ÎµÏÎ¼Î¿Ï…Î¬Ï',0),(337666,9380,'zh','å¸å•é‚®ç¼–\r\n',0),(337667,9380,'sv','Fakturering Zip',0),(337668,9380,'it','Zip di fatturazione',0),(337669,9380,'tl','',0),(337670,9380,'th','&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;&#3607;&#3637;&#3656;&#3623;&#3634;&#3591;&#3610;&#3636;&#3621;',0),(337671,9380,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤œà¤¼à¤¿à¤ª',0),(337672,9380,'ms','Bil Zip',0),(337673,9380,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(337674,9380,'fr','Zip de facturation',0),(337675,9380,'jp','è«‹æ±‚å…ˆéƒµä¾¿ç•ªå·',0),(337676,9380,'pt','Zip de faturamento',0),(337677,9380,'ru','Ð’Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð² Zip',0),(337678,9380,'es','CÃ³digo Postal de FacturaciÃ³n',0),(337679,9380,'de','Abrechnung-Zip',0),(337680,9380,'en','Billing Zip',0),(337681,9381,'is','',0),(337682,9381,'dr','(Ø³Ù†Ø¯',0),(337683,9381,'pr',' Ø´Ù†Ø§Ø³Ù‡ Ø«Ø¨Øª(Ø³Ù†Ø¯',0),(337684,9381,'tr','KayÄ±t kodu',0),(337685,9381,'pl','Identyfikator rekordu',0),(337686,9381,'bg','Ð˜Ð” Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(337687,9381,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ø´Ù†Ø§Ø®Øª',0),(337688,9381,'sr','Ð˜Ð” Ð·Ð°Ð¿Ð¸ÑÐ°',0),(337689,9381,'vi','ID há»“ sÆ¡',0),(337690,9381,'af','Rekord ID',0),(337691,9381,'ro','Record ID',0),(337692,9381,'et','Kirje ID',0),(337693,9381,'si','ID zapisa',0),(337694,9381,'ba','ID catatan',0),(337695,9381,'nl','Record-ID',0),(337696,9381,'fi','Tietueen tunnus',0),(337697,9381,'no','OppfÃ¸rings-ID',0),(337698,9381,'da','POST-id',0),(337699,9381,'ko','ë ˆì½”ë“œ ID',0),(337700,9381,'he','×ž×–×”×” ×¨×©×•×ž×”',0),(337701,9381,'el','Î•Î³Î³ÏÎ±Ï†Î® ID',0),(337702,9381,'zh','è®°å½•ID\r\n',0),(337703,9381,'sv','POST-ID',0),(337704,9381,'it','ID record',0),(337705,9381,'tl','',0),(337706,9381,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;',0),(337707,9381,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ ID',0),(337708,9381,'ms','Pengenalan rekod',0),(337709,9381,'ar','Ù…Ø¹Ø±Ù‘Ù Ø§Ù„Ø³Ø¬Ù„Ù‘',0),(337710,9381,'fr','ID de lâ€™enregistrement',0),(337711,9381,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ ID',0),(337712,9381,'pt','ID de registro',0),(337713,9381,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(337714,9381,'es','Registrar ID',0),(337715,9381,'de','Datensatz-ID',0),(337716,9381,'en','Record ID',0),(337717,9382,'is','',0),(337718,9382,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ Ù…Ø¬Ø§Ù†ÙŠ',0),(337719,9382,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ Ù…Ø¬Ø§Ù†ÙŠ',0),(337720,9382,'tr','Ãœcretsiz Nakliye seÃ§eneÄŸi eklendi',0),(337721,9382,'pl','Dodaj opcjÄ™ wysyÅ‚ka gratis',0),(337722,9382,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¾Ð¿Ñ†Ð¸Ñ Ð·Ð° Ð±ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(337723,9382,'ur','Ù…ÙØª Ø´Ù¾Ù†Ú¯ Ø§Ø®ØªÛŒØ§Ø± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(337724,9382,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð°Ð½ Ñ‚Ñ€Ð°Ð½ÑÐ¿Ð¾Ñ€Ñ‚ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(337725,9382,'vi','ThÃªm Lá»±a Chá»n Váº­n Chuyá»ƒn Miá»…n PhÃ­',0),(337726,9382,'af','Gratis Versendingsopsie Byvoeg',0),(337727,9382,'ro','AdaugÄƒ opÅ£iunea de transport gratuit',0),(337728,9382,'et','Lisa tasuta tarnimise valik',0),(337729,9382,'si','Dodaj moÅ¾nost brezplaÄna dostava',0),(337730,9382,'ba','Tambahkan pilihan pengiriman gratis',0),(337731,9382,'nl','Toevoegen optie gratis verzending',0),(337732,9382,'fi','LisÃ¤Ã¤ Free Shipping vaihtoehto',0),(337733,9382,'no','Legge til gratis forsendelsesmÃ¥te',0),(337734,9382,'da','TilfÃ¸j mulighed for gratis forsendelse',0),(337735,9382,'ko','ë¬´ë£Œ ë°°ì†¡ ì˜µì…˜ ì¶”ê°€',0),(337736,9382,'he','×”×•×¡×£ ××¤×©×¨×•×ª ×ž×©×œ×•×— ×—×™× ×',0),(337737,9382,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÎ»ÎµÏÎ¸ÎµÏÎ· ÎµÏ€Î¹Î»Î¿Î³Î® Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(337738,9382,'zh','å¢žåŠ å…è´¹è¿é€é€‰å‰‡\r\n',0),(337739,9382,'sv','LÃ¤gg till gratis frakt alternativ',0),(337740,9382,'it','Aggiungere l\'opzione di spedizione gratuita',0),(337741,9382,'tl','',0),(337742,9382,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3615;&#3619;&#3637;',0),(337743,9382,'hi','à¤¨à¤¿: à¤¶à¥à¤²à¥à¤• à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¿à¤•à¤²à¥à¤ª à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(337744,9382,'ms','Tambah pilihan penghantaran percuma',0),(337745,9382,'ar','Ø¥Ø¶Ø§ÙØ© Ø®ÙŠØ§Ø± Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù…Ø¬Ø§Ù†ÙŠ',0),(337746,9382,'fr','Ajouter option de manutention gratuit',0),(337747,9382,'jp','é€æ–™ç„¡æ–™ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(337748,9382,'pt','Adicionar a opÃ§Ã£o de frete grÃ¡tis',0),(337749,9382,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð°Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(337750,9382,'es','Agregar la OpciÃ³n de Flete Gratis',0),(337751,9382,'de','Kostenloser Versand-Option hinzufÃ¼gen',0),(337752,9382,'en','Add Free Shipping Option',0),(337753,9383,'is','',0),(337754,9383,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø­Ù…Ù„ Ù…Ø¬Ø§Ù†ÙŠ ',0),(337755,9383,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø­Ù…Ù„ Ù…Ø¬Ø§Ù†ÙŠ ',0),(337756,9383,'tr','Ãœcretsiz nakliye seÃ§enekleri',0),(337757,9383,'pl','Opcje wysyÅ‚ka gratis',0),(337758,9383,'bg','Ð‘ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ð¿Ñ†Ð¸Ð¸',0),(337759,9383,'ur','Ù…ÙØª Ø´Ù¾Ù†Ú¯ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(337760,9383,'sr','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð°Ð½ Ñ‚Ñ€Ð°Ð½ÑÐ¿Ð¾Ñ€Ñ‚ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(337761,9383,'vi','Lá»±a chá»n váº­n chuyá»ƒn miá»…n phÃ­',0),(337762,9383,'af','Gratis Versendingsopsies',0),(337763,9383,'ro','OpÅ£iuni de livrare gratuitÄƒ',0),(337764,9383,'et','Tasuta saatmine',0),(337765,9383,'si','BrezplaÄna dostava moÅ¾nosti',0),(337766,9383,'ba','Pilihan pengiriman gratis',0),(337767,9383,'nl','Gratis het Verzendmogelijkheden',0),(337768,9383,'fi','Ilmainen toimitus vaihtoehdot',0),(337769,9383,'no','Gratis frakt alternativer',0),(337770,9383,'da','Gratis Shipping muligheder',0),(337771,9383,'ko','ë¬´ë£Œ ë°°ì†¡ ì˜µì…˜',0),(337772,9383,'he','××¤×©×¨×•×™×•×ª ×ž×©×œ×•×— ×—×™× ×',0),(337773,9383,'el','Î”Ï‰ÏÎµÎ¬Î½ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¹ÎºÎ¬',0),(337774,9383,'zh','å…è´¹é€è´§é€‰é¡¹\r\n',0),(337775,9383,'sv','Gratis fraktalternativ',0),(337776,9383,'it','Opzioni di spedizione gratuita',0),(337777,9383,'tl','',0),(337778,9383,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3615;&#3619;&#3637;',0),(337779,9383,'hi','à¤¨à¤¿: à¤¶à¥à¤²à¥à¤• à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¿à¤•à¤²à¥à¤ª',0),(337780,9383,'ms','Pilihan penghantaran percuma',0),(337781,9383,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù…Ø¬Ø§Ù†ÙŠ',0),(337782,9383,'fr','Options de livraison gratuite',0),(337783,9383,'jp','é€æ–™ç„¡æ–™ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(337784,9383,'pt','OpÃ§Ãµes de frete grÃ¡tis',0),(337785,9383,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾Ð¹ ÐžÑ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(337786,9383,'es','Opciones Gratis de Transporte',0),(337787,9383,'de','Kostenloser Versand-Optionen',0),(337788,9383,'en','Free Shipping Options',0),(337789,9384,'is','',0),(337790,9384,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ Ù…Ø¬Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(337791,9384,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ Ù…Ø¬Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(337792,9384,'tr','Ãœcretsiz Nakliye seÃ§eneÄŸi baÅŸarÄ±yla silindi',0),(337793,9384,'pl','Darmowa wysyÅ‚ka opcjÄ™ usuniÄ™te pomyÅ›lnie',0),(337794,9384,'bg','Ð‘ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ð¿Ñ†Ð¸Ñ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(337795,9384,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø§Ø®ØªÛŒØ§Ø± Ù…ÙØª Ø´Ù¾Ù†Ú¯',0),(337796,9384,'sr','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(337797,9384,'vi','XÃ³a lá»±a chá»n váº­n chuyá»ƒn miá»…n phÃ­ thÃ nh cÃ´ng',0),(337798,9384,'af','Gratis Versendingsopsie Suksesvol Geskrap',0),(337799,9384,'ro','Transport gratuit opÅ£iune eliminÄƒ cu succes',0),(337800,9384,'et','Free Shipping vÃµimalus edukalt kustutatud',0),(337801,9384,'si','BrezplaÄna dostava moÅ¾nost uspeÅ¡no izbrisana',0),(337802,9384,'ba','Gratis pengiriman pilihan berhasil dihapus',0),(337803,9384,'nl','Gratis verzending optie succesvol verwijderd',0),(337804,9384,'fi','Free Shipping vaihtoehto poistettu',0),(337805,9384,'no','Gratis frakt alternativet slettet',0),(337806,9384,'da','Free Shipping Option slettet',0),(337807,9384,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì˜µì…˜ ë¬´ë£Œ ë°°ì†¡',0),(337808,9384,'he','×ž×©×œ×•×— ×—×™× × ××¤×©×¨×•×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(337809,9384,'el','Î”Ï‰ÏÎµÎ¬Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÏ€Î¹Î»Î¿Î³Î® Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(337810,9384,'zh','å…è´¹è¿é€é€‰é¡¹åˆ é™¤æˆåŠŸ\r\n',0),(337811,9384,'sv','Fri frakt alternativet raderades',0),(337812,9384,'it','Spedizione gratuita opzione eliminato con successo',0),(337813,9384,'tl','',0),(337814,9384,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3615;&#3619;&#3637;&#3606;&#3641;&#3585;&#3621;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(337815,9384,'hi','à¤¨à¤¿: à¤¶à¥à¤²à¥à¤• à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾',0),(337816,9384,'ms','Percuma penghantaran pilihan dihapuskan dengan jayanya',0),(337817,9384,'ar','Ø§Ù„Ø´Ø­Ù† Ù…Ø¬Ø§Ù†Ø§Ù‹ Ø®ÙŠØ§Ø± Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(337818,9384,'fr','Livraison gratuite Option supprimÃ©e avec succÃ¨s',0),(337819,9384,'jp','è‡ªç”±ãªå‡ºè·ã‚ªãƒ—ã‚·ãƒ§ãƒ³ãŒå‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(337820,9384,'pt','Frete grÃ¡tis opÃ§Ã£o excluÃ­da com sucesso',0),(337821,9384,'ru','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð°Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(337822,9384,'es','OpciÃ³n Gratis de Transporte Eliminado Exitosamente',0),(337823,9384,'de','Kostenloser Versand Option erfolgreich gelÃ¶scht',0),(337824,9384,'en','Free Shipping Option Deleted Successfully',0),(337825,9385,'is','',0),(337826,9385,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ Ù…Ø¬Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ  Ø´Ø¯ ',0),(337827,9385,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ø­Ù…Ù„ Ù…Ø¬Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ  Ø´Ø¯ ',0),(337828,9385,'tr','Ãœcretsiz Nakliye seÃ§eneÄŸi baÅŸarÄ±yla kuruldu',0),(337829,9385,'pl','Darmowa wysyÅ‚ka opcja pomyÅ›lnie skonfigurowane',0),(337830,9385,'bg','Ð‘ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ð¿Ñ†Ð¸Ñ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(337831,9385,'ur','Ø§Ø®ØªÛŒØ§Ø± Ù…ÙØª Ø´Ù¾Ù†Ú¯ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø³ÛŒÙ¹ Ø§Ù¾',0),(337832,9385,'sr','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(337833,9385,'vi','Sep up lá»±a chá»n váº­n chuyá»ƒn miá»…n phÃ­ thÃ nh cÃ´ng',0),(337834,9385,'af','Gratis Versendingsopsies Suksesvol Opgestel',0),(337835,9385,'ro','Transport gratuit optiunea configurarea cu succes',0),(337836,9385,'et','Free Shipping vÃµimalus seadistada edukalt',0),(337837,9385,'si','BrezplaÄna dostava moÅ¾nost nastaviti uspeÅ¡no',0),(337838,9385,'ba','Gratis pengiriman pilihan mengatur berhasil',0),(337839,9385,'nl','Gratis verzending optie instellen met succes',0),(337840,9385,'fi','Free Shipping vaihtoehto mÃ¤Ã¤rittÃ¤Ã¤ onnistuneesti',0),(337841,9385,'no','Gratis frakt alternativet konfigurert',0),(337842,9385,'da','Free Shipping Option oprettet med succes',0),(337843,9385,'ko','ì„±ê³µì ìœ¼ë¡œ ì„¤ì • ì˜µì…˜ ë¬´ë£Œ ë°°ì†¡',0),(337844,9385,'he','×ž×©×œ×•×— ×—×™× × ××¤×©×¨×•×ª ×œ×”×’×“×™×¨ ×‘×”×¦×œ×—×”',0),(337845,9385,'el','Î•Î»ÎµÏÎ¸ÎµÏÎ· ÎµÏ€Î¹Î»Î¿Î³Î® Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Î­Ï‡ÎµÎ¹ ÏƒÏ…ÏƒÏ„Î±Î¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(337846,9385,'zh','å…è´¹è¿é€é€‰é¡¹è®¾ç½®æˆåŠŸ\r\n',0),(337847,9385,'sv','Fri frakt alternativet StÃ¤ll in framgÃ¥ngsrikt',0),(337848,9385,'it','Spedizione gratuita opzione impostato correttamente',0),(337849,9385,'tl','',0),(337850,9385,'th','&#3605;&#3633;&#3623;&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3615;&#3619;&#3637;&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(337851,9385,'hi','à¤¨à¤¿: à¤¶à¥à¤²à¥à¤• à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¥‡à¤Ÿ à¤…à¤ª',0),(337852,9385,'ms','Percuma penghantaran pilihan sediakan berjaya',0),(337853,9385,'ar','Ø§Ù„Ø´Ø­Ù† Ù…Ø¬Ø§Ù†Ø§Ù‹ Ø®ÙŠØ§Ø± Ø¥Ø¹Ø¯Ø§Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(337854,9385,'fr','Option de livraison gratuit mis en place avec succÃ¨s',0),(337855,9385,'jp','æ­£å¸¸ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’é€æ–™ç„¡æ–™',0),(337856,9385,'pt','Frete grÃ¡tis opÃ§Ã£o configurar com Ãªxito',0),(337857,9385,'ru','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð°Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ð¿Ñ†Ð¸Ñ ÑÐ¾Ð·Ð´Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(337858,9385,'es','OpciÃ³n Gratis de Transporte Configurado Exitosamente',0),(337859,9385,'de','Kostenloser Versand Option erfolgreich eingerichtet',0),(337860,9385,'en','Free Shipping Option Set Up Successfully',0),(337861,9386,'is','',0),(337862,9386,'dr','( Ø§Ø¶Ø§ÙÙŠ',0),(337863,9386,'pr','Ø­Ù…Ù„ Ù…Ø¬Ø§Ù†ÙŠ Ø¨Ø§Ù„Ø§ØªØ± Ø§Ø²( Ø§Ø¶Ø§ÙÙŠ',0),(337864,9386,'tr','Ãœzerinden Ã¼cretsiz nakliye',0),(337865,9386,'pl','Darmowa wysyÅ‚ka ponad',0),(337866,9386,'bg','Ð‘ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð°Ð´',0),(337867,9386,'ur','Ù¾Ø± Ù…ÙØª Ø´Ù¾Ù†Ú¯',0),(337868,9386,'sr','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð°Ð½ Ñ‚Ñ€Ð°Ð½ÑÐ¿Ð¾Ñ€Ñ‚ Ð¿Ñ€ÐµÐºÐ¾',0),(337869,9386,'vi','Váº­n chuyá»ƒn miá»…n phÃ­ qua',0),(337870,9386,'af','Gratis Versendings Meer',0),(337871,9386,'ro','Transport gratuit peste',0),(337872,9386,'et','Tasuta saatmine Ã¼le',0),(337873,9386,'si','BrezplaÄna dostava nad',0),(337874,9386,'ba','Gratis biaya pengiriman atas',0),(337875,9386,'nl','Gratis verzending boven',0),(337876,9386,'fi','Ilmainen toimitus yli',0),(337877,9386,'no','Gratis frakt Over',0),(337878,9386,'da','Gratis forsendelse Over',0),(337879,9386,'ko','ì´ìƒ ë¬´ë£Œ ë°°ì†¡',0),(337880,9386,'he','×ž×©×œ×•×— ×—×™× × ×ž×¢×œ',0),(337881,9386,'el','Î”Ï‰ÏÎµÎ¬Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ',0),(337882,9386,'zh','å…è´¹é€è´§\r\n',0),(337883,9386,'sv','Gratis frakt Ã¶ver',0),(337884,9386,'it','Spedizione gratuita sopra',0),(337885,9386,'tl','',0),(337886,9386,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3615;&#3619;&#3637;&#3585;&#3623;&#3656;&#3634;',0),(337887,9386,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¨à¤¿: à¤¶à¥à¤²à¥à¤• à¤¨à¥Œà¤µà¤¹à¤¨',0),(337888,9386,'ms','Penghantaran percuma ke atas',0),(337889,9386,'ar','Ø­Ø±ÙŠØ© Ø§Ù„Ù…Ù„Ø§Ø­Ø© Ø¹Ø¨Ø±',0),(337890,9386,'fr','Livraison gratuite sur',0),(337891,9386,'jp','ä»¥ä¸Šã§é€æ–™ç„¡æ–™',0),(337892,9386,'pt','Frete grÃ¡tis sobre',0),(337893,9386,'ru','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð°Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ð¾',0),(337894,9386,'es','Transporte Gratis Sobre',0),(337895,9386,'de','Kostenloser Versand Ã¼ber',0),(337896,9386,'en','Free Shipping Over',0),(337897,9387,'is','',0),(337898,9387,'dr','( Ø§Ø¶Ø§ÙÙŠ ) Ù…Ù‚Ø¯Ø§Ø± ',0),(337899,9387,'pr','Ø­Ù…Ù„ Ù…Ø¬Ø§Ù†ÙŠ Ø¨Ø§Ù„Ø§ØªØ± Ø§Ø²( Ø§Ø¶Ø§ÙÙŠ ) Ù…Ù‚Ø¯Ø§Ø± ',0),(337900,9387,'tr','Ãœcretsiz kargo tutarÄ±',0),(337901,9387,'pl','BezpÅ‚atna dostawa powyÅ¼ej kwoty',0),(337902,9387,'bg','Ð‘ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð°Ð´ ÑÑƒÐ¼Ð°',0),(337903,9387,'ur','Ù…ÙØª Ø´Ù¾Ù†Ú¯ Ø±Ù‚Ù… Ø³Û’ Ø²Ø§Ø¦Ø¯ ÛÛ’',0),(337904,9387,'sr','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð°Ð½ Ñ‚Ñ€Ð°Ð½ÑÐ¿Ð¾Ñ€Ñ‚ Ð¿Ñ€ÐµÐºÐ¾ Ð¸Ð·Ð½Ð¾ÑÐ°',0),(337905,9387,'vi','Váº­n chuyá»ƒn miá»…n phÃ­ qua sá»‘ lÆ°á»£ng',0),(337906,9387,'af','Gratis Versendings Oorskry Bedrag',0),(337907,9387,'ro','Transport gratuit peste valoarea',0),(337908,9387,'et','Tasuta saatmine Ã¼le summa',0),(337909,9387,'si','BrezplaÄna dostava nad vrednostjo',0),(337910,9387,'ba','Gratis pengiriman lebih dari jumlah',0),(337911,9387,'nl','Gratis verzending boven bedrag',0),(337912,9387,'fi','Ilmainen toimitus yli mÃ¤Ã¤rÃ¤',0),(337913,9387,'no','Gratis frakt Over belÃ¸p',0),(337914,9387,'da','Gratis forsendelse Over belÃ¸b',0),(337915,9387,'ko','ê¸ˆì•¡ ì´ìƒ ë¬´ë£Œ ë°°ì†¡',0),(337916,9387,'he','×ž×©×œ×•×— ×—×™× × ×ž×¢×œ ×¡×›×•×',0),(337917,9387,'el','Î”Ï‰ÏÎµÎ¬Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Î¬Î½Ï‰ Ï€Î¿ÏƒÏŒ',0),(337918,9387,'zh','å…è´¹é€è´§é‡‘é¢\r\n',0),(337919,9387,'sv','Gratis frakt Ã¶ver belopp',0),(337920,9387,'it','Spedizione gratuita sopra quantitÃ ',0),(337921,9387,'tl','',0),(337922,9387,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3615;&#3619;&#3637;&#3585;&#3623;&#3656;&#3634;',0),(337923,9387,'hi','à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¨à¤¿: à¤¶à¥à¤²à¥à¤• à¤¨à¥Œà¤µà¤¹à¤¨',0),(337924,9387,'ms','Penghantaran percuma ke atas jumlah',0),(337925,9387,'ar','Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù…Ø¬Ø§Ù†ÙŠ Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø¨Ù„Øº',0),(337926,9387,'fr','Livraison gratuite sur montant',0),(337927,9387,'jp','é‡ä»¥ä¸Šã§é€æ–™ç„¡æ–™',0),(337928,9387,'pt','Frete grÃ¡tis sobre quantidade',0),(337929,9387,'ru','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð°Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð° ÑÑƒÐ¼Ð¼Ñƒ',0),(337930,9387,'es','Transporte Gratis Sobre Cantidad',0),(337931,9387,'de','Kostenloser Versand Ã¼ber Betrag',0),(337932,9387,'en','Free Shipping Over Amount',0),(337933,9388,'is','',0),(337934,9388,'dr','Ø±ÙˆØ´ Ù‡Ø§ÙŠ Ø­Ù…Ù„',0),(337935,9388,'pr','Ø±ÙˆØ´ Ù‡Ø§ÙŠ Ø­Ù…Ù„',0),(337936,9388,'tr','Gemi yÃ¶ntemleri',0),(337937,9388,'pl','Metody statku',0),(337938,9388,'bg','ÐœÐµÑ‚Ð¾Ð´Ð¸ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(337939,9388,'ur','Ø¬ÛØ§Ø² Ú©Û’ Ø·Ø±ÛŒÙ‚Û’',0),(337940,9388,'sr','Ð‘Ñ€Ð¾Ð´ Ð¼ÐµÑ‚Ð¾Ð´Ðµ',0),(337941,9388,'vi','PhÆ°Æ¡ng thá»©c chuyá»ƒn',0),(337942,9388,'af','Versend Metodes',0),(337943,9388,'ro','Metode de livrare',0),(337944,9388,'et','Laeva meetodid',0),(337945,9388,'si','Ladja metode',0),(337946,9388,'ba','Metode kapal',0),(337947,9388,'nl','Schip methoden',0),(337948,9388,'fi','Aluksen menetelmiÃ¤',0),(337949,9388,'no','Skipet metoder',0),(337950,9388,'da','Skibet metoder',0),(337951,9388,'ko','ì„ ë°• ë°©ë²•',0),(337952,9388,'he','×©×™×˜×•×ª ×”×¡×¤×™× ×”',0),(337953,9388,'el','Î Î»Î¿Î¯Î¿ Î¼ÎµÎ¸ÏŒÎ´Î¿Ï…Ï‚',0),(337954,9388,'zh','è¿é€æ–¹æ³•\r\n',0),(337955,9388,'sv','Fraktmetoder',0),(337956,9388,'it','Metodi di nave',0),(337957,9388,'tl','',0),(337958,9388,'th','&#3623;&#3636;&#3608;&#3637;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(337959,9388,'hi','à¤œà¤¹à¤¾à¤œ à¤µà¤¿à¤§à¤¿à¤¯à¤¾à¤',0),(337960,9388,'ms','Kaedah kapal',0),(337961,9388,'ar','Ø·Ø±Ù‚ Ø§Ù„Ø´Ø­Ù†',0),(337962,9388,'fr','MÃ©thodes de navire',0),(337963,9388,'jp','å‡ºè·æ–¹æ³•',0),(337964,9388,'pt','MÃ©todos de navio',0),(337965,9388,'ru','Ð¡ÑƒÐ´Ð¾Ð²Ñ‹Ðµ Ð¼ÐµÑ‚Ð¾Ð´Ñ‹',0),(337966,9388,'es','MÃ©todos de Transporte',0),(337967,9388,'de','Schiff-Methoden',0),(337968,9388,'en','Ship Methods',0),(337969,9389,'is','',0),(337970,9389,'dr','Ø¹Ù†ÙˆØ§Ù† Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(337971,9389,'pr','Ø¹Ù†ÙˆØ§Ù† Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(337972,9389,'tr','BaÅŸlÄ±ÄŸÄ± boÅŸ olamaz',0),(337973,9389,'pl','TytuÅ‚ nie moÅ¼e byÄ‡ puste',0),(337974,9389,'bg','Ð—Ð°Ð³Ð»Ð°Ð²Ð¸ÐµÑ‚Ð¾ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾',0),(337975,9389,'ur','Ø¹Ù†ÙˆØ§Ù† Ø®Ø§Ù„ÛŒ Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©ØªØ§',0),(337976,9389,'sr','ÐÐ°ÑÐ»Ð¾Ð² Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð°Ð·Ð½Ð¾',0),(337977,9389,'vi','Chá»©c danh khÃ´ng thá»ƒ Ä‘á»ƒ trá»‘ng',0),(337978,9389,'af','Titel Kan Nie Leeg Wees',0),(337979,9389,'ro','Titlul obligatoriu',0),(337980,9389,'et','Pealkiri ei tohi olla tÃ¼hi',0),(337981,9389,'si','Naslov ne sme biti prazno',0),(337982,9389,'ba','Judul tidak boleh kosong',0),(337983,9389,'nl','de titel kan niet leeg zijn',0),(337984,9389,'fi','Otsikko ei voi olla tyhjÃ¤',0),(337985,9389,'no','Tittelen kan ikke vÃ¦re tomt',0),(337986,9389,'da','Titel mÃ¥ ikke vÃ¦re tomt',0),(337987,9389,'ko','ì œëª©ì— ë¹ˆ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(337988,9389,'he','×›×•×ª×¨×ª ×œ× ×™×›×•×œ ×œ×”×™×•×ª ×¨×™×§',0),(337989,9389,'el','Î¤Î¯Ï„Î»Î¿Ï‚ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ½ÏŒ',0),(337990,9389,'zh','æ ‡é¢˜ä¸èƒ½ä¸ºç©º\r\n',0),(337991,9389,'sv','Titeln kan inte vara tomt',0),(337992,9389,'it','Titolo non puÃ² essere vuoto',0),(337993,9389,'tl','',0),(337994,9389,'th','&#3605;&#3657;&#3609;&#3648;&#3619;&#3639;&#3656;&#3629;&#3591;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3623;&#3656;&#3634;&#3591;&#3652;&#3604;&#3657;',0),(337995,9389,'hi','à¤¶à¥€à¤°à¥à¤·à¤• à¤°à¤¿à¤•à¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾',0),(337996,9389,'ms','Tajuk tidak boleh kosong',0),(337997,9389,'ar','Ø§Ù„Ø¹Ù†ÙˆØ§Ù† Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ÙŠÙƒÙˆÙ† ÙØ§Ø±ØºØ§Ù‹',0),(337998,9389,'fr','Titre ne peut pas Ãªtre vide',0),(337999,9389,'jp','ã‚¿ã‚¤ãƒˆãƒ«ã‚’ç©ºç™½ã«ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(338000,9389,'pt','TÃ­tulo nÃ£o pode estar em branco',0),(338001,9389,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¿ÑƒÑÑ‚Ñ‹Ð¼',0),(338002,9389,'es','Titulo No Puede Estar en Blanco',0),(338003,9389,'de','Titel darf nicht leer sein.',0),(338004,9389,'en','Title Cannot Be Blank',0),(338005,9390,'is','',0),(338006,9390,'dr','Ø´ØºÙ„ Ù‡Ø§ ',0),(338007,9390,'pr','Ø´ØºÙ„ Ù‡Ø§ ',0),(338008,9390,'tr','Ä°ÅŸleri',0),(338009,9390,'pl','Oferty pracy',0),(338010,9390,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð¼ÐµÑÑ‚Ð°',0),(338011,9390,'ur','Ø±ÙˆØ²Ú¯Ø§Ø± Ú©Û’ Ù…ÙˆØ§Ù‚Ø¹',0),(338012,9390,'sr','ÐŸÐ¾ÑÐ»Ð¾Ð²Ð¸',0),(338013,9390,'vi','Jobs',0),(338014,9390,'af','Kontrakwerke',0),(338015,9390,'ro','Locuri de munca',0),(338016,9390,'et','TÃ¶Ã¶pakkumised',0),(338017,9390,'si','Delovna mesta',0),(338018,9390,'ba','Pekerjaan',0),(338019,9390,'nl','Banen',0),(338020,9390,'fi','TyÃ¶paikat',0),(338021,9390,'no','Jobber',0),(338022,9390,'da','Arbejdspladser',0),(338023,9390,'ko','ì±„ìš© ì •ë³´',0),(338024,9390,'he','×¢×‘×•×“×•×ª',0),(338025,9390,'el','Î˜Î­ÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(338026,9390,'zh','å·¥ä½œ\r\n',0),(338027,9390,'sv','Jobb',0),(338028,9390,'it','Offerte di lavoro',0),(338029,9390,'tl','',0),(338030,9390,'th','&#3591;&#3634;&#3609;',0),(338031,9390,'hi','à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¤¾à¤‚',0),(338032,9390,'ms','Kerja-kerja',0),(338033,9390,'ar','Ø§Ù„ÙˆØ¸Ø§Ø¦Ù',0),(338034,9390,'fr','Travaux',0),(338035,9390,'jp','ã‚¸ãƒ§ãƒ–',0),(338036,9390,'pt','Postos de trabalho',0),(338037,9390,'ru','Ð’Ð°ÐºÐ°Ð½ÑÐ¸Ð¸',0),(338038,9390,'es','Trabajos',0),(338039,9390,'de','Jobs',0),(338040,9390,'en','Jobs',0),(338041,9391,'is','',0),(338042,9391,'dr','Ø¬Ø³ØªØ¬Ùˆ Ø´ØºÙ„ ',0),(338043,9391,'pr','Ø¬Ø³ØªØ¬Ùˆ Ø´ØºÙ„ ',0),(338044,9391,'tr','Ä°ÅŸ arama',0),(338045,9391,'pl','Poszukiwanie pracy',0),(338046,9391,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(338047,9391,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ ØªÙ„Ø§Ø´',0),(338048,9391,'sr','Ð¢Ñ€Ð°Ð¶ÐµÑšÐµ Ð¿Ð¾ÑÐ»Ð°',0),(338049,9391,'vi','TÃ¬m Job',0),(338050,9391,'af','Kontrakwerk Soek',0),(338051,9391,'ro','Cautare Job',0),(338052,9391,'et','TÃ¶Ã¶ otsing',0),(338053,9391,'si','Iskanje zaposlitve',0),(338054,9391,'ba','Mencari pekerjaan',0),(338055,9391,'nl','Job Search',0),(338056,9391,'fi','TyÃ¶nhaku',0),(338057,9391,'no','JobbsÃ¸k',0),(338058,9391,'da','JobsÃ¸gning',0),(338059,9391,'ko','ì±„ìš© ì •ë³´ ê²€ìƒ‰',0),(338060,9391,'he','×—×™×¤×•×© ×¢×‘×•×“×”',0),(338061,9391,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(338062,9391,'zh','æ±‚èŒ\r\n',0),(338063,9391,'sv','SÃ¶k jobb',0),(338064,9391,'it','Ricerca di lavoro',0),(338065,9391,'tl','',0),(338066,9391,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3591;&#3634;&#3609;',0),(338067,9391,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤–à¥‹à¤œ',0),(338068,9391,'ms','Carian kerja',0),(338069,9391,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† ÙˆØ¸ÙŠÙØ©',0),(338070,9391,'fr','Recherche de Travaux',0),(338071,9391,'jp','ã‚¸ãƒ§ãƒ–æ¤œç´¢',0),(338072,9391,'pt','Procura de emprego',0),(338073,9391,'ru','ÐŸÐ¾Ð¸ÑÐº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(338074,9391,'es','Busqueda de Trabajos',0),(338075,9391,'de','Job-Suche',0),(338076,9391,'en','Job Search',0),(338077,9392,'is','',0),(338078,9392,'dr','Ø´ØºÙ„ Ø¬Ø¯ÙŠØ¯ ',0),(338079,9392,'pr','Ø´ØºÙ„ Ø¬Ø¯ÙŠØ¯ ',0),(338080,9392,'tr','Yeni iÅŸ',0),(338081,9392,'pl','Nowej pracy',0),(338082,9392,'bg','ÐÐ¾Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(338083,9392,'ur','Ù†ÛŒØ§ Ú©Ø§Ù…',0),(338084,9392,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(338085,9392,'vi','Job má»›i',0),(338086,9392,'af','Nuwe Projek',0),(338087,9392,'ro','Noul loc de muncÄƒ',0),(338088,9392,'et','Uus tÃ¶Ã¶',0),(338089,9392,'si','Novo delovno mesto',0),(338090,9392,'ba','Pekerjaan baru',0),(338091,9392,'nl','Nieuwe baan',0),(338092,9392,'fi','Uusi tyÃ¶',0),(338093,9392,'no','Ny jobb',0),(338094,9392,'da','Nye Job',0),(338095,9392,'ko','ìƒˆ ìž‘ì—…',0),(338096,9392,'he','×¢×‘×•×“×” ×—×“×©×”',0),(338097,9392,'el','ÎÎ­Î± Î¸Î­ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(338098,9392,'zh','æ–°å·¥ä½œ\r\n',0),(338099,9392,'sv','Nytt jobb',0),(338100,9392,'it','Nuovo lavoro',0),(338101,9392,'tl','',0),(338102,9392,'th','&#3591;&#3634;&#3609;&#3651;&#3627;&#3617;&#3656;',0),(338103,9392,'hi','à¤¨à¤ˆ à¤¨à¥Œà¤•à¤°à¥€',0),(338104,9392,'ms','Pekerjaan baru',0),(338105,9392,'ar','ÙˆØ¸ÙŠÙØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(338106,9392,'fr','Nouveau Travaux',0),(338107,9392,'jp','æ–°ã—ã„ä»•äº‹',0),(338108,9392,'pt','Novo emprego',0),(338109,9392,'ru','ÐÐ¾Ð²Ð°Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(338110,9392,'es','Nuevo Trabajo',0),(338111,9392,'de','Neuen Job',0),(338112,9392,'en','New Job',0),(338113,9393,'is','',0),(338114,9393,'dr','Ù…Ø¹Ø§Ù ÙƒØ±Ø¯Ù† Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¯Ø±  Ù‡Ø± Ø³Ø§Ù„  ',0),(338115,9393,'pr','Ù…Ø¹Ø§Ù ÙƒØ±Ø¯Ù† Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¯Ø±  Ù‡Ø± Ø³Ø§Ù„  ',0),(338116,9393,'tr','Her yÄ±l muaf Ã¼cretleri',0),(338117,9393,'pl','PÅ‚ace zwolnione rocznie',0),(338118,9393,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ñ‚ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¾',0),(338119,9393,'ur','ÛØ± Ø³Ø§Ù„ Ù…Ø³ØªØ«Ù†ÛŒ Ø§Ø¬Ø±Øª',0),(338120,9393,'sr','Ð˜Ð·ÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ð»Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(338121,9393,'vi','Miá»…n trá»« lÆ°Æ¡ng má»—i nÄƒm',0),(338122,9393,'af','Vrygestelde Besoldiging Per Jaar',0),(338123,9393,'ro','Scutite de salarii pe an',0),(338124,9393,'et','Maksuvaba palga aastas',0),(338125,9393,'si','OproÅ¡Äene plaÄe na leto',0),(338126,9393,'ba','Dibebaskan upah Per tahun',0),(338127,9393,'nl','Vrijgesteld loon Per jaar',0),(338128,9393,'fi','Vapautettu palkat vuodessa',0),(338129,9393,'no','Unntatt lÃ¸nn Per Ã¥r',0),(338130,9393,'da','Undtaget lÃ¸n pr. Ã¥r',0),(338131,9393,'ko','ì—°ê°„ ë©´ì œ ìž„ê¸ˆ',0),(338132,9393,'he','×©×›×¨ ×¤×˜×•×¨ ×œ×©× ×”',0),(338133,9393,'el','Î‘Ï€Î±Î»Î»Î¬ÏƒÏƒÎ¿Î½Ï„Î±Î¹ Î¼Î¹ÏƒÎ¸Î¿Î¯ Î±Î½Î¬ Î­Ï„Î¿Ï‚',0),(338134,9393,'zh','æ¯ä¸€å¹´è±å…å·¥èµ„\r\n',0),(338135,9393,'sv','Undanta lÃ¶ner Per Ã¥r',0),(338136,9393,'it','Salari esenti all\'anno',0),(338137,9393,'tl','',0),(338138,9393,'th','&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;&#3605;&#3656;&#3629;&#3611;&#3637;',0),(338139,9393,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤· à¤›à¥‚à¤Ÿ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(338140,9393,'ms','Dikecualikan daripada gaji setahun',0),(338141,9393,'ar','Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø£Ø¬ÙˆØ± Ø³Ù†ÙˆÙŠØ§Ù‹',0),(338142,9393,'fr','Salaires exonÃ©rÃ©s par an',0),(338143,9393,'jp','å¹´é–“æŽ§é™¤è³ƒé‡‘',0),(338144,9393,'pt','Isentos salÃ¡rios por ano',0),(338145,9393,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°ÑŽÑ‚ÑÑ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð° Ð² Ð³Ð¾Ð´',0),(338146,9393,'es','Sueldos Exentos Por AÃ±o',0),(338147,9393,'de','Befreit Lohn pro Jahr',0),(338148,9393,'en','Exempt Wages Per Year',0),(338149,9394,'is','',0),(338150,9394,'dr','Ø­Ù‚ÙˆÙ‚  Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ…ØªØ± Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯',0),(338151,9394,'pr','Ø­Ù‚ÙˆÙ‚  Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ…ØªØ± Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯',0),(338152,9394,'tr','Vergiye tabi daha az vergi Ã¶demek',0),(338153,9394,'pl','Opodatkowaniu zapÅ‚aciÄ‡ mniej podatku dochodowego',0),(338154,9394,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(338155,9394,'ur','Ù‚Ø§Ø¨Ù„ Ù¹ÛŒÚ©Ø³ Ú©Ù… Ø§Ù†Ú©Ù… Ù¹ÛŒÚ©Ø³ Ø§Ø¯Ø§ Ú©Ø±ØªÛ’ ÛÛŒÚº',0),(338156,9394,'sr','ÐžÐ¿Ð¾Ñ€ÐµÐ·Ð¸Ð² Ð¿Ð»Ð°Ñ‚Ðµ Ð¼Ð°ÑšÐµ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð´Ð¾Ñ…Ð¾Ð´Ð°Ðº',0),(338157,9394,'vi','LÆ°Æ¡ng chá»‹u thuáº¿ trá»« thuáº¿ thu nháº­p',0),(338158,9394,'af','Belasbare Besoldiging Minus Inkomste Belasting',0),(338159,9394,'ro','Salariu impozabil minus impozitul pe venit',0),(338160,9394,'et','Maksukohustuslane maksta vÃ¤hem tulumaksu',0),(338161,9394,'si','DavÄni zavezanec plaÄati manj davka na dohodek',0),(338162,9394,'ba','Pajak membayar pajak pendapatan kurang',0),(338163,9394,'nl','Belastbaar loon minder inkomstenbelasting',0),(338164,9394,'fi','Verovelvollinen maksaa vÃ¤hemmÃ¤n tuloveroa',0),(338165,9394,'no','Skattepliktig betale mindre skatt',0),(338166,9394,'da','Skattepligtige betaler mindre skat',0),(338167,9394,'ko','ë” ì ì€ ì†Œë“ì„¸ë¥¼ ì§€ë¶ˆ í•˜ëŠ” ê³¼ì„¸',0),(338168,9394,'he','×—×™×™×‘ ×‘×ž×¡ ×œ×©×œ× ×¤×—×•×ª ×ž×¡ ×”×›× ×¡×”',0),(338169,9394,'el','Î¦ÏŒÏÎ¿ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Î»Î¹Î³ÏŒÏ„ÎµÏÎ¿ Ï†ÏŒÏÎ¿ ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(338170,9394,'zh','åº”çº³ç¨Žå°‘äºŽæ‰€å¾—ç¨Ž\r\n',0),(338171,9394,'sv','Skattepliktiga betalar mindre skatt',0),(338172,9394,'it','Soggetti passivi pagare meno tasse di reddito',0),(338173,9394,'tl','',0),(338174,9394,'th','&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;&#3616;&#3634;&#3625;&#3637;&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;',0),(338175,9394,'hi','à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨ à¤•à¤® à¤†à¤¯à¤•à¤°',0),(338176,9394,'ms','Cukai bayar ditolak cukai pendapatan',0),(338177,9394,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ø£Ù‚Ù„ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯Ø®Ù„',0),(338178,9394,'fr','Taxables payer moins dâ€™impÃ´t',0),(338179,9394,'jp','ä»¥ä¸‹ã®æ‰€å¾—ç¨Žèª²ç¨Žçµ¦ä¸Ž',0),(338180,9394,'pt','Sujeito passivo pagar menos imposto de renda',0),(338181,9394,'ru','ÐžÐ±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð¼ÐµÐ½ÑŒÑˆÐµ Ð¿Ð¾Ð´Ð¾Ñ…Ð¾Ð´Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(338182,9394,'es','Pago Imponible menos Impuesto Sobre la Renta',0),(338183,9394,'de','Steuerpflichtigen weniger Steuern zahlen',0),(338184,9394,'en','Taxable Pay Less Income Tax',0),(338185,9395,'is','',0),(338186,9395,'dr','Ø­Ù‚ÙˆÙ‚  Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ…ØªØ± Ø§Ø²  Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ ',0),(338187,9395,'pr','Ø­Ù‚ÙˆÙ‚  Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ÙƒÙ…ØªØ± Ø§Ø²  Ù…Ø§Ù„ÙŠØ§Øª Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ ',0),(338188,9395,'tr','Vergiye tabi SS daha az vergi Ã¶demek',0),(338189,9395,'pl','Opodatkowaniu zapÅ‚aciÄ‡ mniej podatku od SS',0),(338190,9395,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð´Ð°Ð½ÑŠÐº, Ð¡Ð¡',0),(338191,9395,'ur','Ø§ÛŒØ³ Ø§ÛŒØ³ Ù¹ÛŒÚ©Ø³ Ú©Ù… Ù¹ÛŒÚ©Ø³ ØªÙ†Ø®ÙˆØ§Û',0),(338192,9395,'sr','ÐžÐ¿Ð¾Ñ€ÐµÐ·Ð¸Ð² Ð¿Ð»Ð°Ñ‚Ðµ Ð¼Ð°ÑšÐµ Ð¡Ð¡ Ð¿Ð¾Ñ€ÐµÐ·',0),(338193,9395,'vi','LÆ°Æ¡ng chá»‹u thuáº¿ trá»« thuáº¿ SS',0),(338194,9395,'af','Belasbare Besoldiging Minus \"SS\" Belasting',0),(338195,9395,'ro','Impozabile plÄƒtesc mai puÅ£in impozit SS',0),(338196,9395,'et','Maksukohustuslane maksta vÃ¤hem maksu SS',0),(338197,9395,'si','DavÄni zavezanec plaÄati manj davka SS',0),(338198,9395,'ba','Pajak membayar pajak SS kurang',0),(338199,9395,'nl','Belastbare minder SS-belasting betalen',0),(338200,9395,'fi','Veron maksavat vÃ¤hemmÃ¤n SS veroja',0),(338201,9395,'no','Skattepliktig betale mindre SS skatt',0),(338202,9395,'da','Afgiftspligtige beskattes mindre SS',0),(338203,9395,'ko','ê³¼ì„¸ ì„¸ê¸ˆ ì ê²Œ ì§€ë¶ˆ SS',0),(338204,9395,'he','×—×™×™×‘ ×‘×ž×¡ ×œ×©×œ× ×¤×—×•×ª ×ž×¡ ×”××¡. ××¡',0),(338205,9395,'el','Î¦ÏŒÏÎ¿ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Î»Î¹Î³ÏŒÏ„ÎµÏÎ¿ Ï†ÏŒÏÎ¿ SS',0),(338206,9395,'zh','åº”çº³ç¨Žå°‘äºŽç¤¾ä¼šä¿éšœå†›\r\n',0),(338207,9395,'sv','Skattepliktiga betalar mindre skatt i SS',0),(338208,9395,'it','Soggetti passivi pagare meno tasse di SS',0),(338209,9395,'tl','',0),(338210,9395,'th','&#3616;&#3634;&#3625;&#3637;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3592;&#3656;&#3634;&#3618;&#3609;&#3657;&#3629;&#3618;&#3585;&#3623;&#3656;&#3634;&#3616;&#3634;&#3625;&#3637; SS',0),(338211,9395,'hi','à¤à¤¸ à¤à¤¸ à¤•à¤° à¤•à¤® à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤µà¥‡à¤¤à¤¨',0),(338212,9395,'ms','Dikenakan cukai membayar cukai SS Kurang',0),(338213,9395,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ø£Ù‚Ù„ Ø¶Ø±ÙŠØ¨Ø© SS',0),(338214,9395,'fr','Taxables payer moins dâ€™impÃ´ts SS',0),(338215,9395,'jp','èª²ç¨Žå¯¾è±¡ãŒå°‘ãªã„ SS ç¨Žã‚’æ‰•ã†',0),(338216,9395,'pt','Sujeito passivo pagar menos impostos de SS',0),(338217,9395,'ru','ÐžÐ±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð¼ÐµÐ½ÑŒÑˆÐµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð², Ð¡Ð¡',0),(338218,9395,'es','Pago Imponible menos Impuesto de Seguro Social',0),(338219,9395,'de','Steuerpflichtigen weniger SS Steuern zahlen',0),(338220,9395,'en','Taxable Pay Less SS Tax',0),(338221,9396,'is','',0),(338222,9396,'dr','Ù…Ø¹Ø§Ù ÙƒØ±Ø¯Ù† Ø¯Ø³ØªÙ…Ø²Ø¯ Ù‡Ø§ÙŠ Ø³Ø§Ù„ ',0),(338223,9396,'pr','Ù…Ø¹Ø§Ù ÙƒØ±Ø¯Ù† Ø¯Ø³ØªÙ…Ø²Ø¯ Ù‡Ø§ÙŠ Ø³Ø§Ù„ ',0),(338224,9396,'tr','Muafiyet Ã¼cret yÄ±l',0),(338225,9396,'pl','Roku pÅ‚ace zwolnione',0),(338226,9396,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ñ‚ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(338227,9396,'ur','Ù…Ø³ØªØ«Ù†ÛŒ Ø§Ø¬Ø±Øª Ø³Ø§Ù„',0),(338228,9396,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ Ð¸Ð·ÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ',0),(338229,9396,'vi','Miá»…n trá»« lÆ°Æ¡ng nÄƒm',0),(338230,9396,'af','Vrygestelde Besoldiging Jaar',0),(338231,9396,'ro','An salariile scutite',0),(338232,9396,'et','Maksuvaba palga aasta',0),(338233,9396,'si','OproÅ¡Äene plaÄe leto',0),(338234,9396,'ba','Tahun dibebaskan upah',0),(338235,9396,'nl','Vrijgesteld loon jaar',0),(338236,9396,'fi','Vapautettu palkat vuoden',0),(338237,9396,'no','Unntatt lÃ¸nn Ã¥r',0),(338238,9396,'da','Undtaget lÃ¸n Ã¥r',0),(338239,9396,'ko','ë©´ì œ ìž„ê¸ˆ ë…„',0),(338240,9396,'he','×”×©× ×” ×©×›×¨ ×¤×˜×•×¨',0),(338241,9396,'el','Î‘Ï€Î±Î»Î»Î¬ÏƒÏƒÎ¿Î½Ï„Î±Î¹ Î¼Î¹ÏƒÎ¸Î¿Î¯ Î­Ï„Î¿Ï‚',0),(338242,9396,'zh','è±å…å¹´å·¥èµ„\r\n',0),(338243,9396,'sv','Undanta lÃ¶ner Ã¥r',0),(338244,9396,'it','Anno di retribuzioni esenti',0),(338245,9396,'tl','',0),(338246,9396,'th','&#3611;&#3637;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3588;&#3656;&#3634;&#3592;&#3657;&#3634;&#3591;',0),(338247,9396,'hi','à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤µà¤°à¥à¤·',0),(338248,9396,'ms','Tahun dikecualikan daripada upah',0),(338249,9396,'ar','Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø£Ø¬ÙˆØ± Ø§Ù„Ø¹Ø§Ù…',0),(338250,9396,'fr','AnnÃ©e de salaire exonÃ©rÃ©',0),(338251,9396,'jp','é™¤å¤–ã•ã‚Œã‚‹è³ƒé‡‘ã®å¹´',0),(338252,9396,'pt','Ano de salÃ¡rios isentos',0),(338253,9396,'ru','Ð“Ð¾Ð´ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°ÑŽÑ‚ÑÑ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(338254,9396,'es','Sueldos Exentos AÃ±o',0),(338255,9396,'de','Befreit LÃ¶hne Jahr',0),(338256,9396,'en','Exempt Wages Year',0),(338257,9397,'is','',0),(338258,9397,'dr','/ Ø§ØµÙ„Ø§Ø­  Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø®Ø¯Ù…Ø§Øª Ø¯Ø±Ù…Ø§Ù†ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ù‡ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø§Ù…Ø¯',0),(338259,9397,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / ÙˆÙŠØ±Ø§ÙŠØ´ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø®Ø¯Ù…Ø§Øª Ø¯Ø±Ù…Ø§Ù†ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ù‡ Ù…Ø¹Ø§ÙÙŠØª Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø§Ù…Ø¯',0),(338260,9397,'tr','Gelir vergisi muafiyeti iÃ§in Ã¶denen FICA Ekle',0),(338261,9397,'pl','Dodaj FICA wypÅ‚acane do zwolnienia z podatku dochodowego',0),(338262,9397,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ FICA, Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð½Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº',0),(338263,9397,'ur','Ø§Ù†Ú©Ù… Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø¯Ø§ Ú©ÛŒØ§ ÙØ§Ú©ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(338264,9397,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐžÐ”Ð Ð•Ð¡ÐšÐ£ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾ Ð´Ð° Ð¾Ð´Ð±Ð¸Ñ˜Ðµ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð´Ð¾Ñ…Ð¾Ð´Ð°Ðº',0),(338265,9397,'vi','ThÃªm tráº£ báº£o hiá»ƒm xÃ£ há»™i tráº£ vÃ o pháº§n miá»…n thuáº¿ thu nháº­p ',0),(338266,9397,'af','FICA Betaal aan Inkomste Belasting Uitsluiting Byvoeg',0),(338267,9397,'ro','Adauga FICA acordatÄƒ scutirea de impozitul pe venit',0),(338268,9397,'et','Lisa vabastus makstud Sotsiaalmaksu',0),(338269,9397,'si','Dodaj FICA nameniti oprostitev davka od dohodka',0),(338270,9397,'ba','Tambahkan FICA dibayar untuk pembebasan pajak penghasilan',0),(338271,9397,'nl','FICA betaald aan inkomstenbelasting vrijstelling toevoegen',0),(338272,9397,'fi','LisÃ¤Ã¤ FICA maksetaan tuloverosta',0),(338273,9397,'no','Legge til FICA betalt skattefritak',0),(338274,9397,'da','TilfÃ¸je FICA betalt til indkomstskattefritagelse',0),(338275,9397,'ko','ì†Œë“ì„¸ ë©´ì œë¥¼ ì§€ë¶ˆê°€ ë´ ì¶”ê°€',0),(338276,9397,'he','×œ×”×•×¡×™×£ ×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™ ×©×™×œ× ×ž×¡ ×”×›× ×¡×” ×¤×˜×•×¨',0),(338277,9397,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î· ÏƒÏ…Î¼Î²Î¿Ï…Î»Î® Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ Î±Ï€Î±Î»Î»Î±Î³Î® Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï… ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(338278,9397,'zh','å¢žåŠ å¯Œé€šä¿é™©æ”¯ä»˜çš„æ‰€å¾—ç¨Žè±å…\r\n',0),(338279,9397,'sv','LÃ¤gg till FICA betalas till befrielse frÃ¥n inkomstskatt',0),(338280,9397,'it','Aggiungi FICA pagato all\'esenzione dall\'imposta sul reddito',0),(338281,9397,'tl','',0),(338282,9397,'th','&#3648;&#3614;&#3636;&#3656;&#3617; FICA &#3607;&#3637;&#3656;&#3592;&#3656;&#3634;&#3618;&#3649;&#3621;&#3657;&#3623;&#3648;&#3614;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3616;&#3634;&#3625;&#3637;&#3648;&#35',0),(338283,9397,'hi','à¤†à¤¯à¤•à¤° à¤®à¥‡à¤‚ à¤›à¥‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ FICA à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(338284,9397,'ms','Tambah FICA dibayar kepada pengecualian cukai pendapatan',0),(338285,9397,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø­ÙƒÙ…ÙŠ ÙŠØ¯ÙØ¹ Ù„Ù„Ø¥Ø¹ÙØ§Ø¡ Ù…Ù† Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯Ø®Ù„',0),(338286,9397,'fr','Ajouter FICA VersÃ©e Ã  exonÃ©ration de l\'impÃ´t',0),(338287,9397,'jp','FICA ã‚’æ”¯æ‰•ã£ãŸæ‰€å¾—ç¨Žã®å…é™¤ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(338288,9397,'pt','Adicionar FICA pago para isenÃ§Ã£o de imposto de renda',0),(338289,9397,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ FICA, Ð²Ñ‹Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ Ð¿Ð¾Ð´Ð¾Ñ…Ð¾Ð´Ð½Ð¾Ð³Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(338290,9397,'es','Agregar FICA Pagado a la ExenciÃ³n de Impuesto Sobre la Renta',0),(338291,9397,'de','FÃ¼gen Sie FICA gezahlten Einkommen-/KÃ¶rperschaftsteuerbefreiung hinzu',0),(338292,9397,'en','Add FICA Paid to Income Tax Exemption',0),(338293,9398,'is','',0),(338294,9398,'dr','ØºÙŠØ± Ø§Ø² Ø¢Ù…Ø±ÙŠÙƒØ§ ',0),(338295,9398,'pr','ØºÙŠØ± Ø§Ø² Ø¢Ù…Ø±ÙŠÙƒØ§ ',0),(338296,9398,'tr','Non-US sadece',0),(338297,9398,'pl','Non US tylko',0),(338298,9398,'bg','Ð˜Ð·Ð²ÑŠÐ½ Ð¡ÐÐ© ÑÐ°Ð¼Ð¾',0),(338299,9398,'ur','Ø§Ù…Ø±ÛŒÚ©Ø§ ØµØ±Ù',0),(338300,9398,'sr','ÐÐ¸ÑÑƒ ÑÐ°Ð´ ÑÐ°Ð¼Ð¾',0),(338301,9398,'vi','Chá»‰ khÃ´ng á»Ÿ Má»¹',0),(338302,9398,'af','Nie-VSA Alleenlik',0),(338303,9398,'ro','Non-US numai',0),(338304,9398,'et','Mitte-USA ainult',0),(338305,9398,'si','Non-US le',0),(338306,9398,'ba','Non-US hanya',0),(338307,9398,'nl','Niet-Amerikaanse alleen',0),(338308,9398,'fi','Kuin Yhdysvaltain vain',0),(338309,9398,'no','Ikke-amerikanske bare',0),(338310,9398,'da','Ikke-amerikanske kun',0),(338311,9398,'ko','ë¹„-ë¯¸êµ­ ì „ìš©',0),(338312,9398,'he','×ž×—×•×¥ ×œ××¨×” ×‘ ×‘×œ×‘×“',0),(338313,9398,'el','ÎœÎ·-Î—Î Î‘ Î¼ÏŒÎ½Î¿',0),(338314,9398,'zh','éžä»…ç¾Žå›½\r\n',0),(338315,9398,'sv','Icke-amerikanska endast',0),(338316,9398,'it','Non-US solo',0),(338317,9398,'tl','',0),(338318,9398,'th','&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3651;&#3594;&#3656; US &#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(338319,9398,'hi','à¤—à¥ˆà¤°-à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ à¤•à¥‡à¤µà¤²',0),(338320,9398,'ms','Bukan AS hanya',0),(338321,9398,'ar','ØºÙŠØ± Ø§Ù„Ø£Ù…Ø±ÙŠÙƒÙŠØ© ÙÙ‚Ø·',0),(338322,9398,'fr','Autres que les Ã‰tats-Unis seulement',0),(338323,9398,'jp','éžç±³å›½ã®ã¿',0),(338324,9398,'pt','Non-US apenas',0),(338325,9398,'ru','Non Ð¡Ð¨Ð Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(338326,9398,'es','No-EEUU Solamente',0),(338327,9398,'de','Non-US',0),(338328,9398,'en','Non-US Only',0),(338329,9399,'is','',0),(338330,9399,'dr','Ù…Ø¹Ø§ÙÙŠØª Ø¯ÙˆÙ„ØªÙŠ Ø³Ø§Ù„Ø§Ù†Ù‡',0),(338331,9399,'pr','Ù…Ø¹Ø§ÙÙŠØª Ø¯ÙˆÙ„ØªÙŠ Ø³Ø§Ù„Ø§Ù†Ù‡',0),(338332,9399,'tr','YÄ±llÄ±k Federal muafiyet',0),(338333,9399,'pl','Rocznym federalnych zwolnienia',0),(338334,9399,'bg','Ð“Ð¾Ð´Ð¸ÑˆÐ½Ð¸ Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ',0),(338335,9399,'ur','Ø³Ø§Ù„Ø§Ù†Û ÙˆÙØ§Ù‚ÛŒ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(338336,9399,'sr','Ð“Ð¾Ð´Ð¸ÑˆÑšÐ¸ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(338337,9399,'vi','Miá»…n Trá»« LiÃªn Bang HÃ ng NÄƒm',0),(338338,9399,'af','Jaarlikse federale vrystelling',0),(338339,9399,'ro','Scutirii anuale federale',0),(338340,9399,'et','Aasta fÃ¶deraalse erand',0),(338341,9399,'si','Letni zvezni oprostitev',0),(338342,9399,'ba','Pembebasan Federal tahunan',0),(338343,9399,'nl','Jaarlijkse federale vrijstelling',0),(338344,9399,'fi','Vuosittain liittovaltion vapautus',0),(338345,9399,'no','Ã…rlige fÃ¸derale fritak',0),(338346,9399,'da','Ã…rlige fÃ¸derale fritagelse',0),(338347,9399,'ko','ì—°ë¡€ ì—°ë°© ë©´ì œ',0),(338348,9399,'he','×¤×˜×•×¨ ×”×¤×“×¨×œ×™ ×”×©× ×ª×™',0),(338349,9399,'el','Î•Ï„Î®ÏƒÎ¹Î± ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® Î±Ï€Î±Î»Î»Î±Î³Î®',0),(338350,9399,'zh','å¹´åº¦è”é‚¦è±å…\r\n',0),(338351,9399,'sv','Ã…rliga Federal undantag',0),(338352,9399,'it','Esenzione federale annuale',0),(338353,9399,'tl','',0),(338354,9399,'th','&#3585;&#3634;&#3619;&#3618;&#3636;&#3609;&#3618;&#3629;&#3617;&#3585;&#3634;&#3619;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;&#3586;&#3629;&#3591;&#3619;&#3633;&#3600;&#3610;&#3634;&#3621;',0),(338355,9399,'hi','à¤µà¤¾à¤°à¥à¤·à¤¿à¤• à¤¸à¤‚à¤˜à¥€à¤¯ à¤›à¥‚à¤Ÿ',0),(338356,9399,'ms','Pengecualian Tahunan Persekutuan',0),(338357,9399,'ar','Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¥ØªØ­Ø§Ø¯ÙŠ Ø§Ù„Ø³Ù†ÙˆÙŠ',0),(338358,9399,'fr','Exemption fÃ©dÃ©rale annuelle',0),(338359,9399,'jp','å¹´æ¬¡ä¸­å¤®æ”¿åºœå…é™¤',0),(338360,9399,'pt','IsenÃ§Ã£o Federal anual',0),(338361,9399,'ru','Ð•Ð¶ÐµÐ³Ð¾Ð´Ð½Ð¾Ðµ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾',0),(338362,9399,'es','ExenciÃ³n Federal Anual',0),(338363,9399,'de','JÃ¤hrliche Bundesrepublik Befreiung',0),(338364,9399,'en','Annual Federal Exemption',0),(338365,9400,'is','',0),(338366,9400,'dr','ÙÙ‚Ø· Ø«Ø¨Øª Ø´ÙˆØ¯ Ø§Ú¯Ø± Ø´Ù…Ø§Ø±Ø´ Ù…Ø¹Ø§ÙÙŠØª Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡ ',0),(338367,9400,'pr','ÙÙ‚Ø· Ø«Ø¨Øª Ø´ÙˆØ¯ Ø§Ú¯Ø± Ø´Ù…Ø§Ø±Ø´ Ù…Ø¹Ø§ÙÙŠØª Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡ ',0),(338368,9400,'tr','Sadece muafiyet sayÄ±sÄ± gÃ¶rmezden, girin',0),(338369,9400,'pl','WprowadÅº tylko jeÅ›li ignorujÄ…c zwolnienia Count',0),(338370,9400,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð³Ñ€Ð°Ñ„',0),(338371,9400,'ur','Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ø´Ù…Ø§Ø± Ú©Ùˆ Ù†Ø¸Ø± Ø§Ù†Ø¯Ø§Ø² Ú©Ø± Ú©Û’ Ø§Ú¯Ø± ØµØ±Ù Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(338372,9400,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð·Ð°Ð½ÐµÐ¼Ð°Ñ€ÑƒÑ˜ÑƒÑ›Ð¸ Ð¸Ð·ÑƒÐ·Ð¸Ð¼Ð°ÑšÐ° Ð³Ñ€Ð¾Ñ„',0),(338373,9400,'vi','Chá»‰ nháº­p náº¿u bá» qua bá»™ Ä‘áº¿m miá»…n trá»«',0),(338374,9400,'af','Voer Slegs In, Indien Vrystellingstelling geignoreer word',0),(338375,9400,'ro','Intra doar dacÄƒ ignorarea scutirea Count',0),(338376,9400,'et','Sisestada ainult kui ignoreerides maksuvabastuse arv',0),(338377,9400,'si','Samo vnesite, Äe neupoÅ¡tevanje oprostitev Count',0),(338378,9400,'ba','Hanya masukkan jika mengabaikan pembebasan Count',0),(338379,9400,'nl','Vul alleen als het negeren van vrijstelling graaf',0),(338380,9400,'fi','Kirjoita vain jos unohdetaan vapautuksen mÃ¤Ã¤rÃ¤',0),(338381,9400,'no','Bare angi nÃ¥r ignorerer fritak teller',0),(338382,9400,'da','Indtast kun hvis ignorerer fritagelse Count',0),(338383,9400,'ko','ë©´ì œ íšŸìˆ˜ë¥¼ ë¬´ì‹œ í•˜ëŠ” ê²½ìš°ë§Œ ìž…ë ¥',0),(338384,9400,'he','×”×–×Ÿ ×¨×§ ×× ×”×ª×¢×œ×ž×•×ª ×¤×˜×•×¨ ×¡×¤×™×¨×”',0),(338385,9400,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼ÏŒÎ½Î¿ ÎµÎ¬Î½ Î±Î³Î½Î¿ÏŽÎ½Ï„Î±Ï‚ Î±Ï€Î±Î»Î»Î±Î³Î® Count',0),(338386,9400,'zh','åªå½“å¿½ç•¥è±å…è®¡æ•°æ—¶è¿›å…¥\r\n',0),(338387,9400,'sv','Bara ange om ignorera undantaget Count',0),(338388,9400,'it','Entrare solo se ignorando esenzione totali',0),(338389,9400,'tl','',0),(338390,9400,'th','&#3611;&#3657;&#3629;&#3609;&#3648;&#3593;&#3614;&#3634;&#3632;&#3585;&#3634;&#3619;&#3609;&#3633;&#3610;&#3607;&#3637;&#3656;&#3618;&#3585;&#3648;&#3623;&#3657;&#3609;',0),(338391,9400,'hi','à¤•à¥‡à¤µà¤² à¤›à¥‚à¤Ÿ à¤—à¤¿à¤¨à¤¤à¥€ à¤•à¥€ à¤…à¤¨à¤¦à¥‡à¤–à¥€, à¤¤à¥‹ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(338392,9400,'ms','Hanya masukkan jika mengabaikan kiraan pengecualian',0),(338393,9400,'ar','Ø£Ø¯Ø®Ù„ ÙÙ‚Ø· Ø¥Ø°Ø§ ØªØ¬Ø§Ù‡Ù„ Ø§Ù„ÙƒÙˆÙ†Øª Ø§Ù„Ø¥Ø¹ÙØ§Ø¡',0),(338394,9400,'fr','Entrez seulement si ignorant Exemption comte',0),(338395,9400,'jp','å…é™¤ã®æ•°ã‚’ç„¡è¦–ã™ã‚‹å ´åˆã®ã¿å…¥åŠ›ã—ã¾ã™ã€‚',0),(338396,9400,'pt','SÃ³ entrar se ignorando a contagem de isenÃ§Ã£o',0),(338397,9400,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð²Ð²ÐµÑÑ‚Ð¸, ÐµÑÐ»Ð¸ Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¸ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ð¹',0),(338398,9400,'es','Solo Entra Si Ignora El Conteo de Exenciones',0),(338399,9400,'de','Nur geben Sie ein, wenn Freistellung Graf ignorieren',0),(338400,9400,'en','Only Enter If Ignoring Exemption Count',0),(338401,9401,'is','',0),(338402,9401,'dr','Ù†Ù…Ø§Ø¯ Ø§Ø¹Ø´Ø§Ø± ',0),(338403,9401,'pr','Ù†Ù…Ø§Ø¯ Ø§Ø¹Ø´Ø§Ø± ',0),(338404,9401,'tr','OndalÄ±k simgesi',0),(338405,9401,'pl','Symbol dziesiÄ™tny',0),(338406,9401,'bg','Ð”ÐµÑÐµÑ‚Ð¸Ñ‡ÐµÐ½ ÑÐ¸Ð¼Ð²Ð¾Ð»',0),(338407,9401,'ur','Ø§Ø¹Ø´Ø§Ø±ÛŒ Ø¹Ù„Ø§Ù…Øª',0),(338408,9401,'sr','Ð”ÐµÑ†Ð¸Ð¼Ð°Ð»Ð½Ð¸ ÑÐ¸Ð¼Ð±Ð¾Ð»',0),(338409,9401,'vi','Biá»ƒu tÆ°á»£ng tháº­p phÃ¢n',0),(338410,9401,'af','Desimale Simbool',0),(338411,9401,'ro','Simbol zecimal',0),(338412,9401,'et','KÃ¼mnendikke eraldav sÃ¼mbol',0),(338413,9401,'si','Decimalni simbol',0),(338414,9401,'ba','Simbol desimal',0),(338415,9401,'nl','Decimaalteken',0),(338416,9401,'fi','Desimaalierotin',0),(338417,9401,'no','Desimaltegn',0),(338418,9401,'da','Decimalseparator',0),(338419,9401,'ko','ì†Œìˆ˜ì  ê¸°í˜¸',0),(338420,9401,'he','×¡×™×ž×Ÿ ×¢×©×¨×•× ×™',0),(338421,9401,'el','Î£ÏÎ¼Î²Î¿Î»Î¿ Ï…Ï€Î¿Î´Î¹Î±ÏƒÏ„Î¿Î»Î®Ï‚',0),(338422,9401,'zh','å°æ•°ç‚¹ç¬¦å·\r\n',0),(338423,9401,'sv','Decimaltecken',0),(338424,9401,'it','Separatore decimale',0),(338425,9401,'tl','',0),(338426,9401,'th','&#3626;&#3633;&#3597;&#3621;&#3633;&#3585;&#3625;&#3603;&#3660;&#3607;&#3624;&#3609;&#3636;&#3618;&#3617;',0),(338427,9401,'hi','à¤¦à¤¶à¤®à¤²à¤µ à¤ªà¥à¤°à¤¤à¥€à¤•',0),(338428,9401,'ms','Simbol perpuluhan',0),(338429,9401,'ar','Ø±Ù…Ø² Ø§Ù„Ø¹Ù„Ø§Ù…Ø© Ø§Ù„Ø¹Ø´Ø±ÙŠØ©',0),(338430,9401,'fr','Symbole dÃ©cimal',0),(338431,9401,'jp','å°æ•°ç‚¹ã®è¨˜å·',0),(338432,9401,'pt','SÃ­mbolo decimal',0),(338433,9401,'ru','Ð”ÐµÑÑÑ‚Ð¸Ñ‡Ð½Ñ‹Ð¹ ÑÐ¸Ð¼Ð²Ð¾Ð»',0),(338434,9401,'es','SÃ­mbolo Decimal',0),(338435,9401,'de','Dezimal-Symbol',0),(338436,9401,'en','Decimal Symbol',0),(338437,9402,'is','',0),(338438,9402,'dr','(Ø¯Ø³ØªÚ¯Ø§Ù‡ ØªØ¬Ø²ÙŠÙ‡',0),(338439,9402,'pr','Ù‡Ø²Ø§Ø±Ø§Ù† Ø¬Ø¯Ø§ÙƒÙ†Ù†Ø¯Ù‡ (Ø¯Ø³ØªÚ¯Ø§Ù‡ ØªØ¬Ø²ÙŠÙ‡',0),(338440,9402,'tr','Binler ayÄ±rÄ±cÄ±sÄ±',0),(338441,9402,'pl','TysiÄ™cy separatora',0),(338442,9402,'bg','Ð¥Ð¸Ð»ÑÐ´Ð¸ Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»',0),(338443,9402,'ur','ÛØ²Ø§Ø±ÙˆÚº Ø¬Ø¯Ø§ Ú©Ø§Ø±',0),(338444,9402,'sr','ÐÐ° Ñ…Ð¸Ñ™Ð°Ð´Ðµ Ð·Ð° Ñ€Ð°Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ',0),(338445,9402,'vi','Dáº¥u cÃ¡ch hÃ ng ngÃ n',0),(338446,9402,'af','Duisende Verdeler',0),(338447,9402,'ro','Mii Separator',0),(338448,9402,'et','Tuhandeliste eraldaja',0),(338449,9402,'si','TisoÄ loÄilo',0),(338450,9402,'ba','Ribuan pemisah',0),(338451,9402,'nl','Duizenden scheidingsteken',0),(338452,9402,'fi','Tuhansia erotin',0),(338453,9402,'no','Tusenvis skilletegn',0),(338454,9402,'da','Tusinder Separator',0),(338455,9402,'ko','ìˆ˜ì²œ êµ¬ë¶„',0),(338456,9402,'he','××œ×¤×™× ×ž×¤×¨×™×“',0),(338457,9402,'el','Î§Î¹Î»Î¹Î¬Î´ÎµÏ‚ Î´Î¹Î±Ï‡Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ',0),(338458,9402,'zh','åƒä½åˆ†éš”ç¬¦\r\n',0),(338459,9402,'sv','Tusentals avgrÃ¤nsare',0),(338460,9402,'it','Migliaia separatore',0),(338461,9402,'tl','',0),(338462,9402,'th','&#3649;&#3610;&#3656;&#3591;&#3609;&#3633;&#3610;&#3614;&#3633;&#3609;',0),(338463,9402,'hi','à¤¹à¤œà¤¾à¤°à¥‹à¤‚ à¤µà¤¿à¤­à¤¾à¤œà¤•',0),(338464,9402,'ms','Beribu-ribu pemisah',0),(338465,9402,'ar','Ø§Ù„Ø¢Ù„Ø§Ù ÙØ§ØµÙ„',0),(338466,9402,'fr','Des milliers sÃ©parateur',0),(338467,9402,'jp','æ•°åƒã®åŒºåˆ‡ã‚Šè¨˜å·',0),(338468,9402,'pt','Milhares separador',0),(338469,9402,'ru','Ð¢Ñ‹ÑÑÑ‡Ð¸ Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑŒ',0),(338470,9402,'es','Separador de miles',0),(338471,9402,'de','Tausende Separator',0),(338472,9402,'en','Thousands Separator',0),(338473,9403,'is','',0),(338474,9403,'dr','(Ø´Ø§Ø±Ú˜ ) ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯  Ø¨Ø§Ø·Ù„ Ø´ÙˆØ¯',0),(338475,9403,'pr','Ù‡Ø²ÙŠÙ†Ù‡ (Ø´Ø§Ø±Ú˜ ) ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯  Ø¨Ø§Ø·Ù„ Ø´ÙˆØ¯',0),(338476,9403,'tr','Kredi kartÄ± Ã¼cret hÃ¼kÃ¼msÃ¼z deÄŸil',0),(338477,9403,'pl','Nie moÅ¼na uniewaÅ¼niÄ‡ pÅ‚atnoÅ›ci kartÄ… kredytowÄ…',0),(338478,9403,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸ Ñ‚Ð°ÐºÑÐ° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½',0),(338479,9403,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú†Ø§Ø±Ø¬ ÙˆÙˆØ§ÚˆÛŒØ¯ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©Ø§',0),(338480,9403,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³Ð°Ð¾ Ð±Ð¸Ñ‚Ð¸ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(338481,9403,'vi','KhÃ´ng vÃ´ hiá»‡u Ä‘Æ°á»£c phÃ­ Tháº» TÃ­n Dá»¥ng',0),(338482,9403,'af','Krediet kaart gelaai kon nie ontlaste word nie',0),(338483,9403,'ro','Cardul de credit taxa nu ar putea fi anulate',0),(338484,9403,'et','Krediitkaardi tasu ei saanud kehtetu',0),(338485,9403,'si','Dajatev kreditno kartico ne bo razveljavljena.',0),(338486,9403,'ba','Biaya kartu kredit tidak menjadi Voided',0),(338487,9403,'nl','Credit Card kosten worden niet ongeldig verklaard.',0),(338488,9403,'fi','Luottokorttimaksu ei voitu mitÃ¤tÃ¶idÃ¤',0),(338489,9403,'no','Kredittkort kan ikke annulleres',0),(338490,9403,'da','Kreditkort gebyr kunne ikke afvises',0),(338491,9403,'ko','ì‹ ìš© ì¹´ë“œ ìš”ê¸ˆì„ ë¬´íš¨ ì²˜ë¦¬',0),(338492,9403,'he','×ª×©×œ×•× ×‘×›×¨×˜×™×¡ ××©×¨××™ ×™×›×•×œ ×œ× ×œ×”×™×•×ª ×©×ª×•×§×¤×Ÿ ×‘×•×˜×œ',0),(338493,9403,'el','Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î±ÎºÏ…ÏÏŽÎ½ÎµÏ„Î±Î¹ Î· Ï‡ÏÎ­Ï‰ÏƒÎ· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(338494,9403,'zh','ä¿¡ç”¨å¡è´¹ç”¨æ— æ³•è¢«ä½œåºŸ\r\n',0),(338495,9403,'sv','Kreditkort avgift kan inte ogiltigfÃ¶rklaras',0),(338496,9403,'it','Addebito su carta di credito non potrebbe essere annullata',0),(338497,9403,'tl','',0),(338498,9403,'th','&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3650;&#3604;&#3618;&#3594;&#3634;&#3619;&#3660;&#3592; &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3652;&#3604;&#3657;',0),(338499,9403,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥à¤²à¥à¤• Voided à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(338500,9403,'ms','Caj kad kredit tidak ditiadakan',0),(338501,9403,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªÙƒÙˆÙ† Ø¨Ø§Ø·Ù„Ø© Ø±Ø³ÙˆÙ… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(338502,9403,'fr','Frais de carte de crÃ©dit ne pourrait pas Ãªtre annulÃ©s',0),(338503,9403,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ãƒãƒ£ãƒ¼ã‚¸ãŒç„¡åŠ¹',0),(338504,9403,'pt','CartÃ£o de crÃ©dito nÃ£o pode ser anulada',0),(338505,9403,'ru','ÐÐµ Ð±Ñ‹Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð¿ÑƒÑ‰ÐµÐ½Ð½Ð°Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(338506,9403,'es','Carga de Tarjeta de CrÃ©dito no se Puede Anular',0),(338507,9403,'de','KreditkartengebÃ¼hr konnte nicht storniert werden',0),(338508,9403,'en','Credit Card Charge Could Not Be Voided',0),(338509,9404,'is','',0),(338510,9404,'dr','(Ø´Ø§Ø±Ú˜ ) ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù…Ø¹ÙƒÙˆØ³ Ø´Ø¯ ( Ø¨Ø±Ú¯Ø´Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯ ',0),(338511,9404,'pr','Ù‡Ø²ÙŠÙ†Ù‡ (Ø´Ø§Ø±Ú˜ ) ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù…Ø¹ÙƒÙˆØ³ Ø´Ø¯ ( Ø¨Ø±Ú¯Ø´Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯ ',0),(338512,9404,'tr','Kredi kartÄ± Ã¼cret baÅŸarÄ±yla ters',0),(338513,9404,'pl','Karty kredytowej opÅ‚atÄ… pomyÅ›lnie odwrÃ³cona',0),(338514,9404,'bg','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ñ‚Ð°ÐºÑÐ° ÑÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(338515,9404,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú†Ø§Ø±Ø¬ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ù„Ù¹',0),(338516,9404,'sr','ÐšÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¾Ð±Ñ€Ð½ÑƒÐ»Ð¾',0),(338517,9404,'vi','Äáº£o NgÆ°á»£c PhÃ­ Tháº» TÃ­n Dá»¥ng ThÃ nh CÃ´ng',0),(338518,9404,'af','Kredietkaartkoste Suksesvol Teruggeskryf',0),(338519,9404,'ro','Cardul de credit taxa inversat cu succes',0),(338520,9404,'et','Krediitkaardi tasu edukalt Ã¼mber pÃ¶Ã¶ranud',0),(338521,9404,'si','Dajatev kreditno kartico uspeÅ¡no stornirane',0),(338522,9404,'ba','Biaya kartu kredit yang berhasil terbalik',0),(338523,9404,'nl','Credit Card kosten met succes ongedaan gemaakt',0),(338524,9404,'fi','Luottokorttimaksu peruutettu',0),(338525,9404,'no','Kredittkortgebyr reversert',0),(338526,9404,'da','Kreditkort gebyr med succes vendt',0),(338527,9404,'ko','ì‹ ìš© ì¹´ë“œ ì¶©ì „ ì„±ê³µì ìœ¼ë¡œ ë°˜ì „',0),(338528,9404,'he','×ª×©×œ×•× ×‘×›×¨×˜×™×¡ ××©×¨××™ ×‘×”×¦×œ×—×” ×”×¤×•×š',0),(338529,9404,'el','Î§ÏÎ­Ï‰ÏƒÎ· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ Î±Î½Ï„Î­ÏƒÏ„ÏÎµÏˆÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(338530,9404,'zh','ä¿¡ç”¨å¡æ”¶è´¹æˆåŠŸæ‰­è½¬\r\n',0),(338531,9404,'sv','Kreditkort avgift framgÃ¥ngsrikt Ã¥terfÃ¶rda',0),(338532,9404,'it','Addebito su carta di credito invertito con successo',0),(338533,9404,'tl','',0),(338534,9404,'th','&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3650;&#3604;&#3618;&#3594;&#3634;&#3619;&#3660;&#3592;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(338535,9404,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥à¤²à¥à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤‰à¤²à¤Ÿ',0),(338536,9404,'ms','Caj kad kredit yang berjaya menyongsangkan',0),(338537,9404,'ar','Ø±Ø³ÙˆÙ… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¨Ù†Ø¬Ø§Ø­ Ø¹ÙƒØ³',0),(338538,9404,'fr','Frais de carte de crÃ©dit avec succÃ¨s inversÃ©',0),(338539,9404,'jp','é€†ã«æ­£å¸¸ã«ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ‰‹æ•°æ–™',0),(338540,9404,'pt','Carga de cartÃ£o de crÃ©dito invertida com sucesso',0),(338541,9404,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð²ÑÐ¿ÑÑ‚ÑŒ',0),(338542,9404,'es','Carga de Tarjeta de CrÃ©dito Reversada Exitosamente',0),(338543,9404,'de','KreditkartengebÃ¼hr erfolgreich storniert',0),(338544,9404,'en','Credit Card Charge Successfully Reversed',0),(338545,9405,'is','',0),(338546,9405,'dr','(Ø´Ø§Ø±Ú˜ ) ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ø§Ø·Ù„ Ø´Ø¯',0),(338547,9405,'pr','Ù‡Ø²ÙŠÙ†Ù‡ (Ø´Ø§Ø±Ú˜ ) ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ø§Ø·Ù„ Ø´Ø¯',0),(338548,9405,'tr','Kredi kartÄ± Ã¼cret baÅŸarÄ±yla hÃ¼kÃ¼msÃ¼z',0),(338549,9405,'pl','Karty kredytowej opÅ‚atÄ… pomyÅ›lnie anulowane',0),(338550,9405,'bg','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½ Ñ‚Ð°ÐºÑÐ° ÑÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(338551,9405,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú†Ø§Ø±Ø¬ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ÙˆÙˆØ§ÚˆÛŒØ¯',0),(338552,9405,'sr','ÐšÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½.',0),(338553,9405,'vi','VÃ´ hiá»‡u PhÃ­ Tháº» TÃ­n Dá»¥ng ThÃ nh CÃ´ng',0),(338554,9405,'af','Kredietkaartkoste Suksesvol Uitgevee',0),(338555,9405,'ro','Cardul de credit taxa anulat cu succes',0),(338556,9405,'et','Krediitkaardi tasu edukalt kustutatud',0),(338557,9405,'si','Dajatev kreditno kartico uspeÅ¡no razveljavljena',0),(338558,9405,'ba','Biaya kartu kredit yang berhasil Voided',0),(338559,9405,'nl','Credit Card kosten met succes ongeldig',0),(338560,9405,'fi','Luottokorttimaksu onnistui mitÃ¤tÃ¶ity',0),(338561,9405,'no','Kredittkortgebyr ble annullert',0),(338562,9405,'da','Kreditkort gebyr blev annulleret',0),(338563,9405,'ko','ì‹ ìš© ì¹´ë“œ ì¶©ì „ ì„±ê³µì ìœ¼ë¡œ ë¬´íš¨í™”',0),(338564,9405,'he','×ª×©×œ×•× ×‘×›×¨×˜×™×¡ ××©×¨××™ ×‘×”×¦×œ×—×” ×©×ª×•×§×¤×Ÿ ×‘×•×˜×œ',0),(338565,9405,'el','Î§ÏÎ­Ï‰ÏƒÎ· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚, Î½Î± Î±ÎºÏ…ÏÏ‰Î¸ÎµÎ¯ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(338566,9405,'zh','ä¿¡ç”¨å¡æ”¶è´¹æˆåŠŸæ— æ•ˆ\r\n',0),(338567,9405,'sv','Kreditkort avgift framgÃ¥ngsrikt annullerad',0),(338568,9405,'it','Addebito su carta di credito correttamente annullato',0),(338569,9405,'tl','',0),(338570,9405,'th','&#3610;&#3633;&#3605;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;&#3650;&#3604;&#3618;&#3594;&#3634;&#3619;&#3660;&#3592;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(338571,9405,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥à¤²à¥à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• Voided',0),(338572,9405,'ms','Caj kad kredit yang berjaya Voided',0),(338573,9405,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ØªÙ‡Ù…Ø© Ø¨Ø§Ø·Ù„Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(338574,9405,'fr','Frais de carte de crÃ©dit annulÃ©e avec succÃ¨s',0),(338575,9405,'jp','æ­£å¸¸ã«ç„¡åŠ¹ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ‰‹æ•°æ–™',0),(338576,9405,'pt','Carga de cartÃ£o de crÃ©dito com Ãªxito anulada',0),(338577,9405,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð¿ÑƒÑ‰ÐµÐ½Ð½Ð°Ñ',0),(338578,9405,'es','Carga de Tarjeta de CrÃ©dito Anulada Exitosamente',0),(338579,9405,'de','KreditkartengebÃ¼hr erfolgreich storniert',0),(338580,9405,'en','Credit Card Charge Successfully Voided',0),(338581,9406,'is','',0),(338582,9406,'dr','Ù„Ø·ÙØ§ Ø¨Ù‡ ØµÙˆØ±Øª Ø¯Ø³ØªÙŠ Ø´Ø§Ø±Ú˜ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø®Ø§Ø±Ø¬ Ø§Ø² Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø±Ø§ Ø¨Ø§Ø·Ù„ ÙƒÙ†ÙŠØ¯ ',0),(338583,9406,'pr','Ù„Ø·ÙØ§ Ø¨Ù‡ ØµÙˆØ±Øª Ø¯Ø³ØªÙŠ Ø´Ø§Ø±Ú˜ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø®Ø§Ø±Ø¬ Ø§Ø² Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø±Ø§ Ø¨Ø§Ø·Ù„ ÙƒÙ†ÙŠØ¯ ',0),(338584,9406,'tr','LÃ¼tfen el ile bu sistemin dÄ±ÅŸÄ±nda kredi kartÄ± Ã¼cret geÃ§ersiz.',0),(338585,9406,'pl','ProszÄ™ rÄ™cznie uniewaÅ¼nienia karty kredytowej opÅ‚aty od tego systemu.',0),(338586,9406,'bg','ÐœÐ¾Ð»Ñ Ñ€ÑŠÑ‡Ð½Ð¾ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸ Ñ‚Ð°ÐºÑÐ° Ð¸Ð·Ð²ÑŠÐ½ Ñ‚Ð°Ð·Ð¸ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°.',0),(338587,9406,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¯Ø³ØªÛŒ Ø·ÙˆØ± Ù¾Ø± Ø§Ø³ Ù†Ø¸Ø§Ù… Ø³Û’ Ø¨Ø§ÛØ± Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø§Ù„Ø²Ø§Ù… ØµÙØ± ÛÛ’ Û”',0),(338588,9406,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ, Ñ€ÑƒÑ‡Ð½Ð¾ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‚Ð¸ ÑÐ° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼ Ð¸Ð·Ð²Ð°Ð½ Ð¾Ð²Ð¾Ð³ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°.',0),(338589,9406,'vi','TrÃ¡nh vÃ´ hiá»‡u phÃ­ tháº» tÃ­n dá»¥ng thá»§ cÃ´ng bÃªn ngoai NolaPro',0),(338590,9406,'af','Verwerp asseblief die kredietkaartfooi buite NolaPro',0),(338591,9406,'ro','VÄƒ rugÄƒm sÄƒ manual anulat taxa de card de credit Ã®n afara de acest sistem.',0),(338592,9406,'et','Palun kÃ¤sitsi tÃ¼histada krediitkaardi tasu vÃ¤ljaspool seda sÃ¼steemi.',0),(338593,9406,'si','Prosimo, roÄno niÄna dajatev kreditno kartico zunaj tega sistema.',0),(338594,9406,'ba','Silakan secara manual membatalkan kartu kredit biaya di luar sistem ini.',0),(338595,9406,'nl','Gelieve ongeldig handmatig de creditcard kosten buiten dit systeem.',0),(338596,9406,'fi','Ota manuaalisesti mitÃ¤tÃ¶idÃ¤ luottokorttimaksu ulkopuolella tÃ¤mÃ¤n jÃ¤rjestelmÃ¤n.',0),(338597,9406,'no','Vennligst manuelt kansellere kredittkortbetalingen utenfor dette systemet.',0),(338598,9406,'da','Venligst manuelt ugyldiggÃ¸re kreditkort betaling uden for dette system.',0),(338599,9406,'ko','ì œë°œì´ ì‹œìŠ¤í…œ ì´ì™¸ì˜ ì‹ ìš© ì¹´ë“œ ìš”ê¸ˆ ìˆ˜ë™ìœ¼ë¡œ ë¬´íš¨í™”.',0),(338600,9406,'he','×‘×‘×§×©×” ×‘××•×¤×Ÿ ×™×“× ×™ ×œ×©×œ×•×œ ××ª ×”×ž×˜×¢×Ÿ ×›×¨×˜×™×¡ ××©×¨××™ ×ž×—×•×¥ ×ž×¢×¨×›×ª ×–×•.',0),(338601,9406,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Î½Î± Î±ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Î¼Îµ Î¼Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î¿ Ï„ÏÏŒÏ€Î¿ Ï„Î·Î½ Ï‡ÏÎ­Ï‰ÏƒÎ· Ï„Î·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ Î­Î¾Ï‰ Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±.',0),(338602,9406,'zh','è¯·æ‰‹åŠ¨åºŸé™¤NolaProå¤–çš„ä¿¡ç”¨å¡æ”¶è´¹',0),(338603,9406,'sv','VÃ¤nligen manuellt makulera kreditkort avgift utanfÃ¶r detta system.',0),(338604,9406,'it','Per favore manualmente invalidare l\'addebito della carta di credito di fuori di questo sistema.',0),(338605,9406,'tl','',0),(338606,9406,'th','Please manually void the credit card charge outside of NolaPro.',0),(338607,9406,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤°à¥‚à¤ª à¤¸à¥‡ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤†à¤°à¥‹à¤ª à¤®à¥‡à¤‚ à¤‡à¤¸ à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤•à¥‡ à¤¬à¤¾à¤¹à¤° à¤¶à¥‚à¤¨à¥à¤¯à¥¤',0),(338608,9406,'ms','Sila secara manual membatalkan caj kad kredit di luar sistem ini.',0),(338609,9406,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥ÙØ±Ø§Øº ÙŠØ¯ÙˆÙŠØ§Ù‹ Ù…Ù‚Ø§Ø¨Ù„ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø®Ø§Ø±Ø¬ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù….',0),(338610,9406,'fr','S\'il vous plaÃ®t manuellement annuler les frais de carte de crÃ©dit en dehors de ce systÃ¨me.',0),(338611,9406,'jp','ãã ã•ã„æ‰‹å‹•ã§ç„¡åŠ¹ã«ã“ã®ã‚·ã‚¹ãƒ†ãƒ ã®å¤–ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®å……é›»ã€‚',0),(338612,9406,'pt','Por favor manualmente anula a carga do cartÃ£o de crÃ©dito fora deste sistema.',0),(338613,9406,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ Ð½ÐµÐ´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð¹ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð¿Ð»Ð°Ñ‚Ñƒ Ð·Ð° Ð¿Ñ€ÐµÐ´ÐµÐ»Ð°Ð¼Ð¸ ÑÑ‚Ð¾Ð¹ ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹.',0),(338614,9406,'es','Por Favor anular manualmente la carga de tarjeta de crÃ©dito afuera de NolaPro',0),(338615,9406,'de','Bitte manuell ErlÃ¶schen Sie die Kreditkarte kostenlos auÃŸerhalb dieses Systems.',0),(338616,9406,'en','Please manually void the credit card charge outside of this system.',0),(338617,9407,'is','',0),(338618,9407,'dr','Ø³Ø±ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ØªØ±Ø§Ø² Ù†ÙŠØ³Øª ',0),(338619,9407,'pr','Ø³Ø±ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ØªØ±Ø§Ø² Ù†ÙŠØ³Øª ',0),(338620,9407,'tr','Hareket kÃ¼mesini dengeli deÄŸil.',0),(338621,9407,'pl','Zestaw transakcji nie jest zrÃ³wnowaÅ¼ony.',0),(338622,9407,'bg','ÐÐ°Ð±Ð¾Ñ€ Ð¾Ñ‚ ÑÐ´ÐµÐ»ÐºÐ°Ñ‚Ð° Ð½Ðµ Ðµ Ð±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð°Ð½Ð°.',0),(338623,9407,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø³ÛŒÙ¹ Ù…ØªÙˆØ§Ø²Ù† Ù†ÛÛŒÚº ÛÛ’ Û”',0),(338624,9407,'sr','Ð¡ÐºÑƒÐ¿Ñƒ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð¸Ñ˜Ðµ Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÑ’ÐµÐ½.',0),(338625,9407,'vi','Giao dá»‹ch chÆ°a cÃ¢n Ä‘á»‘i',0),(338626,9407,'af','Die gestelde transaksie balanseer nie.',0),(338627,9407,'ro','Setul de tranzacÅ£ie nu este echilibrat.',0),(338628,9407,'et','Tehingu komplekt on tasakaalustatud.',0),(338629,9407,'si','Niz transakcij ni uravnoteÅ¾ena.',0),(338630,9407,'ba','Kumpulan transaksi yang tidak seimbang.',0),(338631,9407,'nl','De transactie-set is niet evenwichtig.',0),(338632,9407,'fi','Tapahtuman set ei ole tasapainoinen.',0),(338633,9407,'no','Hvilke transaksjonen er ikke balansert.',0),(338634,9407,'da','Transaktionen sÃ¦t er ikke afbalanceret.',0),(338635,9407,'ko','íŠ¸ëžœìž­ì…˜ ì§‘í•© í•˜ì§€ ê· í˜• ì´ë‹¤.',0),(338636,9407,'he','×¢×¨×›×ª ×”×˜×¨× ×–×§×¦×™×” ××™× ×” ×ž××•×–× ×ª.',0),(338637,9407,'el','Î¤Î¿ ÏƒÏÎ½Î¿Î»Î¿ ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î·Î¼Î­Î½Î·.',0),(338638,9407,'zh','æœ¬æ¬¡äº¤æ˜“é›†æ²¡æœ‰ç»“ä½™ã€‚\r\n',0),(338639,9407,'sv','Den transaktion som Ã¤r inte balanserad.',0),(338640,9407,'it','Il set di transazioni non Ã¨ equilibrato.',0),(338641,9407,'tl','',0),(338642,9407,'th','&#3605;&#3633;&#3657;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3652;&#3617;&#3656;&#3626;&#3617;&#3604;&#3640;&#3621;',0),(338643,9407,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¸à¥‡à¤Ÿ à¤¸à¤‚à¤¤à¥à¤²à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(338644,9407,'ms','Set urus niaga yang tidak seimbang.',0),(338645,9407,'ar','Ù‡Ø°Ù‡ Ø§Ù„Ø¹Ù…Ù„ÙŠØ§Øª ØºÙŠØ± Ù…ØªÙˆØ§Ø²Ù†Ø©',0),(338646,9407,'fr','Lâ€™ensemble de la transaction nâ€™est pas Ã©quilibrÃ©.',0),(338647,9407,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ã‚»ãƒƒãƒˆãŒå‡ç­‰ã§ãªã„ã§ã™ã€‚',0),(338648,9407,'pt','O conjunto de transaÃ§Ãµes nÃ£o estÃ¡ equilibrado.',0),(338649,9407,'ru','ÐÐ°Ð±Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ Ð½Ðµ ÑÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð°.',0),(338650,9407,'es','El Juego Transaccional no esta en balance',0),(338651,9407,'de','Transaktionssatz ist nicht ausgewogen.',0),(338652,9407,'en','The transaction set is not balanced.',0),(338653,9408,'is','',0),(338654,9408,'dr','/ Ù„ØºÙˆ  Ø¨ÛŒØ¬Ú© ',0),(338655,9408,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ / Ù„ØºÙˆ  ÙØ§ÙƒØªÙˆØ± ',0),(338656,9408,'tr','Fatura gÃ¶rÃ¼ntÃ¼le/iptal',0),(338657,9408,'pl','Zobacz/Anuluj fakturÄ™',0),(338658,9408,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð·Ð³Ð»ÐµÐ´/Ð¾Ñ‚ÐºÐ°Ð·',0),(338659,9408,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ù†Ø¸Ø±/Ù…Ù†Ø³ÙˆØ®',0),(338660,9408,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· /ÐžÑ‚ÐºÐ°Ð¶Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(338661,9408,'vi','Xem/Há»§y hÃ³a Ä‘Æ¡n ',0),(338662,9408,'af','Faktuur Besigtig/Kanseleer',0),(338663,9408,'ro','Vezi factura/anulare',0),(338664,9408,'et','Vaata/TÃ¼hista arve',0),(338665,9408,'si','RaÄun pogled/PrekliÄi',0),(338666,9408,'ba','Faktur View/membatalkan',0),(338667,9408,'nl','Factuur bekijken/annuleren',0),(338668,9408,'fi','Laskun View/Peruuta',0),(338669,9408,'no','Faktura Vis/Avbestill',0),(338670,9408,'da','Faktura visning/Annuller',0),(338671,9408,'ko','ì²­êµ¬ì„œ ë³´ê¸°/ì·¨ì†Œ',0),(338672,9408,'he','×”×¦×’/×‘×˜×œ ×—×©×‘×•× ×™×ª',0),(338673,9408,'el','Î ÏÎ¿Î²Î¿Î»Î®/Î±ÎºÏÏÏ‰ÏƒÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(338674,9408,'zh','å‘ç¥¨æŸ¥çœ‹/å–æ¶ˆ\r\n',0),(338675,9408,'sv','Faktura Visa/Avbryt',0),(338676,9408,'it','Fattura consulta/annulla',0),(338677,9408,'tl','',0),(338678,9408,'th','&#3604;&#3641;/&#3618;&#3585;&#3648;&#3621;&#3636;&#3585; &#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(338679,9408,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¦à¥ƒà¤¶à¥à¤¯/à¤°à¤¦à¥à¤¦',0),(338680,9408,'ms','Invois View/Batal',0),(338681,9408,'ar','Ø¹Ø±Ø¶/Ø¥Ù„ØºØ§Ø¡ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(338682,9408,'fr','Voir/Annuler une Facture',0),(338683,9408,'jp','è«‹æ±‚æ›¸è¡¨ç¤º/ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(338684,9408,'pt','Fatura ver/cancelar',0),(338685,9408,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ð¾Ñ‚Ð¼ÐµÐ½Ð° Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(338686,9408,'es','Factura Vistar/Cancelar',0),(338687,9408,'de','Rechnung anzeigen/abbrechen',0),(338688,9408,'en','Invoice View/Cancel',0),(338689,9409,'is','',0),(338690,9409,'dr','Ø§Ø¹Ù…Ø§Ù„ Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø³Ù‡Ù… Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¨ÙŠÙ…Ù‡ Ù¾Ø²Ø´ÙƒÙŠ Ø¯Ø± Ù‡Ø± Ø¯ÙˆØ±Ù‡ Ù†Ù‡ Ø¯Ø± Ø³Ø§Ù„ ',0),(338691,9409,'pr','Ø§Ø¹Ù…Ø§Ù„ Ù…Ø§ÙƒØ²ÙŠÙ…Ù… Ø³Ù‡Ù… Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ Ùˆ Ø¨ÙŠÙ…Ù‡ Ù¾Ø²Ø´ÙƒÙŠ Ø¯Ø± Ù‡Ø± Ø¯ÙˆØ±Ù‡ Ù†Ù‡ Ø¯Ø± Ø³Ø§Ù„ ',0),(338692,9409,'tr','FICA Max dÃ¶nem deÄŸil yÄ±l baÅŸÄ±na uygulamak',0),(338693,9409,'pl','ZastosowaÄ‡ FICA Max za okres roku nie',0),(338694,9409,'bg','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð° FICA ÐœÐ°ÐºÑ ÐµÐ´Ð¸Ð½ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(338695,9409,'ur','ÙØ§Ú©ÛŒ Ú©ÛŒ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø¯ÙˆØ± Ù†ÛÛŒÚº Ø³Ø§Ù„ ÙÛŒ Ù„Ú¯Ø§Ø¦ÛŒÚº',0),(338696,9409,'sr','ÐŸÑ€Ð¸Ð¼ÐµÐ½Ð° ÐžÐ”Ð Ð•Ð¡ÐšÐ£ ÐœÐ°x Ð¿Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñƒ Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(338697,9409,'vi','á»¨ng Dá»¥ng má»©c báº£o hiá»ƒm xÃ£ há»™i tá»‘i Ä‘a theo giai Ä‘oáº¡n khÃ´ng theo nÄƒm',0),(338698,9409,'af','FICA Max per periode nie jaar van toepassing',0),(338699,9409,'ro','Aplica FICA Max pe o perioadÄƒ nu an',0),(338700,9409,'et','Rakendada Sotsiaalmaksu Max mitte aasta, mil',0),(338701,9409,'si','Uporablja FICA Max na obdobje ne',0),(338702,9409,'ba','Menerapkan FICA Max per periode tidak tahun',0),(338703,9409,'nl','FICA Max per periode niet jaar toepassen',0),(338704,9409,'fi','Soveltaa FICA Max aikana ei vuonna',0),(338705,9409,'no','Bruke FICA Max per periode ikke Ã¥r',0),(338706,9409,'da','Anvende FICA Max pr. periode ikke Ã¥r',0),(338707,9409,'ko','ê¸°ê°„ í•˜ì§€ ë…„ ë‹¹ê°€ ë´ ìµœëŒ€ ì ìš©',0),(338708,9409,'he','×”×—×œ×ª ×œ×‘×™×˜×•×— ×”×œ××•×ž×™ ×”×¤×“×¨×œ×™ ×ž×§×¡ ×”×ª×§×•×¤×ª×™ ×œ× ×”×©× ×”',0),(338709,9409,'el','Î•Ï†Î±ÏÎ¼ÏŒÏƒÏ„Îµ ÏƒÏ…Î¼Î²Î¿Ï…Î»Î® Max Î±Î½Î¬ Ï€ÎµÏÎ¯Î¿Î´Î¿ ÏŒÏ‡Î¹ Î­Ï„Î¿Ï‚',0),(338710,9409,'zh','æ¯æœŸç”³è¯·ç¤¾ä¼šä¿é™©å¹´åº¦æœ€å¤šä¸\r\n',0),(338711,9409,'sv','TillÃ¤mpa FICA Max per Ã¥r inte',0),(338712,9409,'it','Applicare Max FICA al periodo dell\'anno non',0),(338713,9409,'tl','',0),(338714,9409,'th','&#3651;&#3594;&#3657; FICA &#3626;&#3641;&#3591;&#3626;&#3640;&#3604; &#3605;&#3656;&#3629; &#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3652;&#3617;&#3656;&#3588;&#3619;&#3610;&#3611;&#3637;',0),(338715,9409,'hi','FICA Max à¤¨à¤¹à¥€à¤‚ à¤µà¤°à¥à¤· à¤•à¥€ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤…à¤¨à¥à¤¸à¤¾à¤° à¤²à¤¾à¤—à¥‚',0),(338716,9409,'ms','Memohon FICA Max satu tempoh tahun tidak',0),(338717,9409,'ar','ØªØ·Ø¨ÙŠÙ‚ Ù…Ø§ÙƒØ³ Ù…Ø­ÙƒÙ…ÙŠ ÙƒÙ„ ÙØªØ±Ø© Ù„ÙŠØ³ Ù…Ù† Ø§Ù„Ø³Ù†Ø©',0),(338718,9409,'fr','Appliquer le FICA Max par pÃ©riode pas an',0),(338719,9409,'jp','æœŸé–“ãªãã€å¹´ã‚ãŸã‚Š FICA Max ã‚’é©ç”¨ã—ã¾ã™ã€‚',0),(338720,9409,'pt','Aplicar o Max FICA por perÃ­odo do ano nÃ£o',0),(338721,9409,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÐœÐ°ÐºÑ FICA Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð½Ðµ Ð³Ð¾Ð´',0),(338722,9409,'es','Aplica FICA MÃ¡ximo por PerÃ­odo no por AÃ±o',0),(338723,9409,'de','FICA Max pro Jahr nicht anwenden',0),(338724,9409,'en','Apply FICA Max per Period not Year',0),(338725,9410,'is','',0),(338726,9410,'dr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø´Ø±Ø§ÙŠØ· ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ ÙƒØ§Ø±Ø¨Ø±Ø§Ù†  Ø¯ÙŠÚ¯Ø± ',0),(338727,9410,'pr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø´Ø±Ø§ÙŠØ· ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ ÙƒØ§Ø±Ø¨Ø±Ø§Ù†  Ø¯ÙŠÚ¯Ø± ',0),(338728,9410,'tr','DiÄŸer Timeclock kullanÄ±cÄ±lar iÃ§in oturum aÃ§ma durumu blok gÃ¶rÃ¼nÃ¼m',0),(338729,9410,'pl','Widok bloku stan logowania do innych uÅ¼ytkownikÃ³w za darmo',0),(338730,9410,'bg','Ð‘Ð»Ð¾Ðº Ð¸Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑ Ð·Ð° Ð´Ñ€ÑƒÐ³Ð¸ Timeclock Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(338731,9410,'ur','Ø¯ÛŒÚ¯Ø± Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© ØµØ§Ø±ÙÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ù„Ø§Ú¯ Ø§Ù† Ø­Ø§Ù„Øª Ú©Û’ Ø¨Ù„Ø§Ú© Ù…Ù†Ø¸Ø±',0),(338732,9410,'sr','Ð‘Ð»Ð¾Ðº Ð¿Ñ€Ð¸ÐºÐ°Ð· ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð° Ð·Ð° Ð´Ñ€ÑƒÐ³Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐµ Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº',0),(338733,9410,'vi','NgÆ°á»i sá»­ dá»¥ng mÃ¡y cháº¥m cÃ´ng khÃ´ng nhÃ¬n tháº¥y tÃ¬nh tráº¡ng Ä‘Äƒng nháº­p',0),(338734,9410,'af','Blokeer Besigtiging van Aantekening Status vir Ander Tydklok Gebruikers',0),(338735,9410,'ro','Bloc de vedere statutul de conectare pentru alÅ£i utilizatori de ceas',0),(338736,9410,'et','Plokk vaade logimisolek Timeclock teistele kasutajatele',0),(338737,9410,'si','Blok pogled na stanje prijave za druge uporabnike Timeclock',0),(338738,9410,'ba','Blok View status Login untuk pengguna Timeclock',0),(338739,9410,'nl','Weergave van het blok van aanmeldstatus voor andere gebruikers van de klok',0),(338740,9410,'fi','Blokki katsella kirjautuminen asemaan muiden Timeclock kÃ¤yttÃ¤jien',0),(338741,9410,'no','Blokkere visning av logikk Status for andre Timeclock brukere',0),(338742,9410,'da','Blok visning af loginstatus for andre Timeclock brugere',0),(338743,9410,'ko','ë‹¤ë¥¸ Timeclock ì‚¬ìš©ìžì— ëŒ€ í•œ ë¡œê·¸ì¸ ìƒíƒœì˜ ë¸”ë¡ ë³´ê¸°',0),(338744,9410,'he','×ª×¦×•×’×ª ×‘×œ×•×§ ×©×œ ×ž×¦×‘ ×”×”×ª×—×‘×¨×•×ª ×¢×‘×•×¨ ×ž×©×ª×ž×©×™× ××—×¨×™× Timeclock',0),(338745,9410,'el','Î ÏÎ¿Î²Î¿Î»Î® Î¼Ï€Î»Î¿Îº ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ Î³Î¹Î± Î¬Î»Î»Î¿Ï…Ï‚ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Timeclock',0),(338746,9410,'zh','å…¶ä»–Timeclockç”¨æˆ·ç™»å½•çŠ¶æ€æŸ¥çœ‹\r\n',0),(338747,9410,'sv','Blockera vyn av inloggningsstatus fÃ¶r andra Timeclock anvÃ¤ndare',0),(338748,9410,'it','Vista di blocco del Login Status per altri utenti di Timeclock',0),(338749,9410,'tl','',0),(338750,9410,'th','&#3610;&#3621;&#3655;&#3629;&#3585;&#3585;&#3634;&#3619;&#3604;&#3641;&#3586;&#3629;&#3591;&#3626;&#3606;&#3634;&#3609;&#3632;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3619;&#3632;&#3610;&#3610;&#3586;&#3629;&#3591;&#3612;&#3',0),(338751,9410,'hi','à¤…à¤¨à¥à¤¯ Timeclock à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥‰à¤—à¤¿à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¤¾ à¤¬à¥à¤²à¥‰à¤• à¤¦à¥ƒà¤¶à¥à¤¯',0),(338752,9410,'ms','Pandangan blok status Login untuk pengguna Timeclock lain',0),(338753,9410,'ar','Ø¹Ø±Ø¶ Ø¨Ù„ÙˆÙƒ ÙÙŠ Ø­Ø§Ù„Ø© ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ø¢Ø®Ø±ÙŠÙ† ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(338754,9410,'fr','Vue de bloc de lâ€™Ã©tat de connexion pour les autres utilisateurs Timeclock',0),(338755,9410,'jp','ä»–ã®ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®ãƒ­ã‚°ã‚¤ãƒ³çŠ¶æ…‹ã®ãƒ–ãƒ­ãƒƒã‚¯ã‚’è¡¨ç¤ºã—ã¾ã™',0),(338756,9410,'pt','Vista do bloco de Status de Login para outros usuÃ¡rios Timeclock',0),(338757,9410,'ru','Ð’Ð¸Ð´ Ð±Ð»Ð¾ÐºÐ° ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð²Ñ…Ð¾Ð´Ð° Ð´Ð»Ñ Ð´Ñ€ÑƒÐ³Ð¸Ñ… Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ Timeclock',0),(338758,9410,'es','Bloquea la vista de Estado de Login para Otros Usuarios de Reloj Marcador',0),(338759,9410,'de','Block-Ansicht des Login-Status fÃ¼r andere Timeclock Benutzer',0),(338760,9410,'en','Block View of Login Status for Other Timeclock Users',0),(338761,9411,'is','',0),(338762,9411,'dr','Ø­Ø³Ø§Ø¨ Ø¹Ù…Ù„Ú©Ø±Ø¯ Ø§Ø±Ø²',0),(338763,9411,'pr','Ø­Ø³Ø§Ø¨ Ø¹Ù…Ù„Ú©Ø±Ø¯ Ø§Ø±Ø²',0),(338764,9411,'tr','DÃ¶viz Ticaret hesabÄ±',0),(338765,9411,'pl','Waluty Trading konto',0),(338766,9411,'bg','ÐÐºÐ°ÑƒÐ½Ñ‚ Ð·Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²Ð¸Ñ Ð½Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(338767,9411,'ur','Ú©Ø±Ù†Ø³ÛŒ Ù¹Ø±ÛŒÚˆÙ†Ú¯ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(338768,9411,'sr','Ð’Ð°Ð»ÑƒÑ‚Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð·Ð° Ñ‚Ñ€Ð³Ð¾Ð²Ð°ÑšÐµ',0),(338769,9411,'vi','TK Giao Dá»‹ch Tiá»n Tá»‡',0),(338770,9411,'af','Valuta handel rekening',0),(338771,9411,'ro','MonedÄƒ de tranzacÅ£ionare cont',0),(338772,9411,'et','Valuuta Trading konto',0),(338773,9411,'si','Valuta Trading raÄun',0),(338774,9411,'ba','Rekening perdagangan mata uang',0),(338775,9411,'nl','Valuta Trading Account',0),(338776,9411,'fi','Valuutta Trading tili',0),(338777,9411,'no','Valuta Trading konto',0),(338778,9411,'da','Valuta Trading konto',0),(338779,9411,'ko','í†µí™” íŠ¸ë ˆì´ë”© ê³„ì •',0),(338780,9411,'he','×—×©×‘×•×Ÿ ×ž×¡×—×¨ ×ž×˜×‘×¢',0),(338781,9411,'el','ÎÏŒÎ¼Î¹ÏƒÎ¼Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½',0),(338782,9411,'zh','è´§å¸äº¤æ˜“è´¦æˆ·\r\n',0),(338783,9411,'sv','Valuta handelskonto',0),(338784,9411,'it','Conto di Trading di valuta',0),(338785,9411,'tl','',0),(338786,9411,'th','&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(338787,9411,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤Ÿà¥à¤°à¥‡à¤¡à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¥‡',0),(338788,9411,'ms','Akaun perdagangan Mata Wang',0),(338789,9411,'ar','Ø­Ø³Ø§Ø¨ ØªØ¯Ø§ÙˆÙ„ Ø§Ù„Ø¹Ù…Ù„Ø§Øª',0),(338790,9411,'fr','Compte de Trading de devises',0),(338791,9411,'jp','é€šè²¨ã®å–å¼•å£åº§',0),(338792,9411,'pt','Conta de negociaÃ§Ã£o de moeda',0),(338793,9411,'ru','Ð’Ð°Ð»ÑŽÑ‚Ð° Ñ‚Ð¾Ñ€Ð³Ð¾Ð²Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(338794,9411,'es','Cuenta de Intercambio de Monedas',0),(338795,9411,'de','WÃ¤hrung-Trading-Konto',0),(338796,9411,'en','Currency Trading Account',0),(338797,9412,'is','',0),(338798,9412,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(338799,9412,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(338800,9412,'tr','Bir ticaret hesabÄ± girmeniz gerekir.',0),(338801,9412,'pl','NaleÅ¼y wprowadziÄ‡ konto handlowe.',0),(338802,9412,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²Ð¸Ñ.',0),(338803,9412,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù¹Ø±ÛŒÚˆÙ†Ú¯ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(338804,9412,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ñ‚Ñ€Ð³Ð¾Ð²Ð°ÑšÐµ.',0),(338805,9412,'vi','Báº¡n pháº£i nháº­p 1 TK Giao Dá»‹ch ',0),(338806,9412,'af','U moet \'n HANDELSREKENING invoer.',0),(338807,9412,'ro','Trebuie sa introduceti un cont comercial',0),(338808,9412,'et','Te peate sisestama kauplemiskonto',0),(338809,9412,'si','Vnesite raÄun za trgovanje.',0),(338810,9412,'ba','Anda harus memasukkan akun perdagangan.',0),(338811,9412,'nl','U moet een Trading Account invoeren.',0),(338812,9412,'fi','Kirjoita Trading tili.',0),(338813,9412,'no','Du mÃ¥ angi en Trading konto.',0),(338814,9412,'da','Du skal angive en Trading konto.',0),(338815,9412,'ko','ê±°ëž˜ ê³„ì¢Œë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(338816,9412,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×—×©×‘×•×Ÿ ×”×ž×¡×—×¨.',0),(338817,9412,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½.',0),(338818,9412,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªäº¤æ˜“è´¦æˆ·ã€‚\r\n',0),(338819,9412,'sv','Du mÃ¥ste ange en handelskonto.',0),(338820,9412,'it','Ãˆ necessario immettere un Account di Trading.',0),(338821,9412,'tl','',0),(338822,9412,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3619;&#3629;&#3585;&#3610;&#3633;&#3597;&#3594;&#3637;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(338823,9412,'hi','à¤†à¤ªà¤•à¥‹ à¤à¤• à¤Ÿà¥à¤°à¥‡à¤¡à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(338824,9412,'ms','Awda mesti masukkan satu akaun perdagangan.',0),(338825,9412,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ \"Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØªØ§Ø¬Ø±Ø©\".',0),(338826,9412,'fr','Vous devez entrer un compte de transaction',0),(338827,9412,'jp','å–å¼•ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(338828,9412,'pt','VocÃª deve inserir uma conta de negociaÃ§Ã£o.',0),(338829,9412,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ñ‚Ð¾Ñ€Ð³Ð¾Ð²Ñ‹Ð¹ ÑÑ‡ÐµÑ‚.',0),(338830,9412,'es','Debe entra una Cuenta de Compraventa',0),(338831,9412,'de','Sie mÃ¼ssen ein Trading-Konto eingeben.',0),(338832,9412,'en','You must enter a Trading Account.',0),(338833,9413,'is','',0),(338834,9413,'dr','Ù†Ø±Ø® Ø§Ø±Ø² Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(338835,9413,'pr','Ù†Ø±Ø® Ø§Ø±Ø² Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(338836,9413,'tr','DÃ¶viz kurlarÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(338837,9413,'pl','Kursy walut pomyÅ›lnie zaktualizowana',0),(338838,9413,'bg','Ð’Ð°Ð»ÑƒÑ‚Ð½Ð¸ ÐºÑƒÑ€ÑÐ¾Ð²Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(338839,9413,'ur','Ú©Ø±Ù†Ø³ÛŒ Ú©ÛŒ Ø´Ø±Ø­ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(338840,9413,'sr','Ð’Ð°Ð»ÑƒÑ‚Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(338841,9413,'vi','Cáº­p Nháº­t Tá»· giÃ¡ ngoáº¡i tá»‡ thÃ nh cÃ´ng',0),(338842,9413,'af','Geldeenheid Koers suksesvol Opdateer',0),(338843,9413,'ro','Valutar actualizat cu succes',0),(338844,9413,'et','Valuutakursid uuendati eduakalt',0),(338845,9413,'si','TeÄajih, uspeÅ¡no posodobljena',0),(338846,9413,'ba','Kurs mata uang yang berhasil',0),(338847,9413,'nl','Wisselkoersen bijgewerkt',0),(338848,9413,'fi','Valuuttakurssien pÃ¤ivittÃ¤minen onnistui',0),(338849,9413,'no','Valutakurser oppdatert',0),(338850,9413,'da','Valutakurser opdateret',0),(338851,9413,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” í†µí™” ìš”ê¸ˆ',0),(338852,9413,'he','×©×¢×¨×™ ×”×—×œ×™×¤×™×Ÿ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(338853,9413,'el','Î™ÏƒÎ¿Ï„Î¹Î¼Î¯ÎµÏ‚ Î½Î¿Î¼Î¹ÏƒÎ¼Î¬Ï„Ï‰Î½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(338854,9413,'zh','è´§å¸æ±‡çŽ‡æ›´æ–°æˆåŠŸ\r\n',0),(338855,9413,'sv','Valutakurser som uppdaterats',0),(338856,9413,'it','Valuta i tassi aggiornati correttamente',0),(338857,9413,'tl','',0),(338858,9413,'th','&#3629;&#3633;&#3588;&#3619;&#3634;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(338859,9413,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤®à¥à¤¦à¥à¤°à¤¾ à¤¦à¤°',0),(338860,9413,'ms','Kadar Mata Wang yang berjaya dikemas kini',0),(338861,9413,'ar','Ø­Ø¯Ù‘Ø«Øª Ø£Ø³Ø¹Ø§Ø± ØµØ±Ù Ø§Ù„Ø¹Ù…Ù„Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(338862,9413,'fr','Taux de change mis Ã  jour avec succÃ¨s',0),(338863,9413,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸé€šè²¨ãƒ¬ãƒ¼ãƒˆ',0),(338864,9413,'pt','Taxas de cÃ¢mbio atualizadas com sucesso',0),(338865,9413,'ru','ÐšÑƒÑ€ÑÑ‹ Ð’Ð°Ð»ÑŽÑ‚Ñ‹ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(338866,9413,'es','Tipos de Cambio Actualizados Exitosamente',0),(338867,9413,'de','WÃ¤hrungskurse erfolgreich aktualisiert',0),(338868,9413,'en','Currency Rates Updated Successfully',0),(338869,9414,'is','',0),(338870,9414,'dr','( Ù†Ø§Ø¸Ø±) Ù†Ø±Ø® Ø§Ø±Ø²',0),(338871,9414,'pr','Ù…Ø¯ÙŠØ± ( Ù†Ø§Ø¸Ø±) Ù†Ø±Ø® Ø§Ø±Ø²',0),(338872,9414,'tr','Para birimi oranÄ± YÃ¶neticisi',0),(338873,9414,'pl','MenadÅ¼er kursÃ³w walut',0),(338874,9414,'bg','Ð’Ð°Ð»ÑƒÑ‚Ð° ÐºÑƒÑ€Ñ Ð¼ÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€',0),(338875,9414,'ur','Ú©Ø±Ù†Ø³ÛŒ Ú©ÛŒ Ø´Ø±Ø­ Ù…ÛŒÙ†ÛŒØ¬Ø±',0),(338876,9414,'sr','ÐœÐµÐ½Ð°ÑŸÐµÑ€ ÑÑ‚Ð¾Ð¿Ð° Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(338877,9414,'vi','Quáº£n LÃ½ Tá»· GiÃ¡ Tiá»n Tá»‡',0),(338878,9414,'af','Geldeenheid Koers Bestuurder',0),(338879,9414,'ro','Manager de cursul valutar',0),(338880,9414,'et','Valuutakursi haldaja',0),(338881,9414,'si','Manager teÄaj valute',0),(338882,9414,'ba','Manajer tingkat mata uang',0),(338883,9414,'nl','Munt tarief Manager',0),(338884,9414,'fi','Rahan mÃ¤Ã¤rÃ¤ hallinta',0),(338885,9414,'no','Valuta pris Manager',0),(338886,9414,'da','Valuta kurs Manager',0),(338887,9414,'ko','í†µí™” ìš”ê¸ˆ ê´€ë¦¬ìž',0),(338888,9414,'he','×ž×˜×‘×¢ ×§×¦×‘ ×ž× ×”×œ',0),(338889,9414,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Î¹ÏƒÎ¿Ï„Î¹Î¼Î¯Î± Ï„Î¿Ï… Î½Î¿Î¼Î¯ÏƒÎ¼Î±Ï„Î¿Ï‚',0),(338890,9414,'zh','è´§å¸çš„æ±‡çŽ‡ç®¡ç†\r\n',0),(338891,9414,'sv','Valuta kurs Manager',0),(338892,9414,'it','Valuta Rate Manager',0),(338893,9414,'tl','',0),(338894,9414,'th','&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3629;&#3633;&#3605;&#3619;&#3634;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(338895,9414,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤¦à¤° à¤ªà¥à¤°à¤¬à¤‚à¤§à¤•',0),(338896,9414,'ms','Pengurus kadar Mata Wang',0),(338897,9414,'ar','Ù…Ø¯ÙŠØ± Ø³Ø¹Ø± ØµØ±Ù Ø§Ù„Ø¹Ù…Ù„Ø©',0),(338898,9414,'fr','Gestionnaire de taux de devise',0),(338899,9414,'jp','é€šè²¨ãƒ¬ãƒ¼ãƒˆ ãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼',0),(338900,9414,'pt','Gerenciador de taxa de moeda',0),(338901,9414,'ru','Ð ÑƒÐºÐ¾Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒ ÐºÑƒÑ€ÑÐ° Ð²Ð°Ð»ÑŽÑ‚Ñ‹',0),(338902,9414,'es','Administrador de Tipos de Cambio',0),(338903,9414,'de','WÃ¤hrungs-Rate-Manager',0),(338904,9414,'en','Currency Rate Manager',0),(338905,9415,'is','',0),(338906,9415,'dr','Ù†Ø±Ø®Ù‡Ø§ÙŠ Ø§Ø±Ø² ØªØ§Ø±ÙŠØ®ÙŠ ',0),(338907,9415,'pr','Ù†Ø±Ø®Ù‡Ø§ÙŠ Ø§Ø±Ø² ØªØ§Ø±ÙŠØ®ÙŠ ',0),(338908,9415,'tr','Tarihsel DÃ¶viz kurlarÄ±',0),(338909,9415,'pl','Historyczne kursy walut',0),(338910,9415,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ‡ÐµÑÐºÐ¸ Ð¾Ð±Ð¼ÐµÐ½Ð½Ð¸ ÐºÑƒÑ€ÑÐ¾Ð²Ðµ',0),(338911,9415,'ur','ØªØ§Ø±ÛŒØ®ÛŒ Ú©Ø±Ù†Ø³ÛŒ Ú©ÛŒ Ø´Ø±Ø­',0),(338912,9415,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜ÑÐºÐ¸ Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(338913,9415,'vi','Lá»‹ch sá»­ GiÃ¡ tiá»n tá»‡ ',0),(338914,9415,'af','Historiese Geldeenheid Koerse',0),(338915,9415,'ro','Istoric valutar',0),(338916,9415,'et','Ajaloolised valuutakursid',0),(338917,9415,'si','Zgodovinski teÄaj',0),(338918,9415,'ba','Nilai tukar mata uang sejarah',0),(338919,9415,'nl','Historische wisselkoersen',0),(338920,9415,'fi','Historiallinen valuuttakurssien',0),(338921,9415,'no','Historiske valutakurser',0),(338922,9415,'da','Historiske valutakurser',0),(338923,9415,'ko','ì—­ì‚¬ì ì¸ í™˜ìœ¨',0),(338924,9415,'he','×©×¢×¨×™ ×”×—×œ×™×¤×™×Ÿ ×”×”×™×¡×˜×•×¨×™×™×',0),(338925,9415,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î¹ÏƒÎ¿Ï„Î¹Î¼Î¹ÏŽÎ½',0),(338926,9415,'zh','åŽ†å²è´§å¸æ±‡çŽ‡\r\n',0),(338927,9415,'sv','Historiska valutakurser',0),(338928,9415,'it','Tassi storici',0),(338929,9415,'tl','',0),(338930,9415,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3649;&#3621;&#3585;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3618;&#3657;&#3629;&#3609;&#3627;&#3621;&#3633;&#3591;',0),(338931,9415,'hi','à¤à¤¤à¤¿à¤¹à¤¾à¤¸à¤¿à¤• à¤®à¥à¤¦à¥à¤°à¤¾ à¤¦à¤°',0),(338932,9415,'ms','Sejarah Mata Wang kadar',0),(338933,9415,'ar','Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Øª Ø§Ù„ØªØ§Ø±ÙŠØ®ÙŠØ©',0),(338934,9415,'fr','Taux de change historiques',0),(338935,9415,'jp','æ­´å²çš„é€šè²¨ã®ãƒ¬ãƒ¼ãƒˆ',0),(338936,9415,'pt','Taxas de cÃ¢mbio histÃ³ricas',0),(338937,9415,'ru','ÐšÑƒÑ€ÑÑ‹ Ð²Ð°Ð»ÑŽÑ‚ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ',0),(338938,9415,'es','Tipos de Cambio Historicos',0),(338939,9415,'de','Historische Wechselkurse',0),(338940,9415,'en','Historical Currency Rates',0),(338941,9416,'is','',0),(338942,9416,'dr','(ØªØ³Ø¹ÙŠØ±) Ø°Ø®ÙŠØ±Ù‡â€Œ Ø´Ø¯Ù‡',0),(338943,9416,'pr','Ù†Ø±Ø® Ù‡Ø§ÙŠ ØªØ¨Ø¯ÙŠÙ„ (ØªØ³Ø¹ÙŠØ±) Ø°Ø®ÙŠØ±Ù‡â€Œ Ø´Ø¯Ù‡',0),(338944,9416,'tr','SaklÄ± dÃ¶nÃ¼ÅŸÃ¼m oranlarÄ±',0),(338945,9416,'pl','WspÃ³Å‚czynniki konwersji przechowywane',0),(338946,9416,'bg','Ð¡ÑŠÑ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ‚Ðµ Ð¾Ð±Ð¼ÐµÐ½Ð½Ð¸ ÐºÑƒÑ€ÑÐ¾Ð²Ðµ',0),(338947,9416,'ur','Ø°Ø®ÛŒØ±Û Ø´Ø¯Û ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ø´Ø±Ø­',0),(338948,9416,'sr','Ð¡Ñ‚Ð¾Ð¿Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ ÑƒÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚ÐµÐ½Ðµ',0),(338949,9416,'vi','LÆ°u tá»· giÃ¡ chuyá»ƒn Ä‘á»•i',0),(338950,9416,'af','Gestoorde Oorskakeling Tariewe',0),(338951,9416,'ro','Ratele de conversie stocate',0),(338952,9416,'et','Salvestatud Ã¼mberarvestuskursid',0),(338953,9416,'si','Shranjene menjalnih',0),(338954,9416,'ba','Tingkat konversi tersimpan',0),(338955,9416,'nl','Opgeslagen omrekeningskoersen',0),(338956,9416,'fi','Tallennettu muuntokurssit',0),(338957,9416,'no','Lagrede konverteringsfrekvenser',0),(338958,9416,'da','Lagrede omregningskurser',0),(338959,9416,'ko','ì €ìž¥ ëœ ì „í™˜ìœ¨',0),(338960,9416,'he','×©×™×¢×•×¨×™ ×”×”×ž×¨×” ×ž××•×—×¡× ×ª',0),(338961,9416,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏ…Î¼Î­Î½Î· ÏƒÏ…Î½Î±Î»Î»Î±Î³Î¼Î±Ï„Î¹ÎºÎ­Ï‚ Î¹ÏƒÎ¿Ï„Î¹Î¼Î¯ÎµÏ‚',0),(338962,9416,'zh','å­˜å‚¨è½¬æ¢çŽ‡\r\n',0),(338963,9416,'sv','Lagrade omrÃ¤kningskurser',0),(338964,9416,'it','Tassi di conversione stored',0),(338965,9416,'tl','',0),(338966,9416,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3648;&#3585;&#3655;&#3610;',0),(338967,9416,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹à¥€à¤¤ à¤°à¥‚à¤ªà¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¤°',0),(338968,9416,'ms','Kadar penukaran yang disimpan',0),(338969,9416,'ar','Ù…Ø¹Ø¯Ù„Ø§Øª Ø§Ù„ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ù…Ø®Ø²Ù†Ø©',0),(338970,9416,'fr','Taux de Conversion stockÃ©e',0),(338971,9416,'jp','ã‚¹ãƒˆã‚¢ãƒ‰ã®ã‚³ãƒ³ãƒãƒ¼ã‚¸ãƒ§ãƒ³çŽ‡',0),(338972,9416,'pt','Taxas de conversÃ£o armazenado',0),(338973,9416,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ðµ ÐºÐ¾ÑÑ„Ñ„Ð¸Ñ†Ð¸ÐµÐ½Ñ‚Ñ‹',0),(338974,9416,'es','Tipos de Cambio Guardado',0),(338975,9416,'de','Gespeicherten Conversion-Raten',0),(338976,9416,'en','Stored Conversion Rates',0),(338977,9417,'is','',0),(338978,9417,'dr','Ø´Ù…Ø§ Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ø§Ø² Ù„ÙŠÙ†Ùƒ Ø²ÙŠØ± Ø¨Ø±Ø§ÙŠ Ø¨Ù‡ Ø¯Ø³Øª Ø¢ÙˆØ±Ø¯Ù† Ù†Ø±Ø® Ù‡Ø§ÙŠ ØªØ¨Ø¯ÙŠÙ„ Ø§Ø±Ø² Ø§ÙˆÙ„ÙŠÙ‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(338979,9417,'pr','Ø´Ù…Ø§ Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ø§Ø² Ù„ÙŠÙ†Ùƒ Ø²ÙŠØ± Ø¨Ø±Ø§ÙŠ Ø¨Ù‡ Ø¯Ø³Øª Ø¢ÙˆØ±Ø¯Ù† Ù†Ø±Ø® Ù‡Ø§ÙŠ ØªØ¨Ø¯ÙŠÙ„ Ø§Ø±Ø² Ø§ÙˆÙ„ÙŠÙ‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†ÙŠØ¯ ',0),(338980,9417,'tr','Tarihi para birimi dÃ¶nÃ¼ÅŸtÃ¼rme oranlarÄ± almak iÃ§in aÅŸaÄŸÄ±daki baÄŸlantÄ±yÄ± kullanabilirsiniz.',0),(338981,9417,'pl','MoÅ¼na uÅ¼yÄ‡ PoniÅ¼szy link aby uzyskaÄ‡ historycznych walut kursy wymiany.',0),(338982,9417,'bg','ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ ÑÐ»ÐµÐ´Ð½Ð¸Ñ Ð»Ð¸Ð½Ðº Ð·Ð° Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ‡ÐµÑÐºÐ¸ Ð²Ð°Ð»ÑƒÑ‚Ð½Ð¸ Ð¾Ð±Ð¼ÐµÐ½Ð½Ð¸ ÐºÑƒÑ€ÑÐ¾Ð²Ðµ.',0),(338983,9417,'ur','Ø¢Ù¾ Ú©Ùˆ ØªØ§Ø±ÛŒØ®ÛŒ Ú©Ø±Ù†Ø³ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ø´Ø±Ø­ Ø­Ø§ØµÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ù„Ù†Ú© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº Û”',0),(338984,9417,'sr','Ð¡Ñ™ÐµÐ´ÐµÑ›Ð° Ð²ÐµÐ·Ð° Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð±Ð¸Ð»Ð¸ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜ÑÐºÐµ Ð²Ð°Ð»ÑƒÑ‚Ðµ ÑÑ‚Ð¾Ð¿Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ.',0),(338985,9417,'vi','Báº¡n cÃ³ thá»ƒ theo ÄÆ°á»ng Dáº«n nÃ y Ä‘á»ƒ truy cáº­p nháº­t kÃ½ tá»· giÃ¡ ngoáº¡i tá»‡',0),(338986,9417,'af','U kan die volgende skakel gebruik om die geskiedkundige geldoorskakelingskoerse te verkry.',0),(338987,9417,'ro','UtilizaÅ£i linkul urmÄƒtor pentru a obÅ£ine istoric valutar ratele de conversie.',0),(338988,9417,'et','Te saate kasutada seda linki, et nÃ¤ha valuutakursi konverteerimiste ajalugu',0),(338989,9417,'si','Uporabite naslednjo povezavo zadobiti zgodovinskih valuto menjalni teÄaji.',0),(338990,9417,'ba','Anda dapat menggunakan link berikut untuk mendapatkan mata uang sejarah tingkat konversi.',0),(338991,9417,'nl','U kunt de volgende link gebruiken om historische valuta conversie ratios.',0),(338992,9417,'fi','Seuraavan linkin avulla voit saada historiallinen valuutan muuntokurssit.',0),(338993,9417,'no','Du kan bruke fÃ¸lgende link for Ã¥ fÃ¥ historiske valuta konverteringsfrekvenser.',0),(338994,9417,'da','Du kan bruge fÃ¸lgende link til at fÃ¥ historiske valuta omregningskurser.',0),(338995,9417,'ko','ì—­ì‚¬ì ì¸ í†µí™” ë³€í™˜ ë ˆì´íŠ¸ë¥¼ ì–»ìœ¼ë ¤ë©´ ë‹¤ìŒ ë§í¬ë¥¼ ì‚¬ìš©í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(338996,9417,'he','×‘××¤×©×¨×•×ª×š ×œ×”×©×ª×ž×© ×‘×§×™×©×•×¨ ×”×‘× ×›×“×™ ×œ×§×‘×œ ×ž×˜×‘×¢ ×”×™×¡×˜×•×¨×™ ×©×™×¢×•×¨×™ ×”×”×ž×¨×”.',0),(338997,9417,'el','ÎœÏ€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ ÏƒÏ„Î¿Î½ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ ÏƒÏÎ½Î´ÎµÏƒÎ¼Î¿ Î³Î¹Î± Î½Î± Ï€Î¬ÏÎµÏ„Îµ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î± Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÎ¬ Ï€Î¿ÏƒÎ¿ÏƒÏ„Î¬ Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î®Ï‚.',0),(338998,9417,'zh','ä½ å¯ä»¥ä½¿ç”¨ä»¥ä¸‹é“¾æŽ¥èŽ·å¾—åŽ†å²è´§å¸å…‘æ¢çŽ‡ã€‚\r\n',0),(338999,9417,'sv','Du kan anvÃ¤nda lÃ¤nken nedan fÃ¶r att fÃ¥ historiska valuta omrÃ¤kningskurser.',0),(339000,9417,'it','Ãˆ possibile utilizzare il seguente link per ottenere valuta storico tassi di conversione.',0),(339001,9417,'tl','',0),(339002,9417,'th','You can use the following link to get historical currency conversion rates.',0),(339003,9417,'hi','à¤à¤¤à¤¿à¤¹à¤¾à¤¸à¤¿à¤• à¤®à¥à¤¦à¥à¤°à¤¾ à¤°à¥‚à¤ªà¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¤° à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤ª à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ à¤²à¤¿à¤‚à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(339004,9417,'ms','Anda boleh gunakan link berikut untuk mendapatkan sejarah Mata Wang kadar penukaran.',0),(339005,9417,'ar','ÙŠÙ…ÙƒÙ†Ùƒ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø· Ø§Ù„ØªØ§Ù„ÙŠ Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ù…Ù„Ø§Øª Ø§Ù„ØªØ§Ø±ÙŠØ®ÙŠØ© Ù…Ø¹Ø¯Ù„Ø§Øª Ø§Ù„ØªØ­ÙˆÙŠÙ„.',0),(339006,9417,'fr','Vous pouvez utiliser le lien suivant pour obtenir des devises historique taux de conversion.',0),(339007,9417,'jp','æ­´å²çš„é€šè²¨ã®å¤‰æ›ãƒ¬ãƒ¼ãƒˆã‚’å–å¾—ã™ã‚‹ã®ã«ã€æ¬¡ã®ãƒªãƒ³ã‚¯ã‚’ä½¿ç”¨ã§ãã¾ã™ã€‚',0),(339008,9417,'pt','VocÃª pode usar o link a seguir para obter moeda histÃ³rica de taxas de conversÃ£o.',0),(339009,9417,'ru','ÐœÐ¾Ð¶Ð½Ð¾ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÑƒÑŽ ÑÑÑ‹Ð»ÐºÑƒ Ð´Ð»Ñ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ‡ÐµÑÐºÐ¸Ñ… Ð²Ð°Ð»ÑŽÑ‚ ÐºÐ¾ÑÑ„Ñ„Ð¸Ñ†Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¿ÐµÑ€ÐµÑÑ‡ÐµÑ‚Ð°.',0),(339010,9417,'es','Puede usar el enlace siguente para conseguir tipos de cambio historicos de monedas',0),(339011,9417,'de','Den folgenden Link kÃ¶nnen Sie um historische WÃ¤hrung Conversion-Raten zu bekommen.',0),(339012,9417,'en','You can use the following link to get historical currency conversion rates.',0),(339013,9418,'is','',0),(339014,9418,'dr','ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ±',0),(339015,9418,'pr','ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ±',0),(339016,9418,'tr','Fatura dosya',0),(339017,9418,'pl','Plik faktury',0),(339018,9418,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ñ„Ð°Ð¹Ð»',0),(339019,9418,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ø³Ù„',0),(339020,9418,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(339021,9418,'vi','Há»“ sÆ¡ HÃ³a Ä‘Æ¡n ',0),(339022,9418,'af','FaktuurlÃªer',0),(339023,9418,'ro','Fisier factura',0),(339024,9418,'et','Arve fail',0),(339025,9418,'si','RaÄunu datoteke',0),(339026,9418,'ba','Faktur File',0),(339027,9418,'nl','Factuur bestand',0),(339028,9418,'fi','Lasku tiedosto',0),(339029,9418,'no','Fakturaen filen',0),(339030,9418,'da','Faktura fil',0),(339031,9418,'ko','ì†¡ìž¥ íŒŒì¼',0),(339032,9418,'he','×§×•×‘×¥ ×—×©×‘×•× ×™×ª',0),(339033,9418,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(339034,9418,'zh','å‘ç¥¨æ–‡ä»¶\r\n',0),(339035,9418,'sv','Faktura-fil',0),(339036,9418,'it','File della fattura',0),(339037,9418,'tl','',0),(339038,9418,'th','&#3652;&#3615;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(339039,9418,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤²',0),(339040,9418,'ms','Fail invois',0),(339041,9418,'ar','Ù…Ù„Ù Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(339042,9418,'fr','Fichier de facture',0),(339043,9418,'jp','è«‹æ±‚æ›¸ãƒ•ã‚¡ã‚¤ãƒ«',0),(339044,9418,'pt','Arquivo de factura',0),(339045,9418,'ru','Ð¤Ð°Ð¹Ð» Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(339046,9418,'es','Archivo de Facturas',0),(339047,9418,'de','Rechnungsdatei',0),(339048,9418,'en','Invoice File',0),(339049,9419,'is','',0),(339050,9419,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ±',0),(339051,9419,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ±',0),(339052,9419,'tr','Fatura dosyayÄ± seÃ§in',0),(339053,9419,'pl','Zaznacz plik faktury',0),(339054,9419,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ„Ð°Ð¹Ð»',0),(339055,9419,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(339056,9419,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(339057,9419,'vi','Chá»n há»“ sÆ¡ hÃ³a Ä‘Æ¡n',0),(339058,9419,'af','Selekteer FaktuurlÃªer',0),(339059,9419,'ro','SelectaÅ£i fiÅŸierul facturÄƒ',0),(339060,9419,'et','Valige arve fail',0),(339061,9419,'si','Izberite datoteko raÄuna',0),(339062,9419,'ba','Pilih File faktur',0),(339063,9419,'nl','Selecteer factuur bestand',0),(339064,9419,'fi','Valitse laskun tiedosto',0),(339065,9419,'no','Velg fakturaen filen',0),(339066,9419,'da','VÃ¦lg faktura fil',0),(339067,9419,'ko','ì†¡ìž¥ íŒŒì¼ ì„ íƒ',0),(339068,9419,'he','×‘×—×¨ ×§×•×‘×¥ ×—×©×‘×•× ×™×ª',0),(339069,9419,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(339070,9419,'zh','é€‰æ‹©å‘ç¥¨æ–‡ä»¶\r\n',0),(339071,9419,'sv','VÃ¤lj faktura fil',0),(339072,9419,'it','Selezionare il File della fattura',0),(339073,9419,'tl','',0),(339074,9419,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3652;&#3615;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(339075,9419,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(339076,9419,'ms','Pilih fail invois',0),(339077,9419,'ar','Ø­Ø¯Ø¯ Ù…Ù„Ù Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(339078,9419,'fr','SÃ©lectionnez le fichier facture',0),(339079,9419,'jp','è«‹æ±‚æ›¸ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(339080,9419,'pt','Selecione o arquivo de factura',0),(339081,9419,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¤Ð°Ð¹Ð» Ð¡Ñ‡ÐµÑ‚Ð°',0),(339082,9419,'es','Selecciona el File de la Factura',0),(339083,9419,'de','WÃ¤hlen Sie die Rechnungsdatei',0),(339084,9419,'en','Select Invoice File',0),(339085,9420,'is','',0),(339086,9420,'dr','ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ± Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ù…Ù†Ø§Ø³Ø¨ÙŠ Ù†ÙŠØ³Øª ',0),(339087,9420,'pr','ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ± Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ù…Ù†Ø§Ø³Ø¨ÙŠ Ù†ÙŠØ³Øª ',0),(339088,9420,'tr','Fatura dosya biÃ§imi doÄŸru deÄŸil.',0),(339089,9420,'pl','Plik faktury nie jest w odpowiednim formacie.',0),(339090,9420,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ñ„Ð°Ð¹Ð»ÑŠÑ‚ Ð½Ðµ Ðµ Ð² Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¸Ñ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚.',0),(339091,9420,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ø³Ù„ Ù…Ù†Ø§Ø³Ø¨ ÙˆØ¶Ø¹ Ù…ÛŒÚº Ù†ÛÛŒÚº Û”',0),(339092,9420,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð¸Ñ˜Ðµ Ñƒ Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð°Ñ˜ÑƒÑ›ÐµÐ¼ Ð¾Ð±Ð»Ð¸ÐºÑƒ.',0),(339093,9420,'vi','Há»“ sÆ¡ hÃ³a Ä‘Æ¡n khÃ´ng Ä‘Ãºng máº«u',0),(339094,9420,'af','Die faktuurlÃªer is nie in die regte formaat nie.',0),(339095,9420,'ro','FiÅŸierul de facturÄƒ nu este Ã®n formatul corect.',0),(339096,9420,'et','Arve fail pole Ãµiges vormingus.',0),(339097,9420,'si','RaÄun datoteka ni v pravilni obliki.',0),(339098,9420,'ba','Faktur file ini tidak dalam format yang tepat.',0),(339099,9420,'nl','Het factuur-bestand is niet in het juiste formaat.',0),(339100,9420,'fi','Lasku-tiedosto ei ole oikeassa muodossa.',0),(339101,9420,'no','Fakturaen filen er ikke i riktig format.',0),(339102,9420,'da','Faktura fil er ikke i det korrekte format.',0),(339103,9420,'ko','ì†¡ìž¥ íŒŒì¼ì€ ì ì ˆ í•œ í˜•ì‹.',0),(339104,9420,'he','×—×©×‘×•× ×™×ª ×”×§×•×‘×¥ ××™× ×• ×‘×ª×‘× ×™×ª ×ž×ª××™×ž×”.',0),(339105,9420,'el','Î¤Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÏ„Î· ÏƒÏ‰ÏƒÏ„Î® Î¼Î¿ÏÏ†Î®.',0),(339106,9420,'zh','è¯¥å‘ç¥¨çš„æ–‡ä»¶ä¸æ˜¯æ­£ç¡®çš„æ ¼å¼ã€‚\r\n',0),(339107,9420,'sv','Faktura filen Ã¤r inte i rÃ¤tt format.',0),(339108,9420,'it','Il file della fattura non Ã¨ nel formato corretto.',0),(339109,9420,'tl','',0),(339110,9420,'th','&#3652;&#3615;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3652;&#3617;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3607;&#3637;&#3656;&#3648;&#3627;&#3617;&#3634;&#3',0),(339111,9420,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤² à¤‰à¤šà¤¿à¤¤ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(339112,9420,'ms','Fail invois ini tidak dalam format yang betul.',0),(339113,9420,'ar','ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ù„Ù Ù„ÙŠØ³ ÙÙŠ Ø§Ù„ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„ØµØ­ÙŠØ­.',0),(339114,9420,'fr','Le fichier facture nâ€™est pas au bon format.',0),(339115,9420,'jp','è«‹æ±‚ãƒ•ã‚¡ã‚¤ãƒ«ã¯ã€é©åˆ‡ãªå½¢å¼ã§ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(339116,9420,'pt','O arquivo de factura nÃ£o Ã© no formato adequado.',0),(339117,9420,'ru','Ð¤Ð°Ð¹Ð» ÑÑ‡ÐµÑ‚Ð° Ð½Ðµ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð² Ð¿Ñ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ð¾Ð¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ.',0),(339118,9420,'es','El File de la factura no esta en el formato correcto.',0),(339119,9420,'de','Die Rechnungsdatei ist nicht im richtigen Format.',0),(339120,9420,'en','The invoice file is not in the proper format.',0),(339121,9421,'is','',0),(339122,9421,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ± Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯',0),(339123,9421,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ± Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯',0),(339124,9421,'tr','Bir fatura dosyasÄ± gÃ¶ndermeniz gerekir.',0),(339125,9421,'pl','NaleÅ¼y przesÅ‚aÄ‡ plik z faktura.',0),(339126,9421,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð´Ð°Ð´ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð» Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°.',0),(339127,9421,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ÙØ§Ø¦Ù„ Ø¬Ù…Ø¹ Ú©Ø±Ø§Ù†Ø§ Ø¶Ø±ÙˆØ±ÛŒ ÛÙˆÚ¯Ø§ Û”',0),(339128,9421,'sr','ÐÐµÐ¾Ð¿Ñ…Ð¾Ð´Ð½Ð¾ Ñ˜Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ.',0),(339129,9421,'vi','Báº¡n pháº£i ná»™p 1 há»“ sÆ¡ hÃ³a Ä‘Æ¡n',0),(339130,9421,'af','U moet \'n FaktuurlÃªer indien.',0),(339131,9421,'ro','Trebuie sa depuneti un dosar de facturÄƒ.',0),(339132,9421,'et','Te peate sisestama arve faili',0),(339133,9421,'si','Morate poslati datoteko raÄuna.',0),(339134,9421,'ba','Anda harus mengirimkan File faktur.',0),(339135,9421,'nl','U dient een factuur-bestand.',0),(339136,9421,'fi','LÃ¤hetÃ¤t lasku-tiedosto.',0),(339137,9421,'no','Du mÃ¥ sende en faktura-fil.',0),(339138,9421,'da','Du skal sende en faktura fil.',0),(339139,9421,'ko','ì†¡ìž¥ íŒŒì¼ì„ ì œì¶œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(339140,9421,'he','×¢×œ×™×š ×œ×”×’×™×© ×§×•×‘×¥ ×—×©×‘×•× ×™×ª.',0),(339141,9421,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï…Ï€Î¿Î²Î¬Î»ÎµÏ„Îµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿.',0),(339142,9421,'zh','ä½ å¿…é¡»æäº¤å‘ç¥¨æ–‡ä»¶ã€‚\r\n',0),(339143,9421,'sv','Du mÃ¥ste skicka en faktura-fil.',0),(339144,9421,'it','Ãˆ necessario inviare un File di fattura.',0),(339145,9421,'tl','',0),(339146,9421,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3618;&#3629;&#3617;&#3619;&#3633;&#3610;&#3652;&#3615;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;',0),(339147,9421,'hi','à¤†à¤ª à¤à¤• à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(339148,9421,'ms','Anda perlu menghantar satu fail invois.',0),(339149,9421,'ar','ÙŠØ¬Ø¨ Ø¥Ø±Ø³Ø§Ù„ \"Ù…Ù„Ù Ø§Ù„ÙØ§ØªÙˆØ±Ø©\".',0),(339150,9421,'fr','Vous devez soumettre un fichier de facture',0),(339151,9421,'jp','è«‹æ±‚æ›¸ãƒ•ã‚¡ã‚¤ãƒ«ã‚’æå‡ºã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(339152,9421,'pt','VocÃª deve enviar um arquivo de nota fiscal.',0),(339153,9421,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» ÑÑ‡ÐµÑ‚Ð°.',0),(339154,9421,'es','Debe presentar un File de FacturaciÃ³n',0),(339155,9421,'de','Sie mÃ¼ssen eine Rechnungsdatei einreichen.',0),(339156,9421,'en','You must submit an Invoice File.',0),(339157,9422,'is','',0),(339158,9422,'dr','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ù‡ÙŠ Ø®Ø§Ù„Øµ Ø¯Ø± Ù…Ø§Ù‡ Ø¢ÙŠÙ†Ø¯Ù‡ ',0),(339159,9422,'pr','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ù‡ÙŠ Ø®Ø§Ù„Øµ Ø¯Ø± Ù…Ø§Ù‡ Ø¢ÙŠÙ†Ø¯Ù‡ ',0),(339160,9422,'tr','Net sÃ¼re sonu tarihi ay takip Ã¼zerinde',0),(339161,9422,'pl','Netto Due dnia nastÄ™pujÄ…cego po miesiÄ…cu',0),(339162,9422,'bg','ÐÐµÑ‚Ð¾ Ð¿Ð°Ð´ÐµÐ¶ Ð´Ð°Ñ‚Ð° Ð½Ð° ÑÐ»ÐµÐ´Ð²Ð°Ñ‰ Ð¼ÐµÑÐµÑ†',0),(339163,9422,'ur','Ù†ÛŒÙ¹ Ù¾Ø± Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ® Ù¾Ø± Ù…ÛÛŒÙ†Û’ Ú©Û’ Ø¨Ø¹Ø¯',0),(339164,9422,'sr','ÐÐµÑ‚Ð¾ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð° Ð¿Ð¾ÑÐ»Ðµ Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(339165,9422,'vi','NgÃ y thuáº§n dáº¿n háº¡n vÃ o thÃ¡ng sau',0),(339166,9422,'af','Datum waarop Netto Betaalbaar is in Volgende Maand',0),(339167,9422,'ro','Net cuvenit data pe luna',0),(339168,9422,'et','Neto nÃµuetekohaselt kuupÃ¤evast jÃ¤rgneva',0),(339169,9422,'si','Neto zaradi datum po mesecu',0),(339170,9422,'ba','Bersih karena tanggal mengikuti bulan',0),(339171,9422,'nl','Netto Due datum op de volgende maand',0),(339172,9422,'fi','NET asianmukaisesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤Ã¤ seuraavan kuukauden',0),(339173,9422,'no','Netto grunn dato etter mÃ¥ned',0),(339174,9422,'da','Netto Due dato efter mÃ¥ned',0),(339175,9422,'ko','Net ì¸í•´ ë‹¤ìŒ ë‹¬ì— ë‚ ì§œ',0),(339176,9422,'he','× ×˜×• ×™×¢×“ ×ª××¨×™×š ×œ××—×¨ ×—×•×“×©',0),(339177,9422,'el','ÎšÎ±Î¸Î±ÏÎ¬ Î»ÏŒÎ³Ï‰ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Ï€ÎµÏ„Î±Î¹ Î¼Î®Î½Î±',0),(339178,9422,'zh','å‡€æˆªæ­¢æ—¥æœŸåœ¨ä¸‹ä¸€ä¸ªæœˆ\r\n',0),(339179,9422,'sv','Netto vederbÃ¶rlig datum pÃ¥ fÃ¶ljande mÃ¥nad',0),(339180,9422,'it','Netto Due data il successivo mese',0),(339181,9422,'tl','',0),(339182,9422,'th','Net Due Date On Following Month',0),(339183,9422,'hi','à¤¨à¥‡à¤Ÿ à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¿à¤¥à¤¿ à¤ªà¤° à¤®à¤¾à¤¹ à¤•à¥‡ à¤¬à¤¾à¤¦',0),(339184,9422,'ms','Bersih wajar berikutan bulan pada tarikh',0),(339185,9422,'ar','ØµØ§ÙÙŠ Ø£ØµÙˆÙ„ Ø§Ù„ØªØ§Ø±ÙŠØ® Ø¨Ø¹Ø¯ Ø´Ù‡Ø±',0),(339186,9422,'fr','NET Due Date aprÃ¨s mois',0),(339187,9422,'jp','Net ã®ãŸã‚æ¬¡ã®æœˆã®æ—¥ä»˜',0),(339188,9422,'pt','LÃ­quido devido data no seguinte mÃªs',0),(339189,9422,'ru','NET Ð´Ð¾Ð»Ð¶Ð½Ð¾Ðµ Ð”Ð°Ñ‚Ð° ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ³Ð¾',0),(339190,9422,'es','Fecha de Vencimiento del Neto en el Siguente Mes',0),(339191,9422,'de','NET-Due Datum nach Monat',0),(339192,9422,'en','Net Due Date On Following Month',0),(339193,9423,'is','',0),(339194,9423,'dr','Ù‡ÙŠÚ† Ù†Ø±Ø®ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(339195,9423,'pr','Ù‡ÙŠÚ† Ù†Ø±Ø®ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(339196,9423,'tr','HiÃ§bir oranÄ± kullanÄ±labilir',0),(339197,9423,'pl','Nie dostÄ™pnej taryfy',0),(339198,9423,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð»Ð¸Ñ‡ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(339199,9423,'ur','Ú©ÙˆØ¦ÛŒ Ø´Ø±Ø­ Ø¯Ø³ØªÛŒØ§Ø¨',0),(339200,9423,'sr','ÐÐµÐ¼Ð° Ð²Ð°Ð»ÑƒÑ‚Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ðµ',0),(339201,9423,'vi','KhÃ´ng cÃ³ giÃ¡ sáºµn',0),(339202,9423,'af','Geen Tarief Beskikbaar',0),(339203,9423,'ro','Nu rata disponibile',0),(339204,9423,'et','Ei hinda',0),(339205,9423,'si','Ne stopnje, ki je na voljo',0),(339206,9423,'ba','Tingkat tidak tersedia',0),(339207,9423,'nl','Geen tarief beschikbaar',0),(339208,9423,'fi','Mahdollisen hinnan',0),(339209,9423,'no','Ingen pris tilgjengelig',0),(339210,9423,'da','Ingen tilgÃ¦ngelige sats',0),(339211,9423,'ko','ì‚¬ìš©í•  ìˆ˜ ì—†ëŠ” ì†ë„',0),(339212,9423,'he','×§×¦×‘ ×œ× ×–×ž×™×Ÿ',0),(339213,9423,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Ï„Î¹Î¼Î®',0),(339214,9423,'zh','æ²¡æœ‰åˆ©çŽ‡çš„å¯ç”¨\r\n',0),(339215,9423,'sv','Ingen skattesats som Ã¤r lediga',0),(339216,9423,'it','Nessuna tariffa disponibile',0),(339217,9423,'tl','',0),(339218,9423,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3629;&#3633;&#3605;&#3619;&#3634;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;',0),(339219,9423,'hi','à¤•à¥‹à¤ˆ à¤¦à¤° à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(339220,9423,'ms','Tiada kadar yang tersedia',0),(339221,9423,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø³Ø¹Ø± Ù…ØªØ§Ø­',0),(339222,9423,'fr','Aucun tarif disponible',0),(339223,9423,'jp','ãªã„ãƒ¬ãƒ¼ãƒˆ',0),(339224,9423,'pt','NÃ£o hÃ¡ taxa disponÃ­vel',0),(339225,9423,'ru','ÐÐµÑ‚ Ñ‚Ð°Ñ€Ð¸Ñ„',0),(339226,9423,'es','El Tipo de Cambio no Esta Disponible',0),(339227,9423,'de','Kein Kurs verfÃ¼gbar',0),(339228,9423,'en','No Rate Available',0),(339229,9424,'is','',0),(339230,9424,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ  Ù†Ù…ÙˆÙ†Ù‡ Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ  Ø¨Ø§ ',0),(339231,9424,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ  Ù†Ù…ÙˆÙ†Ù‡ Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ  Ø¨Ø§ ',0),(339232,9424,'tr','Ä°lk giriÅŸ',0),(339233,9424,'pl','PoczÄ…tkowa logowania',0),(339234,9424,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÐµÐ½ Login',0),(339235,9424,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù„Ø§Ú¯ Ø§Ù†',0),(339236,9424,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð°',0),(339237,9424,'vi','Demo ÄÄƒng Nháº­p TK vá»›i',0),(339238,9424,'af','Demo Rekeninge Teken-Aan Met',0),(339239,9424,'ro','IniÅ£ialÄƒ de conectare',0),(339240,9424,'et','Esmase sisselogimise',0),(339241,9424,'si','PoÄeten prepriÄevalnost',0),(339242,9424,'ba','Initial Login',0),(339243,9424,'nl','Eerste Login',0),(339244,9424,'fi','EnsimmÃ¤isen kirjautumisen',0),(339245,9424,'no','FÃ¸rste innlogging',0),(339246,9424,'da','FÃ¸rste Login',0),(339247,9424,'ko','ì´ˆê¸° ë¡œê·¸ì¸',0),(339248,9424,'he','×”×ª×—×‘×¨×•×ª ×¨××©×•× ×™×ª',0),(339249,9424,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÎµÎ¯ÏƒÎ¿Î´Î¿Ï‚',0),(339250,9424,'zh','æ¨¡æ‹Ÿè´¦æˆ·ç™»é™†çš„\r\n',0),(339251,9424,'sv','FÃ¶rsta inloggning',0),(339252,9424,'it','Gli account dimostrativi possono autenticarsi con',0),(339253,9424,'tl','',0),(339254,9424,'th','&#3626;&#3634;&#3608;&#3636;&#3605;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3586;&#3657;&#3634;&#3626;&#3641;&#3656;&#3619;&#3632;&#3610;&#3610;&#3604;&#3657;&#3623;&#3618;',0),(339255,9424,'hi','à¤†à¤°à¤‚à¤­à¤¿à¤• à¤²à¥‰à¤—à¤¿à¤¨',0),(339256,9424,'ms','Log-masuk awal',0),(339257,9424,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø£ÙˆÙ„ÙŠØ©',0),(339258,9424,'fr','Ouverture de session initiale',0),(339259,9424,'jp','æœ€åˆã®ãƒ­ã‚°ã‚¤ãƒ³',0),(339260,9424,'pt','Login inicial',0),(339261,9424,'ru','ÐŸÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð²Ñ…Ð¾Ð´',0),(339262,9424,'es','Cuentas de Demo Login Con',0),(339263,9424,'de','Erstmalige Anmeldung',0),(339264,9424,'en','Initial Login',0),(339265,9425,'is','',0),(339266,9425,'dr','Ù…Ø¯ÙŠØ±ÙŠØª ØªØ¬Ø§Ø±Øª Ø¨Ø± Ø§Ø³Ø§Ø³ ÙˆØ¨ ',0),(339267,9425,'pr','Ù…Ø¯ÙŠØ±ÙŠØª ØªØ¬Ø§Ø±Øª Ø¨Ø± Ø§Ø³Ø§Ø³ ÙˆØ¨ ',0),(339268,9425,'tr','Web tabanlÄ± iÅŸ yÃ¶netimi',0),(339269,9425,'pl','Web-Based Business Management',0),(339270,9425,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° ÑƒÐµÐ± Ð±Ð°Ð·Ð¸Ñ€Ð°Ð½Ð¸ Ð±Ð¸Ð·Ð½ÐµÑ',0),(339271,9425,'ur','ÙˆÛŒØ¨ Ù¾Ø± Ù…Ø¨Ù†ÛŒ Ú©Ø§Ø±ÙˆØ¨Ø§Ø±ÛŒ Ø§Ù†ØªØ¸Ø§Ù…',0),(339272,9425,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐ° Ð¿Ð¾ÑÐ»Ð¾Ð²Ð°ÑšÐµÐ¼ Ð½Ð° WÐµÐ±Ñƒ',0),(339273,9425,'vi','Quáº£n lÃ½ kinh doanh qua web',0),(339274,9425,'af','Webgebasseerde Besigheidsbestuur',0),(339275,9425,'ro','Management de afaceri bazate pe web',0),(339276,9425,'et','Web-Based Business Management',0),(339277,9425,'si','Upravljanje spletnega poslovanja',0),(339278,9425,'ba','Manajemen bisnis berbasis web',0),(339279,9425,'nl','Web-Based Business Management',0),(339280,9425,'fi','Web-pohjainen liikkeenjohdon',0),(339281,9425,'no','Webbasert administrasjon',0),(339282,9425,'da','Web-baseret Business Management',0),(339283,9425,'ko','ì›¹ ê¸°ë°˜ ì—…ë¬´ ê´€ë¦¬',0),(339284,9425,'he','× ×™×”×•×œ ×¢×¡×§×™ ×ž×‘×•×¡×¡-××™× ×˜×¨× ×˜',0),(339285,9425,'el','Web-Based ÎµÏ€Î¹Ï‡ÎµÎ¯ÏÎ·ÏƒÎ· Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚',0),(339286,9425,'zh','åŸºäºŽäº’è”ç½‘çš„ä¸šåŠ¡ç®¡ç†\r\n',0),(339287,9425,'sv','SpindelvÃ¤v-baserat fÃ¶retagsledning',0),(339288,9425,'it','Gestione aziendale basata sul Web',0),(339289,9425,'tl','',0),(339290,9425,'th','Web-Based Business Management',0),(339291,9425,'hi','à¤µà¥‡à¤¬-à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤µà¥à¤¯à¤µà¤¸à¤¾à¤¯ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨',0),(339292,9425,'ms','Pengurusan perniagaan berasaskan web',0),(339293,9425,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ø£Ø¹Ù…Ø§Ù„ Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ© Ø¹Ù„Ù‰ Ø´Ø¨ÙƒØ© Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(339294,9425,'fr','Gestion d\'entreprise basÃ©e sur le Web',0),(339295,9425,'jp','Web ãƒ™ãƒ¼ã‚¹ã®ãƒ“ã‚¸ãƒã‚¹ç®¡ç†',0),(339296,9425,'pt','GestÃ£o de negÃ³cios baseado na Web',0),(339297,9425,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð²ÐµÐ±-Ð±Ð¸Ð·Ð½ÐµÑ',0),(339298,9425,'es','GestiÃ³n de Negocios Basado en el Web',0),(339299,9425,'de','Web-basierte Business Management',0),(339300,9425,'en','Web-Based Business Management',0),(339301,9426,'is','',0),(339302,9426,'dr','Ø²Ø¨Ø§Ù† Ø³ÙŠØ³ØªÙ… ',0),(339303,9426,'pr','Ø²Ø¨Ø§Ù† Ø³ÙŠØ³ØªÙ… ',0),(339304,9426,'tr','Sistem dili',0),(339305,9426,'pl','JÄ™zyk systemu',0),(339306,9426,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð½Ð¸ÑÑ‚ ÐµÐ·Ð¸Ðº',0),(339307,9426,'ur','Ø³Ø³Ù¹Ù… Ú©ÛŒ Ø²Ø¨Ø§Ù†',0),(339308,9426,'sr','Ð¡Ð¸ÑÑ‚ÐµÐ¼ÑÐºÐ¸ Ñ˜ÐµÐ·Ð¸Ðº',0),(339309,9426,'vi','NgÃ´n ngá»¯ há»‡ thá»‘ng',0),(339310,9426,'af','Sisteem Taal',0),(339311,9426,'ro','Limba sistem',0),(339312,9426,'et','SÃ¼steemi keel',0),(339313,9426,'si','Sistem jezik',0),(339314,9426,'ba','Sistem bahasa',0),(339315,9426,'nl','Systeemtaal',0),(339316,9426,'fi','JÃ¤rjestelmÃ¤n kieli',0),(339317,9426,'no','SystemsprÃ¥ket',0),(339318,9426,'da','Systemsproget',0),(339319,9426,'ko','ì‹œìŠ¤í…œ ì–¸ì–´',0),(339320,9426,'he','×©×¤×ª ×”×ž×¢×¨×›×ª',0),(339321,9426,'el','Î“Î»ÏŽÏƒÏƒÎ± Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚',0),(339322,9426,'zh','ç³»ç»Ÿè¯­è¨€\r\n',0),(339323,9426,'sv','SystemsprÃ¥k',0),(339324,9426,'it','Lingua del sistema',0),(339325,9426,'tl','',0),(339326,9426,'th','&#3619;&#3632;&#3610;&#3610;&#3616;&#3634;&#3625;&#3634;',0),(339327,9426,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤•à¥€ à¤­à¤¾à¤·à¤¾',0),(339328,9426,'ms','Sistem Bahasa',0),(339329,9426,'ar','Ù„ØºØ© Ø§Ù„Ù…Ù†Ø¸ÙˆÙ…Ø©',0),(339330,9426,'fr','Langue du systÃ¨me',0),(339331,9426,'jp','ã‚·ã‚¹ãƒ†ãƒ ã®è¨€èªž',0),(339332,9426,'pt','Idioma do sistema',0),(339333,9426,'ru','Ð¯Ð·Ñ‹Ðº Ð¡Ð¸ÑÑ‚ÐµÐ¼Ñ‹',0),(339334,9426,'es','Idioma del Sistema',0),(339335,9426,'de','Systemsprache',0),(339336,9426,'en','System Language',0),(339337,9427,'is','',0),(339338,9427,'dr','Ù‡Ù…Ù‡ ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¶Ø±ÙˆØ±ÙŠ Ù‡Ø³ØªÙ†Ø¯',0),(339339,9427,'pr','Ù‡Ù…Ù‡ ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¶Ø±ÙˆØ±ÙŠ Ù‡Ø³ØªÙ†Ø¯',0),(339340,9427,'tr','TÃ¼m alanlarÄ±n doldurulmasÄ± zorunludur',0),(339341,9427,'pl','Wszystkie pola sÄ… wymagane',0),(339342,9427,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° ÑÐ° Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸',0),(339343,9427,'ur','ØªÙ…Ø§Ù… Ù‚Ø·Ø¹Ø§Øª Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(339344,9427,'sr','Ð¡Ð²Ð° Ð¿Ð¾Ñ™Ð° ÑÑƒ Ð¾Ð±Ð°Ð²ÐµÐ·Ð½Ð°',0),(339345,9427,'vi','YÃªu Cáº§u Táº¥t Cáº£ CÃ¡c TrÆ°á»ng',0),(339346,9427,'af','Alle Velde Word Benodig',0),(339347,9427,'ro','Toate campurile sunt obligatorii',0),(339348,9427,'et','KÃµik vÃ¤ljad on kohustuslikud',0),(339349,9427,'si','Vsa polja so obvezna',0),(339350,9427,'ba','Semua kolom wajib diisi',0),(339351,9427,'nl','Alle velden zijn verplicht',0),(339352,9427,'fi','Kaikki kentÃ¤t ovat pakollisia',0),(339353,9427,'no','Alle felt er pÃ¥krevd',0),(339354,9427,'da','Alle felter skal udfyldes',0),(339355,9427,'ko','ëª¨ë“  í•„ë“œëŠ” í•„ìˆ˜',0),(339356,9427,'he','×›×œ ×”×©×“×•×ª ×—×•×‘×”',0),(339357,9427,'el','Î¤Î± Ï€ÎµÎ´Î¯Î± ÎµÎ¯Î½Î±Î¹ Ï…Ï€Î¿Ï‡ÏÎµÏ‰Ï„Î¹ÎºÎ¬',0),(339358,9427,'zh','å„é¡¹å‡ä¸ºå¿…å¡«é¡¹\r\n',0),(339359,9427,'sv','Alla fÃ¤lt Ã¤r obligatoriska',0),(339360,9427,'it','Tutti i campi sono obbligatori',0),(339361,9427,'tl','',0),(339362,9427,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3615;&#3636;&#3621;&#3604;&#3660;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(339363,9427,'hi','à¤¸à¤­à¥€ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¤‚',0),(339364,9427,'ms','Semua bidang yang diperlukan',0),(339365,9427,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ù…Ø·Ù„ÙˆØ¨Ø©',0),(339366,9427,'fr','Tous les champs sont obligatoires',0),(339367,9427,'jp','ã™ã¹ã¦ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ãŒå¿…è¦ã§ã™ã€‚',0),(339368,9427,'pt','Todos os campos sÃ£o obrigatÃ³rios',0),(339369,9427,'ru','Ð’ÑÐµ Ð¿Ð¾Ð»Ñ ÑÐ²Ð»ÑÑŽÑ‚ÑÑ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼Ð¸',0),(339370,9427,'es','Todos los campos son obligatorios',0),(339371,9427,'de','Alle Felder sind Pflichtfelder',0),(339372,9427,'en','All Fields Are Required',0),(339373,9428,'is','',0),(339374,9428,'dr','Ù„Ø·ÙØ§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(339375,9428,'pr','Ù„Ø·ÙØ§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(339376,9428,'tr','LÃ¼tfen yeniden deneyin',0),(339377,9428,'pl','ProszÄ™ sprÃ³buj ponownie',0),(339378,9428,'bg','ÐœÐ¾Ð»Ñ, Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(339379,9428,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº',0),(339380,9428,'sr','ÐŸÐ¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(339381,9428,'vi','Vui lÃ²ng thá»­ láº¡i',0),(339382,9428,'af','Probeer Asseblief Weer',0),(339383,9428,'ro','VÄƒ rugÄƒm sÄƒ Ã®ncercaÅ£i din nou',0),(339384,9428,'et','Palun proovi uuesti',0),(339385,9428,'si','Prosimo, poskusite znova',0),(339386,9428,'ba','Silakan coba lagi',0),(339387,9428,'nl','Probeer het a.u.b. opnieuw',0),(339388,9428,'fi','YritÃ¤ uudelleen',0),(339389,9428,'no','PrÃ¸v pÃ¥ nytt',0),(339390,9428,'da','PrÃ¸v venligst igen',0),(339391,9428,'ko','ë‹¤ì‹œ ì‹œë„ í•˜ì‹­ì‹œì˜¤',0),(339392,9428,'he','×× × × ×¡×” ×©×•×‘',0),(339393,9428,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(339394,9428,'zh','è¯·å†è¯•ä¸€æ¬¡\r\n',0),(339395,9428,'sv','VÃ¤nligen fÃ¶rsÃ¶k igen',0),(339396,9428,'it','Si prega di riprovare',0),(339397,9428,'tl','',0),(339398,9428,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3621;&#3629;&#3591;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;',0),(339399,9428,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚',0),(339400,9428,'ms','Sila cuba lagi',0),(339401,9428,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„Ù…Ø­Ø§ÙˆÙ„Ø© Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(339402,9428,'fr','Please Try Again',0),(339403,9428,'jp','ã‚‚ã†ä¸€åº¦ã‚„ã‚Šç›´ã—ã¦ãã ã•ã„ã€‚',0),(339404,9428,'pt','Por favor, tente novamente',0),(339405,9428,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ð¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÐµÑ‰Ðµ Ñ€Ð°Ð·',0),(339406,9428,'es','Por Favor Intenta Otra Vez',0),(339407,9428,'de','Bitte versuchen Sie es erneut',0),(339408,9428,'en','Please Try Again',0),(339409,9429,'is','',0),(339410,9429,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ø­Ù…Ù„ Ù†Ø¯Ù‡ÙŠØ¯ Ø§Ú¯Ø± Ù‚ÙŠÙ…Øª Ù‡Ø§ Ø¯Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(339411,9429,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ø­Ù…Ù„ Ù†Ø¯Ù‡ÙŠØ¯ Ø§Ú¯Ø± Ù‚ÙŠÙ…Øª Ù‡Ø§ Ø¯Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø¬Ø±Ø§Ø¡Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(339412,9429,'tr','Eksik EÄŸer gemiyi karÅŸÄ±lama sipariÅŸinde maliyeti izin verme',0),(339413,9429,'pl','Nie Zezwalaj na statku, jeÅ›li brak kosztÃ³w realizacji zamÃ³wienia',0),(339414,9429,'bg','ÐÐµ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÑÐ²Ð°Ñ‚ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±, Ð°ÐºÐ¾ Ð»Ð¸Ð¿ÑÐ²Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¿Ð¾ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(339415,9429,'ur','Ø§Ú¯Ø± Ù„Ø§Ù¾ØªÛ Ø¬ÛØ§Ø² Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ù¾Ø± Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº',0),(339416,9429,'sr','ÐÐµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð±Ñ€Ð¾Ð´ Ð°ÐºÐ¾ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ ÐºÐ¾ÑˆÑ‚Ð° Ð½Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(339417,9429,'vi','KhÃ´ng cho váº­n chuyá»ƒn náº¿u thiáº¿u giÃ¡ thÃ nh trÃªn ÄÆ¡n HÃ ng Giao Táº­n NÆ¡i',0),(339418,9429,'af','Moenie Versending Toelaat Indien Kostes Op Uitvoeringsbestelling Uitgelaat is',0),(339419,9429,'ro','Permite navei Ã®n cazul Ã®n care lipsesc costÄƒ pe Ã®ndeplinirea comenzii',0),(339420,9429,'et','Ã„ra luba tarnimist, kui kaubatellimusel on hindu puudu',0),(339421,9429,'si','Ne dovoli, da ladje, Äe manjka stane na izpolnitev nalog',0),(339422,9429,'ba','Jangan biarkan biaya kapal jika hilang pada pemenuhan Order',0),(339423,9429,'nl','Laat niet schip als ontbrekende kost Fulfillment orde',0),(339424,9429,'fi','Ã„lÃ¤ anna laiva jos puuttuu maksaa tÃ¤yttÃ¶tilaus',0),(339425,9429,'no','Tillat ikke skipet hvis mangler koster pÃ¥ innfrielsesordren',0),(339426,9429,'da','Tillad ikke skib hvis mangler koster opfyldningsordren',0),(339427,9429,'ko','í–‰ ìˆœì„œì— ë“­ë‹ˆë‹¤ ë°° ëˆ„ë½ í•˜ëŠ” ê²½ìš° í—ˆìš© í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(339428,9429,'he','××œ ×ª××¤×©×¨ ×”×¡×¤×™× ×” ×× ×—×¡×¨×™× ×¢×•×œ×” ×¢×œ ×ž×™×ž×•×© ×”×–×ž× ×”',0),(339429,9429,'el','Î”ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï€Î»Î¿Î¯Î¿ Î±Î½ Î»ÎµÎ¯Ï€Î¿Ï…Î½ ÎºÎ¿ÏƒÏ„Î¯Î¶ÎµÎ¹ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(339430,9429,'zh','å¦‚æžœå±¥è¡Œè®¢å•æˆæœ¬ä¸¢å¤±ä¸å…è®¸è¿é€\r\n',0),(339431,9429,'sv','TillÃ¥t inte fartyget om saknas kostar uppfyllelseordern',0),(339432,9429,'it','Non consentire nave se mancante costa su ordine di evasione',0),(339433,9429,'tl','',0),(339434,9429,'th','&#3652;&#3617;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3626;&#3656;&#3591;&#3627;&#3634;&#3585;&#3652;&#3617;&#3656;&#3617;&#3637;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3',0),(339435,9429,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤…à¤—à¤° à¤²à¤¾à¤ªà¤¤à¤¾ à¤œà¤¹à¤¾à¤œ à¤²à¤¾à¤—à¤¤ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(339436,9429,'ms','Tidak membenarkan kapal jika hilang bayaran dengan memenuhi arahan',0),(339437,9429,'ar','Ø¹Ø¯Ù… Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ø°Ø§ ÙƒØ§Ù† ÙÙŠ Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙÙ‚ÙˆØ¯ÙŠÙ† ÙÙŠ Ø£Ù…Ø± Ø§Ù„Ø§Ø³ØªÙŠÙØ§Ø¡',0),(339438,9429,'fr','Ne pas laisser le navire sâ€™il manque coÃ»te sur ordre de traitement',0),(339439,9429,'jp','èˆ¹ãŒä¸è¶³ã—ã¦ã„ã‚‹å ´åˆã¯ã€ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼ã«ã‚³ã‚¹ãƒˆã‚’è¨±å¯ã—ã¾ã›ã‚“ã€‚',0),(339440,9429,'pt','NÃ£o Permita Envio se Faltando PreÃ§os e ou Ordem Preenchida',0),(339441,9429,'ru','ÐÐµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐ°Ð¹Ñ‚Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ, ÐµÑÐ»Ð¸ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð½Ð° Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(339442,9429,'es','No se Permite Enviar Si Faltan los Costos en el Orden de Cumplimiento',0),(339443,9429,'de','Nicht lassen Sie zu, dass Schiff fehlen auf AusfÃ¼hrungsauftrag kostet',0),(339444,9429,'en','Do Not Allow Ship If Missing Costs On Fulfillment Order',0),(339445,9430,'is','',0),(339446,9430,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ¬Ø§Ø±ÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ',0),(339447,9430,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ¬Ø§Ø±ÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ',0),(339448,9430,'tr','VarsayÄ±lan kategori osCommerce sipariÅŸleri iÃ§in',0),(339449,9430,'pl','DomyÅ›lna kategoria dla osCommerce zamÃ³wieÅ„',0),(339450,9430,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ osCommerce Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð°',0),(339451,9430,'ur','Ø¹Ø«Ú©ÙˆÙ…Ù…Ø±Ú©Ø§ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ø·Û’ Ø´Ø¯Û Ø²Ù…Ø±Û',0),(339452,9430,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð·Ð° Ð¾ÑÐ¦Ð¾Ð¼Ð¼ÐµÑ€Ñ†Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(339453,9430,'vi','Thá»ƒ loáº¡i máº·c Ä‘á»‹nh cho ÄÆ¡n HÃ ng OSCommerce',0),(339454,9430,'af','Verstekte Kategorie vir OSHandel Bestellings',0),(339455,9430,'ro','Categoria implicit pentru osCommerce comenzi',0),(339456,9430,'et','OsCommerce tellimuste vaikekategooria',0),(339457,9430,'si','Privzete kategorije za osCommerce naroÄila',0),(339458,9430,'ba','Patokan Jenis untuk Pesanan OSCommerce',0),(339459,9430,'nl','Standaardcategorie voor osCommerce bestellingen',0),(339460,9430,'fi','OsCommerce tilaukset oletusluokka',0),(339461,9430,'no','Standardkategori for osCommerce ordrer',0),(339462,9430,'da','Standardart for osCommerce ordrer',0),(339463,9430,'ko','OsCommerce ì£¼ë¬¸ì— ëŒ€ í•œ ê¸°ë³¸ ì¹´í…Œê³ ë¦¬',0),(339464,9430,'he','×§×˜×’×•×¨×™×ª ×‘×¨×™×¨×ª ×ž×—×“×œ ×¢×‘×•×¨ ×”×–×ž× ×•×ª osCommerce',0),(339465,9430,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ osCommerce',0),(339466,9430,'zh','é»˜è®¤ç±»åˆ«OSCommerceè®¢å•\r\n',0),(339467,9430,'sv','Standardkategori fÃ¶r osCommerce order',0),(339468,9430,'it','Categoria di default per gli ordini di osCommerce',0),(339469,9430,'tl','',0),(339470,9430,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3586;&#3629;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3619;&#3632;&#3610;&#3610;&#3',0),(339471,9430,'hi','OsCommerce à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(339472,9430,'ms','Kategori lalai untuk pesanan osCommerce',0),(339473,9430,'ar','Ø§Ù„ÙØ¦Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ù„Ø£ÙˆØ§Ù…Ø± Ø¨ÙˆØ±ØµØ© Ù…ØµØ±',0),(339474,9430,'fr','CatÃ©gorie par dÃ©faut pour les commandes dâ€™osCommerce',0),(339475,9430,'jp','ã‚ªãƒ³ãƒ©ã‚¤ãƒ³ ã‚·ãƒ§ãƒƒãƒ—ã®æ³¨æ–‡ã®æ—¢å®šã®ã‚«ãƒ†ã‚´ãƒª',0),(339476,9430,'pt','Categoria padrÃ£o para ordens de osCommerce',0),(339477,9430,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚-Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð°',0),(339478,9430,'es','CategorÃ­a Predeterminada para Pedidos de OSCommerce',0),(339479,9430,'de','Standardkategorie fÃ¼r OsCommerce-Bestellungen',0),(339480,9430,'en','Default Category for osCommerce Orders',0),(339481,9431,'is','',0),(339482,9431,'dr','ØªÙ†Ø¸ÙŠÙ… Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(339483,9431,'pr','ØªÙ†Ø¸ÙŠÙ… Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(339484,9431,'tr','VarsayÄ±lan deÄŸerleri baÅŸarÄ±yla kaydedildi',0),(339485,9431,'pl','WartoÅ›ci domyÅ›lne pomyÅ›lnie zapisany',0),(339486,9431,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(339487,9431,'ur','Ø·Û’ Ø´Ø¯Û Ù‚Ø¯Ø±ÙˆÚº Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸',0),(339488,9431,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(339489,9431,'vi','GiÃ¡ trá»‹ Máº·c Ä‘á»‹nh sao lÆ°u thÃ nh cÃ´ng',0),(339490,9431,'af','Verstekte Waardes Suksesvol Gestoor',0),(339491,9431,'ro','Valorile implicite salvat cu succes',0),(339492,9431,'et','Vaikimisi vÃ¤Ã¤rtused salvestati edukalt',0),(339493,9431,'si','Privzete vrednosti, ki je uspeÅ¡no shranjen',0),(339494,9431,'ba','Nilai-nilai default yang berhasil diselamatkan',0),(339495,9431,'nl','Standaardwaarden opgeslagen',0),(339496,9431,'fi','Oletusarvoja, jotka on tallennettu',0),(339497,9431,'no','Standardverdiene som er lagret',0),(339498,9431,'da','StandardvÃ¦rdier gemmes korrekt',0),(339499,9431,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” ê¸°ë³¸ ê°’',0),(339500,9431,'he','×¢×¨×›×™ ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(339501,9431,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Ï„Î¹Î¼Î­Ï‚ Ï€Î¿Ï… Î±Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(339502,9431,'zh','é»˜è®¤å€¼ä¿å­˜æˆåŠŸ\r\n',0),(339503,9431,'sv','StandardvÃ¤rden som sparats',0),(339504,9431,'it','Valori predefiniti salvati con successo',0),(339505,9431,'tl','',0),(339506,9431,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3652;&#3623;&#3657;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(339507,9431,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(339508,9431,'ms','Nilai-nilai lalai yang berjaya disimpan',0),(339509,9431,'ar','Ø­ÙØ¸Øª Ø§Ù„Ù‚ÙŠÙ… Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(339510,9431,'fr','Valeurs par dÃ©faut enregistrÃ©es avec succÃ¨s',0),(339511,9431,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚ŒãŸæ—¢å®šå€¤',0),(339512,9431,'pt','Valores padrÃ£o salvos com sucesso',0),(339513,9431,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(339514,9431,'es','Valores por OmisiÃ³n Guardado Exitosamente',0),(339515,9431,'de','Standardwerte erfolgreich gespeichert',0),(339516,9431,'en','Default Values Saved Successfully',0),(339517,9432,'is','',0),(339518,9432,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø®ÙˆØ¯ÙƒØ§Ø± ',0),(339519,9432,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø®ÙˆØ¯ÙƒØ§Ø± ',0),(339520,9432,'tr','VarsayÄ±lan deÄŸerler kaydedilirken hata oluÅŸtu',0),(339521,9432,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania wartoÅ›ci domyÅ›lne',0),(339522,9432,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸Ñ‚Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(339523,9432,'ur','Ø·Û’ Ø´Ø¯Û Ù‚Ø¯Ø±ÙˆÚº Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(339524,9432,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ¿Ñ€ÐµÐ¼Ð°ÑšÐ° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(339525,9432,'vi','Lá»—i sao lÆ°u giÃ¡ trá»‹ máº·c Ä‘á»‹nh',0),(339526,9432,'af','Fout met Stoor van Verstekte Waardes',0),(339527,9432,'ro','Eroare la salvarea valorile implicite',0),(339528,9432,'et','VaikevÃ¤Ã¤rtused salvestamisel ilmnes tÃµrge',0),(339529,9432,'si','Napaka pri shranjevanju privzete vrednosti',0),(339530,9432,'ba','Kesalahan menyimpan nilai Default',0),(339531,9432,'nl','Fout bij het opslaan van standaardwaarden',0),(339532,9432,'fi','Virhe tallennettaessa oletusarvot',0),(339533,9432,'no','Feil under lagring av standardverdier',0),(339534,9432,'da','Fejl under lagring af standardvÃ¦rdier',0),(339535,9432,'ko','ê¸°ë³¸ ê°’ì„ ì €ìž¥ í•˜ëŠ” ì˜¤ë¥˜',0),(339536,9432,'he','×©×’×™××” ×‘×¢×ª ×©×ž×™×¨×ª ×¢×¨×›×™ ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(339537,9432,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Ï„Î¹Î¼Î­Ï‚',0),(339538,9432,'zh','é”™è¯¯ä¿å­˜é»˜è®¤å€¼\r\n',0),(339539,9432,'sv','Fel vid sparande av standardvÃ¤rden',0),(339540,9432,'it','Errore durante il salvataggio di valori predefiniti',0),(339541,9432,'tl','',0),(339542,9432,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3588;&#3656;&#3634;&#3617;&#3634;&#3605;&#3619;&#3634;&#3600;&#3634;&#3609;',0),(339543,9432,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¤¾à¤¨ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(339544,9432,'ms','Ralat Menyimpan nilai lalai',0),(339545,9432,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸ Ø§Ù„Ù‚ÙŠÙ… Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(339546,9432,'fr','Erreur dâ€™enregistrement des valeurs par dÃ©faut',0),(339547,9432,'jp','æ—¢å®šå€¤ã‚’ä¿å­˜ä¸­ã«ã‚¨ãƒ©ãƒ¼',0),(339548,9432,'pt','Erro ao salvar valores padrÃ£o',0),(339549,9432,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(339550,9432,'es','Error Guardando los Valores por OmisiÃ³n',0),(339551,9432,'de','Fehler beim Speichern des Default-Werte',0),(339552,9432,'en','Error Saving Default Values',0),(339553,9433,'is','',0),(339554,9433,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§ÙŠ Ø§Ø¯ØºØ§Ù… Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(339555,9433,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§ÙŠ Ø§Ø¯ØºØ§Ù… Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(339556,9433,'tr','osCommerce TÃ¼mleÅŸtirme VarsayÄ±lanlarÄ±',0),(339557,9433,'pl','DomyÅ›lnie jest integracja osCommerce',0),(339558,9433,'bg','osCommerce Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(339559,9433,'ur','Ø§Ù†Ø¶Ù…Ø§Ù… Ø·Û’ Ø´Ø¯Û Ø¹Ø«Ú©ÙˆÙ…Ù…Ø±Ø³ÛŒ',0),(339560,9433,'sr','Ð¾ÑÐ¦Ð¾Ð¼Ð¼ÐµÑ€Ñ†Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ˜Ðµ',0),(339561,9433,'vi','Máº·c Äá»‹nh Há»£p Nháº¥t ThÆ°Æ¡ng Máº¡i OSC',0),(339562,9433,'af','OSHandel Verstekte Intergrasie',0),(339563,9433,'ro','osCommerce Defaults de integrare',0),(339564,9433,'et','osCommerce integratsiooni vaikesÃ¤tted',0),(339565,9433,'si','osCommerce integracija privzetih nastavitev',0),(339566,9433,'ba','osCommerce integrasi default',0),(339567,9433,'nl','osCommerce integratie standaard',0),(339568,9433,'fi','osCommerce yhdentymisen oletukset',0),(339569,9433,'no','osCommerce integrering standarder',0),(339570,9433,'da','osCommerce Integration som standard',0),(339571,9433,'ko','osCommerce í†µí•© ê¸°ë³¸ê°’',0),(339572,9433,'he','osCommerce ××™× ×˜×’×¨×¦×™×” ×‘×¨×™×¨×•×ª ×ž×—×“×œ',0),(339573,9433,'el','osCommerce Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ·Ï‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(339574,9433,'zh','è´­ç‰©è½¦ç³»ç»Ÿæ•´ä½“é»˜è®¤\r\n',0),(339575,9433,'sv','osCommerce Integration som standard',0),(339576,9433,'it','osCommerce integrazione impostazioni predefinite',0),(339577,9433,'tl','',0),(339578,9433,'th','&#3619;&#3623;&#3617;&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609; OSCommerce',0),(339579,9433,'hi','osCommerce à¤à¤•à¤¤à¤¾ à¤šà¥‚à¤•',0),(339580,9433,'ms','osCommerce integrasi lalai',0),(339581,9433,'ar','Ø¨ÙˆØ±ØµØ© Ù…ØµØ± \"Ø§Ù„ØªÙƒØ§Ù…Ù„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ§Øª\"',0),(339582,9433,'fr','osCommerce, intÃ©gration par dÃ©faut',0),(339583,9433,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã§çµ±åˆã‚ªãƒ³ãƒ©ã‚¤ãƒ³ ã‚·ãƒ§ãƒƒãƒ—',0),(339584,9433,'pt','PadrÃµes de integraÃ§Ã£o de osCommerce',0),(339585,9433,'ru','Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚-Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð°',0),(339586,9433,'es','IntegraciÃ³n de OSCommerce Predeterminadas',0),(339587,9433,'de','OsCommerce Integration in Verzug',0),(339588,9433,'en','osCommerce Integration Defaults',0),(339589,9434,'is','',0),(339590,9434,'dr','NolaPro Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§Ø¨Ø· ÛŒÙˆØ²Ø±Ø¯ÙŠ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÙØª ÙˆÛŒØ± ',0),(339591,9434,'pr','NolaPro Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§Ø¨Ø· ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ',0),(339592,9434,'tr','API gÃ¼nlÃ¼ÄŸe kaydetme',0),(339593,9434,'pl','API Logging',0),(339594,9434,'bg','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° API',0),(339595,9434,'ur','API Ù„Ø§Ú¯ Ø§Ù†',0),(339596,9434,'sr','Ð’Ð¾Ñ’ÐµÑšÐµ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐÐŸÐ˜',0),(339597,9434,'vi','Äang Ä‘Äƒng nháº­p NolaPro API',0),(339598,9434,'af','NolaPro API Aantekening',0),(339599,9434,'ro','API de logare',0),(339600,9434,'et','API logimine',0),(339601,9434,'si','API seÄnje',0),(339602,9434,'ba','API Logging',0),(339603,9434,'nl','API-logboekregistratie',0),(339604,9434,'fi','API kirjaaminen',0),(339605,9434,'no','API Logging',0),(339606,9434,'da','LogfÃ¸ring af API',0),(339607,9434,'ko','API ë¡œê¹…',0),(339608,9434,'he','×¨×™×©×•× API',0),(339609,9434,'el','ÎšÎ±Ï„Î±Î³ÏÎ±Ï†Î® API',0),(339610,9434,'zh','NolaProåº”ç”¨ç¨‹åºç¼–ç¨‹æŽ¥å£ç™»å½•\r\n',0),(339611,9434,'sv','API-loggning',0),(339612,9434,'it','Registrazione API',0),(339613,9434,'tl','',0),(339614,9434,'th','NolaPro API Logging',0),(339615,9434,'hi','API à¤²à¥‰à¤—à¤¿à¤‚à¤—',0),(339616,9434,'ms','Pembalakan API',0),(339617,9434,'ar','ØªØ³Ø¬ÙŠÙ„ API',0),(339618,9434,'fr','Journalisation d\'API',0),(339619,9434,'jp','API ãƒ­ã‚°',0),(339620,9434,'pt','Logging API',0),(339621,9434,'ru','API Ð¿Ñ€Ð¾Ñ‚Ð¾ÐºÐ¾Ð»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(339622,9434,'es','Poniendo el API de NolaPro en BitÃ¡cora',0),(339623,9434,'de','API-Protokollierung',0),(339624,9434,'en','API Logging',0),(339625,9435,'is','',0),(339626,9435,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù„ØºÙˆ Ø´Ø¯ Ø¨Ø¹Ù„Øª ÙƒØ§Ù„Ø§ÙŠ Ø¨Ø¯ÙˆÙ† Ù‚ÙŠÙ…Øª ',0),(339627,9435,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù„ØºÙˆ Ø´Ø¯ Ø¨Ø¹Ù„Øª ÙƒØ§Ù„Ø§ÙŠ Ø¨Ø¯ÙˆÙ† Ù‚ÙŠÙ…Øª ',0),(339628,9435,'tr','Sevk irsaliyesi ile hayÄ±r fiyat-madde nedeniyle iptal',0),(339629,9435,'pl','OdwoÅ‚any z powodu elementu bez kosztÃ³w przesyÅ‚ki',0),(339630,9435,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°, Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð° Ð¿Ð¾Ñ€Ð°Ð´Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ Ð±ÐµÐ· Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(339631,9435,'ur','ÛÚ‘Ù¾Û Ú©ÛŒ Ú©ÙˆØ¦ÛŒ Ù‚ÛŒÙ…Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ø´Û’ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(339632,9435,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð° Ð·Ð±Ð¾Ð³ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» ÑÐ° Ð½ÐµÐ¼Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(339633,9435,'vi','Chuyáº¿n hÃ ng há»§y do hÃ ng khÃ´ng cÃ³ giÃ¡ thÃ nh',0),(339634,9435,'af','Besending Gekanselleer Weens die feit dat Item Nie oor \'n Koste beskik nie',0),(339635,9435,'ro','Anulat din cauza element cu nu a costa de expediere',0),(339636,9435,'et','Saadetise tÃµttu kauba tasuta',0),(339637,9435,'si','Dobavnice, odpovedan zaradi elementa brez stroÅ¡kov',0),(339638,9435,'ba','Dibatalkan karena Item dengan tanpa biaya pengiriman',0),(339639,9435,'nl','Verzending geannuleerd wegens Item zonder kosten',0),(339640,9435,'fi','Siirto peruuntuu nimikkeen ilman kustannuksia',0),(339641,9435,'no','Forsendelsen avlyst pÃ¥ grunn av elementet uten kostnad',0),(339642,9435,'da','OverfÃ¸rslen annulleret pÃ¥ grund af varen uden omkostninger',0),(339643,9435,'ko','ì„ ì  ë¹„ìš© ì—†ì´ í•­ëª© ë•Œë¬¸ì— ì·¨ì†Œ',0),(339644,9435,'he','×‘×•×˜×œ ×¢×§×‘ ×¤×¨×™×˜ ×¢× ×œ× ×¢×œ×•×ª ×”×ž×©×œ×•×—',0),(339645,9435,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î±ÎºÏ…ÏÏ‰Î¸ÎµÎ¯ Î»ÏŒÎ³Ï‰ ÎµÎ¯Î´Î¿Ï‚ Î¼Îµ Ï„Î·Î½ Ï‡Ï‰ÏÎ¯Ï‚ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(339646,9435,'zh','è£…è¿å–æ¶ˆï¼Œå› ä¸ºé¡¹ç›®æ— æˆæœ¬\r\n',0),(339647,9435,'sv','SÃ¤ndningen avbryts pÃ¥ grund av objekt med utan kostnad',0),(339648,9435,'it','Annullata a causa di elemento senza alcun costo di spedizione',0),(339649,9435,'tl','',0),(339650,9435,'th','&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;&#3606;&#3641;&#3585;&#3618;&#3585;&#3648;&#3621;&#3636;&#3585;&#3648;&#3609;&#3639;&#3656;&#3629;&#3591;&#3592;&#3634;&#3585;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3652;&#3617;&#3656;&#3617;&#3',0),(339651,9435,'hi','à¤•à¥‹à¤ˆ à¤²à¤¾à¤—à¤¤ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤•à¤¾à¤°à¤£ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤²à¤¦à¤¾à¤¨',0),(339652,9435,'ms','Dibatalkan kerana Item dengan tanpa sebarang kos penghantaran',0),(339653,9435,'ar','Ø£Ù„ØºÙ‰ Ø¨Ø³Ø¨Ø¨ Ø§Ù„Ø¨Ù†Ø¯ Ø¨Ø£ÙŠ ØªÙƒÙ„ÙØ© Ø§Ù„Ø´Ø­Ù†',0),(339654,9435,'fr','AnnulÃ©e en raison de lâ€™Ã©lÃ©ment sans frais de livraison',0),(339655,9435,'jp','å‡ºè·è²»ç”¨ãªã—ã§é …ç›®ã®ãŸã‚ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(339656,9435,'pt','Cancelado devido ao Item sem o custo de envio',0),(339657,9435,'ru','ÐžÑ‚Ð³Ñ€ÑƒÐ·ÐºÐ°, Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½ Ð¸Ð·-Ð·Ð° Ð¿ÑƒÐ½ÐºÑ‚Ð° Ñ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(339658,9435,'es','EnvÃ­o Cancelado por Causa de un Item Sin Costo',0),(339659,9435,'de','Versand abgesagt wegen Artikel ohne Kosten',0),(339660,9435,'en','Shipment Canceled Due To Item With No Cost',0),(339661,9436,'is','',0),(339662,9436,'dr','Ø§Ø¯ØºØ§Ù… Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(339663,9436,'pr','Ø§Ø¯ØºØ§Ù… Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(339664,9436,'tr','osCommerce TÃ¼mleÅŸtirme',0),(339665,9436,'pl','osCommerce integracji',0),(339666,9436,'bg','osCommerce Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ',0),(339667,9436,'ur','Ø¹Ø«Ú©ÙˆÙ…Ù…Ø±Ø³ÛŒ Ø§Ù†Ø¶Ù…Ø§Ù…',0),(339668,9436,'sr','Ð¾ÑÐ¦Ð¾Ð¼Ð¼ÐµÑ€Ñ†Ðµ Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ˜Ðµ',0),(339669,9436,'vi','Há»£p Nháº¥t ThÆ°Æ¡ng Máº¡i OSC',0),(339670,9436,'af','OSHandel Intergrasie',0),(339671,9436,'ro','osCommerce integrare',0),(339672,9436,'et','osCommerce integratsiooni',0),(339673,9436,'si','osCommerce integracije',0),(339674,9436,'ba','osCommerce integrasi',0),(339675,9436,'nl','osCommerce integratie',0),(339676,9436,'fi','osCommerce integraatio',0),(339677,9436,'no','osCommerce integrering',0),(339678,9436,'da','osCommerce Integration',0),(339679,9436,'ko','osCommerce í†µí•©',0),(339680,9436,'he','osCommerce ××™× ×˜×’×¨×¦×™×”',0),(339681,9436,'el','osCommerce Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ·Ï‚',0),(339682,9436,'zh','å†œå·¥å•†ä¸€ä½“åŒ–çš„æ“ä½œç³»ç»Ÿ\r\n',0),(339683,9436,'sv','osCommerce Integration',0),(339684,9436,'it','osCommerce integrazione',0),(339685,9436,'tl','',0),(339686,9436,'th','&#3585;&#3634;&#3619;&#3619;&#3623;&#3617; OSCommerce',0),(339687,9436,'hi','osCommerce à¤à¤•à¤¤à¤¾',0),(339688,9436,'ms','osCommerce integrasi',0),(339689,9436,'ar','Ø§Ù„ØªÙƒØ§Ù…Ù„ Ù…Ø¹ OSCommerce',0),(339690,9436,'fr','IntÃ©gration dâ€™osCommerce',0),(339691,9436,'jp','osCommerce ã®çµ±åˆ',0),(339692,9436,'pt','IntegraÃ§Ã£o de osCommerce',0),(339693,9436,'ru','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚-Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð° Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ð¸',0),(339694,9436,'es','IntegraciÃ³n de OSCommerce',0),(339695,9436,'de','OsCommerce Integration',0),(339696,9436,'en','osCommerce Integration',0),(339697,9437,'is','',0),(339698,9437,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(339699,9437,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ ÙˆØ§Ø­Ø¯ Ù‚ÙŠÙ…Øª ',0),(339700,9437,'tr','VarsayÄ±lan fiyat birimi',0),(339701,9437,'pl','DomyÅ›lna jednostka cenowa',0),(339702,9437,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(339703,9437,'ur','Ø·Û’ Ø´Ø¯Û Ù‚ÛŒÙ…Øª ÛŒÙˆÙ†Ù¹',0),(339704,9437,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ñ†ÐµÐ½Ñƒ',0),(339705,9437,'vi','ÄÆ¡n vá»‹ GiÃ¡ Máº·c Ä‘á»‹nh',0),(339706,9437,'af','Verstekte Pryseenheid',0),(339707,9437,'ro','Implicit preÅ£ul unitar',0),(339708,9437,'et','VaikemÃµÃµtÃ¼hiku hind',0),(339709,9437,'si','Privzeta enota cene',0),(339710,9437,'ba','Standar harga Unit',0),(339711,9437,'nl','Standaard prijs eenheid',0),(339712,9437,'fi','Hinta OletusyksikkÃ¶',0),(339713,9437,'no','Standard prisenhet',0),(339714,9437,'da','Standard prisenhed',0),(339715,9437,'ko','ê¸°ë³¸ ê°€ê²© ë‹¨ìœ„',0),(339716,9437,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×ž×—×™×¨ ×”×™×—×™×“×”',0),(339717,9437,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï„Î¹Î¼Î® Î¼Î¿Î½Î¬Î´Î±',0),(339718,9437,'zh','é»˜è®¤ä»·æ ¼å•ä½\r\n',0),(339719,9437,'sv','Standard prisenhet',0),(339720,9437,'it','UnitÃ  di prezzo predefinito',0),(339721,9437,'tl','',0),(339722,9437,'th','&#3629;&#3633;&#3605;&#3619;&#3634;&#3588;&#3656;&#3634;&#3627;&#3609;&#3656;&#3634;&#3623;&#3618;&#3619;&#3634;&#3588;&#3634;',0),(339723,9437,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤•à¤¾à¤ˆ',0),(339724,9437,'ms','Unit harga lalai',0),(339725,9437,'ar','ÙˆØ­Ø¯Ø© Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(339726,9437,'fr','UnitÃ© de prix par dÃ©faut',0),(339727,9437,'jp','æ—¢å®šã®ä¾¡æ ¼å˜ä½',0),(339728,9437,'pt','Unidade de preÃ§o padrÃ£o',0),(339729,9437,'ru','Ð¦ÐµÐ½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(339730,9437,'es','Unidad de Precio por OmisiÃ³n',0),(339731,9437,'de','Standardpreis Einheit',0),(339732,9437,'en','Default Price Unit',0),(339733,9438,'is','',0),(339734,9438,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´  ',0),(339735,9438,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´  ',0),(339736,9438,'tr','VarsayÄ±lan satÄ±ÅŸ Kategori',0),(339737,9438,'pl','DomyÅ›lnej kategorii sprzedaÅ¼y',0),(339738,9438,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(339739,9438,'ur','Ø·Û’ Ø´Ø¯Û Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û',0),(339740,9438,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(339741,9438,'vi','Thá»ƒ loáº¡i bÃ¡n hÃ ng máº·c Ä‘á»‹nh',0),(339742,9438,'af','Verstekte Verkoopskategorie',0),(339743,9438,'ro','Implicit categoria vanzari',0),(339744,9438,'et','MÃ¼Ã¼gi vaikekategooria',0),(339745,9438,'si','Privzeto prodaje Kategorija',0),(339746,9438,'ba','Default kategori penjualan',0),(339747,9438,'nl','Verkoop standaardcategorie',0),(339748,9438,'fi','Myynnin oletusluokka',0),(339749,9438,'no','Standardkategori for salg',0),(339750,9438,'da','Standard salgskategori',0),(339751,9438,'ko','ê¸°ë³¸ íŒë§¤ ì¹´í…Œê³ ë¦¬',0),(339752,9438,'he','×§×˜×’×•×¨×™×ª ×ž×›×™×¨×•×ª ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(339753,9438,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(339754,9438,'zh','é»˜è®¤é”€å”®ç§ç±»',0),(339755,9438,'sv','Standardkategori fÃ¶r fÃ¶rsÃ¤ljning',0),(339756,9438,'it','Categoria di vendita predefinito',0),(339757,9438,'tl','',0),(339758,9438,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3617;&#3623;&#3604;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(339759,9438,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(339760,9438,'ms','Kategori jualan lalai',0),(339761,9438,'ar','ØªØµÙ†ÙŠÙ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠ',0),(339762,9438,'fr','CatÃ©gorie de vente par dÃ©faut',0),(339763,9438,'jp','æ—¢å®šã®è²©å£²ã‚«ãƒ†ã‚´ãƒª',0),(339764,9438,'pt','Vendas categoria padrÃ£o',0),(339765,9438,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÐŸÑ€Ð¾Ð´Ð°Ð¶ ÐŸÐ¾ Ð£Ð¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(339766,9438,'es','CategorÃ­a de Ventas por OmisiÃ³n',0),(339767,9438,'de','Standardkategorie Vertrieb',0),(339768,9438,'en','Default Sales Category',0),(339769,9439,'is','',0),(339770,9439,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ ÙˆØ§Ø­Ø¯ ÙØ±ÙˆØ´  ',0),(339771,9439,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ ÙˆØ§Ø­Ø¯ ÙØ±ÙˆØ´  ',0),(339772,9439,'tr','VarsayÄ±lan satÄ±ÅŸ birimi',0),(339773,9439,'pl','DomyÅ›lnÄ… jednostkÄ… SprzedajÄ…',0),(339774,9439,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(339775,9439,'ur','Ø·Û’ Ø´Ø¯Û Ø¨ÛŒÚ†ÛŒÚº ÛŒÙˆÙ†Ù¹',0),(339776,9439,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(339777,9439,'vi','ÄÆ¡n vá»‹ bÃ¡n máº·c Ä‘á»‹nh',0),(339778,9439,'af','Verstekte Verkoopte Eenheid',0),(339779,9439,'ro','Unitate de Vindem implicit',0),(339780,9439,'et','MÃ¼Ã¼a vaikemÃµÃµtÃ¼hiku',0),(339781,9439,'si','Privzete enote za prodajo',0),(339782,9439,'ba','Default Jual Unit',0),(339783,9439,'nl','Standaardeenheid voor verkopen',0),(339784,9439,'fi','Myy OletusyksikkÃ¶',0),(339785,9439,'no','Standardenhet for salg',0),(339786,9439,'da','Standard sÃ¦lge enhed',0),(339787,9439,'ko','ê¸°ë³¸ íŒë§¤ ë‹¨ìœ„',0),(339788,9439,'he','×™×—×™×“×ª ×œ×ž×›×•×¨ ×›×‘×¨×™×¨×ª ×ž×—×“×œ',0),(339789,9439,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¼Î¿Î½Î¬Î´Î± Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(339790,9439,'zh','é»˜è®¤é”€å”®å•ä½',0),(339791,9439,'sv','SÃ¤lja standardenhet',0),(339792,9439,'it','UnitÃ  di vendita predefinito',0),(339793,9439,'tl','',0),(339794,9439,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3627;&#3609;&#3656;&#3623;&#3618;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;',0),(339795,9439,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¬à¥‡à¤š à¤‡à¤•à¤¾à¤ˆ',0),(339796,9439,'ms','Lalai menjual Unit',0),(339797,9439,'ar','ÙˆØ­Ø¯Ø© Ø¨ÙŠØ¹ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(339798,9439,'fr','UnitÃ© de vente par dÃ©faut',0),(339799,9439,'jp','æ—¢å®šã®è²©å£²å˜ä½',0),(339800,9439,'pt','Unidade de venda padrÃ£o',0),(339801,9439,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(339802,9439,'es','Unidad de Ventas por OmisiÃ³n',0),(339803,9439,'de','Standardeinheit verkaufen',0),(339804,9439,'en','Default Sell Unit',0),(339805,9440,'is','',0),(339806,9440,'dr','ØªØµØ­ÙŠØ­ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø´Ø±ÙƒØª ',0),(339807,9440,'pr','ØªØµØ­ÙŠØ­ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø´Ø±ÙƒØª ',0),(339808,9440,'tr','GL hesap ÅŸirket dÃ¼zeltme',0),(339809,9440,'pl','Poprawka GL konto firmy',0),(339810,9440,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð¾Ð±Ñ‰ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€Ð¸ÐºÑ€ÐµÐ¿Ð²Ð°Ð¼',0),(339811,9440,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ù…Ù¾Ù†ÛŒ Ø¯Ø±Ø³Øª Ú©Ø±ÛŒÚº',0),(339812,9440,'sr','Ð“Ð› Ð Ð°Ñ‡ÑƒÐ½ Ð¦Ð¾Ð¼Ð¿Ð°Ð½y Ð¤Ð¸x',0),(339813,9440,'vi','Chá»‘t TK Sá»• CÃ¡i Tá»•ng Há»£p Cá»§a Cty',0),(339814,9440,'af','GL rekening maatskappy Fix',0),(339815,9440,'ro','Compania de cont GL Fix',0),(339816,9440,'et','GL konto ettevÃµtte parandus',0),(339817,9440,'si','Pritrditi GL raÄun podjetja',0),(339818,9440,'ba','Memperbaiki GL Account perusahaan',0),(339819,9440,'nl','GL Account bedrijf Fix',0),(339820,9440,'fi','GL huomioon firma fiksoida',0),(339821,9440,'no','GL konto selskapet fastsette',0),(339822,9440,'da','GL konto selskab Fix',0),(339823,9440,'ko','GL ê³„ì • íšŒì‚¬ ìˆ˜ì •',0),(339824,9440,'he','×ª×™×§×•×Ÿ ×”×—×‘×¨×” ×—×©×‘×•×Ÿ GL',0),(339825,9440,'el','Î•Ï€Î¹Î´Î¹ÏŒÏÎ¸Ï‰ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ GL',0),(339826,9440,'zh','æ€»å¸å¸æˆ·å…¬å¸ä¿®å¤\r\n',0),(339827,9440,'sv','GL konto fÃ¶retaget Fix',0),(339828,9440,'it','SocietÃ  di contabilitÃ  generale Account Fix',0),(339829,9440,'tl','',0),(339830,9440,'th','&#3592;&#3633;&#3604;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3586;&#3629;&#3591;&#3607;&#3637;&#3656;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3649;&#3',0),(339831,9440,'hi','GL à¤–à¤¾à¤¤à¥‡ à¤•à¤‚à¤ªà¤¨à¥€ à¤¤à¤¯',0),(339832,9440,'ms','Baiki GL akaun Syarikat',0),(339833,9440,'ar','Ø¥ØµÙ„Ø§Ø­ GL Ø­Ø³Ø§Ø¨ Ø§Ù„Ø´Ø±ÙƒØ©',0),(339834,9440,'fr','Compagnie compte GL Fix',0),(339835,9440,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ä¼šç¤¾ã®ä¿®æ­£',0),(339836,9440,'pt','CorreÃ§Ã£o de GL conta empresa',0),(339837,9440,'ru','GL ÑÑ‡ÐµÑ‚Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Fix',0),(339838,9440,'es','Cuenta LM Arreglar la Empresa',0),(339839,9440,'de','GL-Konto Firma Fix',0),(339840,9440,'en','GL Account Company Fix',0),(339841,9441,'is','',0),(339842,9441,'dr','Ø¢ÙŠØ§ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ ØŸ',0),(339843,9441,'pr','Ø¢ÙŠØ§ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…ÙŠ ÙƒÙ†ÙŠØ¯ ØŸ',0),(339844,9441,'tr','Bu sipariÅŸ sÃ¼reci?',0),(339845,9441,'pl','Realizacji zamÃ³wienia?',0),(339846,9441,'bg','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚Ð²Ð° Ñ‚Ð¾Ð·Ð¸ Ñ€ÐµÐ´?',0),(339847,9441,'ur','Ø§Ø³ Ø­Ú©Ù… Ù¾Ø± Ø¹Ù…Ù„ØŸ',0),(339848,9441,'sr','ÐžÐ±Ñ€Ð°Ð´Ð¸ Ð¾Ð²Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ð°?',0),(339849,9441,'vi','Xá»­ lÃ½ Ä‘Æ¡n hÃ ng nÃ y?',0),(339850,9441,'af','Verwerk hierdie bestelling?',0),(339851,9441,'ro','Procesul de acest ordin?',0),(339852,9441,'et','See, et protsess?',0),(339853,9441,'si','Proces to naloga?',0),(339854,9441,'ba','Proses pesanan ini?',0),(339855,9441,'nl','Deze bestelling verwerken?',0),(339856,9441,'fi','TÃ¤mÃ¤n tilauksen kÃ¤sittelyyn?',0),(339857,9441,'no','Behandle denne rekkefÃ¸lgen?',0),(339858,9441,'da','Behandle denne ordre?',0),(339859,9441,'ko','ì´ ìˆœì„œë¥¼ ì²˜ë¦¬ í•©ë‹ˆê¹Œ?',0),(339860,9441,'he','×œ×¢×‘×“ ×”×–×ž× ×” ×–×•?',0),(339861,9441,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬;',0),(339862,9441,'zh','å¤„ç†æ­¤å‘½ä»¤ï¼Ÿ\r\n',0),(339863,9441,'sv','Behandla denna bestÃ¤llning?',0),(339864,9441,'it','Evadere l\'ordine?',0),(339865,9441,'tl','',0),(339866,9441,'th','&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3609;&#3637;&#3657;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;?',0),(339867,9441,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾?',0),(339868,9441,'ms','Memproses Perintah ini?',0),(339869,9441,'ar','Ù…Ø¹Ø§Ù„Ø¬Ø© Ù‡Ø°Ø§ Ø§Ù„Ø£Ù…Ø±ØŸ',0),(339870,9441,'fr','Traiter cette commandeÂ ?',0),(339871,9441,'jp','ã“ã®æ³¨æ–‡ã®å‡¦ç†ã§ã™ã‹ã€‚',0),(339872,9441,'pt','Processar esta ordem?',0),(339873,9441,'ru','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº?',0),(339874,9441,'es','Â¿Procesa este Pedido?',0),(339875,9441,'de','Bearbeiten diese Bestellung?',0),(339876,9441,'en','Process this order?',0),(339877,9442,'is','',0),(339878,9442,'dr','ÙƒÙ„ÙŠØ¯ Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯ÙŠ',0),(339879,9442,'pr','ÙƒÙ„ÙŠØ¯ Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯ÙŠ',0),(339880,9442,'tr','API anahtarÄ±',0),(339881,9442,'pl','Klucz API',0),(339882,9442,'bg','API ÐºÐ»ÑŽÑ‡',0),(339883,9442,'ur','API Ú©Ù„ÛŒØ¯',0),(339884,9442,'sr','ÐÐŸÐ˜ ÐºÑ™ÑƒÑ‡',0),(339885,9442,'vi','ChÃ¬a API',0),(339886,9442,'af','API Sleutel',0),(339887,9442,'ro','API-cheie',0),(339888,9442,'et','API vÃµti',0),(339889,9442,'si','API kljuÄ',0),(339890,9442,'ba','Kunci API',0),(339891,9442,'nl','API-sleutel',0),(339892,9442,'fi','API-avain',0),(339893,9442,'no','API-nÃ¸kkel',0),(339894,9442,'da','API-nÃ¸gle',0),(339895,9442,'ko','API í‚¤',0),(339896,9442,'he','API ×ž×¤×ª×—',0),(339897,9442,'el','ÎšÎ»ÎµÎ¹Î´Î¯ API',0),(339898,9442,'zh','åº”ç”¨ç¨‹åºæŽ¥å£å¯†é’¥\r\n',0),(339899,9442,'sv','API-nyckel',0),(339900,9442,'it','Chiave API',0),(339901,9442,'tl','',0),(339902,9442,'th','API Key',0),(339903,9442,'hi','API à¤•à¥à¤‚à¤œà¥€',0),(339904,9442,'ms','Kekunci API',0),(339905,9442,'ar','API Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(339906,9442,'fr','ClÃ© API',0),(339907,9442,'jp','API ã‚­ãƒ¼',0),(339908,9442,'pt','Chave de API',0),(339909,9442,'ru','ÐšÐ»ÑŽÑ‡ API',0),(339910,9442,'es','Clave de API',0),(339911,9442,'de','API-SchlÃ¼ssel',0),(339912,9442,'en','API Key',0),(339913,9443,'is','',0),(339914,9443,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ',0),(339915,9443,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø±Ø§Ø¨Ø· Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ',0),(339916,9443,'tr','Mevcut API hesaplarÄ±',0),(339917,9443,'pl','Konta dostÄ™pne API',0),(339918,9443,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¸ API ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(339919,9443,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ API Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(339920,9443,'sr','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ðµ ÐÐŸÐ˜ Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(339921,9443,'vi','TK API CÃ³ Sáºµn',0),(339922,9443,'af','Beskikbare API Rekeninge',0),(339923,9443,'ro','Conturi disponibile API',0),(339924,9443,'et','Saadaval API kontod',0),(339925,9443,'si','Na voljo API raÄunov',0),(339926,9443,'ba','Tersedia API account',0),(339927,9443,'nl','Beschikbare API Accounts',0),(339928,9443,'fi','Saatavilla API tilit',0),(339929,9443,'no','Tilgjengelige API kontoer',0),(339930,9443,'da','TilgÃ¦ngelige API konti',0),(339931,9443,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” API ê³„ì •',0),(339932,9443,'he','API ×–×ž×™×Ÿ ×—×©×‘×•× ×•×ª',0),(339933,9443,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î¿ API Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(339934,9443,'zh','å¯ç”¨çš„åº”ç”¨ç¼–ç¨‹æŽ¥å£å¸æˆ·\r\n',0),(339935,9443,'sv','TillgÃ¤ngliga API konton',0),(339936,9443,'it','Conti di API disponibili',0),(339937,9443,'tl','',0),(339938,9443,'th','&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3610;&#3633;&#3597;&#3594;&#3637; API &#3652;&#3604;&#3657;',0),(339939,9443,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ API à¤–à¤¾à¤¤à¥‹à¤‚',0),(339940,9443,'ms','API disediakan akaun',0),(339941,9443,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª API Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(339942,9443,'fr','Comptes de lâ€™API disponibles',0),(339943,9443,'jp','åˆ©ç”¨ã§ãã‚‹ API ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(339944,9443,'pt','Contas de API disponÃ­vel',0),(339945,9443,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ API ÑÑ‡ÐµÑ‚Ð°',0),(339946,9443,'es','Cuentas de API Disponibles',0),(339947,9443,'de','VerfÃ¼gbare API Konten',0),(339948,9443,'en','Available API Accounts',0),(339949,9444,'is','',0),(339950,9444,'dr','ÙˆØ±ÙˆØ¯ Ù…Ø¯ÙŠØ±ÙŠØª Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(339951,9444,'pr','ÙˆØ±ÙˆØ¯ Ù…Ø¯ÙŠØ±ÙŠØª Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(339952,9444,'tr','OSCom Admin kullanÄ±cÄ± adÄ±',0),(339953,9444,'pl','OSCom Admin Login',0),(339954,9444,'bg','OSCom Admin Ð²Ñ…Ð¾Ð´',0),(339955,9444,'ur','Ø¹Ø«Ú©Ø§ÙˆÙ… Ø§ÛŒÚˆÙ…Ù† Ù„Ø§Ú¯ Ø§Ù†',0),(339956,9444,'sr','ÐžÐ¡Ð¦Ð¾Ð¼ ÐÐ´Ð¼Ð¸Ð½ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð°',0),(339957,9444,'vi','OSCom Quáº£n Trá»‹ ÄÄƒng Nháº­p',0),(339958,9444,'af','OSCom Admin Aantekening',0),(339959,9444,'ro','OSCom Admin Login',0),(339960,9444,'et','OSCom Admin Logi sisse',0),(339961,9444,'si','OSCom Admin uporabniÅ¡ko ime',0),(339962,9444,'ba','OSCom Admin Login',0),(339963,9444,'nl','OSCom Admin Login',0),(339964,9444,'fi','OSCom Admin Login',0),(339965,9444,'no','OSCom Admin Login',0),(339966,9444,'da','OSCom Admin Login',0),(339967,9444,'ko','OSCom ê´€ë¦¬ìž ë¡œê·¸ì¸',0),(339968,9444,'he','×›× ×™×¡×” ×œ×ž×¢×¨×›×ª × ×™×”×•×œ OSCom',0),(339969,9444,'el','OSCom Admin Login',0),(339970,9444,'zh','è´­ç‰©è½¦ç³»ç»Ÿç®¡ç†å‘˜ç™»é™†',0),(339971,9444,'sv','OSCom Admin Login',0),(339972,9444,'it','OSCom Admin Login',0),(339973,9444,'tl','',0),(339974,9444,'th','OSCom Admin Login',0),(339975,9444,'hi','OSCom à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤²à¥‰à¤—à¤¿à¤¨',0),(339976,9444,'ms','Log masuk pentadbir OSCom',0),(339977,9444,'ar','Ø£ÙˆØ³ÙˆÙ… Ø§Ù„Ø¥Ø¯Ø§Ø±ÙŠØ© Ù„Ù„Ø¯Ø®ÙˆÙ„',0),(339978,9444,'fr','OSCom Admin Login',0),(339979,9444,'jp','OSCom ç®¡ç†è€…ãƒ­ã‚°ã‚¤ãƒ³',0),(339980,9444,'pt','OSCom Admin Login',0),(339981,9444,'ru','OSCom ÐÐ´Ð¼Ð¸Ð½ Ð›Ð¾Ð³Ð¸Ð½',0),(339982,9444,'es','Admin de OSCom Login',0),(339983,9444,'de','OSCom Admin Login',0),(339984,9444,'en','OSCom Admin Login',0),(339985,9445,'is','',0),(339986,9445,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù…Ø¯ÙŠØ±ÙŠØª Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(339987,9445,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù…Ø¯ÙŠØ±ÙŠØª Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(339988,9445,'tr','OSCom Admin parola',0),(339989,9445,'pl','OSCom hasÅ‚o administratora',0),(339990,9445,'bg','OSCom Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(339991,9445,'ur','Ø¹Ø«Ú©Ø§ÙˆÙ… Ù…Ù†ØªØ¸Ù… Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(339992,9445,'sr','ÐžÐ¡Ð¦Ð¾Ð¼ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ÑÐºÐµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ',0),(339993,9445,'vi','OSCom Máº­t MÃ£ Quáº£n Trá»‹ ',0),(339994,9445,'af','\"OSCom\" Admin Wagwoord',0),(339995,9445,'ro','Parola de Admin OSCom',0),(339996,9445,'et','OSCom Admin parooli',0),(339997,9445,'si','OSCom Admin geslo',0),(339998,9445,'ba','OSCom Admin Password',0),(339999,9445,'nl','OSCom Admin wachtwoord',0),(340000,9445,'fi','OSCom Admin-salasana',0),(340001,9445,'no','OSCom Admin passord',0),(340002,9445,'da','OSCom Admin Password',0),(340003,9445,'ko','OSCom ê´€ë¦¬ìž ë¹„ë°€ ë²ˆí˜¸',0),(340004,9445,'he','×¡×™×¡×ž×ª ×”×ž× ×”×œ OSCom',0),(340005,9445,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Admin OSCom',0),(340006,9445,'zh','è´­ç‰©è½¦ç³»ç»Ÿç®¡ç†å‘˜å¯†ç \r\n',0),(340007,9445,'sv','OSCom Admin lÃ¶senord',0),(340008,9445,'it','OSCom Admin Password',0),(340009,9445,'tl','',0),(340010,9445,'th','OSCom Admin Password',0),(340011,9445,'hi','OSCom à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡',0),(340012,9445,'ms','Kata laluan pentadbiran OSCom',0),(340013,9445,'ar','ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ø§Ù„Ù…Ø´Ø±Ù Ø£ÙˆØ³ÙƒÙˆÙ…',0),(340014,9445,'fr','OSCom Admin mot de passe',0),(340015,9445,'jp','OSCom ç®¡ç†è€…ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰',0),(340016,9445,'pt','OSCom Admin senha',0),(340017,9445,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð° OSCom',0),(340018,9445,'es','Admin de OSCom ContraseÃ±a',0),(340019,9445,'de','OSCom-Admin-Passwort',0),(340020,9445,'en','OSCom Admin Password',0),(340021,9446,'is','',0),(340022,9446,'dr','ÙˆØ¨ Ø³Ø§ÙŠØª Ø§Ø¬Ø±Ø§ÙŠÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ ',0),(340023,9446,'pr','ÙˆØ¨ Ø³Ø§ÙŠØª Ø§Ø¬Ø±Ø§ÙŠÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ ',0),(340024,9446,'tr','OSCom Admin URL',0),(340025,9446,'pl','OSCom Admin URL',0),(340026,9446,'bg','OSCom Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ URL',0),(340027,9446,'ur','Ø¹Ø«Ú©Ø§ÙˆÙ… Ø§ÛŒÚˆÙ…Ù† URL',0),(340028,9446,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° ÐžÐ¡Ð¦Ð¾Ð¼ ÐÐ´Ð¼Ð¸Ð½',0),(340029,9446,'vi','OSCom URL Quáº£n Trá»‹',0),(340030,9446,'af','OSHandel Admin BA (\"URL\")',0),(340031,9446,'ro','URL-ul OSCom Admin',0),(340032,9446,'et','OSCom Admin URL',0),(340033,9446,'si','OSCom Admin URL',0),(340034,9446,'ba','URL OSCom Admin',0),(340035,9446,'nl','OSCom Admin URL',0),(340036,9446,'fi','OSCom Admin URL',0),(340037,9446,'no','OSCom Admin URL',0),(340038,9446,'da','OSCom Admin URL',0),(340039,9446,'ko','OSCom ê´€ë¦¬ URL',0),(340040,9446,'he','×›×ª×•×‘×ª URL OSCom Admin',0),(340041,9446,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· URL Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚ OSCom',0),(340042,9446,'zh','è´­ç‰©è½¦ç³»ç»Ÿç®¡ç†ç½‘å€\r\n\r\n',0),(340043,9446,'sv','URL: OSCom Admin',0),(340044,9446,'it','OSCom Admin URL',0),(340045,9446,'tl','',0),(340046,9446,'th','OSCom Admin URL',0),(340047,9446,'hi','OSCom à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• URL',0),(340048,9446,'ms','URL OSCom Admin',0),(340049,9446,'ar','Ø±Ø§Ø¨Ø· Ø§Ù„Ù…Ø´Ø±Ù Ø£ÙˆØ³ÙˆÙ…',0),(340050,9446,'fr','OSCom Admin URL',0),(340051,9446,'jp','OSCom ç®¡ç† URL',0),(340052,9446,'pt','OSCom Admin URL',0),(340053,9446,'ru','OSCom Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð° URL',0),(340054,9446,'es','Admin de OSCom URL',0),(340055,9446,'de','OSCom Admin URL',0),(340056,9446,'en','OSCom Admin URL',0),(340057,9447,'is','',0),(340058,9447,'dr','Ù†Ø§Ù… Ù…ÙŠØ²Ø¨Ø§Ù† Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(340059,9447,'pr','Ù†Ø§Ù… Ù…ÙŠØ²Ø¨Ø§Ù† Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(340060,9447,'tr','OSCom veritabanÄ± ana bilgisayar adÄ±',0),(340061,9447,'pl','Nazwa hosta bazy danych OSCom',0),(340062,9447,'bg','OSCom Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ñ…Ð¾ÑÑ‚',0),(340063,9447,'ur','Ø§ÙˆØ³Ú©Ø§ÙˆÙ… ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©Û’ Ù…ÛŒØ²Ø¨Ø§Ù† Ú©Û’ Ù†Ø§Ù…',0),(340064,9447,'sr','Ð˜Ð¼Ðµ Ð´Ð¾Ð¼Ð°Ñ›Ð¸Ð½Ð° ÐžÐ¡Ð¦Ð¾Ð¼ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(340065,9447,'vi','TÃªn Host cá»§a dá»¯ liá»‡u OSCcom',0),(340066,9447,'af','OSCom Databasis Gasheernaam',0),(340067,9447,'ro','Numele de gazdÄƒ baza de date OSCom',0),(340068,9447,'et','OSCom andmebaasi serveri nimi',0),(340069,9447,'si','OSCom zbirke ime gostitelja',0),(340070,9447,'ba','OSCom Database nama Host',0),(340071,9447,'nl','OSCom Database hostnaam',0),(340072,9447,'fi','OSCom tietokannan palvelimen nimi',0),(340073,9447,'no','OSCom Database vertsnavn',0),(340074,9447,'da','OSCom Database vÃ¦rtsnavnet',0),(340075,9447,'ko','OSCom ë°ì´í„°ë² ì´ìŠ¤ í˜¸ìŠ¤íŠ¸ ì´ë¦„',0),(340076,9447,'he','×©× ×ž×—×©×‘ ×ž××¨×— ×©×œ ×ž×¡×“ × ×ª×•× ×™× OSCom',0),(340077,9447,'el','OSCom Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ ÏŒÎ½Î¿Î¼Î± Ï„Î¿Ï… ÎºÎµÎ½Ï„ÏÎ¹ÎºÎ¿Ï Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„Î®',0),(340078,9447,'zh','è´­ç‰©è½¦ç³»ç»Ÿæ•°æ®åº“ä¸»æœºå\r\n',0),(340079,9447,'sv','OSCom databas vÃ¤rdnamn',0),(340080,9447,'it','Nome Host OSCom Database',0),(340081,9447,'tl','',0),(340082,9447,'th','OSCom Database Host Name',0),(340083,9447,'hi','OSCom à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¹à¥‹à¤¸à¥à¤Ÿ à¤¨à¤¾à¤®',0),(340084,9447,'ms','Nama hos pangkalan data OSCom',0),(340085,9447,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø¶ÙŠÙ Ø£ÙˆØ³ÙˆÙ… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(340086,9447,'fr','Nom dâ€™hÃ´te OSCom Database',0),(340087,9447,'jp','OSCom ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã®ãƒ›ã‚¹ãƒˆå',0),(340088,9447,'pt','Nome de Host do banco de dados OSCom',0),(340089,9447,'ru','Ð˜Ð¼Ñ Ñ…Ð¾ÑÑ‚Ð° Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… OSCom',0),(340090,9447,'es','Nombre de Host de Base de Datos de OSCom',0),(340091,9447,'de','OSCom Datenbank-Host-Name',0),(340092,9447,'en','OSCom Database Host Name',0),(340093,9448,'is','',0),(340094,9448,'dr','Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(340095,9448,'pr','Ù†Ø§Ù… Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(340096,9448,'tr','OSCom veritabanÄ± adÄ±',0),(340097,9448,'pl','Nazwa bazy danych OSCom',0),(340098,9448,'bg','OSCom Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¸Ð¼Ðµ',0),(340099,9448,'ur','Ø¹Ø«Ú©Ø§ÙˆÙ… Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù†Ø§Ù…',0),(340100,9448,'sr','Ð˜Ð¼Ðµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÐžÐ¡Ð¦Ð¾Ð¼',0),(340101,9448,'vi','TÃªn dá»¯ liá»‡u OSCom',0),(340102,9448,'af','OSCom Databasis Naam',0),(340103,9448,'ro','Numele bazei de date OSCom',0),(340104,9448,'et','OSCom andmebaasi nimi',0),(340105,9448,'si','Ime zbirke podatkov OSCom',0),(340106,9448,'ba','Nama OSCom Database',0),(340107,9448,'nl','OSCom Database naam',0),(340108,9448,'fi','OSCom tietokannan nimi',0),(340109,9448,'no','OSCom navn',0),(340110,9448,'da','OSCom Database navn',0),(340111,9448,'ko','OSCom ë°ì´í„°ë² ì´ìŠ¤ ì´ë¦„',0),(340112,9448,'he','×©× ×ž×¡×“ ×”× ×ª×•× ×™× ×©×œ OSCom',0),(340113,9448,'el','ÎŒÎ½Î¿Î¼Î± Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ OSCom',0),(340114,9448,'zh','è´­ç‰©è½¦ç³»ç»Ÿæ•°æ®åº“åç§°\r\n',0),(340115,9448,'sv','OSCom databas namn',0),(340116,9448,'it','Nome del Database OSCom',0),(340117,9448,'tl','',0),(340118,9448,'th','OSCom Database Name',0),(340119,9448,'hi','OSCom à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¤¾ à¤¨à¤¾à¤®',0),(340120,9448,'ms','Nama pangkalan data OSCom',0),(340121,9448,'ar','Ø§Ø³Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø£ÙˆØ³ÙˆÙ…',0),(340122,9448,'fr','OSCom Database Name',0),(340123,9448,'jp','OSCom ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹å',0),(340124,9448,'pt','Nome do banco de dados OSCom',0),(340125,9448,'ru','Ð˜Ð¼Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… OSCom',0),(340126,9448,'es','Nombre Base de Datos de OSCom',0),(340127,9448,'de','OSCom Datenbankname',0),(340128,9448,'en','OSCom Database Name',0),(340129,9449,'is','',0),(340130,9449,'dr','OSComØ±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ØªÛŒ',0),(340131,9449,'pr','OSComØ±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(340132,9449,'tr','OSCom ÅŸifresi',0),(340133,9449,'pl','HasÅ‚o bazy danych OSCom',0),(340134,9449,'bg','OSCom Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(340135,9449,'ur','Ø§ÙˆØ³Ú©Ø§ÙˆÙ… Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(340136,9449,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐµ Ð·Ð° Ð±Ð°Ð·Ñƒ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÐžÐ¡Ð¦Ð¾Ð¼',0),(340137,9449,'vi','Máº­t mÃ£ dá»¯ liá»‡u OSCom',0),(340138,9449,'af','\"OSCom\" Databasis Wagwoord',0),(340139,9449,'ro','Parola bazei de date OSCom',0),(340140,9449,'et','OSCom andmebaasi parool',0),(340141,9449,'si','Gesla zbirke podatkov OSCom',0),(340142,9449,'ba','Password OSCom Database',0),(340143,9449,'nl','OSCom Database wachtwoord',0),(340144,9449,'fi','OSCom tietokannan salasana',0),(340145,9449,'no','OSCom passord',0),(340146,9449,'da','OSCom Database adgangskode',0),(340147,9449,'ko','OSCom ë°ì´í„°ë² ì´ìŠ¤ ì•”í˜¸',0),(340148,9449,'he','×¡×™×¡×ž×ª ×ž×¡×“ × ×ª×•× ×™× OSCom',0),(340149,9449,'el','ÎšÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ OSCom',0),(340150,9449,'zh','è´­ç‰©è½¦ç³»ç»Ÿæ•°æ®åº“å¯†ç \r\n',0),(340151,9449,'sv','OSCom databas lÃ¶senord',0),(340152,9449,'it','OSCom Database Password',0),(340153,9449,'tl','',0),(340154,9449,'th','OSCom Database Password',0),(340155,9449,'hi','OSCom à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡',0),(340156,9449,'ms','Pangkalan data OSCom kata laluan',0),(340157,9449,'ar','ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø£ÙˆØ³ÙˆÙ…',0),(340158,9449,'fr','OSCom Database Password',0),(340159,9449,'jp','OSCom ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰',0),(340160,9449,'pt','Senha de banco de dados OSCom',0),(340161,9449,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… OSCom',0),(340162,9449,'es','ContraseÃ±a de Base de Datos de OSCom',0),(340163,9449,'de','OSCom Datenbank-Kennwort',0),(340164,9449,'en','OSCom Database Password',0),(340165,9450,'is','',0),(340166,9450,'dr','Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(340167,9450,'pr','Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø³ÙŠØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÙŠ',0),(340168,9450,'tr','OSCom veritabanÄ± kullanÄ±cÄ± adÄ±',0),(340169,9450,'pl','Nazwa uÅ¼ytkownika bazy danych OSCom',0),(340170,9450,'bg','OSCom Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ',0),(340171,9450,'ur','Ø¹Ø«Ú©Ø§ÙˆÙ… ÚˆÛŒÙ¹Ø§Ø¨ÛŒØ³ Ú©Ø§ ØµØ§Ø±Ù Ù†Ø§Ù…',0),(340172,9450,'sr','ÐžÐ¡Ð¦Ð¾Ð¼ Ð±Ð°Ð·Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ',0),(340173,9450,'vi','TÃªn ngÆ°á»i sá»­ dá»¥ng dá»¯ liá»‡u OSCom',0),(340174,9450,'af','OSHandel Databasis Gebruikernaam',0),(340175,9450,'ro','Numele de utilizator bazei de date OSCom',0),(340176,9450,'et','OSCom andmebaasi kasutaja nimi',0),(340177,9450,'si','UporabniÅ¡ko ime zbirke podatkov OSCom',0),(340178,9450,'ba','Nama pengguna OSCom Database',0),(340179,9450,'nl','De naam van de gebruiker van de OSCom Database',0),(340180,9450,'fi','OSCom tietokannan kÃ¤yttÃ¤jÃ¤tunnus',0),(340181,9450,'no','OSCom Database brukernavn',0),(340182,9450,'da','OSCom Database Brugernavn',0),(340183,9450,'ko','OSCom ë°ì´í„°ë² ì´ìŠ¤ ì‚¬ìš©ìž ì´ë¦„',0),(340184,9450,'he','×©× ×ž×©×ª×ž×© ×ž×¡×“ ×”× ×ª×•× ×™× OSCom',0),(340185,9450,'el','ÎŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ OSCom',0),(340186,9450,'zh','è´­ç‰©è½¦ç³»ç»Ÿæ•°æ®åº“ç”¨æˆ·å\r\n',0),(340187,9450,'sv','OSCom databas anvÃ¤ndarnamn',0),(340188,9450,'it','Nome utente del Database OSCom',0),(340189,9450,'tl','',0),(340190,9450,'th','OSCom Database User Name',0),(340191,9450,'hi','OSCom à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤®',0),(340192,9450,'ms','Nama pengguna pangkalan data OSCom',0),(340193,9450,'ar','Ø§Ø³Ù… Ù…Ø³ØªØ®Ø¯Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø£ÙˆØ³ÙˆÙ…',0),(340194,9450,'fr','Nom dâ€™utilisateur de base de donnÃ©es OSCom',0),(340195,9450,'jp','OSCom ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ ãƒ¦ãƒ¼ã‚¶ãƒ¼å',0),(340196,9450,'pt','Nome de usuÃ¡rio de banco de dados OSCom',0),(340197,9450,'ru','Ð˜Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… OSCom',0),(340198,9450,'es','Nombre del usuario de Base de Datos de OSCom',0),(340199,9450,'de','OSCom Datenbankbenutzername',0),(340200,9450,'en','OSCom Database User Name',0),(340201,9451,'is','',0),(340202,9451,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø§Ø±Ø² ',0),(340203,9451,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø§Ø±Ø² ',0),(340204,9451,'tr','VarsayÄ±lan para birimi',0),(340205,9451,'pl','Waluta domyÅ›lna',0),(340206,9451,'bg','Ð’Ð°Ð»ÑƒÑ‚Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(340207,9451,'ur','Ø·Û’ Ø´Ø¯Û Ú©Ø±Ù†Ø³ÛŒ',0),(340208,9451,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(340209,9451,'vi','Tiá»n tá»‡ Máº·c Ä‘á»‹nh',0),(340210,9451,'af','Verstekte Geldeenheid',0),(340211,9451,'ro','Valutar implicit',0),(340212,9451,'et','Vaikimisi valuua',0),(340213,9451,'si','Privzeto valuto',0),(340214,9451,'ba','Default mata uang',0),(340215,9451,'nl','Standaardvaluta',0),(340216,9451,'fi','Oletusvaluutta',0),(340217,9451,'no','Standardvalutaen',0),(340218,9451,'da','Standardvaluta',0),(340219,9451,'ko','ê¸°ë³¸ í†µí™”',0),(340220,9451,'he','×ž×˜×‘×¢ ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(340221,9451,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(340222,9451,'zh','é»˜è®¤è´§å¸\r\n',0),(340223,9451,'sv','Standardvaluta',0),(340224,9451,'it','Valuta predefinita',0),(340225,9451,'tl','',0),(340226,9451,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;',0),(340227,9451,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¾',0),(340228,9451,'ms','Mata Wang lalai',0),(340229,9451,'ar','Ø§Ù„Ø¹Ù…Ù„Ø© Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠØ©',0),(340230,9451,'fr','Devise par dÃ©faut',0),(340231,9451,'jp','æ—¢å®šã®é€šè²¨',0),(340232,9451,'pt','Moeda padrÃ£o',0),(340233,9451,'ru','Ð’Ð°Ð»ÑŽÑ‚Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(340234,9451,'es','Moneda por OmisiÃ³n',0),(340235,9451,'de','Standard-WÃ¤hrung',0),(340236,9451,'en','Default Currency',0),(340237,9452,'is','',0),(340238,9452,'dr','ØªÙ…Ø§Ù… Ù…Ù‚Ø§Ø¯ÙŠØ± Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø¯Ø± Ø§ÙŠÙ† Ù‚Ø³Ù…Øª Ø¨ÙŠØ§Ù† Ø´Ø¯Ù‡ Ø¯Ø± ',0),(340239,9452,'pr','ØªÙ…Ø§Ù… Ù…Ù‚Ø§Ø¯ÙŠØ± Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø¯Ø± Ø§ÙŠÙ† Ù‚Ø³Ù…Øª Ø¨ÙŠØ§Ù† Ø´Ø¯Ù‡ Ø¯Ø± ',0),(340240,9452,'tr','Ä°fade bu bÃ¶lÃ¼mdeki tÃ¼m aylÄ±k tutarlar',0),(340241,9452,'pl','Wszystkie kwoty miesiÄ™cznych w tej sekcji, wyraÅ¼ona w',0),(340242,9452,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¼ÐµÑÐµÑ‡Ð½Ð¸ ÑÑƒÐ¼Ð¸ Ð² Ñ‚Ð¾Ð·Ð¸ Ñ€Ð°Ð·Ð´ÐµÐ», Ð¸Ð·Ñ€Ð°Ð·ÐµÐ½Ð¾ Ð²',0),(340243,9452,'ur','ØªÙ…Ø§Ù… Ù…Ø§ÛØ§Ù†Û Ù…Ù‚Ø¯Ø§Ø± Ù…ÛŒÚº Ú©Ø§ Ø§Ø¸ÛØ§Ø± Ú©ÛŒØ§ Ø§Ø³ Ø³ÛŒÚ©Ø´Ù† Ù…ÛŒÚº',0),(340244,9452,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¸ Ð¸Ð·Ð½Ð¾ÑÐµ Ñƒ Ð¾Ð²Ð¾Ð¼ Ð¾Ð´ÐµÑ™ÐºÑƒ Ð¸Ð·Ñ€Ð°Ð¶ÐµÐ½Ð° Ñƒ',0),(340245,9452,'vi','Táº¥t Cáº£ Sá»‘ LÆ°á»£ng HÃ ng ThÃ¡ng trong má»¥c nÃ y thá»ƒ hiá»‡n á»Ÿ',0),(340246,9452,'af','Al die maandelikse bedrae wat in hierdie artikel uitgespreek in',0),(340247,9452,'ro','Toate sumele lunare Ã®n aceastÄƒ secÅ£iune exprimate Ã®n',0),(340248,9452,'et','Igakuised summad kÃ¤esolevas paragrahvis vÃ¤ljendatud',0),(340249,9452,'si','Vse meseÄne zneske v tem oddelku, izraÅ¾ena v',0),(340250,9452,'ba','Semua jumlah bulanan dalam bagian ini dinyatakan dalam',0),(340251,9452,'nl','Alle maandelijkse bedragen in deze sectie uitgedrukt in',0),(340252,9452,'fi','Kaikki tÃ¤ssÃ¤ kohdassa ilmaistu mÃ¤Ã¤rÃ¤',0),(340253,9452,'no','Alle mÃ¥nedlige belÃ¸pene i denne delen i',0),(340254,9452,'da','Alle de mÃ¥nedlige belÃ¸b i dette afsnit, udtrykt i',0),(340255,9452,'ko','í‘œí˜„ í•˜ëŠ”ì´ ì„¹ì…˜ì—ì„œ ëª¨ë“  ì›”ë³„ ê¸ˆì•¡',0),(340256,9452,'he','×›×œ ×”×¡×›×•×ž×™× ×”×—×•×“×©×™×™× ×‘×¡×¢×™×£ ×–×” ×‘× ×œ×™×“×™ ×‘×™×˜×•×™',0),(340257,9452,'el','ÎŒÎ»Î± Ï„Î± Î¼Î·Î½Î¹Î±Î¯Î± Ï€Î¿ÏƒÎ¬ ÏƒÎµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÎ½ÏŒÏ„Î·Ï„Î± ÎµÎºÏ†ÏÎ¬Î¶ÎµÏ„Î±Î¹ ÏƒÎµ',0),(340258,9452,'zh','æœ¬èŠ‚ä¸­çš„æ‰€æœ‰æ¯æœˆæ•°é¢è¡¨ç¤ºä¸º\r\n',0),(340259,9452,'sv','Alla mÃ¥natliga belopp i det hÃ¤r avsnittet uttryckt i',0),(340260,9452,'it','Tutti gli importi mensili in questa sezione espressa in',0),(340261,9452,'tl','',0),(340262,9452,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3651;&#3609;&#3626;&#3656;&#3623;&#3609;&#3609;&#3637;&#3657;&#3649;&#3626;&#3604;&#3591;&#3651;&#3609;',0),(340263,9452,'hi','à¤‡à¤¸ à¤…à¤¨à¥à¤­à¤¾à¤— à¤®à¥‡à¤‚ à¤µà¥à¤¯à¤•à¥à¤¤ à¤•à¥€ à¤¸à¤­à¥€ à¤®à¤¾à¤¸à¤¿à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(340264,9452,'ms','Semua amaun bulanan dalam bahagian ini dinyatakan dalam',0),(340265,9452,'ar','Ø¬Ù…ÙŠØ¹ \"Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ø´Ù‡Ø±ÙŠØ©\" ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„ÙØ±Ø¹ Ø§Ù„Ù…Ø¹Ø±Ø¨ Ø¹Ù†Ù‡Ø§ ÙÙŠ',0),(340266,9452,'fr','Tous les montants mensuels dans cette section exprimÃ©e en',0),(340267,9452,'jp','è¡¨ã•ã‚Œã‚‹ã“ã®ã‚»ã‚¯ã‚·ãƒ§ãƒ³ã®ã™ã¹ã¦ã®æ¯Žæœˆã®é‡‘é¡',0),(340268,9452,'pt','Todos os montantes mensais nesta seÃ§Ã£o, expressado em',0),(340269,9452,'ru','Ð’ÑÐµ ÐµÐ¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ñ‹Ðµ ÑÑƒÐ¼Ð¼Ñ‹ Ð² ÑÑ‚Ð¾Ð¼ Ñ€Ð°Ð·Ð´ÐµÐ»Ðµ, Ð²',0),(340270,9452,'es','Todos los Montos Mensuales en esta secciÃ³n se expresan en',0),(340271,9452,'de','Die monatlichen BetrÃ¤ge in diesem Abschnitt, ausgedrÃ¼ckt in',0),(340272,9452,'en','All the Monthly Amounts in this section expressed in',0),(340273,9453,'is','',0),(340274,9453,'dr','Ø¯Ø±Ø¢Ù…Ø¯ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(340275,9453,'pr','Ø¯Ø±Ø¢Ù…Ø¯ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(340276,9453,'tr','Komisyon geliri',0),(340277,9453,'pl','Prowizyjnych',0),(340278,9453,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð´Ð¾Ñ…Ð¾Ð´',0),(340279,9453,'ur','Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ø¢Ù…Ø¯Ù†ÛŒ',0),(340280,9453,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(340281,9453,'vi','Thu nháº­p Hoa há»“ng ',0),(340282,9453,'af','Kommissie Inkomste',0),(340283,9453,'ro','Comisia venituri',0),(340284,9453,'et','Teenustasu tulu',0),(340285,9453,'si','Komisija dohodka',0),(340286,9453,'ba','Pendapatan komisi',0),(340287,9453,'nl','Provisie-inkomsten',0),(340288,9453,'fi','Palkkiotuotot',0),(340289,9453,'no','Kommisjonen inntekter',0),(340290,9453,'da','Kommissionen indkomst',0),(340291,9453,'ko','ìˆ˜ìˆ˜ë£Œ ìˆ˜ìž…',0),(340292,9453,'he','×”× ×¦×™×‘×•×ª ×”×›× ×¡×”',0),(340293,9453,'el','ÎˆÏƒÎ¿Î´Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÎ¹ÏŽÎ½',0),(340294,9453,'zh','ä½£é‡‘æ”¶å…¥\r\n',0),(340295,9453,'sv','ProvisionsintÃ¤kterna',0),(340296,9453,'it','Commissioni attive',0),(340297,9453,'tl','',0),(340298,9453,'th','&#3619;&#3634;&#3618;&#3652;&#3604;&#3657;&#3588;&#3656;&#3634;&#3588;&#3629;&#3617;&#3617;&#3636;&#3594;&#3594;&#3633;&#3656;&#3609;',0),(340299,9453,'hi','à¤•à¤®à¥€à¤¶à¤¨ à¤†à¤¯',0),(340300,9453,'ms','Pendapatan komisen',0),(340301,9453,'ar','Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø§Ù„Ø¹Ù…ÙˆÙ„Ø§Øª',0),(340302,9453,'fr','Revenu de commissions',0),(340303,9453,'jp','æ‰‹æ•°æ–™åŽå…¥',0),(340304,9453,'pt','ComissÃ£o de renda',0),(340305,9453,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¾Ð½Ð½Ñ‹Ðµ Ð´Ð¾Ñ…Ð¾Ð´Ñ‹',0),(340306,9453,'es','Ingresos por Comisiones',0),(340307,9453,'de','ProvisionsertrÃ¤ge',0),(340308,9453,'en','Commission Income',0),(340309,9454,'is','',0),(340310,9454,'dr','(Ø§Ø¹ØªØ¨Ø§Ø±) Ø­Ø³Ø§Ø¨â€ŒÙ‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(340311,9454,'pr','Ø§Ù…Ø§Ù†Øª(Ø§Ø¹ØªØ¨Ø§Ø±) Ø­Ø³Ø§Ø¨â€ŒÙ‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(340312,9454,'tr','BorÃ§lar gÃ¼ven',0),(340313,9454,'pl','Zaufaj zobowiÄ…zania',0),(340314,9454,'bg','Ð”Ð¾Ð²ÐµÑ€Ð¸Ðµ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(340315,9454,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ù¹Ø±Ø³Ù¹',0),(340316,9454,'sr','Ð’ÐµÑ€ÑƒÑ˜ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(340317,9454,'vi','Tráº£ á»¦y ThÃ¡c',0),(340318,9454,'af','Trust Betaalbares (RO)',0),(340319,9454,'ro','ÃŽncredere Ã®n datorii',0),(340320,9454,'et','Usalda vÃµlad',0),(340321,9454,'si','Zaupanje obveznosti',0),(340322,9454,'ba','Mempercayai hutang',0),(340323,9454,'nl','Vertrouwen van schulden',0),(340324,9454,'fi','Luota Ostovelat',0),(340325,9454,'no','Stol leverandÃ¸rgjeld',0),(340326,9454,'da','Trust kreditorstyring',0),(340327,9454,'ko','ë¯¸ì§€ê¸‰ê¸ˆì„ ì‹ ë¢°',0),(340328,9454,'he','×œ×‘×˜×•×— ×–×›××™×',0),(340329,9454,'el','Î•Î¼Ï€Î¹ÏƒÏ„ÎµÏÎµÏƒÏ„Îµ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(340330,9454,'zh','ä¿¡æ‰˜åº”ä»˜æ¬¾é¡¹\r\n',0),(340331,9454,'sv','Lita pÃ¥ LeverantÃ¶rsskulder',0),(340332,9454,'it','Debiti di fiducia',0),(340333,9454,'tl','',0),(340334,9454,'th','&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3652;&#3623;&#3657;&#3623;&#3634;&#3591;&#3651;&#3592;&#3652;&#3604;&#3657;',0),(340335,9454,'hi','Payables à¤ªà¤° à¤­à¤°à¥‹à¤¸à¤¾',0),(340336,9454,'ms','Mempercayai pemiutang',0),(340337,9454,'ar','Ø§Ù„Ø«Ù‚Ø© Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(340338,9454,'fr','Confiance des comptes fournisseurs',0),(340339,9454,'jp','å‚µå‹™ã‚’ä¿¡é ¼ã—ã¾ã™ã€‚',0),(340340,9454,'pt','Confiar em contas a pagar',0),(340341,9454,'ru','Ð”Ð¾Ð²ÐµÑ€Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ',0),(340342,9454,'es','Cuentas por Pagar del Trust',0),(340343,9454,'de','Vertrauen Sie Verbindlichkeiten',0),(340344,9454,'en','Trust Payables',0),(340345,9455,'is','',0),(340346,9455,'dr','(Ø§Ù…Ø§Ø¯Ù‡ Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(340347,9455,'pr','Ø­ÙˆØ§Ù„Ù‡ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†ÙƒÙŠ Ø¨Ø§ Ø§ÙŠÙ† Ø§Ø±Ø² Ø¨Ù‡ ÙŠÙƒ Ø­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªÙ†Ø¸ÙŠÙ…(Ø§Ù…Ø§Ø¯Ù‡ Ø³Ø§Ø²ÙŠ) Ø­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(340348,9455,'tr','Bu para birimi cinsinden bir banka hesabÄ± CC hesap Kurulum alanÄ±nda (fatura) kredi kartÄ± seÃ§enekleri-> kurulum-> CC hesabÄ±na atayÄ±n.',0),(340349,9455,'pl','Konto bankowe w tej walucie naleÅ¼y przypisaÄ‡ konto CC w obszarze Ustawienia konta CC (Billing-> Instalator-> opcje karty kredytowej).',0),(340350,9455,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð² Ñ‚Ð°Ð·Ð¸ Ð²Ð°Ð»ÑƒÑ‚Ð° Ð½Ð° ÑÐº ÑÐ¼ÐµÑ‚ÐºÐ° Ð² ÑÐº Ð¿Ñ€Ð¾Ñ„Ð¸Ð» Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¾Ð±Ð»Ð°ÑÑ‚ (Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-> Ð¾Ð¿Ñ†Ð¸Ð¸ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°).',0),(340351,9455,'ur','Ù†Ù‚Ù„ Ø¨Ø±Ø§Û“ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…ÛŒÚº Ù†Ù‚Ù„ Ø¨Ø±Ø§Û“ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ Ø§Ù¾ Ø§ÛŒØ±ÛŒØ§ (Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª-> Ø³ÛŒÙ¹ Ø§Ù¾->) Ù…ÛŒÚº Ø§ÛŒÚ© Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø³ Ú©Ø±Ù†Ø³ÛŒ Ù…ÛŒÚº ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº Û”',0),(340352,9455,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ñ€Ð°Ñ‡ÑƒÐ½ Ñƒ Ð±Ð°Ð½Ñ†Ð¸ Ñƒ Ð¾Ð²Ð¾Ñ˜ Ð²Ð°Ð»ÑƒÑ‚Ð¸ Ð½Ð° ÐºÐ¾Ð½Ñ‚Ð¾ \"Ð¦Ð¦\" Ñƒ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ Ð¦Ð¦ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° (Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ).',0),(340353,9455,'vi','Chá»‰ Äá»‹nh má»™t TK ngoáº¡i tá»‡ ngÃ¢n hÃ ng nÃ y cho má»™t tÃ i khoáº£n tháº» tÃ­n dá»¥ng trong khu vá»±c setup TK tháº» tÃ­n dá»¥ng (Xuáº¥t HÃ³a ÄÆ¡n -> Setup -> CÃ¡c Lá»±a Chá»n Tháº» TÃ­n Dá»¥ng).',0),(340354,9455,'af','Skryf \'n bankrekening toe in hierdie geldeenheid tot \'n BK Rekening in die BK rekening opstellingsarea (Fakturering -> Opstelling -> Kredietkaartopsies).',0),(340355,9455,'ro','AtribuiÅ£i un cont bancar Ã®n aceastÄƒ valutÄƒ la un cont de CC Ã®n zona de configurare al contului CC (facturare-> Setup-> opÅ£iuni de Card de Credit).',0),(340356,9455,'et','Omistada CC kontole CC konto seadistamine piirkonnas (arved-> krediitkaardi valikute seadistamine->) pangakonto selles valuutas.',0),(340357,9455,'si','BanÄnega raÄuna v tej valuti dodeliti CC raÄun podroÄju CC raÄun setup (zaraÄunavanje-> Setup-> kreditno kartico moÅ¾nosti).',0),(340358,9455,'ba','Menetapkan rekening bank dalam mata uang ini ke rekening CC di daerah setup account CC (penagihan-> Setup-> pilihan kartu kredit).',0),(340359,9455,'nl','Een bankrekening in deze valuta toewijzen aan een CC-account in de CC account setup gebied (facturering-> Setup-> Credit Card opties).',0),(340360,9455,'fi','MÃ¤Ã¤rittÃ¤Ã¤ pankkitilin tÃ¤ssÃ¤ valuutassa CC tilille CC tilin asetukset-alueen (laskutus-> asetukset-> luottokortin asetukset).',0),(340361,9455,'no','Tilordne en bankkonto i denne valutaen til CC konto i CC konto Oppsett-omrÃ¥det (Billing-> Setup-> kredittkort alternativer).',0),(340362,9455,'da','Tildele en bankkonto i denne valuta til en CC konto i omrÃ¥det OpsÃ¦tning for CC-konto (fakturering-> Setup-> Credit Card indstillinger).',0),(340363,9455,'ko','ì°¸ì¡° ê³„ì • ì„¤ì¹˜ ì§€ì—­ (ê²°ì œ ì‹ ìš© ì¹´ë“œ ì˜µì…˜-> ì„¤ì¹˜->)ì—ì„œ CC ê³„ì •ì—ì´ í†µí™”ì—ì„œ ì€í–‰ ê³„ì¢Œë¥¼ í• ë‹¹ í•©ë‹ˆë‹¤.',0),(340364,9455,'he','×œ×”×§×¦×•×ª ×—×©×‘×•×Ÿ ×‘× ×§ ×‘×ž×˜×‘×¢ ×–×” ×—×©×‘×•×Ÿ CC ×‘××–×•×¨ ×”×’×“×¨×ª ×—×©×‘×•×Ÿ CC (×”×—×™×•×‘-> ×ª×•×›× ×™×ª ×”×”×ª×§× ×”-> ××¤×©×¨×•×™×•×ª ×›×¨×˜×™×¡ ××©×¨××™).',0),(340365,9455,'el','Î“Î¹Î± Î½Î± Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ Î­Î½Î±Î½ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î± ÏƒÎµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ CC ÏƒÏ„Î·Î½ Ï€ÎµÏÎ¹Î¿Ï‡Î® ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï CC (Ï‡ÏÎ­Ï‰ÏƒÎ·-> Setup-> ÎµÏ',0),(340366,9455,'zh','å°†æ­¤è´§å¸çš„é“¶è¡Œå¸æˆ·æŒ‡å®šåˆ°å¤å†™å‰¯æœ¬å¸æˆ·ä¸­çš„è®¾ç½®åŒºåŸŸï¼ˆç»“ç®— ->â€œè®¾ç½®â€œ - >ä¿¡ç”¨å¡é€‰é¡¹ï¼‰\r\n',0),(340367,9455,'sv','Tilldela ett bankkonto i denna valuta till ett CC-konto i omrÃ¥det CC konto instÃ¤llningar (fakturering-> Setup-> kreditkort alternativ).',0),(340368,9455,'it','Assegnare un conto in banca in questa valuta a un account CC nell\'area di installazione conto CC (fatturazione-> installazione-> opzioni di carta di credito).',0),(340369,9455,'tl','',0),(340370,9455,'th','Assign a bank account in this currency to a CC account in the CC account setup area (Billing -> Setup -> Credit Card Options).',0),(340371,9455,'hi','à¤‡à¤¸ à¤®à¥à¤¦à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤à¤• à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ CC à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¥à¤·à¥‡à¤¤à¥à¤° (à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤µà¤¿à¤•à¤²à¥à¤ª-> à¤¸à¥‡à¤Ÿà¤…à¤ª->) à¤®à¥‡à¤‚ à¤à¤• à¤¸à¥€à¤¸à¥€ à¤–à',0),(340372,9455,'ms','Peruntukan akaun bank dalam mata wang ini ke akaun CC di Daerah persediaan akaun CC (bil-> persediaan-> pilihan kad kredit).',0),(340373,9455,'ar','ØªØ¹ÙŠÙŠÙ† Ø­Ø³Ø§Ø¨ Ù…ØµØ±ÙÙŠ Ø¨Ù‡Ø°Ù‡ Ø§Ù„Ø¹Ù…Ù„Ø© Ù„Ø­Ø³Ø§Ø¨ CC ÙÙŠ Ù…Ø¬Ø§Ù„ Ø¥Ø¹Ø¯Ø§Ø¯ Ø­Ø³Ø§Ø¨ CC (Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-> Ø®ÙŠØ§Ø±Ø§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†).',0),(340374,9455,'fr','Attribuer un compte bancaire en cette devise Ã  un compte CC dans la zone de configuration de compte CC (facturation-> Setup-> Options de carte de crÃ©dit).',0),(340375,9455,'jp','CC ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ã‚¨ãƒªã‚¢ (ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ã‚ªãƒ—ã‚·ãƒ§ãƒ³-> ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—-> è«‹æ±‚) ã« CC ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã«ã“ã®é€šè²¨ã®éŠ€è¡Œå£åº§ã‚’å‰²ã‚Šå½“ã¦ã¾ã™ã€‚',0),(340376,9455,'pt','Atribua uma conta bancÃ¡ria nesta moeda para uma conta CC na Ã¡rea \' configuraÃ§Ã£o \' conta CC (faturamento-> Setup-> opÃ§Ãµes de cartÃ£o de crÃ©dito).',0),(340377,9455,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÑŒÑ‚Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð² ÑÑ‚Ð¾Ð¹ Ð²Ð°Ð»ÑŽÑ‚Ðµ Ð½Ð° ÑÑ‡ÐµÑ‚ Ð“Ðš Ð² Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ ÑÑ‡ÐµÑ‚Ð° Ð“Ðš (Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸-> Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚Ñ‹ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹).',0),(340378,9455,'es','Asigna una cuenta bancaria en este moneda a una cuenta TC en la Ã¡rea de configuraciÃ³n de cuentas TC (FacturaciÃ³n -> ConfiguraciÃ³n -> Opciones de Tarjetas de CrÃ©dito).',0),(340379,9455,'de','Ein CC-Konto im Bereich CC mein Konto einrichten (Abrechnung-> Setup-> Kreditkartenoptionen) ein Konto in dieser WÃ¤hrung zuweisen.',0),(340380,9455,'en','Assign a bank account in this currency to a CC account in the CC account setup area (Billing -> Setup -> Credit Card Options).',0),(340381,9456,'is','',0),(340382,9456,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù†ÙŠØ³Øª',0),(340383,9456,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù†ÙŠØ³Øª',0),(340384,9456,'tr','Kredi kartÄ± iÅŸlemi iÅŸleyemiyor',0),(340385,9456,'pl','Nie moÅ¼na przetworzyÄ‡ transakcji karty kredytowej',0),(340386,9456,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° ÑÐ´ÐµÐ»ÐºÐ°',0),(340387,9456,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ù¾Ø± Ø¹Ù…Ù„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(340388,9456,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¾Ð±Ñ€Ð°Ð´Ð¸Ñ‚Ð¸ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ñƒ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(340389,9456,'vi','KhÃ´ng thá»ƒ xá»­ lÃ½ giao dá»‹ch báº±ng tháº» tÃ­n dá»¥ng',0),(340390,9456,'af','Kan Nie Kredietkaarttransaksie Prosesseer Nie',0),(340391,9456,'ro','Nu poate procesa tranzacÅ£ii de Card de Credit',0),(340392,9456,'et','Krediitkaardi makset ei saa teostada',0),(340393,9456,'si','Ne more obdelati transakcijo s kreditno kartico',0),(340394,9456,'ba','Tidak dapat memproses transaksi kartu kredit',0),(340395,9456,'nl','Creditcardtransactie verwerken niet',0),(340396,9456,'fi','Ei voi kÃ¤sitellÃ¤ luottokorttitapahtuman',0),(340397,9456,'no','Kan ikke behandle kredittkorttransaksjon',0),(340398,9456,'da','Kan ikke behandle kreditkorttransaktion',0),(340399,9456,'ko','ì‹ ìš© ì¹´ë“œ ê±°ëž˜ë¥¼ ì²˜ë¦¬í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(340400,9456,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×¢×‘×“ ××ª ×¢×¡×§×ª ×”××©×¨××™',0),(340401,9456,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(340402,9456,'zh','æ— æ³•å¤„ç†ä¿¡ç”¨å¡äº¤æ˜“\r\n',0),(340403,9456,'sv','Kan inte behandla kreditkortstransaktion',0),(340404,9456,'it','Impossibile elaborare la transazione con carta di credito',0),(340405,9456,'tl','',0),(340406,9456,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3607;&#3635;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3588;&#3619;&#3648;&#3588;&#3619;&#3604;&#3636;&#3605;',0),(340407,9456,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(340408,9456,'ms','Tidak dapat memproses transaksi kad kredit',0),(340409,9456,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ù…Ø¹Ø§Ù„Ø¬Ø© Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(340410,9456,'fr','Ne peut pas traiter la Transaction par carte de crÃ©dit',0),(340411,9456,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã‚’å‡¦ç†ã§ãã¾ã›ã‚“ã€‚',0),(340412,9456,'pt','NÃ£o Ã© possÃ­vel processar a transaÃ§Ã£o de cartÃ£o de crÃ©dito',0),(340413,9456,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚ÑŒ ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸ÑŽ Ð¡ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ð¾Ð¹',0),(340414,9456,'es','No se Puede Procesar la TransacciÃ³n de la Tarjeta de CrÃ©dito',0),(340415,9456,'de','Kreditkarten-Transaktion kann nicht verarbeitet werden.',0),(340416,9456,'en','Cannot Process Credit Card Transaction',0),(340417,9457,'is','',0),(340418,9457,'dr','(Ù…Ø¹Ø§Ø´) Ù†ÙŠØ³Øª',0),(340419,9457,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù¾Ø±Ø¯Ø§Ø®Øª (Ø­Ù‚ÙˆÙ‚) Ù†ÙŠØ³Øª',0),(340420,9457,'tr','Ã–deme iÅŸleyemiyor',0),(340421,9457,'pl','Nie moÅ¼e przetworzyÄ‡ pÅ‚atnoÅ›ci',0),(340422,9457,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾',0),(340423,9457,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù¾Ø± Ø¹Ù…Ù„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(340424,9457,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¾Ð±Ñ€Ð°Ð´Ð¸Ñ‚Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(340425,9457,'vi','KhÃ´ng thá»ƒ xá»­ lÃ½ thanh toÃ¡n',0),(340426,9457,'af','Kan nie Betaling Prosesseer nie',0),(340427,9457,'ro','Nu poate procesa plata',0),(340428,9457,'et','Makset ei saa tÃ¶Ã¶delda',0),(340429,9457,'si','Ne more obdelati plaÄilnih',0),(340430,9457,'ba','Tidak dapat memproses pembayaran',0),(340431,9457,'nl','Betaling verwerken niet',0),(340432,9457,'fi','Ei voi kÃ¤sitellÃ¤ maksua',0),(340433,9457,'no','Kan ikke behandle betalingen',0),(340434,9457,'da','Kan ikke behandle betaling',0),(340435,9457,'ko','ì§€ë¶ˆì„ ì²˜ë¦¬í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(340436,9457,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×¢×‘×“ ××ª ×”×ª×©×œ×•×',0),(340437,9457,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯ Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î®',0),(340438,9457,'zh','æ— æ³•å¤„ç†ä»˜æ¬¾\r\n',0),(340439,9457,'sv','Kan inte behandla betalning',0),(340440,9457,'it','Impossibile elaborare il pagamento',0),(340441,9457,'tl','',0),(340442,9457,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3617;&#3635;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;',0),(340443,9457,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(340444,9457,'ms','Tidak dapat memproses pembayaran',0),(340445,9457,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ø¯ÙØ¹',0),(340446,9457,'fr','Impossible de traiter le paiement',0),(340447,9457,'jp','ãŠæ”¯æ‰•ã„ã‚’å‡¦ç†ã§ãã¾ã›ã‚“ã€‚',0),(340448,9457,'pt','NÃ£o Ã© possÃ­vel processar o pagamento',0),(340449,9457,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð¡Ð¾Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶',0),(340450,9457,'es','No se Puede Procesar el Pago',0),(340451,9457,'de','Zahlung kann nicht verarbeitet werden.',0),(340452,9457,'en','Cannot Process Payment',0),(340453,9458,'is','',0),(340454,9458,'dr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†ÙƒÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø§Ø±Ø² ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(340455,9458,'pr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†ÙƒÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø§Ø±Ø² ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(340456,9458,'tr','Bu para birimi iÃ§in hiÃ§bir banka hesaplarÄ± var',0),(340457,9458,'pl','Nie konta Bank istniejÄ… dla tej waluty',0),(340458,9458,'bg','ÐÑÐ¼Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð²Ð°Ð»ÑƒÑ‚Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(340459,9458,'ur','Ú©ÙˆØ¦ÛŒ Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø³ Ú©Ø±Ù†Ø³ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº Û”',0),(340460,9458,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ñƒ Ð±Ð°Ð½Ñ†Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð·Ð° Ð¾Ð²Ñƒ Ð²Ð°Ð»ÑƒÑ‚Ñƒ',0),(340461,9458,'vi','KhÃ´ng CÃ³ TK NgÃ¢n HÃ ng Cho Ngoáº¡i Tá»‡ NÃ y',0),(340462,9458,'af','Geen Bankrekenige Bestaan Vir Hierdie Geldeenheid',0),(340463,9458,'ro','Conturi nu exista aceastÄƒ monedÄƒ',0),(340464,9458,'et','Ei ole panga kontot pole arvustust',0),(340465,9458,'si','Brez banÄnih raÄunov obstajajo za to valuto',0),(340466,9458,'ba','No Rekening Bank yang ada untuk mata uang ini',0),(340467,9458,'nl','Geen Bank Accounts bestaan voor deze valuta',0),(340468,9458,'fi','Pankki-tilejÃ¤ ei ole tÃ¤lle valuutalle',0),(340469,9458,'no','Det finnes ingen Bank kontoer For denne valutaen',0),(340470,9458,'da','Ingen bankkonti findes For denne valuta',0),(340471,9458,'ko','ì´ í†µí™”ì— ëŒ€ í•œ ì€í–‰ ê³„ì •ì´ ì—†ìŒ',0),(340472,9458,'he','××™×Ÿ ×—×©×‘×•× ×•×ª ×‘× ×§ ×§×™×™× ×¢×‘×•×¨ ×ž×˜×‘×¢ ×–×”',0),(340473,9458,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Î¯ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(340474,9458,'zh','æ²¡æœ‰é“¶è¡Œå¸æˆ·å­˜åœ¨è¿™ä¸ªè´§å¸\r\n',0),(340475,9458,'sv','Inga bankkonton finns fÃ¶r denna valuta',0),(340476,9458,'it','Nessun account di banca esistente per questa valuta',0),(340477,9458,'tl','',0),(340478,9458,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3610;&#3633;&#3597;&#3594;&#3637;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3586;&#3629;&#3591;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;&#3609;&#3637;&#3657;',0),(340479,9458,'hi','à¤‡à¤¸ à¤®à¥à¤¦à¥à¤°à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¥Œà¤œà¥‚à¤¦',0),(340480,9458,'ms','Akaun Bank tidak wujud untuk Mata Wang ini',0),(340481,9458,'ar','ÙˆØ¬ÙˆØ¯ Ù„Ø§ Ø­Ø³Ø§Ø¨Ø§Øª Ù…ØµØ±ÙÙŠØ© Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø¹Ù…Ù„Ø©',0),(340482,9458,'fr','Aucun compte bancaire existe pour cette monnaie',0),(340483,9458,'jp','ã“ã®é€šè²¨ã®éŠ€è¡Œå£åº§ãŒå­˜åœ¨ã—ã¾ã›ã‚“ã€‚',0),(340484,9458,'pt','Sem contas bancÃ¡rias existe para esta moeda',0),(340485,9458,'ru','ÐÐµ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ Ð´Ð»Ñ Ð´Ð°Ð½Ð½Ð¾Ð¹ Ð²Ð°Ð»ÑŽÑ‚Ñ‹',0),(340486,9458,'es','No Existen Cuentas Bancarias Para Este Moneda',0),(340487,9458,'de','Keine Bank-Konten gibt es fÃ¼r diese WÃ¤hrung',0),(340488,9458,'en','No Bank Accounts Exist For This Currency',0),(340489,9459,'is','',0),(340490,9459,'dr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø§Ø±Ø² ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(340491,9459,'pr','Ù‡ÙŠÚ† Ø­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø§Ø±Ø² ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(340492,9459,'tr','Bu para birimi iÃ§in hiÃ§bir CC hesaplarÄ± var',0),(340493,9459,'pl','Konta nie CC istnieje dla tej waluty',0),(340494,9459,'bg','ÐÐµ CC ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‚ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(340495,9459,'ur','Ø§Ø³ Ú©Ø±Ù†Ø³ÛŒ Ú©Û’ Ù„Ø¦Û’ Ú©ÙˆØ¦ÛŒ CC Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(340496,9459,'sr','ÐÐµÐ¼Ð° Ð¦Ð¦ Ñ€Ð°Ñ‡ÑƒÐ½ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð·Ð° Ð¾Ð²Ñƒ Ð²Ð°Ð»ÑƒÑ‚Ñƒ',0),(340497,9459,'vi','KhÃ´ng CÃ³ TK Tháº» TÃ­n Dá»¥ng Cho Loáº¡i Tiá»n nÃ y',0),(340498,9459,'af','Geen KK Rekeninge Bestaan Vir Hierdie Geldeenheid',0),(340499,9459,'ro','Nici nu reprezintÄƒ CC exista aceastÄƒ monedÄƒ',0),(340500,9459,'et','Ei ole CC kontot pole arvustust',0),(340501,9459,'si','Ne CC raÄuni obstajajo za to valuto',0),(340502,9459,'ba','Ada CC account yang ada untuk mata uang ini',0),(340503,9459,'nl','Geen CC Accounts bestaan voor deze valuta',0),(340504,9459,'fi','CC-tilejÃ¤ ei ole tÃ¤lle valuutalle',0),(340505,9459,'no','Det finnes ingen kopi kontoer For denne valutaen',0),(340506,9459,'da','Findes ingen CC konti For denne valuta',0),(340507,9459,'ko','ì´ í†µí™”ì— ëŒ€ í•œ ê³„ì •ì´ ì—†ìŠµë‹ˆë‹¤ CC',0),(340508,9459,'he','××™×Ÿ ×—×©×‘×•× ×•×ª CC ×§×™×™×ž×•×ª ×¢×‘×•×¨ ×ž×˜×‘×¢ ×–×”',0),(340509,9459,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ CC Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(340510,9459,'zh','æ²¡æœ‰ä¿¡ç”¨å¡å¸æˆ·å­˜åœ¨è¿™ä¸ªè´§å¸\r\n',0),(340511,9459,'sv','Inga CC konton finns fÃ¶r denna valuta',0),(340512,9459,'it','Nessun account CC esistente per questa valuta',0),(340513,9459,'tl','',0),(340514,9459,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3626;&#3635;&#3648;&#3609;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3586;&#3629;&#3591;&#3626;&#3585;&#3640;&#3621;&#3648;&#3591;&#3636;&#3609;&#3609;&#3',0),(340515,9459,'hi','à¤‡à¤¸ à¤®à¥à¤¦à¥à¤°à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤–à¤¾à¤¤à¥‡ à¤®à¥Œà¤œà¥‚à¤¦',0),(340516,9459,'ms','Akaun CC tidak wujud untuk Mata Wang ini',0),(340517,9459,'ar','Ù„Ø§ Ù†Ø³Ø®Ø© ØªÙˆØ¬Ø¯ Ø­Ø³Ø§Ø¨Ø§Øª Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø¹Ù…Ù„Ø©',0),(340518,9459,'fr','Aucun compte CC existe pour cette monnaie',0),(340519,9459,'jp','ã“ã®é€šè²¨ã® CC ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒå­˜åœ¨ã—ã¾ã›ã‚“ã€‚',0),(340520,9459,'pt','Sem contas CC existem para esta moeda',0),(340521,9459,'ru','ÐÐµ CC ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ð²Ð°Ð»ÑŽÑ‚Ñ‹',0),(340522,9459,'es','No Existen Cuentas de TC Para Este Moneda',0),(340523,9459,'de','Keine CC-Konten gibt es fÃ¼r diese WÃ¤hrung',0),(340524,9459,'en','No CC Accounts Exist For This Currency',0),(340525,9460,'is','',0),(340526,9460,'dr','ÙƒÙ„ Ù¾Ø±ÙˆÚ˜Ù‡',0),(340527,9460,'pr','ÙƒÙ„ Ù¾Ø±ÙˆÚ˜Ù‡',0),(340528,9460,'tr','Proje Toplam',0),(340529,9460,'pl','ÅÄ…cznie projekt',0),(340530,9460,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(340531,9460,'ur','Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ Ú©Ù„',0),(340532,9460,'sr','ÐŸÑ€Ð¾Ñ˜ÐµÐºÐ°Ñ‚ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(340533,9460,'vi','Tá»•ng cá»™ng Dá»± Ã¡n',0),(340534,9460,'af','Projek Totaal',0),(340535,9460,'ro','Total proiect',0),(340536,9460,'et','Projekt kokku',0),(340537,9460,'si','Projekt skupaj',0),(340538,9460,'ba','Proyek Total',0),(340539,9460,'nl','Project totaal',0),(340540,9460,'fi','Projektin yhteensÃ¤',0),(340541,9460,'no','Prosjekt totalt',0),(340542,9460,'da','Projektet samlede',0),(340543,9460,'ko','í”„ë¡œì íŠ¸ ì´',0),(340544,9460,'he','×¤×¨×•×™×§×˜ ×”×›×•×œ×œ',0),(340545,9460,'el','Î¤Î¿ Î­ÏÎ³Î¿ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(340546,9460,'zh','é¡¹ç›®æ€»\r\n',0),(340547,9460,'sv','Projektet totalt',0),(340548,9460,'it','Progetto totale',0),(340549,9460,'tl','',0),(340550,9460,'th','&#3618;&#3629;&#3604;&#3619;&#3623;&#3617;&#3650;&#3611;&#3619;&#3649;&#3592;&#3588;',0),(340551,9460,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥à¤²',0),(340552,9460,'ms','Jumlah projek',0),(340553,9460,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(340554,9460,'fr','Total du projet',0),(340555,9460,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®åˆè¨ˆ',0),(340556,9460,'pt','Total do projeto',0),(340557,9460,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(340558,9460,'es','Total del Proyecto',0),(340559,9460,'de','Projekt insgesamt',0),(340560,9460,'en','Project Total',0),(340561,9461,'is','',0),(340562,9461,'dr','Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ± Ø·Ø¨Ù‚ Ø§Ø³ØªØ§Ù†',0),(340563,9461,'pr','Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ± Ø·Ø¨Ù‚ Ø§Ø³ØªØ§Ù†',0),(340564,9461,'tr','Fatura Ã–zeti devlet tarafÄ±ndan',0),(340565,9461,'pl','Podsumowanie faktury przez PaÅ„stwo',0),(340566,9461,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð ÐµÐ·ÑŽÐ¼Ðµ Ð¾Ñ‚ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°',0),(340567,9461,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø®Ù„Ø§ØµÛ Ø±ÛŒØ§Ø³Øª Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(340568,9461,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð´Ñ€Ð¶Ð°Ð²Ðµ',0),(340569,9461,'vi','Tá»•ng há»£p hÃ³a Ä‘Æ¡n theo tiá»ƒu bang',0),(340570,9461,'af','Faktuur Opsomming per Staat (Landsgebied)',0),(340571,9461,'ro','Factura Scurta descriere de stat',0),(340572,9461,'et','Arvete kokkuvÃµte maakonniti',0),(340573,9461,'si','Povzetek raÄuna drÅ¾ava',0),(340574,9461,'ba','Faktur Ringkasan oleh negara',0),(340575,9461,'nl','Factuuroverzicht door staat',0),(340576,9461,'fi','Laskun Yhteenveto valtion',0),(340577,9461,'no','Fakturasammendrag av staten',0),(340578,9461,'da','Fakturaoversigt af staten',0),(340579,9461,'ko','êµ­ê°€ ì˜í•´ ì†¡ìž¥ ìš”ì•½',0),(340580,9461,'he','×¡×™×›×•× ×—×©×‘×•× ×™×ª ×œ×¤×™ ×ž×“×™× ×”',0),(340581,9461,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÎµÏÎ¯Î»Î·ÏˆÎ· Î±Ï€ÏŒ Ï„Î¿ ÎºÏÎ¬Ï„Î¿Ï‚',0),(340582,9461,'zh','å‘ç¥¨ç”±å›½å®¶æ‘˜è¦\r\n',0),(340583,9461,'sv','Fakturasammanfattning av staten',0),(340584,9461,'it','Riepilogo fatture dallo stato',0),(340585,9461,'tl','',0),(340586,9461,'th','&#3626;&#3619;&#3640;&#3611;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3650;&#3604;&#3618;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(340587,9461,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(340588,9461,'ms','Ringkasan invois mengikut negeri',0),(340589,9461,'ar','Ù…Ù„Ø®Øµ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø­Ø³Ø¨ Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(340590,9461,'fr','Sommaire de la facture par Ã‰tat',0),(340591,9461,'jp','çŠ¶æ…‹ã«ã‚ˆã£ã¦è«‹æ±‚æ›¸ã®æ¦‚è¦',0),(340592,9461,'pt','Resumo de factura por Estado',0),(340593,9461,'ru','Ð¡Ñ‡ÐµÑ‚ Ñ€ÐµÐ·ÑŽÐ¼Ðµ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð°',0),(340594,9461,'es','Sumario de Facturas por Estado',0),(340595,9461,'de','Rechnungszusammenfassung vom Staat',0),(340596,9461,'en','Invoice Summary by State',0),(340597,9462,'is','',0),(340598,9462,'dr','Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ø¨Ø§ Ø§Ø³ØªØ§Ù† ',0),(340599,9462,'pr','Ø®Ù„Ø§ØµÙ‡ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ø¨Ø§ Ø§Ø³ØªØ§Ù† ',0),(340600,9462,'tr','Devlet tarafÄ±ndan fatura Ã–zeti',0),(340601,9462,'pl','Podsumowanie faktury przez PaÅ„stwo',0),(340602,9462,'bg','Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¿Ð¾ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°',0),(340603,9462,'ur','Ø±ÛŒØ§Ø³Øª Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(340604,9462,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð´Ñ€Ð¶Ð°Ð²Ðµ',0),(340605,9462,'vi','Tá»•ng há»£p hÃ³a Ä‘Æ¡n theo tiá»ƒu bang',0),(340606,9462,'af','Opsomming van Fakture per Staat (Landsgebied)',0),(340607,9462,'ro','Rezumat al facturilor de stat',0),(340608,9462,'et','KokkuvÃµte riigi poolt arvete',0),(340609,9462,'si','Povzetek raÄunov drÅ¾ava',0),(340610,9462,'ba','Ringkasan tagihan oleh negara',0),(340611,9462,'nl','Samenvatting van facturen door staat',0),(340612,9462,'fi','Yhteenveto laskujen valtion',0),(340613,9462,'no','Sammendrag av fakturaer av staten',0),(340614,9462,'da','ResumÃ© af fakturaer af staten',0),(340615,9462,'ko','ì†¡ìž¥ ìƒíƒœì— ì˜í•´ì˜ ìš”ì•½',0),(340616,9462,'he','×¡×™×›×•× ×©×œ ×—×©×‘×•× ×™×•×ª ×¢×œ-×™×“×™ ×”×ž×“×™× ×”',0),(340617,9462,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Ï„Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½ Î±Ï€ÏŒ Ï„Î¿ ÎºÏÎ¬Ï„Î¿Ï‚',0),(340618,9462,'zh','å›½å®¶å‡ºå…·çš„çš„å‘ç¥¨æ‘˜è¦\r\n',0),(340619,9462,'sv','Sammanfattning av fakturor av staten',0),(340620,9462,'it','Riepilogo delle fatture dallo stato',0),(340621,9462,'tl','',0),(340622,9462,'th','&#3626;&#3619;&#3640;&#3611;&#3586;&#3629;&#3591;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3650;&#3604;&#3618;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(340623,9462,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(340624,9462,'ms','Ringkasan invois mengikut negeri',0),(340625,9462,'ar','Ù…Ù„Ø®Øµ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø¨Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(340626,9462,'fr','RÃ©sumÃ© des factures par lâ€™Ã‰tat',0),(340627,9462,'jp','çŠ¶æ…‹ã«ã‚ˆã£ã¦è«‹æ±‚æ›¸ã®æ¦‚è¦',0),(340628,9462,'pt','Resumo das faturas por Estado',0),(340629,9462,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð² Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð°',0),(340630,9462,'es','Sumario de Facturas por Estado',0),(340631,9462,'de','Zusammenfassung der Rechnungen vom Staat',0),(340632,9462,'en','Summary of Invoices by State',0),(340633,9463,'is','',0),(340634,9463,'dr','(Ø¹Ù…Ù„) Ù†ÙŠØ³Øª Ø¯Ø±  Ø²Ù…Ø§Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²  Ù‚ÙŠÙ…Øª Ø¬Ù†Ø³Ù‡Ø§ Ø¯Ø± Ø­Ø§Ù„Øª  ',0),(340635,9463,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÙŠÙ† ØªØ§Ø¨Ø¹(Ø¹Ù…Ù„) Ù†ÙŠØ³Øª Ø¯Ø±  Ø²Ù…Ø§Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²  Ù‚ÙŠÙ…Øª ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ø­Ø§Ù„Øª  \r\n Plug-in',0),(340636,9463,'tr','KullanÄ±m bu iÅŸlevi gerÃ§ek madde fiyatlarÄ± eklenti kullanÄ±rken olamaz',0),(340637,9463,'pl','Nie, to uÅ¼ycie funkcji podczas korzystania z rzeczywisty element ceny dodatkÃ³w',0),(340638,9463,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ñ‚Ð°Ð·Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð¿Ñ€Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ†ÐµÐ½Ð¸ Ð´Ð¾Ð±Ð°Ð²ÐºÐ°',0),(340639,9463,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ ÛŒÛ ÙØ¹Ù„ Ø§ØµÙ„ Ø´Û’ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ø§Ø¶Ø§ÙÛ-Ø¬Ø§Øª Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ø¬Ø¨ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(340640,9463,'sr','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¾Ð²Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ ÐºÐ°Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÑÑ‚Ð²Ð°Ñ€Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ñ†ÐµÐ½Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð°Ðº',0),(340641,9463,'vi','KhÃ´ng dÃ¹ng Ä‘Æ°á»£c chá»©c nÄƒng nÃ y khi sá»­ dá»¥ng GiÃ¡ HÃ ng Thá»±c Táº¿',0),(340642,9463,'af','Kan nie Hierdie Funksie Gebruik Wanneer Werklike Item Pryse Inprop gebruik word nie',0),(340643,9463,'ro','Nu pot utilizare aceastÄƒ funcÅ£ie atunci cÃ¢nd se utilizeazÄƒ real element preÅ£urile supliment',0),(340644,9463,'et','Ei saa kasutada see funktsioon kui tegelik kauba eest lisandmooduli abil',0),(340645,9463,'si','Ne morem raba to funkcijo pri uporabi dejanskega elementa cene dodatek',0),(340646,9463,'ba','Tidak bisa menggunakan ini fungsi dengan menggunakan sebenarnya Item harga Add-On',0),(340647,9463,'nl','Kan niet gebruik deze functie bij het gebruik van werkelijke Item prijzen Add-On',0),(340648,9463,'fi','Voi kÃ¤yttÃ¤Ã¤ tÃ¤mÃ¤ toimintoa kÃ¤ytettÃ¤essÃ¤ varsinainen nimikkeen hinnat Add-On',0),(340649,9463,'no','Ikke bruk denne funksjonen nÃ¥r du bruker faktiske element priser Add-On',0),(340650,9463,'da','Kan ikke bruge denne funktion nÃ¥r du bruger faktiske vare priser tilfÃ¸jelse',0),(340651,9463,'ko','ì‚¬ìš©ì´ ê¸°ëŠ¥ ì‚¬ìš© í•˜ëŠ” ê²½ìš° ì‹¤ì œ í•­ëª© ê°€ê²© ì¶”ê°€ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(340652,9463,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×©×™×ž×•×© ×–×• ×¤×•× ×§×¦×™×” ×‘×¢×ª ×©×™×ž×•×© ×‘×¤×•×¢×œ ×¤×¨×™×˜ ×ž×—×™×¨×™× ×”×¨×—×‘×”',0),(340653,9463,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Ï‡ÏÎ®ÏƒÎ· Î±Ï…Ï„ÏŒ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± ÏŒÏ„Î±Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î­Ï‚',0),(340654,9463,'zh','å½“ä½¿ç”¨å®žé™…é¡¹ç›®ä»·æ ¼æ’ä»¶æ—¶ä¸èƒ½ä½¿ç”¨æ­¤åŠŸèƒ½\r\n',0),(340655,9463,'sv','Kan inte anvÃ¤nda detta funktionen nÃ¤r du anvÃ¤nder faktiska objektet priser tillÃ¤gg',0),(340656,9463,'it','Impossibile utilizzare questa funzione quando si utilizzano effettivo elemento prezzi Add-on',0),(340657,9463,'tl','',0),(340658,9463,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3651;&#3594;&#3657;&#3615;&#3633;&#3591;&#3585;&#3660;&#3594;&#3633;&#3656;&#3609;&#3609;&#3637;&#3657;&#3648;&#3617;&#3639;&#3656;&#3629;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3619;&#3',0),(340659,9463,'hi','à¤‰à¤ªà¤¯à¥‹à¤— à¤‡à¤¸ à¤«à¤¼à¤‚à¤•à¥à¤¶à¤¨ à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‡à¤‚ à¤à¤¡-à¤‘à¤¨ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¤à¥‡ à¤¸à¤®à¤¯ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(340660,9463,'ms','Tidak boleh menggunakan ini berfungsi apabila menggunakan tambahan harga sebenar Item',0),(340661,9463,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† \"Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù‡Ø°Ù‡ Ø§Ù„Ø¯Ø§Ù„Ø© Ø¹Ù†Ø¯\" Ø§Ø³ØªØ®Ø¯Ø§Ù… \"Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„ÙØ¹Ù„ÙŠ Ø£Ø³Ø¹Ø§Ø± Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©\"',0),(340662,9463,'fr','Ne pouvez pas utiliser cette fonction lors de lâ€™utilisation rÃ©elle question prix Add-on',0),(340663,9463,'jp','ä½¿ç”¨ã“ã®æ©Ÿèƒ½ã‚’å®Ÿéš›ã®å•†å“ä¾¡æ ¼ã®ã‚¢ãƒ‰ã‚ªãƒ³ã‚’ä½¿ç”¨ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(340664,9463,'pt','NÃ£o Use esta funÃ§Ã£o quando usando o complemento de preÃ§os Item real',0),(340665,9463,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸ÑŽ Ð¿Ñ€Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ð³Ð¾ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ñ†ÐµÐ½Ñ‹ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(340666,9463,'es','No se Puede Usar Esta FunciÃ³n Cuando Esta Usando el Plug-In de Precios Actuales del Item',0),(340667,9463,'de','Kann nicht Verwendung dieser Funktion wenn mit tatsÃ¤chlichen Artikel Preise Add-on',0),(340668,9463,'en','Cannot Use This Function When using Actual Item Prices Add-On',0),(340669,9464,'is','',0),(340670,9464,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ ØªØµØ­ÙŠØ­ Ù…Ø§Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(340671,9464,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ùˆ ØªØµØ­ÙŠØ­ Ù…Ø§Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ ',0),(340672,9464,'tr','DoÄŸrulayÄ±n ve doÄŸru Ã¶ÄŸeyi dengeler',0),(340673,9464,'pl','SprawdÅº i Popraw przedmiot sald',0),(340674,9464,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¸ Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¾ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð±Ð°Ð»Ð°Ð½ÑÐ¸',0),(340675,9464,'ur','Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ú©Ø±ÛŒÚº Ø§ÙˆØ± ØµØ­ÛŒØ­ Ø´Û’ Ø¨ÛŒÙ„Ù†Ø³',0),(340676,9464,'sr','ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ Ð¸ Ð¸ÑÐ¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÑƒ ÑÐ°Ð»Ð´Ð°',0),(340677,9464,'vi','Kiá»ƒm tra & chá»‰nh sá»­a sá»‘ dÆ° hÃ ng',0),(340678,9464,'af','Verifeer en Korrigeer Item Balanse',0),(340679,9464,'ro','Verifica si elementul corect soldurile',0),(340680,9464,'et','Kinnita ja paranda toote koguseid',0),(340681,9464,'si','Preveri in pravilno postavko bilanc',0),(340682,9464,'ba','Memverifikasi dan memperbaiki Item saldo',0),(340683,9464,'nl','Controleren en corrigeren van Item saldi',0),(340684,9464,'fi','Tarkista ja korjaa kohteen saldot',0),(340685,9464,'no','Kontrollere og rette element saldoer',0),(340686,9464,'da','Kontrollere og korrigere vare saldi',0),(340687,9464,'ko','í™•ì¸ í•˜ ê³  ì˜¬ë°”ë¥¸ í•­ëª© ê· í˜•',0),(340688,9464,'he','×•×“× ×•×ž××–× ×ª ××ª ×”×¤×¨×™×˜ ×”× ×›×•×Ÿ',0),(340689,9464,'el','Î•Î»Î­Î³Ï‡ÎµÎ¹ ÎºÎ±Î¹ Î¹ÏƒÎ¿ÏÏÎ¿Ï€ÎµÎ¯ Ï„Î¿ ÏƒÏ‰ÏƒÏ„ÏŒ Î±Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î¿',0),(340690,9464,'zh','éªŒè¯å’Œæ­£ç¡®çš„é¡¹ç›®ç»“ä½™\r\n',0),(340691,9464,'sv','Kontrollera och korrigera objekt saldon',0),(340692,9464,'it','Verificare e correggere i saldi elemento',0),(340693,9464,'tl','',0),(340694,9464,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3649;&#3621;&#3632;&#3618;&#3629;&#3604;&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(340695,9464,'hi','à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤¸à¤‚à¤¤à¥à¤²à¤¿à¤¤ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤¸à¤¹à¥€ à¤†à¤‡à¤Ÿà¤®',0),(340696,9464,'ms','Mengesahkan dan baki betul Item',0),(340697,9464,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø¶ÙˆØ§Ø¨Ø· ÙˆØ§Ù„ØªÙˆØ§Ø²Ù†Ø§Øª Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„ØµØ­ÙŠØ­',0),(340698,9464,'fr','VÃ©rifiez et corrigez soldÃ©s',0),(340699,9464,'jp','ç¢ºèªã—ã€ã‚¢ã‚¤ãƒ†ãƒ  ãƒãƒ©ãƒ³ã‚¹ã‚’ä¿®æ­£',0),(340700,9464,'pt','Verificar e corrigir os saldos de Item',0),(340701,9464,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð¸ Ð¸ÑÐ¿Ñ€Ð°Ð²ÑŒÑ‚Ðµ Ð±Ð°Ð»Ð°Ð½ÑÑ‹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(340702,9464,'es','Verifican y Corrigen los Balances del Item ',0),(340703,9464,'de','ÃœberprÃ¼fen Sie und korrigieren Sie Element Salden',0),(340704,9464,'en','Verify and Correct Item Balances',0),(340705,9465,'is','',0),(340706,9465,'dr','Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† ÙˆØ²Ù†ÙŠ',0),(340707,9465,'pr','Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† ÙˆØ²Ù†ÙŠ',0),(340708,9465,'tr','AÄŸÄ±rlÄ±klÄ± ortalama kullanarak sÃ¼re baÅŸlar',0),(340709,9465,'pl','RozpoczÄ…Ä‡ okresu za pomocÄ… waÅ¼ona Å›rednia',0),(340710,9465,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð½Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€ÐµÑ‚ÐµÐ³Ð»ÐµÐ½Ð° ÑÑ€ÐµÐ´Ð½Ð°',0),(340711,9465,'ur','Ø¨Ø§Ø±Øª Avg. Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ø¯ÙˆØ± Ø´Ø±ÙˆØ¹',0),(340712,9465,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚ÐµÑ›Ð¸ ÑƒÑ‚Ð²Ñ€Ñ’ÐµÐ½Ð¸ ÐŸÐ¾Ð»Ð°Ð·Ð¸ÑˆÑ‚Ðµ',0),(340713,9465,'vi','Ká»³ báº¯t Ä‘áº§u sá»­ dá»¥ng trá»ng lÆ°á»£ng trung bÃ¬nh',0),(340714,9465,'af','Begin tydperk gebruik geweegde Bew.-gem.',0),(340715,9465,'ro','ÃŽncepe perioada de folosire medie ponderatÄƒ',0),(340716,9465,'et','Alustada kasutades kaalutud keskmise perioodi',0),(340717,9465,'si','ZaÄne obdobje tehtano povpreÄno',0),(340718,9465,'ba','Mulai menggunakan rata-rata tertimbang periode',0),(340719,9465,'nl','Begin periode met behulp van gewogen gem.',0),(340720,9465,'fi','Aloittaa kauden kirjanpidollisen painotettu keskiarvo',0),(340721,9465,'no','Starte periode med avveid gj.sn.',0),(340722,9465,'da','Begynde periode ved hjÃ¦lp af Gns.kost',0),(340723,9465,'ko','ê°€ ì¤‘ëœ í‰ê· ì„ ì‚¬ìš© í•˜ ì—¬ ì‹œìž‘ ê¸°ê°„',0),(340724,9465,'he','×‘×’×™×Ÿ ×ª×§×•×¤×ª ×©×™×ž×•×© ×ž×ž×•×¦×¢ ×ž×©×•×§×œ×œ',0),(340725,9465,'el','ÎžÎµÎºÎ¹Î½Î®ÏƒÎµÎ¹ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ ÏƒÏ„Î±Î¸Î¼Î¹ÏƒÎ¼Î­Î½Î· Î¼Î­ÏƒÎ· Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(340726,9465,'zh','æœŸåˆä½¿ç”¨åŠ æƒå¹³å‡ã€‚\r\n',0),(340727,9465,'sv','PÃ¥bÃ¶rja Period med vÃ¤gda Avg.',0),(340728,9465,'it','Iniziare il periodo di utilizzo medio ponderato a',0),(340729,9465,'tl','',0),(340730,9465,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3609;&#3657;&#3635;&#3627;&#3609;&#3',0),(340731,9465,'hi','à¤­à¤¾à¤°à¤¿à¤¤ à¤”à¤¸à¤¤ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤…à¤µà¤§à¤¿ à¤¶à¥à¤°à¥‚',0),(340732,9465,'ms','Mula menggunakan wajaran purata tempoh',0),(340733,9465,'ar','ØªØ¨Ø¯Ø£ Ø§Ù„ÙØªØ±Ø© Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù…ØªÙˆØ³Ø· Ù…Ø±Ø¬Ø­.',0),(340734,9465,'fr','Commencer la pÃ©riode Ã  lâ€™aide de moyenne pondÃ©rÃ©e',0),(340735,9465,'jp','åŠ é‡å¹³å‡ã‚’ä½¿ç”¨ã—ã¦ã€æœŸé–“ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(340736,9465,'pt','ComeÃ§ar o perÃ­odo usando avg ponderada.',0),(340737,9465,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑ Ð²Ð·Ð²ÐµÑˆÐµÐ½Ð½Ð¾Ðµ ÑÑ€ÐµÐ´Ð½ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ',0),(340738,9465,'es','Comienza el PerÃ­odo Usando el promedio ponderado',0),(340739,9465,'de','Periode mit gewichteten Durchschnitt',0),(340740,9465,'en','Begin Period Using Weighted Avg.',0),(340741,9466,'is','',0),(340742,9466,'dr','Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† ÙˆØ²Ù†ÙŠ ',0),(340743,9466,'pr','Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† ÙˆØ²Ù†ÙŠ ',0),(340744,9466,'tr','AÄŸÄ±rlÄ±klÄ± ortalama kullanarak bitiÅŸ sÃ¼resini',0),(340745,9466,'pl','Koniec okresu za pomocÄ… waÅ¼ona Å›rednia',0),(340746,9466,'bg','ÐšÑ€Ð°Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´, ÐºÐ°Ñ‚Ð¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° ÑÑ€ÐµÐ´Ð½Ð¾ Ð¿Ñ€ÐµÑ‚ÐµÐ³Ð»ÐµÐ½Ð°Ñ‚Ð° ÑÑ€ÐµÐ´Ð½Ð°',0),(340747,9466,'ur','Ø§Ø®ØªØªØ§Ù… Ù…Ø¯Øª Ø¨Ø§Ø±Øª Avg. Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(340748,9466,'sr','ÐšÑ€Ð°Ñ˜ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚ÐµÑ›Ð¸ ÑƒÑ‚Ð²Ñ€Ñ’ÐµÐ½Ð¸ ÐŸÐ¾Ð»Ð°Ð·Ð¸ÑˆÑ‚Ðµ',0),(340749,9466,'vi','Cuá»‘i ká»³ dÃ¹ng trá»ng lÆ°á»£ng trung bÃ¬ng',0),(340750,9466,'af','End Periode Gebruik Geweegde Hoev.',0),(340751,9466,'ro','SfÃ¢rÅŸitul perioadei folosind medie ponderatÄƒ',0),(340752,9466,'et','LÃµpp-periood kasutades kaalutud keskm.',0),(340753,9466,'si','Koncu obdobja s tehtano povpreÄno',0),(340754,9466,'ba','Periode akhir menggunakan rata-rata tertimbang',0),(340755,9466,'nl','Einde termijn met behulp van gewogen gem.',0),(340756,9466,'fi','KÃ¤yttÃ¤mÃ¤llÃ¤ painotettu keskiarvo tilikauden lopussa',0),(340757,9466,'no','Ende periode med avveid gj.sn.',0),(340758,9466,'da','Ende periode ved hjÃ¦lp af Gns.kost',0),(340759,9466,'ko','ê°€ ì¤‘ëœ í‰ê· ì„ ì‚¬ìš© í•˜ ì—¬ ìµœì¢… ê¸°ê°„',0),(340760,9466,'he','×¡×™×•× ×ª×§×•×¤×ª ×©×™×ž×•×© ×ž×ž×•×¦×¢ ×ž×©×•×§×œ×œ',0),(340761,9466,'el','Î¤Î­Î»Î¿Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ ÏƒÏ„Î±Î¸Î¼Î¹ÏƒÎ¼Î­Î½Î· Î¼Î­ÏƒÎ·',0),(340762,9466,'zh','æœŸæœ«ä½¿ç”¨åŠ æƒå¹³å‡ã€‚\r\n',0),(340763,9466,'sv','Slutet perioden anvÃ¤nder vÃ¤gda Avg.',0),(340764,9466,'it','Fine periodo utilizzando medio ponderato a',0),(340765,9466,'tl','',0),(340766,9466,'th','&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3585;&#3634;&#3619;&#3651;&#3594;&#3657;&#3588;&#3656;&#3634;&#3648;&#3593;&#3621;&#3637;&#3656;&#3618;&#3606;&#3656;&#3623;&#3591;&#3609;&#3657;&#3',0),(340767,9466,'hi','à¤­à¤¾à¤°à¤¿à¤¤ à¤”à¤¸à¤¤ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤…à¤‚à¤¤ à¤…à¤µà¤§à¤¿',0),(340768,9466,'ms','Akhir zaman yang menggunakan purata wajaran',0),(340769,9466,'ar','Ù†Ù‡Ø§ÙŠØ© ÙØªØ±Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù…ØªÙˆØ³Ø· Ù…Ø±Ø¬Ø­.',0),(340770,9466,'fr','Fin de pÃ©riode en utilisant la moyenne pondÃ©rÃ©e',0),(340771,9466,'jp','åŠ é‡å¹³å‡ã‚’ä½¿ç”¨ã—ã¦æœŸé–“ã®çµ‚äº†',0),(340772,9466,'pt','Fim de perÃ­odo usando avg ponderada.',0),(340773,9466,'ru','ÐšÐ¾Ð½ÐµÑ† Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑ Ð²Ð·Ð²ÐµÑˆÐµÐ½Ð½Ð¾Ðµ ÑÑ€ÐµÐ´Ð½ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ',0),(340774,9466,'es','Termina el PerÃ­odo Usando el Promedio Ponderado.',0),(340775,9466,'de','End-Periode mit gewichteten Durchschnitt',0),(340776,9466,'en','End Period Using Weighted Avg.',0),(340777,9467,'is','',0),(340778,9467,'dr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ Ø·Ø¨Ù‚ Ø§Ø³ØªØ§Ù†',0),(340779,9467,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ Ø·Ø¨Ù‚ Ø§Ø³ØªØ§Ù†',0),(340780,9467,'tr','Faturalar devlet tarafÄ±ndan',0),(340781,9467,'pl','Faktury przez PaÅ„stwo',0),(340782,9467,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¾Ñ‚ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°',0),(340783,9467,'ur','Ø±ÛŒØ§Ø³Øª Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ÙˆØ¨Ø¬Ù„ÛŒ',0),(340784,9467,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð´Ñ€Ð¶Ð°Ð²Ðµ',0),(340785,9467,'vi','HÃ³a Ä‘Æ¡n theo tiá»ƒu bang',0),(340786,9467,'af','Fakture per Staat (Landsgebied)',0),(340787,9467,'ro','Facturi de stat',0),(340788,9467,'et','Arve riik',0),(340789,9467,'si','RaÄunov, ki jih drÅ¾ava',0),(340790,9467,'ba','Faktur oleh negara',0),(340791,9467,'nl','Facturen door staat',0),(340792,9467,'fi','Laskujen valtion',0),(340793,9467,'no','Fakturaer av staten',0),(340794,9467,'da','Fakturaer af staten',0),(340795,9467,'ko','êµ­ê°€ ì˜í•´ ì²­êµ¬ì„œ',0),(340796,9467,'he','×—×©×‘×•× ×™×•×ª ×œ×¤×™ ×ž×“×™× ×”',0),(340797,9467,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½ Î±Ï€ÏŒ Ï„Î¿ ÎºÏÎ¬Ï„Î¿Ï‚',0),(340798,9467,'zh','å‘ç¥¨æŒ‰å›½å®¶\r\n',0),(340799,9467,'sv','Fakturor av staten',0),(340800,9467,'it','Fatture da stato',0),(340801,9467,'tl','',0),(340802,9467,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3650;&#3604;&#3618;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(340803,9467,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0);
INSERT INTO `langdef` VALUES (340804,9467,'ms','Invois mengikut negeri',0),(340805,9467,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø¨Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(340806,9467,'fr','Factures par Ã‰tat',0),(340807,9467,'jp','è«‹æ±‚æ›¸ã®çŠ¶æ…‹ã‚’',0),(340808,9467,'pt','Facturas por Estado',0),(340809,9467,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð¾Ñ‚ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð°',0),(340810,9467,'es','Facturas por Estado',0),(340811,9467,'de','Rechnungen vom Staat',0),(340812,9467,'en','Invoices by State',0),(340813,9468,'is','',0),(340814,9468,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠâ€Œ  Ùˆ ØªØµØ¯ÙŠÙ‚ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(340815,9468,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠâ€Œ  Ùˆ ØªØµØ¯ÙŠÙ‚ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(340816,9468,'tr','Stok doÄŸrulayÄ±n',0),(340817,9468,'pl','Sprawdzanie zapasÃ³w',0),(340818,9468,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð°',0),(340819,9468,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(340820,9468,'sr','ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ Ð·Ð°Ð»Ð¸Ñ…Ðµ',0),(340821,9468,'vi','XÃ¡c Nháº­n HÃ ng Trong Kho',0),(340822,9468,'af','Verifeer Inventaris',0),(340823,9468,'ro','Verifica stoc',0),(340824,9468,'et','Kinnita invenuur',0),(340825,9468,'si','Preveri zaloge',0),(340826,9468,'ba','Memverifikasi persediaan',0),(340827,9468,'nl','Voorraad controleren',0),(340828,9468,'fi','Tarkista varaston',0),(340829,9468,'no','Kontroller lager',0),(340830,9468,'da','Kontroller lagerbeholdningen',0),(340831,9468,'ko','ìž¬ê³  í™•ì¸',0),(340832,9468,'he','××™×ž×•×ª ×ž×œ××™',0),(340833,9468,'el','Î•Ï€Î±Î»Î·Î¸ÎµÏÏƒÏ„Îµ Ï„Î·Î½ Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(340834,9468,'zh','éªŒè¯æ¸…å•\r\n',0),(340835,9468,'sv','Kontrollera lager',0),(340836,9468,'it','Verificare per inventario',0),(340837,9468,'tl','',0),(340838,9468,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;',0),(340839,9468,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(340840,9468,'ms','Mengesahkan inventori',0),(340841,9468,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(340842,9468,'fr','VÃ©rifier lâ€™inventaire',0),(340843,9468,'jp','åœ¨åº«ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(340844,9468,'pt','Verificar o inventÃ¡rio',0),(340845,9468,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(340846,9468,'es','Verifica el Inventario',0),(340847,9468,'de','Inventar zu Ã¼berprÃ¼fen',0),(340848,9468,'en','Verify Inventory',0),(340849,9469,'is','',0),(340850,9469,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø¨Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø± ØµÙØ­Ù‡ Ø§ÙØ²ÙˆØ¯Ù†',0),(340851,9469,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø¨Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø± ØµÙØ­Ù‡ Ø§ÙØ²ÙˆØ¯Ù†',0),(340852,9469,'tr','Banka mevduat Ã¶demeleri Otomatik SeÃ§ sayfa Ekle',0),(340853,9469,'pl','Opcja auto wybÃ³r pÅ‚atnoÅ›ci na depozyt bankowy Dodaj stronÄ™',0),(340854,9469,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÐ½ Ð¸Ð·Ð±Ð¾Ñ€ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð¿Ð¾ Ð±Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð´Ð¾Ð±Ð°Ð²Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(340855,9469,'ur','Ø®ÙˆØ¯-Ù…Ù†ØªØ®Ø¨ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ Ù¾Ø± ØµÙØ­Û Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(340856,9469,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð±Ð¸Ñ€Ð°ÑšÐµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð±Ð°Ð½Ñ†Ð¸ Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(340857,9469,'vi','Tá»± Äá»™ng Lá»±a Chá»n CÃ¡c Thanh ToÃ¡n Trong Trang Tiá»n Cá»c NgÃ¢n HÃ ng',0),(340858,9469,'af','Outo-Selekteer Betalings Op Bank Deposito Byvoegingsblad',0),(340859,9469,'ro','Selectare automatÄƒ a plÄƒÅ£ilor pe depozit bancar Adauga filme',0),(340860,9469,'et','Vali automaatselt makseid pangahoiuste Lisa lehekÃ¼lg',0),(340861,9469,'si','Samodejna izbira plaÄila na banÄni depozit dodati strani',0),(340862,9469,'ba','Auto-pilih pembayaran pada deposito Bank menambahkan halaman',0),(340863,9469,'nl','Automatische selectie betalingen op bankstorting toevoegen pagina',0),(340864,9469,'fi','Automaattinen valinta maksut pankkitalletus LisÃ¤Ã¤ sivu',0),(340865,9469,'no','Velg automatisk betalinger pÃ¥ bankinnskudd legge til side',0),(340866,9469,'da','VÃ¦lg automatisk betalinger pÃ¥ Bank depositum tilfÃ¸je videoside',0),(340867,9469,'ko','ì€í–‰ ì˜ˆê¸ˆì— ìžë™ ì„ íƒ ì§€ë¶ˆ íŽ˜ì´ì§€ ì¶”ê°€',0),(340868,9469,'he','×‘×—×™×¨×” ××•×˜×•×ž×˜×™×ª ×©×œ ×ª×©×œ×•×ž×™× ×¢×œ ×¤×™×§×“×•×Ÿ ×”×‘× ×§ ×œ×”×•×¡×™×£ ×“×£',0),(340869,9469,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÏ€Î¹Î»Î¿Î³Î® Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ ÏƒÏ„Î·Î½ Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÎµÎ»Î¯Î´Î±Ï‚',0),(340870,9469,'zh','é“¶è¡Œå­˜æ¬¾è‡ªåŠ¨é€‰æ‹©æ”¯ä»˜åŠ é¡µ\r\n',0),(340871,9469,'sv','Auto-Select betalningar pÃ¥ bankinsÃ¤ttningar LÃ¤gg till sida',0),(340872,9469,'it','Selezione automatica dei pagamenti su deposito bancario Aggiungi pagina',0),(340873,9469,'tl','',0),(340874,9469,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3612;&#3656;&#3634;&#3609;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3',0),(340875,9469,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤ªà¤° à¤¸à¥à¤µà¤¤:-à¤šà¥à¤¨à¥‡à¤‚ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥ƒà¤·à¥à¤  à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(340876,9469,'ms','Auto-Pilih pembayaran Bank Deposit menambah halaman',0),(340877,9469,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ¯ Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ Ù„Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª ÙÙŠ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ© Ø¥Ø¶Ø§ÙØ© ØµÙØ­Ø©',0),(340878,9469,'fr','SÃ©lection automatique des paiements sur des dÃ©pÃ´ts bancaires ajouter Page',0),(340879,9469,'jp','éŠ€è¡Œé é‡‘ã®æ”¯æ‰•ã„ã‚’è‡ªå‹•é¸æŠžãƒšãƒ¼ã‚¸ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(340880,9469,'pt','SeleÃ§Ã£o automÃ¡tica de pagamentos em depÃ³sito bancÃ¡rio Adicionar pÃ¡gina',0),(340881,9469,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð²Ñ‹Ð±Ð¾Ñ€ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(340882,9469,'es','Auto-seleccionar Pagos en la PÃ¡gina de Agregar DepÃ³sito Bancario',0),(340883,9469,'de','Auto-Select Zahlungen auf Bankeinlagen hinzufÃ¼gen Seite',0),(340884,9469,'en','Auto-Select Payments On Bank Deposit Add Page',0),(340885,9470,'is','',0),(340886,9470,'dr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØ§ÙŠÙŠØ¯ Ø´Ø¯ ',0),(340887,9470,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØ§ÙŠÙŠØ¯ Ø´Ø¯ ',0),(340888,9470,'tr','Stok baÅŸarÄ±yla doÄŸrulandÄ±',0),(340889,9470,'pl','ZapasÃ³w pomyÅ›lnie zweryfikowane',0),(340890,9470,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¸',0),(340891,9470,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚',0),(340892,9470,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ð¾',0),(340893,9470,'vi','XÃ¡c Nháº­n HÃ ng HÃ³a ThÃ nh CÃ´ng',0),(340894,9470,'af','Inventaris Suksesvol Geverifeer',0),(340895,9470,'ro','Inventar cu succes verificat',0),(340896,9470,'et','Varude Ãµnnestus',0),(340897,9470,'si','UspeÅ¡no preveriti zaloge',0),(340898,9470,'ba','Persediaan berhasil memverifikasi',0),(340899,9470,'nl','Inventaris geverifieerd',0),(340900,9470,'fi','Varaston tarkistanut',0),(340901,9470,'no','Lager bekreftet',0),(340902,9470,'da','Lageret bekrÃ¦ftet',0),(340903,9470,'ko','ìž¬ê³  í™•ì¸',0),(340904,9470,'he','×ž×œ××™ ×œ××ž×ª ×‘×”×¦×œ×—×”',0),(340905,9470,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÏ€Î±Î»Î·Î¸ÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(340906,9470,'zh','åº“å­˜æˆåŠŸéªŒè¯\r\n',0),(340907,9470,'sv','Inventering verifierats',0),(340908,9470,'it','Per inventario verificato con esito positivo',0),(340909,9470,'tl','',0),(340910,9470,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3588;&#3621;&#3633;&#3591;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(340911,9470,'hi','à¤¸à¥‚à¤šà¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¿à¤¤',0),(340912,9470,'ms','Inventori yang berjaya disahkan',0),(340913,9470,'ar','Ø¨Ù†Ø¬Ø§Ø­ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(340914,9470,'fr','Inventaire vÃ©rifiÃ© avec succÃ¨s',0),(340915,9470,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªãŒæ­£å¸¸ã«æ¤œè¨¼',0),(340916,9470,'pt','InventÃ¡rio verificado com Ãªxito',0),(340917,9470,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¾',0),(340918,9470,'es','Inventario Verificado Exitosamente',0),(340919,9470,'de','Inventar erfolgreich verifiziert',0),(340920,9470,'en','Inventory Successfully Verified',0),(340921,9471,'is','',0),(340922,9471,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ Ø§Ù†Ø¯ â€“Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø±Ø¯ ÙƒÙ†Ø¯ ',0),(340923,9471,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø§ÙŠÙ† Ø®Ø±ÙŠØ¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ Ø§Ù†Ø¯ â€“Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø±Ø¯ ÙƒÙ†Ø¯ ',0),(340924,9471,'tr','Zaten satÄ±lan - bu satÄ±n alma Ã¶ÄŸeleri olamaz Unreceive',0),(340925,9471,'pl','Elementy z tego zakupu juÅ¼ sprzedane - nie Unreceive',0),(340926,9471,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð¾Ñ‚ Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð²ÐµÑ‡Ðµ ÑÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¸ - Ð½Ðµ Unreceive',0),(340927,9471,'ur','Ø§Ø´ÛŒØ§ Ø³Û’ Ù¾ÛÙ„Û’ ÛÛŒ ÙØ±ÙˆØ®Øª - ÛŒÛ Ø®Ø±ÛŒØ¯ Ø³Ú©ØªØ§ Ø§Ù†Ø±ÛŒØ³ÛŒÙˆÛŒ',0),(340928,9471,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð¸Ð· Ð¾Ð²Ðµ Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ð²ÐµÑ› Ð¿Ñ€Ð¾Ð´Ð°Ð¾ - Ð½Ðµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð£Ð½Ñ€ÐµÑ†ÐµÐ¸Ð²Ðµ.',0),(340929,9471,'vi','HÃ ng trong láº§n mua hÃ ng nÃ y Ä‘Ã£ bÃ¡n - KhÃ´ng nháº­n Ä‘Æ°á»£c',0),(340930,9471,'af','Items Vanaf Hierdie Aankope Alreeds Verkoop - Kan nie Unreceive',0),(340931,9471,'ro','Elemente din aceastÄƒ achiziÅ£ie deja vandute - nu Unreceive',0),(340932,9471,'et','Ei saa Ã¼ksusi seda osta juba mÃ¼Ã¼dud - Unreceive',0),(340933,9471,'si','Elementi iz tega nakupa Å¾e prodajajo - ni Unreceive',0),(340934,9471,'ba','Item dari pembelian ini sudah dijual - tidak Unreceive',0),(340935,9471,'nl','Items uit deze aankoop reeds verkocht - kan niet Unreceive',0),(340936,9471,'fi','TÃ¤mÃ¤n ostaa jo myyty - kohteita ei voi Unreceive',0),(340937,9471,'no','Elementer fra dette kjÃ¸pet allerede solgt - Unreceive ikke',0),(340938,9471,'da','Elementer fra dette kÃ¸b allerede solgt - kan ikke Unreceive',0),(340939,9471,'ko','ì´ë¯¸ íŒë§¤-ì´ êµ¬ìž… í•­ëª© Unreceive ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(340940,9471,'he','×¤×¨×™×˜×™× ×©×œ ×¨×›×™×©×” ×–×• ×›×‘×¨ × ×ž×›×¨ - ×œ× Unreceive',0),(340941,9471,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Ï€ÏŒ Ï„Î·Î½ Î±Î³Î¿ÏÎ¬ Î±Ï…Ï„Î® Ï€Ï‰Î»ÎµÎ¯Ï„Î±Î¹ Î®Î´Î· - Î´ÎµÎ½ Unreceive',0),(340942,9471,'zh','æ¥æºäºŽæ­¤é‡‡è´­çš„é¡¹ç›®å·²ç»å”®å‡º- æ— æ³•æŽ¥æ”¶\r\n',0),(340943,9471,'sv','Artiklar frÃ¥n detta kÃ¶p redan sÃ¥ld - kan inte Unreceive',0),(340944,9471,'it','Gli elementi da questo acquisto giÃ  venduto - non puÃ² Unreceive',0),(340945,9471,'tl','',0),(340946,9471,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3614;&#3619;&#3657;&#3629;&#3617;&#3586;&#3634;&#3618; - &#3652;&#3617;',0),(340947,9471,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¬à¥‡à¤š à¤¦à¤¿à¤¯à¤¾ - à¤‡à¤¸ à¤–à¤°à¥€à¤¦ à¤¸à¥‡ Unreceive à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(340948,9471,'ms','Item dari pembelian ini sudah dijual - tidak Unreceive',0),(340949,9471,'ar','Ø¹Ù†Ø§ØµØ± Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø¨ÙŠØ¹Øª Ø¨Ø§Ù„ÙØ¹Ù„-Ù„Ø§ Ø£ÙˆÙ†Ø±ÙŠØ³ÙŠÙÙŠ',0),(340950,9471,'fr','Les Ã©lÃ©ments de cet achat dÃ©jÃ  vendu - ne peut pas Unreceive',0),(340951,9471,'jp','æ—¢ã«è²©å£² - è³¼å…¥ã‹ã‚‰ã‚¢ã‚¤ãƒ†ãƒ ã“ã¨ã¯ã§ãã¾ã›ã‚“ Unreceive ã—ã¾ã™ã€‚',0),(340952,9471,'pt','Itens desta compra jÃ¡ vendido - nÃ£o Unreceive',0),(340953,9471,'ru','ÐŸÑ€ÐµÐ´Ð¼ÐµÑ‚Ñ‹ Ð¸Ð· ÑÑ‚Ð¾Ð¹ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÑƒÐ¶Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð½Ð¾ - Ð½Ðµ Unreceive',0),(340954,9471,'es','Items de esta Compra Ya Se Vendieron - No se Puede no Recibir',0),(340955,9471,'de','Elemente aus diesem Kauf bereits verkauft - Unreceive kann nicht',0),(340956,9471,'en','Items From This Purchase Already Sold - Cannot Unreceive',0),(340957,9472,'is','',0),(340958,9472,'dr','Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯ â€“ Ø§Ø¨ØªØ¯Ø§ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ ',0),(340959,9472,'pr','Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯ â€“ Ø§Ø¨ØªØ¯Ø§ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø±Ø§ Ø­Ø°Ù ÙƒÙ†ÙŠØ¯ ',0),(340960,9472,'tr','BorÃ§lar - geÃ§ti Bill ilk silmek',0),(340961,9472,'pl','Przekazany do zobowiÄ…zania - UsuÅ„ pierwszy Bill',0),(340962,9472,'bg','ÐŸÑ€ÐµÐ¼Ð¸Ð½Ð° ÐºÑŠÐ¼ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ - Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð±Ð¸Ð» Ð¿ÑŠÑ€Ð²Ð¸',0),(340963,9472,'ur','Ø¨Ù„ Ù¾ÛÙ„Û’ Ú¯Ø²Ø± Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ù„Ø¦Û’ - Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(340964,9472,'sr','ÐŸÑ€ÐµÐ»Ð°Ð·Ð¸ Ð½Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° - Ð±Ñ€Ð¸ÑÐ°ÑšÐµ Ð‘Ð¸Ð» Ð¿Ñ€Ð²Ð¸',0),(340965,9472,'vi','Káº¿t Chuyá»ƒn Sang Pháº£i Tráº£ - XÃ³a HÃ³a ÄÆ¡n TrÆ°á»›c',0),(340966,9472,'af','Oorgedra Na Uitgawes (RB) - Skrap Fakturering Eerste',0),(340967,9472,'ro','A trecut la datorii - ÅŸterge primul proiect de lege',0),(340968,9472,'et','Edasi vÃµlad - kustutada arve esimese',0),(340969,9472,'si','Posredovan obveznosti - izbrisati raÄun prvi',0),(340970,9472,'ba','Dilewatkan ke hutang - menghapus Bill pertama',0),(340971,9472,'nl','Bill eerste doorgegeven aan schulden - verwijderen',0),(340972,9472,'fi','Siirtyi velat - poistaa laskun ensimmÃ¤inen',0),(340973,9472,'no','Sendt til leverandÃ¸rgjeld - slette Bill fÃ¸rste',0),(340974,9472,'da','GÃ¥et til gÃ¦ld - slette Bill fÃ¸rste',0),(340975,9472,'ko','ë¹Œ ì²˜ìŒ ì‚­ì œ ë¯¸ì§€ê¸‰ê¸ˆ-í†µê³¼ ì‹œì¼°ìŠµë‹ˆë‹¤',0),(340976,9472,'he','×œ×–×›××™× - ×œ×ž×—×•×§ ××ª ×”×—×©×‘×•×Ÿ ×”×¨××©×•×Ÿ',0),(340977,9472,'el','ÎÎ± Ï€ÎµÏÎ¬ÏƒÎµÎ¹ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ - Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï€ÏÏŽÏ„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(340978,9472,'zh','ä¼ é€’åˆ°åº”ä»˜å¸æ¬¾- é¦–å…ˆåˆ é™¤å¸å•\r\n',0),(340979,9472,'sv','Skickas till leverantÃ¶rsskulder - ta bort Bill fÃ¶rsta',0),(340980,9472,'it','Passato ai debiti - Elimina prima di Bill',0),(340981,9472,'tl','',0),(340982,9472,'th','&#3612;&#3656;&#3634;&#3609;&#3652;&#3611;&#3618;&#3633;&#3591;&#3648;&#3592;&#3657;&#3634;&#3627;&#3609;&#3637;&#3657; - &#3621;&#3610;&#3610;&#3636;&#3621;&#3649;&#3619;&#3585;',0),(340983,9472,'hi','à¤¸à¥‡ Payables - à¤ªà¤¾à¤°à¤¿à¤¤ à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤ªà¤¹à¤²à¥‡ à¤¹à¤Ÿà¤¾à¤à¤',0),(340984,9472,'ms','Diluluskan kepada pemiutang - menghapuskan pertama Rang undang-undang',0),(340985,9472,'ar','ØªÙ…Ø±ÙŠØ± Ø¥Ù„Ù‰ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹-Ø­Ø°Ù Ø£ÙˆÙ„ Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ†',0),(340986,9472,'fr','PassÃ© aux crÃ©diteurs - supprimer premier Bill',0),(340987,9472,'jp','ãƒ“ãƒ«ã®æœ€åˆã‚’å‰Šé™¤ - è²·æŽ›é‡‘ã«æ¸¡ã•ã‚Œã‚‹',0),(340988,9472,'pt','Passado para contas a pagar - excluir primeiro Bill',0),(340989,9472,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ð½Ð½Ñ‹Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ - ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¿ÐµÑ€Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(340990,9472,'es','Pasado a Proveedores - Elimina la Factura Primero',0),(340991,9472,'de','Ãœbergeben an Verbindlichkeiten - Bill zuerst lÃ¶schen',0),(340992,9472,'en','Passed To Payables - Delete Bill First',0),(340993,9473,'is','',0),(340994,9473,'dr','(Ù…Ø³Ø§Ø¨Ù‚Ù‡)Ù†ÙŠØ³Øª',0),(340995,9473,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù‡Ù…Ø§Ù‡Ù†Ú¯(Ù…Ø³Ø§Ø¨Ù‚Ù‡)Ù†ÙŠØ³Øª',0),(340996,9473,'tr','EÅŸleÅŸme bulunamadÄ±',0),(340997,9473,'pl','Nie moÅ¼na znaleÅºÄ‡ dopasowania',0),(340998,9473,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð¼Ð°Ñ‡',0),(340999,9473,'ur','Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº Ù…Ù„ Ø³Ú©Ø§',0),(341000,9473,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐµ',0),(341001,9473,'vi','KhÃ´ng phÃ¹ há»£p',0),(341002,9473,'af','Kon nie Gelyke Vind',0),(341003,9473,'ro','Nu am putut gÄƒsi meci',0),(341004,9473,'et','Ei leia mÃ¤ngu',0),(341005,9473,'si','Tekmo ni bilo mogoÄe najti.',0),(341006,9473,'ba','Tidak dapat menemukan pertandingan',0),(341007,9473,'nl','Kan niet vinden Match',0),(341008,9473,'fi','Ei lÃ¶ytÃ¤nyt ottelu',0),(341009,9473,'no','Finner ikke kamp',0),(341010,9473,'da','Kunne ikke finde Match',0),(341011,9473,'ko','ì¼ì¹˜ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(341012,9473,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ×”×ª××ž×”',0),(341013,9473,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î²ÏÎµÎ¹ Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯Î±',0),(341014,9473,'zh','æ‰¾ä¸åˆ°åŒ¹é…\r\n',0),(341015,9473,'sv','Kunde inte hitta Match',0),(341016,9473,'it','Impossibile trovare corrispondenza',0),(341017,9473,'tl','',0),(341018,9473,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3588;&#3657;&#3609;&#3627;&#3634;&#3614;&#3610;',0),(341019,9473,'hi','à¤®à¥ˆà¤š à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(341020,9473,'ms','Tidak dapat mencari padanan',0),(341021,9473,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ ØªØ·Ø§Ø¨Ù‚',0),(341022,9473,'fr','Nâ€™a pas trouvÃ© de correspondance',0),(341023,9473,'jp','ä¸€è‡´ã‚’è¦‹ã¤ã‘ã‚‹ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(341024,9473,'pt','NÃ£o foi possÃ­vel encontrar o jogo',0),(341025,9473,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ Ð¼Ð°Ñ‚Ñ‡',0),(341026,9473,'es','No se PodÃ­a Encontrar una Equivalencia',0),(341027,9473,'de','Spiel konnte nicht gefunden werden.',0),(341028,9473,'en','Could Not Find Match',0),(341029,9474,'is','',0),(341030,9474,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„ ',0),(341031,9474,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯ÙØªØ± ÙƒÙ„ ',0),(341032,9474,'tr','GL tutar',0),(341033,9474,'pl','Kwota GL',0),(341034,9474,'bg','GL ÑÑƒÐ¼Ð°',0),(341035,9474,'ur','Ø¬ÛŒØ¬Û’ Ø±Ù‚Ù…',0),(341036,9474,'sr','Ð“Ð› Ð¸Ð·Ð½Ð¾Ñ',0),(341037,9474,'vi','TK sá»• cÃ¡i',0),(341038,9474,'af','AG Bedrag',0),(341039,9474,'ro','GL suma',0),(341040,9474,'et','GL summa',0),(341041,9474,'si','GL znesek',0),(341042,9474,'ba','Jumlah GL',0),(341043,9474,'nl','GL bedrag',0),(341044,9474,'fi','GL mÃ¤Ã¤rÃ¤',0),(341045,9474,'no','GL belÃ¸p',0),(341046,9474,'da','GL belÃ¸b',0),(341047,9474,'ko','GL ê¸ˆì•¡',0),(341048,9474,'he','×›×ž×•×ª GL',0),(341049,9474,'el','Î Î¿ÏƒÏŒ GL',0),(341050,9474,'zh','æ€»å¸é‡‘é¢\r\n',0),(341051,9474,'sv','GL belopp',0),(341052,9474,'it','QuantitÃ  GL',0),(341053,9474,'tl','',0),(341054,9474,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(341055,9474,'hi','GL à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(341056,9474,'ms','L jumlah',0),(341057,9474,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(341058,9474,'fr','Montant GL',0),(341059,9474,'jp','GL é‡',0),(341060,9474,'pt','Quantidade GL',0),(341061,9474,'ru','GL ÑÑƒÐ¼Ð¼Ð°',0),(341062,9474,'es','LM Cantidad',0),(341063,9474,'de','GL-Betrag',0),(341064,9474,'en','GL Amount',0),(341065,9475,'is','',0),(341066,9475,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ ',0),(341067,9475,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ ÙƒØ§Ù„Ø§ ',0),(341068,9475,'tr','Ã–ÄŸesi izci raporu',0),(341069,9475,'pl','Element raportu Tracker',0),(341070,9475,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Tracker Ð´Ð¾ÐºÐ»Ð°Ð´',0),(341071,9475,'ur','Ø´Û’ Ù¹Ø±ÛŒÚ©Ø± Ø±Ù¾ÙˆØ±Ù¹',0),(341072,9475,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(341073,9475,'vi','BÃ¡o cÃ¡o theo dÃµi máº·t hÃ ng',0),(341074,9475,'af','Item Opsporingverslag',0),(341075,9475,'ro','Raport de monitorizare element',0),(341076,9475,'et','Kauba Tracker aruanne',0),(341077,9475,'si','PoroÄilo Tracker element',0),(341078,9475,'ba','Item Tracker laporan',0),(341079,9475,'nl','Item Tracker verslag',0),(341080,9475,'fi','Kohde Tracker kertomus',0),(341081,9475,'no','Elementet Tracker rapport',0),(341082,9475,'da','Vare Tracker rapport',0),(341083,9475,'ko','í•­ëª© ì¶”ì  ë³´ê³ ì„œ',0),(341084,9475,'he','×“×•×— ×ž×¢×§×‘ ×¤×¨×™×˜×™×',0),(341085,9475,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Tracker Î­ÎºÎ¸ÎµÏƒÎ·',0),(341086,9475,'zh','é¡¹ç›®è·Ÿè¸ªæŠ¥å‘Š\r\n',0),(341087,9475,'sv','Objekt Tracker rapport',0),(341088,9475,'it','Elemento Tracking Report',0),(341089,9475,'tl','',0),(341090,9475,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(341091,9475,'hi','à¤†à¤‡à¤Ÿà¤® à¤Ÿà¥à¤°à¥ˆà¤•à¤° à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(341092,9475,'ms','Item Tracker Laporan',0),(341093,9475,'ar','ØªÙ‚Ø±ÙŠØ± ØªØ¹Ù‚Ø¨ Ø¹Ù†ØµØ±',0),(341094,9475,'fr','Point Tracker rapport',0),(341095,9475,'jp','é …ç›®è¿½è·¡ãƒ¬ãƒãƒ¼ãƒˆ',0),(341096,9475,'pt','RelatÃ³rio de Tracker item',0),(341097,9475,'ru','ÐŸÑƒÐ½ÐºÑ‚ Tracker Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(341098,9475,'es','Informe de Rastreador del item',0),(341099,9475,'de','Tracker Itemsbericht',0),(341100,9475,'en','Item Tracker Report',0),(341101,9476,'is','',0),(341102,9476,'dr','Ø¨Ø§ÙŠØ¯ Ø¯Ø± Ø§ÙŠÙ† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(341103,9476,'pr','Ø¨Ø§ÙŠØ¯ Ø¯Ø± Ø§ÙŠÙ† Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(341104,9476,'tr','Bu fiÅŸ olabilir',0),(341105,9476,'pl','MoÅ¼e byÄ‡ w ten kupon',0),(341106,9476,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð² Ñ‚Ð¾Ð·Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(341107,9476,'ur','Ø§Ø³ ÙˆØ§Ø¤Ú†Ø± Ù…ÛŒÚº ÛÙˆ Ø³Ú©ØªØ§ ÛÛ’',0),(341108,9476,'sr','ÐœÐ¾Ð¶Ð´Ð° Ñƒ Ð¾Ð²Ð¾Ð¼ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(341109,9476,'vi','CÃ³ thá»ƒ á»Ÿ trong Phiáº¿u nÃ y',0),(341110,9476,'af','Mag Dalk In Hierdie Bewysstuk Wees',0),(341111,9476,'ro','Ar putea fi Ã®n acest Voucher',0),(341112,9476,'et','VÃµib olla see kanne',0),(341113,9476,'si','Morda v ta kupon',0),(341114,9476,'ba','Mungkin dalam Voucher ini',0),(341115,9476,'nl','Misschien wel In deze Voucher',0),(341116,9476,'fi','EhkÃ¤ tÃ¤mÃ¤ tosite',0),(341117,9476,'no','Kan vÃ¦re i dette bilaget',0),(341118,9476,'da','Kan vÃ¦re i denne kupon',0),(341119,9476,'ko','ì´ ë°”ìš°ì²˜ì— ìžˆì„ ìˆ˜ë„ ìžˆìŠµë‹ˆë‹¤.',0),(341120,9476,'he','×™×™×ª×›×Ÿ ×‘×©×•×‘×¨ ×”×–×”',0),(341121,9476,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(341122,9476,'zh','å¯èƒ½ä¼šåœ¨æ­¤å‡­è¯\r\n',0),(341123,9476,'sv','Kan vara i denna verifikation',0),(341124,9476,'it','Potrebbe essere In questo buono',0),(341125,9476,'tl','',0),(341126,9476,'th','&#3629;&#3634;&#3592;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3609;&#3637;&#3657;',0),(341127,9476,'hi','à¤‡à¤¸ à¤µà¤¾à¤‰à¤šà¤° à¤®à¥‡à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(341128,9476,'ms','Mungkin ada dalam baucar ini',0),(341129,9476,'ar','Ù‚Ø¯ ÙŠÙƒÙˆÙ† ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(341130,9476,'fr','Peut-Ãªtre dans ce bon',0),(341131,9476,'jp','ã‚¯ãƒ¼ãƒãƒ³ãŒã‚ã‚‹ã‹ã‚‚ã—ã‚Œãªã„',0),(341132,9476,'pt','Pode ser neste Voucher',0),(341133,9476,'ru','Ð’Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾, ÑÑ‚Ð¾Ñ‚ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(341134,9476,'es','Puede estar en Este Voucher',0),(341135,9476,'de','MÃ¶glicherweise In diesem Gutschein',0),(341136,9476,'en','Might Be In This Voucher',0),(341137,9477,'is','',0),(341138,9477,'dr','Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(341139,9477,'pr','Ø¨Ø±Ø§ÙŠ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ ',0),(341140,9477,'tr','GL hesabÄ±na',0),(341141,9477,'pl','Do konta k/g',0),(341142,9477,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(341143,9477,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³Û’',0),(341144,9477,'sr','Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½',0),(341145,9477,'vi','Cho TK Sá»• CÃ¡i Tá»•ng Há»£p',0),(341146,9477,'af','Na AG Rekening',0),(341147,9477,'ro','Contul GL',0),(341148,9477,'et','Pearaamatu kontole',0),(341149,9477,'si','GL raÄun',0),(341150,9477,'ba','Ke rekening GL',0),(341151,9477,'nl','Bij GL-Account',0),(341152,9477,'fi','GL-tiliisi',0),(341153,9477,'no','GL-kontoen',0),(341154,9477,'da','GL konto',0),(341155,9477,'ko','GL ê³„ì •',0),(341156,9477,'he','×œ×—×©×‘×•×Ÿ GL',0),(341157,9477,'el','Î£Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î³/Î»',0),(341158,9477,'zh','æ€»å¸å¸æˆ·\r\n',0),(341159,9477,'sv','Till GL-konto',0),(341160,9477,'it','Per conto di contabilitÃ  generale',0),(341161,9477,'tl','',0),(341162,9477,'th','&#3606;&#3638;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(341163,9477,'hi','GL à¤–à¤¾à¤¤à¥‡',0),(341164,9477,'ms','Ke akaun GL',0),(341165,9477,'ar','Ø¥Ù„Ù‰ Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(341166,9477,'fr','Au compte GL',0),(341167,9477,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã«',0),(341168,9477,'pt','A conta GL',0),(341169,9477,'ru','ÐÐ° ÑÑ‡ÐµÑ‚ GL',0),(341170,9477,'es','A la Cuenta LM',0),(341171,9477,'de','GL-Konto',0),(341172,9477,'en','To GL Account',0),(341173,9478,'is','',0),(341174,9478,'dr','Ø­Ø³Ø§Ø¨ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(341175,9478,'pr','Ø­Ø³Ø§Ø¨ Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(341176,9478,'tr','Hesap alt tÃ¼rÃ¼',0),(341177,9478,'pl','Podtyp konta',0),(341178,9478,'bg','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿ Ð½Ð° Ð¿Ñ€Ð¾Ñ„Ð¸Ð»Ð°',0),(341179,9478,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù…',0),(341180,9478,'sr','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(341181,9478,'vi','TK Phá»¥',0),(341182,9478,'af','Rekening Sub-tipe',0),(341183,9478,'ro','Subtipul de cont',0),(341184,9478,'et','Konto alatÃ¼Ã¼bi',0),(341185,9478,'si','RaÄun podtip',0),(341186,9478,'ba','Sub-tipe Akun',0),(341187,9478,'nl','Subtype van de rekening',0),(341188,9478,'fi','Huomioon alatyyppi',0),(341189,9478,'no','Konto undertype',0),(341190,9478,'da','Konto undertype',0),(341191,9478,'ko','ê³„ì • í•˜ìœ„',0),(341192,9478,'he','×¡×•×’ ×©×œ ×—×©×‘×•×Ÿ',0),(341193,9478,'el','Î”ÎµÏ…Ï„ÎµÏÎµÏÏ‰Î½ Ï„ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(341194,9478,'zh','å¸æˆ·å­ç±»åž‹\r\n',0),(341195,9478,'sv','Konto subtyp',0),(341196,9478,'it','Sottotipo di conto',0),(341197,9478,'tl','',0),(341198,9478,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(341199,9478,'hi','à¤–à¤¾à¤¤à¤¾ à¤‰à¤ª-à¤ªà¥à¤°à¤•à¤¾à¤°',0),(341200,9478,'ms','Akaun Subtype',0),(341201,9478,'ar','Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ Ù„Ù„Ø­Ø³Ø§Ø¨',0),(341202,9478,'fr','Sous-type de compte',0),(341203,9478,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ã‚µãƒ–ã‚¿ã‚¤ãƒ—',0),(341204,9478,'pt','Subtipo de conta',0),(341205,9478,'ru','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(341206,9478,'es','Subtipo de Cuenta',0),(341207,9478,'de','Konto-Subtyp',0),(341208,9478,'en','Account Subtype',0),(341209,9479,'is','',0),(341210,9479,'dr','ØªØ¹Ø¯ÙŠÙ„Ø§Øª ÙŠØ§ ØªÙÙƒÙŠÙƒ',0),(341211,9479,'pr','ØªØ¹Ø¯ÙŠÙ„Ø§Øª ÙŠØ§ ØªÙÙƒÙŠÙƒ',0),(341212,9479,'tr','Ayarlamalar veya arÄ±za',0),(341213,9479,'pl','Korekty lub awarii',0),(341214,9479,'bg','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸ Ð¸Ð»Ð¸ Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ¸',0),(341215,9479,'ur','Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ ÛŒØ§ ØªØ¹Ø·Ù„',0),(341216,9479,'sr','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð¸Ð»Ð¸ ÐºÐ²Ð°Ñ€Ð¾Ð²Ð°',0),(341217,9479,'vi','Sá»­a Äá»•i Hay Chia Ra',0),(341218,9479,'af','Aansuiwerings of Ontledings',0),(341219,9479,'ro','AjustÄƒri sau defalcÄƒrile',0),(341220,9479,'et','TÃ¤psustuste ja jaotused',0),(341221,9479,'si','Prilagoditve ali razÄlenitve',0),(341222,9479,'ba','Penyesuaian atau kerusakan',0),(341223,9479,'nl','Aanpassingen of storingen',0),(341224,9479,'fi','Mukautukset ja erittelyt',0),(341225,9479,'no','Justeringer eller sammenbrudd',0),(341226,9479,'da','Justeringer eller nedbrud',0),(341227,9479,'ko','ì¡°ì • ë˜ëŠ” ê³ ìž¥',0),(341228,9479,'he','×”×ª××ž×•×ª ××• ×§×œ×§×•×œ×™×',0),(341229,9479,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚ Î® Î±Î½Î±Î»ÏÏƒÎµÎ¹Ï‚',0),(341230,9479,'zh','è°ƒæ•´æˆ–æ•…éšœ\r\n',0),(341231,9479,'sv','Justeringar eller haverier',0),(341232,9479,'it','Regolazioni o guasti',0),(341233,9479,'tl','',0),(341234,9479,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3627;&#3619;&#3639;&#3629; &#3648;&#3610;&#3619;&#3588;&#3604;&#3634;&#3623;&#3609;&#3660;\n',0),(341235,9479,'hi','à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤¯à¤¾ à¤Ÿà¥‚à¤Ÿà¤¨à¥‡',0),(341236,9479,'ms','Pelarasan atau kerosakan',0),(341237,9479,'ar','ØªØ¹Ø¯ÙŠÙ„Ø§Øª Ø£Ùˆ Ø£Ø¹Ø·Ø§Ù„',0),(341238,9479,'fr','Ajustements ou pannes',0),(341239,9479,'jp','èª¿æ•´ã‚„æ•…éšœ',0),(341240,9479,'pt','Ajustes ou avarias',0),(341241,9479,'ru','ÐšÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð¸Ð»Ð¸ Ð¿Ð¾Ð»Ð¾Ð¼ÐºÐ¸',0),(341242,9479,'es','Ajustes o Desgloses',0),(341243,9479,'de','Anpassungen oder Pannen',0),(341244,9479,'en','Adjustments or Breakdowns',0),(341245,9480,'is','',0),(341246,9480,'dr','Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ú¯Ø²Ø§Ø±Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(341247,9480,'pr','Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ù‡ Ú¯Ø²Ø§Ø±Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(341248,9480,'tr','GL stok hesabÄ± GL envanter raporu seÃ§eneÄŸi iÃ§in',0),(341249,9480,'pl','Konto zapasÃ³w GL dla opcji Raport zapasÃ³w GL',0),(341250,9480,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð·Ð°Ð¿Ð°ÑÐ¸ Ð½Ð° GL Ð·Ð° GL Ð·Ð°Ð¿Ð°ÑÐ¸ Ð´Ð¾ÐºÐ»Ð°Ð´ Ð¾Ð¿Ñ†Ð¸Ñ',0),(341251,9480,'ur','Ø¬ÛŒØ¬Û’ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¬ÛŒØ¬Û’ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ø§Ø®ØªÛŒØ§Ø± Ú©Û’ Ù„Ø¦Û’',0),(341252,9480,'sr','Ð“Ð› ÐºÐ¾Ð½Ñ‚Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð·Ð° Ð“Ð› Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(341253,9480,'vi','TK Sá»• CÃ¡i Tá»•ng Há»£p HÃ ng hÃ³a DÃ¹ng Cho BÃ¡o CÃ¡o HÃ ng Tá»“n Kho Theo Sá»• CÃ¡i',0),(341254,9480,'af','AG Voorraadrekening vir AG Inventaris Verslagopsie',0),(341255,9480,'ro','Contul de stocuri GL pentru GL inventar raport opÅ£iune',0),(341256,9480,'et','GL varude kontot GL inventuuri aruande valik',0),(341257,9480,'si','GL konto zaloge za moÅ¾nost poroÄila zaloge GL',0),(341258,9480,'ba','GL persediaan Account untuk GL inventaris laporan pilihan',0),(341259,9480,'nl','GL voorraadrekening voor GL inventaris verslag optie',0),(341260,9480,'fi','GL varastotilin GL varaston raporttivaihtoehto',0),(341261,9480,'no','GL lagerkontoen For GL lager rapportalternativet',0),(341262,9480,'da','GL Lagerkonto For GL lager rapportindstilling',0),(341263,9480,'ko','GL ìž¬ê³  ë³´ê³ ì„œ ì˜µì…˜ì— ëŒ€ í•œ GL ìž¬ê³  ê³„ì •',0),(341264,9480,'he','GL ×—×©×‘×•×Ÿ ×ž×œ××™ ×œ××¤×©×¨×•×ª ×“×•×— ×ž×œ××™ GL',0),(341265,9480,'el','GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î³Î¹Î± GL ÎµÏ€Î¹Î»Î¿Î³Î® Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(341266,9480,'zh','æ€»å¸åº“å­˜æŠ¥è¡¨é€‰é¡¹çš„æ€»å¸åº“å­˜å¸æˆ·\r\n',0),(341267,9480,'sv','GL lagerkontot fÃ¶r GL inventering rapportalternativ',0),(341268,9480,'it','Conto di magazzino GL GL Inventory Report opzione',0),(341269,9480,'tl','',0),(341270,9480,'th','GL Inventory Account For GL Inventory Report Option',0),(341271,9480,'hi','GL GL à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤–à¤¾à¤¤à¥‡',0),(341272,9480,'ms','Akaun inventori GL untuk GL inventori laporan pilihan',0),(341273,9480,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† GL Ù„Ø®ÙŠØ§Ø± ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø¬Ø±Ø¯ GL',0),(341274,9480,'fr','Compte de stock GL pour Option de Report de lâ€™inventaire GL',0),(341275,9480,'jp','GL åœ¨åº«ãƒ¬ãƒãƒ¼ãƒˆ ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã® GL åœ¨åº«å‹˜å®š',0),(341276,9480,'pt','Conta de estoque GL para a opÃ§Ã£o de relatÃ³rio de inventÃ¡rio GL',0),(341277,9480,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ GL Ð´Ð»Ñ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ GL',0),(341278,9480,'es','LM Cuenta de Inventario para OpciÃ³n de Informe de Inventario de LM',0),(341279,9480,'de','GL Lagerkonto fÃ¼r GL-Inventar-Bericht-Option',0),(341280,9480,'en','GL Inventory Account For GL Inventory Report Option',0),(341281,9481,'is','',0),(341282,9481,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(341283,9481,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(341284,9481,'tr','GL envanter raporu',0),(341285,9481,'pl','Raport inwentarzowy GL',0),(341286,9481,'bg','GL Ð·Ð°Ð¿Ð°ÑÐ¸ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(341287,9481,'ur','Ø¬ÛŒØ¬Û’ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(341288,9481,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° Ð“Ð›',0),(341289,9481,'vi','BÃ¡o CÃ¡o HÃ ng hÃ³a á»ž Sá»• CÃ¡i Tá»•ng Há»£p',0),(341290,9481,'af','AG Inventaris Verslag',0),(341291,9481,'ro','Raport de inventar GL',0),(341292,9481,'et','GL inventuuri aruanne',0),(341293,9481,'si','PoroÄila o popisu GL',0),(341294,9481,'ba','GL inventaris laporan',0),(341295,9481,'nl','GL-inventarisatierapport',0),(341296,9481,'fi','GL: n inventaarion',0),(341297,9481,'no','GL kontorinnholdsrapport',0),(341298,9481,'da','GL lagerrapport',0),(341299,9481,'ko','GL ìž¬ê³  ë³´ê³ ì„œ',0),(341300,9481,'he','GL ×•×—.',0),(341301,9481,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ GL',0),(341302,9481,'zh','æ€»å¸åº“å­˜æŠ¥å‘Š\r\n',0),(341303,9481,'sv','GL inventarierapport',0),(341304,9481,'it','Rapporto di inventario GL',0),(341305,9481,'tl','',0),(341306,9481,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3588;&#3591;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(341307,9481,'hi','GL à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(341308,9481,'ms','GL inventori Laporan',0),(341309,9481,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ÙÙŠ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(341310,9481,'fr','Rapport dâ€™inventaire GL',0),(341311,9481,'jp','GL ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒª ãƒ¬ãƒãƒ¼ãƒˆ',0),(341312,9481,'pt','RelatÃ³rio de inventÃ¡rio GL',0),(341313,9481,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ GL',0),(341314,9481,'es','LM Informe de Inventario',0),(341315,9481,'de','GL-Inventar-Report',0),(341316,9481,'en','GL Inventory Report',0),(341317,9482,'is','',0),(341318,9482,'dr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚ Ø¹Ù…Ù„ÙŠØ§Øª ',0),(341319,9482,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚ Ø¹Ù…Ù„ÙŠØ§Øª ',0),(341320,9482,'tr','Eylem tarafÄ±ndan sipariÅŸ',0),(341321,9482,'pl','KolejnoÅ›Ä‡ dziaÅ‚ania',0),(341322,9482,'bg','Ð ÐµÐ´ Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(341323,9482,'ur','Ú©Ø§Ø±Ø±ÙˆØ§Ø¦ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(341324,9482,'sr','ÐŸÐ¾Ñ˜ÐµÐ´Ð¸Ð½Ð°Ñ‡Ð½Ð¸Ñ… Ð°ÐºÑ†Ð¸Ñ˜Ð°',0),(341325,9482,'vi','Äáº·t hÃ ng theo hÃ nh Ä‘á»™ng',0),(341326,9482,'af','Bestel Deur Aksie',0),(341327,9482,'ro','Ordinea de acÅ£iune',0),(341328,9482,'et','Tegevuse jÃ¤rgi',0),(341329,9482,'si','Nalog z ukrepom',0),(341330,9482,'ba','Order by aksi',0),(341331,9482,'nl','Order by actie',0),(341332,9482,'fi','Jotta toimilla',0),(341333,9482,'no','Sorter etter handling',0),(341334,9482,'da','RÃ¦kkefÃ¸lge af tiltag',0),(341335,9482,'ko','ë™ìž‘ ìˆœì„œ',0),(341336,9482,'he','×¡×“×¨ ×œ×¤×™ ×¤×¢×•×œ×”',0),(341337,9482,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Ï€ÏŒ Î´ÏÎ¬ÏƒÎ·',0),(341338,9482,'zh','æŒ‰åŠ¨ä½œæŽ’åº\r\n',0),(341339,9482,'sv','BestÃ¤llning av Ã¥tgÃ¤rder',0),(341340,9482,'it','Ordine di azione',0),(341341,9482,'tl','',0),(341342,9482,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3650;&#3604;&#3618;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;',0),(341343,9482,'hi','à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥à¤°à¤®',0),(341344,9482,'ms','Perintah oleh tindakan',0),(341345,9482,'ar','Ø£Ù…Ø± Ø¨Ø§ØªØ®Ø§Ø° Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª',0),(341346,9482,'fr','Commande par Action',0),(341347,9482,'jp','è¡Œå‹•é †',0),(341348,9482,'pt','Ordem por aÃ§Ã£o',0),(341349,9482,'ru','Ð—Ð°ÐºÐ°Ð· Ð¿Ð¾ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸ÑŽ',0),(341350,9482,'es','Orden por AcciÃ³n',0),(341351,9482,'de','Bestellung von Aktion',0),(341352,9482,'en','Order by Action',0),(341353,9483,'is','',0),(341354,9483,'dr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚ ÙƒØ§Ù„Ø§',0),(341355,9483,'pr','Ù…Ø±ØªØ¨ ÙƒØ±Ø¯Ù† Ø·Ø¨Ù‚ ÙƒØ§Ù„Ø§',0),(341356,9483,'tr','Maddeye gÃ¶re sipariÅŸ',0),(341357,9483,'pl','ZamÃ³wienia przez element',0),(341358,9483,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð¿Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(341359,9483,'ur','Ø´Û’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¢Ø±ÚˆØ±',0),(341360,9483,'sr','ÐŸÐ¾Ñ˜ÐµÐ´Ð¸Ð½Ð°Ñ‡Ð½Ð¸Ñ… Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(341361,9483,'vi','Äáº·t hÃ ng theo danh má»¥c',0),(341362,9483,'af','Bestelling per Item',0),(341363,9483,'ro','Ordinea de element',0),(341364,9483,'et','Telli kaup',0),(341365,9483,'si','Vrstni red po artiklu',0),(341366,9483,'ba','Order by Item',0),(341367,9483,'nl','Order by Item',0),(341368,9483,'fi','Jotta nimikkeittÃ¤in',0),(341369,9483,'no','Sorter etter vare',0),(341370,9483,'da','Bestilling af vare',0),(341371,9483,'ko','ì£¼ë¬¸ í•­ëª©',0),(341372,9483,'he','×¡×“×¨ ×œ×¤×™ ×¤×¨×™×˜',0),(341373,9483,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Ï€ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(341374,9483,'zh','æŒ‰ç‰©å“æŽ’åº\r\n',0),(341375,9483,'sv','BestÃ¤llning av objekt',0),(341376,9483,'it','Ordine di articolo',0),(341377,9483,'tl','',0),(341378,9483,'th','&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3650;&#3604;&#3618;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(341379,9483,'hi','à¤†à¤‡à¤Ÿà¤® à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤†à¤¦à¥‡à¤¶',0),(341380,9483,'ms','Perintah oleh Item',0),(341381,9483,'ar','ØªØ±ØªÙŠØ¨ Ø­Ø³Ø¨ Ø§Ù„ØµÙ†Ù',0),(341382,9483,'fr','Commande par poste',0),(341383,9483,'jp','é …ç›®é †',0),(341384,9483,'pt','Ordem por Item',0),(341385,9483,'ru','Ð—Ð°ÐºÐ°Ð· Ð¿Ð¾ Ð¢Ð¾Ð²Ð°Ñ€Ñƒ',0),(341386,9483,'es','Orden por Item',0),(341387,9483,'de','Bestellung per Element',0),(341388,9483,'en','Order by Item',0),(341389,9484,'is','',0),(341390,9484,'dr','Ù†ÙˆØ¹ Ú¯Ø²Ø§Ø±Ø´ ',0),(341391,9484,'pr','Ù†ÙˆØ¹ Ú¯Ø²Ø§Ø±Ø´ ',0),(341392,9484,'tr','Rapor tÃ¼rÃ¼',0),(341393,9484,'pl','Typ raportu',0),(341394,9484,'bg','Ð¢Ð¸Ð¿ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(341395,9484,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ù‚Ø³Ù…',0),(341396,9484,'sr','Ð¢Ð¸Ð¿ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(341397,9484,'vi','Loáº¡i BÃ¡o cÃ¡o ',0),(341398,9484,'af','Verslag Tipe',0),(341399,9484,'ro','Tipul de raport',0),(341400,9484,'et','Aruande tÃ¼Ã¼p',0),(341401,9484,'si','Vrsta poroÄila',0),(341402,9484,'ba','Jenis laporan',0),(341403,9484,'nl','Rapporttype',0),(341404,9484,'fi','Raporttityyppi',0),(341405,9484,'no','Rapporttype',0),(341406,9484,'da','Rapporttypen',0),(341407,9484,'ko','ë³´ê³ ì„œ ìœ í˜•',0),(341408,9484,'he','×¡×•×’ ×”×“×•×—',0),(341409,9484,'el','Î¤ÏÏ€Î¿Ï‚ Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(341410,9484,'zh','æŠ¥å‘Šç±»åž‹\r\n',0),(341411,9484,'sv','Typ av rapport',0),(341412,9484,'it','Tipo di rapporto',0),(341413,9484,'tl','',0),(341414,9484,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;',0),(341415,9484,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(341416,9484,'ms','Jenis laporan',0),(341417,9484,'ar','Ù†ÙˆØ¹ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(341418,9484,'fr','Type de rapport',0),(341419,9484,'jp','ãƒ¬ãƒãƒ¼ãƒˆã®ç¨®é¡ž',0),(341420,9484,'pt','Tipo de relatÃ³rio',0),(341421,9484,'ru','Ð¢Ð¸Ð¿ ÐžÑ‚Ñ‡ÐµÑ‚Ð°',0),(341422,9484,'es','Tipo de Informe',0),(341423,9484,'de','Berichtstyp',0),(341424,9484,'en','Report Type',0),(341425,9485,'is','',0),(341426,9485,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡   ÙØ±ÙˆØ´ ',0),(341427,9485,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡   ÙØ±ÙˆØ´ ',0),(341428,9485,'tr','SatÄ±lÄ±k kullanÄ±m',0),(341429,9485,'pl','UÅ¼ycie sprzedaÅ¼',0),(341430,9485,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°',0),(341431,9485,'ur','ÙØ±ÙˆØ®Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(341432,9485,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ',0),(341433,9485,'vi','DÃ¹ng cho bÃ¡n hÃ ng',0),(341434,9485,'af','Verkoop gebruik',0),(341435,9485,'ro','Utilizarea de vÃ¢nzare',0),(341436,9485,'et','MÃ¼Ã¼k kasutamine',0),(341437,9485,'si','Prodajo uporabo',0),(341438,9485,'ba','Gunakan penjualan',0),(341439,9485,'nl','Verkoop gebruik',0),(341440,9485,'fi','MyytÃ¤vÃ¤nÃ¤ kÃ¤yttÃ¶',0),(341441,9485,'no','Salg bruk',0),(341442,9485,'da','Salg brug',0),(341443,9485,'ko','íŒë§¤ ì‚¬ìš©',0),(341444,9485,'he','×©×™×ž×•×© ×œ×ž×›×™×¨×”',0),(341445,9485,'el','Î ÏŽÎ»Î·ÏƒÎ· Ï‡ÏÎ®ÏƒÎ·',0),(341446,9485,'zh','é”€å”®ä½¿ç”¨\r\n',0),(341447,9485,'sv','FÃ¶rsÃ¤ljning anvÃ¤ndning',0),(341448,9485,'it','Uso di vendita',0),(341449,9485,'tl','',0),(341450,9485,'th','&#3651;&#3594;&#3657;&#3586;&#3634;&#3618;',0),(341451,9485,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(341452,9485,'ms','Jualan menggunakan',0),(341453,9485,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¨ÙŠØ¹',0),(341454,9485,'fr','Utilisation de la vente',0),(341455,9485,'jp','è²©å£²ä½¿ç”¨',0),(341456,9485,'pt','Uso de venda',0),(341457,9485,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°',0),(341458,9485,'es','Usa de la Venta',0),(341459,9485,'de','Verkauf-Einsatz',0),(341460,9485,'en','Sale Use',0),(341461,9486,'is','',0),(341462,9486,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø§ÙŠ',0),(341463,9486,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø§ÙŠ',0),(341464,9486,'tr','Rapor iÃ§in izleme',0),(341465,9486,'pl','Raport dla Å›ledzenia',0),(341466,9486,'bg','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÐ»Ð°Ð´ Ð·Ð°',0),(341467,9486,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ø³Ø±Ø§Øº Ø±Ø§Û',0),(341468,9486,'sr','ÐŸÑ€Ð°Ñ›ÐµÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð·Ð°',0),(341469,9486,'vi','TÃ¬m bÃ¡o cÃ¡o cho',0),(341470,9486,'af','Sporingsverslag Vir',0),(341471,9486,'ro','Raport de urmÄƒrire pentru',0),(341472,9486,'et','JÃ¤lgimise aruande',0),(341473,9486,'si','Sledenje poroÄila za',0),(341474,9486,'ba','Pelacakan Laporan',0),(341475,9486,'nl','Verslag voor bijhouden',0),(341476,9486,'fi','Seuranta raportti',0),(341477,9486,'no','Sporing rapport For',0),(341478,9486,'da','Tracking rapport For',0),(341479,9486,'ko','ì¶”ì ì— ëŒ€ í•œ ë³´ê³ ì„œ',0),(341480,9486,'he','×“×• ×— ×ž×¢×§×‘',0),(341481,9486,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚ Î³Î¹Î±',0),(341482,9486,'zh','è·Ÿè¸ªæŠ¥å‘Š\r\n',0),(341483,9486,'sv','Tracking rapport fÃ¶r',0),(341484,9486,'it','Rapporto di monitoraggio per',0),(341485,9486,'tl','',0),(341486,9486,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3586;&#3629;&#3591;',0),(341487,9486,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤',0),(341488,9486,'ms','Penjejakan laporan untuk',0),(341489,9486,'ar','ØªÙ‚Ø±ÙŠØ± Ø¹Ù† ØªØªØ¨Ø¹',0),(341490,9486,'fr','Rapport de suivi pour',0),(341491,9486,'jp','è¿½è·¡ã®ãƒ¬ãƒãƒ¼ãƒˆ',0),(341492,9486,'pt','RelatÃ³rio de controle para',0),(341493,9486,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð´Ð»Ñ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(341494,9486,'es','Informe de Rastreo Para',0),(341495,9486,'de','Tracking-Bericht fÃ¼r',0),(341496,9486,'en','Tracking Report For',0),(341497,9487,'is','',0),(341498,9487,'dr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ú¯Ø²Ø§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(341499,9487,'pr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ú¯Ø²Ø§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(341500,9487,'tr','Blok AR raporlarÄ±',0),(341501,9487,'pl','Blok AR raporty',0),(341502,9487,'bg','Ð‘Ð»Ð¾Ðº AR Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(341503,9487,'ur','Ø¨Ù„Ø§Ú© Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø±Ù¾ÙˆØ±Ù¹ÛŒÚº',0),(341504,9487,'sr','Ð‘Ð»Ð¾Ðº ÐÐ  Ð¸Ð·Ð²Ñ˜ÐµÑˆÑ‚Ð°Ñ˜',0),(341505,9487,'vi','BÃ¡o cÃ¡o TK pháº£i thu',0),(341506,9487,'af','Blokkeer RO Verslae',0),(341507,9487,'ro','Rapoarte de bloc AR',0),(341508,9487,'et','Block AR aruanded',0),(341509,9487,'si','Blok AR poroÄila',0),(341510,9487,'ba','Blok AR laporan',0),(341511,9487,'nl','Blok AR verslagen',0),(341512,9487,'fi','EstÃ¤ AR raportit',0),(341513,9487,'no','Blokkere AR rapporter',0),(341514,9487,'da','Blok AR rapporter',0),(341515,9487,'ko','ë¸”ë¡ AR ë³´ê³ ì„œ',0),(341516,9487,'he','×‘×œ×•×§ AR ×“×•×—×•×ª',0),(341517,9487,'el','AR Î¼Ï€Î»Î¿Îº ÎµÎºÎ¸Î­ÏƒÎµÏ‰Î½',0),(341518,9487,'zh','å°é”åº”æ”¶å¸æ¬¾çš„ç›¸å…³æŠ¥å‘Š\r\n',0),(341519,9487,'sv','Block AR rapporter',0),(341520,9487,'it','Rapporti di blocco AR',0),(341521,9487,'tl','',0),(341522,9487,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3610;&#3636;&#3621;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3610;&#3621;&#3655;&#3629;&#3585;',0),(341523,9487,'hi','à¤¬à¥à¤²à¥‰à¤• AR à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(341524,9487,'ms','Laporan AR blok',0),(341525,9487,'ar','ÙƒØªÙ„Ø© Ø¹ Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ±',0),(341526,9487,'fr','Rapports de bloc AR',0),(341527,9487,'jp','ãƒ–ãƒ­ãƒƒã‚¯ AR ãƒ¬ãƒãƒ¼ãƒˆ',0),(341528,9487,'pt','RelatÃ³rios de AR de bloco',0),(341529,9487,'ru','ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹ AR Ð±Ð»Ð¾Ðº',0),(341530,9487,'es','Bloquean Informes de CC',0),(341531,9487,'de','Block-AR-Berichte',0),(341532,9487,'en','Block AR Reports',0),(341533,9488,'is','',0),(341534,9488,'dr','Ø§Ú¯Ø± ÙƒØ§Ø±Ø¨Ø± Ø­Ù‚ÙˆÙ‚ Ø®ÙˆØ§Ù†Ø¯Ù† ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø¯Ø§Ø±Ø¯ ',0),(341535,9488,'pr','Ø§Ú¯Ø± ÙƒØ§Ø±Ø¨Ø± Ø­Ù‚ÙˆÙ‚ Ø®ÙˆØ§Ù†Ø¯Ù† ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø¯Ø§Ø±Ø¯ ',0),(341536,9488,'tr','KullanÄ±cÄ± AR okuma haklarÄ± varsa',0),(341537,9488,'pl','JeÅ›li uÅ¼ytkownik ma uprawnienia odczytu, AR',0),(341538,9488,'bg','ÐÐºÐ¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ð¸Ð¼Ð° Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ñ‡ÐµÑ‚ÐµÐ½Ðµ Ð½Ð° AR',0),(341539,9488,'ur','Ø§Ú¯Ø± ØµØ§Ø±Ù Ø§Ù„Ø±Ø­ÛŒÙ‚ Ù¾Ú‘Ú¾ÛŒÚº Ø­Ù‚ÙˆÙ‚',0),(341540,9488,'sr','ÐÐºÐ¾ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð¸Ð¼Ð° Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ñ‡Ð¸Ñ‚Ð°ÑšÐµ ÐÐ ',0),(341541,9488,'vi','Náº¿u NgÆ°á»i Sá»­ Dá»¥ng CÃ³ Quyá»n Äá»c TK Pháº£i Thu',0),(341542,9488,'af','Indien Gebruiker oor RO Leesregte beskik.',0),(341543,9488,'ro','ÃŽn cazul Ã®n care utilizatorul are drepturi de citire AR',0),(341544,9488,'et','Kui kasutajal on AR Loe Ãµigusi',0),(341545,9488,'si','ÄŒe uporabnik ima pravice za branje AR',0),(341546,9488,'ba','Jika pengguna memiliki hak membaca AR',0),(341547,9488,'nl','Als gebruiker AR lees rechten heeft',0),(341548,9488,'fi','Jos kÃ¤yttÃ¤jÃ¤llÃ¤ on AR luku oikeudet',0),(341549,9488,'no','Hvis brukeren har AR lese rettigheter',0),(341550,9488,'da','Hvis brugeren har AR lÃ¦se rettigheder',0),(341551,9488,'ko','ë§Œì•½ ì‚¬ìš©ìžê°€ AR ì½ê¸° ê¶Œí•œ',0),(341552,9488,'he','×× ×™×© ×œ×ž×©×ª×ž×© ×–×›×•×™×•×ª ×§×¨×™××” AR',0),(341553,9488,'el','Î•Î¬Î½ Î¿ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ Î­Ï‡ÎµÎ¹ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Î±Î½Î¬Î³Î½Ï‰ÏƒÎ·Ï‚ AR',0),(341554,9488,'zh','å¦‚æžœç”¨æˆ·æœ‰è¯»å–æƒé™å—ä½“\r\n',0),(341555,9488,'sv','Om anvÃ¤ndaren har AR LÃ¤s rÃ¤ttigheter',0),(341556,9488,'it','Se l\'utente ha i diritti di lettura AR',0),(341557,9488,'tl','',0),(341558,9488,'th','&#3606;&#3657;&#3634;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3617;&#3637;&#3626;&#3636;&#3607;&#3608;&#3636;&#3585;&#3634;&#3619;&#3629;&#3656;&#3634;&#3609;&#3621;&#3641;&#3585;&#3627;&#3609;&#3637;&#3657;',0),(341559,9488,'hi','à¤¯à¤¦à¤¿ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ AR à¤ªà¤¢à¤¼à¥‡à¤‚ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¹à¥ˆ',0),(341560,9488,'ms','Jika pengguna mempunyai hak-hak Baca AR',0),(341561,9488,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù„Ø¯ÙŠÙ‡ Ø­Ù‚ÙˆÙ‚ Ù‚Ø±Ø§Ø¡Ø© Ø¹',0),(341562,9488,'fr','Si lâ€™utilisateur dispose de droits de lecture AR',0),(341563,9488,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã¯ã€AR èª­ã¿å–ã‚Šæ¨©é™ã‚’æŒã£ã¦ã„ã‚‹å ´åˆ',0),(341564,9488,'pt','Se o usuÃ¡rio tem direitos de leitura de AR',0),(341565,9488,'ru','Ð•ÑÐ»Ð¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð¸Ð¼ÐµÐµÑ‚ Ð¿Ñ€Ð°Ð²Ð° Ñ‡Ñ‚ÐµÐ½Ð¸Ñ AR',0),(341566,9488,'es','Si el Usuario Tiene Derecho de Leer el CC',0),(341567,9488,'de','Wenn Benutzer Leserechte AR',0),(341568,9488,'en','If User Has AR Read Rights',0),(341569,9489,'is','',0),(341570,9489,'dr','Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ø§Ø³ØªØ§Ù† Ù‡Ø§  Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(341571,9489,'pr','Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ø§Ø³ØªØ§Ù† Ù‡Ø§  Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯',0),(341572,9489,'tr','TÃœM devletler iÃ§in boÅŸ bÄ±rakÄ±n',0),(341573,9489,'pl','Pozostaw puste dla wszystkich StanÃ³w',0),(341574,9489,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð¸',0),(341575,9489,'ur','Ø³Ø¨ Ø§Ù…Ø±ÛŒÚ©Û Ú©Û’ Ù„Ø¦Û’ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(341576,9489,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° ÑÐ²Ðµ Ð´Ñ€Ð¶Ð°Ð²Ðµ',0),(341577,9489,'vi','Äá»ƒ trá»‘ng cho táº¥t cáº£ cÃ¡c tiá»ƒu bang',0),(341578,9489,'af','Laat Oop vir ALLE State (Landsgebiede)',0),(341579,9489,'ro','LÄƒsaÈ›i-o necompletatÄƒ pentru toate statele',0),(341580,9489,'et','JÃ¤tke tÃ¼hjaks kÃµik riigid',0),(341581,9489,'si','Pustite prazno za vse drÅ¾ave',0),(341582,9489,'ba','Biarkan kosong untuk semua negara',0),(341583,9489,'nl','Laat leeg voor alle Staten',0),(341584,9489,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi kaikki valtiot',0),(341585,9489,'no','Tomt for alle stater',0),(341586,9489,'da','Tomt for alle stater',0),(341587,9489,'ko','ëª¨ë“  êµ­ê°€ ëŒ€ í•œ ë¹„ì›Œ',0),(341588,9489,'he','×ª×©××™×¨ ×¨×™×§ ×¢×‘×•×¨ ×›×œ ×”×‘×¨×™×ª',0),(341589,9489,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ Î³Î¹Î± ÏŒÎ»Î± Ï„Î± ÎºÏÎ¬Ï„Î· Î¼Î­Î»Î·',0),(341590,9489,'zh','ç»™æ‰€æœ‰çŠ¶æ€ç©ºç™½\r\n',0),(341591,9489,'sv','LÃ¤mna tom fÃ¶r alla stater',0),(341592,9489,'it','Lasciare vuoto per tutti gli Stati',0),(341593,9489,'tl','',0),(341594,9489,'th','&#3648;&#3623;&#3657;&#3609;&#3623;&#3656;&#3634;&#3591;&#3652;&#3623;&#3657;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(341595,9489,'hi','à¤¸à¤­à¥€ à¤°à¤¾à¤œà¥à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¤¾à¤²à¥€ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚',0),(341596,9489,'ms','Biarkan kosong untuk semua negeri',0),(341597,9489,'ar','Ø§ØªØ±Ùƒ Ø§Ù„Ù…Ø³Ø§Ø­Ø© ÙØ§Ø±ØºØ© Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø¯ÙˆÙ„',0),(341598,9489,'fr','Laissez vide pour tous les Etats',0),(341599,9489,'jp','ã™ã¹ã¦ã®ç±³å›½ã®ç©ºç™½ã®ã¾ã¾ã«',0),(341600,9489,'pt','Deixe em branco para todos os Estados',0),(341601,9489,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼ Ð´Ð»Ñ Ð²ÑÐµÑ… Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²-',0),(341602,9489,'es','Dejar en Blanco para TODOS Los Estados',0),(341603,9489,'de','FÃ¼r jeden Status leer lassen',0),(341604,9489,'en','Leave Blank for ALL States',0),(341605,9490,'is','',0),(341606,9490,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡',0),(341607,9490,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡',0),(341608,9490,'tr','Ã–zet raporu',0),(341609,9490,'pl','Podsumowanie raportu',0),(341610,9490,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(341611,9490,'ur','Ø®Ù„Ø§ØµÛ Ø±Ù¾ÙˆØ±Ù¹',0),(341612,9490,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÑÐ° Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ¾Ð¼',0),(341613,9490,'vi','BÃ¡o cÃ¡o tá»•ng quÃ¡t',0),(341614,9490,'af','Opsommingsverslag',0),(341615,9490,'ro','Raport de sintezÄƒ',0),(341616,9490,'et','KokkuvÃµttev aruanne',0),(341617,9490,'si','Zbirno poroÄilo',0),(341618,9490,'ba','Ringkasan laporan',0),(341619,9490,'nl','Samenvattend verslag',0),(341620,9490,'fi','Yhteenvetoraportti',0),(341621,9490,'no','Sammendragsrapport',0),(341622,9490,'da','Sammenfattende rapport',0),(341623,9490,'ko','ìš”ì•½ ë³´ê³ ì„œ',0),(341624,9490,'he','×“×•×— ×¡×™×›×•×',0),(341625,9490,'el','Î£Ï…Î½Î¿Ï€Ï„Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ·',0),(341626,9490,'zh','æ‘˜è¦æŠ¥è¡¨\r\n',0),(341627,9490,'sv','Sammanfattande rapport',0),(341628,9490,'it','Relazione di sintesi',0),(341629,9490,'tl','',0),(341630,9490,'th','&#3619;&#3634;&#3618;&#3591;&#3634;&#3609;&#3626;&#3619;&#3640;&#3611;',0),(341631,9490,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(341632,9490,'ms','Ringkasan laporan',0),(341633,9490,'ar','ØªÙ‚Ø±ÙŠØ± Ù…Ù„Ø®Ù‘Øµ',0),(341634,9490,'fr','Rapport de synthÃ¨se',0),(341635,9490,'jp','æ¦‚è¦ãƒ¬ãƒãƒ¼ãƒˆ',0),(341636,9490,'pt','RelatÃ³rio resumido',0),(341637,9490,'ru','Ð¡Ð²Ð¾Ð´Ð½Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(341638,9490,'es','Informe de Resumen',0),(341639,9490,'de','Zusammenfassender Bericht',0),(341640,9490,'en','Summary Report',0),(341641,9491,'is','',0),(341642,9491,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(341643,9491,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(341644,9491,'tr','SatÄ±cÄ± faturasÄ±',0),(341645,9491,'pl','Bill dostawcy',0),(341646,9491,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð±Ð¸Ð»',0),(341647,9491,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„',0),(341648,9491,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(341649,9491,'vi','HÃ³a Ä‘Æ¡n NgÆ°á»i bÃ¡n',0),(341650,9491,'af','Handelaar Wetsontwerp',0),(341651,9491,'ro','Factura furnizor',0),(341652,9491,'et','Tarnija arve',0),(341653,9491,'si','RaÄun dobavitelja',0),(341654,9491,'ba','Penjual Bill',0),(341655,9491,'nl','Leverancier Bill',0),(341656,9491,'fi','Toimittajan lasku',0),(341657,9491,'no','LeverandÃ¸ren Bill',0),(341658,9491,'da','Kreditor Bill',0),(341659,9491,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ',0),(341660,9491,'he','×—×©×‘×•×Ÿ ×¡×¤×§',0),(341661,9491,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(341662,9491,'zh','é”€å”®æ–¹å¸å•',0),(341663,9491,'sv','LeverantÃ¶r Bill',0),(341664,9491,'it','Pagamenti fornitore',0),(341665,9491,'tl','',0),(341666,9491,'th','&#3651;&#3610;&#3648;&#3619;&#3637;&#3618;&#3585;&#3648;&#3585;&#3655;&#3610;&#3648;&#3591;&#3636;&#3609;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;',0),(341667,9491,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤²',0),(341668,9491,'ms','Penjual Rang undang-undang',0),(341669,9491,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(341670,9491,'fr','Projet de loi du vendeur',0),(341671,9491,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸',0),(341672,9491,'pt','Conta de fornecedor',0),(341673,9491,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(341674,9491,'es','Recibo de Proveedor',0),(341675,9491,'de','Kreditor-Zahlung',0),(341676,9491,'en','Vendor Bill',0),(341677,9492,'is','',0),(341678,9492,'dr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(341679,9492,'pr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(341680,9492,'tr','Maliyet kodu',0),(341681,9492,'pl','Koszt kodu',0),(341682,9492,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÐºÐ¾Ð´',0),(341683,9492,'ur','Ù‚ÛŒÙ…Øª Ú©ÙˆÚˆ',0),(341684,9492,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(341685,9492,'vi','MÃ£ giÃ¡ thÃ nh',0),(341686,9492,'af','Koste Kode',0),(341687,9492,'ro','Codul de cost',0),(341688,9492,'et','Kulude kood',0),(341689,9492,'si','StroÅ¡kovno kodo',0),(341690,9492,'ba','Kode biaya',0),(341691,9492,'nl','Kosten Code',0),(341692,9492,'fi','Kustannuskoodi',0),(341693,9492,'no','Pris kode',0),(341694,9492,'da','Pris kode',0),(341695,9492,'ko','ë¹„ìš©ëœ ì½”ë“œ',0),(341696,9492,'he','×§×•×“ ×¢×œ×•×ª',0),(341697,9492,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ±',0),(341698,9492,'zh','æˆæœ¬ä»£ç \r\n',0),(341699,9492,'sv','Kostnad kod',0),(341700,9492,'it','Codice di costo',0),(341701,9492,'tl','',0),(341702,9492,'th','&#3619;&#3627;&#3633;&#3626;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(341703,9492,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡',0),(341704,9492,'ms','Kod kos',0),(341705,9492,'ar','Ø±Ù…Ø²Ø§Ù„ØªÙƒÙ„ÙØ©',0),(341706,9492,'fr','Code de coÃ»t',0),(341707,9492,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰',0),(341708,9492,'pt','CÃ³digo de custo',0),(341709,9492,'ru','ÐšÐ¾Ð´ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(341710,9492,'es','CÃ³digo de Costo',0),(341711,9492,'de','Kostencode',0),(341712,9492,'en','Cost Code',0),(341713,9493,'is','',0),(341714,9493,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØªØ¹ÙŠÙŠÙ† ÙƒÙ†Ù†Ø¯Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(341715,9493,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØªØ¹ÙŠÙŠÙ† ÙƒÙ†Ù†Ø¯Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(341716,9493,'tr','Kurulum kategorisi olarak iÅŸlem tanÄ±mlayÄ±cÄ±larÄ±',0),(341717,9493,'pl','Kategorii instalacji jako identyfikatory transakcji',0),(341718,9493,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ ÐºÐ°Ñ‚Ð¾ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð¸ Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(341719,9493,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ø´Ù†Ø§Ø®Øª Ú©Ø§Ø± Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(341720,9493,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ ÐºÐ°Ð¾ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð¸ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(341721,9493,'vi','Setup thá»ƒ loáº¡i nhÆ° lÃ  nháº­n biáº¿t giao dá»‹ch ',0),(341722,9493,'af','Stel KategoriÃ« as Transaksie Identifiseerders op',0),(341723,9493,'ro','Categorii de configurare ca identificatori de tranzactie',0),(341724,9493,'et','Seadistuse kategooria tehingu tunnused',0),(341725,9493,'si','Namestitev kategorije kot transakcija identifikatorji',0),(341726,9493,'ba','Setup Kategori sebagai Identifikasi Transaksi',0),(341727,9493,'nl','Setup categorieÃ«n als transactie-id \'s',0),(341728,9493,'fi','Luokat tapahtuman tunnisteina',0),(341729,9493,'no','Installasjonsprogrammet kategorier som transaksjonen identifikatorer',0),(341730,9493,'da','Setup kategorier som transaktions-id\'er',0),(341731,9493,'ko','íŠ¸ëžœìž­ì…˜ ì‹ë³„ìžë¡œ ì„¤ì • ì¹´í…Œê³ ë¦¬',0),(341732,9493,'he','×”×’×“×¨×ª ×§×˜×’×•×¨×™×•×ª ×›×ž×–×”×™× ×¢×¡×§×ª',0),(341733,9493,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ (Setup) Ï‰Ï‚ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®',0),(341734,9493,'zh','ä½œä¸ºäº‹åŠ¡æ ‡è¯†è®¾ç½®åˆ†ç±»\r\n',0),(341735,9493,'sv','Setup kategorier som transaktionen identifierare',0),(341736,9493,'it','Categorie di installazione come identificatori di transazione',0),(341737,9493,'tl','',0),(341738,9493,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3605;&#3634;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3619;&#3632;&#3',0),(341739,9493,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(341740,9493,'ms','Kategori persediaan sebagai pengecam transaksi',0),(341741,9493,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ ÙØ¦Ø§Øª ÙƒÙ…Ø¹Ø±ÙØ§Øª Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(341742,9493,'fr','CatÃ©gories dâ€™installation en tant quâ€™identificateurs de Transaction',0),(341743,9493,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è­˜åˆ¥å­ã¨ã—ã¦ã‚«ãƒ†ã‚´ãƒªã‚’è¨­å®šã—ã¾ã™ã€‚',0),(341744,9493,'pt','ConfiguraÃ§Ã£o de categorias como identificadores de transaÃ§Ã£o',0),(341745,9493,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ ÐºÐ°Ðº Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ñ‹ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹',0),(341746,9493,'es','Configurar CategorÃ­as como Identificadores de Transacciones',0),(341747,9493,'de','Richten Sie Kategorien wie Transaktion-IDs',0),(341748,9493,'en','Setup Categories as Transaction Identifiers',0),(341749,9494,'is','',0),(341750,9494,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙƒØ¯Ù‡Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØªØ¹ÙŠÙŠÙ† ÙƒÙ†Ù†Ø¯Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(341751,9494,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ÙƒØ¯Ù‡Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØªØ¹ÙŠÙŠÙ† ÙƒÙ†Ù†Ø¯Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(341752,9494,'tr','Maliyet kodlarÄ± iÅŸlem tanÄ±mlayÄ±cÄ± olarak kurulum',0),(341753,9494,'pl','Konfiguracja kodÃ³w kosztÃ³w jako identyfikatory transakcji',0),(341754,9494,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÐºÐ¾Ð´Ð¾Ð²Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚Ð¾ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð¸ Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(341755,9494,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ø´Ù†Ø§Ø®Øª Ú©Ø§Ø± Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ù‚ÛŒÙ…Øª Ø±Ù…ÙˆØ²',0),(341756,9494,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÑˆÐ¸Ñ„Ñ€Ðµ ÐºÐ°Ð¾ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð¸ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(341757,9494,'vi','MÃ£ phÃ­ Setup nhÆ° lÃ  nháº­n biáº¿t giao dá»‹ch ',0),(341758,9494,'af','Opstelling van Koste Kodes as Transaksie Identifiseerders',0),(341759,9494,'ro','Setare Cost coduri ca identificatori de tranzacÅ£ie',0),(341760,9494,'et','Setup kulud koodiga kui tehingu tunnused',0),(341761,9494,'si','Nastavitev stroÅ¡kov kode kot transakcija identifikatorji',0),(341762,9494,'ba','Kode biaya setup sebagai pengidentifikasi transaksi',0),(341763,9494,'nl','Kosten instelcodes als transactie-id \'s',0),(341764,9494,'fi','MÃ¤Ã¤ritÃ¤ kustannus koodeja tapahtuman tunnisteina',0),(341765,9494,'no','Sette pris koder som transaksjonen identifikatorer',0),(341766,9494,'da','Setup omkostninger koder som transaktions-id\'er',0),(341767,9494,'ko','íŠ¸ëžœìž­ì…˜ ì‹ë³„ìžë¡œ ì„¤ì¹˜ ë¹„ìš©ëœ ì½”ë“œ',0),(341768,9494,'he','×§×•×“×™ ×¢×œ×•×ª ×”×”×ª×§× ×” ×›×ž×–×”×™× ×¢×¡×§×ª',0),(341769,9494,'el','Î¡ÏÎ¸Î¼Î¹ÏƒÎ· ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÎºÏŽÎ´Î¹ÎºÎµÏ‚ Ï‰Ï‚ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®',0),(341770,9494,'zh','ä¸ºäº¤æ˜“æˆæœ¬ä»£ç è®¾ç½®æ ‡è¯†ç¬¦\r\n',0),(341771,9494,'sv','Kostnad InstÃ¤llningskoder som transaktionen identifierare',0),(341772,9494,'it','Configurare i codici di costo come identificatori di transazione',0),(341773,9494,'tl','',0),(341774,9494,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3619;&#3627;&#3633;&#3626;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3605;&#3634;&#3617;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3',0),(341775,9494,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤²à¤¾à¤—à¤¤ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤•à¥‹à¤¡à¥à¤¸',0),(341776,9494,'ms','Kod kos persediaan sebagai pengecam transaksi',0),(341777,9494,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø±Ù…ÙˆØ² Ø§Ù„ØªÙƒÙ„ÙØ© ÙƒÙ…Ø¹Ø±ÙØ§Øª Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(341778,9494,'fr','CoÃ»t de Codes de configuration en tant quâ€™identificateurs de Transaction',0),(341779,9494,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è­˜åˆ¥å­ã¨ã—ã¦ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰',0),(341780,9494,'pt','Custo de instalaÃ§Ã£o de cÃ³digos como identificadores de transaÃ§Ã£o',0),(341781,9494,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´Ñ‹ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ ÐºÐ°Ðº Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ñ‹ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹',0),(341782,9494,'es','CÃ³digos de Costos de ConfiguraciÃ³n como Identificadores de Transacciones',0),(341783,9494,'de','Setup-Kosten-Codes als Transaktion-IDs',0),(341784,9494,'en','Setup Cost Codes as Transaction Identifiers',0),(341785,9495,'is','',0),(341786,9495,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(341787,9495,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(341788,9495,'tr','Kurulum hareket kodu',0),(341789,9495,'pl','Ustawienie ID transakcji',0),(341790,9495,'bg','Ð˜Ð” Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð·Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(341791,9495,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(341792,9495,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð˜Ð” Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(341793,9495,'vi','Setup ID giao dá»‹ch',0),(341794,9495,'af','Transaksie ID Opstel',0),(341795,9495,'ro','Configurare Transaction ID',0),(341796,9495,'et','Seadista kande ID',0),(341797,9495,'si','Nastavitev posla ID',0),(341798,9495,'ba','ID transaksi setup',0),(341799,9495,'nl','Transactie-ID instellen',0),(341800,9495,'fi','Setup Tapahtumatunnus',0),(341801,9495,'no','Installasjonsprogrammet transaksjons-ID',0),(341802,9495,'da','OpsÃ¦tning af transaktions-ID',0),(341803,9495,'ko','íŠ¸ëžœìž­ì…˜ ID ì„¤ì •',0),(341804,9495,'he','×ª×•×›× ×™×ª ×”×”×ª×§× ×” ×ž×–×”×” ×ª× ×•×¢×”',0),(341805,9495,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(341806,9495,'zh','è®¾ç½®äº‹åŠ¡èº«ä»½è¯\r\n',0),(341807,9495,'sv','Installationsprogrammet fÃ¶r transaktions-ID',0),(341808,9495,'it','ID della transazione di installazione',0),(341809,9495,'tl','',0),(341810,9495,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;',0),(341811,9495,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ ID à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(341812,9495,'ms','Sediakan ID transaksi',0),(341813,9495,'ar','Ù…Ø¹Ø±Ù Ù…Ø¹Ø§Ù…Ù„Ø© Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(341814,9495,'fr','Configuration des ID de Transaction',0),(341815,9495,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ID ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(341816,9495,'pt','ConfiguraÃ§Ã£o ID de transaÃ§Ã£o',0),(341817,9495,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(341818,9495,'es','ID de ConfiguraciÃ³n de TransaciÃ³n',0),(341819,9495,'de','Transaktions-ID einrichten',0),(341820,9495,'en','Setup Transaction ID',0),(341821,9496,'is','',0),(341822,9496,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ØªØ¹ÙŠÙŠÙ† ÙƒÙ†Ù†Ø¯Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(341823,9496,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ ØªØ¹ÙŠÙŠÙ† ÙƒÙ†Ù†Ø¯Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(341824,9496,'tr','Kurulum iÅŸlem tanÄ±mlayÄ±cÄ±larÄ±',0),(341825,9496,'pl','Konfiguracja identyfikatorÃ³w transakcji',0),(341826,9496,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð¸',0),(341827,9496,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ø´Ù†Ø§Ø®Øª Ú©Ø§Ø± Ø³ÛŒÙ¹ Ø§Ù¾',0),(341828,9496,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð°',0),(341829,9496,'vi','Setup nháº­n biáº¿t giao dá»‹ch',0),(341830,9496,'af','Transaksie Identifiseerders Opstel',0),(341831,9496,'ro','Identificatori de tranzacÅ£ie de configurare',0),(341832,9496,'et','Seadista kande tunnused',0),(341833,9496,'si','Nastavitev posla identifikatorji',0),(341834,9496,'ba','Setup pengidentifikasi transaksi',0),(341835,9496,'nl','Transactie-id instellen',0),(341836,9496,'fi','MÃ¤Ã¤ritÃ¤ tapahtuman tunnukset',0),(341837,9496,'no','Installasjonsprogrammet transaksjon IDer',0),(341838,9496,'da','Setup transaktions-id\'er',0),(341839,9496,'ko','íŠ¸ëžœìž­ì…˜ ì‹ë³„ìž ì„¤ì •',0),(341840,9496,'he','×”×’×“×¨×ª ×ž×–×”×™ ×˜×¨× ×–×§×¦×™×•×ª',0),(341841,9496,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(341842,9496,'zh','è®¾ç½®äº‹åŠ¡æ ‡è¯†\r\n',0),(341843,9496,'sv','Setup transaktionen identifierare',0),(341844,9496,'it','Identificatori di transazione di installazione',0),(341845,9496,'tl','',0),(341846,9496,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3619;&#3632;&#3610;&#3640;',0),(341847,9496,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾',0),(341848,9496,'ms','Persediaan pengecam transaksi',0),(341849,9496,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ù…Ø¹Ø±ÙØ§Øª Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(341850,9496,'fr','Identificateurs de Transaction dâ€™installation',0),(341851,9496,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è­˜åˆ¥å­',0),(341852,9496,'pt','Identificadores de transaÃ§Ã£o de instalaÃ§Ã£o',0),(341853,9496,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ñ‹ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(341854,9496,'es','Configurar Identificadores de Transacciones',0),(341855,9496,'de','Setup-Transaktion-IDs',0),(341856,9496,'en','Setup Transaction Identifiers',0),(341857,9497,'is','',0),(341858,9497,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø´ØºÙ„ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(341859,9497,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø´ØºÙ„ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(341860,9497,'tr','Ä°ÅŸlemi iÅŸlem tanÄ±mlayÄ±cÄ± olarak kullanÄ±lÄ±r',0),(341861,9497,'pl','UÅ¼ywaÄ‡ zadanie jako identyfikator transakcji',0),(341862,9497,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð° ÐºÐ°Ñ‚Ð¾ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(341863,9497,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ø´Ù†Ø§Ø®Øª Ú©Ù†Ù†Ø¯Û Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Û”',0),(341864,9497,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ðµ Ð¿Ð¾ÑÐ°Ð¾ ÐºÐ°Ð¾ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(341865,9497,'vi','DÃ¹ng Job Ä‘á»ƒ xÃ¡c Ä‘á»‹nh giao dá»‹ch',0),(341866,9497,'af','Werk as transaksie identifiseerder gebruik',0),(341867,9497,'ro','Utilizarea Job ca identificatorul de tranzacÅ£ie',0),(341868,9497,'et','Kasutada tÃ¶Ã¶ kande ID.',0),(341869,9497,'si','Uporabite kot identifikator posla',0),(341870,9497,'ba','Menggunakan pekerjaan sebagai pengenal transaksi',0),(341871,9497,'nl','Gebruik baan als transactie-id',0),(341872,9497,'fi','KÃ¤yttÃ¤Ã¤ tyÃ¶ tapahtuman tunnus',0),(341873,9497,'no','Bruk jobb som transaksjons-ID',0),(341874,9497,'da','Bruge Job som Transaction ID',0),(341875,9497,'ko','ìž‘ì—…ì„ ì‚¬ìš© í•˜ ì—¬ íŠ¸ëžœìž­ì…˜ ì‹ë³„ìžë¡œ',0),(341876,9497,'he','×œ×”×©×ª×ž×© ××ª ×”×¢×‘×•×“×” ×‘×ª×•×¨ ×ž×–×”×” ×”×˜×¨× ×–×§×¦×™×”',0),(341877,9497,'el','Î§ÏÎ®ÏƒÎ· Î´Î¿Ï…Î»ÎµÎ¹Î¬ Ï‰Ï‚ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(341878,9497,'zh','ä½œä¸šæ ‡è¯†ç¬¦ç”¨ä½œäº¤æ˜“\r\n',0),(341879,9497,'sv','AnvÃ¤nda jobb som transaktionen identifierare',0),(341880,9497,'it','Utilizzare lavoro come identificatore di transazione',0),(341881,9497,'tl','',0),(341882,9497,'th','&#3651;&#3594;&#3657;&#3591;&#3634;&#3609;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3619;&#3632;&#3610;&#3640;',0),(341883,9497,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¤¾ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(341884,9497,'ms','Menggunakan kerja sebagai pengecam transaksi',0),(341885,9497,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ© ÙƒÙ…Ø¹Ø±Ù‘Ù Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø©',0),(341886,9497,'fr','Utilisez le Job comme identificateur de Transaction',0),(341887,9497,'jp','ã‚¸ãƒ§ãƒ–ã‚’ä½¿ç”¨ã—ã¦ã€ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã®è­˜åˆ¥å­ã¨ã—ã¦',0),(341888,9497,'pt','Usar o trabalho como identificador de transaÃ§Ã£o',0),(341889,9497,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ ÐºÐ°Ðº Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(341890,9497,'es','Usar Trabajo com Identificador de TransacciÃ³n',0),(341891,9497,'de','Job als Transaktions-ID verwenden',0),(341892,9497,'en','Use Job as Transaction Identifier',0),(341893,9498,'is','',0),(341894,9498,'dr','Ø§Ù†ÙˆØ§Ø¹ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(341895,9498,'pr','Ø§Ù†ÙˆØ§Ø¹ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(341896,9498,'tr','Maliyet tÃ¼rleri',0),(341897,9498,'pl','Rodzaje kosztÃ³w',0),(341898,9498,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð²Ð¸Ð´Ð¾Ð²Ðµ',0),(341899,9498,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(341900,9498,'sr','Ð’Ñ€ÑÑ‚Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(341901,9498,'vi','Loáº¡i giÃ¡ thÃ nh',0),(341902,9498,'af','Koste Tipes',0),(341903,9498,'ro','Tipuri de costuri',0),(341904,9498,'et','Kulude liigid',0),(341905,9498,'si','Vrste stroÅ¡kov',0),(341906,9498,'ba','Jenis biaya',0),(341907,9498,'nl','Kosten typen',0),(341908,9498,'fi','Kustannusten tyypit',0),(341909,9498,'no','Kostnader typer',0),(341910,9498,'da','Pristyper',0),(341911,9498,'ko','ë¹„ìš©ëœ ì¢…ë¥˜',0),(341912,9498,'he','×¡×•×’×™ ×‘×¢×œ×•×ª',0),(341913,9498,'el','Î¤ÏÏ€Î¿Î¹ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(341914,9498,'zh','æˆæœ¬ç±»åž‹\r\n',0),(341915,9498,'sv','Kostnadstyper',0),(341916,9498,'it','Tipi di costo',0),(341917,9498,'tl','',0),(341918,9498,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(341919,9498,'hi','à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(341920,9498,'ms','Jenis-jenis kos',0),(341921,9498,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„ØªÙƒÙ„ÙØ©',0),(341922,9498,'fr','Types de coÃ»ts',0),(341923,9498,'jp','ã‚³ã‚¹ãƒˆã®ç¨®é¡ž',0),(341924,9498,'pt','Tipos de custo',0),(341925,9498,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(341926,9498,'es','Tipos de Costos',0),(341927,9498,'de','Kosten-Typen',0),(341928,9498,'en','Cost Types',0),(341929,9499,'is','',0),(341930,9499,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§Ù†ÙˆØ§Ø¹ Ú¯Ø±ÙˆÙ‡ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(341931,9499,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø§Ù†ÙˆØ§Ø¹ Ú¯Ø±ÙˆÙ‡ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(341932,9499,'tr','Kategori maliyet tÃ¼rleri kurulum',0),(341933,9499,'pl','Konfiguracja typÃ³w kategorii kosztÃ³w',0),(341934,9499,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(341935,9499,'ur','Ø²Ù…Ø±Û Ù‚ÛŒÙ…Øª Ø§Ù‚Ø³Ø§Ù… Ø³ÛŒÙ¹ Ø§Ù¾',0),(341936,9499,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð²Ñ€ÑÑ‚Ðµ',0),(341937,9499,'vi','Setup thá»ƒ loáº¡i Chi phÃ­',0),(341938,9499,'af','Opstel kategorie koste tipes',0),(341939,9499,'ro','Configurare tipuri Cost categorie',0),(341940,9499,'et','Seadistuse kategooria kulude liigid',0),(341941,9499,'si','Namestitev kategorije stroÅ¡kov vrste',0),(341942,9499,'ba','Kategori jenis biaya setup',0),(341943,9499,'nl','Categorie kosten typen instellen',0),(341944,9499,'fi','MÃ¤Ã¤ritÃ¤ luokka kustannusten tyypit',0),(341945,9499,'no','Setup kostnad kategoritypene',0),(341946,9499,'da','Setup kategori pristyper',0),(341947,9499,'ko','ì¹´í…Œê³ ë¦¬ ë¹„ìš©ëœ ì¢…ë¥˜ ì„¤ì •',0),(341948,9499,'he','×”×’×“×¨×ª ×¡×•×’×™ ×¢×œ×•×ª ×§×˜×’×•×¨×™×”',0),(341949,9499,'el','Î¡ÏÎ¸Î¼Î¹ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï„ÏÏ€Î¿Ï…Ï‚',0),(341950,9499,'zh','è®¾ç½®ç±»åˆ«æˆæœ¬ç±»åž‹\r\n',0),(341951,9499,'sv','Setup kategori kostnadstyper',0),(341952,9499,'it','Categoria tipi di costo di installazione',0),(341953,9499,'tl','',0),(341954,9499,'th','&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(341955,9499,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(341956,9499,'ms','Sediakan kategori jenis kos',0),(341957,9499,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø£Ù†ÙˆØ§Ø¹ ÙØ¦Ø© Ø§Ù„ØªÙƒÙ„ÙØ©',0),(341958,9499,'fr','Configurer les Types de coÃ»t de catÃ©gories',0),(341959,9499,'jp','ã‚³ã‚¹ãƒˆã®ç¨®é¡žã®ã‚«ãƒ†ã‚´ãƒªã‚’ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã—ã¾ã™ã€‚',0),(341960,9499,'pt','ConfiguraÃ§Ã£o de tipos de custo de categoria',0),(341961,9499,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ñ‚Ð¸Ð¿Ñ‹',0),(341962,9499,'es','Tipos de Costo de CategorÃ­as de ConfiguraciÃ³n',0),(341963,9499,'de','Setup-Kosten Kategorietypen',0),(341964,9499,'en','Setup Category Cost Types',0),(341965,9500,'is','',0),(341966,9500,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(341967,9500,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(341968,9500,'tr','Ä°ÅŸlem tanÄ±mlayÄ±cÄ±sÄ± iÃ§in Kategoriler',0),(341969,9500,'pl','Kategorie dla identyfikatora transakcji',0),(341970,9500,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð·Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(341971,9500,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ø´Ù†Ø§Ø®Øª Ú©Ù†Ù†Ø¯Û Ú©Û’ Ù„ÛŒÛ’ Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(341972,9500,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð·Ð° Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(341973,9500,'vi','Thá»ƒ loáº¡i cho nháº­n biáº¿t giao dá»‹ch',0),(341974,9500,'af','KategoriÃ« vir Transaksie Identifiseerder',0),(341975,9500,'ro','Categorii pentru identificatorul de tranzacÅ£ie',0),(341976,9500,'et','Tehingutunnus kategooriad',0),(341977,9500,'si','Kategorije za identifikator posla',0),(341978,9500,'ba','Kategori untuk Identifikasi Transaksi',0),(341979,9500,'nl','CategorieÃ«n voor transactie-id',0),(341980,9500,'fi','Luokat tapahtuman tunnus',0),(341981,9500,'no','Kategorier for transaksjons-ID',0),(341982,9500,'da','Kategorier for transaktions-id',0),(341983,9500,'ko','íŠ¸ëžœìž­ì…˜ ì‹ë³„ìžì— ëŒ€ í•œ ì¹´í…Œê³ ë¦¬',0),(341984,9500,'he','×§×˜×’×•×¨×™×•×ª ×¢×‘×•×¨ ×ž×–×”×” ×”×˜×¨× ×–×§×¦×™×”',0),(341985,9500,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î¿ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(341986,9500,'zh','ä¸ºäº¤æ˜“ç±»åˆ«æ ‡è¯†\r\n',0),(341987,9500,'sv','Kategorier fÃ¶r transaktion-ID.',0),(341988,9500,'it','Categorie per identificatore di transazione',0),(341989,9500,'tl','',0),(341990,9500,'th','&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3619;&#3632;&#3610;&#3640;',0),(341991,9500,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(341992,9500,'ms','Kategori bagi pengenalpastian transaksi',0),(341993,9500,'ar','ÙØ¦Ø§Øª Ù„Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø©',0),(341994,9500,'fr','CatÃ©gories pour lâ€™identificateur de Transaction',0),(341995,9500,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è­˜åˆ¥å­ã®ã‚«ãƒ†ã‚´ãƒª',0),(341996,9500,'pt','Categorias para identificador de transaÃ§Ã£o',0),(341997,9500,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð´Ð»Ñ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(341998,9500,'es','CategorÃ­as para Identificador de Transacciones',0),(341999,9500,'de','Kategorien fÃ¼r Transaktions-ID',0),(342000,9500,'en','Categories for Transaction Identifier',0),(342001,9501,'is','',0),(342002,9501,'dr','Ø´Ø±Ø­ Ú¯Ø±ÙˆÙ‡',0),(342003,9501,'pr','Ø´Ø±Ø­ Ú¯Ø±ÙˆÙ‡',0),(342004,9501,'tr','Kategori aÃ§Ä±klamasÄ±',0),(342005,9501,'pl','Opis kategorii',0),(342006,9501,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(342007,9501,'ur','Ø²Ù…Ø±Û ØªÙØµÛŒÙ„',0),(342008,9501,'sr','ÐžÐ¿Ð¸Ñ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(342009,9501,'vi','MÃ´ táº£ thá»ƒ loáº¡i',0),(342010,9501,'af','Kategorie Beskrywing',0),(342011,9501,'ro','Descriere categorie',0),(342012,9501,'et','Kategooria kirjeldus',0),(342013,9501,'si','Kategorija opis',0),(342014,9501,'ba','Deskripsi Kategori',0),(342015,9501,'nl','Categoriebeschrijving',0),(342016,9501,'fi','Luokan kuvaus',0),(342017,9501,'no','Kategoribeskrivelse',0),(342018,9501,'da','Kategoribeskrivelse',0),(342019,9501,'ko','ì¹´í…Œê³ ë¦¬ ì„¤ëª…',0),(342020,9501,'he','×ª×™××•×¨ ×§×˜×’×•×¨×™×™×ª',0),(342021,9501,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚',0),(342022,9501,'zh','åˆ†ç±»æè¿°\r\n',0),(342023,9501,'sv','Kategoribeskrivning',0),(342024,9501,'it','Descrizione della categoria',0),(342025,9501,'tl','',0),(342026,9501,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(342027,9501,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤µà¤¿à¤µà¤°à¤£',0),(342028,9501,'ms','Perihalan kategori',0),(342029,9501,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„ØªØµÙ†ÙŠÙ',0),(342030,9501,'fr','Description de la catÃ©gorie',0),(342031,9501,'jp','ã‚«ãƒ†ã‚´ãƒªã®èª¬æ˜Ž',0),(342032,9501,'pt','DescriÃ§Ã£o da categoria',0),(342033,9501,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(342034,9501,'es','DescripciÃ³n de CategorÃ­a',0),(342035,9501,'de','Kategorie-Beschreibung',0),(342036,9501,'en','Category Description',0),(342037,9502,'is','',0),(342038,9502,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ú¯Ø±ÙˆÙ‡',0),(342039,9502,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ú¯Ø±ÙˆÙ‡',0),(342040,9502,'tr','Kategori iÅŸlem tanÄ±mlayÄ±cÄ±sÄ±',0),(342041,9502,'pl','Kategoria identyfikator transakcji',0),(342042,9502,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(342043,9502,'ur','Ø²Ù…Ø±Û Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø´Ù†Ø§Ø®Øª Ú©Ù†Ù†Ø¯Û',0),(342044,9502,'sr','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(342045,9502,'vi','XÃ¡c nháº­n thá»ƒ loáº¡i giao dá»‹ch',0),(342046,9502,'af','Kategorie transaksie identifiseerder',0),(342047,9502,'ro','Identificatorul de tranzacÅ£ie categorie',0),(342048,9502,'et','Kategooria tehingutunnus',0),(342049,9502,'si','Identifikator kategorije transakcij',0),(342050,9502,'ba','Kategori transaksi pengenal',0),(342051,9502,'nl','Categorie transactie-id',0),(342052,9502,'fi','Luokka tapahtuman tunnus',0),(342053,9502,'no','Kategori transaksjons-ID',0),(342054,9502,'da','Kategori Transaction ID',0),(342055,9502,'ko','ì¹´í…Œê³ ë¦¬ íŠ¸ëžœìž­ì…˜ ì‹ë³„ìž',0),(342056,9502,'he','×ž×–×”×” ×”×˜×¨× ×–×§×¦×™×” ×§×˜×’×•×¨×™×”',0),(342057,9502,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(342058,9502,'zh','åˆ†ç±»äº¤æ˜“æ ‡è¯†\r\n',0),(342059,9502,'sv','Kategori transaktionen identifierare',0),(342060,9502,'it','Identificatore di transazione di categoria',0),(342061,9502,'tl','',0),(342062,9502,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3607;&#3637;&#3656;&#3619;&#3632;&#3610;&#3640;',0),(342063,9502,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾',0),(342064,9502,'ms','Pengenal pasti kategori urus niaga',0),(342065,9502,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø© Ø§Ù„ÙØ¦Ø©',0),(342066,9502,'fr','Identificateur de Transaction de catÃ©gorie',0),(342067,9502,'jp','ã‚«ãƒ†ã‚´ãƒªã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è­˜åˆ¥å­',0),(342068,9502,'pt','Identificador de transaÃ§Ã£o da categoria',0),(342069,9502,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(342070,9502,'es','Identificador de Transacciones de CategorÃ­a',0),(342071,9502,'de','Kategorie-Transaktions-ID',0),(342072,9502,'en','Category Transaction Identifier',0),(342073,9503,'is','',0),(342074,9503,'dr','Ù†ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(342075,9503,'pr','Ù†ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(342076,9503,'tr','Maliyet tÃ¼rÃ¼',0),(342077,9503,'pl','Typ kosztu',0),(342078,9503,'bg','Ð’Ð¸Ð´ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(342079,9503,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ù‚Ø³Ù…',0),(342080,9503,'sr','Ð’Ñ€ÑÑ‚Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(342081,9503,'vi','Loáº¡i giÃ¡ thÃ nh',0),(342082,9503,'af','Koste Tipe',0),(342083,9503,'ro','Tip de cost',0),(342084,9503,'et','Kulu liik',0),(342085,9503,'si','Vrsta stroÅ¡ka',0),(342086,9503,'ba','Jenis biaya',0),(342087,9503,'nl','Kosten Type',0),(342088,9503,'fi','Kustannustyypin',0),(342089,9503,'no','Kostnader Type',0),(342090,9503,'da','Omkostninger Type',0),(342091,9503,'ko','ë¹„ìš©',0),(342092,9503,'he','×¡×•×’ ×¢×œ×•×ª',0),(342093,9503,'el','Î•Î¯Î´Î¿Ï‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(342094,9503,'zh','æˆæœ¬ç±»åž‹\r\n',0),(342095,9503,'sv','Kostnadstyp',0),(342096,9503,'it','Tipo di costo',0),(342097,9503,'tl','',0),(342098,9503,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(342099,9503,'hi','à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(342100,9503,'ms','Jenis kos',0),(342101,9503,'ar','Ù†ÙˆØ¹ Ø§Ù„ØªÙƒÙ„ÙØ©',0),(342102,9503,'fr','Type de coÃ»t',0),(342103,9503,'jp','ã‚³ã‚¹ãƒˆã®ç¨®é¡ž',0),(342104,9503,'pt','Tipo de custo',0),(342105,9503,'ru','Ð¢Ð¸Ð¿ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(342106,9503,'es','Tipo de Costo',0),(342107,9503,'de','Kostenart',0),(342108,9503,'en','Cost Type',0),(342109,9504,'is','',0),(342110,9504,'dr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª',0),(342111,9504,'pr','Ú†Ø§Ù¾ Ù„ÙŠØ³Øª',0),(342112,9504,'tr','Listesini yazdÄ±r',0),(342113,9504,'pl','Drukuj listÄ™',0),(342114,9504,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(342115,9504,'ur','ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(342116,9504,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ',0),(342117,9504,'vi','Danh sÃ¡ch in',0),(342118,9504,'af','Druk Lys',0),(342119,9504,'ro','Lista de imprimare',0),(342120,9504,'et','Prindi loend',0),(342121,9504,'si','Tiskanje seznama',0),(342122,9504,'ba','Mencetak daftar',0),(342123,9504,'nl','Lijst afdrukken',0),(342124,9504,'fi','Tulosta luettelo',0),(342125,9504,'no','Skriv ut liste',0),(342126,9504,'da','Udskrive liste',0),(342127,9504,'ko','ëª©ë¡ ì¸ì‡„',0),(342128,9504,'he','×”×“×¤×¡ ×¨×©×™×ž×”',0),(342129,9504,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚',0),(342130,9504,'zh','æ‰“å°åˆ—è¡¨\r\n',0),(342131,9504,'sv','Skriva ut en lista',0),(342132,9504,'it','Elenco di stampa',0),(342133,9504,'tl','',0),(342134,9504,'th','&#3614;&#3636;&#3617;&#3614;&#3660;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(342135,9504,'hi','à¤¸à¥‚à¤šà¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(342136,9504,'ms','Cetak senarai',0),(342137,9504,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(342138,9504,'fr','Imprimer la liste',0),(342139,9504,'jp','ãƒªã‚¹ãƒˆã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(342140,9504,'pt','Imprimir lista',0),(342141,9504,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¡Ð¿Ð¸ÑÐºÐ°',0),(342142,9504,'es','Lista de ImpresiÃ³n',0),(342143,9504,'de','Druckliste',0),(342144,9504,'en','Print List',0),(342145,9505,'is','',0),(342146,9505,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ú¯Ø±ÙˆÙ‡  Ø§Ù†ÙˆØ§Ø¹ Ù‡Ø²ÙŠÙ†Ù‡',0),(342147,9505,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ú¯Ø±ÙˆÙ‡  Ø§Ù†ÙˆØ§Ø¹ Ù‡Ø²ÙŠÙ†Ù‡',0),(342148,9505,'tr','Kategori iÅŸlem tanÄ±mlayÄ±cÄ± maliyet tÃ¼rleri',0),(342149,9505,'pl','Kategoria typÃ³w kosztÃ³w identyfikator transakcji',0),(342150,9505,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð²Ð¸Ð´Ð¾Ð²Ðµ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(342151,9505,'ur','Ø²Ù…Ø±Û Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ø´Ù†Ø§Ø®Øª Ú©Ù†Ù†Ø¯Û Ù‚ÛŒÙ…Øª Ø§Ù‚Ø³Ø§Ù…',0),(342152,9505,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð²Ñ€ÑÑ‚Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(342153,9505,'vi','Loáº¡i chi phÃ­ cá»§a thá»ƒ loáº¡i giao dá»‹ch ',0),(342154,9505,'af','Kategorie Transaksie Identifiseerder Koste Tipe',0),(342155,9505,'ro','Categorie tranzactie identificator Cost tipuri',0),(342156,9505,'et','Kategooria tunnus kulu tÃ¼Ã¼bid',0),(342157,9505,'si','Kategorije stroÅ¡kov vrste transakcije identifikator',0),(342158,9505,'ba','Kategori transaksi pengenal biaya jenis',0),(342159,9505,'nl','Categorie transactiesoorten id kosten',0),(342160,9505,'fi','Luokan tunnus kustannusten tapahtumatyypit',0),(342161,9505,'no','Kategori ID kostnader typer',0),(342162,9505,'da','Kategori Transaction ID pristyper',0),(342163,9505,'ko','ì¹´í…Œê³ ë¦¬ íŠ¸ëžœìž­ì…˜ ì‹ë³„ìž ë¹„ìš©ëœ ì¢…ë¥˜',0),(342164,9505,'he','×§×˜×’×•×¨×™×” ×”×ž×–×”×” ×¡×•×’×™ ×ª× ×•×¢×•×ª ×¢×œ×•×ª',0),(342165,9505,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï„ÏÏ€Ï‰Î½ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½',0),(342166,9505,'zh','åˆ†ç±»äº¤æ˜“æˆæœ¬ç±»åž‹æ ‡è¯†ç¬¦\r\n',0),(342167,9505,'sv','Kategori-ID kostnad transaktionstyper',0),(342168,9505,'it','Categoria tipi costo di transazione identificatore',0),(342169,9505,'tl','',0),(342170,9505,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3607;&#3637;&#3656;&#3619;&#3632;&#3610;&#3640;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3',0),(342171,9505,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾ à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(342172,9505,'ms','Kategori urus niaga pengenalpastian jenis kos',0),(342173,9505,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø¹Ø±Ù Ù…Ø¹Ø§Ù…Ù„Ø© Ø§Ù„ÙØ¦Ø©',0),(342174,9505,'fr','Types de coÃ»ts identificateur catÃ©gorie de transactions',0),(342175,9505,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è­˜åˆ¥å­ã‚³ã‚¹ãƒˆ ã‚¿ã‚¤ãƒ—',0),(342176,9505,'pt','Tipos de custo identificador de transaÃ§Ã£o da categoria',0),(342177,9505,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ð¸Ð¿Ñ‹ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(342178,9505,'es','Tipos de Costo de Identificador de Transacciones de CategorÃ­a',0),(342179,9505,'de','Kategorie-ID Kosten Buchungsarten',0),(342180,9505,'en','Category Transaction Identifier Cost Types',0),(342181,9506,'is','',0),(342182,9506,'dr','Ø´Ø±Ø­ Ù†ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(342183,9506,'pr','Ø´Ø±Ø­ Ù†ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(342184,9506,'tr','Maliyet tÃ¼rÃ¼ aÃ§Ä±klamasÄ±',0),(342185,9506,'pl','Opis rodzaju kosztÃ³w',0),(342186,9506,'bg','Ð’Ð¸Ð´ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(342187,9506,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(342188,9506,'sr','ÐžÐ¿Ð¸Ñ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð²Ñ€ÑÑ‚Ðµ',0),(342189,9506,'vi','Diá»…n giáº£i loáº¡i giÃ¡ thÃ nh',0),(342190,9506,'af','Koste Tipe Beskrywing',0),(342191,9506,'ro','Cost tip Descriere',0),(342192,9506,'et','Kulu liik kirjeldus',0),(342193,9506,'si','Vrsta stroÅ¡ka opis',0),(342194,9506,'ba','Jenis biaya Deskripsi',0),(342195,9506,'nl','Kosten Type Beschrijving',0),(342196,9506,'fi','Kustannukset tyypin kuvaus',0),(342197,9506,'no','Kostnader beskrivelsen',0),(342198,9506,'da','Omkostninger Type beskrivelse',0),(342199,9506,'ko','ë¹„ìš© ì„¤ëª…',0),(342200,9506,'he','×ª×™××•×¨ ×©×œ ×¡×•×’ ×¢×œ×•×ª',0),(342201,9506,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Ï„ÏÏ€Î¿Ï… Ï„Î¿Ï… ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(342202,9506,'zh','æˆæœ¬ç±»åž‹è¯´æ˜Ž\r\n',0),(342203,9506,'sv','Kostnadstyp Beskrivning',0),(342204,9506,'it','Descrizione del tipo di costo',0),(342205,9506,'tl','',0),(342206,9506,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(342207,9506,'hi','à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤µà¤¿à¤µà¤°à¤£',0),(342208,9506,'ms','Perihalan jenis kos',0),(342209,9506,'ar','ÙˆØµÙ Ù†ÙˆØ¹ Ø§Ù„ØªÙƒÙ„ÙØ©',0),(342210,9506,'fr','Description du Type de coÃ»t',0),(342211,9506,'jp','ã‚³ã‚¹ãƒˆã®ç¨®é¡žã®èª¬æ˜Ž',0),(342212,9506,'pt','DescriÃ§Ã£o do tipo de custo',0),(342213,9506,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð° Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(342214,9506,'es','DescripciÃ³n de Tio de Costo',0),(342215,9506,'de','Kostenart Beschreibung',0),(342216,9506,'en','Cost Type Description',0),(342217,9507,'is','',0),(342218,9507,'dr','Ø´ØºÙ„ ÙƒØ¯Ù‡Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ø§ÙŠ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(342219,9507,'pr','Ø´ØºÙ„ ÙƒØ¯Ù‡Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ø§ÙŠ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(342220,9507,'tr','Ä°ÅŸ kodlarÄ± iÅŸlem tanÄ±mlayÄ±cÄ±sÄ± iÃ§in maliyet. ',0),(342221,9507,'pl','Pracy kosztÃ³w kodÃ³w dla identyfikatora transakcji ',0),(342222,9507,'bg','Ð¡ÐµÐ±ÐµÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸Ñ‚Ðµ ÐºÐ¾Ð´Ð¾Ð²Ðµ Ð·Ð° Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ ',0),(342223,9507,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ø±Ù…ÙˆØ² Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ø´Ù†Ø§Ø®Øª Ú©Ù†Ù†Ø¯Û Ú©Û’ Ù„Ø¦Û’ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ Û” ',0),(342224,9507,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ ÐºÐ¾Ð´Ð¾Ð²Ðµ Ð·Ð° Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ',0),(342225,9507,'vi','MÃ£ giÃ¡ thÃ nh Job Ä‘á»ƒ nháº­n biáº¿t giao dá»‹ch',0),(342226,9507,'af','Werkstuk Koste Kodes vir Transaksie Identifiseerder',0),(342227,9507,'ro','Job Costa coduri pentru identificatorul de tranzacÅ£ie ',0),(342228,9507,'et','TÃ¶Ã¶ kulu koodid tehingu identifikaator ',0),(342229,9507,'si','Projektnih stroÅ¡kov kode za identifikator posla ',0),(342230,9507,'ba','Pekerjaan biaya kode untuk transaksi pengenal ',0),(342231,9507,'nl','Baan kosten Codes voor transactie-id ',0),(342232,9507,'fi','TyÃ¶ maksaa koodit tapahtuman tunnus ',0),(342233,9507,'no','Jobben koster koder for transaksjons-ID ',0),(342234,9507,'da','Job koste koder for transaktions-id ',0),(342235,9507,'ko','ìž‘ì—… ë¹„ìš© ì½”ë“œ íŠ¸ëžœìž­ì…˜ ì‹ë³„ìžì— ëŒ€ í•œ ',0),(342236,9507,'he','×”×¢×‘×•×“×” ×¢×•×œ×” ×§×•×“×™ ×¢×‘×•×¨ ×ž×–×”×” ×”×˜×¨× ×–×§×¦×™×” ',0),(342237,9507,'el','Î•ÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚ Î³Î¹Î± Ï„Î¿ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚ ',0),(342238,9507,'zh','å¯¹äº¤æ˜“æˆæœ¬ä»£ç æ ‡è¯†å·¥ä½œ\r\n',0),(342239,9507,'sv','Jobbet kostar koder fÃ¶r transaktion-ID. ',0),(342240,9507,'it','I codici dei costi lavoro per identificatore di transazione ',0),(342241,9507,'tl','',0),(342242,9507,'th','&#3619;&#3627;&#3633;&#3626;&#3591;&#3634;&#3609;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3637;&#3656;&#3619;&#3632;&#3610;&#3640;',0),(342243,9507,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‹à¤¡ à¤²à¤¾à¤—à¤¤ ',0),(342244,9507,'ms','Kerja kos kod Pengenal pasti urus niaga ',0),(342245,9507,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø±Ù…ÙˆØ² Ø§Ù„ØªÙƒÙ„ÙØ© Ù„Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø© ',0),(342246,9507,'fr','Codes de coÃ»t de travail pour lâ€™identificateur de Transaction ',0),(342247,9507,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è­˜åˆ¥å­ã®ä»•äº‹ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰',0),(342248,9507,'pt','Trabalho custou cÃ³digos para identificador de transaÃ§Ã£o ',0),(342249,9507,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ð´Ñ‹ Ð´Ð»Ñ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ ',0),(342250,9507,'es','CÃ³digos de Costo de Trabajo para Identificador de Transacciones ',0),(342251,9507,'de','Job Kosten Codes fÃ¼r Transaktions-ID ',0),(342252,9507,'en','Job Cost Codes for Transaction Identifier ',0),(342253,9508,'is','',0),(342254,9508,'dr','Ø´Ø±Ø­ Ø´ØºÙ„ ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(342255,9508,'pr','Ø´Ø±Ø­ Ø´ØºÙ„ ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(342256,9508,'tr','Ä°ÅŸ maliyet kodu tanÄ±mÄ±',0),(342257,9508,'pl','Kod Opis kosztÃ³w zleceÅ„',0),(342258,9508,'bg','Ð¡ÐµÐ±ÐµÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸Ñ‚Ðµ ÐºÐ¾Ð´ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(342259,9508,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©ÙˆÚˆ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(342260,9508,'sr','ÐžÐ¿Ð¸Ñ ÑˆÐ¸Ñ„Ñ€Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(342261,9508,'vi','MÃ´ táº£ mÃ£ giÃ¡ thÃ nh Job',0),(342262,9508,'af','Projekkoste Kode Beskrywing',0),(342263,9508,'ro','Cost codul postului',0),(342264,9508,'et','TÃ¶Ã¶ kulu kirjeldus',0),(342265,9508,'si','Projektnih stroÅ¡kov Å¡ifra opis',0),(342266,9508,'ba','Deskripsi kode biaya pekerjaan',0),(342267,9508,'nl','Kosten Code functieomschrijving',0),(342268,9508,'fi','Kustannusten kuvaus',0),(342269,9508,'no','Jobben koster beskrivelse',0),(342270,9508,'da','Pris kode jobbeskrivelse',0),(342271,9508,'ko','ìž‘ì—… ë¹„ìš©ëœ ì½”ë“œ ì„¤ëª…',0),(342272,9508,'he','×ª×™××•×¨ ×§×•×“ ×¢×œ×•×ª ×”×¢×‘×•×“×”',0),(342273,9508,'el','Î•ÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(342274,9508,'zh','ä½œä¸šæˆæœ¬ä»£ç è¯´æ˜Ž\r\n',0),(342275,9508,'sv','Jobbet kostar kodbeskrivning',0),(342276,9508,'it','Descrizione codice di costo del lavoro',0),(342277,9508,'tl','',0),(342278,9508,'th','&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3619;&#3627;&#3633;&#3626;&#3591;&#3634;&#3609;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(342279,9508,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(342280,9508,'ms','Penghuraian Kod kos kerja',0),(342281,9508,'ar','ÙˆØµÙ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© ØªÙƒÙ„ÙØ© Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(342282,9508,'fr','CoÃ»t Code Description',0),(342283,9508,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã®ä»•äº‹ã®èª¬æ˜Ž',0),(342284,9508,'pt','DescriÃ§Ã£o do cÃ³digo de custo de trabalho',0),(342285,9508,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐºÐ¾Ð´Ð°',0),(342286,9508,'es','DescripciÃ³n de CÃ³digo de Costo de Trabajo',0),(342287,9508,'de','Kostencode Stellenbeschreibung',0),(342288,9508,'en','Job Cost Code Description',0),(342289,9509,'is','',0),(342290,9509,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(342291,9509,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(342292,9509,'tr','Maliyet kodu iÅŸlem tanÄ±mlayÄ±cÄ±sÄ±',0),(342293,9509,'pl','Identyfikator transakcji kodem kosztÃ³w',0),(342294,9509,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÐºÐ¾Ð´ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(342295,9509,'ur','Ù‚ÛŒÙ…Øª Ú©ÙˆÚˆ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø´Ù†Ø§Ø®Øª Ú©Ù†Ù†Ø¯Û',0),(342296,9509,'sr','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð¨Ð¸Ñ„Ñ€Ð°',0),(342297,9509,'vi','MÃ£ giÃ¡ thÃ nh nháº­n biáº¿t giao dá»‹ch',0),(342298,9509,'af','Koste Kodes vir Transaksie Identifiseerder',0),(342299,9509,'ro','Identificatorul de tranzacÅ£ie cod de cost',0),(342300,9509,'et','Kulu tehingu identifikaator',0),(342301,9509,'si','StroÅ¡kovno kodo transakcije identifikator',0),(342302,9509,'ba','Kode biaya transaksi pengenal',0),(342303,9509,'nl','Kosten Code transactie-id',0),(342304,9509,'fi','Kustannuskoodi tapahtuman tunnus',0),(342305,9509,'no','Pris kode transaksjons-ID',0),(342306,9509,'da','Pris kode Transaction ID',0),(342307,9509,'ko','ë¹„ìš©ëœ ì½”ë“œ íŠ¸ëžœìž­ì…˜ ì‹ë³„ìž',0),(342308,9509,'he','×§×•×“ ×¢×œ×•×ª ×ž×–×”×” ×”×˜×¨× ×–×§×¦×™×”',0),(342309,9509,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ± Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(342310,9509,'zh','æˆæœ¬ä»£ç äº¤æ˜“æ ‡è¯†\r\n',0),(342311,9509,'sv','Kostnad kod transaktionen identifierare',0),(342312,9509,'it','Identificatore di transazione codice di costo',0),(342313,9509,'tl','',0),(342314,9509,'th','&#3619;&#3627;&#3633;&#3626;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;&#3607;&#3637;&#3656;&#3619;&#3632;&#3610;&#3640;',0),(342315,9509,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾',0),(342316,9509,'ms','Kod kos transaksi pengenalpastian',0),(342317,9509,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø© ÙƒÙˆØ¯ Ø§Ù„ØªÙƒÙ„ÙØ©',0),(342318,9509,'fr','CoÃ»t Code identificateur de Transaction',0),(342319,9509,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è­˜åˆ¥å­',0),(342320,9509,'pt','Custo do cÃ³digo identificador de transaÃ§Ã£o',0),(342321,9509,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´Ð°',0),(342322,9509,'es','Identificador de Transacciones de CÃ³digo de Costo',0),(342323,9509,'de','Kostencode Transaktions-ID',0),(342324,9509,'en','Cost Code Transaction Identifier',0),(342325,9510,'is','',0),(342326,9510,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù‡Ø§ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(342327,9510,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù‡Ø§ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ',0),(342328,9510,'tr','Ä°ÅŸlem tanÄ±mlayÄ±cÄ±larÄ± hakkÄ±nda genel bilgi',0),(342329,9510,'pl','OgÃ³lne informacje dotyczÄ…ce identyfikatorÃ³w transakcji',0),(342330,9510,'bg','ÐžÐ±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸ÑÑ‚Ð° Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð¸',0),(342331,9510,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø´Ù†Ø§Ø®Øª Ú©Û’ Ø¨Ø§Ø±Û’ Ù…ÛŒÚº Ø¹Ø§Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(342332,9510,'sr','ÐžÐ¿ÑˆÑ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð¸Ð¼Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(342333,9510,'vi','ThÃ´ng tin chung vá» cÃ¡c giao dá»‹ch Ä‘Ã£ nháº­n dáº¡ng',0),(342334,9510,'af','Algemene Informasie Omtrent Transaksie Identifiseerders',0),(342335,9510,'ro','InformaÅ£ii generale despre identificatori de tranzactie',0),(342336,9510,'et','Ãœldine teave tehingu tunnused',0),(342337,9510,'si','SploÅ¡ne informacije o identifikatorjih transakcije',0),(342338,9510,'ba','Informasi umum tentang transaksi pengenal',0),(342339,9510,'nl','Algemene informatie over transactie-id',0),(342340,9510,'fi','YleisiÃ¤ tietoja tapahtuman tunnukset',0),(342341,9510,'no','Generell informasjon om transaksjonen identifikatorer',0),(342342,9510,'da','Generelle oplysninger om transaktions-id\'er',0),(342343,9510,'ko','íŠ¸ëžœìž­ì…˜ ì‹ë³„ìžì— ëŒ€ í•œ ì¼ë°˜ ì •ë³´',0),(342344,9510,'he','×ž×™×“×¢ ×›×œ×œ×™ ×œ×’×‘×™ ×ž×–×”×™ ×˜×¨× ×–×§×¦×™×•×ª',0),(342345,9510,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î± Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®',0),(342346,9510,'zh','ä¸€èˆ¬ä¿¡æ¯äº‹åŠ¡æ ‡è¯†\r\n',0),(342347,9510,'sv','AllmÃ¤n Information om transaktionen identifierare',0),(342348,9510,'it','Informazioni generali sugli identificatori di transazione',0),(342349,9510,'tl','',0),(342350,9510,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3585;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3619;&#3632;&#3610;&#3',0),(342351,9510,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤¬à¤¾à¤°à¥‡ à¤®à¥‡à¤‚ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(342352,9510,'ms','Maklumat umum tentang pengenalan transaksi',0),(342353,9510,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø© Ø­ÙˆÙ„ Ù…Ø¹Ø±ÙØ§Øª Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(342354,9510,'fr','Informations gÃ©nÃ©rales sur les identificateurs de Transaction',0),(342355,9510,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è­˜åˆ¥å­ã«é–¢ã™ã‚‹ä¸€èˆ¬çš„ãªæƒ…å ±',0),(342356,9510,'pt','InformaÃ§Ãµes gerais sobre identificadores de transaÃ§Ã£o',0),(342357,9510,'ru','ÐžÐ±Ñ‰Ð¸Ðµ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾Ð± Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð°Ñ… Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹',0),(342358,9510,'es','InformaciÃ³n General Sobre Identificador de Transacciones ',0),(342359,9510,'de','Allgemeine Informationen zur Transaktion-IDs',0),(342360,9510,'en','General Information About Transaction Identifiers',0),(342361,9511,'is','',0),(342362,9511,'dr','Ø¢ÙŠØ§ Ú¯Ø±ÙˆÙ‡ ÙŠÙƒ ÙÙŠÙ„Ø¯ ÙˆØ±ÙˆØ¯ Ø¶Ø±ÙˆØ±ÙŠ Ø¯Ø§Ø±Ø¯ ØŸ',0),(342363,9511,'pr','Ø¢ÙŠØ§ Ú¯Ø±ÙˆÙ‡ ÙŠÙƒ ÙÙŠÙ„Ø¯ ÙˆØ±ÙˆØ¯ Ø¶Ø±ÙˆØ±ÙŠ Ø¯Ø§Ø±Ø¯ ØŸ',0),(342364,9511,'tr','Kategori gerekli giriÅŸi alanÄ± yer',0),(342365,9511,'pl','Jest kategoria pole wymagane',0),(342366,9511,'bg','Ð• ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¿Ð¾Ð»Ðµ',0),(342367,9511,'ur','Ø²Ù…Ø±Û Ø§ÛŒÚ© Ù…Ø·Ù„ÙˆØ¨Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù‚Ø·Ø¹Û ÛÛ’',0),(342368,9511,'sr','ÐŸÐ¾Ñ™Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(342369,9511,'vi','Thá»ƒ loáº¡i cÃ³ pháº£i lÃ  má»™t trÆ°á»ng nháº­p yÃªu cáº§u',0),(342370,9511,'af','Is Kategorie \'n Benodigde Inskrywingsveld',0),(342371,9511,'ro','Categoria este un cÃ¢mp de intrare necesar',0),(342372,9511,'et','Kategooria on nÃµutav kirje vÃ¤li',0),(342373,9511,'si','Kategorijo je potrebno vnosno polje',0),(342374,9511,'ba','Adalah kategori bidang catatan diperlukan',0),(342375,9511,'nl','Is categorie een vereist veld',0),(342376,9511,'fi','Onko luokka maahantuloa kenttÃ¤',0),(342377,9511,'no','Er kategori en nÃ¸dvendig feltet',0),(342378,9511,'da','Er kategori en pÃ¥krÃ¦vet indtastningsfelt',0),(342379,9511,'ko','í•„ìˆ˜ ìž…ë ¥ í•„ë“œ ë²”ì£¼ëŠ”',0),(342380,9511,'he','×”×•× ×§×˜×’×•×¨×™×” ×©×“×” ×¢×¨×š × ×“×¨×©',0),(342381,9511,'el','Î•Î¯Î½Î±Î¹ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î­Î½Î± Ï€ÎµÎ´Î¯Î¿ Î±Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½Î· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·',0),(342382,9511,'zh','åˆ†ç±»æ˜¯éœ€è¦è¾“å…¥çš„å­—æ®µï¼Ÿ\r\n',0),(342383,9511,'sv','Ã„r en krÃ¤vs fÃ¤ltet',0),(342384,9511,'it','Ãˆ categoria un campo di ingresso richiesto',0),(342385,9511,'tl','',0),(342386,9511,'th','&#3648;&#3611;&#3655;&#3609;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(342387,9511,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤à¤• à¤†à¤µà¤¶à¥à¤¯à¤• à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤¹à¥ˆ',0),(342388,9511,'ms','Merupakan kategori bidang diperlukan kemasukan',0),(342389,9511,'ar','Ù‡Ùˆ Ø§Ù„ÙØ¦Ø© Ø­Ù‚Ù„ Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø·Ù„ÙˆØ¨',0),(342390,9511,'fr','Est un champ dâ€™entrÃ©e requis-catÃ©gorie',0),(342391,9511,'jp','å¿…é ˆå…¥åŠ›ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’ã‚«ãƒ†ã‚´ãƒªã«ã¯',0),(342392,9511,'pt','Ã‰ um campo de entrada obrigatÃ³ria a categoria',0),(342393,9511,'ru','Ð¯Ð²Ð»ÑÐµÑ‚ÑÑ Ð»Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¿Ð¾Ð»Ðµ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ Ð²Ð²Ð¾Ð´Ð°',0),(342394,9511,'es','Es CategorÃ­a un Campo de Entrada Requerido',0),(342395,9511,'de','Ein Mussfeld ist',0),(342396,9511,'en','Is Category a Required Entry Field',0),(342397,9512,'is','',0),(342398,9512,'dr','Ø¢ÙŠØ§ ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡  ÙŠÙƒ ÙÙŠÙ„Ø¯ ÙˆØ±ÙˆØ¯ Ø¶Ø±ÙˆØ±ÙŠ Ø¯Ø§Ø±Ø¯ ØŸ',0),(342399,9512,'pr','Ø¢ÙŠØ§ ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡  ÙŠÙƒ ÙÙŠÙ„Ø¯ ÙˆØ±ÙˆØ¯ Ø¶Ø±ÙˆØ±ÙŠ Ø¯Ø§Ø±Ø¯ ØŸ',0),(342400,9512,'tr','Gerekli giriÅŸ alan kodu mal \'s',0),(342401,9512,'pl','Jest koszt kodu pole wymagane',0),(342402,9512,'bg','Ð•, ÑÑ‚Ñ€ÑƒÐ²Ð° ÐºÐ¾Ð´ Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¿Ð¾Ð»Ðµ',0),(342403,9512,'ur','Ø§ÛŒÚ© Ù…Ø·Ù„ÙˆØ¨Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù‚Ø·Ø¹Û Ø¶Ø§Ø¨Ø·Û Ù„Ø§Ú¯Øª ÛÛ’',0),(342404,9512,'sr','ÐˆÐµ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ð¨Ð¸Ñ„Ñ€Ð° Ð¾Ð±Ð°Ð²ÐµÐ·Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ð¾Ñ™Ðµ',0),(342405,9512,'vi','MÃ£ giÃ¡ thÃ nh cÃ³ cáº§n 1 trÆ°á»ng nháº­p',0),(342406,9512,'af','Is Koste-kode \'n Benodigde Inskrywingsveld',0),(342407,9512,'ro','Este cod de Cost un cÃ¢mp de intrare necesar',0),(342408,9512,'et','Tippige vÃ¤ljal kood maksab',0),(342409,9512,'si','Je stroÅ¡ek kodo potrebno vnosno polje',0),(342410,9512,'ba','Kode biaya masuk diperlukan bidang',0),(342411,9512,'nl','Is Code kost een vereist veld',0),(342412,9512,'fi','On maksaa koodi pakollinen kenttÃ¤Ã¤n',0),(342413,9512,'no','Er kostnadskode en nÃ¸dvendig inntastingsfeltet',0),(342414,9512,'da','Er koste kode en pÃ¥krÃ¦vet indtastningsfelt',0),(342415,9512,'ko','ë¹„ìš© ì½”ë“œëŠ” í•„ìˆ˜ ìž…ë ¥ í•„ë“œ',0),(342416,9512,'he','×”×•× ×¢×œ×” ×§×•×“ ×©×“×” ×—×•×‘×” ×›× ×™×¡×”',0),(342417,9512,'el','Î•Î¯Î½Î±Î¹ ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î­Î½Î± Ï€ÎµÎ´Î¯Î¿ Î±Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½Î· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·',0),(342418,9512,'zh','æˆæœ¬ä»£ç æ˜¯éœ€è¦è¾“å…¥çš„å­—æ®µï¼Ÿ\r\n',0),(342419,9512,'sv','Ã„r Kostnadskod en krÃ¤vs fÃ¤ltet',0),(342420,9512,'it','Ãˆ il codice di costo un campo richiesto',0),(342421,9512,'tl','',0),(342422,9512,'th','&#3648;&#3611;&#3655;&#3609;&#3619;&#3627;&#3633;&#3626;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3657;&#3629;&#3617;&#3',0),(342423,9512,'hi','à¤•à¥‹à¤ˆ à¤†à¤µà¤¶à¥à¤¯à¤• à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤•à¥‹à¤¡ à¤²à¤¾à¤—à¤¤ à¤¹à¥ˆ',0),(342424,9512,'ms','Adalah kos kod bidang diperlukan kemasukan',0),(342425,9512,'ar','Ù‡Ùˆ ØªÙƒÙ„ÙØ© Ø±Ù…Ø² Ø­Ù‚Ù„ Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø·Ù„ÙˆØ¨',0),(342426,9512,'fr','Est le Code des coÃ»ts un champ dâ€™entrÃ©e requise',0),(342427,9512,'jp','å¿…é ˆå…¥åŠ›ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ ã‚³ãƒ¼ãƒ‰ã®ã‚³ã‚¹ãƒˆã¯ã€',0),(342428,9512,'pt','Ã‰ cÃ³digo de custos de um campo de entrada obrigatÃ³ria',0),(342429,9512,'ru','Ð­Ñ‚Ð¾ ÑÑ‚Ð¾Ð¸Ñ‚ ÐºÐ¾Ð´ Ð¿Ð¾Ð»Ñ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ Ð²Ð²Ð¾Ð´Ð°',0),(342430,9512,'es','Es CÃ³digo de Costo un Campo de Entrada Requerido',0),(342431,9512,'de','Code ein Mussfeld Kosten',0),(342432,9512,'en','Is Cost Code a Required Entry Field',0),(342433,9513,'is','',0),(342434,9513,'dr','Ø¢ÙŠØ§ Ø´ØºÙ„  ÙŠÙƒ ÙÙŠÙ„Ø¯ ÙˆØ±ÙˆØ¯ Ø¶Ø±ÙˆØ±ÙŠ Ø¯Ø§Ø±Ø¯ ØŸ',0),(342435,9513,'pr','Ø¢ÙŠØ§ Ø´ØºÙ„  ÙŠÙƒ ÙÙŠÙ„Ø¯ ÙˆØ±ÙˆØ¯ Ø¶Ø±ÙˆØ±ÙŠ Ø¯Ø§Ø±Ø¯ ØŸ',0),(342436,9513,'tr','Ä°ÅŸ gerekli giriÅŸi alanÄ± yer',0),(342437,9513,'pl','Jest zadanie wymagane pole',0),(342438,9513,'bg','Ð• Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¿Ð¾Ð»Ðµ',0),(342439,9513,'ur','Ú©Ø§Ù… Ø§ÛŒÚ© Ù…Ø·Ù„ÙˆØ¨Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù‚Ø·Ø¹Û ÛÛ’',0),(342440,9513,'sr','ÐŸÐ¾Ñ™Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ Ð¿Ð¾ÑÐ°Ð¾',0),(342441,9513,'vi','Job cÃ³ cáº§n 1 trÆ°á»ng nháº­p',0),(342442,9513,'af','Is Werkstuk \'n Benodigde Inskrywingsveld',0),(342443,9513,'ro','Este treaba un cÃ¢mp de intrare necesar',0),(342444,9513,'et','Tippige vÃ¤ljal on tÃ¶Ã¶',0),(342445,9513,'si','Je delo potrebno vnosno polje',0),(342446,9513,'ba','Apakah pekerjaan diperlukan Entry Field',0),(342447,9513,'nl','Is de baan een vereist veld',0),(342448,9513,'fi','Onko tyÃ¶ maahantuloa kenttÃ¤',0),(342449,9513,'no','Er jobben en nÃ¸dvendig feltet',0),(342450,9513,'da','Er Job en pÃ¥krÃ¦vet indtastningsfelt',0),(342451,9513,'ko','í•„ìˆ˜ ìž…ë ¥ í•„ë“œ ì§ì—…ì€',0),(342452,9513,'he','×”×•× ×¢×‘×•×“×” ×©×“×” ×¢×¨×š × ×“×¨×©',0),(342453,9513,'el','Î•Î¯Î½Î±Î¹ Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î­Î½Î± Ï€ÎµÎ´Î¯Î¿ Î±Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½Î· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·',0),(342454,9513,'zh','å·¥ä½œæ˜¯ä¸€ä¸ªéœ€è¦è¾“å…¥çš„å­—æ®µï¼Ÿ\r\n',0),(342455,9513,'sv','Ã„r jobbet en krÃ¤vs fÃ¤ltet',0),(342456,9513,'it','Ãˆ un campo di ingresso richiesto il lavoro',0),(342457,9513,'tl','',0),(342458,9513,'th','&#3648;&#3611;&#3655;&#3609;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3615;&#3636;&#3621;&#3604;&#3660;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(342459,9513,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‹à¤ˆ à¤†à¤µà¤¶à¥à¤¯à¤• à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤¹à¥ˆ',0),(342460,9513,'ms','Merupakan pekerjaan bidang diperlukan kemasukan',0),(342461,9513,'ar','Ù‡Ùˆ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø­Ù‚Ù„ Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø·Ù„ÙˆØ¨',0),(342462,9513,'fr','RelÃ¨ve un champ dâ€™entrÃ©e requise',0),(342463,9513,'jp','å¿…é ˆå…¥åŠ›ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã®ä»•äº‹ã¯ã€ã—ã¾ã™ã€‚',0),(342464,9513,'pt','Ã‰ um campo de entrada necessÃ¡rios para o trabalho',0),(342465,9513,'ru','Ð­Ñ‚Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð»Ñ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ Ð²Ð²Ð¾Ð´Ð°',0),(342466,9513,'es','Es Trabajo un Campo de Entrada Requerido',0),(342467,9513,'de','Ein Mussfeld ist',0),(342468,9513,'en','Is Job a Required Entry Field',0),(342469,9514,'is','',0),(342470,9514,'dr','Ø¨Ù„Ù‡ Ù‡Ù…ÙŠØ´Ù‡',0),(342471,9514,'pr','Ø¨Ù„Ù‡ Ù‡Ù…ÙŠØ´Ù‡',0),(342472,9514,'tr','Evet her zaman',0),(342473,9514,'pl','Tak zawsze',0),(342474,9514,'bg','Ð”Ð° Ð²Ð¸Ð½Ð°Ð³Ð¸',0),(342475,9514,'ur','ÛØ§Úº ÛÙ…ÛŒØ´Û',0),(342476,9514,'sr','Ð”Ð° ÑƒÐ²ÐµÐº',0),(342477,9514,'vi','LuÃ´ng CÃ³',0),(342478,9514,'af','Ja Altyd',0),(342479,9514,'ro','Da Ã®ntotdeauna',0),(342480,9514,'et','Jah alati',0),(342481,9514,'si','Ja vedno',0),(342482,9514,'ba','Ya selalu',0),(342483,9514,'nl','Ja altijd',0),(342484,9514,'fi','KyllÃ¤ aina',0),(342485,9514,'no','Ja alltid',0),(342486,9514,'da','Ja altid',0),(342487,9514,'ko','í•­ìƒ ì˜ˆ',0),(342488,9514,'he','×›×Ÿ ×ª×ž×™×“',0),(342489,9514,'el','ÎÎ±Î¹ Ï€Î¬Î½Ï„Î±',0),(342490,9514,'zh','æ˜¯ä¸€ç›´\r\n',0),(342491,9514,'sv','Ja alltid',0),(342492,9514,'it','SÃ¬ sempre',0),(342493,9514,'tl','',0),(342494,9514,'th','&#3651;&#3594;&#3656;&#3648;&#3626;&#3617;&#3629;',0),(342495,9514,'hi','à¤¹à¤¾à¤ à¤¹à¤®à¥‡à¤¶à¤¾',0),(342496,9514,'ms','Ya sentiasa',0),(342497,9514,'ar','Ù†Ø¹Ù… Ø¯Ø§Ø¦Ù…Ø§Ù‹',0),(342498,9514,'fr','Oui toujours',0),(342499,9514,'jp','å¸¸ã«ã¯ã„',0),(342500,9514,'pt','Sim sempre',0),(342501,9514,'ru','Ð”Ð°, Ð²ÑÐµÐ³Ð´Ð°',0),(342502,9514,'es','Si Siempre',0),(342503,9514,'de','Ja immer',0),(342504,9514,'en','Yes Always',0),(342505,9515,'is','',0),(342506,9515,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ø¨Ø±Ø§ÙŠ  Ø´Ù†Ø§Ø³Ù‡ Ù‡Ø§ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(342507,9515,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ø¨Ø±Ø§ÙŠ  Ø´Ù†Ø§Ø³Ù‡ Ù‡Ø§ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(342508,9515,'tr','Ä°ÅŸlem tanÄ±mlayÄ±cÄ±sÄ± iÃ§in genel bilgiler',0),(342509,9515,'pl','OgÃ³lne informacje dla identyfikatora transakcji',0),(342510,9515,'bg','ÐžÐ±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸ÑÑ‚Ð° Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(342511,9515,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ø´Ù†Ø§Ø®Øª Ú©Ù†Ù†Ø¯Û Ú©Û’ Ù„Ø¦Û’ Ø¹Ø§Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(342512,9515,'sr','ÐžÐ¿ÑˆÑ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(342513,9515,'vi','ThÃ´ng tin chung vá» cÃ¡c giao dá»‹ch Ä‘Ã£ nháº­n dáº¡ng',0),(342514,9515,'af','Algemene Informasie vir Transaksie Identifiseerder',0),(342515,9515,'ro','Informatii generale pentru identificatorul de tranzacÅ£ie',0),(342516,9515,'et','Ãœldist teavet tehingu identifikaator',0),(342517,9515,'si','SploÅ¡ne informacije za identifikator posla',0),(342518,9515,'ba','Informasi umum untuk transaksi pengenal',0),(342519,9515,'nl','Algemene informatie voor transactie-id',0),(342520,9515,'fi','YleistÃ¤ tietoa tapahtuman tunnus',0),(342521,9515,'no','Generell informasjon om transaksjons-ID',0),(342522,9515,'da','Generelle oplysninger om Transaction ID',0),(342523,9515,'ko','íŠ¸ëžœìž­ì…˜ ì‹ë³„ìžì— ëŒ€ í•œ ì¼ë°˜ ì •ë³´',0),(342524,9515,'he','×ž×™×“×¢ ×›×œ×œ×™ ×¢×‘×•×¨ ×ž×–×”×” ×”×˜×¨× ×–×§×¦×™×”',0),(342525,9515,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î¿ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(342526,9515,'zh','ä¸€èˆ¬çš„äº¤æ˜“ä¿¡æ¯æ ‡è¯†ç¬¦\r\n',0),(342527,9515,'sv','AllmÃ¤n Information fÃ¶r transaktionen identifierare',0),(342528,9515,'it','Informazioni generali per identificatore di transazione',0),(342529,9515,'tl','',0),(342530,9515,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3607;&#3633;&#3656;&#3623;&#3652;&#3611;&#3586;&#3629;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3619;&#3632;&#3610;&#3640;&#3605;&#3633;&#3623;&#3610;&#3640;&#3',0),(342531,9515,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(342532,9515,'ms','Maklumat umum untuk pengenalpastian transaksi',0),(342533,9515,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø© Ø¹Ù† Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø©',0),(342534,9515,'fr','Informations gÃ©nÃ©rales pour lâ€™identificateur de Transaction',0),(342535,9515,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³è­˜åˆ¥å­ã®ä¸€èˆ¬çš„ãªæƒ…å ±',0),(342536,9515,'pt','InformaÃ§Ãµes gerais para o identificador de transaÃ§Ã£o',0),(342537,9515,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð»Ñ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(342538,9515,'es','InformaciÃ³n General Sobre Identificador de TransacciÃ³n ',0),(342539,9515,'de','Allgemeine Informationen fÃ¼r Transaktions-ID',0),(342540,9515,'en','General Information for Transaction Identifier',0),(342541,9516,'is','',0),(342542,9516,'dr','Ù…Ù…Ø§Ù†Ø¹Øª Ø§Ø² Ø±ÙˆÙŠØª ÙØ§ÙƒØªÙˆØ±Ù‡Ø§  Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  ØªÙˆØ³Ø· ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†  Ø¨Ù‡ Ø¬Ø²  Ù…Ø§Ù„Ùƒ',0),(342543,9516,'pr','Ù…Ù…Ø§Ù†Ø¹Øª Ø§Ø² Ø±ÙˆÙŠØª ÙØ§ÙƒØªÙˆØ±Ù‡Ø§  Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†  ØªÙˆØ³Ø· ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†  Ø¨Ù‡ Ø¬Ø²  Ù…Ø§Ù„Ùƒ',0),(342544,9516,'tr','SipariÅŸler, faturalar, mÃ¼ÅŸteriler dÄ±ÅŸÄ±nda gÃ¶rmesini engelleme satÄ±cÄ± kendi',0),(342545,9516,'pl','Blok sprzedawczyni z widzÄ…c zamÃ³wieÅ„, faktur, klientÃ³w innych niÅ¼ wÅ‚asne',0),(342546,9516,'bg','Ð‘Ð»Ð¾Ðº Ñ‚ÑŠÑ€Ð³Ð¾Ð²Ñ†Ð¸ Ð²Ð¸Ð¶Ð´Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸, ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð¸ Ð¾Ñ‚ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð°',0),(342547,9516,'ur','Ø³ÙˆØ§ Ø¯ÛŒÚ©Ú¾ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§ØªØŒ Ú¯Ø§ÛÚ©ÙˆÚº Ø³Û’ Ø¨Ù„Ø§Ú© Ø³ÛŒÙ„Ø² Ú©Û’ Ù…Ø§Ù„Ú©',0),(342548,9516,'sr','Ð‘Ð»Ð¾Ðº Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð¸ Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸Ð¼ Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ, Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ, ÐºÑƒÐ¿Ñ†Ð¸ Ð¾ÑÐ¸Ð¼ Ñ‚Ð¾Ð³Ð° Ð²Ð»Ð°ÑÐ½Ð¸Ðº',0),(342549,9516,'vi','NhÃ¢n viÃªn kinh doanh chá»‰ Ä‘Æ°á»£c xem Ä‘Æ¡n hÃ ng, hÃ³a Ä‘Æ¡n, khÃ¡ch hÃ ng cá»§a mÃ¬nh.',0),(342550,9516,'af','Blokeer Verkoopspersone om Bestellings, Fakture, KliÃ«nte / Klante anders dan sy / haar eie te Besigtig',0),(342551,9516,'ro','Bloc vanzatorii la a vedea altele decÃ¢t comenzi, facturi, clienÅ£ii proprii',0),(342552,9516,'et','Block mÃ¼Ã¼gimehed nÃ¤ha tellimuste, arvete, kliendid kui enda',0),(342553,9516,'si','Blok prodajalci od videnje nalogi, raÄuni, razen lastne stranke',0),(342554,9516,'ba','Tutup Akses Penjual untuk melihat Pesanan dan Pelanggan kecuali milik sendiri',0),(342555,9516,'nl','Blok verkopers zien bestellingen, facturen, klanten, andere dan eigen',0),(342556,9516,'fi','Block myyntimiehet nÃ¤kemÃ¤stÃ¤ tilauksia, laskuja, asiakkaat kuin omaa',0),(342557,9516,'no','Blokkere selgere ser bestillinger, fakturaer, kunder enn eier',0),(342558,9516,'da','Blok sÃ¦lgere fra at se ordrer, fakturaer, kunder andre end ejer',0),(342559,9516,'ko','ì£¼ë¬¸, ì†¡ìž¥, ê³ ê° ì´ì™¸ì˜ ë³´ê³ ì—ì„œ ë¸”ë¡ íŒë§¤ì› ì†Œìœ ',0),(342560,9516,'he','×× ×©×™ ×ž×›×™×¨×•×ª ×‘×œ×•×§ ×œ×¨××•×ª ×”×–×ž× ×•×ª, ×—×©×‘×•× ×™×•×ª, ×œ×§×•×—×•×ª ××—×¨×™× ×ž××©×¨ ×”×‘×¢×œ×™×',0),(342561,9516,'el','ÎœÏ€Î»Î¿Îº Ï€Ï‰Î»Î·Ï„Î­Ï‚ Î±Ï€ÏŒ Ï„Î¿ Î½Î± Î´ÎµÎ¹ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚, Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±, Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÎºÎ±Ï„Î­Ï‡Î¿Ï…Î½ Î¬Î»Î»Î¿ Î±Ï€ÏŒ',0),(342562,9516,'zh','æŽ¨é”€å‘˜é™¤è‡ªå·±çš„è®¢å•ï¼Œå‘ç¥¨ï¼Œå®¢æˆ·å¤–æ— æ³•æŸ¥è¯¢å…¶ä»–\r\n',0),(342563,9516,'sv','Blocket fÃ¶rsÃ¤ljare frÃ¥n att se order, fakturor, kunder annat Ã¤n egna',0),(342564,9516,'it','Il proprietario blocco commessi da vedere altro che ordini, fatture, clienti',0),(342565,9516,'tl','',0),(342566,9516,'th','&#3610;&#3621;&#3655;&#3629;&#3585;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3607;&#3637;&#3656;&#3604;&#3641;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629; &#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657; &',0),(342567,9516,'hi','à¤¬à¥à¤²à¥‰à¤• à¤¸à¥‡à¤²à¥à¤¸à¤®à¥ˆà¤¨ à¤‘à¤°à¥à¤¡à¤°, à¤šà¤¾à¤²à¤¾à¤¨, à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤…à¤²à¤¾à¤µà¤¾ à¤…à¤¨à¥à¤¯ à¤¦à¥‡à¤–à¤¨à¥‡ à¤¸à¥‡ à¤¹à¥€',0),(342568,9516,'ms','Blok Salesmen daripada melihat pesanan, invois, pelanggan selain daripada memiliki',0),(342569,9516,'ar','ÙƒØªÙ„Ø© Ø§Ù„Ø¨Ø§Ø¹Ø© Ù…Ù† Ø±Ø¤ÙŠØ© Ø£ÙˆØ§Ù…Ø±ØŒ Ø§Ù„ÙÙˆØ§ØªÙŠØ±ØŒ ÙˆØºÙŠØ±Ù‡Ø§ Ù…Ù† Ø§Ù…ØªÙ„Ø§Ùƒ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(342570,9516,'fr','Vendeurs de bloc de voir les commandes, les factures, les clients autres que possÃ¨de',0),(342571,9516,'jp','è‡ªåˆ†ã®ä»¥å¤–ã®æ³¨æ–‡ã€è«‹æ±‚æ›¸ã€é¡§å®¢ã‚’è¦‹ã¦ã‹ã‚‰ãƒ–ãƒ­ãƒƒã‚¯ ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³',0),(342572,9516,'pt','Vendedores de bloco de ver encomendas, facturas, clientes, alÃ©m de possuir',0),(342573,9516,'ru','Ð—Ð°Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐŸÑ€Ð¾Ð´Ð°Ð²Ñ†Ð° ÐžÑ‚ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° ÐÐµ Ð¡Ð²Ð¾Ð¸Ñ… Ð—Ð°ÐºÐ°Ð·Ð¾Ð², Ð¡Ñ‡ÐµÑ‚Ð¾Ð², ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(342574,9516,'es','Bloquear Vendedores Para no Vean Pedidos, Facturas, Clientes Aparte de Sus Mismos',0),(342575,9516,'de','Block-VerkÃ¤ufer sehen, Bestellungen, Rechnungen, Kunden mit anderen als eigene',0),(342576,9516,'en','Block Salesmen From Seeing Orders, Invoices, Customers Other Than Own',0),(342577,9517,'is','',0),(342578,9517,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ÙŠØ¯ Ø¨Ù‡ ÙƒØ§Ø±Ø¨Ø± Ù…Ø´Ø®ØµÙŠ Ù¾ÙŠÙˆØ³Øª Ø´ÙˆØ¯',0),(342579,9517,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ÙŠØ¯ Ø¨Ù‡ ÙƒØ§Ø±Ø¨Ø± Ù…Ø´Ø®ØµÙŠ Ù¾ÙŠÙˆØ³Øª Ø´ÙˆØ¯',0),(342580,9517,'tr','SatÄ±cÄ± iÃ§in belirli kullanÄ±cÄ± eklenmelidir',0),(342581,9517,'pl','Sprzedawca musi byÄ‡ doÅ‚Ä…czony do okreÅ›lonego uÅ¼ytkownika',0),(342582,9517,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ‡ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸ ÐºÑŠÐ¼ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚ÐµÐ½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(342583,9517,'ur','Ø¨Ù†Ø§Ú©Ø± Ù…Ø®ØµÙˆØµ ØµØ§Ø±Ù Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ù†Ø³Ù„Ú© Ú©ÛŒØ§ Ø¬Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(342584,9517,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ† Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(342585,9517,'vi','NhÃ¢n viÃªn kinh doanh pháº£i gá»­i kÃ¨m cho ngÆ°á»i sá»­ dá»¥ng cá»¥ thá»ƒ',0),(342586,9517,'af','Verkoopspersoon moet verbind wees aan die spesifieke gebruiker',0),(342587,9517,'ro','VÃ¢nzÄƒtorul trebuie sÄƒ anexeze specifice utilizatorului',0),(342588,9517,'et','MÃ¼Ã¼gimees tuleb siduda konkreetse kasutaja',0),(342589,9517,'si','Prodajalec se priloÅ¾i doloÄenemu uporabniku',0),(342590,9517,'ba','Penjual harus dilampirkan ke pengguna tertentu',0),(342591,9517,'nl','Verkoper moet worden gekoppeld aan een specifieke gebruiker',0),(342592,9517,'fi','MyyjÃ¤ on liitettÃ¤vÃ¤ tietyn kÃ¤yttÃ¤jÃ¤n',0),(342593,9517,'no','Selger mÃ¥ knyttes til bestemt bruker',0),(342594,9517,'da','SÃ¦lger skal vÃ¦re knyttet til specifikke bruger',0),(342595,9517,'ko','ì„¸ì¼ì¦ˆ ë§¨ì€ íŠ¹ì • ì‚¬ìš©ìžì— ì—°ê²° í•´ì•¼ í•©ë‹ˆë‹¤.',0),(342596,9517,'he','×ž×›×™×¨×•×ª ×—×•×‘×” ×œ×¦×¨×£ ×ž×©×ª×ž×© ×¡×¤×¦×™×¤×™',0),(342597,9517,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹ÏƒÏ…Î½Î±Ï†Î¸ÎµÎ¯ ÏƒÏ„Î¿ ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(342598,9517,'zh','æŽ¨é”€å‘˜å¿…é¡»è¿žæŽ¥åˆ°ç‰¹å®šçš„ç”¨æˆ·\r\n',0),(342599,9517,'sv','SÃ¤ljare mÃ¥ste kopplas till specifika anvÃ¤ndare',0),(342600,9517,'it','Venditore deve essere collegato a utente specifico',0),(342601,9517,'tl','',0),(342602,9517,'th','&#3614;&#3609;&#3633;&#3585;&#3591;&#3634;&#3609;&#3586;&#3634;&#3618;&#3605;&#3657;&#3629;&#3591;&#3606;&#3641;&#3585;&#3649;&#3609;&#3610;&#3652;&#3611;&#3607;&#3637;&#3656;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3619;&#3632;&#3',0),(342603,9517,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤²à¤—à¥à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(342604,9517,'ms','Jurujual mestilah disertakan untuk pengguna khusus',0),(342605,9517,'ar','ÙŠØ¬Ø¨ Ø¥Ø±ÙØ§Ù‚ Ø¨Ø§Ø¦Ø¹ Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù…Ø¹ÙŠÙ†',0),(342606,9517,'fr','Vendeur doit Ãªtre attachÃ© Ã  lâ€™utilisateur spÃ©cifique',0),(342607,9517,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³ã¯ã€ç‰¹å®šã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«æŽ¥ç¶šã•ã‚Œã¦ã„ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(342608,9517,'pt','Vendedor deve ser anexado ao usuÃ¡rio especÃ­fico',0),(342609,9517,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ† Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð¿Ñ€Ð¸ÐºÑ€ÐµÐ¿Ð»ÐµÐ½ Ðº Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ð¾Ð¼Ñƒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŽ',0),(342610,9517,'es','Vendedores debe estar adjntados al usuarios especÃ­ficos',0),(342611,9517,'de','VerkÃ¤ufer muss bestimmten Benutzer zugeordnet werden',0),(342612,9517,'en','Salesman must be attached to specific user',0),(342613,9518,'is','',0),(342614,9518,'dr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± ØªØ§ÙŠÙŠØ¯ÙŠÙ‡  Ùˆ Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨',0),(342615,9518,'pr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± ØªØ§ÙŠÙŠØ¯ÙŠÙ‡  Ùˆ Ù„ÙŠØ³Øª Ø§Ù†ØªØ®Ø§Ø¨',0),(342616,9518,'tr','GÃ¶steri satÄ±ÅŸ temsilcisi iletiÅŸim bilgileri onay ve seÃ§im listesi Ã¼zerinde',0),(342617,9518,'pl','PokaÅ¼ informacje kontaktowe sprzedawcy na potwierdzenie & listy wyboru',0),(342618,9518,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ† ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ & ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(342619,9518,'ur','Ø´Ùˆ Ù¾Ø±Ø³Ù† Ø±Ø§Ø¨Ø·Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØµØ¯ÛŒÙ‚ & Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª Ù¾Ø±',0),(342620,9518,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñƒ Ñƒ ÑÐµÑ€Ð¸Ñ˜Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° Ð¸ Ð»Ð¸ÑÑ‚Ñƒ Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€',0),(342621,9518,'vi','Hiá»ƒn thá»‹ ThÃ´ng Tin liÃªn há»‡ nhÃ¢n viÃªn kinh doanh trÃªn danh sÃ¡ch xÃ¡c nháº­n nháº­n hÃ ng',0),(342622,9518,'af','Wys Verkoopspersoon Kontak Inligting op Bevestiging & \"*Pick\" Lys',0),(342623,9518,'ro','AratÄƒ de vÃ¢nzÄƒri informaÅ£ii de Contact pe confirmarea & Pick lista',0),(342624,9518,'et','NÃ¤ita mÃ¼Ã¼giisiku kontakti Info kinnitus & noppimisloend',0),(342625,9518,'si','PrikaÅ¾i prodajalca kontaktne informacije na potrditev & seznam',0),(342626,9518,'ba','Penjual Tampilkan Info kontak pada konfirmasi & memilih daftar',0),(342627,9518,'nl','Toon verkoper Contact Info op bevestiging & picklijst',0),(342628,9518,'fi','NÃ¤ytÃ¤ myyjÃ¤n yhteystiedot on vahvistus & poimintaluettelo',0),(342629,9518,'no','Vis selger kontaktinfo pÃ¥ bekreftelse & plukklisten',0),(342630,9518,'da','Vis sÃ¦lger kontakt Info pÃ¥ bekrÃ¦ftelse & plukliste',0),(342631,9518,'ko','í™•ì¸ ë° ì„ íƒ ëª©ë¡ì— í‘œì‹œ ì˜ì—… ì‚¬ì› ì—°ë½ì²˜ ì •ë³´',0),(342632,9518,'he','×¤×¨×˜×™ ×”×§×©×¨ ×©×œ ××™×© ×”×ž×›×™×¨×•×ª ×”×¦×’ ×¢×œ ××™×©×•×¨ & ×œ×‘×—×•×¨ ×¨×©×™×ž×”',0),(342633,9518,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Ï‰Î»Î·Ï„Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚ ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· & Î»Î¯ÏƒÏ„Î± ÏƒÏ…Î»Î»Î¿Î³Î®Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(342634,9518,'zh','æ˜¾ç¤ºç¡®è®¤ä¸Šçš„é”€å”®äººå‘˜çš„è”ç³»æ–¹å¼ç¡®è®¤å’ŒæŒ‘é€‰åå•\r\n',0),(342635,9518,'sv','Visa kontaktuppgifter sÃ¤ljare pÃ¥ bekrÃ¤ftelse & plocklistan',0),(342636,9518,'it','Informazioni di contatto del venditore Visualizza su conferma & lista di prelievo',0),(342637,9518,'tl','',0),(342638,9518,'th','&#3649;&#3626;&#3604;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3651;&#3609;&#3585;&#3634;&#3619;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3649;&#3621;&#3632;&#3',0),(342639,9518,'hi','à¤¶à¥‹ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ & à¤šà¤¯à¤¨ à¤¸à¥‚à¤šà¥€ à¤ªà¤°',0),(342640,9518,'ms','Papar maklumat kenalan jurujual pada pengesahan & memilih senarai',0),(342641,9518,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„ Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¹Ù„Ù‰ ØªØ£ÙƒÙŠØ¯ & Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ø¡',0),(342642,9518,'fr','Afficher les infos Contact vendeur sur Confirmation & liste de choix',0),(342643,9518,'jp','ç¢ºèªãƒ»é¸æŠžãƒªã‚¹ãƒˆã«é€£çµ¡å…ˆæƒ…å ±ã‚’å–¶æ¥­æ‹…å½“è€…',0),(342644,9518,'pt','Mostrar informaÃ§Ã£o de contato de vendedor na confirmaÃ§Ã£o & lista',0),(342645,9518,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½ÑƒÑŽ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð¾ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ð¸ & ÑÐ¿Ð¸ÑÐºÐ° Ð²Ñ‹Ð±Ð¾Ñ€Ð°',0),(342646,9518,'es','Muestra Info de Contacto de Vendedor en la Lista de ConfirmaciÃ³n y SelecciÃ³n',0),(342647,9518,'de','Kontakt Info VerkÃ¤ufer anzeigen auf BestÃ¤tigung & Auswahlliste',0),(342648,9518,'en','Show Salesperson Contact Info on Confirmation & Pick List',0),(342649,9519,'is','',0),(342650,9519,'dr','Ø§ØµÙ„Ø§Ø­Ø§Øª Ù…Ø¹ÙƒÙˆØ³ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒÙ„ÙŠ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø±Ø§ Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ø¨Ú¯ÙŠØ±Ø¯  Ùˆ Ø§Ø² Ù‚ÙŠÙ…Øª ÙˆØ§Ù‚Ø¹ÙŠ Ø¨Ù‡ Ø¬Ø§ÙŠ Ø¢Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†Ø¯ ',0),(342651,9519,'pr','Ø§ØµÙ„Ø§Ø­Ø§Øª Ù…Ø¹ÙƒÙˆØ³ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒÙ„ÙŠ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø±Ø§ Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ø¨Ú¯ÙŠØ±Ø¯  Ùˆ Ø§Ø² Ù‚ÙŠÙ…Øª ÙˆØ§Ù‚Ø¹ÙŠ Ø¨Ù‡ Ø¬Ø§ÙŠ Ø¢Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ ÙƒÙ†Ø¯ ',0),(342652,9519,'tr','Negatif ayarlamalar gÃ¶rmezden girilen toplam maliyet ve fiili maliyet yerine kullanmak',0),(342653,9519,'pl','Zignoruje wprowadzony caÅ‚kowity koszt i zamiast tego uÅ¼yÄ‡ rzeczywisty koszt korekty in-minus',0),(342654,9519,'bg','ÐžÑ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»Ð½Ð¸ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸ Ñ‰Ðµ Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸Ñ‚Ðµ Ð¾Ð±Ñ‰Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¸ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ Ð”Ð•Ð™Ð¡Ð¢Ð’Ð˜Ð¢Ð•Ð›ÐÐ˜ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð²Ð¼ÐµÑÑ‚Ð¾',0),(342655,9519,'ur','Ù…Ù†ÙÛŒ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ø¯Ø§Ø®Ù„ ÛÙˆ Ú©Ù„ Ù„Ø§Ú¯Øª Ú©Ùˆ Ù†Ø¸Ø± Ø§Ù†Ø¯Ø§Ø² Ú©Ø±Û’ Ú¯Ø§ Ø§ÙˆØ± Ø§Ø³ Ú©ÛŒ Ø§ØµÙ„ Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø¨Ø¬Ø§Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(342656,9519,'sr','ÐÐµÐ³Ð°Ñ‚Ð¸Ð²Ð½Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ñ›Ðµ Ð´Ð° Ð·Ð°Ð½ÐµÐ¼Ð°Ñ€Ð¸Ñ‚Ðµ ÑƒÐ½ÐµÑ‚Ðµ ÑƒÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð¸ ÑƒÐ¼ÐµÑÑ‚Ð¾ Ñ‚Ð¾Ð³Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÑ‚Ð²Ð°Ñ€Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(342657,9519,'vi','Bá» qua chá»‰nh sá»­a Ã¢m. Nháº­p tá»•ng giÃ¡ thÃ nh & dÃ¹ng giÃ¡ thÃ nh thá»±c táº¿ thay tháº¿',0),(342658,9519,'af','Negatiewe aanpassings sal ignoreer ingesleutelde totale koste en gebruik eerder \'n werklike koste',0),(342659,9519,'ro','AjustÄƒri negative va ignora intrat costul Total ÅŸi de a folosi Ã®n schimb costul real',0),(342660,9519,'et','Negatiivsed tÃ¤psustused ignoreerida sisestatud kogukulu ja selle asemel kasutada tegelikke',0),(342661,9519,'si','Oddaja bo prezreti zaÄel stroÅ¡ki in namesto tega uporabite dejanskih stroÅ¡kov',0),(342662,9519,'ba','Penyesuaian negatif akan mengabaikan biaya Total masuk dan menggunakan biaya sebenarnya bukan',0),(342663,9519,'nl','Negatieve correcties zal negeren ingevoerde totale kosten en werkelijke kosten gebruiken',0),(342664,9519,'fi','Negatiiviset oikaisut ohittaa tuli kokonaiskustannukset ja kÃ¤yttÃ¤Ã¤ todellisen kustannuksen sijaan',0),(342665,9519,'no','Nedjusteringer ignorerer angitte kostbelÃ¸p og i stedet bruke faktiske kostnader',0),(342666,9519,'da','Nedreguleringer vil ignorere indtastede samlede omkostninger og i stedet bruge faktiske omkostninger',0),(342667,9519,'ko','ë„¤ê±°í‹°ë¸Œ ì¡°ì • ìž…ë ¥ í•œ ì´ ë¹„ìš©ì„ ë¬´ì‹œ í•˜ ê³  ëŒ€ì‹  ì‹¤ì œ ë¹„ìš©ì„ ì‚¬ìš© í•˜ ì—¬',0),(342668,9519,'he','×”×ª××ž×•×ª ×©×œ×™×œ×™×•×ª ×œ×”×ª×¢×œ× ×”×¢×œ×•×ª ×”×›×•×œ×œ×ª ×©×”×•×–×Ÿ, ×”×©×ª×ž×© ×‘×ž×§×•× ×–××ª ×¢×œ×•×ª ×‘×¤×•×¢×œ',0),(342669,9519,'el','Î‘ÏÎ½Î·Ï„Î¹ÎºÎ­Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚ Î¸Î± Î±Î³Î½Î¿Î®ÏƒÎµÎ¹ ÎµÎ¹ÏƒÎ®Î»Î¸Îµ ÏƒÏ…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÎ±Î¹ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Î½Ï„Î¯ Î³Î¹Î± Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(342670,9519,'zh','æ¶ˆæžè°ƒæ•´å°†å¿½ç•¥è¾“å…¥çš„æ€»æˆæœ¬ï¼Œä»£ä»¥ä½¿ç”¨å®žé™…æˆæœ¬\r\n',0),(342671,9519,'sv','Negativa justeringar kommer att ignorera angivna totalkostnad och i stÃ¤llet anvÃ¤nda faktisk kostnad',0),(342672,9519,'it','Rettifiche negative ignorerÃ  costo totale immesso e utilizzare invece il costo effettivo',0),(342673,9519,'tl','',0),(342674,9519,'th','Negative Adjustments Will Ignore Entered Total Cost And Use ACTUAL Cost Instead',0),(342675,9519,'hi','à¤¨à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤ à¤—à¤ à¤•à¥à¤² à¤²à¤¾à¤—à¤¤ à¤ªà¤° à¤§à¥à¤¯à¤¾à¤¨ à¤¨ à¤¦à¥‡à¤‚ à¤”à¤° à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤²à¤¾à¤—à¤¤ à¤‡à¤¸à¤•à¥‡ à¤¬à¤œà¤¾à¤¯ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(342676,9519,'ms','Pelarasan yang negatif akan mengabaikan dimasukkan jumlah kos dan sebaliknya menggunakan kos sebenar',0),(342677,9519,'ar','Ø³ÙŠØªÙ… ØªØ¬Ø§Ù‡Ù„ Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ© Ø¯Ø®Ù„Øª Ø§Ù„ØªØ³ÙˆÙŠØ§Øª Ø§Ù„Ø³Ù„Ø¨ÙŠØ© ÙˆØ§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„ÙØ¹Ù„ÙŠØ© Ø¨Ø¯Ù„Ø§Ù‹ Ù…Ù† Ø°Ù„Ùƒ',0),(342678,9519,'fr','Ajustements nÃ©gatifs ignorera CoÃ»t Total entrÃ© et utilisez le coÃ»t rÃ©el Ã  la place',0),(342679,9519,'jp','ãƒžã‚¤ãƒŠã‚¹èª¿æ•´ã¯å…¥åŠ›ã—ãŸç·ã‚³ã‚¹ãƒˆã‚’ç„¡è¦–ã—ã€ä»£ã‚ã‚Šã«å®Ÿéš›ã®ã‚³ã‚¹ãƒˆã‚’ä½¿ç”¨ã—ã¦',0),(342680,9519,'pt','Ajustes negativos ignorar o custo Total entrou e Use o custo real',0),(342681,9519,'ru','ÐžÑ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð±ÑƒÐ´ÑƒÑ‚ Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ðµ ÑÐ¾Ð²Ð¾ÐºÑƒÐ¿Ð½ÑƒÑŽ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¸ Ð²Ð¼ÐµÑÑ‚Ð¾ ÑÑ‚Ð¾Ð³Ð¾ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹',0),(342682,9519,'es','Ajustes Negativos IgnorarÃ¡n el Costo Total Entrado y UsarÃ¡ el Costo Actual en Cambio',0),(342683,9519,'de','AbgÃ¤nge werden eingegebenen Gesamtkosten zu ignorieren und stattdessen Istkosten',0),(342684,9519,'en','Negative Adjustments Will Ignore Entered Total Cost And Use ACTUAL Cost Instead',0),(342685,9520,'is','',0),(342686,9520,'dr','Ø¢Ø®Ø±ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´  ',0),(342687,9520,'pr','Ø¢Ø®Ø±ÙŠÙ† Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø³ÙØ§Ø±Ø´  ',0),(342688,9520,'tr','Son kullanÄ±lan sipariÅŸ numarasÄ±',0),(342689,9520,'pl','Ostatni numer zamÃ³wienia uÅ¼ywane',0),(342690,9520,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð·Ð° Ð½Ð¾Ð¼ÐµÑ€',0),(342691,9520,'ur','Ø¢Ø®Ø±ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø±',0),(342692,9520,'sr','Ð—Ð°Ð´ÑšÐ¸ ÐºÐ¾Ñ€Ð¸ÑˆÑ‚ÐµÐ½ Ð±Ñ€Ð¾Ñ˜',0),(342693,9520,'vi','Sá»‘ Ä‘Æ¡n hÃ ng dÃ¹ng cuá»‘i cÃ¹ng',0),(342694,9520,'af','Laaste Bestellingsnommer Gebruik',0),(342695,9520,'ro','Ultimul numÄƒr de ordinea utilizate',0),(342696,9520,'et','Viimati kasutatud tellimuse kood',0),(342697,9520,'si','Zadnje uporabljene zaporedno Å¡tevilko',0),(342698,9520,'ba','Urutan nomor yang terakhir',0),(342699,9520,'nl','Laatste gebruikte bestelnummer',0),(342700,9520,'fi','Viimeinen kÃ¤ytetty tilausnumero',0),(342701,9520,'no','Sist brukte ordrenummer',0),(342702,9520,'da','Sidste anvendte ordrenummer',0),(342703,9520,'ko','ë§ˆì§€ë§‰ ì‚¬ìš©ëœ ì£¼ë¬¸ ë²ˆí˜¸',0),(342704,9520,'he','×ž×¡×¤×¨ ×”×–×ž× ×” ×‘×©×™×ž×•×© ×”××—×¨×•×Ÿ',0),(342705,9520,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Î‘ÏÎ¾Ï‰Î½Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(342706,9520,'zh','æœ€åŽä½¿ç”¨çš„é¡ºåºç¼–å·\r\n',0),(342707,9520,'sv','Senaste begagnade ordernummer',0),(342708,9520,'it','Ultimo numero dell\'ordine usato',0),(342709,9520,'tl','',0),(342710,9520,'th','&#3651;&#3594;&#3657;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3621;&#3656;&#3634;&#3626;&#3640;&#3604;',0),(342711,9520,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤¿à¤ à¤—à¤ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(342712,9520,'ms','Nombor terakhir yang digunakan',0),(342713,9520,'ar','Ø¢Ø®Ø± Ø±Ù‚Ù… ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(342714,9520,'fr','Dernier numÃ©ro de lâ€™ordre dâ€™utilisation rÃ©cent',0),(342715,9520,'jp','æœ€å¾Œã«ä½¿ç”¨ã•ã‚Œã‚‹æ³¨æ–‡ç•ªå·',0),(342716,9520,'pt','Ãšltimo nÃºmero de ordem de uso',0),(342717,9520,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð—Ð°ÐºÐ°Ð·Ð° Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹ ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¼',0),(342718,9520,'es','Ultimo NÃºmero de Pedido Utilizado',0),(342719,9520,'de','Letzten verwendeten Bestell-Nummer',0),(342720,9520,'en','Last Used Order Number',0),(342721,9521,'is','',0),(342722,9521,'dr','ØªÙ†Ø¸ÙŠÙ… Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¨Ø¹Ø¯ÙŠ ',0),(342723,9521,'pr','ØªÙ†Ø¸ÙŠÙ… Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¨Ø¹Ø¯ÙŠ ',0),(342724,9521,'tr','KÃ¼me sonraki sipariÅŸ numarasÄ±',0),(342725,9521,'pl','Zestaw nastÄ™pnego numeru zamÃ³wienia',0),(342726,9521,'bg','Ð—Ð°Ð´Ð°Ð¹ ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(342727,9521,'ur','Ø§Ú¯Ù„Ø§ Ù†Ù…Ø¨Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ø¢Ø±ÚˆØ±',0),(342728,9521,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ ÑÐ»ÐµÐ´ÐµÑ›Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(342729,9521,'vi','Äáº·t sá»‘ Ä‘Æ¡n hÃ ng tiáº¿p theo',0),(342730,9521,'af','Stel Volgende Bestelnommer',0),(342731,9521,'ro','Set urmÄƒtorul numÄƒr de ordine',0),(342732,9521,'et','JÃ¤rgmise tellimuse hulka',0),(342733,9521,'si','Nastavite naslednjo zaporedno Å¡tevilko',0),(342734,9521,'ba','Mengatur nomor pesanan berikutnya',0),(342735,9521,'nl','Set volgende bestelnummer',0),(342736,9521,'fi','Aseta seuraava numero',0),(342737,9521,'no','Angi neste nummer',0),(342738,9521,'da','SÃ¦t nÃ¦ste lÃ¸benummer',0),(342739,9521,'ko','ì„¤ì •ëœ ë‹¤ìŒ ì£¼ë¬¸ ë²ˆí˜¸',0),(342740,9521,'he','×”×’×“×¨×ª ×ž×¡×¤×¨ ×”×”×–×ž× ×” ×”×‘××”',0),(342741,9521,'el','Î£ÎµÏ„ ÎµÏ€ÏŒÎ¼ÎµÎ½Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(342742,9521,'zh','è®¾ç½®ä¸‹ä¸€è®¢å•å·\r\n',0),(342743,9521,'sv','StÃ¤ll in nÃ¤sta lÃ¶pnummer',0),(342744,9521,'it','Impostare numero di ordine successivo',0),(342745,9521,'tl','',0),(342746,9521,'th','&#3585;&#3635;&#3627;&#3609;&#3604;&#3627;&#3617;&#3634;&#3618;&#3648;&#3621;&#3586;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3606;&#3633;&#3604;&#3652;&#3611;',0),(342747,9521,'hi','à¤¸à¥‡à¤Ÿ à¤…à¤—à¤²à¥‡ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(342748,9521,'ms','Set nombor pesanan seterusnya',0),(342749,9521,'ar','ØªØ¹ÙŠÙŠÙ† Ø±Ù‚Ù… Ø§Ù„Ø£Ù…Ø± Ø§Ù„ØªØ§Ù„ÙŠ',0),(342750,9521,'fr','NumÃ©ro de commande suivant Set',0),(342751,9521,'jp','æ¬¡ã®é †åºç•ªå·ã‚’è¨­å®š',0),(342752,9521,'pt','NÃºmero de ordem no prÃ³ximo definido',0),(342753,9521,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ ÐÐ¾Ð¼ÐµÑ€ Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ³Ð¾ Ð—Ð°ÐºÐ°Ð·Ð°',0),(342754,9521,'es','Fijar el Proximo NÃºmero de Pedido',0),(342755,9521,'de','NÃ¤chste Bestellung Setnummer',0),(342756,9521,'en','Set Next Order Number',0),(342757,9522,'is','',0),(342758,9522,'dr','( ØªØ®ÙÙŠÙ ) Ø¯Ø± Ù…Ø§Ù‡ Ø¢ÙŠÙ†Ø¯Ù‡',0),(342759,9522,'pr','ØªØ§Ø±ÙŠØ® ØªÙ†Ø²ÙŠÙ„ ( ØªØ®ÙÙŠÙ ) Ø¯Ø± Ù…Ø§Ù‡ Ø¢ÙŠÙ†Ø¯Ù‡',0),(342760,9522,'tr','Ä°skonto tarihi ay takip',0),(342761,9522,'pl','Data rabatu na po miesiÄ…cu',0),(342762,9522,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð½Ð° ÑÐ»ÐµÐ´Ð²Ð°Ñ‰ Ð¼ÐµÑÐµÑ†',0),(342763,9522,'ur','ØªØ§Ø±ÛŒØ® Ù…Ø§Û Ø¨Ø¹Ø¯ ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(342764,9522,'sr','Ð”Ð°Ñ‚ÑƒÐ¼Ð° ÐºÐ°ÑÐ°ÑÐºÐ¾Ð½Ñ‚Ð° Ð½Ð° Ð¿Ð¾ÑÐ»Ðµ Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(342765,9522,'vi','NgÃ y chiáº¿t kháº¥u trong thÃ¡ng tiáº¿p theo',0),(342766,9522,'af','Kortingsdag in Opvolgende Maand',0),(342767,9522,'ro','Data reducerii pe luna',0),(342768,9522,'et','Hinnaalandi kohta jÃ¤rgneva',0),(342769,9522,'si','Datuma kasaskonta po mesecu',0),(342770,9522,'ba','Diskon tanggal pada mengikuti bulan',0),(342771,9522,'nl','Contantkorting op de volgende maand',0),(342772,9522,'fi','Alennus pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤Ã¤ seuraavan kuukauden',0),(342773,9522,'no','Kontantrabattdato pÃ¥ etter mÃ¥ned',0),(342774,9522,'da','Kontantrabatdato pÃ¥ efter mÃ¥ned',0),(342775,9522,'ko','ë‹¤ìŒ ë‹¬ì— ë‚ ì§œë¥¼ í• ì¸',0),(342776,9522,'he','×”× ×—×” ×ª××¨×™×š ×¢×œ ××—×¨×™ ×—×•×“×©',0),(342777,9522,'el','ÎœÎµÏ„Î¬ Ï„Î¿ Î¼Î®Î½Î± Ï„Î·Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(342778,9522,'zh','åœ¨éšåŽçš„ä¸€ä¸ªæœˆæŠ˜æ‰£æ—¥æœŸ\r\n',0),(342779,9522,'sv','Kassarabattsdatumet pÃ¥ fÃ¶ljande mÃ¥nad',0),(342780,9522,'it','Sconto data successivo mese',0),(342781,9522,'tl','',0),(342782,9522,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3651;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3605;&#3656;&#3629;&#3652;&#3611;',0),(342783,9522,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤®à¤¹à¥€à¤¨à¥‡ à¤ªà¥€à¤›à¤¾ à¤•à¤°à¤¨à¥‡ à¤ªà¤° à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ',0),(342784,9522,'ms','Diskaun tarikh terakhir mengikut bulan',0),(342785,9522,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø®ØµÙ… Ø¹Ù„Ù‰ Ø¨Ø¹Ø¯ Ø´Ù‡Ø±',0),(342786,9522,'fr','Promos Date sur suivant mois',0),(342787,9522,'jp','æ¬¡ã®æœˆã®æ—¥ä»˜ã‚’å‰²å¼•ã—ã¾ã™ã€‚',0),(342788,9522,'pt','Desconto de data no seguinte mÃªs',0),(342789,9522,'ru','Ð”Ð°Ñ‚Ð° ÑÐºÐ¸Ð´ÐºÐ¸ Ð½Ð° ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð¼ÐµÑÑÑ†',0),(342790,9522,'es','Fecha de Descuento en el Mes Siguente',0),(342791,9522,'de','Rabatt-Datum auf den Monat folgt',0),(342792,9522,'en','Discount Date On Following Month',0),(342793,9523,'is','',0),(342794,9523,'dr','(Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(342795,9523,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù†ÙˆØ¹ ÙƒØ§Ø±(Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ÙŠ',0),(342796,9523,'tr','VarsayÄ±lan iÅŸ tÃ¼rÃ¼',0),(342797,9523,'pl','DomyÅ›lny typ pracy',0),(342798,9523,'bg','Ð’Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(342799,9523,'ur','Ø·Û’ Ø´Ø¯Û Ú©Ø§Ù… Ù‚Ø³Ù…',0),(342800,9523,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(342801,9523,'vi','Máº·c Ä‘á»‹nh phÆ°Æ¡ng thá»©c lÃ m viá»‡c',0),(342802,9523,'af','Verstekte Werktipe',0),(342803,9523,'ro','Tipul de lucru implicit',0),(342804,9523,'et','Vaikimisi tÃ¶Ã¶ tÃ¼Ã¼p',0),(342805,9523,'si','Privzeta vrsta dela',0),(342806,9523,'ba','Jenis pekerjaan default',0),(342807,9523,'nl','Standaard werksoort',0),(342808,9523,'fi','TyÃ¶n oletustyyppi',0),(342809,9523,'no','Standard arbeidstype',0),(342810,9523,'da','Standard arbejdstype',0),(342811,9523,'ko','ê¸°ë³¸ ìž‘ì—… ì¢…ë¥˜',0),(342812,9523,'he','×¡×•×’ ×”×¢×‘×•×“×” ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(342813,9523,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï‚ Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(342814,9523,'zh','é»˜è®¤å·¥ä½œç±»åž‹\r\n',0),(342815,9523,'sv','Standardtypen fÃ¶r arbete',0),(342816,9523,'it','Tipo di lavoro predefinito',0),(342817,9523,'tl','',0),(342818,9523,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;',0),(342819,9523,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(342820,9523,'ms','Jenis kerja lalai',0),(342821,9523,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(342822,9523,'fr','Type de travail par dÃ©faut',0),(342823,9523,'jp','æ—¢å®šã®ä½œæ¥­ç¨®é¡ž',0),(342824,9523,'pt','Tipo de trabalho padrÃ£o',0),(342825,9523,'ru','Ð¢Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(342826,9523,'es','Tipo de Trabajo Por Defecto',0),(342827,9523,'de','Standard-Arbeit-Typ',0),(342828,9523,'en','Default Work Type',0),(342829,9524,'is','',0),(342830,9524,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø¯Ù…Ø§Øª Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ ',0),(342831,9524,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø¯Ù…Ø§Øª Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ ',0),(342832,9524,'tr','Hizmet alt iÃ§in Ekle',0),(342833,9524,'pl','Dodaj usÅ‚ugi podtypÃ³w dla',0),(342834,9524,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð° Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð·Ð°',0),(342835,9524,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ Ø°ÛŒÙ„ÛŒ Ø§Ù‚Ø³Ø§Ù… ÛÛŒÚº Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(342836,9524,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿Ð¾Ð²Ð° ÑƒÑÐ»ÑƒÐ³Ð° Ð·Ð°',0),(342837,9524,'vi','ThÃªm cÃ¡c kiá»ƒu dá»‹ch vá»¥ cho ',0),(342838,9524,'af','Voeg Diens Subtipes Vir',0),(342839,9524,'ro','Adauga subtipuri de servicii pentru',0),(342840,9524,'et','Lisada teenuse alatÃ¼Ã¼pide kohta',0),(342841,9524,'si','Dodaj podtipov storitev za',0),(342842,9524,'ba','Tambahkan layanan subtipe untuk',0),(342843,9524,'nl','Service subtypen voor toevoegen',0),(342844,9524,'fi','LisÃ¤Ã¤ palvelu alatyyppien varten',0),(342845,9524,'no','Legge til tjenesten subtyper For',0),(342846,9524,'da','TilfÃ¸je Service undertyper til',0),(342847,9524,'ko','ì— ëŒ€ í•œ ì„œë¹„ìŠ¤ í•˜ìœ„ ì¶”ê°€',0),(342848,9524,'he','×”×•×¡×£ ×ª×ª ×©×™×¨×•×ª ×¢×‘×•×¨',0),(342849,9524,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ Ï…Ï€Î¿ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î±',0),(342850,9524,'zh','å¢žåŠ æœ‰å…³æœåŠ¡å­ç±»åž‹\r\n',0),(342851,9524,'sv','LÃ¤gga till Service undertyper fÃ¶r',0),(342852,9524,'it','Aggiungi servizio sottotipi per',0),(342853,9524,'tl','',0),(342854,9524,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;&#3586;&#3629;&#3591;',0),(342855,9524,'hi','à¤¸à¥‡à¤µà¤¾ à¤‰à¤ªà¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(342856,9524,'ms','Tambah jenis virus Perkhidmatan bagi',0),(342857,9524,'ar','Ø¥Ø¶Ø§ÙØ© Ø®Ø¯Ù…Ø© ÙØ±Ø¹ÙŠØ©',0),(342858,9524,'fr','Ajouter des sous-types de Service pour',0),(342859,9524,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã®ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(342860,9524,'pt','Adicionar serviÃ§o subtipos para',0),(342861,9524,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿Ñ‹ Ð´Ð»Ñ',0),(342862,9524,'es','Agregar Subtipos de Servicios Para',0),(342863,9524,'de','Service-Subtypen fÃ¼r hinzufÃ¼gen',0),(342864,9524,'en','Add Service Subtypes For',0),(342865,9525,'is','',0),(342866,9525,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(342867,9525,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ ',0),(342868,9525,'tr','Alt tÃ¼rÃ¼ Ekle',0),(342869,9525,'pl','Dodaj podtypu',0),(342870,9525,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(342871,9525,'ur','Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(342872,9525,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ð´Ð²Ñ€ÑÑ‚Ð°',0),(342873,9525,'vi','ThÃªm kiá»ƒu phá»¥',0),(342874,9525,'af','Voeg Subtype by',0),(342875,9525,'ro','Adauga subtip',0),(342876,9525,'et','Lisada alatÃ¼Ã¼bi',0),(342877,9525,'si','Dodaj podtip',0),(342878,9525,'ba','Tambahkan subtipe',0),(342879,9525,'nl','Subtype toevoegen',0),(342880,9525,'fi','LisÃ¤Ã¤ alatyyppi',0),(342881,9525,'no','Legge til undertype',0),(342882,9525,'da','TilfÃ¸je undertype',0),(342883,9525,'ko','í•˜ìœ„ë¥¼ ì¶”ê°€',0),(342884,9525,'he','×”×•×¡×£ ×¡×•×’ ×ž×©× ×”',0),(342885,9525,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î´ÎµÏ…Ï„ÎµÏÎµÏÏ‰Î½ Ï„ÏÏ€Î¿Ï‚',0),(342886,9525,'zh','å¢žåŠ å­ç±»åž‹\r\n',0),(342887,9525,'sv','LÃ¤gg till subtyp',0),(342888,9525,'it','Aggiungere il sottotipo',0),(342889,9525,'tl','',0),(342890,9525,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;',0),(342891,9525,'hi','à¤‰à¤ª-à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(342892,9525,'ms','Tambah Subtype',0),(342893,9525,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ ÙØ±Ø¹ÙŠ',0),(342894,9525,'fr','Ajouter sous-type',0),(342895,9525,'jp','ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(342896,9525,'pt','Adicionar o subtipo',0),(342897,9525,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(342898,9525,'es','Agregar Subtipo',0),(342899,9525,'de','Subtyp hinzufÃ¼gen',0),(342900,9525,'en','Add Subtype',0),(342901,9526,'is','',0),(342902,9526,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù†  Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(342903,9526,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù†  Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡',0),(342904,9526,'tr','Alt tÃ¼rÃ¼ kaydedilirken hata oluÅŸtu',0),(342905,9526,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania podtypu',0),(342906,9526,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(342907,9526,'ur','Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… Ù…Ø­ÙÙˆØ¸ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(342908,9526,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ¿Ñ€ÐµÐ¼Ð°ÑšÐ° Ð¿Ð¾Ð´Ð²Ñ€ÑÑ‚Ð°',0),(342909,9526,'vi','Lá»—i khi lÆ°u kiá»ƒu phá»¥',0),(342910,9526,'af','Fout met die stoor Subtype',0),(342911,9526,'ro','Eroare la salvarea subtip',0),(342912,9526,'et','AlatÃ¼Ã¼bi salvestamisel ilmnes tÃµrge',0),(342913,9526,'si','Napaka pri shranjevanju podtip',0),(342914,9526,'ba','Kesalahan menyimpan subtipe',0),(342915,9526,'nl','Fout bij het opslaan van Subtype',0),(342916,9526,'fi','Virhe tallennettaessa alatyyppi',0),(342917,9526,'no','Feil under lagring av undertype',0),(342918,9526,'da','Fejl under lagring af Subtype',0),(342919,9526,'ko','ì˜¤ë¥˜ í•˜ìœ„ í˜•ì‹ ì €ìž¥',0),(342920,9526,'he','××™×¨×¢×” ×©×’×™××” ×‘×©×ž×™×¨×ª ×”×ž×©× ×”',0),(342921,9526,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Î´ÎµÏ…Ï„ÎµÏÎµÏÏ‰Î½ Ï„ÏÏ€Î¿Ï‚',0),(342922,9526,'zh','é”™è¯¯ä¿å­˜äºšåž‹',0),(342923,9526,'sv','Fel vid sparande av subtyp',0),(342924,9526,'it','Errore durante il salvataggio di sottotipo',0),(342925,9526,'tl','',0),(342926,9526,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;',0),(342927,9526,'hi','à¤‰à¤ª-à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(342928,9526,'ms','Ralat Menyimpan Subtype',0),(342929,9526,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ®Ø²ÙŠÙ† Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(342930,9526,'fr','Erreur dâ€™enregistrement sous-type',0),(342931,9526,'jp','ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã‚’ä¿å­˜ä¸­ã«ã‚¨ãƒ©ãƒ¼',0),(342932,9526,'pt','Erro ao salvar o subtipo',0),(342933,9526,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿Ð°',0),(342934,9526,'es','Error Guardando Subtipo',0),(342935,9526,'de','Fehler beim Speichern des Subtyps',0),(342936,9526,'en','Error Saving Subtype',0),(342937,9527,'is','',0),(342938,9527,'dr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(342939,9527,'pr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(342940,9527,'tr','Bir alt tÃ¼rÃ¼ adÄ± olmasÄ± gerekir',0),(342941,9527,'pl','Musi mieÄ‡ nazwÄ™ podtypu',0),(342942,9527,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð¸Ð¼Ðµ Ð½Ð° Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(342943,9527,'ur','Ø§ÛŒÚ© Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù… Ú©Ø§ Ù†Ø§Ù… ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(342944,9527,'sr','ÐœÐ¾Ñ€Ð° Ð¸Ð¼Ð°Ñ‚Ð¸ Ð¸Ð¼Ðµ Ð¿Ð¾Ð´Ð²Ñ€ÑÑ‚Ð°',0),(342945,9527,'vi','Pháº£i cÃ³ má»™t tÃªn phá»¥ A',0),(342946,9527,'af','Moet \'n Sub-tipe Naam hÃª',0),(342947,9527,'ro','Trebuie sÄƒ aveÅ£i un nume de subtip',0),(342948,9527,'et','Peab olema alamtÃ¼Ã¼bi nimi',0),(342949,9527,'si','Mora imeti ime podvrste',0),(342950,9527,'ba','Harus memiliki nama subtipe',0),(342951,9527,'nl','Moet een Subtype naam hebben',0),(342952,9527,'fi','On oltava alatyypin nimi',0),(342953,9527,'no','MÃ¥ ha en undertype navn',0),(342954,9527,'da','Skal Have en Subtype navn',0),(342955,9527,'ko','í•˜ìœ„ í˜•ì‹ ì´ë¦„ì´ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(342956,9527,'he','×‘×˜×— ×™×© ×©× ×¡×•×’',0),(342957,9527,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± Ï…Ï€Î¿ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(342958,9527,'zh','å¿…é¡»æœ‰ä¸€ä¸ªå­ç±»åž‹å\r\n',0),(342959,9527,'sv','MÃ¥ste ha en subtyp namn',0),(342960,9527,'it','Deve avere un nome di sottotipo',0),(342961,9527,'tl','',0),(342962,9527,'th','&#3605;&#3657;&#3629;&#3591;&#3617;&#3637;&#3594;&#3639;&#3656;&#3629;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;',0),(342963,9527,'hi','à¤à¤• à¤‰à¤ª-à¤ªà¥à¤°à¤•à¤¾à¤° à¤¨à¤¾à¤® à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(342964,9527,'ms','Mesti mempunyai nama Subtype',0),(342965,9527,'ar','Ù„Ø§Ø¨Ø¯ Ù…Ù† ÙˆØ¬ÙˆØ¯ Ø¥Ø³Ù… Ù„Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(342966,9527,'fr','Doit avoir un nom de sous-type',0),(342967,9527,'jp','ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã®åå‰ã‚’æŒã¤å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(342968,9527,'pt','Deve ter um nome de subtipo',0),(342969,9527,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð¼ÐµÑ‚ÑŒ Ð¸Ð¼Ñ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿Ð°',0),(342970,9527,'es','Debe Tener Un Nombre de Subtipo',0),(342971,9527,'de','Muss einen Untertyp Namen haben',0),(342972,9527,'en','Must Have A Subtype Name',0),(342973,9528,'is','',0),(342974,9528,'dr','Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª ',0),(342975,9528,'pr','Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª ',0),(342976,9528,'tr','Hizmet alt tÃ¼rlerinden',0),(342977,9528,'pl','UsÅ‚uga podtypÃ³w',0),(342978,9528,'bg','Ð£ÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(342979,9528,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ Ø°ÛŒÙ„ÛŒ Ø§Ù‚Ø³Ø§Ù… ÛÛŒÚº',0),(342980,9528,'sr','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿Ð¾Ð²Ð° ÑƒÑÐ»ÑƒÐ³Ð°',0),(342981,9528,'vi','Loáº¡i dá»‹ch vá»¥ phá»¥',0),(342982,9528,'af','Diens Subtipes',0),(342983,9528,'ro','Subtipuri de serviciu',0),(342984,9528,'et','Teenuse alatÃ¼Ã¼bid',0),(342985,9528,'si','Storitev podtipe',0),(342986,9528,'ba','Subtipe Layanan',0),(342987,9528,'nl','Service Subtypes',0),(342988,9528,'fi','Palvelun alalajit',0),(342989,9528,'no','Tjenesten undertyper',0),(342990,9528,'da','Service undertyper',0),(342991,9528,'ko','ì„œë¹„ìŠ¤ í•˜ìœ„',0),(342992,9528,'he','×¡×•×’×™ ×©×™×¨×•×ª',0),(342993,9528,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï…Ï€Î¿Ï„ÏÏ€Ï‰Î½',0),(342994,9528,'zh','æœåŠ¡äºšåž‹\r\n',0),(342995,9528,'sv','Service undertyper',0),(342996,9528,'it','Sottotipi di servizio',0),(342997,9528,'tl','',0),(342998,9528,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(342999,9528,'hi','à¤¸à¥‡à¤µà¤¾ à¤‰à¤ªà¤ªà¥à¤°à¤•à¤¾à¤°',0),(343000,9528,'ms','Perkhidmatan jenis virus',0),(343001,9528,'ar','Ø§Ù„Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„ÙØ±Ø¹ÙŠØ© Ù„Ù„Ø®Ø¯Ù…Ø§Øª',0),(343002,9528,'fr','Sous-types de service',0),(343003,9528,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã®ã‚µãƒ–ã‚¿ã‚¤ãƒ—',0),(343004,9528,'pt','Subtipos de serviÃ§o',0),(343005,9528,'ru','Ð¡ÐµÑ€Ð²Ð¸Ñ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿Ñ‹',0),(343006,9528,'es','Subtipos de Servicios',0),(343007,9528,'de','Service-Subtypen',0),(343008,9528,'en','Service Subtypes',0),(343009,9529,'is','',0),(343010,9529,'dr','/ Ø¢Ù¾Ø¯ÛŒØª   Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª',0),(343011,9529,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª',0),(343012,9529,'tr','Hizmet Ekle/GÃ¼ncelle alt tÃ¼rlerinden',0),(343013,9529,'pl','UsÅ‚uga podtypÃ³w Dodaj/Aktualizuj',0),(343014,9529,'bg','Ð£ÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(343015,9529,'ur','Ø®Ø¯Ù…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø°ÛŒÙ„ÛŒ Ø§Ù‚Ø³Ø§Ù… ÛÛŒÚº',0),(343016,9529,'sr','Ð¡ÐµÑ€Ð²Ð¸Ñ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿Ð¾Ð²Ð°/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(343017,9529,'vi','ThÃªm/cáº­p nháº­t dá»‹ch vá»¥ phá»¥',0),(343018,9529,'af','Diens Subtipes Byvoeg/Opdateer',0),(343019,9529,'ro','Serviciul subtipuri AdÄƒugaÅ£i/actualizaÅ£i',0),(343020,9529,'et','Teenuse alatÃ¼Ã¼pide andmete lisamine/uuendamine',0),(343021,9529,'si','Storitev podtipov Dodaj/posodobi',0),(343022,9529,'ba','Layanan subtipe menambahkan Update',0),(343023,9529,'nl','Service subtypen toevoegen/bijwerken',0),(343024,9529,'fi','Palvelun alatyyppien lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(343025,9529,'no','Tjenesten subtyper Legg til/Oppdater',0),(343026,9529,'da','Service undertyper TilfÃ¸j/opdater',0),(343027,9529,'ko','ì„œë¹„ìŠ¤ í•˜ìœ„ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(343028,9529,'he','×©×™×¨×•×ª ×ª×ª ×”×•×¡×£/×¢×“×›×Ÿ',0),(343029,9529,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï…Ï€Î¿Ï„ÏÏ€Î¿Ï…Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(343030,9529,'zh','æœåŠ¡äºšåž‹æ–°å¢ž/æ›´æ–°\r\n',0),(343031,9529,'sv','Service subtyper LÃ¤gg till/uppdatera',0),(343032,9529,'it','Servizio aggiungere/aggiornare i sottotipi',0),(343033,9529,'tl','',0),(343034,9529,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(343035,9529,'hi','à¤¸à¥‡à¤µà¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤‰à¤ªà¤ªà¥à¤°à¤•à¤¾à¤°',0),(343036,9529,'ms','Perkhidmatan jenis virus Tambah/Kemaskini',0),(343037,9529,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„ÙØ±Ø¹ÙŠØ© Ù„Ù„Ø®Ø¯Ù…Ø§Øª',0),(343038,9529,'fr','Service des sous-types ajouter/mettre Ã  jour',0),(343039,9529,'jp','ã‚µãƒ¼ãƒ“ã‚¹ ã‚µãƒ–ã‚¿ã‚¤ãƒ—ã‚’è¿½åŠ /æ›´æ–°',0),(343040,9529,'pt','ServiÃ§o de subtipos adicionar/atualizar',0),(343041,9529,'ru','Ð¡Ð»ÑƒÐ¶Ð±Ð° Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿Ñ‹ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(343042,9529,'es','Agregar/Actualizar Subtipo de Servicio',0),(343043,9529,'de','Service Subtypen hinzufÃ¼gen/aktualisieren',0),(343044,9529,'en','Service Subtypes Add/Update',0),(343045,9530,'is','',0),(343046,9530,'dr','Ø­Ø°Ù Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø®Ø¯Ù…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(343047,9530,'pr','Ø­Ø°Ù Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø®Ø¯Ù…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(343048,9530,'tr','Hizmet alt tÃ¼rÃ¼ baÅŸarÄ±yla silindi',0),(343049,9530,'pl','Podtyp usÅ‚ugi pomyÅ›lnie',0),(343050,9530,'bg','Ð£ÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(343051,9530,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ø´Ø¯Û Ø®Ø¯Ù…Øª Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù…',0),(343052,9530,'sr','Ð¡ÐµÑ€Ð²Ð¸Ñ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(343053,9530,'vi','XÃ³a dá»‹ch vá»¥ phá»¥ thÃ nh cÃ´ng',0),(343054,9530,'af','Diens Subtipe Suksesvol Geskrap',0),(343055,9530,'ro','Subtip de serviciu eliminÄƒ cu succes',0),(343056,9530,'et','Teenuse alatÃ¼Ã¼bi edukalt kustutatud',0),(343057,9530,'si','Storitev podtip uspeÅ¡no izbrisana',0),(343058,9530,'ba','Layanan subtipe dihapus berhasil',0),(343059,9530,'nl','Service Subtype succesvol verwijderd',0),(343060,9530,'fi','Palvelun alatyypin poistettu',0),(343061,9530,'no','Tjenesten undertype slettet',0),(343062,9530,'da','Service Subtype slettet',0),(343063,9530,'ko','ì„œë¹„ìŠ¤ í•˜ìœ„ ìœ í˜•ì„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ',0),(343064,9530,'he','×¡×•×’ ×ž×©× ×” ×©×œ ×©×™×¨×•×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(343065,9530,'el','Î”ÎµÏ…Ï„ÎµÏÎµÏÏ‰Î½ Ï„ÏÏ€Î¿Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(343066,9530,'zh','æœåŠ¡äºšåž‹æˆåŠŸåˆ é™¤\r\n',0),(343067,9530,'sv','Service subtyp raderades',0),(343068,9530,'it','Sottotipo di servizio eliminato con successo',0),(343069,9530,'tl','',0),(343070,9530,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(343071,9530,'hi','à¤¸à¥‡à¤µà¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤‰à¤ª-à¤ªà¥à¤°à¤•à¤¾à¤°',0),(343072,9530,'ms','Perkhidmatan Subtype dihapuskan dengan jayanya',0),(343073,9530,'ar','Ø­Ø°Ù Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ Ù„Ù„Ø®Ø¯Ù…Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(343074,9530,'fr','Sous-type de service supprimÃ© avec succÃ¨s',0),(343075,9530,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸã‚µãƒ¼ãƒ“ã‚¹ ã‚µãƒ–ã‚¿ã‚¤ãƒ—',0),(343076,9530,'pt','Subtipo de serviÃ§o excluÃ­do com sucesso',0),(343077,9530,'ru','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿ ÑÐ»ÑƒÐ¶Ð±Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(343078,9530,'es','Subtipo de Servicio Eliminado Exitosamente',0),(343079,9530,'de','Service-Subtyp wurde erfolgreich gelÃ¶scht',0),(343080,9530,'en','Service Subtype Deleted Successfully',0),(343081,9531,'is','',0),(343082,9531,'dr','Ù†Ø§Ù… Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø®Ø¯Ù…Ø§Øª ',0),(343083,9531,'pr','Ù†Ø§Ù… Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø®Ø¯Ù…Ø§Øª ',0),(343084,9531,'tr','Hizmet alt tÃ¼rÃ¼ adÄ±',0),(343085,9531,'pl','Nazwa podtypu usÅ‚ugi',0),(343086,9531,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿',0),(343087,9531,'ur','Ù†Ø§Ù… Ø®Ø¯Ù…Øª Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù…',0),(343088,9531,'sr','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿ Ð¸Ð¼Ðµ ÑƒÑÐ»ÑƒÐ³Ðµ',0),(343089,9531,'vi','TÃªn loáº¡i dá»‹ch vá»¥ phá»¥',0),(343090,9531,'af','Diens Sub-tipe Naam',0),(343091,9531,'ro','Numele de subtipul de serviciu',0),(343092,9531,'et','Teenuse alamtÃ¼Ã¼bi nimi',0),(343093,9531,'si','Ime podvrste storitve',0),(343094,9531,'ba','Nama subtipe Layanan',0),(343095,9531,'nl','Subtype servicenaam',0),(343096,9531,'fi','Palvelun alatyypin nimi',0),(343097,9531,'no','Navn pÃ¥ undertype',0),(343098,9531,'da','Tjenestenavnet undertype',0),(343099,9531,'ko','ì„œë¹„ìŠ¤ í•˜ìœ„ í˜•ì‹ ì´ë¦„',0),(343100,9531,'he','×©× ×¡×•×’ ×©×œ ×©×™×¨×•×ª',0),(343101,9531,'el','ÎŒÎ½Î¿Î¼Î± Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ Î´ÎµÏ…Ï„ÎµÏÎµÏÏ‰Î½ Ï„ÏÏ€Î¿Ï‚',0),(343102,9531,'zh','æœåŠ¡äºšåž‹åç§°\r\n',0),(343103,9531,'sv','Undertyp tjÃ¤nstnamn',0),(343104,9531,'it','Nome del sottotipo di servizio',0),(343105,9531,'tl','',0),(343106,9531,'th','&#3594;&#3639;&#3656;&#3629;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;',0),(343107,9531,'hi','à¤¸à¥‡à¤µà¤¾ à¤‰à¤ª-à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾ à¤¨à¤¾à¤®',0),(343108,9531,'ms','Nama Subtype Perkhidmatan',0),(343109,9531,'ar','Ø¥Ø³Ù… Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ Ù„Ù„Ø®Ø¯Ù…Ø§Øª',0),(343110,9531,'fr','Nom de sous-type de service',0),(343111,9531,'jp','ã‚µãƒ¼ãƒ“ã‚¹ ã‚µãƒ–ã‚¿ã‚¤ãƒ—å',0),(343112,9531,'pt','Nome do subtipo de serviÃ§o',0),(343113,9531,'ru','Ð˜Ð¼Ñ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿Ð°',0),(343114,9531,'es','Nombre de Subtipo de Servicio',0),(343115,9531,'de','Subtyp Dienstname',0),(343116,9531,'en','Service Subtype Name',0),(343117,9532,'is','',0),(343118,9532,'dr','Ø°Ø®ÙŠØ±Ù‡  Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø®Ø¯Ù…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(343119,9532,'pr','Ø°Ø®ÙŠØ±Ù‡  Ø²ÙŠØ± Ú¯Ø±ÙˆÙ‡ Ø®Ø¯Ù…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(343120,9532,'tr','Hizmet alt tÃ¼rÃ¼ baÅŸarÄ±yla kaydedildi',0),(343121,9532,'pl','Podtyp usÅ‚ugi pomyÅ›lnie zapisany',0),(343122,9532,'bg','Ð£ÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(343123,9532,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ø³Ø±ÙˆØ³ Ø°ÛŒÙ„ÛŒ Ù‚Ø³Ù…',0),(343124,9532,'sr','Ð¡ÐµÑ€Ð²Ð¸Ñ Ð¿Ð¾Ð´Ñ‚Ð¸Ð¿ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(343125,9532,'vi','LÆ°u dá»‹ch vá»¥ phá»¥ thÃ nh cÃ´ng',0),(343126,9532,'af','Diens Subtipe Suksesvol Gestoor',0),(343127,9532,'ro','Subtip de serviciu salvat cu succes',0),(343128,9532,'et','Teenuse alatÃ¼Ã¼bi edukalt salvestatud',0),(343129,9532,'si','Storitev podtip shranjen',0),(343130,9532,'ba','Layanan subtipe disimpan berhasil',0),(343131,9532,'nl','Subtype van de service succesvol opgeslagen',0),(343132,9532,'fi','Palvelun alatyypin tallennettu',0),(343133,9532,'no','Tjenesten undertype lagret',0),(343134,9532,'da','Service Subtype gemt med succes',0),(343135,9532,'ko','ì„œë¹„ìŠ¤ í•˜ìœ„ ìœ í˜•ì„ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(343136,9532,'he','×¡×•×’ ×ž×©× ×” ×©×œ ×©×™×¨×•×ª × ×©×ž×¨ ×‘×”×¦×œ×—×”',0),(343137,9532,'el','Î”ÎµÏ…Ï„ÎµÏÎµÏÏ‰Î½ Ï„ÏÏ€Î¿Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… Î±Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(343138,9532,'zh','æœåŠ¡äºšåž‹å·²æˆåŠŸä¿å­˜\r\n',0),(343139,9532,'sv','Service subtyp sparats',0),(343140,9532,'it','Sottotipo di servizio salvato correttamente',0),(343141,9532,'tl','',0),(343142,9532,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3618;&#3656;&#3629;&#3618;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(343143,9532,'hi','à¤¸à¥‡à¤µà¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤‰à¤ª-à¤ªà¥à¤°à¤•à¤¾à¤°',0),(343144,9532,'ms','Perkhidmatan Subtype berjaya disimpan',0),(343145,9532,'ar','Ø­ÙØ¸ Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ Ù„Ù„Ø®Ø¯Ù…Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(343146,9532,'fr','Sous-type de service enregistrÃ© avec succÃ¨s',0),(343147,9532,'jp','æ­£å¸¸ã«ä¿å­˜ã‚µãƒ¼ãƒ“ã‚¹ ã‚µãƒ–ã‚¿ã‚¤ãƒ—',0),(343148,9532,'pt','Subtipo de serviÃ§o com sucesso',0),(343149,9532,'ru','ÐŸÐ¾Ð´Ñ‚Ð¸Ð¿ ÑÐ»ÑƒÐ¶Ð±Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(343150,9532,'es','Subtipo de Servicio Guardado Exitosamente',0),(343151,9532,'de','Service-Subtyp erfolgreich gespeichert',0),(343152,9532,'en','Service Subtype Saved Successfully',0),(343153,9533,'is','',0),(343154,9533,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§ ÙŠÙƒ Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø§Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(343155,9533,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§ ÙŠÙƒ Ù†ÙˆØ¹ Ø®Ø¯Ù…Ø§Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(343156,9533,'tr','Ã–nce bir hizmet tÃ¼rÃ¼ girmelisiniz',0),(343157,9533,'pl','Najpierw naleÅ¼y wprowadziÄ‡ typ usÅ‚ugi',0),(343158,9533,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð¿ÑŠÑ€Ð²Ð¾ Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿ ÑƒÑÐ»ÑƒÐ³Ð°',0),(343159,9533,'ur','Ø¢Ù¾ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø³Ø±ÙˆØ³ Ú©ÛŒ Ø§ÛŒÚ© Ù‚Ø³Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(343160,9533,'sr','ÐŸÑ€Ð²Ð¾ Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ñ‚Ð¸Ð¿ ÑƒÑÐ»ÑƒÐ³Ðµ',0),(343161,9533,'vi','Báº¡n pháº£i nháº­p má»™t loáº¡i dá»‹ch vá»¥ trÆ°á»›c',0),(343162,9533,'af','U moet Eers \'n Dienstipe Invoer',0),(343163,9533,'ro','Mai Ã®ntÃ¢i trebuie sÄƒ introduceÅ£i un tip de serviciu',0),(343164,9533,'et','Te peate ennem sisestama teenuse tÃ¼Ã¼bi',0),(343165,9533,'si','Najprej morate vnesti vrsto storitev',0),(343166,9533,'ba','Anda harus terlebih dahulu memasukkan jenis layanan',0),(343167,9533,'nl','Eerst moet u een servicetype',0),(343168,9533,'fi','Kirjoita ensin palvelutyyppi',0),(343169,9533,'no','Du mÃ¥ fÃ¸rst angi en tjenestetype',0),(343170,9533,'da','Du skal angive en tjenestetype',0),(343171,9533,'ko','ì„œë¹„ìŠ¤ ì¢…ë¥˜ë¥¼ ë¨¼ì € ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(343172,9533,'he','×ª×—×™×œ×” ×¢×œ×™×š ×œ×”×–×™×Ÿ ×¡×•×’ ×©×™×¨×•×ª',0),(343173,9533,'el','Î ÏÎ­Ï€ÎµÎ¹ Ï€ÏÏŽÏ„Î± Î½Î± Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ Î­Î½Î±Î½ Ï„ÏÏ€Î¿ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚',0),(343174,9533,'zh','æ‚¨å¿…é¡»å…ˆè¾“å…¥æœåŠ¡ç±»åž‹\r\n',0),(343175,9533,'sv','Du mÃ¥ste fÃ¶rst ange en typ av tjÃ¤nst',0),(343176,9533,'it','Ãˆ necessario prima inserire un tipo di servizio',0),(343177,9533,'tl','',0),(343178,9533,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3619;&#3629;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3648;&#3611;&#3655;&#3609;&#3629;&#3618;&#3656;&#3634;&#3591;&#3649;&#3619;&#3585;',0),(343179,9533,'hi','à¤†à¤ª à¤ªà¤¹à¤²à¥‡ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ à¤à¤• à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(343180,9533,'ms','Anda harus pertama sekali masukkan jenis perkhidmatan yang',0),(343181,9533,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø£ÙˆÙ„Ø§Ù‹ Ø¥Ø¯Ø®Ø§Ù„ Ù†ÙˆØ¹ Ø§Ù„Ø®Ø¯Ù…Ø©',0),(343182,9533,'fr','Vous devez d\'abord entrer un type de service.',0),(343183,9533,'jp','ã¾ãšã€ã‚µãƒ¼ãƒ“ã‚¹ã®ç¨®é¡žã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(343184,9533,'pt','VocÃª deve primeiro inserir um tipo de serviÃ§o',0),(343185,9533,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ñ‚Ð¸Ð¿ ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(343186,9533,'es','Primero Tiene que Introducir Un Tipo de Servicio',0),(343187,9533,'de','Sie mÃ¼ssen zuerst einen Service eingeben',0),(343188,9533,'en','You Must First Enter A Service Type',0),(343189,9534,'is','',0),(343190,9534,'dr','Ø³Ø§Ø®ØªÙ…Ø§Ù† ',0),(343191,9534,'pr','Ø³Ø§Ø®ØªÙ…Ø§Ù† ',0),(343192,9534,'tr','Bina',0),(343193,9534,'pl','Budynek',0),(343194,9534,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð°',0),(343195,9534,'ur','Ø¹Ù…Ø§Ø±Øª',0),(343196,9534,'sr','Ð—Ð³Ñ€Ð°Ð´Ð°',0),(343197,9534,'vi','Thiáº¿t ká»',0),(343198,9534,'af','Gebou',0),(343199,9534,'ro','ClÄƒdire',0),(343200,9534,'et','Hoone',0),(343201,9534,'si','Stavbe',0),(343202,9534,'ba','Bangunan',0),(343203,9534,'nl','Gebouw',0),(343204,9534,'fi','Rakennus',0),(343205,9534,'no','Bygning',0),(343206,9534,'da','Bygning',0),(343207,9534,'ko','ê±´ë¬¼',0),(343208,9534,'he','×‘× ×™×™×Ÿ',0),(343209,9534,'el','ÎšÏ„Î¯ÏÎ¹Î¿',0),(343210,9534,'zh','å»ºè®¾\r\n',0),(343211,9534,'sv','Byggnad',0),(343212,9534,'it','Costruzione',0),(343213,9534,'tl','',0),(343214,9534,'th','&#3629;&#3634;&#3588;&#3634;&#3619;',0),(343215,9534,'hi','à¤¬à¤¿à¤²à¥à¤¡à¤¿à¤‚à¤—',0),(343216,9534,'ms','Bangunan',0),(343217,9534,'ar','Ø¨Ù†Ø§Ø¡',0),(343218,9534,'fr','BÃ¢timent',0),(343219,9534,'jp','å»ºç‰©',0),(343220,9534,'pt','EdifÃ­cio',0),(343221,9534,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ',0),(343222,9534,'es','Edificio',0),(343223,9534,'de','GebÃ¤ude',0),(343224,9534,'en','Building',0),(343225,9535,'is','',0),(343226,9535,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343227,9535,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343228,9535,'tr','YapÄ± Ekle',0),(343229,9535,'pl','Budynku Dodaj',0),(343230,9535,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°',0),(343231,9535,'ur','Ø¹Ù…Ø§Ø±Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(343232,9535,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(343233,9535,'vi','ThÃªm thiáº¿t káº¿t',0),(343234,9535,'af','Gebou Byvoeg',0),(343235,9535,'ro','Adauga clÄƒdire',0),(343236,9535,'et','Hoone lisamine',0),(343237,9535,'si','Dodaj stavbe',0),(343238,9535,'ba','Menambahkan bangunan',0),(343239,9535,'nl','Gebouw toevoegen',0),(343240,9535,'fi','Rakennuksen lisÃ¤Ã¤',0),(343241,9535,'no','Bygningen legge',0),(343242,9535,'da','Bygning tilfÃ¸je',0),(343243,9535,'ko','ê±´ë¬¼ ì¶”ê°€',0),(343244,9535,'he','×”×•×¡×¤×ª ×‘× ×™×™×Ÿ',0),(343245,9535,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(343246,9535,'zh','æ–°å¢žå»ºè®¾\r\n',0),(343247,9535,'sv','Byggnaden lÃ¤gga',0),(343248,9535,'it','Aggiungi edificio',0),(343249,9535,'tl','',0),(343250,9535,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(343251,9535,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(343252,9535,'ms','Menambah bangunan',0),(343253,9535,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø§Ø¡',0),(343254,9535,'fr','Ajouter du bÃ¢timent',0),(343255,9535,'jp','å»ºç‰©ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(343256,9535,'pt','Adicionar o edifÃ­cio',0),(343257,9535,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð´Ð°Ð½Ð¸Ðµ',0),(343258,9535,'es','Agregar Edificio',0),(343259,9535,'de','GebÃ¤ude hinzufÃ¼gen',0),(343260,9535,'en','Building Add',0),(343261,9536,'is','',0),(343262,9536,'dr','Ø­Ø°Ù Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343263,9536,'pr','Ø­Ø°Ù Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343264,9536,'tr','Bina Sil',0),(343265,9536,'pl','Delete budynku',0),(343266,9536,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°',0),(343267,9536,'ur','Ø¹Ù…Ø§Ø±Øª Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(343268,9536,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð”ÐµÐ»ÐµÑ‚Ðµ',0),(343269,9536,'vi','XÃ³a thiáº¿t káº¿',0),(343270,9536,'af','Gebou Skrap',0),(343271,9536,'ro','ClÄƒdire ÅŸterge',0),(343272,9536,'et','Hoone Kustuta',0),(343273,9536,'si','Brisanje stavbe',0),(343274,9536,'ba','Hapus bangunan',0),(343275,9536,'nl','Gebouw verwijderen',0),(343276,9536,'fi','Rakennuksen Poista',0),(343277,9536,'no','Bygningen Slett',0),(343278,9536,'da','Bygning slet',0),(343279,9536,'ko','ê±´ë¬¼ ì‚­ì œ',0),(343280,9536,'he','×ž×—×™×§×ª ×‘× ×™×™×Ÿ',0),(343281,9536,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(343282,9536,'zh','å»ºè®¾åˆ é™¤\r\n',0),(343283,9536,'sv','Byggnaden Delete',0),(343284,9536,'it','Elimina edificio',0),(343285,9536,'tl','',0),(343286,9536,'th','&#3621;&#3610;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(343287,9536,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤¹à¤Ÿà¤¾à¤à¤',0),(343288,9536,'ms','Hapus bangunan',0),(343289,9536,'ar','Ø­Ø°Ù Ø¨Ù†Ø§Ø¡',0),(343290,9536,'fr','Suppression de bÃ¢timent',0),(343291,9536,'jp','å»ºç‰©å‰Šé™¤',0),(343292,9536,'pt','EdifÃ­cio Delete',0),(343293,9536,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð·Ð´Ð°Ð½Ð¸Ðµ',0),(343294,9536,'es','Agregar Edificio',0),(343295,9536,'de','GebÃ¤ude lÃ¶schen',0),(343296,9536,'en','Building Delete',0),(343297,9537,'is','',0),(343298,9537,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343299,9537,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343300,9537,'tr','Bina gÃ¼ncelleÅŸtirme',0),(343301,9537,'pl','Budowania â€” aktualizacja',0),(343302,9537,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(343303,9537,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(343304,9537,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(343305,9537,'vi','áº­p nCháº­t thiáº¿t káº¿',0),(343306,9537,'af','Gebou bywerking',0),(343307,9537,'ro','Constructii Update',0),(343308,9537,'et','Hoone vÃ¤rskendus',0),(343309,9537,'si','Posodobitev stavbe',0),(343310,9537,'ba','Bangunan Update',0),(343311,9537,'nl','Gebouw Update',0),(343312,9537,'fi','Rakennuksen pÃ¤ivitys',0),(343313,9537,'no','Bygg oppdatering',0),(343314,9537,'da','Bygning opdatering',0),(343315,9537,'ko','ê±´ë¬¼ ì—…ë°ì´íŠ¸',0),(343316,9537,'he','×¢×“×›×•×Ÿ ×‘× ×™×™×Ÿ',0),(343317,9537,'el','ÎšÏ„Î¯ÏÎ¹Î¿ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(343318,9537,'zh','å»ºè®¾æ›´æ–°\r\n',0),(343319,9537,'sv','Byggnaden uppdatering',0),(343320,9537,'it','Aggiornamento della costruzione',0),(343321,9537,'tl','',0),(343322,9537,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(343323,9537,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(343324,9537,'ms','Bangunan kemas',0),(343325,9537,'ar','Ø¨Ù†Ø§Ø¡ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(343326,9537,'fr','Mise Ã  jour de construction',0),(343327,9537,'jp','å»ºç‰©ã®æ›´æ–°',0),(343328,9537,'pt','AtualizaÃ§Ã£o do edifÃ­cio',0),(343329,9537,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(343330,9537,'es','Actualizar Edificio',0),(343331,9537,'de','GebÃ¤ude-Update',0),(343332,9537,'en','Building Update',0),(343333,9538,'is','',0),(343334,9538,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343335,9538,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343336,9538,'tr','Bina eklenirken bir hata oluÅŸtu',0),(343337,9538,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania budynku',0),(343338,9538,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°',0),(343339,9538,'ur','Ø¹Ù…Ø§Ø±Øª Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(343340,9538,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(343341,9538,'vi','Lá»—i thÃªm thiáº¿t káº¿',0),(343342,9538,'af','Fout voeg gebou',0),(343343,9538,'ro','Eroare la adÄƒugarea clÄƒdire',0),(343344,9538,'et','Viga lisades hoone',0),(343345,9538,'si','Napaka pri dodajanju stavbe',0),(343346,9538,'ba','Kesalahan menambahkan bangunan',0),(343347,9538,'nl','Fout het toevoegen van gebouw',0),(343348,9538,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ rakennus',0),(343349,9538,'no','Feil under tillegging av bygningen',0),(343350,9538,'da','Fejl ved tilfÃ¸jelse af bygning',0),(343351,9538,'ko','ê±´ë¬¼ì„ ì¶”ê°€ í•˜ëŠ” ì˜¤ë¥˜',0),(343352,9538,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×‘× ×™×™×Ÿ',0),(343353,9538,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(343354,9538,'zh','é”™è¯¯ï¼šæ–°å¢žå»ºè®¾\r\n',0),(343355,9538,'sv','Ett fel uppstod nÃ¤r byggnaden',0),(343356,9538,'it','Errore durante l\'aggiunta di edificio',0),(343357,9538,'tl','',0),(343358,9538,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(343359,9538,'hi','à¤¬à¤¿à¤²à¥à¤¡à¤¿à¤‚à¤— à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(343360,9538,'ms','Ralat menambah bangunan',0),(343361,9538,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø§Ø¡',0),(343362,9538,'fr','Erreur en ajoutant le bÃ¢timent',0),(343363,9538,'jp','å»ºç‰©ã®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(343364,9538,'pt','Erro ao adicionar o edifÃ­cio',0),(343365,9538,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(343366,9538,'es','Error Agregando Edificio',0),(343367,9538,'de','Fehler beim HinzufÃ¼gen des GebÃ¤udes',0),(343368,9538,'en','Error Adding Building',0),(343369,9539,'is','',0),(343370,9539,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(343371,9539,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(343372,9539,'tr','Bina baÅŸarÄ±yla eklendi',0),(343373,9539,'pl','Budynek dodany pomyÅ›lnie',0),(343374,9539,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(343375,9539,'ur','Ø¹Ù…Ø§Ø±Øª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(343376,9539,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(343377,9539,'vi','ThÃªm thiáº¿t káº¿ thÃ nh cÃ´ng',0),(343378,9539,'af','Gebou Suksesvol Bygevoeg',0),(343379,9539,'ro','ClÄƒdire adÄƒugat cu succes',0),(343380,9539,'et','Hoone on edukalt',0),(343381,9539,'si','Stavbe, ki so dodani',0),(343382,9539,'ba','Bangunan yang ditambahkan berhasil',0),(343383,9539,'nl','Gebouw toegevoegd',0),(343384,9539,'fi','Rakennuksen lisÃ¤Ã¤minen onnistui',0),(343385,9539,'no','Bygningen ble lagt til',0),(343386,9539,'da','Bygningen tilfÃ¸jet',0),(343387,9539,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ê±´ë¬¼',0),(343388,9539,'he','×‘× ×™×™×Ÿ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(343389,9539,'el','ÎšÏ„Î®ÏÎ¹Î¿ Ï€Î¿Ï… Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(343390,9539,'zh','å»ºè®¾æ·»åŠ æˆåŠŸ\r\n',0),(343391,9539,'sv','Byggnaden som lagts',0),(343392,9539,'it','Edificio aggiunto con successo',0),(343393,9539,'tl','',0),(343394,9539,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3629;&#3634;&#3588;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(343395,9539,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(343396,9539,'ms','Berjaya menambah bangunan',0),(343397,9539,'ar','Ø¨Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(343398,9539,'fr','BÃ¢timent ajoutÃ© avec succÃ¨s',0),(343399,9539,'jp','æ­£å¸¸ã«è¿½åŠ ã®å»ºç‰©',0),(343400,9539,'pt','EdifÃ­cio adicionado com sucesso',0),(343401,9539,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(343402,9539,'es','Edificio Agregado Exitosamente',0),(343403,9539,'de','GebÃ¤ude wurde erfolgreich hinzugefÃ¼gt',0),(343404,9539,'en','Building Added Successfully',0),(343405,9540,'is','',0),(343406,9540,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343407,9540,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343408,9540,'tr','Bina silme hatasÄ±',0),(343409,9540,'pl','BÅ‚Ä…d podczas usuwania budynku',0),(343410,9540,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°',0),(343411,9540,'ur','Ø¹Ù…Ø§Ø±Øª Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(343412,9540,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(343413,9540,'vi','XÃ³a lá»—i thiáº¿t káº¿ ',0),(343414,9540,'af','Fout gebou te skrap',0),(343415,9540,'ro','Eroare la È™tergerea cladirea',0),(343416,9540,'et','TÃµrge kustutamisel hoone',0),(343417,9540,'si','Napaka brisanja objekta',0),(343418,9540,'ba','Error menghapus bangunan',0),(343419,9540,'nl','Fout bij het verwijderen van gebouw',0),(343420,9540,'fi','Virhe poistettaessa rakennus',0),(343421,9540,'no','Feil ved sletting av bygningen',0),(343422,9540,'da','Fejl ved sletning af bygning',0),(343423,9540,'ko','ê±´ë¬¼ì„ ì‚­ì œ ì˜¤ë¥˜',0),(343424,9540,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×‘× ×™×™×Ÿ',0),(343425,9540,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(343426,9540,'zh','é”™è¯¯åˆ é™¤å»ºè®¾\r\n',0),(343427,9540,'sv','Misstag utplÃ¥nande byggnad',0),(343428,9540,'it','Errore durante l\'eliminazione di edificio',0),(343429,9540,'tl','',0),(343430,9540,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3621;&#3610;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(343431,9540,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(343432,9540,'ms','Ralat Menghapuskan bangunan',0),(343433,9540,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø¨Ù†Ø§Ø¡',0),(343434,9540,'fr','Erreur de suppression de bÃ¢timent',0),(343435,9540,'jp','å»ºç‰©ã®å‰Šé™¤ã‚¨ãƒ©ãƒ¼',0),(343436,9540,'pt','Erro ao excluir o edifÃ­cio',0),(343437,9540,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(343438,9540,'es','Error Eliminando Edificio',0),(343439,9540,'de','Fehler beim LÃ¶schen der GebÃ¤ude',0),(343440,9540,'en','Error Deleting Building',0),(343441,9541,'is','',0),(343442,9541,'dr','Ø­Ø°Ù Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(343443,9541,'pr','Ø­Ø°Ù Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(343444,9541,'tr','Bina baÅŸarÄ±yla silindi',0),(343445,9541,'pl','Budynek usuniÄ™ty',0),(343446,9541,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(343447,9541,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©ÛŒ Ø¹Ù…Ø§Ø±Øª',0),(343448,9541,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(343449,9541,'vi','XÃ³a lá»—i thiáº¿t káº¿ thÃ nh cÃ´ng',0),(343450,9541,'af','Gebou Suksesvol Geskrap',0),(343451,9541,'ro','ClÄƒdire eliminÄƒ cu succes',0),(343452,9541,'et','Hoone edukalt kustutatud',0),(343453,9541,'si','Stavbe, ki se uspeÅ¡no izbrisana',0),(343454,9541,'ba','Bangunan yang dihapus berhasil',0),(343455,9541,'nl','Gebouw met succes verwijderd',0),(343456,9541,'fi','Rakennuksen poistettu',0),(343457,9541,'no','Bygningen ble slettet',0),(343458,9541,'da','Bygning slettet',0),(343459,9541,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ê±´ë¬¼',0),(343460,9541,'he','×‘× ×™×™×Ÿ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(343461,9541,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(343462,9541,'zh','å»ºè®¾æˆåŠŸåˆ é™¤\r\n',0),(343463,9541,'sv','Byggnaden raderades',0),(343464,9541,'it','Costruzione eliminato con successo',0),(343465,9541,'tl','',0),(343466,9541,'th','&#3621;&#3610;&#3629;&#3634;&#3588;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(343467,9541,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(343468,9541,'ms','Bangunan dihapuskan dengan jayanya',0),(343469,9541,'ar','Ø¨Ù†Ø§Ø¡ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(343470,9541,'fr','Ã‰difice supprimÃ© avec succÃ¨s',0),(343471,9541,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸå»ºç‰©',0),(343472,9541,'pt','EdifÃ­cio excluÃ­do com sucesso',0),(343473,9541,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾',0),(343474,9541,'es','Edificio Eliminado Exitosamente',0),(343475,9541,'de','GebÃ¤ude wurde erfolgreich gelÃ¶scht',0),(343476,9541,'en','Building Deleted Successfully',0),(343477,9542,'is','',0),(343478,9542,'dr','Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343479,9542,'pr','Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343480,9542,'tr','Bina tipi',0),(343481,9542,'pl','Typ budynku',0),(343482,9542,'bg','Ð¢Ð¸Ð¿ ÑÐ³Ñ€Ð°Ð´Ð°',0),(343483,9542,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù‚Ø³Ù…',0),(343484,9542,'sr','Ð¢Ð¸Ð¿ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(343485,9542,'vi','Loáº¡i tháº¿ káº¿',0),(343486,9542,'af','Gebou tipe',0),(343487,9542,'ro','Tip cladire',0),(343488,9542,'et','Hoone tÃ¼Ã¼p',0),(343489,9542,'si','Tip stavbe',0),(343490,9542,'ba','Jenis bangunan',0),(343491,9542,'nl','Gebouw Type',0),(343492,9542,'fi','Rakennuksen tyyppi',0),(343493,9542,'no','Building Type',0),(343494,9542,'da','Bygningen Type',0),(343495,9542,'ko','ê±´ë¬¼ ìœ í˜•',0),(343496,9542,'he','×¡×•×’ ×ž×‘× ×”',0),(343497,9542,'el','Î¤ÏÏ€Î¿Ï‚ ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(343498,9542,'zh','å»ºç­‘ç±»åž‹\r\n',0),(343499,9542,'sv','Byggnadstyp',0),(343500,9542,'it','Tipo di edificio',0),(343501,9542,'tl','',0),(343502,9542,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(343503,9542,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(343504,9542,'ms','Jenis bangunan',0),(343505,9542,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(343506,9542,'fr','Type de bÃ¢timent',0),(343507,9542,'jp','å»ºç‰©ã‚¿ã‚¤ãƒ—',0),(343508,9542,'pt','Tipo de edifÃ­cio',0),(343509,9542,'ru','Ð¢Ð¸Ð¿ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(343510,9542,'es','Tipo de Edificio',0),(343511,9542,'de','GebÃ¤udetyp',0),(343512,9542,'en','Building Type',0),(343513,9543,'is','',0),(343514,9543,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343515,9543,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343516,9543,'tr','Bina gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(343517,9543,'pl','BÅ‚Ä…d aktualizacji budynku',0),(343518,9543,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°',0),(343519,9543,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(343520,9543,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(343521,9543,'vi','Lá»—i cáº­p nháº­t thiáº¿t káº¿',0),(343522,9543,'af','Fout bywerking van gebou',0),(343523,9543,'ro','Eroare la actualizarea clÄƒdire',0),(343524,9543,'et','TÃµrge vÃ¤rskendamisel hoone',0),(343525,9543,'si','Napaka pri posodabljanju stavbe',0),(343526,9543,'ba','Kesalahan memperbarui bangunan',0),(343527,9543,'nl','Fout bij het bijwerken van gebouw',0),(343528,9543,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ rakennus',0),(343529,9543,'no','Feil under oppdatering av bygningen',0),(343530,9543,'da','Fejl under opdatering af bygning',0),(343531,9543,'ko','ê±´ë¬¼ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(343532,9543,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×‘× ×™×™×Ÿ',0),(343533,9543,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(343534,9543,'zh','é”™è¯¯æ›´æ–°å»ºè®¾\r\n',0),(343535,9543,'sv','Fel vid uppdatering av byggnad',0),(343536,9543,'it','Errore durante l\'aggiornamento di costruzione',0),(343537,9543,'tl','',0),(343538,9543,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(343539,9543,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(343540,9543,'ms','Ralat dalam mengemas kini bangunan',0),(343541,9543,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(343542,9543,'fr','Erreur mise Ã  jour de construction',0),(343543,9543,'jp','å»ºç‰©ã®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(343544,9543,'pt','Erro ao atualizar o edifÃ­cio',0),(343545,9543,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(343546,9543,'es','Error Actualizando Edificio',0),(343547,9543,'de','Fehler beim Aktualisieren der GebÃ¤ude',0),(343548,9543,'en','Error Updating Building',0),(343549,9544,'is','',0),(343550,9544,'dr','Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(343551,9544,'pr','Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(343552,9544,'tr','Bina baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(343553,9544,'pl','Budynek pomyÅ›lnie zaktualizowana',0),(343554,9544,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(343555,9544,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(343556,9544,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(343557,9544,'vi','Cáº­p nháº­t thiáº¿t káº¿ thÃ nh cÃ´ng',0),(343558,9544,'af','Gebou Suksesvol Opdateer',0),(343559,9544,'ro','Constructii actualizat cu succes',0),(343560,9544,'et','Hoone vÃ¤rskendatud',0),(343561,9544,'si','Stavbe, ki je uspeÅ¡no posodobljena',0),(343562,9544,'ba','Bangunan yang berhasil',0),(343563,9544,'nl','Gebouw bijgewerkt',0),(343564,9544,'fi','Rakennuksen pÃ¤ivitetty',0),(343565,9544,'no','Bygningen ble oppdatert',0),(343566,9544,'da','Bygning opdateret',0),(343567,9544,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ê±´ë¬¼',0),(343568,9544,'he','×‘× ×™×™×Ÿ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(343569,9544,'el','ÎšÏ„Î¯ÏÎ¹Î¿ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(343570,9544,'zh','å»ºç­‘æˆåŠŸæ›´æ–°\r\n',0),(343571,9544,'sv','Byggnaden som uppdaterats',0),(343572,9544,'it','Interamente rinnovato con successo',0),(343573,9544,'tl','',0),(343574,9544,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(343575,9544,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(343576,9544,'ms','Bangunan yang berjaya dikemas kini',0),(343577,9544,'ar','Ø¨Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(343578,9544,'fr','BÃ¢timent mis Ã  jour avec succÃ¨s',0),(343579,9544,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸå»ºç‰©',0),(343580,9544,'pt','EdifÃ­cio atualizado com sucesso',0),(343581,9544,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(343582,9544,'es','Edificio Actualizado Exitosamente',0),(343583,9544,'de','GebÃ¤ude wurde erfolgreich aktualisiert',0),(343584,9544,'en','Building Updated Successfully',0),(343585,9545,'is','',0),(343586,9545,'dr','Ø­Ø°Ù Ø³Ø§Ø®ØªÙ…Ø§Ù† ',0),(343587,9545,'pr','Ø­Ø°Ù Ø³Ø§Ø®ØªÙ…Ø§Ù† ',0),(343588,9545,'tr','Silme bina',0),(343589,9545,'pl','DELETE budynku',0),(343590,9545,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ ÑÐ³Ñ€Ð°Ð´Ð°',0),(343591,9545,'ur','Ø­Ø°Ù Ú©ÛŒ Ø¹Ù…Ø§Ø±Øª',0),(343592,9545,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð·Ð³Ñ€Ð°Ð´Ð°',0),(343593,9545,'vi','XÃ³a cáº¥u trÃºc',0),(343594,9545,'af','Skrap Gebou',0),(343595,9545,'ro','Åžterge clÄƒdire',0),(343596,9545,'et','Kustuta hoone',0),(343597,9545,'si','Brisanje stavbe',0),(343598,9545,'ba','Hapus bangunan',0),(343599,9545,'nl','Delete gebouw',0),(343600,9545,'fi','Poista rakennus',0),(343601,9545,'no','Slett bygningen',0),(343602,9545,'da','Slet bygning',0),(343603,9545,'ko','ì‚­ì œ ê±´ë¬¼',0),(343604,9545,'he','×ž×—×§ ×‘× ×™×™×Ÿ',0),(343605,9545,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(343606,9545,'zh','åˆ é™¤å¤§æ¥¼\r\n',0),(343607,9545,'sv','Ta bort byggnaden',0),(343608,9545,'it','Elimina Building',0),(343609,9545,'tl','',0),(343610,9545,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(343611,9545,'hi','Delete à¤¬à¤¿à¤²à¥à¤¡à¤¿à¤‚à¤—',0),(343612,9545,'ms','Bangunan Hapus',0),(343613,9545,'ar','Ø¨Ù†Ø§Ø¡ Ø­Ø°Ù',0),(343614,9545,'fr','BÃ¢timent de Delete',0),(343615,9545,'jp','å‰Šé™¤å»ºç‰©',0),(343616,9545,'pt','EdifÃ­cio de Delete',0),(343617,9545,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð·Ð´Ð°Ð½Ð¸Ðµ',0),(343618,9545,'es','Eliminar Edificio',0),(343619,9545,'de','GebÃ¤ude lÃ¶schen',0),(343620,9545,'en','Delete Building',0),(343621,9546,'is','',0),(343622,9546,'dr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø§Ø¬Ø§Ø±Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(343623,9546,'pr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø§Ø¬Ø§Ø±Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(343624,9546,'tr','EmlakÃ§Ä±yla',0),(343625,9546,'pl','Agentem',0),(343626,9546,'bg','ÐÐ³ÐµÐ½Ñ‚ Ð¿Ð¾ Ð¾Ñ‚Ð´Ð°Ð²Ð°Ð½Ðµ',0),(343627,9546,'ur','Ø³Ù†Øª Ú©ÛŒ Ø´Ø±Ø­ÛŒÚº Ø§ÛŒØ¬Ù†Ù¹',0),(343628,9546,'sr','Ð›Ð¸Ð·Ð¸Ð½Ð³ ÐÐ³ÐµÐ½Ñ‚',0),(343629,9546,'vi','Ä‘áº¡i lÃ½ thuÃª',0),(343630,9546,'af','Verhuring Agent',0),(343631,9546,'ro','Agent de leasing',0),(343632,9546,'et','Liisingu esindaja',0),(343633,9546,'si','Najem Agent',0),(343634,9546,'ba','Agen Penyewaan',0),(343635,9546,'nl','Leasing van Agent',0),(343636,9546,'fi','Leasing agentti',0),(343637,9546,'no','Leie Agent',0),(343638,9546,'da','Leasing Agent',0),(343639,9546,'ko','ìž„ëŒ€ ì—ì´ì „íŠ¸',0),(343640,9546,'he','×”×¡×•×›×Ÿ ×”×ž×©×›×™×¨',0),(343641,9546,'el','Î•ÎºÎ¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· Î±Î½Ï„Î¹Ï€ÏÏŒÏƒÏ‰Ï€Î¿Ï‚',0),(343642,9546,'zh','ç§Ÿèµä»£ç†\r\n',0),(343643,9546,'sv','Operationell leasing Agent',0),(343644,9546,'it','Agente di leasing',0),(343645,9546,'tl','',0),(343646,9546,'th','&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3621;&#3636;&#3626;&#3595;&#3636;&#3656;&#3591;',0),(343647,9546,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(343648,9546,'ms','Pajakan ejen',0),(343649,9546,'ar','ÙˆÙƒÙŠÙ„ Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(343650,9546,'fr','Agent de location',0),(343651,9546,'jp','è³ƒè²¸ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆ',0),(343652,9546,'pt','Agente de locaÃ§Ã£o',0),(343653,9546,'ru','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð°Ð³ÐµÐ½Ñ‚',0),(343654,9546,'es','Agente de Arrendamiento',0),(343655,9546,'de','Leasing-Agent',0),(343656,9546,'en','Leasing Agent',0),(343657,9547,'is','',0),(343658,9547,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ ',0),(343659,9547,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ ',0),(343660,9547,'tr','YÃ¶netim Ã¼creti',0),(343661,9547,'pl','OpÅ‚ata za zarzÄ…dzanie',0),(343662,9547,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(343663,9547,'ur','Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ ÙÛŒØ³',0),(343664,9547,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ð° Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ',0),(343665,9547,'vi','phÃ­ quáº£n lÃ½',0),(343666,9547,'af','Bestuursfooi',0),(343667,9547,'ro','Taxa de administrare',0),(343668,9547,'et','Tasu',0),(343669,9547,'si','Pristojbine za upravljanje',0),(343670,9547,'ba','Biaya manajemen',0),(343671,9547,'nl','Beheersvergoeding',0),(343672,9547,'fi','Hallinnointipalkkio',0),(343673,9547,'no','Forvaltningshonorar',0),(343674,9547,'da','Administrationsgebyr',0),(343675,9547,'ko','ê´€ë¦¬ ë¹„ìš©',0),(343676,9547,'he','×“×ž×™ × ×™×”×•×œ',0),(343677,9547,'el','ÎˆÎ¾Î¿Î´Î± Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚',0),(343678,9547,'zh','ç®¡ç†è´¹\r\n',0),(343679,9547,'sv','FÃ¶rvaltningsavgift',0),(343680,9547,'it','Commissioni di gestione',0),(343681,9547,'tl','',0),(343682,9547,'th','&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;',0),(343683,9547,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤¶à¥à¤²à¥à¤•',0),(343684,9547,'ms','Yuran pengurusan',0),(343685,9547,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥Ø¯Ø§Ø±Ø©',0),(343686,9547,'fr','Frais de gestion',0),(343687,9547,'jp','ç®¡ç†è²»',0),(343688,9547,'pt','Taxa de administraÃ§Ã£o',0),(343689,9547,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(343690,9547,'es','ComisiÃ³n de GestiÃ³n',0),(343691,9547,'de','Management-Fee',0),(343692,9547,'en','Management Fee',0),(343693,9548,'is','',0),(343694,9548,'dr','  ÙØ±Ø§ØªØ± Ø§Ø² Ø§Ù†ØªØ¸Ø§Ø± ',0),(343695,9548,'pr','  ÙØ±Ø§ØªØ± Ø§Ø² Ø§Ù†ØªØ¸Ø§Ø± ',0),(343696,9548,'tr','Fiorentina Cap',0),(343697,9548,'pl','Nadmiar Cap',0),(343698,9548,'bg','ÐžÑ‚Ð¾Ð¿Ð»Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ ÐºÐ°Ð¿Ð°Ñ‡ÐºÐ°',0),(343699,9548,'ur','Ø§ÙˆÙˆØ±Ø§Ø¬ Ù¹ÙˆÙ¾ÛŒ',0),(343700,9548,'sr','ÐŸÑ€ÐµÑÑ‚Ð°Ñ€ ÐºÐ°Ð¿Ñƒ',0),(343701,9548,'vi','vÆ°á»£t sá»‘ tiá»n dÆ°',0),(343702,9548,'af','Overage pet',0),(343703,9548,'ro','Supradozarea Cap',0),(343704,9548,'et','Aegunud kork',0),(343705,9548,'si','Overage SKP',0),(343706,9548,'ba','Kelebihan Cap',0),(343707,9548,'nl','Overdosering Cap',0),(343708,9548,'fi','Yli-ikÃ¤inen Cap',0),(343709,9548,'no','Overage Cap',0),(343710,9548,'da','Overdosering Cap',0),(343711,9548,'ko','ë„˜ëŠ” ëª¨ìž',0),(343712,9548,'he','×›×•×‘×¢ ×¢×•×“×¤×•×ª',0),(343713,9548,'el','Î ÎµÏÎ¯ÏƒÏƒÎµÎ¹Î± ÎšÎ‘Î ',0),(343714,9548,'zh','è¶…é¾„ä¸Šé™\r\n',0),(343715,9548,'sv','Ã–versatsning Cap',0),(343716,9548,'it','Fuoriquota Cap',0),(343717,9548,'tl','',0),(343718,9548,'th','Overage Cap',0),(343719,9548,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤Ÿà¥‹à¤ªà¥€',0),(343720,9548,'ms','Overage Cap',0),(343721,9548,'ar','Ø³Ù‚Ù Ø§Ù„ØªØºØ·ÙŠØ©',0),(343722,9548,'fr','Cap excÃ©dentaire',0),(343723,9548,'jp','è¶…éŽã‚­ãƒ£ãƒƒãƒ—',0),(343724,9548,'pt','Cap excedente',0),(343725,9548,'ru','ÐŸÐµÑ€ÐµÑ€Ð¾ÑÑˆÐ¸Ð¹ Cap',0),(343726,9548,'es','Tope de Sobre Edad',0),(343727,9548,'de','Overage Cap',0),(343728,9548,'en','Overage Cap',0),(343729,9549,'is','',0),(343730,9549,'dr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(343731,9549,'pr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(343732,9549,'tr','Mutlu etmek katmak bina tipi',0),(343733,9549,'pl','Prosimy o podanie typu budynku',0),(343734,9549,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿ ÑÐ³Ñ€Ð°Ð´Ð°',0),(343735,9549,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¹Ù…Ø§Ø±Øª Ù‚Ø³Ù… Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(343736,9549,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð²Ñ€ÑÑ‚Ñƒ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(343737,9549,'vi','vui lÃ²ng bao gá»“m loáº¡i cáº¥u trÃºc',0),(343738,9549,'af','Sluit asb. \'n Gebou Tipe in',0),(343739,9549,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i clÄƒdire tip',0),(343740,9549,'et','Palun lisa hoone tÃ¼Ã¼p',0),(343741,9549,'si','Prosimo, da vkljuÄite stavbe tipa',0),(343742,9549,'ba','Sertakan tipe bangunan',0),(343743,9549,'nl','Gelieve te omvatten gebouw Type',0),(343744,9549,'fi','LiitÃ¤ mukaan rakennuksen tyyppi',0),(343745,9549,'no','Behage inkludere bygningen',0),(343746,9549,'da','VedlÃ¦g bygning Type',0),(343747,9549,'ko','ê±´ë¬¼ ìœ í˜•ì— í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(343748,9549,'he','× × ×œ×›×œ×•×œ ×¡×•×’ ×ž×‘× ×”',0),(343749,9549,'el','Î Î±ÏÎ±ÎºÎ±Î»ÎµÎ¯ÏƒÏ„Îµ Î½Î± Î±Î½Î±Ï†Î­ÏÎµÏ„Îµ Ï„Î¿Î½ Ï„ÏÏ€Î¿ Ï„Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(343750,9549,'zh','è¯·åˆ—å…¥å»ºç­‘ç±»åž‹\r\n',0),(343751,9549,'sv','VÃ¤nligen inkludera byggnadstyp',0),(343752,9549,'it','Si prega di includere tipo di edificio',0),(343753,9549,'tl','',0),(343754,9549,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(343755,9549,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤‡à¤®à¤¾à¤°à¤¤ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(343756,9549,'ms','Sila sertakan jenis bangunan',0),(343757,9549,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ù†ÙˆØ¹ Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(343758,9549,'fr','Veuillez indiquer le Type de bÃ¢timent',0),(343759,9549,'jp','å»ºç‰©ã®ç¨®é¡žã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(343760,9549,'pt','Por favor inclua o tipo de edifÃ­cio',0),(343761,9549,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(343762,9549,'es','Por Favor Incluye Tipo de Edificio',0),(343763,9549,'de','Bitte fÃ¼gen Sie GebÃ¤udetyp',0),(343764,9549,'en','Please Include Building Type',0),(343765,9550,'is','',0),(343766,9550,'dr','Ù„Ø·ÙØ§ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø§Ø¬Ø§Ø±Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(343767,9550,'pr','Ù„Ø·ÙØ§ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø§Ø¬Ø§Ø±Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(343768,9550,'tr','LÃ¼tfen Ajan Kiralama dahil',0),(343769,9550,'pl','Prosimy o podanie, Leasing agenta',0),(343770,9550,'bg','ÐœÐ¾Ð»Ñ, Ð²ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¾Ñ‚Ð´Ð°Ð²Ð°Ð½Ðµ Ð¿Ð¾Ð´ Ð½Ð°ÐµÐ¼ Ð°Ð³ÐµÐ½Ñ‚',0),(343771,9550,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒØ¬Ù†Ù¹ Ø¬ÙÚ¾ÙˆÙ¹ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(343772,9550,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³ ÐÐ³ÐµÐ½Ñ‚',0),(343773,9550,'vi','Vui lÃ²ng bao gá»“m Ä‘áº¡i lÃ½ thuÃª',0),(343774,9550,'af','Sluit Asseblief \'n Verhuringsagent in',0),(343775,9550,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i Agent de Leasing',0),(343776,9550,'et','Palun lisa liisingu agent',0),(343777,9550,'si','Prosimo, vkljuÄite lizing Agent',0),(343778,9550,'ba','Harap sertakan Leasing agen',0),(343779,9550,'nl','Gelieve te omvatten Leasing Agent',0),(343780,9550,'fi','LiitÃ¤ Leasing agentti',0),(343781,9550,'no','Ta Leasing Agent',0),(343782,9550,'da','Inkluder venligst Leasing Agent',0),(343783,9550,'ko','ìž„ëŒ€ ì—ì´ì „íŠ¸ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(343784,9550,'he','×× × ×›×œ×•×œ ×¡×•×›×Ÿ ×”×©×›×¨×”',0),(343785,9550,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Ï‡ÏÎ·Î¼Î±Ï„Î¿Î´Î¿Ï„Î¹ÎºÎ® Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î±',0),(343786,9550,'zh','è¯·åˆ—å…¥ç§Ÿèµä»£ç†\r\n',0),(343787,9550,'sv','VÃ¤nligen inkludera Leasing Agent',0),(343788,9550,'it','Si prega di includere Leasing Agent',0),(343789,9550,'tl','',0),(343790,9550,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3651;&#3626;&#3656;&#3605;&#3633;&#3623;&#3649;&#3607;&#3609;&#3621;&#3637;&#3626;&#3595;&#3636;&#3656;&#3591;\n',0),(343791,9550,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤²à¥€à¤œà¤¿à¤‚à¤— à¤à¤œà¥‡à¤‚à¤Ÿ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(343792,9550,'ms','Sila sertakan pajakan ejen',0),(343793,9550,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ù„ØªØ£Ø¬ÙŠØ± ÙˆÙƒÙŠÙ„',0),(343794,9550,'fr','Veuillez y inclure la location Agent',0),(343795,9550,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã‚’ãƒªãƒ¼ã‚¹ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(343796,9550,'pt','Por favor inclua o agente de locaÃ§Ã£o',0),(343797,9550,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð°Ð³ÐµÐ½Ñ‚',0),(343798,9550,'es','Por Favor Incluye Agente de Arrendamiento',0),(343799,9550,'de','Bitte fÃ¼gen Sie Agent Leasing',0),(343800,9550,'en','Please Include Leasing Agent',0),(343801,9551,'is','',0),(343802,9551,'dr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(343803,9551,'pr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(343804,9551,'tr','LÃ¼tfen adÄ±nÄ± iÃ§erir',0),(343805,9551,'pl','Podaj nazwÄ™',0),(343806,9551,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¸Ð¼ÐµÑ‚Ð¾',0),(343807,9551,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù†Ø§Ù… Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(343808,9551,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð´Ð° ÑÐ°Ð´Ñ€Ð¶Ð¸ Ð¸Ð¼Ðµ',0),(343809,9551,'vi','vui lÃ²ng bao gá»“m tÃªn',0),(343810,9551,'af','Sluit asb. Naam In',0),(343811,9551,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i numele',0),(343812,9551,'et','Palun lisa nimi',0),(343813,9551,'si','Prosimo, vkljuÄite ime',0),(343814,9551,'ba','Harap Sertakan nama',0),(343815,9551,'nl','Vermeld naam',0),(343816,9551,'fi','Ota myÃ¶s nimi',0),(343817,9551,'no','Ta med navnet',0),(343818,9551,'da','Inkluder venligst navn',0),(343819,9551,'ko','ì´ë¦„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(343820,9551,'he','×× × ×›×œ×•×œ ×©×',0),(343821,9551,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(343822,9551,'zh','è¯·åˆ—å…¥å§“å\r\n',0),(343823,9551,'sv','VÃ¤nligen inkludera namn',0),(343824,9551,'it','Si prega di includere nome',0),(343825,9551,'tl','',0),(343826,9551,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3594;&#3639;&#3656;&#3629;',0),(343827,9551,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¨à¤¾à¤® à¤¶à¤¾à¤®à¤¿à¤²',0),(343828,9551,'ms','Sila sertakan nama',0),(343829,9551,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ø³Ù…',0),(343830,9551,'fr','Veuillez inclure le nom',0),(343831,9551,'jp','åã‚‚å«ã‚ã¦ãã ã•ã„ã€‚',0),(343832,9551,'pt','Por favor, inclua o nome',0),(343833,9551,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ',0),(343834,9551,'es','Por Favor Incluye Nombre',0),(343835,9551,'de','Bitte geben Sie Namen',0),(343836,9551,'en','Please Include Name',0),(343837,9552,'is','',0),(343838,9552,'dr','Ù„Ø·ÙØ§ Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(343839,9552,'pr','Ù„Ø·ÙØ§ Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(343840,9552,'tr','LÃ¼tfen yardÄ±mcÄ± programlar ÅŸarj dahil',0),(343841,9552,'pl','ProszÄ™ podaÄ‡ bezpÅ‚atnie Utilities',0),(343842,9552,'bg','ÐœÐ¾Ð»Ñ, Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° ÐºÐ¾Ð¼ÑƒÐ½Ð°Ð»Ð½Ð¸ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(343843,9552,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÙØ§Ø¯ÛŒØª Ú†Ø§Ø±Ø¬ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(343844,9552,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ¾Ð¼ÑƒÐ½Ð°Ð»Ð½Ðµ ÑƒÑÐ»ÑƒÐ³Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(343845,9552,'vi','vui lÃ²ng thÃªm phÃ­ sá»­ dá»¥ng ',0),(343846,9552,'af','Sluit asseblief Dienste Heffing in',0),(343847,9552,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i taxa utilitati',0),(343848,9552,'et','Palun lisage kommunaalteenuste eest',0),(343849,9552,'si','Prosim vraÄunati Utilities brezplaÄno',0),(343850,9552,'ba','Harap sertakan biaya utilitas',0),(343851,9552,'nl','Gelieve te omvatten Utilities gratis',0),(343852,9552,'fi','LiitÃ¤ Utilities ilmaiseksi',0),(343853,9552,'no','Ta med verktÃ¸y kostnad',0),(343854,9552,'da','VedlÃ¦g Utilities afgift',0),(343855,9552,'ko','ìœ í‹¸ë¦¬í‹° ìš”ê¸ˆì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(343856,9552,'he','×× × ×›×œ×•×œ ×—×™×•×‘ ×©×¨×•×ª×™×',0),(343857,9552,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Î²Î¿Î·Î¸Î·Ï„Î¹ÎºÎ¬ Ï€ÏÎ¿Î³ÏÎ¬Î¼Î¼Î±Ï„Î± Ï†ÏŒÏÏ„Î¹ÏƒÎ·Ï‚',0),(343858,9552,'zh','è¯·åˆ—å…¥å…¬ç”¨äº‹ä¸šè´¹\r\n',0),(343859,9552,'sv','VÃ¤nligen inkludera Utilities kostnad',0),(343860,9552,'it','Si prega di includere utilitÃ  carica',0),(343861,9552,'tl','',0),(343862,9552,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3588;&#3656;&#3634;&#3626;&#3634;&#3608;&#3634;&#3619;&#3603;&#3641;&#3611;&#3650;&#3616;&#3588;',0),(343863,9552,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤¿à¤¤à¤¾à¤à¤ à¤šà¤¾à¤°à¥à¤œ à¤­à¥€ à¤¶à¤¾à¤®à¤¿à¤²',0),(343864,9552,'ms','Sila sertakan bayaran utiliti',0),(343865,9552,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ø±Ø§ÙÙ‚ Ø§Ù„Ø¹Ø§Ù…Ø©',0),(343866,9552,'fr','Veuillez inclure les frais de services publics',0),(343867,9552,'jp','ãƒ¦ãƒ¼ãƒ†ã‚£ãƒªãƒ†ã‚£æ–™é‡‘ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(343868,9552,'pt','Por favor incluir utilitÃ¡rios de carga',0),(343869,9552,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ ÐºÐ¾Ð¼Ð¼ÑƒÐ½Ð°Ð»ÑŒÐ½Ñ‹Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(343870,9552,'es','Por Favor Incluyen Cargos de Servicios',0),(343871,9552,'de','Bitte fÃ¼gen Sie Dienstprogramme kostenlos',0),(343872,9552,'en','Please Include Utilities Charge',0),(343873,9553,'is','',0),(343874,9553,'dr','(ØªØ³Ù‡ÙŠÙ„Ø§Øª',0),(343875,9553,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ(ØªØ³Ù‡ÙŠÙ„Ø§Øª',0),(343876,9553,'tr','YardÄ±mcÄ± programlar ÅŸarj',0),(343877,9553,'pl','NarzÄ™dzia bezpÅ‚atnie',0),(343878,9553,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° ÐºÐ¾Ð¼ÑƒÐ½Ð°Ð»Ð½Ð¸ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(343879,9553,'ur','Ø§ÙØ§Ø¯ÛŒØª Ú†Ø§Ø±Ø¬',0),(343880,9553,'sr','ÐšÐ¾Ð¼ÑƒÐ½Ð°Ð»Ð½Ðµ ÑƒÑÐ»ÑƒÐ³Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(343881,9553,'vi','Chi phÃ­ tiá»‡n Ã­ch',0),(343882,9553,'af','Nuts las',0),(343883,9553,'ro','Taxa de utilitati',0),(343884,9553,'et','Kommunaalteenuste eest',0),(343885,9553,'si','Utilities brezplaÄno',0),(343886,9553,'ba','Biaya utilitas',0),(343887,9553,'nl','Utilities gratis',0),(343888,9553,'fi','Utilities ilmaiseksi',0),(343889,9553,'no','VerktÃ¸y kostnad',0),(343890,9553,'da','Utilities afgift',0),(343891,9553,'ko','ìœ í‹¸ë¦¬í‹° ìš”ê¸ˆ',0),(343892,9553,'he','×›×œ×™ ×¢×–×¨ ×ª×©×œ×•×',0),(343893,9553,'el','Î”Ï‰ÏÎµÎ¬Î½ Î²Î¿Î·Î¸Î·Ï„Î¹ÎºÎ¬ Ï€ÏÎ¿Î³ÏÎ¬Î¼Î¼Î±Ï„Î±',0),(343894,9553,'zh','å…¬ç”¨äº‹ä¸šæ”¶è´¹\r\n',0),(343895,9553,'sv','Utilities kostnad',0),(343896,9553,'it','Carica di utilitÃ ',0),(343897,9553,'tl','',0),(343898,9553,'th','&#3588;&#3656;&#3634;&#3626;&#3634;&#3608;&#3634;&#3619;&#3603;&#3641;&#3611;&#3650;&#3616;&#3588;',0),(343899,9553,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤¿à¤¤à¤¾à¤à¤ à¤†à¤°à¥‹à¤ª',0),(343900,9553,'ms','Caj utiliti',0),(343901,9553,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ø±Ø§ÙÙ‚ Ø§Ù„Ø¹Ø§Ù…Ø©',0),(343902,9553,'fr','Frais de services publics',0),(343903,9553,'jp','ãƒ¦ãƒ¼ãƒ†ã‚£ãƒªãƒ†ã‚£æ–™é‡‘',0),(343904,9553,'pt','UtilitÃ¡rios de carga',0),(343905,9553,'ru','ÐšÐ¾Ð¼Ð¼ÑƒÐ½Ð°Ð»ÑŒÐ½Ñ‹Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(343906,9553,'es','Cargo para Servicios Publicos',0),(343907,9553,'de','Dienstprogramme kostenlos',0),(343908,9553,'en','Utilities Charge',0),(343909,9554,'is','',0),(343910,9554,'dr','Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343911,9554,'pr','Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343912,9554,'tr','Bina mÃ¼lkiyet',0),(343913,9554,'pl','WÅ‚asnoÅ›ci budynku',0),(343914,9554,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(343915,9554,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù…Ù„Ú©ÛŒØª',0),(343916,9554,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾',0),(343917,9554,'vi','quyá»nthiáº¿t káº¿',0),(343918,9554,'af','Eienaarskap van Gebou',0),(343919,9554,'ro','ClÄƒdirea proprietate',0),(343920,9554,'et','Hoone omanik',0),(343921,9554,'si','LastniÅ¡tvo stavbe',0),(343922,9554,'ba','Bangunan kepemilikan',0),(343923,9554,'nl','Gebouw eigendom',0),(343924,9554,'fi','Rakennuksen omistus',0),(343925,9554,'no','Bygningen eierskap',0),(343926,9554,'da','Bygning ejerskab',0),(343927,9554,'ko','ê±´ë¬¼ ì†Œìœ ê¶Œ',0),(343928,9554,'he','×ž×‘× ×” ×‘×¢×œ×•×ª',0),(343929,9554,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(343930,9554,'zh','æˆ¿å±‹æ‰€æœ‰æƒ\r\n',0),(343931,9554,'sv','Byggnaden Ã¤gande',0),(343932,9554,'it','Proprietario d\'immobili',0),(343933,9554,'tl','',0),(343934,9554,'th','&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(343935,9554,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ',0),(343936,9554,'ms','Pemilikan bangunan',0),(343937,9554,'ar','Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(343938,9554,'fr','PropriÃ©tÃ© de lâ€™immeuble',0),(343939,9554,'jp','å»ºç‰©æ‰€æœ‰æ¨©',0),(343940,9554,'pt','Posse de prÃ©dio',0),(343941,9554,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(343942,9554,'es','Pertenencia de Edificio',0),(343943,9554,'de','GebÃ¤udeeigentum',0),(343944,9554,'en','Building Ownership',0),(343945,9555,'is','',0),(343946,9555,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343947,9555,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343948,9555,'tr','Bina mÃ¼lkiyet Ekle',0),(343949,9555,'pl','WÅ‚asnoÅ›ci budynku Dodaj',0),(343950,9555,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(343951,9555,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(343952,9555,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð³Ñ€Ð°Ð´Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾',0),(343953,9555,'vi','ThÃªm quyá»n thiáº¿t káº¿',0),(343954,9555,'af','Eienaarskap van Gebou Byvoeg',0),(343955,9555,'ro','Adauga clÄƒdirea proprietate',0),(343956,9555,'et','Hoone omanik lisada',0),(343957,9555,'si','Dodaj lastniÅ¡tvo stavbe',0),(343958,9555,'ba','Menambahkan bangunan kepemilikan',0),(343959,9555,'nl','Gebouw eigendom toevoegen',0),(343960,9555,'fi','Rakennuksen omistusoikeuden lisÃ¤Ã¤',0),(343961,9555,'no','Bygningen eierskap legge',0),(343962,9555,'da','Bygning ejerskab tilfÃ¸je',0),(343963,9555,'ko','ê±´ë¬¼ ì†Œìœ ê¶Œ ì¶”ê°€',0),(343964,9555,'he','×‘×¢×œ×•×ª ×”×‘× ×™×™×Ÿ ×œ×”×•×¡×™×£',0),(343965,9555,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÏ„Î¹ÏÎ¯Î¿Ï… Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(343966,9555,'zh','æ–°å¢žæˆ¿å±‹æ‰€æœ‰æƒ\r\n',0),(343967,9555,'sv','Byggnadens Ã¤gare lÃ¤gga till',0),(343968,9555,'it','Aggiungere proprietario d\'immobili',0),(343969,9555,'tl','',0),(343970,9555,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(343971,9555,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(343972,9555,'ms','Menambah pemilikan bangunan',0),(343973,9555,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(343974,9555,'fr','Ajouter des propriÃ©tÃ© de lâ€™immeuble',0),(343975,9555,'jp','å»ºç‰©æ‰€æœ‰æ¨©ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(343976,9555,'pt','Adicionar o edifÃ­cio Propriedade',0),(343977,9555,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð´Ð°Ð½Ð¸Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(343978,9555,'es','Agregar Pertenencia de Edificio',0),(343979,9555,'de','GebÃ¤udeeigentum hinzufÃ¼gen',0),(343980,9555,'en','Building Ownership Add',0),(343981,9556,'is','',0),(343982,9556,'dr','Ø­Ø°Ù Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343983,9556,'pr','Ø­Ø°Ù Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(343984,9556,'tr','Bina mÃ¼lkiyet Sil',0),(343985,9556,'pl','Delete wÅ‚asnoÅ›ci budynku',0),(343986,9556,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(343987,9556,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(343988,9556,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾ Ð”ÐµÐ»ÐµÑ‚Ðµ',0),(343989,9556,'vi','XÃ³a quyá»n thiáº¿t káº¿',0),(343990,9556,'af','Eienaarskap van Gebou Skrap',0),(343991,9556,'ro','ClÄƒdirea proprietate a ÅŸterge',0),(343992,9556,'et','Hoone omandiÃµiguse Kustuta',0),(343993,9556,'si','IzbriÅ¡i lastniÅ¡tvo stavbe',0),(343994,9556,'ba','Bangunan kepemilikan Hapus',0),(343995,9556,'nl','Gebouw eigendom verwijderen',0),(343996,9556,'fi','Rakennuksen omistusoikeuden Poista',0),(343997,9556,'no','Bygningen eierskap Slett',0),(343998,9556,'da','Bygning ejerskab slet',0),(343999,9556,'ko','ê±´ë¬¼ ì†Œìœ ê¶Œ ì‚­ì œ',0),(344000,9556,'he','×ž×—×§ ×‘×¢×œ×•×ª ×”×‘× ×™×™×Ÿ',0),(344001,9556,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎºÏ„Î¯ÏÎ¹Î¿ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(344002,9556,'zh','åˆ é™¤æˆ¿å±‹æ‰€æœ‰æƒ\r\n',0),(344003,9556,'sv','Byggnaden Ã¤gande Delete',0),(344004,9556,'it','Edificio proprietÃ  Elimina',0),(344005,9556,'tl','',0),(344006,9556,'th','&#3621;&#3610;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(344007,9556,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤¹à¤Ÿà¤¾à¤à¤',0),(344008,9556,'ms','Menghapuskan pemilikan bangunan',0),(344009,9556,'ar','Ø­Ø°Ù Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(344010,9556,'fr','BÃ¢timent propriÃ©tÃ© Delete',0),(344011,9556,'jp','å»ºç‰©ã®æ‰€æœ‰æ¨©ã®å‰Šé™¤',0),(344012,9556,'pt','EdifÃ­cio Propriedade Delete',0),(344013,9556,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð²Ð»Ð°Ð´ÐµÐ»ÑŒÑ†Ð° Ð·Ð´Ð°Ð½Ð¸Ñ',0),(344014,9556,'es','Eliminar Pertenencia de Edificio',0),(344015,9556,'de','GebÃ¤udes Eigentum lÃ¶schen',0),(344016,9556,'en','Building Ownership Delete',0),(344017,9557,'is','',0),(344018,9557,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344019,9557,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344020,9557,'tr','Bina mÃ¼lkiyet gÃ¼ncelleÅŸtirme',0),(344021,9557,'pl','Aktualizacja wÅ‚asnoÅ›ci budynku',0),(344022,9557,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð¾Ð±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(344023,9557,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(344024,9557,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(344025,9557,'vi','Cáº­p nháº­t quyá»n thiáº¿t káº¿',0),(344026,9557,'af','Eienaarskap van Gebou Opdateer',0),(344027,9557,'ro','ClÄƒdirea proprietate Update',0),(344028,9557,'et','Hoone omandiÃµiguse vÃ¤rskendus',0),(344029,9557,'si','Posodobitev lastniÅ¡tvo stavbe',0),(344030,9557,'ba','Bangunan kepemilikan Update',0),(344031,9557,'nl','Gebouw eigendom Update',0),(344032,9557,'fi','Rakennuksen omistusoikeuden pÃ¤ivitys',0),(344033,9557,'no','Bygningen eierskap oppdatering',0),(344034,9557,'da','Bygning ejerskab opdatering',0),(344035,9557,'ko','ê±´ë¬¼ ì†Œìœ ê¶Œ ì—…ë°ì´íŠ¸',0),(344036,9557,'he','×¢×“×›×•×Ÿ ×‘×¢×œ×•×ª ×”×‘× ×™×™×Ÿ',0),(344037,9557,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(344038,9557,'zh','æ›´æ–°æˆ¿å±‹æ‰€æœ‰æƒ\r\n',0),(344039,9557,'sv','Byggnaden Ã¤ganderÃ¤tten uppdatering',0),(344040,9557,'it','Aggiornamento di proprietÃ  di edificio',0),(344041,9557,'tl','',0),(344042,9557,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(344043,9557,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(344044,9557,'ms','Kemas kini pemilikan bangunan',0),(344045,9557,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(344046,9557,'fr','Mise Ã  jour de construction propriÃ©tÃ©',0),(344047,9557,'jp','å»ºç‰©æ‰€æœ‰æ¨©ã‚¢ãƒƒãƒ—ãƒ‡ãƒ¼ãƒˆ',0),(344048,9557,'pt','AtualizaÃ§Ã£o de posse do prÃ©dio',0),(344049,9557,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(344050,9557,'es','Actualizar Pertenencia de Edificio',0),(344051,9557,'de','GebÃ¤ude-Eigentum-Update',0),(344052,9557,'en','Building Ownership Update',0),(344053,9558,'is','',0),(344054,9558,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344055,9558,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344056,9558,'tr','Hata ekleme bina mÃ¼lkiyet',0),(344057,9558,'pl','BÅ‚Ä…d dodawania wÅ‚asnoÅ›ci budynku',0),(344058,9558,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(344059,9558,'ur','Ù†Ù‚Øµ Ø§Ø¶Ø§ÙÛ Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù…Ù„Ú©ÛŒØª',0),(344060,9558,'sr','Ð“Ñ€ÐµÑˆÐºÐµ Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ Ð·Ð³Ñ€Ð°Ð´Ñƒ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾',0),(344061,9558,'vi','Lá»—i thÃªm quyá»n thiáº¿t káº¿',0),(344062,9558,'af','Fout met die Byvoeging van Eienaarskap van Gebou',0),(344063,9558,'ro','Eroare adÄƒugÃ¢nd clÄƒdirea proprietate',0),(344064,9558,'et','Viga lisades hoone omandiÃµiguse',0),(344065,9558,'si','Napaka dodajanje stavbe lastniÅ¡tva',0),(344066,9558,'ba','Kesalahan menambahkan bangunan kepemilikan',0),(344067,9558,'nl','Fout toe te voegen gebouw eigendom',0),(344068,9558,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ rakennuksen omistus',0),(344069,9558,'no','Feil Ã¥ legge bygge eierskap',0),(344070,9558,'da','Fejl tilfÃ¸je bygning ejerskab',0),(344071,9558,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê±´ë¬¼ ì†Œìœ ê¶Œ',0),(344072,9558,'he','×©×’×™××” ×”×•×¡×¤×ª ×ž×‘× ×” ×‘×¢×œ×•×ª',0),(344073,9558,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÏ„Î¹ÏÎ¯Î¿Ï… Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(344074,9558,'zh','é”™è¯¯ï¼šæ–°å¢žæˆ¿å±‹æ‰€æœ‰æƒ\r\n',0),(344075,9558,'sv','Fel att lÃ¤gga till byggnaden Ã¤gande',0),(344076,9558,'it','Errore aggiunta proprietario d\'immobili',0),(344077,9558,'tl','',0),(344078,9558,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(344079,9558,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ',0),(344080,9558,'ms','Ralat menambah bangunan pemilikan',0),(344081,9558,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(344082,9558,'fr','Erreur ajout bÃ¢timent propriÃ©tÃ©',0),(344083,9558,'jp','ã‚¨ãƒ©ãƒ¼è¿½åŠ å»ºç‰©æ‰€æœ‰æ¨©',0),(344084,9558,'pt','Erro adicionando edifÃ­cio Propriedade',0),(344085,9558,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð·Ð´Ð°Ð½Ð¸Ñ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(344086,9558,'es','Error Agregando Pertenencia de Edificio',0),(344087,9558,'de','Fehler hinzufÃ¼gen GebÃ¤udeeigentum',0),(344088,9558,'en','Error Adding Building Ownership',0),(344089,9559,'is','',0),(344090,9559,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(344091,9559,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(344092,9559,'tr','Bina mÃ¼lkiyet baÅŸarÄ±yla eklendi',0),(344093,9559,'pl','WÅ‚asnoÅ›ci budynku dodany pomyÅ›lnie',0),(344094,9559,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(344095,9559,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(344096,9559,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(344097,9559,'vi','ThÃªm quyá»n thiáº¿t káº¿ thÃ nh cÃ´ng',0),(344098,9559,'af','Eienaarskap van Gebou Suksesvol Bygevoeg',0),(344099,9559,'ro','ClÄƒdirea proprietate adÄƒugat cu succes',0),(344100,9559,'et','Hoone omanik on edukalt',0),(344101,9559,'si','LastniÅ¡tvo stavbe, dodani',0),(344102,9559,'ba','Bangunan kepemilikan ditambahkan berhasil',0),(344103,9559,'nl','Gebouw eigendom toegevoegd',0),(344104,9559,'fi','Rakennuksen omistusoikeuden lisÃ¤Ã¤minen onnistui',0),(344105,9559,'no','Bygningen eierskap lagt',0),(344106,9559,'da','Bygning ejerskab tilfÃ¸jet',0),(344107,9559,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ê±´ë¬¼ ì†Œìœ ê¶Œ',0),(344108,9559,'he','×‘×¢×œ×•×ª ×ž×‘× ×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(344109,9559,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(344110,9559,'zh','æˆ¿å±‹æ‰€æœ‰æƒæ·»åŠ æˆåŠŸ\r\n',0),(344111,9559,'sv','Byggnaden Ã¤gande lagts',0),(344112,9559,'it','Proprietario d\'immobili aggiunto con successo',0),(344113,9559,'tl','',0),(344114,9559,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3629;&#3634;&#3588;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(344115,9559,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(344116,9559,'ms','Pemilikan bangunan berjaya menambah',0),(344117,9559,'ar','Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ø¨Ù†Ù‰ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(344118,9559,'fr','PropriÃ©tÃ© de bÃ¢timent ajoutÃ©e avec succÃ¨s',0),(344119,9559,'jp','å»ºç‰©ã®æ‰€æœ‰æ¨©ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(344120,9559,'pt','Posse do edifÃ­cio adicionado com sucesso',0),(344121,9559,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾',0),(344122,9559,'es','Pertenencia de Edificio Agregado Exitosamente',0),(344123,9559,'de','GebÃ¤udeeigentum erfolgreich hinzugefÃ¼gt',0),(344124,9559,'en','Building Ownership Added Successfully',0),(344125,9560,'is','',0),(344126,9560,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344127,9560,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344128,9560,'tr','Bina mÃ¼lkiyet silme hatasÄ±',0),(344129,9560,'pl','BÅ‚Ä…d podczas usuwania wÅ‚asnoÅ›ci budynku',0),(344130,9560,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(344131,9560,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(344132,9560,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð·Ð³Ñ€Ð°Ð´Ñƒ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾',0),(344133,9560,'vi','Lá»—i xÃ³a quyá»n thiáº¿t káº¿',0),(344134,9560,'af','Fout met die Skraping van Eienaarskap van Gebou',0),(344135,9560,'ro','Eroare la È™tergerea clÄƒdirea proprietate',0),(344136,9560,'et','TÃµrge kustutamisel hoone omandiÃµiguse',0),(344137,9560,'si','Napaka brisanja lastniÅ¡tvo stavbe',0),(344138,9560,'ba','Error menghapus kepemilikan bangunan',0),(344139,9560,'nl','Fout bij het verwijderen van de eigendom van het gebouw',0),(344140,9560,'fi','Virhe poistettaessa rakennuksen omistus',0),(344141,9560,'no','Feil ved sletting av bygningen eierskap',0),(344142,9560,'da','Fejl ved sletning af bygningen ejerskab',0),(344143,9560,'ko','ê±´ë¬¼ ì†Œìœ ê¶Œì„ ì‚­ì œ ì˜¤ë¥˜',0),(344144,9560,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×‘×¢×œ×•×ª ×”×‘× ×™×™×Ÿ',0),(344145,9560,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï… Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(344146,9560,'zh','é”™è¯¯åˆ é™¤æˆ¿å±‹æ‰€æœ‰æƒ\r\n',0),(344147,9560,'sv','Fel ta bort byggnaden Ã¤gande',0),(344148,9560,'it','Errore durante l\'eliminazione proprietario d\'immobili',0),(344149,9560,'tl','',0),(344150,9560,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3621;&#3610;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(344151,9560,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(344152,9560,'ms','Ralat Menghapuskan pemilikan bangunan',0),(344153,9560,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(344154,9560,'fr','Erreur de suppression de propriÃ©tÃ© de lâ€™immeuble',0),(344155,9560,'jp','å»ºç‰©æ‰€æœ‰æ¨©ã®å‰Šé™¤ã‚¨ãƒ©ãƒ¼',0),(344156,9560,'pt','Erro ao excluir a posse do prÃ©dio',0),(344157,9560,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð²Ð»Ð°Ð´ÐµÐ»ÑŒÑ†Ð° Ð·Ð´Ð°Ð½Ð¸Ñ',0),(344158,9560,'es','Error Eliminando Pertenencia de Edificio',0),(344159,9560,'de','Fehler beim LÃ¶schen GebÃ¤udeeigentum',0),(344160,9560,'en','Error Deleting Building Ownership',0),(344161,9561,'is','',0),(344162,9561,'dr','Ø­Ø°Ù Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(344163,9561,'pr','Ø­Ø°Ù Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(344164,9561,'tr','Bina mÃ¼lkiyet baÅŸarÄ±yla silindi',0),(344165,9561,'pl','WÅ‚asnoÅ›ci budynku usuniÄ™ty',0),(344166,9561,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(344167,9561,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(344168,9561,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(344169,9561,'vi','XÃ³a quyá»n thiáº¿t káº¿ thÃ nh cÃ´ng',0),(344170,9561,'af','Eienaarskap van Gebou Suksesvol Geskrap',0),(344171,9561,'ro','ClÄƒdirea proprietate eliminÄƒ cu succes',0),(344172,9561,'et','Hoone omandiÃµiguse edukalt kustutatud',0),(344173,9561,'si','LastniÅ¡tvo stavbe uspeÅ¡no izbrisana',0),(344174,9561,'ba','Bangunan kepemilikan dihapus berhasil',0),(344175,9561,'nl','Gebouw eigendom met succes verwijderd',0),(344176,9561,'fi','Rakennuksen omistusoikeuden poistettu',0),(344177,9561,'no','Bygningen eierskap slettet',0),(344178,9561,'da','Bygning ejerskab slettet',0),(344179,9561,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ê±´ë¬¼ ì†Œìœ ê¶Œ',0),(344180,9561,'he','×ž×‘× ×” ×”×‘×¢×œ×•×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(344181,9561,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(344182,9561,'zh','æˆ¿å±‹æ‰€æœ‰æƒæˆåŠŸåˆ é™¤\r\n',0),(344183,9561,'sv','Byggnaden Ã¤gande raderades',0),(344184,9561,'it','Proprietario d\'immobili eliminato con successo',0),(344185,9561,'tl','',0),(344186,9561,'th','&#3621;&#3610;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3629;&#3634;&#3588;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(344187,9561,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾',0),(344188,9561,'ms','Pemilikan bangunan dihapuskan dengan jayanya',0),(344189,9561,'ar','Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ø¨Ù†Ù‰ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(344190,9561,'fr','PropriÃ©tÃ© de bÃ¢timent supprimÃ©e avec succÃ¨s',0),(344191,9561,'jp','å»ºç‰©ã®æ‰€æœ‰æ¨©ã¯æ­£å¸¸ã«å‰Šé™¤',0),(344192,9561,'pt','Posse de prÃ©dio apagado com sucesso',0),(344193,9561,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾',0),(344194,9561,'es','Pertenencia de Edificio Eliminado Exitosamente',0),(344195,9561,'de','GebÃ¤udeeigentum erfolgreich gelÃ¶scht',0),(344196,9561,'en','Building Ownership Deleted Successfully',0),(344197,9562,'is','',0),(344198,9562,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344199,9562,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344200,9562,'tr','Bina mÃ¼lkiyet gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(344201,9562,'pl','BÅ‚Ä…d aktualizacji wÅ‚asnoÅ›ci budynku',0),(344202,9562,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(344203,9562,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(344204,9562,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð·Ð³Ñ€Ð°Ð´Ñƒ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾',0),(344205,9562,'vi','Lá»—i cáº­p nháº­t quyá»n thiáº¿t káº¿',0),(344206,9562,'af','Fout met die Opdatering van Eienaarskap van Gebou',0),(344207,9562,'ro','Eroare la actualizarea clÄƒdirea proprietate',0),(344208,9562,'et','Hoone omandiÃµiguse vÃ¤rskendamise tÃµrge',0),(344209,9562,'si','Napaka pri posodabljanju lastniÅ¡tvo stavbe',0),(344210,9562,'ba','Kesalahan memperbarui bangunan kepemilikan',0),(344211,9562,'nl','Fout bij het bijwerken van de eigendom van het gebouw',0),(344212,9562,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ rakennuksen omistus',0),(344213,9562,'no','Feil under oppdatering av bygningen eierskap',0),(344214,9562,'da','Fejl under opdatering af bygningen ejerskab',0),(344215,9562,'ko','ê±´ë¬¼ ì†Œìœ ê¶Œ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(344216,9562,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×ž×‘× ×” ×‘×¢×œ×•×ª',0),(344217,9562,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï… Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(344218,9562,'zh','é”™è¯¯æ›´æ–°æˆ¿å±‹æ‰€æœ‰æƒ\r\n',0),(344219,9562,'sv','Fel vid uppdatering av byggnaden Ã¤gande',0),(344220,9562,'it','Errore di aggiornamento proprietario d\'immobili',0),(344221,9562,'tl','',0),(344222,9562,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3629;&#3634;&#3588;&#3634;&#3619;',0),(344223,9562,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(344224,9562,'ms','Ralat dalam mengemas kini pemilikan bangunan',0),(344225,9562,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(344226,9562,'fr','Erreur mise Ã  jour de la propriÃ©tÃ© de lâ€™immeuble',0),(344227,9562,'jp','å»ºç‰©æ‰€æœ‰æ¨©ã‚’æ›´æ–°ä¸­ã®ã‚¨ãƒ©ãƒ¼',0),(344228,9562,'pt','Erro ao atualizar a propriedade do edifÃ­cio',0),(344229,9562,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð´Ð°Ð½Ð¸Ñ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(344230,9562,'es','Error Actualizando Pertenencia de Edificio',0),(344231,9562,'de','Fehler beim Aktualisieren von GebÃ¤udeeigentum',0),(344232,9562,'en','Error Updating Building Ownership',0),(344233,9563,'is','',0),(344234,9563,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(344235,9563,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­Ù‚ Ù…Ø§Ù„Ú©ÙŠØª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(344236,9563,'tr','Bina mÃ¼lkiyet baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(344237,9563,'pl','WÅ‚asnoÅ›ci budynku pomyÅ›lnie zaktualizowana',0),(344238,9563,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(344239,9563,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª',0),(344240,9563,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(344241,9563,'vi','Cáº­p nhÃ¢t quyá»n thiáº¿t káº¿ thÃ nh cÃ´ng',0),(344242,9563,'af','Eienaarskap van Gebou Suksesvol Opdateer',0),(344243,9563,'ro','ClÄƒdirea proprietate actualizat cu succes',0),(344244,9563,'et','Hoone omandiÃµiguse vÃ¤rskendatud',0),(344245,9563,'si','LastniÅ¡tvo stavbe uspeÅ¡no posodobljena',0),(344246,9563,'ba','Bangunan kepemilikan berhasil',0),(344247,9563,'nl','Gebouw eigendom bijgewerkt',0),(344248,9563,'fi','Rakennuksen omistusoikeuden pÃ¤ivitetty',0),(344249,9563,'no','Bygningen eierskap oppdatert',0),(344250,9563,'da','Bygning ejerskab opdateret',0),(344251,9563,'ko','ê±´ë¬¼ ì†Œìœ ê¶Œì„ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(344252,9563,'he','×ž×‘× ×” ×”×‘×¢×œ×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(344253,9563,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(344254,9563,'zh','æˆ¿å±‹æ‰€æœ‰æƒå·²æˆåŠŸæ›´æ–°\r\n',0),(344255,9563,'sv','Byggnaden Ã¤gande uppdaterats',0),(344256,9563,'it','Proprietario d\'immobili aggiornato con successo',0),(344257,9563,'tl','',0),(344258,9563,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3629;&#3634;&#3588;&#3634;&#3619;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(344259,9563,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(344260,9563,'ms','Pemilikan bangunan berjaya dikemas kini',0),(344261,9563,'ar','Ù…Ù„ÙƒÙŠØ© Ø¨Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(344262,9563,'fr','PropriÃ©tÃ© de construction mis Ã  jour avec succÃ¨s',0),(344263,9563,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸå»ºç‰©æ‰€æœ‰æ¨©',0),(344264,9563,'pt','EdifÃ­cio Propriedade atualizada com sucesso',0),(344265,9563,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(344266,9563,'es','Pertenencia de Edificio Actualizado Exitosamente',0),(344267,9563,'de','GebÃ¤udeeigentum erfolgreich aktualisiert',0),(344268,9563,'en','Building Ownership Updated Successfully',0),(344269,9564,'is','',0),(344270,9564,'dr','Ù…Ø§Ù„ÙƒÙŠØª Ø¬Ø§Ø±ÙŠ',0),(344271,9564,'pr','Ù…Ø§Ù„ÙƒÙŠØª Ø¬Ø§Ø±ÙŠ',0),(344272,9564,'tr','GeÃ§erli sahip olma',0),(344273,9564,'pl','Aktualne prawo wÅ‚asnoÅ›ci',0),(344274,9564,'bg','Ð¢ÐµÐºÑƒÑ‰ Ð¿Ñ€Ð¸Ñ‚ÐµÐ¶Ð°Ð½Ð¸Ðµ',0),(344275,9564,'ur','Ø­Ø§Ù„ÛŒÛ Ù…Ù„Ú©ÛŒØª',0),(344276,9564,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾',0),(344277,9564,'vi','chá»§ hiá»‡n nay',0),(344278,9564,'af','Huidige Eienaarskap',0),(344279,9564,'ro','Curent de proprietate',0),(344280,9564,'et','Praegused omandiÃµigus',0),(344281,9564,'si','Trenutna lastniÅ¡tva',0),(344282,9564,'ba','Kepemilikan saat ini',0),(344283,9564,'nl','Huidige eigenaar',0),(344284,9564,'fi','NykyisessÃ¤ omistuksessa',0),(344285,9564,'no','Gjeldende eierskap',0),(344286,9564,'da','NuvÃ¦rende ejerskab',0),(344287,9564,'ko','í˜„ìž¬ ì†Œìœ ê¶Œ',0),(344288,9564,'he','×‘×¢×œ×•×ª × ×•×›×—×™×ª',0),(344289,9564,'el','Î£Î·Î¼ÎµÏÎ¹Î½ÏŒ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¹Î±ÎºÏŒ ÎºÎ±Î¸ÎµÏƒÏ„ÏŽÏ‚',0),(344290,9564,'zh','ç›®å‰çš„æ‰€æœ‰æƒ\r\n',0),(344291,9564,'sv','Nuvarande Ã¤gande',0),(344292,9564,'it','ProprietÃ  attuale',0),(344293,9564,'tl','',0),(344294,9564,'th','&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(344295,9564,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ',0),(344296,9564,'ms','Semasa pemilikan',0),(344297,9564,'ar','Ø§Ù„Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(344298,9564,'fr','PropriÃ©taire actuel',0),(344299,9564,'jp','ç¾åœ¨ã®æ‰€æœ‰æ¨©',0),(344300,9564,'pt','Posse atual',0),(344301,9564,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð¿Ñ€Ð°Ð²Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(344302,9564,'es','Pertenencia Actual',0),(344303,9564,'de','Aktuellen EigentÃ¼mer',0),(344304,9564,'en','Current Ownership',0),(344305,9565,'is','',0),(344306,9565,'dr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙƒÙŠØª',0),(344307,9565,'pr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙƒÙŠØª',0),(344308,9565,'tr','YÃ¼zde mÃ¼lkiyet',0),(344309,9565,'pl','Procent wÅ‚asnoÅ›ci',0),(344310,9565,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð½Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚Ñ‚Ð°',0),(344311,9565,'ur','ÙÛŒ ØµØ¯ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª',0),(344312,9565,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð°',0),(344313,9565,'vi','pháº§n trÄƒm lÃ m chá»§',0),(344314,9565,'af','Persentasie Eienaarskap',0),(344315,9565,'ro','Procent de proprietate',0),(344316,9565,'et','Protsent omandi',0),(344317,9565,'si','Odstotek lastniÅ¡tva',0),(344318,9565,'ba','Persentase kepemilikan',0),(344319,9565,'nl','Percentage eigendom',0),(344320,9565,'fi','Omistusprosentti',0),(344321,9565,'no','Prosent eierskap',0),(344322,9565,'da','Procentdelen af ejerskab',0),(344323,9565,'ko','ì†Œìœ  ì§€ë¶„ ë¹„ìœ¨ì€',0),(344324,9565,'he','×‘×¢×œ×•×ª ××—×•×–',0),(344325,9565,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎºÏ…ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚',0),(344326,9565,'zh','è‚¡æƒç™¾åˆ†æ¯”\r\n',0),(344327,9565,'sv','ProcentÃ¤gandet',0),(344328,9565,'it','Percentuale di proprietÃ ',0),(344329,9565,'tl','',0),(344330,9565,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3585;&#3634;&#3619;&#3648;&#3611;&#3655;&#3609;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;',0),(344331,9565,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ',0),(344332,9565,'ms','Peratus pemilikan',0),(344333,9565,'ar','Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ù„ÙƒÙŠØ©',0),(344334,9565,'fr','PropriÃ©tÃ© pourcentage',0),(344335,9565,'jp','æ‰€æœ‰æ¨©ã®å‰²åˆ',0),(344336,9565,'pt','Porcentagem de propriedade',0),(344337,9565,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð²Ð»Ð°Ð´ÐµÐ½Ð¸Ñ',0),(344338,9565,'es','Porcentaje de Pertenencia',0),(344339,9565,'de','Beteiligungsquote',0),(344340,9565,'en','Percent Ownership',0),(344341,9566,'is','',0),(344342,9566,'dr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙƒÙŠØª Ø¨ÙŠØ´ØªØ± Ø§Ø² ØµØ¯ Ø¯Ø± ØµØ¯ ',0),(344343,9566,'pr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙƒÙŠØª Ø¨ÙŠØ´ØªØ± Ø§Ø² ØµØ¯ Ø¯Ø± ØµØ¯ ',0),(344344,9566,'tr','YÃ¼zde sahipliÄŸi yÃ¼zde 100\'den fazla',0),(344345,9566,'pl','Procent wÅ‚asnoÅ›ci ponad 100 procent',0),(344346,9566,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð°Ð´ 100 Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(344347,9566,'ur','ÙÛŒ ØµØ¯ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª 100 ÙÛŒØµØ¯ Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(344348,9566,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð° Ð¿Ñ€ÐµÐºÐ¾ 100%',0),(344349,9566,'vi','lÃ m chá»§ hÆ¡n 100%',0),(344350,9566,'af','Persentasie Eienaarskap Oorskry 100 Persent',0),(344351,9566,'ro','Proprietate la sutÄƒ peste 100 %',0),(344352,9566,'et','Protsent omandi Ã¼le 100%',0),(344353,9566,'si','Odstotek lastniÅ¡tva nad 100 odstotkov',0),(344354,9566,'ba','Persen kepemilikan lebih dari 100 persen',0),(344355,9566,'nl','Procent eigendom van meer dan 100 procent',0),(344356,9566,'fi','Omistusprosentti yli 100 prosenttia',0),(344357,9566,'no','Prosent eierskap Over 100 prosent',0),(344358,9566,'da','Procentdelen af ejerskab Over 100 procent',0),(344359,9566,'ko','ì†Œìœ  ì§€ë¶„ ë¹„ìœ¨ì€ 100% ì´ìƒ',0),(344360,9566,'he','×‘×¢×œ×•×ª ××—×•×– ×ž×¢×œ 100 ××—×•×–',0),(344361,9566,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎºÏ…ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ 100 Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(344362,9566,'zh','è¶…è¿‡100%çš„è‚¡æƒç™¾åˆ†æ¯”\r\n',0),(344363,9566,'sv','ProcentÃ¤gandet Ã¶ver 100 procent',0),(344364,9566,'it','Percentuale di oltre il 100% di proprietÃ ',0),(344365,9566,'tl','',0),(344366,9566,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3585;&#3634;&#3619;&#3648;&#3611;&#3655;&#3609;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3617;&#3634;&#3585;&#3585;&#3623;&#3656;&#3634; 100 %',0),(344367,9566,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ 100 à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(344368,9566,'ms','Peratus pemilikan 100 peratus',0),(344369,9566,'ar','Ù†Ø³Ø¨Ø© Ù…Ù„ÙƒÙŠØ© Ø£ÙƒØ«Ø± Ù…Ù† 100 ÙÙŠ Ø§Ù„Ù…Ø§Ø¦Ø©',0),(344370,9566,'fr','PropriÃ©tÃ© pour cent plus de 100 pour cent',0),(344371,9566,'jp','æ‰€æœ‰æ¨©ã®å‰²åˆ 100%',0),(344372,9566,'pt','Porcentagem de propriedade de mais de 100 por cento',0),(344373,9566,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð²Ð»Ð°Ð´ÐµÐ½Ð¸Ñ Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ð½Ð° 100 Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(344374,9566,'es','Porcentaje de Pertenencia MÃ¡s que 100%',0),(344375,9566,'de','Beteiligungsquote Ã¼ber 100 Prozent',0),(344376,9566,'en','Percent Ownership Over 100 Percent',0),(344377,9567,'is','',0),(344378,9567,'dr','Ù„Ø·ÙØ§ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(344379,9567,'pr','Ù„Ø·ÙØ§ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(344380,9567,'tr','LÃ¼tfen yapÄ± ekleyin',0),(344381,9567,'pl','Prosimy o podanie budynku',0),(344382,9567,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ ÑÐ³Ñ€Ð°Ð´Ð°',0),(344383,9567,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¹Ù…Ø§Ø±Øª Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(344384,9567,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(344385,9567,'vi','vui lÃ²ng bao gá»“m cáº¥u trÃºc',0),(344386,9567,'af','Sluit asb. \'n Gebou in',0),(344387,9567,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i clÄƒdire',0),(344388,9567,'et','Palun lisa hoone',0),(344389,9567,'si','Prosimo, da vkljuÄite stavbe',0),(344390,9567,'ba','Harap sertakan bangunan',0),(344391,9567,'nl','Gelieve te omvatten gebouw',0),(344392,9567,'fi','LiitÃ¤ mukaan rakennuksen',0),(344393,9567,'no','Ta bygningen',0),(344394,9567,'da','VedlÃ¦g bygning',0),(344395,9567,'ko','ê±´ë¬¼ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(344396,9567,'he','×× × ×›×œ×•×œ ×‘× ×™×Ÿ',0),(344397,9567,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ ÎºÏ„Î¯ÏÎ¹Î¿',0),(344398,9567,'zh','è¯·åˆ—å…¥å»ºè®¾\r\n',0),(344399,9567,'sv','VÃ¤nligen inkludera byggnad',0),(344400,9567,'it','Si prega di includere edificio',0),(344401,9567,'tl','',0),(344402,9567,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(344403,9567,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(344404,9567,'ms','Sila sertakan bangunan',0),(344405,9567,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø¨Ù†Ø§Ø¡',0),(344406,9567,'fr','Sâ€™il vous plaÃ®t inclure bÃ¢timent',0),(344407,9567,'jp','å»ºç‰©ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(344408,9567,'pt','Por favor inclua o edifÃ­cio',0),(344409,9567,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð·Ð´Ð°Ð½Ð¸Ðµ',0),(344410,9567,'es','Por Favor Incluye Edificio',0),(344411,9567,'de','Bitte fÃ¼gen Sie GebÃ¤ude',0),(344412,9567,'en','Please Include Building',0),(344413,9568,'is','',0),(344414,9568,'dr','Ù„Ø·ÙØ§ Ø´Ø±ÙƒØª Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(344415,9568,'pr','Ù„Ø·ÙØ§ Ø´Ø±ÙƒØª Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(344416,9568,'tr','LÃ¼tfen ÅŸirket ekleyin',0),(344417,9568,'pl','Prosimy o podanie firmy',0),(344418,9568,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(344419,9568,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(344420,9568,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(344421,9568,'vi','vui lÃ²ng bao gá»“m cÃ´ng ty',0),(344422,9568,'af','Sluit asb. \'n Onderneming in',0),(344423,9568,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i companie',0),(344424,9568,'et','Palun lisa ettevÃµte',0),(344425,9568,'si','Prosimo, da vkljuÄite podjetje',0),(344426,9568,'ba','Harap sertakan perusahaan',0),(344427,9568,'nl','Voeg bedrijf',0),(344428,9568,'fi','LiitÃ¤ mukaan yritys',0),(344429,9568,'no','Ta selskapet',0),(344430,9568,'da','VedlÃ¦g selskab',0),(344431,9568,'ko','íšŒì‚¬ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(344432,9568,'he','×× × ×›×œ×•×œ ×—×‘×¨×”',0),(344433,9568,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(344434,9568,'zh','è¯·åˆ—å…¥å…¬å¸\r\n',0),(344435,9568,'sv','VÃ¤nligen inkludera fÃ¶retag',0),(344436,9568,'it','Si prega di includere societÃ ',0),(344437,9568,'tl','',0),(344438,9568,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(344439,9568,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤‚à¤ªà¤¨à¥€ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(344440,9568,'ms','Sila sertakan Syarikat',0),(344441,9568,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ù„Ø´Ø±ÙƒØ©',0),(344442,9568,'fr','Sâ€™il vous plaÃ®t inclure Company',0),(344443,9568,'jp','ä¼šç¤¾ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(344444,9568,'pt','Por favor inclua a empresa',0),(344445,9568,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(344446,9568,'es','Por Favor Incluye Empresa',0),(344447,9568,'de','Bitte fÃ¼gen Sie Unternehmen',0),(344448,9568,'en','Please Include Company',0),(344449,9569,'is','',0),(344450,9569,'dr','Ù„Ø·ÙØ§ Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙƒÙŠØª  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(344451,9569,'pr','Ù„Ø·ÙØ§ Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙƒÙŠØª  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(344452,9569,'tr','Mutlu etmek katmak yÃ¼zde mÃ¼lkiyet',0),(344453,9569,'pl','ProszÄ™ podaÄ‡ procent wÅ‚asnoÅ›ci',0),(344454,9569,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(344455,9569,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÙÛŒ ØµØ¯ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(344456,9569,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð°',0),(344457,9569,'vi','vui lÃ²ng bao gá»“m pháº§n trÄƒm sá»Ÿ há»¯u',0),(344458,9569,'af','Sluit asseblief Persentasie Eienaarskap in',0),(344459,9569,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i la sutÄƒ de proprietate',0),(344460,9569,'et','Palun lisa osalusprotsent',0),(344461,9569,'si','Prosimo, da vkljuÄite odstotek lastniÅ¡tva',0),(344462,9569,'ba','Harap sertakan persen kepemilikan',0),(344463,9569,'nl','Gelieve te omvatten procent eigendom',0),(344464,9569,'fi','LiitÃ¤ Omistusprosentti',0),(344465,9569,'no','Ta prosent eierskap',0),(344466,9569,'da','VedlÃ¦g procentvis ejerskab',0),(344467,9569,'ko','ì†Œìœ  ì§€ë¶„ ë¹„ìœ¨ì€ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(344468,9569,'he','× × ×œ×›×œ×•×œ ×‘×¢×œ×•×ª ××—×•×–',0),(344469,9569,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎºÏ…ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚',0),(344470,9569,'zh','è¯·åˆ—å…¥æ‰€æœ‰æƒç™¾åˆ†æ¯”\r\n',0),(344471,9569,'sv','VÃ¤nligen inkludera procentÃ¤gandet',0),(344472,9569,'it','Si prega di includere percentuale di proprietÃ ',0),(344473,9569,'tl','',0),(344474,9569,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3619;&#3623;&#3617;&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;',0),(344475,9569,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(344476,9569,'ms','Sila sertakan peratus pemilikan',0),(344477,9569,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ù†Ø³Ø¨Ø© Ù…Ù„ÙƒÙŠØ©',0),(344478,9569,'fr','Veuillez indiquer le pourcentage propriÃ©tÃ©',0),(344479,9569,'jp','æ‰€æœ‰æ¨©ã®å‰²åˆã‚’æ˜Žè¨˜ã—ã¦',0),(344480,9569,'pt','Por favor inclua porcentagem de propriedade',0),(344481,9569,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð²Ð»Ð°Ð´ÐµÐ½Ð¸Ñ',0),(344482,9569,'es','Por Favor Incluye Porcentaje de Pertenencia',0),(344483,9569,'de','Bitte fÃ¼gen Sie Beteiligungsquote',0),(344484,9569,'en','Please Include Percent Ownership',0),(344485,9570,'is','',0),(344486,9570,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344487,9570,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344488,9570,'tr','Bina tÃ¼rÃ¼ Ekle',0),(344489,9570,'pl','Dodaj typ budynku',0),(344490,9570,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ ÑÐ³Ñ€Ð°Ð´Ð°',0),(344491,9570,'ur','Ø¹Ù…Ø§Ø±Øª Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(344492,9570,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð³Ñ€Ð°Ð´Ðµ Ñ‚Ð¸Ð¿',0),(344493,9570,'vi','ThÃªm loáº¡i thiáº¿t káº¿',0),(344494,9570,'af','Gebou tipe voeg',0),(344495,9570,'ro','Adauga clÄƒdire tip',0),(344496,9570,'et','Hoone tÃ¼Ã¼bi lisada',0),(344497,9570,'si','Dodati vrsto zgradbe',0),(344498,9570,'ba','Menambahkan jenis bangunan',0),(344499,9570,'nl','Gebouw Type toevoegen',0),(344500,9570,'fi','Rakennuksen tyyppi lisÃ¤Ã¤',0),(344501,9570,'no','Building Type legge',0),(344502,9570,'da','Bygningen Type tilfÃ¸je',0),(344503,9570,'ko','ê±´ë¬¼ ìœ í˜• ì¶”ê°€',0),(344504,9570,'he','×”×•×¡×£ ×¡×•×’ ×ž×‘× ×”',0),(344505,9570,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿Î½ Ï„ÏÏ€Î¿ Ï„Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(344506,9570,'zh','å»ºç­‘ç±»åž‹æ·»åŠ \r\n',0),(344507,9570,'sv','Byggnadstyp lÃ¤gga',0),(344508,9570,'it','Aggiungi tipo di edificio',0),(344509,9570,'tl','',0),(344510,9570,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(344511,9570,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(344512,9570,'ms','Tambah jenis bangunan',0),(344513,9570,'ar','Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(344514,9570,'fr','Type de bÃ¢timent ajouter',0),(344515,9570,'jp','å»ºç‰©ã®ç¨®é¡žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(344516,9570,'pt','Adicionar o tipo de edifÃ­cio',0),(344517,9570,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(344518,9570,'es','Agregar Tipo de Edificio',0),(344519,9570,'de','GebÃ¤udetyp hinzufÃ¼gen',0),(344520,9570,'en','Building Type Add',0),(344521,9571,'is','',0),(344522,9571,'dr','Ø­Ø°Ù Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344523,9571,'pr','Ø­Ø°Ù Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344524,9571,'tr','Bina tÃ¼rÃ¼ Sil',0),(344525,9571,'pl','UsuÅ„ typ budynku',0),(344526,9571,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ñ‚Ð¸Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(344527,9571,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(344528,9571,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ñ‚Ð¸Ð¿ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(344529,9571,'vi','XÃ³a loáº¡i thiáº¿t káº¿',0),(344530,9571,'af','Gebou tipe Delete',0),(344531,9571,'ro','Åžtergere de tipul clÄƒdirii',0),(344532,9571,'et','Hoone tÃ¼Ã¼p Kustuta',0),(344533,9571,'si','Izbrisati vrsto stavbe',0),(344534,9571,'ba','Hapus jenis bangunan',0),(344535,9571,'nl','Gebouw Type verwijderen',0),(344536,9571,'fi','Rakennuksen tyyppi Poista',0),(344537,9571,'no','Bygningen Type Slett',0),(344538,9571,'da','Bygningen Type slet',0),(344539,9571,'ko','ê±´ë¬¼ ìœ í˜• ì‚­ì œ',0),(344540,9571,'he','×‘× ×™×™×Ÿ ×¡×•×’ ×ž×—×§',0),(344541,9571,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… ÎºÏ„Î¯ÏÎ¹Î¿ Ï„ÏÏ€Î¿Ï…',0),(344542,9571,'zh','å»ºç­‘ç±»åž‹åˆ é™¤\r\n',0),(344543,9571,'sv','Byggnad typ ta bort',0),(344544,9571,'it','Costruzione tipo Elimina',0),(344545,9571,'tl','',0),(344546,9571,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(344547,9571,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(344548,9571,'ms','Bangunan jenis Hapus',0),(344549,9571,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(344550,9571,'fr','BÃ¢timent Type Delete',0),(344551,9571,'jp','å»ºç‰©ã®ç¨®é¡žã®å‰Šé™¤',0),(344552,9571,'pt','EdifÃ­cio tipo Delete',0),(344553,9571,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(344554,9571,'es','Eliminar Tipo de Edificio',0),(344555,9571,'de','Haus Typ lÃ¶schen',0),(344556,9571,'en','Building Type Delete',0),(344557,9572,'is','',0),(344558,9572,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344559,9572,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344560,9572,'tr','Bina tÃ¼rÃ¼ gÃ¼ncelleÅŸtirme',0),(344561,9572,'pl','Budynek typ aktualizacji',0),(344562,9572,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ñ‚Ð¸Ð¿ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(344563,9572,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(344564,9572,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ð¸Ð¿ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(344565,9572,'vi','Cáº­p nháº­t loáº¡i thiáº¿t káº¿',0),(344566,9572,'af','Gebou tipe bywerking',0),(344567,9572,'ro','Actualizare de tipul clÄƒdirii',0),(344568,9572,'et','Hoone tÃ¼Ã¼p vÃ¤rskendus',0),(344569,9572,'si','Building tip posodobitev',0),(344570,9572,'ba','Bangunan jenis Update',0),(344571,9572,'nl','Gebouw Type Update',0),(344572,9572,'fi','Rakennuksen tyyppi pÃ¤ivitys',0),(344573,9572,'no','Bygningen Type oppdatering',0),(344574,9572,'da','Bygningen Type opdatering',0),(344575,9572,'ko','ê±´ë¬¼ ìœ í˜• ì—…ë°ì´íŠ¸',0),(344576,9572,'he','×‘× ×™×™×Ÿ ×¡×•×’ ×¢×“×›×•×Ÿ',0),(344577,9572,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Ï… ÎºÏ„Î®ÏÎ¹Î¿',0),(344578,9572,'zh','å»ºç­‘ç±»åž‹æ›´æ–°\r\n',0),(344579,9572,'sv','Byggnad typ uppdatering',0),(344580,9572,'it','Aggiornamento del tipo di edificio',0),(344581,9572,'tl','',0),(344582,9572,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(344583,9572,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(344584,9572,'ms','Kemaskini jenis bangunan',0),(344585,9572,'ar','Ø¨Ù†Ø§Ø¡ Ù†ÙˆØ¹ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(344586,9572,'fr','Mise Ã  jour du Type de bÃ¢timent',0),(344587,9572,'jp','å»ºç‰©ã®ç¨®é¡žæ›´æ–°',0),(344588,9572,'pt','ActualizaÃ§Ã£o do tipo de edifÃ­cio',0),(344589,9572,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð° Ð·Ð´Ð°Ð½Ð¸Ñ',0),(344590,9572,'es','Actualizar Tipo de Edificio',0),(344591,9572,'de','Haus Typ Update',0),(344592,9572,'en','Building Type Update',0),(344593,9573,'is','',0),(344594,9573,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344595,9573,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344596,9573,'tr','Hata ekleme bina tipi',0),(344597,9573,'pl','BÅ‚Ä…d dodawania budynku typu',0),(344598,9573,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°',0),(344599,9573,'ur','Ù†Ù‚Øµ Ø§Ø¶Ø§ÙÛ Ø¹Ù…Ø§Ø±Øª Ù‚Ø³Ù…',0),(344600,9573,'sr','Ð¢Ð¸Ð¿ Ð·Ð³Ñ€Ð°Ð´Ðµ Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ Ð³Ñ€ÐµÑˆÐºÐµ',0),(344601,9573,'vi',' ThÃªm loáº¡i thiáº¿t káº¿ bá»‹ lá»—i',0),(344602,9573,'af','Voeg gebou fouttipe',0),(344603,9573,'ro','Eroare adÄƒugÃ¢nd clÄƒdire tip',0),(344604,9573,'et','Viga lisades hoone tÃ¼Ã¼p',0),(344605,9573,'si','Vrsta stavbe dodajanje napake',0),(344606,9573,'ba','Jenis galat menambahkan bangunan',0),(344607,9573,'nl','Fout bij toevoegen van bouwtype',0),(344608,9573,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ rakennuksen tyyppi',0),(344609,9573,'no','Feil Ã¥ legge bygge Type',0),(344610,9573,'da','Fejl tilfÃ¸je bygning Type',0),(344611,9573,'ko','ì˜¤ë¥˜ ì¶”ê°€ ê±´ë¬¼ ìœ í˜•',0),(344612,9573,'he','×©×’×™××” ×”×•×¡×¤×ª ×¡×•×’ ×ž×‘× ×”',0),(344613,9573,'el','Î¤ÏÏ€Î¿Ï‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·Ï‚ ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(344614,9573,'zh','é”™è¯¯ï¼šæ–°å¢žå»ºç­‘ç±»åž‹\r\n',0),(344615,9573,'sv','Fel att lÃ¤gga till byggnadstyp',0),(344616,9573,'it','Tipo di edificio aggiungendo errore',0),(344617,9573,'tl','',0),(344618,9573,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(344619,9573,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤‡à¤®à¤¾à¤°à¤¤ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(344620,9573,'ms','Ralat menambah jenis bangunan',0),(344621,9573,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(344622,9573,'fr','Erreur ajout dâ€™un Type de bÃ¢timent',0),(344623,9573,'jp','ã‚¨ãƒ©ãƒ¼ã‚’è¿½åŠ ã™ã‚‹å»ºç‰©ã®ç¨®é¡ž',0),(344624,9573,'pt','Tipo de edifÃ­cio erro adicionando',0),(344625,9573,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ñ‚Ð¸Ð¿ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(344626,9573,'es','Error Agregando Tipo de Edificio',0),(344627,9573,'de','Fehler hinzufÃ¼gen GebÃ¤udetyp',0),(344628,9573,'en','Error Adding Building Type',0),(344629,9574,'is','',0),(344630,9574,'dr','Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(344631,9574,'pr','Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(344632,9574,'tr','Bina tipi baÅŸarÄ±yla eklendi',0),(344633,9574,'pl','Budynek typ dodany pomyÅ›lnie',0),(344634,9574,'bg','Ð¢Ð¸Ð¿ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(344635,9574,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù‚Ø³Ù… Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(344636,9574,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(344637,9574,'vi','ThÃªm loáº¡i thiáº¿ káº¿ thÃ nh cÃ´ng',0),(344638,9574,'af','Gebou Tipe Suksesvol Bygevoeg',0),(344639,9574,'ro','Tip cladire adÄƒugat cu succes',0),(344640,9574,'et','Hoone tÃ¼Ã¼p on edukalt',0),(344641,9574,'si','UspeÅ¡no dodana vrsta stavbe',0),(344642,9574,'ba','Tipe bangunan ditambahkan berhasil',0),(344643,9574,'nl','Gebouw Type toegevoegd',0),(344644,9574,'fi','Rakennuksen tyyppi lisÃ¤Ã¤minen onnistui',0),(344645,9574,'no','Building Type lagt',0),(344646,9574,'da','Bygningen Type tilfÃ¸jet',0),(344647,9574,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ê±´ë¬¼ ìœ í˜•',0),(344648,9574,'he','×¡×•×’ ×ž×‘× ×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(344649,9574,'el','Î ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Ï„Î¿Î½ Ï„ÏÏ€Î¿ Ï„Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(344650,9574,'zh','å»ºç­‘ç±»åž‹æ·»åŠ æˆåŠŸ\r\n',0),(344651,9574,'sv','Byggnadstyp som lagts',0),(344652,9574,'it','Tipo di edificio aggiunto con successo',0),(344653,9574,'tl','',0),(344654,9574,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(344655,9574,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(344656,9574,'ms','Jenis bangunan yang berjaya menambah',0),(344657,9574,'ar','Ù†ÙˆØ¹ Ø¨Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(344658,9574,'fr','Type de bÃ¢timent ajoutÃ© avec succÃ¨s',0),(344659,9574,'jp','å»ºç‰©ã®ç¨®é¡žãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(344660,9574,'pt','Tipo de edifÃ­cio adicionado com sucesso',0),(344661,9574,'ru','Ð¢Ð¸Ð¿ Ð·Ð´Ð°Ð½Ð¸Ñ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(344662,9574,'es','Tipo de Edificio Agregado Exitosamente',0),(344663,9574,'de','GebÃ¤udetyp erfolgreich hinzugefÃ¼gt',0),(344664,9574,'en','Building Type Added Successfully',0),(344665,9575,'is','',0),(344666,9575,'dr','Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ù‡ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯',0),(344667,9575,'pr','Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ù‡ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯',0),(344668,9575,'tr','Binaya baÄŸlÄ± bina tipi',0),(344669,9575,'pl','Typ budynku doÅ‚Ä…czony do budynku',0),(344670,9575,'bg','Ð¢Ð¸Ð¿ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°, Ð¿Ñ€Ð¸ÐºÑ€ÐµÐ¿ÐµÐ½Ð° ÐºÑŠÐ¼ ÑÐ³Ñ€Ð°Ð´Ð°',0),(344671,9575,'ur','Ø¹Ù…Ø§Ø±Øª Ø³Û’ Ù…Ù†Ø³Ù„Ú© Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù‚Ø³Ù…',0),(344672,9575,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ñ‚Ð¸Ð¿Ð° Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(344673,9575,'vi','Loáº¡i thiáº¿t káº¿ kÃ¨m theo',0),(344674,9575,'af','Gebou tipe verbonde aan gebou',0),(344675,9575,'ro','Tip cladire ataÅŸat la clÄƒdirea',0),(344676,9575,'et','Hoone tÃ¼Ã¼bi hoone',0),(344677,9575,'si','Vrsta stavbe pritrjena stavbe',0),(344678,9575,'ba','Tipe bangunan yang melekat pada bangunan',0),(344679,9575,'nl','Gebouw Type gekoppeld aan gebouw',0),(344680,9575,'fi','Rakennuksen tyyppi liitetÃ¤Ã¤n rakennuksen',0),(344681,9575,'no','Building Type knyttet til bygningen',0),(344682,9575,'da','Bygningen Type knyttet til bygning',0),(344683,9575,'ko','ê±´ë¬¼ì— ì—°ê²° ëœ ê±´ë¬¼ ìœ í˜•',0),(344684,9575,'he','×¡×•×’ ×ž×‘× ×” ×¦×ž×•×“ ×œ×‘× ×™×™×Ÿ',0),(344685,9575,'el','Î¤ÏÏ€Î¿Ï‚ ÎºÏ„Î¹ÏÎ¯Î¿Ï… Ï€Î¿Ï… ÎµÏ€Î¹ÏƒÏ…Î½Î¬Ï€Ï„ÎµÏ„Î±Î¹ ÏƒÏ„Î¿ ÎºÏ„Î¯ÏÎ¹Î¿',0),(344686,9575,'zh','å»ºç­‘ç±»åž‹é™„åŠ äºŽå»ºç­‘\r\n',0),(344687,9575,'sv','Byggnadstyp bifogas byggnad',0),(344688,9575,'it','Tipo di edificio collegato all\'edificio',0),(344689,9575,'tl','',0),(344690,9575,'th','&#3649;&#3609;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3621;&#3',0),(344691,9575,'hi','à¤­à¤µà¤¨ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤²à¤—à¥à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(344692,9575,'ms','Jenis bangunan yang melekat pada bangunan',0),(344693,9575,'ar','Ù†ÙˆØ¹ Ø¨Ù†Ø§Ø¡ ÙŠØ¹Ù„Ù‚ Ø¹Ù„Ù‰ Ø¨Ù†Ø§Ø¡',0),(344694,9575,'fr','Type de bÃ¢timent, attachÃ© au bÃ¢timent',0),(344695,9575,'jp','ãƒ“ãƒ«ãƒ‡ã‚£ãƒ³ã‚° ã‚¿ã‚¤ãƒ—ã®å»ºç‰©ã«æŽ¥ç¶šã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(344696,9575,'pt','Tipo de edifÃ­cio anexado ao edifÃ­cio',0),(344697,9575,'ru','Ð¢Ð¸Ð¿ Ð·Ð´Ð°Ð½Ð¸Ñ, Ð¿Ñ€Ð¸Ð²ÑÐ·Ð°Ð½Ð½Ñ‹Ð¹ Ðº Ð·Ð´Ð°Ð½Ð¸ÑŽ',0),(344698,9575,'es','Tipo de Edificio Apegado al Edificio',0),(344699,9575,'de','GebÃ¤udetyp an GebÃ¤ude angeschlossen',0),(344700,9575,'en','Building Type Attached To Building',0),(344701,9576,'is','',0),(344702,9576,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù  Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344703,9576,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù  Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344704,9576,'tr','Bina tipi silme hatasÄ±',0),(344705,9576,'pl','BÅ‚Ä…d podczas usuwania typu budynku',0),(344706,9576,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ ÑÐ³Ñ€Ð°Ð´Ð°',0),(344707,9576,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(344708,9576,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ‚Ð¸Ð¿ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(344709,9576,'vi','XÃ³a loáº¡i thiáº¿t káº¿ bá»‹ lá»—i',0),(344710,9576,'af','Kon nie gebou tipe skrap',0),(344711,9576,'ro','Eroare la È™tergerea clÄƒdire tip',0),(344712,9576,'et','TÃµrge kustutamisel hoone tÃ¼Ã¼p',0),(344713,9576,'si','Napaka brisanja objekta tipa',0),(344714,9576,'ba','Error menghapus jenis bangunan',0),(344715,9576,'nl','Fout bij het verwijderen van gebouw Type',0),(344716,9576,'fi','Virhe poistettaessa rakennuksen tyyppi',0),(344717,9576,'no','Feil ved sletting av bygning skriver',0),(344718,9576,'da','Fejl ved sletning af bygningen Type',0),(344719,9576,'ko','ê±´ë¬¼ ìœ í˜• ì‚­ì œ ì˜¤ë¥˜',0),(344720,9576,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×¡×•×’ ×ž×‘× ×”',0),(344721,9576,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„ÏÏ€Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(344722,9576,'zh','å»ºç­‘ç±»åž‹é”™è¯¯åˆ é™¤\r\n',0),(344723,9576,'sv','Misstag utplÃ¥nande byggnadstyp',0),(344724,9576,'it','Errore durante l\'eliminazione di tipologia edilizia',0),(344725,9576,'tl','',0),(344726,9576,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(344727,9576,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(344728,9576,'ms','Ralat Menghapuskan jenis bangunan',0),(344729,9576,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(344730,9576,'fr','Erreur de suppression de Type de bÃ¢timent',0),(344731,9576,'jp','å»ºç‰©ã®ã‚¿ã‚¤ãƒ—ã®å‰Šé™¤ã‚¨ãƒ©ãƒ¼',0),(344732,9576,'pt','Erro ao excluir o tipo de edifÃ­cio',0),(344733,9576,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¸Ð¿Ð° Ð·Ð´Ð°Ð½Ð¸Ñ',0),(344734,9576,'es','Error Eliminando Tipo de Edificio',0),(344735,9576,'de','Fehler beim LÃ¶schen der GebÃ¤udetyp',0),(344736,9576,'en','Error Deleting Building Type',0),(344737,9577,'is','',0),(344738,9577,'dr','Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(344739,9577,'pr','Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(344740,9577,'tr','Bina tipi baÅŸarÄ±yla silindi',0),(344741,9577,'pl','Typ budynku usuniÄ™ty',0),(344742,9577,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ñ‚Ð¸Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(344743,9577,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù‚Ø³Ù…',0),(344744,9577,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(344745,9577,'vi','XÃ³a loáº¡i thiáº¿t káº¿ thÃ nh cÃ´ng',0),(344746,9577,'af','Gebou Tipe Suksesvol Geskrap',0),(344747,9577,'ro','Tip cladire eliminÄƒ cu succes',0),(344748,9577,'et','Hoone tÃ¼Ã¼p edukalt kustutatud',0),(344749,9577,'si','Vrsta stavbe, uspeÅ¡no izbrisana',0),(344750,9577,'ba','Tipe bangunan dihapus berhasil',0),(344751,9577,'nl','Gebouw Type succesvol verwijderd',0),(344752,9577,'fi','Rakennuksen tyyppi poistettu',0),(344753,9577,'no','Building Type slettet',0),(344754,9577,'da','Bygningen Type slettet',0),(344755,9577,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ê±´ë¬¼ ìœ í˜•',0),(344756,9577,'he','×¡×•×’ ×ž×‘× ×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(344757,9577,'el','Î¤ÏÏ€Î¿Ï‚ ÎºÏ„Î¹ÏÎ¯Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(344758,9577,'zh','å»ºç­‘ç±»åž‹æˆåŠŸåˆ é™¤\r\n',0),(344759,9577,'sv','Byggnadstyp raderades',0),(344760,9577,'it','Tipo di edificio cancellato con successo',0),(344761,9577,'tl','',0),(344762,9577,'th','&#3621;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(344763,9577,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾',0),(344764,9577,'ms','Jenis bangunan yang dihapuskan dengan jayanya',0),(344765,9577,'ar','Ù†ÙˆØ¹ Ø¨Ù†Ø§Ø¡ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(344766,9577,'fr','Type de bÃ¢timent supprimÃ© avec succÃ¨s',0),(344767,9577,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸå»ºç‰©ã‚¿ã‚¤ãƒ—',0),(344768,9577,'pt','Tipo de edifÃ­cio excluÃ­do com Ãªxito',0),(344769,9577,'ru','Ð¢Ð¸Ð¿ Ð·Ð´Ð°Ð½Ð¸Ñ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾',0),(344770,9577,'es','Tipo de Edificio Eliminado Exitosamente',0),(344771,9577,'de','GebÃ¤udetyp erfolgreich gelÃ¶scht',0),(344772,9577,'en','Building Type Deleted Successfully',0),(344773,9578,'is','',0),(344774,9578,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344775,9578,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(344776,9578,'tr','Bina tipi gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(344777,9578,'pl','BÅ‚Ä…d aktualizacji typu budynku',0),(344778,9578,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ‚Ð¸Ð¿ ÑÐ³Ñ€Ð°Ð´Ð°',0),(344779,9578,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(344780,9578,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ‚Ð¸Ð¿ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(344781,9578,'vi','Cáº­p nháº­t loáº¡i thiáº¿t káº¿ bá»‹ lá»—i',0),(344782,9578,'af','Fout bywerking gebou tipe',0),(344783,9578,'ro','Eroare la actualizarea clÄƒdire tip',0),(344784,9578,'et','Hoone tÃ¼Ã¼bi vÃ¤rskendamise tÃµrge',0),(344785,9578,'si','Napaka pri posodabljanju stavbe tipa',0),(344786,9578,'ba','Kesalahan memperbarui jenis bangunan',0),(344787,9578,'nl','Fout bij het bijwerken van gebouw Type',0),(344788,9578,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ rakennuksen tyyppi',0),(344789,9578,'no','Feil under oppdatering av bygning skriver',0),(344790,9578,'da','Fejl under opdatering af bygningen Type',0),(344791,9578,'ko','ê±´ë¬¼ ìœ í˜• ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(344792,9578,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×¡×•×’ ×ž×‘× ×”',0),(344793,9578,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(344794,9578,'zh','å»ºç­‘ç±»åž‹é”™è¯¯æ›´æ–°\r\n',0),(344795,9578,'sv','Fel vid uppdatering av byggnadstyp',0),(344796,9578,'it','Errore di aggiornamento tipo di edificio',0),(344797,9578,'tl','',0),(344798,9578,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3',0),(344799,9578,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(344800,9578,'ms','Ralat dalam mengemas kini jenis bangunan',0),(344801,9578,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(344802,9578,'fr','Erreur mise Ã  jour du Type de bÃ¢timent',0),(344803,9578,'jp','å»ºç‰©ã®ç¨®é¡žã‚’æ›´æ–°ä¸­ã®ã‚¨ãƒ©ãƒ¼',0),(344804,9578,'pt','Erro ao atualizar o tipo de edifÃ­cio',0),(344805,9578,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ‚Ð¸Ð¿Ð° Ð·Ð´Ð°Ð½Ð¸Ñ',0),(344806,9578,'es','Error Actualizando Tipo de Edificio',0),(344807,9578,'de','Fehler beim Aktualisieren der GebÃ¤udetyp',0),(344808,9578,'en','Error Updating Building Type',0),(344809,9579,'is','',0),(344810,9579,'dr','Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(344811,9579,'pr','Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(344812,9579,'tr','Bina tipi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(344813,9579,'pl','Typ budynku pomyÅ›lnie zaktualizowana',0),(344814,9579,'bg','Ð¢Ð¸Ð¿ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(344815,9579,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(344816,9579,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(344817,9579,'vi','Cáº­p nháº­t loáº¡i thiáº¿t káº¿ thÃ nh cÃ´ng',0),(344818,9579,'af','Gebou Tipe Suksesvol Opdateer',0),(344819,9579,'ro','Tip cladire actualizat cu succes',0),(344820,9579,'et','Hoone tÃ¼Ã¼p vÃ¤rskendamine Ãµnnestus',0),(344821,9579,'si','Vrsta stavbe, uspeÅ¡no posodobljena',0),(344822,9579,'ba','Tipe bangunan yang berhasil',0),(344823,9579,'nl','Gebouw Type bijgewerkt',0),(344824,9579,'fi','Rakennuksen tyyppi pÃ¤ivitetty',0),(344825,9579,'no','Building Type oppdatert',0),(344826,9579,'da','Bygningen Type opdateret',0),(344827,9579,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ê±´ë¬¼ ìœ í˜•',0),(344828,9579,'he','×¡×•×’ ×ž×‘× ×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(344829,9579,'el','Î¤ÏÏ€Î¿Ï‚ ÎºÏ„Î¹ÏÎ¯Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(344830,9579,'zh','å»ºç­‘ç±»åž‹æˆåŠŸæ›´æ–°\r\n',0),(344831,9579,'sv','Byggnadstyp uppdaterats',0),(344832,9579,'it','Tipo di edificio aggiornato con successo',0),(344833,9579,'tl','',0),(344834,9579,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(344835,9579,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(344836,9579,'ms','Jenis bangunan yang berjaya dikemas kini',0),(344837,9579,'ar','Ù†ÙˆØ¹ Ø¨Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(344838,9579,'fr','Type de bÃ¢timent, mis Ã  jour avec succÃ¨s',0),(344839,9579,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸå»ºç‰©ã‚¿ã‚¤ãƒ—',0),(344840,9579,'pt','Tipo de construÃ§Ã£o atualizado com sucesso',0),(344841,9579,'ru','Ð¢Ð¸Ð¿ Ð·Ð´Ð°Ð½Ð¸Ñ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(344842,9579,'es','Tipo de Edificio Actualizado Exitosamente',0),(344843,9579,'de','GebÃ¤udetyp erfolgreich aktualisiert',0),(344844,9579,'en','Building Type Updated Successfully',0),(344845,9580,'is','',0),(344846,9580,'dr','Ø³Ø§Ù„ ØªØ­ØµÙŠÙ„ÙŠ ',0),(344847,9580,'pr','Ø³Ø§Ù„ ØªØ­ØµÙŠÙ„ÙŠ ',0),(344848,9580,'tr','Akademik yÄ±l',0),(344849,9580,'pl','Rok akademicki',0),(344850,9580,'bg','ÐÐºÐ°Ð´ÐµÐ¼Ð¸Ñ‡Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(344851,9580,'ur',' Ø³Ø§Ù„Ø§Ù†Û ÙˆØµÙˆÙ„ÛŒ',0),(344852,9580,'sr','ÐÐºÐ°Ð´ÐµÐ¼ÑÐºÐµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(344853,9580,'vi','nÄƒm há»c',0),(344854,9580,'af','Akademiese Jaar',0),(344855,9580,'ro','An universitar',0),(344856,9580,'et','Ã•ppeaasta',0),(344857,9580,'si','Å tudijskem letu',0),(344858,9580,'ba','Tahun',0),(344859,9580,'nl','Academiejaar\r\n',0),(344860,9580,'fi','Lukuvuosi',0),(344861,9580,'no','StudieÃ¥ret',0),(344862,9580,'da','Akademiske Ã¥r',0),(344863,9580,'ko','í•™ì‚¬ ì—°ë„',0),(344864,9580,'he','×©× ×” ××§×“×ž××™×ª',0),(344865,9580,'el','Î‘ÎºÎ±Î´Î·Î¼Î±ÏŠÎºÎ® Î§ÏÎ¿Î½Î¹Î¬',0),(344866,9580,'zh','å­¦å¹´',0),(344867,9580,'sv','Akademisk Ã¥r',0),(344868,9580,'it','Anno Accademico',0),(344869,9580,'tl','',0),(344870,9580,'th','&#3611;&#3637;&#3585;&#3634;&#3619;&#3624;&#3638;&#3585;&#3625;&#3634;',0),(344871,9580,'hi','à¤¶à¥ˆà¤•à¥à¤·à¤¿à¤• à¤µà¤°à¥à¤·',0),(344872,9580,'ms','Tahun akademik',0),(344873,9580,'ar','Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ø¯Ø±Ø§Ø³ÙŠØ©',0),(344874,9580,'fr','AnnÃ©e acadÃ©mique',0),(344875,9580,'jp','å¹´åº¦',0),(344876,9580,'pt','Ano acadÃªmico',0),(344877,9580,'ru','ÐÐºÐ°Ð´ÐµÐ¼Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð“Ð¾Ð´',0),(344878,9580,'es','AÃ±o Academico',0),(344879,9580,'de','Akademisches Jahr',0),(344880,9580,'en','Academic Year',0),(344881,9581,'is','',0),(344882,9581,'dr','Ù„Ø·ÙØ§ Ø¯ÙˆØ±Ù‡ Ø§Ø¬Ø§Ø±Ù‡  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(344883,9581,'pr','Ù„Ø·ÙØ§ Ø¯ÙˆØ±Ù‡ Ø§Ø¬Ø§Ø±Ù‡  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(344884,9581,'tr','Mutlu etmek katmak kÄ±ralÄ±k sÃ¼resi',0),(344885,9581,'pl','ProszÄ™ podaÄ‡ okres wynajÄ™cia',0),(344886,9581,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð½Ð°ÐµÐ¼ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(344887,9581,'ur','Ø¨Ø±Ø§Ø¦Û’ Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ú©Ø±Ø§Ø¦Û’ Ú©ÛŒ Ù…Ø¯Øª Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(344888,9581,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ¸Ñ€Ð¸Ñ˜Ñƒ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(344889,9581,'vi','vui lÃ²ng bao gá»“m thá»i gian thuÃª',0),(344890,9581,'af','Sluit asseblief Huur Periode in',0),(344891,9581,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i perioada de inchiriere',0),(344892,9581,'et','Palun lisa rendiperiood',0),(344893,9581,'si','Prosimo, da vkljuÄite najem obdobje',0),(344894,9581,'ba','Harap sertakan periode sewa',0),(344895,9581,'nl','Gelieve te omvatten huur periode',0),(344896,9581,'fi','LiitÃ¤ mukaan vuokra-ajan',0),(344897,9581,'no','Ta med leie periode',0),(344898,9581,'da','VedlÃ¦g leje periode',0),(344899,9581,'ko','ìž„ëŒ€ ê¸°ê°„ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(344900,9581,'he','×× × ×›×œ×•×œ ×ª×§×•×¤×ª ×”×©×›×¨×”',0),(344901,9581,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î•Î½Î¿Î¹ÎºÎ¯Î±ÏƒÎ· Ï€ÎµÏÎ¯Î¿Î´Î¿Ï‚',0),(344902,9581,'zh','è¯·åˆ—å…¥ç§Ÿé‡‘æœŸ\r\n',0),(344903,9581,'sv','VÃ¤nligen inkludera hyra Period',0),(344904,9581,'it','Si prega di includere il periodo',0),(344905,9581,'tl','',0),(344906,9581,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3585;&#3634;&#3619;&#3648;&#3594;&#3656;&#3634;',0),(344907,9581,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤¿à¤°à¤¾à¤¯à¤¾ à¤…à¤µà¤§à¤¿ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(344908,9581,'ms','Sila sertakan tempoh sewa',0),(344909,9581,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† ÙØªØ±Ø© Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(344910,9581,'fr','Veuillez indiquer la pÃ©riode de location',0),(344911,9581,'jp','ãƒ¬ãƒ³ã‚¿ãƒ«æœŸé–“ã‚’æ˜Žè¨˜ã—ã¦',0),(344912,9581,'pt','Por favor inclua o perÃ­odo de aluguel',0),(344913,9581,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´ ÐÑ€ÐµÐ½Ð´Ñ‹',0),(344914,9581,'es','Por Favor Incluye PerÃ­odo de Renta',0),(344915,9581,'de','Bitte fÃ¼gen Sie Miete Zeitraum',0),(344916,9581,'en','Please Include Rent Period',0),(344917,9582,'is','',0),(344918,9582,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¬Ø§Ø±Ù‡ ',0),(344919,9582,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¬Ø§Ø±Ù‡ ',0),(344920,9582,'tr','Kira tutarÄ±',0),(344921,9582,'pl','Kwota czynszu',0),(344922,9582,'bg','Ð¡ÑƒÐ¼Ð°Ñ‚Ð° Ð·Ð° Ð½Ð°ÐµÐ¼Ð°',0),(344923,9582,'ur','Ú©Ø±Ø§ÛŒÛ Ú©ÛŒ Ø±Ù‚Ù…',0),(344924,9582,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ñƒ',0),(344925,9582,'vi','tá»•ng sá»‘ thuÃª',0),(344926,9582,'af','Huur bedrag',0),(344927,9582,'ro','Chirie suma',0),(344928,9582,'et','Rendisumma',0),(344929,9582,'si','Znesek najemnine',0),(344930,9582,'ba','Jumlah sewa',0),(344931,9582,'nl','Bedrag van de huur',0),(344932,9582,'fi','Vuokrattavana mÃ¤Ã¤rÃ¤',0),(344933,9582,'no','Leie belÃ¸p',0),(344934,9582,'da','Leje belÃ¸b',0),(344935,9582,'ko','ìž„ëŒ€ ê¸ˆì•¡',0),(344936,9582,'he','×¡×›×•× ×”×©×›×™×¨×•×ª',0),(344937,9582,'el','Î•Î½Î¿Î¯ÎºÎ¹Î¿',0),(344938,9582,'zh','ç§Ÿé‡‘æ•°é¢\r\n',0),(344939,9582,'sv','Hyresbeloppet',0),(344940,9582,'it','Importo affitto',0),(344941,9582,'tl','',0),(344942,9582,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3585;&#3634;&#3619;&#3648;&#3594;&#3656;&#3634;',0),(344943,9582,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¤¾ à¤°à¤¾à¤¶à¤¿',0),(344944,9582,'ms','Amaun sewa',0),(344945,9582,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(344946,9582,'fr','Montant du loyer',0),(344947,9582,'jp','å®¶è³ƒé¡',0),(344948,9582,'pt','Quantidade de aluguel',0),(344949,9582,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð°Ñ€ÐµÐ½Ð´Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(344950,9582,'es','Cantidad de Renta',0),(344951,9582,'de','HÃ¶he der Miete',0),(344952,9582,'en','Rent Amount',0),(344953,9583,'is','',0),(344954,9583,'dr','Ø¯ÙˆØ±Ù‡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(344955,9583,'pr','Ø¯ÙˆØ±Ù‡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(344956,9583,'tr','KÄ±ralÄ±k sÃ¼resi',0),(344957,9583,'pl','Wynajem okres',0),(344958,9583,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´ Ð½Ð° Ð½Ð°ÐµÐ¼Ð°Ð½Ðµ',0),(344959,9583,'ur','Ú©Ø±Ø§Ø¦Û’ Ú©ÛŒ Ù…Ø¯Øª',0),(344960,9583,'sr','ÐÐ°Ñ˜Ð°Ð¼ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(344961,9583,'vi','ká»³ háº¡n thuÃª',0),(344962,9583,'af','Verhuringsperiode',0),(344963,9583,'ro','Perioada de inchiriere',0),(344964,9583,'et','Rendi periood',0),(344965,9583,'si','Najem obdobje',0),(344966,9583,'ba','Periode sewa',0),(344967,9583,'nl','Huur periode',0),(344968,9583,'fi','Vuokra-ajan',0),(344969,9583,'no','Leie periode',0),(344970,9583,'da','Leje periode',0),(344971,9583,'ko','ìž„ëŒ€ ê¸°ê°„',0),(344972,9583,'he','×ª×§×•×¤×ª ×©×›×™×¨×•×ª',0),(344973,9583,'el','Î•Î½Î¿Î¹ÎºÎ¯Î±ÏƒÎ· Ï€ÎµÏÎ¯Î¿Î´Î¿Ï‚',0),(344974,9583,'zh','ç§ŸæœŸå†…\r\n',0),(344975,9583,'sv','Hyra Period',0),(344976,9583,'it','Periodo di affitto',0),(344977,9583,'tl','',0),(344978,9583,'th','&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3648;&#3594;&#3656;&#3634;',0),(344979,9583,'hi','à¤•à¤¿à¤°à¤¾à¤ à¤ªà¤° à¤²à¥‡à¤¨à¥‡ à¤•à¥€ à¤…à¤µà¤§à¤¿',0),(344980,9583,'ms','Tempoh sewa',0),(344981,9583,'ar','ÙØªØ±Ø© Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(344982,9583,'fr','PÃ©riode de location',0),(344983,9583,'jp','è³ƒè²¸æœŸé–“',0),(344984,9583,'pt','PerÃ­odo de aluguel',0),(344985,9583,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´ ÐÑ€ÐµÐ½Ð´Ñ‹',0),(344986,9583,'es','PerÃ­odo de Renta',0),(344987,9583,'de','Miete Zeitraum',0),(344988,9583,'en','Rent Period',0),(344989,9584,'is','',0),(344990,9584,'dr','Ù†ÙŠÙ…Ø³Ø§Ù„ ØªØ­ØµÙŠÙ„ÙŠ',0),(344991,9584,'pr','Ù†ÙŠÙ…Ø³Ø§Ù„ ØªØ­ØµÙŠÙ„ÙŠ',0),(344992,9584,'tr','DÃ¶nem',0),(344993,9584,'pl','Semestru',0),(344994,9584,'bg','Ð¡ÐµÐ¼ÐµÑÑ‚ÑŠÑ€',0),(344995,9584,'ur','Ø³Ù…Ø³Ù¹Ø±',0),(344996,9584,'sr','Ð¡ÐµÐ¼ÐµÑÑ‚Ð°Ñ€',0),(344997,9584,'vi','há»c ká»³',0),(344998,9584,'af','Semester',0),(344999,9584,'ro','Semestru',0),(345000,9584,'et','Poolaasta',0),(345001,9584,'si','Semester',0),(345002,9584,'ba','Semester',0),(345003,9584,'nl','Semester',0),(345004,9584,'fi','Lukukauden',0),(345005,9584,'no','Semester',0),(345006,9584,'da','Semester',0),(345007,9584,'ko','í•™ê¸°',0),(345008,9584,'he','×¡×ž×¡×˜×¨',0),(345009,9584,'el','Î•Î¾Î¬Î¼Î·Î½Î¿',0),(345010,9584,'zh','å­¦æœŸ\r\n',0),(345011,9584,'sv','Planeringsterminen',0),(345012,9584,'it','Semestre',0),(345013,9584,'tl','',0),(345014,9584,'th','&#3648;&#3607;&#3629;&#3617;',0),(345015,9584,'hi','à¤¸à¥‡à¤®à¥‡à¤¸à¥à¤Ÿà¤°',0),(345016,9584,'ms','Semester',0),(345017,9584,'ar','Ø§Ù„ÙØµÙ„ Ø§Ù„Ø¯Ø±Ø§Ø³ÙŠ',0),(345018,9584,'fr','Semestre',0),(345019,9584,'jp','å­¦æœŸ',0),(345020,9584,'pt','Semestre',0),(345021,9584,'ru','Ð¡ÐµÐ¼ÐµÑÑ‚Ñ€',0),(345022,9584,'es','Semestre',0),(345023,9584,'de','Semester',0),(345024,9584,'en','Semester',0),(345025,9585,'is','',0),(345026,9585,'dr','Ù¾Ø§Ù†Ø²Ø¯Ù‡ Ø±ÙˆØ²ÙŠÚ©Ø¨Ø§Ø±',0),(345027,9585,'pr','Ù¾Ø§Ù†Ø²Ø¯Ù‡ Ø±ÙˆØ²ÙŠÚ©Ø¨Ø§Ø±',0),(345028,9585,'tr','YarÄ± aylÄ±k',0),(345029,9585,'pl','PÃ³Å‚-miesiÄ™czne',0),(345030,9585,'bg','ÐŸÐ¾Ð»Ñƒ-Ð¼ÐµÑÐµÑ‡ÐµÐ½',0),(345031,9585,'ur','Ø³ÛŒÙ…ÛŒ Ù…Ø§ÛØ§Ù†Û',0),(345032,9585,'sr','ÐŸÐ¾Ð»Ñƒ -Ñ˜ÐµÐ´Ð½Ð¾Ð¼ Ð¼ÐµÑÐµÑ‡Ð½Ð¾',0),(345033,9585,'vi','Giá»¯a thÃ¡ng',0),(345034,9585,'af','Semi-Maandeliks',0),(345035,9585,'ro','Semi-lunar',0),(345036,9585,'et','Poolekuine',0),(345037,9585,'si','Pol-meseÄno',0),(345038,9585,'ba','Semi bulanan',0),(345039,9585,'nl','Semi-maandelijks',0),(345040,9585,'fi','Toinen kuukausi',0),(345041,9585,'no','Semi-mÃ¥nedlige',0),(345042,9585,'da','Semi-mÃ¥nedlige',0),(345043,9585,'ko','ë°˜ ì›”',0),(345044,9585,'he','×—×¦×™-×—×•×“×©×™',0),(345045,9585,'el','Î—Î¼Î¹-Î¼Î·Î½Î¹Î±Î¯Î±',0),(345046,9585,'zh','åŠæœˆ\r\n',0),(345047,9585,'sv','Semi-monthly',0),(345048,9585,'it','Semi-mensile',0),(345049,9585,'tl','',0),(345050,9585,'th','&#3588;&#3619;&#3638;&#3656;&#3591;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(345051,9585,'hi','à¤…à¤°à¥à¤¦à¥à¤§-à¤®à¤¾à¤¸à¤¿à¤•',0),(345052,9585,'ms','Setengah bulanan',0),(345053,9585,'ar','Ù†ØµÙ Ø´Ù‡Ø±ÙŠ',0),(345054,9585,'fr','Deux fois par mois',0),(345055,9585,'jp','åŠæœˆåˆŠ',0),(345056,9585,'pt','Semi-mensal',0),(345057,9585,'ru','Ð Ð°Ð·Ð° Ð² Ð¼ÐµÑÑÑ†',0),(345058,9585,'es','Quincenal',0),(345059,9585,'de','Halbmonatlich',0),(345060,9585,'en','Semi-Monthly',0),(345061,9586,'is','',0),(345062,9586,'dr','Ù†ÙŠÙ…Ø³Ø§Ù„ ',0),(345063,9586,'pr','Ù†ÙŠÙ…Ø³Ø§Ù„ ',0),(345064,9586,'tr','YarÄ± yÄ±llÄ±k',0),(345065,9586,'pl','PÃ³Å‚ roku',0),(345066,9586,'bg','ÐŸÐ¾Ð»Ñƒ-ÐµÐ¶ÐµÐ³Ð¾Ð´Ð½Ð¾',0),(345067,9586,'ur','Ø³ÛŒÙ…ÛŒ Ø³Ø§Ù„Ø§Ù†Û',0),(345068,9586,'sr','ÐŸÐ¾Ð»Ñƒ-Ð³Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(345069,9586,'vi','Giá»¯a nÄƒm',0),(345070,9586,'af','Semi-Jaarliks',0),(345071,9586,'ro','Semi-anual',0),(345072,9586,'et','Pooleaastane',0),(345073,9586,'si','Pol-letno',0),(345074,9586,'ba','Semi tahunan',0),(345075,9586,'nl','Semi-jaarlijkse',0),(345076,9586,'fi','Semi vuosittain',0),(345077,9586,'no','Semi-Ã¥rlig',0),(345078,9586,'da','Semi-Ã¥rlige',0),(345079,9586,'ko','ì„¸ë¯¸ ë§¤ë…„',0),(345080,9586,'he','×—×¦×™-×©× ×ª×™',0),(345081,9586,'el','Î—Î¼Î¹-ÎµÏ„Î®ÏƒÎ¹Î±',0),(345082,9586,'zh','åŠå¹´åº¦ä¸šç»©\r\n',0),(345083,9586,'sv','Semi Ã¥rligt',0),(345084,9586,'it','Semi-annuale',0),(345085,9586,'tl','',0),(345086,9586,'th','&#3588;&#3619;&#3638;&#3656;&#3591;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(345087,9586,'hi','à¤…à¤°à¥à¤§ à¤µà¤¾à¤°à¥à¤·à¤¿à¤•',0),(345088,9586,'ms','Separuh Tahunan',0),(345089,9586,'ar','Ù†ØµÙ Ø³Ù†ÙˆÙŠ',0),(345090,9586,'fr','Semi-annuellement',0),(345091,9586,'jp','åŠå¹´é–“',0),(345092,9586,'pt','Semi-anual',0),(345093,9586,'ru','ÐŸÐ¾Ð»Ð³Ð¾Ð´Ð° Ð² Ð³Ð¾Ð´',0),(345094,9586,'es','Semi-Anual',0),(345095,9586,'de','Halb-jÃ¤hrlich',0),(345096,9586,'en','Semi-Yearly',0),(345097,9587,'is','',0),(345098,9587,'dr','Ù†Ø§Ù… ÙØ±Ø¹ÙŠ',0),(345099,9587,'pr','Ù†Ø§Ù… ÙØ±Ø¹ÙŠ',0),(345100,9587,'tr','SoyadÄ±nÄ±z',0),(345101,9587,'pl','SubName',0),(345102,9587,'bg','Subname',0),(345103,9587,'ur','Ø³Ø¨Ù†Ù…ÛŒ',0),(345104,9587,'sr','Ð¡ÑƒÐ±Ð½Ð°Ð¼Ðµ',0),(345105,9587,'vi','Subname',0),(345106,9587,'af','Subnaam',0),(345107,9587,'ro','Subname',0),(345108,9587,'et','Subname',0),(345109,9587,'si','Subname',0),(345110,9587,'ba','Subname',0),(345111,9587,'nl','Subname',0),(345112,9587,'fi','Subname',0),(345113,9587,'no','Subname',0),(345114,9587,'da','Subname',0),(345115,9587,'ko','Subname',0),(345116,9587,'he','Subname',0),(345117,9587,'el','Subname',0),(345118,9587,'zh','å­åç§°\r\n',0),(345119,9587,'sv','Subname',0),(345120,9587,'it','Nome secondario',0),(345121,9587,'tl','',0),(345122,9587,'th','&#3594;&#3639;&#3656;&#3629;&#3618;&#3656;&#3629;&#3618;',0),(345123,9587,'hi','Subname',0),(345124,9587,'ms','Subname',0),(345125,9587,'ar','Ø³ÙˆØ¨Ù†Ø§Ù…ÙŠ',0),(345126,9587,'fr','Subname',0),(345127,9587,'jp','æã‚‰ã',0),(345128,9587,'pt','Subname',0),(345129,9587,'ru','SubName',0),(345130,9587,'es','Subnombre',0),(345131,9587,'de','Subname',0),(345132,9587,'en','Subname',0),(345133,9588,'is','',0),(345134,9588,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙˆØ§Ø­Ø¯ ',0),(345135,9588,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙˆØ§Ø­Ø¯ ',0),(345136,9588,'tr','Birimi ekleme',0),(345137,9588,'pl','Dodaj urzÄ…dzenie',0),(345138,9588,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(345139,9588,'ur','ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(345140,9588,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(345141,9588,'vi','ThÃªm Ä‘Æ¡n vá»‹',0),(345142,9588,'af','Eenheid Byvoeg',0),(345143,9588,'ro','Adauga unitate',0),(345144,9588,'et','Ãœhiku lisamine',0),(345145,9588,'si','Dodati enote',0),(345146,9588,'ba','Tambahkan unit',0),(345147,9588,'nl','Eenheid toevoegen',0),(345148,9588,'fi','YksikkÃ¶ lisÃ¤Ã¤',0),(345149,9588,'no','Enheten legger',0),(345150,9588,'da','Enhed tilfÃ¸je',0),(345151,9588,'ko','ë‹¨ìœ„ ì¶”ê°€',0),(345152,9588,'he','×”×•×¡×¤×ª ×™×—×™×“×”',0),(345153,9588,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(345154,9588,'zh','å•ä½æ–°å¢ž\r\n',0),(345155,9588,'sv','LÃ¤gg till enhet',0),(345156,9588,'it','Aggiungere unitÃ ',0),(345157,9588,'tl','',0),(345158,9588,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(345159,9588,'hi','à¤‡à¤•à¤¾à¤ˆ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(345160,9588,'ms','Tambah unit',0),(345161,9588,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ­Ø¯Ø©',0),(345162,9588,'fr','Ajouter des unitÃ©s',0),(345163,9588,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(345164,9588,'pt','Unidade adicionar',0),(345165,9588,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð±Ð»Ð¾Ðº',0),(345166,9588,'es','Agregar Unidad',0),(345167,9588,'de','GerÃ¤t hinzufÃ¼gen',0),(345168,9588,'en','Unit Add',0),(345169,9589,'is','',0),(345170,9589,'dr','Ø­Ø°Ù ÙˆØ§Ø­Ø¯ ',0),(345171,9589,'pr','Ø­Ø°Ù ÙˆØ§Ø­Ø¯ ',0),(345172,9589,'tr','Birim silme',0),(345173,9589,'pl','UsuÅ„ urzÄ…dzenie',0),(345174,9589,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(345175,9589,'ur','ÛŒÙˆÙ†Ù¹ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(345176,9589,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(345177,9589,'vi','XÃ³a Ä‘Æ¡n vá»‹',0),(345178,9589,'af','Eenheid Ongedaan maak',0),(345179,9589,'ro','Unitate ÅŸterge',0),(345180,9589,'et','Ãœhiku kustutamine',0),(345181,9589,'si','Enota Delete',0),(345182,9589,'ba','Hapus unit',0),(345183,9589,'nl','Eenheid verwijderen',0),(345184,9589,'fi','Laitteen poistaminen',0),(345185,9589,'no','Enheten Slett',0),(345186,9589,'da','Enhed slet',0),(345187,9589,'ko','ë‹¨ìœ„ ì‚­ì œ',0),(345188,9589,'he','×ž×—×™×§×ª ×™×—×™×“×”',0),(345189,9589,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(345190,9589,'zh','å•ä½åˆ é™¤\r\n',0),(345191,9589,'sv','Ta bort enheten',0),(345192,9589,'it','Elimina unitÃ ',0),(345193,9589,'tl','',0),(345194,9589,'th','&#3621;&#3610;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(345195,9589,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¹à¤Ÿà¤¾à¤à¤',0),(345196,9589,'ms','Hapus unit',0),(345197,9589,'ar','Ø­Ø°Ù ÙˆØ­Ø¯Ø©',0),(345198,9589,'fr','Supprimer des unitÃ©s',0),(345199,9589,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã®å‰Šé™¤',0),(345200,9589,'pt','Excluir da unidade',0),(345201,9589,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð±Ð»Ð¾Ðº',0),(345202,9589,'es','Eliminar Unidad',0),(345203,9589,'de','GerÃ¤t lÃ¶schen',0),(345204,9589,'en','Unit Delete',0),(345205,9590,'is','',0),(345206,9590,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙˆØ§Ø­Ø¯ ',0),(345207,9590,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙˆØ§Ø­Ø¯ ',0),(345208,9590,'tr','Birim gÃ¼ncelleÅŸtirme',0),(345209,9590,'pl','Aktualizacja urzÄ…dzenia',0),(345210,9590,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(345211,9590,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(345212,9590,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(345213,9590,'vi','Cáº­p nháº­t Ä‘Æ¡n vá»‹',0),(345214,9590,'af','Eenheid Opdateer',0),(345215,9590,'ro','Update unitate',0),(345216,9590,'et','Ãœksuse vÃ¤rskendamine',0),(345217,9590,'si','Enota posodobitev',0),(345218,9590,'ba','Unit Update',0),(345219,9590,'nl','Eenheid Update',0),(345220,9590,'fi','YksikÃ¶n pÃ¤ivitys',0),(345221,9590,'no','Enheten oppdatering',0),(345222,9590,'da','Enheden opdatering',0),(345223,9590,'ko','ìž¥ì¹˜ ì—…ë°ì´íŠ¸',0),(345224,9590,'he','×¢×“×›×•×Ÿ ×™×—×™×“×”',0),(345225,9590,'el','ÎœÎ¿Î½Î¬Î´Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚',0),(345226,9590,'zh','å•ä½æ›´æ–°\r\n',0),(345227,9590,'sv','Enhet uppdatering',0),(345228,9590,'it','Aggiornamento di unitÃ ',0),(345229,9590,'tl','',0),(345230,9590,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(345231,9590,'hi','à¤‡à¤•à¤¾à¤ˆ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(345232,9590,'ms','Unit Kemaskini',0),(345233,9590,'ar','ØªØ­Ø¯ÙŠØ« ÙˆØ­Ø¯Ø©',0),(345234,9590,'fr','Mise Ã  jour des unitÃ©s',0),(345235,9590,'jp','å˜ä½ã®æ›´æ–°',0),(345236,9590,'pt','AtualizaÃ§Ã£o de unidade',0),(345237,9590,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð±Ð»Ð¾ÐºÐ°',0),(345238,9590,'es','Actualizar Unidad',0),(345239,9590,'de','Einheit-Update',0),(345240,9590,'en','Unit Update',0),(345241,9591,'is','',0),(345242,9591,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙˆØ§Ø­Ø¯ ',0),(345243,9591,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† ÙˆØ§Ø­Ø¯ ',0),(345244,9591,'tr','Hata birim ekleme',0),(345245,9591,'pl','BÅ‚Ä…d dodawania urzÄ…dzenia',0),(345246,9591,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(345247,9591,'ur','Ù†Ù‚Øµ ÛŒÙˆÙ†Ù¹ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(345248,9591,'sr','Ð“Ñ€ÐµÑˆÐºÐµ Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(345249,9591,'vi','Lá»—i thÃªm Ä‘Æ¡n vá»‹',0),(345250,9591,'af','Fout toevoeging van eenheid',0),(345251,9591,'ro','Eroare adÄƒugÃ¢nd unitate',0),(345252,9591,'et','Viga lisades Ã¼ksus',0),(345253,9591,'si','Napaka pri dodajanju enota',0),(345254,9591,'ba','Kesalahan menambahkan Unit',0),(345255,9591,'nl','Fout toe te voegen eenheid',0),(345256,9591,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ yksikkÃ¶',0),(345257,9591,'no','Feil Ã¥ legge til enheten',0),(345258,9591,'da','Fejl tilfÃ¸je enhed',0),(345259,9591,'ko','ì˜¤ë¥˜ ì¶”ê°€ ë‹¨ìœ„',0),(345260,9591,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×™×—×™×“×”',0),(345261,9591,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ Î¼Î¿Î½Î¬Î´Î±',0),(345262,9591,'zh','é”™è¯¯æ·»åŠ å•ä½\r\n',0),(345263,9591,'sv','Fel att lÃ¤gga till enheten',0),(345264,9591,'it','Errore aggiunta di unitÃ ',0),(345265,9591,'tl','',0),(345266,9591,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(345267,9591,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤‡à¤•à¤¾à¤ˆ',0),(345268,9591,'ms','Ralat menambah Unit',0),(345269,9591,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© ÙˆØ­Ø¯Ø©',0),(345270,9591,'fr','Erreur ajout dâ€™unitÃ©',0),(345271,9591,'jp','è¿½åŠ ãƒ¦ãƒ‹ãƒƒãƒˆã®ã‚¨ãƒ©ãƒ¼',0),(345272,9591,'pt','Erro adicionando unidade',0),(345273,9591,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(345274,9591,'es','Error Agregando Unidad',0),(345275,9591,'de','Fehler hinzufÃ¼gen Unit',0),(345276,9591,'en','Error Adding Unit',0),(345277,9592,'is','',0),(345278,9592,'dr','ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(345279,9592,'pr','ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(345280,9592,'tr','Birim baÅŸarÄ±yla eklendi',0),(345281,9592,'pl','UrzÄ…dzenie pomyÅ›lnie dodany',0),(345282,9592,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(345283,9592,'ur','ÛŒÙˆÙ†Ù¹ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(345284,9592,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(345285,9592,'vi','ThÃªm Ä‘Æ¡n vá»‹ thÃ nh cÃ´ng',0),(345286,9592,'af','Eenheid Suksesvol Bygevoeg',0),(345287,9592,'ro','Unitate adÄƒugatÄƒ cu succes',0),(345288,9592,'et','Ãœksuse lisamine Ãµnnestus',0),(345289,9592,'si','Enote, ki so dodani',0),(345290,9592,'ba','Unit ditambahkan berhasil',0),(345291,9592,'nl','Eenheid toegevoegd',0),(345292,9592,'fi','YksikÃ¶n lisÃ¤Ã¤minen onnistui',0),(345293,9592,'no','Enheten ble lagt til',0),(345294,9592,'da','Enhed tilfÃ¸jet',0),(345295,9592,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ë‹¨ìœ„',0),(345296,9592,'he','×™×—×™×“×” × ×•×¡×¤×” ×‘×”×¦×œ×—×”',0),(345297,9592,'el','ÎœÎ¿Î½Î¬Î´Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(345298,9592,'zh','æˆåŠŸæ·»åŠ å•ä½\r\n',0),(345299,9592,'sv','Enhet som lagts',0),(345300,9592,'it','UnitÃ  aggiunto con successo',0),(345301,9592,'tl','',0),(345302,9592,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(345303,9592,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(345304,9592,'ms','Berjaya menambah unit',0),(345305,9592,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„ÙˆØ­Ø¯Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(345306,9592,'fr','UnitÃ© ajoutÃ©e avec succÃ¨s',0),(345307,9592,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã¯æ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(345308,9592,'pt','Unidade adicionada com sucesso',0),(345309,9592,'ru','Ð‘Ð»Ð¾Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(345310,9592,'es','Unidad Agregada Exitosamente',0),(345311,9592,'de','GerÃ¤t wurde erfolgreich hinzugefÃ¼gt',0),(345312,9592,'en','Unit Added Successfully',0),(345313,9593,'is','',0),(345314,9593,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù ÙˆØ§Ø­Ø¯ ',0),(345315,9593,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù ÙˆØ§Ø­Ø¯ ',0),(345316,9593,'tr','Hata silme birim',0),(345317,9593,'pl','BÅ‚Ä…d usuwania urzÄ…dzenia',0),(345318,9593,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(345319,9593,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ ÛŒÙˆÙ†Ù¹',0),(345320,9593,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(345321,9593,'vi','Lá»—i xÃ³a Ä‘Æ¡n vá»‹',0),(345322,9593,'af','Fout met skraping van hierdie Eenheid',0),(345323,9593,'ro','Eroare ÅŸtergerea unitate',0),(345324,9593,'et','TÃµrge kustutamisel Ã¼ksus',0),(345325,9593,'si','Napaka brisanja enota',0),(345326,9593,'ba','Error menghapus Unit',0),(345327,9593,'nl','Fout verwijderen eenheid',0),(345328,9593,'fi','Virhe poistettaessa yksikkÃ¶',0),(345329,9593,'no','Feil slette enhet',0),(345330,9593,'da','Fejl slette enhed',0),(345331,9593,'ko','ì˜¤ë¥˜ ì‚­ì œ ë‹¨ìœ„',0),(345332,9593,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×™×—×™×“×”',0),(345333,9593,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î¼Î¿Î½Î¬Î´Î±',0),(345334,9593,'zh','é”™è¯¯åˆ é™¤å•ä½\r\n',0),(345335,9593,'sv','Misstag utplÃ¥nande enhet',0),(345336,9593,'it','Errore eliminazione unitÃ ',0),(345337,9593,'tl','',0),(345338,9593,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3621;&#3610;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(345339,9593,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤‡à¤•à¤¾à¤ˆ',0),(345340,9593,'ms','Ralat Menghapuskan Unit',0),(345341,9593,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„ÙˆØ­Ø¯Ø©',0),(345342,9593,'fr','Erreur suppression de lâ€™unitÃ©',0),(345343,9593,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã®å‰Šé™¤ä¸­ã®ã‚¨ãƒ©ãƒ¼',0),(345344,9593,'pt','Erro excluindo unidade',0),(345345,9593,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(345346,9593,'es','Error Eliminando Unidad',0),(345347,9593,'de','Fehler lÃ¶schen Einheit',0),(345348,9593,'en','Error Deleting Unit',0),(345349,9594,'is','',0),(345350,9594,'dr','ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(345351,9594,'pr','ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(345352,9594,'tr','Birim baÅŸarÄ±yla silindi',0),(345353,9594,'pl','UrzÄ…dzenie pomyÅ›lnie',0),(345354,9594,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(345355,9594,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ ÛŒÙˆÙ†Ù¹',0),(345356,9594,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(345357,9594,'vi','XÃ³a Ä‘Æ¡n vá»‹ thÃ nh cÃ´ng',0),(345358,9594,'af','Eenheid Suksesvol Geskrap',0),(345359,9594,'ro','Unitate eliminÄƒ cu succes',0),(345360,9594,'et','Ãœksuse kustutamine Ãµnnestus',0),(345361,9594,'si','Enota uspeÅ¡no izbrisana',0),(345362,9594,'ba','Unit dihapus berhasil',0),(345363,9594,'nl','Eenheid met succes verwijderd',0),(345364,9594,'fi','Laite poistettu',0),(345365,9594,'no','Enheten ble slettet',0),(345366,9594,'da','Enheden slettet',0),(345367,9594,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ë‹¨ìœ„',0),(345368,9594,'he','×™×—×™×“×” × ×ž×—×§×” ×‘×”×¦×œ×—×”',0),(345369,9594,'el','ÎœÎ¿Î½Î¬Î´Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(345370,9594,'zh','å•ä½æˆåŠŸåˆ é™¤\r\n',0),(345371,9594,'sv','Enheten raderades',0),(345372,9594,'it','UnitÃ  eliminato con successo',0),(345373,9594,'tl','',0),(345374,9594,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3606;&#3641;&#3585;&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(345375,9594,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾',0),(345376,9594,'ms','Unit dihapuskan dengan jayanya',0),(345377,9594,'ar','Ø­Ø°ÙØª Ø§Ù„ÙˆØ­Ø¯Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(345378,9594,'fr','UnitÃ© supprimÃ©e avec succÃ¨s',0),(345379,9594,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã¯æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(345380,9594,'pt','Unidade apagada com sucesso',0),(345381,9594,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾',0),(345382,9594,'es','Unidad Eliminada Exitosamente',0),(345383,9594,'de','GerÃ¤t wurde erfolgreich gelÃ¶scht',0),(345384,9594,'en','Unit Deleted Successfully',0),(345385,9595,'is','',0),(345386,9595,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙˆØ§Ø­Ø¯ ',0),(345387,9595,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙˆØ§Ø­Ø¯ ',0),(345388,9595,'tr','Hata gÃ¼ncelleÅŸtirme birimi',0),(345389,9595,'pl','BÅ‚Ä…d aktualizacji jednostki',0),(345390,9595,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(345391,9595,'ur','Ù†Ù‚Øµ ÛŒÙˆÙ†Ù¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(345392,9595,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(345393,9595,'vi','Lá»—i cáº­p nháº­t Ä‘Æ¡n vá»‹',0),(345394,9595,'af','Fout met Opdatering van Eenheid',0),(345395,9595,'ro','Eroare de actualizare unitate',0),(345396,9595,'et','Viga ajakohastamine Ã¼ksus',0),(345397,9595,'si','Napaka posodabljanje enota',0),(345398,9595,'ba','Kesalahan update Unit',0),(345399,9595,'nl','Fout bijwerken eenheid',0),(345400,9595,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ yksikkÃ¶',0),(345401,9595,'no','Feil oppdatering enhet',0),(345402,9595,'da','Fejl opdatering enhed',0),(345403,9595,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ë‹¨ìœ„',0),(345404,9595,'he','×©×’×™××” ×‘×¢×“×›×•×Ÿ ×™×—×™×“×”',0),(345405,9595,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î¿Î½Î¬Î´Î±',0),(345406,9595,'zh','é”™è¯¯æ›´æ–°å•å…ƒ\r\n',0),(345407,9595,'sv','Fel uppdatera enheten',0),(345408,9595,'it','Errore aggiornamento unitÃ ',0),(345409,9595,'tl','',0),(345410,9595,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3592;&#3634;&#3585;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(345411,9595,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤‡à¤•à¤¾à¤ˆ',0),(345412,9595,'ms','Ralat pengemaskinian Unit',0),(345413,9595,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« ÙˆØ­Ø¯Ø©',0),(345414,9595,'fr','Erreur mise Ã  jour de lâ€™unitÃ©',0),(345415,9595,'jp','ã‚¨ãƒ©ãƒ¼æ›´æ–°å˜ä½',0),(345416,9595,'pt','Unidade de atualizaÃ§Ã£o de erro',0),(345417,9595,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð±Ð»Ð¾ÐºÐ°',0),(345418,9595,'es','Error Actualizando la Unidad',0),(345419,9595,'de','Fehler Update Einheit',0),(345420,9595,'en','Error Updating Unit',0),(345421,9596,'is','',0),(345422,9596,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(345423,9596,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙˆØ§Ø­Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(345424,9596,'tr','Birim baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(345425,9596,'pl','UrzÄ…dzenie pomyÅ›lnie zaktualizowana',0),(345426,9596,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(345427,9596,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(345428,9596,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(345429,9596,'vi','Cáº­p nháº­t Ä‘Æ¡n vá»‹ thÃ nh cÃ´ng',0),(345430,9596,'af','Eenheid Suksesvol Opdateer',0),(345431,9596,'ro','Unitate actualizat cu succes',0),(345432,9596,'et','Ãœksuse vÃ¤rskendamine Ãµnnestus',0),(345433,9596,'si','Enota, ki je uspeÅ¡no posodobljena',0),(345434,9596,'ba','Unit yang berhasil',0),(345435,9596,'nl','Eenheid bijgewerkt',0),(345436,9596,'fi','YksikkÃ¶ pÃ¤ivitetty',0),(345437,9596,'no','Enheten oppdatert',0),(345438,9596,'da','Enhed opdateret',0),(345439,9596,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ë‹¨ìœ„',0),(345440,9596,'he','×™×—×™×“×” ×¢×•×“×›× ×” ×‘×”×¦×œ×—×”',0),(345441,9596,'el','ÎœÎ¿Î½Î¬Î´Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(345442,9596,'zh','å•ä½å·²æˆåŠŸæ›´æ–°\r\n',0),(345443,9596,'sv','Enhet som uppdaterats',0),(345444,9596,'it','UnitÃ  aggiornata correttamente',0),(345445,9596,'tl','',0),(345446,9596,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(345447,9596,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(345448,9596,'ms','Unit berjaya dikemas kini',0),(345449,9596,'ar','Ø­Ø¯Ù‘Ø«Øª Ø§Ù„ÙˆØ­Ø¯Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(345450,9596,'fr','UnitÃ© de mise Ã  jour rÃ©ussie',0),(345451,9596,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã¯æ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(345452,9596,'pt','Unidade atualizada com sucesso',0),(345453,9596,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(345454,9596,'es','Unidad Actualizada Exitosamente',0),(345455,9596,'de','GerÃ¤t wurde erfolgreich aktualisiert',0),(345456,9596,'en','Unit Updated Successfully',0),(345457,9597,'is','',0),(345458,9597,'dr','Ø¨Ø§ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(345459,9597,'pr','Ø¨Ø§ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(345460,9597,'tr','Ä°ÅŸ tÃ¼rÃ¼ tarafÄ±ndan',0),(345461,9597,'pl','Przez typ pracy',0),(345462,9597,'bg','ÐŸÐ¾ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(345463,9597,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(345464,9597,'sr','ÐŸÐ¾ Ð²Ñ€ÑÑ‚Ð¸ Ð¿Ð¾ÑÐ»Ð°',0),(345465,9597,'vi','Theo kiá»ƒu cÃ´ng viá»‡c',0),(345466,9597,'af','Per Werk Tipe',0),(345467,9597,'ro','De lucru tip',0),(345468,9597,'et','TÃ¶Ã¶d tÃ¼Ã¼bi jÃ¤rgi',0),(345469,9597,'si','Vrste dela',0),(345470,9597,'ba','Oleh jenis pekerjaan',0),(345471,9597,'nl','Door werksoort',0),(345472,9597,'fi','TyÃ¶tyypin',0),(345473,9597,'no','Arbeidstype',0),(345474,9597,'da','Af arbejdstypen',0),(345475,9597,'ko','ìž‘ì—… í˜•ì‹',0),(345476,9597,'he','×œ×¤×™ ×¡×•×’ ×¢×‘×•×“×”',0),(345477,9597,'el','Î¤ÏÏ€Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(345478,9597,'zh','æŒ‰å·¥ç¨‹ç±»åˆ«\r\n',0),(345479,9597,'sv','Av arbetstyp',0),(345480,9597,'it','Dal tipo di lavoro',0),(345481,9597,'tl','',0),(345482,9597,'th','&#3650;&#3604;&#3618;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3591;&#3634;&#3609;',0),(345483,9597,'hi','à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(345484,9597,'ms','Mengikut jenis kerja',0),(345485,9597,'ar','Ø­Ø³Ø¨ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(345486,9597,'fr','Par Type de travaux',0),(345487,9597,'jp','ä½œæ¥­ã®ç¨®é¡žã«ã‚ˆã£ã¦',0),(345488,9597,'pt','Pelo tipo de trabalho',0),(345489,9597,'ru','ÐŸÐ¾ Ð¢Ð¸Ð¿Ñƒ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(345490,9597,'es','Por Tipo de Trabajo',0),(345491,9597,'de','Nach Arbeitstyp',0),(345492,9597,'en','By Work Type',0),(345493,9598,'is','',0),(345494,9598,'dr','ÙÙŠÙ„ØªØ± Ø¨Ø§ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(345495,9598,'pr','ÙÙŠÙ„ØªØ± Ø¨Ø§ Ù†ÙˆØ¹ ÙƒØ§Ø±',0),(345496,9598,'tr','Ä°ÅŸ tÃ¼rÃ¼ne gÃ¶re filtre',0),(345497,9598,'pl','Filtruj wedÅ‚ug typu pracy',0),(345498,9598,'bg','Ð¤Ð¸Ð»Ñ‚ÑŠÑ€ Ð¿Ð¾ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(345499,9598,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ÙÙ„Ù¹Ø± Ú©Ø±ÛŒÚº',0),(345500,9598,'sr','Ð¤Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾ Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(345501,9598,'vi','lá»c theo loáº¡i cÃ´ng viá»‡c',0),(345502,9598,'af','Filter volgens werk tipe',0),(345503,9598,'ro','Filtrare dupÄƒ tipul de munca',0),(345504,9598,'et','Filtreeri tÃ¶Ã¶ tÃ¼Ã¼p',0),(345505,9598,'si','Filtriraj po vrsti dela',0),(345506,9598,'ba','Filter menurut jenis pekerjaan',0),(345507,9598,'nl','Filteren op werksoort',0),(345508,9598,'fi','Suodata tyÃ¶n tyyppi',0),(345509,9598,'no','Filtrere etter arbeidstype',0),(345510,9598,'da','Filtrere efter arbejdstype',0),(345511,9598,'ko','ìž‘ì—… í˜•ì‹ì— ì˜í•´ í•„í„°ë§',0),(345512,9598,'he','×œ×¡× ×Ÿ ×œ×¤×™ ×¡×•×’ ×¢×‘×•×“×”',0),(345513,9598,'el','Î¦Î¹Î»Ï„ÏÎ¬ÏÎ¹ÏƒÎ¼Î± ÎºÎ±Ï„Î¬ Ï„ÏÏ€Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(345514,9598,'zh','æŒ‰å·¥ç¨‹ç±»åˆ«è¿‡æ»¤å™¨\r\n',0),(345515,9598,'sv','Filtrera efter arbetstyp',0),(345516,9598,'it','Filtra per tipo di lavoro',0),(345517,9598,'tl','',0),(345518,9598,'th','&#3605;&#3633;&#3623;&#3585;&#3619;&#3629;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;',0),(345519,9598,'hi','à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤° à¤•à¤°à¥‡à¤‚',0),(345520,9598,'ms','Tapis mengikut jenis kerja',0),(345521,9598,'ar','Ø§Ù„ØªØµÙÙŠØ© Ø­Ø³Ø¨ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(345522,9598,'fr','Filtrer par Type de travail',0),(345523,9598,'jp','ä½œæ¥­ã®ç¨®é¡žåˆ¥ã®ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼ã—ã¾ã™ã€‚',0),(345524,9598,'pt','Filtrar por tipo de trabalho',0),(345525,9598,'ru','Ð¤Ð¸Ð»ÑŒÑ‚Ñ€ ÐŸÐ¾ Ð¢Ð¸Ð¿Ñƒ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(345526,9598,'es','Filtrar Por Tipo de Trabajo',0),(345527,9598,'de','Filtern nach Arbeitstyp',0),(345528,9598,'en','Filter By Work Type',0),(345529,9599,'is','',0),(345530,9599,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø³Ø¨Øª Ø¨Ù‡ Ú†Ù‡ ØªØ¹Ø¯Ø§Ø¯ Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ Ù…Ø³Ø§ÙˆÙŠ',0),(345531,9599,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø³Ø¨Øª Ø¨Ù‡ Ú†Ù‡ ØªØ¹Ø¯Ø§Ø¯ Ù‚Ø³Ù…ØªÙ‡Ø§ÙŠ Ù…Ø³Ø§ÙˆÙŠ',0),(345532,9599,'tr','Bill kaÃ§ eÅŸit parÃ§aya',0),(345533,9599,'pl','Bill na ile rÃ³wne czÄ™Å›ci',0),(345534,9599,'bg','Ð‘Ð¸Ð» Ð½Ð° ÐºÐ¾Ð»ÐºÐ¾ Ñ€Ð°Ð²Ð½Ð¸ Ñ‡Ð°ÑÑ‚Ð¸',0),(345535,9599,'ur','Ø¨Ù„ Ú©Ùˆ Ú©ØªÙ†Û’ Ù…Ø³Ø§ÙˆÛŒ Ø­ØµÙˆÚº Ù…ÛŒÚº',0),(345536,9599,'sr','Ð‘Ð¸Ð» Ñƒ ÐºÐ¾Ð»Ð¸ÐºÐ¾ Ñ˜ÐµÐ´Ð½Ð°ÐºÐ¸Ñ… Ð´ÐµÐ»Ð¾Ð²Ð°',0),(345537,9599,'vi','HÃ³a Ä‘Æ¡n tÆ°Æ¡ng á»©ng vá»›i bao nhiÃªu pháº§n',0),(345538,9599,'af','Wetsontwerp in hoeveel gelyke dele',0),(345539,9599,'ro','Proiect de lege in cate parti egale',0),(345540,9599,'et','Bill mitu vÃµrdseks osaks',0),(345541,9599,'si','Zakona, na koliko enakih delov',0),(345542,9599,'ba','Bill ke berapa banyak bagian yang sama',0),(345543,9599,'nl','Bill in hoeveel gelijke delen',0),(345544,9599,'fi','Bill kuinka monta yhtÃ¤ suureen osaan',0),(345545,9599,'no','Bill i hvor mange like deler',0),(345546,9599,'da','Bill i hvor mange lige store dele',0),(345547,9599,'ko','ëª‡ ë“±ë¶„ìœ¼ë¡œ ë¹Œ',0),(345548,9599,'he','×‘×™×œ ×œ×—×œ×§×™× ×©×•×•×™× ×›×ž×”',0),(345549,9599,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ ÏƒÎµ Ï€ÏŒÏƒÎ± Î¯ÏƒÎ± Î¼Î­ÏÎ·',0),(345550,9599,'zh','å¸å•ç­‰åˆ†ä¸ºå¤šå°‘éƒ¨åˆ†\r\n',0),(345551,9599,'sv','Bill i hur mÃ¥nga lika stora delar',0),(345552,9599,'it','Bill in quante parti uguali',0),(345553,9599,'tl','',0),(345554,9599,'th','Bill Into How Many Equal Parts',0),(345555,9599,'hi','à¤•à¤¿à¤¤à¤¨à¥‡ à¤¬à¤°à¤¾à¤¬à¤° à¤­à¤¾à¤—à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¬à¤¿à¤²',0),(345556,9599,'ms','Rang undang-undang kepada berapa bahagian yang sama',0),(345557,9599,'ar','Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ø¥Ù„Ù‰ ÙƒÙŠÙÙŠØ© Ø§Ù„Ø¹Ø¯ÙŠØ¯ Ù…Ù† Ø£Ø¬Ø²Ø§Ø¡ Ù…ØªØ³Ø§ÙˆÙŠØ©',0),(345558,9599,'fr','Projet de loi en combien de parties Ã©gales',0),(345559,9599,'jp','ã©ã®ã‚ˆã†ã«å¤šãã®ç­‰ã—ã„éƒ¨åˆ†ã«ãƒ“ãƒ«',0),(345560,9599,'pt','Bill em quantas partes iguais',0),(345561,9599,'ru','Ð‘Ð¸Ð»Ð» Ð½Ð° ÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ñ€Ð°Ð²Ð½Ñ‹Ñ… Ñ‡Ð°ÑÑ‚ÐµÐ¹',0),(345562,9599,'es','Facturar Entre Varias Partes Iguales',0),(345563,9599,'de','Bill in wie viele gleiche Teile',0),(345564,9599,'en','Bill Into How Many Equal&nbsp;Parts',0),(345565,9600,'is','',0),(345566,9600,'dr','-  Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ú¯Ø±ÙˆÙ‡ ',0),(345567,9600,'pr','Ù‡Ù…Ù‡ -  Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÙŠ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ú¯Ø±ÙˆÙ‡ ',0),(345568,9600,'tr','TÃ¼m yayÄ±nlar-Kategori gÃ¶re sÄ±rala',0),(345569,9600,'pl','Wszystkie - Sortuj wedÅ‚ug kategorii',0),(345570,9600,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ - ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(345571,9600,'ur','ØªÙ…Ø§Ù… - Ú†Ú¾Ø§Ù†Ù¹ÛŒÚº Ø¨Ù…Ø·Ø§Ø¨Ù‚ Ù‚Ø³Ù…',0),(345572,9600,'sr','Ð¡Ð²Ðµ - Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸',0),(345573,9600,'vi','táº¥t cáº£- sáº¯p xáº¿p theo phÃ¢n loáº¡i',0),(345574,9600,'af','Alle Sorteer Volgens Kategorie',0),(345575,9600,'ro','Toate - sortare dupa categorie',0),(345576,9600,'et','KÃµik - Sorteeri kategooria jÃ¤rgi',0),(345577,9600,'si','Vse - razvrÅ¡Äanje po kategorijah',0),(345578,9600,'ba','Semua - Urut berdasarkan Kategori',0),(345579,9600,'nl','Alle - sorteren op categorie',0),(345580,9600,'fi','Kaikki - Lajittele Luokka',0),(345581,9600,'no','Alle - Sorter etter kategori',0),(345582,9600,'da','Alle - sorter efter kategori',0),(345583,9600,'ko','ëª¨ë‘-ë²”ì£¼ë³„ìœ¼ë¡œ ì •ë ¬',0),(345584,9600,'he','×›×œ - ×ž×™×™×Ÿ ×œ×¤×™ ×§×˜×’×•×¨×™×”',0),(345585,9600,'el','ÎŒÎ»Î± - Ï„Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ· Î±Î½Î¬ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(345586,9600,'zh','å…¨éƒ¨- æŒ‰ç±»åˆ«åˆ†ç±»\r\n',0),(345587,9600,'sv','Alla - sortera efter kategori',0),(345588,9600,'it','Tutti - Ordina per categoria',0),(345589,9600,'tl','',0),(345590,9600,'th','&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604; - &#3592;&#3633;&#3604;&#3648;&#3619;&#3637;&#3618;&#3591;&#3605;&#3634;&#3617;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(345591,9600,'hi','à¤¸à¤­à¥€ - à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(345592,9600,'ms','Semua - Susun mengikut Kategori',0),(345593,9600,'ar','Ø§Ù„ÙƒÙ„-ÙØ±Ø² Ø­Ø³Ø¨ Ø§Ù„ÙØ¦Ø©',0),(345594,9600,'fr','Tous - Trier par catÃ©gorie',0),(345595,9600,'jp','ã™ã¹ã¦ã®ã‚«ãƒ†ã‚´ãƒªã§ä¸¦ã¹æ›¿ãˆ',0),(345596,9600,'pt','Todos - classificaÃ§Ã£o por categoria',0),(345597,9600,'ru','Ð’ÑÐµ - Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐŸÐ¾ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(345598,9600,'es','Todo - Clasificar por CategorÃ­a',0),(345599,9600,'de','Alle - nach Kategorie sortieren',0),(345600,9600,'en','All - Sort By Category',0),(345601,9601,'is','',0),(345602,9601,'dr','Ø­Ù‚ÙˆÙ‚ Ù¾ÙŠØ´Ø±ÙØªÙ‡ ÙƒØ§Ø±Ø¨Ø±',0),(345603,9601,'pr','Ø­Ù‚ÙˆÙ‚ Ù¾ÙŠØ´Ø±ÙØªÙ‡ ÙƒØ§Ø±Ø¨Ø±',0),(345604,9601,'tr','GeliÅŸmiÅŸ kullanÄ±cÄ± haklarÄ±',0),(345605,9601,'pl','Zaawansowane prawa uÅ¼ytkownika',0),(345606,9601,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ñ€Ð°Ð²Ð°',0),(345607,9601,'ur','Ø§Ø¹Ù„ÛŒ ØµØ§Ø±Ù Ú©Û’ Ø­Ù‚ÙˆÙ‚',0),(345608,9601,'sr','ÐÐ°Ð¿Ñ€ÐµÐ´Ð½Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð¿Ñ€Ð°Ð²Ð°',0),(345609,9601,'vi','Quyá»n ngÆ°á»i sá»­ dá»¥ng nÃ¢ng cao',0),(345610,9601,'af','Gevorderde Gebruikerregte',0),(345611,9601,'ro','Drepturile de utilizator avansat',0),(345612,9601,'et','EdasijÃµudnud kasutaja Ãµigused',0),(345613,9601,'si','Napredne uporabniÅ¡ke pravice',0),(345614,9601,'ba','Hak-hak pengguna tingkat lanjut',0),(345615,9601,'nl','Geavanceerde gebruikersrechten',0),(345616,9601,'fi','Kokenut kÃ¤yttÃ¤jÃ¤ oikeudet',0),(345617,9601,'no','Avanserte rettigheter',0),(345618,9601,'da','Avanceret brugerrettigheder',0),(345619,9601,'ko','ê³ ê¸‰ ì‚¬ìš©ìž ê¶Œí•œ',0),(345620,9601,'he','×–×›×•×™×•×ª ×ž×©×ª×ž×© ×ž×ª×§×“×',0),(345621,9601,'el','Î¤Ï‰Î½ Î´Î¹ÎºÎ±Î¹Ï‰Î¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÏ„Î· Î³Î¹Î± Ï€ÏÎ¿Ï‡Ï‰ÏÎ·Î¼Î­Î½Î¿Ï…Ï‚',0),(345622,9601,'zh','é«˜çº§ç”¨æˆ·æƒé™\r\n',0),(345623,9601,'sv','Avancerad anvÃ¤ndarrÃ¤ttigheter',0),(345624,9601,'it','Diritti utente avanzati',0),(345625,9601,'tl','',0),(345626,9601,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3626;&#3636;&#3607;&#3608;&#3636;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(345627,9601,'hi','à¤‰à¤¨à¥à¤¨à¤¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(345628,9601,'ms','Hak-hak pengguna lebih maju',0),(345629,9601,'ar','Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ù…ØªÙ‚Ø¯Ù…Ø©',0),(345630,9601,'fr','Droits de lâ€™utilisateur avancÃ©',0),(345631,9601,'jp','é«˜åº¦ãªãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©åˆ©',0),(345632,9601,'pt','Direitos de usuÃ¡rio avanÃ§ado',0),(345633,9601,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ ÐŸÑ€Ð°Ð²Ð° ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(345634,9601,'es','Derechos de Usuarios Avanzados',0),(345635,9601,'de','Erweiterte Benutzerrechte',0),(345636,9601,'en','Advanced User Rights',0),(345637,9602,'is','',0),(345638,9602,'dr','Ø­Ù‚ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø± Ø­Ø°Ù Ø´Ø¯ ',0),(345639,9602,'pr','Ø­Ù‚ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø± Ø­Ø°Ù Ø´Ø¯ ',0),(345640,9602,'tr','DoÄŸru bu kullanÄ±cÄ±dan kaldÄ±rÄ±lÄ±r grubu',0),(345641,9602,'pl','Grupa prawo usuniÄ™te dla tego uÅ¼ytkownika',0),(345642,9602,'bg','Ð“Ñ€ÑƒÐ¿Ð° Ð¾Ñ‚ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸ Ñ‚Ð¾Ñ‡Ð½Ð¾ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(345643,9602,'ur','Ú¯Ø±ÙˆÙ¾ Ø­Ù‚ Ø§Ø³ ØµØ§Ø±Ù Ú©Û’ Ù„ÛŒÛ’ ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(345644,9602,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð¾Ð´Ð¼Ð°Ñ… ÑƒÐºÐ»Ð¾ÑšÐµÐ½Ð¸ Ð·Ð° Ð¾Ð²Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(345645,9602,'vi','quyá»n cá»§a nhÃ³m Ä‘Æ°á»£c chuyá»ƒn cho ngÆ°á»i sá»§ dá»¥ng nÃ y',0),(345646,9602,'af','Groepregte Verwyder Vir Hierdie Gebruiker',0),(345647,9602,'ro','Grupa chiar eliminat pentru acest utilizator',0),(345648,9602,'et','Ã•igus eemaldada selle kasutaja nimel',0),(345649,9602,'si','Skupina pravico odstraniti za tega uporabnika',0),(345650,9602,'ba','Kelompok kanan dihapus untuk pengguna ini',0),(345651,9602,'nl','Groep recht voor deze gebruiker verwijderd',0),(345652,9602,'fi','RyhmÃ¤ juuri poistaa tÃ¤mÃ¤n kÃ¤yttÃ¤jÃ¤n',0),(345653,9602,'no','Gruppen rett fjernet For denne brukeren',0),(345654,9602,'da','Gruppe lige fjernet For denne bruger',0),(345655,9602,'ko','ë°”ë¡œì´ ì‚¬ìš©ìž ì œê±° ê·¸ë£¹',0),(345656,9602,'he','×§×‘×•×¦×” ×ž×ž×© ×”×•×¡×¨ ×¢×‘×•×¨ ×ž×©×ª×ž×© ×–×”',0),(345657,9602,'el','ÎŸÎ¼Î¬Î´Î± Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯ Î±ÎºÏÎ¹Î²ÏŽÏ‚ Î³Î¹Î± Î±Ï…Ï„ÏŒÎ½ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(345658,9602,'zh','ç»„æƒåˆ©å·²ä¸ºæ­¤ç”¨æˆ·å–æ¶ˆ\r\n',0),(345659,9602,'sv','Grupp rÃ¤tt bort fÃ¶r denna anvÃ¤ndare',0),(345660,9602,'it','Gruppo di destra rimosso per questo utente',0),(345661,9602,'tl','',0),(345662,9602,'th','&#3626;&#3636;&#3607;&#3608;&#3636;&#3586;&#3629;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3609;&#3637;&#3657;&#3621;&#3610;&#3629;&#3629;&#3585;&#3649;&#3621;&#3657;&#3623;',0),(345663,9602,'hi','à¤¸à¤®à¥‚à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¤¹à¥€ à¤¨à¤¿à¤•à¤¾à¤² à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(345664,9602,'ms','Kumpulan yang betul-betul dikeluarkan untuk pengguna ini',0),(345665,9602,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¥Ø²Ø§Ù„Ø© Ø­Ù‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù‡Ø°Ø§',0),(345666,9602,'fr','Groupe droit supprimÃ© pour cet utilisateur',0),(345667,9602,'jp','ã‚°ãƒ«ãƒ¼ãƒ—ãŒã“ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©åˆ©ã®å‰Šé™¤',0),(345668,9602,'pt','Grupo bem removido para este usuÃ¡rio',0),(345669,9602,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° ÑÑ€Ð°Ð·Ñƒ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(345670,9602,'es','Derechos del Grupo Eliminado para Este Usuario',0),(345671,9602,'de','Gruppe fÃ¼r diesen Benutzer direkt entfernt',0),(345672,9602,'en','Group Right Removed For This User',0),(345673,9603,'is','',0),(345674,9603,'dr','Ø­Ù‚ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ ÙŠ Ú¯Ø±ÙˆÙ‡ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(345675,9603,'pr','Ø­Ù‚ Ø¬Ø¯ÙŠØ¯ Ø¨Ø±Ø§ ÙŠ Ú¯Ø±ÙˆÙ‡ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(345676,9603,'tr','SaÄŸ yeni grup iÃ§in mevcut deÄŸil',0),(345677,9603,'pl','Nowe prawo nie dostÄ™pne dla tej grupy',0),(345678,9603,'bg','ÐÐ¾Ð²Ð¾ Ð¿Ñ€Ð°Ð²Ð¾ Ð½Ðµ ÑÐ° Ð´Ð¾ÑÑ‚ÑŠÐ¿Ð½Ð¸ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(345679,9603,'ur','Ù†ÛŒØ§ Ø­Ù‚ Ú¯Ø±ÙˆÙ¾ Ú©Û’ Ù„Ø¦Û’ Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº ÛÛ’',0),(345680,9603,'sr','ÐÐ¾Ð²Ð¾ Ð¿Ñ€Ð°Ð²Ð¾ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ Ñƒ Ð³Ñ€ÑƒÐ¿Ñƒ',0),(345681,9603,'vi','Quyá»n má»›i khÃ´ng cÃ³ trong nhÃ³m',0),(345682,9603,'af','Nuwe Regte Nie Beskikbaar Vir Die Groep',0),(345683,9603,'ro','Noua dreapta nu este disponibil la grupul',0),(345684,9603,'et','Uut Ãµigust rÃ¼hma pole saadaval',0),(345685,9603,'si','Nove pravice ni na voljo v skupino',0),(345686,9603,'ba','Baru kanan tidak tersedia untuk kelompok',0),(345687,9603,'nl','Nieuw rechts niet beschikbaar voor de groep',0),(345688,9603,'fi','Uuden ryhmÃ¤n ei kÃ¤ytettÃ¤vissÃ¤',0),(345689,9603,'no','Nye hÃ¸yre ikke tilgjengelig for gruppen',0),(345690,9603,'da','Nye hÃ¸jre ikke er tilgÃ¦ngelige for gruppen',0),(345691,9603,'ko','ë‰´ë¼ì´íŠ¸ ê·¸ë£¹ì— ì‚¬ìš©í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(345692,9603,'he','× ×›×•×Ÿ ×”×—×“×© ××™× ×• ×–×ž×™×Ÿ ×œ×§×‘×•×¦×”',0),(345693,9603,'el','ÎÎ­Î¿ Î´Î¹ÎºÎ±Î¯Ï‰Î¼Î± Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· ÏƒÏ„Î·Î½ Î¿Î¼Î¬Î´Î±',0),(345694,9603,'zh','å¯¹ç»„ä¸å¯ç”¨çš„æ–°æƒåˆ©\r\n',0),(345695,9603,'sv','Nya hÃ¶gern inte tillgÃ¤ngliga fÃ¶r gruppen',0),(345696,9603,'it','Nuovo diritto non disponibili per il gruppo',0),(345697,9603,'tl','',0),(345698,9603,'th','&#3618;&#3629;&#3604;&#3586;&#3634;&#3618;&#3651;&#3627;&#3617;&#3656;',0),(345699,9603,'hi','à¤¨à¤ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤®à¥‚à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(345700,9603,'ms','Hak baru tidak tersedia kepada Kumpulan',0),(345701,9603,'ar','Ø­Ù‚ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© ØºÙŠØ± Ù…ØªÙˆÙØ±Ø© Ù„Ù„ÙØ±ÙŠÙ‚',0),(345702,9603,'fr','Nouveau droit non disponible pour le groupe',0),(345703,9603,'jp','æ–°ã—ã„æ¨©åˆ©ã‚°ãƒ«ãƒ¼ãƒ—ã«ã¯ä½¿ç”¨ã§ãã¾ã›ã‚“',0),(345704,9603,'pt','Novo direito nÃ£o estÃ¡ disponÃ­vel para o grupo',0),(345705,9603,'ru','ÐÐ¾Ð²Ð¾Ðµ Ð¿Ñ€Ð°Ð²Ð¾ Ð½ÐµÐ´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ Ð´Ð»Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(345706,9603,'es','Nuevo Derecho que no es Disponible al Grupo',0),(345707,9603,'de','Neue Rechte fÃ¼r die Gruppe nicht verfÃ¼gbar',0),(345708,9603,'en','New Right Not Available To The Group',0),(345709,9604,'is','',0),(345710,9604,'dr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø±ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(345711,9604,'pr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø±ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(345712,9604,'tr','HiÃ§bir kullanÄ±cÄ± kimliÄŸi kÃ¼mesi',0),(345713,9604,'pl','Nie zestaw identyfikator uÅ¼ytkownika',0),(345714,9604,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð˜Ð” Ð½Ð° Ð½Ð°Ð±Ð¾Ñ€',0),(345715,9604,'ur','Ú©ÙˆØ¦ÛŒ ØµØ§Ø±Ù ID Ø³ÛŒÙ¹',0),(345716,9604,'sr','ÐÐµÐ¼Ð° Ð¡ÐµÑ‚ Ð˜Ð” ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(345717,9604,'vi','khÃ´ng láº­p ID ngÆ°á»i sá»­ dá»¥ng',0),(345718,9604,'af','Geen Gebruiker ID Opgestel',0),(345719,9604,'ro','Nici un Set de ID de utilizator',0),(345720,9604,'et','Kasutaja ID pole mÃ¤Ã¤ratud',0),(345721,9604,'si','Ni nastavljenega ID uporabnika',0),(345722,9604,'ba','Tidak ada User ID Set',0),(345723,9604,'nl','geen gebruikers ID set',0),(345724,9604,'fi','Ei kÃ¤yttÃ¤jÃ¤ ID asetettu',0),(345725,9604,'no','Ingen bruker ID sett',0),(345726,9604,'da','Ingen bruger ID sÃ¦t',0),(345727,9604,'ko','ì‚¬ìš©ìž ID ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(345728,9604,'he','×œ× ×”×•×’×“×¨×• ×ž×–×”×” ×ž×©×ª×ž×©',0),(345729,9604,'el','ÎŸÏÎ¹ÏƒÏ„ÎµÎ¯ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï‡ÏÎ®ÏƒÏ„Î·',0),(345730,9604,'zh','æ²¡æœ‰ç”¨æˆ·èº«ä»½è¯é›†\r\n',0),(345731,9604,'sv','Ingen anvÃ¤ndare ID-instÃ¤llning',0),(345732,9604,'it','Nessun Set di ID utente',0),(345733,9604,'tl','',0),(345734,9604,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3627;&#3633;&#3626;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3605;&#3633;&#3657;&#3591;',0),(345735,9604,'hi','à¤•à¥‹à¤ˆ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ ID à¤¸à¥‡à¤Ÿ',0),(345736,9604,'ms','Set ID pengguna tidak',0),(345737,9604,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(345738,9604,'fr','Aucun jeu dâ€™ID de lâ€™utilisateur',0),(345739,9604,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ ID ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(345740,9604,'pt','Nenhum conjunto de ID de usuÃ¡rio',0),(345741,9604,'ru','ID ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ ÐÐµ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(345742,9604,'es','No se ConfigurÃ³ el ID de Usuario',0),(345743,9604,'de','Keine Benutzer-ID-Set',0),(345744,9604,'en','No User ID Set',0),(345745,9605,'is','',0),(345746,9605,'dr','ØªÙ†Ø¸ÙŠÙ… Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¯Ø³ØªØ±Ø³ÙŠ Ú¯Ø±ÙˆÙ‡',0),(345747,9605,'pr','ØªÙ†Ø¸ÙŠÙ… Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¯Ø³ØªØ±Ø³ÙŠ Ú¯Ø±ÙˆÙ‡',0),(345748,9605,'tr','KÃ¼me varsayÄ±lan grup eriÅŸimi',0),(345749,9605,'pl','Zestaw domyÅ›lne grupy dostÄ™pu',0),(345750,9605,'bg','ÐÐ°Ð±Ð¾Ñ€ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð³Ñ€ÑƒÐ¿Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(345751,9605,'ur','Ø³ÛŒÙ¹ Ø·Û’ Ø´Ø¯Û Ú¯Ø±ÙˆÙ¾ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ',0),(345752,9605,'sr','ÐÑ†Ñ†ÐµÑÑ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ñƒ Ð³Ñ€ÑƒÐ¿Ñƒ',0),(345753,9605,'vi','CÃ i Ä‘áº·t truy cáº­p nhÃ³m máº·c Ä‘á»‹nh',0),(345754,9605,'af','Verstel Verstekte Groep Toegang',0),(345755,9605,'ro','Setul implicit grup acces',0),(345756,9605,'et','Set Default juurdepÃ¤Ã¤su',0),(345757,9605,'si','Niz privzeto skupino dostop',0),(345758,9605,'ba','Set Default kelompok akses',0),(345759,9605,'nl','Set standaard groepstoegang',0),(345760,9605,'fi','Set Default kÃ¤yttÃ¶oikeus',0),(345761,9605,'no','Sett standard tilgang',0),(345762,9605,'da','SÃ¦t standard gruppe adgang',0),(345763,9605,'ko','ì„¤ì • ê¸°ë³¸ ê·¸ë£¹ ì•¡ì„¸ìŠ¤',0),(345764,9605,'he','×’×™×©×” ×¢×¨×›×ª ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×§×‘×•×¦×”',0),(345765,9605,'el','Î£ÎµÏ„ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¿Î¼Î¬Î´Î± Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(345766,9605,'zh','è®¾ç½®é»˜è®¤ç»„è®¿é—®\r\n',0),(345767,9605,'sv','Ange standardgruppen tillgÃ¥ng',0),(345768,9605,'it','Set di gruppo predefinito accesso',0),(345769,9605,'tl','',0),(345770,9605,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3621;&#3640;&#3656;&#3623;&#3585;&#3634;&#3619;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(345771,9605,'hi','à¤¸à¥‡à¤Ÿ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¤®à¥‚à¤¹ à¤¤à¤• à¤ªà¤¹à¥à¤à¤š',0),(345772,9605,'ms','Capaian set lalai Kumpulan',0),(345773,9605,'ar','Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(345774,9605,'fr','Set Default Group accÃ¨s',0),(345775,9605,'jp','ã‚»ãƒƒãƒˆã®æ—¢å®šã®ã‚°ãƒ«ãƒ¼ãƒ—ã®ã‚¢ã‚¯ã‚»ã‚¹æ¨©',0),(345776,9605,'pt','Conjunto padrÃ£o de grupo acesso',0),(345777,9605,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿ Ðº Ð³Ñ€ÑƒÐ¿Ð¿Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð½Ð°Ð±Ð¾Ñ€',0),(345778,9605,'es','Configura Acceso de Grupo Predeterminado',0),(345779,9605,'de','Set Default Gruppenzugriff',0),(345780,9605,'en','Set Default Group Access',0),(345781,9606,'is','',0),(345782,9606,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§  ÙŠÙƒ Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(345783,9606,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§  ÙŠÙƒ Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(345784,9606,'tr','HaklarÄ± grubu Ã¶nce girmeniz gerekir',0),(345785,9606,'pl','Najpierw naleÅ¼y wprowadziÄ‡ grupÄ™ praw',0),(345786,9606,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð¿ÑŠÑ€Ð²Ð¾',0),(345787,9606,'ur','Ø¢Ù¾ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§ÛŒÚ© Ø­Ù‚ÙˆÙ‚ Ú¯Ø±ÙˆÙ¾ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(345788,9606,'sr','ÐŸÑ€Ð²Ð¾ Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ ÑƒÐ½ÐµÑ‚Ð¸ Ð¿Ñ€Ð°Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(345789,9606,'vi','Báº¡n pháº£i nháº­p nhÃ³m cÃ¡c quyá»n trÆ°á»›c',0),(345790,9606,'af','U Moet eers \'n Groepreg Invoer ',0),(345791,9606,'ro','Trebuie sÄƒ introduceÅ£i un grup de drepturile mai Ã®ntÃ¢i',0),(345792,9606,'et','Te peate sisestama eelnevalt Ãµiguste grupi',0),(345793,9606,'si','Vnesti morate skupino pravice najprej',0),(345794,9606,'ba','Anda harus memasukkan kelompok HAM pertama',0),(345795,9606,'nl','U moet eerst een rechtengroep invoeren',0),(345796,9606,'fi','MÃ¤Ã¤ritÃ¤ oikeuksien ryhmÃ¤ ensin',0),(345797,9606,'no','Du mÃ¥ angi en rettigheter gruppen fÃ¸rst',0),(345798,9606,'da','Du skal angive en rettigheder gruppe fÃ¸rst',0),(345799,9606,'ko','ê¶Œë¦¬ ê·¸ë£¹ì„ ë¨¼ì € ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(345800,9606,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×–×›×•×™×•×ª ×§×‘×•×¦×” ×¨××©×™×ª',0),(345801,9606,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î¿Î¼Î¬Î´Î± Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï€ÏÏŽÏ„Î±',0),(345802,9606,'zh','æ‚¨å¿…é¡»é¦–å…ˆè¾“å…¥ä¸€ä¸ªæƒé™ç»„\r\n',0),(345803,9606,'sv','Du mÃ¥ste ange en rÃ¤ttighetsgrupp fÃ¶rst',0),(345804,9606,'it','Ãˆ necessario inserire prima un gruppo di diritti',0),(345805,9606,'tl','',0),(345806,9606,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3619;&#3629;&#3585;&#3626;&#3636;&#3607;&#3608;&#3636;&#3586;&#3629;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3648;&#3611;&#3655;&#3609;&#3626;&#3636;&#3656;&#3591;&#3649;&#3619;&#3585;',0),(345807,9606,'hi','à¤†à¤ª à¤à¤• à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤®à¥‚à¤¹ à¤ªà¤¹à¤²à¥‡ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(345808,9606,'ms','Anda mesti memasukkan hak Kumpulan pertama',0),(345809,9606,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø¬Ù…ÙˆØ¹Ø© Ø­Ù‚ÙˆÙ‚ Ø£ÙˆÙ„Ø§',0),(345810,9606,'fr','Vous devez entrer d\'abord un groupe de droits',0),(345811,9606,'jp','æœ€åˆã®æ¨©åˆ©ã‚°ãƒ«ãƒ¼ãƒ—ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(345812,9606,'pt','VocÃª deve inserir um grupo de direitos primeiro',0),(345813,9606,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð³Ñ€ÑƒÐ¿Ð¿Ñƒ Ð¿Ñ€Ð°Ð²',0),(345814,9606,'es','Debe Ingresar un Grupo de Derechos Primero',0),(345815,9606,'de','Sie mÃ¼ssen zuerst eine Rechte Gruppe eingeben.',0),(345816,9606,'en','You Must Enter A Rights Group First',0),(345817,9607,'is','',0),(345818,9607,'dr','Ø­Ù‚ÙˆÙ‚ Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(345819,9607,'pr','Ø­Ù‚ÙˆÙ‚ Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(345820,9607,'tr','Grup haklarÄ± baÅŸarÄ±yla kaydedildi',0),(345821,9607,'pl','Grupy praw zapisany pomyÅ›lnie',0),(345822,9607,'bg','Ð“Ñ€ÑƒÐ¿Ð° Ð¿Ñ€Ð°Ð²Ð° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(345823,9607,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ú¯Ø±ÙˆÙ¾ Ú©Û’ Ø­Ù‚ÙˆÙ‚',0),(345824,9607,'sr','Ð“Ñ€ÑƒÐ¿Ð½Ð° Ð¿Ñ€Ð°Ð²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(345825,9607,'vi','quyá»n cá»§a nhÃ³m Ä‘Æ°á»£c lÆ°u thÃ nh cÃ´ng',0),(345826,9607,'af','Groepregte Suksesvol Gestoor',0),(345827,9607,'ro','Grupului drepturi salvat cu succes',0),(345828,9607,'et','Grupi Ãµigused edukalt salvestatud',0),(345829,9607,'si','Skupina pravic, ki se uspeÅ¡no shranjen',0),(345830,9607,'ba','Kelompok HAM disimpan berhasil',0),(345831,9607,'nl','Groepsrechten succesvol opgeslagen',0),(345832,9607,'fi','RyhmÃ¤n oikeudet tallennettu',0),(345833,9607,'no','Gruppe rettigheter lagret',0),(345834,9607,'da','Gruppe rettigheder gemt med succes',0),(345835,9607,'ko','ê·¸ë£¹ ê¶Œí•œì„ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(345836,9607,'he','×–×›×•×™×•×ª ×§×‘×•×¦×” ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(345837,9607,'el','Î”Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Î¿Î¼Î¬Î´Î±Ï‚ Ï€Î¿Ï… Î±Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(345838,9607,'zh','ç»„æƒåˆ©å·²æˆåŠŸä¿å­˜\r\n',0),(345839,9607,'sv','Grupp rÃ¤ttigheter har sparats',0),(345840,9607,'it','Diritti del gruppo salvati correttamente',0),(345841,9607,'tl','',0),(345842,9607,'th','&#3626;&#3636;&#3607;&#3608;&#3636;&#3586;&#3629;&#3591;&#3585;&#3621;&#3640;&#3656;&#3617;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(345843,9607,'hi','à¤¸à¤®à¥‚à¤¹ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(345844,9607,'ms','Hak-hak Kumpulan yang berjaya disimpan',0),(345845,9607,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(345846,9607,'fr','Droits de groupe enregistrÃ©s avec succÃ¨s',0),(345847,9607,'jp','ã‚°ãƒ«ãƒ¼ãƒ—æ¨©é™ãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(345848,9607,'pt','Direitos de grupo com sucesso',0),(345849,9607,'ru','ÐŸÑ€Ð°Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(345850,9607,'es','Derechos del Grupo Guardado Exitosamente',0),(345851,9607,'de','Gruppenrechte erfolgreich gespeichert',0),(345852,9607,'en','Group Rights Saved Successfully',0),(345853,9608,'is','',0),(345854,9608,'dr','Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯ ',0),(345855,9608,'pr','Ú¯Ø±ÙˆÙ‡ Ø¬Ø¯ÙŠØ¯ ',0),(345856,9608,'tr','Yeni Grup',0),(345857,9608,'pl','Nowa grupa',0),(345858,9608,'bg','ÐÐ¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(345859,9608,'ur','Ù†ÛŒØ§ Ú¯Ø±ÙˆÙ¾',0),(345860,9608,'sr','ÐÐ¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(345861,9608,'vi','nhÃ³m má»›i',0),(345862,9608,'af','Nuwe Groep',0),(345863,9608,'ro','Grup nou',0),(345864,9608,'et','Uus grupp',0),(345865,9608,'si','Nova skupina',0),(345866,9608,'ba','Grup baru',0),(345867,9608,'nl','Nieuwe groep',0),(345868,9608,'fi','Uusi ryhmÃ¤',0),(345869,9608,'no','Ny gruppe',0),(345870,9608,'da','Ny gruppe',0),(345871,9608,'ko','ìƒˆ ê·¸ë£¹',0),(345872,9608,'he','×§×‘×•×¦×” ×—×“×©×”',0),(345873,9608,'el','ÎÎ­Î± Î¿Î¼Î¬Î´Î±',0),(345874,9608,'zh','æ–°ç»„\r\n',0),(345875,9608,'sv','Ny grupp',0),(345876,9608,'it','Nuovo gruppo',0),(345877,9608,'tl','',0),(345878,9608,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3651;&#3627;&#3617;&#3656;',0),(345879,9608,'hi','à¤¨à¤¯à¤¾ à¤¸à¤®à¥‚à¤¹',0),(345880,9608,'ms','Kumpulan baru',0),(345881,9608,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(345882,9608,'fr','Nouveau groupe',0),(345883,9608,'jp','æ–°ã—ã„ã‚°ãƒ«ãƒ¼ãƒ—',0),(345884,9608,'pt','Novo grupo',0),(345885,9608,'ru','ÐÐ¾Ð²Ð°Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ð°',0),(345886,9608,'es','Nuevo Grupo',0),(345887,9608,'de','Neue Gruppe',0),(345888,9608,'en','New Group',0),(345889,9609,'is','',0),(345890,9609,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø± ',0),(345891,9609,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø± ',0),(345892,9609,'tr','Gruplara kullanÄ±cÄ± haklarÄ±',0),(345893,9609,'pl','Grupy praw uÅ¼ytkownika',0),(345894,9609,'bg','Ð“Ñ€ÑƒÐ¿Ð¸ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ñ€Ð°Ð²Ð°',0),(345895,9609,'ur','ØµØ§Ø±Ù Ø±Ø§Ø¦Ù¹Ø³ Ú¯Ø±ÙˆÙ¾Ø³',0),(345896,9609,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸Ñ… Ð¿Ñ€Ð°Ð²Ð° Ð³Ñ€ÑƒÐ¿Ðµ',0),(345897,9609,'vi','NgÆ°á»i sá»­ dá»¥ng quyá»n nhÃ³m',0),(345898,9609,'af','Gebruikerregte Groepe',0),(345899,9609,'ro','Utilizator drepturile grupurilor',0),(345900,9609,'et','Kasutaja Ãµiguste rÃ¼hmad',0),(345901,9609,'si','UporabniÅ¡kih pravic skupine',0),(345902,9609,'ba','Pengguna hak kelompok',0),(345903,9609,'nl','Gebruikersrechten, groepen',0),(345904,9609,'fi','KÃ¤yttÃ¤jÃ¤n oikeuksia ajavat ryhmÃ¤t',0),(345905,9609,'no','Brukeren rettigheter grupper',0),(345906,9609,'da','Bruger rettigheder grupper',0),(345907,9609,'ko','ì‚¬ìš©ìž ê¶Œí•œ ê·¸ë£¹',0),(345908,9609,'he','×§×‘×•×¦×•×ª ×©×œ ×–×›×•×™×•×ª ×ž×©×ª×ž×©',0),(345909,9609,'el','ÎŸÎ¼Î¬Î´ÎµÏ‚ Î´Î¹ÎºÎ±Î¹Ï‰Î¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÏ„Î·',0),(345910,9609,'zh','ç”¨æˆ·æƒé™ç»„\r\n',0),(345911,9609,'sv','AnvÃ¤ndarrÃ¤ttigheter grupper',0),(345912,9609,'it','Gruppi per i diritti utente',0),(345913,9609,'tl','',0),(345914,9609,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3617;&#3637;&#3626;&#3636;&#3607;&#3608;&#3636;',0),(345915,9609,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤®à¥‚à¤¹à¥‹à¤‚',0),(345916,9609,'ms','Pengguna hak Kumpulan',0),(345917,9609,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(345918,9609,'fr','Groupes des droits utilisateur',0),(345919,9609,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©é™ã‚°ãƒ«ãƒ¼ãƒ—',0),(345920,9609,'pt','Grupos de direitos de usuÃ¡rio',0),(345921,9609,'ru','ÐŸÑ€Ð°Ð²Ð° Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð° ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ðš Ð“Ñ€ÑƒÐ¿Ð¿Ð°Ð¼',0),(345922,9609,'es','Grupos de Derechos de Usuarios',0),(345923,9609,'de','Benutzerrechte Gruppen',0),(345924,9609,'en','User Rights Groups',0),(345925,9610,'is','',0),(345926,9610,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(345927,9610,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(345928,9610,'tr','Bir grup adÄ± girmeniz gerekir',0),(345929,9610,'pl','NaleÅ¼y wprowadziÄ‡ nazwÄ™ grupy',0),(345930,9610,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(345931,9610,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ø§ÛŒÚ© Ú¯Ø±ÙˆÙ¾ Ú©Ø§ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(345932,9610,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð³Ñ€ÑƒÐ¿Ðµ',0),(345933,9610,'vi','Báº¡n pháº£i nháº­p tÃªn nhÃ³m',0),(345934,9610,'af','U moet \'n Groepnaam Invoer',0),(345935,9610,'ro','IntroduceÅ£i un nume de grup',0),(345936,9610,'et','Te peate sisestama grupi nime',0),(345937,9610,'si','Vnesti morate ime skupine',0),(345938,9610,'ba','Anda harus memasukkan nama grup',0),(345939,9610,'nl','U moet een groepsnaam invoeren',0),(345940,9610,'fi','Kirjoita ryhmÃ¤nimi',0),(345941,9610,'no','Du mÃ¥ angi et gruppenavn',0),(345942,9610,'da','Du skal angive et gruppenavn',0),(345943,9610,'ko','ê·¸ë£¹ ì´ë¦„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(345944,9610,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×©× ×§×‘×•×¦×”',0),(345945,9610,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± Î¿Î¼Î¬Î´Î±Ï‚',0),(345946,9610,'zh','æ‚¨å¿…é¡»è¾“å…¥ç»„å\r\n',0),(345947,9610,'sv','Du mÃ¥ste ange ett namn fÃ¶r gruppen',0),(345948,9610,'it','Ãˆ necessario immettere un nome di gruppo',0),(345949,9610,'tl','',0),(345950,9610,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3585;&#3619;&#3629;&#3585;&#3594;&#3639;&#3656;&#3629;&#3585;&#3621;&#3640;&#3656;&#3617;',0),(345951,9610,'hi','à¤†à¤ªà¤•à¥‹ à¤•à¥‹à¤ˆ à¤¸à¤®à¥‚à¤¹ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(345952,9610,'ms','Awda mesti masukkan nama Kumpulan',0),(345953,9610,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ¯Ø®Ù„ Ø¥Ø³Ù… Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(345954,9610,'fr','Vous devez entrer un nom de groupe.',0),(345955,9610,'jp','ã‚°ãƒ«ãƒ¼ãƒ—åã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(345956,9610,'pt','VocÃª deve digitar um nome de grupo',0),(345957,9610,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¸Ð¼Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(345958,9610,'es','Debe Ingresar un Nombre de Grupo',0),(345959,9610,'de','Sie mÃ¼ssen einen Gruppennamen eingeben.',0),(345960,9610,'en','You Must Enter A Group Name',0),(345961,9611,'is','',0),(345962,9611,'dr','Ø­Ù‚ÙˆÙ‚ Ù¾ÙŠØ´Ø±ÙØªÙ‡ ',0),(345963,9611,'pr','Ø­Ù‚ÙˆÙ‚ Ù¾ÙŠØ´Ø±ÙØªÙ‡ ',0),(345964,9611,'tr','GeliÅŸmiÅŸ haklar',0),(345965,9611,'pl','Zaawansowanych praw',0),(345966,9611,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¸ Ð¿Ñ€Ð°Ð²Ð°',0),(345967,9611,'ur','Ø§Ø¹Ù„ÛŒ Ø­Ù‚ÙˆÙ‚',0),(345968,9611,'sr','ÐÐ°Ð¿Ñ€ÐµÐ´Ð½Ð° Ð¿Ñ€Ð°Ð²Ð°',0),(345969,9611,'vi','PhÃ¢m quyá»n nÃ¢ng cao',0),(345970,9611,'af','Gevorderde Regte',0),(345971,9611,'ro','Drepturile avansate',0),(345972,9611,'et','TÃ¤psemad Ãµigused',0),(345973,9611,'si','Napredno pravic',0),(345974,9611,'ba','Hak-hak yang lanjut',0),(345975,9611,'nl','Geavanceerde rechten',0),(345976,9611,'fi','LisÃ¤oikeudet',0),(345977,9611,'no','Avanserte rettigheter',0),(345978,9611,'da','Avanceret rettigheder',0),(345979,9611,'ko','ê³ ê¸‰ ê¶Œí•œ',0),(345980,9611,'he','×–×›×•×™×•×ª ×ž×ª×§×“×',0),(345981,9611,'el','Î ÏÎ¿Î·Î³Î¼Î­Î½ÎµÏ‚ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î±',0),(345982,9611,'zh','é«˜çº§æƒé™\r\n',0),(345983,9611,'sv','Avancerade rÃ¤ttigheter',0),(345984,9611,'it','Diritti avanzati',0),(345985,9611,'tl','',0),(345986,9611,'th','&#3626;&#3636;&#3607;&#3608;&#3636;&#3614;&#3636;&#3648;&#3624;&#3625;',0),(345987,9611,'hi','à¤‰à¤¨à¥à¤¨à¤¤ à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(345988,9611,'ms','Hak-hak lanjutan',0),(345989,9611,'ar','Ø­Ù‚ÙˆÙ‚ Ù…ØªÙ‚Ø¯Ù…Ø©',0),(345990,9611,'fr','Droits avancÃ©s',0),(345991,9611,'jp','é«˜åº¦ãªæ¨©é™',0),(345992,9611,'pt','Direitos avanÃ§ados',0),(345993,9611,'ru','Ð Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ñ€Ð°Ð²Ð°',0),(345994,9611,'es','Derechos Avanzados',0),(345995,9611,'de','Erweiterte Rechte',0),(345996,9611,'en','Advanced Rights',0),(345997,9612,'is','',0),(345998,9612,'dr','Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(345999,9612,'pr','Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(346000,9612,'tr','POS',0),(346001,9612,'pl','POS',0),(346002,9612,'bg','POS',0),(346003,9612,'ur','Ù¾ÙˆØ²ÛŒØ´Ù†',0),(346004,9612,'sr','ÐŸÐžÐ¡',0),(346005,9612,'vi','POS',0),(346006,9612,'af','PVV',0),(346007,9612,'ro','POS',0),(346008,9612,'et','POS',0),(346009,9612,'si','POS',0),(346010,9612,'ba','POS',0),(346011,9612,'nl','POS',0),(346012,9612,'fi','POS',0),(346013,9612,'no','POS',0),(346014,9612,'da','POS',0),(346015,9612,'ko','í¬ìŠ¤',0),(346016,9612,'he','×§×•×¤×”',0),(346017,9612,'el','POS',0),(346018,9612,'zh','é”€å”®ç‚¹\r\n',0),(346019,9612,'sv','POS',0),(346020,9612,'it','POS',0),(346021,9612,'tl','',0),(346022,9612,'th','&#3592;&#3640;&#3604;&#3586;&#3634;&#3618;',0),(346023,9612,'hi','à¤ªà¥€à¤“à¤à¤¸',0),(346024,9612,'ms','POS',0),(346025,9612,'ar','Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(346026,9612,'fr','POINT DE VENTE',0),(346027,9612,'jp','POS',0),(346028,9612,'pt','POS',0),(346029,9612,'ru','ÐšÐÐ¡Ð¡Ð',0),(346030,9612,'es','PDV',0),(346031,9612,'de','POS',0),(346032,9612,'en','POS',0),(346033,9613,'is','',0),(346034,9613,'dr','Ú†Ùƒ Ù‡Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ø¯ÙƒÙ…Ù‡ Ú†Ø§Ù¾ Ø±Ø§ ÙØ´Ø§Ø± Ø¯Ù‡ÙŠØ¯ ØªØ§Ø¹Ù…Ù„ÙŠØ§Øª Ù¾Ø§ÙŠØ§Ù† ÙŠØ§Ø¨Ø¯',0),(346035,9613,'pr','Ú†Ùƒ Ù‡Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ø¯ÙƒÙ…Ù‡ Ú†Ø§Ù¾ Ø±Ø§ ÙØ´Ø§Ø± Ø¯Ù‡ÙŠØ¯ ØªØ§Ø¹Ù…Ù„ÙŠØ§Øª Ù¾Ø§ÙŠØ§Ù† ÙŠØ§Ø¨Ø¯',0),(346036,9613,'tr','OluÅŸturulan - denetler iÅŸleme tamamlamak iÃ§in YazdÄ±r\'a basÄ±n',0),(346037,9613,'pl','Sprawdza wygenerowany - naciÅ›nij przycisk Drukuj na zakoÅ„czenie przetwarzania',0),(346038,9613,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸Ñ‚Ðµ Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸ - Ð½Ð°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ Ð¿ÐµÑ‡Ð°Ñ‚, Ð·Ð° Ð´Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°Ñ‚Ð°',0),(346039,9613,'ur','Ú†ÛŒÚ© Ù¾Ø±ÛŒØ³ Ù¾Ø±Ù†Ù¹ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ù…Ú©Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù¾ÛŒØ¯Ø§ ÛÙˆØªÛŒ ÛÛ’-',0),(346040,9613,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð° Ð³ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ð½Ðµ - Ð¿Ñ€Ð¸Ñ‚Ð¸ÑÐ½Ð¸Ñ‚Ðµ ÐŸÑ€Ð¸Ð½Ñ‚ Ð·Ð°Ð²Ñ€ÑˆÐ¸Ñ‚Ð¸ Ð¾Ð±Ñ€Ð°Ð´Ñƒ',0),(346041,9613,'vi','Kiá»ƒm tra Ä‘Æ°á»£c táº¡o ra - báº¥m Print káº¿t thÃºc xá»­ lÃ½',0),(346042,9613,'af','Tjeks Gegenereer - Druk Uitdruk Om Prosessering te Voltooi',0),(346043,9613,'ro','Controalele generat - Print de presÄƒ pentru a termina transformarea',0),(346044,9613,'et','Kontrolli saadud - tÃ¶Ã¶tlemise lÃµpetamiseks vajutage Prindi',0),(346045,9613,'si','Pregledi ustvarila - tiskanje do konca obdelave',0),(346046,9613,'ba','Cek dihasilkan - pers cetak untuk menyelesaikan pengolahan',0),(346047,9613,'nl','Controles gegenereerd - pers afdrukken naar de Finish verwerking',0),(346048,9613,'fi','Tarkastusten syntyy - paina Tulosta loppuun kÃ¤sittely',0),(346049,9613,'no','Sjekker generert - trykk Print Ã¥ fullfÃ¸re behandlingen',0),(346050,9613,'da','Kontrollerer genererede - Tryk pÃ¥ Udskriv for at afslutte behandlingen',0),(346051,9613,'ko','ê²€ì‚¬ ìƒì„±-ì²˜ë¦¬ ì™„ë£Œë¥¼ ëˆŒëŸ¬ ì¸ì‡„',0),(346052,9613,'he','×‘×“×™×§×•×ª ×©× ×•×¦×¨ - ×”×§×© ×¢×œ ×”×“×¤×¡×” ×›×“×™ ×œ×¡×™×™× ××ª ×¢×™×‘×•×“',0),(346053,9613,'el','Î•Î»Î­Î³Ï‡Î¿Ï…Ï‚ Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½Ï„Î±Î¹ - ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€Î±Ï„Î®ÏƒÏ„Îµ Î¤Î­Î»Î¿Ï‚ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(346054,9613,'zh','æ£€æŸ¥ç”Ÿæˆçš„-æŒ‰æ‰“å°å¤„ç†å®Œ\r\n',0),(346055,9613,'sv','Kontrollerar genererade - tryck pÃ¥ Print fÃ¶r att avsluta behandlingen',0),(346056,9613,'it','Controlli generati - comunicato stampa al termine dell\'elaborazione',0),(346057,9613,'tl','',0),(346058,9613,'th','&#3648;&#3594;&#3655;&#3588;&#3652;&#3604;&#3657;&#3626;&#3619;&#3657;&#3634;&#3591;&#3586;&#3638;&#3657;&#3609; - &#3585;&#3604;&#3614;&#3636;&#3617;&#3614;&#3660;&#3649;&#3621;&#3657;&#3623;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3585;&#3619;',0),(346059,9613,'hi','à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ - à¤œà¤¾à¤à¤š à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‹ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¥‡à¤¸ à¤®à¥à¤¦à¥à¤°à¤£',0),(346060,9613,'ms','Pemeriksaan yang dihasilkan - akhbar cetak hingga ke akhir proses',0),(346061,9613,'ar','Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§-Ø§Ù„ØµØ­Ø§ÙØ© Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© Ù„Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ù…Ù† ØªØ¬Ù‡ÙŠØ²',0),(346062,9613,'fr','VÃ©rifie gÃ©nÃ©rÃ© - Appuyez sur Imprimer pour terminer le traitement',0),(346063,9613,'jp','ãƒã‚§ãƒƒã‚¯ã®ç”Ÿæˆ - ãƒ—ãƒ¬ã‚¹å°åˆ·å‡¦ç†ãŒå®Œäº†ã™ã‚‹ã«ã¯',0),(346064,9613,'pt','Verifica gerado - pressione Imprimir para concluir o processamento',0),(346065,9613,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÐ¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ñ… - Ð½Ð°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð´Ð»Ñ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸',0),(346066,9613,'es','Cheques Generados - Oprima Imprimir para Terminar el Proceso',0),(346067,9613,'de','Kontrollen generiert - Presse Print Verarbeitung beenden',0),(346068,9613,'en','Checks Generated - Press Print To Finish Processing',0),(346069,9614,'is','',0),(346070,9614,'dr','(Ù…Ø§Ù…ÙˆØ±ÙŠØª) ÙˆÙŠÚ˜Ù‡',0),(346071,9614,'pr','Ù‡Ù…Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ â€“ Ø´ØºÙ„ (Ù…Ø§Ù…ÙˆØ±ÙŠØª) ÙˆÙŠÚ˜Ù‡',0),(346072,9614,'tr','TÃ¼m hesaplar - belirli iÅŸ',0),(346073,9614,'pl','Wszystkie konta - okreÅ›lonego zadanie',0),(346074,9614,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸ - ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(346075,9614,'ur','ØªÙ…Ø§Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹ - Ù…Ø®ØµÙˆØµ Ú©Ø§Ù…',0),(346076,9614,'sr','Ð¡Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸ - Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(346077,9614,'vi','Táº¥t cáº£ tÃ i khoáº£n - cÃ´ng viá»‡c cá»¥ thá»ƒ',0),(346078,9614,'af','Alle Rekeninge - Spesifieke Werkstuk',0),(346079,9614,'ro','Toate conturile - specifice Job',0),(346080,9614,'et','KÃµik kontod - konkreetse tÃ¶Ã¶',0),(346081,9614,'si','Vse raÄune - posebne delo',0),(346082,9614,'ba','Semua account - pekerjaan tertentu',0),(346083,9614,'nl','Alle Accounts - specifieke baan',0),(346084,9614,'fi','Kaikki tilit - tyÃ¶paikkaa',0),(346085,9614,'no','Alle kontoer - spesifikk jobb',0),(346086,9614,'da','Alle konti - specifikke Job',0),(346087,9614,'ko','ëª¨ë“  ê³„ì •-íŠ¹ì • ìž‘ì—…',0),(346088,9614,'he','×›×œ ×—×©×‘×•× ×•×ª - ×¢×‘×•×“×” ×¡×¤×¦×™×¤×™×ª',0),(346089,9614,'el','ÎŒÎ»Î¿Î¹ Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ - ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î· ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(346090,9614,'zh','æ‰€æœ‰å¸æˆ·-å…·ä½“å·¥ä½œ\r\n',0),(346091,9614,'sv','Alla konton - specifika jobb',0),(346092,9614,'it','Tutti i conti - lavoro specifico',0),(346093,9614,'tl','',0),(346094,9614,'th','&#3585;&#3636;&#3592;&#3585;&#3619;&#3619;&#3617;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(346095,9614,'hi','à¤¸à¤­à¥€ à¤–à¤¾à¤¤à¥‡ - à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤¨à¥Œà¤•à¤°à¥€',0),(346096,9614,'ms','Semua akaun - pekerjaan yang khusus',0),(346097,9614,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª-ÙˆØ¸ÙŠÙØ© Ù…Ø­Ø¯Ø¯Ø©',0),(346098,9614,'fr','Tous les comptes - travail spÃ©cifique',0),(346099,9614,'jp','ç‰¹å®šã®ã‚¸ãƒ§ãƒ–ã®ã™ã¹ã¦ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ-',0),(346100,9614,'pt','Todas as contas - trabalho especÃ­fico',0),(346101,9614,'ru','Ð’ÑÐµ ÑÑ‡ÐµÑ‚Ð° - ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ð¾Ð³Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(346102,9614,'es','Todas las Cuentas - Trabajo EspecÃ­fico',0),(346103,9614,'de','Alle Konten - spezifischen Job',0),(346104,9614,'en','All Accounts - Specific Job',0),(346105,9615,'is','',0),(346106,9615,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªÙ…Ø§Ù… Ø­Ø³Ø§Ø¨Ù‡Ø§ ',0),(346107,9615,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ØªÙ…Ø§Ù… Ø­Ø³Ø§Ø¨Ù‡Ø§ ',0),(346108,9615,'tr','BÃ¼tÃ¼n hesaplarÄ±nÄ± DÃ¼zenle',0),(346109,9615,'pl','Edycja wszystkich kont',0),(346110,9615,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸',0),(346111,9615,'ur','ØªÙ…Ø§Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(346112,9615,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÑÐ²Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(346113,9615,'vi','Chá»‰nh sá»­a táº¥t cáº£ cÃ¡c tÃ i khoáº£n',0),(346114,9615,'af','Redigeer Alle Rekeninge',0),(346115,9615,'ro','Edita toate conturile',0),(346116,9615,'et','Muuta kÃµik kontod',0),(346117,9615,'si','Urejanje vseh raÄunov',0),(346118,9615,'ba','Mengedit semua account',0),(346119,9615,'nl','Alle Accounts bewerken',0),(346120,9615,'fi','Muokkaa kaikesta',0),(346121,9615,'no','Rediger alle kontoer',0),(346122,9615,'da','Rediger alle konti',0),(346123,9615,'ko','ëª¨ë“  ê³„ì • íŽ¸ì§‘',0),(346124,9615,'he','×¢×¨×•×š ××ª ×›×œ ×”×—×©×‘×•× ×•×ª',0),(346125,9615,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(346126,9615,'zh','ç¼–è¾‘æ‰€æœ‰å¸æˆ·\r\n',0),(346127,9615,'sv','Redigera alla konton',0),(346128,9615,'it','Modificare tutti gli account',0),(346129,9615,'tl','',0),(346130,9615,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(346131,9615,'hi','à¤¸à¤­à¥€ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(346132,9615,'ms','Edit semua akaun',0),(346133,9615,'ar','ØªØ­Ø±ÙŠØ± ÙƒÙ„ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(346134,9615,'fr','Modifier tous les comptes',0),(346135,9615,'jp','ã™ã¹ã¦ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(346136,9615,'pt','Editar todas as contas',0),(346137,9615,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð²ÑÐµÑ… ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(346138,9615,'es','Editar Todas las Cuentas',0),(346139,9615,'de','Alle Konten bearbeiten',0),(346140,9615,'en','Edit All Accounts',0),(346141,9616,'is','',0),(346142,9616,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§ÙŠÙ† Ø­Ø³Ø§Ø¨ ',0),(346143,9616,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§ÙŠÙ† Ø­Ø³Ø§Ø¨ ',0),(346144,9616,'tr','Bu hesabÄ± DÃ¼zenle',0),(346145,9616,'pl','Edytowanie konta',0),(346146,9616,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(346147,9616,'ur','ÛŒÛ Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(346148,9616,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¾Ð²Ð°Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½',0),(346149,9616,'vi','Chá»‰nh sá»­a tÃ i khoáº£n nÃ y',0),(346150,9616,'af','Redigeer Hierdie Rekening',0),(346151,9616,'ro','Edita acest cont',0),(346152,9616,'et','Redigeeri selle konto',0),(346153,9616,'si','Uredite ta raÄun',0),(346154,9616,'ba','Mengedit Account ini',0),(346155,9616,'nl','Deze Account bewerken',0),(346156,9616,'fi','Muokkaa tÃ¤mÃ¤n tilin',0),(346157,9616,'no','Rediger denne kontoen',0),(346158,9616,'da','Rediger denne konto',0),(346159,9616,'ko','ì´ ê³„ì • íŽ¸ì§‘',0),(346160,9616,'he','×¢×¨×•×š ×—×©×‘×•×Ÿ ×–×”',0),(346161,9616,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(346162,9616,'zh','ç¼–è¾‘æœ¬å¸æˆ·\r\n',0),(346163,9616,'sv','Redigera kontot',0),(346164,9616,'it','Modificare questo Account',0),(346165,9616,'tl','',0),(346166,9616,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3610;&#3633;&#3597;&#3594;&#3637;&#3609;&#3637;&#3657;',0),(346167,9616,'hi','à¤‡à¤¸ à¤–à¤¾à¤¤à¥‡ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(346168,9616,'ms','Edit akaun ini',0),(346169,9616,'ar','ØªØ­Ø±ÙŠØ± Ù‡Ø°Ø§ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(346170,9616,'fr','Modifier ce compte',0),(346171,9616,'jp','ã“ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(346172,9616,'pt','Editar esta conta',0),(346173,9616,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(346174,9616,'es','Editar Esta Cuenta',0),(346175,9616,'de','Dieses Konto bearbeiten',0),(346176,9616,'en','Edit This Account',0),(346177,9617,'is','',0),(346178,9617,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„',0),(346179,9617,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„',0),(346180,9617,'tr','GÃ¼ncelleÅŸtirme proje bÃ¼tÃ§esi',0),(346181,9617,'pl','BudÅ¼et zlecenia aktualizacji',0),(346182,9617,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(346183,9617,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(346184,9617,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð±ÑƒÑŸÐµÑ‚ Ð¿Ð¾ÑÐ»Ð°',0),(346185,9617,'vi','Cáº­p nháº­t ngÃ¢n sÃ¡ch cÃ´ng viá»‡c',0),(346186,9617,'af','Opdateer Werkstuk Begroting',0),(346187,9617,'ro','Actualizare Buget lucrare',0),(346188,9617,'et','Uuenda projekti eelarve',0),(346189,9617,'si','PredraÄun projekta posodobitev',0),(346190,9617,'ba','Update pekerjaan anggaran',0),(346191,9617,'nl','Update projectbudget',0),(346192,9617,'fi','PÃ¤ivitÃ¤ projektibudjetin',0),(346193,9617,'no','Oppdatere prosjektbudsjett',0),(346194,9617,'da','Opdatere sagsbudget',0),(346195,9617,'ko','ì—…ë°ì´íŠ¸ ìž‘ì—… ì˜ˆì‚°',0),(346196,9617,'he','×œ×¢×“×›×Ÿ ××ª ×ª×§×¦×™×‘ ×”×¢×‘×•×“×”',0),(346197,9617,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Î­ÏÎ³Î¿Ï… Ï„Î·Î½ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ·',0),(346198,9617,'zh','æ›´æ–°ä½œä¸šé¢„ç®—\r\n',0),(346199,9617,'sv','Uppdatera projektbudget',0),(346200,9617,'it','Aggiornamento Budget di commessa',0),(346201,9617,'tl','',0),(346202,9617,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3591;&#3634;&#3609;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(346203,9617,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾à¤°à¥à¤¯ à¤¬à¤œà¤Ÿ',0),(346204,9617,'ms','Kemaskini kerja bajet',0),(346205,9617,'ar','ØªØ­Ø¯ÙŠØ« ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(346206,9617,'fr','Budget projet mise Ã  jour',0),(346207,9617,'jp','ä»•äº‹ã®äºˆç®—ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(346208,9617,'pt','OrÃ§amento de trabalho de atualizaÃ§Ã£o',0),(346209,9617,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(346210,9617,'es','Actualiza Presupuesto de Tarea',0),(346211,9617,'de','Projektbudget zu aktualisieren',0),(346212,9617,'en','Update Job Budget',0),(346213,9618,'is','',0),(346214,9618,'dr','Ø­Ø°Ù Ø§ÙŠÙ†  Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ ',0),(346215,9618,'pr','Ø­Ø°Ù Ø§ÙŠÙ†  Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ ',0),(346216,9618,'tr','Bu yinelenen Ã§eki Sil',0),(346217,9618,'pl','UsunÄ…Ä‡ ten kupon cyklicznego',0),(346218,9618,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ñ‚Ð¾Ð·Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(346219,9618,'ur','Ø§Ø³ Ø¨Ø§Ø± Ø¨Ø§Ø± ÛÙˆÙ†Û’ ÙˆØ§Ù„ÛŒ ÙˆØ§Ø¤Ú†Ø± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(346220,9618,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ð°Ñ˜ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(346221,9618,'vi','XÃ³a chá»©ng tá»« nÃ y theo Ä‘á»‹nh ká»³',0),(346222,9618,'af','Skrap hierdie Herhalende Bewysstuk',0),(346223,9618,'ro','Åžterge acest Voucher recurente',0),(346224,9618,'et','Kustuta korduv kanne',0),(346225,9618,'si','Izbrisati to ponavljajoÄe se kupon',0),(346226,9618,'ba','Menghapus Voucher ini berulang',0),(346227,9618,'nl','Verwijderen van deze terugkerende Voucher',0),(346228,9618,'fi','Poista tÃ¤mÃ¤ toistuva tosite',0),(346229,9618,'no','Slette denne regelmessige bilag',0),(346230,9618,'da','Slet denne tilbagevendende Voucher',0),(346231,9618,'ko','ì´ ë˜í’€ì´ ë°”ìš°ì²˜ë¥¼ ì‚­ì œ',0),(346232,9618,'he','×œ×ž×—×•×§ ×©×•×‘×¨ ×–×” ×—×•×–×¨×•×ª',0),(346233,9618,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(346234,9618,'zh','åˆ é™¤æ­¤å†æ¬¡åˆ¸\r\n',0),(346235,9618,'sv','Ta bort denna Ã¥terkommande Voucher',0),(346236,9618,'it','Cancella questo voucher ricorrente',0),(346237,9618,'tl','',0),(346238,9618,'th','&#3621;&#3610;&#3651;&#3610;&#3626;&#3635;&#3588;&#3633;&#3597;&#3592;&#3656;&#3634;&#3618;&#3607;&#3637;&#3656;&#3595;&#3657;&#3635;&#3609;&#3637;&#3657;',0),(346239,9618,'hi','à¤‡à¤¸ à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ Voucher à¤¹à¤Ÿà¤¾à¤à¤',0),(346240,9618,'ms','Menghapuskan baucar ini berulang',0),(346241,9618,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø§Ù„Ù…ØªÙƒØ±Ù‘Ø±',0),(346242,9618,'fr','Supprimer ce bon rÃ©current',0),(346243,9618,'jp','ã“ã®å®šæœŸçš„ãªä¼ç¥¨ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(346244,9618,'pt','Excluir este Voucher recorrente',0),(346245,9618,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(346246,9618,'es','Eliminar este Voucher Recurrente',0),(346247,9618,'de','LÃ¶schen Sie diese wiederkehrende Gutschein',0),(346248,9618,'en','Delete This Recurring Voucher',0),(346249,9619,'is','',0),(346250,9619,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø«Ø¨ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(346251,9619,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø«Ø¨ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ ',0),(346252,9619,'tr','Yinelenen defter giriÅŸlerini dÃ¼zenleme',0),(346253,9619,'pl','EdytowaÄ‡ cykliczne wpisy do ksiÄ™gi',0),(346254,9619,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(346255,9619,'ur','Ù…Ú©Ø±Ø± Ú©Ú¾Ø§ØªØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(346256,9619,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑšÐ¸Ð³Ðµ',0),(346257,9619,'vi','Chá»‰nh sá»­a má»¥c sá»• káº¿ toÃ¡n Ä‘á»‹nh ká»³',0),(346258,9619,'af','Redigeer Herhaaldende Grootboekinskrywings',0),(346259,9619,'ro','Edita intrÄƒrile din registrul de recurente',0),(346260,9619,'et','Redigeerige korduva andmikukannete',0),(346261,9619,'si','Urejanje ponavljajoÄe se postavke',0),(346262,9619,'ba','Mengedit entri buku besar berulang',0),(346263,9619,'nl','Bewerken periodieke posten',0),(346264,9619,'fi','Muokkaa toistuvat tapahtumat',0),(346265,9619,'no','Redigere regelmessige poster',0),(346266,9619,'da','Redigere tilbagevendende finansposter',0),(346267,9619,'ko','ë˜í’€ì´ ë˜ëŠ” ë ˆì € í•­ëª© íŽ¸ì§‘',0),(346268,9619,'he','×¢×¨×™×›×ª ×¤×§×•×“×•×ª ×™×•×ž×Ÿ ×—×•×–×¨×•×ª',0),(346269,9619,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(346270,9619,'zh','ç¼–è¾‘å‘¨æœŸæ€§èŽ±æ°ä½œå“\r\n',0),(346271,9619,'sv','Redigera Ã¥terkommande transaktioner',0),(346272,9619,'it','Modificare le registrazioni contabili periodiche',0),(346273,9619,'tl','',0),(346274,9619,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3648;&#3585;&#3636;&#3604;&#3595;&#3657;&#3635;',0),(346275,9619,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤²à¥‡à¤œà¤¼à¤° à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(346276,9619,'ms','Edit entri Lejar berulang',0),(346277,9619,'ar','ØªØ­Ø±ÙŠØ± Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ù…ØªÙƒØ±Ù‘Ø±Ø©',0),(346278,9619,'fr','Modifier les Ã©critures pÃ©riodiques',0),(346279,9619,'jp','å®šæœŸçš„ãªç·å‹˜å®šå…ƒå¸³ã®ã‚¨ãƒ³ãƒˆãƒªã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(346280,9619,'pt','Editar entradas de Ledger recorrentes',0),(346281,9619,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ…ÑÑ ÑƒÑ‡Ñ‚ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¹',0),(346282,9619,'es','Editar Entradas de Libro Mayor Recurrentes',0),(346283,9619,'de','Wiederkehrende Posten bearbeiten',0),(346284,9619,'en','Edit Recurring Ledger Entries',0),(346285,9620,'is','',0),(346286,9620,'dr','ÙŠØ§ Ø´ØºÙ„ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(346287,9620,'pr','ÙŠØ§ Ø´ØºÙ„ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(346288,9620,'tr','Veya gerekli iÅŸ seÃ§ilmedi',0),(346289,9620,'pl','Lub wymagane zadanie nie zaznaczone',0),(346290,9620,'bg','Ð˜Ð»Ð¸ Ð¸Ð·Ð¸ÑÐºÐ²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ ÑÐ° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(346291,9620,'ur','ÛŒØ§ Ù…Ø·Ù„ÙˆØ¨Û Ú©Ø§Ù… Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº',0),(346292,9620,'sr','Ð˜Ð»Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°Ð½ Ð¿Ð¾ÑÐ°Ð¾ Ð½Ð¸Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(346293,9620,'vi','Hoáº·c yÃªu cáº§u cÃ´ng viá»‡c khÃ´ng Ä‘Æ°á»£c chá»n',0),(346294,9620,'af','Of Benodig Werkstuk Nie Geselekteer',0),(346295,9620,'ro','Sau cere Job nu selectat',0),(346296,9620,'et','VÃµi vajaminev projekt pole valitud',0),(346297,9620,'si','Ali ustrezen projekt ni izbran',0),(346298,9620,'ba','Atau pekerjaan yang diperlukan tidak dipilih',0),(346299,9620,'nl','Of vereiste baan niet geselecteerd',0),(346300,9620,'fi','Tai tarvittaessa asia ole valittu',0),(346301,9620,'no','Eller prosjektet ikke valgt',0),(346302,9620,'da','Eller krÃ¦ves Job ikke valgt',0),(346303,9620,'ko','ë˜ëŠ” í•„ìš”í•œ ìž‘ì—…ì„ ì„ íƒ í•˜ì§€',0),(346304,9620,'he','××• ××ª ×”×¢×‘×•×“×” ×”× ×“×¨×©×ª ×œ× × ×‘×—×¨',0),(346305,9620,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½Î· ÎµÏÎ³Î±ÏƒÎ¯Î± Î´ÎµÎ½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ Î®',0),(346306,9620,'zh','æˆ–è€…ä¸é€‰æ‹©æ‰€éœ€æœåŠ¡\r\n',0),(346307,9620,'sv','Eller krÃ¤vs jobb inte markerad',0),(346308,9620,'it','O richieste per il processo non selezionata',0),(346309,9620,'tl','',0),(346310,9620,'th','&#3627;&#3619;&#3639;&#3629;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(346311,9620,'hi','à¤¯à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤•à¤¾à¤°à¥à¤¯ à¤¨à¤¹à¥€à¤‚ à¤šà¤¯à¤¨à¤¿à¤¤',0),(346312,9620,'ms','Atau pekerjaan yang dikehendaki tidak dipilih',0),(346313,9620,'ar','Ø£Ùˆ Ø¹Ø¯Ù… ØªØ­Ø¯ÙŠØ¯ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(346314,9620,'fr','Ou dâ€™emploi requis non sÃ©lectionnÃ©',0),(346315,9620,'jp','ã¾ãŸã¯å¿…è¦ãªã‚¸ãƒ§ãƒ–ãŒé¸æŠžã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(346316,9620,'pt','Ou trabalho exigido nÃ£o selecionado',0),(346317,9620,'ru','Ð˜Ð»Ð¸ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(346318,9620,'es','O No se SeleccionÃ³ La Tarea Requerida',0),(346319,9620,'de','Oder gewÃ¼nschten Job nicht ausgewÃ¤hlt',0),(346320,9620,'en','Or Required Job Not Selected',0),(346321,9621,'is','',0),(346322,9621,'dr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(346323,9621,'pr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ',0),(346324,9621,'tr','Maliyet kodu',0),(346325,9621,'pl','Koszt kodu',0),(346326,9621,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÐºÐ¾Ð´',0),(346327,9621,'ur','Ù‚ÛŒÙ…Øª Ú©ÙˆÚˆ',0),(346328,9621,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(346329,9621,'vi','mÃ£ chi phÃ­',0),(346330,9621,'af','Koste Kode',0),(346331,9621,'ro','Codul de cost',0),(346332,9621,'et','Kulude kood',0),(346333,9621,'si','StroÅ¡kovno kodo',0),(346334,9621,'ba','Kode biaya',0),(346335,9621,'nl','Kosten Code',0),(346336,9621,'fi','Kustannuskoodi',0),(346337,9621,'no','Pris kode',0),(346338,9621,'da','Pris kode',0),(346339,9621,'ko','ë¹„ìš©ëœ ì½”ë“œ',0),(346340,9621,'he','×§×•×“ ×¢×œ×•×ª',0),(346341,9621,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ±',0),(346342,9621,'zh','æˆæœ¬ä»£ç \r\n',0),(346343,9621,'sv','Kostnad kod',0),(346344,9621,'it','Codice di costo',0),(346345,9621,'tl','',0),(346346,9621,'th','&#3619;&#3627;&#3633;&#3626;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;',0),(346347,9621,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡',0),(346348,9621,'ms','Kod kos',0),(346349,9621,'ar','Ø±Ù…Ø² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(346350,9621,'fr','Code de coÃ»t',0),(346351,9621,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰',0),(346352,9621,'pt','CÃ³digo de custo',0),(346353,9621,'ru','ÐšÐ¾Ð´ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(346354,9621,'es','CÃ³digo de Costo',0),(346355,9621,'de','Kostencode',0),(346356,9621,'en','Cost Code',0),(346357,9622,'is','',0),(346358,9622,'dr','ÙƒØ¯ Ø´ØºÙ„ ',0),(346359,9622,'pr','ÙƒØ¯ Ø´ØºÙ„ ',0),(346360,9622,'tr','Proje kodu',0),(346361,9622,'pl','Kod pracy',0),(346362,9622,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° ÐºÐ¾Ð´',0),(346363,9622,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Ø§ Ú©ÙˆÚˆ',0),(346364,9622,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð¿Ð¾Ð´Ñ€ÑƒÑ‡Ñ˜Ð°',0),(346365,9622,'vi','mÃ£ cÃ´ng viá»‡c',0),(346366,9622,'af','Werkstuk Kode ',0),(346367,9622,'ro','Job cod',0),(346368,9622,'et','TÃ¶Ã¶ kood',0),(346369,9622,'si','Delovnega mesta kodo',0),(346370,9622,'ba','Kode pekerjaan',0),(346371,9622,'nl','Code van de baan',0),(346372,9622,'fi','Projektin koodin',0),(346373,9622,'no','Jobbkode',0),(346374,9622,'da','Job kode',0),(346375,9622,'ko','ìž‘ì—… ì½”ë“œ',0),(346376,9622,'he','×§×•×“ ×¢×‘×•×“×”',0),(346377,9622,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î­ÏÎ³Î¿Ï…',0),(346378,9622,'zh','å·¥ä½œä»£ç \r\n',0),(346379,9622,'sv','Jobbkod',0),(346380,9622,'it','Codice di lavoro',0),(346381,9622,'tl','',0),(346382,9622,'th','&#3619;&#3627;&#3633;&#3626;&#3591;&#3634;&#3609;',0),(346383,9622,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥‹à¤¡',0),(346384,9622,'ms','Kod kerja',0),(346385,9622,'ar','ÙƒÙˆØ¯ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(346386,9622,'fr','Code du travail',0),(346387,9622,'jp','ã‚¸ãƒ§ãƒ– ã‚³ãƒ¼ãƒ‰',0),(346388,9622,'pt','CÃ³digo do trabalho',0),(346389,9622,'ru','ÐšÐ¾Ð´ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(346390,9622,'es','CÃ³digo de ColcaciÃ³n',0),(346391,9622,'de','Job-Code',0),(346392,9622,'en','Job Code',0),(346393,9623,'is','',0),(346394,9623,'dr','1 ',0),(346395,9623,'pr','Ø³Ø·Ø± Ø¢Ø¯Ø±Ø³  1 ',0),(346396,9623,'tr','Adres satÄ±rÄ± 1',0),(346397,9623,'pl','1. wiersz adresu',0),(346398,9623,'bg','ÐÐ´Ñ€ÐµÑ Ñ€ÐµÐ´ 1',0),(346399,9623,'ur','Ù¾ØªÛ Ú©ÛŒ Ù„Ø§Ø¦Ù† 1',0),(346400,9623,'sr','Ð ÐµÐ´ Ð·Ð° Ð°Ð´Ñ€ÐµÑÑƒ 1',0),(346401,9623,'vi','DÃ²ng Ä‘á»‹a Chá»‰ 1',0),(346402,9623,'af','Adreslyn 1',0),(346403,9623,'ro','Adresa linia 1',0),(346404,9623,'et','Aadressirida 1',0),(346405,9623,'si','Vrstica naslova 1',0),(346406,9623,'ba','Alamat Baris 1',0),(346407,9623,'nl','Adresregel 1',0),(346408,9623,'fi','Rivi 1',0),(346409,9623,'no','Adresselinje 1',0),(346410,9623,'da','Adresselinje 1',0),(346411,9623,'ko','ì£¼ì†Œ ìž…ë ¥ëž€ 1',0),(346412,9623,'he','×©×•×¨×ª ×›×ª×•×‘×ª 1',0),(346413,9623,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·, Î³ÏÎ±Î¼Î¼Î® 1',0),(346414,9623,'zh','åœ°å€è¡Œ1\r\n',0),(346415,9623,'sv','Adress linje 1',0),(346416,9623,'it','Riga indirizzo 1',0),(346417,9623,'tl','',0),(346418,9623,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604; 1',0),(346419,9623,'hi','à¤ªà¤¤à¤¾ à¤ªà¤‚à¤•à¥à¤¤à¤¿ 1',0),(346420,9623,'ms','Alamat baris 1',0),(346421,9623,'ar','Ø³Ø·Ø± Ø§Ù„Ø¹Ù†ÙˆØ§Ù† 1',0),(346422,9623,'fr','Ligne d\'Adresse 1',0),(346423,9623,'jp','ä½æ‰€è¡Œ 1',0),(346424,9623,'pt','Linha de endereÃ§o 1',0),(346425,9623,'ru','ÐÐ´Ñ€ÐµÑ Ð¡Ñ‚Ñ€Ð¾ÐºÐ° 1',0),(346426,9623,'es','DirecciÃ³n Linea 1',0),(346427,9623,'de','Adresszeile 1',0),(346428,9623,'en','Address Line 1',0),(346429,9624,'is','',0),(346430,9624,'dr','2',0),(346431,9624,'pr','Ø³Ø·Ø± Ø¢Ø¯Ø±Ø³   2',0),(346432,9624,'tr','Adres satÄ±rÄ± 2',0),(346433,9624,'pl','2. wiersz adresu',0),(346434,9624,'bg','ÐÐ´Ñ€ÐµÑ Ñ€ÐµÐ´ 2',0),(346435,9624,'ur','Ù¾ØªÛ Ú©ÛŒ Ù„Ø§Ø¦Ù† 2',0),(346436,9624,'sr','Ð ÐµÐ´ Ð·Ð° Ð°Ð´Ñ€ÐµÑÑƒ 2',0),(346437,9624,'vi','DÃ²ng Ä‘á»‹a Chá»‰ 2',0),(346438,9624,'af','Adreslyn 2',0),(346439,9624,'ro','Adresa linia 2',0),(346440,9624,'et','Aadressirida 2',0),(346441,9624,'si','Vrstica naslova 2',0),(346442,9624,'ba','Alamat Baris 2',0),(346443,9624,'nl','Adresregel 2',0),(346444,9624,'fi','Osoiterivi 2',0),(346445,9624,'no','Adresselinje 2',0),(346446,9624,'da','Adresselinje 2',0),(346447,9624,'ko','ì£¼ì†Œ ìž…ë ¥ëž€ 2',0),(346448,9624,'he','×©×•×¨×ª ×›×ª×•×‘×ª 2',0),(346449,9624,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·-Î³ÏÎ±Î¼Î¼Î® 2',0),(346450,9624,'zh','åœ°å€è¡Œ2\r\n',0),(346451,9624,'sv','Adressrad 2',0),(346452,9624,'it','Riga 2 indirizzo',0),(346453,9624,'tl','',0),(346454,9624,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604; 2',0),(346455,9624,'hi','à¤ªà¤¤à¤¾ à¤ªà¤‚à¤•à¥à¤¤à¤¿ 2',0),(346456,9624,'ms','Alamat baris 2',0),(346457,9624,'ar','Ø³Ø·Ø± Ø§Ù„Ø¹Ù†ÙˆØ§Ù† 2',0),(346458,9624,'fr','Ligne d\'Adresse 2',0),(346459,9624,'jp','ä½æ‰€ 2 è¡Œç›®',0),(346460,9624,'pt','Linha de endereÃ§o 2',0),(346461,9624,'ru','ÐÐ´Ñ€ÐµÑ Ð¡Ñ‚Ñ€Ð¾ÐºÐ° 2',0),(346462,9624,'es','DirecciÃ³n Linea 2',0),(346463,9624,'de','Adresszeile 2',0),(346464,9624,'en','Address Line 2',0),(346465,9625,'is','',0),(346466,9625,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¨Ø§ Ø±Ø¯ÙŠÙ Ø¨Ø§Ù„Ø§ ',0),(346467,9625,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¨Ø§ Ø±Ø¯ÙŠÙ Ø¨Ø§Ù„Ø§ ',0),(346468,9625,'tr','GÃ¶rÃ¼ntÃ¼ yukarÄ±daki satÄ±r ile',0),(346469,9625,'pl','WyÅ›wietlacz z wiersz powyÅ¼ej',0),(346470,9625,'bg','Ð”Ð¸ÑÐ¿Ð»ÐµÐ¹ Ñ Ñ€ÐµÐ´ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ',0),(346471,9625,'ur','Ø¨Ø§Ù„Ø§ ØµÙ Ú©Û’ Ø³Ø§ØªÚ¾ Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(346472,9625,'sr','Ð•ÐºÑ€Ð°Ð½ ÑÐ° Ñ€ÐµÐ´ Ð¸Ð·Ð½Ð°Ð´',0),(346473,9625,'vi','Hiá»ƒn thá»‹ vá»›i dÃ²ng á»Ÿ trÃªn',0),(346474,9625,'af','Vetoon Met Boonste Ry',0),(346475,9625,'ro','Display cu rÃ¢nd mai sus',0),(346476,9625,'et','Ekraani kohale',0),(346477,9625,'si','Zaslon z vrstico zgoraj',0),(346478,9625,'ba','Tampilan dengan baris di atas',0),(346479,9625,'nl','Display met rij boven',0),(346480,9625,'fi','NÃ¤yttÃ¶ ylÃ¤puolella',0),(346481,9625,'no','Skjerm med rad over',0),(346482,9625,'da','Display med rÃ¦kke ovenfor',0),(346483,9625,'ko','ìœ„ì˜ í–‰ ë””ìŠ¤í”Œë ˆì´',0),(346484,9625,'he','×¦×’ ×¢× ×©×•×¨×” ×©×ž×¢×œ',0),(346485,9625,'el','ÎŸÎ¸ÏŒÎ½Î· Î¼Îµ Î³ÏÎ±Î¼Î¼Î® Ï€Î¬Î½Ï‰',0),(346486,9625,'zh','ä¸Žä¸Šæ–¹è¡Œä¸€åŒæ˜¾ç¤º\r\n',0),(346487,9625,'sv','Display med raden ovanfÃ¶r',0),(346488,9625,'it','Display con riga sopra',0),(346489,9625,'tl','',0),(346490,9625,'th','&#3649;&#3626;&#3604;&#3591;&#3649;&#3606;&#3623;&#3604;&#3657;&#3634;&#3609;&#3610;&#3609;',0),(346491,9625,'hi','à¤Šà¤ªà¤° à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨',0),(346492,9625,'ms','Paparan dengan baris di atas',0),(346493,9625,'ar','Ø¹Ø±Ø¶ Ù…Ø¹ ØµÙ Ù„Ø£Ø¹Ù„Ù‰',0),(346494,9625,'fr','Affichage avec ligne ci-dessus',0),(346495,9625,'jp','ä¸Šã®è¡Œã®è¡¨ç¤º',0),(346496,9625,'pt','Visor com linha acima',0),(346497,9625,'ru','Ð”Ð¸ÑÐ¿Ð»ÐµÐ¹ Ñ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð²Ñ‹ÑˆÐµ',0),(346498,9625,'es','Desplega con Fila Arriba',0),(346499,9625,'de','Display mit Zeile oben',0),(346500,9625,'en','Display With Row Above',0),(346501,9626,'is','',0),(346502,9626,'dr','ÙÙŠÙ„Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(346503,9626,'pr','ÙÙŠÙ„Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(346504,9626,'tr','Alan baÅŸarÄ±yla kaydedildi',0),(346505,9626,'pl','Pole pomyÅ›lnie zapisany',0),(346506,9626,'bg','ÐŸÐ¾Ð»Ðµ, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(346507,9626,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ù‚Ø·Ø¹Û',0),(346508,9626,'sr','ÐŸÐ¾Ñ™Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(346509,9626,'vi','lÆ°u trÆ°á»ng thÃ nh cÃ´ng',0),(346510,9626,'af','Veld Suksesvol Gestoor',0),(346511,9626,'ro','Teren de salvat cu succes',0),(346512,9626,'et','VÃ¤li salvestati edukalt',0),(346513,9626,'si','PodroÄju uspeÅ¡no shranjen',0),(346514,9626,'ba','Bidang disimpan berhasil',0),(346515,9626,'nl','Veld succesvol opgeslagen',0),(346516,9626,'fi','KenttÃ¤Ã¤n tallennettu',0),(346517,9626,'no','Feltet lagret',0),(346518,9626,'da','Feltet gemt med succes',0),(346519,9626,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” í•„ë“œ',0),(346520,9626,'he','×©×“×” ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(346521,9626,'el','Î ÎµÎ´Î¯Î¿ Ï€Î¿Ï… Î±Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(346522,9626,'zh','å­—æ®µå·²æˆåŠŸä¿å­˜\r\n',0),(346523,9626,'sv','FÃ¤ltet har sparats',0),(346524,9626,'it','Campo salvato correttamente',0),(346525,9626,'tl','',0),(346526,9626,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3615;&#3636;&#3621;&#3604;&#3660;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(346527,9626,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(346528,9626,'ms','Bidang yang berjaya disimpan',0),(346529,9626,'ar','Ø­ÙØ¸ Ø§Ù„Ø­Ù‚Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(346530,9626,'fr','Domaine enregistrÃ© avec succÃ¨s',0),(346531,9626,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚ŒãŸãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(346532,9626,'pt','Campo com sucesso',0),(346533,9626,'ru','ÐŸÐ¾Ð»Ðµ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¾',0),(346534,9626,'es','Campo Guardado Exitosamente',0),(346535,9626,'de','Bereich erfolgreich gespeichert',0),(346536,9626,'en','Field Saved Successfully',0),(346537,9627,'is','',0),(346538,9627,'dr','Ú†Ù¾ ',0),(346539,9627,'pr','Ú†Ù¾ ',0),(346540,9627,'tr','Sol',0),(346541,9627,'pl','Po lewej stronie',0),(346542,9627,'bg','Ð›ÑÐ²',0),(346543,9627,'ur','Ø¨Ø§Ø¦ÛŒÚº Ø·Ø±Ù',0),(346544,9627,'sr','Ð›ÐµÐ²Ð¾',0),(346545,9627,'vi','TrÃ¡i',0),(346546,9627,'af','Links',0),(346547,9627,'ro','StÃ¢nga',0),(346548,9627,'et','Vasakule',0),(346549,9627,'si','Levo',0),(346550,9627,'ba','Kiri',0),(346551,9627,'nl','Links',0),(346552,9627,'fi','Vasemmalle',0),(346553,9627,'no','Venstre',0),(346554,9627,'da','Venstre',0),(346555,9627,'ko','ì™¼ìª½',0),(346556,9627,'he','×©×ž××œ',0),(346557,9627,'el','Î‘ÏÎ¹ÏƒÏ„ÎµÏÎ¬',0),(346558,9627,'zh','å·¦\r\n',0),(346559,9627,'sv','VÃ¤nster',0),(346560,9627,'it','Sinistra',0),(346561,9627,'tl','',0),(346562,9627,'th','&#3595;&#3657;&#3634;&#3618;',0),(346563,9627,'hi','à¤¬à¤¾à¤ˆà¤‚ à¤“à¤°',0),(346564,9627,'ms','Kiri',0),(346565,9627,'ar','Ø§Ù„ÙŠØ³Ø§Ø±',0),(346566,9627,'fr','Gauche',0),(346567,9627,'jp','å·¦',0),(346568,9627,'pt','Esquerda',0),(346569,9627,'ru','Ð¡Ð»ÐµÐ²Ð°',0),(346570,9627,'es','SaliÃ³',0),(346571,9627,'de','Links',0),(346572,9627,'en','Left',0),(346573,9628,'is','',0),(346574,9628,'dr','Ù„ÙŠÙ†Ùƒ Ø´Ø¯Ù‡ Ø¨Ø§ ',0),(346575,9628,'pr','Ù„ÙŠÙ†Ùƒ Ø´Ø¯Ù‡ Ø¨Ø§ ',0),(346576,9628,'tr','Ä°le baÄŸlantÄ±lÄ±',0),(346577,9628,'pl','PowiÄ…zany z',0),(346578,9628,'bg','Ð¡Ð²ÑŠÑ€Ð·Ð°Ð½ Ñ',0),(346579,9628,'ur','Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ù†Ø³Ù„Ú©',0),(346580,9628,'sr','ÐšÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð¿Ð¾Ð²ÐµÐ·Ð°Ð½ ÑÐ°',0),(346581,9628,'vi','Ä‘Æ°á»£c káº¿t ná»‘i vá»›i',0),(346582,9628,'af','Geskakel Met',0),(346583,9628,'ro','ÃŽn legÄƒturÄƒ cu',0),(346584,9628,'et','Seotud',0),(346585,9628,'si','Povezana z',0),(346586,9628,'ba','Terkait dengan',0),(346587,9628,'nl','Verbonden met',0),(346588,9628,'fi','Liittyy',0),(346589,9628,'no','Knyttet til',0),(346590,9628,'da','Forbundet med',0),(346591,9628,'ko','ì—°ê²°',0),(346592,9628,'he','×ž×§×•×©×¨ ×¢×',0),(346593,9628,'el','Î Î¿Ï… ÏƒÏ…Î½Î´Î­Î¿Î½Ï„Î±Î¹ Î¼Îµ',0),(346594,9628,'zh','ä¸Žé“¾æŽ¥\r\n',0),(346595,9628,'sv','Kopplad till',0),(346596,9628,'it','Collegata con',0),(346597,9628,'tl','',0),(346598,9628,'th','&#3621;&#3636;&#3591;&#3588;&#3660;&#3585;&#3633;&#3610;',0),(346599,9628,'hi','à¤•à¥‡ à¤¸à¤¾à¤¥ à¤œà¥à¤¡à¤¼à¥‡',0),(346600,9628,'ms','Berkaitan dengan',0),(346601,9628,'ar','Ù…Ø±ØªØ¨Ø· Ø¨Ù€',0),(346602,9628,'fr','LiÃ© Ã ',0),(346603,9628,'jp','é€£å‹•',0),(346604,9628,'pt','Ligado com',0),(346605,9628,'ru','Ð¡Ð²ÑÐ·Ð°Ð½Ð½Ñ‹Ðµ Ñ',0),(346606,9628,'es','Conectado Con',0),(346607,9628,'de','Im Zusammenhang mit',0),(346608,9628,'en','Linked With',0),(346609,9629,'is','',0),(346610,9629,'dr','Ù„ÙŠÙ†Ùƒ Ø¨Ù‡ ÙÙŠÙ„Ø¯ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(346611,9629,'pr','Ù„ÙŠÙ†Ùƒ Ø¨Ù‡ ÙÙŠÙ„Ø¯ Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(346612,9629,'tr','BaÄŸlantÄ±yÄ± mÃ¼ÅŸteri alanÄ±na',0),(346613,9629,'pl','Link do odbiorcy pole',0),(346614,9629,'bg','Ð’Ñ€ÑŠÐ·ÐºÐ° ÐºÑŠÐ¼ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ð¾Ð»Ðµ',0),(346615,9629,'ur','Ú©Ø³Ù¹Ù…Ø± Ù‚Ø·Ø¹Û Ú©Û’ Ù„ÛŒÛ’ Ø±Ø¨Ø·',0),(346616,9629,'sr','ÐŸÐ¾Ð²ÐµÐ¶Ð¸ ÑÐ° Ð¿Ð¾Ñ™Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(346617,9629,'vi','ÄÆ°á»ng dáº«n tá»›i trÆ°á»ng khÃ¡ch hÃ ng',0),(346618,9629,'af','Koppel Aan Klant/KliÃ«nt Velde',0),(346619,9629,'ro','Link-ul de la client cÃ¢mp',0),(346620,9629,'et','Link vÃ¤ljale',0),(346621,9629,'si','Povezava do kupca polje',0),(346622,9629,'ba','Link ke pelanggan Field',0),(346623,9629,'nl','Link naar het veld klant',0),(346624,9629,'fi','Linkki kenttÃ¤Ã¤n',0),(346625,9629,'no','Link til kunde-feltet',0),(346626,9629,'da','Link til kunden felt',0),(346627,9629,'ko','ê³ ê° í•„ë“œì— ë§í¬',0),(346628,9629,'he','×§×™×©×•×¨ ×œ×©×“×” ×”×œ×§×•×—',0),(346629,9629,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Î¼Îµ Ï„Î¿ Ï€ÎµÎ´Î¯Î¿ \"Ï€ÎµÎ»Î¬Ï„Î·Ï‚\"',0),(346630,9629,'zh','é“¾æŽ¥åˆ°ç”¨æˆ·å­—æ®µ\r\n',0),(346631,9629,'sv','LÃ¤nk till kund',0),(346632,9629,'it','Link al campo cliente',0),(346633,9629,'tl','',0),(346634,9629,'th','&#3621;&#3636;&#3591;&#3588;&#3660;&#3652;&#3611;&#3615;&#3636;&#3621;&#3604;&#3660;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(346635,9629,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤«à¤¼à¥€à¤²à¥à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¿à¤‚à¤•',0),(346636,9629,'ms','Pautan ke bidang Baca',0),(346637,9629,'ar','Ø±Ø§Ø¨Ø· Ø¥Ù„Ù‰ Ø­Ù‚Ù„ Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(346638,9629,'fr','Lien vers le champ client',0),(346639,9629,'jp','ãŠå®¢æ§˜ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã¸ã®ãƒªãƒ³ã‚¯',0),(346640,9629,'pt','Link para o campo do cliente',0),(346641,9629,'ru','Ð¡ÑÑ‹Ð»ÐºÐ° Ð½Ð° Ð¿Ð¾Ð»Ðµ Customer',0),(346642,9629,'es','Vincular al Campo del Cliente',0),(346643,9629,'de','Link zum Kunden-Bereich',0),(346644,9629,'en','Link To Customer Field',0),(346645,9630,'is','',0),(346646,9630,'dr','1',0),(346647,9630,'pr','Ù†Ø¸Ø± ØªÙ„ÙÙ†  1',0),(346648,9630,'tr','Telefon 1 yorum',0),(346649,9630,'pl','Telefon 1 komentarz',0),(346650,9630,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 1 ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(346651,9630,'ur','ÙÙˆÙ† 1 ØªØ¨ØµØ±Û',0),(346652,9630,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 1 ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(346653,9630,'vi','bÃ¬nh luáº­n phone 1',0),(346654,9630,'af','Telefoon 1 Opmerking',0),(346655,9630,'ro','Telefon 1 comentariu',0),(346656,9630,'et','Telefoni 1 kommentaar',0),(346657,9630,'si','Telefon 1 komentar',0),(346658,9630,'ba','Telepon 1 komentar',0),(346659,9630,'nl','Telefoon 1 reactie',0),(346660,9630,'fi','Puhelin 1 kommentti',0),(346661,9630,'no','Telefonnummer 1 kommentar',0),(346662,9630,'da','Telefon 1 kommentar',0),(346663,9630,'ko','ì „í™” 1 ì½”ë©˜íŠ¸',0),(346664,9630,'he','×˜×œ×¤×•×Ÿ 1 ×ª×’×•×‘×”',0),(346665,9630,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ 1 ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(346666,9630,'zh','ç”µè¯1è¯„è®º\r\n',0),(346667,9630,'sv','Telefon 1 kommentar',0),(346668,9630,'it','Telefono cellulare 1 commento',0),(346669,9630,'tl','',0),(346670,9630,'th','&#3649;&#3626;&#3604;&#3591;&#3588;&#3623;&#3634;&#3617;&#3588;&#3636;&#3604;&#3648;&#3627;&#3655;&#3609;&#3607;&#3634;&#3591;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660; 1',0),(346671,9630,'hi','à¤«à¤¼à¥‹à¤¨ 1 à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€',0),(346672,9630,'ms','Telefon 1 Comment',0),(346673,9630,'ar','ØªØ¹Ù„ÙŠÙ‚ Ø§Ù„Ù‡Ø§ØªÙ 1',0),(346674,9630,'fr','TÃ©lÃ©phone 1 commentaire',0),(346675,9630,'jp','æºå¸¯é›»è©±ã® 1 ã¤ã®ã‚³ãƒ¡ãƒ³ãƒˆ',0),(346676,9630,'pt','Telefone 1 comentÃ¡rio',0),(346677,9630,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ 1 ÐšÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¸',0),(346678,9630,'es','TelÃ©fono 1 Comentario',0),(346679,9630,'de','Telefon 1 Kommentar',0),(346680,9630,'en','Phone 1 Comment',0),(346681,9631,'is','',0),(346682,9631,'dr','2',0),(346683,9631,'pr','Ù†Ø¸Ø± ØªÙ„ÙÙ†  2',0),(346684,9631,'tr','Telefon 2 yorum',0),(346685,9631,'pl','Telefon 2 komentarz',0),(346686,9631,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 2 ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(346687,9631,'ur','ÙÙˆÙ† 2 ØªØ¨ØµØ±Û',0),(346688,9631,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 2 ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð°',0),(346689,9631,'vi','bÃ¬nh luáº­n phone 2',0),(346690,9631,'af','Telefoon 2 Opmerking',0),(346691,9631,'ro','Telefon 2 comentariu',0),(346692,9631,'et','Telefoni 2 kommentaar',0),(346693,9631,'si','Telefon 2 komentar',0),(346694,9631,'ba','Telepon 2 komentar',0),(346695,9631,'nl','Telefoon 2 commentaar',0),(346696,9631,'fi','Puhelin 2 kommenttia',0),(346697,9631,'no','Telefon 2 kommentar',0),(346698,9631,'da','Telefon 2 kommentar',0),(346699,9631,'ko','ì „í™” 2 ì½”ë©˜íŠ¸',0),(346700,9631,'he','×˜×œ×¤×•×Ÿ 2 ×”×¢×¨×•×ª',0),(346701,9631,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ 2 ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(346702,9631,'zh','ç”µè¯2è¯„è®º\r\n',0),(346703,9631,'sv','Telefon 2 kommentar',0),(346704,9631,'it','Commento di telefono 2',0),(346705,9631,'tl','',0),(346706,9631,'th','&#3649;&#3626;&#3604;&#3591;&#3588;&#3623;&#3634;&#3617;&#3588;&#3636;&#3604;&#3648;&#3627;&#3655;&#3609;&#3607;&#3634;&#3591;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660; 2',0),(346707,9631,'hi','à¤«à¤¼à¥‹à¤¨ 2 à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€',0),(346708,9631,'ms','Telefon 2 Komen',0),(346709,9631,'ar','ØªØ¹Ù„ÙŠÙ‚ Ø§Ù„Ù‡Ø§ØªÙ 2',0),(346710,9631,'fr','Commentaire de tÃ©lÃ©phone 2',0),(346711,9631,'jp','é›»è©± 2 ã‚³ãƒ¡ãƒ³ãƒˆ',0),(346712,9631,'pt','ComentÃ¡rio de telefone 2',0),(346713,9631,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ñ‹Ð¹ ÐÐ¾Ð¼ÐµÑ€ 2 ÐšÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¸',0),(346714,9631,'es','TelÃ©fono 2 Comentario',0),(346715,9631,'de','Telefon 2 Kommentar',0),(346716,9631,'en','Phone 2 Comment',0),(346717,9632,'is','',0),(346718,9632,'dr','Ù…Ø­Ù„ Ø¹Ù†ÙˆØ§Ù† ',0),(346719,9632,'pr','Ù…Ø­Ù„ Ø¹Ù†ÙˆØ§Ù† ',0),(346720,9632,'tr','BaÅŸlÄ±k yer',0),(346721,9632,'pl','Nazwa lokalizacji',0),(346722,9632,'bg','Ð”ÑÐ» Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(346723,9632,'ur','Ø¹Ù†ÙˆØ§Ù† Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(346724,9632,'sr','ÐÐ°Ð·Ð¸Ð² Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(346725,9632,'vi','TiÃªu Ä‘á» vá»‹ trÃ­',0),(346726,9632,'af','Liggingstitel',0),(346727,9632,'ro','Titlu locaÅ£ie',0),(346728,9632,'et','Pealkirja asukoht',0),(346729,9632,'si','Naslov lokacije',0),(346730,9632,'ba','Judul lokasi',0),(346731,9632,'nl','Locatie van de titel',0),(346732,9632,'fi','Otsikon sijainti',0),(346733,9632,'no','Tittel sted',0),(346734,9632,'da','Titel beliggenhed',0),(346735,9632,'ko','ì œëª© ìœ„ì¹˜',0),(346736,9632,'he','×ž×™×§×•× ×”×›×•×ª×¨×ª',0),(346737,9632,'el','Î¤Î¯Ï„Î»Î¿Ï‚ Î¸Î­ÏƒÎ·Ï‚',0),(346738,9632,'zh','æ ‡é¢˜ä½ç½®\r\n',0),(346739,9632,'sv','Titel lÃ¤ge',0),(346740,9632,'it','Titolo posizione',0),(346741,9632,'tl','',0),(346742,9632,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3605;&#3657;&#3609;&#3648;&#3619;&#3639;&#3656;&#3629;&#3591;',0),(346743,9632,'hi','à¤¶à¥€à¤°à¥à¤·à¤• à¤¸à¥à¤¥à¤¾à¤¨',0),(346744,9632,'ms','Tajuk lokasi',0),(346745,9632,'ar','Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(346746,9632,'fr','Emplacement du titre',0),(346747,9632,'jp','ã‚¿ã‚¤ãƒˆãƒ«ã®å ´æ‰€',0),(346748,9632,'pt','LocalizaÃ§Ã£o de tÃ­tulo',0),(346749,9632,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(346750,9632,'es','Lugar de Titulo',0),(346751,9632,'de','Titel Standort',0),(346752,9632,'en','Title Location',0),(346753,9633,'is','',0),(346754,9633,'dr','Ø¨Ø§Ù„Ø§',0),(346755,9633,'pr','Ø¨Ø§Ù„Ø§',0),(346756,9633,'tr','SayfanÄ±n ÃœstÃ¼',0),(346757,9633,'pl','Do gÃ³ry',0),(346758,9633,'bg','Ð¢Ð¾Ð¿',0),(346759,9633,'ur','Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø±',0),(346760,9633,'sr','Ð’Ñ€Ñ…',0),(346761,9633,'vi','Ä‘áº§u',0),(346762,9633,'af','Bokant',0),(346763,9633,'ro','Top',0),(346764,9633,'et','Top',0),(346765,9633,'si','Vrh',0),(346766,9633,'ba','Atas',0),(346767,9633,'nl','Boven',0),(346768,9633,'fi','Alkuun',0),(346769,9633,'no','Topp',0),(346770,9633,'da','Top',0),(346771,9633,'ko','ë§¨ ìœ„ë¡œ',0),(346772,9633,'he','×”×¢×œ×™×•×Ÿ',0),(346773,9633,'el','ÎšÎ¿ÏÏ…Ï†Î®',0),(346774,9633,'zh','é¡¶éƒ¨',0),(346775,9633,'sv','Topp',0),(346776,9633,'it','In alto',0),(346777,9633,'tl','',0),(346778,9633,'th','&#3604;&#3657;&#3634;&#3609;&#3610;&#3609;',0),(346779,9633,'hi','à¤¶à¥€à¤°à¥à¤·',0),(346780,9633,'ms','Atas',0),(346781,9633,'ar','Ø£Ø¹Ù„Ù‰',0),(346782,9633,'fr','Retour au dÃ©but',0),(346783,9633,'jp','ãƒšãƒ¼ã‚¸ã®ãƒˆãƒƒãƒ—ã¸',0),(346784,9633,'pt','InÃ­cio',0),(346785,9633,'ru','Ð’Ð²ÐµÑ€Ñ…',0),(346786,9633,'es','Encima',0),(346787,9633,'de','Nach oben',0),(346788,9633,'en','Top',0),(346789,9634,'is','',0),(346790,9634,'dr','Ø¯Ø±ØµØ¯ Ø¹Ø±Ø¶ ',0),(346791,9634,'pr','Ø¯Ø±ØµØ¯ Ø¹Ø±Ø¶ ',0),(346792,9634,'tr','GeniÅŸliÄŸi %',0),(346793,9634,'pl','SzerokoÅ›Ä‡ %',0),(346794,9634,'bg','Ð¨Ð¸Ñ€Ð¸Ð½Ð° %',0),(346795,9634,'ur','Ú†ÙˆÚ‘Ø§Ø¦ÛŒ %',0),(346796,9634,'sr','Ð¨Ð¸Ñ€Ð¸Ð½Ð° %',0),(346797,9634,'vi','Pháº§n trÄƒm chiá»u rá»™ng',0),(346798,9634,'af','Wydte %',0),(346799,9634,'ro','LÄƒÅ£imea %',0),(346800,9634,'et','Laius %',0),(346801,9634,'si','Å irina %',0),(346802,9634,'ba','Lebar %',0),(346803,9634,'nl','Breedte %',0),(346804,9634,'fi','Leveys %',0),(346805,9634,'no','Bredde %',0),(346806,9634,'da','Bredde %',0),(346807,9634,'ko','í­ %',0),(346808,9634,'he','×¨×•×—×‘ %',0),(346809,9634,'el','Î Î»Î¬Ï„Î¿Ï‚ %',0),(346810,9634,'zh','å®½åº¦ï¼…\r\n',0),(346811,9634,'sv','Bredd %',0),(346812,9634,'it','Larghezza %',0),(346813,9634,'tl','',0),(346814,9634,'th','&#3588;&#3623;&#3634;&#3617;&#3585;&#3623;&#3657;&#3634;&#3591; %',0),(346815,9634,'hi','à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ %',0),(346816,9634,'ms','Lebar %',0),(346817,9634,'ar','% Ø¹Ø±Ø¶',0),(346818,9634,'fr','% De la largeur',0),(346819,9634,'jp','å¹… %',0),(346820,9634,'pt','% De largura',0),(346821,9634,'ru','Ð¨Ð¸Ñ€Ð¸Ð½Ð° %',0),(346822,9634,'es','Anchura %',0),(346823,9634,'de','Breite %',0),(346824,9634,'en','Width %',0),(346825,9635,'is','',0),(346826,9635,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ø§Ù†ØªØ®Ø§Ø¨ ',0),(346827,9635,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ø§Ù†ØªØ®Ø§Ø¨ ',0),(346828,9635,'tr','SayÄ± artÄ± seÃ§in',0),(346829,9635,'pl','Numer i wybierz',0),(346830,9635,'bg','Ð‘Ñ€Ð¾Ð¹ Ð¿Ð»ÑŽÑ Ð¸Ð·Ð±Ð¾Ñ€',0),(346831,9635,'ur','ØªØ¹Ø¯Ø§Ø¯ Ú©Û’ Ø¹Ù„Ø§ÙˆÛ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(346832,9635,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐŸÐ»ÑƒÑ Ð¸Ð·Ð±Ð¾Ñ€',0),(346833,9635,'vi','sá»‘ cá»™ng lá»±a chá»n',0),(346834,9635,'af','Getal Plus kies',0),(346835,9635,'ro','NumÄƒrul Plus Select',0),(346836,9635,'et','Number ja valige',0),(346837,9635,'si','Å tevilko ter izberite',0),(346838,9635,'ba','Nomor ditambah pilih',0),(346839,9635,'nl','Nummer Plus selecteren',0),(346840,9635,'fi','Numero ja valitse',0),(346841,9635,'no','Tall pluss Velg',0),(346842,9635,'da','Antal Plus VÃ¦lg',0),(346843,9635,'ko','ìˆ«ìž ë”í•˜ê¸° ì„ íƒ',0),(346844,9635,'he','×ž×¡×¤×¨ ×¤×œ×•×¡ ×‘×—×¨',0),(346845,9635,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÏƒÏ…Î½ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ',0),(346846,9635,'zh','åŠ æ•°é€‰æ‹©\r\n',0),(346847,9635,'sv','Antalet Plus VÃ¤lj',0),(346848,9635,'it','Numero piÃ¹ Select',0),(346849,9635,'tl','',0),(346850,9635,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3592;&#3635;&#3609;&#3623;&#3609;&#3610;&#3623;&#3585;',0),(346851,9635,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(346852,9635,'ms','Nombor Plus Pilih',0),(346853,9635,'ar','Ø¹Ø¯Ø¯ Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ ØªØ­Ø¯ÙŠØ¯',0),(346854,9635,'fr','Nombre Plus Select',0),(346855,9635,'jp','æ•°ã‚’åŠ ãˆãŸé¸æŠž',0),(346856,9635,'pt','NÃºmero mais Select',0),(346857,9635,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¿Ð»ÑŽÑ Ð²Ñ‹Ð±Ð¾Ñ€',0),(346858,9635,'es','NÃºmero Plus Seleccionar',0),(346859,9635,'de','Anzahl Plus wÃ¤hlen Sie',0),(346860,9635,'en','Number Plus Select',0),(346861,9636,'is','',0),(346862,9636,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø±  ÙŠÙƒ Ù†Ø§Ø¸Ø± Ø¨Ø§Ø´ÙŠØ¯ ',0),(346863,9636,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø¨Ø±Ø§ÙŠ ÙˆÙŠØ±Ø§ÙŠØ´ Ø­Ù‚ÙˆÙ‚ ÙƒØ§Ø±Ø¨Ø±  ÙŠÙƒ Ù†Ø§Ø¸Ø± Ø¨Ø§Ø´ÙŠØ¯ ',0),(346864,9636,'tr','KullanÄ±cÄ± haklarÄ±nÄ± dÃ¼zenlemek iÃ§in bir yÃ¶netici olmanÄ±z gerekir',0),(346865,9636,'pl','Musi byÄ‡ przeÅ‚oÅ¼ony do prawa uÅ¼ytkownika do edycji',0),(346866,9636,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð½Ð°Ð´Ð·Ð¾Ñ€ÐµÐ½ Ð¾Ñ€Ð³Ð°Ð½ Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð²Ð°',0),(346867,9636,'ur','Ø¢Ù¾ ØµØ§Ø±Ù Ú©Û’ Ø­Ù‚ÙˆÙ‚ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ø³Ù¾Ø±ÙˆØ§Ø¦Ø²Ø± ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(346868,9636,'sr','Ð¢Ð¸ Ð¼Ð¾Ñ€Ð° Ð´Ð° ÑÐ¸ ÑÑƒÐ¿ÐµÑ€Ð²Ð¸Ð·Ð¾Ñ€ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸Ñ… Ð¿Ñ€Ð°Ð²Ð°',0),(346869,9636,'vi','Báº¡n pháº£i lÃ  ngÆ°á»i giÃ¡m sÃ¡t Ä‘á»ƒ chá»‰nh sá»­a cÃ¡c quyá»n sá»­ dá»¥ng',0),(346870,9636,'af','U Moet \'n Toesighouer wees om Gebruikerregte te Redigeer',0),(346871,9636,'ro','Trebuie sÄƒ aveÅ£i un supraveghetor pentru a edita drepturile de utilizator',0),(346872,9636,'et','Te peate olema peakasutaja, et muuta kasutajaÃµigusi',0),(346873,9636,'si','Morate biti nadzornik za urejanje pravic uporabnikov',0),(346874,9636,'ba','Anda harus menjadi seorang Supervisor untuk mengedit hak pengguna',0),(346875,9636,'nl','U moet een toezichthouder voor het bewerken van gebruikersrechten',0),(346876,9636,'fi','Sinun tÃ¤ytyy olla Esimies voi muokata kÃ¤yttÃ¶oikeuksia',0),(346877,9636,'no','Du mÃ¥ vÃ¦re en veileder redigere rettigheter',0),(346878,9636,'da','Du skal vÃ¦re en vejleder til at redigere brugerrettigheder',0),(346879,9636,'ko','ì‚¬ìš©ìž ê¶Œí•œì„ íŽ¸ì§‘ í•˜ë ¤ë©´ ê´€ë¦¬ìž ì—¬ì•¼ í•©ë‹ˆë‹¤.',0),(346880,9636,'he','××ª×” ×—×™×™×‘ ×œ×”×™×•×ª ×ž×¤×§×— ×œ×¢×¨×•×š ×–×›×•×™×•×ª ×ž×©×ª×ž×©',0),(346881,9636,'el','Î˜Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Î½Î±Î½ ÎµÏ€ÏŒÏ€Ï„Î· Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï‡ÏÎ®ÏƒÏ„Î·',0),(346882,9636,'zh','ä½ å¿…é¡»æ˜¯ä¸€ä¸ªä¸»ç®¡ç¼–è¾‘ç”¨æˆ·æƒé™\r\n',0),(346883,9636,'sv','Du mÃ¥ste vara en handledare att redigera anvÃ¤ndarrÃ¤ttigheter',0),(346884,9636,'it','Ãˆ necessario essere un supervisore per modificare i diritti utente',0),(346885,9636,'tl','',0),(346886,9636,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3648;&#3611;&#3655;&#3609;&#3627;&#3657;&#3623;&#3627;&#3609;&#3657;&#3634;&#3606;&#3638;&#3591;&#3592;&#3632;&#3649;&#3585;&#3657;&#3652;&#3586;&#3626;&#3636;&#3607;&#3608;&#3636;&#3586;&#3629;&#3591;&#3',0),(346887,9636,'hi','à¤†à¤ª à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤ªà¤°à¥à¤¯à¤µà¥‡à¤•à¥à¤·à¤• à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(346888,9636,'ms','Anda mesti menjadi seorang penyelia untuk mengedit hak pengguna',0),(346889,9636,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ø£Ù† ØªÙƒÙˆÙ† Ù…Ø´Ø±ÙØ§ Ø­ØªÙ‰ ØªØªÙ…ÙƒÙ† Ù…Ù† ØªØ­Ø±ÙŠØ± Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(346890,9636,'fr','Vous devez Ãªtre un superviseur pour modifier les droits dâ€™utilisateur',0),(346891,9636,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©é™ã‚’ç·¨é›†ã™ã‚‹ã®ã«ã¯ã‚¹ãƒ¼ãƒ‘ãƒ¼ãƒã‚¤ã‚¶ãƒ¼ã‚’ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(346892,9636,'pt','VocÃª deve ser um Supervisor para editar direitos de usuÃ¡rio',0),(346893,9636,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ ÑÑƒÐ¿ÐµÑ€Ð²Ð°Ð¹Ð·ÐµÑ€ Ð´Ð»Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð°Ð² Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(346894,9636,'es','Tiene Que Ser un Supervisor Para Editar Derechos del Usuario',0),(346895,9636,'de','Sie mÃ¼ssen ein Supervisor, Benutzerrechte zu bearbeiten sein.',0),(346896,9636,'en','You Must Be A Supervisor To Edit User Rights',0),(346897,9637,'is','',0),(346898,9637,'dr','ØªØ§ÙŠÙŠØ¯ Ø§Ø±Ø¬Ø§Ø¹ ÙØ±Ù…',0),(346899,9637,'pr','ØªØ§ÙŠÙŠØ¯ Ø§Ø±Ø¬Ø§Ø¹ ÙØ±Ù…',0),(346900,9637,'tr','Form gÃ¶ndermeyi Onayla',0),(346901,9637,'pl','Potwierdzenie zÅ‚oÅ¼enia formularza',0),(346902,9637,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€Ð°',0),(346903,9637,'ur','ÙØ§Ø±Ù… Ø¬Ù…Ø¹ Ú©Ø±Ø§Ù†Û’ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(346904,9637,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸ Ð¿Ñ€Ð¾ÑÐ»ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ†Ð°',0),(346905,9637,'vi','Ä‘á»‡ trÃ¬nh máº«u xÃ¡c nháº­n',0),(346906,9637,'af','Bevestig Vorm Inhandiging',0),(346907,9637,'ro','ConfirmaÅ£i trimiterea formularului',0),(346908,9637,'et','Kinnita vormi sisu',0),(346909,9637,'si','Potrdite poÅ¡iljanje obrazcev',0),(346910,9637,'ba','Konfirmasi pengiriman Form',0),(346911,9637,'nl','Indienen van formulieren te bevestigen',0),(346912,9637,'fi','Vahvista lomakkeen lÃ¤hettÃ¤minen',0),(346913,9637,'no','Bekrefte skjemainnsending',0),(346914,9637,'da','BekrÃ¦fte formularafsendelse',0),(346915,9637,'ko','ì–‘ì‹ ì œì¶œ í™•ì¸',0),(346916,9637,'he','×œ××©×¨ ×©×œ×™×—×ª ×”×˜×•×¤×¡',0),(346917,9637,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Ï…Ï€Î¿Î²Î¿Î»Î®Ï‚ Ï†ÏŒÏÎ¼Î±Ï‚',0),(346918,9637,'zh','ç¡®è®¤è¡¨å•æäº¤\r\n',0),(346919,9637,'sv','BekrÃ¤fta formulÃ¤rÃ¶verfÃ¶ringen',0),(346920,9637,'it','Confermare l\'invio del modulo',0),(346921,9637,'tl','',0),(346922,9637,'th','&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3649;&#3610;&#3610;&#3615;&#3629;&#3619;&#3660;&#3617;',0),(346923,9637,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤¸à¤¬à¤®à¤¿à¤¶à¤¨ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿',0),(346924,9637,'ms','Mengesahkan penghantaran borang',0),(346925,9637,'ar','ØªØ£ÙƒÙŠØ¯ Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ù†Ù…ÙˆØ°Ø¬',0),(346926,9637,'fr','Confirmer lâ€™envoi dâ€™un formulaire',0),(346927,9637,'jp','ãƒ•ã‚©ãƒ¼ãƒ ã®é€ä¿¡ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(346928,9637,'pt','Confirmar o envio do formulÃ¡rio',0),(346929,9637,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ Ñ„Ð¾Ñ€Ð¼Ñ‹',0),(346930,9637,'es','Confirma la Forma de SumisiÃ³n',0),(346931,9637,'de','Ãœbermittlung des Formulars zu bestÃ¤tigen',0),(346932,9637,'en','Confirm Form Submission',0),(346933,9638,'is','',0),(346934,9638,'dr','Ù„Ø·ÙØ§ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ø¶Ø±ÙˆØ±ÙŠ Ø±Ø§ ÙƒØ§Ù…Ù„ ÙƒÙ†ÙŠØ¯ ',0),(346935,9638,'pr','Ù„Ø·ÙØ§ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ø¶Ø±ÙˆØ±ÙŠ Ø±Ø§ ÙƒØ§Ù…Ù„ ÙƒÙ†ÙŠØ¯ ',0),(346936,9638,'tr','Gerekli alan doldurunuz',0),(346937,9638,'pl','ProszÄ™ wypeÅ‚niÄ‡ wymagane pola',0),(346938,9638,'bg','ÐœÐ¾Ð»Ñ, Ð¿Ð¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¿Ð¾Ð»Ðµ',0),(346939,9638,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù…Ø·Ù„ÙˆØ¨Û ÙÛŒÙ„Úˆ Ù…Ú©Ù…Ù„',0),(346940,9638,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ, Ð¿Ð¾Ð¿ÑƒÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð¿Ð¾Ñ™Ð°',0),(346941,9638,'vi','vui lÃ²ng hoÃ n thÃ nh trÆ°á»ng Ä‘Æ°á»£c yÃªu cáº§u',0),(346942,9638,'af','Voltooi Asseblief die Benodigde Veld',0),(346943,9638,'ro','VÄƒ rugÄƒm sÄƒ completaÅ£i cÃ¢mp obligatoriu',0),(346944,9638,'et','Palun tÃ¤ida nÃµutud vÃ¤li',0),(346945,9638,'si','Izpolnite zahtevana polja',0),(346946,9638,'ba','Lengkapi bidang yang diperlukan',0),(346947,9638,'nl','Vul de verplichte velden',0),(346948,9638,'fi','TÃ¤ytÃ¤ vaadittu kenttÃ¤',0),(346949,9638,'no','Fyll obligatorisk felt',0),(346950,9638,'da','Udfyld feltet skal udfyldes',0),(346951,9638,'ko','í•„ìˆ˜ í•„ë“œë¥¼ ìž‘ì„± í•˜ì‹­ì‹œì˜¤',0),(346952,9638,'he','×× × ×ž×œ× ×©×“×” ×—×•×‘×”',0),(346953,9638,'el','Î Î±ÏÎ±ÎºÎ±Î»ÎµÎ¯ÏƒÎ¸Îµ Î½Î± ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÏƒÎµÏ„Îµ Ï„Î¿ Î±Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½Î¿ Ï€ÎµÎ´Î¯Î¿',0),(346954,9638,'zh','è¯·å¡«å†™å¿…å¡«å­—æ®µ\r\n',0),(346955,9638,'sv','VÃ¤nligen fyll i obligatoriska fÃ¤lt',0),(346956,9638,'it','Compilare il campo obbligatorio',0),(346957,9638,'tl','',0),(346958,9638,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3585;&#3619;&#3629;&#3585;&#3615;&#3636;&#3621;&#3604;&#3660;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(346959,9638,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤«à¤¼à¥€à¤²à¥à¤¡ à¤­à¤°à¥‡à¤‚',0),(346960,9638,'ms','Sila lengkapkan butir-butir mandatori',0),(346961,9638,'ar','ÙŠØ±Ø¬Ù‰ Ø¥ÙƒÙ…Ø§Ù„ Ø§Ù„Ø­Ù‚Ù„ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨',0),(346962,9638,'fr','Veuillez remplir le champ obligatoire',0),(346963,9638,'jp','å¿…è¦ãªãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(346964,9638,'pt','Por favor, preencha o campo obrigatÃ³rio',0),(346965,9638,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð·Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚Ðµ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¿Ð¾Ð»Ñ',0),(346966,9638,'es','Por favor Completar el Campo Requerido',0),(346967,9638,'de','Bitte fÃ¼llen Sie erforderliches Feld',0),(346968,9638,'en','Please Complete Required Field',0),(346969,9639,'is','',0),(346970,9639,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(346971,9639,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(346972,9639,'tr','LÃ¼tfen bir parola girin',0),(346973,9639,'pl','ProszÄ™ wpisaÄ‡ hasÅ‚o',0),(346974,9639,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(346975,9639,'ur','Ø§ÛŒÚ© Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(346976,9639,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ',0),(346977,9639,'vi','vui lÃ²ng nháº­p máº­t kháº©u',0),(346978,9639,'af','Voer asb. \'n Wagwoord in',0),(346979,9639,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i o parolÄƒ',0),(346980,9639,'et','Palun sisesta salasÃµna',0),(346981,9639,'si','Prosimo, vnesite geslo',0),(346982,9639,'ba','Silakan masukkan sandi',0),(346983,9639,'nl','Voer a.u.b. een wachtwoord',0),(346984,9639,'fi','Kirjoita salasana',0),(346985,9639,'no','Skriv inn et passord',0),(346986,9639,'da','Angiv en adgangskode',0),(346987,9639,'ko','ì•”í˜¸ë¥¼ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤',0),(346988,9639,'he','×”×–×Ÿ ×¡×™×¡×ž×”',0),(346989,9639,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Ï€Î»Î·ÎºÏ„ÏÎ¿Î»ÏŒÎ³Î·ÏƒÎµ Î­Î½Î±Î½ ÎºÏ‰Î´Î¹ÎºÏŒ',0),(346990,9639,'zh','è¯·è¾“å…¥å¯†ç \r\n',0),(346991,9639,'sv','Ange ett lÃ¶senord',0),(346992,9639,'it','Per favore Inserisci una Password',0),(346993,9639,'tl','',0),(346994,9639,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3611;&#3657;&#3629;&#3609;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;',0),(346995,9639,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(346996,9639,'ms','Sila masukkan kata laluan',0),(346997,9639,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ±',0),(346998,9639,'fr','Veuillez entrer un mot de passe',0),(346999,9639,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(347000,9639,'pt','Por favor, digite uma senha',0),(347001,9639,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐŸÐ°Ñ€Ð¾Ð»ÑŒ',0),(347002,9639,'es','Por favor Ingresar un Password',0),(347003,9639,'de','Bitte geben Sie ein Kennwort',0),(347004,9639,'en','Please Enter A Password',0),(347005,9640,'is','',0),(347006,9640,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ  ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(347007,9640,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ  ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(347008,9640,'tr','LÃ¼tfen bir kullanÄ±cÄ± adÄ± girin',0),(347009,9640,'pl','WprowadÅº nazwÄ™ uÅ¼ytkownika',0),(347010,9640,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ',0),(347011,9640,'ur','ØµØ§Ø±Ù Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(347012,9640,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ',0),(347013,9640,'vi','vui lÃ²ng nháº­p ngÆ°á»i sá»­ dá»¥ng ',0),(347014,9640,'af','Voer asb. \'n Gebruikernaam In',0),(347015,9640,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un nume de utilizator',0),(347016,9640,'et','Palun sisesta kasutajanimi',0),(347017,9640,'si','Vnesite uporabniÅ¡ko ime',0),(347018,9640,'ba','Masukkan nama pengguna',0),(347019,9640,'nl','Voer een gebruikersnaam',0),(347020,9640,'fi','Kirjoita kÃ¤yttÃ¤jÃ¤nimi',0),(347021,9640,'no','Skriv inn et brukernavn',0),(347022,9640,'da','Angiv et Brugernavn',0),(347023,9640,'ko','ì‚¬ìš©ìž ì´ë¦„ ìž…ë ¥',0),(347024,9640,'he','×”×–×Ÿ ×©× ×ž×©×ª×ž×©',0),(347025,9640,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î·',0),(347026,9640,'zh','è¯·è¾“å…¥ä¸€ä¸ªç”¨æˆ·å\r\n',0),(347027,9640,'sv','VÃ¤nligen ange ett anvÃ¤ndarnamn',0),(347028,9640,'it','Inserisci un nome utente',0),(347029,9640,'tl','',0),(347030,9640,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3611;&#3657;&#3629;&#3609;&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(347031,9640,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(347032,9640,'ms','Sila masukkan nama pengguna',0),(347033,9640,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(347034,9640,'fr','Veuillez entrer un nom dâ€™utilisateur',0),(347035,9640,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼åã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(347036,9640,'pt','Por favor digite um nome de usuÃ¡rio',0),(347037,9640,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð˜Ð¼Ñ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(347038,9640,'es','Por favor Ingresar un Nombre de Usuario',0),(347039,9640,'de','Bitte geben Sie einen Benutzernamen',0),(347040,9640,'en','Please Enter A Username',0),(347041,9641,'is','',0),(347042,9641,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ÙŠØ§ Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ ØµØ­ÙŠØ­ Ù†ÙŠØ³Øª ',0),(347043,9641,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ÙŠØ§ Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ ØµØ­ÙŠØ­ Ù†ÙŠØ³Øª ',0),(347044,9641,'tr','KullanÄ±cÄ± adÄ± veya parola yanlÄ±ÅŸ',0),(347045,9641,'pl','NiewÅ‚aÅ›ciwa nazwa uÅ¼ytkownika lub hasÅ‚o',0),(347046,9641,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ Ð¸Ð»Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð° Ðµ Ð½ÐµÐ¿Ñ€Ð°Ð²Ð¸Ð»ÐµÐ½',0),(347047,9641,'ur','ØµØ§Ø±Ù Ù†Ø§Ù… ÛŒØ§ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¯Ø±Ø³Øª Ù†ÛÛŒÚº ØªÚ¾Ø§',0),(347048,9641,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ Ð¸Ð»Ð¸ Ð»Ð¾Ð·Ð¸Ð½ÐºÐ° Ñ˜Ðµ Ð½ÐµÐ¸ÑÐ¿Ñ€Ð°Ð²Ð½Ð°',0),(347049,9641,'vi','tÃªn ngÆ°á»i dÃ¹ng vÃ  máº­t kháº©u khÃ´ng Ä‘Ãºng',0),(347050,9641,'af','Die Gebruikernaam of Wagwoord Was Verkeerd',0),(347051,9641,'ro','Numele de utilizator sau parola este incorectÄƒ',0),(347052,9641,'et','Kasutajanimi vÃµi salasÃµna oli valesti sisestatud',0),(347053,9641,'si','UporabniÅ¡ko ime ali geslo sta nepravilna',0),(347054,9641,'ba','Nama pengguna atau sandi adalah salah',0),(347055,9641,'nl','De gebruikersnaam of paswoord is fout',0),(347056,9641,'fi','KÃ¤yttÃ¤jÃ¤nimi tai salasana oli virheellinen',0),(347057,9641,'no','Brukernavnet eller passordet er feil',0),(347058,9641,'da','Brugernavnet eller adgangskoden er forkert',0),(347059,9641,'ko','ì‚¬ìš©ìž ì´ë¦„ ë˜ëŠ” ì•”í˜¸ê°€ ìž˜ëª» ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(347060,9641,'he','×©× ×ž×©×ª×ž×© ××• ×¡×™×¡×ž×” ×©×’×•×™×™×”',0),(347061,9641,'el','Î¤Î¿ ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· Î® Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î®Ï„Î±Î½ ÎµÏƒÏ†Î±Î»Î¼Î­Î½Î·',0),(347062,9641,'zh','ç”¨æˆ·åæˆ–å¯†ç ä¸æ­£ç¡®\r\n',0),(347063,9641,'sv','AnvÃ¤ndarnamn eller lÃ¶senord var felaktigt',0),(347064,9641,'it','Il nome utente o la Password non Ã¨ corretta',0),(347065,9641,'tl','',0),(347066,9641,'th','The Username or Password &#3652;&#3617;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;',0),(347067,9641,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤—à¤¼à¤²à¤¤ à¤¥à¤¾',0),(347068,9641,'ms','Nama pengguna atau kata laluan tidak betul',0),(347069,9641,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø£Ùˆ ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± ØºÙŠØ± ØµØ­ÙŠØ­Ø©',0),(347070,9641,'fr','Le nom dâ€™utilisateur ou mot de passe est Incorrect',0),(347071,9641,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼åã¾ãŸã¯ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ãŒæ­£ã—ãã‚ã‚Šã¾ã›ã‚“ã€‚',0),(347072,9641,'pt','O nome de usuÃ¡rio ou senha estava incorreta',0),(347073,9641,'ru','Ð˜Ð¼Ñ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð˜Ð»Ð¸ ÐŸÐ°Ñ€Ð¾Ð»ÑŒ Ð’Ð²ÐµÐ´ÐµÐ½Ñ‹ ÐÐµÐ²ÐµÑ€Ð½Ð¾',0),(347074,9641,'es','El Nombre del Usuario o Password fue Incorrecto',0),(347075,9641,'de','Der Benutzername oder das Kennwort wurde falsch',0),(347076,9641,'en','The Username or Password Was Incorrect',0),(347077,9642,'is','',0),(347078,9642,'dr','Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ ',0),(347079,9642,'pr','Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ ',0),(347080,9642,'tr','KullanÄ±cÄ± adÄ±',0),(347081,9642,'pl','Nazwa uÅ¼ytkownika',0),(347082,9642,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ',0),(347083,9642,'ur','ØµØ§Ø±Ù Ú©Ø§ Ù†Ø§Ù…',0),(347084,9642,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ',0),(347085,9642,'vi','TÃªn ngÆ°á»i dÃ¹ng',0),(347086,9642,'af','Gebruikernaam',0),(347087,9642,'ro','Nume de utilizator',0),(347088,9642,'et','Kasutajanimi',0),(347089,9642,'si','UporabniÅ¡ko ime',0),(347090,9642,'ba','Nama pengguna',0),(347091,9642,'nl','Gebruikersnaam',0),(347092,9642,'fi','KÃ¤yttÃ¤jÃ¤tunnus',0),(347093,9642,'no','Brukernavn',0),(347094,9642,'da','Username',0),(347095,9642,'ko','ì‚¬ìš©ìž ì´ë¦„',0),(347096,9642,'he','×©× ×ž×©×ª×ž×©',0),(347097,9642,'el','ÎŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î·',0),(347098,9642,'zh','ç”¨æˆ·å\r\n',0),(347099,9642,'sv','AnvÃ¤ndarnamn',0),(347100,9642,'it','Nome utente',0),(347101,9642,'tl','',0),(347102,9642,'th','&#3594;&#3639;&#3656;&#3629;&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;',0),(347103,9642,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤®',0),(347104,9642,'ms','Nama pengguna',0),(347105,9642,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(347106,9642,'fr','Nom dâ€™utilisateur',0),(347107,9642,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼å',0),(347108,9642,'pt','Nome de usuÃ¡rio',0),(347109,9642,'ru','Ð˜Ð¼Ñ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(347110,9642,'es','Nombre de Usuario',0),(347111,9642,'de','Benutzername',0),(347112,9642,'en','Username',0),(347113,9643,'is','',0),(347114,9643,'dr','Ø´Ù…Ø§  Ø§Ø² Ø³ÙŠØ³ØªÙ… Ø®Ø§Ø±Ø¬ Ø´Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(347115,9643,'pr','Ø´Ù…Ø§  Ø§Ø² Ø³ÙŠØ³ØªÙ… Ø®Ø§Ø±Ø¬ Ø´Ø¯Ù‡ Ø§ÙŠØ¯ ',0),(347116,9643,'tr','Seni gÃ¼nlÃ¼ÄŸe kaydedildi',0),(347117,9643,'pl','ZostaÅ‚eÅ› wylogowany',0),(347118,9643,'bg','Ð’Ð¸Ðµ Ð¸Ð·Ð»ÑÐ·Ð¾Ñ…Ñ‚Ðµ',0),(347119,9643,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ù†Û’ Ù„Ø§Ú¯ Ø¢Ø¤Ù¹ Ú©Ø±Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(347120,9643,'sr','Ð¡Ñ‚Ðµ Ð¾Ð´Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð¸',0),(347121,9643,'vi','Báº¡n Ä‘Ã£ Ä‘Äƒng xuáº¥t',0),(347122,9643,'af','U Is Uitgeteken',0),(347123,9643,'ro','Ai fost deconectat',0),(347124,9643,'et','Te olete vÃ¤lja logitud',0),(347125,9643,'si','Odjavili ste se bili',0),(347126,9643,'ba','Anda telah dikeluarkan',0),(347127,9643,'nl','U bent uitgelogd',0),(347128,9643,'fi','Olet kirjautunut',0),(347129,9643,'no','Du har logget av',0),(347130,9643,'da','Du er blevet logget',0),(347131,9643,'ko','ë‹¹ì‹ ì€ ë°–ìœ¼ë¡œ ê¸°ë¡ ëœ',0),(347132,9643,'he','×©×”×ª×—×‘×¨×ª',0),(347133,9643,'el','ÎˆÏ‡ÎµÏ„Îµ ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯',0),(347134,9643,'zh','æ‚¨å·²ç»ç™»å‡º\r\n',0),(347135,9643,'sv','Du har loggats ut',0),(347136,9643,'it','Sei stato disconnesso',0),(347137,9643,'tl','',0),(347138,9643,'th','&#3588;&#3640;&#3603;&#3652;&#3604;&#3657;&#3629;&#3629;&#3585;&#3592;&#3634;&#3585;&#3619;&#3632;&#3610;&#3610;',0),(347139,9643,'hi','à¤¤à¥à¤® à¤²à¥‰à¤— à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(347140,9643,'ms','Anda telah log keluar',0),(347141,9643,'ar','Ù„Ù‚Ø¯ Ù‚Ù…Øª Ø¨ØªØ³Ø¬ÙŠÙ„',0),(347142,9643,'fr','Vous avez Ã©tÃ© dÃ©connectÃ©',0),(347143,9643,'jp','ã‚ãªãŸãŒãƒ­ã‚°ã‚¢ã‚¦ãƒˆã—ã¾ã—ãŸ',0),(347144,9643,'pt','VocÃª foi desconectado para fora',0),(347145,9643,'ru','Ð’Ñ‹ Ð²Ñ‹ÑˆÐ»Ð¸',0),(347146,9643,'es','Ha Sido Logout',0),(347147,9643,'de','Sie haben sich abgemeldet worden',0),(347148,9643,'en','You Have Been Logged Out',0),(347149,9644,'is','',0),(347150,9644,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø³Ø§Ø¨Ù‚Ù‡',0),(347151,9644,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø³Ø§Ø¨Ù‚Ù‡',0),(347152,9644,'tr','Arka plan kontrolleri',0),(347153,9644,'pl','W weryfikacji',0),(347154,9644,'bg','Ð¤Ð¾Ð½ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(347155,9644,'ur','Ù¾Ø³ Ù…Ù†Ø¸Ø± Ú†ÛŒÚ©',0),(347156,9644,'sr','ÐŸÐ¾Ð·Ð°Ð´Ð¸Ð½Ð° Ñ‡ÐµÐºÐ¾Ð²Ð¸',0),(347157,9644,'vi','Kiá»ƒm tra thÃ´ng tin ',0),(347158,9644,'af','Agtergrond Tjeks',0),(347159,9644,'ro','Controale de fond',0),(347160,9644,'et','Taustakontrolli',0),(347161,9644,'si','Preverjanje preteklosti',0),(347162,9644,'ba','Pemeriksaan latar belakang',0),(347163,9644,'nl','Achtergrondcontroles',0),(347164,9644,'fi','Taustan tarkistus',0),(347165,9644,'no','Bakgrunnssjekker',0),(347166,9644,'da','Baggrundstjek',0),(347167,9644,'ko','ë°°ê²½ ìˆ˜ í‘œ',0),(347168,9644,'he','×‘×“×™×§×ª ×¨×§×¢',0),(347169,9644,'el','Î•Î»Î­Î³Ï‡Î¿Ï…Ï‚ ÏƒÏ„Î¿ Ï€Î±ÏÎ±ÏƒÎºÎ®Î½Î¹Î¿',0),(347170,9644,'zh','èƒŒæ™¯æ£€æŸ¥\r\n',0),(347171,9644,'sv','Bakgrundskontroller',0),(347172,9644,'it','Controlli della prioritÃ  bassa',0),(347173,9644,'tl','',0),(347174,9644,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3614;&#3639;&#3657;&#3609;&#3627;&#3621;&#3633;&#3591;',0),(347175,9644,'hi','à¤ªà¥ƒà¤·à¥à¤ à¤­à¥‚à¤®à¤¿ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(347176,9644,'ms','Pemeriksaan latar belakang',0),(347177,9644,'ar','Ø®Ù„ÙÙŠØ© Ø§Ù„Ø´ÙŠÙƒØ§Øª',0),(347178,9644,'fr','VÃ©rifications des antÃ©cÃ©dents',0),(347179,9644,'jp','èƒŒæ™¯ã‚’ãƒã‚§ãƒƒã‚¯',0),(347180,9644,'pt','VerificaÃ§Ã£o de antecedentes',0),(347181,9644,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(347182,9644,'es','Chequeas de Antecedetes',0),(347183,9644,'de','Background Checks',0),(347184,9644,'en','Background Checks',0),(347185,9645,'is','',0),(347186,9645,'dr','(Ø§Ø®ÙŠØ±',0),(347187,9645,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ú¯Ø°Ø´ØªÙ‡ (Ø§Ø®ÙŠØ±',0),(347188,9645,'tr','GeÃ§ Ã¶demeler',0),(347189,9645,'pl','OpÃ³Åºnienia w pÅ‚atnoÅ›ciach',0),(347190,9645,'bg','Ð—Ð°ÐºÑŠÑÐ½ÐµÐ»Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(347191,9645,'ur','ØªØ§Ø®ÛŒØ±ÛŒ Ø§Ø¯Ø§Ø¦ÛŒ',0),(347192,9645,'sr','Ð˜ÑÐ¿Ð»Ð°Ñ‚Ðµ ÐºÐ°ÑÐ½Ðµ',0),(347193,9645,'vi','thanh toÃ¡n muá»™n',0),(347194,9645,'af','Laat Betalings',0),(347195,9645,'ro','ÃŽntÃ¢rzierea plÄƒÅ£ilor',0),(347196,9645,'et','Hilinenud maksed',0),(347197,9645,'si','Zamudne obresti',0),(347198,9645,'ba','Keterlambatan pembayaran',0),(347199,9645,'nl','Late betalingen',0),(347200,9645,'fi','ViivÃ¤styneistÃ¤ maksuista',0),(347201,9645,'no','Sen betaling',0),(347202,9645,'da','Forsinkede betalinger',0),(347203,9645,'ko','ëŠ¦ì€ ì§€ë¶ˆ',0),(347204,9645,'he','×ª×©×œ×•×ž×™× ×ž××•×—×¨×™×',0),(347205,9645,'el','ÎšÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ·Î¼Î­Î½ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(347206,9645,'zh','é€¾æœŸä»˜æ¬¾\r\n',0),(347207,9645,'sv','Sena betalningar',0),(347208,9645,'it','Ritardi nei pagamenti',0),(347209,9645,'tl','',0),(347210,9645,'th','&#3585;&#3634;&#3619;&#3594;&#3635;&#3619;&#3632;&#3648;&#3591;&#3636;&#3609;&#3621;&#3656;&#3634;&#3594;&#3657;&#3634;',0),(347211,9645,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(347212,9645,'ms','Kelewatan pembayaran',0),(347213,9645,'ar','Ø§Ù„Ø¯ÙØ¹Ø§Øª Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(347214,9645,'fr','Retards de paiement',0),(347215,9645,'jp','æ”¯æ‰•ã„é…å»¶',0),(347216,9645,'pt','Pagamentos em atraso',0),(347217,9645,'ru','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(347218,9645,'es','Pagos TardÃ­os',0),(347219,9645,'de','VerspÃ¤tete Zahlungen',0),(347220,9645,'en','Late Payments',0),(347221,9646,'is','',0),(347222,9646,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ ',0),(347223,9646,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ ',0),(347224,9646,'tr','Kiralama',0),(347225,9646,'pl','DzierÅ¼awy',0),(347226,9646,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³',0),(347227,9646,'ur','Ù„ÙÛŒØ²Ø²',0),(347228,9646,'sr','Ð£Ð³Ð¾Ð²Ð¾Ñ€Ð¸',0),(347229,9646,'vi','há»£p Ä‘á»“ng cho thuÃª',0),(347230,9646,'af','Huurkontrakte',0),(347231,9646,'ro','Contracte de leasing',0),(347232,9646,'et','Rent',0),(347233,9646,'si','Najemi',0),(347234,9646,'ba','Sewa',0),(347235,9646,'nl','Lease-overeenkomsten',0),(347236,9646,'fi','Vuokrasopimukset',0),(347237,9646,'no','Leieavtaler',0),(347238,9646,'da','LejemÃ¥l',0),(347239,9646,'ko','ìž„ëŒ€',0),(347240,9646,'he','×—×›×™×¨×”',0),(347241,9646,'el','ÎœÎ¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(347242,9646,'zh','ç§Ÿèµ\r\n',0),(347243,9646,'sv','Leasingavtal',0),(347244,9646,'it','Contratti di locazione',0),(347245,9646,'tl','',0),(347246,9646,'th','&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(347247,9646,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚',0),(347248,9646,'ms','Pajakan',0),(347249,9646,'ar','Ø¹Ù‚ÙˆØ¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(347250,9646,'fr','Contrats de location',0),(347251,9646,'jp','ãƒªãƒ¼ã‚¹',0),(347252,9646,'pt','LocaÃ§Ãµes',0),(347253,9646,'ru','ÐÑ€ÐµÐ½Ð´Ð°',0),(347254,9646,'es','Arrendamientos',0),(347255,9646,'de','Leasing',0),(347256,9646,'en','Leases',0),(347257,9647,'is','',0),(347258,9647,'dr','Ø§Ø¯Ø§Ø±Ù‡ ÙƒØ±Ø¯Ù† Ù…Ø³ØªØ§Ø¬Ø±ÙŠÙ† ',0),(347259,9647,'pr','Ø§Ø¯Ø§Ø±Ù‡ ÙƒØ±Ø¯Ù† Ù…Ø³ØªØ§Ø¬Ø±ÙŠÙ† ',0),(347260,9647,'tr','KiracÄ±larÄ± YÃ¶net',0),(347261,9647,'pl','ZarzÄ…dzanie dzierÅ¼awcami',0),(347262,9647,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»Ð¸',0),(347263,9647,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±ÙˆÚº Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±ÛŒÚº',0),(347264,9647,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ ÑÑ‚Ð°Ð½Ð°Ñ€Ðµ',0),(347265,9647,'vi','Quáº£n lÃ½ nhÃ¢n cÃ´ng',0),(347266,9647,'af','Bestuur Huurders',0),(347267,9647,'ro','Gestiona chiriasi',0),(347268,9647,'et','Rentnike haldamine',0),(347269,9647,'si','Upravljanje podrejenih elementov',0),(347270,9647,'ba','Mengelola penyewa',0),(347271,9647,'nl','Beheren van huurders',0),(347272,9647,'fi','Hallitse palveltavia kohteita',0),(347273,9647,'no','Administrere leietakere',0),(347274,9647,'da','HÃ¥ndtere lejere',0),(347275,9647,'ko','ì„¸ ìž…ìž ê´€ë¦¬',0),(347276,9647,'he','×œ× ×”×œ ××ª ×”×“×™×™×¨×™×',0),(347277,9647,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· ÎµÎ½Î¿Î¹ÎºÎ¹Î±ÏƒÏ„ÏŽÎ½',0),(347278,9647,'zh','ç®¡ç†ç§Ÿæˆ·\r\n',0),(347279,9647,'sv','Hantera hyresgÃ¤ster',0),(347280,9647,'it','Il gestore di inquilini',0),(347281,9647,'tl','',0),(347282,9647,'th','&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;',0),(347283,9647,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°à¥‹à¤‚ à¤•à¤¾ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨',0),(347284,9647,'ms','Uruskan penyewa',0),(347285,9647,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±ÙŠÙ†',0),(347286,9647,'fr','GÃ©rer des locataires',0),(347287,9647,'jp','ãƒ†ãƒŠãƒ³ãƒˆã‚’ç®¡ç†ã—ã¾ã™ã€‚',0),(347288,9647,'pt','Gerenciar os inquilinos',0),(347289,9647,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð°Ð¼Ð¸',0),(347290,9647,'es','Manejar Inquilinos',0),(347291,9647,'de','Mandanten verwalten',0),(347292,9647,'en','Manage Tenants',0),(347293,9648,'is','',0),(347294,9648,'dr','Ù„Ø·ÙØ§ ÙˆØ§Ø±Ø¯ Ø³ÙŠØ³ØªÙ… Ø´ÙˆÙŠØ¯',0),(347295,9648,'pr','Ù„Ø·ÙØ§ ÙˆØ§Ø±Ø¯ Ø³ÙŠØ³ØªÙ… Ø´ÙˆÙŠØ¯',0),(347296,9648,'tr','LÃ¼tfen giriÅŸ yapÄ±nÄ±z',0),(347297,9648,'pl','ProszÄ™ siÄ™ zalogowaÄ‡',0),(347298,9648,'bg','ÐœÐ¾Ð»Ñ, Ð²Ð»ÐµÐ·Ñ‚Ðµ',0),(347299,9648,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº',0),(347300,9648,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° ÑÐµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ',0),(347301,9648,'vi','vui lÃ²ng Ä‘Äƒng nháº­p',0),(347302,9648,'af','Teken asseblief In',0),(347303,9648,'ro','LogaÅ£i-vÄƒ',0),(347304,9648,'et','Palun logi sisse',0),(347305,9648,'si','Prijavite se',0),(347306,9648,'ba','Silakan login',0),(347307,9648,'nl','Log In',0),(347308,9648,'fi','Kirjaudu sisÃ¤Ã¤n',0),(347309,9648,'no','Vennligst logg inn',0),(347310,9648,'da','Log venligst ind',0),(347311,9648,'ko','ë¡œê·¸ì¸ì„ í•´ ì£¼ì„¸ìš”',0),(347312,9648,'he','×× × ×”×ª×—×‘×¨',0),(347313,9648,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ',0),(347314,9648,'zh','è¯·ç™»å½•\r\n',0),(347315,9648,'sv','VÃ¤nligen logga In',0),(347316,9648,'it','Effettua il login',0),(347317,9648,'tl','',0),(347318,9648,'th','Please Log In',0),(347319,9648,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤²à¥‰à¤— à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(347320,9648,'ms','Sila Log Masuk',0),(347321,9648,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(347322,9648,'fr','Veuillez vous connecter',0),(347323,9648,'jp','ãƒ­ã‚°ã‚¤ãƒ³ã—ã¦ãã ã•ã„ã€‚',0),(347324,9648,'pt','Efetue o login',0),(347325,9648,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð¾Ð¹Ð´Ð¸Ñ‚Ðµ',0),(347326,9648,'es','Por Favor Login',0),(347327,9648,'de','Loggen Sie sich bitte',0),(347328,9648,'en','Please Log In',0),(347329,9649,'is','',0),(347330,9649,'dr','Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(347331,9649,'pr','Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(347332,9649,'tr','Ã–zellik kullanÄ±labilirliÄŸi',0),(347333,9649,'pl','DostÄ™pnoÅ›Ä‡ wÅ‚aÅ›ciwoÅ›ci',0),(347334,9649,'bg','Ð˜Ð¼Ð¾Ñ‚Ð¸ Ð´Ð¾ÑÑ‚ÑŠÐ¿Ð½Ð¾ÑÑ‚Ñ‚Ð°',0),(347335,9649,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ø¯Ø³ØªÛŒØ§Ø¨ÛŒ',0),(347336,9649,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¾ÑÑ‚',0),(347337,9649,'vi','tÃ i sáº£n hiá»‡n cÃ³',0),(347338,9649,'af','Eiendom Beskikbaarheid',0),(347339,9649,'ro','Disponibilitate proprietate',0),(347340,9649,'et','Majutusasutuse saadavust',0),(347341,9649,'si','RazpoloÅ¾ljivost nepremiÄnine',0),(347342,9649,'ba','Ketersediaan properti',0),(347343,9649,'nl','Eigenschap beschikbaarheid',0),(347344,9649,'fi','Ominaisuuden saatavuus',0),(347345,9649,'no','Egenskapen tilgjengelighet',0),(347346,9649,'da','Egenskaben tilgÃ¦ngelighed',0),(347347,9649,'ko','ì†ì„± ê°€ìš©ì„±',0),(347348,9649,'he','×”×ž××¤×™×™×Ÿ ×–×ž×™× ×•×ª',0),(347349,9649,'el','Î¤Î¿ ÎºÎ±Ï„Î¬Î»Ï…Î¼Î± Î´Î¹Î±Î¸ÎµÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î±',0),(347350,9649,'zh','å±žæ€§çš„å¯ç”¨æ€§\r\n',0),(347351,9649,'sv','Boendet tillgÃ¤nglighet',0),(347352,9649,'it','DisponibilitÃ  di proprietÃ .',0),(347353,9649,'tl','',0),(347354,9649,'th','&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;',0),(347355,9649,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥€ à¤‰à¤ªà¤²à¤¬à¥à¤§à¤¤à¤¾',0),(347356,9649,'ms','Adanya harta',0),(347357,9649,'ar','ØªÙˆÙØ± Ø®Ø§ØµÙŠØ©',0),(347358,9649,'fr','DisponibilitÃ© de la propriÃ©tÃ©',0),(347359,9649,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®å¯ç”¨æ€§',0),(347360,9649,'pt','Disponibilidade de propriedade.',0),(347361,9649,'ru','ÐÐ°Ð»Ð¸Ñ‡Ð¸Ðµ Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚Ð¸',0),(347362,9649,'es','Disponibilidad de Propiedad',0),(347363,9649,'de','Immobilien VerfÃ¼gbarkeit',0),(347364,9649,'en','Property Availability',0),(347365,9650,'is','',0),(347366,9650,'dr','Ù„ÙŠØ³Øª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(347367,9650,'pr','Ù„ÙŠØ³Øª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(347368,9650,'tr','Ã–zellik listesi',0),(347369,9650,'pl','Lista wÅ‚aÅ›ciwoÅ›ci',0),(347370,9650,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(347371,9650,'ur','Ø®Ø§ØµÛŒØª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(347372,9650,'sr','Ð›Ð¸ÑÑ‚Ð° ÑÐ²Ð¾Ñ˜ÑÑ‚Ð°Ð²Ð°',0),(347373,9650,'vi','danh sach tÃ i sáº£n',0),(347374,9650,'af','Eiendom lys',0),(347375,9650,'ro','ListÄƒ de proprietate',0),(347376,9650,'et','Vara nimekiri',0),(347377,9650,'si','Seznama lastnosti',0),(347378,9650,'ba','Daftar properti',0),(347379,9650,'nl','Eigenschappenlijst',0),(347380,9650,'fi','Ominaisuusluettelo',0),(347381,9650,'no','Egenskapslisten',0),(347382,9650,'da','Egenskabslisten',0),(347383,9650,'ko','ì†ì„± ëª©ë¡',0),(347384,9650,'he','×¨×©×™×ž×ª × ×›×¡×™×',0),(347385,9650,'el','Î›Î¯ÏƒÏ„Î± Î±ÎºÎ¹Î½Î®Ï„Ï‰Î½',0),(347386,9650,'zh','å±žæ€§æ¸…å•\r\n',0),(347387,9650,'sv','Egenskapslistan',0),(347388,9650,'it','Elenco delle proprietÃ ',0),(347389,9650,'tl','',0),(347390,9650,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3607;&#3619;&#3633;&#3614;&#3618;&#3660;&#3626;&#3636;&#3609;',0),(347391,9650,'hi','à¤—à¥à¤£ à¤¸à¥‚à¤šà¥€',0),(347392,9650,'ms','Senarai Hartanah',0),(347393,9650,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø®ØµØ§Ø¦Øµ',0),(347394,9650,'fr','Liste des propriÃ©tÃ©s',0),(347395,9650,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ ãƒªã‚¹ãƒˆ',0),(347396,9650,'pt','Lista de propriedade',0),(347397,9650,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑÐ²Ð¾Ð¹ÑÑ‚Ð²',0),(347398,9650,'es','Lista de Propiedad',0),(347399,9650,'de','Eigenschaftenliste',0),(347400,9650,'en','Property List',0),(347401,9651,'is','',0),(347402,9651,'dr','Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(347403,9651,'pr','Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(347404,9651,'tr','Ã–zellik yÃ¶netimi sistemi',0),(347405,9651,'pl','System zarzÄ…dzania WÅ‚aÅ›ciwoÅ›Ä‡',0),(347406,9651,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð° Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚Ð¸',0),(347407,9651,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ Ú©Ø§ Ù†Ø¸Ø§Ù…',0),(347408,9651,'sr','ÐŸÑ€Ð¾Ð¿ÐµÑ€Ñ‚y ÐœÐ°Ð½Ð°Ð³ÐµÐ¼ÐµÐ½Ñ‚ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(347409,9651,'vi','há»‡ thá»‘ng quáº£n lÃ½ tÃ i sáº£n',0),(347410,9651,'af','Eiendom bestuur stelsel',0),(347411,9651,'ro','Sistem de Management de proprietate',0),(347412,9651,'et','Kinnisvara haldamise sÃ¼steem',0),(347413,9651,'si','Sistem za upravljanje premoÅ¾enja',0),(347414,9651,'ba','Sistem manajemen properti',0),(347415,9651,'nl','Vastgoed managementsysteem',0),(347416,9651,'fi','Elokuvia ja kanavia',0),(347417,9651,'no','Egenskapen styringssystem',0),(347418,9651,'da','Property managementsystem',0),(347419,9651,'ko','ì†ì„± ê´€ë¦¬ ì‹œìŠ¤í…œ',0),(347420,9651,'he','×ž×¢×¨×›×ª × ×™×”×•×œ ×¨×›×•×©',0),(347421,9651,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Î±ÎºÎ¹Î½Î®Ï„Ï‰Î½',0),(347422,9651,'zh','å±žæ€§ç®¡ç†ç³»ç»Ÿ\r\n',0),(347423,9651,'sv','Property Management System',0),(347424,9651,'it','Sistema di gestione della proprietÃ .',0),(347425,9651,'tl','',0),(347426,9651,'th','&#3619;&#3632;&#3610;&#3610;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3629;&#3626;&#3633;&#3591;&#3627;&#3634;&#3619;&#3636;&#3617;&#3607;&#3619;&#3633;&#3614;&#3618;&#3660;',0),(347427,9651,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤ªà¥à¤°à¤£à¤¾à¤²à¥€',0),(347428,9651,'ms','Sistem pengurusan harta',0),(347429,9651,'ar','Ù†Ø¸Ø§Ù… Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(347430,9651,'fr','SystÃ¨me de gestion de propriÃ©tÃ©',0),(347431,9651,'jp','ç‰©ä»¶ç®¡ç†ã‚·ã‚¹ãƒ†ãƒ ',0),(347432,9651,'pt','Sistema de gestÃ£o de propriedade',0),(347433,9651,'ru','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒÑŽ',0),(347434,9651,'es','Sistema de AdministraciÃ³n de Propiedad',0),(347435,9651,'de','Property Managementsystem',0),(347436,9651,'en','Property Management System',0),(347437,9652,'is','',0),(347438,9652,'dr','ØªØµØ±Ù Ø¯Ø§Ø±Ø§Ø¦ÙŠ                                                                                             ',0),(347439,9652,'pr','ØªØµØ±Ù Ø¯Ø§Ø±Ø§Ø¦ÙŠ                                                                                             ',0),(347440,9652,'tr','Ã–zellik iÅŸgal',0),(347441,9652,'pl','Zajmowania majÄ…tku',0),(347442,9652,'bg','Ð˜Ð¼Ð¾Ñ‚Ð¸ Ð¿Ñ€Ð¾Ñ„ÐµÑÐ¸Ñ',0),(347443,9652,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù‚Ø¨Ø¶Û’',0),(347444,9652,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ Ð¾ÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ˜Ðµ',0),(347445,9652,'vi','giá»¯ tÃ i sáº£n',0),(347446,9652,'af','Eiendom Okkupasie',0),(347447,9652,'ro','OcupaÅ£ia de proprietate',0),(347448,9652,'et','Majutusasutuse okupatsiooni',0),(347449,9652,'si','Lastnost poklic',0),(347450,9652,'ba','Pendudukan properti',0),(347451,9652,'nl','Eigenschap bezetting',0),(347452,9652,'fi','Ominaisuuden ammatti',0),(347453,9652,'no','Egenskapen yrke',0),(347454,9652,'da','Egenskaben besÃ¦ttelse',0),(347455,9652,'ko','ì†ì„± ì§ì—…',0),(347456,9652,'he','×”×ž××¤×™×™×Ÿ ×¢×™×¡×•×§',0),(347457,9652,'el','Î¤Î¿ ÎºÎ±Ï„Î¬Î»Ï…Î¼Î± ÎºÎ±Ï„Î¿Ï‡Î®Ï‚',0),(347458,9652,'zh','å±žæ€§å ç”¨',0),(347459,9652,'sv','Boendet ockupation',0),(347460,9652,'it','Occupazione di proprietÃ .',0),(347461,9652,'tl','',0),(347462,9652,'th','&#3607;&#3637;&#3656;&#3604;&#3636;&#3609;&#3607;&#3637;&#3656;&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3629;&#3591;',0),(347463,9652,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤¬à¥à¤œà¥‡',0),(347464,9652,'ms','Menduduki harta tanah',0),(347465,9652,'ar','Ø§Ø­ØªÙ„Ø§Ù„ Ø§Ù„Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(347466,9652,'fr','Occupation de la propriÃ©tÃ©',0),(347467,9652,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®è·æ¥­',0),(347468,9652,'pt','OcupaÃ§Ã£o de propriedade.',0),(347469,9652,'ru','ÐžÐºÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(347470,9652,'es','OcupaciÃ³n de Propiedad',0),(347471,9652,'de','Eigentum-Besetzung',0),(347472,9652,'en','Property Occupation',0),(347473,9653,'is','',0),(347474,9653,'dr','(Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ)',0),(347475,9653,'pr','Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ú¯Ø±ÙŠ (Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ)',0),(347476,9653,'tr','UmutlarÄ±',0),(347477,9653,'pl','Perspektywy',0),(347478,9653,'bg','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð¸Ñ‚Ðµ',0),(347479,9653,'ur','Ø§Ù…Ú©Ø§Ù†Ø§Øª',0),(347480,9653,'sr','Ð˜Ð·Ð³Ð»ÐµÐ´Ð¸ Ð·Ð°',0),(347481,9653,'vi','triá»ƒn vá»ng',0),(347482,9653,'af','Voornemende KliÃ«nte',0),(347483,9653,'ro','Perspectivele',0),(347484,9653,'et','VÃ¤ljavaated',0),(347485,9653,'si','MoÅ¾nosti',0),(347486,9653,'ba','Prospek',0),(347487,9653,'nl','Vooruitzichten',0),(347488,9653,'fi','NÃ¤kymÃ¤t',0),(347489,9653,'no','Utsiktene',0),(347490,9653,'da','Fremtidsudsigter',0),(347491,9653,'ko','ì „ë§',0),(347492,9653,'he','×œ×§×•×—×•×ª ×¤×•×˜× ×¦×™××œ×™×™×',0),(347493,9653,'el','Î ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ­Ï‚',0),(347494,9653,'zh','å‰æ™¯\r\n',0),(347495,9653,'sv','Framtidsutsikter',0),(347496,9653,'it','Prospettive',0),(347497,9653,'tl','',0),(347498,9653,'th','&#3612;&#3641;&#3657;&#3607;&#3637;&#3656;&#3627;&#3623;&#3633;&#3591;&#3592;&#3632;&#3652;&#3604;&#3657;&#3648;&#3611;&#3655;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(347499,9653,'hi','à¤•à¥€ à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾à¤“à¤‚',0),(347500,9653,'ms','Prospek',0),(347501,9653,'ar','Ø¢ÙØ§Ù‚',0),(347502,9653,'fr','Perspectives',0),(347503,9653,'jp','å±•æœ›',0),(347504,9653,'pt','Perspectivas',0),(347505,9653,'ru','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ñ‹',0),(347506,9653,'es','Clientes Potenciales',0),(347507,9653,'de','Perspektiven',0),(347508,9653,'en','Prospects',0),(347509,9654,'is','',0),(347510,9654,'dr','Ù¾Ø±Ø³Ø´Ù†Ø§Ù…Ù‡',0),(347511,9654,'pr','Ù¾Ø±Ø³Ø´Ù†Ø§Ù…Ù‡',0),(347512,9654,'tr','Soru formlarÄ±',0),(347513,9654,'pl','Kwestionariusze',0),(347514,9654,'bg','Ð’ÑŠÐ¿Ñ€Ð¾ÑÐ½Ð¸Ñ†Ð¸',0),(347515,9654,'ur','Ù‚ÛŒØ³Ù¹Ø§ÙˆÙ†Ù†ÛŒØ±',0),(347516,9654,'sr','Ð£Ð¿Ð¸Ñ‚Ð½Ð¸Ñ†Ð¸',0),(347517,9654,'vi','CÃ¢u há»i',0),(347518,9654,'af','Vraelyste',0),(347519,9654,'ro','Chestionare',0),(347520,9654,'et','KÃ¼simustik',0),(347521,9654,'si','VpraÅ¡alniki',0),(347522,9654,'ba','Kuesioner',0),(347523,9654,'nl','Vragenlijsten',0),(347524,9654,'fi','Kyselylomakkeet',0),(347525,9654,'no','SpÃ¸rreskjemaer',0),(347526,9654,'da','SpÃ¸rgeskemaer',0),(347527,9654,'ko','ì„¤ë¬¸ ì¡°ì‚¬',0),(347528,9654,'he','×©××œ×•× ×™×',0),(347529,9654,'el','Î•ÏÏ‰Ï„Î·Î¼Î±Ï„Î¿Î»ÏŒÎ³Î¹Î±',0),(347530,9654,'zh','é—®å·\r\n',0),(347531,9654,'sv','FrÃ¥geformulÃ¤r',0),(347532,9654,'it','Questionari',0),(347533,9654,'tl','',0),(347534,9654,'th','&#3649;&#3610;&#3610;&#3626;&#3629;&#3610;&#3606;&#3634;&#3617;',0),(347535,9654,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨à¤¾à¤µà¤²à¥€',0),(347536,9654,'ms','Borang soal selidik',0),(347537,9654,'ar','Ø§Ù„Ø§Ø³ØªØ¨ÙŠØ§Ù†Ø§Øª',0),(347538,9654,'fr','Questionnaires',0),(347539,9654,'jp','ã‚¢ãƒ³ã‚±ãƒ¼ãƒˆ',0),(347540,9654,'pt','QuestionÃ¡rios',0),(347541,9654,'ru','ÐÐ½ÐºÐµÑ‚Ð½Ñ‹Ð¹ ÐžÐ¿Ñ€Ð¾Ñ',0),(347542,9654,'es','Cuestionario',0),(347543,9654,'de','FragebÃ¶gen',0),(347544,9654,'en','Questionnaires',0),(347545,9655,'is','',0),(347546,9655,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ùˆ ØªØ¹Ù…ÙŠØ±',0),(347547,9655,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ùˆ ØªØ¹Ù…ÙŠØ±',0),(347548,9655,'tr','Ä°stek bakÄ±m',0),(347549,9655,'pl','Å»Ä…dania obsÅ‚ugi',0),(347550,9655,'bg','Ð˜ÑÐºÐ°Ð½Ðµ Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(347551,9655,'ur','Ø¨Ø­Ø§Ù„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø±ÛŒÚº',0),(347552,9655,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ',0),(347553,9655,'vi','Ä‘á» nghá»‹ báº£o dÆ°á»¡ng',0),(347554,9655,'af','Versoek onderhoud',0),(347555,9655,'ro','Cerere de Ã®ntreÅ£inere',0),(347556,9655,'et','Elatise nÃµude esitamiseks',0),(347557,9655,'si','Zahteva vzdrÅ¾evanje',0),(347558,9655,'ba','Permintaan pemeliharaan',0),(347559,9655,'nl','Aanvraag onderhoud',0),(347560,9655,'fi','PyytÃ¤Ã¤ huolto',0),(347561,9655,'no','Be om vedlikehold',0),(347562,9655,'da','Anmode om vedligeholdelse',0),(347563,9655,'ko','ìœ ì§€ ë³´ìˆ˜ ìš”ì²­',0),(347564,9655,'he','×‘×§×©×” ×ª×—×–×•×§×”',0),(347565,9655,'el','Î‘Î¯Ï„Î·ÏƒÎ· ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ·Ï‚',0),(347566,9655,'zh','è¯·æ±‚ç»´æŠ¤\r\n',0),(347567,9655,'sv','BegÃ¤ra underhÃ¥ll',0),(347568,9655,'it','Richiesta manutenzione',0),(347569,9655,'tl','',0),(347570,9655,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3585;&#3634;&#3619;&#3610;&#3635;&#3619;&#3640;&#3591;&#3619;&#3633;&#3585;&#3625;&#3634;',0),(347571,9655,'hi','à¤°à¤–à¤°à¤–à¤¾à¤µ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(347572,9655,'ms','Permintaan penyenggaraan',0),(347573,9655,'ar','Ø·Ù„Ø¨ ØµÙŠØ§Ù†Ø©',0),(347574,9655,'fr','Demande entretien',0),(347575,9655,'jp','ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹ã‚’è¦æ±‚ã—ã¾ã™ã€‚',0),(347576,9655,'pt','SolicitaÃ§Ã£o de manutenÃ§Ã£o',0),(347577,9655,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(347578,9655,'es','Se Solicita Mantenimiento',0),(347579,9655,'de','Wartungsanfrage',0),(347580,9655,'en','Request Maintenance',0),(347581,9656,'is','',0),(347582,9656,'dr','Ù…Ø³ØªØ§Ø¬Ø±Ø§Ù† ',0),(347583,9656,'pr','Ù…Ø³ØªØ§Ø¬Ø±Ø§Ù† ',0),(347584,9656,'tr','KiracÄ±',0),(347585,9656,'pl','NajemcÃ³w',0),(347586,9656,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ»Ð¸',0),(347587,9656,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±ÙˆÚº Ú©Û’ Ù„Û“',0),(347588,9656,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€Ð¸',0),(347589,9656,'vi','nhá»¯ng ngÆ°á»i thuÃª nhÃ ',0),(347590,9656,'af','Huurders',0),(347591,9656,'ro','Chiriasi',0),(347592,9656,'et','ÃœÃ¼rnikud',0),(347593,9656,'si','Najemniki',0),(347594,9656,'ba','Penyewa',0),(347595,9656,'nl','Huurders',0),(347596,9656,'fi','Vuokralaisten',0),(347597,9656,'no','Leietakere',0),(347598,9656,'da','Lejere',0),(347599,9656,'ko','ì„¸ ìž…ìž',0),(347600,9656,'he','×”×“×™×™×¨×™×',0),(347601,9656,'el','Î•Î½Î¿Î¹ÎºÎ¹Î±ÏƒÏ„Î­Ï‚',0),(347602,9656,'zh','ä¸šæƒäºº\r\n',0),(347603,9656,'sv','HyresgÃ¤ster',0),(347604,9656,'it','Inquilini',0),(347605,9656,'tl','',0),(347606,9656,'th','&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;',0),(347607,9656,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°à¥‹à¤‚',0),(347608,9656,'ms','Penyewa',0),(347609,9656,'ar','Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±ÙŠÙ†',0),(347610,9656,'fr','Locataires',0),(347611,9656,'jp','ãƒ†ãƒŠãƒ³ãƒˆ',0),(347612,9656,'pt','Inquilinos',0),(347613,9656,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ñ‹',0),(347614,9656,'es','Inquilinos',0),(347615,9656,'de','Mieter',0),(347616,9656,'en','Tenants',0),(347617,9657,'is','',0),(347618,9657,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  Ø¯Ø±ÙŠØ§ÙØª Ù†Ø´Ø¯Ù‡ ',0),(347619,9657,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  Ø¯Ø±ÙŠØ§ÙØª Ù†Ø´Ø¯Ù‡ ',0),(347620,9657,'tr','PO Unreceive',0),(347621,9657,'pl','PO Unreceive',0),(347622,9657,'bg','PO Unreceive',0),(347623,9657,'ur','Ù¾Ùˆ Ø§Ù†Ø±ÛŒØ³ÛŒÙˆÛŒ',0),(347624,9657,'sr','ÐŸÐž Ð£Ð½Ñ€ÐµÑ†ÐµÐ¸Ð²Ðµ',0),(347625,9657,'vi','chÆ°a nháº­n Ä‘Æ¡n mua hÃ ng',0),(347626,9657,'af','PO Unreceive',0),(347627,9657,'ro','PO Unreceive',0),(347628,9657,'et','PO Unreceive',0),(347629,9657,'si','PO Unreceive',0),(347630,9657,'ba','PO Unreceive',0),(347631,9657,'nl','PO Unreceive',0),(347632,9657,'fi','PO Unreceive',0),(347633,9657,'no','PO Unreceive',0),(347634,9657,'da','PO Unreceive',0),(347635,9657,'ko','í¬ Unreceive',0),(347636,9657,'he','×¤×• Unreceive',0),(347637,9657,'el','PO Unreceive',0),(347638,9657,'zh','è®¢å•æœªæŽ¥æ”¶\r\n',0),(347639,9657,'sv','PO Unreceive',0),(347640,9657,'it','PO Unreceive',0),(347641,9657,'tl','',0),(347642,9657,'th','&#3652;&#3617;&#3656;&#3619;&#3633;&#3610;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(347643,9657,'hi','à¤ªà¥‹ Unreceive',0),(347644,9657,'ms','PO Unreceive',0),(347645,9657,'ar','Øµ. Ø¨. Ø£ÙˆÙ†Ø±ÙŠØ³ÙŠÙÙŠ',0),(347646,9657,'fr','PO Unreceive',0),(347647,9657,'jp','PO Unreceive ã—ã¾ã™ã€‚',0),(347648,9657,'pt','PO Unreceive',0),(347649,9657,'ru','Ð¡ÐŸ Unreceive',0),(347650,9657,'es','No Recibe el OC',0),(347651,9657,'de','PO Unreceive',0),(347652,9657,'en','PO Unreceive',0),(347653,9658,'is','',0),(347654,9658,'dr','Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ ',0),(347655,9658,'pr','Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ ',0),(347656,9658,'tr','OluÅŸturulan faturalara iÃ§in',0),(347657,9658,'pl','Dla faktur utworzonych',0),(347658,9658,'bg','Ð—Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(347659,9658,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(347660,9658,'sr','Ð—Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð¸Ð¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð°',0),(347661,9658,'vi','cho hÃ³a Ä‘Æ¡n Ä‘Æ°á»£c táº¡o',0),(347662,9658,'af','Vir Fakture Geskep',0),(347663,9658,'ro','Pentru facturile create',0),(347664,9658,'et','Loodud arvete',0),(347665,9658,'si','Za raÄune, ki so ustvarili',0),(347666,9658,'ba','Untuk faktur dibuat',0),(347667,9658,'nl','Voor facturen gemaakt',0),(347668,9658,'fi','Laskujen on luotu',0),(347669,9658,'no','For fakturaer opprettet',0),(347670,9658,'da','For fakturaer, der oprettes',0),(347671,9658,'ko','ì²­êµ¬ì„œ ìž‘ì„±',0),(347672,9658,'he','×¢×‘×•×¨ ×—×©×‘×•× ×™×•×ª ×©× ×•×¦×¨×•',0),(347673,9658,'el','Î“Î¹Î± Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½Ï„Î±Î¹',0),(347674,9658,'zh','å»ºç«‹å‘ç¥¨\r\n',0),(347675,9658,'sv','FÃ¶r fakturor som skapats',0),(347676,9658,'it','Per le fatture create',0),(347677,9658,'tl','',0),(347678,9658,'th','&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3607;&#3637;&#3656;&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(347679,9658,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(347680,9658,'ms','Bagi invois-invois yang dicipta',0),(347681,9658,'ar','Ø¨Ø§Ù„Ù†Ø³Ø¨Ø© Ù„Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§',0),(347682,9658,'fr','Pour les factures crÃ©Ã©es',0),(347683,9658,'jp','è«‹æ±‚æ›¸ã®ä½œæˆ',0),(347684,9658,'pt','Para faturas criado',0),(347685,9658,'ru','Ð”Ð»Ñ Ð¡Ð¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(347686,9658,'es','Para Facturas Creadas',0),(347687,9658,'de','FÃ¼r Rechnungen erstellt',0),(347688,9658,'en','For Invoices Created',0),(347689,9659,'is','',0),(347690,9659,'dr','Ø­Ø³Ø§Ø¨ Ø´Ù…Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ù„Ø·ÙØ§ Ø§ÙƒÙ†ÙˆÙ† ÙˆØ§Ø±Ø¯ Ø³ÙŠØ³ØªÙ… Ø´ÙˆÙŠØ¯ ',0),(347691,9659,'pr','Ø­Ø³Ø§Ø¨ Ø´Ù…Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª â€“ Ù„Ø·ÙØ§ Ø§ÙƒÙ†ÙˆÙ† ÙˆØ§Ø±Ø¯ Ø³ÙŠØ³ØªÙ… Ø´ÙˆÙŠØ¯ ',0),(347692,9659,'tr','HesabÄ±nÄ±z oluÅŸturuldu. LÃ¼tfen ÅŸimdi oturum aÃ§Ä±n.',0),(347693,9659,'pl','Twoje konto zostaÅ‚o utworzone. Zaloguj siÄ™ teraz.',0),(347694,9659,'bg','Ð’Ð°ÑˆÐ¸ÑÑ‚ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ðµ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½. ÐœÐ¾Ð»Ñ, Ð²Ð»ÐµÐ·Ñ‚Ðµ ÑÐµÐ³Ð°.',0),(347695,9659,'ur','Ø¢Ù¾ Ú©Ø§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†Ø§ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û” Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù„Ø§Ú¯ Ø§ÙÙ† Ú©Ø±ÛŒÚº Û”',0),(347696,9659,'sr','Ð’Ð°Ñˆ Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½. ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ ÑÐµ ÑÐ°Ð´Ð°.',0),(347697,9659,'vi','TÃ i khoáº£n cá»§a báº¡n Ä‘Ã£ Ä‘Æ°á»£c táº¡o. Vui lÃ²ng truy cáº­p',0),(347698,9659,'af','U Rekening is geskep.  Teken asb. nou aan.',0),(347699,9659,'ro','Contul a fost creat. LogaÅ£i-vÄƒ acum.',0),(347700,9659,'et','Konto on loodud ja vÃµite sisse logida',0),(347701,9659,'si','VaÅ¡ raÄun je bil ustvarjen. Prijavite se zdaj.',0),(347702,9659,'ba','Akun anda telah dibuat. Harap kembali Log In',0),(347703,9659,'nl','Uw Account is aangemaakt. Log nu in.',0),(347704,9659,'fi','Tilisi on luotu. Kirjaudu sisÃ¤Ã¤n nyt.',0),(347705,9659,'no','Kontoen er opprettet. Logg pÃ¥ nÃ¥.',0),(347706,9659,'da','Din konto er blevet oprettet. Log venligst ind nu.',0),(347707,9659,'ko','ê³„ì • ìƒì„± ë˜ì—ˆìŠµë‹ˆë‹¤. ì§€ê¸ˆ ë¡œê·¸ì¸ í•˜ì‹­ì‹œì˜¤.',0),(347708,9659,'he','×”×—×©×‘×•×Ÿ ×©×œ×š × ×•×¦×¨. ×× × ×”×™×›× ×¡ ×¢×›×©×™×•.',0),(347709,9659,'el','Î£Î±Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î­Ï‡ÎµÎ¹ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸ÎµÎ¯. Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Ï„ÏŽÏÎ±.',0),(347710,9659,'zh','æ‚¨çš„å¸æˆ·å·²åˆ›å»ºã€‚è¯·çŽ°åœ¨ç™»å½•',0),(347711,9659,'sv','Ditt konto har skapats. Logga in nu.',0),(347712,9659,'it','Il tuo profilo Ã¨ stato creato correttamente. Puoi autenticarti ora.',0),(347713,9659,'tl','',0),(347714,9659,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3626;&#3619;&#3657;&#3634;&#3591;&#3649;&#3621;&#3657;&#3623; &#3585;&#3619;&#3640;&#3603;&#3634;&#3621;&#3655;&#3629;&#3585;&#3629;&#3636;&#3609;&#3605;&#',0),(347715,9659,'hi','à¤†à¤ªà¤•à¤¾ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤ à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤¬ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¥‡à¤‚à¥¤',0),(347716,9659,'ms','Akaun anda telah dibuat. Sila log masuk sekarang.',0),(347717,9659,'ar','ØªÙ… Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ. Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø¢Ù†.',0),(347718,9659,'fr','Votre compte a Ã©tÃ© crÃ©Ã©.\r\nIdentifiez-vous maintenant.',0),(347719,9659,'jp','ã‚ãªãŸã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒä½œæˆã•ã‚Œã¾ã—ãŸã€‚ä»Šã™ããƒ­ã‚°ã‚¤ãƒ³ã—ã¦ãã ã•ã„ã€‚',0),(347720,9659,'pt','Sua conta foi criada. Efetue o login agora.',0),(347721,9659,'ru','Ð’Ð°ÑˆÐ° ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð±Ñ‹Ð»Ð° ÑÐ¾Ð·Ð´Ð°Ð½Ð°. ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð¾Ð¹Ð´Ð¸Ñ‚Ðµ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ.',0),(347722,9659,'es','Se creÃ³ su cuenta. Por favor login ahora',0),(347723,9659,'de','Konto wurde erstellt. Bitte melden Sie sich jetzt an.',0),(347724,9659,'en','Your Account has been created. Please log in now.',0),(347725,9660,'is','',0),(347726,9660,'dr','Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ ',0),(347727,9660,'pr','Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ ',0),(347728,9660,'tr','Yeni hesap',0),(347729,9660,'pl','Nowe konto',0),(347730,9660,'bg','ÐÐ¾Ð² Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(347731,9660,'ur','Ù†ÛŒØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(347732,9660,'sr','ÐÐ¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(347733,9660,'vi','tÃ i khoáº£n má»›i',0),(347734,9660,'af','Nuwe Rekening',0),(347735,9660,'ro','Cont nou',0),(347736,9660,'et','Uus konto',0),(347737,9660,'si','Nov raÄun',0),(347738,9660,'ba','Akun baru',0),(347739,9660,'nl','Nieuwe Account',0),(347740,9660,'fi','Uusi tili',0),(347741,9660,'no','Ny konto',0),(347742,9660,'da','Ny konto',0),(347743,9660,'ko','ìƒˆ ê³„ì •',0),(347744,9660,'he','×—×©×‘×•×Ÿ ×—×“×©',0),(347745,9660,'el','ÎÎ­Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚',0),(347746,9660,'zh','æ–°çš„å¸æˆ·\r\n',0),(347747,9660,'sv','Nytt konto',0),(347748,9660,'it','Nuovo Account',0),(347749,9660,'tl','',0),(347750,9660,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3651;&#3627;&#3617;&#3656;',0),(347751,9660,'hi','à¤¨à¤¯à¤¾ à¤–à¤¾à¤¤à¤¾',0),(347752,9660,'ms','Akaun baru',0),(347753,9660,'ar','Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯',0),(347754,9660,'fr','Nouveau compte',0),(347755,9660,'jp','æ–°ã—ã„ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(347756,9660,'pt','Nova conta',0),(347757,9660,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÐŸÑ€Ð¾Ñ„Ð¸Ð»ÑŒ',0),(347758,9660,'es','Nueva Cuenta',0),(347759,9660,'de','Neues Konto',0),(347760,9660,'en','New Account',0),(347761,9661,'is','',0),(347762,9661,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ØªÙ†Ø¸ÙŠÙ… Ù…Ø¬Ø¯Ø¯',0),(347763,9661,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ØªÙ†Ø¸ÙŠÙ… Ù…Ø¬Ø¯Ø¯',0),(347764,9661,'tr','Parola sÄ±fÄ±rlama',0),(347765,9661,'pl','Resetowanie hasÅ‚a',0),(347766,9661,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(347767,9661,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(347768,9661,'sr','ÐŸÐ¾Ð½Ð¸ÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ',0),(347769,9661,'vi','táº¡p láº¡i máº­t kháº©u',0),(347770,9661,'af','Wagwoord is Teruggestel',0),(347771,9661,'ro','Reseteaza parola',0),(347772,9661,'et','Nulli salasÃµna',0),(347773,9661,'si','Ponastavitev gesla',0),(347774,9661,'ba','Membuat ulang sandi',0),(347775,9661,'nl','Reset wachtwoord',0),(347776,9661,'fi','Vaihda salasana',0),(347777,9661,'no','Tilbakestill passord',0),(347778,9661,'da','Nulstil adgangskode',0),(347779,9661,'ko','ì•”í˜¸ ë‹¤ì‹œ ì„¤ì •',0),(347780,9661,'he','××™×¤×•×¡ ×¡×™×¡×ž×”',0),(347781,9661,'el','Î•Ï€Î±Î½Î±Ï†Î¿ÏÎ¬ ÎºÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(347782,9661,'zh','é‡è®¾å¯†ç \r\n',0),(347783,9661,'sv','Ã…terstÃ¤ll lÃ¶senord',0),(347784,9661,'it','Reimpostare la Password',0),(347785,9661,'tl','',0),(347786,9661,'th','&#3588;&#3656;&#3634;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3648;&#3588;&#3619;&#3639;&#3656;&#3629;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(347787,9661,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤°à¥€à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(347788,9661,'ms','Set semula kata laluan',0),(347789,9661,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ±',0),(347790,9661,'fr','RÃ©initialiser mot de passe',0),(347791,9661,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’ãƒªã‚»ãƒƒãƒˆã—ã¾ã™ã€‚',0),(347792,9661,'pt','Redefinir senha',0),(347793,9661,'ru','Ð¡Ð±Ñ€Ð¾Ñ Ð¿Ð°Ñ€Ð¾Ð»Ñ',0),(347794,9661,'es','Reintroduce el Password',0),(347795,9661,'de','Passwort zurÃ¼cksetzen',0),(347796,9661,'en','Reset Password',0),(347797,9662,'is','',0),(347798,9662,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ  Ø§ÙŠØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨',0),(347799,9662,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ  Ø§ÙŠØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨',0),(347800,9662,'tr','Hesap oluÅŸturma yardÄ±m',0),(347801,9662,'pl','Pomoc dotyczÄ…ca tworzenia konta',0),(347802,9662,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ Ð·Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(347803,9662,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªØ®Ù„ÛŒÙ‚ Ù…Ø¯Ø¯',0),(347804,9662,'sr','ÐŸÐ¾Ð¼Ð¾Ñ› Ð·Ð° ÑÑ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(347805,9662,'vi','GiÃºp Ä‘á»¡ táº¡o tÃ i khoáº£n',0),(347806,9662,'af','Hulp met Skep van \'n Rekening',0),(347807,9662,'ro','Ajutor de creare cont',0),(347808,9662,'et','Konto loomise abi',0),(347809,9662,'si','RaÄun ustvarjanja pomoÄ',0),(347810,9662,'ba','Bantuan Pembuatan Akun',0),(347811,9662,'nl','Hulp bij maken van accounts',0),(347812,9662,'fi','Tilin luominen-ohjeet',0),(347813,9662,'no','Etableringen hjelp',0),(347814,9662,'da','Konto skabelse hjÃ¦lp',0),(347815,9662,'ko','ê³„ì • ë§Œë“¤ê¸° ë„ì›€',0),(347816,9662,'he','×¢×–×¨×” ×™×¦×™×¨×ª ×—×©×‘×•×Ÿ',0),(347817,9662,'el','Î’Î¿Î®Î¸ÎµÎ¹Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(347818,9662,'zh','å¸®åŠ©å¸æˆ·å»ºç«‹',0),(347819,9662,'sv','HjÃ¤lp fÃ¶r skapande av konto',0),(347820,9662,'it','Aiuto nella creazione del profilo',0),(347821,9662,'tl','',0),(347822,9662,'th','&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(347823,9662,'hi','à¤–à¤¾à¤¤à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾',0),(347824,9662,'ms','Bantuan penciptaan akaun',0),(347825,9662,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø¥Ù†Ø´Ø§Ø¡ Ø­Ø³Ø§Ø¨',0),(347826,9662,'fr','Aide pour la crÃ©ation du compte',0),(347827,9662,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ä½œæˆã«å½¹ç«‹ã¤',0),(347828,9662,'pt','Ajuda de criaÃ§Ã£o de conta',0),(347829,9662,'ru','ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ Ð’ Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ð¸ ÐŸÑ€Ð¾Ñ„Ð¸Ð»Ñ',0),(347830,9662,'es','Ayuda de la ConfiguraciÃ³n de la Cuenta',0),(347831,9662,'de','Hilfe fÃ¼r Kontenerstellung',0),(347832,9662,'en','Account Creation Help',0),(347833,9663,'is','',0),(347834,9663,'dr','ÙŠÙƒ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ØµØ­ÙŠØ­ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ Ø­Ø³Ø§Ø¨ Ø´Ù…Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(347835,9663,'pr','ÙŠÙƒ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ØµØ­ÙŠØ­ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ Ø­Ø³Ø§Ø¨ Ø´Ù…Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(347836,9663,'tr','HesabÄ± kullanÄ±cÄ± adÄ±nÄ±z kullanÄ±lmak Ã¼zere geÃ§erli bir e-posta adresi girin.',0),(347837,9663,'pl','WprowadÅº prawidÅ‚owy adres E-mail, aby byÄ‡ uÅ¼ywany jako Twoja nazwa uÅ¼ytkownika konta.',0),(347838,9663,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° ÐºÐ°Ñ‚Ð¾ Ð²Ñ…Ð¾Ð´ Ð² Ð¿Ñ€Ð¾Ñ„Ð¸Ð»Ð° ÑÐ¸.',0),(347839,9663,'ur','Ø§Ù¾Ù†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ ØµØ§Ø±Ù Ù†Ø§Ù… Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ø¬Ø§Ø¦Ø² Ù¾ØªØ§ Ø§ÛŒ Ù…ÛŒÙ„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(347840,9663,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð²Ð°Ð¶ÐµÑ›Ñƒ Ð°Ð´Ñ€ÐµÑÑƒ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ Ñ›Ðµ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ ÐºÐ°Ð¾ Ð²Ð°ÑˆÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°.',0),(347841,9663,'vi','Nháº­p Ä‘á»‹a chá»‰ thÆ° Ä‘iá»‡n tá»­ Ä‘á»ƒ sá»­ dá»¥ng tÃ i khoáº£n cá»§a báº¡n.',0),(347842,9663,'af','Voer \'n geldige E-posadres in om te gebruik as u Rekeninggebruikersnaam.',0),(347843,9663,'ro','Introduceti o adresa valida de E-mail pentru a fi folosit ca numele contului de utilizator.',0),(347844,9663,'et','Sisesta kehtiv e-maili aadress, mida kasutatakse sinu konto kasutajanimena',0),(347845,9663,'si','Vnesite veljaven e-poÅ¡tni naslov, ki se uporabljajo kot vaÅ¡e uporabniÅ¡ko ime za raÄun.',0),(347846,9663,'ba','Masukkan alamat email yang berlaku untuk digunakan sebagai Akun nama pengguna',0),(347847,9663,'nl','Voer een geldig e-mailadres moet worden gebruikt als de gebruikersnaam van uw Account.',0),(347848,9663,'fi','Anna kelvollinen sÃ¤hkÃ¶postiosoite kÃ¤ytetÃ¤Ã¤n tilisi kÃ¤yttÃ¤jÃ¤tunnus.',0),(347849,9663,'no','Angi en gyldig e-postadresse som brukernavnet for kontoen.',0),(347850,9663,'da','Angiv en gyldig E-mail-adresse bruges som brugernavnet til din konto.',0),(347851,9663,'ko','ê³„ì • ì‚¬ìš©ìž ì´ë¦„ìœ¼ë¡œ ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” ìœ íš¨í•œ ì´ë©”ì¼ ì£¼ì†Œë¥¼ ìž…ë ¥ í•©ë‹ˆë‹¤.',0),(347852,9663,'he','×”×–×Ÿ ×›×ª×•×‘×ª ×“×•× ×œ ×—×•×§×™×ª ×›×“×™ ×œ×©×ž×© ××ª ×©× ×—×©×‘×•×Ÿ ×”×ž×©×ª×ž×© ×©×œ×š.',0),(347853,9663,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î­Î³ÎºÏ…ÏÎ· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Ï€Î¿Ï… Î¸Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ Ï‰Ï‚ ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï ÏƒÎ±Ï‚.',0),(347854,9663,'zh','è¾“å…¥ä¸€ä¸ªæœ‰æ•ˆçš„ç”µå­é‚®ä»¶åœ°å€ä½œä¸ºæ‚¨å¸æˆ·çš„ç”¨æˆ·åä½¿ç”¨ã€‚\r\n',0),(347855,9663,'sv','Ange en giltig e-postadress som ska anvÃ¤ndas som anvÃ¤ndarnamn fÃ¶r ditt konto.',0),(347856,9663,'it','Inserisci un indirizzo email valido come Nome Utente per il tuo profilo.',0),(347857,9663,'tl','',0),(347858,9663,'th','&#3611;&#3657;&#3629;&#3609;&#3629;&#3637;&#3648;&#3617;&#3621;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3605;&#3657;&#3629;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3651;&#3594;&#3657;&#3648;&#3611;&#3655;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3',0),(347859,9663,'hi','à¤…à¤ªà¤¨à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤®à¤¾à¤¨à¥à¤¯ à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(347860,9663,'ms','Masukkan alamat e-mel yang sah untuk digunakan sebagai nama pengguna akaun anda.',0),(347861,9663,'ar','Ø£Ø¯Ø®Ù„ \"Ø¹Ù†ÙˆØ§Ù† Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ\" ØµØ§Ù„Ø­ Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…Ù‡ \"Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…\" Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ.',0),(347862,9663,'fr','Entrer une adresse courriel valide, elle sera utilisÃ©e comme nom d\'utilisateur de votre compte.',0),(347863,9663,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ãƒ¦ãƒ¼ã‚¶ãƒ¼åã¨ã—ã¦ä½¿ç”¨ã™ã‚‹æœ‰åŠ¹ãªé›»å­ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(347864,9663,'pt','Digite um endereÃ§o de E-mail vÃ¡lido para ser usado como seu nome de usuÃ¡rio da conta.',0),(347865,9663,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ Email ÐÐ´Ñ€ÐµÑ ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ð¹ Ð±ÑƒÐ´ÐµÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒÑÑ ÐºÐ°Ðº Ð˜Ð¼Ñ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð²Ð°ÑˆÐµÐ³Ð¾ ÐŸÑ€Ð¾Ñ„Ð¸Ð»Ñ.',0),(347866,9663,'es','Introducir una DirecciÃ³n de Email que se usarÃ¡ como su Nombre de Usuario ',0),(347867,9663,'de','Bitte als Benutzername eine aktive Email-Adresse angeben',0),(347868,9663,'en','Enter a valid Email Address to be used as your Account Username.',0),(347869,9664,'is','',0),(347870,9664,'dr','Ù„Ø·ÙØ§ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ Ùˆ Ø³Ù¾Ø³ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ø± Ø¯ÙˆÙ… Ù†ÙŠØ² Ø¢Ù†Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(347871,9664,'pr','Ù„Ø·ÙØ§ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø®ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ Ùˆ Ø³Ù¾Ø³ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø¨Ø§Ø± Ø¯ÙˆÙ… Ù†ÙŠØ² Ø¢Ù†Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(347872,9664,'tr','LÃ¼tfen parolanÄ±zÄ± bir kez ve daha sonra ikinci kez onaylamak iÃ§in girin.',0),(347873,9664,'pl','ProszÄ™ wprowadziÄ‡ hasÅ‚o raz i nastÄ™pnie drugi raz, aby potwierdziÄ‡.',0),(347874,9664,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð°Ñ‚Ð° ÑÐ¸ Ð²ÐµÐ´Ð½ÑŠÐ¶ Ð¸ ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð° Ð·Ð° Ð²Ñ‚Ð¾Ñ€Ð¸ Ð¿ÑŠÑ‚, Ð·Ð° Ð´Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´Ð¸Ñ‚Ðµ.',0),(347875,9664,'ur','Ø§ÛŒÚ© Ø¨Ø§Ø± Ø¢Ù¾ Ø§Ù¾Ù†Ø§ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø§ÙˆØ± Ø¯ÙˆØ³Ø±ÛŒ Ø¨Ø§Ø± ØªØµØ¯ÛŒÙ‚ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(347876,9664,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ñ˜ÐµÐ´Ð½Ð¾Ð¼ Ð¸ Ð¾Ð½Ð´Ð° Ð´Ñ€ÑƒÐ³Ð¸ Ð¿ÑƒÑ‚ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ð»Ð¸.',0),(347877,9664,'vi','Vui lÃ²ng Ä‘Äƒng nháº­p máº­t kháº©u vÃ  sau Ä‘Ã³ nháº­p láº§n 2 Ä‘á»ƒ xÃ¡c nháº­n.',0),(347878,9664,'af','Voer asb. u wagwoord eenmalig in en dan vir \'n tweede keer ter bevestig.',0),(347879,9664,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i parola o singurÄƒ datÄƒ ÅŸi apoi a doua oarÄƒ pentru a confirma.',0),(347880,9664,'et','Palun sisesta oma salasÃµna ning kinnita',0),(347881,9664,'si','Vnesite geslo enkrat in nato Å¡e enkrat potrditi.',0),(347882,9664,'ba','Masukkan password satu kali kemudian ulangi untuk konfirmasi',0),(347883,9664,'nl','Voer uw wachtwoord Ã©Ã©n keer en dan een tweede keer te bevestigen.',0),(347884,9664,'fi','Kirjoita salasana kerran ja sitten toisen kerran vahvistaa.',0),(347885,9664,'no','Angi passordet en gang og deretter en gang for Ã¥ bekrefte.',0),(347886,9664,'da','Angiv venligst dit Password en gang og derefter en anden gang for at bekrÃ¦fte.',0),(347887,9664,'ko','í•œ ë²ˆì— ê·€í•˜ì˜ ë¹„ë°€ ë²ˆí˜¸ë¥¼ ë‹¤ìŒ ë‘ ë²ˆì§¸ ì‹œê°„ í™•ì¸ì„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤.',0),(347888,9664,'he','×”×–×™× ×• ×‘×‘×§×©×” ××ª ×”×¡×™×¡×ž×” ×©×œ×š ×¤×¢× ××—×ª ×ž×›×Ÿ ×¤×¢× ×©× ×™×™×” ×›×“×™ ×œ××©×¨.',0),(347889,9664,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ®Ï‚ ÏƒÎ±Ï‚ Î¼Î¯Î± Ï†Î¿ÏÎ¬ ÎºÎ±Î¹, ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î±, Î¼Î¹Î± Î´ÎµÏÏ„ÎµÏÎ· Ï†Î¿ÏÎ¬ Î³Î¹Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·.',0),(347890,9664,'zh','è¯·è¾“å…¥æ‚¨çš„å¯†ç ä¸€æ¬¡ï¼Œç„¶åŽç¬¬äºŒæ¬¡ç¡®è®¤ã€‚\r\n',0),(347891,9664,'sv','VÃ¤nligen ange ditt lÃ¶senord en gÃ¥ng och sedan en andra gÃ¥ng fÃ¶r att bekrÃ¤fta.',0),(347892,9664,'it','Inserisci la tua password una volta e poi una seconda per confermarla.',0),(347893,9664,'tl','',0),(347894,9664,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3585;&#3619;&#3629;&#3585;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3629;&#3637;&#3585;&#3588;&#3619;&#3633;&#3657;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3',0),(347895,9664,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤ªà¤¨à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤à¤• à¤¬à¤¾à¤° à¤”à¤° à¤‰à¤¸à¤•à¥‡ à¤¬à¤¾à¤¦ à¤à¤• à¤¦à¥‚à¤¸à¤°à¥€ à¤¬à¤¾à¤° à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(347896,9664,'ms','Sila masukkan kata laluan anda dan kemudian kali kedua untuk mengesahkan.',0),(347897,9664,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ Ù…Ø±Ø© ÙˆØ§Ø­Ø¯Ø© ÙˆØ«Ù… Ù…Ø±Ø© Ø«Ø§Ù†ÙŠØ© Ù„Ù„ØªØ£ÙƒÙŠØ¯.',0),(347898,9664,'fr','Entrer votre mot de passe une fois et une seconde fois pour confirmer.',0),(347899,9664,'jp','ä¸€åº¦ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã¨ã€2 ç•ªç›®ã®æ™‚é–“ã‚’ç¢ºèªã™ã‚‹ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(347900,9664,'pt','Por favor, digite sua senha uma vez e depois uma segunda vez para confirmar.',0),(347901,9664,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ð¹ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð¸ Ð¿Ð¾Ñ‚Ð¾Ð¼ ÐµÑ‰Ðµ Ñ€Ð°Ð· Ð´Ð»Ñ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ.',0),(347902,9664,'es','Por favor ingresa su Password una vez y luego una segunda vez para confirmarlo',0),(347903,9664,'de','Bitte das Kennwort eingeben und 2. Mal bestÃ¤tigen',0),(347904,9664,'en','Please enter your Password once and then a second time to confirm.',0),(347905,9665,'is','',0),(347906,9665,'dr','ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(347907,9665,'pr','ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(347908,9665,'tr','Bu e-posta adresine sahip bir hesap zaten var.',0),(347909,9665,'pl','Konta z tego adres E-mail juÅ¼ istnieje.',0),(347910,9665,'bg','Ð’ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ñ Ñ‚Ð¾Ð·Ð¸ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ.',0),(347911,9665,'ur','Ø§Ø³ Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÛŒÚˆØ±ÛŒØ³ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Û”',0),(347912,9665,'sr','ÐÐ°Ð»Ð¾Ð³ ÑÐ° Ñ‚Ð¾Ð¼ Ðµ-Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(347913,9665,'vi','Má»™t tÃ i khoáº£n vá»›i Ä‘á»‹a chá»‰ Email Ä‘Ã£ tá»“n táº¡i.',0),(347914,9665,'af','\'n Rekening met daardie E-pos Adres bestaan alreeds.',0),(347915,9665,'ro','ExistÄƒ deja un cont cu acea adresÄƒ de E-mail.',0),(347916,9665,'et','See e-posti aadressiga konto on juba olemas.',0),(347917,9665,'si','RaÄun s tem e-poÅ¡tni naslov Å¾e obstaja.',0),(347918,9665,'ba','Akun dengan alamat Email yang sudah ada.',0),(347919,9665,'nl','Er bestaat al een Account met dat e-mailadres.',0),(347920,9665,'fi','Tilin kyseinen sÃ¤hkÃ¶postiosoite on jo olemassa.',0),(347921,9665,'no','Det finnes allerede en konto med denne e-postadressen.',0),(347922,9665,'da','Der findes allerede en konto med denne E-mail-adresse.',0),(347923,9665,'ko','ê·¸ ì´ë©”ì¼ ì£¼ì†Œë¥¼ ê°€ì§„ ê³„ì •ì´ ì´ë¯¸ ì¡´ìž¬í•©ë‹ˆë‹¤.',0),(347924,9665,'he','×—×©×‘×•×Ÿ ×¢× ×›×ª×•×‘×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™ ×–×• ×›×‘×¨ ×§×™×™×ž×ª.',0),(347925,9665,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î¼Îµ ÏŒÏ„Î¹ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·.',0),(347926,9665,'zh','æ‹¥æœ‰è¯¥ç”µå­é‚®ä»¶åœ°å€çš„å¸æˆ·å·²ç»å­˜åœ¨',0),(347927,9665,'sv','Det finns redan ett konto med den e-postadressen.',0),(347928,9665,'it','Esiste giÃ  un Account con tale indirizzo Email.',0),(347929,9665,'tl','',0),(347930,9665,'th','&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3617;&#3637;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;&#3649;&#3621;&#3657;&#3623;',0),(347931,9665,'hi','à¤‰à¤¸ à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤–à¤¾à¤¤à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆà¥¤',0),(347932,9665,'ms','Akaun dengan alamat e-mel tersebut telah wujud.',0),(347933,9665,'ar','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… \"Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ\" Ù‡Ø°Ø§ Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„.',0),(347934,9665,'fr','Un compte avec cette adresse E-mail existe dÃ©jÃ .',0),(347935,9665,'jp','ãã®ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã¯æ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(347936,9665,'pt','JÃ¡ existe uma conta com esse endereÃ§o de Email.',0),(347937,9665,'ru','Ð£Ð¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ñ ÑÑ‚Ð¸Ð¼ Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹.',0),(347938,9665,'es','Una Cuenta con esa DirecciÃ³n de Email ya existe',0),(347939,9665,'de','Ein Konto mit dieser e-Mail-Adresse ist bereits vorhanden.',0),(347940,9665,'en','An Account with that Email Address already exists.',0),(347941,9666,'is','',0),(347942,9666,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³',0),(347943,9666,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³',0),(347944,9666,'tr','Ä°letiÅŸim bilgileri',0),(347945,9666,'pl','Informacje kontaktowe',0),(347946,9666,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(347947,9666,'ur','Ø±Ø§Ø¨Ø·Û Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(347948,9666,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(347949,9666,'vi','thÃ´ng tin liÃªn há»‡',0),(347950,9666,'af','Kontak Inligting',0),(347951,9666,'ro','InformaÅ£ii de contact',0),(347952,9666,'et','Kontaktinfo',0),(347953,9666,'si','Kontaktni podatki',0),(347954,9666,'ba','Informasi kontak',0),(347955,9666,'nl','Contact informatie',0),(347956,9666,'fi','Yhteystiedot',0),(347957,9666,'no','Kontaktinformasjon',0),(347958,9666,'da','Kontaktoplysninger',0),(347959,9666,'ko','ì—°ë½ì²˜ ì •ë³´',0),(347960,9666,'he','×ž×™×“×¢ ×œ×™×¦×™×¨×ª ×§×©×¨',0),(347961,9666,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚',0),(347962,9666,'zh','è”ç³»ä¿¡æ¯\r\n',0),(347963,9666,'sv','Kontaktuppgifter',0),(347964,9666,'it','Informazioni di contatto',0),(347965,9666,'tl','',0),(347966,9666,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;',0),(347967,9666,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(347968,9666,'ms','Maklumat untuk dihubungi',0),(347969,9666,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¥ØªØµØ§Ù„',0),(347970,9666,'fr','Informations de contact',0),(347971,9666,'jp','é€£çµ¡å…ˆæƒ…å ±',0),(347972,9666,'pt','InformaÃ§Ãµes de contato',0),(347973,9666,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð°Ñ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(347974,9666,'es','InformaciÃ³n de Contacto',0),(347975,9666,'de','Kontakt-Informationen',0),(347976,9666,'en','Contact Information',0),(347977,9667,'is','',0),(347978,9667,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³',0),(347979,9667,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³',0),(347980,9667,'tr','Ä°letiÅŸim bilgileri yardÄ±m',0),(347981,9667,'pl','Pomoc informacje kontaktowe',0),(347982,9667,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸ Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(347983,9667,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ Ù…Ø¯Ø¯ Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº',0),(347984,9667,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸',0),(347985,9667,'vi','trá»£ giÃºp thÃ´ng tin liÃªn há»‡',0),(347986,9667,'af','Kontak Inligting Hulp',0),(347987,9667,'ro','InformaÅ£iile de contact ajutor',0),(347988,9667,'et','Kontaktinfo abi',0),(347989,9667,'si','Kontaktne informacije pomoÄ',0),(347990,9667,'ba','Informasi kontak bantuan',0),(347991,9667,'nl','Contactinformatie hulp',0),(347992,9667,'fi','Yhteystiedot-Help',0),(347993,9667,'no','Kontaktinformasjon hjelp',0),(347994,9667,'da','Kontaktoplysninger hjÃ¦lp',0),(347995,9667,'ko','ì—°ë½ì²˜ ì •ë³´ ë„ì›€ë§',0),(347996,9667,'he','×ž×™×“×¢ ×œ×™×¦×™×¨×ª ×§×©×¨ ×¢×–×¨×”',0),(347997,9667,'el','Î’Î¿Î®Î¸ÎµÎ¹Î± Î•Ï€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±',0),(347998,9667,'zh','è”ç³»ä¿¡æ¯å¸®åŠ©\r\n',0),(347999,9667,'sv','Kontakta Information hjÃ¤lp',0),(348000,9667,'it','Informazioni di contatto aiuto',0),(348001,9667,'tl','',0),(348002,9667,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;',0),(348003,9667,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¤¦à¤¦',0),(348004,9667,'ms','Maklumat bantuan',0),(348005,9667,'ar','Ù…Ø³Ø§Ø¹Ø¯Ø© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¥ØªØµØ§Ù„',0),(348006,9667,'fr','Informations de contact aide',0),(348007,9667,'jp','é€£çµ¡å…ˆæƒ…å ±ã®ãƒ˜ãƒ«ãƒ—',0),(348008,9667,'pt','InformaÃ§Ãµes de contato ajuda',0),(348009,9667,'ru','ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð¾Ð¹ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸',0),(348010,9667,'es','Ayuda de InformaciÃ³n de Contacto',0),(348011,9667,'de','Kontakt Informationen-Hilfe',0),(348012,9667,'en','Contact Information Help',0),(348013,9668,'is','',0),(348014,9668,'dr','ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ù‡ Ø¬Ø² Ø¨Ø±Ø§ÙŠ Ø§Ø³Ù… Ø¯ÙˆÙ…  Ø²ÙŠØ± Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³  Ù„Ø§Ø²Ù… Ù‡Ø³ØªÙ†Ø¯ ',0),(348015,9668,'pr','ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ù‡ Ø¬Ø² Ø¨Ø±Ø§ÙŠ Ø§Ø³Ù… Ø¯ÙˆÙ…  Ø²ÙŠØ± Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³  Ù„Ø§Ø²Ù… Ù‡Ø³ØªÙ†Ø¯ ',0),(348016,9668,'tr','GÃ¶bek adÄ± altÄ±nda iletiÅŸim bilgileri dÄ±ÅŸÄ±ndaki tÃ¼m alanlar gereklidir.',0),(348017,9668,'pl','Wszystkie pola z wyjÄ…tkiem imienia pod informacje kontaktowe sÄ… wymagane.',0),(348018,9668,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° Ñ Ð¸Ð·ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ Ð½Ð° Ð±Ð°Ñ‰Ð¸Ð½Ð¾ Ð¸Ð¼Ðµ Ð¿Ð¾Ð´ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ ÑÐ° Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸.',0),(348019,9668,'ur','Ø³ÙˆØ§Ø¦Û’ Ø¯Ø±Ù…ÛŒØ§Ù†ÛŒ Ù†Ø§Ù… Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ ØªØ­Øª ØªÙ…Ø§Ù… Ù‚Ø·Ø¹Ø§Øª Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(348020,9668,'sr','Ð¡Ð²Ð° Ð¿Ð¾Ñ™Ð° Ð¾ÑÐ¸Ð¼ ÑÑ€ÐµÐ´ÑšÐµ Ð¸Ð¼Ðµ Ð¿Ð¾Ð´ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ ÑÑƒ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ.',0),(348021,9668,'vi','táº¥t cáº£ cÃ¡c trÆ°á»ng ngoáº¡i trá»« pháº§n tÃªn giá»¯a dÆ°á»›i thÃ´ng tin liÃªn láº¡ Ä‘Æ°á»£c yÃªu cáº§u',0),(348022,9668,'af','Alle velde buiten vir Tweede Naam onder Kontak Inligting word benodig.',0),(348023,9668,'ro','Toate cÃ¢mpurile cu excepÅ£ia Prenume Ã®n conformitate cu informaÅ£iile de Contact sunt obligatorii.',0),(348024,9668,'et','KÃµik vÃ¤ljad v.a Teine Nimi kontaktinfo all on kohustuslikud',0),(348025,9668,'si','Je treba vsa polja razen drugo ime pod Kontakt.',0),(348026,9668,'ba','Semua kecuali nama tengah di bawah informasi kontak harus diisi.',0),(348027,9668,'nl','Alle velden met uitzondering van de middelste naam onder contactinformatie zijn vereist.',0),(348028,9668,'fi','Kaikki kentÃ¤t lukuun ottamatta toinen nimi alle Yhteystiedot tarvitaan.',0),(348029,9668,'no','Alle felt unntatt mellomnavn under kontaktinformasjon er nÃ¸dvendig.',0),(348030,9668,'da','Alle felter undtagen mellemnavn under kontaktoplysninger er pÃ¥krÃ¦vet.',0),(348031,9668,'ko','ì—°ë½ì²˜ ì •ë³´ì—ì„œ ì¤‘ê°„ ì´ë¦„ ì œì™¸í•œ ëª¨ë“  í•„ë“œëŠ” í•„ìˆ˜ìž…ë‹ˆë‹¤.',0),(348032,9668,'he','×›×œ ×”×©×“×•×ª ×ž×œ×‘×“ ×”×©× ×”××ž×¦×¢×™ ×ª×—×ª ×¤×¨×˜×™ ×× ×©×™ ×”×§×©×¨ × ×“×¨×©×™×.',0),(348033,9668,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹ ÏŒÎ»Î± Ï„Î± Ï€ÎµÎ´Î¯Î± ÎµÎºÏ„ÏŒÏ‚ Î±Ï€ÏŒ Ï„Î¿ Î¼ÎµÏƒÎ±Î¯Î¿ ÏŒÎ½Î¿Î¼Î± Ï…Ï€ÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚.',0),(348034,9668,'zh','é™¤äº†ä¸­é—´åå­—è”ç³»ä¿¡æ¯åç§°æ‰€æœ‰å­—æ®µéƒ½æ˜¯å¿…éœ€çš„',0),(348035,9668,'sv','Alla fÃ¤lt utom mellannamn enligt kontaktuppgifter Ã¤r obligatoriska.',0),(348036,9668,'it','Tutti i campi ad eccezione di secondo nome in informazioni di contatto sono necessari.',0),(348037,9668,'tl','',0),(348038,9668,'th','All fields except for Middle Name under Contact Information are required.',0),(348039,9668,'hi','à¤®à¤§à¥à¤¯ à¤¨à¤¾à¤® à¤¸à¤‚à¤ªà¤°à¥à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤…à¤‚à¤¤à¤°à¥à¤—à¤¤ à¤•à¥‹ à¤›à¥‹à¤¡à¤¼à¤•à¤° à¤¸à¤­à¥€ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¤‚à¥¤',0),(348040,9668,'ms','Semua bidang kecuali nama tengah di bawah maklumat orang hubungan yang diperlukan.',0),(348041,9668,'ar','ÙƒØ§ÙØ© Ø§Ù„Ø­Ù‚ÙˆÙ„ ÙÙŠÙ…Ø§ Ø¹Ø¯Ø§ Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆØ³Ø· ØªØ­Øª \"Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„\" Ù…Ø·Ù„ÙˆØ¨Ø©.',0),(348042,9668,'fr','Les champs Ã  lâ€™exception du prÃ©nom sous les informations de Contact sont obligatoires.',0),(348043,9668,'jp','é€£çµ¡å…ˆæƒ…å ±ã®ä¸‹ã§ãƒŸãƒ‰ãƒ«ãƒãƒ¼ãƒ ã‚’é™¤ãã™ã¹ã¦ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ãŒå¿…è¦ã§ã™ã€‚',0),(348044,9668,'pt','Todos os campos exceto nome do meio em informaÃ§Ãµes de contato sÃ£o necessÃ¡rios.',0),(348045,9668,'ru','Ð’ÑÐµ Ð¿Ð¾Ð»Ñ, Ð·Ð° Ð¸ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ÐµÐ¼ Ð¾Ñ‚Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ.',0),(348046,9668,'es','Todos los Campos aparte del Segundo Nombre bajo InformaciÃ³n de Contacto son Requeridos',0),(348047,9668,'de','Alle Felder mit Ausnahme der zweiten Vornamen unter Kontaktinformationen sind erforderlich.',0),(348048,9668,'en','All fields except for Middle Name under Contact Information are required.',0),(348049,9669,'is','',0),(348050,9669,'dr','ÙØ±Ù… Ø²ÙŠØ± Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ù…Ø³ØªØ§ Ø¬Ø± Ø®ÙˆØ¯  Ù¾Ø± ÙƒÙ†ÙŠØ¯',0),(348051,9669,'pr','ÙØ±Ù… Ø²ÙŠØ± Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ù…Ø³ØªØ§ Ø¬Ø± Ø®ÙˆØ¯  Ù¾Ø± ÙƒÙ†ÙŠØ¯',0),(348052,9669,'tr','KiracÄ± hesabÄ±nÄ±zÄ± oluÅŸturmak iÃ§in aÅŸaÄŸÄ±daki formu doldurunuz.',0),(348053,9669,'pl','WypeÅ‚nij poniÅ¼szy formularz, aby utworzyÄ‡ konto dzierÅ¼awcy.',0),(348054,9669,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð° Ð¿Ð¾ Ð´Ð¾Ð»Ñƒ Ð·Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ñ„Ð¸Ð»Ð° ÑÐ¸ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ».',0),(348055,9669,'ur','Ø§Ø³ Ø§Ù¾Ù†Û’ Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†ÛŒÚ†Û’ Ø¯ÛŒØ¦Û’ Ú¯Ø¦Û’ ÙØ§Ø±Ù… Ú©Ùˆ Ù¾ÙØ± Ú©Ø±ÛŒÚº Û”',0),(348056,9669,'sr','ÐŸÐ¾Ð¿ÑƒÐ½Ð¸Ñ‚Ðµ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð°Ñ€ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð²Ð°Ñˆ Ð½Ð°Ð»Ð¾Ð³ ÑÑ‚Ð°Ð½Ð°Ñ€.',0),(348057,9669,'vi','Ä‘iá»n máº«u dÆ°á»›i Ä‘á»ƒ táº¡o tÃ i khoáº£n Tenant',0),(348058,9669,'af','Vul die vorm hieronder in om u Verhuurderrekening te skep.',0),(348059,9669,'ro','CompletaÅ£i formularul de mai jos pentru a crea contul chiriaÅŸ.',0),(348060,9669,'et','TÃ¤ida alljÃ¤rgnev vorm, et luua konto Ã¼Ã¼rnik.',0),(348061,9669,'si','Izpolnite spodnji obrazec za ustvarjanje raÄuna najemnika.',0),(348062,9669,'ba','Mengisi formulir di bawah untuk membuat akun penyewa.',0),(348063,9669,'nl','Vul het formulier hieronder om uw Account van de huurder.',0),(348064,9669,'fi','TÃ¤ytÃ¤ lomake alla vuokralainen-tilin luomisessa.',0),(348065,9669,'no','Fyll ut skjemaet nedenfor for Ã¥ opprette kontoen leietaker.',0),(348066,9669,'da','Udfyld formularen nedenfor for at oprette kontoen lejer.',0),(348067,9669,'ko','ê±°ì£¼ìž ê³„ì •ì„ ë§Œë“¤ë ¤ë©´ ì•„ëž˜ ì–‘ì‹ì„ ìž‘ì„± í•˜ì‹­ì‹œì˜¤.',0),(348068,9669,'he','×ž×œ××• ××ª ×”×˜×•×¤×¡ ×©×œ×”×œ×Ÿ ×›×“×™ ×œ×™×¦×•×¨ ×—×©×‘×•×Ÿ ×”×“×™×™×¨ ×©×œ×š.',0),(348069,9669,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏŽÏƒÏ„Îµ Ï„Î·Î½ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Ï†ÏŒÏÎ¼Î± Î³Î¹Î± Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÎ±Ï‚ Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½.',0),(348070,9669,'zh','å¡«å†™ä»¥ä¸‹è¡¨æ ¼ï¼Œä»¥åˆ›å»ºç§Ÿå®¢å¸æˆ·ã€‚\r\n',0),(348071,9669,'sv','Fyll i formulÃ¤ret nedan fÃ¶r att skapa kontot hyresgÃ¤st.',0),(348072,9669,'it','Compila il modulo qui sotto per creare il tuo Account Tenant.',0),(348073,9669,'tl','',0),(348074,9669,'th','&#3585;&#3619;&#3629;&#3585;&#3649;&#3610;&#3610;&#3615;&#3629;&#3619;&#3660;&#3617;&#3604;&#3657;&#3634;&#3609;&#3621;&#3656;&#3634;&#3591;&#3648;&#3614;&#3639;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3612;&#3641;&#3657;&#3588;&#3619;&#3629;&#3',0),(348075,9669,'hi','à¤…à¤ªà¤¨à¥‡ Tenant à¤–à¤¾à¤¤à¤¾ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ à¤«à¥‰à¤°à¥à¤® à¤•à¥‹ à¤­à¤°à¥‡à¤‚à¥¤',0),(348076,9669,'ms','Mengisi borang di bawah untuk membuka akaun penyewa anda.',0),(348077,9669,'ar','Ù…Ù„Ø¡ Ø§Ù„Ù†Ù…ÙˆØ°Ø¬ Ø£Ø¯Ù†Ø§Ù‡ Ù„Ø¥Ù†Ø´Ø§Ø¡ \"Ø­Ø³Ø§Ø¨Ùƒ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±\".',0),(348078,9669,'fr','Remplissez le formulaire ci-dessous pour crÃ©er votre compte locataire.',0),(348079,9669,'jp','ãƒ†ãƒŠãƒ³ãƒˆ ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½œæˆã™ã‚‹ã®ã«ã¯ã€ä»¥ä¸‹ã®ãƒ•ã‚©ãƒ¼ãƒ ã«è¨˜å…¥ã—ã¾ã™ã€‚',0),(348080,9669,'pt','Preencha o formulÃ¡rio abaixo para criar sua conta do inquilino.',0),(348081,9669,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚Ðµ Ñ„Ð¾Ñ€Ð¼Ñƒ Ð½Ð¸Ð¶Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ ÑÐ²Ð¾Ð¹ ÑÑ‡ÐµÑ‚ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð°.',0),(348082,9669,'es','Llena la forma abajo para crear su Cuenta de Inquilino',0),(348083,9669,'de','FÃ¼llen Sie das Formular unten, um Ihr Mandantenkonto erstellen.',0),(348084,9669,'en','Fill out the form below to create your Tenant Account.',0),(348085,9670,'is','',0),(348086,9670,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ù…Ø³ØªØ§Ø¬Ø± Ø¬Ø¯ÙŠØ¯ ',0),(348087,9670,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ù…Ø³ØªØ§Ø¬Ø± Ø¬Ø¯ÙŠØ¯ ',0),(348088,9670,'tr','Yeni kiracÄ± hesabÄ± oluÅŸturma',0),(348089,9670,'pl','UtwÃ³rz nowe konto dzierÅ¼awcy',0),(348090,9670,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð·Ð° Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»',0),(348091,9670,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Û’ Ù†ÛŒØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(348092,9670,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ ÑÑ‚Ð°Ð½Ð°Ñ€ Ñ€Ð°Ñ‡ÑƒÐ½',0),(348093,9670,'vi','táº¡o tÃ i khoáº£n tenant má»›i',0),(348094,9670,'af','Skep Nuwe Verhuurder Rekening',0),(348095,9670,'ro','Creare cont nou chiriaÅŸ',0),(348096,9670,'et','Registreeru kasutajaks rentniku',0),(348097,9670,'si','Ustvarite nov raÄun najemnik',0),(348098,9670,'ba','Buat akun baru penyewa',0),(348099,9670,'nl','Nieuwe huurder Account aanmaken',0),(348100,9670,'fi','Luo uusi vuokralainen tili',0),(348101,9670,'no','Opprette ny leietaker konto',0),(348102,9670,'da','Oprette nye lejer konto',0),(348103,9670,'ko','ìƒˆë¡œìš´ ê±°ì£¼ìž ê³„ì • ë§Œë“¤ê¸°',0),(348104,9670,'he','×™×¦×™×¨×ª ×—×©×‘×•×Ÿ ×“×™×™×¨ ×—×“×©',0),(348105,9670,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î½Î­Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½',0),(348106,9670,'zh','åˆ›å»ºæ–°æ‰¿ç§Ÿäººå¸æˆ·\r\n',0),(348107,9670,'sv','Skapa nya hyresgÃ¤sten konto',0),(348108,9670,'it','Creare nuovo Account Tenant',0),(348109,9670,'tl','',0),(348110,9670,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(348111,9670,'hi','à¤¨à¤¯à¤¾ Tenant à¤–à¤¾à¤¤à¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(348112,9670,'ms','Cipta akaun penyewa baru',0),(348113,9670,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(348114,9670,'fr','CrÃ©er nouveau compte locataire',0),(348115,9670,'jp','æ–°è¦ãƒ†ãƒŠãƒ³ãƒˆ ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½œæˆã—ã¾ã™ã€‚',0),(348116,9670,'pt','Criar nova conta de inquilino',0),(348117,9670,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(348118,9670,'es','Crear Nueva Cuenta de Inquilino',0),(348119,9670,'de','Neue Mieterkonto erstellen',0),(348120,9670,'en','Create New Tenant Account',0),(348121,9671,'is','',0),(348122,9671,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…',0),(348123,9671,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…',0),(348124,9671,'tr','GiriÅŸ bilgileri',0),(348125,9671,'pl','Dane logowania',0),(348126,9671,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð²Ñ…Ð¾Ð´',0),(348127,9671,'ur','Ù„Ø§Ú¯ Ø§Ù† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(348128,9671,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÑƒ',0),(348129,9671,'vi','thÃ´ng tin Ä‘Äƒng nháº­p',0),(348130,9671,'af','Aanteken Inligting',0),(348131,9671,'ro','InformaÅ£iile de conectare',0),(348132,9671,'et','Sisselogimise andmed',0),(348133,9671,'si','Podatke za prijavo',0),(348134,9671,'ba','Informasi login',0),(348135,9671,'nl','Login informatie',0),(348136,9671,'fi','Kirjautumistiedot',0),(348137,9671,'no','PÃ¥loggingsinformasjon',0),(348138,9671,'da','Login-oplysninger',0),(348139,9671,'ko','ë¡œê·¸ì¸ ì •ë³´',0),(348140,9671,'he','×¤×¨×˜×™ ×”×›× ×™×¡×”',0),(348141,9671,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚',0),(348142,9671,'zh','ç™»å½•ä¿¡æ¯\r\n',0),(348143,9671,'sv','Information om inloggning',0),(348144,9671,'it','Informazioni di login',0),(348145,9671,'tl','',0),(348146,9671,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3621;&#3655;&#3629;&#3585;&#3629;&#3636;&#3609;',0),(348147,9671,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(348148,9671,'ms','Maklumat login',0),(348149,9671,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(348150,9671,'fr','Informations de connexion',0),(348151,9671,'jp','ãƒ­ã‚°ã‚¤ãƒ³æƒ…å ±',0),(348152,9671,'pt','InformaÃ§Ãµes de login',0),(348153,9671,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð›Ð¾Ð³Ð¸Ð½Ð°',0),(348154,9671,'es','InformaciÃ³n de Login',0),(348155,9671,'de','Login-Daten',0),(348156,9671,'en','Login Information',0),(348157,9672,'is','',0),(348158,9672,'dr','Ù„Ø·ÙØ§ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†ÙŠØ¯ ',0),(348159,9672,'pr','Ù„Ø·ÙØ§ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†ÙŠØ¯ ',0),(348160,9672,'tr','LÃ¼tfen parolayÄ± onaylayÄ±n',0),(348161,9672,'pl','ProszÄ™ potwierdziÄ‡ hasÅ‚o',0),(348162,9672,'bg','ÐœÐ¾Ð»Ñ, Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(348163,9672,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(348164,9672,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ',0),(348165,9672,'vi','vui lÃ²ng xÃ¡c nháº­n máº­t kháº©u',0),(348166,9672,'af','Bevestig asb. Wagwoord',0),(348167,9672,'ro','VÄƒ rugÄƒm sÄƒ confirmaÅ£i parola',0),(348168,9672,'et','Palun kinnita salasÃµna',0),(348169,9672,'si','Potrdite geslo',0),(348170,9672,'ba','Konfirmasi Password',0),(348171,9672,'nl','Bevestig wachtwoord',0),(348172,9672,'fi','Vahvista salasana',0),(348173,9672,'no','Bekreft passord',0),(348174,9672,'da','BekrÃ¦ft adgangskode',0),(348175,9672,'ko','ì•”í˜¸ë¥¼ í™•ì¸ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(348176,9672,'he','×× × ××©×¨×• ×¡×™×¡×ž×”',0),(348177,9672,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(348178,9672,'zh','è¯·ç¡®è®¤å¯†ç \r\n',0),(348179,9672,'sv','VÃ¤nligen bekrÃ¤fta lÃ¶senord',0),(348180,9672,'it','Conferma Password',0),(348181,9672,'tl','',0),(348182,9672,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3618;&#3639;&#3609;&#3618;&#3633;&#3609;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;',0),(348183,9672,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(348184,9672,'ms','Sila sahkan kata laluan',0),(348185,9672,'ar','Ø£Ø±Ø¬Ùˆ ØªØ£ÙƒÙŠØ¯ ÙƒÙ„Ù…Ø© Ø§Ù„Ø³Ø±Ù‘',0),(348186,9672,'fr','Sâ€™il vous plaÃ®t confirmer mot de passe',0),(348187,9672,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’ã”ç¢ºèªãã ã•ã„ã€‚',0),(348188,9672,'pt','Por favor, confirme a senha',0),(348189,9672,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚Ðµ ÐŸÐ°Ñ€Ð¾Ð»ÑŒ',0),(348190,9672,'es','Por favor Confirmar Password',0),(348191,9672,'de','Bitte Passwort bestÃ¤tigen',0),(348192,9672,'en','Please Confirm Password',0),(348193,9673,'is','',0),(348194,9673,'dr','Ù„Ø·ÙØ§ Ø¢Ø¯Ø±Ø³ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ',0),(348195,9673,'pr','Ù„Ø·ÙØ§ Ø¢Ø¯Ø±Ø³ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ',0),(348196,9673,'tr','LÃ¼tfen adresi eklemek',0),(348197,9673,'pl','Prosimy o podanie adresu',0),(348198,9673,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð°Ð´Ñ€ÐµÑ',0),(348199,9673,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù¾ØªÛ Ø´Ø§Ù…Ù„ Ù†Û Ú©Ø±ÛŒÚº',0),(348200,9673,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð°Ð´Ñ€ÐµÑÑƒ',0),(348201,9673,'vi','vui lÃ²ng bao gá»“m Ä‘á»‹a chá»‰',0),(348202,9673,'af','Sluit Adresse In',0),(348203,9673,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i adresa',0),(348204,9673,'et','Palun lisa aadress',0),(348205,9673,'si','Prosimo, da vkljuÄite naslov',0),(348206,9673,'ba','Sertakan alamat',0),(348207,9673,'nl','Vermeld adres',0),(348208,9673,'fi','LiitÃ¤ osoite',0),(348209,9673,'no','Vennligst inkluder postadresse',0),(348210,9673,'da','Inkluder venligst adresse',0),(348211,9673,'ko','ì£¼ì†Œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(348212,9673,'he','× × ×œ×›×œ×•×œ ×›×ª×•×‘×ª',0),(348213,9673,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(348214,9673,'zh','è¯·åˆ—å…¥åœ°å€\r\n',0),(348215,9673,'sv','VÃ¤nligen inkludera adress',0),(348216,9673,'it','Si prega di includere indirizzo',0),(348217,9673,'tl','',0),(348218,9673,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;',0),(348219,9673,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤¤à¤¾ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(348220,9673,'ms','Sila sertakan alamat',0),(348221,9673,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø¹Ù†ÙˆØ§Ù†',0),(348222,9673,'fr','Sâ€™il vous plaÃ®t inclure adresse',0),(348223,9673,'jp','ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’æ˜Žè¨˜ã—ã¦',0),(348224,9673,'pt','Por favor inclua o endereÃ§o',0),(348225,9673,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð°Ð´Ñ€ÐµÑ',0),(348226,9673,'es','Por favor Incluye Una DirecciÃ³n',0),(348227,9673,'de','Bitte geben Sie Adresse',0),(348228,9673,'en','Please Include Address',0),(348229,9674,'is','',0),(348230,9674,'dr','Ù„Ø·ÙØ§ Ø´Ù‡Ø± Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348231,9674,'pr','Ù„Ø·ÙØ§ Ø´Ù‡Ø± Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348232,9674,'tr','LÃ¼tfen ÅŸehir ekleyin',0),(348233,9674,'pl','ProszÄ™ podaÄ‡ miasto',0),(348234,9674,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð³Ñ€Ð°Ð´',0),(348235,9674,'ur','Ø¨Ø±Ø§Ø¦Û’ Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø´ÛØ± Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(348236,9674,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð³Ñ€Ð°Ð´',0),(348237,9674,'vi','vui lÃ²ng bao gá»“m thÃ nh phá»‘',0),(348238,9674,'af','Sluit asseblief Dorp/Stad In',0),(348239,9674,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i City',0),(348240,9674,'et','Palun lisa linn',0),(348241,9674,'si','Prosimo, da vkljuÄite mesto',0),(348242,9674,'ba','Harap sertakan City',0),(348243,9674,'nl','Gelieve te omvatten stad',0),(348244,9674,'fi','Ilmoita City',0),(348245,9674,'no','Ta byen',0),(348246,9674,'da','Inkluder venligst by',0),(348247,9674,'ko','ì‹œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(348248,9674,'he','×× × ×›×œ×•×œ ×¢×™×¨',0),(348249,9674,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï€ÏŒÎ»Î·',0),(348250,9674,'zh','è¯·åˆ—å…¥åŸŽå¸‚\r\n',0),(348251,9674,'sv','VÃ¤nligen inkludera City',0),(348252,9674,'it','Si prega di includere cittÃ ',0),(348253,9674,'tl','',0),(348254,9674,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3629;&#3635;&#3648;&#3616;&#3629;',0),(348255,9674,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¶à¤¹à¤° à¤¶à¤¾à¤®à¤¿à¤²',0),(348256,9674,'ms','Sila masukkan bandar',0),(348257,9674,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(348258,9674,'fr','Sâ€™il vous plaÃ®t inclure ville',0),(348259,9674,'jp','å¸‚ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(348260,9674,'pt','Por favor, inclua a cidade',0),(348261,9674,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð“Ð¾Ñ€Ð¾Ð´',0),(348262,9674,'es','Por favor Incluye Una Ciudad',0),(348263,9674,'de','Bitte geben Sie Stadt',0),(348264,9674,'en','Please Include City',0),(348265,9675,'is','',0),(348266,9675,'dr','Ù„Ø·ÙØ§ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348267,9675,'pr','Ù„Ø·ÙØ§ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348268,9675,'tr','LÃ¼tfen e-posta adresi ekleyin',0),(348269,9675,'pl','ProszÄ™ podaÄ‡ adres E-mail',0),(348270,9675,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ',0),(348271,9675,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒ Ù…ÛŒÙ„ Ù¾ØªÛ Ø´Ø§Ù…Ù„ Ù†Û Ú©Ø±ÛŒÚº',0),(348272,9675,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ðµ-Ð°Ð´Ñ€ÐµÑÑƒ',0),(348273,9675,'vi','vui lÃ²ng bao gá»“m Ä‘á»‹a chá»‰ thÆ°',0),(348274,9675,'af','Sluit asb. \'n E-posades in',0),(348275,9675,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i adresa de E-mail',0),(348276,9675,'et','Palun lisa e-posti aadress',0),(348277,9675,'si','Prosimo, da vkljuÄite e-poÅ¡tni naslov',0),(348278,9675,'ba','Sertakan alamat Email',0),(348279,9675,'nl','Gelieve te omvatten e-mailadres',0),(348280,9675,'fi','LiitÃ¤ mukaan sÃ¤hkÃ¶postiosoitteesi',0),(348281,9675,'no','Ta med e-postadresse',0),(348282,9675,'da','Inkluder venligst E-mail adresse',0),(348283,9675,'ko','ì´ë©”ì¼ ì£¼ì†Œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(348284,9675,'he','×× × ×›×œ×•×œ ×›×ª×•×‘×ª ×“×•×\"×œ',0),(348285,9675,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(348286,9675,'zh','è¯·åˆ—å…¥ç”µå­é‚®ä»¶åœ°å€\r\n',0),(348287,9675,'sv','VÃ¤nligen inkludera e-postadress',0),(348288,9675,'it','Si prega di inserire indirizzo Email',0),(348289,9675,'tl','',0),(348290,9675,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(348291,9675,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ˆ-à¤®à¥‡à¤² à¤ªà¤¤à¤¾ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(348292,9675,'ms','Sila sertakan alamat e-mel',0),(348293,9675,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(348294,9675,'fr','Adresse de courriel, veuillez indiquer',0),(348295,9675,'jp','ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’æ˜Žè¨˜ã—ã¦',0),(348296,9675,'pt','Por favor inclua o endereÃ§o de E-mail',0),(348297,9675,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð°Ð´Ñ€ÐµÑ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(348298,9675,'es','Por favor Incluye Una DirecciÃ³n de Email',0),(348299,9675,'de','Bitte geben Sie e-Mail-Adresse',0),(348300,9675,'en','Please Include Email Address',0),(348301,9676,'is','',0),(348302,9676,'dr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348303,9676,'pr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348304,9676,'tr','LÃ¼tfen ad iÃ§erir',0),(348305,9676,'pl','ProszÄ™ podaÄ‡ imiÄ™',0),(348306,9676,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ Ð¸Ð¼Ðµ',0),(348307,9676,'ur','Ø¨Ø±Ø§Ø¦Û’ Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù¾ÛÙ„Û’ Ù†Ø§Ù… Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(348308,9676,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¿Ñ€Ð²Ð¾ Ð¸Ð¼Ðµ',0),(348309,9676,'vi','vui lÃ²ng bao gá»“m tÃªn riÃªng',0),(348310,9676,'af','Sluit asb. Voornaam In',0),(348311,9676,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i numele',0),(348312,9676,'et','Palun lisa eesnimi',0),(348313,9676,'si','Prosimo, vkljuÄite ime',0),(348314,9676,'ba','Harap Sertakan nama pertama',0),(348315,9676,'nl','Gelieve te omvatten voornaam',0),(348316,9676,'fi','Kirjoita etunimi',0),(348317,9676,'no','Ta med fornavn',0),(348318,9676,'da','VedlÃ¦g fornavn',0),(348319,9676,'ko','ì´ë¦„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(348320,9676,'he','×× × ×›×œ×•×œ ×©× ×¤×¨×˜×™',0),(348321,9676,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î¬',0),(348322,9676,'zh','è¯·åˆ—å…¥åå­—\r\n',0),(348323,9676,'sv','VÃ¤nligen inkludera fÃ¶rnamn',0),(348324,9676,'it','Si prega di includere nome',0),(348325,9676,'tl','',0),(348326,9676,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3594;&#3639;&#3656;&#3629;',0),(348327,9676,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤® à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(348328,9676,'ms','Sila sertakan nama pertama',0),(348329,9676,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„',0),(348330,9676,'fr','Veuillez indiquer le prÃ©nom',0),(348331,9676,'jp','æœ€åˆã®åå‰ã‚’æ˜Žè¨˜ã—ã¦',0),(348332,9676,'pt','Por favor, inclua o nome',0),(348333,9676,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð˜Ð¼Ñ',0),(348334,9676,'es','Por favor Incluye Un Nombre',0),(348335,9676,'de','Bitte geben Sie Vorname',0),(348336,9676,'en','Please Include First Name',0),(348337,9677,'is','',0),(348338,9677,'dr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348339,9677,'pr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348340,9677,'tr','LÃ¼tfen soyadÄ± ekleyin',0),(348341,9677,'pl','Podaj nazwisko',0),(348342,9677,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ',0),(348343,9677,'ur','Ø¨Ø±Ø§Ø¦Û’ Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(348344,9677,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(348345,9677,'vi','Vui lÃ²ng bao gá»“m há»',0),(348346,9677,'af','Sluit asb. Van In',0),(348347,9677,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i numele de familie',0),(348348,9677,'et','Palun lisa perekonna nimi',0),(348349,9677,'si','Prosimo, da vkljuÄite priimek',0),(348350,9677,'ba','Harap Sertakan nama terakhir',0),(348351,9677,'nl','Gelieve te omvatten achternaam',0),(348352,9677,'fi','Kirjoita sukunimi',0),(348353,9677,'no','Ta med etternavn',0),(348354,9677,'da','Inkluder venligst efternavn',0),(348355,9677,'ko','ì„± í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(348356,9677,'he','×× × ×›×œ×•×œ ×©× ×ž×©×¤×—×”',0),(348357,9677,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ ÏŒÎ½Î¿Î¼Î±',0),(348358,9677,'zh','è¯·åˆ—å…¥å§“æ°\r\n',0),(348359,9677,'sv','VÃ¤nligen ange efternamn',0),(348360,9677,'it','Si prega di includere cognome',0),(348361,9677,'tl','',0),(348362,9677,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3609;&#3634;&#3617;&#3626;&#3585;&#3640;&#3621;',0),(348363,9677,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(348364,9677,'ms','Sila sertakan nama bapa/keluarga',0),(348365,9677,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ø³Ù… Ø§Ù„Ø¹Ø§Ø¦Ù„Ø©',0),(348366,9677,'fr','Veuillez inclure le nom de famille',0),(348367,9677,'jp','æœ€å¾Œã®åã‚‚å«ã‚ã¦ãã ã•ã„ã€‚',0),(348368,9677,'pt','Por favor inclua o Ãºltimo nome',0),(348369,9677,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¤Ð°Ð¼Ð¸Ð»Ð¸ÑŽ',0),(348370,9677,'es','Por favor Incluye Un Apellido',0),(348371,9677,'de','Bitte geben Sie Nachname',0),(348372,9677,'en','Please Include Last Name',0),(348373,9678,'is','',0),(348374,9678,'dr','Ù„Ø·ÙØ§ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348375,9678,'pr','Ù„Ø·ÙØ§ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348376,9678,'tr','LÃ¼tfen parola ekleyin',0),(348377,9678,'pl','Podaj hasÅ‚o',0),(348378,9678,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(348379,9678,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¨Ø±Ø§Ø¦Û’ Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(348380,9678,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ',0),(348381,9678,'vi','vui lÃ²ng bao gá»“m máº­t kháº©u',0),(348382,9678,'af','Sluit asb. Wagwoord in',0),(348383,9678,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i parola',0),(348384,9678,'et','Palun lisa salasÃµna',0),(348385,9678,'si','Prosimo, da vkljuÄite geslo',0),(348386,9678,'ba','Harap sertakan Password',0),(348387,9678,'nl','Geef wachtwoord',0),(348388,9678,'fi','LiitÃ¤ salasana',0),(348389,9678,'no','Ta med passord',0),(348390,9678,'da','Inkluder venligst Password',0),(348391,9678,'ko','ë¹„ë°€ ë²ˆí˜¸ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(348392,9678,'he','×× × ×›×œ×•×œ ×¡×™×¡×ž×”',0),(348393,9678,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(348394,9678,'zh','è¯·åˆ—å…¥å¯†ç \r\n',0),(348395,9678,'sv','VÃ¤nligen inkludera lÃ¶senord',0),(348396,9678,'it','Si prega di includere Password',0),(348397,9678,'tl','',0),(348398,9678,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;',0),(348399,9678,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(348400,9678,'ms','Sila masukkan kata laluan',0),(348401,9678,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ±',0),(348402,9678,'fr','Mot de passe, veuillez indiquer',0),(348403,9678,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’æ˜Žè¨˜ã—ã¦',0),(348404,9678,'pt','Por favor, inclua a palavra-passe',0),(348405,9678,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ',0),(348406,9678,'es','Por favor Incluye Un Password',0),(348407,9678,'de','Bitte geben Sie Kennwort',0),(348408,9678,'en','Please Include Password',0),(348409,9679,'is','',0),(348410,9679,'dr','Ù„Ø·ÙØ§ ØªÙ„ÙÙ† Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348411,9679,'pr','Ù„Ø·ÙØ§ ØªÙ„ÙÙ† Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348412,9679,'tr','LÃ¼tfen telefon dahil',0),(348413,9679,'pl','Prosimy o podanie telefonu',0),(348414,9679,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(348415,9679,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÙÙˆÙ† Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(348416,9679,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° ÑƒÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(348417,9679,'vi','vui lÃ²ng bao gá»“m phone',0),(348418,9679,'af','Sluit asseblief Telefoon in',0),(348419,9679,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i telefon',0),(348420,9679,'et','Palun kaasa telefoninumber',0),(348421,9679,'si','Prosimo, da vkljuÄite telefon',0),(348422,9679,'ba','Harap sertakan telepon',0),(348423,9679,'nl','Gelieve te omvatten telefoon',0),(348424,9679,'fi','LiitÃ¤ Puhelin',0),(348425,9679,'no','Ta telefonen',0),(348426,9679,'da','Inkluder venligst telefonen',0),(348427,9679,'ko','ì „í™”ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(348428,9679,'he','×× × ×›×œ×•×œ ×˜×œ×¤×•×Ÿ',0),(348429,9679,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ Ï„Î·Î»Î­Ï†Ï‰Î½ÏŒ',0),(348430,9679,'zh','è¯·åˆ—å…¥ç”µè¯\r\n',0),(348431,9679,'sv','VÃ¤nligen inkludera telefon',0),(348432,9679,'it','Si prega di includere telefono',0),(348433,9679,'tl','',0),(348434,9679,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3648;&#3610;&#3629;&#3619;&#3660;&#3650;&#3607;&#3619;&#3624;&#3633;&#3614;&#3607;&#3660;',0),(348435,9679,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤«à¥‹à¤¨ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(348436,9679,'ms','Sila sertakan telefon',0),(348437,9679,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ù„Ù‡Ø§ØªÙ',0),(348438,9679,'fr','Sâ€™il vous plaÃ®t inclure tÃ©lÃ©phone',0),(348439,9679,'jp','æºå¸¯é›»è©±ã‚’æ˜Žè¨˜ã—ã¦',0),(348440,9679,'pt','Favor incluir telefone',0),(348441,9679,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ ÐÐ¾Ð¼ÐµÑ€ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(348442,9679,'es','Por favor Incluye Un NÃºmero de TelÃ©fono',0),(348443,9679,'de','Bitte geben Sie Telefon',0),(348444,9679,'en','Please Include Phone',0),(348445,9680,'is','',0),(348446,9680,'dr','Ù„Ø·ÙØ§ Ø§Ø³ØªØ§Ù†  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348447,9680,'pr','Ù„Ø·ÙØ§ Ø§Ø³ØªØ§Ù†  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348448,9680,'tr','Devlet lÃ¼tfen ekleyin',0),(348449,9680,'pl','Prosimy o podanie PaÅ„stwa',0),(348450,9680,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°',0),(348451,9680,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø±ÛŒØ§Ø³Øª Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(348452,9680,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð´Ñ€Ð¶Ð°Ð²Ð°',0),(348453,9680,'vi','vui lÃ²ng bao gá»“m giai Ä‘oáº¡n',0),(348454,9680,'af','Sluit asseblief Staat (Landsgebied) in',0),(348455,9680,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i stat',0),(348456,9680,'et','Palun lisa maakond',0),(348457,9680,'si','Prosimo, da vkljuÄite drÅ¾ava',0),(348458,9680,'ba','Harap sertakan negara',0),(348459,9680,'nl','Vermeld staat',0),(348460,9680,'fi','LiitÃ¤ mukaan valtion',0),(348461,9680,'no','Ta med staten',0),(348462,9680,'da','Inkluder venligst tilstand',0),(348463,9680,'ko','êµ­ê°€ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(348464,9680,'he','×× × ×›×œ×•×œ ×§×˜×’×•×¨×™×™×”',0),(348465,9680,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ ÎºÏÎ¬Ï„Î¿Ï‚',0),(348466,9680,'zh','è¯·åˆ—å…¥å·ž\r\n',0),(348467,9680,'sv','VÃ¤nligen inkludera statliga',0),(348468,9680,'it','Si prega di includere stato',0),(348469,9680,'tl','',0),(348470,9680,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3592;&#3633;&#3591;&#3627;&#3623;&#3633;&#3604;',0),(348471,9680,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤°à¤¾à¤œà¥à¤¯ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(348472,9680,'ms','Sila sertakan Negeri',0),(348473,9680,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(348474,9680,'fr','Sâ€™il vous plaÃ®t inclure Ã‰tat',0),(348475,9680,'jp','çŠ¶æ…‹ã‚’æ˜Žè¨˜ã—ã¦',0),(348476,9680,'pt','Por favor inclua o estado',0),(348477,9680,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(348478,9680,'es','Por favor Incluye Un Estado',0),(348479,9680,'de','Bitte fÃ¼gen Sie Zustand',0),(348480,9680,'en','Please Include State',0),(348481,9681,'is','',0),(348482,9681,'dr','Ù„Ø·ÙØ§ ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348483,9681,'pr','Ù„Ø·ÙØ§ ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(348484,9681,'tr','Mutlu etmek katmak ZIP',0),(348485,9681,'pl','Prosimy o podanie Zip',0),(348486,9681,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸',0),(348487,9681,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø²Ù¾ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(348488,9681,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð—Ð¸Ð¿',0),(348489,9681,'vi','vui lÃ²ng bao gá»“m zip',0),(348490,9681,'af','Sluit asseblief Poskode in',0),(348491,9681,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i Zip',0),(348492,9681,'et','Palun lisa ZIP kood ',0),(348493,9681,'si','Prosimo, da vkljuÄite Zip',0),(348494,9681,'ba','Harap sertakan Zip',0),(348495,9681,'nl','Gelieve te omvatten Zip',0),(348496,9681,'fi','LiitÃ¤ Zip',0),(348497,9681,'no','Ta med Zip',0),(348498,9681,'da','VedlÃ¦g Zip',0),(348499,9681,'ko','ìš°íŽ¸ ë²ˆí˜¸ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(348500,9681,'he','×× × ×›×œ×•×œ ×ž×™×§×•×“',0),(348501,9681,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï†ÎµÏÎ¼Î¿Ï…Î¬Ï',0),(348502,9681,'zh','è¯·åˆ—å…¥é‚®ç¼–\r\n',0),(348503,9681,'sv','VÃ¤nligen inkludera Zip',0),(348504,9681,'it','Si prega di includere Zip',0),(348505,9681,'tl','',0),(348506,9681,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3652;&#3611;&#3619;&#3625;&#3603;&#3637;&#3618;&#3660;',0),(348507,9681,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤œà¤¼à¤¿à¤ª à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(348508,9681,'ms','Sila sertakan Zip',0),(348509,9681,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(348510,9681,'fr','Sâ€™il vous plaÃ®t inclure Zip',0),(348511,9681,'jp','éƒµä¾¿ç•ªå·ã‚’æ˜Žè¨˜ã—ã¦',0),(348512,9681,'pt','Por favor inclua o Zip',0),(348513,9681,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Zip',0),(348514,9681,'es','Por favor Incluye Un CÃ³digo Postal',0),(348515,9681,'de','Bitte fÃ¼gen Sie Zip',0),(348516,9681,'en','Please Include Zip',0),(348517,9682,'is','',0),(348518,9682,'dr','Ø­Ø³Ø§Ø¨ÙŠ Ø¨Ø§ Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(348519,9682,'pr','Ø­Ø³Ø§Ø¨ÙŠ Ø¨Ø§ Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(348520,9682,'tr','Bu e-posta adresi ile bir hesap bulunamadÄ±.',0),(348521,9682,'pl','Konta z takim samym adresem e-mail nie zostaÅ‚ znaleziony.',0),(348522,9682,'bg','ÐÐºÐ°ÑƒÐ½Ñ‚ Ñ Ñ‚Ð¾Ð·Ð¸ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½.',0),(348523,9682,'ur','Ø§Ø³ Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÛŒÚˆØ±ÛŒØ³ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†ÛÛŒÚº Ù…Ù„Ø§ Û”',0),(348524,9682,'sr','ÐÐ°Ð»Ð¾Ð³ ÑÐ° Ñ‚Ð¾Ð¼ Ðµ-Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½.',0),(348525,9682,'vi','má»™t tÃ i khoáº£n vá»›i Ä‘á»‹a chá»‰ thÆ° khÃ´ng Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(348526,9682,'af','\'n Rekening met die e-pos adres was nie gevind.',0),(348527,9682,'ro','Un cont cu acea adresÄƒ de e-mail nu a fost gÄƒsit.',0),(348528,9682,'et','E-maili aadressi ei leitud',0),(348529,9682,'si','RaÄun s tem e-poÅ¡tni naslov ni bilo mogoÄe najti.',0),(348530,9682,'ba','Account dengan alamat email tersebut tidak ditemukan.',0),(348531,9682,'nl','Een account met dat e-mailadres is niet gevonden.',0),(348532,9682,'fi','Tilin kyseinen sÃ¤hkÃ¶postiosoite ei lÃ¶ytynyt.',0),(348533,9682,'no','Finner ikke en konto med denne e-postadressen.',0),(348534,9682,'da','En konto med denne e-mail-adresse blev ikke fundet.',0),(348535,9682,'ko','ê·¸ ì´ë©”ì¼ ì£¼ì†Œì™€ ê³„ì •ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(348536,9682,'he','×—×©×‘×•×Ÿ ×¢× ×›×ª×•×‘×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™ ×–×• ×œ× × ×ž×¦××”.',0),(348537,9682,'el','ÎˆÎ½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î¼Îµ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Ï€Î¿Ï… Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ.',0),(348538,9682,'zh','æœ‰è¯¥ç”µå­é‚®ä»¶åœ°å€çš„å¸æˆ·æ²¡æœ‰æœªæ‰¾åˆ°ã€‚\r\n',0),(348539,9682,'sv','Ett konto med den e-postadressen kunde inte hittas.',0),(348540,9682,'it','Un account con tale indirizzo email non Ã¨ stato trovato.',0),(348541,9682,'tl','',0),(348542,9682,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(348543,9682,'hi','à¤‰à¤¸ à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¥‹à¤ˆ à¤–à¤¾à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤¥à¤¾à¥¤',0),(348544,9682,'ms','Akaun dengan alamat e-mel tersebut tidak dijumpai.',0),(348545,9682,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù‡Ø°Ø§.',0),(348546,9682,'fr','Un compte avec cette adresse email nâ€™a pas Ã©tÃ© trouvÃ©.',0),(348547,9682,'jp','ãã®ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(348548,9682,'pt','Uma conta com esse endereÃ§o de email nÃ£o foi encontrada.',0),(348549,9682,'ru','Ð£Ñ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ñ ÑÑ‚Ð¸Ð¼ Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½.',0),(348550,9682,'es','No se encontrÃ³ una cuenta con esta direcciÃ³n de Email.',0),(348551,9682,'de','Ein Konto mit dieser e-Mail-Adresse wurde nicht gefunden.',0),(348552,9682,'en','An account with that email address was not found.',0),(348553,9683,'is','',0),(348554,9683,'dr','1 : Ø´Ù…Ø§ Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø­Ø³Ø§Ø¨ Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙˆØ¨ Ø³Ø§ÙŠØª Ø²ÙŠØ± Ø¯ÙˆØ¨Ø§Ø±Ù‡ ØªÙ†Ø¸ÙŠÙ… ÙƒÙ†ÙŠØ¯ ',0),(348555,9683,'pr','Ù…ØªÙ† Ø§ÙŠÙ…ÙŠÙ„ 1 : Ø´Ù…Ø§ Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø­Ø³Ø§Ø¨ Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø§ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙˆØ¨ Ø³Ø§ÙŠØª Ø²ÙŠØ± Ø¯ÙˆØ¨Ø§Ø±Ù‡ ØªÙ†Ø¸ÙŠÙ… ÙƒÙ†ÙŠØ¯ ',0),(348556,9683,'tr','AÅŸaÄŸÄ±daki URL\'yi ziyaret ederek hesap ÅŸifrenizi sÄ±fÄ±rlayabilirsiniz:',0),(348557,9683,'pl','MoÅ¼na zresetowaÄ‡ hasÅ‚o do konta, odwiedzajÄ…c poniÅ¼szy adres URL:',0),(348558,9683,'bg','ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð°Ñ‚Ð° Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð° Ñ Ð¿Ð¾ÑÐµÑ‰ÐµÐ½Ð¸Ðµ Ð½Ð° URL Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ:',0),(348559,9683,'ur','Ø¯Ø±Ø¬ Ø°ÛŒÙ„ URL Ù¾Ø± Ø¬Ø§ Ú©Ø± Ø¢Ù¾ Ø§Ù¾Ù†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº:',0),(348560,9683,'sr','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð¸ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ‚Ð°ÐºÐ¾ ÑˆÑ‚Ð¾ Ñ›ÐµÑ‚Ðµ Ð¿Ð¾ÑÐµÑ‚Ð¸Ñ‚Ð¸ Ð½Ð° Ð´Ð¾Ð»Ðµ Ð½Ð°Ð²ÐµÐ´ÐµÐ½Ð¾Ñ˜ Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ¸:',0),(348561,9683,'vi','báº¡n cÃ³ thá»ƒ Ä‘áº·t láº¡i máº­t kháº©u cho tÃ i khoáº£n bá»Ÿi URL dÆ°á»›i Ä‘Ã¢y',0),(348562,9683,'af','U kan u Rekening se Wagwoord oorset deur die BA (\"URL\") hieronder te besoek:',0),(348563,9683,'ro','PoÈ›i reseta parola de cont accesÃ¢nd URL-ul de mai jos:',0),(348564,9683,'et','Saad nullida oma Konto salasÃµna klikates allolevale lingile:',0),(348565,9683,'si','Geslo za raÄun lahko ponastavite z obiskom URL spodaj:',0),(348566,9683,'ba','Anda dapat membuat ulang sandi Account dengan mengunjungi URL di bawah ini:',0),(348567,9683,'nl','U kunt uw wachtwoord resetten door een bezoek aan de onderstaande URL:',0),(348568,9683,'fi','Voit pyytÃ¤Ã¤ uuden salasanan kÃ¤ymÃ¤llÃ¤ URL-osoite:',0),(348569,9683,'no','Du kan tilbakestille passordet ved Ã¥ gÃ¥ til URL-adressen nedenfor:',0),(348570,9683,'da','Du kan nulstille adgangskoden til din konto ved at besÃ¸ge Webadressen nedenfor:',0),(348571,9683,'ko','ì•„ëž˜ URLì„ ë°©ë¬¸ í•˜ ì—¬ ê³„ì • ì•”í˜¸ë¥¼ ë‹¤ì‹œ ì„¤ì •í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(348572,9683,'he','×‘××¤×©×¨×•×ª×š ×œ××¤×¡ ××ª ×”×¡×™×¡×ž×” ×œ×—×©×‘×•×Ÿ ×©×œ×š ×¢×œ-×™×“×™ ×‘×™×§×•×¨ ×›×ª×•×‘×ª ×”-URL ×”×‘××•×ª:',0),(348573,9683,'el','ÎœÏ€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± ÎµÏ€Î±Î½Î±Ï†Î­ÏÎµÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï ÏƒÎ±Ï‚, ÎµÏ€Î¹ÏƒÎºÎµÏ†Î¸ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· URL:',0),(348574,9683,'zh','æ‚¨å¯ä»¥è®¿é—®æ­¤ç½‘å€ä»¥é‡ç½®æ‚¨çš„å¸æˆ·å¯†ç ï¼š\r\n',0),(348575,9683,'sv','Du kan Ã¥terstÃ¤lla lÃ¶senordet fÃ¶r kontot genom att besÃ¶ka adressen nedan:',0),(348576,9683,'it','Ãˆ possibile reimpostare la Password dell\'Account visitando l\'URL riportato di seguito:',0),(348577,9683,'tl','',0),(348578,9683,'th','&#3588;&#3640;&#3603;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3605;&#3633;&#3657;&#3591;&#3588;&#3656;&#3634;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637; &#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3650;&#',0),(348579,9683,'hi','à¤†à¤ª à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ URL à¤ªà¤° à¤œà¤¾à¤•à¤° à¤…à¤ªà¤¨à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤°à¥€à¤¸à¥‡à¤Ÿ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚:',0),(348580,9683,'ms','Anda boleh mengeset semula kata laluan akaun anda dengan melawat URL di bawah:',0),(348581,9683,'ar','ÙŠÙ…ÙƒÙ†Ùƒ Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† \"ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ø§Ù„Ø­Ø³Ø§Ø¨\" Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ø²ÙŠØ§Ø±Ø© URL Ø£Ø¯Ù†Ø§Ù‡:',0),(348582,9683,'fr','Vous pouvez rÃ©initialiser votre mot de passe en visitant lâ€™URL ci-dessousÂ :',0),(348583,9683,'jp','ä»¥ä¸‹ã® URL ã«ã‚¢ã‚¯ã‚»ã‚¹ã—ã¦ã€ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’ãƒªã‚»ãƒƒãƒˆã§ãã¾ã™ã€‚',0),(348584,9683,'pt','VocÃª pode redefinir a senha da sua conta visitando o URL abaixo:',0),(348585,9683,'ru','Ð’Ñ‹ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ ÑÐ±Ñ€Ð¾ÑÐ¸Ñ‚ÑŒ Ð²Ð°Ñˆ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸, Ð¿Ð¾ÑÐµÑ‚Ð¸Ð² URL Ð½Ð¸Ð¶Ðµ:',0),(348586,9683,'es','Puede cambiar su Password de Cuenta por visitar el URL abajo:',0),(348587,9683,'de','Sie kÃ¶nnen Ihr Konto-Kennwort zurÃ¼cksetzen, besuchen Sie den folgenden URL:',0),(348588,9683,'en','You can reset your Account Password by visiting the URL below:',0),(348589,9684,'is','',0),(348590,9684,'dr','2 : Ù„Ø·ÙØ§ Ø§ÙŠÙ† Ø§ÙŠÙ…ÙŠÙ„ Ø±Ø§ Ø§Ú¯Ø± Ø§Ø² Ø´Ù…Ø§ Ø¬Ù‡Øª  ØªÙ†Ø¸ÙŠÙ… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±ØªØ§Ù† Ø¯Ø±Ø®ÙˆØ§Ø³ØªÙŠ Ù†ÙƒØ±Ø¯ Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(348591,9684,'pr','Ù…ØªÙ† Ø§ÙŠÙ…ÙŠÙ„ 2 : Ù„Ø·ÙØ§ Ø§ÙŠÙ† Ø§ÙŠÙ…ÙŠÙ„ Ø±Ø§ Ø§Ú¯Ø± Ø§Ø² Ø´Ù…Ø§ Ø¬Ù‡Øª  ØªÙ†Ø¸ÙŠÙ… Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±ØªØ§Ù† Ø¯Ø±Ø®ÙˆØ§Ø³ØªÙŠ Ù†ÙƒØ±Ø¯ Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(348592,9684,'tr','Hesap ÅŸifrenizi sÄ±fÄ±rlamak iÃ§in talep deÄŸil EÄŸer bu e-posta lÃ¼tfen dikkate almayÄ±n.',0),(348593,9684,'pl','Zignoruj tÄ™ wiadomoÅ›Ä‡ e-mail, jeÅ›li nie poprosisz aby zresetowaÄ‡ swoje hasÅ‚o do konta.',0),(348594,9684,'bg','Ð¥Ð°Ñ€ÐµÑÐ²Ð°Ð¼ Ð½Ðµ Ð·Ð°Ñ‡Ð¸Ñ‚Ð°Ð¼ Ñ‚Ð¾Ð·Ð¸ Ð¸Ð¼ÐµÐ¹Ð», Ð°ÐºÐ¾ Ð½Ðµ Ð¿Ð¾Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð°Ñ‚Ð° Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð°.',0),(348595,9684,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ø§Ù¾Ù†Ø§ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒØ§ Ù†ÛÛŒÚº ØªÙˆ Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§Ø³ Ø§ÛŒ Ù…ÛŒÙ„ Ù†Ø¸Ø±Ø§Ù†Ø¯Ø§Ø² Ú©Ø±ÛŒÚº Û”',0),(348596,9684,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° Ð·Ð°Ð½ÐµÐ¼Ð°Ñ€Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ Ðµ-Ð¿Ð¾Ñ€ÑƒÐºÑƒ, Ð°ÐºÐ¾ Ð²Ð¸ Ð½Ð¸ÑÑ‚Ðµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°Ð»Ð¸ Ð´Ð° Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð¸Ñ‚Ðµ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ñ€Ð°Ñ‡ÑƒÐ½Ð°.',0),(348597,9684,'vi','Xin khÃ´ng Ä‘á»ƒ Ã½ Ä‘áº¿n email nÃ y náº¿u báº¡n khÃ´ng Ä‘á» nghá»‹ Ä‘áº·t láº¡i máº­t kháº©u email cá»§a báº¡n',0),(348598,9684,'af','Ignoreer asseblief hierdie e-pos indien u nie \'n versoek gerig het om u Rekening Wagwoord te \"reset\" nie.',0),(348599,9684,'ro','VÄƒ rugÄƒm sÄƒ ignore acest e-mail, Ã®n cazul Ã®n care nu au solicitat pentru a reseta parola de cont.',0),(348600,9684,'et','Palun eia seda e-kirja, kui sa ei ole soovinud oma Konto salasÃµna nullida.',0),(348601,9684,'si','Prosimo, ignorirajte to e-poÅ¡to, Äe niste zahtevali za ponastavitev gesla za raÄun.',0),(348602,9684,'ba','Harap mengabaikan email ini jika Anda tidak meminta untuk membuat ulang sandi Account.',0),(348603,9684,'nl','Negeer deze e-mail als u niet hebt gevraagd uw wachtwoord opnieuw instellen.',0),(348604,9684,'fi','Haluta laiminlyÃ¶dÃ¤ tÃ¤mÃ¤n sÃ¤hkÃ¶postiviestin, jos et pyytÃ¤nyt salasanan.',0),(348605,9684,'no','Vennligst se bort fra denne e-posten hvis du ikke har bedt om Ã¥ tilbakestille passordet.',0),(348606,9684,'da','Venligst se bort fra denne email hvis du ikke har bedt om at nulstille adgangskoden til din konto.',0),(348607,9684,'ko','ê³„ì • ë¹„ë°€ ë²ˆí˜¸ ìž¬ì„¤ì •ì„ ìš”ì²­ í•˜ì§€ ì•Šì€ ê²½ìš°ì´ ì´ë©”ì¼ì„ ë¬´ì‹œ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤.',0),(348608,9684,'he','× × ×œ×”×ª×¢×œ× ×”××™×ž×™×™×œ ×”×–×” ×× ×©×œ× ×‘×™×§×©×ª ×›×“×™ ×œ××¤×¡ ××ª ×”×¡×™×¡×ž×” ×œ×—×©×‘×•×Ÿ ×©×œ×š.',0),(348609,9684,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Î±Î³Î½Î¿Î®ÏƒÎµÎ¹ Î±Ï…Ï„ÏŒ Ï„Î¿ email, Î±Î½ Î´ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Î¶Î·Ï„Î®ÏƒÎµÎ¹ Î½Î± ÎµÏ€Î±Î½Î±Ï†Î­ÏÎµÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï ÏƒÎ±Ï‚.',0),(348610,9684,'zh','å¦‚æžœæ‚¨æ²¡æœ‰è¦æ±‚é‡è®¾å¸æˆ·çš„å¯†ç ï¼Œè¯·å¿½ç•¥æ­¤ç”µå­é‚®ä»¶ã€‚\r\n',0),(348611,9684,'sv','VÃ¤nligen bortse frÃ¥n detta mail om du inte har begÃ¤rt fÃ¶r att Ã¥terstÃ¤lla lÃ¶senordet fÃ¶r ditt konto.',0),(348612,9684,'it','Se non hai richiesto di reimpostare la Password dell\'Account, si prega di ignorare questa email.',0),(348613,9684,'tl','',0),(348614,9684,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3611;&#3599;&#3636;&#3648;&#3626;&#3608;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3609;&#3637;&#3657; &#3606;&#3657;&#3634;&#3588;&#3640;&#3603;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3619;&#3657;&#3629;&#3591;&#',0),(348615,9684,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤…à¤ªà¤¨à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤°à¥€à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤¥à¤¾, à¤¤à¥‹ à¤•à¥ƒà¤ªà¤¯à¤¾ à¤‡à¤¸ à¤ˆà¤®à¥‡à¤² à¤•à¥€ à¤‰à¤ªà¥‡à¤•à¥à¤·à¤¾à¥¤',0),(348616,9684,'ms','Sila mengabaikan e-mel ini jika anda tidak meminta untuk set semula kata laluan akaun anda.',0),(348617,9684,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¬Ø§Ù‡Ù„ Ù‡Ø°Ø§ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¥Ø°Ø§ ÙƒÙ†Øª Ù„Ù… ØªØ·Ù„Ø¨ Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† \"ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ø§Ù„Ø­Ø³Ø§Ø¨\" Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ.',0),(348618,9684,'fr','Sâ€™il vous plaÃ®t ignorer ce message si vous nâ€™avez pas demandÃ© pour rÃ©initialiser votre mot de passe.',0),(348619,9684,'jp','ã‚ãªãŸã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’ãƒªã‚»ãƒƒãƒˆã™ã‚‹ã®ã«ã¯è¦æ±‚ã—ã¦ã„ãªã„å ´åˆã¯ã€ã“ã®ãƒ¡ãƒ¼ãƒ«ã‚’ç„¡è¦–ã—ã¦ãã ã•ã„ã€‚',0),(348620,9684,'pt','Por favor, desconsidere este e-mail se vocÃª nÃ£o pediu para redefinir a senha da sua conta.',0),(348621,9684,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð½Ðµ Ð¾Ð±Ñ€Ð°Ñ‰Ð°Ð¹Ñ‚Ðµ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ñ ÑÑ‚Ð¾ Ð¿Ð¸ÑÑŒÐ¼Ð¾, ÐµÑÐ»Ð¸ Ð²Ñ‹ Ð½Ðµ Ð·Ð°Ð¿Ñ€Ð°ÑˆÐ¸Ð²Ð°Ð»Ð¸ Ð´Ð»Ñ ÑÐ±Ñ€Ð¾ÑÐ° Ð¿Ð°Ñ€Ð¾Ð»Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸.',0),(348622,9684,'es','Por Favor no hace caso de este email si no solicitÃ³ un cambio a su Password de Cuenta',0),(348623,9684,'de','Bitte ignorieren Sie diese e-Mail, wenn Sie nicht angefordert haben, um Ihr Konto-Kennwort zurÃ¼ckzusetzen.',0),(348624,9684,'en','Please disregard this email if you did not request to reset your Account Password.',0),(348625,9685,'is','',0),(348626,9685,'dr','Ø«Ø¨Øª Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(348627,9685,'pr','Ø«Ø¨Øª Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(348628,9685,'tr','E-posta adresini girin',0),(348629,9685,'pl','Wpisz adres E-mail',0),(348630,9685,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ',0),(348631,9685,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÛŒÚˆØ±ÛŒØ³ Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(348632,9685,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ðµ-Ð°Ð´Ñ€ÐµÑÑƒ',0),(348633,9685,'vi','nháº­p Ä‘á»‹a chá»‰ email',0),(348634,9685,'af','Voer E-pos Adres In',0),(348635,9685,'ro','Introdu adresa de Email',0),(348636,9685,'et','Sisesta e-maili aadress',0),(348637,9685,'si','Vnesite e-poÅ¡tni naslov',0),(348638,9685,'ba','Masukkan alamat Email',0),(348639,9685,'nl','Voer e-mailadres',0),(348640,9685,'fi','Astua Email kohdistaa',0),(348641,9685,'no','Angi e-postadresse',0),(348642,9685,'da','Indtast E-mail-adresse',0),(348643,9685,'ko','ì´ë©”ì¼ ì£¼ì†Œë¥¼ ìž…ë ¥',0),(348644,9685,'he','×”×–×Ÿ ××ª ×›×ª×•×‘×ª ×”×“×•×',0),(348645,9685,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(348646,9685,'zh','è¾“å…¥ç”µå­é‚®ä»¶åœ°å€',0),(348647,9685,'sv','Ange e-postadress',0),(348648,9685,'it','Inserisci indirizzo Email',0),(348649,9685,'tl','',0),(348650,9685,'th','&#3611;&#3657;&#3629;&#3609;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(348651,9685,'hi','à¤ˆ-à¤®à¥‡à¤² à¤ªà¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(348652,9685,'ms','Masukkan alamat e-mel',0),(348653,9685,'ar','Ø£Ø¯Ø®Ù„ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(348654,9685,'fr','Entrez lâ€™adresse E-mail',0),(348655,9685,'jp','ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(348656,9685,'pt','Digite o endereÃ§o de E-mail',0),(348657,9685,'ru','Ð’Ð²ÐµÑÑ‚Ð¸ E-mail ÐÐ´Ñ€ÐµÑ',0),(348658,9685,'es','Introducir DirecciÃ³n de Email',0),(348659,9685,'de','E-Mail-Adresse',0),(348660,9685,'en','Enter Email Address',0),(348661,9686,'is','',0),(348662,9686,'dr','Ø«Ø¨Øª Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÙŠØ¯ ',0),(348663,9686,'pr','Ø«Ø¨Øª Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÙŠØ¯ ',0),(348664,9686,'tr','Yeni parolayÄ± girin',0),(348665,9686,'pl','WprowadÅº nowe hasÅ‚o',0),(348666,9686,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(348667,9686,'ur','Ù†ÛŒØ§ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(348668,9686,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ',0),(348669,9686,'vi','nháº­p máº­t kháº£u má»›i',0),(348670,9686,'af','Voer Nuwe Wagwoord in',0),(348671,9686,'ro','IntroduceÅ£i noua parolÄƒ',0),(348672,9686,'et','Sisesta uus salasÃµna',0),(348673,9686,'si','Vnesite novo geslo',0),(348674,9686,'ba','Masukkan kata sandi baru',0),(348675,9686,'nl','Geef een nieuw wachtwoord',0),(348676,9686,'fi','Anna uusi salasana',0),(348677,9686,'no','Skriv inn nytt passord',0),(348678,9686,'da','Indtast ny adgangskode',0),(348679,9686,'ko','ìƒˆ ì•”í˜¸ ìž…ë ¥',0),(348680,9686,'he','×”×–×Ÿ ××ª ×”×¡×™×¡×ž×” ×”×—×“×©×”',0),(348681,9686,'el','Î Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÏ„Îµ Î½Î­Î¿ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(348682,9686,'zh','è¾“å…¥æ–°å¯†ç ',0),(348683,9686,'sv','Ange nytt lÃ¶senord',0),(348684,9686,'it','Immettere la nuova Password',0),(348685,9686,'tl','',0),(348686,9686,'th','&#3611;&#3657;&#3629;&#3609;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3651;&#3627;&#3617;&#3656;',0),(348687,9686,'hi','à¤¨à¤¯à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(348688,9686,'ms','Masukkan kata laluan baru',0),(348689,9686,'ar','Ø£Ø¯Ø®Ù„ ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(348690,9686,'fr','Entrez le nouveau mot de passe',0),(348691,9686,'jp','æ–°ã—ã„ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(348692,9686,'pt','Digite a nova senha',0),(348693,9686,'ru','Ð’Ð²ÐµÑÑ‚Ð¸ ÐÐ¾Ð²Ñ‹Ð¹ ÐŸÐ°Ñ€Ð¾Ð»ÑŒ',0),(348694,9686,'es','Introducer Nuevo Password',0),(348695,9686,'de','Neues Passwort eingeben',0),(348696,9686,'en','Enter New Password',0),(348697,9687,'is','',0),(348698,9687,'dr','ÙŠÙƒ Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§ Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ ',0),(348699,9687,'pr','ÙŠÙƒ Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§ Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ ',0),(348700,9687,'tr','Daha ayrÄ±ntÄ±lÄ± talimatlar iÃ§eren bir e-posta gÃ¶nderilen ',0),(348701,9687,'pl','E-mail z dalszymi instrukcjami zostaÅ‚a wysÅ‚ana do ',0),(348702,9687,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ñ Ð¿Ð¾-Ð½Ð°Ñ‚Ð°Ñ‚ÑŠÑˆÐ½Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ðµ Ð±Ð¸Ð»Ð¾ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾ Ð´Ð¾ ',0),(348703,9687,'ur','Ù…Ø²ÛŒØ¯ ÛØ¯Ø§ÛŒØ§Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ ',0),(348704,9687,'sr','Ð•-Ð¼Ð°Ð¸Ð» ÑÐ° Ð´Ð°Ñ™ÑšÐ¸Ð¼ ÑƒÐ¿ÑƒÑ‚Ð°Ð¼Ð° Ð¿Ð¾ÑÐ»Ð°Ñ‚ ',0),(348705,9687,'vi','má»™t thÆ° vá»›i nhiá»u hÆ°á»›ng dáº«n hÆ¡n Ä‘Ã£ Ä‘Æ°á»£c gá»­i Ä‘i',0),(348706,9687,'af','\'N e-pos met verdere instruksies is gestuur om ',0),(348707,9687,'ro','A fost trimis un email cu instrucÅ£iuni ',0),(348708,9687,'et','TÃ¤iendavate juhiste e-posti on saadetud ',0),(348709,9687,'si','Je bilo poslano e-poÅ¡tno nadaljnja navodila ',0),(348710,9687,'ba','Email dengan petunjuk lebih lanjut telah dikirim ke ',0),(348711,9687,'nl','Een e-mail met verdere instructies heeft verzonden naar ',0),(348712,9687,'fi','SÃ¤hkÃ¶postitse lisÃ¤ohjeita on lÃ¤hetetty ',0),(348713,9687,'no','En email med videre instruksjoner er sendt til ',0),(348714,9687,'da','FÃ¥et har tilsendt en e-mail med yderligere instruktioner ',0),(348715,9687,'ko','ì¶”ê°€ ì§€ì¹¨ì´ í¬í•¨ ëœ ì´ë©”ì¼ ë³´ë‚´ê¸° ',0),(348716,9687,'he','× ×©×œ×—×” ×”×•×“×¢×ª ×“×•× ×¢× ×”×•×¨××•×ª × ×•×¡×¤×•×ª ',0),(348717,9687,'el','ÎˆÏ‡ÎµÎ¹ ÏƒÏ„Î±Î»ÎµÎ¯ email Î¼Îµ Ï€ÎµÏÎ±Î¹Ï„Î­ÏÏ‰ Î¿Î´Î·Î³Î¯ÎµÏ‚ ',0),(348718,9687,'zh','ä¸€ä¸ªè¿›ä¸€æ­¥çš„è¯´æ˜Žç”µå­é‚®ä»¶å·²è¢«é€å¾€\r\n',0),(348719,9687,'sv','Ett e-postmeddelande med vidare instruktioner har skickats till ',0),(348720,9687,'it','Ãˆ stata inviata un\'email con ulteriori istruzioni per ',0),(348721,9687,'tl','',0),(348722,9687,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3614;&#3619;&#3657;&#3629;&#3617;&#3588;&#3635;&#3649;&#3609;&#3632;&#3609;&#3635;&#3648;&#3614;&#3636;&#3656;&#3617;&#3648;&#3605;&#3636;&#3617;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3626;&#3656;&#3591;&#3652;&#3',0),(348723,9687,'hi','à¤†à¤—à¥‡ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤ˆà¤®à¥‡à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ ',0),(348724,9687,'ms','E-mel arahan selanjutnya telah dihantar ke ',0),(348725,9687,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø¥Ø±Ø³Ø§Ù„ Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù…Ø¹ Ù…Ø²ÙŠØ¯ Ù…Ù† Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª ',0),(348726,9687,'fr','Un courriel contenant des instructions supplÃ©mentaires a Ã©tÃ© envoyÃ© Ã  ',0),(348727,9687,'jp','è©³ç´°ãªæ‰‹é †ã‚’è¨˜è¼‰ã—ãŸãƒ¡ãƒ¼ãƒ«ãŒé€ä¿¡ã•ã‚Œã¾ã—ãŸã€‚',0),(348728,9687,'pt','Foi enviado um e-mail com instruÃ§Ãµes para ',0),(348729,9687,'ru','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ð» Ð¿Ð¸ÑÑŒÐ¼Ð¾ Ñ Ð´Ð°Ð»ÑŒÐ½ÐµÐ¹ÑˆÐ¸Ð¼Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸ÑÐ¼Ð¸ ',0),(348730,9687,'es','Un email con mÃ¡s instrucciones se habia mandado a:',0),(348731,9687,'de','Eine e-Mail mit weiteren Anweisungen geschickt ',0),(348732,9687,'en','An email with further instructions has been sent to ',0),(348733,9688,'is','',0),(348734,9688,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(348735,9688,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(348736,9688,'tr','LÃ¼tfen bir e-posta adresi girin',0),(348737,9688,'pl','ProszÄ™ podaÄ‡ adres E-mail',0),(348738,9688,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ',0),(348739,9688,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø¢ÛŒÚˆØ±ÛŒØ³ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(348740,9688,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ðµ-Ð°Ð´Ñ€ÐµÑÑƒ',0),(348741,9688,'vi','vui lÃ²ng nháº­p má»™t Ä‘á»‹a chá»‰ thÆ°',0),(348742,9688,'af','Voer asb. \'n E-posades in',0),(348743,9688,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i o adresÄƒ de E-mail',0),(348744,9688,'et','Palun sisesta e-maili aadress',0),(348745,9688,'si','Vnesite e-poÅ¡tni naslov',0),(348746,9688,'ba','Harap masukkan alamat Email',0),(348747,9688,'nl','Voer een e-mailadres',0),(348748,9688,'fi','Kirjoita sÃ¤hkÃ¶postiosoite',0),(348749,9688,'no','Skriv inn en e-postadresse',0),(348750,9688,'da','Angiv en E-mail-adresse',0),(348751,9688,'ko','ì´ë©”ì¼ ì£¼ì†Œë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(348752,9688,'he','×”×–×™× ×• ×›×ª×•×‘×ª ×“×•×',0),(348753,9688,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(348754,9688,'zh','è¯·è¾“å…¥ç”µå­é‚®ä»¶åœ°å€\r\n',0),(348755,9688,'sv','VÃ¤nligen ange en e-postadress',0),(348756,9688,'it','Si prega di inserire un indirizzo Email',0),(348757,9688,'tl','',0),(348758,9688,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3611;&#3657;&#3629;&#3609;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(348759,9688,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(348760,9688,'ms','Sila masukkan alamat e-mel',0),(348761,9688,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø¹Ù†ÙˆØ§Ù† Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(348762,9688,'fr','Veuillez entrer une adresse E-mail',0),(348763,9688,'jp','ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(348764,9688,'pt','Por favor digite um endereÃ§o de E-mail',0),(348765,9688,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð°Ð´Ñ€ÐµÑ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(348766,9688,'es','Por favor Ingresar una DirecciÃ³n de Email',0),(348767,9688,'de','Bitte geben Sie eine e-Mail-Adresse',0),(348768,9688,'en','Please Enter An Email Address',0),(348769,9689,'is','',0),(348770,9689,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø­Ø³Ø§Ø¨ Ø®ÙˆØ¯ Ø±Ø§ ØªÙ†Ø¸ÙŠÙ… Ù…Ø¬Ø¯Ø¯ ÙƒÙ†ÙŠØ¯  ',0),(348771,9689,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø­Ø³Ø§Ø¨ Ø®ÙˆØ¯ Ø±Ø§ ØªÙ†Ø¸ÙŠÙ… Ù…Ø¬Ø¯Ø¯ ÙƒÙ†ÙŠØ¯  ',0),(348772,9689,'tr','Hesap ÅŸifrenizi sÄ±fÄ±rlamak',0),(348773,9689,'pl','Resetowanie hasÅ‚a do konta',0),(348774,9689,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(348775,9689,'ur','Ø¢Ù¾ Ú©Ø§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(348776,9689,'sr','ÐŸÐ¾Ð½Ð¸ÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(348777,9689,'vi','táº¡o láº¡i máº­t kháº©u tÃ i khoáº£n cá»§a báº¡n',0),(348778,9689,'af','U Rekening Wagwoord word Teruggestel',0),(348779,9689,'ro','Resetare parola contului',0),(348780,9689,'et','LÃ¤htesta oma konto salasÃµna',0),(348781,9689,'si','Ponastavi geslo raÄuna',0),(348782,9689,'ba','Membuat ulang sandi Account',0),(348783,9689,'nl','Uw wachtwoord opnieuw instellen',0),(348784,9689,'fi','Salasanan',0),(348785,9689,'no','Tilbakestille passordet',0),(348786,9689,'da','Nulstille adgangskoden til din konto',0),(348787,9689,'ko','ê³„ì • ì•”í˜¸ë¥¼ ë‹¤ì‹œ ì„¤ì •',0),(348788,9689,'he','×œ××¤×¡ ××ª ×”×¡×™×¡×ž×” ×œ×—×©×‘×•×Ÿ ×©×œ×š',0),(348789,9689,'el','Î•Ï€Î±Î½Î±Ï†Î¿ÏÎ¬ Ï„Î¿Ï… ÎºÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(348790,9689,'zh','é‡ç½®æ‚¨çš„å¸æˆ·å¯†ç \r\n',0),(348791,9689,'sv','Ã…terstÃ¤lla lÃ¶senordet fÃ¶r ditt konto',0),(348792,9689,'it','Reimpostare la Password dell\'Account',0),(348793,9689,'tl','',0),(348794,9689,'th','&#3619;&#3637;&#3648;&#3595;&#3605;&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3610;&#3633;&#3597;&#3594;&#3637;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(348795,9689,'hi','à¤†à¤ªà¤•à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤°à¥€à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(348796,9689,'ms','Set semula kata laluan akaun anda',0),(348797,9689,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(348798,9689,'fr','RÃ©initialiser votre mot de passe de compte',0),(348799,9689,'jp','ã‚ãªãŸã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’ãƒªã‚»ãƒƒãƒˆã—ã¾ã™ã€‚',0),(348800,9689,'pt','Redefinir a senha da sua conta',0),(348801,9689,'ru','Ð¡Ð±Ñ€Ð¾Ñ Ð¿Ð°Ñ€Ð¾Ð»Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(348802,9689,'es','Reintroduce Su Password de Cuenta',0),(348803,9689,'de','Ihr Account-Passwort zurÃ¼cksetzen',0),(348804,9689,'en','Reset Your Account Password',0),(348805,9690,'is','',0),(348806,9690,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø´Ù…Ø§  Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(348807,9690,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø´Ù…Ø§  Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù…Ø¬Ø¯Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(348808,9690,'tr','Parola sÄ±fÄ±rlama',0),(348809,9690,'pl','Twoje hasÅ‚o zostaÅ‚o zresetowane',0),(348810,9690,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(348811,9690,'ur','Ø¢Ù¾ Ú©Ø§ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©ÛŒ Ú¯Ø¦ÛŒ ÛÛ’',0),(348812,9690,'sr','Ð’Ð°ÑˆÐ° Ð»Ð¾Ð·Ð¸Ð½ÐºÐ° Ñ˜Ðµ Ð¿Ð¾Ð½Ð¸ÑˆÑ‚ÐµÐ½Ð°',0),(348813,9690,'vi','Máº­t kháº©u cá»§a báº¡n Ä‘Ã£ Ä‘Æ°á»£c thiáº¿t láº­p láº¡i',0),(348814,9690,'af','U Wagwoord is Teruggestel',0),(348815,9690,'ro','Parola a fost resetat',0),(348816,9690,'et','Teie salasÃµna on uuesti lÃ¤htestatud',0),(348817,9690,'si','VaÅ¡e geslo je bilo ponastavljeno',0),(348818,9690,'ba','Reset Password Anda',0),(348819,9690,'nl','Uw wachtwoord opnieuw heeft ingesteld',0),(348820,9690,'fi','Salasanan nollaus',0),(348821,9690,'no','Passordet er tilbakestilt',0),(348822,9690,'da','Adgangskoden er blevet nulstillet',0),(348823,9690,'ko','ì•”í˜¸ ë‹¤ì‹œ ì„¤ì •',0),(348824,9690,'he','××™×¤×•×¡ ×”×¡×™×¡×ž×” ×©×œ×š',0),(348825,9690,'el','ÎˆÏ‡ÎµÎ¹ Î³Î¯Î½ÎµÎ¹ ÎµÏ€Î±Î½Î±Ï†Î¿ÏÎ¬ Ï„Î¿Ï… ÎºÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(348826,9690,'zh','æ‚¨çš„å¯†ç å·²é‡ç½®\r\n',0),(348827,9690,'sv','Ditt lÃ¶senord har Ã¥terstÃ¤llts',0),(348828,9690,'it','La Password Ã¨ stata reimpostata',0),(348829,9690,'tl','',0),(348830,9690,'th','&#3619;&#3627;&#3633;&#3626;&#3612;&#3656;&#3634;&#3609;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3605;&#3633;&#3657;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(348831,9690,'hi','à¤…à¤ªà¤¨à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤°à¥€à¤¸à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(348832,9690,'ms','Kata laluan anda telah disetkan semula',0),(348833,9690,'ar','ØªÙ… Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(348834,9690,'fr','Votre mot de passe a Ã©tÃ© rÃ©initialisÃ©',0),(348835,9690,'jp','ã‚ãªãŸã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã¯ãƒªã‚»ãƒƒãƒˆã•ã‚Œã¾ã—ãŸ',0),(348836,9690,'pt','Sua senha foi redefinida',0),(348837,9690,'ru','Ð’Ð°Ñˆ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð±Ñ‹Ð» ÑÐ±Ñ€Ð¾ÑˆÐµÐ½',0),(348838,9690,'es','Su Password se Hizo de Nuevo',0),(348839,9690,'de','Ihr Passwort',0),(348840,9690,'en','Your Password Has Been Reset',0),(348841,9691,'is','',0),(348842,9691,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³Ø·Ø±',0),(348843,9691,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³Ø·Ø±',0),(348844,9691,'tr','Tutar satÄ±r',0),(348845,9691,'pl','Kwota wiersza',0),(348846,9691,'bg','Ð ÐµÐ´ ÑÑƒÐ¼Ð°',0),(348847,9691,'ur','Ø±Ù‚Ù… Ù„Ø§Ø¦Ù†',0),(348848,9691,'sr','Ð ÐµÐ´ Ð¸Ð·Ð½Ð¾ÑÐ°',0),(348849,9691,'vi','DÃ²ng sá»‘ tiá»n',0),(348850,9691,'af','Bedrag Lyn',0),(348851,9691,'ro','SumÄƒ linie',0),(348852,9691,'et','Koguse rida',0),(348853,9691,'si','Znesek vrstice',0),(348854,9691,'ba','Jumlah baris',0),(348855,9691,'nl','Bedragregel',0),(348856,9691,'fi','Summarivi',0),(348857,9691,'no','BelÃ¸pslinje',0),(348858,9691,'da','BelÃ¸b linje',0),(348859,9691,'ko','ì–‘ ì„ ',0),(348860,9691,'he','×”×©×•×¨×” ×¡×›×•×',0),(348861,9691,'el','Î Î¿ÏƒÏŒ Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(348862,9691,'zh','é¢çº¿\r\n',0),(348863,9691,'sv','Rad med',0),(348864,9691,'it','Riga importo',0),(348865,9691,'tl','',0),(348866,9691,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3610;&#3619;&#3619;&#3607;&#3633;&#3604;',0),(348867,9691,'hi','à¤°à¤¾à¤¶à¤¿ à¤²à¤¾à¤‡à¤¨',0),(348868,9691,'ms','Jumlah garisan',0),(348869,9691,'ar','Ø­Ø¬Ù… Ø§Ù„Ø®Ø·',0),(348870,9691,'fr','Montant ligne',0),(348871,9691,'jp','é‡ç·š',0),(348872,9691,'pt','Quantidade de linha',0),(348873,9691,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÑ‚Ñ€Ð¾ÐºÐ¸',0),(348874,9691,'es','Linea de Monto',0),(348875,9691,'de','Betrag-Linie',0),(348876,9691,'en','Amount Line',0),(348877,9692,'is','',0),(348878,9692,'dr','ÙØ±Ø§ØªØ± Ø±ÙØªÙ† Ø¨ÙˆØ¯Ø¬Ù‡ Ù…Ø§Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(348879,9692,'pr','ÙØ±Ø§ØªØ± Ø±ÙØªÙ† Ø¨ÙˆØ¯Ø¬Ù‡ Ù…Ø§Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(348880,9692,'tr','Ay-to-date bÃ¼tÃ§e aÅŸÄ±yor',0),(348881,9692,'pl','Przekracza budÅ¼et miesiÄ…ca do Data',0),(348882,9692,'bg','ÐÐ°Ð´Ð²Ð¸ÑˆÐ°Ð²Ð° Ð¼ÐµÑÐµÑ† ÐºÑŠÐ¼ Ð´Ð°Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(348883,9692,'ur','Ù…ÛÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ ØªØ§Ø±ÛŒØ® Ú©Û’ Ø¨Ø¬Ù¹ Ø³Û’ Ø²ÛŒØ§Ø¯Û ÛÛ’',0),(348884,9692,'sr','ÐŸÑ€ÐµÐ¼Ð°ÑˆÑƒÑ˜Ðµ Ð±ÑƒÑŸÐµÑ‚ Ð·Ð° Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(348885,9692,'vi','VÆ°á»£t quÃ¡ thÃ¡ng Ä‘áº¿n ngÃ y ngÃ¢n sÃ¡ch',0),(348886,9692,'af','Oorskry Maand-tot-op-Datum Begroting',0),(348887,9692,'ro','DepÄƒÅŸeÅŸte bugetul de luni la data',0),(348888,9692,'et','Kuu kuupÃ¤ev eelarve Ã¼letab',0),(348889,9692,'si','Presega proraÄun mesec datum',0),(348890,9692,'ba','Melebihi anggaran bulan-to-date',0),(348891,9692,'nl','Maand-to-date begroting overschrijdt',0),(348892,9692,'fi','YlittÃ¤Ã¤ budjetin kuukausi tÃ¤hÃ¤n pÃ¤ivÃ¤Ã¤n saakka',0),(348893,9692,'no','Overskrider mÃ¥ned-to-date budsjett',0),(348894,9692,'da','Overstiger mÃ¥ned-til-dato Budget',0),(348895,9692,'ko','ë‹¬ ë‚ ì§œ ì˜ˆì‚° ì´ˆê³¼',0),(348896,9692,'he','×—×•×¨×’ ×—×•×“×© ×¢×“ ×”×™×•× ×ª×§×¦×™×‘',0),(348897,9692,'el','Î¥Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ Ï„Î¿Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î¼Î®Î½Î±-to-Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(348898,9692,'zh','è¶…è¿‡ä¸€ä¸ªæœˆçš„æœ€æ–°è´¢æ”¿é¢„ç®—æ¡ˆ\r\n',0),(348899,9692,'sv','Ã–verskrider mÃ¥nad-till-datum Budget',0),(348900,9692,'it','Supera il Budget Month-to-date',0),(348901,9692,'tl','',0),(348902,9692,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3648;&#3585;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;&#3652;&#3611;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(348903,9692,'hi','à¤®à¤¾à¤¹-à¤Ÿà¥‚-à¤¡à¥‡à¤Ÿ à¤¬à¤œà¤Ÿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¹à¥ˆ',0),(348904,9692,'ms','Melebihi bajet bulan sehingga kini',0),(348905,9692,'ar','ØªØ¬Ø§ÙˆØ² Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø´Ù‡Ø± Ø¥Ù„Ù‰ ØªØ§Ø±ÙŠØ®',0),(348906,9692,'fr','DÃ©passe le Budget du mois Ã  ce jour',0),(348907,9692,'jp','æœˆ-æ—¥ã®äºˆç®—ã‚’è¶…ãˆã¦ã„ã¾ã™',0),(348908,9692,'pt','Excede o orÃ§amento do mÃªs-a-dia',0),(348909,9692,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð¼ÐµÑÑÑ† Ð´Ð¾ Ð´Ð°Ñ‚Ñ‹',0),(348910,9692,'es','Se Excede el Presupuesto de Mes-a-la Fecha',0),(348911,9692,'de','Month-to-Date Budget Ã¼berschreitet',0),(348912,9692,'en','Exceeds Month-to-date Budget',0),(348913,9693,'is','',0),(348914,9693,'dr','ÙØ±Ø§ØªØ± Ø±ÙØªÙ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(348915,9693,'pr','ÙØ±Ø§ØªØ± Ø±ÙØªÙ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(348916,9693,'tr','Year-to-date bÃ¼tÃ§e aÅŸÄ±yor',0),(348917,9693,'pl','Przekracza budÅ¼et roku do Data',0),(348918,9693,'bg','ÐÐ°Ð´Ð²Ð¸ÑˆÐ°Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° ÐºÑŠÐ¼ Ð´Ð°Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(348919,9693,'ur','ØªØ§Ø±ÛŒØ® Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø³Ø§Ù„ Ú©Û’ Ø¨Ø¬Ù¹ Ø³Û’ Ø²ÛŒØ§Ø¯Û ÛÛ’',0),(348920,9693,'sr','ÐŸÑ€ÐµÐ¼Ð°ÑˆÑƒÑ˜Ðµ Ð±ÑƒÑŸÐµÑ‚ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(348921,9693,'vi','VÆ°á»£t quÃ¡ nÄƒm Ä‘áº¿n ngÃ y ngÃ¢n sÃ¡ch',0),(348922,9693,'af','Oorskry Maand-tot-op-Datum Begroting',0),(348923,9693,'ro','DepÄƒÅŸeÅŸte bugetul anului la data',0),(348924,9693,'et','Aasta kuupÃ¤evani eelarve Ã¼letab',0),(348925,9693,'si','Presega proraÄun za leto do datuma',0),(348926,9693,'ba','Melebihi anggaran tahun-to-date',0),(348927,9693,'nl','Groter is dan de begroting van het jaar-to-date',0),(348928,9693,'fi','YlittÃ¤Ã¤ vuoden alusta budjetin',0),(348929,9693,'no','Overskrider hittil i Ã¥r budsjett',0),(348930,9693,'da','Overstiger Ã¥r-til-dato Budget',0),(348931,9693,'ko','1 ë…„-ë‚ ì§œ ì˜ˆì‚° ì´ˆê³¼',0),(348932,9693,'he','×—×•×¨×’ ×ª×§×¦×™×‘ ×”×©× ×” ×¢×“ ×”×™×•×',0),(348933,9693,'el','Î¥Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ Ï„Î¿Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î­Ï„Î¿Ï…Ï‚-to-Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(348934,9693,'zh','è¶…è¿‡å¹´åº¦æœ€æ–°çš„è´¢æ”¿é¢„ç®—æ¡ˆ\r\n',0),(348935,9693,'sv','Ã–verskrider Year-to-date Budget',0),(348936,9693,'it','Supera il Budget di anno-to-date',0),(348937,9693,'tl','',0),(348938,9693,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3648;&#3585;&#3636;&#3609;&#3611;&#3637;&#3652;&#3611;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;',0),(348939,9693,'hi','à¤µà¤°à¥à¤·-à¤®à¥‡à¤‚-à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¬à¤œà¤Ÿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¹à¥ˆ',0),(348940,9693,'ms','Melebihi bajet tahun sehingga kini',0),(348941,9693,'ar','ØªØ¬Ø§ÙˆØ² Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø³Ù†Ø© Ø­ØªÙ‰ ØªØ§Ø±ÙŠØ®Ù‡',0),(348942,9693,'fr','DÃ©passe le Budget de lâ€™exercice Ã  ce jour',0),(348943,9693,'jp','ä»Šå¹´ã«å…¥ã£ã¦ã®äºˆç®—ã‚’è¶…ãˆã¦ã„ã¾ã™',0),(348944,9693,'pt','Excede o orÃ§amento do ano-to-date',0),(348945,9693,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð½Ð° Ð³Ð¾Ð´',0),(348946,9693,'es','Se Excede el Presupuesto del AÃ±o-a-la Fecha',0),(348947,9693,'de','Year-to-Date Budget Ã¼berschreitet',0),(348948,9693,'en','Exceeds Year-to-date Budget',0),(348949,9694,'is','',0),(348950,9694,'dr','ÙØ±Ø§ØªØ± Ø±ÙØªÙ† Ø¨ÙˆØ¯Ø¬Ù‡ Ù…Ø§Ù‡',0),(348951,9694,'pr','ÙØ±Ø§ØªØ± Ø±ÙØªÙ† Ø¨ÙˆØ¯Ø¬Ù‡ Ù…Ø§Ù‡',0),(348952,9694,'tr','Ay bÃ¼tÃ§e aÅŸÄ±yor',0),(348953,9694,'pl','Przekracza budÅ¼et miesiÄ…ca',0),(348954,9694,'bg','ÐÐ°Ð´Ð²Ð¸ÑˆÐ°Ð²Ð° Ð¼ÐµÑÐµÑ‡ÐµÐ½ Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(348955,9694,'ur','Ù…Ø§Û Ø¨Ø¬Ù¹ Ø³Û’ Ø²ÛŒØ§Ø¯Û ÛÛ’',0),(348956,9694,'sr','ÐŸÑ€ÐµÐ¼Ð°ÑˆÑƒÑ˜Ðµ Ð±ÑƒÑŸÐµÑ‚ Ð·Ð° Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(348957,9694,'vi','VÆ°á»£t quÃ¡ thÃ¡ng ngÃ¢n sÃ¡ch',0),(348958,9694,'af','Oorskry Maand Begroting',0),(348959,9694,'ro','DepÄƒÅŸeÅŸte bugetul luna',0),(348960,9694,'et','Kuu eelarve Ã¼letab',0),(348961,9694,'si','Presega mesec proraÄuna',0),(348962,9694,'ba','Melebihi anggaran bulan',0),(348963,9694,'nl','Groter is dan de begroting van de maand',0),(348964,9694,'fi','YlittÃ¤Ã¤ kuukauden budjetin',0),(348965,9694,'no','Overskrider mÃ¥ned budsjett',0),(348966,9694,'da','Overstiger mÃ¥ned Budget',0),(348967,9694,'ko','ë‹¬ ì˜ˆì‚° ì´ˆê³¼',0),(348968,9694,'he','×¢×•×œ×” ×¢×œ ×”×ª×§×¦×™×‘ ×‘×—×•×“×©',0),(348969,9694,'el','Î¥Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ Ï„Î¿Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î¼Î®Î½Î±',0),(348970,9694,'zh','è¶…è¿‡æœˆçš„é¢„ç®—\r\n',0),(348971,9694,'sv','Ã–verskrider mÃ¥nad Budget',0),(348972,9694,'it','Supera il Budget del mese',0),(348973,9694,'tl','',0),(348974,9694,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3648;&#3585;&#3636;&#3609;&#3648;&#3604;&#3639;&#3629;&#3609;',0),(348975,9694,'hi','à¤®à¤¾à¤¹ à¤¬à¤œà¤Ÿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¹à¥ˆ',0),(348976,9694,'ms','Melebihi bajet bulan',0),(348977,9694,'ar','ØªØ¬Ø§ÙˆØ² Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø´Ù‡Ø±',0),(348978,9694,'fr','DÃ©passe le Budget du mois',0),(348979,9694,'jp','1 ãƒ¶æœˆã®äºˆç®—ã‚’è¶…ãˆã¦ã„ã¾ã™',0),(348980,9694,'pt','Excede o orÃ§amento do mÃªs',0),(348981,9694,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ Ð¼ÐµÑÑÑ‡Ð½Ñ‹Ð¹ Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(348982,9694,'es','Se Excede el Presupuesto Mensual',0),(348983,9694,'de','Monats-Budget Ã¼berschreitet',0),(348984,9694,'en','Exceeds Month Budget',0),(348985,9695,'is','',0),(348986,9695,'dr','ÙØ±Ø§ØªØ± Ø±ÙØªÙ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„',0),(348987,9695,'pr','ÙØ±Ø§ØªØ± Ø±ÙØªÙ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„',0),(348988,9695,'tr','YÄ±lÄ± BÃ¼tÃ§e aÅŸÄ±yor',0),(348989,9695,'pl','Przekracza budÅ¼et roku',0),(348990,9695,'bg','ÐÐ°Ð´Ð²Ð¸ÑˆÐ°Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(348991,9695,'ur','Ø³Ø§Ù„ Ú©Û’ Ø¨Ø¬Ù¹ Ø³Û’ Ø²ÛŒØ§Ø¯Û ÛÛ’',0),(348992,9695,'sr','ÐŸÑ€ÐµÐ¼Ð°ÑˆÑƒÑ˜Ðµ Ð±ÑƒÑŸÐµÑ‚ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(348993,9695,'vi','VÆ°á»£t quÃ¡ nÄƒm ngÃ¢n sÃ¡ch',0),(348994,9695,'af','Oorskry Jaar Begroting',0),(348995,9695,'ro','DepÄƒÅŸeÅŸte bugetul anului',0),(348996,9695,'et','Aasta eelarve Ã¼letab',0),(348997,9695,'si','Presega proraÄun za leto',0),(348998,9695,'ba','Melebihi anggaran tahun',0),(348999,9695,'nl','Groter is dan de begroting van het jaar',0),(349000,9695,'fi','YlittÃ¤Ã¤ vuoden budjetin',0),(349001,9695,'no','Overskrider Ã¥rs budsjett',0),(349002,9695,'da','Overstiger Ã¥r Budget',0),(349003,9695,'ko','ì˜¬í•´ ì˜ˆì‚° ì´ˆê³¼',0),(349004,9695,'he','×¢×•×œ×” ×¢×œ ×”×ª×§×¦×™×‘ ×©× ×”',0),(349005,9695,'el','Î¥Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ Ï„Î¿ Î­Ï„Î¿Ï‚ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(349006,9695,'zh','è¶…å‡ºå¹´åº¦è´¢æ”¿é¢„ç®—æ¡ˆ\r\n',0),(349007,9695,'sv','Ã–verskrider Budget Ã¥r',0),(349008,9695,'it','Supera il bilancio anno',0),(349009,9695,'tl','',0),(349010,9695,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3648;&#3585;&#3636;&#3609;&#3611;&#3637;',0),(349011,9695,'hi','à¤µà¤°à¥à¤· à¤¬à¤œà¤Ÿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¹à¥ˆ',0),(349012,9695,'ms','Melebihi bajet tahun',0),(349013,9695,'ar','ØªØ¬Ø§ÙˆØ² Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(349014,9695,'fr','DÃ©passe le Budget de lâ€™annÃ©e',0),(349015,9695,'jp','å¹´é–“äºˆç®—ã‚’è¶…ãˆã¦ã„ã¾ã™',0),(349016,9695,'pt','Excede o orÃ§amento do ano',0),(349017,9695,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð½Ð° Ð³Ð¾Ð´',0),(349018,9695,'es','Se Excede Presupuesto aÃ±ual',0),(349019,9695,'de','Haushalt des Jahres Ã¼bersteigt',0),(349020,9695,'en','Exceeds Year Budget',0),(349021,9696,'is','',0),(349022,9696,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(349023,9696,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(349024,9696,'tr','BÃ¼tÃ§e gÃ¼ncelleÅŸtirme',0),(349025,9696,'pl','Aktualizacja budÅ¼etu',0),(349026,9696,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(349027,9696,'ur','Ø¨Ø¬Ù¹ Ø§Ù¾ ÚˆÛŒÙ¹',0),(349028,9696,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð±ÑƒÑŸÐµÑ‚Ð°',0),(349029,9696,'vi','Cáº­p nháº­t ngÃ¢n sÃ¡ch',0),(349030,9696,'af','Begroting Opdateer',0),(349031,9696,'ro','Actualizare buget',0),(349032,9696,'et','Eelarve vÃ¤rskendus',0),(349033,9696,'si','ProraÄun posodobitev',0),(349034,9696,'ba','Anggaran Update',0),(349035,9696,'nl','Update van de begroting',0),(349036,9696,'fi','BudjettipÃ¤ivitys',0),(349037,9696,'no','Budsjettoppdatering',0),(349038,9696,'da','Budget opdatering',0),(349039,9696,'ko','ì˜ˆì‚° ì—…ë°ì´íŠ¸',0),(349040,9696,'he','×¢×“×›×•×Ÿ ×ª×§×¦×™×‘',0),(349041,9696,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(349042,9696,'zh','é¢„ç®—æ›´æ–°\r\n',0),(349043,9696,'sv','Budget uppdatering',0),(349044,9696,'it','Aggiornamento di bilancio',0),(349045,9696,'tl','',0),(349046,9696,'th','&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(349047,9696,'hi','à¤¬à¤œà¤Ÿ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(349048,9696,'ms','Kemaskini bajet',0),(349049,9696,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(349050,9696,'fr','Mise Ã  jour budgÃ©taire',0),(349051,9696,'jp','äºˆç®—ã®æ›´æ–°',0),(349052,9696,'pt','AtualizaÃ§Ã£o do orÃ§amento',0),(349053,9696,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(349054,9696,'es','ActualizaciÃ³n de Presupuesto',0),(349055,9696,'de','Budget-Update',0),(349056,9696,'en','Budget Update',0),(349057,9697,'is','',0),(349058,9697,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(349059,9697,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(349060,9697,'tr','GL hesabÄ±nÄ±n seÃ§ili bulunamadÄ±',0),(349061,9697,'pl','Wybrane konto GL nie znaleziono',0),(349062,9697,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð¸Ð·Ð±Ñ€Ð°Ð½ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(349063,9697,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(349064,9697,'sr','Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(349065,9697,'vi','TK sá»• cÃ¡i Ä‘Ã£ chá»n khÃ´ng tÃ¬m tháº¥y',0),(349066,9697,'af','AG Rekening Gekies nie Gevind',0),(349067,9697,'ro','GL contul selectat nu a fost gÄƒsit',0),(349068,9697,'et','GL konto valitud ei leitud',0),(349069,9697,'si','Izbrani GL ni mogoÄe najti',0),(349070,9697,'ba','GL Account dipilih tidak ditemukan',0),(349071,9697,'nl','GL Account geselecteerd niet gevonden',0),(349072,9697,'fi','GL tili valittu ei lÃ¶ydy',0),(349073,9697,'no','GL kontoen merket funnet ikke',0),(349074,9697,'da','GL konto valgt fundet ikke',0),(349075,9697,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ GL ê³„ì • ì„ íƒ',0),(349076,9697,'he','GL ×”×—×©×‘×•×Ÿ ×©× ×‘×—×¨ ×œ× × ×ž×¦×',0),(349077,9697,'el','GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(349078,9697,'zh','é€‰å®šæ€»å¸å¸æˆ·æ‰¾ä¸åˆ°\r\n',0),(349079,9697,'sv','GL konto markerat hittades inte',0),(349080,9697,'it','GL Account selezionato non trovato',0),(349081,9697,'tl','',0),(349082,9697,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(349083,9697,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤šà¤¯à¤¨à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(349084,9697,'ms','GL akaun dipilih tidak dijumpai',0),(349085,9697,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ø§Ù„Ù…Ø­Ø¯Ø¯ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(349086,9697,'fr','GL compte sÃ©lectionnÃ© introuvable',0),(349087,9697,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®é¸æŠžãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã€‚',0),(349088,9697,'pt','GL conta selecionado nÃ£o foi encontrado',0),(349089,9697,'ru','GL Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð° ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°',0),(349090,9697,'es','No se EcontrÃ³ la Cuenta LM Seleccionada ',0),(349091,9697,'de','GL-Konto ausgewÃ¤hlt wurde nicht gefunden',0),(349092,9697,'en','GL Account Selected not Found',0),(349093,9698,'is','',0),(349094,9698,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(349095,9698,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(349096,9698,'tr','Ä°ÅŸ PO Ekle',0),(349097,9698,'pl','DodaÄ‡ PO pracy',0),(349098,9698,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ PO',0),(349099,9698,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ù¾Ùˆ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(349100,9698,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾ ÐŸÐž',0),(349101,9698,'vi','ThÃªm cÃ´ng viá»‡c PO',0),(349102,9698,'af','Projek AN Byvoeg',0),(349103,9698,'ro','Adauga Job PO',0),(349104,9698,'et','Lisada tÃ¶Ã¶ PO',0),(349105,9698,'si','Dodaj delo PO',0),(349106,9698,'ba','Tambahkan pekerjaan PO',0),(349107,9698,'nl','Toevoegen van baan PO',0),(349108,9698,'fi','LisÃ¤Ã¤ tyÃ¶ PO',0),(349109,9698,'no','Legg jobben PO',0),(349110,9698,'da','TilfÃ¸j Job PO',0),(349111,9698,'ko','ì¼ í¬',0),(349112,9698,'he','×”×•×¡×£ ××ª ×”×¢×‘×•×“×” ×¤×•',0),(349113,9698,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÏÎ³Î±ÏƒÎ¯Î± PO',0),(349114,9698,'zh','å¢žåŠ ä½œä¸šè®¢å•\r\n',0),(349115,9698,'sv','LÃ¤gg till jobb PO',0),(349116,9698,'it','Aggiungi lavoro PO',0),(349117,9698,'tl','',0),(349118,9698,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3634;&#3609;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(349119,9698,'hi','à¤¨à¥Œà¤•à¤°à¥€ PO à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(349120,9698,'ms','Tambah kerja PO',0),(349121,9698,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ùˆ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(349122,9698,'fr','Ajouter Bon de Commande Tache',0),(349123,9698,'jp','ä»•äº‹ PO ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(349124,9698,'pt','Adicionar emprego PO',0),(349125,9698,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð¿Ð¾',0),(349126,9698,'es','Agregar Trabajo de OC',0),(349127,9698,'de','FÃ¼gen Sie Job PO',0),(349128,9698,'en','Add Job PO',0),(349129,9699,'is','',0),(349130,9699,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(349131,9699,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(349132,9699,'tr','Ä°ÅŸ PO gÃ¼ncelleÅŸtirmek',0),(349133,9699,'pl','Aktualizacja PO pracy',0),(349134,9699,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° PO',0),(349135,9699,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ù¾Ùˆ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(349136,9699,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐŸÐž Ð¿Ð¾ÑÐ°Ð¾',0),(349137,9699,'vi','Cáº­p nháº­t cÃ´ng viá»‡c Ä‘Æ¡n hÃ ng',0),(349138,9699,'af','Opdateer Werstuk AB',0),(349139,9699,'ro','Actualizare Job PO',0),(349140,9699,'et','Muudetud tÃ¶Ã¶ PO',0),(349141,9699,'si','Posodobiti delo PO',0),(349142,9699,'ba','Memperbarui pekerjaan PO',0),(349143,9699,'nl','Update Job PO',0),(349144,9699,'fi','PÃ¤ivitÃ¤ tyÃ¶ PO',0),(349145,9699,'no','Oppdatere jobb PO',0),(349146,9699,'da','Opdatere Job PO',0),(349147,9699,'ko','ì¼ í¬ ì—…ë°ì´íŠ¸',0),(349148,9699,'he','×¢×“×›×•×Ÿ ×¢×‘×•×“×” ×¤×•',0),(349149,9699,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ PO',0),(349150,9699,'zh','æ›´æ–°ä½œä¸šè®¢å•\r\n',0),(349151,9699,'sv','Uppdatera jobb PO',0),(349152,9699,'it','PO di lavoro di aggiornamento',0),(349153,9699,'tl','',0),(349154,9699,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;',0),(349155,9699,'hi','à¤¨à¥Œà¤•à¤°à¥€ PO à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(349156,9699,'ms','Kemaskini Terakhir kerja PO',0),(349157,9699,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø¨Ùˆ',0),(349158,9699,'fr','Mise Ã  jour de travail PO',0),(349159,9699,'jp','ä»•äº‹ PO ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(349160,9699,'pt','Atualizar trabalho PO',0),(349161,9699,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ PO',0),(349162,9699,'es','Actualiza OC de Tarea',0),(349163,9699,'de','Job-PO zu aktualisieren',0),(349164,9699,'en','Update Job PO',0),(349165,9700,'is','',0),(349166,9700,'dr','(Ø´ØºÙ„) ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯',0),(349167,9700,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ  Ø±ÙˆØ´ (Ø´ØºÙ„) Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯',0),(349168,9700,'tr','Yeni iÅŸ satÄ±nalma sipariÅŸi oluÅŸturma',0),(349169,9700,'pl','UtwÃ³rz nowe zamÃ³wienie zakupu pracy',0),(349170,9700,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(349171,9700,'ur','Ø§ÛŒÚ© Ù†ÛŒØ§ Ú©Ø§Ù… Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(349172,9700,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(349173,9700,'vi','Táº¡o ra má»™t cÃ´ng viá»‡c má»›i mua hÃ ng',0),(349174,9700,'af','Skep \'n Nuwe Projek Aankoopbestelling',0),(349175,9700,'ro','Crea o comandÄƒ de cumpÄƒrare JOB',0),(349176,9700,'et','Uue projekti ostutellimuse loomine',0),(349177,9700,'si','Ustvarite novo nabavni nalog delo',0),(349178,9700,'ba','Membuat Order Pembelian pekerjaan baru',0),(349179,9700,'nl','Maak een nieuwe inkooporder voor baan',0),(349180,9700,'fi','Luo uusi tyÃ¶ ostotilaus',0),(349181,9700,'no','Opprette en ny jobb-bestilling',0),(349182,9700,'da','Opret en ny JOB indkÃ¸bsordre',0),(349183,9700,'ko','ìƒˆë¡œìš´ ìž‘ì—… ì£¼ë¬¸ì„œ ë§Œë“¤ê¸°',0),(349184,9700,'he','×¦×•×¨ ×”×–×ž× ×ª ×¨×›×© ××ª ×”×¢×‘×•×“×” ×”×—×“×©×”',0),(349185,9700,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î¼Î¹Î± Î½Î­Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚ Î•Î¡Î“Î‘Î£ÎŠÎ‘Î£',0),(349186,9700,'zh','åˆ›å»ºä¸€ä¸ªæ–°ä½œä¸šé‡‡è´­è®¢å•\r\n',0),(349187,9700,'sv','Skapa en ny inkÃ¶psorder fÃ¶r jobb',0),(349188,9700,'it','Creare un nuovo ordine di acquisto di lavoro',0),(349189,9700,'tl','',0),(349190,9700,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3626;&#3633;&#3657;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(349191,9700,'hi','à¤à¤• à¤¨à¤ˆ à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶ à¤¬à¤¨à¤¾à¤à¤',0),(349192,9700,'ms','Mencipta pesanan belian baru kerja',0),(349193,9700,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ø´Ø±Ø§Ø¡ ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(349194,9700,'fr','CrÃ©er un nouvel ordre dâ€™achat de travail',0),(349195,9700,'jp','æ–°ã—ã„ä»•äº‹ã®ç™ºæ³¨æ›¸ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(349196,9700,'pt','Criar uma nova ordem de compra de emprego',0),(349197,9700,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(349198,9700,'es','Crear Un Nuevo Orden de Compra de Trabajo',0),(349199,9700,'de','Erstellen Sie eine neue JOB-Bestellung',0),(349200,9700,'en','Create a New JOB Purchase Order',0),(349201,9701,'is','',0),(349202,9701,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(349203,9701,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(349204,9701,'tr','Ä°ÅŸ PO DÃ¼zenle',0),(349205,9701,'pl','PO zadania edytowanie',0),(349206,9701,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ PO',0),(349207,9701,'ur','Ú©Ø§Ù… Ù¾ÙˆØ³Ù¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(349208,9701,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿Ð¾ÑÐ°Ð¾ ÐŸÐž',0),(349209,9701,'vi','Chá»‰nh sá»­a cÃ´ng viá»‡c PO',0),(349210,9701,'af','Redigeer Werkstuk AB',0),(349211,9701,'ro','Editare Job PO',0),(349212,9701,'et','Muuta tÃ¶Ã¶ PO',0),(349213,9701,'si','Urejanje delovnih mest PO',0),(349214,9701,'ba','Mengedit pekerjaan PO',0),(349215,9701,'nl','Bewerken van baan PO',0),(349216,9701,'fi','Muokkaa tyÃ¶tÃ¤ PO',0),(349217,9701,'no','Redigere jobb PO',0),(349218,9701,'da','Redigere Job PO',0),(349219,9701,'ko','í¬ ì¼ì„ íŽ¸ì§‘',0),(349220,9701,'he','×¢×¨×™×›×ª ×”×¢×‘×•×“×” ×¤×•',0),(349221,9701,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ PO',0),(349222,9701,'zh','ç¼–è¾‘å·¥ä½œè®¢å•\r\n',0),(349223,9701,'sv','Redigera jobb PO',0),(349224,9701,'it','PO di lavoro di modificare',0),(349225,9701,'tl','',0),(349226,9701,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(349227,9701,'hi','à¤¨à¥Œà¤•à¤°à¥€ PO à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(349228,9701,'ms','Edit PO kerja',0),(349229,9701,'ar','ØªØ­Ø±ÙŠØ± Ø¨Ùˆ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(349230,9701,'fr','Modifier le travail PO',0),(349231,9701,'jp','ä»•äº‹ PO ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(349232,9701,'pt','Editar trabalho PO',0),(349233,9701,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ PO',0),(349234,9701,'es','Editar OC de Trabajo',0),(349235,9701,'de','Job-PO bearbeiten',0),(349236,9701,'en','Edit Job PO',0),(349237,9702,'is','',0),(349238,9702,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ Ø´ØºÙ„',0),(349239,9702,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ Ø´ØºÙ„',0),(349240,9702,'tr','Yeni iÅŸ PO',0),(349241,9702,'pl','Nowe zadanie PO',0),(349242,9702,'bg','ÐÐ¾Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° PO',0),(349243,9702,'ur','Ù†ÛŒØ§ Ú©Ø§Ù… Ù¾Ùˆ',0),(349244,9702,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾ ÐŸÐž',0),(349245,9702,'vi','New Job PO',0),(349246,9702,'af','Nuwe Projek AB',0),(349247,9702,'ro','Noul Job PO',0),(349248,9702,'et','Uus tÃ¶Ã¶ PO',0),(349249,9702,'si','Nove zaposlitve PO',0),(349250,9702,'ba','Baru pekerjaan PO',0),(349251,9702,'nl','Nieuwe baan PO',0),(349252,9702,'fi','Uuden tyÃ¶n PO',0),(349253,9702,'no','Ny jobb PO',0),(349254,9702,'da','Nye Job PO',0),(349255,9702,'ko','ìƒˆë¡œìš´ ì§ì—… í¬',0),(349256,9702,'he','×¤×• ×¢×‘×•×“×” ×—×“×©×”',0),(349257,9702,'el','ÎÎ­Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ PO',0),(349258,9702,'zh','æ–°å»ºä½œä¸šè®¢å•\r\n',0),(349259,9702,'sv','Nya jobb PO',0),(349260,9702,'it','Il nuovo lavoro PO',0),(349261,9702,'tl','',0),(349262,9702,'th','&#3591;&#3634;&#3609;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3627;&#3617;&#3656;',0),(349263,9702,'hi','à¤¨à¤ˆ à¤¨à¥Œà¤•à¤°à¥€ PO',0),(349264,9702,'ms','Baru kerja PO',0),(349265,9702,'ar','Øµ. Ø¨ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(349266,9702,'fr','Nouveau Job PO',0),(349267,9702,'jp','æ–°ã—ã„ã‚¸ãƒ§ãƒ– PO',0),(349268,9702,'pt','Novo emprego PO',0),(349269,9702,'ru','ÐÐ¾Ð²Ð°Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾',0),(349270,9702,'es','OC de Nueva Tarea',0),(349271,9702,'de','Neue Job-PO',0),(349272,9702,'en','New Job PO',0),(349273,9703,'is','',0),(349274,9703,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ ',0),(349275,9703,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙŠÙƒ Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ ',0),(349276,9703,'tr','Varolan bir iÅŸ satÄ±nalma sipariÅŸini gÃ¼ncelleÅŸtirmek',0),(349277,9703,'pl','Aktualizacja istniejÄ…cego zamÃ³wienia zakupu pracy',0),(349278,9703,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(349279,9703,'ur','Ø§ÛŒÚ© Ù…ÙˆØ¬ÙˆØ¯ Ú©Ø§Ù… Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(349280,9703,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð¿Ð¾ÑÐ°Ð¾ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(349281,9703,'vi','Cáº­p Nháº­t má»™t hiá»‡n cÃ³ cÃ´ng viá»‡c mua hÃ ng',0),(349282,9703,'af','Opdateer \'n Bestaande Werkstuk Aankoopbestelling',0),(349283,9703,'ro','Actualizarea unei comenzi de cumpÄƒrare Job',0),(349284,9703,'et','Uuendada olemasoleva tÃ¶Ã¶ ostutellimuse',0),(349285,9703,'si','Posodobitev obstojeÄe delo nabavni nalog',0),(349286,9703,'ba','Update pesanan pembelian pekerjaan yang ada',0),(349287,9703,'nl','Een bestaande baan-inkooporder bijgewerkt',0),(349288,9703,'fi','PÃ¤ivitÃ¤ tyÃ¶-ostotilaus',0),(349289,9703,'no','Oppdatere en eksisterende jobb bestilling',0),(349290,9703,'da','Opdatere en eksisterende kÃ¸bsordre, Job',0),(349291,9703,'ko','ì—…ë°ì´íŠ¸ëŠ” ê¸°ì¡´ ìž‘ì—… ì£¼ë¬¸ì„œ',0),(349292,9703,'he','×¢×“×›×•×Ÿ ×”×–×ž× ×” ×œ×¨×›×™×©×ª ×¢×‘×•×“×” ×§×™×™×ž×ª',0),(349293,9703,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Î¹Î±Ï‚ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎ±Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î±Î³Î¿ÏÎ¬Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(349294,9703,'zh','æ›´æ–°çŽ°æœ‰çš„é‡‡è´­è®¢å•ä½œä¸š\r\n',0),(349295,9703,'sv','Uppdatera en befintlig inkÃ¶psorder fÃ¶r jobb',0),(349296,9703,'it','Aggiornare un ordine di acquisto di lavoro esistente',0),(349297,9703,'tl','',0),(349298,9703,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3610;&#3591;&#3634;&#3609;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;',0),(349299,9703,'hi','à¤à¤• à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¨à¥Œà¤•à¤°à¥€ à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(349300,9703,'ms','Kemaskini Terakhir pesanan pembelian kerja sedia ada',0),(349301,9703,'ar','ØªØ­Ø¯ÙŠØ« Ø£Ù…Ø± Ø´Ø±Ø§Ø¡ ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(349302,9703,'fr','Mise Ã  jour un ordre dâ€™achat de travail existant',0),(349303,9703,'jp','æ—¢å­˜ã®ä»•äº‹ç™ºæ³¨æ›¸ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(349304,9703,'pt','Atualizar uma ordem de compra de trabalho existente',0),(349305,9703,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(349306,9703,'es','Actualiza un Orden de Compra de Tarea Existente',0),(349307,9703,'de','Update einer bestehenden Job-Bestellung',0),(349308,9703,'en','Update an Existing Job Purchase Order',0),(349309,9704,'is','',0),(349310,9704,'dr','Ù‡Ù…Ù‡ Ù†ÙˆØ¹ Ù‡Ø§',0),(349311,9704,'pr','Ù‡Ù…Ù‡ Ù†ÙˆØ¹ Ù‡Ø§',0),(349312,9704,'tr','TÃ¼m tÃ¼rleri',0),(349313,9704,'pl','Wszystkie typy',0),(349314,9704,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð²Ð¸Ð´Ð¾Ð²Ðµ',0),(349315,9704,'ur','ØªÙ…Ø§Ù… Ø§Ù‚Ø³Ø§Ù…',0),(349316,9704,'sr','Ð¡Ð²Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸',0),(349317,9704,'vi','TÃ¢t cáº£ cÃ¡c loáº¡i',0),(349318,9704,'af','Alle Tipes',0),(349319,9704,'ro','Toate tipurile',0),(349320,9704,'et','KÃµik liigid',0),(349321,9704,'si','Vse vrste',0),(349322,9704,'ba','Semua jenis',0),(349323,9704,'nl','Alle typen',0),(349324,9704,'fi','Kaikki tyypit',0),(349325,9704,'no','Alle typer',0),(349326,9704,'da','Alle typer',0),(349327,9704,'ko','ëª¨ë“  ì¢…ë¥˜',0),(349328,9704,'he','×›×œ ×¡×•×’×™',0),(349329,9704,'el','ÎŒÎ»Î¿Î¹ Î¿Î¹ Ï„ÏÏ€Î¿Î¹',0),(349330,9704,'zh','æ‰€æœ‰ç±»åž‹\r\n',0),(349331,9704,'sv','Alla typer',0),(349332,9704,'it','Tutti i tipi',0),(349333,9704,'tl','',0),(349334,9704,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(349335,9704,'hi','à¤¸à¤­à¥€ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(349336,9704,'ms','Semua jenis',0),(349337,9704,'ar','Ø¬Ù…ÙŠØ¹ Ø£Ù†ÙˆØ§Ø¹',0),(349338,9704,'fr','Tous les Types',0),(349339,9704,'jp','ã™ã¹ã¦ã®ç¨®é¡ž',0),(349340,9704,'pt','Todos os tipos',0),(349341,9704,'ru','Ð’ÑÐµ Ð¢Ð¸Ð¿Ñ‹',0),(349342,9704,'es','Todos los Tipos',0),(349343,9704,'de','Alle Typen',0),(349344,9704,'en','All Types',0),(349345,9705,'is','',0),(349346,9705,'dr','ÙÙ‚Ø· Ù†ÙˆØ¹ Ø´ØºÙ„ ',0),(349347,9705,'pr','ÙÙ‚Ø· Ù†ÙˆØ¹ Ø´ØºÙ„ ',0),(349348,9705,'tr','Ä°ÅŸ tÃ¼rÃ¼ yalnÄ±zca',0),(349349,9705,'pl','Tylko typ pracy',0),(349350,9705,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ ÑÐ°Ð¼Ð¾',0),(349351,9705,'ur','ØµØ±Ù Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù…',0),(349352,9705,'sr','Ð¡Ð°Ð¼Ð¾ Ð²Ñ€ÑÑ‚Ð° Ð¿Ð¾ÑÐ»Ð°',0),(349353,9705,'vi','chá»‰ loáº¡i viá»‡c',0),(349354,9705,'af','Kontrakwerk Tipe Alleenlik',0),(349355,9705,'ro','Tip de muncÄƒ',0),(349356,9705,'et','Ainult tÃ¶Ã¶ liik',0),(349357,9705,'si','Job Type le',0),(349358,9705,'ba','Jenis pekerjaan',0),(349359,9705,'nl','Alleen het Type van baan',0),(349360,9705,'fi','Job Type vain',0),(349361,9705,'no','Jobbtypen bare',0),(349362,9705,'da','Jobtype kun',0),(349363,9705,'ko','ìž‘ì—… ìœ í˜•ë§Œ',0),(349364,9705,'he','×¡×•×’ ×”×ž×©×™×ž×” ×‘×œ×‘×“',0),(349365,9705,'el','Î˜Î­ÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î¤ÏÏ€Î¿Ï‚ Î¼ÏŒÎ½Î¿',0),(349366,9705,'zh','ä»…å·¥ä½œç±»åž‹\r\n',0),(349367,9705,'sv','Jobbtyp endast',0),(349368,9705,'it','Tipo di lavoro solo',0),(349369,9705,'tl','',0),(349370,9705,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3591;&#3634;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(349371,9705,'hi','à¤•à¥‡à¤µà¤² à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(349372,9705,'ms','Jenis pekerjaan',0),(349373,9705,'ar','Ù†ÙˆØ¹ Ø§Ù„ÙˆØ¸ÙŠÙØ© ÙÙ‚Ø·',0),(349374,9705,'fr','Type dâ€™emploi seulement',0),(349375,9705,'jp','ã‚¸ãƒ§ãƒ–ã®ç¨®é¡žã®ã¿',0),(349376,9705,'pt','Tipo de trabalho sÃ³',0),(349377,9705,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ñ‚Ð¸Ð¿ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(349378,9705,'es','Tipo de ColocaciÃ³n Solamente',0),(349379,9705,'de','Job-Typ',0),(349380,9705,'en','Job Type Only',0),(349381,9706,'is','',0),(349382,9706,'dr','ÙÙ‚Ø· Ù†ÙˆØ¹ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(349383,9706,'pr','ÙÙ‚Ø· Ù†ÙˆØ¹ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(349384,9706,'tr','Standart tip sadece',0),(349385,9706,'pl','Standardowy typ tylko',0),(349386,9706,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ‚Ð¸Ð¿ ÑÐ°Ð¼Ð¾',0),(349387,9706,'ur','ØµØ±Ù Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù‚Ø³Ù…',0),(349388,9706,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ñ‚Ð¸Ð¿ ÑÐ°Ð¼Ð¾',0),(349389,9706,'vi','Loáº¡i tiÃªu chuáº©n',0),(349390,9706,'af','Standaard Tipe Alleenlik',0),(349391,9706,'ro','Standard de tip numai',0),(349392,9706,'et','Standard tÃ¼Ã¼p',0),(349393,9706,'si','Standard tip samo',0),(349394,9706,'ba','Tipe standar hanya',0),(349395,9706,'nl','Alleen het standaard Type',0),(349396,9706,'fi','Standard tyyppi',0),(349397,9706,'no','Standardtypen bare',0),(349398,9706,'da','Standard Type kun',0),(349399,9706,'ko','í‘œì¤€ íƒ€ìž…ë§Œ',0),(349400,9706,'he','×¡×•×’ ×ª×§×Ÿ ×‘×œ×‘×“',0),(349401,9706,'el','ÎšÎ±Î½Î¿Î½Î¹ÎºÏŒÏ‚ Ï„ÏÏ€Î¿Ï‚ Î¼ÏŒÎ½Î¿',0),(349402,9706,'zh','åªæœ‰æ ‡å‡†åž‹\r\n',0),(349403,9706,'sv','Standard typ bara',0),(349404,9706,'it','Tipo standard solo',0),(349405,9706,'tl','',0),(349406,9706,'th','&#3648;&#3593;&#3614;&#3634;&#3632;&#3611;&#3619;&#3632;&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;\n',0),(349407,9706,'hi','à¤®à¤¾à¤¨à¤• à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡à¤µà¤²',0),(349408,9706,'ms','Jenis Standard',0),(349409,9706,'ar','Ø§Ù„Ù†ÙˆØ¹ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ ÙÙ‚Ø·',0),(349410,9706,'fr','Type standard uniquement',0),(349411,9706,'jp','æ¨™æº–åž‹ã®ã¿',0),(349412,9706,'pt','PadrÃ£o tipo apenas',0),(349413,9706,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð¢Ð¸Ð¿',0),(349414,9706,'es','Tipo EstÃ¡ndar Solamente',0),(349415,9706,'de','Nur Standard Typ',0),(349416,9706,'en','Standard Type Only',0),(349417,9707,'is','',0),(349418,9707,'dr','Ú†Ù‡ Ù†ÙˆØ¹ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ÙŠ',0),(349419,9707,'pr','Ú†Ù‡ Ù†ÙˆØ¹ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ÙŠ',0),(349420,9707,'tr','Hangi tÃ¼r PO',0),(349421,9707,'pl','Typy, ktÃ³re po',0),(349422,9707,'bg','ÐšÐ¾Ð¸ Ð²Ð¸Ð´Ð¾Ð²Ðµ PO',0),(349423,9707,'ur','Ú©Ø³ Ø·Ø±Ø­ Ù¾Ùˆ',0),(349424,9707,'sr','ÐšÐ¾Ñ˜Ðµ Ð²Ñ€ÑÑ‚Ðµ ÐŸÐž',0),(349425,9707,'vi','Loáº¡i Ä‘Æ¡n Ä‘áº·t hÃ ng nÃ o',0),(349426,9707,'af','Watter Tipes van AB',0),(349427,9707,'ro','Care sunt tipurile de PO',0),(349428,9707,'et','Millist tÃ¼Ã¼pi ostutellimus',0),(349429,9707,'si','Katere vrste PO',0),(349430,9707,'ba','Jenis PO',0),(349431,9707,'nl','Welke soorten PO',0),(349432,9707,'fi','MinkÃ¤ tyyppisiÃ¤ PO',0),(349433,9707,'no','Hvilke typer PO',0),(349434,9707,'da','Hvilke typer af PO',0),(349435,9707,'ko','í¬ì˜ ìœ í˜•',0),(349436,9707,'he','××™×œ×• ×¡×•×’×™× ×©×œ ×¤×•',0),(349437,9707,'el','Î Î¿Î¹Î¿Î¹ Ï„ÏÏ€Î¿Î¹ PO',0),(349438,9707,'zh','å“ªäº›ç±»åž‹çš„é‡‡è´­è®¢å•\r\n',0),(349439,9707,'sv','Vilka typer av PO',0),(349440,9707,'it','Quali tipi di PO',0),(349441,9707,'tl','',0),(349442,9707,'th','&#3595;&#3638;&#3656;&#3591;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;',0),(349443,9707,'hi','à¤ªà¥à¤²à¤¿à¤¸ à¤•à¥€ à¤•à¤¿à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(349444,9707,'ms','Yang jenis PO',0),(349445,9707,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø¨Ùˆ',0),(349446,9707,'fr','Quels Types de PO',0),(349447,9707,'jp','PO ã®ç¨®é¡ž',0),(349448,9707,'pt','Quais os tipos de PO',0),(349449,9707,'ru','ÐšÐ°ÐºÐ¸Ðµ Ñ‚Ð¸Ð¿Ñ‹ PO',0),(349450,9707,'es','Que Tipos de OC',0),(349451,9707,'de','Welche Arten von PO',0),(349452,9707,'en','Which Types of PO',0),(349453,9708,'is','',0),(349454,9708,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(349455,9708,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡',0),(349456,9708,'tr','Malzemeler PO',0),(349457,9708,'pl','MateriaÅ‚y PO',0),(349458,9708,'bg','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ PO',0),(349459,9708,'ur','Ù…ÙˆØ§Ø¯ Ù¾Ùˆ',0),(349460,9708,'sr','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð» ÐŸÐž',0),(349461,9708,'vi','Váº­t liá»‡u PO',0),(349462,9708,'af','Materiale AB',0),(349463,9708,'ro','Materiale PO',0),(349464,9708,'et','Materjalide PO',0),(349465,9708,'si','Materialov PO',0),(349466,9708,'ba','Bahan PO',0),(349467,9708,'nl','Materialen PO',0),(349468,9708,'fi','Materiaalit PO',0),(349469,9708,'no','Materialer PO',0),(349470,9708,'da','Materialer PO',0),(349471,9708,'ko','ìžë£Œ í¬',0),(349472,9708,'he','×—×•×ž×¨×™× ×¤×•',0),(349473,9708,'el','Î¥Î»Î¹ÎºÎ¬ PO',0),(349474,9708,'zh','ææ–™é‡‡è´­è®¢å•\r\n',0),(349475,9708,'sv','Material PO',0),(349476,9708,'it','Materiali PO',0),(349477,9708,'tl','',0),(349478,9708,'th','&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3623;&#3633;&#3605;&#3606;&#3640;&#3604;&#3636;&#3610;',0),(349479,9708,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤ªà¥‹',0),(349480,9708,'ms','Bahan-bahan PO',0),(349481,9708,'ar','Ù…ÙˆØ§Ø¯ Ø¨Ùˆ',0),(349482,9708,'fr','MatÃ©riaux PO',0),(349483,9708,'jp','ææ–™ PO',0),(349484,9708,'pt','Materiais PO',0),(349485,9708,'ru','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹ Ð¿Ð¾',0),(349486,9708,'es','Materiales de OC',0),(349487,9708,'de','Material PO',0),(349488,9708,'en','Materials PO',0),(349489,9709,'is','',0),(349490,9709,'dr','Ù…ÙØ§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(349491,9709,'pr','Ù…ÙØ§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(349492,9709,'tr','PO amaÃ§',0),(349493,9709,'pl','Celem PO',0),(349494,9709,'bg','PO Ñ†ÐµÐ»',0),(349495,9709,'ur','Ù¾Ùˆ Ù…Ù‚ØµØ¯',0),(349496,9709,'sr','ÐŸÐž ÑÐ²Ñ€ÑÐ¸',0),(349497,9709,'vi','Má»¥c Ä‘Ã­ch cá»§a PO',0),(349498,9709,'af','PO doel',0),(349499,9709,'ro','Scopul PO',0),(349500,9709,'et','PO eesmÃ¤rk',0),(349501,9709,'si','PO namenu',0),(349502,9709,'ba','Tujuan PO',0),(349503,9709,'nl','Doel van de PO',0),(349504,9709,'fi','PO tarkoitus',0),(349505,9709,'no','PO formÃ¥l',0),(349506,9709,'da','PO formÃ¥l',0),(349507,9709,'ko','ê°€ ëª©ì ',0),(349508,9709,'he','×¤×• ×ž×˜×¨×”',0),(349509,9709,'el','PO ÏƒÎºÎ¿Ï€ÏŒÏ‚',0),(349510,9709,'zh','å®ç›®çš„\r\n',0),(349511,9709,'sv','PO syfte',0),(349512,9709,'it','Scopo di PO',0),(349513,9709,'tl','',0),(349514,9709,'th','&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3648;&#3614;&#3639;&#3656;&#3629;',0),(349515,9709,'hi','PO à¤‰à¤¦à¥à¤¦à¥‡à¤¶à¥à¤¯',0),(349516,9709,'ms','Tujuan PO',0),(349517,9709,'ar','Øµ. Ø¨ Ø§Ù„ØºØ±Ø¶',0),(349518,9709,'fr','But de PO',0),(349519,9709,'jp','PO ã®ç›®çš„',0),(349520,9709,'pt','Finalidade de PO',0),(349521,9709,'ru','ÐŸÐž Ñ†ÐµÐ»Ð¸',0),(349522,9709,'es','PropÃ³sito de OC',0),(349523,9709,'de','PO-Zweck',0),(349524,9709,'en','PO Purpose',0),(349525,9710,'is','',0),(349526,9710,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰',0),(349527,9710,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰',0),(349528,9710,'tr','TaÅŸeron PO',0),(349529,9710,'pl','Podwykonawstwo PO',0),(349530,9710,'bg','ÐŸÐ¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ PO',0),(349531,9710,'ur','Ø³Ø¨Ú©ÙˆÙ†Ù¹Ø±Ø§Ú©Ù¹ Ù¾Ùˆ',0),(349532,9710,'sr','ÐŸÐž Ð¿Ð¾Ð´Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð°',0),(349533,9710,'vi','Subcontract PO',0),(349534,9710,'af','Sub-kontrak AB',0),(349535,9710,'ro','Subcontractare PO',0),(349536,9710,'et','Allhankelepingu PO',0),(349537,9710,'si','Podpogodbe PO',0),(349538,9710,'ba','Subkontrak PO',0),(349539,9710,'nl','Onderaanneming PO',0),(349540,9710,'fi','Alihankinnan PO',0),(349541,9710,'no','Sub-PO',0),(349542,9710,'da','Underleverance PO',0),(349543,9710,'ko','í•˜ì²­ í¬',0),(349544,9710,'he','×§×¨×™×¢×ª ×¤×•',0),(349545,9710,'el','PO Ï…Ï€ÎµÏÎ³Î¿Î»Î±Î²Î¯Î±Ï‚',0),(349546,9710,'zh','åˆ†åŒ…è®¢å•\r\n',0),(349547,9710,'sv','UnderleverantÃ¶rskontraktet PO',0),(349548,9710,'it','PO di subappalto',0),(349549,9710,'tl','',0),(349550,9710,'th','&#3626;&#3633;&#3597;&#3597;&#3634;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(349551,9710,'hi','Subcontract PO',0),(349552,9710,'ms','PO sub-kontrak',0),(349553,9710,'ar','Øµ. Ø¨Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù†.',0),(349554,9710,'fr','Contrat de sous-traitance PO',0),(349555,9710,'jp','ä¸‹è«‹ PO',0),(349556,9710,'pt','PO de subcontrato',0),(349557,9710,'ru','Ð”Ð¾Ð³Ð¾Ð²Ð¾Ñ€ ÑÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´Ð° PO',0),(349558,9710,'es','OC de Subcontrato',0),(349559,9710,'de','Unterauftrag PO',0),(349560,9710,'en','Subcontract PO',0),(349561,9711,'is','',0),(349562,9711,'dr','( _Ø­Ù…Ù„ Ø¨Ù‡ _  ) ',0),(349563,9711,'pr','Ù‡ÙŠÚ† Ù…ÙˆØ±Ø¯ÙŠ Ø¯Ø± Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯ ÙØ±Ø¹ÙŠ  ( _Ø­Ù…Ù„ Ø¨Ù‡ _  ) ',0),(349564,9711,'tr','TaÅŸeron Shipto kutusu yok',0),(349565,9711,'pl','Nie ma pola na podwykonawstwo Shipto',0),(349566,9711,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð·Ð° Ð¿Ð¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Shipto',0),(349567,9711,'ur','Ú©ÙˆØ¦ÛŒ Ø®Ø§Ù†ÙˆÚº Ù¾Ø± Ø³Ø¨Ú©ÙˆÙ†Ù¹Ø±Ø§Ú©Ù¹ Ø´Ø§Ù¾Ù¹Ùˆ',0),(349568,9711,'sr','ÐÐµÐ¼Ð° ÐºÑƒÑ‚Ð¸Ñ˜Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð° ÐŸÑ€Ð¸Ð¼Ð°Ð¾Ñ† Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(349569,9711,'vi','KhÃ´ng cÃ³ há»™p trÃªn Subcontract Shipto',0),(349570,9711,'af','Geen Bokse op Sub-kontrak  Versend Aan',0),(349571,9711,'ro','Casete de pe Shipto de subcontractare',0),(349572,9711,'et','Pole kaste allhankelepingu Shipto',0),(349573,9711,'si','Ni polja na podpogodbe Shipto',0),(349574,9711,'ba','Ada kotak di subkontrak Shipto',0),(349575,9711,'nl','Geen vakken op toeleveringscontract Shipto',0),(349576,9711,'fi','Ei laatikoita alihankinnan Shipto',0),(349577,9711,'no','Ingen bokser pÃ¥ sub-Shipto',0),(349578,9711,'da','Ingen bokse pÃ¥ underleverance Shipto',0),(349579,9711,'ko','í•˜ì²­ Shipto ì—†ìŒ ìƒìž',0),(349580,9711,'he','×œ×œ× ×ª×™×‘×•×ª ×¢×œ ×§×¨×™×¢×ª ×©×¢×•×–×‘×ª',0),(349581,9711,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Ï€Î»Î±Î¯ÏƒÎ¹Î± ÏƒÎµ Ï…Ï€ÎµÏÎ³Î¿Î»Î±Î²Î¯Î±Ï‚ Shipto',0),(349582,9711,'zh','å¯¹åˆ†åŒ…èˆ¹å·æ¡†ï¼Œ\r\n',0),(349583,9711,'sv','Inga rutor pÃ¥ legotillverkning Shipto',0),(349584,9711,'it','Senza finestre di subappalto Shipto',0),(349585,9711,'tl','',0),(349586,9711,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3594;&#3656;&#3629;&#3591;&#3586;&#3629;&#3591;&#3626;&#3633;&#3597;&#3597;&#3634;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(349587,9711,'hi','à¤•à¥‹à¤ˆ à¤¬à¤•à¥à¤¸à¥‡ Subcontract Shipto à¤ªà¤°',0),(349588,9711,'ms','Tiada kotak di sub-kontrak Shipto',0),(349589,9711,'ar','Ø£ÙŠØ© Ù…Ø±Ø¨Ø¹Ø§Øª Ø¹Ù„Ù‰ Ø§Ù„ØªØ¹Ø§Ù‚Ø¯ Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù† Ø´ÙŠØªÙˆ',0),(349590,9711,'fr','Pas de boÃ®tes sur la sous-traitance Shipto',0),(349591,9711,'jp','ä¸‹è«‹ Shipto ã®ãƒœãƒƒã‚¯ã‚¹ã¯è¡¨ç¤ºã•ã‚Œã¾ã›ã‚“ã€‚',0),(349592,9711,'pt','Sem caixas no navio de subcontrato',0),(349593,9711,'ru','ÐÐµÑ‚ ÐºÐ¾Ñ€Ð¾Ð±ÐºÐ¸ Ð½Ð° ÑÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´Ðµ Shipto',0),(349594,9711,'es','No hay Cajas en el Subcontrato de Enviar a',0),(349595,9711,'de','Keine Boxen auf Subcontract Shipto',0),(349596,9711,'en','No Boxes on Subcontract Shipto',0),(349597,9712,'is','',0),(349598,9712,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÙŠØ¯ ÙÙ‚Ø· Ø¯Ø± Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù‡Ø§ÙŠ ÙØ±Ø¹ÙŠ',0),(349599,9712,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÙŠØ¯ ÙÙ‚Ø· Ø¯Ø± Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù‡Ø§ÙŠ ÙØ±Ø¹ÙŠ',0),(349600,9712,'tr','SatÄ±nalma Mkt. gÃ¶ster YalnÄ±zca taÅŸeron',0),(349601,9712,'pl','PokaÅ¼ iloÅ›Ä‡ zakupu Tylko na podwykonawstwo',0),(349602,9712,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð°Ð¹ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð¡Ð°Ð¼Ð¾ Ð·Ð° Ð¿Ð¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(349603,9712,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Qty. Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº ØµØ±Ù Ø³Ø¨Ú©ÙˆÙ†Ù¹Ø±Ø§Ú©Ù¹ Ù¾Ø±',0),(349604,9712,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ð» Ð½Ð°Ð±Ð°Ð²ÐºÐµ. Ð¡Ð°Ð¼Ð¾ Ð½Ð° Ð¿Ð¾Ð´Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð°',0),(349605,9712,'vi','Hiá»ƒn thá»‹ mua Qty. Chá»‰ trÃªn Subcontract',0),(349606,9712,'af','Wys Aankoop Hoev. Slegs op Sub-kontrak',0),(349607,9712,'ro','Cant. de cumpÄƒrare AratÄƒ Numai pe subcontractare',0),(349608,9712,'et','NÃ¤ita ostu kogust Ainult linna allhankelepingu',0),(349609,9712,'si','PrikaÅ¾i nakup koliÄina Samo na kooperanta',0),(349610,9712,'ba','Tampilkan pembelian Qty. Hanya pada subkontrak',0),(349611,9712,'nl','Toon aankoop veld Alleen op uitbesteden',0),(349612,9712,'fi','NÃ¤ytÃ¤ ostojen mÃ¤Ã¤rÃ¤ Vain jÃ¤senen alihankintana',0),(349613,9712,'no','Vis KjÃ¸p antall Bare pÃ¥ sub',0),(349614,9712,'da','Vis KÃ¸b antal Kun pÃ¥ underleverance',0),(349615,9712,'ko','êµ¬ë§¤ ìˆ˜ëŸ‰ì„ í‘œì‹œ í•˜ì²­ì—ë§Œ',0),(349616,9712,'he','×”×¦×’ ×›×ž×•×ª ×¨×›×™×©×” ×¨×§ ×¢×œ ×§×¨×™×¢×ª',0),(349617,9712,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î Î¿Ïƒ Î±Î³Î¿ÏÎ¬. ÎœÏŒÎ½Î¿ ÏƒÎµ Ï…Ï€ÎµÏÎ³Î¿Î»Î±Î²Î¯Î±',0),(349618,9712,'zh','æ˜¾ç¤ºè´­ä¹°æ•°é‡ã€‚åªæœ‰åœ¨åˆ†åŒ…åˆåŒ\r\n',0),(349619,9712,'sv','Visa kÃ¶p Ant. Endast pÃ¥ legotillverkning',0),(349620,9712,'it','Vedi acquisto Qty. Solo il subappalto',0),(349621,9712,'tl','',0),(349622,9712,'th','&#3649;&#3626;&#3604;&#3591;&#3611;&#3619;&#3636;&#3617;&#3634;&#3603;&#3595;&#3639;&#3657;&#3629;&#3648;&#3593;&#3614;&#3634;&#3632;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3618;&#3656;&#3629;&#3618;',0),(349623,9712,'hi','à¤–à¤°à¥€à¤¦ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤ à¤•à¥‡à¤µà¤² Subcontract à¤ªà¤°',0),(349624,9712,'ms','Menunjukkan pembelian Qty. Hanya pada sub-kontrak',0),(349625,9712,'ar','Ø¥Ø¸Ù‡Ø§Ø± Qty. Ø§Ù„Ø´Ø±Ø§Ø¡ ÙÙ‚Ø· Ø¹Ù„Ù‰ Ø§Ù„ØªØ¹Ø§Ù‚Ø¯ Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù†',0),(349626,9712,'fr','Voir lâ€™achat QtÃ© Que le contrat de sous-traitance',0),(349627,9712,'jp','è³¼å…¥æ•°é‡ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚ä¸‹è«‹ã‘ã«ã®ã¿',0),(349628,9712,'pt','Visualizar compra Qtd. SÃ³ no subcontrato',0),(349629,9712,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° ÐšÐ¾Ð»-Ð²Ð¾ Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð½Ð° ÑÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´',0),(349630,9712,'es','Muestra Cantidad de Compra Solo en el Subcontrato',0),(349631,9712,'de','Zeigen Kauf Anz Nur im Unterauftrag',0),(349632,9712,'en','Show Purchase Qty. Only on Subcontract',0),(349633,9713,'is','',0),(349634,9713,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(349635,9713,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(349636,9713,'tr','Standart SatÄ±nalma sipariÅŸleri',0),(349637,9713,'pl','ZamÃ³wienia zakupu na standardowy',0),(349638,9713,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(349639,9713,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(349640,9713,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð¸Ð·Ð»Ð°Ð·Ð½Ð¸Ñ… Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°',0),(349641,9713,'vi','TiÃªu chuáº©n mua Ä‘Æ¡n hÃ ng',0),(349642,9713,'af','Standaard Aankoopbestellings',0),(349643,9713,'ro','Comenzi de cumpÄƒrare standard',0),(349644,9713,'et','Standard ostutellimused',0),(349645,9713,'si','Standardni naroÄilnice',0),(349646,9713,'ba','Pesanan pembelian standar',0),(349647,9713,'nl','Standaard inkooporders',0),(349648,9713,'fi','Vakio-ostotilausten',0),(349649,9713,'no','Standard bestillinger',0),(349650,9713,'da','Standard indkÃ¸bsordrer',0),(349651,9713,'ko','í‘œì¤€ êµ¬ë§¤ ì£¼ë¬¸',0),(349652,9713,'he','×”×–×ž× ×•×ª ×¨×›×© ×¡×˜× ×“×¨×˜×™',0),(349653,9713,'el','Î£Ï„Î¬Î½Ï„Î±Ï Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(349654,9713,'zh','æ ‡å‡†é‡‡è´­è®¢å•\r\n',0),(349655,9713,'sv','Standard inkÃ¶psorder',0),(349656,9713,'it','Ordini di acquisto standard',0),(349657,9713,'tl','',0),(349658,9713,'th','&#3617;&#3634;&#3605;&#3619;&#3600;&#3634;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(349659,9713,'hi','à¤®à¤¾à¤¨à¤• à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(349660,9713,'ms','Pesanan pembelian Standard',0),(349661,9713,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(349662,9713,'fr','Ordres dâ€™achat standard',0),(349663,9713,'jp','æ¨™æº–è³¼è²·ç™ºæ³¨',0),(349664,9713,'pt','Ordens de compra padrÃ£o',0),(349665,9713,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(349666,9713,'es','Ordenes de Compra EstÃ¡ndares',0),(349667,9713,'de','Normalbestellungen',0),(349668,9713,'en','Standard Purchase Orders',0),(349669,9714,'is','',0),(349670,9714,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰',0),(349671,9714,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰',0),(349672,9714,'tr','TaÅŸeron sipariÅŸler',0),(349673,9714,'pl','Zlecenia podwykonawstwa',0),(349674,9714,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ð¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(349675,9714,'ur','Ø³Ø¨Ú©ÙˆÙ†Ù¹Ø±Ø§Ú©Ù¹ Ú©Û’ Ø§Ø­Ú©Ø§Ù…',0),(349676,9714,'sr','ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¿Ð¾Ð´Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð°',0),(349677,9714,'vi','ÄÆ¡n Ä‘áº·t hÃ ng subcontract',0),(349678,9714,'af','Sub-Kontrak Bestellings',0),(349679,9714,'ro','Comenzi de subcontractare',0),(349680,9714,'et','Allhankelepingu tellimused',0),(349681,9714,'si','Podpogodbe naroÄila',0),(349682,9714,'ba','Subkontrak pesanan',0),(349683,9714,'nl','Onderaanneming Orders',0),(349684,9714,'fi','Alihankinnan tilaukset',0),(349685,9714,'no','Sub-ordre',0),(349686,9714,'da','Underleverance ordrer',0),(349687,9714,'ko','í•˜ì²­ ì£¼ë¬¸',0),(349688,9714,'he','×§×¨×™×¢×ª ×”×–×ž× ×•×ª',0),(349689,9714,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï…Ï€ÎµÏÎ³Î¿Î»Î±Î²Î¯Î±Ï‚',0),(349690,9714,'zh','åˆ†åŒ…è®¢å•\r\n',0),(349691,9714,'sv','UnderleverantÃ¶rskontraktet order',0),(349692,9714,'it','Ordini di subappalto',0),(349693,9714,'tl','',0),(349694,9714,'th','&#3626;&#3633;&#3597;&#3597;&#3634;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(349695,9714,'hi','Subcontract à¤†à¤¦à¥‡à¤¶',0),(349696,9714,'ms','Pesanan sub-kontrak',0),(349697,9714,'ar','Ø£ÙˆØ§Ù…Ø± Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù†',0),(349698,9714,'fr','Commandes de sous-traitance',0),(349699,9714,'jp','å¤–æ³¨ç™ºæ³¨',0),(349700,9714,'pt','Ordens de subcontrataÃ§Ã£o',0),(349701,9714,'ru','Ð¡ÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(349702,9714,'es','Ordenes de Subcontrato',0),(349703,9714,'de','Lohnbearbeitungsbestellungen',0),(349704,9714,'en','Subcontract Orders',0),(349705,9715,'is','',0),(349706,9715,'dr','Ù‚Ø§Ù„Ø¨ Ø³ÙØ§Ø±Ø´ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰',0),(349707,9715,'pr','Ù‚Ø§Ù„Ø¨ Ø³ÙØ§Ø±Ø´ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰',0),(349708,9715,'tr','TaÅŸeron sipariÅŸi biÃ§imi',0),(349709,9715,'pl','Podwykonawstwo Order Format',0),(349710,9715,'bg','ÐŸÐ¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½Ð¸Ð¼Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(349711,9715,'ur','Ø³Ø¨Ú©ÙˆÙ†Ù¹Ø±Ø§Ú©Ù¹ ØªØ±ØªÛŒØ¨ ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(349712,9715,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¿Ð¾Ð´Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð°',0),(349713,9715,'vi','Subcontract lá»‡nh Ä‘á»‹nh dáº¡ng',0),(349714,9715,'af','Sub-Kontrak Bestellingsformaat',0),(349715,9715,'ro','Format de ordine subcontractare',0),(349716,9715,'et','Allhankelepingu tellimuse vorm',0),(349717,9715,'si','Oblika naloga kooperanta',0),(349718,9715,'ba','Subkontrak urutan Format',0),(349719,9715,'nl','Onderaanneming Order Format',0),(349720,9715,'fi','Alihankinnan Order Format',0),(349721,9715,'no','Format for sub',0),(349722,9715,'da','Underleverance Order Format',0),(349723,9715,'ko','í•˜ì²­ ì£¼ë¬¸ í˜•ì‹',0),(349724,9715,'he','×ª×‘× ×™×ª ×¡×“×¨ ×§×¨×™×¢×ª',0),(349725,9715,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î¼Î¿ÏÏ†Î® Ï…Ï€ÎµÏÎ³Î¿Î»Î±Î²Î¯Î±Ï‚',0),(349726,9715,'zh','åˆ†åŒ…åˆåŒçš„å‘½ä»¤æ ¼å¼\r\n',0),(349727,9715,'sv','Format fÃ¶r underkontrakt ordning',0),(349728,9715,'it','Formato di ordine di subappalto',0),(349729,9715,'tl','',0),(349730,9715,'th','&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3626;&#3633;&#3597;&#3597;&#3634;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(349731,9715,'hi','Subcontract à¤•à¥à¤°à¤® à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(349732,9715,'ms','Sub-kontrak perintah Format',0),(349733,9715,'ar','ØªÙ†Ø³ÙŠÙ‚ ØªØ±ØªÙŠØ¨ Ø§Ù„ØªØ¹Ø§Ù‚Ø¯ Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù†',0),(349734,9715,'fr','Contrat de sous-traitance commande Format',0),(349735,9715,'jp','å¤–æ³¨ã‚ªãƒ¼ãƒ€ãƒ¼ ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(349736,9715,'pt','Formato de ordem de subcontrato',0),(349737,9715,'ru','Ð”Ð¾Ð³Ð¾Ð²Ð¾Ñ€ ÑÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(349738,9715,'es','Formato de Ordees de Subcontrato',0),(349739,9715,'de','Unterauftrag Bestellformat',0),(349740,9715,'en','Subcontract Order Format',0),(349741,9716,'is','',0),(349742,9716,'dr','Ù…ØªÙˆÙ‚Ù ÙƒØ±Ø¯Ù† Ú†Ø§Ù¾ Ø´Ù…Ø§Ø±Ù‡ Ø³Ø·Ø± Ø±ÙˆÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹ÙŠ',0),(349743,9716,'pr','Ù…ØªÙˆÙ‚Ù ÙƒØ±Ø¯Ù† Ú†Ø§Ù¾ Ø´Ù…Ø§Ø±Ù‡ Ø³Ø·Ø± Ø±ÙˆÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹ÙŠ',0),(349744,9716,'tr','SatÄ±r numarasÄ± taÅŸeron olarak bastÄ±rmak',0),(349745,9716,'pl','PominÄ…Ä‡ numer wiersza na podwykonawstwo',0),(349746,9716,'bg','ÐŸÐ¾Ñ‚Ð¸ÑÐºÐ°Ñ‚ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ñ€ÐµÐ´Ð° Ð·Ð° Ð¿Ð¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(349747,9716,'ur','Ø³Ø¨Ú©ÙˆÙ†Ù¹Ø±Ø§Ú©Ù¹ Ù¾Ø± Ù„Ø§Ø¦Ù† Ù†Ù…Ø¨Ø± Ù…Ù¹Ø§Ø¦ÛŒÚº',0),(349748,9716,'sr','ÐŸÐ¾Ñ‚Ð¸ÑÐ½ÑƒÑ‚Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ€ÐµÐ´Ð° Ð½Ð° Ð¿Ð¾Ð´Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð°',0),(349749,9716,'vi','NgÄƒn cháº·n sá»‘ dÃ²ng trÃªn Subcontract',0),(349750,9716,'af','Onderdruk ReÃ«lnommer op Subcontract',0),(349751,9716,'ro','Suprimare numÄƒr de linie pe subcontractare',0),(349752,9716,'et','Rea Number allhankelepingu pÃ¤rsivad',0),(349753,9716,'si','Zatiranje Å¡tevilka vrstice kooperanta',0),(349754,9716,'ba','Menekan nomor baris subkontrak',0),(349755,9716,'nl','Onderdrukken regelnummer op uitbesteden',0),(349756,9716,'fi','Tukahduttaa alihankinnan rivinumero',0),(349757,9716,'no','Undertrykke linjenummeret pÃ¥ sub',0),(349758,9716,'da','Undertrykke linjenummer pÃ¥ underleverance',0),(349759,9716,'ko','í•˜ì²­ì— ì¤„ ë²ˆí˜¸ í‘œì‹œ ì•ˆ í•¨',0),(349760,9716,'he','×œ×“×›× ××ª ×ž×¡×¤×¨ ×”×©×•×¨×” ×¢×œ ×§×¨×™×¢×ª',0),(349761,9716,'el','ÎšÎ±Ï„Î±ÏƒÏ„Î­Î»Î»Î¿Ï…Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ„Î¿ Ï…Ï€ÎµÏÎ³Î¿Î»Î±Î²Î¯Î±Ï‚',0),(349762,9716,'zh','ç¦æ­¢å¯¹åˆ†åŒ…è¡Œå·\r\n',0),(349763,9716,'sv','UtelÃ¤mna radnummer pÃ¥ legotillverkning',0),(349764,9716,'it','Sopprimere il numero di riga sul subappalto',0),(349765,9716,'tl','',0),(349766,9716,'th','Suppres Line Number on Subcontract',0),(349767,9716,'hi','Subcontract à¤ªà¤° à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤•à¥à¤°à¤®à¤¾à¤‚à¤• à¤°à¥‹à¤•à¥‡à¤‚',0),(349768,9716,'ms','Menyekat nombor baris di sub-kontrak',0),(349769,9716,'ar','Ù‚Ù…Ø¹ Ø±Ù‚Ù… Ø§Ù„Ø³Ø·Ø± ÙÙŠ Ø§Ù„ØªØ¹Ø§Ù‚Ø¯ Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù†',0),(349770,9716,'fr','Supprimer le numÃ©ro de contrat de sous-traitance',0),(349771,9716,'jp','ä¸‹è«‹ã‘ã«è¡Œç•ªå·ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(349772,9716,'pt','Suprimir o nÃºmero da linha no subcontrato',0),(349773,9716,'ru','ÐŸÐ¾Ð´Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð° ÑÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´Ð°',0),(349774,9716,'es','Suprime NÃºmero de Linea en el Subcontrato',0),(349775,9716,'de','Zeilennummer Subcontract unterdrÃ¼cken',0),(349776,9716,'en','Suppress Line Number on Subcontract',0),(349777,9717,'is','',0),(349778,9717,'dr','Ù…Ø¯ÙŠØ± ØªÙˆÙ„ÙŠØ¯ ',0),(349779,9717,'pr','Ù…Ø¯ÙŠØ± ØªÙˆÙ„ÙŠØ¯ ',0),(349780,9717,'tr','Ãœretim Mgr.',0),(349781,9717,'pl','Mgr produkcji.',0),(349782,9717,'bg','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ Mgr.',0),(349783,9717,'ur','Ù¾ÛŒØ¯Ø§ÙˆØ§Ø± Ø§ØªÚ¯Ø± Û”',0),(349784,9717,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑšÐ° Ð£Ð¿Ñ€.',0),(349785,9717,'vi','quáº£n lÃ½ sáº£n xuáº¥t',0),(349786,9717,'af','Produksie Mgr.',0),(349787,9717,'ro','ProducÅ£ie Mgr.',0),(349788,9717,'et','Tootmise Mgr.',0),(349789,9717,'si','Proizvodnja Mgr.',0),(349790,9717,'ba','Mgr produksi.',0),(349791,9717,'nl','Mgr van de productie.',0),(349792,9717,'fi','Tuotannon Mgr.',0),(349793,9717,'no','Produksjon Mgr.',0),(349794,9717,'da','Produktion Mgr.',0),(349795,9717,'ko','ìƒì‚° ê´€ë¦¬ìžìž…ë‹ˆë‹¤.',0),(349796,9717,'he','×™×™×¦×•×¨ Mgr.',0),(349797,9717,'el','Î Î±ÏÎ±Î³Ï‰Î³Î® Mgr.',0),(349798,9717,'zh','ç”Ÿäº§ç»ç†ã€‚\r\n',0),(349799,9717,'sv','Production Mgr.',0),(349800,9717,'it','Produzione Mgr.',0),(349801,9717,'tl','',0),(349802,9717,'th','&#3605;&#3633;&#3623;&#3585;&#3634;&#3619;&#3612;&#3621;&#3636;&#3605;',0),(349803,9717,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¨ à¤à¤®à¤œà¥€à¤†à¤°à¥¤',0),(349804,9717,'ms','P\'urus pengeluaran.',0),(349805,9717,'ar','Ù…Ø¯ÙŠØ± Ø§Ù„Ø¥Ù†ØªØ§Ø¬',0),(349806,9717,'fr','Resp de production.',0),(349807,9717,'jp','ç”Ÿç”£èª²é•·',0),(349808,9717,'pt','Gerente de produÃ§Ã£o.',0),(349809,9717,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ Mgr.',0),(349810,9717,'es','Jefe de ProducciÃ³n',0),(349811,9717,'de','Produktion-Mgr.',0),(349812,9717,'en','Production Mgr.',0),(349813,9718,'is','',0),(349814,9718,'dr','Ù…Ø¯ÙŠØ± Ø³Ø§ÙŠØª ',0),(349815,9718,'pr','Ù…Ø¯ÙŠØ± Ø³Ø§ÙŠØª ',0),(349816,9718,'tr','Site YÃ¶neticisi',0),(349817,9718,'pl','Kierownik budowy',0),(349818,9718,'bg','Ð¡Ð°Ð¹Ñ‚ Ð¼ÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€',0),(349819,9718,'ur','Ø³Ø§Ø¦Ù¹ Ù…ÛŒÙ†ÛŒØ¬Ø±',0),(349820,9718,'sr','Ð“Ñ€Ð°Ð´Ð¸Ð»Ð¸ÑˆÑ‚Ð°',0),(349821,9718,'vi','NgÆ°á»i quáº£n lÃ½ web',0),(349822,9718,'af','Terreinbestuurder',0),(349823,9718,'ro','Managerul site-ului',0),(349824,9718,'et','Objektijuht',0),(349825,9718,'si','Upravitelj mest',0),(349826,9718,'ba','Pengelola situs',0),(349827,9718,'nl','Sitebeheerder',0),(349828,9718,'fi','Site Manager',0),(349829,9718,'no','OmrÃ¥deansvarlig',0),(349830,9718,'da','Site Manager',0),(349831,9718,'ko','ì‚¬ì´íŠ¸ ê´€ë¦¬ìž',0),(349832,9718,'he','×ž× ×”×œ ××ª×¨',0),(349833,9718,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¹ÏŽÎ½',0),(349834,9718,'zh','ç«™ç‚¹ç®¡ç†\r\n',0),(349835,9718,'sv','Platschef',0),(349836,9718,'it','Site Manager',0),(349837,9718,'tl','',0),(349838,9718,'th','&#3612;&#3641;&#3657;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;&#3604;&#3657;&#3634;&#3609;',0),(349839,9718,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤•',0),(349840,9718,'ms','Pengurus tapak',0),(349841,9718,'ar','Ù…Ø¯ÙŠØ± Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(349842,9718,'fr','Gestionnaire du site',0),(349843,9718,'jp','ã‚µã‚¤ãƒˆ ãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼',0),(349844,9718,'pt','Gerenciador de sites',0),(349845,9718,'ru','ÐœÐµÐ½ÐµÐ´Ð¶ÐµÑ€ ÑÐ°Ð¹Ñ‚Ð°',0),(349846,9718,'es','Jefe de Sitio',0),(349847,9718,'de','Site-Manager',0),(349848,9718,'en','Site Manager',0),(349849,9719,'is','',0),(349850,9719,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰',0),(349851,9719,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰',0),(349852,9719,'tr','TaÅŸeron SatÄ±nalma sipariÅŸi',0),(349853,9719,'pl','ZleciÄ‡ zamÃ³wienie zakupu',0),(349854,9719,'bg','ÐŸÐ¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½Ð¸Ð¼Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(349855,9719,'ur','Ø³Ø¨Ú©ÙˆÙ†Ù¹Ø±Ø§Ú©Ù¹ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ±',0),(349856,9719,'sr','ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¿Ð¾Ð´Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð°',0),(349857,9719,'vi','Subcontract mua hÃ ng',0),(349858,9719,'af','Sub-Kontrak Aankoopbestelling',0),(349859,9719,'ro','ComandÄƒ de cumpÄƒrare subcontractare',0),(349860,9719,'et','Ostutellimuse alltÃ¶Ã¶vÃµtuleping',0),(349861,9719,'si','Kooperantski nabavni nalog',0),(349862,9719,'ba','Order Pembelian subkontrak',0),(349863,9719,'nl','Uitbestedingsinkooporder',0),(349864,9719,'fi','Alihankkijan ostotilauksen',0),(349865,9719,'no','UnderleverandÃ¸rbestilling',0),(349866,9719,'da','UnderleverandÃ¸rkÃ¸bsordren',0),(349867,9719,'ko','í•˜ì²­ ì£¼ë¬¸ì„œ',0),(349868,9719,'he','×§×¨×™×¢×ª ×”×¨×›×©',0),(349869,9719,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚ Ï…Ï€ÎµÏÎ³Î¿Î»Î±Î²Î¯Î±Ï‚',0),(349870,9719,'zh','åˆ†åŒ…è´­ä¹°è®¢å•\r\n',0),(349871,9719,'sv','InkÃ¶psorder fÃ¶r underkontrakt',0),(349872,9719,'it','Ordine di acquisto di subappalto',0),(349873,9719,'tl','',0),(349874,9719,'th','&#3626;&#3633;&#3597;&#3597;&#3634;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(349875,9719,'hi','Subcontract à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(349876,9719,'ms','Sub-kontrak pesanan belian',0),(349877,9719,'ar','Ø£Ù…Ø± Ø´Ø±Ø§Ø¡ Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù†',0),(349878,9719,'fr','Commande achat de sous-traitance',0),(349879,9719,'jp','ä¸‹è«‹ç™ºæ³¨æ›¸',0),(349880,9719,'pt','Ordem de compra de subcontrato',0),(349881,9719,'ru','Ð”Ð¾Ð³Ð¾Ð²Ð¾Ñ€ ÑÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´Ð° Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(349882,9719,'es','Orden de Compra de Subcontrato',0),(349883,9719,'de','Fremdarbeitsbestellung',0),(349884,9719,'en','Subcontract Purchase Order',0),(349885,9720,'is','',0),(349886,9720,'dr','Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„  Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø± ÙƒØ§Ù„Ø§Ù‡Ø§ Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ùˆ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(349887,9720,'pr','Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„  Ø¨Ø±Ø§ÙŠ Ø³Ø·Ø± ÙƒØ§Ù„Ø§Ù‡Ø§ Ø·Ø¨Ù‚ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ùˆ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ',0),(349888,9720,'tr','GL hesap satÄ±r Ã¶ÄŸeleri iÃ§in standart PO ve SB gÃ¶ster',0),(349889,9720,'pl','PokaÅ¼ konta k/g dla towarÃ³w w wierszu na standardowy pad i SB',0),(349890,9720,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸Ñ‚Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ PO Ð¸ SB',0),(349891,9720,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ù„Ø¦Û’ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù¾Ùˆ Ø§ÙˆØ± SB Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(349892,9720,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ñ€ÐµÐ´Ð° Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð¿Ð¾-Ð° Ð¸ Ð¡Ð‘',0),(349893,9720,'vi','Hiá»ƒn thá»‹ khÃ¡ch sáº¡n GL tÃ i khoáº£n cho cÃ¡c chi tiáº¿t Ä‘Æ¡n hÃ ng trÃªn tiÃªu chuáº©n PO vÃ  SB',0),(349894,9720,'af','Wys AG Rekening vir Lynitems op Standaard AB en *\"SB\"*',0),(349895,9720,'ro','AratÄƒ GL cont pentru elementele rÃ¢nd pe Standard PO È™i SB',0),(349896,9720,'et','NÃ¤ita kirjeid pearaamatukontole Standard PO ja SB',0),(349897,9720,'si','PrikaÅ¾i GL predstavljajo postavke na standardni PO in SB',0),(349898,9720,'ba','Lihat GL Account untuk item baris standar PO dan SB',0),(349899,9720,'nl','Toon GL Account voor regelitems op standaard PO en SB',0),(349900,9720,'fi','NÃ¤ytÃ¤ Kirjanpitotilin pÃ¤Ã¤tilin rivejÃ¤ varten kahden PO ja SB',0),(349901,9720,'no','Vis GL konto for linjeelementer Standard PO og SB',0),(349902,9720,'da','Vis GL konto for linjeelementer pÃ¥ Standard PO og SB',0),(349903,9720,'ko','í‘œì¤€ í¬ ë° SB GL ê³„ì • í–‰ í•­ëª©ì— ëŒ€ í•œ í‘œì‹œ',0),(349904,9720,'he','×ž×¦×™×’×™× GL ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×¤×¨×™×˜×™ ×©×•×¨×” ×¢×œ ×¤×• ×¨×’×™×œ ×•×’× SB',0),(349905,9720,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÎµ Î£Ï„Î¬Î½Ï„Î±Ï PO ÎºÎ±Î¹ SB',0),(349906,9720,'zh','æ˜¾ç¤ºGLå¸æˆ·çš„è®¢å•è¡Œé¡¹ç›®çš„æ ‡å‡†çš„å’ŒSB\r\n',0),(349907,9720,'sv','Visa GL konto fÃ¶r radartiklar pÃ¥ Standard PO och SB',0),(349908,9720,'it','Visualizza il conto di contabilitÃ  generale per gli elementi pubblicitari sulla SB e PO Standard',0),(349909,9720,'tl','',0),(349910,9720,'th','Show GL Account for Line Items on Standard PO and SB',0),(349911,9720,'hi','GL à¤–à¤¾à¤¤à¥‡ à¤²à¤¾à¤‡à¤¨ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¨à¤• PO à¤”à¤° SB à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(349912,9720,'ms','Menunjukkan akaun GL untuk Line item Standard PO dan SB',0),(349913,9720,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø­Ø³Ø§Ø¨ GL Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø³Ø·Ø± ÙÙŠ Ø¨Ùˆ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© ÙˆØ¨ÙŠÙ†Ø§Ù„ÙŠ Ø§Ù„Ø´Ø§Ø±Ù‚Ø©',0),(349914,9720,'fr','Voir lâ€™Ã©tablissement compte GL pour les Ã©lÃ©ments sur SB et PO Standard',0),(349915,9720,'jp','æ¨™æº–çš„ãª PO ã¨ SB ã«å“ç›®ã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(349916,9720,'pt','Mostrar conta GL para itens de linha no SB e PO padrÃ£o',0),(349917,9720,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð° GL Ð´Ð»Ñ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¹ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ñ… PO Ð¸ SB',0),(349918,9720,'es','Muestra Cuenta de LM para Line Items en los OC y SB EstÃ¡ndares',0),(349919,9720,'de','Auf Normalbestellung und SB Fibukonto fÃ¼r Einzelposten anzeigen',0),(349920,9720,'en','Show GL Account for Line Items on Standard PO and SB',0),(349921,9721,'is','',0),(349922,9721,'dr','Ø¢Ø¯Ø±Ø³ Ø´ØºÙ„',0),(349923,9721,'pr','Ø¢Ø¯Ø±Ø³ Ø´ØºÙ„',0),(349924,9721,'tr','Ä°ÅŸ adresi',0),(349925,9721,'pl','Adres pracy',0),(349926,9721,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð°Ð´Ñ€ÐµÑ',0),(349927,9721,'ur','Ø¬Ø§Ø¨ Ø¹Ù†ÙˆØ§Ù†',0),(349928,9721,'sr','ÐÐ´Ñ€ÐµÑÐ° Ð½Ð° Ð¿Ð¾ÑÐ»Ñƒ',0),(349929,9721,'vi','Ä‘á»‹a chá»‰ cÃ´ng viá»‡c',0),(349930,9721,'af','Kontrakwerk Adres',0),(349931,9721,'ro','Job adresa',0),(349932,9721,'et','TÃ¶Ã¶koha aadress',0),(349933,9721,'si','Delo naslov',0),(349934,9721,'ba','Alamat pekerjaan',0),(349935,9721,'nl','Werk adres',0),(349936,9721,'fi','TyÃ¶paikan osoite',0),(349937,9721,'no','Jobb-adresse',0),(349938,9721,'da','Job adresse',0),(349939,9721,'ko','ì§ìž¥ ì£¼ì†Œ',0),(349940,9721,'he','×›×ª×•×‘×ª ×¢×‘×•×“×”',0),(349941,9721,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(349942,9721,'zh','å·¥ä½œåœ°å€\r\n',0),(349943,9721,'sv','Jobb-adress',0),(349944,9721,'it','Indirizzo di lavoro',0),(349945,9721,'tl','',0),(349946,9721,'th','&#3607;&#3637;&#3656;&#3629;&#3618;&#3641;&#3656;&#3591;&#3634;&#3609;',0),(349947,9721,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¤¤à¤¾',0),(349948,9721,'ms','Jawatan alamat',0),(349949,9721,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(349950,9721,'fr','Adresse de travail',0),(349951,9721,'jp','ä»•äº‹ä½æ‰€',0),(349952,9721,'pt','EndereÃ§o de trabalho',0),(349953,9721,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð°Ð´Ñ€ÐµÑÐ°',0),(349954,9721,'es','DirecciÃ³n de ColocaciÃ³n',0),(349955,9721,'de','Job-Adresse',0),(349956,9721,'en','Job Address',0),(349957,9722,'is','',0),(349958,9722,'dr','(Ø¯Ø³Øª Ø¯ÙˆÙ…',0),(349959,9722,'pr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰(Ø¯Ø³Øª Ø¯ÙˆÙ…',0),(349960,9722,'tr','TaÅŸeron',0),(349961,9722,'pl','Podwykonawstwo',0),(349962,9722,'bg','ÐŸÐ¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(349963,9722,'ur','Ø³Ø¨Ú©ÙˆÙ†Ù¹Ø±Ø§Ú©Ù¹',0),(349964,9722,'sr','ÐŸÐ¾Ð´Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð°',0),(349965,9722,'vi','Phá»¥ lá»¥c há»£p Ä‘á»“ng',0),(349966,9722,'af','Sub-kontrakteur',0),(349967,9722,'ro','Subcontractare',0),(349968,9722,'et','Allhankelepingu',0),(349969,9722,'si','Podpogodbe',0),(349970,9722,'ba','Subkontrak',0),(349971,9722,'nl','Onderaanneming',0),(349972,9722,'fi','Alihankinnan',0),(349973,9722,'no','Anskaffe',0),(349974,9722,'da','Underleverance',0),(349975,9722,'ko','í•˜ì²­',0),(349976,9722,'he','×§×¨×™×¢×ª',0),(349977,9722,'el','Î¥Ï€ÎµÏÎ³Î¿Î»Î±Î²Î¯Î±Ï‚',0),(349978,9722,'zh','åˆ†åŒ…åˆåŒ\r\n',0),(349979,9722,'sv','UnderleverantÃ¶rskontraktet',0),(349980,9722,'it','Subappalto',0),(349981,9722,'tl','',0),(349982,9722,'th','&#3626;&#3633;&#3597;&#3597;&#3634;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;',0),(349983,9722,'hi','Subcontract',0),(349984,9722,'ms','Sub-kontrak',0),(349985,9722,'ar','Ø§Ù„ØªØ¹Ø§Ù‚Ø¯ Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù†',0),(349986,9722,'fr','Contrat de sous-traitance',0),(349987,9722,'jp','ä¸‹è«‹',0),(349988,9722,'pt','Subcontrato',0),(349989,9722,'ru','Ð”Ð¾Ð³Ð¾Ð²Ð¾Ñ€ ÑÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´Ð°',0),(349990,9722,'es','Subcontrato',0),(349991,9722,'de','Unterauftrag',0),(349992,9722,'en','Subcontract',0),(349993,9723,'is','',0),(349994,9723,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ  Ø§Ø¬Ø§Ø±Ù‡ ',0),(349995,9723,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ  Ø§Ø¬Ø§Ø±Ù‡ ',0),(349996,9723,'tr','Kira uygulamalarÄ±',0),(349997,9723,'pl','DzierÅ¼awa aplikacji',0),(349998,9723,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(349999,9723,'ur','Ù„ÛŒØ² Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù†Ø²',0),(350000,9723,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(350001,9723,'vi','gáº¯n vÃ o há»£p Ä‘á»“ng thuÃª',0),(350002,9723,'af','Huurkontrak Aansoeke',0),(350003,9723,'ro','Cereri de inchiriere',0),(350004,9723,'et','Liisingu taotlused',0),(350005,9723,'si','Najem aplikacije',0),(350006,9723,'ba','Sewa aplikasi',0),(350007,9723,'nl','Lease aanvragen',0),(350008,9723,'fi','Vuokrasopimuksen sovellukset',0),(350009,9723,'no','Leieavtale programmer',0),(350010,9723,'da','Leasing programmer',0),(350011,9723,'ko','ìž„ëŒ€ ì‘ìš© í”„ë¡œê·¸ëž¨',0),(350012,9723,'he','×©×›×™×¨×•×ª ×™×™×©×•×ž×™×',0),(350013,9723,'el','Î•ÎºÎ¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· ÎµÏ†Î±ÏÎ¼Î¿Î³ÏŽÎ½',0),(350014,9723,'zh','ç§Ÿèµåº”ç”¨\r\n',0),(350015,9723,'sv','Leasing-program',0),(350016,9723,'it','Contratto di locazione applicazioni',0),(350017,9723,'tl','',0),(350018,9723,'th','&#3650;&#3611;&#3619;&#3649;&#3585;&#3619;&#3617;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(350019,9723,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤†à¤µà¥‡à¤¦à¤¨',0),(350020,9723,'ms','Permohonan pajakan',0),(350021,9723,'ar','ØªØ·Ø¨ÙŠÙ‚Ø§Øª Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(350022,9723,'fr','Demandes de location',0),(350023,9723,'jp','ãƒªãƒ¼ã‚¹ç”³ã—è¾¼ã¿',0),(350024,9723,'pt','AplicaÃ§Ãµes de locaÃ§Ã£o',0),(350025,9723,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¹',0),(350026,9723,'es','Aplicaciones de Arrendamientos',0),(350027,9723,'de','Lease-Anwendungen',0),(350028,9723,'en','Lease Applications',0),(350029,9724,'is','',0),(350030,9724,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(350031,9724,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(350032,9724,'tr','Kira uygulama seÃ§in',0),(350033,9724,'pl','Wybierz aplikacjÄ™ dzierÅ¼awy',0),(350034,9724,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ, Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(350035,9724,'ur','Ù„ÛŒØ² Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù† Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(350036,9724,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð° Ð½Ð°Ñ˜Ð°Ð¼',0),(350037,9724,'vi','Chá»n á»©ng dá»¥ng thuÃª',0),(350038,9724,'af','Kies Verhuring Aansoek',0),(350039,9724,'ro','SelectaÅ£i aplicare leasing',0),(350040,9724,'et','Valige liisingutaotlus',0),(350041,9724,'si','Izberite aplikacijo, najem',0),(350042,9724,'ba','Pilih aplikasi sewa',0),(350043,9724,'nl','Select Lease aanvraag',0),(350044,9724,'fi','Valitse vuokra-sovellus',0),(350045,9724,'no','Velg Lease program',0),(350046,9724,'da','VÃ¦lg leasing ansÃ¸gning',0),(350047,9724,'ko','ìž„ëŒ€ ì‘ìš© í”„ë¡œê·¸ëž¨ ì„ íƒ',0),(350048,9724,'he','×‘×—×¨ ×‘×™×™×©×•× ×—×›×™×¨×”',0),(350049,9724,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎµÏ†Î±ÏÎ¼Î¿Î³Î® Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(350050,9724,'zh','é€‰æ‹©ç§Ÿèµç”³è¯·\r\n',0),(350051,9724,'sv','VÃ¤lj leasing program',0),(350052,9724,'it','Selezionare applicazione del contratto di locazione',0),(350053,9724,'tl','',0),(350054,9724,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3650;&#3611;&#3619;&#3649;&#3585;&#3619;&#3617;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(350055,9724,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤— à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(350056,9724,'ms','Pilih permohonan pajakan',0),(350057,9724,'ar','Ø­Ø¯Ø¯ ØªØ·Ø¨ÙŠÙ‚ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(350058,9724,'fr','SÃ©lectionnez lâ€™Application bail',0),(350059,9724,'jp','ãƒªãƒ¼ã‚¹ ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(350060,9724,'pt','Selecione aplicativo de locaÃ§Ã£o',0),(350061,9724,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ, ÐÑ€ÐµÐ½Ð´Ð°',0),(350062,9724,'es','Selecciona Solicitud de Arrendamiento',0),(350063,9724,'de','WÃ¤hlen Sie Mietvertrag Anwendung',0),(350064,9724,'en','Select Lease Application',0),(350065,9725,'is','',0),(350066,9725,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¬Ø§Ø±Ù‡ ',0),(350067,9725,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¬Ø§Ø±Ù‡ ',0),(350068,9725,'tr','Kira Ekle',0),(350069,9725,'pl','Dodawanie dzierÅ¼awy',0),(350070,9725,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(350071,9725,'ur','Ù„ÛŒØ² Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(350072,9725,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð°ÐºÑƒÐ¿',0),(350073,9725,'vi','ThÃªm cho thuÃª',0),(350074,9725,'af','Huurkontrak Byvoeg',0),(350075,9725,'ro','Adauga leasing',0),(350076,9725,'et','ÃœÃ¼rilepingu lisa',0),(350077,9725,'si','Dodaj najema',0),(350078,9725,'ba','Tambahkan sewa',0),(350079,9725,'nl','Toevoegen van Lease',0),(350080,9725,'fi','LisÃ¤Ã¤ vuokrasopimuksen',0),(350081,9725,'no','Legge til leie',0),(350082,9725,'da','TilfÃ¸je Lease',0),(350083,9725,'ko','ì¶”ê°€ ìž„ëŒ€',0),(350084,9725,'he','×”×•×¡×£ ×©×›×™×¨×•×ª',0),(350085,9725,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(350086,9725,'zh','å¢žåŠ ç§Ÿèµ\r\n',0),(350087,9725,'sv','LÃ¤gg till Lease',0),(350088,9725,'it','Aggiungere il contratto di locazione',0),(350089,9725,'tl','',0),(350090,9725,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(350091,9725,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(350092,9725,'ms','Tambah pajakan',0),(350093,9725,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(350094,9725,'fr','Ajouter Bail',0),(350095,9725,'jp','ãƒªãƒ¼ã‚¹ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(350096,9725,'pt','Adicionar locaÃ§Ã£o',0),(350097,9725,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÑ€ÐµÐ½Ð´Ð°',0),(350098,9725,'es','Agregar Arrendamiento',0),(350099,9725,'de','FÃ¼gen Sie Leasing',0),(350100,9725,'en','Add Lease',0),(350101,9726,'is','',0),(350102,9726,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(350103,9726,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(350104,9726,'tr','Depozito miktarÄ±',0),(350105,9726,'pl','Kwota depozytu',0),(350106,9726,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(350107,9726,'ur','Ø¬Ù…Ø¹ Ø±Ù‚Ù…',0),(350108,9726,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(350109,9726,'vi','Sá»‘ tiá»n Ä‘áº·t cá»c',0),(350110,9726,'af','Deposito Bedrag',0),(350111,9726,'ro','Suma depunerii',0),(350112,9726,'et','Hoiuse summa',0),(350113,9726,'si','Znesek pologa',0),(350114,9726,'ba','Jumlah deposit',0),(350115,9726,'nl','Stortingsbedrag',0),(350116,9726,'fi','Talletussumma',0),(350117,9726,'no','InnbetalingsbelÃ¸pet',0),(350118,9726,'da','IndbetalingsbelÃ¸bet',0),(350119,9726,'ko','ìž… ê¸ˆì•¡',0),(350120,9726,'he','×¡×›×•× ×”×¤×™×§×“×•×Ÿ',0),(350121,9726,'el','Î Î¿ÏƒÏŒ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(350122,9726,'zh','å­˜æ¬¾é‡‘é¢\r\n',0),(350123,9726,'sv','InsÃ¤ttningsbelopp',0),(350124,9726,'it','Importo del deposito',0),(350125,9726,'tl','',0),(350126,9726,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;',0),(350127,9726,'hi','à¤œà¤®à¤¾ à¤°à¤¾à¤¶à¤¿',0),(350128,9726,'ms','Jumlah Deposit',0),(350129,9726,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(350130,9726,'fr','Montant de la caution',0),(350131,9726,'jp','å…¥é‡‘é¡',0),(350132,9726,'pt','Valor do depÃ³sito',0),(350133,9726,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(350134,9726,'es','Monto de DepÃ³sito',0),(350135,9726,'de','Einzahlungsbetrag',0),(350136,9726,'en','Deposit Amount',0),(350137,9727,'is','',0),(350138,9727,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø¬Ø§Ø±Ù‡ ',0),(350139,9727,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø¬Ø§Ø±Ù‡ ',0),(350140,9727,'tr','Kira DÃ¼zenle',0),(350141,9727,'pl','EdycjÄ™ leasingu',0),(350142,9727,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(350143,9727,'ur','Ù„ÛŒØ² Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(350144,9727,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð½Ð°Ñ˜Ð°Ð¼',0),(350145,9727,'vi','Sá»­a há»£p Ä‘á»“ng thuÃª',0),(350146,9727,'af','Redigeer Huurooreenkoms',0),(350147,9727,'ro','Editare leasing',0),(350148,9727,'et','ÃœÃ¼rilepingu muutmine',0),(350149,9727,'si','Urejanje zakupa',0),(350150,9727,'ba','Mengedit sewa',0),(350151,9727,'nl','Bewerken van Lease',0),(350152,9727,'fi','Muokkaa vuokrasopimuksen',0),(350153,9727,'no','Redigere Lease',0),(350154,9727,'da','Redigere Lease',0),(350155,9727,'ko','ìž„ëŒ€ë¥¼ íŽ¸ì§‘',0),(350156,9727,'he','×¢×¨×™×›×ª ×—×•×–×” ×©×›×™×¨×•×ª',0),(350157,9727,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(350158,9727,'zh','ç¼–è¾‘ç§Ÿèµ\r\n',0),(350159,9727,'sv','Redigera Lease',0),(350160,9727,'it','Modificare il contratto di locazione',0),(350161,9727,'tl','',0),(350162,9727,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(350163,9727,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(350164,9727,'ms','Edit pajakan',0),(350165,9727,'ar','ØªØ­Ø±ÙŠØ± Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(350166,9727,'fr','Modifier le bail',0),(350167,9727,'jp','ãƒªãƒ¼ã‚¹ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(350168,9727,'pt','Editar a locaÃ§Ã£o',0),(350169,9727,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð°Ñ€ÐµÐ½Ð´Ñƒ',0),(350170,9727,'es','Editar Arrendamiento',0),(350171,9727,'de','Mietvertrag zu bearbeiten',0),(350172,9727,'en','Edit Lease',0),(350173,9728,'is','',0),(350174,9728,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù…Ù‚Ø¯Ø§Ø± Ø³Ù¾Ø±Ø¯Ù‡ Ø±Ø§ Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯ ',0),(350175,9728,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù…Ù‚Ø¯Ø§Ø± Ø³Ù¾Ø±Ø¯Ù‡ Ø±Ø§ Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯ ',0),(350176,9728,'tr','LÃ¼tfen bir depozito miktarÄ± iÃ§erir.',0),(350177,9728,'pl','ProszÄ™ podaÄ‡ kwotÄ™ depozytu.',0),(350178,9728,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð° ÑÑƒÐ¼Ð°Ñ‚Ð° Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°.',0),(350179,9728,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© ÚˆÙ¾Ø§Ø²Ù¹ Ú©ÛŒ Ø±Ù‚Ù… Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”',0),(350180,9728,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð½Ð° Ð¸Ð·Ð½Ð¾Ñ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°.',0),(350181,9728,'vi','Xin bao gá»“m sá»‘ tiá»n gá»­i',0),(350182,9728,'af','Sluit asb. \'n Depositobedrag in',0),(350183,9728,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i o sumÄƒ de depozit.',0),(350184,9728,'et','Palun lisage hoiuse summa.',0),(350185,9728,'si','Prosimo, da vkljuÄite depozit znesek.',0),(350186,9728,'ba','Sertakan jumlah Deposit.',0),(350187,9728,'nl','Geef een aanbetalingsbedrag op.',0),(350188,9728,'fi','Kirjoita talletettava summa.',0),(350189,9728,'no','Vennligst Inkluder en innskuddsbelÃ¸p.',0),(350190,9728,'da','VedlÃ¦g en indbetalingsbelÃ¸bet.',0),(350191,9728,'ko','ìž… ê¸ˆì•¡ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤.',0),(350192,9728,'he','× × ×œ×›×œ×•×œ ××ª ×¡×›×•× ×”×”×¤×§×“×”.',0),(350193,9728,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î± Ï€Î¿ÏƒÏŒ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚.',0),(350194,9728,'zh','è¯·åŒ…æ‹¬å­˜æ¬¾æ•°ç›®ã€‚\r\n',0),(350195,9728,'sv','VÃ¤nligen inkludera ett insÃ¤ttningsbelopp.',0),(350196,9728,'it','Si prega di includere una quantitÃ  di deposito.',0),(350197,9728,'tl','',0),(350198,9728,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3613;&#3634;&#3585;',0),(350199,9728,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤œà¤®à¤¾ à¤°à¤¾à¤¶à¤¿ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚à¥¤',0),(350200,9728,'ms','Sila sertakan Jumlah Deposit.',0),(350201,9728,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ´ØªÙ…Ù„ Ø¹Ù„Ù‰ \"Ù…Ø¨Ù„Øº Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹\".',0),(350202,9728,'fr','Veuillez inclure un montant de dÃ©pÃ´t.',0),(350203,9728,'jp','å…¥é‡‘é¡ã‚’è¨˜è¼‰ã—ã¦ãã ã•ã„ã€‚',0),(350204,9728,'pt','Por favor, inclua uma quantidade de depÃ³sito.',0),(350205,9728,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ ÑÑƒÐ¼Ð¼Ñƒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°.',0),(350206,9728,'es','Por Favor Incluye un Monto de DepÃ³sito',0),(350207,9728,'de','Bitte geben Sie eine Einzahlung.',0),(350208,9728,'en','Please include a Deposit Amount.',0),(350209,9729,'is','',0),(350210,9729,'dr','... Ø±Ø§ Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯  Pet Deposit.',0),(350211,9729,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø³Ù¾Ø±Ø¯Ù‡ ... Ø±Ø§ Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯  Pet Deposit.',0),(350212,9729,'tr','LÃ¼tfen evde beslenen hayvan KasasÄ± iÃ§erir.',0),(350213,9729,'pl','ProszÄ™ podaÄ‡ wpÅ‚aty zwierzÄ™tom.',0),(350214,9729,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð³Ð°Ð»ÐµÐ½Ð¸Ðº Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚.',0),(350215,9729,'ur','Ø§ÛŒÚ© Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± Ø¬Ù…Ø¹ Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”',0),(350216,9729,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ™ÑƒÐ±Ð¸Ð¼Ð°Ñ†.',0),(350217,9729,'vi','Xin bao gá»“m khoáº£n tiá»n gá»­i Æ°u tiÃªn',0),(350218,9729,'af','Sluit asseblief \'n troeteldier deposito.',0),(350219,9729,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i un depozit de Pet.',0),(350220,9729,'et','Palun lisage lemmiklooma deposiit.',0),(350221,9729,'si','Prosimo, da vkljuÄite Pet vlog.',0),(350222,9729,'ba','Sertakan Pet Deposit.',0),(350223,9729,'nl','Gelieve te omvatten de storting van een huisdier.',0),(350224,9729,'fi','LiitÃ¤ mukaan lemmikkielÃ¤inten talletus.',0),(350225,9729,'no','Ta med en Pet innskudd.',0),(350226,9729,'da','VedlÃ¦g en Pet indbetaling.',0),(350227,9729,'ko','ì• ì™„ ë™ë¬¼ ë³´ì¦ê¸ˆì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤.',0),(350228,9729,'he','× × ×œ×›×œ×•×œ ×¤×™×§×“×•×Ÿ ×—×™×™×ª ×”×ž×—×ž×“.',0),(350229,9729,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î¼Î¹Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ Î¶ÏŽÎ¿.',0),(350230,9729,'zh','è¯·åŒ…æ‹¬ä¸€ä¸ªå® ç‰©å­˜æ¬¾ã€‚\r\n',0),(350231,9729,'sv','VÃ¤nligen inkludera en Pet insÃ¤ttning.',0),(350232,9729,'it','Si prega di includere un deposito di Pet.',0),(350233,9729,'tl','',0),(350234,9729,'th','Please include a Pet Deposit.',0),(350235,9729,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤ªà¤¾à¤²à¤¤à¥‚ à¤œà¤®à¤¾ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚à¥¤',0),(350236,9729,'ms','Sila sertakan Deposit haiwan kesayangan.',0),(350237,9729,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† \"ÙˆØ¯ÙŠØ¹Ø© Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ©\".',0),(350238,9729,'fr','Veuillez inclure un dÃ©pÃ´t de Pet.',0),(350239,9729,'jp','ãƒšãƒƒãƒˆ ãƒ‡ãƒã‚¸ãƒƒãƒˆã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(350240,9729,'pt','Por favor inclua um depÃ³sito de animal de estimaÃ§Ã£o.',0),(350241,9729,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Pet Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°.',0),(350242,9729,'es','Por Favor Incluye un DepÃ³sito para la Mascota',0),(350243,9729,'de','Bitte geben Sie eine Pet-Einzahlung.',0),(350244,9729,'en','Please include a Pet Deposit.',0),(350245,9730,'is','',0),(350246,9730,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¬Ø§Ø±Ù‡ Ø±Ø§ Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯ ',0),(350247,9730,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¬Ø§Ø±Ù‡ Ø±Ø§ Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯ ',0),(350248,9730,'tr','LÃ¼tfen bir kira tutarÄ± dahil.',0),(350249,9730,'pl','ProszÄ™ podaÄ‡ kwotÄ™ czynszu.',0),(350250,9730,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ ÑÑƒÐ¼Ð°Ñ‚Ð° Ð·Ð° Ð½Ð°ÐµÐ¼Ð°.',0),(350251,9730,'ur','Ø§ÛŒÚ© Ú©Ø±Ø§ÛŒÛ Ú©ÛŒ Ø±Ù‚Ù… Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”',0),(350252,9730,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¸Ð·Ð½Ð¾Ñ Ñƒ Ð½Ð°Ñ˜Ð°Ð¼.',0),(350253,9730,'vi','Xin bao gá»“m khoáº£n tiá»n thuÃª',0),(350254,9730,'af','Sluit asb. \'n Huurbedrag in',0),(350255,9730,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i o cantitate de chirie.',0),(350256,9730,'et','Palun lisage Ã¼Ã¼ri summa.',0),(350257,9730,'si','Prosimo, da vkljuÄite znesek najemnine.',0),(350258,9730,'ba','Sertakan jumlah sewa.',0),(350259,9730,'nl','Gelieve te omvatten een bedrag van de huur.',0),(350260,9730,'fi','Ilmoita vuokra summa.',0),(350261,9730,'no','Ta med et leie belÃ¸p.',0),(350262,9730,'da','VedlÃ¦g en leje belÃ¸b.',0),(350263,9730,'ko','ìž„ëŒ€ ê¸ˆì•¡ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤.',0),(350264,9730,'he','× × ×œ×›×œ×•×œ ××ª ×¡×›×•× ×©×›×¨ ×”×“×™×¨×”.',0),(350265,9730,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î± ÎµÎ½Î¿Î¯ÎºÎ¹Î¿.',0),(350266,9730,'zh','å…¶ä¸­åŒ…æ‹¬äº†ç§Ÿé‡‘æ•°é¢\r\n',0),(350267,9730,'sv','VÃ¤nligen inkludera en hyresbeloppet.',0),(350268,9730,'it','Si prega di includere un importo di affitto.',0),(350269,9730,'tl','',0),(350270,9730,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3592;&#3635;&#3609;&#3623;&#3609;&#3588;&#3656;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(350271,9730,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤•à¤¿à¤°à¤¾à¤¯à¤¾ à¤°à¤¾à¤¶à¤¿ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚à¥¤',0),(350272,9730,'ms','Sila sertakan jumlah sewa yang.',0),(350273,9730,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ´ØªÙ…Ù„ Ø¹Ù„Ù‰ \"Ù…Ø¨Ù„Øº Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±\".',0),(350274,9730,'fr','Veuillez inclure un montant du loyer.',0),(350275,9730,'jp','è³ƒæ–™é¡ã‚’è¨˜è¼‰ã—ã¦ãã ã•ã„ã€‚',0),(350276,9730,'pt','Por favor, inclua uma quantidade de aluguel.',0),(350277,9730,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ ÑÑƒÐ¼Ð¼Ñƒ Ð°Ñ€ÐµÐ½Ð´Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹.',0),(350278,9730,'es','Por Favor Incluye un Monto de Renta',0),(350279,9730,'de','Bitte geben Sie einen Betrag der Miete.',0),(350280,9730,'en','Please include a Rent Amount.',0),(350281,9731,'is','',0),(350282,9731,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø°Ø®ÙŠØ±Ù‡ Ø³Ø§Ø²ÙŠ Ø±Ø§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯ ',0),(350283,9731,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø°Ø®ÙŠØ±Ù‡ Ø³Ø§Ø²ÙŠ Ø±Ø§ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯ ',0),(350284,9731,'tr','LÃ¼tfen rezervasyon Ã¼creti dahil.',0),(350285,9731,'pl','ProszÄ™ doÅ‚Ä…czyÄ‡ opÅ‚atÄ™ za rezerwacjÄ™.',0),(350286,9731,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð°Ñ‚Ð° Ñ‚Ð°ÐºÑÐ°.',0),(350287,9731,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø¨Ú©Ù†Ú¯ ÙÛŒØ³ Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”',0),(350288,9731,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð½Ð°ÐºÐ½Ð°Ð´Ñƒ Ð·Ð° Ñ€ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ˜Ñƒ.',0),(350289,9731,'vi','Xin bao gá»“m phÃ­ giá»¯ chá»—',0),(350290,9731,'af','Sluit asb. \'n Besprekingsfooi in.',0),(350291,9731,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i o taxÄƒ de rezervare.',0),(350292,9731,'et','Palun lisage on broneerimistasu.',0),(350293,9731,'si','Prosimo, da vkljuÄite znesek rezervacije.',0),(350294,9731,'ba','Sertakan biaya pemesanan.',0),(350295,9731,'nl','Gelieve te omvatten een reserveringskosten.',0),(350296,9731,'fi','LiitÃ¤ mukaan varausmaksun.',0),(350297,9731,'no','Ta med et reservasjonsgebyr.',0),(350298,9731,'da','VedlÃ¦g et reservationsgebyr.',0),(350299,9731,'ko','ì˜ˆì•½ ìˆ˜ìˆ˜ë£Œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤.',0),(350300,9731,'he','× × ×œ×›×œ×•×œ ×¢×ž×œ×ª ×”×–×ž× ×”.',0),(350301,9731,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î± Ï„Î­Î»Î¿Ï‚ ÎºÏÎ¬Ï„Î·ÏƒÎ·Ï‚.',0),(350302,9731,'zh','è¯·æä¾›é¢„è®¢è´¹ç”¨ã€‚\r\n',0),(350303,9731,'sv','VÃ¤nligen inkludera en bokningsavgift.',0),(350304,9731,'it','Si prega di includere una tassa di prenotazione.',0),(350305,9731,'tl','',0),(350306,9731,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3585;&#3634;&#3619;&#3592;&#3629;&#3591;',0),(350307,9731,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤†à¤°à¤•à¥à¤·à¤£ à¤¶à¥à¤²à¥à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚à¥¤',0),(350308,9731,'ms','Sila sertakan bayaran tempahan.',0),(350309,9731,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ \"Ø±Ø³ÙˆÙ… Ø§Ù„Ø­Ø¬Ø²\".',0),(350310,9731,'fr','Veuillez inclure un frais de rÃ©servation.',0),(350311,9731,'jp','ã”äºˆç´„æ–™é‡‘ãŒå«ã¾ã‚Œã¾ã™ã€‚',0),(350312,9731,'pt','Por favor, inclua uma taxa de reserva.',0),(350313,9731,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‚Ñƒ Ð·Ð° Ð±Ñ€Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ.',0),(350314,9731,'es','Por Favor Incluye una Cuota de ReservaciÃ³n',0),(350315,9731,'de','Bitte geben Sie eine ReservierungsgebÃ¼hr.',0),(350316,9731,'en','Please include a Reservation Fee.',0),(350317,9732,'is','',0),(350318,9732,'dr','- Ø§ØµÙ„Ø§Ø­   Ùˆ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ ',0),(350319,9732,'pr','Ø§ÙØ²ÙˆØ¯Ù†  - ÙˆÙŠØ±Ø§ÙŠØ´  Ùˆ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ ',0),(350320,9732,'tr','Eklemek, dÃ¼zenlemek ve kiralarÄ± gÃ¶rÃ¼ntÃ¼lemek.',0),(350321,9732,'pl','Dodawanie, edytowanie i wyÅ›wietlanie dzierÅ¼aw.',0),(350322,9732,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ, Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¸ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³.',0),(350323,9732,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚºØŒ ØªØ¯ÙˆÛŒÙ† Ø§ÙˆØ± Ù„ÙÛŒØ²Ø² Ø¯ÛŒÚ©Ú¾ÛŒÚº Û”',0),(350324,9732,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ , ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸.',0),(350325,9732,'vi','thÃªm,sáº¯p xáº¿p, sá»­a há»£p Ä‘á»“ng cho thuÃª ',0),(350326,9732,'af','Huurkontrakte Byvoeg, redigeer en besigtig.',0),(350327,9732,'ro','AdÄƒuga, edita ÅŸi Vezi contracte de leasing.',0),(350328,9732,'et','Lisada, redigeerida ja vaadata rent.',0),(350329,9732,'si','Dodajte, uredite in si ogledate najemi.',0),(350330,9732,'ba','Menambahkan, mengedit dan melihat sewa.',0),(350331,9732,'nl','Toevoegen, bewerken en weergeven van lease-overeenkomsten.',0),(350332,9732,'fi','LisÃ¤Ã¤, Muokkaa ja tarkastele vuokrasopimukset.',0),(350333,9732,'no','Legg til, Rediger og Vis leieavtaler.',0),(350334,9732,'da','TilfÃ¸je, redigere og fÃ¥ vist lejemÃ¥l.',0),(350335,9732,'ko','ì¶”ê°€, íŽ¸ì§‘ í•˜ ê³  ìž„ëŒ€ë¥¼ ë³¼.',0),(350336,9732,'he','×œ×”×•×¡×™×£, ×œ×¢×¨×•×š ×•×œ×”×¦×™×’ ×—×›×™×¨×”.',0),(350337,9732,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ, Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ ÎºÎ±Î¹ Î½Î± Ï€ÏÎ¿Î²Î¬Î»ÎµÏ„Îµ Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚.',0),(350338,9732,'zh','æ·»åŠ ï¼Œç¼–è¾‘å’ŒæŸ¥çœ‹ç§Ÿèµã€‚\r\n',0),(350339,9732,'sv','LÃ¤gga till, redigera och Visa leasingavtal.',0),(350340,9732,'it','Aggiungere, modificare e visualizzare i contratti di locazione.',0),(350341,9732,'tl','',0),(350342,9732,'th','&#3648;&#3614;&#3636;&#3656;&#3617;,&#3649;&#3585;&#3657;&#3652;&#3586;,&#3604;&#3641; &#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(350343,9732,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚, à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡à¥¤',0),(350344,9732,'ms','Tambah, edit dan lihat pajakan.',0),(350345,9732,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØªØ­Ø±ÙŠØ± ÙˆØ¹Ø±Ø¶ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±Ø§Øª.',0),(350346,9732,'fr','Ajouter, modifier et afficher des baux.',0),(350347,9732,'jp','è¿½åŠ ã€ç·¨é›†ãŠã‚ˆã³è¡¨ç¤ºã®ãƒªãƒ¼ã‚¹ã€‚',0),(350348,9732,'pt','Adicionar, editar e visualizar as locaÃ§Ãµes.',0),(350349,9732,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ, Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¸ ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð¾Ð² Ð¾Ð± Ð°Ñ€ÐµÐ½Ð´Ðµ.',0),(350350,9732,'es','Agregar, editar y visionar Arrendamientos',0),(350351,9732,'de','FÃ¼gen Sie hinzu, bearbeiten Sie und zeigen Sie der MietvertrÃ¤ge an.',0),(350352,9732,'en','Add, edit and view Leases.',0),(350353,9733,'is','',0),(350354,9733,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(350355,9733,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(350356,9733,'tr','Kira baÅŸarÄ±yla eklendi',0),(350357,9733,'pl','DzierÅ¼awy dodany pomyÅ›lnie',0),(350358,9733,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(350359,9733,'ur','Ù„ÛŒØ² Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(350360,9733,'sr','Ð—Ð°ÐºÑƒÐ¿ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(350361,9733,'vi','Ä‘Ã£ thÃªm há»£p Ä‘á»“ng thuÃª thÃ nh cÃ´ng',0),(350362,9733,'af','Huurkontrak Suksesvol Bygevoeg',0),(350363,9733,'ro','Leasing adÄƒugat cu succes',0),(350364,9733,'et','ÃœÃ¼rileping on edukalt',0),(350365,9733,'si','Najem dodani',0),(350366,9733,'ba','Sewa ditambahkan berhasil',0),(350367,9733,'nl','Lease toegevoegd',0),(350368,9733,'fi','Vuokrasopimuksen lisÃ¤Ã¤minen onnistui',0),(350369,9733,'no','Leieavtalen lagt',0),(350370,9733,'da','Lease tilfÃ¸jet',0),(350371,9733,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ìž„ëŒ€',0),(350372,9733,'he','×—×›×™×¨×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(350373,9733,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(350374,9733,'zh','ç§Ÿèµæ·»åŠ æˆåŠŸ\r\n',0),(350375,9733,'sv','Hyresavtalet som lagts',0),(350376,9733,'it','Contratto di locazione aggiunto con successo',0),(350377,9733,'tl','',0),(350378,9733,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(350379,9733,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤ªà¤Ÿà¥à¤Ÿà¤¾',0),(350380,9733,'ms','Pajakan yang berjaya menambah',0),(350381,9733,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(350382,9733,'fr','Bail a ajoutÃ© avec succÃ¨s',0),(350383,9733,'jp','ãƒªãƒ¼ã‚¹ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(350384,9733,'pt','Aluguel adicionado com sucesso',0),(350385,9733,'ru','ÐÑ€ÐµÐ½Ð´Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(350386,9733,'es','Arrendamiento Agregado Exitosamente',0),(350387,9733,'de','Lease erfolgreich hinzugefÃ¼gt',0),(350388,9733,'en','Lease Added Successfully',0),(350389,9734,'is','',0),(350390,9734,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡ ',0),(350391,9734,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡ ',0),(350392,9734,'tr','Kira baÅŸlangÄ±Ã§ tarihi',0),(350393,9734,'pl','Data rozpoczÄ™cia najmu',0),(350394,9734,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(350395,9734,'ur','Ù„ÛŒØ² Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(350396,9734,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð·Ð°ÐºÑƒÐ¿Ð°',0),(350397,9734,'vi','ngÃ y báº¥t Ä‘áº§u thuÃª',0),(350398,9734,'af','Huurkontrak Begindatum',0),(350399,9734,'ro','Data de inceput de leasing',0),(350400,9734,'et','Rendi alguskuupÃ¤ev',0),(350401,9734,'si','Najem zaÄetni datum',0),(350402,9734,'ba','Sewa dimulai tanggal',0),(350403,9734,'nl','Begindatum van de lease-overeenkomst',0),(350404,9734,'fi','Vuokrasopimuksen aloituspÃ¤ivÃ¤',0),(350405,9734,'no','Leieavtalen Start dato',0),(350406,9734,'da','Leje Start dato',0),(350407,9734,'ko','ìž„ëŒ€ ì‹œìž‘ ë‚ ì§œ',0),(350408,9734,'he','×ª××¨×™×š ×‘×’×™×Ÿ ×—×›×™×¨×”',0),(350409,9734,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(350410,9734,'zh','ç§Ÿçº¦å¼€å§‹æ—¥æœŸ\r\n',0),(350411,9734,'sv','Lease Begin datum',0),(350412,9734,'it','Data di inizio del contratto di locazione',0),(350413,9734,'tl','',0),(350414,9734,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3636;&#3656;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(350415,9734,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(350416,9734,'ms','Tarikh mulakan pajakan',0),(350417,9734,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(350418,9734,'fr','Date de dÃ©but de bail',0),(350419,9734,'jp','ãƒªãƒ¼ã‚¹é–‹å§‹æ—¥',0),(350420,9734,'pt','Data de inÃ­cio de locaÃ§Ã£o',0),(350421,9734,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(350422,9734,'es','Fecha de Comienza de Arrendamiento',0),(350423,9734,'de','Lease-Startdatum',0),(350424,9734,'en','Lease Begin Date',0),(350425,9735,'is','',0),(350426,9735,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(350427,9735,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(350428,9735,'tr','DELETE baÅŸarÄ±yla kira',0),(350429,9735,'pl','DzierÅ¼awy UsuÅ„ pomyÅ›lnie',0),(350430,9735,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(350431,9735,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ù„ÛŒØ² Ù¾Ø±',0),(350432,9735,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð·Ð°ÐºÑƒÐ¿ Ð”ÐµÐ»ÐµÑ‚Ðµ',0),(350433,9735,'vi','xÃ³a há»£p Ä‘á»“ng thuÃª thÃ nh cÃ´ng',0),(350434,9735,'af','Huurkontrak Suksesvol Geskrap',0),(350435,9735,'ro','Leasing ÅŸterge cu succes',0),(350436,9735,'et','Liisi Kustuta edukalt',0),(350437,9735,'si','Zakup brisanje uspeÅ¡no',0),(350438,9735,'ba','Sewa Hapus berhasil',0),(350439,9735,'nl','Lease verwijderen met succes',0),(350440,9735,'fi','Vuokrata poistaminen onnistui',0),(350441,9735,'no','Lease Slett vellykket',0),(350442,9735,'da','Lease slet med succes',0),(350443,9735,'ko','ì‚­ì œë¥¼ ì„±ê³µì ìœ¼ë¡œ ìž„ëŒ€',0),(350444,9735,'he','×©×›×™×¨×•×ª ×ž×—×§ ×‘×”×¦×œ×—×”',0),(350445,9735,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î´Î¹Î±Î³ÏÎ±Ï†Î® Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(350446,9735,'zh','ç§Ÿèµåˆ é™¤æˆåŠŸ\r\n',0),(350447,9735,'sv','Leasa Delete framgÃ¥ngsrikt',0),(350448,9735,'it','Leasing Elimina con successo',0),(350449,9735,'tl','',0),(350450,9735,'th','&#3621;&#3610;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(350451,9735,'hi','Delete à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(350452,9735,'ms','Pajakan Delete berjaya',0),(350453,9735,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(350454,9735,'fr','Location Delete avec succÃ¨s',0),(350455,9735,'jp','æ­£å¸¸ã«å‰Šé™¤ã‚’ãƒªãƒ¼ã‚¹ã—ã¾ã™ã€‚',0),(350456,9735,'pt','LocaÃ§Ã£o Delete com sucesso',0),(350457,9735,'ru','ÐÑ€ÐµÐ½Ð´Ð° ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(350458,9735,'es','Arrendamiento Eliminado Exitosamente',0),(350459,9735,'de','Leasen Sie erfolgreich lÃ¶schen',0),(350460,9735,'en','Lease Delete Successfully',0),(350461,9736,'is','',0),(350462,9736,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø¬Ø§Ø±Ù‡ ',0),(350463,9736,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø¬Ø§Ø±Ù‡ ',0),(350464,9736,'tr','Kira bitiÅŸ tarihi',0),(350465,9736,'pl','Data zakoÅ„czenia leasingu',0),(350466,9736,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(350467,9736,'ur','Ù„ÛŒØ² Ú©Û’ Ø§Ø®ØªØªØ§Ù… Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(350468,9736,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð·Ð° Ð½Ð°Ñ˜Ð°Ð¼',0),(350469,9736,'vi','ngÃ y thuÃª cuá»‘i cÃ¹ng',0),(350470,9736,'af','Huurkontrak Enddatum',0),(350471,9736,'ro','Data de terminare leasing',0),(350472,9736,'et','Rendi lÃµppkuupÃ¤ev',0),(350473,9736,'si','Najem konÄni datum',0),(350474,9736,'ba','Tanggal akhir sewa',0),(350475,9736,'nl','Einddatum van de huurovereenkomst',0),(350476,9736,'fi','Vuokrasopimuksen pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(350477,9736,'no','Leieavtalen sluttdatoen',0),(350478,9736,'da','Lease slutdato',0),(350479,9736,'ko','ìž„ëŒ€ ì¢…ë£Œ ë‚ ì§œ',0),(350480,9736,'he','×ª××¨×™×š ×¡×™×•× ×©×›×™×¨×•×ª',0),(350481,9736,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(350482,9736,'zh','ç§Ÿèµç»“æŸæ—¥æœŸ\r\n',0),(350483,9736,'sv','Lease slutdatum',0),(350484,9736,'it','Data di fine del contratto di locazione',0),(350485,9736,'tl','',0),(350486,9736,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(350487,9736,'hi','à¤²à¥€à¤œ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(350488,9736,'ms','Tarikh tamat pajakan',0),(350489,9736,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(350490,9736,'fr','Date de fin de bail',0),(350491,9736,'jp','ãƒªãƒ¼ã‚¹çµ‚äº†æ—¥',0),(350492,9736,'pt','Data de tÃ©rmino de locaÃ§Ã£o',0),(350493,9736,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(350494,9736,'es','Fecha de TerminaciÃ³n del Arrendamiento',0),(350495,9736,'de','Lease-Enddatum',0),(350496,9736,'en','Lease End Date',0),(350497,9737,'is','',0),(350498,9737,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(350499,9737,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(350500,9737,'tr','Kira bilgi yardÄ±m',0),(350501,9737,'pl','DzierÅ¼awy informacje pomocy',0),(350502,9737,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(350503,9737,'ur','Ù„ÛŒØ² Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø¯Ø¯',0),(350504,9737,'sr','ÐŸÐ¾Ð¼Ð¾Ñ› Ð·Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð·Ð°ÐºÑƒÐ¿Ñƒ',0),(350505,9737,'vi','thÃ´ng tin trá»£ giÃºp khi thuÃª',0),(350506,9737,'af','Huurkontrak Inligtingshulp',0),(350507,9737,'ro','Ajutor de informaÅ£ii leasing',0),(350508,9737,'et','Liisingu info abi',0),(350509,9737,'si','Najem informacije pomoÄ',0),(350510,9737,'ba','Sewa informasi bantuan',0),(350511,9737,'nl','Lease informatiehulp',0),(350512,9737,'fi','Vuokrasopimus tiedot ohje',0),(350513,9737,'no','Leieavtalen informasjon hjelp',0),(350514,9737,'da','LejemÃ¥let Information hjÃ¦lp',0),(350515,9737,'ko','ìž„ëŒ€ ì •ë³´ ë„ì›€ë§',0),(350516,9737,'he','×©×›×™×¨×•×ª ×ž×™×“×¢ ×¢×–×¨×”',0),(350517,9737,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î²Î¿Î®Î¸ÎµÎ¹Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½',0),(350518,9737,'zh','ç§Ÿèµä¿¡æ¯å¸®åŠ©\r\n',0),(350519,9737,'sv','Lease Information hjÃ¤lp',0),(350520,9737,'it','Contratto di locazione informazioni aiuto',0),(350521,9737,'tl','',0),(350522,9737,'th','&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(350523,9737,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¤¦à¤¦',0),(350524,9737,'ms','Bantuan maklumat pajakan',0),(350525,9737,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(350526,9737,'fr','Location Information aide',0),(350527,9737,'jp','ãƒªãƒ¼ã‚¹æƒ…å ±ãƒ˜ãƒ«ãƒ—',0),(350528,9737,'pt','Ajuda de informaÃ§Ãµes de locaÃ§Ã£o',0),(350529,9737,'ru','ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ð± Ð°Ñ€ÐµÐ½Ð´Ðµ',0),(350530,9737,'es','Ayuda de InformaciÃ³n del Arrendamiento',0),(350531,9737,'de','Leasing Informationen-Hilfe',0),(350532,9737,'en','Lease Information Help',0),(350533,9738,'is','',0),(350534,9738,'dr','ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¶Ø±ÙˆØ±ÙŠ Ø§Ø³Øª ',0),(350535,9738,'pr','ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¶Ø±ÙˆØ±ÙŠ Ø§Ø³Øª ',0),(350536,9738,'tr','TÃ¼m alanlarÄ±n doldurulmasÄ± zorunludur.',0),(350537,9738,'pl','Wszystkie pola sÄ… wymagane.',0),(350538,9738,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° ÑÐ° Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸.',0),(350539,9738,'ur','ØªÙ…Ø§Ù… Ù‚Ø·Ø¹Ø§Øª Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(350540,9738,'sr','Ð¡Ð²Ð° Ð¿Ð¾Ñ™Ð° ÑÑƒ Ð¾Ð±Ð°Ð²ÐµÐ·Ð½Ð°.',0),(350541,9738,'vi','táº¥t cáº£ cÃ¡c trÆ°á»ng Ä‘á»u cáº§n',0),(350542,9738,'af','Alle velde word vereis.',0),(350543,9738,'ro','Toate campurile sunt obligatorii.',0),(350544,9738,'et','KÃµik vÃ¤ljad on kohustuslikud.',0),(350545,9738,'si','Vsa polja so obvezna.',0),(350546,9738,'ba','Semua kolom wajib diisi.',0),(350547,9738,'nl','Alle velden zijn verplicht.',0),(350548,9738,'fi','Kaikki kentÃ¤t ovat pakollisia.',0),(350549,9738,'no','Alle felt er pÃ¥krevde.',0),(350550,9738,'da','Alle felter skal udfyldes.',0),(350551,9738,'ko','ëª¨ë“  í•„ë“œëŠ” í•„ìˆ˜ìž…ë‹ˆë‹¤.',0),(350552,9738,'he','×›×œ ×©×“×•×ª × ×“×¨×©×™×.',0),(350553,9738,'el','ÎŒÎ»Î± Ï„Î± Ï€ÎµÎ´Î¯Î± ÎµÎ¯Î½Î±Î¹ Ï…Ï€Î¿Ï‡ÏÎµÏ‰Ï„Î¹ÎºÎ¬.',0),(350554,9738,'zh','æ‰€æœ‰å­—æ®µæ˜¯å¿…éœ€çš„ã€‚\r\n',0),(350555,9738,'sv','Alla fÃ¤lt Ã¤r obligatoriska.',0),(350556,9738,'it','Tutti i campi sono obbligatori.',0),(350557,9738,'tl','',0),(350558,9738,'th','&#3615;&#3636;&#3621;&#3604;&#3660;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(350559,9738,'hi','à¤¸à¤­à¥€ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¤‚à¥¤',0),(350560,9738,'ms','Semua bidang yang diperlukan.',0),(350561,9738,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ù…Ø·Ù„ÙˆØ¨Ø©.',0),(350562,9738,'fr','Tous les champs sont obligatoires.',0),(350563,9738,'jp','ã™ã¹ã¦ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ãŒå¿…è¦ã§ã™ã€‚',0),(350564,9738,'pt','Todos os campos sÃ£o obrigatÃ³rios.',0),(350565,9738,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð·Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð¿Ð¾Ð»Ñ.',0),(350566,9738,'es','Todos los campos se requieren',0),(350567,9738,'de','Alle Felder sind Pflichtfelder.',0),(350568,9738,'en','All fields are required.',0),(350569,9739,'is','',0),(350570,9739,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(350571,9739,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(350572,9739,'tr','Kira bilgisi',0),(350573,9739,'pl','Informacje o dzierÅ¼awach',0),(350574,9739,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(350575,9739,'ur','Ù„ÛŒØ² Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(350576,9739,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð·Ð°ÐºÑƒÐ¿Ñƒ',0),(350577,9739,'vi','thÃ´ng tin thuÃª',0),(350578,9739,'af','Huurkontrak Inligting',0),(350579,9739,'ro','Contract de leasing de informaÅ£ii',0),(350580,9739,'et','Liisingu info',0),(350581,9739,'si','Informacije za najem',0),(350582,9739,'ba','Informasi sewa',0),(350583,9739,'nl','Lease-informatie',0),(350584,9739,'fi','Vuokrasopimus tiedot',0),(350585,9739,'no','Leasinginformasjon',0),(350586,9739,'da','LejemÃ¥let Information',0),(350587,9739,'ko','ìž„ëŒ€ ì •ë³´',0),(350588,9739,'he','×ž×™×“×¢ ×—×›×™×¨×”',0),(350589,9739,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(350590,9739,'zh','ç§Ÿèµä¿¡æ¯\r\n',0),(350591,9739,'sv','LÃ¥neinformation',0),(350592,9739,'it','Informazioni di lease',0),(350593,9739,'tl','',0),(350594,9739,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(350595,9739,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(350596,9739,'ms','Maklumat pajakan',0),(350597,9739,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(350598,9739,'fr','Location Information',0),(350599,9739,'jp','ãƒªãƒ¼ã‚¹æƒ…å ±',0),(350600,9739,'pt','InformaÃ§Ãµes de locaÃ§Ã£o',0),(350601,9739,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ð± Ð°Ñ€ÐµÐ½Ð´Ðµ',0),(350602,9739,'es','InformaciÃ³n del Arrendamiento',0),(350603,9739,'de','Leasing-Informationen',0),(350604,9739,'en','Lease Information',0),(350605,9740,'is','',0),(350606,9740,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(350607,9740,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(350608,9740,'tr','Kira baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(350609,9740,'pl','DzierÅ¼awy pomyÅ›lnie zaktualizowana',0),(350610,9740,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(350611,9740,'ur','Ù„ÛŒØ² Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(350612,9740,'sr','Ð—Ð°ÐºÑƒÐ¿ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(350613,9740,'vi','cáº­p nháº­t há»£p Ä‘á»“ng thuÃª thÃ nh cÃ´ng',0),(350614,9740,'af','Huurkontrak suksesvol Opdateer',0),(350615,9740,'ro','Contract de leasing actualizat cu succes',0),(350616,9740,'et','ÃœÃ¼rilepingu vÃ¤rskendatud',0),(350617,9740,'si','Najem uspeÅ¡no posodobljena',0),(350618,9740,'ba','Sewa yang berhasil',0),(350619,9740,'nl','Lease bijgewerkt',0),(350620,9740,'fi','Vuokrasopimuksen pÃ¤ivitetty',0),(350621,9740,'no','Leieavtalen oppdatert',0),(350622,9740,'da','Lease opdateret',0),(350623,9740,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ìž„ëŒ€',0),(350624,9740,'he','×©×›×™×¨×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(350625,9740,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(350626,9740,'zh','ç§ŸèµæˆåŠŸæ›´æ–°\r\n',0),(350627,9740,'sv','Lease uppdaterats',0),(350628,9740,'it','Contratto di locazione aggiornato con successo',0),(350629,9740,'tl','',0),(350630,9740,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(350631,9740,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤ªà¤Ÿà¥à¤Ÿà¤¾',0),(350632,9740,'ms','Pajakan yang berjaya dikemas kini',0),(350633,9740,'ar','Ø§Ù„ØªØ£Ø¬ÙŠØ± Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(350634,9740,'fr','Contrat de location mis Ã  jour avec succÃ¨s',0),(350635,9740,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸãƒªãƒ¼ã‚¹',0),(350636,9740,'pt','LocaÃ§Ã£o atualizada com sucesso',0),(350637,9740,'ru','ÐÑ€ÐµÐ½Ð´Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(350638,9740,'es','Arrendamiento Actualizado Exitosamente',0),(350639,9740,'de','Lease erfolgreich aktualisiert',0),(350640,9740,'en','Lease Updated Successfully',0),(350641,9741,'is','',0),(350642,9741,'dr','Ù‡ÙŠÚ† Ø§Ø¬Ø§Ø±Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(350643,9741,'pr','Ù‡ÙŠÚ† Ø§Ø¬Ø§Ø±Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(350644,9741,'tr','KiralarÄ± bulundu.',0),(350645,9741,'pl','Nie znaleziono dzierÅ¼aw.',0),(350646,9741,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³.',0),(350647,9741,'ur','Ú©ÙˆØ¦ÛŒ Ù„ÙÛŒØ²Ø² Ù¾Ø§ÛŒØ§ Û”',0),(350648,9741,'sr','ÐÐµÐ¼Ð° Ð´ÐµÐ¾Ð½Ð¸Ñ†Ðµ Ð½Ð°ÑˆÐ°Ð¾.',0),(350649,9741,'vi','khÃ´ng tÃ¬m tháº¥y há»£p Ä‘á»“ng thuÃª',0),(350650,9741,'af','Geen Huurkontrakte Gevind nie.',0),(350651,9741,'ro','Nici contractele de leasing gÄƒsite.',0),(350652,9741,'et','Ei leitud rendilepingute.',0),(350653,9741,'si','Najemi, ki ni naÅ¡el.',0),(350654,9741,'ba','Sewa tidak ditemukan.',0),(350655,9741,'nl','Geen lease-overeenkomsten gevonden.',0),(350656,9741,'fi','Vuokrasopimukset ei lÃ¶ytynyt.',0),(350657,9741,'no','Ingen lisenser finnes.',0),(350658,9741,'da','Ingen lejemÃ¥l fundet.',0),(350659,9741,'ko','ì•„ë‹ˆ ìž„ëŒ€ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(350660,9741,'he','×—×›×™×¨×” ×œ× × ×ž×¦××•.',0),(350661,9741,'el','ÎšÎ±Î¼Î¯Î± Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(350662,9741,'zh','æ²¡æœ‰æ‰¾åˆ°ç§Ÿèµã€‚\r\n',0),(350663,9741,'sv','Ingen leasing hittade.',0),(350664,9741,'it','Nessun prestito trovato.',0),(350665,9741,'tl','',0),(350666,9741,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(350667,9741,'hi','à¤•à¥‹à¤ˆ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(350668,9741,'ms','Pajakan tidak ditemui.',0),(350669,9741,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±Ø§Øª Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(350670,9741,'fr','Aucun bail trouvÃ©.',0),(350671,9741,'jp','ãªã„ãƒªãƒ¼ã‚¹ã‚’ç™ºè¦‹ã—ã¾ã™ã€‚',0),(350672,9741,'pt','Sem concessÃµes encontradas.',0),(350673,9741,'ru','Ð‘ÐµÐ· Ð°Ñ€ÐµÐ½Ð´Ñ‹ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.',0),(350674,9741,'es','No se Encontraron Arrendamientos',0),(350675,9741,'de','Keine Leases gefunden.',0),(350676,9741,'en','No Leases Found.',0),(350677,9742,'is','',0),(350678,9742,'dr','Ù‡ÙŠÚ† ÙˆØ§Ø­Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(350679,9742,'pr','Ù‡ÙŠÚ† ÙˆØ§Ø­Ø¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(350680,9742,'tr','Birimleri bulundu.',0),(350681,9742,'pl','Nie znaleziono jednostek.',0),(350682,9742,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸.',0),(350683,9742,'ur','Ú©ÙˆØ¦ÛŒ ÛŒÙˆÙ†Ù¹Ø³ Ù¾Ø§ÛŒØ§ Û”',0),(350684,9742,'sr','ÐÐµÐ¼Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ Ð½Ð°ÑˆÐ°Ð¾.',0),(350685,9742,'vi','khÃ´ng tÃ¬m tháº¥y cÃ¡c Ä‘Æ¡n vá»‹',0),(350686,9742,'af','Geen Eenhede Gevind.',0),(350687,9742,'ro','Nici unitÄƒÈ›i gÄƒsite.',0),(350688,9742,'et','Ãœhikuid ei leitud.',0),(350689,9742,'si','Ne enote, najdene.',0),(350690,9742,'ba','Unit tidak ditemukan.',0),(350691,9742,'nl','Geen eenheden gevonden.',0),(350692,9742,'fi','YksikkÃ¶Ã¤ ei lÃ¶ytynyt.',0),(350693,9742,'no','Ingen enheter funnet.',0),(350694,9742,'da','Ingen enheder findes.',0),(350695,9742,'ko','ì•„ë‹ˆ ëŒ€ ë°œê²¬ìž…ë‹ˆë‹¤.',0),(350696,9742,'he','.×œ× × ×ž×¦××• ×™×—×™×“×•×ª',0),(350697,9742,'el','Î”ÎµÎ½ Ï„Î¹Ï‚ Î¼Î¿Î½Î¬Î´ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½.',0),(350698,9742,'zh','æ²¡æœ‰å‘çŽ°ä»»ä½•å•ä½ã€‚\r\n',0),(350699,9742,'sv','Inga enheter hittades.',0),(350700,9742,'it','Non riscontrato.',0),(350701,9742,'tl','',0),(350702,9742,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(350703,9742,'hi','à¤•à¥‹à¤ˆ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾à¥¤',0),(350704,9742,'ms','Tiada unit yang ditemui.',0),(350705,9742,'ar','Ø§Ù„ÙˆØ­Ø¯Ø§Øª Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰.',0),(350706,9742,'fr','Aucun unitÃ© trouvÃ©.',0),(350707,9742,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã‚’ç™ºè¦‹ã—ã¦ã„ã¾ã›ã‚“ã€‚',0),(350708,9742,'pt','Nenhuma unidade encontrada.',0),(350709,9742,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾.',0),(350710,9742,'es','No se Encontraron Unidades',0),(350711,9742,'de','Keine Einheiten gefunden.',0),(350712,9742,'en','No Units Found.',0),(350713,9743,'is','',0),(350714,9743,'dr','Pet Deposit',0),(350715,9743,'pr','Pet Deposit',0),(350716,9743,'tr','Evde beslenen hayvan mevduat',0),(350717,9743,'pl','PieÅ›ciÄ‡ depozytu',0),(350718,9743,'bg','Ð“Ð°Ð»ÐµÐ½Ð¸Ðº Ð²Ð»Ð¾Ð³',0),(350719,9743,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± Ø¬Ù…Ø¹',0),(350720,9743,'sr','Ð‰ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(350721,9743,'vi','khoáº£n tiá»n gá»­i Ä‘áº·t biá»‡t',0),(350722,9743,'af','Troeteldier deposito',0),(350723,9743,'ro','Animal de casÄƒ depozit',0),(350724,9743,'et','Lemmikloomade hoiuse',0),(350725,9743,'si','HiÅ¡nih depozita',0),(350726,9743,'ba','Hewan peliharaan Deposit',0),(350727,9743,'nl','Huisdier storting',0),(350728,9743,'fi','LemmikkielÃ¤inten talletus',0),(350729,9743,'no','Pet innskudd',0),(350730,9743,'da','KÃ¦ledyr depositum',0),(350731,9743,'ko','ì• ì™„ ë™ë¬¼ ë³´ì¦ê¸ˆ',0),(350732,9743,'he','×¤×™×§×“×•×Ÿ ×œ×—×™×•×ª ×ž×—×ž×“',0),(350733,9743,'el','ÎšÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½',0),(350734,9743,'zh','å® ç‰©å­˜æ¬¾\r\n',0),(350735,9743,'sv','Husdjur insÃ¤ttning',0),(350736,9743,'it','Deposito domestico',0),(350737,9743,'tl','',0),(350738,9743,'th','&#3613;&#3634;&#3585;&#3626;&#3633;&#3605;&#3623;&#3660;&#3648;&#3621;&#3637;&#3657;&#3618;&#3591;',0),(350739,9743,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤œà¤®à¤¾',0),(350740,9743,'ms','Deposit haiwan kesayangan',0),(350741,9743,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ©',0),(350742,9743,'fr','DÃ©pÃ´t pour animaux de compagnie',0),(350743,9743,'jp','ãƒšãƒƒãƒˆã®é ã‹ã‚Š',0),(350744,9743,'pt','DepÃ³sito de animais',0),(350745,9743,'ru','Pet Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(350746,9743,'es','DepÃ³sito para Mascota',0),(350747,9743,'de','Kaution',0),(350748,9743,'en','Pet Deposit',0),(350749,9744,'is','',0),(350750,9744,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(350751,9744,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(350752,9744,'tr','LÃ¼tfen bitiÅŸ tarihi seÃ§in.',0),(350753,9744,'pl','ProszÄ™ wybraÄ‡ datÄ™ zakoÅ„czenia.',0),(350754,9744,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°.',0),(350755,9744,'ur','Ø§ÛŒÚ© ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Û”',0),(350756,9744,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°.',0),(350757,9744,'vi','vui lÃ²ng chá»n ngÃ y káº¿t thÃºc',0),(350758,9744,'af','Selekteer asseblief \'n End Datum.',0),(350759,9744,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i o datÄƒ de Ã®ncheiere.',0),(350760,9744,'et','Palun vali lÃµppkuupÃ¤ev',0),(350761,9744,'si','Izberite konÄni datum.',0),(350762,9744,'ba','Silakan pilih tanggal akhir.',0),(350763,9744,'nl','Selecteer een einddatum.',0),(350764,9744,'fi','Valitse pÃ¤Ã¤ttymispÃ¤ivÃ¤.',0),(350765,9744,'no','Velg en sluttdato.',0),(350766,9744,'da','VÃ¦lg en slutdato.',0),(350767,9744,'ko','ë ë‚ ì§œë¥¼ ì„ íƒ í•˜ì‹­ì‹œì˜¤.',0),(350768,9744,'he','.×× × ×‘×—×¨ ×ª××¨×™×š ×¡×™×•×',0),(350769,9744,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚.',0),(350770,9744,'zh','è¯·é€‰æ‹©ä¸€ä¸ªç»“æŸæ—¥æœŸã€‚\r\n',0),(350771,9744,'sv','VÃ¤nligen vÃ¤lj ett slutdatum.',0),(350772,9744,'it','Si prega di selezionare una data di fine.',0),(350773,9744,'tl','',0),(350774,9744,'th','&#3650;&#3611;&#3619;&#3604;&#3648;&#3621;&#3639;&#3629;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(350775,9744,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚à¥¤',0),(350776,9744,'ms','Sila pilih tarikh tamat.',0),(350777,9744,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ \"ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡\".',0),(350778,9744,'fr','Veuillez sÃ©lectionner une Date de fin.',0),(350779,9744,'jp','çµ‚äº†æ—¥ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(350780,9744,'pt','Por favor, selecione uma data de tÃ©rmino.',0),(350781,9744,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð”Ð°Ñ‚Ñƒ ÐžÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ.',0),(350782,9744,'es','Por Favor Selecciona Una Fecha de TerminaciÃ³n',0),(350783,9744,'de','Bitte wÃ¤hlen Sie ein Enddatum.',0),(350784,9744,'en','Please select an End Date.',0),(350785,9745,'is','',0),(350786,9745,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(350787,9745,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(350788,9745,'tr','LÃ¼tfen baÅŸlamak bir tarih seÃ§in.',0),(350789,9745,'pl','ProszÄ™ wybraÄ‡ datÄ™ rozpoczÄ…Ä‡.',0),(350790,9745,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð·Ð°Ð¿Ð¾Ñ‡Ð½Ðµ Ð´Ð°Ñ‚Ð°.',0),(350791,9745,'ur','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Û”',0),(350792,9745,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚Ð¸.',0),(350793,9745,'vi','vui lÃ²ng chá»n ngÃ y báº¯t Ä‘áº§u',0),(350794,9745,'af','Selekteer asseblief \'n Begindatum',0),(350795,9745,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i o datÄƒ Ã®ncep.',0),(350796,9745,'et','Palun vali algus kuupÃ¤ev',0),(350797,9745,'si','Izberite zaÄetek datum.',0),(350798,9745,'ba','Silakan pilih tanggal mulai.',0),(350799,9745,'nl','Selecteer een datum beginnen.',0),(350800,9745,'fi','Valitse Aloita pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤.',0),(350801,9745,'no','Velg en begynner dato.',0),(350802,9745,'da','VÃ¦lg venligst en begynder dato.',0),(350803,9745,'ko','ì‹œìž‘ ë‚ ì§œë¥¼ ì„ íƒ í•˜ì‹­ì‹œì˜¤.',0),(350804,9745,'he','.×× × ×‘×—×¨ ×ª××¨×™×š ×”×ª×—×œ×”',0),(350805,9745,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… Î±ÏÏ‡Î¯Î¶Î¿Ï…Î½.',0),(350806,9745,'zh','è¯·é€‰æ‹©ä¸€å¼€å§‹æ—¥æœŸã€‚\r\n',0),(350807,9745,'sv','VÃ¤nligen vÃ¤lj ett pÃ¥bÃ¶rja datum.',0),(350808,9745,'it','Si prega di selezionare una data di inizio.',0),(350809,9745,'tl','',0),(350810,9745,'th','&#3650;&#3611;&#3619;&#3604;&#3648;&#3621;&#3639;&#3629;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(350811,9745,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤¿à¤¸à¥€ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚à¥¤',0),(350812,9745,'ms','Sila pilih tarikh mula.',0),(350813,9745,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ \"ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡\".',0),(350814,9745,'fr','Veuillez sÃ©lectionner une Date commencer.',0),(350815,9745,'jp','é–‹å§‹æ—¥ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(350816,9745,'pt','Por favor, selecione uma data de inÃ­cio.',0),(350817,9745,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð”Ð°Ñ‚Ñƒ ÐÐ°Ñ‡Ð°Ð»Ð°.',0),(350818,9745,'es','Por Favor Selecciona Una Fecha de Comienza',0),(350819,9745,'de','Bitte wÃ¤hlen Sie ein Anfangsdatum.',0),(350820,9745,'en','Please select a Begin Date.',0),(350821,9746,'is','',0),(350822,9746,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(350823,9746,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(350824,9746,'tr','LÃ¼tfen bir yapÄ± seÃ§in.',0),(350825,9746,'pl','ProszÄ™ wybraÄ‡ budynek.',0),(350826,9746,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ´Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°.',0),(350827,9746,'ur','Ø§ÛŒÚ© Ø¹Ù…Ø§Ø±Øª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Û”',0),(350828,9746,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð·Ð³Ñ€Ð°Ð´Ñƒ.',0),(350829,9746,'vi','vui lÃ²ng chá»n cáº¥u trÃºc',0),(350830,9746,'af','Kies asseblief \'n Gebou.',0),(350831,9746,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i o clÄƒdire.',0),(350832,9746,'et','Palun vali hoone',0),(350833,9746,'si','Izberite stavbe.',0),(350834,9746,'ba','Silahkan pilih sebuah bangunan.',0),(350835,9746,'nl','Selecteer een gebouw.',0),(350836,9746,'fi','Valitse rakennuksen.',0),(350837,9746,'no','Velg en bygning.',0),(350838,9746,'da','VÃ¦lg venligst en bygning.',0),(350839,9746,'ko','ê±´ë¬¼ì„ ì„ íƒ í•˜ì‹­ì‹œì˜¤.',0),(350840,9746,'he','.×× × ×‘×—×¨ ×‘× ×™×Ÿ',0),(350841,9746,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± ÎºÏ„Î¯ÏÎ¹Î¿.',0),(350842,9746,'zh','è¯·é€‰æ‹©ä¸€ä¸ªå»ºè®¾ã€‚\r\n',0),(350843,9746,'sv','VÃ¤nligen vÃ¤lj en byggnad.',0),(350844,9746,'it','Si prega di selezionare un edificio.',0),(350845,9746,'tl','',0),(350846,9746,'th','&#3650;&#3611;&#3619;&#3604;&#3648;&#3621;&#3639;&#3629;&#3585;&#3585;&#3634;&#3619;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(350847,9746,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤‡à¤®à¤¾à¤°à¤¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚à¥¤',0),(350848,9746,'ms','Sila pilih sebuah bangunan.',0),(350849,9746,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ø£Ø­Ø¯ Ø§Ù„Ù…Ø¨Ø§Ù†ÙŠ.',0),(350850,9746,'fr','Veuillez sÃ©lectionner un bÃ¢timent.',0),(350851,9746,'jp','å»ºç‰©ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(350852,9746,'pt','Por favor selecione um edifÃ­cio.',0),(350853,9746,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð·Ð´Ð°Ð½Ð¸Ðµ.',0),(350854,9746,'es','Por Favor Selecciona Un Edificio',0),(350855,9746,'de','Bitte wÃ¤hlen Sie ein GebÃ¤ude.',0),(350856,9746,'en','Please select a Building.',0),(350857,9747,'is','',0),(350858,9747,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù…Ø³ØªØ§Ø¬Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(350859,9747,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù…Ø³ØªØ§Ø¬Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(350860,9747,'tr','Bir kiracÄ± seÃ§iniz.',0),(350861,9747,'pl','ProszÄ™ wybraÄ‡ najemcy.',0),(350862,9747,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ».',0),(350863,9747,'ur','Ø§ÛŒÚ© Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Û”',0),(350864,9747,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð½Ð°Ñ€Ð°.',0),(350865,9747,'vi','vui lÃ²ng chá»n ngÆ°á»i thue',0),(350866,9747,'af','Sluit \'n Huurder In.',0),(350867,9747,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i un chiriaÅŸ.',0),(350868,9747,'et','Palun vali rentnik',0),(350869,9747,'si','Izberite najemnik.',0),(350870,9747,'ba','Silakan pilih penyewa.',0),(350871,9747,'nl','Selecteer een huurder.',0),(350872,9747,'fi','Valitse vuokralainen.',0),(350873,9747,'no','Velg en leietaker.',0),(350874,9747,'da','VÃ¦lg venligst en lejer.',0),(350875,9747,'ko','ì„¸ ìž…ìžë¥¼ ì„ íƒ í•˜ì‹­ì‹œì˜¤.',0),(350876,9747,'he','×× × ×‘×—×¨',0),(350877,9747,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®.',0),(350878,9747,'zh','è¯·é€‰æ‹©ä¸€ä¸ªç§Ÿå®¢ã€‚\r\n',0),(350879,9747,'sv','VÃ¤nligen vÃ¤lj en hyresgÃ¤st.',0),(350880,9747,'it','Si prega di selezionare un inquilino.',0),(350881,9747,'tl','',0),(350882,9747,'th','&#3650;&#3611;&#3619;&#3604;&#3648;&#3621;&#3639;&#3629;&#3585;&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;',0),(350883,9747,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚à¥¤',0),(350884,9747,'ms','Sila pilih penyewa.',0),(350885,9747,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ù…Ø³ØªØ£Ø¬Ø±.',0),(350886,9747,'fr','Veuillez sÃ©lectionner un locataire.',0),(350887,9747,'jp','ãƒ†ãƒŠãƒ³ãƒˆã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(350888,9747,'pt','Por favor selecione um inquilino.',0),(350889,9747,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð°.',0),(350890,9747,'es','Por Favor Selecciona Un Inquilino',0),(350891,9747,'de','Bitte wÃ¤hlen Sie einen Mieter.',0),(350892,9747,'en','Please select a Tenant.',0),(350893,9748,'is','',0),(350894,9748,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ ÙˆØ§Ø­Ø¯  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(350895,9748,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ ÙˆØ§Ø­Ø¯  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(350896,9748,'tr','LÃ¼tfen bir birim seÃ§in.',0),(350897,9748,'pl','ProszÄ™ wybraÄ‡ jednostki.',0),(350898,9748,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°.',0),(350899,9748,'ur','Ø§ÛŒÚ© ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Û”',0),(350900,9748,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ.',0),(350901,9748,'vi','vui lÃ²ng chá»n Ä‘Æ¡n vá»‹',0),(350902,9748,'af','Kies asseblief \'n Eenheid.',0),(350903,9748,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i o unitate.',0),(350904,9748,'et','Palun vali Ã¼ksus',0),(350905,9748,'si','Izberite enoto.',0),(350906,9748,'ba','Silakan pilih Unit.',0),(350907,9748,'nl','Selecteer een eenheid.',0),(350908,9748,'fi','Valitse yksikkÃ¶.',0),(350909,9748,'no','Velg en enhet.',0),(350910,9748,'da','VÃ¦lg en enhed.',0),(350911,9748,'ko','ë‹¨ìœ„ë¥¼ ì„ íƒ í•˜ì‹­ì‹œì˜¤.',0),(350912,9748,'he','×× × ×‘×—×¨',0),(350913,9748,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î¼Î¿Î½Î¬Î´Î±.',0),(350914,9748,'zh','è¯·é€‰æ‹©ä¸€ä¸ªå•ä½',0),(350915,9748,'sv','VÃ¤nligen vÃ¤lj en enhet.',0),(350916,9748,'it','Si prega di selezionare un\'unitÃ .',0),(350917,9748,'tl','',0),(350918,9748,'th','&#3650;&#3611;&#3619;&#3604;&#3648;&#3621;&#3639;&#3629;&#3585;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(350919,9748,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚à¥¤',0),(350920,9748,'ms','Sila pilih satu Unit.',0),(350921,9748,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ ÙˆØ­Ø¯Ø©.',0),(350922,9748,'fr','Veuillez sÃ©lectionner une unitÃ©.',0),(350923,9748,'jp','å˜ä½ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(350924,9748,'pt','Por favor, selecione uma unidade.',0),(350925,9748,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑƒÑÑ‚Ñ€Ð¾Ð¹ÑÑ‚Ð²Ð¾.',0),(350926,9748,'es','Por Favor Selecciona Una Unidad',0),(350927,9748,'de','Bitte wÃ¤hlen Sie eine Einheit.',0),(350928,9748,'en','Please select a Unit.',0),(350929,9749,'is','',0),(350930,9749,'dr','( Ø±Ø²Ø±Ùˆ ',0),(350931,9749,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø°Ø®ÙŠØ±Ù‡( Ø±Ø²Ø±Ùˆ ',0),(350932,9749,'tr','Rezervasyon Ã¼creti',0),(350933,9749,'pl','OpÅ‚ata rezerwacyjna',0),(350934,9749,'bg','Ð ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð°Ñ‚Ð° Ñ‚Ð°ÐºÑÐ°',0),(350935,9749,'ur','Ø¨Ú©Ù†Ú¯ ÙÛŒØ³',0),(350936,9749,'sr','Ð—Ð° Ñ€ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(350937,9749,'vi','phÃ­ Ä‘áº·t trÆ°á»›c',0),(350938,9749,'af','Besprekingsfooi',0),(350939,9749,'ro','Taxa de rezervare',0),(350940,9749,'et','Broneerimistasu',0),(350941,9749,'si','Znesek rezervacije',0),(350942,9749,'ba','Biaya Pemesanan',0),(350943,9749,'nl','Reserveringskosten',0),(350944,9749,'fi','Varausmaksun',0),(350945,9749,'no','Reservasjonsgebyr',0),(350946,9749,'da','Reservationsgebyr',0),(350947,9749,'ko','ì˜ˆì•½ ìˆ˜ìˆ˜ë£Œ',0),(350948,9749,'he','×¢×ž×œ×ª ×”×–×ž× ×”',0),(350949,9749,'el','Î¤Î­Î»Î¿Ï‚ ÎºÏÎ¬Ï„Î·ÏƒÎ·Ï‚',0),(350950,9749,'zh','é¢„è®¢è´¹\r\n',0),(350951,9749,'sv','Bokningsavgift',0),(350952,9749,'it','Tassa di prenotazione',0),(350953,9749,'tl','',0),(350954,9749,'th','&#3588;&#3656;&#3634;&#3608;&#3619;&#3619;&#3617;&#3648;&#3609;&#3637;&#3618;&#3617;&#3585;&#3634;&#3619;&#3592;&#3629;&#3591;',0),(350955,9749,'hi','à¤†à¤°à¤•à¥à¤·à¤£ à¤¶à¥à¤²à¥à¤•',0),(350956,9749,'ms','Bayaran Tempahan',0),(350957,9749,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø­Ø¬Ø²',0),(350958,9749,'fr','Frais de rÃ©servation',0),(350959,9749,'jp','äºˆç´„æ‰‹æ•°æ–™',0),(350960,9749,'pt','Taxa de reserva',0),(350961,9749,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ€ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ð¸',0),(350962,9749,'es','Cuota de ReservaciÃ³n',0),(350963,9749,'de','ReservierungsgebÃ¼hr',0),(350964,9749,'en','Reservation Fee',0),(350965,9750,'is','',0),(350966,9750,'dr','Ù…Ø³ØªØ§Ø¬Ø± ',0),(350967,9750,'pr','Ù…Ø³ØªØ§Ø¬Ø± ',0),(350968,9750,'tr','KiracÄ±',0),(350969,9750,'pl','Najemcy',0),(350970,9750,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ»',0),(350971,9750,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±',0),(350972,9750,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€',0),(350973,9750,'vi','NgÆ°á»i thuÃª nhÃ ',0),(350974,9750,'af','Huurder',0),(350975,9750,'ro','ChiriaÅŸ',0),(350976,9750,'et','Rentniku',0),(350977,9750,'si','Najemnik',0),(350978,9750,'ba','Penyewa',0),(350979,9750,'nl','Huurder',0),(350980,9750,'fi','Vuokralainen',0),(350981,9750,'no','Leietaker',0),(350982,9750,'da','Lejer',0),(350983,9750,'ko','ì„¸ ìž…ìž',0),(350984,9750,'he','×”×“×™×™×¨',0),(350985,9750,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½',0),(350986,9750,'zh','ä¸šæƒäºº\r\n',0),(350987,9750,'sv','HyresgÃ¤st',0),(350988,9750,'it','Inquilino',0),(350989,9750,'tl','',0),(350990,9750,'th','&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;',0),(350991,9750,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°',0),(350992,9750,'ms','Penyewa',0),(350993,9750,'ar','Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(350994,9750,'fr','Locataire',0),(350995,9750,'jp','ãƒ†ãƒŠãƒ³ãƒˆ',0),(350996,9750,'pt','Inquilino',0),(350997,9750,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€',0),(350998,9750,'es','Inquilino',0),(350999,9750,'de','Mieter',0),(351000,9750,'en','Tenant',0),(351001,9751,'is','',0),(351002,9751,'dr','Ø§Ø¯Ø§Ø±Ù‡ ÙƒØ±Ø¯Ù† Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§ ',0),(351003,9751,'pr','Ø§Ø¯Ø§Ø±Ù‡ ÙƒØ±Ø¯Ù† Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§ ',0),(351004,9751,'tr','YÃ¶netme',0),(351005,9751,'pl','ZarzÄ…dzanie potencjalnymi klientami',0),(351006,9751,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ñ€Ð¾ÑÐ¿ÐµÐºÑ‚Ð¸',0),(351007,9751,'ur','Ø§Ù…Ú©Ø§Ù†Ø§Øª Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±ÛŒÚº',0),(351008,9751,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ð¸Ð·Ð³Ð»ÐµÐ´Ðµ',0),(351009,9751,'vi','Quáº£n lÃ½ toÃ n cáº£nh',0),(351010,9751,'af','Behartig Voornemende KliÃ«nt',0),(351011,9751,'ro','Gestiona perspectivele',0),(351012,9751,'et','Hallata vÃ¤ljavaateid',0),(351013,9751,'si','Upravljanje moÅ¾nosti',0),(351014,9751,'ba','Mengelola prospek',0),(351015,9751,'nl','Beheren van vooruitzichten',0),(351016,9751,'fi','Hallitse nÃ¤kymiÃ¤',0),(351017,9751,'no','Administrere prospekter',0),(351018,9751,'da','Administrere kundeemner',0),(351019,9751,'ko','ìž ìž¬ ê³ ê° ê´€ë¦¬',0),(351020,9751,'he','× ×™×”×•×œ ×”×˜×™×¤×•×œ ×‘×œ×§×•×—×•×ª ×¤×•×˜× ×¦×™××œ×™×™×',0),(351021,9751,'el','Î”Î¹Î±Ï‡ÎµÎ¹ÏÎ¹ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ­Ï‚',0),(351022,9751,'zh','ç®¡ç†å±•æœ›\r\n',0),(351023,9751,'sv','Hantera framtidsutsikter',0),(351024,9751,'it','Il gestore di prospettive',0),(351025,9751,'tl','',0),(351026,9751,'th','&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3585;&#3634;&#3619;',0),(351027,9751,'hi','à¤¸à¤‚à¤­à¤¾à¤µà¤¿à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(351028,9751,'ms','Menguruskan prospek',0),(351029,9751,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„ØªÙˆÙ‚Ø¹Ø§Øª',0),(351030,9751,'fr','GÃ©rer les perspectives',0),(351031,9751,'jp','è¦‹é€šã—ã‚’ç®¡ç†ã—ã¾ã™ã€‚',0),(351032,9751,'pt','Gerenciar clientes potenciais',0),(351033,9751,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ‚ÐµÐ½Ñ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¼Ð¸',0),(351034,9751,'es','Manaejar Clientes Potenciales',0),(351035,9751,'de','Verwalten von Perspektiven',0),(351036,9751,'en','Manage Prospects',0),(351037,9752,'is','',0),(351038,9752,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ùˆ  ÙˆÙŠØ±Ø§ÙŠØ´  Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§ ',0),(351039,9752,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ùˆ  ÙˆÙŠØ±Ø§ÙŠØ´  Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§ ',0),(351040,9752,'tr','UmutlarÄ± gÃ¶rÃ¼ntÃ¼leyin ve dÃ¼zenleyin.',0),(351041,9752,'pl','WyÅ›wietlanie i edytowanie perspektywy.',0),(351042,9752,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð¸.',0),(351043,9752,'ur','Ù…Ù†Ø¸Ø± Ø§ÙˆØ± ØªØ±Ù…ÛŒÙ… Ú©Û’ Ø§Ù…Ú©Ø§Ù†Ø§Øª ÛÛŒÚº Û”',0),(351044,9752,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¸ ÑƒÑ€ÐµÐ´Ð¸Ñ‚Ðµ Ð¸Ð·Ð³Ð»ÐµÐ´Ðµ.',0),(351045,9752,'vi','Xem xÃ©t vÃ  chá»‰nh sá»­a toÃ n cáº£nh',0),(351046,9752,'af','Besigtig en redigeer Voornemende KliÃ«nte.',0),(351047,9752,'ro','VizualizaÈ›i È™i editaÈ›i perspectivele.',0),(351048,9752,'et','Saate vaadata ja redigeerida vÃ¤ljavaateid.',0),(351049,9752,'si','Ogled in urejanje moÅ¾nosti.',0),(351050,9752,'ba','Lihat dan edit prospek.',0),(351051,9752,'nl','Bekijken en bewerken van vooruitzichten.',0),(351052,9752,'fi','Tarkastele ja Muokkaa nÃ¤kymiÃ¤.',0),(351053,9752,'no','Vis og Rediger prospekter.',0),(351054,9752,'da','FÃ¥ vist og redigere kundeemner.',0),(351055,9752,'ko','ë³´ê¸° ë° íŽ¸ì§‘ ìž ìž¬ ê³ ê°ìž…ë‹ˆë‹¤.',0),(351056,9752,'he','×”×¦×’×” ×•×¢×¨×™×›×” ×©×œ ×œ×§×•×—×•×ª ×¤×•×˜× ×¦×™××œ×™×™×.',0),(351057,9752,'el','Î ÏÎ¿Î²Î¬Î»ÎµÏ„Îµ ÎºÎ±Î¹ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ­Ï‚.',0),(351058,9752,'zh','æŸ¥çœ‹å’Œç¼–è¾‘å‰æ™¯ã€‚\r\n',0),(351059,9752,'sv','Visa och redigera framtidsutsikter.',0),(351060,9752,'it','Visualizzare e modificare le prospettive.',0),(351061,9752,'tl','',0),(351062,9752,'th','&#3604;&#3641;&#3649;&#3621;&#3632;&#3649;&#3585;&#3657;&#3652;&#3586;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;',0),(351063,9752,'hi','à¤•à¥€ à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾à¤“à¤‚ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤”à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚à¥¤',0),(351064,9752,'ms','Lihat dan edit prospek.',0),(351065,9752,'ar','Ø¹Ø±Ø¶ ÙˆØªØ­Ø±ÙŠØ± Ø¢ÙØ§Ù‚.',0),(351066,9752,'fr','Afficher et modifier les perspectives.',0),(351067,9752,'jp','è¡¨ç¤ºãŠã‚ˆã³ç·¨é›†ã®è¦‹é€šã—ã€‚',0),(351068,9752,'pt','Exiba e edite as perspectivas.',0),(351069,9752,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ñ‹.',0),(351070,9752,'es','Visionar y editar Clientes Potenciales',0),(351071,9752,'de','Anzeigen und Bearbeiten von Perspektiven.',0),(351072,9752,'en','View and edit Prospects.',0),(351073,9753,'is','',0),(351074,9753,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù†Ø§Ù… ',0),(351075,9753,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù†Ø§Ù… ',0),(351076,9753,'tr','Ad arama',0),(351077,9753,'pl','Nazwa wyszukiwania',0),(351078,9753,'bg','Ð˜Ð¼Ðµ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(351079,9753,'ur','Ù†Ø§Ù… ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(351080,9753,'sr','Ð˜Ð¼Ðµ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(351081,9753,'vi','TÃªn tÃ¬m kiáº¿m',0),(351082,9753,'af','Naam Soektog',0),(351083,9753,'ro','CÄƒutare de nume',0),(351084,9753,'et','Nime otsing',0),(351085,9753,'si','Ime IÅ¡Äi',0),(351086,9753,'ba','Nama pencarian',0),(351087,9753,'nl','Zoeken op naam',0),(351088,9753,'fi','Nimihaku',0),(351089,9753,'no','NavnsÃ¸k',0),(351090,9753,'da','NavnesÃ¸gning',0),(351091,9753,'ko','ì´ë¦„ ê²€ìƒ‰',0),(351092,9753,'he','×—×™×¤×•×© ×©×',0),(351093,9753,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î¿Î½ÏŒÎ¼Î±Ï„Î¿Ï‚',0),(351094,9753,'zh','åç§°æœç´¢\r\n',0),(351095,9753,'sv','Namn SÃ¶k',0),(351096,9753,'it','Ricerca per nome',0),(351097,9753,'tl','',0),(351098,9753,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3594;&#3639;&#3656;&#3629;',0),(351099,9753,'hi','à¤¨à¤¾à¤® à¤–à¥‹à¤œ',0),(351100,9753,'ms','Carian nama',0),(351101,9753,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ø³Ù…',0),(351102,9753,'fr','Recherche par nom',0),(351103,9753,'jp','åå‰ã®æ¤œç´¢',0),(351104,9753,'pt','Pesquisa de nomes',0),(351105,9753,'ru','ÐŸÐ¾Ð¸ÑÐº ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ñ',0),(351106,9753,'es','Busqueda de Nombre',0),(351107,9753,'de','Namenssuche',0),(351108,9753,'en','Name Search',0),(351109,9754,'is','',0),(351110,9754,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ù…Ù…ØªØ§Ø²',0),(351111,9754,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ù…Ù…ØªØ§Ø²',0),(351112,9754,'tr','Tercih edilen alan',0),(351113,9754,'pl','Preferowany obszar',0),(351114,9754,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ Ñ€Ð°Ð¹Ð¾Ð½',0),(351115,9754,'ur','ØªØ±Ø¬ÛŒØ­ÛŒ Ø¹Ù„Ø§Ù‚Û’',0),(351116,9754,'sr','Ð–ÐµÑ™ÐµÐ½Ð¸Ñ… Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(351117,9754,'vi','vÃ¹ng Ä‘Æ°á»£c Æ°a thÃ­ch',0),(351118,9754,'af','Verkiesde Area',0),(351119,9754,'ro','ZonÄƒ preferatÄƒ',0),(351120,9754,'et','Piirkondadest',0),(351121,9754,'si','Raje obmoÄje',0),(351122,9754,'ba','Pilihan Area',0),(351123,9754,'nl','Gewenste ruimte',0),(351124,9754,'fi','Haluamasi alue',0),(351125,9754,'no','Foretrukne omrÃ¥det',0),(351126,9754,'da','Foretrukne omrÃ¥de',0),(351127,9754,'ko','ì„ í˜¸ ì§€ì—­',0),(351128,9754,'he','××–×•×¨ ×ž×•×¢×“×£',0),(351129,9754,'el','Î ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(351130,9754,'zh','é¦–é€‰åœ°åŒº\r\n',0),(351131,9754,'sv','Rekommenderad Area',0),(351132,9754,'it','Zona preferita',0),(351133,9754,'tl','',0),(351134,9754,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(351135,9754,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(351136,9754,'ms','Kawasan pilihan',0),(351137,9754,'ar','Ø§Ù„Ù…Ø¬Ø§Ù„ Ø§Ù„Ù…ÙØ¶Ù„',0),(351138,9754,'fr','Secteur prÃ©fÃ©rÃ©',0),(351139,9754,'jp','æœ€å¯„ã‚Šã®ã‚¨ãƒªã‚¢',0),(351140,9754,'pt','Ãrea preferencial',0),(351141,9754,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ñ€Ð°Ð¹Ð¾Ð½',0),(351142,9754,'es','Ãrea Preferida',0),(351143,9754,'de','Bevorzugte Gegend',0),(351144,9754,'en','Preferred Area',0),(351145,9755,'is','',0),(351146,9755,'dr','(Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(351147,9755,'pr','Ù†Ù…Ø§ÙŠØ´ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ(Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(351148,9755,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ uygulama',0),(351149,9755,'pl','PokaÅ¼ aplikacjÄ™',0),(351150,9755,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(351151,9755,'ur','Ù…Ù†Ø¸Ø± Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù†',0),(351152,9755,'sr','ÐÐ¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·',0),(351153,9755,'vi','Xem á»©ng dá»¥ng',0),(351154,9755,'af','Besigtig Aansoek',0),(351155,9755,'ro','Vezi aplicaÅ£ia',0),(351156,9755,'et','Kuva rakendus',0),(351157,9755,'si','Pogled uporabe',0),(351158,9755,'ba','Lihat aplikasi',0),(351159,9755,'nl','Bekijk toepassing',0),(351160,9755,'fi','NÃ¤ytÃ¤ sovellus',0),(351161,9755,'no','Vis programmet',0),(351162,9755,'da','Se program',0),(351163,9755,'ko','ì‘ìš© í”„ë¡œê·¸ëž¨ ë³´ê¸°',0),(351164,9755,'he','×ª×¦×•×’×ª ×™×™×©×•×',0),(351165,9755,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎµÏ†Î±ÏÎ¼Î¿Î³Î®Ï‚',0),(351166,9755,'zh','æŸ¥çœ‹åº”ç”¨ç¨‹åº\r\n',0),(351167,9755,'sv','Visa ansÃ¶kan',0),(351168,9755,'it','Applicazione di visualizzazione',0),(351169,9755,'tl','',0),(351170,9755,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(351171,9755,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤—',0),(351172,9755,'ms','Permohonan paparan',0),(351173,9755,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¹Ø±Ø¶',0),(351174,9755,'fr','Demande dâ€™avis',0),(351175,9755,'jp','ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã®è¡¨ç¤º',0),(351176,9755,'pt','Aplicativo de exibiÃ§Ã£o',0),(351177,9755,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(351178,9755,'es','Visionar una AplicaciÃ³n',0),(351179,9755,'de','Anwendung anzeigen',0),(351180,9755,'en','View Application',0),(351181,9756,'is','',0),(351182,9756,'dr','(Ø¯Ø±Ø®ÙˆØ§Ø³Øª ',0),(351183,9756,'pr','Ù†ÙˆØ¹ Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ(Ø¯Ø±Ø®ÙˆØ§Ø³Øª ',0),(351184,9756,'tr','Uygulama tÃ¼rÃ¼',0),(351185,9756,'pl','Typ aplikacji',0),(351186,9756,'bg','Ð¢Ð¸Ð¿ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(351187,9756,'ur','Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù† Ù‚Ø³Ù…',0),(351188,9756,'sr','Ð¢Ð¸Ð¿ Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(351189,9756,'vi','Loáº¡i á»©ng dá»¥ng',0),(351190,9756,'af','Aansoek tipe',0),(351191,9756,'ro','Cerere tip',0),(351192,9756,'et','Taotluse tÃ¼Ã¼p',0),(351193,9756,'si','Vrsta programa',0),(351194,9756,'ba','Jenis aplikasi',0),(351195,9756,'nl','Toepassingstype',0),(351196,9756,'fi','Sovelluksen tyyppi',0),(351197,9756,'no','Programtypen',0),(351198,9756,'da','Programtype',0),(351199,9756,'ko','ì‘ìš© í”„ë¡œê·¸ëž¨ ì¢…ë¥˜',0),(351200,9756,'he','×¡×•×’ ×™×™×©×•×',0),(351201,9756,'el','Î¤ÏÏ€Î¿Ï‚ ÎµÏ†Î±ÏÎ¼Î¿Î³Î®Ï‚',0),(351202,9756,'zh','åº”ç”¨ç±»åž‹\r\n',0),(351203,9756,'sv','Typ av ansÃ¶kan',0),(351204,9756,'it','Tipo di applicazione',0),(351205,9756,'tl','',0),(351206,9756,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3585;&#3634;&#3619;&#3626;&#3617;&#3633;&#3588;&#3619;&#3591;&#3634;&#3609;',0),(351207,9756,'hi','à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤— à¤•à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(351208,9756,'ms','Jenis aplikasi',0),(351209,9756,'ar','Ù†ÙˆØ¹ Ø§Ù„ØªØ·Ø¨ÙŠÙ‚',0),(351210,9756,'fr','Type dâ€™application',0),(351211,9756,'jp','ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã®ç¨®é¡ž',0),(351212,9756,'pt','Tipo de aplicativo',0),(351213,9756,'ru','Ð¢Ð¸Ð¿ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(351214,9756,'es','Tipo de AplicaciÃ³n',0),(351215,9756,'de','Anwendungstyp',0),(351216,9756,'en','Application Type',0),(351217,9757,'is','',0),(351218,9757,'dr','ÙØ¹Ù„Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(351219,9757,'pr','ÙØ¹Ù„Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(351220,9757,'tr','Åžu anda umudu kaydedilen',0),(351221,9757,'pl','Aktualnie zapisane jako perspektywa',0),(351222,9757,'bg','Ð’ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ð·Ð°Ð¿Ð¸ÑÐ²Ð° ÐºÐ°Ñ‚Ð¾ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(351223,9757,'ur','ÙÛŒ Ø§Ù„Ø­Ø§Ù„ Ø§Ù…Ú©Ø§Ù† Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù…Ø­ÙÙˆØ¸',0),(351224,9757,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ñ‡ÑƒÐ²Ð° ÐºÐ°Ð¾ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(351225,9757,'vi','gáº§n nhÆ° Ä‘Ã£ lÆ°u háº¿t',0),(351226,9757,'af','Huidiglik Gestoor as Voornemende KliÃ«nt',0),(351227,9757,'ro','ÃŽn prezent salvat ca perspectiva',0),(351228,9757,'et','Praegu salvestada vÃ¤ljavaade',0),(351229,9757,'si','Trenutno shranjene kot moÅ¾nost',0),(351230,9757,'ba','Saat ini disimpan sebagai prospek',0),(351231,9757,'nl','Op dit moment opgeslagen als vooruitzicht',0),(351232,9757,'fi','TÃ¤llÃ¤ hetkellÃ¤ tallentaa mahdollisuus',0),(351233,9757,'no','Er lagret som prospektet',0),(351234,9757,'da','Aktuelt er gemt som udsigten',0),(351235,9757,'ko','í˜„ìž¬ ì „ë§ìœ¼ë¡œ ì €ìž¥',0),(351236,9757,'he','×›×™×•× × ×©×ž×¨ ×›×ž×• ×¤×¨×•×¡×¤×§×˜',0),(351237,9757,'el','Î‘Ï…Ï„Î®Î½ Ï„Î· ÏƒÏ„Î¹Î³Î¼Î® Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Î¼Î­Î½Î¿ Ï‰Ï‚ Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ®',0),(351238,9757,'zh','ç›®å‰å‚¨å­˜çš„å±•æœ›\r\n',0),(351239,9757,'sv','FÃ¶r nÃ¤rvarande sparas som Prospect',0),(351240,9757,'it','Attualmente salvati come prospettiva',0),(351241,9757,'tl','',0),(351242,9757,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3650;&#3629;&#3585;&#3634;&#3626;&#3651;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(351243,9757,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(351244,9757,'ms','Pada masa ini disimpan sebagai prospek',0),(351245,9757,'ar','Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø© Ø­Ø§Ù„ÙŠØ§ ÙƒØ§Ø­ØªÙ…Ø§Ù„',0),(351246,9757,'fr','Actuellement enregistrÃ©s en tant que Prospect',0),(351247,9757,'jp','ç¾åœ¨ã®è¦‹é€šã—ã¨ã—ã¦ä¿å­˜',0),(351248,9757,'pt','Atualmente salvo como perspectiva',0),(351249,9757,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ ÑÐ¾Ñ…Ñ€Ð°Ð½ÑÐµÑ‚ÑÑ ÐºÐ°Ðº Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(351250,9757,'es','Actualmente Guardado como Prospecto',0),(351251,9757,'de','Derzeit als Prospect gespeichert',0),(351252,9757,'en','Currently Saved as Prospect',0),(351253,9758,'is','',0),(351254,9758,'dr','( Ø¯Ø± Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ )  ÙØ¹Ù„ÙŠ ',0),(351255,9758,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ ( Ø¯Ø± Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ )  ÙØ¹Ù„ÙŠ ',0),(351256,9758,'tr','Mevcut uygulamalar',0),(351257,9758,'pl','BieÅ¼Ä…cy aplikacje',0),(351258,9758,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(351259,9758,'ur','Ø­Ø§Ù„ÛŒÛ Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù†Ø²',0),(351260,9758,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(351261,9758,'vi','Ä‘Æ¡n hiá»‡n nay',0),(351262,9758,'af','Huidige Programme',0),(351263,9758,'ro','Cererile de curent',0),(351264,9758,'et','Praegused rakendused',0),(351265,9758,'si','Prijave',0),(351266,9758,'ba','Aplikasi saat ini',0),(351267,9758,'nl','Huidige toepassingen',0),(351268,9758,'fi','Nykyisten sovellusten',0),(351269,9758,'no','Aktuelle applikasjoner',0),(351270,9758,'da','NuvÃ¦rende programmer',0),(351271,9758,'ko','í˜„ìž¬ ì‘ìš© í”„ë¡œê·¸ëž¨',0),(351272,9758,'he','×”×™×™×©×•×ž×™× ×”× ×•×›×—×™',0),(351273,9758,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎµÏ‚ ÎµÏ†Î±ÏÎ¼Î¿Î³Î­Ï‚',0),(351274,9758,'zh','å½“å‰åº”ç”¨\r\n',0),(351275,9758,'sv','Aktuella program',0),(351276,9758,'it','Applicazioni correnti',0),(351277,9758,'tl','',0),(351278,9758,'th','&#3649;&#3629;&#3614;&#3614;&#3621;&#3636;&#3648;&#3588;&#3594;&#3633;&#3656;&#3609;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(351279,9758,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤—',0),(351280,9758,'ms','Aplikasi semasa',0),(351281,9758,'ar','Ø§Ù„ØªØ·Ø¨ÙŠÙ‚Ø§Øª Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(351282,9758,'fr','Applications actuelles',0),(351283,9758,'jp','ç¾åœ¨ã®ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(351284,9758,'pt','AplicaÃ§Ãµes atuais',0),(351285,9758,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(351286,9758,'es','Aplicaciones Actuales',0),(351287,9758,'de','Aktuelle Anwendungen',0),(351288,9758,'en','Current Applications',0),(351289,9759,'is','',0),(351290,9759,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ ',0),(351291,9759,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ ',0),(351292,9759,'tr','GeÃ§erli kiralamalar',0),(351293,9759,'pl','Aktualnych umÃ³w leasingu',0),(351294,9759,'bg','ÐÐ°ÑÑ‚Ð¾ÑÑ‰Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð²Ð¸ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð¸',0),(351295,9759,'ur','Ø­Ø§Ù„ÛŒÛ Ù„ÙÛŒØ²Ø²',0),(351296,9759,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(351297,9759,'vi','Ä‘ang thuÃª hiá»‡n nay',0),(351298,9759,'af','Huidige Huurkontrakte',0),(351299,9759,'ro','Contractele de Ã®nchiriere curent',0),(351300,9759,'et','Praegune rent',0),(351301,9759,'si','ObstojeÄih najemov',0),(351302,9759,'ba','Sekarang sewa',0),(351303,9759,'nl','Huidige lease-overeenkomsten',0),(351304,9759,'fi','Vuokrasopimuksiin',0),(351305,9759,'no','Gjeldende leieavtaler',0),(351306,9759,'da','NuvÃ¦rende lejemÃ¥l',0),(351307,9759,'ko','í˜„ìž¬ ìž„ëŒ€',0),(351308,9759,'he','×—×›×™×¨×” × ×•×›×—×™',0),(351309,9759,'el','ÎœÎ¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(351310,9759,'zh','çŽ°æœ‰ç§Ÿèµ\r\n',0),(351311,9759,'sv','LÃ¶pande hyresavtal',0),(351312,9759,'it','Contratti di locazione attuale',0),(351313,9759,'tl','',0),(351314,9759,'th','&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(351315,9759,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚',0),(351316,9759,'ms','Pajakan semasa',0),(351317,9759,'ar','Ø¹Ù‚ÙˆØ¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(351318,9759,'fr','Actuel des baux',0),(351319,9759,'jp','ç¾åœ¨ã®ãƒªãƒ¼ã‚¹',0),(351320,9759,'pt','Atuais locaÃ§Ãµes',0),(351321,9759,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(351322,9759,'es','Arrendamientos Actuales',0),(351323,9759,'de','Aktuelle MietvertrÃ¤ge',0),(351324,9759,'en','Current Leases',0),(351325,9760,'is','',0),(351326,9760,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ùˆ  ÙˆÙŠØ±Ø§ÙŠØ´ Ù…Ø³ØªØ§Ø¬Ø±ÙŠÙ† Ùˆ  Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§',0),(351327,9760,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ùˆ  ÙˆÙŠØ±Ø§ÙŠØ´ Ù…Ø³ØªØ§Ø¬Ø±ÙŠÙ† Ùˆ  Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§',0),(351328,9760,'tr','GÃ¶rÃ¼ntÃ¼leyin ve kiracÄ± ve umutlarÄ± dÃ¼zenleyin.',0),(351329,9760,'pl','WyÅ›wietlanie i edytowanie najemcÃ³w i perspektyw.',0),(351330,9760,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»Ð¸ Ð¸ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð¸.',0),(351331,9760,'ur','Ø¯ÛŒÚ©Ú¾ÛŒÚº Ø§ÙˆØ± Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±ÙˆÚº Ø§ÙˆØ± Ø§Ù…Ú©Ø§Ù†Ø§Øª Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ… Ú©Ø±ÛŒÚº Û”',0),(351332,9760,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¸ ÑƒÑ€ÐµÐ´Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð½Ð°Ñ€Ðµ Ð¸ Ð¸Ð·Ð³Ð»ÐµÐ´Ð¸Ð¼Ð°.',0),(351333,9760,'vi','xem xÃ©t vÃ  chá»‰nh sá»­a nhÃ¢n tá»‘ vÃ  hoÃ n cáº£nh',0),(351334,9760,'af','Besigtig en redigeer Huurders en Voornemendes.',0),(351335,9760,'ro','VizualizaÈ›i È™i editaÈ›i chiriaÅŸilor ÅŸi perspectivele.',0),(351336,9760,'et','Saate vaadata ja redigeerida Ã¼Ã¼rnikele ja vÃ¤ljavaateid.',0),(351337,9760,'si','Ogled in urejanje najemnikov in moÅ¾nosti.',0),(351338,9760,'ba','Lihat dan edit penyewa dan prospek.',0),(351339,9760,'nl','Bekijken en bewerken van huurders en vooruitzichten.',0),(351340,9760,'fi','Tarkastele ja Muokkaa vuokralaisten ja nÃ¤kymiÃ¤.',0),(351341,9760,'no','Vis og Rediger leietakere og prospekter.',0),(351342,9760,'da','FÃ¥ vist og Rediger lejere og udsigter.',0),(351343,9760,'ko','ë³´ê¸° ë° íŽ¸ì§‘ ê±°ì£¼ìž ë° ìž ìž¬ ê³ ê°.',0),(351344,9760,'he','×”×¦×’×” ×•×¢×¨×™×›×” ×©×œ ×”×“×™×™×¨×™× ×•×”×¡×™×›×•×™×™×.',0),(351345,9760,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎºÎ±Î¹ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„Ï‰Î½ ÎµÎ½Î¿Î¹ÎºÎ¹Î±ÏƒÏ„ÏŽÎ½ ÎºÎ±Î¹ Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ­Ï‚.',0),(351346,9760,'zh','åŽå°ç®¡ç†ä½æˆ·é¡»çŸ¥\r\n',0),(351347,9760,'sv','Visa och redigera hyresgÃ¤ster och framtidsutsikter.',0),(351348,9760,'it','Visualizzare e modificare gli inquilini e prospettive.',0),(351349,9760,'tl','',0),(351350,9760,'th','&#3604;&#3641;&#3649;&#3621;&#3632;&#3649;&#3585;&#3657;&#3652;&#3586; &#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;&#3649;&#3621;&#3632;&#3648;&#3611;&#3657;&#3634;&#3627;&#3617;&#3634;&#3618;',0),(351351,9760,'hi','à¤¦à¥‡à¤–à¤¨à¥‡ à¤”à¤° à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°à¥‹à¤‚ à¤”à¤° à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾à¤“à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚à¥¤',0),(351352,9760,'ms','Lihat dan edit penyewa dan prospek.',0),(351353,9760,'ar','Ø¹Ø±Ø¶ ÙˆØªØ­Ø±ÙŠØ± Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±ÙŠÙ† ÙˆØ§Ù„ØªÙˆÙ‚Ø¹Ø§Øª.',0),(351354,9760,'fr','Affichez et modifiez des locataires et des perspectives.',0),(351355,9760,'jp','è¡¨ç¤ºãŠã‚ˆã³ç·¨é›†ã®ãƒ†ãƒŠãƒ³ãƒˆã¨ã®è¦‹é€šã—ã€‚',0),(351356,9760,'pt','Visualizar e editar os inquilinos e perspectivas.',0),(351357,9760,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð¾Ð² Ð¸ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ñ‹.',0),(351358,9760,'es','Visionar y editar Inquilinos y Clientes Potenciales',0),(351359,9760,'de','Anzeigen und Bearbeiten von Mietern und Interessenten.',0),(351360,9760,'en','View and edit Tenants and Prospects.',0),(351361,9761,'is','',0),(351362,9761,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ù…Ù…ØªØ§Ø² ',0),(351363,9761,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ù…Ù…ØªØ§Ø² ',0),(351364,9761,'tr','Tercih edilen alan',0),(351365,9761,'pl','Preferowany obszar',0),(351366,9761,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ Ñ€Ð°Ð¹Ð¾Ð½',0),(351367,9761,'ur','ØªØ±Ø¬ÛŒØ­ÛŒ Ø¹Ù„Ø§Ù‚Û’',0),(351368,9761,'sr','Ð–ÐµÑ™ÐµÐ½Ð¸Ñ… Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(351369,9761,'vi','VÃ¹ng Æ°a thÃ­ch',0),(351370,9761,'af','Verkiesde Area',0),(351371,9761,'ro','ZonÄƒ preferatÄƒ',0),(351372,9761,'et','Piirkondadest',0),(351373,9761,'si','Raje obmoÄje',0),(351374,9761,'ba','Pilihan Area',0),(351375,9761,'nl','Gewenste ruimte',0),(351376,9761,'fi','Haluamasi alue',0),(351377,9761,'no','Foretrukne omrÃ¥det',0),(351378,9761,'da','Foretrukne omrÃ¥de',0),(351379,9761,'ko','ì„ í˜¸ ì§€ì—­',0),(351380,9761,'he','××–×•×¨ ×ž×•×¢×“×£',0),(351381,9761,'el','Î ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(351382,9761,'zh','é¦–é€‰åœ°åŒº\r\n',0),(351383,9761,'sv','Rekommenderad Area',0),(351384,9761,'it','Zona preferita',0),(351385,9761,'tl','',0),(351386,9761,'th','&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(351387,9761,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(351388,9761,'ms','Kawasan pilihan',0),(351389,9761,'ar','Ø§Ù„Ù…Ø¬Ø§Ù„ Ø§Ù„Ù…ÙØ¶Ù„',0),(351390,9761,'fr','Secteur prÃ©fÃ©rÃ©',0),(351391,9761,'jp','æœ€å¯„ã‚Šã®ã‚¨ãƒªã‚¢',0),(351392,9761,'pt','Ãrea preferencial',0),(351393,9761,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ñ€Ð°Ð¹Ð¾Ð½',0),(351394,9761,'es','Ãrea Preferida',0),(351395,9761,'de','Bevorzugte Gegend',0),(351396,9761,'en','Preferred Area',0),(351397,9762,'is','',0),(351398,9762,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø³ØªØ§Ø¬Ø± ',0),(351399,9762,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø³ØªØ§Ø¬Ø± ',0),(351400,9762,'tr','KiracÄ± bilgileri',0),(351401,9762,'pl','NajemcÃ³w informacje',0),(351402,9762,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(351403,9762,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(351404,9762,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(351405,9762,'vi','ThÃ´ng tin ngÆ°á»i thuÃª nhÃ ',0),(351406,9762,'af','Huurder Inligting ',0),(351407,9762,'ro','ChiriaÅŸ informaÅ£ii',0),(351408,9762,'et','Rentniku info',0),(351409,9762,'si','Najemnik informacije',0),(351410,9762,'ba','Penyewa informasi',0),(351411,9762,'nl','Huurder informatie',0),(351412,9762,'fi','Vuokralainen tiedot',0),(351413,9762,'no','Leietaker informasjon',0),(351414,9762,'da','Lejeren Information',0),(351415,9762,'ko','ê±°ì£¼ìž ì •ë³´',0),(351416,9762,'he','×”×“×™×™×¨ ×ž×™×“×¢',0),(351417,9762,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(351418,9762,'zh','ç§Ÿæˆ·ä¿¡æ¯\r\n',0),(351419,9762,'sv','HyresgÃ¤st-Information',0),(351420,9762,'it','Informazioni inquilino',0),(351421,9762,'tl','',0),(351422,9762,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;',0),(351423,9762,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(351424,9762,'ms','Maklumat penyewa',0),(351425,9762,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(351426,9762,'fr','Information du locataire',0),(351427,9762,'jp','ãƒ†ãƒŠãƒ³ãƒˆæƒ…å ±',0),(351428,9762,'pt','InformaÃ§Ãµes de inquilino',0),(351429,9762,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(351430,9762,'es','informaciÃ³n de Inquilino',0),(351431,9762,'de','Mieter-Informationen',0),(351432,9762,'en','Tenant Information',0),(351433,9763,'is','',0),(351434,9763,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø³ØªØ§Ø¬Ø± ',0),(351435,9763,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø³ØªØ§Ø¬Ø± ',0),(351436,9763,'tr','KiracÄ± bilgi yardÄ±m',0),(351437,9763,'pl','DzierÅ¼awcy informacje pomocy',0),(351438,9763,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(351439,9763,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø¯Ø¯',0),(351440,9763,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸',0),(351441,9763,'vi','NgÆ°á»i thuÃª nhÃ  thÃ´ng tin trá»£ giÃºp',0),(351442,9763,'af','Huurder Inligting Hulp',0),(351443,9763,'ro','Ajutor de informaÅ£ii chiriaÅŸ',0),(351444,9763,'et','Rentniku info abi',0),(351445,9763,'si','Najemnik informacije pomoÄ',0),(351446,9763,'ba','Penyewa informasi bantuan',0),(351447,9763,'nl','Huurder informatiehulp',0),(351448,9763,'fi','Vuokralainen ohje',0),(351449,9763,'no','Leietaker informasjon hjelp',0),(351450,9763,'da','Lejeren Information hjÃ¦lp',0),(351451,9763,'ko','ê±°ì£¼ìž ì •ë³´ ë„ì›€ë§',0),(351452,9763,'he','×”×“×™×™×¨ ×ž×™×“×¢ ×¢×–×¨×”',0),(351453,9763,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î®Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ Î²Î¿Î®Î¸ÎµÎ¹Î±Ï‚',0),(351454,9763,'zh','ç§Ÿæˆ·ä¿¡æ¯å¸®åŠ©\r\n',0),(351455,9763,'sv','HyresgÃ¤st Information hjÃ¤lp',0),(351456,9763,'it','Aiuto informazioni inquilino',0),(351457,9763,'tl','',0),(351458,9763,'th','&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;',0),(351459,9763,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¤¦à¤¦',0),(351460,9763,'ms','Bantuan maklumat penyewa',0),(351461,9763,'ar','ØªØ³Ø§Ø¹Ø¯ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(351462,9763,'fr','Aide Information locataire',0),(351463,9763,'jp','ãƒ†ãƒŠãƒ³ãƒˆæƒ…å ±ãƒ˜ãƒ«ãƒ—',0),(351464,9763,'pt','Inquilino informaÃ§Ãµes ajuda',0),(351465,9763,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð°Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒ',0),(351466,9763,'es','Ayuda de InformaciÃ³n de Inquilino',0),(351467,9763,'de','Mieter-Informationen-Hilfe',0),(351468,9763,'en','Tenant Information Help',0),(351469,9764,'is','',0),(351470,9764,'dr',': ØªØºÙŠÙŠØ± Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ù…Ø³ØªØ§Ø¬Ø± Ù†Ø§Ù… ÛŒÙˆØ²Ø±ÙŠ ÙƒÙ‡ Ø¢Ù†Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†Ù†Ø¯ Ø±Ø§ ØªØºÙŠÙŠØ± Ø®Ùˆ',0),(351471,9764,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø³ØªØ§Ø¬Ø± ØªØºÙŠÙŠØ± Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ â€“ Ø§Ø®Ø·Ø§Ø±â€Œ: ØªØºÙŠÙŠØ± Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ Ù…Ø³ØªØ§Ø¬Ø± Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ ÙƒÙ‡ Ø¢Ù†Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†Ù†Ø¯ Ø±Ø§ ØªØºÙŠÙŠØ± Ø®ÙˆØ',0),(351472,9764,'tr','<b>UyarÄ±:</b> KiracÄ± e-posta adresini deÄŸiÅŸtirme-ecek deÄŸiÅŸmek iÃ§in kullandÄ±klarÄ± kullanÄ±cÄ± adÄ± oturum aÃ§ma.',0),(351473,9764,'pl','<b>OstrzeÅ¼enie:</b> Zmiana adresu E-mail najemcy zmieni nazwÄ™ uÅ¼ytkownika korzystajÄ… z logowania.',0),(351474,9764,'bg','<b>ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ:</b> ÐŸÑ€Ð¾Ð¼ÑÐ½Ð°Ñ‚Ð° Ð½Ð° Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ Ñ‰Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾Ñ‚Ð¾ Ð¸Ð¼Ðµ, Ñ‚Ðµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ Ð·Ð° Ð²Ñ…Ð¾Ð´.',0),(351475,9764,'ur','<b>ØªÙ†Ø¨ÛŒÛ:</b> Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±ÙˆÚº Ú©Û’ Ù„Û“ Ø§ÛŒ Ù…ÛŒÙ„ Ù¾ØªÛ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Ø§ ÛÙˆÚ¯Ø§ ÙˆÛ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Û’ Ù„ÛŒÛ’ ØµØ§Ø±Ù Ù†Ø§Ù… ØªØ¨Ø¯ÛŒÙ„ Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº Û”',0),(351476,9764,'sr','<b>Ð£Ð¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ:</b> ÐœÐµÑšÐ°ÑšÐµ ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸ Ð•Ð¼Ð°Ð¸Ð» Ð°Ð´Ñ€ÐµÑÑƒ Ñ›Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ðµ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ.',0),(351477,9764,'vi','<b>Cáº£nh bÃ¡o:</b> Thay Ä‘á»•i Ä‘á»‹a chá»‰ Email cá»§a ngÆ°á»i thuÃª nhÃ  sáº½ thay Ä‘á»•i tÃªn ngÆ°á»i dÃ¹ng, há» sá»­ dá»¥ng Ä‘á»ƒ Ä‘Äƒng nháº­p.',0),(351478,9764,'af','<b>Warning:</b> Deur die Huurder se E-pos te verander, sal ook die Gebruikernaam verander wat hul gebruik om aan te teken.',0),(351479,9764,'ro','<b>Avertisment:</b> Schimbarea adresei de E-mail chiriasi va schimba numele de utilizator pe care le folosesc pentru a login.',0),(351480,9764,'et','<b>Hoiatus:</b> Rentnike jaoks e-posti aadressi muutmine muudab nad kasutavad kasutajanime login.',0),(351481,9764,'si','<b>Opozorilo:</b> Najemniki e-poÅ¡tni naslov bo spremenite uporabniÅ¡ko ime, ki jih uporabljajo za prijavo.',0),(351482,9764,'ba','<b>Peringatan:</b> Mengubah alamat Email penyewa akan mengubah nama pengguna mereka gunakan untuk login.',0),(351483,9764,'nl','<b>Waarschuwing:</b> De huurders e-mailadres wijzigt, gelden de gebruikersnaam die ze om te gebruiken inloggen.',0),(351484,9764,'fi','<b>Varoitus:</b> Vuokralaisten sÃ¤hkÃ¶postiosoitteen vaihtaminen muuttaa kÃ¤yttÃ¤jÃ¤tunnuksen avulla he johdonmukaisuus.',0),(351485,9764,'no','<b>Advarsel:</b> Endre epostadressen leietakere vil endre brukernavnet de bruker til Ã¥ logge inn.',0),(351486,9764,'da','<b>Advarsel:</b> Skiftende lejere E-mail adresse vil Ã¦ndre brugernavnet de bruger til at logge ind.',0),(351487,9764,'ko','<b>ê²½ê³ :</b> ê±°ì£¼ìž ì´ë©”ì¼ ì£¼ì†Œë¥¼ ë³€ê²½ í•˜ëŠ” ê²ƒì´ ê·¸ë“¤ì„ ì‚¬ìš© í•˜ ì—¬ ì‚¬ìš©ìž ì´ë¦„ ë³€ê²½ ë©ë‹ˆë‹¤ ë¡œê·¸ì¸.',0),(351488,9764,'he','<b>××–×”×¨×”:</b> ×œ×©× ×•×ª ××ª ×›×ª×•×‘×ª ×”×“×•× ×©×œ ×”×“×™×™×¨×™× ×™×”×™×” ×œ×©× ×•×ª ××ª ×©× ×”×ž×©×ª×ž×© ×•×”×¡×™×¡×ž×” ×”× ×ž×©×ª×ž×©×™× ×›×“×™ ×›× ×™×¡×”.',0),(351489,9764,'el','<b>Î ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·:</b> Î‘Î»Î»Î±Î³Î® Ï„Î·Ï‚ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·Ï‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Ï„Î¿Ï…Ï‚ Î¼Î¹ÏƒÎ¸Ï‰Ï„Î­Ï‚ Î¸Î± Î±Î»Î»Î¬Î¾ÎµÎ¹ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½ Î³Î¹Î± Î½Î± ÏƒÏ…Î½Î´',0),(351490,9764,'zh','<b>è­¦å‘Šï¼šæ›´æ”¹ç”µå­é‚®ä»¶åœ°å€çš„ä½æˆ·å°†æ”¹å˜\r\n',0),(351491,9764,'sv','<b>Varning:</b> Om du Ã¤ndrar e-postadressen som hyresgÃ¤ster kommer det anvÃ¤ndarnamn som de anvÃ¤nder fÃ¶r att logga in.',0),(351492,9764,'it','<b>Avviso:</b> Modifica dell\'indirizzo di posta elettronica di inquilini cambierÃ  il nome utente che utilizzano per account di accesso.',0),(351493,9764,'tl','',0),(351494,9764,'th','<b>Warning:</b> Changing the Tenants Email Address will change the Username they use to login.',0),(351495,9764,'hi','<b>à¤šà¥‡à¤¤à¤¾à¤µà¤¨à¥€:</b> à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°à¥‹à¤‚ à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤µà¥‡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¦à¤² à¤œà¤¾à¤à¤—à¤¾ à¤ªà¥à¤°à¤µà',0),(351496,9764,'ms','<b>Amaran:</b> Menukar alamat e-mel penyewa akan menukar nama pengguna mereka gunakan untuk log masuk.',0),(351497,9764,'ar','<b>ØªØ­Ø°ÙŠØ±:</b> ØªØºÙŠÙŠØ± \"Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±ÙŠÙ†\" Ø³ÙŠØªÙ… ØªØºÙŠÙŠØ± Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„ØªÙŠ ÙŠØ³ØªØ®Ø¯Ù…ÙˆÙ†Ù‡Ø§ Ù„ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„.',0),(351498,9764,'fr','<b>AvertissementÂ :</b> Modification de lâ€™adresse de courriel de locataires va changer le nom dâ€™utilisateur quâ€™ils utilisent pour se connecter.',0),(351499,9764,'jp','<b>è­¦å‘Š:</b>å…¥å±…è€…ã®ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ãŒå¤‰æ›´ã•ã‚Œã¾ã™ã¨ãƒ¦ãƒ¼ã‚¶ãƒ¼åã‚’ä½¿ç”¨ã—ã¦ãƒ­ã‚°ã‚¤ãƒ³ã—ã¾ã™ã€‚',0),(351500,9764,'pt','<b>AVISO:</b> Alterar o endereÃ§o de E-mail de inquilinos vai mudar o nome de usuÃ¡rio que eles usam para logon.',0),(351501,9764,'ru','<b>ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ:</b> Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð°Ð´Ñ€ÐµÑÐ° ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð¾Ð² Ð±ÑƒÐ´ÐµÑ‚ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¸Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ, Ð¾Ð½Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑŽÑ‚ Ð´Ð»Ñ Ð²Ñ…Ð¾Ð´Ð°.',0),(351502,9764,'es','<b>Aviso:</b> Cambiando la DirecciÃ³n de Email cambiarÃ¡ el Nombre de Usuario de Login',0),(351503,9764,'de','<b>Warnung:</b> Die Mieter e-Mail-Adresse Ã¤ndern, Ã¤ndert die Benutzernamen, die sie, um verwenden Anmeldung.',0),(351504,9764,'en','<b>Warning:</b> Changing the Tenants Email Address will change the Username they use to login.',0),(351505,9765,'is','',0),(351506,9765,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø³ØªØ§Ø¬Ø± Ù†Ø§Ù… Ù…ÙŠØ§Ù†ÙŠ â€“ ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ù‡ Ø¬Ø² Ù†Ø§Ù… Ù…ÙŠØ§Ù†ÙŠ Ø²ÙŠØ± Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ \r\nØ¶Ø±ÙˆØ±ÙŠ Ù‡Ø³ØªÙ†Ø¯ \r\n',0),(351507,9765,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø³ØªØ§Ø¬Ø± Ù†Ø§Ù… Ù…ÙŠØ§Ù†ÙŠ â€“ ØªÙ…Ø§Ù… ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ù‡ Ø¬Ø² Ù†Ø§Ù… Ù…ÙŠØ§Ù†ÙŠ Ø²ÙŠØ± Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ \r\nØ¶Ø±ÙˆØ±ÙŠ Ù‡Ø³ØªÙ†Ø¯ \r\n',0),(351508,9765,'tr','GÃ¶bek adÄ± altÄ±nda iletiÅŸim bilgileri dÄ±ÅŸÄ±ndaki tÃ¼m alanlar gereklidir.',0),(351509,9765,'pl','Wszystkie pola z wyjÄ…tkiem imienia pod informacje kontaktowe sÄ… wymagane.',0),(351510,9765,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° Ñ Ð¸Ð·ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ Ð½Ð° Ð±Ð°Ñ‰Ð¸Ð½Ð¾ Ð¸Ð¼Ðµ Ð¿Ð¾Ð´ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ ÑÐ° Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸.',0),(351511,9765,'ur','Ø³ÙˆØ§Ø¦Û’ Ø¯Ø±Ù…ÛŒØ§Ù†ÛŒ Ù†Ø§Ù… Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ ØªØ­Øª ØªÙ…Ø§Ù… Ù‚Ø·Ø¹Ø§Øª Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(351512,9765,'sr','Ð¡Ð²Ð° Ð¿Ð¾Ñ™Ð° Ð¾ÑÐ¸Ð¼ ÑÑ€ÐµÐ´ÑšÐµ Ð¸Ð¼Ðµ Ð¿Ð¾Ð´ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ ÑÑƒ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ.',0),(351513,9765,'vi','Táº¥t cáº£ cÃ¡c trÆ°á»ng ngoáº¡i trá»« tÃªn Ä‘á»‡m trong thÃ´ng tin liÃªn láº¡c Ä‘Æ°á»£c yÃªu cáº§u.',0),(351514,9765,'af','Alle velde buiten vir Tweede Naam onder Kontak Inligting word benodig.',0),(351515,9765,'ro','Toate cÃ¢mpurile cu excepÅ£ia Prenume Ã®n conformitate cu informaÅ£iile de Contact sunt obligatorii.',0),(351516,9765,'et','VÃ¤lja arvatud Keskmine nimi, Kontakt andmed kÃµik vÃ¤ljad on kohustuslikud.',0),(351517,9765,'si','Je treba vsa polja razen drugo ime pod Kontakt.',0),(351518,9765,'ba','Semua kecuali nama tengah di bawah informasi kontak harus diisi.',0),(351519,9765,'nl','Alle velden met uitzondering van de middelste naam onder contactinformatie zijn vereist.',0),(351520,9765,'fi','Kaikki kentÃ¤t lukuun ottamatta toinen nimi alle Yhteystiedot tarvitaan.',0),(351521,9765,'no','Alle felt unntatt mellomnavn under kontaktinformasjon er nÃ¸dvendig.',0),(351522,9765,'da','Alle felter undtagen mellemnavn under kontaktoplysninger er pÃ¥krÃ¦vet.',0),(351523,9765,'ko','ì—°ë½ì²˜ ì •ë³´ì—ì„œ ì¤‘ê°„ ì´ë¦„ ì œì™¸í•œ ëª¨ë“  í•„ë“œëŠ” í•„ìˆ˜ìž…ë‹ˆë‹¤.',0),(351524,9765,'he','×›×œ ×”×©×“×•×ª ×ž×œ×‘×“ ×”×©× ×”××ž×¦×¢×™ ×ª×—×ª ×¤×¨×˜×™ ×× ×©×™ ×”×§×©×¨ × ×“×¨×©×™×.',0),(351525,9765,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹ ÏŒÎ»Î± Ï„Î± Ï€ÎµÎ´Î¯Î± ÎµÎºÏ„ÏŒÏ‚ Î±Ï€ÏŒ Ï„Î¿ Î¼ÎµÏƒÎ±Î¯Î¿ ÏŒÎ½Î¿Î¼Î± Ï…Ï€ÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚.',0),(351526,9765,'zh','é™¤äº†ä¸­ä¸œè”ç³»ä¿¡æ¯åç§°æ˜¯æ ¹æ®æ‰€æœ‰å­—æ®µ\r\n',0),(351527,9765,'sv','Alla fÃ¤lt utom mellannamn enligt kontaktuppgifter Ã¤r obligatoriska.',0),(351528,9765,'it','Tutti i campi ad eccezione di secondo nome in informazioni di contatto sono necessari.',0),(351529,9765,'tl','',0),(351530,9765,'th','All fields except for Middle Name under Contact Information are required.',0),(351531,9765,'hi','à¤®à¤§à¥à¤¯ à¤¨à¤¾à¤® à¤¸à¤‚à¤ªà¤°à¥à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤…à¤‚à¤¤à¤°à¥à¤—à¤¤ à¤•à¥‹ à¤›à¥‹à¤¡à¤¼à¤•à¤° à¤¸à¤­à¥€ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¤‚à¥¤',0),(351532,9765,'ms','Semua bidang kecuali nama tengah di bawah maklumat orang hubungan yang diperlukan.',0),(351533,9765,'ar','ÙƒØ§ÙØ© Ø§Ù„Ø­Ù‚ÙˆÙ„ ÙÙŠÙ…Ø§ Ø¹Ø¯Ø§ Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆØ³Ø· ØªØ­Øª \"Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„\" Ù…Ø·Ù„ÙˆØ¨Ø©.',0),(351534,9765,'fr','Les champs Ã  lâ€™exception du prÃ©nom sous les informations de Contact sont obligatoires.',0),(351535,9765,'jp','é€£çµ¡å…ˆæƒ…å ±ã®ä¸‹ã§ãƒŸãƒ‰ãƒ«ãƒãƒ¼ãƒ ã‚’é™¤ãã™ã¹ã¦ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ãŒå¿…è¦ã§ã™ã€‚',0),(351536,9765,'pt','Todos os campos exceto nome do meio em informaÃ§Ãµes de contato sÃ£o necessÃ¡rios.',0),(351537,9765,'ru','Ð’ÑÐµ Ð¿Ð¾Ð»Ñ, Ð·Ð° Ð¸ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ÐµÐ¼ Ð¾Ñ‚Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ.',0),(351538,9765,'es','Todos los Campos Aparte de Segundo Nombre Bajo InformaciÃ³n de Contacto se Requieren',0),(351539,9765,'de','Alle Felder mit Ausnahme der zweiten Vornamen unter Kontaktinformationen sind erforderlich.',0),(351540,9765,'en','All fields except for Middle Name under Contact Information are required.',0),(351541,9766,'is','',0),(351542,9766,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø³ØªØ§Ø¬Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(351543,9766,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø³ØªØ§Ø¬Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(351544,9766,'tr','KiracÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(351545,9766,'pl','DzierÅ¼awcy pomyÅ›lnie zaktualizowana',0),(351546,9766,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(351547,9766,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(351548,9766,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(351549,9766,'vi','NgÆ°á»i thuÃª nhÃ  cáº­p nháº­t thÃ nh cÃ´ng',0),(351550,9766,'af','Huurder Suksesvol Opdateer',0),(351551,9766,'ro','ChiriaÅŸ actualizat cu succes',0),(351552,9766,'et','Rentniku uuendamine Ãµnnestus',0),(351553,9766,'si','Najemnik, ki je uspeÅ¡no posodobljena',0),(351554,9766,'ba','Penyewa yang berhasil',0),(351555,9766,'nl','Huurder bijgewerkt',0),(351556,9766,'fi','Vuokralainen pÃ¤ivitetty',0),(351557,9766,'no','Leietaker oppdatert',0),(351558,9766,'da','Lejer opdateret',0),(351559,9766,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì„¸ ìž…ìž',0),(351560,9766,'he','×”×“×™×™×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(351561,9766,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(351562,9766,'zh','ä¸šæƒäººå·²æˆåŠŸæ›´æ–°\r\n',0),(351563,9766,'sv','HyresgÃ¤st som uppdaterats',0),(351564,9766,'it','Inquilino aggiornato con successo',0),(351565,9766,'tl','',0),(351566,9766,'th','&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3618;&#3611;&#3619;&#3640;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(351567,9766,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(351568,9766,'ms','Penyewa yang berjaya dikemas kini',0),(351569,9766,'ar','Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(351570,9766,'fr','Locataire, mis Ã  jour avec succÃ¨s',0),(351571,9766,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸãƒ†ãƒŠãƒ³ãƒˆ',0),(351572,9766,'pt','Inquilino atualizado com sucesso',0),(351573,9766,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(351574,9766,'es','inquilino Actualizado Exitosamente',0),(351575,9766,'de','Mieter, die erfolgreich aktualisiert',0),(351576,9766,'en','Tenant Updated Successfully',0),(351577,9767,'is','',0),(351578,9767,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù†Ø§Ø­ÙŠÙ‡ Ù…Ø±Ø¬Ø¹  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(351579,9767,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù†Ø§Ø­ÙŠÙ‡ Ù…Ø±Ø¬Ø¹  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(351580,9767,'tr','LÃ¼tfen bir tercih edilen alan seÃ§in',0),(351581,9767,'pl','ProszÄ™ wybraÄ‡ preferowany obszar',0),(351582,9767,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ Ñ€Ð°Ð¹Ð¾Ð½',0),(351583,9767,'ur','Ø§ÛŒÚ© Ú©Ùˆ ØªØ±Ø¬ÛŒØ­ Ø¯ÛŒ Ø¹Ù„Ø§Ù‚Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(351584,9767,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¶ÐµÑ™ÐµÐ½Ðµ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(351585,9767,'vi','vui lÃ²ng chá»n vÃ¹ng tham kháº£o',0),(351586,9767,'af','Kies asseblief \'n Voorkeur Area',0),(351587,9767,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i o zonÄƒ preferatÄƒ',0),(351588,9767,'et','Palun vali eelistatud ala',0),(351589,9767,'si','Izberite raje obmoÄje',0),(351590,9767,'ba','Silakan pilih Area pilihan',0),(351591,9767,'nl','Kies een voorkeur',0),(351592,9767,'fi','Valitse ensisijainen alue',0),(351593,9767,'no','Velg en Ã¸nsket omrÃ¥de',0),(351594,9767,'da','VÃ¦lg et foretrukket omrÃ¥de',0),(351595,9767,'ko','ì›í•˜ëŠ” ì˜ì—­ì„ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(351596,9767,'he','×× × ×‘×—×¨ ××–×•×¨ ×ž×•×¢×“×£',0),(351597,9767,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Ï€ÎµÏÎ¹Î¿Ï‡Î® Î ÏÎ¿Ï„ÎµÎ¹Î½ÏŒÎ¼ÎµÎ½Ï‰Î½ ÎžÎµÎ½Î¿Î´Î¿Ï‡ÎµÎ¯Ï‰Î½',0),(351598,9767,'zh','è¯·é€‰æ‹©ä¸€ä¸ªé¦–é€‰åœ°åŒº\r\n',0),(351599,9767,'sv','VÃ¤nligen vÃ¤lj ett program omrÃ¥de',0),(351600,9767,'it','Si prega di selezionare una zona preferita',0),(351601,9767,'tl','',0),(351602,9767,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3648;&#3621;&#3639;&#3629;&#3585;&#3614;&#3639;&#3657;&#3609;&#3607;&#3637;&#3656;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3585;&#3634;&#3619;',0),(351603,9767,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(351604,9767,'ms','Sila pilih kawasan utama yang',0),(351605,9767,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ \"Ù…Ù†Ø·Ù‚Ø© Ø§Ù„Ù…ÙØ¶Ù„\"',0),(351606,9767,'fr','Veuillez sÃ©lectionner une zone prÃ©fÃ©rÃ©',0),(351607,9767,'jp','å¸Œæœ›ã®ã‚¨ãƒªã‚¢ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(351608,9767,'pt','Por favor, selecione uma Ã¡rea preferencial',0),(351609,9767,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°ÐµÐ¼Ñ‹Ð¹ Ñ€Ð°Ð¹Ð¾Ð½',0),(351610,9767,'es','Por Favor Selecciona Una Ãrea Preferida',0),(351611,9767,'de','Bitte wÃ¤hlen Sie eine bevorzugte Region',0),(351612,9767,'en','Please select a Preferred Area',0),(351613,9768,'is','',0),(351614,9768,'dr','(Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(351615,9768,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø³ØªÙˆØ± Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ(Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(351616,9768,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ uygulama talimatlarÄ±',0),(351617,9768,'pl','Zobacz instrukcje dotyczÄ…ce stosowania',0),(351618,9768,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(351619,9768,'ur','Ù…Ù†Ø¸Ø± Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù† ÛØ¯Ø§ÛŒØ§Øª',0),(351620,9768,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð·Ð° Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(351621,9768,'vi','Xem cáº¥u trÃºc á»©ng dá»¥ng',0),(351622,9768,'af','Besigtig Aansoek Instruksies',0),(351623,9768,'ro','InstrucÅ£iuni de aplicare Vezi',0),(351624,9768,'et','Vaade kasutamisjuhised',0),(351625,9768,'si','Navodila za uporabo pogled',0),(351626,9768,'ba','Lihat petunjuk aplikasi',0),(351627,9768,'nl','Bekijk toepassing instructies',0),(351628,9768,'fi','Katso hakuohjeet',0),(351629,9768,'no','Vis programinstruksjoner',0),(351630,9768,'da','Se ansÃ¸gning instruktioner',0),(351631,9768,'ko','ë³´ê¸° ì‘ìš© í”„ë¡œê·¸ëž¨ ì§€ì¹¨',0),(351632,9768,'he','×ª×¦×•×’×ª ×™×™×©×•× ×”×•×¨××•×ª',0),(351633,9768,'el','Î”ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚ ÎµÏ†Î±ÏÎ¼Î¿Î³Î®Ï‚',0),(351634,9768,'zh','æŸ¥çœ‹ç”³è¯·æŒ‡å¯¼\r\n',0),(351635,9768,'sv','Visa instruktioner fÃ¶r ansÃ¶kan',0),(351636,9768,'it','Visualizza le istruzioni di applicazione',0),(351637,9768,'tl','',0),(351638,9768,'th','&#3649;&#3626;&#3604;&#3591;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(351639,9768,'hi','à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤— à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶ à¤¦à¥‡à¤–à¥‡à¤‚',0),(351640,9768,'ms','Paparan arahan permohonan',0),(351641,9768,'ar','Ø¹Ø±Ø¶ ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø¥Ø±Ø´Ø§Ø¯Ø§Øª',0),(351642,9768,'fr','Vue de la pose',0),(351643,9768,'jp','ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã®èª¬æ˜Žæ›¸ã‚’è¦‹ã‚‹',0),(351644,9768,'pt','InstruÃ§Ãµes de aplicaÃ§Ã£o do vista',0),(351645,9768,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð¿Ð¾ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÐµÐ½Ð¸ÑŽ',0),(351646,9768,'es','Visiona Instrucciones de la Solicitud',0),(351647,9768,'de','Ansicht-Anwendungshinweise',0),(351648,9768,'en','View Application Instructions',0),(351649,9769,'is','',0),(351650,9769,'dr','Ø´Ù…Ø§ Ø¨Ù‡ Ø§ÙŠÙ† ÙØ§ÙŠÙ„ Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø¯Ø§Ø±ÙŠØ¯',0),(351651,9769,'pr','Ø´Ù…Ø§ Ø¨Ù‡ Ø§ÙŠÙ† ÙØ§ÙŠÙ„ Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø¯Ø§Ø±ÙŠØ¯',0),(351652,9769,'tr','Bu dosyaya eriÅŸemez.',0),(351653,9769,'pl','Nie masz dostÄ™pu do tego pliku.',0),(351654,9769,'bg','ÐÑÐ¼Ð°Ñ‚Ðµ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ñ‚Ð¾Ð·Ð¸ Ñ„Ð°Ð¹Ð».',0),(351655,9769,'ur','Ø¢Ù¾ Ù†Û’ Ø§Ø³ Ù…Ø³Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø±Ø³Ø§Ø¦ÛŒ Ú©Ø§ Ø­Ø§ØµÙ„ Ù†ÛÛŒÚº Û”',0),(351656,9769,'sr','ÐÐµÐ¼Ð°Ñ‚Ðµ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¾Ð²Ð¾Ñ˜ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸.',0),(351657,9769,'vi','Báº¡n khÃ´ng cÃ³ quyá»n truy cáº­p vÃ o táº­p tin nÃ y',0),(351658,9769,'af','U het nie toegang tot hierdie lÃªer nie',0),(351659,9769,'ro','Nu au acces la acest fisier.',0),(351660,9769,'et','Teil ei ole Ãµigusi selle faili avamiseks',0),(351661,9769,'si','Nimate dostopa do te datoteke.',0),(351662,9769,'ba','Anda tidak memiliki akses ke file ini.',0),(351663,9769,'nl','U hebt geen toegang tot dit bestand.',0),(351664,9769,'fi','Access ei tarvitse tÃ¤tÃ¤ tiedostoa.',0),(351665,9769,'no','Du har ikke tilgang til denne filen.',0),(351666,9769,'da','Du har ikke adgang til denne fil.',0),(351667,9769,'ko','ë‹¹ì‹ ì´ í•  í•„ìš”ê°€ ì—†ìŠµë‹ˆë‹¤ ì•¡ì„¸ìŠ¤ê°€ì´ íŒŒì¼.',0),(351668,9769,'he','.××™×Ÿ ×œ×š ×’×™×©×” ×œ×§×•×‘×¥ ×–×”',0),(351669,9769,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿.',0),(351670,9769,'zh','æ‚¨æ²¡æœ‰è®¿é—®æ­¤æ–‡ä»¶ã€‚\r\n',0),(351671,9769,'sv','Du har inte tillgÃ¥ng till denna fil.',0),(351672,9769,'it','Non avete accesso a questo file.',0),(351673,9769,'tl','',0),(351674,9769,'th','&#3588;&#3640;&#3603;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3652;&#3615;&#3621;&#3660;&#3609;&#3637;&#3657;&#3652;&#3604;&#3657;',0),(351675,9769,'hi','à¤†à¤ª à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¹à¥à¤à¤š à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(351676,9769,'ms','Anda tidak mempunyai capaian ke fail ini.',0),(351677,9769,'ar','Ù„ÙŠØ³ Ù„Ø¯ÙŠÙƒ Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ù…Ù„Ù.',0),(351678,9769,'fr','Vous nâ€™avez pas accÃ¨s Ã  ce fichier.',0),(351679,9769,'jp','ã“ã®ãƒ•ã‚¡ã‚¤ãƒ«ã¸ã®ã‚¢ã‚¯ã‚»ã‚¹ã‚’å¿…è¦ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(351680,9769,'pt','VocÃª nÃ£o tem acesso a esse arquivo.',0),(351681,9769,'ru','Ð£ Ð²Ð°Ñ Ð½ÐµÑ‚ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ðº ÑÑ‚Ð¾Ð¼Ñƒ Ñ„Ð°Ð¹Ð»Ñƒ.',0),(351682,9769,'es','No Tiene Acceso a este File',0),(351683,9769,'de','Sie kÃ¶nnen nicht auf diese Datei zugreifen.',0),(351684,9769,'en','You do not have access to this file.',0),(351685,9770,'is','',0),(351686,9770,'dr','Ù†Ø§Ø­ÙŠÙ‡',0),(351687,9770,'pr','Ù†Ø§Ø­ÙŠÙ‡',0),(351688,9770,'tr','Alan',0),(351689,9770,'pl','Obszar',0),(351690,9770,'bg','ÐŸÐ»Ð¾Ñ‰',0),(351691,9770,'ur','Ø¹Ù„Ø§Ù‚Û',0),(351692,9770,'sr','ÐžÐ±Ð»Ð°ÑÑ‚',0),(351693,9770,'vi','Khu vá»±c',0),(351694,9770,'af','Area',0),(351695,9770,'ro','Zona',0),(351696,9770,'et','Piirkond',0),(351697,9770,'si','ObmoÄje',0),(351698,9770,'ba','Daerah',0),(351699,9770,'nl','Gebied',0),(351700,9770,'fi','Alue',0),(351701,9770,'no','OmrÃ¥det',0),(351702,9770,'da','OmrÃ¥de',0),(351703,9770,'ko','ì§€ì—­',0),(351704,9770,'he','××–×•×¨',0),(351705,9770,'el','Î ÎµÏÎ¹Î¿Ï‡Î®',0),(351706,9770,'zh','åŒº\r\n',0),(351707,9770,'sv','OmrÃ¥de',0),(351708,9770,'it','Zona',0),(351709,9770,'tl','',0),(351710,9770,'th','&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;',0),(351711,9770,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(351712,9770,'ms','Kawasan',0),(351713,9770,'ar','Ø§Ù„Ù…Ù†Ø·Ù‚Ø©',0),(351714,9770,'fr','Zone',0),(351715,9770,'jp','ã‚¨ãƒªã‚¢',0),(351716,9770,'pt','Ãrea',0),(351717,9770,'ru','ÐŸÐ»Ð¾Ñ‰Ð°Ð´ÑŒ',0),(351718,9770,'es','Ãrea',0),(351719,9770,'de','Bereich',0),(351720,9770,'en','Area',0),(351721,9771,'is','',0),(351722,9771,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(351723,9771,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(351724,9771,'tr','Alan Ekle',0),(351725,9771,'pl','Dodaj obszar',0),(351726,9771,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(351727,9771,'ur','Ø¹Ù„Ø§Ù‚Û Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(351728,9771,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð¾Ð±Ð»Ð°ÑÑ‚',0),(351729,9771,'vi','ThÃªm khu vá»±c',0),(351730,9771,'af','Area Byvoeg',0),(351731,9771,'ro','Zona Adauga',0),(351732,9771,'et','Piirkondade Lisamine',0),(351733,9771,'si','Dodaj obmoÄje',0),(351734,9771,'ba','Tambahkan daerah',0),(351735,9771,'nl','Ruimte toevoegen',0),(351736,9771,'fi','Alueen lisÃ¤Ã¤minen',0),(351737,9771,'no','OmrÃ¥det legge',0),(351738,9771,'da','OmrÃ¥de tilfÃ¸je',0),(351739,9771,'ko','ì§€ì—­ ì¶”ê°€',0),(351740,9771,'he','×”×•×¡×£ ××–×•×¨',0),(351741,9771,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÎµÏÎ¹Î¿Ï‡Î®Ï‚',0),(351742,9771,'zh','åŒºæ–°å¢ž\r\n',0),(351743,9771,'sv','OmrÃ¥det lÃ¤gga till',0),(351744,9771,'it','Zona aggiungere',0),(351745,9771,'tl','',0),(351746,9771,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;',0),(351747,9771,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(351748,9771,'ms','Menambah kawasan',0),(351749,9771,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø³Ø§Ø­Ø©',0),(351750,9771,'fr','Ajouter zone',0),(351751,9771,'jp','ã‚¨ãƒªã‚¢ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(351752,9771,'pt','Adicionar Ã¡rea',0),(351753,9771,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±Ð»Ð°ÑÑ‚ÑŒ',0),(351754,9771,'es','Agregar Ãrea',0),(351755,9771,'de','Bereich hinzufÃ¼gen',0),(351756,9771,'en','Area Add',0),(351757,9772,'is','',0),(351758,9772,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ø­Ø°Ù Ø´Ø¯',0),(351759,9772,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ø­Ø°Ù Ø´Ø¯',0),(351760,9772,'tr','AlanÄ± sil',0),(351761,9772,'pl','UsuÅ„ obszar',0),(351762,9772,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð¾Ð½Ð°',0),(351763,9772,'ur','Ø¹Ù„Ø§Ù‚Û’ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(351764,9772,'sr','ÐžÐ±Ð»Ð°ÑÑ‚ Ð”ÐµÐ»ÐµÑ‚Ðµ',0),(351765,9772,'vi','XÃ³a khu vá»±c',0),(351766,9772,'af','Area Geskrap',0),(351767,9772,'ro','Zona ÅŸtergere',0),(351768,9772,'et','Piirkondade Kustutamine',0),(351769,9772,'si','IzbriÅ¡i obmoÄje',0),(351770,9772,'ba','Hapus daerah',0),(351771,9772,'nl','Gebied verwijderen',0),(351772,9772,'fi','Alueen poistaminen',0),(351773,9772,'no','OmrÃ¥det Slett',0),(351774,9772,'da','OmrÃ¥det slet',0),(351775,9772,'ko','ì§€ì—­ ì‚­ì œ',0),(351776,9772,'he','×ž×—×™×§×ª ××–×•×¨',0),(351777,9772,'el','Î ÎµÏÎ¹Î¿Ï‡Î® Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚',0),(351778,9772,'zh','åŒºåˆ é™¤\r\n',0),(351779,9772,'sv','Ta bort omrÃ¥det',0),(351780,9772,'it','Elimina area',0),(351781,9772,'tl','',0),(351782,9772,'th','&#3621;&#3610;&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;',0),(351783,9772,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(351784,9772,'ms','Padam kawasan',0),(351785,9772,'ar','Ø­Ø°Ù Ù…Ù†Ø·Ù‚Ø©',0),(351786,9772,'fr','Suppression de la zone',0),(351787,9772,'jp','é ˜åŸŸã®å‰Šé™¤',0),(351788,9772,'pt','ExclusÃ£o de Ã¡rea',0),(351789,9772,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(351790,9772,'es','Eliminar Ãrea',0),(351791,9772,'de','Bereich lÃ¶schen',0),(351792,9772,'en','Area Delete',0),(351793,9773,'is','',0),(351794,9773,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(351795,9773,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(351796,9773,'tr','Alan gÃ¼ncelleÅŸtirme',0),(351797,9773,'pl','Aktualizacja obszar',0),(351798,9773,'bg','ÐŸÐ»Ð¾Ñ‰ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(351799,9773,'ur','Ø¹Ù„Ø§Ù‚Û’ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(351800,9773,'sr','ÐžÐ±Ð»Ð°ÑÑ‚ Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸',0),(351801,9773,'vi','Cáº­p nháº­t khu vá»±c',0),(351802,9773,'af','Area Opdateer',0),(351803,9773,'ro','Zona de Update',0),(351804,9773,'et','Piirkondade VÃ¤rskendamine',0),(351805,9773,'si','ObmoÄje posodobitev',0),(351806,9773,'ba','Daerah Update',0),(351807,9773,'nl','Gebied Update',0),(351808,9773,'fi','Alueen pÃ¤ivitys',0),(351809,9773,'no','OmrÃ¥de oppdatering',0),(351810,9773,'da','OmrÃ¥det Update',0),(351811,9773,'ko','ì§€ì—­ ì—…ë°ì´íŠ¸',0),(351812,9773,'he','××–×•×¨ ×¢×“×›×•×Ÿ',0),(351813,9773,'el','Î ÎµÏÎ¹Î¿Ï‡Î® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚',0),(351814,9773,'zh','åŒºåŸŸæ›´æ–°\r\n',0),(351815,9773,'sv','OmrÃ¥det uppdatering',0),(351816,9773,'it','Aggiornamento della zona',0),(351817,9773,'tl','',0),(351818,9773,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;',0),(351819,9773,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(351820,9773,'ms','Kemas kawasan',0),(351821,9773,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ù†Ø·Ù‚Ø©',0),(351822,9773,'fr','Mise Ã  jour de zone',0),(351823,9773,'jp','ã‚¨ãƒªã‚¢æ›´æ–°',0),(351824,9773,'pt','AtualizaÃ§Ã£o de Ã¡rea',0),(351825,9773,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(351826,9773,'es','Actualizar Ãrea',0),(351827,9773,'de','Bereich Update',0),(351828,9773,'en','Area Update',0),(351829,9774,'is','',0),(351830,9774,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡',0),(351831,9774,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡',0),(351832,9774,'tr','Hata alanÄ± ekleme',0),(351833,9774,'pl','BÅ‚Ä…d dodawania strefy',0),(351834,9774,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(351835,9774,'ur','Ù†Ù‚Øµ Ø¹Ù„Ø§Ù‚Û’ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(351836,9774,'sr','Ð“Ñ€ÐµÑˆÐºÐµ Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ Ð¾Ð±Ð»Ð°ÑÑ‚',0),(351837,9774,'vi','Lá»—i thÃªm khu vá»±c',0),(351838,9774,'af','\'n Fout het onstaan met die Byvoeging van Area',0),(351839,9774,'ro','Eroare adÄƒugÃ¢nd zona',0),(351840,9774,'et','Piirkonna Lisamisel Tekkis Viga',0),(351841,9774,'si','Napaka dodajanje obmoÄja',0),(351842,9774,'ba','Kesalahan menambahkan Area',0),(351843,9774,'nl','Fout toe te voegen gebied',0),(351844,9774,'fi','Virhe lisÃ¤Ã¤minen alueella',0),(351845,9774,'no','Feil Ã¥ legge til omrÃ¥det',0),(351846,9774,'da','Fejl tilfÃ¸je omrÃ¥de',0),(351847,9774,'ko','ì˜¤ë¥˜ ì¶”ê°€ ì§€ì—­',0),(351848,9774,'he','×©×’×™××” ×”×•×¡×¤×ª ××–×•×¨',0),(351849,9774,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(351850,9774,'zh','é”™è¯¯ï¼šæ–°å¢žåŒº\r\n',0),(351851,9774,'sv','Fel att lÃ¤gga till omrÃ¥det',0),(351852,9774,'it','Errore aggiunta di zona',0),(351853,9774,'tl','',0),(351854,9774,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;',0),(351855,9774,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(351856,9774,'ms','Ralat menambah kawasan',0),(351857,9774,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ù…Ù†Ø·Ù‚Ø©',0),(351858,9774,'fr','Erreur ajout zone',0),(351859,9774,'jp','ã‚¨ãƒ©ãƒ¼ã‚’è¿½åŠ ã™ã‚‹]',0),(351860,9774,'pt','Ãrea de erro adicionando',0),(351861,9774,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(351862,9774,'es','Error Agregando Ãrea',0),(351863,9774,'de','Fehler hinzufÃ¼gen Bereich',0),(351864,9774,'en','Error Adding Area',0),(351865,9775,'is','',0),(351866,9775,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(351867,9775,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(351868,9775,'tr','AlanÄ± baÅŸarÄ±yla eklendi',0),(351869,9775,'pl','Obszaru dodane pomyÅ›lnie',0),(351870,9775,'bg','ÐŸÐ»Ð¾Ñ‰ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(351871,9775,'ur','Ø¹Ù„Ø§Ù‚Û’ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(351872,9775,'sr','ÐžÐ±Ð»Ð°ÑÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(351873,9775,'vi','ThÃªm khu vu74c thÃ nh cÃ´ng',0),(351874,9775,'af','Area Suksesvol Bygevoeg',0),(351875,9775,'ro','Zona adÄƒugat cu succes',0),(351876,9775,'et','Piirkond Lisamine Ã•nnestus',0),(351877,9775,'si','ObmoÄja, ki so dodani',0),(351878,9775,'ba','Daerah yang ditambahkan berhasil',0),(351879,9775,'nl','Gebied met succes toegevoegd',0),(351880,9775,'fi','Alueen lisÃ¤Ã¤minen onnistui',0),(351881,9775,'no','OmrÃ¥det ble lagt til',0),(351882,9775,'da','OmrÃ¥det tilfÃ¸jet',0),(351883,9775,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ì§€ì—­',0),(351884,9775,'he','××–×•×¨ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(351885,9775,'el','Î ÎµÏÎ¹Î¿Ï‡Î® Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(351886,9775,'zh','åŒºæ·»åŠ æˆåŠŸ\r\n',0),(351887,9775,'sv','OmrÃ¥de som lagts',0),(351888,9775,'it','Area aggiunta con successo',0),(351889,9775,'tl','',0),(351890,9775,'th','&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(351891,9775,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(351892,9775,'ms','Kawasan yang berjaya menambah',0),(351893,9775,'ar','Ø§Ù„Ù…Ù†Ø·Ù‚Ø© ÙˆØ£Ø¶Ø§Ù Ø¨Ù†Ø¬Ø§Ø­',0),(351894,9775,'fr','Espace ajoutÃ© avec succÃ¨s',0),(351895,9775,'jp','æ­£å¸¸ã«è¿½åŠ ã‚¨ãƒªã‚¢',0),(351896,9775,'pt','Ãrea adicionada com sucesso',0),(351897,9775,'ru','ÐžÐ±Ð»Ð°ÑÑ‚ÑŒ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(351898,9775,'es','Ãrea Agregada Exitosamente',0),(351899,9775,'de','Bereich erfolgreich hinzugefÃ¼gt',0),(351900,9775,'en','Area Added Successfully',0),(351901,9776,'is','',0),(351902,9776,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ù‡ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯',0),(351903,9776,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ù‡ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯',0),(351904,9776,'tr','Binaya baÄŸlÄ± alan',0),(351905,9776,'pl','Powierzchni doÅ‚Ä…czone do budynku',0),(351906,9776,'bg','ÐŸÐ»Ð¾Ñ‰ ÐºÑŠÐ¼ ÑÐ³Ñ€Ð°Ð´Ð°',0),(351907,9776,'ur','Ø¹Ù…Ø§Ø±Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ù†Ø³Ù„Ú© Ø¹Ù„Ø§Ù‚Û’',0),(351908,9776,'sr','ÐžÐ±Ð»Ð°ÑÑ‚ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(351909,9776,'vi','Khu vá»±c kÃ¨m theo Ä‘á»ƒ xÃ¢y dá»±ng',0),(351910,9776,'af','Gebied verbonde aan gebou',0),(351911,9776,'ro','Zona ataÅŸat la clÄƒdirea',0),(351912,9776,'et','Ala, mis on seotud hoone',0),(351913,9776,'si','ObmoÄju pripadajo stavbe',0),(351914,9776,'ba','Daerah yang melekat pada bangunan',0),(351915,9776,'nl','Gebied gekoppeld aan gebouw',0),(351916,9776,'fi','Alue liitetÃ¤Ã¤n rakennuksen',0),(351917,9776,'no','OmrÃ¥det knyttet til bygningen',0),(351918,9776,'da','OmrÃ¥de, der knyttet til bygning',0),(351919,9776,'ko','ì§€ì—­ ê±´ë¬¼ì— ì—°ê²° ëœ',0),(351920,9776,'he','××–×•×¨ ×¦×ž×•×“ ×œ×‘× ×™×™×Ÿ',0),(351921,9776,'el','Î ÎµÏÎ¹Î¿Ï‡Î® Ï€Î¿Ï… ÏƒÏ…Î½Î´Î­ÎµÏ„Î±Î¹ Î¼Îµ Ï„Î¿ ÎºÏ„Î¯ÏÎ¹Î¿',0),(351922,9776,'zh','å¤§åŽ¦é™„è®¾\r\n',0),(351923,9776,'sv','OmrÃ¥de bifogas byggnad',0),(351924,9776,'it','Area collegata alla costruzione',0),(351925,9776,'tl','',0),(351926,9776,'th','&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3649;&#3609;&#3610;&#3652;&#3611;&#3607;&#3637;&#3656;&#3585;&#3634;&#3619;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(351927,9776,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤²à¤—à¥à¤¨ à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(351928,9776,'ms','Kawasan yang melekat pada bangunan',0),(351929,9776,'ar','ØªØ¹Ù„Ù‚ Ø¹Ù„Ù‰ Ø¨Ù†Ø§Ø¡ Ù…Ù†Ø·Ù‚Ø©',0),(351930,9776,'fr','Zone fixÃ©e au bÃ¢timent',0),(351931,9776,'jp','åœ°åŸŸã®å»ºç‰©ã«æŽ¥ç¶šã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(351932,9776,'pt','Ãrea, ligada ao edifÃ­cio',0),(351933,9776,'ru','ÐžÐ±Ð»Ð°ÑÑ‚ÑŒ, Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ Ðº Ð·Ð´Ð°Ð½Ð¸ÑŽ',0),(351934,9776,'es','Ãrea Anexado a un Edificio',0),(351935,9776,'de','Bereich an GebÃ¤ude angeschlossen',0),(351936,9776,'en','Area Attached To Building',0),(351937,9777,'is','',0),(351938,9777,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù†Ø§Ø­ÙŠÙ‡',0),(351939,9777,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù†Ø§Ø­ÙŠÙ‡',0),(351940,9777,'tr','Hata silme alan',0),(351941,9777,'pl','BÅ‚Ä…d usuwania obszaru',0),(351942,9777,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð·Ð¾Ð½Ð°',0),(351943,9777,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ø¹Ù„Ø§Ù‚Û',0),(351944,9777,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¾Ð±Ð»Ð°ÑÑ‚',0),(351945,9777,'vi','Lá»—i xo1x khu vá»±c',0),(351946,9777,'af','Fout met Skrap van Area',0),(351947,9777,'ro','Eroare Åžtergere zonÄƒ',0),(351948,9777,'et','TÃµrge kustutamisel ala',0),(351949,9777,'si','Napaka brisanja obmoÄje',0),(351950,9777,'ba','Error menghapus Area',0),(351951,9777,'nl','Fout verwijderen gebied',0),(351952,9777,'fi','Virhe poistettaessa alue',0),(351953,9777,'no','Feil slette omrÃ¥det',0),(351954,9777,'da','Fejl slette omrÃ¥de',0),(351955,9777,'ko','ì˜¤ë¥˜ ì‚­ì œ ì˜ì—­',0),(351956,9777,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×”××–×•×¨',0),(351957,9777,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(351958,9777,'zh','åŒºåˆ é™¤å¤±è´¥\r\n',0),(351959,9777,'sv','Misstag utplÃ¥nande omrÃ¥de',0),(351960,9777,'it','Errore eliminazione Area',0),(351961,9777,'tl','',0),(351962,9777,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3621;&#3610;&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;',0),(351963,9777,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(351964,9777,'ms','Ralat menghapuskan kawasan',0),(351965,9777,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ù…Ù†Ø·Ù‚Ø©',0),(351966,9777,'fr','Erreur suppression zone',0),(351967,9777,'jp','ã‚¨ãƒ©ãƒ¼ã®å‰Šé™¤]',0),(351968,9777,'pt','Ãrea de exclusÃ£o de erro',0),(351969,9777,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(351970,9777,'es','Error Eliminando una Ãrea',0),(351971,9777,'de','Fehler lÃ¶schen Bereich',0),(351972,9777,'en','Error Deleting Area',0),(351973,9778,'is','',0),(351974,9778,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(351975,9778,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(351976,9778,'tr','Alan baÅŸarÄ±yla silindi',0),(351977,9778,'pl','Obszarze usuniÄ™ty',0),(351978,9778,'bg','ÐŸÐ»Ð¾Ñ‰ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(351979,9778,'ur','Ø¹Ù„Ø§Ù‚Û’ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒØ§',0),(351980,9778,'sr','ÐžÐ±Ð»Ð°ÑÑ‚ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(351981,9778,'vi','XÃ³a khu vá»±c thÃ nh cÃ´ng',0),(351982,9778,'af','Area Suksesvol Geskrap',0),(351983,9778,'ro','Zona eliminÄƒ cu succes',0),(351984,9778,'et','Edukalt kustutatud ala',0),(351985,9778,'si','PodroÄju uspeÅ¡no izbrisana',0),(351986,9778,'ba','Daerah dihapus berhasil',0),(351987,9778,'nl','Gebied met succes verwijderd',0),(351988,9778,'fi','Alue, poistettu',0),(351989,9778,'no','OmrÃ¥det ble slettet',0),(351990,9778,'da','OmrÃ¥det slettet',0),(351991,9778,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì§€ì—­',0),(351992,9778,'he','××–×•×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(351993,9778,'el','Î ÎµÏÎ¹Î¿Ï‡Î® Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(351994,9778,'zh','åŒºæˆåŠŸåˆ é™¤\r\n',0),(351995,9778,'sv','OmrÃ¥de som raderades',0),(351996,9778,'it','Zona eliminato con successo',0),(351997,9778,'tl','',0),(351998,9778,'th','&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3621;&#3610;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(351999,9778,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾',0),(352000,9778,'ms','Kawasan yang dihapuskan dengan jayanya',0),(352001,9778,'ar','Ø§Ù„Ù…Ø¬Ø§Ù„ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(352002,9778,'fr','Domaine supprimÃ© avec succÃ¨s',0),(352003,9778,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸé ˜åŸŸ',0),(352004,9778,'pt','Ãrea apagada com sucesso',0),(352005,9778,'ru','ÐžÐ±Ð»Ð°ÑÑ‚ÑŒ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾',0),(352006,9778,'es','Ãrea Eliminada Exitosamente',0),(352007,9778,'de','Bereich erfolgreich gelÃ¶scht',0),(352008,9778,'en','Area Deleted Successfully',0),(352009,9779,'is','',0),(352010,9779,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ø­ÙŠÙ‡',0),(352011,9779,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ø­ÙŠÙ‡',0),(352012,9779,'tr','Hata gÃ¼ncelleÅŸtirme alanÄ±',0),(352013,9779,'pl','BÅ‚Ä…d aktualizacji obszaru',0),(352014,9779,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð¾Ð½Ð°',0),(352015,9779,'ur','Ù†Ù‚Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø¹Ù„Ø§Ù‚Û’',0),(352016,9779,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(352017,9779,'vi','Lá»—i cáº­p nháº­t khu vá»±c thÃ nh cÃ´ng',0),(352018,9779,'af','Fout het ontstaan met die Opdatering van Area',0),(352019,9779,'ro','Eroare de actualizare zona',0),(352020,9779,'et','Viga ajakohastamine ala',0),(352021,9779,'si','Napaka posodabljanje obmoÄje',0),(352022,9779,'ba','Kesalahan update Area',0),(352023,9779,'nl','Fout bijwerken gebied',0),(352024,9779,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ alue',0),(352025,9779,'no','Feil oppdatering omrÃ¥det',0),(352026,9779,'da','Fejl opdatering omrÃ¥de',0),(352027,9779,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ì˜ì—­',0),(352028,9779,'he','××–×•×¨ ×”×ž×¢×“×›× ×ª ×©×’×™××”',0),(352029,9779,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(352030,9779,'zh','é”™è¯¯æ›´æ–°åŒº\r\n',0),(352031,9779,'sv','Fel uppdatering omrÃ¥de',0),(352032,9779,'it','Errore aggiornamento Area',0),(352033,9779,'tl','',0),(352034,9779,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;',0),(352035,9779,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(352036,9779,'ms','Ralat pengemaskinian kawasan',0),(352037,9779,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ù†Ø·Ù‚Ø©',0),(352038,9779,'fr','Zone de mise Ã  jour erreur',0),(352039,9779,'jp','ã‚¨ãƒ©ãƒ¼æ›´æ–°]',0),(352040,9779,'pt','Ãrea de atualizaÃ§Ã£o de erro',0),(352041,9779,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(352042,9779,'es','Error Actualizando Ãrea',0),(352043,9779,'de','Fehler Update Bereich',0),(352044,9779,'en','Error Updating Area',0),(352045,9780,'is','',0),(352046,9780,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(352047,9780,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(352048,9780,'tr','Alan baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(352049,9780,'pl','Obszarze pomyÅ›lnie zaktualizowana',0),(352050,9780,'bg','ÐŸÐ»Ð¾Ñ‰ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(352051,9780,'ur','Ø¹Ù„Ø§Ù‚Û’ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(352052,9780,'sr','ÐžÐ±Ð»Ð°ÑÑ‚ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(352053,9780,'vi','Cáº­p nháº­t khu vá»±c thÃ nh cÃ´ng',0),(352054,9780,'af','Area Suksesvol Opdateer',0),(352055,9780,'ro','Zona actualizat cu succes',0),(352056,9780,'et','VÃ¤rskendatud ala',0),(352057,9780,'si','ObmoÄje, ki je uspeÅ¡no posodobljena',0),(352058,9780,'ba','Daerah yang berhasil',0),(352059,9780,'nl','Gebied bijgewerkt',0),(352060,9780,'fi','Alueen pÃ¤ivitetty',0),(352061,9780,'no','OmrÃ¥det oppdatert',0),(352062,9780,'da','OmrÃ¥det opdateret',0),(352063,9780,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì§€ì—­',0),(352064,9780,'he','××–×•×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(352065,9780,'el','Î ÎµÏÎ¹Î¿Ï‡Î® ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(352066,9780,'zh','åŒºæ›´æ–°æˆåŠŸ\r\n',0),(352067,9780,'sv','OmrÃ¥de som uppdaterats',0),(352068,9780,'it','Area aggiornata correttamente',0),(352069,9780,'tl','',0),(352070,9780,'th','&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(352071,9780,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(352072,9780,'ms','Kawasan yang berjaya dikemas kini',0),(352073,9780,'ar','Ù…Ø¬Ø§Ù„ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(352074,9780,'fr','Zone de mise Ã  jour rÃ©ussie',0),(352075,9780,'jp','æ­£å¸¸ã«æ›´æ–°ã‚¨ãƒªã‚¢',0),(352076,9780,'pt','Ãrea de atualizado com sucesso',0),(352077,9780,'ru','ÐžÐ±Ð»Ð°ÑÑ‚Ð¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(352078,9780,'es','Ãrea Actualizada Exitosamente',0),(352079,9780,'de','Bereich erfolgreich aktualisiert',0),(352080,9780,'en','Area Updated Successfully',0),(352081,9781,'is','',0),(352082,9781,'dr','Ø­Ø°Ù Ù†Ø§Ø­ÙŠÙ‡ ',0),(352083,9781,'pr','Ø­Ø°Ù Ù†Ø§Ø­ÙŠÙ‡ ',0),(352084,9781,'tr','AlanÄ± sil',0),(352085,9781,'pl','UsuÅ„ obszar',0),(352086,9781,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(352087,9781,'ur','Ø¹Ù„Ø§Ù‚Û’ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(352088,9781,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð±Ð»Ð°ÑÑ‚',0),(352089,9781,'vi','XÃ³a vÃ¹ng',0),(352090,9781,'af','Skrap Area',0),(352091,9781,'ro','ÅžtergeÅ£i zona',0),(352092,9781,'et','Kustuta ala',0),(352093,9781,'si','IzbriÅ¡i obmoÄje',0),(352094,9781,'ba','Menghapus Area',0),(352095,9781,'nl','Gebied verwijderen',0),(352096,9781,'fi','Poista alue',0),(352097,9781,'no','Slette omrÃ¥det',0),(352098,9781,'da','Slette omrÃ¥de',0),(352099,9781,'ko','ì˜ì—­ ì‚­ì œ',0),(352100,9781,'he','×ž×—×™×§×ª ××–×•×¨',0),(352101,9781,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(352102,9781,'zh','åˆ é™¤åŒº\r\n',0),(352103,9781,'sv','Ta bort omrÃ¥det',0),(352104,9781,'it','Elimina Area',0),(352105,9781,'tl','',0),(352106,9781,'th','&#3621;&#3610;&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;',0),(352107,9781,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(352108,9781,'ms','Menghapuskan kawasan',0),(352109,9781,'ar','Ø­Ø°Ù Ù…Ù†Ø·Ù‚Ø©',0),(352110,9781,'fr','Supprimer la zone',0),(352111,9781,'jp','é ˜åŸŸã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(352112,9781,'pt','Excluir a Ã¡rea',0),(352113,9781,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¾Ð±Ð»Ð°ÑÑ‚ÑŒ',0),(352114,9781,'es','Eliminar Ãrea',0),(352115,9781,'de','Bereich lÃ¶schen',0),(352116,9781,'en','Delete Area',0),(352117,9782,'is','',0),(352118,9782,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡',0),(352119,9782,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø§Ø­ÙŠÙ‡',0),(352120,9782,'tr','Alan Ekle',0),(352121,9782,'pl','Dodaj obszar',0),(352122,9782,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(352123,9782,'ur','Ø¹Ù„Ø§Ù‚Û Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(352124,9782,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð¾Ð±Ð»Ð°ÑÑ‚',0),(352125,9782,'vi','ThÃªm khu vá»±c',0),(352126,9782,'af','Area Byvoeg',0),(352127,9782,'ro','Adauga zona',0),(352128,9782,'et','Piirkonna Lisamine',0),(352129,9782,'si','Dodaj obmoÄje',0),(352130,9782,'ba','Tambahkan Area',0),(352131,9782,'nl','Ruimte toevoegen',0),(352132,9782,'fi','LisÃ¤tÃ¤ alueen',0),(352133,9782,'no','Legge til omrÃ¥det',0),(352134,9782,'da','TilfÃ¸je omrÃ¥de',0),(352135,9782,'ko','ì§€ì—­ ì¶”ê°€',0),(352136,9782,'he','×”×•×¡×£ ××–×•×¨',0),(352137,9782,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÎµÏÎ¹Î¿Ï‡Î®Ï‚',0),(352138,9782,'zh','æ–°å¢žåŒº\r\n',0),(352139,9782,'sv','LÃ¤gg till omrÃ¥de',0),(352140,9782,'it','Aggiungi Area',0),(352141,9782,'tl','',0),(352142,9782,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3614;&#3639;&#3656;&#3609;&#3607;&#3637;&#3656;',0),(352143,9782,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(352144,9782,'ms','Menambah kawasan',0),(352145,9782,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø³Ø§Ø­Ø©',0),(352146,9782,'fr','Ajouter zone',0),(352147,9782,'jp','é ˜åŸŸã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(352148,9782,'pt','Adicionar Ã¡rea',0),(352149,9782,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±Ð»Ð°ÑÑ‚ÑŒ',0),(352150,9782,'es','Agregar Ãrea',0),(352151,9782,'de','Bereich hinzufÃ¼gen',0),(352152,9782,'en','Add Area',0),(352153,9783,'is','',0),(352154,9783,'dr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø§Ø¬Ø§Ø±Ù‡ ',0),(352155,9783,'pr','ÙØ§ÙŠÙ„ Ù‡Ø§ÙŠ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ø§Ø¬Ø§Ø±Ù‡ ',0),(352156,9783,'tr','Kira PDF dosyalarÄ±',0),(352157,9783,'pl','DzierÅ¼awy plikÃ³w PDF',0),(352158,9783,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ PDF Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(352159,9783,'ur','Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ø¦Ù„ÙˆÚº Ú©Ùˆ Ù„ÛŒØ² Ù¾Ø±',0),(352160,9783,'sr','Ð—Ð°ÐºÑƒÐ¿ ÐŸÐ”Ð¤ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(352161,9783,'vi','file PDF há»£p Ä‘á»“ng thuÃª',0),(352162,9783,'af','Huurkontrak PDF LeÃªrs',0),(352163,9783,'ro','Leasing fiÅŸiere PDF',0),(352164,9783,'et','ÃœÃ¼rilepingu PDF faile',0),(352165,9783,'si','Najem PDF datoteke',0),(352166,9783,'ba','Sewa file PDF',0),(352167,9783,'nl','Leasen van PDF-bestanden',0),(352168,9783,'fi','Vuokrasopimuksen PDF-tiedostoja',0),(352169,9783,'no','Leieavtalen PDF-filer',0),(352170,9783,'da','Lease PDF-filer',0),(352171,9783,'ko','PDF íŒŒì¼ì„ ìž„ëŒ€',0),(352172,9783,'he','×§×•×‘×¦×™ PDF ×—×›×™×¨×”',0),(352173,9783,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î±ÏÏ‡ÎµÎ¯Î± PDF',0),(352174,9783,'zh','ç§ŸèµPDFæ–‡ä»¶\r\n',0),(352175,9783,'sv','Leasa PDF-filer',0),(352176,9783,'it','Contratto di locazione PDF file',0),(352177,9783,'tl','',0),(352178,9783,'th','&#3652;&#3615;&#3621;&#3660;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634; PDF',0),(352179,9783,'hi','à¤ªà¥€à¤¡à¥€à¤à¤« à¤«à¤¾à¤‡à¤²à¥‹à¤‚ à¤•à¥‡ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(352180,9783,'ms','Fail PDF pajakan',0),(352181,9783,'ar','ØªØ£Ø¬ÙŠØ± Ù…Ù„ÙØ§Øª PDF',0),(352182,9783,'fr','Louer des fichiers PDF',0),(352183,9783,'jp','PDF ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ãƒªãƒ¼ã‚¹ã—ã¾ã™ã€‚',0),(352184,9783,'pt','LocaÃ§Ã£o de arquivos PDF',0),(352185,9783,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð² PDF',0),(352186,9783,'es','Files PDF del Arrendamiento',0),(352187,9783,'de','Mietvertrag PDF-Dateien',0),(352188,9783,'en','Lease PDF Files',0),(352189,9784,'is','',0),(352190,9784,'dr','Ù„Ø·ÙØ§ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠÙŠ Ø±Ø§ ÙƒÙ‡ Ø¨Ø§ Ø§Ø¬Ø§Ø±Ù‡ Ù…ÙˆØ¬ÙˆØ¯  Ù‡Ù…Ù¾ÙˆØ´Ø§Ù†ÙŠ Ù†Ø¯Ø§Ø±Ø¯  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(352191,9784,'pr','Ù„Ø·ÙØ§ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠÙŠ Ø±Ø§ ÙƒÙ‡ Ø¨Ø§ Ø§Ø¬Ø§Ø±Ù‡ Ù…ÙˆØ¬ÙˆØ¯  Ù‡Ù…Ù¾ÙˆØ´Ø§Ù†ÙŠ Ù†Ø¯Ø§Ø±Ø¯  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(352192,9784,'tr','LÃ¼tfen varolan bir kira ile Ã§akÄ±ÅŸmadÄ±ÄŸÄ±ndan tarihleri seÃ§in.',0),(352193,9784,'pl','ProszÄ™ wybraÄ‡ daty, ktÃ³re nie pokrywajÄ… siÄ™ z istniejÄ…cej dzierÅ¼awy.',0),(352194,9784,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð¸, ÐºÐ¾Ð¸Ñ‚Ð¾ Ð½Ðµ ÑÐµ Ð¿Ñ€Ð¸Ð¿Ð¾ÐºÑ€Ð¸Ð²Ð°Ñ‚ ÑÑŠÑ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ð»Ð¸Ð·Ð¸Ð½Ð³.',0),(352195,9784,'ur','Ú©Û Ø§ÛŒÚ© Ù…ÙˆØ¬ÙˆØ¯ Ù„ÛŒØ² Ø³Û’ Ù…ØªØ¬Ø§ÙˆØ² Ù†ÛÛŒÚº ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Û”',0),(352196,9784,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼Ðµ ÐºÐ¾Ñ˜Ð¸ Ð½Ðµ Ð´Ð¾Ð»Ð°Ð·Ð¸ Ð´Ð¾ Ð¿Ñ€ÐµÐºÐ»Ð°Ð¿Ð°ÑšÐ° ÑÐ° Ð½Ð° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð·Ð°ÐºÑƒÐ¿.',0),(352197,9784,'vi','vui lÃ²ng chá»n ngÃ y mÃ  khÃ´ng chÃ¨n lÃªn ngÃ y thuÃª hiá»‡n táº¡i',0),(352198,9784,'af','Kies asseblief datums wat nie oorvleuel met \'n bestaande huurkontrak.',0),(352199,9784,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i datele care nu se suprapun cu un contract de leasing existente.',0),(352200,9784,'et','Palun vali pÃ¤evad mis ei kattu olemasoleva liisinguperioodiga',0),(352201,9784,'si','Izberite datume, ki se ne prekrivajo z obstojeÄih najemnih.',0),(352202,9784,'ba','Pilih tanggal yang tidak tumpang tindih dengan sewa yang ada.',0),(352203,9784,'nl','Selecteer datums die elkaar niet met een bestaande lease overlappen.',0),(352204,9784,'fi','Valitse pÃ¤ivÃ¤mÃ¤Ã¤riÃ¤, jotka eivÃ¤t ole pÃ¤Ã¤llekkÃ¤isiÃ¤ nykyinen vuokrasopimus.',0),(352205,9784,'no','Velg datoene ikke overlapper en eksisterende leiekontrakt.',0),(352206,9784,'da','VÃ¦lg venligst datoer, der ikke overlapper med en eksisterende lejekontrakt.',0),(352207,9784,'ko','ê¸°ì¡´ ìž„ëŒ€ì™€ ì¤‘ë³µ í•˜ì§€ ì•ŠëŠ” ë‚ ì§œë¥¼ ì„ íƒ í•˜ì‹­ì‹œì˜¤.',0),(352208,9784,'he','× × ×‘×—×¨ ×ª××¨×™×›×™× ××©×¨ ×œ× ×—×•×¤×¤×™× ×”×—×•×–×” ×”×§×™×™×.',0),(352209,9784,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¹Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚ Ï€Î¿Ï… Î´ÎµÎ½ ÏƒÏ…Î¼Ï€Î¯Ï€Ï„Î¿Ï…Î½ Î¼Îµ Î¼Î¹Î± Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎ± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·.',0),(352210,9784,'zh','è¯·é€‰æ‹©ä¸ä¸ŽçŽ°æœ‰çš„ç§Ÿèµé‡å çš„æ—¥æœŸã€‚\r\n',0),(352211,9784,'sv','VÃ¤lj datum som inte Ã¶verlappar en befintlig hyresavtalet.',0),(352212,9784,'it','Per favore selezionare le date che non si sovrappongono con un contratto di locazione esistente.',0),(352213,9784,'tl','',0),(352214,9784,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3648;&#3621;&#3639;&#3629;&#3585;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3607;&#3633;&#3610;&#3595;&#3657;&#3629;&#3609;&#3585;&#3633;&#3610;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3',0),(352215,9784,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤“à¤µà¤°à¤²à¥ˆà¤ª à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚à¥¤',0),(352216,9784,'ms','Sila pilih tarikh yang tidak bertindih dengan pajakan yang sedia ada.',0),(352217,9784,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ø§Ù„ØªÙˆØ§Ø±ÙŠØ® Ø§Ù„ØªÙŠ Ù„Ø§ ØªØªØ¯Ø§Ø®Ù„ Ù…Ø¹ ØªØ£Ø¬ÙŠØ± Ø§Ù„Ø­Ø§Ù„ÙŠØ©.',0),(352218,9784,'fr','Sâ€™il vous plaÃ®t sÃ©lectionnez les dates qui ne se chevauchent pas avec un bail existant.',0),(352219,9784,'jp','æ—¢å­˜ã®ãƒªãƒ¼ã‚¹ã¨é‡è¤‡ã—ãªã„æ—¥ä»˜ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(352220,9784,'pt','Por favor, selecione as datas que nÃ£o se sobrepÃµem com um contrato de arrendamento existente.',0),(352221,9784,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ñ‹, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð½Ðµ ÑÐ¾Ð²Ð¿Ð°Ð´Ð°ÑŽÑ‚ Ñ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÐµÐ¹ Ð°Ñ€ÐµÐ½Ð´Ñ‹.',0),(352222,9784,'es','Por Favor Selecciona Fechas que no Sobresalen con un Arrendamiento Existente',0),(352223,9784,'de','Bitte wÃ¤hlen Sie die Daten, die mit einem bestehenden Mietvertrag nicht Ã¼berlappen.',0),(352224,9784,'en','Please select dates that don\'t overlap with an existing lease.',0),(352225,9785,'is','',0),(352226,9785,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§',0),(352227,9785,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§',0),(352228,9785,'tr','Arama Kiralama',0),(352229,9785,'pl','Szukaj dzierÅ¼awy',0),(352230,9785,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(352231,9785,'ur','ØªÙ„Ø§Ø´ Ù„ÙÛŒØ²Ø²',0),(352232,9785,'sr','Ð£Ð³Ð¾Ð²Ð¾Ñ€Ð¸ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(352233,9785,'vi','Tim kiáº¿m cÃ¡c ngÆ°á»i cho thuÃª',0),(352234,9785,'af','Soek huurooreenkomste',0),(352235,9785,'ro','CautÄƒ locaÈ›iile',0),(352236,9785,'et','Otsi rent',0),(352237,9785,'si','IÅ¡Äi najemi',0),(352238,9785,'ba','Cari sewa',0),(352239,9785,'nl','Zoek lease-overeenkomsten',0),(352240,9785,'fi','Etsi vuokrasopimukset',0),(352241,9785,'no','SÃ¸k leieavtaler',0),(352242,9785,'da','SÃ¸g lejemÃ¥l',0),(352243,9785,'ko','ê²€ìƒ‰ ìž„ëŒ€',0),(352244,9785,'he','×—×™×¤×•×© ×—×›×™×¨×”',0),(352245,9785,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(352246,9785,'zh','æœç´¢ç§Ÿèµ\r\n',0),(352247,9785,'sv','SÃ¶k lÃ¥n',0),(352248,9785,'it','Ricerca leasing',0),(352249,9785,'tl','',0),(352250,9785,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(352251,9785,'hi','à¤–à¥‹à¤œ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚',0),(352252,9785,'ms','Cari pajakan',0),(352253,9785,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø¹Ù‚ÙˆØ¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(352254,9785,'fr','Recherche Location',0),(352255,9785,'jp','ãƒªãƒ¼ã‚¹æ¤œç´¢',0),(352256,9785,'pt','Pesquisa de locaÃ§Ãµes',0),(352257,9785,'ru','ÐŸÐ¾Ð¸ÑÐº Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(352258,9785,'es','Busque Arrendamientos',0),(352259,9785,'de','Suche-Leasing',0),(352260,9785,'en','Search Leases',0),(352261,9786,'is','',0),(352262,9786,'dr','Ù‡ÙŠÚ† Ù…Ø³ØªØ§Ø¬Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(352263,9786,'pr','Ù‡ÙŠÚ† Ù…Ø³ØªØ§Ø¬Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(352264,9786,'tr','KiracÄ± yok bulundu',0),(352265,9786,'pl','Nie znaleziono najemcÃ³w',0),(352266,9786,'bg','ÐÑÐ¼Ð° Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(352267,9786,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ù¾Ø§ÛŒØ§',0),(352268,9786,'sr','ÐÐ¸ÐºÐ¾ Ð¾Ð´ ÑÑ‚Ð°Ð½Ð°Ñ€Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(352269,9786,'vi','khÃ´ng tÃ¬m tháº¥y nhÃ¢n viÃªcn',0),(352270,9786,'af','Geen Huurders Gevind',0),(352271,9786,'ro','Chiriasii nu gÄƒsite',0),(352272,9786,'et','Ei leidnud Ã¼Ã¼rnikud',0),(352273,9786,'si','Ne najemniki naÅ¡el',0),(352274,9786,'ba','Penyewa tidak ditemukan',0),(352275,9786,'nl','Geen huurders gevonden',0),(352276,9786,'fi','Ole vuokralaisia lÃ¶ytyi',0),(352277,9786,'no','Ingen leietakere funnet',0),(352278,9786,'da','Ingen lejere fundet',0),(352279,9786,'ko','ì•„ë‹ˆ ì„¸ ìž…ìž ë°œê²¬',0),(352280,9786,'he','×”×“×™×™×¨×™× ×œ× × ×ž×¦××•',0),(352281,9786,'el','ÎšÎ±Î¼Î¯Î± ÎµÎ½Î¿Î¹ÎºÎ¹Î±ÏƒÏ„Î­Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(352282,9786,'zh','æ²¡æœ‰æ‰¾åˆ°ç§Ÿæˆ·\r\n',0),(352283,9786,'sv','Inga hyresgÃ¤ster som hittade',0),(352284,9786,'it','Non inquilini trovati',0),(352285,9786,'tl','',0),(352286,9786,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(352287,9786,'hi','à¤•à¥‹à¤ˆ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(352288,9786,'ms','Tiada penyewa yang ditemui',0),(352289,9786,'ar','Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±ÙŠÙ† Ù„Ø§ ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(352290,9786,'fr','Aucun locataires trouvÃ©s',0),(352291,9786,'jp','ç™ºè¦‹ãªã„ãƒ†ãƒŠãƒ³ãƒˆ',0),(352292,9786,'pt','Sem inquilinos encontrados',0),(352293,9786,'ru','ÐÐµ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð¾Ð² Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(352294,9786,'es','No se Encontraron Inquilinos',0),(352295,9786,'de','Keine Mieter gefunden',0),(352296,9786,'en','No Tenants Found',0),(352297,9787,'is','',0),(352298,9787,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù…Ø³ØªØ§Ø¬Ø±Ø§Ù† ',0),(352299,9787,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù…Ø³ØªØ§Ø¬Ø±Ø§Ù† ',0),(352300,9787,'tr','Arama kiracÄ±',0),(352301,9787,'pl','Wyszukiwanie najemcÃ³w',0),(352302,9787,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»Ð¸',0),(352303,9787,'ur','ØªÙ„Ø§Ø´ Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±ÙˆÚº Ú©Û’ Ù„Û“',0),(352304,9787,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð½Ð°Ñ€Ðµ',0),(352305,9787,'vi','TÃ¬m kiáº¿m ngÆ°á»i thuÃª nhÃ ',0),(352306,9787,'af','Soek Huurders',0),(352307,9787,'ro','CÄƒutaÅ£i chiriasi',0),(352308,9787,'et','Otsi Ã¼Ã¼rnikud',0),(352309,9787,'si','Iskanje najemnikov',0),(352310,9787,'ba','Cari penyewa',0),(352311,9787,'nl','Zoek huurders',0),(352312,9787,'fi','Etsi vuokralaisten',0),(352313,9787,'no','SÃ¸k leietakere',0),(352314,9787,'da','SÃ¸g blandt lejere',0),(352315,9787,'ko','ê²€ìƒ‰ ê±°ì£¼ìž',0),(352316,9787,'he','×—×™×¤×•×© ×“×™×™×¨×™×',0),(352317,9787,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎµÎ½Î¿Î¹ÎºÎ¹Î±ÏƒÏ„Î­Ï‚',0),(352318,9787,'zh','æœç´¢ç§Ÿæˆ·\r\n',0),(352319,9787,'sv','SÃ¶k hyresgÃ¤ster',0),(352320,9787,'it','Ricerca inquilini',0),(352321,9787,'tl','',0),(352322,9787,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;',0),(352323,9787,'hi','à¤–à¥‹à¤œ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°à¥‹à¤‚',0),(352324,9787,'ms','Cari penyewa',0),(352325,9787,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±ÙŠÙ†',0),(352326,9787,'fr','Recherche locataires',0),(352327,9787,'jp','ãƒ†ãƒŠãƒ³ãƒˆæ¤œç´¢',0),(352328,9787,'pt','Inquilinos de pesquisa',0),(352329,9787,'ru','ÐŸÐ¾Ð¸ÑÐº Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð¾Ð²',0),(352330,9787,'es','Busque Inquilinos',0),(352331,9787,'de','Suche Mieter',0),(352332,9787,'en','Search Tenants',0),(352333,9788,'is','',0),(352334,9788,'dr','(Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù†',0),(352335,9788,'pr','ØªØ§Ø±ÙŠØ® Ù‚Ø§Ø¨Ù„ÙŠØª Ø§Ø³ØªÙØ§Ø¯Ù‡ (Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù†',0),(352336,9788,'tr','GeÃ§erlilik tarihi',0),(352337,9788,'pl','Data dostÄ™pnoÅ›ci',0),(352338,9788,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚',0),(352339,9788,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(352340,9788,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¾ÑÑ‚Ð¸',0),(352341,9788,'vi','NgÃ y cÃ³ sáºµn',0),(352342,9788,'af','Beskikbaarheidsdatum',0),(352343,9788,'ro','Data disponibilitate',0),(352344,9788,'et','Saadaval alates',0),(352345,9788,'si','Availability rok',0),(352346,9788,'ba','Tanggal ketersediaan',0),(352347,9788,'nl','Beschikbaarheidsdatum',0),(352348,9788,'fi','Vapautumisen',0),(352349,9788,'no','Tilgjengelighetsdato',0),(352350,9788,'da','Anvendelighed aldersbestemme',0),(352351,9788,'ko','ê°€ëŠ¥ ë‚ ì§œ',0),(352352,9788,'he','×ª××¨×™×š ×–×ž×™× ×•×ª',0),(352353,9788,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î´Î¹Î±Î¸ÎµÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î±Ï‚',0),(352354,9788,'zh','å¯ç”¨æ—¥æœŸ\r\n',0),(352355,9788,'sv','Datum fÃ¶r tillgÃ¤nglighet',0),(352356,9788,'it','Data di disponibilitÃ ',0),(352357,9788,'tl','',0),(352358,9788,'th','&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3623;&#3656;&#3634;&#3591;',0),(352359,9788,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§à¤¤à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(352360,9788,'ms','Tarikh ketersediaan',0),(352361,9788,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥ØªØ§Ø­Ø©',0),(352362,9788,'fr','Date de disponibilitÃ©',0),(352363,9788,'jp','åˆ©ç”¨å¯èƒ½æ—¥',0),(352364,9788,'pt','Data de disponibilidade',0),(352365,9788,'ru','Ð”Ð°Ñ‚Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ÑÑ‚Ð¸',0),(352366,9788,'es','Fecha de Disponibilidad',0),(352367,9788,'de','VerfÃ¼gbarkeitsdatum',0),(352368,9788,'en','Availability Date',0),(352369,9789,'is','',0),(352370,9789,'dr','Ù‡ÙŠÚ† Ù†ØªÙŠØ¬Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(352371,9789,'pr','Ù‡ÙŠÚ† Ù†ØªÙŠØ¬Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(352372,9789,'tr','HiÃ§bir sonuÃ§ bulunamadÄ±',0),(352373,9789,'pl','Nie znaleziono wynikÃ³w',0),(352374,9789,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸',0),(352375,9789,'ur','Ú©ÙˆØ¦ÛŒ Ù†ØªØ§Ø¦Ø¬ Ù†ÛÛŒÚº Ù…Ù„Û’',0),(352376,9789,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½ Ð½Ð¸Ñ˜ÐµÐ´Ð°Ð½ Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚',0),(352377,9789,'vi','khÃ´ng tÃ¬m tháº¥y káº¿t quáº£',0),(352378,9789,'af','Geen Resultate Gevind',0),(352379,9789,'ro','Niciun rezultat gÄƒsit',0),(352380,9789,'et','Tulemusi ei leitud',0),(352381,9789,'si','NiÄ ni bilo najdeno',0),(352382,9789,'ba','Hasil tidak ditemukan',0),(352383,9789,'nl','Geen resultaten gevonden',0),(352384,9789,'fi','Ei tuloksia',0),(352385,9789,'no','Finner ingen resultater',0),(352386,9789,'da','Ingen resultater fundet',0),(352387,9789,'ko','ê²°ê³¼ê°€ ë°œê²¬',0),(352388,9789,'he','×œ× × ×ž×¦××• ×ª×•×¦××•×ª',0),(352389,9789,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î±Ï€Î¿Ï„ÎµÎ»Î­ÏƒÎ¼Î±Ï„Î±',0),(352390,9789,'zh','æ‰¾ä¸åˆ°ç»“æžœ\r\n',0),(352391,9789,'sv','Inga resultat hittades',0),(352392,9789,'it','Nessun risultato trovato',0),(352393,9789,'tl','',0),(352394,9789,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;',0),(352395,9789,'hi','à¤•à¥‹à¤ˆ à¤ªà¤°à¤¿à¤£à¤¾à¤® à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(352396,9789,'ms','Tiada keputusan dijumpai',0),(352397,9789,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù†ØªØ§Ø¦Ø¬',0),(352398,9789,'fr','Aucun rÃ©sultat trouvÃ©',0),(352399,9789,'jp','çµæžœã¯è¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(352400,9789,'pt','Nenhum resultado encontrado',0),(352401,9789,'ru','Ð ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ñ‹ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(352402,9789,'es','No se Encontraron Resultados',0),(352403,9789,'de','Keine Ergebnisse gefunden',0),(352404,9789,'en','No Results Found',0),(352405,9790,'is','',0),(352406,9790,'dr','Ø¯Ø³ØªÙˆØ± Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(352407,9790,'pr','Ø¯Ø³ØªÙˆØ± Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(352408,9790,'tr','Ã–zellik kullanÄ±labilirliÄŸi yÃ¶nergeleri',0),(352409,9790,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ dostÄ™pnoÅ›ci instrukcji',0),(352410,9790,'bg','Ð˜Ð¼Ð¾Ñ‚Ð¸ Ð´Ð¾ÑÑ‚ÑŠÐ¿Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(352411,9790,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ø¯Ø³ØªÛŒØ§Ø¨ÛŒ Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(352412,9790,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ÑÑ‚ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(352413,9790,'vi','chá»‰ dáº«n tÃ i sáº£n hiá»‡n cÃ³',0),(352414,9790,'af','Eiendom Beskikbaarheidsinstruksies',0),(352415,9790,'ro','InstrucÅ£iuni de disponibilitate proprietate',0),(352416,9790,'et','Majutusasutuse saadavust juhiseid',0),(352417,9790,'si','Lastnost Availability navodila',0),(352418,9790,'ba','Properti ketersediaan petunjuk',0),(352419,9790,'nl','Eigenschap beschikbaarheid instructies',0),(352420,9790,'fi','Ominaisuuden saatavuus ohjeet',0),(352421,9790,'no','Egenskapen tilgjengelighet instruksjoner',0),(352422,9790,'da','Egenskaben tilgÃ¦ngelighed instruktioner',0),(352423,9790,'ko','ì†ì„± ì—¬ë¶€ ì§€ì‹œ',0),(352424,9790,'he','×”×ž××¤×™×™×Ÿ ×–×ž×™× ×•×ª ×”×•×¨××•×ª',0),(352425,9790,'el','Î¤Î¿ ÎºÎ±Ï„Î¬Î»Ï…Î¼Î± Î´Î¹Î±Î¸ÎµÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î± Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(352426,9790,'zh','å±žæ€§çš„å¯ç”¨æ€§è¯´æ˜Ž\r\n',0),(352427,9790,'sv','Boendet tillgÃ¤nglighet instruktioner',0),(352428,9790,'it','ProprietÃ  disponibilitÃ  istruzioni',0),(352429,9790,'tl','',0),(352430,9790,'th','&#3588;&#3635;&#3649;&#3609;&#3632;&#3609;&#3635;&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;&#3607;&#3637;&#3656;&#3651;&#3594;&#3657;&#3652;&#3604;&#3657;',0),(352431,9790,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥€ à¤‰à¤ªà¤²à¤¬à¥à¤§à¤¤à¤¾ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(352432,9790,'ms','Arahan ketersediaan harta tanah',0),(352433,9790,'ar','Ø®Ø§ØµÙŠØ© ØªÙˆØ§ÙØ± ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(352434,9790,'fr','Instructions de disponibilitÃ© de propriÃ©tÃ©',0),(352435,9790,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®å¯ç”¨æ€§ã«ã¤ã„ã¦',0),(352436,9790,'pt','InstruÃ§Ãµes de disponibilidade de propriedade.',0),(352437,9790,'ru','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð¿Ð¾ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ÑÑ‚Ð¸ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(352438,9790,'es','Instrucciones de Disponibilidad de Propiedad',0),(352439,9790,'de','Eigentum-VerfÃ¼gbarkeit-Anweisungen',0),(352440,9790,'en','Property Availability Instructions',0),(352441,9791,'is','',0),(352442,9791,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§ ',0),(352443,9791,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§ ',0),(352444,9791,'tr','Arama Ã¶zellikleri',0),(352445,9791,'pl','Wyszukiwanie obiektÃ³w',0),(352446,9791,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚Ð¸',0),(352447,9791,'ur','ØªÙ„Ø§Ø´ Ø®ÙˆØ§Øµ',0),(352448,9791,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(352449,9791,'vi','TÃ¬m kiáº¿m tÃ i sáº£n',0),(352450,9791,'af','Soek Eiendomme',0),(352451,9791,'ro','ProprietÄƒÅ£ile de cÄƒutare',0),(352452,9791,'et','Otsi majutusasutust',0),(352453,9791,'si','Iskanje lastnosti',0),(352454,9791,'ba','Cari properti',0),(352455,9791,'nl','Zoek vastgoed',0),(352456,9791,'fi','Haun ominaisuudet',0),(352457,9791,'no','SÃ¸k boliger',0),(352458,9791,'da','SÃ¸g egenskaber',0),(352459,9791,'ko','ê²€ìƒ‰ ì†ì„±',0),(352460,9791,'he','×ž××¤×™×™× ×™ ×—×™×¤×•×©',0),(352461,9791,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎºÎ±Ï„Î±Î»Ï…Î¼Î¬Ï„Ï‰Î½',0),(352462,9791,'zh','æœç´¢å±žæ€§\r\n',0),(352463,9791,'sv','SÃ¶k boenden',0),(352464,9791,'it','Ricerca immobili',0),(352465,9791,'tl','',0),(352466,9791,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3588;&#3640;&#3603;&#3626;&#3617;&#3610;&#3633;&#3605;&#3636;',0),(352467,9791,'hi','à¤–à¥‹à¤œ à¤—à¥à¤£',0),(352468,9791,'ms','Cari hartanah',0),(352469,9791,'ar','Ø®ØµØ§Ø¦Øµ Ø§Ù„Ø¨Ø­Ø«',0),(352470,9791,'fr','PropriÃ©tÃ©s de recherche',0),(352471,9791,'jp','æ¤œç´¢ã®ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£',0),(352472,9791,'pt','Propriedades de pesquisa',0),(352473,9791,'ru','ÐŸÐ¾Ð¸ÑÐº Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚Ð¾Ð² Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ñ',0),(352474,9791,'es','Busque Propiedades',0),(352475,9791,'de','Suche Immobilien',0),(352476,9791,'en','Search Properties',0),(352477,9792,'is','',0),(352478,9792,'dr','ØªØµØ±Ù Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(352479,9792,'pr','ØªØµØ±Ù Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(352480,9792,'tr','BinayÄ± iÅŸgal',0),(352481,9792,'pl','Budynek zawÃ³d',0),(352482,9792,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ð¾ÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ',0),(352483,9792,'ur','Ø¹Ù…Ø§Ø±Øª Ú©Ø§ Ù‚Ø¨Ø¶Û',0),(352484,9792,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð¾ÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ˜Ðµ',0),(352485,9792,'vi','CÃ´ng viá»‡c thiáº¿t káº¿',0),(352486,9792,'af','Gebou Okkupasie',0),(352487,9792,'ro','OcupaÅ£ia de constructii',0),(352488,9792,'et','Hoone okupatsiooni',0),(352489,9792,'si','Stavbe poklic',0),(352490,9792,'ba','Bangunan pekerjaan',0),(352491,9792,'nl','Bezetting van gebouw',0),(352492,9792,'fi','Rakennuksen ammatti',0),(352493,9792,'no','Bygningen yrke',0),(352494,9792,'da','Bygning besÃ¦ttelse',0),(352495,9792,'ko','ê±´ë¬¼ ì ë ¹',0),(352496,9792,'he','×‘× ×™×™×Ÿ ×”×›×™×‘×•×©',0),(352497,9792,'el','ÎšÎ±Ï„Î¬Î»Î·ÏˆÎ· Ï„Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(352498,9792,'zh','å»ºè®¾å æœ‰\r\n',0),(352499,9792,'sv','Byggnaden ockupation',0),(352500,9792,'it','Occupazione di edificio',0),(352501,9792,'tl','',0),(352502,9792,'th','&#3629;&#3634;&#3594;&#3637;&#3614;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(352503,9792,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤µà¥à¤¯à¤µà¤¸à¤¾à¤¯',0),(352504,9792,'ms','Kelayakan menduduki bangunan',0),(352505,9792,'ar','Ø§Ù„Ø§Ø­ØªÙ„Ø§Ù„ Ø¨Ù†Ø§Ø¡',0),(352506,9792,'fr','Occupation de lâ€™immeuble',0),(352507,9792,'jp','å»ºç‰©ã®è·æ¥­',0),(352508,9792,'pt','OcupaÃ§Ã£o de prÃ©dio',0),(352509,9792,'ru','ÐžÐºÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(352510,9792,'es','OcupaciÃ³n de EdifÃ­cio',0),(352511,9792,'de','GebÃ¤ude-Besetzung',0),(352512,9792,'en','Building Occupation',0),(352513,9793,'is','',0),(352514,9793,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø§Ø´ØªØºØ§Ù„',0),(352515,9793,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø§Ø´ØªØºØ§Ù„',0),(352516,9793,'tr','GÃ¼n iÅŸgal',0),(352517,9793,'pl','Dni zajÄ™te',0),(352518,9793,'bg','Ð”Ð½Ð¸ Ð·Ð°ÐµÑ‚Ð¸',0),(352519,9793,'ur','Ù‚Ø¨Ø¶Û',0),(352520,9793,'sr','Ð”Ð°Ð½Ð° Ð¾ÐºÑƒÐ¿Ð¸Ñ€Ð°Ð½.',0),(352521,9793,'vi','NgÃ y Ä‘Ã³ng',0),(352522,9793,'af','Dae Geokkupeer',0),(352523,9793,'ro','Zile ocupate',0),(352524,9793,'et','PÃ¤eva hÃµivatud',0),(352525,9793,'si','Dni zaseda',0),(352526,9793,'ba','Hari diduduki',0),(352527,9793,'nl','Dagen bezet',0),(352528,9793,'fi','PÃ¤ivÃ¤Ã¤ kÃ¤ytÃ¶ssÃ¤',0),(352529,9793,'no','Dager okkuperte',0),(352530,9793,'da','Dage besat',0),(352531,9793,'ko','ì°¨ì§€ í•˜ëŠ” ì¼',0),(352532,9793,'he','×™×ž×™× ×›×‘×©×•',0),(352533,9793,'el','Î—Î¼Î­ÏÎµÏ‚ ÎºÎ±Ï„Î­Î»Î±Î²Î±Î½',0),(352534,9793,'zh','å·²è¿‡å¤©æ•°\r\n',0),(352535,9793,'sv','Dagar ockuperade',0),(352536,9793,'it','Giorni occupati',0),(352537,9793,'tl','',0),(352538,9793,'th','&#3623;&#3633;&#3609;&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3629;&#3591;',0),(352539,9793,'hi','à¤¦à¤¿à¤¨ à¤ªà¤° à¤•à¤¬à¥à¤œà¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾',0),(352540,9793,'ms','Hari yang sibuk',0),(352541,9793,'ar','Ø§Ù„Ù…Ø­ØªÙ„Ø© ÙŠÙˆÙ…Ø§',0),(352542,9793,'fr','Jours occupÃ©s',0),(352543,9793,'jp','æ—¥å é ˜',0),(352544,9793,'pt','Dias ocupados',0),(352545,9793,'ru','Ð”Ð½Ð¸ Ð·Ð°Ð½ÑÑ‚Ñ‹',0),(352546,9793,'es','DÃ­as Ocupados',0),(352547,9793,'de','Tage besetzt',0),(352548,9793,'en','Days Occupied',0),(352549,9794,'is','',0),(352550,9794,'dr','Ø¯Ø±ØµØ¯ Ø§Ø´ØªØºØ§Ù„ ',0),(352551,9794,'pr','Ø¯Ø±ØµØ¯ Ø§Ø´ØªØºØ§Ù„ ',0),(352552,9794,'tr','% Ä°ÅŸgal',0),(352553,9794,'pl','% ZawÃ³d',0),(352554,9794,'bg','% ÐžÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ',0),(352555,9794,'ur','% Ù‚Ø¨Ø¶Û',0),(352556,9794,'sr','% ÐžÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ˜Ðµ',0),(352557,9794,'vi','% chiáº¿m giá»¯',0),(352558,9794,'af','% Okkupasie',0),(352559,9794,'ro','% Ocupatia',0),(352560,9794,'et','% Okupatsiooni',0),(352561,9794,'si','% Poklic',0),(352562,9794,'ba','% Pendudukan',0),(352563,9794,'nl','% Bezetting',0),(352564,9794,'fi','% Ammatti',0),(352565,9794,'no','% Yrke',0),(352566,9794,'da','% BesÃ¦ttelse',0),(352567,9794,'ko','% ì ë ¹',0),(352568,9794,'he','% ×”×›×™×‘×•×©',0),(352569,9794,'el','% ÎšÎ±Ï„Î¿Ï‡Î®Ï‚',0),(352570,9794,'zh','ï¼…èŒä¸š\r\n',0),(352571,9794,'sv','% Ockupation',0),(352572,9794,'it','% Occupazione',0),(352573,9794,'tl','',0),(352574,9794,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3629;&#3634;&#3594;&#3637;&#3614;',0),(352575,9794,'hi','% à¤µà¥à¤¯à¤µà¤¸à¤¾à¤¯',0),(352576,9794,'ms','% Pekerjaan',0),(352577,9794,'ar','% Ø§Ù„Ø§Ø­ØªÙ„Ø§Ù„',0),(352578,9794,'fr','% Occupation',0),(352579,9794,'jp','% è·æ¥­',0),(352580,9794,'pt','% De ocupaÃ§Ã£o',0),(352581,9794,'ru','% ÐžÐºÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ',0),(352582,9794,'es','% Ocupado',0),(352583,9794,'de','% Besetzung',0),(352584,9794,'en','% Occupation',0),(352585,9795,'is','',0),(352586,9795,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ØªØµØ±Ù Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(352587,9795,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ØªØµØ±Ù Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(352588,9795,'tr','Ã–zellik iÅŸgal yÃ¶nergeleri',0),(352589,9795,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ zawÃ³d instrukcje',0),(352590,9795,'bg','Ð˜Ð¼Ð¾Ñ‚Ð¸ Ð¿Ñ€Ð¾Ñ„ÐµÑÐ¸Ñ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(352591,9795,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©Û’ Ù‚Ø¨Ø¶Û’ Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(352592,9795,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ Ð¾ÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ˜Ðµ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(352593,9795,'vi','chá»‰ dáº«n giá»¯ tÃ i sáº£n',0),(352594,9795,'af','Eiendom Okkupasie Instruksies',0),(352595,9795,'ro','InstrucÅ£iuni de ocupaÅ£ie proprietate',0),(352596,9795,'et','Majutusasutuse okupatsiooni juhiseid',0),(352597,9795,'si','Lastnost poklic navodila',0),(352598,9795,'ba','Properti pendudukan petunjuk',0),(352599,9795,'nl','Eigenschap bezetting instructies',0),(352600,9795,'fi','Ominaisuuden miehityksen ohjeet',0),(352601,9795,'no','Egenskapen yrke instruksjoner',0),(352602,9795,'da','Egenskaben besÃ¦ttelse instruktioner',0),(352603,9795,'ko','ì†ì„± ì§ì—… ì§€ì¹¨',0),(352604,9795,'he','×”×ž××¤×™×™×Ÿ ×¢×™×¡×•×§ ×”×•×¨××•×ª',0),(352605,9795,'el','Î¤Î¿ ÎºÎ±Ï„Î¬Î»Ï…Î¼Î± ÎºÎ±Ï„Î¿Ï‡Î®Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(352606,9795,'zh','å±žæ€§å ç”¨æŒ‡ç¤º\r\n',0),(352607,9795,'sv','Boendet ockupationen instruktioner',0),(352608,9795,'it','ProprietÃ  occupazione istruzioni',0),(352609,9795,'tl','',0),(352610,9795,'th','&#3588;&#3635;&#3649;&#3609;&#3632;&#3609;&#3635;&#3607;&#3637;&#3656;&#3604;&#3636;&#3609;&#3607;&#3637;&#3656;&#3588;&#3619;&#3629;&#3610;&#3588;&#3619;&#3629;&#3591;',0),(352611,9795,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤¬à¥à¤œà¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(352612,9795,'ms','Arahan menduduki harta tanah',0),(352613,9795,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ø­ØªÙ„Ø§Ù„ Ø§Ù„Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(352614,9795,'fr','Instructions dâ€™Occupation de propriÃ©tÃ©',0),(352615,9795,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£è·æ¥­æŒ‡ç¤º',0),(352616,9795,'pt','InstruÃ§Ãµes de ocupaÃ§Ã£o de propriedade.',0),(352617,9795,'ru','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð¾ÐºÐºÑƒÐ¿Ð°Ñ†Ð¸Ð¾Ð½Ð½Ñ‹Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(352618,9795,'es','Instrucciones de OcupaciÃ³n de Propiedad',0),(352619,9795,'de','Eigenschaft Beruf Anweisungen',0),(352620,9795,'en','Property Occupation Instructions',0),(352621,9796,'is','',0),(352622,9796,'dr','(Ø´ØºÙ„',0),(352623,9796,'pr','ÙˆØ§Ø­Ø¯ Ø§Ø´ØªØºØ§Ù„(Ø´ØºÙ„',0),(352624,9796,'tr','Birim iÅŸgal',0),(352625,9796,'pl','Jednostki pracy',0),(352626,9796,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð¾ÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ',0),(352627,9796,'ur','ÛŒÙˆÙ†Ù¹ Ù‚Ø¨Ø¶Û’',0),(352628,9796,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¾ÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ˜Ðµ',0),(352629,9796,'vi','ÄÆ¡n vá»‹ nghá» nghiá»‡p',0),(352630,9796,'af','Eenheid beroep',0),(352631,9796,'ro','Unitate de ocupaÅ£ie',0),(352632,9796,'et','Ãœksuse okupatsiooni',0),(352633,9796,'si','Dejavnost enote',0),(352634,9796,'ba','Pendudukan unit',0),(352635,9796,'nl','Eenheid bezetting',0),(352636,9796,'fi','YksikkÃ¶ ammatti',0),(352637,9796,'no','Enheten yrke',0),(352638,9796,'da','Enhed besÃ¦ttelse',0),(352639,9796,'ko','ë‹¨ìœ„ ì§ì—…',0),(352640,9796,'he','×™×—×™×“×ª ×”×›×™×‘×•×©',0),(352641,9796,'el','ÎœÎ¿Î½Î¬Î´Î± ÎºÎ±Ï„Î¿Ï‡Î®Ï‚',0),(352642,9796,'zh','å•ä½å ç”¨\r\n',0),(352643,9796,'sv','Enheten ockupation',0),(352644,9796,'it','Occupazione di unitÃ ',0),(352645,9796,'tl','',0),(352646,9796,'th','&#3627;&#3609;&#3656;&#3623;&#3618;&#3629;&#3634;&#3594;&#3637;&#3614;',0),(352647,9796,'hi','à¤µà¥à¤¯à¤µà¤¸à¤¾à¤¯ à¤‡à¤•à¤¾à¤ˆ',0),(352648,9796,'ms','Pekerjaan unit',0),(352649,9796,'ar','Ø§Ù„Ø§Ø­ØªÙ„Ø§Ù„ ÙˆØ­Ø¯Ø©',0),(352650,9796,'fr','Occupation de lâ€™unitÃ©',0),(352651,9796,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã®è·æ¥­',0),(352652,9796,'pt','OcupaÃ§Ã£o de unidade',0),(352653,9796,'ru','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð¾ÐºÐºÑƒÐ¿Ð°Ñ†Ð¸Ð¸',0),(352654,9796,'es','OcupaciÃ³n de Unidad',0),(352655,9796,'de','Einheit-Besetzung',0),(352656,9796,'en','Unit Occupation',0),(352657,9797,'is','',0),(352658,9797,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±Ø­Ù„Ù‡ ',0),(352659,9797,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø±Ø­Ù„Ù‡ ',0),(352660,9797,'tr','AÅŸama Ekle',0),(352661,9797,'pl','Dodaj etap',0),(352662,9797,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÑ‚Ð°Ð¿',0),(352663,9797,'ur','Ù…Ø±Ø­Ù„Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(352664,9797,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ„Ð°Ð·Ð°',0),(352665,9797,'vi','ThÃªm giai Ä‘oáº¡n',0),(352666,9797,'af','Voeg stadium',0),(352667,9797,'ro','Adauga etapa',0),(352668,9797,'et','Lisa etapp',0),(352669,9797,'si','Dodaj stopnjo',0),(352670,9797,'ba','Menambahkan tahap',0),(352671,9797,'nl','Toevoegen van podium',0),(352672,9797,'fi','LisÃ¤Ã¤ vaihe',0),(352673,9797,'no','Legge til scenen',0),(352674,9797,'da','TilfÃ¸je fase',0),(352675,9797,'ko','ë‹¨ê³„ ì¶”ê°€',0),(352676,9797,'he','×”×•×¡×£ ×©×œ×‘',0),(352677,9797,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î±Î´Î¯Î¿Ï…',0),(352678,9797,'zh','å¢žåŠ é˜¶æ®µ\r\n',0),(352679,9797,'sv','LÃ¤gga till Stadium',0),(352680,9797,'it','Aggiungere Stage',0),(352681,9797,'tl','',0),(352682,9797,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;',0),(352683,9797,'hi','à¤šà¤°à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(352684,9797,'ms','Tambah peringkat',0),(352685,9797,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø±Ø­Ù„Ø©',0),(352686,9797,'fr','Ajouter stade',0),(352687,9797,'jp','ã‚¹ãƒ†ãƒ¼ã‚¸ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(352688,9797,'pt','Adicionar a fase',0),(352689,9797,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑ‚Ð°Ð¿',0),(352690,9797,'es','Agregar Etapa',0),(352691,9797,'de','Phase hinzufÃ¼gen',0),(352692,9797,'en','Add Stage',0),(352693,9798,'is','',0),(352694,9798,'dr','Ù…Ø¬Ø§Ø²',0),(352695,9798,'pr','Ù…Ø¬Ø§Ø²',0),(352696,9798,'tr','Ä°zin verilen',0),(352697,9798,'pl','Dozwolone',0),(352698,9798,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(352699,9798,'ur','Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(352700,9798,'sr','Ð”Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(352701,9798,'vi','ÄÆ°á»£c cho phÃ©p',0),(352702,9798,'af','Toegelaat',0),(352703,9798,'ro','Permis',0),(352704,9798,'et','Lubatud',0),(352705,9798,'si','Dovoljeno',0),(352706,9798,'ba','Diperbolehkan',0),(352707,9798,'nl','Toegestaan',0),(352708,9798,'fi','Internet',0),(352709,9798,'no','Tillatt',0),(352710,9798,'da','Tilladt',0),(352711,9798,'ko','í—ˆìš©',0),(352712,9798,'he','×ž××•×¤×©×¨',0),(352713,9798,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(352714,9798,'zh','å…è®¸\r\n',0),(352715,9798,'sv','TillÃ¥tna',0),(352716,9798,'it','Ammessi',0),(352717,9798,'tl','',0),(352718,9798,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;',0),(352719,9798,'hi','à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(352720,9798,'ms','Dibenarkan',0),(352721,9798,'ar','Ù…Ø³Ù…ÙˆØ­',0),(352722,9798,'fr','Permis',0),(352723,9798,'jp','è¨±å¯',0),(352724,9798,'pt','Permitida',0),(352725,9798,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾',0),(352726,9798,'es','Permitido',0),(352727,9798,'de','Erlaubt',0),(352728,9798,'en','Allowed',0),(352729,9799,'is','',0),(352730,9799,'dr','Ø§Ø¬Ø§Ø²Ù‡ ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§',0),(352731,9799,'pr','Ø§Ø¬Ø§Ø²Ù‡ ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§',0),(352732,9799,'tr','Eylemler saÄŸlar',0),(352733,9799,'pl','UmoÅ¼liwia dziaÅ‚ania',0),(352734,9799,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»ÑÐ²Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(352735,9799,'ur','Ø¹Ù…Ù„ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒØªØ§ ÛÛ’',0),(352736,9799,'sr','ÐžÐ¼Ð¾Ð³ÑƒÑ›Ð°Ð²Ð° Ñ€Ð°Ð´ÑšÐµ',0),(352737,9799,'vi','Cho phÃ¡p thao tÃ¡c',0),(352738,9799,'af','Aksies Toelaat',0),(352739,9799,'ro','Permite acÅ£iuni',0),(352740,9799,'et','VÃµimaldab meetmete',0),(352741,9799,'si','OmogoÄa dejanja',0),(352742,9799,'ba','Memungkinkan tindakan',0),(352743,9799,'nl','Toegestane acties\r\n',0),(352744,9799,'fi','Ansiosta toimet',0),(352745,9799,'no','Lar handlinger',0),(352746,9799,'da','Tillader handlinger',0),(352747,9799,'ko','ìž‘ì—… ìˆ˜',0),(352748,9799,'he','×ž××¤×©×¨ ×¤×¢×•×œ×•×ª',0),(352749,9799,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€ÎµÎ¹ Î´ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(352750,9799,'zh','å…è®¸åŠ¨ä½œ\r\n',0),(352751,9799,'sv','GÃ¶r Ã¥tgÃ¤rder',0),(352752,9799,'it','Consente le operazioni di',0),(352753,9799,'tl','',0),(352754,9799,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3651;&#3627;&#3657;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3591;&#3634;&#3609;',0),(352755,9799,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤¤à¤¾ à¤¹à¥ˆ',0),(352756,9799,'ms','Membolehkan tindakan',0),(352757,9799,'ar','ØªØ³Ù…Ø­ Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª',0),(352758,9799,'fr','Autorise les Actions de',0),(352759,9799,'jp','æ“ä½œã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(352760,9799,'pt','Permite que as aÃ§Ãµes',0),(352761,9799,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ°ÐµÑ‚ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(352762,9799,'es','Se Permite Acciones',0),(352763,9799,'de','Aktionen kÃ¶nnen',0),(352764,9799,'en','Allows Actions',0),(352765,9800,'is','',0),(352766,9800,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…Ø¬Ø§Ø²',0),(352767,9800,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…Ø¬Ø§Ø²',0),(352768,9800,'tr','Yetkili grup',0),(352769,9800,'pl','Autoryzowane grupy',0),(352770,9800,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸',0),(352771,9800,'ur','Ù…Ø¬Ø§Ø² Ú¯Ø±ÙˆÙ¾',0),(352772,9800,'sr','ÐžÐ²Ð»Ð°ÑˆÑ›ÐµÐ½Ð¸ Ð³Ñ€ÑƒÐ¿Ðµ',0),(352773,9800,'vi','Quyá»n cá»§a nhÃ³m',0),(352774,9800,'af','Gemagtigde Groepe',0),(352775,9800,'ro','Autorizat grupuri',0),(352776,9800,'et','Volitatud rÃ¼hmad',0),(352777,9800,'si','PooblaÅ¡Äeni skupine',0),(352778,9800,'ba','Kelompok-kelompok yang berwenang',0),(352779,9800,'nl','Geautoriseerde groepen',0),(352780,9800,'fi','Lupa ryhmÃ¤t',0),(352781,9800,'no','Autoriserte grupper',0),(352782,9800,'da','Etablerede grupper',0),(352783,9800,'ko','ê¶Œí•œì´ ë¶€ì—¬ ëœ ê·¸ë£¹',0),(352784,9800,'he','×§×‘×•×¦×•×ª ×ž×•×¨×©×”',0),(352785,9800,'el','Î•Î¾Î¿Ï…ÏƒÎ¹Î¿Î´Î¿Ï„Î·Î¼Î­Î½ÎµÏ‚ Î¿Î¼Î¬Î´ÎµÏ‚',0),(352786,9800,'zh','æŽˆæƒç»„\r\n',0),(352787,9800,'sv','Auktoriserade grupper',0),(352788,9800,'it','Gruppi autorizzati',0),(352789,9800,'tl','',0),(352790,9800,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3607;&#3637;&#3656;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(352791,9800,'hi','à¤…à¤§à¤¿à¤•à¥ƒà¤¤ à¤¸à¤®à¥‚à¤¹',0),(352792,9800,'ms','Kumpulan yang diberi kuasa',0),(352793,9800,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø®ÙˆÙ‘Ù„Ø©',0),(352794,9800,'fr','Groupes autorisÃ©s',0),(352795,9800,'jp','èªå®šã‚°ãƒ«ãƒ¼ãƒ—',0),(352796,9800,'pt','Grupos autorizados',0),(352797,9800,'ru','ÐÐ²Ñ‚Ð¾Ñ€Ð¸Ð·Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(352798,9800,'es','Grupos Autorizados',0),(352799,9800,'de','Autorisierte Gruppen',0),(352800,9800,'en','Authorized Groups',0),(352801,9801,'is','',0),(352802,9801,'dr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ù…Ø¬Ø§Ø²',0),(352803,9801,'pr','ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ù…Ø¬Ø§Ø²',0),(352804,9801,'tr','Yetkili kullanÄ±cÄ±lar',0),(352805,9801,'pl','Autoryzowanych uÅ¼ytkownikÃ³w',0),(352806,9801,'bg','ÐžÑ‚Ð¾Ñ€Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(352807,9801,'ur','Ù…Ø¬Ø§Ø² ØµØ§Ø±ÙÛŒÙ†',0),(352808,9801,'sr','ÐÑƒÑ‚Ð¾Ñ€Ð¸Ð·Ð¾Ð²Ð°Ð½Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸',0),(352809,9801,'vi','Quyá»n ngÆ°á»i sá»­ dá»¥ng',0),(352810,9801,'af','Gemagtigde Gebruikers',0),(352811,9801,'ro','Utilizatorii autorizaÈ›i',0),(352812,9801,'et','Volitatud kasutajad',0),(352813,9801,'si','PooblaÅ¡Äeni uporabniki',0),(352814,9801,'ba','Pengguna resmi',0),(352815,9801,'nl','Geautoriseerde gebruikers',0),(352816,9801,'fi','Valtuutetut kÃ¤yttÃ¤jÃ¤t',0),(352817,9801,'no','Autoriserte brukere',0),(352818,9801,'da','Autoriserede brugere',0),(352819,9801,'ko','ê¶Œí•œì´ ìžˆëŠ” ì‚¬ìš©ìž',0),(352820,9801,'he','×ž×©×ª×ž×©×™× ×ž×•×¨×©×™×',0),(352821,9801,'el','Î•Î¾Î¿Ï…ÏƒÎ¹Î¿Î´Î¿Ï„Î·Î¼Î­Î½Î¿Î¹ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(352822,9801,'zh','æŽˆæƒç”¨æˆ·\r\n',0),(352823,9801,'sv','Auktoriserade anvÃ¤ndare',0),(352824,9801,'it','Utenti autorizzati',0),(352825,9801,'tl','',0),(352826,9801,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;',0),(352827,9801,'hi','à¤…à¤§à¤¿à¤•à¥ƒà¤¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(352828,9801,'ms','Pengguna-pengguna berdaftar',0),(352829,9801,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ù…Ø®ÙˆÙ„ÙŠÙ†',0),(352830,9801,'fr','Utilisateurs autorisÃ©s',0),(352831,9801,'jp','æ‰¿èªã•ã‚ŒãŸãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(352832,9801,'pt','UsuÃ¡rios autorizados',0),(352833,9801,'ru','ÐÐ²Ñ‚Ð¾Ñ€Ð¸Ð·Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸',0),(352834,9801,'es','Usuarios Autorizados',0),(352835,9801,'de','Autorisierte Benutzer',0),(352836,9801,'en','Authorized Users',0),(352837,9802,'is','',0),(352838,9802,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®ÙˆØ¯ÙƒØ§Ø±',0),(352839,9802,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø®ÙˆØ¯ÙƒØ§Ø±',0),(352840,9802,'tr','Otomatik tetik',0),(352841,9802,'pl','Automatyczny spust',0),(352842,9802,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÐ½ Ð¿Ñ€ÐµÐ²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ÐµÐ»',0),(352843,9802,'ur','Ø®ÙˆØ¯Ú©Ø§Ø± Ù¹Ø±ÛŒÚ¯Ø±',0),(352844,9802,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð¾ÐºÐ¸Ð´Ð°Ñ‡',0),(352845,9802,'vi','Tá»± ÄÃ´ng kÃ­ch hoáº¡t',0),(352846,9802,'af','Outomatiese sneller',0),(352847,9802,'ro','DeclanÅŸare automatÄƒ',0),(352848,9802,'et','Automaatne vallandada',0),(352849,9802,'si','Samodejne sproÅ¾itve',0),(352850,9802,'ba','Otomatis memicu',0),(352851,9802,'nl','Automatische Trigger',0),(352852,9802,'fi','Automaattinen kÃ¤ynnistys',0),(352853,9802,'no','Automatisk utlÃ¸ser',0),(352854,9802,'da','Automatisk udlÃ¸ser',0),(352855,9802,'ko','ìžë™ íŠ¸ë¦¬ê±°',0),(352856,9802,'he','×ž×¤×¢×™×œ ××•×˜×•×ž×˜×™×ª',0),(352857,9802,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î·Ï‚ ÏƒÎºÎ±Î½Î´Î¬Î»Î·Ï‚',0),(352858,9802,'zh','è‡ªåŠ¨è§¦å‘\r\n',0),(352859,9802,'sv','Automatisk utlÃ¶sare',0),(352860,9802,'it','Levetta di comando automatica',0),(352861,9802,'tl','',0),(352862,9802,'th','&#3585;&#3621;&#3652;&#3621;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;',0),(352863,9802,'hi','à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤Ÿà¥à¤°à¤¿à¤—à¤°',0),(352864,9802,'ms','Pencetus automatik',0),(352865,9802,'ar','Ø§Ù„Ø²Ù†Ø§Ø¯ Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(352866,9802,'fr','DÃ©clenchement automatique',0),(352867,9802,'jp','è‡ªå‹•ãƒˆãƒªã‚¬ãƒ¼',0),(352868,9802,'pt','Disparador automÃ¡tico',0),(352869,9802,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð¼ÐµÑ…Ð°Ð½Ð¸Ð·Ð¼',0),(352870,9802,'es','Gato Automatico',0),(352871,9802,'de','Automatische AuslÃ¶sung',0),(352872,9802,'en','Automatic Trigger',0),(352873,9803,'is','',0),(352874,9803,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(352875,9803,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(352876,9803,'tr','Veri baÅŸarÄ±yla kaydedildi',0),(352877,9803,'pl','Dane zapisane pomyÅ›lnie',0),(352878,9803,'bg','Ð”Ð°Ð½Ð½Ð¸, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(352879,9803,'ur','Ú©ÙˆØ§Ø¦Ù Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸',0),(352880,9803,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ñ‡ÑƒÐ²Ð°Ñ˜Ñƒ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(352881,9803,'vi','ÄÃ£ lÆ°u dá»¯ liá»‡u thÃ nh cÃ´ng',0),(352882,9803,'af','Data Suksesvol Gestoor',0),(352883,9803,'ro','Date salvat cu succes',0),(352884,9803,'et','Andmed salvestati edukalt',0),(352885,9803,'si','Podatkov, shranjen',0),(352886,9803,'ba','Data yang disimpan berhasil',0),(352887,9803,'nl','Gegevens succesvol opgeslagen',0),(352888,9803,'fi','Tietojen tallentaminen onnistui',0),(352889,9803,'no','Data lagret',0),(352890,9803,'da','Data gemt med succes',0),(352891,9803,'ko','ë°ì´í„°ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(352892,9803,'he','×”× ×ª×•× ×™× × ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(352893,9803,'el','Î”ÎµÎ´Î¿Î¼Î­Î½Î± Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(352894,9803,'zh','æ•°æ®ä¿å­˜æˆåŠŸ\r\n',0),(352895,9803,'sv','Data har sparats',0),(352896,9803,'it','Dati salvati con successo',0),(352897,9803,'tl','',0),(352898,9803,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3648;&#3619;&#3637;&#3618;&#3610;&#3619;&#3657;&#3629;&#3618;',0),(352899,9803,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(352900,9803,'ms','Data yang berjaya disimpan',0),(352901,9803,'ar','Ø­ÙØ¸Øª Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(352902,9803,'fr','DonnÃ©es enregistrÃ©es avec succÃ¨s',0),(352903,9803,'jp','ãƒ‡ãƒ¼ã‚¿ãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(352904,9803,'pt','Dados salvos com sucesso',0),(352905,9803,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(352906,9803,'es','Datos Guardados Exitosamente',0),(352907,9803,'de','Daten erfolgreich gespeichert',0),(352908,9803,'en','Data Saved Successfully',0),(352909,9804,'is','',0),(352910,9804,'dr','( Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(352911,9804,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù Ø³Ø§Ø¨Ù‚Ù‡ ( Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(352912,9804,'tr','KayÄ±t silme hatasÄ±',0),(352913,9804,'pl','BÅ‚Ä…d podczas usuwania rekordu',0),(352914,9804,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(352915,9804,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(352916,9804,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð·Ð°Ð¿Ð¸ÑÐ°',0),(352917,9804,'vi','Lá»—i khi xÃ³a há»“ sÆ¡',0),(352918,9804,'af','Fout rekord te skrap',0),(352919,9804,'ro','Eroare la È™tergerea Record',0),(352920,9804,'et','TÃµrge kirje kustutamisel',0),(352921,9804,'si','Napaka pri brisanju zapisa',0),(352922,9804,'ba','Error menghapus Record',0),(352923,9804,'nl','Fout bij het verwijderen van de Record',0),(352924,9804,'fi','Virhe poistettaessa tietuetta',0),(352925,9804,'no','Feil ved sletting av post',0),(352926,9804,'da','Fejl ved sletning af post',0),(352927,9804,'ko','ë ˆì½”ë“œ ì‚­ì œ ì˜¤ë¥˜',0),(352928,9804,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×¨×©×•×ž×”',0),(352929,9804,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(352930,9804,'zh','é”™è¯¯åˆ é™¤è®°å½•',0),(352931,9804,'sv','Fel ta bort post',0),(352932,9804,'it','Errore durante l\'eliminazione di Record',0),(352933,9804,'tl','',0),(352934,9804,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;',0),(352935,9804,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(352936,9804,'ms','Ralat Menghapuskan rekod',0),(352937,9804,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø³Ø¬Ù„',0),(352938,9804,'fr','Erreur de suppression de dossier',0),(352939,9804,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’å‰Šé™¤ä¸­ã«ã‚¨ãƒ©ãƒ¼',0),(352940,9804,'pt','Erro ao excluir o registro',0),(352941,9804,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(352942,9804,'es','Error Eliminando Record',0),(352943,9804,'de','Fehler beim Datensatz lÃ¶schen',0),(352944,9804,'en','Error Deleting Record',0),(352945,9805,'is','',0),(352946,9805,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(352947,9805,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(352948,9805,'tr','Verileri gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(352949,9805,'pl','BÅ‚Ä…d aktualizacji danych',0),(352950,9805,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ',0),(352951,9805,'ur','Ú©ÙˆØ§Ø¦Ù Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(352952,9805,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(352953,9805,'vi','Lá»—i khi cáº­p nháº­t dá»¯ liá»‡u',0),(352954,9805,'af','Fout met Opdatering van Data',0),(352955,9805,'ro','Eroare la actualizarea datelor',0),(352956,9805,'et','TÃµrge andmete uuendamine',0),(352957,9805,'si','Napaka pri posodabljanju podatkov',0),(352958,9805,'ba','Kesalahan memperbarui Data',0),(352959,9805,'nl','Fout bij het bijwerken van gegevens',0),(352960,9805,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tietoja',0),(352961,9805,'no','Feil under oppdatering av Data',0),(352962,9805,'da','Fejl under opdatering af Data',0),(352963,9805,'ko','ë°ì´í„°ë¥¼ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì˜¤ë¥˜',0),(352964,9805,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ × ×ª×•× ×™×',0),(352965,9805,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(352966,9805,'zh','æ›´æ–°æ•°æ®é”™è¯¯\r\n',0),(352967,9805,'sv','Fel vid uppdatering av Data',0),(352968,9805,'it','Errore durante l\'aggiornamento dei dati',0),(352969,9805,'tl','',0),(352970,9805,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(352971,9805,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(352972,9805,'ms','Ralat dalam mengemas kini Data',0),(352973,9805,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(352974,9805,'fr','Erreur mise Ã  jour de donnÃ©es',0),(352975,9805,'jp','ãƒ‡ãƒ¼ã‚¿ã‚’æ›´æ–°ä¸­ã®ã‚¨ãƒ©ãƒ¼',0),(352976,9805,'pt','Erro ao atualizar dados',0),(352977,9805,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(352978,9805,'es','Error Actualizando Datos',0),(352979,9805,'de','Fehler beim Aktualisieren von Daten',0),(352980,9805,'en','Error Updating Data',0),(352981,9806,'is','',0),(352982,9806,'dr','ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ Ø¨Ø§Ø²Ø¯Ø§Ø±Ù†Ø¯Ù‡',0),(352983,9806,'pr','ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ Ø¨Ø§Ø²Ø¯Ø§Ø±Ù†Ø¯Ù‡',0),(352984,9806,'tr','Eylemleri engeller',0),(352985,9806,'pl','Zapobiega dziaÅ‚ania',0),(352986,9806,'bg','ÐŸÑ€ÐµÐ´Ð¾Ñ‚Ð²Ñ€Ð°Ñ‚ÑÐ²Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(352987,9806,'ur','Ø§Ø¹Ù…Ø§Ù„ Ú©Ùˆ Ø±ÙˆÚ©ØªØ§ ÛÛ’',0),(352988,9806,'sr','Ð¡Ð¿Ñ€ÐµÑ‡Ð°Ð²Ð° Ñ€Ð°Ð´ÑšÐµ',0),(352989,9806,'vi','cháº·n hÃ nh Ä‘á»™ng',0),(352990,9806,'af','Voorkom Aksies',0),(352991,9806,'ro','Previne acÅ£iuni',0),(352992,9806,'et','Takistab meetmete',0),(352993,9806,'si','PrepreÄi dejanja',0),(352994,9806,'ba','Mencegah tindakan',0),(352995,9806,'nl','Acties niet meer mogelijk',0),(352996,9806,'fi','EstÃ¤Ã¤ toimia',0),(352997,9806,'no','Forhindrer handlinger',0),(352998,9806,'da','Forhindrer handlinger',0),(352999,9806,'ko','ìž‘ì—… ë°©ì§€',0),(353000,9806,'he','×ž×•× ×¢×ª ×¤×¢×•×œ×•×ª',0),(353001,9806,'el','Î‘Ï€Î¿Ï„ÏÎ­Ï€ÎµÎ¹ ÎµÎ½Î­ÏÎ³ÎµÎ¹ÎµÏ‚',0),(353002,9806,'zh','é˜²æ­¢è¡ŒåŠ¨\r\n',0),(353003,9806,'sv','FÃ¶rhindrar Ã¥tgÃ¤rder',0),(353004,9806,'it','Impedisce azioni',0),(353005,9806,'tl','',0),(353006,9806,'th','&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3611;&#3657;&#3629;&#3591;&#3585;&#3633;&#3609;',0),(353007,9806,'hi','à¤•à¥à¤°à¤¿à¤¯à¤¾à¤“à¤‚ à¤•à¥‹ à¤°à¥‹à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(353008,9806,'ms','Menghalang tindakan',0),(353009,9806,'ar','ÙŠÙ…Ù†Ø¹ Ø§ØªØ®Ø§Ø° Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª',0),(353010,9806,'fr','EmpÃªche les Actions',0),(353011,9806,'jp','æ“ä½œã‚’é˜²æ­¢ã—ã¾ã™ã€‚',0),(353012,9806,'pt','Impede que as acÃ§Ãµes',0),(353013,9806,'ru','ÐŸÑ€ÐµÐ´Ð¾Ñ‚Ð²Ñ€Ð°Ñ‰Ð°ÐµÑ‚ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(353014,9806,'es','Se Previene Acciones',0),(353015,9806,'de','Verhindert, dass Aktionen',0),(353016,9806,'en','Prevents Actions',0),(353017,9807,'is','',0),(353018,9807,'dr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(353019,9807,'pr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(353020,9807,'tr','KaydÄ± baÅŸarÄ±yla silindi',0),(353021,9807,'pl','UsuniÄ™ty rekord',0),(353022,9807,'bg','Ð—Ð°Ð¿Ð¸ÑÑŠÑ‚ Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(353023,9807,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒØ§',0),(353024,9807,'sr','Ð—Ð°Ð¿Ð¸Ñ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(353025,9807,'vi','Ä‘Ã£ xÃ³a há»“ sÆ¡ thÃ nh cÃ´ng',0),(353026,9807,'af','Rekord suskesvol geskrap',0),(353027,9807,'ro','ÃŽnregistrare ÅŸtearsÄƒ cu succes',0),(353028,9807,'et','Edukalt kustutatud kirje',0),(353029,9807,'si','Zapis uspeÅ¡no izbrisana',0),(353030,9807,'ba','Catatan dihapus berhasil',0),(353031,9807,'nl','Record met succes verwijderd',0),(353032,9807,'fi','Tietue poistettu',0),(353033,9807,'no','Posten ble slettet',0),(353034,9807,'da','Posten slettet',0),(353035,9807,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ë ˆì½”ë“œ',0),(353036,9807,'he','×©×™× × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(353037,9807,'el','Î•Î³Î³ÏÎ±Ï†Î® Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(353038,9807,'zh','è®°å½•åˆ é™¤æˆåŠŸ\r\n',0),(353039,9807,'sv','Rekord raderades',0),(353040,9807,'it','Record eliminato con successo',0),(353041,9807,'tl','',0),(353042,9807,'th','&#3611;&#3619;&#3632;&#3623;&#3633;&#3605;&#3636;&#3606;&#3641;&#3585;&#3626;&#3635;&#3648;&#3619;&#3657;&#3592;',0),(353043,9807,'hi','à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(353044,9807,'ms','Rekod dihapuskan dengan jayanya',0),(353045,9807,'ar','Ø­Ø°Ù Ø§Ù„Ø³Ø¬Ù„Ù‘ Ø¨Ù†Ø¬Ø§Ø­',0),(353046,9807,'fr','Dossier supprimÃ© avec succÃ¨s',0),(353047,9807,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ãŒå‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(353048,9807,'pt','Registro excluÃ­do com sucesso',0),(353049,9807,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð°',0),(353050,9807,'es','Record Eliminado Exitosamente',0),(353051,9807,'de','Datensatz wurde erfolgreich gelÃ¶scht',0),(353052,9807,'en','Record Deleted Successfully',0),(353053,9808,'is','',0),(353054,9808,'dr','(Ù…Ø¯Ù„- Ù…Ù‚ÙŠØ§Ø³',0),(353055,9808,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ù…ÙˆÙ†Ù‡(Ù…Ø¯Ù„- Ù…Ù‚ÙŠØ§Ø³',0),(353056,9808,'tr','ModÃ¼l seÃ§in',0),(353057,9808,'pl','Wybierz moduÅ‚',0),(353058,9808,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¼Ð¾Ð´ÑƒÐ»',0),(353059,9808,'ur','Ù…Ø§ÚˆÛŒÙˆÙ„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(353060,9808,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼Ð¾Ð´ÑƒÐ»',0),(353061,9808,'vi','chá»n mÃ´-Ä‘un',0),(353062,9808,'af','Selekteer Module',0),(353063,9808,'ro','SelectaÅ£i modul',0),(353064,9808,'et','Vali moodul',0),(353065,9808,'si','Izberite modul',0),(353066,9808,'ba','Pilih modul',0),(353067,9808,'nl','Selecteer Module',0),(353068,9808,'fi','Valitse moduuli',0),(353069,9808,'no','Velg modul',0),(353070,9808,'da','VÃ¦lg modul',0),(353071,9808,'ko','ëª¨ë“ˆ ì„ íƒ',0),(353072,9808,'he','×‘×—×¨ ×ž×•×“×•×œ',0),(353073,9808,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎµÎ½ÏŒÏ„Î·Ï„Î±',0),(353074,9808,'zh','é€‰æ‹©æ¨¡å—\r\n',0),(353075,9808,'sv','VÃ¤lj modul',0),(353076,9808,'it','Selezionare il modulo',0),(353077,9808,'tl','',0),(353078,9808,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3650;&#3617;&#3604;&#3641;&#3621;',0),(353079,9808,'hi','à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(353080,9808,'ms','Pilih modul',0),(353081,9808,'ar','Ø­Ø¯Ø¯ Ø§Ù„ÙˆØ­Ø¯Ø© Ø§Ù„Ù†Ù…Ø·ÙŠØ©',0),(353082,9808,'fr','SÃ©lectionnez le Module',0),(353083,9808,'jp','ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(353084,9808,'pt','Selecione o mÃ³dulo',0),(353085,9808,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐœÐ¾Ð´ÑƒÐ»ÑŒ',0),(353086,9808,'es','Selecciona Modulo',0),(353087,9808,'de','WÃ¤hlen Sie Modul',0),(353088,9808,'en','Select Module',0),(353089,9809,'is','',0),(353090,9809,'dr','Ù…Ø±Ø­Ù„Ù‡ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ',0),(353091,9809,'pr','Ù…Ø±Ø­Ù„Ù‡ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ',0),(353092,9809,'tr','Sahne kurulumu',0),(353093,9809,'pl','Etap konfiguracji',0),(353094,9809,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÑÑ†ÐµÐ½Ð°Ñ‚Ð°',0),(353095,9809,'ur','Ø§Ø³Ù¹ÛŒØ¬ Ø³ÛŒÙ¹ Ø§Ù¾',0),(353096,9809,'sr','Ð¤Ð°Ð·Ð¸ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ðµ',0),(353097,9809,'vi','Thiáº¿t láº­p giai Ä‘oáº¡n',0),(353098,9809,'af','Stadium opstelling',0),(353099,9809,'ro','Faza de configurare',0),(353100,9809,'et','Projektietapi seadistus',0),(353101,9809,'si','Fazi Setup',0),(353102,9809,'ba','Tahap Setup',0),(353103,9809,'nl','Fase instelling',0),(353104,9809,'fi','Vaiheasetusten',0),(353105,9809,'no','Scenen oppsett',0),(353106,9809,'da','StadieopsÃ¦tningen',0),(353107,9809,'ko','ë¬´ëŒ€ ì„¤ì¹˜',0),(353108,9809,'he','×©×œ×‘ ×”×”×ª×§× ×”',0),(353109,9809,'el','Î£Ï„Î¬Î´Î¹Î¿ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(353110,9809,'zh','é˜¶æ®µå®‰è£…\r\n',0),(353111,9809,'sv','Skede Setup',0),(353112,9809,'it','Fase di installazione',0),(353113,9809,'tl','',0),(353114,9809,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸‚à¸±à¹‰à¸™',0),(353115,9809,'hi','à¤šà¤°à¤£ à¤¸à¥à¤¥à¤¾à¤ªà¤¨à¤¾',0),(353116,9809,'ms','Peringkat persediaan',0),(353117,9809,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø±Ø­Ù„Ø©',0),(353118,9809,'fr','Installation de scÃ¨ne',0),(353119,9809,'jp','ã‚¹ãƒ†ãƒ¼ã‚¸ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(353120,9809,'pt','InstalaÃ§Ã£o de palco',0),(353121,9809,'ru','Ð­Ñ‚Ð°Ð¿ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(353122,9809,'es','CofiguraciÃ³n de Etapa',0),(353123,9809,'de','BÃ¼hne-Setup',0),(353124,9809,'en','Stage Setup',0),(353125,9810,'is','',0),(353126,9810,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ®ÙÙŠÙ ',0),(353127,9810,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ®ÙÙŠÙ ',0),(353128,9810,'tr','Ä°ndirim Ekle',0),(353129,9810,'pl','Dodaj rabat',0),(353130,9810,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(353131,9810,'ur','Ø±Ø¹Ø§ÛŒØª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(353132,9810,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(353133,9810,'vi','ThÃªm chiáº¿t kháº¥u',0),(353134,9810,'af','Korting Byvoeg ',0),(353135,9810,'ro','Adauga Discount',0),(353136,9810,'et','Lisa allahindlus',0),(353137,9810,'si','Dodaj popust',0),(353138,9810,'ba','Tambahkan DISKON',0),(353139,9810,'nl','Korting toevoegen',0),(353140,9810,'fi','LisÃ¤Ã¤ alennus',0),(353141,9810,'no','Legge til rabatt',0),(353142,9810,'da','TilfÃ¸je rabat',0),(353143,9810,'ko','ì¶”ê°€ í• ì¸',0),(353144,9810,'he','×”×•×¡×£ ×”× ×—×”',0),(353145,9810,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·',0),(353146,9810,'zh','å¢žåŠ æŠ˜æ‰£\r\n',0),(353147,9810,'sv','LÃ¤gg till rabatt',0),(353148,9810,'it','Aggiungere sconto',0),(353149,9810,'tl','',0),(353150,9810,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(353151,9810,'hi','à¤›à¥‚à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(353152,9810,'ms','Tambah diskaun',0),(353153,9810,'ar','Ø£Ø¶Ù ØªØ®ÙÙŠØ¶',0),(353154,9810,'fr','Ajouter Discount',0),(353155,9810,'jp','å‰²å¼•ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(353156,9810,'pt','Adicionar o desconto',0),(353157,9810,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡ÐºÐ¸Ð´ÐºÑƒ',0),(353158,9810,'es','Agregar Descuento',0),(353159,9810,'de','FÃ¼gen Sie Rabatt',0),(353160,9810,'en','Add Discount',0),(353161,9811,'is','',0),(353162,9811,'dr','ÙŠÙƒ ØªØ®ÙÙŠÙ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§  Ùˆ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(353163,9811,'pr','ÙŠÙƒ ØªØ®ÙÙŠÙ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§  Ùˆ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(353164,9811,'tr','Bu madde ve mÃ¼ÅŸteri mevcut bir indirim',0),(353165,9811,'pl','ZniÅ¼ki dla tego elementu i klienta juÅ¼ istnieje',0),(353166,9811,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(353167,9811,'ur','ÛŒÛ Ø´Û’ Ø§ÙˆØ± Ú¯Ø§ÛÚ© Ú©Ùˆ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Ú©Û’ Ù„Ø¦Û’ Ø±Ø¹Ø§ÛŒØª',0),(353168,9811,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð·Ð° Ñ‚Ð°Ñ˜ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð¸ ÐºÑƒÐ¿Ñ†Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(353169,9811,'vi','Giáº£m má»¥c nÃ y vÃ  khÃ¡ch hÃ ng Ä‘Ã£ Tá»“n táº¡i',0),(353170,9811,'af','\'n Korting vir hierdie Item en \'n Klant / KliÃ«nt Betaan reeds',0),(353171,9811,'ro','Un Discount pentru acest element ÅŸi client existÄƒ deja',0),(353172,9811,'et','Sellel tootel ja kliendil on juba allahindlus',0),(353173,9811,'si','Popust za ta artikel in kupca Å¾e obstaja',0),(353174,9811,'ba','Diskon untuk Item dan pelanggan sudah ada',0),(353175,9811,'nl','Een korting voor dit Item en de klant al bestaat',0),(353176,9811,'fi','Alennusta tÃ¤lle nimikkeelle ja asiakas on jo olemassa',0),(353177,9811,'no','Rabatt for denne vare og kunde finnes allerede',0),(353178,9811,'da','En rabat for denne vare og debitor findes allerede',0),(353179,9811,'ko','ì´ í•­ëª©ì„ ì´ë¯¸ ì¡´ìž¬ í•˜ëŠ” ê³ ê°ì— ëŒ€ í•œ í• ì¸',0),(353180,9811,'he','×”× ×—×” ×¢×‘×•×¨ ×¤×¨×™×˜ ×• ×œ×§×•×— ×§×™×™× ×›×‘×¨',0),(353181,9811,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÎ±Î¹ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Ï€ÎµÎ»Î¬Ï„Î·Ï‚',0),(353182,9811,'zh','æ­¤é¡¹ç›®çš„æŠ˜æ‰£ï¼Œå®¢æˆ·å·²ç»å­˜åœ¨\r\n',0),(353183,9811,'sv','Rabatt fÃ¶r denna artikel och kund finns redan',0),(353184,9811,'it','Esiste giÃ  uno sconto per questo oggetto e questo cliente',0),(353185,9811,'tl','',0),(353186,9811,'th','&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;&#3649;&#3621;&#3632;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3617;&#3637;&#3629;&#3',0),(353187,9811,'hi','à¤¯à¤¹ à¤†à¤‡à¤Ÿà¤® à¤”à¤° à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤›à¥‚à¤Ÿ',0),(353188,9811,'ms','Diskaun untuk Item ini dan pelanggan telah wujud',0),(353189,9811,'ar','ÙŠÙˆØ¬Ø¯ ØªØ®ÙÙŠØ¶ Ù…Ø³Ø¨Ù‚ Ù„Ù‡Ø°Ø§ Ø§Ù„ØµÙ†Ù ÙˆÙ‡Ø°Ø§ Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(353190,9811,'fr','Une remise pour cet article et le client existe dÃ©jÃ ',0),(353191,9811,'jp','ã“ã®é …ç›®ã¨é¡§å®¢ã¯æ—¢ã«å­˜åœ¨ã®å‰²å¼•',0),(353192,9811,'pt','Um desconto para este Item e o cliente jÃ¡ existe',0),(353193,9811,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð´Ð»Ñ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð¢Ð¾Ð²Ð°Ñ€Ð° Ð¸ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð£Ð¶Ðµ Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(353194,9811,'es','Un Descuennto para este Item y Cliente Ya Existe',0),(353195,9811,'de','Einen Rabatt fÃ¼r diesen Artikel und Kunden bereits vorhanden ist',0),(353196,9811,'en','A Discount for this Item and Customer Already Exists',0),(353197,9812,'is','',0),(353198,9812,'dr','ØªØ®ÙÙŠÙØ§Øª Ø®Ø±ÙŠØ¯Ø§Ø±ÙƒØ§Ù„Ø§   ',0),(353199,9812,'pr','ØªØ®ÙÙŠÙØ§Øª Ø®Ø±ÙŠØ¯Ø§Ø±ÙƒØ§Ù„Ø§   ',0),(353200,9812,'tr','MÃ¼ÅŸteri madde iskontolarÄ±',0),(353201,9812,'pl','Klienta elementu rabaty',0),(353202,9812,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(353203,9812,'ur','Ú©Ø³Ù¹Ù…Ø± Ø´Û’ Ø±Ø¹Ø§ÛŒØª',0),(353204,9812,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð° Ð½Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(353205,9812,'vi','hoa há»“ng cho khÃ¡ch hÃ ng',0),(353206,9812,'af','Klant / KliÃ«nt Item Kortings',0),(353207,9812,'ro','Reduceri de elementul client',0),(353208,9812,'et','Kliendi toodete allahindlused',0),(353209,9812,'si','Popusta artikla',0),(353210,9812,'ba','Pelanggan Item DISKON',0),(353211,9812,'nl','Klant artikelkortingen',0),(353212,9812,'fi','Asiakkaan nimikealennuksia',0),(353213,9812,'no','Kunden Varerabatter',0),(353214,9812,'da','Kunde vare rabatter',0),(353215,9812,'ko','ê³ ê° í•­ëª© í• ì¸',0),(353216,9812,'he','×”× ×—×•×ª ×¤×¨×™×˜ ×œ×§×•×—',0),(353217,9812,'el','Î•ÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(353218,9812,'zh','å®¢æˆ·é¡¹ç›®æŠ˜æ‰£\r\n',0),(353219,9812,'sv','Kunden artikelrabatter',0),(353220,9812,'it','Sconti cliente elemento',0),(353221,9812,'tl','',0),(353222,9812,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(353223,9812,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤†à¤‡à¤Ÿà¤® à¤›à¥‚à¤Ÿ',0),(353224,9812,'ms','Baca Item diskaun',0),(353225,9812,'ar','ØªØ®ÙÙŠØ¶Ø§Øª Ø§Ù„ØµÙ†Ù Ù„Ù„Ø²Ø¨ÙˆÙ†',0),(353226,9812,'fr','Remises de poste client',0),(353227,9812,'jp','é¡§å®¢ã®å‰²å¼•é …ç›®',0),(353228,9812,'pt','Descontos de Item do cliente',0),(353229,9812,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÑÐºÐ¸Ð´ÐºÐ¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(353230,9812,'es','Descuentos de Items de Clientes',0),(353231,9812,'de','Kundenrabatte Element',0),(353232,9812,'en','Customer Item Discounts',0),(353233,9813,'is','',0),(353234,9813,'dr','ØªØ®ÙÙŠÙ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(353235,9813,'pr','ØªØ®ÙÙŠÙ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(353236,9813,'tr','Ä°ndirim baÅŸarÄ±yla silindi',0),(353237,9813,'pl','ZniÅ¼ki, usuniÄ™ty',0),(353238,9813,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(353239,9813,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø±Ø¹Ø§ÛŒØª',0),(353240,9813,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(353241,9813,'vi','XÃ³a bá» chiáº¿t kháº¥u thÃ nh cÃ´ng',0),(353242,9813,'af','Korting Suksesvol Geskrap',0),(353243,9813,'ro','Reducere eliminÄƒ cu succes',0),(353244,9813,'et','Allahindluse edukalt kustutatud',0),(353245,9813,'si','Popust uspeÅ¡no izbrisana',0),(353246,9813,'ba','Diskon dihapus berhasil',0),(353247,9813,'nl','Korting met succes verwijderd',0),(353248,9813,'fi','Alennus poistettu',0),(353249,9813,'no','Rabatt slettet',0),(353250,9813,'da','Rabat slettet',0),(353251,9813,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” í• ì¸',0),(353252,9813,'he','×”× ×—×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(353253,9813,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(353254,9813,'zh','æŠ˜æ‰£æˆåŠŸåˆ é™¤\r\n',0),(353255,9813,'sv','Rabatt raderades',0),(353256,9813,'it','Sconto eliminato con successo',0),(353257,9813,'tl','',0),(353258,9813,'th','&#3621;&#3610;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3649;&#3621;&#3657;&#3623;',0),(353259,9813,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¥€ à¤›à¥‚à¤Ÿ',0),(353260,9813,'ms','Diskaun dihapuskan dengan jayanya',0),(353261,9813,'ar','Ø­Ø°Ù Ø§Ù„ØªØ®ÙÙŠØ¶ Ø¨Ù†Ø¬Ø§Ø­',0),(353262,9813,'fr','Escompte supprimÃ© avec succÃ¨s',0),(353263,9813,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸå‰²å¼•',0),(353264,9813,'pt','Desconto apagado com sucesso',0),(353265,9813,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½Ð°',0),(353266,9813,'es','Descuento Eliminado Exitosamente',0),(353267,9813,'de','Rabatt wurde erfolgreich gelÃ¶scht',0),(353268,9813,'en','Discount Deleted Successfully',0),(353269,9814,'is','',0),(353270,9814,'dr','ØªØ®ÙÙŠÙ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(353271,9814,'pr','ØªØ®ÙÙŠÙ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(353272,9814,'tr','Ä°ndirim baÅŸarÄ±yla kaydedildi',0),(353273,9814,'pl','ZniÅ¼ki pomyÅ›lnie zapisany',0),(353274,9814,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(353275,9814,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ø±Ø¹Ø§ÛŒØª',0),(353276,9814,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(353277,9814,'vi','ÄÃ£ lÆ°u thÃ nh cÃ´ng chiáº¿t kháº¥u',0),(353278,9814,'af','Korting Suksesvol Gestoor',0),(353279,9814,'ro','Reducere salvat cu succes',0),(353280,9814,'et','Allahindlus salvestati edukalt',0),(353281,9814,'si','Popust shranjen',0),(353282,9814,'ba','Diskon disimpan berhasil',0),(353283,9814,'nl','Korting succesvol opgeslagen',0),(353284,9814,'fi','Alennus tallennettu',0),(353285,9814,'no','Rabatt lagret',0),(353286,9814,'da','Rabat gemt med succes',0),(353287,9814,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” í• ì¸',0),(353288,9814,'he','×”× ×—×” ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(353289,9814,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Ï€Î¿Ï… Î±Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(353290,9814,'zh','æŠ˜æ‰£å·²æˆåŠŸä¿å­˜\r\n',0),(353291,9814,'sv','Rabatt har sparats',0),(353292,9814,'it','Sconto salvato correttamente',0),(353293,9814,'tl','',0),(353294,9814,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3649;&#3621;&#3657;&#3623;',0),(353295,9814,'hi','à¤›à¥‚à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(353296,9814,'ms','Diskaun yang berjaya disimpan',0),(353297,9814,'ar','Ø­ÙØ¸ Ø§Ù„ØªØ®ÙÙŠØ¶ Ø¨Ù†Ø¬Ø§Ø­',0),(353298,9814,'fr','Remise correctement enregistrÃ©',0),(353299,9814,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚ŒãŸå‰²å¼•',0),(353300,9814,'pt','Desconto com sucesso',0),(353301,9814,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð°',0),(353302,9814,'es','Descuento Guardado Exitosamente',0),(353303,9814,'de','Rabatt erfolgreich gespeichert',0),(353304,9814,'en','Discount Saved Successfully',0),(353305,9815,'is','',0),(353306,9815,'dr','Ø«Ø§Ø¨Øª ØªØ®ÙÙŠÙ',0),(353307,9815,'pr','Ø«Ø§Ø¨Øª ØªØ®ÙÙŠÙ',0),(353308,9815,'tr','DÃ¼z indirim',0),(353309,9815,'pl','PÅ‚aski rabat',0),(353310,9815,'bg','ÐŸÐ»Ð¾ÑÐºÐ¸ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(353311,9815,'ur','ÙÙ„ÛŒÙ¹ Ø±Ø¹Ø§ÛŒØª',0),(353312,9815,'sr','Ð Ð°Ð²Ð½Ð° Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(353313,9815,'vi','chiáº¿t kháº¥u 1 giÃ¡',0),(353314,9815,'af','Plat afslag',0),(353315,9815,'ro','Reducere la platÄƒ',0),(353316,9815,'et','Korter Soodus',0),(353317,9815,'si','Ravno popust',0),(353318,9815,'ba','Diskon datar',0),(353319,9815,'nl','Platte korting',0),(353320,9815,'fi','Tasainen alennus',0),(353321,9815,'no','Flat rabatt',0),(353322,9815,'da','Flad rabat',0),(353323,9815,'ko','í”Œëž« í• ì¸',0),(353324,9815,'he','×”× ×—×” ×©×˜×•×—',0),(353325,9815,'el','Î•Ï€Î¯Ï€ÎµÎ´Î· Î­ÎºÏ€Ï„Ï‰ÏƒÎ·',0),(353326,9815,'zh','å›ºå®šä¼˜æƒ \r\n',0),(353327,9815,'sv','Platt rabatt',0),(353328,9815,'it','Sconto del piatto',0),(353329,9815,'tl','',0),(353330,9815,'th','&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;&#3649;&#3609;&#3623;&#3619;&#3634;&#3610;',0),(353331,9815,'hi','à¤«à¥à¤²à¥ˆà¤Ÿ à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ',0),(353332,9815,'ms','Diskaun Flat',0),(353333,9815,'ar','Ø®ØµÙ… Ø´Ù‚Ø©',0),(353334,9815,'fr','Plat Discount',0),(353335,9815,'jp','ãƒ•ãƒ©ãƒƒãƒˆå‰²å¼•',0),(353336,9815,'pt','Desconto plano',0),(353337,9815,'ru','ÐŸÐ»Ð¾ÑÐºÐ°Ñ ÑÐºÐ¸Ð´ÐºÐ°',0),(353338,9815,'es','Descuento Fijo',0),(353339,9815,'de','Flache Rabatt',0),(353340,9815,'en','Flat Discount',0),(353341,9816,'is','',0),(353342,9816,'dr','Ø¯Ø±ØµØ¯ ØªØ®ÙÙŠÙ',0),(353343,9816,'pr','Ø¯Ø±ØµØ¯ ØªØ®ÙÙŠÙ',0),(353344,9816,'tr','YÃ¼zde indirim',0),(353345,9816,'pl','Procent rabatu',0),(353346,9816,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(353347,9816,'ur','ÙÛŒ ØµØ¯ Ø±Ø¹Ø§ÛŒØª',0),(353348,9816,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(353349,9816,'vi','phÃ n trÄƒm chiáº¿t kháº¥u',0),(353350,9816,'af','Persentasie Korting',0),(353351,9816,'ro','Procent reducere',0),(353352,9816,'et','Protsenti allahindlust',0),(353353,9816,'si','Odstotni popust',0),(353354,9816,'ba','Diskon persen',0),(353355,9816,'nl','Percentage korting',0),(353356,9816,'fi','Prosentin alennuksen',0),(353357,9816,'no','Prosent rabatt',0),(353358,9816,'da','Procent rabat',0),(353359,9816,'ko','% í• ì¸',0),(353360,9816,'he','××—×•×– ×”× ×—×”',0),(353361,9816,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(353362,9816,'zh','ä¼˜æƒ ç™¾åˆ†æ¯”\r\n',0),(353363,9816,'sv','Procent rabatt',0),(353364,9816,'it','Percentuale sconto',0),(353365,9816,'tl','',0),(353366,9816,'th','&#3648;&#3611;&#3629;&#3619;&#3660;&#3648;&#3595;&#3655;&#3609;&#3605;&#3660;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(353367,9816,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤›à¥‚à¤Ÿ',0),(353368,9816,'ms','Peratus diskaun',0),(353369,9816,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ø§Ù„ØªØ®ÙÙŠØ¶',0),(353370,9816,'fr','Pourcentage de remise',0),(353371,9816,'jp','% å‰²å¼•',0),(353372,9816,'pt','Por cento de desconto',0),(353373,9816,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÑÐºÐ¸Ð´ÐºÐ¸',0),(353374,9816,'es','Porcentaje de Descuento',0),(353375,9816,'de','Prozent Rabatt',0),(353376,9816,'en','Percent Discount',0),(353377,9817,'is','',0),(353378,9817,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ ØªØ®ÙÙŠÙØ§Øª ',0),(353379,9817,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ ØªØ®ÙÙŠÙØ§Øª ',0),(353380,9817,'tr','Arama indirimler',0),(353381,9817,'pl','Szukaj ofert',0),(353382,9817,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸',0),(353383,9817,'ur','ØªÙ„Ø§Ø´ Ú©ÛŒ Ø±Ø¹Ø§ÛŒØª',0),(353384,9817,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ðµ',0),(353385,9817,'vi','TÃ¬m kiáº¿m chiáº¿t kháº¥u',0),(353386,9817,'af','Soek Kortings',0),(353387,9817,'ro','CautÄƒ reduceri',0),(353388,9817,'et','Otsi allahindlusi',0),(353389,9817,'si','Iskanje popustov',0),(353390,9817,'ba','Cari DISKON',0),(353391,9817,'nl','Zoek kortingen',0),(353392,9817,'fi','Etsi alennukset',0),(353393,9817,'no','SÃ¸k etter rabatter',0),(353394,9817,'da','SÃ¸g efter rabatter',0),(353395,9817,'ko','ê²€ìƒ‰ í• ì¸',0),(353396,9817,'he','×—×¤×© ×”× ×—×•×ª',0),(353397,9817,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½',0),(353398,9817,'zh','æœç´¢æŠ˜æ‰£\r\n',0),(353399,9817,'sv','SÃ¶k rabatter',0),(353400,9817,'it','Ricerca Sconti',0),(353401,9817,'tl','',0),(353402,9817,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(353403,9817,'hi','à¤–à¥‹à¤œ à¤›à¥‚à¤Ÿ',0),(353404,9817,'ms','Cari diskaun',0),(353405,9817,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª',0),(353406,9817,'fr','Rechercher des rÃ©ductions',0),(353407,9817,'jp','æ¤œç´¢å‰²å¼•',0),(353408,9817,'pt','Busca descontos',0),(353409,9817,'ru','Ð˜ÑÐºÐ°Ñ‚ÑŒ Ð¡ÐºÐ¸Ð´ÐºÐ¸',0),(353410,9817,'es','Busque Descuentos',0),(353411,9817,'de','Suche Rabatte',0),(353412,9817,'en','Search Discounts',0),(353413,9818,'is','',0),(353414,9818,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙƒØ§Ù„Ø§ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(353415,9818,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙƒØ§Ù„Ø§ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(353416,9818,'tr','Bir Ã¶ÄŸeyi seÃ§melisiniz',0),(353417,9818,'pl','NaleÅ¼y wybraÄ‡ element',0),(353418,9818,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(353419,9818,'ur','Ø¢Ù¾ Ú©Ø³ÛŒ Ø´Û’ Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(353420,9818,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¾Ð´Ð°Ð±Ñ€Ð°Ñ‚Ð¸ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(353421,9818,'vi','Báº¡n pháº£i chá»n 1 danh muc',0),(353422,9818,'af','U moet \'n Item Kies',0),(353423,9818,'ro','Trebuie sÄƒ alegeÅ£i un element',0),(353424,9818,'et','Te peate valima kauba',0),(353425,9818,'si','Izbrati morate element',0),(353426,9818,'ba','Anda harus memilih Item',0),(353427,9818,'nl','U moet een Item kiezen',0),(353428,9818,'fi','Valitse kohde',0),(353429,9818,'no','Du mÃ¥ velge et element',0),(353430,9818,'da','Du skal vÃ¦lge et element',0),(353431,9818,'ko','í•­ëª©ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(353432,9818,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×¤×¨×™×˜',0),(353433,9818,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(353434,9818,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªé¡¹ç›®\r\n',0),(353435,9818,'sv','Du mÃ¥ste vÃ¤lja ett objekt',0),(353436,9818,'it','Ãˆ necessario scegliere un elemento',0),(353437,9818,'tl','',0),(353438,9818,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(353439,9818,'hi','à¤†à¤ª à¤•à¤¿à¤¸à¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(353440,9818,'ms','Anda mesti memilih satu Item',0),(353441,9818,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø¥Ø®ØªÙŠØ§Ø± ØµÙ†Ù',0),(353442,9818,'fr','Vous devez choisir un Ã©lÃ©ment',0),(353443,9818,'jp','é …ç›®ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(353444,9818,'pt','VocÃª deve escolher um Item',0),(353445,9818,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€',0),(353446,9818,'es','Debe Escoger un Item',0),(353447,9818,'de','Sie mÃ¼ssen ein Element auswÃ¤hlen.',0),(353448,9818,'en','You Must Choose an Item',0),(353449,9819,'is','',0),(353450,9819,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(353451,9819,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø±  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(353452,9819,'tr','Bir mÃ¼ÅŸteri seÃ§melisiniz',0),(353453,9819,'pl','NaleÅ¼y wybraÄ‡ klienta',0),(353454,9819,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(353455,9819,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ú¯Ø§ÛÚ© Ú©Ùˆ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(353456,9819,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¾Ð´Ð°Ð±Ñ€Ð°Ñ‚Ð¸ ÐºÑƒÐ¿Ñ†Ð°',0),(353457,9819,'vi','Báº¡n pháº£i chá»n 1 khÃ¡ch hÃ ng',0),(353458,9819,'af','U moet \'n KliÃ«nt/Klant Kies',0),(353459,9819,'ro','Trebuie sÄƒ alegeÅ£i un client',0),(353460,9819,'et','Pead valima kliendi',0),(353461,9819,'si','Izbrati morate stranko',0),(353462,9819,'ba','Anda harus memilih pelanggan',0),(353463,9819,'nl','U moet het kiezen van een klant',0),(353464,9819,'fi','Valitse asiakas',0),(353465,9819,'no','Du mÃ¥ velge en kunde',0),(353466,9819,'da','Du skal vÃ¦lge en debitor',0),(353467,9819,'ko','ê³ ê°ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(353468,9819,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×œ×§×•×—',0),(353469,9819,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î±Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(353470,9819,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªå®¢æˆ·\r\n',0),(353471,9819,'sv','Du mÃ¥ste vÃ¤lja en kund',0),(353472,9819,'it','Ãˆ necessario scegliere un cliente',0),(353473,9819,'tl','',0),(353474,9819,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3648;&#3621;&#3639;&#3629;&#3585;&#3621;&#3641;&#3585;&#3588;&#3657;&#3656;&#3634;',0),(353475,9819,'hi','à¤†à¤ª à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(353476,9819,'ms','Anda mesti memilih pelanggan',0),(353477,9819,'ar','Ù„Ø§Ø¨Ø¯ Ù…Ù† Ø¥Ø®ØªÙŠØ§Ø± Ø²Ø¨ÙˆÙ†',0),(353478,9819,'fr','Vous devez choisir un client',0),(353479,9819,'jp','é¡§å®¢ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(353480,9819,'pt','VocÃª deve escolher um cliente',0),(353481,9819,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(353482,9819,'es','Debe Escoger un Cliente',0),(353483,9819,'de','Sie mÃ¼ssen einen Kunden auswÃ¤hlen.',0),(353484,9819,'en','You Must Choose a Customer',0),(353485,9820,'is','',0),(353486,9820,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ®ÙÙŠÙ Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯',0),(353487,9820,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ®ÙÙŠÙ Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯',0),(353488,9820,'tr','Bir indirim ayarlamanÄ±z gerekir',0),(353489,9820,'pl','NaleÅ¼y ustawiÄ‡ zniÅ¼ki',0),(353490,9820,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(353491,9820,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø±Ø¹Ø§ÛŒØª Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(353492,9820,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ð¾Ð¿ÑƒÑÑ‚',0),(353493,9820,'vi','Báº¡n pháº£i thiáº¿t láº­p chiáº¿t kháº¥u',0),(353494,9820,'af','U moet \'n Korting Opstel',0),(353495,9820,'ro','Trebuie sÄƒ setaÅ£i o reducere',0),(353496,9820,'et','Te peate mÃ¤Ã¤rama allahindluse',0),(353497,9820,'si','Morate nastaviti popust',0),(353498,9820,'ba','Anda harus mengatur DISKON',0),(353499,9820,'nl','U moet het instellen van een korting',0),(353500,9820,'fi','Alennusta on mÃ¤Ã¤ritettÃ¤vÃ¤',0),(353501,9820,'no','Du mÃ¥ angi en rabatt',0),(353502,9820,'da','Du skal angive en rabat',0),(353503,9820,'ko','í• ì¸ì„ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(353504,9820,'he','×¢×œ×™×š ×œ×”×’×“×™×¨ ×”× ×—×”',0),(353505,9820,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¯ÏƒÎµÏ„Îµ Î¼Î¹Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·',0),(353506,9820,'zh','æ‚¨å¿…é¡»è®¾ç½®ä¸€ä¸ªæŠ˜æ‰£\r\n',0),(353507,9820,'sv','Du mÃ¥ste ange en rabatt',0),(353508,9820,'it','Ãˆ necessario impostare uno sconto',0),(353509,9820,'tl','',0),(353510,9820,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3605;&#3633;&#3657;&#3591;&#3626;&#3656;&#3623;&#3609;&#3621;&#3604;',0),(353511,9820,'hi','à¤†à¤ª à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ à¤à¤• à¤›à¥‚à¤Ÿ',0),(353512,9820,'ms','Anda mesti menetapkan diskaun',0),(353513,9820,'ar','Ù„Ø§Ø¨Ø¯ Ù…Ù† ØªØ­Ø¯ÙŠØ¯ ØªØ®ÙÙŠØ¶',0),(353514,9820,'fr','Vous devez fixer une remise',0),(353515,9820,'jp','å‰²å¼•ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(353516,9820,'pt','VocÃª deve definir um desconto',0),(353517,9820,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð Ð°Ð·Ð¼ÐµÑ€ Ð¡ÐºÐ¸Ð´ÐºÐ¸',0),(353518,9820,'es','Debe Configurar un Descuento',0),(353519,9820,'de','Sie mÃ¼ssen einen Rabatt festlegen.',0),(353520,9820,'en','You Must Set a Discount',0),(353521,9821,'is','',0),(353522,9821,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ø± ',0),(353523,9821,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ø± ',0),(353524,9821,'tr','Ä°ÅŸ ayrÄ±ntÄ±larÄ± DÃ¼zenle',0),(353525,9821,'pl','Edytuj szczegÃ³Å‚y pracy',0),(353526,9821,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ‚Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(353527,9821,'ur','Ú©Ø§Ù… Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(353528,9821,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ€Ð°Ð´Ð½Ð¸ Ð·Ð°Ð´Ð°Ñ†Ð¸',0),(353529,9821,'vi','Sá»­a chi tiáº¿t cÃ´ng viá»‡c',0),(353530,9821,'af','Werk Details Redigeer',0),(353531,9821,'ro','Edita munca detalii',0),(353532,9821,'et','Muuta tÃ¶Ã¶ Ã¼ksikasju',0),(353533,9821,'si','Urejanje dela podrobnosti',0),(353534,9821,'ba','Mengedit rincian pekerjaan',0),(353535,9821,'nl','Werk Details bewerken',0),(353536,9821,'fi','Muokkaa tyÃ¶tÃ¤',0),(353537,9821,'no','Rediger arbeidsdetaljer',0),(353538,9821,'da','Redigere arbejde detaljer',0),(353539,9821,'ko','ìž‘ì—… ì„¸ë¶€ ì •ë³´ íŽ¸ì§‘',0),(353540,9821,'he','×¢×¨×•×š ×¤×¨×˜×™ ×¢×‘×•×“×”',0),(353541,9821,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï„Î·Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(353542,9821,'zh','ç¼–è¾‘å·¥ä½œçš„è¯¦æƒ…\r\n',0),(353543,9821,'sv','Redigera arbetsinformation',0),(353544,9821,'it','Modificare i dettagli del lavoro',0),(353545,9821,'tl','',0),(353546,9821,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3591;&#3585;&#3634;&#3619;&#3607;&#3635;&#3634;&#3609;',0),(353547,9821,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤µà¤¿à¤µà¤°à¤£ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(353548,9821,'ms','Mengedit butiran kerja',0),(353549,9821,'ar','ØªØ­Ø±ÙŠØ± ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¹Ù…Ù„',0),(353550,9821,'fr','Modifier les dÃ©tails du travail',0),(353551,9821,'jp','ä½œæ¥­ã®è©³ç´°ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(353552,9821,'pt','Editar detalhes do trabalho',0),(353553,9821,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð Ð°Ð±Ð¾Ñ‚Ñ‹',0),(353554,9821,'es','Editar Detalles de ColocaciÃ³n',0),(353555,9821,'de','Werk Details bearbeiten',0),(353556,9821,'en','Edit Work Details',0),(353557,9822,'is','',0),(353558,9822,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(353559,9822,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(353560,9822,'tr','Servis sipariÅŸ iÅŸ ayrÄ±ntÄ±larÄ±',0),(353561,9822,'pl','SzczegÃ³Å‚y pracy zamÃ³wienia usÅ‚ugi',0),(353562,9822,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸',0),(353563,9822,'ur','Ø³Ø±ÙˆØ³ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Ø§Ù… Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(353564,9822,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¿Ð¾ÑÐ»Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÑÐµÑ€Ð²Ð¸ÑÐ°',0),(353565,9822,'vi','ThÃ´ng tin chi tiáº¿t Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(353566,9822,'af','Diensbestelling Werk Details',0),(353567,9822,'ro','Serviciul ordine de lucru detalii',0),(353568,9822,'et','Teenuse tellimuse tÃ¶Ã¶ Ã¼ksikasjad',0),(353569,9822,'si','Podrobnosti o naroÄilu dela storitev',0),(353570,9822,'ba','Rincian kerja layanan pesanan',0),(353571,9822,'nl','Service werk ordergegevens',0),(353572,9822,'fi','Huoltotilauksen tyÃ¶n tiedot',0),(353573,9822,'no','Tjenesten Ordredetaljer arbeid',0),(353574,9822,'da','Service arbejde ordreoplysninger',0),(353575,9822,'ko','ì„œë¹„ìŠ¤ ì£¼ë¬¸ ìž‘ì—… ì •ë³´',0),(353576,9822,'he','×©×™×¨×•×ª ×”×–×ž× ×ª ×¢×‘×•×“×” ×¤×¨×˜×™',0),(353577,9822,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(353578,9822,'zh','æœåŠ¡è®¢å•å·¥ä½œçš„è¯¦æƒ…\r\n',0),(353579,9822,'sv','Service arbete Orderdetaljer',0),(353580,9822,'it','Servizio ordine lavoro dettagli',0),(353581,9822,'tl','',0),(353582,9822,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3591;&#3634;&#3609;&#3610;&#3619;&#3636;&#3585;&#3634;&#3619;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(353583,9822,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾à¤°à¥à¤¯ à¤µà¤¿à¤µà¤°à¤£',0),(353584,9822,'ms','Butir-butir kerja pesanan Perkhidmatan',0),(353585,9822,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¹Ù…Ù„ Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(353586,9822,'fr','DÃ©tails de la commande service travaux',0),(353587,9822,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã®ä½œæ¥­è©³ç´°',0),(353588,9822,'pt','Detalhes de trabalho de ordem de serviÃ§o',0),(353589,9822,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð°',0),(353590,9822,'es','Detalles de Tarea de Orden de Servicio',0),(353591,9822,'de','Service Arbeit Bestelldetails',0),(353592,9822,'en','Service Order Work Details',0),(353593,9823,'is','',0),(353594,9823,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(353595,9823,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(353596,9823,'tr','Ã‡alÄ±ÅŸma ayrÄ±ntÄ±larÄ±nÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(353597,9823,'pl','SzczegÃ³Å‚y pracy pomyÅ›lnie zaktualizowana',0),(353598,9823,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ‚Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(353599,9823,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø§Ù… Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(353600,9823,'sr','Ð Ð°Ð´Ð½Ð¸ Ð·Ð°Ð´Ð°Ñ†Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(353601,9823,'vi','Cáº­p nháº­t chi tiáº¿t cÃ´ng viá»‡c thÃ nh cÃ´ng',0),(353602,9823,'af','Werk Besonderhede Suksesvol Opdateer',0),(353603,9823,'ro','Detalii de munca actualizat cu succes',0),(353604,9823,'et','TÃ¶Ã¶kirjelduse vÃ¤rskendamine Ãµnnestus',0),(353605,9823,'si','Podrobnosti delo uspeÅ¡no posodobljena',0),(353606,9823,'ba','Rincian pekerjaan yang berhasil',0),(353607,9823,'nl','Work gegevens bijgewerkt',0),(353608,9823,'fi','TyÃ¶n tiedot pÃ¤ivitetty',0),(353609,9823,'no','Arbeidsdetaljer oppdatert',0),(353610,9823,'da','Arbejde detaljer opdateret',0),(353611,9823,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ìž‘ì—… ì •ë³´',0),(353612,9823,'he','×¤×¨×˜×™ ×¢×‘×•×“×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(353613,9823,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(353614,9823,'zh','æˆåŠŸæ›´æ–°å·¥ä½œçš„è¯¦æƒ…\r\n',0),(353615,9823,'sv','Arbetsdetaljer uppdaterats',0),(353616,9823,'it','Dettagli di lavoro aggiornati correttamente',0),(353617,9823,'tl','',0),(353618,9823,'th','&#3619;&#3634;&#3618;&#3621;&#3632;&#3648;&#3629;&#3637;&#3618;&#3604;&#3585;&#3634;&#3619;&#3607;&#3635;&#3591;&#3634;&#3609;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(353619,9823,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤ à¤—à¤ à¤•à¤¾à¤°à¥à¤¯ à¤µà¤¿à¤µà¤°à¤£',0),(353620,9823,'ms','Butir-butir kerja yang berjaya dikemas kini',0),(353621,9823,'ar','ØªÙØ§ØµÙŠÙ„ Ø¹Ù…Ù„ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(353622,9823,'fr','DÃ©tails de travail mis Ã  jour avec succÃ¨s',0),(353623,9823,'jp','æ­£å¸¸ã«æ›´æ–°ä½œæ¥­ã®è©³ç´°',0),(353624,9823,'pt','Detalhes de trabalho atualizados com sucesso',0),(353625,9823,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(353626,9823,'es','Detalles de Trabajo Actualizados Exitosamente',0),(353627,9823,'de','Arbeitsdetails erfolgreich aktualisiert',0),(353628,9823,'en','Work Details Updated Successfully',0),(353629,9824,'is','',0),(353630,9824,'dr','Ù…Ø±Ø­Ù„Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(353631,9824,'pr','Ù…Ø±Ø­Ù„Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(353632,9824,'tr','Ä°ÅŸlem aÅŸamasÄ±',0),(353633,9824,'pl','Etap procesu',0),(353634,9824,'bg','Ð•Ñ‚Ð°Ð¿ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ°',0),(353635,9824,'ur','Ø¹Ù…Ù„ Ú©Û’ Ù…Ø±Ø­Ù„Û’',0),(353636,9824,'sr','Ð¤Ð°Ð·Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑÐ°',0),(353637,9824,'vi','giai Ä‘oáº¡n tiáº¿n hÃ nh',0),(353638,9824,'af','Verwerkingsvlak',0),(353639,9824,'ro','Procesul etapei',0),(353640,9824,'et','Protsessi etapp',0),(353641,9824,'si','Faza procesa',0),(353642,9824,'ba','Tahap proses',0),(353643,9824,'nl','Fase van het proces',0),(353644,9824,'fi','Prosessivaihe',0),(353645,9824,'no','Prosessen scenen',0),(353646,9824,'da','Fase processen',0),(353647,9824,'ko','í”„ë¡œì„¸ìŠ¤ ë‹¨ê³„',0),(353648,9824,'he','×©×œ×‘ ×‘×ª×”×œ×™×š',0),(353649,9824,'el','Î£Ï„Î¬Î´Î¹Î¿ Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±Ï‚',0),(353650,9824,'zh','å¤„ç†é˜¶æ®µ\r\n',0),(353651,9824,'sv','Processteg',0),(353652,9824,'it','Fase del processo di',0),(353653,9824,'tl','',0),(353654,9824,'th','&#3586;&#3633;&#3657;&#3609;&#3605;&#3629;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;',0),(353655,9824,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤…à¤µà¤¸à¥à¤¥à¤¾',0),(353656,9824,'ms','Peringkat proses',0),(353657,9824,'ar','Ø§Ù„Ù…Ø±Ø­Ù„Ø© Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(353658,9824,'fr','Ã‰tapes du processus',0),(353659,9824,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã®æ®µéšŽ',0),(353660,9824,'pt','EstÃ¡gio do processo',0),(353661,9824,'ru','Ð¡Ñ‚Ð°Ð´Ð¸Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ°',0),(353662,9824,'es','Etapa de Proceso',0),(353663,9824,'de','Prozessphase',0),(353664,9824,'en','Process Stage',0),(353665,9825,'is','',0),(353666,9825,'dr','Ù…Ø±Ø­Ù„Ù‡ ',0),(353667,9825,'pr','Ù…Ø±Ø­Ù„Ù‡ ',0),(353668,9825,'tr','Sahne',0),(353669,9825,'pl','Etap',0),(353670,9825,'bg','Ð•Ñ‚Ð°Ð¿',0),(353671,9825,'ur','Ù…Ø±Ø­Ù„Û’',0),(353672,9825,'sr','ÐŸÐ¾Ð·Ð¾Ñ€Ð½Ð¸Ñ†Ð¸',0),(353673,9825,'vi','Giai Ä‘oáº¡n',0),(353674,9825,'af','Stadium',0),(353675,9825,'ro','Etapa',0),(353676,9825,'et','Etapp',0),(353677,9825,'si','Fazi',0),(353678,9825,'ba','Panggung',0),(353679,9825,'nl','Stadium',0),(353680,9825,'fi','Vaiheessa',0),(353681,9825,'no','Scenen',0),(353682,9825,'da','Fase',0),(353683,9825,'ko','ë‹¨ê³„',0),(353684,9825,'he','×”×‘×ž×”',0),(353685,9825,'el','Î£Ï„Î¬Î´Î¹Î¿',0),(353686,9825,'zh','é˜¶æ®µ\r\n',0),(353687,9825,'sv','Skede',0),(353688,9825,'it','Fase',0),(353689,9825,'tl','',0),(353690,9825,'th','à¹€à¸§à¸—à¸µ',0),(353691,9825,'hi','à¤®à¤‚à¤š',0),(353692,9825,'ms','Peringkat',0),(353693,9825,'ar','Ù…Ø±Ø­Ù„Ø©',0),(353694,9825,'fr','Stade',0),(353695,9825,'jp','ã‚¹ãƒ†ãƒ¼ã‚¸',0),(353696,9825,'pt','EstÃ¡gio',0),(353697,9825,'ru','Ð¡Ñ‚Ð°Ð´Ð¸Ñ',0),(353698,9825,'es','Etapa',0),(353699,9825,'de','BÃ¼hne',0),(353700,9825,'en','Stage',0),(353701,9826,'is','',0),(353702,9826,'dr','Ù…Ø±Ø§Ø­Ù„ Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(353703,9826,'pr','Ù…Ø±Ø§Ø­Ù„ Ù¾Ø±Ø¯Ø§Ø²Ø´ ',0),(353704,9826,'tr','Ä°ÅŸlem aÅŸamalarÄ±',0),(353705,9826,'pl','Etapy procesu',0),(353706,9826,'bg','Ð•Ñ‚Ð°Ð¿Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑÐ°',0),(353707,9826,'ur','Ø¹Ù…Ù„ Ù…Ø±Ø§Ø­Ù„',0),(353708,9826,'sr','Ð¤Ð°Ð·Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ°',0),(353709,9826,'vi','giai Ä‘oáº¡n tiáº¿n hÃ nh',0),(353710,9826,'af','Verwerkingsvlakke',0),(353711,9826,'ro','Etapele procesului',0),(353712,9826,'et','Protsessi etapid',0),(353713,9826,'si','Faze procesa',0),(353714,9826,'ba','Tahapan proses',0),(353715,9826,'nl','Processtadia',0),(353716,9826,'fi','Prosessin vaiheet',0),(353717,9826,'no','Prosesstrinn',0),(353718,9826,'da','Processtadier',0),(353719,9826,'ko','í”„ë¡œì„¸ìŠ¤ ë‹¨ê³„',0),(353720,9826,'he','×©×œ×‘×™× ×‘×ª×”×œ×™×š',0),(353721,9826,'el','Î£Ï„Î¬Î´Î¹Î± Ï„Î·Ï‚ Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±Ï‚',0),(353722,9826,'zh','å¤„ç†é˜¶æ®µ\r\n',0),(353723,9826,'sv','Processteg',0),(353724,9826,'it','Fasi del processo',0),(353725,9826,'tl','',0),(353726,9826,'th','&#3586;&#3633;&#3657;&#3609;&#3605;&#3629;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3617;&#3623;&#3621;&#3612;&#3621;',0),(353727,9826,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤…à¤µà¤¸à¥à¤¥à¤¾',0),(353728,9826,'ms','Peringkat proses',0),(353729,9826,'ar','Ù…Ø±Ø§Ø­Ù„ Ø§Ù„Ø¹Ù…Ù„ÙŠØ©',0),(353730,9826,'fr','Ã‰tapes du processus',0),(353731,9826,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã®æ®µéšŽ',0),(353732,9826,'pt','Fases do processo',0),(353733,9826,'ru','Ð­Ñ‚Ð°Ð¿Ñ‹ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ°',0),(353734,9826,'es','Etapas de Proceso',0),(353735,9826,'de','Prozessstufen',0),(353736,9826,'en','Process Stages',0),(353737,9827,'is','',0),(353738,9827,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†ÙˆØ¹ Ù…Ø±Ø­Ù„Ù‡ ØªØ¹ÙŠÙŠÙ† ÙƒÙ†ÙŠØ¯ ',0),(353739,9827,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†ÙˆØ¹ Ù…Ø±Ø­Ù„Ù‡ ØªØ¹ÙŠÙŠÙ† ÙƒÙ†ÙŠØ¯ ',0),(353740,9827,'tr','Bir sahne tÃ¼rÃ¼ belirtmeniz gerekir',0),(353741,9827,'pl','NaleÅ¼y okreÅ›liÄ‡ typ etapu',0),(353742,9827,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑƒÐºÐ°Ð¶ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿ Ð½Ð° ÐµÑ‚Ð°Ð¿',0),(353743,9827,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù…Ø±Ø­Ù„Û’ Ú©ÛŒ Ù‚Ø³Ù… Ú©Ø§ Ø§Ø®ØªØµØ§Øµ Ú©Ø±ÛŒÚº',0),(353744,9827,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð½Ð°Ð²ÐµÑÑ‚Ð¸ Ñ‚Ð¸Ð¿ ÑÑ†ÐµÐ½Ð¸',0),(353745,9827,'vi','Báº¡n pháº£i chá»n 1 loáº¡i giai Ä‘oáº¡n',0),(353746,9827,'af','Jy moet \'n stadium tipe spesifiseer',0),(353747,9827,'ro','Trebuie sÄƒ specificaÈ›i un tip de scenÄƒ',0),(353748,9827,'et','Te peate mÃ¤Ã¤rama etapi tÃ¼Ã¼bi',0),(353749,9827,'si','DoloÄite vrsto fazi',0),(353750,9827,'ba','Anda harus menentukan jenis panggung',0),(353751,9827,'nl','Moet u een Type podium',0),(353752,9827,'fi','MÃ¤Ã¤ritÃ¤ vaiheen tyyppi',0),(353753,9827,'no','Du mÃ¥ angi en scene Type',0),(353754,9827,'da','Du skal angive en fase',0),(353755,9827,'ko','ë‹¨ê³„ ìœ í˜•ì„ ì§€ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(353756,9827,'he','×¢×œ×™×š ×œ×¦×™×™×Ÿ ×¡×•×’ ×”×‘×ž×”',0),(353757,9827,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎºÎ±Î¸Î¿ÏÎ¯ÏƒÎµÏ„Îµ Î­Î½Î±Î½ Ï„ÏÏ€Î¿ ÏƒÏ„Î¬Î´Î¹Î¿',0),(353758,9827,'zh','æ‚¨å¿…é¡»æŒ‡å®šä¸€ä¸ªé˜¶æ®µç±»åž‹\r\n',0),(353759,9827,'sv','Du mÃ¥ste ange en scenen typ.',0),(353760,9827,'it','Ãˆ necessario specificare un tipo di fase',0),(353761,9827,'tl','',0),(353762,9827,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3619;&#3632;&#3610;&#3640;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;',0),(353763,9827,'hi','à¤¤à¥à¤® à¤à¤• à¤®à¤‚à¤š à¤ªà¥à¤°à¤•à¤¾à¤° à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(353764,9827,'ms','Anda mesti menetapkan jenis peringkat',0),(353765,9827,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† ØªØ­Ø¯ÙŠØ¯ Ù†ÙˆØ¹ Ù…Ø±Ø­Ù„Ø©',0),(353766,9827,'fr','vous devez spÃ©cifier un type de scÃ¨ne',0),(353767,9827,'jp','ã‚¹ãƒ†ãƒ¼ã‚¸ã®ç¨®é¡žã‚’æŒ‡å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(353768,9827,'pt','VocÃª deve especificar um tipo de estÃ¡gio',0),(353769,9827,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ ÑƒÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¸Ð¿ ÑÑ‚Ð°Ð¿Ð°',0),(353770,9827,'es','Debe Especificar un Tipo de Etapa',0),(353771,9827,'de','Sie mÃ¼ssen einen Stufentyp angeben.',0),(353772,9827,'en','You Must Specify a Stage Type',0),(353773,9828,'is','',0),(353774,9828,'dr','ÙØ¹Ø§Ù„ÙŠØª Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯ ',0),(353775,9828,'pr','ÙØ¹Ø§Ù„ÙŠØª Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯ ',0),(353776,9828,'tr','Eylem engellendi',0),(353777,9828,'pl','Blokowana akcja',0),(353778,9828,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½',0),(353779,9828,'ur','Ø¨Ù„Ø§Ú© Ø´Ø¯Û Ø¹Ù…Ù„',0),(353780,9828,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½',0),(353781,9828,'vi','HÃ nh Ä‘á»™ng bá»‹ khÃ³a',0),(353782,9828,'af','Aksie is geblokkeer',0),(353783,9828,'ro','AcÅ£iune blocat',0),(353784,9828,'et','Tegevus, mis on blokeeritud',0),(353785,9828,'si','Ukrepi, ki so blokirani',0),(353786,9828,'ba','Tindakan yang diblokir',0),(353787,9828,'nl','Actie geblokkeerd',0),(353788,9828,'fi','EstetyllÃ¤ toimella',0),(353789,9828,'no','Blokkerte handlinger',0),(353790,9828,'da','Handling blokeret',0),(353791,9828,'ko','ì°¨ë‹¨ ìž‘ì—…',0),(353792,9828,'he','×”×¤×¢×•×œ×” × ×—×¡×ž×”',0),(353793,9828,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¹ÏƒÎ¼Î­Î½Î· ÎµÎ½Î­ÏÎ³ÎµÎ¹Î±',0),(353794,9828,'zh','å°é”åŠ¨ä½œ\r\n',0),(353795,9828,'sv','Blockerad Ã¥tgÃ¤rd',0),(353796,9828,'it','Azione bloccata',0),(353797,9828,'tl','',0),(353798,9828,'th','&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3636;&#3609;&#3585;&#3634;&#3619;&#3606;&#3641;&#3585;&#3611;&#3636;&#3604;&#3585;&#3633;&#3657;&#3609;',0),(353799,9828,'hi','à¤¬à¥à¤²à¥‰à¤• à¤•à¥€ à¤—à¤ˆ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(353800,9828,'ms','Tindakan yang disekat',0),(353801,9828,'ar','Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø­Ø¸Ø±',0),(353802,9828,'fr','Action bloquÃ©s',0),(353803,9828,'jp','ãƒ–ãƒ­ãƒƒã‚¯ã•ã‚ŒãŸã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(353804,9828,'pt','AÃ§Ã£o bloqueada',0),(353805,9828,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð¾',0),(353806,9828,'es','AcciÃ³n Blogueada',0),(353807,9828,'de','Aktion blockiert',0),(353808,9828,'en','Action Blocked',0),(353809,9829,'is','',0),(353810,9829,'dr','ØªØºÙŠÙŠØ± Ø®ÙˆØ¯ÙƒØ§Ø±',0),(353811,9829,'pr','ØªØºÙŠÙŠØ± Ø®ÙˆØ¯ÙƒØ§Ø±',0),(353812,9829,'tr','Otomatik deÄŸiÅŸiklik',0),(353813,9829,'pl','Automatycznych zmian',0),(353814,9829,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(353815,9829,'ur','Ø®ÙˆØ¯ Ú©Ø§Ø± ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(353816,9829,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(353817,9829,'vi','Thay Ä‘á»•i tá»± Ä‘á»™ng',0),(353818,9829,'af','Outomatiese verandering',0),(353819,9829,'ro','Schimbare automatÄƒ',0),(353820,9829,'et','Automaatne muutmine',0),(353821,9829,'si','Avtomatsko spremeni',0),(353822,9829,'ba','Perubahan otomatis',0),(353823,9829,'nl','Geautomatiseerde wijzigen',0),(353824,9829,'fi','Automaattinen muutos',0),(353825,9829,'no','Automatisk endre',0),(353826,9829,'da','Automatiseret Ã¦ndring',0),(353827,9829,'ko','ìžë™ëœ ë³€ê²½',0),(353828,9829,'he','×©×™× ×•×™ ××•×˜×•×ž×˜×™',0),(353829,9829,'el','Î‘Ï…Ï„Î¿Î¼Î±Ï„Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î· Î±Î»Î»Î±Î³Î®',0),(353830,9829,'zh','è‡ªåŠ¨å˜æ›´\r\n',0),(353831,9829,'sv','Automatiserad fÃ¶rÃ¤ndring',0),(353832,9829,'it','Cambio automatizzato',0),(353833,9829,'tl','',0),(353834,9829,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3629;&#3633;&#3605;&#3650;&#3609;&#3617;&#3633;&#3605;&#3636;',0),(353835,9829,'hi','à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(353836,9829,'ms','Perubahan secara automatik',0),(353837,9829,'ar','Ø§Ù„ØªØºÙŠÙŠØ± Ø§Ù„Ø¢Ù„ÙŠ',0),(353838,9829,'fr','Changement automatique',0),(353839,9829,'jp','è‡ªå‹•å¤‰æ›´',0),(353840,9829,'pt','MudanÃ§a automÃ¡tica',0),(353841,9829,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(353842,9829,'es','Cambio Automatizado',0),(353843,9829,'de','Automatisierte Ã„nderung',0),(353844,9829,'en','Automated Change',0),(353845,9830,'is','',0),(353846,9830,'dr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(353847,9830,'pr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(353848,9830,'tr','PO silmek',0),(353849,9830,'pl','UsuÅ„ PO',0),(353850,9830,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° PO',0),(353851,9830,'ur','Ù¾Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(353852,9830,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ ÐŸÐž',0),(353853,9830,'vi','XÃ³a Ä‘á» nghá»‹ mua hÃ ng',0),(353854,9830,'af','Skrap AB',0),(353855,9830,'ro','ÅžtergeÅ£i PO',0),(353856,9830,'et','Kustuta ostutellimus',0),(353857,9830,'si','Izbrisati PO',0),(353858,9830,'ba','Menghapus PO',0),(353859,9830,'nl','PO verwijderen',0),(353860,9830,'fi','Poista PO',0),(353861,9830,'no','Slette PO',0),(353862,9830,'da','Slette PO',0),(353863,9830,'ko','ì‚¬ì„œí•¨ ì‚­ì œ',0),(353864,9830,'he','×ž×—×™×§×ª ×¤×•',0),(353865,9830,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… PO',0),(353866,9830,'zh','åˆ é™¤è®¢å•\r\n',0),(353867,9830,'sv','Ta bort PO',0),(353868,9830,'it','Elimina PO',0),(353869,9830,'tl','',0),(353870,9830,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(353871,9830,'hi','à¤ªà¥€à¤“ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡',0),(353872,9830,'ms','Menghapuskan PO',0),(353873,9830,'ar','Ø­Ø°Ù Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(353874,9830,'fr','Supprimer des PO',0),(353875,9830,'jp','PO ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(353876,9830,'pt','Excluir o PO',0),(353877,9830,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ PO',0),(353878,9830,'es','Eliminar OC',0),(353879,9830,'de','PO zu lÃ¶schen',0),(353880,9830,'en','Delete PO',0),(353881,9831,'is','',0),(353882,9831,'dr','Ø®Ø·Ø§ ÙŠ ØªØºÙŠÙŠØ± Ù…Ø±Ø­Ù„Ù‡',0),(353883,9831,'pr','Ø®Ø·Ø§ ÙŠ ØªØºÙŠÙŠØ± Ù…Ø±Ø­Ù„Ù‡',0),(353884,9831,'tr','Hata deÄŸiÅŸen sahne',0),(353885,9831,'pl','BÅ‚Ä…d zmiany etapu',0),(353886,9831,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¼ÑÐ½Ð° Ð½Ð° ÑÑ†ÐµÐ½Ð°Ñ‚Ð°',0),(353887,9831,'ur','Ù†Ù‚Øµ Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Ø§ Ù…Ø±Ø­Ù„Û',0),(353888,9831,'sr','Ð¤Ð°Ð·Ð° Ð¼ÐµÑšÐ° Ð³Ñ€ÐµÑˆÐºÐµ',0),(353889,9831,'vi','Lá»—i thay Ä‘á»•i giai Ä‘oáº¡n',0),(353890,9831,'af','Fout verander stadium',0),(353891,9831,'ro','Eroare schimbarea etapa',0),(353892,9831,'et','Viga muutuvate etapp',0),(353893,9831,'si','Napaka spreminjanje fazi',0),(353894,9831,'ba','Kesalahan mengubah panggung',0),(353895,9831,'nl','Fout wijzigen fase',0),(353896,9831,'fi','Virhe muuttaa vaiheen',0),(353897,9831,'no','Feil endring scenen',0),(353898,9831,'da','Fejl Ã¦ndre fase',0),(353899,9831,'ko','ì˜¤ë¥˜ ë³€ê²½ ë‹¨ê³„',0),(353900,9831,'he','×©×’×™××ª ×©×™× ×•×™ ×”×‘×ž×”',0),(353901,9831,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î»Î»Î±Î³Î® ÏƒÏ„Î¬Î´Î¹Î¿',0),(353902,9831,'zh','é”™è¯¯è½¬åž‹é˜¶æ®µ\r\n',0),(353903,9831,'sv','Fel Ã¤ndra scenen',0),(353904,9831,'it','Errore cambiando fase',0),(353905,9831,'tl','',0),(353906,9831,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3586;&#3633;&#3657;&#3609;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;',0),(353907,9831,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¥à¤¤à¤° à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(353908,9831,'ms','Kesilapan menukar tahap',0),(353909,9831,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØºÙŠÙŠØ± Ø§Ù„Ù…Ø±Ø­Ù„Ø©',0),(353910,9831,'fr','Erreur changement de scÃ¨ne',0),(353911,9831,'jp','ã‚¨ãƒ©ãƒ¼ã‚’å¤‰æ›´ã™ã‚‹ã‚¹ãƒ†ãƒ¼ã‚¸',0),(353912,9831,'pt','Fase de mudanÃ§a de erro',0),(353913,9831,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ ÑÑ‚Ð°Ð¿Ð°',0),(353914,9831,'es','Error Cambiando Etapa',0),(353915,9831,'de','Fehler Ã¤ndern BÃ¼hne',0),(353916,9831,'en','Error Changing Stage',0),(353917,9832,'is','',0),(353918,9832,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(353919,9832,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø­Ø°Ù ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(353920,9832,'tr','Not silme hatasÄ±',0),(353921,9832,'pl','BÅ‚Ä…d podczas usuwania Uwaga',0),(353922,9832,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(353923,9832,'ur','Ù†ÙˆÙ¹ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(353924,9832,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(353925,9832,'vi','Lá»—i khi xÃ³a ghi chÃº',0),(353926,9832,'af','Fout skrap Nota',0),(353927,9832,'ro','Eroare la È™tergerea NotÄƒ',0),(353928,9832,'et','TÃµrge kustutamisel MÃ¤rkus',0),(353929,9832,'si','Napaka pri brisanju Opomba',0),(353930,9832,'ba','Error menghapus catatan',0),(353931,9832,'nl','Fout bij het verwijderen van notitie',0),(353932,9832,'fi','Virhe poistettaessa Huomautus',0),(353933,9832,'no','Feil ved sletting av notatet',0),(353934,9832,'da','Fejl ved sletning af Note',0),(353935,9832,'ko','ì°¸ê³  ì‚­ì œ ì˜¤ë¥˜',0),(353936,9832,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×”×¢×¨×”',0),(353937,9832,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(353938,9832,'zh','é”™è¯¯åˆ é™¤æ³¨',0),(353939,9832,'sv','Fel ta bort anteckning',0),(353940,9832,'it','Errore durante l\'eliminazione di Note',0),(353941,9832,'tl','',0),(353942,9832,'th','&#3648;&#3585;&#3636;&#3604;&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3621;&#3610;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(353943,9832,'hi','à¤¨à¥‹à¤Ÿ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(353944,9832,'ms','Ralat Menghapuskan Nota',0),(353945,9832,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ù…Ù„Ø§Ø­Ø¸Ø©',0),(353946,9832,'fr','Erreur de suppression de Note',0),(353947,9832,'jp','ãƒ¡ãƒ¢ã®å‰Šé™¤ã‚¨ãƒ©ãƒ¼',0),(353948,9832,'pt','Erro ao excluir nota',0),(353949,9832,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(353950,9832,'es','Error Eliminado Nota',0),(353951,9832,'de','Fehler beim LÃ¶schen der Hinweis',0),(353952,9832,'en','Error Deleting Note',0),(353953,9833,'is','',0),(353954,9833,'dr','Ù…Ø±Ø­Ù„Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(353955,9833,'pr','Ù…Ø±Ø­Ù„Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(353956,9833,'tr','Yeni sahne',0),(353957,9833,'pl','Nowy etap',0),(353958,9833,'bg','ÐÐ¾Ð² ÐµÑ‚Ð°Ð¿',0),(353959,9833,'ur','Ù†ÛŒØ§ Ù…Ø±Ø­Ù„Û',0),(353960,9833,'sr','ÐÐ¾Ð²Ð° Ñ„Ð°Ð·Ð°',0),(353961,9833,'vi','giai Ä‘oáº¡n má»›i',0),(353962,9833,'af','Nuwe stadium',0),(353963,9833,'ro','NouÄƒ etapÄƒ',0),(353964,9833,'et','Uus etapp',0),(353965,9833,'si','Novo stopnjo',0),(353966,9833,'ba','Tahap baru',0),(353967,9833,'nl','Nieuwe fase',0),(353968,9833,'fi','Uusi vaihe',0),(353969,9833,'no','Nytt stadium',0),(353970,9833,'da','Ny fase',0),(353971,9833,'ko','ìƒˆë¡œìš´ ë‹¨ê³„',0),(353972,9833,'he','×‘×ž×” ×—×“×©×”',0),(353973,9833,'el','ÎÎ­Î¿ ÏƒÏ„Î¬Î´Î¹Î¿',0),(353974,9833,'zh','æ–°é˜¶æ®µ\r\n',0),(353975,9833,'sv','Ny etapp',0),(353976,9833,'it','Nuova tappa',0),(353977,9833,'tl','',0),(353978,9833,'th','&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;&#3651;&#3627;&#3617;&#3656;',0),(353979,9833,'hi','à¤¨à¤ˆ à¤…à¤µà¤¸à¥à¤¥à¤¾',0),(353980,9833,'ms','Peringkat baru',0),(353981,9833,'ar','Ù…Ø±Ø­Ù„Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(353982,9833,'fr','Nouvelle Ã©tape',0),(353983,9833,'jp','æ–°ãŸãªã‚‹ã‚¹ãƒ†ãƒ¼ã‚¸',0),(353984,9833,'pt','Nova etapa',0),(353985,9833,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÑÑ‚Ð°Ð¿',0),(353986,9833,'es','Nueva Etapa',0),(353987,9833,'de','Neue Etappe',0),(353988,9833,'en','New Stage',0),(353989,9834,'is','',0),(353990,9834,'dr','Ù…Ø±Ø­Ù„Ù‡ Ù‚Ø¨Ù„ÙŠ',0),(353991,9834,'pr','Ù…Ø±Ø­Ù„Ù‡ Ù‚Ø¨Ù„ÙŠ',0),(353992,9834,'tr','Eski sahne',0),(353993,9834,'pl','Starego etapu',0),(353994,9834,'bg','Ð¡Ñ‚Ð°Ñ€Ð¸Ñ ÐµÑ‚Ð°Ð¿',0),(353995,9834,'ur','Ù¾Ø±Ø§Ù†ÛŒ Ù…Ø±Ø­Ù„Û’',0),(353996,9834,'sr','Ð¡Ñ‚Ð°Ñ€Ð¸ ÑÑ†ÐµÐ½Ð¸',0),(353997,9834,'vi','giai Ä‘oáº¡n cÅ©',0),(353998,9834,'af','Ou stadium',0),(353999,9834,'ro','Etapa vechi',0),(354000,9834,'et','Vana etapp',0),(354001,9834,'si','Stari fazi',0),(354002,9834,'ba','Tahap tua',0),(354003,9834,'nl','Oude stadium',0),(354004,9834,'fi','Vanha vaiheessa',0),(354005,9834,'no','Gamle scenen',0),(354006,9834,'da','Gamle scene',0),(354007,9834,'ko','ì˜¤ëž˜ ëœ ë‹¨ê³„',0),(354008,9834,'he','×”×‘×ž×” ×”×¢×ª×™×§×”',0),(354009,9834,'el','Î Î±Î»Î¹ÏŒ ÏƒÏ„Î¬Î´Î¹Î¿',0),(354010,9834,'zh','æ—§é˜¶æ®µ\r\n',0),(354011,9834,'sv','Gamla scenen',0),(354012,9834,'it','Vecchio stadio',0),(354013,9834,'tl','',0),(354014,9834,'th','&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;&#3648;&#3585;&#3656;&#3634;',0),(354015,9834,'hi','à¤ªà¥à¤°à¤¾à¤¨à¥‡ à¤®à¤‚à¤š',0),(354016,9834,'ms','Peringkat lama',0),(354017,9834,'ar','Ù…Ø±Ø­Ù„Ø© Ù‚Ø¯ÙŠÙ…Ø©',0),(354018,9834,'fr','Ancien stade',0),(354019,9834,'jp','å¤ã„ã‚¹ãƒ†ãƒ¼ã‚¸',0),(354020,9834,'pt','Antigo palco',0),(354021,9834,'ru','Ð¡Ñ‚Ð°Ñ€Ñ‹Ð¹ ÑÑ‚Ð°Ð¿',0),(354022,9834,'es','Etapa Vieja',0),(354023,9834,'de','Alte Stufe',0),(354024,9834,'en','Old Stage',0),(354025,9835,'is','',0),(354026,9835,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ ',0),(354027,9835,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ ',0),(354028,9835,'tr','SatÄ±nalma sipariÅŸleri',0),(354029,9835,'pl','ZamÃ³wienia zakupu',0),(354030,9835,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(354031,9835,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(354032,9835,'sr','Ð˜Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(354033,9835,'vi','ÄÆ¡n Mua HÃ ng',0),(354034,9835,'af','Aankoopbestellings',0),(354035,9835,'ro','Comenzi de cumpÄƒrare',0),(354036,9835,'et','Ostutellimused',0),(354037,9835,'si','NaroÄilnice',0),(354038,9835,'ba','Pesanan pembelian',0),(354039,9835,'nl','Inkooporders',0),(354040,9835,'fi','Ostotilaukset',0),(354041,9835,'no','Bestillinger',0),(354042,9835,'da','KÃ¸bsordrer',0),(354043,9835,'ko','êµ¬ë§¤ ì£¼ë¬¸',0),(354044,9835,'he','×”×–×ž× ×•×ª ×¨×›×™×©×”',0),(354045,9835,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Î³Î¿ÏÎ¬Ï‚',0),(354046,9835,'zh','é‡‡è´­è®¢å•\r\n',0),(354047,9835,'sv','InkÃ¶psorder',0),(354048,9835,'it','Ordini di acquisto',0),(354049,9835,'tl','',0),(354050,9835,'th','&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3651;&#3609;&#3585;&#3634;&#3619;&#3595;&#3639;&#3657;&#3629;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(354051,9835,'hi','à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(354052,9835,'ms','Pesanan pembelian',0),(354053,9835,'ar','Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ø´Ø±Ø§Ø¡',0),(354054,9835,'fr','Bons de commande',0),(354055,9835,'jp','ç™ºæ³¨æ›¸',0),(354056,9835,'pt','Ordens de compra',0),(354057,9835,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(354058,9835,'es','Ordenes de Compra',0),(354059,9835,'de','Bestellungen/AuftrÃ¤ge',0),(354060,9835,'en','Purchase Orders',0),(354061,9836,'is','',0),(354062,9836,'dr','Ù…Ø±Ø­Ù„Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(354063,9836,'pr','Ù…Ø±Ø­Ù„Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØºÙŠÙŠØ± ÙƒØ±Ø¯ ',0),(354064,9836,'tr','Sahne baÅŸarÄ±yla deÄŸiÅŸtirildi',0),(354065,9836,'pl','Etapie pomyÅ›lnie zmieniony',0),(354066,9836,'bg','Ð•Ñ‚Ð°Ð¿ Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(354067,9836,'ur','Ù…Ø±Ø­Ù„Û’ Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(354068,9836,'sr','Ð¤Ð°Ð·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½',0),(354069,9836,'vi','Thay Ä‘á»•i giai Ä‘oáº¡n thÃ nh cÃ´ng',0),(354070,9836,'af','Terrein Suksesvol Verander',0),(354071,9836,'ro','Scena s-a schimbat cu succes',0),(354072,9836,'et','Muudetud etapp',0),(354073,9836,'si','Fazi, uspeÅ¡no',0),(354074,9836,'ba','Tahap yang berhasil diubah',0),(354075,9836,'nl','Fase met succes gewijzigd',0),(354076,9836,'fi','Vaiheessa muutettu',0),(354077,9836,'no','Scenen endret',0),(354078,9836,'da','Tidspunkt Ã¦ndret',0),(354079,9836,'ko','ì„±ê³µì ìœ¼ë¡œ ë³€ê²½ í•˜ëŠ” ë‹¨ê³„',0),(354080,9836,'he','×‘×ž×” ×©×•× ×” ×‘×”×¦×œ×—×”',0),(354081,9836,'el','Î†Î»Î»Î±Î¾Îµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚ Ï„Î¿ ÏƒÏ„Î¬Î´Î¹Î¿',0),(354082,9836,'zh','ç¬¬ä¸€é˜¶æ®µå·²æˆåŠŸæ›´æ”¹\r\n',0),(354083,9836,'sv','Scenen som Ã¤ndrats',0),(354084,9836,'it','Fase ha cambiato con successo',0),(354085,9836,'tl','',0),(354086,9836,'th','à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¹€à¸ªà¸£à¹‡à¸ˆ',0),(354087,9836,'hi','à¤šà¤°à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(354088,9836,'ms','Peringkat yang berjaya ditukar',0),(354089,9836,'ar','ØºÙŠÙ‘Ø±Øª Ø§Ù„Ù…Ø±Ø­Ù„Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(354090,9836,'fr','Stade a changÃ© avec succÃ¨s',0),(354091,9836,'jp','æ®µéšŽã®å¤‰æ›´ã«æˆåŠŸ',0),(354092,9836,'pt','EstÃ¡gio alterado com Ãªxito',0),(354093,9836,'ru','Ð¡Ñ‚Ð°Ð´Ð¸Ñ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½',0),(354094,9836,'es','Etapa Cambiada Exitosamente',0),(354095,9836,'de','Phase wurden erfolgreich geÃ¤ndert',0),(354096,9836,'en','Stage Changed Successfully',0),(354097,9837,'is','',0),(354098,9837,'dr','Ù…Ø±Ø­Ù„Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(354099,9837,'pr','Ù…Ø±Ø­Ù„Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(354100,9837,'tr','Sahne baÅŸarÄ±yla silindi',0),(354101,9837,'pl','Sceny usuniÄ™te pomyÅ›lnie',0),(354102,9837,'bg','Ð•Ñ‚Ð°Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(354103,9837,'ur','Ù…Ø±Ø­Ù„Û Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(354104,9837,'sr','Ð¤Ð°Ð·Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(354105,9837,'vi','XÃ³a giai Ä‘oáº¡n thÃ nh cÃ´ng',0),(354106,9837,'af','\"Stage\" Suksesvol Geskrap',0),(354107,9837,'ro','EtapÄƒ eliminÄƒ cu succes',0),(354108,9837,'et','Etapp edukalt kustutatud',0),(354109,9837,'si','Fazi uspeÅ¡no izbrisana',0),(354110,9837,'ba','Tahap dihapus berhasil',0),(354111,9837,'nl','Fase succesvol verwijderd',0),(354112,9837,'fi','Vaiheessa poistettu',0),(354113,9837,'no','Scenen slettet',0),(354114,9837,'da','Fase slettet',0),(354115,9837,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ë‹¨ê³„',0),(354116,9837,'he','×©×œ×‘ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(354117,9837,'el','Î”Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚ Ï„Î¿ ÏƒÏ„Î¬Î´Î¹Î¿',0),(354118,9837,'zh','ç¬¬ä¸€é˜¶æ®µæˆåŠŸåˆ é™¤\r\n',0),(354119,9837,'sv','Scenen som raderades',0),(354120,9837,'it','Eliminati con successo del cestino',0),(354121,9837,'tl','',0),(354122,9837,'th','à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸—à¸µà¹ˆà¸–à¸¹à¸à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(354123,9837,'hi','à¤šà¤°à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾',0),(354124,9837,'ms','Peringkat dihapuskan dengan jayanya',0),(354125,9837,'ar','Ø­Ø°ÙØª Ø§Ù„Ù…Ø±Ø­Ù„Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(354126,9837,'fr','ScÃ¨ne supprimÃ©e avec succÃ¨s',0),(354127,9837,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸæ®µéšŽ',0),(354128,9837,'pt','Palco apagado com sucesso',0),(354129,9837,'ru','Ð¡Ñ‚Ð°Ð´Ð¸Ñ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(354130,9837,'es','Etapa Eliminada Exitosamente',0),(354131,9837,'de','BÃ¼hne wurde erfolgreich gelÃ¶scht',0),(354132,9837,'en','Stage Deleted Successfully',0),(354133,9838,'is','',0),(354134,9838,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰',0),(354135,9838,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰',0),(354136,9838,'tr','TaÅŸeron PO\'Ä±n',0),(354137,9838,'pl','Podwykonawstwo PO',0),(354138,9838,'bg','ÐŸÐ¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ PO',0),(354139,9838,'ur','Ø³Ø¨Ú©ÙˆÙ†Ù¹Ø±Ø§Ú©Ù¹ Ù¾Ùˆ',0),(354140,9838,'sr','ÐŸÐ¾Ð´Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð° ÐŸÐž',0),(354141,9838,'vi','ÄÆ¡n Ä‘áº·t hÃ ng cá»§a phá»¥ lá»¥c há»£p Ä‘á»“ng',0),(354142,9838,'af','Sub-kontrak AB\'s',0),(354143,9838,'ro','Subcontractare PO',0),(354144,9838,'et','Allhankelepingu PO',0),(354145,9838,'si','Podpogodbe PO',0),(354146,9838,'ba','Subkontrak PO',0),(354147,9838,'nl','Onderaanneming PO\'s',0),(354148,9838,'fi','Alihankinnan PO',0),(354149,9838,'no','Sub-PO',0),(354150,9838,'da','Underleverance PO',0),(354151,9838,'ko','í•˜ì²­ í¬',0),(354152,9838,'he','×©×œ ×§×¨×™×¢×ª ×¤×•',0),(354153,9838,'el','Î¥Ï€ÎµÏÎ³Î¿Î»Î±Î²Î¯Î± ÎŸÎ ',0),(354154,9838,'zh','åˆ†åŒ…è®¢å•çš„\r\n',0),(354155,9838,'sv','UnderleverantÃ¶rskontraktet PO',0),(354156,9838,'it','Di subappalto PO',0),(354157,9838,'tl','',0),(354158,9838,'th','&#3626;&#3633;&#3597;&#3597;&#3634;&#3619;&#3633;&#3610;&#3594;&#3656;&#3623;&#3591;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(354159,9838,'hi','Subcontract PO',0),(354160,9838,'ms','Subkontrak PO',0),(354161,9838,'ar','Ø§Ù„ØªØ¹Ø§Ù‚Ø¯ Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù† Ø¨Ùˆ',0),(354162,9838,'fr','Contrat de sous-traitance PO',0),(354163,9838,'jp','ä¸‹è«‹ PO',0),(354164,9838,'pt','Do subcontrato PO',0),(354165,9838,'ru','Ð”Ð¾Ð³Ð¾Ð²Ð¾Ñ€ ÑÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´Ð° PO',0),(354166,9838,'es','OC\'s de Subcontrato',0),(354167,9838,'de','Unterauftrag PO',0),(354168,9838,'en','Subcontract PO\'s',0),(354169,9839,'is','',0),(354170,9839,'dr','Ù†ÙˆØ¹ Ù…Ø±Ø­Ù„Ù‡ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(354171,9839,'pr','Ù†ÙˆØ¹ Ù…Ø±Ø­Ù„Ù‡ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(354172,9839,'tr','Sahne tÃ¼rÃ¼ yok',0),(354173,9839,'pl','Nie istnieje typ etapu',0),(354174,9839,'bg','Ð¢Ð¸Ð¿ Ð½Ð° ÑÑ†ÐµÐ½Ð°Ñ‚Ð° Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(354175,9839,'ur','Ø§Ø³Ù¹ÛŒØ¬ Ú©ÛŒ Ù‚Ø³Ù… Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº',0),(354176,9839,'sr','Ð¢Ð¸Ð¿ Ð½Ð° Ð¿Ð¾Ð·Ð¾Ñ€Ð½Ð¸Ñ†Ð¸ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(354177,9839,'vi','Loáº¡i giai Ä‘oáº¡n nÃ y khÃ´ng tá»“n táº¡i',0),(354178,9839,'af','Die stadium tipe bestaan nie',0),(354179,9839,'ro','Nu exista tip de scenÄƒ',0),(354180,9839,'et','Etapi tÃ¼Ã¼pi pole olemas',0),(354181,9839,'si','Fazi vrsta ne obstaja',0),(354182,9839,'ba','Jenis tahap yang tidak ada',0),(354183,9839,'nl','Het Type fase bestaat niet',0),(354184,9839,'fi','Vaiheen tyyppiÃ¤ ei ole olemassa',0),(354185,9839,'no','Hvilken scenen finnes ikke',0),(354186,9839,'da','Fase Type findes ikke',0),(354187,9839,'ko','ë¬´ëŒ€ í˜•ì‹ì´ ì¡´ìž¬ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(354188,9839,'he','×¡×•×’ ×©×œ×‘ ×œ× ×§×™×™×',0),(354189,9839,'el','ÎŸ Ï„ÏÏ€Î¿Ï‚ Ï„Î¿ ÏƒÏ„Î¬Î´Î¹Î¿ Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹',0),(354190,9839,'zh','é˜¶æ®µç±»åž‹ä¸å­˜åœ¨\r\n',0),(354191,9839,'sv','Vilken scen existerar inte',0),(354192,9839,'it','Il tipo di fase non esiste',0),(354193,9839,'tl','',0),(354194,9839,'th','&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;&#3652;&#3617;&#3656;&#3617;&#3637;',0),(354195,9839,'hi','à¤®à¤‚à¤š à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(354196,9839,'ms','Jenis peringkat yang tidak wujud',0),(354197,9839,'ar','Ù†ÙˆØ¹ Ù‡Ø°Ø§ Ø§Ù„Ù…Ø±Ø­Ù„Ø© ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(354198,9839,'fr','Le Type de scÃ¨ne nâ€™existe pas',0),(354199,9839,'jp','ã‚¹ãƒ†ãƒ¼ã‚¸ã®ç¨®é¡žã¯å­˜åœ¨ã—ã¾ã›ã‚“',0),(354200,9839,'pt','O tipo de estÃ¡gio nÃ£o existe',0),(354201,9839,'ru','Ð¢Ð¸Ð¿ ÑÑ‚Ð°Ð¿Ð° Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(354202,9839,'es','El Tipo de Etapa No Existe',0),(354203,9839,'de','Die BÃ¼hne ist nicht vorhanden',0),(354204,9839,'en','The Stage Type Does Not Exist',0),(354205,9840,'is','',0),(354206,9840,'dr','Ø´Ù…Ø§ Ø¨Ù‡ ØªÙ†Ø¸ÙŠÙ… Ø§ÙŠÙ† Ù…Ø±Ø­Ù„Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø¯Ø§Ø±ÙŠØ¯ ',0),(354207,9840,'pr','Ø´Ù…Ø§ Ø¨Ù‡ ØªÙ†Ø¸ÙŠÙ… Ø§ÙŠÙ† Ù…Ø±Ø­Ù„Ù‡ Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø¯Ø§Ø±ÙŠØ¯ ',0),(354208,9840,'tr','Bu sahne ayarlamak iÃ§in eriÅŸim hakkÄ±nÄ±z yok',0),(354209,9840,'pl','Nie masz dostÄ™pu, aby ustawiÄ‡ ten etap',0),(354210,9840,'bg','Ð’Ð¸Ðµ Ð½ÑÐ¼Ð°Ñ‚Ðµ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð° Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ Ñ‚Ð¾Ð·Ð¸ ÐµÑ‚Ð°Ð¿',0),(354211,9840,'ur','Ø¢Ù¾ Ø§Ø³ Ù…Ø±Ø­Ù„Û’ Ú©Ùˆ Ø³ÛŒÙ¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø±Ø³Ø§Ø¦ÛŒ Ø­Ø§ØµÙ„ Ù†ÛÛŒÚº',0),(354212,9840,'sr','ÐÐµÐ¼Ð°Ñ‚Ðµ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸ Ð¾Ð²Ñƒ Ñ„Ð°Ð·Ñƒ',0),(354213,9840,'vi','Báº¡n khÃ´ng cÃ³ quyá»n truy cáº­p Ä‘á»ƒ thiáº¿t láº­p giai Ä‘oáº¡n',0),(354214,9840,'af','U het nie Toegang om Hierdie Vlak te Stel',0),(354215,9840,'ro','Nu aveÅ£i acces pentru a seta aceastÄƒ etapÄƒ',0),(354216,9840,'et','Teil ei ole Ãµigusi seadistada seda etappi',0),(354217,9840,'si','Nimate dostopa nastavite etapa',0),(354218,9840,'ba','Anda tidak memiliki akses untuk mengatur tahap ini',0),(354219,9840,'nl','U hoeft geen toegang tot dit decor',0),(354220,9840,'fi','Sinulla ei ole pÃ¤Ã¤syÃ¤ asettaa tÃ¤ssÃ¤ vaiheessa',0),(354221,9840,'no','Du har ikke tilgang til Ã¥ sette dette stadiet',0),(354222,9840,'da','Du har ikke adgang til denne fase indstille',0),(354223,9840,'ko','ì´ ë‹¨ê³„ë¥¼ ì„¤ì • í•˜ì§€ ì•Šì•„ë„',0),(354224,9840,'he','××™×Ÿ ×œ×š ×’×™×©×” ×›×“×™ ×œ×”×’×“×™×¨ ×‘×©×œ×‘ ×–×”',0),(354225,9840,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· Î³Î¹Î± Î½Î± ÏÏ…Î¸Î¼Î¯ÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¬Î´Î¹Î¿',0),(354226,9840,'zh','æ‚¨æ²¡æœ‰æƒé™è®¿é—®è®¾ç½®æ­¤é˜¶æ®µ\r\n',0),(354227,9840,'sv','Du har inte tillgÃ¥ng till stÃ¤lla denna scenen',0),(354228,9840,'it','Non si dispone di accesso per impostare questa fase',0),(354229,9840,'tl','',0),(354230,9840,'th','&#3588;&#3640;&#3603;&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3586;&#3657;&#3634;&#3606;&#3638;&#3591;&#3585;&#3634;&#3619;&#3605;&#3633;&#3657;&#3591;&#3626;&#3606;&#3634;&#3609;&#3607;&#3637;&#3656;&#3609;&#3637;&#3657;',0),(354231,9840,'hi','à¤†à¤ªà¤•à¥‹ à¤‡à¤¸ à¤¸à¥à¤¤à¤° à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¹à¥à¤à¤š à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(354232,9840,'ms','Anda tidak mempunyai akses untuk menetapkan peringkat ini',0),(354233,9840,'ar','Ù„ÙŠØ³ Ù„Ø¯ÙŠÙƒ Ø­Ù‚ Ø§Ù„ÙˆØµÙˆÙ„ Ø¶Ø¨Ø· Ù‡Ø°Ù‡ Ø§Ù„Ù…Ø±Ø­Ù„Ø©',0),(354234,9840,'fr','Vous nâ€™avez pas accÃ¨s Ã  ce stade de la valeur',0),(354235,9840,'jp','ã“ã®æ®µéšŽã‚’è¨­å®šã¸ã®ã‚¢ã‚¯ã‚»ã‚¹ã‚’å¿…è¦ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(354236,9840,'pt','VocÃª nÃ£o tem acesso ao conjunto nesta fase',0),(354237,9840,'ru','ÐÐµÑ‚ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ð´Ð»Ñ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ ÑÑ‚Ð¾Ð¹ ÑÑ‚Ð°Ð´Ð¸Ð¸',0),(354238,9840,'es','No Tiene Acceso para Configurar esta Etapa',0),(354239,9840,'de','Sie haben keinen Zugriff auf diese BÃ¼hne',0),(354240,9840,'en','You Do Not Have Access to Set This Stage',0),(354241,9841,'is','',0),(354242,9841,'dr','(Ø§Ù†ØªØµØ§Ø¨- )',0),(354243,9841,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª (Ø§Ù†ØªØµØ§Ø¨- )',0),(354244,9841,'tr','Randevu ekleme',0),(354245,9841,'pl','Dodawanie terminu',0),(354246,9841,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÑ€ÐµÑ‰Ð°',0),(354247,9841,'ur','ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(354248,9841,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(354249,9841,'vi','ThÃªm lÃ´',0),(354250,9841,'af','Afspraak Byvoeg',0),(354251,9841,'ro','Adauga rezervare',0),(354252,9841,'et','Kohtumise lisamine',0),(354253,9841,'si','Dodati sestanek',0),(354254,9841,'ba','Menambahkan janji temu',0),(354255,9841,'nl','Afspraak toevoegen',0),(354256,9841,'fi','LisÃ¤Ã¤ tapaaminen',0),(354257,9841,'no','Legge til avtale',0),(354258,9841,'da','TilfÃ¸je udnÃ¦vnelsen',0),(354259,9841,'ko','ì•½ì† ì¶”ê°€',0),(354260,9841,'he','×”×•×¡×£ ×¤×’×™×©×”',0),(354261,9841,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ…Î½Î¬Î½Ï„Î·ÏƒÎ·Ï‚',0),(354262,9841,'zh','å¢žåŠ çº¦ä¼š\r\n',0),(354263,9841,'sv','LÃ¤gga till avtalad tid',0),(354264,9841,'it','Aggiungere appuntamento',0),(354265,9841,'tl','',0),(354266,9841,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;',0),(354267,9841,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(354268,9841,'ms','Tambah pelantikan',0),(354269,9841,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ¹Ø¯',0),(354270,9841,'fr','Ajouter rendez-vous',0),(354271,9841,'jp','äºˆå®šã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(354272,9841,'pt','Adicionar a nomeaÃ§Ã£o',0),(354273,9841,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(354274,9841,'es','Agregar Cita',0),(354275,9841,'de','Termin hinzufÃ¼gen',0),(354276,9841,'en','Add Appointment',0),(354277,9842,'is','',0),(354278,9842,'dr','Ø§Ø«Ø§Ø«Ù‡',0),(354279,9842,'pr','Ø§Ø«Ø§Ø«Ù‡',0),(354280,9842,'tr','Randevular',0),(354281,9842,'pl','Terminy',0),(354282,9842,'bg','Ð¡Ñ€ÐµÑ‰Ð¸',0),(354283,9842,'ur','ØªØ¹ÛŒÙ†Ø§Øª Ù…Ù„Ø§Ù‚Ø§Øª',0),(354284,9842,'sr','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(354285,9842,'vi','CÃ¡c cuá»™c háº¹n',0),(354286,9842,'af','Afsprake',0),(354287,9842,'ro','Numiri',0),(354288,9842,'et','Kohtumised',0),(354289,9842,'si','Sestanki',0),(354290,9842,'ba','Janji',0),(354291,9842,'nl','Afspraken',0),(354292,9842,'fi','Tapaamiset',0),(354293,9842,'no','Avtaler',0),(354294,9842,'da','UdnÃ¦vnelser',0),(354295,9842,'ko','ì•½ì†',0),(354296,9842,'he','×¤×’×™×©×•×ª',0),(354297,9842,'el','Î¡Î±Î½Ï„ÎµÎ²Î¿Ï',0),(354298,9842,'zh','çº¦ä¼š\r\n',0),(354299,9842,'sv','Avtalade tider',0),(354300,9842,'it','Appuntamenti',0),(354301,9842,'tl','',0),(354302,9842,'th','&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;',0),(354303,9842,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ',0),(354304,9842,'ms','Janji temu',0),(354305,9842,'ar','Ù…ÙˆØ§Ø¹ÙŠØ¯',0),(354306,9842,'fr','Rendez-vous',0),(354307,9842,'jp','äºˆå®š',0),(354308,9842,'pt','NomeaÃ§Ãµes',0),(354309,9842,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(354310,9842,'es','Citas',0),(354311,9842,'de','Termine',0),(354312,9842,'en','Appointments',0),(354313,9843,'is','',0),(354314,9843,'dr','(Ø§Ù†ØªØµØ§Ø¨ Ù‡Ø§- Ø§Ø«Ø§Ø«Ù‡)',0),(354315,9843,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ  Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª Ù‡Ø§(Ø§Ù†ØªØµØ§Ø¨ Ù‡Ø§- Ø§Ø«Ø§Ø«Ù‡)',0),(354316,9843,'tr','Randevular yÃ¶nergeleri',0),(354317,9843,'pl','Instrukcje terminÃ³w',0),(354318,9843,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° ÑÑ€ÐµÑ‰Ð¸',0),(354319,9843,'ur','ØªØ¹ÛŒÙ†Ø§Øª Ù…Ù„Ø§Ù‚Ø§Øª ÛØ¯Ø§ÛŒØ§Øª',0),(354320,9843,'sr','Ð£Ð¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð·Ð° Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(354321,9843,'vi','HÆ°á»›ng dáº«n cÃ¡c cuá»™c háº¹n',0),(354322,9843,'af','Afsprake Instruksies',0),(354323,9843,'ro','Numiri instrucÅ£iuni',0),(354324,9843,'et','Kohtumised juhiseid',0),(354325,9843,'si','Sestanki navodila',0),(354326,9843,'ba','Janji petunjuk',0),(354327,9843,'nl','Afspraken instructies',0),(354328,9843,'fi','Tapaamiset ohjeet',0),(354329,9843,'no','Avtaler instruksjoner',0),(354330,9843,'da','UdnÃ¦vnelser instruktioner',0),(354331,9843,'ko','ì•½ì† ì§€ì¹¨',0),(354332,9843,'he','×¤×’×™×©×•×ª ×”×•×¨××•×ª',0),(354333,9843,'el','Î£Ï…Î½Î±Î½Ï„Î®ÏƒÎµÎ¹Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(354334,9843,'zh','çº¦ä¼šè¯´æ˜Ž\r\n',0),(354335,9843,'sv','Avtalade tider instruktioner',0),(354336,9843,'it','Istruzioni di appuntamenti',0),(354337,9843,'tl','',0),(354338,9843,'th','&#3588;&#3635;&#3649;&#3609;&#3632;&#3609;&#3635;&#3651;&#3609;&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;',0),(354339,9843,'hi','à¤¨à¤¿à¤¯à¥à¤•à¥à¤¤à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(354340,9843,'ms','Arahan pelantikan',0),(354341,9843,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ§Ø¹ÙŠØ¯',0),(354342,9843,'fr','Instructions de nominations',0),(354343,9843,'jp','äºˆå®šã®æŒ‡ç¤º',0),(354344,9843,'pt','InstruÃ§Ãµes de nomeaÃ§Ãµes',0),(354345,9843,'ru','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð¿Ð¾ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸ÑÐ¼',0),(354346,9843,'es','Instrucciones de Citas',0),(354347,9843,'de','Termine-Anweisungen',0),(354348,9843,'en','Appointments Instructions',0),(354349,9844,'is','',0),(354350,9844,'dr','(Ø§Ù†ØªØµØ§Ø¨) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯.',0),(354351,9844,'pr','Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª(Ø§Ù†ØªØµØ§Ø¨) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯.',0),(354352,9844,'tr','Randevu baÅŸarÄ±yla eklendi',0),(354353,9844,'pl','Mianowanie dodany pomyÅ›lnie',0),(354354,9844,'bg','Ð¡Ñ€ÐµÑ‰Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(354355,9844,'ur','Ù…Ù„Ø§Ù‚Ø§Øª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(354356,9844,'sr','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð° Ð¾Ð±Ð°Ð²ÐµÐ·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(354357,9844,'vi','Cuá»™c hen thÃªm vÃ o thÃ nh cÃ´ng',0),(354358,9844,'af','Afspraak Suksesvol Bygevoeg',0),(354359,9844,'ro','Numirea adÄƒugat cu succes',0),(354360,9844,'et','Kohtumine on edukalt',0),(354361,9844,'si','Imenovanje dodani',0),(354362,9844,'ba','Penunjukan ditambahkan berhasil',0),(354363,9844,'nl','Afspraak toegevoegd',0),(354364,9844,'fi','Tapaamisen lisÃ¤Ã¤minen onnistui',0),(354365,9844,'no','Avtalen ble lagt til',0),(354366,9844,'da','UdnÃ¦vnelse tilfÃ¸jet',0),(354367,9844,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ì•½ì†',0),(354368,9844,'he','×ž×™× ×•×™ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(354369,9844,'el','Î”Î¹Î¿ÏÎ¹ÏƒÎ¼ÏŒÏ‚ Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(354370,9844,'zh','é¢„çº¦æˆåŠŸæ·»åŠ \r\n',0),(354371,9844,'sv','Avtalad tid lagts',0),(354372,9844,'it','Appuntamento aggiunto con successo',0),(354373,9844,'tl','',0),(354374,9844,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(354375,9844,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(354376,9844,'ms','Perlantikan yang berjaya menambah',0),(354377,9844,'ar','Ø£Ø¶Ø¨Ù Ø§Ù„Ù…ÙˆØ¹Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(354378,9844,'fr','Rendez-vous ajoutÃ© avec succÃ¨s',0),(354379,9844,'jp','äºˆå®šãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(354380,9844,'pt','Compromisso adicionado com sucesso',0),(354381,9844,'ru','Ð’ÑÑ‚Ñ€ÐµÑ‡Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(354382,9844,'es','Cita Agregada Exitosamente',0),(354383,9844,'de','Termin wurde erfolgreich hinzugefÃ¼gt',0),(354384,9844,'en','Appointment Added Successfully',0),(354385,9845,'is','',0),(354386,9845,'dr','(Ø§Ù†ØªØµØ§Ø¨) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(354387,9845,'pr','Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª(Ø§Ù†ØªØµØ§Ø¨) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(354388,9845,'tr','Randevu baÅŸarÄ±yla silindi',0),(354389,9845,'pl','Mianowanie usuniÄ™ty',0),(354390,9845,'bg','Ð¡Ñ€ÐµÑ‰Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(354391,9845,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù…Ù„Ø§Ù‚Ø§Øª',0),(354392,9845,'sr','Ð¡Ð°ÑÑ‚Ð°Ð½Ð°Ðº Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(354393,9845,'vi','Cuá»™c háº¹n xÃ³a thÃ nh cÃ´ng',0),(354394,9845,'af','Afspraak Suksesvol Geskrap',0),(354395,9845,'ro','Numirea eliminÄƒ cu succes',0),(354396,9845,'et','Kohtumise edukalt kustutatud',0),(354397,9845,'si','Imenovanje uspeÅ¡no izbrisana',0),(354398,9845,'ba','Penunjukan dihapus berhasil',0),(354399,9845,'nl','Afspraak met succes verwijderd',0),(354400,9845,'fi','Tapaamisen poistettu',0),(354401,9845,'no','Avtalen ble slettet',0),(354402,9845,'da','UdnÃ¦vnelse slettet',0),(354403,9845,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì•½ì†',0),(354404,9845,'he','×ž×™× ×•×™ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(354405,9845,'el','Î”Î¹Î¿ÏÎ¹ÏƒÎ¼ÏŒÏ‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(354406,9845,'zh','é¢„çº¦æˆåŠŸåˆ é™¤\r\n',0),(354407,9845,'sv','Avtalad tid raderades',0),(354408,9845,'it','Appuntamento eliminato con successo',0),(354409,9845,'tl','',0),(354410,9845,'th','&#3621;&#3610;&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(354411,9845,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ',0),(354412,9845,'ms','Pelantikan dihapuskan dengan jayanya',0),(354413,9845,'ar','Ø­Ø°Ù Ø§Ù„Ù…ÙˆØ¹Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(354414,9845,'fr','Nomination supprimÃ©e avec succÃ¨s',0),(354415,9845,'jp','æ­£å¸¸ã«å‰Šé™¤äºˆå®š',0),(354416,9845,'pt','NomeaÃ§Ã£o apagada com sucesso',0),(354417,9845,'ru','Ð’ÑÑ‚Ñ€ÐµÑ‡Ð¸ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½Ñ‹',0),(354418,9845,'es','Cita Eliminada Exitosamente',0),(354419,9845,'de','Termin gelÃ¶scht',0),(354420,9845,'en','Appointment Deleted Successfully',0),(354421,9846,'is','',0),(354422,9846,'dr','(Ø§Ù†ØªØµØ§Ø¨',0),(354423,9846,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª(Ø§Ù†ØªØµØ§Ø¨',0),(354424,9846,'tr','Randevu yardÄ±m',0),(354425,9846,'pl','Mianowanie pomoc',0),(354426,9846,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ Ð·Ð° Ð½Ð°Ð·Ð½Ð°Ñ‡Ð°Ð²Ð°Ð½Ðµ',0),(354427,9846,'ur','ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ú©ÛŒ Ù…Ø¯Ø¯',0),(354428,9846,'sr','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð° Ð¾Ð±Ð°Ð²ÐµÐ·Ð° Ð¿Ð¾Ð¼Ð¾Ñ›',0),(354429,9846,'vi','GiÃºp Ä‘á»¡ lá»‹ch háº¹n',0),(354430,9846,'af','Afspraak Hulp',0),(354431,9846,'ro','Numirea ajutor',0),(354432,9846,'et','Kohtumise abi',0),(354433,9846,'si','Imenovanje pomoÄ',0),(354434,9846,'ba','Janji bantuan',0),(354435,9846,'nl','Afspraak Help',0),(354436,9846,'fi','Tapaamisen ohje',0),(354437,9846,'no','Avtale hjelp',0),(354438,9846,'da','UdnÃ¦vnelse hjÃ¦lp',0),(354439,9846,'ko','ì•½ì† ë„ì›€ë§',0),(354440,9846,'he','×¢×–×¨×” ×¤×’×™×©×”',0),(354441,9846,'el','Î”Î¹Î¿ÏÎ¹ÏƒÎ¼ÏŒÏ‚ Î²Î¿Î®Î¸ÎµÎ¹Î±',0),(354442,9846,'zh','é¢„çº¦å¸®åŠ©\r\n',0),(354443,9846,'sv','Avtalad tid hjÃ¤lp',0),(354444,9846,'it','Guida di appuntamento',0),(354445,9846,'tl','',0),(354446,9846,'th','&#3585;&#3634;&#3619;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;',0),(354447,9846,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤®à¤¦à¤¦',0),(354448,9846,'ms','Bantuan pelantikan',0),(354449,9846,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„ØªØ¹ÙŠÙŠÙ†',0),(354450,9846,'fr','Aide de nomination',0),(354451,9846,'jp','äºˆç´„ãƒ˜ãƒ«ãƒ—',0),(354452,9846,'pt','Ajuda de nomeaÃ§Ã£o',0),(354453,9846,'ru','Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ° Ð¿Ð¾ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸ÑŽ',0),(354454,9846,'es','Ayuda de Cita',0),(354455,9846,'de','Termin-Hilfe',0),(354456,9846,'en','Appointment Help',0),(354457,9847,'is','',0),(354458,9847,'dr','(Ø§Ù†ØªØµØ§Ø¨)',0),(354459,9847,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª(Ø§Ù†ØªØµØ§Ø¨)',0),(354460,9847,'tr','Randevu yardÄ±m talimatlarÄ±nÄ±',0),(354461,9847,'pl','Mianowanie pomocy instrukcji',0),(354462,9847,'bg','Ð¡Ñ€ÐµÑ‰Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(354463,9847,'ur','ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ù…Ø¯Ø¯ ÛØ¯Ø§ÛŒØ§Øª',0),(354464,9847,'sr','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð° Ð¾Ð±Ð°Ð²ÐµÐ·Ð° Ð¿Ð¾Ð¼Ð¾Ñ› ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(354465,9847,'vi','HÆ°á»›ng dáº«n GiÃºp Ä‘á»¡ lá»‹ch háº¹n',0),(354466,9847,'af','Afspraak Hulp Instruksies',0),(354467,9847,'ro','InstrucÅ£iuni de ajutor rezervare',0),(354468,9847,'et','Kohtumise aidata juhiste',0),(354469,9847,'si','Imenovanje pomoÄ navodila',0),(354470,9847,'ba','Petunjuk Bantuan janji',0),(354471,9847,'nl','Afspraak hulp instructies',0),(354472,9847,'fi','Tapaaminen auttaa ohjeet',0),(354473,9847,'no','Avtale hjelp instruksjoner',0),(354474,9847,'da','UdnÃ¦vnelse hjÃ¦lp instruktioner',0),(354475,9847,'ko','ì•½ì† ë„ì›€ ì§€ì¹¨',0),(354476,9847,'he','×”×•×¨××•×ª ×œ×¢×–×¨×” ×¤×’×™×©×”',0),(354477,9847,'el','ÎŸÎ´Î·Î³Î¯ÎµÏ‚ Î²Î¿Î®Î¸ÎµÎ¹Î±Ï‚ ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(354478,9847,'zh','é¢„çº¦å¸®åŠ©è¯´æ˜Ž\r\n',0);
INSERT INTO `langdef` VALUES (354479,9847,'sv','Avtalad tid hjÃ¤lpinstruktioner',0),(354480,9847,'it','Istruzioni della Guida di appuntamento',0),(354481,9847,'tl','',0),(354482,9847,'th','&#3588;&#3635;&#3649;&#3609;&#3632;&#3609;&#3635;&#3585;&#3634;&#3619;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;',0),(354483,9847,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤®à¤¦à¤¦ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(354484,9847,'ms','Arahan bantuan pelantikan',0),(354485,9847,'ar','ØªØ¹ÙŠÙŠÙ† ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(354486,9847,'fr','Instructions dâ€™aide de nomination',0),(354487,9847,'jp','äºˆç´„ãƒ˜ãƒ«ãƒ—',0),(354488,9847,'pt','InstruÃ§Ãµes de ajuda de nomeaÃ§Ã£o',0),(354489,9847,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(354490,9847,'es','Instrucciones de Ayuda de Cita',0),(354491,9847,'de','Termin-Hilfe-Anweisungen',0),(354492,9847,'en','Appointment Help Instructions',0),(354493,9848,'is','',0),(354494,9848,'dr','(Ø§Ù†ØªØµØ§Ø¨ ',0),(354495,9848,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª  Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª(Ø§Ù†ØªØµØ§Ø¨ ',0),(354496,9848,'tr','Randevu bilgileri',0),(354497,9848,'pl','Informacji o wydarzeniu',0),(354498,9848,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÑÑ€ÐµÑ‰Ð°Ñ‚Ð°',0),(354499,9848,'ur','ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(354500,9848,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ð¾Ñ˜ Ð¾Ð±Ð°Ð²ÐµÐ·Ð¸',0),(354501,9848,'vi','ThÃ´ng tin cuá»™c háº¹n',0),(354502,9848,'af','Afspraak Inligting',0),(354503,9848,'ro','InformaÅ£ii rezervare',0),(354504,9848,'et','Kohtumise informatsioon',0),(354505,9848,'si','Informacij o sestanku',0),(354506,9848,'ba','Penunjukan informasi',0),(354507,9848,'nl','Afspraak informatie',0),(354508,9848,'fi','Tapaamisen tiedot',0),(354509,9848,'no','Avtaleinformasjonen',0),(354510,9848,'da','Aftaleoplysninger',0),(354511,9848,'ko','ì•½ì† ì •ë³´',0),(354512,9848,'he','×ž×™×“×¢ ×¢×œ ×¤×’×™×©×”',0),(354513,9848,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ…Î½Î¬Î½Ï„Î·ÏƒÎ·Ï‚',0),(354514,9848,'zh','çº¦ä¼šä¿¡æ¯\r\n',0),(354515,9848,'sv','Avtalad tid Information',0),(354516,9848,'it','Informazioni sugli appuntamenti',0),(354517,9848,'tl','',0),(354518,9848,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;',0),(354519,9848,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(354520,9848,'ms','Maklumat temujanji',0),(354521,9848,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ¹ÙŠÙŠÙ†',0),(354522,9848,'fr','Informations de nomination',0),(354523,9848,'jp','äºˆå®šã®æƒ…å ±',0),(354524,9848,'pt','InformaÃ§Ãµes de nomeaÃ§Ã£o',0),(354525,9848,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ðž Ð’ÑÑ‚Ñ€ÐµÑ‡Ðµ',0),(354526,9848,'es','InformaciÃ³n de Cita',0),(354527,9848,'de','Termininformationen',0),(354528,9848,'en','Appointment Information',0),(354529,9849,'is','',0),(354530,9849,'dr','(Ø§Ù†ØªØµØ§Ø¨) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¢Ù¾Ø¯ÛŒØª  Ø´Ø¯',0),(354531,9849,'pr','Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª(Ø§Ù†ØªØµØ§Ø¨) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(354532,9849,'tr','Randevu baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(354533,9849,'pl','Mianowanie pomyÅ›lnie zaktualizowana',0),(354534,9849,'bg','Ð¡Ñ€ÐµÑ‰Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(354535,9849,'ur','Ù…Ù„Ø§Ù‚Ø§Øª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(354536,9849,'sr','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð° Ð¾Ð±Ð°Ð²ÐµÐ·Ð° Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(354537,9849,'vi','cáº­p nháº­t thÃ´ng tin cuá»™c háº¹n thÃ nh cÃ´ng',0),(354538,9849,'af','Afspraak Suksesvol Opdateer',0),(354539,9849,'ro','Numirea actualizat cu succes',0),(354540,9849,'et','Kohtumine vÃ¤rskendatud',0),(354541,9849,'si','Imenovanje uspeÅ¡no posodobljena',0),(354542,9849,'ba','Janji yang berhasil',0),(354543,9849,'nl','Afspraak met succes bijgewerkt',0),(354544,9849,'fi','Tapaamisen pÃ¤ivittÃ¤minen onnistui',0),(354545,9849,'no','Avtale oppdatert',0),(354546,9849,'da','UdnÃ¦vnelse opdateret',0),(354547,9849,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì•½ì†',0),(354548,9849,'he','×ž×™× ×•×™ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(354549,9849,'el','Î£Ï…Î½Î¬Î½Ï„Î·ÏƒÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(354550,9849,'zh','æˆåŠŸé¢„çº¦æ›´æ–°\r\n',0),(354551,9849,'sv','Avtalad tid uppdaterats',0),(354552,9849,'it','Appuntamento aggiornato con successo',0),(354553,9849,'tl','',0),(354554,9849,'th','&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(354555,9849,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¿à¤¤ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ',0),(354556,9849,'ms','Perlantikan berjaya dikemas kini',0),(354557,9849,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ù…ÙˆØ¹Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(354558,9849,'fr','Rendez-vous Ã  jour avec succÃ¨s',0),(354559,9849,'jp','æ­£å¸¸ã«æ›´æ–°äºˆå®š',0),(354560,9849,'pt','Compromisso atualizado com sucesso',0),(354561,9849,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½',0),(354562,9849,'es','Cita Actualizada Exitosamente',0),(354563,9849,'de','Termin wurde erfolgreich aktualisiert',0),(354564,9849,'en','Appointment Updated Successfully',0),(354565,9850,'is','',0),(354566,9850,'dr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª Ø¨Ù‡ ØªÙ‚ÙˆÙŠÙ… Ø´Ù…Ø§ Ø§Ø±Ø³Ø§Ù„ Ø´ÙˆØ¯',0),(354567,9850,'pr','Ø§ÙŠÙ†Ø¬Ø§ Ø±Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª Ø¨Ù‡ ØªÙ‚ÙˆÙŠÙ… Ø´Ù…Ø§ Ø§Ø±Ø³Ø§Ù„ Ø´ÙˆØ¯',0),(354568,9850,'tr','Ä°hracat iÃ§in randevu takvim iÃ§in tÄ±klayÄ±nÄ±z',0),(354569,9850,'pl','Kliknij tutaj, aby wywÃ³z terminu do kalendarza',0),(354570,9850,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¸Ð·Ð½Ð¾Ñ ÑÑ€ÐµÑ‰Ð° Ð²ÑŠÐ² Ð²Ð°ÑˆÐ¸Ñ ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€',0),(354571,9850,'ur','ÛŒÛØ§Úº Ø¨Ø±Ø¢Ù…Ø¯ Ù¾Ø± Ù…Ù„Ø§Ù‚Ø§Øª Ø¢Ù¾ Ú©Û’ Ú©ÛŒÙ„Ù†ÚˆØ± Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(354572,9850,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð·Ð° Ð¸Ð·Ð²Ð¾Ð· Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ñƒ Ð¾Ð±Ð°Ð²ÐµÐ·Ñƒ Ñƒ ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€',0),(354573,9850,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ xuáº¥t cuá»™c háº¹n vÃ o lá»‹ch cá»§a báº¡n.',0),(354574,9850,'af','Kliek Hier om die Afspraak uit te voer na u Kalender',0),(354575,9850,'ro','Click aici pentru Export numirea Calendar',0),(354576,9850,'et','Vajuta siia, et ekspordi kalendrisse kohtumise',0),(354577,9850,'si','Kliknite tukaj za izvoz imenovanje koledar',0),(354578,9850,'ba','Klik di sini untuk ekspor janji temu ke kalender',0),(354579,9850,'nl','Klik hier om de Export de benoeming aan uw agenda',0),(354580,9850,'fi','Klikkaa tÃ¤stÃ¤ vienti tapaamisen kalenteriisi',0),(354581,9850,'no','Klikk her for Ã¥ eksportere avtalen i kalenderen',0),(354582,9850,'da','Klik her for at eksportere udnÃ¦vnelsen til din kalender',0),(354583,9850,'ko','ì¼ì •ì— ì•½ì†ì„ ë‚´ë³´ë‚¼ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(354584,9850,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×™×™×¦× ××ª ×”×¤×’×™×©×” ×œ×œ×•×— ×”×©× ×” ×©×œ×š',0),(354585,9850,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± ÎµÎ¾Î¬Î³ÎµÏ„Îµ Ï„Î¿ ÏÎ±Î½Ï„ÎµÎ²Î¿Ï ÏƒÏ„Î¿ Î·Î¼ÎµÏÎ¿Î»ÏŒÎ³Î¹ÏŒ ÏƒÎ±Ï‚',0),(354586,9850,'zh','ç‚¹å‡»è¿™é‡Œå¯¼å‡ºåˆ°æ‚¨çš„æ—¥åŽ†çº¦ä¼š\r\n',0),(354587,9850,'sv','Klicka hÃ¤r fÃ¶r att exportera utnÃ¤mningen till din kalender',0),(354588,9850,'it','Clicca qui per esportare l\'appuntamento al tuo calendario',0),(354589,9850,'tl','',0),(354590,9850,'th','&#3588;&#3621;&#3636;&#3585;&#3607;&#3637;&#3656;&#3609;&#3637;&#3656;&#3648;&#3614;&#3639;&#3656;&#3629;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;&#3652;&#3611;&#3607;&#3637;&#3656;&#3',0),(354591,9850,'hi','à¤¯à¤¹à¤¾à¤ à¤…à¤ªà¤¨à¥‡ à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(354592,9850,'ms','Klik di sini untuk eksport janji temu kalendar anda',0),(354593,9850,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„ØªØµØ¯ÙŠØ± Ø§Ù„Ù…ÙˆØ¹Ø¯ Ø¥Ù„Ù‰ Ø§Ù„ØªÙ‚ÙˆÙŠÙ… Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(354594,9850,'fr','Cliquez ici pour lâ€™exportation le rendez-vous Ã  votre calendrier',0),(354595,9850,'jp','ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦äºˆå®šè¡¨ã«äºˆå®šã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã™ã‚‹',0),(354596,9850,'pt','Clique aqui para exportaÃ§Ã£o a nomeaÃ§Ã£o ao seu calendÃ¡rio',0),(354597,9850,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð¡ÑŽÐ´Ð° Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐŸÐµÑ€ÐµÐ½ÐµÑÑ‚Ð¸ Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ñ Ð² Ð²Ð°Ñˆ ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ÑŒ',0),(354598,9850,'es','Hace Click Aqui para Exportar la Cita a su Calendario',0),(354599,9850,'de','Klicken Sie hier, um Export, den Termin in Ihren Kalender',0),(354600,9850,'en','Click Here to Export the Appointment to your Calendar',0),(354601,9851,'is','',0),(354602,9851,'dr','Ù‡ÙŠÚ† Ø§Ø«Ø§Ø«ÙŠÙ‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(354603,9851,'pr','Ù‡ÙŠÚ† Ø§Ø«Ø§Ø«ÙŠÙ‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(354604,9851,'tr','Buldum randevu yok',0),(354605,9851,'pl','Terminy, nie znaleziono',0),(354606,9851,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ ÑÑ€ÐµÑ‰Ð¸',0),(354607,9851,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ ØªØ¹ÛŒÙ†Ø§Øª Ù…Ù„Ø§Ù‚Ø§Øª',0),(354608,9851,'sr','ÐÐµÐ¼Ð° ÑÐ°ÑÑ‚Ð°Ð½Ð°ÐºÐ° Ð½Ð°ÑˆÐ°Ð¾',0),(354609,9851,'vi','khÃ´ng tÃ¬m tháº¥y thiáº¿t bá»‹',0),(354610,9851,'af','Geen Afsprake Gevind',0),(354611,9851,'ro','Nu numiri gÄƒsite',0),(354612,9851,'et','Kohtumisi ei leitud',0),(354613,9851,'si','Ni sestanki ugotovila',0),(354614,9851,'ba','Tidak ada janji yang ditemukan',0),(354615,9851,'nl','Geen afspraken gevonden',0),(354616,9851,'fi','Tapaamisia ei lÃ¶ytynyt',0),(354617,9851,'no','Ingen avtaler funnet',0),(354618,9851,'da','Ingen udnÃ¦vnelser fandt',0),(354619,9851,'ko','ì•„ë¬´ ì•½ì† ë°œê²¬',0),(354620,9851,'he','×œ× × ×ž×¦××• ×¤×’×™×©×•×ª',0),(354621,9851,'el','Î”ÎµÎ½ Î´Î¹Î¿ÏÎ¹ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(354622,9851,'zh','æœªæ‰¾åˆ°çº¦ä¼š\r\n',0),(354623,9851,'sv','Inga avtalade tider hittade',0),(354624,9851,'it','Appuntamenti non trovati',0),(354625,9851,'tl','',0),(354626,9851,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;',0),(354627,9851,'hi','à¤•à¥‹à¤ˆ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(354628,9851,'ms','Tiada pelantikan yang ditemui',0),(354629,9851,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…ÙˆØ§Ø¹ÙŠØ¯',0),(354630,9851,'fr','Aucune nomination trouvÃ©e',0),(354631,9851,'jp','ç™ºè¦‹ã®äºˆå®šã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(354632,9851,'pt','Nenhum compromisso encontrado',0),(354633,9851,'ru','ÐÐµÑ‚ Ð²ÑÑ‚Ñ€ÐµÑ‡ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(354634,9851,'es','No se Encontraron Citas',0),(354635,9851,'de','Keine Termine gefunden',0),(354636,9851,'en','No Appointments Found',0),(354637,9852,'is','',0),(354638,9852,'dr','Ù„Ø·ÙØ§ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(354639,9852,'pr','Ù„Ø·ÙØ§ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(354640,9852,'tr','LÃ¼tfen bitiÅŸ tarihi dahil',0),(354641,9852,'pl','ProszÄ™ podaÄ‡ datÄ™ zakoÅ„czenia',0),(354642,9852,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(354643,9852,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ® Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(354644,9852,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(354645,9852,'vi','vui lÃ²ng bao gá»“m 1 ngÃ y cuá»‘i',0),(354646,9852,'af','Sluit asseblief \'n End Datum in',0),(354647,9852,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i o datÄƒ de Ã®ncheiere',0),(354648,9852,'et','Palun lisa lÃµppkuupÃ¤ev',0),(354649,9852,'si','Prosimo, da vkljuÄite konÄni datum',0),(354650,9852,'ba','Harap sertakan tanggal akhir',0),(354651,9852,'nl','Geef een einddatum',0),(354652,9852,'fi','Kirjoita pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(354653,9852,'no','Ta med en dato',0),(354654,9852,'da','VedlÃ¦g en slutdato',0),(354655,9852,'ko','ì¢…ë£Œ ë‚ ì§œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(354656,9852,'he','× × ×œ×›×œ×•×œ ×ª××¨×™×š ×¡×™×•×',0),(354657,9852,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(354658,9852,'zh','è¯·åˆ—å…¥ä¸€ä¸ªç»“æŸæ—¥æœŸ\r\n',0),(354659,9852,'sv','VÃ¤nligen ange ett slutdatum',0),(354660,9852,'it','Si prega di includere una data di fine',0),(354661,9852,'tl','',0),(354662,9852,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3623;&#3633;&#3609;&#3626;&#3636;&#3657;&#3609;&#3626;&#3640;&#3604;',0),(354663,9852,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(354664,9852,'ms','Sila Sertakan tarikh tamat',0),(354665,9852,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡',0),(354666,9852,'fr','Veuillez indiquer une Date de fin',0),(354667,9852,'jp','çµ‚äº†æ—¥ã‚’æ˜Žè¨˜ã—ã¦',0),(354668,9852,'pt','Por favor, inclua uma data de tÃ©rmino',0),(354669,9852,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð”Ð°Ñ‚Ñƒ ÐžÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(354670,9852,'es','Por favor Incluye Una Fecha de TerminaciÃ³n',0),(354671,9852,'de','Bitte geben Sie ein Enddatum',0),(354672,9852,'en','Please Include an End Date',0),(354673,9853,'is','',0),(354674,9853,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹  Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(354675,9853,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹  Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(354676,9853,'tr','LÃ¼tfen baÅŸlangÄ±Ã§ tarihi ekle',0),(354677,9853,'pl','ProszÄ™ podaÄ‡ datÄ™ rozpoczÄ™cia',0),(354678,9853,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(354679,9853,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¢ØºØ§Ø² Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(354680,9853,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(354681,9853,'vi','vui lÃ²ng bao gá»“m 1 ngÃ y báº¯t Ä‘áº§u',0),(354682,9853,'af','Sluit asseblief \'n Begin Datum in',0),(354683,9853,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i o datÄƒ de Ã®nceput',0),(354684,9853,'et','Palun lisa alg kuupÃ¤ev',0),(354685,9853,'si','Prosimo, da vkljuÄite zaÄetni datum',0),(354686,9853,'ba','Harap sertakan tanggal mulai',0),(354687,9853,'nl','Geef een begindatum',0),(354688,9853,'fi','LiitÃ¤ aloituspÃ¤ivÃ¤',0),(354689,9853,'no','Ta en start dato',0),(354690,9853,'da','VedlÃ¦g en Start dato',0),(354691,9853,'ko','ì‹œìž‘ ë‚ ì§œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(354692,9853,'he','× × ×œ×›×œ×•×œ ×ª××¨×™×š ×”×”×ª×—×œ×”',0),(354693,9853,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(354694,9853,'zh','è¯·åˆ—å…¥ä¸€ä¸ªå¼€å§‹æ—¥æœŸ\r\n',0),(354695,9853,'sv','VÃ¤nligen inkludera ett Begin-datum',0),(354696,9853,'it','Si prega di includere una data di inizio',0),(354697,9853,'tl','',0),(354698,9853,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3623;&#3633;&#3609;&#3607;&#3637;&#3656;&#3648;&#3636;&#3656;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;',0),(354699,9853,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤¿à¤¸à¥€ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(354700,9853,'ms','Sila Sertakan tarikh mulakan',0),(354701,9853,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(354702,9853,'fr','Veuillez indiquer une Date de dÃ©but',0),(354703,9853,'jp','é–‹å§‹æ—¥ã‚’æ˜Žè¨˜ã—ã¦',0),(354704,9853,'pt','Por favor, inclua uma data de inÃ­cio',0),(354705,9853,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð”Ð°Ñ‚Ñƒ ÐÐ°Ñ‡Ð°Ð»Ð°',0),(354706,9853,'es','Por favor Incluye Una Fecha de Comienza',0),(354707,9853,'de','Bitte geben Sie ein Anfangsdatum',0),(354708,9853,'en','Please Include a Begin Date',0),(354709,9854,'is','',0),(354710,9854,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¹Ù†ÙˆØ§Ù†  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(354711,9854,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¹Ù†ÙˆØ§Ù†  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(354712,9854,'tr','LÃ¼tfen bir baÅŸlÄ±k ekleyin',0),(354713,9854,'pl','Prosimy o podanie tytuÅ‚u',0),(354714,9854,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð·Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ',0),(354715,9854,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø¹Ù†ÙˆØ§Ù† Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(354716,9854,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð½Ð°ÑÐ»Ð¾Ð²',0),(354717,9854,'vi','vui lÃ²ng gá»“m tá»±a Ä‘á»',0),(354718,9854,'af','Sluit \'n Titel In',0),(354719,9854,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i un titlu',0),(354720,9854,'et','Palun lisa tiitel',0),(354721,9854,'si','Prosimo, da vkljuÄite naslov',0),(354722,9854,'ba','Sertakan judul',0),(354723,9854,'nl','Voeg een titel',0),(354724,9854,'fi','SisÃ¤llytÃ¤ otsikko',0),(354725,9854,'no','Ta med en tittel',0),(354726,9854,'da','VedlÃ¦g en titel',0),(354727,9854,'ko','ì œëª© í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(354728,9854,'he','× × ×œ×›×œ×•×œ ×›×•×ª×¨×ª',0),(354729,9854,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î±Î½ Ï„Î¯Ï„Î»Î¿',0),(354730,9854,'zh','è¯·åˆ—å…¥ä¸€ä¸ªæ ‡é¢˜\r\n',0),(354731,9854,'sv','VÃ¤nligen inkludera en titel',0),(354732,9854,'it','Si prega di includere un titolo',0),(354733,9854,'tl','',0),(354734,9854,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3594;&#3639;&#3656;&#3629;&#3648;&#3619;&#3639;&#3656;&#3629;&#3591;',0),(354735,9854,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¶à¥€à¤°à¥à¤·à¤• à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(354736,9854,'ms','Sila sertakan tajuk',0),(354737,9854,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø¹Ù†ÙˆØ§Ù†',0),(354738,9854,'fr','Veuillez inclure un titre',0),(354739,9854,'jp','ã‚¿ã‚¤ãƒˆãƒ«ã‚’æ˜Žè¨˜ã—ã¦',0),(354740,9854,'pt','Por favor inclua um tÃ­tulo',0),(354741,9854,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ',0),(354742,9854,'es','Por favor Incluye Un Titulo',0),(354743,9854,'de','Bitte geben Sie einen Titel',0),(354744,9854,'en','Please Include a Title',0),(354745,9855,'is','',0),(354746,9855,'dr','(Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ',0),(354747,9855,'pr','Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ú¯Ø±ÙŠ (Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ',0),(354748,9855,'tr','Umudu',0),(354749,9855,'pl','Perspektywa',0),(354750,9855,'bg','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(354751,9855,'ur','Ø§Ù…Ú©Ø§Ù†',0),(354752,9855,'sr','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(354753,9855,'vi','triá»ƒn vá»ng',0),(354754,9855,'af','Voornemende KliÃ«nt',0),(354755,9855,'ro','Perspectiva',0),(354756,9855,'et','VÃ¤ljavaade',0),(354757,9855,'si','MoÅ¾nost',0),(354758,9855,'ba','Prospek',0),(354759,9855,'nl','Vooruitzicht',0),(354760,9855,'fi','Mahdollisuus',0),(354761,9855,'no','Prospektet',0),(354762,9855,'da','Udsigten',0),(354763,9855,'ko','ì „ë§',0),(354764,9855,'he','×¤×¨×•×¡×¤×§×˜',0),(354765,9855,'el','Î ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ®',0),(354766,9855,'zh','å‰æ™¯\r\n',0),(354767,9855,'sv','Prospect',0),(354768,9855,'it','Prospettiva',0),(354769,9855,'tl','',0),(354770,9855,'th','&#3612;&#3641;&#3657;&#3607;&#3637;&#3656;&#3627;&#3623;&#3633;&#3591;&#3592;&#3632;&#3652;&#3604;&#3657;&#3648;&#3611;&#3655;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;',0),(354771,9855,'hi','à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾',0),(354772,9855,'ms','Prospek',0),(354773,9855,'ar','Ø§Ø­ØªÙ…Ø§Ù„',0),(354774,9855,'fr','Perspective',0),(354775,9855,'jp','è¦‹é€šã—',0),(354776,9855,'pt','Prospect',0),(354777,9855,'ru','ÐŸÑ€Ð¾ÑÐ¿ÐµÐºÑ‚',0),(354778,9855,'es','Cliente Potencial',0),(354779,9855,'de','Aussicht auf',0),(354780,9855,'en','Prospect',0),(354781,9856,'is','',0),(354782,9856,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø«Ø§Ø«Ù‡',0),(354783,9856,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø«Ø§Ø«Ù‡',0),(354784,9856,'tr','Arama randevular',0),(354785,9856,'pl','Wyszukiwanie terminÃ³w',0),(354786,9856,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° ÑÑ€ÐµÑ‰Ð¸',0),(354787,9856,'ur','ØªÙ„Ø§Ø´ ØªØ¹ÛŒÙ†Ø§Øª Ù…Ù„Ø§Ù‚Ø§Øª',0),(354788,9856,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð³Ð° Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(354789,9856,'vi','TÃ¬m kiáº¿m cuá»™c háº¹n',0),(354790,9856,'af','Afsprake',0),(354791,9856,'ro','CÄƒutaÅ£i numiri',0),(354792,9856,'et','Otsi kohtumisi',0),(354793,9856,'si','IÅ¡Äi sestanke',0),(354794,9856,'ba','Cari janji',0),(354795,9856,'nl','Zoek afspraken',0),(354796,9856,'fi','Etsi tapaamiset',0),(354797,9856,'no','SÃ¸k etter avtaler',0),(354798,9856,'da','SÃ¸g udnÃ¦vnelser',0),(354799,9856,'ko','ê²€ìƒ‰ ì•½ì†',0),(354800,9856,'he','×—×¤×© ×¤×’×™×©×•×ª',0),(354801,9856,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(354802,9856,'zh','æœç´¢çº¦ä¼š\r\n',0),(354803,9856,'sv','SÃ¶k mÃ¶ten',0),(354804,9856,'it','Ricerca appuntamenti',0),(354805,9856,'tl','',0),(354806,9856,'th','&#3588;&#3657;&#3609;&#3627;&#3634;&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;',0),(354807,9856,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤–à¥‹à¤œ',0),(354808,9856,'ms','Cari pelantikan',0),(354809,9856,'ar','ØªØ¹ÙŠÙŠÙ†Ø§Øª Ø§Ù„Ø¨Ø­Ø«',0),(354810,9856,'fr','Nominations de recherche',0),(354811,9856,'jp','äºˆå®šæ¤œç´¢',0),(354812,9856,'pt','Consultas de pesquisa',0),(354813,9856,'ru','ÐŸÐ¾Ð¸ÑÐº Ð’ÑÑ‚Ñ€ÐµÑ‡',0),(354814,9856,'es','Busque Citas',0),(354815,9856,'de','Termine suchen',0),(354816,9856,'en','Search Appointments',0),(354817,9857,'is','',0),(354818,9857,'dr','Ø´Ø§Ù…Ù„ ÙŠÙƒ Ø¯ÙˆØ±Ù‡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(354819,9857,'pr','Ø´Ø§Ù…Ù„ ÙŠÙƒ Ø¯ÙˆØ±Ù‡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(354820,9857,'tr','Bir kira dÃ¶nemi dahil',0),(354821,9857,'pl','ObejmowaÄ‡ okres wynajÄ™cia',0),(354822,9857,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð½Ð°ÐµÐ¼ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(354823,9857,'ur','Ø§ÛŒÚ© Ú©Ø±Ø§Ø¦Û’ Ú©ÛŒ Ù…Ø¯Øª Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(354824,9857,'sr','ÐžÐ±ÑƒÑ…Ð²Ð°Ñ‚Ð°Ñ˜Ñƒ ÐŸÐµÑ€Ð¸Ð¾Ð´ Ð¾Ð´ ÐºÐ¸Ñ€Ð¸Ñ˜Ðµ',0),(354825,9857,'vi','Bao gá»“m thá»i gian thuÃª',0),(354826,9857,'af','Sluit \'n Huur Periode in',0),(354827,9857,'ro','Include o perioadÄƒ de inchiriat',0),(354828,9857,'et','Sisaldada Rent',0),(354829,9857,'si','VkljuÄujejo najemnino obdobje',0),(354830,9857,'ba','Mencakup periode sewa',0),(354831,9857,'nl','Een huur periode bevatten',0),(354832,9857,'fi','Vuokra pistettÃ¤',0),(354833,9857,'no','Inkluder en leie periode',0),(354834,9857,'da','Omfatte en leje periode',0),(354835,9857,'ko','ìž„ëŒ€ ê¸°ê°„ì„ í¬í•¨',0),(354836,9857,'he','×œ×›×œ×•×œ ×ª×§×•×¤×ª ×”×©×›×™×¨×•×ª',0),(354837,9857,'el','Î£Ï…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î¼Î¹Î± Ï„ÎµÎ»ÎµÎ¯Î± ÏƒÏ„Î·Î½ ÎµÎ½Î¿Î¹ÎºÎ¯Î±ÏƒÎ·',0),(354838,9857,'zh','åŒ…æ‹¬ä¸€æœŸç§Ÿ\r\n',0),(354839,9857,'sv','Inkludera en hyra Period',0),(354840,9857,'it','Comprendono un periodo di affitto',0),(354841,9857,'tl','',0),(354842,9857,'th','&#3619;&#3623;&#3617;&#3606;&#3638;&#3591;&#3594;&#3656;&#3623;&#3591;&#3648;&#3623;&#3621;&#3634;&#3607;&#3637;&#3656;&#3648;&#3594;&#3656;&#3634;',0),(354843,9857,'hi','à¤à¤• à¤•à¤¿à¤°à¤¾à¤ à¤•à¥€ à¤…à¤µà¤§à¤¿ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(354844,9857,'ms','Termasuk tempoh sewa',0),(354845,9857,'ar','ÙˆØªØ´Ù…Ù„ ÙØªØ±Ø© Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(354846,9857,'fr','Inclure une pÃ©riode de location',0),(354847,9857,'jp','ãƒ¬ãƒ³ã‚¿ãƒ«æœŸé–“ã‚’å«ã‚€',0),(354848,9857,'pt','Incluir um perÃ­odo de aluguel',0),(354849,9857,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ ÑÑ€Ð¾Ðº Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(354850,9857,'es','Incluye un PerÃ­odo de Renta',0),(354851,9857,'de','Umfassen Sie einen Zeitraum mieten',0),(354852,9857,'en','Include a Rent Period',0),(354853,9858,'is','',0),(354854,9858,'dr','(Ø§Ù‚Ø³Ø§Ø· ',0),(354855,9858,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ (Ø§Ù‚Ø³Ø§Ø· ',0),(354856,9858,'tr','Ã–deme sayÄ±sÄ±',0),(354857,9858,'pl','Liczba pÅ‚atnoÅ›ci',0),(354858,9858,'bg','Ð‘Ñ€Ð¾Ð¹ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸ÑÑ‚Ð°',0),(354859,9858,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(354860,9858,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‚Ð°',0),(354861,9858,'vi','sá»‘ thanh toÃ¡n',0),(354862,9858,'af','Aantal Betalings',0),(354863,9858,'ro','NumÄƒr de plÄƒÅ£i',0),(354864,9858,'et','Maksete arv',0),(354865,9858,'si','Å tevilo plaÄil',0),(354866,9858,'ba','Jumlah pembayaran',0),(354867,9858,'nl','Aantal betalingen',0),(354868,9858,'fi','Maksujen mÃ¤Ã¤rÃ¤',0),(354869,9858,'no','Antall innbetalinger',0),(354870,9858,'da','Antallet af betalinger',0),(354871,9858,'ko','ì§€ë¶ˆì˜ ìˆ˜',0),(354872,9858,'he','×ž×¡×¤×¨ ×”×ª×©×œ×•×ž×™×',0),(354873,9858,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½ Ï„Ï‰Î½',0),(354874,9858,'zh','ä»˜æ¬¾æ•°\r\n',0),(354875,9858,'sv','Antal betalningar',0),(354876,9858,'it','Numero di pagamenti',0),(354877,9858,'tl','',0),(354878,9858,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3586;&#3629;&#3591;&#3585;&#3634;&#3619;&#3592;&#3656;&#3634;&#3618;',0),(354879,9858,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(354880,9858,'ms','Jumlah pembayaran',0),(354881,9858,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(354882,9858,'fr','Nombre de paiements',0),(354883,9858,'jp','æ”¯æ‰•å›žæ•°',0),(354884,9858,'pt','NÃºmero de pagamentos',0),(354885,9858,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐŸÐ»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(354886,9858,'es','NÃºmero de Pagos',0),(354887,9858,'de','Anzahl der Zahlungen',0),(354888,9858,'en','Number of Payments',0),(354889,9859,'is','',0),(354890,9859,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ ',0),(354891,9859,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ ',0),(354892,9859,'tr','Umudu Ekle',0),(354893,9859,'pl','Dodaj perspektywÄ™',0),(354894,9859,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(354895,9859,'ur','Ø§Ù…Ú©Ø§Ù† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(354896,9859,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(354897,9859,'vi','ThÃªm dá»± kiáº¿n',0),(354898,9859,'af','Voornemende KliÃ«nt Byvoeg',0),(354899,9859,'ro','Adauga Prospect',0),(354900,9859,'et','VÃµimalus lisada',0),(354901,9859,'si','Dodaj moÅ¾nost',0),(354902,9859,'ba','Tambahkan prospek',0),(354903,9859,'nl','Toevoegen van vooruitzicht',0),(354904,9859,'fi','LisÃ¤Ã¤ mahdollisuuksia',0),(354905,9859,'no','Legge til prospektet',0),(354906,9859,'da','TilfÃ¸je udsigten',0),(354907,9859,'ko','ì¶”ê°€ ì „ë§',0),(354908,9859,'he','×œ×”×•×¡×™×£ ×¤×¨×•×¡×¤×§×˜',0),(354909,9859,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ®',0),(354910,9859,'zh','å¢žåŠ å±•æœ›\r\n',0),(354911,9859,'sv','LÃ¤gg till Prospect',0),(354912,9859,'it','Aggiungere Prospect',0),(354913,9859,'tl','',0),(354914,9859,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3650;&#3629;&#3585;&#3634;&#3626;',0),(354915,9859,'hi','à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(354916,9859,'ms','Menambah prospek',0),(354917,9859,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ù…ÙƒØ§Ù†ÙŠØ©',0),(354918,9859,'fr','Ajouter la perspective',0),(354919,9859,'jp','è¦‹é€šã—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(354920,9859,'pt','Adicionar perspectiva',0),(354921,9859,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ñƒ',0),(354922,9859,'es','Agregar Cliente Prospectivo',0),(354923,9859,'de','Perspektive hinzufÃ¼gen',0),(354924,9859,'en','Add Prospect',0),(354925,9860,'is','',0),(354926,9860,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³  ØªØºÙŠÙŠØ± Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(354927,9860,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³  ØªØºÙŠÙŠØ± Ø¢Ø¯Ø±Ø³ Ø§ÙŠÙ…ÙŠÙ„ ',0),(354928,9860,'tr','E-posta adresini deÄŸiÅŸtirme bilgileri yardÄ±m baÅŸvurun',0),(354929,9860,'pl','Skontaktuj siÄ™ z pomoc informacje o zmianie adresu E-mail',0),(354930,9860,'bg','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑÐ°',0),(354931,9860,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ù¾ØªÛ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Ø§ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ Ù…Ø¯Ø¯ Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº',0),(354932,9860,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸ Ð´Ð° Ð¼ÐµÑšÐ° Ð•Ð¼Ð°Ð¸Ð» Ð°Ð´Ñ€ÐµÑÐ°',0),(354933,9860,'vi','tÃ¬m thÃ´ng tin liÃªn há»‡ thay Ä‘á»•i Ä‘á»‹a chá»‰ há»™p thÆ°',0),(354934,9860,'af','Kontak Informasie Help met die Verandering van E-pos Adresse',0),(354935,9860,'ro','InformaÅ£ii de ajutor schimbarea adresa de Email de contact',0),(354936,9860,'et','Kontaktinfo abi - e-maili aadressi muutmine',0),(354937,9860,'si','Obrnite na informacije pomoÄ e-poÅ¡tni naslov',0),(354938,9860,'ba','Kontak informasi bantuan mengubah alamat Email',0),(354939,9860,'nl','Neem contact op met informatiehulp e-mailadres wijzigen',0),(354940,9860,'fi','Ota tiedot ohjeet sÃ¤hkÃ¶postiosoitteen vaihtaminen',0),(354941,9860,'no','Kontakt informasjon hjelp endre e-postadresse',0),(354942,9860,'da','Kontakt oplysninger HjÃ¦lp til at Ã¦ndre E-mail adresse',0),(354943,9860,'ko','ì •ë³´ ë„ì›€ ì´ë©”ì¼ ì£¼ì†Œ ë³€ê²½ ë¬¸ì˜',0),(354944,9860,'he','×¦×•×¨ ×§×©×¨ ×¢× ×ž×™×“×¢ ×¢×–×¨×” ×‘×©×™× ×•×™ ×›×ª×•×‘×ª ×”×“×•× ×œ ×©×œ×š',0),(354945,9860,'el','Î•Ï€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î®ÏƒÏ„Îµ Î¼Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î²Î¿Î®Î¸ÎµÎ¹Î±Ï‚ Î±Î»Î»Î±Î³Î® Ï„Î·Ï‚ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·Ï‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(354946,9860,'zh','è”ç³»ä¿¡æ¯å¸®åŠ©æ›´æ”¹ç”µå­é‚®ä»¶åœ°å€\r\n',0),(354947,9860,'sv','Kontakta Information hjÃ¤lp att Ã¤ndra e-postadress',0),(354948,9860,'it','Informazioni aiuto modifica indirizzo Email di contatto',0),(354949,9860,'tl','',0),(354950,9860,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3612;&#3641;&#3657;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3594;&#3656;&#3623;&#3618;&#3648;&#3627;&#3621;&#3639;&#3629;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3629;&#3637;&#3',0),(354951,9860,'hi','à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¤¦à¤¦ à¤¸à¥‡ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚',0),(354952,9860,'ms','Hubungi maklumat bantuan menukar alamat e-mel',0),(354953,9860,'ar','Ø§ØªØµÙ„ Ø¨Ù…Ø³Ø§Ø¹Ø¯Ø© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØºÙŠÙŠØ± Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(354954,9860,'fr','Contactez lâ€™Information changement dâ€™adresse E-mail',0),(354955,9860,'jp','ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã®å¤‰æ›´æƒ…å ±ã®ãƒ˜ãƒ«ãƒ—ã«ãŠå•ã„åˆã‚ã›ãã ã•ã„ã€‚',0),(354956,9860,'pt','Entre em contato com a ajuda de informaÃ§Ãµes alterar endereÃ§o de E-mail',0),(354957,9860,'ru','ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð¾Ð¹ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð”Ð»Ñ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Email ÐÐ´Ñ€ÐµÑÐ°',0),(354958,9860,'es','Ayuda de InformaciÃ³n de Contacto Cambiar la DirecciÃ³n de Email',0),(354959,9860,'de','Kontakt Informationen-Hilfe, e-Mail-Adresse Ã¤ndern',0),(354960,9860,'en','Contact Information Help Changing Email Address',0),(354961,9861,'is','',0),(354962,9861,'dr','Ø§Ø«Ø§Ø«Ù‡ ÙØ¹Ù„ÙŠ ',0),(354963,9861,'pr','Ø§Ø«Ø§Ø«Ù‡ ÙØ¹Ù„ÙŠ ',0),(354964,9861,'tr','GeÃ§erli randevu',0),(354965,9861,'pl','Aktualne terminy',0),(354966,9861,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ ÑÑ€ÐµÑ‰Ð¸',0),(354967,9861,'ur','Ø­Ø§Ù„ÛŒÛ ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª',0),(354968,9861,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(354969,9861,'vi','cÃ´ng viá»‡c hiá»‡n nay',0),(354970,9861,'af','Huidige Afsprake',0),(354971,9861,'ro','Curent numiri',0),(354972,9861,'et','Praegune kohtumised',0),(354973,9861,'si','Trenutni sestanki',0),(354974,9861,'ba','Saat ini janji',0),(354975,9861,'nl','Huidige mandaten',0),(354976,9861,'fi','NykyisiÃ¤ tapaamisia',0),(354977,9861,'no','Gjeldende avtaler',0),(354978,9861,'da','NuvÃ¦rende aftaler',0),(354979,9861,'ko','í˜„ìž¬ ì•½ì†',0),(354980,9861,'he','×”×ž×™× ×•×™×™× ×”× ×•×›×—×™',0),(354981,9861,'el','Î£Î·Î¼ÎµÏÎ¹Î½ÏŒ ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(354982,9861,'zh','å½“å‰çº¦ä¼š\r\n',0),(354983,9861,'sv','Aktuella mÃ¶ten',0),(354984,9861,'it','Appuntamenti attuali',0),(354985,9861,'tl','',0),(354986,9861,'th','&#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(354987,9861,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ',0),(354988,9861,'ms','Semasa pelantikan',0),(354989,9861,'ar','Ø§Ù„Ù…Ù†Ø§ØµØ¨ Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(354990,9861,'fr','Nominations actuelles',0),(354991,9861,'jp','ç¾åœ¨ã®äºˆå®š',0),(354992,9861,'pt','Compromissos atuais',0),(354993,9861,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(354994,9861,'es','Citas Actuales',0),(354995,9861,'de','Aktuelle Termine',0),(354996,9861,'en','Current Appointments',0),(354997,9862,'is','',0),(354998,9862,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø±Ø­ Ø­Ø³Ø§Ø¨ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ',0),(354999,9862,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø±Ø­ Ø­Ø³Ø§Ø¨ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ',0),(355000,9862,'tr','Yeni bir umudu hesabÄ± aÃ§Ä±klama oluÅŸturun.',0),(355001,9862,'pl','UtwÃ³rz nowy perspektywa opis konta',0),(355002,9862,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(355003,9862,'ur','Ù†ÛŒØ§ Ø§Ù…Ú©Ø§Ù† Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªÙØµÛŒÙ„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(355004,9862,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð¸Ð·Ð³Ð»ÐµÐ´Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð¾Ð¿Ð¸Ñ',0),(355005,9862,'vi','táº¡o toÃ n bá»™ tÃ i khoáº£n mÃ´ táº£ má»›i',0),(355006,9862,'af','Skep Nuwe Voornemende KliÃ«nt Rekeningbeskrywing',0),(355007,9862,'ro','CreaÅ£i noua perspectiva cont Descriere',0),(355008,9862,'et','Uus vÃ¤ljavaade konto kirjeldus.',0),(355009,9862,'si','Ustvarite nov raÄun opis moÅ¾nosti',0),(355010,9862,'ba','Buat Rekening prospek baru',0),(355011,9862,'nl','Nieuwe vooruitzicht accountbeschrijving maken',0),(355012,9862,'fi','Luo uusi prospektin tilin kuvaus',0),(355013,9862,'no','Opprette nye prospektet konto beskrivelse',0),(355014,9862,'da','Oprette nye udsigten kontobeskrivelse',0),(355015,9862,'ko','ìƒˆë¡œìš´ ì „ë§ ê³„ì • ì„¤ëª… ë§Œë“¤ê¸°',0),(355016,9862,'he','×œ×™×¦×•×¨ ×ª×™××•×¨ ×—×©×‘×•×Ÿ ×¤×¨×•×¡×¤×§×˜ ×—×“×©',0),(355017,9862,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î½Î­Î± Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ® Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(355018,9862,'zh','åˆ›å»ºæ–°çš„å‰æ™¯å¸æˆ·è¯´æ˜Ž\r\n',0),(355019,9862,'sv','Skapa nya utsikter kontobeskrivning',0),(355020,9862,'it','Creare nuova prospettiva Account descrizione',0),(355021,9862,'tl','',0),(355022,9862,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3650;&#3629;&#3585;&#3634;&#3626;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3610;&#3633;&#3597;&#3594;&#3637;',0),(355023,9862,'hi','à¤¨à¤ˆ à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤–à¤¾à¤¤à¤¾ à¤µà¤¿à¤µà¤°à¤£ à¤¬à¤¨à¤¾à¤à¤',0),(355024,9862,'ms','Mencipta keterangan akaun prospek baru',0),(355025,9862,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙˆØµÙ Ø­Ø³Ø§Ø¨ Ø¢ÙØ§Ù‚ Ø¬Ø¯ÙŠØ¯Ø©',0),(355026,9862,'fr','CrÃ©er nouvelle perspective compte Description',0),(355027,9862,'jp','æ–°ã—ã„è¦‹é€šã—ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®èª¬æ˜Žã‚’ä½œæˆã—ã¾ã™ã€‚',0),(355028,9862,'pt','Criar nova perspectiva conta descriÃ§Ã£o',0),(355029,9862,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ñƒ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(355030,9862,'es','Crear DescripciÃ³n de Cuenta de Nuevo Prospecto',0),(355031,9862,'de','Erstellen Sie neue Perspektive Kontobeschreibung',0),(355032,9862,'en','Create New Prospect Account Description',0),(355033,9863,'is','',0),(355034,9863,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ ',0),(355035,9863,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ ',0),(355036,9863,'tr','Umudu hesabÄ± oluÅŸturun',0),(355037,9863,'pl','UtwÃ³rz konto perspektywa',0),(355038,9863,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°Ñ‚Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(355039,9863,'ur','Ø§Ù…Ú©Ø§Ù† Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(355040,9863,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(355041,9863,'vi','táº¡o toÃ n bá»™ tÃ i khoáº£n',0),(355042,9863,'af','Skep Voornemende KliÃ«nt Rekening',0),(355043,9863,'ro','Creaza cont de perspectiva',0),(355044,9863,'et','Potentsiaalse kliendi konto loomine',0),(355045,9863,'si','Ustvarite raÄun moÅ¾nost',0),(355046,9863,'ba','Membuat Account prospek',0),(355047,9863,'nl','Vooruitzicht Account aanmaken',0),(355048,9863,'fi','Prospektitilin luominen',0),(355049,9863,'no','Opprette prospektet konto',0),(355050,9863,'da','Opret kundeemnet konto',0),(355051,9863,'ko','ì „ë§ ê³„ì • ë§Œë“¤ê¸°',0),(355052,9863,'he','×¦×•×¨ ×—×©×‘×•×Ÿ ×¤×¨×•×¡×¤×§×˜',0),(355053,9863,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ®',0),(355054,9863,'zh','åˆ›å»ºå¸æˆ·å‰æ™¯\r\n',0),(355055,9863,'sv','Skapa Prospect konto',0),(355056,9863,'it','Creare Account di Prospect',0),(355057,9863,'tl','',0),(355058,9863,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3650;&#3629;&#3585;&#3634;&#3626;',0),(355059,9863,'hi','à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(355060,9863,'ms','Cipta akaun Prospect',0),(355061,9863,'ar','Ù‚Ù… Ø¨Ø¥Ù†Ø´Ø§Ø¡ Ø­Ø³Ø§Ø¨ Ø§Ù„Ø§Ø­ØªÙ…Ø§Ù„',0),(355062,9863,'fr','CrÃ©er le compte de la perspective',0),(355063,9863,'jp','è¦‹é€šã—ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½œæˆã—ã¾ã™ã€‚',0),(355064,9863,'pt','Criar conta de perspectiva',0),(355065,9863,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ñƒ ÑÑ‡ÐµÑ‚Ð°',0),(355066,9863,'es','Crear Cuenta de Prospecto',0),(355067,9863,'de','Aussicht auf Konto erstellen',0),(355068,9863,'en','Create Prospect Account',0),(355069,9864,'is','',0),(355070,9864,'dr','(Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ ',0),(355071,9864,'pr','Ø­Ø³Ø§Ø¨ Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ú¯Ø±ÙŠ (Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯ ',0),(355072,9864,'tr','Umudu hesabÄ± baÅŸarÄ±yla oluÅŸturuldu',0),(355073,9864,'pl','Perspektywa konta zostaÅ‚ utworzony pomyÅ›lnie',0),(355074,9864,'bg','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°Ñ‚Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(355075,9864,'ur','Ø§Ù…Ú©Ø§Ù† Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(355076,9864,'sr','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°',0),(355077,9864,'vi','toÃ n bá»™ tÃ i khoáº£n Ä‘Ã£ Ä‘Æ°á»£c táº¡o thÃ nh cÃ´ng',0),(355078,9864,'af','Voornemende KliÃ«nte Rekening Suksesvol Geskep',0),(355079,9864,'ro','Perspectiva cont creat cu succes',0),(355080,9864,'et','Potentsiaalse kliendi konto loomine Ãµnnestus',0),(355081,9864,'si','MoÅ¾nost raÄun uspeÅ¡no ustvarjen',0),(355082,9864,'ba','Prospek Account dibuat dengan sukses',0),(355083,9864,'nl','Vooruitzicht Account succesvol aangemaakt',0),(355084,9864,'fi','Prospektitilin luonti onnistui',0),(355085,9864,'no','Prospektet konto opprettet',0),(355086,9864,'da','Udsigten konto oprettet',0),(355087,9864,'ko','ì „ë§ ê³„ì •ì„ ì„±ê³µì ìœ¼ë¡œ ë§Œë“ ',0),(355088,9864,'he','×¤×¨×•×¡×¤×§×˜ ×—×©×‘×•×Ÿ × ×•×¦×¨ ×‘×”×¦×œ×—×”',0),(355089,9864,'el','Î ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(355090,9864,'zh','å‰æ™¯å¸æˆ·åˆ›å»ºæˆåŠŸ\r\n',0),(355091,9864,'sv','Prospect konto skapats',0),(355092,9864,'it','Prospettiva Account creato con successo',0),(355093,9864,'tl','',0),(355094,9864,'th','&#3626;&#3619;&#3657;&#3634;&#3591;&#3610;&#3633;&#3597;&#3594;&#3637;&#3612;&#3641;&#3657;&#3607;&#3637;&#3656;&#3627;&#3623;&#3633;&#3591;&#3592;&#3632;&#3652;&#3604;&#3657;&#3648;&#3611;&#3655;&#3609;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3626;&#3',0),(355095,9864,'hi','à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤–à¤¾à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(355096,9864,'ms','Akaun prospek yang berjaya dicipta',0),(355097,9864,'ar','Ø­Ø³Ø§Ø¨ Ø§Ø­ØªÙ…Ø§Ù„ Ø¥Ù†Ø´Ø§Ø¡ Ø¨Ù†Ø¬Ø§Ø­',0),(355098,9864,'fr','Compte de la perspective crÃ©Ã©e avec succÃ¨s',0),(355099,9864,'jp','è¦‹é€šã—ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒæ­£å¸¸ã«ä½œæˆã•ã‚Œã¾ã—ãŸã€‚',0),(355100,9864,'pt','Perspectiva conta criada com sucesso',0),(355101,9864,'ru','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð° ÑÑ‡ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½',0),(355102,9864,'es','Cuenta de Cliente Potencial Creada Exitosamente',0),(355103,9864,'de','Aussicht auf Konto erfolgreich erstellt',0),(355104,9864,'en','Prospect Account Created Successfully',0),(355105,9865,'is','',0),(355106,9865,'dr','/ Ø§ØµÙ„Ø§Ø­  Ø§Ø«Ø§Ø«Ù‡ ',0),(355107,9865,'pr','Ø§ÙØ²ÙˆØ¯Ù†  / ÙˆÙŠØ±Ø§ÙŠØ´ Ø§Ø«Ø§Ø«Ù‡ ',0),(355108,9865,'tr','Randevular Ekle/DÃ¼zenle',0),(355109,9865,'pl','Dodawanie/Edycja terminÃ³w',0),(355110,9865,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑ€ÐµÑ‰Ð¸',0),(355111,9865,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ¹ÛŒÙ†Ø§Øª Ù…Ù„Ø§Ù‚Ø§Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(355112,9865,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(355113,9865,'vi','ThÃªm/sá»­a thÃ nh pháº§n',0),(355114,9865,'af','Afsprake Byvoeg/Redigeer ',0),(355115,9865,'ro','AdÄƒugare/Editare numiri',0),(355116,9865,'et','Lisa/muuda kohtumisi',0),(355117,9865,'si','Dodaj/Uredi sestanki',0),(355118,9865,'ba','Menambah/mengedit janji',0),(355119,9865,'nl','Afspraken toevoegen/bewerken',0),(355120,9865,'fi','LisÃ¤Ã¤ tai Muokkaa tapaamisia',0),(355121,9865,'no','Legge til eller redigere avtaler',0),(355122,9865,'da','TilfÃ¸j/redigÃ©r udnÃ¦vnelser',0),(355123,9865,'ko','ì•½ì† ì¶”ê°€/íŽ¸ì§‘',0),(355124,9865,'he','×”×•×¡×£/×¢×¨×•×š ×¤×’×™×©×•×ª',0),(355125,9865,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ…Î½Î±Î½Ï„Î®ÏƒÎµÎ¹Ï‚',0),(355126,9865,'zh','å¢žåŠ /ç¼–è¾‘çº¦ä¼š\r\n',0),(355127,9865,'sv','LÃ¤gga till eller redigera avtalade tider',0),(355128,9865,'it','Aggiungere/modificare gli appuntamenti',0),(355129,9865,'tl','',0),(355130,9865,'th','&#3648;&#3614;&#3636;&#3656;&#3617;/&#3649;&#3585;&#3657;&#3652;&#3586; &#3585;&#3634;&#3619;&#3609;&#3633;&#3604;&#3627;&#3617;&#3634;&#3618;',0),(355131,9865,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ /',0),(355132,9865,'ms','Tambah/Edit pelantikan',0),(355133,9865,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± Ù…ÙˆØ§Ø¹ÙŠØ¯',0),(355134,9865,'fr','Ajouter/Modifier Rendez-Vous',0),(355135,9865,'jp','äºˆå®šã®è¿½åŠ /ç·¨é›†',0),(355136,9865,'pt','Adicionar/editar compromissos',0),(355137,9865,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð’ÑÑ‚Ñ€ÐµÑ‡Ð¸',0),(355138,9865,'es','Agregar/Editar Citas',0),(355139,9865,'de','Termine hinzufÃ¼gen/bearbeiten',0),(355140,9865,'en','Add/Edit Appointments',0),(355141,9866,'is','',0),(355142,9866,'dr','(Ø¯Ø±Ø®ÙˆØ§Ø³Øª  ',0),(355143,9866,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯Ù‰(Ø¯Ø±Ø®ÙˆØ§Ø³Øª  ',0),(355144,9866,'tr','Uygulama',0),(355145,9866,'pl','Aplikacji',0),(355146,9866,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(355147,9866,'ur','Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù†',0),(355148,9866,'sr','ÐÐ¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(355149,9866,'vi','á»¨ng dá»¥ng',0),(355150,9866,'af','Aansoek',0),(355151,9866,'ro','Cerere',0),(355152,9866,'et','Taotlus',0),(355153,9866,'si','Uporaba',0),(355154,9866,'ba','Aplikasi',0),(355155,9866,'nl','Toepassing',0),(355156,9866,'fi','Sovellus',0),(355157,9866,'no','Programmet',0),(355158,9866,'da','AnsÃ¸gning',0),(355159,9866,'ko','ì‘ìš© í”„ë¡œê·¸ëž¨',0),(355160,9866,'he','×™×™×©×•×',0),(355161,9866,'el','Î•Ï†Î±ÏÎ¼Î¿Î³Î®',0),(355162,9866,'zh','åº”ç”¨\r\n',0),(355163,9866,'sv','AnsÃ¶kan',0),(355164,9866,'it','Applicazione',0),(355165,9866,'tl','',0),(355166,9866,'th','&#3585;&#3634;&#3619;&#3626;&#3617;&#3633;&#3588;&#3619;&#3591;&#3634;&#3609;',0),(355167,9866,'hi','à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤—',0),(355168,9866,'ms','Permohonan',0),(355169,9866,'ar','Ø§Ù„ØªØ·Ø¨ÙŠÙ‚',0),(355170,9866,'fr','Application',0),(355171,9866,'jp','ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(355172,9866,'pt','AplicaÃ§Ã£o',0),(355173,9866,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(355174,9866,'es','AplicaciÃ³n',0),(355175,9866,'de','Anwendung',0),(355176,9866,'en','Application',0),(355177,9867,'is','',0),(355178,9867,'dr','(ØªÙ‚Ø§Ø¶Ø§) Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(355179,9867,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ(ØªÙ‚Ø§Ø¶Ø§) Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(355180,9867,'tr','LÃ¼tfen bir uygulama iÃ§erir',0),(355181,9867,'pl','ProszÄ™ podaÄ‡ aplikacjÄ™',0),(355182,9867,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(355183,9867,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù† Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(355184,9867,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(355185,9867,'vi','vui lÃ²ng bao gá»“m 1 Ä‘Æ¡n',0),(355186,9867,'af','Sluit \'n Aansoek In',0),(355187,9867,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i o cerere',0),(355188,9867,'et','Palun lisa avaldus',0),(355189,9867,'si','Prosimo, da vkljuÄite aplikacija',0),(355190,9867,'ba','Harap sertakan aplikasi',0),(355191,9867,'nl','Voeg een toepassing',0),(355192,9867,'fi','LiitÃ¤ mukaan hakemus',0),(355193,9867,'no','Ta med et program',0),(355194,9867,'da','VedlÃ¦g en ansÃ¸gning',0),(355195,9867,'ko','ì‘ìš© í”„ë¡œê·¸ëž¨ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(355196,9867,'he','× × ×œ×›×œ×•×œ ×™×™×©×•×',0),(355197,9867,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î¼Î¹Î± ÎµÏ†Î±ÏÎ¼Î¿Î³Î®',0),(355198,9867,'zh','è¯·åˆ—å…¥ä¸€ä¸ªåº”ç”¨\r\n',0),(355199,9867,'sv','VÃ¤nligen inkludera ett program',0),(355200,9867,'it','Si prega di includere un\'applicazione',0),(355201,9867,'tl','',0),(355202,9867,'th','&#3650;&#3611;&#3619;&#3604;&#3619;&#3623;&#3617;&#3650;&#3611;&#3619;&#3649;&#3585;&#3619;&#3617;',0),(355203,9867,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤— à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(355204,9867,'ms','Sila sertakan permohonan',0),(355205,9867,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† ØªØ·Ø¨ÙŠÙ‚',0),(355206,9867,'fr','Veuillez inclure une demande',0),(355207,9867,'jp','ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(355208,9867,'pt','Por favor inclua um aplicativo',0),(355209,9867,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(355210,9867,'es','Por favor Incluye Una AplicaciÃ³n',0),(355211,9867,'de','Bitte fÃ¼gen Sie eine Anwendung',0),(355212,9867,'en','Please Include An Application',0),(355213,9868,'is','',0),(355214,9868,'dr','Ø­Ø°Ù Ø§Ø¬Ø§Ø±Ù‡ ',0),(355215,9868,'pr','Ø­Ø°Ù Ø§Ø¬Ø§Ø±Ù‡ ',0),(355216,9868,'tr','Delete lease',0),(355217,9868,'pl','DELETE Lease',0),(355218,9868,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(355219,9868,'ur','Ù„ÛŒØ² Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(355220,9868,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð·Ð°ÐºÑƒÐ¿',0),(355221,9868,'vi','XÃ³a há»£p Ä‘á»“ng cho thuÃª',0),(355222,9868,'af','Skrap Huurkontrakte',0),(355223,9868,'ro','ÅžtergeÅ£i leasing',0),(355224,9868,'et','Kustuta Ã¼Ã¼rilepingu',0),(355225,9868,'si','Izbrisati najema',0),(355226,9868,'ba','Menghapus sewa',0),(355227,9868,'nl','Lease verwijderen',0),(355228,9868,'fi','Delete Lease',0),(355229,9868,'no','Delete Lease',0),(355230,9868,'da','Slette Lease',0),(355231,9868,'ko','ìž„ëŒ€ë¥¼ ì‚­ì œ',0),(355232,9868,'he','×ž×—×™×§×ª ×”×—×›×™×¨×”',0),(355233,9868,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(355234,9868,'zh','åˆ é™¤ç§Ÿèµ\r\n',0),(355235,9868,'sv','Ta bort Lease',0),(355236,9868,'it','Eliminare il Lease',0),(355237,9868,'tl','',0),(355238,9868,'th','&#3621;&#3610;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(355239,9868,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤à¤',0),(355240,9868,'ms','Menghapuskan pajakan',0),(355241,9868,'ar','Ø­Ø°Ù Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(355242,9868,'fr','Supprimer le bail',0),(355243,9868,'jp','ãƒªãƒ¼ã‚¹ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(355244,9868,'pt','Excluir o contrato de arrendamento',0),(355245,9868,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹ Ð°Ð´Ñ€ÐµÑÐ°',0),(355246,9868,'es','Eliminar Arendamiento',0),(355247,9868,'de','LÃ¶schen der Lease',0),(355248,9868,'en','Delete Lease',0),(355249,9869,'is','',0),(355250,9869,'dr','Ø®Ø·Ø§  Ø¯Ø± Ø²Ù…Ø§Ù† Ø­Ø°Ù Ø§Ø¬Ø§Ø±Ù‡ ',0),(355251,9869,'pr','Ø®Ø·Ø§  Ø¯Ø± Ø²Ù…Ø§Ù† Ø­Ø°Ù Ø§Ø¬Ø§Ø±Ù‡ ',0),(355252,9869,'tr','Kira silinirken hata oluÅŸtu',0),(355253,9869,'pl','BÅ‚Ä…d podczas usuwania dzierÅ¼awy',0),(355254,9869,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(355255,9869,'ur','Ù„ÛŒØ² Ø­Ø°Ù Ú©Ø±Ù†Û’ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ',0),(355256,9869,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð·Ð°ÐºÑƒÐ¿',0),(355257,9869,'vi','lá»‘i khi xÃ³a há»£p Ä‘á»“ng thuÃª',0),(355258,9869,'af','\'n Fout het ontstaan terwyl Huurkontrak Geskrap is',0),(355259,9869,'ro','Eroare la ÅŸtergerea leasing',0),(355260,9869,'et','ÃœÃ¼rilepingu kustutamisel ilmnes tÃµrge',0),(355261,9869,'si','Napaka pri brisanju najema',0),(355262,9869,'ba','Kesalahan saat menghapus sewa',0),(355263,9869,'nl','Fout bij het verwijderen van Lease',0),(355264,9869,'fi','Virhe poistettaessa vuokrasopimuksen',0),(355265,9869,'no','Feil under sletting av leieavtalen',0),(355266,9869,'da','Fejl under sletning af lejemÃ¥let',0),(355267,9869,'ko','ìž„ëŒ€ë¥¼ ì‚­ì œ í•˜ëŠ” ë™ì•ˆ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤',0),(355268,9869,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×”×—×›×™×¨×”',0),(355269,9869,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(355270,9869,'zh','åˆ é™¤ç§Ÿèµæ—¶å‘ç”Ÿé”™è¯¯\r\n',0),(355271,9869,'sv','Ett fel uppstod nÃ¤r nÃ¤r lÃ¥n tas bort',0),(355272,9869,'it','Errore durante l\'eliminazione di Lease',0),(355273,9869,'tl','',0),(355274,9869,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3586;&#3603;&#3632;&#3585;&#3635;&#3621;&#3633;&#3591;&#3621;&#3610;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(355275,9869,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(355276,9869,'ms','Ralat Menghapuskan pajakan',0),(355277,9869,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(355278,9869,'fr','Erreur lors de la suppression de bail',0),(355279,9869,'jp','ãƒªãƒ¼ã‚¹ã®å‰Šé™¤ä¸­ã®ã‚¨ãƒ©ãƒ¼',0),(355280,9869,'pt','Erro ao excluir o contrato de arrendamento',0),(355281,9869,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(355282,9869,'es','Error Eliminando el Arrendamiento',0),(355283,9869,'de','Fehler beim LÃ¶schen der Lease',0),(355284,9869,'en','Error While Deleting Lease',0),(355285,9870,'is','',0),(355286,9870,'dr','Ø¢Ù¾Ù„ÙˆØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(355287,9870,'pr','Ø¢Ù¾Ù„ÙˆØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(355288,9870,'tr','Yeni kira upload',0),(355289,9870,'pl','WgraÄ‡ nowÄ… dzierÅ¼awÄ™',0),(355290,9870,'bg','ÐšÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð»Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð² Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(355291,9870,'ur','Ù†Ø¦ÛŒ Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(355292,9870,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð¸ Ð½Ð¾Ð²Ð¸ Ð·Ð°ÐºÑƒÐ¿',0),(355293,9870,'vi','Táº£i thuÃª má»›i',0),(355294,9870,'af','Nuwe Huurkontrak Oplaai',0),(355295,9870,'ro','ÃŽncÄƒrcaÅ£i noul contract de leasing',0),(355296,9870,'et','Laadida uut elujÃµudu',0),(355297,9870,'si','Upload nov najem',0),(355298,9870,'ba','Meng-upload sewa baru',0),(355299,9870,'nl','Uploaden van de nieuwe Lease',0),(355300,9870,'fi','Lataa uusi vuokrasopimus',0),(355301,9870,'no','Laste opp ny leieavtale',0),(355302,9870,'da','Uploade nye lejemÃ¥l',0),(355303,9870,'ko','ìƒˆë¡œìš´ ìž„ëŒ€ë¥¼ ì—…ë¡œë“œ',0),(355304,9870,'he','×œ×”×¢×œ×•×ª ×—×›×™×¨×” ×—×“×©×”',0),(355305,9870,'el','Î‘Î½ÎµÎ²Î¬ÏƒÎµÏ„Îµ Î½Î­Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·',0),(355306,9870,'zh','ä¸Šä¼ æ–°ç§Ÿçº¦\r\n',0),(355307,9870,'sv','Ladda upp nytt hyresavtal',0),(355308,9870,'it','Caricare il nuovo contratto di locazione',0),(355309,9870,'tl','',0),(355310,9870,'th','&#3629;&#3657;&#3614;&#3650;&#3627;&#3621;&#3604;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(355311,9870,'hi','à¤¨à¤¯à¤¾ à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(355312,9870,'ms','Muat naik nafas baru',0),(355313,9870,'ar','ØªØ­Ù…ÙŠÙ„ Ø¥ÙŠØ¬Ø§Ø± Ø¬Ø¯ÙŠØ¯',0),(355314,9870,'fr','TÃ©lÃ©charger le nouveau bail',0),(355315,9870,'jp','æ–°ã—ã„ãƒªãƒ¼ã‚¹ã‚’ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(355316,9870,'pt','Carregar a nova locaÃ§Ã£o',0),(355317,9870,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ',0),(355318,9870,'es','Subir un Nuevo Arrendamiento',0),(355319,9870,'de','Hochladen von neuem',0),(355320,9870,'en','Upload New Lease',0),(355321,9871,'is','',0),(355322,9871,'dr','Ú†Ø§Ù¾ Ø§Ø¬Ø§Ø±Ù‡ ',0),(355323,9871,'pr','Ú†Ø§Ù¾ Ø§Ø¬Ø§Ø±Ù‡ ',0),(355324,9871,'tr','YazdÄ±rma kira',0),(355325,9871,'pl','WydrukowaÄ‡ dzierÅ¼awy',0),(355326,9871,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(355327,9871,'ur','Ù„ÛŒØ² Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(355328,9871,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð·Ð°ÐºÑƒÐ¿',0),(355329,9871,'vi','thuÃª in',0),(355330,9871,'af','Druk Huurkontrak',0),(355331,9871,'ro','Imprimare leasing',0),(355332,9871,'et','Prindi Ã¼Ã¼rilepingu',0),(355333,9871,'si','Tiskanje, najem',0),(355334,9871,'ba','Mencetak sewa',0),(355335,9871,'nl','Afdrukken van Lease',0),(355336,9871,'fi','Tulosta vuokrasopimus',0),(355337,9871,'no','Skrive ut Lease',0),(355338,9871,'da','Trykte Lease',0),(355339,9871,'ko','ì¸ì‡„ ìž„ëŒ€',0),(355340,9871,'he','×œ×”×“×¤×™×¡ ××ª ×—×•×–×” ×”×©×›×™×¨×•×ª',0),(355341,9871,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(355342,9871,'zh','æ‰“å°ç§Ÿèµ\r\n',0),(355343,9871,'sv','Skriva ut Lease',0),(355344,9871,'it','Stampare il contratto di locazione',0),(355345,9871,'tl','',0),(355346,9871,'th','&#3614;&#3639;&#3617;&#3614;&#3660;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(355347,9871,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(355348,9871,'ms','Mencetak pajakan',0),(355349,9871,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(355350,9871,'fr','Imprimer le contrat de location',0),(355351,9871,'jp','ãƒªãƒ¼ã‚¹ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(355352,9871,'pt','Imprimir contrato',0),(355353,9871,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(355354,9871,'es','Imprime Contrato de Arrendamiento',0),(355355,9871,'de','Mietvertrag ausdrucken',0),(355356,9871,'en','Print Lease',0),(355357,9872,'is','',0),(355358,9872,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(355359,9872,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(355360,9872,'tr','DeÄŸiÅŸiklikleri Ä°zle PO',0),(355361,9872,'pl','Åšledzenie zmian PO',0),(355362,9872,'bg','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° PO Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(355363,9872,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù¾Ùˆ',0),(355364,9872,'sr','ÐŸÑ€Ð°Ñ›ÐµÑšÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð° ÐŸÐž',0),(355365,9872,'vi','Theo dÃµi thay Ä‘á»•i PO',0),(355366,9872,'af','Spoor AB Veranderinge',0),(355367,9872,'ro','UrmÄƒri schimbÄƒrile PO',0),(355368,9872,'et','Muutuste jÃ¤lituse PO',0),(355369,9872,'si','PO sledi spremembam',0),(355370,9872,'ba','Melacak perubahan PO',0),(355371,9872,'nl','Wijzigingen bijhouden PO',0),(355372,9872,'fi','Muutosten seuranta PO',0),(355373,9872,'no','Endringssporing PO',0),(355374,9872,'da','PO Ã¦ndringer',0),(355375,9872,'ko','ë³€ê²½ ë‚´ìš© ì¶”ì  í¬',0),(355376,9872,'he','×ž×¢×§×‘ ××—×¨ ×©×™× ×•×™×™× ×¤×•',0),(355377,9872,'el','Î Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ· Î±Î»Î»Î±Î³ÏŽÎ½ PO',0),(355378,9872,'zh','è·Ÿè¸ªè®¢å•çš„å˜åŒ–\r\n',0),(355379,9872,'sv','SpÃ¥ra PO Ã¤ndringar',0),(355380,9872,'it','Tenere traccia delle modifiche di PO',0),(355381,9872,'tl','',0),(355382,9872,'th','&#3605;&#3636;&#3604;&#3605;&#3634;&#3617;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3585;&#3634;&#3619;&#3592;&#3633;&#3604;&#3595;&#3639;&#3657;&#3629;',0),(355383,9872,'hi','PO à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤Ÿà¥à¤°à¥ˆà¤• à¤•à¤°à¤¨à¤¾',0),(355384,9872,'ms','Mengesan perubahan PO',0),(355385,9872,'ar','ØªØ¹Ù‚Ø¨ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø¨Ùˆ',0),(355386,9872,'fr','Suivre lâ€™Ã©volution de la PO',0),(355387,9872,'jp','PO å¤‰æ›´ã‚’è¿½è·¡ã—ã¾ã™ã€‚',0),(355388,9872,'pt','Controlar as alteraÃ§Ãµes de PO',0),(355389,9872,'ru','ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹ PO',0),(355390,9872,'es','Seguir la Pista de Cambios del OC',0),(355391,9872,'de','Ã„nderungen verfolgen PO',0),(355392,9872,'en','Track PO Changes',0),(355393,9873,'is','',0),(355394,9873,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø³Ø§Ø®Øª',0),(355395,9873,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø³Ø§Ø®Øª',0),(355396,9873,'tr','Ä°nÅŸaat iÅŸ eklemek',0),(355397,9873,'pl','Dodaj zadanie budowlane',0),(355398,9873,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(355399,9873,'ur','ØªØ¹Ù…ÛŒØ±Ø§ØªÛŒ Ú©Ø§Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(355400,9873,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð³Ñ€Ð°Ñ’ÐµÐ²Ð¸Ð½ÑÐºÐ¸ Ð¿Ð¾ÑÐ°Ð¾',0),(355401,9873,'vi','Viá»‡c xÃ¢y dá»±ng thÃªm',0),(355402,9873,'af','Konstruksie Werkstukke Byvoeg',0),(355403,9873,'ro','Adauga Job constructii',0),(355404,9873,'et','Ehituse tÃ¶Ã¶ lisamine',0),(355405,9873,'si','Dodaj gradbeni posel',0),(355406,9873,'ba','Tambahkan pekerjaan konstruksi',0),(355407,9873,'nl','Bouw Job toevoegen',0),(355408,9873,'fi','Rakentamisen tyÃ¶tÃ¤ lisÃ¤Ã¤',0),(355409,9873,'no','Anlegg Job legge',0),(355410,9873,'da','Byggeri Job tilfÃ¸je',0),(355411,9873,'ko','ê±´ì„¤ ìž‘ì—… ì¶”ê°€',0),(355412,9873,'he','×œ×”×•×¡×™×£ ×”×¢×‘×•×“×” ×‘×‘× ×™×™×”',0),(355413,9873,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®Ï‚',0),(355414,9873,'zh','å»ºç­‘å·¥ä½œæ–°å¢ž\r\n',0),(355415,9873,'sv','Konstruktion jobb LÃ¤gg',0),(355416,9873,'it','Lavoro di costruzione aggiungere',0),(355417,9873,'tl','',0),(355418,9873,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3634;&#3609;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(355419,9873,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¤¾à¤°à¥à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(355420,9873,'ms','Tambah kerja pembinaan',0),(355421,9873,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(355422,9873,'fr','Travail de construction ajouter',0),(355423,9873,'jp','å»ºè¨­ã®ä»•äº‹ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(355424,9873,'pt','Adicionar o trabalho de construÃ§Ã£o',0),(355425,9873,'ru','Ð¡Ñ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(355426,9873,'es','Agregar Trabajo de Construccion',0),(355427,9873,'de','Bau Job hinzufÃ¼gen',0),(355428,9873,'en','Construction Job Add',0),(355429,9874,'is','',0),(355430,9874,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(355431,9874,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(355432,9874,'tr','Ä°ÅŸ baÅŸarÄ±yla eklendi',0),(355433,9874,'pl','Zadanie dodane pomyÅ›lnie',0),(355434,9874,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(355435,9874,'ur','Ú©Ø§Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(355436,9874,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(355437,9874,'vi','Ä‘Ã£ thÃªm cÃ´ng viá»‡c thÃ nh cÃ´ng',0),(355438,9874,'af','Werkstuk Suksesvol Geskep',0),(355439,9874,'ro','Job adaugat cu succes',0),(355440,9874,'et','TÃ¶Ã¶ on edukalt',0),(355441,9874,'si','Delo uspeÅ¡no dodani',0),(355442,9874,'ba','Pekerjaan ditambahkan berhasil',0),(355443,9874,'nl','Baan toegevoegd',0),(355444,9874,'fi','TyÃ¶paikkojen lisÃ¤Ã¤minen onnistui',0),(355445,9874,'no','Jobb lagt',0),(355446,9874,'da','Job tilfÃ¸jet',0),(355447,9874,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ìž‘ì—…',0),(355448,9874,'he','×¢×‘×•×“×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(355449,9874,'el','Î ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Ï„Î· Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(355450,9874,'zh','ä½œä¸šæˆåŠŸæ·»åŠ \r\n',0),(355451,9874,'sv','Jobb som lagts',0),(355452,9874,'it','Lavoro aggiunto con successo',0),(355453,9874,'tl','',0),(355454,9874,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(355455,9874,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(355456,9874,'ms','Kerja yang berjaya menambah',0),(355457,9874,'ar','ÙˆØ¸ÙŠÙØ© Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(355458,9874,'fr','TÃ¢che ajoutÃ© avec succÃ¨s',0),(355459,9874,'jp','ã‚¸ãƒ§ãƒ–ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(355460,9874,'pt','Trabalho adicionado com sucesso',0),(355461,9874,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(355462,9874,'es','ColocaciÃ³n Agregada Exitosamente',0),(355463,9874,'de','Job erfolgreich hinzugefÃ¼gt',0),(355464,9874,'en','Job Added Successfully',0),(355465,9875,'is','',0),(355466,9875,'dr','Ø´ØºÙ„ Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯ ',0),(355467,9875,'pr','Ø´ØºÙ„ Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯ ',0),(355468,9875,'tr','Ä°ÅŸ ekledi',0),(355469,9875,'pl','Zadanie nie dodaÅ‚',0),(355470,9875,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¾',0),(355471,9875,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©ÛŒØ§',0),(355472,9875,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ñ‚',0),(355473,9875,'vi','cÃ´ng viá»‡c khÃ´ng Ä‘Æ°á»£c thÃªm',0),(355474,9875,'af','Kontrakwerk Nie Bygevoeg',0),(355475,9875,'ro','Job nu adÄƒugat',0),(355476,9875,'et','TÃ¶Ã¶ ei lisata',0),(355477,9875,'si','Delo ne doda',0),(355478,9875,'ba','Pekerjaan tidak ditambahkan',0),(355479,9875,'nl','Baan niet toegevoegd',0),(355480,9875,'fi','TyÃ¶ ei lisÃ¤tÃ¤',0),(355481,9875,'no','Jobben ikke lagt',0),(355482,9875,'da','Job ikke tilfÃ¸jet',0),(355483,9875,'ko','ìž‘ì—… ì¶”ê°€ ë˜ì§€',0),(355484,9875,'he','×”×¢×‘×•×“×” ×œ× ×”×•×¡×™×£',0),(355485,9875,'el','Î”Î¿Ï…Î»ÎµÎ¹Î¬ Î´ÎµÎ½ Ï€ÏÎ¿ÏƒÏ„Î¯Î¸ÎµÏ„Î±Î¹',0),(355486,9875,'zh','å·¥ä½œæœªæ·»åŠ \r\n',0),(355487,9875,'sv','Jobb som inte lagt till',0),(355488,9875,'it','Lavoro non aggiunto',0),(355489,9875,'tl','',0),(355490,9875,'th','&#3591;&#3634;&#3609;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(355491,9875,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(355492,9875,'ms','Pekerjaan yang tidak ditambah',0),(355493,9875,'ar','Ù„Ù… ØªØªÙ… Ø¥Ø¶Ø§ÙØ© Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(355494,9875,'fr','Travail ne pas ajoutÃ©',0),(355495,9875,'jp','ã‚¸ãƒ§ãƒ–ã¯è¿½åŠ ã•ã‚Œã¾ã›ã‚“ã€‚',0),(355496,9875,'pt','Trabalho nÃ£o adicionado',0),(355497,9875,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(355498,9875,'es','ColocaciÃ³n no Agregada',0),(355499,9875,'de','Auftrags nicht hinzugefÃ¼gt',0),(355500,9875,'en','Job Not Added',0),(355501,9876,'is','',0),(355502,9876,'dr','Ù…ØªØ¹Ù„Ù‚ Ø¨Ù‡ Ø´Ø±Ú©Øª ÙˆØ§Ø¨Ø³ØªÙ‡ Ù†ÙŠØ³Øª ',0),(355503,9876,'pr','Ù…ØªØ¹Ù„Ù‚ Ø¨Ù‡ Ø´Ø±Ú©Øª ÙˆØ§Ø¨Ø³ØªÙ‡ Ù†ÙŠØ³Øª ',0),(355504,9876,'tr','Ä°liÅŸkili ÅŸirketine ait deÄŸil',0),(355505,9876,'pl','Nie sÄ… wÅ‚asnoÅ›ciÄ… spÃ³Å‚ki powiÄ…zanej',0),(355506,9876,'bg','ÐÐµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð½Ð° ÑÐ²ÑŠÑ€Ð·Ð°Ð½Ð¾ Ð´Ñ€ÑƒÐ¶ÐµÑÑ‚Ð²Ð¾',0),(355507,9876,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ÙˆØ§Ø¨Ø³ØªÛ Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ù†ÛÛŒÚº',0),(355508,9876,'sr','ÐÐ¸Ñ˜Ðµ Ñƒ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ñƒ Ð¿Ð¾Ð²ÐµÐ·Ð°Ð½Ð¾Ð³ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð°',0),(355509,9876,'vi','khÃ´ng lÃ m chá»§ bá»Ÿi cÃ´ng ty Ä‘Ã£ há»£p nháº¥t',0),(355510,9876,'af','Nie Besit deur Geassosieerde Onderneming',0),(355511,9876,'ro','Nu sunt deÅ£inute de societate asociatÄƒ',0),(355512,9876,'et','Ei kuulu sidusettevÃµte',0),(355513,9876,'si','Niso v lasti povezane druÅ¾be',0),(355514,9876,'ba','Tidak dimiliki oleh perusahaan terkait',0),(355515,9876,'nl','Geen eigendom is van de verbonden onderneming',0),(355516,9876,'fi','Ei omista osakkuusyhtiÃ¶',0),(355517,9876,'no','Ikke eies av tilknyttede selskap',0),(355518,9876,'da','Ikke ejes af associeret selskab',0),(355519,9876,'ko','ê´€ë ¨ëœ íšŒì‚¬ì— ì˜í•´ ì†Œìœ  í•˜ì§€ ì•Šì€',0),(355520,9876,'he','×‘×‘×¢×œ×•×ª×• ×—×‘×¨×” ×§×©×•×¨×”',0),(355521,9876,'el','Î”ÎµÎ½ Î±Î½Î®ÎºÎµÎ¹ ÏƒÎµ ÏƒÏ…Î½Î´ÎµÎ´ÎµÎ¼Î­Î½Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(355522,9876,'zh','ä¸å±žäºŽå…³è”å…¬å¸\r\n',0),(355523,9876,'sv','Inte Ã¤gs av intressebolag',0),(355524,9876,'it','Non di proprietÃ  di societÃ  associata',0),(355525,9876,'tl','',0),(355526,9876,'th','&#3652;&#3617;&#3656;&#3648;&#3611;&#3655;&#3609;&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3651;&#3609;&#3648;&#3588;&#3619;&#3639;&#3629;',0),(355527,9876,'hi','à¤¸à¤‚à¤¬à¤‚à¤§à¤¿à¤¤ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚',0),(355528,9876,'ms','Tidak dimiliki oleh syarikat bersekutu',0),(355529,9876,'ar','Ù„ÙŠØ³Øª Ù…Ù„ÙƒØ§ Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ù…Ù‚ØªØ±Ù†Ø©',0),(355530,9876,'fr','Nâ€™appartenant pas Ã  la sociÃ©tÃ© affiliÃ©e',0),(355531,9876,'jp','é–¢é€£ä¼šç¤¾ãŒæ‰€æœ‰ã—ã¦ã„ã¾ã›ã‚“ã€‚',0),(355532,9876,'pt','NÃ£o pertence a empresa associada',0),(355533,9876,'ru','ÐÐµ Ð¿Ñ€Ð¸Ð½Ð°Ð´Ð»ÐµÐ¶Ð°Ñ‰Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(355534,9876,'es','No se Pertenece a Una Empresa Asociada',0),(355535,9876,'de','Nicht im Besitz von assoziierten Unternehmen',0),(355536,9876,'en','Not Owned by Associated Company',0),(355537,9877,'is','',0),(355538,9877,'dr','ØµØ§Ø­Ø¨ Ø´Ø±ÙƒØª ',0),(355539,9877,'pr','ØµØ§Ø­Ø¨ Ø´Ø±ÙƒØª ',0),(355540,9877,'tr','Firma sahipleri',0),(355541,9877,'pl','WÅ‚aÅ›ciciel firmy',0),(355542,9877,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸Ðº Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð°',0),(355543,9877,'ur','Ù…Ø§Ù„Ú© Ú©Ù…Ù¾Ù†ÛŒ',0),(355544,9877,'sr','Ð’Ð»Ð°ÑÐ½Ð¸Ðº ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(355545,9877,'vi','lÃ m chá»§ cÃ´ng ty',0),(355546,9877,'af','Eienaar Onderneming',0),(355547,9877,'ro','Proprietarul companiei',0),(355548,9877,'et','Omanikfirma',0),(355549,9877,'si','Lastnik podjetja',0),(355550,9877,'ba','Pemilik perusahaan',0),(355551,9877,'nl','Eigenaar bedrijf',0),(355552,9877,'fi','Omistaja yhtiÃ¶',0),(355553,9877,'no','Eier selskapet',0),(355554,9877,'da','Ejer selskabet',0),(355555,9877,'ko','ì†Œìœ ìž íšŒì‚¬',0),(355556,9877,'he','×‘×¢×œ ×”×—×‘×¨×”',0),(355557,9877,'el','Î™Î´Î¹Î¿ÎºÏ„Î®Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(355558,9877,'zh','æ‹¥æœ‰è€…å…¬å¸\r\n',0),(355559,9877,'sv','Ã„gare fÃ¶retaget',0),(355560,9877,'it','SocietÃ  proprietaria',0),(355561,9877,'tl','',0),(355562,9877,'th','&#3648;&#3592;&#3657;&#3634;&#3586;&#3629;&#3591;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;',0),(355563,9877,'hi','à¤®à¤¾à¤²à¤¿à¤• à¤•à¤‚à¤ªà¤¨à¥€',0),(355564,9877,'ms','Pemilik syarikat',0),(355565,9877,'ar','Ù…Ø§Ù„Ùƒ Ø§Ù„Ø´Ø±ÙƒØ©',0),(355566,9877,'fr','SociÃ©tÃ© propriÃ©taire',0),(355567,9877,'jp','ã‚ªãƒ¼ãƒŠãƒ¼ä¼šç¤¾',0),(355568,9877,'pt','ProprietÃ¡rio da empresa',0),(355569,9877,'ru','Ð’Ð»Ð°Ð´ÐµÐ»ÐµÑ† ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(355570,9877,'es','Empresa Particular',0),(355571,9877,'de','EigentÃ¼mer-Firma',0),(355572,9877,'en','Owner Company',0),(355573,9878,'is','',0),(355574,9878,'dr','Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(355575,9878,'pr','Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(355576,9878,'tr','Ä°ÅŸ baÅŸarÄ±yla silindi',0),(355577,9878,'pl','Zadanie usuniÄ™te pomyÅ›lnie',0),(355578,9878,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(355579,9878,'ur','Ú©Ø§Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒØ§',0),(355580,9878,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(355581,9878,'vi','Ä‘Ã£ xÃ³a cÃ´ng viá»‡c thÃ nh cÃ´ng',0),(355582,9878,'af','Werkstuk Suksesvol Geskrap',0),(355583,9878,'ro','Job eliminat cu succes',0),(355584,9878,'et','TÃ¶Ã¶ edukalt kustutatud',0),(355585,9878,'si','Delo uspeÅ¡no izbrisana',0),(355586,9878,'ba','Pekerjaan dihapus berhasil',0),(355587,9878,'nl','Werk succesvol verwijderd',0),(355588,9878,'fi','TyÃ¶ poistettu',0),(355589,9878,'no','Jobb slettet',0),(355590,9878,'da','Job slettet',0),(355591,9878,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ìž‘ì—…',0),(355592,9878,'he','×”×¢×‘×•×“×” × ×ž×—×§×” ×‘×”×¦×œ×—×”',0),(355593,9878,'el','Î‘Ï€Î±ÏƒÏ‡ÏŒÎ»Î·ÏƒÎ·Ï‚, Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(355594,9878,'zh','å·¥ä½œæˆåŠŸåˆ é™¤\r\n',0),(355595,9878,'sv','Jobb som raderades',0),(355596,9878,'it','Lavoro eliminato con successo',0),(355597,9878,'tl','',0),(355598,9878,'th','&#3621;&#3610;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(355599,9878,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾',0),(355600,9878,'ms','Pekerjaan yang dihapuskan dengan jayanya',0),(355601,9878,'ar','ÙˆØ¸ÙŠÙØ© Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(355602,9878,'fr','Poste supprimÃ© avec succÃ¨s',0),(355603,9878,'jp','ã‚¸ãƒ§ãƒ–ã¯å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(355604,9878,'pt','Trabalho excluÃ­do com sucesso',0),(355605,9878,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾',0),(355606,9878,'es','ColocaciÃ³n Eliminada Exitosamente',0),(355607,9878,'de','Auftrag wurde erfolgreich gelÃ¶scht',0),(355608,9878,'en','Job Deleted Successfully',0),(355609,9879,'is','',0),(355610,9879,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´ØºÙ„ ',0),(355611,9879,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´ØºÙ„ ',0),(355612,9879,'tr','Ä°ÅŸ gÃ¼ncelleme',0),(355613,9879,'pl','Zadanie aktualizacji',0),(355614,9879,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(355615,9879,'ur','Ú©Ø§Ù… ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(355616,9879,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(355617,9879,'vi','cáº­p nháº­t viá»‡c',0),(355618,9879,'af','Projek Opdateer',0),(355619,9879,'ro','Job Update',0),(355620,9879,'et','TÃ¶Ã¶ vÃ¤rskendus',0),(355621,9879,'si','Posodobitev delovnih',0),(355622,9879,'ba','Pekerjaan Update',0),(355623,9879,'nl','Baan Update',0),(355624,9879,'fi','PÃ¤ivitetty',0),(355625,9879,'no','Oppdatering',0),(355626,9879,'da','Job opdatering',0),(355627,9879,'ko','ìž‘ì—… ì—…ë°ì´íŠ¸',0),(355628,9879,'he','×¢×“×›×•×Ÿ ×¢×‘×•×“×”',0),(355629,9879,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¸Î­ÏƒÎµÏ‰Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(355630,9879,'zh','æ›´æ–°å·¥ä½œ\r\n',0),(355631,9879,'sv','Jobb uppdatering',0),(355632,9879,'it','Lavoro aggiornamento',0),(355633,9879,'tl','',0),(355634,9879,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3591;&#3634;&#3609;',0),(355635,9879,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(355636,9879,'ms','Kerja Kemaskini',0),(355637,9879,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ù‡Ù…Ø©',0),(355638,9879,'fr','Mise Ã  jour de travail',0),(355639,9879,'jp','ã‚¸ãƒ§ãƒ–ã®æ›´æ–°',0),(355640,9879,'pt','AtualizaÃ§Ã£o do trabalho',0),(355641,9879,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(355642,9879,'es','ActualizaciÃ³n de ColocaciÃ³n',0),(355643,9879,'de','Job-Update',0),(355644,9879,'en','Job Update',0),(355645,9880,'is','',0),(355646,9880,'dr','ØªØºÙŠÙŠØ± Ø¯Ø± Ø®ÙˆØ§Ø³Øª',0),(355647,9880,'pr','ØªØºÙŠÙŠØ± Ø¯Ø± Ø®ÙˆØ§Ø³Øª',0),(355648,9880,'tr','DeÄŸiÅŸiklik isteÄŸi',0),(355649,9880,'pl','Å»Ä…danie zmiany',0),(355650,9880,'bg','Ð˜ÑÐºÐ°Ð½ÐµÑ‚Ð¾ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(355651,9880,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(355652,9880,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñƒ',0),(355653,9880,'vi','Thay Ä‘Ã´3i yÃªu cáº§u',0),(355654,9880,'af','Verander Versoek',0),(355655,9880,'ro','Cerere de schimbare',0),(355656,9880,'et','Muutmise taotlus',0),(355657,9880,'si','Zahteva po spremembi',0),(355658,9880,'ba','Perubahan permintaan',0),(355659,9880,'nl','Change Request',0),(355660,9880,'fi','MuutospyyntÃ¶',0),(355661,9880,'no','EndringsforespÃ¸rsel',0),(355662,9880,'da','Anmodning om Ã¦ndring',0),(355663,9880,'ko','ë³€ê²½ ìš”ì²­',0),(355664,9880,'he','×‘×§×©×ª ×©×™× ×•×™',0),(355665,9880,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î±Î»Î»Î±Î³Î®Ï‚',0),(355666,9880,'zh','å˜æ›´è¯·æ±‚\r\n',0),(355667,9880,'sv','Ã„ndringsbegÃ¤ran',0),(355668,9880,'it','Richiesta di modifica',0),(355669,9880,'tl','',0),(355670,9880,'th','&#3588;&#3635;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;',0),(355671,9880,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(355672,9880,'ms','Perubahan permintaan',0),(355673,9880,'ar','Ø·Ù„Ø¨ ØªØºÙŠÙŠØ±',0),(355674,9880,'fr','Demande de modification',0),(355675,9880,'jp','å¤‰æ›´è¦æ±‚',0),(355676,9880,'pt','SolicitaÃ§Ã£o de alteraÃ§Ã£o',0),(355677,9880,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(355678,9880,'es','Cambia la Solicitud',0),(355679,9880,'de','Change Request',0),(355680,9880,'en','Change Request',0),(355681,9881,'is','',0),(355682,9881,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø´ØºÙ„ ',0),(355683,9881,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø´ØºÙ„ ',0),(355684,9881,'tr','Ä°ÅŸ kimliÄŸi',0),(355685,9881,'pl','Identyfikator zadania',0),(355686,9881,'bg','Ð˜Ð” Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(355687,9881,'ur','Ø¬Ø§Ø¨ Ø´Ù†Ø§Ø®Øª',0),(355688,9881,'sr','Ð˜Ð” Ð¿Ð¾ÑÐ»Ð°',0),(355689,9881,'vi','ID cÃ´ng viá»‡c',0),(355690,9881,'af','Kontrakwerk ID',0),(355691,9881,'ro','Job ID',0),(355692,9881,'et','TÃ¶Ã¶ ID',0),(355693,9881,'si','ID posla',0),(355694,9881,'ba','Pekerjaan ID',0),(355695,9881,'nl','Vacature-ID',0),(355696,9881,'fi','TyÃ¶n tunnus',0),(355697,9881,'no','Jobb-ID',0),(355698,9881,'da','Job-ID',0),(355699,9881,'ko','ìž‘ì—… ID',0),(355700,9881,'he','×ž×–×”×” ×ž×©×™×ž×”',0),(355701,9881,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(355702,9881,'zh','èŒä½ç¼–å·\r\n',0),(355703,9881,'sv','Jobb-ID',0),(355704,9881,'it','ID del processo',0),(355705,9881,'tl','',0),(355706,9881,'th','&#3619;&#3627;&#3633;&#3626;&#3591;&#3634;&#3609;',0),(355707,9881,'hi','à¤•à¤¾à¤°à¥à¤¯ ID',0),(355708,9881,'ms','ID kerja',0),(355709,9881,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ù‡Ù…Ø©',0),(355710,9881,'fr','ID de travail',0),(355711,9881,'jp','ã‚¸ãƒ§ãƒ– ID',0),(355712,9881,'pt','ID do trabalho',0),(355713,9881,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(355714,9881,'es','ID de ColocaciÃ³n',0),(355715,9881,'de','Auftrags-ID',0),(355716,9881,'en','Job ID',0),(355717,9882,'is','',0),(355718,9882,'dr','Ù†Ù…Ø§ÙŠØ´ ØªÙ…Ø§Ù… ØªØºÙŠÙŠØ± Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(355719,9882,'pr','Ù†Ù…Ø§ÙŠØ´ ØªÙ…Ø§Ù… ØªØºÙŠÙŠØ± Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(355720,9882,'tr','TÃ¼m sÄ±ra deÄŸiÅŸtirme iÅŸlemi sayÄ±sÄ± HaritayÄ±',0),(355721,9882,'pl','PokaÅ¼ wszystkie polecenia zmian',0),(355722,9882,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(355723,9882,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Û’ ØªÙ…Ø§Ù… Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(355724,9882,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ²Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñƒ',0),(355725,9882,'vi','Hiá»ƒn thá»‹ táº¥t cáº£ thay Ä‘á»•i Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(355726,9882,'af','Wys Alle Veranderde Bestellings',0),(355727,9882,'ro','AratÄƒ toate comenzile de schimbare',0),(355728,9882,'et','NÃ¤ita kÃµik muutus tellimused',0),(355729,9882,'si','PrikaÅ¾i vse spremembe naroÄila',0),(355730,9882,'ba','Tampilkan semua perubahan pesanan',0),(355731,9882,'nl','Toon alle wijzigingsopdrachten',0),(355732,9882,'fi','NÃ¤ytÃ¤ kaikki muutos tilaukset',0),(355733,9882,'no','Vis alle bestillinger',0),(355734,9882,'da','Vis alle Ã¦ndringer ordrer',0),(355735,9882,'ko','ëª¨ë“  ì£¼ë¬¸ ë³€ê²½ í‘œì‹œ',0),(355736,9882,'he','×”×¦×’ ××ª ×›×œ ×”×–×ž× ×•×ª ×©×™× ×•×™',0),(355737,9882,'el','Î”ÎµÎ¯Ï„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î³Î¹Î± Î±Î»Î»Î±Î³Î®',0),(355738,9882,'zh','æ˜¾ç¤ºæ‰€æœ‰æ›´æ”¹å•\r\n',0),(355739,9882,'sv','Visa alla Ã¤ndringsorder',0),(355740,9882,'it','Visualizza tutti gli ordini di modifica',0),(355741,9882,'tl','',0),(355742,9882,'th','&#3649;&#3626;&#3604;&#3591;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3588;&#3635;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3607;&#3633;&#3656;&#3591;&#3627;&#3617;&#3604;',0),(355743,9882,'hi','à¤¸à¤­à¥€ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(355744,9882,'ms','Menunjukkan semua pesanan perubahan',0),(355745,9882,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø¬Ù…ÙŠØ¹ Ø£ÙˆØ§Ù…Ø± Ø§Ù„ØªØºÙŠÙŠØ±',0),(355746,9882,'fr','Montrer tous les ordres de modification',0),(355747,9882,'jp','ã™ã¹ã¦ã®å¤‰æ›´å‘½ä»¤ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(355748,9882,'pt','Mostrar todos os pedidos de alteraÃ§Ã£o',0),(355749,9882,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð²ÑÐµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(355750,9882,'es','Muestra Todos los Ordenes de Cambio',0),(355751,9882,'de','Zeige alle Ã„nderungsauftrÃ¤ge',0),(355752,9882,'en','Show All Change Orders',0),(355753,9883,'is','',0),(355754,9883,'dr','ÙÙ‚Ø· Ø¨ÙˆØ¯Ø¬Ù‡',0),(355755,9883,'pr','ÙÙ‚Ø· Ø¨ÙˆØ¯Ø¬Ù‡',0),(355756,9883,'tr','Sadece bÃ¼tÃ§e',0),(355757,9883,'pl','BudÅ¼etu tylko',0),(355758,9883,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ ÑÐ°Ð¼Ð¾',0),(355759,9883,'ur','ØµØ±Ù Ø¨Ø¬Ù¹',0),(355760,9883,'sr','Ð¡Ð°Ð¼Ð¾ Ð±ÑƒÑŸÐµÑ‚',0),(355761,9883,'vi','Chá»‰ dÃ¹ng cho NgÃ¢n SÃ¡ch',0),(355762,9883,'af','Begroting Alleenlik',0),(355763,9883,'ro','Buget numai',0),(355764,9883,'et','Ainult eelarve',0),(355765,9883,'si','ProraÄun le',0),(355766,9883,'ba','Anggaran hanya',0),(355767,9883,'nl','Begroting alleen',0),(355768,9883,'fi','Budjetti',0),(355769,9883,'no','Budsjettet bare',0),(355770,9883,'da','Budgettet kun',0),(355771,9883,'ko','ì˜ˆì‚°ë§Œ',0),(355772,9883,'he','×ª×§×¦×™×‘ ×¨×§',0),(355773,9883,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î¼ÏŒÎ½Î¿',0),(355774,9883,'zh','é¢„ç®—æ¡ˆåª\r\n',0),(355775,9883,'sv','Budget endast',0),(355776,9883,'it','Bilancio solo',0),(355777,9883,'tl','',0),(355778,9883,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3648;&#3593;&#3614;&#3634;&#3632;',0),(355779,9883,'hi','à¤¬à¤œà¤Ÿ à¤•à¥‡à¤µà¤²',0),(355780,9883,'ms','Bajet hanya',0),(355781,9883,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© ÙÙ‚Ø·',0),(355782,9883,'fr','Budget uniquement',0),(355783,9883,'jp','äºˆç®—ã ã‘',0),(355784,9883,'pt','OrÃ§amento somente',0),(355785,9883,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(355786,9883,'es','Presupuesto Solo',0),(355787,9883,'de','Budget nur',0),(355788,9883,'en','Budget Only',0),(355789,9884,'is','',0),(355790,9884,'dr','ØªØºÙŠÙŠØ± Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ù†ØªØ¸Ø± ØªØ§ÙŠÙŠØ¯ ',0),(355791,9884,'pr','ØªØºÙŠÙŠØ± Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ù†ØªØ¸Ø± ØªØ§ÙŠÙŠØ¯ ',0),(355792,9884,'tr','Onay bekleyen deÄŸiÅŸiklik isteÄŸi',0),(355793,9884,'pl','Å»Ä…danie zmiany oczekujÄ…ce na zatwierdzenie',0),(355794,9884,'bg','Ð˜ÑÐºÐ°Ð½ÐµÑ‚Ð¾ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°, Ñ‡Ð°ÐºÐ°Ñ‰ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(355795,9884,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ø±',0),(355796,9884,'sr','ÐšÐ¾Ñ˜Ð¸ Ñ‡ÐµÐºÐ° Ð½Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñƒ',0),(355797,9884,'vi','Äang chá» thay Ä‘á»•i phÃª duyá»‡t',0),(355798,9884,'af','Verander Afwagtende Versoek Goedkeuring',0),(355799,9884,'ro','Cerere de schimbare aÅŸteaptÄƒ aprobarea',0),(355800,9884,'et','Muutmise taotlus kinnitamise ootel',0),(355801,9884,'si','Spremeniti zahtevek, ki Äaka na odobritev',0),(355802,9884,'ba','Permintaan perubahan menunggu persetujuan',0),(355803,9884,'nl','Change-verzoek in afwachting van goedkeuring',0),(355804,9884,'fi','MuutospyyntÃ¶ odottaa hyvÃ¤ksyntÃ¤Ã¤',0),(355805,9884,'no','Endre forespÃ¸rselen venter pÃ¥ godkjenning',0),(355806,9884,'da','Rediger anmodningen afventer godkendelse',0),(355807,9884,'ko','ìŠ¹ì¸ì„ ê¸°ë‹¤ë¦¬ëŠ” ë³€ê²½ ìš”ì²­',0),(355808,9884,'he','×‘×§×©×ª ×©×™× ×•×™ ×ž×ž×ª×™×Ÿ ×œ××™×©×•×¨',0),(355809,9884,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î±Î»Î»Î±Î³Î®Ï‚ Î±Î½Î±Î¼Î­Î½ÎµÎ¹ Î­Î³ÎºÏÎ¹ÏƒÎ·',0),(355810,9884,'zh','å˜æ›´ç”³è¯·æ­£åœ¨ç­‰å¾…æ‰¹å‡†\r\n',0),(355811,9884,'sv','Ã„ndra begÃ¤ran vÃ¤ntar pÃ¥ godkÃ¤nnande',0),(355812,9884,'it','Richiesta di modifica in attesa di approvazione',0),(355813,9884,'tl','',0),(355814,9884,'th','&#3588;&#3635;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3619;&#3629;&#3629;&#3609;&#3641;&#3617;&#3633;&#3605;&#3636;',0),(355815,9884,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤•à¥€ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤•à¤¾ à¤‡à¤‚à¤¤à¤œà¤¾à¤°',0),(355816,9884,'ms','Perubahan permintaan menunggu kelulusan',0),(355817,9884,'ar','ÙÙŠ Ø§Ù†ØªØ¸Ø§Ø± Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø·Ù„Ø¨ ØªØºÙŠÙŠØ±',0),(355818,9884,'fr','Demande de modification en attente dâ€™approbation',0),(355819,9884,'jp','å¤‰æ›´è¦æ±‚ã®æ‰¿èªå¾…ã¡',0),(355820,9884,'pt','Aguardando aprovaÃ§Ã£o de solicitaÃ§Ã£o de alteraÃ§Ã£o',0),(355821,9884,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ, Ð¾Ð¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ñ… ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(355822,9884,'es','Cambia la Solicitud que se Espera AprobaciÃ³n',0),(355823,9884,'de','Antrag zur Genehmigung',0),(355824,9884,'en','Change Request Awaiting Approval',0),(355825,9885,'is','',0),(355826,9885,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø³Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(355827,9885,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø³Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(355828,9885,'tr','Yeni inÅŸaat iÅŸ eklemek',0),(355829,9885,'pl','DodaÄ‡ nowe zadanie budowlane',0),(355830,9885,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(355831,9885,'ur','Ù†Ø¦ÛŒ ØªØ¹Ù…ÛŒØ± Ø¬Ø§Ø¨ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(355832,9885,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾ Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÐµ',0),(355833,9885,'vi','ThÃªm cÃ´ng viá»‡c xÃ¢y dá»±ng má»›i',0),(355834,9885,'af','Nuwe Konstruksie Werkstuk Byvoeg',0),(355835,9885,'ro','Adauga nou Job constructii',0),(355836,9885,'et','Lisa uus ehitus tÃ¶Ã¶de',0),(355837,9885,'si','Dodaj novo zaposlitev gradbeniÅ¡tvo',0),(355838,9885,'ba','Menambahkan baru pekerjaan konstruksi',0),(355839,9885,'nl','Toevoegen van nieuwe bouw-baan',0),(355840,9885,'fi','LisÃ¤Ã¤ uusi rakentaminen tyÃ¶',0),(355841,9885,'no','Legg til ny bygging jobb',0),(355842,9885,'da','TilfÃ¸je nye byggeri Job',0),(355843,9885,'ko','ìƒˆë¡œìš´ ê±´ì„¤ ìž‘ì—… ì¶”ê°€',0),(355844,9885,'he','×”×•×¡×£ ×¢×‘×•×“×ª ×‘× ×™×” ×—×“×©×”',0),(355845,9885,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î¸Î­ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®Ï‚',0),(355846,9885,'zh','æ–°å¢žæ–°å»ºè®¾å·¥ä½œ\r\n',0),(355847,9885,'sv','LÃ¤gg till nytt byggande jobb',0),(355848,9885,'it','Aggiungi nuovo lavoro di costruzione',0),(355849,9885,'tl','',0),(355850,9885,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3634;&#3609;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(355851,9885,'hi','à¤¨à¤ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¤¾à¤® à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(355852,9885,'ms','Tambah kerja pembinaan baru',0),(355853,9885,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ¸ÙŠÙØ© Ø¬Ø¯ÙŠØ¯Ø© ÙÙŠ Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(355854,9885,'fr','Ajouter Nouveau Tache de Construction',0),(355855,9885,'jp','æ–°ã—ã„å·¥äº‹ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(355856,9885,'pt','Adicionar novo trabalho de construÃ§Ã£o',0),(355857,9885,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ð¾Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(355858,9885,'es','Agregar Nuevo Trabajo de ConstrucciÃ³n',0),(355859,9885,'de','Neue Bau Job hinzufÃ¼gen',0),(355860,9885,'en','Add New Construction Job',0),(355861,9886,'is','',0),(355862,9886,'dr','Ø´ØºÙ„  Ø³Ø§Ø®Øª',0),(355863,9886,'pr','Ø´ØºÙ„  Ø³Ø§Ø®Øª',0),(355864,9886,'tr','Ä°nÅŸaat iÅŸleri',0),(355865,9886,'pl','Prac budowlanych',0),(355866,9886,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð² ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(355867,9886,'ur','ØªØ¹Ù…ÛŒØ±Ø§ØªÛŒ Ú©Ø§Ù…',0),(355868,9886,'sr','Ð“Ñ€Ð°Ñ’ÐµÐ²Ð¸Ð½ÑÐºÐ¸Ñ… Ð¿Ð¾ÑÐ»Ð¾Ð²Ð°',0),(355869,9886,'vi','Viá»‡c xÃ¢y dá»±ng',0),(355870,9886,'af','Konstruksie Werkstukke',0),(355871,9886,'ro','Joburi Ã®n construcÅ£ii',0),(355872,9886,'et','Ehitus TÃ¶Ã¶pakkumised',0),(355873,9886,'si','Zaposlitve v gradbeniÅ¡tvu',0),(355874,9886,'ba','Pekerjaan konstruksi',0),(355875,9886,'nl','Bouw vacatures',0),(355876,9886,'fi','Rakentaminen tyÃ¶paikat',0),(355877,9886,'no','Bygging jobber',0),(355878,9886,'da','Konstruktion job',0),(355879,9886,'ko','ê±´ì„¤ ì±„ìš© ì •ë³´',0),(355880,9886,'he','×¢×‘×•×“×•×ª ×‘× ×™×™×”',0),(355881,9886,'el','ÎŸÎ¹ÎºÎ¿Î´Î¿Î¼Î¹ÎºÎ­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚',0),(355882,9886,'zh','å»ºç­‘å·¥ä½œ\r\n',0),(355883,9886,'sv','Byggjobb',0),(355884,9886,'it','Lavori in costruzione',0),(355885,9886,'tl','',0),(355886,9886,'th','&#3591;&#3634;&#3609;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(355887,9886,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¤¾à¤‚',0),(355888,9886,'ms','Kerja-kerja pembinaan',0),(355889,9886,'ar','ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(355890,9886,'fr','Offres dâ€™emploi construction',0),(355891,9886,'jp','å»ºè¨­ã®ä»•äº‹',0),(355892,9886,'pt','Empregos na construÃ§Ã£o',0),(355893,9886,'ru','Ð¡Ñ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(355894,9886,'es','Trabajos de Construccion',0),(355895,9886,'de','Stellenangebote im Baugewerbe',0),(355896,9886,'en','Construction Jobs',0),(355897,9887,'is','',0),(355898,9887,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø´ØºÙ„ Ù‡Ø§ÙŠ Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø²',0),(355899,9887,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø´ØºÙ„ Ù‡Ø§ÙŠ Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø²',0),(355900,9887,'tr','Ä°nÅŸaat iÅŸleri DÃ¼zenle',0),(355901,9887,'pl','Edytowanie zadaÅ„ budowlanych',0),(355902,9887,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð² ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(355903,9887,'ur','ØªØ¹Ù…ÛŒØ±Ø§ØªÛŒ Ú©Ø§Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(355904,9887,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð³Ñ€Ð°Ñ’ÐµÐ²Ð¸Ð½ÑÐºÐ¸Ñ… Ð¿Ð¾ÑÐ»Ð¾Ð²Ð°',0),(355905,9887,'vi','Chá»‰nh sá»­a cÃ´ng viá»‡c xÃ¢y dá»±ng',0),(355906,9887,'af','Redigeer Konstruksie Werkstuk',0),(355907,9887,'ro','Joburi Ã®n construcÅ£ii de editare',0),(355908,9887,'et','Redigeeri ehitus TÃ¶Ã¶pakkumised',0),(355909,9887,'si','Urejanje zaposlitve v gradbeniÅ¡tvu',0),(355910,9887,'ba','Mengedit pekerjaan konstruksi',0),(355911,9887,'nl','Bewerken van bouw-Jobs',0),(355912,9887,'fi','Muokkaa rakennusalan tyÃ¶paikkoja',0),(355913,9887,'no','Redigere bygging jobber',0),(355914,9887,'da','Redigere konstruktion job',0),(355915,9887,'ko','ê±´ì„¤ ìž‘ì—… íŽ¸ì§‘',0),(355916,9887,'he','×¢×¨×™×›×ª ×¢×‘×•×“×•×ª ×‘× ×™×™×”',0),(355917,9887,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®Ï‚',0),(355918,9887,'zh','ç¼–è¾‘å»ºç­‘å·¥ä½œ\r\n',0),(355919,9887,'sv','Redigera Byggjobb',0),(355920,9887,'it','Modifica dei processi di costruzione',0),(355921,9887,'tl','',0),(355922,9887,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3591;&#3634;&#3609;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(355923,9887,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¤¾à¤°à¥à¤¯ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(355924,9887,'ms','Mengedit kerja-kerja pembinaan',0),(355925,9887,'ar','ØªØ­Ø±ÙŠØ± ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(355926,9887,'fr','Ã‰diter des travaux de Construction',0),(355927,9887,'jp','å»ºè¨­ã®ä»•äº‹ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(355928,9887,'pt','Editar os trabalhos de construÃ§Ã£o',0),(355929,9887,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(355930,9887,'es','Editar Trabajos de ConstrucciÃ³n',0),(355931,9887,'de','Bau-AuftrÃ¤ge bearbeiten',0),(355932,9887,'en','Edit Construction Jobs',0),(355933,9888,'is','',0),(355934,9888,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø´ØºÙ„ Ù‡Ø§ÙŠ Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø² ',0),(355935,9888,'pr','Ø«Ø¨Øª / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´ØºÙ„ Ù‡Ø§ÙŠ Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø² ',0),(355936,9888,'tr','Ä°nÅŸaat iÅŸleri girin/gÃ¼ncelleme',0),(355937,9888,'pl','WprowadÅº/aktualizacja prac budowlanych',0),(355938,9888,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð² ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(355939,9888,'ur','ØªØ¹Ù…ÛŒØ± Ù…Ù„Ø§Ø²Ù…ØªÙˆÚº Ù…ÛŒÚº Ø¯Ø§Ø®Ù„/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(355940,9888,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð³Ñ€Ð°Ñ’ÐµÐ²Ð¸Ð½ÑÐºÐ¸Ñ… Ð¿Ð¾ÑÐ»Ð¾Ð²Ð°',0),(355941,9888,'vi','Nháº­p/Cáº­p nháº­t cÃ¡c cÃ´ng viá»‡c xÃ¢y dá»±ng',0),(355942,9888,'af','Invoer/Opdateer Konstruksie Projekte ',0),(355943,9888,'ro','IntroduceÅ£i/actualizaÅ£i Joburi Ã®n construcÅ£ii',0),(355944,9888,'et','Ehitus TÃ¶Ã¶pakkumised sisestamine/ajakohastamine',0),(355945,9888,'si','Vnos/posodobitev zaposlitve v gradbeniÅ¡tvu',0),(355946,9888,'ba','Masukkan/Perbarui pekerjaan konstruksi',0),(355947,9888,'nl','Invoeren/bijwerken bouw vacatures',0),(355948,9888,'fi','PÃ¤ivittÃ¤minen rakennusalan tyÃ¶paikkoja',0),(355949,9888,'no','Angi/Oppdater bygging jobber',0),(355950,9888,'da','Indtaste/opdatere konstruktion job',0),(355951,9888,'ko','ê±´ì„¤ ìž‘ì—… ìž…ë ¥/ì—…ë°ì´íŠ¸',0),(355952,9888,'he','×”×–×Ÿ/×¢×“×›×•×Ÿ ×©×œ ×¢×‘×•×“×•×ª ×‘× ×™×™×”',0),(355953,9888,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¿Î¹ÎºÎ¿Î´Î¿Î¼Î¹ÎºÎ­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚',0),(355954,9888,'zh','è¾“å…¥/æ›´æ–°å»ºç­‘å·¥ä½œ',0),(355955,9888,'sv','Ange/uppdatera Byggjobb',0),(355956,9888,'it','Inserire o aggiornare i lavori di costruzione',0),(355957,9888,'tl','',0),(355958,9888,'th','&#3611;&#3657;&#3629;&#3609;/&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591; &#3591;&#3634;&#3609;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(355959,9888,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¤¾à¤°à¥à¤¯ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ /',0),(355960,9888,'ms','Masukkan/Kemaskini kerja-kerja pembinaan',0),(355961,9888,'ar','Ø¥Ø¯Ø®Ø§Ù„/ØªØ­Ø¯ÙŠØ« ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(355962,9888,'fr','Entrez/mise Ã  jour des travaux de Construction',0),(355963,9888,'jp','å»ºè¨­æ¥­ã®é›‡ç”¨ã®å…¥åŠ›/æ›´æ–°',0),(355964,9888,'pt','Inserir/atualizar empregos na construÃ§Ã£o',0),(355965,9888,'ru','Ð’Ð²Ð¾Ð´/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ñ€Ð°Ð±Ð¾Ñ‚',0),(355966,9888,'es','Introducir/Actualizar Colocaciones de ConstrucciÃ³n',0),(355967,9888,'de','Geben Sie/Update Stellenangebote im Baugewerbe',0),(355968,9888,'en','Enter/Update Construction Jobs',0),(355969,9889,'is','',0),(355970,9889,'dr','Ù†Ù‚Ø·Ù‡ Ù…Ù‚ØµØ¯ ',0),(355971,9889,'pr','Ù†Ù‚Ø·Ù‡ Ù…Ù‚ØµØ¯ ',0),(355972,9889,'tr','Hedef noktasÄ±',0),(355973,9889,'pl','Punkt docelowy',0),(355974,9889,'bg','Ð¢Ð¾Ñ‡ÐºÐ° Ð´ÐµÑÑ‚Ð¸Ð½Ð°Ñ†Ð¸Ñ',0),(355975,9889,'ur','Ù…Ù‚ØµÙˆØ¯ Ù¾ÙˆØ§Ø¦Ù†Ù¹',0),(355976,9889,'sr','ÐžÐ´Ñ€ÐµÐ´Ð¸ÑˆÐ½Ð° Ñ‚Ð°Ñ‡ÐºÐ°',0),(355977,9889,'vi','Äiá»ƒm Ä‘áº¿n Ä‘iá»ƒm',0),(355978,9889,'af','Bestemming punt',0),(355979,9889,'ro','Punctul de destinaÅ£ie',0),(355980,9889,'et','Sihtpunkti',0),(355981,9889,'si','Ciljno toÄko',0),(355982,9889,'ba','Titik tujuan',0),(355983,9889,'nl','Bestemming',0),(355984,9889,'fi','PÃ¤Ã¤tepiste',0),(355985,9889,'no','Bestemmelsesstedet',0),(355986,9889,'da','Destination punkt',0),(355987,9889,'ko','ëŒ€ìƒ ì§€ì ',0),(355988,9889,'he','× ×§×•×“×ª ×™×¢×“',0),(355989,9889,'el','Î£Î·Î¼ÎµÎ¯Î¿ Ï€ÏÎ¿Î¿ÏÎ¹ÏƒÎ¼Î¿Ï',0),(355990,9889,'zh','ç›®çš„åœ°ç‚¹\r\n',0),(355991,9889,'sv','MÃ¥lpunkt',0),(355992,9889,'it','Punto di destinazione',0),(355993,9889,'tl','',0),(355994,9889,'th','&#3592;&#3640;&#3604;&#3627;&#3617;&#3634;&#3618;&#3611;&#3621;&#3634;&#3618;&#3607;&#3634;&#3591;',0),(355995,9889,'hi','à¤—à¤‚à¤¤à¤µà¥à¤¯ à¤¬à¤¿à¤‚à¤¦à¥',0),(355996,9889,'ms','Destinasi',0),(355997,9889,'ar','Ù†Ù‚Ø·Ø© Ø§Ù„Ù…Ù‚ØµØ¯',0),(355998,9889,'fr','Point de destination',0),(355999,9889,'jp','å…ˆã®ãƒã‚¤ãƒ³ãƒˆ',0),(356000,9889,'pt','Ponto de destino',0),(356001,9889,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(356002,9889,'es','Punto de DestinaciÃ³n',0),(356003,9889,'de','Zielpunkt',0),(356004,9889,'en','Destination Point',0),(356005,9890,'is','',0),(356006,9890,'dr','( Ù‚ÙŠÙ…Øª) ÙÙ‚Ø· ',0),(356007,9890,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ ( Ù‚ÙŠÙ…Øª) ÙÙ‚Ø· ',0),(356008,9890,'tr','YalnÄ±zca tahmin',0),(356009,9890,'pl','OszacowaÄ‡ tylko',0),(356010,9890,'bg','Ð¡Ð°Ð¼Ð¾ Ð¿Ñ€Ð¾Ð³Ð½Ð¾Ð·Ð½Ð°',0),(356011,9890,'ur','ØµØ±Ù Ø§Ù†Ø¯Ø§Ø²Û’',0),(356012,9890,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÑƒÑ˜Ñƒ ÑÐ°Ð¼Ð¾',0),(356013,9890,'vi','DÃ¢n sá»‘ Æ°á»›c tÃ­nh chá»‰',0),(356014,9890,'af','Skatting Alleenlik',0),(356015,9890,'ro','Estimare numai',0),(356016,9890,'et','Hinnata ainult',0),(356017,9890,'si','Samo ocena',0),(356018,9890,'ba','Perkiraan hanya',0),(356019,9890,'nl','Slechts schatting',0),(356020,9890,'fi','Arvioon',0),(356021,9890,'no','Anslag',0),(356022,9890,'da','SkÃ¸n kun',0),(356023,9890,'ko','ìœ¼ë¡œë§Œ',0),(356024,9890,'he','×”×¢×¨×›×” ×‘×œ×‘×“',0),(356025,9890,'el','Î•ÎºÏ„Î¯Î¼Î·ÏƒÎ· Î¼ÏŒÎ½Î¿',0),(356026,9890,'zh','åªæ˜¯ä¼°è®¡\r\n',0),(356027,9890,'sv','Uppskattning bara',0),(356028,9890,'it','Solo stima',0),(356029,9890,'tl','',0),(356030,9890,'th','&#3611;&#3619;&#3632;&#3648;&#3617;&#3636;&#3609;&#3648;&#3607;&#3656;&#3634;&#3609;&#3633;&#3657;&#3609;',0),(356031,9890,'hi','à¤•à¥‡à¤µà¤² à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(356032,9890,'ms','Anggaran sahaja',0),(356033,9890,'ar','ØªÙ‚Ø¯ÙŠØ± ÙÙ‚Ø·',0),(356034,9890,'fr','Estimer seulement',0),(356035,9890,'jp','è¦‹ç©ã®ã¿',0),(356036,9890,'pt','Estimativa somente',0),(356037,9890,'ru','ÐžÑ†ÐµÐ½ÐºÐ° Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(356038,9890,'es','EstimaciÃ³n Solamente',0),(356039,9890,'de','Nur SchÃ¤tzung',0),(356040,9890,'en','Estimate Only',0),(356041,9891,'is','',0),(356042,9891,'dr','FOB ÙÙˆØ¨ Ù…Ø­Ù„ ',0),(356043,9891,'pr','FOB ÙÙˆØ¨ Ù…Ø­Ù„ ',0),(356044,9891,'tr','FOB noktasÄ±',0),(356045,9891,'pl','FOB punkt',0),(356046,9891,'bg','FOB Ñ‚Ð¾Ñ‡ÐºÐ°',0),(356047,9891,'ur','Ù¾Ø§Ú©Ù¹ Ù¾ÙˆØ§Ø¦Ù†Ù¹',0),(356048,9891,'sr','Ð¤ÐžÐ‘ ÐŸÐ¾Ð¸Ð½Ñ‚',0),(356049,9891,'vi','FOB Ä‘iá»ƒm',0),(356050,9891,'af','FOB punt',0),(356051,9891,'ro','FOB punct',0),(356052,9891,'et','FOB punkti',0),(356053,9891,'si','FOB toÄke',0),(356054,9891,'ba','FOB Point',0),(356055,9891,'nl','FOB punt',0),(356056,9891,'fi','FOB kohta',0),(356057,9891,'no','FOB punkt',0),(356058,9891,'da','FOB punkt',0),(356059,9891,'ko','FOB ì§€ì ',0),(356060,9891,'he','× ×§×•×“×ª ×¤×•×‘',0),(356061,9891,'el','Î£Î·Î¼ÎµÎ¯Î¿ FOB',0),(356062,9891,'zh','ç¦»å²¸ç‚¹\r\n',0),(356063,9891,'sv','FOB punkt',0),(356064,9891,'it','Punto di FOB',0),(356065,9891,'tl','',0),(356066,9891,'th','&#3605;&#3635;&#3649;&#3627;&#3609;&#3656;&#3591; FOB ',0),(356067,9891,'hi','à¤à¤«à¤“à¤¬à¥€ à¤¬à¤¿à¤‚à¤¦à¥',0),(356068,9891,'ms','Titik FOB',0),(356069,9891,'ar','Ù†Ù‚Ø·Ø© ÙÙˆØ¨',0),(356070,9891,'fr','Point FAB',0),(356071,9891,'jp','FOB ãƒã‚¤ãƒ³ãƒˆ',0),(356072,9891,'pt','Ponto FOB',0),(356073,9891,'ru','FOB Ñ‚Ð¾Ñ‡ÐºÐ°',0),(356074,9891,'es','Punto de Libre Abordo',0),(356075,9891,'de','FOB-Punkt',0),(356076,9891,'en','FOB Point',0),(356077,9892,'is','',0),(356078,9892,'dr','Ø¯Ø±ØµØ¯ Ø³Ù† Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ',0),(356079,9892,'pr','Ø¯Ø±ØµØ¯ Ø³Ù† Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ',0),(356080,9892,'tr','Retainage yÃ¼zde',0),(356081,9892,'pl','Procent Retainage',0),(356082,9892,'bg','Retainage Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(356083,9892,'ur','Ø±ÛŒÙ¹Ø§ÛŒÙ†Ø§Ø¬ ÙÛŒ ØµØ¯',0),(356084,9892,'sr','Ð ÐµÑ‚Ð°Ð¸Ð½Ð°Ð³Ðµ %',0),(356085,9892,'vi','Retainage pháº§n trÄƒm',0),(356086,9892,'af','Retainage persent',0),(356087,9892,'ro','Retainage la sutÄƒ',0),(356088,9892,'et','Retainage %',0),(356089,9892,'si','Retainage odstotkov',0),(356090,9892,'ba','Retainage persen',0),(356091,9892,'nl','Retainage procent',0),(356092,9892,'fi','PidÃ¤tyksen prosenttia',0),(356093,9892,'no','Retainage prosent',0),(356094,9892,'da','Tilbageholdelse procent',0),(356095,9892,'ko','Retainage %',0),(356096,9892,'he','Retainage ××—×•×–',0),(356097,9892,'el','Retainage Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(356098,9892,'zh','ä¿ç•™é‡‘çš„ç™¾åˆ†æ¯”\r\n',0),(356099,9892,'sv','InnehÃ¥llet belopp procent',0),(356100,9892,'it','Ritenuta di garanzia per cento',0),(356101,9892,'tl','',0),(356102,9892,'th','&#3648;&#3594;&#3655;&#3588;&#3605;&#3637;&#3585;&#3621;&#3633;&#3610;',0),(356103,9892,'hi','Retainage à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(356104,9892,'ms','Peratus Retainage',0),(356105,9892,'ar','Ø§Ù„Ø§Ø­ØªÙØ§Ø¸ Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(356106,9892,'fr','% De retenue de garantie',0),(356107,9892,'jp','åˆ†å‰² %',0),(356108,9892,'pt','Retainage por cento',0),(356109,9892,'ru','ÐšÐ¾Ð¼Ð¼ÑŒÑŽÐ½Ð¸ÐºÐµÐ¹ÑˆÐ½ %',0),(356110,9892,'es','Porcentaje Retenido',0),(356111,9892,'de','Raten-Prozent',0),(356112,9892,'en','Retainage Percent',0),(356113,9893,'is','',0),(356114,9893,'dr','Ù†Ù‚Ø·Ù‡ Ø­Ù…Ù„',0),(356115,9893,'pr','Ù†Ù‚Ø·Ù‡ Ø­Ù…Ù„',0),(356116,9893,'tr','Sevkiyat noktasÄ±',0),(356117,9893,'pl','Punkt wysyÅ‚ki',0),(356118,9893,'bg','ÐšÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ñ‚Ð¾Ñ‡ÐºÐ°',0),(356119,9893,'ur','Ø´Ù¾Ù†Ú¯ Ù¾ÙˆØ§Ø¦Ù†Ù¹',0),(356120,9893,'sr','Ð¢Ð°Ñ‡ÐºÐµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(356121,9893,'vi','Váº­n chuyá»ƒn Ä‘iá»ƒm',0),(356122,9893,'af','Versendingspunt',0),(356123,9893,'ro','Punct de livrare',0),(356124,9893,'et','LÃ¤htepunkt',0),(356125,9893,'si','Dostava toÄke',0),(356126,9893,'ba','Jalur pelayaran',0),(356127,9893,'nl','Verzending punt',0),(356128,9893,'fi','LÃ¤hetyspiste',0),(356129,9893,'no','Leveringspunktet',0),(356130,9893,'da','Forsendelsesstedet',0),(356131,9893,'ko','ë°°ì†¡ í¬ì¸íŠ¸',0),(356132,9893,'he','× ×§×•×“×ª ×ž×©×œ×•×—',0),(356133,9893,'el','Î£Î·Î¼ÎµÎ¯Î¿ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(356134,9893,'zh','å‘è´§ç‚¹\r\n',0),(356135,9893,'sv','Leveransplatsen',0),(356136,9893,'it','Punto di spedizione',0),(356137,9893,'tl','',0),(356138,9893,'th','&#3592;&#3640;&#3604;&#3585;&#3634;&#3619;&#3586;&#3609;&#3626;&#3656;&#3591;',0),(356139,9893,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤¬à¤¿à¤‚à¤¦à¥',0),(356140,9893,'ms','Tempat penghantaran',0),(356141,9893,'ar','Ù†Ù‚Ø·Ø© Ø§Ù„Ø´Ø­Ù†',0),(356142,9893,'fr','Point dâ€™expÃ©dition',0),(356143,9893,'jp','å‡ºè·ãƒã‚¤ãƒ³ãƒˆ',0),(356144,9893,'pt','Ponto de navegaÃ§Ã£o',0),(356145,9893,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(356146,9893,'es','Punto de EnvÃ­o',0),(356147,9893,'de','Versandstelle',0),(356148,9893,'en','Shipping Point',0),(356149,9894,'is','',0),(356150,9894,'dr','ÙƒÙ„ÙŠØ¯ Ú¯Ø³ØªØ±Ø´ Ø¯Ù‡Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(356151,9894,'pr','ÙƒÙ„ÙŠØ¯ Ú¯Ø³ØªØ±Ø´ Ø¯Ù‡Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(356152,9894,'tr','GeliÅŸtirici anahtar baÅŸarÄ±yla kaydedildi',0),(356153,9894,'pl','Dewelopera klucz zostaÅ‚ zapisany pomyÅ›lnie',0),(356154,9894,'bg','Ð Ð°Ð·Ñ€Ð°Ð±Ð¾Ñ‚Ñ‡Ð¸Ðº ÐºÐ»ÑŽÑ‡, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(356155,9894,'ur','ÚˆÙˆÛŒÙ„Ù¾Ø± Ú©ÛŒ Ú©Ù„ÛŒØ¯ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸',0),(356156,9894,'sr','ÐŸÑ€Ð¾Ñ˜ÐµÐºÑ‚Ð¾Ð²Ð°ÑšÐµ ÐºÑ™ÑƒÑ‡ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(356157,9894,'vi','chÃ¬a khÃ³a ngÆ°á»i nÃ¢ng cáº¥p Ä‘Ã£ lÆ°u thÃ nh cÃ´ng',0),(356158,9894,'af','Onwikkelaarssleutel suksesvol Gesoor',0),(356159,9894,'ro','Cheie dezvoltator salvat cu succes',0),(356160,9894,'et','Arendaja vÃµti edukalt salvestatud',0),(356161,9894,'si','Razvijalec kljuÄ shranjen',0),(356162,9894,'ba','Pengembang kunci disimpan berhasil',0),(356163,9894,'nl','Ontwikkelaar sleutel opgeslagen',0),(356164,9894,'fi','KehittÃ¤jÃ¤ avain tallennettu',0),(356165,9894,'no','Utvikler nÃ¸kkel lagret',0),(356166,9894,'da','Udvikleren nÃ¸gle gemt med succes',0),(356167,9894,'ko','ê°œë°œìž í‚¤ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(356168,9894,'he','×ž×¤×ª×— ×ž×¤×ª×— ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(356169,9894,'el','Î ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÏ„Î®Ï‚ ÎºÎ»ÎµÎ¹Î´Î¯ Ï€Î¿Ï… Î±Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(356170,9894,'zh','å¼€å‘å•†å¯†é’¥ä¿å­˜æˆåŠŸ\r\n',0),(356171,9894,'sv','Utvecklare nyckel har sparats',0),(356172,9894,'it','Sviluppatore chiave salvato correttamente',0),(356173,9894,'tl','',0),(356174,9894,'th','&#3612;&#3641;&#3657;&#3614;&#3633;&#3602;&#3609;&#3634;&#3588;&#3637;&#3618;&#3660;&#3606;&#3641;&#3585;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(356175,9894,'hi','à¤¡à¥‡à¤µà¤²à¤ªà¤° à¤•à¥à¤‚à¤œà¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(356176,9894,'ms','Pemaju utama berjaya disimpan',0),(356177,9894,'ar','Ù…ÙØªØ§Ø­ Ø§Ù„Ù…Ø·ÙˆØ± Ø­ÙØ¸Ù‡ Ø¨Ù†Ø¬Ø§Ø­',0),(356178,9894,'fr','ClÃ© dÃ©veloppeur enregistrÃ©e avec succÃ¨s',0),(356179,9894,'jp','ãƒ‡ãƒ™ãƒ­ãƒƒãƒ‘ãƒ¼ ã‚­ãƒ¼ãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(356180,9894,'pt','Chave de desenvolvedor com sucesso',0),(356181,9894,'ru','ÐšÐ»ÑŽÑ‡ Ñ€Ð°Ð·Ñ€Ð°Ð±Ð¾Ñ‚Ñ‡Ð¸ÐºÐ°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(356182,9894,'es','llave de Desarrollador Guardado Exitosamente',0),(356183,9894,'de','EntwicklerschlÃ¼ssel erfolgreich gespeichert',0),(356184,9894,'en','Developer Key Saved Successfully',0),(356185,9895,'is','',0),(356186,9895,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ„ÙŠØ¯ ØªÙˆØ³Ø¹Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(356187,9895,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒÙ„ÙŠØ¯ ØªÙˆØ³Ø¹Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡ ',0),(356188,9895,'tr','GeliÅŸtirici anahtarÄ±nÄ± dÃ¼zenleyin',0),(356189,9895,'pl','EdytowaÄ‡ klucz Developer',0),(356190,9895,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ€Ð°Ð±Ð¾Ñ‚Ñ‡Ð¸Ðº ÐºÐ»ÑŽÑ‡',0),(356191,9895,'ur','ÚˆÙˆÛŒÙ„Ù¾Ø± Ú©Ù„ÛŒØ¯ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(356192,9895,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð”ÐµÐ²ÐµÐ»Ð¾Ð¿ÐµÑ€ ÐºÑ™ÑƒÑ‡',0),(356193,9895,'vi','chá»‰nh sá»­a ngÆ°á»i nÃ¢ng cáº¥p',0),(356194,9895,'af','Redigeer Ontwikkelaarssleutel',0),(356195,9895,'ro','Editare dezvoltator cheie',0),(356196,9895,'et','Arendaja seda all',0),(356197,9895,'si','Urejanje razvijalec kljuÄnih',0),(356198,9895,'ba','Mengedit pengembang kunci',0),(356199,9895,'nl','Ontwikkelaar sleutel bewerken',0),(356200,9895,'fi','Muokkaa kehittÃ¤jÃ¤ avain',0),(356201,9895,'no','Redigere utvikler nÃ¸kkel',0),(356202,9895,'da','Redigere udvikleren nÃ¸glen',0),(356203,9895,'ko','ê°œë°œìž í‚¤ íŽ¸ì§‘',0),(356204,9895,'he','×¢×¨×™×›×ª ×ž×¤×ª×— ×ž×¤×ª×—',0),(356205,9895,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ ÎºÎ»ÎµÎ¹Î´Î¯ Ï€ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÏ„Î®',0),(356206,9895,'zh','ç¼–è¾‘å¼€å‘å•†å¯†é’¥\r\n',0),(356207,9895,'sv','Redigera utvecklare nyckel',0),(356208,9895,'it','Modificare la chiave di uno sviluppatore',0),(356209,9895,'tl','',0),(356210,9895,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3612;&#3641;&#3657;&#3614;&#3633;&#3602;&#3609;&#3634;&#3588;&#3637;&#3618;&#3660;',0),(356211,9895,'hi','à¤¡à¥‡à¤µà¤²à¤ªà¤° à¤•à¥à¤‚à¤œà¥€ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(356212,9895,'ms','Edit pemaju kunci',0),(356213,9895,'ar','ØªØ­Ø±ÙŠØ± Ù…ÙØªØ§Ø­ Ø§Ù„Ù…Ø·ÙˆØ±',0),(356214,9895,'fr','Modifier la clÃ© dÃ©veloppeur',0),(356215,9895,'jp','ãƒ‡ãƒ™ãƒ­ãƒƒãƒ‘ãƒ¼ ã‚­ãƒ¼ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(356216,9895,'pt','Editar a chave de desenvolvedor',0),(356217,9895,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐºÐ»ÑŽÑ‡ Ñ€Ð°Ð·Ñ€Ð°Ð±Ð¾Ñ‚Ñ‡Ð¸ÐºÐ°',0),(356218,9895,'es','Editar Llave de Desarrollador',0),(356219,9895,'de','EntwicklerschlÃ¼ssel bearbeiten',0),(356220,9895,'en','Edit Developer Key',0),(356221,9896,'is','',0),(356222,9896,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(356223,9896,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(356224,9896,'tr','Hata iÅŸleme Ã¶ÄŸesi',0),(356225,9896,'pl','BÅ‚Ä…d przetwarzania elementu',0),(356226,9896,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(356227,9896,'ur','Ù†Ù‚Øµ Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ø´Û’',0),(356228,9896,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¾Ð±Ñ€Ð°Ð´Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(356229,9896,'vi','Lá»—i trong quÃ¡ trÃ¬nh ghi sá»‘',0),(356230,9896,'af','Fout met Item Prosessering',0),(356231,9896,'ro','Element de procesare eroare',0),(356232,9896,'et','TÃµrge tÃ¶Ã¶tlemise Ã¼ksus',0),(356233,9896,'si','Napake obdelave element',0),(356234,9896,'ba','Kesalahan pengolahan Item',0),(356235,9896,'nl','Fout Processing Item',0),(356236,9896,'fi','Virhe kÃ¤sitellÃ¤Ã¤n nimikettÃ¤',0),(356237,9896,'no','Feil behandling elementet',0),(356238,9896,'da','Fejl behandling vare',0),(356239,9896,'ko','ì˜¤ë¥˜ ì²˜ë¦¬ í•­ëª©',0),(356240,9896,'he','×©×’×™××” ×‘×¢×™×‘×•×“ ×¤×¨×™×˜',0),(356241,9896,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(356242,9896,'zh','é”™è¯¯å¤„ç†é¡¹ç›®',0),(356243,9896,'sv','Fel bearbetning objekt',0),(356244,9896,'it','Errore l\'elaborazione elemento',0),(356245,9896,'tl','',0),(356246,9896,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3619;&#3632;&#3610;&#3623;&#3609;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(356247,9896,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤‚à¤¸à¤¾à¤§à¤¨ à¤†à¤‡à¤Ÿà¤®',0),(356248,9896,'ms','Ralat pemprosesan Item',0),(356249,9896,'ar','Ø®Ø·Ø£ ÙÙŠ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ø¨Ù†Ø¯',0),(356250,9896,'fr','Ã‰lÃ©ment de traitement dâ€™erreur',0),(356251,9896,'jp','ã‚¨ãƒ©ãƒ¼å‡¦ç†é …ç›®',0),(356252,9896,'pt','Item de tratamento de erro',0),(356253,9896,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(356254,9896,'es','Error Procesando Item',0),(356255,9896,'de','Fehler Verarbeitung Element',0),(356256,9896,'en','Error Processing Item',0),(356257,9897,'is','',0),(356258,9897,'dr','ÙƒÙ„ÙŠØ¯ ØªÙˆØ³Ø¹Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡  Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ú¯ÙˆÚ¯Ù„',0),(356259,9897,'pr','ÙƒÙ„ÙŠØ¯ ØªÙˆØ³Ø¹Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡  Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ú¯ÙˆÚ¯Ù„',0),(356260,9897,'tr','Google Base geliÅŸtirici anahtar',0),(356261,9897,'pl','Klucz programisty Google Base',0),(356262,9897,'bg','Google Base Ñ€Ð°Ð·Ñ€Ð°Ð±Ð¾Ñ‚Ñ‡Ð¸Ðº ÐºÐ»ÑŽÑ‡',0),(356263,9897,'ur','Google Ø¨ÛŒØ³ ÚˆÙˆÛŒÙ„Ù¾Ø± Ú©Ù„ÛŒØ¯',0),(356264,9897,'sr','Ð“Ð¾Ð¾Ð³Ð»Ðµ Ð±Ð°Ð·Ð¸ Ð”ÐµÐ²ÐµÐ»Ð¾Ð¿ÐµÑ€ ÐºÑ™ÑƒÑ‡',0),(356265,9897,'vi','phÃ¡t triá»ƒn google dá»±a trÃªn',0),(356266,9897,'af','Google basis ontwikkelaar sleutel',0),(356267,9897,'ro','Cheie de dezvoltator Google Base',0),(356268,9897,'et','Google Base arendaja vÃµti',0),(356269,9897,'si','Google Base razvijalec kljuÄnih',0),(356270,9897,'ba','Kunci pengembang Google Base',0),(356271,9897,'nl','Google Base ontwikkelaar sleutel',0),(356272,9897,'fi','Google Base kehittÃ¤jÃ¤ avain',0),(356273,9897,'no','Google Base utvikler nÃ¸kkel',0),(356274,9897,'da','Google Nedrig udvikleren nÃ¸glen',0),(356275,9897,'ko','êµ¬ê¸€ ë² ì´ìŠ¤ ê°œë°œìž í‚¤',0),(356276,9897,'he','Google Base ×ž×¤×ª×— ×ž×¤×ª×—',0),(356277,9897,'el','ÎšÎ»ÎµÎ¹Î´Î¯ Ï€ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÏ„Î® Î²Î¬ÏƒÎ·Ï‚ Ï„Î·Ï‚ Google',0),(356278,9897,'zh','è°·æ­ŒåŸºåœ°å¼€å‘å•†å¯†é’¥\r\n',0),(356279,9897,'sv','Google Base utvecklare nyckel',0),(356280,9897,'it','Google Base sviluppatore chiave',0),(356281,9897,'tl','',0),(356282,9897,'th','Google Base Developer Key',0),(356283,9897,'hi','à¤—à¥‚à¤—à¤² à¤•à¥‹à¤· à¤¡à¥‡à¤µà¤²à¤ªà¤° à¤•à¥à¤‚à¤œà¥€',0),(356284,9897,'ms','Google Base pemaju kunci',0),(356285,9897,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø¬ÙˆØ¬Ù„ Ø§Ù„Ù…Ø·ÙˆØ± Ø§Ù„Ù…ÙØªØ§Ø­',0),(356286,9897,'fr','ClÃ© de dÃ©veloppeur de Base de Google',0),(356287,9897,'jp','Google Base ã®é–‹ç™ºè€…ã‚­ãƒ¼',0),(356288,9897,'pt','Chave de desenvolvedor Google Base',0),(356289,9897,'ru','ÐšÐ»ÑŽÑ‡ Ñ€Ð°Ð·Ñ€Ð°Ð±Ð¾Ñ‚Ñ‡Ð¸ÐºÐ° Google Base',0),(356290,9897,'es','Llave de Desarrollador de Base de Google',0),(356291,9897,'de','Google Base EntwicklerschlÃ¼ssel',0),(356292,9897,'en','Google Base Developer Key',0),(356293,9898,'is','',0),(356294,9898,'dr','Ù‡ÙŠÚ† Ø§Ø³Ù†Ø§Ø¯ÙŠ Ø¨Ù‡ Ø±ÙˆØ² Ù†Ø´Ø¯Ù‡',0),(356295,9898,'pr','Ù‡ÙŠÚ† Ø§Ø³Ù†Ø§Ø¯ÙŠ Ø¨Ù‡ Ø±ÙˆØ² Ù†Ø´Ø¯Ù‡',0),(356296,9898,'tr','KayÄ±t GÃ¼ncelleme',0),(356297,9898,'pl','Nie rekordÃ³w aktualizowanych',0),(356298,9898,'bg','ÐÑÐ¼Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¾ÑÑŠÐ²Ñ€ÐµÐ¼ÐµÐ½ÑÐ²Ð°Ð½Ðµ',0),(356299,9898,'ur','Ú©ÙˆØ¦ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(356300,9898,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð¸ÑÑƒ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(356301,9898,'vi','khÃ´ng cÃ³ ghi chÃ©p Ä‘Æ°á»£c cáº­p nháº­t',0),(356302,9898,'af','Geen Rekords Opdateer',0),(356303,9898,'ro','ÃŽnregistrÄƒri actualizate',0),(356304,9898,'et','Kirjeid ei uuendatud',0),(356305,9898,'si','Noben zapis posodobljen',0),(356306,9898,'ba','Tidak ada catatan yang diperbarui',0),(356307,9898,'nl','Geen Records bijgewerkt',0),(356308,9898,'fi','Tietueita ei pÃ¤ivitetty',0),(356309,9898,'no','Ingen poster oppdateres',0),(356310,9898,'da','Ingen poster opdateret',0),(356311,9898,'ko','ì—…ë°ì´íŠ¸ ê¸°ë¡',0),(356312,9898,'he','××™×Ÿ ×¨×™×©×•×ž×™ ×ž×¢×•×“×›×Ÿ',0),(356313,9898,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ½Î¿Î½Ï„Î±Î¹',0),(356314,9898,'zh','æ²¡æœ‰è®°å½•æ›´æ–°\r\n',0),(356315,9898,'sv','Inga poster som uppdateras',0),(356316,9898,'it','Nessun record aggiornato',0),(356317,9898,'tl','',0),(356318,9898,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3619;&#3632;&#3648;&#3610;&#3637;&#3618;&#3609;&#3607;&#3637;&#3656;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;',0),(356319,9898,'hi','à¤•à¥‹à¤ˆ à¤…à¤­à¤¿à¤²à¥‡à¤– à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(356320,9898,'ms','Tiada rekod yang Kemaskini',0),(356321,9898,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø³Ø¬Ù„Ø§Øª ØªØ­Ø¯ÙŠØ«',0),(356322,9898,'fr','Aucun enregistrement mis Ã  jour',0),(356323,9898,'jp','æ›´æ–°ãƒ¬ã‚³ãƒ¼ãƒ‰ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(356324,9898,'pt','NÃ£o hÃ¡ registros atualizados',0),(356325,9898,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(356326,9898,'es','No se Actualizaron Records',0),(356327,9898,'de','Keine DatensÃ¤tze aktualisiert',0),(356328,9898,'en','No Records Updated',0),(356329,9899,'is','',0),(356330,9899,'dr','Ø§Ø®ÙŠØ±Ø§ ØªØºÙŠÙŠØ± ÙƒØ±Ø¯Ù‡ ÙŠØ§ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ ',0),(356331,9899,'pr','Ø§Ø®ÙŠØ±Ø§ ØªØºÙŠÙŠØ± ÙƒØ±Ø¯Ù‡ ÙŠØ§ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ ',0),(356332,9899,'tr','Son zamanlarda deÄŸiÅŸtirilmiÅŸ veya ekledi',0),(356333,9899,'pl','Ostatnio zmodyfikowane lub dodane',0),(356334,9899,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð¸ Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸',0),(356335,9899,'ur','Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ… Ø´Ø¯Û ÛŒØ§ Ø´Ø§Ù…Ù„',0),(356336,9899,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¸ Ð¸Ð»Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ð°',0),(356337,9899,'vi','Ä‘Ã£ chá»‰nh sá»­ hoáº·c thÃªm gáº§n Ä‘Ã¢y',0),(356338,9899,'af','Onlangs Verander of Geskep',0),(356339,9899,'ro','Recent modificat sau adÄƒugat',0),(356340,9899,'et','Hiljuti muudetud vÃµi lisatud',0),(356341,9899,'si','Nedavno spremenjeno ali dodano',0),(356342,9899,'ba','Baru saja diubah atau ditambahkan',0),(356343,9899,'nl','Recent gewijzigde of toegevoegde',0),(356344,9899,'fi','Ã„skettÃ¤in muutettu tai lisÃ¤tÃ¤',0),(356345,9899,'no','Sist endret eller lagt til',0),(356346,9899,'da','For nylig Ã¦ndret eller tilfÃ¸jet',0),(356347,9899,'ko','ìµœê·¼ ìˆ˜ì • ë˜ëŠ” ì¶”ê°€',0),(356348,9899,'he','×œ××—×¨×•× ×” ×©×•× ×” ××• × ×•×¡×¤×ª',0),(356349,9899,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î± Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î± Î® Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ',0),(356350,9899,'zh','æœ€è¿‘ä¿®æ”¹æˆ–æ·»åŠ \r\n',0),(356351,9899,'sv','Nyligen Ã¤ndrad eller tillagd',0),(356352,9899,'it','Recentemente modificato o aggiunto',0),(356353,9899,'tl','',0),(356354,9899,'th','&#3649;&#3585;&#3657;&#3652;&#3586;&#3627;&#3619;&#3639;&#3629;&#3648;&#3614;&#3636;&#3656;&#3617;',0),(356355,9899,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤¯à¤¾ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(356356,9899,'ms','Tempahan diubahsuai atau ditambah',0),(356357,9899,'ar','Ø§Ù„Ù…Ø¹Ø¯Ù„Ø© Ø£Ùˆ Ø§Ù„Ù…Ø¶Ø§ÙØ© Ø­Ø¯ÙŠØ«Ø§',0),(356358,9899,'fr','RÃ©cemment modifiÃ©es ou ajoutÃ©es',0),(356359,9899,'jp','æœ€è¿‘å¤‰æ›´ã¾ãŸã¯è¿½åŠ ',0),(356360,9899,'pt','Recentemente adicionado ou modificado',0),(356361,9899,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð½Ñ‹Ðµ Ð˜Ð»Ð¸ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ',0),(356362,9899,'es','Recientemente Modificado o Agregado',0),(356363,9899,'de','KÃ¼rzlich geÃ¤nderte oder zusÃ¤tzliche',0),(356364,9899,'en','Recently Modified Or Added',0),(356365,9900,'is','',0),(356366,9900,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§ÙŠ Ù‡Ù…Ø²Ù…Ø§Ù† Ø³Ø§Ø²ÙŠ',0),(356367,9900,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§ÙŠ Ù‡Ù…Ø²Ù…Ø§Ù† Ø³Ø§Ø²ÙŠ',0),(356368,9900,'tr','EÅŸitleme VarsayÄ±lanlarÄ±',0),(356369,9900,'pl','DomyÅ›lne ustawienia synchronizacji',0),(356370,9900,'bg','Ð¡Ð¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸Ñ‚Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(356371,9900,'ur','ÛÙ… ÙˆÙ‚Øª Ø³Ø§Ø²ÛŒ Ø·Û’ Ø´Ø¯Û',0),(356372,9900,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ ÑÐ¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ðµ',0),(356373,9900,'vi','Ä‘á»“ng bá»™ hÃ³a máº·c Ä‘á»‹nh',0),(356374,9900,'af','Sinchronisasie verstekke',0),(356375,9900,'ro','Sincronizarea implicit',0),(356376,9900,'et','SÃ¼nkroonimise vaikesÃ¤tted',0),(356377,9900,'si','Privzete nastavitve sinhronizacije',0),(356378,9900,'ba','Sinkronisasi default',0),(356379,9900,'nl','Standaardinstellingen voor synchronisatie',0),(356380,9900,'fi','Synkronointi oletukset',0),(356381,9900,'no','Synkronisering standarder',0),(356382,9900,'da','Synkronisering misligholdelser',0),(356383,9900,'ko','ë™ê¸°í™” ê¸°ë³¸ê°’',0),(356384,9900,'he','×¡×™× ×›×¨×•×Ÿ ×‘×¨×™×¨×•×ª ×ž×—×“×œ',0),(356385,9900,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ ÏƒÏ…Î³Ï‡ÏÎ¿Î½Î¹ÏƒÎ¼Î¿Ï',0),(356386,9900,'zh','é»˜è®¤åŒæ­¥\r\n',0),(356387,9900,'sv','Synkronisering Defaults',0),(356388,9900,'it','Impostazioni predefinite di sincronizzazione',0),(356389,9900,'tl','',0),(356390,9900,'th','&#3588;&#3656;&#3634;&#3648;&#3619;&#3636;&#3656;&#3617;&#3605;&#3657;&#3609;&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3626;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;',0),(356391,9900,'hi','à¤¸à¤¿à¤‚à¤•à¥à¤°à¤¨à¤¾à¤‡à¤œà¤¼à¥‡à¤¶à¤¨ à¤šà¥‚à¤•',0),(356392,9900,'ms','Penyegerakan lalai',0),(356393,9900,'ar','Ø§ÙØªØ±Ø§Ø¶ÙŠØ§Øª Ø§Ù„Ù…Ø²Ø§Ù…Ù†Ø©',0),(356394,9900,'fr','Synchronisation par dÃ©faut',0),(356395,9900,'jp','åŒæœŸã®æ—¢å®šå€¤',0),(356396,9900,'pt','PadrÃµes de sincronizaÃ§Ã£o',0),(356397,9900,'ru','Ð¡Ð¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(356398,9900,'es','Sincronizaciones Predeterminadas',0),(356399,9900,'de','Synchronisierung Standardwerte',0),(356400,9900,'en','Synchronization Defaults',0),(356401,9901,'is','',0),(356402,9901,'dr','Ù‡Ù…Ø²Ù…Ø§Ù† Ø³Ø§Ø²ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(356403,9901,'pr','Ù‡Ù…Ø²Ù…Ø§Ù† Ø³Ø§Ø²ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(356404,9901,'tr','EÅŸitleme Ã¶ÄŸeleri',0),(356405,9901,'pl','Synchronizacja elementÃ³w',0),(356406,9901,'bg','Ð¡Ð¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(356407,9901,'ur','ÛÙ… ÙˆÙ‚Øª Ø³Ø§Ø²ÛŒ Ø§Ø´ÛŒØ§',0),(356408,9901,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð·Ð° ÑÐ¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(356409,9901,'vi','Äá»“ng bá»™ hÃ³a cÃ¡c máº·t hÃ ng',0),(356410,9901,'af','Sinchro Items',0),(356411,9901,'ro','Elemente de sincronizare',0),(356412,9901,'et','SÃ¼nkrooni Ã¼ksused',0),(356413,9901,'si','Sinhronizacija elementov',0),(356414,9901,'ba','Sinkronisasi item',0),(356415,9901,'nl','Sync Items',0),(356416,9901,'fi','Synkronoi kohteet',0),(356417,9901,'no','Synkronisere objekter',0),(356418,9901,'da','Sync elementer',0),(356419,9901,'ko','ë™ê¸°í™” í•­ëª©',0),(356420,9901,'he','×¡×™× ×›×¨×•×Ÿ ×”×¤×¨×™×˜×™×',0),(356421,9901,'el','Î‘Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î± ÏƒÏ…Î³Ï‡ÏÎ¿Î½Î¹ÏƒÎ¼Î¿Ï',0),(356422,9901,'zh','åŒæ­¥é¡¹ç›®\r\n',0),(356423,9901,'sv','Synkronisera objekt',0),(356424,9901,'it','Elementi da sincronizzare',0),(356425,9901,'tl','',0),(356426,9901,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3626;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;',0),(356427,9901,'hi','à¤¸à¤¿à¤‚à¤•à¥à¤°à¤¨à¤¾à¤‡à¤œà¤¼à¥‡à¤¶à¤¨ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(356428,9901,'ms','Segerakkan item',0),(356429,9901,'ar','Ù…Ø²Ø§Ù…Ù†Ø© Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(356430,9901,'fr','Ã‰lÃ©ments de synchronisation',0),(356431,9901,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã‚’åŒæœŸã—ã¾ã™ã€‚',0),(356432,9901,'pt','Itens de sincronizaÃ§Ã£o',0),(356433,9901,'ru','Ð¡Ð¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(356434,9901,'es','Items de SincronizaciÃ³n',0),(356435,9901,'de','Sync-Elemente',0),(356436,9901,'en','Sync Items',0),(356437,9902,'is','',0),(356438,9902,'dr','Ù‡Ù…Ø²Ù…Ø§Ù† Ø³Ø§Ø²ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ú¯ÙˆÚ¯Ù„',0),(356439,9902,'pr','Ù‡Ù…Ø²Ù…Ø§Ù† Ø³Ø§Ø²ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ú¯ÙˆÚ¯Ù„',0),(356440,9902,'tr','Google Base ile eÅŸitleme Ã¶ÄŸeleri',0),(356441,9902,'pl','Synchronizowanie elementÃ³w z Google Base',0),(356442,9902,'bg','Ð¡Ð¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ñ Google Ð¾ÑÐ½Ð¾Ð²Ð°',0),(356443,9902,'ur','Google Ú©Û’ Ø³Ø§ØªÚ¾ ÛÙ… ÙˆÙ‚Øª Ø³Ø§Ø²ÛŒ Ø§Ø´ÛŒØ§',0),(356444,9902,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð·Ð° ÑÐ¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ñƒ ÑÐ° Ð“Ð¾Ð¾Ð³Ð»Ðµ Ð±Ð°Ð·Ðµ',0),(356445,9902,'vi','Äá»“ng bá»™ cÃ¡c máº·t hÃ ng vá»›i cÆ¡ sá»Ÿ google',0),(356446,9902,'af','Sinchro Items met Google basis',0),(356447,9902,'ro','Elemente de sincronizare cu Google Base',0),(356448,9902,'et','Google Base SÃ¼nkrooni Ã¼ksused',0),(356449,9902,'si','Sinhronizacija elementov z Google Base',0),(356450,9902,'ba','Item sinkronisasi dengan Google Base',0),(356451,9902,'nl','Sync onderdelen met Google Base',0),(356452,9902,'fi','Synkronoi kohteet Google Base',0),(356453,9902,'no','Synkronisere objekter med Google Base',0),(356454,9902,'da','Sync elementer med Google Base',0),(356455,9902,'ko','Google Base í•­ëª© ë™ê¸°í™”',0),(356456,9902,'he','×¡×™× ×›×¨×•×Ÿ ×”×¤×¨×™×˜×™× ×¢× Google Base',0),(356457,9902,'el','Î‘Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î± ÏƒÏ…Î³Ï‡ÏÎ¿Î½Î¹ÏƒÎ¼Î¿Ï Î¼Îµ Î²Î¬ÏƒÎ· Google',0),(356458,9902,'zh','ä¸Žè°·æ­Œåº“åŒæ­¥çš„é¡¹ç›®\r\n',0),(356459,9902,'sv','Synkronisera objekt med Google Base',0),(356460,9902,'it','Elementi da sincronizzare con Google Base',0),(356461,9902,'tl','',0),(356462,9902,'th','&#3585;&#3634;&#3619;&#3611;&#3619;&#3632;&#3626;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3600;&#3634;&#3609;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3',0),(356463,9902,'hi','à¤—à¥‚à¤—à¤² à¤•à¥‹à¤· à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤¿à¤‚à¤•à¥à¤°à¤¨à¤¾à¤‡à¤œà¤¼à¥‡à¤¶à¤¨ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(356464,9902,'ms','Segerakkan item dengan Google',0),(356465,9902,'ar','Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…Ø²Ø§Ù…Ù†Ø© Ù…Ø¹ Ù‚Ø§Ø¹Ø¯Ø© Ø¬ÙˆØ¬Ù„',0),(356466,9902,'fr','Ã‰lÃ©ments de synchronisation avec Google Base',0),(356467,9902,'jp','Google Base ã®ã‚¢ã‚¤ãƒ†ãƒ ã‚’åŒæœŸã—ã¾ã™ã€‚',0),(356468,9902,'pt','Itens de sincronizaÃ§Ã£o com o Google Base',0),(356469,9902,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÑÐ¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ñ Google Base',0),(356470,9902,'es','Items de SincronizaciÃ³n co el Base de Google',0),(356471,9902,'de','Elemente der Sync mit Google Base',0),(356472,9902,'en','Sync Items With Google Base',0),(356473,9903,'is','',0),(356474,9903,'dr','Ù„Ø·ÙØ§ Ø¯Ø± Ø­Ø³Ø§Ø¨ Ù…Ø¨Ù†Ø§ÙŠ Ø®ÙˆØ¯ Ø¯Ø± Ø³Ø§ÙŠØª Ú¯ÙˆÚ¯Ù„  Ø«Ø¨Øª Ù†Ø§Ù…  ÙƒÙ†ÙŠØ¯',0),(356475,9903,'pr','Ù„Ø·ÙØ§ Ø¯Ø± Ø­Ø³Ø§Ø¨ Ù…Ø¨Ù†Ø§ÙŠ Ø®ÙˆØ¯ Ø¯Ø± Ø³Ø§ÙŠØª Ú¯ÙˆÚ¯Ù„  Ø«Ø¨Øª Ù†Ø§Ù…  ÙƒÙ†ÙŠØ¯',0),(356476,9903,'tr','LÃ¼tfen, Google Base hesabÄ±nÄ±za oturum aÃ§Ä±n',0),(356477,9903,'pl','Zaloguj siÄ™ na swoje konto Google Base',0),(356478,9903,'bg','ÐœÐ¾Ð»Ñ, Ð²Ð»ÐµÐ·Ñ‚Ðµ Ð² Ð¿Ñ€Ð¾Ñ„Ð¸Ð»Ð° ÑÐ¸ Ð² Google Base',0),(356479,9903,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¢Ù¾ Ø¨ÛŒØ³ Google Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…ÛŒÚº Ø³Ø§Ø¦Ù†',0),(356480,9903,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° ÑÐµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð° Ð²Ð°Ñˆ Ñ€Ð°Ñ‡ÑƒÐ½ Ð·Ð° Ð“Ð¾Ð¾Ð³Ð»Ðµ Ð±Ð°Ð·Ðµ',0),(356481,9903,'vi','vui lÃ²ng Ä‘Äƒng nháº­p vÃ o tÃ i khoáº£n google ',0),(356482,9903,'af','Teken asseblief in in u Google Base Rekening',0),(356483,9903,'ro','VÄƒ rugÄƒm sÄƒ faceÅ£i Sign In la contul Google Base',0),(356484,9903,'et','Palun logige sisse kontole Google Base',0),(356485,9903,'si','Prosim prijavite se raÄun Google Base',0),(356486,9903,'ba','Harap masuk ke akun Google Base Anda',0),(356487,9903,'nl','Gelieve aan te melden bij uw Account van Google Base',0),(356488,9903,'fi','Kirjaudu Google Base-tilin',0),(356489,9903,'no','Logg pÃ¥ kontoen din Google Base',0),(356490,9903,'da','Log ind pÃ¥ din Google Base-konto',0),(356491,9903,'ko','Google Base ê³„ì • ë¡œê·¸ì¸ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(356492,9903,'he','× × ×”×™×›× ×¡ ×œ×—×©×‘×•×Ÿ ×©×œ×š ×‘- Google Base',0),(356493,9903,'el','Î£Ï…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ ÏƒÏ„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÎ±Ï‚ Google Î²Î¬ÏƒÎ·',0),(356494,9903,'zh','è¯·ç™»å½•åˆ°æ­¤è¯æ˜Žè¡¨ï¼Œå¹¶å°†å…¶è¿”å›žåˆ°æ‚¨çš„Google Baseå¸æˆ·\r\n',0),(356495,9903,'sv','VÃ¤nligen logga In pÃ¥ ditt Google Base-konto',0),(356496,9903,'it','Per favore accedi al tuo Account di Google Base',0),(356497,9903,'tl','',0),(356498,9903,'th','&#3585;&#3619;&#3640;&#3603;&#3634;&#3621;&#3591;&#3594;&#3639;&#3656;&#3629;&#3648;&#3586;&#3657;&#3634;&#3610;&#3633;&#3597;&#3594;&#3637;&#3585;&#3641;&#3621;&#3648;&#3585;&#3636;&#3657;&#3621;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(356499,9903,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤ªà¤¨à¥‡ à¤—à¥‚à¤—à¤² à¤•à¥‹à¤· à¤–à¤¾à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(356500,9903,'ms','Sila Daftar Masuk ke akaun Google Base',0),(356501,9903,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø¥Ù„Ù‰ Ø­Ø³Ø§Ø¨Ùƒ ÙÙŠ Ù‚Ø§Ø¹Ø¯Ø© Ø¬ÙˆØ¬Ù„',0),(356502,9903,'fr','Sâ€™il vous plaÃ®t vous connecter Ã  votre compte Google Base',0),(356503,9903,'jp','ã‚ãªãŸã® Google ãƒ™ãƒ¼ã‚¹ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã«ã‚µã‚¤ãƒ³ã‚¤ãƒ³ã—ã¦ãã ã•ã„ã€‚',0),(356504,9903,'pt','Por favor, entre sua conta Google Base',0),(356505,9903,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð¾Ð¹Ð´Ð¸Ñ‚Ðµ Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚ Google Base',0),(356506,9903,'es','Por Favor Login a su Cuenta Base de Google',0),(356507,9903,'de','Melden Sie sich bei Ihrem Konto Google Base',0),(356508,9903,'en','Please Sign In To Your Google Base Account',0),(356509,9904,'is','',0),(356510,9904,'dr','. Ø§ØµÙ„Ø§Ø­  ØªØ§ÙŠÙŠØ¯ Ø§Ø² Ù‚Ø¨Ù„ Ø±Ø§ Ù„ØºÙˆ Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯',0),(356511,9904,'pr','Ø§ÙŠÙ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø§Ø² Ù‚Ø¨Ù„ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª . ÙˆÙŠØ±Ø§ÙŠØ´ ØªØ§ÙŠÙŠØ¯ Ø§Ø² Ù‚Ø¨Ù„ Ø±Ø§ Ù„ØºÙˆ Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯',0),(356512,9904,'tr','Bu tasarÄ±nÄ±n Ã¶nceden onaylanmÄ±ÅŸ oldu. DÃ¼zenleme Ã¶n onayÄ± iptal eder.',0),(356513,9904,'pl','Ustawa ta zostaÅ‚a wstÄ™pnie zatwierdzone. Edycji bÄ™dzie anulowaÄ‡ wstÄ™pnÄ… akceptacjÄ™.',0),(356514,9904,'bg','Ð¢Ð¾Ð·Ð¸ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ðµ Ð±Ð¸Ð» Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½. Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ñ‰Ðµ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ.',0),(356515,9904,'ur','Ø§Ø³ Ø¨Ù„ Ú©ÛŒ Ù¾ÛÙ„Û’ Ø³Û’ Ù…Ù†Ø¸ÙˆØ± Ø´Ø¯Û Ø±ÛØ§ ÛÛ’ Û” ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù¾ÛÙ„Û’ Ø³Û’ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ù…Ù†Ø³ÙˆØ® ÛÙˆ Ø¬Ø§Ø¦ÛŒÚº Ú¯ÛŒ Û”',0),(356516,9904,'sr','ÐžÐ²Ð°Ñ˜ Ð·Ð°ÐºÐ¾Ð½ Ñ˜Ðµ Ð±Ð¸Ð¾ Ð¿Ñ€ÐµÐ»Ð¸Ð¼Ð¸Ð½Ð°Ñ€Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ…. Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ›Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´-Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ.',0),(356517,9904,'vi','CÃ¡i bill nÃ y sáº½ Ä‘Æ°á»£c phÃª duyá»‡t trÆ°á»›c. Viá»‡c sá»­a/thÃªm sáº½ há»§y viá»‡c phÃª duyá»‡t trÆ°á»›c',0),(356518,9904,'af','Hierdie rekening is vooraf-goedgekeur.  Redigering sal vooraf-goedkeuring kanseleer.',0),(356519,9904,'ro','Acest proiect de lege a fost pre-aprobate. Editare va anula pre-aprobare.',0),(356520,9904,'et','See seaduseelnÃµu on eelnevalt heaks kiidetud. Redigeerimise tÃ¼histab eelneva nÃµusoleku.',0),(356521,9904,'si','Ta raÄun je bil predhodno odobrene. Urejanje, boste preklicali predhodne odobritve.',0),(356522,9904,'ba','RUU ini sudah pra-disetujui. Mengedit akan membatalkan pra-persetujuan.',0),(356523,9904,'nl','Dit wetsvoorstel is vooraf geselecteerde bieders. Bewerken, zal pre-Goedkeuring annuleren.',0),(356524,9904,'fi','TÃ¤mÃ¤ lakiesitys on pre-hyvÃ¤ksytty. Muokkaaminen peruuttaa ennakkohyvÃ¤ksyntÃ¤.',0),(356525,9904,'no','Dette lovforslaget har vÃ¦rt pre-godkjent. Redigering vil avbryte forhÃ¥ndsgodkjenning.',0),(356526,9904,'da','Dette lovforslag er blevet forhÃ¥ndsgodkendt. Redigering vil annullere forhÃ¥ndsgodkendelse.',0),(356527,9904,'ko','ì´ ë²•ì•ˆì€ ì‚¬ì „ ìŠ¹ì¸ ë˜ì—ˆìŠµë‹ˆë‹¤. íŽ¸ì§‘ í•˜ëŠ” ê²ƒì€ ì‚¬ì „ ìŠ¹ì¸ ì·¨ì†Œ ë©ë‹ˆë‹¤.',0),(356528,9904,'he','×”×¦×¢×ª ×”×—×•×§ ×›×‘×¨ ×ž××•×©×¨×•×ª ×ž×¨××©. ×¢×¨×™×›×ª ×™×‘×˜×œ ××™×©×•×¨ ×ž×¨××©.',0),(356529,9904,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Î­Ï‡ÎµÎ¹ Ï€ÏÎ¿-ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯. Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¸Î± Î±ÎºÏ…ÏÏŽÏƒÎµÎ¹ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ·.',0),(356530,9904,'zh','è¿™é¡¹æ³•æ¡ˆå·²é¢„å…ˆæ ¸å‡†ã€‚ç¼–è¾‘å°†å–æ¶ˆé¢„å…ˆæ ¸å‡†ã€‚\r\n',0),(356531,9904,'sv','Detta lagfÃ¶rslag har varit lÃ¥nelÃ¶fte. Redigera avbryts fÃ¶re godkÃ¤nnande.',0),(356532,9904,'it','Questo disegno di legge Ã¨ stato pre-approvato. Modifica annullerÃ  pre-approvazione.',0),(356533,9904,'tl','',0),(356534,9904,'th','&#3651;&#3610;&#3648;&#3626;&#3619;&#3655;&#3592;&#3609;&#3637;&#3657;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3619;&#3633;&#3610;&#3619;&#3629;&#3591;&#3621;&#3656;&#3623;&#3591;&#3627;&#3609;&#3657;&#3634;. &#3592;&#3632;&#3649;&',0),(356535,9904,'hi','à¤¯à¤¹ à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤ªà¥‚à¤°à¥à¤µ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨-à¤ªà¥‚à¤°à¥à¤µ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤°à¤¦à¥à¤¦ à¤¹à¥‹ à¤œà¤¾à¤à¤—à¤¾à¥¤',0),(356536,9904,'ms','Rang undang-undang ini telah diluluskan terlebih dahulu. Penyuntingan akan membatalkan kelulusan pra.',0),(356537,9904,'ar','ÙˆÙ…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ù‡Ø°Ø§ Ù‚Ø¯ Ø³Ø¨Ù‚Øª Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„ÙŠÙ‡Ø§. ØªØ­Ø±ÙŠØ± Ø³ÙŠØªÙ… Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø§Ù„Ù…Ø³Ø¨Ù‚Ø©.',0),(356538,9904,'fr','Ce projet de loi a Ã©tÃ© prÃ©-approuvÃ©. Ã‰dition annule une approbation prÃ©alable.',0),(356539,9904,'jp','ã“ã®æ³•æ¡ˆã¯ã€äº‹å‰æ‰¿èªã•ã‚Œã¦ã„ã¾ã™ã€‚ç·¨é›†ã™ã‚‹ã¨ã€äº‹å‰æ‰¿èªãŒã‚­ãƒ£ãƒ³ã‚»ãƒ«ã•ã‚Œã¾ã™ã€‚',0),(356540,9904,'pt','Este projeto tem sido pre-aprovado. EdiÃ§Ã£o irÃ¡ cancelar a prÃ©-aprovaÃ§Ã£o.',0),(356541,9904,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð±Ñ‹Ð» Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½. Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð±ÑƒÐ´ÐµÑ‚ Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ.',0),(356542,9904,'es','Este Recibo se ha Aprobado Previamente',0),(356543,9904,'de','Dieses Gesetz wurde genehmigt. Bearbeiten stornieren Vorabgenehmigung.',0),(356544,9904,'en','This bill has been pre-approved. Editing will cancel pre-approval.',0),(356545,9905,'is','',0),(356546,9905,'dr','ØªØºÙŠÙŠØ± Ú¯Ø±ÙˆÙ‡ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø¨Ù‡ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§',0),(356547,9905,'pr','ØªØºÙŠÙŠØ± Ú¯Ø±ÙˆÙ‡ ØªØ¹ÙŠÙŠÙ† Ø´Ø¯Ù‡ Ø¨Ù‡ Ø§ÙŠÙ† ÙƒØ§Ù„Ø§',0),(356548,9905,'tr','Bu Ã¶ÄŸeye atanan Kategori deÄŸiÅŸtirmek',0),(356549,9905,'pl','ZmieÅ„ kategoriÄ™ przypisany do tego elementu',0),(356550,9905,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ, Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(356551,9905,'ur','Ø§Ø³ Ø´Û’ Ú©Ùˆ ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û Ø²Ù…Ø±Û ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(356552,9905,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð´Ð¾Ð´ÐµÑ™ÐµÐ½Ð¾ Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(356553,9905,'vi','Thay Ä‘á»•i chá»‰ Ä‘á»‹nh Ä‘á» má»¥c nÃ y',0),(356554,9905,'af','Verander Kategorie Toegeskryf Na Hierdie Item',0),(356555,9905,'ro','Schimbare categorie atribuit acest element',0),(356556,9905,'et','Sellele Ã¼ksusele mÃ¤Ã¤ratud kategooriat muuta',0),(356557,9905,'si','Spreminjanje zvrsti, dodeljene temu elementu',0),(356558,9905,'ba','Mengubah kategori yang ditetapkan untuk Item ini',0),(356559,9905,'nl','Categorie die is toegewezen aan dit Item wijzigen',0),(356560,9905,'fi','Muuta luokka tÃ¤lle kohteelle mÃ¤Ã¤ritetyn',0),(356561,9905,'no','Endre kategori tilordnet til dette elementet',0),(356562,9905,'da','Ã†ndring af kategori tildelt dette element',0),(356563,9905,'ko','ì´ í•­ëª©ì— í• ë‹¹ ëœ ë²”ì£¼ ë³€ê²½',0),(356564,9905,'he','×œ×©× ×•×ª ××ª ×”×§×˜×’×•×¨×™×” ×©×”×•×§×¦×• ×œ×¤×¨×™×˜ ×–×”',0),(356565,9905,'el','Î‘Î»Î»Î±Î³Î® ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚ Ï€Î¿Ï… Î­Ï‡ÎµÎ¹ Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¹ÏƒÏ„ÎµÎ¯ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(356566,9905,'zh','æ›´æ”¹ç›®å½•åˆ†é…ç»™è¿™ä¸ªé¡¹ç›®\r\n',0),(356567,9905,'sv','Ã„ndra kategori tilldelats denna artikel',0),(356568,9905,'it','Cambia categoria assegnata a questo elemento',0),(356569,9905,'tl','',0),(356570,9905,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3607;&#3637;&#3656;&#3585;&#3635;&#3627;&#3609;&#3604;&#3652;&#3623;&#3657;&#3651;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3609;&#3637;&#3',0),(356571,9905,'hi','à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¥€ à¤—à¤ˆ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(356572,9905,'ms','Mengubah kategori yang ditugaskan untuk Item ini',0),(356573,9905,'ar','ØªØºÙŠÙŠØ± Ø§Ù„ØªØµÙ†ÙŠÙ Ø§Ù„Ù…Ø­Ø¯Ù‘Ø¯ Ù„Ù‡Ø°Ø§ Ø§Ù„ØµÙ†Ù',0),(356574,9905,'fr','Changer la catÃ©gorie assignÃ©e Ã  ce point',0),(356575,9905,'jp','ã“ã®ã‚¢ã‚¤ãƒ†ãƒ ã«å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ã‚‹ã‚«ãƒ†ã‚´ãƒªã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(356576,9905,'pt','Alterar a categoria atribuÃ­da a este Item',0),(356577,9905,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸, Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ ÑÑ‚Ð¾Ð¼Ñƒ Ð¿ÑƒÐ½ÐºÑ‚Ñƒ',0),(356578,9905,'es','Cambia la CategorÃ­a Asignada a Este Item',0),(356579,9905,'de','Ã„ndern Sie diesem Element zugewiesenen Kategorie',0),(356580,9905,'en','Change Category Assigned To This Item',0),(356581,9906,'is','',0),(356582,9906,'dr','ØªØºÙŠÙŠØ± ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ú¯Ø±ÙˆÙ‡',0),(356583,9906,'pr','ØªØºÙŠÙŠØ± ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ú¯Ø±ÙˆÙ‡',0),(356584,9906,'tr','Kategori ile Ã¶ÄŸelerini DeÄŸiÅŸtir',0),(356585,9906,'pl','ZmieÅ„ elementy z Kategoria',0),(356586,9906,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð¾Ð±ÐµÐºÑ‚Ð¸ Ñ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(356587,9906,'ur','Ø²Ù…Ø±Û Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù† Ø§Ø´ÛŒØ§Ø¡ Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„',0),(356588,9906,'sr','ÐœÐµÑšÐ°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸ ÑÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¾Ð¼',0),(356589,9906,'vi','Thay Ä‘á»•i má»¥c Vá»›i loáº¡i',0),(356590,9906,'af','Verander Items Met Kategorie',0),(356591,9906,'ro','Elemente de schimbare cu categoria',0),(356592,9906,'et','Muuta kaupade kategooria',0),(356593,9906,'si','Spreminjanje elementov s kategorijo',0),(356594,9906,'ba','Mengubah item dengan kategori',0),(356595,9906,'nl','Items met een categorie wijzigen',0),(356596,9906,'fi','Muuttaa luokka',0),(356597,9906,'no','Endre elementer med kategori',0),(356598,9906,'da','Ã†ndre emner med kategori',0),(356599,9906,'ko','ì¹´í…Œê³ ë¦¬ì™€ í•­ëª© ë³€ê²½',0),(356600,9906,'he','×œ×©× ×•×ª ××ª ×”×¤×¨×™×˜×™× ×¢× ×”×§×˜×’×•×¨×™×”',0),(356601,9906,'el','Î‘Î»Î»Î±Î³Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î¼Îµ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(356602,9906,'zh','éšç€ç±»åˆ«çš„æ›´æ”¹é¡¹ç›®\r\n',0),(356603,9906,'sv','Ã„ndra objekt med kategori',0),(356604,9906,'it','Modificare oggetti con categoria',0),(356605,9906,'tl','',0),(356606,9906,'th','&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3585;&#3633;&#3610;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(356607,9906,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(356608,9906,'ms','Menukar item dengan kategori',0),(356609,9906,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø¹Ù†Ø§ØµØ± Ù…Ø¹ Ø§Ù„ÙØ¦Ø©',0),(356610,9906,'fr','Modifier les rubriques par catÃ©gorie',0),(356611,9906,'jp','ã‚«ãƒ†ã‚´ãƒªã§é …ç›®ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(356612,9906,'pt','Alterar os itens com categoria',0),(356613,9906,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ñ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÐµÐ¹',0),(356614,9906,'es','Cambia Items Con CategorÃ­a',0),(356615,9906,'de','Artikel Kategorie Ã¤ndern',0),(356616,9906,'en','Change Items With Category',0),(356617,9907,'is','',0),(356618,9907,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ Ù…Ø±ØªØ¨Ø· Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(356619,9907,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ Ù…Ø±ØªØ¨Ø· Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(356620,9907,'tr','Bu kategoriyle iliÅŸkili Ã¶ÄŸeleri',0),(356621,9907,'pl','Elementy zwiÄ…zane z tej kategorii',0),(356622,9907,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, ÑÐ²ÑŠÑ€Ð·Ð°Ð½Ð¸ Ñ Ñ‚Ð°Ð·Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(356623,9907,'ur','Ø§Ø³ Ø²Ù…Ø±Û Ú©Û’ Ø³Ø§ØªÚ¾ ÙˆØ§Ø¨Ø³ØªÛ Ø§Ø´ÛŒØ§Ø¡',0),(356624,9907,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð¿Ð¾Ð²ÐµÐ·Ð°Ð½Ðµ ÑÐ° Ð¾Ð²Ð¾Ð¼ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¾Ð¼',0),(356625,9907,'vi','CÃ¡c má»¥c Ä‘Æ°á»£c liÃªn káº¿t trong nÃ y',0),(356626,9907,'af','Items Geassosieer Met Hierdie Kategorie',0),(356627,9907,'ro','Elemente asociate cu aceastÄƒ categorie',0),(356628,9907,'et','Selle kategooriaga seotud tooted',0),(356629,9907,'si','Postavke, povezane s to kategorijo',0),(356630,9907,'ba','Barang-barang yang berhubungan dengan kategori ini',0),(356631,9907,'nl','Objecten die zijn gekoppeld aan deze categorie',0),(356632,9907,'fi','LiittyvÃ¤t tÃ¤hÃ¤n luokkaan',0),(356633,9907,'no','Elementer knyttet til denne kategorien',0),(356634,9907,'da','Elementer tilknyttet denne kategori',0),(356635,9907,'ko','ì´ ë¶„ë¥˜ì™€ ê´€ë ¨ ëœ í•­ëª©',0),(356636,9907,'he','×”×¤×¨×™×˜×™× ×”×ž×©×•×™×›×™× ×‘×§×˜×’×•×¨×™×” ×–×•',0),(356637,9907,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… ÏƒÏ‡ÎµÏ„Î¯Î¶Î¿Î½Ï„Î±Î¹ Î¼Îµ Î±Ï…Ï„Î® Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(356638,9907,'zh','ä¸Žæ­¤ç›¸å…³çš„é¡¹ç›®ç±»åˆ«\r\n',0),(356639,9907,'sv','Element som associeras med denna kategori',0),(356640,9907,'it','Elementi associati a questa categoria',0),(356641,9907,'tl','',0),(356642,9907,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3607;&#3637;&#3656;&#3648;&#3585;&#3637;&#3656;&#3618;&#3623;&#3586;&#3657;&#3629;&#3591;&#3585;&#3633;&#3610;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;&#3609;&#3637;&#3',0),(356643,9907,'hi','à¤‡à¤¸ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤‚à¤¬à¤¦à¥à¤§ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(356644,9907,'ms','Item-item yang berkaitan dengan kategori ini',0),(356645,9907,'ar','Ø§Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø±ØªØ¨Ø·Ø© Ù…Ø¹ Ù‡Ø°Ø§ Ø§Ù„ØªØµÙ†ÙŠÙ',0),(356646,9907,'fr','Ã‰lÃ©ments associÃ©s Ã  cette catÃ©gorie',0),(356647,9907,'jp','ã“ã®ã‚«ãƒ†ã‚´ãƒªã«é–¢é€£ä»˜ã‘ã‚‰ã‚Œã¦ã„ã‚‹é …ç›®',0),(356648,9907,'pt','Itens associados a esta categoria',0),(356649,9907,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹, ÑÐ²ÑÐ·Ð°Ð½Ð½Ñ‹Ðµ Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÐµÐ¹',0),(356650,9907,'es','Items Asociados Con Este CategorÃ­a',0),(356651,9907,'de','Elemente dieser Kategorie zugeordnet',0),(356652,9907,'en','Items Associated With This Category',0),(356653,9908,'is','',0),(356654,9908,'dr','(Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ',0),(356655,9908,'pr','Ø­Ø±ÙƒØª (Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ',0),(356656,9908,'tr','Hareket',0),(356657,9908,'pl','PrzenieÅ›Ä‡',0),(356658,9908,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸',0),(356659,9908,'ur','Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(356660,9908,'sr','ÐŸÐ¾Ñ‚ÐµÐ·',0),(356661,9908,'vi','chuyá»ƒn',0),(356662,9908,'af','Skuif',0),(356663,9908,'ro','Muta',0),(356664,9908,'et','Liikuda',0),(356665,9908,'si','Premikanje',0),(356666,9908,'ba','Bergerak',0),(356667,9908,'nl','Verplaatsen',0),(356668,9908,'fi','SiirrÃ¤',0),(356669,9908,'no','Flytte',0),(356670,9908,'da','Flytte',0),(356671,9908,'ko','ì´ë™',0),(356672,9908,'he','×ž×”×œ×š',0),(356673,9908,'el','ÎšÎ¯Î½Î·ÏƒÎ·',0),(356674,9908,'zh','ç§»åŠ¨\r\n',0),(356675,9908,'sv','Flytta',0),(356676,9908,'it','Spostare',0),(356677,9908,'tl','',0),(356678,9908,'th','&#3648;&#3588;&#3621;&#3639;&#3629;&#3609;&#3618;&#3657;&#3634;&#3618;',0),(356679,9908,'hi','à¤²à¥‡ à¤œà¤¾à¤à¤',0),(356680,9908,'ms','Langkah',0),(356681,9908,'ar','Ù†Ù‚Ù„',0),(356682,9908,'fr','Se dÃ©placer',0),(356683,9908,'jp','ç§»å‹•',0),(356684,9908,'pt','Mover-se',0),(356685,9908,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ',0),(356686,9908,'es','Mover',0),(356687,9908,'de','Bewegen',0),(356688,9908,'en','Move',0),(356689,9909,'is','',0),(356690,9909,'dr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ ',0),(356691,9909,'pr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ú¯Ø±ÙˆÙ‡ ',0),(356692,9909,'tr','Bu kategori iÃ§in',0),(356693,9909,'pl','Do tej kategorii',0),(356694,9909,'bg','ÐšÑŠÐ¼ Ñ‚Ð°Ð·Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(356695,9909,'ur','Ø§Ø³ Ø²Ù…Ø±Û’ Ú©Û’ Ù„Ø¦Û’',0),(356696,9909,'sr','Ð£ Ð¾Ð²Ð¾Ñ˜ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸',0),(356697,9909,'vi','Äáº¿n máº·t hÃ ng nÃ y',0),(356698,9909,'af','Na Hierdie Kategorie',0),(356699,9909,'ro','ÃŽn aceastÄƒ categorie',0),(356700,9909,'et','Sellesse kategooriasse',0),(356701,9909,'si','V to kategorijo',0),(356702,9909,'ba','Kategori ini',0),(356703,9909,'nl','Tot deze categorie',0),(356704,9909,'fi','TÃ¤hÃ¤n luokkaan',0),(356705,9909,'no','Til denne kategorien',0),(356706,9909,'da','Til denne kategori',0),(356707,9909,'ko','ì´ ë²”ì£¼ì—',0),(356708,9909,'he','×‘×§×˜×’×•×¨×™×” ×–×•',0),(356709,9909,'el','Î£Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(356710,9909,'zh','è¿™ä¸ªç±»åˆ«\r\n',0),(356711,9909,'sv','Till denna kategori',0),(356712,9909,'it','A questa categoria',0),(356713,9909,'tl','',0),(356714,9909,'th','&#3648;&#3614;&#3639;&#3656;&#3629;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3609;&#3637;&#3657;',0),(356715,9909,'hi','à¤‡à¤¸ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(356716,9909,'ms','Kategori ini',0),(356717,9909,'ar','Ù„Ù‡Ø°Ø§ Ø§Ù„ØªØµÙ†ÙŠÙ',0),(356718,9909,'fr','Pour cette catÃ©gorie',0),(356719,9909,'jp','ã“ã®ã‚«ãƒ†ã‚´ãƒªã«',0),(356720,9909,'pt','Para esta categoria',0),(356721,9909,'ru','Ðš ÑÑ‚Ð¾Ð¹ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(356722,9909,'es','A Esta CategorÃ­a',0),(356723,9909,'de','Zu dieser Kategorie',0),(356724,9909,'en','To This Category',0),(356725,9910,'is','',0),(356726,9910,'dr','ÙŠÙƒÙ¾Ø§Ø±Ú†Ù‡ Ø³Ø§Ø²ÙŠ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ú¯ÙˆÚ¯Ù„ ',0),(356727,9910,'pr','ÙŠÙƒÙ¾Ø§Ø±Ú†Ù‡ Ø³Ø§Ø²ÙŠ Ù¾Ø§ÙŠÚ¯Ø§Ù‡ Ú¯ÙˆÚ¯Ù„ ',0),(356728,9910,'tr','Google Base TÃ¼mleÅŸtirme',0),(356729,9910,'pl','Integracja z Google Base',0),(356730,9910,'bg','Google Base Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ',0),(356731,9910,'ur','Ú¯ÙˆÚ¯Ù„ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ø§Ù†Ø¶Ù…Ø§Ù…',0),(356732,9910,'sr','Ð“Ð¾Ð¾Ð³Ð»Ðµ Ð±Ð°Ð·Ð¸ Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ˜Ðµ',0),(356733,9910,'vi','sá»± hÃ²a nháº­p google cÆ¡ báº£n',0),(356734,9910,'af','Google basis integrasie',0),(356735,9910,'ro','Integrare Google Base',0),(356736,9910,'et','Google Base integratsiooni',0),(356737,9910,'si','Integracija Google Base',0),(356738,9910,'ba','Integrasi Google Base',0),(356739,9910,'nl','Google Base integratie',0),(356740,9910,'fi','Google Base integraatio',0),(356741,9910,'no','Google Base integrering',0),(356742,9910,'da','Google Nedrig Integration',0),(356743,9910,'ko','êµ¬ê¸€ ë² ì´ìŠ¤ í†µí•©',0),(356744,9910,'he','Google Base ××™× ×˜×’×¨×¦×™×”',0),(356745,9910,'el','Google Î²Î¬ÏƒÎ· ÎµÎ½Î¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚',0),(356746,9910,'zh','è°·æ­Œæ•´åˆæ•°æ®åº“\r\n',0),(356747,9910,'sv','Google Base Integration',0),(356748,9910,'it','Integrazione di Google Base',0),(356749,9910,'tl','',0),(356750,9910,'th','Google Base Integration',0),(356751,9910,'hi','à¤—à¥‚à¤—à¤² à¤•à¥‹à¤· à¤à¤•à¥€à¤•à¤°à¤£',0),(356752,9910,'ms','Integrasi Google Base',0),(356753,9910,'ar','ØªÙƒØ§Ù…Ù„ Ù‚Ø§Ø¹Ø¯Ø© Ø¬ÙˆØ¬Ù„',0),(356754,9910,'fr','IntÃ©gration de Google Base',0),(356755,9910,'jp','Google ãƒ™ãƒ¼ã‚¹ã®çµ±åˆ',0),(356756,9910,'pt','IntegraÃ§Ã£o Google Base',0),(356757,9910,'ru','Ð˜Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ Google Base',0),(356758,9910,'es','IntegraciÃ³n con Base de Google',0),(356759,9910,'de','Google Base-Integration',0),(356760,9910,'en','Google Base Integration',0),(356761,9911,'is','',0),(356762,9911,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø³ØªÙˆØ± Ø§Ù„Ø¹Ù…Ù„ Ø§Ø¬Ø§Ø±Ù‡ ',0),(356763,9911,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø³ØªÙˆØ± Ø§Ù„Ø¹Ù…Ù„ Ø§Ø¬Ø§Ø±Ù‡ ',0),(356764,9911,'tr','Kira yÃ¶nergeler ekleyin',0),(356765,9911,'pl','Dodaj instrukcje dzierÅ¼awy',0),(356766,9911,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(356767,9911,'ur','Ù„ÛŒØ² ÛØ¯Ø§ÛŒØ§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(356768,9911,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð°ÐºÑƒÐ¿ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(356769,9911,'vi','ThÃªm xÃ¢y dá»±ng thuÃª ',0),(356770,9911,'af','Huurkontrak Instruksies Byvoeg',0),(356771,9911,'ro','Adauga instrucÅ£iunile de leasing',0),(356772,9911,'et','ÃœÃ¼rilepingu juhiste lisamine',0),(356773,9911,'si','Dodaj najem navodila',0),(356774,9911,'ba','Tambahkan sewa petunjuk',0),(356775,9911,'nl','Lease instructies toevoegen',0),(356776,9911,'fi','LisÃ¤tÃ¤ vuokrasopimuksen ohjeita',0),(356777,9911,'no','Legge til leie instruksjoner',0),(356778,9911,'da','TilfÃ¸je Lease instruktioner',0),(356779,9911,'ko','ìž„ëŒ€ ì§€ì¹¨ ì¶”ê°€',0),(356780,9911,'he','×”×•×¡×£ ×”×•×¨××•×ª ×©×›×™×¨×•×ª',0),(356781,9911,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¿Î´Î·Î³Î¯ÎµÏ‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(356782,9911,'zh','å¢žåŠ ç§ŸèµæŒ‡ç¤º',0),(356783,9911,'sv','LÃ¤gg till hyresavtalet instruktioner',0),(356784,9911,'it','Aggiungere le istruzioni di contratto di locazione',0),(356785,9911,'tl','',0),(356786,9911,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3588;&#3635;&#3649;&#3609;&#3632;&#3609;&#3635;&#3626;&#3633;&#3597;&#3597;&#3634;&#3648;&#3594;&#3656;&#3634;',0),(356787,9911,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(356788,9911,'ms','Menambah arahan pajakan',0),(356789,9911,'ar','Ø¥Ø¶Ø§ÙØ© ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(356790,9911,'fr','Ajouter Instructions de Bail',0),(356791,9911,'jp','ãƒªãƒ¼ã‚¹ã®èª¬æ˜Žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(356792,9911,'pt','Adicione instruÃ§Ãµes de locaÃ§Ã£o',0),(356793,9911,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð¿Ð¾ Ð°Ñ€ÐµÐ½Ð´Ðµ',0),(356794,9911,'es','Agregar Instrucciones de Arrendamiento',0),(356795,9911,'de','Lease-Anweisungen hinzufÃ¼gen',0),(356796,9911,'en','Add Lease Instructions',0),(356797,9912,'is','',0),(356798,9912,'dr','Ù…Ø³ØªØ§Ø¬Ø± ÙØ¹Ù„ÙŠ',0),(356799,9912,'pr','Ù…Ø³ØªØ§Ø¬Ø± ÙØ¹Ù„ÙŠ',0),(356800,9912,'tr','GeÃ§erli kiracÄ±',0),(356801,9912,'pl','Aktualny najemca',0),(356802,9912,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»Ð¸',0),(356803,9912,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±',0),(356804,9912,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ ÑÑ‚Ð°Ð½Ð°Ñ€',0),(356805,9912,'vi','Tenant hiá»‡n nay',0),(356806,9912,'af','Huidige Huurder',0),(356807,9912,'ro','Curent chiriaÅŸ',0),(356808,9912,'et','Praegune rentnik',0),(356809,9912,'si','Sedanji najemnik',0),(356810,9912,'ba','Saat ini penyewa',0),(356811,9912,'nl','Huidige huurder',0),(356812,9912,'fi','Nykyinen vuokralainen',0),(356813,9912,'no','Gjeldende leietaker',0),(356814,9912,'da','NuvÃ¦rende lejer',0),(356815,9912,'ko','í˜„ìž¬ ê±°ì£¼ìž',0),(356816,9912,'he','×”×“×™×™×¨ ×”× ×•×›×—×™',0),(356817,9912,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½',0),(356818,9912,'zh','ç›®å‰çš„ç§Ÿæˆ·\r\n',0),(356819,9912,'sv','Nuvarande hyresgÃ¤st',0),(356820,9912,'it','Inquilino attuale',0),(356821,9912,'tl','',0),(356822,9912,'th','&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;&#3611;&#3633;&#3592;&#3592;&#3640;&#3610;&#3633;&#3609;',0),(356823,9912,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°',0),(356824,9912,'ms','Penyewa semasa',0),(356825,9912,'ar','Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(356826,9912,'fr','Locataire actuel',0),(356827,9912,'jp','ç¾åœ¨ã®ãƒ†ãƒŠãƒ³ãƒˆ',0),(356828,9912,'pt','Atual inquilino',0),(356829,9912,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð½Ð°Ð½Ð¸Ð¼Ð°Ñ‚ÐµÐ»ÑŒ',0),(356830,9912,'es','Inquilino Actual',0),(356831,9912,'de','Aktuellen Mieter',0),(356832,9912,'en','Current Tenant',0),(356833,9913,'is','',0),(356834,9913,'dr','Ù…Ø³ØªØ§Ø¬Ø± Ø¬Ø¯ÙŠØ¯ ',0),(356835,9913,'pr','Ù…Ø³ØªØ§Ø¬Ø± Ø¬Ø¯ÙŠØ¯ ',0),(356836,9913,'tr','Yeni kiracÄ±',0),(356837,9913,'pl','Nowym najemcÄ…',0),(356838,9913,'bg','ÐÐ¾Ð² Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»',0),(356839,9913,'ur','Ù†Ø¦Û’ Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±',0),(356840,9913,'sr','ÐÐ¾Ð²Ð¸ ÑÑ‚Ð°Ð½Ð°Ñ€',0),(356841,9913,'vi','ngÆ°á»i má»›i',0),(356842,9913,'af','Nuwe Huurder',0),(356843,9913,'ro','Nou chiriaÅŸ',0),(356844,9913,'et','Uue Ã¼Ã¼rniku',0),(356845,9913,'si','Novega najemnika',0),(356846,9913,'ba','Penyewa baru',0),(356847,9913,'nl','Nieuwe huurder',0),(356848,9913,'fi','Uuden vuokralaisen',0),(356849,9913,'no','Ny leietaker',0),(356850,9913,'da','Nye lejer',0),(356851,9913,'ko','ìƒˆë¡œìš´ ì„¸ ìž…ìž',0),(356852,9913,'he','×“×™×™×¨ ×—×“×©',0),(356853,9913,'el','ÎÎ­Î¿ Î­Î½Î¿Î¹ÎºÎ¿',0),(356854,9913,'zh','æ–°ç§Ÿå®¢\r\n',0),(356855,9913,'sv','Ny hyresgÃ¤st',0),(356856,9913,'it','Nuovo inquilino',0),(356857,9913,'tl','',0),(356858,9913,'th','&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;&#3651;&#3627;&#3617;&#3656;',0),(356859,9913,'hi','à¤¨à¤ˆ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°',0),(356860,9913,'ms','Penyewa baru',0),(356861,9913,'ar','Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(356862,9913,'fr','Nouveau locataire',0),(356863,9913,'jp','æ–°ã—ã„ãƒ†ãƒŠãƒ³ãƒˆ',0),(356864,9913,'pt','Novo inquilino',0),(356865,9913,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€',0),(356866,9913,'es','Nuevo Inquilino',0),(356867,9913,'de','Neue Mieter',0),(356868,9913,'en','New Tenant',0),(356869,9914,'is','',0),(356870,9914,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø³ØªØ§Ø¬Ø±',0),(356871,9914,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø³ØªØ§Ø¬Ø±',0),(356872,9914,'tr','KiracÄ± seÃ§in',0),(356873,9914,'pl','Wybierz najemcy',0),(356874,9914,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»',0),(356875,9914,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(356876,9914,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð½Ð°Ñ€',0),(356877,9914,'vi','chá»n ngÆ°á»i thuÃª nhÃ ',0),(356878,9914,'af','Kies Huurder',0),(356879,9914,'ro','SelectaÅ£i chiriaÅŸ',0),(356880,9914,'et','Valige rentniku',0),(356881,9914,'si','Izberite najemnik',0),(356882,9914,'ba','Pilih penyewa',0),(356883,9914,'nl','Selecteer huurder',0),(356884,9914,'fi','Valitse vuokralainen',0),(356885,9914,'no','Velg leietaker',0),(356886,9914,'da','VÃ¦lg lejer',0),(356887,9914,'ko','ì„¸ ìž…ìžë¥¼ ì„ íƒ',0),(356888,9914,'he','×‘×—×¨ ×”×©×•×›×¨',0),(356889,9914,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½',0),(356890,9914,'zh','é€‰æ‹©ç§Ÿå®¢\r\n',0),(356891,9914,'sv','VÃ¤lj hyresgÃ¤sten',0),(356892,9914,'it','Selezionare inquilino',0),(356893,9914,'tl','',0),(356894,9914,'th','&#3640;&#3648;&#3621;&#3639;&#3629;&#3585;&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;',0),(356895,9914,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(356896,9914,'ms','Pilih penyewa',0),(356897,9914,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(356898,9914,'fr','SÃ©lectionner le locataire',0),(356899,9914,'jp','ãƒ†ãƒŠãƒ³ãƒˆã‚’é¸æŠžã—ã¾ã™ã€‚',0),(356900,9914,'pt','Selecione o inquilino',0),(356901,9914,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(356902,9914,'es','Selecciona Inquilino',0),(356903,9914,'de','WÃ¤hlen Sie Mieter',0),(356904,9914,'en','Select Tenant',0),(356905,9915,'is','',0),(356906,9915,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø±Ø­ Ù…Ø³ØªØ§Ø¬Ø±',0),(356907,9915,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø±Ø­ Ù…Ø³ØªØ§Ø¬Ø±',0),(356908,9915,'tr','KiracÄ± aÃ§Ä±klamayÄ± seÃ§in',0),(356909,9915,'pl','Wybierz Opis najemcy',0),(356910,9915,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(356911,9915,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©ÛŒ ØªÙØµÛŒÙ„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(356912,9915,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿Ð¸Ñ ÑÑ‚Ð°Ð½Ð°Ñ€',0),(356913,9915,'vi','chá»n mÃ´ táº£ ngÆ°á»i thuÃª nhÃ ',0),(356914,9915,'af','Kies Huuder Beskrywing',0),(356915,9915,'ro','SelectaÅ£i chiriaÅŸ Descriere',0),(356916,9915,'et','Valige rentniku kirjeldus',0),(356917,9915,'si','Izberite najemnik opis',0),(356918,9915,'ba','Pilih penyewa Deskripsi',0),(356919,9915,'nl','Selecteer huurder beschrijving',0),(356920,9915,'fi','Valitse vuokralainen kuvaus',0),(356921,9915,'no','Velg leietaker beskrivelse',0),(356922,9915,'da','VÃ¦lg lejer beskrivelse',0),(356923,9915,'ko','ì„¸ ìž…ìž ì„¤ëª… ì„ íƒ',0),(356924,9915,'he','×‘×—×¨ ×”×©×•×›×¨ ×ª×™××•×¨',0),(356925,9915,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½',0),(356926,9915,'zh','é€‰æ‹©ç§Ÿå®¢æè¿°\r\n',0),(356927,9915,'sv','VÃ¤lj hyresgÃ¤sten Beskrivning',0),(356928,9915,'it','Selezionare Descrizione dell\'inquilino',0),(356929,9915,'tl','',0),(356930,9915,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3588;&#3635;&#3629;&#3608;&#3636;&#3610;&#3634;&#3618;&#3612;&#3641;&#3657;&#3648;&#3594;&#3656;&#3634;',0),(356931,9915,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤µà¤¿à¤µà¤°à¤£ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(356932,9915,'ms','Pilih Perihalan penyewa',0),(356933,9915,'ar','Ø­Ø¯Ø¯ ÙˆØµÙ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(356934,9915,'fr','SÃ©lectionnez la Description de locataire',0),(356935,9915,'jp','ãƒ†ãƒŠãƒ³ãƒˆèª¬æ˜Žã‚’é¸æŠžã—ã¾ã™ã€‚',0),(356936,9915,'pt','Selecione a descriÃ§Ã£o do inquilino',0),(356937,9915,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(356938,9915,'es','Selecciona DescripciÃ³n de Inquilino',0),(356939,9915,'de','WÃ¤hlen Sie Mieter Beschreibung',0),(356940,9915,'en','Select Tenant Description',0),(356941,9916,'is','',0),(356942,9916,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙˆØ§Ø­Ø¯',0),(356943,9916,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙˆØ§Ø­Ø¯',0),(356944,9916,'tr','Birim seÃ§in',0),(356945,9916,'pl','Wybierz jednostkÄ™',0),(356946,9916,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(356947,9916,'ur','ÛŒÙˆÙ†Ù¹ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(356948,9916,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(356949,9916,'vi','Chá»n Ä‘Æ¡n vá»‹',0),(356950,9916,'af','Kies eenheid',0),(356951,9916,'ro','SelectaÅ£i unitatea',0),(356952,9916,'et','Valige Ã¼ksus',0),(356953,9916,'si','Izberite enoto',0),(356954,9916,'ba','Pilih Unit',0),(356955,9916,'nl','Selecteer eenheid',0),(356956,9916,'fi','Valitse yksikkÃ¶',0),(356957,9916,'no','Velg enhet',0),(356958,9916,'da','VÃ¦lg enhed',0),(356959,9916,'ko','ë‹¨ìœ„ ì„ íƒ',0),(356960,9916,'he','×‘×—×¨ ×™×—×™×“×”',0),(356961,9916,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¿Î½Î¬Î´Î±',0),(356962,9916,'zh','é€‰æ‹©å•ä½\r\n',0),(356963,9916,'sv','VÃ¤lj enhet',0),(356964,9916,'it','Selezionare unitÃ ',0),(356965,9916,'tl','',0),(356966,9916,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(356967,9916,'hi','à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(356968,9916,'ms','Pilih Unit',0),(356969,9916,'ar','Ø­Ø¯Ø¯ ÙˆØ­Ø¯Ø©',0),(356970,9916,'fr','SÃ©lectionnez lâ€™unitÃ©',0),(356971,9916,'jp','å˜ä½ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(356972,9916,'pt','Selecione a unidade',0),(356973,9916,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(356974,9916,'es','Selecciona Unudad',0),(356975,9916,'de','WÃ¤hlen Sie Einheit',0),(356976,9916,'en','Select Unit',0),(356977,9917,'is','',0),(356978,9917,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ÙˆØ§Ø­Ø¯',0),(356979,9917,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ÙˆØ§Ø­Ø¯',0),(356980,9917,'tr','Birim yÃ¶nergeleri seÃ§in',0),(356981,9917,'pl','Wybierz jednostkÄ™ instrukcje',0),(356982,9917,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(356983,9917,'ur','ÛŒÙˆÙ†Ù¹ ÛØ¯Ø§ÛŒØ§Øª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(356984,9917,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(356985,9917,'vi','Chá»n nhá»¯ng hÆ°á»›ng dáº«n Ä‘Æ¡n vá»‹',0),(356986,9917,'af','Kies eenheid instruksies',0),(356987,9917,'ro','SelectaÅ£i unitatea instrucÅ£iuni',0),(356988,9917,'et','Valige Ã¼ksus juhiseid',0),(356989,9917,'si','Izberite enoto navodila',0),(356990,9917,'ba','Pilih Unit petunjuk',0),(356991,9917,'nl','Selecteer eenheid instructies',0),(356992,9917,'fi','Valitse laitteesi ohjeita',0),(356993,9917,'no','Velg enheten instruksjoner',0),(356994,9917,'da','VÃ¦lg enhed instruktioner',0),(356995,9917,'ko','ì„ íƒ ë‹¨ìœ„ ì§€ì¹¨',0),(356996,9917,'he','×‘×—×¨ ×™×—×™×“×ª ×”×•×¨××•×ª',0),(356997,9917,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¿Î½Î¬Î´Î± Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(356998,9917,'zh','é€‰æ‹©å•ä½è¯´æ˜Ž\r\n',0),(356999,9917,'sv','VÃ¤lj enhet instruktioner',0),(357000,9917,'it','Istruzioni centralina Select',0),(357001,9917,'tl','',0),(357002,9917,'th','&#3588;&#3635;&#3649;&#3609;&#3632;&#3609;&#3635;&#3648;&#3621;&#3639;&#3629;&#3585;&#3627;&#3609;&#3656;&#3623;&#3618;',0),(357003,9917,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(357004,9917,'ms','Pilih arahan Unit',0),(357005,9917,'ar','Ø­Ø¯Ø¯ ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(357006,9917,'fr','SÃ©lectionnez le mode appareil',0),(357007,9917,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã‚’é¸æŠžæŒ‡ç¤º',0),(357008,9917,'pt','Selecione a unidade instruÃ§Ãµes',0),(357009,9917,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð±Ð»Ð¾Ðº Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(357010,9917,'es','Selecciona Instrucciones de Unidad',0),(357011,9917,'de','WÃ¤hlen Sie GerÃ¤t Anweisungen',0),(357012,9917,'en','Select Unit Instructions',0),(357013,9918,'is','',0),(357014,9918,'dr','Ø¨Ù‡ Ø®Ø§Ù†Ù‡ ØªØ§Ø²Ù‡ Ù…Ù†ØªÙ‚Ù„ Ú©Ø±Ø¯Ù†',0),(357015,9918,'pr','Ø¨Ù‡ Ø®Ø§Ù†Ù‡ ØªØ§Ø²Ù‡ Ù…Ù†ØªÙ‚Ù„ Ú©Ø±Ø¯Ù†',0),(357016,9918,'tr','Ä°Ã§eri girin',0),(357017,9918,'pl','PrzesuÅ„',0),(357018,9918,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð²Ð°Ð½Ðµ Ð²',0),(357019,9918,'ur','Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(357020,9918,'sr','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸',0),(357021,9918,'vi','chuyá»ƒn vÃ o',0),(357022,9918,'af','Beweeg',0),(357023,9918,'ro','MutaÅ£i',0),(357024,9918,'et','Liikuda',0),(357025,9918,'si','Premikanje',0),(357026,9918,'ba','Bergerak dalam',0),(357027,9918,'nl','Verplaatsen',0),(357028,9918,'fi','SiirrÃ¤',0),(357029,9918,'no','Flytte i',0),(357030,9918,'da','Flytte',0),(357031,9918,'ko','ì´ë™',0),(357032,9918,'he','×›× ×¡×•',0),(357033,9918,'el','ÎœÎµÏ„Î±ÎºÎ¯Î½Î·ÏƒÎ· ÏƒÎµ',0),(357034,9918,'zh','è¿å…¥\r\n',0),(357035,9918,'sv','Flytta i',0),(357036,9918,'it','Spostare',0),(357037,9918,'tl','',0),(357038,9918,'th','&#3618;&#3657;&#3634;&#3618;&#3648;&#3586;&#3657;&#3634;&#3651;&#3609;',0),(357039,9918,'hi','à¤²à¥‡ à¤œà¤¾à¤à¤',0),(357040,9918,'ms','Bergerak dalam',0),(357041,9918,'ar','Ù†Ù‚Ù„',0),(357042,9918,'fr','Se dÃ©placer dans',0),(357043,9918,'jp','ã‚’ç§»å‹•ã—ã¾ã™ã€‚',0),(357044,9918,'pt','Mover-se',0),(357045,9918,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð²',0),(357046,9918,'es','Mudarse',0),(357047,9918,'de','Bewegen sich In',0),(357048,9918,'en','Move In',0),(357049,9919,'is','',0),(357050,9919,'dr','Ø¨Ø±ÙˆÙŠØ¯ Ø¨Ù‡',0),(357051,9919,'pr','Ø¨Ø±ÙˆÙŠØ¯ Ø¨Ù‡',0),(357052,9919,'tr','Git',0),(357053,9919,'pl','PrzejdÅº do',0),(357054,9919,'bg','ÐžÑ‚Ð¸Ð´Ð¸ Ð½Ð°',0),(357055,9919,'ur','Ø¬Ø§Ø¤',0),(357056,9919,'sr','Ð¿Ð¾Ñ’Ð¸ Ð´Ð¾',0),(357057,9919,'vi','Ä‘i tá»›i',0),(357058,9919,'af','Gaan Na',0),(357059,9919,'ro','du-te la',0),(357060,9919,'et','Mine',0),(357061,9919,'si','pojdi k',0),(357062,9919,'ba','Pergi ke',0),(357063,9919,'nl','Ga naar',0),(357064,9919,'fi','MennÃ¤',0),(357065,9919,'no','gÃ¥ til',0),(357066,9919,'da','GÃ¥ til',0),(357067,9919,'ko','ë¡œ ê°€ë‹¤',0),(357068,9919,'he','×œ×œ×›×ª ×œ',0),(357069,9919,'el','Î Î®Î³Î±Î¹Î½Îµ ÏƒÏ„Î¿',0),(357070,9919,'zh','è½¬åˆ°\r\n',0),(357071,9919,'sv','GÃ¥ till',0),(357072,9919,'it','Vai a',0),(357073,9919,'tl','',0),(357074,9919,'th','&#3652;&#3611;&#3607;&#3637;&#3656;',0),(357075,9919,'hi','à¤¯à¤¹à¤¾à¤ à¤œà¤¾à¤“',0),(357076,9919,'ms','pergi ke',0),(357077,9919,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ø¥Ù„Ù‰',0),(357078,9919,'fr','Atteindre',0),(357079,9919,'jp','è¡Œãã¾ã™',0),(357080,9919,'pt','Ir para',0),(357081,9919,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ðº',0),(357082,9919,'es','Vaya A',0),(357083,9919,'de','Gehe zu',0),(357084,9919,'en','Go To',0),(357085,9920,'is','',0),(357086,9920,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ù‡Ø± ØµÙØ­Ù‡ ',0),(357087,9920,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ù‡Ø± ØµÙØ­Ù‡ ',0),(357088,9920,'tr','Sayfa baÅŸÄ±na Ã¶ÄŸe',0),(357089,9920,'pl','ElementÃ³w na stronie',0),(357090,9920,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(357091,9920,'ur','ÙÛŒ ØµÙØ­Û Ø§Ø´ÛŒØ§Ø¡',0),(357092,9920,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¿Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(357093,9920,'vi','cÃ¡c máº·t hÃ ng cho 1 trang',0),(357094,9920,'af','Items per Blad',0),(357095,9920,'ro','Elemente pe paginÄƒ',0),(357096,9920,'et','Tooteid lehekÃ¼lje kohta',0),(357097,9920,'si','Elementi na strani',0),(357098,9920,'ba','Item Per halaman',0),(357099,9920,'nl','Items Per pagina',0),(357100,9920,'fi','Kohteita sivulla',0),(357101,9920,'no','Elementer Per side',0),(357102,9920,'da','Elementer pr. side',0),(357103,9920,'ko','íŽ˜ì´ì§€ ë‹¹ í•­ëª©',0),(357104,9920,'he','×¤×¨×™×˜×™× ×œ×›×œ ×“×£',0),(357105,9920,'el','Î‘Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î± Î±Î½Î¬ ÏƒÎµÎ»Î¯Î´Î±',0),(357106,9920,'zh','æ¯é¡µé¡¹ç›®\r\n',0),(357107,9920,'sv','Poster Per sida',0),(357108,9920,'it','Elementi Per pagina',0),(357109,9920,'tl','',0),(357110,9920,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3636;&#3609;&#3588;&#3657;&#3634;&#3605;&#3656;&#3629;&#3627;&#3609;&#3657;&#3634;',0),(357111,9920,'hi','à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¥ƒà¤·à¥à¤ ',0),(357112,9920,'ms','Item setiap muka',0),(357113,9920,'ar','Ø§Ù„Ø¨Ù†ÙˆØ¯ Ù„ÙƒÙ„ ØµÙØ­Ø©',0),(357114,9920,'fr','Ã‰lÃ©ments par Page',0),(357115,9920,'jp','ãƒšãƒ¼ã‚¸ã‚ãŸã‚Šã®ã‚¢ã‚¤ãƒ†ãƒ ',0),(357116,9920,'pt','Itens por pÃ¡gina',0),(357117,9920,'ru','Ð¢Ð¾Ð²Ð°Ñ€Ð¾Ð² ÐÐ° Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ ',0),(357118,9920,'es','Items Por PÃ¡gina',0),(357119,9920,'de','Elemente pro Seite',0),(357120,9920,'en','Items Per Page',0),(357121,9921,'is','',0),(357122,9921,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ â€“ ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ù…Ø¹ÙŠ',0),(357123,9921,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ â€“ ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ù…Ø¹ÙŠ',0),(357124,9921,'tr','Madde fiyatlarÄ± - toplu dÃ¼zenleme',0),(357125,9921,'pl','Element ceny - masa Edit',0),(357126,9921,'bg','Ð¦ÐµÐ½Ð¸ - Ð¼Ð°ÑÐ¾Ð²Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(357127,9921,'ur','Ù‚ÛŒÙ…ØªÛŒÚº - ÙˆØ³ÛŒØ¹ Ù¾ÛŒÙ…Ø§Ù†Û’ Ù¾Ø± ØªØ¯ÙˆÛŒÙ† Ø´Û’',0),(357128,9921,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ñ†ÐµÐ½Ðµ - Ð¼Ð°ÑÐ¾Ð²Ð½Ð¾ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(357129,9921,'vi','giÃ¡ hÃ ng- thÃªm khá»‘i lÆ°á»£ng',0),(357130,9921,'af','Item Pryse - Grootmaat Redigeer',0),(357131,9921,'ro','Preturi - masÄƒ Editare element',0),(357132,9921,'et','Toodete hinnad - muuda korraga',0),(357133,9921,'si','Postavka cene - mnoÅ¾iÄno urejanje',0),(357134,9921,'ba','Item harga - massal mengedit',0),(357135,9921,'nl','Punt prijzen - massa bewerken',0),(357136,9921,'fi','Tuotteen hinnat - massasta Edit',0),(357137,9921,'no','Element priser - masse Rediger',0),(357138,9921,'da','Punkt priser - masse Rediger',0),(357139,9921,'ko','ê°€ê²©-ëŒ€ëŸ‰ íŽ¸ì§‘ í•­ëª©',0),(357140,9921,'he','×¤×¨×™×˜ ×‘×ž×—×™×¨×™× - ×¢×¨×™×›×” ×”×ž×•× ×™×ª',0),(357141,9921,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î­Ï‚ - Î¼Î±Î¶Î¹ÎºÎ® ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(357142,9921,'zh','é¡¹ç›®ä»·æ ¼- æ‰¹é‡ç¼–è¾‘\r\n',0),(357143,9921,'sv','Punkt priser - massa redigera',0),(357144,9921,'it','Prezzi - massa modifica dell\'articolo',0),(357145,9921,'tl','',0),(357146,9921,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3619;&#3634;&#3588;&#3634; - &#3649;&#3585;&#3657;&#3652;&#3586; Mass ',0),(357147,9921,'hi','à¤•à¥€à¤®à¤¤à¥‡à¤‚ - à¤®à¤¾à¤¸ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤†à¤‡à¤Ÿà¤®',0),(357148,9921,'ms','Perkara harga - jisim Edit',0),(357149,9921,'ar','Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø£ØµÙ†Ø§Ù - ØªØ­Ø±ÙŠØ± Ø¬Ù…Ø§Ø¹ÙŠ',0),(357150,9921,'fr','Prix - Edit masse le point',0),(357151,9921,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®ä¾¡æ ¼ - ä¸€æ‹¬ç·¨é›†',0),(357152,9921,'pt','PreÃ§os - editar em massa do artigo',0),(357153,9921,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ñ†ÐµÐ½Ñ‹ - Ð¼Ð°ÑÑÐ¾Ð²Ð¾Ð³Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(357154,9921,'es','Precios de Items - EdiciÃ³n Masivo',0),(357155,9921,'de','Artikel-Preise - Mass Edit',0),(357156,9921,'en','Item Prices - Mass Edit',0),(357157,9922,'is','',0),(357158,9922,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(357159,9922,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(357160,9922,'tr','Fiyatlar baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(357161,9922,'pl','Ceny pomyÅ›lnie zaktualizowana',0),(357162,9922,'bg','Ð¦ÐµÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(357163,9922,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ù‚ÛŒÙ…ØªÛŒÚº',0),(357164,9922,'sr','Ð¦ÐµÐ½Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(357165,9922,'vi','cáº­p nháº­t giÃ¡ thÃ nh cÃ´ng',0),(357166,9922,'af','Pryse Suksesvol Opdateer',0),(357167,9922,'ro','Preturi actualizate cu succes',0),(357168,9922,'et','Hinnad uuendati edukalt',0),(357169,9922,'si','Cene uspeÅ¡no posodobljena',0),(357170,9922,'ba','Harga berhasil',0),(357171,9922,'nl','Prijzen bijgewerkt',0),(357172,9922,'fi','Hinnat pÃ¤ivitetty',0),(357173,9922,'no','Prisene oppdatert',0),(357174,9922,'da','Priser opdateret',0),(357175,9922,'ko','ê°€ê²© ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´ íŠ¸',0),(357176,9922,'he','×”×ž×—×™×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(357177,9922,'el','Î¤Î¹Î¼Î­Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¸ÎµÎ¯ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(357178,9922,'zh','æˆåŠŸæ›´æ–°ä»·æ ¼\r\n',0),(357179,9922,'sv','Priserna uppdaterades',0),(357180,9922,'it','Prezzi aggiornati con successo',0),(357181,9922,'tl','',0),(357182,9922,'th','&#3619;&#3634;&#3588;&#3634;&#3606;&#3641;&#3585;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3649;&#3621;&#3657;&#3623;',0),(357183,9922,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‡à¤‚',0),(357184,9922,'ms','Harga dikemaskini berjaya',0),(357185,9922,'ar','Ø­Ø¯Ù‘Ø«Øª Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(357186,9922,'fr','Prix mis Ã  jour avec succÃ¨s',0),(357187,9922,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸä¾¡æ ¼',0),(357188,9922,'pt','PreÃ§os atualizados com sucesso',0),(357189,9922,'ru','Ð¦ÐµÐ½Ñ‹ Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(357190,9922,'es','Precios Actualizados Exiosamente',0),(357191,9922,'de','Preise erfolgreich aktualisiert',0),(357192,9922,'en','Prices Updated Successfully',0),(357193,9923,'is','',0),(357194,9923,'dr','Ø³Ø§ÙŠØ² ÙŠÚ© Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(357195,9923,'pr','Ø³Ø§ÙŠØ² ÙŠÚ© Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(357196,9923,'tr','Toplu iÅŸ boyutu',0),(357197,9923,'pl','Rozmiar partii',0),(357198,9923,'bg','Ð“Ð¾Ð»ÐµÐ¼Ð¸Ð½Ð° Ð½Ð° Ð¿Ð°Ñ€Ñ‚Ð¸Ð´Ð¸Ñ‚Ðµ',0),(357199,9923,'ur','Ø¨ÛŒÚ† Ø³Ø§Ø¦Ø²',0),(357200,9923,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð³Ñ€ÑƒÐ¿Ðµ',0),(357201,9923,'vi','Cá»¡ lÃ´',0),(357202,9923,'af','Bondelgrootte',0),(357203,9923,'ro','MÄƒrimea lotului',0),(357204,9923,'et','Partii suurus',0),(357205,9923,'si','Velikost paketa',0),(357206,9923,'ba','Batch ukuran',0),(357207,9923,'nl','Batchgrootte',0),(357208,9923,'fi','ErÃ¤koko',0),(357209,9923,'no','Satsvis stÃ¸rrelse',0),(357210,9923,'da','BatchstÃ¸rrelse',0),(357211,9923,'ko','ì¼ê´„ ì²˜ë¦¬ í¬ê¸°',0),(357212,9923,'he','×’×•×“×œ ××¦×•×•×”',0),(357213,9923,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Ï„Î·Ï‚ Ï€Î±ÏÏ„Î¯Î´Î±Ï‚',0),(357214,9923,'zh','æ‰¹é‡å¤§å°\r\n',0),(357215,9923,'sv','Satsstorlek',0),(357216,9923,'it','Dimensione del batch',0),(357217,9923,'tl','',0),(357218,9923,'th','&#3586;&#3609;&#3634;&#3604;&#3619;&#3640;&#3656;&#3609;',0),(357219,9923,'hi','à¤¬à¥ˆà¤š à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(357220,9923,'ms','Saiz Kumpulan',0),(357221,9923,'ar','Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ø¯ÙØ¹ÙŠ',0),(357222,9923,'fr','Taille du lot',0),(357223,9923,'jp','ãƒãƒƒãƒ ã‚µã‚¤ã‚º',0),(357224,9923,'pt','Tamanho do lote',0),(357225,9923,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¿Ð°ÐºÐµÑ‚Ð°',0),(357226,9923,'es','TamaÃ±o de Lote',0),(357227,9923,'de','Batch-GrÃ¶ÃŸe',0),(357228,9923,'en','Batch Size',0),(357229,9924,'is','',0),(357230,9924,'dr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡  Ù¾ÙŠØ´  ÙØ§ÙƒØªÙˆØ± Ø´Ù…Ø§ Ø§Ø³Øª',0),(357231,9924,'pr','Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯Ù‡  Ù¾ÙŠØ´  ÙØ§ÙƒØªÙˆØ± Ø´Ù…Ø§ Ø§Ø³Øª',0),(357232,9924,'tr','Pro Forma fatura baÄŸlÄ± olduÄŸunu',0),(357233,9924,'pl','DoÅ‚Ä…czona jest faktura Pro Forma',0),(357234,9924,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¾ Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ñ€Ð¾Ñ„Ð¾Ñ€Ð¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(357235,9924,'ur','Ø§Ù¾Ù†Û’ Ù¾Ø±Ùˆ ÙØ§Ø±Ù…Ø§ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø³Û’ Ù…Ù†Ø³Ù„Ú© ÛÛ’',0),(357236,9924,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ Ñ˜Ðµ Ñ‚Ð²Ð¾Ñ˜ ÐŸÑ€Ð¾ Ð¤Ð¾Ñ€Ð¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(357237,9924,'vi','KÃ¨m theo lÃ bÃ¡o giÃ¡',0),(357238,9924,'af','U Proforma Faktuur is Aangeheg',0),(357239,9924,'ro','AtaÅŸat este factura Pro Forma',0),(357240,9924,'et','Lisatud on oma Pro Forma arve',0),(357241,9924,'si','PriloÅ¾en je vaÅ¡ Pro Forma raÄuna',0),(357242,9924,'ba','Terlampir adalah Forma Invoice Anda Pro',0),(357243,9924,'nl','Uw pro-forma factuur is bijgevoegd',0),(357244,9924,'fi','LiitteenÃ¤ on Pro Forma-laskun',0),(357245,9924,'no','Vedlagt er din Pro Forma-faktura',0),(357246,9924,'da','VedhÃ¦ftet er din Pro Forma faktura',0),(357247,9924,'ko','ì²¨ë¶€ëŠ” í”„ë¡œ ê²¬ì  ì†¡ìž¥',0),(357248,9924,'he','×ž×¦×•×¨×¤×ª ×—×©×‘×•× ×™×ª ×¤×¨×•×¤×•×¨×ž×” ×©×œ×š',0),(357249,9924,'el','Î•Ï€Î¹ÏƒÏ…Î½Î¬Ï€Ï„ÎµÏ„Î±Î¹ ÏƒÎ±Ï‚ Pro Forma Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(357250,9924,'zh','é™„ä¸Šä½ çš„å½¢å¼å‘ç¥¨\r\n',0),(357251,9924,'sv','Bifogat Ã¤r din Pro Forma faktura',0),(357252,9924,'it','Ãˆ allegata la fattura proforma',0),(357253,9924,'tl','',0),(357254,9924,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3593;&#3610;&#3633;&#3610;&#3648;&#3605;&#3655;&#3617;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3649;&#3609;&#3610;&#3649;&#3621;&#3657;&#3623;',0),(357255,9924,'hi','à¤¸à¤‚à¤²à¤—à¥à¤¨ à¤¹à¥ˆ à¤†à¤ªà¤•à¥‡ à¤¸à¤®à¤°à¥à¤¥à¤• Forma à¤šà¤¾à¤²à¤¾à¤¨',0),(357256,9924,'ms','Berikut adalah invois Pro Forma',0),(357257,9924,'ar','Ø§Ù„Ù…Ø±ÙÙ‚Ø© Ù‡ÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ© Ø¨Ø±Ùˆ',0),(357258,9924,'fr','AttachÃ© est votre facture Pro',0),(357259,9924,'jp','æ·»ä»˜ã‚ãªãŸãƒ—ãƒ­é€ã‚ŠçŠ¶ã®ã§ã™ã€‚',0),(357260,9924,'pt','Em anexo Ã© sua fatura Proforma Pro',0),(357261,9924,'ru','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ ÑÑ‡ÐµÑ‚Ñƒ Pro Forma',0),(357262,9924,'es','Adjnto es su Factura Proforma',0),(357263,9924,'de','Angeschlossen ist Ihr Pro Forma Invoice',0),(357264,9924,'en','Attached is your Pro Forma Invoice',0),(357265,9925,'is','',0),(357266,9925,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ù¾ÙŠØ´ ÙØ§ÙƒØªÙˆØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(357267,9925,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ù¾ÙŠØ´ ÙØ§ÙƒØªÙˆØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(357268,9925,'tr','Pro Forma fatura gÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klatÄ±n',0),(357269,9925,'pl','Kliknij, aby wyÅ›wietliÄ‡ faktura proforma',0),(357270,9925,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ„Ð¾Ñ€Ð¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(357271,9925,'ur','Ù¾Ø±Ùˆ ÙØ§Ø±Ù…Ø§ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(357272,9925,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ ÐŸÑ€Ð¾ Ð¤Ð¾Ñ€Ð¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(357273,9925,'vi','Nháº¥n vÃ o Ä‘á»ƒ xem bÃ¡o giÃ¡',0),(357274,9925,'af','Kliek om te Proforma Faktuur te Besigtig',0),(357275,9925,'ro','Click pentru a vizualiza factura Pro Forma',0),(357276,9925,'et','Pro Forma arve vaatamiseks klÃµpsake',0),(357277,9925,'si','Kliknite za ogled Pro Forma raÄuna',0),(357278,9925,'ba','Klik untuk melihat Pro Forma Invoice',0),(357279,9925,'nl','Klik om te bekijken van de Pro Forma factuur',0),(357280,9925,'fi','Klikkaa nÃ¤hdÃ¤ksesi Pro Forma-laskun',0),(357281,9925,'no','Klikk for Ã¥ vise Pro Forma-faktura',0),(357282,9925,'da','Klik her for at se Pro Forma faktura',0),(357283,9925,'ko','í´ë¦­ í•˜ ì—¬ í”„ë¡œ ê²¬ì  ì†¡ìž¥ ë³´ê¸°',0),(357284,9925,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’ ×—×©×‘×•× ×™×ª ×¤×¨×•×¤×•×¨×ž×”',0),(357285,9925,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Pro Forma Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(357286,9925,'zh','ç‚¹å‡»æŸ¥çœ‹å½¢å¼å‘ç¥¨\r\n',0),(357287,9925,'sv','Klicka fÃ¶r att Visa Pro Forma faktura',0),(357288,9925,'it','Clicca per visualizzare la fattura proforma',0),(357289,9925,'tl','',0),(357290,9925,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3641;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3593;&#3610;&#3633;&#3610;&#3648;&#3605;&#3655;&#3617;',0),(357291,9925,'hi','à¤ªà¥à¤°à¥‹ Forma à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(357292,9925,'ms','Klik untuk melihat Pro Forma invois',0),(357293,9925,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ø¹Ø±Ø¶ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø¨Ø¯Ø¦ÙŠØ© Ø¨Ø±Ùˆ',0),(357294,9925,'fr','Cliquez pour visualiser le Pro Forma facture',0),(357295,9925,'jp','ãƒ—ãƒ­é€ã‚ŠçŠ¶ã‚’è¡¨ç¤ºã™ã‚‹] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(357296,9925,'pt','Clique para ver os Pro fatura Proforma',0),(357297,9925,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð¿Ñ€Ð¾ ÑÑ‡ÐµÑ‚-Ð¿Ñ€Ð¾Ñ„Ð¾Ñ€Ð¼Ð°',0),(357298,9925,'es','Hacer Clic para Visionar la Factura Proforma',0),(357299,9925,'de','Klicken Sie Pro Forma Rechnung an',0),(357300,9925,'en','Click to View Pro Forma Invoice',0),(357301,9926,'is','',0),(357302,9926,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ù¾ÙŠØ´ ÙØ§ÙƒØªÙˆØ± ',0),(357303,9926,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ù¾ÙŠØ´ ÙØ§ÙƒØªÙˆØ± ',0),(357304,9926,'tr','Pro Forma fatura e-posta',0),(357305,9926,'pl','Poczta elektroniczna faktura proforma',0),(357306,9926,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð¿Ñ€Ð¾Ñ„Ð¾Ñ€Ð¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(357307,9926,'ur','Ù¾Ø±Ùˆ ÙØ§Ø±Ù…Ø§ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(357308,9926,'sr','Ð• -ÐŸÑ€Ð¾ Ð¤Ð¾Ñ€Ð¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(357309,9926,'vi','ThÆ° Romaforma invoice',0),(357310,9926,'af','E-pos Proforma Faktuur',0),(357311,9926,'ro','FacturÄƒ Pro Forma de e-mail',0),(357312,9926,'et','Pro Forma arve emaili',0),(357313,9926,'si','E-Pro Forma raÄuna',0),(357314,9926,'ba','Email Pro Forma Invoice',0),(357315,9926,'nl','E-mail Pro Forma factuur',0),(357316,9926,'fi','Email Pro Forma-laskun',0),(357317,9926,'no','E-Pro Forma-faktura',0),(357318,9926,'da','Email Pro Forma faktura',0),(357319,9926,'ko','í”„ë¡œ ê²¬ì  ì†¡ìž¥ ì´ë©”ì¼',0),(357320,9926,'he','×“×•× ×œ ×—×©×‘×•× ×™×ª ×¤×¨×•×¤×•×¨×ž×”',0),(357321,9926,'el','Pro Forma Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(357322,9926,'zh','ç”µå­é‚®ä»¶å½¢å¼å‘ç¥¨\r\n',0),(357323,9926,'sv','E-Pro Forma faktura',0),(357324,9926,'it','E-mail fattura proforma',0),(357325,9926,'tl','',0),(357326,9926,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3593;&#3610;&#3633;&#3610;&#3648;&#3605;&#3655;&#3617;',0),(357327,9926,'hi','à¤ˆà¤®à¥‡à¤² à¤¸à¤®à¤°à¥à¤¥à¤• Forma à¤šà¤¾à¤²à¤¾à¤¨',0),(357328,9926,'ms','E-mel Pro Forma invois',0),(357329,9926,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¨Ø±Ùˆ ÙÙˆØ±Ù…Ø§ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(357330,9926,'fr','Pro Forma facture par courriel',0),(357331,9926,'jp','ãƒ—ãƒ­é€ã‚ŠçŠ¶ã‚’ãƒ¡ãƒ¼ãƒ«',0),(357332,9926,'pt','E-mail Pro fatura Proforma',0),(357333,9926,'ru','Pro Forma ÑÑ‡ÐµÑ‚Ð° Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(357334,9926,'es','Email Factura Proforma',0),(357335,9926,'de','E-Mail Pro Forma Rechnung',0),(357336,9926,'en','Email Pro Forma Invoice',0),(357337,9927,'is','',0),(357338,9927,'dr','Ù¾ÙŠØ´ ÙØ§Ú©ØªÙˆØ±',0),(357339,9927,'pr','Ù¾ÙŠØ´ ÙØ§Ú©ØªÙˆØ±',0),(357340,9927,'tr','Pro Forma fatura',0),(357341,9927,'pl','Faktura proforma',0),(357342,9927,'bg','ÐŸÑ€Ð¾Ñ„Ð¾Ñ€Ð¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(357343,9927,'ur','Ù¾Ø±Ùˆ ÙØ§Ø±Ù…Ø§ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(357344,9927,'sr','ÐŸÑ€Ð¾ Ð¤Ð¾Ñ€Ð¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(357345,9927,'vi','hÃ³a Ä‘Æ¡n nhÃ¡p',0),(357346,9927,'af','Proforma Faktuur',0),(357347,9927,'ro','FacturÄƒ Pro Forma',0),(357348,9927,'et','Pro Forma arve',0),(357349,9927,'si','Pro Forma raÄuna',0),(357350,9927,'ba','Pro Forma Invoice',0),(357351,9927,'nl','Pro Forma factuur',0),(357352,9927,'fi','Pro Forma-laskun',0),(357353,9927,'no','Pro Forma-faktura',0),(357354,9927,'da','Pro Forma faktura',0),(357355,9927,'ko','í”„ë¡œ ê²¬ì  ì†¡ìž¥',0),(357356,9927,'he','×—×©×‘×•× ×™×ª ×¤×¨×•×¤×•×¨×ž×”',0),(357357,9927,'el','Pro Forma Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(357358,9927,'zh','å½¢å¼å‘ç¥¨\r\n',0),(357359,9927,'sv','Pro Forma faktura',0),(357360,9927,'it','Fattura proforma',0),(357361,9927,'tl','',0),(357362,9927,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3593;&#3610;&#3633;&#3610;&#3648;&#3605;&#3655;&#3617;',0),(357363,9927,'hi','à¤ªà¥à¤°à¥‹ Forma à¤šà¤¾à¤²à¤¾à¤¨',0),(357364,9927,'ms','Pro Forma invois',0),(357365,9927,'ar','Ø¨Ø±Ùˆ ÙÙˆØ±Ù…Ø§ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(357366,9927,'fr','Pro Forma facture',0),(357367,9927,'jp','ãƒ—ãƒ­é€ã‚ŠçŠ¶',0),(357368,9927,'pt','Pro fatura Proforma',0),(357369,9927,'ru','ÐŸÑ€Ð¾ ÑÑ‡ÐµÑ‚-Ð¿Ñ€Ð¾Ñ„Ð¾Ñ€Ð¼Ð°',0),(357370,9927,'es','Factura Proforma',0),(357371,9927,'de','Pro Forma Rechnung',0),(357372,9927,'en','Pro Forma Invoice',0),(357373,9928,'is','',0),(357374,9928,'dr','Ù¾ÙŠØ´ ÙØ§ÙƒØªÙˆØ± ',0),(357375,9928,'pr','Ù¾ÙŠØ´ ÙØ§ÙƒØªÙˆØ± ',0),(357376,9928,'tr','Pro Forma fatura',0),(357377,9928,'pl','Faktura proforma',0),(357378,9928,'bg','ÐŸÑ€Ð¾Ñ„Ð¾Ñ€Ð¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(357379,9928,'ur','Ù¾Ø±Ùˆ ÙØ§Ø±Ù…Ø§ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(357380,9928,'sr','ÐŸÑ€Ð¾ Ð¤Ð¾Ñ€Ð¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(357381,9928,'vi','hÃ³a Ä‘Æ¡n táº¡m',0),(357382,9928,'af','Pro Forma faktuur',0),(357383,9928,'ro','FacturÄƒ Pro Forma',0),(357384,9928,'et','Pro Forma arve',0),(357385,9928,'si','Pro Forma raÄuna',0),(357386,9928,'ba','Pro Forma Invoice',0),(357387,9928,'nl','Pro Forma factuur',0),(357388,9928,'fi','Pro Forma-laskun',0),(357389,9928,'no','Pro Forma-faktura',0),(357390,9928,'da','Pro Forma faktura',0),(357391,9928,'ko','í”„ë¡œ ê²¬ì  ì†¡ìž¥',0),(357392,9928,'he','×—×©×‘×•× ×™×ª ×¤×¨×•×¤×•×¨×ž×”',0),(357393,9928,'el','Pro Forma Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(357394,9928,'zh','å½¢å¼å‘ç¥¨\r\n',0),(357395,9928,'sv','Pro Forma faktura',0),(357396,9928,'it','Fattura proforma',0),(357397,9928,'tl','',0),(357398,9928,'th','&#3651;&#3610;&#3649;&#3592;&#3657;&#3591;&#3627;&#3609;&#3637;&#3657;&#3593;&#3610;&#3633;&#3610;&#3648;&#3605;&#3655;&#3617;',0),(357399,9928,'hi','à¤ªà¥à¤°à¥‹ Forma à¤šà¤¾à¤²à¤¾à¤¨',0),(357400,9928,'ms','Pro Forma invois',0),(357401,9928,'ar','Ø¨Ø±Ùˆ ÙÙˆØ±Ù…Ø§ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(357402,9928,'fr','Pro Forma facture',0),(357403,9928,'jp','ãƒ—ãƒ­é€ã‚ŠçŠ¶',0),(357404,9928,'pt','Pro fatura Proforma',0),(357405,9928,'ru','ÐŸÑ€Ð¾ ÑÑ‡ÐµÑ‚-Ð¿Ñ€Ð¾Ñ„Ð¾Ñ€Ð¼Ð°',0),(357406,9928,'es','Factura Proforma',0),(357407,9928,'de','Pro Forma Rechnung',0),(357408,9928,'en','Pro Forma Invoice',0),(357409,9929,'is','',0),(357410,9929,'dr','Ø¨Ø±Ø§ÙŠ Ø§Ø¯Ø§Ù…Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(357411,9929,'pr','Ø¨Ø±Ø§ÙŠ Ø§Ø¯Ø§Ù…Ù‡ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ',0),(357412,9929,'tr','DevamÄ± iÃ§in tÄ±klayÄ±nÄ±z',0),(357413,9929,'pl','Kliknij, aby kontynuowaÄ‡',0),(357414,9929,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸',0),(357415,9929,'ur','Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(357416,9929,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸',0),(357417,9929,'vi','Nháº¥n Ä‘á»ƒ tiáº¿p tá»¥c',0),(357418,9929,'af','Kliek om Voort te Gaan',0),(357419,9929,'ro','Click pentru a continua',0),(357420,9929,'et','Kliki jÃ¤tkamiseks',0),(357421,9929,'si','Kliknite za nadaljevanje',0),(357422,9929,'ba','Klik untuk melanjutkan',0),(357423,9929,'nl','Klik om verder te',0),(357424,9929,'fi','Napsauta jatkaaksesi',0),(357425,9929,'no','Klikk for Ã¥ fortsette',0),(357426,9929,'da','Klik for at fortsÃ¦tte',0),(357427,9929,'ko','í´ë¦­ í•˜ ì—¬ ê³„ì†',0),(357428,9929,'he','×œ×—×¥ ×›×“×™ ×œ×”×ž×©×™×š',0),(357429,9929,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± ÏƒÏ…Î½ÎµÏ‡Î¯ÏƒÎµÏ„Îµ',0),(357430,9929,'zh','ç‚¹å‡»ç»§ç»­\r\n',0),(357431,9929,'sv','Klicka fÃ¶r att fortsÃ¤tta',0),(357432,9929,'it','Clicca per continuare',0),(357433,9929,'tl','',0),(357434,9929,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3652;&#3611;&#3605;&#3656;&#3629;',0),(357435,9929,'hi','à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚ à¤œà¤¾à¤°à¥€ à¤°à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(357436,9929,'ms','Klik untuk teruskan',0),(357437,9929,'ar','Ø£Ù†Ù‚Ø± Ù„Ù„Ø¥Ø³ØªÙ…Ø±Ø§Ø±',0),(357438,9929,'fr','Cliquez ici pour continuer',0),(357439,9929,'jp','ã‚¯ãƒªãƒƒã‚¯ã—ã¦ç¶šè¡Œã™ã‚‹ã«ã¯',0),(357440,9929,'pt','Clique aqui para continuar',0),(357441,9929,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð·Ð°ÐºÐ¾Ð½Ñ‡Ð¸Ñ‚ÑŒ',0),(357442,9929,'es','Hacer Clic para Continuar',0),(357443,9929,'de','Klicken Sie auf weiter',0),(357444,9929,'en','Click to Continue',0),(357445,9930,'is','',0),(357446,9930,'dr','Ø®Ø·Ø§ â€“ ÙØ§ÙŠÙ„ Ù‚Ø§Ø¨Ù„ Ù†ÙˆØ´ØªÙ† Ù†ÙŠØ³Øª',0),(357447,9930,'pr','Ø®Ø·Ø§ â€“ ÙØ§ÙŠÙ„ Ù‚Ø§Ø¨Ù„ Ù†ÙˆØ´ØªÙ† Ù†ÙŠØ³Øª',0),(357448,9930,'tr','Hata - dosya yazÄ±lamÄ±yor',0),(357449,9930,'pl','BÅ‚Ä…d - nie zapisu pliku',0),(357450,9930,'bg','Ð“Ñ€ÐµÑˆÐºÐ° - Ñ„Ð°Ð¹Ð»ÑŠÑ‚ Ð½Ðµ Ðµ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°ÐµÐ¼',0),(357451,9930,'ur','Ù†Ù‚Øµ - Ù…Ø³Ù„ Ù†ÛÛŒÚº Ù‚Ø§Ø¨Ù„ ØªØ­Ø±ÛŒØ±',0),(357452,9930,'sr','Ð“Ñ€ÐµÑˆÐºÐ° - Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð¿Ð¸ÑÐ°Ñ‚Ð¸',0),(357453,9930,'vi','Lá»—i - tá»‡p khÃ´ng thá»ƒ ghi',0),(357454,9930,'af','Fout - LÃªer nie Skryfbaar nie',0),(357455,9930,'ro','Eroare - dosar drepturi de scriere',0),(357456,9930,'et','Viga - fail pole kirjutatav',0),(357457,9930,'si','Napaka - ni zapisljiva datoteka',0),(357458,9930,'ba','Kesalahan - File tidak dapat ditulisi',0),(357459,9930,'nl','Fout - bestand niet schrijfbaar',0),(357460,9930,'fi','Virhe - tiedostoa ei voi kirjoittaa',0),(357461,9930,'no','Feil - filen ikke skrivbar',0),(357462,9930,'da','Fejl - filen ikke skrivbar',0),(357463,9930,'ko','ì˜¤ë¥˜-íŒŒì¼ ì“°ê¸° ê°€ëŠ¥ í•˜ì§€',0),(357464,9930,'he','×©×’×™××” - ×§×•×‘×¥ ×©×œ× × ×™×ª×Ÿ ×œ×›×ª×•×‘',0),(357465,9930,'el','Î£Ï†Î¬Î»Î¼Î± - Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÎµÎ³Î³ÏÎ¬ÏˆÎ¹Î¼Î¿',0),(357466,9930,'zh','é”™è¯¯- æ–‡ä»¶ä¸å¯å†™',0),(357467,9930,'sv','Fel - filen inte skrivbar',0),(357468,9930,'it','Errore - File non scrivibile',0),(357469,9930,'tl','',0),(357470,9930,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604; - &#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3648;&#3586;&#3637;&#3618;&#3609;&#3652;&#3615;&#3621;&#3660;&#3652;&#3604;&#3657;',0),(357471,9930,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ - à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¹à¥€à¤‚ à¤²à¤¿à¤–à¤¨à¥‡ à¤¯à¥‹à¤—à¥à¤¯',0),(357472,9930,'ms','Ralat - fail tidak boleh tulis',0),(357473,9930,'ar','Ø®Ø·Ø£-Ù…Ù„Ù ØºÙŠØ± Ù‚Ø§Ø¨Ù„ Ù„Ù„ÙƒØªØ§Ø¨Ø©',0),(357474,9930,'fr','Erreur - pas accessible en Ã©criture de fichier',0),(357475,9930,'jp','ã‚¨ãƒ©ãƒ¼ - ãƒ•ã‚¡ã‚¤ãƒ«ãŒæ›¸ãè¾¼ã¿ç¦æ­¢',0),(357476,9930,'pt','Erro - arquivo nÃ£o gravÃ¡vel',0),(357477,9930,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° - Ð¤Ð°Ð¹Ð» ÐÐµ ÐŸÐ¸ÑˆÐµÑ‚ÑÑ',0),(357478,9930,'es','Error - File No Es Grabable',0),(357479,9930,'de','Fehler - Datei nicht beschreibbar',0),(357480,9930,'en','Error - File Not Writable',0),(357481,9931,'is','',0),(357482,9931,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø² ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ ',0),(357483,9931,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø² ÙƒØ±Ø¯Ù† ÙØ§ÙŠÙ„ ',0),(357484,9931,'tr','Dosya aÃ§Ä±lÄ±rken hata oluÅŸtu',0),(357485,9931,'pl','BÅ‚Ä…d otwarcia pliku',0),(357486,9931,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(357487,9931,'ur','Ù†Ù‚Øµ Ù…Ø³Ù„ Ú©Ú¾ÙˆÙ„ Ø±ÛØ§',0),(357488,9931,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ñ‚Ð²Ð°Ñ€Ð°ÑšÑƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(357489,9931,'vi','Lá»—i khi má»Ÿ file',0),(357490,9931,'af','Fout begaan met Opening van LÃªer',0),(357491,9931,'ro','Eroare de deschidere fiÅŸier',0),(357492,9931,'et','Faili avamisel ilmnes viga',0),(357493,9931,'si','Napaka pri odpiranju datoteke',0),(357494,9931,'ba','Kesalahan membuka File',0),(357495,9931,'nl','Error Opening File',0),(357496,9931,'fi','Virhe avattaessa tiedostoa',0),(357497,9931,'no','Feil under Ã¥pning av filen',0),(357498,9931,'da','Fejl Ã¥bning af fil',0),(357499,9931,'ko','ì˜¤ë¥˜ ì—´ê¸° íŒŒì¼',0),(357500,9931,'he','×©×’×™××” ×¤×ª×™×—×ª ×§×•×‘×¥',0),(357501,9931,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î¿ Î¬Î½Î¿Î¹Î³Î¼Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(357502,9931,'zh','æ‰“å¼€æ–‡ä»¶æ—¶å‡ºé”™',0),(357503,9931,'sv','Fel att Ã¶ppna filen',0),(357504,9931,'it','Errore apertura File',0),(357505,9931,'tl','',0),(357506,9931,'th','&#3586;&#3657;&#3629;&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3648;&#3611;&#3636;&#3604;&#3652;&#3615;&#3621;&#3660;',0),(357507,9931,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤–à¥‹à¤²à¤¨à¥‡ à¤«à¤¼à¤¾à¤‡à¤²',0),(357508,9931,'ms','Ralat membuka fail',0),(357509,9931,'ar','Ø®Ø·Ø£ ÙÙŠ ÙØªØ­ Ø§Ù„Ù…Ù„Ù',0),(357510,9931,'fr','Erreur ouverture fichier',0),(357511,9931,'jp','ã‚¨ãƒ©ãƒ¼é–‹ããƒ•ã‚¡ã‚¤ãƒ«',0),(357512,9931,'pt','Erro ao abrir arquivo',0),(357513,9931,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ð¸Ð¸ Ð¤Ð°Ð¹Ð»Ð°',0),(357514,9931,'es','Error Abriendo File',0),(357515,9931,'de','Fehler beim Ã–ffnen der Datei',0),(357516,9931,'en','Error Opening File',0),(357517,9932,'is','',0),(357518,9932,'dr','Ø§Ø±Ø³Ø§Ù„ ÙØ§ÙŠÙ„ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ ',0),(357519,9932,'pr','Ø§Ø±Ø³Ø§Ù„ ÙØ§ÙŠÙ„ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ ',0),(357520,9932,'tr','DÄ±ÅŸa aktarma dosyasÄ± oluÅŸturulur',0),(357521,9932,'pl','Wygenerowany plik eksportu',0),(357522,9932,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð», Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½',0),(357523,9932,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ù…Ø³Ù„ Ø¨Ù†Ø§Ø¦ÛŒ',0),(357524,9932,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð³ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ð½Ð°',0),(357525,9932,'vi','Káº¿t xuáº¥t file chung',0),(357526,9932,'af','UitvoerlÃªer Gegenereer',0),(357527,9932,'ro','ExportÄƒ fiÅŸierul generat',0),(357528,9932,'et','Ekspordi faili loodud',0),(357529,9932,'si','Izvozi datoteko, ustvarjeno',0),(357530,9932,'ba','Mengekspor File yang dihasilkan',0),(357531,9932,'nl','Exportbestand gegenereerd',0),(357532,9932,'fi','Luo vientitiedosto',0),(357533,9932,'no','Eksportfilen generert',0),(357534,9932,'da','Eksportfil genereret',0),(357535,9932,'ko','ë‚´ë³´ë‚´ê¸° íŒŒì¼ ìƒì„±',0),(357536,9932,'he','×™×™×¦×•× ×§×•×‘×¥ ×©× ×•×¦×¨',0),(357537,9932,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½Ï„Î±Î¹',0),(357538,9932,'zh','å¯¼å‡ºç”Ÿæˆæ–‡ä»¶\r\n',0),(357539,9932,'sv','Exportfilen genereras',0),(357540,9932,'it','Esportare File generato',0),(357541,9932,'tl','',0),(357542,9932,'th','&#3652;&#3615;&#3621;&#3660;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;&#3606;&#3641;&#3585;&#3626;&#3619;&#3657;&#3634;&#3591;',0),(357543,9932,'hi','à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(357544,9932,'ms','Eksport fail yang dihasilkan',0),(357545,9932,'ar','ØªØµØ¯ÙŠØ± Ù…Ù„Ù Ø§Ù„Ø°ÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡',0),(357546,9932,'fr','Exporter le fichier gÃ©nÃ©rÃ©',0),(357547,9932,'jp','ç”Ÿæˆã•ã‚ŒãŸã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«',0),(357548,9932,'pt','Arquivo de exportaÃ§Ã£o gerado',0),(357549,9932,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð¡Ð¾Ð·Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð¤Ð°Ð¹Ð»Ð°',0),(357550,9932,'es','File de ExportaciÃ³n Generado',0),(357551,9932,'de','Exportdatei generiert',0),(357552,9932,'en','Export File Generated',0),(357553,9933,'is','',0),(357554,9933,'dr','Ø´Ø±Ø§ÙŠØ· Ø§Ø±Ø³Ø§Ù„ ',0),(357555,9933,'pr','Ø´Ø±Ø§ÙŠØ· Ø§Ø±Ø³Ø§Ù„ ',0),(357556,9933,'tr','Ã–ÄŸeleri verme',0),(357557,9933,'pl','Eksportowanie elementÃ³w',0),(357558,9933,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(357559,9933,'ur','Ø§Ø´ÛŒØ§Ø¡ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(357560,9933,'sr','Ð˜Ð·Ð²Ð¾Ð· ÑÑ‚Ð°Ð²ÐºÐ¸',0),(357561,9933,'vi','káº¿t xuáº¥t má»¥c',0),(357562,9933,'af','Uitvoer van Items',0),(357563,9933,'ro','Elemente de export',0),(357564,9933,'et','Eksportida Ã¼ksusi',0),(357565,9933,'si','IzvoÅ¾eni elementi',0),(357566,9933,'ba','Mengekspor barang-barang',0),(357567,9933,'nl','Items exporteren',0),(357568,9933,'fi','ViennistÃ¤',0),(357569,9933,'no','Eksportere elementer',0),(357570,9933,'da','Eksport varer',0),(357571,9933,'ko','ìˆ˜ì¶œ í’ˆëª©',0),(357572,9933,'he','×™×¦× ×¤×¨×™×˜×™×',0),(357573,9933,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÎ¾Î±Î³Ï‰Î³ÏŽÎ½',0),(357574,9933,'zh','å‡ºå£é¡¹ç›®\r\n',0),(357575,9933,'sv','Exportera objekt',0),(357576,9933,'it','Esportare gli elementi',0),(357577,9933,'tl','',0),(357578,9933,'th','&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;',0),(357579,9933,'hi','à¤†à¤‡à¤Ÿà¤® à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(357580,9933,'ms','Eksport barangan',0),(357581,9933,'ar','ØªØµØ¯ÙŠØ± Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(357582,9933,'fr','Exporter des Ã©lÃ©ments',0),(357583,9933,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(357584,9933,'pt','Exportar itens',0),(357585,9933,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(357586,9933,'es','Items de ExportaciÃ³n',0),(357587,9933,'de','Exportartikel',0),(357588,9933,'en','Export Items',0),(357589,9934,'is','',0),(357590,9934,'dr','CSV File ',0),(357591,9934,'pr','Ù†Ø§Ù… ÙØ§ÙŠÙ„ Ø§Ø³ÙƒÙŠ Ù…Ø­Ù„ÙŠ Ø¨Ø±Ø§ÙŠ ØµØ¯ÙˆØ± CSV File ',0),(357592,9934,'tr','Yerel CSV dosya adÄ±nÄ± vermek iÃ§in',0),(357593,9934,'pl','Nazwa pliku CSV lokalnych na eksport',0),(357594,9934,'bg','ÐœÐµÑÑ‚Ð½Ð¸ CSV Ñ„Ð°Ð¹Ð» Ð¸Ð¼Ðµ Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(357595,9934,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù‚Ø§Ù…ÛŒ CSV Ù…Ø³Ù„ Ù†Ø§Ù…',0),(357596,9934,'sr','Ð˜Ð¼Ðµ Ð»Ð¾ÐºÐ°Ð»Ð½Ð¾Ð³ Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ð¸Ð·Ð²Ð¾Ð·',0),(357597,9934,'vi','TÃªn tá»‡p CSV Ä‘á»‹a phÆ°Æ¡ng cho xuáº¥t kháº©u',0),(357598,9934,'af','Plaaslike CSV LÃ«ernaam vir Uitvoer',0),(357599,9934,'ro','Nume de fiÅŸier CSV locale pentru Export',0),(357600,9934,'et','Kohaliku CSV faili nimi ekspordiks',0),(357601,9934,'si','Ime lokalne CSV datoteke za izvoz',0),(357602,9934,'ba','Nama File CSV lokal untuk ekspor',0),(357603,9934,'nl','Lokale CSV-bestandsnaam voor uitvoer',0),(357604,9934,'fi','Paikallinen CSV-tiedostonimi vieminen',0),(357605,9934,'no','Lokale CSV-filnavn for eksport',0),(357606,9934,'da','Lokale CSV filnavn til eksport',0),(357607,9934,'ko','ìˆ˜ì¶œì— ëŒ€ í•œ ë¡œì»¬ CSV íŒŒì¼ ì´ë¦„',0),(357608,9934,'he','×©× ×§×•×‘×¥ CSV ×”×ž×§×•×ž×™ ×œ×™×™×¦×•×',0),(357609,9934,'el','ÎŒÎ½Î¿Î¼Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï… CSV Ï„Î¿Ï€Î¹ÎºÏŒ Î³Î¹Î± ÎµÎ¾Î±Î³Ï‰Î³Î®',0),(357610,9934,'zh','æœ¬åœ°çš„CSVæ–‡ä»¶åå‡ºå£\r\n',0),(357611,9934,'sv','Lokala CSV-filens namn fÃ¶r Export',0),(357612,9934,'it','Nome del File CSV locale per l\'esportazione',0),(357613,9934,'tl','',0),(357614,9934,'th','&#3594;&#3639;&#3656;&#3629;&#3607;&#3657;&#3629;&#3591;&#3606;&#3636;&#3656;&#3609;&#3652;&#3615;&#3621;&#3660; CSV &#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;',0),(357615,9934,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ CSV à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¾à¤®',0),(357616,9934,'ms','Nama fail CSV tempatan bagi eksport',0),(357617,9934,'ar','Ø§Ø³Ù… Ù…Ù„Ù CSV Ø§Ù„Ù…Ø­Ù„ÙŠØ© Ù„Ù„ØªØµØ¯ÙŠØ±',0),(357618,9934,'fr','Nom du fichier CSV locaux destinÃ©s Ã  l\'exportation',0),(357619,9934,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆç”¨ã®ãƒ­ãƒ¼ã‚«ãƒ« CSV ãƒ•ã‚¡ã‚¤ãƒ«å',0),(357620,9934,'pt','Nome do arquivo CSV locais para exportaÃ§Ã£o',0),(357621,9934,'ru','Ð˜Ð¼Ñ Ð»Ð¾ÐºÐ°Ð»ÑŒÐ½Ð¾Ð³Ð¾ CSV Ñ„Ð°Ð¹Ð»Ð° Ð´Ð»Ñ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(357622,9934,'es','Nombre de File de CSV Local para ExportaciÃ³n',0),(357623,9934,'de','Lokale CSV-Dateinamen fÃ¼r den Export',0),(357624,9934,'en','Local CSV File Name for Export',0),(357625,9935,'is','',0),(357626,9935,'dr','Ù†ÙˆØ´ØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(357627,9935,'pr','Ù†ÙˆØ´ØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(357628,9935,'tr','YazÄ±lÄ± deÄŸil',0),(357629,9935,'pl','Nie napisaÅ‚',0),(357630,9935,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸',0),(357631,9935,'ur','Ù†ÛÛŒÚº Ù„Ú©Ú¾Ø§',0),(357632,9935,'sr','ÐÐ¸Ñ˜Ðµ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(357633,9935,'vi','khÃ´ng Ä‘Æ°á»£c viáº¿t',0),(357634,9935,'af','Geskryf nie',0),(357635,9935,'ro','Nu scris',0),(357636,9935,'et','Ei saa kirjutada',0),(357637,9935,'si','Ne koncu',0),(357638,9935,'ba','Tidak tertulis',0),(357639,9935,'nl','Niet geschreven',0),(357640,9935,'fi','Ole kirjoitettu',0),(357641,9935,'no','Ikke skrevet',0),(357642,9935,'da','Ikke skrevet',0),(357643,9935,'ko','ê¸°ë¡ ë˜ì§€',0),(357644,9935,'he','×œ× × ×›×ª×‘',0),(357645,9935,'el','Î”ÎµÎ½ Î³ÏÎ¬Ï†ÎµÏ„Î±Î¹',0),(357646,9935,'zh','ä¸å†™\r\n',0),(357647,9935,'sv','Inte skrivit',0),(357648,9935,'it','Non scritti',0),(357649,9935,'tl','',0),(357650,9935,'th','&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3648;&#3586;&#3637;&#3618;&#3609;',0),(357651,9935,'hi','à¤¨à¤¹à¥€à¤‚ à¤²à¤¿à¤–à¤¾',0),(357652,9935,'ms','Tidak bertulis',0),(357653,9935,'ar','Ù„Ù… ÙŠÙƒØªØ¨',0),(357654,9935,'fr','Ne pas Ã©crit',0),(357655,9935,'jp','æ›¸ã‹ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(357656,9935,'pt','NÃ£o estÃ¡ escrito',0),(357657,9935,'ru','ÐÐµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(357658,9935,'es','No Escrito',0),(357659,9935,'de','Nicht geschrieben',0),(357660,9935,'en','Not Written',0),(357661,9936,'is','',0),(357662,9936,'dr','Ø¨Ø±Ø§ÙŠ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(357663,9936,'pr','Ø¨Ø±Ø§ÙŠ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÙŠÙ„ Ø§Ø±Ø³Ø§Ù„ ÙƒØ§Ù„Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(357664,9936,'tr','Madde verme dosyasÄ±nÄ± indirmek iÃ§in tÄ±klayÄ±nÄ±z',0),(357665,9936,'pl','Kliknij, aby pobraÄ‡ plik eksportu towaru',0),(357666,9936,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¸Ð·Ñ‚ÐµÐ³Ð»Ð¸Ñ‚Ðµ Ñ„Ð°Ð¹Ð» Ð·Ð° ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(357667,9936,'ur','Ø´Û’ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ù…Ø³Ù„ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Û’ Ù„Ø¦Û’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(357668,9936,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÐ»Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ Ð¸Ð·Ð²Ð¾Ð·Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(357669,9936,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ táº£i vá» táº­p tin xuáº¥t kháº©u má»¥c',0),(357670,9936,'af','Kliek om Item UitvoerlÃªer af te laai',0),(357671,9936,'ro','Click pentru a descÄƒrca fiÅŸierul de Export element',0),(357672,9936,'et','KlÃµpsake kauba ekspordi fail allalaadimiseks',0),(357673,9936,'si','Kliknite, Äe Å¾elite artikel izvozno datoteko prenesite',0),(357674,9936,'ba','Klik untuk men-Download File ekspor Item',0),(357675,9936,'nl','Klik om te downloaden van Item exportbestand',0),(357676,9936,'fi','Lataa nimikkeen vientitiedosto',0),(357677,9936,'no','Klikk for Ã¥ laste elementet eksportfilen',0),(357678,9936,'da','Klik her for at hente varen eksportfilen',0),(357679,9936,'ko','í•­ëª© ë‚´ë³´ë‚´ê¸° íŒŒì¼ì„ ë‹¤ìš´ë¡œë“œ í•˜ë ¤ë©´ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(357680,9936,'he','×œ×—×¦×• ×œ×”×•×¨×“×ª ×§×•×‘×¥ ×”×™×™×¦×•× ×¤×¨×™×˜',0),(357681,9936,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± ÎºÎ±Ï„ÎµÎ²Î¬ÏƒÎµÏ„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(357682,9936,'zh','ç‚¹å‡»ä¸‹è½½é¡¹ç›®å¯¼å‡ºçš„æ–‡ä»¶\r\n',0),(357683,9936,'sv','Klicka fÃ¶r att hÃ¤mta objektet exportfil',0),(357684,9936,'it','Clicca qui per scaricare il File di esportazione di elementi',0),(357685,9936,'tl','',0),(357686,9936,'th','&#3588;&#3621;&#3636;&#3585;&#3648;&#3614;&#3639;&#3656;&#3629;&#3604;&#3634;&#3623;&#3609;&#3660;&#3650;&#3627;&#3621;&#3604;&#3619;&#3634;&#3618;&#3585;&#3634;&#3619;&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;&#3652;&#3615;&#3621;&#3660;',0),(357687,9936,'hi','à¤†à¤‡à¤Ÿà¤® à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(357688,9936,'ms','Klik untuk muat turun fail eksport barangan',0),(357689,9936,'ar','Ø§Ø¶ØºØ· Ù‡Ù†Ø§ Ù„ØªØ­Ù…ÙŠÙ„ Ù…Ù„Ù ØªØµØ¯ÙŠØ± Ø§Ù„Ø¨Ù†Ø¯',0),(357690,9936,'fr','Cliquez ici pour tÃ©lÃ©charger le fichier d\'exportation de point',0),(357691,9936,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã™ã‚‹] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(357692,9936,'pt','Clique para baixar o arquivo de exportaÃ§Ã£o do Item',0),(357693,9936,'ru','Ð©ÐµÐ»ÐºÐ½Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐºÐ°Ñ‡Ð°Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(357694,9936,'es','Hacer Clic para Descargar Archivo de ExportaciÃ³n de Item',0),(357695,9936,'de','Klicken Sie auf das Element-Export-Datei herunterladen',0),(357696,9936,'en','Click to Download Item Export File',0),(357697,9937,'is','',0),(357698,9937,'dr','Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ ',0),(357699,9937,'pr','Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ ',0),(357700,9937,'tr','Kategori adÄ±',0),(357701,9937,'pl','Nazwa kategorii',0),(357702,9937,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(357703,9937,'ur','Ù‚Ø³Ù… Ú©Ø§ Ù†Ø§Ù…',0),(357704,9937,'sr','Ð˜Ð¼Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(357705,9937,'vi','TÃªn thá»ƒ loáº¡i',0),(357706,9937,'af','Kategorie Naam',0),(357707,9937,'ro','Numele categoriei',0),(357708,9937,'et','Kategooria nimetus',0),(357709,9937,'si','Ime kategorije',0),(357710,9937,'ba','Nama kategori',0),(357711,9937,'nl','Categorienaam',0),(357712,9937,'fi','Luokkanimi',0),(357713,9937,'no','Kategorinavn',0),(357714,9937,'da','Kategorinavn',0),(357715,9937,'ko','ì¹´í…Œê³ ë¦¬ ì´ë¦„',0),(357716,9937,'he','×©× ×”×§×˜×’×•×¨×™×”',0),(357717,9937,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚',0),(357718,9937,'zh','åˆ†ç±»åç§°\r\n',0),(357719,9937,'sv','Kategorinamn',0),(357720,9937,'it','Nome categoria',0),(357721,9937,'tl','',0),(357722,9937,'th','&#3594;&#3639;&#3656;&#3629;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(357723,9937,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¨à¤¾à¤®',0),(357724,9937,'ms','Nama kategori',0),(357725,9937,'ar','Ø¥Ø³Ù… Ø§Ù„ØªØµÙ†ÙŠÙ',0),(357726,9937,'fr','Nom de la catÃ©gorie',0),(357727,9937,'jp','ã‚«ãƒ†ã‚´ãƒªå',0),(357728,9937,'pt','Nome da categoria',0),(357729,9937,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(357730,9937,'es','Nombre de CategorÃ­a',0),(357731,9937,'de','Kategorienamen',0),(357732,9937,'en','Category Name',0),(357733,9938,'is','',0),(357734,9938,'dr','ÙƒÙ¾ÙŠ Ø¯Ø± Ù…ØªÙ† Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(357735,9938,'pr','ÙƒÙ¾ÙŠ Ø¯Ø± Ù…ØªÙ† Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(357736,9938,'tr','Metin programa kopyalama',0),(357737,9938,'pl','Skopiuj tekst programu',0),(357738,9938,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐºÑÑ‚ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð°',0),(357739,9938,'ur','Ù…ØªÙ† Ú©Û’ Ù¾Ø±ÙˆÚ¯Ø±Ø§Ù… Ú©Û’ Ù„ÛŒÛ’ Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(357740,9938,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ñ‚ÐµÐºÑÑ‚Ð° Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð°',0),(357741,9938,'vi','Sao chÃ©p ngÃ´n ngá»¯ diá»…n giáº£i',0),(357742,9938,'af','Kopieer na Tikprograam',0),(357743,9938,'ro','CopiaÅ£i textul programului',0),(357744,9938,'et','Kopeerige tekst programm',0),(357745,9938,'si','Kopirajte besedilo programa',0),(357746,9938,'ba','Salin ke teks Program',0),(357747,9938,'nl','Naar tekstprogramma kopiÃ«ren',0),(357748,9938,'fi','Kopioi ohjelma',0),(357749,9938,'no','Kopiere tekst program',0),(357750,9938,'da','Kopiere tekst program',0),(357751,9938,'ko','í…ìŠ¤íŠ¸ í”„ë¡œê·¸ëž¨ì— ë³µì‚¬',0),(357752,9938,'he','×”×¢×ª×§ ×˜×§×¡×˜ ×œ×ª×•×›× ×™×ª',0),(357753,9938,'el','Î‘Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î±',0),(357754,9938,'zh','å¤åˆ¶åˆ°æ–‡æœ¬ç¨‹åº\r\n',0),(357755,9938,'sv','Kopiera Text program',0),(357756,9938,'it','Copiare testo programma',0),(357757,9938,'tl','',0),(357758,9938,'th','&#3588;&#3633;&#3604;&#3621;&#3629;&#3585;&#3652;&#3611;&#3618;&#3633;&#3591;&#3650;&#3611;&#3619;&#3649;&#3585;&#3619;&#3617;&#3586;&#3657;&#3629;&#3588;&#3623;&#3634;&#3617;',0),(357759,9938,'hi','à¤ªà¤¾à¤  à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¥‹à¤—à¥à¤°à¤¾à¤® à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(357760,9938,'ms','Salin ke Program teks',0),(357761,9938,'ar','Ù†Ø³Ø® Ø¥Ù„Ù‰ Ø¨Ø±Ù†Ø§Ù…Ø¬ Ø§Ù„Ù†Øµ',0),(357762,9938,'fr','Copier texte programme',0),(357763,9938,'jp','ãƒ†ã‚­ã‚¹ãƒˆ ãƒ—ãƒ­ã‚°ãƒ©ãƒ ã¸ã®ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(357764,9938,'pt','Copiar para o programa de texto',0),(357765,9938,'ru','Ð¡ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ‚ÐµÐºÑÑ‚ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ñ‹',0),(357766,9938,'es','Copia al Programa de Texto',0),(357767,9938,'de','Textprogramm kopieren',0),(357768,9938,'en','Copy to Text Program',0),(357769,9939,'is','',0),(357770,9939,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø± Ø§ÙƒØ³Ù„ Ø¨Ø§ Ø¬Ø¯Ø§ ÙƒÙ†Ù†Ø¯Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(357771,9939,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø± Ø§ÙƒØ³Ù„ Ø¨Ø§ Ø¬Ø¯Ø§ ÙƒÙ†Ù†Ø¯Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ ',0),(357772,9939,'tr','SeÃ§ili ayÄ±rÄ±cÄ± Bar ile Excel\'e alma',0),(357773,9939,'pl','Importowania do programu Excel z pasek separatora wybrane',0),(357774,9939,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð² Excel Ñ Ð±Ð°Ñ€ Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ» Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(357775,9939,'ur','Ø¬Ø¯Ø§ Ú©Ø§Ø± Ù…Ù†ØªØ®Ø¨ Ø¨Ø§Ø± Ú©Û’ Ø³Ø§ØªÚ¾ Excel Ù…ÛŒÚº Ø¯Ø±Ø¢Ù…Ø¯',0),(357776,9939,'sr','Ð£Ð²Ð¾Ð· Ñƒ Ð•xÑ†ÐµÐ» Ð¿Ð¾Ð¼Ð¾Ñ›Ñƒ Ñ‚Ñ€Ð°ÐºÐ° Ð·Ð° Ñ€Ð°Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(357777,9939,'vi','Nháº­p vÃ o Excel vá»›i thanh chia tÃ¡ch Ä‘Æ°á»£c chá»n',0),(357778,9939,'af','Invoer Binne-in Excel met Staafverdeler (\"Bar Seperator\") Gekies',0),(357779,9939,'ro','Importul Ã®n Excel cu Bar Separator selectate',0),(357780,9939,'et','Import Exceli koos Baar valitud eraldaja',0),(357781,9939,'si','Uvozu v Excel z Bar loÄilo izbrano',0),(357782,9939,'ba','Impor ke Excel dengan Bar pemisah yang dipilih',0),(357783,9939,'nl','Invoer in Excel met Bar scheidingsteken geselecteerd',0),(357784,9939,'fi','Tuominen Exceliin Baari erotin on valittuna',0),(357785,9939,'no','Importere til Excel med Bar skillefiguren',0),(357786,9939,'da','Import til Excel med Bar Separator valgt',0),(357787,9939,'ko','ì„ íƒ êµ¬ë¶„ ë°”ì™€ í•¨ê»˜ Excelë¡œ ê°€ì ¸ì˜¤ê¸°',0),(357788,9939,'he','×™×™×‘×•× ×œ×ª×•×š Excel ×¢× ×‘×¨ ×ž×¤×¨×™×“ ×©× ×‘×—×¨×•',0),(357789,9939,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏ„Î¿ Excel Î¼Îµ Î¼Ï€Î±Ï Î´Î¹Î±Ï‡Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(357790,9939,'zh','å¯¼å…¥é€‰æ‹©çš„æ¡ç›®åˆ†ç¦»å™¨åˆ°Excelè¡¨ä¸­\r\n',0),(357791,9939,'sv','Import till Excel med Bar avgrÃ¤nsare valt',0),(357792,9939,'it','Importazione in Excel con barra separatore selezionato',0),(357793,9939,'tl','',0),(357794,9939,'th','Import Into Excel with Bar Separator Selected',0),(357795,9939,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤µà¤¿à¤­à¤¾à¤œà¤• à¤ªà¤Ÿà¥à¤Ÿà¥€ à¤•à¥‡ à¤¸à¤¾à¤¥ Excel à¤®à¥‡à¤‚ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(357796,9939,'ms','Import ke dalam Excel dengan Bar pemisah yang dipilih',0),(357797,9939,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯Ù‡Ø§ Ø¥Ù„Ù‰ Excel Ù…Ø¹ Ø´Ø±ÙŠØ· ÙØ§ØµÙ„ Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(357798,9939,'fr','Importation dans Excel avec barre sÃ©parateur sÃ©lectionnÃ©',0),(357799,9939,'jp','ã‚»ãƒ‘ãƒ¬ãƒ¼ã‚¿ãƒ¼ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦ãƒãƒ¼ã‚’ä½¿ç”¨ã—ãŸ Excel ã¸ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(357800,9939,'pt','ImportaÃ§Ã£o para o Excel com Bar separador seleccionado',0),(357801,9939,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð² Excel Ñ Ð‘Ð°Ñ€ Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»Ñ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(357802,9939,'es','Importar a Excel con el Separador de Barras Seleccionado',0),(357803,9939,'de','Import in Excel mit Bar Trennzeichen ausgewÃ¤hlt',0),(357804,9939,'en','Import Into Excel with Bar Separator Selected',0),(357805,9940,'is','',0),(357806,9940,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø± ÙØ§ÙŠÙ„ Ù…ØªÙ†ÙŠ ',0),(357807,9940,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø¯Ø± ÙØ§ÙŠÙ„ Ù…ØªÙ†ÙŠ ',0),(357808,9940,'tr','TXT dosyasÄ± olarak kaydetme',0),(357809,9940,'pl','Zapisz jako plik TXT',0),(357810,9940,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ ÐºÐ°Ñ‚Ð¾ TXT Ñ„Ð°Ð¹Ð»',0),(357811,9940,'ur','TXT Ù…Ø³Ù„ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº Ø¨Ø·ÙˆØ±',0),(357812,9940,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ ÐºÐ°Ð¾ Ð¢XÐ¢ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(357813,9940,'vi','LÆ°u táº­p tin TXT',0),(357814,9940,'af','Stoor as TXT LÃªer',0),(357815,9940,'ro','SalvaÅ£i ca fiÅŸier TXT',0),(357816,9940,'et','Salvesta kui TXT fail',0),(357817,9940,'si','Shrani kot TXT datoteko',0),(357818,9940,'ba','Simpan sebagai TXT File',0),(357819,9940,'nl','Opslaan als TXT bestand',0),(357820,9940,'fi','Tallenna tekstitiedosto',0),(357821,9940,'no','Lagre som TXT-fil',0),(357822,9940,'da','Gemme som TXT-fil',0),(357823,9940,'ko','TXT íŒŒì¼ë¡œ ì €ìž¥',0),(357824,9940,'he','×©×ž×•×¨ ×›×§×•×‘×¥ ×˜×§×¡×˜',0),(357825,9940,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï‰Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿ TXT',0),(357826,9940,'zh','ä¿å­˜ä¸ºæ–‡æœ¬æ–‡ä»¶\r\n',0),(357827,9940,'sv','Spara som TXT-fil',0),(357828,9940,'it','Salvare come file. TXT',0),(357829,9940,'tl','',0),(357830,9940,'th','&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;&#3648;&#3611;&#3655;&#3609; TXT &#3652;&#3615;&#3621;&#3660;',0),(357831,9940,'hi','TXT à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(357832,9940,'ms','Simpan sebagai fail TXT',0),(357833,9940,'ar','Ø§Ù„ØªØ®Ø²ÙŠÙ† ÙƒÙ…Ù„Ù TXT',0),(357834,9940,'fr','Enregistrer en tant que fichier TXT',0),(357835,9940,'jp','TXT ãƒ•ã‚¡ã‚¤ãƒ«ã¨ã—ã¦ä¿å­˜ã—ã¾ã™ã€‚',0),(357836,9940,'pt','Salvar como arquivo TXT',0),(357837,9940,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ ÐºÐ°Ðº TXT Ð¤Ð°Ð¹Ð»',0),(357838,9940,'es','Guearda como File TXT',0),(357839,9940,'de','Speichern als TXT-Datei',0),(357840,9940,'en','Save as TXT File',0),(357841,9941,'is','',0),(357842,9941,'dr','Ø¬Ù‡Øª Ú†Ø§Ù¾ Ø³Ø± ØµÙØ­Ù‡ Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´  Ø¯Ø± Ù¾Ø§ÙŠÙŠÙ† ',0),(357843,9941,'pr','Ø¬Ù‡Øª Ú†Ø§Ù¾ Ø³Ø± ØµÙØ­Ù‡ Ø¨Ø±Ø§ÙŠ Ù†Ù…Ø§ÙŠØ´  Ø¯Ø± Ù¾Ø§ÙŠÙŠÙ† ',0),(357844,9941,'tr','AÅŸaÄŸÄ±da gÃ¶sterilen baÅŸlÄ±klarÄ± yakalamak iÃ§in',0),(357845,9941,'pl','Zdobycie nagÅ‚Ã³wki poniÅ¼ej',0),(357846,9941,'bg','Ð”Ð° ÑƒÐ»Ð¾Ð²Ð¸ Ð·Ð°Ð³Ð»Ð°Ð²ÐºÐ¸, Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½Ð¸ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ',0),(357847,9941,'ur','Ø¯Ú©Ú¾Ø§ÛŒØ§ Ú©Û’ Ù†ÛŒÚ†Û’ ÛÛŒÚˆØ± Ù¾Ø± Ù‚Ø¨Ø¶Û Ú©Ø±Ù†Ø§',0),(357848,9941,'sr','Ð—Ð° Ñ…Ð²Ð°Ñ‚Ð°ÑšÐµ Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½ Ð¸ÑÐ¿Ð¾Ð´',0),(357849,9941,'vi','Chá»¥p TiÃªu Ä‘á» Hiá»ƒn thá»‹ DÆ°á»›i Ä‘Ã¢y',0),(357850,9941,'af','Om te vang opskrifte hieronder',0),(357851,9941,'ro','Pentru a capta anteturile mai jos',0),(357852,9941,'et','LÃ¼Ã¼a allpool pÃ¤ised',0),(357853,9941,'si','Za zajemanje glave spodaj',0),(357854,9941,'ba','Untuk menangkap header yang ditunjukkan di bawah ini',0),(357855,9941,'nl','Om vast te leggen Headers hieronder',0),(357856,9941,'fi','Kaapata otsikoiden alla',0),(357857,9941,'no','Ã… fange overskriftene nedenfor',0),(357858,9941,'da','At fange headere vises nedenfor',0),(357859,9941,'ko','ì•„ëž˜ì— í‘œì‹œ ëœ í—¤ë”ë¥¼ ìº¡ì²˜',0),(357860,9941,'he','×›×“×™ ×œ×ª×¤×•×¡ ×›×•×ª×¨×•×ª ×”×ž×•×¦×’×•×ª ×œ×”×œ×Ÿ',0),(357861,9941,'el','ÎÎ± ÏƒÏ…Î»Î»Î¬Î²ÎµÎ¹ Ï„Î¹Ï‚ ÎºÎµÏ†Î±Î»Î¯Î´ÎµÏ‚ Ï€Î¿Ï… Ï†Î±Î¯Î½ÎµÏ„Î±Î¹ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰',0),(357862,9941,'zh','æ•æ‰ä¸‹é¢æ˜¾ç¤ºçš„æ ‡é¢˜\r\n',0),(357863,9941,'sv','Att fÃ¥nga rubriker visas nedan',0),(357864,9941,'it','Per catturare le intestazioni illustrate di seguito',0),(357865,9941,'tl','',0),(357866,9941,'th','To Capture Headers Shown Below',0),(357867,9941,'hi','à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤–à¤¾à¤ à¤—à¤ à¤¹à¥‡à¤¡à¤° à¤ªà¤° à¤•à¤¬à¥à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(357868,9941,'ms','Untuk menangkap pengepala-pengepala yang ditunjukkan di bawah',0),(357869,9941,'ar','Ù„Ø§Ù„ØªÙ‚Ø§Ø· Ø§Ù„Ø±Ø¤ÙˆØ³ ÙƒÙ…Ø§ ÙŠÙ„ÙŠ:',0),(357870,9941,'fr','Pour capturer les en-tÃªtes ci-dessous',0),(357871,9941,'jp','æ¬¡ã«ç¤ºã™ãƒ˜ãƒƒãƒ€ãƒ¼ã‚’ã‚­ãƒ£ãƒ—ãƒãƒ£ã™ã‚‹ã«ã¯',0),(357872,9941,'pt','Para capturar cabeÃ§alhos mostrados abaixo',0),(357873,9941,'ru','Ð”Ð»Ñ Ð·Ð°Ñ…Ð²Ð°Ñ‚Ð° Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²ÐºÐ¸, Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½Ð¾ Ð½Ð¸Ð¶Ðµ',0),(357874,9941,'es','Para Capturar Cabezeras Mostrados Abajo',0),(357875,9941,'de','Header unten erfassen',0),(357876,9941,'en','To Capture Headers Shown Below',0),(357877,9942,'is','',0),(357878,9942,'dr','Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(357879,9942,'pr','Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± ',0),(357880,9942,'tr','Stok birim fiyatÄ±nÄ± satÄ±cÄ±',0),(357881,9942,'pl','Cena jednostkowa zapasÃ³w',0),(357882,9942,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÑŠÑÑ‚Ð°Ð² ÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð°',0),(357883,9942,'ur','Ø§Ø³Ù¹Ø§Ú© ÛŒÙˆÙ†Ù¹ ÙÛŒ ÙˆÛŒÙ†ÚˆØ± Ù‚ÛŒÙ…Øª',0),(357884,9942,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð¿Ð¾Ñ˜ÐµÐ´Ð¸Ð½Ð°Ñ‡Ð½Ð° Ñ†ÐµÐ½Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(357885,9942,'vi','giÃ¡ cá»§a nhÃ  cung cáº¥p trÃªn má»—i Ä‘Æ¡n vá»‹ chá»©ng khoÃ¡n',0),(357886,9942,'af','Verskaffer Pryse per Voorraadeenheid',0),(357887,9942,'ro','Furnizor de preÅ£ul pe unitate de stoc',0),(357888,9942,'et','Tarnija laoseisu Ã¼hiku hind',0),(357889,9942,'si','Prodajalec cena na enoto zalog',0),(357890,9942,'ba','Vendor harga per Unit saham',0),(357891,9942,'nl','Leverancier voorraad eenheidsprijs',0),(357892,9942,'fi','Toimittajan varastossa YksikkÃ¶hinta',0),(357893,9942,'no','LeverandÃ¸rens pris per lager enhet',0),(357894,9942,'da','LeverandÃ¸ren lager enhedsprisen',0),(357895,9942,'ko','ìž¬ê³  ë‹¨ìœ„ ë‹¹ ê°€ê²© ê³µê¸‰ ì—…ì²´',0),(357896,9942,'he','×¡×¤×§ ×ž×—×™×¨ ×œ×™×—×™×“×” ×ž× ×™×•×ª',0),(357897,9942,'el','Î¤Î¹Î¼Î® Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Î¶Ï‰Î¹ÎºÎ¿Ï ÎºÎµÏ†Î±Î»Î±Î¯Î¿Ï…',0),(357898,9942,'zh','æ¯åº“å­˜å•ä½ä¾›åº”å•†å®šä»·\r\n',0),(357899,9942,'sv','LeverantÃ¶rens pris per aktie',0),(357900,9942,'it','Fornitore prezzo per unitÃ  di magazzino',0),(357901,9942,'tl','',0),(357902,9942,'th','&#3619;&#3634;&#3588;&#3634;&#3586;&#3629;&#3591;&#3612;&#3641;&#3657;&#3586;&#3634;&#3618;&#3605;&#3656;&#3629;&#3627;&#3609;&#3656;&#3623;&#3618;&#3626;&#3605;&#3655;&#3629;&#3588;',0),(357903,9942,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤•à¥€à¤®à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤¶à¥‡à¤¯à¤° à¤‡à¤•à¤¾à¤ˆ',0),(357904,9942,'ms','Penjual harga seunit saham',0),(357905,9942,'ar','Ø³Ø¹Ø± Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø© ØªØ®Ø²ÙŠÙ†',0),(357906,9942,'fr','Prix par unitÃ© de Stock',0),(357907,9942,'jp','åœ¨åº«å˜ä½ã‚ãŸã‚Šã®ãƒ™ãƒ³ãƒ€ãƒ¼ã®ä¾¡æ ¼',0),(357908,9942,'pt','Fornecedor preÃ§o por unidade de estoque',0),(357909,9942,'ru','Ð¦ÐµÐ½Ð° Ð°Ð±Ð¾Ð½ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð½Ð° ÑÐºÐ»Ð°Ð´Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(357910,9942,'es','Precio de Proveedor Por Unidad de Inventario',0),(357911,9942,'de','Kreditor hat Einzelpreis',0),(357912,9942,'en','Vendor Price per Stock Unit',0),(357913,9943,'is','',0),(357914,9943,'dr','Ø§Ø±Ø³Ø§Ù„',0),(357915,9943,'pr','Ø§Ø±Ø³Ø§Ù„',0),(357916,9943,'tr','Ä°hracat',0),(357917,9943,'pl','WywÃ³z',0),(357918,9943,'bg','Ð˜Ð·Ð½Ð¾Ñ',0),(357919,9943,'ur','Ø¨Ø±Ø¢Ù…Ø¯Ø§Øª',0),(357920,9943,'sr','Ð˜Ð·Ð²Ð¾Ð·',0),(357921,9943,'vi','Káº¿t xuáº¥t',0),(357922,9943,'af','Uitvoere',0),(357923,9943,'ro','Exporturile',0),(357924,9943,'et','Andmete Eksportimine',0),(357925,9943,'si','Izvoz',0),(357926,9943,'ba','Ekspor',0),(357927,9943,'nl','Export',0),(357928,9943,'fi','Vienti',0),(357929,9943,'no','Eksport',0),(357930,9943,'da','Eksport',0),(357931,9943,'ko','ìˆ˜ì¶œ',0),(357932,9943,'he','×™×¦×•×',0),(357933,9943,'el','Î•Î¾Î±Î³Ï‰Î³Î­Ï‚',0),(357934,9943,'zh','å‡ºå£\r\n',0),(357935,9943,'sv','Export',0),(357936,9943,'it','Esportazioni',0),(357937,9943,'tl','',0),(357938,9943,'th','&#3626;&#3656;&#3591;&#3629;&#3629;&#3585;',0),(357939,9943,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤',0),(357940,9943,'ms','Eksport',0),(357941,9943,'ar','ØªØµØ¯ÙŠØ± Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(357942,9943,'fr','Exportations',0),(357943,9943,'jp','è¼¸å‡º',0),(357944,9943,'pt','ExportaÃ§Ãµes',0),(357945,9943,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(357946,9943,'es','Exportaciones',0),(357947,9943,'de','Exporte',0),(357948,9943,'en','Exports',0),(357949,9944,'is','',0),(357950,9944,'dr','Ø³Ø§Ø¹Ø§Øª Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(357951,9944,'pr','Ø³Ø§Ø¹Ø§Øª Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(357952,9944,'tr','HastalÄ±k izni saatler kaldÄ±',0),(357953,9944,'pl','PozostaÅ‚e godziny urlopu',0),(357954,9944,'bg','ÐžÑ‚Ð¿ÑƒÑÐº Ð¿Ð¾ Ð±Ð¾Ð»ÐµÑÑ‚ Ñ‡Ð°ÑÐ¾Ð²Ðµ Ð¾ÑÑ‚Ð°Ð²Ð°Ñ‚',0),(357955,9944,'ur','Ø¨ÛŒÙ…Ø§Ø± Ú¯Ú¾Ù†Ù¹Û’ Ø¨Ø§Ù‚ÛŒ Ú†Ú¾ÙˆÚ‘ÛŒÚº',0),(357956,9944,'sr','Ð‘Ð¾Ð»Ð¾Ð²Ð°ÑšÐ° Ñ‡Ð°ÑÐ¾Ð²Ð°',0),(357957,9944,'vi','á»m giá» cÃ²n láº¡i',0),(357958,9944,'af','Oorblywende Siekverlof Ure ',0),(357959,9944,'ro','Concediu medical ore rÄƒmase',0),(357960,9944,'et','Tundi veel haiguslehel',0),(357961,9944,'si','BolniÅ¡kega dopusta, ure preostalo',0),(357962,9944,'ba','Cuti jam tersisa',0),(357963,9944,'nl','Ziek laat uur afloopt',0),(357964,9944,'fi','Sairausloma tuntia jÃ¤ljellÃ¤',0),(357965,9944,'no','SykefravÃ¦r timer igjen',0),(357966,9944,'da','SygefravÃ¦r timer tilbage',0),(357967,9944,'ko','ë³‘ê°€ ë‚¨ì€ ì‹œê°„',0),(357968,9944,'he','×—×•×œ×” ×œ×¢×–×•×‘ × ×©××¨×• ×©×¢×•×ª',0),(357969,9944,'el','Î‘Î½Î±ÏÏÏ‰Ï„Î¹ÎºÎ® Î¬Î´ÎµÎ¹Î± ÏŽÏÎµÏ‚ Î±Ï€Î¿Î¼Î­Î½Î¿Ï…Î½',0),(357970,9944,'zh','ç—…å‡å‰©ä½™æ—¶é—´\r\n',0),(357971,9944,'sv','SjukfrÃ¥nvaro timmar kvar',0),(357972,9944,'it','Congedo ore rimanenti',0),(357973,9944,'tl','',0),(357974,9944,'th','&#3594;&#3633;&#3656;&#3623;&#3650;&#3617;&#3591;&#3621;&#3634;&#3611;&#3656;&#3623;&#3618;&#3607;&#3637;&#3656;&#3648;&#3627;&#3621;&#3639;&#3629;&#3629;&#3618;&#3641;&#3656;',0),(357975,9944,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤¶à¥‡à¤· à¤¬à¥€à¤®à¤¾à¤° à¤›à¥‹à¤¡à¤¼ à¤¦à¥‹',0),(357976,9944,'ms','Cuti sakit yang jam lagi',0),(357977,9944,'ar','Ø§Ù„Ø¥Ø¬Ø§Ø²Ø© Ø§Ù„Ù…Ø±Ø¶ÙŠØ© Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(357978,9944,'fr','CongÃ© de maladie heures restantes',0),(357979,9944,'jp','ç—…æ¬ æ™‚é–“æ•°æ®‹ã‚Š',0),(357980,9944,'pt','Doente deixa horas restantes',0),(357981,9944,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾ÑÑ‚Ð°Ð²ÑˆÐ¸Ñ…ÑÑ Ñ‡Ð°ÑÐ¾Ð² Ð¾Ñ‚Ð¿ÑƒÑÐºÐ° Ð¿Ð¾ Ð±Ð¾Ð»ÐµÐ·Ð½Ð¸',0),(357982,9944,'es','Horas que Queda de Vacaciones de Enfermedad',0),(357983,9944,'de','Krankheitstage Stunden verbleibende',0),(357984,9944,'en','Sick Leave Hours Remaining',0),(357985,9945,'is','',0),(357986,9945,'dr','Ø³Ø§Ø¹Ø§Øª Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ù…Ø±Ø®ØµÙŠ ',0),(357987,9945,'pr','Ø³Ø§Ø¹Ø§Øª Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ù…Ø±Ø®ØµÙŠ ',0),(357988,9945,'tr','Saatler kalan tatil',0),(357989,9945,'pl','Wakacje, pozostaÅ‚e godziny',0),(357990,9945,'bg','Ð’Ð°ÐºÐ°Ð½Ñ†Ð¸Ð¾Ð½ÐµÐ½ Ñ‡Ð°ÑÐ¾Ð²Ðµ Ð¾ÑÑ‚Ð°Ð²Ð°Ñ‚',0),(357991,9945,'ur','Ú¯Ú¾Ù†Ù¹Û’ Ø¨Ø§Ù‚ÛŒ Ú†Ú¾Ù¹ÛŒ',0),(357992,9945,'sr','ÐžÐ´Ð¼Ð¾Ñ€ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ ÑÐ°Ñ‚Ð¸ Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾',0),(357993,9945,'vi','Ká»³ nghá»‰ giá» cÃ²n láº¡i',0),(357994,9945,'af','Oorblywende Vakansie Ure',0),(357995,9945,'ro','Vacanta ore rÄƒmase',0),(357996,9945,'et','Puhkuse tundi veel',0),(357997,9945,'si','PoÄitnice, preostale ure',0),(357998,9945,'ba','Liburan jam tersisa',0),(357999,9945,'nl','Vakantie uren resterende',0),(358000,9945,'fi','Loma tuntia jÃ¤ljellÃ¤',0),(358001,9945,'no','Ferie timer igjen',0),(358002,9945,'da','Ferie timer tilbage',0),(358003,9945,'ko','ë‚¨ì€ ì‹œê°„ íœ´ê°€',0),(358004,9945,'he','×©×¢×•×ª ×—×•×¤×©×” × ×•×ª×¨×™×',0),(358005,9945,'el','Î”Î¹Î±ÎºÎ¿Ï€Î­Ï‚ ÏŽÏÎµÏ‚ Î±Ï€Î¿Î¼Î­Î½Î¿Ï…Î½',0),(358006,9945,'zh','ä¼‘å‡æ—¶é—´å‰©ä½™\r\n',0),(358007,9945,'sv','Semester timmar kvar',0),(358008,9945,'it','Vacanze ore rimanenti',0),(358009,9945,'tl','',0),(358010,9945,'th','&#3619;&#3632;&#3618;&#3632;&#3648;&#3623;&#3621;&#3634;&#3623;&#3633;&#3609;&#3627;&#3618;&#3640;&#3604;&#3607;&#3637;&#3656;&#3604;&#3627;&#3621;&#3639;&#3629;',0),(358011,9945,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤¶à¥‡à¤· à¤›à¥à¤Ÿà¥à¤Ÿà¥€',0),(358012,9945,'ms','Percutian yang jam lagi',0),(358013,9945,'ar','Ø¥Ø¬Ø§Ø²Ø© Ø§Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(358014,9945,'fr','GÃ®te vacances heures restantes',0),(358015,9945,'jp','æ®‹å­˜æ™‚é–“ã®ä¼‘æš‡',0),(358016,9945,'pt','FÃ©rias horas restantes',0),(358017,9945,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾ÑÑ‚Ð°Ð²ÑˆÐ¸Ñ…ÑÑ Ñ‡Ð°ÑÐ¾Ð² Ð¾Ñ‚Ð¿ÑƒÑÐºÐ°',0),(358018,9945,'es','Horas Que se Queda de Vacaiones',0),(358019,9945,'de','Urlaub Stunden verbleibende',0),(358020,9945,'en','Vacation Hours Remaining',0),(358021,9946,'is','',0),(358022,9946,'dr','Ø¨Ù‡ ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ Ø§Ø±Ø¬Ø§Ø¹ Ø´ÙˆØ¯',0),(358023,9946,'pr','Ø¨Ù‡ ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ Ø§Ø±Ø¬Ø§Ø¹ Ø´ÙˆØ¯',0),(358024,9946,'tr','TÃ¼m ÅŸirketler iÃ§in geÃ§erlidir',0),(358025,9946,'pl','Stosuje siÄ™ do wszystkich przedsiÄ™biorstw',0),(358026,9946,'bg','Ð¡Ðµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð° Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(358027,9946,'ur','ØªÙ…Ø§Ù… Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ú©Ùˆ Ù„Ø§Ú¯Ùˆ ÛÙˆØªØ§ ÛÛ’',0),(358028,9946,'sr','ÐžÐ´Ð½Ð¾ÑÐ¸ ÑÐµ Ð½Ð° ÑÐ²Ð¸Ð¼ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð¸Ð¼Ð°',0),(358029,9946,'vi','Ãp dá»¥ng cho táº¥t cáº£ cÃ¡c cÃ´ng ty',0),(358030,9946,'af','Geld vir alle maatskappye',0),(358031,9946,'ro','Se aplicÄƒ tuturor companiilor',0),(358032,9946,'et','Rakendub kÃµigile ettevÃµtetele',0),(358033,9946,'si','Velja za vsa podjetja',0),(358034,9946,'ba','Berlaku untuk semua perusahaan',0),(358035,9946,'nl','Is van toepassing op alle bedrijven',0),(358036,9946,'fi','Sovelletaan kaikkien yritysten',0),(358037,9946,'no','Gjelder alle selskaper',0),(358038,9946,'da','GÃ¦lder for alle virksomheder',0),(358039,9946,'ko','ëª¨ë“  íšŒì‚¬ì— ì ìš© ë©ë‹ˆë‹¤.',0),(358040,9946,'he','×—×œ ×¢×œ ×›×œ ×”×—×‘×¨×•×ª',0),(358041,9946,'el','Î™ÏƒÏ‡ÏÎµÎ¹ Î³Î¹Î± Ï„Î¹Ï‚ ÎµÏ€Î¹Ï‡ÎµÎ¹ÏÎ®ÏƒÎµÎ¹Ï‚ ÏŒÎ»Î±',0),(358042,9946,'zh','é€‚ç”¨äºŽæ‰€æœ‰å…¬å¸\r\n',0),(358043,9946,'sv','GÃ¤ller fÃ¶r alla fÃ¶retag',0),(358044,9946,'it','Si applica a tutte le aziende',0),(358045,9946,'tl','',0),(358046,9946,'th','&#3651;&#3594;&#3657;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3607;&#3633;&#3657;&#3591;&#3627;&#3617;&#3604;',0),(358047,9946,'hi','à¤¸à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¥‚ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ',0),(358048,9946,'ms','Terpakai kepada semua syarikat',0),(358049,9946,'ar','ÙˆÙŠÙ†Ø·Ø¨Ù‚ Ø¹Ù„Ù‰ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´Ø±ÙƒØ§Øª',0),(358050,9946,'fr','S\'applique Ã  toutes les entreprises',0),(358051,9946,'jp','ã™ã¹ã¦ã®ä¼æ¥­ã«é©ç”¨ã•ã‚Œã¾ã™ã€‚',0),(358052,9946,'pt','Aplica-se a todas as empresas',0),(358053,9946,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½ÑÐµÑ‚ÑÑ Ð´Ð»Ñ Ð²ÑÐµÑ… Ñ„Ð¸Ñ€Ð¼',0),(358054,9946,'es','Se Aplica a Todas las Emprresas',0),(358055,9946,'de','Gilt fÃ¼r alle Mandanten',0),(358056,9946,'en','Applies to All Companies',0),(358057,9947,'is','',0),(358058,9947,'dr',' ØªØ§ÙŠÙŠØ¯ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ',0),(358059,9947,'pr',' ØªØ§ÙŠÙŠØ¯ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ',0),(358060,9947,'tr','Onay kurulumu',0),(358061,9947,'pl','Zatwierdzenie ustawienia',0),(358062,9947,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(358063,9947,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø³ÛŒÙ¹ Ø§Ù¾',0),(358064,9947,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐ°',0),(358065,9947,'vi','CÃ i Ä‘áº·t phÃª duyá»‡t',0),(358066,9947,'af','Goedkeuring Opstelling',0),(358067,9947,'ro','Aprobarea Setup',0),(358068,9947,'et','Kinnitamise seadistamine',0),(358069,9947,'si','Odobritev Setup',0),(358070,9947,'ba','Persetujuan Setup',0),(358071,9947,'nl','Goedkeuring Setup',0),(358072,9947,'fi','HyvÃ¤ksynnÃ¤n asetukset',0),(358073,9947,'no','Oppsett for journalvalidering',0),(358074,9947,'da','OpsÃ¦tning af kladdegodkendelse',0),(358075,9947,'ko','ìŠ¹ì¸ ì„¤ì •',0),(358076,9947,'he','××™×©×•×¨ ×ª×•×›× ×™×ª ×”×”×ª×§× ×”',0),(358077,9947,'el','Î¡ÏÎ¸Î¼Î¹ÏƒÎ· Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚',0),(358078,9947,'zh','æ‰¹å‡†è®¾ç½®\r\n',0),(358079,9947,'sv','FÃ¶r godkÃ¤nnande',0),(358080,9947,'it','Installazione di approvazione',0),(358081,9947,'tl','',0),(358082,9947,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3605;&#3636;&#3604;&#3605;&#3633;&#3657;&#3591;',0),(358083,9947,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(358084,9947,'ms','Persediaan kelulusan',0),(358085,9947,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø¨Ø±Ù†Ø§Ù…Ø¬ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(358086,9947,'fr','ParamÃ©trage d\'approbation',0),(358087,9947,'jp','æ‰¿èªã®è¨­å®š',0),(358088,9947,'pt','InstalaÃ§Ã£o de aprovaÃ§Ã£o',0),(358089,9947,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(358090,9947,'es','ConfiguraciÃ³n de AprobaciÃ³n',0),(358091,9947,'de','Genehmigung-Setup',0),(358092,9947,'en','Approval Setup',0),(358093,9948,'is','',0),(358094,9948,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠÙŠ ÙƒÙ‡ Ø§ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª Ø±Ø§ ØªØ§ÙŠÙŠØ¯ Ù…ÙŠ ÙƒÙ†Ù†Ø¯ ',0),(358095,9948,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠÙŠ ÙƒÙ‡ Ø§ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª Ø±Ø§ ØªØ§ÙŠÙŠØ¯ Ù…ÙŠ ÙƒÙ†Ù†Ø¯ ',0),(358096,9948,'tr','Bu eylemi onaylamak gruplar',0),(358097,9948,'pl','Grupy, ktÃ³re moÅ¼e zatwierdziÄ‡ tÄ™ akcjÄ™',0),(358098,9948,'bg','Ð“Ñ€ÑƒÐ¿Ð¸, ÐºÐ¾Ð¸Ñ‚Ð¾ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€ÑÐ²Ð°Ñ‚ Ñ‚Ð¾Ð²Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(358099,9948,'ur','ÙˆÛ Ú¯Ø±ÙˆÛ Ø¬Ùˆ Ø§Ø³ Ø¹Ù…Ù„ Ú©Ùˆ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(358100,9948,'sr','Ð“Ñ€ÑƒÐ¿Ðµ ÐºÐ¾Ñ˜Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ñƒ',0),(358101,9948,'vi','nhiá»u nhÃ³m cÃ³ thá»ƒ duyá»‡t hÃ nh Ä‘á»™ng nÃ y',0),(358102,9948,'af','Groepe Wat Hierdie Aksie Kan Goedkeur',0),(358103,9948,'ro','Grupurile care poate aproba aceastÄƒ acÅ£iune',0),(358104,9948,'et','RÃ¼hmad, kellel on Ãµigus kinnitada selle toimingu',0),(358105,9948,'si','Skupine, ki lahko potrdi to dejanje',0),(358106,9948,'ba','Kelompok yang dapat menyetujui tindakan ini',0),(358107,9948,'nl','Groepen die deze actie kunnen goedkeuren',0),(358108,9948,'fi','RyhmÃ¤t, jotka voivat hyvÃ¤ksyÃ¤ tÃ¤mÃ¤n toiminnan',0),(358109,9948,'no','Grupper som kan godkjenne denne handlingen',0),(358110,9948,'da','Grupper, der kan godkende denne handling',0),(358111,9948,'ko','ì´ ìž‘ì—…ì„ ìŠ¹ì¸í•  ìˆ˜ ìžˆëŠ” ê·¸ë£¹',0),(358112,9948,'he','×§×‘×•×¦×•×ª ××©×¨ ×™×›×•×œ×™× ×œ××©×¨ ×¤×¢×•×œ×” ×–×•',0),(358113,9948,'el','ÎŸÎ¹ Î¿Î¼Î¬Î´ÎµÏ‚ Ï€Î¿Ï… Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± ÎµÎ³ÎºÏÎ¯Î½Î¿Ï…Î½ Ï„Î·Î½ Ï€Î±ÏÎ¿ÏÏƒÎ± Î´ÏÎ¬ÏƒÎ·',0),(358114,9948,'zh','å¯ä»¥æ‰¹å‡†è¿™é¡¹è¡ŒåŠ¨çš„ç»„\r\n',0),(358115,9948,'sv','Grupper som kan godkÃ¤nna denna Ã¥tgÃ¤rd',0),(358116,9948,'it','Gruppi che possono approvare questa azione',0),(358117,9948,'tl','',0),(358118,9948,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3609;&#3585;&#3634;&#3619;&#3609;&#3637;&#3657;',0),(358119,9948,'hi','à¤¸à¤®à¥‚à¤¹ à¤¹à¥ˆ à¤•à¤¿ à¤‡à¤¸ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤•à¥‹ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(358120,9948,'ms','Kumpulan-Kumpulan yang boleh meluluskan tindakan ini',0),(358121,9948,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„ØªÙŠ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªÙˆØ§ÙÙ‚ Ø¹Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡',0),(358122,9948,'fr','Groupes qui peuvent approuver cette Action',0),(358123,9948,'jp','ã“ã®æ“ä½œã‚’æ‰¿èªã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã‚°ãƒ«ãƒ¼ãƒ—',0),(358124,9948,'pt','Grupos que podem aprovar esta aÃ§Ã£o',0),(358125,9948,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð¼Ð¾Ð¶Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(358126,9948,'es','Grupos que Pueden Aprobar Esta AcciÃ³n',0),(358127,9948,'de','Gruppen, die diese Aktion zu genehmigen, kÃ¶nnen',0),(358128,9948,'en','Groups That Can Approve This Action',0),(358129,9949,'is','',0),(358130,9949,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠÙŠ ÙƒÙ‡ Ø¨Ø§ÙŠØ¯ ØªØ§ÙŠÙŠØ¯  Ø§ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª Ø±Ø§ Ø¨Ú¯ÙŠØ±Ù†Ø¯  ',0),(358131,9949,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠÙŠ ÙƒÙ‡ Ø¨Ø§ÙŠØ¯ ØªØ§ÙŠÙŠØ¯  Ø§ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª Ø±Ø§ Ø¨Ú¯ÙŠØ±Ù†Ø¯  ',0),(358132,9949,'tr','Bu eylem iÃ§in onay almak gerekir gruplarÄ±',0),(358133,9949,'pl','Grupy, ktÃ³re muszÄ… uzyskaÄ‡ zatwierdzenie tej akcji',0),(358134,9949,'bg','Ð“Ñ€ÑƒÐ¿Ð¸, ÐºÐ¾Ð¸Ñ‚Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð·Ð° Ñ‚Ð¾Ð²Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(358135,9949,'ur','ÙˆÛ Ú¯Ø±ÙˆÛ Ø¬Ùˆ Ø§Ø³ Ø¹Ù…Ù„ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø­Ø§ØµÙ„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(358136,9949,'sr','Ð“Ñ€ÑƒÐ¿Ðµ ÐºÐ¾Ñ˜Ðµ Ð¼Ð¾Ñ€Ð° Ð´Ð¾Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ Ð·Ð° Ð¾Ð²Ñƒ Ñ€Ð°Ð´ÑšÑƒ',0),(358137,9949,'vi','nhiá»u nhÃ³m cÃ³ thá»ƒ duyá»‡t cho hÃ nh Ä‘á»™ng nÃ y',0),(358138,9949,'af','Groepe Wat Goedkeur Moet Verkry Vir Hierdie Aksie',0),(358139,9949,'ro','Grupurile care trebuie sÄƒ obÅ£inÄƒ aprobare pentru aceastÄƒ acÅ£iune',0),(358140,9949,'et','RÃ¼hmad, kes peab saama heakskiidu selleks toiminguks',0),(358141,9949,'si','Skupine, ki mora dobiti odobritev za to dejanje',0),(358142,9949,'ba','Kelompok yang harus mendapatkan persetujuan untuk tindakan ini',0),(358143,9949,'nl','Groepen die goedkeuring voor deze actie moeten krijgen',0),(358144,9949,'fi','RyhmÃ¤t, jotka hyvÃ¤ksyttÃ¤Ã¤ toiminto',0),(358145,9949,'no','Grupper som mÃ¥ fÃ¥ godkjenning For denne handlingen',0),(358146,9949,'da','Grupper, der skal fÃ¥ godkendelse til denne handling',0),(358147,9949,'ko','ì´ ìž‘ì—…ì— ëŒ€ í•œ ìŠ¹ì¸ì„ ë°›ì•„ì•¼ ê·¸ë£¹',0),(358148,9949,'he','×§×‘×•×¦×•×ª ××©×¨ ×—×™×™×‘ ×œ×§×‘×œ ××™×©×•×¨ ×¢×‘×•×¨ ×¤×¢×•×œ×” ×–×•',0),(358149,9949,'el','ÎŸÎ¼Î¬Î´ÎµÏ‚ Ï€Î¿Ï… Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€Î¬ÏÎµÎ¹ Ï„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ· Î³Î¹Î± Ï„Î·Î½ ÎµÎ½Î­ÏÎ³ÎµÎ¹Î± Î±Ï…Ï„Î®',0),(358150,9949,'zh','å¿…é¡»å¾—åˆ°æ­¤è¡ŒåŠ¨æ‰¹å‡†çš„ç»„\r\n',0),(358151,9949,'sv','Grupper som mÃ¥ste fÃ¥ godkÃ¤nnande fÃ¶r denna Ã¥tgÃ¤rd',0),(358152,9949,'it','Gruppi che devono ottenere l\'approvazione per questa azione',0),(358153,9949,'tl','',0),(358154,9949,'th','&#3585;&#3621;&#3640;&#3656;&#3617;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3652;&#3604;&#3657;&#3619;&#3633;&#3610;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3604;&#3635;&#3',0),(358155,9949,'hi','à¤¸à¤®à¥‚à¤¹ à¤¹à¥ˆ à¤•à¤¿ à¤‡à¤¸ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤®à¤¿à¤²à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(358156,9949,'ms','Kumpulan yang perlu mendapatkan kelulusan bagi tindakan ini',0),(358157,9949,'ar','Ø§Ù„ÙØ¦Ø§Øª Ø§Ù„ØªÙŠ ÙŠØ¬Ø¨ Ø£Ù† ØªØ­ØµÙ„ Ø¹Ù„Ù‰ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù…Ù„',0),(358158,9949,'fr','Groupes qui doivent obtenir l\'approbation pour cette Action',0),(358159,9949,'jp','ã“ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã®æ‰¿èªã‚’å¾—ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã‚°ãƒ«ãƒ¼ãƒ—',0),(358160,9949,'pt','Grupos que devem receber aprovaÃ§Ã£o para esta aÃ§Ã£o',0),(358161,9949,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(358162,9949,'es','Grupos que Deben Obtener Permiso Para Esta AcciÃ³n',0),(358163,9949,'de','Gruppen, die Genehmigung fÃ¼r diese Aktion zu erhalten, mÃ¼ssen',0),(358164,9949,'en','Groups That Must Get Approval For This Action',0),(358165,9950,'is','',0),(358166,9950,'dr','ÙƒØ§Ø±Ø¨Ø±ÙŠ ÙƒÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†Ø¯ ',0),(358167,9950,'pr','ÙƒØ§Ø±Ø¨Ø±ÙŠ ÙƒÙ‡ Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø§ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†Ø¯ ',0),(358168,9950,'tr','Bu eylem onaylayabilen kullanÄ±cÄ±lar',0),(358169,9950,'pl','UÅ¼ytkownicy, ktÃ³rzy mogÄ… zatwierdzaÄ‡ tej akcji',0),(358170,9950,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ, ÐºÐ¾Ð¸Ñ‚Ð¾ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€ÑÐ²Ð°Ñ‚ Ñ‚Ð¾Ð²Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(358171,9950,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©Ùˆ Ø¬Ùˆ Ø§Ø³ Ø¹Ù…Ù„ Ú©Ùˆ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(358172,9950,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸ ÐºÐ¾Ñ˜Ð¸ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°Ñ˜Ñƒ Ð¾Ð²Ñƒ Ñ€Ð°Ð´ÑšÑƒ',0),(358173,9950,'vi','Nhá»¯ng ngÆ°á»i sá»­ dá»¥ng cÃ³ thá»ƒ phÃª duyá»‡t lá»‡nh nÃ y',0),(358174,9950,'af','Gebruikers Wie Hierdie Aksie kan Goedkeur',0),(358175,9950,'ro','Utilizatorii care poate aproba aceastÄƒ acÅ£iune',0),(358176,9950,'et','See meede kinnitamise Ãµigusega kasutajad',0),(358177,9950,'si','Uporabniki, ki lahko potrdi to dejanje',0),(358178,9950,'ba','Pengguna yang dapat menyetujui tindakan ini',0),(358179,9950,'nl','Gebruikers die deze actie kunnen goedkeuren',0),(358180,9950,'fi','KÃ¤yttÃ¤jÃ¤t, jotka voivat hyvÃ¤ksyÃ¤ tÃ¤mÃ¤n toiminnan',0),(358181,9950,'no','Brukere som kan godkjenne denne handlingen',0),(358182,9950,'da','Brugere, der kan godkende denne handling',0),(358183,9950,'ko','ì´ ìž‘ì—…ì„ ìŠ¹ì¸í•  ìˆ˜ ìžˆëŠ” ì‚¬ìš©ìž',0),(358184,9950,'he','×ž×©×ª×ž×©×™× ×©×™×›×•×œ×™× ×œ××©×¨ ×¤×¢×•×œ×” ×–×•',0),(358185,9950,'el','ÎŸÎ¹ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Ï€Î¿Ï… Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± ÎµÎ³ÎºÏÎ¯Î½Î¿Ï…Î½ Ï„Î·Î½ Ï€Î±ÏÎ¿ÏÏƒÎ± Î´ÏÎ¬ÏƒÎ·',0),(358186,9950,'zh','å¯ä»¥æ‰¹å‡†è¿™ç§è¡ŒåŠ¨çš„ç”¨æˆ·\r\n',0),(358187,9950,'sv','AnvÃ¤ndare som kan godkÃ¤nna denna Ã¥tgÃ¤rd',0),(358188,9950,'it','Utenti che possono approvare questa azione',0),(358189,9950,'tl','',0),(358190,9950,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3636;&#3585;&#3634;&#3619;&#3609;&#3637;&#3',0),(358191,9950,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹, à¤œà¥‹ à¤‡à¤¸ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‹ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(358192,9950,'ms','Pengguna yang boleh meluluskan tindakan ini',0),(358193,9950,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ø°ÙŠÙ† ÙŠÙ…ÙƒÙ†Ù‡Ù… Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡',0),(358194,9950,'fr','Utilisateurs qui peuvent approuver cette Action',0),(358195,9950,'jp','ã“ã®æ“ä½œã‚’æ‰¿èªã§ãã‚‹ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(358196,9950,'pt','UsuÃ¡rios que podem aprovar esta aÃ§Ã£o',0),(358197,9950,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸ ÐšÐ¾Ð¼Ñƒ Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾ Ð”Ð°Ð½Ð½Ð¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(358198,9950,'es','Usuarios que Pueden Aprobar Esta AcciÃ³n',0),(358199,9950,'de','Benutzer, die diese Aktion genehmigen kann',0),(358200,9950,'en','Users Who Can Approve This Action',0),(358201,9951,'is','',0),(358202,9951,'dr','ÙƒØ§Ø±Ø¨Ø±ÙŠ ÙƒÙ‡ Ø¨Ø§ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª ØªØ§ÙŠÙŠØ¯ Ø¨Ú¯ÙŠØ±Ø¯ ',0),(358203,9951,'pr','ÙƒØ§Ø±Ø¨Ø±ÙŠ ÙƒÙ‡ Ø¨Ø§ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª ØªØ§ÙŠÙŠØ¯ Ø¨Ú¯ÙŠØ±Ø¯ ',0),(358204,9951,'tr','Bu eylem iÃ§in onay almak gerekir kullanÄ±cÄ±lar',0),(358205,9951,'pl','UÅ¼ytkownicy, ktÃ³rzy muszÄ… uzyskaÄ‡ zatwierdzenie tej akcji',0),(358206,9951,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ, ÐºÐ¾Ð¸Ñ‚Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð·Ð° Ñ‚Ð¾Ð²Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(358207,9951,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©Ùˆ Ø¬Ùˆ Ø§Ø³ Ø¹Ù…Ù„ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø­Ø§ØµÙ„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(358208,9951,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸ ÐºÐ¾Ñ˜Ð¸ Ð¼Ð¾Ñ€Ð°Ñ˜Ñƒ Ð´Ð¾Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ Ð·Ð° Ð¾Ð²Ñƒ Ñ€Ð°Ð´ÑšÑƒ',0),(358209,9951,'vi','Nhá»¯ng ngÆ°á»i sá»­ dá»¥ng pháº£i Ä‘Æ°á»£c phÃª duyá»‡t cho lá»‡nh nÃ y',0),(358210,9951,'af','Gebruikers Wie Goedkeuring moet kry vir Hierdie Aksie',0),(358211,9951,'ro','Utilizatorii care trebuie sÄƒ obÅ£inÄƒ aprobare pentru aceastÄƒ acÅ£iune',0),(358212,9951,'et','Kasutajad, kes peab saama heakskiidu selleks toiminguks',0),(358213,9951,'si','Uporabniki, ki mora dobiti odobritev za to dejanje',0),(358214,9951,'ba','Pengguna yang harus mendapatkan persetujuan untuk tindakan ini',0),(358215,9951,'nl','Gebruikers die goedkeuring voor deze actie moeten krijgen',0),(358216,9951,'fi','KÃ¤yttÃ¤jÃ¤ joka hyvÃ¤ksyttÃ¤Ã¤ toiminto',0),(358217,9951,'no','Brukere som mÃ¥ fÃ¥ godkjenning for denne handlingen',0),(358218,9951,'da','Brugere, der skal fÃ¥ godkendelse til denne handling',0),(358219,9951,'ko','ì‚¬ìš©ìžê°€ì´ ìž‘ì—…ì— ëŒ€ í•œ ìŠ¹ì¸ì„ ë°›ì•„ì•¼ í•©ë‹ˆë‹¤.',0),(358220,9951,'he','×ž×©×ª×ž×©×™× ×©×¦×¨×™×›×™× ×œ×§×‘×œ ××™×©×•×¨ ×¢×‘×•×¨ ×¤×¢×•×œ×” ×–×•',0),(358221,9951,'el','ÎŸÎ¹ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Ï€Î¿Ï… Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€Î¬ÏÎµÎ¹ Ï„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ· Î³Î¹Î± Ï„Î·Î½ ÎµÎ½Î­ÏÎ³ÎµÎ¹Î± Î±Ï…Ï„Î®',0),(358222,9951,'zh','å¿…é¡»å¾—åˆ°è¿™ä¸ªè¡ŒåŠ¨å®¡æ‰¹çš„ç”¨æˆ·\r\n',0),(358223,9951,'sv','AnvÃ¤ndare som mÃ¥ste fÃ¥ godkÃ¤nnande fÃ¶r denna Ã¥tgÃ¤rd',0),(358224,9951,'it','Utenti che devono ottenere l\'approvazione per questa azione',0),(358225,9951,'tl','',0),(358226,9951,'th','&#3612;&#3641;&#3657;&#3651;&#3594;&#3657;&#3607;&#3637;&#3656;&#3605;&#3657;&#3629;&#3591;&#3651;&#3627;&#3657;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3604;&#3635;&#3648;&#3609;&#3636;&#3636;&#3585;&#3634;&#3619;&#3609;&#3',0),(358227,9951,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹, à¤œà¥‹ à¤‡à¤¸ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤®à¤¿à¤²à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(358228,9951,'ms','Pengguna yang perlu mendapatkan kelulusan bagi tindakan ini',0),(358229,9951,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ø°ÙŠÙ† ÙŠØ¬Ø¨ Ø£Ù† ØªØ­ØµÙ„ Ø¹Ù„Ù‰ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù…Ù„',0),(358230,9951,'fr','Utilisateurs qui doivent obtenir l\'approbation pour cette Action',0),(358231,9951,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ãŒã“ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã®æ‰¿èªã‚’å¾—ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(358232,9951,'pt','UsuÃ¡rios que devem obter aprovaÃ§Ã£o para esta aÃ§Ã£o',0),(358233,9951,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸ ÐšÑ‚Ð¾ Ð”Ð¾Ð»Ð¶ÐµÐ½ ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ Ð´Ð»Ñ Ð­Ñ‚Ð¾Ð³Ð¾ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(358234,9951,'es','Usuarios que Deben Agarrar AprobaciÃ³n para Esta AccciÃ³n',0),(358235,9951,'de','Benutzer, die Genehmigung fÃ¼r diese Aktion zu erhalten, mÃ¼ssen',0),(358236,9951,'en','Users Who Must Get Approval for This Action',0),(358237,9952,'is','',0),(358238,9952,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø­Ø³Ø§Ø¨ Ù…Ø´Ø§Ø¨Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(358239,9952,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø­Ø³Ø§Ø¨ Ù…Ø´Ø§Ø¨Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù‡Ø²ÙŠÙ†Ù‡ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ú©Ø§Ù„Ø§ Ø¯Ø± Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ú¯Ø±Ø¯Ø§Ù†Ø¯Ù† ÙØ¹Ø§Ù„ÙŠØª Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(358240,9952,'tr','AynÄ± hesap SMM eylem iÃ§in stok hesabÄ± inkÃ¢r etmek iÃ§in kullanÄ±n.',0),(358241,9952,'pl','UÅ¼ywaÄ‡ tego samego konta jako zÄ™bÃ³w aby odwrÃ³ciÄ‡ dziaÅ‚anie na koncie zapasÃ³w',0),(358242,9952,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÑÑŠÑ‰Ð°Ñ‚Ð° ÑÐ¼ÐµÑ‚ÐºÐ° ÐºÐ°Ñ‚Ð¾ ÐžÐ¡ÐŸ Ð´Ð° Ð¾Ñ‚Ñ€Ð¸Ñ‡Ð°Ñ‚ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð·Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(358243,9952,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¹Ù…Ù„ Ú©ÛŒ Ù†ÙÛŒ Ú©Û’ Ù„ÛŒÛ’ Ú©Ø§ÙˆÚ¯Ø³ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§ÛŒÚ© ÛÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(358244,9952,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¸ÑÑ‚Ð¸ Ð½Ð°Ð»Ð¾Ð³ ÐºÐ°Ð¾ Ð¢ÐŸÐ  Ð½ÐµÐ³Ð¸Ñ€Ð°ÑšÐ° Ð°ÐºÑ†Ð¸Ñ˜Ñƒ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(358245,9952,'vi','Sá»­ dá»¥ng cÃ¹ng má»™t tÃ i khoáº£n nhÆ° COGS Ä‘á»ƒ phá»§ nháº­n cÃ¡c hÃ nh Ä‘á»™ng Ä‘á»ƒ tÃ i khoáº£n hÃ ng tá»“n kho',0),(358246,9952,'af','Gebruik Dieselfde Rekening as KVV om Aksie na Inventaris Rekening te weerspreek',0),(358247,9952,'ro','UtilizaÅ£i acelaÅŸi cont ca ROÅ¢ILE sÄƒ nege acÅ£iune la contul de stocuri',0),(358248,9952,'et','Kasutada sama konto OMAHINNAD eitama tegevus varude kontole',0),(358249,9952,'si','Uporabite isti raÄun kot VZVODI za zanika dejanje za konto zaloge',0),(358250,9952,'ba','Menggunakan akun yang sama sebagai roda untuk meniadakan tindakan untuk persediaan Account',0),(358251,9952,'nl','Dezelfde Account gebruiken als RADERTJES te ontkennen actie aan voorraadrekening',0),(358252,9952,'fi','KÃ¤yttÃ¤Ã¤ samaa tiliÃ¤ kuin hampaat tyhjÃ¤ksi toimia varastotilin',0),(358253,9952,'no','Bruke samme konto som hjul Ã¥ negere handling lagerkontoen',0),(358254,9952,'da','Bruge samme konto som VAREFORBRUG til negere handling til lagerkontoen',0),(358255,9952,'ko','ìž¬ê³  ê³„ì •ì— ìž‘ì—…ì„ ë¶€ì • í•˜ëŠ” í†±ë‹ˆ ê°™ì€ ê³„ì • ì‚¬ìš©',0),(358256,9952,'he','×œ×”×©×ª×ž×© ×‘××•×ª×• ×—×©×‘×•×Ÿ ×”×—×•×–×™× ×›×“×™ ×œ×©×œ×•×œ ×¤×¢×•×œ×” ×œ×—×©×‘×•×Ÿ ×”×ž×œ××™',0),(358257,9952,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î¿ Î¯Î´Î¹Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï‰Ï‚ Î“Î¡Î‘ÎÎ†Î–Î™Î‘ Î½Î± Î±Î¼Ï†Î¹ÏƒÎ²Î·Ï„Î·Î¸Î¿ÏÎ½ Î´ÏÎ¬ÏƒÎ· ÏƒÏ„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(358258,9952,'zh','ä½¿ç”¨ç›¸åŒçš„å¸æˆ·ä½œä¸ºé”€å”®æˆæœ¬å¦å®šè¡ŒåŠ¨ç›˜å­˜è´¦æˆ·\r\n',0),(358259,9952,'sv','AnvÃ¤nda samma konto som kuggar att fÃ¶rneka att lagerkontot',0),(358260,9952,'it','Utilizzare Account stesso come ingranaggi per negare l\'azione per conto di inventario',0),(358261,9952,'tl','',0),(358262,9952,'th','&#3651;&#3594;&#3657;&#3610;&#3633;&#3597;&#3594;&#3637;&#3648;&#3604;&#3637;&#3618;&#3623;&#3585;&#3633;&#3609;&#3585;&#3633;&#3610;&#3610;&#3633;&#3597;&#3594;&#3637;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3585;&#3634;&#3619;&#3586;&#3634;&#3618;&#3',0),(358263,9952,'hi','COGS à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤à¤• à¤¹à¥€ à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤–à¤¾à¤¤à¥‡ à¤•à¥‹ à¤¨à¤•à¤¾à¤°à¤¨à¤¾',0),(358264,9952,'ms','Menggunakan akaun yang sama sebagai salah satu alat untuk mencegah tindakan untuk akaun inventori',0),(358265,9952,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù†ÙØ³ Ø­Ø³Ø§Ø¨ COGS Ù„ÙŠÙ†ÙÙŠ Ø§Ù„Ø¹Ù…Ù„ Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(358266,9952,'fr','Utilisez le mÃªme compte comme CMV Ã  nier l\'Action sur compte en stock',0),(358267,9952,'jp','æ­¯è»Šã¨ã—ã¦åŒã˜ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½¿ç”¨ã—ã¦ã‚¢ã‚¯ã‚·ãƒ§ãƒ³åœ¨åº«å‹˜å®šã‚’å¦å®šã—ã¾ã™ã€‚',0),(358268,9952,'pt','Usar a mesma conta como COGS para negar a aÃ§Ã£o para a conta de estoque',0),(358269,9952,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¶Ðµ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð²Ð¸Ð½Ñ‚Ð¸ÐºÐ¸ Ð´Ð»Ñ Ð¸Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(358270,9952,'es','Usa la Misma Cuenta como CDV Para Negar AcciÃ³n a la Cuenta de Inventorio',0),(358271,9952,'de','Verwenden Sie dasselbe Konto als RÃ„DCHEN Aktion Lagerkonto zu negieren',0),(358272,9952,'en','Use Same Account as COGS to Negate Action to Inventory Account',0),(358273,9953,'is','',0),(358274,9953,'dr','Ø§ÙŠÙ…ÙŠÙ„ ØªÙ…Ø§Ø³ Ø¨Ø§Ù†Ùƒ ',0),(358275,9953,'pr','Ø§ÙŠÙ…ÙŠÙ„ ØªÙ…Ø§Ø³ Ø¨Ø§Ù†Ùƒ ',0),(358276,9953,'tr','Banka iletiÅŸim e-posta',0),(358277,9953,'pl','Kontakt E-mail banku',0),(358278,9953,'bg','Ð‘Ð°Ð½ÐºÐ°Ñ‚Ð° Ð¸Ð¼ÐµÐ¹Ð» Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(358279,9953,'ur','Ø¨ÛŒÙ†Ú© Ø³Û’ Ø±Ø§Ø¨Ø·Û Ø§ÛŒ Ù…ÛŒÙ„',0),(358280,9953,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð•Ð¼Ð°Ð¸Ð» Ð±Ð°Ð½ÐºÐµ',0),(358281,9953,'vi','Äá»‹c chá»‰ thÆ° Ä‘iá»‡n tá»­ cá»§a NgÃ¢n hÃ ng',0),(358282,9953,'af','Bank Kontak E-pos',0),(358283,9953,'ro','E-mail de Contact Banca',0),(358284,9953,'et','Panga e-posti',0),(358285,9953,'si','Banka stik Email',0),(358286,9953,'ba','Email Kontak Bank',0),(358287,9953,'nl','Bank Contact E-mail',0),(358288,9953,'fi','Pankin sÃ¤hkÃ¶postiosoite',0),(358289,9953,'no','Bank e',0),(358290,9953,'da','Bank kontakt E-mail',0),(358291,9953,'ko','ì€í–‰ ì—°ë½ì²˜ ì´ë©”ì¼',0),(358292,9953,'he','×”×‘× ×§ ×™×¦×™×¨×ª ×§×©×¨ ×“×•××¨ ××œ×§×˜×¨×•× ×™',0),(358293,9953,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± E-mail ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚',0),(358294,9953,'zh','é“¶è¡Œè”ç³»äººç”µå­é‚®ä»¶\r\n',0),(358295,9953,'sv','Bank kontakt e-post',0),(358296,9953,'it','E-mail di contatto banca',0),(358297,9953,'tl','',0),(358298,9953,'th','&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;&#3607;&#3637;&#3656;&#3605;&#3636;&#3604;&#3605;&#3656;&#3629;&#3652;&#3604;&#3657;&#3651;&#3609;&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;',0),(358299,9953,'hi','à¤¬à¥ˆà¤‚à¤• à¤ˆà¤®à¥‡à¤² à¤¸à¥‡ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚',0),(358300,9953,'ms','E-mel kenalan Bank',0),(358301,9953,'ar','Ø§Ù„Ø¨Ù†Ùƒ Ø§Ù„Ø§ØªØµØ§Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(358302,9953,'fr','Email de Contact de la Banque',0),(358303,9953,'jp','éŠ€è¡Œã®é€£çµ¡å…ˆãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹',0),(358304,9953,'pt','E-mail de contato do banco',0),(358305,9953,'ru','Ð‘Ð°Ð½Ðº ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ñ‹Ð¹ Ð°Ð´Ñ€ÐµÑ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(358306,9953,'es','Email del Contacto Bancario',0),(358307,9953,'de','Bank-Kontakt-Email',0),(358308,9953,'en','Bank Contact Email',0),(358309,9954,'is','',0),(358310,9954,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§Ø²Ø±Ø³ Ø¨Ø§Ù†Ùƒ',0),(358311,9954,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§Ø²Ø±Ø³ Ø¨Ø§Ù†Ùƒ',0),(358312,9954,'tr','Banka mÃ¼fettiÅŸi e-posta',0),(358313,9954,'pl','E inspektor bankowy',0),(358314,9954,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð² Ð¸Ð½ÑÐ¿ÐµÐºÑ‚Ð¾Ñ€ Ð¸Ð¼ÐµÐ¹Ð»',0),(358315,9954,'ur','Ø¨ÛŒÙ†Ú© Ø§Ù†Ø³Ù¾Ú©Ù¹Ø± Ø§ÛŒ Ù…ÛŒÙ„',0),(358316,9954,'sr','Ð‘Ð°Ð½ÐºÐ° Ð¸Ð½ÑÐ¿ÐµÐºÑ‚Ð¾Ñ€ Ð•Ð¼Ð°Ð¸Ð»',0),(358317,9954,'vi','ThÆ° Ä‘iá»‡n tá»­ thanh tra ngÃ¢n hÃ ng',0),(358318,9954,'af','Bank Ombudsman E-pos',0),(358319,9954,'ro','E-mail de Inspector bancar',0),(358320,9954,'et','Panga inspektor Email',0),(358321,9954,'si','BanÄni inÅ¡pektor Email',0),(358322,9954,'ba','Bank Inspektur Email',0),(358323,9954,'nl','Bank Inspector E-mail',0),(358324,9954,'fi','Bank tarkastaja sÃ¤hkÃ¶posti',0),(358325,9954,'no','Banken inspektÃ¸r Email',0),(358326,9954,'da','Bank inspektÃ¸r E-mail',0),(358327,9954,'ko','ì€í–‰ ê´€ë¦¬ìž ì´ë©”ì¼',0),(358328,9954,'he','×”×‘× ×§ ×ž×¤×§×— ×“×•×',0),(358329,9954,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎµÏ€Î¹Î¸ÎµÏ‰ÏÎ·Ï„Î®Ï‚ Email',0),(358330,9954,'zh','é“¶è¡Œæ£€å¯Ÿå‘˜ç”µé‚®\r\n',0),(358331,9954,'sv','Bank inspektÃ¶r Email',0),(358332,9954,'it','Banca ispettore Email',0),(358333,9954,'tl','',0),(358334,9954,'th','&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3612;&#3641;&#3657;&#3605;&#3619;&#3623;&#3592;&#3629;&#3637;&#3648;&#3617;&#3621;&#3660;',0),(358335,9954,'hi','à¤¬à¥ˆà¤‚à¤• à¤¨à¤¿à¤°à¥€à¤•à¥à¤·à¤• à¤ˆà¤®à¥‡à¤²',0),(358336,9954,'ms','E-mel Inspektor Bank',0),(358337,9954,'ar','Ø£Ø±Ø³Ù„ Ù…ÙØªØ´ Ø§Ù„Ø¨Ù†Ùƒ',0),(358338,9954,'fr','Courriel d\'inspecteur du banque',0),(358339,9954,'jp','éŠ€è¡Œæ¤œæŸ»å®˜ãƒ¡ãƒ¼ãƒ«',0),(358340,9954,'pt','E-mail do Inspetor de banco',0),(358341,9954,'ru','Ð‘Ð°Ð½Ðº Ð¸Ð½ÑÐ¿ÐµÐºÑ‚Ð¾Ñ€Ð¾Ð¼ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(358342,9954,'es','Email del Inspector Bancario',0),(358343,9954,'de','Bank Inspektor E-Mail',0),(358344,9954,'en','Bank Inspector Email',0),(358345,9955,'is','',0),(358346,9955,'dr','Ù†Ø§Ù… Ø¨Ø§Ø²Ø±Ø³ Ø¨Ø§Ù†Ùƒ',0),(358347,9955,'pr','Ù†Ø§Ù… Ø¨Ø§Ø²Ø±Ø³ Ø¨Ø§Ù†Ùƒ',0),(358348,9955,'tr','Banka mÃ¼fettiÅŸi adÄ±',0),(358349,9955,'pl','Nazwa banku inspektor',0),(358350,9955,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¸Ð½ÑÐ¿ÐµÐºÑ‚Ð¾Ñ€ Ð½Ð° Ð±Ð°Ð½ÐºÐ°Ñ‚Ð°',0),(358351,9955,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ø§Ù†Ø³Ù¾Ú©Ù¹Ø± Ú©Û’ Ù†Ø§Ù…',0),(358352,9955,'sr','Ð˜Ð¼Ðµ Ð½Ð°Ð´Ð·Ð¾Ñ€Ð½Ð¸ÐºÐ° Ð±Ð°Ð½ÐºÐµ',0),(358353,9955,'vi','TÃªn thanh tra ngÃ¢n hÃ ng',0),(358354,9955,'af','Bank Ombudsman Naam',0),(358355,9955,'ro','Numele de Inspector bancar',0),(358356,9955,'et','Panga inspektori nimi',0),(358357,9955,'si','Ime banke inÅ¡pektor',0),(358358,9955,'ba','Nama bank Inspektur',0),(358359,9955,'nl','De naam van de inspecteur van de Bank',0),(358360,9955,'fi','Pankin tarkastajan nimi',0),(358361,9955,'no','InspektÃ¸r banknavn',0),(358362,9955,'da','InspektÃ¸r banknavn',0),(358363,9955,'ko','ì€í–‰ ê´€ë¦¬ìž ì´ë¦„',0),(358364,9955,'he','×©× ×”×ž×¤×§×— ×”×‘× ×§',0),(358365,9955,'el','Î•Î Î©ÎÎ¥ÎœÎ™Î‘ ÎµÏ€Î¹Î¸ÎµÏ‰ÏÎ·Ï„Î®Ï‚',0),(358366,9955,'zh','é“¶è¡Œæ£€æŸ¥å‘˜å§“å\r\n',0),(358367,9955,'sv','Bankens inspektÃ¶r namn',0),(358368,9955,'it','Nome della banca ispettore',0),(358369,9955,'tl','',0),(358370,9955,'th','&#3608;&#3609;&#3634;&#3588;&#3634;&#3619;&#3612;&#3641;&#3657;&#3605;&#3619;&#3623;&#3592;&#3594;&#3639;&#3656;&#3629;',0),(358371,9955,'hi','à¤¬à¥ˆà¤‚à¤• à¤¨à¤¿à¤°à¥€à¤•à¥à¤·à¤• à¤•à¤¾ à¤¨à¤¾à¤®',0),(358372,9955,'ms','Nama Inspektor Bank',0),(358373,9955,'ar','Ø§Ø³Ù… Ø§Ù„Ù…ÙØªØ´ Ø§Ù„Ø¨Ù†Ùƒ',0),(358374,9955,'fr','Nom d\'inspecteur de banque',0),(358375,9955,'jp','éŠ€è¡Œæ¤œæŸ»å®˜å',0),(358376,9955,'pt','Nome do Inspetor de banco',0),(358377,9955,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¸Ð½ÑÐ¿ÐµÐºÑ‚Ð¾Ñ€ Ð±Ð°Ð½ÐºÐ°',0),(358378,9955,'es','Nombre del inspector Bancario',0),(358379,9955,'de','Name der Bank-Inspektor',0),(358380,9955,'en','Bank Inspector Name',0),(358381,9956,'is','',0),(358382,9956,'dr','Ù…Ù†Ø¨Ø¹ Ø¨ÙˆØ¯Ø¬Ù‡',0),(358383,9956,'pr','Ù…Ù†Ø¨Ø¹ Ø¨ÙˆØ¯Ø¬Ù‡',0),(358384,9956,'tr','BÃ¼tÃ§e baÅŸvuru',0),(358385,9956,'pl','BudÅ¼et odniesienia',0),(358386,9956,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð¿Ñ€ÐµÐ¿Ñ€Ð°Ñ‚ÐºÐ°',0),(358387,9956,'ur','Ø¨Ø¬Ù¹ Ú©Ø§ Ø­ÙˆØ§Ù„Û',0),(358388,9956,'sr','Ð ÐµÑ„ÐµÑ€ÐµÐ½Ñ†Ð° Ð·Ð° Ð±ÑƒÑŸÐµÑ‚',0),(358389,9956,'vi','Tham kháº£o ngÃ¢n sÃ¡ch',0),(358390,9956,'af','Begroting Verwysing',0),(358391,9956,'ro','Buget de referinÅ£Äƒ',0),(358392,9956,'et','Eelarve viide',0),(358393,9956,'si','ProraÄun referenÄne',0),(358394,9956,'ba','Anggaran referensi',0),(358395,9956,'nl','Begroting verwijzing',0),(358396,9956,'fi','Talousarvion viite',0),(358397,9956,'no','Budsjett referanse',0),(358398,9956,'da','Budget Reference',0),(358399,9956,'ko','ì˜ˆì‚° ì°¸ì¡°',0),(358400,9956,'he','×”×¤× ×™×™×ª ×ª×§×¦×™×‘',0),(358401,9956,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(358402,9956,'zh','é¢„ç®—å‚è€ƒ\r\n',0),(358403,9956,'sv','Budget referens',0),(358404,9956,'it','Riferimento del bilancio',0),(358405,9956,'tl','',0),(358406,9956,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3607;&#3637;&#3656;&#3629;&#3657;&#3634;&#3591;&#3629;&#3636;&#3591;',0),(358407,9956,'hi','à¤¬à¤œà¤Ÿ à¤¸à¤‚à¤¦à¤°à¥à¤­',0),(358408,9956,'ms','Rujukan bajet',0),(358409,9956,'ar','Ù…Ø±Ø¬Ø¹ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(358410,9956,'fr','RÃ©fÃ©rence budgÃ©taire',0),(358411,9956,'jp','äºˆç®—å‚ç…§',0),(358412,9956,'pt','ReferÃªncia de orÃ§amento',0),(358413,9956,'ru','Ð ÐµÐºÐ¾Ð¼ÐµÐ½Ð´Ð°Ñ†Ð¸Ð¸ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(358414,9956,'es','Referencia del Presupuesto',0),(358415,9956,'de','Budget-Verweis',0),(358416,9956,'en','Budget Reference',0),(358417,9957,'is','',0),(358418,9957,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(358419,9957,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(358420,9957,'tr','Genel muhasebe bÃ¼tÃ§elerini kontrol',0),(358421,9957,'pl','SprawdÅº budÅ¼ety K/G',0),(358422,9957,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð¾Ð±Ñ‰Ð¸ ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´Ð½Ð¸ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸',0),(358423,9957,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(358424,9957,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð³ÐµÐ½ÐµÑ€Ð°Ð»Ð° ÐºÑšÐ¸Ð³Ðµ Ð±ÑƒÑŸÐµÑ‚Ðµ',0),(358425,9957,'vi','Kiá»ƒm tra ngÃ¢n sÃ¡ch tá»•ng há»£p',0),(358426,9957,'af','Nasien van Algemene Grootboek Begrotings',0),(358427,9957,'ro','Verifica bugetele de Registrul General',0),(358428,9957,'et','Kontrollige Ãœldised pearaamatu eelarvetesse',0),(358429,9957,'si','Preverite sploÅ¡ne postavke predraÄunov',0),(358430,9957,'ba','Periksa General Ledger anggaran',0),(358431,9957,'nl','Selectievakje General Ledger begrotingen',0),(358432,9957,'fi','Tarkista yleiset kirjanpidon budjetteihin',0),(358433,9957,'no','Sjekk generelt finansbudsjetter',0),(358434,9957,'da','Kontrollere almindelige finansbudgetter',0),(358435,9957,'ko','ì¼ë°˜ ë ˆì € ì˜ˆì‚° í™•ì¸',0),(358436,9957,'he','×”×¡×™×ž×•×Ÿ ×”×›×œ×œ×™ ×‘×¡×¤×¨×™ ×”×ª×§×¦×™×‘',0),(358437,9957,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î·Î½ Î³ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(358438,9957,'zh','æ£€æŸ¥æ€»å¸é¢„ç®—\r\n',0),(358439,9957,'sv','Kontrollera allmÃ¤nna redovisningsbudgetar',0),(358440,9957,'it','Controllare i bilanci di contabilitÃ  generale',0),(358441,9957,'tl','',0),(358442,9957,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3610;&#3633;&#3597;&#3594;&#3637;&#3649;&#3618;&#3585;&#3611;&#3619;&#3632;&#3648;&#3616;&#3607;',0),(358443,9957,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤•à¥‡ à¤¬à¤œà¤Ÿ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(358444,9957,'ms','Semak bajet Lejar Am',0),(358445,9957,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ù…ÙˆØ§Ø²Ù†Ø§Øª Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(358446,9957,'fr','VÃ©rifier les Budgets de grand livre gÃ©nÃ©ral',0),(358447,9957,'jp','ä¸€èˆ¬çš„ãªå…ƒå¸³äºˆç®—ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(358448,9957,'pt','Verifique o General Ledger orÃ§amentos',0),(358449,9957,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ñ‹ Ð“Ð»Ð°Ð²Ð½Ð¾Ð¹ ÐšÐ½Ð¸Ð³Ð¸',0),(358450,9957,'es','Chequear Presupuesto de Libro Mayor',0),(358451,9957,'de','General Ledger Budgets zu Ã¼berprÃ¼fen',0),(358452,9957,'en','Check General Ledger Budgets',0),(358453,9958,'is','',0),(358454,9958,'dr','Ú†Ùƒ Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø´ØºÙ„',0),(358455,9958,'pr','Ú†Ùƒ Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø´ØºÙ„',0),(358456,9958,'tr','Proje bÃ¼tÃ§elerini kontrol',0),(358457,9958,'pl','SprawdÅº budÅ¼ety zleceÅ„',0),(358458,9958,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¸',0),(358459,9958,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹ Ú©ÛŒ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„',0),(358460,9958,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð±ÑƒÑŸÐµÑ‚Ðµ Ð¿Ð¾ÑÐ»Ð°',0),(358461,9958,'vi','Kiá»ƒm tra cÃ´ng viá»‡c ngÃ¢n sÃ¡ch',0),(358462,9958,'af','Nasien van Werkstuk Begrotings',0),(358463,9958,'ro','Verifica bugetele Job',0),(358464,9958,'et','Kontrollige Projektieelarvete',0),(358465,9958,'si','Preveri, predraÄunov',0),(358466,9958,'ba','Memeriksa pekerjaan anggaran',0),(358467,9958,'nl','Selectievakje projectbudgetten',0),(358468,9958,'fi','Tarkista projektibudjetit',0),(358469,9958,'no','Sjekk prosjektbudsjetter',0),(358470,9958,'da','Check sagsbudgetter',0),(358471,9958,'ko','ì¼ìžë¦¬ ì˜ˆì‚° í™•ì¸',0),(358472,9958,'he','×‘×“×•×§ ××ª ×”×¢×‘×•×“×” ×ª×§×¦×™×‘×™×',0),(358473,9958,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ Î­ÏÎ³Ï‰Î½',0),(358474,9958,'zh','æ£€æŸ¥ä½œä¸šé¢„ç®—\r\n',0),(358475,9958,'sv','Kontrollera projektbudgetar',0),(358476,9958,'it','Controllare i bilanci lavoro',0),(358477,9958,'tl','',0),(358478,9958,'th','&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3591;&#3634;&#3609;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(358479,9958,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤¬à¤œà¤Ÿ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(358480,9958,'ms','Semak kerja belanjawan',0),(358481,9958,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ø§Ù„ÙˆØ¸Ø§Ø¦Ù',0),(358482,9958,'fr','VÃ©rifier les Budgets de l\'emploi',0),(358483,9958,'jp','ã‚¸ãƒ§ãƒ–ã®äºˆç®—ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(358484,9958,'pt','Verificar o trabalho dos OrÃ§amentos',0),(358485,9958,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¾Ð² Ñ€Ð°Ð±Ð¾Ñ‚',0),(358486,9958,'es','Chequear Presupuesos de Trabajos',0),(358487,9958,'de','Scheck von Projektbudgets',0),(358488,9958,'en','Check Job Budgets',0),(358489,9959,'is','',0),(358490,9959,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø±Ø³ÙŠ Ù†ÙƒÙ†ÙŠØ¯ ',0),(358491,9959,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ Ø±Ø§ Ø¨Ø±Ø±Ø³ÙŠ Ù†ÙƒÙ†ÙŠØ¯ ',0),(358492,9959,'tr','BÃ¼tÃ§elerini kontrol edebilirim',0),(358493,9959,'pl','Nie sprawdzaj budÅ¼etÃ³w',0),(358494,9959,'bg','ÐÐµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÐ²Ð°Ð¹ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸',0),(358495,9959,'ur','ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) Ú©ÛŒ Ù…Øª Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(358496,9959,'sr','ÐÐµ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð°Ñ˜ Ð±ÑƒÑŸÐµÑ‚Ðµ',0),(358497,9959,'vi','KhÃ´ng kiá»ƒm tra ngÃ¢n sÃ¡ch',0),(358498,9959,'af','Moenie Begrotings Nagaan nie',0),(358499,9959,'ro','Verifica bugetele',0),(358500,9959,'et','Kontrolli eelarveid',0),(358501,9959,'si','Ne Preverjaj proraÄunov',0),(358502,9959,'ba','Jangan cek anggaran',0),(358503,9959,'nl','Begrotingen niet controleren',0),(358504,9959,'fi','Ã„lÃ¤ valitse budjetit',0),(358505,9959,'no','Kontroller ikke budsjetter',0),(358506,9959,'da','Afkryds ikke budgetter',0),(358507,9959,'ko','ì˜ˆì‚°ì„ í™•ì¸ í•˜ì§€ ë§ˆì‹­ì‹œì˜¤',0),(358508,9959,'he','××œ ×ª×¡×ž×Ÿ ×ª×§×¦×™×‘×™×',0),(358509,9959,'el','Î”ÎµÎ½ ÎµÎ»Î­Î³Ï‡Î¿Ï…Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(358510,9959,'zh','ä¸æ£€æŸ¥è´¢æ”¿é¢„ç®—æ¡ˆ\r\n',0),(358511,9959,'sv','Kontrollera inte budgetar',0),(358512,9959,'it','Non eseguire controllo dei bilanci',0),(358513,9959,'tl','',0),(358514,9959,'th','&#3652;&#3617;&#3656;&#3605;&#3619;&#3623;&#3592;&#3626;&#3629;&#3610;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;',0),(358515,9959,'hi','à¤¬à¤œà¤Ÿ à¤•à¥€ à¤œà¤¾à¤à¤š à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¥‡à¤‚',0),(358516,9959,'ms','Tidak menyemak belanjawan',0),(358517,9959,'ar','Ø¹Ø¯Ù… Ø§Ù„Ù‚ÙŠØ§Ù… Ø¨ØªØ¯Ù‚ÙŠÙ‚ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª',0),(358518,9959,'fr','Ne cochez pas les Budgets',0),(358519,9959,'jp','äºˆç®—ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã›ã‚“ã€‚',0),(358520,9959,'pt','NÃ£o verificar os orÃ§amentos',0),(358521,9959,'ru','ÐÐµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÑ‚ÑŒ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ñ‹',0),(358522,9959,'es','No Chequear los Presupuestos',0),(358523,9959,'de','Budgets nicht prÃ¼fen',0),(358524,9959,'en','Do Not Check Budgets',0),(358525,9960,'is','',0),(358526,9960,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ ',0),(358527,9960,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ ',0),(358528,9960,'tr','Ä°ÅŸ eklemek',0),(358529,9960,'pl','Dodaj zadanie',0),(358530,9960,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(358531,9960,'ur','Ø¬Ø§Ø¨ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(358532,9960,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾',0),(358533,9960,'vi','thÃªm job',0),(358534,9960,'af','Kontrakwerk Byvoeg',0),(358535,9960,'ro','Adauga Job',0),(358536,9960,'et','TÃ¶Ã¶ lisamine',0),(358537,9960,'si','Dodaj delo',0),(358538,9960,'ba','Tambah pekerjaan',0),(358539,9960,'nl','Job toevoegen',0),(358540,9960,'fi','TyÃ¶ lisÃ¤Ã¤',0),(358541,9960,'no','Jobb legge',0),(358542,9960,'da','Job tilfÃ¸je',0),(358543,9960,'ko','ìž‘ì—… ì¶”ê°€',0),(358544,9960,'he','×”×•×¡×£ ××ª ×”×¢×‘×•×“×”',0),(358545,9960,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(358546,9960,'zh','æ–°å¢žä½œä¸š\r\n',0),(358547,9960,'sv','LÃ¤gg till jobb',0),(358548,9960,'it','Lavoro Aggiungi',0),(358549,9960,'tl','',0),(358550,9960,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3634;&#3609;',0),(358551,9960,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(358552,9960,'ms','Tambah kerja',0),(358553,9960,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ¸ÙŠÙØ©',0),(358554,9960,'fr','Ajouter Job',0),(358555,9960,'jp','ã‚¸ãƒ§ãƒ–ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(358556,9960,'pt','Adicionar emprego',0),(358557,9960,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(358558,9960,'es','Agregar Trabajo',0),(358559,9960,'de','Job hinzufÃ¼gen',0),(358560,9960,'en','Job Add',0),(358561,9961,'is','',0),(358562,9961,'dr','MSProject Ù†Ø§Ù… Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(358563,9961,'pr','MSProject Ù†Ø§Ù… Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(358564,9961,'tr','MSProject iÅŸ adÄ±',0),(358565,9961,'pl','Nazwa zadanie MSProject',0),(358566,9961,'bg','Ð˜Ð¼Ðµ Ð½Ð° MSProject Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(358567,9961,'ur','Ù†Ø§Ù… Ù…Ø³Ù¾Ø±ÙˆØ¬ÛŒÚ©Ù¹ Ø¬Ø§Ø¨',0),(358568,9961,'sr','ÐÐ°Ð·Ð¸Ð² ÐœÐ¡ÐŸÑ€Ð¾Ñ˜ÐµÑ†Ñ‚ Ð¿Ð¾ÑÐ»Ð°',0),(358569,9961,'vi','tÃªn cÃ´ng viá»‡c MSProject',0),(358570,9961,'af','MSProject Werknaam',0),(358571,9961,'ro','MSProject Job nume',0),(358572,9961,'et','MSProject tÃ¶Ã¶ nimi',0),(358573,9961,'si','Ime MSProject posla',0),(358574,9961,'ba','Nama MSProject pekerjaan',0),(358575,9961,'nl','MSProject Taaknaam',0),(358576,9961,'fi','MSProject tyÃ¶n nimi',0),(358577,9961,'no','Navn pÃ¥ MSProject',0),(358578,9961,'da','MSProject Job navn',0),(358579,9961,'ko','MSProject ìž‘ì—… ì´ë¦„',0),(358580,9961,'he','×©× ×”×ž×©×™×ž×” MSProject',0),(358581,9961,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ MSProject',0),(358582,9961,'zh','MSé¡¹ç›®ä½œä¸šåç§°\r\n',0),(358583,9961,'sv','MSProject jobbnamn',0),(358584,9961,'it','Nome lavoro MSProject',0),(358585,9961,'tl','',0),(358586,9961,'th','&#3594;&#3639;&#3656;&#3629;&#3591;&#3634;&#3609; MSProject ',0),(358587,9961,'hi','MSProject à¤•à¤¾à¤°à¥à¤¯ à¤¨à¤¾à¤®',0),(358588,9961,'ms','Nama kerja MSProject',0),(358589,9961,'ar','Ø§Ø³Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ© Ù…Ø³Ø¨Ø±ÙˆØ¬ÙŠÙƒØª',0),(358590,9961,'fr','Nom du travail de MSProject',0),(358591,9961,'jp','MSProject ã‚¸ãƒ§ãƒ–å',0),(358592,9961,'pt','Nome do trabalho de MSProject',0),(358593,9961,'ru','Ð˜Ð¼Ñ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ, MSProject',0),(358594,9961,'es','Nombre de Trabajo para Proyecto MS',0),(358595,9961,'de','MSProject Jobname',0),(358596,9961,'en','MSProject Job Name',0),(358597,9962,'is','',0),(358598,9962,'dr','Ù†Ø§Ø­ÙŠÙ‡ ',0),(358599,9962,'pr','Ù†Ø§Ø­ÙŠÙ‡ ',0),(358600,9962,'tr','BÃ¶lge',0),(358601,9962,'pl','W regionie',0),(358602,9962,'bg','Ð ÐµÐ³Ð¸Ð¾Ð½',0),(358603,9962,'ur','Ø¹Ù„Ø§Ù‚Û',0),(358604,9962,'sr','Ð ÐµÐ³Ð¸Ð¾Ð½Ð°',0),(358605,9962,'vi','vÃ¹ng',0),(358606,9962,'af','Streek',0),(358607,9962,'ro','Regiune',0),(358608,9962,'et','Piirkond',0),(358609,9962,'si','Regija',0),(358610,9962,'ba','Wilayah',0),(358611,9962,'nl','Regio',0),(358612,9962,'fi','Alueen',0),(358613,9962,'no','Regionen',0),(358614,9962,'da','Regionen',0),(358615,9962,'ko','ì§€ì—­',0),(358616,9962,'he','××–×•×¨',0),(358617,9962,'el','Î ÎµÏÎ¹Î¿Ï‡Î®',0),(358618,9962,'zh','åŒº\r\n',0),(358619,9962,'sv','Regionen',0),(358620,9962,'it','Regione',0),(358621,9962,'tl','',0),(358622,9962,'th','&#3616;&#3641;&#3617;&#3636;&#3616;&#3634;&#3588;',0),(358623,9962,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(358624,9962,'ms','Rantau',0),(358625,9962,'ar','Ø§Ù„Ù…Ù†Ø·Ù‚Ø©',0),(358626,9962,'fr','RÃ©gion',0),(358627,9962,'jp','åœ°åŸŸ',0),(358628,9962,'pt','RegiÃ£o',0),(358629,9962,'ru','Ð ÐµÐ³Ð¸Ð¾Ð½',0),(358630,9962,'es','RegiÃ³n',0),(358631,9962,'de','Region',0),(358632,9962,'en','Region',0),(358633,9963,'is','',0),(358634,9963,'dr','(Ø¨ÙŠÙ…Ù‡ Ø­ÙˆØ§Ø¯Ø«',0),(358635,9963,'pr','Ù…Ø¨Ù„Øº Ø¨ÙŠÙ…Ù‡ Ù…Ø±Ú¯ ØªØµØ§Ø¯ÙÙŠ(Ø¨ÙŠÙ…Ù‡ Ø­ÙˆØ§Ø¯Ø«',0),(358636,9963,'tr','Risk sigorta tutarÄ±',0),(358637,9963,'pl','Kwota ubezpieczenia ryzyka',0),(358638,9963,'bg','Ð Ð¸ÑÐº Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÑƒÐ¼Ð°',0),(358639,9963,'ur','Ø®Ø·Ø±Û Ù†ÛÛŒÚº Ø¨ÛŒÙ…Û Ú©ÛŒ Ø±Ù‚Ù…',0),(358640,9963,'sr','Ð Ð¸Ð·Ð¸Ðº Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ° Ð¸Ð·Ð½Ð¾Ñ',0),(358641,9963,'vi','tá»•ng sá»• báº£o hiá»ƒm rá»§i ro',0),(358642,9963,'af','Risiko versekering bedrag',0),(358643,9963,'ro','Suma de asigurare risc',0),(358644,9963,'et','Riski kindlustus summa',0),(358645,9963,'si','Znesek zavarovanja tveganja',0),(358646,9963,'ba','Dana asuransi risiko',0),(358647,9963,'nl','Bedrag voor verzekerde risico',0),(358648,9963,'fi','Riski perusmÃ¤Ã¤rÃ¤Ã¤n',0),(358649,9963,'no','Risiko forsikring belÃ¸p',0),(358650,9963,'da','Risiko forsikring belÃ¸b',0),(358651,9963,'ko','ìœ„í—˜ ë³´í—˜ ê¸ˆì•¡',0),(358652,9963,'he','×¡×›×•× ×‘×™×˜×•×— ×¡×™×›×•× ×™×',0),(358653,9963,'el','Î‘ÏƒÏ†Î±Î»Î¹ÏƒÏ„Î¹ÎºÏŒ Ï€Î¿ÏƒÏŒ ÎºÎ¹Î½Î´ÏÎ½Î¿Ï…',0),(358654,9963,'zh','é£Žé™©ä¿é™©é‡‘é¢\r\n',0),(358655,9963,'sv','Risk fÃ¶rsÃ¤kringsbelopp',0),(358656,9963,'it','Importo assicurazione rischio',0),(358657,9963,'tl','',0),(358658,9963,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3648;&#3591;&#3636;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3588;&#3623;&#3634;&#3617;&#3648;&#3626;&#3637;&#3656;&#3618;&#3591;',0),(358659,9963,'hi','à¤œà¥‹à¤–à¤¿à¤® à¤¬à¥€à¤®à¤¾ à¤°à¤¾à¤¶à¤¿',0),(358660,9963,'ms','Jumlah insurans risiko',0),(358661,9963,'ar','Ù…Ø¨Ù„Øº Ø§Ù„ØªØ£Ù…ÙŠÙ† Ø¶Ø¯ Ø§Ù„Ù…Ø®Ø§Ø·Ø±',0),(358662,9963,'fr','Montant d\'assurance de risques',0),(358663,9963,'jp','ãƒªã‚¹ã‚¯ä¿é™ºé‡‘é¡',0),(358664,9963,'pt','Quantidade de seguros de risco',0),(358665,9963,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ€Ð¸ÑÐºÐ¾Ð²',0),(358666,9963,'es','Monto de Seguro de Riesgos',0),(358667,9963,'de','Risiko Versicherungssumme',0),(358668,9963,'en','Risk Insurance Amount',0),(358669,9964,'is','',0),(358670,9964,'dr','(Ø¨ÙŠÙ…Ù‡ Ø­ÙˆØ§Ø¯Ø«',0),(358671,9964,'pr','ØªØ§Ø±ÙŠØ® Ø§Ù†Ù‚Ø¶Ø§Ø¡ Ø¨ÙŠÙ…Ù‡ Ù…Ø±Ú¯ ØªØµØ§Ø¯ÙÙŠ(Ø¨ÙŠÙ…Ù‡ Ø­ÙˆØ§Ø¯Ø«',0),(358672,9964,'tr','Risk SigortasÄ± son kullanma tarihi',0),(358673,9964,'pl','Data wygaÅ›niÄ™cia ubezpieczenia ryzyka',0),(358674,9964,'bg','Ð Ð¸ÑÐºÐ¾Ð²Ð¸ Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²ÐºÐ¸ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(358675,9964,'ur','Ø±Ø³Ú© Ø§Ù†Ø´ÙˆØ±Ù†Ø³ Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(358676,9964,'sr','Ð Ð¸Ð·Ð¸Ðº Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ° Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÑÑ‚Ð°Ð½ÐºÐ° Ð²Ð°Ð¶ÐµÑšÐ°',0),(358677,9964,'vi','gia háº¡n ngÃ y báº£o hiá»ƒm rá»§i ro',0),(358678,9964,'af','Risiko versekering vervaldatum',0),(358679,9964,'ro','Data de expirare asigurare risc',0),(358680,9964,'et','Riski kindlustus aegumiskuupÃ¤ev',0),(358681,9964,'si','Tveganje zavarovanja potek rok',0),(358682,9964,'ba','Risiko asuransi kadaluarsa',0),(358683,9964,'nl','Risico verzekering vervaldatum',0),(358684,9964,'fi','Riski Vakuutuksen vanhentumispÃ¤ivÃ¤',0),(358685,9964,'no','Risiko forsikringen utlÃ¸psdato',0),(358686,9964,'da','Risiko forsikring udlÃ¸bsdato',0),(358687,9964,'ko','ìœ„í—˜ ë³´í—˜ ë§Œë£Œ ë‚ ì§œ',0),(358688,9964,'he','×ª××¨×™×š ×ª×¤×•×’×” ×‘×™×˜×•×— ×¡×™×›×•× ×™×',0),(358689,9964,'el','ÎšÎ¯Î½Î´Ï…Î½Î¿ Î»Î®Î¾Î· Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚',0),(358690,9964,'zh','é£Žé™©ä¿é™©åˆ°æœŸæ—¥\r\n',0),(358691,9964,'sv','Risk fÃ¶rsÃ¤kring utgÃ¥ngsdatum',0),(358692,9964,'it','Data di scadenza assicurazione rischio',0),(358693,9964,'tl','',0),(358694,9964,'th','&#3623;&#3633;&#3609;&#3627;&#3617;&#3604;&#3629;&#3634;&#3618;&#3640;&#3648;&#3591;&#3636;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3588;&#3623;&#3634;&#3617;&#3648;&#3626;&#3637;&#3656;&#3618;&#3591;',0),(358695,9964,'hi','à¤œà¥‹à¤–à¤¿à¤® à¤¬à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(358696,9964,'ms','Tarikh tamat tempoh insurans risiko',0),(358697,9964,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØªØ£Ù…ÙŠÙ† Ø¶Ø¯ Ø§Ù„Ù…Ø®Ø§Ø·Ø±',0),(358698,9964,'fr','Date d\'Expiration d\'assurance de risques',0),(358699,9964,'jp','ãƒªã‚¹ã‚¯ä¿é™ºæœŸé™',0),(358700,9964,'pt','Data de expiraÃ§Ã£o seguros de risco',0),(358701,9964,'ru','Ð¡Ñ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ€Ð¸ÑÐºÐ¾Ð²',0),(358702,9964,'es','Seguro de Riesgos Fecha de Vencimiento',0),(358703,9964,'de','Risiko-Versicherung-Ablaufdatum',0),(358704,9964,'en','Risk Insurance Expiration Date',0),(358705,9965,'is','',0),(358706,9965,'dr','Ø¨ÙŠÙ…Ù‡ Ú¯Ø± Ø¨ÙŠÙ…Ù‡ Ù…Ø±Ú¯ ØªØµØ§Ø¯ÙÙŠ',0),(358707,9965,'pr','Ø¨ÙŠÙ…Ù‡ Ú¯Ø± Ø¨ÙŠÙ…Ù‡ Ù…Ø±Ú¯ ØªØµØ§Ø¯ÙÙŠ',0),(358708,9965,'tr','Risk SigortasÄ± sigortacÄ±',0),(358709,9965,'pl','Ryzyko Underwriter ubezpieczeÅ„',0),(358710,9965,'bg','Ð Ð¸ÑÐº Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²ÐºÐ° Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(358711,9965,'ur','Ø±Ø³Ú© Ø§Ù†Ø´ÙˆØ±Ù†Ø³ Ø§Ù†ÚˆØ±ÙˆØ±Ø§Ù¹ÛŒØ±',0),(358712,9965,'sr','Ð Ð¸Ð·Ð¸Ðº Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(358713,9965,'vi','thanh toÃ¡n há»£p Ä‘á»“ng báº£o hiá»ƒm rá»§i ro',0),(358714,9965,'af','Risiko versekering Underwriter',0),(358715,9965,'ro','Risc de subscriitor de asigurare',0),(358716,9965,'et','Riski kindlustus Underwriter',0),(358717,9965,'si','Tveganje zavarovanja porok',0),(358718,9965,'ba','Penanggung asuransi risiko',0),(358719,9965,'nl','Risico verzekering Underwriter',0),(358720,9965,'fi','Riskin vakuutus takaaja',0),(358721,9965,'no','Risiko forsikringen Underwriter',0),(358722,9965,'da','Risiko forsikring Underwriter',0),(358723,9965,'ko','ìœ„í—˜ ë³´í—˜ ì—…ìž',0),(358724,9965,'he','×¡×™×›×•× ×™× ×‘×ª×—×•× ×”×‘×™×˜×•×—',0),(358725,9965,'el','Î‘ÏƒÏ†Î±Î»Î¹ÏƒÏ„Î¹ÎºÎ® Î±ÏƒÏ†Î±Î»Î¹ÏƒÏ„Î®Ï‚ ÎºÎ¹Î½Î´ÏÎ½Ï‰Î½',0),(358726,9965,'zh','é£Žé™©ä¿é™©æ‹…ä¿äºº\r\n',0),(358727,9965,'sv','Risk fÃ¶rsÃ¤kring Underwriter',0),(358728,9965,'it','Sottoscrittore di assicurazione rischio',0),(358729,9965,'tl','',0),(358730,9965,'th','&#3648;&#3591;&#3636;&#3609;&#3611;&#3619;&#3632;&#3585;&#3633;&#3609;&#3588;&#3623;&#3634;&#3617;&#3648;&#3626;&#3637;&#3656;&#3618;&#3591;&#3616;&#3634;&#3618;&#3651;&#3605;&#3657;&#3585;&#3634;&#3619;&#3648;&#3586;&#3637;&#3618;&#3609;',0),(358731,9965,'hi','à¤œà¥‹à¤–à¤¿à¤® à¤¬à¥€à¤®à¤¾ à¤¹à¤¾à¤®à¥€à¤¦à¤¾à¤°',0),(358732,9965,'ms','Pengunderait insurans risiko',0),(358733,9965,'ar','Ù…ÙƒØªØªØ¨ Ø§Ù„ØªØ£Ù…ÙŠÙ† Ø¶Ø¯ Ø§Ù„Ù…Ø®Ø§Ø·Ø±',0),(358734,9965,'fr','Souscripteur d\'assurance risque',0),(358735,9965,'jp','ãƒªã‚¹ã‚¯ä¿é™ºå¼•å—',0),(358736,9965,'pt','Subscritor de seguros de risco',0),(358737,9965,'ru','Ð¡Ñ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ€Ð¸ÑÐºÐ° ÐÐ½Ð´ÐµÑ€Ñ€Ð°Ð¹Ñ‚ÐµÑ€',0),(358738,9965,'es','Seguro de Riesgos Asegurador',0),(358739,9965,'de','Risiko Versicherung Underwriter',0),(358740,9965,'en','Risk Insurance Underwriter',0),(358741,9966,'is','',0),(358742,9966,'dr','ÙƒØ¯ Ø³Ø§ÙŠØª',0),(358743,9966,'pr','ÙƒØ¯ Ø³Ø§ÙŠØª',0),(358744,9966,'tr','Site kodu',0),(358745,9966,'pl','Kod strony',0),(358746,9966,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð¾Ð±ÐµÐºÑ‚Ð°',0),(358747,9966,'ur','Ø³Ø§Ø¦Ù¹ Ú©Ø§ Ú©ÙˆÚˆ',0),(358748,9966,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(358749,9966,'vi','MÃ£ trang web',0),(358750,9966,'af','Terreinkode',0),(358751,9966,'ro','Site-ul codul',0),(358752,9966,'et','Koha kood',0),(358753,9966,'si','Mesto kode',0),(358754,9966,'ba','Kode situs',0),(358755,9966,'nl','Site-Code',0),(358756,9966,'fi','Sivuston koodi',0),(358757,9966,'no','OmrÃ¥dekoden',0),(358758,9966,'da','Site kode',0),(358759,9966,'ko','ì‚¬ì´íŠ¸ ì½”ë“œ',0),(358760,9966,'he','×§×•×“ ××ª×¨',0),(358761,9966,'el','Î ÎµÏÎ¹Î¿Ï‡Î® ÎºÏŽÎ´Î¹ÎºÎ±',0),(358762,9966,'zh','ç½‘ç«™å®ˆåˆ™\r\n',0),(358763,9966,'sv','Webbplats kod',0),(358764,9966,'it','Codice sito',0),(358765,9966,'tl','',0),(358766,9966,'th','&#3619;&#3627;&#3633;&#3626;&#3604;&#3657;&#3634;&#3609;',0),(358767,9966,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤•à¥‹à¤¡',0),(358768,9966,'ms','Soalan kod',0),(358769,9966,'ar','Ù…Ø¯ÙˆÙ†Ø© Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(358770,9966,'fr','Code de site',0),(358771,9966,'jp','ã‚µã‚¤ãƒˆ ã‚³ãƒ¼ãƒ‰',0),(358772,9966,'pt','CÃ³digo do site',0),(358773,9966,'ru','ÐšÐ¾Ð´ ÑÐ°Ð¹Ñ‚Ð°',0),(358774,9966,'es','CÃ³digo de Sitio',0),(358775,9966,'de','Standortcode',0),(358776,9966,'en','Site Code',0),(358777,9967,'is','',0),(358778,9967,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ ',0),(358779,9967,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ ',0),(358780,9967,'tr','Proje bÃ¼tÃ§esi Ekle',0),(358781,9967,'pl','DodaÄ‡ budÅ¼et zlecenia',0),(358782,9967,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(358783,9967,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(358784,9967,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð±ÑƒÑŸÐµÑ‚ Ð¿Ð¾ÑÐ»Ð°',0),(358785,9967,'vi','ThÃªm NgÃ¢n sÃ¡ch cÃ´ng viá»‡c',0),(358786,9967,'af','Werkstuk Begroting Byvoeg',0),(358787,9967,'ro','Adauga Buget lucrare',0),(358788,9967,'et','Lisage projekti eelarve',0),(358789,9967,'si','Dodaj PredraÄun projekta',0),(358790,9967,'ba','Tambahkan pekerjaan anggaran',0),(358791,9967,'nl','Projectbudget toevoegen',0),(358792,9967,'fi','LisÃ¤Ã¤ projektibudjetti',0),(358793,9967,'no','Legge til prosjektbudsjettet',0),(358794,9967,'da','TilfÃ¸je sagsbudget',0),(358795,9967,'ko','ì¼ìžë¦¬ ì˜ˆì‚° ì¶”ê°€',0),(358796,9967,'he','×”×•×¡×£ ×ª×§×¦×™×‘ ×¢×‘×•×“×”',0),(358797,9967,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Î­ÏÎ³Î¿Ï…',0),(358798,9967,'zh','å¢žåŠ é¡¹ç›®é¢„ç®—\r\n',0),(358799,9967,'sv','LÃ¤gg till projektbudget',0),(358800,9967,'it','Aggiungi Budget Commessa',0),(358801,9967,'tl','',0),(358802,9967,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3610;&#3611;&#3619;&#3632;&#3611;&#3634;&#3603;&#3591;&#3634;&#3609;',0),(358803,9967,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¬à¤œà¤Ÿ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(358804,9967,'ms','Tambah kerja bajet',0),(358805,9967,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(358806,9967,'fr','Ajouter Budgetaire de Tache',0),(358807,9967,'jp','ã‚¸ãƒ§ãƒ–ã®äºˆç®—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(358808,9967,'pt','Adicionar trabalho orÃ§amento',0),(358809,9967,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(358810,9967,'es','Agregar Presupuesto de Trabajo',0),(358811,9967,'de','Projektbudget hinzufÃ¼gen',0),(358812,9967,'en','Add Job Budget',0),(358813,9968,'is','',0),(358814,9968,'dr','Ú¯Ø±ÙˆÙ‡ Ù„Ø§Ø²Ù… Ø§Ø³Øª',0),(358815,9968,'pr','Ú¯Ø±ÙˆÙ‡ Ù„Ø§Ø²Ù… Ø§Ø³Øª',0),(358816,9968,'tr','Gerekli kategori',0),(358817,9968,'pl','Kategoria wymagane',0),(358818,9968,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¸Ð·Ð¸ÑÐºÐ²Ð°',0),(358819,9968,'ur','Ø²Ù…Ø±Û Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(358820,9968,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð°',0),(358821,9968,'vi','YÃªu cáº§u',0),(358822,9968,'af','Kategorie Benodig',0),(358823,9968,'ro','Categoria necesarÄƒ',0),(358824,9968,'et','Kategooria kohustuslik',0),(358825,9968,'si','Kategorija, ki zahteva',0),(358826,9968,'ba','Kategori yang diperlukan',0),(358827,9968,'nl','Categorie vereist',0),(358828,9968,'fi','Pakollinen luokka',0),(358829,9968,'no','Kategori kreves',0),(358830,9968,'da','Kategori krÃ¦ves',0),(358831,9968,'ko','í•„ìš”í•œ ë²”ì£¼',0),(358832,9968,'he','×§×˜×’×•×¨×™×” × ×“×¨×©',0),(358833,9968,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î±, Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(358834,9968,'zh','åˆ†ç±»è¦æ±‚\r\n',0),(358835,9968,'sv','Kategori krÃ¤vs',0),(358836,9968,'it','Categoria necessaria',0),(358837,9968,'tl','',0),(358838,9968,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;',0),(358839,9968,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(358840,9968,'ms','Kategori yang diperlukan',0),(358841,9968,'ar','Ø§Ù„ØªØµÙ†ÙŠÙ Ù…Ø·Ù„ÙˆØ¨',0),(358842,9968,'fr','CatÃ©gorie requis',0),(358843,9968,'jp','å¿…è¦ãªã‚«ãƒ†ã‚´ãƒª',0),(358844,9968,'pt','Categoria exigida',0),(358845,9968,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð°Ñ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(358846,9968,'es','CategorÃ­a Requerida',0),(358847,9968,'de','Kategorie erforderlich',0),(358848,9968,'en','Category Required',0),(358849,9969,'is','',0),(358850,9969,'dr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(358851,9969,'pr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(358852,9969,'tr','Maliyet kodu gerekli',0),(358853,9969,'pl','Koszt kodu wymaganych',0),(358854,9969,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÐºÐ¾Ð´ ÑÐµ Ð¸Ð·Ð¸ÑÐºÐ²Ð°',0),(358855,9969,'ur','Ù„Ø§Ú¯Øª Ú©ÙˆÚˆ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(358856,9969,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÐºÐ¾Ð´ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°',0),(358857,9969,'vi','yÃªu cáº§u mÃ£ chi phÃ­',0),(358858,9969,'af','Koste Kode Benodig',0),(358859,9969,'ro','Cost Code necesar',0),(358860,9969,'et','Kulude koodi vaja',0),(358861,9969,'si','StroÅ¡kovno kodo zahteva',0),(358862,9969,'ba','Kode biaya yang diperlukan',0),(358863,9969,'nl','Kosten Code vereist',0),(358864,9969,'fi','Kustannusten koodi tarvitaan',0),(358865,9969,'no','Pris koden kreves',0),(358866,9969,'da','Pris kode krÃ¦ves',0),(358867,9969,'ko','í•„ìš”í•œ ë¹„ìš©ëœ ì½”ë“œ',0),(358868,9969,'he','×¢×œ×•×ª ×”×§×•×“ ×”× ×“×¨×©',0),(358869,9969,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ± Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(358870,9969,'zh','æˆæœ¬ä»£ç çš„è§„å®š\r\n',0),(358871,9969,'sv','Kostnad koden krÃ¤vs',0),(358872,9969,'it','Codice costo richiesto',0),(358873,9969,'tl','',0),(358874,9969,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3619;&#3627;&#3633;&#3626;&#3588;&#3656;&#3634;&#3651;&#3594;&#3657;&#3592;&#3656;&#3634;&#3618;',0),(358875,9969,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(358876,9969,'ms','Kod kos yang diperlukan',0),(358877,9969,'ar','Ø±Ù…Ø² Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(358878,9969,'fr','CoÃ»t Code requis',0),(358879,9969,'jp','å¿…è¦ãªã‚³ã‚¹ãƒˆã®ã‚³ãƒ¼ãƒ‰',0),(358880,9969,'pt','Custo cÃ³digo necessÃ¡rio',0),(358881,9969,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´Ð°, Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾Ð³Ð¾',0),(358882,9969,'es','CÃ³digo de Costo Requerido',0),(358883,9969,'de','Kosten erforderlichen Code',0),(358884,9969,'en','Cost Code Required',0),(358885,9970,'is','',0),(358886,9970,'dr','ÙƒØ¯ Ø´ØºÙ„ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(358887,9970,'pr','ÙƒØ¯ Ø´ØºÙ„ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(358888,9970,'tr','Ä°ÅŸ kodu gerekli',0),(358889,9970,'pl','Kod zadania wymagane',0),(358890,9970,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° ÐºÐ¾Ð´ ÑÐµ Ð¸Ð·Ð¸ÑÐºÐ²Ð°',0),(358891,9970,'ur','Ø¶Ø±ÙˆØ±Øª Ù…Ù„Ø§Ø²Ù…Øª Ú©ÙˆÚˆ',0),(358892,9970,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ñ˜Ðµ Ð¨Ð¸Ñ„Ñ€Ð° Ð¿Ð¾Ð´Ñ€ÑƒÑ‡Ñ˜Ð°',0),(358893,9970,'vi','mÃ£ cÃ´ng viá»‡c Ä‘Ã²i',0),(358894,9970,'af','Werkstuk Kode Benodig',0),(358895,9970,'ro','Job Code necesar',0),(358896,9970,'et','TÃ¶Ã¶ koodi vaja',0),(358897,9970,'si','Delo kodo zahteva',0),(358898,9970,'ba','Kode pekerjaan yang diperlukan',0),(358899,9970,'nl','Baan Code vereist',0),(358900,9970,'fi','TyÃ¶koodi tarvitaan',0),(358901,9970,'no','Jobbkode som kreves',0),(358902,9970,'da','Job kode krÃ¦ves',0),(358903,9970,'ko','ìž‘ì—… ì½”ë“œ',0),(358904,9970,'he','× ×“×¨×© ×§×•×“ ×¢×‘×•×“×”',0),(358905,9970,'el','ÎšÏ‰Î´Î¹ÎºÏŒ Î­ÏÎ³Î¿Ï… Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(358906,9970,'zh','è§„å®šçš„å·¥ä½œä»£ç \r\n',0),(358907,9970,'sv','Jobb kod krÃ¤vs',0),(358908,9970,'it','Codice di lavoro richiesto',0),(358909,9970,'tl','',0),(358910,9970,'th','&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3619;&#3627;&#3633;&#3626;&#3591;&#3634;&#3609;',0),(358911,9970,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤•à¥‹à¤¡',0),(358912,9970,'ms','Kod kerja yang dikehendaki',0),(358913,9970,'ar','ÙƒÙˆØ¯ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(358914,9970,'fr','Code du travail requis',0),(358915,9970,'jp','å¿…è¦ãªä»•äº‹ã‚³ãƒ¼ãƒ‰',0),(358916,9970,'pt','CÃ³digo de trabalho necessÃ¡rio',0),(358917,9970,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð´Ð°, Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾Ð³Ð¾',0),(358918,9970,'es','CÃ³digo de Trabajo Requerido',0),(358919,9970,'de','Job-Code erforderlich',0),(358920,9970,'en','Job Code Required',0),(358921,9971,'is','',0),(358922,9971,'dr','ÙˆÙ‚ØªÙŠ Ø´ØºÙ„ Ù…Ø´Ø®Øµ Ù…ÙŠ Ø´ÙˆØ¯ Ø¨Ø§ÙŠØ¯ Ù¾Ø± Ø´ÙˆØ¯  Ø¯Ø± ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ú¯Ø±ÙˆÙ‡ ',0),(358923,9971,'pr','ÙˆÙ‚ØªÙŠ Ø´ØºÙ„ Ù…Ø´Ø®Øµ Ù…ÙŠ Ø´ÙˆØ¯ Ø¨Ø§ÙŠØ¯ Ù¾Ø± Ø´ÙˆØ¯  Ø¯Ø± ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ú¯Ø±ÙˆÙ‡ ',0),(358924,9971,'tr','Ne zaman iÅŸ belirtilen maliyet kodu ve kategori doldurmanÄ±z gerekir',0),(358925,9971,'pl','Kiedy okreÅ›lone zadanie, naleÅ¼y wypeÅ‚niÄ‡ kod kosztu i kategorii',0),(358926,9971,'bg','ÐšÐ¾Ð³Ð°Ñ‚Ð¾ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ð° ÐºÐ¾Ð´ Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(358927,9971,'ur','Ø¬Ø¨ Ø§Ø®ØªØµØ§ØµÛŒ Ù…Ù„Ø§Ø²Ù…Øª Ù„Ø§Ú¯Øª Ú©ÙˆÚˆ Ø§ÙˆØ± Ø²Ù…Ø±Û Ù…ÛŒÚº Ù¾ÙØ± Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(358928,9971,'sr','ÐšÐ°Ð´Ð° Ñ˜Ðµ Ð¿Ð¾ÑÐ°Ð¾ Ð½Ð°Ð²ÐµÐ´ÐµÐ½ Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ð¿ÑƒÐ½Ð¸Ñ‚Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÐºÐ¾Ð´Ð° Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(358929,9971,'vi','Khi cÃ´ng viá»‡c Ä‘Æ°á»£c chá»‰ Ä‘á»‹nh pháº£i Ä‘iá»n Ä‘áº§y Ä‘á»§ chi phÃ­ vÃ  ngÃ nh nghá»',0),(358930,9971,'af','Wanneer Werkstuk Gespesifiseerd is Moet Koste Kode en Kategorie Ingevul word',0),(358931,9971,'ro','CÃ¢nd Job specificate trebuie sÄƒ completaÅ£i codul de Cost ÅŸi categorie',0),(358932,9971,'et','Kui tÃ¶Ã¶ on mÃ¤Ã¤ratletud siis tuleb tÃ¤ita kulu kood ja kategooria',0),(358933,9971,'si','Ko posel morate izpolniti stroÅ¡kovno kodo in Kategorija',0),(358934,9971,'ba','Ketika pekerjaan ditentukan harus mengisi kode biaya dan kategori',0),(358935,9971,'nl','Wanneer taak opgegeven kosten Code en categorie moet invullen',0),(358936,9971,'fi','Kun TyÃ¶tunnuksen ja on tÃ¤ytettÃ¤vÃ¤ kustannuskoodi luokka',0),(358937,9971,'no','NÃ¥r jobben angitt mÃ¥ fylle ut pris koden og kategori',0),(358938,9971,'da','NÃ¥r Job angivet skal udfylde omkostninger kode og kategori',0),(358939,9971,'ko','ì§€ì • ëœ ìž‘ì—… ë¹„ìš©ëœ ì½”ë“œ ë° ì¹´í…Œê³ ë¦¬ì—ì„œ ì±„ì›Œì•¼',0),(358940,9971,'he','×›××©×¨ ×ž×©×™×ž×” ×©×¦×•×™× ×” ×¢×œ×™×š ×œ×ž×œ× ×§×•×“ ×¢×œ×•×ª ×•×§×˜×’×•×¨×™×”',0),(358941,9971,'el','ÎŒÏ„Î±Î½ ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Î· ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÏƒÎµÏ„Îµ Ï„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ± ÎºÎ±Î¹ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(358942,9971,'zh','æŒ‡å®šä½œä¸šå¿…é¡»å¡«å†™æˆæœ¬ä»£ç å’Œç±»åˆ«\r\n',0),(358943,9971,'sv','NÃ¤r jobb angivna mÃ¥ste fylla i kostnad kod och kategori',0),(358944,9971,'it','Quando il lavoro specificato deve compilare codice costo e categoria',0),(358945,9971,'tl','',0),(358946,9971,'th','&#3648;&#3617;&#3639;&#3656;&#3629;&#3591;&#3634;&#3609;&#3606;&#3641;&#3585;&#3619;&#3632;&#3610;&#3640;&#3605;&#3657;&#3629;&#3591;&#3585;&#3619;&#3629;&#3585;&#3619;&#3627;&#3633;&#3626;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3649;&#3621;&#3632;&#3',0),(358947,9971,'hi','à¤œà¤¬ à¤¨à¥Œà¤•à¤°à¥€ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤”à¤° à¤¶à¥à¤°à¥‡à¤£à¥€ à¤®à¥‡à¤‚ à¤­à¤°à¤¨à¥‡ à¤šà¤¾à¤¹à¤¿à¤',0),(358948,9971,'ms','Bilakah kerja yang ditentukan mestilah mengisi kod kos dan kategori',0),(358949,9971,'ar','Ø¹Ù†Ø¯Ù…Ø§ ÙŠØ¬Ø¨ Ù…Ù„Ø¡ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…Ø­Ø¯Ø¯Ø© ÙÙŠ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ø§Ù„ØªÙƒÙ„ÙØ©ØŒ ÙˆØ§Ù„ÙØ¦Ø©',0),(358950,9971,'fr','Lorsque le travail spÃ©cifiÃ© doit remplir Code coÃ»t et catÃ©gorie',0),(358951,9971,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã¨ã‚«ãƒ†ã‚´ãƒªã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ä»•äº‹ã‚’æŒ‡å®šã—ãŸå ´åˆ',0),(358952,9971,'pt','Quando o trabalho especificado deve preencher cÃ³digo custo e categoria',0),(358953,9971,'ru','ÐšÐ¾Ð³Ð´Ð° ÑƒÐºÐ°Ð·Ð°Ð½Ð½Ñ‹Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð·Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð² ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¸ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ð´Ð°',0),(358954,9971,'es','Cuando el Trabajo estÃ¡ Especificado Debe Llenar el Costo, CÃ³digo y CategorÃ­a',0),(358955,9971,'de','Bei Angabe von Job muss Kosten Code und Kategorie ausfÃ¼llen',0),(358956,9971,'en','When Job Specified Must Fill in Cost Code and Category',0),(358957,9972,'is','',0),(358958,9972,'dr','Ù‡Ù…ÙŠØ´Ù‡ Ø§Ú¯Ø± Ø´ØºÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(358959,9972,'pr','Ù‡Ù…ÙŠØ´Ù‡ Ø§Ú¯Ø± Ø´ØºÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(358960,9972,'tr','Her zaman iÅŸ seÃ§tiyseniz,',0),(358961,9972,'pl','Zawsze, gdy zadanie zaznaczone',0),(358962,9972,'bg','Ð’Ð¸Ð½Ð°Ð³Ð¸ Ð°ÐºÐ¾ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(358963,9972,'ur','Ø§Ú¯Ø± Ù…Ù„Ø§Ø²Ù…Øª Ú©Ùˆ ÛÙ…ÛŒØ´Û Ù…Ù†ØªØ®Ø¨',0),(358964,9972,'sr','Ð£Ð²ÐµÐº Ð°ÐºÐ¾ Ð¿Ð¾ÑÐ°Ð¾ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸',0),(358965,9972,'vi','LuÃ´n luÃ´n náº¿u chá»n viá»‡c',0),(358966,9972,'af','Altyd as werk gekies',0),(358967,9972,'ro','ÃŽntotdeauna dacÄƒ Job selectat',0),(358968,9972,'et','Alati kui tÃ¶Ã¶ valitud',0),(358969,9972,'si','Vedno, Äe delo izbrali',0),(358970,9972,'ba','Selalu jika pekerjaan dipilih',0),(358971,9972,'nl','Altijd als taak geselecteerd',0),(358972,9972,'fi','Aina, jos tyÃ¶ valittu',0),(358973,9972,'no','Alltid hvis jobb',0),(358974,9972,'da','Altid hvis Job valgt',0),(358975,9972,'ko','ì§ì—…ì„ ì„ íƒ í•˜ëŠ” ê²½ìš°ì— í•­ìƒ',0),(358976,9972,'he','×ª×ž×™×“ ×× ×”×¢×‘×•×“×” × ×‘×—×¨',0),(358977,9972,'el','Î Î¬Î½Ï„Î± ÎµÎ¬Î½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(358978,9972,'zh','å§‹ç»ˆå‡è®¾é€‰æ‹©çš„å·¥ä½œ\r\n',0),(358979,9972,'sv','Alltid om jobb',0),(358980,9972,'it','Sempre se il lavoro selezionato',0),(358981,9972,'tl','',0),(358982,9972,'th','&#3648;&#3626;&#3617;&#3629;&#3606;&#3657;&#3634;&#3648;&#3621;&#3639;&#3629;&#3585;&#3591;&#3634;&#3609;',0),(358983,9972,'hi','à¤¯à¤¦à¤¿ à¤¹à¤®à¥‡à¤¶à¤¾ à¤¨à¥Œà¤•à¤°à¥€ à¤•à¤¾ à¤šà¤¯à¤¨',0),(358984,9972,'ms','Sentiasa jika memilih kerja',0),(358985,9972,'ar','Ø¯Ø§Ø¦Ù…Ø§Ù‹ ÙÙŠ Ø­Ø§Ù„Ø© ØªØ­Ø¯ÙŠØ¯ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(358986,9972,'fr','Toujours si emploi sÃ©lectionnÃ©',0),(358987,9972,'jp','ã‚¸ãƒ§ãƒ–ãŒé¸æŠžã•ã‚Œã¦ã„ã‚‹å ´åˆã«å¸¸ã«',0),(358988,9972,'pt','Sempre se trabalho selecionado',0),(358989,9972,'ru','Ð’ÑÐµÐ³Ð´Ð° Ð¿Ñ€Ð¸ Ð²Ñ‹Ð±Ð¾Ñ€Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(358990,9972,'es','Siempre si el Trabajo estÃ¡ Seleccionado',0),(358991,9972,'de','Immer, wenn Auftrag ausgewÃ¤hlt',0),(358992,9972,'en','Always if Job Selected',0),(358993,9973,'is','',0),(358994,9973,'dr','ØªØ§Ø±ÙŠØ® ØªØ¹Ù‡Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯',0),(358995,9973,'pr','ØªØ§Ø±ÙŠØ® ØªØ¹Ù‡Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯',0),(358996,9973,'tr','TaahhÃ¼t verilerin baÅŸarÄ±yla alÄ±ndÄ±',0),(358997,9973,'pl','PomyÅ›lnie zaimportowane dane zobowiÄ…zanie',0),(358998,9973,'bg','ÐÐ½Ð³Ð°Ð¶Ð¸Ð¼ÐµÐ½Ñ‚ Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(358999,9973,'ur','Ø¹Ø²Ù… Ú©ÙˆØ§Ø¦Ù Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯',0),(359000,9973,'sr','ÐŸÐ¾ÑÐ²ÐµÑ›ÐµÐ½Ð¾ÑÑ‚ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸',0),(359001,9973,'vi','Ä‘Ã£ nháº­p dá»¯ liá»‡u cam káº¿t tahnhf cÃ´ng',0),(359002,9973,'af','\"Commitment\" Data Suksesvol Ingevoer',0),(359003,9973,'ro','Angajamentul datele importate cu succes',0),(359004,9973,'et','Kohustus andmeid edukalt imporditud',0),(359005,9973,'si','Zavezanost podatkov uspeÅ¡no uvoÅ¾en',0),(359006,9973,'ba','Komitmen Data berhasil diimpor',0),(359007,9973,'nl','Inzet gegevens geÃ¯mporteerd',0),(359008,9973,'fi','Sitoutumista tietojen tuonti onnistui',0),(359009,9973,'no','Forpliktelse dataene importert',0),(359010,9973,'da','Engagement Data importeret',0),(359011,9973,'ko','ì„±ê³µì ìœ¼ë¡œ ê°€ì ¸ì˜¨ ì•½ì† ë°ì´í„°',0),(359012,9973,'he','×ž×—×•×™×‘×•×ª × ×ª×•× ×™× ×ž×™×•×‘××™× ×‘×”×¦×œ×—×”',0),(359013,9973,'el','Î”Î­ÏƒÎ¼ÎµÏ…ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(359014,9973,'zh','æ‰¿è¯ºä»˜æ¬¾æ•°æ®å¯¼å…¥æˆåŠŸ\r\n',0),(359015,9973,'sv','Engagemang Data har importerats',0),(359016,9973,'it','Impegno dati importati con successo',0),(359017,9973,'tl','',0),(359018,9973,'th','&#3585;&#3634;&#3619;&#3617;&#3629;&#3610;&#3627;&#3617;&#3634;&#3618;&#3606;&#3641;&#3585;&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(359019,9973,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§à¤¤à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤¯à¤¾à¤¤',0),(359020,9973,'ms','Data komitmen yang berjaya diimport',0),(359021,9973,'ar','Ø§Ù„Ø§Ù„ØªØ²Ø§Ù… Ø¨Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(359022,9973,'fr','DonnÃ©es d\'engagement importÃ©es avec succÃ¨s',0),(359023,9973,'jp','ã‚³ãƒŸãƒƒãƒˆãƒ¡ãƒ³ãƒˆ ãƒ‡ãƒ¼ã‚¿ãŒæ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã¾ã—ãŸ',0),(359024,9973,'pt','Compromisso dados importados com Ãªxito',0),(359025,9973,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²',0),(359026,9973,'es','Datos de Compromiso Importados Exitosamente',0),(359027,9973,'de','Engagement-Daten wurden erfolgreich importiert',0),(359028,9973,'en','Commitment Data Imported Successfully',0),(359029,9974,'is','',0),(359030,9974,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  Ú¯Ø±ÙˆÙ‡  Ù†ÙŠØ³Øª',0),(359031,9974,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  Ú¯Ø±ÙˆÙ‡  Ù†ÙŠØ³Øª',0),(359032,9974,'tr','Kategori bulunamadÄ±',0),(359033,9974,'pl','Nie moÅ¼na odnaleÅºÄ‡ kategorii',0),(359034,9974,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(359035,9974,'ur','Ø²Ù…Ø±Û Ù†ÛÛŒÚº Ù…Ù„ Ø³Ú©Ø§',0),(359036,9974,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(359037,9974,'vi','khÃ´ng thá»ƒ tÃ¬m tháº¥y danh má»¥c',0),(359038,9974,'af','Kategorie nie kon vind',0),(359039,9974,'ro','Nu am putut gÄƒsi categorie',0),(359040,9974,'et','Ei leidnud kategooria',0),(359041,9974,'si','Kategorije ni bilo mogoÄe najti.',0),(359042,9974,'ba','Tidak dapat menemukan kategori',0),(359043,9974,'nl','Konden niet vondst categorie',0),(359044,9974,'fi','Ei lÃ¶ytynyt luokka',0),(359045,9974,'no','Finner ikke kategori',0),(359046,9974,'da','Kunne ikke finde kategori',0),(359047,9974,'ko','ë²”ì£¼ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(359048,9974,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ×§×˜×’×•×¨×™×”',0),(359049,9974,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(359050,9974,'zh','æ‰¾ä¸åˆ°åˆ†ç±»\r\n',0),(359051,9974,'sv','Kunde inte hitta kategori',0),(359052,9974,'it','Non poteva trovare la categoria',0),(359053,9974,'tl','',0),(359054,9974,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3627;&#3617;&#3623;&#3604;&#3627;&#3617;&#3641;&#3656;&#3652;&#3604;&#3657;',0),(359055,9974,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(359056,9974,'ms','Tidak dapat mencari kategori',0),(359057,9974,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥ÙŠØ¬Ø§Ø¯ Ø§Ù„ØªØµÙ†ÙŠÙ',0),(359058,9974,'fr','N\'a pas trouvÃ© de catÃ©gorie',0),(359059,9974,'jp','ã‚«ãƒ†ã‚´ãƒªãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(359060,9974,'pt','NÃ£o consegui encontrar a categoria',0),(359061,9974,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÐÐ°Ð¹Ñ‚Ð¸ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(359062,9974,'es','No se PodÃ­a Encontrar la CategorÃ­a',0),(359063,9974,'de','Kategorie konnte nicht gefunden werden.',0),(359064,9974,'en','Could Not Find Category',0),(359065,9975,'is','',0),(359066,9975,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡  Ù†ÙŠØ³Øª',0),(359067,9975,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡  Ù†ÙŠØ³Øª',0),(359068,9975,'tr','Maliyet kodu bulunamadÄ±',0),(359069,9975,'pl','Nie mogÅ‚em znaleÅºÄ‡ kod kosztu',0),(359070,9975,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð°Ñ… Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ñ Ñ†ÐµÐ½Ð° ÐºÐ¾Ð´',0),(359071,9975,'ur','Ù„Ø§Ú¯Øª Ú©ÙˆÚˆ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§',0),(359072,9975,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ ÑˆÐ¸Ñ„Ñ€Ñƒ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(359073,9975,'vi','khÃ´ng thá»ƒ tÃ¬m tháº¥y mÃ£ chi phÃ­',0),(359074,9975,'af','Kon Nie Koste Kode Vind Nie',0),(359075,9975,'ro','Nu a putut gÄƒsi codul de Cost',0),(359076,9975,'et','Ei leidnud kulu kood',0),(359077,9975,'si','StroÅ¡kovno kode ni bilo mogoÄe najti.',0),(359078,9975,'ba','Tidak bisa menemukan kode biaya',0),(359079,9975,'nl','Konden niet vondst kosten Code',0),(359080,9975,'fi','Ei lÃ¶ytÃ¤nyt kustannuskoodi',0),(359081,9975,'no','Finner ikke kostnader kode',0),(359082,9975,'da','Kunne ikke finde omkostninger kode',0),(359083,9975,'ko','ë¹„ìš©ëœ ì½”ë“œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(359084,9975,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×§×•×“ ×¢×œ×•×ª',0),(359085,9975,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ ÎºÏ‰Î´Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(359086,9975,'zh','æ‰¾ä¸åˆ°æˆæœ¬ä»£ç \r\n',0),(359087,9975,'sv','Kunde inte hitta kostnad kod',0),(359088,9975,'it','Non poteva trovare codice costo',0),(359089,9975,'tl','',0),(359090,9975,'th','&#3652;&#3617;&#3656;&#3626;&#3634;&#3617;&#3634;&#3619;&#3606;&#3627;&#3634;&#3619;&#3627;&#3633;&#3626;&#3605;&#3657;&#3609;&#3607;&#3640;&#3609;&#3652;&#3604;&#3657;',0),(359091,9975,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(359092,9975,'ms','Tidak dapat mencari kod kos',0),(359093,9975,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø±Ù…Ø² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(359094,9975,'fr','N\'a pas trouvÃ© de Code de coÃ»t',0),(359095,9975,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã‚’è¦‹ã¤ã‘ã‚‹ã“ã¨ãŒã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(359096,9975,'pt','NÃ£o foi possÃ­vel encontrar o cÃ³digo de custo',0),(359097,9975,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´',0),(359098,9975,'es','No se PodÃ­a Encontrar el CÃ³digo de Costo',0),(359099,9975,'de','Kosten-Code konnte nicht gefunden werden.',0),(359100,9975,'en','Could Not Find Cost Code',0),(359101,9976,'is','',0),(359102,9976,'dr','ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ ',0),(359103,9976,'pr','ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ ',0),(359104,9976,'tr','Excel dosyasÄ±',0),(359105,9976,'pl','Plik Excel',0),(359106,9976,'bg','Excel Ñ„Ð°Ð¹Ð»',0),(359107,9976,'ur','Ø§ÛŒÚ©Ø³Ù„ ÙØ§Ø¦Ù„',0),(359108,9976,'sr','Ð•xÑ†ÐµÐ» Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(359109,9976,'vi','File excel',0),(359110,9976,'af','ExcellÃªer ',0),(359111,9976,'ro','FiÅŸier Excel',0),(359112,9976,'et','Exceli dokument',0),(359113,9976,'si','Excel datoteke',0),(359114,9976,'ba','Excel File',0),(359115,9976,'nl','Excel-bestand',0),(359116,9976,'fi','Excel-tiedosto',0),(359117,9976,'no','Excel-fil',0),(359118,9976,'da','Excel-fil',0),(359119,9976,'ko','Excel íŒŒì¼',0),(359120,9976,'he','×§×•×‘×¥ ××§×¡×œ',0),(359121,9976,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Excel',0),(359122,9976,'zh','Excelæ–‡ä»¶\r\n',0),(359123,9976,'sv','Excel-fil',0),(359124,9976,'it','File Excel',0),(359125,9976,'tl','',0),(359126,9976,'th','&#3652;&#3615;&#3621;&#3660; Excel',0),(359127,9976,'hi','Excel à¤«à¤¼à¤¾à¤‡à¤²',0),(359128,9976,'ms','Fail Excel',0),(359129,9976,'ar','Ù…Ù„Ù Ø¥ÙƒØ³Ù„',0),(359130,9976,'fr','Fichier Excel',0),(359131,9976,'jp','Excel ãƒ•ã‚¡ã‚¤ãƒ«',0),(359132,9976,'pt','Arquivo do Excel',0),(359133,9976,'ru','Excel Ð¤Ð°Ð¹Ð»',0),(359134,9976,'es','File de Excel',0),(359135,9976,'de','Excel-Datei',0),(359136,9976,'en','Excel File',0),(359137,9977,'is','',0),(359138,9977,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø´ØºÙ„ Ùˆ ØªØ¹Ù‡Ø¯Ø§Øª ',0),(359139,9977,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø´ØºÙ„ Ùˆ ØªØ¹Ù‡Ø¯Ø§Øª ',0),(359140,9977,'tr','Alma iÅŸi bÃ¼tÃ§eleri ve taahhÃ¼tleri',0),(359141,9977,'pl','Importuj zadanie budÅ¼etÃ³w i zobowiÄ…zaÅ„',0),(359142,9977,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¸ Ð¸ Ð°Ð½Ð³Ð°Ð¶Ð¸Ð¼ÐµÐ½Ñ‚Ð¸',0),(359143,9977,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ú©Ø§Ù… ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) Ø§ÙˆØ± ÙˆØ¹Ø¯Û’',0),(359144,9977,'sr','Ð‘ÑƒÑŸÐµÑ‚Ðµ Ð¿Ð¾ÑÐ»Ð° ÑƒÐ²Ð¾Ð·Ð° Ð¸ Ð¾Ð±Ð°Ð²ÐµÐ·Ð°',0),(359145,9977,'vi','Nháº­p ngÃ¢n sÃ¡ch cÃ´ng viá»‡c vÃ  trÃ¡ch nhiá»‡m',0),(359146,9977,'af','Invoer van Werkstukbegrotings en Verbindtenisse',0),(359147,9977,'ro','Bugetele de Job import ÅŸi angajamente',0),(359148,9977,'et','TÃ¶Ã¶ eelarveid ja kohustused',0),(359149,9977,'si','Uvoz predraÄunov in obveznosti',0),(359150,9977,'ba','Impor pekerjaan anggaran dan komitmen',0),(359151,9977,'nl','Import projectbudgetten en verplichtingen',0),(359152,9977,'fi','Tuo Projektibudjettien ja sitoumukset',0),(359153,9977,'no','Importer prosjektbudsjetter og forpliktelser',0),(359154,9977,'da','Import sagsbudgetter og forpligtelser',0),(359155,9977,'ko','ê°€ì ¸ì˜¤ê¸° ìž‘ì—… ì˜ˆì‚° ë° ì•½ì†',0),(359156,9977,'he','×™×™×‘×•× ×”×¢×‘×•×“×” ×ª×§×¦×™×‘×™× ×•×”×ª×—×™×™×‘×•×™×•×ª',0),(359157,9977,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î­ÏÎ³Î¿Ï… ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ ÎºÎ±Î¹ Î´ÎµÏƒÎ¼ÎµÏÏƒÎµÎ¹Ï‚',0),(359158,9977,'zh','å¯¼å…¥ä½œä¸šé¢„ç®—å’Œæ‰¿è¯º\r\n',0),(359159,9977,'sv','Importera projektbudgetar och Ã¥taganden',0),(359160,9977,'it','Importazione bilanci di lavoro e impegni',0),(359161,9977,'tl','',0),(359162,9977,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3649;&#3621;&#3632;&#3586;&#3657;&#3629;&#3612;&#3641;&#3585;&#3617;&#3633;&#3604;',0),(359163,9977,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤¾à¤°à¥à¤¯ à¤¬à¤œà¤Ÿ à¤”à¤° à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§à¤¤à¤¾à¤“à¤‚',0),(359164,9977,'ms','Import kerja belanjawan dan komitmen',0),(359165,9977,'ar','Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ù…Ù‡Ù…Ø© Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙˆØ§Ù„Ø§Ù„ØªØ²Ø§Ù…Ø§Øª',0),(359166,9977,'fr','Import emploi Budgets et engagements',0),(359167,9977,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ã‚¸ãƒ§ãƒ–ã®äºˆç®—ã¨ã‚³ãƒŸãƒƒãƒˆãƒ¡ãƒ³ãƒˆ',0),(359168,9977,'pt','OrÃ§amentos de trabalho de importaÃ§Ã£o e autorizaÃ§Ãµes',0),(359169,9977,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¾Ð² Ñ€Ð°Ð±Ð¾Ñ‚ Ð¸ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(359170,9977,'es','Importar Presupuestos de Trabajos y Compromisos',0),(359171,9977,'de','Import-Projektbudgets und Verpflichtungen',0),(359172,9977,'en','Import Job Budgets and Commitments',0),(359173,9978,'is','',0),(359174,9978,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ â€“  ØµØ±ÙÙ†Ø¸Ø± ÙƒÙ†ÙŠØ¯ ',0),(359175,9978,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ â€“  ØµØ±ÙÙ†Ø¸Ø± ÙƒÙ†ÙŠØ¯ ',0),(359176,9978,'tr','Ä°ÅŸ bÃ¼tÃ§e verilerini--atlama zaten',0),(359177,9978,'pl','Praca budÅ¼etu danych juÅ¼ istnieje - pomijam',0),(359178,9978,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°--Ð²ÑŠÐ¶Ðµ',0),(359179,9978,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹ Ú©Û’ Ú©ÙˆØ§Ø¦Ù Ù¾ÛÙ„Û’ ÛÛŒ - Ø³Ú©Ù¾Ù¾Ù†Ú¯ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(359180,9978,'sr','ÐŸÐ¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð±ÑƒÑŸÐµÑ‚Ñƒ Ð¿Ð¾ÑÐ°Ð¾ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸--Ð¿Ñ€ÐµÑÐºÐ°ÐºÐ°ÑšÐ°',0),(359181,9978,'vi','dá»¯ liá»‡u ngÃ¢n sÃ¡ch cÃ´ng viá»‡c Ä‘Ã£ cÃ³-Ä‘ang bá»',0),(359182,9978,'af','Werkstuk Begroting Data Bestaan Alreeds -- Skip',0),(359183,9978,'ro','Job date deja existÄƒ--sÄƒrind peste',0),(359184,9978,'et','Projekti eelarve andmed juba olemas--vahele',0),(359185,9978,'si','Dela proraÄuna podatkov Å¾e obstaja--preskakovanje',0),(359186,9978,'ba','Data anggaran pekerjaan sudah ada--melewatkan',0),(359187,9978,'nl','Baan begrotingsgegevens bestaat al--overslaan',0),(359188,9978,'fi','TyÃ¶ budjettitiedot jo--ohittaminen',0),(359189,9978,'no','Jobb budsjettdata finnes allerede - hoppe',0),(359190,9978,'da','Job budgetdata findes allerede--overspringelse',0),(359191,9978,'ko','ì¼ìžë¦¬ ì˜ˆì‚° ë°ì´í„°ê°€ ì´ë¯¸ ì¡´ìž¬ í•˜ëŠ”-ê±´ë„ˆë›°ëŠ”',0),(359192,9978,'he','× ×ª×•× ×™ ×ª×§×¦×™×‘ ×”×¢×‘×•×“×” ×›×‘×¨ ×§×™×™×--×“×™×œ×•×’',0),(359193,9978,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·--Ï€Î±ÏÎ±ÎºÎ¬Î¼Ï€Ï„Î¿Î½Ï„Î±Ï‚',0),(359194,9978,'zh','é¡¹ç›®é¢„ç®—çš„æ•°æ®å·²ç»å­˜åœ¨ -è·³è¿‡\r\n',0),(359195,9978,'sv','Jobb budgetuppgifter finns redan--hoppar',0),(359196,9978,'it','Dati di bilancio di lavoro giÃ  esistano - salto',0),(359197,9978,'tl','',0),(359198,9978,'th','&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3591;&#3634;&#3609;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623; -- &#3585;&#3635;&#3621;&#3633;&#3591;&#3586;&#3657;&#3634;&#3617',0),(359199,9978,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¬à¤œà¤Ÿ à¤¡à¥‡à¤Ÿà¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ - à¤²à¤‚à¤˜à¤¨ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(359200,9978,'ms','Kerja bajet Data telah wujud--Skipping',0),(359201,9978,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© ÙˆØ¸ÙŠÙØ© Ù…ÙˆØ¬ÙˆØ¯Ø© Ø¨Ø§Ù„ÙØ¹Ù„-ØªØ®Ø·ÙŠ',0),(359202,9978,'fr','Les donnÃ©es du Budget travail existent dÃ©jÃ --sauter',0),(359203,9978,'jp','äºˆç®—ãƒ‡ãƒ¼ã‚¿ã®ã‚¸ãƒ§ãƒ–ã¯æ—¢ã«å­˜åœ¨ã—ã¾ã™--ã‚¹ã‚­ãƒƒãƒ—',0),(359204,9978,'pt','Dados do orÃ§amento de trabalho jÃ¡ existem..--pulando',0),(359205,9978,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ñ‹Ñ… Ð´Ð°Ð½Ð½Ñ‹Ñ… ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚--Ð¿Ñ€Ð¾Ð¿ÑƒÑÐº',0),(359206,9978,'es','Presupuesto de Trabajo Ya Existe -- Brincando',0),(359207,9978,'de','Job-Budget-Daten ist bereits vorhanden--Ã¼berspringen',0),(359208,9978,'en','Job Budget Data Already Exists -- Skipping',0),(359209,9979,'is','',0),(359210,9979,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(359211,9979,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(359212,9979,'tr','Ä°ÅŸ bÃ¼tÃ§e verileri baÅŸarÄ±yla alÄ±ndÄ±',0),(359213,9979,'pl','Praca budÅ¼etu dane zaimportowane pomyÅ›lnie',0),(359214,9979,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(359215,9979,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹ Ú©Û’ Ú©ÙˆØ§Ø¦Ù Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯',0),(359216,9979,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ²ÐµÐ·ÐµÐ½Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð±ÑƒÑŸÐµÑ‚Ñƒ Ð¿Ð¾ÑÐ°Ð¾',0),(359217,9979,'vi','nháº­p dá»¯ liá»‡u ngÃ¢n sÃ¡ch cÃ´ng viá»‡c thÃ nh cÃ´ng',0),(359218,9979,'af','Werkstuk Begroting Data Suksesvol Ingevoer',0),(359219,9979,'ro','Job buget datele importate cu succes',0),(359220,9979,'et','Projekti eelarve andmed edukalt imporditud',0),(359221,9979,'si','Podatke o proraÄunu delo uspeÅ¡no uvoÅ¾en',0),(359222,9979,'ba','Data anggaran pekerjaan berhasil diimpor',0),(359223,9979,'nl','Baan begrotingsgegevens geÃ¯mporteerd',0),(359224,9979,'fi','TyÃ¶ budjettitiedot tuonti onnistui',0),(359225,9979,'no','Jobb budsjettdata importert',0),(359226,9979,'da','Job budgetdata importeret',0),(359227,9979,'ko','ì„±ê³µì ìœ¼ë¡œ ê°€ì ¸ì˜¨ ìž‘ì—… ì˜ˆì‚° ë°ì´í„°',0),(359228,9979,'he','× ×ª×•× ×™ ×ª×§×¦×™×‘ ×¢×‘×•×“×” ×ž×™×•×‘× ×‘×”×¦×œ×—×”',0),(359229,9979,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î´ÎµÎ´Î¿Î¼Î­Î½Î± ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(359230,9979,'zh','é¡¹ç›®é¢„ç®—æ•°æ®å¯¼å…¥æˆåŠŸ\r\n',0),(359231,9979,'sv','Jobb budgetuppgifter har importerats',0),(359232,9979,'it','Dati di bilancio di lavoro importati correttamente',0),(359233,9979,'tl','',0),(359234,9979,'th','&#3609;&#3635;&#3648;&#3586;&#3657;&#3634;&#3586;&#3657;&#3629;&#3617;&#3641;&#3621;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(359235,9979,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¬à¤œà¤Ÿ à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤¯à¤¾à¤¤',0),(359236,9979,'ms','Data bajet kerja berjaya diimport',0),(359237,9979,'ar','Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­ ÙÙŠ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(359238,9979,'fr','DonnÃ©es du Budget travail importÃ©es avec succÃ¨s',0),(359239,9979,'jp','æ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚ŒãŸã‚¸ãƒ§ãƒ–äºˆç®—ãƒ‡ãƒ¼ã‚¿',0),(359240,9979,'pt','Trabalho orÃ§amento dados importados com Ãªxito',0),(359241,9979,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(359242,9979,'es','Datos de Presupuesto de Trabajo Importados Exitosamente',0),(359243,9979,'de','Job-Budget-Daten wurden erfolgreich importiert',0),(359244,9979,'en','Job Budget Data Imported Successfully',0),(359245,9980,'is','',0),(359246,9980,'dr','ÙƒØ¯ Ø´ØºÙ„ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª ',0),(359247,9980,'pr','ÙƒØ¯ Ø´ØºÙ„ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª ',0),(359248,9980,'tr','Proje kodu kÃ¼mesi deÄŸil',0),(359249,9980,'pl','Kod zadania nie zestaw',0),(359250,9980,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° ÐºÐ¾Ð´ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼',0),(359251,9980,'ur','Ø¬Ø§Ø¨ Ú©ÙˆÚˆ Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(359252,9980,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð¿Ð¾Ð´Ñ€ÑƒÑ‡Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(359253,9980,'vi','khÃ´ng táº¡o mÃ£ cÃ´ng viá»‡c',0),(359254,9980,'af','Werkstuk Kode Nie Opgestel',0),(359255,9980,'ro','Job cod nu setaÅ£i',0),(359256,9980,'et','TÃ¶Ã¶ Code ei mÃ¤Ã¤ra',0),(359257,9980,'si','Koda za delo ni nastavljena',0),(359258,9980,'ba','Ayub kode tidak diatur',0),(359259,9980,'nl','Baan Code niet instellen',0),(359260,9980,'fi','TyÃ¶koodi aseteta',0),(359261,9980,'no','Jobbkode ikke angitt',0),(359262,9980,'da','Job kode ikke indstillet',0),(359263,9980,'ko','ìž‘ì—… ì½”ë“œë¥¼ ì„¤ì • í•˜ì§€',0),(359264,9980,'he','×§×•×“ ×ž×©×™×ž×” ××™× ×” ×ž×•×’×“×¨×ª',0),(359265,9980,'el','ÎšÏ‰Î´Î¹ÎºÏŒ Î­ÏÎ³Î¿Ï… Ï€Î¿Ï… Î´ÎµÎ½',0),(359266,9980,'zh','æœªè®¾ç½®ä½œä¸šä»£ç \r\n',0),(359267,9980,'sv','Jobb koden inte instÃ¤lld',0),(359268,9980,'it','Codice di lavoro non impostato',0),(359269,9980,'tl','',0),(359270,9980,'th','&#3619;&#3627;&#3633;&#3626;&#3591;&#3634;&#3609;&#3652;&#3617;&#3656;&#3652;&#3604;&#3657;&#3605;&#3633;&#3657;&#3591;',0),(359271,9980,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‹à¤¡ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(359272,9980,'ms','Kod kerja tidak disetkan',0),(359273,9980,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø±Ù…Ø² Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(359274,9980,'fr','Code du travail non dÃ©finie',0),(359275,9980,'jp','ã‚¸ãƒ§ãƒ– ã‚³ãƒ¼ãƒ‰ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(359276,9980,'pt','CÃ³digo do trabalho nÃ£o definido',0),(359277,9980,'ru','ÐÐµ Ð·Ð°Ð´Ð°Ð½ ÐºÐ¾Ð´ Ð´Ð¾Ð»Ð¶Ð½Ð¾ÑÑ‚Ð¸',0),(359278,9980,'es','CÃ³digo de Trabajo No EstÃ¡ Configurado',0),(359279,9980,'de','Job-Code wurde nicht festgelegt.',0),(359280,9980,'en','Job Code Not Set',0),(359281,9981,'is','',0),(359282,9981,'dr','Ø´ØºÙ„ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(359283,9981,'pr','Ø´ØºÙ„ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(359284,9981,'tr','Ä°ÅŸ bulunamadÄ±',0),(359285,9981,'pl','Nie znaleziono',0),(359286,9981,'bg','ÐÐµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(359287,9981,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ù†ÛÛŒÚº Ù…Ù„ÛŒ',0),(359288,9981,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(359289,9981,'vi','cÃ´ng viá»‡c khÃ´ng tÃ¬m tháº¥y',0),(359290,9981,'af','Kontrakwerk Nie Gevind',0),(359291,9981,'ro','Job nu a fost gÄƒsit',0),(359292,9981,'et','TÃ¶Ã¶ ei leitud',0),(359293,9981,'si','Posla ni mogoÄe najti',0),(359294,9981,'ba','Pekerjaan tidak ditemukan',0),(359295,9981,'nl','Job niet gevonden',0),(359296,9981,'fi','TyÃ¶ ei lÃ¶ydy',0),(359297,9981,'no','Jobben ikke funnet',0),(359298,9981,'da','Job ikke fundet',0),(359299,9981,'ko','ìž‘ì—…ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(359300,9981,'he','×”×ž×©×™×ž×” ×œ× × ×ž×¦××”',0),(359301,9981,'el','Î”Î¿Ï…Î»ÎµÎ¹Î¬ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(359302,9981,'zh','æœªæ‰¾åˆ°å·¥ä½œ\r\n',0),(359303,9981,'sv','Jobb hittades inte',0),(359304,9981,'it','Lavoro non trovato',0),(359305,9981,'tl','',0),(359306,9981,'th','&#3652;&#3617;&#3656;&#3614;&#3610;&#3591;&#3634;&#3609;',0),(359307,9981,'hi','à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€ à¤¨à¥Œà¤•à¤°à¥€',0),(359308,9981,'ms','Pekerjaan yang tidak dijumpai',0),(359309,9981,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(359310,9981,'fr','Emploi non trouvÃ©',0),(359311,9981,'jp','ã‚¸ãƒ§ãƒ–ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(359312,9981,'pt','Trabalho nÃ£o encontrado',0),(359313,9981,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°',0),(359314,9981,'es','No Se EncontrÃ³ Trabajo',0),(359315,9981,'de','Stelle nicht gefunden',0),(359316,9981,'en','Job Not Found',0),(359317,9982,'is','',0),(359318,9982,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ø´ØºÙ„ ',0),(359319,9982,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ø´ØºÙ„ ',0),(359320,9982,'tr','Ä°ÅŸ Excel dosyasÄ± seÃ§in',0),(359321,9982,'pl','Wybierz plik programu Excel w pracy',0),(359322,9982,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Excel Ñ„Ð°Ð¹Ð»',0),(359323,9982,'ur','Ø¬Ø§Ø¨ Excel Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(359324,9982,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÐ°Ð¾ Ð•xÑ†ÐµÐ» Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(359325,9982,'vi','Chá»n táº­p tin excel nghá» nghiá»‡p',0),(359326,9982,'af','Selekteer Werkstuk Excel LÃªer',0),(359327,9982,'ro','SelectaÅ£i fiÅŸierul de Excel Job',0),(359328,9982,'et','Vali tÃ¶Ã¶ Exceli fail',0),(359329,9982,'si','Izberi Excelovo datoteko delo',0),(359330,9982,'ba','Pilih File Excel pekerjaan',0),(359331,9982,'nl','Selecteer Excel taakbestand',0),(359332,9982,'fi','Valitse projektin Excel-tiedosto',0),(359333,9982,'no','Velg jobben Excel-fil',0),(359334,9982,'da','VÃ¦lg Excel jobfil',0),(359335,9982,'ko','ìž‘ì—… Excel íŒŒì¼ì„ ì„ íƒ',0),(359336,9982,'he','×‘×—×¨ ×§×•×‘×¥ Excel ×”×¢×‘×•×“×”',0),(359337,9982,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Excel ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(359338,9982,'zh','é€‰æ‹©ä½œä¸šExcelæ–‡ä»¶\r\n',0),(359339,9982,'sv','VÃ¤lj jobb Excel-fil',0),(359340,9982,'it','Selezionare il File di lavoro Excel',0),(359341,9982,'tl','',0),(359342,9982,'th','&#3648;&#3621;&#3639;&#3629;&#3585;&#3591;&#3634;&#3609;&#3648;&#3611;&#3655;&#3609;&#3652;&#3615;&#3621;&#3660; Excel ',0),(359343,9982,'hi','à¤¨à¥Œà¤•à¤°à¥€ Excel à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(359344,9982,'ms','Pilih fail Excel kerja',0),(359345,9982,'ar','Ø­Ø¯Ø¯ Ù…Ù„Ù Excel Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(359346,9982,'fr','SÃ©lectionnez le fichier Excel de tÃ¢che',0),(359347,9982,'jp','ã‚¸ãƒ§ãƒ–ã® Excel ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã—ã¾ã™',0),(359348,9982,'pt','Selecione o arquivo de trabalho do Excel',0),(359349,9982,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ„Ð°Ð¹Ð» Excel Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(359350,9982,'es','Selecciona File Excel de Trabajo',0),(359351,9982,'de','WÃ¤hlen Sie Job-Excel-Datei',0),(359352,9982,'en','Select Job Excel File',0),(359353,9983,'is','',0),(359354,9983,'dr','ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ù…Ù†Ø§Ø³Ø¨ÙŠ Ù†ÙŠØ³Øª ',0),(359355,9983,'pr','ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ø¯Ø± Ù‚Ø§Ù„Ø¨ Ù…Ù†Ø§Ø³Ø¨ÙŠ Ù†ÙŠØ³Øª ',0),(359356,9983,'tr','Excel dosya biÃ§imi doÄŸru deÄŸil',0),(359357,9983,'pl','Plik programu Excel nie jest w odpowiednim formacie',0),(359358,9983,'bg','Ð¤Ð°Ð¹Ð»Ð° Ð½Ð° Excel Ð½Ðµ Ðµ Ð² Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¸Ñ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(359359,9983,'ur','Excel Ù…Ø³Ù„ Ù…Ù†Ø§Ø³Ø¨ ÙˆØ¶Ø¹ Ù…ÛŒÚº Ù†ÛÛŒÚº ÛÛ’ Û”',0),(359360,9983,'sr','Ð•xÑ†ÐµÐ» Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð¸Ñ˜Ðµ Ñƒ Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¾Ð¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(359361,9983,'vi','Táº­p tin excel nÃ y cÃ³ Ä‘á»‹nh dáº¡ng khÃ´ng Ä‘Ãºng',0),(359362,9983,'af','Die Excel LÃªer is nie in die Regte Formaat nie.',0),(359363,9983,'ro','Fi È™ ierul Excel nu este Ã®n Format corect',0),(359364,9983,'et','Exceli fail pole Ãµiges vormingus',0),(359365,9983,'si','Excel datoteka ni v pravilni obliki',0),(359366,9983,'ba','Excel File ini tidak dalam Format yang tepat',0),(359367,9983,'nl','Het Excel-bestand Is niet In de juiste indeling',0),(359368,9983,'fi','Excel-tiedosto ei ole oikeassa muodossa',0),(359369,9983,'no','Excel-filen er ikke riktig format',0),(359370,9983,'da','Excel-filen er ikke i korrekt Format',0),(359371,9983,'ko','Excel íŒŒì¼ì€ ì ì ˆ í•œ í˜•ì‹',0),(359372,9983,'he','×§×•×‘×¥ ×”-Excel ××™× ×• ×‘×ª×‘× ×™×ª ×ž×ª××™×ž×”',0),(359373,9983,'el','Î¤Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï„Î¿Ï… Excel Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÏ„Î· ÏƒÏ‰ÏƒÏ„Î® Î¼Î¿ÏÏ†Î®',0),(359374,9983,'zh','Excelæ–‡ä»¶ä¸æ˜¯æ­£ç¡®çš„æ ¼å¼\r\n',0),(359375,9983,'sv','Excel-filen Ã¤r inte i rÃ¤tt Format',0),(359376,9983,'it','Il File di Excel non Ã¨ nel formato corretto',0),(359377,9983,'tl','',0),(359378,9983,'th','Excel &#3652;&#3615;&#3621;&#3660;&#3652;&#3617;&#3656;&#3629;&#3618;&#3641;&#3656;&#3651;&#3609;&#3619;&#3641;&#3611;&#3649;&#3610;&#3610;&#3607;&#3637;&#3656;&#3648;&#3627;&#3617;&#3634;&#3632;&#3626;&#3617;',0),(359379,9983,'hi','Excel à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤‰à¤šà¤¿à¤¤ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(359380,9983,'ms','Fail Excel ini tidak dalam Format yang betul',0),(359381,9983,'ar','Excel Ø§Ù„Ù…Ù„Ù Ù„ÙŠØ³ ÙÙŠ Ø§Ù„ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„ØµØ­ÙŠØ­',0),(359382,9983,'fr','Le fichier Excel n\'est pas au bon format',0),(359383,9983,'jp','Excel ãƒ•ã‚¡ã‚¤ãƒ«ã‚’å½¢å¼ãŒæ­£ã—ãã‚ã‚Šã¾ã›ã‚“ã€‚',0),(359384,9983,'pt','O arquivo de Excel nÃ£o estÃ¡ no formato adequado',0),(359385,9983,'ru','Ð¤Ð°Ð¹Ð» Excel Ð½Ðµ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð² Ð½ÑƒÐ¶Ð½Ð¾Ð¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ',0),(359386,9983,'es','Este File Excel No estÃ¡ en el Formato Correcto',0),(359387,9983,'de','Die Exceldatei ist nicht im richtigen Format',0),(359388,9983,'en','The Excel File Is Not In The Proper Format',0),(359389,9984,'is','',0),(359390,9984,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯',0),(359391,9984,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯',0),(359392,9984,'tr','Bir Excel dosyasÄ± gÃ¶ndermeniz gerekir',0),(359393,9984,'pl','Musisz przesÅ‚aÄ‡ plik programu Excel',0),(359394,9984,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð´Ð°Ð´ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð» Ð½Ð° Excel',0),(359395,9984,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§ÛŒÚ© Excel ÙØ§Ø¦Ù„ Ø¬Ù…Ø¹ Ú©Ø±ÙˆØ§Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(359396,9984,'sr','ÐœÐ¾Ñ€Ð°Ñ˜Ñƒ Ð´Ð° Ð¿Ð¾Ð´Ð½ÐµÑÑƒ Ð•xÑ†ÐµÐ» Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(359397,9984,'vi','Báº¡n pháº£i ná»™p 1 táº­p tin excel',0),(359398,9984,'af','U moet \'n Excel LÃªer Indien.',0),(359399,9984,'ro','Trebuie sÄƒ trimiteÅ£i un fiÅŸier Excel',0),(359400,9984,'et','Te peate sisestama exceli faili',0),(359401,9984,'si','Morate poslati Excelove datoteke',0),(359402,9984,'ba','Anda harus mengirimkan Excel File',0),(359403,9984,'nl','U dient een Excel-bestand',0),(359404,9984,'fi','LÃ¤hetÃ¤t Excel-tiedosto',0),(359405,9984,'no','Du mÃ¥ sende en Excel-fil',0),(359406,9984,'da','Du skal indsende en Excel-fil',0),(359407,9984,'ko','Excel íŒŒì¼ì„ ì œì¶œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(359408,9984,'he','×¢×œ×™×š ×œ×”×’×™×© ×‘×§×•×‘×¥ Excel',0),(359409,9984,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï…Ï€Î¿Î²Î¬Î»ÎµÏ„Îµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿ Excel',0),(359410,9984,'zh','ä½ å¿…é¡»æäº¤ä¸€ä¸ªExcelæ–‡ä»¶\r\n',0),(359411,9984,'sv','Du mÃ¥ste lÃ¤mna in en Excel-fil',0),(359412,9984,'it','Ãˆ necessario inviare un File di Excel',0),(359413,9984,'tl','',0),(359414,9984,'th','&#3588;&#3640;&#3603;&#3605;&#3657;&#3629;&#3591;&#3618;&#3629;&#3617;&#3619;&#3633;&#3610;&#3652;&#3615;&#3621;&#3660; Excel ',0),(359415,9984,'hi','à¤†à¤ª à¤•à¤¿à¤¸à¥€ Excel à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(359416,9984,'ms','Anda perlu menghantar satu fail Excel',0),(359417,9984,'ar','ÙŠØ¬Ø¨ Ø¥Ø±Ø³Ø§Ù„ Ù…Ù„Ù Excel',0),(359418,9984,'fr','Vous devez soumettre un fichier Excel',0),(359419,9984,'jp','Excel ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é€ä¿¡ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(359420,9984,'pt','VocÃª deve enviar um arquivo do Excel',0),(359421,9984,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» Excel',0),(359422,9984,'es','Debe Someter un File de Excel',0),(359423,9984,'de','Sie mÃ¼ssen eine Excel-Datei einreichen.',0),(359424,9984,'en','You Must Submit an Excel File',0),(359425,9985,'is','',0),(359426,9985,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(359427,9985,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(359428,9985,'tr','Onay notlarÄ±',0),(359429,9985,'pl','Zatwierdzenie notatki',0),(359430,9985,'bg','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(359431,9985,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Û’ Ù†ÙˆÙ¹',0),(359432,9985,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(359433,9985,'vi','Ghi chÃº phÃª duyá»‡t',0),(359434,9985,'af','Goedkeuringsnotas',0),(359435,9985,'ro','Note de aprobare',0),(359436,9985,'et','Kinnituse mÃ¤rked',0),(359437,9985,'si','Odobritev opombe',0),(359438,9985,'ba','Persetujuan catatan',0),(359439,9985,'nl','Goedkeuring notities',0),(359440,9985,'fi','HyvÃ¤ksynnÃ¤n huomautuksia',0),(359441,9985,'no','Godkjenning notater',0),(359442,9985,'da','Godkendelse noter',0),(359443,9985,'ko','ìŠ¹ì¸',0),(359444,9985,'he','××™×©×•×¨ ×”×¢×¨×•×ª',0),(359445,9985,'el','ÎˆÎ³ÎºÏÎ¹ÏƒÎ· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(359446,9985,'zh','æ ¸å‡†é€šçŸ¥\r\n',0),(359447,9985,'sv','GodkÃ¤nnande anteckningar',0),(359448,9985,'it','Approvazione note',0),(359449,9985,'tl','',0),(359450,9985,'th','&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;',0),(359451,9985,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‡ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(359452,9985,'ms','Nota-Nota kelulusan',0),(359453,9985,'ar','ÙˆØªÙ„Ø§Ø­Ø¸ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø©',0),(359454,9985,'fr','Notes d\'approbation',0),(359455,9985,'jp','æ‰¿èªãƒ¡ãƒ¢',0),(359456,9985,'pt','Notas de aprovaÃ§Ã£o',0),(359457,9985,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(359458,9985,'es','Notas de AprobaciÃ³n',0),(359459,9985,'de','Genehmigung Notes',0),(359460,9985,'en','Approval Notes',0),(359461,9986,'is','',0),(359462,9986,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØµÙˆÙŠØ¨ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØ§ÙŠÙŠØ¯ Ø´Ø¯',0),(359463,9986,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØµÙˆÙŠØ¨ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ØªØ§ÙŠÙŠØ¯ Ø´Ø¯',0),(359464,9986,'tr','Onay isteÄŸi baÅŸarÄ±yla onaylandÄ±',0),(359465,9986,'pl','Zatwierdzenie wniosku pomyÅ›lnie zatwierdzona',0),(359466,9986,'bg','Ð—Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ, Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(359467,9986,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ù†Ø¸ÙˆØ± Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’',0),(359468,9986,'sr','Ð£ÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ñ˜Ðµ Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ð¾ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ',0),(359469,9986,'vi','YÃªu áº§u phÃª duyá»‡t Ä‘Æ°á»£c cháº¥p nháº­n thÃ nh cÃ´ng',0),(359470,9986,'af','Goedgekeerde Versoek Suksesvol Goedgekeur',0),(359471,9986,'ro','Cererea de aprobare aprobat cu succes',0),(359472,9986,'et','Kinnituse taotlus heaks edukalt',0),(359473,9986,'si','ProÅ¡nja za odobritev, ki uspeÅ¡no odobren',0),(359474,9986,'ba','Permintaan persetujuan disetujui berhasil',0),(359475,9986,'nl','Aanvraag tot goedkeuring goedgekeurd met succes',0),(359476,9986,'fi','HyvÃ¤ksytty onnistuneesti hyvÃ¤ksymispyyntÃ¶',0),(359477,9986,'no','GodkjenningsforespÃ¸rsel er godkjent',0),(359478,9986,'da','Godkendelsesanmodningen godkendt med succes',0),(359479,9986,'ko','ì„±ê³µì ìœ¼ë¡œ ìŠ¹ì¸ ìŠ¹ì¸ ìš”ì²­',0),(359480,9986,'he','××™×©×•×¨ ×”×‘×§×©×” ××•×©×¨×” ×‘×”×¦×œ×—×”',0),(359481,9986,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚ ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(359482,9986,'zh','æ‰¹å‡†è¯·æ±‚æ ¸å‡†æˆåŠŸ\r\n',0),(359483,9986,'sv','BegÃ¤ran om godkÃ¤nnande godkÃ¤nda framgÃ¥ngsrikt',0),(359484,9986,'it','Richiesta di approvazione approvato con successo',0),(359485,9986,'tl','',0),(359486,9986,'th','&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636; &#3585;&#3634;&#3619;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(359487,9986,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥€',0),(359488,9986,'ms','Permintaan kelulusan diluluskan berjaya',0),(359489,9986,'ar','Ø·Ù„Ø¨ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(359490,9986,'fr','Demande d\'approbation approuvÃ© avec succÃ¨s',0),(359491,9986,'jp','æ­£å¸¸ã«æ‰¿èªã•ã‚ŒãŸæ‰¿èªè¦æ±‚',0),(359492,9986,'pt','SolicitaÃ§Ã£o de aprovaÃ§Ã£o aprovada com sucesso',0),(359493,9986,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ñ€Ð¾Ñ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(359494,9986,'es','Solicitud de AprobaciÃ³n Aprobado Exitosamente',0),(359495,9986,'de','Genehmigung-Antrag genehmigt erfolgreich',0),(359496,9986,'en','Approval Request Approved Successfully',0),(359497,9987,'is','',0),(359498,9987,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª  ØªØµÙˆÙŠØ¨ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø±Ø¯  Ø´Ø¯',0),(359499,9987,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª  ØªØµÙˆÙŠØ¨ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø±Ø¯  Ø´Ø¯',0),(359500,9987,'tr','Onay isteÄŸi baÅŸarÄ±yla engellendi',0),(359501,9987,'pl','Å»Ä…dania zatwierdzenia pomyÅ›lnie',0),(359502,9987,'bg','Ð—Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ, Ð¾Ñ‚ÐºÐ°Ð· ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(359503,9987,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ù†Ú©Ø§Ø± Ú©ÛŒØ§',0),(359504,9987,'sr','Ð£ÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½ Ð·Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ',0),(359505,9987,'vi','YÃªu cáº§u phÃª duyá»‡t bá»‹ tá»« chá»‘i thÃ nh cÃ´ng',0),(359506,9987,'af','Goedgekeerde Versoek Suksesvol OntsÃª',0),(359507,9987,'ro','Cerere de aprobare a negat cu succes',0),(359508,9987,'et','TÃ¼Ã¼bikinnituse taotlusest keelduti edukalt',0),(359509,9987,'si','ProÅ¡nja za odobritev, zanikal uspeÅ¡no',0),(359510,9987,'ba','Permintaan persetujuan menyangkal berhasil',0),(359511,9987,'nl','Aanvraag tot goedkeuring geweigerd met succes',0),(359512,9987,'fi','HyvÃ¤ksymispyyntÃ¶ estetty onnistuneesti',0),(359513,9987,'no','GodkjenningsforespÃ¸rsel nektet vellykket',0),(359514,9987,'da','Godkendelsesanmodningen nÃ¦gtet med succes',0),(359515,9987,'ko','ìŠ¹ì¸ ìš”ì²­ì€ ì„±ê³µì ìœ¼ë¡œ ê±°ë¶€',0),(359516,9987,'he','××™×©×•×¨ ×”×‘×§×©×” × ×“×—×™×ª ×‘×”×¦×œ×—×”',0),(359517,9987,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚ Î±ÏÎ½Î®Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(359518,9987,'zh','æ‰¹å‡†è¯·æ±‚è¢«æ‹’ç»æˆåŠŸ\r\n',0),(359519,9987,'sv','BegÃ¤ran om godkÃ¤nnande fÃ¶rnekas framgÃ¥ngsrikt',0),(359520,9987,'it','Approvazione richiesta negata con successo',0),(359521,9987,'tl','',0),(359522,9987,'th','&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636; &#3611;&#3599;&#3636;&#3648;&#3626;&#3608;&#3585;&#3634;&#3619;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(359523,9987,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤¿à¤·à¥‡à¤§',0),(359524,9987,'ms','Permintaan kelulusan yang dinafikan berjaya',0),(359525,9987,'ar','Ø·Ù„Ø¨ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ù†ÙÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(359526,9987,'fr','Demande d\'approbation a niÃ© avec succÃ¨s',0),(359527,9987,'jp','æ‰¿èªè¦æ±‚ã‚’æ­£å¸¸ã«æ‹’å¦',0),(359528,9987,'pt','SolicitaÃ§Ã£o de aprovaÃ§Ã£o negada com sucesso',0),(359529,9987,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(359530,9987,'es','Solicitud de AprobaciÃ³n Negado Exitosamente',0),(359531,9987,'de','Genehmigung-Antrag erfolgreich verweigert',0),(359532,9987,'en','Approval Request Denied Successfully',0),(359533,9988,'is','',0),(359534,9988,'dr','ØªØ§ÙŠÙŠØ¯ ÙŠØ§  Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†Ø¬Ø§Ù… Ù‡Ø± ØªØºÙŠÙŠØ±',0),(359535,9988,'pr','ØªØ§ÙŠÙŠØ¯ ÙŠØ§  Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†Ø¬Ø§Ù… Ù‡Ø± ØªØºÙŠÙŠØ±',0),(359536,9988,'tr','Onaylama veya reddetme herhangi bir deÄŸiÅŸiklik yapmadan Ã¶nce',0),(359537,9988,'pl','ZatwierdziÄ‡ lub odrzuciÄ‡ przed dokonaniem jakichkolwiek zmian',0),(359538,9988,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÑ‚ Ð¸Ð»Ð¸ Ð¾Ñ‚ÐºÐ°Ð¶Ð°Ñ‚ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(359539,9988,'ur','Ú©Ùˆ Ù…Ù†Ø¸ÙˆØ± Ú©Ø±ÛŒÚº ÛŒØ§ Ú©ÙˆØ¦ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ú©Ø±Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ú©ÛŒ ØªØ±Ø¯ÛŒØ¯',0),(359540,9988,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð¸Ñ‚Ð¸ Ð¸Ð»Ð¸ Ð¾Ð´Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ðµ Ð¼ÐµÑšÐ°ÑšÐ°',0),(359541,9988,'vi','PhÃª duyá»‡t hoáº·c vÃ  tá»« chá»‘i trÆ°á»›c khi táº¡o thay Ä‘á»•i',0),(359542,9988,'af','Goedkeur of weier voor enige veranderinge',0),(359543,9988,'ro','Aproba sau respinge Ã®nainte de a face orice modificÄƒri',0),(359544,9988,'et','VÃµi sellest keeldumise enne muutuste tegemist',0),(359545,9988,'si','Odobrite ali zavrnete pred vnaÅ¡anjem sprememb',0),(359546,9988,'ba','Menyetujui atau menolak sebelum membuat perubahan',0),(359547,9988,'nl','Goedkeuren of weigeren voordat u wijzigingen aanbrengt',0),(359548,9988,'fi','HyvÃ¤ksyÃ¤ tai hylÃ¤tÃ¤ ennen muutosten',0),(359549,9988,'no','Godkjenne eller avvise fÃ¸r du gjÃ¸r endringer',0),(359550,9988,'da','Godkende eller afvise fÃ¸r du foretager Ã¦ndringer',0),(359551,9988,'ko','ìŠ¹ì¸ í•˜ê±°ë‚˜ ë³€ê²½ í•˜ê¸° ì „ì— ê±°ë¶€',0),(359552,9988,'he','×œ××©×¨ ××• ×œ×“×—×•×ª ×œ×¤× ×™ ×‘×™×¦×•×¢ ×©×™× ×•×™×™× ×›×œ×©×”×',0),(359553,9988,'el','Î‘Ï€Î¿Î´ÎµÏ‡Ï„ÎµÎ¯Ï„Îµ Î® Î½Î± Î±Ï€Î¿ÏÏÎ¯ÏˆÎµÏ„Îµ Ï€ÏÎ¹Î½ ÎºÎ¬Î½ÎµÏ„Îµ Î¿Ï€Î¿Î¹ÎµÏƒÎ´Î®Ï€Î¿Ï„Îµ Î±Î»Î»Î±Î³Î­Ï‚',0),(359554,9988,'zh','è¿›è¡Œä»»ä½•æ›´æ”¹ä¹‹å‰æ‰¹å‡†æˆ–æ‹’ç»',0),(359555,9988,'sv','GodkÃ¤nna eller neka innan du gÃ¶r nÃ¥gra Ã¤ndringar',0),(359556,9988,'it','Approvare o rifiutare prima di apportare modifiche',0),(359557,9988,'tl','',0),(359558,9988,'th','&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3627;&#3619;&#3639;&#3629;&#3611;&#3599;&#3636;&#3648;&#3626;&#3608; &#3585;&#3656;&#3629;&#3609;&#3607;&#3635;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#',0),(359559,9988,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤‡à¤¨à¤•à¤¾à¤°',0),(359560,9988,'ms','Meluluskan atau menolak sebelum membuat sebarang perubahan',0),(359561,9988,'ar','Ù‚Ø¨ÙˆÙ„ Ø£Ùˆ Ø±ÙØ¶ Ù‚Ø¨Ù„ Ø¥Ø¬Ø±Ø§Ø¡ Ø£ÙŠ ØªØºÙŠÙŠØ±Ø§Øª',0),(359562,9988,'fr','Approuver ou refuser avant toute modification',0),(359563,9988,'jp','æ‰¿èªã¾ãŸã¯æ‹’å¦å¤‰æ›´ã®å‰ã«',0),(359564,9988,'pt','Aprovar ou negar antes de fazer alteraÃ§Ãµes',0),(359565,9988,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Ð¸Ð»Ð¸ Ð¾Ñ‚ÐºÐ»Ð¾Ð½Ð¸Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÐ´ Ð²Ð½ÐµÑÐµÐ½Ð¸ÐµÐ¼ Ð»ÑŽÐ±Ñ‹Ñ… Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(359566,9988,'es','Aprueba o Niega Antes que Hacer Cambios',0),(359567,9988,'de','Genehmigen Sie oder ablehnen Sie, bevor Sie Ã„nderungen vornehmen',0),(359568,9988,'en','Approve Or Deny Before Making Any Changes',0),(359569,9989,'is','',0),(359570,9989,'dr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(359571,9989,'pr','ØªØ§ÙŠÙŠØ¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(359572,9989,'tr','PO onaylama',0),(359573,9989,'pl','Zatwierdzenie PO',0),(359574,9989,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÐ²Ð° PO',0),(359575,9989,'ur','Ù¾Ùˆ Ù…Ù†Ø¸ÙˆØ±',0),(359576,9989,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð°Ð²Ð° ÐŸÐž',0),(359577,9989,'vi','PhÃª duyá»‡t Ä‘Æ¡n hÃ ng',0),(359578,9989,'af','AB Goedkeur',0),(359579,9989,'ro','Aproba PO',0),(359580,9989,'et','Kinnitada PO',0),(359581,9989,'si','Odobri PO',0),(359582,9989,'ba','Menyetujui PO',0),(359583,9989,'nl','Goedkeuren van PO',0),(359584,9989,'fi','HyvÃ¤ksy PO',0),(359585,9989,'no','Godkjenne PO',0),(359586,9989,'da','Godkende PO',0),(359587,9989,'ko','PO ìŠ¹ì¸',0),(359588,9989,'he','×œ××©×¨ ×¤×•',0),(359589,9989,'el','Î•Î³ÎºÏÎ¯Î½ÎµÏ„Îµ Ï„Î¿ PO',0),(359590,9989,'zh','å®¡æ‰¹é‡‡è´­è®¢å•\r\n',0),(359591,9989,'sv','GodkÃ¤nna PO',0),(359592,9989,'it','Approvare PO',0),(359593,9989,'tl','',0),(359594,9989,'th','&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(359595,9989,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤‘à¤«à¤¼à¤¿à¤¸ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨',0),(359596,9989,'ms','Meluluskan PO',0),(359597,9989,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø¨Ùˆ',0),(359598,9989,'fr','Approuver PO',0),(359599,9989,'jp','PO ã‚’æ‰¿èªã—ã¾ã™ã€‚',0),(359600,9989,'pt','Aprovar PO',0),(359601,9989,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ PO',0),(359602,9989,'es','Aprueba OC',0),(359603,9989,'de','PO zu genehmigen',0),(359604,9989,'en','Approve PO',0),(359605,9990,'is','',0),(359606,9990,'dr','Ù…Ù†ØªØ¸Ø± ØªØ§ÙŠÙŠØ¯',0),(359607,9990,'pr','Ù…Ù†ØªØ¸Ø± ØªØ§ÙŠÙŠØ¯',0),(359608,9990,'tr','Onay bekliyor',0),(359609,9990,'pl','OczekujÄ…ce na zatwierdzenie',0),(359610,9990,'bg','Ð˜Ð·Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ Ð½Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(359611,9990,'ur','Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ø±',0),(359612,9990,'sr','ÐšÐ¾Ñ˜Ð¸ Ñ‡ÐµÐºÐ° Ð½Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ',0),(359613,9990,'vi','Äang chá» phÃª duyá»‡t',0),(359614,9990,'af','Afwagtend op Goedkeuring',0),(359615,9990,'ro','ÃŽn aÅŸteptarea aprobÄƒrii',0),(359616,9990,'et','Ootab heakskiitmist',0),(359617,9990,'si','ÄŒaka na odobritev',0),(359618,9990,'ba','Menunggu persetujuan',0),(359619,9990,'nl','In afwachting van goedkeuring',0),(359620,9990,'fi','Odottaa hyvÃ¤ksyntÃ¤Ã¤',0),(359621,9990,'no','Venter pÃ¥ godkjenning',0),(359622,9990,'da','Afventer godkendelse',0),(359623,9990,'ko','ìŠ¹ì¸ì„ ê¸°ë‹¤ë¦¬ëŠ” ì¤‘',0),(359624,9990,'he','×ž×ž×ª×™×Ÿ ×œ××™×©×•×¨',0),(359625,9990,'el','Î•Î½ Î±Î½Î±Î¼Î¿Î½Î® Ï„Î·Ï‚ Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚',0),(359626,9990,'zh','æ­£åœ¨ç­‰å¾…æ‰¹å‡†\r\n',0),(359627,9990,'sv','VÃ¤ntar pÃ¥ godkÃ¤nnande',0),(359628,9990,'it','In attesa di approvazione',0),(359629,9990,'tl','',0),(359630,9990,'th','&#3619;&#3629;&#3585;&#3634;&#3619;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;',0),(359631,9990,'hi','à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤•à¤¾ à¤‡à¤‚à¤¤à¤œà¤¾à¤°',0),(359632,9990,'ms','Menunggu kelulusan',0),(359633,9990,'ar','ÙÙŠ Ø§Ù†ØªØ¸Ø§Ø± Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø©',0),(359634,9990,'fr','En attente d\'approbation',0),(359635,9990,'jp','æ‰¿èªã‚’å¾…ã¡',0),(359636,9990,'pt','Aguardando aprovaÃ§Ã£o',0),(359637,9990,'ru','ÐžÐ¶Ð¸Ð´Ð°ÐµÑ‚ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(359638,9990,'es','Esperando AprobaciÃ³n',0),(359639,9990,'de','Freigeschaltet',0),(359640,9990,'en','Awaiting Approval',0),(359641,9991,'is','',0),(359642,9991,'dr','Ø®Ø·Ø§ Ø¯Ø±  Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØ§ÙŠÙŠØ¯ ',0),(359643,9991,'pr','Ø®Ø·Ø§ Ø¯Ø±  Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØ§ÙŠÙŠØ¯ ',0),(359644,9991,'tr','Hata inkar onay isteÄŸi',0),(359645,9991,'pl','BÅ‚Ä…d odmawiajÄ…cy zatwierdzania wniosek',0),(359646,9991,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¾Ñ‚ÐºÐ°Ð·Ð²Ð°Ñ‰Ð°Ñ‚Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(359647,9991,'ur','Ù†Ù‚Øµ Ú©Ø§ Ø§Ù†Ú©Ø§Ø± Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(359648,9991,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾Ñ€Ð¸Ñ†Ð°ÑšÐ° Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ',0),(359649,9991,'vi','Lá»—i khi tá»« chá»‘i Ä‘á» nghá»‹ duyá»‡t',0),(359650,9991,'af','Fout ontken goedkeuring versoek',0),(359651,9991,'ro','Eroare nega cererea de aprobare',0),(359652,9991,'et','TÃµrge keelav kinnituse taotlus',0),(359653,9991,'si','Napaka zanikala proÅ¡nja za odobritev',0),(359654,9991,'ba','Permintaan persetujuan menyangkal kesalahan',0),(359655,9991,'nl','Fout ontkennen aanvraag tot goedkeuring',0),(359656,9991,'fi','Virhe kieltÃ¤Ã¤ hyvÃ¤ksymispyyntÃ¶',0),(359657,9991,'no','Feil nekte godkjenningsforespÃ¸rsel',0),(359658,9991,'da','Fejl fornÃ¦gtede godkendelsesanmodning',0),(359659,9991,'ko','ì˜¤ë¥˜ ë¶€ì • ìŠ¹ì¸ ìš”ì²­',0),(359660,9991,'he','×‘×§×©×” ×œ××™×©×•×¨ ×œ×”×ª×›×—×© ×©×’×™××”',0),(359661,9991,'el','Î£Ï†Î¬Î»Î¼Î± Î±ÏÎ½Î¿ÏÎ¼ÎµÎ½Î¿ Î±Î¯Ï„Î·ÏƒÎ· Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚',0),(359662,9991,'zh','é”™è¯¯æ‹’ç»æ‰¹å‡†è¯·æ±‚\r\n',0),(359663,9991,'sv','Fel att fÃ¶rneka godkÃ¤nnandebegÃ¤ran',0),(359664,9991,'it','Errore negando richiesta di approvazione',0),(359665,9991,'tl','',0),(359666,9991,'th','&#3612;&#3636;&#3604;&#3614;&#3621;&#3634;&#3604;&#3651;&#3609;&#3585;&#3634;&#3619;&#3611;&#3599;&#3636;&#3648;&#3626;&#3608;&#3585;&#3634;&#3619;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;',0),(359667,9991,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¨à¤•à¤¾à¤° à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(359668,9991,'ms','Ralat menafikan kelulusan permintaan',0),(359669,9991,'ar','Ø·Ù„Ø¨ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ù†ÙÙŠ Ø§Ù„Ø®Ø·Ø£',0),(359670,9991,'fr','Demande d\'approbation qui refuse d\'erreur',0),(359671,9991,'jp','æ‰¿èªè¦æ±‚ã®æ‹’å¦ã‚¨ãƒ©ãƒ¼',0),(359672,9991,'pt','Erro nega pedido de aprovaÃ§Ã£o',0),(359673,9991,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ñ‚ÐºÐ°Ð·Ð° ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ Ð·Ð°Ð¿Ñ€Ð¾Ñ',0),(359674,9991,'es','Error Negando Solicitud de AprobaciÃ³n',0),(359675,9991,'de','Fehler verweigert Zustimmung Anfrage',0),(359676,9991,'en','Error Denying Approval Request',0),(359677,9992,'is','',0),(359678,9992,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØ§ÙŠÙŠØ¯ Ø¯Ø§Ø±Ø¯ ',0),(359679,9992,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØ§ÙŠÙŠØ¯ Ø¯Ø§Ø±Ø¯ ',0),(359680,9992,'tr','PO onayÄ± gerekiyor.',0),(359681,9992,'pl','PO potrzebuje zgody',0),(359682,9992,'bg','PO ÑÐµ Ð½ÑƒÐ¶Ð´Ð°Ðµ Ð¾Ñ‚ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(359683,9992,'ur','Ù¾Ùˆ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(359684,9992,'sr','ÐŸÐž Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(359685,9992,'vi','Ä‘Æ¡n mua hÃ ng cáº§n duyá»‡t',0),(359686,9992,'af','AB Nodig Goedkeuring',0),(359687,9992,'ro','PO are nevoie de aprobarea',0),(359688,9992,'et','PO vajab heakskiitu',0),(359689,9992,'si','PO potrebuje odobritev',0),(359690,9992,'ba','PO membutuhkan persetujuan',0),(359691,9992,'nl','PO moet goedkeuring',0),(359692,9992,'fi','PO tulee hyvÃ¤ksyÃ¤',0),(359693,9992,'no','PO trenger godkjenning',0),(359694,9992,'da','PO behov for godkendelse',0),(359695,9992,'ko','PO ìŠ¹ì¸ í•„ìš”',0),(359696,9992,'he','×¤×• ×¦×¨×™×š ××™×©×•×¨',0),(359697,9992,'el','PO Ï‡ÏÎµÎ¹Î¬Î¶ÎµÏ„Î±Î¹ Ï„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ· Ï„Î¿Ï…',0),(359698,9992,'zh','è®¢å•éœ€è¦å®¡æ‰¹\r\n',0),(359699,9992,'sv','PO behÃ¶ver godkÃ¤nnande',0),(359700,9992,'it','PO ha bisogno di approvazione',0),(359701,9992,'tl','',0),(359702,9992,'th','&#3627;&#3617;&#3634;&#3618;&#3648;&#3627;&#3605;&#3640;&#3651;&#3610;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;',0),(359703,9992,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤‘à¤«à¤¼à¤¿à¤¸ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(359704,9992,'ms','PO memerlukan kelulusan',0),(359705,9992,'ar','Øµ. Ø¨. ÙˆÙŠØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ Ù…ÙˆØ§ÙÙ‚Ø©',0),(359706,9992,'fr','PO doit Ãªtre approuvÃ©',0),(359707,9992,'jp','PO ã®æ‰¿èªã‚’å¿…è¦',0),(359708,9992,'pt','PO precisa de aprovaÃ§Ã£o',0),(359709,9992,'ru','PO Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ',0),(359710,9992,'es','OC Necesita AprobaciÃ³n',0),(359711,9992,'de','PO braucht Zustimmung',0),(359712,9992,'en','PO Needs Approval',0),(359713,9993,'is','',0),(359714,9993,'dr','ØªØ§Ø±ÙŠØ® Ø¯Ø±Ø®ÙˆØ§Ø³Øª ',0),(359715,9993,'pr','ØªØ§Ø±ÙŠØ® Ø¯Ø±Ø®ÙˆØ§Ø³Øª ',0),(359716,9993,'tr','Ä°stek tarihi',0),(359717,9993,'pl','Data wniosku',0),(359718,9993,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ°',0),(359719,9993,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø±ÛŒÚº',0),(359720,9993,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°',0),(359721,9993,'vi','ngÃ y Ä‘á» nghá»‹',0),(359722,9993,'af','Versoek Datum',0),(359723,9993,'ro','Cerere data',0),(359724,9993,'et','Taotluse kuupÃ¤ev',0),(359725,9993,'si','Datum zahteve',0),(359726,9993,'ba','Tanggal permintaan',0),(359727,9993,'nl','Datum van aanvraag',0),(359728,9993,'fi','PyynnÃ¶n pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(359729,9993,'no','ForespÃ¸rselsdato',0),(359730,9993,'da','Anmodningsdato',0),(359731,9993,'ko','ìš”ì²­ ë‚ ì§œ',0),(359732,9993,'he','×ª××¨×™×š ×‘×§×©×”',0),(359733,9993,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î·Ï‚ Î±Î¯Ï„Î·ÏƒÎ·Ï‚',0),(359734,9993,'zh','ç”³è¯·æ—¥æœŸ\r\n',0),(359735,9993,'sv','Datum',0),(359736,9993,'it','Data di richiesta',0),(359737,9993,'tl','',0),(359738,9993,'th','&#3623;&#3633;&#3609;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;',0),(359739,9993,'hi','à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(359740,9993,'ms','Tarikh permintaan',0),(359741,9993,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø·Ù„Ø¨',0),(359742,9993,'fr','Date de la demande',0),(359743,9993,'jp','è¦æ±‚ã®æ—¥ä»˜',0),(359744,9993,'pt','Data do pedido',0),(359745,9993,'ru','Ð”Ð°Ñ‚Ð° Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(359746,9993,'es','Fecha de Solicitud',0),(359747,9993,'de','Datum der Anfrage',0),(359748,9993,'en','Request Date',0),(359749,9994,'is','',0),(359750,9994,'dr','Ø°Ø®ÙŠØ±Ù‡  Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯ ',0),(359751,9994,'pr','Ø°Ø®ÙŠØ±Ù‡  Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯ ',0),(359752,9994,'tr','Engellenen Kaydet',0),(359753,9994,'pl','Zapisz zablokowany',0),(359754,9994,'bg','ÐžÑÐ²ÐµÐ½ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ',0),(359755,9994,'ur','Ø¨Ù„Ø§Ú© Ø´Ø¯Û Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(359756,9994,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ð¸',0),(359757,9994,'vi','LÆ°u bá»‹ cháº·n',0),(359758,9994,'af','Stoor geblokkeer',0),(359759,9994,'ro','SalvaÅ£i blocat',0),(359760,9994,'et','Salvesta blokeeritud',0),(359761,9994,'si','Shranite blokiran',0),(359762,9994,'ba','Simpan diblokir',0),(359763,9994,'nl','Geblokkeerde opslaan',0),(359764,9994,'fi','Tallenna estetty',0),(359765,9994,'no','Lagre blokkert',0),(359766,9994,'da','Gemme blokeret',0),(359767,9994,'ko','ì €ìž¥ ì°¨ë‹¨',0),(359768,9994,'he','×©×ž×•×¨ ×—×¡×•×ž×™×',0),(359769,9994,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Î¼Ï€Î»Î¿ÎºÎ¬ÏÎµÎ¹',0),(359770,9994,'zh','ä¿å­˜å°é”\r\n',0),(359771,9994,'sv','Spara blockerade',0),(359772,9994,'it','Salvare bloccati',0),(359773,9994,'tl','',0),(359774,9994,'th','&#3610;&#3621;&#3655;&#3629;&#3585;&#3585;&#3634;&#3619;&#3610;&#3633;&#3609;&#3607;&#3638;&#3585;',0),(359775,9994,'hi','à¤…à¤µà¤°à¥à¤¦à¥à¤§ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(359776,9994,'ms','Simpan disekat',0),(359777,9994,'ar','Ø­ÙØ¸ Ø§Ù„Ù…Ø­Ø¸ÙˆØ±Ø©',0),(359778,9994,'fr','Ã‰conomisez bloquÃ©s',0),(359779,9994,'jp','ãƒ–ãƒ­ãƒƒã‚¯ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(359780,9994,'pt','Salvar bloqueados',0),(359781,9994,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð·Ð°Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ',0),(359782,9994,'es','Guearda Bloqueado',0),(359783,9994,'de','Speichern Sie blockierte',0),(359784,9994,'en','Save Blocked',0),(359785,9995,'is','',0),(359786,9995,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ ',0),(359787,9995,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ ',0),(359788,9995,'tr','Proje bÃ¼tÃ§esi Ekle',0),(359789,9995,'pl','DodaÄ‡ budÅ¼et zlecenia',0),(359790,9995,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(359791,9995,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(359792,9995,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ð¿Ð¾ÑÐ»Ð° Ð´Ð¾Ð´Ð°Ñ‚Ðµ',0),(359793,9995,'vi','thÃªm ngÃ¢n sÃ¡ch cÃ´ng viá»‡c',0),(359794,9995,'af','Werkstuk Begroting Skep',0),(359795,9995,'ro','Buget lucrare Adauga',0),(359796,9995,'et','Projekti eelarve lisamine',0),(359797,9995,'si','PredraÄun projekta dodati',0),(359798,9995,'ba','Tambahkan pekerjaan anggaran',0),(359799,9995,'nl','Projectbudget toevoegen',0),(359800,9995,'fi','Projektibudjetin lisÃ¤Ã¤',0),(359801,9995,'no','Prosjektbudsjett legge',0),(359802,9995,'da','Sagsbudget tilfÃ¸je',0),(359803,9995,'ko','ì¼ìžë¦¬ ì˜ˆì‚° ì¶”ê°€',0),(359804,9995,'he','×œ×”×•×¡×™×£ ×ª×§×¦×™×‘ ×”×¢×‘×•×“×”',0),(359805,9995,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Î­ÏÎ³Î¿Ï…',0),(359806,9995,'zh','é¡¹ç›®é¢„ç®—æ·»åŠ \r\n',0),(359807,9995,'sv','Projektbudget lÃ¤gga till',0),(359808,9995,'it','Aggiungi Budget Commessa',0),(359809,9995,'tl','',0),(359810,9995,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3591;&#3634;&#3609;',0),(359811,9995,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¬à¤œà¤Ÿ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(359812,9995,'ms','Tambah kerja bajet',0),(359813,9995,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(359814,9995,'fr','Budget projet ajouter',0),(359815,9995,'jp','ã‚¸ãƒ§ãƒ–ã®äºˆç®—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(359816,9995,'pt','Adicionar o orÃ§amento do trabalho',0),(359817,9995,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(359818,9995,'es','Agregar Presupuesto de Trabajo',0),(359819,9995,'de','Projektbudget hinzufÃ¼gen',0),(359820,9995,'en','Job Budget Add',0),(359821,9996,'is','',0),(359822,9996,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(359823,9996,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(359824,9996,'tr','Proje bÃ¼tÃ§esi baÅŸarÄ±yla eklendi',0),(359825,9996,'pl','BudÅ¼et zlecenia, dodano pomyÅ›lnie',0),(359826,9996,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(359827,9996,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(359828,9996,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ð¿Ð¾ÑÐ»Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(359829,9996,'vi','Ä‘Ã£ thÃªm ngÃ¢n sÃ¡ch cÃ´ng viá»‡c thÃ nh cÃ´ng',0),(359830,9996,'af','Werkstuk Begroting Suksesvol Geskep',0),(359831,9996,'ro','Buget lucrare adÄƒugat cu succes',0),(359832,9996,'et','Projekti eelarve lisatud',0),(359833,9996,'si','PredraÄun projekta, uspeÅ¡no dodani',0),(359834,9996,'ba','Pekerjaan anggaran ditambahkan berhasil',0),(359835,9996,'nl','Projectbudget toegevoegd',0),(359836,9996,'fi','Projektibudjetin lisÃ¤Ã¤minen onnistui',0),(359837,9996,'no','Prosjektbudsjett lagt',0),(359838,9996,'da','Sagsbudget tilfÃ¸jet',0),(359839,9996,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ìž‘ì—… ì˜ˆì‚°',0),(359840,9996,'he','×”×¢×‘×•×“×” ×ª×§×¦×™×‘ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(359841,9996,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Î­ÏÎ³Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(359842,9996,'zh','é¡¹ç›®é¢„ç®—æ·»åŠ æˆåŠŸ\r\n',0),(359843,9996,'sv','Projektbudget lagts',0),(359844,9996,'it','Budget Commessa aggiunto con successo',0),(359845,9996,'tl','',0),(359846,9996,'th','&#3648;&#3614;&#3636;&#3656;&#3617;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3591;&#3634;&#3609;&#3626;&#3635;&#3648;&#3619;&#3655;&#3592;',0),(359847,9996,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¬à¤œà¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(359848,9996,'ms','Bajet kerja yang berjaya menambah',0),(359849,9996,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© ÙˆØ¸ÙŠÙØ© Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(359850,9996,'fr','Budget projet ajoutÃ© avec succÃ¨s',0),(359851,9996,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸã‚¸ãƒ§ãƒ–äºˆç®—',0),(359852,9996,'pt','OrÃ§amento de trabalho adicionado com sucesso',0),(359853,9996,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(359854,9996,'es','Presupuesto de Trabajo Agregado Exitosamente',0),(359855,9996,'de','Projektbudget erfolgreich hinzugefÃ¼gt',0),(359856,9996,'en','Job Budget Added Successfully',0),(359857,9997,'is','',0),(359858,9997,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´ØºÙ„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(359859,9997,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´ØºÙ„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(359860,9997,'tr','Proje bÃ¼tÃ§esi, zaten bu iÅŸ iÃ§in var',0),(359861,9997,'pl','BudÅ¼et zlecenia juÅ¼ istnieje dla tej pracy',0),(359862,9997,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(359863,9997,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹ Ø§Ø³ Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù„Ø¦Û’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(359864,9997,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ð¿Ð¾ÑÐ»Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾',0),(359865,9997,'vi','ngÃ¢n sÃ¡ch cÃ´ng viá»‡c Ä‘Ã£ cÃ³ cho cÃ´ng viá»‡c nÃ y',0),(359866,9997,'af','Werkstuk Begroting Bestaan Alreeds Vir Hierdie Werkstuk',0),(359867,9997,'ro','Buget lucrare existÄƒ deja pentru acest Job',0),(359868,9997,'et','Projekti eelarve on juba olemas seda tÃ¶Ã¶d',0),(359869,9997,'si','PredraÄun projekta Å¾e obstaja za ta posel',0),(359870,9997,'ba','Anggaran pekerjaan sudah ada untuk pekerjaan ini',0),(359871,9997,'nl','Projectbudget bestaat al voor deze Job',0),(359872,9997,'fi','TÃ¤mÃ¤ tyÃ¶ on jo olemassa projektibudjetti',0),(359873,9997,'no','Prosjektbudsjett finnes allerede For denne jobben',0),(359874,9997,'da','Sagsbudget findes allerede For dette Job',0),(359875,9997,'ko','ì´ ìž‘ì—…ì— ëŒ€ í•œ ìž‘ì—… ì˜ˆì‚° ì´ë¯¸',0),(359876,9997,'he','×ª×§×¦×™×‘ ×”×¢×‘×•×“×” ×›×‘×¨ ×§×™×™× ×‘×©×‘×™×œ ×”×¢×‘×•×“×” ×”×–×•',0),(359877,9997,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Î­ÏÎ³Î¿Ï… Ï€Î¿Ï… Î®Î´Î· Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(359878,9997,'zh','é¡¹ç›®é¢„ç®—å·²ç»å­˜åœ¨äºŽè¿™ä»½å·¥ä½œä¸­\r\n',0),(359879,9997,'sv','Projektbudget finns redan fÃ¶r det hÃ¤r jobbet',0),(359880,9997,'it','Bilancio di lavoro esiste giÃ  per questo lavoro',0),(359881,9997,'tl','',0),(359882,9997,'th','&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3591;&#3634;&#3609;&#3617;&#3637;&#3629;&#3618;&#3641;&#3656;&#3649;&#3621;&#3657;&#3623;&#3626;&#3635;&#3627;&#3619;&#3633;&#3610;&#3591;&#3634;&#3609;&#3609;&#3637;&#3657;',0),(359883,9997,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¬à¤œà¤Ÿ à¤‡à¤¸ à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(359884,9997,'ms','Bajet kerja sudah wujud untuk kerja ini',0),(359885,9997,'ar','Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù…Ù‡Ù…Ø© Ø¨Ø§Ù„ÙØ¹Ù„ Ù„Ù‡Ø°Ù‡ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(359886,9997,'fr','Budget projet existe dÃ©jÃ  pour ce travail',0),(359887,9997,'jp','ã“ã®ã‚¸ãƒ§ãƒ–ã¯æ—¢ã«ã‚¸ãƒ§ãƒ–äºˆç®—',0),(359888,9997,'pt','OrÃ§amento de trabalho jÃ¡ existe para este trabalho',0),(359889,9997,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(359890,9997,'es','Presupuesto de Trabajo Ya Existe para este Trabajo',0),(359891,9997,'de','Projektbudget fÃ¼r diesen Job ist bereits vorhanden.',0),(359892,9997,'en','Job Budget Already Exists For This Job',0),(359893,9998,'is','',0),(359894,9998,'dr','Ù‡ÙŠÚ† Ø´ØºÙ„ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(359895,9998,'pr','Ù‡ÙŠÚ† Ø´ØºÙ„ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(359896,9998,'tr','SeÃ§ili iÅŸ yok',0),(359897,9998,'pl','Nie ma pracy wybranych',0),(359898,9998,'bg','ÐÑÐ¼Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(359899,9998,'ur','Ú©Ø³ÛŒ Ú©ÛŒ Ù†ÙˆÚ©Ø±ÛŒ Ù†ÛÛŒÚº Ù…Ù†ØªØ®Ø¨',0),(359900,9998,'sr','Ð‘ÐµÐ· Ð¿Ð¾ÑÐ»Ð° Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½',0),(359901,9998,'vi','khÃ´ng cÃ³ viá»‡c Ä‘Æ°á»£c chá»n',0),(359902,9998,'af','Geen werk gekies',0),(359903,9998,'ro','Nici un Job selectate',0),(359904,9998,'et','Valitud tÃ¶Ã¶',0),(359905,9998,'si','Brez zaposlitve, izbrana',0),(359906,9998,'ba','Tidak ada pekerjaan yang dipilih',0),(359907,9998,'nl','Geen taak geselecteerd',0),(359908,9998,'fi','Ei valittu tyÃ¶',0),(359909,9998,'no','Ingen jobb valgt',0),(359910,9998,'da','Ingen Job valgt',0),(359911,9998,'ko','ì§ì—… ì„ íƒ',0),(359912,9998,'he','×œ× × ×‘×—×¨×” ×¢×‘×•×“×”',0),(359913,9998,'el','Î”ÎµÎ½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Ï„Î¹ÎºÎ¬',0),(359914,9998,'zh','æ²¡æœ‰å·²é€‰çš„èŒä¸š\r\n',0),(359915,9998,'sv','Inget jobb som valts',0),(359916,9998,'it','Nessun lavoro selezionato.',0),(359917,9998,'tl','',0),(359918,9998,'th','&#3652;&#3617;&#3656;&#3617;&#3637;&#3591;&#3634;&#3609;&#3607;&#3637;&#3656;&#3648;&#3621;&#3639;&#3629;&#3585;',0),(359919,9998,'hi','à¤•à¥‹à¤ˆ à¤¨à¥Œà¤•à¤°à¥€ à¤•à¤¾ à¤šà¤¯à¤¨',0),(359920,9998,'ms','Tiada kerja yang dipilih',0),(359921,9998,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ù‡Ù…Ø© Ù…Ø­Ø¯Ø¯Ø©',0),(359922,9998,'fr','Aucun travail sÃ©lectionnÃ©',0),(359923,9998,'jp','é¸æŠžã—ãŸã‚¸ãƒ§ãƒ–ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(359924,9998,'pt','Nenhum trabalho selecionado',0),(359925,9998,'ru','ÐÐµ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(359926,9998,'es','NingÃºn Trabajo Seleccionado',0),(359927,9998,'de','Kein Job ausgewÃ¤hlt',0),(359928,9998,'en','No Job Selected',0),(359929,9999,'is','',0),(359930,9999,'dr','ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ø¯Ø§Ø±Ø¯ ',0),(359931,9999,'pr','ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ø¯Ø§Ø±Ø¯ ',0),(359932,9999,'tr','GÃ¶zden geÃ§irme vardÄ±r',0),(359933,9999,'pl','Ma zmiany',0),(359934,9999,'bg','Ð˜Ð¼Ð° Ñ€ÐµÐ´Ð°ÐºÑ†Ð¸Ñ',0),(359935,9999,'ur','Ù†Ø¸Ø± Ø«Ø§Ù†ÛŒ Ú©ÛŒ ÛÛ’',0),(359936,9999,'sr','ÐˆÐµ Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ð°',0),(359937,9999,'vi','Ä‘ang duyá»‡t láº¡i',0),(359938,9999,'af','Hersiening het',0),(359939,9999,'ro','A revizuire',0),(359940,9999,'et','On lÃ¤bivaatamine',0),(359941,9999,'si','Je revizija',0),(359942,9999,'ba','Memiliki revisi',0),(359943,9999,'nl','Herziening heeft',0),(359944,9999,'fi','On tarkistus',0),(359945,9999,'no','Har revisjon',0),(359946,9999,'da','Har revisionen',0),(359947,9999,'ko','ìˆ˜ì •ì„ í–ˆìŠµë‹ˆë‹¤.',0),(359948,9999,'he','×™×© ×ž×”×“×•×¨×”',0),(359949,9999,'el','ÎˆÏ‡ÎµÎ¹ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(359950,9999,'zh','å·²ä¿®è®¢\r\n',0),(359951,9999,'sv','Har Ã¶versyn',0),(359952,9999,'it','Ha la revisione',0),(359953,9999,'tl','',0),(359954,9999,'th','&#3617;&#3637;&#3585;&#3634;&#3619;&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3651;&#3627;&#3617;&#3656;',0),(359955,9999,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤¹à¥ˆ',0),(359956,9999,'ms','Mempunyai semakan',0),(359957,9999,'ar','ÙˆÙ‚Ø¯ Ù…Ø±Ø§Ø¬Ø¹Ø©',0),(359958,9999,'fr','A rÃ©vision',0),(359959,9999,'jp','ãƒªãƒ“ã‚¸ãƒ§ãƒ³ã‚’ãŒ',0),(359960,9999,'pt','Tem revisÃ£o',0),(359961,9999,'ru','Ð˜Ð¼ÐµÐµÑ‚ Ñ€ÐµÐ´Ð°ÐºÑ†Ð¸Ñ',0),(359962,9999,'es','Tiene RevisiÃ³n',0),(359963,9999,'de','Hat Revision',0),(359964,9999,'en','Has Revision',0),(359965,10000,'is','',0),(359966,10000,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(359967,10000,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(359968,10000,'tr','Ä°ÅŸ bÃ¼tÃ§e gÃ¼ncelleme',0),(359969,10000,'pl','Zadanie aktualizacji budÅ¼etu',0),(359970,10000,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(359971,10000,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹ Ø§Ù¾ ÚˆÛŒÙ¹',0),(359972,10000,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð±ÑƒÑŸÐµÑ‚Ð° Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(359973,10000,'vi','cáº­p nháº­t ngÃ¢n sÃ¡ch cÃ´ng viá»‡c',0),(359974,10000,'af','Projek Begroting Opdateer',0),(359975,10000,'ro','Actualizare de buget Job',0),(359976,10000,'et','Projekti eelarve Update',0),(359977,10000,'si','Posodobitev delovnih proraÄuna',0),(359978,10000,'ba','Pekerjaan anggaran Update',0),(359979,10000,'nl','Baan begroting Update',0),(359980,10000,'fi','TyÃ¶ budjettipÃ¤ivitys',0),(359981,10000,'no','Budsjettoppdatering',0),(359982,10000,'da','Job Budget opdatering',0),(359983,10000,'ko','ì¼ìžë¦¬ ì˜ˆì‚° ì—…ë°ì´íŠ¸',0),(359984,10000,'he','×¢×“×›×•×Ÿ ×ª×§×¦×™×‘ ×”×¢×‘×•×“×”',0),(359985,10000,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(359986,10000,'zh','é¡¹ç›®é¢„ç®—æ›´æ–°\r\n',0),(359987,10000,'sv','Jobb Budget uppdatering',0),(359988,10000,'it','Lavoro preventivo aggiornamento',0),(359989,10000,'tl','',0),(359990,10000,'th','&#3611;&#3619;&#3633;&#3610;&#3611;&#3619;&#3640;&#3591;&#3591;&#3610;&#3611;&#3619;&#3632;&#3617;&#3634;&#3603;&#3591;&#3634;&#3609;',0),(359991,10000,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¬à¤œà¤Ÿ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(359992,10000,'ms','Kerja bajet Kemaskini',0),(359993,10000,'ar','ØªØ­Ø¯ÙŠØ« ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(359994,10000,'fr','Mise Ã  jour budgÃ©taire du travail',0),(359995,10000,'jp','ã‚¸ãƒ§ãƒ–ã®äºˆç®—ã®æ›´æ–°',0),(359996,10000,'pt','AtualizaÃ§Ã£o de orÃ§amento do trabalho',0),(359997,10000,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(359998,10000,'es','ActualizaciÃ³n de Presupuesto de Trabajo ',0),(359999,10000,'de','Budget-Aktualisierung',0),(360000,10000,'en','Job Budget Update',0),(360001,10001,'is','',0),(360002,10001,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ø¯ÙŠØ¯',0),(360003,10001,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ø¯ÙŠØ¯',0),(360004,10001,'tr','Yeni tutar',0),(360005,10001,'pl','Nowa kwota',0),(360006,10001,'bg','ÐÐ¾Ð²Ð° ÑÑƒÐ¼Ð°',0),(360007,10001,'ur','Ù†Ø¦ÛŒ Ø±Ù‚Ù…',0),(360008,10001,'sr','ÐÐ¾Ð²Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(360009,10001,'vi','Sá»‘ lÆ°á»£ng má»›i',0),(360010,10001,'af','Nuwe Bedrag',0),(360011,10001,'ro','Noua valoare',0),(360012,10001,'et','Uus kogus',0),(360013,10001,'si','Nov znesek',0),(360014,10001,'ba','Jumlah baru',0),(360015,10001,'nl','Nieuwe bedrag',0),(360016,10001,'fi','Uusi mÃ¤Ã¤rÃ¤',0),(360017,10001,'no','Nytt belÃ¸p',0),(360018,10001,'da','Nyt belÃ¸b',0),(360019,10001,'ko','ìƒˆë¡œìš´ ê¸ˆì•¡',0),(360020,10001,'he','×”×›×ž×•×ª ×”×—×“×©×”',0),(360021,10001,'el','ÎÎ­Î¿ Ï€Î¿ÏƒÏŒ',0),(360022,10001,'zh','æ–°çš„é‡‘é¢\r\n',0),(360023,10001,'sv','Nya belopp',0),(360024,10001,'it','Nuovo importo',0),(360025,10001,'tl','',0),(360026,10001,'th','&#3592;&#3635;&#3609;&#3623;&#3609;&#3651;&#3627;&#3617;&#3656;',0),(360027,10001,'hi','à¤¨à¤ˆ à¤°à¤¾à¤¶à¤¿',0),(360028,10001,'ms','Jumlah yang baru',0),(360029,10001,'ar','ÙƒÙ…ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(360030,10001,'fr','Nouveau montant',0),(360031,10001,'jp','æ–°ã—ã„é‡‘é¡',0),(360032,10001,'pt','Nova quantidade',0),(360033,10001,'ru','ÐÐ¾Ð²Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(360034,10001,'es','Nuevo Monto',0),(360035,10001,'de','Neue Betrag',0),(360036,10001,'en','New Amount',0),(360037,10002,'is','',0),(360038,10002,'dr','Ø§Ù†ØªØ¸Ø§Ø± Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ ',0),(360039,10002,'pr','Ø§Ù†ØªØ¸Ø§Ø± Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ ',0),(360040,10002,'tr','Onay bekleyen',0),(360041,10002,'pl','OczekujÄ…ce na zatwierdzenie',0),(360042,10002,'bg','Ð˜Ð·Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(360043,10002,'ur','Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ø±',0),(360044,10002,'sr','Ð§ÐµÐºÐ°ÑšÐµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐ°',0),(360045,10002,'vi','Äá»£i phÃª duyá»‡t',0),(360046,10002,'af','Afwagtend op Goedkeuring',0),(360047,10002,'ro','AÅŸteptare pentru aprobarea',0),(360048,10002,'et','Ootab aksepteerimist',0),(360049,10002,'si','ÄŒakanje na odobritev',0),(360050,10002,'ba','Menunggu persetujuan',0),(360051,10002,'nl','Wachten op goedkeuring',0),(360052,10002,'fi','Odottaa hyvÃ¤ksyntÃ¤Ã¤',0),(360053,10002,'no','Venter pÃ¥ godkjenning',0),(360054,10002,'da','Venter pÃ¥ godkendelse',0),(360055,10002,'ko','ìŠ¹ì¸ ëŒ€ê¸°',0),(360056,10002,'he','×ž×—×›×” ×œ××™×©×•×¨',0),(360057,10002,'el','Î•Î½ Î±Î½Î±Î¼Î¿Î½Î® Ï„Î·Ï‚ Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚',0),(360058,10002,'zh','ç­‰å¾…æ‰¹å‡†\r\n',0),(360059,10002,'sv','VÃ¤ntar pÃ¥ godkÃ¤nnande',0),(360060,10002,'it','In attesa di approvazione',0),(360061,10002,'tl','',0),(360062,10002,'th','&#3585;&#3635;&#3621;&#3633;&#3591;&#3619;&#3629;&#3588;&#3635;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;',0),(360063,10002,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤‚à¤¤à¤œà¤¾à¤° à¤•à¤°',0),(360064,10002,'ms','Menunggu kelulusan',0),(360065,10002,'ar','ÙÙŠ Ø§Ù†ØªØ¸Ø§Ø± Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø©',0),(360066,10002,'fr','En attente d\'approbation',0),(360067,10002,'jp','æ‰¿èªã‚’å¾…ã£ã¦ã„ã¾ã™ã€‚',0),(360068,10002,'pt','Ã€ espera de aprovaÃ§Ã£o',0),(360069,10002,'ru','ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ',0),(360070,10002,'es','Esperando AprobaciÃ³n',0),(360071,10002,'de','Warten auf Genehmigung',0),(360072,10002,'en','Waiting for Approval',0),(360073,10003,'is','',0),(360074,10003,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª  ØªØµÙˆÙŠØ¨ Ø´Ø¯Ù‡ Ø§Ø±Ø³Ø§Ù„  Ø´Ø¯',0),(360075,10003,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª  ØªØµÙˆÙŠØ¨ Ø´Ø¯Ù‡ Ø§Ø±Ø³Ø§Ù„  Ø´Ø¯',0),(360076,10003,'tr','Onay isteÄŸi',0),(360077,10003,'pl','WysÅ‚anych Å¼Ä…daÅ„ zatwierdzenia',0),(360078,10003,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(360079,10003,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(360080,10003,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(360081,10003,'vi','YÃªu cáº§u phÃª duyá»‡t Ä‘Æ°á»£c gá»­i',0),(360082,10003,'af','Goedgekeerde Versoek is Aangestuur',0),(360083,10003,'ro','Cerere de aprobare a trimis',0),(360084,10003,'et','Kinnituse taotlus saata',0),(360085,10003,'si','Poslana proÅ¡nja za odobritev',0),(360086,10003,'ba','Permintaan persetujuan yang dikirim',0),(360087,10003,'nl','Aanvraag tot goedkeuring verzonden',0),(360088,10003,'fi','LÃ¤hetetÃ¤Ã¤n hyvÃ¤ksymispyyntÃ¶',0),(360089,10003,'no','GodkjenningsforespÃ¸rsel sendt',0),(360090,10003,'da','Godkendelsesanmodningen sendt',0),(360091,10003,'ko','ìŠ¹ì¸ ìš”ì²­ ì „ì†¡',0),(360092,10003,'he','×‘×§×©×” ×œ××™×©×•×¨ ×©×œ×—',0),(360093,10003,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚ Ï€Î¿Ï… Î­ÏƒÏ„ÎµÎ¹Î»Îµ',0),(360094,10003,'zh','æ‰¹å‡†è¯·æ±‚å·²å‘é€\r\n',0),(360095,10003,'sv','BegÃ¤ran om godkÃ¤nnande skickas',0),(360096,10003,'it','Approvazione richiesta inviata',0),(360097,10003,'tl','',0),(360098,10003,'th','&#3626;&#3656;&#3591;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3585;&#3634;&#3619;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;',0),(360099,10003,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤­à¥‡à¤œà¤¾',0),(360100,10003,'ms','Permintaan kelulusan yang dihantar',0),(360101,10003,'ar','Ø·Ù„Ø¨ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø¥Ø±Ø³Ø§Ù„',0),(360102,10003,'fr','Demande d\'approbation envoyÃ©',0),(360103,10003,'jp','æ‰¿èªä¾é ¼ã®é€ä¿¡',0),(360104,10003,'pt','SolicitaÃ§Ã£o de aprovaÃ§Ã£o enviada',0),(360105,10003,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°, Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ð¾Ð³Ð¾',0),(360106,10003,'es','Solicitud de AprobaciÃ³n se MandÃ³',0),(360107,10003,'de','Genehmigung-Anfrage gesendet',0),(360108,10003,'en','Approval Request Sent',0),(360109,10004,'is','',0),(360110,10004,'dr',' ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(360111,10004,'pr',' ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(360112,10004,'tr','TarafÄ±ndan onaylanmÄ±ÅŸ',0),(360113,10004,'pl','Zatwierdzone przez',0),(360114,10004,'bg','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½ Ð¾Ñ‚',0),(360115,10004,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(360116,10004,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¾ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(360117,10004,'vi','PhÃª duyá»‡t bá»Ÿi',0),(360118,10004,'af','Goedgekeur Deur',0),(360119,10004,'ro','Aprobat de',0),(360120,10004,'et','Poolt heaks kiidetud',0),(360121,10004,'si','Odobril',0),(360122,10004,'ba','Disetujui oleh',0),(360123,10004,'nl','Goedgekeurd door',0),(360124,10004,'fi','HyvÃ¤ksymÃ¤n',0),(360125,10004,'no','Godkjent av',0),(360126,10004,'da','Godkendt af',0),(360127,10004,'ko','ì˜í•´ ìŠ¹ì¸',0),(360128,10004,'he','×©××•×©×¨×• ×¢×œ-×™×“×™',0),(360129,10004,'el','Î•Î³ÎºÏÎ¹Î¸ÎµÎ¯ Î±Ï€ÏŒ',0),(360130,10004,'zh','æ‰¹å‡†\r\n',0),(360131,10004,'sv','GodkÃ¤nts av',0),(360132,10004,'it','Approvato dal',0),(360133,10004,'tl','',0),(360134,10004,'th','&#3629;&#3609;&#3640;&#3597;&#3634;&#3605;&#3650;&#3604;&#3618;',0),(360135,10004,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤',0),(360136,10004,'ms','Diluluskan oleh',0),(360137,10004,'ar','ÙˆØ§ÙÙ‚ Ø¹Ù„ÙŠÙ‡Ø§',0),(360138,10004,'fr','ApprouvÃ© par',0),(360139,10004,'jp','ã«ã‚ˆã£ã¦æ‰¿èªã•ã‚Œã¾ã—ãŸã€‚',0),(360140,10004,'pt','Aprovado pela',0),(360141,10004,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð°',0),(360142,10004,'es','Aprobado Por',0),(360143,10004,'de','Gebilligten',0),(360144,10004,'en','Approved By',0),(360145,10005,'is','',0),(360146,10005,'dr','ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø¯Ø±',0),(360147,10005,'pr','ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø¯Ø±',0),(360148,10005,'tr','Ãœzerinde onaylÄ±',0),(360149,10005,'pl','Zatwierdzone na',0),(360150,10005,'bg','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½ Ð½Ð°',0),(360151,10005,'ur','Ù¾Ø± Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(360152,10005,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð°Ð²Ð° Ð½Ð°',0),(360153,10005,'vi','Cháº¥p thuáº­n ngÃ y',0),(360154,10005,'af','Goedgekeur Op',0),(360155,10005,'ro','Aprobat',0),(360156,10005,'et','Selle heaks',0),(360157,10005,'si','Odobrena na',0),(360158,10005,'ba','Disetujui pada',0),(360159,10005,'nl','Goedgekeurd op',0),(360160,10005,'fi','HyvÃ¤ksyi',0),(360161,10005,'no','Godkjent pÃ¥',0),(360162,10005,'da','Godkendt pÃ¥',0),(360163,10005,'ko','ì— ìŠ¹ì¸',0),(360164,10005,'he','××•×©×¨×” ×‘',0),(360165,10005,'el','Î•Î³ÎºÏÎ¯Î¸Î·ÎºÎµ ÏƒÏ„Î¹Ï‚',0),(360166,10005,'zh','æ‰¹å‡†\r\n',0),(360167,10005,'sv','GodkÃ¤nd pÃ¥',0),(360168,10005,'it','Approvato il',0),(360169,10005,'tl','',0),(360170,10005,'th','&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636; &#3603;',0),(360171,10005,'hi','à¤ªà¤° à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥‡ à¤¦à¥€',0),(360172,10005,'ms','Diluluskan pada',0),(360173,10005,'ar','ÙˆØ§ÙÙ‚ Ø¹Ù„Ù‰',0),(360174,10005,'fr','ApprouvÃ© le',0),(360175,10005,'jp','ã‚’æ‰¿èª',0),(360176,10005,'pt','Aprovado em',0),(360177,10005,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½ Ð½Ð°',0),(360178,10005,'es','Aprobado En',0),(360179,10005,'de','Am',0),(360180,10005,'en','Approved On',0),(360181,10006,'is','',0),(360182,10006,'dr','ØªØºÙŠÙŠØ± Ø¬ÙˆØ§Ø¨ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(360183,10006,'pr','ØªØºÙŠÙŠØ± Ø¬ÙˆØ§Ø¨ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(360184,10006,'tr','DeÄŸiÅŸiklik isteÄŸi yanÄ±tÄ± gÃ¶nderdi',0),(360185,10006,'pl','WysÅ‚anych odpowiedzi na Å¼Ä…dania zmiany',0),(360186,10006,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð¸ÑÐºÐ°Ð½Ðµ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°',0),(360187,10006,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø§ Ø¬ÙˆØ§Ø¨ Ø¨Ú¾ÛŒØ¬Ø§',0),(360188,10006,'sr','ÐžÐ´Ð³Ð¾Ð²Ð¾Ñ€ Ð½Ð° Ð·Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñƒ Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(360189,10006,'vi','Thay Ä‘á»•i Ä‘Ã¡p á»©ng yÃªu cáº§u gá»­i',0),(360190,10006,'af','Verandering versoek reaksie gestuur',0),(360191,10006,'ro','Schimbare cerere rÄƒspuns trimis',0),(360192,10006,'et','Muudatuse taotluse vastus saadetud',0),(360193,10006,'si','Sprememba zahteva odgovor poslan',0),(360194,10006,'ba','Perubahan permintaan respon dikirim',0),(360195,10006,'nl','Verandering verzoek verzonden antwoorden',0),(360196,10006,'fi','Muutoksen pyyntÃ¶ vastaus lÃ¤hetetÃ¤Ã¤n',0),(360197,10006,'no','Endre forespÃ¸rsel svar sendt',0),(360198,10006,'da','Skift anmodning svar sendt',0),(360199,10006,'ko','ë³€ê²½ ìš”ì²­ ì‘ë‹µ ì „ì†¡',0),(360200,10006,'he','×‘×§×©×” ×©×™× ×•×™ ×ª×’×•×‘×” ×©×œ×—',0),(360201,10006,'el','Î‘Î»Î»Î±Î³Î® Î±Î¯Ï„Î·Î¼Î± Î±Ï€Î¬Î½Ï„Î·ÏƒÎ· Î­ÏƒÏ„ÎµÎ¹Î»Îµ',0),(360202,10006,'zh','å˜æ›´è¯·æ±‚å“åº”å‘é€\r\n',0),(360203,10006,'sv','Ã„ndra begÃ¤ran skickade svar',0),(360204,10006,'it','Modifica richiesta risposta inviata',0),(360205,10006,'tl','',0),(360206,10006,'th','&#3626;&#3656;&#3591;&#3585;&#3634;&#3619;&#3605;&#3629;&#3610;&#3619;&#3633;&#3610;&#3588;&#3635;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;',0),(360207,10006,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¥à¤°à¤¤à¤¿à¤¸à¤¾à¤¦ à¤­à¥‡à¤œà¤¾',0),(360208,10006,'ms','Tindak-balas permintaan perubahan yang dihantar',0),(360209,10006,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ø³ØªØ¬Ø§Ø¨Ø© Ù„Ø·Ù„Ø¨ Ø§Ù„ØªØºÙŠÙŠØ±',0),(360210,10006,'fr','Changement demande rÃ©ponse envoyÃ©e',0),(360211,10006,'jp','å¤‰æ›´è¦æ±‚ã®å¿œç­”ãŒé€ä¿¡ã•ã‚Œã¾ã™ã€‚',0),(360212,10006,'pt','Resposta de solicitaÃ§Ã£o de mudanÃ§a enviada',0),(360213,10006,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð¾Ñ‚Ð²ÐµÑ‚ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½',0),(360214,10006,'es','Respuesta de Solicitud de Cambio se MandÃ³',0),(360215,10006,'de','Change-Anforderung-Antwort gesendet',0),(360216,10006,'en','Change Request Response Sent',0),(360217,10007,'is','',0),(360218,10007,'dr','ØªØºÙŠÙŠØ± Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ ',0),(360219,10007,'pr','ØªØºÙŠÙŠØ± Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ ',0),(360220,10007,'tr','DeÄŸiÅŸiklik isteÄŸi gÃ¶nderdi',0),(360221,10007,'pl','WysÅ‚anych Å¼Ä…daÅ„ zmiany',0),(360222,10007,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ°Ñ‚Ð°, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð°',0),(360223,10007,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(360224,10007,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñƒ Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(360225,10007,'vi','Thay Ä‘á»•i yÃªu cáº§u Ä‘Æ°á»£c gá»­i',0),(360226,10007,'af','Verander versoek gestuur',0),(360227,10007,'ro','Cerere de schimbare a trimis',0),(360228,10007,'et','Muutmise taotlus saata',0),(360229,10007,'si','Spremeniti zahtevek poslan',0),(360230,10007,'ba','Permintaan perubahan yang dikirim',0),(360231,10007,'nl','Change-verzoek verzonden',0),(360232,10007,'fi','MuutospyyntÃ¶ lÃ¤hetetÃ¤Ã¤n',0),(360233,10007,'no','Endre forespÃ¸rsel sendt',0),(360234,10007,'da','Ã†ndre anmodning, der sendes',0),(360235,10007,'ko','ë³€ê²½ ìš”ì²­ ì „ì†¡',0),(360236,10007,'he','×‘×§×©×ª ×©×™× ×•×™ ×©×œ×—',0),(360237,10007,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î±Î»Î»Î±Î³Î®Ï‚ Ï€Î¿Ï… Î­ÏƒÏ„ÎµÎ¹Î»Îµ',0),(360238,10007,'zh','å˜æ›´è¯·æ±‚å·²å‘é€\r\n',0),(360239,10007,'sv','Ã„ndringsbegÃ¤ran skickas',0),(360240,10007,'it','Richiesta di modifica inviata',0),(360241,10007,'tl','',0),(360242,10007,'th','&#3626;&#3656;&#3591;&#3588;&#3635;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;',0),(360243,10007,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤­à¥‡à¤œà¤¾',0),(360244,10007,'ms','Perubahan permintaan dihantar',0),(360245,10007,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø·Ù„Ø¨ ØªØºÙŠÙŠØ±',0),(360246,10007,'fr','Demande de modification envoyÃ©e',0),(360247,10007,'jp','å¤‰æ›´è¦æ±‚ã®é€ä¿¡',0),(360248,10007,'pt','SolicitaÃ§Ã£o de alteraÃ§Ã£o enviada',0),(360249,10007,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(360250,10007,'es','Solicitud de Cambio se MandÃ³',0),(360251,10007,'de','Eine Anforderung gesendet',0),(360252,10007,'en','Change Request Sent',0),(360253,10008,'is','',0),(360254,10008,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ',0),(360255,10008,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ',0),(360256,10008,'tr','TarafÄ±ndan engellendi',0),(360257,10008,'pl','Odmowa przez',0),(360258,10008,'bg','ÐžÑ‚ÐºÐ°Ð·Ð°Ð½ Ð¾Ñ‚',0),(360259,10008,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ù†Ú©Ø§Ø± Ú©ÛŒØ§',0),(360260,10008,'sr','ÐžÐ´Ð±Ð¸Ñ˜ÐµÐ½Ð° Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(360261,10008,'vi','Bá»‹ tá»« chá»‘i bá»Ÿi',0),(360262,10008,'af','Verbied Deur',0),(360263,10008,'ro','Refuzat de',0),(360264,10008,'et','Eitavad',0),(360265,10008,'si','Zanikali',0),(360266,10008,'ba','Ditolak oleh',0),(360267,10008,'nl','Geweigerd door',0),(360268,10008,'fi','EvÃ¤tty',0),(360269,10008,'no','Avvist av',0),(360270,10008,'da','NÃ¦gtet af',0),(360271,10008,'ko','ì˜í•´ ê±°ë¶€',0),(360272,10008,'he','× ×“×—×ª×” ×¢×œ ×™×“×™',0),(360273,10008,'el','Î”ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î±Ï€ÏŒ',0),(360274,10008,'zh','å¦è®¤\r\n',0),(360275,10008,'sv','FÃ¶rnekas av',0),(360276,10008,'it','Negato da',0),(360277,10008,'tl','',0),(360278,10008,'th','&#3606;&#3641;&#3585;&#3611;&#3599;&#3636;&#3648;&#3626;&#3608;&#3650;&#3604;&#3618;',0),(360279,10008,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤–à¤‚à¤¡à¤¨ à¤•à¤¿à¤¯à¤¾',0),(360280,10008,'ms','Ditolak oleh',0),(360281,10008,'ar','ÙˆÙ†ÙÙ‰ Ù‚Ø¨Ù„',0),(360282,10008,'fr','RefusÃ© par',0),(360283,10008,'jp','ã«ã‚ˆã£ã¦æ‹’å¦ã•ã‚Œã¾ã—ãŸ',0),(360284,10008,'pt','Negado pelo',0),(360285,10008,'ru','ÐžÑ‚ÐºÐ»Ð¾Ð½ÐµÐ½Ð¾',0),(360286,10008,'es','Negado Por',0),(360287,10008,'de','Von verweigert',0),(360288,10008,'en','Denied By',0),(360289,10009,'is','',0),(360290,10009,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(360291,10009,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(360292,10009,'tr','Ãœzerinde engellendi',0),(360293,10009,'pl','Odmowa na',0),(360294,10009,'bg','ÐžÑ‚ÐºÐ°Ð·Ð°Ð½ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð½Ð°',0),(360295,10009,'ur','Ù¾Ø± Ø§Ù†Ú©Ø§Ø± Ú©ÛŒØ§',0),(360296,10009,'sr','ÐŸÐ¾Ñ€ÐµÐºÐ°Ð¾ Ñ˜Ðµ Ñƒ',0),(360297,10009,'vi','Bá»‹ tá»« chá»‘i trÃªn',0),(360298,10009,'af','Verbied Op',0),(360299,10009,'ro','Interzis pe',0),(360300,10009,'et','Keelatud',0),(360301,10009,'si','Zavrnjen na',0),(360302,10009,'ba','Ditolak pada',0),(360303,10009,'nl','Geweigerd op',0),(360304,10009,'fi','EvÃ¤tÃ¤Ã¤n',0),(360305,10009,'no','Nektet pÃ¥',0),(360306,10009,'da','NÃ¦gtet pÃ¥',0),(360307,10009,'ko','ì— ê±°ë¶€',0),(360308,10009,'he','× ×“×—×ª×”-',0),(360309,10009,'el','Î”Î¹Î­ÏˆÎµÏ…ÏƒÎµ Ï„Î·Î½',0),(360310,10009,'zh','å¦è®¤\r\n',0),(360311,10009,'sv','Nekad pÃ¥',0),(360312,10009,'it','Negato alle',0),(360313,10009,'tl','',0),(360314,10009,'th','&#3606;&#3641;&#3585;&#3611;&#3599;&#3636;&#3648;&#3626;&#3608; &#3603;',0),(360315,10009,'hi','à¤ªà¤° à¤¨à¤¿à¤·à¥‡à¤§',0),(360316,10009,'ms','Dinafikan pada',0),(360317,10009,'ar','ÙˆÙ†ÙÙ‰ ÙÙŠ',0),(360318,10009,'fr','RefusÃ©e sur',0),(360319,10009,'jp','æ‹’å¦ã•ã‚Œã¾ã—ãŸ',0),(360320,10009,'pt','Negada no',0),(360321,10009,'ru','ÐžÑ‚ÐºÐ°Ð·Ð°Ð½Ð¾ Ð²',0),(360322,10009,'es','Negado En',0),(360323,10009,'de','FÃ¼r verweigert',0),(360324,10009,'en','Denied On',0),(360325,10010,'is','',0),(360326,10010,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØ§ÙŠÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(360327,10010,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØ§ÙŠÙŠØ¯ Ø¬Ø¯ÙŠØ¯ ',0),(360328,10010,'tr','Yeni onay isteÄŸi',0),(360329,10010,'pl','Nowe Å¼Ä…danie zatwierdzenia',0),(360330,10010,'bg','ÐÐ¾Ð²Ð¾ Ð¸ÑÐºÐ°Ð½Ðµ Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(360331,10010,'ur','Ù†Ø¦Û’ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(360332,10010,'sr','ÐÐ¾Ð²Ð¸ Ð·Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ',0),(360333,10010,'vi','YÃªu cáº§u phÃª duyá»‡t má»›i',0),(360334,10010,'af','Nuwe Goedkeuringsversoek',0),(360335,10010,'ro','NouÄƒ cerere de aprobare',0),(360336,10010,'et','Uus kinnituse palve',0),(360337,10010,'si','ProÅ¡nja za odobritev',0),(360338,10010,'ba','Permintaan persetujuan baru',0),(360339,10010,'nl','Nieuwe aanvraag tot goedkeuring',0),(360340,10010,'fi','Uusi hyvÃ¤ksymispyyntÃ¶',0),(360341,10010,'no','Ny forespÃ¸rsel om godkjenning',0),(360342,10010,'da','Nye godkendelsesanmodning',0),(360343,10010,'ko','ìƒˆë¡œìš´ ìŠ¹ì¸ ìš”ì²­',0),(360344,10010,'he','×‘×§×©×ª ××™×©×•×¨ ×—×“×©',0),(360345,10010,'el','ÎÎ­Î± Î±Î¯Ï„Î·ÏƒÎ· Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚',0),(360346,10010,'zh','æ–°æ‰¹å‡†è¯·æ±‚\r\n',0),(360347,10010,'sv','Ny begÃ¤ran om godkÃ¤nnande',0),(360348,10010,'it','Nuova richiesta di approvazione',0),(360349,10010,'tl','',0),(360350,10010,'th','&#3619;&#3657;&#3656;&#3629;&#3591;&#3586;&#3629;&#3588;&#3635;&#3629;&#3609;&#3640;&#3617;&#3633;&#3605;&#3636;&#3651;&#3627;&#3617;&#3656;',0),(360351,10010,'hi','à¤¨à¤ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(360352,10010,'ms','Permohonan kelulusan',0),(360353,10010,'ar','Ø·Ù„Ø¨ Ù‚Ø¨ÙˆÙ„ Ø¬Ø¯ÙŠØ¯',0),(360354,10010,'fr','Nouvelle demande d\'approbation',0),(360355,10010,'jp','æ–°ã—ã„æ‰¿èªè¦æ±‚',0),(360356,10010,'pt','Novo pedido de aprovaÃ§Ã£o',0),(360357,10010,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(360358,10010,'es','Nuevo Solicitud de AprobaciÃ³n',0),(360359,10010,'de','Neue Zulassung-Anforderung',0),(360360,10010,'en','New Approval Request',0),(360361,10011,'is','',0),(360362,10011,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØºÙŠÙŠØ± Ø´Ù…Ø§ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(360363,10011,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØºÙŠÙŠØ± Ø´Ù…Ø§ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(360364,10011,'tr','DeÄŸiÅŸiklik isteÄŸi onaylandÄ±',0),(360365,10011,'pl','Å»Ä…danie zmiany zostaÅ‚ zatwierdzony',0),(360366,10011,'bg','Ð—Ð°ÑÐ²ÐºÐ°Ñ‚Ð° Ð²Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½',0),(360367,10011,'ur','Ø¢Ù¾ Ú©ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ù†Ø¸ÙˆØ± Ú©Ø±Ù„ÛŒ Ú¯Ø¦ÛŒÚº',0),(360368,10011,'sr','Ð’Ð°Ñˆ Ð·Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð° Ñ˜Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð°.',0),(360369,10011,'vi','YÃªu cáº§u thay Ä‘á»•i cá»§a báº¡n Ä‘Ã£ Ä‘Æ°á»£c cháº¥p thuáº­n',0),(360370,10011,'af','U Versoek om Veranderinge te Maak is Goedgekeur',0),(360371,10011,'ro','Solicitarea de modificare a fost aprobat',0),(360372,10011,'et','Teie muudatus on kinnitatud',0),(360373,10011,'si','VaÅ¡i zahtevi je bil odobren',0),(360374,10011,'ba','Permintaan perubahan Anda telah disetujui',0),(360375,10011,'nl','Uw veranderingsverzoek is goedgekeurd',0),(360376,10011,'fi','Muuta pyyntÃ¶Ã¤ ole hyvÃ¤ksytty',0),(360377,10011,'no','Endre forespÃ¸rselen er godkjent',0),(360378,10011,'da','Din anmodning om Ã¦ndring er blevet godkendt',0),(360379,10011,'ko','ë³€ê²½ ìš”ì²­ ìŠ¹ì¸',0),(360380,10011,'he','×‘×§×©×ª ×©×™× ×•×™ ×©×œ×š ××•×©×¨×”',0),(360381,10011,'el','Î£Î±Ï‚ Î±Î¯Ï„Î·ÏƒÎ· Î±Î»Î»Î±Î³Î®Ï‚ Î­Ï‡ÎµÎ¹ ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯',0),(360382,10011,'zh','æ‚¨çš„æ›´æ”¹è¯·æ±‚å·²è¢«æ‰¹å‡†\r\n',0),(360383,10011,'sv','Din begÃ¤ran har godkÃ¤nts',0),(360384,10011,'it','Ãˆ stata approvata la richiesta di modifica',0),(360385,10011,'tl','',0),(360386,10011,'th','&#3585;&#3634;&#3619;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3652;&#3604;&#3657;&#3606;&#3641;&#3585;&#3629;&#3',0),(360387,10011,'hi','à¤†à¤ªà¤•à¥‡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(360388,10011,'ms','Permintaan perubahan anda telah diluluskan',0),(360389,10011,'ar','ØªÙ… Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø·Ù„Ø¨ ØªØºÙŠÙŠØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(360390,10011,'fr','Votre demande de modification a Ã©tÃ© approuvÃ©e',0),(360391,10011,'jp','å¤‰æ›´è¦æ±‚ã‚’æ‰¿èªã—ã¾ã—ãŸã€‚',0),(360392,10011,'pt','Seu pedido de mudanÃ§a foi aprovado',0),(360393,10011,'ru','Ð’Ð°Ñˆ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð±Ñ‹Ð» ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½',0),(360394,10011,'es','Su solicitud de Cambio se AprobÃ³',0),(360395,10011,'de','Ihr Wechsel-Antrag wurde genehmigt',0),(360396,10011,'en','Your Change Request Has Been Approved',0),(360397,10012,'is','',0),(360398,10012,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØºÙŠÙŠØ± Ø´Ù…Ø§ Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(360399,10012,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØºÙŠÙŠØ± Ø´Ù…Ø§ Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(360400,10012,'tr','DeÄŸiÅŸiklik isteÄŸi reddedildi',0),(360401,10012,'pl','Å»Ä…danie zmiany odmÃ³wiono',0),(360402,10012,'bg','Ð—Ð°ÑÐ²ÐºÐ°Ñ‚Ð° Ð²Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½',0),(360403,10012,'ur','Ø¢Ù¾ Ú©ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ ØªØ±Ø¯ÛŒØ¯ Ú©ÛŒ Ú¯Ø¦ÛŒ ÛÛ’',0),(360404,10012,'sr','Ð¢Ð²Ð¾Ñ˜ ÐºÑƒÑÑƒÑ€ Ð·Ð°Ñ…Ñ‚ÐµÐ² Ñ˜Ðµ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½.',0),(360405,10012,'vi','YÃªu cáº§u thay Ä‘á»•i cá»§a báº¡n Ä‘Ã£ bá»‹ tá»« chá»‘i',0),(360406,10012,'af','Jou verandering versoek is geweier',0),(360407,10012,'ro','S-a refuzat solicitarea de modificare',0),(360408,10012,'et','Teie muudatus on tagasilÃ¼katud',0),(360409,10012,'si','Sprememba zahteva je bila zavrnjena',0),(360410,10012,'ba','Permintaan perubahan Anda telah ditolak',0),(360411,10012,'nl','Uw veranderingsverzoek is geweigerd',0),(360412,10012,'fi','Muutoksen pyyntÃ¶ on evÃ¤tty',0),(360413,10012,'no','Endre forespÃ¸rselen har blitt avslÃ¥tt',0),(360414,10012,'da','Din anmodning om Ã¦ndring er blevet nÃ¦gtet',0),(360415,10012,'ko','ë³€ê²½ ìš”ì²­ì´ ê±°ë¶€ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(360416,10012,'he','× ×“×—×ª×” ×‘×§×©×ª ×©×™× ×•×™ ×©×œ×š',0),(360417,10012,'el','Î‘ÏÎ½Î®Î¸Î·ÎºÎµ Ï„Î¿ Î±Î¯Ï„Î·Î¼Î¬ ÏƒÎ±Ï‚ Î±Î»Î»Î±Î³Î®',0),(360418,10012,'zh','æ‚¨çš„æ›´æ”¹è¯·æ±‚å·²è¢«æ‹’ç»\r\n',0),(360419,10012,'sv','Din begÃ¤ran har nekats',0),(360420,10012,'it','La richiesta di modifica Ã¨ stato negato',0),(360421,10012,'tl','',0),(360422,10012,'th','&#3585;&#3634;&#3619;&#3619;&#3657;&#3629;&#3591;&#3586;&#3629;&#3585;&#3634;&#3619;&#3648;&#3611;&#3621;&#3637;&#3656;&#3618;&#3609;&#3649;&#3611;&#3621;&#3591;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;&#3606;&#3641;&#3585;&#3611;&#3599;&#3636;&#3648;&#3',0),(360423,10012,'hi','à¤†à¤ªà¤•à¥‡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤…à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(360424,10012,'ms','Permintaan perubahan anda telah dinafikan',0),(360425,10012,'ar','ØªÙ… Ø±ÙØ¶ Ø·Ù„Ø¨ ØªØºÙŠÙŠØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(360426,10012,'fr','Votre demande de modification a Ã©tÃ© refusÃ©',0),(360427,10012,'jp','å¤‰æ›´è¦æ±‚ãŒæ‹’å¦ã•ã‚Œã¾ã—ãŸ',0),(360428,10012,'pt','Foi negado seu pedido de mudanÃ§a',0),(360429,10012,'ru','Ð’Ð°Ñˆ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð±Ñ‹Ð»Ð¾ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð¾',0),(360430,10012,'es','Su solicitud de Cambio se NagÃ³',0),(360431,10012,'de','Ihre Anforderung wurde verweigert',0),(360432,10012,'en','Your Change Request Has Been Denied',0),(360433,10013,'is','',0),(360434,10013,'dr','Ø¢ÙŠØ§ Ø§ÙŠÙ† ÙŠÙƒ Ø´Ø±ÙƒØª Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø² Ø§Ø³Øª ØŸ',0),(360435,10013,'pr','Ø¢ÙŠØ§ Ø§ÙŠÙ† ÙŠÙƒ Ø´Ø±ÙƒØª Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø² Ø§Ø³Øª ØŸ',0),(360436,10013,'tr','Bu bir inÅŸaat firmasÄ± mÄ±',0),(360437,10013,'pl','Jest to firma budowlana',0),(360438,10013,'bg','Ð• ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(360439,10013,'ur','ÛŒÛ Ø§ÛŒÚ© ØªØ¹Ù…ÛŒØ±Ø§ØªÛŒ Ú©Ù…Ù¾Ù†ÛŒ ÛÛ’',0),(360440,10013,'sr','Ð”Ð° Ð»Ð¸ Ñ˜Ðµ Ð¾Ð²Ð¾ Ð³Ñ€Ð°Ñ’ÐµÐ²Ð¸Ð½ÑÐºÐµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(360441,10013,'vi','ÄÃ¢y cÃ³ pháº£i lÃ  má»™t cÃ´ng ty xÃ¢y dá»±ng',0),(360442,10013,'af','Is dit \'n Konstruksie Onderneming',0),(360443,10013,'ro','Aceasta este o companie de constructii',0),(360444,10013,'et','Kas see ehitusfirma',0),(360445,10013,'si','Je to gradbeno podjetje',0),(360446,10013,'ba','Apakah ini sebuah perusahaan konstruksi',0),(360447,10013,'nl','Is dit een bouwbedrijf',0),(360448,10013,'fi','Onko tÃ¤mÃ¤ rakennusalan yritys',0),(360449,10013,'no','Er dette et byggefirma',0),(360450,10013,'da','Er dette et byggefirma',0),(360451,10013,'ko','ì´ ê±´ì„¤ íšŒì‚¬ ì¸ê°€ìš”',0),(360452,10013,'he','? ×”×× ×–×” ×—×‘×¨×ª ×‘× ×™×™×”',0),(360453,10013,'el','Î‘Ï…Ï„ÏŒ ÎµÎ¯Î½Î±Î¹ Î¼Î¹Î± ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î±ÏƒÏ„Î¹ÎºÎ® ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(360454,10013,'zh','è¿™æ˜¯ä¸€é—´å»ºç­‘å…¬å¸\r\n',0),(360455,10013,'sv','Ã„r detta ett byggfÃ¶retag',0),(360456,10013,'it','Questa Ã¨ una societÃ  di costruzioni',0),(360457,10013,'tl','',0),(360458,10013,'th','&#3609;&#3637;&#3657;&#3610;&#3619;&#3636;&#3625;&#3633;&#3607;&#3585;&#3656;&#3629;&#3626;&#3619;&#3657;&#3634;&#3591;&#3627;&#3619;&#3639;&#3629;&#3652;&#3617;&#3656;',0),(360459,10013,'hi','à¤¯à¤¹ à¤à¤• à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¤‚à¤ªà¤¨à¥€ à¤¹à¥ˆ',0),(360460,10013,'ms','Adakah ini sebuah syarikat pembinaan',0),(360461,10013,'ar','Ù‡Ø°Ø§ Ù‡Ùˆ Ø´Ø±ÙƒØ© Ù„Ù„Ø¨Ù†Ø§Ø¡',0),(360462,10013,'fr','C\'est une entreprise de Construction',0),(360463,10013,'jp','ã“ã‚Œã¯ã€å»ºè¨­ä¼šç¤¾ã§ã™ã€‚',0),(360464,10013,'pt','Isto Ã© uma empresa de construÃ§Ã£o',0),(360465,10013,'ru','Ð­Ñ‚Ð¾ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(360466,10013,'es','Â¿Es una Empresa de ConstrucciÃ³n?',0),(360467,10013,'de','Ist das ein Bauunternehmen',0),(360468,10013,'en','Is this a Construction Company',0),(360469,10014,'is','',0),(360470,10014,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  Ù…Ø´ØªØ±ÙŠ Ø´Ù…Ø§',0),(360471,10014,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  Ù…Ø´ØªØ±ÙŠ Ø´Ù…Ø§',0),(360472,10014,'tr','MÃ¼ÅŸterinizin PO',0),(360473,10014,'pl','PO klienta',0),(360474,10014,'bg','ÐÐ° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° PO',0),(360475,10014,'ur','Ø¢Ù¾ Ú©Û’ Ú¯Ø§ÛÚ© Ú©Û’ Ù¾Ùˆ',0),(360476,10014,'sr','Ð’Ð°Ñˆ ÐºÑƒÐ¿Ð°Ñ† ÐŸÐž',0),(360477,10014,'vi','KhÃ¡ch hÃ ng cá»§a báº¡n PO',0),(360478,10014,'af','U Klante/KliÃ«nte AB',0),(360479,10014,'ro','Clientului PO',0),(360480,10014,'et','Sinu kliendi ostutellimus',0),(360481,10014,'si','VaÅ¡e stranke PO',0),(360482,10014,'ba','PO pelanggan Anda',0),(360483,10014,'nl','Uw klant PO',0),(360484,10014,'fi','Asiakkaan PO',0),(360485,10014,'no','Kundens PO',0),(360486,10014,'da','Kundens PO',0),(360487,10014,'ko','ê³ ê°ì˜ í¬',0),(360488,10014,'he','×”×¤×• ×©×œ ×”×œ×§×•×— ×©×œ×š',0),(360489,10014,'el','Î¤Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· ÏƒÎ±Ï‚ PO',0),(360490,10014,'zh','æ‚¨çš„å®¢æˆ·çš„è®¢å•\r\n',0),(360491,10014,'sv','Kundens PO',0),(360492,10014,'it','Ufficio Postale del cliente',0),(360493,10014,'tl','',0),(360494,10014,'th','&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3621;&#3641;&#3585;&#3588;&#3657;&#3634;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(360495,10014,'hi','à¤…à¤ªà¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤ªà¥€à¤“',0),(360496,10014,'ms','PO pelanggan anda',0),(360497,10014,'ar','Øµ. Ø¨. Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(360498,10014,'fr','PO votre client',0),(360499,10014,'jp','ã‚ãªãŸã®é¡§å®¢ã® PO',0),(360500,10014,'pt','PO do seu cliente.',0),(360501,10014,'ru','Ð’Ð°Ñˆ ÐºÐ»Ð¸ÐµÐ½Ñ‚ PO',0),(360502,10014,'es','El OC de su Cliente',0),(360503,10014,'de','Ihr Kunde PO',0),(360504,10014,'en','Your Customer\'s PO',0),(360505,10015,'is','',0),(360506,10015,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø´Ù…Ø§',0),(360507,10015,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø´Ù…Ø§',0),(360508,10015,'tr','Senin PO',0),(360509,10015,'pl','PO',0),(360510,10015,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²',0),(360511,10015,'ur','Ø¢Ù¾ Ú©ÛŒ Ù¾ÙˆØ³Ù¹',0),(360512,10015,'sr','Ð¢Ð²Ð¾Ñ˜ Ð½Ð°Ð´Ð·Ð¾Ñ€Ð½Ð¸Ðº',0),(360513,10015,'vi','PO cá»§a báº¡n',0),(360514,10015,'af','U AB',0),(360515,10015,'ro','Å¢i PO',0),(360516,10015,'et','Sinu ostutellimus',0),(360517,10015,'si','VaÅ¡e PO',0),(360518,10015,'ba','PO Anda',0),(360519,10015,'nl','Uw PO',0),(360520,10015,'fi','Oman PO',0),(360521,10015,'no','Din PO',0),(360522,10015,'da','Din PO',0),(360523,10015,'ko','ë‹¹ì‹ ì˜ í¬',0),(360524,10015,'he','×”×ª×¢×•×“×ª ×–×”×•×ª ×©×œ×š',0),(360525,10015,'el','Î˜Îˆ',0),(360526,10015,'zh','æ‚¨çš„é‡‡è´­è®¢å•\r\n',0),(360527,10015,'sv','Din PO',0),(360528,10015,'it','Proprio Ufficio Postale',0),(360529,10015,'tl','',0),(360530,10015,'th','&#3585;&#3634;&#3619;&#3626;&#3633;&#3656;&#3591;&#3595;&#3639;&#3657;&#3629;&#3586;&#3629;&#3591;&#3588;&#3640;&#3603;',0),(360531,10015,'hi','à¤…à¤ªà¤¨à¥‡ à¤ªà¥‹',0),(360532,10015,'ms','PO anda',0),(360533,10015,'ar','Øµ. Ø¨ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(360534,10015,'fr','Votre bon de commande',0),(360535,10015,'jp','ã‚ãªãŸãƒãƒ¼',0),(360536,10015,'pt','Seu PO',0),(360537,10015,'ru','Ð’Ð°Ñˆ PO',0),(360538,10015,'es','Su OC',0),(360539,10015,'de','Ihr PO',0),(360540,10015,'en','Your PO',0),(360541,10016,'is','',0),(360542,10016,'dr','Ø¯Ø±ØµØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ú¯Ø´ØªÙŠ  Ø¨Ø§Ù„Ø§ØªØ± Ø§Ø² Ù‡Ø²ÙŠÙ†Ù‡',0),(360543,10016,'pr','Ø¯Ø±ØµØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ú¯Ø´ØªÙŠ  Ø¨Ø§Ù„Ø§ØªØ± Ø§Ø² Ù‡Ø²ÙŠÙ†Ù‡',0),(360544,10016,'tr','Chargeback yÃ¼zde Upcharge',0),(360545,10016,'pl','Procent obciÄ…Å¼enia zwrotnego Upcharge',0),(360546,10016,'bg','Ð‘Ð°Ðº Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Upcharge',0),(360547,10016,'ur','Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ø´Ø±Ø­ Ø§Ù¾Ú†Ø§Ø±Ú¯Ø§',0),(360548,10016,'sr','Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð£Ð¿Ñ†Ñ…Ð°Ñ€Ð³Ðµ',0),(360549,10016,'vi','Tá»· lá»‡ pháº§n trÄƒm tiá»n chiáº¿t kháº¥u Upcharge',0),(360550,10016,'af','Chargeback persentasie Upcharge',0),(360551,10016,'ro','Procentul de chargeback Upcharge',0),(360552,10016,'et','SissenÃµudmine protsent Upcharge',0),(360553,10016,'si','Odstotek poraÄuna Upcharge',0),(360554,10016,'ba','Persentase chargeback Upcharge',0),(360555,10016,'nl','Chargeback Percentage Upcharge',0),(360556,10016,'fi','Chargeback osuus Upcharge',0),(360557,10016,'no','TilbakefÃ¸ring prosent Upcharge',0),(360558,10016,'da','TilbagefÃ¸rslen procentdel Upcharge',0),(360559,10016,'ko','í™˜ë¶ˆ ë¹„ìœ¨ Upcharge',0),(360560,10016,'he','××—×•×– ×”×—×™×•×‘ Upcharge',0),(360561,10016,'el','Chargeback Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Upcharge',0),(360562,10016,'zh','é€€æ¬¾ç™¾åˆ†æ¯”æ³¨å†Œè´¹\r\n',0),(360563,10016,'sv','Chargeback andel Upcharge',0),(360564,10016,'it','Percentuale di chargeback Upcharge',0),(360565,10016,'tl','',0),(360566,10016,'th','Upcharge à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(360567,10016,'hi','à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ Upcharge',0),(360568,10016,'ms','Upcharge peratusan caj semula',0),(360569,10016,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø£ÙˆØ¨ØªØ´Ø§Ø±Ø¬ÙŠ',0),(360570,10016,'fr','Pourcentage de Chargeback Upcharge',0),(360571,10016,'jp','ãƒã‚¹ã‚¿ãƒ–ã‚‚ãƒãƒ£ãƒ¼ã‚¸ ãƒãƒƒã‚¯çŽ‡',0),(360572,10016,'pt','Percentagem de chargeback Upcharge',0),(360573,10016,'ru','Ð”Ð¾Ð»Ñ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð° Ð±Ñ€Ñ‘Ð²Ð½Ð°',0),(360574,10016,'es','Porcentaje de Cargos Extras de Reintegro del Cobro',0),(360575,10016,'de','Chargeback Prozentsatz Aufpreis',0),(360576,10016,'en','Chargeback Percentage Upcharge',0),(360577,10017,'is','',0),(360578,10017,'dr','Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯ Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(360579,10017,'pr','Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯ Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(360580,10017,'tr','Chargeback gelir hesabÄ±',0),(360581,10017,'pl','Konto przychodÃ³w Chargeback',0),(360582,10017,'bg','Ð‘Ð°Ðº Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(360583,10017,'ur','Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ø±ÛŒÙˆÛŒÙ†ÛŒÙˆ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(360584,10017,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(360585,10017,'vi','Tiá»n chiáº¿t kháº¥u doanh thu tÃ i khoáº£n',0),(360586,10017,'af','Chargeback inkomste rekening',0),(360587,10017,'ro','Contul de venituri de chargeback',0),(360588,10017,'et','SissenÃµudmine tulukonto',0),(360589,10017,'si','RaÄun poraÄuna prihodkov',0),(360590,10017,'ba','Rekening pendapatan chargeback',0),(360591,10017,'nl','Chargeback inkomstenrekening',0),(360592,10017,'fi','Chargeback tuottotili',0),(360593,10017,'no','TilbakefÃ¸ring inntektskontoen',0),(360594,10017,'da','TilbagefÃ¸rslen omsÃ¦tningskonto',0),(360595,10017,'ko','í™˜ë¶ˆ ìˆ˜ìµ ê³„ì •',0),(360596,10017,'he','×—×©×‘×•×Ÿ ×”×›× ×¡×•×ª ×”×—×™×•×‘',0),(360597,10017,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ chargeback ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(360598,10017,'zh','æ”¶å…¥å¸æˆ·æ‰£æ¬¾\r\n',0),(360599,10017,'sv','Chargeback intÃ¤ktskonto',0),(360600,10017,'it','Conto ricavi di chargeback',0),(360601,10017,'tl','',0),(360602,10017,'th','à¸šà¸±à¸à¸Šà¸µà¸£à¸²à¸¢à¹„à¸”à¹‰à¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(360603,10017,'hi','à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤°à¤¾à¤œà¤¸à¥à¤µ à¤–à¤¾à¤¤à¥‡',0),(360604,10017,'ms','Akaun pendapatan caj semula',0),(360605,10017,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯ ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(360606,10017,'fr','Compte des recettes de Chargeback',0),(360607,10017,'jp','ãƒãƒ£ãƒ¼ã‚¸ ãƒãƒƒã‚¯ã®åŽç›Šå‹˜å®š',0),(360608,10017,'pt','Conta de receita de chargeback',0),(360609,10017,'ru','Ð¡Ñ‡ÐµÑ‚ Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð² Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð½Ñ‹Ñ… Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(360610,10017,'es','Cuenta de Renta de Reintegro del Cobro',0),(360611,10017,'de','Chargeback Ertragskonto',0),(360612,10017,'en','Chargeback Revenue Account',0),(360613,10018,'is','',0),(360614,10018,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†ÙƒÙŠ Ø¶Ø§Ù…Ù† ',0),(360615,10018,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†ÙƒÙŠ Ø¶Ø§Ù…Ù† ',0),(360616,10018,'tr','Hizmetli banka hesabÄ±',0),(360617,10018,'pl','Rachunek bankowy ustalajÄ…cy',0),(360618,10018,'bg','Ð¤Ð¸ÐºÑÐ°Ñ‚Ð¾Ñ€ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°',0),(360619,10018,'ur','Ø¯Ø§Ù…Ù†Ú¯ÛŒØ± Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(360620,10018,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ñƒ Ð±Ð°Ð½Ñ†Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ñ‚ÐµÐ·Ñƒ',0),(360621,10018,'vi','TÃ i khoáº£n ngÃ¢n hÃ ng thuá»™c háº¡',0),(360622,10018,'af','Middels bankrekening',0),(360623,10018,'ro','Cont bancar de retinere',0),(360624,10018,'et','Fiksaator pangakonto',0),(360625,10018,'si','Honorar banÄnega raÄuna',0),(360626,10018,'ba','Rekening Bank punggawa',0),(360627,10018,'nl','Vazal bankrekening',0),(360628,10018,'fi','Kiinnike pankkitili',0),(360629,10018,'no','Retainer bankkonto',0),(360630,10018,'da','Holderen bankkonto',0),(360631,10018,'ko','ë¦¬ í…Œ ì´ë„ˆ ì€í–‰ ê³„ì¢Œ',0),(360632,10018,'he','×—×©×‘×•×Ÿ ×”×‘× ×§ ×©×›×¨ ×˜×¨×—×”',0),(360633,10018,'el','Î‘ÎºÏŒÎ»Î¿Ï…Î¸ÏŒÏ‚ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(360634,10018,'zh','å®¶è‡£é“¶è¡Œå¸æˆ·\r\n',0),(360635,10018,'sv','HÃ¥llare bankkonto',0),(360636,10018,'it','Conto corrente bancario fermo',0),(360637,10018,'tl','',0),(360638,10018,'th','à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¹ƒà¸™à¸˜à¸™à¸²à¸„à¸²à¸£',0),(360639,10018,'hi','à¤¸à¥‡à¤µà¤• à¤•à¥‡ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‡',0),(360640,10018,'ms','Akaun Bank penahan',0),(360641,10018,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ Ø§Ù„ØªØ¬Ù†ÙŠØ¨',0),(360642,10018,'fr','Compte bancaire de retenue',0),(360643,10018,'jp','ãƒªãƒ†ãƒ¼ãƒŠéŠ€è¡Œå£åº§',0),(360644,10018,'pt','Conta bancÃ¡ria do retentor',0),(360645,10018,'ru','Ð”ÐµÑ€Ð¶Ð°Ñ‚ÐµÐ»ÑŒ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(360646,10018,'es','Cuenta Bancaria de Anticipos',0),(360647,10018,'de','Halter Bankkonto',0),(360648,10018,'en','Retainer Bank Account',0),(360649,10019,'is','',0),(360650,10019,'dr','Ø­Ø³Ø§Ø¨ Ù†Ú¯Ø§Ù‡Ø¯Ø§Ø´ØªÙ‡ Ø´Ø¯Ù‡ Ø¶Ø§Ù…Ù†',0),(360651,10019,'pr','Ø­Ø³Ø§Ø¨ Ù†Ú¯Ø§Ù‡Ø¯Ø§Ø´ØªÙ‡ Ø´Ø¯Ù‡ Ø¶Ø§Ù…Ù†',0),(360652,10019,'tr','Hizmetli Held hesabÄ±',0),(360653,10019,'pl','Uchwyt utrzymywane konto',0),(360654,10019,'bg','Ð¤Ð¸ÐºÑÐ°Ñ‚Ð¾Ñ€ Ð¿Ð¾Ð´Ð²Ð¸Ð¶ÐµÐ½ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(360655,10019,'ur','Ø¯Ø§Ù…Ù†Ú¯ÛŒØ± Ø¹ÛØ¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(360656,10019,'sr','ÐŸÑ€Ð¾Ñ‚ÐµÐ·Ð° Ð¾Ð´Ñ€Ð¶Ð°Ð½ Ð½Ð°Ð»Ð¾Ð³',0),(360657,10019,'vi','Thuá»™c háº¡ Ä‘Æ°á»£c tá»• chá»©c tÃ i khoáº£n',0),(360658,10019,'af','Middels aanhou rekening',0),(360659,10019,'ro','Retinere Å£inut cont',0),(360660,10019,'et','Fiksaator Held konto',0),(360661,10019,'si','Honorar Held raÄun',0),(360662,10019,'ba','Pengikut Held Account',0),(360663,10019,'nl','Vazal Held Account',0),(360664,10019,'fi','Kiinnike Held tili',0),(360665,10019,'no','Retainer holdt konto',0),(360666,10019,'da','Holderen holdes konto',0),(360667,10019,'ko','ë¦¬ í…Œ ì´ë„ˆ ê°œìµœ ê³„ì •',0),(360668,10019,'he','×—×©×‘×•×Ÿ ×©×›×¨ ×˜×¨×—×” ×”×œ×“',0),(360669,10019,'el','Î‘ÎºÏŒÎ»Î¿Ï…Î¸ÏŒÏ‚ ÎºÏÎ±Ï„Î·Î¼Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(360670,10019,'zh','å®¶è‡£ä¸¾è¡Œå¸æˆ·\r\n',0),(360671,10019,'sv','HÃ¥llare Held konto',0),(360672,10019,'it','Fermo tenuto conto',0),(360673,10019,'tl','',0),(360674,10019,'th','à¸šà¸±à¸à¸Šà¸µà¸ˆà¸±à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¹ƒà¸™',0),(360675,10019,'hi','à¤…à¤¨à¥à¤šà¤° à¤§à¤¾à¤°à¤¿à¤¤ à¤–à¤¾à¤¤à¥‡',0),(360676,10019,'ms','Penahan dipegang akaun',0),(360677,10019,'ar','Ø­Ø³Ø§Ø¨ Ø¹Ù‚Ø¯ Ø§Ù„ØªÙˆÙƒÙŠÙ„',0),(360678,10019,'fr','Compte tenue de retenue',0),(360679,10019,'jp','ãƒªãƒ†ãƒ¼ãƒŠé–‹å‚¬ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(360680,10019,'pt','Retentor Held conta',0),(360681,10019,'ru','Ð¤Ð¸ÐºÑÐ°Ñ‚Ð¾Ñ€ Ð¿Ñ€Ð¾Ð²ÐµÐ» ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(360682,10019,'es','Cuenta de Retener el Anticipo',0),(360683,10019,'de','Halter-Held-Konto',0),(360684,10019,'en','Retainer Held Account',0),(360685,10020,'is','',0),(360686,10020,'dr','Ø¯Ø§Ø¯ Ùˆ Ø³ØªØ¯',0),(360687,10020,'pr','Ø¯Ø§Ø¯ Ùˆ Ø³ØªØ¯',0),(360688,10020,'tr','AnlaÅŸma',0),(360689,10020,'pl','OfertÄ™',0),(360690,10020,'bg','Ð¡Ð´ÐµÐ»ÐºÐ°',0),(360691,10020,'ur','Ø³ÙˆØ¯Ø§',0),(360692,10020,'sr','Ð”Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(360693,10020,'vi','thá»a thuáº­n',0),(360694,10020,'af','Ooreenkoms',0),(360695,10020,'ro','Afacere',0),(360696,10020,'et','Deal',0),(360697,10020,'si','Deal',0),(360698,10020,'ba','Kesepakatan',0),(360699,10020,'nl','Deal',0),(360700,10020,'fi','Deal',0),(360701,10020,'no','Avtale',0),(360702,10020,'da','Deal',0),(360703,10020,'ko','ê±°ëž˜',0),(360704,10020,'he','×“×™×œ',0),(360705,10020,'el','Î£Ï…Î¼Ï†Ï‰Î½Î¯Î±',0),(360706,10020,'zh','å¤„ç†\r\n',0),(360707,10020,'sv','Deal',0),(360708,10020,'it','Affare',0),(360709,10020,'tl','',0),(360710,10020,'th','à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¸ªà¸¸à¸”à¸žà¸´à¹€à¸¨à¸©',0),(360711,10020,'hi','à¤¸à¥Œà¤¦à¤¾',0),(360712,10020,'ms','Perjanjian',0),(360713,10020,'ar','ØµÙÙ‚Ø©',0),(360714,10020,'fr','Deal',0),(360715,10020,'jp','å¥‘ç´„',0),(360716,10020,'pt','NegÃ³cio',0),(360717,10020,'ru','Ð¡Ð´ÐµÐ»ÐºÐ°',0),(360718,10020,'es','Acuerdo',0),(360719,10020,'de','Deal',0),(360720,10020,'en','Deal',0),(360721,10021,'is','',0),(360722,10021,'dr','ØªØ§Ø±ÙŠØ® ÙƒÙ„Ù†Ú¯ Ø²Ù†ÙŠ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(360723,10021,'pr','ØªØ§Ø±ÙŠØ® ÙƒÙ„Ù†Ú¯ Ø²Ù†ÙŠ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(360724,10021,'tr','Zemin kÄ±rma tarihi tahmini',0),(360725,10021,'pl','Szacowana data przeÅ‚omowym',0),(360726,10021,'bg','ÐžÑ†ÐµÐ½ÑÐ²Ð° ÐŸÑŠÑ€Ð²Ð° ÐºÐ¾Ð¿ÐºÐ° Ð´Ð°Ñ‚Ð°',0),(360727,10021,'ur','Ø²Ù…ÛŒÙ† Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ùˆ ØªÙˆÚ‘Ù†Û’ Ú©Ø§ Ø§Ù†Ø¯Ø§Ø²Û Ù„Ú¯Ø§ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(360728,10021,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð·ÐµÐ¼Ñ™Ñƒ Ñ€Ð°Ð·Ð±Ð¸Ñ˜Ð°ÑšÐµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(360729,10021,'vi','Dá»± tÃ­nh ngÃ y ngáº¯t',0),(360730,10021,'af','Geraamde grond breek datum',0),(360731,10021,'ro','Estimat teren de rupere data',0),(360732,10021,'et','Hinnanguliselt revolutsioonilise kuupÃ¤ev',0),(360733,10021,'si','Ocenjena zemlja zlom datum',0),(360734,10021,'ba','Diperkirakan Ground Breaking tanggal',0),(360735,10021,'nl','Naar schatting baanbrekende datum',0),(360736,10021,'fi','Arvioitu uraauurtava pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(360737,10021,'no','AnslÃ¥tt banebrytende dato',0),(360738,10021,'da','AnslÃ¥et banebrydende dato',0),(360739,10021,'ko','ì§€ìƒ ëŠëŠ” ë‚ ì§œ ì˜ˆìƒ',0),(360740,10021,'he','×”×§×¨×§×¢ ×©×‘×™×¨×ª ×ª××¨×™×š ×ž×©×•×¢×¨',0),(360741,10021,'el','Î•ÎºÏ„Î¹Î¼Î¬Ï„Î±Î¹ ÏŒÏ„Î¹ Ï„Î¿ Î­Î´Î±Ï†Î¿Ï‚ ÏƒÏ€Î¬Î¶Î¿Î½Ï„Î±Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(360742,10021,'zh','é¢„è®¡åŠ¨å·¥æ—¥æœŸ\r\n',0),(360743,10021,'sv','BerÃ¤knat datum fÃ¶r banbrytande',0),(360744,10021,'it','Terra di rottura data di stima',0),(360745,10021,'tl','',0),(360746,10021,'th','à¸›à¸£à¸°à¸¡à¸²à¸“à¸”à¸´à¸™à¸—à¸³à¸¥à¸²à¸¢à¸§à¸±à¸™',0),(360747,10021,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‹ à¤¤à¥‹à¤¡à¤¼à¤¨à¥‡ à¤œà¤®à¥€à¤¨ à¤•à¤¾ à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(360748,10021,'ms','Dianggarkan dimulakan tarikh',0),(360749,10021,'ar','ÙˆÙ‚Ø¯Ø± Ø§Ù„Ø£Ø±Ø¶ ÙƒØ³Ø± Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(360750,10021,'fr','EstimÃ© rupture Date du terrain',0),(360751,10021,'jp','ç”»æœŸçš„ãªæ—¥ä»˜ã®æŽ¨å®š',0),(360752,10021,'pt','Estima-se inovador data',0),(360753,10021,'ru','ÐŸÐ¾ Ð¾Ñ†ÐµÐ½ÐºÐ°Ð¼ Ð½Ð¾Ð²Ð°Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð”Ð°Ñ‚Ð°',0),(360754,10021,'es','Fecha Estimada de Comienza de ConstrucciÃ³n',0),(360755,10021,'de','Ersten Spatenstich Datum geschÃ¤tzt',0),(360756,10021,'en','Estimated Ground Breaking Date',0),(360757,10022,'is','',0),(360758,10022,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§ÙŠØª ',0),(360759,10022,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§ÙŠØª ',0),(360760,10022,'tr','Site Ekle',0),(360761,10022,'pl','Witryny',0),(360762,10022,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ°Ð¹Ñ‚',0),(360763,10022,'ur','Ø³Ø§Ø¦Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(360764,10022,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(360765,10022,'vi','ThÃªm trang web',0),(360766,10022,'af','Webwerf Byvoeg',0),(360767,10022,'ro','Adauga site-ul',0),(360768,10022,'et','Saidi lisamine',0),(360769,10022,'si','Dodaj stran',0),(360770,10022,'ba','Tambahkan situs',0),(360771,10022,'nl','Site toevoegen',0),(360772,10022,'fi','Sivuston lisÃ¤Ã¤minen',0),(360773,10022,'no','Nettstedet legge til',0),(360774,10022,'da','Webstedet tilfÃ¸je',0),(360775,10022,'ko','ì‚¬ì´íŠ¸ ì¶”ê°€',0),(360776,10022,'he','×”×•×¡×£ ××ª×¨',0),(360777,10022,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ site',0),(360778,10022,'zh','ç½‘ç«™åŠ å…¥\r\n',0),(360779,10022,'sv','LÃ¤gg till webbplats',0),(360780,10022,'it','Aggiungi sito',0),(360781,10022,'tl','',0),(360782,10022,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ',0),(360783,10022,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(360784,10022,'ms','Tambah laman web',0),(360785,10022,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹',0),(360786,10022,'fr','Ajouter site',0),(360787,10022,'jp','ã‚µã‚¤ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(360788,10022,'pt','Adicionar site',0),(360789,10022,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ°Ð¹Ñ‚',0),(360790,10022,'es','Agregar Sitio',0),(360791,10022,'de','Website hinzufÃ¼gen',0),(360792,10022,'en','Site Add',0),(360793,10023,'is','',0),(360794,10023,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(360795,10023,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(360796,10023,'tr','Site baÅŸarÄ±yla eklendi',0),(360797,10023,'pl','Strona dodana pomyÅ›lnie',0),(360798,10023,'bg','Ð¡Ð°Ð¹Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(360799,10023,'ur','Ø³Ø§Ø¦Ù¹ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(360800,10023,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(360801,10023,'vi','thÃªm trang web thÃ nh cÃ´ng',0),(360802,10023,'af','Terrein Suksesvol Bygevoeg',0),(360803,10023,'ro','Pe site-ul cu succes',0),(360804,10023,'et','Lisatud saidi',0),(360805,10023,'si','Mesta uspeÅ¡no dodali',0),(360806,10023,'ba','Situs berhasil ditambahkan',0),(360807,10023,'nl','Site met succes toegevoegd',0),(360808,10023,'fi','Sivuston lisÃ¤Ã¤minen onnistui',0),(360809,10023,'no','OmrÃ¥det ble lagt til',0),(360810,10023,'da','Webstedet tilfÃ¸jet',0),(360811,10023,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ì‚¬ì´íŠ¸',0),(360812,10023,'he','××ª×¨ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(360813,10023,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Ï„Î¿ site',0),(360814,10023,'zh','ç½‘ç«™æ·»åŠ æˆåŠŸ\r\n',0),(360815,10023,'sv','Webbplats som lagts',0),(360816,10023,'it','Sito aggiunto con successo',0),(360817,10023,'tl','',0),(360818,10023,'th','à¹„à¸‹à¸•à¹Œà¸—à¸µà¹ˆà¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(360819,10023,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(360820,10023,'ms','Laman web yang berjaya menambah',0),(360821,10023,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø¨Ù†Ø¬Ø§Ø­',0),(360822,10023,'fr','Site ajoutÃ© avec succÃ¨s',0),(360823,10023,'jp','ã‚µã‚¤ãƒˆãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(360824,10023,'pt','Site adicionado com sucesso',0),(360825,10023,'ru','Ð¡Ð°Ð¹Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(360826,10023,'es','Sitio Agregado Exitosamente',0),(360827,10023,'de','Website erfolgreich hinzugefÃ¼gt',0),(360828,10023,'en','Site Added Successfully',0),(360829,10024,'is','',0),(360830,10024,'dr','Ø³Ø§ÙŠØª  Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(360831,10024,'pr','Ø³Ø§ÙŠØª  Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(360832,10024,'tr','Site zaten var',0),(360833,10024,'pl','Strona istnieje juÅ¼',0),(360834,10024,'bg','Ð’ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° ÑÐ°Ð¹Ñ‚',0),(360835,10024,'ur','ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ú©ÛŒ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(360836,10024,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(360837,10024,'vi','Trang web nÃ y Ä‘Ã£ tá»“n táº¡i rá»“i',0),(360838,10024,'af','Terrein Bestaan Alreeds',0),(360839,10024,'ro','Site-ul existÄƒ deja',0),(360840,10024,'et','Sait on juba olemas',0),(360841,10024,'si','Å½e obstaja mesto',0),(360842,10024,'ba','Situs yang sudah ada',0),(360843,10024,'nl','Er bestaat al site',0),(360844,10024,'fi','Sivusto on jo olemassa',0),(360845,10024,'no','OmrÃ¥det finnes allerede',0),(360846,10024,'da','Websted findes allerede',0),(360847,10024,'ko','ì‚¬ì´íŠ¸ê°€ ì´ë¯¸ ìžˆìŒ',0),(360848,10024,'he','×”××ª×¨ ×›×‘×¨ ×§×™×™×',0),(360849,10024,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(360850,10024,'zh','ç½‘ç«™å·²å­˜åœ¨\r\n',0),(360851,10024,'sv','Det finns redan webbplats',0),(360852,10024,'it','Sito giÃ  esistente',0),(360853,10024,'tl','',0),(360854,10024,'th','à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(360855,10024,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(360856,10024,'ms','Tapak telah sedia wujud',0),(360857,10024,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„',0),(360858,10024,'fr','Site existe dÃ©jÃ ',0),(360859,10024,'jp','ã‚µã‚¤ãƒˆã¯æ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(360860,10024,'pt','Site jÃ¡ existe',0),(360861,10024,'ru','Ð¡Ð°Ð¹Ñ‚ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(360862,10024,'es','Sitio Ya Existe',0),(360863,10024,'de','Website ist bereits vorhanden.',0),(360864,10024,'en','Site Already Exists',0),(360865,10025,'is','',0),(360866,10025,'dr','Ù†Ø§Ù… Ø³Ø§ÙŠØª ',0),(360867,10025,'pr','Ù†Ø§Ù… Ø³Ø§ÙŠØª ',0),(360868,10025,'tr','Site adÄ±',0),(360869,10025,'pl','Nazwa witryny',0),(360870,10025,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐ°Ð¹Ñ‚',0),(360871,10025,'ur','ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ú©Ø§ Ù†Ø§Ù…',0),(360872,10025,'sr','Ð˜Ð¼Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(360873,10025,'vi','tÃªn trang web',0),(360874,10025,'af','Webwerf Naam',0),(360875,10025,'ro','Numele site-ului',0),(360876,10025,'et','Saidi nimi',0),(360877,10025,'si','Ime mesta',0),(360878,10025,'ba','Nama situs',0),(360879,10025,'nl','Naam van de site',0),(360880,10025,'fi','Sivustonimi',0),(360881,10025,'no','OmrÃ¥denavn',0),(360882,10025,'da','Navn pÃ¥ websted',0),(360883,10025,'ko','ì‚¬ì´íŠ¸ ì´ë¦„',0),(360884,10025,'he','×©× ××ª×¨',0),(360885,10025,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±Ï‚',0),(360886,10025,'zh','ç½‘ç«™åç§°\r\n',0),(360887,10025,'sv','Webbplatsens namn',0),(360888,10025,'it','Nome del sito',0),(360889,10025,'tl','',0),(360890,10025,'th','à¸Šà¸·à¹ˆà¸­à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ',0),(360891,10025,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(360892,10025,'ms','Nama tapak',0),(360893,10025,'ar','Ø§Ø³Ù… Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(360894,10025,'fr','Nom du site',0),(360895,10025,'jp','ã‚µã‚¤ãƒˆå',0),(360896,10025,'pt','Nome do site',0),(360897,10025,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÑÐ°Ð¹Ñ‚Ð°',0),(360898,10025,'es','Pagina Web',0),(360899,10025,'de','Site-Name',0),(360900,10025,'en','Site Name',0),(360901,10026,'is','',0),(360902,10026,'dr','Ø³Ø§ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯ ',0),(360903,10026,'pr','Ø³Ø§ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯ ',0),(360904,10026,'tr','Siteyi ekledi',0),(360905,10026,'pl','Strony nie dodaje',0),(360906,10026,'bg','Ð¡Ð°Ð¹Ñ‚Ð° Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¾',0),(360907,10026,'ur','Ø³Ø§Ø¦Ù¹ Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©ÛŒØ§',0),(360908,10026,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ñ‚',0),(360909,10026,'vi','Trang web khÃ´ng thÃªm vÃ o Ä‘Æ°á»£c',0),(360910,10026,'af','Terrein Nie Bygevoeg',0),(360911,10026,'ro','Pe site-ul nu',0),(360912,10026,'et','Saiti ei saa lisada',0),(360913,10026,'si','Stran ne doda',0),(360914,10026,'ba','Situs tidak ditambahkan',0),(360915,10026,'nl','Site niet toegevoegd',0),(360916,10026,'fi','Sivusto ei lisÃ¤tÃ¤',0),(360917,10026,'no','Nettstedet ikke lagt',0),(360918,10026,'da','Site ikke tilfÃ¸jet',0),(360919,10026,'ko','ì‚¬ì´íŠ¸ ì¶”ê°€',0),(360920,10026,'he','×”××ª×¨ ×œ× ×”×•×¡×™×£',0),(360921,10026,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Î´ÎµÎ½ Ï€ÏÎ¿ÏƒÏ„Î¯Î¸ÎµÎ½Ï„Î±Î¹',0),(360922,10026,'zh','ç½‘ç«™æœªæ·»åŠ \r\n',0),(360923,10026,'sv','Webbplats inte lÃ¤ggas',0),(360924,10026,'it','Sito non aggiunto',0),(360925,10026,'tl','',0),(360926,10026,'th','à¹„à¸‹à¸•à¹Œà¹„à¸¡à¹ˆà¹€à¸žà¸´à¹ˆà¸¡',0),(360927,10026,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(360928,10026,'ms','Lokasi yang tidak ditambah',0),(360929,10026,'ar','Ù„Ù… ØªØªÙ… Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(360930,10026,'fr','Site ne pas ajoutÃ©',0),(360931,10026,'jp','ã‚µã‚¤ãƒˆã‚’è¿½åŠ ã—ã¦ã„ã¾ã›ã‚“',0),(360932,10026,'pt','Site nÃ£o adicionado',0),(360933,10026,'ru','Ð¡Ð°Ð¹Ñ‚ Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(360934,10026,'es','Sitio No Agregado',0),(360935,10026,'de','Website nicht hinzugefÃ¼gt',0),(360936,10026,'en','Site Not Added',0),(360937,10027,'is','',0),(360938,10027,'dr','Ø­Ø°Ù Ø³Ø§ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(360939,10027,'pr','Ø­Ø°Ù Ø³Ø§ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(360940,10027,'tr','Site baÅŸarÄ±yla silindi',0),(360941,10027,'pl','Strony usuniÄ™te pomyÅ›lnie',0),(360942,10027,'bg','Ð¡Ð°Ð¹Ñ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(360943,10027,'ur','Ø³Ø§Ø¦Ù¹ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(360944,10027,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(360945,10027,'vi','XÃ³a trang web thÃ nh cÃ´ng',0),(360946,10027,'af','Terrein Suksesvol Geskrap',0),(360947,10027,'ro','Site-ul eliminÄƒ cu succes',0),(360948,10027,'et','Saidi edukalt kustutatud',0),(360949,10027,'si','Mesto uspeÅ¡no izbrisana',0),(360950,10027,'ba','Situs berhasil dihapus',0),(360951,10027,'nl','Site met succes verwijderd',0),(360952,10027,'fi','Poistettu sivusto',0),(360953,10027,'no','OmrÃ¥det ble slettet',0),(360954,10027,'da','Site slettet',0),(360955,10027,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ì‚¬ì´íŠ¸',0),(360956,10027,'he','×”××ª×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(360957,10027,'el','Î”Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚ Ï„Î¿ site',0),(360958,10027,'zh','ç½‘ç«™æˆåŠŸåˆ é™¤\r\n',0),(360959,10027,'sv','Webbplats raderades',0),(360960,10027,'it','Sito cancellato con successo',0),(360961,10027,'tl','',0),(360962,10027,'th','à¹„à¸‹à¸•à¹Œà¸–à¸¹à¸à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(360963,10027,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(360964,10027,'ms','Laman yang dihapuskan dengan jayanya',0),(360965,10027,'ar','Ø­Ø°Ù Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø¨Ù†Ø¬Ø§Ø­',0),(360966,10027,'fr','Site supprimÃ© avec succÃ¨s',0),(360967,10027,'jp','ã‚µã‚¤ãƒˆãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(360968,10027,'pt','Site apagado com sucesso',0),(360969,10027,'ru','Ð¡Ð°Ð¹Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(360970,10027,'es','Siio Eliminado Exiosamente',0),(360971,10027,'de','Website erfolgreich gelÃ¶scht',0),(360972,10027,'en','Site Deleted Successfully',0),(360973,10028,'is','',0),(360974,10028,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø§ÙŠØª ',0),(360975,10028,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø§ÙŠØª ',0),(360976,10028,'tr','Site gÃ¼ncelleme',0),(360977,10028,'pl','Aktualizacja strony',0),(360978,10028,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° ÑÐ°Ð¹Ñ‚Ð°',0),(360979,10028,'ur','ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ø§Ù¾ ÚˆÛŒÙ¹',0),(360980,10028,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(360981,10028,'vi','cáº­p nháº­t trang web',0),(360982,10028,'af','Terrein Opdateer',0),(360983,10028,'ro','Site-ul actualizare',0),(360984,10028,'et','Saidi uuendamine',0),(360985,10028,'si','Posodobitev mesta',0),(360986,10028,'ba','Situs Update',0),(360987,10028,'nl','Site Update',0),(360988,10028,'fi','Sivuston pÃ¤ivitys',0),(360989,10028,'no','Sideoppdatering',0),(360990,10028,'da','Site-opdatering',0),(360991,10028,'ko','ì‚¬ì´íŠ¸ ì—…ë°ì´íŠ¸',0),(360992,10028,'he','×¢×“×›×•×Ÿ ×”××ª×¨',0),(360993,10028,'el','Î˜Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹ Ï„Î¿ site',0),(360994,10028,'zh','ç«™ç‚¹æ›´æ–°\r\n',0),(360995,10028,'sv','Uppdatering',0),(360996,10028,'it','Aggiornamento sito',0),(360997,10028,'tl','',0),(360998,10028,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ',0),(360999,10028,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤…à¤ªà¤¡à¥‡à¤Ÿ',0),(361000,10028,'ms','Kemaskini Laman web',0),(361001,10028,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(361002,10028,'fr','Mise Ã  jour du site',0),(361003,10028,'jp','ã‚µã‚¤ãƒˆã®æ›´æ–°',0),(361004,10028,'pt','AtualizaÃ§Ã£o do site',0),(361005,10028,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ°Ð¹Ñ‚Ð°',0),(361006,10028,'es','ActualizaciÃ³n de Sitio',0),(361007,10028,'de','Website Update',0),(361008,10028,'en','Site Update',0),(361009,10029,'is','',0),(361010,10029,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(361011,10029,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(361012,10029,'tr','Chargeback iÅŸ PO eklemek',0),(361013,10029,'pl','DodaÄ‡ obciÄ…Å¼enia pracy PO',0),(361014,10029,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ PO',0),(361015,10029,'ur','Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ù…Ù„Ø§Ø²Ù…Øª Ù¾Ùˆ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(361016,10029,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº Ð¿Ð¾ÑÐ°Ð¾ ÐŸÐž',0),(361017,10029,'vi','ThÃªm cÃ´ng viá»‡c tiá»n chiáº¿t kháº¥u PO',0),(361018,10029,'af','Byvoeg van Verhaalbare Werkstuk AN',0),(361019,10029,'ro','Adauga Chargeback Job PO',0),(361020,10029,'et','Lisada sissenÃµudmine tÃ¶Ã¶ PO',0),(361021,10029,'si','Dodaj poraÄuna zaposlitev PO',0),(361022,10029,'ba','Tambahkan Chargeback pekerjaan PO',0),(361023,10029,'nl','Add Chargeback Job PO',0),(361024,10029,'fi','LisÃ¤Ã¤ takaisinperinnÃ¤n tyÃ¶ PO',0),(361025,10029,'no','Legge til tilbakefÃ¸rsel jobb PO',0),(361026,10029,'da','TilfÃ¸je tilbagefÃ¸rslen Job PO',0),(361027,10029,'ko','í™˜ë¶ˆ ì¼ í¬ ì¶”ê°€',0),(361028,10029,'he','×”×•×¡×¤×ª ×¢×‘×•×“×” ×”×—×™×•×‘ ×¤×•',0),(361029,10029,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Chargeback Î´Î¿Ï…Î»ÎµÎ¹Î¬ PO',0),(361030,10029,'zh','å¢žåŠ æ‰£æ¬¾ä½œä¸šè®¢å•\r\n',0),(361031,10029,'sv','LÃ¤gg till Ã¥terdebitering jobb PO',0),(361032,10029,'it','Aggiungi Chargeback lavoro PO',0),(361033,10029,'tl','',0),(361034,10029,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸‡à¸²à¸™à¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ PO',0),(361035,10029,'hi','à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¥‹ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(361036,10029,'ms','Tambah caj balik kerja PO',0),(361037,10029,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ¸ÙŠÙØ© ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø¨Ùˆ',0),(361038,10029,'fr','Ajouter Chargeback travail PO',0),(361039,10029,'jp','ãƒãƒ£ãƒ¼ã‚¸ ãƒãƒƒã‚¯ ãƒ» ã‚¸ãƒ§ãƒ– PO ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(361040,10029,'pt','Adicionar trabalho Chargeback PO',0),(361041,10029,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ Chargeback PO',0),(361042,10029,'es','Agregar OC de Trabajo de Chargeback',0),(361043,10029,'de','Chargeback Auftrag PO hinzuzufÃ¼gen',0),(361044,10029,'en','Add Chargeback Job PO',0),(361045,10030,'is','',0),(361046,10030,'dr','Ø¯Ø±ØµØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù†Ø´Ø¯Ù‡',0),(361047,10030,'pr','Ø¯Ø±ØµØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù†Ø´Ø¯Ù‡',0),(361048,10030,'tr','YÃ¼zde Upcharge',0),(361049,10030,'pl','Procent Upcharge',0),(361050,10030,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Upcharge',0),(361051,10030,'ur','ÙÛŒ ØµØ¯ Ø§Ù¾Ú†Ø§Ø±Ú¯Ø§',0),(361052,10030,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð£Ð¿Ñ†Ñ…Ð°Ñ€Ð³Ðµ',0),(361053,10030,'vi','Pháº§n trÄƒm Upcharge',0),(361054,10030,'af','Persentasie Upcharge',0),(361055,10030,'ro','Procent Upcharge',0),(361056,10030,'et','Protsent Upcharge',0),(361057,10030,'si','Odstotek Upcharge',0),(361058,10030,'ba','Upcharge persen',0),(361059,10030,'nl','Percentage Upcharge',0),(361060,10030,'fi','Prosenttia Upcharge',0),(361061,10030,'no','Prosent Upcharge',0),(361062,10030,'da','Procent Upcharge',0),(361063,10030,'ko','ë°±ë¶„ìœ¨ Upcharge',0),(361064,10030,'he','Upcharge ××—×•×–',0),(361065,10030,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Upcharge',0),(361066,10030,'zh','ç™¾åˆ†æ¯”çš„ç½ªå\r\n',0),(361067,10030,'sv','Procent Upcharge',0),(361068,10030,'it','Percentuale Upcharge',0),(361069,10030,'tl','',0),(361070,10030,'th','à¸£à¹‰à¸­à¸¢à¸¥à¸° Upcharge',0),(361071,10030,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ Upcharge',0),(361072,10030,'ms','Peratus Upcharge',0),(361073,10030,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ø£ÙˆØ¨ØªØ´Ø§Ø±Ø¬ÙŠ',0),(361074,10030,'fr','Pourcentage Upcharge',0),(361075,10030,'jp','ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆè¿½åŠ æ–™é‡‘',0),(361076,10030,'pt','Por cento Upcharge',0),(361077,10030,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð±Ñ€Ñ‘Ð²Ð½Ð°',0),(361078,10030,'es','Porcentaje de Cargos Extras (Upcharge)',0),(361079,10030,'de','Prozent Aufpreis',0),(361080,10030,'en','Percent Upcharge',0),(361081,10031,'is','',0),(361082,10031,'dr','Ù…Ø³Ø¦ÙˆÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(361083,10031,'pr','Ù…Ø³Ø¦ÙˆÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(361084,10031,'tr','SatÄ±cÄ± sorumlu',0),(361085,10031,'pl','OdpowiedzialnoÅ›Ä‡ sprzedawcy',0),(361086,10031,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ÐµÐ½',0),(361087,10031,'ur','ÙˆÛŒÙ†ÚˆØ± Ø°Ù…Û Ø¯Ø§Ø±',0),(361088,10031,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ñ˜Ðµ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€Ð°Ð½',0),(361089,10031,'vi','NhÃ  cung cáº¥p chá»‹u trÃ¡ch nhiá»‡m',0),(361090,10031,'af','Verkoper verantwoordelik',0),(361091,10031,'ro','Furnizor responsabil',0),(361092,10031,'et','Hankija vastutav',0),(361093,10031,'si','Prodajalec odgovoren',0),(361094,10031,'ba','Vendor bertanggung jawab',0),(361095,10031,'nl','Leverancier verantwoordelijk',0),(361096,10031,'fi','Toimittaja vastaa',0),(361097,10031,'no','LeverandÃ¸ren ansvarlig',0),(361098,10031,'da','LeverandÃ¸ren ansvarlig',0),(361099,10031,'ko','ê³µê¸‰ ì—…ì²´ ì±…ìž„',0),(361100,10031,'he','×”×¡×¤×§ ××—×¨××™',0),(361101,10031,'el','Î¥Ï€ÎµÏÎ¸Ï…Î½Î¿Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(361102,10031,'zh','å–æ–¹è´Ÿè´£\r\n',0),(361103,10031,'sv','SÃ¤ljaren ansvarar',0),(361104,10031,'it','Venditore responsabile',0),(361105,10031,'tl','',0),(361106,10031,'th','à¸œà¸¹à¹‰à¸£à¸±à¸šà¸œà¸´à¸”à¸Šà¸­à¸š',0),(361107,10031,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¤¿à¤®à¥à¤®à¥‡à¤¦à¤¾à¤°',0),(361108,10031,'ms','Penjual yang bertanggungjawab',0),(361109,10031,'ar','Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ù…Ø³Ø¤ÙˆÙ„Ø§Ù‹',0),(361110,10031,'fr','Vendeur responsable',0),(361111,10031,'jp','è²¬ä»»ãŒã‚ã‚‹ãƒ™ãƒ³ãƒ€ãƒ¼',0),(361112,10031,'pt','Vendedor responsÃ¡vel',0),(361113,10031,'ru','ÐžÑ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(361114,10031,'es','Vendedor Responsable',0),(361115,10031,'de','Anbieter verantwortlich',0),(361116,10031,'en','Vendor Responsible',0),(361117,10032,'is','',0),(361118,10032,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² ØªØºÙŠÙŠØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(361119,10032,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² ØªØºÙŠÙŠØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(361120,10032,'tr','PO Ã¶nce deÄŸiÅŸiklikleri gÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klatÄ±n',0),(361121,10032,'pl','Kliknij przycisk Widok PO przed zmianami',0),(361122,10032,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¸Ð·Ð³Ð»ÐµÐ´ PO Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(361123,10032,'ur','Ù…Ù†Ø¸Ø± Ù¾Ùˆ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ø³Û’ Ù¾ÛÙ„Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(361124,10032,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð· ÐŸÐž Ð¿Ñ€Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(361125,10032,'vi','Xem Ä‘Æ¡n hÃ ng trÆ°á»›c khi thay Ä‘á»•i ',0),(361126,10032,'af','Kliek om AB te Besigtig Alvorens Veranderinge Gemaak is',0),(361127,10032,'ro','Click pentru a vizualiza PO Ã®nainte de modificÄƒri',0),(361128,10032,'et','KlÃµpsake vaate PO enne muudatuste',0),(361129,10032,'si','Kliknite za ogled PO pred spremembami',0),(361130,10032,'ba','Klik untuk melihat PO sebelum perubahan',0),(361131,10032,'nl','Klik om te bekijken PO voorafgaand aan wijzigingen',0),(361132,10032,'fi','Klikkaa nÃ¤hdÃ¤ksesi PO ennen muutosten',0),(361133,10032,'no','Klikk for Ã¥ vise PO fÃ¸r endringer',0),(361134,10032,'da','Klik for at se PO forud for Ã¦ndringer',0),(361135,10032,'ko','í´ë¦­ ë³€ê²½ ì „ì— í¬ ë³´ê¸°',0),(361136,10032,'he','×œ×—×¥ ×¢×œ ×ª×¦×•×’×” ×¤×• ×œ×¤× ×™ ×©×™× ×•×™×™×',0),(361137,10032,'el','ÎšÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¹Ï„Îµ PO Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚',0),(361138,10032,'zh','ç‚¹å‡»æŸ¥çœ‹è®¢å•ä¹‹å‰çš„å˜åŒ–\r\n',0),(361139,10032,'sv','Klicka fÃ¶r att Visa PO innan fÃ¶rÃ¤ndringar',0),(361140,10032,'it','Clicca per visualizzare PO prima della modifiche',0),(361141,10032,'tl','',0),(361142,10032,'th','à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹ PO à¸à¹ˆà¸­à¸™à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(361143,10032,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤ªà¥‹ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(361144,10032,'ms','Klik untuk lihat PO sebelum perubahan',0),(361145,10032,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ø¹Ø±Ø¶ Ø¨Ùˆ Ù‚Ø¨Ù„ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(361146,10032,'fr','Cliquez pour voir PO avant les modifications',0),(361147,10032,'jp','ã‚¯ãƒªãƒƒã‚¯ã™ã‚‹ã¨å¤‰æ›´å‰ã®ãƒ“ãƒ¥ãƒ¼ ãƒãƒ¼',0),(361148,10032,'pt','Clique para ver PO antes de mudanÃ§as',0),(361149,10032,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° PO Ð´Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(361150,10032,'es','Hacer Clic para Visionar OC Antes de los Cambios',0),(361151,10032,'de','Klicken Sie auf Ansicht PO vor Ã„nderungen',0),(361152,10032,'en','Click to View PO Prior to Changes',0),(361153,10033,'is','',0),(361154,10033,'dr','FOB ÙÙˆØ¨ Ù…Ù‚ØµØ¯',0),(361155,10033,'pr','FOB ÙÙˆØ¨ Ù…Ù‚ØµØ¯\r\n',0),(361156,10033,'tr','FOB hedef',0),(361157,10033,'pl','Franco statek przeznaczenia',0),(361158,10033,'bg','FOB Ð¼ÐµÑÑ‚Ð¾Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(361159,10033,'ur','Ù¾Ø§Ú©Ù¹ Ù…Ù‚ØµÙˆØ¯',0),(361160,10033,'sr','Ð¤ÐžÐ‘ Ð¾Ð´Ñ€ÐµÐ´Ð¸ÑˆÑ‚Ðµ',0),(361161,10033,'vi','Ä‘iá»ƒm Ä‘áº¿n FOB',0),(361162,10033,'af','FOB bestemming',0),(361163,10033,'ro','FOB destinaÅ£ie',0),(361164,10033,'et','FOB sihtkohta',0),(361165,10033,'si','FOB destinacijo',0),(361166,10033,'ba','Tujuan FOB',0),(361167,10033,'nl','FOB bestemming',0),(361168,10033,'fi','FOB kohde',0),(361169,10033,'no','FOB destinasjon',0),(361170,10033,'da','FOB Destination',0),(361171,10033,'ko','FOB ëŒ€ìƒ',0),(361172,10033,'he','FOB ×”×™×¢×“',0),(361173,10033,'el','FOB Ï€ÏÎ¿Î¿ÏÎ¹ÏƒÎ¼Î¿Ï',0),(361174,10033,'zh','ç©¿ä¸Šäº¤è´§ç›®çš„åœ°\r\n',0),(361175,10033,'sv','FOB Destination',0),(361176,10033,'it','Destinazione FOB',0),(361177,10033,'tl','',0),(361178,10033,'th','à¸›à¸¥à¸²à¸¢à¸—à¸²à¸‡à¸‚à¸­à¸‡ FOB',0),(361179,10033,'hi','à¤à¤«à¤“à¤¬à¥€ à¤—à¤‚à¤¤à¤µà¥à¤¯',0),(361180,10033,'ms','Destinasi FOB',0),(361181,10033,'ar','Ø§Ù„ÙˆØ¬Ù‡Ø© ÙÙˆØ¨',0),(361182,10033,'fr','FOB Destination',0),(361183,10033,'jp','FOB åˆ°ç€åœ°',0),(361184,10033,'pt','FOB-destino',0),(361185,10033,'ru','FOB Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(361186,10033,'es','DestinaciÃ³n LAB',0),(361187,10033,'de','FOB-Ziel',0),(361188,10033,'en','FOB Destination',0),(361189,10034,'is','',0),(361190,10034,'dr','FOB ÙÙˆØ¨ Ù…Ø­Ù„ Ø­Ù…Ù„ ',0),(361191,10034,'pr','FOB ÙÙˆØ¨ Ù…Ø­Ù„ Ø­Ù…Ù„ ',0),(361192,10034,'tr','FOB gemi noktasÄ±',0),(361193,10034,'pl','FOB punkt statku',0),(361194,10034,'bg','FOB ÐºÐ¾Ñ€Ð°Ð± Ñ‚Ð¾Ñ‡ÐºÐ°',0),(361195,10034,'ur','Ù¾Ø§Ú©Ù¹ Ø¬ÛØ§Ø² Ù†Ù‚Ø·Û',0),(361196,10034,'sr','Ð¤ÐžÐ‘ Ð±Ñ€Ð¾Ð´ ÐŸÐ¾Ð¸Ð½Ñ‚',0),(361197,10034,'vi','Äiá»ƒm váº­n chuyá»ƒn FOB',0),(361198,10034,'af','FOB skip punt',0),(361199,10034,'ro','Punct de livrare FOB',0),(361200,10034,'et','FOB laeva punkti',0),(361201,10034,'si','FOB ladje toÄke',0),(361202,10034,'ba','FOB kapal Point',0),(361203,10034,'nl','FOB schip punt',0),(361204,10034,'fi','FOB aluksen kohta',0),(361205,10034,'no','FOB skipet punkt',0),(361206,10034,'da','FOB skib punkt',0),(361207,10034,'ko','FOB ì„ ë°• í¬ì¸íŠ¸',0),(361208,10034,'he','FOB ×”×¡×¤×™× ×” × ×§×•×“×”',0),(361209,10034,'el','FOB Ï€Î»Î¿Î¯Î¿ ÏƒÎ·Î¼ÎµÎ¯Î¿',0),(361210,10034,'zh','èˆ¹ç¦»å²¸ä»·ç‚¹\r\n',0),(361211,10034,'sv','FOB fartyget punkt',0),(361212,10034,'it','Punto nave FOB',0),(361213,10034,'tl','',0),(361214,10034,'th','à¸ˆà¸¸à¸”à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ FOB',0),(361215,10034,'hi','à¤à¤«à¤“à¤¬à¥€ à¤œà¤¹à¤¾à¤œ à¤¬à¤¿à¤‚à¤¦à¥',0),(361216,10034,'ms','FOB kapal titik',0),(361217,10034,'ar','ØªØ³Ù„ÙŠÙ… Ø¸Ù‡Ø± Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù†Ù‚Ø·Ø©',0),(361218,10034,'fr','FOB navire Point',0),(361219,10034,'jp','FOB èˆ¹ãƒã‚¤ãƒ³ãƒˆ',0),(361220,10034,'pt','FOB navio ponto',0),(361221,10034,'ru','FOB ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(361222,10034,'es','LAB Punto de Comienza',0),(361223,10034,'de','FOB-Schiff-Punkt',0),(361224,10034,'en','FOB Ship Point',0),(361225,10035,'is','',0),(361226,10035,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ú¯Ø§Ù‡ Ø³Ø§Ø®ØªÙ…Ø§Ù†ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(361227,10035,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Ú¯Ø§Ù‡ Ø³Ø§Ø®ØªÙ…Ø§Ù†ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(361228,10035,'tr','Yeni inÅŸaat alanÄ±na Ekle',0),(361229,10035,'pl','Dodaj nowe budowy',0),(361230,10035,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð¾Ð±ÐµÐºÑ‚',0),(361231,10035,'ur','Ù†Ø¦Û’ ØªØ¹Ù…ÛŒØ±Ø§ØªÛŒ Ú©Ø§Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(361232,10035,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¾ Ð³Ñ€Ð°Ð´Ð¸Ð»Ð¸ÑˆÑ‚Ðµ',0),(361233,10035,'vi','ThÃªm má»›i xÃ¢y dá»±ng trang web',0),(361234,10035,'af','Nuwe Konstruksie Terrein Byvoeg',0),(361235,10035,'ro','AdÄƒuga noi site-ul de constructii',0),(361236,10035,'et','Lisage uus ehitusplatsil',0),(361237,10035,'si','Dodajte nove gradbiÅ¡Äu',0),(361238,10035,'ba','Tambahkan situs konstruksi baru',0),(361239,10035,'nl','Nieuwe Construction Site toevoegen',0),(361240,10035,'fi','LisÃ¤Ã¤ uusi tyÃ¶maa',0),(361241,10035,'no','Legge til nye byggeplass',0),(361242,10035,'da','TilfÃ¸je nye byggeplads',0),(361243,10035,'ko','ìƒˆë¡œìš´ ê±´ì„¤ ì‚¬ì´íŠ¸ ì¶”ê°€',0),(361244,10035,'he','×”×•×¡×£ ××ª×¨ ×‘× ×™×” ×—×“×©',0),(361245,10035,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ ÎµÏÎ³Î¿Ï„Î¬Î¾Î¹Î¿',0),(361246,10035,'zh','å¢žåŠ æ–°çš„å»ºè®¾åœºåœ°\r\n',0),(361247,10035,'sv','LÃ¤gg till ny byggarbetsplats',0),(361248,10035,'it','Aggiungi nuovo cantiere',0),(361249,10035,'tl','',0),(361250,10035,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹„à¸‹à¸•à¹Œà¸à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸«à¸¡à¹ˆ',0),(361251,10035,'hi','à¤¨à¤ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤¥à¤² à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(361252,10035,'ms','Tambah tapak pembinaan yang baru',0),(361253,10035,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø¨Ù†Ø§Ø¡ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(361254,10035,'fr','Ajouter Nouveau Chantier',0),(361255,10035,'jp','æ–°ã—ã„å»ºè¨­ç¾å ´ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(361256,10035,'pt','Adicionar novo Site de construÃ§Ã£o',0),(361257,10035,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ ÑÐ°Ð¹Ñ‚ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾',0),(361258,10035,'es','Agregar Nuevo Sitio de ConstrucciÃ³n',0),(361259,10035,'de','FÃ¼gen Sie neue Baustelle',0),(361260,10035,'en','Add New Construction Site',0),(361261,10036,'is','',0),(361262,10036,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ  Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(361263,10036,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ  Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯',0),(361264,10036,'tr','Yeni Chargeback satÄ±nalma sipariÅŸi oluÅŸturma',0),(361265,10036,'pl','UtwÃ³rz nowe obciÄ…Å¼enia zwrotnego zamÃ³wienia',0),(361266,10036,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð½Ð° Ð‘Ð°Ðº',0),(361267,10036,'ur','Ø§ÛŒÚ© Ù†Ø¦ÛŒ Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(361268,10036,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº',0),(361269,10036,'vi','Táº¡o ra má»™t tráº­t tá»± tiá»n chiáº¿t kháº¥u mua má»›i',0),(361270,10036,'af','Skep \'n Nuwe Terugbetaalbare Aankoopbestelling',0),(361271,10036,'ro','Crea o comandÄƒ de cumpÄƒrare de Chargeback',0),(361272,10036,'et','Uus sissenÃµudmine ostutellimuse loomine',0),(361273,10036,'si','Ustvari novo naroÄilnico poraÄuna',0),(361274,10036,'ba','Membuat Order Pembelian Chargeback baru',0),(361275,10036,'nl','Maak een nieuwe inkooporder van Chargeback',0),(361276,10036,'fi','Chargeback ostotilauksen luominen',0),(361277,10036,'no','Opprette en ny bestilling for tilbakefÃ¸ring',0),(361278,10036,'da','Opret en ny tilbagefÃ¸rslen indkÃ¸bsordre',0),(361279,10036,'ko','ìƒˆë¡œìš´ í™˜ë¶ˆ ì£¼ë¬¸ì„œ ë§Œë“¤ê¸°',0),(361280,10036,'he','×¦×•×¨ ×”×–×ž× ×ª ×¨×›×© ×”×—×™×•×‘ ×”×—×“×©',0),(361281,10036,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î¼Î¹Î±Ï‚ Î½Î­Î±Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚ Chargeback Î±Î³Î¿ÏÎ¬',0),(361282,10036,'zh','åˆ›å»ºä¸€ä¸ªæ–°çš„æ‰£æ¬¾é‡‡è´­è®¢å•\r\n',0),(361283,10036,'sv','Skapa en ny inkÃ¶psorder fÃ¶r Ã¥terbetalning',0),(361284,10036,'it','Creare un nuovo ordine di acquisto di Chargeback',0),(361285,10036,'tl','',0),(361286,10036,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(361287,10036,'hi','à¤¬à¤¨à¤¾à¤à¤ à¤à¤• à¤¨à¤ˆ à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(361288,10036,'ms','Mencipta pesanan pembelian caj balik baru',0),(361289,10036,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ø´Ø±Ø§Ø¡ ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(361290,10036,'fr','CrÃ©er un nouvel ordre d\'achat de Chargeback',0),(361291,10036,'jp','æ–°ã—ã„ãƒãƒ£ãƒ¼ã‚¸ ãƒãƒƒã‚¯ç™ºæ³¨æ›¸ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(361292,10036,'pt','Criar uma nova ordem de compra de Chargeback',0),(361293,10036,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð½Ñ‹Ñ… Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(361294,10036,'es','Crear Un Nuevo Reintegro de Compra OC',0),(361295,10036,'de','Erstellen Sie eine neue Chargeback-Bestellung',0),(361296,10036,'en','Create a New Chargeback Purchase Order',0),(361297,10037,'is','',0),(361298,10037,'dr','(Ø´ØºÙ„) Ø¨Ø±Ú¯Ø´Øª Ø§Ø² ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯',0),(361299,10037,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙŠÙƒ  Ø±ÙˆØ´ (Ø´ØºÙ„) Ø¨Ø±Ú¯Ø´Øª Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯',0),(361300,10037,'tr','Yeni bir iÅŸ ters ibraz satÄ±nalma sipariÅŸi oluÅŸtur',0),(361301,10037,'pl','UtworzyÄ‡ nowe zamÃ³wienie zakupu Chargeback pracy',0),(361302,10037,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð½Ð° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(361303,10037,'ur','Ø§ÛŒÚ© Ù†Ø¦Û’ Ú©Ø§Ù… Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(361304,10037,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº Ð½Ð¾Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(361305,10037,'vi','Táº¡o ra má»™t cÃ´ng viá»‡c má»›i phÃ¡p bá»“i hoÃ n Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(361306,10037,'af','Skep \'n Nuwe Projek Terugbetaalbare Aankoopbestelling',0),(361307,10037,'ro','Crea o comandÄƒ de cumpÄƒrare de Chargeback Job',0),(361308,10037,'et','Uus tÃ¶Ã¶ sissenÃµudmine ostu tellimus',0),(361309,10037,'si','Ustvarite nov posel poraÄuna naroÄilnico',0),(361310,10037,'ba','Membuat Order Pembelian Chargeback pekerjaan baru',0),(361311,10037,'nl','Maak een nieuwe baan Chargeback inkooporder',0),(361312,10037,'fi','Luo uusi tyÃ¶ takaisinperinnÃ¤n ostotilaus',0),(361313,10037,'no','Opprette en ny jobb tilbakefÃ¸rsel bestilling',0),(361314,10037,'da','Opret en ny Job tilbagefÃ¸rslen indkÃ¸bsordre',0),(361315,10037,'ko','ìƒˆë¡œìš´ ì§ì—… í™˜ë¶ˆ êµ¬ë§¤ ì£¼ë¬¸',0),(361316,10037,'he','×¦×•×¨ ×”×–×ž× ×ª ×¨×›×© ×”×—×™×•×‘ ×¢×‘×•×“×” ×—×“×©×”',0),(361317,10037,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î¼Î¹Î±Ï‚ Î½Î­Î±Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚ Chargeback Î±Î³Î¿ÏÎ¬ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(361318,10037,'zh','åˆ›å»ºä¸€ä¸ªæ–°ä½œä¸šæ‰£æ¬¾é‡‡è´­è®¢å•\r\n',0),(361319,10037,'sv','Skapa en ny jobb Chargeback inkÃ¶psorder',0),(361320,10037,'it','Creare un nuovo ordine di acquisto di Chargeback di lavoro',0),(361321,10037,'tl','',0),(361322,10037,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‡à¸²à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(361323,10037,'hi','à¤¬à¤¨à¤¾à¤à¤ à¤à¤• à¤¨à¤ˆ à¤¨à¥Œà¤•à¤°à¥€ à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(361324,10037,'ms','Mencipta pesanan pembelian caj balik kerja baru',0),(361325,10037,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ø´Ø±Ø§Ø¡ ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(361326,10037,'fr','CrÃ©er de nouveaux emplois Chargeback commande',0),(361327,10037,'jp','æ–°ã—ã„ã‚¸ãƒ§ãƒ– ãƒãƒ£ãƒ¼ã‚¸ ãƒãƒƒã‚¯ã¯ç™ºæ³¨æ›¸ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(361328,10037,'pt','Criar uma nova ordem de compra de Chargeback de emprego',0),(361329,10037,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ Chargeback Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(361330,10037,'es','Crear Un Nuevo Reintegro de Compra de un Trabajo OC',0),(361331,10037,'de','Erstellen Sie eine neue Stelle Chargeback-Bestellung',0),(361332,10037,'en','Create a New Job Chargeback Purchase Order',0),(361333,10038,'is','',0),(361334,10038,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø±Ú¯Ø§Ù‡ Ù‡Ø§ÙŠ Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø²',0),(361335,10038,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙƒØ§Ø±Ú¯Ø§Ù‡ Ù‡Ø§ÙŠ Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø²',0),(361336,10038,'tr','Ä°nÅŸaat siteleri dÃ¼zenlemek',0),(361337,10038,'pl','Edytuj budÃ³w',0),(361338,10038,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¾Ð±ÐµÐºÑ‚Ð¸',0),(361339,10038,'ur','ØªØ¹Ù…ÛŒØ±Ø§ØªÛŒ Ù…Ù‚Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(361340,10038,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð³Ñ€Ð°Ð´Ð¸Ð»Ð¸ÑˆÑ‚Ð°',0),(361341,10038,'vi','Chá»‰nh sá»­a cÃ¡c trang web xÃ¢y dá»±ng',0),(361342,10038,'af','Redigeer Konstruksie Terreine',0),(361343,10038,'ro','Edita site-uri de constructii',0),(361344,10038,'et','Redigeeri ehitusplatsidel',0),(361345,10038,'si','Urejanje gradbiÅ¡Äih',0),(361346,10038,'ba','Mengedit situs konstruksi',0),(361347,10038,'nl','Bewerken van bouwplaatsen',0),(361348,10038,'fi','Muokkaa rakennustyÃ¶mailla',0),(361349,10038,'no','Redigere byggeplasser',0),(361350,10038,'da','Redigere byggepladser',0),(361351,10038,'ko','ê±´ì„¤ í˜„ìž¥ íŽ¸ì§‘',0),(361352,10038,'he','×¢×¨×™×›×ª ××ª×¨×™ ×‘× ×™×™×”',0),(361353,10038,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î± ÎµÏÎ³Î¿Ï„Î¬Î¾Î¹Î±',0),(361354,10038,'zh','ç¼–è¾‘å»ºç­‘åœ°ç›˜\r\n',0),(361355,10038,'sv','Redigera byggarbetsplatser',0),(361356,10038,'it','Modifica costruzione siti',0),(361357,10038,'tl','',0),(361358,10038,'th','à¹à¸à¹‰à¹„à¸‚à¸à¹ˆà¸­',0),(361359,10038,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¥à¤¥à¤²à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(361360,10038,'ms','Edit binaan.',0),(361361,10038,'ar','ØªØ­Ø±ÙŠØ± Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(361362,10038,'fr','Modifier les chantiers de Construction',0),(361363,10038,'jp','å»ºè¨­ç¾å ´ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(361364,10038,'pt','Editar Sites de construÃ§Ã£o',0),(361365,10038,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ð¿Ð»Ð¾Ñ‰Ð°Ð´Ð¾Ðº',0),(361366,10038,'es','Editar Sitios de ConstrucciÃ³n',0),(361367,10038,'de','Baustellen zu bearbeiten',0),(361368,10038,'en','Edit Construction Sites',0),(361369,10039,'is','',0),(361370,10039,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ø§ÙŠØª ',0),(361371,10039,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø³Ø§ÙŠØª ',0),(361372,10039,'tr','Site dÃ¼zenleme',0),(361373,10039,'pl','Edytowanie witryny',0),(361374,10039,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ°Ð¹Ñ‚',0),(361375,10039,'ur','ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(361376,10039,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(361377,10039,'vi','Chá»‰nh sá»­a trang web',0),(361378,10039,'af','Redigeer webwerf',0),(361379,10039,'ro','Edita site-ul',0),(361380,10039,'et','Muuda saidi',0),(361381,10039,'si','Uredi mesto',0),(361382,10039,'ba','Mengedit situs',0),(361383,10039,'nl','Site bewerken',0),(361384,10039,'fi','Muokata sivustoa',0),(361385,10039,'no','Redigere omrÃ¥det',0),(361386,10039,'da','Redigere hjemmesiden',0),(361387,10039,'ko','ì‚¬ì´íŠ¸ íŽ¸ì§‘',0),(361388,10039,'he','×¢×¨×•×š ××ª×¨',0),(361389,10039,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±Ï‚',0),(361390,10039,'zh','ç¼–è¾‘ç«™ç‚¹\r\n',0),(361391,10039,'sv','Redigera webbplats',0),(361392,10039,'it','Modifica sito',0),(361393,10039,'tl','',0),(361394,10039,'th','à¹à¸à¹‰à¹„à¸‚à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ',0),(361395,10039,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(361396,10039,'ms','Edit lokasi',0),(361397,10039,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(361398,10039,'fr','Modifier Site',0),(361399,10039,'jp','ã‚µã‚¤ãƒˆã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(361400,10039,'pt','Editar Site',0),(361401,10039,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ°Ð¹Ñ‚',0),(361402,10039,'es','Editar Sitio',0),(361403,10039,'de','Website bearbeiten',0),(361404,10039,'en','Edit Site',0),(361405,10040,'is','',0),(361406,10040,'dr','(Ù¾ÙˆÙ„ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¨Ù‡ Ù…Ø´ØªØ±ÙŠ',0),(361407,10040,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ú¯Ø´ØªÙŠ (Ù¾ÙˆÙ„ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¨Ù‡ Ù…Ø´ØªØ±ÙŠ',0),(361408,10040,'tr','Yeni ters ibraz',0),(361409,10040,'pl','Nowe obciÄ…Å¼enia',0),(361410,10040,'bg','ÐÐ¾Ð²Ð¸ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾',0),(361411,10040,'ur','Ù†ÛŒØ§ Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú©',0),(361412,10040,'sr','ÐÐ¾Ð²Ð¸ Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº',0),(361413,10040,'vi','Tiá»n chiáº¿t kháº¥u má»›i',0),(361414,10040,'af','Nuwe Chargeback',0),(361415,10040,'ro','Noi Chargeback',0),(361416,10040,'et','Uus sissenÃµudmine',0),(361417,10040,'si','Nov poraÄuna',0),(361418,10040,'ba','Chargeback baru',0),(361419,10040,'nl','Nieuwe Chargeback',0),(361420,10040,'fi','Uusi palautus',0),(361421,10040,'no','Nye tilbakefÃ¸ring',0),(361422,10040,'da','Nye tilbagefÃ¸rsel',0),(361423,10040,'ko','ìƒˆë¡œìš´ í™˜ë¶ˆ',0),(361424,10040,'he','×”×—×™×•×‘ ×”×—×“×©',0),(361425,10040,'el','ÎÎ­Î± Chargeback',0),(361426,10040,'zh','æ–°æ‰£æ¬¾\r\n',0),(361427,10040,'sv','Nya Ã¥terbetalning',0),(361428,10040,'it','Nuovo Chargeback',0),(361429,10040,'tl','',0),(361430,10040,'th','à¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(361431,10040,'hi','à¤¨à¤ˆ à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤•',0),(361432,10040,'ms','Caj-balik baru',0),(361433,10040,'ar','ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(361434,10040,'fr','Nouveau Chargeback',0),(361435,10040,'jp','æ–°ã—ã„ãƒãƒ£ãƒ¼ã‚¸ ãƒãƒƒã‚¯',0),(361436,10040,'pt','Chargeback novo',0),(361437,10040,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(361438,10040,'es','Nuevo Reintegro de Cobra',0),(361439,10040,'de','Neue Chargeback',0),(361440,10040,'en','New Chargeback',0),(361441,10041,'is','',0),(361442,10041,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¬Ø¯ÙŠØ¯ Ø´ØºÙ„',0),(361443,10041,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¬Ø¯ÙŠØ¯ Ø´ØºÙ„',0),(361444,10041,'tr','Yeni iÅŸ ters ibraz',0),(361445,10041,'pl','Nowe obciÄ…Å¼enia pracy',0),(361446,10041,'bg','ÐÐ¾Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾',0),(361447,10041,'ur','Ù†Ø¦ÛŒ Ø¬Ø§Ø¨ Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú©',0),(361448,10041,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾ Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº',0),(361449,10041,'vi','Má»›i cÃ´ng viá»‡c tiá»n chiáº¿t kháº¥u',0),(361450,10041,'af','Nuwe werk Chargeback',0),(361451,10041,'ro','Noul Job Chargeback',0),(361452,10041,'et','Uus tÃ¶Ã¶ sissenÃµudmine',0),(361453,10041,'si','Novo delo poraÄuna',0),(361454,10041,'ba','Chargeback pekerjaan baru',0),(361455,10041,'nl','Nieuwe baan Chargeback',0),(361456,10041,'fi','Uusi tyÃ¶ takaisinperinnÃ¤n',0),(361457,10041,'no','Ny jobb tilbakefÃ¸ring',0),(361458,10041,'da','Nye Job tilbagefÃ¸rsel',0),(361459,10041,'ko','ìƒˆë¡œìš´ ì§ì—… í™˜ë¶ˆ',0),(361460,10041,'he','×”×—×™×•×‘ ×¢×‘×•×“×” ×—×“×©×”',0),(361461,10041,'el','ÎÎ­Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Chargeback',0),(361462,10041,'zh','æ–°å»ºä½œä¸šæ‰£æ¬¾\r\n',0),(361463,10041,'sv','Nya jobbet Ã¥terbetalning',0),(361464,10041,'it','Nuovo lavoro Chargeback',0),(361465,10041,'tl','',0),(361466,10041,'th','à¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‡à¸²à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(361467,10041,'hi','à¤¨à¤ˆ à¤¨à¥Œà¤•à¤°à¥€ à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤•',0),(361468,10041,'ms','Caj-balik kerja yang baru',0),(361469,10041,'ar','ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(361470,10041,'fr','Nouveau Job Chargeback',0),(361471,10041,'jp','æ–°ã—ã„ã‚¸ãƒ§ãƒ–ã®ãƒãƒ£ãƒ¼ã‚¸ ãƒãƒƒã‚¯',0),(361472,10041,'pt','Novo trabalho Chargeback',0),(361473,10041,'ru','ÐÐ¾Ð²Ð°Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð½Ñ‹Ñ… Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(361474,10041,'es','Nuevo Trabajo Reintegro de Cobra',0),(361475,10041,'de','Neue Job-Chargeback',0),(361476,10041,'en','New Job Chargeback',0),(361477,10042,'is','',0),(361478,10042,'dr','Ø³Ø§ÙŠØª Ø¬Ø¯ÙŠØ¯',0),(361479,10042,'pr','Ø³Ø§ÙŠØª Ø¬Ø¯ÙŠØ¯',0),(361480,10042,'tr','Yeni Site',0),(361481,10042,'pl','Nowa strona',0),(361482,10042,'bg','ÐÐ¾Ð² ÑÐ°Ð¹Ñ‚',0),(361483,10042,'ur','Ù†Ø¦ÛŒ ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹',0),(361484,10042,'sr','ÐÐ¾Ð²Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(361485,10042,'vi','Trang web má»›i',0),(361486,10042,'af','Nuwe Webwerf',0),(361487,10042,'ro','Noul Site',0),(361488,10042,'et','Uus sait',0),(361489,10042,'si','Novo mesto',0),(361490,10042,'ba','Situs baru',0),(361491,10042,'nl','Nieuwe Site',0),(361492,10042,'fi','Uusi sivusto',0),(361493,10042,'no','Nytt nettsted',0),(361494,10042,'da','Nyt Site',0),(361495,10042,'ko','ìƒˆ ì‚¬ì´íŠ¸',0),(361496,10042,'he','××ª×¨ ×—×“×©',0),(361497,10042,'el','ÎÎ­Î¿ Site',0),(361498,10042,'zh','æ–°ç½‘ç«™\r\n',0),(361499,10042,'sv','Ny webbplats',0),(361500,10042,'it','Nuovo sito',0),(361501,10042,'tl','',0),(361502,10042,'th','à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¹ƒà¸«à¸¡à¹ˆ',0),(361503,10042,'hi','à¤¨à¤ˆ à¤¸à¤¾à¤‡à¤Ÿ',0),(361504,10042,'ms','Tapak baru',0),(361505,10042,'ar','Ù…ÙˆÙ‚Ø¹ Ø¬Ø¯ÙŠØ¯',0),(361506,10042,'fr','Nouveau Site',0),(361507,10042,'jp','æ–°ã—ã„ã‚µã‚¤ãƒˆ',0),(361508,10042,'pt','Novo Site',0),(361509,10042,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÑÐ°Ð¹Ñ‚',0),(361510,10042,'es','Nuevo Sitio',0),(361511,10042,'de','Neue Website',0),(361512,10042,'en','New Site',0),(361513,10043,'is','',0),(361514,10043,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù†Ø¨ÙˆØ¯ Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙŠØ§ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(361515,10043,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù†Ø¨ÙˆØ¯ Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ÙŠØ§ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(361516,10043,'tr','Ä°ÅŸ PO veya SB GL bÃ¼tÃ§elerini kontrol',0),(361517,10043,'pl','SprawdÅº budÅ¼ety GL-praca PO lub SB',0),(361518,10043,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ GL Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸ Ð·Ð°-Ð½ÐµÐ¿Ñ€Ð¾ÐµÐºÑ‚Ð½Ð° PO Ð¸Ð»Ð¸ SB',0),(361519,10043,'ur','Ø¬ÛŒØ¬Û’ ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) ØºÛŒØ± Ù…Ù„Ø§Ø²Ù…Øª Ù¾Ùˆ ÛŒØ§ SB Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(361520,10043,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð“Ð› Ð±ÑƒÑŸÐµÑ‚Ðµ Ð·Ð° ÐºÐ¾Ñ˜Ð¸ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÐ°Ð¾ ÐŸÐž Ð¸Ð»Ð¸ Ð¡Ð‘',0),(361521,10043,'vi','Kiá»ƒm tra GL ngÃ¢n sÃ¡ch cho cÃ´ng viá»‡c phÃ²ng khÃ´ng PO hoáº·c SB',0),(361522,10043,'af','Nasien van AG Begrotings vir Nie-Werkstuk AB of \"SB\"',0),(361523,10043,'ro','Verifica GL bugetele pentru Non-Job PO sau SB',0),(361524,10043,'et','Kontrollige GL eelarve tÃ¶Ã¶ PO vÃµi SB',0),(361525,10043,'si','Preverite GL proraÄunov za PO zaposlitev ali SB',0),(361526,10043,'ba','Periksa GL anggaran untuk PO bebas-pekerjaan atau SB',0),(361527,10043,'nl','GL budgetten voor niet-Job PO of SB controleren',0),(361528,10043,'fi','Tarkista GL budjetit-Job PO tai SB',0),(361529,10043,'no','Sjekk GL budsjetter for ikke-jobb PO eller SB',0),(361530,10043,'da','Kontrollere GL budgetter for ikke-Job PO eller SB',0),(361531,10043,'ko','ë¹„ ì§ì—… í¬ ë˜ëŠ” SB GL ì˜ˆì‚° í™•ì¸',0),(361532,10043,'he','×‘×“×•×§ GL ×ª×§×¦×™×‘×™× ×©××™× ×” ×¢×‘×•×“×”-×¤×• ××• SB',0),(361533,10043,'el','Î•Î»Î­Î³Î¾Ï„Îµ GL Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ Î³Î¹Î± Ï„Î· Î¼Î·-ÎµÏÎ³Î±ÏƒÎ¯Î± PO Î® SB',0),(361534,10043,'zh','æ£€æŸ¥éžåœ¨èŒè®¢å•æˆ–SBå‰å°”é¢„ç®—\r\n',0),(361535,10043,'sv','Kontrollera GL budgetar fÃ¶r icke-jobb PO eller SB',0),(361536,10043,'it','Controllare GL i bilanci per Non-lavoro PO o SB',0),(361537,10043,'tl','',0),(361538,10043,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“ GL à¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆà¸‡à¸²à¸™ PO à¸«à¸£à¸·à¸­ SB',0),(361539,10043,'hi','à¤œà¥€à¤à¤² à¤¬à¤œà¤Ÿ à¤—à¥ˆà¤° à¤•à¤¾à¤® à¤ªà¥‹ à¤¯à¤¾ SB à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(361540,10043,'ms','Semak bajet GL PO kerja atau SB',0),(361541,10043,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª GL Ù„Ø¨Ø±ÙŠØ¯ ØºÙŠØ± Ù…Ù‡Ù…Ø© Ø£Ùˆ Ø¨ÙŠÙ†Ø§Ù„ÙŠ Ø§Ù„Ø´Ø§Ø±Ù‚Ø©',0),(361542,10043,'fr','VÃ©rifier les Budgets GL pour Non-Job PO ou SB',0),(361543,10043,'jp','éžä»•äº‹ PO ã¾ãŸã¯ SB ã® GL äºˆç®—ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(361544,10043,'pt','Verificar os orÃ§amentos GL para emprego nÃ£o PO ou SB',0),(361545,10043,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ GL Ð±ÑŽÐ´Ð¶ÐµÑ‚Ñ‹ Ð´Ð»Ñ PO-Job Ð¸Ð»Ð¸ SB',0),(361546,10043,'es','Chequear Presupuestos LM para OC o SB Que no Son de un Trabajo',0),(361547,10043,'de','ÃœberprÃ¼fen Sie GL-Budgets fÃ¼r nicht-Job PO oder SB',0),(361548,10043,'en','Check GL Budgets for Non-Job PO or SB',0),(361549,10044,'is','',0),(361550,10044,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(361551,10044,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(361552,10044,'tr','Not kategori ekleme',0),(361553,10044,'pl','Dodaj kategoriÄ™ Uwaga',0),(361554,10044,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(361555,10044,'ur','Ù†ÙˆÙ¹ Ø²Ù…Ø±Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(361556,10044,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(361557,10044,'vi','ThÃªm ghi chÃº loáº¡i',0),(361558,10044,'af','Nota Kategorie Byvoeg',0),(361559,10044,'ro','Adauga nota categorie',0),(361560,10044,'et','Lisa mÃ¤rgete kategooria',0),(361561,10044,'si','Dodajte opombo Kategorija',0),(361562,10044,'ba','Tambahkan kategori catatan',0),(361563,10044,'nl','Opmerking categorie toevoegen',0),(361564,10044,'fi','LisÃ¤Ã¤ huomautus luokka',0),(361565,10044,'no','Legge til merknad kategori',0),(361566,10044,'da','TilfÃ¸j Note kategori',0),(361567,10044,'ko','ì°¸ê³  ë²”ì£¼ ì¶”ê°€',0),(361568,10044,'he','×œ×”×•×¡×™×£ ×”×¢×¨×” ×§×˜×’×•×¨×™×”...',0),(361569,10044,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(361570,10044,'zh','å¢žåŠ å¤‡æ³¨ç±»åˆ«\r\n',0),(361571,10044,'sv','LÃ¤gg till anteckning kategori',0),(361572,10044,'it','Aggiungi nota categoria',0),(361573,10044,'tl','',0),(361574,10044,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸›à¸£à¸°à¹€à¸ à¸—à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸',0),(361575,10044,'hi','à¤¨à¥‹à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(361576,10044,'ms','Tambah Kategori Nota',0),(361577,10044,'ar','Ø¥Ø¶Ø§ÙØ© ØªØµÙ†ÙŠÙ Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(361578,10044,'fr','Ajouter Note catÃ©gorie',0),(361579,10044,'jp','æ³¨ã‚«ãƒ†ã‚´ãƒªã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(361580,10044,'pt','Adicionar categoria nota',0),(361581,10044,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ Ð—Ð°Ð¼ÐµÑ‚Ð¾Ðº',0),(361582,10044,'es','Agregar CategorÃ­a de Notas',0),(361583,10044,'de','Hinweis Kategorie hinzufÃ¼gen',0),(361584,10044,'en','Add Note Category',0),(361585,10045,'is','',0),(361586,10045,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø¬Ø§Ø±ÙŠ ',0),(361587,10045,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø¬Ø§Ø±ÙŠ ',0),(361588,10045,'tr','GeÃ§erli Not kategorileri',0),(361589,10045,'pl','BieÅ¼Ä…cej kategorii Uwaga',0),(361590,10045,'bg','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(361591,10045,'ur','Ø­Ø§Ù„ÛŒÛ Ù†ÙˆÙ¹ Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(361592,10045,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ñƒ Ð¿Ð¾Ñ€ÑƒÐºÑƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(361593,10045,'vi','danh má»¥c ghi chÃº hiá»‡n nay',0),(361594,10045,'af','Huidige Nota KategoriÃ«',0),(361595,10045,'ro','Curent NotÄƒ categorii',0),(361596,10045,'et','Praeguse mÃ¤rkme Kategooriad',0),(361597,10045,'si','Trenutni Opomba kategorije',0),(361598,10045,'ba','Kategori Catatan Terkini',0),(361599,10045,'nl','Huidige opmerking CategorieÃ«n',0),(361600,10045,'fi','Nykyinen Huomautus Luokat',0),(361601,10045,'no','Gjeldende notat kategorier',0),(361602,10045,'da','Aktuelle Note kategorier',0),(361603,10045,'ko','í˜„ìž¬ ì°¸ê³  ë²”ì£¼',0),(361604,10045,'he','×§×˜×’×•×¨×™×•×ª ×”×¢×¨×” ×”× ×•×›×—×™',0),(361605,10045,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(361606,10045,'zh','æœ¬è¯´æ˜Žåˆ†ç±»\r\n',0),(361607,10045,'sv','Nuvarande Obs kategorier',0),(361608,10045,'it','Corrente nota categorie',0),(361609,10045,'tl','',0),(361610,10045,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸›à¸£à¸°à¹€à¸ à¸—à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(361611,10045,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¨à¥‹à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(361612,10045,'ms','Semasa Nota kategori',0),(361613,10045,'ar','Ø§Ù„ÙØ¦Ø§Øª Ø§Ù„Ù…Ø°ÙƒØ±Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(361614,10045,'fr','CatÃ©gories actuelles de Note',0),(361615,10045,'jp','ç¾åœ¨ã®ãƒ¡ãƒ¢ã®ã‚«ãƒ†ã‚´ãƒª',0),(361616,10045,'pt','Categorias de nota atual',0),(361617,10045,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð—Ð°Ð¼ÐµÑ‚Ð¾Ðº',0),(361618,10045,'es','CategorÃ­as de Notas Actuales',0),(361619,10045,'de','Aktuelle Hinweis-Kategorien',0),(361620,10045,'en','Current Note Categories',0),(361621,10046,'is','',0),(361622,10046,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª',0),(361623,10046,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª',0),(361624,10046,'tr','Not kategorileri',0),(361625,10046,'pl','Uwaga Kategorie',0),(361626,10046,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(361627,10046,'ur','Ù†ÙˆÙ¹ Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(361628,10046,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(361629,10046,'vi','ghi chÃº má»¥c lá»¥c',0),(361630,10046,'af','Nota KategoriÃ«',0),(361631,10046,'ro','NotÄƒ categorii',0),(361632,10046,'et','MÃ¤rkus kategooria',0),(361633,10046,'si','Opomba kategorije',0),(361634,10046,'ba','Kategori Catatan',0),(361635,10046,'nl','Opmerking CategorieÃ«n',0),(361636,10046,'fi','Huomautus Luokat',0),(361637,10046,'no','Merk kategoriene',0),(361638,10046,'da','BemÃ¦rk kategorier',0),(361639,10046,'ko','ì°¸ê³  ë²”ì£¼',0),(361640,10046,'he','×”×¢×¨×” ×§×˜×’×•×¨×™×•×ª',0),(361641,10046,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(361642,10046,'zh','è¯´æ˜Žç±»åˆ«\r\n',0),(361643,10046,'sv','Obs kategorier',0),(361644,10046,'it','Nota categorie',0),(361645,10046,'tl','',0),(361646,10046,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸›à¸£à¸°à¹€à¸ à¸—',0),(361647,10046,'hi','à¤¨à¥‹à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(361648,10046,'ms','Kategori Nota',0),(361649,10046,'ar','ØªØµÙ†ÙŠÙØ§Øª Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(361650,10046,'fr','Remarque catÃ©gories',0),(361651,10046,'jp','ãƒ¡ãƒ¢ ã‚«ãƒ†ã‚´ãƒª',0),(361652,10046,'pt','Categorias de observaÃ§Ã£o',0),(361653,10046,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð—Ð°Ð¼ÐµÑ‚Ð¾Ðº',0),(361654,10046,'es','CategorÃ­as de Notas',0),(361655,10046,'de','Hinweis-Kategorien',0),(361656,10046,'en','Note Categories',0),(361657,10047,'is','',0),(361658,10047,'dr','Ú¯Ø±ÙˆÙ‡ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(361659,10047,'pr','Ú¯Ø±ÙˆÙ‡ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(361660,10047,'tr','Not Kategori baÅŸarÄ±yla silindi',0),(361661,10047,'pl','Uwaga kategorii przesâ”‚anie',0),(361662,10047,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(361663,10047,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù†ÙˆÙ¹ Ø²Ù…Ø±Û',0),(361664,10047,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(361665,10047,'vi','xÃ³a ghi chÃº má»¥c lá»¥c thÃ nh cÃ´ng',0),(361666,10047,'af','Nota Kategorie Suksesvol Geskrap',0),(361667,10047,'ro','NotÄƒ categorie ÅŸtearsÄƒ cu succes',0),(361668,10047,'et','MÃ¤rkus kategooria edukalt kustutatud',0),(361669,10047,'si','Opomba Kategorija uspeÅ¡no izbrisana',0),(361670,10047,'ba','Kategori catatan dihapus berhasil',0),(361671,10047,'nl','Opmerking categorie verwijderd',0),(361672,10047,'fi','Huomautus luokka poistettu',0),(361673,10047,'no','Merk kategorien slettet',0),(361674,10047,'da','BemÃ¦rk kategori slettet',0),(361675,10047,'ko','ì°¸ê³  ë²”ì£¼ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(361676,10047,'he','×”×¢×¨×” ×‘×§×˜×’×•×¨×™×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(361677,10047,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(361678,10047,'zh','è¯´æ˜Žç±»åˆ«å·²åˆ é™¤æˆåŠŸ\r\n',0),(361679,10047,'sv','Obs kategorin raderades',0),(361680,10047,'it','Nota categoria eliminato con successo',0),(361681,10047,'tl','',0),(361682,10047,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸›à¸£à¸°à¹€à¸ à¸—à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(361683,10047,'hi','à¤¨à¥‹à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(361684,10047,'ms','Nota kategori dihapuskan dengan jayanya',0),(361685,10047,'ar','Ø­Ø°Ù ØªØµÙ†ÙŠÙ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(361686,10047,'fr','Remarque catÃ©gorie supprimÃ©e avec succÃ¨s',0),(361687,10047,'jp','ãƒ¡ãƒ¢ ã‚«ãƒ†ã‚´ãƒªã‚’å‰Šé™¤ã—ã¾ã—ãŸ',0),(361688,10047,'pt','Categoria nota apagada com sucesso',0),(361689,10047,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð—Ð°Ð¼ÐµÑ‚Ð¾Ðº Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½Ð°',0),(361690,10047,'es','CategorÃ­a de Nota Eliminada Exiosamene',0),(361691,10047,'de','Hinweis-Kategorie erfolgreich gelÃ¶scht',0),(361692,10047,'en','Note Category Deleted Successfully',0),(361693,10048,'is','',0),(361694,10048,'dr','Ú¯Ø±ÙˆÙ‡ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(361695,10048,'pr','Ú¯Ø±ÙˆÙ‡ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(361696,10048,'tr','Not Kategori baÅŸarÄ±yla kaydedildi',0),(361697,10048,'pl','Uwaga kategorii zapisane',0),(361698,10048,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(361699,10048,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ù†ÙˆÙ¹ Ø²Ù…Ø±Û',0),(361700,10048,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(361701,10048,'vi','lÆ°u ghi chÃº má»¥c lá»¥c thÃ nh cÃ´ng',0),(361702,10048,'af','Nota Kategorie Suksesvol Gestoor',0),(361703,10048,'ro','Nota categoria salvat cu succes',0),(361704,10048,'et','MÃ¤rkus kategooria edukalt salvestatud',0),(361705,10048,'si','Opomba Kategorija uspeÅ¡no shranjen',0),(361706,10048,'ba','Kategori catatan yang disimpan berhasil',0),(361707,10048,'nl','Opmerking categorie opgeslagen',0),(361708,10048,'fi','Huomautus luokka tallennettu',0),(361709,10048,'no','Merk kategorien lagret',0),(361710,10048,'da','BemÃ¦rk kategori gemt med succes',0),(361711,10048,'ko','ì°¸ê³  ë²”ì£¼ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(361712,10048,'he','×”×¢×¨×” ×‘×§×˜×’×•×¨×™×” ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(361713,10048,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(361714,10048,'zh','è¯´æ˜Žç±»åˆ«ä¿å­˜æˆåŠŸ\r\n',0),(361715,10048,'sv','Obs kategorin sparats',0),(361716,10048,'it','Nota categoria salvato correttamente',0),(361717,10048,'tl','',0),(361718,10048,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸›à¸£à¸°à¹€à¸ à¸—à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(361719,10048,'hi','à¤¨à¥‹à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(361720,10048,'ms','Kategori nota yang berjaya disimpan',0),(361721,10048,'ar','Ø­ÙØ¸ ØªØµÙ†ÙŠÙ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(361722,10048,'fr','CatÃ©gorie note enregistrÃ© avec succÃ¨s',0),(361723,10048,'jp','æ³¨ã‚«ãƒ†ã‚´ãƒªãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(361724,10048,'pt','Categoria nota salva com sucesso',0),(361725,10048,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð—Ð°Ð¼ÐµÑ‚Ð¾Ðº Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð°',0),(361726,10048,'es','CategorÃ­a de Nota Guardada Exiosamene',0),(361727,10048,'de','Hinweis-Kategorie erfolgreich gespeichert',0),(361728,10048,'en','Note Category Saved Successfully',0),(361729,10049,'is','',0),(361730,10049,'dr','Ø§Ù†ÙˆØ§Ø¹ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª',0),(361731,10049,'pr','Ø§Ù†ÙˆØ§Ø¹ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª',0),(361732,10049,'tr','Not tÃ¼rleri',0),(361733,10049,'pl','TypÃ³w notatek',0),(361734,10049,'bg','Ð’Ð¸Ð´Ð¾Ð²Ðµ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(361735,10049,'ur','Ù†ÙˆÙ¹ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(361736,10049,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸',0),(361737,10049,'vi','cÃ¡c loáº¡i ghi chÃº',0),(361738,10049,'af','Nota Tipes',0),(361739,10049,'ro','Tipuri de note',0),(361740,10049,'et','MÃ¤rkme tÃ¼Ã¼pidest',0),(361741,10049,'si','Vrst beleÂ¾k',0),(361742,10049,'ba','Jenis catatan',0),(361743,10049,'nl','Opmerking typen',0),(361744,10049,'fi','Muistiinpanon tyyppi',0),(361745,10049,'no','Merknadstyper',0),(361746,10049,'da','Notetyper',0),(361747,10049,'ko','ì°¸ê³  ìœ í˜•',0),(361748,10049,'he','×”×¢×¨×” ×¡×•×’×™×',0),(361749,10049,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· Ï„ÏÏ€Î¿Ï…Ï‚',0),(361750,10049,'zh','æ³¨ç±»åž‹\r\n',0),(361751,10049,'sv','Noteringstyper',0),(361752,10049,'it','Tipi di nota',0),(361753,10049,'tl','',0),(361754,10049,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸',0),(361755,10049,'hi','à¤¨à¥‹à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(361756,10049,'ms','Nota',0),(361757,10049,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø©',0),(361758,10049,'fr','Types de notes',0),(361759,10049,'jp','ãƒ¡ãƒ¢åž‹',0),(361760,10049,'pt','Tipos de nota',0),(361761,10049,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð—Ð°Ð¼ÐµÑ‚Ð¾Ðº',0),(361762,10049,'es','Tipos de Notas',0),(361763,10049,'de','Hinweis-Typen',0),(361764,10049,'en','Note Types',0),(361765,10050,'is','',0),(361766,10050,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(361767,10050,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(361768,10050,'tr','Kategori adÄ± girmelisiniz',0),(361769,10050,'pl','NaleÅ¼y wprowadziÄ‡ nazwÄ™ kategorii',0),(361770,10050,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(361771,10050,'ur','Ø¢Ù¾ Ù†Û’ Ø§ÛŒÚ© Ù‚Ø³Ù… Ú©Ø§ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(361772,10050,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð¼Ðµ',0),(361773,10050,'vi','Báº¡n pháº£i nháº­p tÃªn thá»ƒ loáº¡i',0),(361774,10050,'af','U moet \'n Kategorie Naam Invoer',0),(361775,10050,'ro','Trebuie sÄƒ introduceÅ£i un nume categorie',0),(361776,10050,'et','Te peate sisestama kategooria nime',0),(361777,10050,'si','Vnesti morate ime kategorije',0),(361778,10050,'ba','Anda harus memasukkan nama kategori',0),(361779,10050,'nl','U moet de categorienaam van een opgeven',0),(361780,10050,'fi','Kirjoita luokkanimi',0),(361781,10050,'no','Du mÃ¥ angi et kategorinavn',0),(361782,10050,'da','Du skal angive en kategorinavn',0),(361783,10050,'ko','ì¹´í…Œê³ ë¦¬ ì´ë¦„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(361784,10050,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×©× ×§×˜×’×•×¨×™×”',0),(361785,10050,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚',0),(361786,10050,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªåˆ†ç±»åç§°\r\n',0),(361787,10050,'sv','Du mÃ¥ste ange ett kategorinamn',0),(361788,10050,'it','Ãˆ necessario immettere un nome di categoria',0),(361789,10050,'tl','',0),(361790,10050,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­à¸«à¸¡à¸§à¸”à¸«à¸¡à¸¹à¹ˆ',0),(361791,10050,'hi','à¤†à¤ª à¤à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(361792,10050,'ms','Anda harus masukkan nama kategori',0),(361793,10050,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø¥Ø¯Ø®Ø§Ù„ Ø¥Ø³Ù… ØªØµÙ†ÙŠÙ',0),(361794,10050,'fr','Vous devez entrer un nom de catÃ©gorie.',0),(361795,10050,'jp','ã‚«ãƒ†ã‚´ãƒªåã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(361796,10050,'pt','VocÃª deve digitar um nome de categoria',0),(361797,10050,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(361798,10050,'es','Debe Entrar un Nombre de CategorÃ­a',0),(361799,10050,'de','Sie mÃ¼ssen einen Kategorienamen eingeben.',0),(361800,10050,'en','You Must Enter a Category Name',0),(361801,10051,'is','',0),(361802,10051,'dr','Ú¯Ø±ÙˆÙ‡ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯',0),(361803,10051,'pr','Ú¯Ø±ÙˆÙ‡ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯',0),(361804,10051,'tr','Kategori boÅŸ olmamalÄ±dÄ±r',0),(361805,10051,'pl','Kategoria nie moÅ¼e byÄ‡ pusta',0),(361806,10051,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ð¿Ñ€Ð°Ð·ÐµÐ½',0),(361807,10051,'ur','Ø²Ù…Ø±Û Ø®Ø§Ù„ÛŒ Ù†ÛÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(361808,10051,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð°Ð·Ð°Ð½',0),(361809,10051,'vi','Thá»ƒ loáº¡i khÃ´ng pháº£i lÃ  sáº£n pháº©m nÃ o',0),(361810,10051,'af','Kategorie Moet Nie Leeg Wees Nie',0),(361811,10051,'ro','Categoria nu trebuie sÄƒ fie gol',0),(361812,10051,'et','Kategooria ei tohi olla tÃ¼hi',0),(361813,10051,'si','Kategorija ne sme biti prazen',0),(361814,10051,'ba','Kategori tidak boleh kosong',0),(361815,10051,'nl','Categorie Must Not Be Empty',0),(361816,10051,'fi','Luokka ei voi olla tyhjÃ¤',0),(361817,10051,'no','Kategori mÃ¥ ikke vÃ¦re tomt',0),(361818,10051,'da','Kategori mÃ¥ ikke vÃ¦re tom',0),(361819,10051,'ko','ë²”ì£¼ëŠ” ë¹„ì›Œë‘˜ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ í•©ë‹ˆë‹¤.',0),(361820,10051,'he','×§×˜×’×•×¨×™×” ××™× ×• ×™×›×•×œ ×œ×”×™×•×ª ×¨×™×§',0),(361821,10051,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î´ÎµÎ½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ½ÏŒ',0),(361822,10051,'zh','åˆ†ç±»ä¸èƒ½ä¸ºç©º\r\n',0),(361823,10051,'sv','Kategori fÃ¥r inte vara tom',0),(361824,10051,'it','Categoria non deve essere vuoto',0),(361825,10051,'tl','',0),(361826,10051,'th','à¸›à¸£à¸°à¹€à¸ à¸—à¸•à¹‰à¸­à¸‡à¹„à¸¡à¹ˆà¸§à¹ˆà¸²à¸‡à¹€à¸›à¸¥à¹ˆà¸²',0),(361827,10051,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤°à¤¿à¤•à¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(361828,10051,'ms','Kategori tidak boleh kosong',0),(361829,10051,'ar','Ø§Ù„ØªØµÙ†ÙŠÙ ÙŠØ¬Ø¨ Ø£Ù† Ù„Ø§ ÙŠÙƒÙˆÙ† Ø®Ø§Ù„ÙŠØ§',0),(361830,10051,'fr','CatÃ©gorie ne doit pas Ãªtre vide',0),(361831,10051,'jp','ã‚«ãƒ†ã‚´ãƒªã¯ç©ºã«ã§ãã¾ã›ã‚“ã€‚',0),(361832,10051,'pt','Categoria nÃ£o deve estar vazia',0),(361833,10051,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÐÐµ Ð”Ð¾Ð»Ð¶Ð½Ð° Ð‘Ñ‹Ñ‚ÑŒ ÐŸÑƒÑÑ‚Ð°',0),(361834,10051,'es','CategorÃ­a No Debe Estar VacÃ­o',0),(361835,10051,'de','Kategorie darf nicht leer sein.',0),(361836,10051,'en','Category Must Not Be Empty',0),(361837,10052,'is','',0),(361838,10052,'dr','Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø´ØºÙ„ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø§Ø³Øª Ú¯Ø±ÙˆÙ‡ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯',0),(361839,10052,'pr','Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø´ØºÙ„ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø§Ø³Øª Ú¯Ø±ÙˆÙ‡ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯',0),(361840,10052,'tr','Ä°ÅŸ belirtildiÄŸinde Cateory mutlaka boÅŸ deÄŸil',0),(361841,10052,'pl','ArtykuÃ… musi nie byÄ‡ pusta, gdy okreÅ›lone zadanie',0),(361842,10052,'bg','Cateory Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð½Ðµ Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°Ð´Ð°Ð´ÐµÐ½',0),(361843,10052,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Ø§ Ø§Ø®ØªØµØ§Øµ Ø¶Ø±ÙˆØ±ÛŒ Ø­Ø¨Ø§Ù„Û Ø®Ø§Ù„ÛŒ Ù†Û ÛÙˆ ØªÙˆ',0),(361844,10052,'sr','Ð¦Ð°Ñ‚ÐµÐ¾Ñ€y Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð°Ð·Ð°Ð½ ÐºÐ°Ð´Ð° Ð¿Ð¾ÑÐ°Ð¾ Ð½Ð°Ð²ÐµÐ´ÐµÐ½',0),(361845,10052,'vi','Cateory pháº£i khÃ´ng cÃ³ sáº£n pháº©m nÃ o khi cÃ´ng viá»‡c chá»‰ Ä‘á»‹nh',0),(361846,10052,'af','Kategorie Moet Nie Leeg Wees Wanneer Werkstuk Gespesifiseer is Nie',0),(361847,10052,'ro','Cateory trebuie sÄƒ nu fie gol atunci cÃ¢nd Job specificate',0),(361848,10052,'et','Cateory Must ei ole tÃ¼hi, kui need tÃ¶Ã¶d',0),(361849,10052,'si','Cateory moÅ¡t ne biti prazno, ko delo doloÄena',0),(361850,10052,'ba','Cateory harus tidak menjadi kosong bila pekerjaan ditentukan',0),(361851,10052,'nl','Cateory Must Be Not Empty als baan opgegeven',0),(361852,10052,'fi','Cateory on ei saa olla tyhjÃ¤, kun mÃ¤Ã¤ritetty projekti',0),(361853,10052,'no','Cateory mÃ¥ vÃ¦re ikke tom nÃ¥r jobben angitt',0),(361854,10052,'da','Cateory mÃ¥ vÃ¦re ikke tom, nÃ¥r Job angivet',0),(361855,10052,'ko','Cateory í•´ì•¼ í•˜ì§€ ì•Šì„ ë¹ˆ ìž‘ì—… ì§€ì •',0),(361856,10052,'he','×—×•×‘×” Cateory ××™× ×• ×™×›×•×œ ×œ×”×™×•×ª ×¨×™×§ ×›××©×¨ ×”×¢×‘×•×“×” ×©×¦×•×™× ×”',0),(361857,10052,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Cateory, Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ½ÏŒ ÏŒÏ„Î±Î½ ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Î· ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(361858,10052,'zh','åˆ†ç±»ä¸èƒ½ä¸ºç©ºå½“å·¥ä½œæŒ‡å®š\r\n',0),(361859,10052,'sv','Cateory mÃ¥ste vara inte tomt nÃ¤r jobb anges',0),(361860,10052,'it','Cateory deve non essere vuota quando lavoro specificato',0),(361861,10052,'tl','',0),(361862,10052,'th','Cateory à¸•à¹‰à¸­à¸‡à¹„à¸¡à¹ˆà¸§à¹ˆà¸²à¸‡à¹€à¸›à¸¥à¹ˆà¸²à¹€à¸¡à¸·à¹ˆà¸­à¸‡à¸²à¸™',0),(361863,10052,'hi','à¤œà¤¬ à¤¨à¥Œà¤•à¤°à¥€ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ Cateory à¤šà¤¾à¤¹à¤¿à¤ à¤–à¤¾à¤²à¥€ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾',0),(361864,10052,'ms','Mesti Cateory tidak boleh kosong apabila kerja ditentukan',0),(361865,10052,'ar','ÙƒØ§ØªÙŠÙˆØ±ÙŠ ÙŠØ¬Ø¨ Ø£Ù† Ù„Ø§ ÙŠÙƒÙˆÙ† ÙØ§Ø±ØºØ§Ù‹ Ø¹Ù†Ø¯ ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ù…Ù‡Ù…Ø©',0),(361866,10052,'fr','Cateory doit ne pas Ãªtre vide lorsque le Job spÃ©cifiÃ©',0),(361867,10052,'jp','ã‚¸ãƒ§ãƒ–æŒ‡å®šã•ã‚Œã¦ã‚‚ Cateory ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ãŒç©ºã«ã•ã‚ŒãŸã§ãã¾ã›ã‚“ã€‚',0),(361868,10052,'pt','Cateory deve nÃ£o ser vazio quando trabalho especificado',0),(361869,10052,'ru','Cateory Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð½Ðµ Ð±Ñ‹Ñ‚ÑŒ Ð¿ÑƒÑÑ‚Ñ‹Ð¼ Ð¿Ñ€Ð¸ ÑƒÐºÐ°Ð·Ð°Ð½Ð¸Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(361870,10052,'es','CategorÃ­a No Debe Estar VacÃ­o Cuando el Trabajo EstÃ¡ Especificado',0),(361871,10052,'de','Cateory muss sein nicht leer, wenn Job angegeben',0),(361872,10052,'en','Cateory Must Not Be Empty When Job Specified',0),(361873,10053,'is','',0),(361874,10053,'dr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(361875,10053,'pr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(361876,10053,'tr','Maliyet kodu boÅŸ olmamalÄ±dÄ±r',0),(361877,10053,'pl','Koszt kodu nie moÅ¼e byÄ‡ pusta',0),(361878,10053,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÐºÐ¾Ð´ Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ð¿Ñ€Ð°Ð·ÐµÐ½',0),(361879,10053,'ur','Ù„Ø§Ú¯Øª Ú©ÙˆÚˆ Ø®Ø§Ù„ÛŒ Ù†ÛÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛØ¦Û’',0),(361880,10053,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¨Ð¸Ñ„Ñ€Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð°Ð·Ð°Ð½',0),(361881,10053,'vi','MÃ£ chi phÃ­ khÃ´ng pháº£i lÃ  sáº£n pháº©m nÃ o',0),(361882,10053,'af','Koste Kode Moet nie Leeg Wees',0),(361883,10053,'ro','Cost cod nu trebuie sÄƒ fie gol',0),(361884,10053,'et','Kulu kood ei tohi olla tÃ¼hi',0),(361885,10053,'si','StroÅ¡kovno Å¡ifra ne sme biti prazen',0),(361886,10053,'ba','Kode biaya tidak boleh kosong',0),(361887,10053,'nl','Kosten Code Must Not Be Empty',0),(361888,10053,'fi','Kustannuskoodi on oltava arvo',0),(361889,10053,'no','Pris koden kan ikke vÃ¦re tomt',0),(361890,10053,'da','Pris kode mÃ¥ ikke vÃ¦re tom',0),(361891,10053,'ko','ë¹„ìš©ëœ ì½”ë“œ ë¹„ì–´ ìžˆì–´ì•¼',0),(361892,10053,'he','×§×•×“ ×¢×œ×•×ª ××™× ×• ×™×›×•×œ ×œ×”×™×•×ª ×¨×™×§',0),(361893,10053,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ± Î´ÎµÎ½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ½ÏŒ',0),(361894,10053,'zh','æˆæœ¬ä»£ç ä¸èƒ½ä¸ºç©º\r\n',0),(361895,10053,'sv','Kostnad kod fÃ¥r inte vara tom',0),(361896,10053,'it','Codice costo non deve essere vuoto',0),(361897,10053,'tl','',0),(361898,10053,'th','à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™à¸•à¹‰à¸­à¸‡à¹„à¸¡à¹ˆà¸§à¹ˆà¸²à¸‡à¹€à¸›à¸¥à¹ˆà¸²',0),(361899,10053,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤°à¤¿à¤•à¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(361900,10053,'ms','Kod kos tidak boleh kosong',0),(361901,10053,'ar','ÙƒÙˆØ¯ Ø§Ù„ØªÙƒÙ„ÙØ© ÙŠØ¬Ø¨ Ø£Ù† Ù„Ø§ ÙŠÙƒÙˆÙ† ÙØ§Ø±ØºØ§Ù‹',0),(361902,10053,'fr','Code de coÃ»t ne doit pas Ãªtre vide',0),(361903,10053,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã¯ç©ºã«ã§ãã¾ã›ã‚“ã€‚',0),(361904,10053,'pt','CÃ³digo de custo nÃ£o deve estar vazio',0),(361905,10053,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´Ð° Ð½Ðµ Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ð¿ÑƒÑÑ‚Ñ‹Ð¼',0),(361906,10053,'es','CÃ³digo de Costo No Debe Ser VacÃ­o',0),(361907,10053,'de','Kosten-Code darf nicht leer sein.',0),(361908,10053,'en','Cost Code Must Not Be Empty',0),(361909,10054,'is','',0),(361910,10054,'dr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ÙˆÙ‚ØªÙŠ Ø´ØºÙ„ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(361911,10054,'pr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ÙˆÙ‚ØªÙŠ Ø´ØºÙ„ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(361912,10054,'tr','Zaman iÅŸ belirtilen maliyet kodu boÅŸ olmamalÄ±dÄ±r',0),(361913,10054,'pl','Koszt kodu musi byÄ‡ pusty nie po okreÅ›leniu zadanie',0),(361914,10054,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÐºÐ¾Ð´ Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°Ð´Ð°Ð´ÐµÐ½',0),(361915,10054,'ur','Ø¬Ø¨ Ú©Ø§Ù… Ø§Ø®ØªØµØ§ØµÛŒ Ù„Ø§Ú¯Øª Ú©ÙˆÚˆ Ø®Ø§Ù„ÛŒ Ù†ÛÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(361916,10054,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÑˆÐ¸Ñ„Ñ€Ð° Ð½Ðµ ÑÐ¼Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð°Ð·Ð°Ð½ ÐºÐ°Ð´Ð° Ð¿Ð¾ÑÐ°Ð¾ Ð½Ð°Ð²ÐµÐ´ÐµÐ½',0),(361917,10054,'vi','MÃ£ chi phÃ­ khÃ´ng pháº£i lÃ  sáº£n pháº©m nÃ o khi cÃ´ng viá»‡c chá»‰ Ä‘á»‹nh',0),(361918,10054,'af','Koste Kode Moet nie Leeg Wees Wanneer Werkstuk Gespesifiseer Word',0),(361919,10054,'ro','Cost cod nu trebuie sÄƒ fie gol atunci cÃ¢nd Job specificate',0),(361920,10054,'et','Kulu kood ei tohi olla tÃ¼hi, kui need tÃ¶Ã¶d',0),(361921,10054,'si','StroÅ¡kovno Å¡ifra ne sme biti prazen, ko delo doloÄena',0),(361922,10054,'ba','Kode biaya tidak boleh kosong bila pekerjaan ditentukan',0),(361923,10054,'nl','Kosten Code Must Not Be Empty als baan opgegeven',0),(361924,10054,'fi','Kustannuskoodi on oltava tyhjÃ¤ kun mÃ¤Ã¤ritetty projekti',0),(361925,10054,'no','Pris koden kan ikke vÃ¦re tom nÃ¥r jobben angitt',0),(361926,10054,'da','Pris kode mÃ¥ ikke vÃ¦re tom, nÃ¥r jobbet er angivet',0),(361927,10054,'ko','ë¹„ìš©ëœ ì½”ë“œ í•´ì„œëŠ” ì•ˆ ë¹ˆ ì¼ ì§€ì •',0),(361928,10054,'he','×§×•×“ ×¢×œ×•×ª ××™× ×• ×™×›×•×œ ×œ×”×™×•×ª ×¨×™×§ ×›××©×¨ ×”×¢×‘×•×“×” ×©×¦×•×™× ×”',0),(361929,10054,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ± Î´ÎµÎ½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ½ÏŒ ÏŒÏ„Î±Î½ ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Î· ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(361930,10054,'zh','æˆæœ¬ä»£ç ä¸èƒ½ä¸ºç©ºå½“å·¥ä½œæŒ‡å®š\r\n',0),(361931,10054,'sv','Kostnad kod fÃ¥r inte vara tomt nÃ¤r jobb anges',0),(361932,10054,'it','Codice costo non deve essere vuota quando lavoro specificato',0),(361933,10054,'tl','',0),(361934,10054,'th','à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™à¸•à¹‰à¸­à¸‡à¹„à¸¡à¹ˆà¸§à¹ˆà¸²à¸‡à¹€à¸›à¸¥à¹ˆà¸²à¹€à¸¡à¸·à¹ˆà¸­à¸‡à¸²à¸™',0),(361935,10054,'hi','à¤œà¤¬ à¤¨à¥Œà¤•à¤°à¥€ à¤¨à¤¿à¤°à¥à¤¦à¤¿à¤·à¥à¤Ÿ à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤°à¤¿à¤•à¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(361936,10054,'ms','Kod kos tidak boleh kosong apabila kerja ditentukan',0),(361937,10054,'ar','Ø±Ù…Ø² Ø§Ù„ØªÙƒÙ„ÙØ© Ù„Ø§ ÙŠØ¬Ø¨ Ø£Ù† ØªÙƒÙˆÙ† ÙØ§Ø±ØºØ© Ø¹Ù†Ø¯ ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ù…Ù‡Ù…Ø©',0),(361938,10054,'fr','Code de coÃ»t ne doit pas Ãªtre vide lorsque le Job spÃ©cifiÃ©',0),(361939,10054,'jp','ã‚¸ãƒ§ãƒ–ãŒæŒ‡å®šã•ã‚ŒãŸã¨ãã«ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã¯ç©ºã«ã§ãã¾ã›ã‚“ã€‚',0),(361940,10054,'pt','CÃ³digo de custo nÃ£o deve estar vazio quando trabalho especificado',0),(361941,10054,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´ Ð½Ðµ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, ÐºÐ¾Ð³Ð´Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ ÑƒÐºÐ°Ð·Ð°Ð½Ð¾',0),(361942,10054,'es','CÃ³digo de Costo No Debe Ser VacÃ­o Cuando Un Trabajo EstÃ¡ Especificado',0),(361943,10054,'de','Kosten-Code darf nicht leer sein, wenn Job angegeben',0),(361944,10054,'en','Cost Code Must Not Be Empty When Job Specified',0),(361945,10055,'is','',0),(361946,10055,'dr','Ø´ØºÙ„ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(361947,10055,'pr','Ø´ØºÙ„ Ù†Ø¨Ø§ÙŠØ¯ Ø®Ø§Ù„ÙŠ Ø¨Ø§Ø´Ø¯ ',0),(361948,10055,'tr','BoÅŸ iÅŸ deÄŸil gerekir olmak',0),(361949,10055,'pl','Zadanie nie moÅ¼e byÄ‡ puste',0),(361950,10055,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ñ€Ð°Ð·ÐµÐ½',0),(361951,10055,'ur','Ù†ÙˆÚ©Ø±ÛŒ Ú†Ø§ÛÛŒÛ’ Ù†Û Ø®Ø§Ù„ÛŒ Ø¬Ø§Ø¦Û’',0),(361952,10055,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð°Ð·Ð½Ð°',0),(361953,10055,'vi','CÃ´ng viá»‡c pháº£i khÃ´ng cÃ³ sáº£n pháº©m nÃ o',0),(361954,10055,'af','Werkstuk Mag Nie Leeg Wees Nie',0),(361955,10055,'ro','Job trebuie sÄƒ nu fie gol',0),(361956,10055,'et','TÃ¶Ã¶ peab ei vÃµi olla tÃ¼hi',0),(361957,10055,'si','Zaposlitev ne sme biti prazno',0),(361958,10055,'ba','Pekerjaan harus tidak menjadi kosong',0),(361959,10055,'nl','Baan moet niet worden leeg',0),(361960,10055,'fi','TyÃ¶ saa olla tyhjÃ¤',0),(361961,10055,'no','Jobben mÃ¥ ikke vÃ¦re tomt',0),(361962,10055,'da','Job mÃ¥ ikke vÃ¦re tom',0),(361963,10055,'ko','ìž‘ì—… í•´ì•¼ í•˜ì§€ ì•Šì„ ë¹ˆ',0),(361964,10055,'he','×”×¢×‘×•×“×” ×—×™×™×‘×ª ×œ× ×œ×”×™×•×ª ×¨×™×§',0),(361965,10055,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î´ÎµÎ½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎºÎµÎ½ÏŒ',0),(361966,10055,'zh','å·¥ä½œä¸èƒ½ä¸ºç©º\r\n',0),(361967,10055,'sv','Jobbet fÃ¥r inte vara tom',0),(361968,10055,'it','Lavoro non deve essere vuota',0),(361969,10055,'tl','',0),(361970,10055,'th','à¸‡à¸²à¸™à¸•à¹‰à¸­à¸‡à¹„à¸¡à¹ˆà¸§à¹ˆà¸²à¸‡à¹€à¸›à¸¥à¹ˆà¸²',0),(361971,10055,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¨à¤¹à¥€à¤‚ à¤šà¤¾à¤¹à¤¿à¤ à¤–à¤¾à¤²à¥€ à¤¹à¥‹',0),(361972,10055,'ms','Kerja mesti tidak kosong',0),(361973,10055,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© ÙŠØ¬Ø¨ Ø£Ù† Ù„Ø§ ØªÙƒÙˆÙ† ÙØ§Ø±ØºØ©',0),(361974,10055,'fr','Job ne doit ne pas Ãªtre vide',0),(361975,10055,'jp','ç©ºã§ã¯ãªã„å¿…è¦ãŒã‚ã‚Šã¾ã™ä»•äº‹',0),(361976,10055,'pt','Trabalho nÃ£o deve ser vazio',0),(361977,10055,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ Ð¿ÑƒÑÑ‚Ð°',0),(361978,10055,'es','Trabajo No Debe Ser VacÃ­o',0),(361979,10055,'de','Job darf nicht sein leer',0),(361980,10055,'en','Job Must Not be Empty',0),(361981,10056,'is','',0),(361982,10056,'dr','/ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´   Ø§Ø² Ø§Ø² Ø´ØºÙ„ Ø¯ÙŠÚ¯Ø± ',0),(361983,10056,'pr','ÙƒÙ¾ÙŠ Ø´ØºÙ„ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ / ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´   Ø§Ø² Ø§Ø² Ø´ØºÙ„ Ø¯ÙŠÚ¯Ø± ',0),(361984,10056,'tr','Kopya iÅŸ PO/SB diÄŸer iÅŸ',0),(361985,10056,'pl','Egzemplarz pracy PO/SB z innych miejsc pracy',0),(361986,10056,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚ PO/SB Ð¾Ñ‚ Ð´Ñ€ÑƒÐ³Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(361987,10056,'ur','Ø¯ÙˆØ³Ø±Û’ Ú©Û’ Ú©Ø§Ù… Ø³Û’ Ù…Ù„Ø§Ø²Ù…Øª Ù¾Ùˆ/SB Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(361988,10056,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾ÑÐ»Ð° ÐŸÐž/Ð¡Ð‘ Ð¸Ð· Ð´Ñ€ÑƒÐ³Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(361989,10056,'vi','sao chÃ©p Job PO/SB tá»« khÃ¡c Job khÃ¡c ',0),(361990,10056,'af','Kopieer Werkstuk AB/\"SB\" vanaf \'n Ander Werkstuk',0),(361991,10056,'ro','Copie Job PO/SB la alte locuri de muncÄƒ',0),(361992,10056,'et','TÃ¶Ã¶ PO/SB kopeerida teiste tÃ¶Ã¶d',0),(361993,10056,'si','Delo PO/SB kopirati iz drugih delovnih',0),(361994,10056,'ba','Menyalin pekerjaan PO/SB dari pekerjaan lainnya',0),(361995,10056,'nl','Baan PO/SB kopiÃ«ren van andere baan',0),(361996,10056,'fi','Kopioi tyÃ¶ PO/SB muuta tyÃ¶tÃ¤',0),(361997,10056,'no','Kopiere jobb PO/SB fra andre jobb',0),(361998,10056,'da','Kopiere Job PO/SB fra andre Job',0),(361999,10056,'ko','ë‹¤ë¥¸ ì§ìž¥ì—ì„œ ì¼ í¬/SBë¥¼ ë³µì‚¬',0),(362000,10056,'he','×”×¢×ª×§ ×”×¢×‘×•×“×” ×¤×•/SB ×ž×›×œ ×¢×‘×•×“×” ××—×¨×ª',0),(362001,10056,'el','Î‘Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ PO/SB Î±Ï€ÏŒ Î¬Î»Î»Î· Î¸Î­ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(362002,10056,'zh','ä»Žå…¶ä»–å·¥ä½œå¤å°ä½œä¸šè®¢å•/æœåŠ¡å…¬å‘Š\r\n',0),(362003,10056,'sv','Kopiera jobb PO/SB frÃ¥n andra jobb',0),(362004,10056,'it','Copia lavoro PO/SB da altro lavoro',0),(362005,10056,'tl','',0),(362006,10056,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¸‡à¸²à¸™ PO/SB à¸ˆà¸²à¸à¸‡à¸²à¸™à¸­à¸·à¹ˆà¸™ à¹†',0),(362007,10056,'hi','à¤…à¤¨à¥à¤¯ à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¥‡ à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¥‹/SB à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(362008,10056,'ms','Kerja salinan PO/SB dari kerja lain',0),(362009,10056,'ar','Ù†Ø³Ø® Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø¨Ùˆ/SB Ù…Ù† Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø£Ø®Ø±Ù‰',0),(362010,10056,'fr','Copier le travail PO/SB d\'autres emplois',0),(362011,10056,'jp','ä»–ã®ã‚¸ãƒ§ãƒ–ã‹ã‚‰ã‚¸ãƒ§ãƒ– PO/SB ã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(362012,10056,'pt','Copiar trabalho PO/SB de outro trabalho',0),(362013,10056,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ PO/SB Ñ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(362014,10056,'es','Copiar Trabajo OC/SB Del Otro Trabajo',0),(362015,10056,'de','Job PO/SB von andere Stelle kopieren',0),(362016,10056,'en','Copy Job PO/SB from Other Job',0),(362017,10057,'is','',0),(362018,10057,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(362019,10057,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(362020,10057,'tr','GL hesabÄ± girmeniz gerekir',0),(362021,10057,'pl','NaleÅ¼y wprowadziÄ‡ konto GL',0),(362022,10057,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ð° GL',0),(362023,10057,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(362024,10057,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ñ€Ð°Ñ‡ÑƒÐ½ Ñƒ Ð“Ð›',0),(362025,10057,'vi','Báº¡n Pháº£i Nháº­p má»™t tÃ i khoáº£n GL',0),(362026,10057,'af','U Moet \'n AG Rekening Invoer',0),(362027,10057,'ro','Trebuie sÄƒ introduceÅ£i un cont GL',0),(362028,10057,'et','Te peate sisestama pearaamtu konto',0),(362029,10057,'si','Vnesite raÄun GL',0),(362030,10057,'ba','Anda harus memasukkan rekening GL',0),(362031,10057,'nl','U moet een GL-Account invoeren',0),(362032,10057,'fi','Kirjoita Kirjanpitotilin pÃ¤Ã¤tilin',0),(362033,10057,'no','Du mÃ¥ angi en gi-konto',0),(362034,10057,'da','Du skal angive en GL konto',0),(362035,10057,'ko','GL ê³„ì •ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(362036,10057,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×—×©×‘×•×Ÿ GL',0),(362037,10057,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(362038,10057,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªæ€»å¸å¸æˆ·\r\n',0),(362039,10057,'sv','Du mÃ¥ste ange ett GL-konto',0),(362040,10057,'it','Ãˆ necessario immettere un Account GL',0),(362041,10057,'tl','',0),(362042,10057,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(362043,10057,'hi','à¤†à¤ªà¤•à¥‹ à¤à¤• GL à¤–à¤¾à¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(362044,10057,'ms','Anda mesti masukkan akaun GL',0),(362045,10057,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ¯Ø®Ù„ Ø­Ø³Ø§Ø¨ Ø£Ø³ØªØ§Ø° Ø¹Ø§Ù…',0),(362046,10057,'fr','Vous devez entrer un compte GL',0),(362047,10057,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(362048,10057,'pt','VocÃª deve digitar uma conta GL',0),(362049,10057,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL',0),(362050,10057,'es','Debe Entrar una Cuenta LM',0),(362051,10057,'de','Sie mÃ¼ssen ein GL-Konto eingeben.',0),(362052,10057,'en','You Must Enter a GL Account',0),(362053,10058,'is','',0),(362054,10058,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡  Ø¯ÙØªØ± ÙƒÙ„ Ú†Ù†Ø¯ Ø´Ø±ÙƒØªÙŠ',0),(362055,10058,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡  Ø¯ÙØªØ± ÙƒÙ„ Ú†Ù†Ø¯ Ø´Ø±ÙƒØªÙŠ',0),(362056,10058,'tr','Multicompany GL gÃ¼nlÃ¼ÄŸÃ¼ ekleme',0),(362057,10058,'pl','Multicompany GL dziennika dodaÄ‡',0),(362058,10058,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° multicompany GL Ð´Ð½ÐµÐ²Ð½Ð¸Ðº',0),(362059,10058,'ur','Ù…Ù„Ù¹Ú©ÙˆÙ…Ù¾Ù†ÛŒ Ø¬ÛŒØ¬Û’ Ø¬Ø±Ù†Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(362060,10058,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¼ÑƒÐ»Ñ‚Ð¸Ñ†Ð¾Ð¼Ð¿Ð°Ð½y Ð“Ð›',0),(362061,10058,'vi','ThÃªm giao dá»‹ch sá»• cÃ¡i cÃ´ng ty Ä‘a quá»‘c gia',0),(362062,10058,'af','Multi-onderneming AG Joernaal Skep',0),(362063,10058,'ro','Multisocietate GL jurnal Adauga',0),(362064,10058,'et','Multicompany GL tÃ¶Ã¶lehe lisamine',0),(362065,10058,'si','Multicompany GL Journal dodate',0),(362066,10058,'ba','Tambahkan multicompany GL jurnal',0),(362067,10058,'nl','Multicompany GL Journal toevoegen',0),(362068,10058,'fi','Multicompany KP-pÃ¤ivÃ¤kirjassa lisÃ¤Ã¤',0),(362069,10058,'no','Multicompany GL Journal legge',0),(362070,10058,'da','Funktioner til flere GL Journal tilfÃ¸je',0),(362071,10058,'ko','Multicompany GL ì €ë„ ì¶”ê°€',0),(362072,10058,'he','×”×•×¡×£ ×™×•×ž×Ÿ multicompany GL',0),(362073,10058,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Multicompany Î»',0),(362074,10058,'zh','å¤šå…¬å¸æ€»å¸æ—¥å¿—æ–°å¢ž\r\n',0),(362075,10058,'sv','Multicompany GL tidning lÃ¤gga till',0),(362076,10058,'it','Aggiungi GL multiempresa Journal',0),(362077,10058,'tl','',0),(362078,10058,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸› multicompany',0),(362079,10058,'hi','Multicompany GL à¤œà¤°à¥à¤¨à¤² à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(362080,10058,'ms','Jurnal multicompany GL Tambah',0),(362081,10058,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚ÙŠØ¯ ÙŠÙˆÙ…ÙŠØ© Ù…ØªØ¹Ø¯Ø¯ Ø§Ù„Ø´Ø±ÙƒØ§Øª',0),(362082,10058,'fr','Ajouter Journal GL multisociÃ©tÃ©s',0),(362083,10058,'jp','çµã³ã¤ã„ãŸ GL ä»•è¨³å¸³ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(362084,10058,'pt','Adicionar jornal multiempresa GL',0),(362085,10058,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¼ÐµÐ¶Ð´Ñƒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¸Ð¼Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÐ¼Ð¸ GL Ð¶ÑƒÑ€Ð½Ð°Ð»',0),(362086,10058,'es','Agregar Diario de LM de Multiempresa',0),(362087,10058,'de','Multicompany GL-Journal hinzufÃ¼gen',0),(362088,10058,'en','Multicompany GL Journal Add',0),(362089,10059,'is','',0),(362090,10059,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø±ÙƒØª Ø¯ÙˆÙ…',0),(362091,10059,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø±ÙƒØª Ø¯ÙˆÙ…',0),(362092,10059,'tr','SELECT ikinci ÅŸirket',0),(362093,10059,'pl','Wybierz drugi firmy',0),(362094,10059,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð²Ñ‚Ð¾Ñ€Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(362095,10059,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Ø¯ÙˆØ³Ø±ÛŒ Ú©Ù…Ù¾Ù†ÛŒ',0),(362096,10059,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¾ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ðµ',0),(362097,10059,'vi','Chá»n cÃ´ng ty thá»© 2',0),(362098,10059,'af','Kies Tweede Onderneming',0),(362099,10059,'ro','SelectaÅ£i a doua companie',0),(362100,10059,'et','Vali teine ettevÃµte',0),(362101,10059,'si','Izberite drugo podjetje',0),(362102,10059,'ba','Pilih kedua perusahaan',0),(362103,10059,'nl','Selecteer tweede bedrijf',0),(362104,10059,'fi','Valitse toinen yritys',0),(362105,10059,'no','Velg andre selskap',0),(362106,10059,'da','VÃ¦lg andet selskab',0),(362107,10059,'ko','ë‘ ë²ˆì§¸ íšŒì‚¬ ì„ íƒ',0),(362108,10059,'he','×‘×—×¨ ×—×‘×¨×” ×©× ×™×”',0),(362109,10059,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎµÂµÏ†Î¬Î½Î¹ÏƒÎ·',0),(362110,10059,'zh','é€‰æ‹©ç¬¬äºŒå®¶å…¬å¸\r\n',0),(362111,10059,'sv','VÃ¤lj andra fÃ¶retag',0),(362112,10059,'it','Selezionare seconda compagnia',0),(362113,10059,'tl','',0),(362114,10059,'th','à¹€à¸¥à¸·à¸­à¸à¸—à¸µà¹ˆà¸ªà¸­à¸‡ à¸šà¸£à¸´à¸©à¸±à¸—',0),(362115,10059,'hi','à¤¦à¥‚à¤¸à¤°à¥€ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(362116,10059,'ms','Pilih kedua Syarikat',0),(362117,10059,'ar','Ø§Ø®ØªØ± Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø«Ø§Ù†ÙŠØ©',0),(362118,10059,'fr','SÃ©lectionnez deuxiÃ¨me compagnie',0),(362119,10059,'jp','2 ç•ªç›®ã®ä¼šç¤¾ã‚’é¸æŠž',0),(362120,10059,'pt','Selecione segunda companhia',0),(362121,10059,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð’Ñ‚Ð¾Ñ€ÑƒÑŽ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ',0),(362122,10059,'es','Selecciona La Segunda Empresa',0),(362123,10059,'de','Zweite Auswahl von Unternehmen',0),(362124,10059,'en','Select Second Company',0),(362125,10060,'is','',0),(362126,10060,'dr','ÙƒØ§Ø±Ø¨Ø± Ø¨Ù‡ Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø´Ø±ÙƒØª Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø¯Ø§Ø±Ø¯ ',0),(362127,10060,'pr','ÙƒØ§Ø±Ø¨Ø± Ø¨Ù‡ Ø¨ÙŠØ´ Ø§Ø² ÙŠÙƒ Ø´Ø±ÙƒØª Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø¯Ø§Ø±Ø¯ ',0),(362128,10060,'tr','KullanÄ±cÄ± eriÅŸimi daha fazla bir ÅŸirket yok',0),(362129,10060,'pl','UÅ¼ytkownik nie ma dostÄ™pu w wiÄ™cej niÅ¼ jednej firmy',0),(362130,10060,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ð½ÑÐ¼Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð² Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(362131,10060,'ur','ØµØ§Ø±Ù Ø±Ø³Ø§Ø¦ÛŒ Ø§ÛŒÚ© Ú©Ù…Ù¾Ù†ÛŒ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù†ÛÛŒÚº ÛÛ’',0),(362132,10060,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð½ÐµÐ¼Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ñƒ Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ñ˜ÐµÐ´Ð½Ð¾Ð³ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð°',0),(362133,10060,'vi','NgÆ°á»i dÃ¹ng khÃ´ng cÃ³ quyá»n truy cáº­p nhiá»u hÆ¡n 1 cÃ´ng ty',0),(362134,10060,'af','Gebruiker Het net Toegang tot Een Onderneming ',0),(362135,10060,'ro','Utilizatorul nu are acces la mai mult de o companie',0),(362136,10060,'et','Kasutajal on juurdepÃ¤Ã¤s rohkem kui Ã¼ks ettevÃµte',0),(362137,10060,'si','Uporabnik nima dostopa v veÄ kot eni druÅ¾bi',0),(362138,10060,'ba','Pengguna tidak memiliki akses di lebih dari satu perusahaan',0),(362139,10060,'nl','Gebruiker heeft geen toegang In meer dan Ã©Ã©n bedrijf',0),(362140,10060,'fi','KÃ¤yttÃ¤jÃ¤llÃ¤ ei ole pÃ¤Ã¤syÃ¤ enemmÃ¤n kuin yksi yritys',0),(362141,10060,'no','Brukeren har ikke tilgang i mer enn ett selskap',0),(362142,10060,'da','Brugeren har ikke adgang i mere end Ã©t selskab',0),(362143,10060,'ko','ì‚¬ìš©ìžëŠ” ì—†ë‹¤ ì ‘ê·¼ í•œ íšŒì‚¬ ë³´ë‹¤ ë”',0),(362144,10060,'he','×œ×ž×©×ª×ž×© ××™×Ÿ ×’×™×©×” ×™×•×ª×¨ ×ž××©×¨ ×—×‘×¨×” ××—×ª',0),(362145,10060,'el','Î§ÏÎ®ÏƒÏ„Î·Ï‚ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Î±Ï€ÏŒ Î¼Î¯Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(362146,10060,'zh','ç”¨æˆ·ä¸èƒ½è®¿é—®å¤šäºŽä¸€ä¸ªå…¬å¸',0),(362147,10060,'sv','AnvÃ¤ndaren har inte Ã¥tkomst i mer Ã¤n ett fÃ¶retag',0),(362148,10060,'it','Utente non ha accesso a piÃ¹ di una societÃ ',0),(362149,10060,'tl','',0),(362150,10060,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸‚à¹‰à¸²à¹ƒà¸™à¸¡à¸²à¸à¸à¸§à¹ˆà¸²à¸«à¸™à¸¶à¹ˆà¸‡ à¸šà¸£à¸´à¸©à¸±à¸—',0),(362151,10060,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤ªà¤¹à¥à¤à¤š à¤à¤• à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥‡ à¤­à¥€ à¤…à¤§à¤¿à¤• à¤®à¥‡à¤‚ à¤ªà¤¾à¤¸ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(362152,10060,'ms','Pengguna tidak mempunyai akses dalam lebih daripada satu syarikat',0),(362153,10060,'ar','Ù„ÙŠØ³ Ù„Ø¯Ù‰ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„ÙˆØµÙˆÙ„ ÙÙŠ Ø£ÙƒØ«Ø± Ù…Ù† Ø´Ø±ÙƒØ© ÙˆØ§Ø­Ø¯Ø©',0),(362154,10060,'fr','L\'utilisateur n\'a pas accÃ¨s Ã  plus qu\'une entreprise',0),(362155,10060,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ãŒ 1 ã¤ã®ä¼šç¤¾ã‚ˆã‚Šã‚‚å¤šãã®ã‚¢ã‚¯ã‚»ã‚¹ã‚’æŒã£ã¦ã„ã¾ã›ã‚“ã€‚',0),(362156,10060,'pt','UsuÃ¡rio nÃ£o tem acesso em mais de uma empresa',0),(362157,10060,'ru','Ð£ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ ÐÐµÑ‚ Ð”Ð¾Ð¿ÑƒÑÐºÐ° Ð‘Ð¾Ð»ÐµÐµ Ð§ÐµÐ¼ Ðš ÐžÐ´Ð½Ð¾Ð¹ Ð¤Ð¸Ñ€Ð¼Ðµ',0),(362158,10060,'es','Usuario No Tiene Acceso En MÃ¡s Que Una Empresa',0),(362159,10060,'de','Benutzer kann nicht mehr als ein Unternehmen zugreifen',0),(362160,10060,'en','User Does Not Have Access In More Than One Company',0),(362161,10061,'is','',0),(362162,10061,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª',0),(362163,10061,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª',0),(362164,10061,'tr','BÃ¼tÃ§e yÄ±lÄ± ayarlanmamÄ±ÅŸ',0),(362165,10061,'pl','Rok budÅ¼etowy nie zestaw',0),(362166,10061,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼',0),(362167,10061,'ur','Ø¨Ø¬Ù¹ Ø³Ø§Ù„ Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(362168,10061,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ Ð±ÑƒÑŸÐµÑ‚ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(362169,10061,'vi','KhÃ´ng cÃ³ ngÃ¢n sÃ¡ch nÄƒm',0),(362170,10061,'af','Begrotingsjaar Nie Gestel',0),(362171,10061,'ro','An bugetar nu Set',0),(362172,10061,'et','Eelarveaastal ei mÃ¤Ã¤ra',0),(362173,10061,'si','ProraÄunsko leto ni nastavljena',0),(362174,10061,'ba','Anggaran tahun tidak diatur',0),(362175,10061,'nl','Begrotingsjaar niet ingesteld',0),(362176,10061,'fi','Varainhoitovuoden aseteta',0),(362177,10061,'no','Budsjett Ã¥ret ikke angitt',0),(362178,10061,'da','RegnskabsÃ¥r ikke indstillet',0),(362179,10061,'ko','ì˜ˆì‚° í•´ ë†“ì§€',0),(362180,10061,'he','×ª×§×¦×™×‘ ×”×©× ×” ××™× ×• ×ž×•×’×“×¨',0),(362181,10061,'el','ÎŸÎ¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚ Ï€Î¿Ï… Î´ÎµÎ½',0),(362182,10061,'zh','é¢„ç®—å¹´åº¦æœªè®¾ç½®\r\n',0),(362183,10061,'sv','BudgetÃ¥ret inte instÃ¤lld',0),(362184,10061,'it','Anno di budget non impostato',0),(362185,10061,'tl','',0),(362186,10061,'th','à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸›à¸µ',0),(362187,10061,'hi','à¤¬à¤œà¤Ÿ à¤µà¤°à¥à¤· à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(362188,10061,'ms','Tahun belanjawan tidak disetkan',0),(362189,10061,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(362190,10061,'fr','Exercice pas dÃ©finie',0),(362191,10061,'jp','äºˆç®—å¹´åº¦ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(362192,10061,'pt','ExercÃ­cio orÃ§amental nÃ£o definido',0),(362193,10061,'ru','Ð“Ð¾Ð´Ð¾Ð²Ð¾Ð¹ Ð‘ÑŽÐ´Ð¶ÐµÑ‚ ÐÐµ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(362194,10061,'es','AÃ±o de Presupesto No Configurado',0),(362195,10061,'de','Haushaltsjahr ist nicht festgelegt.',0),(362196,10061,'en','Budget Year Not Set',0),(362197,10062,'is','',0),(362198,10062,'dr','Ù†Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª',0),(362199,10062,'pr','Ù†Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª',0),(362200,10062,'tr','BÃ¼tÃ§e adÄ± ayarlÄ± deÄŸil',0),(362201,10062,'pl','Nazwa budÅ¼etu nie zestaw',0),(362202,10062,'bg','ÐÐµ Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¾ Ð¸Ð¼Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(362203,10062,'ur','Ø¨Ø¬Ù¹ Ú©Ø§ Ù†Ø§Ù… Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(362204,10062,'sr','Ð˜Ð¼Ðµ Ð±ÑƒÑŸÐµÑ‚Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(362205,10062,'vi','NgÃ¢n sÃ¡ch tÃªn khÃ´ng Ä‘Æ°á»£c thiáº¿t láº­p',0),(362206,10062,'af','Begrotingnaam nie Gestel',0),(362207,10062,'ro','Nume buget nu setaÅ£i',0),(362208,10062,'et','Eelarve nimi pole seatud',0),(362209,10062,'si','Ime predraÄuna ni nastavljena',0),(362210,10062,'ba','Nama anggaran tidak diatur',0),(362211,10062,'nl','Naam artikelbudget niet ingesteld',0),(362212,10062,'fi','Budjetin nimi ei ole mÃ¤Ã¤ritetty',0),(362213,10062,'no','Budsjettnavnet ikke angitt',0),(362214,10062,'da','Budgetnavnet ikke indstillet',0),(362215,10062,'ko','ì˜ˆì‚° ì´ë¦„ì´ ì„¤ì • í•˜ì§€',0),(362216,10062,'he','×ª×§×¦×™×‘ ×©× ××™× ×• ×ž×•×’×“×¨',0),(362217,10062,'el','Î”ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(362218,10062,'zh','é¢„ç®—æœªè®¾ç½®åç§°\r\n',0),(362219,10062,'sv','Budgetnamnet inte instÃ¤lld',0),(362220,10062,'it','Nome budget non impostato',0),(362221,10062,'tl','',0),(362222,10062,'th','à¹„à¸¡à¹ˆà¸à¸³à¸«à¸™à¸”à¸Šà¸·à¹ˆà¸­à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“',0),(362223,10062,'hi','à¤¬à¤œà¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤® à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(362224,10062,'ms','Nama bajet tidak ditetapkan',0),(362225,10062,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ø³Ù… Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù„Ø§',0),(362226,10062,'fr','Nom de budget pas dÃ©finie',0),(362227,10062,'jp','äºˆç®—åãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(362228,10062,'pt','OrÃ§amento nome nÃ£o definido',0),(362229,10062,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð° ÐÐµ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾',0),(362230,10062,'es','Nombre de Presupuesto no EsttÃ¡ Deteminado',0),(362231,10062,'de','Haushalt Name wurde nicht festgelegt.',0),(362232,10062,'en','Budget Name Not Set',0),(362233,10063,'is','',0),(362234,10063,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù†ÙŠØ³Øª',0),(362235,10063,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù†ÙŠØ³Øª',0),(362236,10063,'tr','GL hesabÄ± bulunamadÄ±',0),(362237,10063,'pl','Nie moÅ¼na odnaleÅºÄ‡ konta GL',0),(362238,10063,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(362239,10063,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ùˆ ØªÙ„Ø§Ø´ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(362240,10063,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð“Ð›',0),(362241,10063,'vi','khÃ´ng thá»ƒ tÃ¬m tháº¥y sá»• cÃ¡i tÃ i khoáº£n',0),(362242,10063,'af','Nie Instaat om AG Rekening te Vind',0),(362243,10063,'ro','Nu am putut gÄƒsi GL cont',0),(362244,10063,'et','Pearaamatu kontot ei leitud',0),(362245,10063,'si','GL raÄuna ni bilo mogoÄe najti.',0),(362246,10063,'ba','Tidak dapat menemukan GL Account',0),(362247,10063,'nl','Konden niet vondst GL Account',0),(362248,10063,'fi','Ei lÃ¶ytÃ¤nyt Kirjanpitotilin pÃ¤Ã¤tilin',0),(362249,10063,'no','Finner ikke gi-konto',0),(362250,10063,'da','Kunne ikke finde GL konto',0),(362251,10063,'ko','GL ê³„ì •ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(362252,10063,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ×—×©×‘×•×Ÿ GL',0),(362253,10063,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(362254,10063,'zh','æ‰¾ä¸åˆ°æ€»å¸å¸æˆ·\r\n',0),(362255,10063,'sv','Kunde inte hitta GL konto',0),(362256,10063,'it','Non riusciva a trovare Account GL',0),(362257,10063,'tl','',0),(362258,10063,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸šà¸±à¸à¸Šà¸µ GL',0),(362259,10063,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(362260,10063,'ms','Tidak dapat mencari akaun GL',0),(362261,10063,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥ÙŠØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(362262,10063,'fr','N\'a pas trouvÃ© de compte GL',0),(362263,10063,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¦‹ã¤ã‘ã‚‰ã‚Œã¾ã›ã‚“ã§ã—ãŸã€‚',0),(362264,10063,'pt','NÃ£o foi possÃ­vel encontrar conta GL',0),(362265,10063,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL',0),(362266,10063,'es','No Se Puede Encontrar la Cuenta LM',0),(362267,10063,'de','GL-Konto konnte nicht gefunden werden.',0),(362268,10063,'en','Could Not Find GL Account',0),(362269,10064,'is','',0),(362270,10064,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(362271,10064,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯ ',0),(362272,10064,'tr','GL bÃ¼tÃ§e verileri baÅŸarÄ±yla alÄ±ndÄ±',0),(362273,10064,'pl','GL budÅ¼etu dane zaimportowane pomyÅ›lnie',0),(362274,10064,'bg','GL Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(362275,10064,'ur','Ø¬ÛŒØ¬Û’ Ø¨Ø¬Ù¹ Ú©ÙˆØ§Ø¦Ù Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯',0),(362276,10064,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ²ÐµÐ·ÐµÐ½Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð±ÑƒÑŸÐµÑ‚Ñƒ Ð“Ð›',0),(362277,10064,'vi','Nháº­p sá»‘ liá»‡u TK ngÃ¢n sÃ¡ch thÃ nh cÃ´ng',0),(362278,10064,'af','AG Begrotingsdata Suksesvol Ingevoer',0),(362279,10064,'ro','GL buget datele importate cu succes',0),(362280,10064,'et','GL eelarveandmeid imporditakse edukalt',0),(362281,10064,'si','Podatke o proraÄunu GL uspeÅ¡no uvoÅ¾en',0),(362282,10064,'ba','GL anggaran Data berhasil diimpor',0),(362283,10064,'nl','GL begrotingsgegevens geÃ¯mporteerd',0),(362284,10064,'fi','GL budjettitiedot tuonti onnistui',0),(362285,10064,'no','GL budsjettdata importert',0),(362286,10064,'da','GL budgetdata importeret',0),(362287,10064,'ko','GL ì˜ˆì‚° ë°ì´í„°ë¥¼ ì„±ê³µì ìœ¼ë¡œ ê°€ì ¸ì™”ëŠ”ë°',0),(362288,10064,'he','× ×ª×•× ×™ ×ª×§×¦×™×‘ GL ×™×•×‘××• ×‘×”×¦×œ×—×”',0),(362289,10064,'el','GL Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(362290,10064,'zh','æ€»å¸é¢„ç®—æ•°æ®å¯¼å…¥æˆåŠŸ\r\n',0),(362291,10064,'sv','GL budgetdata har importerats',0),(362292,10064,'it','Dati di bilancio GL importati correttamente',0),(362293,10064,'tl','',0),(362294,10064,'th','GL à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(362295,10064,'hi','à¤œà¥€à¤à¤² à¤¬à¤œà¤Ÿ à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤¯à¤¾à¤¤',0),(362296,10064,'ms','Data bajet GL yang berjaya diimport',0),(362297,10064,'ar','Ø¥Ø³ØªÙŠØ±Øª Ø¨ÙŠØ§Ù†Ø§Øª Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ø¨Ù†Ø¬Ø§Ø­',0),(362298,10064,'fr','GL Budget donnÃ©es importÃ©es avec succÃ¨s',0),(362299,10064,'jp','GL äºˆç®—ãƒ‡ãƒ¼ã‚¿ãŒæ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã¾ã—ãŸ',0),(362300,10064,'pt','GL orÃ§amento dados importados com Ãªxito',0),(362301,10064,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð¾Ð² Ð“Ðš Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹ ',0),(362302,10064,'es','LM Datos de Presupuesto Importados Exitosamente',0),(362303,10064,'de','GL-Budget-Daten wurden erfolgreich importiert',0),(362304,10064,'en','GL Budget Data Imported Successfully',0),(362305,10065,'is','',0),(362306,10065,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(362307,10065,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(362308,10065,'tr','GL bÃ¼tÃ§eleri iÃ§eri',0),(362309,10065,'pl','Importuj budÅ¼ety K/G',0),(362310,10065,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸, GL',0),(362311,10065,'ur','Ø¬ÛŒØ¬Û’ ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹) Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(362312,10065,'sr','Ð“Ð› Ð±ÑƒÑŸÐµÑ‚Ðµ',0),(362313,10065,'vi','nháº­p ngÃ¢n sÃ¡ch sá»• cÃ¡i',0),(362314,10065,'af','Invoer van AG Begrotings',0),(362315,10065,'ro','Bugetele de GL import',0),(362316,10065,'et','GL eelarveid',0),(362317,10065,'si','Uvozite predraÄune GL',0),(362318,10065,'ba','Impor GL anggaran',0),(362319,10065,'nl','GL budgetten importeren',0),(362320,10065,'fi','Budjettien tuomisen GL',0),(362321,10065,'no','Importere GL budsjetter',0),(362322,10065,'da','IndlÃ¦se budgetter, GL',0),(362323,10065,'ko','ê°€ì ¸ì˜¤ê¸° GL ì˜ˆì‚°',0),(362324,10065,'he','×™×™×‘×•× GL ×ª×§×¦×™×‘×™×',0),(362325,10065,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® GL Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(362326,10065,'zh','å¯¼å…¥æ€»å¸é¢„ç®—\r\n',0),(362327,10065,'sv','Importera GL budgetar',0),(362328,10065,'it','Importare i budget GL',0),(362329,10065,'tl','',0),(362330,10065,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(362331,10065,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚ GL à¤¬à¤œà¤Ÿ',0),(362332,10065,'ms','Import GL belanjawan',0),(362333,10065,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(362334,10065,'fr','Importer des Budgets GL',0),(362335,10065,'jp','GL äºˆç®—ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(362336,10065,'pt','Importar orÃ§amentos GL',0),(362337,10065,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð¾Ð² Ð“Ðš',0),(362338,10065,'es','Importar presupuestos de LM',0),(362339,10065,'de','Import-GL-Budgets',0),(362340,10065,'en','Import GL Budgets',0),(362341,10066,'is','',0),(362342,10066,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(362343,10066,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(362344,10066,'tr','GL bÃ¼tÃ§e Excel dosyasÄ±nÄ± seÃ§in',0),(362345,10066,'pl','Wybierz plik programu Excel budÅ¼etu GL',0),(362346,10066,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ GL Ð±ÑŽÐ´Ð¶ÐµÑ‚ Excel Ñ„Ð°Ð¹Ð»',0),(362347,10066,'ur','Ø¬ÛŒØ¬Û’ Ø¨Ø¬Ù¹ Excel Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(362348,10066,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð“Ð› Ð±ÑƒÑŸÐµÑ‚Ð° Ð•xÑ†ÐµÐ» Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(362349,10066,'vi','Chá»n táº­p tin excel ngÃ¢n sÃ¡ch GL',0),(362350,10066,'af','Selekteer AG Begroting Excel LÃªer',0),(362351,10066,'ro','SelectaÅ£i GL fiÅŸier Excel buget',0),(362352,10066,'et','Valige GL eelarve Exceli fail',0),(362353,10066,'si','Izberite datoteko Excel proraÄuna GL',0),(362354,10066,'ba','Pilih File Excel GL anggaran',0),(362355,10066,'nl','Selecteer GL begroting Excel-bestand',0),(362356,10066,'fi','Valitse GL talousarvion Excel-tiedosto',0),(362357,10066,'no','Velg GL budsjett Excel-fil',0),(362358,10066,'da','VÃ¦lg GL Budget Excel fil',0),(362359,10066,'ko','GL ì˜ˆì‚° ì—‘ì…€ íŒŒì¼ ì„ íƒ',0),(362360,10066,'he','×‘×—×¨ ×§×•×‘×¥ Excel ×ª×§×¦×™×‘ GL',0),(362361,10066,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±ÏÏ‡ÎµÎ¯Î¿ Excel Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï GL',0),(362362,10066,'zh','é€‰æ‹©æ€»å¸é¢„ç®—Excelæ–‡ä»¶\r\n',0),(362363,10066,'sv','VÃ¤lj GL Budget Excel-fil',0),(362364,10066,'it','Selezionare il File di Excel bilancio GL',0),(362365,10066,'tl','',0),(362366,10066,'th','à¹€à¸¥à¸·à¸­à¸à¹à¸Ÿà¹‰à¸¡ Excel à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(362367,10066,'hi','à¤œà¥€à¤à¤² à¤¬à¤œà¤Ÿ Excel à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(362368,10066,'ms','Pilih fail Excel GL bajet',0),(362369,10066,'ar','Ø­Ø¯Ø¯ Ù…Ù„Ù Excel Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© GL',0),(362370,10066,'fr','SÃ©lectionnez le fichier Excel GL Budget',0),(362371,10066,'jp','GL äºˆç®— Excel ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã—ã¾ã™',0),(362372,10066,'pt','Selecione o arquivo de Excel de orÃ§amento GL',0),(362373,10066,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Excel Ð¤Ð°Ð¹Ð» Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð° Ð“Ðš',0),(362374,10066,'es','Selecciona File de Excel del Presupuesto LM',0),(362375,10066,'de','WÃ¤hlen Sie GL-Budget-Excel-Datei',0),(362376,10066,'en','Select GL Budget Excel File',0),(362377,10067,'is','',0),(362378,10067,'dr','Ù…Ù‚Ø¯Ø§Ø±  Ø¨Ø±Ú¯Ø´Øª Ù‡Ø²ÙŠÙ†Ù‡',0),(362379,10067,'pr','Ù…Ù‚Ø¯Ø§Ø±  Ø¨Ø±Ú¯Ø´Øª Ù‡Ø²ÙŠÙ†Ù‡',0),(362380,10067,'tr','Chargeback tutar',0),(362381,10067,'pl','Kwota obciÄ…Å¼enia zwrotnego',0),(362382,10067,'bg','Ð‘Ð°Ðº ÑÑƒÐ¼Ð°',0),(362383,10067,'ur','Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ù…Ù‚Ø¯Ø§Ø±',0),(362384,10067,'sr','Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº Ð¸Ð·Ð½Ð¾Ñ',0),(362385,10067,'vi','Sá»‘ tiá»n chiáº¿t kháº¥u',0),(362386,10067,'af','Chargeback bedrag',0),(362387,10067,'ro','Suma de chargeback',0),(362388,10067,'et','SissenÃµudmine suurus',0),(362389,10067,'si','Znesek poraÄuna',0),(362390,10067,'ba','Jumlah chargeback',0),(362391,10067,'nl','Chargeback bedrag',0),(362392,10067,'fi','TakaisinperintÃ¤summa',0),(362393,10067,'no','TilbakefÃ¸ring belÃ¸p',0),(362394,10067,'da','TilbagefÃ¸rslen belÃ¸b',0),(362395,10067,'ko','í™˜ë¶ˆ ê¸ˆì•¡',0),(362396,10067,'he','×¡×›×•× ×”×—×™×•×‘',0),(362397,10067,'el','Î Î¿ÏƒÏŒ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(362398,10067,'zh','é€€æ¬¾é‡‘é¢\r\n',0),(362399,10067,'sv','Ã…terbetalning belopp',0),(362400,10067,'it','QuantitÃ  di chargeback',0),(362401,10067,'tl','',0),(362402,10067,'th','à¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(362403,10067,'hi','à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤°à¤¾à¤¶à¤¿',0),(362404,10067,'ms','Jumlah caj semula',0),(362405,10067,'ar','ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ù…Ø¨Ù„Øº',0),(362406,10067,'fr','Montant de la facturation interne',0),(362407,10067,'jp','ãƒãƒ£ãƒ¼ã‚¸ ãƒãƒƒã‚¯é‡‘é¡',0),(362408,10067,'pt','Quantidade de chargeback',0),(362409,10067,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(362410,10067,'es','Monto de Reintegro de Cobro',0),(362411,10067,'de','Chargeback Betrag',0),(362412,10067,'en','Chargeback Amount',0),(362413,10068,'is','',0),(362414,10068,'dr','Ø¢ÙŠØ§ Ø§Ø² Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨ÙŠØ´ØªØ± Ø§Ø³Øª ',0),(362415,10068,'pr','Ø¢ÙŠØ§ Ø§Ø² Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨ÙŠØ´ØªØ± Ø§Ø³Øª ',0),(362416,10068,'tr','BÃ¼tÃ§enin Ã¼zerindedir',0),(362417,10068,'pl','Jest nad budÅ¼etem',0),(362418,10068,'bg','Ð• Ð½Ð°Ð´ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(362419,10068,'ur','Ø¨Ø¬Ù¹ Ù¾Ø± ÛÛ’ Û”',0),(362420,10068,'sr','ÐŸÑ€ÐµÐ¼Ð°ÑˆÐ¸Ð¾ Ð±ÑƒÑŸÐµÑ‚',0),(362421,10068,'vi','quÃ¡ ngÃ¢n sÃ¡ch',0),(362422,10068,'af','Oorskry Begroting',0),(362423,10068,'ro','Este peste bugetul',0),(362424,10068,'et','On eelarvest',0),(362425,10068,'si','Je nad proraÄunom',0),(362426,10068,'ba','Atas anggaran',0),(362427,10068,'nl','Boven het Budget',0),(362428,10068,'fi','Budjetin',0),(362429,10068,'no','Over budsjettet',0),(362430,10068,'da','Budgettet',0),(362431,10068,'ko','ì˜ˆì‚°ì„ ì´ˆê³¼ìž…ë‹ˆë‹¤.',0),(362432,10068,'he','×—×•×¨×’×ª ×ž×”×ª×§×¦×™×‘',0),(362433,10068,'el','ÎžÎµÏ€ÎµÏÎ½Î¿ÏÎ½ Ï„Î¿Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ',0),(362434,10068,'zh','è¶…å‡ºé¢„ç®—\r\n',0),(362435,10068,'sv','Ã–ver budgeten',0),(362436,10068,'it','Ãˆ fuori Budget',0),(362437,10068,'tl','',0),(362438,10068,'th','à¹€à¸à¸´à¸™à¸‡à¸š',0),(362439,10068,'hi','à¤¬à¤œà¤Ÿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¹à¥ˆ',0),(362440,10068,'ms','Lebih bajet',0),(362441,10068,'ar','Ù‡Ùˆ Ø£ÙƒØ«Ø± Ù…Ù† Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(362442,10068,'fr','Est au-dessus du Budget',0),(362443,10068,'jp','äºˆç®—ä¸Šã«ã‚ã‚Šã¾ã™ã€‚',0),(362444,10068,'pt','Ã‰ sobre o orÃ§amento',0),(362445,10068,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(362446,10068,'es','Es MÃ¡s que el Presupuesto',0),(362447,10068,'de','Budget',0),(362448,10068,'en','Is Over Budget',0),(362449,10069,'is','',0),(362450,10069,'dr','Ø¢ÙŠØ§ Ø§Ø² Ø¨ÙˆØ¯Ø¬Ù‡ Ù…Ø§Ù‡ Ø¨ÙŠØ´ØªØ± Ø§Ø³Øª ',0),(362451,10069,'pr','Ø¢ÙŠØ§ Ø§Ø² Ø¨ÙˆØ¯Ø¬Ù‡ Ù…Ø§Ù‡ Ø¨ÙŠØ´ØªØ± Ø§Ø³Øª ',0),(362452,10069,'tr','BÃ¼tÃ§eyi aÅŸan bir',0),(362453,10069,'pl','Jest nad budÅ¼etem na miesiÄ…c',0),(362454,10069,'bg','Ð• Ð½Ð°Ð´ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° Ð·Ð° Ð¼ÐµÑÐµÑ†',0),(362455,10069,'ur','Ø¨Ø¬Ù¹ Ù¾Ø± Ù…ÛÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ ÛÛ’ Û”',0),(362456,10069,'sr','ÐˆÐµ Ð¿Ñ€ÐµÐ¼Ð°ÑˆÐ¸Ð¾ Ð±ÑƒÑŸÐµÑ‚ Ð·Ð° Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(362457,10069,'vi','quÃ¡ ngÃ¢n sÃ¡ch cho thÃ¡ng',0),(362458,10069,'af','Oorskry Begroting vir Maand',0),(362459,10069,'ro','Este peste bugetul pentru luna',0),(362460,10069,'et','On eelarvest kuu',0),(362461,10069,'si','Je nad proraÄunom za mesec',0),(362462,10069,'ba','Adalah atas anggaran untuk bulan',0),(362463,10069,'nl','Is boven het Budget voor maand',0),(362464,10069,'fi','On budjetin kuukauden',0),(362465,10069,'no','Er Over budsjettet for mÃ¥neden',0),(362466,10069,'da','Er Over budgettet for mÃ¥ned',0),(362467,10069,'ko','ë‹¬ì— ëŒ€ í•œ ì˜ˆì‚°ì„ ì´ˆê³¼ìž…ë‹ˆë‹¤.',0),(362468,10069,'he','×—×•×¨×’×ª ×ž×”×ª×§×¦×™×‘ ×‘×ž×©×š ×—×•×“×©',0),(362469,10069,'el','Î•Î¯Î½Î±Î¹ Ï€Î­ÏÎ± Î±Ï€ÏŒ Ï„Î¿Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î³Î¹Î± Ï„Î¿ Î¼Î®Î½Î±',0),(362470,10069,'zh','è¶…å‡ºæœˆé¢„ç®—\r\n',0),(362471,10069,'sv','Ã„r Ã¶ver Budget fÃ¶r mÃ¥nad',0),(362472,10069,'it','Ãˆ fuori Budget per mese',0),(362473,10069,'tl','',0),(362474,10069,'th','à¹€à¸à¸´à¸™à¸à¸§à¹ˆà¸²à¸‡à¸šà¹€à¸”à¸·à¸­à¸™',0),(362475,10069,'hi','à¤®à¤¾à¤¹ à¤¬à¤œà¤Ÿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¹à¥ˆ',0),(362476,10069,'ms','Adalah lebih bajet untuk bulan',0),(362477,10069,'ar','Ù‡Ùˆ Ø£ÙƒØ«Ø± Ù…Ù† Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù„Ù„Ø´Ù‡Ø±',0),(362478,10069,'fr','Est sur le Budget pour le mois',0),(362479,10069,'jp','ä»Šæœˆã®äºˆç®—ã‚ªãƒ¼ãƒãƒ¼ã§ã™ã€‚',0),(362480,10069,'pt','Ã‰ sobre o orÃ§amento para o mÃªs',0),(362481,10069,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ ÐœÐµÑÑÑ‡Ð½Ñ‹Ð¹ Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(362482,10069,'es','Es MÃ¡s que el Presupuesto por el Mes',0),(362483,10069,'de','Ist Ã¼ber dem Budget fÃ¼r Monat',0),(362484,10069,'en','Is Over Budget for Month',0),(362485,10070,'is','',0),(362486,10070,'dr','Ø¢ÙŠØ§ Ø§Ø² Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ Ø¨ÙŠØ´ØªØ± Ø§Ø³Øª',0),(362487,10070,'pr','Ø¢ÙŠØ§ Ø§Ø² Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ Ø¨ÙŠØ´ØªØ± Ø§Ø³Øª',0),(362488,10070,'tr','BÃ¼tÃ§eyi yÄ±l olduÄŸunu',0),(362489,10070,'pl','Jest nad budÅ¼etem na rok',0),(362490,10070,'bg','Ð• Ð½Ð°Ð´ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(362491,10070,'ur','Ø³Ø§Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø¨Ø¬Ù¹ Ù¾Ø± ÛÛ’',0),(362492,10070,'sr','ÐˆÐµ Ð¿Ñ€ÐµÐ¼Ð°ÑˆÐ¸Ð¾ Ð±ÑƒÑŸÐµÑ‚ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(362493,10070,'vi','quÃ¡ ngÃ¢n sÃ¡ch cho nÄƒm',0),(362494,10070,'af','Oorskry Begroting vir Jaar',0),(362495,10070,'ro','Este peste bugetul pentru anul',0),(362496,10070,'et','Aasta eelarvest on',0),(362497,10070,'si','Je nad proraÄunom za leto',0),(362498,10070,'ba','Adalah atas anggaran untuk tahun',0),(362499,10070,'nl','Is ten opzichte van begroting voor het jaar',0),(362500,10070,'fi','On budjetin vuoden',0),(362501,10070,'no','Er Over budsjettet for Ã¥ret',0),(362502,10070,'da','Er Over budgettet for Ã¥r',0),(362503,10070,'ko','ì˜¬í•´ ì˜ˆì‚°ì„ ì´ˆê³¼ìž…ë‹ˆë‹¤.',0),(362504,10070,'he','× ×’×ž×¨ ×”×ª×§×¦×™×‘ ×œ×©× ×”',0),(362505,10070,'el','Î•Î¯Î½Î±Î¹ Ï€Î­ÏÎ± Î±Ï€ÏŒ Ï„Î¿Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚',0),(362506,10070,'zh','è¶…å‡ºå¹´é¢„ç®—\r\n',0),(362507,10070,'sv','Ã„r Ã¶ver Budget fÃ¶r Ã¥r',0),(362508,10070,'it','Ãˆ fuori Budget per anno',0),(362509,10070,'tl','',0),(362510,10070,'th','à¹€à¸›à¹‡à¸™à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸µ',0),(362511,10070,'hi','à¤¬à¤œà¤Ÿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¥ˆ',0),(362512,10070,'ms','Adalah lebih bajet bagi tahun',0),(362513,10070,'ar','Ù‡Ùˆ Ø£ÙƒØ«Ø± Ù…Ù† Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù„Ù„Ø³Ù†Ø©',0),(362514,10070,'fr','Est sur le Budget pour l\'annÃ©e',0),(362515,10070,'jp','1 å¹´é–“ã®äºˆç®—ãŒ',0),(362516,10070,'pt','Ã‰ sobre o orÃ§amento para o ano',0),(362517,10070,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ Ð“Ð¾Ð´Ð¾Ð²Ð¾Ð¹ Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(362518,10070,'es','Es MÃ¡s que el Presupuesto por el AÃ±o',0),(362519,10070,'de','Ist Ã¼ber dem Budget fÃ¼r das Jahr',0),(362520,10070,'en','Is Over Budget for Year',0),(362521,10071,'is','',0),(362522,10071,'dr','ÙŠÙƒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(362523,10071,'pr','ÙŠÙƒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(362524,10071,'tr','BorÃ§lar Bill zaten bu ters ibraz PO iÃ§in oluÅŸturuldu. Bill mutlaka silinir Chargeback PO silmeden Ã¶nce ilk',0),(362525,10071,'pl','Rozliczenie zobowiÄ…zaÅ„ zostaÅ‚a juÅ¼ utworzona dla tego obciÄ…Å¼enia PO. Bill muszÄ… byÄ‡ usuniÄ™te przed usuniÄ™ciem Chargeback PO',0),(362526,10071,'bg','Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ¾Ð½ Ð²ÐµÑ‡Ðµ Ðµ Ð±Ð¸Ð» ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½ Ð·Ð° Ñ‚Ð°Ð·Ð¸ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ PO. Ð‘Ð¸Ð» Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð¿ÑŠÑ€Ð²Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ PO',0),(362527,10071,'ur','Ø§ÛŒÚ© Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø¨Ù„ Ù¾ÛÙ„Û’ ÛÛŒ Ø§Ø³ Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ú©ÛŒ Ù¾ÙˆØ³Ù¹ Ú©Û’ Ù„Ø¦Û’ Ø¨Ù†Ø§ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û” Ø¨Ù„ Ø¶Ø±ÙˆØ±ÛŒ Ø­Ø°Ù Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ù¾Ùˆ Ø­Ø°Ù Ú©Ø±Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’',0),(362528,10071,'sr','ÐÐ°Ñ†Ñ€Ñ‚ Ð·Ð°ÐºÐ¾Ð½Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ñ˜Ðµ Ð²ÐµÑ› ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð° Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº ÐŸÐ¾Ð°. Ð‘Ð¸Ð» Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½ Ð¿Ñ€Ð²Ð¸ Ð¿Ñ€Ðµ Ð±Ñ€Ð¸ÑÐ°ÑšÐ° Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº ÐŸÐž',0),(362529,10071,'vi','HÃ³a Ä‘Æ¡n CÃ¡c khoáº£n pháº£i tráº£ Ä‘Ã£ Ä‘Æ°á»£c táº¡o cho iá»tn chiáº¿t kháº¥u PO nÃ y.  Bill Pháº£i xÃ³a Äáº§u tiÃªn TrÆ°á»›c khi XÃ³a Tiá»n chiáº¿t kháº¥u PO',0),(362530,10071,'af','\'n Betaalbare Rekening is Alreeds Geskep vir hierdie Teruggestuurde AB.  Die Rekening moet Eers Geskrap word, Alvorens die Teruggestuurde AB Geskrap Word',0),(362531,10071,'ro','Un proiect de lege de datorii a fost deja creat pentru acest PO Chargeback. Proiect de lege trebuie sÄƒ fi ÅŸters prima Ã®nainte de a ÅŸterge Chargeback PO',0),(362532,10071,'et','VÃµlad Bill on juba loodud selle sissenÃµudmine PO. Arve tuleb kustutada enne kustutamist sissenÃµudmine PO',0),(362533,10071,'si','Obveznosti raÄun Å¾e bil ustvarjen za ta poraÄuna pad. Zakona mora biti izbrisan prvi spredaj izbris poraÄuna PO',0),(362534,10071,'ba','Tagihan hutang sudah telah dibuat untuk PO Chargeback ini. Bill harus dihapus terlebih dahulu sebelum menghapus Chargeback PO',0),(362535,10071,'nl','Een Bill schulden heeft al zijn gemaakt voor deze Chargeback PO. Bill moeten worden verwijderd eerst Chargeback PO verwijderen',0),(362536,10071,'fi','Ostovelkojen Bill on jo luotu takaisinperinnÃ¤n PO. Bill on poistettava ennen poistamista takaisinperinnÃ¤n PO',0),(362537,10071,'no','En gjeld regning er allerede opprettet for denne tilbakefÃ¸rsel PO. Bill mÃ¥ slettes fÃ¸r du sletter tilbakefÃ¸rsel PO',0),(362538,10071,'da','En gÃ¦ld Bill er allerede oprettet for denne tilbagefÃ¸rsel PO. Regningen skal slettes fÃ¸rst, fÃ¸r du sletter tilbagefÃ¸rslen PO',0),(362539,10071,'ko','ë¯¸ì§€ê¸‰ê¸ˆ ë¹Œì´ í™˜ë¶ˆ í¬ ì´ë¯¸ ë§Œë“¤ì–´ì¡ŒìŠµë‹ˆë‹¤. ë¹Œ í•´ì•¼ ì‚­ì œ í™˜ë¶ˆ í¬ë¥¼ ì‚­ì œ í•˜ê¸° ì „ì— ë¨¼ì €',0),(362540,10071,'he','×—×©×‘×•×Ÿ ×–×›××™× ×›×‘×¨ × ×•×¦×¨ ×¢×‘×•×¨ ×¤×• ×”×—×™×•×‘ ×”×–×”. ×‘×™×œ ×—×™×™×‘ ×œ×”×™×ž×—×§ ×”×¨××©×•×Ÿ ×œ×¤× ×™ ×ž×—×™×§×ª ×”×—×™×•×‘ ×¤×•',0),(362541,10071,'el','ÎˆÎ½Î± Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ Î­Ï‡ÎµÎ¹ Î®Î´Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸ÎµÎ¯ Î³Î¹Î± Î±Ï…Ï„ÏŒ Chargeback PO. Bill Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î´Î¹Î±Î³ÏÎ±Ï†Î¿ÏÎ½ Ï€ÏÏŽÏ„Î± Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Chargeback PO',0),(362542,10071,'zh','åº”ä»˜å¸å•å·²ç»è®¾å®šäº†è¿™ä¸ªæ‰£æ¬¾è®¢å•ã€‚åˆ é™¤æ‰£æ¬¾è®¢å•å‰é¦–å…ˆå¿…é¡»åˆ é™¤è´¦å•ã€‚\r\n',0),(362543,10071,'sv','En leverantÃ¶rsskulder Bill har redan skapats fÃ¶r denna Ã¥terbetalning PO. Bill mÃ¥ste tas bort fÃ¶rst innan du tar bort Chargeback PO',0),(362544,10071,'it','Un disegno di legge di debiti Ã¨ giÃ  stato creato per questo PO di Chargeback. Bill deve essere eliminato prima prima di eliminare il Chargeback PO',0),(362545,10071,'tl','',0),(362546,10071,'th','à¸¡à¸µà¸à¸²à¸£à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰à¸ªà¸³à¸«à¸£à¸±à¸š PO à¸™à¸µà¹‰à¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ à¸¥à¸šà¸•à¸±à¹‹à¸§à¸•à¹‰à¸­à¸‡à¹à¸£à¸à¸à¹ˆà¸­à¸™à¸—à¸µà¹ˆà¸ˆà¸°à¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸Šà¸³à',0),(362547,10071,'hi','à¤à¤• Payables à¤¬à¤¿à¤² à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤¸ à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤ªà¥‹ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤ à¤¬à¤¿à¤² à¤šà¤¾à¤¹à¤¿à¤ à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤œà¤¾ à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤ªà¥€à¤“ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤¸',0),(362548,10071,'ms','Rang undang-undang pemiutang telah dicipta untuk PO caj semula ini. Rang undang-undang mesti dihapuskan pertama sebelum menghapuskan caj balik PO',0),(362549,10071,'ar','ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡ \"ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¯ÙØ¹\" Ù…Ø³Ø¨Ù‚Ø§Ù‹ Ù„Ù‡Ø°Ø§ \"Ø¨Ùˆ ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ\". Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† ÙŠØ¬Ø¨ Ø£Ù† ØªØ­Ø°Ù Ø£ÙˆÙ„Ø§Ù‹ Ù‚Ø¨Ù„ Ø­Ø°Ù ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø¨Ùˆ',0),(362550,10071,'fr','Un projet de loi des comptes fournisseurs a dÃ©jÃ  Ã©tÃ© crÃ©Ã© pour ce PO de rÃ©trofacturation. Projet de loi doit Ãªtre supprimÃ©e avant suppression Chargeback PO',0),(362551,10071,'jp','ã“ã®ãƒãƒ£ãƒ¼ã‚¸ ãƒãƒƒã‚¯ PO ã§ã€è²·æŽ›é‡‘è«‹æ±‚æ›¸ãŒæ—¢ã«ä½œæˆã•ã‚Œã¾ã—ãŸã€‚è«‹æ±‚ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™å‰Šé™¤ PO ãƒãƒ£ãƒ¼ã‚¸ ãƒãƒƒã‚¯ã‚’å‰Šé™¤ã™ã‚‹å‰ã«ã€ã¾ãš',0),(362552,10071,'pt','JÃ¡ foi criado um projeto de lei de contas a pagar por este PO de Chargeback. Bill deve ser eliminado primeiro antes de excluir o Chargeback PO',0),(362553,10071,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ ÑƒÐ¶Ðµ Ð±Ñ‹Ð» ÑÐ¾Ð·Ð´Ð°Ð½ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð° PO. Ð—Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½ Ð¿ÐµÑ€Ð²Ñ‹Ð¹ Ð¿ÐµÑ€ÐµÐ´ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸ÐµÐ¼ Chargeback ',0),(362554,10071,'es','Un Recibo por Pagar Ya Se CreÃ³ Para Este OC de Reintegro de Cobro',0),(362555,10071,'de','Eine Kreditoren-Rechnung wurde bereits fÃ¼r dieses Chargeback-PO erstellt. Bill muss gelÃ¶scht werden erste vor dem LÃ¶schen Chargeback PO',0),(362556,10071,'en','A Payables Bill has Already been Created for this Chargeback PO. Bill Must Be Deleted First Before Deleting Chargeback PO',0),(362557,10072,'is','',0),(362558,10072,'dr','Ø¨Ø±ÙˆÙŠØ¯  Ø¨Ù‡ ØµÙØ­Ù‡ Ø¨Ø¹Ø¯ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ ',0),(362559,10072,'pr','Ø¨Ø±ÙˆÙŠØ¯  Ø¨Ù‡ ØµÙØ­Ù‡ Ø¨Ø¹Ø¯ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ ',0),(362560,10072,'tr','Onaylamak iÃ§in sonraki sayfaya git',0),(362561,10072,'pl','PrzejdÅº do nastÄ™pnej strony do zatwierdzenia',0),(362562,10072,'bg','ÐžÑ‚Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€ÑÐ²Ð°Ð½Ðµ',0),(362563,10072,'ur','Ø¬Ø§Ø¦ÛŒÚº Ø¨Ø·Ø±Ù Ø§Ú¯Ù„Ø§ ØµÙØ­Û Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯ÛŒÙ†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(362564,10072,'sr','Ð˜Ð´Ð¸ Ð½Ð° ÑÐ»ÐµÐ´ÐµÑ›Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ',0),(362565,10072,'vi','tá»›i trang tiáº¿p theo Ä‘á»ƒ duyá»‡t',0),(362566,10072,'af','Gaan na Volgende Bladsy om Goed te keur',0),(362567,10072,'ro','Du-te la pagina urmÄƒtoare pentru a aproba',0),(362568,10072,'et','Kinnitamiseks mine jÃ¤rgmisele lehele',0),(362569,10072,'si','Na naslednjo stran za odobritev',0),(362570,10072,'ba','Pergi ke halaman berikutnya untuk menyetujui',0),(362571,10072,'nl','Ga naar volgende pagina goed te keuren',0),(362572,10072,'fi','Siirry seuraavalle sivulle hyvÃ¤ksymÃ¤Ã¤n',0),(362573,10072,'no','GÃ¥ til neste side Ã¥ godkjenne',0),(362574,10072,'da','GÃ¥ til nÃ¦ste side for at godkende',0),(362575,10072,'ko','ìŠ¹ì¸ ë‹¤ìŒ íŽ˜ì´ì§€ë¡œ ì´ë™',0),(362576,10072,'he','×¢×‘×•×¨ ××œ ×”×“×£ ×”×‘× ×›×“×™ ×œ××©×¨',0),(362577,10072,'el','ÎœÎµÏ„Î¬Î²Î±ÏƒÎ· ÏƒÏ„Î·Î½ ÎµÏ€ÏŒÎ¼ÎµÎ½Î· ÏƒÎµÎ»Î¯Î´Î± Î½Î± ÎµÎ³ÎºÏÎ¯Î½ÎµÎ¹',0),(362578,10072,'zh','åˆ°ä¸‹ä¸€é¡µå®¡æ‰¹\r\n',0),(362579,10072,'sv','GÃ¥ till nÃ¤sta sida att godkÃ¤nna',0),(362580,10072,'it','Vai alla pagina successiva di approvare',0),(362581,10072,'tl','',0),(362582,10072,'th','à¹„à¸›à¸—à¸µà¹ˆà¸«à¸™à¹‰à¸²à¸–à¸±à¸”à¹„à¸›à¹€à¸žà¸·à¹ˆà¸­à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(362583,10072,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤—à¤²à¥‡ à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤œà¤¾à¤à¤',0),(362584,10072,'ms','Pergi ke halaman seterusnya untuk meluluskan',0),(362585,10072,'ar','Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰ Ø§Ù„ØµÙØ­Ø© Ø§Ù„ØªØ§Ù„ÙŠØ© Ù„Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰',0),(362586,10072,'fr','Aller Ã  la Page suivante pour approuver',0),(362587,10072,'jp','æ‰¿èªã™ã‚‹æ¬¡ã®ãƒšãƒ¼ã‚¸ã«è¡Œã',0),(362588,10072,'pt','Ir para prÃ³xima pÃ¡gina para aprovar',0),(362589,10072,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ðº ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑƒÑ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ',0),(362590,10072,'es','Va a la PrÃ³xima PÃ¡gina para Aprobar',0),(362591,10072,'de','Gehen Sie zur nÃ¤chsten Seite zu genehmigen',0),(362592,10072,'en','Go to Next Page to Approve',0),(362593,10073,'is','',0),(362594,10073,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ Ù…Ù†ØªØ¸Ø± ØªØ§ÙŠÙŠØ¯ ',0),(362595,10073,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ Ø¬Ø¯ÙŠØ¯ Ù…Ù†ØªØ¸Ø± ØªØ§ÙŠÙŠØ¯ ',0),(362596,10073,'tr','Onay bekleyen yeni PO',0),(362597,10073,'pl','Nowe PO czekajÄ…cych na akceptacjÄ™',0),(362598,10073,'bg','ÐÐ¾Ð²Ð¸ PO, Ñ‡Ð°ÐºÐ°Ñ‰Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(362599,10073,'ur','Ù†Ø¦ÛŒ Ù¾ÙˆØ³Ù¹ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ø±',0),(362600,10073,'sr','ÐÐ¾Ð²Ð¸ ÐŸÐž Ñ‡ÐµÐºÐ° Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(362601,10073,'vi','Chá» duyá»‡t Ä‘Æ¡n hÃ ng má»›i',0),(362602,10073,'af','Nuwe AB Wag op Goedkeuring',0),(362603,10073,'ro','Noi PO astepta aprobarea',0),(362604,10073,'et','Uus PO ootab heakskiitmist',0),(362605,10073,'si','Nov PO Äakajo na odobritev',0),(362606,10073,'ba','Baru PO menunggu persetujuan',0),(362607,10073,'nl','Nieuwe PO wachten goedkeuring',0),(362608,10073,'fi','Uuden PO odottaa hyvÃ¤ksyntÃ¤Ã¤',0),(362609,10073,'no','Nye PO venter pÃ¥ godkjenning',0),(362610,10073,'da','Nye PO venter pÃ¥ godkendelse',0),(362611,10073,'ko','ìƒˆë¡œìš´ PO ìŠ¹ì¸ ëŒ€ê¸°',0),(362612,10073,'he','×¤×• ×—×“×© ×ž×—×›×” ×œ××™×©×•×¨',0),(362613,10073,'el','ÎÎ­Î± PO Î±Î½Î±Î¼Î¿Î½Î® Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚',0),(362614,10073,'zh','æ–°çš„é‡‡è´­è®¢å•æ­£åœ¨ç­‰å¾…æ‰¹å‡†\r\n',0),(362615,10073,'sv','Nya PO vÃ¤ntar pÃ¥ godkÃ¤nnande',0),(362616,10073,'it','PO di nuovo in attesa di approvazione',0),(362617,10073,'tl','',0),(362618,10073,'th','PO à¹ƒà¸«à¸¡à¹ˆà¸—à¸µà¹ˆà¸£à¸­à¸à¸²à¸£à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(362619,10073,'hi','à¤¨à¤ˆ à¤ªà¥‹ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤‡à¤‚à¤¤à¤œà¤¼à¤¾à¤° à¤•à¤°',0),(362620,10073,'ms','PO baru yang menunggu kelulusan',0),(362621,10073,'ar','Ø¨Ùˆ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© ÙÙŠ Ø§Ù†ØªØ¸Ø§Ø± Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø©',0),(362622,10073,'fr','Nouveau PO en attente d\'approbation',0),(362623,10073,'jp','æ‰¿èªã‚’å¾…ã£ã¦ã„ã‚‹æ–°ã—ã„ PO',0),(362624,10073,'pt','PO de novo Ã¡ espera de aprovaÃ§Ã£o',0),(362625,10073,'ru','ÐÐ¾Ð²Ñ‹Ð¹ PO, Ð¾Ð¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ñ… ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(362626,10073,'es','Nuevo OC Esperando la AprobaciÃ³n',0),(362627,10073,'de','Neue PO warten Genehmigung',0),(362628,10073,'en','New PO Waiting Approval',0),(362629,10074,'is','',0),(362630,10074,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØ§ÙŠÙŠØ¯ Ø¯Ø§Ø±Ø¯',0),(362631,10074,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØ§ÙŠÙŠØ¯ Ø¯Ø§Ø±Ø¯',0),(362632,10074,'tr','DeÄŸiÅŸiklikleri Ã¶nce onay PO ihtiyacÄ±',0),(362633,10074,'pl','PO potrzebuje zgody przed zmianami',0),(362634,10074,'bg','PO ÑÐµ Ð½ÑƒÐ¶Ð´Ð°Ðµ Ð¾Ñ‚ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ, Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ',0),(362635,10074,'ur','Ù¾Ùˆ ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ø³Û’ Ù¾ÛÙ„Û’ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(362636,10074,'sr','ÐŸÐž Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ Ð¿Ñ€Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(362637,10074,'vi','Ä‘Æ¡n mua hÃ ng cáº§n duyá»‡t trÆ°á»›c khi thÃ y Ä‘á»•i',0),(362638,10074,'af','AB Nodig Goedkeuring Alvorens Veranderinge sal Reflekteer',0),(362639,10074,'ro','PO are nevoie de aprobare Ã®nainte de modificÄƒri',0),(362640,10074,'et','PO heaks kiitma enne muudatuste',0),(362641,10074,'si','PO potrebuje odobritev pred spremembami',0),(362642,10074,'ba','PO membutuhkan persetujuan sebelum perubahan',0),(362643,10074,'nl','PO moet goedkeuring voordat wijzigingen',0),(362644,10074,'fi','PO tulee hyvÃ¤ksyÃ¤ ennen kuin muutokset',0),(362645,10074,'no','PO trenger godkjenning fÃ¸r endringer',0),(362646,10074,'da','PO behov for godkendelse, fÃ¸r Ã¦ndringer',0),(362647,10074,'ko','ê°€ ë³€í™” í•˜ê¸° ì „ì— ìŠ¹ì¸ì´ í•„ìš”ë¡œ',0),(362648,10074,'he','×¤×• ×¦×¨×™×š ××™×©×•×¨ ×œ×¤× ×™ ×©×™× ×•×™×™×',0),(362649,10074,'el','PO Ï‡ÏÎµÎ¹Î¬Î¶ÎµÏ„Î±Î¹ Ï„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ· Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚',0),(362650,10074,'zh','è®¢å•å˜æ›´ä¹‹å‰éœ€è¦æ‰¹å‡†\r\n',0),(362651,10074,'sv','PO behÃ¶ver godkÃ¤nnande innan fÃ¶rÃ¤ndringar',0),(362652,10074,'it','PO ha bisogno di approvazione prima di modifiche',0),(362653,10074,'tl','',0),(362654,10074,'th','PO à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸à¹ˆà¸­à¸™à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(362655,10074,'hi','à¤ªà¥‹ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(362656,10074,'ms','PO memerlukan kelulusan sebelum perubahan',0),(362657,10074,'ar','Øµ. Ø¨. ÙˆÙŠØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ Ù…ÙˆØ§ÙÙ‚Ø© Ù‚Ø¨Ù„ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(362658,10074,'fr','PO doit Ãªtre approuvÃ© avant la variation',0),(362659,10074,'jp','å¤‰æ›´ã™ã‚‹å‰ã«æ‰¿èªã‚’å¿…è¦ã¨ PO',0),(362660,10074,'pt','PO precisa de aprovaÃ§Ã£o antes de mudanÃ§as',0),(362661,10074,'ru','PO Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð´Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(362662,10074,'es','OC Necesita AprobaciÃ³n Antes que Cambiar',0),(362663,10074,'de','PO braucht Zustimmung vor Ã„nderungen',0),(362664,10074,'en','PO Needs Approval Before Changes',0),(362665,10075,'is','',0),(362666,10075,'dr','ØªØ§Ø±ÙŠØ® Ø¨ÙˆØ¯Ø¬Ù‡',0),(362667,10075,'pr','ØªØ§Ø±ÙŠØ® Ø¨ÙˆØ¯Ø¬Ù‡',0),(362668,10075,'tr','BÃ¼tÃ§e tarihi',0),(362669,10075,'pl','Data budÅ¼etu',0),(362670,10075,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð´Ð°Ñ‚Ð°',0),(362671,10075,'ur','Ø¨Ø¬Ù¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(362672,10075,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ð´Ð°Ñ‚ÑƒÐ¼',0),(362673,10075,'vi','NgÃ y ngÃ¢n sÃ¡ch',0),(362674,10075,'af','Begrotingsdatum',0),(362675,10075,'ro','Data de buget',0),(362676,10075,'et','Eelarve kuupÃ¤ev',0),(362677,10075,'si','ProraÄun datum',0),(362678,10075,'ba','Anggaran tanggal',0),(362679,10075,'nl','Begroting datum',0),(362680,10075,'fi','Talousarvion pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(362681,10075,'no','Budsjett dato',0),(362682,10075,'da','Budget dato',0),(362683,10075,'ko','ì˜ˆì‚° ë‚ ì§œ',0),(362684,10075,'he','×ª×§×¦×™×‘ ×ª××¨×™×š',0),(362685,10075,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(362686,10075,'zh','é¢„ç®—æ—¥æœŸ\r\n',0),(362687,10075,'sv','Budget datum',0),(362688,10075,'it','Data di bilancio',0),(362689,10075,'tl','',0),(362690,10075,'th','à¸§à¸±à¸™à¸‚à¸­à¸‡à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“',0),(362691,10075,'hi','à¤¬à¤œà¤Ÿ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(362692,10075,'ms','Tarikh bajet',0),(362693,10075,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(362694,10075,'fr','Date du budget',0),(362695,10075,'jp','äºˆç®—æ—¥',0),(362696,10075,'pt','Data do orÃ§amento',0),(362697,10075,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð”Ð°Ñ‚Ð°',0),(362698,10075,'es','Fecha de Presupesto',0),(362699,10075,'de','Budget-Datum',0),(362700,10075,'en','Budget Date',0),(362701,10076,'is','',0),(362702,10076,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ ',0),(362703,10076,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„ ',0),(362704,10076,'tr','Proje bÃ¼tÃ§esi',0),(362705,10076,'pl','BudÅ¼et zlecenia',0),(362706,10076,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(362707,10076,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹',0),(362708,10076,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ð¿Ð¾ÑÐ»Ð°',0),(362709,10076,'vi','ngÃ¢n sÃ¡ch cÃ´ng viá»‡c',0),(362710,10076,'af','Werkstuk Begroting',0),(362711,10076,'ro','Buget lucrare',0),(362712,10076,'et','Projekti eelarve',0),(362713,10076,'si','PredraÄun projekta',0),(362714,10076,'ba','Pekerjaan anggaran',0),(362715,10076,'nl','Projectbudget',0),(362716,10076,'fi','Projektibudjetti',0),(362717,10076,'no','Prosjektbudsjett',0),(362718,10076,'da','Sagsbudget',0),(362719,10076,'ko','ì¼ìžë¦¬ ì˜ˆì‚°',0),(362720,10076,'he','×ª×§×¦×™×‘ ×¢×‘×•×“×”',0),(362721,10076,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Î­ÏÎ³Î¿Ï…',0),(362722,10076,'zh','å·¥ä½œé¢„ç®—\r\n',0),(362723,10076,'sv','Projektbudget',0),(362724,10076,'it','Budget Commessa',0),(362725,10076,'tl','',0),(362726,10076,'th','à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸‡à¸²à¸™',0),(362727,10076,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¬à¤œà¤Ÿ',0),(362728,10076,'ms','Kerja bajet',0),(362729,10076,'ar','Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¹Ù…Ù„',0),(362730,10076,'fr','Budget projet',0),(362731,10076,'jp','ã‚¸ãƒ§ãƒ–ã®äºˆç®—',0),(362732,10076,'pt','OrÃ§amento de trabalho',0),(362733,10076,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(362734,10076,'es','Presupuesto del Trabajo',0),(362735,10076,'de','Projektbudget',0),(362736,10076,'en','Job Budget',0),(362737,10077,'is','',0),(362738,10077,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´ØºÙ„ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(362739,10077,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´ØºÙ„ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(362740,10077,'tr','Bir iÅŸe girmeniz gerekir',0),(362741,10077,'pl','NaleÅ¼y wprowadziÄ‡ zadanie',0),(362742,10077,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(362743,10077,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø¬Ø§Ø¨ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(362744,10077,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¿Ð¾ÑÐ°Ð¾',0),(362745,10077,'vi','Báº¡n pháº£i nháº­p má»™t viá»‡c lÃ m',0),(362746,10077,'af','U Moet \'n Werkstuk Invoer',0),(362747,10077,'ro','Trebuie sÄƒ introduceÅ£i un loc de muncÄƒ',0),(362748,10077,'et','Te peate sisestama ameti',0),(362749,10077,'si','Vnesti morate zaposlitev',0),(362750,10077,'ba','Anda harus memasukkan pekerjaan',0),(362751,10077,'nl','U moet een taak invoeren',0),(362752,10077,'fi','Anna tyÃ¶',0),(362753,10077,'no','Du mÃ¥ angi en jobb',0),(362754,10077,'da','Du skal angive et Job',0),(362755,10077,'ko','ì¼ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(362756,10077,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×¢×‘×•×“×”',0),(362757,10077,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(362758,10077,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªèŒä½\r\n',0),(362759,10077,'sv','Du mÃ¥ste ange ett jobb',0),(362760,10077,'it','Ãˆ necessario inserire un lavoro',0),(362761,10077,'tl','',0),(362762,10077,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸‡à¸²à¸™',0),(362763,10077,'hi','à¤¤à¥à¤® à¤à¤• à¤¨à¥Œà¤•à¤°à¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(362764,10077,'ms','Anda mesti masukkan pekerjaan',0),(362765,10077,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ¯Ø®Ù„ ÙˆØ¸ÙŠÙØ©',0),(362766,10077,'fr','Vous devez entrer un emploi.',0),(362767,10077,'jp','ã‚¸ãƒ§ãƒ–ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(362768,10077,'pt','VocÃª deve digitar um trabalho',0),(362769,10077,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(362770,10077,'es','Debe Entrar Un Trabajo',0),(362771,10077,'de','Sie mÃ¼ssen einen Job eingeben.',0),(362772,10077,'en','You Must Enter a Job',0),(362773,10078,'is','',0),(362774,10078,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ ',0),(362775,10078,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ ',0),(362776,10078,'tr','Notlar ekleme',0),(362777,10078,'pl','DodaÄ‡ notatki',0),(362778,10078,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(362779,10078,'ur','Ù†ÙˆÙ¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(362780,10078,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(362781,10078,'vi','ThÃªm ghi chÃº',0),(362782,10078,'af','Notas Byvoeg',0),(362783,10078,'ro','Adauga note',0),(362784,10078,'et','Lisa mÃ¤rkeid',0),(362785,10078,'si','Dodajanje opomb',0),(362786,10078,'ba','Tambahkan catatan',0),(362787,10078,'nl','Notities toevoegen',0),(362788,10078,'fi','LisÃ¤Ã¤ muistiinpanoja',0),(362789,10078,'no','Legge til notater',0),(362790,10078,'da','TilfÃ¸je noter',0),(362791,10078,'ko','ë©”ëª¨ ì¶”ê°€',0),(362792,10078,'he','×”×•×¡×£ ×¤×ª×§×™×',0),(362793,10078,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÏ‰Î½',0),(362794,10078,'zh','å¢žåŠ æ³¨é‡Š\r\n',0),(362795,10078,'sv','LÃ¤gga till anteckningar',0),(362796,10078,'it','Aggiungere note',0),(362797,10078,'tl','',0),(362798,10078,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸',0),(362799,10078,'hi','à¤¨à¥‹à¤Ÿà¥à¤¸ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(362800,10078,'ms','Tambah Nota-Nota',0),(362801,10078,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(362802,10078,'fr','Ajouter des Notes',0),(362803,10078,'jp','ãƒ¡ãƒ¢ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(362804,10078,'pt','Adicionar notas',0),(362805,10078,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð—Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(362806,10078,'es','Agregar Notas',0),(362807,10078,'de','Notizen hinzufÃ¼gen',0),(362808,10078,'en','Add Notes',0),(362809,10079,'is','',0),(362810,10079,'dr','ØªØ§ÙŠÙŠØ¯',0),(362811,10079,'pr','ØªØ§ÙŠÙŠØ¯',0),(362812,10079,'tr','Onaylama',0),(362813,10079,'pl','Zatwierdzenie',0),(362814,10079,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÐ²Ð°',0),(362815,10079,'ur','Ù…Ù†Ø¸ÙˆØ±',0),(362816,10079,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð¸Ñ‚Ð¸',0),(362817,10079,'vi','PhÃª duyá»‡',0),(362818,10079,'af','Goedkeur',0),(362819,10079,'ro','Aproba',0),(362820,10079,'et','Kinnitamine',0),(362821,10079,'si','Odobri',0),(362822,10079,'ba','Menyetujui',0),(362823,10079,'nl','Goedkeuren',0),(362824,10079,'fi','HyvÃ¤ksyÃ¤',0),(362825,10079,'no','Godkjenne',0),(362826,10079,'da','Godkende',0),(362827,10079,'ko','ìŠ¹ì¸',0),(362828,10079,'he','×œ××©×¨',0),(362829,10079,'el','Î•Î³ÎºÏÎ¯Î½ÎµÎ¹',0),(362830,10079,'zh','æ‰¹å‡†\r\n',0),(362831,10079,'sv','GodkÃ¤nna',0),(362832,10079,'it','Approvare',0),(362833,10079,'tl','',0),(362834,10079,'th','à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(362835,10079,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(362836,10079,'ms','Meluluskan',0),(362837,10079,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰',0),(362838,10079,'fr','Approuver',0),(362839,10079,'jp','æ‰¿èª',0),(362840,10079,'pt','Aprovar',0),(362841,10079,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ',0),(362842,10079,'es','Aprobar',0),(362843,10079,'de','Genehmigen',0),(362844,10079,'en','Approve',0),(362845,10080,'is','',0),(362846,10080,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø¨ÙˆØ¯Ø¬Ù‡',0),(362847,10080,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø¨ÙˆØ¯Ø¬Ù‡',0),(362848,10080,'tr','BÃ¼tÃ§e baÅŸlayacak',0),(362849,10080,'pl','Data rozp. budÅ¼et',0),(362850,10080,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð´Ð°Ñ‚Ð°',0),(362851,10080,'ur','Ø¨Ø¬Ù¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¢ØºØ§Ø²',0),(362852,10080,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð±ÑƒÑŸÐµÑ‚Ð°',0),(362853,10080,'vi','NgÃ y báº¯t Ä‘áº§u ngÃ¢n sÃ¡ch',0),(362854,10080,'af','Begin Begrotingsdatum',0),(362855,10080,'ro','Data de buget incep',0),(362856,10080,'et','Eelarve alguskuupÃ¤ev',0),(362857,10080,'si','ZaÄetni datum proraÄuna',0),(362858,10080,'ba','Mulai tanggal anggaran',0),(362859,10080,'nl','Begroting begindatum',0),(362860,10080,'fi','Talousarvion alkamispÃ¤ivÃ¤',0),(362861,10080,'no','Starte budsjett dato',0),(362862,10080,'da','Begynde budgettet dato',0),(362863,10080,'ko','ì˜ˆì‚° ë‚ ì§œë¥¼ ì‹œìž‘',0),(362864,10080,'he','×‘×’×™×Ÿ ×ª×§×¦×™×‘ ×ª××¨×™×š',0),(362865,10080,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(362866,10080,'zh','é¢„ç®—å¼€å§‹æ—¥æœŸ\r\n',0),(362867,10080,'sv','BÃ¶rja Budget datum',0),(362868,10080,'it','Iniziare la data di bilancio',0),(362869,10080,'tl','',0),(362870,10080,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“',0),(362871,10080,'hi','à¤¬à¤œà¤Ÿ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¶à¥à¤°à¥‚ à¤¹à¥‹',0),(362872,10080,'ms','Mula tarikh bajet',0),(362873,10080,'ar','ÙŠØ¨Ø¯Ø£ ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(362874,10080,'fr','Commencer la Date du Budget',0),(362875,10080,'jp','äºˆç®—æ—¥ä»˜ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(362876,10080,'pt','ComeÃ§ar a data do orÃ§amento',0),(362877,10080,'ru','ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ð°Ñ Ð”Ð°Ñ‚Ð° Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(362878,10080,'es','Comienza Fecha de Presupesto',0),(362879,10080,'de','Anfangsdatum Budget',0),(362880,10080,'en','Begin Budget Date',0),(362881,10081,'is','',0),(362882,10081,'dr','Ø±Ø¯ Ú©Ø±Ø¯Ù† ',0),(362883,10081,'pr','Ø±Ø¯ Ú©Ø±Ø¯Ù† ',0),(362884,10081,'tr','Ä°nkar',0),(362885,10081,'pl','OdmÃ³wiÄ‡',0),(362886,10081,'bg','ÐžÑ‚Ñ€Ð¸Ñ‡Ð°Ñ‚',0),(362887,10081,'ur','Ù…Ù†Ú©Ø±',0),(362888,10081,'sr','ÐŸÐ¾Ñ€Ð¸Ñ†Ð°Ñ‚Ð¸',0),(362889,10081,'vi','Tá»« chá»‘i',0),(362890,10081,'af','Ontken',0),(362891,10081,'ro','Nega',0),(362892,10081,'et','Eitada',0),(362893,10081,'si','Zanikati',0),(362894,10081,'ba','Menyangkal',0),(362895,10081,'nl','Weigeren',0),(362896,10081,'fi','KieltÃ¤Ã¤',0),(362897,10081,'no','Nekte',0),(362898,10081,'da','BenÃ¦gte',0),(362899,10081,'ko','ê±°ë¶€',0),(362900,10081,'he','×œ×”×›×—×™×©',0),(362901,10081,'el','Î‘ÏÎ½Î·Î¸ÎµÎ¯',0),(362902,10081,'zh','å¦è®¤\r\n',0),(362903,10081,'sv','Neka',0),(362904,10081,'it','Negare',0),(362905,10081,'tl','',0),(362906,10081,'th','à¸›à¸à¸´à¹€à¸ªà¸˜',0),(362907,10081,'hi','à¤¸à¥‡ à¤‡à¤¨à¤•à¤¾à¤°',0),(362908,10081,'ms','Menafikan',0),(362909,10081,'ar','Ø±ÙØ¶',0),(362910,10081,'fr','Nier',0),(362911,10081,'jp','æ‹’å¦',0),(362912,10081,'pt','Negar',0),(362913,10081,'ru','ÐžÑ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÑŒ',0),(362914,10081,'es','Negar',0),(362915,10081,'de','Verweigern',0),(362916,10081,'en','Deny',0),(362917,10082,'is','',0),(362918,10082,'dr',' ØªØ§Ø±ÙŠØ® Ø§ØªÙ…Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(362919,10082,'pr',' ØªØ§Ø±ÙŠØ® Ø§ØªÙ…Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡ ',0),(362920,10082,'tr','Son bÃ¼tÃ§e tarihi',0),(362921,10082,'pl','Data zakoÅ„czenia budÅ¼etu',0),(362922,10082,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(362923,10082,'ur','Ø¨Ø¬Ù¹ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(362924,10082,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð±ÑƒÑŸÐµÑ‚Ð°',0),(362925,10082,'vi','NgÃ y káº¿t thÃºc ngÃ¢n sÃ¡ch',0),(362926,10082,'af','End Begrotingsdatum',0),(362927,10082,'ro','Data de sfÃ¢rÅŸit al bugetului',0),(362928,10082,'et','Eelarve lÃµppkuupÃ¤ev',0),(362929,10082,'si','KonÄni proraÄun datum',0),(362930,10082,'ba','Tanggal akhir anggaran',0),(362931,10082,'nl','Begroting einddatum',0),(362932,10082,'fi','Budjetin pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(362933,10082,'no','Budsjett sluttdatoen',0),(362934,10082,'da','Slutdato for budgettet',0),(362935,10082,'ko','ì˜ˆì‚° ì¢…ë£Œì¼',0),(362936,10082,'he','×ª××¨×™×š ×¡×™×•× ×”×ª×§×¦×™×‘',0),(362937,10082,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(362938,10082,'zh','é¢„ç®—æ¡ˆç»“æŸæ—¥æœŸ',0),(362939,10082,'sv','Budget slutdatum',0),(362940,10082,'it','Data del bilancio finale',0),(362941,10082,'tl','',0),(362942,10082,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“',0),(362943,10082,'hi','à¤…à¤‚à¤¤ à¤¬à¤œà¤Ÿ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(362944,10082,'ms','Tarikh akhir bajet',0),(362945,10082,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(362946,10082,'fr','Date de fin Budget',0),(362947,10082,'jp','äºˆç®—ã®çµ‚äº†æ—¥',0),(362948,10082,'pt','Data do orÃ§amento final',0),(362949,10082,'ru','ÐšÐ¾Ð½ÐµÑ‡Ð½Ð°Ñ Ð”Ð°Ñ‚Ð° Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(362950,10082,'es','Fecha de TerminaciÃ³n del Presupuesto',0),(362951,10082,'de','Budget-Enddatum',0),(362952,10082,'en','End Budget Date',0),(362953,10083,'is','',0),(362954,10083,'dr','ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ù…Ø¹Ù„Ù‚ Ø¯Ø§Ø±Ø¯ ',0),(362955,10083,'pr','ØªØ¬Ø¯ÙŠØ¯ Ù†Ø¸Ø± Ù…Ø¹Ù„Ù‚ Ø¯Ø§Ø±Ø¯ ',0),(362956,10083,'tr','DÃ¼zeltme olan',0),(362957,10083,'pl','Czasu rewizji',0),(362958,10083,'bg','Ð• Ð² Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€ÐµÑ€Ð°Ð·Ð³Ð»ÐµÐ¶Ð´Ð°Ð½Ðµ',0),(362959,10083,'ur','Ø§Ø´Ø®Ø§Øµ Ú©Û’ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ ÛÛ’',0),(362960,10083,'sr','Ð˜Ð¼Ð° Ð½ÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ðµ Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ðµ',0),(362961,10083,'vi','Ä‘ang treo sá»± duyá»‡t láº¡i',0),(362962,10083,'af','Het hangende hersiening',0),(362963,10083,'ro','A pÃ¢nÄƒ la revizuirea',0),(362964,10083,'et','LÃ¤bivaatamiseni on',0),(362965,10083,'si','ÄŒakajoÄe spremembe',0),(362966,10083,'ba','Telah tertunda revisi',0),(362967,10083,'nl','Heeft in afwachting van de herziening',0),(362968,10083,'fi','Kunnes on',0),(362969,10083,'no','Har ventende revisjon',0),(362970,10083,'da','Har indtil Revision',0),(362971,10083,'ko','ê°œì • ë³´ë¥˜',0),(362972,10083,'he','×™×© ×”×ž×ž×ª×™× ×™× ×ž×”×“×•×¨×”',0),(362973,10083,'el','ÎˆÏ‡ÎµÎ¹ ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î® Ï„Î·Ï‚ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·Ï‚',0),(362974,10083,'zh','æ­£åœ¨ç”³è¯·ä¿®è®¢\r\n',0),(362975,10083,'sv','Har i avvaktan pÃ¥ Ã¶versynen',0),(362976,10083,'it','Ãˆ in attesa della revisione',0),(362977,10083,'tl','',0),(362978,10083,'th','à¹„à¸”à¹‰à¸žà¸´à¸ˆà¸²à¸£à¸“à¸²à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(362979,10083,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤²à¤‚à¤¬à¤¿à¤¤ à¤¹à¥ˆ',0),(362980,10083,'ms','Telah menunggu semakan',0),(362981,10083,'ar','Ø¨Ø§Ù†ØªØ¸Ø§Ø± Ù…Ø±Ø§Ø¬Ø¹Ø©',0),(362982,10083,'fr','A en attendant la rÃ©vision',0),(362983,10083,'jp','ä¿ç•™ä¸­ã®ãƒªãƒ“ã‚¸ãƒ§ãƒ³',0),(362984,10083,'pt','Tem pendente a revisÃ£o',0),(362985,10083,'ru','Ð˜Ð¼ÐµÐµÑ‚ Ð´Ð¾ Ð¿ÐµÑ€ÐµÑÐ¼Ð¾Ñ‚Ñ€Ð°',0),(362986,10083,'es','Tiene RevisiÃ³n Pendiente',0),(362987,10083,'de','Ausstehende Revision',0),(362988,10083,'en','Has Pending Revision',0),(362989,10084,'is','',0),(362990,10084,'dr','Ù†Ù…Ø§ÙŠØ´ Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ù‚Ø¨Ù„ÙŠ',0),(362991,10084,'pr','Ù†Ù…Ø§ÙŠØ´ Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ù‚Ø¨Ù„ÙŠ',0),(362992,10084,'tr','Ã–nceki sÃ¼rÃ¼mleri gÃ¶ster',0),(362993,10084,'pl','PokaÅ¼ wczeÅ›niejsze wersje',0),(362994,10084,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ Ð²ÐµÑ€ÑÐ¸Ð¸',0),(362995,10084,'ur','Ø³Ø§Ø¨Ù‚Û ÙˆØ±Ú˜Ù† Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(362996,10084,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ðµ Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ',0),(362997,10084,'vi','Thá»ƒ hiá»‡n phiÃªn báº£n trÆ°á»›c',0),(362998,10084,'af','Wys Vorige Weergawes',0),(362999,10084,'ro','AratÄƒ versiunile anterioare',0),(363000,10084,'et','Kuva varasemad versioonid',0),(363001,10084,'si','PrikaÅ¾i prejÅ¡nje razliÄice',0),(363002,10084,'ba','Versi-versi sebelumnya Tampilkan',0),(363003,10084,'nl','Eerdere versies weergeven',0),(363004,10084,'fi','NÃ¤ytÃ¤ aiemmat versiot',0),(363005,10084,'no','Vis tidligere versjoner',0),(363006,10084,'da','Vis tidligere versioner',0),(363007,10084,'ko','ì´ì „ ë²„ì „ ë³´ê¸°',0),(363008,10084,'he','×”×¦×’ ×’×™×¨×¡××•×ª ×§×•×“×ž×•×ª',0),(363009,10084,'el','ÎŸÎ¹ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ ÎµÎºÎ´ÏŒÏƒÎµÎ¹Ï‚ Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·',0),(363010,10084,'zh','æ˜¾ç¤ºä»¥å‰çš„ç‰ˆæœ¬\r\n',0),(363011,10084,'sv','Visa tidigare versioner',0),(363012,10084,'it','Visualizza versioni precedenti',0),(363013,10084,'tl','',0),(363014,10084,'th','à¹à¸ªà¸”à¸‡à¸£à¸¸à¹ˆà¸™à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(363015,10084,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£à¥‹à¤‚ à¤¦à¤¿à¤–à¤¾à¤¨à¥‡',0),(363016,10084,'ms','Tunjuk versi yang terdahulu',0),(363017,10084,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¥ØµØ¯Ø§Ø±Ø§Øª Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(363018,10084,'fr','Afficher les Versions prÃ©cÃ©dentes',0),(363019,10084,'jp','ä»¥å‰ã®ãƒãƒ¼ã‚¸ãƒ§ãƒ³ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(363020,10084,'pt','Mostrar as versÃµes anteriores',0),(363021,10084,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐŸÑ€ÐµÐ´Ð¸Ð´ÑƒÑ‰Ð¸Ðµ Ð’ÐµÑ€ÑÐ¸Ð¸',0),(363022,10084,'es','Muestra Versiones Anteriores',0),(363023,10084,'de','Vorherige Versionen anzeigen',0),(363024,10084,'en','Show Prior Versions',0),(363025,10085,'is','',0),(363026,10085,'dr','ÙƒÙ¾ÙŠ Ø¯Ø± Ø´ØºÙ„ ',0),(363027,10085,'pr','ÙƒÙ¾ÙŠ Ø¯Ø± Ø´ØºÙ„ ',0),(363028,10085,'tr','Ä°ÅŸ iÃ§in kopyalama',0),(363029,10085,'pl','Skopiuj do pracy',0),(363030,10085,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(363031,10085,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ø³Û’ Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(363032,10085,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð½Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(363033,10085,'vi','Sao chÃ©p cÃ´ng viá»‡c',0),(363034,10085,'af','Kopieer na werk',0),(363035,10085,'ro','Copie la Job',0),(363036,10085,'et','Kopeeri PROJEKTILE',0),(363037,10085,'si','Kopiraj v sluÅ¾bo',0),(363038,10085,'ba','Copy pekerjaan',0),(363039,10085,'nl','KopiÃ«ren naar project',0),(363040,10085,'fi','Kopioi tyÃ¶',0),(363041,10085,'no','Kopiere til jobben',0),(363042,10085,'da','Kopier til Job',0),(363043,10085,'ko','ìž‘ì—… ë³µì‚¬',0),(363044,10085,'he','×œ×”×¢×ª×™×§ ××ª ×”×¢×‘×•×“×”',0),(363045,10085,'el','Î‘Î½Ï„Î¹Î³ÏÎ±Ï†Î® ÏƒÎµ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(363046,10085,'zh','å¤åˆ¶åˆ°å·¥ä½œ\r\n',0),(363047,10085,'sv','Kopiera till jobb',0),(363048,10085,'it','Copia di lavoro',0),(363049,10085,'tl','',0),(363050,10085,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¸‡à¸²à¸™',0),(363051,10085,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(363052,10085,'ms','Salin ke kerja',0),(363053,10085,'ar','Ù†Ø³Ø® Ù„Ù„ÙˆØ¸ÙŠÙØ©',0),(363054,10085,'fr','Copier vers l\'emploi',0),(363055,10085,'jp','ã‚¸ãƒ§ãƒ–ã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(363056,10085,'pt','Copiar para o trabalho',0),(363057,10085,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(363058,10085,'es','Copiar AL Trabajo',0),(363059,10085,'de','Kopieren in Auftrag',0),(363060,10085,'en','Copy TO Job',0),(363061,10086,'is','',0),(363062,10086,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ Ù‡Ù…Ú†Ù†ÙŠÙ† ',0),(363063,10086,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ Ù‡Ù…Ú†Ù†ÙŠÙ† ',0),(363064,10086,'tr','AyrÄ±ca bÃ¼tÃ§elerini oluÅŸtur',0),(363065,10086,'pl','UtwÃ³rz takÅ¼e budÅ¼ety',0),(363066,10086,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ñ‚Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸ ÑÑŠÑ‰Ð¾',0),(363067,10086,'ur','Ø¨Ø¬Ù¹ Ø¨Ú¾ÛŒ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(363068,10086,'sr','Ð¢Ð°ÐºÐ¾Ñ’Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ Ð±ÑƒÑŸÐµÑ‚Ðµ',0),(363069,10086,'vi','cÅ©ng táº¡o ngÃ¢n sÃ¡ch',0),(363070,10086,'af','Skep ook Begrotings',0),(363071,10086,'ro','De asemenea, sÄƒ creaÅ£i bugete',0),(363072,10086,'et','Looge eelarved ka',0),(363073,10086,'si','Ustvarite predraÄune tudi',0),(363074,10086,'ba','Membuat anggaran juga',0),(363075,10086,'nl','Ook budgetten maken',0),(363076,10086,'fi','Voit luoda budjetteja myÃ¶s',0),(363077,10086,'no','Opprette budsjetter ogsÃ¥',0),(363078,10086,'da','Oprette budgetter ogsÃ¥',0),(363079,10086,'ko','ë˜í•œ ì˜ˆì‚° ë§Œë“¤ê¸°',0),(363080,10086,'he','×™×•×¦×¨×™× ×ª×§×¦×™×‘×™× ×’×',0),(363081,10086,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ ÎµÏ€Î¯ÏƒÎ·Ï‚',0),(363082,10086,'zh','è¿˜å»ºç«‹é¢„ç®—\r\n',0),(363083,10086,'sv','Skapa budgetar ocksÃ¥',0),(363084,10086,'it','Creare anche i bilanci',0),(363085,10086,'tl','',0),(363086,10086,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸¢à¸±à¸‡',0),(363087,10086,'hi','à¤¬à¤œà¤Ÿ à¤­à¥€ à¤¬à¤¨à¤¾à¤à¤',0),(363088,10086,'ms','Membuat belanjawan juga',0),(363089,10086,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª ÙƒØ°Ù„Ùƒ',0),(363090,10086,'fr','CrÃ©er des Budgets aussi',0),(363091,10086,'jp','ã¾ãŸäºˆç®—ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(363092,10086,'pt','Criar orÃ§amentos tambÃ©m',0),(363093,10086,'ru','Ð¢Ð°ÐºÐ¶Ðµ Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ñ‹',0),(363094,10086,'es','TambiÃ©n Crear Presupuestos',0),(363095,10086,'de','Erstellen Sie Budgets auch',0),(363096,10086,'en','Create Budgets Also',0),(363097,10087,'is','',0),(363098,10087,'dr','Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙƒÙ¾ÙŠ Ø´Ø¯ ',0),(363099,10087,'pr','Ø´ØºÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙƒÙ¾ÙŠ Ø´Ø¯ ',0),(363100,10087,'tr','Ä°ÅŸi baÅŸarÄ±yla kopyalanan',0),(363101,10087,'pl','Praca skopiowana pomyÅ›lnie',0),(363102,10087,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð°, ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(363103,10087,'ur','Ú©Ø§Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù†Ù‚Ù„ Ú©Ø±',0),(363104,10087,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ð¸',0),(363105,10087,'vi','Ä‘Ã£ sao chÃ©p cÃ´ng viá»‡c thÃ nh cÃ´ng',0),(363106,10087,'af','Werkstuk Suksesvol Gekopieer',0),(363107,10087,'ro','Job copiat cu succes',0),(363108,10087,'et','Projekti edukal kopeerimisel',0),(363109,10087,'si','UspeÅ¡no kopirane delo',0),(363110,10087,'ba','Pekerjaan yang disalin berhasil',0),(363111,10087,'nl','Werk met succes gekopieerd',0),(363112,10087,'fi','Projektin kopiointi onnistui',0),(363113,10087,'no','Jobb kopiert vellykket',0),(363114,10087,'da','Job kopieret korrekt',0),(363115,10087,'ko','ì„±ê³µì ìœ¼ë¡œ ë³µì‚¬ í•˜ëŠ” ìž‘ì—…',0),(363116,10087,'he','×”×¢×‘×•×“×” ×”×•×¢×ª×§×” ×‘×”×¦×œ×—×”',0),(363117,10087,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï€Î¿Ï… Î±Î½Ï„Î¹Î³ÏÎ¬Ï†Î·ÎºÎ±Î½ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(363118,10087,'zh','ä½œä¸šå¤åˆ¶æˆåŠŸ\r\n',0),(363119,10087,'sv','Jobb kopieras framgÃ¥ngsrikt',0),(363120,10087,'it','Lavoro copiato con successo',0),(363121,10087,'tl','',0),(363122,10087,'th','à¸‡à¸²à¸™à¸„à¸±à¸”à¸¥à¸­à¸à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(363123,10087,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤•à¥€ à¤¨à¥Œà¤•à¤°à¥€',0),(363124,10087,'ms','Kerja yang berjaya disalin',0),(363125,10087,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„ØªÙŠ ØªÙ… Ù†Ø³Ø®Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(363126,10087,'fr','Emploi copiÃ© avec succÃ¨s',0),(363127,10087,'jp','ã‚¸ãƒ§ãƒ–ãŒæ­£å¸¸ã«ã‚³ãƒ”ãƒ¼ã•ã‚Œã¾ã—ãŸ',0),(363128,10087,'pt','Trabalho copiado com Ãªxito',0),(363129,10087,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹',0),(363130,10087,'es','Trabajo Copiado Exiosamente',0),(363131,10087,'de','Job erfolgreich kopiert',0),(363132,10087,'en','Job Copied Successfully',0),(363133,10088,'is','',0),(363134,10088,'dr','/ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´  SB',0),(363135,10088,'pr','ÙƒÙ¾ÙŠ  Ø´ØºÙ„  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  / ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´  SB\r\n ',0),(363136,10088,'tr','Ä°ÅŸ PO/SB Kopyala',0),(363137,10088,'pl','Praca PO/SB kopii',0),(363138,10088,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° PO/SB ÐºÐ¾Ð¿Ð¸Ðµ',0),(363139,10088,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ù¾Ùˆ ÙØ±ÛŒØ¶Û Ø³Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯Û’ Ù†Ù‚Ù„',0),(363140,10088,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾ ÐŸÐž/Ð¡Ð‘',0),(363141,10088,'vi','PO cÃ´ng viá»‡c/ sao chÃ©p SB',0),(363142,10088,'af','Werk PO/SB afskrif',0),(363143,10088,'ro','Copie de PO/SB Job',0),(363144,10088,'et','TÃ¶Ã¶ PO/SB koopia',0),(363145,10088,'si','Delo PO/SB izvod',0),(363146,10088,'ba','Copy pekerjaan PO SB',0),(363147,10088,'nl','Baan PO/SB kopie',0),(363148,10088,'fi','TyÃ¶ PO/SB kopio',0),(363149,10088,'no','Jobb PO/SB kopi',0),(363150,10088,'da','Job PO/SB kopi',0),(363151,10088,'ko','ì¼ í¬/SB ë³µì‚¬',0),(363152,10088,'he','×”×¢×‘×•×“×” ×¤×•/SB ×¢×•×ª×§',0),(363153,10088,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± PO/SB Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿',0),(363154,10088,'zh','å·¥ä½œè®¢å•/è¡Œä¸šæ ‡å‡†å¤åˆ¶\r\n',0),(363155,10088,'sv','Jobb PO/SB kopia',0),(363156,10088,'it','Copia di lavoro PO/SB',0),(363157,10088,'tl','',0),(363158,10088,'th','à¸‡à¸²à¸™à¸ªà¸³à¹€à¸™à¸² PO/SB',0),(363159,10088,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¥‹/SB à¤•à¥€ à¤¨à¤•à¤²',0),(363160,10088,'ms','Salinan PO/SB kerja',0),(363161,10088,'ar','Ù†Ø³Ø®Ø© Ø¨Ùˆ/SB Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(363162,10088,'fr','Copie de travail PO/SB',0),(363163,10088,'jp','ã‚¸ãƒ§ãƒ– PO/SB ã®ã‚³ãƒ”ãƒ¼',0),(363164,10088,'pt','CÃ³pia de trabalho PO/SB',0),(363165,10088,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ PO/SB',0),(363166,10088,'es','Trabajo OC/SB Copiar',0),(363167,10088,'de','Job-PO/SB-Kopie',0),(363168,10088,'en','Job PO/SB Copy',0),(363169,10089,'is','',0),(363170,10089,'dr','Ø´ØºÙ„ Ø¬Ù‡Øª ÙƒÙ¾ÙŠ Ø§Ø² ',0),(363171,10089,'pr','Ø´ØºÙ„ Ø¬Ù‡Øª ÙƒÙ¾ÙŠ Ø§Ø² ',0),(363172,10089,'tr','Ä°ÅŸ kopyalamak iÃ§in',0),(363173,10089,'pl','Zadanie kopii z',0),(363174,10089,'bg','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð·Ð° ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚',0),(363175,10089,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ø³Û’ Ù†Ù‚Ù„ Ú©Ø±Ù†Ø§',0),(363176,10089,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñƒ ÐºÐ¾Ð¿Ð¸Ñ˜Ð¸ Ð¸Ð·',0),(363177,10089,'vi','cÃ´ng viá»‡c Ä‘á»ƒ sao chÃ©p tá»«',0),(363178,10089,'af','Afskrif van werk',0),(363179,10089,'ro','Job pentru a copia de',0),(363180,10089,'et','Projekti koopia',0),(363181,10089,'si','Delo prepisati iz',0),(363182,10089,'ba','Pekerjaan untuk salinan dari',0),(363183,10089,'nl','Baan u kopiÃ«ren van',0),(363184,10089,'fi','Kopioi tyÃ¶',0),(363185,10089,'no','Jobb Ã¥ Kopier fra',0),(363186,10089,'da','Job til kopi fra',0),(363187,10089,'ko','ìž‘ì—…ì—ì„œ ë³µì‚¬',0),(363188,10089,'he','×”×¢×‘×•×“×” ×¢×•×ª×§ ×ž×Ÿ',0),(363189,10089,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÏƒÎµ Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Î±Ï€ÏŒ',0),(363190,10089,'zh','å·¥ä½œå¤åˆ¶æ¥æº\r\n',0),(363191,10089,'sv','Jobb till kopia frÃ¥n',0),(363192,10089,'it','Lavoro di copia da',0),(363193,10089,'tl','',0),(363194,10089,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¸ˆà¸²à¸à¸‡à¸²à¸™',0),(363195,10089,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¥‡ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(363196,10089,'ms','Tugas untuk salinan daripada',0),(363197,10089,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø¥Ù„Ù‰ Ù†Ø³Ø®Ø© Ù…Ù†',0),(363198,10089,'fr','Travail de copie de',0),(363199,10089,'jp','ã‚³ãƒ”ãƒ¼ã™ã‚‹ã‚¸ãƒ§ãƒ–',0),(363200,10089,'pt','Trabalho de cÃ³pia de',0),(363201,10089,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð´Ð»Ñ ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¸Ð·',0),(363202,10089,'es','Trabajo Desde Que Copiar ',0),(363203,10089,'de','Job in Kopie aus',0),(363204,10089,'en','Job to Copy FROM',0),(363205,10090,'is','',0),(363206,10090,'dr','ÙƒÙ¾ÙŠ Ù†Ø´Ø¯Ù‡',0),(363207,10090,'pr','ÙƒÙ¾ÙŠ Ù†Ø´Ø¯Ù‡',0),(363208,10090,'tr','Kopyalanmaz',0),(363209,10090,'pl','Nie kopiowaÄ‡',0),(363210,10090,'bg','ÐÐµ ÑÐµ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ñ‚',0),(363211,10090,'ur','Ù†Ù‚Ù„ Ù†ÛÛŒÚº Ú©ÛŒ',0),(363212,10090,'sr','ÐÐ¸Ñ˜Ðµ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ð°',0),(363213,10090,'vi','khÃ´ng sao chÃ©p',0),(363214,10090,'af','Nie GekopieÃ«r',0),(363215,10090,'ro','Nu copiat',0),(363216,10090,'et','Ei kopeerita',0),(363217,10090,'si','Ne kopirati',0),(363218,10090,'ba','Tidak disalin',0),(363219,10090,'nl','Niet gekopieerd',0),(363220,10090,'fi','Ei kopioida',0),(363221,10090,'no','Ikke kopieres',0),(363222,10090,'da','Ikke kopieret',0),(363223,10090,'ko','ë³µì‚¬ ë˜ì§€',0),(363224,10090,'he','×œ× ×œ×”×¢×ª×™×§',0),(363225,10090,'el','Î”ÎµÎ½ Î±Î½Ï„Î¹Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹',0),(363226,10090,'zh','ä¸å¤åˆ¶\r\n',0),(363227,10090,'sv','Inte kopieras',0),(363228,10090,'it','Non copiate',0),(363229,10090,'tl','',0),(363230,10090,'th','à¹„à¸¡à¹ˆà¸„à¸±à¸”à¸¥à¸­à¸',0),(363231,10090,'hi','à¤¨à¤•à¤² à¤¨à¤¹à¥€à¤‚',0),(363232,10090,'ms','Tidak disalin',0),(363233,10090,'ar','Ù„Ù… ÙŠØªÙ… Ù†Ø³Ø®',0),(363234,10090,'fr','Non copiÃ©',0),(363235,10090,'jp','ã‚³ãƒ”ãƒ¼ã§ã¯ãªã',0),(363236,10090,'pt','NÃ£o copiado',0),(363237,10090,'ru','ÐÐµ ÐºÐ¾Ð¿Ð¸Ñ€ÑƒÐµÑ‚ÑÑ',0),(363238,10090,'es','Se CopiÃ³ la Nota',0),(363239,10090,'de','Nicht kopiert',0),(363240,10090,'en','Not Copied',0),(363241,10091,'is','',0),(363242,10091,'dr','/ Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(363243,10091,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¬Ø§Ø±ÙŠ / Ø¬Ø²Ø¦ÙŠØ§Øª Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(363244,10091,'tr','GeÃ§erli PO/SB AyrÃ½ntÃ½yÃ½ kullan fiyatlandÄ±rma',0),(363245,10091,'pl','UÅ¼yj bieÅ¼Ä…cego szczegÃ³Å‚owoÅ›ci PO/SB ceny',0),(363246,10091,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° PO/SB Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(363247,10091,'ur','Ø­Ø§Ù„ÛŒÛ Ù¾Ùˆ ÙØ±ÛŒØ¶Û Ø³Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯Û’ ØªÙØµÛŒÙ„ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(363248,10091,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ ÐŸÐž/Ð¡Ð‘ Ð´ÐµÑ‚Ð°Ñ™ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(363249,10091,'vi','Sá»­ dá»¥ng giÃ¡ hiá»‡n táº¡i chi tiáº¿t PO / SB',0),(363250,10091,'af','Gebruik huidige PO/SB Detail pryse',0),(363251,10091,'ro','UtilizaÃ¾i curent PO/SB detalii de stabilire a preÅ£urilor',0),(363252,10091,'et','Kasuta praegust PO/SB andmeid hinnakujundus',0),(363253,10091,'si','Uporabite trenutni PO/SB podrobnosti cen',0),(363254,10091,'ba','Gunakan saat ini PO SB Detail harga',0),(363255,10091,'nl','Gebruik huidige PO/SB Detail prijzen',0),(363256,10091,'fi','KÃ¤ytÃ¤ nykyisen PO/SB yksityiskohtaisesti hinnoittelu',0),(363257,10091,'no','Bruk gjeldende PO/SB detaljer priser',0),(363258,10091,'da','Brug aktuelle PO/SB detalje prissÃ¦tning',0),(363259,10091,'ko','í˜„ìž¬ í¬/SB ì„¸ë¶€ ì‚¬ìš© ê°€ê²©',0),(363260,10091,'he','×”×©×ª×ž×© ×”×¤×™×¨×•×˜ ×¤×•/SB ×”× ×•×›×—×™ ×ª×ž×—×•×¨',0),(363261,10091,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± PO/SB Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(363262,10091,'zh','ä½¿ç”¨ç›®å‰çš„è®¢å•/æŸäººè¯¦ç»†ä»·æ ¼\r\n',0),(363263,10091,'sv','AnvÃ¤nda nuvarande PO/SB detalj prissÃ¤ttning',0),(363264,10091,'it','Utilizzare corrente PO/SB dettaglio prezzi',0),(363265,10091,'tl','',0),(363266,10091,'th','à¹ƒà¸Šà¹‰à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸” PO/SB à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¸£à¸²à¸„à¸²',0),(363267,10091,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ªà¥‹/SB à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(363268,10091,'ms','Gunakan semasa PO/SB Detail harga',0),(363269,10091,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø­Ø§Ù„ÙŠ Ø¨Ùˆ/SB ØªÙØ§ØµÙŠÙ„ Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(363270,10091,'fr','Utilisez actuel PO/SB Detail des prix',0),(363271,10091,'jp','ç¾åœ¨ã® PO/SB è©³ç´°ã‚’ä½¿ç”¨ã™ã‚‹ä¾¡æ ¼è¨­å®š',0),(363272,10091,'pt','Usar atual PO/SB detalhes de preÃ§os',0),(363273,10091,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ‚ÐµÐºÑƒÑ‰ÐµÐ³Ð¾ PO/SB Ð´ÐµÑ‚Ð°Ð»Ð¸ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(363274,10091,'es','Usa Sistema de Precios de OC/SB Actual',0),(363275,10091,'de','Verwenden Sie aktuelle PO/SB-Detail Preise',0),(363276,10091,'en','Use Current PO/SB Detail Pricing',0),(363277,10092,'is','',0),(363278,10092,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø´ØºÙ„',0),(363279,10092,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø´ØºÙ„',0),(363280,10092,'tr','Proje bÃ¼tÃ§elerini',0),(363281,10092,'pl','BudÅ¼ety ZleceÅ„',0),(363282,10092,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð¸ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¸',0),(363283,10092,'ur','Ø¬Ø§Ø¨ ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹)',0),(363284,10092,'sr','Ð‘ÑƒÑŸÐµÑ‚Ðµ Ð¿Ð¾ÑÐ»Ð°',0),(363285,10092,'vi','NgÃ¢n sÃ¡ch cÃ´ng viá»‡c',0),(363286,10092,'af','Werkstuk Begrotings',0),(363287,10092,'ro','Job bugetele',0),(363288,10092,'et','Projektieelarvete',0),(363289,10092,'si','PredraÄunov',0),(363290,10092,'ba','Pekerjaan anggaran',0),(363291,10092,'nl','Projectbudgetten',0),(363292,10092,'fi','Projektibudjettien',0),(363293,10092,'no','Prosjektbudsjetter',0),(363294,10092,'da','Sagsbudgetter',0),(363295,10092,'ko','ì¼ìžë¦¬ ì˜ˆì‚°',0),(363296,10092,'he','×”×¢×‘×•×“×” ×ª×§×¦×™×‘×™×',0),(363297,10092,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î­ÏÎ³Î¿Ï…',0),(363298,10092,'zh','ä½œä¸šé¢„ç®—\r\n',0),(363299,10092,'sv','Projektbudgetar',0),(363300,10092,'it','Lavoro bilanci',0),(363301,10092,'tl','',0),(363302,10092,'th','à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸‡à¸²à¸™',0),(363303,10092,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤¬à¤œà¤Ÿ',0),(363304,10092,'ms','Kerja belanjawan',0),(363305,10092,'ar','Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ø§Ù„ÙˆØ¸Ø§Ø¦Ù',0),(363306,10092,'fr','Emploi des Budgets',0),(363307,10092,'jp','ã‚¸ãƒ§ãƒ–ã®äºˆç®—',0),(363308,10092,'pt','OrÃ§amentos de emprego',0),(363309,10092,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ñ‹ Ñ€Ð°Ð±Ð¾Ñ‚',0),(363310,10092,'es','Presupuestos del Trabajos',0),(363311,10092,'de','Projektbudgets',0),(363312,10092,'en','Job Budgets',0),(363313,10093,'is','',0),(363314,10093,'dr','Ú¯Ø±ÙˆÙ‡ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(363315,10093,'pr','Ú¯Ø±ÙˆÙ‡ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ',0),(363316,10093,'tr','Not Kategori',0),(363317,10093,'pl','Uwaga kategorii',0),(363318,10093,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(363319,10093,'ur','Ù†ÙˆÙ¹ Ø²Ù…Ø±Û',0),(363320,10093,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(363321,10093,'vi','ghi chÃº má»¥c lá»¥c',0),(363322,10093,'af','Nota Kategorie',0),(363323,10093,'ro','NotÄƒ categorie',0),(363324,10093,'et','MÃ¤rkus kategooria',0),(363325,10093,'si','Opomba Kategorija',0),(363326,10093,'ba','Kategori catatan',0),(363327,10093,'nl','Opmerking categorie',0),(363328,10093,'fi','Huomautus luokka',0),(363329,10093,'no','Merk kategori',0),(363330,10093,'da','BemÃ¦rk kategori',0),(363331,10093,'ko','ì°¸ê³  ë²”ì£¼',0),(363332,10093,'he','×”×¢×¨×” ×‘×§×˜×’×•×¨×™×”',0),(363333,10093,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(363334,10093,'zh','è¯´æ˜Žç±»åˆ«\r\n',0),(363335,10093,'sv','Obs kategori',0),(363336,10093,'it','Nota categoria',0),(363337,10093,'tl','',0),(363338,10093,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸›à¸£à¸°à¹€à¸ à¸—',0),(363339,10093,'hi','à¤¨à¥‹à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(363340,10093,'ms','Kategori Nota',0),(363341,10093,'ar','ØªØµÙ†ÙŠÙ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø©',0),(363342,10093,'fr','Remarque catÃ©gorie',0),(363343,10093,'jp','æ³¨ã‚«ãƒ†ã‚´ãƒª',0),(363344,10093,'pt','Categoria nota',0),(363345,10093,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð—Ð°Ð¼ÐµÑ‚Ð¾Ðº',0),(363346,10093,'es','CategorÃ­a de Nota',0),(363347,10093,'de','Hinweis-Kategorie',0),(363348,10093,'en','Note Category',0),(363349,10094,'is','',0),(363350,10094,'dr','Ù†Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª',0),(363351,10094,'pr','Ù†Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª',0),(363352,10094,'tr','BÃ¼tÃ§e adÄ± ayarlÄ± deÄŸil',0),(363353,10094,'pl','Nazwa budÅ¼etu nie zestaw',0),(363354,10094,'bg','ÐÐµ Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¾ Ð¸Ð¼Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(363355,10094,'ur','Ø¨Ø¬Ù¹ Ú©Ø§ Ù†Ø§Ù… Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(363356,10094,'sr','Ð˜Ð¼Ðµ Ð±ÑƒÑŸÐµÑ‚Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(363357,10094,'vi','KhÃ´ng cÃ³ tÃªn ngÃ¢n sÃ¡ch',0),(363358,10094,'af','Begrotingnaam Nie Gestel',0),(363359,10094,'ro','Nume buget nu setaÅ£i',0),(363360,10094,'et','Eelarve nimi pole seatud',0),(363361,10094,'si','Ime predraÄuna ni nastavljena',0),(363362,10094,'ba','Nama anggaran tidak diatur',0),(363363,10094,'nl','Naam artikelbudget niet ingesteld',0),(363364,10094,'fi','Budjetin nimi ei ole mÃ¤Ã¤ritetty',0),(363365,10094,'no','Budsjettnavnet ikke angitt',0),(363366,10094,'da','Budgetnavnet ikke indstillet',0),(363367,10094,'ko','ì˜ˆì‚° ì´ë¦„ì´ ì„¤ì • í•˜ì§€',0),(363368,10094,'he','×ª×§×¦×™×‘ ×©× ××™× ×• ×ž×•×’×“×¨',0),(363369,10094,'el','Î”ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(363370,10094,'zh','é¢„ç®—æœªè®¾ç½®åç§°\r\n',0),(363371,10094,'sv','Budgetnamnet inte instÃ¤lld',0),(363372,10094,'it','Nome budget non impostato',0),(363373,10094,'tl','',0),(363374,10094,'th','à¹„à¸¡à¹ˆà¸à¸³à¸«à¸™à¸”à¸Šà¸·à¹ˆà¸­à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“',0),(363375,10094,'hi','à¤¬à¤œà¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤® à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(363376,10094,'ms','Nama bajet tidak ditetapkan',0),(363377,10094,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ø³Ù… Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù„Ø§',0),(363378,10094,'fr','Nom de budget pas dÃ©finie',0),(363379,10094,'jp','äºˆç®—åãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(363380,10094,'pt','OrÃ§amento nome nÃ£o definido',0),(363381,10094,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð° ÐÐµ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾',0),(363382,10094,'es','Nombre de Presupesto No Configurado',0),(363383,10094,'de','Haushalt Name wurde nicht festgelegt.',0),(363384,10094,'en','Budget Name Not Set',0),(363385,10095,'is','',0),(363386,10095,'dr','Ù‡ÙŠÚ† ÙƒØ§Ø±Ø¨Ø±ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(363387,10095,'pr','Ù‡ÙŠÚ† ÙƒØ§Ø±Ø¨Ø±ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ ',0),(363388,10095,'tr','SeÃ§ili kullanÄ±cÄ± yok',0),(363389,10095,'pl','Nie wybrany przez uÅ¼ytkownika',0),(363390,10095,'bg','ÐÐ¸Ñ‚Ð¾ ÐµÐ´Ð¸Ð½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(363391,10095,'ur','Ú©ÙˆØ¦ÛŒ ØµØ§Ø±Ù Ù…Ù†ØªØ®Ø¨',0),(363392,10095,'sr','ÐÐ¸Ñ˜ÐµÐ´Ð°Ð½ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½',0),(363393,10095,'vi','khÃ´ng chá»n ngÆ°á»i sá»­ dá»¥ng',0),(363394,10095,'af','Geen Gebruiker Gekies',0),(363395,10095,'ro','Nici un utilizator selectat',0),(363396,10095,'et','Valitud kasutaja',0),(363397,10095,'si','Ne izbere uporabnik',0),(363398,10095,'ba','Tidak ada pengguna yang dipilih',0),(363399,10095,'nl','Geen gebruiker geselecteerd',0),(363400,10095,'fi','KÃ¤yttÃ¤jÃ¤Ã¤ ei valittu',0),(363401,10095,'no','Ingen bruker valgt',0),(363402,10095,'da','Ingen bruger valgt',0),(363403,10095,'ko','ì‚¬ìš©ìž ì„ íƒ',0),(363404,10095,'he','×œ× × ×‘×—×¨ ×ž×©×ª×ž×©',0),(363405,10095,'el','ÎšÎ±Î½Î­Î½Î±Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ ÎµÏ€Î¹Î»Î­Î¾ÎµÎ¹',0),(363406,10095,'zh','æ²¡æœ‰å·²é€‰çš„ç”¨æˆ·\r\n',0),(363407,10095,'sv','Inga anvÃ¤ndare som valt',0),(363408,10095,'it','Nessun utente selezionato',0),(363409,10095,'tl','',0),(363410,10095,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹„à¸¡à¹ˆà¹€à¸¥à¸·à¸­à¸',0),(363411,10095,'hi','à¤•à¥‹à¤ˆ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤šà¤¯à¤¨à¤¿à¤¤',0),(363412,10095,'ms','Ada pengguna yang dipilih',0),(363413,10095,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(363414,10095,'fr','Aucun utilisateur sÃ©lectionnÃ©',0),(363415,10095,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ãŒé¸æŠžã—ã¾ã—ãŸã€‚',0),(363416,10095,'pt','Nenhum usuÃ¡rio selecionado',0),(363417,10095,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ ÐÐµ Ð’Ñ‹Ð±Ñ€Ð°Ð½',0),(363418,10095,'es','Usuario No Seleccionado',0),(363419,10095,'de','Kein Benutzer ausgewÃ¤hlt',0),(363420,10095,'en','No User Selected',0),(363421,10096,'is','',0),(363422,10096,'dr','ØªØ¹ÙˆÙŠØ¶ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† â€“ Ù„Ø·ÙØ§ ØµØ¨Ø± ÙƒÙ†ÙŠØ¯ ',0),(363423,10096,'pr','ØªØ¹ÙˆÙŠØ¶ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† â€“ Ù„Ø·ÙØ§ ØµØ¨Ø± ÙƒÙ†ÙŠØ¯ ',0),(363424,10096,'tr','Anahtarlama kullanÄ±cÄ±lar - lÃ¼tfen bekleyin',0),(363425,10096,'pl','PrzeÅ‚Ä…czania uÅ¼ytkownikÃ³w - proszÄ™ czekaÄ‡',0),(363426,10096,'bg','ÐŸÑ€ÐµÐ²ÐºÐ»ÑŽÑ‡Ð²Ð°Ð½Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸ - Ð¼Ð¾Ð»Ñ Ð¸Ð·Ñ‡Ð°ÐºÐ°Ð¹Ñ‚Ðµ',0),(363427,10096,'ur','ØµØ§Ø±ÙÛŒÙ† Ø³ÙˆØ¦Ú† Ú©Ø§Ø±ÛŒ - Ø§Ù†ØªØ¸Ø§Ø± Ú©Ø±ÛŒÚº Û”',0),(363428,10096,'sr','ÐŸÑ€ÐµÐ±Ð°Ñ†Ð¸Ð²Ð°ÑšÐµ Ð¸Ð·Ð¼ÐµÑ’Ñƒ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° - Ð¼Ð¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð§ÐµÐºÐ°Ñ˜',0),(363429,10096,'vi','Chuyá»ƒn Ä‘á»•i ngÆ°á»i sá»­ dá»¥ng - Xin vui lÃ²ng Chá»',0),(363430,10096,'af','Wissel van Gebruikers - Wag Asseblief',0),(363431,10096,'ro','Comutare utilizatori - vÄƒ rugÄƒm sÄƒ aÅŸteptaÅ£i',0),(363432,10096,'et','ÃœmberlÃ¼lituvaid kasutajatele - Palun oota',0),(363433,10096,'si','Preklapljanje uporabnikov - prosim poÄakaj',0),(363434,10096,'ba','Switching Users - harap tunggu',0),(363435,10096,'nl','Switch gebruikers - wees zo goed wachten',0),(363436,10096,'fi','Siirtyminen kÃ¤yttÃ¤jÃ¤t - odota',0),(363437,10096,'no','Bytte brukere - vennligst vent',0),(363438,10096,'da','Skifte brugere - venligst vent',0),(363439,10096,'ko','ìŠ¤ìœ„ì¹­ ì‚¬ìš©ìž-ëŒ€ê¸° í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤.',0),(363440,10096,'he','×ž×©×ª×ž×©×™× ×ž×™×ª×•×’ â€“ × × ×”×ž×ª×Ÿ',0),(363441,10096,'el','ÎœÎµÏ„Î±Î³Ï‰Î³Î®Ï‚ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ - Ï€Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï€ÎµÏÎ¹Î¼Î­Î½ÎµÏ„Îµ',0),(363442,10096,'zh','åˆ‡æ¢ç”¨æˆ·- è¯·ç­‰å¾…\r\n',0),(363443,10096,'sv','Byta anvÃ¤ndare - var snÃ¤ll och vÃ¤nta',0),(363444,10096,'it','Commutazione utenti - si prega di attendere',0),(363445,10096,'tl','',0),(363446,10096,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸ªà¸¥à¸±à¸š - à¸à¸£à¸¸à¸“à¸²à¸£à¸­',0),(363447,10096,'hi','à¤¸à¥à¤µà¤¿à¤šà¤¨ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ - à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥à¤°à¤¤à¥€à¤•à¥à¤·à¤¾',0),(363448,10096,'ms','Pensuisan pengguna - Sila tunggu',0),(363449,10096,'ar','Ø§Ù„ØªØ¨Ø¯ÙŠÙ„ Ø¨ÙŠÙ† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†--Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„Ø§Ù†ØªØ¸Ø§Ø±',0),(363450,10096,'fr','Commutation d\'utilisateurs - Veuillez patienter',0),(363451,10096,'jp','ã‚¹ã‚¤ãƒƒãƒãƒ³ã‚° ãƒ¦ãƒ¼ã‚¶ãƒ¼ - ãŠå¾…ã¡ã‚’ãã ã•ã„ã€‚',0),(363452,10096,'pt','ComutaÃ§Ã£o de usuÃ¡rios - por favor, espere',0),(363453,10096,'ru','ÐŸÐµÑ€ÐµÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ - ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° ÐŸÐ¾Ð´Ð¾Ð¶Ð´Ð¸Ñ‚Ðµ',0),(363454,10096,'es','Cambiando Usuarios - Por Favor Espera',0),(363455,10096,'de','Switching Benutzer - bitte warten',0),(363456,10096,'en','Switching Users - Please Wait',0),(363457,10097,'is','',0),(363458,10097,'dr','(Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡ ) Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ',0),(363459,10097,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ…(Ø«Ø¨Øª Ø±ÙˆØ²Ø§Ù†Ù‡ ) Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ',0),(363460,10097,'tr','Olarak giriÅŸ yapÄ±n',0),(363461,10097,'pl','Zaloguj siÄ™ jako',0),(363462,10097,'bg','Ð’Ð»ÐµÐ·Ñ‚Ðµ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° ÐºÐ°Ñ‚Ð¾',0),(363463,10097,'ur','Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº',0),(363464,10097,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ ÑÐµ ÐºÐ°Ð¾',0),(363465,10097,'vi','Ä‘Äƒng nháº­p khi',0),(363466,10097,'af','Inteken As',0),(363467,10097,'ro','LogheazÄƒ-te ca',0),(363468,10097,'et','Logi sisse kui',0),(363469,10097,'si','Prijavite kot',0),(363470,10097,'ba','Log In sebagai',0),(363471,10097,'nl','Log In als',0),(363472,10097,'fi','Kirjaudu sisÃ¤Ã¤n',0),(363473,10097,'no','Logg inn som',0),(363474,10097,'da','Log ind som',0),(363475,10097,'ko','ë¡œ ë¡œê·¸ì¸',0),(363476,10097,'he','×œ×”×™×›× ×¡ ×‘×ª×•×¨',0),(363477,10097,'el','Î£Ï…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Ï‰Ï‚',0),(363478,10097,'zh','ç™»å½•ä¸º\r\n',0),(363479,10097,'sv','Logga In som',0),(363480,10097,'it','Accedere come',0),(363481,10097,'tl','',0),(363482,10097,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¹ƒà¸™',0),(363483,10097,'hi','à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤²à¥‰à¤— à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(363484,10097,'ms','Log masuk sebagai',0),(363485,10097,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(363486,10097,'fr','Connectez-vous en tant que',0),(363487,10097,'jp','ã¨ã—ã¦ãƒ­ã‚°ã‚¤ãƒ³ã—ã¾ã™ã€‚',0),(363488,10097,'pt','Logar como',0),(363489,10097,'ru','Ð’Ð¾Ð¹Ð´Ð¸Ñ‚Ðµ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ ÐºÐ°Ðº',0),(363490,10097,'es','Entrar Como',0),(363491,10097,'de','Melden Sie sich als',0),(363492,10097,'en','Log In As',0),(363493,10098,'is','',0),(363494,10098,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ù¾ÙŠØ´ Ù†Ù…Ø§ÙŠØ´ ',0),(363495,10098,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù Ù¾ÙŠØ´ Ù†Ù…Ø§ÙŠØ´ ',0),(363496,10098,'tr','ÃœrÃ¼n PDF Ã¶nizleme',0),(363497,10098,'pl','PodglÄ…d PDF produktu',0),(363498,10098,'bg','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚ PDF Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(363499,10098,'ur','Ù…ØµÙ†ÙˆØ¹Û PDF Ù¾ÛŒØ´ Ù…Ù†Ø¸Ø±',0),(363500,10098,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ ÐŸÐ”Ð¤ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(363501,10098,'vi','duyá»‡t PDF sáº£n pháº§m',0),(363502,10098,'af','Produk PDF voorskou',0),(363503,10098,'ro','Produs PDF Preview',0),(363504,10098,'et','Toote PDF-i eelvaade',0),(363505,10098,'si','Izdelek PDF predogled',0),(363506,10098,'ba','Produk PDF Tinjauan',0),(363507,10098,'nl','Product PDF-Preview',0),(363508,10098,'fi','Tuotteen PDF esikatselu',0),(363509,10098,'no','Produktet PDF forpremiÃ¨re',0),(363510,10098,'da','PDF Produkteksempel',0),(363511,10098,'ko','ë¯¸ë¦¬ ë³´ê¸° PDF ì œí’ˆ',0),(363512,10098,'he','×”×ž×•×¦×¨ PDF ×ž×§×“×™×ž×”',0),(363513,10098,'el','Î ÏÎ¿ÏŠÏŒÎ½ PDF Ï€ÏÎ¿ÎµÏ€Î¹ÏƒÎºÏŒÏ€Î·ÏƒÎ·',0),(363514,10098,'zh','äº§å“PDFé¢„è§ˆ\r\n',0),(363515,10098,'sv','Produkt PDF fÃ¶rhandsvisningen',0),(363516,10098,'it','Anteprima PDF del prodotto',0),(363517,10098,'tl','',0),(363518,10098,'th','à¸•à¸±à¸§à¸­à¸¢à¹ˆà¸²à¸‡à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œ PDF',0),(363519,10098,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤ªà¥€à¤¡à¥€à¤à¤« à¤ªà¥‚à¤°à¥à¤µà¤¾à¤µà¤²à¥‹à¤•à¤¨',0),(363520,10098,'ms','Produk PDF pratonton',0),(363521,10098,'ar','Ù…Ø¹Ø§ÙŠÙ†Ø© Ø§Ù„Ù…Ù†ØªØ¬ PDF',0),(363522,10098,'fr','AperÃ§u du produit PDF',0),(363523,10098,'jp','è£½å“ã® PDF ãƒ—ãƒ¬ãƒ“ãƒ¥ãƒ¼',0),(363524,10098,'pt','VisualizaÃ§Ã£o PDF do produto',0),(363525,10098,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° PDF',0),(363526,10098,'es','Vista Previa del Producto PDF',0),(363527,10098,'de','Produkt-PDF-Vorschau',0),(363528,10098,'en','Product PDF Preview',0),(363529,10099,'is','',0),(363530,10099,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙŠÙ„ ØµÙˆØªÙŠ ',0),(363531,10099,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙŠÙ„ ØµÙˆØªÙŠ ',0),(363532,10099,'tr','ÃœrÃ¼n ses dosyasÄ±',0),(363533,10099,'pl','Plik dÅºwiÄ™kowy produktu',0),(363534,10099,'bg','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚ Ð·Ð²ÑƒÐºÐ¾Ð² Ñ„Ð°Ð¹Ð»',0),(363535,10099,'ur','Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ Ø¢ÙˆØ§Ø² Ù…Ø³Ù„',0),(363536,10099,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ Ð·Ð²ÑƒÑ‡Ð½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(363537,10099,'vi','file Ã¢m thanh sáº£n pháº©m',0),(363538,10099,'af','Produk KlanklÃªer',0),(363539,10099,'ro','FiÅŸier de sunet produs',0),(363540,10099,'et','Toote helifail',0),(363541,10099,'si','Izdelek zvoÄne datoteke',0),(363542,10099,'ba','File suara produk',0),(363543,10099,'nl','Product geluid bestand',0),(363544,10099,'fi','Tuotteen Ã¤Ã¤nitiedosto',0),(363545,10099,'no','Produktet lyd fil',0),(363546,10099,'da','Produkt lydfil',0),(363547,10099,'ko','ì œí’ˆ ì†Œë¦¬ íŒŒì¼',0),(363548,10099,'he','×§×•×‘×¥ ×¦×œ×™×œ ×”×ž×•×¦×¨',0),(363549,10099,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Î®Ï‡Î¿Ï… Ï€ÏÎ¿ÏŠÏŒÎ½',0),(363550,10099,'zh','äº§å“å£°éŸ³æ–‡ä»¶\r\n',0),(363551,10099,'sv','Produkt fil',0),(363552,10099,'it','File suono prodotto',0),(363553,10099,'tl','',0),(363554,10099,'th','à¹à¸Ÿà¹‰à¸¡à¹€à¸ªà¸µà¸¢à¸‡à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œ',0),(363555,10099,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤§à¥à¤µà¤¨à¤¿ à¤«à¤¼à¤¾à¤‡à¤²',0),(363556,10099,'ms','Fail bunyi produk',0),(363557,10099,'ar','Ù…Ù„ÙÙ‘ ØµÙˆØª Ø§Ù„ØµÙ†Ù',0),(363558,10099,'fr','Produit Sound File',0),(363559,10099,'jp','è£½å“ã‚µã‚¦ãƒ³ãƒ‰ ãƒ•ã‚¡ã‚¤ãƒ«',0),(363560,10099,'pt','Arquivo de som do produto',0),(363561,10099,'ru','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚ Ð·Ð²ÑƒÐºÐ¾Ð²Ð¾Ð¹ Ñ„Ð°Ð¹Ð»',0),(363562,10099,'es','File de Sonido del Producto',0),(363563,10099,'de','Produkt-Sound-Datei',0),(363564,10099,'en','Product Sound File',0),(363565,10100,'is','',0),(363566,10100,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙŠÙ„ ÙˆÙŠØ¯Ø¦ÙˆÙŠÙŠ',0),(363567,10100,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙŠÙ„ ÙˆÙŠØ¯Ø¦ÙˆÙŠÙŠ',0),(363568,10100,'tr','ÃœrÃ¼n Video dosyasÄ±',0),(363569,10100,'pl','Plik wideo produktu',0),(363570,10100,'bg','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚ Ð²Ð¸Ð´ÐµÐ¾ Ñ„Ð°Ð¹Ð»',0),(363571,10100,'ur','Ù…ØµÙ†ÙˆØ¹Û ÙˆÚˆÛŒÙˆ Ù…Ø³Ù„',0),(363572,10100,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ Ð’Ð¸Ð´ÐµÐ¾ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(363573,10100,'vi','file hÃ¬nh áº£nh sáº£n pháº©m',0),(363574,10100,'af','Produk VideolÃªer',0),(363575,10100,'ro','FiÅŸiere Video produs',0),(363576,10100,'et','Toote Video faili',0),(363577,10100,'si','Izdelek Video datoteke',0),(363578,10100,'ba','File Video produk',0),(363579,10100,'nl','Product Video bestand',0),(363580,10100,'fi','Tuotteen videotiedosto',0),(363581,10100,'no','Produktet videofil',0),(363582,10100,'da','Produkt Video fil',0),(363583,10100,'ko','ì œí’ˆ ë¹„ë””ì˜¤ íŒŒì¼',0),(363584,10100,'he','×¡×¨×˜×•×Ÿ ×ž×•×¦×¨',0),(363585,10100,'el','Î ÏÎ¿ÏŠÏŒÎ½ Î±ÏÏ‡ÎµÎ¯Î¿ Î²Î¯Î½Ï„ÎµÎ¿',0),(363586,10100,'zh','äº§å“è§†é¢‘æ–‡ä»¶\r\n',0),(363587,10100,'sv','Produkt videofil',0),(363588,10100,'it','File Video prodotto',0),(363589,10100,'tl','',0),(363590,10100,'th','à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¹à¸Ÿà¹‰à¸¡à¸§à¸´à¸”à¸µà¹‚à¸­',0),(363591,10100,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤µà¥€à¤¡à¤¿à¤¯à¥‹ à¤«à¤¼à¤¾à¤‡à¤²',0),(363592,10100,'ms','Fail Video produk',0),(363593,10100,'ar','Ù…Ù„Ù Ø§Ù„ÙÙŠØ¯ÙŠÙˆ Ø§Ù„Ù†Ø§ØªØ¬',0),(363594,10100,'fr','Fichier vidÃ©o produit',0),(363595,10100,'jp','è£½å“ãƒ“ãƒ‡ã‚ª ãƒ•ã‚¡ã‚¤ãƒ«',0),(363596,10100,'pt','Arquivo de vÃ­deo de produto',0),(363597,10100,'ru','Ð’Ð¸Ð´ÐµÐ¾ Ñ„Ð°Ð¹Ð» Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(363598,10100,'es','File de Video del Producto',0),(363599,10100,'de','Produkt-Video-Datei',0),(363600,10100,'en','Product Video File',0),(363601,10101,'is','',0),(363602,10101,'dr','Ø­Ø°Ù Ø¨Ø§Ø² Ø¨ÙŠÙ†ÙŠ ÙØ§ÙŠÙ„  Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ØªÙˆÙ„ÙŠØ¯ ',0),(363603,10101,'pr','Ø­Ø°Ù Ø¨Ø§Ø² Ø¨ÙŠÙ†ÙŠ ÙØ§ÙŠÙ„  Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ØªÙˆÙ„ÙŠØ¯ ',0),(363604,10101,'tr','ÃœrÃ¼n PDF Ã¶nizleme Sil',0),(363605,10101,'pl','Usuwanie produktu PDF PodglÄ…d',0),(363606,10101,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ PDF Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(363607,10101,'ur','Ù…ØµÙ†ÙˆØ¹Û PDF Ù¾ÛŒØ´ Ù…Ù†Ø¸Ø± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(363608,10101,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ ÐŸÐ”Ð¤',0),(363609,10101,'vi','xÃ³a Ä‘Ã¡nh giÃ¡ sáº£n pháº©m PDF',0),(363610,10101,'af','Skrap Produk PDF Voorskou',0),(363611,10101,'ro','Åžtergere produs PDF Preview',0),(363612,10101,'et','Kustuta toote PDF eelvaade',0),(363613,10101,'si','Izbrisati izdelek PDF predogled',0),(363614,10101,'ba','Menghapus produk PDF Tinjauan',0),(363615,10101,'nl','Verwijderen Product PDF-Preview',0),(363616,10101,'fi','Poista tuotteen PDF esikatselu',0),(363617,10101,'no','Slette produktet PDF forpremiÃ¨re',0),(363618,10101,'da','Slette PDF Produkteksempel',0),(363619,10101,'ko','ì œí’ˆ PDF ë¯¸ë¦¬ ë³´ê¸° ì‚­ì œ',0),(363620,10101,'he','×ž×—×§ ×ž×•×¦×¨ PDF ×ž×§×“×™×ž×”',0),(363621,10101,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ Ï€ÏÎ¿ÏŠÏŒÎ½ PDF Ï€ÏÎ¿ÎµÏ€Î¹ÏƒÎºÏŒÏ€Î·ÏƒÎ·',0),(363622,10101,'zh','åˆªé™¤ç”¢å“PDFé è¦½',0),(363623,10101,'sv','Ta bort produkt PDF fÃ¶rhandsvisningen',0),(363624,10101,'it','Eliminare l\'anteprima del prodotto PDF',0),(363625,10101,'tl','',0),(363626,10101,'th','à¸¥à¸šà¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œ PDF à¹à¸ªà¸”à¸‡à¸•à¸±à¸§à¸­à¸¢à¹ˆà¸²à¸‡',0),(363627,10101,'hi','à¤ªà¥€ à¤¡à¥€ à¤à¤«à¤¼ à¤ªà¥‚à¤°à¥à¤µà¤¾à¤µà¤²à¥‹à¤•à¤¨ à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(363628,10101,'ms','Menghapuskan produk PDF pratonton',0),(363629,10101,'ar','Ø­Ø°Ù Ø§Ù„Ù…Ù†ØªØ¬ Ù…Ø¹Ø§ÙŠÙ†Ø© PDF',0),(363630,10101,'fr','Supprimer PDF aperÃ§u du produit',0),(363631,10101,'jp','è£½å“ã® PDF ãƒ—ãƒ¬ãƒ“ãƒ¥ãƒ¼ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(363632,10101,'pt','Excluir produto PDF Preview',0),(363633,10101,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° PDF Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€',0),(363634,10101,'es','Elimina PDF de Vista Previa del Producto',0),(363635,10101,'de','Produkt-PDF-Vorschau zu lÃ¶schen',0),(363636,10101,'en','Delete Product PDF Preview',0),(363637,10102,'is','',0),(363638,10102,'dr','Ø­Ø°Ù ÙØ§ÙŠÙ„ ØµÙˆØªÙŠ ØªÙˆÙ„ÙŠØ¯ ',0),(363639,10102,'pr','Ø­Ø°Ù ÙØ§ÙŠÙ„ ØµÙˆØªÙŠ ØªÙˆÙ„ÙŠØ¯ ',0),(363640,10102,'tr','DELETE Ã¼rÃ¼n ses dosyasÄ±',0),(363641,10102,'pl','UsuÅ„ produkt Sound pliku',0),(363642,10102,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ Ð·Ð²ÑƒÐºÐ¾Ð² Ñ„Ð°Ð¹Ð»',0),(363643,10102,'ur','Ø­Ø°Ù Ú©ÛŒ Ù…ØµÙ†ÙˆØ¹Ø§Øª Ø¢ÙˆØ§Ø² Ù…Ø³Ù„',0),(363644,10102,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ Ð·Ð²ÑƒÑ‡Ð½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(363645,10102,'vi','xÃ³a file Ã¢m thanh sáº£n pháº©m',0),(363646,10102,'af','Skrap Produk KlanklÃªer',0),(363647,10102,'ro','Åžtergere produs sunet fiÅŸier',0),(363648,10102,'et','Kustuta toote helifail',0),(363649,10102,'si','Brisanje izdelkov zvok pila',0),(363650,10102,'ba','Suara produk Hapus File',0),(363651,10102,'nl','Verwijderen Product geluid bestand',0),(363652,10102,'fi','Poista tuotteen Ã¤Ã¤nitiedosto',0),(363653,10102,'no','Slett produktet lyd fil',0),(363654,10102,'da','Slet produkt lydfil',0),(363655,10102,'ko','ì‚­ì œ ì œí’ˆ ì‚¬ìš´ë“œ íŒŒì¼',0),(363656,10102,'he','×¦×œ×™×œ ×”×ž×•×¦×¨ ×ž×—×§ ×§×•×‘×¥',0),(363657,10102,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚ Î®Ï‡Î¿Ï… Î±ÏÏ‡ÎµÎ¯Î¿',0),(363658,10102,'zh','åˆªé™¤ç”¢å“è²éŸ³æ–‡ä»¶',0),(363659,10102,'sv','Ta bort produkt fil',0),(363660,10102,'it','Suono prodotto Elimina File',0),(363661,10102,'tl','',0),(363662,10102,'th','à¹€à¸ªà¸µà¸¢à¸‡à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¸¥à¸šà¹à¸Ÿà¹‰à¸¡',0),(363663,10102,'hi','Delete à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤§à¥à¤µà¤¨à¤¿ à¤«à¤¼à¤¾à¤‡à¤²',0),(363664,10102,'ms','Bunyi produk Hapus fail',0),(363665,10102,'ar','Ø­Ø°Ù Ù…Ù„ÙÙ‘ ØµÙˆØª Ø§Ù„ØµÙ†Ù',0),(363666,10102,'fr','Delete produit Sound File',0),(363667,10102,'jp','å‰Šé™¤è£½å“ã‚µã‚¦ãƒ³ãƒ‰ ãƒ•ã‚¡ã‚¤ãƒ«',0),(363668,10102,'pt','Excluir produto som arquivo',0),(363669,10102,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð—Ð²ÑƒÐºÐ¾Ð²Ð¾Ð¹ Ð¤Ð°Ð¹Ð» ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(363670,10102,'es','Elimina File de Sonido del Producto',0),(363671,10102,'de','Delete-Produkt-Sound-Datei',0),(363672,10102,'en','Delete Product Sound File',0),(363673,10103,'is','',0),(363674,10103,'dr','Ø­Ø°Ù ÙØ§ÙŠÙ„ ØªØµÙˆÙŠØ±ÙŠ  ØªÙˆÙ„ÙŠØ¯',0),(363675,10103,'pr','Ø­Ø°Ù ÙØ§ÙŠÙ„ ØªØµÙˆÙŠØ±ÙŠ  ØªÙˆÙ„ÙŠØ¯',0),(363676,10103,'tr','ÃœrÃ¼n Video dosyasÄ±nÄ± silin',0),(363677,10103,'pl','UsuÅ„ plik wideo produktu',0),(363678,10103,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ Ð²Ð¸Ð´ÐµÐ¾ Ñ„Ð°Ð¹Ð»',0),(363679,10103,'ur','Ù…ØµÙ†ÙˆØ¹Û ÙˆÚˆÛŒÙˆ Ù…Ø³Ù„ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(363680,10103,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ Ð’Ð¸Ð´ÐµÐ¾ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(363681,10103,'vi','xÃ³a file hÃ¬nh áº£nh sáº£n pháº©m',0),(363682,10103,'af','Skrap Produk VideolÃªer',0),(363683,10103,'ro','ÅžtergeÅ£i fiÅŸierul Video produs',0),(363684,10103,'et','Kustuta toote videofail',0),(363685,10103,'si','Izbrisati izdelek Video datoteke',0),(363686,10103,'ba','Menghapus File Video produk',0),(363687,10103,'nl','Product videobestand verwijderen',0),(363688,10103,'fi','Poista tuote Video tiedosto',0),(363689,10103,'no','Slette produktet videofil',0),(363690,10103,'da','Slette fabrikat Video fil',0),(363691,10103,'ko','ì œí’ˆ ë¹„ë””ì˜¤ íŒŒì¼ ì‚­ì œ',0),(363692,10103,'he','×ž×—×™×§×ª ×§×•×‘×¥ ×•×™×“××• ×”×ž×•×¦×¨',0),(363693,10103,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±ÏÏ‡ÎµÎ¯Î¿ Î²Î¯Î½Ï„ÎµÎ¿ Ï€ÏÎ¿ÏŠÏŒÎ½',0),(363694,10103,'zh','äº§å“è§†é¢‘æ–‡ä»¶åˆ é™¤\r\n',0),(363695,10103,'sv','Ta bort produkt videofil',0),(363696,10103,'it','Eliminare il File Video prodotto',0),(363697,10103,'tl','',0),(363698,10103,'th','à¸¥à¸šà¹à¸Ÿà¹‰à¸¡à¸§à¸´à¸”à¸µà¹‚à¸­à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(363699,10103,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤µà¥€à¤¡à¤¿à¤¯à¥‹ à¤«à¤¼à¤¾à¤‡à¤² à¤¹à¤Ÿà¤¾à¤à¤',0),(363700,10103,'ms','Menghapuskan fail Video produk',0),(363701,10103,'ar','Ø­Ø°Ù Ù…Ù„Ù Ø§Ù„ÙÙŠØ¯ÙŠÙˆ Ø§Ù„Ù†Ø§ØªØ¬',0),(363702,10103,'fr','Supprimer le fichier vidÃ©o produit',0),(363703,10103,'jp','è£½å“ã®ãƒ“ãƒ‡ã‚ªã®ãƒ•ã‚¡ã‚¤ãƒ«ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(363704,10103,'pt','Excluir o arquivo de vÃ­deo de produto',0),(363705,10103,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð’Ð¸Ð´ÐµÐ¾ Ð¤Ð°Ð¹Ð» ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(363706,10103,'es','Elimina File de Video del Producto',0),(363707,10103,'de','Produkt-Video-Datei zu lÃ¶schen',0),(363708,10103,'en','Delete Product Video File',0),(363709,10104,'is','',0),(363710,10104,'dr','Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(363711,10104,'pr','Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(363712,10104,'tr','HastalÄ±k izni kullanÄ±lan',0),(363713,10104,'pl','Chorobowe wykorzystywane',0),(363714,10104,'bg','ÐžÑ‚Ð¿ÑƒÑÐº ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°',0),(363715,10104,'ur','Ø¨ÛŒÙ…Ø§Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú†Ú¾ÙˆÚ‘ÛŒÚº',0),(363716,10104,'sr','Ð‘Ð¾Ð»Ð¾Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(363717,10104,'vi','PhÃ©p nghá»‰ bá»‡nh Ä‘Æ°á»£c sá»­ dá»¥ng',0),(363718,10104,'af','Siekverlof Gebruik',0),(363719,10104,'ro','Concediu medical folosit',0),(363720,10104,'et','Kasutatud haiguslehel',0),(363721,10104,'si','BolniÅ¡ka odsotnost, ki se uporablja',0),(363722,10104,'ba','Cuti digunakan',0),(363723,10104,'nl','Ziekteverlof gebruikt',0),(363724,10104,'fi','KÃ¤ytetty sairasloma',0),(363725,10104,'no','SykefravÃ¦r brukes',0),(363726,10104,'da','SygefravÃ¦r anvendes',0),(363727,10104,'ko','ë³‘ê°€ ì‚¬ìš©',0),(363728,10104,'he','×©×™×ž×•×© ×“×ž×™ ×ž×—×œ×”',0),(363729,10104,'el','Î‘Î½Î±ÏÏÏ‰Ï„Î¹ÎºÎ® Î¬Î´ÎµÎ¹Î± Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹',0),(363730,10104,'zh','å·²ä½¿ç”¨çš„ç—…å‡\r\n',0),(363731,10104,'sv','Sjukskrivning som anvÃ¤nds',0),(363732,10104,'it','Congedo usato',0),(363733,10104,'tl','',0),(363734,10104,'th','à¸¥à¸²à¸›à¹ˆà¸§à¸¢à¸—à¸µà¹ˆà¹ƒà¸Šà¹‰',0),(363735,10104,'hi','à¤¬à¥€à¤®à¤¾à¤° à¤›à¥‹à¤¡à¤¼ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(363736,10104,'ms','Cuti sakit yang digunakan',0),(363737,10104,'ar','Ø§Ù„Ø¥Ø¬Ø§Ø²Ø© Ø§Ù„Ù…Ø±Ø¶ÙŠØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(363738,10104,'fr','CongÃ© de maladie utilisÃ©',0),(363739,10104,'jp','ç—…æ°—ä¼‘æš‡ã®ä½¿ç”¨',0),(363740,10104,'pt','LicenÃ§a usada',0),(363741,10104,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¾Ñ‚Ð¿ÑƒÑÐº Ð¿Ð¾ Ð±Ð¾Ð»ÐµÐ·Ð½Ð¸',0),(363742,10104,'es','VacaciÃ³n de Enfermedad Usada',0),(363743,10104,'de','Krankheitstage verwendet',0),(363744,10104,'en','Sick Leave Used',0),(363745,10105,'is','',0),(363746,10105,'dr','Ù…Ø±Ø®ØµÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(363747,10105,'pr','Ù…Ø±Ø®ØµÙŠ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(363748,10105,'tr','KullanÄ±lan tatil',0),(363749,10105,'pl','Wakacje uÅ¼ywane',0),(363750,10105,'bg','Ð’Ð°ÐºÐ°Ð½Ñ†Ð¸Ñ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°',0),(363751,10105,'ur','Ú†Ú¾Ù¹ÛŒÙˆÚº Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(363752,10105,'sr','ÐžÐ´Ð¼Ð¾Ñ€ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(363753,10105,'vi','ká»³ nghá»‰ Ä‘Ã£ sá»­ dá»¥ng',0),(363754,10105,'af','Vakansie Gebruik',0),(363755,10105,'ro','Vacanta utilizate',0),(363756,10105,'et','Kasutatud puhkus',0),(363757,10105,'si','PoÄitnice, ki se uporablja',0),(363758,10105,'ba','Liburan yang digunakan',0),(363759,10105,'nl','Vakantie gebruikt',0),(363760,10105,'fi','Loma kÃ¤ytetÃ¤Ã¤n',0),(363761,10105,'no','Ferie brukes',0),(363762,10105,'da','Ferie bruges',0),(363763,10105,'ko','íœ´ê°€ ì‚¬ìš©',0),(363764,10105,'he','×—×•×¤×©×” ×‘×©×™×ž×•×©',0),(363765,10105,'el','Î”Î¹Î±ÎºÎ¿Ï€Î­Ï‚ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹',0),(363766,10105,'zh','å·²ç”¨å‡æœŸ\r\n',0),(363767,10105,'sv','Semester anvÃ¤nds',0),(363768,10105,'it','Vacanza usato',0),(363769,10105,'tl','',0),(363770,10105,'th','à¹ƒà¸Šà¹‰à¸§à¸±à¸™à¸«à¸¢à¸¸à¸”à¸žà¸±à¸à¸œà¹ˆà¸­à¸™',0),(363771,10105,'hi','à¤‰à¤ªà¤¯à¥‹à¤— à¤›à¥à¤Ÿà¥à¤Ÿà¥€',0),(363772,10105,'ms','Percutian yang digunakan',0),(363773,10105,'ar','Ø¹Ø·Ù„Ø© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(363774,10105,'fr','Vacances utilisÃ©',0),(363775,10105,'jp','ä¼‘æš‡ã®ä½¿ç”¨',0),(363776,10105,'pt','FÃ©rias usada',0),(363777,10105,'ru','ÐžÑ‚Ð¿ÑƒÑÐº Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½',0),(363778,10105,'es','Vacaciones Usadas',0),(363779,10105,'de','Urlaub verwendet',0),(363780,10105,'en','Vacation Used',0),(363781,10106,'is','',0),(363782,10106,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù…ÙƒØ§Ù† ÙŠØ§Ø¨ÙŠ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(363783,10106,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù…ÙƒØ§Ù† ÙŠØ§Ø¨ÙŠ Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÙŠ Ø¨Ø§Ù†ÙƒÙŠ ',0),(363784,10106,'tr','Ã‡ek hesabÄ± bulma hatasÄ±',0),(363785,10106,'pl','BÅ‚Ä…d lokalizowania konto czekowe',0),(363786,10106,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð½Ð°Ð¼Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(363787,10106,'ur','Ù†Ù‚Øµ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ ÚˆÚ¾ÙˆÙ†Úˆ Ø±ÛØ§ ÛÛ’',0),(363788,10106,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð»Ð¾Ñ†Ð¸Ñ€Ð°ÑšÑƒ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(363789,10106,'vi','Lá»—i kiá»ƒm tra vá»‹ trÃ­ tÃ i khoáº£n',0),(363790,10106,'af','Fout opspoor gaan rekening',0),(363791,10106,'ro','Eroare Verificarea cont de localizarea',0),(363792,10106,'et','Vea leidmine pangakonto',0),(363793,10106,'si','Napaka pri lociranju preverjanje raÄuna',0),(363794,10106,'ba','Kesalahan menemukan rekening',0),(363795,10106,'nl','Fout zoeken betaalrekening',0),(363796,10106,'fi','Virhe etsittÃ¤essÃ¤ tarkkailun huomioon',0),(363797,10106,'no','Finner brukskonto',0),(363798,10106,'da','Fejl under sÃ¸gning efter checkkonto',0),(363799,10106,'ko','ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œë¥¼ ì°¾ê¸° ì˜¤ë¥˜',0),(363800,10106,'he','×©×’×™××” ×‘××™×ª×•×¨ ×—×©×‘×•×Ÿ ×‘× ×§',0),(363801,10106,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ½Ï„Î¿Ï€Î¹ÏƒÎ¼Î¿Ï Ï„ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(363802,10106,'zh','æ”¯ç¥¨å¸æˆ·çš„å®šä½é”™è¯¯',0),(363803,10106,'sv','Fel att lokalisera lÃ¶nekonto',0),(363804,10106,'it','Errore individuazione di conto corrente',0),(363805,10106,'tl','',0),(363806,10106,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸šà¸±à¸à¸Šà¸µ',0),(363807,10106,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤šà¥‡à¤•à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¤¾ à¤¢à¥‚à¤à¤¢ à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(363808,10106,'ms','Ralat mengesan memeriksa akaun',0),(363809,10106,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ¯ Ù…ÙˆÙ‚Ø¹ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø­Ø³Ø§Ø¨',0),(363810,10106,'fr','Erreur localisation compte-chÃ¨ques',0),(363811,10106,'jp','å½“åº§é é‡‘å£åº§ã‚’æ¤œç´¢ã™ã‚‹ã‚¨ãƒ©ãƒ¼',0),(363812,10106,'pt','Erro ao localizar a conta corrente',0),(363813,10106,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð¸ÑÐºÐµ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚',0),(363814,10106,'es','Error Encontrar Cuenta de Cheques',0),(363815,10106,'de','Fehler suchen Girokonto',0),(363816,10106,'en','Error Locating Checking Account',0),(363817,10107,'is','',0),(363818,10107,'dr','Ø³ÙˆØ¯ Ø³Ø§Ù„Ø§Ù†Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(363819,10107,'pr','Ø³ÙˆØ¯ Ø³Ø§Ù„Ø§Ù†Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(363820,10107,'tr','Kar yÄ±l Tarih',0),(363821,10107,'pl','Zysku roku do data',0),(363822,10107,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° ÐºÑŠÐ¼ Ð´Ð°Ñ‚Ð°',0),(363823,10107,'ur','Ù…Ù†Ø§ÙØ¹ Ø³Ø§Ù„-Ú©Ø±Ù†Ø§-ØªØ§Ø±ÛŒØ®',0),(363824,10107,'sr','Ð”Ð¾Ð±Ð¸Ñ‚ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð´Ð¾ Ð´Ð°Ð½Ð°Ñ',0),(363825,10107,'vi','lá»£i nhuÃ¢n nÄƒm Ä‘áº¿n ngÃ y',0),(363826,10107,'af','Wins Jaar-tot-Datum',0),(363827,10107,'ro','Profit an la data',0),(363828,10107,'et','Kasum aasta kuupÃ¤ev',0),(363829,10107,'si','DobiÄka leto do datuma',0),(363830,10107,'ba','Keuntungan tahun-to-Date',0),(363831,10107,'nl','Winst jaar-to-Date',0),(363832,10107,'fi','Tuotto vuoden alusta',0),(363833,10107,'no','Fortjeneste Ã¥r-til-dato',0),(363834,10107,'da','Profit Ã¥r-til-dato',0),(363835,10107,'ko','ì´ìµ 1 ë…„-ë‚ ì§œ',0),(363836,10107,'he','×¨×•×•×— ×”×©× ×” ×¢×“ ×”×™×•×',0),(363837,10107,'el','ÎšÎ­ÏÎ´Î¿Ï‚ Î­Ï„Î¿Ï…Ï‚-to-Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(363838,10107,'zh','èŽ·åˆ©å¹´åˆ°\r\n',0),(363839,10107,'sv','Vinst Ã¥r till-datum',0),(363840,10107,'it','Profitto per anno',0),(363841,10107,'tl','',0),(363842,10107,'th','à¸à¸³à¹„à¸£à¸à¸±à¸šà¸•à¹‰à¸™à¸›à¸µ',0),(363843,10107,'hi','à¤²à¤¾à¤­-à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(363844,10107,'ms','Keuntungan tahun-hingga kini',0),(363845,10107,'ar','Ø±Ø¨Ø­ Ø§Ù„Ø³Ù†Ø© Ø¥Ù„Ù‰ ØªØ§Ø±ÙŠØ®',0),(363846,10107,'fr','Profit Year-to-Date',0),(363847,10107,'jp','åˆ©ç›Šå¹´é–“æ—¥',0),(363848,10107,'pt','Lucro Year-to-Date',0),(363849,10107,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ Ð³Ð¾Ð´ Ðº Ð”Ð°Ñ‚Ð°',0),(363850,10107,'es','Utilidad AÃ±o-a La-Fecha',0),(363851,10107,'de','Gewinn-Year-to-Date',0),(363852,10107,'en','Profit Year-to-Date',0),(363853,10108,'is','',0),(363854,10108,'dr','ÙƒÙ„ Ø³ÙˆØ¯',0),(363855,10108,'pr','ÙƒÙ„ Ø³ÙˆØ¯',0),(363856,10108,'tr','Toplam kar',0),(363857,10108,'pl','CaÅ‚kowity zysk',0),(363858,10108,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(363859,10108,'ur','Ú©Ù„ Ù…Ù†Ø§ÙØ¹',0),(363860,10108,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð·Ð°Ñ€Ð°Ð´Ð°',0),(363861,10108,'vi','Tá»•ng lá»£i nhuáº­n',0),(363862,10108,'af','Totale Wins',0),(363863,10108,'ro','Profitul total de pe',0),(363864,10108,'et','Kokku kasum',0),(363865,10108,'si','Celoten dobiÄek',0),(363866,10108,'ba','Total Profit',0),(363867,10108,'nl','Totale winst',0),(363868,10108,'fi','Kokonaisvoiton',0),(363869,10108,'no','Samlet overskudd',0),(363870,10108,'da','Samlede fortjeneste',0),(363871,10108,'ko','ì´ ìˆ˜ìµ',0),(363872,10108,'he','×”×¨×•×•×— ×”×›×•×œ×œ',0),(363873,10108,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÎºÎ­ÏÎ´Î¿Ï‚',0),(363874,10108,'zh','åˆ©æ¶¦æ€»é¢\r\n',0),(363875,10108,'sv','Total vinst',0),(363876,10108,'it','Profitto totale',0),(363877,10108,'tl','',0),(363878,10108,'th','à¸à¸³à¹„à¸£à¸£à¸§à¸¡',0),(363879,10108,'hi','à¤•à¥à¤² à¤²à¤¾à¤­',0),(363880,10108,'ms','Jumlah keuntungan',0),(363881,10108,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø±Ø¨Ø­',0),(363882,10108,'fr','Profit total',0),(363883,10108,'jp','ç·åˆ©ç›Š',0),(363884,10108,'pt','Lucro total',0),(363885,10108,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ',0),(363886,10108,'es','Ganancia Total',0),(363887,10108,'de','Gesamtgewinn',0),(363888,10108,'en','Total Profit',0),(363889,10109,'is','',0),(363890,10109,'dr','( Ù¾ÙŠØ´ ÙØ±Ø¶ Ø§Ø±Ø²Ø´',0),(363891,10109,'pr','ØªÙ†Ø¸ÙŠÙ… Ø®ÙˆØ¯ÙƒØ§Ø±( Ù¾ÙŠØ´ ÙØ±Ø¶ Ø§Ø±Ø²Ø´',0),(363892,10109,'tr','VarsayÄ±lan deÄŸerler',0),(363893,10109,'pl','WartoÅ›ci domyÅ›lne',0),(363894,10109,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(363895,10109,'ur','Ø·Û’ Ø´Ø¯Û Ù‚Ø¯Ø±ÙˆÚº',0),(363896,10109,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(363897,10109,'vi','GiÃ¡ trá»‹ máº·c Ä‘á»‹nh',0),(363898,10109,'af','Verstekte Waardes',0),(363899,10109,'ro','Valorile implicite',0),(363900,10109,'et','VaikevÃ¤Ã¤rtused',0),(363901,10109,'si','Privzete vrednosti',0),(363902,10109,'ba','Nilai default',0),(363903,10109,'nl','Standaardwaarden',0),(363904,10109,'fi','Oletusarvot',0),(363905,10109,'no','Standardverdier',0),(363906,10109,'da','StandardvÃ¦rdier',0),(363907,10109,'ko','ê¸°ë³¸ ê°’',0),(363908,10109,'he','×¢×¨×›×™ ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(363909,10109,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Ï„Î¹Î¼Î­Ï‚',0),(363910,10109,'zh','é»˜è®¤å€¼\r\n',0),(363911,10109,'sv','StandardvÃ¤rden',0),(363912,10109,'it','Valori predefiniti',0),(363913,10109,'tl','',0),(363914,10109,'th','à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(363915,10109,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¤¾à¤¨',0),(363916,10109,'ms','Nilai-nilai lalai',0),(363917,10109,'ar','Ø§Ù„Ù‚ÙŠÙ… Ø§Ù„Ø¥ÙØªØ±Ø§Ø¶ÙŠØ©',0),(363918,10109,'fr','Valeurs par dÃ©faut',0),(363919,10109,'jp','æ—¢å®šå€¤',0),(363920,10109,'pt','Valores padrÃ£o',0),(363921,10109,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(363922,10109,'es','Valores por Defecto',0),(363923,10109,'de','Standardwerte',0),(363924,10109,'en','Default Values',0),(363925,10110,'is','',0),(363926,10110,'dr','Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(363927,10110,'pr','Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(363928,10110,'tr','Fatura biÃ§imlendirme',0),(363929,10110,'pl','Faktura formatowanie',0),(363930,10110,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(363931,10110,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ÙˆØ¶Ø¹ Ú©Ø§Ø±ÛŒ',0),(363932,10110,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¾Ð±Ð»Ð¸ÐºÐ¾Ð²Ð°ÑšÐ°',0),(363933,10110,'vi','dáº¡ng hÃ³a Ä‘Æ¡n',0),(363934,10110,'af','Faktuur Formatering',0),(363935,10110,'ro','FacturÄƒ de formatare',0),(363936,10110,'et','Arve vormindamine',0),(363937,10110,'si','Oblikovanje raÄuna',0),(363938,10110,'ba','Faktur format',0),(363939,10110,'nl','Factuur opmaken',0),(363940,10110,'fi','Laskun muotoilu',0),(363941,10110,'no','Faktura formatering',0),(363942,10110,'da','Faktura formatering',0),(363943,10110,'ko','ì²­êµ¬ì„œ ì„œì‹',0),(363944,10110,'he','×¢×™×¦×•×‘ ×—×©×‘×•× ×™×ª',0),(363945,10110,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¼Î¿ÏÏ†Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(363946,10110,'zh','å‘ç¥¨æ ¼å¼\r\n',0),(363947,10110,'sv','Faktura formatering',0),(363948,10110,'it','Fattura formattazione',0),(363949,10110,'tl','',0),(363950,10110,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(363951,10110,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¸à¥à¤µà¤°à¥‚à¤ªà¤£',0),(363952,10110,'ms','Format invois',0),(363953,10110,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(363954,10110,'fr','Facture de mise en forme',0),(363955,10110,'jp','è«‹æ±‚æ›¸ã®æ›¸å¼è¨­å®š',0),(363956,10110,'pt','Factura de formataÃ§Ã£o',0),(363957,10110,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(363958,10110,'es','Formatos de Facturas',0),(363959,10110,'de','Rechnung, die Formatierung',0),(363960,10110,'en','Invoice Formatting',0),(363961,10111,'is','',0),(363962,10111,'dr','Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ Ùˆ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ Ø³Ø±ÙŠØ¹ ',0),(363963,10111,'pr','Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ Ùˆ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§Ø¡ Ø³Ø±ÙŠØ¹ ',0),(363964,10111,'tr','POS ve Fullfillment hÄ±zlÄ± sipariÅŸ',0),(363965,10111,'pl','POS i Fullfillment szybkiego zamÃ³wienia',0),(363966,10111,'bg','POS Ð¸ Fullfillment Ð±ÑŠÑ€Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(363967,10111,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø§ÙˆØ± ÙÙˆÙ„ÙÙ„Ù…ÛŒÙ†Ù¹ Ú©Ø§ ÙÙˆØ±ÛŒ Ø­Ú©Ù…',0),(363968,10111,'sr','Ð‘Ñ€Ð·Ð¸ Ñ€ÐµÐ´ ÐŸÐžÐ¡ Ð¸ Ð¤ÑƒÐ»Ð»Ñ„Ð¸Ð»Ð»Ð¼ÐµÐ½Ñ‚',0),(363969,10111,'vi','Ä‘iá»ƒm bÃ¡n hÃ ng vÃ  Ä‘iá»n háº¿t Ä‘Æ¡n hÃ ng nhanh',0),(363970,10111,'af','PVV (\"POS\") en Blits Uitvoeringsbestellings',0),(363971,10111,'ro','POS ÅŸi laolaltÄƒ comandÄƒ rapidÄƒ',0),(363972,10111,'et','POS ja Fullfillment kiire, et',0),(363973,10111,'si','POS in Fullfillment hitro, da',0),(363974,10111,'ba','POS dan Fullfillment Order cepat',0),(363975,10111,'nl','POS en Fullfillment snel bestellen',0),(363976,10111,'fi','POS ja Fullfillment PikasyÃ¶ttÃ¶',0),(363977,10111,'no','POS og Fullfillment Quick Bestill',0),(363978,10111,'da','POS og fuldendelse Quick Order',0),(363979,10111,'ko','POS ë° Fullfillment ë¹ ë¥¸ ì£¼ë¬¸',0),(363980,10111,'he','×”×–×ž× ×” ×ž×”×™×¨×” POS, Fullfillment',0),(363981,10111,'el','Î Î©Î£ ÎºÎ±Î¹ Fullfillment Î³ÏÎ®Î³Î¿ÏÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(363982,10111,'zh','é”€å”®ç‚¹å’Œå®žè·µå¿«é€Ÿè®¢è´­\r\n',0),(363983,10111,'sv','POS och Fullfillment BestÃ¤ll',0),(363984,10111,'it','POS e Fullfillment ordine veloce',0),(363985,10111,'tl','',0),(363986,10111,'th','POS à¹à¸¥à¸° Fullfillment à¸ªà¸±à¹ˆà¸‡à¸”à¹ˆà¸§à¸™',0),(363987,10111,'hi','POS à¤”à¤° Fullfillment à¤¤à¥à¤µà¤°à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶',0),(363988,10111,'ms','Order cepat POS dan Fullfillment',0),(363989,10111,'ar','ØªØ±ØªÙŠØ¨ Ø³Ø±ÙŠØ¹ POS ÙˆØ§Ù„Ø´Ø±Ø§ÙƒØ©',0),(363990,10111,'fr','POS et Fullfillment commande rapide',0),(363991,10111,'jp','POS ã‚„æˆå°±ã®ã‚¯ã‚¤ãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼',0),(363992,10111,'pt','POS e Fullfillment ordem rÃ¡pida',0),(363993,10111,'ru','POS Ð¸ Ð¸ÑÐ¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð‘Ñ‹ÑÑ‚Ñ€Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð·',0),(363994,10111,'es','Pedido RÃ¡pido de PDV y Cumplimiento',0),(363995,10111,'de','POS und Fullfillment schnell bestellen',0),(363996,10111,'en','POS and Fullfillment Quick Order',0),(363997,10112,'is','',0),(363998,10112,'dr','Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª',0),(363999,10112,'pr','Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª',0),(364000,10112,'tr','BiÃ§imlendirme deyimi',0),(364001,10112,'pl','Instrukcja formatowania',0),(364002,10112,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(364003,10112,'ur','ÙˆØ¶Ø¹ Ú©Ø§Ø±ÛŒ Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(364004,10112,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð¾Ð±Ð»Ð¸ÐºÐ¾Ð²Ð°ÑšÐ°',0),(364005,10112,'vi','Äá»‹nh dáº¡ng máº«u bÃ¡o cÃ¡o',0),(364006,10112,'af','Staat Formatering',0),(364007,10112,'ro','DeclaraÅ£ie de formatare',0),(364008,10112,'et','Aruande vormindamine',0),(364009,10112,'si','Izjave, oblikovanje',0),(364010,10112,'ba','Pernyataan format',0),(364011,10112,'nl','Verklaring van opmaak',0),(364012,10112,'fi','Lausunto muotoilu',0),(364013,10112,'no','Setningen formatering',0),(364014,10112,'da','ErklÃ¦ring formatering',0),(364015,10112,'ko','ê³„ì‚° ì„œ ì„œì‹',0),(364016,10112,'he','×ž×©×¤×˜ ×¢×™×¦×•×‘',0),(364017,10112,'el','Î”Î®Î»Ï‰ÏƒÎ· Î¼Î¿ÏÏ†Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(364018,10112,'zh','å£°æ˜Žæ ¼å¼\r\n',0),(364019,10112,'sv','Uttalande formatering',0),(364020,10112,'it','Istruzione di formattazione',0),(364021,10112,'tl','',0),(364022,10112,'th','à¸ˆà¸±à¸”à¸£à¸¹à¸›à¹à¸šà¸šà¸‡à¸š',0),(364023,10112,'hi','à¤¸à¥à¤µà¤°à¥‚à¤ªà¤£ à¤•à¥‡ à¤¬à¤¯à¤¾à¤¨',0),(364024,10112,'ms','Format penyata',0),(364025,10112,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„ØªÙ†Ø³ÙŠÙ‚',0),(364026,10112,'fr','DÃ©claration de mise en forme',0),(364027,10112,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã®æ›¸å¼è¨­å®š',0),(364028,10112,'pt','DeclaraÃ§Ã£o de formataÃ§Ã£o',0),(364029,10112,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(364030,10112,'es','Formateo de DeclaraciÃ³n',0),(364031,10112,'de','Anweisung, die Formatierung',0),(364032,10112,'en','Statement Formatting',0),(364033,10113,'is','',0),(364034,10113,'dr','Ù¾Ø§Ù†Ø²Ø¯Ù‡Ù…  Ù…Ø§Ù‡ ',0),(364035,10113,'pr','Ù¾Ø§Ù†Ø²Ø¯Ù‡Ù…  Ù…Ø§Ù‡ ',0),(364036,10113,'tr','AyÄ±n on beÅŸinci',0),(364037,10113,'pl','PiÄ™tnastego dnia miesiÄ…ca',0),(364038,10113,'bg','ÐŸÐµÑ‚Ð½Ð°Ð´ÐµÑÐµÑ‚Ð¾ Ñ‡Ð¸ÑÐ»Ð¾ Ð½Ð° Ð¼ÐµÑÐµÑ†',0),(364039,10113,'ur','Ù…ÛÛŒÙ†Û Ú©ÛŒ Ù¾Ù†Ø¯Ø±ÛÙˆÛŒÚº',0),(364040,10113,'sr','15 Ñƒ Ð¼ÐµÑÐµÑ†Ñƒ',0),(364041,10113,'vi','mÆ°á»i lÄƒm cá»§a thÃ¡ng',0),(364042,10113,'af','Vyftiende van Maand',0),(364043,10113,'ro','A cincisprezecea a lunii',0),(364044,10113,'et','Kuu 15',0),(364045,10113,'si','Petnajstega v mesecu',0),(364046,10113,'ba','Hari kelima belas bulan',0),(364047,10113,'nl','Vijftiende van de maand',0),(364048,10113,'fi','Viidestoista kuukauden',0),(364049,10113,'no','Femtende mÃ¥ned',0),(364050,10113,'da','Femtende i mÃ¥neden',0),(364051,10113,'ko','ë‹¬ì˜ 15',0),(364052,10113,'he','×”×—×ž×© ×¢×©×¨×” ×—×•×“×©',0),(364053,10113,'el','15Î¿ Î¼Î®Î½Î±',0),(364054,10113,'zh','æœˆåäº”æ—¥\r\n',0),(364055,10113,'sv','Femtonde i mÃ¥naden',0),(364056,10113,'it','Quindicesimo del mese',0),(364057,10113,'tl','',0),(364058,10113,'th','à¸ªà¸´à¸šà¸«à¹‰à¸²à¸‚à¸­à¸‡à¹€à¸”à¸·à¸­à¸™',0),(364059,10113,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ fifteenth',0),(364060,10113,'ms','Fifteenth bulan',0),(364061,10113,'ar','Ø§Ù„Ø®Ø§Ù…Ø³ Ø¹Ø´Ø± Ø´Ù‡Ø±',0),(364062,10113,'fr','QuinziÃ¨me du mois',0),(364063,10113,'jp','æœˆã® 15 æ—¥',0),(364064,10113,'pt','Dia 15 do mÃªs',0),(364065,10113,'ru','ÐŸÑÑ‚Ð½Ð°Ð´Ñ†Ð°Ñ‚Ð¾Ðµ Ñ‡Ð¸ÑÐ»Ð¾ ÐœÐµÑÑÑ†Ð°',0),(364066,10113,'es','Quince del Mes',0),(364067,10113,'de','15. des Monats',0),(364068,10113,'en','Fifteenth of Month',0),(364069,10114,'is','',0),(364070,10114,'dr','Ø§ÙˆÙ„ÙŠÙ† Ø±ÙˆØ² Ù…Ø§Ù‡',0),(364071,10114,'pr','Ø§ÙˆÙ„ÙŠÙ† Ø±ÙˆØ² Ù…Ø§Ù‡',0),(364072,10114,'tr','AyÄ±n ilk gÃ¼nÃ¼',0),(364073,10114,'pl','Pierwszy dzieÅ„ miesiÄ…ca',0),(364074,10114,'bg','ÐŸÑŠÑ€Ð²Ð¸Ñ Ð´ÐµÐ½ Ð½Ð° Ð¼ÐµÑÐµÑ†',0),(364075,10114,'ur','Ù…ÛÛŒÙ†Û’ Ú©Ø§ Ù¾ÛÙ„Ø§ Ø¯Ù†',0),(364076,10114,'sr','ÐŸÑ€Ð²Ð¸ Ð´Ð°Ð½ Ñƒ Ð¼ÐµÑÐµÑ†Ñƒ',0),(364077,10114,'vi','NgÃ y Ä‘áº§u cá»§a nÄƒm',0),(364078,10114,'af','Eerste Dag van Maand',0),(364079,10114,'ro','Prima zi a lunii',0),(364080,10114,'et','Kuu esimene pÃ¤ev',0),(364081,10114,'si','Prvi dan v mesecu',0),(364082,10114,'ba','Hari pertama bulan',0),(364083,10114,'nl','Eerste dag van de maand',0),(364084,10114,'fi','Kuukauden ensimmÃ¤inen pÃ¤ivÃ¤',0),(364085,10114,'no','FÃ¸rste dagen i mÃ¥neden',0),(364086,10114,'da','FÃ¸rste dag i mÃ¥neden',0),(364087,10114,'ko','ë‹¬ì˜ ì²« ë‚ ',0),(364088,10114,'he','×”×™×•× ×”×¨××©×•×Ÿ ×©×œ ×”×—×•×“×©',0),(364089,10114,'el','Î ÏÏŽÏ„Î· Î·Î¼Î­ÏÎ± Ï„Î¿Ï… Î¼Î®Î½Î±',0),(364090,10114,'zh','æ¯æœˆçš„ç¬¬ä¸€å¤©\r\n',0),(364091,10114,'sv','FÃ¶rsta dagen i mÃ¥naden',0),(364092,10114,'it','Primo giorno del mese',0),(364093,10114,'tl','',0),(364094,10114,'th','à¸§à¸±à¸™à¹à¸£à¸à¸‚à¸­à¸‡à¹€à¸”à¸·à¸­à¸™',0),(364095,10114,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¤¾ à¤ªà¤¹à¤²à¤¾ à¤¦à¤¿à¤¨',0),(364096,10114,'ms','Hari pertama dari bulan',0),(364097,10114,'ar','Ø§Ù„ÙŠÙˆÙ… Ø§Ù„Ø£ÙˆÙ„ ÙÙŠ Ø§Ù„Ø´Ù‡Ø±',0),(364098,10114,'fr','Premier jour du mois',0),(364099,10114,'jp','æœˆã®æœ€åˆã®æ—¥',0),(364100,10114,'pt','Primeiro dia do mÃªs',0),(364101,10114,'ru','ÐŸÐµÑ€Ð²Ñ‹Ð¹ Ð”ÐµÐ½ÑŒ ÐœÐµÑÑÑ†Ð°',0),(364102,10114,'es','Primer DÃ­a del Mes',0),(364103,10114,'de','Ersten Tag des Monats',0),(364104,10114,'en','First Day of Month',0),(364105,10115,'is','',0),(364106,10115,'dr','Ø§Ú¯Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù…Ø§Ù‡Ø§Ù†Ù‡ â€“ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ú†Ù‡ Ø±ÙˆØ²ÙŠ Ø§Ø³Øª ',0),(364107,10115,'pr','Ø§Ú¯Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù…Ø§Ù‡Ø§Ù†Ù‡ â€“ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ú†Ù‡ Ø±ÙˆØ²ÙŠ Ø§Ø³Øª ',0),(364108,10115,'tr','AylÄ±k Plan, hangi gÃ¼n Ã¶deme',0),(364109,10115,'pl','PlanujÄ…c co miesiÄ…c pÅ‚aciÄ‡ na co dzieÅ„',0),(364110,10115,'bg','ÐÐºÐ¾ Ð¼ÐµÑÐµÑ‡ÐµÐ½ Ð¿Ð»Ð°Ð½, Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð½Ð° ÐºÐ¾Ð¹ Ð´ÐµÐ½',0),(364111,10115,'ur','Ø§Ú¯Ø± Ù…Ø§ÛØ§Ù†Û Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒØŒ Ú©Ø³ Ø¯Ù† Ø§Ø¯Ø§',0),(364112,10115,'sr','ÐÐºÐ¾ Ñ˜ÐµÐ´Ð½Ð¾Ð¼ Ð¼ÐµÑÐµÑ‡Ð½Ð¾, Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð° ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð´Ð°Ð½Ð°Ñ Ð´Ð°Ð½',0),(364113,10115,'vi','náº¿u káº¿ hoáº¡ch hÃ ng thÃ¡ng tráº£ vÃ o ngÃ y nÃ o',0),(364114,10115,'af','Ingeval van \'n Maandlikse Plan, Betaal Op Watter Dag',0),(364115,10115,'ro','DacÄƒ planul lunar, plata ce zi',0),(364116,10115,'et','Kui kuu, maksma mida pÃ¤ev',0),(364117,10115,'si','ÄŒe meseÄni naÄrt, plaÄati na kakÅ¡en dan',0),(364118,10115,'ba','Jika berencana bulanan, membayar apa hari',0),(364119,10115,'nl','Als maandelijkse Plan, betalen op welke dag',0),(364120,10115,'fi','Jos kuukauden, maksaa mitÃ¤ pÃ¤ivÃ¤',0),(364121,10115,'no','Hvis mÃ¥nedlig Plan, betale pÃ¥ hvilken dag',0),(364122,10115,'da','Hvis mÃ¥nedlige planer, betale hvad dag',0),(364123,10115,'ko','ì›”ê°„ ê³„íš, ì–´ë–¤ ë‚ ì— ì§€ë¶ˆ',0),(364124,10115,'he','×× ×ž×ª×›× × ×™× ×”×—×•×“×©×™, ×œ×©×œ× ×¢×œ ××™×–×” ×™×•× ×”×™×•×',0),(364125,10115,'el','Î•Î¬Î½ Ï„Î¿ Î¼Î·Î½Î¹Î±Î¯Î¿ ÏƒÏ‡Î­Î´Î¹Î¿, Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Î Î¿Î¹Î± Î¼Î­ÏÎ±',0),(364126,10115,'zh','å¦‚æžœæ¯æœˆè®¡åˆ’ï¼Œåœ¨å“ªä¸€å¤©æ”¶è´¹\r\n',0),(364127,10115,'sv','Om mÃ¥nad planerar, betala vad dag',0),(364128,10115,'it','Se il piano mensile, pagare in quale giorno',0),(364129,10115,'tl','',0),(364130,10115,'th','à¸–à¹‰à¸²à¸£à¸²à¸¢à¹€à¸”à¸·à¸­à¸™ à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¹ƒà¸™à¸§à¸±à¸™à¹ƒà¸”',0),(364131,10115,'hi','à¤…à¤—à¤° à¤®à¤¾à¤¸à¤¿à¤• à¤¯à¥‹à¤œà¤¨à¤¾ à¤¹à¥ˆ, à¤•à¥à¤¯à¤¾ à¤¦à¤¿à¤¨ à¤ªà¤° à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(364132,10115,'ms','Jika pelan bulanan, membayar pada hari apa',0),(364133,10115,'ar','ÙŠÙˆÙ… Ø§Ù„Ø¯ÙØ¹ ØŒ ÙÙŠ Ø­Ø§Ù„Ø© Ø§Ù„Ø£Ù‚Ø³Ø§Ø· Ø§Ù„Ø´Ù‡Ø±ÙŠØ©',0),(364134,10115,'fr','Si l\'intention de tous les mois, payer ce jour',0),(364135,10115,'jp','æ¯Žæœˆã®å ´åˆã¯ã€ä½•æ—¥ã«æ”¯æ‰•ã†',0),(364136,10115,'pt','Se o plano mensal, paga em que dia',0),(364137,10115,'ru','Ð•ÑÐ»Ð¸ Ð•Ð¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ñ‹Ð¹ ÐŸÐ»Ð°Ð½, ÐŸÐ»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð² ÐšÐ°ÐºÐ¾Ð¹ Ð”ÐµÐ½ÑŒ',0),(364138,10115,'es','Si Plan Mensual, Paga en Cual DÃ­a',0),(364139,10115,'de','Wenn monatlich planen, zu zahlen, an welchem Tag',0),(364140,10115,'en','If Monthly Plan, Pay On What Day',0),(364141,10116,'is','',0),(364142,10116,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª Ø¬Ù‡Øª Ø§Ù†Ø¬Ø§Ù… Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(364143,10116,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª Ø¬Ù‡Øª Ø§Ù†Ø¬Ø§Ù… Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(364144,10116,'tr','Ã–deme yapmak iÃ§in kaÃ§ kez',0),(364145,10116,'pl','LiczbÄ™ razy, aby dokonaÄ‡ pÅ‚atnoÅ›ci',0),(364146,10116,'bg','Ð‘Ñ€Ð¾Ð¹ Ð¿ÑŠÑ‚Ð¸ Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(364147,10116,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ùˆ Ú©Ø±Ù†Û’ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(364148,10116,'sr','ÐšÐ¾Ð»Ð¸ÐºÐ¾ Ð¿ÑƒÑ‚Ð° Ð´Ð° ÑÐµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(364149,10116,'vi','sá»‘ thá»i gian Ä‘á»ƒ thanh toÃ¡n',0),(364150,10116,'af','Aantal Kere Om Betaling te Maak',0),(364151,10116,'ro','NumÄƒrul de ori pentru a face plata',0),(364152,10116,'et','Mitu korda teha makseid',0),(364153,10116,'si','Kolikokrat plaÄevanje',0),(364154,10116,'ba','Jumlah kali untuk melakukan pembayaran',0),(364155,10116,'nl','Aantal keren om betaling te verrichten',0),(364156,10116,'fi','Monta kertaa maksu',0),(364157,10116,'no','Antall ganger Ã¥ betale',0),(364158,10116,'da','Antal gange for at gÃ¸re betaling',0),(364159,10116,'ko','ì§€ë¶ˆ íšŸìˆ˜',0),(364160,10116,'he','×ž×¡×¤×¨ ×¤×¢×ž×™× ×œ×‘×¦×¢ ××ª ×”×ª×©×œ×•×',0),(364161,10116,'el','Î ÏŒÏƒÎµÏ‚ Ï†Î¿ÏÎ­Ï‚ Ï€Î»Î·ÏÏŽÏƒÎ·',0),(364162,10116,'zh','ä»˜æ¬¾æ¬¡æ•°\r\n',0),(364163,10116,'sv','MÃ¥nga gÃ¥nger att gÃ¶ra betalning',0),(364164,10116,'it','Numero di volte per effettuare il pagamento',0),(364165,10116,'tl','',0),(364166,10116,'th','à¸ˆà¸³à¸™à¸§à¸™à¸„à¸£à¸±à¹‰à¸‡à¹ƒà¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(364167,10116,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤µà¤¸à¤°à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(364168,10116,'ms','Bilangan kali untuk membuat pembayaran',0),(364169,10116,'ar','Ø¹Ø¯Ø¯ Ù…Ø±Ø§Øª Ø§Ù„Ø¯ÙØ¹',0),(364170,10116,'fr','Nombre de fois pour effectuer le paiement',0),(364171,10116,'jp','ãŠæ”¯æ‰•ã„å›žæ•°',0),(364172,10116,'pt','NÃºmero de vezes para fazer o pagamento',0),(364173,10116,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ€Ð°Ð·, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(364174,10116,'es','NÃºmero de Veces para Hacer Pagos',0),(364175,10116,'de','HÃ¤ufigkeit der Zahlung',0),(364176,10116,'en','Number Of Times To Make Payment',0),(364177,10117,'is','',0),(364178,10117,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ ',0),(364179,10117,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡ ',0),(364180,10117,'tr','Yinelenen BorÃ§lar Ekle',0),(364181,10117,'pl','DodaÄ‡ powtarzajÄ…ce zobowiÄ…zania',0),(364182,10117,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(364183,10117,'ur','Ø¨Ø§Ø± Ø¨Ø§Ø± ÛÙˆÙ†Û’ ÙˆØ§Ù„ÛŒ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(364184,10117,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(364185,10117,'vi','thÃªm pháº£i tráº£ Ä‘á»‹nh ká»³',0),(364186,10117,'af','Herhalende Uitgawes (RB) Byvoeg',0),(364187,10117,'ro','Adauga recurente datorii',0),(364188,10117,'et','Korduva vÃµlad lisa',0),(364189,10117,'si','Dodaj ponavljajoÄih se obveznosti',0),(364190,10117,'ba','Hutang berulang menambahkan',0),(364191,10117,'nl','Terugkerende schulden toevoegen',0),(364192,10117,'fi','Toistuva velat lisÃ¤Ã¤',0),(364193,10117,'no','Regelmessige leverandÃ¸rgjeld legge',0),(364194,10117,'da','Tilbagevendende kreditorstyring tilfÃ¸je',0),(364195,10117,'ko','ë˜í’€ì´ ë¯¸ì§€ê¸‰ê¸ˆ ì¶”ê°€',0),(364196,10117,'he','×œ×”×•×¡×™×£ ×–×›××™× ×—×•×–×¨×•×ª',0),(364197,10117,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(364198,10117,'zh','å¾ªçŽ¯åº”ä»˜æ¬¾é¡¹å¢žåŠ \r\n',0),(364199,10117,'sv','Ã…terkommande leverantÃ¶rsskulder lÃ¤gga till',0),(364200,10117,'it','Aggiungi debiti ricorrenti',0),(364201,10117,'tl','',0),(364202,10117,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸±à¸à¸Šà¸µà¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¹€à¸à¸´à¸”à¸‹à¹‰à¸³',0),(364203,10117,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ Payables à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(364204,10117,'ms','Tambah berulang pemiutang',0),(364205,10117,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…ØªÙƒØ±Ø±',0),(364206,10117,'fr','Ajouter rÃ©current des comptes fournisseurs',0),(364207,10117,'jp','å®šæœŸçš„ãªå‚µå‹™ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(364208,10117,'pt','Adicionar pagamentos recorrentes',0),(364209,10117,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰ÐµÐ³Ð¾ÑÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(364210,10117,'es','Agregar Cuentas por Pagar Recurrentes',0),(364211,10117,'de','Wiederkehrende Verbindlichkeiten hinzufÃ¼gen',0),(364212,10117,'en','Recurring Payables Add',0),(364213,10118,'is','',0),(364214,10118,'dr','Ø¯Ù‡Ù…ÙŠÙ† Ù…Ø§Ù‡ ',0),(364215,10118,'pr','Ø¯Ù‡Ù…ÙŠÙ† Ù…Ø§Ù‡ ',0),(364216,10118,'tr','Onuncu ayÄ±n',0),(364217,10118,'pl','DziesiÄ…tego dnia miesiÄ…ca',0),(364218,10118,'bg','Ð”ÐµÑÐµÑ‚Ð° Ð¾Ñ‚ Ð¼ÐµÑÐµÑ†',0),(364219,10118,'ur','Ù…ÛÛŒÙ†Û Ú©ÛŒ Ø¯Ø³ÙˆÛŒÚº ØªØ§Ø±ÛŒØ®',0),(364220,10118,'sr','Ð”ÐµÑÐµÑ‚Ð¸Ð½Ñƒ Ð¾Ð´ Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(364221,10118,'vi','NgÃ y mÆ°á»i cá»§a thÃ¡ng',0),(364222,10118,'af','Tiende van die Maand',0),(364223,10118,'ro','Zecea a lunii',0),(364224,10118,'et','KÃ¼mnenda kuu',0),(364225,10118,'si','Deseti mesec',0),(364226,10118,'ba','Kesepuluh bulan',0),(364227,10118,'nl','Tiende van de maand',0),(364228,10118,'fi','Kymmenes kuukausi',0),(364229,10118,'no','Tiende mÃ¥ned',0),(364230,10118,'da','Tiendedel af mÃ¥ned',0),(364231,10118,'ko','ë‹¬ì˜ 10 ë¶„ì˜ 1',0),(364232,10118,'he','×”×¢×©×™×¨×™ ×©×œ ×—×•×“×©',0),(364233,10118,'el','Î”Î­ÎºÎ±Ï„Î¿ Î¼Î®Î½Î±',0),(364234,10118,'zh','æ¯æœˆåå·\r\n',0),(364235,10118,'sv','Tionde mÃ¥nad',0),(364236,10118,'it','Decimo del mese',0),(364237,10118,'tl','',0),(364238,10118,'th','à¸ªà¸´à¸šà¹€à¸”à¸·à¸­à¸™',0),(364239,10118,'hi','à¤¦à¤¸à¤µà¥‡à¤‚ à¤®à¤¾à¤¹ à¤•à¥€',0),(364240,10118,'ms','Kesepuluh bulan',0),(364241,10118,'ar','Ø§Ù„Ø¹Ø§Ø´Ø± Ø´Ù‡Ø±',0),(364242,10118,'fr','DixiÃ¨me du mois',0),(364243,10118,'jp','æœˆã® 10 åˆ†ã® 1',0),(364244,10118,'pt','DÃ©cimo mÃªs',0),(364245,10118,'ru','Ð”ÐµÑÑÑ‚Ð¾Ðµ Ð§Ð¸ÑÐ»Ð¾ ÐœÐµÑÑÑ†Ð°',0),(364246,10118,'es','Diez del Mes',0),(364247,10118,'de','Zehntel des Monats',0),(364248,10118,'en','Tenth of Month',0),(364249,10119,'is','',0),(364250,10119,'dr','Ø¨ÙŠØ³ØªÙ… Ù…Ø§Ù‡ ',0),(364251,10119,'pr','Ø¨ÙŠØ³ØªÙ… Ù…Ø§Ù‡ ',0),(364252,10119,'tr','AyÄ±n yirminci',0),(364253,10119,'pl','Dwudziestego dnia miesiÄ…ca',0),(364254,10119,'bg','Ð¥Ð¥ Ð½Ð° Ð¼ÐµÑÐµÑ†',0),(364255,10119,'ur','Ø¨ÛŒØ³ÙˆÛŒÚº Ù…Ø§Û Ú©Û’',0),(364256,10119,'sr','Ð”Ð²Ð°Ð´ÐµÑÐµÑ‚Ð¸ Ð¼ÐµÑÐµÑ†Ñƒ',0),(364257,10119,'vi','NgÃ y thá»© 20 hÃ ng thÃ¡ng',0),(364258,10119,'af','Twintigste van Maand',0),(364259,10119,'ro','XX a lunii',0),(364260,10119,'et','Kuu kahekÃ¼mnenda',0),(364261,10119,'si','Dvajsetega meseca',0),(364262,10119,'ba','Kedua puluh bulan',0),(364263,10119,'nl','Twintigste van de maand',0),(364264,10119,'fi','1900 kuukauden',0),(364265,10119,'no','Av mÃ¥neden',0),(364266,10119,'da','Tyvende af mÃ¥ned',0),(364267,10119,'ko','ë‹¬ì˜ 20',0),(364268,10119,'he','×”×¢×©×¨×™× ×©×œ ×”×—×•×“×©',0),(364269,10119,'el','Î•Î¹ÎºÎ¿ÏƒÏ„ÏŒ Ï„Î¿Ï… Î¼Î®Î½Î±',0),(364270,10119,'zh','ç¬¬äºŒåæœˆ\r\n',0),(364271,10119,'sv','Tjugonde i mÃ¥naden',0),(364272,10119,'it','XX del mese',0),(364273,10119,'tl','',0),(364274,10119,'th','à¸¢à¸µà¹ˆà¸ªà¸´à¸šà¹€à¸”à¸·à¸­à¸™',0),(364275,10119,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥€ à¤¬à¥€à¤¸à¤µà¥€à¤‚',0),(364276,10119,'ms','20 bulan',0),(364277,10119,'ar','Ø§Ù„Ø¹Ø´Ø±ÙŠÙ† Ù…Ù† Ø§Ù„Ø´Ù‡Ø±',0),(364278,10119,'fr','VingtiÃ¨me du mois',0),(364279,10119,'jp','æœˆã® 20 åˆ†',0),(364280,10119,'pt','XX do mÃªs',0),(364281,10119,'ru','Ð”Ð²ÐµÐ½Ð°Ð´Ñ†Ð°Ñ‚Ð¾Ðµ Ð§Ð¸ÑÐ»Ð¾ ÐœÐµÑÑÑ†Ð°',0),(364282,10119,'es','Veinte del Mes',0),(364283,10119,'de','20. des Monats',0),(364284,10119,'en','Twentieth of Month',0),(364285,10120,'is','',0),(364286,10120,'dr','Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨ÙŠÙ† ',0),(364287,10120,'pr','Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨ÙŠÙ† ',0),(364288,10120,'tr','ArasÄ±nda girdi',0),(364289,10120,'pl','WszedÅ‚ miÄ™dzy',0),(364290,10120,'bg','Ð¡ÐºÐ»ÑŽÑ‡ÐµÐ½ Ð¼ÐµÐ¶Ð´Ñƒ',0),(364291,10120,'ur','Ø¯Ø±Ù…ÛŒØ§Ù† Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(364292,10120,'sr','Ð£ÑˆÐ°Ð¾ Ñ˜Ðµ Ð¸Ð·Ð¼ÐµÑ’Ñƒ',0),(364293,10120,'vi','Ä‘Ã£ nháº­p giá»¯a',0),(364294,10120,'af','Ingetik het tussen',0),(364295,10120,'ro','A intrat Ã®ntre',0),(364296,10120,'et','Vahel',0),(364297,10120,'si','Vpisana med',0),(364298,10120,'ba','Memasuki antara',0),(364299,10120,'nl','Ingevoerd tussen',0),(364300,10120,'fi','VÃ¤lillÃ¤',0),(364301,10120,'no','Angitt mellom',0),(364302,10120,'da','Ind mellem',0),(364303,10120,'ko','ì‚¬ì´ ìž…ë ¥ í•œ',0),(364304,10120,'he','× ×›× ×¡ ×‘×™×Ÿ',0),(364305,10120,'el','Î¤Î­Î¸Î·ÎºÎµ Î¼ÎµÏ„Î±Î¾Ï',0),(364306,10120,'zh','åœ¨ä¹‹é—´è®¢ç«‹',0),(364307,10120,'sv','In mellan',0),(364308,10120,'it','Entrato tra',0),(364309,10120,'tl','',0),(364310,10120,'th','à¹ƒà¸ªà¹ˆà¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡',0),(364311,10120,'hi','à¤¬à¥€à¤š à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(364312,10120,'ms','Di antara',0),(364313,10120,'ar','Ø¯Ø®Ù„Øª Ø¨ÙŠÙ†',0),(364314,10120,'fr','Recueillies entre',0),(364315,10120,'jp','é–“ã«å…¥ã£ãŸ',0),(364316,10120,'pt','Inserido entre',0),(364317,10120,'ru','Ð’Ð²ÐµÐ´ÐµÐ½Ð¾ ÐœÐµÐ¶Ð´Ñƒ',0),(364318,10120,'es','Entrada Entre',0),(364319,10120,'de','Zwischen',0),(364320,10120,'en','Entered Between',0),(364321,10121,'is','',0),(364322,10121,'dr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨ÙŠÙ† ',0),(364323,10121,'pr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨ÙŠÙ† ',0),(364324,10121,'tr','MÃ¼ÅŸteriler arasÄ±nda girilen gÃ¶ster',0),(364325,10121,'pl','PokaÅ¼ klientÃ³w wszedÅ‚ miÄ™dzy',0),(364326,10121,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸, ÑÐºÐ»ÑŽÑ‡ÐµÐ½ Ð¼ÐµÐ¶Ð´Ñƒ',0),(364327,10121,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† Ø¯Ø§Ø®Ù„ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(364328,10121,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐºÑƒÐ¿Ñ†Ðµ ÑƒÑˆÐ°Ð¾ Ð¸Ð·Ð¼ÐµÑ’Ñƒ',0),(364329,10121,'vi','Hiá»ƒn thá»‹ khÃ¡ch hÃ ng báº¯t Ä‘áº§u tá»«',0),(364330,10121,'af','Wys Klante/KliÃ«nte Ingevoer Tussen',0),(364331,10121,'ro','AratÄƒ clienÅ£ii intrat Ã®ntre',0),(364332,10121,'et','Klientide vahel',0),(364333,10121,'si','PokaÅ¾i uporabniki vnesli med',0),(364334,10121,'ba','Menunjukkan pelanggan memasuki antara',0),(364335,10121,'nl','Klanten ingevoerd tussen laten zien',0),(364336,10121,'fi','Osoittaa asiakkaille vÃ¤lillÃ¤',0),(364337,10121,'no','Vise kunder inn mellom',0),(364338,10121,'da','Vise kunderne ind mellem',0),(364339,10121,'ko','ê³ ê° ì‚¬ì´ì˜ ìž…ë ¥ í‘œì‹œ',0),(364340,10121,'he','×œ×”×¨××•×ª ×œ×œ×§×•×—×•×ª × ×›× ×¡ ×‘×™×Ÿ',0),(364341,10121,'el','Î”ÎµÎ¯Î¾ÎµÎ¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï„Î­Î¸Î·ÎºÎµ Î¼ÎµÏ„Î±Î¾Ï',0),(364342,10121,'zh','å®¢æˆ·å±•ç¤ºè®¢ç«‹ä¹‹\r\n',0),(364343,10121,'sv','Visa kunderna in mellan',0),(364344,10121,'it','Mostrare ai clienti iscritti tra',0),(364345,10121,'tl','',0),(364346,10121,'th','à¹à¸ªà¸”à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²à¸›à¹‰à¸­à¸™à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡',0),(364347,10121,'hi','à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤¬à¥€à¤š à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(364348,10121,'ms','Menunjukkan di antara pelanggan',0),(364349,10121,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¯Ø®Ù„Øª Ø¨ÙŠÙ†',0),(364350,10121,'fr','Montrer aux clients recueillies entre',0),(364351,10121,'jp','é¡§å®¢ã®é–“å…¥åŠ›ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(364352,10121,'pt','Mostrar aos clientes que entraram entre',0),(364353,10121,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð’Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ñ… ÐœÐµÐ¶Ð´Ñƒ',0),(364354,10121,'es','Mostrar Clientes Entradas Entre',0),(364355,10121,'de','Zeigen Sie Kunden, die zwischen an',0),(364356,10121,'en','Show Customers Entered Between',0),(364357,10122,'is','',0),(364358,10122,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§ ÙØ±ÙˆØ´ Ù‡Ø§',0),(364359,10122,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§ ÙØ±ÙˆØ´ Ù‡Ø§',0),(364360,10122,'tr','Sadece mÃ¼ÅŸteri satÄ±ÅŸ gÃ¶stermek',0),(364361,10122,'pl','PokaÅ¼ tylko klienta w sprzedaÅ¼y',0),(364362,10122,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(364363,10122,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ ÙØ±ÙˆØ®Øª Ú©Û’ Ø³Ø§ØªÚ¾ ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(364364,10122,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÐºÑƒÐ¿Ñ†Ð° ÑÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¾Ð¼',0),(364365,10122,'vi','Chá»‰ thá»ƒ hiá»‡n khÃ¡ch hÃ ng vá»›i doanh sá»‘',0),(364366,10122,'af','Wys  Alleenlik Klante/KliÃ«nte Met Verkope',0),(364367,10122,'ro','AratÄƒ numai clientul cu vanzari',0),(364368,10122,'et','NÃ¤idata vaid MÃ¼Ã¼k kliendile',0),(364369,10122,'si','PokaÅ¾i samo kupec s prodajo',0),(364370,10122,'ba','Tampilkan hanya pelanggan dengan penjualan',0),(364371,10122,'nl','Toon alleen klant met verkoop',0),(364372,10122,'fi','NÃ¤ytÃ¤ vain asiakkaiden myynti',0),(364373,10122,'no','Vis bare kunder med salg',0),(364374,10122,'da','Vis kun kunde med salg',0),(364375,10122,'ko','íŒë§¤ì™€ ê³ ê°ë§Œ í‘œì‹œ',0),(364376,10122,'he','×”×¦×’ ×¨×§ ×œ×§×•×— ×¢× ×ž×›×™×¨×•×ª',0),(364377,10122,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ Ï„Ï‰Î½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î¼Îµ Ï„Î¹Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(364378,10122,'zh','ä»…æ˜¾ç¤ºæœ‰é”€å”®çš„å®¢æˆ·\r\n',0),(364379,10122,'sv','Visa endast kunden med fÃ¶rsÃ¤ljning',0),(364380,10122,'it','Spettacolo unico cliente con vendite',0),(364381,10122,'tl','',0),(364382,10122,'th','à¹à¸ªà¸”à¸‡à¹€à¸‰à¸žà¸²à¸°à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆ à¸¡à¸µà¸¢à¸­à¸”à¸‚à¸²à¸¢',0),(364383,10122,'hi','à¤•à¥‡à¤µà¤² à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(364384,10122,'ms','Menunjukkan hanya pelanggan dengan jualan',0),(364385,10122,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙÙ‚Ø· Ù…Ù† Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…Ø¹ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(364386,10122,'fr','Afficher uniquement les clients dont les ventes',0),(364387,10122,'jp','å£²ã‚Šä¸Šã’é«˜ã¯é¡§å®¢ã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(364388,10122,'pt','Mostrar somente ao cliente com vendas',0),(364389,10122,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¡ ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð°Ð¼Ð¸',0),(364390,10122,'es','Mostrar Sol Clientes Con Ventas',0),(364391,10122,'de','Zeigen Sie nur Kunden mit einem Umsatz',0),(364392,10122,'en','Show Only Customer With Sales',0),(364393,10123,'is','',0),(364394,10123,'dr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø§Ø®ÙŠØ± ',0),(364395,10123,'pr','Ù„ÙŠØ³Øª Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø§Ø®ÙŠØ± ',0),(364396,10123,'tr','Son mÃ¼ÅŸteriler',0),(364397,10123,'pl','Ostatnich klientÃ³w',0),(364398,10123,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(364399,10123,'ur','Ø­Ø§Ù„ÛŒÛ ØµØ§Ø±ÙÛŒÙ†',0),(364400,10123,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¸ ÐºÑƒÐ¿Ñ†Ð¸',0),(364401,10123,'vi','cÃ¡c khÃ¡ch hÃ ng gáº§n Ä‘Ã¢y',0),(364402,10123,'af','Onlangse Klante/KliÃ«nte',0),(364403,10123,'ro','ClienÅ£ii recente',0),(364404,10123,'et','Tehtud kÃ¼lastajad',0),(364405,10123,'si','Zadnjih stranke',0),(364406,10123,'ba','Terbaru pelanggan',0),(364407,10123,'nl','Recente klanten',0),(364408,10123,'fi','Viime asiakkaat',0),(364409,10123,'no','Siste kundene',0),(364410,10123,'da','Seneste kunder',0),(364411,10123,'ko','ìµœê·¼ ê³ ê°',0),(364412,10123,'he','×œ×§×•×—×•×ª ××—×¨×•× ×™×',0),(364413,10123,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(364414,10123,'zh','æ–°é¡¾å®¢\r\n',0),(364415,10123,'sv','Senaste kunder',0),(364416,10123,'it','Clienti recenti',0),(364417,10123,'tl','',0),(364418,10123,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(364419,10123,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(364420,10123,'ms','Hari pelanggan',0),(364421,10123,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(364422,10123,'fr','Visiteurs rÃ©cents',0),(364423,10123,'jp','æœ€è¿‘ã®é¡§å®¢',0),(364424,10123,'pt','Clientes recentes',0),(364425,10123,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¸Ðµ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹',0),(364426,10123,'es','Clientes Recientes',0),(364427,10123,'de','Aktuelle Kunden',0),(364428,10123,'en','Recent Customers',0),(364429,10124,'is','',0),(364430,10124,'dr','Ù‚Ø¨Ù„ Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ú†Ùƒ Ù„ÙŠØ³Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(364431,10124,'pr','Ù‚Ø¨Ù„ Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ú†Ùƒ Ù„ÙŠØ³Øª ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(364432,10124,'tr','Ã–deme Ã¶nce tamamlanmÄ±ÅŸ denetim listesi gerektirir',0),(364433,10124,'pl','WymagajÄ… zakoÅ„czone Lista kontrolna przed dokonaniem pÅ‚atnoÅ›ci',0),(364434,10124,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ð¿Ð¾Ð¿ÑŠÐ»Ð½ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº Ð¿Ñ€ÐµÐ´Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(364435,10124,'ur','Ù…Ú©Ù…Ù„ ÙÛØ±Ø³Øª Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø³Û’ Ù¾ÛÙ„Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÙˆØªÛŒ ÛÛ’',0),(364436,10124,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°Ñ˜Ñƒ Ð¿Ð¾Ð¿ÑƒÑšÐµÐ½Ðµ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(364437,10124,'vi','YÃªu cáº§u hoÃ n thÃ nh danh sÃ¡ch kiá»ƒm tra trÆ°á»›c khi thanh toÃ¡n',0),(364438,10124,'af','Benodig Voltooide Nasienlys Alvorens Betaling Geskied',0),(364439,10124,'ro','NecesitÄƒ completat listÄƒ de verificare Ã®nainte de plata',0),(364440,10124,'et','NÃµuda koostatud kontrollnimekirja enne makse',0),(364441,10124,'si','Zahtevajo izpolnjen kontrolni seznam pred plaÄilom',0),(364442,10124,'ba','Memerlukan Checklist selesai sebelum pembayaran',0),(364443,10124,'nl','Ingevulde controlelijst vÃ³Ã³r betaling vereisen',0),(364444,10124,'fi','Vaatia valmistunut tarkistuslista ennen maksamista',0),(364445,10124,'no','Kreve fullfÃ¸rt sjekklisten fÃ¸r betaling',0),(364446,10124,'da','KrÃ¦ve udfyldt tjekliste fÃ¸r betaling',0),(364447,10124,'ko','ì§€ë¶ˆ ì „ì— ì™„ë£Œ ì ê²€ í•„ìš”',0),(364448,10124,'he','×“×•×¨×©×™× ×”×¨×©×™×ž×” ×”×•×©×œ×ž×” ×œ×¤× ×™ ×”×ª×©×œ×•×',0),(364449,10124,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½ Ï„Î·Î½ ÏƒÏ…Î¼Ï€Î»Î·ÏÏ‰Î¼Î­Î½Î· Î»Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎºÎ±Ï„Î±Î²Î¿Î»Î®',0),(364450,10124,'zh','å‰å®Œæˆä»˜æ¬¾æ¸…å•è¦æ±‚\r\n',0),(364451,10124,'sv','KrÃ¤ver avslutade checklista innan betalning',0),(364452,10124,'it','Richiedono Checklist completato prima del pagamento',0),(364453,10124,'tl','',0),(364454,10124,'th','à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œà¸à¹ˆà¸­à¸™à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(364455,10124,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤ªà¥‚à¤°à¤¾ à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(364456,10124,'ms','Memerlukan senarai semak yang lengkap sebelum pembayaran',0),(364457,10124,'ar','ØªØªØ·Ù„Ø¨ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ø±Ø¬Ø¹ÙŠØ© Ø§Ù„Ù…Ù†Ø¬Ø²Ø© Ù‚Ø¨Ù„ Ø§Ù„Ø¯ÙØ¹',0),(364458,10124,'fr','Liste de contrÃ´le dÃ»ment rempli avant le paiement',0),(364459,10124,'jp','ãŠæ”¯æ‰•ã„å‰ã«å®Œæˆã—ãŸãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆãŒå¿…è¦ã§ã™ã€‚',0),(364460,10124,'pt','Exigem Checklist concluÃ­da antes do pagamento',0),(364461,10124,'ru','Ð¢Ñ€ÐµÐ±ÑƒÑŽÑ‚ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ñ… ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ Ð¿ÐµÑ€ÐµÐ´ Ð¾Ð¿Ð»Ð°Ñ‚Ð¾Ð¹',0),(364462,10124,'es','Requiere Lista de Tareas Completa Antes que Pagar',0),(364463,10124,'de','AusgefÃ¼llte Checkliste vor Zahlung erforderlich',0),(364464,10124,'en','Require Completed Checklist Before Payment',0),(364465,10125,'is','',0),(364466,10125,'dr','Ù…Ù†Ùˆ Ù„ÙŠÙ†Ùƒ ',0),(364467,10125,'pr','Ù…Ù†Ùˆ Ù„ÙŠÙ†Ùƒ ',0),(364468,10125,'tr','MenÃ¼ baÄŸlantÄ±sÄ±',0),(364469,10125,'pl','Menu Link',0),(364470,10125,'bg','ÐœÐµÐ½ÑŽ Ð²Ñ€ÑŠÐ·ÐºÐ°',0),(364471,10125,'ur','ÙÛØ±Ø³Øª Ú©Ø§ Ù„Ù†Ú©',0),(364472,10125,'sr','ÐœÐµÐ½Ð¸ Ð›Ð¸Ð½Ðº',0),(364473,10125,'vi','LiÃªn káº¿t menu',0),(364474,10125,'af','Kieslys skakel',0),(364475,10125,'ro','Link-ul de meniu',0),(364476,10125,'et','MenÃ¼Ã¼ Link',0),(364477,10125,'si','Meni Link',0),(364478,10125,'ba','Menu Link',0),(364479,10125,'nl','Menu Link',0),(364480,10125,'fi','Valikon linkkiÃ¤',0),(364481,10125,'no','Kobling-menyen',0),(364482,10125,'da','Menulink',0),(364483,10125,'ko','ë©”ë‰´ ë§í¬',0),(364484,10125,'he','×ª×¤×¨×™×˜ ×§×™×©×•×¨×™×',0),(364485,10125,'el','ÎœÎµÎ½Î¿Ï ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(364486,10125,'zh','èœå•é“¾æŽ¥\r\n',0),(364487,10125,'sv','Menyn lÃ¤nk',0),(364488,10125,'it','Menu Link',0),(364489,10125,'tl','',0),(364490,10125,'th','à¹€à¸¡à¸™à¸¹à¸¥à¸´à¸‡à¸„à¹Œ',0),(364491,10125,'hi','à¤®à¥‡à¤¨à¥‚ à¤²à¤¿à¤‚à¤•',0),(364492,10125,'ms','Pautan Menu',0),(364493,10125,'ar','Ø±Ø§Ø¨Ø· Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(364494,10125,'fr','Lien du menu',0),(364495,10125,'jp','ãƒ¡ãƒ‹ãƒ¥ãƒ¼ã®ãƒªãƒ³ã‚¯',0),(364496,10125,'pt','Menu Link',0),(364497,10125,'ru','Ð¡ÑÑ‹Ð»ÐºÐ° ÐœÐµÐ½ÑŽ',0),(364498,10125,'es','Enlace del MenÃº',0),(364499,10125,'de','Link Menu',0),(364500,10125,'en','Menu Link',0),(364501,10126,'is','',0),(364502,10126,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙƒÙŠØª ',0),(364503,10126,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙƒÙŠØª ',0),(364504,10126,'tr','MÃ¼lkiyet Ekle',0),(364505,10126,'pl','DodaÄ‡ wÅ‚asnoÅ›ci',0),(364506,10126,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚Ñ‚Ð°',0),(364507,10126,'ur','Ù…Ù„Ú©ÛŒØª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(364508,10126,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾',0),(364509,10126,'vi','ThÃªm quyá»n sá»Ÿ há»¯u',0),(364510,10126,'af','Eienaarskap Byvoeg',0),(364511,10126,'ro','Adauga proprietate',0),(364512,10126,'et','Lisada omandiÃµiguse',0),(364513,10126,'si','Dodaj lastniÅ¡tva',0),(364514,10126,'ba','Tambahkan kepemilikan',0),(364515,10126,'nl','Voeg eigendom',0),(364516,10126,'fi','LisÃ¤Ã¤ omistus',0),(364517,10126,'no','Legge til eierskap',0),(364518,10126,'da','TilfÃ¸je ejerskab',0),(364519,10126,'ko','ì¶”ê°€ ì†Œìœ ê¶Œ',0),(364520,10126,'he','×”×•×¡×£ ×‘×¢×œ×•×ª',0),(364521,10126,'el','Î ÏÎ¿ÏƒÎ¸Î­Ï„Ï‰ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±',0),(364522,10126,'zh','å¢žåŠ çš„æ‰€æœ‰æƒ\r\n',0),(364523,10126,'sv','LÃ¤gg till Ã¤gande',0),(364524,10126,'it','Aggiungere proprietÃ ',0),(364525,10126,'tl','',0),(364526,10126,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡',0),(364527,10126,'hi','à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(364528,10126,'ms','Menambah pemilikan',0),(364529,10126,'ar','Ø£Ø¶Ù Ù…Ù„ÙƒÙŠØ©',0),(364530,10126,'fr','Ajouter propriÃ©tÃ©',0),(364531,10126,'jp','æ‰€æœ‰æ¨©ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(364532,10126,'pt','Adicionar a propriedade',0),(364533,10126,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð²Ð»Ð°Ð´ÐµÐ»ÑŒÑ†Ð°',0),(364534,10126,'es','Agrega una AdquisiciÃ³n',0),(364535,10126,'de','HinzufÃ¼gen von Eigentum',0),(364536,10126,'en','Add Ownership',0),(364537,10127,'is','',0),(364538,10127,'dr','ØµØ§Ø­Ø¨ Ø´Ø±ÙƒØª ',0),(364539,10127,'pr','ØµØ§Ø­Ø¨ Ø´Ø±ÙƒØª ',0),(364540,10127,'tr','Åžirket sahibi',0),(364541,10127,'pl','WÅ‚aÅ›ciciel firmy',0),(364542,10127,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸Ðº Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð°',0),(364543,10127,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù…Ø§Ù„Ú©',0),(364544,10127,'sr','Ð’Ð»Ð°ÑÐ½Ð¸Ðº ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(364545,10127,'vi','chá»§ cÃ´ng ty',0),(364546,10127,'af','Onderneming Eienaar',0),(364547,10127,'ro','Proprietarul companiei',0),(364548,10127,'et','EttevÃµtte omanik',0),(364549,10127,'si','DruÅ¾ba lastnik',0),(364550,10127,'ba','Pemilik perusahaan',0),(364551,10127,'nl','Eigenaar bedrijf',0),(364552,10127,'fi','Yrityksen omistaja',0),(364553,10127,'no','Selskapet eier',0),(364554,10127,'da','Selskabet ejer',0),(364555,10127,'ko','íšŒì‚¬ ì†Œìœ ìž',0),(364556,10127,'he','×‘×¢×œ ×”×—×‘×¨×”',0),(364557,10127,'el','Î™Î´Î¹Î¿ÎºÏ„Î®Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(364558,10127,'zh','å…¬å¸è€æ¿\r\n',0),(364559,10127,'sv','FÃ¶retagets Ã¤gare',0),(364560,10127,'it','Proprietario dell\'azienda',0),(364561,10127,'tl','',0),(364562,10127,'th','à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸šà¸£à¸´à¸©à¸±à¸—',0),(364563,10127,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥à¤µà¤¾à¤®à¥€',0),(364564,10127,'ms','Pemilik syarikat',0),(364565,10127,'ar','Ù…Ø§Ù„Ùƒ Ø§Ù„Ø´Ø±ÙƒØ©',0),(364566,10127,'fr','PropriÃ©taire de l\'entreprise',0),(364567,10127,'jp','ä¼šç¤¾ã®æ‰€æœ‰è€…',0),(364568,10127,'pt','ProprietÃ¡rio da empresa',0),(364569,10127,'ru','Ð’Ð»Ð°Ð´ÐµÐ»ÐµÑ† ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(364570,10127,'es','DueÃ±o de Empresa',0),(364571,10127,'de','Firmeninhaber',0),(364572,10127,'en','Company Owner',0),(364573,10128,'is','',0),(364574,10128,'dr','Ù…Ø§Ù„ÙƒÙŠØª',0),(364575,10128,'pr','Ù…Ø§Ù„ÙƒÙŠØª',0),(364576,10128,'tr','Sahiplik',0),(364577,10128,'pl','WÅ‚asnoÅ›ci',0),(364578,10128,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(364579,10128,'ur','Ù…Ù„Ú©ÛŒØª',0),(364580,10128,'sr','Ð’Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾',0),(364581,10128,'vi','chá»§ sá»Ÿ há»¯u',0),(364582,10128,'af','Eienaarskap',0),(364583,10128,'ro','Dreptul de proprietate',0),(364584,10128,'et','Omandiline kuuluvus',0),(364585,10128,'si','LastniÅ¡tvo',0),(364586,10128,'ba','Kepemilikan',0),(364587,10128,'nl','Eigendom',0),(364588,10128,'fi','Omistus',0),(364589,10128,'no','Eierskap',0),(364590,10128,'da','Ejerskab',0),(364591,10128,'ko','ì†Œìœ ê¶Œ',0),(364592,10128,'he','×‘×¢×œ×•×ª',0),(364593,10128,'el','Î™Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±',0),(364594,10128,'zh','æ‰€æœ‰æƒ\r\n',0),(364595,10128,'sv','Ã„gande',0),(364596,10128,'it','ProprietÃ ',0),(364597,10128,'tl','',0),(364598,10128,'th','à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡',0),(364599,10128,'hi','à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ',0),(364600,10128,'ms','Pemilikan',0),(364601,10128,'ar','Ù…Ù„ÙƒÙŠØ©',0),(364602,10128,'fr','PropriÃ©tÃ©',0),(364603,10128,'jp','æ‰€æœ‰æ¨©',0),(364604,10128,'pt','Propriedade',0),(364605,10128,'ru','ÐŸÑ€Ð°Ð²Ð¾ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(364606,10128,'es','Pertenencia',0),(364607,10128,'de','Eigentum',0),(364608,10128,'en','Ownership',0),(364609,10129,'is','',0),(364610,10129,'dr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙƒÙŠØª',0),(364611,10129,'pr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙƒÙŠØª',0),(364612,10129,'tr','SahipliÄŸi yÃ¼zde',0),(364613,10129,'pl','Procent wÅ‚asnoÅ›ci',0),(364614,10129,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð½Ð° ÑÑ‚Ð¾',0),(364615,10129,'ur','Ù…Ù„Ú©ÛŒØª ÙÛŒØµØ¯',0),(364616,10129,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð°',0),(364617,10129,'vi','pháº§n trÄƒm sá»Ÿ há»¯u',0),(364618,10129,'af','Persentasie Eienaarskap',0),(364619,10129,'ro','Dreptul de proprietate la sutÄƒ',0),(364620,10129,'et','OmandiÃµigusega protsent',0),(364621,10129,'si','Odstotkov lastniÅ¡tva',0),(364622,10129,'ba','Persen kepemilikan',0),(364623,10129,'nl','Eigendom procent',0),(364624,10129,'fi','Omistus prosenttia',0),(364625,10129,'no','Eierskap prosent',0),(364626,10129,'da','Ejerskab procent',0),(364627,10129,'ko','ì†Œìœ ê¶Œ %',0),(364628,10129,'he','××—×•×– ×‘×¢×œ×•×ª',0),(364629,10129,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±',0),(364630,10129,'zh','æ‰€æœ‰æƒç™¾åˆ†æ¯”\r\n',0),(364631,10129,'sv','Ã„gande procent',0),(364632,10129,'it','Per cento di proprietÃ ',0),(364633,10129,'tl','',0),(364634,10129,'th','à¸£à¹‰à¸­à¸¢à¸¥à¸°à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡',0),(364635,10129,'hi','à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(364636,10129,'ms','Peratus pemilikan',0),(364637,10129,'ar','ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ù…Ù„ÙƒÙŠØ©',0),(364638,10129,'fr','PropriÃ©tÃ© pour cent',0),(364639,10129,'jp','æ‰€æœ‰æ¨©ã®ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ',0),(364640,10129,'pt','Por cento de posse',0),(364641,10129,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð²Ð»Ð°Ð´ÐµÐ½Ð¸Ñ',0),(364642,10129,'es','Porcentaje de Pertenencia',0),(364643,10129,'de','Eigentum Prozent',0),(364644,10129,'en','Ownership Percent',0),(364645,10130,'is','',0),(364646,10130,'dr','Ø«Ø¨Øª Ù…Ø§Ù„ÙƒÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(364647,10130,'pr','Ø«Ø¨Øª Ù…Ø§Ù„ÙƒÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(364648,10130,'tr','MÃ¼lkiyet kaydÄ± baÅŸarÄ±yla kaydedildi',0),(364649,10130,'pl','WÅ‚asnoÅ›Ä‡ rekordÃ³w pomyÅ›lnie zapisany',0),(364650,10130,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚Ñ‚Ð° Ð²ÑŠÑ€Ñ…Ñƒ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(364651,10130,'ur','Ù…Ù„Ú©ÛŒØª Ú©ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(364652,10130,'sr','Ð’Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾ Ð·Ð°Ð¿Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(364653,10130,'vi','ÄÃ£ lÆ°u ghi chá»§ sá»Ÿ há»¯u thÃ nh cÃ´ng',0),(364654,10130,'af','Eienakaprekord Suksesvol Gestoor',0),(364655,10130,'ro','Proprietatii Ã®nregistrÄƒri salvat cu succes',0),(364656,10130,'et','Omandi kirje edukalt salvestatud',0),(364657,10130,'si','LastniÅ¡tvo zapis shranjen',0),(364658,10130,'ba','Catatan kepemilikan yang berhasil diselamatkan',0),(364659,10130,'nl','Eigendom Record opgeslagen',0),(364660,10130,'fi','Omistus tietueen tallentaminen onnistui',0),(364661,10130,'no','Eierskap post lagret',0),(364662,10130,'da','Ejerskab rekord gemt med succes',0),(364663,10130,'ko','ì†Œìœ ê¶Œ ê¸°ë¡ì„ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(364664,10130,'he','×‘×¢×œ×•×ª ×¢×œ ×¨×©×•×ž×•×ª ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(364665,10130,'el','Î•Î³Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(364666,10130,'zh','æ‰€æœ‰æƒè®°å½•å·²æˆåŠŸä¿å­˜\r\n',0),(364667,10130,'sv','Ã„gande-post som sparats',0),(364668,10130,'it','ProprietÃ  Record salvati con successo',0),(364669,10130,'tl','',0),(364670,10130,'th','à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(364671,10130,'hi','à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(364672,10130,'ms','Pemilikan rekod berjaya disimpan',0),(364673,10130,'ar','Ø³Ø¬Ù„ Ù…Ù„ÙƒÙŠØ© Ø­ÙØ¸Ù‡ Ø¨Ù†Ø¬Ø§Ø­',0),(364674,10130,'fr','Enregistrement de propriÃ©tÃ© enregistrÃ© avec succÃ¨s',0),(364675,10130,'jp','æ‰€æœ‰æ¨©ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(364676,10130,'pt','Registro de propriedade, salvo com sucesso',0),(364677,10130,'ru','Ð’Ð»Ð°Ð´ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(364678,10130,'es','Record de Pertenencia Guardado Exitosamente',0),(364679,10130,'de','Besitz-Eintrag erfolgreich gespeichert',0),(364680,10130,'en','Ownership Record Saved Successfully',0),(364681,10131,'is','',0),(364682,10131,'dr','Ù…Ø§Ù„Ùƒ ',0),(364683,10131,'pr','Ù…Ø§Ù„Ùƒ ',0),(364684,10131,'tr','Sahibi',0),(364685,10131,'pl','Jest wÅ‚aÅ›cicielem',0),(364686,10131,'bg','ÐŸÑ€Ð¸Ñ‚ÐµÐ¶Ð°Ð²Ð°',0),(364687,10131,'ur','Ù…Ø§Ù„Ú©',0),(364688,10131,'sr','Ð’Ð»Ð°ÑÐ½Ð¸Ðº',0),(364689,10131,'vi','lÃ m chá»§',0),(364690,10131,'af','Besit',0),(364691,10131,'ro','Detine',0),(364692,10131,'et','Omab',0),(364693,10131,'si','Je lastnik',0),(364694,10131,'ba','Memiliki',0),(364695,10131,'nl','Bezit',0),(364696,10131,'fi','Omistaa',0),(364697,10131,'no','Eier',0),(364698,10131,'da','Ejer',0),(364699,10131,'ko','ì†Œìœ  í•˜',0),(364700,10131,'he','×”×‘×¢×œ×™×',0),(364701,10131,'el','ÎšÎ±Ï„Î­Ï‡ÎµÎ¹',0),(364702,10131,'zh','æ‹¥æœ‰\r\n',0),(364703,10131,'sv','Ã„ger',0),(364704,10131,'it','Possiede',0),(364705,10131,'tl','',0),(364706,10131,'th','à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡',0),(364707,10131,'hi','à¤•à¤¾ à¤®à¤¾à¤²à¤¿à¤•',0),(364708,10131,'ms','Memiliki',0),(364709,10131,'ar','ÙŠÙ…Ù„Ùƒ',0),(364710,10131,'fr','Est propriÃ©taire',0),(364711,10131,'jp','æ‰€æœ‰ã—ã¦ã„ã¾ã™ã€‚',0),(364712,10131,'pt','Ã‰ o dono',0),(364713,10131,'ru','Ð’Ð»Ð°Ð´ÐµÐµÑ‚',0),(364714,10131,'es','Ser DueÃ±o de',0),(364715,10131,'de','Besitzt',0),(364716,10131,'en','Owns',0),(364717,10132,'is','',0),(364718,10132,'dr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙƒÙŠØª Ø¨Ø§ÙŠØ¯ Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(364719,10132,'pr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÙƒÙŠØª Ø¨Ø§ÙŠØ¯ Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(364720,10132,'tr','Daha bÃ¼yÃ¼k 0\'dan yÃ¼zde sahipliÄŸini gerekir olmak',0),(364721,10132,'pl','Procent wÅ‚asnoÅ›ci musi byÄ‡ wiÄ™kszy niÅ¼ 0',0),(364722,10132,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° Ð½Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚Ñ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ð¾-Ð³Ð¾Ð»ÑÐ¼Ð¾ Ð¾Ñ‚ 0',0),(364723,10132,'ur','ÙÛŒ ØµØ¯ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û 0 ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒÛ’',0),(364724,10132,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð²ÐµÑ›Ð¸ Ð¾Ð´ 0',0),(364725,10132,'vi','Pháº§n trÄƒm chá»§ sá»¡ há»¯u pháº£i lá»›n hÆ¡n 0',0),(364726,10132,'af','Die Persentasie van Eienaarskap Moet Groter Wees as 0',0),(364727,10132,'ro','La sutÄƒ de proprietate trebuie sÄƒ fie mai mare decÃ¢t 0',0),(364728,10132,'et','Protsent omandi peab olema suurem kui 0',0),(364729,10132,'si','Odstotkov lastniÅ¡tva mora biti veÄja od 0',0),(364730,10132,'ba','Persen dari kepemilikan harus lebih besar daripada 0',0),(364731,10132,'nl','De procent van eigendom moet worden groter dan 0',0),(364732,10132,'fi','Prosentin omistus on oltava suurempi kuin 0',0),(364733,10132,'no','Prosent av eierskap mÃ¥ vÃ¦re stÃ¸rre enn 0',0),(364734,10132,'da','Procent af ejerskab skal vÃ¦re stÃ¸rre end 0',0),(364735,10132,'ko','%ì˜ ì†Œìœ ê¶Œ ì´ì–´ì•¼ í° 0 ë³´ë‹¤',0),(364736,10132,'he','××—×•×– ×©×œ ×”×‘×¢×œ×•×ª ×—×™×™×‘×ª ×œ×”×™×•×ª ×’×“×•×œ×” ×ž 0',0),(364737,10132,'el','Î¤Î¿ Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï„Î·Ï‚ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼ÎµÎ³Î±Î»ÏÏ„ÎµÏÎ¿ Î±Ï€ÏŒ 0',0),(364738,10132,'zh','æ‰€æœ‰åˆ¶çš„ç™¾åˆ†æ¯”å¿…é¡»å¤§äºŽ0\r\n',0),(364739,10132,'sv','Procent av Ã¤gandet mÃ¥ste vara stÃ¶rre Ã¤n 0',0),(364740,10132,'it','La percentuale di proprietÃ  deve essere maggiore di 0',0),(364741,10132,'tl','',0),(364742,10132,'th','à¹ƒà¸™à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸‚à¸­à¸‡à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸•à¹‰à¸­à¸‡à¸¡à¸²à¸à¸à¸§à¹ˆà¸² 0',0),(364743,10132,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¤¾ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ à¤…à¤§à¤¿à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• 0 à¤¸à¥‡',0),(364744,10132,'ms','Dengan peratus daripada pemilikan mestilah lebih besar daripada 0',0),(364745,10132,'ar','\"Ø§Ù„Ù…Ø¦Ø© Ù…Ù† Ù…Ù„ÙƒÙŠØ© ÙŠØ¬Ø¨ Ø£Ù†\" ØªÙƒÙˆÙ† \"Ø£ÙƒØ¨Ø± Ù…Ù†\" 0',0),(364746,10132,'fr','Le pourcentage de propriÃ©tÃ© doit Ãªtre supÃ©rieur Ã  0',0),(364747,10132,'jp','0 ã‚ˆã‚Šå¤§ãã„ãŒã€ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆã®æ‰€æœ‰æ¨©ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(364748,10132,'pt','Os por cento de posse deve ser maior que 0',0),(364749,10132,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð²Ð»Ð°Ð´ÐµÐ½Ð¸Ñ Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ð±Ð¾Ð»ÑŒÑˆÐµ Ñ‡ÐµÐ¼ 0',0),(364750,10132,'es','El Porcentaje de Pertenencia Debe Ser MÃ¡s Grande Que Cero',0),(364751,10132,'de','Das Prozent der Besitz muss sein grÃ¶ÃŸer als 0',0),(364752,10132,'en','The Percent of Ownership Must be Greater Than 0',0),(364753,10133,'is','',0),(364754,10133,'dr','100 ÙÛŒØµØ¯ Ø¨Ø§Ø´Ø¯ ',0),(364755,10133,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù…Ø§Ù„ÙƒÙŠØª Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨ÙŠØ´ Ø§Ø² 100 Ø¯Ø±ØµØ¯ Ø¨Ø§Ø´Ø¯ ',0),(364756,10133,'tr','Toplam sahip olma yÃ¼zde 100\'den fazla olamaz',0),(364757,10133,'pl','CaÅ‚kowita wÅ‚asnoÅ›Ä‡ nie moÅ¼e przekroczyÄ‡ 100 procent',0),(364758,10133,'bg','ÐŸÑŠÐ»Ð½Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð´Ñ…Ð²ÑŠÑ€Ð»Ñ 100 Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(364759,10133,'ur','Ú©Ù„ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª 100 ÙÛŒ ØµØ¯ Ø³Û’ ØªØ¬Ø§ÙˆØ² Ù†ÛÛŒÚº',0),(364760,10133,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾ Ð½Ðµ ÑÐ¼Ðµ Ð¿Ñ€ÐµÐ¼Ð°ÑˆÐ¸Ñ‚Ð¸ 100 Ð¿Ð¾ÑÑ‚Ð¾',0),(364761,10133,'vi','Tá»•ng sá»‘ sá»Ÿ há»¯u khÃ´ng vÆ°á»£t quÃ¡ 100%',0),(364762,10133,'af','Totale Eienaarskap Mag Nie 100 Persent Oorskry',0),(364763,10133,'ro','Total de proprietate nu poate depÄƒÅŸi 100 la sutÄƒ',0),(364764,10133,'et','Omamine vÃµib anda kuni 100%',0),(364765,10133,'si','Skupno lastniÅ¡tvo ne sme biti veÄja od 100 odstotkov',0),(364766,10133,'ba','Total kepemilikan tidak boleh melebihi 100 persen',0),(364767,10133,'nl','Totale eigendom mag niet hoger zijn dan 100 procent',0),(364768,10133,'fi','Kokonaiskustannuksia ei saa olla 100 prosenttia',0),(364769,10133,'no','Totalt eierskap kan ikke overstige 100 prosent',0),(364770,10133,'da','Samlede ejerskab mÃ¥ ikke overstige 100 procent',0),(364771,10133,'ko','ì´ ì†Œìœ ê¶Œì€ 100%ë¥¼ ì´ˆê³¼í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(364772,10133,'he','×”×‘×¢×œ×•×ª ×”×›×•×œ×œ×ª ×œ× ×ª×¢×œ×” ×¢×œ 100 ××—×•×–',0),(364773,10133,'el','ÎŸÎ»Î¹ÎºÎ® Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î± Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï…Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ Ï„Î¿ 100 Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(364774,10133,'zh','æ€»æ‰€æœ‰æƒå¯èƒ½ä¸è¶…è¿‡ç™¾åˆ†ç™¾\r\n',0),(364775,10133,'sv','Totala Ã¤gande fÃ¥r inte Ã¶verstiga 100 procent',0),(364776,10133,'it','ProprietÃ  totale non puÃ² superare il 100 per cento',0),(364777,10133,'tl','',0),(364778,10133,'th','à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸£à¸§à¸¡à¸•à¹‰à¸­à¸‡à¹„à¸¡à¹ˆà¹€à¸à¸´à¸™à¸£à¹‰à¸­à¸¢à¸¥à¸° 100',0),(364779,10133,'hi','à¤•à¥à¤² à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ 100 à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¨ à¤¹à¥‹',0),(364780,10133,'ms','Jumlah pemilikan tidak boleh melebihi 100 peratus',0),(364781,10133,'ar','Ù„Ø§ ÙŠØ¬ÙˆØ² Ø£Ù† ÙŠØªØ¬Ø§ÙˆØ² Ù…Ø¬Ù…ÙˆØ¹ Ù…Ù„ÙƒÙŠØ© 100%',0),(364782,10133,'fr','PropriÃ©tÃ© totale ne peut dÃ©passer 100 %',0),(364783,10133,'jp','æ‰€æœ‰æ¨©ã®åˆè¨ˆãŒ 100% ã‚’è¶…ãˆã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(364784,10133,'pt','Posse total nÃ£o pode exceder 100%',0),(364785,10133,'ru','ÐžÐ±Ñ‰ÐµÐ¹ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð¿Ñ€ÐµÐ²Ñ‹ÑˆÐ°Ñ‚ÑŒ 100 Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(364786,10133,'es','Pertenencia Total no Debe Exceder 100 Porciento',0),(364787,10133,'de','Total Ownership kann nicht 100 Prozent Ã¼bersteigt.',0),(364788,10133,'en','Total Ownership May Not Exceed 100 Percent',0),(364789,10134,'is','',0),(364790,10134,'dr','ÙƒØ§Ø±Ø¨Ø± Ù…Ø§Ù„Ùƒ ',0),(364791,10134,'pr','ÙƒØ§Ø±Ø¨Ø± Ù…Ø§Ù„Ùƒ ',0),(364792,10134,'tr','KullanÄ±cÄ±nÄ±n sahibi',0),(364793,10134,'pl','UÅ¼ytkownika wÅ‚aÅ›ciciela',0),(364794,10134,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸Ðº',0),(364795,10134,'ur','ØµØ§Ø±Ù Ú©Û’ Ù…Ø§Ù„Ú©',0),(364796,10134,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð²Ð»Ð°ÑÐ½Ð¸Ðº',0),(364797,10134,'vi','NgÆ°á»i chá»§ sá»Ÿ há»¯u ngÆ°á»i dÃ¹ng',0),(364798,10134,'af','Gebruiker Eienaar',0),(364799,10134,'ro','Utilizator proprietar',0),(364800,10134,'et','Kasutaja omanik',0),(364801,10134,'si','Uporabnik lastnik',0),(364802,10134,'ba','Pemilik pengguna',0),(364803,10134,'nl','Gebruiker eigenaar',0),(364804,10134,'fi','KÃ¤yttÃ¤jÃ¤n omistaja',0),(364805,10134,'no','Brukeren eier',0),(364806,10134,'da','Brugeren ejer',0),(364807,10134,'ko','ì‚¬ìš©ìž ì†Œìœ ìž',0),(364808,10134,'he','×ž×©×ª×ž×© ×‘×¢×œ',0),(364809,10134,'el','Î™Î´Î¹Î¿ÎºÏ„Î®Ï„Î·Ï‚ Ï„Î¿Ï… Ï‡ÏÎ®ÏƒÏ„Î·',0),(364810,10134,'zh','ç”¨æˆ·æ‰€æœ‰è€…\r\n',0),(364811,10134,'sv','AnvÃ¤ndaren Ã¤gare',0),(364812,10134,'it','Utente proprietario',0),(364813,10134,'tl','',0),(364814,10134,'th','à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(364815,10134,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¥à¤µà¤¾à¤®à¥€',0),(364816,10134,'ms','Pemilik pengguna',0),(364817,10134,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ù…Ø§Ù„Ùƒ',0),(364818,10134,'fr','Utilisateur propriÃ©taire',0),(364819,10134,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ‰€æœ‰è€…',0),(364820,10134,'pt','UsuÃ¡rio proprietÃ¡rio',0),(364821,10134,'ru','Ð’Ð»Ð°Ð´ÐµÐ»ÐµÑ† Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(364822,10134,'es','Dueno Usuario',0),(364823,10134,'de','Benutzer Besitzer',0),(364824,10134,'en','User Owner',0),(364825,10135,'is','',0),(364826,10135,'dr','Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ù‡Ù… ÙŠÙƒ Ø´Ø±ÙƒØª Ùˆ Ù‡Ù… ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø±Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø§Ù„Ùƒ Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(364827,10135,'pr','Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ù‡Ù… ÙŠÙƒ Ø´Ø±ÙƒØª Ùˆ Ù‡Ù… ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± Ø±Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø§Ù„Ùƒ Ø¯Ø± Ø§ÙŠÙ†Ø¬Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(364828,10135,'tr','Hem ÅŸirket hem de kullanÄ±cÄ± sahibi olarak burada seÃ§emezsiniz',0),(364829,10135,'pl','Nie moÅ¼na wybraÄ‡ zarÃ³wno firmy, jak i uÅ¼ytkownika jako wÅ‚aÅ›ciciela tutaj',0),(364830,10135,'bg','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ´Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» ÐºÐ°Ñ‚Ð¾ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸Ðº Ñ‚ÑƒÐº',0),(364831,10135,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ú©Ù…Ù¾Ù†ÛŒ Ø§ÙˆØ± ØµØ§Ø±Ù Ø¯ÙˆÙ†ÙˆÚº Ù…Ø§Ù„Ú© Ú©Û’ Ø·ÙˆØ± Ù¾Ø± ÛŒÛØ§Úº Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(364832,10135,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° ÐºÐ°Ð¾ Ð²Ð»Ð°ÑÐ½Ð¸ÐºÐ° Ð¾Ð²Ð´Ðµ',0),(364833,10135,'vi','báº¡n khÃ´ng thá»ƒ vá»«a chá»n cáº£ cÃ´ng ty vÃ  ngÆ°á»i sá»­ dá»¥ng nhÆ° lÃ  chá»§ sá»Ÿ há»¯u á»Ÿ Ä‘Ã¢y',0),(364834,10135,'af','U Kan Nie Hier Beide \'n Onderneming EN \'n Gebruiker as Eienaar kies nie',0),(364835,10135,'ro','Se poate selecta un utilizator ÅŸi unei companii ca un proprietar de aici',0),(364836,10135,'et','Te ei saa mÃ¤Ã¤rata omanikku ja kasutajat korraga omanikuks siin',0),(364837,10135,'si','Podjetje in uporabnika ne morete izbrati kot lastnik tukaj',0),(364838,10135,'ba','Anda tidak dapat memilih sebuah perusahaan dan pengguna sebagai pemilik di sini',0),(364839,10135,'nl','U kunt zowel een bedrijf als een gebruiker niet selecteren als een eigenaar hier',0),(364840,10135,'fi','Valitse yritys ja kÃ¤yttÃ¤jÃ¤ koska by haltija',0),(364841,10135,'no','Du kan ikke velge bÃ¥de et selskap og brukeren som eier her',0),(364842,10135,'da','Du kan ikke vÃ¦lge et firma og en bruger som ejer her',0),(364843,10135,'ko','ì—¬ê¸° ì†Œìœ ìžëŠ” íšŒì‚¬ì™€ ì‚¬ìš©ìž ë‘˜ ë‹¤ë¥¼ ì„ íƒí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(364844,10135,'he','××™×Ÿ ×‘××¤×©×¨×•×ª×š ×œ×‘×—×•×¨ ×”×Ÿ ×©×œ ×”×—×‘×¨×” ×•×”×Ÿ ×œ×ž×©×ª×ž×© ×›×‘×¢×œ×™× ×›××Ÿ',0),(364845,10135,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î¼Î¹Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎºÎ±Î¹ Î­Î½Î± Ï‡ÏÎ®ÏƒÏ„Î· Ï‰Ï‚ Î¹Î´Î¹Î¿ÎºÏ„Î®Ï„Î·Ï‚ ÎµÎ´ÏŽ',0),(364846,10135,'zh','ä½ ä¸èƒ½é€‰æ‹©ä¸€ä¸ªå…¬å¸æˆ–ä¸€ä¸ªç”¨æˆ·ä½œä¸ºè¿™é‡Œçš„æ‰€æœ‰è€…\r\n',0),(364847,10135,'sv','Du kan inte vÃ¤lja bÃ¥de ett fÃ¶retag och en anvÃ¤ndare som Ã¤gare hÃ¤r',0),(364848,10135,'it','Non Ã¨ possibile selezionare un\'azienda sia un utente come proprietario qui',0),(364849,10135,'tl','',0),(364850,10135,'th','à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸¥à¸·à¸­à¸à¸—à¸±à¹‰à¸‡à¸šà¸£à¸´à¸©à¸±à¸—à¹à¸¥à¸°à¸œà¸¹à¹‰à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸—à¸µà¹ˆà¸™à¸µà¹ˆ',0),(364851,10135,'hi','à¤†à¤ª à¤¯à¤¹à¤¾à¤ à¤¸à¥à¤µà¤¾à¤®à¥€ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¦à¥‹à¤¨à¥‹à¤‚ à¤à¤• à¤•à¤‚à¤ªà¤¨à¥€ à¤”à¤° à¤à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(364852,10135,'ms','Anda tidak boleh memilih kedua-dua syarikat dan pengguna sebagai pemilik di sini',0),(364853,10135,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ†Ùƒ ØªØ­Ø¯ÙŠØ¯ ÙƒÙ„ Ù…Ù† Ø´Ø±ÙƒØ© ÙˆÙ…Ø³ØªØ®Ø¯Ù… ÙƒÙ…Ø§Ù„Ùƒ Ù‡Ù†Ø§',0),(364854,10135,'fr','Vous ne pouvez pas sÃ©lectionner des fois une entreprise et un utilisateur en tant que propriÃ©taire ici',0),(364855,10135,'jp','ã“ã“ã§ã¯ã€æ‰€æœ‰è€…ã¨ã—ã¦ã€ä¼šç¤¾ã¨ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®ä¸¡æ–¹ã‚’é¸æŠžã§ãã¾ã›ã‚“ã€‚',0),(364856,10135,'pt','VocÃª nÃ£o pode selecionar uma empresa e um usuÃ¡rio como um dono aqui',0),(364857,10135,'ru','Ð’Ñ‹ ÐÐµ ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐžÐ±Ðµ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð˜ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð² ÐºÐ°Ñ‡ÐµÑÑ‚Ð²Ðµ Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¸ÐºÐ° Ð—Ð´ÐµÑÑŒ',0),(364858,10135,'es','No se Puede Seleccionar Tanto Una Empresa Como Un Usuario Como Un DueÃ±o Aqui',0),(364859,10135,'de','Sie kÃ¶nnen keine Firma und ein Benutzer als Besitzer hier auswÃ¤hlen.',0),(364860,10135,'en','You Cannot Select Both a Company AND a User as an Owner Here',0),(364861,10136,'is','',0),(364862,10136,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± ÙŠØ§ ÙŠÙƒ Ø´Ø±ÙƒØª Ø±Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø§Ù„Ùƒ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(364863,10136,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙƒØ§Ø±Ø¨Ø± ÙŠØ§ ÙŠÙƒ Ø´Ø±ÙƒØª Ø±Ø§ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø§Ù„Ùƒ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(364864,10136,'tr','Bir kullanÄ±cÄ± veya bir ÅŸirket sahibi olarak seÃ§melisiniz',0),(364865,10136,'pl','NaleÅ¼y wybraÄ‡ uÅ¼ytkownika bÄ…dÅº firmy jako wÅ‚aÅ›ciciel',0),(364866,10136,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð¸Ð»Ð¸ Ñ„Ð¸Ñ€Ð¼Ð° ÐºÐ°Ñ‚Ð¾ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸Ðº',0),(364867,10136,'ur','Ø¢Ù¾ Ø§ÛŒÚ© ØµØ§Ø±Ù ÛŒØ§ Ú©Ø³ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù…Ø§Ù„Ú© Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(364868,10136,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¸Ð»Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð° ÐºÐ°Ð¾ Ð²Ð»Ð°ÑÐ½Ð¸ÐºÐ°',0),(364869,10136,'vi','Báº¡n Pháº£i Chá»n Hoáº·c lÃ  má»™t NgÆ°á»i dÃ¹ng OR CÃ´ng ty nhÆ° lÃ  ngÆ°á»i chá»§ sá»Ÿ há»¯u',0),(364870,10136,'af','U Moet \'n of \'n Gebruiker OF \'n Onderneming as \'n Eienaar kies',0),(364871,10136,'ro','Trebuie sÄƒ selectaÅ£i un utilizator sau o companie ca proprietar',0),(364872,10136,'et','Te peate mÃ¤Ã¤rama kas kasutaja vÃµi ettevÃµtte omanikuks',0),(364873,10136,'si','Morate izbrati uporabnik ali podjetje kot lastnik',0),(364874,10136,'ba','Anda harus memilih pengguna maupun perusahaan sebagai pemilik',0),(364875,10136,'nl','U moet een gebruiker of een bedrijf als een eigenaar selecteren',0),(364876,10136,'fi','Valitse kÃ¤yttÃ¤jÃ¤ tai yrityksen omistajana',0),(364877,10136,'no','Du mÃ¥ velge en bruker eller et selskap som eier',0),(364878,10136,'da','Du skal vÃ¦lge enten en bruger eller et selskab, som ejer',0),(364879,10136,'ko','ì†Œìœ ìžë¡œ ì„œ ì‚¬ìš©ìž ë˜ëŠ” íšŒì‚¬ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(364880,10136,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×ž×©×ª×ž×© ××• ×—×‘×¨×” ×›×‘×¢×œ×™×',0),(364881,10136,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ ÎµÎ¯Ï„Îµ Î­Î½Î± Ï‡ÏÎ®ÏƒÏ„Î· Î® Î¼Î¹Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Ï‰Ï‚ Î¹Î´Î¹Î¿ÎºÏ„Î®Ï„Î·Ï‚',0),(364882,10136,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªç”¨æˆ·æˆ–å…¬å¸ä½œä¸ºæ‰€æœ‰è€…\r\n',0),(364883,10136,'sv','Du mÃ¥ste vÃ¤lja antingen en anvÃ¤ndare eller ett fÃ¶retag som Ã¤gare',0),(364884,10136,'it','Ãˆ necessario selezionare un utente o una societÃ  come proprietario',0),(364885,10136,'tl','',0),(364886,10136,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸«à¸£à¸·à¸­à¸šà¸£à¸´à¸©à¸±à¸—à¸—à¸µà¹ˆà¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡',0),(364887,10136,'hi','à¤¤à¥à¤® à¤à¤• à¤®à¤¾à¤²à¤¿à¤• à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¯à¤¾ à¤¤à¥‹ à¤à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¯à¤¾ à¤à¤• à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(364888,10136,'ms','Anda mesti memilih sama ada pengguna atau Syarikat sebagai pemilik',0),(364889,10136,'ar','ÙŠØ¬Ø¨ ØªØ­Ø¯ÙŠØ¯ Ù…Ø³ØªØ®Ø¯Ù… Ø£Ùˆ Ø´Ø±ÙƒØ© ÙƒÙ…Ø§Ù„Ùƒ',0),(364890,10136,'fr','Vous devez sÃ©lectionner un utilisateur, ou bien une sociÃ©tÃ©, comme prorpiÃ©taire.',0),(364891,10136,'jp','æ‰€æœ‰è€…ã¨ã—ã¦ã€ãƒ¦ãƒ¼ã‚¶ãƒ¼ã¾ãŸã¯ä¼šç¤¾ã®ã©ã¡ã‚‰ã‹ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(364892,10136,'pt','VocÃª deve selecionar um usuÃ¡rio ou uma empresa como um proprietÃ¡rio',0),(364893,10136,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð½Ñ‹ Ð¢Ð°ÐºÐ¶Ðµ Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð˜Ð›Ð˜ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑŽ ÐºÐ°Ðº Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¸ÐºÐ°',0),(364894,10136,'es','Debe Seleccionar o Un usuario o Una Empresa Como el DueÃ±o',0),(364895,10136,'de','Sie mÃ¼ssen entweder ein Benutzer oder ein Unternehmen als EigentÃ¼mer auswÃ¤hlen.',0),(364896,10136,'en','You Must Select Either a User OR a Company as an Owner',0),(364897,10137,'is','',0),(364898,10137,'dr','/ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(364899,10137,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  / ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(364900,10137,'tr','PO/SB',0),(364901,10137,'pl','PO/SB',0),(364902,10137,'bg','PO/SB',0),(364903,10137,'ur','Ù¾Ùˆ ÙØ±ÛŒØ¶Û Ø³Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯Û’',0),(364904,10137,'sr','ÐŸÐž/Ð¡Ð‘',0),(364905,10137,'vi','PO/SB',0),(364906,10137,'af','PO/SB',0),(364907,10137,'ro','PO/SB',0),(364908,10137,'et','PO/SB',0),(364909,10137,'si','PO/SB',0),(364910,10137,'ba','PO SB',0),(364911,10137,'nl','PO/SB',0),(364912,10137,'fi','PO/SB',0),(364913,10137,'no','PO/SB',0),(364914,10137,'da','PO/SB',0),(364915,10137,'ko','í¬/SB',0),(364916,10137,'he','×¤×•/SB',0),(364917,10137,'el','PO/SB',0),(364918,10137,'zh','è®¢å•/æœåŠ¡å…¬å‘Š\r\n',0),(364919,10137,'sv','PO/SB',0),(364920,10137,'it','PO/SB',0),(364921,10137,'tl','',0),(364922,10137,'th','à¸›à¸­/SB',0),(364923,10137,'hi','à¤ªà¥€à¤“/SB',0),(364924,10137,'ms','PO/SB',0),(364925,10137,'ar','Øµ. Ø¨/Ø³',0),(364926,10137,'fr','PO/SB',0),(364927,10137,'jp','PO/SB',0),(364928,10137,'pt','PO/SB',0),(364929,10137,'ru','PO/SB',0),(364930,10137,'es','OC/SB',0),(364931,10137,'de','PO/SB',0),(364932,10137,'en','PO/SB',0),(364933,10138,'is','',0),(364934,10138,'dr','/ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(364935,10138,'pr','Ú†Ùƒ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  / ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(364936,10138,'tr','PO/SB denetim listesi',0),(364937,10138,'pl','Lista kontrolna PO/SB',0),(364938,10138,'bg','PO/SB Ð§ÐµÐºÐ»Ð¸ÑÑ‚',0),(364939,10138,'ur','Ù¾Ùˆ ÙØ±ÛŒØ¶Û Ø³Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯Û’ Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(364940,10138,'sr','ÐŸÐž /Ð¡Ð‘ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(364941,10138,'vi','danh sÃ¡ch kiá»ƒm tra PO/SB',0),(364942,10138,'af','PO/SB Kontrolelys',0),(364943,10138,'ro','Lista de verificare a PO/SB',0),(364944,10138,'et','PO/SB kontroll-loend',0),(364945,10138,'si','PO/SB kontrolni seznam',0),(364946,10138,'ba','PO SB Checklist',0),(364947,10138,'nl','PO/SB Checklist',0),(364948,10138,'fi','PO/SB tarkistuslista',0),(364949,10138,'no','PO/SB sjekkliste',0),(364950,10138,'da','PO/SB tjekliste',0),(364951,10138,'ko','í¬/SB ì²´í¬ ë¦¬ìŠ¤íŠ¸',0),(364952,10138,'he','×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢ ×¤×•/SB',0),(364953,10138,'el','PO/SB Î»Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(364954,10138,'zh','è®¢å•/æœåŠ¡å…¬å‘Šæ£€æŸ¥æ¸…å•\r\n',0),(364955,10138,'sv','PO/SB checklista',0),(364956,10138,'it','PO/SB Checklist',0),(364957,10138,'tl','',0),(364958,10138,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š PO/SB',0),(364959,10138,'hi','à¤ªà¥€à¤“/SB à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ',0),(364960,10138,'ms','Senarai Semak PO/SB',0),(364961,10138,'ar','Øµ. Ø¨/SB Ø§Ù„Ù…Ø±Ø¬Ø¹ÙŠØ©',0),(364962,10138,'fr','Liste de contrÃ´le de PO/SB',0),(364963,10138,'jp','PO/SB ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆ',0),(364964,10138,'pt','Checklist de PO/SB',0),(364965,10138,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº PO/SB',0),(364966,10138,'es','OC/SB Lista de Tareas',0),(364967,10138,'de','PO/SB-Checkliste',0),(364968,10138,'en','PO/SB Checklist',0),(364969,10139,'is','',0),(364970,10139,'dr','(Ø³ÙŠØ§Ù‡Ù‡  ',0),(364971,10139,'pr','Ú†Ùƒ Ù„ÙŠØ³Øª (Ø³ÙŠØ§Ù‡Ù‡  ',0),(364972,10139,'tr','Kontrol listesi',0),(364973,10139,'pl','Lista kontrolna',0),(364974,10139,'bg','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº',0),(364975,10139,'ur','Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(364976,10139,'sr','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(364977,10139,'vi','Danh má»¥c kiá»ƒm tra',0),(364978,10139,'af','Nasienlys',0),(364979,10139,'ro','Lista de verificare',0),(364980,10139,'et','Kontroll-loend',0),(364981,10139,'si','Kontrolni seznam',0),(364982,10139,'ba','Daftar Periksa',0),(364983,10139,'nl','Controlelijst',0),(364984,10139,'fi','Tarkistuslista',0),(364985,10139,'no','Sjekkliste',0),(364986,10139,'da','Tjekliste',0),(364987,10139,'ko','ê²€ì‚¬ ëª©ë¡',0),(364988,10139,'he','×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢',0),(364989,10139,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(364990,10139,'zh','æ¸…å•\r\n',0),(364991,10139,'sv','Checklista',0),(364992,10139,'it','Lista di controllo',0),(364993,10139,'tl','',0),(364994,10139,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(364995,10139,'hi','à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ',0),(364996,10139,'ms','Senarai Semak',0),(364997,10139,'ar','Ù‚Ø§Ø¦Ù…Ø© Ù…Ø±Ø¬Ø¹ÙŠØ©',0),(364998,10139,'fr','Liste de vÃ©rification',0),(364999,10139,'jp','ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆ',0),(365000,10139,'pt','Lista de verificaÃ§Ã£o',0),(365001,10139,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(365002,10139,'es','Lista de Tareas',0),(365003,10139,'de','Checkliste',0),(365004,10139,'en','Checklist',0),(365005,10140,'is','',0),(365006,10140,'dr','(Ø³ÙŠØ§Ù‡Ù‡) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(365007,10140,'pr','Ú†Ùƒ Ù„ÙŠØ³Øª (Ø³ÙŠØ§Ù‡Ù‡) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯',0),(365008,10140,'tr','Kontrol listesi baÅŸarÄ±yla kaydedildi',0),(365009,10140,'pl','Lista kontrolna zapisane',0),(365010,10140,'bg','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(365011,10140,'ur','Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(365012,10140,'sr','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ð° Ð»Ð¸ÑÑ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(365013,10140,'vi','LÆ°u danh má»¥c kiá»ƒm tra thÃ nh cÃ´ng',0),(365014,10140,'af','Nasienlys suksesvol Gestoor',0),(365015,10140,'ro','Lista de verificare salvat cu succes',0),(365016,10140,'et','Meelespea edukalt salvestatud',0),(365017,10140,'si','Kontrolni seznam uspeÅ¡no shranjen',0),(365018,10140,'ba','Daftar Periksa yang berhasil diselamatkan',0),(365019,10140,'nl','Controlelijst opgeslagen',0),(365020,10140,'fi','Tarkistuslista tallennettu',0),(365021,10140,'no','Sjekkliste lagret',0),(365022,10140,'da','Tjekliste gemt med succes',0),(365023,10140,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” ê²€ì‚¬ ëª©ë¡',0),(365024,10140,'he','×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢ ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(365025,10140,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(365026,10140,'zh','å·²æˆåŠŸä¿å­˜æ¸…å•\r\n',0),(365027,10140,'sv','Checklista sparats',0),(365028,10140,'it','Lista di controllo salvato correttamente',0),(365029,10140,'tl','',0),(365030,10140,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(365031,10140,'hi','à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(365032,10140,'ms','Senarai Semak yang berjaya disimpan',0),(365033,10140,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ø®ØªÙŠØ§Ø± Ø­ÙØ¸ Ø¨Ù†Ø¬Ø§Ø­',0),(365034,10140,'fr','Liste de contrÃ´le enregistrÃ©e avec succÃ¨s',0),(365035,10140,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚ŒãŸãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆ',0),(365036,10140,'pt','Lista de verificaÃ§Ã£o com sucesso',0),(365037,10140,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(365038,10140,'es','Lista de Tareas Grabada Exitosamente',0),(365039,10140,'de','Checkliste erfolgreich gespeichert',0),(365040,10140,'en','Checklist Saved Successfully',0),(365041,10141,'is','',0),(365042,10141,'dr','(Ø³ÙŠØ§Ù‡Ù‡) ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡  Ø§Ø³Øª',0),(365043,10141,'pr','Ù†ÙˆØ¹ Ú†Ùƒ Ù„ÙŠØ³Øª (Ø³ÙŠØ§Ù‡Ù‡) ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡  Ø§Ø³Øª',0),(365044,10141,'tr','Denetim tÃ¼rÃ¼ ayarlÄ± deÄŸil',0),(365045,10141,'pl','Lista kontrolna typu nie zestaw',0),(365046,10141,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ñ‚Ð¸Ð¿ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼',0),(365047,10141,'ur','ÙÛØ±Ø³Øª Ù‚Ø³Ù… Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(365048,10141,'sr','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ð° Ð»Ð¸ÑÑ‚Ð° Ñ‚Ð¸Ð¿ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(365049,10141,'vi','KhÃ´ng cÃ³ danh má»¥c kiá»ƒm tra',0),(365050,10141,'af','Nasienlys Tipe Nie Gestel',0),(365051,10141,'ro','Tip de listÄƒ de verificare nu setaÅ£i',0),(365052,10141,'et','Kontroll-loendi tÃ¼Ã¼p pole mÃ¤Ã¤ratud',0),(365053,10141,'si','Kontrolni seznam vrsta ni nastavljena',0),(365054,10141,'ba','Jenis daftar tidak diatur',0),(365055,10141,'nl','Controlelijst Type niet is ingesteld',0),(365056,10141,'fi','Tarkistuslista tyyppiÃ¤ ei ole mÃ¤Ã¤ritetty',0),(365057,10141,'no','Sjekkliste Type ikke angitt',0),(365058,10141,'da','Tjekliste Type ikke angivet',0),(365059,10141,'ko','ê²€ì‚¬ ëª©ë¡ í˜•ì‹ì´ ì„¤ì • í•˜ì§€',0),(365060,10141,'he','×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢ ×¡×•×’ ×œ× ×ž×•×’×“×¨',0),(365061,10141,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… Ï„ÏÏ€Î¿Ï‚ Î´ÎµÎ½ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(365062,10141,'zh','æ¸…å•ç±»åž‹æœªè®¾ç½®\r\n',0),(365063,10141,'sv','Checklista typ inte instÃ¤lld',0),(365064,10141,'it','Elenco di controllo tipo non impostato',0),(365065,10141,'tl','',0),(365066,10141,'th','à¹„à¸¡à¹ˆà¸à¸³à¸«à¸™à¸”à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(365067,10141,'hi','à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(365068,10141,'ms','Senarai Semak jenis tidak disetkan',0),(365069,10141,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù†ÙˆØ¹ Ø§Ù„Ù…Ø±Ø¬Ø¹ÙŠØ©',0),(365070,10141,'fr','Liste de vÃ©rification Type pas dÃ©fini',0),(365071,10141,'jp','ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆã®ç¨®é¡žãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(365072,10141,'pt','Lista de verificaÃ§Ã£o tipo nÃ£o definido',0),(365073,10141,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº Ñ‚Ð¸Ð¿ Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(365074,10141,'es','Tipo de Lista de Tareas No Configurado',0),(365075,10141,'de','Checkliste-Typ wurde nicht festgelegt.',0),(365076,10141,'en','Checklist Type Not Set',0),(365077,10142,'is','',0),(365078,10142,'dr','-  Ù‡ÙŠÚ† Ù†Ù…Ø¨Ø± Ø«Ø¨ØªÙŠ  ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù†Ø´Ø¯ ',0),(365079,10142,'pr','Ø®Ø·Ø§-  Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ø«Ø¨ØªÙŠ  ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù†Ø´Ø¯ ',0),(365080,10142,'tr','Hata - gÃ¶nderilen hiÃ§bir kayÄ±t kodu',0),(365081,10142,'pl','BÅ‚Ä…d - nie identyfikator rekordu wysÅ‚ane',0),(365082,10142,'bg','Ð“Ñ€ÐµÑˆÐºÐ° - Ð½ÑÐ¼Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð˜Ð” Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(365083,10142,'ur','Ù†Ù‚Øµ - Ú©ÙˆØ¦ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø´Ù†Ø§Ø®Øª Ù†ÛÛŒÚº Ø¨Ú¾ÛŒØ¬Ø§',0),(365084,10142,'sr','Ð“Ñ€ÐµÑˆÐºÐ° - Ð½ÐµÐ¼Ð° Ð·Ð°Ð¿Ð¸ÑÐ° Ð˜Ð” Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(365085,10142,'vi','Lá»—i- khÃ´ng cÃ³ ghi chÃ©p ID Ä‘Æ°á»£c gá»­i',0),(365086,10142,'af','Fout - geen rekord ID gestuur',0),(365087,10142,'ro','Eroare - nu Record ID-ul trimis',0),(365088,10142,'et','Viga - pole saadetud kirje ID',0),(365089,10142,'si','Napaka - ni ID zapisa poslala',0),(365090,10142,'ba','Kesalahan - ID tidak ada catatan yang dikirim',0),(365091,10142,'nl','Fout - geen Record-ID verzonden',0),(365092,10142,'fi','Virhe - ei lÃ¤hettÃ¤nyt Tietuetunnus',0),(365093,10142,'no','Feil - ingen oppfÃ¸rings-ID sendt',0),(365094,10142,'da','Fejl - ingen post-id sendt',0),(365095,10142,'ko','ì˜¤ë¥˜-ë ˆì½”ë“œ ID ì „ì†¡',0),(365096,10142,'he','×©×’×™××” - ××™×Ÿ ×ž×–×”×” ×¨×©×•×ž×” ×©×œ×—',0),(365097,10142,'el','Î£Ï†Î¬Î»Î¼Î± - Î´ÎµÎ½ ÏÎµÎºÏŒÏ ID Î­ÏƒÏ„ÎµÎ¹Î»Îµ',0),(365098,10142,'zh','é”™è¯¯ - æ²¡æœ‰å‘é€è®°å½•ID',0),(365099,10142,'sv','Fel - inget post-ID som skickas',0),(365100,10142,'it','Errore - No ID Record inviati',0),(365101,10142,'tl','',0),(365102,10142,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸” - à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸«à¸±à¸ªà¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡',0),(365103,10142,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ - à¤•à¥‹à¤ˆ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ ID à¤­à¥‡à¤œà¥€',0),(365104,10142,'ms','Ralat - tiada ID nota yang dihantar',0),(365105,10142,'ar','Ø®Ø·Ø£--Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…Ø¹Ø±Ù Ø³Ø¬Ù„ Ø¥Ø±Ø³Ø§Ù„',0),(365106,10142,'fr','Erreur - aucun Record ID envoyÃ©',0),(365107,10142,'jp','ã‚¨ãƒ©ãƒ¼ - é€ä¿¡ãƒ¬ã‚³ãƒ¼ãƒ‰ ID ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(365108,10142,'pt','Erro - sem ID de registro enviado',0),(365109,10142,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° - Ð½Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(365110,10142,'es','Error - No se EnviÃ³ NingÃºn Record',0),(365111,10142,'de','Fehler - kein Datensatz-ID gesendet',0),(365112,10142,'en','Error - No Record ID Sent',0),(365113,10143,'is','',0),(365114,10143,'dr','Ù‚Ø¨ÙˆÙ„ Ø¬Ù‡Øª Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø§Ø¯Ù†',0),(365115,10143,'pr','Ù‚Ø¨ÙˆÙ„ Ø¬Ù‡Øª Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø§Ø¯Ù†',0),(365116,10143,'tr','Tamam devam etmek',0),(365117,10143,'pl','OK, aby kontynuowaÄ‡',0),(365118,10143,'bg','ÐžÐš, Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸Ñ‚Ðµ',0),(365119,10143,'ur','Ù¹Ú¾ÛŒÚ© ÛÛ’ Ø¢Ú¯Û’ Ø¨Ú‘Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(365120,10143,'sr','ÐžÐš Ð·Ð° Ð½Ð°ÑÑ‚Ð°Ð²Ð°Ðº Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ðµ',0),(365121,10143,'vi','Äá»“ng Ã½ tiáº¿p tá»¥c',0),(365122,10143,'af','OK om voort te',0),(365123,10143,'ro','OK pentru a continua',0),(365124,10143,'et','OK, et jÃ¤tkata',0),(365125,10143,'si','OK za nadaljevanje',0),(365126,10143,'ba','OK untuk melanjutkan',0),(365127,10143,'nl','OK om door te gaan',0),(365128,10143,'fi','Jatketaanko',0),(365129,10143,'no','OK for Ã¥ fortsette',0),(365130,10143,'da','OK for at fortsÃ¦tte',0),(365131,10143,'ko','ê³„ì† ì§„í–‰ í•˜ë ¤ë©´ í™•ì¸',0),(365132,10143,'he','×‘×¨×¦×•× ×š ×œ×”×ž×©×™×š',0),(365133,10143,'el','Î•Î½Ï„Î¬Î¾ÎµÎ¹ Î³Î¹Î± Î½Î± Ï€ÏÎ¿Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹',0),(365134,10143,'zh','ç¡®å®šç»§ç»­\r\n',0),(365135,10143,'sv','OK fÃ¶r att fortsÃ¤tta',0),(365136,10143,'it','OK per procedere',0),(365137,10143,'tl','',0),(365138,10143,'th','à¸•à¸à¸¥à¸‡à¹€à¸žà¸·à¹ˆà¸­à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸•à¹ˆà¸­à¹„à¸›',0),(365139,10143,'hi','à¤ à¥€à¤• à¤¹à¥ˆ à¤†à¤—à¥‡ à¤¬à¤¢à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(365140,10143,'ms','Tekan OK untuk meneruskan',0),(365141,10143,'ar','\"Ù…ÙˆØ§ÙÙ‚\" Ù„Ù„Ù…ØªØ§Ø¨Ø¹Ø©',0),(365142,10143,'fr','OK pour aller de l\'avant',0),(365143,10143,'jp','[Ok] ã‚’ç¶šè¡Œã™ã‚‹ã«ã¯',0),(365144,10143,'pt','OK para prosseguir',0),(365145,10143,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ OK Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶ÐµÐ½Ð¸Ñ',0),(365146,10143,'es','OK para Proceder',0),(365147,10143,'de','OK, um fortzufahren',0),(365148,10143,'en','OK to Proceed',0),(365149,10144,'is','',0),(365150,10144,'dr','(Ù„Ø§Ø²Ù…Ù‡',0),(365151,10144,'pr','ØªÙ‚Ø§Ø¶Ø§(Ù„Ø§Ø²Ù…Ù‡',0),(365152,10144,'tr','Gereksinimi',0),(365153,10144,'pl','WymÃ³g',0),(365154,10144,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð°Ð½ÐµÑ‚Ð¾',0),(365155,10144,'ur','Ø¶Ø±ÙˆØ±Øª',0),(365156,10144,'sr','Ð£ÑÐ»Ð¾Ð²',0),(365157,10144,'vi','yÃªu cáº§u',0),(365158,10144,'af','Vereiste',0),(365159,10144,'ro','CerinÅ£Äƒ',0),(365160,10144,'et','NÃµue',0),(365161,10144,'si','Zahteva',0),(365162,10144,'ba','Persyaratan',0),(365163,10144,'nl','Eis',0),(365164,10144,'fi','Vaatimus',0),(365165,10144,'no','Krav',0),(365166,10144,'da','Kravet om',0),(365167,10144,'ko','ìš”êµ¬ ì‚¬í•­',0),(365168,10144,'he','×“×¨×™×©×”',0),(365169,10144,'el','Î‘Ï€Î±Î¯Ï„Î·ÏƒÎ·',0),(365170,10144,'zh','è¦æ±‚\r\n',0),(365171,10144,'sv','Kravet',0),(365172,10144,'it','Requisito',0),(365173,10144,'tl','',0),(365174,10144,'th','à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£',0),(365175,10144,'hi','à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(365176,10144,'ms','Keperluan',0),(365177,10144,'ar','Ø´Ø±Ø·',0),(365178,10144,'fr','Exigence',0),(365179,10144,'jp','è¦ä»¶',0),(365180,10144,'pt','ExigÃªncia',0),(365181,10144,'ru','Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(365182,10144,'es','Requerimiento',0),(365183,10144,'de','Anforderung',0),(365184,10144,'en','Requirement',0),(365185,10145,'is','',0),(365186,10145,'dr','ØªØ§ÙŠÙŠØ¯ ØªØºÙŠÙŠØ±',0),(365187,10145,'pr','ØªØ§ÙŠÙŠØ¯ ØªØºÙŠÙŠØ±',0),(365188,10145,'tr','DeÄŸiÅŸikliÄŸi onaylamak',0),(365189,10145,'pl','Zatwierdzanie zmian',0),(365190,10145,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÐ²Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(365191,10145,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ',0),(365192,10145,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(365193,10145,'vi','Cháº¥p thuáº­n thay Ä‘á»•i',0),(365194,10145,'af','Verandering Goedkeur',0),(365195,10145,'ro','Aproba schimbarea',0),(365196,10145,'et','Kinnitamine muutmine',0),(365197,10145,'si','Odobritev sprememb',0),(365198,10145,'ba','Menyetujui perubahan',0),(365199,10145,'nl','Goedkeuren van verandering',0),(365200,10145,'fi','HyvÃ¤ksy muutos',0),(365201,10145,'no','Godkjenne endring',0),(365202,10145,'da','Godkende Ã¦ndringen',0),(365203,10145,'ko','ë³€ê²½ ìŠ¹ì¸',0),(365204,10145,'he','×œ××©×¨ ×©×™× ×•×™',0),(365205,10145,'el','ÎˆÎ³ÎºÏÎ¹ÏƒÎ· Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚',0),(365206,10145,'zh','æ ¸å‡†å˜æ›´\r\n',0),(365207,10145,'sv','Ã„ndring',0),(365208,10145,'it','Approvare la modifica',0),(365209,10145,'tl','',0),(365210,10145,'th','à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(365211,10145,'hi','à¤¬à¤¦à¤²à¤¾à¤µ à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€',0),(365212,10145,'ms','Meluluskan perubahan',0),(365213,10145,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ ØªØºÙŠÙŠØ±',0),(365214,10145,'fr','Approuver le changement',0),(365215,10145,'jp','å¤‰æ›´ã‚’æ‰¿èªã—ã¾ã™ã€‚',0),(365216,10145,'pt','Aprovar a mudanÃ§a',0),(365217,10145,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(365218,10145,'es','Aprueba Cambio',0),(365219,10145,'de','Ã„nderung genehmigen',0),(365220,10145,'en','Approve Change',0),(365221,10146,'is','',0),(365222,10146,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(365223,10146,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„',0),(365224,10146,'tr','GL bÃ¼tÃ§e',0),(365225,10146,'pl','GL budÅ¼etu',0),(365226,10146,'bg','GL Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(365227,10146,'ur','Ø¬ÛŒØ¬Û’ Ø¨Ø¬Ù¹',0),(365228,10146,'sr','Ð“Ð› Ð±ÑƒÑŸÐµÑ‚Ð°',0),(365229,10146,'vi','GL ngÃ¢n sÃ¡ch',0),(365230,10146,'af','AG Begroting',0),(365231,10146,'ro','GL buget',0),(365232,10146,'et','GL eelarve',0),(365233,10146,'si','GL proraÄuna',0),(365234,10146,'ba','GL anggaran',0),(365235,10146,'nl','GL begroting',0),(365236,10146,'fi','GL talousarvion',0),(365237,10146,'no','GL budsjett',0),(365238,10146,'da','GL Budget',0),(365239,10146,'ko','GL ì˜ˆì‚°',0),(365240,10146,'he','×ª×§×¦×™×‘ GL',0),(365241,10146,'el','GL Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(365242,10146,'zh','å‰å°”é¢„ç®—\r\n',0),(365243,10146,'sv','GL Budget',0),(365244,10146,'it','Bilancio GL',0),(365245,10146,'tl','',0),(365246,10146,'th','à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(365247,10146,'hi','à¤œà¥€à¤à¤² à¤¬à¤œà¤Ÿ',0),(365248,10146,'ms','GL bajet',0),(365249,10146,'ar','Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(365250,10146,'fr','Budget GL',0),(365251,10146,'jp','GL äºˆç®—',0),(365252,10146,'pt','OrÃ§amento GL',0),(365253,10146,'ru','Ð“Ðš Ð‘ÑŽÐ´Ð¶ÐµÑ‚',0),(365254,10146,'es','Presupuesto de LM',0),(365255,10146,'de','GL-Budget',0),(365256,10146,'en','GL Budget',0),(365257,10147,'is','',0),(365258,10147,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØ§ÙŠÙŠØ¯ Ø¯Ø§Ø±Ø¯ ',0),(365259,10147,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯ÙØªØ± ÙƒÙ„ Ù†ÙŠØ§Ø² Ø¨Ù‡ ØªØ§ÙŠÙŠØ¯ Ø¯Ø§Ø±Ø¯ ',0),(365260,10147,'tr','GL bÃ¼tÃ§e onayÄ± gerekiyor.',0),(365261,10147,'pl','GL budÅ¼etu wymaga zgody',0),(365262,10147,'bg','GL Ð±ÑŽÐ´Ð¶ÐµÑ‚ ÑÐµ Ð½ÑƒÐ¶Ð´Ð°Ðµ Ð¾Ñ‚ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(365263,10147,'ur','Ø¬ÛŒØ¬Û’ Ø¨Ø¬Ù¹ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(365264,10147,'sr','Ð“Ð› Ð±ÑƒÑŸÐµÑ‚ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(365265,10147,'vi','GL ngÃ¢n sÃ¡ch cáº§n phÃª duyá»‡t',0),(365266,10147,'af','AG Begroting Nodig Goedkeuring',0),(365267,10147,'ro','GL buget are nevoie de aprobarea',0),(365268,10147,'et','GL eelarve heaks kiitma',0),(365269,10147,'si','GL proraÄuna potrebuje odobritev',0),(365270,10147,'ba','GL anggaran membutuhkan persetujuan',0),(365271,10147,'nl','GL begroting moet goedkeuring',0),(365272,10147,'fi','GL talousarvio tulee hyvÃ¤ksyÃ¤',0),(365273,10147,'no','GL budsjett trenger godkjenning',0),(365274,10147,'da','GL Budget behov for godkendelse',0),(365275,10147,'ko','GL ì˜ˆì‚° ìŠ¹ì¸ì´ í•„ìš”ë¡œ',0),(365276,10147,'he','GL ×”×ª×§×¦×™×‘ ×¦×¨×™×š ××™×©×•×¨',0),(365277,10147,'el','GL Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Ï‡ÏÎµÎ¹Î¬Î¶ÎµÏ„Î±Î¹ Ï„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ· Ï„Î¿Ï…',0),(365278,10147,'zh','å‰å°”é¢„ç®—éœ€è¦å®¡æ‰¹\r\n',0),(365279,10147,'sv','GL Budget behÃ¶ver godkÃ¤nnande',0),(365280,10147,'it','Bilancio GL ha bisogno di approvazione',0),(365281,10147,'tl','',0),(365282,10147,'th','à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(365283,10147,'hi','à¤œà¥€à¤à¤² à¤¬à¤œà¤Ÿ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(365284,10147,'ms','Bajet GL memerlukan kelulusan',0),(365285,10147,'ar','Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ ØªØµØ¯ÙŠÙ‚',0),(365286,10147,'fr','GL Budget doit Ãªtre approuvÃ©',0),(365287,10147,'jp','GL äºˆç®—ã®æ‰¿èªã‚’å¿…è¦',0),(365288,10147,'pt','GL orÃ§amento precisa de aprovaÃ§Ã£o',0),(365289,10147,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚ Ð“Ðš ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ ',0),(365290,10147,'es','Presupuestos de LM Necesitan AprobaciÃ³n',0),(365291,10147,'de','GL-Haushalt braucht Zustimmung',0),(365292,10147,'en','GL Budget Needs Approval',0),(365293,10148,'is','',0),(365294,10148,'dr','(Ø³ÙŠØ§Ù‡Ù‡',0),(365295,10148,'pr','Ù†ÙˆØ¹ Ú†Ùƒ Ù„ÙŠØ³Øª (Ø³ÙŠØ§Ù‡Ù‡',0),(365296,10148,'tr','Denetim tÃ¼rÃ¼',0),(365297,10148,'pl','Lista kontrolna typu',0),(365298,10148,'bg','Ð¢Ð¸Ð¿ ÑÐ¿Ð¸ÑÑŠÐº',0),(365299,10148,'ur','ÙÛØ±Ø³Øª Ù‚Ø³Ù…',0),(365300,10148,'sr','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ð° Ð»Ð¸ÑÑ‚Ð° Ð²Ñ€ÑÑ‚Ð°',0),(365301,10148,'vi','Loáº¡i danh má»¥c kiá»ƒm tra',0),(365302,10148,'af','Nasienlys Tipe',0),(365303,10148,'ro','Tip de listÄƒ de verificare',0),(365304,10148,'et','Kontroll-loendi tÃ¼Ã¼p',0),(365305,10148,'si','Kontrolni seznam vrsta',0),(365306,10148,'ba','Tipe daftar',0),(365307,10148,'nl','Controlelijst Type',0),(365308,10148,'fi','Tarkistuslista tyyppi',0),(365309,10148,'no','Sjekkliste Type',0),(365310,10148,'da','Tjekliste Type',0),(365311,10148,'ko','ê²€ì‚¬ ëª©ë¡ ìœ í˜•',0),(365312,10148,'he','×¡×•×’ ×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢',0),(365313,10148,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… Ï„ÏÏ€Î¿Ï…',0),(365314,10148,'zh','æ¸…å•ç±»åž‹\r\n',0),(365315,10148,'sv','Checklista typ',0),(365316,10148,'it','Elenco di controllo tipo',0),(365317,10148,'tl','',0),(365318,10148,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸Šà¸™à¸´à¸”',0),(365319,10148,'hi','à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(365320,10148,'ms','Senarai Semak jenis',0),(365321,10148,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ø®ØªÙŠØ§Ø± Ù†ÙˆØ¹',0),(365322,10148,'fr','Type de liste de contrÃ´le',0),(365323,10148,'jp','ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆã®ã‚¿ã‚¤ãƒ—',0),(365324,10148,'pt','Tipo de lista de verificaÃ§Ã£o',0),(365325,10148,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº Ñ‚Ð¸Ð¿',0),(365326,10148,'es','Tipo de Lista de Tareas',0),(365327,10148,'de','Checkliste-Typ',0),(365328,10148,'en','Checklist Type',0),(365329,10149,'is','',0),(365330,10149,'dr','ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ',0),(365331,10149,'pr','ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ',0),(365332,10149,'tr','TarafÄ±ndan tamamlandÄ±',0),(365333,10149,'pl','UzupeÅ‚nione',0),(365334,10149,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¾ Ð¾Ñ‚',0),(365335,10149,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§',0),(365336,10149,'sr','Ð—Ð°Ð²Ñ€ÑˆÐµÐ½Ð° Ð´Ð¾',0),(365337,10149,'vi','Ä‘Æ°á»£c hoÃ n thÃ nh bá»Ÿi',0),(365338,10149,'af','Voltooi Deur',0),(365339,10149,'ro','Completat de',0),(365340,10149,'et','TÃ¤idab',0),(365341,10149,'si','Izpolni',0),(365342,10149,'ba','Selesai',0),(365343,10149,'nl','Ingevuld door',0),(365344,10149,'fi','MennessÃ¤',0),(365345,10149,'no','FullfÃ¸rt av',0),(365346,10149,'da','Afsluttet ved',0),(365347,10149,'ko','ì— ì˜í•´ ì™„ë£Œ',0),(365348,10149,'he','×”×•×©×œ×ž×” ×¢×œ ×™×“×™',0),(365349,10149,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏŽÎ½ÎµÏ„Î±Î¹ Î±Ï€ÏŒ',0),(365350,10149,'zh','å®Œæˆ\r\n',0),(365351,10149,'sv','Fyllas i av',0),(365352,10149,'it','Completato da',0),(365353,10149,'tl','',0),(365354,10149,'th','à¹à¸¥à¹‰à¸§à¹€à¸ªà¸£à¹‡à¸ˆ',0),(365355,10149,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥‚à¤°à¤¾ à¤•à¤¿à¤¯à¤¾',0),(365356,10149,'ms','Dilengkapkan oleh',0),(365357,10149,'ar','Ø£Ù†Ø¬Ø²Øª Ù‚Ø¨Ù„',0),(365358,10149,'fr','ComplÃ©tÃ© par',0),(365359,10149,'jp','ã«ã‚ˆã£ã¦å®Œæˆå“',0),(365360,10149,'pt','Preenchido pelo',0),(365361,10149,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°',0),(365362,10149,'es','Completado Por',0),(365363,10149,'de','ErgÃ¤nzt durch',0),(365364,10149,'en','Completed By',0),(365365,10150,'is','',0),(365366,10150,'dr','Ú†Ùƒ Ù„ÙŠØ³ØªÙ‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(365367,10150,'pr','Ú†Ùƒ Ù„ÙŠØ³ØªÙ‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(365368,10150,'tr','GL denetim listeleri',0),(365369,10150,'pl','Listy kontrolne GL',0),(365370,10150,'bg','GL ÑÐ¿Ð¸ÑÑŠÑ†Ð¸',0),(365371,10150,'ur','Ø¬ÛŒØ¬Û’ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(365372,10150,'sr','Ð“Ð› Ð»Ð¸ÑÑ‚Ðµ',0),(365373,10150,'vi','kiá»ƒm tra danh sÃ¡ch sá»• cÃ¡i',0),(365374,10150,'af','AG Nasienlyste',0),(365375,10150,'ro','Liste de control GL',0),(365376,10150,'et','GL kontroll-loendid',0),(365377,10150,'si','GL Checklists',0),(365378,10150,'ba','Daftar-pembanding GL',0),(365379,10150,'nl','GL controlelijsten',0),(365380,10150,'fi','GL tarkistuslistat',0),(365381,10150,'no','GL sjekklister',0),(365382,10150,'da','GL tjeklister',0),(365383,10150,'ko','GL ì²´í¬ ë¦¬ìŠ¤íŠ¸',0),(365384,10150,'he','×¨×©×™×ž×•×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢ GL',0),(365385,10150,'el','GL Î»Î¯ÏƒÏ„ÎµÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(365386,10150,'zh','æ€»å¸æ£€æŸ¥å•\r\n',0),(365387,10150,'sv','GL checklistor',0),(365388,10150,'it','Liste di controllo GL',0),(365389,10150,'tl','',0),(365390,10150,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š GL',0),(365391,10150,'hi','à¤œà¥€à¤à¤² à¤œà¤¾à¤à¤š à¤¸à¥‚à¤šà¥€',0),(365392,10150,'ms','Senarai Semak GL',0),(365393,10150,'ar','Ù‚ÙˆØ§Ø¦Ù… GL',0),(365394,10150,'fr','Listes de vÃ©rification GL',0),(365395,10150,'jp','GL ã®ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆ',0),(365396,10150,'pt','Listas de GL',0),(365397,10150,'ru','GL ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ðµ ÑÐ¿Ð¸ÑÐºÐ¸',0),(365398,10150,'es','Listas de Tareas del LM',0),(365399,10150,'de','GL-Checklisten',0),(365400,10150,'en','GL Checklists',0),(365401,10151,'is','',0),(365402,10151,'dr','Ù¾Ø§ÙŠØ§Ù† Ù…Ø§Ù‡ ',0),(365403,10151,'pr','Ù¾Ø§ÙŠØ§Ù† Ù…Ø§Ù‡ ',0),(365404,10151,'tr','Ay sonu',0),(365405,10151,'pl','Koniec miesiÄ…ca',0),(365406,10151,'bg','ÐšÑ€Ð°Ñ Ð½Ð° Ð¼ÐµÑÐµÑ†Ð°',0),(365407,10151,'ur','Ø§Ø®ØªØªØ§Ù… Ù…ÛÛŒÙ†Û',0),(365408,10151,'sr','ÐšÑ€Ð°Ñ˜ Ð¼ÐµÑÐµÑ†Ð°',0),(365409,10151,'vi','cuá»‘i thÃ¡ng',0),(365410,10151,'af','Maandeinde',0),(365411,10151,'ro','SfÃ¢rÅŸitul lunii',0),(365412,10151,'et','Kuu lÃµpp',0),(365413,10151,'si','Koncu meseca',0),(365414,10151,'ba','Akhir bulan',0),(365415,10151,'nl','Einde van de maand',0),(365416,10151,'fi','Kuukauden lopussa',0),(365417,10151,'no','MÃ¥ned',0),(365418,10151,'da','MÃ¥nedsafslutning',0),(365419,10151,'ko','ë‹¬ ë',0),(365420,10151,'he','×‘×¡×•×£ ×”×—×•×“×©',0),(365421,10151,'el','Î¤Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î¼Î®Î½Î±',0),(365422,10151,'zh','æœˆåº•\r\n',0),(365423,10151,'sv','MÃ¥nadsslut',0),(365424,10151,'it','Fine mese',0),(365425,10151,'tl','',0),(365426,10151,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¹€à¸”à¸·à¸­à¸™',0),(365427,10151,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤…à¤‚à¤¤',0),(365428,10151,'ms','Hujung bulan',0),(365429,10151,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø´Ù‡Ø±',0),(365430,10151,'fr','Fin du mois',0),(365431,10151,'jp','æœˆæœ«',0),(365432,10151,'pt','Fim do mÃªs',0),(365433,10151,'ru','ÐšÐ¾Ð½ÐµÑ† ÐœÐµÑÑÑ†Ð°',0),(365434,10151,'es','Fin del Mes',0),(365435,10151,'de','Monatsende',0),(365436,10151,'en','Month End',0),(365437,10152,'is','',0),(365438,10152,'dr','Q',0),(365439,10152,'pr','Q',0),(365440,10152,'tr','Q',0),(365441,10152,'pl','Q',0),(365442,10152,'bg','Q',0),(365443,10152,'ur','Q',0),(365444,10152,'sr','Q',0),(365445,10152,'vi','Q',0),(365446,10152,'af','Q',0),(365447,10152,'ro','Q',0),(365448,10152,'et','Q',0),(365449,10152,'si','Q',0),(365450,10152,'ba','Q',0),(365451,10152,'nl','Q',0),(365452,10152,'fi','Q',0),(365453,10152,'no','Q',0),(365454,10152,'da','Q',0),(365455,10152,'ko','Q',0),(365456,10152,'he','Q',0),(365457,10152,'el','Q',0),(365458,10152,'zh','Q\r\n',0),(365459,10152,'sv','Q',0),(365460,10152,'it','Q',0),(365461,10152,'tl','',0),(365462,10152,'th','Q',0),(365463,10152,'hi','à¤•à¥à¤¯à¥‚',0),(365464,10152,'ms','Q',0),(365465,10152,'ar','Q',0),(365466,10152,'fr','Q',0),(365467,10152,'jp','Q',0),(365468,10152,'pt','Q',0),(365469,10152,'ru','Q',0),(365470,10152,'es','T',0),(365471,10152,'de','Q',0),(365472,10152,'en','Q',0),(365473,10153,'is','',0),(365474,10153,'dr','Ù¾Ø§ÙŠØ§Ù† Ø³Ù‡ Ù…Ø§Ù‡',0),(365475,10153,'pr','Ù¾Ø§ÙŠØ§Ù† Ø³Ù‡ Ù…Ø§Ù‡',0),(365476,10153,'tr','Ã‡eyrek sonu',0),(365477,10153,'pl','ZakoÅ„czeniu kwartaÅ‚u',0),(365478,10153,'bg','ÐšÐ²Ð°Ñ€Ñ‚Ð°Ð» ÐºÑ€Ð°Ð¹',0),(365479,10153,'ur','Ø³Û Ù…Ø§ÛÛŒ Ú©Û’ Ø§Ø®ØªØªØ§Ù…',0),(365480,10153,'sr','ÐšÑ€Ð°Ñ˜ ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð°',0),(365481,10153,'vi','Káº¿t thÃºc quÃ½',0),(365482,10153,'af','Kwartaal Eindig',0),(365483,10153,'ro','SfÃ¢rÅŸitul trimestrului',0),(365484,10153,'et','Kvartali lÃµpp',0),(365485,10153,'si','Konec Äetrtletja',0),(365486,10153,'ba','Akhir kuartal',0),(365487,10153,'nl','Kwartaaleinde',0),(365488,10153,'fi','NeljÃ¤nneksen lopussa',0),(365489,10153,'no','Kvartal slutten',0),(365490,10153,'da','Kvartal End',0),(365491,10153,'ko','ë¶„ê¸° ë',0),(365492,10153,'he','×¡×•×£ ×¨×‘×¢×•×Ÿ',0),(365493,10153,'el','Î¤Î­Î»Î¿Ï‚ Ï„ÏÎ¹Î¼Î®Î½Î¿Ï…',0),(365494,10153,'zh','å­£åº¦æœ«\r\n',0),(365495,10153,'sv','Kvartalet slutet',0),(365496,10153,'it','Fine trimestre',0),(365497,10153,'tl','',0),(365498,10153,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¹„à¸•à¸£à¸¡à¸²à¸ª',0),(365499,10153,'hi','à¤¤à¤¿à¤®à¤¾à¤¹à¥€ à¤•à¥‡ à¤…à¤‚à¤¤',0),(365500,10153,'ms','Suku akhir',0),(365501,10153,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø±Ø¨Ø¹',0),(365502,10153,'fr','Fin du trimestre',0),(365503,10153,'jp','å››åŠæœŸæœ«',0),(365504,10153,'pt','Fim de trimestre',0),(365505,10153,'ru','ÐšÐ¾Ð½ÐµÑ† Ñ‡ÐµÑ‚Ð²ÐµÑ€Ñ‚Ð¸',0),(365506,10153,'es','Fin del Trimestre',0),(365507,10153,'de','Quartalsende',0),(365508,10153,'en','Quarter End',0),(365509,10154,'is','',0),(365510,10154,'dr','Ú†Ùƒ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± Ø¯ÙØªØ± ÙƒÙ„ ',0),(365511,10154,'pr','Ú†Ùƒ Ù„ÙŠØ³Øª Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± Ø¯ÙØªØ± ÙƒÙ„ ',0),(365512,10154,'tr','Son GL denetim listeleri',0),(365513,10154,'pl','Ostatnie GL listy kontrolne',0),(365514,10154,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ GL ÑÐ¿Ð¸ÑÑŠÑ†Ð¸',0),(365515,10154,'ur','Ø­Ø§Ù„ÛŒÛ Ø¬ÛŒØ¬Û’ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(365516,10154,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ð“Ð› Ð»Ð¸ÑÑ‚Ðµ',0),(365517,10154,'vi','danh sÃ¡ch kiá»ƒm tra sá»• cÃ¡i tÃ i khoáº£n gáº§n Ä‘Ã¢y',0),(365518,10154,'af','Onlangse AG Nasienlys',0),(365519,10154,'ro','Liste de control GL recente',0),(365520,10154,'et','Tehtud GL kontroll-loendid',0),(365521,10154,'si','Nedavni GL Checklists',0),(365522,10154,'ba','Daftar-pembanding GL hari',0),(365523,10154,'nl','Recente GL controlelijsten',0),(365524,10154,'fi','Hotelliin GL tarkistuslistat',0),(365525,10154,'no','Siste GL sjekklister',0),(365526,10154,'da','Seneste GL tjeklister',0),(365527,10154,'ko','ìµœê·¼ GL ì²´í¬ ë¦¬ìŠ¤íŠ¸',0),(365528,10154,'he','×”××—×¨×•× ×•×ª GL ×¨×©×™×ž×•×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢',0),(365529,10154,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Î»Î¯ÏƒÏ„ÎµÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… GL',0),(365530,10154,'zh','æœ€è¿‘çš„æ€»å¸æ£€æŸ¥å•\r\n',0),(365531,10154,'sv','Senaste GL checklistor',0),(365532,10154,'it','Recenti GL Checklists',0),(365533,10154,'tl','',0),(365534,10154,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(365535,10154,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ GL à¤œà¤¾à¤à¤š à¤¸à¥‚à¤šà¥€',0),(365536,10154,'ms','Senarai Semak GL hari',0),(365537,10154,'ar','Ù‚ÙˆØ§Ø¦Ù… Ù…Ø±Ø¬Ø¹ÙŠØ© GL Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(365538,10154,'fr','Listes de vÃ©rification rÃ©centes GL',0),(365539,10154,'jp','æœ€è¿‘ã® GL ã®ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆ',0),(365540,10154,'pt','Recentes listas de GL',0),(365541,10154,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ðµ GL',0),(365542,10154,'es','Listas de Tareas Recientes de LM',0),(365543,10154,'de','Den letzten GL-Checklisten',0),(365544,10154,'en','Recent GL Checklists',0),(365545,10155,'is','',0),(365546,10155,'dr','Ù¾Ø§ÙŠØ§Ù† Ø³Ø§Ù„ ',0),(365547,10155,'pr','Ù¾Ø§ÙŠØ§Ù† Ø³Ø§Ù„ ',0),(365548,10155,'tr','YÄ±l sonu',0),(365549,10155,'pl','Na koniec roku',0),(365550,10155,'bg','ÐšÑ€Ð°Ñ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(365551,10155,'ur','Ø³Ø§Ù„ Ø§Ø®ØªØªØ§Ù…',0),(365552,10155,'sr','ÐšÑ€Ð°Ñ˜Ð° Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(365553,10155,'vi','Cuá»‘i nÄƒm',0),(365554,10155,'af','Jaareinde',0),(365555,10155,'ro','SfÃ¢rÅŸitul anului',0),(365556,10155,'et','Aasta lÃµpp',0),(365557,10155,'si','Konec leta',0),(365558,10155,'ba','Akhir tahun',0),(365559,10155,'nl','Einde van het jaar',0),(365560,10155,'fi','Vuoden lopussa',0),(365561,10155,'no','Ã…rsslutt',0),(365562,10155,'da','Ã…rets udgang',0),(365563,10155,'ko','ì—°ë§',0),(365564,10155,'he','×‘×¡×•×£ ×”×©× ×”',0),(365565,10155,'el','Î¤Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î­Ï„Î¿Ï…Ï‚',0),(365566,10155,'zh','å¹´ç»ˆ\r\n',0),(365567,10155,'sv','Slutet av Ã¥r',0),(365568,10155,'it','Fine anno',0),(365569,10155,'tl','',0),(365570,10155,'th','à¸ªà¸´à¹‰à¸™à¸›à¸µ',0),(365571,10155,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤…à¤‚à¤¤',0),(365572,10155,'ms','Akhir tahun',0),(365573,10155,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(365574,10155,'fr','Fin de l\'annÃ©e',0),(365575,10155,'jp','ä¼šè¨ˆå¹´åº¦æœ«',0),(365576,10155,'pt','Fim de ano',0),(365577,10155,'ru','ÐšÐ¾Ð½ÐµÑ† Ð³Ð¾Ð´Ð°',0),(365578,10155,'es','Fin del AÃ±o',0),(365579,10155,'de','Ende des Jahres',0),(365580,10155,'en','Year End',0),(365581,10156,'is','',0),(365582,10156,'dr','Ø®Ø§Ù„Øµ  ',0),(365583,10156,'pr','Ø®Ø§Ù„Øµ  ',0),(365584,10156,'tr','NET',0),(365585,10156,'pl','Netto',0),(365586,10156,'bg','ÐœÑ€ÐµÐ¶Ð°Ñ‚Ð°',0),(365587,10156,'ur','Ø¬Ø§Ù„',0),(365588,10156,'sr','ÐÐµÑ‚',0),(365589,10156,'vi','thá»±c',0),(365590,10156,'af','Net',0),(365591,10156,'ro','Net',0),(365592,10156,'et','Net',0),(365593,10156,'si','Net',0),(365594,10156,'ba','Bersih',0),(365595,10156,'nl','Net',0),(365596,10156,'fi','NET',0),(365597,10156,'no','NET',0),(365598,10156,'da','Net',0),(365599,10156,'ko','Net',0),(365600,10156,'he','× ×˜×•',0),(365601,10156,'el','NET',0),(365602,10156,'zh','å‡€\r\n',0),(365603,10156,'sv','Net',0),(365604,10156,'it','NET',0),(365605,10156,'tl','',0),(365606,10156,'th','à¸ªà¸¸à¸—à¸˜à¸´',0),(365607,10156,'hi','à¤¨à¥‡à¤Ÿ',0),(365608,10156,'ms','Bersih',0),(365609,10156,'ar','ØµØ§ÙÙŠ',0),(365610,10156,'fr','NET',0),(365611,10156,'jp','Net',0),(365612,10156,'pt','NET',0),(365613,10156,'ru','NET',0),(365614,10156,'es','Neto',0),(365615,10156,'de','NET',0),(365616,10156,'en','Net',0),(365617,10157,'is','',0),(365618,10157,'dr','(Ø­Ø³Ø§Ø¨ Ø¯ÛŒÙˆÙ† ) Ø¨Ø±Ø§ÙŠ',0),(365619,10157,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø¯Ù‡ÙƒØ§Ø±(Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡ÙŠ) Ø¨Ø±Ø§ÙŠ',0),(365620,10157,'tr','Toplam BorÃ§lar',0),(365621,10157,'pl','CaÅ‚kowitego obciÄ…Å¼enia dla',0),(365622,10157,'bg','ÐžÐ±Ñ‰Ð¾ Ð´ÐµÐ±Ð¸Ñ‚ Ð·Ð°',0),(365623,10157,'ur','Ú©Ù„ Ø¯ÛŒØ¨ØªØ³ Ú©Û’ Ù„Ø¦Û’',0),(365624,10157,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð·Ð°',0),(365625,10157,'vi','Tá»•ng ná»£ Ä‘á»‘i vá»›i',0),(365626,10157,'af','Totale Debiete vir',0),(365627,10157,'ro','Depuneri totale pentru',0),(365628,10157,'et','Kogu deebetsumma jaoks',0),(365629,10157,'si','Skupaj v breme za',0),(365630,10157,'ba','Total debet untuk',0),(365631,10157,'nl','Totaal debet voor',0),(365632,10157,'fi','Veloitusten kokonaismÃ¤Ã¤rÃ¤',0),(365633,10157,'no','Samlet debetbelÃ¸p for',0),(365634,10157,'da','Samlede debiteringer for',0),(365635,10157,'ko','ì— ëŒ€ í•œ ì´ ì°¨ë³€',0),(365636,10157,'he','×¡×” ×› ×—×™×•×‘×™× ×¢×‘×•×¨',0),(365637,10157,'el','Î¤Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï„Ï‰Î½ Ï‡ÏÎµÏŽÏƒÎµÏ‰Î½ Î³Î¹Î±',0),(365638,10157,'zh','åˆè®¡è½¬å¸\r\n',0),(365639,10157,'sv','Totala debiteringar fÃ¶r',0),(365640,10157,'it','Totale degli addebiti per',0),(365641,10157,'tl','',0),(365642,10157,'th','à¹€à¸”à¸šà¸´à¸•à¸£à¸§à¸¡à¸ªà¸³à¸«à¸£à¸±à¸š',0),(365643,10157,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤² à¤¨à¤¾à¤®à¥‡',0),(365644,10157,'ms','Jumlah Debit bagi',0),(365645,10157,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø®ØµÙˆÙ… Ø¹Ù„Ù‰',0),(365646,10157,'fr','Total des retraits pour',0),(365647,10157,'jp','ç·å€Ÿã‚Šæ–¹',0),(365648,10157,'pt','Total dos dÃ©bitos para',0),(365649,10157,'ru','Ð’ÑÐµÐ³Ð¾ Ð´ÐµÐ±ÐµÑ‚Ð° Ð´Ð»Ñ',0),(365650,10157,'es','DÃ©bitos Totales para',0),(365651,10157,'de','Total Debits fÃ¼r',0),(365652,10157,'en','Total Debits for',0),(365653,10158,'is','',0),(365654,10158,'dr','(Ø­Ø³Ø§Ø¨ Ø¯ÛŒÙˆÙ† ) Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ø¯ÙŠÚ¯Ø± Ø´Ø±ÙƒØª Ù‡Ø§',0),(365655,10158,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø¯Ù‡ÙƒØ§Ø±(Ø­Ø³Ø§Ø¨ Ø¨Ø¯Ù‡ÙŠ) Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ø¯ÙŠÚ¯Ø± Ø´Ø±ÙƒØª Ù‡Ø§',0),(365656,10158,'tr','DiÄŸer ÅŸirketler iÃ§in Toplam BorÃ§lar',0),(365657,10158,'pl','CaÅ‚kowitego obciÄ…Å¼enia dla wszystkich innych firm',0),(365658,10158,'bg','ÐžÐ±Ñ‰Ð¾ Ð´ÐµÐ±Ð¸Ñ‚ Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ñ€ÑƒÐ³Ð¸ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(365659,10158,'ur','ØªÙ…Ø§Ù… Ø¯ÛŒÚ¯Ø± Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ú©Û’ Ù„Ø¦Û’ Ú©Ù„ Ø¯ÛŒØ¨ØªØ³',0),(365660,10158,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð·Ð° ÑÐ²Ðµ Ð´Ñ€ÑƒÐ³Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(365661,10158,'vi','Tá»•ng ná»£ Ä‘á»‘i vá»›i táº¥t cáº£ cÃ¡c cÃ´ng ty khÃ¡c',0),(365662,10158,'af','Totale Debiete vir Alle Ander Ondernemings',0),(365663,10158,'ro','Debite totalÄƒ pentru toate alte firme',0),(365664,10158,'et','Kogu deebetsumma teiste Ã¤riÃ¼hingute',0),(365665,10158,'si','Skupaj v breme za vsa druga podjetja',0),(365666,10158,'ba','Total debet untuk perusahaan lain',0),(365667,10158,'nl','Totaal debet voor overige bedrijven',0),(365668,10158,'fi','Veloitusten kokonaismÃ¤Ã¤rÃ¤ kaikkien muiden yritysten',0),(365669,10158,'no','Samlet debetbelÃ¸p for alle andre selskaper',0),(365670,10158,'da','Samlede debiteringer for alle andre selskaber',0),(365671,10158,'ko','ë‹¤ë¥¸ ëª¨ë“  íšŒì‚¬ì— ëŒ€ í•œ ì´ ì°¨ë³€',0),(365672,10158,'he','×¡×” ×› ×—×™×•×‘×™× ×¢×‘×•×¨ ×›×œ ×—×‘×¨×•×ª ××—×¨×•×ª',0),(365673,10158,'el','Î¤Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï„Ï‰Î½ Ï‡ÏÎµÏŽÏƒÎµÏ‰Î½ Î³Î¹Î± ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î¬Î»Î»ÎµÏ‚ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚',0),(365674,10158,'zh','æ€»è®¡æ‰€æœ‰å…¶ä»–å…¬å¸çš„è½¬è´¦\r\n',0),(365675,10158,'sv','Totala debiteringar fÃ¶r alla andra fÃ¶retag',0),(365676,10158,'it','Totali debiti per tutte le altre societÃ ',0),(365677,10158,'tl','',0),(365678,10158,'th','à¹€à¸”à¸šà¸´à¸•à¸£à¸§à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸£à¸´à¸©à¸±à¸—à¸­à¸·à¹ˆà¸™ à¹† à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(365679,10158,'hi','à¤…à¤¨à¥à¤¯ à¤¸à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤² à¤¨à¤¾à¤®à¥‡',0),(365680,10158,'ms','Jumlah Debit bagi semua syarikat-syarikat lain',0),(365681,10158,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø®ØµÙˆÙ… Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø£Ø®Ø±Ù‰',0),(365682,10158,'fr','Total des retraits pour toutes les autres sociÃ©tÃ©s',0),(365683,10158,'jp','ä»–ã®ã™ã¹ã¦ã®ä¼šç¤¾ã®ãŸã‚ã®ç·å€Ÿã‚Šæ–¹',0),(365684,10158,'pt','Total dos dÃ©bitos para todas as outras empresas',0),(365685,10158,'ru','Ð’ÑÐµÐ³Ð¾ Ð´ÐµÐ±ÐµÑ‚Ð° Ð´Ð»Ñ Ð²ÑÐµÑ… Ð´Ñ€ÑƒÐ³Ð¸Ñ… ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¹',0),(365686,10158,'es','DÃ©bitos Totales para Todas las Otras Empresas',0),(365687,10158,'de','Insgesamt soll fÃ¼r alle Ã¼brigen Unternehmen',0),(365688,10158,'en','Total Debits for All Other Companies',0),(365689,10159,'is','',0),(365690,10159,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª  ØªØµÙˆÙŠØ¨ Ø´Ø¯Ù‡  Ø±Ø¯  Ø´Ø¯',0),(365691,10159,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª  ØªØµÙˆÙŠØ¨ Ø´Ø¯Ù‡  Ø±Ø¯  Ø´Ø¯',0),(365692,10159,'tr','Onay isteÄŸi baÅŸarÄ±sÄ±z oldu',0),(365693,10159,'pl','Zatwierdzenia Å¼Ä…dania nie powiodÅ‚o siÄ™',0),(365694,10159,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(365695,10159,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§',0),(365696,10159,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ',0),(365697,10159,'vi','Táº¥t cáº£ yÃªu cáº§u phÃª duyá»‡ khÃ´ng thÃ nh cÃ´g',0),(365698,10159,'af','Goedgekeerde Versoek het Gefaal',0),(365699,10159,'ro','Cerere de aprobare a eÅŸuat',0),(365700,10159,'et','Kinnituse taotlus nurjus',0),(365701,10159,'si','ProÅ¡nja za odobritev, ki ni uspela',0),(365702,10159,'ba','Persetujuan permintaan gagal',0),(365703,10159,'nl','Aanvraag tot goedkeuring is mislukt',0),(365704,10159,'fi','HyvÃ¤ksynnÃ¤n pyyntÃ¶ epÃ¤onnistui',0),(365705,10159,'no','Godkjenning mislyktes',0),(365706,10159,'da','Godkendelsesanmodningen mislykkedes.',0),(365707,10159,'ko','ìŠ¹ì¸ ìš”ì²­ ì‹¤íŒ¨',0),(365708,10159,'he','×‘×§×©×” ×œ××™×©×•×¨ × ×›×©×œ',0),(365709,10159,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚ Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(365710,10159,'zh','æ‰¹å‡†è¯·æ±‚å¤±è´¥\r\n',0),(365711,10159,'sv','BegÃ¤ran misslyckades',0),(365712,10159,'it','Richiesta di approvazione non riuscita',0),(365713,10159,'tl','',0),(365714,10159,'th','à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸à¸²à¸£à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸—à¸µà¹ˆà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(365715,10159,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤µà¤¿à¤«à¤²',0),(365716,10159,'ms','Permintaan kelulusan yang gagal',0),(365717,10159,'ar','ÙØ´Ù„ Ø·Ù„Ø¨ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø©',0),(365718,10159,'fr','Demande d\'approbation a Ã©chouÃ©',0),(365719,10159,'jp','æ‰¿èªè¦æ±‚ãŒå¤±æ•—ã—ã¾ã—ãŸ',0),(365720,10159,'pt','SolicitaÃ§Ã£o de aprovaÃ§Ã£o falhada',0),(365721,10159,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°, Ð½Ðµ',0),(365722,10159,'es','PeticiÃ³n de AprobaciÃ³n FallÃ³',0),(365723,10159,'de','Genehmigung Request Failed',0),(365724,10159,'en','Approval Request Failed',0),(365725,10160,'is','',0),(365726,10160,'dr','Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù…Ø¯ÙŠØ±',0),(365727,10160,'pr','Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬ Ù…Ø¯ÙŠØ±',0),(365728,10160,'tr','TimeClock YÃ¶neticisi',0),(365729,10160,'pl','TimeClock Manager',0),(365730,10160,'bg','TimeClock Ð¼ÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€',0),(365731,10160,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù…Ù†ÛŒØ¬Ø±',0),(365732,10160,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº ÐœÐµÐ½Ð°ÑŸÐµÑ€',0),(365733,10160,'vi','Timeclock quáº£n lÃ½',0),(365734,10160,'af','Tydklok Bestuurder',0),(365735,10160,'ro','Ceas Manager',0),(365736,10160,'et','TimeClock Manager',0),(365737,10160,'si','TimeClock Manager',0),(365738,10160,'ba','Timeclock Manajer',0),(365739,10160,'nl','Klok Manager',0),(365740,10160,'fi','Timeclock Manager',0),(365741,10160,'no','TimeClock Manager',0),(365742,10160,'da','Timeclock Manager',0),(365743,10160,'ko','Timeclock ê´€ë¦¬ìž',0),(365744,10160,'he','×ž× ×”×œ Timeclock',0),(365745,10160,'el','Î”Î¹ÎµÏ…Î¸Ï…Î½Ï„Î®Ï‚ Timeclock',0),(365746,10160,'zh','æ—¶é’Ÿç®¡ç†\r\n',0),(365747,10160,'sv','Timeclock Manager',0),(365748,10160,'it','Timeclock Manager',0),(365749,10160,'tl','',0),(365750,10160,'th','à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸à¸²à¸£ Timeclock',0),(365751,10160,'hi','Timeclock à¤ªà¥à¤°à¤¬à¤‚à¤§à¤•',0),(365752,10160,'ms','Pengurus Timeclock',0),(365753,10160,'ar','Ù…Ø¯ÙŠØ± ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(365754,10160,'fr','Timeclock Manager',0),(365755,10160,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼',0),(365756,10160,'pt','Gerente de timeclock',0),(365757,10160,'ru','TimeClock Ð¼ÐµÐ½ÐµÐ´Ð¶ÐµÑ€',0),(365758,10160,'es','Supervisor del Reloj Checador',0),(365759,10160,'de','Timeclock Manager',0),(365760,10160,'en','Timeclock Manager',0),(365761,10161,'is','',0),(365762,10161,'dr','ØªØ§ÙŠÙŠØ¯ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§',0),(365763,10161,'pr','ØªØ§ÙŠÙŠØ¯ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§',0),(365764,10161,'tr','Geri Ã¶deme onayÄ±',0),(365765,10161,'pl','ZatwierdziÄ‡ zwrot',0),(365766,10161,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÐ²Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ð¸Ñ',0),(365767,10161,'ur','Ø±ÛŒØ§Ù…Ø¨Ø±Ø³Ù…Ù†Ù¹Ø³ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ',0),(365768,10161,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð¸ Ð½Ð°ÐºÐ½Ð°Ð´Ð°Ð¼Ð° ÑˆÑ‚ÐµÑ‚Ðµ',0),(365769,10161,'vi','PhÃª duyá»‡t bá»“i hoÃ n',0),(365770,10161,'af','Terugbetalings Goedkeur',0),(365771,10161,'ro','Aproba rambursÄƒri',0),(365772,10161,'et','Kinnitada tagasimaksed',0),(365773,10161,'si','Odobritev povraÄila',0),(365774,10161,'ba','Menyetujui reimbursement',0),(365775,10161,'nl','Goedkeuren van vergoedingen',0),(365776,10161,'fi','HyvÃ¤ksyÃ¤ korvaukset',0),(365777,10161,'no','Godkjenne refusjoner',0),(365778,10161,'da','Godkende refusioner',0),(365779,10161,'ko','í™˜ê¸‰ì„ ìŠ¹ì¸',0),(365780,10161,'he','×œ××©×¨ ×”×—×–×¨',0),(365781,10161,'el','Î•Î³ÎºÏÎ¯Î½ÎµÎ¹ Ï„Î¹Ï‚ ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î­Ï‚',0),(365782,10161,'zh','æ‰¹å‡†æŠ¥é”€\r\n',0),(365783,10161,'sv','GodkÃ¤nna Ã¥terbetalningar',0),(365784,10161,'it','Approvare i rimborsi',0),(365785,10161,'tl','',0),(365786,10161,'th','à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¸·à¸™',0),(365787,10161,'hi','à¤ªà¥ˆà¤¸à¥‡ à¤•à¥€ à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€',0),(365788,10161,'ms','Meluluskan pembayaran balik',0),(365789,10161,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ ØªØ³Ø¯ÙŠØ¯ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(365790,10161,'fr','Approuver les remboursements',0),(365791,10161,'jp','æ‰•ã„æˆ»ã—ã‚’æ‰¿èªã—ã¾ã™ã€‚',0),(365792,10161,'pt','Aprovar os reembolsos',0),(365793,10161,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Ð²Ð¾Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ñ',0),(365794,10161,'es','Aprueba Reembolsos',0),(365795,10161,'de','Erstattungen zu genehmigen',0),(365796,10161,'en','Approve Reimbursements',0),(365797,10162,'is','',0),(365798,10162,'dr','ØªØ§ÙŠÙŠØ¯ ØªÙ‚Ø§Ø¶Ø§Ù‡Ø§ÙŠ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª',0),(365799,10162,'pr','ØªØ§ÙŠÙŠØ¯ ØªÙ‚Ø§Ø¶Ø§Ù‡Ø§ÙŠ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª',0),(365800,10162,'tr','Geri Ã¶deme isteklerini onaylama',0),(365801,10162,'pl','Zatwierdza wnioski o zwrot kosztÃ³w',0),(365802,10162,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÐ²Ð° Ð¸ÑÐºÐ°Ð½Ð¸ÑÑ‚Ð° Ð·Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(365803,10162,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº Ù…Ù†Ø¸ÙˆØ±',0),(365804,10162,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð¸ Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ Ð½Ð°ÐºÐ½Ð°Ð´Ð°',0),(365805,10162,'vi','yÃªu cáº§u phÃª duyá»‡t bá»“i hoÃ n',0),(365806,10162,'af','Terugbetalingsversoeke Goedkeur',0),(365807,10162,'ro','Aproba cererile de rambursare',0),(365808,10162,'et','Kinnitada HÃ¼vitistaotlused',0),(365809,10162,'si','Odobrijo zahtevki za povraÄila',0),(365810,10162,'ba','Menyetujui permintaan Reimbursement',0),(365811,10162,'nl','Goedkeuren van terugbetaling aanvragen',0),(365812,10162,'fi','HyvÃ¤ksy korvaushakemus',0),(365813,10162,'no','Godkjenne forespÃ¸rsler om refusjon',0),(365814,10162,'da','Godkende anmodninger om godtgÃ¸relser',0),(365815,10162,'ko','ë³´ìƒ ìš”ì²­ì„ ìŠ¹ì¸',0),(365816,10162,'he','×œ××©×¨ ×‘×§×©×•×ª ×”×—×–×¨',0),(365817,10162,'el','Î•Î³ÎºÏÎ¯Î½ÎµÎ¹ Ï„Î± Î±Î¹Ï„Î®Î¼Î±Ï„Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚ Î´Î±Ï€Î±Î½ÏŽÎ½',0),(365818,10162,'zh','è¯·æ±‚æ ¸å‡†æŠ¥é”€\r\n',0),(365819,10162,'sv','GodkÃ¤nna begÃ¤ran om ersÃ¤ttning',0),(365820,10162,'it','Approvare le richieste di rimborso',0),(365821,10162,'tl','',0),(365822,10162,'th','à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸„à¸³à¸‚à¸­à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¸·à¸™',0),(365823,10162,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¥à¤µà¥€à¤•à¤¾à¤°à¤¨à¤¾',0),(365824,10162,'ms','Meluluskan permohonan bayaran balik perbelanjaan',0),(365825,10162,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ø³Ø¯Ø§Ø¯',0),(365826,10162,'fr','Approuver les demandes de remboursement',0),(365827,10162,'jp','æ‰•ã„æˆ»ã—ã«é–¢ã™ã‚‹ãƒªã‚¯ã‚¨ã‚¹ãƒˆã‚’æ‰¿èªã—ã¾ã™ã€‚',0),(365828,10162,'pt','Aprovar solicitaÃ§Ãµes de reembolso',0),(365829,10162,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´Ð°Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾ÑÑ‹ Ð²Ð¾Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ñ',0),(365830,10162,'es','Aprueba Peticiones para Reembolsos',0),(365831,10162,'de','Erstattung Anforderungen genehmigen',0),(365832,10162,'en','Approve Reimbursement Requests',0),(365833,10163,'is','',0),(365834,10163,'dr','-  ØªØ§ÙŠÙŠØ¯Ø§Øª Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯ Ù‡ Ø§Ø³Øª ',0),(365835,10163,'pr','Ø®Ø·Ø§ -  ØªØ§ÙŠÙŠØ¯Ø§Øª Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯ Ù‡ Ø§Ø³Øª ',0),(365836,10163,'tr','Hata - deÄŸil kurtarmak onaylarÄ±',0),(365837,10163,'pl','BÅ‚Ä…d - aprobaty nie zapisane',0),(365838,10163,'bg','Ð“Ñ€ÐµÑˆÐºÐ° - Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ Ð½Ðµ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸',0),(365839,10163,'ur','Ù†Ù‚Øµ - Ù…Ù†Ø¸ÙˆØ±ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº',0),(365840,10163,'sr','Ð“Ñ€ÐµÑˆÐºÐ° - Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐ° Ð½Ð¸Ñ˜Ðµ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½Ð°',0),(365841,10163,'vi','Lá»—i- kÃ½ duyá»‡t khÃ´ng Ä‘Æ°á»£c lÆ°u',0),(365842,10163,'af','Fout - Goedkeurings Nie Gestoor',0),(365843,10163,'ro','Eroare - aprobÄƒrile nesalvatÄƒ',0),(365844,10163,'et','Viga - kinnitused ei salvestata',0),(365845,10163,'si','Napaka - soglasja ne shrani',0),(365846,10163,'ba','Kesalahan - persetujuan tidak disimpan',0),(365847,10163,'nl','Fout - goedkeuringen niet opgeslagen',0),(365848,10163,'fi','Virhe - hyvÃ¤ksynnÃ¤t eivÃ¤t tallennu',0),(365849,10163,'no','Feil - godkjenninger ikke lagret',0),(365850,10163,'da','Fejl - godkendelser ikke gemt',0),(365851,10163,'ko','ì˜¤ë¥˜-ìŠ¹ì¸ ì €ìž¥ ë˜ì§€',0),(365852,10163,'he','×©×’×™××” - ××™×©×•×¨×™× ×œ× × ×©×ž×¨',0),(365853,10163,'el','Î£Ï†Î¬Î»Î¼Î± - ÎµÎ³ÎºÏÎ¯ÏƒÎµÎ¹Ï‚ Î´ÎµÎ½ Î±Ï€Î¿Î¸Î·ÎºÎµÏÎ¿Î½Ï„Î±Î¹',0),(365854,10163,'zh','é”™è¯¯ -ä¸ä¿å­˜è®¤è¯',0),(365855,10163,'sv','Fel - godkÃ¤nnanden inte sparas',0),(365856,10163,'it','Errore - approvazioni non salvati',0),(365857,10163,'tl','',0),(365858,10163,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸” - à¹„à¸¡à¹ˆà¸šà¸±à¸™à¸—à¸¶à¸à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(365859,10163,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ - à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¨à¤¹à¥€à¤‚ à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(365860,10163,'ms','Ralat - kelulusan tidak disimpan',0),(365861,10163,'ar','Ø®Ø·Ø£--Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø§Øª ØºÙŠØ± Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø©',0),(365862,10163,'fr','Erreur - approbations non enregistrÃ©es',0),(365863,10163,'jp','ã‚¨ãƒ©ãƒ¼ - æ‰¿èªã¯ä¿å­˜ã•ã‚Œã¾ã›ã‚“ã€‚',0),(365864,10163,'pt','Erro - recepÃ§Ãµes nÃ£o salvos',0),(365865,10163,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° - Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð½Ðµ ÑÐ¾Ñ…Ñ€Ð°Ð½ÑÑŽÑ‚ÑÑ',0),(365866,10163,'es','Error - Aprobaciones no Guardados',0),(365867,10163,'de','Fehler - Zulassungen nicht gespeichert',0),(365868,10163,'en','Error - Approvals Not Saved',0),(365869,10164,'is','',0),(365870,10164,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(365871,10164,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(365872,10164,'tr','Onay gerekli olmadÄ±ÄŸÄ±nÄ± kontrol edin',0),(365873,10164,'pl','SprawdÅº, czy wymagana zgoda',0),(365874,10164,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ð»Ð¸ Ð¸Ð·Ð¸ÑÐºÐ²Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(365875,10164,'ur','Ø§Ú¯Ø± Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÙˆ ØªÙˆ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(365876,10164,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°ÐºÐ¾ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(365877,10164,'vi','Kiá»ƒm tra xem phÃª duyá»‡t yÃªu cáº§u',0),(365878,10164,'af','Merk indien Goedkeuring Benodig word',0),(365879,10164,'ro','VerificaÅ£i dacÄƒ aprobarea necesare',0),(365880,10164,'et','Kontrollige, kui tunnustamine on nÃµutav',0),(365881,10164,'si','Preverite, Äe je obvezna odobritev',0),(365882,10164,'ba','Periksa apakah persetujuan diperlukan',0),(365883,10164,'nl','Controleer of goedkeuring vereist',0),(365884,10164,'fi','Tarkista, onko hyvÃ¤ksyntÃ¤ vaaditaan',0),(365885,10164,'no','Sjekk om godkjenning kreves',0),(365886,10164,'da','Tjek om godkendelse krÃ¦ves',0),(365887,10164,'ko','ê²€ì‚¬ ìŠ¹ì¸ì„ ìš”êµ¬ í•˜ëŠ” ê²½ìš°',0),(365888,10164,'he','×‘×“×•×§ ×× × ×“×¨×© ××™×©×•×¨',0),(365889,10164,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÎµÎ¬Î½ Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î­Î³ÎºÏÎ¹ÏƒÎ·',0),(365890,10164,'zh','æ£€æŸ¥æ˜¯å¦éœ€è¦æ‰¹å‡†\r\n',0),(365891,10164,'sv','Kontrollera om godkÃ¤nnande krÃ¤vs',0),(365892,10164,'it','Verificare se richiesta approvazione',0),(365893,10164,'tl','',0),(365894,10164,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸§à¹ˆà¸²à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(365895,10164,'hi','à¤¯à¤¦à¤¿ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤šà¥‡à¤•',0),(365896,10164,'ms','Semak jika kelulusan diperlukan',0),(365897,10164,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø­Ø§Ù„Ø© Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(365898,10164,'fr','VÃ©rifier si l\'approbation requise',0),(365899,10164,'jp','æ‰¿èªãŒå¿…è¦ãªå ´åˆã¯ãƒã‚§ãƒƒã‚¯',0),(365900,10164,'pt','Verifique se a aprovaÃ§Ã£o necessÃ¡ria',0),(365901,10164,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ, ÐµÑÐ»Ð¸ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(365902,10164,'es','Verificar si se Requiere AprobaciÃ³n',0),(365903,10164,'de','ÃœberprÃ¼fen Sie, ob die Genehmigung erforderlich',0),(365904,10164,'en','Check if Approval Required',0),(365905,10165,'is','',0),(365906,10165,'dr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù…ÙŠ ØªÙˆØ§Ù† Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ±Ø¯',0),(365907,10165,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ù…ÙŠ ØªÙˆØ§Ù† Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ±Ø¯',0),(365908,10165,'tr','EÄŸer kontrol edebilirsiniz seÃ§in',0),(365909,10165,'pl','SprawdÅº, czy moÅ¼na wybraÄ‡',0),(365910,10165,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ð»Ð¸ Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ',0),(365911,10165,'ur','Ø§Ú¯Ø± ØªÙˆ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(365912,10165,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð´Ð° Ð»Ð¸ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ',0),(365913,10165,'vi','Kiá»ƒm tra náº¿u cÃ³ thá»ƒ chá»n',0),(365914,10165,'af','Kontroleer as kan kies',0),(365915,10165,'ro','VerificaÅ£i dacÄƒ puteÅ£i selecta',0),(365916,10165,'et','Vaata kui saad valida',0),(365917,10165,'si','Preverite, Äe izberete',0),(365918,10165,'ba','Periksa jika dapat memilih',0),(365919,10165,'nl','Controleer indien kunt selecteren',0),(365920,10165,'fi','Tarkista valita',0),(365921,10165,'no','Sjekk Hvis kan velge',0),(365922,10165,'da','Kontroller kan vÃ¦lge',0),(365923,10165,'ko','í™•ì¸ì„ ì„ íƒí•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤',0),(365924,10165,'he','×‘×“×•×§ ×× × ×™×ª×Ÿ ×œ×‘×—×•×¨',0),(365925,10165,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÎµÎ¬Î½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÎ¹',0),(365926,10165,'zh','æ£€æŸ¥æ˜¯å¦å¯ä»¥é€‰æ‹©\r\n',0),(365927,10165,'sv','Kontrollera om kan vÃ¤lja',0),(365928,10165,'it','Verifica se puÃ² selezionare',0),(365929,10165,'tl','',0),(365930,10165,'th','à¸–à¹‰à¸²à¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸¥à¸·à¸­à¸',0),(365931,10165,'hi','à¤…à¤—à¤° à¤œà¤¾à¤à¤š à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(365932,10165,'ms','Periksa jika boleh memilih',0),(365933,10165,'ar','Ù…Ø¹Ø±ÙØ© Ù…Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù† \"ÙŠÙ…ÙƒÙ† ØªØ­Ø¯ÙŠØ¯\"',0),(365934,10165,'fr','VÃ©rifier si pouvez sÃ©lectionner',0),(365935,10165,'jp','å ´åˆã‚’ãƒã‚§ãƒƒã‚¯ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã‚’é¸æŠžã—ã¾ã™',0),(365936,10165,'pt','Verifique se pode selecionar',0),(365937,10165,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð¼Ð¾Ð¶Ð½Ð¾ Ð»Ð¸ Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ',0),(365938,10165,'es','Verificar si se Puede Seleccionar',0),(365939,10165,'de','ÃœberprÃ¼fen Sie, ob kÃ¶nnen auswÃ¤hlen',0),(365940,10165,'en','Check if Can Select',0),(365941,10166,'is','',0),(365942,10166,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ ',0),(365943,10166,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ú¯Ø±ÙˆÙ‡ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø±ÙŠ ',0),(365944,10166,'tr','VarsayÄ±lan kategori Timeclock iÅŸÃ§ilik saati iÃ§in',0),(365945,10166,'pl','Kategorii domyÅ›lnej dla godzin pracy Timeclock',0),(365946,10166,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð·Ð° Timeclock Ñ‚Ñ€ÑƒÐ´ Ñ‡Ð°ÑÐ°',0),(365947,10166,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù…Ø²Ø¯ÙˆØ± Ú©Û’ Ø§ÙˆÙ‚Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ø·Û’ Ø´Ø¯Û Ø²Ù…Ø±Û',0),(365948,10166,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ ÑÐ°Ñ‚Ð¸Ð¼Ð° Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ñ€Ð°Ð´Ð°',0),(365949,10166,'vi','Thá»ƒ loáº¡i máº·c Ä‘á»‹nh cho Timeclock lao Ä‘á»™ng giá»',0),(365950,10166,'af','Verstekte Kategorie vir Tydklok Arbeidsure',0),(365951,10166,'ro','Categoria implicit pentru munca ceas ore',0),(365952,10166,'et','Timeclock tÃ¶Ã¶ tundide vaikekategooria',0),(365953,10166,'si','Privzeta kategorija Timeclock Labor ur',0),(365954,10166,'ba','Default kategori selama jam kerja Timeclock',0),(365955,10166,'nl','Standaardcategorie voor klok Labor uur',0),(365956,10166,'fi','Timeclock tyÃ¶ tuntien oletusluokka',0),(365957,10166,'no','Standardkategori for Timeclock arbeidstimer',0),(365958,10166,'da','Standardart for Timeclock arbejdslÃ¸n',0),(365959,10166,'ko','Timeclock ë…¸ë™ ì‹œê°„ì— ëŒ€ í•œ ê¸°ë³¸ ì¹´í…Œê³ ë¦¬',0),(365960,10166,'he','×§×˜×’×•×¨×™×ª ×‘×¨×™×¨×ª ×ž×—×“×œ ×¢×‘×•×¨ ×©×¢×•×ª ×”×¢×‘×•×“×” Timeclock',0),(365961,10166,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î®Ï‚ Î³Î¹Î± ÏŽÏÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Timeclock',0),(365962,10166,'zh','é»˜è®¤åˆ†ç±»åŠ³åŠ¨æ—¶é—´çš„æ—¶é’Ÿ\r\n',0),(365963,10166,'sv','Standardkategori fÃ¶r Timeclock arbetstimmar',0),(365964,10166,'it','Categoria predefinita per ore di lavoro Timeclock',0),(365965,10166,'tl','',0),(365966,10166,'th','à¸›à¸£à¸°à¹€à¸ à¸—à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¹à¸£à¸‡à¸‡à¸²à¸™ Timeclock',0),(365967,10166,'hi','Timeclock à¤¶à¥à¤°à¤® à¤˜à¤‚à¤Ÿà¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(365968,10166,'ms','Kategori lalai untuk Timeclock buruh',0),(365969,10166,'ar','Ø§Ù„ÙØ¦Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ù„Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„ ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(365970,10166,'fr','CatÃ©gorie par dÃ©faut pour les heures de main-d\'Å“uvre Timeclock',0),(365971,10166,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯åŠ´åƒæ™‚é–“ã®æ—¢å®šã®ã‚«ãƒ†ã‚´ãƒª',0),(365972,10166,'pt','Categoria padrÃ£o para horas de trabalho Timeclock',0),(365973,10166,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ Timeclock Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ñ… Ñ‡Ð°ÑÐ¾Ð²',0),(365974,10166,'es','CategorÃ­a por Defecto para Horas de Labor de Reloj Checador',0),(365975,10166,'de','Standardkategorie fÃ¼r Timeclock Arbeitsstunden',0),(365976,10166,'en','Default Category for Timeclock Labor Hours',0),(365977,10167,'is','',0),(365978,10167,'dr','Ù¾ÙŠØ´ ØªØ§ÙŠÙŠØ¯ Ù…Ø¯ÙŠØ± Ø¶Ø±ÙˆØ±ÙŠ Ø§Ø³Øª ',0),(365979,10167,'pr','Ù¾ÙŠØ´ ØªØ§ÙŠÙŠØ¯ Ù…Ø¯ÙŠØ± Ø¶Ø±ÙˆØ±ÙŠ Ø§Ø³Øª ',0),(365980,10167,'tr','YÃ¶neticisi Ã¶n onay gerekli',0),(365981,10167,'pl','MenedÅ¼er wymagane jest wstÄ™pne zatwierdzenie',0),(365982,10167,'bg','ÐœÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ ÑÐµ Ð¸Ð·Ð¸ÑÐºÐ²Ð°',0),(365983,10167,'ur','Ù…Ù†ÛŒØ¬Ø± Ù¾Ø±ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(365984,10167,'sr','ÐŸÑ€ÐµÐ´ -Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ Ð¼ÐµÐ½Ð°ÑŸÐµÑ€Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ',0),(365985,10167,'vi','Quáº£n lÃ½ trÆ°á»›c khi phÃª duyá»‡t yÃªu cáº§u',0),(365986,10167,'af','Bestuurder Vooraf-Goedkeuring Benodig',0),(365987,10167,'ro','Manager de pre-aprobare necesare',0),(365988,10167,'et','Manager eelnev heakskiitmine nÃµutud',0),(365989,10167,'si','Manager predhodno odobritev je zahtevana',0),(365990,10167,'ba','Manajer pra-persetujuan yang diperlukan',0),(365991,10167,'nl','Manager selectie vooraf vereist',0),(365992,10167,'fi','Manager ennakkohyvÃ¤ksyntÃ¤ vaaditaan',0),(365993,10167,'no','FÃ¸r godkjenning kreves',0),(365994,10167,'da','Manager forudgÃ¥ende godkendelse krÃ¦ves',0),(365995,10167,'ko','ê´€ë¦¬ìž ì‚¬ì „ ìŠ¹ì¸ í•„ìš”',0),(365996,10167,'he','×ž× ×”×œ ×©×œ×¤× ×™ ×”××™×©×•×¨ ×”× ×“×¨×©',0),(365997,10167,'el','Î ÏÎ¿-Î­Î³ÎºÏÎ¹ÏƒÎ· Î´Î¹Î±Ï‡ÎµÎ¹ÏÎ¹ÏƒÏ„Î® Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹',0),(365998,10167,'zh','ç»ç†è¦æ±‚å®¡æ‰¹å‰\r\n\r\n',0),(365999,10167,'sv','Manager fÃ¶re godkÃ¤nnande krÃ¤vs',0),(366000,10167,'it','Gestione pre-approvazione necessaria',0),(366001,10167,'tl','',0),(366002,10167,'th','à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸à¸²à¸£à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²à¸ˆà¸³à¹€à¸›à¹‡à¸™',0),(366003,10167,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤• à¤ªà¥‚à¤°à¥à¤µ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(366004,10167,'ms','Pengurus pra kelulusan yang diperlukan',0),(366005,10167,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø§Ù„Ù…Ø³Ø¨Ù‚Ø© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(366006,10167,'fr','Gestionnaire pre autorisation nÃ©cessaire',0),(366007,10167,'jp','ãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼ã€äº‹å‰æ‰¿èªãŒå¿…è¦',0),(366008,10167,'pt','Gerente de prÃ©-aprovaÃ§Ã£o necessÃ¡ria',0),(366009,10167,'ru','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð¼ÐµÐ½ÐµÐ´Ð¶ÐµÑ€Ð° Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ',0),(366010,10167,'es','PreaprobaciÃ³n del Supervisor Requerida',0),(366011,10167,'de','Manager vor Genehmigung erforderlich',0),(366012,10167,'en','Manager Pre-Approval Required',0),(366013,10168,'is','',0),(366014,10168,'dr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¯Ø±ØµØ¯ Ù†Ú¯Ù‡Ø¯Ø§Ø±Ù†Ø¯Ù‡',0),(366015,10168,'pr',' Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¯Ø±ØµØ¯ Ù†Ú¯Ù‡Ø¯Ø§Ø±Ù†Ø¯Ù‡',0),(366016,10168,'tr','VarsayÄ±lan hizmetli yÃ¼zde',0),(366017,10168,'pl','DomyÅ›lnie element ustalajÄ…cy procent',0),(366018,10168,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ„Ð¸ÐºÑÐ°Ñ‚Ð¾Ñ€ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(366019,10168,'ur','Ø·Û’ Ø´Ø¯Û Ø¯Ø§Ù…Ù†Ú¯ÛŒØ± ÙÛŒØµØ¯',0),(366020,10168,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¿Ñ€Ð¾Ñ‚ÐµÐ·Ñƒ Ð¿Ð¾ÑÑ‚Ð¾',0),(366021,10168,'vi','Máº·c Ä‘á»‹nh giá»¯ pháº§n trÄƒm',0),(366022,10168,'af','Verstek middels persent',0),(366023,10168,'ro','Procente de retinere implicit',0),(366024,10168,'et','Vaikimisi honorar protsenti',0),(366025,10168,'si','Privzeto honorar odstotkov',0),(366026,10168,'ba','Default pengikut persen',0),(366027,10168,'nl','Standaard Retainer procent',0),(366028,10168,'fi','Oletuksena kiinnike prosenttia',0),(366029,10168,'no','Standard Retainer prosent',0),(366030,10168,'da','Standard Retainer procent',0),(366031,10168,'ko','ê¸°ë³¸ ê³ ì • %',0),(366032,10168,'he','××—×•×– ×©×›×¨ ×˜×¨×—×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(366033,10168,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î±ÎºÏŒÎ»Î¿Ï…Î¸ÏŒÏ‚ Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(366034,10168,'zh','é»˜è®¤å®¶è‡£ç™¾åˆ†æ¯”\r\n',0),(366035,10168,'sv','Standard hÃ¥llare procent',0),(366036,10168,'it','Predefinito fermo per cento',0),(366037,10168,'tl','',0),(366038,10168,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¹ƒà¸™à¸à¸²à¸£à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(366039,10168,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤…à¤¨à¥à¤šà¤° à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(366040,10168,'ms','Lalai penahan peratus',0),(366041,10168,'ar','Ø§Ù„Ù…Ø¦Ø© Ø§Ù„ØªØ¬Ù†ÙŠØ¨ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(366042,10168,'fr','% De rÃ©tention par dÃ©faut',0),(366043,10168,'jp','æ—¢å®šã®å›ºå®šãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ',0),(366044,10168,'pt','Por cento de retenÃ§Ã£o padrÃ£o',0),(366045,10168,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ñ€ÐµÐ·ÐµÑ€Ð²Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(366046,10168,'es','Porcentaje del Anticipo Sobre los Honorarios por Defecto',0),(366047,10168,'de','Standard Retainer Prozent',0),(366048,10168,'en','Default Retainer Percent',0),(366049,10169,'is','',0),(366050,10169,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(366051,10169,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„',0),(366052,10169,'tr','GL bÃ¼tÃ§eleri',0),(366053,10169,'pl','BudÅ¼ety K/G',0),(366054,10169,'bg','GL Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸',0),(366055,10169,'ur','Ø¬ÛŒØ¬Û’ ØªØ®Ù…ÛŒÙ†ÙˆÚº (Ø¨Ø¬Ù¹)',0),(366056,10169,'sr','Ð“Ð› Ð±ÑƒÑŸÐµÑ‚Ðµ',0),(366057,10169,'vi','GL ngÃ¢n sÃ¡ch',0),(366058,10169,'af','AG Begrotings',0),(366059,10169,'ro','GL bugetele',0),(366060,10169,'et','GL eelarved',0),(366061,10169,'si','GL proraÄunov',0),(366062,10169,'ba','GL anggaran',0),(366063,10169,'nl','GL begrotingen',0),(366064,10169,'fi','GL budjetit',0),(366065,10169,'no','GL budsjetter',0),(366066,10169,'da','GL budgetter',0),(366067,10169,'ko','GL ì˜ˆì‚°',0),(366068,10169,'he','×ª×§×¦×™×‘×™× GL',0),(366069,10169,'el','GL Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(366070,10169,'zh','å‰å°”é¢„ç®—\r\n',0),(366071,10169,'sv','GL budgetar',0),(366072,10169,'it','Bilanci GL',0),(366073,10169,'tl','',0),(366074,10169,'th','à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(366075,10169,'hi','à¤œà¥€à¤à¤² à¤¬à¤œà¤Ÿ',0),(366076,10169,'ms','GL belanjawan',0),(366077,10169,'ar','Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(366078,10169,'fr','Budgets GL',0),(366079,10169,'jp','GL äºˆç®—',0),(366080,10169,'pt','OrÃ§amentos GL',0),(366081,10169,'ru','Ð“Ðš Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ñ‹',0),(366082,10169,'es','Presupuestos de LM',0),(366083,10169,'de','GL-Budgets',0),(366084,10169,'en','GL Budgets',0),(366085,10170,'is','',0),(366086,10170,'dr','ØªØ§ÙŠÙŠØ¯ Ø³Ø§Ø¹Ø§Øª',0),(366087,10170,'pr','ØªØ§ÙŠÙŠØ¯ Ø³Ø§Ø¹Ø§Øª',0),(366088,10170,'tr','Saat onaylama',0),(366089,10170,'pl','Zatwierdzanie godziny',0),(366090,10170,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÐ²Ð° Ñ‡Ð°ÑÐ°',0),(366091,10170,'ur','Ú¯Ú¾Ù†Ù¹Û’ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ',0),(366092,10170,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð¸ ÑÐ°Ñ‚Ð¸',0),(366093,10170,'vi','Giá» phÃª duyá»‡t',0),(366094,10170,'af','Ure Goedkeur',0),(366095,10170,'ro','Aproba ore',0),(366096,10170,'et','Kinnitada tundi',0),(366097,10170,'si','Odobri ur',0),(366098,10170,'ba','Menyetujui jam',0),(366099,10170,'nl','Goedkeuren van uren',0),(366100,10170,'fi','HyvÃ¤ksy tuntia',0),(366101,10170,'no','Godkjenne timer',0),(366102,10170,'da','Godkende timer',0),(366103,10170,'ko','ì‹œê°„ ìŠ¹ì¸',0),(366104,10170,'he','×œ××©×¨ ×©×¢×•×ª',0),(366105,10170,'el','Î•Î³ÎºÏÎ¯Î½ÎµÎ¹ Ï„Î¹Ï‚ ÏŽÏÎµÏ‚',0),(366106,10170,'zh','æ‰¹å‡†æ—¶é—´\r\n',0),(366107,10170,'sv','GodkÃ¤nna timmar',0),(366108,10170,'it','Approvare ore',0),(366109,10170,'tl','',0),(366110,10170,'th','à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡',0),(366111,10170,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€',0),(366112,10170,'ms','Meluluskan jam',0),(366113,10170,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø³Ø§Ø¹Ø§Øª',0),(366114,10170,'fr','Approuver les heures',0),(366115,10170,'jp','æ™‚é–“ã‚’æ‰¿èªã—ã¾ã™ã€‚',0),(366116,10170,'pt','Aprovar horas',0),(366117,10170,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Ñ‡Ð°ÑÐ¾Ð²',0),(366118,10170,'es','Aprueba Horas',0),(366119,10170,'de','Stunden zu genehmigen',0),(366120,10170,'en','Approve Hours',0),(366121,10171,'is','',0),(366122,10171,'dr','Ø®Ø·Ø§ â€“ Ø²Ù…Ø§Ù† Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯ ',0),(366123,10171,'pr','Ø®Ø·Ø§ â€“ Ø²Ù…Ø§Ù† Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯ ',0),(366124,10171,'tr','Hata - deÄŸil kurtarmak zaman',0),(366125,10171,'pl','BÅ‚Ä…d - nie oszczÄ™dnoÅ›Ä‡ czasu',0),(366126,10171,'bg','Ð“Ñ€ÐµÑˆÐºÐ° - Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ðµ',0),(366127,10171,'ur','Ù†Ù‚Øµ - ÙˆÙ‚Øª Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº',0),(366128,10171,'sr','Ð“Ñ€ÐµÑˆÐºÐ° - Ð¿ÑƒÑ‚ Ð½Ð¸Ñ˜Ðµ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½Ð°',0),(366129,10171,'vi','Lá»—i- thá»i gian khÃ´ng Ä‘Æ°á»£c lÆ°u',0),(366130,10171,'af','Fout - Tyd Nie Gestoor',0),(366131,10171,'ro','Eroare - timp salvatÄƒ nu',0),(366132,10171,'et','Viga - aega ei salvestata',0),(366133,10171,'si','Napaka - Äas ne shrani',0),(366134,10171,'ba','Kesalahan - waktu tidak disimpan',0),(366135,10171,'nl','Fout - tijd niet opgeslagen',0),(366136,10171,'fi','Virhe - ei tallennuksen',0),(366137,10171,'no','Feil - ikke lagret',0),(366138,10171,'da','Fejl - ikke sparede tid',0),(366139,10171,'ko','ì˜¤ë¥˜-ì‹œê°„ ì €ìž¥ ë˜ì§€',0),(366140,10171,'he','×©×’×™××” - ×–×ž×Ÿ ×œ× × ×©×ž×¨',0),(366141,10171,'el','Î£Ï†Î¬Î»Î¼Î± - Î´ÎµÎ½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·',0),(366142,10171,'zh','é”™è¯¯ -æœªä¿å­˜æ—¶é—´',0),(366143,10171,'sv','Fel - inte sparad tid',0),(366144,10171,'it','Errore - tempo non salvato',0),(366145,10171,'tl','',0),(366146,10171,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸” - à¹„à¸¡à¹ˆà¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸§à¸¥à¸²',0),(366147,10171,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ - à¤¸à¤®à¤¯ à¤¨à¤¹à¥€à¤‚ à¤¬à¤šà¤¾ à¤²à¤¿à¤¯à¤¾',0),(366148,10171,'ms','Ralat - masa tidak disimpan',0),(366149,10171,'ar','Ø®Ø·Ø£--Ù„Ø§ ÙŠØªÙ… Ø­ÙØ¸ Ø§Ù„ÙˆÙ‚Øª',0),(366150,10171,'fr','Erreur - ne pas de gain de temps',0),(366151,10171,'jp','ã‚¨ãƒ©ãƒ¼ - æ™‚é–“ã¯ä¿å­˜ã•ã‚Œã¾ã›ã‚“ã€‚',0),(366152,10171,'pt','Erro - tempo nÃ£o salvo',0),(366153,10171,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° - Ð’Ñ€ÐµÐ¼Ñ ÐÐµ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¾',0),(366154,10171,'es','Error - Tiempo no Guardado',0),(366155,10171,'de','Fehler - Zeit nicht gespeichert',0),(366156,10171,'en','Error - Time Not Saved',0),(366157,10172,'is','',0),(366158,10172,'dr','(Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø®Ø±Ø¯Ù‡ Ø±ÙŠØ²',0),(366159,10172,'pr','Ø³Ø§Ø¹Ø§Øª Ø±ÙˆÙŠ ÙƒØ§Ù…ÙŠÙˆÙ†(Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø®Ø±Ø¯Ù‡ Ø±ÙŠØ²',0),(366160,10172,'tr','OT gÃ¶nderilen',0),(366161,10172,'pl','OT Hrs',0),(366162,10172,'bg','OT Ñ‡',0),(366163,10172,'ur','OT Ú¯Ú¾Ù†Ù¹Û’',0),(366164,10172,'sr','Ð˜ÐˆÐ• Ñ‡',0),(366165,10172,'vi','lÃ m thÃªm giá»',0),(366166,10172,'af','Jesus naam nie.',0),(366167,10172,'ro','OT ore',0),(366168,10172,'et','OT tundi',0),(366169,10172,'si','OT Hrs',0),(366170,10172,'ba','PL Hrs',0),(366171,10172,'nl','OT Hrs',0),(366172,10172,'fi','OT Hrs',0),(366173,10172,'no','OT timer',0),(366174,10172,'da','OT Hrs',0),(366175,10172,'ko','OT ì‹œê°„',0),(366176,10172,'he','OT ×©×¢×•×ª',0),(366177,10172,'el','OT ÏŽÏÎµÏ‚',0),(366178,10172,'zh','åŠ ç­å°æ—¶æ•°\r\n',0),(366179,10172,'sv','OT timmar',0),(366180,10172,'it','OT Hrs',0),(366181,10172,'tl','',0),(366182,10172,'th','à¸™. OT',0),(366183,10172,'hi','OT Hrs',0),(366184,10172,'ms','Jam OT',0),(366185,10172,'ar','Ø³Ø§Ø¹Ø§Øª Ø¨Ø¹Ø¯ Ø§Ù„ØªÙ…Ø¯ÙŠØ¯',0),(366186,10172,'fr','OT Hrs',0),(366187,10172,'jp','OT æ™‚é–“',0),(366188,10172,'pt','OT Hrs',0),(366189,10172,'ru','OT Ñ‡Ð°ÑÐ¾Ð²',0),(366190,10172,'es','Horas de Sobre Tiempo',0),(366191,10172,'de','OT Hrs',0),(366192,10172,'en','OT Hrs',0),(366193,10173,'is','',0),(366194,10173,'dr','ØªØ§Ø±ÙŠØ® ÙƒØ§Ø± ',0),(366195,10173,'pr','ØªØ§Ø±ÙŠØ® ÙƒØ§Ø± ',0),(366196,10173,'tr','Ã‡alÄ±ÅŸma tarihi',0),(366197,10173,'pl','Data pracy',0),(366198,10173,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(366199,10173,'ur','Ú©Ø§Ù… Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(366200,10173,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ð±Ñ€Ð°Ð´Ðµ',0),(366201,10173,'vi','NgÃ y lÃ m viá»‡c',0),(366202,10173,'af','Werk Datum',0),(366203,10173,'ro','Data de lucru',0),(366204,10173,'et','TÃ¶Ã¶pÃ¤ev',0),(366205,10173,'si','Datum obdelave',0),(366206,10173,'ba','Tanggal pekerjaan',0),(366207,10173,'nl','Werkdatum',0),(366208,10173,'fi','TyÃ¶n pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(366209,10173,'no','Arbeidsdatoen',0),(366210,10173,'da','Arbejdsdatoen.',0),(366211,10173,'ko','ìž‘ì—… ë‚ ì§œ',0),(366212,10173,'he','×¢×‘×•×“×” ×ª××¨×™×š',0),(366213,10173,'el','Î—Î¼/Î½Î¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(366214,10173,'zh','å·¥ä½œæ—¥æœŸ\r\n',0),(366215,10173,'sv','Arbetsdatumet.',0),(366216,10173,'it','Data di lavoro',0),(366217,10173,'tl','',0),(366218,10173,'th','à¸§à¸±à¸™à¸—à¸³à¸‡à¸²à¸™',0),(366219,10173,'hi','à¤•à¤¾à¤® à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(366220,10173,'ms','Tarikh kerja-kerja',0),(366221,10173,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¹Ù…Ù„',0),(366222,10173,'fr','Date de travail',0),(366223,10173,'jp','ä½œæ¥­æ—¥',0),(366224,10173,'pt','Data de trabalho',0),(366225,10173,'ru','Ð”Ð°Ñ‚Ð° Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(366226,10173,'es','Fecha del Trabajo',0),(366227,10173,'de','Arbeitsdatum',0),(366228,10173,'en','Work Date',0),(366229,10174,'is','',0),(366230,10174,'dr','Ø²Ù…Ø§Ù† Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯ â€“ Ø®Ø·Ø§ Ø¯Ø± Ø³Ø·Ø± ',0),(366231,10174,'pr','Ø²Ù…Ø§Ù† Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯ â€“ Ø®Ø·Ø§ Ø¯Ø± Ø³Ø·Ø± ',0),(366232,10174,'tr','Zaman satÄ±rdaki hata kayÄ±tlÄ± deÄŸil-',0),(366233,10174,'pl','Czas nie zapisane - bÅ‚Ä…d w linii',0),(366234,10174,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð½Ðµ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸ - Ð³Ñ€ÐµÑˆÐºÐ° Ð² Ñ€ÐµÐ´',0),(366235,10174,'ur','ÙˆÙ‚Øª Ù„Ø§Ø¦Ù† Ù…ÛŒÚº Ù†Ù‚Øµ Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº-',0),(366236,10174,'sr','Ð’Ñ€ÐµÐ¼ÐµÐ½Ð° Ð½Ð¸ÑÑƒ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½Ðµ - Ð³Ñ€ÐµÑˆÐºÐ° Ñƒ Ñ€ÐµÐ´',0),(366237,10174,'vi','KhÃ´ng lÆ°u thá»i gian, lá»—i trong dÃ²ng',0),(366238,10174,'af','Tyd Nie Gestoor - Fout het onstaan in Lyn',0),(366239,10174,'ro','Timp salvat nu - eroare Ã®n linie',0),(366240,10174,'et','Aeg ei salvestata - tÃµrge reas',0),(366241,10174,'si','ÄŒas ne shrani - napaka v vrstici',0),(366242,10174,'ba','Waktu tidak disimpan - kesalahan dalam baris',0),(366243,10174,'nl','Tijd niet opgeslagen - fout in lijn',0),(366244,10174,'fi','Aika ei tallenneta - rivillÃ¤ virhe',0),(366245,10174,'no','Tid ikke lagret - feil pÃ¥ linjen',0),(366246,10174,'da','Tid ikke gemt - fejl i linje',0),(366247,10174,'ko','ì‹œê°„ ì €ìž¥ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤-ë¼ì¸ ì˜¤ë¥˜',0),(366248,10174,'he','×”×–×ž×Ÿ ×œ× × ×©×ž×¨ - ×©×’×™××” ×‘×©×•×¨×”',0),(366249,10174,'el','Î§ÏÏŒÎ½Î¿ Î´ÎµÎ½ Î±Ï€Î¿Î¸Î·ÎºÎµÏÎ¿Î½Ï„Î±Î¹ - ÏƒÏ†Î¬Î»Î¼Î± ÏƒÎµ Î³ÏÎ±Î¼Î¼Î®',0),(366250,10174,'zh','æ—¶é—´ä¸ä¿å­˜ -è¡Œä¸­çš„é”™è¯¯\r\n',0),(366251,10174,'sv','Tid sparas inte - fel i linje',0),(366252,10174,'it','Tempo non salvato - errore in linea',0),(366253,10174,'tl','',0),(366254,10174,'th','à¹€à¸§à¸¥à¸²à¹„à¸¡à¹ˆà¸šà¸±à¸™à¸—à¸¶à¸ - à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸šà¸£à¸£à¸—à¸±à¸”',0),(366255,10174,'hi','à¤¸à¤®à¤¯ à¤°à¥‡à¤–à¤¾ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¨à¤¹à¥€à¤‚ à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾-',0),(366256,10174,'ms','Masa tidak disimpan - ralat dalam talian',0),(366257,10174,'ar','Ø§Ù„ÙˆÙ‚Øª Ø¹Ø¯Ù… Ø­ÙØ¸-Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø®Ø·',0),(366258,10174,'fr','Temps ne pas gagnÃ© - erreur Ã  la ligne',0),(366259,10174,'jp','æ™‚é–“ã¯ä¿å­˜ã•ã‚Œã¾ã›ã‚“ - è¡Œã§ã‚¨ãƒ©ãƒ¼',0),(366260,10174,'pt','Tempo nÃ£o salvo - erro na linha',0),(366261,10174,'ru','Ð’Ñ€ÐµÐ¼Ñ ÐÐµ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¾ - ÐžÑˆÐ¸Ð±ÐºÐ° Ð² Ð¡Ñ‚Ñ€Ð¾ÐºÐµ',0),(366262,10174,'es','Tiempo no Guardado - Error en Linea',0),(366263,10174,'de','Zeit nicht gespeichert - Fehler in Zeile',0),(366264,10174,'en','Time Not Saved - Error in Line',0),(366265,10175,'is','',0),(366266,10175,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¬Ù‡Øª Ø­Ù‚ÙˆÙ‚',0),(366267,10175,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¬Ù‡Øª Ø­Ù‚ÙˆÙ‚',0),(366268,10175,'tr','Toplam OT Ã¶deme',0),(366269,10175,'pl','CaÅ‚kowitej zapÅ‚aty OT',0),(366270,10175,'bg','ÐžÐ±Ñ‰Ð¾ OT Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(366271,10175,'ur','Ú©Ù„ OT ØªÙ†Ø®ÙˆØ§Û',0),(366272,10175,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð° Ð˜ÐˆÐ•',0),(366273,10175,'vi','Tá»•ng sá»‘  tiá»n pháº£i tráº£ OT',0),(366274,10175,'af','Totale GT Besoldiging',0),(366275,10175,'ro','Plata totalÄƒ OT',0),(366276,10175,'et','Kokku OT maksma',0),(366277,10175,'si','Skupaj plaÄilo OT',0),(366278,10175,'ba','Total membayar PL',0),(366279,10175,'nl','Totale OT Pay',0),(366280,10175,'fi','OT palkka yhteensÃ¤',0),(366281,10175,'no','LÃ¸nn totalt OT',0),(366282,10175,'da','Total OT lÃ¸n',0),(366283,10175,'ko','ì´ ì—°ìž¥ ì „ ì§€ë¶ˆ',0),(366284,10175,'he','×¡×” ×› ×”×©×›×¨ ×‘×ª×  ×š',0),(366285,10175,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ®Ï‚ Î±Î¼Î¿Î¹Î²Î®Ï‚ OT',0),(366286,10175,'zh','æ€»è®¡åŠ ç­å·¥èµ„\r\n',0),(366287,10175,'sv','Totalt OT betala',0),(366288,10175,'it','Totale OT Pay',0),(366289,10175,'tl','',0),(366290,10175,'th','à¸£à¸§à¸¡à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡ OT',0),(366291,10175,'hi','à¤•à¥à¤² OT à¤ªà¥‡',0),(366292,10175,'ms','Jumlah gaji OT',0),(366293,10175,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø£Ø¬Ø± Ø¨Ø¹Ø¯ Ø§Ù„ØªÙ…Ø¯ÙŠØ¯',0),(366294,10175,'fr','OT salaire total',0),(366295,10175,'jp','åˆè¨ˆæ”¯æ‰•ã† OT',0),(366296,10175,'pt','Pagamento total do OT',0),(366297,10175,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ OT',0),(366298,10175,'es','Pagos Totales para Sobretiempo',0),(366299,10175,'de','Total OT Pay',0),(366300,10175,'en','Total OT Pay',0),(366301,10176,'is','',0),(366302,10176,'dr','ST ',0),(366303,10176,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø­Ù‚ÙˆÙ‚ Ø³Ø§Ø¹Ø§Øª Ù…Ø³ØªÙ‚ÙŠÙ… ST ',0),(366304,10176,'tr','Toplam ST Ã¶deme',0),(366305,10176,'pl','ST suma wynagrodzeÅ„',0),(366306,10176,'bg','ÐžÐ±Ñ‰Ð¾ ST Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(366307,10176,'ur','Ú©Ù„ Ø³ÛŒÙ†Ù¹ ØªÙ†Ø®ÙˆØ§Û',0),(366308,10176,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¡Ð¢ Ð¿Ð»Ð°Ñ‚Ð°',0),(366309,10176,'vi','Tá»•ng thanh toÃ¡n ST',0),(366310,10176,'af','Totale GT Besoldiging',0),(366311,10176,'ro','Plata totalÄƒ ST',0),(366312,10176,'et','Kokku ST makse',0),(366313,10176,'si','PlaÄilo Total ST',0),(366314,10176,'ba','Membayar total ST',0),(366315,10176,'nl','Totaal ST Pay',0),(366316,10176,'fi','YhteensÃ¤ ST maksu',0),(366317,10176,'no','Totalt ST lÃ¸nn',0),(366318,10176,'da','Total ST lÃ¸n',0),(366319,10176,'ko','ì´ ì„¸ì¸íŠ¸ ì§€ë¶ˆ',0),(366320,10176,'he','×¨×—\' ×¡×š ×©×›×¨',0),(366321,10176,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ ST Pay',0),(366322,10176,'zh','å…±è®¡æ ‡å‡†è–ªé…¬\r\n',0),(366323,10176,'sv','Totalt ST lÃ¶n',0),(366324,10176,'it','Retribuzione totale ST',0),(366325,10176,'tl','',0),(366326,10176,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸£à¸§à¸¡ ST',0),(366327,10176,'hi','à¤•à¥à¤² à¤…à¤¨à¥à¤¸à¥‚à¤šà¤¿à¤¤ à¤œà¤¨à¤œà¤¾à¤¤à¤¿ à¤ªà¥‡',0),(366328,10176,'ms','ST jumlah gaji',0),(366329,10176,'ar','Ø´ Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø£Ø¬Ø±',0),(366330,10176,'fr','Salaire total ST',0),(366331,10176,'jp','åˆè¨ˆã‚»ãƒ³ãƒˆæ‰•ã†',0),(366332,10176,'pt','Pagamento total ST',0),(366333,10176,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð²ÑÐµÐ³Ð¾ ST',0),(366334,10176,'es','Pago Total del ST',0),(366335,10176,'de','Gesamt ST Pay',0),(366336,10176,'en','Total ST Pay',0),(366337,10177,'is','',0),(366338,10177,'dr','- Ø®Ø·Ø§ Ø¯Ø± Ø³Ø·Ø± ',0),(366339,10177,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯- Ø®Ø·Ø§ Ø¯Ø± Ø³Ø·Ø± ',0),(366340,10177,'tr','Veri kaydedilmez--SatÄ±rdaki hata',0),(366341,10177,'pl','Dane, zapisane nie--BÅ‚Ä…d w linii',0),(366342,10177,'bg','Ð”Ð°Ð½Ð½Ð¸Ñ‚Ðµ Ð½Ðµ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ñ‚--Ð“Ñ€ÐµÑˆÐºÐ° Ð² Ñ€ÐµÐ´',0),(366343,10177,'ur','Ú©ÙˆØ§Ø¦Ù Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº - Ø³Ø·Ø± Ù…ÛŒÚº Ø§ÛŒÚ© Ù†Ù‚Øµ',0),(366344,10177,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸ ÑÐµ Ð½Ðµ Ñ‡ÑƒÐ²Ð°Ñ˜Ñƒ--Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ñ€ÐµÐ´',0),(366345,10177,'vi','Dá»¯ liá»‡u khÃ´ng Ä‘Æ°á»£c lÆ°u- Lá»—i á»Ÿ dÃ²ng',0),(366346,10177,'af','Data Ongestoor -- Fout in die Lyn',0),(366347,10177,'ro','Datele salvate nu--Eroare Ã®n linie',0),(366348,10177,'et','Andmeid ei salvestata--TÃµrge reas',0),(366349,10177,'si','Podatki niso shranjeni--Napaka v vrstici',0),(366350,10177,'ba','Data tidak disimpan--Kesalahan dalam baris',0),(366351,10177,'nl','Gegevens niet opgeslagen--Fout In lijn',0),(366352,10177,'fi','Tietoja ei tallenneta--RivillÃ¤ virhe',0),(366353,10177,'no','Data ikke lagret--Feil pÃ¥ linjen',0),(366354,10177,'da','Data ikke gemt--Fejl i linje',0),(366355,10177,'ko','ë¼ì¸ì— ë°ì´í„°ë¥¼ ì €ìž¥í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤-ì˜¤ë¥˜',0),(366356,10177,'he','×”× ×ª×•× ×™× ××™× × × ×©×ž×¨×™× - ×©×’×™××” ×‘×©×•×¨×”',0),(366357,10177,'el','Î”ÎµÎ´Î¿Î¼Î­Î½Î± Î´ÎµÎ½ Î±Ï€Î¿Î¸Î·ÎºÎµÏÎ¿Î½Ï„Î±Î¹--Î£Ï†Î¬Î»Î¼Î± ÏƒÎµ Î³ÏÎ±Î¼Î¼Î®',0),(366358,10177,'zh','æ•°æ®ä¸ä¿å­˜- è¡Œé”™è¯¯\r\n',0),(366359,10177,'sv','Data sparas inte--Fel i linje',0),(366360,10177,'it','Dati non salvati..--Errore In linea',0),(366361,10177,'tl','',0),(366362,10177,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹„à¸¡à¹ˆà¸šà¸±à¸™à¸—à¸¶à¸ - à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸šà¸£à¸£à¸—à¸±à¸”',0),(366363,10177,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤¹à¥‡à¤œà¤¾ à¤¨à¤¹à¥€à¤‚ - à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(366364,10177,'ms','Data yang tidak disimpan--Ralat dalam talian',0),(366365,10177,'ar','Ø¹Ø¯Ù… Ø­ÙØ¸ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª-Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø®Ø·',0),(366366,10177,'fr','Les donnÃ©es non enregistrÃ©es--Erreur en ligne',0),(366367,10177,'jp','è¡Œã«ãƒ‡ãƒ¼ã‚¿ãŒä¿å­˜ã•ã‚Œã¾ã›ã‚“--ã‚¨ãƒ©ãƒ¼',0),(366368,10177,'pt','Dados nÃ£o salvos..--Erro na linha',0),(366369,10177,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ ÐÐµ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹ -- ÐžÑˆÐ¸Ð±ÐºÐ° Ð’ Ð¡Ñ‚Ñ€Ð¾ÐºÐµ',0),(366370,10177,'es','Datos No Guardados - Error En Linea',0),(366371,10177,'de','Daten nicht gespeichert--Fehler In Zeile',0),(366372,10177,'en','Data Not Saved -- Error In Line',0),(366373,10178,'is','',0),(366374,10178,'dr','Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(366375,10178,'pr','Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(366376,10178,'tr','Geri Ã¶deme',0),(366377,10178,'pl','Zwroty',0),(366378,10178,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(366379,10178,'ur','Ø±ÛŒØ§Ù…Ø¨Ø±Ø³Ù…Ù†Ù¹Ø³',0),(366380,10178,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ð°Ð¼Ð° ÑˆÑ‚ÐµÑ‚Ðµ',0),(366381,10178,'vi','hoÃ n láº¡i',0),(366382,10178,'af','Reimbursements',0),(366383,10178,'ro','RambursÄƒrile',0),(366384,10178,'et','Tagasimaksed',0),(366385,10178,'si','PovraÄila',0),(366386,10178,'ba','Reimbursement',0),(366387,10178,'nl','Vergoedingen',0),(366388,10178,'fi','Korvaukset',0),(366389,10178,'no','Refusjoner',0),(366390,10178,'da','GodtgÃ¸relser',0),(366391,10178,'ko','í™˜ê¸‰',0),(366392,10178,'he','×”×—×–×¨',0),(366393,10178,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î­Ï‚',0),(366394,10178,'zh','å¿è¿˜\r\n',0),(366395,10178,'sv','Ã…terbetalningar',0),(366396,10178,'it','Rimborsi',0),(366397,10178,'tl','',0),(366398,10178,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¸·à¸™',0),(366399,10178,'hi','à¤ªà¥ˆà¤¸à¥‡ à¤•à¥€ à¤µà¤¾à¤ªà¤¸à¥€',0),(366400,10178,'ms','Pembayaran balik',0),(366401,10178,'ar','Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³Ø¯Ø¯Ø©',0),(366402,10178,'fr','Remboursements',0),(366403,10178,'jp','æ‰•ã„æˆ»ã—',0),(366404,10178,'pt','Reembolsos',0),(366405,10178,'ru','Ð’Ð¾Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(366406,10178,'es','Reembolsos',0),(366407,10178,'de','Erstattungen',0),(366408,10178,'en','Reimbursements',0),(366409,10179,'is','',0),(366410,10179,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª â€Œ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øªâ€Œ ',0),(366411,10179,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª â€Œ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øªâ€Œ ',0),(366412,10179,'tr','Geri Ã¶deme isteÄŸi',0),(366413,10179,'pl','Å»Ä…danie zwrotu pieniÄ™dzy',0),(366414,10179,'bg','Ð˜ÑÐºÐ°Ð½Ðµ Ð·Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(366415,10179,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(366416,10179,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ð° Ð·Ð°Ñ…Ñ‚ÐµÐ²',0),(366417,10179,'vi','Äá» nghá»‹ hoÃ n láº¡i',0),(366418,10179,'af','Terugbetaling versoek',0),(366419,10179,'ro','Cerere de rambursare',0),(366420,10179,'et','HÃ¼vitamise taotlus',0),(366421,10179,'si','Zahteva povraÄilo',0),(366422,10179,'ba','Penggantian permintaan',0),(366423,10179,'nl','Terugbetaling verzoek',0),(366424,10179,'fi','KorvauspyyntÃ¶',0),(366425,10179,'no','Refusjon-forespÃ¸rsel',0),(366426,10179,'da','Refusion anmodning',0),(366427,10179,'ko','ë³´ìƒ ìš”ì²­',0),(366428,10179,'he','×‘×§×©×ª ×”×—×–×¨',0),(366429,10179,'el','Î‘Î¯Ï„Î·ÏƒÎ· ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚',0),(366430,10179,'zh','è¦æ±‚é€€æ¬¾\r\n',0),(366431,10179,'sv','ErsÃ¤ttning begÃ¤ran',0),(366432,10179,'it','Richiesta di rimborso',0),(366433,10179,'tl','',0),(366434,10179,'th','à¸„à¸³à¸‚à¸­à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¸·à¸™',0),(366435,10179,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(366436,10179,'ms','Permintaan bayaran balik',0),(366437,10179,'ar','Ø·Ù„Ø¨ ØªØ³Ø¯ÙŠØ¯',0),(366438,10179,'fr','Demande de remboursement',0),(366439,10179,'jp','å„Ÿé‚„è¦æ±‚',0),(366440,10179,'pt','SolicitaÃ§Ã£o de reembolso',0),(366441,10179,'ru','Ð’Ð¾Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ñ€Ð¾Ñ',0),(366442,10179,'es','PeticiÃ³n para Reembolso',0),(366443,10179,'de','Erstattung Anfrage',0),(366444,10179,'en','Reimbursement Request',0),(366445,10180,'is','',0),(366446,10180,'dr','ØµÙØ­Ù‡ Ù…Ø¯ÙŠØ± ',0),(366447,10180,'pr','ØµÙØ­Ù‡ Ù…Ø¯ÙŠØ± ',0),(366448,10180,'tr','YÃ¶neticisi sayfasÄ±',0),(366449,10180,'pl','Strona MenedÅ¼er',0),(366450,10180,'bg','ÐœÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(366451,10180,'ur','Ù…Ù†ÛŒØ¬Ø± Ú©Ø§ ØµÙØ­Û',0),(366452,10180,'sr','ÐœÐµÐ½Ð°ÑŸÐµÑ€ Ð·Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(366453,10180,'vi','trang quáº£n lÃ½',0),(366454,10180,'af','Bestuurder Bladsy',0),(366455,10180,'ro','Manager Page',0),(366456,10180,'et','Halduri veebilehel',0),(366457,10180,'si','Manager Page',0),(366458,10180,'ba','Halaman Manager',0),(366459,10180,'nl','Pagina van de Manager',0),(366460,10180,'fi','Manager-sivu',0),(366461,10180,'no','Manager-siden',0),(366462,10180,'da','Siden styring',0),(366463,10180,'ko','ê´€ë¦¬ìž íŽ˜ì´ì§€',0),(366464,10180,'he','×“×£ ×ž× ×”×œ',0),(366465,10180,'el','Î£ÎµÎ»Î¯Î´Î± \"Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·\"',0),(366466,10180,'zh','ç®¡ç†é¡µé¢\r\n',0),(366467,10180,'sv','PÃ¥ sidan',0),(366468,10180,'it','Pagina gestione',0),(366469,10180,'tl','',0),(366470,10180,'th','à¸«à¸™à¹‰à¸²à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸à¸²à¸£',0),(366471,10180,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤• à¤ªà¥ƒà¤·à¥à¤ ',0),(366472,10180,'ms','Halaman Pengurus',0),(366473,10180,'ar','ØµÙØ­Ø© Ø§Ù„Ù…Ø¯ÙŠØ±',0),(366474,10180,'fr','Gestionnaire de Page',0),(366475,10180,'jp','ãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼ã®ãƒšãƒ¼ã‚¸',0),(366476,10180,'pt','PÃ¡gina Gerenciador',0),(366477,10180,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð”Ð¸ÑÐ¿ÐµÑ‚Ñ‡ÐµÑ€',0),(366478,10180,'es','PÃ¡gina del Supervisor',0),(366479,10180,'de','Seite \"Manager\"',0),(366480,10180,'en','Manager Page',0),(366481,10181,'is','',0),(366482,10181,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(366483,10181,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(366484,10181,'tr','Geri Ã¶deme isteÄŸinde',0),(366485,10181,'pl','Å»Ä…danie zwrotu',0),(366486,10181,'bg','Ð˜ÑÐºÐ°Ð½Ðµ Ð·Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(366487,10181,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø±ÛŒÚº',0),(366488,10181,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ›Ð°Ñ˜',0),(366489,10181,'vi','YÃªu cáº§u bá»“i hoÃ n',0),(366490,10181,'af','Versoek terugbetaling',0),(366491,10181,'ro','Cerere de rambursare',0),(366492,10181,'et','Toetussummad',0),(366493,10181,'si','Zahteva povraÄilo',0),(366494,10181,'ba','Permintaan Reimbursement',0),(366495,10181,'nl','Vraag om een vergoeding',0),(366496,10181,'fi','Korvausta',0),(366497,10181,'no','Be om refusjon',0),(366498,10181,'da','Anmodning om refusion',0),(366499,10181,'ko','ë³´ìƒ ìš”ì²­',0),(366500,10181,'he','×‘×§×©×ª ×”×—×–×¨',0),(366501,10181,'el','Î‘Î¯Ï„Î·ÏƒÎ· ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚',0),(366502,10181,'zh','è¯·æ±‚å¿è¿˜\r\n',0),(366503,10181,'sv','BegÃ¤ra Ã¥terbetalning',0),(366504,10181,'it','Richiesta di rimborso',0),(366505,10181,'tl','',0),(366506,10181,'th','à¸‚à¸­à¹€à¸‡à¸´à¸™à¸„à¸·à¸™',0),(366507,10181,'hi','à¤…à¤¨à¥à¤°à¥‹à¤§ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤ªà¥‚à¤°à¥à¤¤à¤¿',0),(366508,10181,'ms','Permintaan bayaran balik',0),(366509,10181,'ar','Ø·Ù„Ø¨ ØªØ³Ø¯ÙŠØ¯',0),(366510,10181,'fr','Demande de remboursement',0),(366511,10181,'jp','å„Ÿé‚„ã‚’è¦æ±‚ã—ã¾ã™ã€‚',0),(366512,10181,'pt','SolicitaÃ§Ã£o de reembolso',0),(366513,10181,'ru','Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ñ‚ÑŒ Ð²Ð¾Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ñ',0),(366514,10181,'es','Solicitar Reembolso',0),(366515,10181,'de','Antrag Erstattung',0),(366516,10181,'en','Request Reimbursement',0),(366517,10182,'is','',0),(366518,10182,'dr','Ø´ØºÙ„ Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡ ',0),(366519,10182,'pr','Ø´ØºÙ„ Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡ ',0),(366520,10182,'tr','BaÅŸlatÄ±lan iÅŸ',0),(366521,10182,'pl','RozpoczÄ…Å‚ pracÄ™',0),(366522,10182,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð°Ð»Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(366523,10182,'ur','Ú©Ø§Ù… Ø´Ø±ÙˆØ¹ Ú©ÛŒÛ’ Û”',0),(366524,10182,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½ÑƒÐ¾ Ð¿Ð¾ÑÐ°Ð¾',0),(366525,10182,'vi','Báº¯t Ä‘áº§u cÃ´ng viá»‡c',0),(366526,10182,'af','Begin werk',0),(366527,10182,'ro','A Ã®nceput Job',0),(366528,10182,'et','Alustatud tÃ¶Ã¶d',0),(366529,10182,'si','ZaÄel delo',0),(366530,10182,'ba','Pekerjaan dimulai',0),(366531,10182,'nl','Gestarte baan',0),(366532,10182,'fi','Alkoi tyÃ¶',0),(366533,10182,'no','Startet jobben',0),(366534,10182,'da','Igangsatte Job',0),(366535,10182,'ko','ì‹œìž‘ëœ ìž‘ì—…',0),(366536,10182,'he','×”×¢×‘×•×“×” ×”×ª×—×™×œ×”',0),(366537,10182,'el','Î†ÏÏ‡Î¹ÏƒÎµ Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(366538,10182,'zh','å¼€å§‹çš„å·¥ä½œ\r\n',0),(366539,10182,'sv','BÃ¶rjade jobb',0),(366540,10182,'it','Lavoro iniziato',0),(366541,10182,'tl','',0),(366542,10182,'th','à¸‡à¸²à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(366543,10182,'hi','à¤¶à¥à¤°à¥‚ à¤•à¤° à¤¨à¥Œà¤•à¤°à¥€',0),(366544,10182,'ms','Memulakan kerja',0),(366545,10182,'ar','Ø¨Ø¯Ø£Øª Ø§Ù„Ù…Ù‡Ù…Ø©',0),(366546,10182,'fr','Travail commencÃ©',0),(366547,10182,'jp','ã‚¸ãƒ§ãƒ–ã‚’é–‹å§‹ã—ã¾ã—ãŸ',0),(366548,10182,'pt','Trabalho comeÃ§ou',0),(366549,10182,'ru','ÐÐ°Ñ‡Ð°Ð» Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(366550,10182,'es','Se ComenzÃ³ el Trabajo',0),(366551,10182,'de','Gestartete Job',0),(366552,10182,'en','Started Job',0),(366553,10183,'is','',0),(366554,10183,'dr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡',0),(366555,10183,'pr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡',0),(366556,10183,'tr','Ä°ÅŸ emri baÅŸladÄ±',0),(366557,10183,'pl','ZaczÄ…Å‚ zlecenie',0),(366558,10183,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ°',0),(366559,10183,'ur','ØªØ±ØªÛŒØ¨ Ú©Ø§Ù… Ø´Ø±ÙˆØ¹ Ú©Ø± Ø¯ÛŒØ§',0),(366560,10183,'sr','ÐŸÐ¾Ñ‡ÐµÐ¾ Ñ€Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(366561,10183,'vi','Báº¯t Ä‘áº§u Ä‘Æ¡n Ä‘áº·t hÃ ng lÃ m viá»‡c',0),(366562,10183,'af','Begin Werkbestelling',0),(366563,10183,'ro','A Ã®nceput comanda de lucru',0),(366564,10183,'et','Alustas tÃ¶Ã¶d jÃ¤rjekorras',0),(366565,10183,'si','ZaÄel delovni nalog',0),(366566,10183,'ba','Mulai urutan kerja',0),(366567,10183,'nl','Begon werkorder',0),(366568,10183,'fi','Alkoi TyÃ¶tilaus',0),(366569,10183,'no','Startet Arbeidsordre',0),(366570,10183,'da','Startet arbejde rÃ¦kkefÃ¸lge',0),(366571,10183,'ko','ìž‘ì—… ì£¼ë¬¸ ì‹œìž‘',0),(366572,10183,'he','×”×ª×—×™×œ ×¡×“×¨ ×”×¢×‘×•×“×”',0),(366573,10183,'el','ÎžÎµÎºÎ¯Î½Î·ÏƒÎµ Ï„Î·Î½ ÎµÎ½Ï„Î¿Î»Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(366574,10183,'zh','å¼€å§‹å·¥ä½œç§©åº\r\n',0),(366575,10183,'sv','BÃ¶rjade arbetsorder',0),(366576,10183,'it','Iniziato il lavoro di ordine',0),(366577,10183,'tl','',0),(366578,10183,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™',0),(366579,10183,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤•à¤¾à¤® à¤¶à¥à¤°à¥‚ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(366580,10183,'ms','Memulakan kerja',0),(366581,10183,'ar','Ø¨Ø¯Ø£ Ø¹Ù…Ù„ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(366582,10183,'fr','CommencÃ© le bon de travail',0),(366583,10183,'jp','ä½œæ¥­æ³¨æ–‡ã‚’é–‹å§‹',0),(366584,10183,'pt','ComeÃ§ou a ordem de serviÃ§o',0),(366585,10183,'ru','ÐÐ°Ñ‡Ð°Ð» Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°',0),(366586,10183,'es','Se ComenzÃ³ el Orden del Trabajo',0),(366587,10183,'de','Arbeitsauftrag gestartet',0),(366588,10183,'en','Started Work Order',0),(366589,10184,'is','',0),(366590,10184,'dr','Ø´Ø±ÙˆØ¹ ÙƒØ§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(366591,10184,'pr','Ø´Ø±ÙˆØ¹ ÙƒØ§Ø± Ø¬Ø¯ÙŠØ¯ ',0),(366592,10184,'tr','Yeni bir iÅŸe baÅŸlamak',0),(366593,10184,'pl','RozpoczÄ™ciem nowej pracy',0),(366594,10184,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(366595,10184,'ur','Ù†ÛŒØ§ Ú©Ø§Ù… Ø´Ø±ÙˆØ¹ Ú©Ø±ÛŒÚº',0),(366596,10184,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð¿Ð¾ÑÐ»Ð°',0),(366597,10184,'vi','Báº¯t Ä‘áº§u cÃ´ng viá»‡c má»›i',0),(366598,10184,'af','Begin Nuwe Werk',0),(366599,10184,'ro','ÃŽncepe noua lucrare',0),(366600,10184,'et','Alusta uut tÃ¶Ã¶d',0),(366601,10184,'si','ZaÄetek novega dela',0),(366602,10184,'ba','Memulai pekerjaan baru',0),(366603,10184,'nl','Nieuwe aan de slag',0),(366604,10184,'fi','Aloittaa uusi tyÃ¶',0),(366605,10184,'no','Starte nye arbeidet',0),(366606,10184,'da','Start nye arbejde',0),(366607,10184,'ko','ìƒˆë¡œìš´ ì¼ì„ ì‹œìž‘',0),(366608,10184,'he','×œ×”×ª×—×™×œ ×¢×‘×•×“×” ×—×“×©×”',0),(366609,10184,'el','ÎˆÎ½Î±ÏÎ¾Î· Î½Î­Ï‰Î½ ÎµÏÎ³Î±ÏƒÎ¹ÏŽÎ½',0),(366610,10184,'zh','å¼€å§‹æ–°å·¥ä½œ\r\n',0),(366611,10184,'sv','Starta nytt arbete',0),(366612,10184,'it','Iniziare il nuovo lavoro',0),(366613,10184,'tl','',0),(366614,10184,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸—à¸³à¸‡à¸²à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(366615,10184,'hi','à¤¨à¤ à¤•à¤¾à¤® à¤¶à¥à¤°à¥‚',0),(366616,10184,'ms','Mula kerja baru',0),(366617,10184,'ar','Ø¨Ø¯Ø¡ Ø¹Ù…Ù„ Ø¬Ø¯ÙŠØ¯',0),(366618,10184,'fr','Entreprendre de nouveaux travaux',0),(366619,10184,'jp','æ–°ã—ã„ä»•äº‹ã‚’å§‹ã‚ã‚‹',0),(366620,10184,'pt','ComeÃ§ar a trabalhar de novo',0),(366621,10184,'ru','ÐÐ°Ñ‡Ð°Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(366622,10184,'es','Comienza el Nuevo Trabajo',0),(366623,10184,'de','Neue Arbeit beginnen',0),(366624,10184,'en','Start New Work',0),(366625,10185,'is','',0),(366626,10185,'dr','ØªØ§ÙŠÙŠØ¯ ØªÙ‚Ø§Ø¶Ø§Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ',0),(366627,10185,'pr','ØªØ§ÙŠÙŠØ¯ ØªÙ‚Ø§Ø¶Ø§Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ',0),(366628,10185,'tr','Ä°zin isteklerini onaylama',0),(366629,10185,'pl','Zatwierdzanie czas wyÅ‚Ä…czyÄ‡ Å¼Ä…dania',0),(366630,10185,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÐ²Ð° Ð¿Ð¾Ñ‡Ð¸Ð²ÐºÐ° Ð¸ÑÐºÐ°Ð½Ð¸Ñ',0),(366631,10185,'ur','Ø¯ÙˆØ± Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº Ù…Ù†Ø¸ÙˆØ±',0),(366632,10185,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ',0),(366633,10185,'vi','Cháº¥p thuá»‡n yÃªu cáº§u thá»i gian ngÆ°ng',0),(366634,10185,'af','Keur Tyd-Af Versoeke Goed',0),(366635,10185,'ro','Aproba timp cereri',0),(366636,10185,'et','TÃ¶Ã¶lt Ã¤ra taotlused heaks kiitma',0),(366637,10185,'si','Odobriti odsotnost zahteve',0),(366638,10185,'ba','Menyetujui masa Off permintaan',0),(366639,10185,'nl','Goedkeuren van verlof aanvragen',0),(366640,10185,'fi','HyvÃ¤ksy-ajan pyynnÃ¶t',0),(366641,10185,'no','Godkjenne fritidsforespÃ¸rsler',0),(366642,10185,'da','Godkende Afspadsering anmodninger',0),(366643,10185,'ko','ì‹œê°„ ìš”ì²­ì„ ìŠ¹ì¸',0),(366644,10185,'he','×œ××©×¨ ×—×•×¤×© ×‘×§×©×•×ª',0),(366645,10185,'el','Î•Î³ÎºÏÎ¯Î½ÎµÎ¹ Î±Ï€Î¿Ï…ÏƒÎ¹Î¬ÏƒÎ¿Ï…Î½ Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚',0),(366646,10185,'zh','è¯·æ±‚æ‰¹å‡†ä¼‘å‡\r\n',0),(366647,10185,'sv','GodkÃ¤nna begÃ¤ran om ledighet',0),(366648,10185,'it','Approvare il tempo fuori le richieste',0),(366649,10185,'tl','',0),(366650,10185,'th','à¹€à¸§à¸¥à¸²à¸­à¸­à¸à¸„à¸³à¸‚à¸­à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(366651,10185,'hi','à¤¸à¤®à¤¯ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¬à¤‚à¤¦ à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€',0),(366652,10185,'ms','Meluluskan masa Off permintaan',0),(366653,10185,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø·Ù„Ø¨Ø§Øª Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ù…Ø³ØªÙ‚Ø·Ø¹',0),(366654,10185,'fr','Approuver les demandes de congÃ©',0),(366655,10185,'jp','å®Ÿåƒå¤–æ™‚é–“è¦æ±‚ã‚’æ‰¿èªã—ã¾ã™ã€‚',0),(366656,10185,'pt','Aprovar a folga do pedidos',0),(366657,10185,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð²',0),(366658,10185,'es','Aprueba Peticiones para Tiempo Libre',0),(366659,10185,'de','Freistellung von der Anfragen zu genehmigen',0),(366660,10185,'en','Approve Time Off Requests',0),(366661,10186,'is','',0),(366662,10186,'dr','Ø«Ø¨Øª Ø³Ø§Ø¹Ø§Øª ',0),(366663,10186,'pr','Ø«Ø¨Øª Ø³Ø§Ø¹Ø§Øª ',0),(366664,10186,'tr','Saat girin',0),(366665,10186,'pl','WprowadÅº godzin',0),(366666,10186,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ‡Ð°ÑÐ°',0),(366667,10186,'ur','Ú¯Ú¾Ù†Ù¹Û’ Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(366668,10186,'sr','Ð£Ð½Ð¾Ñ ÑÐ°Ñ‚Ð¸',0),(366669,10186,'vi','nháº­p so giá»',0),(366670,10186,'af','Ure Invoer',0),(366671,10186,'ro','IntroduceÅ£i ore',0),(366672,10186,'et','Tundide sisestamine',0),(366673,10186,'si','Vnesite ur',0),(366674,10186,'ba','Masukkan jam',0),(366675,10186,'nl','Uren invoeren',0),(366676,10186,'fi','Tuntien',0),(366677,10186,'no','Angi timer',0),(366678,10186,'da','Angiv timer',0),(366679,10186,'ko','ì‹œê°„ ìž…ë ¥',0),(366680,10186,'he','×”×–×Ÿ ×©×¢×•×ª',0),(366681,10186,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ ÏŽÏÎµÏ‚',0),(366682,10186,'zh','è¾“å…¥å°æ—¶',0),(366683,10186,'sv','Ange timmar',0),(366684,10186,'it','Immettere le ore',0),(366685,10186,'tl','',0),(366686,10186,'th','à¸›à¹‰à¸­à¸™à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡',0),(366687,10186,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(366688,10186,'ms','Masukkan jam',0),(366689,10186,'ar','Ø£Ø¯Ø®Ù„ Ø³Ø§Ø¹Ø§Øª',0),(366690,10186,'fr','Entrez les heures',0),(366691,10186,'jp','æ™‚é–“ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(366692,10186,'pt','Inserir horas',0),(366693,10186,'ru','Ð’Ð²ÐµÑÑ‚Ð¸ Ð§Ð°ÑÑ‹',0),(366694,10186,'es','Horas de Entrada',0),(366695,10186,'de','Geben Sie Stunden',0),(366696,10186,'en','Enter Hours',0),(366697,10187,'is','',0),(366698,10187,'dr','Ø«Ø¨Øª Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª',0),(366699,10187,'pr','Ø«Ø¨Øª Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª',0),(366700,10187,'tr','Geri Ã¶deme girin',0),(366701,10187,'pl','WprowadÅº zwroty',0),(366702,10187,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ð¸Ñ',0),(366703,10187,'ur','Ø±ÛŒØ§Ù…Ø¨Ø±Ø³Ù…Ù†Ù¹Ø³ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(366704,10187,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð°ÐºÐ½Ð°Ð´Ð°Ð¼Ð° ÑˆÑ‚ÐµÑ‚Ðµ',0),(366705,10187,'vi','nháº­p sá»± hoÃ n láº¡i',0),(366706,10187,'af','Tik Reimbursements',0),(366707,10187,'ro','IntroduceÅ£i rambursÄƒri',0),(366708,10187,'et','Sisestage tagasimaksed',0),(366709,10187,'si','Vnesite povraÄil',0),(366710,10187,'ba','Masukkan reimbursement',0),(366711,10187,'nl','Invoeren van vergoedingen',0),(366712,10187,'fi','Kirjoita korvaukset',0),(366713,10187,'no','Angi refusjoner',0),(366714,10187,'da','Angiv refusion',0),(366715,10187,'ko','í™˜ê¸‰ì„ ìž…ë ¥',0),(366716,10187,'he','×”×–×Ÿ ×”×—×–×¨',0),(366717,10187,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î­Ï‚',0),(366718,10187,'zh','è¾“å…¥å¿è¿˜',0),(366719,10187,'sv','Ange Ã¥terbetalningar',0),(366720,10187,'it','Immettere i rimborsi',0),(366721,10187,'tl','',0),(366722,10187,'th','à¸›à¹‰à¸­à¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¸·à¸™',0),(366723,10187,'hi','à¤ªà¥ˆà¤¸à¥‡ à¤•à¥€ à¤µà¤¾à¤ªà¤¸à¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(366724,10187,'ms','Masukkan pembayaran balik',0),(366725,10187,'ar','Ù‚Ù… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³Ø¯Ø¯Ø©',0),(366726,10187,'fr','Entrez les remboursements',0),(366727,10187,'jp','æ‰•ã„æˆ»ã—ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(366728,10187,'pt','Insira os reembolsos',0),(366729,10187,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð²Ð¾Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ñ',0),(366730,10187,'es','Entrar Reembolsos',0),(366731,10187,'de','Geben Sie Erstattungen',0),(366732,10187,'en','Enter Reimbursements',0),(366733,10188,'is','',0),(366734,10188,'dr','Ø«Ø¨Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ',0),(366735,10188,'pr','Ø«Ø¨Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ',0),(366736,10188,'tr','Ä°stek saati girin',0),(366737,10188,'pl','WprowadÅº czas wyÅ‚Ä…czyÄ‡ Å¼Ä…dania',0),(366738,10188,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ‡Ð°Ñ Ñ€Ð°Ð·ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð¾Ñ‚ Ð·Ð°ÑÐ²ÐºÐ¸',0),(366739,10188,'ur','Ø¯ÙˆØ± Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(366740,10188,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð²Ñ€ÐµÐ¼Ðµ ÑÐ° Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð¸Ð¼Ð°',0),(366741,10188,'vi','nháº­p Ä‘á» nghá»‹ nghá»‰',0),(366742,10188,'af','Invoer van Tyd-Af Versoek',0),(366743,10188,'ro','Intre timp cereri',0),(366744,10188,'et','Sisestage aeg maha taotlused',0),(366745,10188,'si','Vnesite Äas Off zahteve',0),(366746,10188,'ba','Memasuki masa Off permintaan',0),(366747,10188,'nl','Voer tijd uit aanvragen',0),(366748,10188,'fi','Kirjoita ajan pyynnÃ¶t',0),(366749,10188,'no','Angi fritid forespÃ¸rsler',0),(366750,10188,'da','Angiv Afspadsering anmodninger',0),(366751,10188,'ko','ìš”ì²­ ì‹œê°„ ìž…ë ¥',0),(366752,10188,'he','×”×–×Ÿ ×—×•×¤×© ×‘×§×©×•×ª',0),(366753,10188,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î¿ Ï‡ÏÏŒÎ½Î¿ Î±Î¹Ï„Î®Î¼Î±Ï„Î±',0),(366754,10188,'zh','è¾“å…¥è¯·å‡è¯·æ±‚',0),(366755,10188,'sv','Ange tid av fÃ¶rfrÃ¥gningar',0),(366756,10188,'it','Inserire ora fuori le richieste',0),(366757,10188,'tl','',0),(366758,10188,'th','à¸›à¹‰à¸­à¸™à¹€à¸§à¸¥à¸²à¸›à¸´à¸”à¸„à¸³à¸‚à¸­',0),(366759,10188,'hi','à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¬à¤‚à¤¦ à¤¸à¤®à¤¯ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(366760,10188,'ms','Masukkan masa Off permintaan',0),(366761,10188,'ar','Ø¥Ø¯Ø®Ø§Ù„ ÙˆÙ‚Øª Ø¥ÙŠÙ‚Ø§Ù Ø§Ù„Ø·Ù„Ø¨Ø§Øª',0),(366762,10188,'fr','Entrez les demandes',0),(366763,10188,'jp','å®Ÿåƒå¤–æ™‚é–“è¦æ±‚ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(366764,10188,'pt','Digite o tempo fora solicitaÃ§Ãµes',0),(366765,10188,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð²Ñ€ÐµÐ¼Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð²',0),(366766,10188,'es','Entrar Solicitudes del Tiempo Libre',0),(366767,10188,'de','Geben Sie Zeit Anfragen',0),(366768,10188,'en','Enter Time Off Requests',0),(366769,10189,'is','',0),(366770,10189,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¬Ø¯ÙˆÙ„ Ø²Ù…Ø§Ù† Ù…Ø±Ø®ØµÙŠ',0),(366771,10189,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¬Ø¯ÙˆÙ„ Ø²Ù…Ø§Ù† Ù…Ø±Ø®ØµÙŠ',0),(366772,10189,'tr','GÃ¶steri zamanÄ± kapatma zamanlamasÄ±',0),(366773,10189,'pl','PokaÅ¼ czas poza harmonogramem',0),(366774,10189,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²Ñ€ÐµÐ¼Ðµ Ð¸Ð·Ð²ÑŠÐ½ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(366775,10189,'ur','Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ÛŒ Ø³Û’ Ø¯ÙÙˆØ± ÙˆÙ‚Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(366776,10189,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð²Ñ€ÐµÐ¼Ðµ ÐžÑ„Ñ„ Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´',0),(366777,10189,'vi','Thá»ƒ hiá»‡n lá»‹ch táº¯t thá»i gian',0),(366778,10189,'af','Wys Tyd-Af Skedule',0),(366779,10189,'ro','Timp AratÄƒ Off program',0),(366780,10189,'et','Teatrietenduse maha ajakava',0),(366781,10189,'si','PokaÅ¾i Äas Off urnik',0),(366782,10189,'ba','Menampilkan waktu dari jadwal',0),(366783,10189,'nl','Toon tijd schema',0),(366784,10189,'fi','NÃ¤ytÃ¤ aika kalenteri',0),(366785,10189,'no','Vis tid av tidsplan',0),(366786,10189,'da','Vis tid Off tidsplan',0),(366787,10189,'ko','ì¼ì •ì—ì„œ ì‹œê°„ í‘œì‹œ',0),(366788,10189,'he','×”×¦×’ ×–×ž×Ÿ ×ž×œ×•×— ×”×–×ž× ×™×',0),(366789,10189,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï‡ÏÏŒÎ½Î¿Ï… Î±Ï€ÏŒ Ï„Î¿ Ï‡ÏÎ¿Î½Î¿Î´Î¹Î¬Î³ÏÎ±Î¼Î¼Î±',0),(366790,10189,'zh','æ˜¾ç¤ºä¼‘é—²æ—¶é—´æ—¶é—´å®‰æŽ’\r\n',0),(366791,10189,'sv','Visa tid bort schemat',0),(366792,10189,'it','Tempo di spettacolo fuori programma',0),(366793,10189,'tl','',0),(366794,10189,'th','à¹à¸ªà¸”à¸‡à¹€à¸§à¸¥à¸²à¸ˆà¸²à¸à¸à¸³à¸«à¸™à¸”à¸à¸²à¸£',0),(366795,10189,'hi','à¤¶à¥‹ à¤¸à¤®à¤¯ à¤…à¤¨à¥à¤¸à¥‚à¤šà¥€ à¤¬à¤‚à¤¦',0),(366796,10189,'ms','Masa Show Off Jadual',0),(366797,10189,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙˆÙ‚Øª Ù‚Ø¨Ø§Ù„Ø© Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø²Ù…Ù†ÙŠ',0),(366798,10189,'fr','Afficher le temps hors calendrier',0),(366799,10189,'jp','ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ«ã‚’ã‚ªãƒ•æ™‚é–“ã‚’è¡¨ç¤º',0),(366800,10189,'pt','Hora do show horÃ¡rio',0),(366801,10189,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ Ñ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ¾Ð¼',0),(366802,10189,'es','Mostrar Agenda de Tiemp Libre',0),(366803,10189,'de','Karte-Freizeit Zeitplan',0),(366804,10189,'en','Show Time Off Schedule',0),(366805,10190,'is','',0),(366806,10190,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(366807,10190,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(366808,10190,'tr','Bill gÃ¶rÃ¼nÃ¼mÃ¼',0),(366809,10190,'pl','Bill widok',0),(366810,10190,'bg','Ð‘Ð¸Ð» Ð¸Ð·Ð³Ð»ÐµÐ´',0),(366811,10190,'ur','Ø¨Ù„ Ù…Ù†Ø¸Ø±',0),(366812,10190,'sr','Ð‘Ð¸Ð» Ð¿Ñ€Ð¸ÐºÐ°Ð·',0),(366813,10190,'vi','Xem hÃ³a Ä‘Æ¡n',0),(366814,10190,'af','Wetsontwerp bekyk',0),(366815,10190,'ro','Bill Vezi',0),(366816,10190,'et','Bill vaade',0),(366817,10190,'si','Bill pogled',0),(366818,10190,'ba','Lihat Bill',0),(366819,10190,'nl','Bill weergave',0),(366820,10190,'fi','Bill Katso',0),(366821,10190,'no','Bill visning',0),(366822,10190,'da','Bill Se',0),(366823,10190,'ko','ë¹Œ ë³´ê¸°',0),(366824,10190,'he','×”×¦×’ ×—×©×‘×•×Ÿ',0),(366825,10190,'el','Bill Î¸Î­Î±',0),(366826,10190,'zh','å¸å•å®¡æ ¸\r\n',0),(366827,10190,'sv','Bill Visa',0),(366828,10190,'it','Vista di Bill',0),(366829,10190,'tl','',0),(366830,10190,'th','à¸¡à¸¸à¸¡à¸¡à¸­à¸‡à¸£à¸²à¸¢à¸à¸²à¸£',0),(366831,10190,'hi','à¤¬à¤¿à¤² à¤¦à¥‡à¤–à¥‡à¤‚',0),(366832,10190,'ms','Lihat Rang undang-undang',0),(366833,10190,'ar','Ø¹Ø±Ø¶ Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(366834,10190,'fr','Vue de Bill',0),(366835,10190,'jp','æ³•æ¡ˆãƒ“ãƒ¥ãƒ¼',0),(366836,10190,'pt','Bill View',0),(366837,10190,'ru','Ð‘Ð¸Ð»Ð» Ð²Ð¸Ð´',0),(366838,10190,'es','Vista de Factura',0),(366839,10190,'de','Bill anzeigen',0),(366840,10190,'en','Bill View',0),(366841,10191,'is','',0),(366842,10191,'dr','Ø³Ù† Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ',0),(366843,10191,'pr','Ø³Ù† Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ',0),(366844,10191,'tr','Retainage',0),(366845,10191,'pl','Retainage',0),(366846,10191,'bg','Retainage',0),(366847,10191,'ur','Ø±ÛŒÙ¹Ø§ÛŒÙ†Ø§Ø¬',0),(366848,10191,'sr','Ð ÐµÑ‚Ð°Ð¸Ð½Ð°Ð³Ðµ',0),(366849,10191,'vi','giá»¯ láº¡i',0),(366850,10191,'af','Retainage',0),(366851,10191,'ro','Retainage',0),(366852,10191,'et','Retainage',0),(366853,10191,'si','Retainage',0),(366854,10191,'ba','Retainage',0),(366855,10191,'nl','Retainage',0),(366856,10191,'fi','PidÃ¤tys',0),(366857,10191,'no','Retainage',0),(366858,10191,'da','Tilbageholdelse',0),(366859,10191,'ko','Retainage',0),(366860,10191,'he','Retainage',0),(366861,10191,'el','Retainage',0),(366862,10191,'zh','ä¿ç•™é‡‘\r\n',0),(366863,10191,'sv','InnehÃ¥llet belopp',0),(366864,10191,'it','Retainage',0),(366865,10191,'tl','',0),(366866,10191,'th','à¹€à¸‡à¸´à¸™à¸›à¸£à¸°à¸à¸±à¸™',0),(366867,10191,'hi','Retainage',0),(366868,10191,'ms','Retainage',0),(366869,10191,'ar','Ù„Ù‚Ø¯',0),(366870,10191,'fr','Retenue de garantie',0),(366871,10191,'jp','Retainage',0),(366872,10191,'pt','Pluviais',0),(366873,10191,'ru','ÐšÐ¾Ð¼Ð¼ÑŒÑŽÐ½Ð¸ÐºÐµÐ¹ÑˆÐ½',0),(366874,10191,'es','Anticipos',0),(366875,10191,'de','Retainage',0),(366876,10191,'en','Retainage',0),(366877,10192,'is','',0),(366878,10192,'dr','Ù…Ø±ØªØ¨ Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(366879,10192,'pr','Ù…Ø±ØªØ¨ Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(366880,10192,'tr','TarafÄ±ndan sipariÅŸ',0),(366881,10192,'pl','ZamÃ³wione przez',0),(366882,10192,'bg','ÐŸÐ¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸ Ð¿Ð¾',0),(366883,10192,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(366884,10192,'sr','ÐŸÐ¾ Ð½Ð°Ñ€ÐµÐ´Ð±Ð¸',0),(366885,10192,'vi','Ä‘Æ°á»£c Ä‘áº·t hÃ ng bá»Ÿi',0),(366886,10192,'af','Bestel Deur',0),(366887,10192,'ro','Comandate de',0),(366888,10192,'et','Tellitud',0),(366889,10192,'si','Odredi',0),(366890,10192,'ba','Diperintahkan oleh',0),(366891,10192,'nl','Gerangschikt',0),(366892,10192,'fi','Tilata',0),(366893,10192,'no','Bestilt av',0),(366894,10192,'da','Bestilt af',0),(366895,10192,'ko','ì— ì˜í•´ ì£¼ë¬¸',0),(366896,10192,'he','×”×•×–×ž×Ÿ ×¢\"×™',0),(366897,10192,'el','Î Î±ÏÎ±Î³Î³Î­Î»Î¸Î·ÎºÎµ Î±Ï€ÏŒ',0),(366898,10192,'zh','æŒ‰æŽ’åº\r\n',0),(366899,10192,'sv','BestÃ¤llt av',0),(366900,10192,'it','Ordinati',0),(366901,10192,'tl','',0),(366902,10192,'th','à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¹‚à¸”à¸¢',0),(366903,10192,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾',0),(366904,10192,'ms','Diperintahkan oleh',0),(366905,10192,'ar','ÙˆØ£Ù…Ø±Øª Ø¨Ù‡Ø§',0),(366906,10192,'fr','TriÃ©s par',0),(366907,10192,'jp','é †ã«ä¸¦ã¹æ›¿ãˆ',0),(366908,10192,'pt','Ordenados por',0),(366909,10192,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð¾',0),(366910,10192,'es','Ordenado Por',0),(366911,10192,'de','Geordnet nach',0),(366912,10192,'en','Ordered By',0),(366913,10193,'is','',0),(366914,10193,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³Ø·Ø± Ø¬Ø²Ø¦ÙŠØ§Øª Ø¯Ø± ØªÙ‡ Ú†Ú© ',0),(366915,10193,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³Ø·Ø± Ø¬Ø²Ø¦ÙŠØ§Øª Ø¯Ø± ØªÙ‡ Ú†Ú© ',0),(366916,10193,'tr','Saplama Ã¼zerinde satÄ±r ayrÄ±ntÄ±larÄ± gÃ¶ster',0),(366917,10193,'pl','PokaÅ¼ szczegÃ³Å‚y linii na Stub',0),(366918,10193,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ñ‚ Ñ€ÐµÐ´Ð° Ð·Ð° Ð²ÑÐµ Ð¾Ñ‰Ðµ Ð¼ÑŠÐ½Ð¸Ñ‡Ðµ',0),(366919,10193,'ur','Ø¯Ø§Ú‘Ú¾ Ù¾Ø± Ù„Ø§Ø¦Ù† ØªÙØ§ØµÛŒÙ„ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(366920,10193,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð»Ð¸Ð½Ð¸Ñ˜Ñƒ Ð½Ð° Ð¾Ð´ÑÐµÑ‡Ð°Ðº',0),(366921,10193,'vi','Hiá»ƒn thá»‹ chi tiáº¿t dÃ²ng',0),(366922,10193,'af','Wys Lyn Besonderhede op Teenbladjie',0),(366923,10193,'ro','AfiÈ™are detalii linie pe ciot',0),(366924,10193,'et','NÃ¤ita rea Ã¼ksikasjad VÃ¤lislingid',0),(366925,10193,'si','PokaÅ¾i vrstico podrobnosti na Å¡tor',0),(366926,10193,'ba','Lihat rincian garis rintisan',0),(366927,10193,'nl','Toon lijn Details op Stub',0),(366928,10193,'fi','NÃ¤ytÃ¤ tiedot tynkÃ¤',0),(366929,10193,'no','Vis linjedetaljene pÃ¥ sta.',0),(366930,10193,'da','Vis Linjedetaljer pÃ¥ Stub',0),(366931,10193,'ko','ê·¸ ë£¨í„° ê¸°ì— ì„  ì •ë³´ ë³´ê¸°',0),(366932,10193,'he','×”×¦×’ ××ª ×¤×¨×˜×™ ×”×§×• ×¢×œ ×¡×¤×—',0),(366933,10193,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½ Î³ÏÎ±Î¼Î¼Î® ÏƒÏ„Î¿ ÏƒÏ„Î­Î»ÎµÏ‡Î¿Ï‚',0),(366934,10193,'zh','åœ¨å­˜æ ¹æ˜¾ç¤ºè¡Œè¯¦æƒ…\r\n',0),(366935,10193,'sv','Visa Detaljer fÃ¶r pÃ¥ Stub',0),(366936,10193,'it','Visualizza i dettagli di linea sulla Stub',0),(366937,10193,'tl','',0),(366938,10193,'th','à¹à¸ªà¸”à¸‡à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸™ Stub',0),(366939,10193,'hi','à¤¸à¥à¤Ÿà¤¬ à¤ªà¤° à¤²à¤¾à¤‡à¤¨ à¤µà¤¿à¤µà¤°à¤£ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(366940,10193,'ms','Menunjukkan butir-butir garis pada tunas',0),(366941,10193,'ar','Ø¥Ø¸Ù‡Ø§Ø± ØªÙØ§ØµÙŠÙ„ Ø®Ø· ÙÙŠ ÙƒØ¹Ø¨ Ø§Ù„Ø±ÙˆØªÙŠÙ†',0),(366942,10193,'fr','Afficher les dÃ©tails en ligne sur le talon',0),(366943,10193,'jp','ã‚¹ã‚¿ãƒ–ã«è¡Œã®è©³ç´°ã‚’è¡¨ç¤º',0),(366944,10193,'pt','Mostrar detalhes de linha no esboÃ§o',0),(366945,10193,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð»Ð¸Ð½Ð¸Ð¸ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð½Ð° Ð·Ð°Ð³Ð»ÑƒÑˆÐºÐ¸',0),(366946,10193,'es','Mostrar Detalles de Linea de Ficha',0),(366947,10193,'de','Zeigen Sie Linie Details zum Stub',0),(366948,10193,'en','Show Line Details On Stub',0),(366949,10194,'is','',0),(366950,10194,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§Ù‰ Ø³Ø±Ù…Ø§ÙŠÙ‡ Ø§Ù‰',0),(366951,10194,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§Ù‰ Ø³Ø±Ù…Ø§ÙŠÙ‡ Ø§Ù‰',0),(366952,10194,'tr','Sermaye giderleri',0),(366953,10194,'pl','NakÅ‚ady kapitaÅ‚owe',0),(366954,10194,'bg','ÐšÐ°Ð¿Ð¸Ñ‚Ð°Ð»Ð¾Ð²Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(366955,10194,'ur','Ø¯Ø§Ø±Ø§Ù„Ø­Ú©ÙˆÙ…Øª Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(366956,10194,'sr','ÐšÐ°Ð¿Ð¸Ñ‚Ð°Ð»Ð½Ðµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ðµ',0),(366957,10194,'vi','Chi phÃ­  gÃ³p vá»‘n',0),(366958,10194,'af','Kapitale Uitgawes',0),(366959,10194,'ro','Cheltuielile de capital',0),(366960,10194,'et','Kapitalikulutused',0),(366961,10194,'si','Investicijski izdatki',0),(366962,10194,'ba','Belanja modal',0),(366963,10194,'nl','Kapitaaluitgaven',0),(366964,10194,'fi','Investoinnit',0),(366965,10194,'no','Investeringer',0),(366966,10194,'da','AnlÃ¦gsudgifter',0),(366967,10194,'ko','ìžë³¸ ì§€ì¶œ',0),(366968,10194,'he','×”×•×¦××•×ª ×”×•×Ÿ',0),(366969,10194,'el','ÎšÎµÏ†Î±Î»Î±Î¹Î±ÎºÎ­Ï‚ Î´Î±Ï€Î¬Î½ÎµÏ‚',0),(366970,10194,'zh','èµ„æœ¬æ”¯å‡º\r\n',0),(366971,10194,'sv','AnlÃ¤ggningskostnader',0),(366972,10194,'it','Spese in conto capitale',0),(366973,10194,'tl','',0),(366974,10194,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸—à¸¸à¸™',0),(366975,10194,'hi','à¤ªà¥‚à¤‚à¤œà¥€ à¤µà¥à¤¯à¤¯',0),(366976,10194,'ms','Perbelanjaan modal yang',0),(366977,10194,'ar','Ø§Ù„Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø±Ø£Ø³Ù…Ø§Ù„ÙŠØ©',0),(366978,10194,'fr','DÃ©penses en immobilisations',0),(366979,10194,'jp','è³‡æœ¬çš„æ”¯å‡º',0),(366980,10194,'pt','Gastos de capital',0),(366981,10194,'ru','ÐšÐ°Ð¿Ð¸Ñ‚Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(366982,10194,'es','Egresos de Capital',0),(366983,10194,'de','Investitionen in Sachanlagen',0),(366984,10194,'en','Capital Expenditures',0),(366985,10195,'is','',0),(366986,10195,'dr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯  Ùˆ Ù…Ø¹Ø§Ø¯Ù„Ù‡Ø§ÙŠ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯',0),(366987,10195,'pr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯  Ùˆ Ù…Ø¹Ø§Ø¯Ù„Ù‡Ø§ÙŠ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯',0),(366988,10195,'tr','Nakit ve nakit benzeri Varlâ€ºklar',0),(366989,10195,'pl','Åšrodki pieniÄ™Å¼ne i ekwiwalenty Å›rodkÃ³w pieniÄ™Å¼nych',0),(366990,10195,'bg','ÐŸÐ°Ñ€Ð¸ Ð¸ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ ÐµÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ð¸',0),(366991,10195,'ur','Ù†Ù‚Ø¯ Ø§ÙˆØ± Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©Û’ Ù…ØªØ±Ø§Ø¯Ù',0),(366992,10195,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ñƒ Ð¸ ÐµÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ðµ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ',0),(366993,10195,'vi','Tiá»n vÃ  tÆ°Æ¡ng Ä‘Æ°Æ¡ng tiá»n',0),(366994,10195,'af','Kontant en Kontant Ekwivalente',0),(366995,10195,'ro','Numerar ÅŸi echivalente de numerar',0),(366996,10195,'et','Raha ja raha ekvivalendid',0),(366997,10195,'si','Denar in denarni ustrezniki',0),(366998,10195,'ba','Kas dan setara kas',0),(366999,10195,'nl','Geldmiddelen en kasequivalenten',0),(367000,10195,'fi','Rahat ja pankkisaamiset',0),(367001,10195,'no','Betalingsmidler',0),(367002,10195,'da','Kontanter og likvide aktiver',0),(367003,10195,'ko','í˜„ê¸ˆ ë° í˜„ê¸ˆ ë“±ê°€ë¬¼',0),(367004,10195,'he','×ž×–×•×ž× ×™× ×•×©×•×•×™ ×ž×–×•×ž× ×™×',0),(367005,10195,'el','ÎœÎµÏ„ÏÎ·Ï„Î¬ ÎºÎ±Î¹ Î¹ÏƒÎ¿Î´ÏÎ½Î±Î¼Î± Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½',0),(367006,10195,'zh','çŽ°é‡‘åŠçŽ°é‡‘ç­‰å€¼\r\n',0),(367007,10195,'sv','Likvida medel',0),(367008,10195,'it','Liquide e mezzi equivalenti',0),(367009,10195,'tl','',0),(367010,10195,'th','à¹€à¸‡à¸´à¸™à¸ªà¸”à¹à¸¥à¸°à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸—à¸µà¸¢à¸šà¹€à¸—à¹ˆà¸²à¹€à¸‡à¸´à¸™à¸ªà¸”',0),(367011,10195,'hi','à¤¨à¤•à¤¦ à¤”à¤° à¤¨à¤•à¤¦à¥€ à¤¸à¤®à¤•à¤•à¥à¤·',0),(367012,10195,'ms','Tunai dan setara tunai',0),(367013,10195,'ar','Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© ÙˆØ´Ø¨Ù‡ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(367014,10195,'fr','EspÃ¨ces et quasi-espÃ¨ces',0),(367015,10195,'jp','ç¾é‡‘åŠã³ç¾é‡‘åŒç­‰ç‰©',0),(367016,10195,'pt','Caixa e equivalentes',0),(367017,10195,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¸ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ ÑÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ñ‹',0),(367018,10195,'es','Efectivo y Equivalentes',0),(367019,10195,'de','Zahlungsmittel und ZahlungsmittelÃ¤quivalente',0),(367020,10195,'en','Cash and Cash Equivalents',0),(367021,10196,'is','',0),(367022,10196,'dr','(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ) ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ ØªØ£Ù…ÙŠÙ† Ù…Ø§Ù„ÙŠ',0),(367023,10196,'pr','Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ø§Ø²(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ) ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ ØªØ£Ù…ÙŠÙ† Ù…Ø§Ù„ÙŠ',0),(367024,10196,'tr','Nakit akÄ±ÅŸÄ± (iÃ§in kullanÄ±lan) Ã¼zerinden finansman faaliyetleri',0),(367025,10196,'pl','PrzepÅ‚ywy Å›rodkÃ³w pieniÄ™Å¼nych z (uÅ¼ywane) finansowanie dziaÅ‚alnoÅ›ci',0),(367026,10196,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ð¾Ñ‚Ð¾Ðº Ð¾Ñ‚ (Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ Ð·Ð°) Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð¸ Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ð¸',0),(367027,10196,'ur','Ú©ÛŒØ´ ÙÙ„Ùˆ (Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„) Ø³Û’ Ø³Ø±Ú¯Ø±Ù…ÛŒÙˆÚº Ú©ÛŒ Ù…Ø§Ù„ÛŒ Ù…Ø¹Ø§ÙˆÙ†Øª',0),(367028,10196,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸ Ñ‚Ð¾Ðº Ð¸Ð· (Ñƒ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸) Ñ„Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€Ð°ÑšÐµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(367029,10196,'vi','LÆ°u chuyá»ƒn tiá»n tá»« (sá»­ dá»¥ng cho) hoáº¡t Ä‘á»™ng tÃ i chÃ­nh',0),(367030,10196,'af','Kontantvloei Van (Gebruik Vir)\r\nFinansieringsaktiwiteite',0),(367031,10196,'ro','Fluxul de numerar din (folosit pentru) activitÄƒÅ£i de finanÅ£are',0),(367032,10196,'et','(Kasutatakse) Rahavoog finantseerimistegevusest',0),(367033,10196,'si','Denarni tokovi iz (uporabljeni za) financiranje dejavnosti',0),(367034,10196,'ba','Arus kas dari (digunakan untuk) pembiayaan kegiatan',0),(367035,10196,'nl','Netto kasstroom uit (gebruikt voor) financieringsactiviteiten',0),(367036,10196,'fi','(KÃ¤ytetty) rahavirta rahoitustoiminnasta',0),(367037,10196,'no','KontantstrÃ¸m fra (benyttet For) finansieringsaktiviteter',0),(367038,10196,'da','PengestrÃ¸mme fra (brugt i) finansieringsaktivitet',0),(367039,10196,'ko','(ì‚¬ìš©)ì—ì„œ í˜„ê¸ˆ íë¦„ê³¼ ìž¬ë¬´ í™œë™',0),(367040,10196,'he','×ª×–×¨×™× ×ž×–×•×ž× ×™× ×ž (×ž×©×ž×©) ×ž×™×ž×•×Ÿ ×¤×¢×™×œ×•×™×•×ª',0),(367041,10196,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚ Î±Ï€ÏŒ (Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ¼ÎµÎ½Î± Î³Î¹Î±) Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„ÎµÏ‚ Ï‡ÏÎ·Î¼Î±Ï„Î¿Î´ÏŒÏ„Î·ÏƒÎ·Ï‚',0),(367042,10196,'zh','çŽ°é‡‘æµé‡ï¼ˆç”¨äºŽï¼‰èžèµ„æ´»åŠ¨\r\n',0),(367043,10196,'sv','KassaflÃ¶de frÃ¥n (anvÃ¤nds fÃ¶r) finansaktiviteter',0),(367044,10196,'it','Flusso di cassa da (usato per) attivitÃ  di finanziamento',0),(367045,10196,'tl','',0),(367046,10196,'th','à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¸ˆà¸²à¸ (à¹ƒà¸Šà¹‰à¹ƒà¸™) à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸ˆà¸±à¸”à¸«à¸²à¹€à¸‡à¸´à¸™',0),(367047,10196,'hi','(à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾) à¤¸à¥‡ à¤¨à¤•à¤¦à¥€ à¤ªà¥à¤°à¤µà¤¾à¤¹ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤µà¤¿à¤¤à¥à¤¤ à¤ªà¥‹à¤·à¤£',0),(367048,10196,'ms','Aliran tunai daripada (digunakan untuk) aktiviti pembiayaan',0),(367049,10196,'ar','Ø§Ù„ØªØ¯ÙÙ‚Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ù…Ù† (Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„) ØªÙ…ÙˆÙŠÙ„ Ø§Ù„Ø£Ù†Ø´Ø·Ø©',0),(367050,10196,'fr','Flux de trÃ©sorerie provenant des (affectÃ©s aux) activitÃ©s de financement',0),(367051,10196,'jp','ï¼ˆä½¿ç”¨ï¼‰ ã‹ã‚‰ã®ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ» ãƒ•ãƒ­ãƒ¼è²¡å‹™æ´»å‹•',0),(367052,10196,'pt','Cash Flow (usado para) atividades de financiamento',0),(367053,10196,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿Ð¾Ñ‚Ð¾Ðº Ð¾Ñ‚ (Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ) Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð¾Ð¹ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(367054,10196,'es','Flujo de Efectivo de (Usado Por) Actividades Financieros',0),(367055,10196,'de','Cash Flow aus (verwendet fÃ¼r) FinanzierungstÃ¤tigkeit',0),(367056,10196,'en','Cash Flow From (Used For) Financing Activities',0),(367057,10197,'is','',0),(367058,10197,'dr','(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ) ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ Ø³Ø±Ù…Ø§ÙŠÙ‡ Ú¯Ø°Ø§Ø±ÙŠ',0),(367059,10197,'pr','Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ø§Ø²(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ) ÙØ¹Ø§Ù„ÙŠØªÙ‡Ø§ÙŠ Ø³Ø±Ù…Ø§ÙŠÙ‡ Ú¯Ø°Ø§Ø±ÙŠ',0),(367060,10197,'tr','Nakit akÄ±ÅŸÄ± (iÃ§in kullanÄ±lan) Ã¼zerinden yatÄ±rÄ±m faaliyetleri',0),(367061,10197,'pl','PrzepÅ‚ywy Å›rodkÃ³w pieniÄ™Å¼nych z (uÅ¼ywane) dziaÅ‚alnoÅ›ci inwestycyjnej',0),(367062,10197,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ð¾Ñ‚Ð¾Ðº Ð¾Ñ‚ (Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ Ð·Ð°) Ð¸Ð½Ð²ÐµÑÑ‚Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ð¸',0),(367063,10197,'ur','Ú©ÛŒØ´ ÙÙ„Ùˆ (Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„) Ø³Û’ Ø³Ø±Ú¯Ø±Ù…ÛŒÙˆÚº Ú©ÛŒ Ø³Ø±Ù…Ø§ÛŒÛ Ú©Ø§Ø±ÛŒ',0),(367064,10197,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸ Ñ‚Ð¾Ðº Ð¸Ð· (Ñƒ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸) Ð¸Ð½Ð²ÐµÑÑ‚Ð¸Ñ€Ð°ÑšÐµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(367065,10197,'vi','LÆ°u chuyá»ƒn tiá»n tá»« (sá»­ dá»¥ng cho) hoáº¡t Ä‘á»™ng Ä‘áº§u tÆ°.',0),(367066,10197,'af','Kontantvloei Van (Gebruik Vir)\r\nBeleggingsaktiwiteite',0),(367067,10197,'ro','Fluxul de numerar din (folosit pentru) activitÄƒÅ£i de investiÅ£ii',0),(367068,10197,'et','(Kasutatakse) Rahavoog investeerimistegevusest kokku',0),(367069,10197,'si','Denarni tokovi iz (uporabljeni za) naloÅ¾benih dejavnosti',0),(367070,10197,'ba','Arus kas dari (digunakan untuk) kegiatan investasi',0),(367071,10197,'nl','Netto kasstroom uit (gebruikt voor) investeringsactiviteiten',0),(367072,10197,'fi','(KÃ¤ytetty) Kassavirta investointien',0),(367073,10197,'no','KontantstrÃ¸m fra (benyttet For) investeringsaktiviteter',0),(367074,10197,'da','PengestrÃ¸mme fra (anvendt i) investeringsaktivitet',0),(367075,10197,'ko','(ì‚¬ìš©)ì—ì„œ í˜„ê¸ˆ íë¦„ íˆ¬ìž í™œë™',0),(367076,10197,'he','×ª×–×¨×™× ×ž×–×•×ž× ×™× ×ž (×ž×©×ž×©) ×ž×©×§×™×¢×™× ×¤×¢×™×œ×•×™×•×ª',0),(367077,10197,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚ Î±Ï€ÏŒ (Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ¼ÎµÎ½Î± Î³Î¹Î±) ÎµÏ€ÎµÎ½Î´Ï…Ï„Î¹ÎºÎ­Ï‚ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„ÎµÏ‚',0),(367078,10197,'zh','çŽ°é‡‘æµé‡ï¼ˆç”¨äºŽï¼‰æŠ•èµ„æ´»åŠ¨\r\n',0),(367079,10197,'sv','KassaflÃ¶de frÃ¥n (anvÃ¤nds fÃ¶r) investeringsaktiviteter',0),(367080,10197,'it','Flusso di cassa da (usato per) attivitÃ  di investimento',0),(367081,10197,'tl','',0),(367082,10197,'th','à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¸ˆà¸²à¸ (à¹ƒà¸Šà¹‰à¹ƒà¸™) à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸¥à¸‡à¸—à¸¸à¸™',0),(367083,10197,'hi','(à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾) à¤¸à¥‡ à¤¨à¤•à¤¦à¥€ à¤ªà¥à¤°à¤µà¤¾à¤¹ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿à¤¯à¥‹à¤‚ à¤¨à¤¿à¤µà¥‡à¤¶',0),(367084,10197,'ms','Aliran tunai daripada (digunakan untuk) aktiviti pelaburan',0),(367085,10197,'ar','Ø§Ù„ØªØ¯ÙÙ‚Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ù…Ù† (Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„) Ø£Ù†Ø´Ø·Ø© Ø§Ù„Ø§Ø³ØªØ«Ù…Ø§Ø±',0),(367086,10197,'fr','Flux de trÃ©sorerie provenant des (affectÃ©s aux) activitÃ©s d\'investissement',0),(367087,10197,'jp','ï¼ˆä½¿ç”¨ï¼‰ ã‹ã‚‰ã®ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ» ãƒ•ãƒ­ãƒ¼æŠ•è³‡æ´»å‹•',0),(367088,10197,'pt','Cash Flow (usado para) atividades de investimento',0),(367089,10197,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿Ð¾Ñ‚Ð¾Ðº Ð¾Ñ‚ (Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ) Ð¸Ð½Ð²ÐµÑÑ‚Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(367090,10197,'es','Flujo de Efectivo de (Usado Por) Actividades de inversiÃ³n',0),(367091,10197,'de','Cash Flow aus (verwendet fÃ¼r) InvestitionstÃ¤tigkeit',0),(367092,10197,'en','Cash Flow From (Used For) Investing Activities',0),(367093,10198,'is','',0),(367094,10198,'dr','(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ) Ø¹Ù…Ù„ÙŠØ§Øª',0),(367095,10198,'pr','Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ø§Ø²(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ) Ø¹Ù…Ù„ÙŠØ§Øª',0),(367096,10198,'tr','Nakit akÄ±ÅŸÄ± (iÃ§in kullanÄ±lan) iÅŸlemleri',0),(367097,10198,'pl','PrzepÅ‚ywy Å›rodkÃ³w pieniÄ™Å¼nych z (uÅ¼ywane) operacji',0),(367098,10198,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ð¾Ñ‚Ð¾Ðº Ð¾Ñ‚ (Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ Ð·Ð°) Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(367099,10198,'ur','Ú©ÛŒØ´ ÙÙ„Ùˆ (Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„) Ø³Û’ Ø¢Ù¾Ø±ÛŒØ´Ù†',0),(367100,10198,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸ Ñ‚Ð¾Ðº Ð¸Ð· (Ñƒ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸) Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ñ˜Ðµ',0),(367101,10198,'vi','LÆ°u chuyá»ƒn tiá»n (sá»­ dá»¥ng cho) hoáº¡t Ä‘á»™ng hoáº¡t Ä‘á»™ng.',0),(367102,10198,'af','Kontantvloei Van (Gebruik Vir)\r\nBedrywighede',0),(367103,10198,'ro','Fluxul de numerar din (folosit pentru) operaÅ£iunile',0),(367104,10198,'et','Rahavoog (kasutatakse) operatsioonid',0),(367105,10198,'si','Denarni tokovi iz (uporabljeni za) poslovanja',0),(367106,10198,'ba','Arus kas dari (digunakan untuk) operasi',0),(367107,10198,'nl','Netto kasstroom uit (gebruikt voor) operaties',0),(367108,10198,'fi','Kassavirta (kÃ¤ytetty) toiminta',0),(367109,10198,'no','KontantstrÃ¸m fra (benyttet For) operasjoner',0),(367110,10198,'da','PengestrÃ¸mme fra (anvendt i) drift',0),(367111,10198,'ko','(ì‚¬ìš©)ì—ì„œ í˜„ê¸ˆ íë¦„ ìž‘ì—…',0),(367112,10198,'he','×ª×–×¨×™× ×ž×–×•×ž× ×™× ×ž (×ž×©×ž×©) ×¤×¢×•×œ×•×ª',0),(367113,10198,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚ Î±Ï€ÏŒ (Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ¼ÎµÎ½Î± Î³Î¹Î±) ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚',0),(367114,10198,'zh','çŽ°é‡‘æµé‡ï¼ˆç”¨äºŽï¼‰è¥è¿\r\n',0),(367115,10198,'sv','KassaflÃ¶de frÃ¥n (anvÃ¤nds fÃ¶r) verksamhet',0),(367116,10198,'it','Flusso di cassa da (usato per) le operazioni',0),(367117,10198,'tl','',0),(367118,10198,'th','à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¸ˆà¸²à¸ (à¹ƒà¸Šà¹‰à¹ƒà¸™) à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸‡à¸²à¸™',0),(367119,10198,'hi','(à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾) à¤¸à¥‡ à¤¨à¤•à¤¦à¥€ à¤ªà¥à¤°à¤µà¤¾à¤¹ à¤¸à¤‚à¤šà¤¾à¤²à¤¨',0),(367120,10198,'ms','Aliran tunai daripada (digunakan untuk) operasi',0),(367121,10198,'ar','Ø§Ù„ØªØ¯ÙÙ‚Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ù…Ù† (Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„) Ø¹Ù…Ù„ÙŠØ§Øª',0),(367122,10198,'fr','Flux de trÃ©sorerie provenant des (affectÃ©s aux) activitÃ©s',0),(367123,10198,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ» ãƒ•ãƒ­ãƒ¼ ï¼ˆä½¿ç”¨ï¼‰ ã®æ“ä½œ',0),(367124,10198,'pt','Cash Flow (usado para) operaÃ§Ãµes',0),(367125,10198,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿Ð¾Ñ‚Ð¾Ðº Ð¾Ñ‚ (Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ) Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¹',0),(367126,10198,'es','Flujo de Efectivo de (Usado Por) Operaciones',0),(367127,10198,'de','Cash Flow aus (verwendet fÃ¼r) Operationen',0),(367128,10198,'en','Cash Flow From (Used For) Operations',0),(367129,10199,'is','',0),(367130,10199,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù†  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯',0),(367131,10199,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù†  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯',0),(367132,10199,'tr','Ekleme nakit akÄ±ÅŸÄ± raporu hattÄ± baÅŸarÄ±sÄ±z oldu',0),(367133,10199,'pl','Nie powiodÅ‚o siÄ™ Dodawanie linii raport przepÅ‚ywu Å›rodkÃ³w pieniÄ™Å¼nych',0),(367134,10199,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¿Ð°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ð¾Ñ‚Ð¾Ðº Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð»Ð¸Ð½Ð¸Ñ',0),(367135,10199,'ur','Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©ÛŒØ´ ÙÙ„Ùˆ Ø±Ù¾ÙˆØ±Ù¹ Ù„Ø§Ø¦Ù† Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§',0),(367136,10199,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾ Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð»Ð¸Ð½Ð¸Ñ˜Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð½Ð¾Ð²Ñ‡Ð°Ð½Ð¾Ð³ Ñ‚Ð¾ÐºÐ°',0),(367137,10199,'vi','ThÃªm bÃ¡o cÃ¡o lÆ°u chuyá»ƒn tiá»n tá»‡ khÃ´ng thÃ nh',0),(367138,10199,'af','Faal in Byvoeging van Lyn in Kontantvloei Verslag ',0),(367139,10199,'ro','Nu a reuÈ™it adÄƒugarea fluxurilor de numerar raport linie',0),(367140,10199,'et','Lisades rahavoogude aruande joone nurjus',0),(367141,10199,'si','Ni bilo mogoÄe dodajanje vrstice poroÄila denarni tok',0),(367142,10199,'ba','Gagal menambahkan baris laporan arus kas',0),(367143,10199,'nl','Toe te voegen kasstroom verslag lijn is mislukt',0),(367144,10199,'fi','EpÃ¤onnistui lisÃ¤Ã¤minen kassavirta rivi',0),(367145,10199,'no','Kan ikke legge til kontantstrÃ¸m rapporten linje',0),(367146,10199,'da','Kunne ikke tilfÃ¸je Cash Flow betÃ¦nkningen linje',0),(367147,10199,'ko','ì¶”ê°€ í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œ ì„  ì‹¤íŒ¨',0),(367148,10199,'he','× ×›×©×œ×” ×”×•×¡×¤×ª ×§×• ×“×•×— ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(367149,10199,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î³ÏÎ±Î¼Î¼Î®Ï‚ Î­ÎºÎ¸ÎµÏƒÎ· Ï„Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚',0),(367150,10199,'zh','æ·»åŠ çŽ°é‡‘æµæŠ¥å‘Šè¡Œå¤±è´¥\r\n',0),(367151,10199,'sv','Det gick inte att lÃ¤gga till kassaflÃ¶de rapport linje',0),(367152,10199,'it','Fallito aggiungendo linea di rapporto flusso di cassa',0),(367153,10199,'tl','',0),(367154,10199,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(367155,10199,'hi','à¤œà¥‹à¤¡à¤¼à¤•à¤° à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤²à¤¾à¤‡à¤¨ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(367156,10199,'ms','Gagal menambah talian laporan aliran tunai',0),(367157,10199,'ar','ÙØ´Ù„ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø³Ø·Ø± ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(367158,10199,'fr','N\'a pas d\'ajout ligne de rapport de flux de trÃ©sorerie',0),(367159,10199,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆè¡Œã®è¿½åŠ ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(367160,10199,'pt','Falha adicionando linha de relatÃ³rio de fluxo de caixa',0),(367161,10199,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð»Ð¸Ð½Ð¸Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´ Ð´Ð²Ð¸Ð¶ÐµÐ½Ð¸Ñ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(367162,10199,'es','Falla por Agregar Linea de Informe de Flujo de Efectivo',0),(367163,10199,'de','Fehler beim HinzufÃ¼gen von Cashflow-Bericht-Linie',0),(367164,10199,'en','Failed Adding Cash Flow Report Line',0),(367165,10200,'is','',0),(367166,10200,'dr','Ø§ÙØ²ÙˆØ¯Ù†  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(367167,10200,'pr','Ø§ÙØ²ÙˆØ¯Ù†  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(367168,10200,'tr','Nakit akÄ±ÅŸÄ± raporu satÄ±rÄ± baÅŸarÄ±yla eklendi',0),(367169,10200,'pl','PrzepÅ‚yw Å›rodkÃ³w pieniÄ™Å¼nych raport linii dodano pomyÅ›lnie',0),(367170,10200,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð»Ð¸Ð½Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(367171,10200,'ur','Ú©ÛŒØ´ ÙÙ„Ùˆ Ø±Ù¾ÙˆØ±Ù¹ Ù„Ø§Ø¦Ù† Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(367172,10200,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸ Ñ‚Ð¾Ðº Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ñ€ÐµÐ´ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(367173,10200,'vi','ThÃªm dÃ²ng bÃ¡o cÃ¡o lÆ°u chuyá»ƒn tiá»n tá»‡ thÃ nh cÃ´ng',0),(367174,10200,'af','Lyn suksesvol Bygevoeg in Kontantvloei Verslag',0),(367175,10200,'ro','Fluxul de numerar raport linie adÄƒugat cu succes',0),(367176,10200,'et','Rahavoogude aruande joone lisatud',0),(367177,10200,'si','UspeÅ¡no dodana vrstica za poroÄilo denarni tok',0),(367178,10200,'ba','Laporan arus kas baris ditambahkan berhasil',0),(367179,10200,'nl','Kasstroom verslag lijn toegevoegd',0),(367180,10200,'fi','Kassavirta rivin lisÃ¤Ã¤minen onnistui',0),(367181,10200,'no','KontantstrÃ¸m rapporten linje lagt',0),(367182,10200,'da','Cash Flow rapportlinje tilfÃ¸jet',0),(367183,10200,'ko','í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œ ì¤„ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(367184,10200,'he','×§×• ×— ×ª×–×¨×™× ×ž×–×•×ž× ×™× × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(367185,10200,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚ Î­ÎºÎ¸ÎµÏƒÎ· Î³ÏÎ±Î¼Î¼Î® Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(367186,10200,'zh','çŽ°é‡‘æµé‡æŠ¥å‘Šè¡Œæ·»åŠ æˆåŠŸ\r\n',0),(367187,10200,'sv','KassaflÃ¶de rapport linje lagts',0),(367188,10200,'it','Flusso di cassa relazione linea aggiunto con successo',0),(367189,10200,'tl','',0),(367190,10200,'th','à¸šà¸£à¸£à¸—à¸±à¸”à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(367191,10200,'hi','à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(367192,10200,'ms','Garisan laporan aliran tunai yang berjaya menambah',0),(367193,10200,'ar','Ø®Ø· ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(367194,10200,'fr','Ligne de rapport de flux de trÃ©sorerie ajoutÃ© avec succÃ¨s',0),(367195,10200,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆæ˜Žç´°è¡ŒãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(367196,10200,'pt','RelatÃ³rio de fluxo de caixa linha adicionada com sucesso',0),(367197,10200,'ru','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´Ðµ Ð»Ð¸Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(367198,10200,'es','Linea de informe de Flujo de Efectivo de Agregada Exitosamente',0),(367199,10200,'de','Cashflow-Bericht-Linie erfolgreich hinzugefÃ¼gt',0),(367200,10200,'en','Cash Flow Report Line Added Successfully',0),(367201,10201,'is','',0),(367202,10201,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯',0),(367203,10201,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯',0),(367204,10201,'tr','Nakit akÄ±ÅŸÄ± raporu satÄ±r silme baÅŸarÄ±sÄ±z oldu',0),(367205,10201,'pl','Nie powiodÅ‚o siÄ™ usuniÄ™cie linii raport przepÅ‚ywu Å›rodkÃ³w pieniÄ™Å¼nych',0),(367206,10201,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð¿Ð°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ð¾Ñ‚Ð¾Ðº Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð»Ð¸Ð½Ð¸Ñ',0),(367207,10201,'ur','Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©ÛŒØ´ ÙÙ„Ùˆ Ø±Ù¾ÙˆØ±Ù¹ Ù„Ø§Ø¦Ù† Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§',0),(367208,10201,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾ Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ñ€ÐµÐ´Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð½Ð¾Ð²Ñ‡Ð°Ð½Ð¾Ð³ Ñ‚Ð¾ÐºÐ°',0),(367209,10201,'vi','XÃ³a dÃ²ng thÃªm bÃ¡o cÃ¡o lÆ°u chuyá»ƒn tiá»n tá»‡ khÃ´ng thÃ nh',0),(367210,10201,'af','Faal in Skrap van Lyn in Kontantvloei Verslag ',0),(367211,10201,'ro','Nu a reuÅŸit ÅŸtergerea fluxul de numerar raport linie',0),(367212,10201,'et','EbaÃµnnestus kustutada rahavoogude aruande rea',0),(367213,10201,'si','Ni uspelo brisanje linije poroÄilo denarni tok',0),(367214,10201,'ba','Gagal menghapus baris laporan arus kas',0),(367215,10201,'nl','Verwijderen kasstroom verslag lijn is mislukt',0),(367216,10201,'fi','EpÃ¤onnistui poistaminen kassavirta rivi',0),(367217,10201,'no','Kan ikke slette kontantstrÃ¸m rapporten linje',0),(367218,10201,'da','Kunne ikke slette Cash Flow betÃ¦nkningen linje',0),(367219,10201,'ko','í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œ ì¤„ ì‚­ì œ ì‹¤íŒ¨',0),(367220,10201,'he','× ×›×©×œ×” ×‘×ž×—×™×§×ª ×©×•×¨×” ×“×•×— ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(367221,10201,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· Î´Î¹Î±Î³ÏÎ±Ï†Î® Î³ÏÎ±Î¼Î¼Î®Ï‚ Î­ÎºÎ¸ÎµÏƒÎ· Ï„Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚',0),(367222,10201,'zh','çŽ°é‡‘æµæŠ¥è¡¨æ— æ³•åˆ é™¤è¡Œ\r\n',0),(367223,10201,'sv','Kunde inte ta bort kassaflÃ¶de rapport linje',0),(367224,10201,'it','Impossibile eliminazione linea di rapporto flusso di cassa',0),(367225,10201,'tl','',0),(367226,10201,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸¥à¸šà¸šà¸£à¸£à¸—à¸±à¸”à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(367227,10201,'hi','à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤²à¤¾à¤‡à¤¨ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(367228,10201,'ms','Gagal menghapus talian laporan aliran tunai',0),(367229,10201,'ar','ÙØ´Ù„ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø³Ø·Ø± ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(367230,10201,'fr','Ã‰chec de suppression ligne de rapport de flux de trÃ©sorerie',0),(367231,10201,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆè¡Œã®å‰Šé™¤ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(367232,10201,'pt','NÃ£o conseguiu apagar linha de relatÃ³rio de fluxo de caixa',0),(367233,10201,'ru','Ð¡Ð±Ð¾Ð¹ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´Ðµ Ð»Ð¸Ð½Ð¸Ñ',0),(367234,10201,'es','FallÃ³ Eliminando la Linea del Informe de Flujo de Efectivo',0),(367235,10201,'de','Fehler beim LÃ¶schen von Cashflow-Bericht-Linie',0),(367236,10201,'en','Failed Deleting Cash Flow Report Line',0),(367237,10202,'is','',0),(367238,10202,'dr','Ø­Ø°Ù  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(367239,10202,'pr','Ø­Ø°Ù  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(367240,10202,'tr','Nakit akÄ±ÅŸÄ± raporu satÄ±rÄ± baÅŸarÄ±yla silindi',0),(367241,10202,'pl','PrzepÅ‚yw Å›rodkÃ³w pieniÄ™Å¼nych raportu wiersza usuniÄ™te pomyÅ›lnie',0),(367242,10202,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð»Ð¸Ð½Ð¸Ñ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(367243,10202,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©ÛŒØ´ ÙÙ„Ùˆ Ø±Ù¾ÙˆØ±Ù¹ Ù„Ø§Ø¦Ù†',0),(367244,10202,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸ Ñ‚Ð¾Ðº Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ñ€ÐµÐ´ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(367245,10202,'vi','XÃ³a dÃ²ng bÃ¡o cÃ¡o lÆ°u chuyá»ƒn tiá»n tá»‡ thÃ nh cÃ´ng',0),(367246,10202,'af','Lyn suksesvol Geskrap in Kontantvloei Verslag',0),(367247,10202,'ro','Fluxul de numerar raport linie ÅŸtearsÄƒ cu succes',0),(367248,10202,'et','Rahavoogude aruande joone edukalt kustutatud',0),(367249,10202,'si','Denarni tok poroÄilo Line uspeÅ¡no izbrisana',0),(367250,10202,'ba','Laporan arus kas Line dihapus berhasil',0),(367251,10202,'nl','Kasstroom verslag lijn met succes verwijderd',0),(367252,10202,'fi','Kassavirta rivi poistettu',0),(367253,10202,'no','KontantstrÃ¸m rapporten linje slettet',0),(367254,10202,'da','Cash Flow rapportlinje slettet',0),(367255,10202,'ko','í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œ ì¤„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(367256,10202,'he','×§×• ×— ×ª×–×¨×™× ×ž×–×•×ž× ×™× × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(367257,10202,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚ Î­ÎºÎ¸ÎµÏƒÎ· Î³ÏÎ±Î¼Î¼Î®, Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(367258,10202,'zh','çŽ°é‡‘æµæŠ¥è¡¨è¡Œåˆ é™¤æˆåŠŸ\r\n',0),(367259,10202,'sv','KassaflÃ¶de rapport linje raderades',0),(367260,10202,'it','Flusso di cassa relazione linea eliminato con successo',0),(367261,10202,'tl','',0),(367262,10202,'th','à¸šà¸£à¸£à¸—à¸±à¸”à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(367263,10202,'hi','à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¥€ à¤²à¤¾à¤‡à¤¨',0),(367264,10202,'ms','Garisan laporan aliran tunai yang dihapuskan dengan jayanya',0),(367265,10202,'ar','Ø®Ø· ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(367266,10202,'fr','Ligne de rapport de flux de trÃ©sorerie supprimÃ© avec succÃ¨s',0),(367267,10202,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆæ˜Žç´°è¡Œã‚’å‰Šé™¤ã—ã¾ã—ãŸ',0),(367268,10202,'pt','RelatÃ³rio de fluxo de caixa linha apagada com sucesso',0),(367269,10202,'ru','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´Ðµ Ð»Ð¸Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(367270,10202,'es','Linea del Informe de Flujo de Efectivo Eliminada Exitosamente',0),(367271,10202,'de','Cashflow-Bericht-Linie erfolgreich gelÃ¶scht',0),(367272,10202,'en','Cash Flow Report Line Deleted Successfully',0),(367273,10203,'is','',0),(367274,10203,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯',0),(367275,10203,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯',0),(367276,10203,'tr','Nakit akÄ±ÅŸÄ± raporu satÄ±r gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu',0),(367277,10203,'pl','Niepowodzenie aktualizacji wiersza raportu przepÅ‚ywu Å›rodkÃ³w pieniÄ™Å¼nych',0),(367278,10203,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ð¾Ñ‚Ð¾Ðº Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð»Ð¸Ð½Ð¸Ñ',0),(367279,10203,'ur','Ú©ÛŒØ´ ÙÙ„Ùˆ Ø±Ù¾ÙˆØ±Ù¹ Ù„Ø§Ø¦Ù† ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(367280,10203,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð½Ð¾Ð²Ñ‡Ð°Ð½Ð¸ Ñ‚Ð¾Ðº Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð»Ð¸Ð½Ð¸Ñ˜Ð°',0),(367281,10203,'vi','Cáº­p nháº­t dÃ²ng bÃ¡o cÃ¡o lÆ°u chuyá»ƒn tiá»n tá»‡ khÃ´ng thÃ nh.',0),(367282,10203,'af','Faal in Opdatering van Lyn in Kontantvloei Verslag ',0),(367283,10203,'ro','Nu a reuÈ™it actualizarea fluxurilor de numerar raport linie',0),(367284,10203,'et','Ei Ãµnnestunud ajakohastamine rahavoogude aruande joone',0),(367285,10203,'si','Ni uspelo posodabljanje denarni tok poroÄilo Line',0),(367286,10203,'ba','Gagal update baris laporan arus kas',0),(367287,10203,'nl','Bijwerken kasstroom verslag lijn is mislukt',0),(367288,10203,'fi','Kassavirta mietinnÃ¶ssÃ¤ rivin pÃ¤ivitys epÃ¤onnistui',0),(367289,10203,'no','Kan ikke oppdatere kontantstrÃ¸m rapporten linje',0),(367290,10203,'da','Kunne ikke opdatere Cash Flow betÃ¦nkningen linje',0),(367291,10203,'ko','í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œ ì„  ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(367292,10203,'he','× ×›×©×œ ×¢×“×›×•×Ÿ ×§×• ×“×•×— ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(367293,10203,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³ÏÎ±Î¼Î¼Î® Î­ÎºÎ¸ÎµÏƒÎ· Ï„Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚',0),(367294,10203,'zh','æ— æ³•æ›´æ–°çŽ°é‡‘æµé‡æŠ¥å‘Šè¡Œ\r\n',0),(367295,10203,'sv','Gick inte att uppdatera kassaflÃ¶de rapport linje',0),(367296,10203,'it','Impossibile aggiornamento linea di rapporto flusso di cassa',0),(367297,10203,'tl','',0),(367298,10203,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸šà¸£à¸£à¸—à¸±à¸”à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(367299,10203,'hi','à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤°à¥‡à¤–à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(367300,10203,'ms','Gagal mengemaskini Garis laporan aliran tunai',0),(367301,10203,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø®Ø· ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(367302,10203,'fr','N\'a pas de ligne de rapport mise Ã  jour des flux de trÃ©sorerie',0),(367303,10203,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆè¡Œã®æ›´æ–°ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(367304,10203,'pt','Falha de atualizaÃ§Ã£o linha de relatÃ³rio de fluxo de caixa',0),(367305,10203,'ru','Ð¡Ð±Ð¾Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´Ðµ Ð»Ð¸Ð½Ð¸Ñ',0),(367306,10203,'es','FallÃ³ Actualizando Linea del Informe de Flujo de Efectivo',0),(367307,10203,'de','Fehler bei Aktualisierung Cashflow-Bericht-Linie',0),(367308,10203,'en','Failed Updating Cash Flow Report Line',0),(367309,10204,'is','',0),(367310,10204,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(367311,10204,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø³Ø·Ø± Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(367312,10204,'tr','Nakit akÄ±ÅŸÄ± raporu satÄ±rÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(367313,10204,'pl','PrzepÅ‚yw Å›rodkÃ³w pieniÄ™Å¼nych raport linii pomyÅ›lnie zaktualizowana',0),(367314,10204,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð»Ð¸Ð½Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(367315,10204,'ur','Ú©ÛŒØ´ ÙÙ„Ùˆ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ù„Ø§Ø¦Ù†',0),(367316,10204,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸ Ñ‚Ð¾Ðº Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð»Ð¸Ð½Ð¸Ñ˜Ñƒ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(367317,10204,'vi','Cáº­p nháº­t dÃ²ng bÃ¡o cÃ¡o lÆ°u chuyá»ƒn tiá»n tá»‡ thÃ nh cÃ´ng.',0),(367318,10204,'af','Lyn suksesvol Opdateer in Kontantvloei Verslag',0),(367319,10204,'ro','Linie de raport flux de numerar actualizat cu succes',0),(367320,10204,'et','Rahavoogude aruande rea vÃ¤rskendamine Ãµnnestus',0),(367321,10204,'si','Denarni tok poroÄilo Line uspeÅ¡no posodobljena',0),(367322,10204,'ba','Laporan arus kas Line berhasil',0),(367323,10204,'nl','Kasstroom verslag lijn bijgewerkt',0),(367324,10204,'fi','Kassavirta rivin pÃ¤ivittÃ¤minen onnistui',0),(367325,10204,'no','KontantstrÃ¸m rapporten linje oppdatert',0),(367326,10204,'da','Cash Flow rapportlinje opdateret',0),(367327,10204,'ko','í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œ ì¤„ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(367328,10204,'he','×§×• ×— ×ª×–×¨×™× ×ž×–×•×ž× ×™× ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(367329,10204,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚ Î³ÏÎ±Î¼Î¼Î® Î­ÎºÎ¸ÎµÏƒÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(367330,10204,'zh','çŽ°é‡‘æµé‡æŠ¥å‘Šè¡Œæ›´æ–°æˆåŠŸ\r\n',0),(367331,10204,'sv','KassaflÃ¶de rapport linje uppdaterats',0),(367332,10204,'it','Linea di rapporto flusso di cassa aggiornato con successo',0),(367333,10204,'tl','',0),(367334,10204,'th','à¸šà¸£à¸£à¸—à¸±à¸”à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(367335,10204,'hi','à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(367336,10204,'ms','Garisan laporan aliran tunai yang berjaya dikemas kini',0),(367337,10204,'ar','Ø®Ø· ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(367338,10204,'fr','Ligne de rapport de flux de trÃ©sorerie mis Ã  jour avec succÃ¨s',0),(367339,10204,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆæ˜Žç´°è¡ŒãŒæ­£å¸¸ã«æ›´æ–°',0),(367340,10204,'pt','Linha de relatÃ³rio de fluxo de caixa atualizada com sucesso',0),(367341,10204,'ru','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´Ðµ Ð»Ð¸Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(367342,10204,'es','Linea del Informe de Flujo de Efectivo Acualizada Exitosamente',0),(367343,10204,'de','Cashflow-Bericht-Linie erfolgreich aktualisiert',0),(367344,10204,'en','Cash Flow Report Line Updated Successfully',0),(367345,10205,'is','',0),(367346,10205,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¬Ø§Ø±ÙŠ',0),(367347,10205,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø¬Ø§Ø±ÙŠ',0),(367348,10205,'tr','GeÃ§erli GL hesaplarÄ±',0),(367349,10205,'pl','BieÅ¼Ä…ce rachunki GL',0),(367350,10205,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ GL ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(367351,10205,'ur','Ø­Ø§Ù„ÛŒÛ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³',0),(367352,10205,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð›',0),(367353,10205,'vi','tÃ i khoáº£n sá»• cÃ¡i hiá»‡n nay',0),(367354,10205,'af','Huidige AG Rekeninge',0),(367355,10205,'ro','Curent GL conturi',0),(367356,10205,'et','Praeguses GL kontod',0),(367357,10205,'si','TekoÄih raÄunih GL',0),(367358,10205,'ba','Current GL Accounts',0),(367359,10205,'nl','Huidige GL-Accounts',0),(367360,10205,'fi','Nykyinen GL tilit',0),(367361,10205,'no','Gjeldende GL-kontoer',0),(367362,10205,'da','Aktuelle GL konti',0),(367363,10205,'ko','í˜„ìž¬ GL ê³„ì •',0),(367364,10205,'he','×—×©×‘×•× ×•×ª GL ×”× ×•×›×—×™×™×',0),(367365,10205,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(367366,10205,'zh','å½“å‰æ€»å¸å¸æˆ·\r\n',0),(367367,10205,'sv','Nuvarande GL konton',0),(367368,10205,'it','Correnti conti GL',0),(367369,10205,'tl','',0),(367370,10205,'th','à¸£à¸«à¸±à¸ªà¸šà¸±à¸à¸Šà¸µà¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(367371,10205,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ GL à¤–à¤¾à¤¤à¥‹à¤‚',0),(367372,10205,'ms','Semasa GL akaun',0),(367373,10205,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(367374,10205,'fr','Comptes courants de GL',0),(367375,10205,'jp','ç¾åœ¨ã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(367376,10205,'pt','Contas correntes de GL',0),(367377,10205,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° GL',0),(367378,10205,'es','Cuentas Circulantes del LM',0),(367379,10205,'de','Aktuellen GL-Konten',0),(367380,10205,'en','Current GL Accounts',0),(367381,10206,'is','',0),(367382,10206,'dr','ØªÙ†Ø¸ÙŠÙ… Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ø¯ÙØªØ± ÙƒÙ„',0),(367383,10206,'pr','ØªÙ†Ø¸ÙŠÙ… Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ø¯ÙØªØ± ÙƒÙ„',0),(367384,10206,'tr','Genel muhasebe nakit akÄ±ÅŸÄ± raporu kurulumu',0),(367385,10206,'pl','Ustawienie raport General Ledger przepÅ‚ywu Å›rodkÃ³w pieniÄ™Å¼nych',0),(367386,10206,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°Ñ‚Ð° Ð½Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°Ñ‚Ð° Ð·Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð» ÐºÐ½Ð¸Ð³Ð° Ð·Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸',0),(367387,10206,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ú©ÛŒØ´ ÙÙ„Ùˆ Ø±Ù¾ÙˆØ±Ù¹ Ø³ÛŒÙ¹ Ø§Ù¾',0),(367388,10206,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ Ð½Ð¾Ð²Ñ‡Ð°Ð½Ð¾Ð³ Ñ‚Ð¾ÐºÐ°',0),(367389,10206,'vi','thiáº¿t láº­p bÃ¡o cÃ¡o chung dÃ²ng tiá»n',0),(367390,10206,'af','Algemene Grootboek Kontantvloeiverslag Opstelling',0),(367391,10206,'ro','Setup de raport general Ledger fluxul de numerar',0),(367392,10206,'et','Pearaamatu sularaha liikumise aruanne',0),(367393,10206,'si','General Ledger denarni tok poroÄilo Setup',0),(367394,10206,'ba','Laporan arus kas General Ledger Setup',0),(367395,10206,'nl','General Ledger kasstroom verslag Setup',0),(367396,10206,'fi','General Ledger kassavirta asetukset',0),(367397,10206,'no','General Ledger kontantstrÃ¸m rapportoppsett',0),(367398,10206,'da','General Ledger Cash Flow rapportopsÃ¦tning',0),(367399,10206,'ko','ì¼ë°˜ ë ˆì € í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œ ì„¤ì •',0),(367400,10206,'he','×”×’×“×¨×ª ×“×•×— ×ª×–×¨×™× ×ž×–×•×ž× ×™× ×›×œ×œ×™ ×¡×¤×¨ ×¨××©×™',0),(367401,10206,'el','Î“ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® Ï„Î±Î¼ÎµÎ¹Î±ÎºÎ®Ï‚ ÏÎ¿Î®Ï‚ Ï€Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚ Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(367402,10206,'zh','æ€»è´¦çŽ°é‡‘æµæŠ¥è¡¨è®¾ç½®\r\n',0),(367403,10206,'sv','General Ledger kassaflÃ¶de rapportinstÃ¤llningar',0),(367404,10206,'it','Flusso di cassa di contabilitÃ  generale Report Setup',0),(367405,10206,'tl','',0),(367406,10206,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸à¸²à¸£à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¸‚à¸­à¸‡à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(367407,10206,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(367408,10206,'ms','Persediaan laporan aliran tunai Lejar Am',0),(367409,10206,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ Ù„Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(367410,10206,'fr','Flux de trÃ©sorerie pour le grand livre gÃ©nÃ©ral Report Setup',0),(367411,10206,'jp','ä¸€èˆ¬çš„ãªå…ƒå¸³ã®ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆ ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(367412,10206,'pt','ConfiguraÃ§Ã£o do relatÃ³rio de fluxo de caixa do General Ledger',0),(367413,10206,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¾Ð² Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹ ÐºÐ½Ð¸Ð³Ð¸ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸',0),(367414,10206,'es','ConfiguraciÃ³n del Informe del Flujo del Efectivo del Libro Mayor',0),(367415,10206,'de','General Ledger Cashflow-Bericht-Setup',0),(367416,10206,'en','General Ledger Cash Flow Report Setup',0),(367417,10207,'is','',0),(367418,10207,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ø± ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ø±Ø§ Ù…ÙˆØ«Ø± Ø¨Ø§Ø´Ø¯',0),(367419,10207,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ Ø¯Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ø¨Ø± ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ø±Ø§ Ù…ÙˆØ«Ø± Ø¨Ø§Ø´Ø¯',0),(367420,10207,'tr','Nakit etkileyen deÄŸil gelir Ã¶ÄŸeler',0),(367421,10207,'pl','Elementy dochodÃ³w nie wpÅ‚ywajÄ…cych na gotÃ³wkÄ™',0),(367422,10207,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð½Ð° Ð´Ð¾Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ, Ð½Ðµ Ð·Ð°ÑÑÐ³Ð°Ñ‚ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸',0),(367423,10207,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©Ùˆ Ù…ØªØ§Ø«Ø± Ù†ÛÛŒÚº Ø¢Ù…Ø¯Ù†ÛŒ Ù…ÛŒÚº Ø§Ø´ÛŒØ§Ø¡',0),(367424,10207,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ñƒ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´ Ð½Ðµ ÑƒÑ‚Ð¸Ñ‡Ðµ Ð½Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ñƒ',0),(367425,10207,'vi','CÃ¡c máº·t hÃ ng trong doanh thu Ä‘ang khÃ´ng áº£nh hÆ°á»Ÿng Ä‘áº¿n tiá»n',0),(367426,10207,'af','Items In Inkomste Affekteer Nie Kontant',0),(367427,10207,'ro','Elementele din venituri nu afecteazÄƒ numerar',0),(367428,10207,'et','Kaupade sissetulek ei mÃµjutaks raha',0),(367429,10207,'si','Elemente dohodka ne vplivajo denarnih',0),(367430,10207,'ba','Item dalam pendapatan tidak mempengaruhi tunai',0),(367431,10207,'nl','Items In inkomen niet van invloed op Cash',0),(367432,10207,'fi','Kohteiden tulot ei vaikuta kÃ¤teistÃ¤',0),(367433,10207,'no','Elementer i inntekt ikke pÃ¥virker kontanter',0),(367434,10207,'da','Elementer i indkomst ikke pÃ¥virker Cash',0),(367435,10207,'ko','ì†Œë“ ì—†ëŠ” í˜„ê¸ˆì— ì˜í–¥ì„ ë¯¸ì¹˜ëŠ” í•­ëª©',0),(367436,10207,'he','×¤×¨×™×˜×™ ×”×›× ×¡×” ×œ× ×ž×©×¤×™×¢ ×¢×œ ×ž×–×•×ž× ×™×',0),(367437,10207,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚ Ï€Î¿Ï… Î´ÎµÎ½ ÎµÏ€Î·ÏÎµÎ¬Î¶Î¿Ï…Î½ Ï„Î± Î¼ÎµÏ„ÏÎ·Ï„Î¬',0),(367438,10207,'zh','æ”¶å…¥é¡¹ç›®ä¸å½±å“çŽ°é‡‘\r\n',0),(367439,10207,'sv','Objekt i inkomst som inte pÃ¥verkar likvida medel',0),(367440,10207,'it','Elementi di reddito che non interessano in contanti',0),(367441,10207,'tl','',0),(367442,10207,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸²à¸¢à¹„à¸”à¹‰à¹„à¸¡à¹ˆà¸à¸£à¸°à¸—à¸šà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(367443,10207,'hi','à¤†à¤¯ à¤¨à¤•à¤¦ à¤¨à¤¹à¥€à¤‚ à¤•à¥‹ à¤ªà¥à¤°à¤­à¤¾à¤µà¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(367444,10207,'ms','Item-item dalam pendapatan yang tidak melibatkan Wang Tunai',0),(367445,10207,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± ÙÙŠ Ø§Ù„Ø¯Ø®Ù„ Ø§Ù„ØªÙŠ Ù„Ø§ ØªØ¤Ø«Ø± Ø¹Ù„Ù‰ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(367446,10207,'fr','Ã‰lÃ©ments de revenu sans incidence sur la trÃ©sorerie',0),(367447,10207,'jp','ç¾é‡‘ã«å½±éŸ¿ã‚’ä¸Žãˆãªã„åŽå…¥é …ç›®',0),(367448,10207,'pt','Itens em renda, nÃ£o afetando o dinheiro',0),(367449,10207,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð² Ð´Ð¾Ñ…Ð¾Ð´, Ð½Ðµ Ð·Ð°Ñ‚Ñ€Ð°Ð³Ð¸Ð²Ð°Ñ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ',0),(367450,10207,'es','Items en Ingresos Que No Se Afectan el Efecivo',0),(367451,10207,'de','Teile des Einkommens nicht beeinflussen Cash',0),(367452,10207,'en','Items In Income Not Affecting Cash',0),(367453,10208,'is','',0),(367454,10208,'dr','Ø®Ø§Ù„Øµ Ù†Ù‚Ø¯Ù‰ Ø§Ø² Ø³Ø±Ù…Ø§ÙŠÙ‡ Ø¯Ø± Ú¯Ø±Ø¯Ø´',0),(367455,10208,'pr','Ø®Ø§Ù„Øµ Ù†Ù‚Ø¯Ù‰ Ø§Ø² Ø³Ø±Ù…Ø§ÙŠÙ‡ Ø¯Ø± Ú¯Ø±Ø¯Ø´',0),(367456,10208,'tr','Net nakit (iÃ§in kullanÄ±lan) dan sermayesi',0),(367457,10208,'pl','Net gotÃ³wki (uÅ¼ywane) kapitaÅ‚u obrotowego',0),(367458,10208,'bg','ÐÐµÑ‚Ð½Ð¸ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¾Ñ‚ (Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ Ð·Ð°) Ð¾Ð±Ð¾Ñ€Ð¾Ñ‚ÐµÐ½ ÐºÐ°Ð¿Ð¸Ñ‚Ð°Ð»',0),(367459,10208,'ur','Ù†ÛŒÙ¹ Ù¾Ø± Ù†Ù‚Ø¯ (Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„) Ø³Û’ Ú©Ø§Ù… Ú©Ø±Ù†Û’ Ú©Û’ Ø¯Ø§Ø±Ø§Ù„Ø­Ú©ÙˆÙ…Øª',0),(367460,10208,'sr','ÐÐµÑ‚Ð¾ Ð½Ð¾Ð²Ð°Ñ† Ð¸Ð· (Ñƒ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸) Ð¾Ð±Ñ€Ñ‚Ð½Ð° ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°',0),(367461,10208,'vi','tiá»n thá»±c táº¿ tá»« (Ä‘Æ°á»£c sá»­ dá»¥ng cho) vá»‘n hoáº¡t Ä‘á»™ng',0),(367462,10208,'af','Netto Kontant Van (Gebruik Vir) Bedryfskapitaal',0),(367463,10208,'ro','Net de numerar din (folosit pentru) capitalului de lucru',0),(367464,10208,'et','Rahavood alates (kasutatakse) kÃ¤ibekapitali',0),(367465,10208,'si','Neto denarni iz (uporabljeni za) obratnih sredstev',0),(367466,10208,'ba','Kas bersih dari (digunakan untuk) modal kerja',0),(367467,10208,'nl','Netto Cash uit (gebruikt voor) werkkapitaal',0),(367468,10208,'fi','NET kÃ¤teisellÃ¤ (kÃ¤ytetty) kÃ¤yttÃ¶pÃ¤Ã¤oman',0),(367469,10208,'no','Netto kontant fra (benyttet For) arbeidskapital',0),(367470,10208,'da','Netto kontant fra (anvendt i) driftskapital',0),(367471,10208,'ko','(ì‚¬ìš©)ì—ì„œ í˜„ê¸ˆ ìˆœ ìš´ì „ ìžê¸ˆ',0),(367472,10208,'he','× ×˜×• ×‘×ž×–×•×ž×Ÿ ×‘×œ×‘×“ (×ž×©×ž×©) ×”×•×Ÿ ×—×•×–×¨',0),(367473,10208,'el','ÎšÎ±Î¸Î±ÏÎ¬ Î¼ÎµÏ„ÏÎ·Ï„Î¬ Î±Ï€ÏŒ (Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ¼ÎµÎ½Î± Î³Î¹Î±) ÎºÎµÏ†Î¬Î»Î±Î¹Î¿ ÎºÎ¯Î½Î·ÏƒÎ·Ï‚',0),(367474,10208,'zh','å‡€çŽ°é‡‘ï¼ˆä½¿ç”¨ï¼‰çš„å‘¨è½¬\r\n',0),(367475,10208,'sv','KassaflÃ¶den frÃ¥n (anvÃ¤nds fÃ¶r) rÃ¶relsekapital',0),(367476,10208,'it','NET Cash da (usato per) capitale circolante',0),(367477,10208,'tl','',0),(367478,10208,'th','à¸ªà¸¸à¸—à¸˜à¸´à¹€à¸‡à¸´à¸™à¸ªà¸”à¸ˆà¸²à¸ (à¹ƒà¸Šà¹‰à¸ªà¸³à¸«à¸£à¸±à¸š) à¹€à¸‡à¸´à¸™à¸—à¸¸à¸™à¸«à¸¡à¸¸à¸™à¹€à¸§à¸µà¸¢à¸™',0),(367479,10208,'hi','à¤¨à¥‡à¤Ÿ à¤¨à¤•à¤¦ (à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾) à¤¸à¥‡ à¤•à¤¾à¤°à¥à¤¯à¤¶à¥€à¤² à¤ªà¥‚à¤‚à¤œà¥€',0),(367480,10208,'ms','Bersih tunai daripada (digunakan untuk) modal kerja',0),(367481,10208,'ar','ØµØ§ÙÙŠ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ù…Ù† (Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„) Ø±Ø£Ø³ Ø§Ù„Ù…Ø§Ù„ Ø§Ù„Ø¹Ø§Ù…Ù„',0),(367482,10208,'fr','Encaisse nette des (affectÃ©s aux) Fonds de roulement',0),(367483,10208,'jp','ï¼ˆä½¿ç”¨ï¼‰ ã®ç´”ç¾é‡‘é‹è»¢è³‡æœ¬',0),(367484,10208,'pt','NET dinheiro do (usado para) Capital de giro',0),(367485,10208,'ru','Ð§Ð¸ÑÑ‚Ñ‹Ðµ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ðµ Ð¾Ñ‚ (Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ) Ð¾Ð±Ð¾Ñ€Ð¾Ñ‚Ð½Ð¾Ð³Ð¾ ÐºÐ°Ð¿Ð¸Ñ‚Ð°Ð»Ð°',0),(367486,10208,'es','Efectivo Neto De (Usado Por) Capital del Trabajo',0),(367487,10208,'de','Mittelzufluss aus (verwendet fÃ¼r) das Working Capital',0),(367488,10208,'en','Net Cash From (Used For) Working Capital',0),(367489,10209,'is','',0),(367490,10209,'dr','Ø®Ø§Ù„Øµ Ù…Ø¨Ø§Ø¯Ù„Ù‡  Ø¯Ø± Ø¯ÙŠÚ¯Ø± ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø¯Ø§Ø±Ø§Ø¦ÙŠÙ‡Ø§ Ùˆ Ø¨Ø¯Ù‡ÙŠÙ‡Ø§',0),(367491,10209,'pr','Ø®Ø§Ù„Øµ Ù…Ø¨Ø§Ø¯Ù„Ù‡  Ø¯Ø± Ø¯ÙŠÚ¯Ø± ÙØ¹Ø§Ù„ÙŠØª Ù‡Ø§ÙŠ Ø¯Ø§Ø±Ø§Ø¦ÙŠÙ‡Ø§ Ùˆ Ø¨Ø¯Ù‡ÙŠÙ‡Ø§',0),(367492,10209,'tr','DiÄŸer iÅŸletme varlÄ±klarÄ± ve yÃ¼kÃ¼mlÃ¼lÃ¼kleri net deÄŸiÅŸimi',0),(367493,10209,'pl','Zmiany netto w innych aktywÃ³w i pasywÃ³w',0),(367494,10209,'bg','ÐÐµÑ‚Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð² Ð´Ñ€ÑƒÐ³Ð¸ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð¸ Ð¸ Ð¿Ð°ÑÐ¸Ð²Ð¸',0),(367495,10209,'ur','Ø¯ÙˆØ³Ø±Û’ Ø¢Ù¾Ø±ÛŒÙ¹Ù†Ú¯ Ø§Ø«Ø§Ø«ÙˆÚº Ø§ÙˆØ± Ø¯Ø§Ø±ÛŒÙˆÚº Ù…ÛŒÚº Ø¬Ø§Ù„ Ú©ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ',0),(367496,10209,'sr','ÐŸÑ€Ð¾Ð¼ÐµÑ‚ Ñƒ Ð´Ñ€ÑƒÐ³Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ðµ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¸ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(367497,10209,'vi','Thay Ä‘á»•i thuáº§n trong cÃ¡c tÃ i sáº£n hoáº¡t Ä‘á»™ng khÃ¡c vÃ  ná»£ pháº£i tráº£',0),(367498,10209,'af','Netto Verandering in Ander Bedryfsbates en -laste',0),(367499,10209,'ro','Sold perioadÄƒ Ã®n alte exploatare activele ÅŸi pasivele',0),(367500,10209,'et','Tresooraktsiate muutus muid varasid ja kohustusi',0),(367501,10209,'si','Promet v drugih operativnih sredstev in obveznosti',0),(367502,10209,'ba','Perubahan bersih dalam aset dan kewajiban lain operasi',0),(367503,10209,'nl','Mutatie in overige operationele activa en passiva',0),(367504,10209,'fi','Nettomuutos muut liiketoiminnan varat ja velat',0),(367505,10209,'no','Nettoendring i andre operative eiendeler og gjeld',0),(367506,10209,'da','NettoÃ¦ndring i andre driftsmÃ¦ssige aktiver og passiver',0),(367507,10209,'ko','ë‹¤ë¥¸ ìš´ì˜ ìžì‚° ë° ë¶€ì±„ì˜ ìˆœ ë³€í™”',0),(367508,10209,'he','×©×™× ×•×™ × ×˜×• ×©×œ ×”× ×›×¡×™× ×•×”×”×ª×—×™×™×‘×•×™×•×ª ×”×¤×¢×œ×” ××—×¨×™×',0),(367509,10209,'el','ÎšÎ¯Î½Î·ÏƒÎ· Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï… Î¬Î»Î»ÎµÏ‚ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¹Î±ÎºÏŽÎ½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ ÎºÎ±Î¹ Ï…Ï€Î¿Ï‡ÏÎµÏŽÏƒÎµÏ‰Î½',0),(367510,10209,'zh','å…¶ä»–ç»è¥èµ„äº§åŠè´Ÿå€ºå‡€å¢žå‡\r\n',0),(367511,10209,'sv','FÃ¶rÃ¤ndring av Ã¶vriga tillgÃ¥ngar och skulder',0),(367512,10209,'it','Variazione netta altre attivitÃ  e le passivitÃ  operative',0),(367513,10209,'tl','',0),(367514,10209,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸ªà¸¸à¸—à¸˜à¸´à¹ƒà¸™à¸ªà¸´à¸™à¸—à¸£à¸±à¸žà¸¢à¹Œà¹à¸¥à¸°à¸«à¸™à¸µà¹‰à¸ªà¸´à¸™à¸”à¸³à¹€à¸™à¸´à¸™à¸‡à¸²à¸™à¸­à¸·à¹ˆà¸™ à¹†',0),(367515,10209,'hi','à¤…à¤¨à¥à¤¯ à¤ªà¤°à¤¿à¤šà¤¾à¤²à¤¨ à¤†à¤¸à¥à¤¤à¤¿à¤¯à¥‹à¤‚ à¤”à¤° à¤¦à¥‡à¤¯à¤¤à¤¾à¤“à¤‚ à¤®à¥‡à¤‚ à¤¨à¤¿à¤µà¤² à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(367516,10209,'ms','Perubahan bersih dalam aset dan liabiliti operasi lain',0),(367517,10209,'ar','ØµØ§ÙÙŠ Ø§Ù„ØªØºÙŠØ± ÙÙŠ Ø§Ù„Ø£ØµÙˆÙ„ ÙˆØ§Ù„Ø®ØµÙˆÙ… Ø§Ù„Ø£Ø®Ø±Ù‰ Ø§Ù„ØªØ´ØºÙŠÙ„',0),(367518,10209,'fr','Variation nette des autres actifs et les passifs d\'exploitation',0),(367519,10209,'jp','ãã®ä»–å–¶æ¥­è³‡ç”£ãŠã‚ˆã³è² å‚µã®ç´”å¢—æ¸›',0),(367520,10209,'pt','VariaÃ§Ã£o lÃ­quida em outros operacionais ativos e passivos',0),(367521,10209,'ru','Ð§Ð¸ÑÑ‚Ð¾Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð´Ñ€ÑƒÐ³Ð¸Ñ… Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ñ‹Ñ… Ð°ÐºÑ‚Ð¸Ð²Ð¾Ð² Ð¸ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²',0),(367522,10209,'es','Cambio Neto en Otros Activos y Pasivos Operacionales ',0),(367523,10209,'de','VerÃ¤nderung der sonstigen betrieblichen VermÃ¶genswerte und Verbindlichkeiten',0),(367524,10209,'en','Net Change in Other Operating Assets and Liabilities',0),(367525,10210,'is','',0),(367526,10210,'dr','Ù„Ø·ÙØ§ Ú¯Ø±ÙˆÙ‡ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(367527,10210,'pr','Ù„Ø·ÙØ§ Ú¯Ø±ÙˆÙ‡ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(367528,10210,'tr','LÃ¼tfen Kategori ekleyin',0),(367529,10210,'pl','Prosimy o podanie kategorii',0),(367530,10210,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(367531,10210,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø²Ù…Ø±Û Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(367532,10210,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(367533,10210,'vi','vui lÃ²ng bao gá»“m danh má»¥c',0),(367534,10210,'af','Sluit asb. \'n Kategorie in',0),(367535,10210,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i categorie',0),(367536,10210,'et','Palun lisa kategooria',0),(367537,10210,'si','Prosimo, da vkljuÄite Kategorija',0),(367538,10210,'ba','Harap sertakan Kategori',0),(367539,10210,'nl','Gelieve te omvatten categorie',0),(367540,10210,'fi','LiitÃ¤ luokka',0),(367541,10210,'no','Ta med kategori',0),(367542,10210,'da','Inkluder venligst kategori',0),(367543,10210,'ko','ë²”ì£¼ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(367544,10210,'he','×× × ×›×œ×•×œ ×§×˜×’×•×¨×™×™×”',0),(367545,10210,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(367546,10210,'zh','è¯·åˆ—å…¥åˆ†ç±»\r\n',0),(367547,10210,'sv','VÃ¤nligen inkludera kategori',0),(367548,10210,'it','Si prega di includere categoria',0),(367549,10210,'tl','',0),(367550,10210,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸§à¸¡à¸›à¸£à¸°à¹€à¸ à¸—',0),(367551,10210,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(367552,10210,'ms','Sila masukkan kategori',0),(367553,10210,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø§Ù„ÙØ¦Ø©',0),(367554,10210,'fr','S\'il vous plaÃ®t inclure catÃ©gorie',0),(367555,10210,'jp','ã‚«ãƒ†ã‚´ãƒªã‚’æŒ‡å®šã—ã¦ãã ã•ã„ã€‚',0),(367556,10210,'pt','Por favor inclua a categoria',0),(367557,10210,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(367558,10210,'es','Por Favor Incluye la CategorÃ­a',0),(367559,10210,'de','Bitte geben Sie Kategorie',0),(367560,10210,'en','Please Include Category',0),(367561,10211,'is','',0),(367562,10211,'dr','Ù„Ø·ÙØ§ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(367563,10211,'pr','Ù„Ø·ÙØ§ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(367564,10211,'tr','LÃ¼tfen GL hesaplarÄ±nÄ± dahil et',0),(367565,10211,'pl','Prosimy o podanie konta GL',0),(367566,10211,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ GL ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(367567,10211,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(367568,10211,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð›',0),(367569,10211,'vi','vui lÃ²ng bao gá»“m tÃ i khoáº£n sá»• cÃ¡i',0),(367570,10211,'af','Sluit AG Rekening in',0),(367571,10211,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i GL conturi',0),(367572,10211,'et','Palun lisa pearaamatu kontod',0),(367573,10211,'si','Prosimo, da vkljuÄite GL raÄunov',0),(367574,10211,'ba','Harap sertakan GL account',0),(367575,10211,'nl','Gelieve te omvatten GL Accounts',0),(367576,10211,'fi','LiitÃ¤ GL tilit',0),(367577,10211,'no','Ta GL kontoer',0),(367578,10211,'da','VedlÃ¦g GL konti',0),(367579,10211,'ko','GL ê³„ì • í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(367580,10211,'he','× × ×œ×›×œ×•×œ ×—×©×‘×•× ×•×ª GL',0),(367581,10211,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(367582,10211,'zh','è¯·åˆ—å…¥æ€»å¸å¸æˆ·\r\n',0),(367583,10211,'sv','VÃ¤nligen inkludera GL konton',0),(367584,10211,'it','Si prega di includere conti GL',0),(367585,10211,'tl','',0),(367586,10211,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸£à¸«à¸±à¸ªà¸šà¸±à¸à¸Šà¸µ',0),(367587,10211,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(367588,10211,'ms','Sila Sertakan akaun GL',0),(367589,10211,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª GL',0),(367590,10211,'fr','Veuillez inclure les comptes GL',0),(367591,10211,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(367592,10211,'pt','Por favor inclua contas GL',0),(367593,10211,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ GL ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(367594,10211,'es','Por Favor Incluye Cuentas del LM',0),(367595,10211,'de','Bitte geben Sie GL-Konten',0),(367596,10211,'en','Please Include GL Accounts',0),(367597,10212,'is','',0),(367598,10212,'dr','(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ) ÙØºØ§Ù„ÙŠØª Ø³Ø±Ù…Ø§ÙŠÙ‡',0),(367599,10212,'pr','Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ Ø§Ø² (Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ) ÙØºØ§Ù„ÙŠØª Ø³Ø±Ù…Ø§ÙŠÙ‡',0),(367600,10212,'tr','Nakit akÄ±ÅŸÄ± (iÃ§in kullanÄ±lan) sermayesi',0),(367601,10212,'pl','PrzepÅ‚ywy Å›rodkÃ³w pieniÄ™Å¼nych z (uÅ¼ywane) kapitaÅ‚u obrotowego',0),(367602,10212,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ð¾Ñ‚Ð¾Ðº Ð¾Ñ‚ (Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ Ð·Ð°) Ð¾Ð±Ð¾Ñ€Ð¾Ñ‚ÐµÐ½ ÐºÐ°Ð¿Ð¸Ñ‚Ð°Ð»',0),(367603,10212,'ur','Ú©ÛŒØ´ ÙÙ„Ùˆ (Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„) Ø³Û’ Ú©Ø§Ù… Ú©Ø±Ù†Û’ Ú©Û’ Ø¯Ø§Ø±Ø§Ù„Ø­Ú©ÙˆÙ…Øª',0),(367604,10212,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸ Ñ‚Ð¾Ðº Ð¸Ð· (Ñƒ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸) Ð¾Ð±Ñ€Ñ‚Ð½Ð° ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°',0),(367605,10212,'vi','LÆ°u chuyá»ƒn tiá»n (sá»­ dá»¥ng cho) Vá»‘n gÃ³p',0),(367606,10212,'af','Kontantvloei Vanaf (Gebruik Vir) Werkende Kapitaal',0),(367607,10212,'ro','Fluxul de numerar din (folosit pentru) capitalului de lucru',0),(367608,10212,'et','Rahavoog (kasutatakse) kÃ¤ibekapitali',0),(367609,10212,'si','Denarni tokovi iz (uporabljeni za) obratnih sredstev',0),(367610,10212,'ba','Arus kas dari (digunakan untuk) modal kerja',0),(367611,10212,'nl','Netto kasstroom uit (gebruikt voor) werkkapitaal',0),(367612,10212,'fi','Kassavirta (kÃ¤ytetty) kÃ¤yttÃ¶pÃ¤Ã¤oman',0),(367613,10212,'no','KontantstrÃ¸m fra (benyttet For) arbeidskapital',0),(367614,10212,'da','PengestrÃ¸mme fra (anvendt i) driftskapital',0),(367615,10212,'ko','(ì‚¬ìš©)ì—ì„œ í˜„ê¸ˆ íë¦„ ìžë³¸',0),(367616,10212,'he','×ª×–×¨×™× ×ž×–×•×ž× ×™× ×ž (×ž×©×ž×©) ×”×•×Ÿ ×—×•×–×¨',0),(367617,10212,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚ Î±Ï€ÏŒ (Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ¼ÎµÎ½Î± Î³Î¹Î±) ÎºÎµÏ†Î¬Î»Î±Î¹Î¿ ÎºÎ¯Î½Î·ÏƒÎ·Ï‚',0),(367618,10212,'zh','çŽ°é‡‘æµé‡ï¼ˆç”¨äºŽï¼‰è¥è¿èµ„é‡‘\r\n',0),(367619,10212,'sv','KassaflÃ¶de frÃ¥n (anvÃ¤nds fÃ¶r) rÃ¶relsekapital',0),(367620,10212,'it','Flusso di cassa da (usato per) capitale circolante',0),(367621,10212,'tl','',0),(367622,10212,'th','à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¸ˆà¸²à¸ (à¹ƒà¸Šà¹‰à¸ªà¸³à¸«à¸£à¸±à¸š) à¹€à¸‡à¸´à¸™à¸—à¸¸à¸™à¸«à¸¡à¸¸à¸™à¹€à¸§à¸µà¸¢à¸™',0),(367623,10212,'hi','(à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾) à¤¸à¥‡ à¤¨à¤•à¤¦à¥€ à¤ªà¥à¤°à¤µà¤¾à¤¹ à¤•à¤¾à¤°à¥à¤¯à¤¶à¥€à¤² à¤ªà¥‚à¤‚à¤œà¥€',0),(367624,10212,'ms','Aliran tunai daripada (digunakan untuk) modal kerja',0),(367625,10212,'ar','Ø§Ù„ØªØ¯ÙÙ‚Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ù…Ù† (Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„) Ø±Ø£Ø³ Ø§Ù„Ù…Ø§Ù„ Ø§Ù„Ø¹Ø§Ù…Ù„',0),(367626,10212,'fr','Flux de trÃ©sorerie provenant des (affectÃ©s aux) Fonds de roulement',0),(367627,10212,'jp','ï¼ˆä½¿ç”¨ï¼‰ ã‹ã‚‰ã®ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ» ãƒ•ãƒ­ãƒ¼é‹è»¢è³‡æœ¬',0),(367628,10212,'pt','Cash Flow (usado para) Capital de giro',0),(367629,10212,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿Ð¾Ñ‚Ð¾Ðº Ð¾Ñ‚ (Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ) Ð¾Ð±Ð¾Ñ€Ð¾Ñ‚Ð½Ð¾Ð³Ð¾ ÐºÐ°Ð¿Ð¸Ñ‚Ð°Ð»Ð°',0),(367630,10212,'es','Flujo de Efectivo de (Usado Por) Capital de Trabajo',0),(367631,10212,'de','Cash Flow aus (verwendet fÃ¼r) das Working Capital',0),(367632,10212,'en','Cash Flow From (Used For) Working Capital',0),(367633,10213,'is','',0),(367634,10213,'dr','/ ÙƒØ§Ù‡Ø´  Ø¯Ø± ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ ÙŠØ§ Ù…Ø¨Ø§Ø¯Ù„Ù‡Ø§ÙŠ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯',0),(367635,10213,'pr','Ø§ÙØ²Ø§ÙŠØ´  / ÙƒØ§Ù‡Ø´  Ø¯Ø± ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ ÙŠØ§ Ù…Ø¨Ø§Ø¯Ù„Ù‡Ø§ÙŠ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯',0),(367636,10213,'tr','Azaltmak/artÄ±rmak nakit ve nakit benzeri Varlâ€ºklar',0),(367637,10213,'pl','Zmniejszenie/zwiÄ™kszenie Å›rodkÃ³w pieniÄ™Å¼nych i ekwiwalentÃ³w Å›rodkÃ³w pieniÄ™Å¼nych',0),(367638,10213,'bg','ÐÐ°Ð¼Ð°Ð»ÐµÐ½Ð¸Ðµ/ÑƒÐ²ÐµÐ»Ð¸Ñ‡ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¸ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ ÐµÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ð¸',0),(367639,10213,'ur','Ú©Ù…ÛŒ/Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ø§ÙˆØ± Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©Û’ Ù…ØªØ±Ø§Ø¯Ù Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ',0),(367640,10213,'sr','Ð¡Ð¼Ð°ÑšÐµÑšÐµ /Ð¿Ð¾Ð²ÐµÑ›Ð°ÑšÐµ Ñƒ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ð¸ Ð¸ ÐµÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ð¸Ð¼Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ',0),(367641,10213,'vi','TÄƒng/ giáº£m cá»§a tiá»n vÃ  cÃ¡c khoáº£n tÆ°Æ¡ng Ä‘Æ°Æ¡ng tiá»n',0),(367642,10213,'af','Vermindering/Vermeerdering in Kontant en Kontant Ekwivalente',0),(367643,10213,'ro','MicÅŸorare/mÄƒrire Ã®n numerar ÅŸi echivalente de numerar',0),(367644,10213,'et','VÃ¤henemine/suurenemine raha ja raha ekvivalendid',0),(367645,10213,'si','ZmanjÅ¡anje/poveÄanje denarnih sredstev in njihovih ustreznikov',0),(367646,10213,'ba','Penurunan/peningkatan kas dan setara kas',0),(367647,10213,'nl','Verkleinen/vergroten in geldmiddelen en kasequivalenten',0),(367648,10213,'fi','VÃ¤hennys/lisÃ¤ys rahavarat',0),(367649,10213,'no','Ã˜ke/redusere i kontanter og bankinnskudd',0),(367650,10213,'da','Ã˜ge/mindske i kontanter og likvide aktiver',0),(367651,10213,'ko','í˜„ê¸ˆ ë° í˜„ê¸ˆ ë“±ê°€ë¬¼ì˜ ê°ì†Œ/ì¦ê°€',0),(367652,10213,'he','×”×§×˜× ×”/×”×’×“×œ×” ×©×œ ×ž×–×•×ž× ×™× ×•×©×•×•×™ ×ž×–×•×ž× ×™×',0),(367653,10213,'el','ÎœÎµÎ¯Ï‰ÏƒÎ·/Î±ÏÎ¾Î·ÏƒÎ· ÏƒÏ„Î± Ï„Î±Î¼ÎµÎ¹Î±ÎºÎ¬ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± ÎºÎ±Î¹ Î¹ÏƒÎ¿Î´ÏÎ½Î±Î¼Î±',0),(367654,10213,'zh','çŽ°é‡‘åŠçŽ°é‡‘ç­‰å€¼é¡¹ç›®å¢žåŠ å‡å°‘\r\n',0),(367655,10213,'sv','Ã–kning/minskning likvida medel',0),(367656,10213,'it','Diminuire o aumentare in liquide e mezzi equivalenti',0),(367657,10213,'tl','',0),(367658,10213,'th','à¸¥à¸”à¸¥à¸‡/à¹€à¸žà¸´à¹ˆà¸¡à¸‚à¸¶à¹‰à¸™à¹€à¸‡à¸´à¸™à¸ªà¸”à¹à¸¥à¸°à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸—à¸µà¸¢à¸šà¹€à¸—à¹ˆà¸²à¹€à¸‡à¸´à¸™à¸ªà¸”',0),(367659,10213,'hi','à¤¨à¤•à¤¦ à¤”à¤° à¤¨à¤•à¤¦à¥€ à¤¸à¤®à¤•à¤•à¥à¤· à¤®à¥‡à¤‚ à¤•à¤®à¥€/à¤µà¥ƒà¤¦à¥à¤§à¤¿',0),(367660,10213,'ms','Penurunan/kenaikan dalam Tunai dan tunai setara',0),(367661,10213,'ar','Ø§Ù„Ù†Ù‚ØµØ§Ù†/Ø§Ù„Ø²ÙŠØ§Ø¯Ø© ÙÙŠ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© ÙˆØ´Ø¨Ù‡ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(367662,10213,'fr','Diminution/augmentation des espÃ¨ces et quasi-espÃ¨ces',0),(367663,10213,'jp','ç¾é‡‘åŠã³ç¾é‡‘åŒç­‰ç‰©ã®å¢—æ¸›',0),(367664,10213,'pt','Diminuir/aumentar em caixa e equivalentes',0),(367665,10213,'ru','Ð£Ð¼ÐµÐ½ÑŒÑˆÐµÐ½Ð¸Ðµ/ÑƒÐ²ÐµÐ»Ð¸Ñ‡ÐµÐ½Ð¸Ðµ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð² Ð¸ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ð¾Ð²',0),(367666,10213,'es','ReducciÃ³n/Aumento en Efectivo y Equivalentes de Efectivo',0),(367667,10213,'de','Abnahme/Zunahme FlÃ¼ssige Mittel',0),(367668,10213,'en','Decrease/Increase in Cash and Cash Equivalents',0),(367669,10214,'is','',0),(367670,10214,'dr','ØµÙˆØ±Øª Ø¬Ø±ÙŠØ§Ù†Ù‡Ø§ÙŠ Ù†Ù‚Ø¯ÙŠ',0),(367671,10214,'pr','ØµÙˆØ±Øª Ø¬Ø±ÙŠØ§Ù†Ù‡Ø§ÙŠ Ù†Ù‚Ø¯ÙŠ',0),(367672,10214,'tr','Deyim bir nakit akÄ±ÅŸÄ±',0),(367673,10214,'pl','PrzepÅ‚ywÃ³w Å›rodkÃ³w pieniÄ™Å¼nych',0),(367674,10214,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸',0),(367675,10214,'ur','Ù†Ù‚Ø¯ Ø¨ÛØ§Ø¤ Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(367676,10214,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ñ‚Ð¾ÐºÐ¾Ð²Ð¸Ð¼Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ',0),(367677,10214,'vi','Báº£n bÃ¡o cÃ¡o dÃ²ng tiá»n',0),(367678,10214,'af','Staat vir Kontantvloei',0),(367679,10214,'ro','DeclaraÅ£ie de fluxuri de numerar',0),(367680,10214,'et','Rahavoogude aruanne',0),(367681,10214,'si','Izkaz denarnih tokov',0),(367682,10214,'ba','Laporan arus kas',0),(367683,10214,'nl','Kasstroomoverzicht',0),(367684,10214,'fi','Konsernin rahavirtalaskelma',0),(367685,10214,'no','Oversikt over kontantstrÃ¸m',0),(367686,10214,'da','ErklÃ¦ring af pengestrÃ¸mme',0),(367687,10214,'ko','í˜„ê¸ˆ íë¦„ì˜ ê³„ì‚° ì„œ',0),(367688,10214,'he','×“×•×— ×ª×–×¨×™×ž×™ ×ž×–×•×ž× ×™×',0),(367689,10214,'el','ÎšÎ‘Î¤Î‘Î£Î¤Î‘Î£Î— Î¤Î‘ÎœÎ•Î™Î‘ÎšÎ©Î Î¡ÎŸÎ©Î',0),(367690,10214,'zh','çŽ°é‡‘æµé‡å£°æ˜Ž\r\n',0),(367691,10214,'sv','KassaflÃ¶desanalys',0),(367692,10214,'it','Rendiconto finanziario',0),(367693,10214,'tl','',0),(367694,10214,'th','à¸‡à¸šà¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(367695,10214,'hi','à¤¨à¤•à¤¦ à¤ªà¥à¤°à¤µà¤¾à¤¹à¥‹à¤‚ à¤•à¤¾ à¤•à¤¥à¤¨',0),(367696,10214,'ms','Penyata aliran tunai',0),(367697,10214,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„ØªØ¯ÙÙ‚Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(367698,10214,'fr','Flux de trÃ©sorerie',0),(367699,10214,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ» ãƒ•ãƒ­ãƒ¼è¨ˆç®—æ›¸',0),(367700,10214,'pt','DemonstraÃ§Ã£o dos fluxos de caixa',0),(367701,10214,'ru','Ðž Ð´Ð²Ð¸Ð¶ÐµÐ½Ð¸Ð¸ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(367702,10214,'es','DeclaraciÃ³n de Flujos del Efectivo',0),(367703,10214,'de','Kapitalflussrechnung',0),(367704,10214,'en','Statement of Cash Flows',0),(367705,10215,'is','',0),(367706,10215,'dr','Ø³Ø§Ù„ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(367707,10215,'pr','Ø³Ø§Ù„ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(367708,10215,'tr','YÄ±l-Tarih',0),(367709,10215,'pl','Roku do data',0),(367710,10215,'bg','Ð“Ð¾Ð´Ð¸Ð½Ð° ÐºÑŠÐ¼ Ð´Ð°Ñ‚Ð°',0),(367711,10215,'ur','Ø³Ø§Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(367712,10215,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(367713,10215,'vi','NÄƒm Ä‘áº¿n ngÃ y',0),(367714,10215,'af','Jaar-tot-Datum',0),(367715,10215,'ro','An-la-data',0),(367716,10215,'et','Aasta algusest tÃ¤naseni',0),(367717,10215,'si','Leto do datuma',0),(367718,10215,'ba','Tahun-To-Date',0),(367719,10215,'nl','Jaar-To-Date',0),(367720,10215,'fi','Vuoden alusta',0),(367721,10215,'no','Hittil i Ã¥r',0),(367722,10215,'da','Ã…r-til-dato',0),(367723,10215,'ko','1 ë…„-ë‚ ì§œ',0),(367724,10215,'he','×”×©× ×” ×¢×“ ×”×™×•×',0),(367725,10215,'el','ÎˆÏ„Î¿Ï‚-To-Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(367726,10215,'zh','ä»Šå¹´æœ€æ–°\r\n',0),(367727,10215,'sv','Year-To-Date',0),(367728,10215,'it','Year-To-Date',0),(367729,10215,'tl','',0),(367730,10215,'th','à¸›à¸µà¸§à¸±à¸™',0),(367731,10215,'hi','à¤µà¤°à¥à¤·-à¤¤à¤¾à¤°à¥€à¤–',0),(367732,10215,'ms','Tahun sehingga kini',0),(367733,10215,'ar','Ø§Ù„Ø³Ù†Ø© Ø¥Ù„Ù‰ ØªØ§Ø±ÙŠØ®',0),(367734,10215,'fr','AnnÃ©e Ã  ce jour',0),(367735,10215,'jp','å¹´ã®æ—¥ä»˜',0),(367736,10215,'pt','Year-To-Date',0),(367737,10215,'ru','Ð“Ð¾Ð´ Ðº Ð”Ð°Ñ‚Ð°',0),(367738,10215,'es','AÃ±o a la Fecha',0),(367739,10215,'de','Year-To-Date',0),(367740,10215,'en','Year-To-Date',0),(367741,10216,'is','',0),(367742,10216,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†   Ù†ÙŠØ³Øª',0),(367743,10216,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†   Ù†ÙŠØ³Øª',0),(367744,10216,'tr','BulunamadÄ±',0),(367745,10216,'pl','Nie mogÅ‚em znaleÅºÄ‡',0),(367746,10216,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸',0),(367747,10216,'ur','Ù†ÛÛŒÚº Ù…Ù„ Ø³Ú©Ø§',0),(367748,10216,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸',0),(367749,10216,'vi','khÃ´ng thá»ƒ tÃ¬m tháº¥y',0),(367750,10216,'af','Kon vind nie',0),(367751,10216,'ro','Nu am putut gÄƒsi',0),(367752,10216,'et','Ei leitud',0),(367753,10216,'si','Ni bilo mogoÄe najti',0),(367754,10216,'ba','Tidak dapat menemukan',0),(367755,10216,'nl','Kon het niet vinden',0),(367756,10216,'fi','Ei lÃ¶ytynyt',0),(367757,10216,'no','Finner ikke',0),(367758,10216,'da','Kunne ikke finde',0),(367759,10216,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(367760,10216,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•×',0),(367761,10216,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰',0),(367762,10216,'zh','æ‰¾ä¸åˆ°\r\n',0),(367763,10216,'sv','Kunde inte hitta',0),(367764,10216,'it','Non poteva trovare',0),(367765,10216,'tl','',0),(367766,10216,'th','à¹„à¸¡à¹ˆà¸žà¸š',0),(367767,10216,'hi','à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(367768,10216,'ms','Tidak dapat mencari',0),(367769,10216,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(367770,10216,'fr','N\'a pas trouvÃ©',0),(367771,10216,'jp','è¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(367772,10216,'pt','NÃ£o foi possÃ­vel encontrar',0),(367773,10216,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÐÐ°Ð¹Ñ‚Ð¸',0),(367774,10216,'es','No se PodÃ­a Encontrar',0),(367775,10216,'de','Konnte nicht gefunden werden',0),(367776,10216,'en','Could Not Find',0),(367777,10217,'is','',0),(367778,10217,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ÙƒÙ†ØªØ±Ù„ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª Ùˆ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ Ù¾Ø±ÙˆÚ˜Ù‡ Ù‡Ø§\r\n MS Project Data',0),(367779,10217,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ÙƒÙ†ØªØ±Ù„ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª Ùˆ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ Ù¾Ø±ÙˆÚ˜Ù‡ Ù‡Ø§\r\n MS Project Data',0),(367780,10217,'tr','Ä°thalat MS proje verileri',0),(367781,10217,'pl','MS importu danych projektu',0),(367782,10217,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ MS Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð´Ð°Ð½Ð½Ð¸',0),(367783,10217,'ur','Ø¯Ø±Ø¢Ù…Ø¯ MS Ù¾Ø±ÙˆØ¬ÛŒÚ©Ù¹ ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³',0),(367784,10217,'sr','Ð£Ð²Ð¾Ð· ÐœÐ¡ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(367785,10217,'vi','Nháº­p sá»‘ liá»‡u káº¿ hoáº¡ch MS',0),(367786,10217,'af','Invoer van MS Project Data',0),(367787,10217,'ro','Datele de proiect de import MS',0),(367788,10217,'et','Impordi MS Project andmed',0),(367789,10217,'si','Uvoz MS Project podatkov',0),(367790,10217,'ba','MS impor Data proyek',0),(367791,10217,'nl','Import MS Project-gegevens',0),(367792,10217,'fi','Tuonti MS Project Data',0),(367793,10217,'no','Importer MS Project-Data',0),(367794,10217,'da','Importere MS Project-Data',0),(367795,10217,'ko','ê°€ì ¸ì˜¤ê¸° MS í”„ë¡œì íŠ¸ ë°ì´í„°',0),(367796,10217,'he','× ×ª×•× ×™ ×¤×¨×•×™×™×§×˜ MS ×”×™×™×‘×•×',0),(367797,10217,'el','MS ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î­ÏÎ³Î¿Ï…',0),(367798,10217,'zh','å¯¼å…¥å¾®è½¯é¡¹ç›®æ•°æ®\r\n',0),(367799,10217,'sv','Importera MS Project-Data',0),(367800,10217,'it','Dati di progetto di importazione di MS',0),(367801,10217,'tl','',0),(367802,10217,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹‚à¸„à¸£à¸‡à¸à¸²à¸£ MS à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(367803,10217,'hi','à¤†à¤¯à¤¾à¤¤ à¤à¤®à¤à¤¸ à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤¡à¥‡à¤Ÿà¤¾',0),(367804,10217,'ms','Import MS Data projek',0),(367805,10217,'ar','Ù…Ø±Ø¶ Ø§Ù„ØªØµÙ„Ø¨ Ø§Ù„Ø¹ØµØ¨ÙŠ Ø§Ù„Ù…ØªØ¹Ø¯Ø¯ Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(367806,10217,'fr','DonnÃ©es de projet importation MS',0),(367807,10217,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ MS ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆ ãƒ‡ãƒ¼ã‚¿',0),(367808,10217,'pt','Dados de projeto de importaÃ§Ã£o MS',0),(367809,10217,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° MS Project',0),(367810,10217,'es','Importar Datos del MS Project',0),(367811,10217,'de','Import von MS-Project-Daten',0),(367812,10217,'en','Import MS Project Data',0),(367813,10218,'is','',0),(367814,10218,'dr','MS Project ÙØ§ÙŠÙ„ Ø³Ø§ÙØª ÙˆÛŒØ±ÙŠ  ÙƒÙ‡ Ø¨Ø±Ø§ÙŠ ÙƒÙ†ØªØ±Ù„ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª Ùˆ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ Ù¾Ø±ÙˆÚ˜Ù‡ Ù‡Ø§ Ø¨Ù‡ ÙƒØ§Ø± Ù…ÙŠ Ø±ÙˆØ¯',0),(367815,10218,'pr','MS Project ÙØ§ÙŠÙ„ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±ÙŠ  ÙƒÙ‡ Ø¨Ø±Ø§ÙŠ ÙƒÙ†ØªØ±Ù„ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª Ùˆ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ Ù¾Ø±ÙˆÚ˜Ù‡ Ù‡Ø§ Ø¨Ù‡ ÙƒØ§Ø± Ù…ÙŠ Ø±ÙˆØ¯',0),(367816,10218,'tr','MS proje dosyasÄ±',0),(367817,10218,'pl','Plik MS Project',0),(367818,10218,'bg','MS Project Ñ„Ð°Ð¹Ð»',0),(367819,10218,'ur','MS Ù¾Ø±Ø§Ø¬ÛŒÚ©Ù¹ Ù…Ø³Ù„',0),(367820,10218,'sr','ÐœÐ¡ ÐŸÑ€Ð¾Ñ˜ÐµÑ†Ñ‚ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(367821,10218,'vi','File dá»± Ã¡n MS',0),(367822,10218,'af','MS Project LÃªer',0),(367823,10218,'ro','MS Project fiÅŸier',0),(367824,10218,'et','MS Projecti failis',0),(367825,10218,'si','MS Project datoteki',0),(367826,10218,'ba','MS Project File',0),(367827,10218,'nl','MS Project-bestand',0),(367828,10218,'fi','MS Project-tiedosto',0),(367829,10218,'no','MS Project-fil',0),(367830,10218,'da','MS Project-fil',0),(367831,10218,'ko','MS í”„ë¡œì íŠ¸ íŒŒì¼',0),(367832,10218,'he','×§×•×‘×¥ MS Project',0),(367833,10218,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ MS Project',0),(367834,10218,'zh','MSé¡¹ç›®æ–‡ä»¶\r\n',0),(367835,10218,'sv','MS Project-filen',0),(367836,10218,'it','MS Project File',0),(367837,10218,'tl','',0),(367838,10218,'th','à¹à¸Ÿà¹‰à¸¡à¹‚à¸„à¸£à¸‡à¸à¸²à¸£ MS',0),(367839,10218,'hi','à¤à¤®à¤à¤¸ à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤«à¤¼à¤¾à¤‡à¤²',0),(367840,10218,'ms','Fail MS projek',0),(367841,10218,'ar','Ù…Ù„Ù Ø§Ù„Ù…Ø´Ø±ÙˆØ¹ MS',0),(367842,10218,'fr','Fichier MS Project',0),(367843,10218,'jp','MS ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«',0),(367844,10218,'pt','Arquivo do MS Project',0),(367845,10218,'ru','Ð¤Ð°Ð¹Ð» MS Project',0),(367846,10218,'es','File de MS Project',0),(367847,10218,'de','MS Project-Datei',0),(367848,10218,'en','MS Project File',0),(367849,10219,'is','',0),(367850,10219,'dr','/ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(367851,10219,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‡Ø§ÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  / ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(367852,10219,'tr','PO/SB gÃ¼ncellemeleri',0),(367853,10219,'pl','Aktualizacje PO/SB',0),(367854,10219,'bg','PO/SB Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(367855,10219,'ur','Ù¾Ùˆ ÙØ±ÛŒØ¶Û Ø³Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯Û’ Ø§Ù¾ ÚˆÛŒÙ¹Ø³',0),(367856,10219,'sr','ÐŸÐž /Ð¡Ð‘ Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐµ',0),(367857,10219,'vi','Cáº­p nháº­t PO/SB',0),(367858,10219,'af','PO/SB bywerkings',0),(367859,10219,'ro','PO/SB actualizÄƒri',0),(367860,10219,'et','PO/SB uuendused',0),(367861,10219,'si','PO/SB posodobitve',0),(367862,10219,'ba','PO SB update',0),(367863,10219,'nl','PO/SB Updates',0),(367864,10219,'fi','PO/SB pÃ¤ivitykset',0),(367865,10219,'no','PO/SB oppdateringer',0),(367866,10219,'da','PO/SB opdateringer',0),(367867,10219,'ko','í¬/SB ì—…ë°ì´íŠ¸',0),(367868,10219,'he','×¢×“×›×•× ×™× ×¤×•/SB',0),(367869,10219,'el','PO/SB ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹Ï‚',0),(367870,10219,'zh','è®¢å•/æœåŠ¡å…¬å‘Šæ–°\r\n',0),(367871,10219,'sv','PO/SB uppdateringar',0),(367872,10219,'it','Aggiornamenti di PO/SB',0),(367873,10219,'tl','',0),(367874,10219,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡ PO/SB',0),(367875,10219,'hi','à¤ªà¥€à¤“/SB à¤…à¤ªà¤¡à¥‡à¤Ÿ',0),(367876,10219,'ms','Pengemaskinian PO/SB',0),(367877,10219,'ar','Øµ. Ø¨/SB Ø§Ù„ØªØ­Ø¯ÙŠØ«Ø§Øª',0),(367878,10219,'fr','Mises Ã  jour PO/SB',0),(367879,10219,'jp','PO/SB æ›´æ–°',0),(367880,10219,'pt','AtualizaÃ§Ãµes de PO/SB',0),(367881,10219,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ PO/SB',0),(367882,10219,'es','OC/SB Actualizaciones',0),(367883,10219,'de','PO/SB-Aktuelles',0),(367884,10219,'en','PO/SB Updates',0),(367885,10220,'is','',0),(367886,10220,'dr','(Ø³ÙˆØ§Ø¨Ù‚) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯ ',0),(367887,10220,'pr','Ø§Ø³Ù†Ø§Ø¯ (Ø³ÙˆØ§Ø¨Ù‚) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯ ',0),(367888,10220,'tr','KayÄ±t baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(367889,10220,'pl','RekordÃ³w pomyÅ›lnie zaktualizowana',0),(367890,10220,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(367891,10220,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(367892,10220,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(367893,10220,'vi','Ä‘Ã£ cáº­p nháº­t há»“ sÆ¡ thÃ nh cÃ´ng',0),(367894,10220,'af','Rekords Suksesvol Opdateer',0),(367895,10220,'ro','ÃŽnregistrÄƒri actualizate cu succes',0),(367896,10220,'et','Kirjete vÃ¤rskendamine Ãµnnestus',0),(367897,10220,'si','Zapisi, ki uspeÅ¡no posodobljena',0),(367898,10220,'ba','Catatan yang berhasil',0),(367899,10220,'nl','Records bijgewerkt',0),(367900,10220,'fi','Tietueiden pÃ¤ivittÃ¤minen onnistui',0),(367901,10220,'no','Poster som er oppdatert',0),(367902,10220,'da','Poster opdateret',0),(367903,10220,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ë ˆì½”ë“œ',0),(367904,10220,'he','×¨×©×•×ž×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(367905,10220,'el','Î‘ÏÏ‡ÎµÎ¯Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ½Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(367906,10220,'zh','æˆåŠŸæ›´æ–°è®°å½•\r\n',0),(367907,10220,'sv','Poster uppdaterades',0),(367908,10220,'it','Record aggiornato con successo',0),(367909,10220,'tl','',0),(367910,10220,'th','à¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(367911,10220,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾',0),(367912,10220,'ms','Rekod-rekod yang berjaya dikemas kini',0),(367913,10220,'ar','Ø­Ø¯Ù‘Ø«Øª Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(367914,10220,'fr','Dossiers mis Ã  jour avec succÃ¨s',0),(367915,10220,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸãƒ¬ã‚³ãƒ¼ãƒ‰',0),(367916,10220,'pt','Registros atualizados com sucesso',0),(367917,10220,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(367918,10220,'es','Records Actualizados Exitosamente',0),(367919,10220,'de','DatensÃ¤tze, die erfolgreich aktualisiert',0),(367920,10220,'en','Records Updated Successfully',0),(367921,10221,'is','',0),(367922,10221,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ ÙƒÙ†ØªØ±Ù„ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª Ùˆ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ Ù¾Ø±ÙˆÚ˜Ù‡ Ù‡Ø§\r\n MS Project ',0),(367923,10221,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ ÙƒÙ†ØªØ±Ù„ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª Ùˆ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ Ù¾Ø±ÙˆÚ˜Ù‡ Ù‡Ø§\r\n MS Project ',0),(367924,10221,'tr','MS proje dosyasÄ±nÄ± seÃ§in',0),(367925,10221,'pl','Wybierz plik MS Project',0),(367926,10221,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð» Ñ MS Project',0),(367927,10221,'ur','MS Ù¾Ø±Ø§Ø¬ÛŒÚ©Ù¹ Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(367928,10221,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð° ÐœÐ¡',0),(367929,10221,'vi','Chá»n táº­p tin dá»± Ã¡n MS',0),(367930,10221,'af','Selekteer MS Project LÃªer',0),(367931,10221,'ro','SelectaÅ£i fiÅŸierul MS Project',0),(367932,10221,'et','Valige MS Projecti failis',0),(367933,10221,'si','Izberite datoteko MS Project',0),(367934,10221,'ba','Pilih File MS Project',0),(367935,10221,'nl','Selecteer bestand van MS Project',0),(367936,10221,'fi','Valitse MS Project-tiedosto',0),(367937,10221,'no','Velg MS Project-fil',0),(367938,10221,'da','VÃ¦lg MS Project-fil',0),(367939,10221,'ko','MS í”„ë¡œì íŠ¸ íŒŒì¼ì„ ì„ íƒ',0),(367940,10221,'he','×‘×—×¨ ×§×•×‘×¥ ×”×¤×¨×•×™×™×§×˜ MS',0),(367941,10221,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï„Î¿Ï… MS Project',0),(367942,10221,'zh','é€‰æ‹©MS é¡¹ç›®æ–‡ä»¶\r\n',0),(367943,10221,'sv','VÃ¤lj MS Project-filen',0),(367944,10221,'it','Selezionare il File di progetto di MS',0),(367945,10221,'tl','',0),(367946,10221,'th','à¹€à¸¥à¸·à¸­à¸à¹à¸Ÿà¹‰à¸¡à¹‚à¸„à¸£à¸‡à¸à¸²à¸£ MS',0),(367947,10221,'hi','à¤à¤®à¤à¤¸ à¤ªà¥à¤°à¥‹à¤œà¥‡à¤•à¥à¤Ÿ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(367948,10221,'ms','Pilih fail MS projek',0),(367949,10221,'ar','Ø­Ø¯Ø¯ Ù…Ù„Ù Ø§Ù„Ù…Ø´Ø±ÙˆØ¹ MS',0),(367950,10221,'fr','SÃ©lectionnez le fichier MS Project',0),(367951,10221,'jp','MS ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(367952,10221,'pt','Selecione o arquivo do MS Project',0),(367953,10221,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ„Ð°Ð¹Ð» MS Project',0),(367954,10221,'es','Selecciona el File de MS Project',0),(367955,10221,'de','WÃ¤hlen Sie MS Project-Datei',0),(367956,10221,'en','Select MS Project File',0),(367957,10222,'is','',0),(367958,10222,'dr','MS Project Records',0),(367959,10222,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ø³Ù†Ø§Ø¯ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ÙƒÙ†ØªØ±Ù„ Ùˆ Ù…Ø¯ÙŠØ±ÙŠØª Ùˆ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÙŠ Ù¾Ø±ÙˆÚ˜Ù‡ Ù‡Ø§ MS Project Records',0),(367960,10222,'tr','Toplam MS proje kayÄ±tlarÄ±',0),(367961,10222,'pl','Records caÅ‚kowita MS Project',0),(367962,10222,'bg','ÐžÐ±Ñ‰Ð¾ MS Project Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(367963,10222,'ur','Ú©Ù„ MS Ù…Ù†ØµÙˆØ¨Û’ Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(367964,10222,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð° ÐœÐ¡ Ð·Ð°Ð¿Ð¸ÑÐµ',0),(367965,10222,'vi','Tá»•ng sá»‘ há»“ sÆ¡ dá»± Ã¡n MS',0),(367966,10222,'af','Totale MS Project Rekords',0),(367967,10222,'ro','Total MS Project Records',0),(367968,10222,'et','Kokku MS Project kirjed',0),(367969,10222,'si','Skupni projekt MS zapisov',0),(367970,10222,'ba','Catatan Total MS Project',0),(367971,10222,'nl','Totale MS Project Records',0),(367972,10222,'fi','MS hankkeen tietueet',0),(367973,10222,'no','Totalt MS Project poster',0),(367974,10222,'da','Samlede MS Project poster',0),(367975,10222,'ko','ì´ MS í”„ë¡œì íŠ¸ ê¸°ë¡',0),(367976,10222,'he','×¡×” ×› MS Project ×¨×©×•×ž×•×ª',0),(367977,10222,'el','Î£ÏÎ½Î¿Î»Î¿ MS Project ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(367978,10222,'zh','æ€»è®¡MSé¡¹ç›®è®°å½•\r\n',0),(367979,10222,'sv','Totala MS Project poster',0),(367980,10222,'it','Totale MS Project Records',0),(367981,10222,'tl','',0),(367982,10222,'th','à¹‚à¸„à¸£à¸‡à¸à¸²à¸£ MS à¸£à¸§à¸¡à¸£à¸°à¹€à¸šà¸µà¸¢à¸™',0),(367983,10222,'hi','à¤•à¥à¤² à¤à¤®à¤à¤¸ à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸',0),(367984,10222,'ms','Rekod-rekod jumlah MS projek',0),(367985,10222,'ar','Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ø§Ù„ÙƒÙ„ÙŠØ© Ù„Ù„Ù…Ø´Ø±ÙˆØ¹ MS',0),(367986,10222,'fr','Total MS Project Records',0),(367987,10222,'jp','MS ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®ç·è¨˜éŒ²',0),(367988,10222,'pt','Total MS Project Records',0),(367989,10222,'ru','Ð’ÑÐµÐ³Ð¾ MS Project Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(367990,10222,'es','Records Totales para MS Project',0),(367991,10222,'de','Total MS Project Records',0),(367992,10222,'en','Total MS Project Records',0),(367993,10223,'is','',0),(367994,10223,'dr','ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ù…Ù† ',0),(367995,10223,'pr','ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ù…Ù† ',0),(367996,10223,'tr','TÃ¼m ÅŸirketler',0),(367997,10223,'pl','Wszystkich moich firm',0),(367998,10223,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸Ñ‚Ðµ ÑÐ¸ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(367999,10223,'ur','Ù…ÛŒØ±ÛŒ ØªÙ…Ø§Ù… Ú©Ù…Ù¾Ù†ÛŒÙˆÚº',0),(368000,10223,'sr','Ð¡Ð²Ðµ Ð¼Ð¾Ñ˜Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(368001,10223,'vi','Táº¥t cáº£ cÃ´ng ty cá»§a tÃ´i',0),(368002,10223,'af','Al My Ondernemings',0),(368003,10223,'ro','Toate companiile mele',0),(368004,10223,'et','Minu ettevÃµtted',0),(368005,10223,'si','Vse moje druÅ¾be',0),(368006,10223,'ba','Semua perusahaan saya',0),(368007,10223,'nl','Alle mijn bedrijven',0),(368008,10223,'fi','Kaikki yritykset',0),(368009,10223,'no','Alle mine selskaper',0),(368010,10223,'da','Alle mine virksomheder',0),(368011,10223,'ko','ë‚´ ëª¨ë“  íšŒì‚¬',0),(368012,10223,'he','×›×œ ×”×—×‘×¨×•×ª ×©×œ×™',0),(368013,10223,'el','ÎŒÎ»ÎµÏ‚ Î¼Î¿Ï… Î¿Î¹ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚',0),(368014,10223,'zh','æˆ‘å…¬å¸æ‰€æœ‰\r\n',0),(368015,10223,'sv','Alla mina fÃ¶retag',0),(368016,10223,'it','Tutte le mie imprese',0),(368017,10223,'tl','',0),(368018,10223,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(368019,10223,'hi','à¤®à¥‡à¤°à¥‡ à¤¸à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¤¾à¤‚',0),(368020,10223,'ms','Semua syarikat saya',0),(368021,10223,'ar','Ø¬Ù…ÙŠØ¹ Ø´Ø±ÙƒØ§Øª Ø¨Ù„Ø¯ÙŠ',0),(368022,10223,'fr','Toutes mes entreprises',0),(368023,10223,'jp','ç§ã®ä¼šç¤¾',0),(368024,10223,'pt','Todas as minhas empresas',0),(368025,10223,'ru','Ð’ÑÐµ Ð¼Ð¾Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(368026,10223,'es','Todas Mis Empresas',0),(368027,10223,'de','Alle meine Unternehmen',0),(368028,10223,'en','All My Companies',0),(368029,10224,'is','',0),(368030,10224,'dr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ù…Ø§Ù„Ùƒ',0),(368031,10224,'pr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ù…Ø§Ù„Ùƒ',0),(368032,10224,'tr','Sahibine gÃ¶re bilanÃ§o',0),(368033,10224,'pl','Bilans przez wÅ‚aÅ›ciciela',0),(368034,10224,'bg','Ð‘Ð°Ð»Ð°Ð½Ñ Ð¾Ñ‚ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸Ðº',0),(368035,10224,'ur','Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ Ú©Û’ Ù…Ø§Ù„Ú© Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(368036,10224,'sr','Ð‘Ð¸Ð»Ð°Ð½Ñ ÑÑ‚Ð°ÑšÐ° Ð¿Ñ€ÐµÐ¼Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÐºÑƒ',0),(368037,10224,'vi','Bang cÃ¢n Ä‘á»‘i theo chá»§ sá»Ÿ há»¯u',0),(368038,10224,'af','Balansstaat per Eienaar',0),(368039,10224,'ro','BilanÅ£ de proprietar',0),(368040,10224,'et','Bilansi omaniku jÃ¤rgi',0),(368041,10224,'si','Bilance stanja po lastniku',0),(368042,10224,'ba','Neraca oleh pemilik',0),(368043,10224,'nl','Balans door eigenaar',0),(368044,10224,'fi','Taseen omistaja',0),(368045,10224,'no','Balansen av eier',0),(368046,10224,'da','Balancen af ejeren',0),(368047,10224,'ko','ëŒ€ì°¨ ëŒ€ì¡°í‘œ ì†Œìœ ìž',0),(368048,10224,'he','×ž××–×Ÿ ×œ×¤×™ ×‘×¢×œ×™×',0),(368049,10224,'el','Î™ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î±Ï€ÏŒ Ï„Î¿Î½ Î¹Î´Î¹Î¿ÎºÏ„Î®Ï„Î·',0),(368050,10224,'zh','èµ„äº§è´Ÿå€ºè¡¨æ‰€æœ‰è€…\r\n',0),(368051,10224,'sv','BalansrÃ¤kningen av Ã¤garen',0),(368052,10224,'it','Stato patrimoniale dal proprietario',0),(368053,10224,'tl','',0),(368054,10224,'th','à¸‡à¸šà¸”à¸¸à¸¥ à¹‚à¸”à¸¢à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡',0),(368055,10224,'hi','à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ à¤•à¥‡ à¤®à¤¾à¤²à¤¿à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(368056,10224,'ms','Kunci kira-kira oleh pemilik',0),(368057,10224,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¹Ù…ÙˆÙ…ÙŠØ© Ø­Ø³Ø¨ Ø§Ù„Ù…Ø§Ù„Ùƒ',0),(368058,10224,'fr','Bilan par propriÃ©taire',0),(368059,10224,'jp','æ‰€æœ‰è€…ã«ã‚ˆã‚‹ãƒãƒ©ãƒ³ã‚¹ ã‚·ãƒ¼ãƒˆ',0),(368060,10224,'pt','BalanÃ§o pelo proprietÃ¡rio',0),(368061,10224,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ Ð¿Ð¾ Ð²Ð»Ð°Ð´ÐµÐ»ÑŒÑ†Ñƒ',0),(368062,10224,'es','Hoja de Balance por DueÃ±o',0),(368063,10224,'de','Bilanz des EigentÃ¼mers',0),(368064,10224,'en','Balance Sheet by Owner',0),(368065,10225,'is','',0),(368066,10225,'dr','ØªØ±Ø§Ø² Ù†Ø§Ù…Ù‡ Ù…Ù†',0),(368067,10225,'pr','ØªØ±Ø§Ø² Ù†Ø§Ù…Ù‡ Ù…Ù†',0),(368068,10225,'tr','Benim bilanÃ§o',0),(368069,10225,'pl','MÃ³j bilans',0),(368070,10225,'bg','ÐœÐ¾ÑÑ‚ Ð±Ð°Ð»Ð°Ð½ÑÐ¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(368071,10225,'ur','Ù…ÛŒØ±Ø§ Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹',0),(368072,10225,'sr','ÐœÐ¾Ñ˜ Ð±Ð¸Ð»Ð°Ð½Ñ ÑÑ‚Ð°ÑšÐ°',0),(368073,10225,'vi','Báº£ng cÃ¢n Ä‘á»‘i cá»§a tÃ´i',0),(368074,10225,'af','My Balansstaat',0),(368075,10225,'ro','Meu bilanÅ£',0),(368076,10225,'et','Minu bilanss',0),(368077,10225,'si','Moj bilance stanja',0),(368078,10225,'ba','Saya neraca',0),(368079,10225,'nl','Mijn balans',0),(368080,10225,'fi','Taseen loppusumma',0),(368081,10225,'no','Min balanse',0),(368082,10225,'da','Min balancen',0),(368083,10225,'ko','ë‚´ ëŒ€ì°¨ ëŒ€ì¡°í‘œ',0),(368084,10225,'he','×”×ž××–×Ÿ ×©×œ×™',0),(368085,10225,'el','ÎœÎ¿Ï… Î¹ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(368086,10225,'zh','æˆ‘çš„èµ„äº§è´Ÿå€ºè¡¨\r\n',0),(368087,10225,'sv','Min balansrÃ¤kning',0),(368088,10225,'it','Il mio bilancio',0),(368089,10225,'tl','',0),(368090,10225,'th','à¸”à¸¸à¸¥à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(368091,10225,'hi','à¤®à¥‡à¤°à¤¾ à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ',0),(368092,10225,'ms','Saya kunci kira-kira',0),(368093,10225,'ar','Ø¨Ù„Ø¯ÙŠ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¹Ù…ÙˆÙ…ÙŠØ©',0),(368094,10225,'fr','Mon bilan',0),(368095,10225,'jp','è‡ªåˆ†ã®è²¸å€Ÿå¯¾ç…§è¡¨',0),(368096,10225,'pt','Meu balanÃ§o',0),(368097,10225,'ru','ÐœÐ¾Ð¹ Ð±Ð°Ð»Ð°Ð½Ñ',0),(368098,10225,'es','Mi Hoja de Balance',0),(368099,10225,'de','Meine Bilanz',0),(368100,10225,'en','My Balance Sheet',0),(368101,10226,'is','',0),(368102,10226,'dr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙƒÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø§ÙŠØ¬Ø§Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(368103,10226,'pr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙƒÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø§ÙŠØ¬Ø§Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(368104,10226,'tr','Bu ÅŸirket iÃ§in oluÅŸturulan hiÃ§bir mÃ¼lkiyet',0),(368105,10226,'pl','Nie wÅ‚asnoÅ›ci utworzone dla tej firmy',0),(368106,10226,'bg','ÐÑÐ¼Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°',0),(368107,10226,'ur','Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù¾ÛŒØ¯Ø§ Ù†Û Ú©ÛŒ Ù…Ù„Ú©ÛŒØª',0),(368108,10226,'sr','ÐÐµÐ¼Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½ Ð·Ð° Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(368109,10226,'vi','Quyá»n sá»Ÿ há»¯u khÃ´ng Ä‘Æ°á»£c táº¡o cho cÃ´ng ty nÃ y',0),(368110,10226,'af','Geen Eienaarskap Geskep vir Hierdie Onderneming',0),(368111,10226,'ro','Nici o proprietate creat pentru aceastÄƒ companie',0),(368112,10226,'et','Ei oma selles ettevÃµttele loonud',0),(368113,10226,'si','Ustvarjen za to podjetje ne prevzema nikakrÅ¡nega lastniÅ¡tva',0),(368114,10226,'ba','Tidak ada kepemilikan yang dibuat untuk perusahaan ini',0),(368115,10226,'nl','Geen eigendom gemaakt voor dit bedrijf',0),(368116,10226,'fi','Ei vaadi luotu tÃ¤lle yritykselle',0),(368117,10226,'no','Eierskap opprettet for dette selskapet',0);
INSERT INTO `langdef` VALUES (368118,10226,'da','Ingen ejerskab lavet for dette selskab',0),(368119,10226,'ko','ì´ íšŒì‚¬ê°€ ë§Œë“  ì•„ë¬´ ì†Œìœ ê¶Œ',0),(368120,10226,'he','××™×Ÿ ×‘×¢×œ×•×ª ×¢×œ ×©× ×•×¦×¨×• ×¢×‘×•×¨ ×”×—×‘×¨×” ×”×–××ª',0),(368121,10226,'el','ÎšÎ±Î¼Î¯Î± Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î± Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î®',0),(368122,10226,'zh','æ­¤å…¬å¸æ²¡æœ‰å»ºç«‹æ‰€æœ‰æƒ\r\n',0),(368123,10226,'sv','Ingen Ã¤ganderÃ¤tt som skapas fÃ¶r detta fÃ¶retag',0),(368124,10226,'it','Nessuna proprietÃ  creato per questa azienda',0),(368125,10226,'tl','',0),(368126,10226,'th','à¹„à¸¡à¹ˆà¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸—à¸µà¹ˆà¸ªà¸£à¹‰à¸²à¸‡à¸‚à¸¶à¹‰à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸£à¸´à¸©à¸±à¸—à¸™à¸µà¹‰',0),(368127,10226,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¨à¤¾à¤ˆ à¤—à¤ˆ à¤•à¥‹à¤ˆ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ',0),(368128,10226,'ms','Tiada pemilikan yang dicipta untuk Syarikat ini',0),(368129,10226,'ar','Ù„Ø§ Ø§Ù„Ù…Ù„ÙƒÙŠØ© Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(368130,10226,'fr','Aucun droit de propriÃ©tÃ© crÃ©Ã© pour cette sociÃ©tÃ©',0),(368131,10226,'jp','ã“ã®ä¼šç¤¾ç”¨ã«ä½œæˆã•ã‚ŒãŸãªã„æ‰€æœ‰æ¨©',0),(368132,10226,'pt','Nenhuma propriedade criada para esta empresa',0),(368133,10226,'ru','ÐÐµÑ‚ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸, ÑÐ¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(368134,10226,'es','No Pertenencia Creado Para Esta Empresa',0),(368135,10226,'de','Kein Eigentum erstellt fÃ¼r diese Firma',0),(368136,10226,'en','No Ownership Created for This Company',0),(368137,10227,'is','',0),(368138,10227,'dr','Ù†Ù…Ø§ÙŠØ´ ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ù…ØªØ¹Ù„Ù‚ Ø¨Ù‡  Ø§ÙŠÙ† Ø´Ø±ÙƒØª ',0),(368139,10227,'pr','Ù†Ù…Ø§ÙŠØ´ ØªÙ…Ø§Ù… Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ù…ØªØ¹Ù„Ù‚ Ø¨Ù‡  Ø§ÙŠÙ† Ø´Ø±ÙƒØª ',0),(368140,10227,'tr','Bu ÅŸirketine ait tÃ¼m ÅŸirketlerin gÃ¶ster',0),(368141,10227,'pl','PokaÅ¼ wszystkich spÃ³Å‚ek naleÅ¼Ä…cych do tej firmy',0),(368142,10227,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ñ€ÑƒÐ¶ÐµÑÑ‚Ð²Ð°, ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°',0),(368143,10227,'ur','ÛŒÛ Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù„Ú©ÛŒØª ØªÙ…Ø§Ù… Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(368144,10227,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ²Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ñƒ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ñƒ Ð¾Ð²Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(368145,10227,'vi','Hiá»ƒn thá»‹ táº¥t cáº£ cÃ´ng ty mÃ  cÃ´ng ty nÃ y sá»Ÿ há»¯u',0),(368146,10227,'af','Wys Alle Ondernemings wat Besit Word deur Hierdie Onderneming',0),(368147,10227,'ro','AratÄƒ toate companiile detinute de aceasta companie',0),(368148,10227,'et','Kuva kÃµik ettevÃµtted selle ettevÃµtte omanduses',0),(368149,10227,'si','PrikaÅ¾i vsa podjetja v lasti te druÅ¾be',0),(368150,10227,'ba','Tampilkan semua perusahaan yang dimiliki oleh perusahaan ini',0),(368151,10227,'nl','Toon alle bedrijven eigendom van deze onderneming',0),(368152,10227,'fi','NÃ¤ytÃ¤ kaikkien yritysten omistama yritys',0),(368153,10227,'no','Vis alle selskap av dette selskapet',0),(368154,10227,'da','Vis alle virksomheder ejet af denne virksomhed',0),(368155,10227,'ko','ì´ íšŒì‚¬ì— ì˜í•´ ì†Œìœ  í•˜ëŠ” ëª¨ë“  íšŒì‚¬ í‘œì‹œ',0),(368156,10227,'he','×”×¦×’ ××ª ×›×œ ×—×‘×¨×•×ª ×‘×‘×¢×œ×•×ª ×”×—×‘×¨×” ×”×–×•',0),(368157,10227,'el','Î”ÎµÎ¯Ï‡Î½Î¿Ï…Î½ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Ï€Î¿Ï… Î±Î½Î®ÎºÎ¿Ï…Î½ ÏƒÎµ Î±Ï…Ï„Î® Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(368158,10227,'zh','æ˜¾ç¤ºç”±æœ¬å…¬å¸æ‹¥æœ‰çš„æ‰€æœ‰å…¬å¸\r\n',0),(368159,10227,'sv','Visa alla fÃ¶retag Ã¤gs av fÃ¶retaget',0),(368160,10227,'it','Visualizza tutte le aziende di proprietÃ  di questa azienda',0),(368161,10227,'tl','',0),(368162,10227,'th','à¹à¸ªà¸”à¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸šà¸£à¸´à¸©à¸±à¸—à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸šà¸£à¸´à¸©à¸±à¸—à¸™à¸µà¹‰',0),(368163,10227,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤µà¤¾à¤²à¥€ à¤¸à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(368164,10227,'ms','Menunjukkan semua syarikat-syarikat yang dimiliki oleh Syarikat ini',0),(368165,10227,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø¬Ù…ÙŠØ¹ Ø´Ø±ÙƒØ§Øª Ù…Ù…Ù„ÙˆÙƒØ© Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(368166,10227,'fr','Montrer toutes les sociÃ©tÃ©s appartenues Ã  cette sociÃ©tÃ©',0),(368167,10227,'jp','ã“ã®ä¼šç¤¾ãŒæ‰€æœ‰ã™ã‚‹ã™ã¹ã¦ã®ä¼šç¤¾ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(368168,10227,'pt','Mostrar todas as empresas pertencentes a esta empresa',0),(368169,10227,'ru','ÐŸÐ¾ÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð’ÑÐµ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ ÐÐ°Ñ…Ð¾Ð´ÑÑ‰Ð¸ÐµÑÑ Ð² Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð­Ñ‚Ð¾Ð¹ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(368170,10227,'es','Mostrar Todas las Empresas que Pertenecen a Esta Empresa',0),(368171,10227,'de','Zeigen Sie alle Unternehmen, die im Besitz von dieser Firma an',0),(368172,10227,'en','Show All Companies Owned by This Company',0),(368173,10228,'is','',0),(368174,10228,'dr','Ù†Ù…Ø§ÙŠØ´ ØªÙ…Ø§Ù… ØµØ§Ø­Ø¨Ø§Ù† Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(368175,10228,'pr','Ù†Ù…Ø§ÙŠØ´ ØªÙ…Ø§Ù… ØµØ§Ø­Ø¨Ø§Ù† Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(368176,10228,'tr','Bu ÅŸirket iÃ§in tÃ¼m sahipleri gÃ¶ster',0),(368177,10228,'pl','PokaÅ¼ wszystkich wÅ‚aÅ›cicieli tej firmy',0),(368178,10228,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸Ñ†Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°',0),(368179,10228,'ur','Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„ÛŒÛ’ ØªÙ…Ø§Ù… Ù…Ø§Ù„Ú©Ø§Ù† Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(368180,10228,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÑÐ²Ð¸Ñ… Ð²Ð»Ð°ÑÐ½Ð¸ÐºÐ° Ð·Ð° Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(368181,10228,'vi','Hiá»ƒn thá»‹ táº¥t cáº£ chá»§ sá»Ÿ há»¯u cho cÃ´ng ty nÃ y',0),(368182,10228,'af','Wys Alle Eienaars van Hierdie Onderneming',0),(368183,10228,'ro','AratÄƒ toate proprietarii pentru aceasta companie',0),(368184,10228,'et','Kuva kÃµik omanikud selle firma',0),(368185,10228,'si','PrikaÅ¾i vse lastnike za to podjetje',0),(368186,10228,'ba','Tampilkan semua pemilik untuk perusahaan ini',0),(368187,10228,'nl','Toon alle eigenaren voor dit bedrijf',0),(368188,10228,'fi','NÃ¤ytÃ¤ kaikki omistajat tÃ¤mÃ¤n yrityksen',0),(368189,10228,'no','Vis alle eiere for dette selskapet',0),(368190,10228,'da','Vis alle ejerne for dette selskab',0),(368191,10228,'ko','ì´ íšŒì‚¬ì— ëŒ€ í•œ ëª¨ë“  ì†Œìœ ìž í‘œì‹œ',0),(368192,10228,'he','×”×¦×’ ××ª ×›×œ ×”×‘×¢×œ×™× ×‘×—×‘×¨×” ×”×–××ª',0),(368193,10228,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ Î¹Î´Î¹Î¿ÎºÏ„Î·Ï„ÏŽÎ½ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î®',0),(368194,10228,'zh','æ˜¾ç¤ºæ­¤å…¬å¸æ‰€æœ‰æ‰€æœ‰äºº\r\n',0),(368195,10228,'sv','Visa alla Ã¤gare fÃ¶r detta fÃ¶retag',0),(368196,10228,'it','Visualizza tutti i proprietari di questa societÃ ',0),(368197,10228,'tl','',0),(368198,10228,'th','à¹à¸ªà¸”à¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸šà¸£à¸´à¸©à¸±à¸—à¸™à¸µà¹‰',0),(368199,10228,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤®à¤¾à¤²à¤¿à¤•à¥‹à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(368200,10228,'ms','Menunjukkan semua pemilik syarikat ini',0),(368201,10228,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙƒØ§ÙØ© Ø§Ù„Ù…Ø§Ù„ÙƒÙŠÙ† Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(368202,10228,'fr','Afficher tous les propriÃ©taires de cette sociÃ©tÃ©',0),(368203,10228,'jp','ã“ã®ä¼šç¤¾ã®æ‰€æœ‰è€…ã‚’ã™ã¹ã¦è¡¨ç¤ºã—ã¾ã™ã€‚',0),(368204,10228,'pt','Mostrar todos os proprietÃ¡rios para esta empresa',0),(368205,10228,'ru','ÐŸÐ¾ÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð’ÑÐµÑ… Ð’Ð»Ð°Ð´ÐµÐ»ÑŒÑ†ÐµÐ² Ð­Ñ‚Ð¾Ð¹ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(368206,10228,'es','Mostrar todos los DueÃ±os de Esta Empresa',0),(368207,10228,'de','Zeige alle Besitzer fÃ¼r diese Firma',0),(368208,10228,'en','Show All Owners for This Company',0),(368209,10229,'is','',0),(368210,10229,'dr','ÙƒØ¯Ø§Ù… Ø´Ø±ÙƒØª',0),(368211,10229,'pr','ÙƒØ¯Ø§Ù… Ø´Ø±ÙƒØª',0),(368212,10229,'tr','Hangi ÅŸirket',0),(368213,10229,'pl','FirmÄ™, ktÃ³ra',0),(368214,10229,'bg','ÐšÐ¾Ñ Ñ„Ð¸Ñ€Ð¼Ð°',0),(368215,10229,'ur','Ø¬Ùˆ Ú©Ù…Ù¾Ù†ÛŒ',0),(368216,10229,'sr','ÐšÐ¾Ñ˜Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(368217,10229,'vi','Cty nÃ o',0),(368218,10229,'af','Watter Onderneming',0),(368219,10229,'ro','Compania care',0),(368220,10229,'et','Mis ettevÃµte',0),(368221,10229,'si','Katero podjetje',0),(368222,10229,'ba','Perusahaan yang',0),(368223,10229,'nl','Welk bedrijf',0),(368224,10229,'fi','MikÃ¤ yritys',0),(368225,10229,'no','Hvilket selskap',0),(368226,10229,'da','Hvilket selskab',0),(368227,10229,'ko','ì–´ë–¤ íšŒì‚¬',0),(368228,10229,'he','××™×–×” ×—×‘×¨×”',0),(368229,10229,'el','Î Î¿Î¹Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(368230,10229,'zh','å“ªå®¶å…¬å¸\r\n',0),(368231,10229,'sv','Vilket fÃ¶retag',0),(368232,10229,'it','Quale azienda',0),(368233,10229,'tl','',0),(368234,10229,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¹ƒà¸”',0),(368235,10229,'hi','à¤œà¥‹ à¤•à¤‚à¤ªà¤¨à¥€',0),(368236,10229,'ms','Syarikat yang',0),(368237,10229,'ar','Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„ØªÙŠ',0),(368238,10229,'fr','Quelle entreprise',0),(368239,10229,'jp','ã©ã®ä¼šç¤¾',0),(368240,10229,'pt','Qual empresa',0),(368241,10229,'ru','ÐšÐ°ÐºÐ¾Ð¹ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(368242,10229,'es','Cual Empresa',0),(368243,10229,'de','Welche Firma',0),(368244,10229,'en','Which Company',0),(368245,10230,'is','',0),(368246,10230,'dr','ÙƒØ¯Ø§Ù… Ú¯Ø²Ø§Ø±Ø´ ',0),(368247,10230,'pr','ÙƒØ¯Ø§Ù… Ú¯Ø²Ø§Ø±Ø´ ',0),(368248,10230,'tr','Hangi rapor',0),(368249,10230,'pl','KtÃ³rego sprawozdanie',0),(368250,10230,'bg','ÐšÐ¾Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(368251,10230,'ur','Ø¬Ø³ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(368252,10230,'sr','ÐšÐ¾Ñ˜Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(368253,10230,'vi','BÃ¡o cÃ¡o nÃ o',0),(368254,10230,'af','Watter Verslag',0),(368255,10230,'ro','Ce raport',0),(368256,10230,'et','Millise raportiga',0),(368257,10230,'si','Katero poroÄilo',0),(368258,10230,'ba','Laporan yang',0),(368259,10230,'nl','Welk rapport',0),(368260,10230,'fi','MistÃ¤ mietinnÃ¶stÃ¤',0),(368261,10230,'no','Hvilken rapport',0),(368262,10230,'da','Hvilken rapport',0),(368263,10230,'ko','ì–´ëŠ ë³´ê³ ì„œ',0),(368264,10230,'he','××™×–×” ×“×• ×—',0),(368265,10230,'el','Î Î¿Î¹Î± Î­ÎºÎ¸ÎµÏƒÎ·',0),(368266,10230,'zh','å“ªä¸ªæŠ¥è¡¨\r\n',0),(368267,10230,'sv','Som rapport',0),(368268,10230,'it','Quale relazione',0),(368269,10230,'tl','',0),(368270,10230,'th','à¸‹à¸¶à¹ˆà¸‡à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(368271,10230,'hi','à¤œà¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(368272,10230,'ms','Laporan yang',0),(368273,10230,'ar','Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø°ÙŠ',0),(368274,10230,'fr','Quel rapport',0),(368275,10230,'jp','ã©ã®ãƒ¬ãƒãƒ¼ãƒˆ',0),(368276,10230,'pt','Que relatÃ³rio',0),(368277,10230,'ru','ÐšÐ°ÐºÐ¾Ð¹ ÐžÑ‚Ñ‡ÐµÑ‚',0),(368278,10230,'es','Cual Informe',0),(368279,10230,'de','Welcher Bericht',0),(368280,10230,'en','Which Report',0),(368281,10231,'is','',0),(368282,10231,'dr','Ø´Ù…Ø§ Ù‡ÙŠÚ† Ù…Ø§Ù„ÙƒÙŠØªÙŠ Ø¯Ø± Ù‡ÙŠÚ† Ø´Ø±ÙƒØªÙŠ Ù†Ø¯Ø§Ø±ÙŠØ¯ ',0),(368283,10231,'pr','Ø´Ù…Ø§ Ù‡ÙŠÚ† Ù…Ø§Ù„ÙƒÙŠØªÙŠ Ø¯Ø± Ù‡ÙŠÚ† Ø´Ø±ÙƒØªÙŠ Ù†Ø¯Ø§Ø±ÙŠØ¯ ',0),(368284,10231,'tr','HiÃ§bir mÃ¼lkiyet herhangi bir ÅŸirket var',0),(368285,10231,'pl','Masz Å¼adnych praw wÅ‚asnoÅ›ci w kaÅ¼dej firmie',0),(368286,10231,'bg','Ð’Ð¸Ðµ Ð½ÑÐ¼Ð°Ñ‚Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð²ÑŠÐ² Ð²ÑÑÐºÐ° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(368287,10231,'ur','Ø¢Ù¾ Ú©Ø³ÛŒ Ø¨Ú¾ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ù…ÛŒÚº Ú©Ø³ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª ÛÛ’',0),(368288,10231,'sr','Ð˜Ð¼Ð°Ñ‚Ðµ Ð½ÐµÐ¼Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾ Ñƒ Ð³Ð¾ÑÑ‚Ðµ',0),(368289,10231,'vi','Báº¡n khÃ´ng cÃ³ quyá»n sá»Ÿ há»¯u trong báº¥t ká»³ cÃ´ng ty nÃ o',0),(368290,10231,'af','U het Nie Enige Eienaarskap in Enige Onderneming nie',0),(368291,10231,'ro','AveÅ£i nici o proprietate Ã®n orice companie',0),(368292,10231,'et','Te ei oma Ã¼htegi ettevÃµtet',0),(368293,10231,'si','Imate brez lastniÅ¡tva v vsako podjetje',0),(368294,10231,'ba','Anda memiliki kepemilikan tidak dalam setiap perusahaan',0),(368295,10231,'nl','U hebt geen eigendom In ieder bedrijf',0),(368296,10231,'fi','Sinulla ei ole omistus yhtiÃ¶tÃ¤',0),(368297,10231,'no','Du har ingen eierskap i selskap',0),(368298,10231,'da','Du har ingen ejerskab i enhver virksomhed',0),(368299,10231,'ko','ì–´ë–¤ íšŒì‚¬ ë“  ì§€ì— ì•„ë¬´ ì†Œìœ ê¶Œì„ê°€ì§€ê³ ',0),(368300,10231,'he','. ×™×© ×œ×š ××ª ×”×‘×¢×œ×•×ª ××™×Ÿ ×‘×›×œ ×—×‘×¨×”',0),(368301,10231,'el','ÎˆÏ‡ÎµÏ„Îµ ÎºÎ±Î¼Î¯Î± Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î± ÏƒÎµ Î¿Ï€Î¿Î¹Î±Î´Î®Ï€Î¿Ï„Îµ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(368302,10231,'zh','ä½ æœ‰æ²¡æœ‰ä»»ä½•å…¬å¸è‚¡æƒ\r\n',0),(368303,10231,'sv','Du har inget Ã¤gande i bolag',0),(368304,10231,'it','Non si dispone di alcuna proprietÃ  In qualsiasi azienda',0),(368305,10231,'tl','',0),(368306,10231,'th','à¸„à¸¸à¸“à¸¡à¸µà¹„à¸¡à¹ˆà¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¹ƒà¸™à¸šà¸£à¸´à¸©à¸±à¸—',0),(368307,10231,'hi','à¤†à¤ª à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¥€ à¤®à¥‡à¤‚ à¤•à¥‹à¤ˆ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤¹à¥ˆ',0),(368308,10231,'ms','Anda mempunyai pemilikan tiada dalam mana-mana Syarikat',0),(368309,10231,'ar','Ù„Ø¯ÙŠÙƒ Ù„Ø§ Ù…Ù„ÙƒÙŠØ© ÙÙŠ Ø£ÙŠ Ø´Ø±ÙƒØ©',0),(368310,10231,'fr','Vous n\'avez aucun droit de propriÃ©tÃ© dans n\'importe quelle entreprise',0),(368311,10231,'jp','ã©ã®ã‚ˆã†ãªä¼æ¥­ã®æ‰€æœ‰æ¨©ã‚’å–å¾—ã‚’ã—ã¦ã„ã¾ã›ã‚“ã€‚',0),(368312,10231,'pt','VocÃª nÃ£o tem nenhuma propriedade em qualquer empresa',0),(368313,10231,'ru','Ð£ Ð²Ð°Ñ Ð½ÐµÑ‚ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð² Ð»ÑŽÐ±Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(368314,10231,'es','No Tiene NingÃºn Pertenencia en Ninguna Empresa',0),(368315,10231,'de','Sie haben kein Eigentum In den einzelnen Unternehmen',0),(368316,10231,'en','You Have No Ownership In Any Company',0),(368317,10232,'is','',0),(368318,10232,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø¯ÙØªØ± ÙƒÙ„  Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡  Ú†Ù†Ø¯ Ø´Ø±ÙƒØªÙŠ ',0),(368319,10232,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø¯ÙØªØ± ÙƒÙ„  Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡  Ú†Ù†Ø¯ Ø´Ø±ÙƒØªÙŠ ',0),(368320,10232,'tr','Ã‡oklu ÅŸirket yevmiye defter giriÅŸleri oluÅŸturma',0),(368321,10232,'pl','Tworzenie wpisÃ³w w Dzienniku Generalnego ksiÄ™gi wielu firm',0),(368322,10232,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð³Ð»Ð°Ð²Ð½Ð°Ñ‚Ð° ÐºÐ½Ð¸Ð³Ð° ÐœÐ½Ð¾Ð³Ð¾Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð°, Ð¼Ð½Ð¾Ð³Ð¾ÐºÐ»Ð¾Ð½Ð¾Ð²Ð° ÐºÐ½Ð¸Ð³Ð°',0),(368323,10232,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ú©Ø«ÛŒØ± Ú©Ù…Ù¾Ù†ÛŒ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(368324,10232,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐµ ÐºÑšÐ¸Ð³Ðµ ÑÐ° Ð²Ð¸ÑˆÐµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° ÑÑ‚Ð°Ð²ÐºÐµ',0),(368325,10232,'vi','Táº¡o táº¡p chÃ­ Ä‘a cÃ´ng ty General Ledger Entries',0),(368326,10232,'af','Skep Algemene Grootboek Multi-Besigheid Joernaal Inskrywings',0),(368327,10232,'ro','Creare intrÄƒri jurnal General Ledger multi-Firma',0),(368328,10232,'et','Loo Ã¼ldine mitme firma pearaamatutÃ¶Ã¶lehe kanded',0),(368329,10232,'si','Ustvarite General Ledger multi-druÅ¾ba dnevnik',0),(368330,10232,'ba','Membuat entri jurnal multi-perusahaan General Ledger',0),(368331,10232,'nl','General Ledger multi-Company dagboekposten worden gemaakt',0),(368332,10232,'fi','Luo yleinen kirjanpidon useita yrityksiÃ¤',0),(368333,10232,'no','Opprette General Ledger multi firma Journal oppfÃ¸ringer',0),(368334,10232,'da','Opret journaloptegnelser General Ledger flere firmaer',0),(368335,10232,'ko','ì¼ë°˜ ë ˆì € ë‹¤ì¤‘ íšŒì‚¬ ì—…ë¬´ ì¼ì§€ í•­ëª© ë§Œë“¤ê¸°',0),(368336,10232,'he','×œ×™×¦×•×¨ ×¢×¨×›×™ ×™×•×ž×Ÿ ×›×œ×œ×™ ×¡×¤×¨ ×¨××©×™ ×—×‘×¨×•×ª ×ž×¨×•×‘×•×ª',0),(368337,10232,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î³ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î Î¿Î»Î»Î±Ï€Î»ÏŽÎ½ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(368338,10232,'zh','å»ºç«‹æ€»å¸å¤šå…¬å¸æ—¥è®°å¸åˆ†å½•\r\n',0),(368339,10232,'sv','Skapa journalposter fÃ¶r General Ledger flera fÃ¶retag',0),(368340,10232,'it','Creare le voci del diario di General Ledger multi-azienda',0),(368341,10232,'tl','',0),(368342,10232,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¸«à¸¥à¸²à¸¢à¸šà¸£à¸´à¸©à¸±à¸—à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(368343,10232,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤¬à¤¹à¥ à¤•à¤‚à¤ªà¤¨à¥€ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¬à¤¨à¤¾à¤à¤',0),(368344,10232,'ms','Membuat catatan jurnal Syarikat berbilang Lejar Am',0),(368345,10232,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù‚ÙŠØ¯ ÙŠÙˆÙ…ÙŠØ© Ù…ØªØ¹Ø¯Ø¯ Ø§Ù„Ø´Ø±ÙƒØ§Øª',0),(368346,10232,'fr','CrÃ©er des entrÃ©es de Journal de multisociÃ©tÃ©s comptable gÃ©nÃ©ral',0),(368347,10232,'jp','ä¸€èˆ¬çš„ãªè¤‡æ•°ä¼æ¥­ä»•è¨³å…ƒå¸³ã®ã‚¨ãƒ³ãƒˆãƒªã‚’ä½œæˆã—ã¾ã™ã€‚',0),(368348,10232,'pt','Criar entradas de diÃ¡rio de vÃ¡rias empresas General Ledger',0),(368349,10232,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¶ÑƒÑ€Ð½Ð°Ð» Ð¼ÑƒÐ»ÑŒÑ‚Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð“Ðš Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹',0),(368350,10232,'es','Crear Entradas de Diario de Multi-Empresas del Libro Mayor',0),(368351,10232,'de','General Ledger Multi-Firma JournaleintrÃ¤ge erstellen',0),(368352,10232,'en','Create General Ledger Multi-Company Journal Entries',0),(368353,10233,'is','',0),(368354,10233,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ú†Ù†Ø¯ Ø´Ø±ÙƒØªÙŠ ',0),(368355,10233,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ú†Ù†Ø¯ Ø´Ø±ÙƒØªÙŠ ',0),(368356,10233,'tr','Ã‡oklu ÅŸirket gÃ¼nlÃ¼k giriÅŸleri',0),(368357,10233,'pl','Wpisy do dziennika wielu firm',0),(368358,10233,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ° Ð½Ð° Ð¼Ð½Ð¾Ð¶ÐµÑÑ‚Ð²Ð¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(368359,10233,'ur','Ú©Ø«ÛŒØ± Ú©Ù…Ù¾Ù†ÛŒ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(368360,10233,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ ÑÐ° Ð²Ð¸ÑˆÐµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(368361,10233,'vi','Nhiá»u cÃ´ng ty táº¡p chÃ­ Entries',0),(368362,10233,'af','Multi-Onderneming Joernaalinskrywings',0),(368363,10233,'ro','Multi-companie jurnal',0),(368364,10233,'et','Multi firma pÃ¤evikukandeid',0),(368365,10233,'si','Multi-druÅ¾ba dnevnik',0),(368366,10233,'ba','Entri jurnal multi-perusahaan',0),(368367,10233,'nl','Meerdere bedrijven logboekitems',0),(368368,10233,'fi','Useita yrityksiÃ¤ pÃ¤ivÃ¤kirjamerkinnÃ¤t',0),(368369,10233,'no','Multi firma journaloppfÃ¸ringer',0),(368370,10233,'da','Flere firmaer journaloptegnelser',0),(368371,10233,'ko','ë‹¤ì¤‘ íšŒì‚¬ ì—…ë¬´ ì¼ì§€ í•­ëª©',0),(368372,10233,'he','×¢×¨×›×™ ×™×•×ž×Ÿ ×—×‘×¨×•×ª ×ž×¨×•×‘×•×ª',0),(368373,10233,'el','Î Î¿Î»Ï…-ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(368374,10233,'zh','å¤šå…¬å¸æ—¥è®°å¸åˆ†å½•\r\n',0),(368375,10233,'sv','Flera fÃ¶retag journalposter',0),(368376,10233,'it','Voci del diario di multi-azienda',0),(368377,10233,'tl','',0),(368378,10233,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¸«à¸¥à¸²à¸¢à¸šà¸£à¸´à¸©à¸±à¸—',0),(368379,10233,'hi','à¤®à¤²à¥à¤Ÿà¥€-à¤•à¤®à¥à¤ªà¤¨à¥€ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(368380,10233,'ms','Catatan jurnal Syarikat multi',0),(368381,10233,'ar','Ù‚ÙŠÙˆØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ© Ø§Ù„Ù…ØªØ¹Ø¯Ø¯Ø© Ø§Ù„Ø´Ø±ÙƒØ§Øª',0),(368382,10233,'fr','EntrÃ©es de Journal de la multi-sociÃ©tÃ©',0),(368383,10233,'jp','è¤‡æ•°ä¼æ¥­ã®ä»•è¨³',0),(368384,10233,'pt','Entradas de diÃ¡rio de vÃ¡rias empresas',0),(368385,10233,'ru','Ð—Ð°Ð¿Ð¸ÑÐµÐ¹ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¸Ñ… ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¹',0),(368386,10233,'es','Entradas del Diario de Multi-Empresas',0),(368387,10233,'de','Multi-Firma JournaleintrÃ¤ge',0),(368388,10233,'en','Multi-Company Journal Entries',0),(368389,10234,'is','',0),(368390,10234,'dr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ù…Ø§Ù„ÙƒÙŠØª ',0),(368391,10234,'pr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ù…Ø§Ù„ÙƒÙŠØª ',0),(368392,10234,'tr','Sahiplik bilanÃ§o',0),(368393,10234,'pl','WÅ‚asnoÅ›ci bilansu',0),(368394,10234,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚Ñ‚Ð° Ð±Ð°Ð»Ð°Ð½ÑÐ¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(368395,10234,'ur','Ù…Ù„Ú©ÛŒØª Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹',0),(368396,10234,'sr','Ð’Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾ Ð±Ð¸Ð»Ð°Ð½Ñ ÑÑ‚Ð°ÑšÐ°',0),(368397,10234,'vi','Báº£ng cÃ¢n Ä‘á»‘i quyá»n sá»Ÿ há»¯u',0),(368398,10234,'af','Eienaarskap Balansstaat',0),(368399,10234,'ro','Proprietate bilanÅ£',0),(368400,10234,'et','Omandi bilanss',0),(368401,10234,'si','LastniÅ¡tvo bilance stanja',0),(368402,10234,'ba','Kepemilikan neraca',0),(368403,10234,'nl','Eigendom balans',0),(368404,10234,'fi','Omistus tase',0),(368405,10234,'no','Eierskap balanse',0),(368406,10234,'da','Ejerskab balancen',0),(368407,10234,'ko','ì†Œìœ ê¶Œ ëŒ€ì°¨ ëŒ€ì¡°í‘œ',0),(368408,10234,'he','×‘×¢×œ×•×ª ×”×ž××–×Ÿ',0),(368409,10234,'el','Î™Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î± Ï„Î¿Ï… Î¹ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(368410,10234,'zh','æ‰€æœ‰åˆ¶çš„èµ„äº§è´Ÿå€ºè¡¨\r\n',0),(368411,10234,'sv','Ã„gande balansrÃ¤kning',0),(368412,10234,'it','Bilancio di proprietÃ ',0),(368413,10234,'tl','',0),(368414,10234,'th','à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸‡à¸šà¸”à¸¸à¸¥',0),(368415,10234,'hi','à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ',0),(368416,10234,'ms','Pemilikan kunci kira-kira',0),(368417,10234,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¹Ù…ÙˆÙ…ÙŠØ© Ù…Ù„ÙƒÙŠØ©',0),(368418,10234,'fr','PropriÃ©tÃ©-bilan',0),(368419,10234,'jp','æ‰€æœ‰æ¨©ã®ãƒãƒ©ãƒ³ã‚¹ ã‚·ãƒ¼ãƒˆ',0),(368420,10234,'pt','BalanÃ§o de posse',0),(368421,10234,'ru','Ð’Ð»Ð°Ð´ÐµÐ½Ð¸Ðµ Ð±Ð°Ð»Ð°Ð½Ñ',0),(368422,10234,'es','Hoja de Balance de Pertenencia',0),(368423,10234,'de','Eigentum-Bilanz',0),(368424,10234,'en','Ownership Balance Sheet',0),(368425,10235,'is','',0),(368426,10235,'dr','ÙƒØ¯ Ø´Ø±ÙƒØª ',0),(368427,10235,'pr','ÙƒØ¯ Ø´Ø±ÙƒØª ',0),(368428,10235,'tr','Åžirket kodu',0),(368429,10235,'pl','Kod firmy',0),(368430,10235,'bg','Ð¤Ð¸Ñ€Ð¼ÐµÐ½ ÐºÐ¾Ð´',0),(368431,10235,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ú©ÙˆÚˆ',0),(368432,10235,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¨Ð¸Ñ„Ñ€Ð°',0),(368433,10235,'vi','CÃ´ng ty mÃ£',0),(368434,10235,'af','Ondernemingkode',0),(368435,10235,'ro','Cod de companie',0),(368436,10235,'et','EttevÃµtte kood',0),(368437,10235,'si','Å ifra podjetja',0),(368438,10235,'ba','Kode perusahaan',0),(368439,10235,'nl','Wetboek van',0),(368440,10235,'fi','Yritystunnus',0),(368441,10235,'no','Firmakode',0),(368442,10235,'da','Firmakode',0),(368443,10235,'ko','íšŒì‚¬ ì½”ë“œ',0),(368444,10235,'he','×§×•×“ ×”×—×‘×¨×”',0),(368445,10235,'el','ÎŸÎ Î‘Î ',0),(368446,10235,'zh','å…¬å¸ä»£ç \r\n',0),(368447,10235,'sv','FÃ¶retagskod',0),(368448,10235,'it','Codice azienda',0),(368449,10235,'tl','',0),(368450,10235,'th','à¸£à¸«à¸±à¸ªà¸šà¸£à¸´à¸©à¸±à¸—',0),(368451,10235,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‹à¤¡',0),(368452,10235,'ms','Kod Syarikat',0),(368453,10235,'ar','Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙƒØ©',0),(368454,10235,'fr','Code des sociÃ©tÃ©s',0),(368455,10235,'jp','ä¼šç¤¾ã‚³ãƒ¼ãƒ‰',0),(368456,10235,'pt','CÃ³digo da empresa',0),(368457,10235,'ru','ÐšÐ¾Ð´ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(368458,10235,'es','CÃ³digo de Empresa',0),(368459,10235,'de','Buchungskreis',0),(368460,10235,'en','Company Code',0),(368461,10236,'is','',0),(368462,10236,'dr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ Ø«Ø¨Øª Ø¯Ø± Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(368463,10236,'pr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ Ø«Ø¨Øª Ø¯Ø± Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡',0),(368464,10236,'tr','GÃ¼nlÃ¼k girdisi seÃ§imleri blok',0),(368465,10236,'pl','Blok z dziennika zapis zaznaczenia',0),(368466,10236,'bg','Ð‘Ð»Ð¾Ðº Ð¾Ñ‚ Ð´Ð½ÐµÐ²Ð½Ð¸Ðº Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ ÑÐµÐ»ÐµÐºÑ†Ð¸Ð¸',0),(368467,10236,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø§Ù†ØªØ®Ø§Ø¨ Ø³Û’ Ø¨Ù„Ø§Ú©',0),(368468,10236,'sr','Ð‘Ð»Ð¾Ðº Ð¾Ð´ Ð¾Ð´Ð°Ð±Ð¸Ñ€Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(368469,10236,'vi','Khá»‘i tá»« táº¡p chÃ­ má»¥c lá»±a chá»n',0),(368470,10236,'af','Blok van joernaal inskrywing seleksies',0),(368471,10236,'ro','Bloc din selecÅ£iile de intrare jurnal',0),(368472,10236,'et','JalutuskÃ¤igu kaugusel tÃ¶Ã¶lehe kanne Valikud',0),(368473,10236,'si','Blok iz izbiranj listu vstop',0),(368474,10236,'ba','Blok dari jurnal Entry pilihan',0),(368475,10236,'nl','Blok uit Journal Entry selecties',0),(368476,10236,'fi','Korttelin pÃ¤Ã¤ssÃ¤ kirjauskansion merkintÃ¤ valinnat',0),(368477,10236,'no','Kvartal fra Journal oppfÃ¸ring valg',0),(368478,10236,'da','Blok fra Journal Entry markeringer',0),(368479,10236,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª© ì„ íƒì—ì„œ ë¸”ë¡',0),(368480,10236,'he','×‘×œ×•×§ ×ž×‘×—×™×¨×•×ª ×¢×¨×š ×™×•×ž×Ÿ',0),(368481,10236,'el','ÎœÏ€Î»Î¿Îº Î±Ï€ÏŒ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(368482,10236,'zh','é˜»æ­¢æ—¥è®°æ¡ç›®é€‰æ‹©\r\n',0),(368483,10236,'sv','Block frÃ¥n journalen intrade val',0),(368484,10236,'it','Blocco da Journal Entry selezioni',0),(368485,10236,'tl','',0),(368486,10236,'th','à¸ˆà¸²à¸à¹€à¸¥à¸·à¸­à¸à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™',0),(368487,10236,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤šà¤¯à¤¨à¥‹à¤‚ à¤¸à¥‡ à¤¬à¥à¤²à¥‰à¤•',0),(368488,10236,'ms','Blok dari pilihan kemasukan jurnal',0),(368489,10236,'ar','ÙƒØªÙ„Ø© Ù…Ù† Ø§Ù„ØªØ­Ø¯ÙŠØ¯Ø§Øª Ø¥Ø¯Ø®Ø§Ù„ Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(368490,10236,'fr','Bloc de sÃ©lections d\'entrÃ©e de Journal',0),(368491,10236,'jp','ãƒ–ãƒ­ãƒƒã‚¯ ã‚¸ãƒ£ãƒ¼ãƒŠãƒ« ã‚¨ãƒ³ãƒˆãƒªã®é¸æŠžã‹ã‚‰',0),(368492,10236,'pt','Bloco de seleÃ§Ãµes de entrada de diÃ¡rio',0),(368493,10236,'ru','Ð‘Ð»Ð¾Ðº Ð¸Ð· Ð¶ÑƒÑ€Ð½Ð°Ð»Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð²',0),(368494,10236,'es','Bloque de Selecciones de Entradas de Diario',0),(368495,10236,'de','Block von Journal Entry Auswahl',0),(368496,10236,'en','Block From Journal Entry Selections',0),(368497,10237,'is','',0),(368498,10237,'dr','Ø¨Ø±Ø±Ø³ÙŠ   Ø¬Ù‡Øª Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù†',0),(368499,10237,'pr','Ø¨Ø±Ø±Ø³ÙŠ   Ø¬Ù‡Øª Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù†',0),(368500,10237,'tr','Engellemek iÃ§in kontrol edin',0),(368501,10237,'pl','SprawdÅº, blok',0),(368502,10237,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð±Ð»Ð¾Ðº',0),(368503,10237,'ur','Ø¨Ù„Ø§Ú© Ø³Û’ Ø¨Ù„Ø§Ú© Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(368504,10237,'sr','ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð»Ð¾Ðº',0),(368505,10237,'vi','Kiá»ƒm tra Ä‘á»ƒ khá»‘i',0),(368506,10237,'af','Kontroleer om te blok',0),(368507,10237,'ro','Verifica la bloc',0),(368508,10237,'et','MÃ¤rkige see ruut Blokeeri',0),(368509,10237,'si','Preverite blok',0),(368510,10237,'ba','Periksa untuk blok',0),(368511,10237,'nl','Controleren op blokkeren',0),(368512,10237,'fi','Tarkista lohko',0),(368513,10237,'no','Sjekk for Ã¥ blokkere',0),(368514,10237,'da','Check til blok',0),(368515,10237,'ko','ë¸”ë¡ í™•ì¸',0),(368516,10237,'he','×‘×“×•×§ ×›×“×™ ×œ×—×¡×•×',0),(368517,10237,'el','Î•Î»Î­Î³Î¾Ï„Îµ ÏƒÎµ Î¼Ï€Î»Î¿Îº',0),(368518,10237,'zh','æ£€æŸ¥åº§\r\n',0),(368519,10237,'sv','Kolla pÃ¥ blocket',0),(368520,10237,'it','Verifica al blocco',0),(368521,10237,'tl','',0),(368522,10237,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸šà¸¥à¹‡à¸­à¸',0),(368523,10237,'hi','à¤¬à¥à¤²à¥‰à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(368524,10237,'ms','Semak untuk blok',0),(368525,10237,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø£Ù† ÙƒØªÙ„Ø©',0),(368526,10237,'fr','VÃ©rifier au bloc',0),(368527,10237,'jp','ãƒ–ãƒ­ãƒƒã‚¯ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(368528,10237,'pt','Verificar ao bloco',0),(368529,10237,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð±Ð»Ð¾Ðº',0),(368530,10237,'es','Chequear para Bloquear',0),(368531,10237,'de','ÃœberprÃ¼fen Sie auf Block',0),(368532,10237,'en','Check to Block',0),(368533,10238,'is','',0),(368534,10238,'dr','Ø§Ù†Ù‚Ø¶Ø§Ø¡',0),(368535,10238,'pr','Ø§Ù†Ù‚Ø¶Ø§Ø¡',0),(368536,10238,'tr','SÃ¼re sonu',0),(368537,10238,'pl','WygaÅ›niÄ™cia',0),(368538,10238,'bg','Ð˜Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° ÑÑ€Ð¾ÐºÐ°',0),(368539,10238,'ur','Ù…Ø¯Øª',0),(368540,10238,'sr','Ð Ð¾Ðº Ð²Ð°Ð¶ÐµÑšÐ°',0),(368541,10238,'vi','Sá»± káº¿t thÃºc',0),(368542,10238,'af','Verstryking',0),(368543,10238,'ro','Expirare',0),(368544,10238,'et','Aegumine',0),(368545,10238,'si','Poteka',0),(368546,10238,'ba','Kedaluwarsa',0),(368547,10238,'nl','Vervaldatum',0),(368548,10238,'fi','Vanhentuminen',0),(368549,10238,'no','UtlÃ¸p',0),(368550,10238,'da','UdlÃ¸b',0),(368551,10238,'ko','ë§Œë£Œ',0),(368552,10238,'he','×ª×¤×•×’×”',0),(368553,10238,'el','Î›Î®Î¾Î·Ï‚',0),(368554,10238,'zh','è¿‡æœŸ\r\n',0),(368555,10238,'sv','FÃ¶rfallodagen',0),(368556,10238,'it','Scadenza',0),(368557,10238,'tl','',0),(368558,10238,'th','à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(368559,10238,'hi','à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿',0),(368560,10238,'ms','Tamat tempoh',0),(368561,10238,'ar','Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØµÙ„Ø§Ø­ÙŠØ©',0),(368562,10238,'fr','Expiration',0),(368563,10238,'jp','æœ‰åŠ¹æœŸé™',0),(368564,10238,'pt','ExpiraÃ§Ã£o',0),(368565,10238,'ru','Ð¡Ñ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(368566,10238,'es','ExpiraciÃ³n',0),(368567,10238,'de','Ablauf',0),(368568,10238,'en','Expiration',0),(368569,10239,'is','',0),(368570,10239,'dr','ÙˆØ¶Ø¹ÙŠØª Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ ÙˆØ²ÙŠØ§Ù† Ù…Ù†',0),(368571,10239,'pr','ÙˆØ¶Ø¹ÙŠØª Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ ÙˆØ²ÙŠØ§Ù† Ù…Ù†',0),(368572,10239,'tr','Kar & kÃ¢r-zarar tablosu',0),(368573,10239,'pl','MÃ³j zysk & strat',0),(368574,10239,'bg','ÐœÐ¾ÑÑ‚ Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° & Ð·Ð°Ð³ÑƒÐ±Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(368575,10239,'ur','Ù…ÛŒØ±Ø§ Ù…Ù†Ø§ÙØ¹ & Ù†Ù‚ØµØ§Ù† Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(368576,10239,'sr','ÐœÐ¾Ñ˜ ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚ & Ð¸Ð»Ð¸ Ð¸Ð·Ð³ÑƒÐ±Ð¸Ñ‚Ð¸.',0),(368577,10239,'vi','BÃ¡o cÃ¡o lá»— lÃ£i cá»§a tÃ´i',0),(368578,10239,'af','My Wins-en-Verlies Staat',0),(368579,10239,'ro','Meu Profit & declaraÅ£ie de pierdere',0),(368580,10239,'et','Minu kasum & kahjumivÃ¤ljavÃµte',0),(368581,10239,'si','Moj dobiÄek & uspeha',0),(368582,10239,'ba','Saya keuntungan & rugi',0),(368583,10239,'nl','Mijn winst & verliesrekening',0),(368584,10239,'fi','Voitto & tappio ilmoitus',0),(368585,10239,'no','Min fortjeneste & tap uttalelse',0),(368586,10239,'da','Min fortjeneste & tab erklÃ¦ring',0),(368587,10239,'ko','ë‚´ ì´ìµì„ & ê³„ì‚° ì„œ',0),(368588,10239,'he','×©×œ×™ ×¨×•×•×— & ×•×”×¤×¡×“',0),(368589,10239,'el','ÎœÎ¿Ï… ÎºÎ­ÏÎ´Î¿Ï‚ & ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î±Ï€Î¿Ï„ÎµÎ»ÎµÏƒÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎµÏ‰Ï‚',0),(368590,10239,'zh','æˆ‘çš„åˆ©æ¶¦å’ŒäºæŸè¡¨\r\n',0),(368591,10239,'sv','Min vinst & resultatrÃ¤kning',0),(368592,10239,'it','Mio profitto & economico',0),(368593,10239,'tl','',0),(368594,10239,'th','à¸à¸³à¹„à¸£ & à¸‡à¸šà¸‚à¸²à¸”à¸—à¸¸à¸™à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(368595,10239,'hi','à¤®à¥‡à¤°à¤¾ à¤²à¤¾à¤­ & à¤¹à¤¾à¤¨à¤¿ à¤¬à¤¯à¤¾à¤¨',0),(368596,10239,'ms','Saya untung & kenyataan kehilangan',0),(368597,10239,'ar','Ø¨Ù„Ø¯ÙŠ Ø§Ù„Ø±Ø¨Ø­ Ø¢Ù†Ø¯ Ø¨ÙŠØ§Ù† Ø§Ù„Ø®Ø³Ø§Ø±Ø©',0),(368598,10239,'fr','Mon Profit & la dÃ©claration de perte',0),(368599,10239,'jp','ç§ã®åˆ©ç›Š & æå¤±ã®å£°æ˜Ž',0),(368600,10239,'pt','Meu lucro & declaraÃ§Ã£o de perda',0),(368601,10239,'ru','ÐœÐ¾Ñ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ & ÑƒÐ±Ñ‹Ñ‚ÐºÐ°Ñ…',0),(368602,10239,'es','Mi Estado de Cuenta de Ganancias y PÃ©rdidas',0),(368603,10239,'de','Mein Gewinn & Verlustrechnung',0),(368604,10239,'en','My Profit & Loss Statement',0),(368605,10240,'is','',0),(368606,10240,'dr','ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÙŠØ§Ù† Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ù…Ø§Ù„Ùƒ ',0),(368607,10240,'pr','ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÙŠØ§Ù† Ø¨ÙˆØ³ÙŠÙ„Ù‡ Ù…Ø§Ù„Ùƒ ',0),(368608,10240,'tr','Kar & sahibi tarafÄ±ndan zarar tablosu',0),(368609,10240,'pl','Zysk & strat przez wÅ‚aÅ›ciciela',0),(368610,10240,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð° & Ð·Ð°Ð³ÑƒÐ±Ð° Ð´ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ Ð¾Ñ‚ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸ÐºÐ°',0),(368611,10240,'ur','Ù…Ù†Ø§ÙØ¹ & Ù…Ø§Ù„Ú© Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù†Ù‚ØµØ§Ù† Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(368612,10240,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð°Ðº Ð¸ Ð³ÑƒÐ±Ð¸Ñ‚Ð°Ðº Ð¸Ð·Ñ˜Ð°Ð²Ð° Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð²Ð»Ð°ÑÐ½Ð¸ÐºÐ°',0),(368613,10240,'vi','bÃ¡o cÃ¡o lá»— lÃ£i bá»Ÿi chá»§ sá»Ÿ há»¯u',0),(368614,10240,'af','Wins-en-Verlies Staat deur Eienaar',0),(368615,10240,'ro','Profitul & declaraÅ£ie de pierdere de proprietar',0),(368616,10240,'et','Kasum & kahjumivÃ¤ljavÃµte omaniku jÃ¤rgi',0),(368617,10240,'si','DobiÄek & izgubo izjava lastnika',0),(368618,10240,'ba','Keuntungan & rugi oleh pemilik',0),(368619,10240,'nl','Winst & verliesrekening door eigenaar',0),(368620,10240,'fi','Voitto & tappio lausuma omistaja',0),(368621,10240,'no','Fortjeneste & tap uttalelse fra eieren',0),(368622,10240,'da','Profit & tab erklÃ¦ring fra ejeren',0),(368623,10240,'ko','ì´ìµ & ì†Œìœ ìžì— ì˜í•´ ê³„ì‚° ì„œ',0),(368624,10240,'he','×¨×•×•×— & ×•×”×¤×¡×“ ×œ×¤×™ ×‘×¢×œ×™×',0),(368625,10240,'el','ÎšÎ­ÏÎ´Î¿Ï‚ & Î±Ï€ÏŽÎ»ÎµÎ¹Î± Î´Î®Î»Ï‰ÏƒÎ· Î±Ï€ÏŒ Ï„Î¿Î½ Î¹Î´Î¹Î¿ÎºÏ„Î®Ï„Î·',0),(368626,10240,'zh','æŸç›Šè¡¨çš„æ‰€æœ‰è€…\r\n',0),(368627,10240,'sv','Vinst & resultatrÃ¤kning av Ã¤garen',0),(368628,10240,'it','Profitto & dichiarazione di perdita dal proprietario',0),(368629,10240,'tl','',0),(368630,10240,'th','à¸à¸³à¹„à¸£ & à¸‡à¸šà¸‚à¸²à¸”à¸—à¸¸à¸™ à¹‚à¸”à¸¢à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡',0),(368631,10240,'hi','à¤²à¤¾à¤­ & à¤®à¤¾à¤²à¤¿à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¹à¤¾à¤¨à¤¿ à¤¬à¤¯à¤¾à¤¨',0),(368632,10240,'ms','Keuntungan & kerugian penyata pemilik',0),(368633,10240,'ar','ÙƒØ´Ù Ø§Ù„Ø£Ø±Ø¨Ø§Ø­ ÙˆØ§Ù„Ø®Ø³Ø§Ø¦Ø± Ù„ÙƒÙ„ Ù…Ø§Ù„Ùƒ',0),(368634,10240,'fr','Profit & dÃ©claration de perte par le propriÃ©taire',0),(368635,10240,'jp','åˆ©ç›Š & æ‰€æœ‰è€…ã«ã‚ˆã£ã¦æå¤±ã®å£°æ˜Ž',0),(368636,10240,'pt','Lucro & declaraÃ§Ã£o de perda do proprietÃ¡rio',0),(368637,10240,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ & Ð¿Ð¾Ñ‚ÐµÑ€Ð¸ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð²Ð»Ð°Ð´ÐµÐ»ÑŒÑ†Ð°',0),(368638,10240,'es','Documento de Estado de Resultados por DueÃ±o',0),(368639,10240,'de','Gewinn & Verlustrechnung des EigentÃ¼mers',0),(368640,10240,'en','Profit & Loss Statement by Owner',0),(368641,10241,'is','',0),(368642,10241,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„',0),(368643,10241,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¨ÙˆØ¯Ø¬Ù‡ Ø´ØºÙ„',0),(368644,10241,'tr','Ä°ÅŸ bÃ¼tÃ§e raporu',0),(368645,10241,'pl','Sprawozdanie budÅ¼et zadania',0),(368646,10241,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(368647,10241,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(368648,10241,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð±ÑƒÑŸÐµÑ‚Ñƒ Ð¿Ð¾ÑÐ°Ð¾',0),(368649,10241,'vi','bÃ¡o cÃ¡o ngÃ¢n sÃ¡ch cÃ´ng viá»‡c',0),(368650,10241,'af','Werkstuk Begrotingsverslag',0),(368651,10241,'ro','Raport de buget Job',0),(368652,10241,'et','Projekti eelarve aruanne',0),(368653,10241,'si','Zaposlitve poroÄilo o proraÄunu',0),(368654,10241,'ba','Laporan anggaran pekerjaan',0),(368655,10241,'nl','Begroting taakrapport',0),(368656,10241,'fi','TyÃ¶ Budjettiraportti',0),(368657,10241,'no','Jobb Budsjettrapport',0),(368658,10241,'da','Budgetrapport â€“ job',0),(368659,10241,'ko','ì¼ìžë¦¬ ì˜ˆì‚° ë³´ê³ ì„œ',0),(368660,10241,'he','×“×•×— ×ª×§×¦×™×‘ ×¢×‘×•×“×”',0),(368661,10241,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ \"ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï\"',0),(368662,10241,'zh','é¡¹ç›®é¢„ç®—æŠ¥å‘Š\r\n',0),(368663,10241,'sv','Jobb budgetrapport',0),(368664,10241,'it','Relazione di lavoro preventivo',0),(368665,10241,'tl','',0),(368666,10241,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸‡à¸²à¸™',0),(368667,10241,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¬à¤œà¤Ÿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(368668,10241,'ms','Laporan bajet kerja',0),(368669,10241,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù…Ù‡Ù…Ø©',0),(368670,10241,'fr','Rapport sur le Budget emploi',0),(368671,10241,'jp','ã‚¸ãƒ§ãƒ–äºˆç®—ãƒ¬ãƒãƒ¼ãƒˆ',0),(368672,10241,'pt','RelatÃ³rio de orÃ§amento de trabalho',0),(368673,10241,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(368674,10241,'es','Informe de Presupuesto del Trabajo',0),(368675,10241,'de','Job Budgetbericht',0),(368676,10241,'en','Job Budget Report',0),(368677,10242,'is','',0),(368678,10242,'dr','Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ ÙˆØ²ÙŠØ§Ù† Ù…Ù†',0),(368679,10242,'pr','Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯ ÙˆØ²ÙŠØ§Ù† Ù…Ù†',0),(368680,10242,'tr','Benim kar ve zarar',0),(368681,10242,'pl','MÃ³j zyskÃ³w i strat',0),(368682,10242,'bg','ÐœÐ¾Ð¸Ñ‚Ðµ Ð¿ÐµÑ‡Ð°Ð»Ð±Ð¸ Ð¸ Ð·Ð°Ð³ÑƒÐ±Ð¸',0),(368683,10242,'ur','Ø§Ù¾Ù†Û’ Ù†ÙØ¹ Ùˆ Ù†Ù‚ØµØ§Ù†',0),(368684,10242,'sr','ÐœÐ¾Ñ˜ Ð´Ð¾Ð±Ð¸Ñ‚ÐºÐ° Ð¸ Ð³ÑƒÐ±Ð¸Ñ‚ÐºÐ°',0),(368685,10242,'vi','Cá»§a tÃ´i lá»£i nhuáº­n vÃ  máº¥t',0),(368686,10242,'af','My Wins-en-Verlies',0),(368687,10242,'ro','Meu de Profit ÅŸi pierdere',0),(368688,10242,'et','Minu tulu ja kulu',0),(368689,10242,'si','Moj poslovnega izida',0),(368690,10242,'ba','Saya keuntungan dan kerugian',0),(368691,10242,'nl','Mijn winst-en verliesrekening',0),(368692,10242,'fi','Voitto ja tappio',0),(368693,10242,'no','Mitt resultat',0),(368694,10242,'da','Min gevinst og tab',0),(368695,10242,'ko','ë‚´ ì†ìµ',0),(368696,10242,'he','×©×œ×™ ×¨×•×•×— ×•×”×¤×¡×“',0),(368697,10242,'el','ÎœÎ¿Ï… Ï‡ÏÎ®ÏƒÎµÏ‰Ï‚',0),(368698,10242,'zh','æˆ‘çš„åˆ©æ¶¦å’ŒäºæŸ\r\n',0),(368699,10242,'sv','Min vinst och fÃ¶rlust',0),(368700,10242,'it','Mio economico',0),(368701,10242,'tl','',0),(368702,10242,'th','à¸à¸³à¹„à¸£à¸‚à¸²à¸”à¸—à¸¸à¸™à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(368703,10242,'hi','à¤…à¤ªà¤¨à¥‡ à¤²à¤¾à¤­ à¤”à¤° à¤¹à¤¾à¤¨à¤¿',0),(368704,10242,'ms','Saya untung dan rugi',0),(368705,10242,'ar','Ø¨Ù„Ø¯ÙŠ Ø§Ù„Ø±Ø¨Ø­ ÙˆØ§Ù„Ø®Ø³Ø§Ø±Ø©',0),(368706,10242,'fr','Mon rÃ©sultat',0),(368707,10242,'jp','ç§ã®åˆ©ç›Šã¨æå¤±',0),(368708,10242,'pt','Meus ganhos e perdas',0),(368709,10242,'ru','ÐœÐ¾Ð¹ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸ Ð¸ ÑƒÐ±Ñ‹Ñ‚ÐºÐ¾Ð²',0),(368710,10242,'es','Mi Ganancias y PÃ©rdidas',0),(368711,10242,'de','Mein Gewinn und Verlust',0),(368712,10242,'en','My Profit and Loss',0),(368713,10243,'is','',0),(368714,10243,'dr','ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÛŒØ§Ù† Ù…Ø§Ù„Ùƒ ',0),(368715,10243,'pr','ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÛŒØ§Ù† Ù…Ø§Ù„Ùƒ ',0),(368716,10243,'tr','Sahibi kar & kÃ¢r-zarar tablosu',0),(368717,10243,'pl','Zysk wÅ‚aÅ›ciciela & strat',0),(368718,10243,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸Ðº Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° & Ð·Ð°Ð³ÑƒÐ±Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(368719,10243,'ur','Ù…Ø§Ù„Ú© Ù…Ù†Ø§ÙØ¹ & Ù†Ù‚ØµØ§Ù† Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(368720,10243,'sr','Ð’Ð»Ð°ÑÐ½Ð¸Ðº ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚ & Ð¸Ð»Ð¸ Ð¸Ð·Ð³ÑƒÐ±Ð¸Ñ‚Ð¸.',0),(368721,10243,'vi','Chá»§ sá»Ÿ há»¯u lá»£i nhuáº­n &amp; tuyÃªn bá»‘ máº¥t',0),(368722,10243,'af','Eienaar Wins-en-Verlies Staat',0),(368723,10243,'ro','Proprietarul Profit & declaraÅ£ie de pierdere',0),(368724,10243,'et','Omaniku kasum & kahjumivÃ¤ljavÃµte',0),(368725,10243,'si','Lastnik dobiÄek & uspeha',0),(368726,10243,'ba','Keuntungan pemilik & rugi',0),(368727,10243,'nl','Eigenaar winst & verliesrekening',0),(368728,10243,'fi','Omistaja voittoa & tappio ilmoitus',0),(368729,10243,'no','Eier Profit & tap uttalelse',0),(368730,10243,'da','Ejer Profit & tab erklÃ¦ring',0),(368731,10243,'ko','ì†Œìœ ìž ì´ìµì„ & ê³„ì‚° ì„œ',0),(368732,10243,'he','×¨×•×•×— ×”×‘×¢×œ×™× & ×•×”×¤×¡×“',0),(368733,10243,'el','Î™Î´Î¹Î¿ÎºÏ„Î®Ï„Î·Ï‚ ÎºÎ­ÏÎ´Î¿Ï‚ & ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î±Ï€Î¿Ï„ÎµÎ»ÎµÏƒÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎµÏ‰Ï‚',0),(368734,10243,'zh','ä¸šä¸»æŸç›Šè¡¨\r\n',0),(368735,10243,'sv','Ã„gare vinst & resultatrÃ¤kning',0),(368736,10243,'it','Profitto del proprietario & economico',0),(368737,10243,'tl','',0),(368738,10243,'th','à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸à¸³à¹„à¸£ & à¸‡à¸šà¸‚à¸²à¸”à¸—à¸¸à¸™',0),(368739,10243,'hi','à¤¸à¥à¤µà¤¾à¤®à¥€ à¤²à¤¾à¤­ & à¤¹à¤¾à¤¨à¤¿ à¤¬à¤¯à¤¾à¤¨',0),(368740,10243,'ms','Keuntungan pemilik & kenyataan kehilangan',0),(368741,10243,'ar','ÙƒØ´Ù Ø§Ù„Ø£Ø±Ø¨Ø§Ø­ ÙˆØ§Ù„Ø®Ø³Ø§Ø¦Ø± Ù„Ù„Ù…Ø§Ù„Ùƒ',0),(368742,10243,'fr','PropriÃ©taire bÃ©nÃ©ficiaire & dÃ©claration de perte',0),(368743,10243,'jp','æ‰€æœ‰è€…ã®åˆ©ç›Š & æå¤±ã®å£°æ˜Ž',0),(368744,10243,'pt','Lucro do proprietÃ¡rio & declaraÃ§Ã£o de perda',0),(368745,10243,'ru','Ð’Ð»Ð°Ð´ÐµÐ»ÐµÑ† Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸ & ÑƒÐ±Ñ‹Ñ‚ÐºÐ°Ñ…',0),(368746,10243,'es','Estado de Resultados del DueÃ±o',0),(368747,10243,'de','Besitzer Gewinn & Verlustrechnung',0),(368748,10243,'en','Owner Profit & Loss Statement',0),(368749,10244,'is','',0),(368750,10244,'dr','Ú†Ø§Ù¾ ÙŠÙƒ ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÛŒØ§Ù† ØªÙˆØ³Ø· Ù…Ø§Ù„Ùƒ ',0),(368751,10244,'pr','Ú†Ø§Ù¾ ÙŠÙƒ ØµÙˆØ±Øª Ø³ÙˆØ¯ Ùˆ Ø²ÛŒØ§Ù† ØªÙˆØ³Ø· Ù…Ø§Ù„Ùƒ ',0),(368752,10244,'tr','Kar & sahibi tarafÄ±ndan zarar raporu yazdÄ±r',0),(368753,10244,'pl','Drukowanie zysku & strat przez wÅ‚aÅ›ciciela',0),(368754,10244,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° & Ð·Ð°Ð³ÑƒÐ±Ð° Ð´ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ Ð¾Ñ‚ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸ÐºÐ°',0),(368755,10244,'ur','Ø§ÛŒÚ© Ù…Ù†Ø§ÙØ¹ Ø¨Ø®Ø´ & Ù…Ø§Ù„Ú© Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù†Ù‚ØµØ§Ù† Ú©Ø§ Ø¨ÛŒØ§Ù† Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(368756,10244,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚ Ð¸ Ð³ÑƒÐ±Ð¸Ñ‚Ð°Ðº Ð¸Ð·Ð²Ð¾Ð´Ð° Ð¿Ð¾ Ð²Ð»Ð°ÑÐ½Ð¸ÐºÑƒ',0),(368757,10244,'vi','In má»™t lá»£i nhuáº­n &amp; máº¥t tuyÃªn bá»‘ cá»§a chá»§ sá»Ÿ há»¯u',0),(368758,10244,'af','Druk \'n Wins-en-Verlies Staat per Eienaar',0),(368759,10244,'ro','Imprima un Profit & declaraÅ£ie de pierdere de proprietar',0),(368760,10244,'et','Prindi kasumi & kahjumivÃ¤ljavÃµte omaniku jÃ¤rgi',0),(368761,10244,'si','Tiskanje dobiÄek & izgubo izjava lastnika',0),(368762,10244,'ba','Mencetak keuntungan & rugi oleh pemilik',0),(368763,10244,'nl','Afdrukken van een winst & verliesrekening door eigenaar',0),(368764,10244,'fi','Tulostaa voittoa & tappio lausuma omistaja',0),(368765,10244,'no','Skrive ut en profitt & tap uttalelse fra eieren',0),(368766,10244,'da','Udskrive en Profit & tab erklÃ¦ring fra ejeren',0),(368767,10244,'ko','ì´ìµ & ì†Œìœ ìžì— ì˜í•´ ê³„ì‚° ì„œ ì¸ì‡„',0),(368768,10244,'he','×”×“×¤×¡ ×©×œ ×¨×•×•×— & ×•×”×¤×¡×“ ×œ×¤×™ ×‘×¢×œ×™×',0),(368769,10244,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î­Î½Î± ÎºÎ­ÏÎ´Î¿Ï‚ & Î±Ï€ÏŽÎ»ÎµÎ¹Î± Î´Î®Î»Ï‰ÏƒÎ· Î±Ï€ÏŒ Ï„Î¿Î½ Î¹Î´Î¹Î¿ÎºÏ„Î®Ï„Î·',0),(368770,10244,'zh','æ‰“å°ç”±ä¸šä¸»æŸç›Šè¡¨\r\n',0),(368771,10244,'sv','Skriva ut en vinst & resultatrÃ¤kning av Ã¤garen',0),(368772,10244,'it','Stampare un profitto & dichiarazione di perdita dal proprietario',0),(368773,10244,'tl','',0),(368774,10244,'th','à¸žà¸´à¸¡à¸žà¹Œà¸à¸³à¹„à¸£ & à¸‡à¸šà¸‚à¸²à¸”à¸—à¸¸à¸™ à¹‚à¸”à¸¢à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡',0),(368775,10244,'hi','à¤à¤• à¤²à¤¾à¤­ & à¤®à¤¾à¤²à¤¿à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¹à¤¾à¤¨à¤¿ à¤•à¤¥à¤¨ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(368776,10244,'ms','Cetak keuntungan & kerugian penyata pemilik',0),(368777,10244,'ar','Ø·Ø¨Ø§Ø¹Ø© ÙƒØ´Ù Ø§Ù„Ø£Ø±Ø¨Ø§Ø­ ÙˆØ§Ù„Ø®Ø³Ø§Ø¦Ø± Ù„ÙƒÙ„ Ù…Ø§Ù„Ùƒ',0),(368778,10244,'fr','Imprimer un Profit & la dÃ©claration de perte par le propriÃ©taire',0),(368779,10244,'jp','åˆ©ç›Š & æ‰€æœ‰è€…ã«ã‚ˆã£ã¦æå¤±ã®ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(368780,10244,'pt','Imprimir um lucro & declaraÃ§Ã£o de perda do proprietÃ¡rio',0),(368781,10244,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸ & Ð¿Ð¾Ñ‚ÐµÑ€Ð¸ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð²Ð»Ð°Ð´ÐµÐ»ÑŒÑ†Ð°',0),(368782,10244,'es','Imprimir un Documento de Estado de Resultados por DueÃ±o',0),(368783,10244,'de','Drucken Sie einen Gewinn & Verlustrechnung des EigentÃ¼mers',0),(368784,10244,'en','Print a Profit & Loss Statement by Owner',0),(368785,10245,'is','',0),(368786,10245,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ ',0),(368787,10245,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ ',0),(368788,10245,'tr','Addministrative Ã¼cret gider hesabÄ±',0),(368789,10245,'pl','Addministrative opÅ‚aty rozchodowych',0),(368790,10245,'bg','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²ÐµÐ½ Ñ‚Ð°ÐºÑÐ°Ñ‚Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(368791,10245,'ur','Ø§Ø¯Ù…Ø§Ù†Ø³Ù¹Ø±ØªØ§ÙˆÛŒ ÙÛŒØ³ Ø®Ø±Ú†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(368792,10245,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð½Ð°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÐÐ´Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ðµ',0),(368793,10245,'vi','TÃ i khoáº£n chi phÃ­ Addministrative phÃ­',0),(368794,10245,'af','Administratiewe Fooi Uitgawe Rekening',0),(368795,10245,'ro','Contul de cheltuieli administrative taxa',0),(368796,10245,'et','Addministrative tasu Kulukonto',0),(368797,10245,'si','Konto stroÅ¡kov Addministrative pristojbina',0),(368798,10245,'ba','Rekening pengeluaran biaya Addministrative',0),(368799,10245,'nl','Addministrative vergoeding kostenrekening',0),(368800,10245,'fi','Addministrative maksu kulutili',0),(368801,10245,'no','Addministrative gebyr kostnadskonto',0),(368802,10245,'da','Addministrative gebyr udgiftskonto',0),(368803,10245,'ko','Addministrative ìˆ˜ìˆ˜ë£Œ ë¹„ìš© ê³„ì •',0),(368804,10245,'he','×—×©×‘×•×Ÿ ×”×•×¦××•×ª ×“×ž×™ Addministrative',0),(368805,10245,'el','Î‘Î¼Î¿Î¹Î²Î® Addministrative Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÎµÎ¾ÏŒÎ´Ï‰Î½',0),(368806,10245,'zh','ç®¡ç†è´¹æ”¯å‡ºå¸æˆ·\r\n',0),(368807,10245,'sv','Addministrative avgift utgiftskonto',0),(368808,10245,'it','Conto di spese di tassa di Addministrative',0),(368809,10245,'tl','',0),(368810,10245,'th','à¸šà¸±à¸à¸Šà¸µà¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡ Addministrative',0),(368811,10245,'hi','Addministrative à¤¶à¥à¤²à¥à¤• à¤µà¥à¤¯à¤¯ à¤–à¤¾à¤¤à¥‡',0),(368812,10245,'ms','Akaun perbelanjaan yuran Addministrative',0),(368813,10245,'ar','Ø­Ø³Ø§Ø¨ Ù…ØµØ±ÙˆÙØ§Øª Ø±Ø³ÙˆÙ… Ø£Ø¯Ù…ÙŠÙ†ÙŠØ³ØªØ±Ø§ØªÙŠÙÙŠ',0),(368814,10245,'fr','Compte de dÃ©penses de frais administratif',0),(368815,10245,'jp','Addministrative æ–™çµŒè²»å‹˜å®š',0),(368816,10245,'pt','Conta de despesas de taxa de Addministrative',0),(368817,10245,'ru','Addministrative Ð¿Ð»Ð°Ñ‚Ð° Ð·Ð° ÑÑ‡ÐµÑ‚',0),(368818,10245,'es','Cuenta de Gastos para Cuotas Administraivas',0),(368819,10245,'de','Addministrative Fee Aufwandskonto',0),(368820,10245,'en','Addministrative Fee Expense Account',0),(368821,10246,'is','',0),(368822,10246,'dr','Ø«Ø§Ø¨Øª ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ ',0),(368823,10246,'pr','Ø«Ø§Ø¨Øª ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ ',0),(368824,10246,'tr','Ä°dari Ã¼cret - dÃ¼z',0),(368825,10246,'pl','OpÅ‚ata administracyjna - mieszkanie',0),(368826,10246,'bg','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ñ‚Ð°ÐºÑÐ° - Ð¿Ð»Ð¾ÑÑŠÐº',0),(368827,10246,'ur','Ø§Ù†ØªØ¸Ø§Ù…ÛŒ ÙÛŒØ³ - ÙÙ„ÛŒÙ¹',0),(368828,10246,'sr','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ñ‚Ð°ÐºÑÐ° - ÑÑ‚Ð°Ð½',0),(368829,10246,'vi','Lá»‡ phÃ­ hÃ nh chÃ­nh - pháº³ng',0),(368830,10246,'af','Administratiewe Fooi - Vaste Tarief',0),(368831,10246,'ro','Taxe administrative - plat',0),(368832,10246,'et','Haldustasu - korter',0),(368833,10246,'si','Upravna taksa - stanovanje',0),(368834,10246,'ba','Biaya administrasi - datar',0),(368835,10246,'nl','Administratiekosten - Flat',0),(368836,10246,'fi','Hallinnollinen maksu - taulu',0),(368837,10246,'no','Administrativt gebyr - flatskjerm',0),(368838,10246,'da','Administrationsgebyr - flad',0),(368839,10246,'ko','ê´€ë¦¬ ë¹„-í”Œëž«',0),(368840,10246,'he','×“×ž×™ × ×™×”×•×œ - ×©×˜×•×—',0),(368841,10246,'el','Î”Î¹Î¿Î¹ÎºÎ·Ï„Î¹ÎºÎ¬ Ï„Î­Î»Î· - ÎµÏ€Î¯Ï€ÎµÎ´Î·Ï‚',0),(368842,10246,'zh','ç®¡ç†è´¹ç”¨- å¹³\r\n',0),(368843,10246,'sv','Administrativ avgift - platt',0),(368844,10246,'it','Tassa amministrativa - piatto',0),(368845,10246,'tl','',0),(368846,10246,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸ˆà¸±à¸”à¸à¸²à¸£ - à¹à¸šà¸™',0),(368847,10246,'hi','à¤ªà¥à¤°à¤¶à¤¾à¤¸à¤¨à¤¿à¤• à¤¶à¥à¤²à¥à¤• - à¤«à¥à¤²à¥ˆà¤Ÿ',0),(368848,10246,'ms','Yuran pentadbiran - rata',0),(368849,10246,'ar','Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥Ø¯Ø§Ø±ÙŠØ©-Ù…Ø³Ø·Ø­Ø©',0),(368850,10246,'fr','Frais administratifs - plat',0),(368851,10246,'jp','äº‹å‹™æ‰‹æ•°æ–™ - ãƒ•ãƒ©ãƒƒãƒˆ',0),(368852,10246,'pt','Taxa administrativa - Flat',0),(368853,10246,'ru','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ñ‹Ð¹ ÑÐ±Ð¾Ñ€ - ÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ð°',0),(368854,10246,'es','Cuota Administrativa - Fijo',0),(368855,10246,'de','VerwaltungsgebÃ¼hr - Wohnung',0),(368856,10246,'en','Administrative Fee - Flat',0),(368857,10247,'is','',0),(368858,10247,'dr','Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ ',0),(368859,10247,'pr','Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ ',0),(368860,10247,'tr','Ä°dari Ã¼cret - yÃ¼zde',0),(368861,10247,'pl','OpÅ‚ata administracyjna - procent',0),(368862,10247,'bg','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ñ‚Ð°ÐºÑÐ° - %',0),(368863,10247,'ur','Ø§Ù†ØªØ¸Ø§Ù…ÛŒ ÙÛŒØ³ - ÙÛŒ ØµØ¯',0),(368864,10247,'sr','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ñ‚Ð°ÐºÑÐ° - %',0),(368865,10247,'vi','Lá»‡ phÃ­ hÃ nh chÃ­nh - pháº§n trÄƒm',0),(368866,10247,'af','Administratiewe Fooi - Persentasie',0),(368867,10247,'ro','Taxe administrative - la sutÄƒ',0),(368868,10247,'et','Haldustasu - protsenti',0),(368869,10247,'si','Upravna taksa - odstotkov',0),(368870,10247,'ba','Biaya administrasi - persen',0),(368871,10247,'nl','Administratiekosten - procent',0),(368872,10247,'fi','Hallinnollinen maksu - prosenttia',0),(368873,10247,'no','Administrativt gebyr - prosent',0),(368874,10247,'da','Administrationsgebyr - procent',0),(368875,10247,'ko','ê´€ë¦¬ ë¹„-%',0),(368876,10247,'he','×“×ž×™ × ×™×”×•×œ - ××—×•×–',0),(368877,10247,'el','Î”Î¹Î¿Î¹ÎºÎ·Ï„Î¹ÎºÎ¬ Ï„Î­Î»Î· - Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(368878,10247,'zh','ç®¡ç†è´¹ç”¨ -ç™¾åˆ†æ¯”\r\n',0),(368879,10247,'sv','Administrativ avgift - procent',0),(368880,10247,'it','Tassa amministrativa - per cento',0),(368881,10247,'tl','',0),(368882,10247,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸ˆà¸±à¸”à¸à¸²à¸£ - à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œ',0),(368883,10247,'hi','à¤ªà¥à¤°à¤¶à¤¾à¤¸à¤¨à¤¿à¤• à¤¶à¥à¤²à¥à¤• - à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(368884,10247,'ms','Yuran pentadbiran - peratus',0),(368885,10247,'ar','Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥Ø¯Ø§Ø±ÙŠØ©-Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(368886,10247,'fr','Frais administratifs - pour cent',0),(368887,10247,'jp','äº‹å‹™æ‰‹æ•°æ–™ - ï¼…',0),(368888,10247,'pt','Taxa administrativa - por cento',0),(368889,10247,'ru','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ñ‹Ð¹ ÑÐ±Ð¾Ñ€ - %',0),(368890,10247,'es','Cuota Administrativa - Porcentaje',0),(368891,10247,'de','VerwaltungsgebÃ¼hr - Prozent',0),(368892,10247,'en','Administrative Fee - Percent',0),(368893,10248,'is','',0),(368894,10248,'dr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´  ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ',0),(368895,10248,'pr','Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´  ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ',0),(368896,10248,'tr','Ä°dari Ã¼creti satÄ±ÅŸ hesabÄ±',0),(368897,10248,'pl','SprzedaÅ¼ konta opÅ‚atÄ™ administracyjnÄ…',0),(368898,10248,'bg','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ñ‚Ð°ÐºÑÐ° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(368899,10248,'ur','Ø§Ù†ØªØ¸Ø§Ù…ÛŒ ÙÛŒØ³ Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(368900,10248,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(368901,10248,'vi','Lá»‡ phÃ­ hÃ nh chÃ­nh tÃ i khoáº£n bÃ¡n hÃ ng',0),(368902,10248,'af','Administratiewe Fooi Verkoopsrekening',0),(368903,10248,'ro','Cont taxÄƒ administrativÄƒ de vÃ¢nzÄƒri',0),(368904,10248,'et','Haldustasu MÃ¼Ã¼gikonto',0),(368905,10248,'si','Prodajni raÄun upravne takse',0),(368906,10248,'ba','Biaya administrasi penjualan Account',0),(368907,10248,'nl','Administratiekosten rekening voor verkoop',0),(368908,10248,'fi','Hallinnollisen maksun myynnin tili',0),(368909,10248,'no','Administrativt gebyr salgskontoen',0),(368910,10248,'da','Administrationsgebyr salg konto',0),(368911,10248,'ko','ìˆ˜ìˆ˜ë£Œ íŒë§¤ ê³„ì •',0),(368912,10248,'he','×“×ž×™ × ×™×”×•×œ ×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª',0),(368913,10248,'el','Î¤Î­Î»Î¿Ï‚ Î´Î¹ÎµÎºÏ€ÎµÏÎ±Î¯Ï‰ÏƒÎ·Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(368914,10248,'zh','é”€å”®å¸æˆ·ç®¡ç†è´¹\r\n',0),(368915,10248,'sv','Administrativ avgift fÃ¶rsÃ¤ljningskontot',0),(368916,10248,'it','Tassa amministrativa Sales Account',0),(368917,10248,'tl','',0),(368918,10248,'th','à¸šà¸±à¸à¸Šà¸µà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£',0),(368919,10248,'hi','à¤ªà¥à¤°à¤¶à¤¾à¤¸à¤¨à¤¿à¤• à¤¶à¥à¤²à¥à¤• à¤µà¤¿à¤•à¥à¤°à¤¯ à¤–à¤¾à¤¤à¤¾',0),(368920,10248,'ms','Akaun jualan Yuran pentadbiran',0),(368921,10248,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥Ø¯Ø§Ø±ÙŠØ©',0),(368922,10248,'fr','Ventes reprÃ©sentent des frais administratifs',0),(368923,10248,'jp','äº‹å‹™æ‰‹æ•°æ–™è²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(368924,10248,'pt','Conta de vendas de taxa administrativa',0),(368925,10248,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ñ‹Ð¹ ÑÐ±Ð¾Ñ€',0),(368926,10248,'es','Cuenta de Ventas de Cuota Administrativa',0),(368927,10248,'de','VerwaltungsgebÃ¼hr Kundenkonto',0),(368928,10248,'en','Administrative Fee Sales Account',0),(368929,10249,'is','',0),(368930,10249,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙˆØ±ÙˆØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(368931,10249,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙˆØ±ÙˆØ¯ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(368932,10249,'tr','Kredi kartÄ± Ã¼cret alma seÃ§enekleri',0),(368933,10249,'pl','Opcje importowania opÅ‚aty kartÄ… kredytowÄ…',0),(368934,10249,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸ Ñ‚Ð°ÐºÑÐ° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(368935,10249,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú†Ø§Ø±Ø¬ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(368936,10249,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ ÑƒÐ²Ð¾Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(368937,10249,'vi','Tháº» tÃ­n dá»¥ng phÃ­ tÃ¹y chá»n nháº­p kháº©u',0),(368938,10249,'af','Kredietkaartheffings Ingevoer Opsies',0),(368939,10249,'ro','Cardul de credit taxa de opÅ£iuni de Import',0),(368940,10249,'et','Krediitkaardi tasu impordi vÃµtmed',0),(368941,10249,'si','MoÅ¾nosti uvoza dajatev kreditno kartico',0),(368942,10249,'ba','Kartu kredit biaya impor pilihan',0),(368943,10249,'nl','Creditcard Charge importopties',0),(368944,10249,'fi','Luottokortti maksu tuomisen asetukset',0),(368945,10249,'no','Kredittkort kostnader importvalg',0),(368946,10249,'da','Kreditkort gebyr importindstillinger',0),(368947,10249,'ko','ì‹ ìš© ì¹´ë“œ ì¶©ì „ ê°€ì ¸ì˜¤ê¸° ì˜µì…˜',0),(368948,10249,'he','××¤×©×¨×•×™×•×ª ×™×™×‘×•× ×©×œ ×ª×©×œ×•× ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(368949,10249,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(368950,10249,'zh','ä¿¡ç”¨å¡æ”¶è´¹å¯¼å…¥é€‰é¡¹\r\n',0),(368951,10249,'sv','Kreditkort avgift importalternativ',0),(368952,10249,'it','Opzioni di importazione di addebito carta di credito',0),(368953,10249,'tl','',0),(368954,10249,'th','à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(368955,10249,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥à¤²à¥à¤• à¤†à¤¯à¤¾à¤¤ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(368956,10249,'ms','Pilihan Import caj kad kredit',0),(368957,10249,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø±Ø³ÙˆÙ… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(368958,10249,'fr','Options d\'importation de carte de crÃ©dit gratuitement',0),(368959,10249,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ–™é‡‘ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(368960,10249,'pt','OpÃ§Ãµes de importaÃ§Ã£o de carga de cartÃ£o de crÃ©dito',0),(368961,10249,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð·Ð°Ñ€ÑÐ´Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(368962,10249,'es','Opciones de ImportaciÃ³n del Cargos de Tarjeta de CrÃ©dito',0),(368963,10249,'de','Kreditkarte kostenlos-Importoptionen',0),(368964,10249,'en','Credit Card Charge Import Options',0),(368965,10250,'is','',0),(368966,10250,'dr','ÙÙ‚Ø· Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(368967,10250,'pr','ÙÙ‚Ø· Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(368968,10250,'tr','Avans tutarlarÄ± yalnÄ±zca',0),(368969,10250,'pl','Uchwyt kwoty tylko',0),(368970,10250,'bg','Ð¤Ð¸ÐºÑÐ°Ñ‚Ð¾Ñ€ ÑÑƒÐ¼Ð¸ ÑÐ°Ð¼Ð¾',0),(368971,10250,'ur','Ø¯Ø§Ù…Ù†Ú¯ÛŒØ± Ù…Ù‚Ø¯Ø§Ø± ØµØ±Ù',0),(368972,10250,'sr','ÐŸÐ¾Ð»Ð¾Ð³ Ð¸Ð·Ð½Ð¾ÑÐ¸ ÑÐ°Ð¼Ð¾',0),(368973,10250,'vi','Giá»¯ sá»‘ tiá»n chá»‰',0),(368974,10250,'af','Middels bedrae slegs',0),(368975,10250,'ro','Retinere sume numai',0),(368976,10250,'et','Fiksaator summad ainult',0),(368977,10250,'si','Honorar zneski samo',0),(368978,10250,'ba','Jumlah pengikut hanya',0),(368979,10250,'nl','Vazal bedragen slechts',0),(368980,10250,'fi','Kiinnike mÃ¤Ã¤riÃ¤ vain',0),(368981,10250,'no','Retainer belÃ¸p bare',0),(368982,10250,'da','Holderen belÃ¸b kun',0),(368983,10250,'ko','ë¦¬ í…Œ ì´ë„ˆ ê¸ˆì•¡ë§Œ',0),(368984,10250,'he','×¡×›×•×ž×™ ×©×›×¨ ×˜×¨×—×” ×¨×§',0),(368985,10250,'el','Î‘ÎºÏŒÎ»Î¿Ï…Î¸ÏŒÏ‚ Ï€Î¿ÏƒÎ¬ Î¼ÏŒÎ½Î¿',0),(368986,10250,'zh','å®¶è‡£åªå \r\n',0),(368987,10250,'sv','HÃ¥llare belopp endast',0),(368988,10250,'it','Solo gli importi di fermo',0),(368989,10250,'tl','',0),(368990,10250,'th','à¸ˆà¸³à¸™à¸§à¸™à¹€à¸‡à¸´à¸™à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¹ƒà¸™',0),(368991,10250,'hi','à¤…à¤¨à¥à¤šà¤° à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡à¤µà¤²',0),(368992,10250,'ms','Jumlah penahan sahaja',0),(368993,10250,'ar','Ø§Ù„ØªØ¬Ù†ÙŠØ¨ Ø§Ù„Ù…Ø¨Ø§Ù„Øº ÙÙ‚Ø·',0),(368994,10250,'fr','Montants de fixation uniquement',0),(368995,10250,'jp','ãƒªãƒ†ãƒ¼ãƒŠé‡‘é¡ã®ã¿',0),(368996,10250,'pt','Retentor somente quantidades',0),(368997,10250,'ru','Ð¤Ð¸ÐºÑÐ°Ñ‚Ð¾Ñ€ ÑÑƒÐ¼Ð¼Ñ‹ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(368998,10250,'es','Solo Cantidades de Anticipos',0),(368999,10250,'de','Halter BetrÃ¤ge nur',0),(369000,10250,'en','Retainer Amounts Only',0),(369001,10251,'is','',0),(369002,10251,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø¶Ø§Ù…Ù†',0),(369003,10251,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø¶Ø§Ù…Ù†',0),(369004,10251,'tr','Hizmetli yalnÄ±zca gÃ¶ster',0),(369005,10251,'pl','PokaÅ¼ tylko uchwyt',0),(369006,10251,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ ÑÐ°Ð¼Ð¾ Ð½Ð° Ñ…Ð¾Ð½Ð¾Ñ€Ð°Ñ€',0),(369007,10251,'ur','Ø¯Ø§Ù…Ù†Ú¯ÛŒØ± ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(369008,10251,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¿Ñ€Ð¾Ñ‚ÐµÐ·Ñƒ',0),(369009,10251,'vi','Hiá»ƒn thá»‹ thuá»™c háº¡ chá»‰',0),(369010,10251,'af','Wys slegs middels',0),(369011,10251,'ro','Retinere AratÄƒ numai',0),(369012,10251,'et','Kuva ainult fiksaator',0),(369013,10251,'si','PokaÅ¾i honorar samo',0),(369014,10251,'ba','Pengikut Tampilkan hanya',0),(369015,10251,'nl','Retainer alleen weergeven',0),(369016,10251,'fi','NÃ¤ytÃ¤ kiinnike vain',0),(369017,10251,'no','Vis Retainer bare',0),(369018,10251,'da','Vis Retainer kun',0),(369019,10251,'ko','ì‡¼ ë¦¬ í…Œ ì´ë„ˆ',0),(369020,10251,'he','×”×¦×’ ××ª ×”×¤×œ×˜×” ×‘×œ×‘×“',0),(369021,10251,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î±ÎºÏŒÎ»Î¿Ï…Î¸ÏŒÏ‚ Î¼ÏŒÎ½Î¿',0),(369022,10251,'zh','åªæ˜¾ç¤ºå›ºå®šå™¨\r\n',0),(369023,10251,'sv','Visa hÃ¥llare endast',0),(369024,10251,'it','Visualizza solo fermo',0),(369025,10251,'tl','',0),(369026,10251,'th','à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¹ƒà¸™à¸à¸²à¸£à¹à¸ªà¸”à¸‡à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(369027,10251,'hi','à¤¸à¥‡à¤µà¤• à¤•à¥‡ à¤•à¥‡à¤µà¤² à¤¦à¤¿à¤–à¤¾à¤à¤',0),(369028,10251,'ms','Menunjukkan penahan sahaja',0),(369029,10251,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ØªØ¬Ù†ÙŠØ¨ ÙÙ‚Ø·',0),(369030,10251,'fr','Voir la retenue uniquement',0),(369031,10251,'jp','ãƒªãƒ†ãƒ¼ãƒŠã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(369032,10251,'pt','Mostrar somente o retentor',0),(369033,10251,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ„Ð¸ÐºÑÐ°Ñ‚Ð¾Ñ€',0),(369034,10251,'es','Mostrar Solo el Anticipo',0),(369035,10251,'de','Retainer nur anzeigen',0),(369036,10251,'en','Show Retainer Only',0),(369037,10252,'is','',0),(369038,10252,'dr','(Ù…Ø¬ÙˆØ²  ÙˆØ±ÙˆØ¯ )  Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(369039,10252,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡  Ø¨Ù„ÙŠØ·(Ù…Ø¬ÙˆØ²  ÙˆØ±ÙˆØ¯ )  ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(369040,10252,'tr','Bilet gÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klatÄ±n',0),(369041,10252,'pl','Kliknij, aby wyÅ›wietliÄ‡ bilet',0),(369042,10252,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð±Ð¸Ð»ÐµÑ‚',0),(369043,10252,'ur','Ù¹Ú©Ù¹ Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(369044,10252,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(369045,10252,'vi','Nháº¥n vÃ o Ä‘á»ƒ xem vÃ©',0),(369046,10252,'af','Klik om te bekyk kaartjie',0),(369047,10252,'ro','Click pentru a vizualiza bilet',0),(369048,10252,'et','Piletite vaatamiseks klÃµpsake',0),(369049,10252,'si','Kliknite za ogled vozovnice',0),(369050,10252,'ba','Klik untuk melihat tiket',0),(369051,10252,'nl','Klik om te bekijken Ticket',0),(369052,10252,'fi','Klikkaa nÃ¤hdÃ¤ksesi lippu',0),(369053,10252,'no','Klikk for Ã¥ vise billett',0),(369054,10252,'da','Klik her for at se billet',0),(369055,10252,'ko','í´ë¦­ í•˜ ì—¬ í‹°ì¼“ ë³´ê¸°',0),(369056,10252,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’ ××ª ×”×›×¨×˜×™×¡',0),(369057,10252,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î¿ ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(369058,10252,'zh','ç‚¹å‡»æŸ¥çœ‹ç¥¨æ®\r\n',0),(369059,10252,'sv','Klicka fÃ¶r att Visa biljett',0),(369060,10252,'it','Mostra ticket',0),(369061,10252,'tl','',0),(369062,10252,'th','à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹à¸•à¸±à¹‹à¸§',0),(369063,10252,'hi','à¤Ÿà¤¿à¤•à¤Ÿ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(369064,10252,'ms','Klik untuk melihat Tiket',0),(369065,10252,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ø¹Ø±Ø¶ Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(369066,10252,'fr','Cliquez pour voir les billets',0),(369067,10252,'jp','ãƒã‚±ãƒƒãƒˆã‚’è¡¨ç¤ºã™ã‚‹] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(369068,10252,'pt','Clique para ver os bilhetes',0),(369069,10252,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð±Ð¸Ð»ÐµÑ‚',0),(369070,10252,'es','Hace Clik para Visionar Boleto',0),(369071,10252,'de','Klicken Sie Ticket an',0),(369072,10252,'en','Click to View Ticket',0),(369073,10253,'is','',0),(369074,10253,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(369075,10253,'pr','Ø³Ù¾Ø±Ø¯Ù‡(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(369076,10253,'tr','Para yatÄ±rma',0),(369077,10253,'pl','Depozyt',0),(369078,10253,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(369079,10253,'ur','Ø¬Ù…Ø¹',0),(369080,10253,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(369081,10253,'vi','Tiá»n gá»­i',0),(369082,10253,'af','Deposito',0),(369083,10253,'ro','Depozit',0),(369084,10253,'et','Tagatisraha',0),(369085,10253,'si','Depozit',0),(369086,10253,'ba','Deposit',0),(369087,10253,'nl','Storting',0),(369088,10253,'fi','Talletus',0),(369089,10253,'no','Innskudd',0),(369090,10253,'da','Depositum',0),(369091,10253,'ko','ë³´ì¦ê¸ˆ',0),(369092,10253,'he','×¤×™×§×“×•×Ÿ',0),(369093,10253,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(369094,10253,'zh','å­˜æ¬¾\r\n',0),(369095,10253,'sv','InsÃ¤ttning',0),(369096,10253,'it','Deposito',0),(369097,10253,'tl','',0),(369098,10253,'th','à¸à¸²à¸',0),(369099,10253,'hi','à¤œà¤®à¤¾',0),(369100,10253,'ms','Deposit',0),(369101,10253,'ar','Ø¥ÙŠØ¯Ø§Ø¹',0),(369102,10253,'fr','DÃ©pÃ´t',0),(369103,10253,'jp','é é‡‘',0),(369104,10253,'pt','DepÃ³sito',0),(369105,10253,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(369106,10253,'es','DepÃ³sito',0),(369107,10253,'de','Einzahlung',0),(369108,10253,'en','Deposit',0),(369109,10254,'is','',0),(369110,10254,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(369111,10254,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(369112,10254,'tr','Mevduat detay',0),(369113,10254,'pl','SzczegÃ³Å‚Ã³w depozytu',0),(369114,10254,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð´ÐµÑ‚Ð°Ð¹Ð»',0),(369115,10254,'ur','Ø¬Ù…Ø¹ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(369116,10254,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð´ÐµÑ‚Ð°Ñ™',0),(369117,10254,'vi','Chi tiáº¿t Ä‘áº·t cá»c',0),(369118,10254,'af','Deposito Detail',0),(369119,10254,'ro','Depozit detaliu',0),(369120,10254,'et','Tagatisraha Detail',0),(369121,10254,'si','Depozit podrobnosti',0),(369122,10254,'ba','Deposit Detail',0),(369123,10254,'nl','Storting Detail',0),(369124,10254,'fi','Talletuksen tiedot',0),(369125,10254,'no','Innskudd detaljer',0),(369126,10254,'da','Depositum detaljer',0),(369127,10254,'ko','ìž…ê¸ˆ ì„¸ë¶€ ì‚¬í•­',0),(369128,10254,'he','×¤×™×¨×•×˜ ×”×”×¤×§×“×”',0),(369129,10254,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(369130,10254,'zh','å­˜æ¬¾æ˜Žç»†\r\n',0),(369131,10254,'sv','InsÃ¤ttning detalj',0),(369132,10254,'it','Dettaglio di deposito',0),(369133,10254,'tl','',0),(369134,10254,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹€à¸‡à¸´à¸™à¸à¸²à¸',0),(369135,10254,'hi','à¤œà¤®à¤¾ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(369136,10254,'ms','Deposit Detail',0),(369137,10254,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(369138,10254,'fr','DÃ©tail du dÃ©pÃ´t',0),(369139,10254,'jp','ãƒ‡ãƒã‚¸ãƒƒãƒˆã®è©³ç´°',0),(369140,10254,'pt','Detalhe de depÃ³sito',0),(369141,10254,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(369142,10254,'es','Detalle del DepÃ³sito',0),(369143,10254,'de','Kaution-Detail',0),(369144,10254,'en','Deposit Detail',0),(369145,10255,'is','',0),(369146,10255,'dr','( ØªÚ©Øª ÙŠØ§ Ø¢Ú¯Ù‡ÙŠ ) Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(369147,10255,'pr','Ø¨Ø±Ú¯Ù‡ ( Ø¨Ù„ÙŠØ· ÙŠØ§ Ø¢Ú¯Ù‡ÙŠ ) Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(369148,10255,'tr','Mevduat Bilet',0),(369149,10255,'pl','Depozyt bilet',0),(369150,10255,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð±Ð¸Ð»ÐµÑ‚',0),(369151,10255,'ur','Ù¹Ú©Ù¹ Ø¬Ù…Ø¹',0),(369152,10255,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(369153,10255,'vi','Tháº» Ä‘áº·t cá»c',0),(369154,10255,'af','Deposito kaartjie',0),(369155,10255,'ro','Bilet de depozit',0),(369156,10255,'et','Tagatisraha Piletite',0),(369157,10255,'si','Depozit vozovnice',0),(369158,10255,'ba','Deposit Tiket',0),(369159,10255,'nl','Deposit Ticket',0),(369160,10255,'fi','Tilisiirrosta',0),(369161,10255,'no','Innskudd billett',0),(369162,10255,'da','Indbetalingsseddel',0),(369163,10255,'ko','ìž…ê¸ˆ í‘œ',0),(369164,10255,'he','×”×¤×§×“×ª ×›×¨×˜×™×¡',0),(369165,10255,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(369166,10255,'zh','å­˜æ¬¾ç¥¨æ®\r\n',0),(369167,10255,'sv','InsÃ¤ttning biljett',0),(369168,10255,'it','Biglietto di deposito',0),(369169,10255,'tl','',0),(369170,10255,'th','à¸•à¸±à¹‹à¸§à¹€à¸‡à¸´à¸™à¸à¸²à¸',0),(369171,10255,'hi','à¤œà¤®à¤¾ à¤Ÿà¤¿à¤•à¤Ÿ',0),(369172,10255,'ms','Deposit Tiket.',0),(369173,10255,'ar','ØªØ°ÙƒØ±Ø© Ø¥ÙŠØ¯Ø§Ø¹',0),(369174,10255,'fr','Billets de dÃ©pÃ´t',0),(369175,10255,'jp','é é‡‘ãƒã‚±ãƒƒãƒˆ',0),(369176,10255,'pt','Bilhetes de depÃ³sito',0),(369177,10255,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð±Ð¸Ð»ÐµÑ‚',0),(369178,10255,'es','Boleto del DepÃ³sito',0),(369179,10255,'de','Kaution-Ticket',0),(369180,10255,'en','Deposit Ticket',0),(369181,10256,'is','',0),(369182,10256,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ',0),(369183,10256,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ',0),(369184,10256,'tr','Ä°dari Ã¼cret',0),(369185,10256,'pl','OpÅ‚ata administracyjna',0),(369186,10256,'bg','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(369187,10256,'ur','Ø§Ù†ØªØ¸Ø§Ù…ÛŒ ÙÛŒØ³',0),(369188,10256,'sr','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(369189,10256,'vi','PhÃ­ hÃ nh chÃ¡nh',0),(369190,10256,'af','Administratiewe Fooi',0),(369191,10256,'ro','TaxÄƒ administrativÄƒ',0),(369192,10256,'et','Haldustasu',0),(369193,10256,'si','Upravna taksa',0),(369194,10256,'ba','Biaya administrasi',0),(369195,10256,'nl','Administratiekosten',0),(369196,10256,'fi','Hallinnollinen maksu',0),(369197,10256,'no','Administrativt gebyr',0),(369198,10256,'da','Administrationsgebyr',0),(369199,10256,'ko','ê´€ë¦¬ ë¹„',0),(369200,10256,'he','×“×ž×™ × ×™×”×•×œ',0),(369201,10256,'el','Î”Î¹Î¿Î¹ÎºÎ·Ï„Î¹ÎºÎ¬ Ï„Î­Î»Î·',0),(369202,10256,'zh','ç®¡ç†è´¹ç”¨\r\n',0),(369203,10256,'sv','Administrativ avgift',0),(369204,10256,'it','Tassa amministrativa',0),(369205,10256,'tl','',0),(369206,10256,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸œà¸¹à¹‰à¸”à¸¹à¹à¸¥',0),(369207,10256,'hi','à¤ªà¥à¤°à¤¶à¤¾à¤¸à¤¨à¤¿à¤• à¤¶à¥à¤²à¥à¤•',0),(369208,10256,'ms','Yuran pentadbiran',0),(369209,10256,'ar','Ø±Ø³ÙˆÙ… Ø¥Ø¯Ø§Ø±ÙŠØ©',0),(369210,10256,'fr','Frais administratifs',0),(369211,10256,'jp','äº‹å‹™æ‰‹æ•°æ–™',0),(369212,10256,'pt','Taxa administrativa',0),(369213,10256,'ru','ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ñ‹Ð¹ ÑÐ±Ð¾Ñ€',0),(369214,10256,'es','Cuota Administrativa',0),(369215,10256,'de','VerwaltungsgebÃ¼hr',0),(369216,10256,'en','Administrative Fee',0),(369217,10257,'is','',0),(369218,10257,'dr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ø³Ø§Ø®ØªÙ…Ø§Ù† ',0),(369219,10257,'pr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ø³Ø§Ø®ØªÙ…Ø§Ù† ',0),(369220,10257,'tr','Bina masraf kodu',0),(369221,10257,'pl','Kod budynku koszt',0),(369222,10257,'bg','ÐšÐ¾Ð´ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°Ñ‚Ð°',0),(369223,10257,'ur','Ø¹Ù…Ø§Ø±Øª Ú©Û’ Ø®Ø±Ú†Û’ Ú©Û’ Ú©ÙˆÚˆ',0),(369224,10257,'sr','ÐšÃ´Ð´ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(369225,10257,'vi','MÃ£ chi phÃ­ thiáº¿t káº¿',0),(369226,10257,'af','Gebou uitgawe kode',0),(369227,10257,'ro','Codul de cheltuieli constructii',0),(369228,10257,'et','Hoone kulukood',0),(369229,10257,'si','Gradbene stroÅ¡ke',0),(369230,10257,'ba','Kode biaya bangunan',0),(369231,10257,'nl','Kosten Baugesetzbuch',0),(369232,10257,'fi','Building kulujen koodi',0),(369233,10257,'no','Bygning bekostning kode',0),(369234,10257,'da','Bygning udgift kode',0),(369235,10257,'ko','ê±´ë¬¼ ê²½ë¹„ ì½”ë“œ',0),(369236,10257,'he','×§×•×“ ×”×•×¦××•×ª ×‘× ×™×™×”',0),(369237,10257,'el','ÎŸÎ¹ÎºÎ¿Î´Î¿Î¼Î¹ÎºÏŒÏ‚ Î´Î±Ï€Î¬Î½Î·',0),(369238,10257,'zh','å»ºç­‘è´¹ç”¨ä»£ç \r\n',0),(369239,10257,'sv','Byggnaden utgiftskod',0),(369240,10257,'it','Codice spese di costruzione',0),(369241,10257,'tl','',0),(369242,10257,'th','à¸£à¸«à¸±à¸ªà¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸­à¸²à¸„à¸²à¸£',0),(369243,10257,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤–à¤°à¥à¤š à¤•à¥‹à¤¡',0),(369244,10257,'ms','Kod perbelanjaan bangunan',0),(369245,10257,'ar','Ù‚Ø§Ù†ÙˆÙ† Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(369246,10257,'fr','Code du bÃ¢timent frais',0),(369247,10257,'jp','å»ºç‰©ã®è²»ç”¨ã‚³ãƒ¼ãƒ‰',0),(369248,10257,'pt','CÃ³digo da despesa de construÃ§Ã£o',0),(369249,10257,'ru','ÐšÐ¾Ð´ Ñ€Ð°ÑÑ…Ð¾Ð´Ð° ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ…',0),(369250,10257,'es','CÃ³digo de Gastos de CostrucciÃ³n',0),(369251,10257,'de','Kosten Bauordnung',0),(369252,10257,'en','Building Expense Code',0),(369253,10258,'is','',0),(369254,10258,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(369255,10258,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(369256,10258,'tr','Kredi kartÄ± Ã¼cretleri',0),(369257,10258,'pl','OpÅ‚aty za karty kredytowej',0),(369258,10258,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ñ‚Ð°ÐºÑÐ¸',0),(369259,10258,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(369260,10258,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(369261,10258,'vi','PhÃ­ tháº» tÃ­n dá»¥ng',0),(369262,10258,'af','Kredietkaarte Kostes',0),(369263,10258,'ro','Taxe de Card de credit',0),(369264,10258,'et','Krediitkaardi tasud',0),(369265,10258,'si','Kreditno kartico stroÅ¡ki',0),(369266,10258,'ba','Biaya kartu kredit',0),(369267,10258,'nl','Creditcardbetalingen te betalen',0),(369268,10258,'fi','Luottokortti maksuja',0),(369269,10258,'no','Kredittkortbelastninger',0),(369270,10258,'da','Kreditkort gebyrer',0),(369271,10258,'ko','ì‹ ìš© ì¹´ë“œ ìˆ˜ìˆ˜ë£Œ',0),(369272,10258,'he','×—×™×•×‘×™ ×›×¨×˜×™×¡ ×”××©×¨××™',0),(369273,10258,'el','Î¤Î­Î»Î· Ï‡ÏÎ®ÏƒÎ·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(369274,10258,'zh','ä¿¡ç”¨å¡æ”¶è´¹\r\n',0),(369275,10258,'sv','Kreditkortsdebiteringar',0),(369276,10258,'it','Carta di credito',0),(369277,10258,'tl','',0),(369278,10258,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(369279,10258,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥à¤²à¥à¤•',0),(369280,10258,'ms','Caj kad kredit',0),(369281,10258,'ar','Ø±Ø³ÙˆÙ… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(369282,10258,'fr','Frais de carte de crÃ©dit',0),(369283,10258,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ–™é‡‘',0),(369284,10258,'pt','CartÃ£o de crÃ©dito',0),(369285,10258,'ru','ÐžÐ±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(369286,10258,'es','Cargos de Tarjeta de CrÃ©dito',0),(369287,10258,'de','KreditkartengebÃ¼hren',0),(369288,10258,'en','Credit Card Charges',0),(369289,10259,'is','',0),(369290,10259,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ÙˆØ§Ø±Ø¯ Ø´Ø¯',0),(369291,10259,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ÙˆØ§Ø±Ø¯ Ø´Ø¯',0),(369292,10259,'tr','Kredi kartÄ± harcamalarÄ±nÄ± baÅŸarÄ±yla alÄ±ndÄ±',0),(369293,10259,'pl','OpÅ‚aty za karty kredytowej zaimportowane pomyÅ›lnie',0),(369294,10259,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ñ‚Ð°ÐºÑÐ¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(369295,10259,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯',0),(369296,10259,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ²ÐµÐ·ÐµÐ½Ðµ',0),(369297,10259,'vi','Nháº­p phÃ­ tháº» tÃ­n dá»¥ng thÃ nh cÃ´ng',0),(369298,10259,'af','Kredietkaartkostes Suksesvol Ingevoer',0),(369299,10259,'ro','Taxe de Card de credit importat cu succes',0),(369300,10259,'et','Krediitkaardi makse edukalt imporditud',0),(369301,10259,'si','Kreditno kartico stroÅ¡ki uspeÅ¡no uvoÅ¾en',0),(369302,10259,'ba','Biaya kartu kredit yang berhasil diimpor',0),(369303,10259,'nl','Creditcardbetalingen geÃ¯mporteerd',0),(369304,10259,'fi','Luottokortti maksuja tuonti onnistui',0),(369305,10259,'no','Kredittkortbelastninger importert',0),(369306,10259,'da','Kreditkort gebyrer importeret',0),(369307,10259,'ko','ì‹ ìš© ì¹´ë“œ ìˆ˜ìˆ˜ë£Œë¥¼ ì„±ê³µì ìœ¼ë¡œ ê°€ì ¸ì™”ëŠ”ë°',0),(369308,10259,'he','×—×™×•×‘×™ ×”××©×¨××™ ×™×•×‘××• ×‘×”×¦×œ×—×”',0),(369309,10259,'el','Î¤Î­Î»Î· Ï‡ÏÎ®ÏƒÎ·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(369310,10259,'zh','ä¿¡ç”¨å¡æ”¶è´¹æˆåŠŸå¯¼å…¥\r\n',0),(369311,10259,'sv','KreditkortskÃ¶p har importerats',0),(369312,10259,'it','Addebiti su carta di credito importati correttamente',0),(369313,10259,'tl','',0),(369314,10259,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸µà¹ˆà¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(369315,10259,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥à¤²à¥à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤¯à¤¾à¤¤',0),(369316,10259,'ms','Caj-caj kad kredit yang berjaya diimport',0),(369317,10259,'ar','Ø±Ø³ÙˆÙ… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(369318,10259,'fr','Frais de carte de crÃ©dit ont bien Ã©tÃ© importÃ©es',0),(369319,10259,'jp','æ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã¾ã—ãŸã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ–™é‡‘',0),(369320,10259,'pt','Taxas de cartÃ£o de crÃ©dito importadas com Ãªxito',0),(369321,10259,'ru','ÐžÐ±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½',0),(369322,10259,'es','Cargos de Tarjeta de CrÃ©dito Imortados Exiosamente',0),(369323,10259,'de','KreditkartengebÃ¼hren, die erfolgreich importiert',0),(369324,10259,'en','Credit Card Charges Imported Successfully',0),(369325,10260,'is','',0),(369326,10260,'dr','ØªØ§ÙŠÙŠØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¬Ù‡Øª ÙˆØ±ÙˆØ¯ ',0),(369327,10260,'pr','ØªØ§ÙŠÙŠØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¬Ù‡Øª ÙˆØ±ÙˆØ¯ ',0),(369328,10260,'tr','Kredi kartÄ± Ã¼cretleri alÄ±nacak Onayla',0),(369329,10260,'pl','Potwierdzenie opÅ‚aty za karty kredytowej do importu',0),(369330,10260,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ñ‚Ð°ÐºÑÐ¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(369331,10260,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(369332,10260,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(369333,10260,'vi','xÃ¡c nháº­n phÃ­ tháº» tÃ­n Ä‘á»¥ng Ä‘á»ƒ nháº­p',0),(369334,10260,'af','Bevestig Kredietkaartheffings om In te voer',0),(369335,10260,'ro','Confirma Card de Credit taxele la Import',0),(369336,10260,'et','Kinnitage krediitkaardi makse impordiks',0),(369337,10260,'si','Potrditev kreditno kartico stroÅ¡ki za uvoz',0),(369338,10260,'ba','Mengkonfirmasi biaya kartu kredit untuk impor',0),(369339,10260,'nl','Bevestigen van creditcardbetalingen te betalen om te importeren',0),(369340,10260,'fi','Vahvista luottokortti maksuja tuo',0),(369341,10260,'no','Bekrefte kredittkortbelastninger Importer',0),(369342,10260,'da','BekrÃ¦fte kreditkort afgifter til Import',0),(369343,10260,'ko','ì‹ ìš© ì¹´ë“œ ìˆ˜ìˆ˜ë£Œ ìˆ˜ìž…ì„ í™•ì¸',0),(369344,10260,'he','×œ××©×¨ ×—×™×•×‘×™ ×›×¨×˜×™×¡ ×”××©×¨××™ ×¢×œ ×™×‘×',0),(369345,10260,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎµÎ¹ Ï„Î­Î»Î· Ï‡ÏÎ®ÏƒÎ·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(369346,10260,'zh','ç¡®è®¤ä¿¡ç”¨å¡æ”¶è´¹å¯¼å…¥\r\n',0),(369347,10260,'sv','BekrÃ¤fta kreditkortsdebiteringar import',0),(369348,10260,'it','Confermare addebiti su carta di credito all\'importazione',0),(369349,10260,'tl','',0),(369350,10260,'th','à¸¢à¸·à¸™à¸¢à¸±à¸™à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(369351,10260,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥à¤²à¥à¤• à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(369352,10260,'ms','Mengesahkan bayaran kad kredit untuk Import',0),(369353,10260,'ar','ØªØ£ÙƒÙŠØ¯ Ø±Ø³ÙˆÙ… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(369354,10260,'fr','Confirmer les frais de carte de crÃ©dit Ã  l\'importation',0),(369355,10260,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ–™é‡‘ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(369356,10260,'pt','Confirmar as acusaÃ§Ãµes de cartÃ£o de crÃ©dito de importaÃ§Ã£o',0),(369357,10260,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(369358,10260,'es','Confirmar Cargos de Tarjeta de CrÃ©dito para Importar',0),(369359,10260,'de','KreditkartengebÃ¼hren fÃ¼r Import zu bestÃ¤tigen',0),(369360,10260,'en','Confirm Credit Card Charges to Import',0),(369361,10261,'is','',0),(369362,10261,'dr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø´Ø±ÙƒØª ',0),(369363,10261,'pr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø´Ø±ÙƒØª ',0),(369364,10261,'tr','Kredi kartÄ± ÅŸirketi satÄ±cÄ±',0),(369365,10261,'pl','Dostawcy karty kredytowej',0),(369366,10261,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(369367,10261,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Ù…Ù¾Ù†ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(369368,10261,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(369369,10261,'vi','cÃ´ng ty tháº» tÃ­n dá»¥ng',0),(369370,10261,'af','Kredietkaart Onderneming Verskaffer',0),(369371,10261,'ro','Compania cardului de credit furnizor',0),(369372,10261,'et','Krediitkaardi firma mÃ¼Ã¼k',0),(369373,10261,'si','Kreditne kartice dobavitelja',0),(369374,10261,'ba','Perusahaan kartu kredit Vendor',0),(369375,10261,'nl','Credit Card bedrijf leverancier',0),(369376,10261,'fi','LuottokorttiyhtiÃ¶ toimittajan',0),(369377,10261,'no','Kredittkortselskapet leverandÃ¸r',0),(369378,10261,'da','Kreditkortselskab leverandÃ¸r',0),(369379,10261,'ko','ì‹ ìš© ì¹´ë“œ íšŒì‚¬ ê³µê¸‰ ì—…ì²´',0),(369380,10261,'he','×—×‘×¨×ª ×›×¨×˜×™×¡×™ ××©×¨××™ ×¡×¤×§×™×',0),(369381,10261,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(369382,10261,'zh','ä¿¡ç”¨å¡å…¬å¸ä¾›åº”å•†\r\n',0),(369383,10261,'sv','KreditkortsfÃ¶retaget leverantÃ¶r',0),(369384,10261,'it','Carta di credito fornitore',0),(369385,10261,'tl','',0),(369386,10261,'th','à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢ à¸šà¸£à¸´à¸©à¸±à¸—à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(369387,10261,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(369388,10261,'ms','Penjual kad kredit Syarikat',0),(369389,10261,'ar','Ø¬Ù‡Ø© Ø¥ØµØ¯Ø§Ø± Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(369390,10261,'fr','SociÃ©tÃ© de crÃ©dit fournisseur',0),(369391,10261,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ä¼šç¤¾ã®ãƒ™ãƒ³ãƒ€ãƒ¼',0),(369392,10261,'pt','Fornecedor de cartÃ£o de crÃ©dito',0),(369393,10261,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ ÐºÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐ° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(369394,10261,'es','Proveedor de Empresa de Tarjetas de CrÃ©dito',0),(369395,10261,'de','Kreditkarten-Unternehmen Anbieter',0),(369396,10261,'en','Credit Card Company Vendor',0),(369397,10262,'is','',0),(369398,10262,'dr','( ÙˆØ±ÙˆØ¯ÙŠÙ‡Ø§ ) Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†ÙƒÙ†ÙŠØ¯ ',0),(369399,10262,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ ( ÙˆØ±ÙˆØ¯ÙŠÙ‡Ø§ ) Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†ÙƒÙ†ÙŠØ¯ ',0),(369400,10262,'tr','GiriÅŸleri Ã¶demezsiniz',0),(369401,10262,'pl','Nie pÅ‚acÄ… wpisy',0),(369402,10262,'bg','Ð”Ð° Ð½Ðµ ÑÐµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(369403,10262,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Ùˆ Ø§ÛŒÚ© Ø§Ø¯Ø§ Ù†ÛÛŒÚº Ú©Ø±ØªÛ’ ÛÛŒÚº',0),(369404,10262,'sr','ÐÐµ Ð¿Ð»Ð°Ñ›Ð°Ñ˜Ñƒ ÑÑ‚Ð°Ð²ÐºÐµ',0),(369405,10262,'vi','KhÃ´ng ghi thanh toÃ¡n',0),(369406,10262,'af','Moenie Inskrywings Betaal',0),(369407,10262,'ro','Nu plÄƒtiÅ£i intrÄƒri',0),(369408,10262,'et','Ei maksa kanded',0),(369409,10262,'si','PlaÄa navedbe',0),(369410,10262,'ba','Tidak membayar entri',0),(369411,10262,'nl','Betaal niet posten',0),(369412,10262,'fi','Ã„lÃ¤ maksa merkinnÃ¤t',0),(369413,10262,'no','Betal ikke oppfÃ¸ringer',0),(369414,10262,'da','Betale ikke poster',0),(369415,10262,'ko','í•­ëª©ì„ ì§€ë¶ˆ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(369416,10262,'he','×œ× ×ž×©×œ×ž×™× ×¢×¨×›×™',0),(369417,10262,'el','Î”ÎµÎ½ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(369418,10262,'zh','ä¸æ”¯ä»˜æ¡ç›®\r\n',0),(369419,10262,'sv','Betala inte poster',0),(369420,10262,'it','Non pagano le voci',0),(369421,10262,'tl','',0),(369422,10262,'th','à¹„à¸¡à¹ˆà¸ˆà¹ˆà¸²à¸¢à¸£à¸²à¸¢à¸à¸²à¸£',0),(369423,10262,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¤¤à¥‡',0),(369424,10262,'ms','Tidak perlu membayar penyertaan',0),(369425,10262,'ar','ÙˆÙ„Ø§ ÙŠØ¯ÙØ¹ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª',0),(369426,10262,'fr','Ne payez pas d\'entrÃ©es',0),(369427,10262,'jp','ã‚¨ãƒ³ãƒˆãƒªã‚’æ‰•ã£ã¦ã„ã¾ã›ã‚“ã€‚',0),(369428,10262,'pt','NÃ£o pagam entradas',0),(369429,10262,'ru','ÐÐµ Ð¿Ð»Ð°Ñ‚ÑÑ‚ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(369430,10262,'es','No Paga a los Entradas',0),(369431,10262,'de','Zahlen Sie keine EintrÃ¤ge',0),(369432,10262,'en','Do Not Pay Entries',0),(369433,10263,'is','',0),(369434,10263,'dr','Ø¬Ù…Ø¹ ÙƒÙ„ Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†ÙƒÙ†ÙŠØ¯ ',0),(369435,10263,'pr','Ø¬Ù…Ø¹ ÙƒÙ„ Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†ÙƒÙ†ÙŠØ¯ ',0),(369436,10263,'tr','Toplam Ã¶deme yapmayÄ±nÄ±z',0),(369437,10263,'pl','Nie pÅ‚acÄ… Å‚Ä…cznie',0),(369438,10263,'bg','Ð”Ð° Ð½Ðµ ÑÐµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð¾Ð±Ñ‰Ð¾',0),(369439,10263,'ur','Ú©Ù„ Ú©Ø§ Ø§Ø¯Ø§ Ù†ÛÛŒÚº Ú©Ø±ØªÛ’ Û”',0),(369440,10263,'sr','ÐÐµ Ð¿Ð»Ð°Ñ‚Ðµ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(369441,10263,'vi','tá»•ng sá»‘ khÃ´ng thanh toÃ¡n',0),(369442,10263,'af','Moenie Totaal Betaal',0),(369443,10263,'ro','Nu plÄƒtiÅ£i Total',0),(369444,10263,'et','Ei maksa kokku',0),(369445,10263,'si','Ne plaÄujejo skupaj',0),(369446,10263,'ba','Tidak membayar Total',0),(369447,10263,'nl','Betaal niet totaal',0),(369448,10263,'fi','Ã„lÃ¤ maksa yhteensÃ¤',0),(369449,10263,'no','Betal ikke totalt',0),(369450,10263,'da','Betale ikke alt',0),(369451,10263,'ko','ì´ ì§€ë¶ˆ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(369452,10263,'he','××™× ×š ×ž×©×œ× ×¡×”',0),(369453,10263,'el','Î”ÎµÎ½ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(369454,10263,'zh','ä¸æ”¯ä»˜æ€»è®¡\r\n',0),(369455,10263,'sv','Betala inte totalt',0),(369456,10263,'it','Non si paga il totale',0),(369457,10263,'tl','',0),(369458,10263,'th','à¹„à¸¡à¹ˆà¸ˆà¹ˆà¸²à¸¢à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(369459,10263,'hi','à¤•à¥à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¤¤à¥‡',0),(369460,10263,'ms','Tidak perlu membayar jumlah',0),(369461,10263,'ar','ÙˆÙ„Ø§ ÙŠØ¯ÙØ¹ Ù…Ø¬Ù…ÙˆØ¹',0),(369462,10263,'fr','Ne payez pas de Total',0),(369463,10263,'jp','åˆè¨ˆã‚’æ‰•ã£ã¦ã„ã¾ã›ã‚“ã€‚',0),(369464,10263,'pt','NÃ£o pagar Total',0),(369465,10263,'ru','ÐÐµ Ð¿Ð»Ð°Ñ‚ÑÑ‚ Ð²ÑÐµÐ³Ð¾',0),(369466,10263,'es','No Paga el Total',0),(369467,10263,'de','Zahlen Sie nicht Total',0),(369468,10263,'en','Do Not Pay Total',0),(369469,10264,'is','',0),(369470,10264,'dr','Ù…Ø¨Ù„Øº ÙƒÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¬Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(369471,10264,'pr','Ù…Ø¨Ù„Øº ÙƒÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¬Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(369472,10264,'tr','Genel toplam almak Ã¶denen deÄŸil',0),(369473,10264,'pl','Sumy nie zapÅ‚aciÅ‚ do importu',0),(369474,10264,'bg','ÐžÐ±Ñ‰Ð° ÑÑƒÐ¼Ð° Ð½Ðµ ÑÐµ Ð¿Ð»Ð°Ñ‰Ð° Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(369475,10264,'ur','Ø¨Ú‘Ø§ Ù…ÛŒØ²Ø§Ù† Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø¯Ø§ Ù†ÛÛŒÚº Ú©ÛŒ',0),(369476,10264,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ð·Ð±Ð¸Ñ€ Ð½Ð¸Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾ Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(369477,10264,'vi','tá»•ng sá»‘ khÃ´ng Ä‘Æ°á»£c tráº£ Ä‘á»ƒ nháº­p',0),(369478,10264,'af','Groot Totaal Onbetaald vir Invoering',0),(369479,10264,'ro','Marele Total nu plÄƒtit pentru Import',0),(369480,10264,'et','ÃœldkokkuvÃµtte maksmata importimiseks',0),(369481,10264,'si','Vsote ne plaÄa za uvoz',0),(369482,10264,'ba','Grand Total tidak dibayar untuk mengimpor',0),(369483,10264,'nl','Eindtotaal betaald niet om te importeren',0),(369484,10264,'fi','Loppusumma ei makseta tuominen',0),(369485,10264,'no','Totalsum betalt ikke importere',0),(369486,10264,'da','Hovedtotal ikke betalt til Import',0),(369487,10264,'ko','ì´ ìˆ˜ìž…ì„ ì§€ë¶ˆ í•˜ì§€',0),(369488,10264,'he','×¡×›×•× ×©×œ× ×©×•×œ× ×œ×™×™×‘×•×',0),(369489,10264,'el','Î“ÎµÎ½Î¹ÎºÏŒ ÏƒÏÎ½Î¿Î»Î¿ Î´ÎµÎ½ ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(369490,10264,'zh','æ€»è®¡ä¸æ”¯ä»˜å¯¼å…¥\r\n',0),(369491,10264,'sv','Totalsumma betalt inte fÃ¶r att importera',0),(369492,10264,'it','Totale complessivo non pagato per importare',0),(369493,10264,'tl','',0),(369494,10264,'th','à¸œà¸¥à¸£à¸§à¸¡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¹„à¸¡à¹ˆà¸Šà¸³à¸£à¸°à¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(369495,10264,'hi','à¤­à¤µà¥à¤¯ à¤•à¥à¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚',0),(369496,10264,'ms','Jumlah besar-besaran tidak dibayar untuk mengimport',0),(369497,10264,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙƒÙ„ÙŠ Ù„Ù… ØªØ¯ÙØ¹ Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(369498,10264,'fr','Total gÃ©nÃ©ral ne pas payÃ© Ã  l\'importation',0),(369499,10264,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹ç·è¨ˆæ”¯æ‰•ã‚ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(369500,10264,'pt','Total geral nÃ£o paga para importaÃ§Ã£o',0),(369501,10264,'ru','Ð˜Ñ‚Ð¾Ð³ Ð½Ðµ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ð¸Ð»Ð¸ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(369502,10264,'es','Gran Total no Pagado para Importar',0),(369503,10264,'de','Gesamtsumme bezahlt nicht importieren',0),(369504,10264,'en','Grand Total Not Paid to Import',0),(369505,10265,'is','',0),(369506,10265,'dr','Ù…Ø¨Ù„Øº ÙƒÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¬Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(369507,10265,'pr','Ù…Ø¨Ù„Øº ÙƒÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¬Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(369508,10265,'tr','Genel toplam almak Ã¶denen',0),(369509,10265,'pl','Sumy wypÅ‚acone do importu',0),(369510,10265,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°, Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð° Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(369511,10265,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú¯Ø±ÛŒÙ†Úˆ Ú©Ù„ Ø§Ø¯Ø§ Ú©ÛŒØ§',0),(369512,10265,'sr','Ð¡Ð²ÐµÑƒÐºÑƒÐ¿Ð½Ð¾ Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾ Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(369513,10265,'vi','tá»•ng sá»‘ Ä‘Ã£ tráº£ Ä‘á»ƒ nháº­p',0),(369514,10265,'af','Groot Totaal Betaal vir Invoering',0),(369515,10265,'ro','Marele Total plÄƒtitÄƒ pentru Import',0),(369516,10265,'et','KÃµik kokku makstud importimiseks',0),(369517,10265,'si','Vsote plaÄane za uvoz',0),(369518,10265,'ba','Grand Total dibayar untuk mengimpor',0),(369519,10265,'nl','Totaal betaald om te importeren',0),(369520,10265,'fi','Loppusumma maksetaan tuoda',0),(369521,10265,'no','Totalsum betalt importere',0),(369522,10265,'da','Grand alt betalt til Import',0),(369523,10265,'ko','ì´í•©ê³„ ê°€ì ¸ì˜¤ê¸° ìœ ë£Œ',0),(369524,10265,'he','×¡×›×•× ×ª×©×œ×•× ×œ×™×™×‘×•×',0),(369525,10265,'el','Î“ÎµÎ½Î¹ÎºÏŒ ÏƒÏÎ½Î¿Î»Î¿ Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(369526,10265,'zh','æ€»è®¡æ”¯ä»˜å¯¼å…¥\r\n',0),(369527,10265,'sv','Totalsumma betalas till Import',0),(369528,10265,'it','Totale pagato per importare',0),(369529,10265,'tl','',0),(369530,10265,'th','à¸œà¸¥à¸£à¸§à¸¡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢à¹ƒà¸«à¹‰à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(369531,10265,'hi','à¤­à¤µà¥à¤¯ à¤•à¥à¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(369532,10265,'ms','Grand jumlah yang dibayar kepada Import',0),(369533,10265,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙƒÙ„ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹ Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(369534,10265,'fr','Grand Total payÃ© Ã  importer',0),(369535,10265,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã«æ”¯æ‰•ã‚ã‚Œã‚‹ç·åˆè¨ˆ',0),(369536,10265,'pt','Valor Total pago para importaÃ§Ã£o',0),(369537,10265,'ru','Ð’ÑÐµÐ³Ð¾ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ð¸Ð»Ð¸ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(369538,10265,'es','Gran Total Pagado para Importar',0),(369539,10265,'de','Gesamtsumme bezahlt importieren',0),(369540,10265,'en','Grand Total Paid to Import',0),(369541,10266,'is','',0),(369542,10266,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(369543,10266,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(369544,10266,'tr','Kredi kartÄ± harcamalarÄ± ithalat',0),(369545,10266,'pl','NaleÅ¼noÅ›ci kartÄ… kredytowÄ…',0),(369546,10266,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ñ‚Ð°ÐºÑÐ¸ Ð¿Ñ€Ð¸ Ð²Ð½Ð¾ÑÐ°',0),(369547,10266,'ur','Ú†Ø§Ø±Ø¬Ø² Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(369548,10266,'sr','Ð£Ð²Ð¾Ð·Ð½Ð¸Ñ… Ð´Ð°Ð¶Ð±Ð¸Ð½Ð° Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(369549,10266,'vi','Nháº­p phÃ­ tháº» ghi cÃ³',0),(369550,10266,'af','Invoer van Kredietkaartheffings',0),(369551,10266,'ro','Card de Credit taxele de import',0),(369552,10266,'et','Impordi krediitkaardi makse',0),(369553,10266,'si','Uvozne dajatve za kreditne kartice',0),(369554,10266,'ba','Biaya kartu kredit impor',0),(369555,10266,'nl','Creditcard invoerheffingen',0),(369556,10266,'fi','Tuo luottokortti maksuja',0),(369557,10266,'no','Importere kredittkortbelastninger',0),(369558,10266,'da','Kreditkort afgifter ved indfoersel',0),(369559,10266,'ko','ì‹ ìš© ì¹´ë“œ ìˆ˜ìˆ˜ë£Œ ìˆ˜ìž…',0),(369560,10266,'he','×™×™×‘×•× ×—×™×•×‘×™ ×›×¨×˜×™×¡ ×”××©×¨××™',0),(369561,10266,'el','Î•Ï€Î¹Î²Î±ÏÏÎ½ÏƒÎµÎ¹Ï‚ Ï„Ï‰Î½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(369562,10266,'zh','å¯¼å…¥ä¿¡è´·å¡æ”¶è´¹\r\n',0),(369563,10266,'sv','Kreditkort importavgifter',0),(369564,10266,'it','Importazione addebiti su carta di credito',0),(369565,10266,'tl','',0),(369566,10266,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(369567,10266,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥à¤²à¥à¤• à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(369568,10266,'ms','Caj kad kredit import',0),(369569,10266,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø±Ø³ÙˆÙ… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(369570,10266,'fr','Frais de carte de crÃ©dit Import',0),(369571,10266,'jp','è¼¸å…¥ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ–™é‡‘',0),(369572,10266,'pt','Encargos de cartÃ£o de crÃ©dito de importaÃ§Ã£o',0),(369573,10266,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(369574,10266,'es','Cargos de Tarjeta de CrÃ©dito de Importaciones',0),(369575,10266,'de','Kreditkarte Einfuhrabgaben',0),(369576,10266,'en','Import Credit Card Charges',0),(369577,10267,'is','',0),(369578,10267,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(369579,10267,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(369580,10267,'tr','Kredi kartÄ± Ã¼cretleri Excel dosyasÄ±nÄ± seÃ§in',0),(369581,10267,'pl','Wybierz plik programu Excel opÅ‚aty kartÄ… kredytowÄ…',0),(369582,10267,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ñ‚Ð°ÐºÑÐ¸ Excel Ñ„Ð°Ð¹Ð»',0),(369583,10267,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª Excel Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(369584,10267,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ Ð•xÑ†ÐµÐ» Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(369585,10267,'vi','Chá»n táº­p tin excel phÃ­ tháº» tÃ­n dá»¥ng',0),(369586,10267,'af','Selekteer Kredietkaartheffings Excel LÃªer',0),(369587,10267,'ro','SelectaÅ£i fiÅŸierul Excel Card de Credit taxele',0),(369588,10267,'et','Valige krediitkaardi makse Exceli fail',0),(369589,10267,'si','Izberi Excelovo datoteko kreditno kartico stroÅ¡ki',0),(369590,10267,'ba','Pilih kartu kredit biaya Excel File',0),(369591,10267,'nl','Selecteer creditcard kosten Excel-bestand',0),(369592,10267,'fi','Valitse luottokortti maksuja Excel-tiedosto',0),(369593,10267,'no','Velg kredittkort kostnader Excel-fil',0),(369594,10267,'da','VÃ¦lg kreditkort afgifter Excel fil',0),(369595,10267,'ko','ì‹ ìš© ì¹´ë“œ ìš”ê¸ˆ Excel íŒŒì¼ ì„ íƒ',0),(369596,10267,'he','×‘×—×¨ ×§×•×‘×¥ Excel ×—×™×•×‘×™× ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(369597,10267,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±ÏÏ‡ÎµÎ¯Î¿ Excel Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(369598,10267,'zh','é€‰æ‹©ä¿¡ç”¨å¡æ”¶è´¹Excelæ–‡ä»¶\r\n',0),(369599,10267,'sv','VÃ¤lj kreditkort avgifter Excel-fil',0),(369600,10267,'it','Selezionare il File di Excel spese carta di credito',0),(369601,10267,'tl','',0),(369602,10267,'th','à¹€à¸¥à¸·à¸­à¸à¹„à¸Ÿà¸¥à¹Œ Excel à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(369603,10267,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¶à¥à¤²à¥à¤• Excel à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(369604,10267,'ms','Pilih fail Excel caj kad kredit',0),(369605,10267,'ar','Ø­Ø¯Ø¯ Ù…Ù„Ù Excel Ø±Ø³ÙˆÙ… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(369606,10267,'fr','SÃ©lectionnez le fichier Excel de carte de crÃ©dit des frais',0),(369607,10267,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ–™é‡‘ã® Excel ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã—ã¾ã™',0),(369608,10267,'pt','Selecione o arquivo de Excel de encargos de cartÃ£o de crÃ©dito',0),(369609,10267,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ„Ð°Ð¹Ð» Excel Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(369610,10267,'es','Selecciona el File de Excel de Cargos de Tarjetas de Credito',0),(369611,10267,'de','WÃ¤hlen Sie Kreditkarte GebÃ¼hren-Excel-Datei',0),(369612,10267,'en','Select Credit Card Charges Excel File',0),(369613,10268,'is','',0),(369614,10268,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ø³Ø·Ø± Ù‡Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(369615,10268,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ø¨Ø±Ø§ÙŠ ØªÙ…Ø§Ù… Ø³Ø·Ø± Ù‡Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(369616,10268,'tr','TÃ¼m satÄ±rlarÄ± iÃ§in bir GL hesabÄ± girmeniz gerekir',0),(369617,10268,'pl','NaleÅ¼y wprowadziÄ‡ konto GL na wszystkie linie',0),(369618,10268,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ð° GL Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ€ÐµÐ´Ð¾Ð²Ðµ',0),(369619,10268,'ur','Ø¢Ù¾ Ú©Û’ Ù„Ø¦Û’ ØªÙ…Ø§Ù… Ù„Ø§Ø¦Ù†ÛŒÚº Ø§ÛŒÚ© Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(369620,10268,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ñ€Ð°Ñ‡ÑƒÐ½ Ñƒ Ð“Ð› Ð·Ð° ÑÐ²Ðµ Ñ€ÐµÐ´Ð¾Ð²Ðµ',0),(369621,10268,'vi','Báº¡n pháº£i nháº­p má»™t tÃ i khoáº£n GL cho táº¥t cáº£ cÃ¡c dÃ²ng',0),(369622,10268,'af','U Moet \'n AG Rekening Invoer vir Alle Lyne',0),(369623,10268,'ro','Trebuie sÄƒ introduceÅ£i un GL cont pentru toate liniile',0),(369624,10268,'et','Te peate sisestama pearaamatu konto kÃµikidel ridadel',0),(369625,10268,'si','Vnesti morate GL raÄun za vse vrstice',0),(369626,10268,'ba','Anda harus memasukkan rekening GL untuk semua baris',0),(369627,10268,'nl','U moet een GL-Account voor alle regels invoeren',0),(369628,10268,'fi','Kirjoita Kirjanpitotilin pÃ¤Ã¤tilin kaikki rivit',0),(369629,10268,'no','Du mÃ¥ angi en GL konto for alle linjer',0),(369630,10268,'da','Du skal angive en GL konto for alle linjer',0),(369631,10268,'ko','ëª¨ë“  ì¤„ì— ëŒ€ í•œ GL ê³„ì •ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(369632,10268,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×—×©×‘×•×Ÿ GL ×¢×‘×•×¨ ×›×œ ×”×©×•×¨×•×ª',0),(369633,10268,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î³ÏÎ±Î¼Î¼Î­Ï‚',0),(369634,10268,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€æ€»å¸å¸æˆ·æ‰€æœ‰è¡Œ\r\n',0),(369635,10268,'sv','Du mÃ¥ste ange en GL konto fÃ¶r alla rader',0),(369636,10268,'it','Ãˆ necessario immettere un Account GL per tutte le linee',0),(369637,10268,'tl','',0),(369638,10268,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸£à¸£à¸—à¸±à¸”à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(369639,10268,'hi','à¤†à¤ª à¤¸à¤­à¥€ à¤²à¤¾à¤‡à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• GL à¤–à¤¾à¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(369640,10268,'ms','Anda mesti masukkan akaun GL untuk semua talian',0),(369641,10268,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ Ø­Ø³Ø§Ø¨ GL Ù„ÙƒØ§ÙØ© Ø§Ù„Ø®Ø·ÙˆØ·',0),(369642,10268,'fr','Vous devez entrer un compte GL pour toutes les lignes.',0),(369643,10268,'jp','ã™ã¹ã¦ã®è¡Œã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(369644,10268,'pt','VocÃª deve digitar uma conta GL para todas as linhas',0),(369645,10268,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL Ð´Ð»Ñ Ð²ÑÐµÑ… Ð»Ð¸Ð½Ð¸Ð¹',0),(369646,10268,'es','Debe Entrar un Cuenta LM para Todas las Lineas',0),(369647,10268,'de','Sie mÃ¼ssen ein GL-Konto fÃ¼r alle Zeilen eingeben.',0),(369648,10268,'en','You Must Enter a GL Account for All Lines',0),(369649,10269,'is','',0),(369650,10269,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(369651,10269,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(369652,10269,'tr','Bir satÄ±cÄ± seÃ§mek gerekir',0),(369653,10269,'pl','NaleÅ¼y wybraÄ‡ sprzedawcÄ™',0),(369654,10269,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(369655,10269,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø®ÙˆØ§Ù†Ú†Û ÙØ±ÙˆØ´ Ø®Ø§ØªÙˆÙ† Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(369656,10269,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ñ‚Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(369657,10269,'vi','Báº¡n pháº£i chá»n 1 nhÃ  cung cáº¥p',0),(369658,10269,'af','U moet \'n Verskaffer Kies',0),(369659,10269,'ro','Trebuie sÄƒ selectaÅ£i un furnizor',0),(369660,10269,'et','Te peate valima tarnija',0),(369661,10269,'si','Izberite prodajalca',0),(369662,10269,'ba','Anda harus memilih Vendor',0),(369663,10269,'nl','U moet een leverancier selecteren',0),(369664,10269,'fi','Valitse toimittaja',0),(369665,10269,'no','Du mÃ¥ velge en leverandÃ¸r',0),(369666,10269,'da','Du skal vÃ¦lge en leverandÃ¸r',0),(369667,10269,'ko','ê³µê¸‰ ì—…ì²´ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(369668,10269,'he','×—×•×‘×” ×œ×‘×—×•×¨ ×¡×¤×§',0),(369669,10269,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î±Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(369670,10269,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªä¾›åº”å•†\r\n',0),(369671,10269,'sv','Du mÃ¥ste vÃ¤lja en leverantÃ¶r',0),(369672,10269,'it','Ãˆ necessario selezionare un fornitore',0),(369673,10269,'tl','',0),(369674,10269,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(369675,10269,'hi','à¤¤à¥à¤® à¤à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(369676,10269,'ms','Anda mesti memilih Vendor',0),(369677,10269,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ®ØªØ§Ø± Ù…ÙˆØ±Ù‘Ø¯',0),(369678,10269,'fr','Vous devez sÃ©lectionner un vendeur',0),(369679,10269,'jp','ä»•å…¥å…ˆã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(369680,10269,'pt','VocÃª deve selecionar um fornecedor',0),(369681,10269,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(369682,10269,'es','Debe Seleccionar un Proveedor',0),(369683,10269,'de','Sie mÃ¼ssen einen Lieferanten auswÃ¤hlen.',0),(369684,10269,'en','You Must Select a Vendor',0),(369685,10270,'is','',0),(369686,10270,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(369687,10270,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø¯Ø§Ø±ÙŠ Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(369688,10270,'tr','Bir idari Ã¼cret gider hesabÄ± ayarlamanÄ±z gerekir',0),(369689,10270,'pl','NaleÅ¼y ustawiÄ‡ konto koszt opÅ‚aty administracyjnej',0),(369690,10270,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ñ‚Ð°ÐºÑÐ° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(369691,10270,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§Ù†ØªØ¸Ø§Ù…ÛŒ ÙÛŒØ³ Ø®Ø±Ú†Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(369692,10270,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ð´ÐµÑÐ¸Ñ‚Ð¸ ÐºÐ¾Ð½Ñ‚Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(369693,10270,'vi','Báº¡n Pháº£i Thiáº¿t láº­p má»™t tÃ i khoáº£n Chi phÃ­ hÃ nh chÃ­nh',0),(369694,10270,'af','U moet \'n Administratiewe Fooi Uitgawe rekening Opstel',0),(369695,10270,'ro','Trebuie sÄƒ setaÅ£i un cont de cheltuieli taxe Administrative',0),(369696,10270,'et','Te peate mÃ¤Ã¤rama administratiivkulule kulukonto',0),(369697,10270,'si','Morate nastaviti raÄun stroÅ¡kov upravne takse',0),(369698,10270,'ba','Anda harus mengatur rekening pengeluaran biaya administrasi',0),(369699,10270,'nl','U moet het instellen van een administratiekosten kostenrekening',0),(369700,10270,'fi','MÃ¤Ã¤ritÃ¤ hallinnollinen maksu kulutili',0),(369701,10270,'no','Du mÃ¥ angi en administrativt gebyr utgiftskonto',0),(369702,10270,'da','Du skal angive et administrationsgebyr udgiftskonto',0),(369703,10270,'ko','ìˆ˜ìˆ˜ë£Œ ë¹„ìš© ê³„ì •ìœ¼ë¡œ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(369704,10270,'he','×¢×œ×™×š ×œ×”×’×“×™×¨ ×—×©×‘×•×Ÿ ×”×•×¦××•×ª ×“×ž×™ × ×™×”×•×œ',0),(369705,10270,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¯ÏƒÎµÏ„Îµ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎµÎ¾ÏŒÎ´Ï‰Î½ Î´Î¹Î¿Î¹ÎºÎ·Ï„Î¹ÎºÏŽÎ½ Ï„ÎµÎ»ÏŽÎ½',0),(369706,10270,'zh','æ‚¨å¿…é¡»è®¾ç½®ä¸€ä¸ªè´¹ç”¨æ”¯å‡ºç®¡ç†å¸æˆ·\r\n',0),(369707,10270,'sv','Du mÃ¥ste ange ett utgiftskonto fÃ¶r administrativ avgift',0),(369708,10270,'it','Ãˆ necessario impostare un conto spese tassa amministrativa',0),(369709,10270,'tl','',0),(369710,10270,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸±à¸à¸Šà¸µà¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£',0),(369711,10270,'hi','à¤†à¤ª à¤à¤• à¤ªà¥à¤°à¤¶à¤¾à¤¸à¤¨à¤¿à¤• à¤¶à¥à¤²à¥à¤• à¤µà¥à¤¯à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(369712,10270,'ms','Anda mesti menetapkan akaun perbelanjaan Yuran pentadbiran',0),(369713,10270,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ¹ÙŠÙŠÙ† Ø­Ø³Ø§Ø¨ Ù…ØµØ±ÙˆÙØ§Øª Ø±Ø³ÙˆÙ… Ø¥Ø¯Ø§Ø±ÙŠØ©',0),(369714,10270,'fr','Vous devez fixer un compte pour dÃ©penses de commission administrative.',0),(369715,10270,'jp','äº‹å‹™æ‰‹æ•°æ–™è²»ç”¨å‹˜å®šã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(369716,10270,'pt','VocÃª deve definir uma conta de despesas de taxa administrativa',0),(369717,10270,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð² Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¸Ð²Ð½Ñ‹Ð¹ ÑÐ±Ð¾Ñ€',0),(369718,10270,'es','Debe Establecer Una Cuenta de Gastos de Una Cuota Administrativa',0),(369719,10270,'de','Sie mÃ¼ssen ein Aufwandskonto VerwaltungsgebÃ¼hr festlegen.',0),(369720,10270,'en','You Must Set an Administrative Fee Expense Account',0),(369721,10271,'is','',0),(369722,10271,'dr','Ù¾Ø§Ùƒ ÙƒØ±Ø¯Ù† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¨Ø§Ø²Ø´Ù†Ø§Ø³Ù‰ Ú©Ø§Ø±Ø§Ú©ØªØ± Ø¨Ø§ Ø¬ÙˆÙ‡Ø± Ù…ØºÙ†Ø§Ø·ÙŠØ³Ù‰',0),(369723,10271,'pr','Ù¾Ø§Ùƒ ÙƒØ±Ø¯Ù† Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¨Ø§Ø²Ø´Ù†Ø§Ø³Ù‰ Ú©Ø§Ø±Ø§Ú©ØªØ± Ø¨Ø§ Ø¬ÙˆÙ‡Ø± Ù…ØºÙ†Ø§Ø·ÙŠØ³Ù‰',0),(369724,10271,'tr','BoÅŸ hisse senedi kullanma MICR mÃ¼rekkep',0),(369725,10271,'pl','Pusty pieÅ„ przy uÅ¼yciu atramentu MICR',0),(369726,10271,'bg','ÐŸÑ€Ð°Ð·ÐµÐ½ ÑÐºÐ»Ð°Ð´ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ MICR Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾',0),(369727,10271,'ur','Ø®Ø§Ù„ÛŒ Ø³Ù¹Ø§Ú© Ú©Ùˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù…Ø§Ú©Ø± Ø§Ù†Ú©',0),(369728,10271,'sr','ÐŸÑ€Ð°Ð·Ð°Ð½ Ð±ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ ÐºÐ¾Ñ€Ð¸ÑÑ‚ÐµÑ›Ð¸ ÐœÐ˜Ð¦Ð  Ð¿ÐµÑ€Ð¾Ð¼',0),(369729,10271,'vi','Má»±c ink MICR dÃ¹ng cho kho trá»‘ng',0),(369730,10271,'af','LeÃ« voorraad gebruik MICR Ink',0),(369731,10271,'ro','Gol stoc folosind MICR cernealÄƒ',0),(369732,10271,'et','TÃ¼hi varude kasutades MICR tint',0),(369733,10271,'si','Prazno zalog z uporabo MICR Ärnila',0),(369734,10271,'ba','Kosong saham menggunakan tinta MICR',0),(369735,10271,'nl','Lege voorraad met behulp van MICR inkt',0),(369736,10271,'fi','TyhjÃ¤ varastossa kÃ¤yttÃ¤mÃ¤llÃ¤ MICR muste',0),(369737,10271,'no','Tomt lager bruker MICR blekk',0),(369738,10271,'da','Tom lager ved hjÃ¦lp af MICR blÃ¦k',0),(369739,10271,'ko','ë¹ˆ ìŠ¤í†¡ì„ ì‚¬ìš© í•˜ ì—¬ MICR ìž‰í¬',0),(369740,10271,'he','×¨×™×§ ×“×™×• MICR ×ž× ×™×•×ª ×‘××ž×¦×¢×•×ª',0),(369741,10271,'el','ÎšÎµÎ½ÏŒ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ MICR Î¼ÎµÎ»Î¬Î½Î¹',0),(369742,10271,'zh','è”åˆä½¿ç”¨çš„ç£æ€§å¢¨æ°´å­—ç¬¦è¯†åˆ«æ²¹å¢¨ç©ºç™½\r\n',0),(369743,10271,'sv','Tomt lager med hjÃ¤lp av MICR blÃ¤ck',0),(369744,10271,'it','Vuoto inchiostro MICR con magazzino',0),(369745,10271,'tl','',0),(369746,10271,'th','à¹€à¸›à¸¥à¹ˆà¸²à¸«à¸¸à¹‰à¸™à¹ƒà¸Šà¹‰ MICR à¸«à¸¡à¸¶à¸',0),(369747,10271,'hi','à¤°à¤¿à¤•à¥à¤¤ à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¤¾ à¤ªà¥à¤°à¤¯à¥‹à¤— à¤®à¤¾à¤‡à¤•à¤° à¤¸à¥à¤¯à¤¾à¤¹à¥€',0),(369748,10271,'ms','Kosong saham menggunakan MICR dakwat',0),(369749,10271,'ar','ÙØ§Ø±ØºØ© Ø§Ù„Ø­Ø¨Ø± Ø§Ù„Ù…Ù…ØºÙ†Ø· Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(369750,10271,'fr','Blanc encre MICR Ã  l\'aide de Stock',0),(369751,10271,'jp','ç©ºç™½ã®ã‚¹ãƒˆãƒƒã‚¯ã‚’ä½¿ç”¨ã—ã¦ MICR ã‚¤ãƒ³ã‚¯',0),(369752,10271,'pt','Em branco estoque usando MICR tinta',0),(369753,10271,'ru','ÐŸÑƒÑÑ‚Ð¾Ð¹ ÑˆÑ‚Ð¾ÐºÐ° Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ Ñ‡ÐµÑ€Ð½Ð¸Ð» MICR',0),(369754,10271,'es','Existencias de Papel en Blanco Usando Tinta de MICR',0),(369755,10271,'de','Leere Lager mit MICR-Tinte',0),(369756,10271,'en','Blank Stock Using MICR Ink',0),(369757,10272,'is','',0),(369758,10272,'dr','Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ   Ø´Ù‡Ø±   ÙƒØ¯Ù¾Ø³ØªÙŠ  Ø§Ø³ØªØ§Ù†',0),(369759,10272,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ùƒ   Ø´Ù‡Ø±   ÙƒØ¯Ù¾Ø³ØªÙŠ  Ø§Ø³ØªØ§Ù†',0),(369760,10272,'tr','Mevduat BankasÄ± ÅŸehir, eyalet ZIP',0),(369761,10272,'pl','Depozyt banku City, stan Zip',0),(369762,10272,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð±Ð°Ð½ÐºÐ° Ð¡Ð¸Ñ‚Ð¸, Ð´ÑŠÑ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸',0),(369763,10272,'ur','Ø¬Ù…Ø¹ Ø¨ÛŒÙ†Ú© Ø´ÛØ±ØŒ Ø±ÛŒØ§Ø³ØªÛŒ Ø²Ù¾',0),(369764,10272,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð±Ð°Ð½ÐºÐ° Ð³Ñ€Ð°Ð´, Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð—Ð¸Ð¿',0),(369765,10272,'vi','MÃ£ thÃ nh phá»‘ Ä‘áº·t cá»c, mÃ£ bang',0),(369766,10272,'af','Deposito Bank, Dorp/Stad, Provinsie, Poskode',0),(369767,10272,'ro','Depozit bancar oraÅŸ, stat Zip',0),(369768,10272,'et','Tagatisraha Panga asukoha linna, osariigi Zip',0),(369769,10272,'si','Depozita banke mesta, drÅ¾avni Zip',0),(369770,10272,'ba','Deposito Bank City, negara Zip',0),(369771,10272,'nl','Storting Bank stad, staat postcode',0),(369772,10272,'fi','Internet pankki kaupunki, valtion Zip',0),(369773,10272,'no','Innskudd Bank by, stat Zip',0),(369774,10272,'da','Depositum Bank by, stat Zip',0),(369775,10272,'ko','ì˜ˆê¸ˆ ì€í–‰ ì‹œ ì£¼ ìš°íŽ¸ ë²ˆí˜¸',0),(369776,10272,'he','×¤×™×§×“×•×Ÿ ×‘×‘× ×§ ×¡×™×˜×™, Zip ×”×ž×“×™× ×”',0),(369777,10272,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î¤Î¡Î‘Î Î•Î–Î‘ Î ÎŸÎ›Î—, ÎºÏÎ±Ï„Î¹ÎºÎ­Ï‚ Zip',0),(369778,10272,'zh','å¼€æˆ·é“¶è¡Œå¸‚ï¼Œå·žé‚®ç¼–\r\n',0),(369779,10272,'sv','InsÃ¤ttning Bank stad, statliga Zip',0),(369780,10272,'it','Deposito banca cittÃ , statale Zip',0),(369781,10272,'tl','',0),(369782,10272,'th','à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸˜à¸™à¸²à¸„à¸²à¸£à¸‹à¸´à¸•à¸µà¹‰ à¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œà¸£à¸±à¸',0),(369783,10272,'hi','à¤œà¤®à¤¾ à¤¬à¥ˆà¤‚à¤• à¤¶à¤¹à¤°, à¤°à¤¾à¤œà¥à¤¯ à¤œà¤¼à¤¿à¤ª',0),(369784,10272,'ms','Deposit Bank bandar, Negeri Zip',0),(369785,10272,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø¨Ù†Ùƒ Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©ØŒ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(369786,10272,'fr','Ville de banque de dÃ©pÃ´t, Zip Ã‰tat',0),(369787,10272,'jp','é é‡‘éŠ€è¡Œå¸‚ã€å·žéƒµä¾¿ç•ªå·',0),(369788,10272,'pt','DepÃ³sito banco cidade, estado Zip',0),(369789,10272,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð±Ð°Ð½ÐºÐ° Ð³Ð¾Ñ€Ð¾Ð´Ð°, Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ð¾Ðµ Zip',0),(369790,10272,'es','Banco de DepÃ³sito Ciudad, Estado, CP',0),(369791,10272,'de','Deposit Bank Stadt, staatliche PLZ',0),(369792,10272,'en','Deposit Bank City, State Zip',0),(369793,10273,'is','',0),(369794,10273,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(369795,10273,'pr','Ø´Ù…Ø§Ø±Ù‡ ØªØ±Ø§Ù†Ø²ÙŠØª Ø§Ø±Ø³Ø§Ù„ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(369796,10273,'tr','Rota transit numarasÄ± para yatÄ±rma',0),(369797,10273,'pl','Depozyt banku tranzytu',0),(369798,10273,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚, Ñ‚Ñ€Ð°Ð½Ð·Ð¸Ñ‚Ð½Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð·Ð° Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(369799,10273,'ur','Ø±ÙˆÙ¹ Ø¨Ù†Ø¯ÛŒ Ù¹Ø±Ø§Ù†Ø²Ù¹ ØªØ¹Ø¯Ø§Ø¯ Ø¬Ù…Ø¹',0),(369800,10273,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¾Ð³ Ð¿Ð¾ÑÑ‚ÑƒÐ¿ÐºÐ° Ñ‚Ñ€Ð°Ð½Ð·Ð¸Ñ‚Ð°',0),(369801,10273,'vi','Chuyá»ƒn sá»‘ Ä‘áº·t cá»c',0),(369802,10273,'af','Deposito Routing transito nommer',0),(369803,10273,'ro','NumÄƒrul de tranzit circuit de depozit',0),(369804,10273,'et','Tagatisraha marsruutimise transiidiks Number',0),(369805,10273,'si','Deponiranje Å¡tevilka proizvodnega postopka tranzita',0),(369806,10273,'ba','Deposit nomor Routing Transit',0),(369807,10273,'nl','Storting transitnummer routering',0),(369808,10273,'fi','Tallettaa Transit reititysnumero',0),(369809,10273,'no','Innskudd transitt registreringsnummer',0),(369810,10273,'da','Depositum Transit for registreringsnummer',0),(369811,10273,'ko','ë¼ìš°íŒ… ì „ì†¡ ë²ˆí˜¸ ìž…ê¸ˆ',0),(369812,10273,'he','×œ×”×¤×§×™×“ ××ª ×ž×¡×¤×¨ ×”× ×™×ª×•×‘ ×˜×¨× ×–×™×˜',0),(369813,10273,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎºÏ‰Î´Î¹ÎºÏŒ Ï†Î±ÏƒÎµÎ¿Î»Î¿Î³Î¯Î¿Ï… Î´Î¹Î±Î¼ÎµÏ„Î±ÎºÏŒÎ¼Î¹ÏƒÎ·Ï‚',0),(369814,10273,'zh','å­˜æ¬¾è·¯å¾„è¿è¾“æ•°ç›®\r\n',0),(369815,10273,'sv','SÃ¤tta in Transit clearingnummer',0),(369816,10273,'it','Deposito di transito numero di Routing',0),(369817,10273,'tl','',0),(369818,10273,'th','à¸à¸²à¸à¸ªà¹ˆà¸‡à¸•à¹ˆà¸­à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹€à¸ªà¹‰à¸™à¸—à¸²à¸‡',0),(369819,10273,'hi','à¤ªà¤¾à¤°à¤—à¤®à¤¨ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤°à¥‚à¤Ÿà¤¿à¤‚à¤— à¤œà¤®à¤¾',0),(369820,10273,'ms','Deposit penghalaan Transit nombor',0),(369821,10273,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„ØªÙˆØ¬ÙŠÙ‡ Ø±Ù‚Ù… Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø¹Ø§Ø¨Ø±',0),(369822,10273,'fr','Routage Transit numÃ©ro de dÃ©pÃ´t',0),(369823,10273,'jp','ãƒˆãƒ©ãƒ³ã‚¸ãƒƒãƒˆã®ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå·ã‚’é é‡‘ã—ã¾ã™ã€‚',0),(369824,10273,'pt','DepÃ³sito do nÃºmero do trÃ¢nsito',0),(369825,10273,'ru','Ð’Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð¸Ñ‚Ð°',0),(369826,10273,'es','Numero de Ruta del Transito del DepÃ³sito',0),(369827,10273,'de','Einzahlung Transit Bankleitzahl',0),(369828,10273,'en','Deposit Routing Transit Number',0),(369829,10274,'is','',0),(369830,10274,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(369831,10274,'pr','Ø°Ø®ÙŠØ±Ù‡  ÙŠØ§ Ù…Ø­Ù„ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(369832,10274,'tr','Teminat deposu veya konumu',0),(369833,10274,'pl','Sklep depozytu lub lokalizacji',0),(369834,10274,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÐºÐ»Ð°Ð´ Ð¸Ð»Ð¸ Ð¼ÑÑÑ‚Ð¾',0),(369835,10274,'ur','Ø¬Ù…Ø¹ Ú©ÛŒ Ø¯Ú©Ø§Ù† ÛŒØ§ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(369836,10274,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð° Ð¸Ð»Ð¸ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(369837,10274,'vi','Dá»± trá»¯ tiá»n gá»­i vÃ  Ä‘á»‹a Ä‘iá»ƒm',0),(369838,10274,'af','Deposito Winkel of ligging',0),(369839,10274,'ro','Depozit magazin sau locaÅ£ie',0),(369840,10274,'et','Tagatisraha poodi vÃµi asukoht',0),(369841,10274,'si','Trgovina depozit ali mesto',0),(369842,10274,'ba','Deposit toko atau lokasi',0),(369843,10274,'nl','Storting winkel of locatie',0),(369844,10274,'fi','Internet Store tai sijainti',0),(369845,10274,'no','Innskudd butikk eller plassering',0),(369846,10274,'da','Depositum butik eller placering',0),(369847,10274,'ko','ì˜ˆê¸ˆ ì €ìž¥ì†Œë‚˜ ìœ„ì¹˜',0),(369848,10274,'he','×”×¤×§×“×ª ×”×—× ×•×ª ××• ×ž×™×§×•×',0),(369849,10274,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± Î® Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(369850,10274,'zh','å­˜æ¬¾å•†åº—æˆ–åœ°ç‚¹\r\n',0),(369851,10274,'sv','InsÃ¤ttning butik eller plats',0),(369852,10274,'it','Archivio di deposito o di posizione',0),(369853,10274,'tl','',0),(369854,10274,'th','à¸à¸²à¸à¸£à¹‰à¸²à¸™à¸„à¹‰à¸²à¸«à¸£à¸·à¸­à¸ªà¸–à¸²à¸™',0),(369855,10274,'hi','à¤œà¤®à¤¾ à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨ à¤¯à¤¾ à¤¸à¥à¤¥à¤¾à¤¨',0),(369856,10274,'ms','Deposit kedai atau lokasi',0),(369857,10274,'ar','Ù…Ø®Ø²Ù† Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø£Ùˆ Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(369858,10274,'fr','DÃ©pÃ´t Store ou emplacement',0),(369859,10274,'jp','æ²ˆæ®¿ç‰©ã®åº—ã‚„å ´æ‰€',0),(369860,10274,'pt','Loja depÃ³sito ou local',0),(369861,10274,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½ Ð¸Ð»Ð¸ Ð¼ÐµÑÑ‚Ð¾',0),(369862,10274,'es','Tienda o Sitio del DepÃ³sito',0),(369863,10274,'de','Kaution-Store oder Lage',0),(369864,10274,'en','Deposit Store or Location',0),(369865,10275,'is','',0),(369866,10275,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(369867,10275,'pr','Ø±ÙˆØ´ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(369868,10275,'tr','Mevduat stili',0),(369869,10275,'pl','Depozyt styl',0),(369870,10275,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÑ‚Ð¸Ð»',0),(369871,10275,'ur','Ø¬Ù…Ø¹ Ø·Ø±Ø²',0),(369872,10275,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÑ‚Ð¸Ð»',0),(369873,10275,'vi','Loáº¡i tiá»n gá»­i',0),(369874,10275,'af','Deposito Styl',0),(369875,10275,'ro','Depozit stil',0),(369876,10275,'et','Tagatisraha stiil',0),(369877,10275,'si','Depozit slog',0),(369878,10275,'ba','Deposit gaya',0),(369879,10275,'nl','Storting stijl',0),(369880,10275,'fi','Talletus tyyli',0),(369881,10275,'no','Innskudd stil',0),(369882,10275,'da','Depositum stil',0),(369883,10275,'ko','ì˜ˆê¸ˆ ìŠ¤íƒ€ì¼',0),(369884,10275,'he','×¡×’× ×•×Ÿ ×¤×™×§×“×•×Ÿ',0),(369885,10275,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÏ„Ï…Î»',0),(369886,10275,'zh','å­˜æ¬¾æ–¹å¼\r\n',0),(369887,10275,'sv','InsÃ¤ttning stil',0),(369888,10275,'it','Stile di deposito',0),(369889,10275,'tl','',0),(369890,10275,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¹€à¸‡à¸´à¸™à¸à¸²à¸',0),(369891,10275,'hi','à¤œà¤®à¤¾ à¤¶à¥ˆà¤²à¥€',0),(369892,10275,'ms','Gaya Deposit',0),(369893,10275,'ar','Ù†Ù…Ø· Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(369894,10275,'fr','DÃ©pÃ´t Style',0),(369895,10275,'jp','é é‡‘ã®ã‚¹ã‚¿ã‚¤ãƒ«',0),(369896,10275,'pt','Estilo de depÃ³sito',0),(369897,10275,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÑ‚Ð¸Ð»ÑŒ',0),(369898,10275,'es','Estilo del DepÃ³sito',0),(369899,10275,'de','Anzahlung Stil',0),(369900,10275,'en','Deposit Style',0),(369901,10276,'is','',0),(369902,10276,'dr','Ø¨Ø±Ø§ÙŠ ÙÙ‡Ø±Ø³Øª Ø³Ù¾Ø±Ø¯Ù‡ ',0),(369903,10276,'pr','Ø¨Ø±Ø§ÙŠ ÙÙ‡Ø±Ø³Øª Ø³Ù¾Ø±Ø¯Ù‡ ',0),(369904,10276,'tr','Havale makbuzlarÄ± iÃ§in',0),(369905,10276,'pl','Za Kwity depozytowe',0),(369906,10276,'bg','Ð—Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð°Ñ„Ð¸ÑˆÐ¸',0),(369907,10276,'ur','Ú©Û’ Ù„Ø¦Û’ ÚˆÙ¾Ø§Ø²Ù¹ Ù¾Ø± Ú†Ø³Ù¾Ø§Úº',0),(369908,10276,'sr','Ð—Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ðµ Ð¿Ð°Ð¿Ð¸Ñ€Ðµ',0),(369909,10276,'vi','cho biÃªn láº¡i tiá»n gá»­i',0),(369910,10276,'af','Vir deposito salarisstrokies',0),(369911,10276,'ro','Pentru depozit AlunecÄƒrile',0),(369912,10276,'et','Deposiitkviitungite kohta',0),(369913,10276,'si','Za Deposit zdrsi',0),(369914,10276,'ba','Untuk slip Deposit',0),(369915,10276,'nl','Voor aanbetaling Slips',0),(369916,10276,'fi','Saat Talletus Liukastumiset',0),(369917,10276,'no','For betalingsbilag',0),(369918,10276,'da','For indbetalingsbilag',0),(369919,10276,'ko','ì˜ˆê¸ˆ ë¯¸ ë„ ëŸ¬ ì§ì— ëŒ€ í•œ',0),(369920,10276,'he','×¢×‘×•×¨ ×©×•×‘×¨×™ ×”×¤×§×“×”',0),(369921,10276,'el','Î“Î¹Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î¼Ï€ÏŒÎ»Î¹Î±',0),(369922,10276,'zh','å¯¹äºŽå­˜æ¬¾å•\r\n',0),(369923,10276,'sv','FÃ¶r insÃ¤ttningskvitton',0),(369924,10276,'it','Per deposito scivola',0),(369925,10276,'tl','',0),(369926,10276,'th','à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸',0),(369927,10276,'hi','à¤œà¤®à¤¾ à¤«à¤¿à¤¸à¤² à¤œà¤¾à¤¤à¤¾ à¤¹à¥ˆ à¤•à¥‡ à¤²à¤¿à¤',0),(369928,10276,'ms','Bagi slip Deposit',0),(369929,10276,'ar','Ù„Ù‚Ø³Ø§Ø¦Ù… Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(369930,10276,'fr','Pour les bordereaux de dÃ©pÃ´t',0),(369931,10276,'jp','é é‡‘ä¼ç¥¨ã®',0),(369932,10276,'pt','Para guias de depÃ³sito',0),(369933,10276,'ru','Ð”Ð»Ñ Ð±Ð»Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¾Ð²',0),(369934,10276,'es','Para Fichas del DepÃ³sito',0),(369935,10276,'de','FÃ¼r Einzahlungsbelege',0),(369936,10276,'en','For Deposit Slips',0),(369937,10277,'is','',0),(369938,10277,'dr','HTML Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ù¾Ø±Ø¯Ù‡ ',0),(369939,10277,'pr','HTML Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ù¾Ø±Ø¯Ù‡ ',0),(369940,10277,'tr','HTML havale makbuzu',0),(369941,10277,'pl','HTML pokwitowania',0),(369942,10277,'bg','HTML Ð²Ð½Ð¾ÑÐ½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(369943,10277,'ur','HTML ÚˆÙ¾ÙˆØ²Ù¹ Ø³Ù„Ù¾',0),(369944,10277,'sr','Ð¥Ð¢ÐœÐ› Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(369945,10277,'vi','Phiáº¿u gá»­i HTML',0),(369946,10277,'af','HTML Deposito Strokie',0),(369947,10277,'ro','HTML depozit alunecare',0),(369948,10277,'et','HTML deposiitkviitungi',0),(369949,10277,'si','HTML depozit Slip',0),(369950,10277,'ba','Slip HTML Deposit',0),(369951,10277,'nl','HTML-afgiftebewijs',0),(369952,10277,'fi','HTML Talletuskuitti',0),(369953,10277,'no','HTML betalingsbilag',0),(369954,10277,'da','HTML indbetalingsbilag',0),(369955,10277,'ko','HTML ì˜ˆê¸ˆ ì „í‘œ',0),(369956,10277,'he','HTML ×”×¤×§×“×”',0),(369957,10277,'el','Î”ÎµÎ»Ï„Î¯Î¿ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚ HTML',0),(369958,10277,'zh','ç½‘é¡µå­˜æ¬¾å•\r\n',0),(369959,10277,'sv','HTML insÃ¤ttningsblanketten',0),(369960,10277,'it','Distinta di deposito HTML',0),(369961,10277,'tl','',0),(369962,10277,'th','HTML à¸à¸²à¸',0),(369963,10277,'hi','HTML à¤œà¤®à¤¾ à¤ªà¤°à¥à¤šà¥€',0),(369964,10277,'ms','Slip HTML Deposit',0),(369965,10277,'ar','Ù‚Ø³ÙŠÙ…Ø© Ø¥ÙŠØ¯Ø§Ø¹ Ø¥ØªØ´ ØªÙŠ Ø£Ù… Ø§Ù„',0),(369966,10277,'fr','Bordereau de dÃ©pÃ´t HTML',0),(369967,10277,'jp','HTML ã®é é‡‘ä¼ç¥¨',0),(369968,10277,'pt','Comprovante de depÃ³sito de HTML',0),(369969,10277,'ru','HTML ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸',0),(369970,10277,'es','Ficha del DepÃ³sito del HTML',0),(369971,10277,'de','HTML Einzahlungsschein',0),(369972,10277,'en','HTML Deposit Slip',0),(369973,10278,'is','',0),(369974,10278,'dr','Ú†Ø§Ù¾ Ù‡Ø§ÙŠ Ø§ÙˆÙ„ÙŠÙ‡ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ù¾Ø±Ø¯Ù‡',0),(369975,10278,'pr','Ú†Ø§Ù¾ Ù‡Ø§ÙŠ Ø§ÙˆÙ„ÙŠÙ‡ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ù¾Ø±Ø¯Ù‡',0),(369976,10278,'tr','Ã–nceden basÄ±lmÄ±ÅŸ havale makbuzu',0),(369977,10278,'pl','Nadrukiem pokwitowania',0),(369978,10278,'bg','ÐŸÐ¾ÑÑÐ½Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ð²Ð½Ð¾ÑÐ½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(369979,10278,'ur','Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹Ø¯ ÚˆÙ¾ÙˆØ²Ù¹ Ø³Ù„Ù¾',0),(369980,10278,'sr','Ð¤Ð°Ð±Ñ€Ð¸Ñ‡ÐºÐ¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¸ Ð¿Ð°Ð¿Ð¸Ñ€',0),(369981,10278,'vi','in trÆ°á»›c giáº¥y gá»­i tiá»n',0),(369982,10278,'af','Vooruitgedrukte Deposito Strokie',0),(369983,10278,'ro','Pre-imprimate depozit alunecare',0),(369984,10278,'et','ValmistrÃ¼kitud deposiitkviitungi',0),(369985,10278,'si','Nespremenljivo depozit Slip',0),(369986,10278,'ba','Bukti transfer dicetak',0),(369987,10278,'nl','Voorgedrukte afgiftebewijs',0),(369988,10278,'fi','Esipainettua Talletuskuitti',0),(369989,10278,'no','ForhÃ¥ndstrykt betalingsbilag',0),(369990,10278,'da','Fortrykt indbetalingsbilag',0),(369991,10278,'ko','ê¸°ì¸ì‡„ ì˜ˆê¸ˆ ì „í‘œ',0),(369992,10278,'he','×”×¤×§×“×” ×ž×•×“×¤×¡ ×ž×¨××©',0),(369993,10278,'el','Î ÏÎ¿Ï„Ï…Ï€Ï‰Î¼Î­Î½ÎµÏ‚ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(369994,10278,'zh','é¢„å°å­˜æ¬¾å•\r\n',0),(369995,10278,'sv','FÃ¶rtryckt insÃ¤ttningsblanketten',0),(369996,10278,'it','Distinta di deposito prestampati',0),(369997,10278,'tl','',0),(369998,10278,'th','à¸à¸²à¸à¸žà¸´à¸¡à¸žà¹Œà¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²',0),(369999,10278,'hi','Preprinted à¤œà¤®à¤¾ à¤ªà¤°à¥à¤šà¥€',0),(370000,10278,'ms','Slip Deposit tercetak',0),(370001,10278,'ar','Ù‚Ø³ÙŠÙ…Ø© Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ø·Ø¨ÙˆØ¹Ø© Ù…Ø³Ø¨Ù‚Ø§Ù‹',0),(370002,10278,'fr','Bordereau prÃ©-imprimÃ©',0),(370003,10278,'jp','ã‚ã‚‰ã‹ã˜ã‚å°åˆ·ã•ã‚ŒãŸé é‡‘ä¼ç¥¨',0),(370004,10278,'pt','Comprovante de depÃ³sito prÃ©-impresso',0),(370005,10278,'ru','ÐŸÐ»Ð¾Ñ‚Ð½Ð°Ñ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸',0),(370006,10278,'es','Ficha de DepÃ³sito Preimprimido',0),(370007,10278,'de','Vorgedruckten Einzahlungsschein',0),(370008,10278,'en','Preprinted Deposit Slip',0),(370009,10279,'is','',0),(370010,10279,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯',0),(370011,10279,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯',0),(370012,10279,'tr','Nakit akÄ±ÅŸÄ± raporu kurulumu',0),(370013,10279,'pl','PrzepÅ‚yw Å›rodkÃ³w pieniÄ™Å¼nych raportu instalacji',0),(370014,10279,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°Ñ‚Ð° Ð½Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°Ñ‚Ð° Ð·Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸',0),(370015,10279,'ur','Ú©ÛŒØ´ ÙÙ„Ùˆ Ø±Ù¾ÙˆØ±Ù¹ Ø³ÛŒÙ¹ Ø§Ù¾',0),(370016,10279,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð° Ð½Ð¾Ð²Ñ‡Ð°Ð½Ð¾Ð³ Ñ‚Ð¾ÐºÐ°',0),(370017,10279,'vi','DÃ²ng tiá»n máº·t bÃ¡o cÃ¡o cÃ i Ä‘áº·t',0),(370018,10279,'af','Kontantvloei Verslag Opstelling',0),(370019,10279,'ro','Fluxul de numerar raport configurare',0),(370020,10279,'et','Rahavoogude aruande seadistus',0),(370021,10279,'si','Denarni tok poroÄilo Setup',0),(370022,10279,'ba','Setup laporan arus kas',0),(370023,10279,'nl','Kasstroom verslag Setup',0),(370024,10279,'fi','Kassavirta asetukset',0),(370025,10279,'no','KontantstrÃ¸m rapportoppsett',0),(370026,10279,'da','Cash Flow rapportopsÃ¦tning',0),(370027,10279,'ko','í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œ ì„¤ì •',0),(370028,10279,'he','×”×’×“×¨×ª ×“×•×— ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(370029,10279,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚ Ï€Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚ Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(370030,10279,'zh','çŽ°é‡‘æµé‡æŠ¥å‘Šè®¾ç½®\r\n',0),(370031,10279,'sv','InstÃ¤llningar fÃ¶r kassaflÃ¶de',0),(370032,10279,'it','Flusso di cassa Report Setup',0),(370033,10279,'tl','',0),(370034,10279,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸à¸²à¸£à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(370035,10279,'hi','à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(370036,10279,'ms','Persediaan laporan aliran tunai',0),(370037,10279,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(370038,10279,'fr','Configuration de rapport de flux de trÃ©sorerie',0),(370039,10279,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆ ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(370040,10279,'pt','ConfiguraÃ§Ã£o do relatÃ³rio de fluxo de caixa',0),(370041,10279,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¾Ð² Ð´Ð²Ð¸Ð¶ÐµÐ½Ð¸Ñ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(370042,10279,'es','ConfiguraciÃ³n de Informe de Flujo de Efectivo',0),(370043,10279,'de','Cashflow-Bericht-Setup',0),(370044,10279,'en','Cash Flow Report Setup',0),(370045,10280,'is','',0),(370046,10280,'dr','Ø§ÙŠÙ† Ù¾Ø±Ø¯Ø§Ø®Øª ÙÙ‚Ø· Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ÙˆÙŠØ±Ø§ÙŠØ´ Ø´ÙˆØ¯ ØªÙˆØ³Ø·',0),(370047,10280,'pr','Ø§ÙŠÙ† Ù¾Ø±Ø¯Ø§Ø®Øª ÙÙ‚Ø· Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ÙˆÙŠØ±Ø§ÙŠØ´ Ø´ÙˆØ¯ ØªÙˆØ³Ø·',0),(370048,10280,'tr','Bu Ã¶deme sadece tarafÄ±ndan deÄŸiÅŸtirilebilir',0),(370049,10280,'pl','PÅ‚atnoÅ›ci mogÄ… byÄ‡ edytowane tylko przez',0),(370050,10280,'bg','Ð¢Ð¾Ð²Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÑÐ½Ð¸ ÑÐ°Ð¼Ð¾ Ð¾Ñ‚',0),(370051,10280,'ur','ÛŒÛ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ØµØ±Ù Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªØ¯ÙˆÛŒÙ† Ù†ÛÛŒÚº Ú©ÛŒ Ø¬Ø§ Ø³Ú©ØªÛŒ',0),(370052,10280,'sr','ÐžÐ²Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð¼Ð¾Ð³Ñƒ ÑÐµ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(370053,10280,'vi','Thanh toÃ¡n nÃ y chá»‰ cÃ³ thá»ƒ Ä‘Æ°á»£c chá»‰nh sá»­a bá»Ÿi',0),(370054,10280,'af','Hierdie Betaling Kan Slegs Geredigeer word Deur',0),(370055,10280,'ro','AceastÄƒ platÄƒ poate fi numai editate de',0),(370056,10280,'et','Selle makse saab muuta ainult poolt',0),(370057,10280,'si','To plaÄilo je mogoÄe urejati le z',0),(370058,10280,'ba','Pembayaran ini hanya bisa diedit oleh',0),(370059,10280,'nl','Deze betaling kan alleen worden bewerkt door',0),(370060,10280,'fi','TÃ¤mÃ¤ maksu voidaan muokata vain',0),(370061,10280,'no','Denne betalingen kan bare redigeres av',0),(370062,10280,'da','Denne betaling kan kun redigeres af',0),(370063,10280,'ko','ì´ ê²°ì œë§Œ í•˜ ì—¬ íŽ¸ì§‘í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(370064,10280,'he','× ×™×ª×Ÿ ×œ×¢×¨×•×š ××ª ×”×ª×©×œ×•× ×¨×§ ×¢×œ ×™×“×™',0),(370065,10280,'el','Î Î»Î·ÏÏ‰Î¼Î® Î±Ï…Ï„Î® Î¼Ï€Î¿ÏÎµÎ¯ Î¼ÏŒÎ½Î¿ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯ Î±Ï€ÏŒ',0),(370066,10280,'zh','è¿™ç§æ”¯ä»˜åªèƒ½ç¼–è¾‘\r\n',0),(370067,10280,'sv','Denna betalning kan endast redigeras av',0),(370068,10280,'it','Questo pagamento puÃ² essere modificato solo da',0),(370069,10280,'tl','',0),(370070,10280,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¹à¸à¹‰à¹„à¸‚à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸™à¸µà¹‰à¹‚à¸”à¸¢à¹€à¸‰à¸žà¸²à¸°',0),(370071,10280,'hi','à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡à¤µà¤² à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤¿à¤ à¤œà¤¾ à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(370072,10280,'ms','Bayaran ini hanya boleh diedit oleh',0),(370073,10280,'ar','ÙŠÙ…ÙƒÙ† ÙÙ‚Ø· ØªØ­Ø±ÙŠØ± Ù‡Ø°Ø§ Ø§Ù„Ø¯ÙØ¹ Ø¨ÙˆØ§Ø³Ø·Ø©',0),(370074,10280,'fr','Ce paiement seulement peut Ãªtre modifiÃ© que par',0),(370075,10280,'jp','ã“ã®æ”¯æ‰•ã„ã«ã‚ˆã£ã¦ã®ã¿ç·¨é›†ã§ãã¾ã™ã€‚',0),(370076,10280,'pt','Este pagamento sÃ³ pode ser editado pelo',0),(370077,10280,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ Ð¼Ð¾Ð¶ÐµÑ‚ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(370078,10280,'es','Este Pago Solo Se Puede Editar Por',0),(370079,10280,'de','Diese Zahlung kann nur bearbeitet werden, indem',0),(370080,10280,'en','This Payment Can Only Be Edited By',0),(370081,10281,'is','',0),(370082,10281,'dr','( ÙŠØ§Ø¯Ø¢ÙˆØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡',0),(370083,10281,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ( ÙŠØ§Ø¯Ø¢ÙˆØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡',0),(370084,10281,'tr','UyarÄ± mektubu',0),(370085,10281,'pl','Przypomnienie',0),(370086,10281,'bg','ÐÐ°Ð¿Ð¾Ð¼Ð½ÑÐ½Ðµ',0),(370087,10281,'ur','ÛŒØ§Ø¯ Ø¯ÛØ§Ù†ÛŒ',0),(370088,10281,'sr','ÐžÐ¿Ð¾Ð¼ÐµÐ½Ðµ',0),(370089,10281,'vi','nháº¯c nhá»Ÿ',0),(370090,10281,'af','Herinneraar',0),(370091,10281,'ro','Memento',0),(370092,10281,'et','Meeldetuletus',0),(370093,10281,'si','Opomnik',0),(370094,10281,'ba','Pengingat',0),(370095,10281,'nl','Herinnering',0),(370096,10281,'fi','Muistutus',0),(370097,10281,'no','PÃ¥minnelse',0),(370098,10281,'da','PÃ¥mindelse',0),(370099,10281,'ko','ì•Œë¦¼',0),(370100,10281,'he','×ª×–×›×•×¨×ª',0),(370101,10281,'el','Î¥Ï€ÎµÎ½Î¸ÏÎ¼Î¹ÏƒÎ·',0),(370102,10281,'zh','æé†’\r\n',0),(370103,10281,'sv','PÃ¥minnelse',0),(370104,10281,'it','Promemoria',0),(370105,10281,'tl','',0),(370106,10281,'th','à¸ˆà¸”à¸«à¸¡à¸²à¸¢à¹€à¸•à¸·à¸­à¸™à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(370107,10281,'hi','à¤…à¤¨à¥à¤¸à¥à¤®à¤¾à¤°à¤•',0),(370108,10281,'ms','Peringatan',0),(370109,10281,'ar','ØªØ°ÙƒÙŠØ±',0),(370110,10281,'fr','Rappel',0),(370111,10281,'jp','ã‚¢ãƒ©ãƒ¼ãƒ ',0),(370112,10281,'pt','Lembrete',0),(370113,10281,'ru','ÐÐ°Ð¿Ð¾Ð¼Ð¸Ð½Ð°Ð½Ð¸Ðµ',0),(370114,10281,'es','Recordatorio',0),(370115,10281,'de','Erinnerung',0),(370116,10281,'en','Reminder',0),(370117,10282,'is','',0),(370118,10282,'dr','Ø¯Ø±ØµØ¯ Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ø´ØªØ±Ù‰',0),(370119,10282,'pr','Ø¯Ø±ØµØ¯ Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ø´ØªØ±Ù‰',0),(370120,10282,'tr','Nakit giriÅŸi yÃ¼zde istemci',0),(370121,10282,'pl','NapÅ‚yw Å›rodkÃ³w pieniÄ™Å¼nych procent klienta',0),(370122,10282,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ñ€Ð¸Ñ‚Ð¾Ðº Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(370123,10282,'ur','Ù†Ù‚Ø¯ Inflow ÙÛŒØµØ¯ ÙˆØµÙˆÙ„ Ú©Ø§Ø±',0),(370124,10282,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð¿Ñ€Ð¸Ð»Ð¸Ð² Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ',0),(370125,10282,'vi','KhÃ¡ch hÃ ng pháº§n trÄƒm dÃ²ng tiá»n máº·t',0),(370126,10282,'af','Kontant invloei persent kliÃ«nt',0),(370127,10282,'ro','Numerar afluxul Client la sutÄƒ',0),(370128,10282,'et','Raha sissevool protsenti klient',0),(370129,10282,'si','Denarni pritok odstotkov odjemalca',0),(370130,10282,'ba','Cash Inflow persen klien',0),(370131,10282,'nl','Cash premie-inkomen percentage Client',0),(370132,10282,'fi','Cash virtaamaan prosenttia asiakkaan',0),(370133,10282,'no','Kontanter tilsig prosent klient',0),(370134,10282,'da','Kontant indstrÃ¸mning procent klient',0),(370135,10282,'ko','í˜„ê¸ˆ ìœ ìž… % í´ë¼ì´ì–¸íŠ¸',0),(370136,10282,'he','×œ×§×•×— ××—×•×– ×©×œ ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(370137,10282,'el','Î•Î¹ÏƒÏÎ¿Î® Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½ Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(370138,10282,'zh','çŽ°é‡‘æµå…¥èˆ¹é˜Ÿç§‘\r\n',0),(370139,10282,'sv','Kontant inflÃ¶de procent klient',0),(370140,10282,'it','Cassa afflusso percentuale Client',0),(370141,10282,'tl','',0),(370142,10282,'th','à¹„à¸„à¸¥à¹€à¸­à¸™à¸•à¹Œà¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸‚à¸­à¸‡à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(370143,10282,'hi','à¤¨à¤•à¤¦ à¤‡à¤¨à¤«à¥à¤²à¥‹ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(370144,10282,'ms','Pelanggan peratus aliran masuk Tunai',0),(370145,10282,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ù†Ø³Ø¨Ø© Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(370146,10282,'fr','Cash Inflow pourcentage Client',0),(370147,10282,'jp','ç¾é‡‘æµå…¥ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆ',0),(370148,10282,'pt','Cash Inflow porcentagem cliente',0),(370149,10282,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¿Ñ€Ð¸Ñ‚Ð¾Ðº Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(370150,10282,'es','Porcentaje de Flujo Entrante de Efectivo del Cliente',0),(370151,10282,'de','Bargeld Zufluss Prozent Client',0),(370152,10282,'en','Cash Inflow Percent Client',0),(370153,10283,'is','',0),(370154,10283,'dr','Ø¯Ø±ØµØ¯ Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ \r\n GFD',0),(370155,10283,'pr','Ø¯Ø±ØµØ¯ Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ \r\n GFD',0),(370156,10283,'tr','Nakit giriÅŸi yÃ¼zde GFD',0),(370157,10283,'pl','Procent wpÅ‚ywÃ³w pieniÄ™Å¼nych GFD',0),(370158,10283,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ñ€Ð¸Ñ‚Ð¾Ðº Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° Ð‘Ð’Ð”',0),(370159,10283,'ur','Ù†Ù‚Ø¯ Inflow ÙÛŒØµØ¯ Ú¯ÙØ¯',0),(370160,10283,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ð¿Ñ€Ð¸Ð»Ð¸Ð² Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ Ð“Ð¤Ð”',0),(370161,10283,'vi','Pháº§n trÄƒm dÃ²ng tiá»n máº·t GFD',0),(370162,10283,'af','Kontant invloei persent GFD',0),(370163,10283,'ro','Afluxul de numerar procente GFD',0),(370164,10283,'et','Raha sissevool protsenti GFD',0),(370165,10283,'si','Odstotkov Cash pritoka GFD',0),(370166,10283,'ba','Cash Inflow persen GFD',0),(370167,10283,'nl','Contant geld instroom procent GFD',0),(370168,10283,'fi','Cash virtaamaan prosenttia GFD',0),(370169,10283,'no','Kontanter tilsig prosent GFD',0),(370170,10283,'da','Kontant indstrÃ¸mning procent GFD',0),(370171,10283,'ko','í˜„ê¸ˆ ìœ ìž… % GFD',0),(370172,10283,'he','××—×•×– ×ª×–×¨×™× ×ž×–×•×ž× ×™× GFD',0),(370173,10283,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ® ÎµÎ¹ÏƒÏÎ¿Î® Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ GFD',0),(370174,10283,'zh','çŽ°é‡‘æµå…¥ç™¾åˆ†æ¯”èˆ¹é˜Ÿç§‘\r\n',0),(370175,10283,'sv','Kontant inflÃ¶de procent GFD',0),(370176,10283,'it','Cassa afflusso per cento GFD',0),(370177,10283,'tl','',0),(370178,10283,'th','à¸£à¹‰à¸­à¸¢à¸¥à¸°à¸‚à¸­à¸‡à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸” GFD',0),(370179,10283,'hi','à¤¨à¤•à¤¦ à¤‡à¤¨à¤«à¥à¤²à¥‹ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ GFD',0),(370180,10283,'ms','Peratus aliran masuk tunai GFD',0),(370181,10283,'ar','Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ ÙÙŠ Ø§Ù„Ù…Ø§Ø¦Ø© Ø³Ø§Ø±ÙŠ Ø§Ù„Ù…ÙØ¹ÙˆÙ„',0),(370182,10283,'fr','Cash Inflow % Gisiger',0),(370183,10283,'jp','ç¾é‡‘æµå…¥å‰²ã® GFD',0),(370184,10283,'pt','Por cento de influxo de dinheiro Eliana',0),(370185,10283,'ru','ÐŸÑ€Ð¸Ñ‚Ð¾Ðº Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð² % GFD',0),(370186,10283,'es','Porcentaje de Flujo Entrante de Efectivo de GFD',0),(370187,10283,'de','Bargeld Zufluss Prozent GFD',0),(370188,10283,'en','Cash Inflow Percent GFD',0),(370189,10284,'is','',0),(370190,10284,'dr','Ø¯Ø±ØµØ¯ Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ \r\nREX',0),(370191,10284,'pr','Ø¯Ø±ØµØ¯ Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ \r\nREX',0),(370192,10284,'tr','Nakit giriÅŸi yÃ¼zde REX',0),(370193,10284,'pl','Procent wpÅ‚ywÃ³w pieniÄ™Å¼nych REX',0),(370194,10284,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ñ€Ð¸Ñ‚Ð¾Ðº Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° Ð ÐµÐºÑ',0),(370195,10284,'ur','Ù†Ù‚Ø¯ Inflow ÙÛŒØµØ¯ Ø±ÛŒÚ©Ø³',0),(370196,10284,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ð¿Ñ€Ð¸Ð»Ð¸Ð² Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ Ð Ð•X',0),(370197,10284,'vi','Pháº§n trÄƒm dÃ²ng tiá»n máº·t REX',0),(370198,10284,'af','Kontant invloei persent REX',0),(370199,10284,'ro','Afluxul de numerar procente REX',0),(370200,10284,'et','Raha sissevool protsenti REX',0),(370201,10284,'si','Odstotkov Cash pritoka REX',0),(370202,10284,'ba','Cash Inflow persen REX',0),(370203,10284,'nl','Contant geld instroom procent REX',0),(370204,10284,'fi','Cash virtaamaan prosenttia REX',0),(370205,10284,'no','Kontanter tilsig prosent REX',0),(370206,10284,'da','Kontant indstrÃ¸mning procent REX',0),(370207,10284,'ko','í˜„ê¸ˆ ìœ ìž… % ë ‰ìŠ¤',0),(370208,10284,'he','××—×•×– ×ª×–×¨×™× ×ž×–×•×ž× ×™× ×¨×§×¡',0),(370209,10284,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ® ÎµÎ¹ÏƒÏÎ¿Î® Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ REX',0),(370210,10284,'zh','çŽ°é‡‘æµå…¥ç™¾åˆ†æ¯”åŠ›å£«\r\n',0),(370211,10284,'sv','Kontant inflÃ¶de procent REX',0),(370212,10284,'it','Cassa afflusso per cento REX',0),(370213,10284,'tl','',0),(370214,10284,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¹€à¸‡à¸´à¸™à¸ªà¸”à¹„à¸«à¸¥à¹€à¸‚à¹‰à¸² REX',0),(370215,10284,'hi','à¤¨à¤•à¤¦ à¤‡à¤¨à¤«à¥à¤²à¥‹ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤°à¥‡à¤•à¥à¤¸',0),(370216,10284,'ms','Peratus aliran masuk tunai REX',0),(370217,10284,'ar','ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ø±ÙŠÙƒØ³',0),(370218,10284,'fr','Cash Inflow % REX',0),(370219,10284,'jp','ç¾é‡‘æµå…¥ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ ãƒ¬ãƒƒã‚¯ã‚¹',0),(370220,10284,'pt','Por cento de influxo de dinheiro REX',0),(370221,10284,'ru','ÐŸÑ€Ð¸Ñ‚Ð¾Ðº Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ñ… Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð² Ð ÐµÐºÑ',0),(370222,10284,'es','Porcentaje de Flujo Entrante de Efectivo del REX',0),(370223,10284,'de','Bargeld Zufluss Prozent REX',0),(370224,10284,'en','Cash Inflow Percent REX',0),(370225,10285,'is','',0),(370226,10285,'dr','Ø¯Ø±ØµØ¯Ø¬Ø±ÙŠØ§Ù† Ø®Ø±ÙˆØ¬ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ø´ØªØ±ÙŠ',0),(370227,10285,'pr','Ø¯Ø±ØµØ¯Ø¬Ø±ÙŠØ§Ù† Ø®Ø±ÙˆØ¬ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ø´ØªØ±ÙŠ',0),(370228,10285,'tr','Nakit Ã‡â€ºkâ€ºflâ€º yÃ¼zde istemci',0),(370229,10285,'pl','OdpÅ‚yw gotÃ³wki procent klienta',0),(370230,10285,'bg','ÐŸÐ°Ñ€Ð¸ Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½ÐµÑ‚Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(370231,10285,'ur','Ù†Ù‚Ø¯ Ø¨Ú¾Ø§Ø¤ ÙÛŒ ØµØ¯ Ú¯Ø§ÛÚ©',0),(370232,10285,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ñƒ Ð¾Ð´Ð²Ð¾Ð´Ð½Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(370233,10285,'vi','Tiá»n máº·t cháº£y ra pháº§n trÄƒm khÃ¡ch hÃ ng',0),(370234,10285,'af','Kontant uitvloei persent kliÃ«nt',0),(370235,10285,'ro','Numerar scurgerea Client la sutÄƒ',0),(370236,10285,'et','Raha vÃ¤ljavool protsenti klient',0),(370237,10285,'si','Denarni odtok odstotkov odjemalca',0),(370238,10285,'ba','Kas keluar persen klien',0),(370239,10285,'nl','Contant geld uitstroom percentage Client',0),(370240,10285,'fi','Rahaa virtasi prosenttia asiakkaan',0),(370241,10285,'no','Kontanter ut prosent klient',0),(370242,10285,'da','Kontant udstrÃ¸mning procent klient',0),(370243,10285,'ko','í˜„ê¸ˆ ìœ ì¶œ % í´ë¼ì´ì–¸íŠ¸',0),(370244,10285,'he','×œ×§×•×— ××—×•×– ×©×œ ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(370245,10285,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ® ÎµÎºÏÎ¿Î® Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(370246,10285,'zh','å®¢æˆ·çŽ°é‡‘æµå‡ºç™¾åˆ†æ¯”\r\n',0),(370247,10285,'sv','Kontant utflÃ¶de procent klient',0),(370248,10285,'it','Cash Outflow percentuale Client',0),(370249,10285,'tl','',0),(370250,10285,'th','à¹„à¸„à¸¥à¹€à¸­à¸™à¸•à¹Œà¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸‚à¸­à¸‡à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(370251,10285,'hi','à¤¨à¤•à¤¦ à¤¬à¤¹à¤¿à¤°à¥à¤µà¤¾à¤¹ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(370252,10285,'ms','Pelanggan peratus aliran keluar Wang Tunai',0),(370253,10285,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ù†Ø³Ø¨Ø© Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(370254,10285,'fr','TrÃ©sorerie Outflow pourcentage Client',0),(370255,10285,'jp','ç¾é‡‘ã®æµå‡ºçŽ‡ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆ',0),(370256,10285,'pt','Dinheiro cliente porcentagem de vazÃ£o',0),(370257,10285,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¾Ñ‚Ñ‚Ð¾Ðº Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(370258,10285,'es','Porcentaje de Flujo Saliente de Efectivo del Cliente',0),(370259,10285,'de','Bargeld-Abfluss-Prozent-Client',0),(370260,10285,'en','Cash Outflow Percent Client',0),(370261,10286,'is','',0),(370262,10286,'dr','Ø¯Ø±ØµØ¯Ø¬Ø±ÙŠØ§Ù† Ø®Ø±ÙˆØ¬ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯\r\n GFD',0),(370263,10286,'pr','Ø¯Ø±ØµØ¯Ø¬Ø±ÙŠØ§Ù† Ø®Ø±ÙˆØ¬ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯\r\n GFD',0),(370264,10286,'tr','Nakit Ã‡â€ºkâ€ºflâ€º yÃ¼zde GFD',0),(370265,10286,'pl','Procent odpÅ‚yw gotÃ³wki GFD',0),(370266,10286,'bg','ÐŸÐ°Ñ€Ð¸ Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½ÐµÑ‚Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° Ð‘Ð’Ð”',0),(370267,10286,'ur','Ù†Ù‚Ø¯ Ø¨Ú¾Ø§Ø¤ ÙÛŒ ØµØ¯ Ú¯ÙØ¯',0),(370268,10286,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ð¾Ð´Ð»Ð¸Ð² Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ Ð“Ð¤Ð”',0),(370269,10286,'vi','Tiá»n máº·t cháº£y ra pháº§n trÄƒm GFD',0),(370270,10286,'af','Kontant uitvloei persent GFD',0),(370271,10286,'ro','Fluxul de numerar procente GFD',0),(370272,10286,'et','Raha vÃ¤ljavool protsenti GFD',0),(370273,10286,'si','Odstotkov Cash odtok GFD',0),(370274,10286,'ba','Kas keluar persen GFD',0),(370275,10286,'nl','Contant geld uitstroom procent GFD',0),(370276,10286,'fi','Rahaa virtasi prosenttia GFD',0),(370277,10286,'no','Kontanter ut prosent GFD',0),(370278,10286,'da','Kontant udstrÃ¸mning procent GFD',0),(370279,10286,'ko','í˜„ê¸ˆ ìœ ì¶œ % GFD',0),(370280,10286,'he','××—×•×– ×ª×–×¨×™× ×ž×–×•×ž× ×™× GFD',0),(370281,10286,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ® ÎµÎºÏÎ¿Î® Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ GFD',0),(370282,10286,'zh','çŽ°é‡‘æµå‡ºé‡çš„ç™¾åˆ†æ¯”èˆ¹é˜Ÿç§‘\r\n',0),(370283,10286,'sv','Kontant utflÃ¶de procent GFD',0),(370284,10286,'it','Per cento di deflusso di cassa GFD',0),(370285,10286,'tl','',0),(370286,10286,'th','à¸£à¹‰à¸­à¸¢à¸¥à¸°à¸‚à¸­à¸‡à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸” GFD',0),(370287,10286,'hi','à¤¨à¤•à¤¦ à¤¬à¤¹à¤¿à¤°à¥à¤µà¤¾à¤¹ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ GFD',0),(370288,10286,'ms','Peratus aliran keluar tunai GFD',0),(370289,10286,'ar','Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ø³Ø§Ø±ÙŠ Ø§Ù„Ù…ÙØ¹ÙˆÙ„',0),(370290,10286,'fr','TrÃ©sorerie Outflow % Gisiger',0),(370291,10286,'jp','ç¾é‡‘æµå‡º ï¼… GFD',0),(370292,10286,'pt','SaÃ­da de dinheiro por cento Eliana',0),(370293,10286,'ru','ÐžÑ‚Ñ‚Ð¾Ðº Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð² % GFD',0),(370294,10286,'es','Porcentaje de Flujo Saliente de Efectivo del GFD',0),(370295,10286,'de','Bargeld Abfluss Prozent GFD',0),(370296,10286,'en','Cash Outflow Percent GFD',0),(370297,10287,'is','',0),(370298,10287,'dr','Ø¨Ø³ØªÙ†  Ù‡Ø²ÙŠÙ†Ù‡ ',0),(370299,10287,'pr','Ø¨Ø³ØªÙ†  Ù‡Ø²ÙŠÙ†Ù‡ ',0),(370300,10287,'tr','KapanÄ±ÅŸ maliyet',0),(370301,10287,'pl','KosztÃ³w zamkniÄ™cia',0),(370302,10287,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð°Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ',0),(370303,10287,'ur','Ø§Ø®ØªØªØ§Ù…ÛŒ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(370304,10287,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð·Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐ°',0),(370305,10287,'vi','ÄÃ³ng chi phÃ­',0),(370306,10287,'af','Koste Afsluiting',0),(370307,10287,'ro','Costurile de Ã®nchidere',0),(370308,10287,'et','Sulgemise kulud',0),(370309,10287,'si','Zapiranje stroÅ¡ki',0),(370310,10287,'ba','Biaya penutupan',0),(370311,10287,'nl','Kosten sluiten',0),(370312,10287,'fi','Kustannukset sulkeminen',0),(370313,10287,'no','Koste lukking',0),(370314,10287,'da','Koste lukning',0),(370315,10287,'ko','ë‹«ê¸° ë¹„ìš©',0),(370316,10287,'he','×¢×œ×•×ª ×¡×’×™×¨×ª',0),(370317,10287,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÎ»ÎµÎ¹ÏƒÎ¯Î¼Î±Ï„Î¿Ï‚',0),(370318,10287,'zh','æˆæœ¬å…³é—­\r\n',0),(370319,10287,'sv','Kostnad stÃ¤ngning',0),(370320,10287,'it','Costi di chiusura',0),(370321,10287,'tl','',0),(370322,10287,'th','à¸›à¸´à¸”à¸šà¸±à¸à¸Šà¸µà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(370323,10287,'hi','à¤¸à¤®à¤¾à¤ªà¤¨ à¤²à¤¾à¤—à¤¤',0),(370324,10287,'ms','Kos yang tutup',0),(370325,10287,'ar','ØªÙƒÙ„ÙØ© Ø¥ØºÙ„Ø§Ù‚',0),(370326,10287,'fr','Frais de clÃ´ture',0),(370327,10287,'jp','é–‰ä¼šã®ã‚³ã‚¹ãƒˆã—ã¾ã™ã€‚',0),(370328,10287,'pt','Custos de fechamento',0),(370329,10287,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ð¸Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(370330,10287,'es','Cerrando Costos',0),(370331,10287,'de','Kosten schlieÃŸen',0),(370332,10287,'en','Cost Closing',0),(370333,10288,'is','',0),(370334,10288,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø³Ø§Ø®Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ',0),(370335,10288,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø³Ø§Ø®Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ',0),(370336,10288,'tr','Maliyet inÅŸaat ana bina',0),(370337,10288,'pl','Koszt budowy gÅ‚Ã³wnych budynkÃ³w',0),(370338,10288,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¸ ÑÐ³Ñ€Ð°Ð´Ð¸',0),(370339,10288,'ur','Ù„Ø§Ú¯Øª Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ø³Ø¨ Ø³Û’ Ø§ÛÙ… Ø¹Ù…Ø§Ø±Ø§Øª',0),(370340,10288,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÐµ Ð³Ð»Ð°Ð²Ð½Ðµ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(370341,10288,'vi','chi phÃ­ xÃ¢y dá»±ng dá»Ÿ dang',0),(370342,10288,'af','Koste Konstruksie Hoof Geboue.',0),(370343,10288,'ro','Cost constructie principalele clÄƒdiri',0),(370344,10288,'et','Maksumus ehituse Main hooned',0),(370345,10288,'si','StroÅ¡ki gradnje glavne stavbe',0),(370346,10288,'ba','Biaya konstruksi bangunan-bangunan utama',0),(370347,10288,'nl','Kosten bouw Main gebouwen',0),(370348,10288,'fi','Kustannukset rakentamiseen Main rakennukset',0),(370349,10288,'no','Kostnadene bygging Main bygninger',0),(370350,10288,'da','Cost bygge Main bygninger',0),(370351,10288,'ko','ë¹„ìš© ê±´ì„¤ ì£¼ìš” ê±´ë¬¼',0),(370352,10288,'he','×¢×œ×•×ª ×”×‘× ×™×™×” ×”×ž×¨×›×–×™×ª ×ž×‘× ×™×',0),(370353,10288,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®Ï‚ ÎºÏÏÎ¹Î± ÎºÏ„Î¯ÏÎ¹Î±',0),(370354,10288,'zh','ä¸»æ¥¼å»ºç­‘æˆæœ¬\r\n',0),(370355,10288,'sv','Kostnad konstruktion Main byggnader',0),(370356,10288,'it','Costo costruzione principale edifici',0),(370357,10288,'tl','',0),(370358,10288,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡à¸­à¸²à¸„à¸²à¸£à¸«à¸¥à¸±à¸',0),(370359,10288,'hi','à¤²à¤¾à¤—à¤¤ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤®à¥à¤–à¥à¤¯ à¤‡à¤®à¤¾à¤°à¤¤à¥‡à¤‚',0),(370360,10288,'ms','Kos pembinaan bangunan-bangunan utama',0),(370361,10288,'ar','ØªÙƒÙ„ÙØ© ØªØ´ÙŠÙŠØ¯ Ø§Ù„Ù…Ø¨Ø§Ù†ÙŠ Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(370362,10288,'fr','CoÃ»t Construction principaux bÃ¢timents',0),(370363,10288,'jp','ã‚³ã‚¹ãƒˆå»ºè¨­ã®ä¸»è¦ãªå»ºç‰©',0),(370364,10288,'pt','Custo de construÃ§Ã£o principais edifÃ­cios',0),(370365,10288,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð° Ð³Ð»Ð°Ð²Ð½Ð¾Ð³Ð¾ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(370366,10288,'es','Costo de ConstrucciÃ³n Edificios Principales',0),(370367,10288,'de','Kosten Bau-HauptgebÃ¤ude',0),(370368,10288,'en','Cost Construction Main Buildings',0),(370369,10289,'is','',0),(370370,10289,'dr','Ø³Ø§Ø²Ú¯Ø§Ø±ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ú¯Ø§Ù‡ Ø³Ø§Ø®ØªÙ…Ø§Ù†ÙŠ',0),(370371,10289,'pr','Ø³Ø§Ø²Ú¯Ø§Ø±ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ú¯Ø§Ù‡ Ø³Ø§Ø®ØªÙ…Ø§Ù†ÙŠ',0),(370372,10289,'tr','Ä°nÅŸaat Site aktivite mal',0),(370373,10289,'pl','Koszt budowy UdogodnieÅ„',0),(370374,10289,'bg','Ð¡Ñ‚Ñ€ÑƒÐ²Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½ÐµÑ‚Ð¾ ÑÐ°Ð¹Ñ‚ ÑƒÐ´Ð¾Ð±ÑÑ‚Ð²Ð°',0),(370375,10289,'ur','ØªØ¹Ù…ÛŒØ±Ø§ØªÛŒ Ø³Ø§Ø¦Ù¹ Ø³ÛÙˆÙ„ÛŒØ§Øª Ú©ÛŒ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(370376,10289,'sr','ÐšÐ¾ÑˆÑ‚Ð° Ð³Ñ€Ð°Ñ’ÐµÐ²Ð¸Ð½ÑÐºÐ¸Ñ… Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸',0),(370377,10289,'vi','chi phÃ­ xÃ¢y dá»±ng',0),(370378,10289,'af','Koste van konstruksie terrein geriewe',0),(370379,10289,'ro','Cost constructie Site facilitÄƒÅ£i',0),(370380,10289,'et','Kulu ehitus saidi mugavustega',0),(370381,10289,'si','StroÅ¡ek gradnje mesto udobja',0),(370382,10289,'ba','Biaya konstruksi situs Fasilitas',0),(370383,10289,'nl','Kosten van bouw Site faciliteiten',0),(370384,10289,'fi','Maksaa rakentaminen sivuston Kylpytuotteita',0),(370385,10289,'no','Koste bygging omrÃ¥det fasiliteter',0),(370386,10289,'da','Koste konstruktion arbejdsplads faciliteter',0),(370387,10289,'ko','ê±´ì„¤ ì‚¬ì´íŠ¸ ì„¤ë¹„ ë¹„ìš©',0),(370388,10289,'he','×¢×œ×•×ª ×”×©×™×¨×•×ª×™× ×‘××ª×¨ ×‘× ×™×™×”',0),(370389,10289,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®Ï‚ Site Î±Î½Î­ÏƒÎµÎ¹Ï‚',0),(370390,10289,'zh','æ–½å·¥çŽ°åœºè®¾æ–½æˆæœ¬\r\n',0),(370391,10289,'sv','Kosta konstruktion webbplats bekvÃ¤mligheter',0),(370392,10289,'it','Costo costruzione sito servizi',0),(370393,10289,'tl','',0),(370394,10289,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡à¸­à¸³à¸™à¸§à¸¢',0),(370395,10289,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤¸à¥à¤µà¤¿à¤§à¤¾à¤“à¤‚ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥€ à¤²à¤¾à¤—à¤¤',0),(370396,10289,'ms','Kos pembinaan tapak Kemudahan',0),(370397,10289,'ar','ØªÙƒÙ„ÙØ© Ø¨Ù†Ø§Ø¡ Ø§Ù„Ù…ÙˆÙ‚Ø¹ ÙˆØ³Ø§Ø¦Ù„ Ø§Ù„Ø±Ø§Ø­Ø©',0),(370398,10289,'fr','CoÃ»t des Ã©quipements de Construction Site',0),(370399,10289,'jp','å»ºè¨­ã‚µã‚¤ãƒˆã®è¨­å‚™ã‚’ã‚³ã‚¹ãƒˆã—ã¾ã™ã€‚',0),(370400,10289,'pt','Custo construÃ§Ã£o Site amenidades',0),(370401,10289,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð° ÑÐ°Ð¹Ñ‚ Ð¿Ñ€Ð¸Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾ÑÑ‚Ð¸',0),(370402,10289,'es','Costo de ConstrucciÃ³n Amenidades del Sitio',0),(370403,10289,'de','Kosten Construction Site Einrichtungen',0),(370404,10289,'en','Cost Construction Site Amenities',0),(370405,10290,'is','',0),(370406,10290,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ø±Ø³Ù‰ ÙÙ†Ù‰ ',0),(370407,10290,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø±Ø±Ø³Ù‰ ÙÙ†Ù‰ ',0),(370408,10290,'tr','Maliyet mÃ¼hendislik',0),(370409,10290,'pl','Koszt inÅ¼ynierii',0),(370410,10290,'bg','Ð¦ÐµÐ½Ð° Ð˜Ð½Ð¶ÐµÐ½ÐµÑ€Ð¸Ð½Ð³',0),(370411,10290,'ur','Ø§Ù†Ø¬ÛŒÙ†Ø¦Ø±Ù†Ú¯ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(370412,10290,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¸Ð½Ð¶ÐµÑšÐµÑ€ÑÑ‚Ð²Ð¾',0),(370413,10290,'vi','chi phÃ­ Engineering',0),(370414,10290,'af','Koste van Ingenieurs',0),(370415,10290,'ro','Costul de inginerie',0),(370416,10290,'et','Kulu Engineering',0),(370417,10290,'si','StroÅ¡ki inÅ¾eniringa',0),(370418,10290,'ba','Biaya rekayasa',0),(370419,10290,'nl','Kosten Engineering',0),(370420,10290,'fi','Kustannukset tekniikan',0),(370421,10290,'no','Kostnader Engineering',0),(370422,10290,'da','Cost Engineering',0),(370423,10290,'ko','ì—”ì§€ë‹ˆì–´ë§ ë¹„ìš©',0),(370424,10290,'he','×¢×œ×•×ª ×”× ×“×¡×”',0),(370425,10290,'el','ÎšÏŒÏƒÏ„Î¿Ï…Ï‚ Î¼Î·Ï‡Î±Î½Î¹ÎºÏŽÎ½',0),(370426,10290,'zh','å·¥ç¨‹æˆæœ¬\r\n',0),(370427,10290,'sv','Kostnad Engineering',0),(370428,10290,'it','Costo di ingegneria',0),(370429,10290,'tl','',0),(370430,10290,'th','à¸§à¸´à¸¨à¸§à¸à¸£à¸£à¸¡à¸•à¹‰à¸™à¸—à¸¸à¸™',0),(370431,10290,'hi','à¤²à¤¾à¤—à¤¤ à¤‡à¤‚à¤œà¥€à¤¨à¤¿à¤¯à¤°à¤¿à¤‚à¤—',0),(370432,10290,'ms','Kos Kejuruteraan',0),(370433,10290,'ar','Ù‡Ù†Ø¯Ø³Ø© Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(370434,10290,'fr','CoÃ»t d\'ingÃ©nierie',0),(370435,10290,'jp','ã‚³ã‚¹ãƒˆ ã‚¨ãƒ³ã‚¸ãƒ‹ã‚¢ ãƒªãƒ³ã‚°',0),(370436,10290,'pt','Engenharia de custos',0),(370437,10290,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¸Ð½Ð¶ÐµÐ½ÐµÑ€Ð½Ñ‹Ñ…',0),(370438,10290,'es','Costo de IngenierÃ­a',0),(370439,10290,'de','Cost Engineering',0),(370440,10290,'en','Cost Engineering',0),(370441,10291,'is','',0),(370442,10291,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ú©Ø¨Ø±Ø¯Ø§Ø±Ù‰',0),(370443,10291,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø®Ø§Ú©Ø¨Ø±Ø¯Ø§Ø±Ù‰',0),(370444,10291,'tr','Maliyet kazÄ±',0),(370445,10291,'pl','Koszt wykopu',0),(370446,10291,'bg','Ð¦ÐµÐ½Ð° Ð¸Ð·ÐºÐ¾Ð¿Ð½Ð¸',0),(370447,10291,'ur','Ù„Ø§Ú¯Øª Ú©Ú¾Ø¯Ø§Ø¦ÛŒ',0),(370448,10291,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð¸ÑÐºÐ¾Ð¿Ð°Ð²Ð°ÑšÐ°',0),(370449,10291,'vi','chi phÃ­ Excavation',0),(370450,10291,'af','Koste uitgrawing',0),(370451,10291,'ro','Costul de excavare',0),(370452,10291,'et','Maksumus kaevetÃ¶Ã¶de',0),(370453,10291,'si','StroÅ¡ki izkopa',0),(370454,10291,'ba','Biaya penggalian',0),(370455,10291,'nl','Kosten opgraving',0),(370456,10291,'fi','Kustannukset kaivaus',0),(370457,10291,'no','Kostnader utgraving',0),(370458,10291,'da','Omkostninger udgravning',0),(370459,10291,'ko','ë¹„ìš©ëœ ë°œêµ´',0),(370460,10291,'he','×¢×œ×•×ª ×”×—×¤×™×¨×”',0),(370461,10291,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î±ÏƒÎºÎ±Ï†Î®',0),(370462,10291,'zh','å¼€æŒ–æˆæœ¬\r\n',0),(370463,10291,'sv','Kostnad utgrÃ¤vning',0),(370464,10291,'it','Costo scavo',0),(370465,10291,'tl','',0),(370466,10291,'th','à¸‚à¸¸à¸”à¸•à¹‰à¸™à¸—à¸¸à¸™',0),(370467,10291,'hi','à¤²à¤¾à¤—à¤¤ à¤‰à¤¤à¥à¤–à¤¨à¤¨',0),(370468,10291,'ms','Kos pengorekan',0),(370469,10291,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ø­ÙØ±',0),(370470,10291,'fr','CoÃ»ts d\'Excavation',0),(370471,10291,'jp','ã‚³ã‚¹ãƒˆç™ºæŽ˜',0),(370472,10291,'pt','Custo de escavaÃ§Ã£o',0),(370473,10291,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð·ÐµÐ¼Ð»ÑÐ½Ñ‹Ñ… Ñ€Ð°Ð±Ð¾Ñ‚',0),(370474,10291,'es','Costo de ExcavaciÃ³n',0),(370475,10291,'de','Kosten Ausgrabung',0),(370476,10291,'en','Cost Excavation',0),(370477,10292,'is','',0),(370478,10292,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø«Ø§Ø«Ù‡',0),(370479,10292,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø«Ø§Ø«Ù‡',0),(370480,10292,'tr','Maliyetli mobilya',0),(370481,10292,'pl','Koszt mebli',0),(370482,10292,'bg','Ð¦ÐµÐ½Ð° Ð¼ÐµÐ±ÐµÐ»Ð¸',0),(370483,10292,'ur','Ù„Ø§Ú¯Øª Ú©Ø§ ÙØ±Ù†ÛŒÚ†Ø±',0),(370484,10292,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð½Ð°Ð¼ÐµÑˆÑ‚Ð°Ñ˜',0),(370485,10292,'vi','chi phÃ­ Ä‘á»“ dÃ¹ng',0),(370486,10292,'af','Koste Meubels',0),(370487,10292,'ro','Mobilier cost',0),(370488,10292,'et','Kulu mÃ¶Ã¶bel',0),(370489,10292,'si','Ceno pohiÅ¡tva',0),(370490,10292,'ba','Biaya Furniture',0),(370491,10292,'nl','Kosten meubilair',0),(370492,10292,'fi','Kustannusten huonekalut',0),(370493,10292,'no','Kostnader mÃ¸bler',0),(370494,10292,'da','Omkostninger mÃ¸bler',0),(370495,10292,'ko','ë¹„ìš©ëœ ê°€êµ¬',0),(370496,10292,'he','×¢×œ×•×ª ×¨×™×”×•×˜',0),(370497,10292,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î­Ï€Î¹Ï€Î»Î±',0),(370498,10292,'zh','å®¶å…·æˆæœ¬\r\n',0),(370499,10292,'sv','Kostnad mÃ¶bler',0),(370500,10292,'it','Costo mobili',0),(370501,10292,'tl','',0),(370502,10292,'th','à¹€à¸Ÿà¸­à¸£à¹Œà¸™à¸´à¹€à¸ˆà¸­à¸£à¹Œà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(370503,10292,'hi','à¤²à¤¾à¤—à¤¤ à¤«à¤°à¥à¤¨à¥€à¤šà¤°',0),(370504,10292,'ms','Kos perabot',0),(370505,10292,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ø£Ø«Ø§Ø«',0),(370506,10292,'fr','CoÃ»t des meubles',0),(370507,10292,'jp','ã‚³ã‚¹ãƒˆã®å®¶å…·',0),(370508,10292,'pt','Custo da mobÃ­lia',0),(370509,10292,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¼ÐµÐ±ÐµÐ»Ð¸',0),(370510,10292,'es','Costo de Muebles',0),(370511,10292,'de','Kosten MÃ¶bel',0),(370512,10292,'en','Cost Furniture',0),(370513,10293,'is','',0),(370514,10293,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¹Ù…ÙˆÙ…ÙŠ',0),(370515,10293,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¹Ù…ÙˆÙ…ÙŠ',0),(370516,10293,'tr','Maliyet genel',0),(370517,10293,'pl','Koszty ogÃ³lne',0),(370518,10293,'bg','ÐžÐ±Ñ‰Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(370519,10293,'ur','Ù„Ø§Ú¯Øª Ø¬Ù†Ø±Ù„',0),(370520,10293,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(370521,10293,'vi','chi phsi chung',0),(370522,10293,'af','Koste Algemeen',0),(370523,10293,'ro','Costul General',0),(370524,10293,'et','Kulude Ã¼ldise',0),(370525,10293,'si','SploÅ¡ni stroÅ¡ki',0),(370526,10293,'ba','Biaya Umum',0),(370527,10293,'nl','Algemene kosten',0),(370528,10293,'fi','Kustannusten yleinen',0),(370529,10293,'no','Kostnaden generelt',0),(370530,10293,'da','Udgifter generelt',0),(370531,10293,'ko','ë¹„ìš© ì¼ë°˜',0),(370532,10293,'he','×¢×œ×•×ª ×›×œ×œ×™×ª',0),(370533,10293,'el','Î“ÎµÎ½Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(370534,10293,'zh','æ€»æˆæœ¬\r\n',0),(370535,10293,'sv','Kostnad allmÃ¤nna',0),(370536,10293,'it','Costo generale',0),(370537,10293,'tl','',0),(370538,10293,'th','à¸—à¸¸à¸™à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(370539,10293,'hi','à¤²à¤¾à¤—à¤¤ à¤œà¤¨à¤°à¤²',0),(370540,10293,'ms','Kos umum',0),(370541,10293,'ar','Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø¹Ø§Ù…Ø©',0),(370542,10293,'fr','CoÃ»t gÃ©nÃ©ral',0),(370543,10293,'jp','ã‚³ã‚¹ãƒˆå…¨èˆ¬',0),(370544,10293,'pt','Custo geral',0),(370545,10293,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹',0),(370546,10293,'es','Costo General',0),(370547,10293,'de','Kosten allgemein',0),(370548,10293,'en','Cost General',0),(370549,10294,'is','',0),(370550,10294,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨Ù‰ Ùˆ ØªÙˆØ²ÙŠØ¹',0),(370551,10294,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨Ù‰ Ùˆ ØªÙˆØ²ÙŠØ¹',0),(370552,10294,'tr','Maliyet Pazarlama',0),(370553,10294,'pl','KosztÃ³w marketingu',0),(370554,10294,'bg','Ð¦ÐµÐ½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²Ð¸Ñ',0),(370555,10294,'ur','Ù…Ø§Ø±Ú©ÛŒÙ¹Ù†Ú¯ Ú©ÛŒ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(370556,10294,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¼Ð°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³Ð°',0),(370557,10294,'vi','chi phÃ­ thá»‹ trÆ°á»ng',0),(370558,10294,'af','Koste bemarking',0),(370559,10294,'ro','Costul de Marketing',0),(370560,10294,'et','Kulude turundus',0),(370561,10294,'si','StroÅ¡ki trÅ¾enja',0),(370562,10294,'ba','Biaya pemasaran',0),(370563,10294,'nl','Kosten Marketing',0),(370564,10294,'fi','Kustannukset markkinointi',0),(370565,10294,'no','Koste markedsfÃ¸ring',0),(370566,10294,'da','Koste markedsfÃ¸ring',0),(370567,10294,'ko','ë§ˆì¼€íŒ… ë¹„ìš©',0),(370568,10294,'he','×¢×œ×•×ª ×©×™×•×•×§',0),(370569,10294,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î¼Î¬ÏÎºÎµÏ„Î¹Î½Î³Îº',0),(370570,10294,'zh','è¥é”€æˆæœ¬\r\n',0),(370571,10294,'sv','Kostnad marknadsfÃ¶ring',0),(370572,10294,'it','Costi di Marketing',0),(370573,10294,'tl','',0),(370574,10294,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸à¸²à¸£à¸•à¸¥à¸²à¸”',0),(370575,10294,'hi','à¤µà¤¿à¤ªà¤£à¤¨ à¤²à¤¾à¤—à¤¤',0),(370576,10294,'ms','Kos pemasaran',0),(370577,10294,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„ØªØ³ÙˆÙŠÙ‚',0),(370578,10294,'fr','CoÃ»t de commercialisation',0),(370579,10294,'jp','ãƒžãƒ¼ã‚±ãƒ†ã‚£ãƒ³ã‚° ã‚³ã‚¹ãƒˆã—ã¾ã™ã€‚',0),(370580,10294,'pt','Custo de Marketing',0),(370581,10294,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¼Ð°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³',0),(370582,10294,'es','Costo de Mercadotecnia',0),(370583,10294,'de','Cost-Marketing',0),(370584,10294,'en','Cost Marketing',0),(370585,10295,'is','',0),(370586,10295,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ ',0),(370587,10295,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ ',0),(370588,10295,'tr','Tahmini bitiÅŸ tarihi',0),(370589,10295,'pl','Szacowana data zakoÅ„czenia',0),(370590,10295,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð° ÐºÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(370591,10295,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ú©Ø§ Ø§Ù†Ø¯Ø§Ø²Û Ù„Ú¯Ø§ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(370592,10295,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(370593,10295,'vi','Æ¯á»›c tÃ­nh ngÃ y káº¿t thÃºc',0),(370594,10295,'af','Geskatte End Datum',0),(370595,10295,'ro','Data de sfÃ¢rÅŸit a estimat',0),(370596,10295,'et','Eeldatav lÃµppkuupÃ¤ev',0),(370597,10295,'si','Ocenjeni konÄni datum',0),(370598,10295,'ba','Perkiraan tanggal akhir',0),(370599,10295,'nl','Geschatte einddatum',0),(370600,10295,'fi','Arvioitu pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(370601,10295,'no','AnslÃ¥tt avslutningsdato',0),(370602,10295,'da','AnslÃ¥et slutdato',0),(370603,10295,'ko','ì˜ˆìƒ ì¢…ë£Œì¼',0),(370604,10295,'he','×ª××¨×™×š ×¡×™×•× ×ž×©×•×¢×¨',0),(370605,10295,'el','Î•ÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(370606,10295,'zh','é¢„è®¡ç»“æŸæ—¥æœŸ\r\n',0),(370607,10295,'sv','BerÃ¤knat slutdatum',0),(370608,10295,'it','Data di fine stimata',0),(370609,10295,'tl','',0),(370610,10295,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¹‚à¸”à¸¢à¸›à¸£à¸°à¸¡à¸²à¸“',0),(370611,10295,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(370612,10295,'ms','Anggaran tarikh akhir',0),(370613,10295,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ù‚Ø¯Ø±',0),(370614,10295,'fr','Date de fin prÃ©vue',0),(370615,10295,'jp','çµ‚äº†æ—¥ã®è¦‹ç©ã‚‚ã‚Š',0),(370616,10295,'pt','Data de fim prevista',0),(370617,10295,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð´Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(370618,10295,'es','Fecha de TerminaciÃ³n Estimada',0),(370619,10295,'de','Voraussichtlicher Termin Ende',0),(370620,10295,'en','Estimated End Date',0),(370621,10296,'is','',0),(370622,10296,'dr','ØªØ§Ø±ÙŠØ® ÙƒÙ„Ù†Ú¯ Ø²Ù†ÙŠ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(370623,10296,'pr','ØªØ§Ø±ÙŠØ® ÙƒÙ„Ù†Ú¯ Ø²Ù†ÙŠ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(370624,10296,'tr','Tahmini Ã§Ä±ÄŸÄ±r aÃ§an tarihi',0),(370625,10296,'pl','Przewidywana data przeÅ‚omowa',0),(370626,10296,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ‚Ð° Ð½Ð¾Ð²Ð°Ñ‚Ð¾Ñ€ÑÐºÐ¸ Ð´Ð°Ñ‚Ð°',0),(370627,10296,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø§ÙˆÙ„ÛŒÙ† ØªØ§Ø±ÛŒØ®',0),(370628,10296,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ñ€ÐµÐ²Ð¾Ð»ÑƒÑ†Ð¸Ð¾Ð½Ð°Ñ€Ð½Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼',0),(370629,10296,'vi','Æ¯á»›c tÃ­nh ngÃ y táº¡m dá»«ng',0),(370630,10296,'af','Geskatte Aanvoringsdatum',0),(370631,10296,'ro','Data estimatÄƒ inovatoare',0),(370632,10296,'et','Oletatava murrangulise',0),(370633,10296,'si','Predvideni datum prelomni',0),(370634,10296,'ba','Perkiraan tanggal inovatif',0),(370635,10296,'nl','Geschatte baanbrekende datum',0),(370636,10296,'fi','Uraauurtava laskettua',0),(370637,10296,'no','AnslÃ¥tt banebrytende dato',0),(370638,10296,'da','AnslÃ¥et banebrydende dato',0),(370639,10296,'ko','ì˜ˆìƒëœ íšê¸°ì ì¸ ë‚ ì§œ',0),(370640,10296,'he','×ª××¨×™×š ×ž×©×•×¢×¨ ×¤×•×¨×¦×ª ×“×¨×š',0),(370641,10296,'el','Î•ÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€ÏÏ‰Ï„Î¿Ï€Î¿ÏÎ¹Î±ÎºÎ®',0),(370642,10296,'zh','é¢„è®¡å¼€å·¥æ—¶é—´\r\n',0),(370643,10296,'sv','BerÃ¤knade banbrytande datum',0),(370644,10296,'it','Innovativa data stimata',0),(370645,10296,'tl','',0),(370646,10296,'th','à¸›à¸£à¸°à¸¡à¸²à¸“à¸§à¸±à¸™à¹ƒà¸«à¸¡à¹ˆà¹€à¸­à¸µà¹ˆà¸¢à¸¡',0),(370647,10296,'hi','Groundbreaking à¤¤à¤¿à¤¥à¤¿ à¤•à¤¾ à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(370648,10296,'ms','Anggaran tarikh pecah tanah',0),(370649,10296,'ar','ØªØ§Ø±ÙŠØ® ÙˆØ¶Ø¹ Ø­Ø¬Ø± Ø§Ù„Ø£Ø³Ø§Ø³ Ø§Ù„Ù…Ù‚Ø¯Ø±',0),(370650,10296,'fr','Date estimÃ©e de rÃ©volutionnaire',0),(370651,10296,'jp','ç”»æœŸçš„ãªæ—¥ä»˜ã®æŽ¨å®š',0),(370652,10296,'pt','Data estimada de inovador',0),(370653,10296,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð´Ð°Ñ‚Ð° Ñ€ÐµÐ²Ð¾Ð»ÑŽÑ†Ð¸Ð¾Ð½Ð½Ð¾Ð¹',0),(370654,10296,'es','Fecha de Comienzo De ConstrucciÃ³n Estimada',0),(370655,10296,'de','Voraussichtlicher Termin der bahnbrechenden',0),(370656,10296,'en','Estimated Groundbreaking Date',0),(370657,10297,'is','',0),(370658,10297,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ØªØ®Ù…ÙŠÙ†ÙŠ',0),(370659,10297,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ ØªØ®Ù…ÙŠÙ†ÙŠ',0),(370660,10297,'tr','Tahmini BaÅŸlangÄ±Ã§ tarihi',0),(370661,10297,'pl','Data rozpoczÄ™cia szacowany',0),(370662,10297,'bg','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°Ð½Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(370663,10297,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØªØ§Ø±ÛŒØ®',0),(370664,10297,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð¿Ð¾Ñ‡ÐµÑ‚Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(370665,10297,'vi','Æ¯á»›c tÃ­nh ngÃ y báº¯t Ä‘áº§u',0),(370666,10297,'af','Geskatte Begindatum',0),(370667,10297,'ro','Data de Ã®nceput estimatÄƒ',0),(370668,10297,'et','Hinnanguline alguskuupÃ¤ev',0),(370669,10297,'si','Ocenjena zaÄetni datum',0),(370670,10297,'ba','Tanggal perkiraan awal',0),(370671,10297,'nl','Geschatte begindatum',0),(370672,10297,'fi','Arvioitu aloituspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(370673,10297,'no','AnslÃ¥tt dato',0),(370674,10297,'da','AnslÃ¥et startdato',0),(370675,10297,'ko','ì˜ˆìƒëœ ì‹œìž‘ ë‚ ì§œ',0),(370676,10297,'he','×ª××¨×™×š ×”×ª×—×œ×” ×ž×©×•×¢×¨',0),(370677,10297,'el','Î•ÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î•ÎÎ‘Î¡ÎžÎ—',0),(370678,10297,'zh','é¢„è®¡å¼€å§‹æ—¥æœŸ\r\n',0),(370679,10297,'sv','BerÃ¤knat startdatum',0),(370680,10297,'it','Data di inizio prevista',0),(370681,10297,'tl','',0),(370682,10297,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹‚à¸”à¸¢à¸›à¸£à¸°à¸¡à¸²à¸“',0),(370683,10297,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(370684,10297,'ms','Tarikh mula anggaran',0),(370685,10297,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡ Ø§Ù„Ù…Ù‚Ø¯Ø±Ø©',0),(370686,10297,'fr','Date de dÃ©part estimÃ©e',0),(370687,10297,'jp','é–‹å§‹äºˆå®šæ—¥',0),(370688,10297,'pt','Data de inÃ­cio estimado',0),(370689,10297,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(370690,10297,'es','Fecha de Comienzo Estimada',0),(370691,10297,'de','Voraussichtlicher Start-Datum',0),(370692,10297,'en','Estimated Start Date',0),(370693,10298,'is','',0),(370694,10298,'dr','Ø§Ø±Ø²Ø´ Ù…ØªØ¹Ø§Ø±Ù Ø¨Ø§Ø²Ø§Ø±',0),(370695,10298,'pr','Ø§Ø±Ø²Ø´ Ù…ØªØ¹Ø§Ø±Ù Ø¨Ø§Ø²Ø§Ø±',0),(370696,10298,'tr','Adil piyasa deÄŸeri',0),(370697,10298,'pl','WartoÅ›ci rynkowej',0),(370698,10298,'bg','Ð¡Ð¿Ñ€Ð°Ð²ÐµÐ´Ð»Ð¸Ð²Ð°Ñ‚Ð° Ð¿Ð°Ð·Ð°Ñ€Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(370699,10298,'ur','Ù…Ù†ØµÙØ§Ù†Û Ù…Ø§Ø±Ú©ÛŒÙ¹ Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(370700,10298,'sr','Ð¤ÐµÑ€ Ñ‚Ñ€Ð¶Ð¸ÑˆÐ½Ñƒ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(370701,10298,'vi','báº±ng giÃ¡ thá»‹ trÆ°á»ng',0),(370702,10298,'af','Redelike Markwaarde',0),(370703,10298,'ro','Valoarea de piaÅ£Äƒ echitabil',0),(370704,10298,'et','Ã•iglase turuvÃ¤Ã¤rtuse',0),(370705,10298,'si','PoÅ¡tene trÅ¾ne vrednosti',0),(370706,10298,'ba','Nilai pasar wajar',0),(370707,10298,'nl','Marktwaarde',0),(370708,10298,'fi','KÃ¤ypÃ¤ arvo',0),(370709,10298,'no','Markedsverdi',0),(370710,10298,'da','Fair markedsvÃ¦rdi',0),(370711,10298,'ko','ê³µì •í•œ ì‹œìž¥ ê°€ì¹˜',0),(370712,10298,'he','×¢×¨×š ×©×•×§ ×”×•×’×Ÿ',0),(370713,10298,'el','Î•ÏÎ»Î¿Î³Î· Î±Î¾Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(370714,10298,'zh','åˆç†çš„å¸‚åœºä»·å€¼\r\n',0),(370715,10298,'sv','MarknadsvÃ¤rdet',0),(370716,10298,'it','Valore equo di mercato',0),(370717,10298,'tl','',0),(370718,10298,'th','à¸¡à¸¹à¸¥à¸„à¹ˆà¸²à¸•à¸¥à¸²à¸”à¸—à¸µà¹ˆà¸¢à¸¸à¸•à¸´à¸˜à¸£à¸£à¸¡',0),(370719,10298,'hi','à¤‰à¤šà¤¿à¤¤ à¤¬à¤¾à¤œà¤¾à¤° à¤®à¥‚à¤²à¥à¤¯',0),(370720,10298,'ms','Nilai pasaran yang saksama',0),(370721,10298,'ar','Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ø³ÙˆÙ‚ÙŠØ© Ø§Ù„Ø¹Ø§Ø¯Ù„Ø©',0),(370722,10298,'fr','Juste valeur marchande',0),(370723,10298,'jp','å…¬æ­£ãªå¸‚å ´ä¾¡å€¤',0),(370724,10298,'pt','Justo valor de mercado',0),(370725,10298,'ru','Ð¡Ð¿Ñ€Ð°Ð²ÐµÐ´Ð»Ð¸Ð²Ð¾Ð¹ Ñ€Ñ‹Ð½Ð¾Ñ‡Ð½Ð¾Ð¹ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸',0),(370726,10298,'es','Valor Justo del Mercado',0),(370727,10298,'de','Verkehrswert',0),(370728,10298,'en','Fair Market Value',0),(370729,10299,'is','',0),(370730,10299,'dr','( Ø¨Ø§Ø²Ø§Ø± ',0),(370731,10299,'pr','Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ù‚Ø§Ø¨Ù„ Ø§Ø¬Ø±Ø§ÙŠ ÙØ±ÙˆØ´ ( Ø¨Ø§Ø²Ø§Ø± ',0),(370732,10299,'tr','Fizibilite Ã§arÅŸÄ± planlarÄ±',0),(370733,10299,'pl','WykonalnoÅ›ci rynku plany',0),(370734,10299,'bg','ÐžÑÑŠÑ‰ÐµÑÑ‚Ð²Ð¸Ð¼Ð¾ÑÑ‚ Ð¿Ð°Ð·Ð°Ñ€ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(370735,10299,'ur','Ø³Ú¾Ù„ Ù…Ø§Ø±Ú©ÛŒÙ¹ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(370736,10299,'sr','Ð¡Ñ‚ÑƒÐ´Ð¸Ñ˜Ðµ Ð¸Ð·Ð²Ð¾Ð´Ñ™Ð¸Ð²Ð¾ÑÑ‚Ð¸ Ñ‚Ñ€Ð¶Ð¸ÑˆÑ‚Ñƒ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(370737,10299,'vi','Káº¿ hoáº¡ch thá»‹ trÆ°á»ng cÃ³ tÃ­nh kháº£ thi',0),(370738,10299,'af','Haalbaarheid mark planne',0),(370739,10299,'ro','Planurile de piaÅ£Äƒ fezabilitate',0),(370740,10299,'et','Teostatavus turu plaanid',0),(370741,10299,'si','Izvedljivosti trÅ¾nih naÄrtov',0),(370742,10299,'ba','Kelayakan pasar rencana',0),(370743,10299,'nl','Haalbaarheid markt plannen',0),(370744,10299,'fi','Toteutettavuus markkinoilla suunnitelmia',0),(370745,10299,'no','GjennomfÃ¸rbarhet markedet planer',0),(370746,10299,'da','Feasibility marked planer',0),(370747,10299,'ko','íƒ€ë‹¹ì„± ì‹œìž¥ ê³„íš',0),(370748,10299,'he','×”×™×ª×›× ×•×ª ×©×•×§ ×ª×•×›× ×™×•×ª',0),(370749,10299,'el','Î‘Î³Î¿ÏÎ¬ ÏƒÏ‡ÎµÎ´Î¯Ï‰Î½ ÎµÏ†Î¹ÎºÏ„ÏŒÏ„Î·Ï„Î±Ï‚',0),(370750,10299,'zh','å¸‚åœºè®¡åˆ’çš„å¯è¡Œæ€§\r\n',0),(370751,10299,'sv','GenomfÃ¶rbarhet marknaden planer',0),(370752,10299,'it','Piani di fattibilitÃ  mercato',0),(370753,10299,'tl','',0),(370754,10299,'th','à¹à¸œà¸™à¸à¸²à¸£à¸•à¸¥à¸²à¸”à¹‚à¸„à¸£à¸‡à¸à¸²à¸£',0),(370755,10299,'hi','à¤µà¥à¤¯à¤µà¤¹à¤¾à¤°à¥à¤¯à¤¤à¤¾ à¤¬à¤¾à¤œà¤¾à¤° à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(370756,10299,'ms','Kemungkinan pasaran pelan',0),(370757,10299,'ar','Ø®Ø·Ø· Ø§Ù„Ø³ÙˆÙ‚ Ø§Ù„Ø¬Ø¯ÙˆÙ‰',0),(370758,10299,'fr','Plans de marchÃ© faisabilitÃ©',0),(370759,10299,'jp','å¯èƒ½æ€§ã®å¸‚å ´è¨ˆç”»',0),(370760,10299,'pt','Planos de mercado de viabilidade',0),(370761,10299,'ru','Ð’Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ÑÑ‚Ð¸ Ñ€Ñ‹Ð½ÐºÐ° Ð¿Ð»Ð°Ð½Ñ‹',0),(370762,10299,'es','Viabilidad Planes de Mercado',0),(370763,10299,'de','Machbarkeit Markt PlÃ¤ne',0),(370764,10299,'en','Feasibility Market Plans',0),(370765,10300,'is','',0),(370766,10300,'dr','Ø§Ù…ÙƒØ§Ù† Ù…Ø·Ø§Ù„Ø¹Ù‡ ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ø²Ø§Ø±',0),(370767,10300,'pr','Ø§Ù…ÙƒØ§Ù† Ù…Ø·Ø§Ù„Ø¹Ù‡ ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ø²Ø§Ø±',0),(370768,10300,'tr','Fizibilite Pazar araÅŸtÄ±rmasÄ±',0),(370769,10300,'pl','MoÅ¼liwoÅ›ci badania rynku',0),(370770,10300,'bg','ÐŸÑ€ÐµÐ´Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð½Ð¾ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð°Ð·Ð°Ñ€Ð°',0),(370771,10300,'ur','Ø³Ú¾Ù„ Ù…Ø§Ø±Ú©ÛŒÙ¹ Ø±ÛŒØ³Ø±Ú†',0),(370772,10300,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ñ‚Ñ€Ð¶Ð¸ÑˆÑ‚Ð° ÑÑ‚ÑƒÐ´Ð¸Ñ˜Ðµ Ð¸Ð·Ð²Ð¾Ð´Ñ™Ð¸Ð²Ð¾ÑÑ‚Ð¸',0),(370773,10300,'vi','nghiÃªn cá»©u thá»‹ trÆ°á»ng kháº£ thi',0),(370774,10300,'af','Haalbaarheid marknavorsing',0),(370775,10300,'ro','Fezabilitatea de cercetare de piaÅ£Äƒ',0),(370776,10300,'et','Teostatavus turu-uuringud',0),(370777,10300,'si','Izvedljivosti trÅ¾ne raziskave',0),(370778,10300,'ba','Riset pasar kelayakan',0),(370779,10300,'nl','Haalbaarheid marktonderzoek',0),(370780,10300,'fi','Toteutettavuus Market Research',0),(370781,10300,'no','GjennomfÃ¸rbarhet markedsundersÃ¸kelser',0),(370782,10300,'da','Feasibility markedsundersÃ¸gelser',0),(370783,10300,'ko','íƒ€ë‹¹ì„± ì‹œìž¥ ì¡°ì‚¬',0),(370784,10300,'he','×ž×—×§×¨ ×©×•×§ ×”×™×ª×›× ×•×ª',0),(370785,10300,'el','ÎˆÏÎµÏ…Î½Î± Î±Î³Î¿ÏÎ¬Ï‚ ÏƒÎºÎ¿Ï€Î¹Î¼ÏŒÏ„Î·Ï„Î±Ï‚',0),(370786,10300,'zh','å¸‚åœºå¯è¡Œæ€§ç ”ç©¶\r\n',0),(370787,10300,'sv','GenomfÃ¶rbarhet marknadsundersÃ¶kningar',0),(370788,10300,'it','Ricerche di mercato di fattibilitÃ ',0),(370789,10300,'tl','',0),(370790,10300,'th','à¸§à¸´à¸ˆà¸±à¸¢à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹„à¸›à¹„à¸”à¹‰',0),(370791,10300,'hi','à¤µà¥à¤¯à¤µà¤¹à¤¾à¤°à¥à¤¯à¤¤à¤¾ à¤¬à¤¾à¤œà¤¾à¤° à¤…à¤¨à¥à¤¸à¤‚à¤§à¤¾à¤¨',0),(370792,10300,'ms','Kemungkinan penyelidikan pasaran',0),(370793,10300,'ar','Ø§Ù„Ø¬Ø¯ÙˆÙ‰ ÙˆØ¨Ø­ÙˆØ« Ø§Ù„Ø³ÙˆÙ‚',0),(370794,10300,'fr','Etudes de faisabilitÃ©',0),(370795,10300,'jp','å¸‚å ´ç ”ç©¶ã®å¯èƒ½æ€§',0),(370796,10300,'pt','Pesquisa de mercado de viabilidade',0),(370797,10300,'ru','Ð¦ÐµÐ»ÐµÑÐ¾Ð¾Ð±Ñ€Ð°Ð·Ð½Ð¾ÑÑ‚ÑŒ Ð¸ÑÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ€Ñ‹Ð½ÐºÐ°',0),(370798,10300,'es','Viabilidad InvestigaciÃ³n de Mercadotecnia',0),(370799,10300,'de','Machbarkeit-Marktforschung',0),(370800,10300,'en','Feasibility Market Research',0),(370801,10301,'is','',0),(370802,10301,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ø§Ù„ÙŠ ',0),(370803,10301,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ø§Ù„ÙŠ ',0),(370804,10301,'tr','Mali isteÄŸi',0),(370805,10301,'pl','Å»Ä…dania finansowe',0),(370806,10301,'bg','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð¸ Ð·Ð°ÑÐ²ÐºÐ°',0),(370807,10301,'ur','Ù…Ø§Ù„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(370808,10301,'sr','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¸Ñ˜ÑÐºÐ¸ Ð·Ð°Ñ…Ñ‚ÐµÐ²',0),(370809,10301,'vi','Ä‘á» nghá»‹ tÃ i chÃ­nh',0),(370810,10301,'af','FinansiÃ«le versoek',0),(370811,10301,'ro','Cerere financiare',0),(370812,10301,'et','Rahalise taotluse',0),(370813,10301,'si','FinanÄne zahteve',0),(370814,10301,'ba','Permintaan keuangan',0),(370815,10301,'nl','FinanciÃ«le verzoek',0),(370816,10301,'fi','RahoituspyyntÃ¶ihin',0),(370817,10301,'no','Finansielle forespÃ¸rsel',0),(370818,10301,'da','Finansielle anmodning',0),(370819,10301,'ko','ê¸ˆìœµ ìš”ì²­',0),(370820,10301,'he','×‘×§×©×” ×¤×™× × ×¡×™',0),(370821,10301,'el','ÎŸÎ¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÎ® Î±Î¯Ï„Î·ÏƒÎ·',0),(370822,10301,'zh','è´¢æ”¿è¯·æ±‚\r\n',0),(370823,10301,'sv','Finansiella begÃ¤ran',0),(370824,10301,'it','Richiesta finanziaria',0),(370825,10301,'tl','',0),(370826,10301,'th','à¸‚à¸­à¹€à¸‡à¸´à¸™',0),(370827,10301,'hi','à¤µà¤¿à¤¤à¥à¤¤à¥€à¤¯ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(370828,10301,'ms','Permintaan kewangan',0),(370829,10301,'ar','Ø·Ù„Ø¨ Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(370830,10301,'fr','Demande financiÃ¨re',0),(370831,10301,'jp','ãƒ•ã‚¡ã‚¤ãƒŠãƒ³ã‚·ãƒ£ãƒ«è¦æ±‚',0),(370832,10301,'pt','SolicitaÃ§Ã£o financeira',0),(370833,10301,'ru','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð·Ð°Ð¿Ñ€Ð¾Ñ',0),(370834,10301,'es','SolicitaciÃ³n Financiero',0),(370835,10301,'de','Finanzielle Anfrage',0),(370836,10301,'en','Financial Request',0),(370837,10302,'is','',0),(370838,10302,'dr','Ø¨Ù‡Ø³Ø§Ø²ÙŠ Ù‡Ø§ ',0),(370839,10302,'pr','Ø¨Ù‡Ø³Ø§Ø²ÙŠ Ù‡Ø§ ',0),(370840,10302,'tr','Ä°yileÅŸtirmeler',0),(370841,10302,'pl','Ulepszenia',0),(370842,10302,'bg','ÐŸÐ¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ',0),(370843,10302,'ur','Ø¨ÛØªØ±ÛŒ',0),(370844,10302,'sr','ÐŸÐ¾Ð±Ð¾Ñ™ÑˆÐ°ÑšÐ°',0),(370845,10302,'vi','Sá»± tiáº¿n bá»™',0),(370846,10302,'af','Verbeteringe',0),(370847,10302,'ro','ÃŽmbunÄƒtÄƒÅ£iri',0),(370848,10302,'et','Parandused',0),(370849,10302,'si','IzboljÅ¡ave',0),(370850,10302,'ba','Perbaikan',0),(370851,10302,'nl','Verbeteringen',0),(370852,10302,'fi','Parannuksia',0),(370853,10302,'no','Forbedringer',0),(370854,10302,'da','Forbedringer',0),(370855,10302,'ko','í–¥ìƒ ëœ ê¸°ëŠ¥',0),(370856,10302,'he','×©×™×¤×•×¨×™×',0),(370857,10302,'el','Î’ÎµÎ»Ï„Î¹ÏŽÏƒÎµÎ¹Ï‚',0),(370858,10302,'zh','æ”¹è¿›\r\n',0),(370859,10302,'sv','FÃ¶rbÃ¤ttringar',0),(370860,10302,'it','Miglioramenti',0),(370861,10302,'tl','',0),(370862,10302,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(370863,10302,'hi','à¤¸à¥à¤§à¤¾à¤°',0),(370864,10302,'ms','Penambahbaikan',0),(370865,10302,'ar','ØªØ­Ø³ÙŠÙ†Ø§Øª',0),(370866,10302,'fr','AmÃ©liorations',0),(370867,10302,'jp','æ”¹å–„',0),(370868,10302,'pt','Melhorias',0),(370869,10302,'ru','Ð£Ð»ÑƒÑ‡ÑˆÐµÐ½Ð¸Ñ',0),(370870,10302,'es','Mejoras',0),(370871,10302,'de','Verbesserungen',0),(370872,10302,'en','Improvements',0),(370873,10303,'is','',0),(370874,10303,'dr','Ø¨Ù‡Ø³Ø§Ø²ÙŠ â€“ Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø³Ø§Ø²ÙŠ ',0),(370875,10303,'pr','Ø¨Ù‡Ø³Ø§Ø²ÙŠ â€“ Ø·Ø±Ø­ Ù‡Ø§ÙŠ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø³Ø§Ø²ÙŠ ',0),(370876,10303,'tr','GeliÅŸmeler - Bina planlarÄ±',0),(370877,10303,'pl','Ulepszenia - plany budowy',0),(370878,10303,'bg','ÐŸÐ¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ - ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ',0),(370879,10303,'ur','Ø¨ÛØªØ±ÛŒ - Ø¹Ù…Ø§Ø±Øª Ú©Û’ Ù…Ù†ØµÙˆØ¨Û’',0),(370880,10303,'sr','ÐŸÐ¾Ð±Ð¾Ñ™ÑˆÐ°ÑšÐ° - Ð¿Ð»Ð°Ð½Ð¾Ð²Ð¸ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(370881,10303,'vi','Sá»± cáº£i tiá»n- káº¿ hoáº¡ch xÃ¢y dá»±ng',0),(370882,10303,'af','Verbeteringe - Bou Planne',0),(370883,10303,'ro','ÃŽmbunÄƒtÄƒÅ£iri - planuri de construcÅ£ie',0),(370884,10303,'et','Parandused - hoone plaanid',0),(370885,10303,'si','IzboljÅ¡ave - gradbenih naÄrtov',0),(370886,10303,'ba','Perbaikan - rencana bangunan',0),(370887,10303,'nl','Verbeteringen - plannen van de bouw',0),(370888,10303,'fi','Parannuksia - rakennussuunnitelmat',0),(370889,10303,'no','Forbedringer - byggeplaner',0),(370890,10303,'da','Forbedringer - byggeplaner',0),(370891,10303,'ko','ê°œì„ -ê±´ë¬¼ ê³„íš',0),(370892,10303,'he','×©×™×¤×•×¨×™× - ×ª×•×›× ×™×•×ª ×‘× ×™×™×Ÿ',0),(370893,10303,'el','Î’ÎµÎ»Ï„Î¹ÏŽÏƒÎµÎ¹Ï‚ - ÏƒÏ‡Î­Î´Î¹Î± Î¿Î¹ÎºÎ¿Î´ÏŒÎ¼Î·ÏƒÎ·Ï‚',0),(370894,10303,'zh','æ”¹è¿› -å»ºç­‘è®¡åˆ’\r\n',0),(370895,10303,'sv','FÃ¶rbÃ¤ttringar - byggplaner',0),(370896,10303,'it','Miglioramenti - piani di costruzione',0),(370897,10303,'tl','',0),(370898,10303,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡ - à¹à¸œà¸™à¸­à¸²à¸„à¸²à¸£',0),(370899,10303,'hi','à¤¸à¥à¤§à¤¾à¤° - à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(370900,10303,'ms','Penambahbaikan - pelan-pelan bangunan',0),(370901,10303,'ar','Ø§Ù„ØªØ­Ø³ÙŠÙ†Ø§Øª-Ø®Ø·Ø· Ø¨Ù†Ø§Ø¡',0),(370902,10303,'fr','AmÃ©liorations - Plans de construction',0),(370903,10303,'jp','æ”¹å–„å»ºç‰©ã®è¨ˆç”»',0),(370904,10303,'pt','Melhorias - planos de construÃ§Ã£o',0),(370905,10303,'ru','Ð£Ð»ÑƒÑ‡ÑˆÐµÐ½Ð¸Ñ - Ð¿Ð»Ð°Ð½Ñ‹ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(370906,10303,'es','Mejoras - Planes de Edificios',0),(370907,10303,'de','Verbesserungen - BauplÃ¤ne',0),(370908,10303,'en','Improvements - Building Plans',0),(370909,10304,'is','',0),(370910,10304,'dr','- ØªÙØµÛŒÙ„  Ø¹Ø¨Ø§Ø±Ø§Øª',0),(370911,10304,'pr','Ø¨Ù‡Ø³Ø§Ø²ÙŠ- Ø´Ø±Ø­ Ø¹Ø¨Ø§Ø±Ø§Øª',0),(370912,10304,'tr','GeliÅŸmeler - aÅŸama aÃ§Ä±klamasÄ±',0),(370913,10304,'pl','Ulepszenia - opis faz',0),(370914,10304,'bg','ÐŸÐ¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ - Ñ„Ð°Ð·Ð¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(370915,10304,'ur','Ø¨ÛØªØ±ÛŒ - Ù…Ø±Ø§Ø­Ù„ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(370916,10304,'sr','ÐŸÐ¾Ð±Ð¾Ñ™ÑˆÐ°ÑšÐ° - Ð¾Ð¿Ð¸Ñ Ñ„Ð°Ð·Ðµ',0),(370917,10304,'vi','Sá»± cáº£i tiáº¿n- mÃ´ táº£ giai Ä‘oáº¡n',0),(370918,10304,'af','Verbeterings - fases Beskrywing',0),(370919,10304,'ro','ÃŽmbunÄƒtÄƒÅ£iri - faze Descriere',0),(370920,10304,'et','Paranemine - faasi kirjeldus',0),(370921,10304,'si','IzboljÅ¡ave - opis faz',0),(370922,10304,'ba','Perbaikan - fase Deskripsi',0),(370923,10304,'nl','Verbeteringen - fasen beschrijving',0),(370924,10304,'fi','Parannuksia - vaiheiden kuvaus',0),(370925,10304,'no','Forbedringer - fasene beskrivelse',0),(370926,10304,'da','Forbedringer - faser beskrivelse',0),(370927,10304,'ko','ê°œì„ -ë‹¨ê³„ ì„¤ëª…',0),(370928,10304,'he','×©×™×¤×•×¨×™× - ×ª×™××•×¨ ×©×œ×‘×™',0),(370929,10304,'el','Î’ÎµÎ»Ï„Î¹ÏŽÏƒÎµÎ¹Ï‚ - Ï†Î¬ÏƒÎµÎ¹Ï‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(370930,10304,'zh','æ”¹è¿› -é˜¶æ®µæè¿°\r\n',0),(370931,10304,'sv','FÃ¶rbÃ¤ttringar - faser Beskrivning',0),(370932,10304,'it','Miglioramenti - Descrizione fasi',0),(370933,10304,'tl','',0),(370934,10304,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡ - à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™',0),(370935,10304,'hi','à¤¸à¥à¤§à¤¾à¤° - à¤šà¤°à¤£à¥‹à¤‚ à¤•à¥‡ à¤µà¤¿à¤µà¤°à¤£',0),(370936,10304,'ms','Penambahbaikan - fasa penerangan',0),(370937,10304,'ar','Ø§Ù„ØªØ­Ø³ÙŠÙ†Ø§Øª--ÙˆØµÙ Ù…Ø±Ø§Ø­Ù„',0),(370938,10304,'fr','AmÃ©liorations - Description des Phases',0),(370939,10304,'jp','æ”¹å–„ãƒ•ã‚§ãƒ¼ã‚ºã®èª¬æ˜Ž',0),(370940,10304,'pt','Melhorias - descriÃ§Ã£o de fases',0),(370941,10304,'ru','Ð£Ð»ÑƒÑ‡ÑˆÐµÐ½Ð¸Ñ - Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑÑ‚Ð°Ð¿Ð¾Ð²',0),(370942,10304,'es','Mejoras - DescripciÃ³n de Etapas',0),(370943,10304,'de','Verbesserungen - Phasen Beschreibung',0),(370944,10304,'en','Improvements - Phases Description',0),(370945,10305,'is','',0),(370946,10305,'dr','- Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙŠ ',0),(370947,10305,'pr','Ø¨Ù‡Ø³Ø§Ø²ÙŠ- Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙŠ ',0),(370948,10305,'tr','GeliÅŸmeler - alÄ±nan Teklifler',0),(370949,10305,'pl','Ulepszenia - Cytaty otrzymaÅ‚',0),(370950,10305,'bg','ÐŸÐ¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ - Ð¾Ñ„ÐµÑ€Ñ‚Ð¸ Ð·Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸',0),(370951,10305,'ur','Ø¨ÛØªØ±ÛŒ - Ù‚ÛŒÙ…Øª ÙˆØµÙˆÙ„ Ú©ÛŒ',0),(370952,10305,'sr','ÐŸÐ¾Ð±Ð¾Ñ™ÑˆÐ°ÑšÐ° - Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ',0),(370953,10305,'vi','Sá»± cáº£i tiáº¿n- Nháº­n bÃ¡o giÃ¡',0),(370954,10305,'af','Verbeteringe - Kwotasies Ontvang',0),(370955,10305,'ro','ÃŽmbunÄƒtÄƒÅ£iri - citate primite',0),(370956,10305,'et','Parandused - laekunud hinnapakkumisi',0),(370957,10305,'si','IzboljÅ¡ave - ponudbe, prejete',0),(370958,10305,'ba','Perbaikan - kutipan yang diterima',0),(370959,10305,'nl','Verbeteringen - offertes ontvangen',0),(370960,10305,'fi','Parannuksia - lainauksia saaneet',0),(370961,10305,'no','Forbedringer - sitater mottatt',0),(370962,10305,'da','Forbedringer - tilbud modtages',0),(370963,10305,'ko','ê°œì„ -ê²¬ì  ì ‘ìˆ˜',0),(370964,10305,'he','×©×™×¤×•×¨×™× - ×”×¦×¢×•×ª ×”×ž×—×™×¨ ×©×”×ª×§×‘×œ×•',0),(370965,10305,'el','Î’ÎµÎ»Ï„Î¹ÏŽÏƒÎµÎ¹Ï‚ - Î±Ï€Î¿ÏƒÏ€Î¬ÏƒÎ¼Î±Ï„Î± Ï€Î¿Ï… Î­Î»Î±Î²Îµ',0),(370966,10305,'zh','æ”¹è¿› -æŠ¥ä»·æŽ¥æ”¶\r\n',0),(370967,10305,'sv','FÃ¶rbÃ¤ttringar - citat fick',0),(370968,10305,'it','Miglioramenti - citazioni ricevute',0),(370969,10305,'tl','',0),(370970,10305,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡ - à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸š',0),(370971,10305,'hi','à¤¸à¥à¤§à¤¾à¤° - à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¬à¥‹à¤²à¤¿à¤¯à¤¾à¤‚',0),(370972,10305,'ms','Penambahbaikan - petikan-petikan yang diterima',0),(370973,10305,'ar','Ø§Ù„ØªØ­Ø³ÙŠÙ†Ø§Øª-Ø§Ù‚ØªØ¨Ø§Ø³Ø§Øª ÙˆØ±Ø¯Øª',0),(370974,10305,'fr','AmÃ©liorations - citations reÃ§ues',0),(370975,10305,'jp','æ”¹å–„ - å¼•ç”¨ç¬¦ã‚’å—ã‘å–ã£ãŸ',0),(370976,10305,'pt','Melhorias - citaÃ§Ãµes recebidas',0),(370977,10305,'ru','Ð£Ð»ÑƒÑ‡ÑˆÐµÐ½Ð¸Ñ - Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»',0),(370978,10305,'es','Mejoras - Cotizaciones Recibidas',0),(370979,10305,'de','Verbesserungen - Angebote erhalten',0),(370980,10305,'en','Improvements - Quotes Received',0),(370981,10306,'is','',0),(370982,10306,'dr','Ø²Ù…ÙŠÙ† Ùˆ Ø§Ø¯Ø¹Ø§Ù†Ø§Ù…Ù‡ Ù‡Ø§   ',0),(370983,10306,'pr','Ø²Ù…ÙŠÙ† Ùˆ Ø§Ø¯Ø¹Ø§Ù†Ø§Ù…Ù‡ Ù‡Ø§   ',0),(370984,10306,'tr','Arazi ve yetkileri',0),(370985,10306,'pl','GruntÃ³w i prawa',0),(370986,10306,'bg','Ð—ÐµÐ¼Ñ Ð¸ Ð¿Ñ€Ð°Ð²Ð°',0),(370987,10306,'ur','Ø²Ù…ÛŒÙ† Ø§ÙˆØ± Ø«Ø§Ù†ÛŒ Ù¾ÙˆØ±ÛŒ',0),(370988,10306,'sr','Ð—ÐµÐ¼Ñ™Ð¸ÑˆÑ‚Ð° Ð¸ Ð¿Ñ€Ð°Ð²Ð° Ð½Ð° Ð±ÐµÐ½ÐµÑ„Ð¸Ñ†Ð¸Ñ˜Ðµ',0),(370989,10306,'vi','Ä‘áº¥t vÃ  quyá»n ',0),(370990,10306,'af','Grond en Regte',0),(370991,10306,'ro','Teren si drepturile',0),(370992,10306,'et','Maa ja maksud',0),(370993,10306,'si','ZemljiÅ¡Ä in pravice',0),(370994,10306,'ba','Tanah dan hak',0),(370995,10306,'nl','Land en rechten',0),(370996,10306,'fi','Maa ja tukioikeudet',0),(370997,10306,'no','Land og rettigheter',0),(370998,10306,'da','Arealer og rettigheder',0),(370999,10306,'ko','ë•…ê³¼ ê¶Œë¦¬',0),(371000,10306,'he','×”××“×ž×” ×•××ª ×–×›××•×™×•×ª',0),(371001,10306,'el','Î“Î· ÎºÎ±Î¹ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î±',0),(371002,10306,'zh','åœŸåœ°å’Œæƒåˆ©\r\n',0),(371003,10306,'sv','Mark och stÃ¶drÃ¤ttigheter',0),(371004,10306,'it','Terra e diritti',0),(371005,10306,'tl','',0),(371006,10306,'th','à¸—à¸µà¹ˆà¸”à¸´à¸™à¹à¸¥à¸°à¹ƒà¸«à¹‰',0),(371007,10306,'hi','à¤­à¥‚à¤®à¤¿ à¤”à¤° à¤à¤¨à¤Ÿà¤¾à¤‡à¤Ÿà¥‡à¤²à¤®à¥‡à¤‚à¤Ÿ',0),(371008,10306,'ms','Tanah dan kelayakan',0),(371009,10306,'ar','Ø§Ù„Ø£Ø±Ø¶ ÙˆØ§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚Ø§Øª',0),(371010,10306,'fr','Terres et droits',0),(371011,10306,'jp','åœŸåœ°ãŠã‚ˆã³è³‡æ ¼',0),(371012,10306,'pt','Terra e direitos',0),(371013,10306,'ru','Ð—ÐµÐ¼Ð»Ñ Ð¸ Ð¿Ð¾ÑÐ¾Ð±Ð¸Ð¹',0),(371014,10306,'es','Terreno y Derechos',0),(371015,10306,'de','Land und AnsprÃ¼che',0),(371016,10306,'en','Land and Entitlements',0),(371017,10307,'is','',0),(371018,10307,'dr','Ø²Ù…ÙŠÙ† Ùˆ Ø§Ø¯Ø¹Ø§Ù†Ø§Ù…Ù‡ Ù‡Ø§ â€“ Ø¯ÙŠÚ¯Ø± ',0),(371019,10307,'pr','Ø²Ù…ÙŠÙ† Ùˆ Ø§Ø¯Ø¹Ø§Ù†Ø§Ù…Ù‡ Ù‡Ø§ â€“ Ø¯ÙŠÚ¯Ø± ',0),(371020,10307,'tr','Arazi ve hak ediÅŸleri - diÄŸer',0),(371021,10307,'pl','GruntÃ³w i prawa - inne',0),(371022,10307,'bg','Ð—ÐµÐ¼Ñ Ð¸ Ð¿Ñ€Ð°Ð²Ð° - Ð´Ñ€ÑƒÐ³Ð¸',0),(371023,10307,'ur','Ø²Ù…ÛŒÙ† Ø§ÙˆØ± Ø«Ø§Ù†ÛŒ Ù¾ÙˆØ±ÛŒ - Ø¯ÛŒÚ¯Ø±',0),(371024,10307,'sr','Ð—ÐµÐ¼Ñ™Ð¸ÑˆÑ‚Ð° Ð¸ Ð¿Ñ€Ð°Ð²Ð° Ð½Ð° Ð±ÐµÐ½ÐµÑ„Ð¸Ñ†Ð¸Ñ˜Ðµ - Ð´Ñ€ÑƒÐ³Ð¸',0),(371025,10307,'vi','Ä‘áº¥t vÃ  quyá»n- khÃ¡c',0),(371026,10307,'af','Grond en Regte - Ander',0),(371027,10307,'ro','Teren si drepturile - alte',0),(371028,10307,'et','Maa ja maksud - muud',0),(371029,10307,'si','ZemljiÅ¡Ä in pravice - druge',0),(371030,10307,'ba','Tanah dan hak - lainnya',0),(371031,10307,'nl','Land en rechten - andere',0),(371032,10307,'fi','Maa- ja oikeudet - muut',0),(371033,10307,'no','Land og rettigheter - andre',0),(371034,10307,'da','Arealer og rettigheder - andre',0),(371035,10307,'ko','ë•…ê³¼ ê¶Œë¦¬-ê¸°íƒ€',0),(371036,10307,'he','×”××“×ž×” ×•××ª ×–×›××•×™×•×ª - ××—×¨×™×',0),(371037,10307,'el','Î“Î· ÎºÎ±Î¹ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± - Î¬Î»Î»Î±',0),(371038,10307,'zh','åœŸåœ°å’Œæƒåˆ©- å…¶ä»–\r\n',0),(371039,10307,'sv','Mark och rÃ¤ttigheter - andra',0),(371040,10307,'it','Terra e diritti - altri',0),(371041,10307,'tl','',0),(371042,10307,'th','à¸—à¸µà¹ˆà¸”à¸´à¸™à¹à¸¥à¸°à¹ƒà¸«à¹‰à¸ªà¸´à¸—à¸˜à¸´à¹Œ - à¸­à¸·à¹ˆà¸™ à¹†',0),(371043,10307,'hi','à¤­à¥‚à¤®à¤¿ à¤”à¤° à¤à¤¨à¤Ÿà¤¾à¤‡à¤Ÿà¥‡à¤²à¤®à¥‡à¤‚à¤Ÿ - à¤…à¤¨à¥à¤¯',0),(371044,10307,'ms','Tanah dan kelayakan - lain',0),(371045,10307,'ar','Ø§Ù„Ø£Ø±Ø¶ ÙˆØ§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚Ø§Øª-Ø£Ø®Ø±Ù‰',0),(371046,10307,'fr','Terres et droits - autres',0),(371047,10307,'jp','åœŸåœ°ãŠã‚ˆã³è³‡æ ¼ - ãã®ä»–',0),(371048,10307,'pt','Terra e direitos - outras',0),(371049,10307,'ru','Ð—ÐµÐ¼Ð»Ñ Ð¸ Ð¿Ð¾ÑÐ¾Ð±Ð¸Ð¹ - Ð´Ñ€ÑƒÐ³Ð¸Ðµ',0),(371050,10307,'es','Terreno y Derechos - Otros',0),(371051,10307,'de','Land und AnsprÃ¼che - andere',0),(371052,10307,'en','Land and Entitlements - Other',0),(371053,10308,'is','',0),(371054,10308,'dr','- Ù…Ø¬ÙˆØ²Ù‡Ø§ ',0),(371055,10308,'pr','Ø²Ù…ÙŠÙ† Ùˆ Ø§Ø¯Ø¹Ø§Ù†Ø§Ù…Ù‡ Ù‡Ø§  - Ù…Ø¬ÙˆØ²Ù‡Ø§ ',0),(371056,10308,'tr','Arazi ve hak ediÅŸleri - izni',0),(371057,10308,'pl','GruntÃ³w i prawa - zezwolenia',0),(371058,10308,'bg','Ð—ÐµÐ¼Ñ Ð¸ Ð¿Ñ€Ð°Ð²Ð° - Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ',0),(371059,10308,'ur','Ø²Ù…ÛŒÙ† Ø§ÙˆØ± Ø«Ø§Ù†ÛŒ Ù¾ÙˆØ±ÛŒ - ÙˆØ±Ú© Ù¾Ø±Ù…Ù¹',0),(371060,10308,'sr','Ð—ÐµÐ¼Ñ™Ð¸ÑˆÑ‚Ð° Ð¸ Ð¿Ñ€Ð°Ð²Ð° Ð½Ð° Ð±ÐµÐ½ÐµÑ„Ð¸Ñ†Ð¸Ñ˜Ðµ - Ð´Ð¾Ð·Ð²Ð¾Ð»Ðµ',0),(371061,10308,'vi','Ä‘áº¥t vÃ  quyá»n- giáº¥y phÃ©p',0),(371062,10308,'af','Grond en Entitlements - permitte',0),(371063,10308,'ro','Teren si drepturile - permise',0),(371064,10308,'et','Maa ja maksud - load',0),(371065,10308,'si','ZemljiÅ¡Ä in pravice - dovoljenj',0),(371066,10308,'ba','Tanah dan hak - izin',0),(371067,10308,'nl','Land en rechten - vergunningen',0),(371068,10308,'fi','Maa- ja oikeudet - luvat',0),(371069,10308,'no','Land og rettigheter - tillatelser',0),(371070,10308,'da','Arealer og rettigheder - tilladelser',0),(371071,10308,'ko','ë•…ê³¼ ê¶Œë¦¬-í—ˆê°€',0),(371072,10308,'he','×”××“×ž×” ×•××ª ×–×›××•×™×•×ª - ×”×™×ª×¨×™×',0),(371073,10308,'el','Î“Î· ÎºÎ±Î¹ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± - Î¬Î´ÎµÎ¹ÎµÏ‚',0),(371074,10308,'zh','åœŸåœ°å’Œæƒåˆ©- å…è®¸\r\n',0),(371075,10308,'sv','Mark och rÃ¤ttigheter - tillstÃ¥nd',0),(371076,10308,'it','Terra e diritti - permessi',0),(371077,10308,'tl','',0),(371078,10308,'th','à¸—à¸µà¹ˆà¸”à¸´à¸™à¹à¸¥à¸°à¹ƒà¸«à¹‰à¸ªà¸´à¸—à¸˜à¸´à¹Œ - à¸‚à¸­à¸­à¸™à¸¸à¸à¸²à¸•',0),(371079,10308,'hi','à¤­à¥‚à¤®à¤¿ à¤”à¤° à¤à¤¨à¤Ÿà¤¾à¤‡à¤Ÿà¥‡à¤²à¤®à¥‡à¤‚à¤Ÿ - à¤ªà¤°à¤®à¤¿à¤Ÿ',0),(371080,10308,'ms','Tanah dan kelayakan - permit',0),(371081,10308,'ar','Ø§Ù„Ø£Ø±Ø¶ ÙˆØ§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚Ø§Øª-ØªØµØ§Ø±ÙŠØ­',0),(371082,10308,'fr','Terres et droits - permis',0),(371083,10308,'jp','åœŸåœ°ã¨ã‚¨ãƒ³ã‚¿ã‚¤ãƒˆãƒ«ãƒ¡ãƒ³ãƒˆã®è¨±å¯',0),(371084,10308,'pt','Terra e direitos - autorizaÃ§Ãµes',0),(371085,10308,'ru','Ð—ÐµÐ¼Ð»Ñ Ð¸ Ð¿Ð¾ÑÐ¾Ð±Ð¸Ð¹ - Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ð¹',0),(371086,10308,'es','Terreno y Derechos - Permisos',0),(371087,10308,'de','Land und AnsprÃ¼che - Genehmigungen',0),(371088,10308,'en','Land and Entitlements - Permits',0),(371089,10309,'is','',0),(371090,10309,'dr','- ØªÙ…Ø§Ø³ Ù‡Ø§ ',0),(371091,10309,'pr','Ø²Ù…ÙŠÙ† Ùˆ Ø§Ø¯Ø¹Ø§Ù†Ø§Ù…Ù‡ Ù‡Ø§  - ØªÙ…Ø§Ø³ Ù‡Ø§ ',0),(371092,10309,'tr','Arazi ve hak ediÅŸleri - rehber',0),(371093,10309,'pl','GruntÃ³w i prawa - kontakty',0),(371094,10309,'bg','Ð—ÐµÐ¼Ñ Ð¸ Ð¿Ñ€Ð°Ð²Ð° - ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(371095,10309,'ur','Ø²Ù…ÛŒÙ† Ø§ÙˆØ± Ø«Ø§Ù†ÛŒ Ù¾ÙˆØ±ÛŒ - Ø±ÙˆØ§Ø¨Ø·',0),(371096,10309,'sr','Ð—ÐµÐ¼Ñ™Ð¸ÑˆÑ‚Ð° Ð¸ Ð¿Ñ€Ð°Ð²Ð° Ð½Ð° Ð±ÐµÐ½ÐµÑ„Ð¸Ñ†Ð¸Ñ˜Ðµ - ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(371097,10309,'vi','Ä‘áº¥t vÃ  cÃ¡c quyá»n- liÃªn há»‡',0),(371098,10309,'af','Grond en Regte - Kontakte',0),(371099,10309,'ro','Teren si drepturile - contacte',0),(371100,10309,'et','Maa ja maksud - kontaktid',0),(371101,10309,'si','ZemljiÅ¡Ä in pravice - stiki',0),(371102,10309,'ba','Tanah dan hak - kontak',0),(371103,10309,'nl','Land en rechten - contacten',0),(371104,10309,'fi','Maa- ja oikeudet - yhteystiedot',0),(371105,10309,'no','Land og rettigheter - kontakter',0),(371106,10309,'da','Arealer og rettigheder - kontakter',0),(371107,10309,'ko','ë•…ê³¼ ê¶Œë¦¬-ì—°ë½ì²˜',0),(371108,10309,'he','×”××“×ž×” ×•××ª ×–×›××•×™×•×ª - ×× ×©×™ ×§×©×¨',0),(371109,10309,'el','Î“Î· ÎºÎ±Î¹ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± - ÎµÏ€Î±Ï†Î­Ï‚',0),(371110,10309,'zh','åœŸåœ°å’Œæƒåˆ©è”ç³»æ–¹å¼\r\n',0),(371111,10309,'sv','Mark och rÃ¤ttigheter - kontakter',0),(371112,10309,'it','Terra e diritti - contatti',0),(371113,10309,'tl','',0),(371114,10309,'th','à¸—à¸µà¹ˆà¸”à¸´à¸™à¹à¸¥à¸°à¹ƒà¸«à¹‰à¸ªà¸´à¸—à¸˜à¸´à¹Œ - à¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­',0),(371115,10309,'hi','à¤­à¥‚à¤®à¤¿ à¤”à¤° à¤à¤¨à¤Ÿà¤¾à¤‡à¤Ÿà¥‡à¤²à¤®à¥‡à¤‚à¤Ÿ - à¤¸à¤‚à¤ªà¤°à¥à¤•',0),(371116,10309,'ms','Tanah dan kelayakan - kenalan',0),(371117,10309,'ar','Ø§Ù„Ø£Ø±Ø¶ ÙˆØ§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚Ø§Øª-Ø¬Ù‡Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„',0),(371118,10309,'fr','Terres et droits - Contacts',0),(371119,10309,'jp','åœŸåœ°ãŠã‚ˆã³è³‡æ ¼ - é€£çµ¡å…ˆ',0),(371120,10309,'pt','Terra e direitos - contatos',0),(371121,10309,'ru','Ð—ÐµÐ¼Ð»Ñ Ð¸ Ð¿Ð¾ÑÐ¾Ð±Ð¸Ð¹ - ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñ‹',0),(371122,10309,'es','Terreno y Derechos - Contacttos',0),(371123,10309,'de','Land und AnsprÃ¼che - Kontakte',0),(371124,10309,'en','Land and Entitlements - Contacts',0),(371125,10310,'is','',0),(371126,10310,'dr','ÙØ§Ø² Ú†Ù‡Ø§Ø±',0),(371127,10310,'pr','ÙØ§Ø² Ú†Ù‡Ø§Ø±',0),(371128,10310,'tr','AÅŸama DÃ¶rt',0),(371129,10310,'pl','Faza czwarta',0),(371130,10310,'bg','Ð§ÐµÑ‚Ð²ÑŠÑ€Ñ‚Ð° Ñ„Ð°Ð·Ð°',0),(371131,10310,'ur','Ú†Ø§Ø± Ù…Ø±Ø­Ù„Û ÙˆØ§Ø±',0),(371132,10310,'sr','Ð¤Ð°Ð·Ð° Ñ‡ÐµÑ‚Ð¸Ñ€Ð¸',0),(371133,10310,'vi','giai Ä‘oáº¡n 4',0),(371134,10310,'af','Fase Vier',0),(371135,10310,'ro','Faza 4',0),(371136,10310,'et','Etapis neli',0),(371137,10310,'si','Å tiri faze',0),(371138,10310,'ba','Tahap empat',0),(371139,10310,'nl','Fase vier',0),(371140,10310,'fi','NeljÃ¤s vaihe',0),(371141,10310,'no','Fase fire',0),(371142,10310,'da','Fase fire',0),(371143,10310,'ko','ë‹¨ê³„ 4',0),(371144,10310,'he','×”×©×œ×‘ ×”×¨×‘×™×¢×™',0),(371145,10310,'el','Î¤Î­Ï„Î±ÏÏ„Î¿ ÏƒÏ„Î¬Î´Î¹Î¿',0),(371146,10310,'zh','ç¬¬å››é˜¶æ®µ\r\n',0),(371147,10310,'sv','Fas fyra',0),(371148,10310,'it','Fase quattro',0),(371149,10310,'tl','',0),(371150,10310,'th','à¸£à¸°à¸¢à¸°à¸—à¸µà¹ˆà¸ªà¸µà¹ˆ',0),(371151,10310,'hi','à¤šà¤¾à¤° à¤šà¤°à¤£',0),(371152,10310,'ms','Fasa empat',0),(371153,10310,'ar','Ø§Ù„Ù…Ø±Ø­Ù„Ø© Ø§Ù„Ø±Ø§Ø¨Ø¹Ø©',0),(371154,10310,'fr','Phase 4',0),(371155,10310,'jp','ãƒ•ã‚§ãƒ¼ã‚º 4',0),(371156,10310,'pt','Fase quatro',0),(371157,10310,'ru','Ð­Ñ‚Ð°Ð¿ 4',0),(371158,10310,'es','Etapa Cuatro',0),(371159,10310,'de','Phase vier',0),(371160,10310,'en','Phase Four',0),(371161,10311,'is','',0),(371162,10311,'dr','(Ù…Ø±Ø­Ù„Ù‡) ÙŠÙƒ',0),(371163,10311,'pr','ÙØ§Ø² (Ù…Ø±Ø­Ù„Ù‡) ÙŠÙƒ',0),(371164,10311,'tr','AÅŸama bir',0),(371165,10311,'pl','Faza pierwsza',0),(371166,10311,'bg','ÐŸÑŠÑ€Ð²Ð° Ñ„Ð°Ð·Ð°',0),(371167,10311,'ur','Ø§ÛŒÚ© Ù…Ø±Ø­Ù„Û ÙˆØ§Ø±',0),(371168,10311,'sr','Ð¤Ð°Ð·Ð° 1',0),(371169,10311,'vi','giai Ä‘oáº¡n 1',0),(371170,10311,'af','Fase Een',0),(371171,10311,'ro','Una de fazÄƒ',0),(371172,10311,'et','Phase One',0),(371173,10311,'si','Phase One',0),(371174,10311,'ba','Tahap satu',0),(371175,10311,'nl','Phase One',0),(371176,10311,'fi','Vaihe yksi',0),(371177,10311,'no','Fase en',0),(371178,10311,'da','Fase et',0),(371179,10311,'ko','1 ë‹¨ê³„',0),(371180,10311,'he','. ×©×œ×‘ ×¨××©×•×Ÿ',0),(371181,10311,'el','Î ÏÏŽÏ„Î· Ï†Î¬ÏƒÎ·',0),(371182,10311,'zh','ç¬¬ä¸€é˜¶æ®µ\r\n',0),(371183,10311,'sv','Phase One',0),(371184,10311,'it','Fase uno',0),(371185,10311,'tl','',0),(371186,10311,'th','à¸£à¸°à¸¢à¸°à¸—à¸µà¹ˆà¸«à¸™à¸¶à¹ˆà¸‡',0),(371187,10311,'hi','à¤šà¤°à¤£ à¤à¤•',0),(371188,10311,'ms','Fasa pertama',0),(371189,10311,'ar','Ø§Ù„Ù…Ø±Ø­Ù„Ø© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(371190,10311,'fr','La premiÃ¨re Ã©tape',0),(371191,10311,'jp','ãƒ•ã‚§ãƒ¼ã‚º 1',0),(371192,10311,'pt','Primeira fase',0),(371193,10311,'ru','ÐŸÐµÑ€Ð²Ð°Ñ Ñ„Ð°Ð·Ð°',0),(371194,10311,'es','Etapa Uno',0),(371195,10311,'de','Phase eins',0),(371196,10311,'en','Phase One',0),(371197,10312,'is','',0),(371198,10312,'dr','ÙØ§Ø² Ø³Ù‡',0),(371199,10312,'pr','ÙØ§Ø² Ø³Ù‡',0),(371200,10312,'tr','ÃœÃ§Ã¼ncÃ¼ aÅŸama',0),(371201,10312,'pl','Faza trzecia',0),(371202,10312,'bg','Ð¢Ñ€ÐµÑ‚Ð° Ñ„Ð°Ð·Ð°',0),(371203,10312,'ur','ØªÛŒÙ† ÙÛŒØ²',0),(371204,10312,'sr','Ð¤Ð°Ð·Ð° 3',0),(371205,10312,'vi','giai Ä‘oáº¡n 3',0),(371206,10312,'af','Fase Drie',0),(371207,10312,'ro','Faza a treia',0),(371208,10312,'et','Etapp',0),(371209,10312,'si','Tri faze',0),(371210,10312,'ba','Tiga tahap',0),(371211,10312,'nl','Fase drie',0),(371212,10312,'fi','Kolmas vaihe',0),(371213,10312,'no','Fase tre',0),(371214,10312,'da','Fase tre',0),(371215,10312,'ko','ë‹¨ê³„ 3',0),(371216,10312,'he','×”×©×œ×‘ ×”×©×œ×™×©×™',0),(371217,10312,'el','Î¦Î¬ÏƒÎ· Ï„ÏÎ¯Î±',0),(371218,10312,'zh','ç¬¬ä¸‰é˜¶æ®µ\r\n',0),(371219,10312,'sv','Fas tre',0),(371220,10312,'it','Fase tre',0),(371221,10312,'tl','',0),(371222,10312,'th','à¸£à¸°à¸¢à¸°à¸—à¸µà¹ˆà¸ªà¸²à¸¡',0),(371223,10312,'hi','à¤¤à¥€à¤¨ à¤šà¤°à¤£',0),(371224,10312,'ms','Fasa tiga',0),(371225,10312,'ar','Ø§Ù„Ù…Ø±Ø­Ù„Ø© Ø§Ù„Ø«Ø§Ù„Ø«Ø©',0),(371226,10312,'fr','TroisiÃ¨me phase',0),(371227,10312,'jp','ãƒ•ã‚§ãƒ¼ã‚º 3',0),(371228,10312,'pt','Fase trÃªs',0),(371229,10312,'ru','Ð¢Ñ€ÐµÑ‚Ð¸Ð¹ ÑÑ‚Ð°Ð¿',0),(371230,10312,'es','Etapa Tres',0),(371231,10312,'de','Drehstrom',0),(371232,10312,'en','Phase Three',0),(371233,10313,'is','',0),(371234,10313,'dr','ÙØ§Ø² Ø¯Ùˆ',0),(371235,10313,'pr','ÙØ§Ø² Ø¯Ùˆ',0),(371236,10313,'tr','Ä°kinci aÅŸama',0),(371237,10313,'pl','Faza Druga',0),(371238,10313,'bg','Ð¤Ð°Ð·Ð° Ð´Ð²Ðµ',0),(371239,10313,'ur','Ù…Ø±Ø­Ù„Û Ø¯Ùˆ',0),(371240,10313,'sr','Ð¤Ð°Ð·Ð° Ð±Ñ€Ð¾Ñ˜ Ð´Ð²Ð°',0),(371241,10313,'vi','giai Ä‘oáº¡n 2',0),(371242,10313,'af','Fase Twee',0),(371243,10313,'ro','Faza a doua',0),(371244,10313,'et','Etapp',0),(371245,10313,'si','Faza',0),(371246,10313,'ba','Tahap kedua',0),(371247,10313,'nl','Fase twee',0),(371248,10313,'fi','Vaihe kaksi',0),(371249,10313,'no','Fase to',0),(371250,10313,'da','Fase to',0),(371251,10313,'ko','2 ë‹¨ê³„',0),(371252,10313,'he','×©×œ×‘ ×©× ×™',0),(371253,10313,'el','Î¦Î¬ÏƒÎ· Î´ÏÎ¿',0),(371254,10313,'zh','ç¬¬äºŒé˜¶æ®µ\r\n',0),(371255,10313,'sv','Fas tvÃ¥',0),(371256,10313,'it','Fase due',0),(371257,10313,'tl','',0),(371258,10313,'th','à¸£à¸°à¸¢à¸°à¸—à¸µà¹ˆà¸ªà¸­à¸‡',0),(371259,10313,'hi','à¤¦à¥‹ à¤šà¤°à¤£',0),(371260,10313,'ms','Fasa dua',0),(371261,10313,'ar','Ø§Ù„Ù…Ø±Ø­Ù„Ø© Ø§Ù„Ø«Ø§Ù†ÙŠØ©',0),(371262,10313,'fr','Phase 2',0),(371263,10313,'jp','ãƒ•ã‚§ãƒ¼ã‚º 2',0),(371264,10313,'pt','Fase dois',0),(371265,10313,'ru','Ð’Ñ‚Ð¾Ñ€Ð¾Ð¹ ÑÑ‚Ð°Ð¿',0),(371266,10313,'es','Etapa Dos',0),(371267,10313,'de','Phase zwei',0),(371268,10313,'en','Phase Two',0),(371269,10314,'is','',0),(371270,10314,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾ÙŠØ´ ÙØ±Ø¶  Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(371271,10314,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾ÙŠØ´ ÙØ±Ø¶  Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(371272,10314,'tr','Proje ayrÄ±ntÄ±larÄ±nÄ± ekle',0),(371273,10314,'pl','SzczegÃ³Å‚y projektu Dodaj',0),(371274,10314,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(371275,10314,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(371276,10314,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(371277,10314,'vi','thÃªm chi tiáº¿t dá»± Ã¡n',0),(371278,10314,'af','Projek Besonderhede Byvoeg',0),(371279,10314,'ro','Adauga detalii proiect',0),(371280,10314,'et','Projekti Ã¼ksikasjade lisamiseks',0),(371281,10314,'si','Dodajte podrobnosti projekta',0),(371282,10314,'ba','Menambahkan rincian proyek',0),(371283,10314,'nl','Bijzonderheden van het project toevoegen',0),(371284,10314,'fi','Projektitietojen lisÃ¤Ã¤minen',0),(371285,10314,'no','Prosjektdetaljer legge',0),(371286,10314,'da','Projektdetaljer tilfÃ¸je',0),(371287,10314,'ko','í”„ë¡œì íŠ¸ ì„¸ë¶€ ì •ë³´ ì¶”ê°€',0),(371288,10314,'he','×”×•×¡×¤×ª ×¤×¨×˜×™ ×”×¤×¨×•×™×™×§×˜',0),(371289,10314,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î­ÏÎ³Î¿Ï…',0),(371290,10314,'zh','é¡¹ç›®ç»†èŠ‚æ·»åŠ \r\n',0),(371291,10314,'sv','LÃ¤gga till projektinformation',0),(371292,10314,'it','Aggiungere dettagli di progetto',0),(371293,10314,'tl','',0),(371294,10314,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹‚à¸„à¸£à¸‡à¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡',0),(371295,10314,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‡ à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(371296,10314,'ms','Tambah butiran projek',0),(371297,10314,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(371298,10314,'fr','Ajouter des dÃ©tails du projet',0),(371299,10314,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®è©³ç´°ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(371300,10314,'pt','Adicionam detalhes do projeto',0),(371301,10314,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(371302,10314,'es','Agregar Detalles del Proyecto',0),(371303,10314,'de','Details zum Projekt hinzufÃ¼gen',0),(371304,10314,'en','Project Details Add',0),(371305,10315,'is','',0),(371306,10315,'dr','Ù‡Ù…Ù‡ Ù…Ø§Ù„ÙƒØ§Ù† ',0),(371307,10315,'pr','Ù‡Ù…Ù‡ Ù…Ø§Ù„ÙƒØ§Ù† ',0),(371308,10315,'tr','TÃ¼m sahipler',0),(371309,10315,'pl','Wszystkich wÅ‚aÅ›cicieli',0),(371310,10315,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸Ñ†Ð¸',0),(371311,10315,'ur','ØªÙ…Ø§Ù… Ù…Ø§Ù„Ú©Ø§Ù†',0),(371312,10315,'sr','Ð¡Ð²Ð¸ Ð²Ð»Ð°ÑÐ½Ð¸Ñ†Ð¸',0),(371313,10315,'vi','táº¥t cáº£ Chá»§ sá»Ÿ há»¯u',0),(371314,10315,'af','Alle Eienaars',0),(371315,10315,'ro','ToÅ£i proprietarii de',0),(371316,10315,'et','KÃµik omanikud',0),(371317,10315,'si','Vsi lastniki',0),(371318,10315,'ba','Semua pemilik',0),(371319,10315,'nl','Alle eigenaren',0),(371320,10315,'fi','Kaikki omistajat',0),(371321,10315,'no','Alle eiere',0),(371322,10315,'da','Alle ejere',0),(371323,10315,'ko','ëª¨ë“  ì†Œìœ ìž',0),(371324,10315,'he','×›×œ ×”×‘×¢×œ×™×',0),(371325,10315,'el','ÎŒÎ»Î¿Î¹ Î¿Î¹ Î¹Î´Î¹Î¿ÎºÏ„Î®Ï„ÎµÏ‚',0),(371326,10315,'zh','æ‰€æœ‰æ‰€æœ‰äºº\r\n',0),(371327,10315,'sv','Alla Ã¤gare',0),(371328,10315,'it','Tutti i proprietari',0),(371329,10315,'tl','',0),(371330,10315,'th','à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(371331,10315,'hi','à¤¸à¤­à¥€ à¤¸à¥à¤µà¤¾à¤®à¥€',0),(371332,10315,'ms','Semua pemilik',0),(371333,10315,'ar','Ø¬Ù…ÙŠØ¹ Ø£ØµØ­Ø§Ø¨',0),(371334,10315,'fr','Tous les propriÃ©taires',0),(371335,10315,'jp','ã™ã¹ã¦ã®æ‰€æœ‰è€…',0),(371336,10315,'pt','Todos os proprietÃ¡rios',0),(371337,10315,'ru','Ð’ÑÐµ Ð²Ð»Ð°Ð´ÐµÐ»ÑŒÑ†Ñ‹',0),(371338,10315,'es','Todos los DueÃ±os',0),(371339,10315,'de','Alle Besitzer',0),(371340,10315,'en','All Owners',0),(371341,10316,'is','',0),(371342,10316,'dr','ÙƒÙ„Ù†Ú¯ Ø²Ù†ÙŠ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(371343,10316,'pr','ÙƒÙ„Ù†Ú¯ Ø²Ù†ÙŠ ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(371344,10316,'tr','Tahmini temel atma',0),(371345,10316,'pl','Szacowany przeÅ‚omowe',0),(371346,10316,'bg','ÐžÑ‡Ð°ÐºÐ²Ð°Ð½Ð°Ñ‚Ð° ÐŸÑŠÑ€Ð²Ð° ÐºÐ¾Ð¿ÐºÐ°',0),(371347,10316,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ú¯Ø±ÙˆÙ†Ø¯Ø¨Ø±ÛŒÚ©Ø§Ù†Ú¯',0),(371348,10316,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ñ€ÐµÐ²Ð¾Ð»ÑƒÑ†Ð¸Ñ˜Ñƒ',0),(371349,10316,'vi','Æ¯á»›c tÃ­nh táº¡m dá»«ng',0),(371350,10316,'af','Geskatte Aanvooring',0),(371351,10316,'ro','EstimatÄƒ revoluÅ£ionarÄƒ',0),(371352,10316,'et','Eeldatav murrangulise',0),(371353,10316,'si','Ocenjena prelomen',0),(371354,10316,'ba','Perkiraan inovatif',0),(371355,10316,'nl','Geschatte baanbrekende',0),(371356,10316,'fi','Arvioitu uraauurtava',0),(371357,10316,'no','AnslÃ¥tt banebrytende',0),(371358,10316,'da','AnslÃ¥ede banebrydende',0),(371359,10316,'ko','ì˜ˆìƒëœ ê¸°ê³µì‹',0),(371360,10316,'he','×”× ×—×ª ××‘×Ÿ ×”×¤×™× ×” ×ž×©×•×¢×¨',0),(371361,10316,'el','Î•ÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· ÏÎ·Î¾Î¹ÎºÎ­Î»ÎµÏ…Î¸Î·',0),(371362,10316,'zh','ä¼°è®¡åŠ¨åœŸ\r\n',0),(371363,10316,'sv','BerÃ¤knade banbrytande',0),(371364,10316,'it','Stimato nell\'innovativa',0),(371365,10316,'tl','',0),(371366,10316,'th','Groundbreaking à¸›à¸£à¸°à¹€à¸¡à¸´à¸™',0),(371367,10316,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ Groundbreaking',0),(371368,10316,'ms','Pecah tanah yang dianggarkan',0),(371369,10316,'ar','Ø§Ù„Ø±Ø§Ø¦Ø¯ Ø§Ù„Ù…Ù‚Ø¯Ø±Ø©',0),(371370,10316,'fr','Inauguration des travaux estimÃ©e',0),(371371,10316,'jp','æŽ¨å®šã®ç”»æœŸçš„ãª',0),(371372,10316,'pt','Estima-se inovador',0),(371373,10316,'ru','ÐŸÐ¾ Ð¾Ñ†ÐµÐ½ÐºÐ°Ð¼ Ð½Ð¾Ð²Ð°Ñ‚Ð¾Ñ€ÑÐºÐ¸Ð¼',0),(371374,10316,'es','Comienzo De ConstrucciÃ³n Estimada',0),(371375,10316,'de','GeschÃ¤tzte Spatenstich',0),(371376,10316,'en','Estimated Groundbreaking',0),(371377,10317,'is','',0),(371378,10317,'dr','Ø´Ø±Ú©Øª ÙˆØ§Ø¨Ø³ØªÙ‡ Ù†ÙŠØ³Øª ',0),(371379,10317,'pr','Ø´Ø±Ú©Øª ÙˆØ§Ø¨Ø³ØªÙ‡ Ù†ÙŠØ³Øª ',0),(371380,10317,'tr','Åžirket iliÅŸkili deÄŸil',0),(371381,10317,'pl','Firma nie zwiÄ…zane',0),(371382,10317,'bg','ÐÐµ ÑÐ²ÑŠÑ€Ð·Ð°Ð½Ð¾ Ð´Ñ€ÑƒÐ¶ÐµÑÑ‚Ð²Ð¾',0),(371383,10317,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ø³Û’ ÙˆØ§Ø¨Ø³ØªÛ Ù†ÛÛŒÚº',0),(371384,10317,'sr','ÐÐµ Ð¿Ð¾Ð²ÐµÐ·Ð°Ð½Ð¾Ð³ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð°',0),(371385,10317,'vi','khÃ´ng Ä‘Æ°á»£c há»£p nháº¥t cÃ´ng ty',0),(371386,10317,'af','NIe Geassosieerde Onderneming',0),(371387,10317,'ro','Nu sunt asociate companiei',0),(371388,10317,'et','Ei ole seotud ettevÃµtte',0),(371389,10317,'si','Niso povezane druÅ¾be',0),(371390,10317,'ba','Perusahaan tidak terkait',0),(371391,10317,'nl','Niet verbonden onderneming',0),(371392,10317,'fi','Ei osakkuusyhtiÃ¶',0),(371393,10317,'no','Ikke tilknyttet selskap',0),(371394,10317,'da','Ikke associeret selskab',0),(371395,10317,'ko','ì—°ê²° ë˜ì§€ ì•Šì€ íšŒì‚¬',0),(371396,10317,'he','×—×‘×¨×” ×œ× ×§×©×•×¨×”',0),(371397,10317,'el','Î”ÎµÎ½ ÏƒÏ…Î½Î´ÎµÎ´ÎµÎ¼Î­Î½Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(371398,10317,'zh','æ²¡æœ‰å…³è”å…¬å¸\r\n',0),(371399,10317,'sv','Inte intressebolag',0),(371400,10317,'it','Azienda non associata',0),(371401,10317,'tl','',0),(371402,10317,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¹€à¸à¸µà¹ˆà¸¢à¸§à¸‚à¹‰à¸­à¸‡',0),(371403,10317,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¨à¤¹à¥€à¤‚ à¤œà¥à¤¡à¤¼à¥‡',0),(371404,10317,'ms','Tidak bersekutu',0),(371405,10317,'ar','Ù„Ø§ ØªØ±ØªØ¨Ø· Ø§Ù„Ø´Ø±ÙƒØ©',0),(371406,10317,'fr','Compagnie non associÃ©e',0),(371407,10317,'jp','ãªã„é–¢é€£ä¼šç¤¾',0),(371408,10317,'pt','Empresa nÃ£o associada',0),(371409,10317,'ru','ÐÐµ ÑÐ²ÑÐ·Ð°Ð½Ð½Ñ‹Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(371410,10317,'es','Empresa No Asociado',0),(371411,10317,'de','Nicht verbundenes Unternehmen',0),(371412,10317,'en','Not Associated Company',0),(371413,10318,'is','',0),(371414,10318,'dr','(Ù…Ø´Ø±ÙˆØ·) Ùˆ Ù…Ù‚Ø¯Ù…Ø§ØªÙŠ',0),(371415,10318,'pr','Ù…Ø¹Ù„Ù‚(Ù…Ø´Ø±ÙˆØ·) Ùˆ Ù…Ù‚Ø¯Ù…Ø§ØªÙŠ',0),(371416,10318,'tr','Bekleyen ve Ã¶n',0),(371417,10318,'pl','Czasu i wstÄ™pne',0),(371418,10318,'bg','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸ Ð¸ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¸',0),(371419,10318,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø§ÙˆØ± Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ',0),(371420,10318,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð¸ Ð¿Ñ€ÐµÐ»Ð¸Ð¼Ð¸Ð½Ð°Ñ€Ð½Ð¸',0),(371421,10318,'vi','Ä‘ang treo vÃ  chuáº©n bá»‹',0),(371422,10318,'af','Afwagtend en Voorlopig',0),(371423,10318,'ro','ÃŽn aÅŸteptare ÅŸi preliminar',0),(371424,10318,'et','Ootel ja esialgse',0),(371425,10318,'si','ÄŒakajoÄe in predhodno',0),(371426,10318,'ba','Tertunda dan awal',0),(371427,10318,'nl','In behandeling en voorlopige',0),(371428,10318,'fi','VireillÃ¤ ja alustava',0),(371429,10318,'no','Ventende og forelÃ¸pig',0),(371430,10318,'da','Ventende og forelÃ¸bige',0),(371431,10318,'ko','ë³´ë¥˜ ë° ì˜ˆë¹„',0),(371432,10318,'he','×”×ž×ª× ×”: ×¨××©×•× ×™',0),(371433,10318,'el','Î£Îµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± ÎºÎ±Î¹ Ï€ÏÎ¿ÎºÎ±Ï„Î±ÏÎºÏ„Î¹ÎºÎ®',0),(371434,10318,'zh','å¾…åŠžåˆæ­¥\r\n',0),(371435,10318,'sv','VÃ¤ntande och preliminÃ¤ra',0),(371436,10318,'it','In sospeso e preliminare',0),(371437,10318,'tl','',0),(371438,10318,'th','à¹€à¸šà¸·à¹‰à¸­à¸‡à¸•à¹‰à¸™ à¹à¸¥à¸°à¸­à¸¢à¸¹à¹ˆà¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸žà¸´à¸ˆà¸²à¸£à¸“à¸²',0),(371439,10318,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¹à¥ˆ à¤”à¤° à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤•',0),(371440,10318,'ms','Belum selesai dan awal',0),(371441,10318,'ar','Ù…Ø¹Ù„Ù‚Ø© ÙˆØ§Ù„Ø£ÙˆÙ„ÙŠØ©',0),(371442,10318,'fr','En attente et prÃ©liminaire',0),(371443,10318,'jp','ä¿ç•™ä¸­ãŠã‚ˆã³äºˆå‚™',0),(371444,10318,'pt','Pendente e preliminar',0),(371445,10318,'ru','ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ðµ Ð¸ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ',0),(371446,10318,'es','Pendiente y Preliminario',0),(371447,10318,'de','Ausstehende und vorlÃ¤ufige',0),(371448,10318,'en','Pending and Preliminary',0),(371449,10319,'is','',0),(371450,10319,'dr','Ù…Ù‚Ø¯Ù…Ø§ØªÙ‰',0),(371451,10319,'pr','Ù…Ù‚Ø¯Ù…Ø§ØªÙ‰',0),(371452,10319,'tr','Ã–n',0),(371453,10319,'pl','WstÄ™pne',0),(371454,10319,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¸',0),(371455,10319,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ',0),(371456,10319,'sr','ÐŸÑ€ÐµÐ»Ð¸Ð¼Ð¸Ð½Ð°Ñ€Ð½Ð¸',0),(371457,10319,'vi','má»Ÿ Ä‘áº§u',0),(371458,10319,'af','Voorlopige',0),(371459,10319,'ro','Preliminare',0),(371460,10319,'et','Esialgse',0),(371461,10319,'si','Predhodne',0),(371462,10319,'ba','Pendahuluan',0),(371463,10319,'nl','Voorontwerp',0),(371464,10319,'fi','Alustava',0),(371465,10319,'no','ForelÃ¸pig',0),(371466,10319,'da','ForelÃ¸bige',0),(371467,10319,'ko','ì˜ˆë¹„',0),(371468,10319,'he','×¨××©×•× ×™',0),(371469,10319,'el','Î ÏÎ¿ÎºÎ±Ï„Î±ÏÎºÏ„Î¹ÎºÎ®',0),(371470,10319,'zh','åˆæ­¥\r\n',0),(371471,10319,'sv','PreliminÃ¤ra',0),(371472,10319,'it','Preliminare',0),(371473,10319,'tl','',0),(371474,10319,'th','à¹€à¸šà¸·à¹‰à¸­à¸‡à¸•à¹‰à¸™',0),(371475,10319,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤•',0),(371476,10319,'ms','Awal',0),(371477,10319,'ar','Ø£ÙˆÙ„Ù‰',0),(371478,10319,'fr','PrÃ©liminaire',0),(371479,10319,'jp','äºˆå‚™',0),(371480,10319,'pt','Preliminar',0),(371481,10319,'ru','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹',0),(371482,10319,'es','Preliminario',0),(371483,10319,'de','VorlÃ¤ufige',0),(371484,10319,'en','Preliminary',0),(371485,10320,'is','',0),(371486,10320,'dr','Ù¾ÙŠÙˆØ³Øª Ù‡Ø§ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡',0),(371487,10320,'pr','Ù¾ÙŠÙˆØ³Øª Ù‡Ø§ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡',0),(371488,10320,'tr','Proje montaj detaylarÄ±',0),(371489,10320,'pl','Projekt szczegÃ³Å‚y zaÅ‚Ä…cznikÃ³w',0),(371490,10320,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ñ‡ÐµÐ½Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(371491,10320,'ur','Ù…Ù†Ø³Ù„Ú©Ø§Øª Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(371492,10320,'sr','ÐŸÑ€Ð¾Ñ˜ÐµÐºÐ°Ñ‚ Ñ˜Ðµ Ð´ÐµÑ‚Ð°Ñ™Ð½Ð¾ Ð¿Ñ€Ð¸Ð»Ð¾Ð³Ðµ',0),(371493,10320,'vi','Ä‘Ã­nh kÃ¨m chi tiáº¿t dá»± Ã¡n',0),(371494,10320,'af','Projek Besonderhede Aanhangsels (\"Attachments\")',0),(371495,10320,'ro','Proiect detalii ataÅŸÄƒri',0),(371496,10320,'et','Projekti Ã¼ksikasjad manused',0),(371497,10320,'si','Projekt podrobnosti Priloge',0),(371498,10320,'ba','Proyek rincian lampiran',0),(371499,10320,'nl','Project Details bijlagen',0),(371500,10320,'fi','Projektin tiedot liitteet',0),(371501,10320,'no','Prosjekt detaljer vedlegg',0),(371502,10320,'da','Projekt detaljer vedhÃ¦ftede filer',0),(371503,10320,'ko','í”„ë¡œì íŠ¸ ì„¸ë¶€ ì‚¬í•­ ì²¨ë¶€ íŒŒì¼',0),(371504,10320,'he','×‘×¤×¨×•×™×™×§×˜ ×ž×¤×¨×˜ ×§×‘×¦×™× ×ž×¦×•×¨×¤×™×',0),(371505,10320,'el','Î ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÏƒÏ…Î½Î·Î¼Î¼Î­Î½Î±',0),(371506,10320,'zh','é¡¹ç›®ç»†èŠ‚é™„ä»¶\r\n',0),(371507,10320,'sv','Projektet Detaljer bilagor',0),(371508,10320,'it','Progetto i dettagli allegati',0),(371509,10320,'tl','',0),(371510,10320,'th','à¹à¸™à¸šà¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹‚à¸„à¸£à¸‡à¸à¸²à¸£',0),(371511,10320,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤µà¤¿à¤µà¤°à¤£ à¤¸à¤‚à¤²à¤—à¥à¤¨à¤•',0),(371512,10320,'ms','Butir-butir projek lampiran',0),(371513,10320,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹ ÙÙŠ Ø§Ù„Ù…Ø±ÙÙ‚Ø§Øª',0),(371514,10320,'fr','DÃ©tails du projet grandes piÃ¨ces jointes',0),(371515,10320,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®æ·»ä»˜ãƒ•ã‚¡ã‚¤ãƒ«ã‚’è©³ç´°ã—ã¾ã™ã€‚',0),(371516,10320,'pt','Projeto detalha anexos',0),(371517,10320,'ru','ÐŸÑ€Ð¾ÐµÐºÑ‚ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð²Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(371518,10320,'es','Anexos de Detalles del Proyecto',0),(371519,10320,'de','Projekt Informationen Ã¼ber Anlagen',0),(371520,10320,'en','Project Details Attachments',0),(371521,10321,'is','',0),(371522,10321,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(371523,10321,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(371524,10321,'tr','Proje detaylarÄ± Update',0),(371525,10321,'pl','SzczegÃ³Å‚y projektu aktualizacji',0),(371526,10321,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(371527,10321,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ø§Ù¾ ÚˆÛŒÙ¹',0),(371528,10321,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(371529,10321,'vi','cáº­p nháº­t chi tiáº¿t dá»± Ã¡n',0),(371530,10321,'af','Projek Besonderhede Opdateer',0),(371531,10321,'ro','Actualizare de detalii proiect',0),(371532,10321,'et','Projekti Ã¼ksikasjad Update',0),(371533,10321,'si','Posodobitev podrobnosti projekta',0),(371534,10321,'ba','Update rincian proyek',0),(371535,10321,'nl','Update voor Project Details',0),(371536,10321,'fi','Yksityiskohdat pÃ¤ivitys',0),(371537,10321,'no','Prosjekt detaljer oppdatering',0),(371538,10321,'da','Projekt detaljer opdatering',0),(371539,10321,'ko','í”„ë¡œì íŠ¸ ì„¸ë¶€ ì •ë³´ ì—…ë°ì´íŠ¸',0),(371540,10321,'he','×¢×“×›×•×Ÿ ×¤×¨×˜×™× project',0),(371541,10321,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î­ÏÎ³Î¿Ï…',0),(371542,10321,'zh','é¡¹ç›®ç»†èŠ‚æ›´æ–°\r\n',0),(371543,10321,'sv','Projektet Detaljer uppdatering',0),(371544,10321,'it','Aggiornamento dettagli progetto',0),(371545,10321,'tl','',0),(371546,10321,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹‚à¸„à¸£à¸‡à¸à¸²à¸£',0),(371547,10321,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤µà¤¿à¤µà¤°à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(371548,10321,'ms','Kemaskini butir-butir projek',0),(371549,10321,'ar','ØªØ­Ø¯ÙŠØ« ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(371550,10321,'fr','Mise Ã  jour des informations de projet',0),(371551,10321,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®è©³ç´°ã®æ›´æ–°',0),(371552,10321,'pt','AtualizaÃ§Ã£o de detalhes do projeto',0),(371553,10321,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(371554,10321,'es','Actualizar Detalles del Proyecto',0),(371555,10321,'de','Projekt-Details-Update',0),(371556,10321,'en','Project Details Update',0),(371557,10322,'is','',0),(371558,10322,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø±Ø§ÙŠØ· Ø¬Ù‡Øª Ù…Ø´Ø§Ù‡Ø¯Ù‡ ',0),(371559,10322,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø±Ø§ÙŠØ· Ø¬Ù‡Øª Ù…Ø´Ø§Ù‡Ø¯Ù‡ ',0),(371560,10322,'tr','Hangi durumunu gÃ¶rÃ¼ntÃ¼lemek iÃ§in seÃ§in',0),(371561,10322,'pl','Wybierz jaki stan widoku',0),(371562,10322,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð¸ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð´Ð° Ð¸Ð·Ð³Ð»ÐµÐ´',0),(371563,10322,'ur','Ø¬Ùˆ Ø­Ø§Ù„Øª Ù…Ù†Ø¸Ø± Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(371564,10322,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ¾Ñ˜Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·',0),(371565,10322,'vi','Chá»n nhá»¯ng tÃ¬nh tráº¡ng Ä‘á»ƒ xem',0),(371566,10322,'af','Kies watter Status te wys',0),(371567,10322,'ro','SelectaÅ£i care statut sÄƒ Vezi',0),(371568,10322,'et','Valige Milline staatus vaade',0),(371569,10322,'si','Izberite katere Status pogled',0),(371570,10322,'ba','Pilih mana Status ke tampilan',0),(371571,10322,'nl','Selecteer welke Status weergave',0),(371572,10322,'fi','Valitse NÃ¤ytÃ¤ tila',0),(371573,10322,'no','Velg hvilken Status for Ã¥ vise',0),(371574,10322,'da','VÃ¦lg hvilken Status til at se',0),(371575,10322,'ko','ì–´ë–¤ ìƒíƒœ ë³´ê¸°ë¥¼ ì„ íƒ',0),(371576,10322,'he','×‘×—×¨ ××™×–×” ×ž×¦×‘ ×ª×¦×•×’×”',0),(371577,10322,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€Î¿Î¹Î± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÏƒÏ„Î·Î½ Ï€ÏÎ¿Î²Î¿Î»Î®',0),(371578,10322,'zh','é€‰æ‹©è¦æŸ¥çœ‹å“ªä¸ªçŠ¶æ€\r\n',0),(371579,10322,'sv','VÃ¤lj vilken Status till vy',0),(371580,10322,'it','Selezionare quale Status a vista',0),(371581,10322,'tl','',0),(371582,10322,'th','à¹€à¸¥à¸·à¸­à¸à¸ªà¸–à¸²à¸™à¸°à¸—à¸µà¹ˆà¸ˆà¸°à¸”à¸¹',0),(371583,10322,'hi','à¤œà¥‹ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(371584,10322,'ms','Pilih Status yang ke paparan',0),(371585,10322,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø­Ø§Ù„Ø© Ø§Ù„ØªÙŠ Ù„Ù„Ø¹Ø±Ø¶',0),(371586,10322,'fr','SÃ©lectionnez quel statut Ã  vue',0),(371587,10322,'jp','è¡¨ç¤ºã™ã‚‹ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã‚’é¸æŠžã—ã¾ã™',0),(371588,10322,'pt','Selecione qual Status Ã  vista',0),(371589,10322,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐšÐ°ÐºÐ¾Ð¹ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ',0),(371590,10322,'es','Selccionar Cual Estatus para Visionar',0),(371591,10322,'de','WÃ¤hlen Sie welche Status zur Ansicht',0),(371592,10322,'en','Select Which Status to View',0),(371593,10323,'is','',0),(371594,10323,'dr','Ø¯Ø± Ø­Ø§Ù„ÙŠ ÙƒÙ‡ Ø¨Ù‡ Ø±ÙˆØ² Ù…ÙŠ Ø´ÙˆØ¯',0),(371595,10323,'pr','Ø¯Ø± Ø­Ø§Ù„ÙŠ ÙƒÙ‡ Ø¨Ù‡ Ø±ÙˆØ² Ù…ÙŠ Ø´ÙˆØ¯',0),(371596,10323,'tr','Yenilemeler yaparken',0),(371597,10323,'pl','Podczas aktualizacji',0),(371598,10323,'bg','ÐŸÑ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(371599,10323,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ø¯ÙˆØ±Ø§Ù†',0),(371600,10323,'sr','ÐŸÑ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(371601,10323,'vi','trong khi cáº­p nháº­t',0),(371602,10323,'af','Terwyl die bywerking',0),(371603,10323,'ro','ÃŽn timp ce actualizarea',0),(371604,10323,'et','Kuni uuendab',0),(371605,10323,'si','Med posodabljanjem',0),(371606,10323,'ba','Sementara memperbarui',0),(371607,10323,'nl','Tijdens het bijwerken',0),(371608,10323,'fi','PÃ¤ivitettÃ¤essÃ¤',0),(371609,10323,'no','Under oppdatering',0),(371610,10323,'da','Under opdatering',0),(371611,10323,'ko','ì—…ë°ì´íŠ¸ í•˜ëŠ” ë™ì•ˆ',0),(371612,10323,'he','×‘×¢×ª ×¢×“×›×•×Ÿ',0),(371613,10323,'el','ÎšÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(371614,10323,'zh','åŒæ—¶æ›´æ–°\r\n',0),(371615,10323,'sv','NÃ¤r du uppdaterar',0),(371616,10323,'it','Durante l\'aggiornamento',0),(371617,10323,'tl','',0),(371618,10323,'th','à¸‚à¸“à¸°à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(371619,10323,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ à¤œà¤¬à¤•à¤¿',0),(371620,10323,'ms','Semasa mengemas kini',0),(371621,10323,'ar','Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ«',0),(371622,10323,'fr','En mettant Ã  jour',0),(371623,10323,'jp','æ›´æ–°ä¸­',0),(371624,10323,'pt','Durante a atualizaÃ§Ã£o',0),(371625,10323,'ru','ÐŸÑ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸',0),(371626,10323,'es','Mientra que Actualizar',0),(371627,10323,'de','WÃ¤hrend der Aktualisierung',0),(371628,10323,'en','While Updating',0),(371629,10324,'is','',0),(371630,10324,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ø¨ÙˆØ¯Ø¬Ù‡ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(371631,10324,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ø¨ÙˆØ¯Ø¬Ù‡ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(371632,10324,'tr','Onaylanan bÃ¼tÃ§e deÄŸiÅŸiklikleri',0),(371633,10324,'pl','Zmiany zatwierdzonego budÅ¼etu',0),(371634,10324,'bg','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(371635,10324,'ur','Ù…Ù†Ø¸ÙˆØ± Ø´Ø¯Û Ø¨Ø¬Ù¹ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(371636,10324,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¸ Ð±ÑƒÑŸÐµÑ‚ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(371637,10324,'vi','Thay Ä‘á»• ngÃ¢n sÃ¡ch phÃª duyá»‡t',0),(371638,10324,'af','Goedgekeurde Begroting Veranderinge',0),(371639,10324,'ro','Bugetul aprobat modificÄƒri',0),(371640,10324,'et','Heakskiidetud muudatused',0),(371641,10324,'si','Spremembe odobrenega proraÄuna',0),(371642,10324,'ba','Perubahan anggaran yang telah disetujui',0),(371643,10324,'nl','Goedgekeurde begroting wijzigingen',0),(371644,10324,'fi','HyvÃ¤ksytyn talousarvion muutokset',0),(371645,10324,'no','Godkjent budsjettendringer',0),(371646,10324,'da','Godkendt budgetÃ¦ndringer',0),(371647,10324,'ko','ìŠ¹ì¸ ëœ ì˜ˆì‚° ë³€ê²½',0),(371648,10324,'he','×”×ª×§×¦×™×‘ ×©××•×©×¨ ×©×™× ×•×™×™×',0),(371649,10324,'el','Î‘Î»Î»Î±Î³Î­Ï‚ ÎµÎ³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(371650,10324,'zh','æ ¸å‡†é¢„ç®—å˜æ›´\r\n',0),(371651,10324,'sv','GodkÃ¤nda budgetfÃ¶rÃ¤ndringar',0),(371652,10324,'it','Bilancio approvato modifiche',0),(371653,10324,'tl','',0),(371654,10324,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸—à¸µà¹ˆà¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(371655,10324,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤¬à¤œà¤Ÿ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(371656,10324,'ms','Bajet perubahan',0),(371657,10324,'ar','Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª ÙÙŠ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ù…Ø¹ØªÙ…Ø¯Ø©',0),(371658,10324,'fr','Budget approuvÃ© des changements',0),(371659,10324,'jp','æ‰¿èªã•ã‚ŒãŸäºˆç®—ã®å¤‰æ›´',0),(371660,10324,'pt','AlteraÃ§Ãµes do orÃ§amento aprovado',0),(371661,10324,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ð¾Ð³Ð¾ Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(371662,10324,'es','Cambios del Presupuesto Aprobados',0),(371663,10324,'de','Ã„nderungen des genehmigten Finanzplans',0),(371664,10324,'en','Approved Budget Changes',0),(371665,10325,'is','',0),(371666,10325,'dr','ØªØºÙŠÙŠØ± Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ø´Ø¯',0),(371667,10325,'pr','ØªØºÙŠÙŠØ± Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÙŠÙŠØ¯ Ø´Ø¯',0),(371668,10325,'tr','OnaylÄ± sÄ±ra deÄŸiÅŸtirme iÅŸlemi sayÄ±sÄ±',0),(371669,10325,'pl','Zatwierdza zmiany zamÃ³wienia',0),(371670,10325,'bg','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(371671,10325,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(371672,10325,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð¸Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(371673,10325,'vi','CÃ¡c lÃªnh thay Ä‘á»•i phÃª duyá»‡t',0),(371674,10325,'af','Goedgekeurde Veranderde Bestellings',0),(371675,10325,'ro','Aprobat schimbarea comenzi',0),(371676,10325,'et','Heaks muutuste tellimused',0),(371677,10325,'si','Odobreni spremembi naroÄila',0),(371678,10325,'ba','Disetujui perintah perubahan',0),(371679,10325,'nl','Wijzigingsopdrachten goedgekeurd',0),(371680,10325,'fi','HyvÃ¤ksytty muuttamisen',0),(371681,10325,'no','Godkjent endringsordrer',0),(371682,10325,'da','Godkendt Ã¦ndring ordrer',0),(371683,10325,'ko','ì£¼ë¬¸ ë³€ê²½ ìŠ¹ì¸',0),(371684,10325,'he','××™×©×•×¨ ×©×™× ×•×™ ×”×•×¨××•×ª',0),(371685,10325,'el','Î•Î³ÎºÏÎ¹Î¸ÎµÎ¯ Î±Î»Î»Î±Î³Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(371686,10325,'zh','æ‰¹å‡†çš„å˜æ›´è®¢å•\r\n',0),(371687,10325,'sv','GodkÃ¤nda Ã¤ndringsorder',0),(371688,10325,'it','Approvati gli ordini di modifica',0),(371689,10325,'tl','',0),(371690,10325,'th','à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(371691,10325,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥€',0),(371692,10325,'ms','Meluluskan arahan perubahan',0),(371693,10325,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø± Ø§Ù„ØªØºÙŠÙŠØ±',0),(371694,10325,'fr','Approbation des avenants',0),(371695,10325,'jp','å¤‰æ›´å‘½ä»¤ã‚’æ‰¿èª',0),(371696,10325,'pt','AprovaÃ§Ã£o de ordens de alteraÃ§Ã£o',0),(371697,10325,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ñ… Ñ€Ð°ÑÐ¿Ð¾Ñ€ÑÐ¶ÐµÐ½Ð¸Ð¹ Ð¾Ð± Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¸',0),(371698,10325,'es','Ordenes de Cambios Aprobados',0),(371699,10325,'de','Ã„nderungsbefehle genehmigt',0),(371700,10325,'en','Approved Change Orders',0),(371701,10326,'is','',0),(371702,10326,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(371703,10326,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ØªØ§ Ø§ÙŠÙ† ØªØ§Ø±ÙŠØ® ',0),(371704,10326,'tr','Maliyet, Tarih',0),(371705,10326,'pl','Koszt do data',0),(371706,10326,'bg','Ð¦ÐµÐ½Ð°-ÐºÑŠÐ¼-Ð´Ð°Ñ‚Ð°',0),(371707,10326,'ur','ØªØ§Ø±ÛŒØ® Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù‚ÛŒÙ…Øª',0),(371708,10326,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(371709,10326,'vi','chi phÃ­ Ä‘áº¿n ngÃ y',0),(371710,10326,'af','Koste-tot-Datum',0),(371711,10326,'ro','Costul la data',0),(371712,10326,'et','Kulu kuupÃ¤ev',0),(371713,10326,'si','StroÅ¡ki do datuma',0),(371714,10326,'ba','Biaya-to-Date',0),(371715,10326,'nl','Kosten-to-Date',0),(371716,10326,'fi','Kustannukset tÃ¤hÃ¤n saakka',0),(371717,10326,'no','Kostnadene hittil',0),(371718,10326,'da','Cost-to-Date',0),(371719,10326,'ko','ë¹„ìš©-ë‚ ì§œ',0),(371720,10326,'he','×¢×œ×•×ª ×¢×“ ×”×™×•×',0),(371721,10326,'el','ÎšÏŒÏƒÏ„Î¿Ï‚-to-Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(371722,10326,'zh','æˆæœ¬å¯¹æ—¥æœŸ\r\n',0),(371723,10326,'sv','Kostnad-till-datum',0),(371724,10326,'it','Costo alla data',0),(371725,10326,'tl','',0),(371726,10326,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸•à¹ˆà¸­à¸§à¸±à¸™',0),(371727,10326,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(371728,10326,'ms','Kos sehingga kini',0),(371729,10326,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø­ØªÙ‰ Ù‡Ø°Ù‡ Ø§Ù„Ù„Ø­Ø¸Ø©',0),(371730,10326,'fr','CoÃ»t Ã  ce jour',0),(371731,10326,'jp','ç¾åœ¨ã¾ã§ã®ã‚³ã‚¹ãƒˆ',0),(371732,10326,'pt','Custo-to-Date',0),(371733,10326,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ðº Ð”Ð°Ñ‚Ð°',0),(371734,10326,'es','Costo-a-la Fecha',0),(371735,10326,'de','Kosten-to-Date',0),(371736,10326,'en','Cost-to-Date',0),(371737,10327,'is','',0),(371738,10327,'dr','Ù…ØºØ§ÙŠØ±Øª Ø´ØºÙ„ ',0),(371739,10327,'pr','Ù…ØºØ§ÙŠØ±Øª Ø´ØºÙ„ ',0),(371740,10327,'tr','Ä°ÅŸ varyans',0),(371741,10327,'pl','Odchylenie pracy',0),(371742,10327,'bg','Ð”Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ñ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(371743,10327,'ur','Ø¬Ø§Ø¨ ØªØºÛŒØ±',0),(371744,10327,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð¾Ð´ÑÑ‚ÑƒÐ¿Ð°ÑšÐ°',0),(371745,10327,'vi','cÃ´ng viá»‡c khÃ¡c nhau',0),(371746,10327,'af','Werkstuk Afwyking',0),(371747,10327,'ro','Job varianÅ£a',0),(371748,10327,'et','TÃ¶Ã¶ dispersioon',0),(371749,10327,'si','Delo Variance',0),(371750,10327,'ba','Varians pekerjaan',0),(371751,10327,'nl','Afwijking van werk',0),(371752,10327,'fi','TyÃ¶n varianssi',0),(371753,10327,'no','Jobb avvik',0),(371754,10327,'da','Job varians',0),(371755,10327,'ko','ìž‘ì—… ë¶„ì‚°',0),(371756,10327,'he','×”×¢×‘×•×“×” ×”×©×•× ×•×ª',0),(371757,10327,'el','Î”Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(371758,10327,'zh','æ‹›è˜å·®å¼‚\r\n',0),(371759,10327,'sv','Jobb varians',0),(371760,10327,'it','Varianza di lavoro',0),(371761,10327,'tl','',0),(371762,10327,'th','à¸‡à¸²à¸™à¸•à¹ˆà¸²à¸‡',0),(371763,10327,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤µà¤¿à¤šà¤°à¤£',0),(371764,10327,'ms','Perbezaan pekerjaan',0),(371765,10327,'ar','Ø§Ù„ÙØ±Ù‚ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(371766,10327,'fr','Variation de l\'emploi',0),(371767,10327,'jp','ã‚¸ãƒ§ãƒ–ã®å·®ç•°',0),(371768,10327,'pt','VariaÃ§Ã£o de emprego',0),(371769,10327,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð´Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ñ',0),(371770,10327,'es','VariaciÃ³n en el Trabajo',0),(371771,10327,'de','Job Varianz',0),(371772,10327,'en','Job Variance',0),(371773,10328,'is','',0),(371774,10328,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…ØºØ§ÙŠØ±Øª Ø´ØºÙ„ ',0),(371775,10328,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…ØºØ§ÙŠØ±Øª Ø´ØºÙ„ ',0),(371776,10328,'tr','Ä°ÅŸ varyans raporu',0),(371777,10328,'pl','Praca wariancji raportu',0),(371778,10328,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð´Ð¸ÑÐ¿ÐµÑ€ÑÐ¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(371779,10328,'ur','Ø¬Ø§Ø¨ ØªØºÛŒØ± Ø±Ù¾ÙˆØ±Ù¹',0),(371780,10328,'sr','Ð˜Ð·Ð²Ñ˜ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð¿Ð¾ÑÐ»Ñƒ Ð¾Ð´ÑÑ‚ÑƒÐ¿Ð°ÑšÐ°',0),(371781,10328,'vi','bÃ¡o cÃ¡o cÃ´ng viá»‡c khÃ¡c nhau',0),(371782,10328,'af','Werkstuk Afwykingsverslag',0),(371783,10328,'ro','Raport de variaÅ£ie Job',0),(371784,10328,'et','TÃ¶Ã¶ dispersiooni aruanne',0),(371785,10328,'si','Zaposlitve poroÄilo Variance',0),(371786,10328,'ba','Pekerjaan varians laporan',0),(371787,10328,'nl','Variantie taakrapport',0),(371788,10328,'fi','Varianssi tyÃ¶raportin',0),(371789,10328,'no','Varians jobbrapport',0),(371790,10328,'da','Job varians rapport',0),(371791,10328,'ko','ìž‘ì—… ì°¨ì´ ë³´ê³ ì„œ',0),(371792,10328,'he','×”×¢×‘×•×“×” ×”×©×•× ×•×ª ×—',0),(371793,10328,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î­ÎºÎ¸ÎµÏƒÎ· Î´Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ·',0),(371794,10328,'zh','å·¥ä½œå·®å¼‚æŠ¥å‘Š\r\n',0),(371795,10328,'sv','Jobb varians rapport',0),(371796,10328,'it','Variazione rapporto di lavoro',0),(371797,10328,'tl','',0),(371798,10328,'th','à¸‡à¸²à¸™à¸£à¸²à¸¢à¸‡à¸²à¸™à¸œà¸¥à¸•à¹ˆà¸²à¸‡',0),(371799,10328,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤µà¤¿à¤šà¤°à¤£ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(371800,10328,'ms','Laporan varians kerja',0),(371801,10328,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ÙØ±Ù‚ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(371802,10328,'fr','Emploi rapport de Variance',0),(371803,10328,'jp','ã‚¸ãƒ§ãƒ– ãƒ¬ãƒãƒ¼ãƒˆã®å·®ç•°',0),(371804,10328,'pt','RelatÃ³rio de variaÃ§Ã£o do emprego',0),(371805,10328,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¾Ñ‚ÐºÐ»Ð¾Ð½ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(371806,10328,'es','informe de VariaciÃ³nes del Trabajo',0),(371807,10328,'de','Auftragsbericht Varianz',0),(371808,10328,'en','Job Variance Report',0),(371809,10329,'is','',0),(371810,10329,'dr','SB/PO',0),(371811,10329,'pr','Ø®Ø§Ù„Øµ Ù…ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø¨Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  SB/PO',0),(371812,10329,'tr','NET taahhÃ¼t SB/PO',0),(371813,10329,'pl','Netto popeÅ‚nione SB/PO',0),(371814,10329,'bg','ÐÐµÑ‚Ð¾ Ð°Ð½Ð³Ð°Ð¶Ð¸Ñ€Ð° SB/PO',0),(371815,10329,'ur','Ø®Ø§Ù„Øµ Ø¹Ø²Ù… SB/Ù¾Ùˆ',0),(371816,10329,'sr','ÐÐµÑ‚Ð¾ Ð¿Ð¾Ñ‡Ð¸ÑšÐµÐ½Ð¸ ÐŸÐž/Ð¡Ð‘',0),(371817,10329,'vi','Net Committed SB/PO',0),(371818,10329,'af','Netto verbind PO/SB',0),(371819,10329,'ro','Net angajat SB/PO',0),(371820,10329,'et','Kasuliku toime SB/PK',0),(371821,10329,'si','Neto zavezana SB/PO',0),(371822,10329,'ba','Berkomitmen SB bersih/PO',0),(371823,10329,'nl','Netto vastgelegd SB/PO',0),(371824,10329,'fi','NET sitoutunut SB/pl',0),(371825,10329,'no','Netto forpliktet SB/PO',0),(371826,10329,'da','Netto engageret SB/PO',0),(371827,10329,'ko','Net ìµœì„ ì„ ë‹¤í•˜ê³  SB/í¬',0),(371828,10329,'he','× ×˜×• ×ž×—×•×™×‘×ª SB/×¤×•',0),(371829,10329,'el','ÎšÎ±Î¸Î±ÏÎ® Î´ÎµÏƒÎ¼ÎµÏ…Ï„ÎµÎ¯ SB/PO',0),(371830,10329,'zh','å‡€å§”æ‰˜çš„æœåŠ¡å…¬å‘Š/é‡‡è´­è®¢å•\r\n',0),(371831,10329,'sv','Net engagerade SB/PO',0),(371832,10329,'it','Netto impegnato SB/PO',0),(371833,10329,'tl','',0),(371834,10329,'th','à¸ªà¸¸à¸—à¸˜à¸´à¸¡à¸±à¹ˆà¸™ SB/PO',0),(371835,10329,'hi','à¤¨à¥‡à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§ SB/PO',0),(371836,10329,'ms','Bersih komited SB/PO',0),(371837,10329,'ar','SB Ù…Ù„ØªØ²Ù…Ø© ØµØ§ÙÙŠ/Ø¨Ùˆ',0),(371838,10329,'fr','NET engagÃ© SB/PO',0),(371839,10329,'jp','Net ã®ã‚³ãƒŸãƒƒãƒˆ SB PO',0),(371840,10329,'pt','LÃ­quida comprometida SB/PO',0),(371841,10329,'ru','NET ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð¾ SB/PO',0),(371842,10329,'es','Neto SB/OC Obligatorio',0),(371843,10329,'de','NET Foul SB/PO',0),(371844,10329,'en','Net Committed PO/SB',0),(371845,10330,'is','',0),(371846,10330,'dr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø§ØµÙ„ÙŠ',0),(371847,10330,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø§ØµÙ„ÙŠ',0),(371848,10330,'tr','Ã–zgÃ¼n tahmin',0),(371849,10330,'pl','PierwotnÄ… prognozÄ™',0),(371850,10330,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(371851,10330,'ur','Ø§ØµÙ„ ØªØ®Ù…ÛŒÙ†Û',0),(371852,10330,'sr','ÐŸÑ€Ð²Ð¾Ð±Ð¸Ñ‚Ð½Ñƒ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñƒ',0),(371853,10330,'vi','Sá»‘ gá»‘c dá»± tÃ­nh',0),(371854,10330,'af','Oorspronklike Skatting',0),(371855,10330,'ro','Estimarea originalÄƒ',0),(371856,10330,'et','Esialgne hinnang',0),(371857,10330,'si','ZaÄetna ocena',0),(371858,10330,'ba','Perkiraan awal',0),(371859,10330,'nl','Oorspronkelijke schatting',0),(371860,10330,'fi','AlkuperÃ¤istÃ¤ arviota',0),(371861,10330,'no','Opprinnelige estimat',0),(371862,10330,'da','Oprindelige skÃ¸n',0),(371863,10330,'ko','ì›ëž˜ ì˜ˆìƒ ê°’',0),(371864,10330,'he','×œ×”×¢×¨×›×•×ª ×”×¨××©×•× ×™×•×ª',0),(371865,10330,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ·',0),(371866,10330,'zh','åŽŸæ¥é¢„ç®—\r\n',0),(371867,10330,'sv','Ursprungliga uppskattning',0),(371868,10330,'it','Stima originale',0),(371869,10330,'tl','',0),(371870,10330,'th','à¸›à¸£à¸°à¹€à¸¡à¸´à¸™à¸•à¹‰à¸™à¸‰à¸šà¸±à¸š',0),(371871,10330,'hi','à¤®à¥‚à¤² à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(371872,10330,'ms','Anggaran asal',0),(371873,10330,'ar','Ø§Ù„ØªÙ‚Ø¯ÙŠØ± Ø§Ù„Ø£ØµÙ„ÙŠ',0),(371874,10330,'fr','Estimation d\'origine',0),(371875,10330,'jp','å…ƒã®è¦‹ç©ã‚‚ã‚Š',0),(371876,10330,'pt','Estimativa original',0),(371877,10330,'ru','Ð˜ÑÑ…Ð¾Ð´Ð½Ð°Ñ Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(371878,10330,'es','EstimaciÃ³n Original',0),(371879,10330,'de','UrsprÃ¼nglichen SchÃ¤tzung',0),(371880,10330,'en','Original Estimate',0),(371881,10331,'is','',0),(371882,10331,'dr','/ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø§ØµÙ„ÙŠ',0),(371883,10331,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ØµÙ„ÙŠ / ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø§ØµÙ„ÙŠ',0),(371884,10331,'tr','Orijinal PO/SB',0),(371885,10331,'pl','Oryginalny PO/SB',0),(371886,10331,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÐµÐ½ PO/SB',0),(371887,10331,'ur','Ø§ØµÙ„ Ù¾ÙˆØ³Ù¹/SB',0),(371888,10331,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ ÐŸÐž/Ð¡Ð‘',0),(371889,10331,'vi','PO/SB gá»‘c',0),(371890,10331,'af','Oorspronklike PO/SB',0),(371891,10331,'ro','Original PO/SB',0),(371892,10331,'et','Algne PO/SB',0),(371893,10331,'si','Original PO/SB',0),(371894,10331,'ba','PO/SB asli',0),(371895,10331,'nl','Oorspronkelijke PO/SB',0),(371896,10331,'fi','AlkuperÃ¤inen PO/SB',0),(371897,10331,'no','Opprinnelige PO/SB',0),(371898,10331,'da','Oprindelige PO/SB',0),(371899,10331,'ko','ì›ëž˜ í¬/SB',0),(371900,10331,'he','×¤×• ×”×ž×§×•×¨×™/SB',0),(371901,10331,'el','Î‘ÏÏ‡Î¹ÎºÎ® PO/SB',0),(371902,10331,'zh','åŽŸè®¢å•/æœåŠ¡å…¬å‘Š\r\n',0),(371903,10331,'sv','Ursprungliga PO/SB',0),(371904,10331,'it','Originale PO/SB',0),(371905,10331,'tl','',0),(371906,10331,'th','PO à¹€à¸”à¸´à¸¡ SB',0),(371907,10331,'hi','à¤®à¥‚à¤² à¤ªà¥‹/SB',0),(371908,10331,'ms','PO/SB asal',0),(371909,10331,'ar','Øµ. Ø¨/SB Ø§Ù„Ø£ØµÙ„ÙŠ',0),(371910,10331,'fr','Original PO/SB',0),(371911,10331,'jp','å…ƒã® PO/SB',0),(371912,10331,'pt','PO/SB original',0),(371913,10331,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ PO/SB',0),(371914,10331,'es','OC/SB Original',0),(371915,10331,'de','Original PO/SB',0),(371916,10331,'en','Original PO/SB',0),(371917,10332,'is','',0),(371918,10332,'dr','( ØªØ¹Ù‡Ø¯',0),(371919,10332,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø§Ø¬Ø±Ø§( ØªØ¹Ù‡Ø¯',0),(371920,10332,'tr','TaahhÃ¼t kaldÄ±',0),(371921,10332,'pl','PozostaÅ‚e do popeÅ‚nienia',0),(371922,10332,'bg','ÐžÑÑ‚Ð°Ð²Ð° Ð´Ð° ÑÐµ Ð°Ð½Ð³Ð°Ð¶Ð¸Ñ€Ð°Ñ‚',0),(371923,10332,'ur','Ø¨Ø§Ù‚ÛŒ Ú©Û’ Ù„Ø¦Û’ Ú©Ø±ØªÛ’',0),(371924,10332,'sr','ÐŸÑ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾ Ð·Ð° Ð¿Ð¾Ñ…Ñ€Ð°ÑšÐ¸Ð²Ð°ÑšÐµ',0),(371925,10332,'vi','cÃ²n láº¡i Ä‘á»ƒ chuyá»ƒn',0),(371926,10332,'af','Oorblywende te pleeg',0),(371927,10332,'ro','RÄƒmase sÄƒ se angajeze',0),(371928,10332,'et','ÃœlejÃ¤Ã¤nud kinnitamine',0),(371929,10332,'si','Preostale objave',0),(371930,10332,'ba','Tersisa untuk komit',0),(371931,10332,'nl','Resterende naar Commit',0),(371932,10332,'fi','JÃ¤ljellÃ¤ Commit',0),(371933,10332,'no','Igjen til utfÃ¸ring',0),(371934,10332,'da','Tilbage til at begÃ¥',0),(371935,10332,'ko','ì»¤ë°‹ í•˜ê¸°ê¹Œì§€ ë‚¨ì€',0),(371936,10332,'he','×©× ×•×ª×¨ ×›×“×™ ×œ×”×ª×—×™×™×‘',0),(371937,10332,'el','Î‘Ï€Î¿Î¼Î­Î½ÎµÎ¹ Î½Î± Î´Î¹Î±Ï€ÏÎ¬Î¾Î¿Ï…Î½',0),(371938,10332,'zh','å‰©ä½™æäº¤\r\n',0),(371939,10332,'sv','Resterande att begÃ¥',0),(371940,10332,'it','Rimanendo a Commit',0),(371941,10332,'tl','',0),(371942,10332,'th','à¹€à¸«à¸¥à¸·à¸­à¸—à¸µà¹ˆà¸ˆà¸°à¸¢à¸·à¸™à¸¢à¸±à¸™',0),(371943,10332,'hi','à¤¶à¥‡à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§',0),(371944,10332,'ms','Tinggal untuk melakukan perbuatan keji',0),(371945,10332,'ar','Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ© Ù„Ù„Ø§Ù„ØªØ²Ø§Ù…',0),(371946,10332,'fr','Restant Ã  engager',0),(371947,10332,'jp','ã‚³ãƒŸãƒƒãƒˆã™ã‚‹æ®‹ã‚Š',0),(371948,10332,'pt','Restante para Commit',0),(371949,10332,'ru','ÐžÑÑ‚Ð°Ð²ÑˆÐ¸ÐµÑÑ Ð´Ð»Ñ Ñ„Ð¸ÐºÑÐ°Ñ†Ð¸Ð¸',0),(371950,10332,'es','Lo Que Queda Para Aplicar',0),(371951,10332,'de','Verbliebenen Commit',0),(371952,10332,'en','Remaining to Commit',0),(371953,10333,'is','',0),(371954,10333,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(371955,10333,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(371956,10333,'tr','Toplam yeni tahmin',0),(371957,10333,'pl','Oszacowania caÅ‚kowitej',0),(371958,10333,'bg','ÐžÐ±Ñ‰Ð¾ Ð½Ð¾Ð²Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(371959,10333,'ur','Ú©Ù„ Ù†ÛŒØ§ ØªØ®Ù…ÛŒÙ†Û',0),(371960,10333,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ð½Ð¾Ð²Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°',0),(371961,10333,'vi','Tá»•ng Æ°á»›c tÃ­nh má»›i',0),(371962,10333,'af','Totale Nuwe Skatting',0),(371963,10333,'ro','Estimarea nou totalÄƒ',0),(371964,10333,'et','Kokku uue hinnangu',0),(371965,10333,'si','Nova skupno oceno',0),(371966,10333,'ba','Total perkiraan baru',0),(371967,10333,'nl','Totaal nieuwe schatting',0),(371968,10333,'fi','YhteensÃ¤ uusi arvio',0),(371969,10333,'no','Totalt ny forhÃ¥ndsberegning',0),(371970,10333,'da','Total ny skÃ¸n',0),(371971,10333,'ko','ì´ ìƒˆë¡œìš´ ê²¬ì ',0),(371972,10333,'he','×”×¢×¨×›×” ×—×“×©×” ×œ×’×ž×¨×™',0),(371973,10333,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® ÎµÎºÏ„Î¯Î¼Î·ÏƒÎ· Î½Î­Î±',0),(371974,10333,'zh','æ€»è®¡æ–°ä¼°è®¡\r\n',0),(371975,10333,'sv','Totalt ny uppskattning',0),(371976,10333,'it','Totale nuova stima',0),(371977,10333,'tl','',0),(371978,10333,'th','à¸›à¸£à¸°à¹€à¸¡à¸´à¸™à¹ƒà¸«à¸¡à¹ˆà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(371979,10333,'hi','à¤•à¥à¤² à¤¨à¤ à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(371980,10333,'ms','Jumlah anggaran yang baru',0),(371981,10333,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ØªÙ‚Ø¯ÙŠØ±Ø§Øª Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(371982,10333,'fr','Totale nouvelle estimation',0),(371983,10333,'jp','åˆè¨ˆã®æ–°ã—ã„è¦‹ç©ã‚‚ã‚Š',0),(371984,10333,'pt','Total estimado de novo',0),(371985,10333,'ru','Ð’ÑÐµÐ³Ð¾ Ð½Ð¾Ð²Ð°Ñ Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(371986,10333,'es','Total Nuevo EstimaciÃ³n',0),(371987,10333,'de','Total neue SchÃ¤tzung',0),(371988,10333,'en','Total New Estimate',0),(371989,10334,'is','',0),(371990,10334,'dr','(Ù‚Ø±Ø¹Ù‡ ÙƒØ´ÙŠ â€“ Ø­ÙˆØ§Ù„Ù‡ ) Ø¬Ø¯ÙŠØ¯ ',0),(371991,10334,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø±Ø³Ù… (Ù‚Ø±Ø¹Ù‡ ÙƒØ´ÙŠ â€“ Ø­ÙˆØ§Ù„Ù‡ ) Ø¬Ø¯ÙŠØ¯ ',0),(371992,10334,'tr','Yeni Ã‡izim Ekle',0),(371993,10334,'pl','Dodawanie nowych',0),(371994,10334,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð ÐµÐ¼Ð¸',0),(371995,10334,'ur','Ù†Ø¦Û’ ÚˆØ±Ø§ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(371996,10334,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð° Ð¿Ñ€Ð¸Ð²Ð»Ð°Ñ‡Ð½Ð°',0),(371997,10334,'vi','ThÃªm pháº§n má»›i',0),(371998,10334,'af','Voeg nuwe teken',0),(371999,10334,'ro','Adauga noi Draw',0),(372000,10334,'et','Lisage uus viik',0),(372001,10334,'si','Dodajte novo Å¾rebanje',0),(372002,10334,'ba','Tambahkan gambar baru',0),(372003,10334,'nl','Toevoegen van nieuwe Draw',0),(372004,10334,'fi','LisÃ¤Ã¤ uusi tehtÃ¤vÃ¤',0),(372005,10334,'no','Legg til ny trekning',0),(372006,10334,'da','TilfÃ¸je nye Draw',0),(372007,10334,'ko','ìƒˆ ê·¸ë¦¬ê¸° ì¶”ê°€',0),(372008,10334,'he','×”×•×¡×£ ×¦×™×•×¨ ×—×“×©',0),(372009,10334,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÎºÎ»Î®ÏÏ‰ÏƒÎ·',0),(372010,10334,'zh','å¢žåŠ æ–°ææ¬¾\r\n',0),(372011,10334,'sv','LÃ¤gg till nya Draw',0),(372012,10334,'it','Aggiungi nuovo sorteggio',0),(372013,10334,'tl','',0),(372014,10334,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸­à¸­à¸à¹ƒà¸«à¸¡à¹ˆ',0),(372015,10334,'hi','à¤¨à¤¯à¤¾ à¤†à¤•à¤°à¥à¤·à¤£ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(372016,10334,'ms','Tambah Seri baru',0),(372017,10334,'ar','Ø¥Ø¶Ø§ÙØ© Ø±Ø³Ù… Ø¬Ø¯ÙŠØ¯',0),(372018,10334,'fr','Ajouter nouveau tirage au sort',0),(372019,10334,'jp','æ–°ã—ã„æç”»ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(372020,10334,'pt','Adicionar novo sorteio',0),(372021,10334,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ€Ð¾Ð·Ñ‹Ð³Ñ€Ñ‹Ñˆ',0),(372022,10334,'es','Agregar Nuevo Retiro de Dinero',0),(372023,10334,'de','FÃ¼gen Sie neue Auslosung',0),(372024,10334,'en','Add New Draw',0),(372025,10335,'is','',0),(372026,10335,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù‚Ø±Ø¹Ù‡ ÙƒØ´ÙŠ Ù‡Ø§(Ú¯Ø±Ø§ÙÙ‡Ø§)',0),(372027,10335,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‚Ø±Ø¹Ù‡ ÙƒØ´ÙŠ Ù‡Ø§(Ù†Ù…ÙˆØ¯Ø§Ø±Ù‡Ø§)',0),(372028,10335,'tr','Berabere ekleyin/gÃ¼ncelleyin',0),(372029,10335,'pl','Dodaj/Aktualizuj rysuje',0),(372030,10335,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð²ÐµÐ½ÑÑ‚Ð²Ð°',0),(372031,10335,'ur','Ø¨Ù†Ø§ØªØ§ ÛÛ’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(372032,10335,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ñ†Ñ€Ñ‚Ð°',0),(372033,10335,'vi','ThÃªm/cáº­p nháº­t ',0),(372034,10335,'af','Voeg/Update trek',0),(372035,10335,'ro','AdÄƒugaÅ£i/actualizaÅ£i atrage',0),(372036,10335,'et','Lisa/vÃ¤rskenda viiki',0),(372037,10335,'si','Dodaj/posodobi Ärpa',0),(372038,10335,'ba','Tambahkan/Perbarui menarik',0),(372039,10335,'nl','Vestigt toevoegen/bijwerken',0),(372040,10335,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ kiinnittÃ¤Ã¤',0),(372041,10335,'no','Legg til/Oppdater trekker',0),(372042,10335,'da','TilfÃ¸j/opdater trÃ¦kker',0),(372043,10335,'ko','ë¬´ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(372044,10335,'he','×”×•×¡×£/×¢×“×›×Ÿ ×©×•××‘×ª',0),(372045,10335,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¹ÏƒÎ¿Ï€Î±Î»Î¯ÎµÏ‚',0),(372046,10335,'zh','å¢žåŠ /æ›´æ–°ææ¬¾\r\n',0),(372047,10335,'sv','LÃ¤gg till/uppdatera drar',0),(372048,10335,'it','Aggiungere o aggiornare le estrazioni',0),(372049,10335,'tl','',0),(372050,10335,'th','à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸§à¸²à¸”',0),(372051,10335,'hi','à¤¡à¥à¤°à¥‰ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(372052,10335,'ms','Tambah/Kemaskini menarik',0),(372053,10335,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« ØªÙˆØ¬Ù‡',0),(372054,10335,'fr','Ajouter/mettre Ã  jour des tirages au sort',0),(372055,10335,'jp','æç”»ã‚’è¿½åŠ /æ›´æ–°',0),(372056,10335,'pt','Adicionar/atualizar empates',0),(372057,10335,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð½Ð¸Ñ‡ÑŒÐ¸Ñ…',0),(372058,10335,'es','Agregar/Actualizar Retiros de Dinero',0),(372059,10335,'de','Zieht hinzufÃ¼gen/aktualisieren',0),(372060,10335,'en','Add/Update Draws',0),(372061,10336,'is','',0),(372062,10336,'dr','ØªØ§ÙŠÙŠØ¯ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ Ø¬Ù‡Øª Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡ Ø­Ø³Ø§Ø¨ ',0),(372063,10336,'pr','ØªØ§ÙŠÙŠØ¯ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ Ø¬Ù‡Øª Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡ Ø­Ø³Ø§Ø¨ ',0),(372064,10336,'tr','AP faturalarÄ± iÃ§erecek ÅŸekilde',0),(372065,10336,'pl','AP rachunki do',0),(372066,10336,'bg','AP ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð´Ð° ÑÐµ Ð²ÐºÐ»ÑŽÑ‡Ð°Ñ‚',0),(372067,10336,'ur','AP Ú©Û’ Ø¨Ù„ Ú©Ùˆ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(372068,10336,'sr','ÐÐŸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð´Ð° ÑƒÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ',0),(372069,10336,'vi','CÃ¡c hÃ³a Ä‘Æ¡n thanh toÃ¡n Ä‘á»ƒ bao gá»“m',0),(372070,10336,'af','RB Rekeninge vir Insluiting',0),(372071,10336,'ro','AP facturile pentru a Include',0),(372072,10336,'et','AP arveid kaasamiseks',0),(372073,10336,'si','AP menice vkljuÄiti',0),(372074,10336,'ba','AP tagihan untuk memasukkan',0),(372075,10336,'nl','AP rekeningen op te nemen',0),(372076,10336,'fi','AP laskut ovat',0),(372077,10336,'no','AP regninger Ã¥ inkludere',0),(372078,10336,'da','AP regninger til ogsÃ¥ at omfatte',0),(372079,10336,'ko','í¬í•¨ í•´ì•¼í•  AP',0),(372080,10336,'he','AP ×©×˜×¨×•×ª ×›×“×™ ×œ×›×œ×•×œ',0),(372081,10336,'el','AP Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚, Î½Î± Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½',0),(372082,10336,'zh','åŒ…æ‹¬åº”ä»˜è´¦æ¬¾çš„è´¦å•\r\n',0),(372083,10336,'sv','AP rÃ¤kningar att inkludera',0),(372084,10336,'it','AP bollette per includere',0),(372085,10336,'tl','',0),(372086,10336,'th','AP à¸•à¸±à¹‹à¸§à¸£à¸§à¸¡',0),(372087,10336,'hi','à¤à¤ªà¥€ à¤¬à¤¿à¤²à¥‹à¤‚ à¤•à¥‹ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(372088,10336,'ms','Bil AP termasuk',0),(372089,10336,'ar','ÙÙˆØ§ØªÙŠØ± ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³ ØªØ´Ù…Ù„',0),(372090,10336,'fr','AP factures Ã  inclure',0),(372091,10336,'jp','Ap é€šä¿¡æ³•æ¡ˆã‚’å«ã‚ã‚‹',0),(372092,10336,'pt','Contas de AP para incluir',0),(372093,10336,'ru','AP ÑÑ‡ÐµÑ‚Ð° Ð²ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ',0),(372094,10336,'es','Recibos de CP para Incluir',0),(372095,10336,'de','AP-Rechnungen enthalten',0),(372096,10336,'en','AP Bills to Include',0),(372097,10337,'is','',0),(372098,10337,'dr','ØªØ±Ø§Ø² Ø¬Ù‡Øª Ù¾Ø§ÙŠØ§Ù† ',0),(372099,10337,'pr','ØªØ±Ø§Ø² Ø¬Ù‡Øª Ù¾Ø§ÙŠØ§Ù† ',0),(372100,10337,'tr','Denge bitirmek iÃ§in',0),(372101,10337,'pl','Saldo do koÅ„ca',0),(372102,10337,'bg','Ð¡Ð°Ð»Ð´Ð¾ Ð´Ð¾ Ñ„Ð¸Ð½Ð°Ð»Ð°',0),(372103,10337,'ur','ØªÙˆØ§Ø²Ù† Ú©ÛŒ ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ù„Ø¦Û’',0),(372104,10337,'sr','Ð¡Ð°Ð»Ð´Ð¾ Ð´Ð° Ð·Ð°Ð²Ñ€ÑˆÐ¸',0),(372105,10337,'vi','CÃ¢n Ä‘á»‘i Ä‘á»ƒ hoÃ n táº¥t',0),(372106,10337,'af','Balans om te Eindig',0),(372107,10337,'ro','Echilibrul pentru a termina',0),(372108,10337,'et','Tasakaalu lÃµpuni',0),(372109,10337,'si','Saldo do konca',0),(372110,10337,'ba','Keseimbangan untuk selesai',0),(372111,10337,'nl','Evenwicht te voltooien',0),(372112,10337,'fi','Tasapaino loppuun',0),(372113,10337,'no','Balanse til slutt',0),(372114,10337,'da','Balance til Finish',0),(372115,10337,'ko','ëì— ê· í˜•',0),(372116,10337,'he','××™×–×•×Ÿ ×›×“×™ ×œ×¡×™×™×',0),(372117,10337,'el','Î™ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± Î¼Î­Ï‡ÏÎ¹ Ï„Î­Î»Î¿Ï‚',0),(372118,10337,'zh','èµ„äº§è´Ÿå€ºè¡¨\r\n',0),(372119,10337,'sv','Balans till slut',0),(372120,10337,'it','Equilibrio per finitura',0),(372121,10337,'tl','',0),(372122,10337,'th','à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸—à¸µà¹ˆà¸ˆà¸°à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸´à¹‰à¸™',0),(372123,10337,'hi','à¤–à¤¤à¥à¤® à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥‡à¤·',0),(372124,10337,'ms','Baki selesai',0),(372125,10337,'ar','Ø§Ù„ØªÙˆØ§Ø²Ù† Ø¥Ù„Ù‰ Ø§Ù„Ù†Ù‡Ø§ÙŠØ©',0),(372126,10337,'fr','Solde Ã  l\'arrivÃ©e',0),(372127,10337,'jp','ä»•ä¸Šã’ã«ãƒãƒ©ãƒ³ã‚¹',0),(372128,10337,'pt','EquilÃ­brio para acabamento',0),(372129,10337,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ Ð´Ð¾ ÐºÐ¾Ð½Ñ†Ð°',0),(372130,10337,'es','Balance para Terminar',0),(372131,10337,'de','Ausgleich zum fertig stellen',0),(372132,10337,'en','Balance to Finish',0),(372133,10338,'is','',0),(372134,10338,'dr','(Ø¨Ø±Ø§Øª) Ù‚Ø±Ø¹Ù‡ Ú©Ø´Ù‰',0),(372135,10338,'pr','ÙˆØ¶Ø¹ÙŠØª (Ø¨Ø±Ø§Øª) Ù‚Ø±Ø¹Ù‡ Ú©Ø´Ù‰',0),(372136,10338,'tr','Beraberlik durumu',0),(372137,10338,'pl','Narysuj Status',0),(372138,10338,'bg','ÐÐ°Ñ‡ÐµÑ€Ñ‚Ð°Ð¹Ñ‚Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(372139,10338,'ur','ÚˆØ±Ø§ Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(372140,10338,'sr','ÐÐ°Ñ†Ñ€Ñ‚Ð°Ñ˜ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(372141,10338,'vi','TÃ¬nh tráº¡ng sá»‘',0),(372142,10338,'af','Teken Status',0),(372143,10338,'ro','Atrage starea',0),(372144,10338,'et','Joonista olek',0),(372145,10338,'si','NariÅ¡ite stanje',0),(372146,10338,'ba','Menggambar Status',0),(372147,10338,'nl','Tekenen van Status',0),(372148,10338,'fi','TehdÃ¤ tila',0),(372149,10338,'no','Tegne Status',0),(372150,10338,'da','Tegne Status',0),(372151,10338,'ko','ë¬´ìŠ¹ë¶€ ìƒíƒœ',0),(372152,10338,'he','×œ×¦×™×™×¨ ×ž×¦×‘',0),(372153,10338,'el','ÎšÎ»Î®ÏÏ‰ÏƒÎ· ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(372154,10338,'zh','ç»˜åˆ¶çŠ¶æ€\r\n',0),(372155,10338,'sv','Rita Status',0),(372156,10338,'it','Disegnare lo stato',0),(372157,10338,'tl','',0),(372158,10338,'th','à¸ªà¸–à¸²à¸™à¸°à¸­à¸­à¸',0),(372159,10338,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤†à¤•à¤°à¥à¤·à¤¿à¤¤',0),(372160,10338,'ms','Menarik Status',0),(372161,10338,'ar','ÙˆØ¶Ø¹ Ø±Ø³Ù…',0),(372162,10338,'fr','Statut du tirage au sort',0),(372163,10338,'jp','æç”»çŠ¶æ…‹',0),(372164,10338,'pt','Desenhar o Status',0),(372165,10338,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(372166,10338,'es','Estado de Retiros de Dinero',0),(372167,10338,'de','Status zu zeichnen',0),(372168,10338,'en','Draw Status',0),(372169,10339,'is','',0),(372170,10339,'dr','(Ø¨Ø±Ø§Øª)  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø´Ø¯',0),(372171,10339,'pr','Ù‚Ø±Ø¹Ù‡ Ú©Ø´Ù‰(Ø¨Ø±Ø§Øª)  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯',0),(372172,10339,'tr','Beraberlik baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(372173,10339,'pl','Remis pomyÅ›lnie zaktualizowana',0),(372174,10339,'bg','ÐÐ°Ñ‡ÐµÑ€Ñ‚Ð°Ð¹Ñ‚Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(372175,10339,'ur','ÚˆØ±Ø§ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(372176,10339,'sr','Ð ÐµÐ¼Ð¸ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(372177,10339,'vi','Cáº­p nháº­t sá»‘ thÃ nh cÃ´ng',0),(372178,10339,'af','Tekening Suksesvol Opdateer',0),(372179,10339,'ro','Trage actualizat cu succes',0),(372180,10339,'et','Joonista vÃ¤rskendatud',0),(372181,10339,'si','Å½rebanje posodablja uspeÅ¡no',0),(372182,10339,'ba','Menggambar diperbarui berhasil',0),(372183,10339,'nl','Tekenen met succes bijgewerkt',0),(372184,10339,'fi','PiirrÃ¤ pÃ¤ivitetty',0),(372185,10339,'no','Tegne oppdatert',0),(372186,10339,'da','Draw opdateret',0),(372187,10339,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ëœ ê·¸ë¦´',0),(372188,10339,'he','×¦×™×™×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(372189,10339,'el','Î•Ï€Î¹ÏƒÏ„Î®ÏƒÏ‰ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(372190,10339,'zh','ç»˜åˆ¶æˆåŠŸæ›´æ–°\r\n',0),(372191,10339,'sv','Rita uppdaterats',0),(372192,10339,'it','Disegnare aggiornato con successo',0),(372193,10339,'tl','',0),(372194,10339,'th','à¸§à¸²à¸”à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(372195,10339,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤†à¤•à¤°à¥à¤·à¤¿à¤¤',0),(372196,10339,'ms','Cabutan yang berjaya dikemas kini',0),(372197,10339,'ar','Ø±Ø³Ù… ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(372198,10339,'fr','Tirage au sort mis Ã  jour avec succÃ¨s',0),(372199,10339,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸæç”»ã—ã¾ã™ã€‚',0),(372200,10339,'pt','Sorteio atualizado com sucesso',0),(372201,10339,'ru','ÐÐ¸Ñ‡ÑŒÑ, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(372202,10339,'es','Retiros Actualizados Exitosamente',0),(372203,10339,'de','Zeichnen, die erfolgreich aktualisiert',0),(372204,10339,'en','Draw Updated Successfully',0),(372205,10340,'is','',0),(372206,10340,'dr','Ø¯Ø±ØµØ¯ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(372207,10340,'pr','Ø¯Ø±ØµØ¯ ÙƒØ§Ù…Ù„ Ø´Ø¯ ',0),(372208,10340,'tr','Tamamlanma yÃ¼zdesi',0),(372209,10340,'pl','Procent wykonania',0),(372210,10340,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸',0),(372211,10340,'ur','ÙÛŒ ØµØ¯ Ù…Ú©Ù…Ù„',0),(372212,10340,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾ÑÑ‚Ð¸',0),(372213,10340,'vi','pháº§n trÄƒm hoÃ n thÃ nh',0),(372214,10340,'af','Persent Voltooi',0),(372215,10340,'ro','Procente completate',0),(372216,10340,'et','LÃµpuleviiduse protsent',0),(372217,10340,'si','Odstotkov dokonÄano',0),(372218,10340,'ba','Persen komplit',0),(372219,10340,'nl','Percentage voltooid',0),(372220,10340,'fi','Prosenttia valmiina',0),(372221,10340,'no','Prosent fullfÃ¸rt',0),(372222,10340,'da','Procent fuldfÃ¸rt',0),(372223,10340,'ko','ì™„ë£Œìœ¨',0),(372224,10340,'he','××—×•×– ×‘×™×¦×•×¢',0),(372225,10340,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ·Ï‚',0),(372226,10340,'zh','å®Œæˆç™¾åˆ†æ¯”\r\n',0),(372227,10340,'sv','Procent fÃ¤rdigt',0),(372228,10340,'it','Percentuale di completamento',0),(372229,10340,'tl','',0),(372230,10340,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸—à¸µà¹ˆà¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(372231,10340,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤ªà¥‚à¤°à¥à¤£',0),(372232,10340,'ms','Peratus selesai',0),(372233,10340,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù„Ù„Ø§ÙƒØªÙ…Ø§Ù„',0),(372234,10340,'fr','Pourcentage d\'achÃ¨vement',0),(372235,10340,'jp','å®Œäº†ã—ãŸãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ',0),(372236,10340,'pt','Porcentagem concluÃ­da',0),(372237,10340,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ',0),(372238,10340,'es','Porciento Completado',0),(372239,10340,'de','\"Prozent abgeschlossen\"',0),(372240,10340,'en','Percent Complete',0),(372241,10341,'is','',0),(372242,10341,'dr','Ø§Ø±Ø²Ø´ ÙÙ‡Ø±Ø³Øª Ø´Ø¯Ù‡ ',0),(372243,10341,'pr','Ø§Ø±Ø²Ø´ ÙÙ‡Ø±Ø³Øª Ø´Ø¯Ù‡ ',0),(372244,10341,'tr','Zamanlanan deÄŸer',0),(372245,10341,'pl','Zaplanowane wartoÅ›ci',0),(372246,10341,'bg','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(372247,10341,'ur','Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ Ù‚Ø¯Ø±',0),(372248,10341,'sr','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°Ð½Ð¸ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(372249,10341,'vi','GiÃ¡ trá»‹ dá»± kiáº¿n',0),(372250,10341,'af','Skedule Waarde',0),(372251,10341,'ro','Valoarea programate',0),(372252,10341,'et','Planeeritud vÃ¤Ã¤rtus',0),(372253,10341,'si','NaÄrtovana vrednost',0),(372254,10341,'ba','Nilai yang dijadwalkan',0),(372255,10341,'nl','Geplande waarde',0),(372256,10341,'fi','Suunniteltu arvo',0),(372257,10341,'no','Planlagt verdi',0),(372258,10341,'da','Planlagte vÃ¦rdi',0),(372259,10341,'ko','ì˜ˆì•½ ëœ ê°’',0),(372260,10341,'he','×¢×¨×š ×ž×ª×•×–×ž× ×ª',0),(372261,10341,'el','Î ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÎ¼Î­Î½Î· Î±Î¾Î¯Î±',0),(372262,10341,'zh','é¢„å®šå€¼\r\n',0),(372263,10341,'sv','Planerat vÃ¤rde',0),(372264,10341,'it','Valore programmato',0),(372265,10341,'tl','',0),(372266,10341,'th','à¸„à¹ˆà¸²à¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”',0),(372267,10341,'hi','à¤¶à¥‡à¤¡à¥à¤¯à¥‚à¤² à¤•à¤¿à¤ à¤—à¤ à¤®à¤¾à¤¨',0),(372268,10341,'ms','Nilai Jadual',0),(372269,10341,'ar','Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¬Ø¯ÙˆÙ„Ø©',0),(372270,10341,'fr','Valeur planifiÃ©e',0),(372271,10341,'jp','ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ«ã•ã‚ŒãŸå€¤',0),(372272,10341,'pt','Valor programado',0),(372273,10341,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð½Ð¾Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(372274,10341,'es','Valor Programado',0),(372275,10341,'de','Geplanten Wert',0),(372276,10341,'en','Scheduled Value',0),(372277,10342,'is','',0),(372278,10342,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‚Ø±Ø¹Ù‡ Ú©Ø´Ù‰',0),(372279,10342,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‚Ø±Ø¹Ù‡ Ú©Ø´Ù‰',0),(372280,10342,'tr','Beraberlik seÃ§in',0),(372281,10342,'pl','Wybierz opcjÄ™ Rysuj',0),(372282,10342,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚ÐµÐ³Ð»ÐµÐ½Ðµ',0),(372283,10342,'ur','ÚˆØ±Ø§ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(372284,10342,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð”Ñ€Ð°w',0),(372285,10342,'vi','Chá»n káº¿t quáº£',0),(372286,10342,'af','Teken kies',0),(372287,10342,'ro','SelectaÅ£i extragere',0),(372288,10342,'et','Valige viik',0),(372289,10342,'si','Izberite Å¾rebanje',0),(372290,10342,'ba','Pilih menarik',0),(372291,10342,'nl','Selecteer Draw',0),(372292,10342,'fi','Valitse Draw',0),(372293,10342,'no','Velg tegne',0),(372294,10342,'da','VÃ¦lg lodtrÃ¦kning',0),(372295,10342,'ko','ê·¸ë¦¬ê¸° ì„ íƒ',0),(372296,10342,'he','×‘×—×¨ ×œ×¦×™×™×¨',0),(372297,10342,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¹ÏƒÎ¿Ï€Î±Î»Î¯Î±',0),(372298,10342,'zh','é€‰æ‹©ç»˜åˆ¶\r\n',0),(372299,10342,'sv','VÃ¤lj Draw',0),(372300,10342,'it','Selezionare Draw',0),(372301,10342,'tl','',0),(372302,10342,'th','à¹€à¸¥à¸·à¸­à¸à¸­à¸­à¸',0),(372303,10342,'hi','à¤¡à¥à¤°à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(372304,10342,'ms','Pilih cabutan',0),(372305,10342,'ar','Ø­Ø¯Ø¯ Ø±Ø³Ù…',0),(372306,10342,'fr','SÃ©lectionnez le tirage au sort',0),(372307,10342,'jp','æç”»ã‚’é¸æŠžã—ã¾ã™',0),(372308,10342,'pt','Selecione Draw',0),(372309,10342,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð Ð¸ÑÑƒÐ½Ð¾Ðº',0),(372310,10342,'es','Selccionar la Quita (Del Dinero)',0),(372311,10342,'de','WÃ¤hlen Sie Draw',0),(372312,10342,'en','Select Draw',0),(372313,10343,'is','',0),(372314,10343,'dr','(Ø±Ø³Ù…',0),(372315,10343,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‚Ø±Ø¹Ù‡ ÙƒØ´ÙŠ(Ø±Ø³Ù…',0),(372316,10343,'tr','GÃ¼ncelleÅŸtirme Ã§izmek',0),(372317,10343,'pl','Aktualizacja remis',0),(372318,10343,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð²ÐµÐ½ÑÑ‚Ð²Ð¾',0),(372319,10343,'ur','ÚˆØ±Ø§ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(372320,10343,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð”Ñ€Ð°w',0),(372321,10343,'vi','Cáº­p nháº­t hÃ ng hÃ³a',0),(372322,10343,'af','Bywerking teken',0),(372323,10343,'ro','Posibilitate de update',0),(372324,10343,'et','Update teha',0),(372325,10343,'si','Posodobitev Å¾rebanje',0),(372326,10343,'ba','Memperbarui menarik',0),(372327,10343,'nl','Update Draw',0),(372328,10343,'fi','PÃ¤ivitÃ¤ vetÃ¤Ã¤',0),(372329,10343,'no','Oppdatere uavgjort',0),(372330,10343,'da','Opdatere Draw',0),(372331,10343,'ko','ê·¸ë¦¬ê¸° ì—…ë°ì´íŠ¸',0),(372332,10343,'he','×¢×“×›×•×Ÿ ×œ×¦×™×™×¨',0),(372333,10343,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¹ÏƒÎ¿Ï€Î±Î»Î¯Î±',0),(372334,10343,'zh','æ›´æ–°ç»˜åˆ¶\r\n',0),(372335,10343,'sv','Uppdatera Draw',0),(372336,10343,'it','Aggiornamento Draw',0),(372337,10343,'tl','',0),(372338,10343,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸­à¸­à¸',0),(372339,10343,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¡à¥à¤°à¤¾',0),(372340,10343,'ms','Kemaskini Terakhir cabutan',0),(372341,10343,'ar','ØªØ­Ø¯ÙŠØ« Ø±Ø³Ù…',0),(372342,10343,'fr','Mise Ã  jour de tirage au sort',0),(372343,10343,'jp','æç”»ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(372344,10343,'pt','Sorteio de atualizaÃ§Ã£o',0),(372345,10343,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´Ñ€Ð¾',0),(372346,10343,'es','Actualizar la Quita (Del Dinero)',0),(372347,10343,'de','Update Draw',0),(372348,10343,'en','Update Draw',0),(372349,10344,'is','',0),(372350,10344,'dr','ÙƒØ§Ø± Ù‚Ø¨Ù„Ø§ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(372351,10344,'pr','ÙƒØ§Ø± Ù‚Ø¨Ù„Ø§ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(372352,10344,'tr','Daha Ã¶nce tamamlanan Ã§alÄ±ÅŸma',0),(372353,10344,'pl','Praca wykonana wczeÅ›niej',0),(372354,10344,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð°, Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ Ñ‚Ð¾Ð²Ð°',0),(372355,10344,'ur','Ù‚Ø¨Ù„ Ø§Ø²ÛŒÚº Ù…Ú©Ù…Ù„ Ú©Ø§Ù…',0),(372356,10344,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½ Ñ€Ð°Ð´',0),(372357,10344,'vi','CÃ´ng viá»‡c Ä‘Ã£ hoÃ n thÃ nh gáº¥p',0),(372358,10344,'af','Werk Voorheen Voltooi',0),(372359,10344,'ro','MuncÄƒ Ã®ncheiate anterior',0),(372360,10344,'et','TÃ¶Ã¶ lÃµpetati eelnevalt',0),(372361,10344,'si','Delo konÄano prej',0),(372362,10344,'ba','Pekerjaan selesai sebelumnya',0),(372363,10344,'nl','Werk eerder voltooid',0),(372364,10344,'fi','Aiemmin suoritetun tyÃ¶n',0),(372365,10344,'no','Arbeid fullfÃ¸rt tidligere',0),(372366,10344,'da','Arbejde afsluttet tidligere',0),(372367,10344,'ko','ì´ì „ì— ì™„ë£Œ ëœ ìž‘ì—…',0),(372368,10344,'he','×¢×‘×•×“×” ×©×”×•×©×œ×ž×” ×‘×¢×‘×¨',0),(372369,10344,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ Ï€ÏÎ¿Î·Î³Î¿Ï…Î¼Î­Î½Ï‰Ï‚',0),(372370,10344,'zh','æ­¤å‰å·²å®Œæˆçš„å·¥ä½œ\r\n',0),(372371,10344,'sv','Avslutat tidigare arbete',0),(372372,10344,'it','Lavoro completato in precedenza',0),(372373,10344,'tl','',0),(372374,10344,'th','à¸‡à¸²à¸™à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(372375,10344,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¤¹à¤²à¥‡ à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤—à¤¯à¤¾',0),(372376,10344,'ms','Kerja yang telah siap sebelum ini',0),(372377,10344,'ar','Ø§Ù„Ø£Ø¹Ù…Ø§Ù„ Ø§Ù„Ù…Ù†Ø¬Ø²Ø© Ù…Ù† Ù‚Ø¨Ù„',0),(372378,10344,'fr','Travaux rÃ©alisÃ©s antÃ©rieurement',0),(372379,10344,'jp','ä»¥å‰ã«å®Œäº†ã—ãŸä½œæ¥­',0),(372380,10344,'pt','Trabalho concluÃ­do anteriormente',0),(372381,10344,'ru','Ð Ð°Ð½ÐµÐµ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð½Ñ‹Ñ… Ñ€Ð°Ð±Ð¾Ñ‚',0),(372382,10344,'es','Trabajo Completado Previamente',0),(372383,10344,'de','Zuvor abgeschlossenen Arbeiten',0),(372384,10344,'en','Work Completed Previously',0),(372385,10345,'is','',0),(372386,10345,'dr','ÙƒØ§Ø± ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡',0),(372387,10345,'pr','ÙƒØ§Ø± ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡',0),(372388,10345,'tr','Bu dÃ¶nem Ã§alÄ±ÅŸmasÄ± tamamlandÄ±',0),(372389,10345,'pl','Prace zakoÅ„czone tego okresu',0),(372390,10345,'bg','Ð¢Ð¾Ð·Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(372391,10345,'ur','Ø§Ø³ Ù…Ø¯Øª Ù…ÛŒÚº Ú©Ø§Ù… Ù…Ú©Ù…Ù„',0),(372392,10345,'sr','Ð Ð°Ð´Ð¾Ð²Ð¸ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½Ð¸ Ð¾Ð²Ð¾Ð³ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(372393,10345,'vi','CÃ´ng viá»‡c Ä‘Ã£ hoÃ n thÃ nh trong giai Ä‘oáº¡n nÃ y',0),(372394,10345,'af','Werk Hierdie Periode Voltooi',0),(372395,10345,'ro','Locul de muncÄƒ Ã®ncheiat aceastÄƒ perioadÄƒ',0),(372396,10345,'et','TÃ¶Ã¶ lÃµpetati sellel perioodil',0),(372397,10345,'si','Delo zakljuÄili to obdobje',0),(372398,10345,'ba','Pekerjaan selesai periode ini',0),(372399,10345,'nl','Werk voltooid deze periode',0),(372400,10345,'fi','TyÃ¶ pÃ¤Ã¤tÃ¶kseen tÃ¤nÃ¤ aikana',0),(372401,10345,'no','Arbeid fullfÃ¸rt denne perioden',0),(372402,10345,'da','Arbejde fuldfÃ¸rt denne periode',0),(372403,10345,'ko','ì´ ê¸°ê°„ì„ ì™„ë£Œ í•˜ëŠ” ìž‘ì—…',0),(372404,10345,'he','×”×¢×‘×•×“×” ×”×•×©×œ×ž×” ×”×ª×§×•×¤×” ×”×–××ª',0),(372405,10345,'el','ÎˆÏÎ³Î¿ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ Î±Ï…Ï„Î® Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(372406,10345,'zh','æœ¬æœŸå®Œæˆçš„å·¥ä½œ\r\n',0),(372407,10345,'sv','Arbetet avslutas denna Period',0),(372408,10345,'it','Lavoro completato questo periodo',0),(372409,10345,'tl','',0),(372410,10345,'th','à¸—à¸³à¸‡à¸²à¸™à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸´à¹‰à¸™à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸™à¸µà¹‰',0),(372411,10345,'hi','à¤‡à¤¸ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤•à¤¾à¤® à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾',0),(372412,10345,'ms','Kerja selesai tempoh ini',0),(372413,10345,'ar','Ø¥Ù†Ø¬Ø§Ø² Ø§Ù„Ø¹Ù…Ù„ ÙÙŠ Ù‡Ø°Ù‡ Ø§Ù„ÙØªØ±Ø©',0),(372414,10345,'fr','Les travaux de cette pÃ©riode',0),(372415,10345,'jp','ä»•äº‹ã¯ã“ã®æœŸé–“ã‚’å®Œäº†ã—ã¾ã—ãŸã€‚',0),(372416,10345,'pt','Trabalho concluÃ­do neste perÃ­odo',0),(372417,10345,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(372418,10345,'es','Trabajo Completado Este PerÃ­odo',0),(372419,10345,'de','Fertigstellung dieser Zeit',0),(372420,10345,'en','Work Completed This Period',0),(372421,10346,'is','',0),(372422,10346,'dr','Ø´Ø±ÙˆØ¹ Ùˆ Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§',0),(372423,10346,'pr','Ø´Ø±ÙˆØ¹ Ùˆ Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§',0),(372424,10346,'tr','BaÅŸlangÄ±Ã§ ve bitiÅŸ dÃ¶nemin hesaplarÄ±',0),(372425,10346,'pl','PoczÄ…tek i koniec okresu kont',0),(372426,10346,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð¸ ÐºÑ€Ð°Ñ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(372427,10346,'ur','Ø¢ØºØ§Ø² Ø§ÙˆØ± Ø§Ø®ØªØªØ§Ù… Ú©Û’ Ø¯ÙˆØ± Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(372428,10346,'sr','ÐšÐ¾Ð½Ñ‚Ð° Ñ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ¾Ð¼ Ð¸ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð·Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(372429,10346,'vi','cÃ¡c tÃ i khoáº£n má»Ÿ vÃ  khÃ³a ká»³ káº¿ toÃ¡n',0),(372430,10346,'af','Begin en Einde-van-Periode Rekeninge',0),(372431,10346,'ro','Conturile de Ã®nceput ÅŸi de sfÃ¢rÅŸit de perioadÄƒ',0),(372432,10346,'et','Algus ja perioodi lÃµpu',0),(372433,10346,'si','ZaÄetku in koncu obdobja raÄunov',0),(372434,10346,'ba','Awal dan akhir waktu account',0),(372435,10346,'nl','Begin en einde van de periode Accounts',0),(372436,10346,'fi','Alku-ja tilikauden lopussa',0),(372437,10346,'no','Begynnelsen og End-of-perioden',0),(372438,10346,'da','Begyndelsen og slutningen af perioden konti',0),(372439,10346,'ko','ì‹œìž‘ ë° ê¸°ê°„ ë ê³„ì •',0),(372440,10346,'he','×—×©×‘×•× ×•×ª ×‘×ª×—×™×œ×ª ×•×ª×§×•×¤×ª ×§×¦×”-',0),(372441,10346,'el','Î‘ÏÏ‡Î® ÎºÎ±Î¹ Ï„Î­Î»Î¿Ï‚ Ï„Î·Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(372442,10346,'zh','å¼€å§‹å’Œç»“æŸï¼ŒæœŸé—´çš„è´¦ç›®\r\n',0),(372443,10346,'sv','BÃ¶rjan och slutet av perioden konton',0),(372444,10346,'it','Conti di inizio e fine del periodo',0),(372445,10346,'tl','',0),(372446,10346,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™ à¹à¸¥à¸°à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸‚à¸­à¸‡à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¸šà¸±à¸à¸Šà¸µ',0),(372447,10346,'hi','à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‡ à¤¶à¥à¤°à¥à¤†à¤¤ à¤”à¤° à¤…à¤‚à¤¤ à¤•à¥€ à¤…à¤µà¤§à¤¿',0),(372448,10346,'ms','Akaun-akaun baru dan akhir zaman',0),(372449,10346,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø¨Ø¯Ø§ÙŠØ© ÙˆÙ†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©',0),(372450,10346,'fr','Comptes de dÃ©but et de fin de pÃ©riode',0),(372451,10346,'jp','æœ€åˆã¨æœ€å¾Œã®æœŸé–“ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(372452,10346,'pt','Contas de inÃ­cio e de fim de perÃ­odo',0),(372453,10346,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð¸ ÐºÐ¾Ð½ÐµÑ† Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° ÑÑ‡ÐµÑ‚Ð°',0),(372454,10346,'es','Cuentas del Comienzo y Fin del PerÃ­odo',0),(372455,10346,'de','Anfang und Ende eines Zeitraums Konten',0),(372456,10346,'en','Beginning and End-of-Period Accounts',0),(372457,10347,'is','',0),(372458,10347,'dr','Ù„ØºÙˆ Ø§Ù…Ø¶Ø§Ø¡',0),(372459,10347,'pr','Ù„ØºÙˆ Ø§Ù…Ø¶Ø§Ø¡',0),(372460,10347,'tr','Ä°ÅŸareti ters Ã§evir',0),(372461,10347,'pl','Czy zmieniÄ‡ znak',0),(372462,10347,'bg','ÐžÐ±Ñ€Ð°Ñ‚ÐµÐ½ Ð·Ð½Ð°Ðº',0),(372463,10347,'ur','Ù†Ø´Ø§Ù†ÛŒ Ù…Ø¹Ú©ÙˆØ³ Ú©Ø±ÛŒÚº',0),(372464,10347,'sr','ÐžÐ±Ñ€Ð½ÑƒÑ‚Ð¸ Ð·Ð½Ð°Ðº',0),(372465,10347,'vi','dáº¥u hiá»‡n ngÆ°á»£c',0),(372466,10347,'af','Omgekeerde teken',0),(372467,10347,'ro','Inversa semn',0),(372468,10347,'et','Muuda mÃ¤rki',0),(372469,10347,'si','Reverse znak',0),(372470,10347,'ba','Membalikkan tanda',0),(372471,10347,'nl','Omgekeerde teken',0),(372472,10347,'fi','Vaihda etumerkki',0),(372473,10347,'no','Snu fortegn',0),(372474,10347,'da','Modsatte fortegn',0),(372475,10347,'ko','ë°˜ëŒ€ ì„œëª…',0),(372476,10347,'he','×œ×”×¤×•×š ××ª ×”×¡×™×ž×Ÿ',0),(372477,10347,'el','Î ÏÏŒÏƒÎ·Î¼Î¿ Î±Î½Ï„Î¹ÏƒÏ„ÏÎ­Ï†ÎµÏ„Î±Î¹',0),(372478,10347,'zh','åå‘ç­¾å­—\r\n',0),(372479,10347,'sv','FÃ¶rtecknet',0),(372480,10347,'it','Segno inverso',0),(372481,10347,'tl','',0),(372482,10347,'th','à¸à¸¥à¸±à¸šà¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢',0),(372483,10347,'hi','à¤°à¤¿à¤µà¤°à¥à¤¸ à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(372484,10347,'ms','Sebaliknya tanda',0),(372485,10347,'ar','Ø¹ÙƒØ³ Ø§Ù„Ø¹Ù„Ø§Ù…Ø©',0),(372486,10347,'fr','Inverser le signe',0),(372487,10347,'jp','ç¬¦å·ã‚’åè»¢ã•ã›ã¾ã™',0),(372488,10347,'pt','Sinal inverso',0),(372489,10347,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ñ‹Ð¹ Ð·Ð½Ð°Ðº',0),(372490,10347,'es','Volver a RevÃ©s el Signo',0),(372491,10347,'de','Vorzeichen umkehren',0),(372492,10347,'en','Reverse Sign',0),(372493,10348,'is','',0),(372494,10348,'dr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯  Ùˆ Ù…Ø¹Ø§Ø¯Ù„Ù‡Ø§ÙŠ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡',0),(372495,10348,'pr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯  Ùˆ Ù…Ø¹Ø§Ø¯Ù„Ù‡Ø§ÙŠ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡',0),(372496,10348,'tr','Nakit ve nakit benzerleri sÃ¼resinin baÅŸlangÄ±cÄ±',0),(372497,10348,'pl','Åšrodki pieniÄ™Å¼ne i gotÃ³wkowych ekwiwalentÃ³w poczÄ…tku okresu',0),(372498,10348,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¸ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ ÐµÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ð¸ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(372499,10348,'ur','Ù†Ù‚Ø¯ Ø§ÙˆØ± Ù†Ù‚Ø¯ Ù…ÛŒÚº Ø¯ÙˆØ± Ú©Û’ Ù…ØªØ±Ø§Ø¯Ù Ú©Ø§ Ø¢ØºØ§Ø²',0),(372500,10348,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ð¸ Ð¸ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ð¸ ÐµÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ð¸Ð¼Ð° Ð¿Ð¾Ñ‡ÐµÑ‚Ð°Ðº Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(372501,10348,'vi','Sá»‘ dÆ° Ä‘áº§u ká»³ tiá»n vÃ  tÆ°Æ¡ng Ä‘Æ°Æ¡ng tiá»n',0),(372502,10348,'af','Kontant en Kontant Ekwivalente Begin van Periode',0),(372503,10348,'ro','Numerar ÅŸi echivalente de numerar Ã®nceputul perioadei',0),(372504,10348,'et','Raha ja raha ekvivalendid perioodi alguse',0),(372505,10348,'si','Denar in denarni ustrezniki zaÄetka obdobja',0),(372506,10348,'ba','Kas dan setara kas awal periode',0),(372507,10348,'nl','Cash en Cash-equivalenten begin van de periode',0),(372508,10348,'fi','KÃ¤teistÃ¤ ja kÃ¤teistÃ¤ vastaavien varojen kauden alussa',0),(372509,10348,'no','Kontanter og kontanter ekvivalenter begynnelsen av perioden',0),(372510,10348,'da','Kontanter og kontant-Ã¦kvivalenter begyndelse',0),(372511,10348,'ko','í˜„ê¸ˆ ë° í˜„ê¸ˆ ë“±ê°€ë¬¼ ì‹œìž‘ ê¸°ê°„',0),(372512,10348,'he','×›×¡×£, ×ž×–×•×ž× ×™× ×•×©×•×•×™ ×ª×—×™×œ×ª ×ª×§×•×¤×ª',0),(372513,10348,'el','ÎœÎµÏ„ÏÎ·Ï„Î¬ ÎºÎ±Î¹ Î¹ÏƒÎ¿Î´ÏÎ½Î±Î¼Î± Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½ Î±ÏÏ‡Î® Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(372514,10348,'zh','çŽ°é‡‘åŠçŽ°é‡‘ç­‰ä»·ç‰©æœŸåˆ\r\n',0),(372515,10348,'sv','Kontanter och likvida medel bÃ¶rjan av Period',0),(372516,10348,'it','Contanti e contanti inizio di equivalenti del periodo di',0),(372517,10348,'tl','',0),(372518,10348,'th','à¹€à¸‡à¸´à¸™à¸ªà¸”à¹à¸¥à¸°à¹€à¸‡à¸´à¸™à¸ªà¸”à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸—à¸µà¸¢à¸šà¹€à¸—à¹ˆà¸²à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(372519,10348,'hi','à¤¨à¤•à¤¦ à¤”à¤° à¤¨à¤•à¤¦à¥€ à¤¸à¤®à¤•à¤•à¥à¤· à¤•à¥€ à¤…à¤µà¤§à¤¿ à¤•à¥€ à¤¶à¥à¤°à¥à¤†à¤¤',0),(372520,10348,'ms','Tunai dan tunai setara permulaan tempoh',0),(372521,10348,'ar','Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© ÙˆØ§Ù„Ù…ÙƒØ§ÙØ¦Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©',0),(372522,10348,'fr','TrÃ©sorerie et Cash Ã©quivalents dÃ©but de pÃ©riode',0),(372523,10348,'jp','ç¾é‡‘åŠã³ç¾é‡‘åŒç­‰ç‰©æœŸé¦–æ®‹é«˜',0),(372524,10348,'pt','Dinheiro e dinheiro inÃ­cio de equivalentes do perÃ­odo',0),(372525,10348,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¸ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ ÑÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ñ‹ Ð½Ð°Ñ‡Ð°Ð»Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(372526,10348,'es','Efectivo y Equivalentes Comienzo del PerÃ­odo',0),(372527,10348,'de','Cash and Cash Equivalents Anfang der Periode',0),(372528,10348,'en','Cash and Cash Equivalents Beginning of Period',0),(372529,10349,'is','',0),(372530,10349,'dr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯  Ùˆ Ù…Ø¹Ø§Ø¯Ù„Ù‡Ø§ÙŠ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡',0),(372531,10349,'pr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯  Ùˆ Ù…Ø¹Ø§Ø¯Ù„Ù‡Ø§ÙŠ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡',0),(372532,10349,'tr','Nakit ve nakit benzerleri dÃ¶nem sonu',0),(372533,10349,'pl','Åšrodki pieniÄ™Å¼ne i gotÃ³wkowych ekwiwalentÃ³w koniec okresu',0),(372534,10349,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¸ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ ÐµÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ð¸ ÐºÑ€Ð°Ñ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(372535,10349,'ur','Ù†Ù‚Ø¯ Ø§ÙˆØ± Ù†Ù‚Ø¯ Ù†Û Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©ÛŒ',0),(372536,10349,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ð¸ Ð¸ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ð¸ ÐµÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ð¸Ð¼Ð° ÐºÑ€Ð°Ñ˜ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(372537,10349,'vi','Sá»‘ dÆ° cuá»‘i ká»³ tiá»n vÃ  tÆ°Æ¡ng Ä‘Æ°Æ¡ng tiá»n',0),(372538,10349,'af','Kontant en Kontant Ekwivalente Begin van Periode',0),(372539,10349,'ro','Numerar si echivalentele de numerar sfÃ¢rÅŸitul perioadei',0),(372540,10349,'et','Raha ja raha ekvivalendid perioodi lÃµpuks',0),(372541,10349,'si','Denar in denarni ustrezniki konec obdobja',0),(372542,10349,'ba','Kas dan setara kas akhir periode',0),(372543,10349,'nl','Cash en Cash-equivalenten einde van periode',0),(372544,10349,'fi','KÃ¤teistÃ¤ ja kÃ¤teistÃ¤ vastaavien varojen pÃ¤Ã¤ttymistÃ¤',0),(372545,10349,'no','Kontanter og kontanter ekvivalenter slutten av perioden',0),(372546,10349,'da','Kontanter og kontant-Ã¦kvivalenter ultimo',0),(372547,10349,'ko','í˜„ê¸ˆ ë° í˜„ê¸ˆ ë“±ê°€ë¬¼ ê¸°ê°„ì˜',0),(372548,10349,'he','×›×¡×£, ×ž×–×•×ž× ×™× ×•×©×•×•×™ ×¡×•×£ ×ª×§×•×¤×”',0),(372549,10349,'el','ÎœÎµÏ„ÏÎ·Ï„Î¬ ÎºÎ±Î¹ Î¹ÏƒÎ¿Î´ÏÎ½Î±Î¼Î± Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½ Ï„Î­Î»Î¿Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(372550,10349,'zh','çŽ°é‡‘åŠçŽ°é‡‘ç­‰ä»·ç‰©æœŸæœ«ä½™é¢\r\n',0),(372551,10349,'sv','Kontanter och likvida medel periodens slut',0),(372552,10349,'it','Contanti e contanti fine di equivalenti del periodo di',0),(372553,10349,'tl','',0),(372554,10349,'th','à¹€à¸‡à¸´à¸™à¸ªà¸”à¹à¸¥à¸°à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸—à¸µà¸¢à¸šà¹€à¸—à¹ˆà¸²à¹€à¸‡à¸´à¸™à¸ªà¸”à¸ªà¸´à¹‰à¸™à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²',0),(372555,10349,'hi','à¤¨à¤•à¤¦ à¤”à¤° à¤¨à¤•à¤¦à¥€ à¤¸à¤®à¤•à¤•à¥à¤· à¤…à¤µà¤§à¤¿ à¤•à¤¾ à¤…à¤‚à¤¤',0),(372556,10349,'ms','Tunai dan tunai setara akhir tempoh',0),(372557,10349,'ar','Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© ÙˆØ§Ù„Ù†Ù‚Ø¯ÙŠØ© Ù…ÙƒØ§ÙØ¦Ø§Øª Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©',0),(372558,10349,'fr','TrÃ©sorerie et Cash Ã©quivalents fin de pÃ©riode',0),(372559,10349,'jp','ç¾é‡‘åŠã³ç¾é‡‘åŒç­‰ç‰©ã®æœŸæœ«',0),(372560,10349,'pt','Dinheiro e dinheiro final de equivalentes de perÃ­odo',0),(372561,10349,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¸ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ ÑÐºÐ²Ð¸Ð²Ð°Ð»ÐµÐ½Ñ‚Ñ‹ ÐºÐ¾Ð½ÐµÑ† Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(372562,10349,'es','Efectivo y Equivalentes Fin del PerÃ­odo',0),(372563,10349,'de','Cash und Cash Equivalents zum Periodenende',0),(372564,10349,'en','Cash and Cash Equivalents End of Period',0),(372565,10350,'is','',0),(372566,10350,'dr','Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(372567,10350,'pr','Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(372568,10350,'tr','Bu ÅŸirket iÃ§in nakit akÄ±ÅŸÄ± raporu',0),(372569,10350,'pl','Raport przepÅ‚ywÃ³w pieniÄ™Å¼nych dla tej firmy',0),(372570,10350,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°',0),(372571,10350,'ur','Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„Ø¦Û’ Ú©ÛŒØ´ ÙÙ„Ùˆ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(372572,10350,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸ Ñ‚Ð¾Ðº Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð·Ð° Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(372573,10350,'vi','BÃ¡o cÃ¡o lÆ°u chuyá»ƒn tiá»n tá»‡ cho cÃ´ng ty nÃ y',0),(372574,10350,'af','Kontantvloei Verslag vir Hierdie Onderneming',0),(372575,10350,'ro','Raport de fluxul de numerar pentru aceasta companie',0),(372576,10350,'et','Rahavoogude aruande selle firma',0),(372577,10350,'si','PoroÄilo o denarnem toku za to podjetje',0),(372578,10350,'ba','Laporan arus kas untuk perusahaan ini',0),(372579,10350,'nl','Het rapport Cashflow voor dit bedrijf',0),(372580,10350,'fi','Kassavirtaraportti tÃ¤lle yritykselle',0),(372581,10350,'no','KontantstrÃ¸m-rapporten for denne',0),(372582,10350,'da','Cash Flow betÃ¦nkning for dette selskab',0),(372583,10350,'ko','ì´ íšŒì‚¬ì— ëŒ€ í•œ í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œ',0),(372584,10350,'he','×“×• ×— ×ª×–×¨×™× ×ž×–×•×ž× ×™× ×œ×—×‘×¨×” ×”×–×•',0),(372585,10350,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î®',0),(372586,10350,'zh','æ­¤å…¬å¸çš„çŽ°é‡‘æµæŠ¥å‘Š\r\n',0),(372587,10350,'sv','KassaflÃ¶desrapport fÃ¶r detta fÃ¶retag',0),(372588,10350,'it','Rapporto flusso di cassa per questa azienda',0),(372589,10350,'tl','',0),(372590,10350,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸£à¸´à¸©à¸±à¸—à¸™à¸µà¹‰',0),(372591,10350,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(372592,10350,'ms','Laporan aliran tunai untuk Syarikat ini',0),(372593,10350,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(372594,10350,'fr','Rapport de flux de trÃ©sorerie pour cette sociÃ©tÃ©',0),(372595,10350,'jp','ã“ã®ä¼šç¤¾ã®ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆ',0),(372596,10350,'pt','RelatÃ³rio de fluxo de caixa para esta companhia.',0),(372597,10350,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(372598,10350,'es','Informe de Flujo de Efectivo Para Esta Empresa',0),(372599,10350,'de','Cashflow-Bericht fÃ¼r dieses Unternehmen',0),(372600,10350,'en','Cash Flow Report for This Company',0),(372601,10351,'is','',0),(372602,10351,'dr','Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ù…Ù† ',0),(372603,10351,'pr','Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ù…Ù† ',0),(372604,10351,'tr','Benim ÅŸirket',0),(372605,10351,'pl','Mojej firmy',0),(372606,10351,'bg','ÐœÐ¾Ð¸Ñ‚Ðµ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(372607,10351,'ur','Ù…ÛŒØ±ÛŒ Ú©Ù…Ù¾Ù†ÛŒÙˆÚº',0),(372608,10351,'sr','ÐœÐ¾Ñ˜Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(372609,10351,'vi','CÃ¡c cÃ´ng ty cá»§a tÃ´i',0),(372610,10351,'af','My Ondernemings',0),(372611,10351,'ro','Companiile mele',0),(372612,10351,'et','Minu ettevÃµtted',0),(372613,10351,'si','Moje druÅ¾be',0),(372614,10351,'ba','Perusahaan saya',0),(372615,10351,'nl','Mijn bedrijven',0),(372616,10351,'fi','Minun yrityksiÃ¤',0),(372617,10351,'no','Mine selskaper',0),(372618,10351,'da','Min virksomheder',0),(372619,10351,'ko','ë‚´ íšŒì‚¬',0),(372620,10351,'he','×—×‘×¨×•×ª ×©×œ×™',0),(372621,10351,'el','Î•Ï„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Î¼Î¿Ï…',0),(372622,10351,'zh','æˆ‘çš„å…¬å¸\r\n',0),(372623,10351,'sv','Mitt fÃ¶retag',0),(372624,10351,'it','Mie imprese',0),(372625,10351,'tl','',0),(372626,10351,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(372627,10351,'hi','à¤®à¥‡à¤°à¤¾ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚',0),(372628,10351,'ms','Syarikat saya',0),(372629,10351,'ar','Ø¨Ù„Ø¯ÙŠ Ø´Ø±ÙƒØ§Øª',0),(372630,10351,'fr','Mes sociÃ©tÃ©s',0),(372631,10351,'jp','ç§ã®ä¼šç¤¾',0),(372632,10351,'pt','Minhas empresas',0),(372633,10351,'ru','ÐœÐ¾Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(372634,10351,'es','Mis Empresas',0),(372635,10351,'de','Mein Unternehmen',0),(372636,10351,'en','My Companies',0),(372637,10352,'is','',0),(372638,10352,'dr','Ù†Ù…Ø§ÙŠØ´ Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ù…ØªØ¹Ù„Ù‚ Ø¨Ù‡ Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(372639,10352,'pr','Ù†Ù…Ø§ÙŠØ´ Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ù…ØªØ¹Ù„Ù‚ Ø¨Ù‡ Ø§ÙŠÙ† Ø´Ø±ÙƒØª',0),(372640,10352,'tr','Bu ÅŸirketine ait ÅŸirketlerin gÃ¶ster',0),(372641,10352,'pl','PokaÅ¼ firm naleÅ¼Ä…cych do tej firmy',0),(372642,10352,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸, ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°',0),(372643,10352,'ur','ÛŒÛ Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù„Ú©ÛŒØªÛŒ Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(372644,10352,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ñƒ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ñƒ Ð¾Ð²Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(372645,10352,'vi','Hiá»ƒn thá»‹ táº¥t cáº£ cÃ´ng ty mÃ  cÃ´ng ty nÃ y sá»Ÿ há»¯u',0),(372646,10352,'af','Wys Ondernemings wat Besit Word deur Hierdie Onderneming',0),(372647,10352,'ro','ArÄƒta companii deÅ£inute de aceastÄƒ companie',0),(372648,10352,'et','Liitunud firmad selle firma omanik',0),(372649,10352,'si','PrikaÅ¾i podjetja v lasti te druÅ¾be',0),(372650,10352,'ba','Menunjukkan perusahaan yang dimiliki oleh perusahaan ini',0),(372651,10352,'nl','Toon bedrijven die eigendom zijn van dit bedrijf',0),(372652,10352,'fi','NÃ¤ytÃ¤ yrityksen omistamien',0),(372653,10352,'no','Vis selskap av dette selskapet',0),(372654,10352,'da','Vis virksomheder ejet af denne virksomhed',0),(372655,10352,'ko','ì´ íšŒì‚¬ì— ì˜í•´ ì†Œìœ  ëœ íšŒì‚¬ë¥¼ í‘œì‹œ',0),(372656,10352,'he','×”×¦×’ ×—×‘×¨×•×ª ×‘×‘×¢×œ×•×ª ×”×—×‘×¨×” ×”×–×•',0),(372657,10352,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Î±Î½Î®ÎºÎµÎ¹ Î±Ï…Ï„Î® Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(372658,10352,'zh','æ˜¾ç¤ºè¯¥æœ¬å…¬å¸æ‹¥æœ‰çš„å…¬å¸\r\n',0),(372659,10352,'sv','Visa fÃ¶retag Ã¤gs av fÃ¶retaget',0),(372660,10352,'it','Visualizza le aziende di proprietÃ  di questa azienda',0),(372661,10352,'tl','',0),(372662,10352,'th','à¸”à¸¹ à¸šà¸£à¸´à¸©à¸±à¸—à¸—à¸µà¹ˆà¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸šà¸£à¸´à¸©à¸±à¸—à¸™à¸µà¹‰',0),(372663,10352,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤µà¤¾à¤²à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(372664,10352,'ms','Menunjukkan syarikat-syarikat yang dimiliki oleh Syarikat ini',0),(372665,10352,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø´Ø±ÙƒØ§Øª Ù…Ù…Ù„ÙˆÙƒØ© Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(372666,10352,'fr','Voir l\'Ã©tablissement de sociÃ©tÃ©s dÃ©tenues par cette entreprise',0),(372667,10352,'jp','ã“ã®ä¼šç¤¾ãŒæ‰€æœ‰ã™ã‚‹ä¼æ¥­ã‚’ç¤ºã™',0),(372668,10352,'pt','Mostrar empresas pertencentes a esta empresa',0),(372669,10352,'ru','ÐŸÐ¾ÐºÐ°Ð¶Ð¸Ñ‚Ðµ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ ÐÐ°Ñ…Ð¾Ð´ÑÑ‰Ð¸ÐµÑÑ Ð² Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð­Ñ‚Ð¾Ð¹ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(372670,10352,'es','Mostrar Empresas que Pertenecen a Esta Empresa',0),(372671,10352,'de','Zeigen Sie Unternehmen, die im Besitz von dieser Firma an',0),(372672,10352,'en','Show Companies Owned by This Company',0),(372673,10353,'is','',0),(372674,10353,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(372675,10353,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(372676,10353,'tr','Eklemek binanÄ±n satÄ±ÅŸ',0),(372677,10353,'pl','SprzedaÅ¼ budynku Dodaj',0),(372678,10353,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(372679,10353,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ ÙØ±ÙˆØ®Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(372680,10353,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð³Ñ€Ð°Ð´Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(372681,10353,'vi','XÃ¢y dá»±ng kinh doanh thÃªm',0),(372682,10353,'af','Gebou verkope voeg',0),(372683,10353,'ro','Adauga clÄƒdire vÃ¢nzÄƒri',0),(372684,10353,'et','Hoone mÃ¼Ã¼ki lisada',0),(372685,10353,'si','Dodaj prodaje stavbe',0),(372686,10353,'ba','Bangunan penjualan Tambah',0),(372687,10353,'nl','Gebouw verkoop toevoegen',0),(372688,10353,'fi','Rakennus myynnin lisÃ¤Ã¤minen',0),(372689,10353,'no','Bygningen salg legge',0),(372690,10353,'da','Bygning salg tilfÃ¸je',0),(372691,10353,'ko','ê±´ë¬¼ íŒë§¤ ì¶”ê°€',0),(372692,10353,'he','×ž×›×™×¨×•×ª ×”×‘× ×™×™×Ÿ ×œ×”×•×¡×™×£',0),(372693,10353,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÏ„Î¹ÏÎ¯Î¿Ï… Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(372694,10353,'zh','æ–°å¢žå»ºè®¾é”€å”®\r\n',0),(372695,10353,'sv','Byggnaden fÃ¶rsÃ¤ljning lÃ¤gga till',0),(372696,10353,'it','Aggiungi edificio vendite',0),(372697,10353,'tl','',0),(372698,10353,'th','à¸‚à¸²à¸¢à¸­à¸²à¸„à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡',0),(372699,10353,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(372700,10353,'ms','Menambah jualan bangunan',0),(372701,10353,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¨Ù†Ù‰ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(372702,10353,'fr','Vente immeuble ajouter',0),(372703,10353,'jp','å»ºç‰©ã®è²©å£²ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(372704,10353,'pt','Adicionar o edifÃ­cio vendas',0),(372705,10353,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(372706,10353,'es','Agregar Ventas de Edificios',0),(372707,10353,'de','GebÃ¤ude Sales hinzufÃ¼gen',0),(372708,10353,'en','Building Sales Add',0),(372709,10354,'is','',0),(372710,10354,'dr','ØªØ§Ø±ÙŠØ® Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ø´Ø¯Ù‡ ',0),(372711,10354,'pr','ØªØ§Ø±ÙŠØ® Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ø´Ø¯Ù‡ ',0),(372712,10354,'tr','Tahmin edilen Tarih',0),(372713,10354,'pl','Przewidywane daty',0),(372714,10354,'bg','ÐŸÑ€Ð¾Ð³Ð½Ð¾Ð·Ð½Ð¸Ñ Ð´Ð°Ñ‚Ð°',0),(372715,10354,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ',0),(372716,10354,'sr','ÐŸÑ€ÐµÐ´Ð²Ð¸Ñ’ÐµÐ½Ð¾Ð³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(372717,10354,'vi','ngÃ y Ä‘Ã£ Ä‘Æ°á»£c dá»± Ä‘oÃ¡n truowcs',0),(372718,10354,'af','Voorgestelde Datum',0),(372719,10354,'ro','Data de cea prognozatÄƒ',0),(372720,10354,'et','Eelarvestatud kuupÃ¤eval',0),(372721,10354,'si','Napovedanih datum',0),(372722,10354,'ba','Tanggal perkiraan',0),(372723,10354,'nl','Verwachte datum',0),(372724,10354,'fi','Arvioitu saapumispÃ¤ivÃ¤',0),(372725,10354,'no','Prognoseberegnede dato',0),(372726,10354,'da','Forventede dato',0),(372727,10354,'ko','ì˜ˆìƒëœ ë‚ ì§œ',0),(372728,10354,'he','×ª××¨×™×š ×—×–×•×™×™×',0),(372729,10354,'el','Î ÏÎ¿Î²Î»ÎµÏ€ÏŒÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(372730,10354,'zh','é¢„æµ‹æ—¥æœŸ\r\n',0),(372731,10354,'sv','BerÃ¤knade datum',0),(372732,10354,'it','Data prevista',0),(372733,10354,'tl','',0),(372734,10354,'th','à¸§à¸±à¸™à¸„à¸²à¸”à¸à¸²à¸£à¸“à¹Œ',0),(372735,10354,'hi','Forecasted à¤¤à¤¾à¤°à¥€à¤–',0),(372736,10354,'ms','Tarikh unjuran',0),(372737,10354,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ØªÙˆÙ‚Ø¹',0),(372738,10354,'fr','Date prÃ©vue',0),(372739,10354,'jp','äºˆæƒ³æ—¥ä»˜',0),(372740,10354,'pt','Data prevista',0),(372741,10354,'ru','ÐŸÑ€Ð¾Ð³Ð½Ð¾Ð·Ð¸Ñ€ÑƒÐµÐ¼Ð°Ñ Ð´Ð°Ñ‚Ð°',0),(372742,10354,'es','Datos Pronosticados',0),(372743,10354,'de','Prognostizierte Datum',0),(372744,10354,'en','Forecasted Date',0),(372745,10355,'is','',0),(372746,10355,'dr','(Ø§Ù†Ù‚Ø·Ø§Ø¹) ÙˆØ§Ù… ',0),(372747,10355,'pr','ÙƒÙˆØªØ§Ù‡ Ø³Ø§Ø²ÙŠ (Ø§Ù†Ù‚Ø·Ø§Ø¹) ÙˆØ§Ù… ',0),(372748,10355,'tr','Kredi talihsizlikti',0),(372749,10355,'pl','Ograniczenie kredytÃ³w',0),(372750,10355,'bg','Ð—Ð°ÐµÐ¼ ÑÑŠÐºÑ€Ð°Ñ‰Ð°Ð²Ð°Ð½Ðµ',0),(372751,10355,'ur','Ù‚Ø±Ø¶ Ú©Û’ Ú©ÙˆØ±Ù¹Ø§ÛŒÙ„Ù…ÛŒÙ†Ù¹',0),(372752,10355,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð¦ÑƒÑ€Ñ‚Ð°Ð¸Ð»Ð¼ÐµÐ½Ñ‚',0),(372753,10355,'vi','RÃºt bá»›t khoáº£n vay',0),(372754,10355,'af','Lening Curtailment',0),(372755,10355,'ro','ÃŽmprumut de restricÈ›ionare',0),(372756,10355,'et','Laenu piiramine',0),(372757,10355,'si','Posojilo skrÄenja',0),(372758,10355,'ba','Pembatasan pinjaman',0),(372759,10355,'nl','Lening inperking',0),(372760,10355,'fi','Lainan supistaminen',0),(372761,10355,'no','LÃ¥n forkortelse',0),(372762,10355,'da','LÃ¥n indskrÃ¦nkning',0),(372763,10355,'ko','ëŒ€ì¶œ ê°ì¶•',0),(372764,10355,'he','×§×™×¦×•×¥ ×”×œ×•×•××”',0),(372765,10355,'el','Î”Î¬Î½ÎµÎ¹Î¿ Ï€ÎµÏÎ¹ÎºÎ¿Ï€Î®',0),(372766,10355,'zh','ç¼©å‡è´·æ¬¾\r\n',0),(372767,10355,'sv','LÃ¥n inskrÃ¤nkning',0),(372768,10355,'it','Prestito Curtailment',0),(372769,10355,'tl','',0),(372770,10355,'th','à¸à¸¹à¹‰ Curtailment',0),(372771,10355,'hi','à¤‹à¤£ Curtailment',0),(372772,10355,'ms','PEMENDEKAN pinjaman',0),(372773,10355,'ar','ØªÙ‚Ù„ÙŠØµ Ø§Ù„Ù‚Ø±ÙˆØ¶',0),(372774,10355,'fr','RÃ©duction de prÃªt',0),(372775,10355,'jp','è²¸ä»˜ã‘é‡‘ã®å‰Šæ¸›',0),(372776,10355,'pt','RestriÃ§Ã£o de emprÃ©stimo',0),(372777,10355,'ru','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(372778,10355,'es','Acortamiento del PrÃ©stamo',0),(372779,10355,'de','Darlehen-Beschneidung',0),(372780,10355,'en','Loan Curtailment',0),(372781,10356,'is','',0),(372782,10356,'dr','Ø®Ø§Ù„Øµ Ø§Ø±Ø²Ø´ Ø¯ÙØªØ±ÙŠ Ø§Ø±Ø²Ø´ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ Ø¨Ù‡ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÙŠ Ø¢ØªÙŠ',0),(372783,10356,'pr','Ø®Ø§Ù„Øµ Ø§Ø±Ø²Ø´ Ø¯ÙØªØ±ÙŠ Ø§Ø±Ø²Ø´ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ Ø¨Ù‡ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÙŠ Ø¢ØªÙŠ',0),(372784,10356,'tr','NET taÅŸÄ±yan deÄŸeri',0),(372785,10356,'pl','WartoÅ›Ä‡ bilansowa netto',0),(372786,10356,'bg','ÐÐµÑ‚Ð½Ð° Ð±Ð°Ð»Ð°Ð½ÑÐ¾Ð²Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(372787,10356,'ur','Ø¬Ø§Ù„ Ù¾Ú©Ú‘Û’ ÛÙˆØ¦Û’ Ù‚Ø¯Ø±',0),(372788,10356,'sr','ÐÐ¾ÑÐ¸ Ð½ÐµÑ‚Ð¾ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(372789,10356,'vi','GiÃ¡ trá»‹ thá»±c táº¿ chuyá»ƒn sang',0),(372790,10356,'af','Netto Drawaarde',0),(372791,10356,'ro','Valoarea netÄƒ contabilÄƒ',0),(372792,10356,'et','Bilansiline netovÃ¤Ã¤rtus',0),(372793,10356,'si','Neto knjigovodska vrednost',0),(372794,10356,'ba','Nilai membawa bersih',0),(372795,10356,'nl','Netto boekwaarde',0),(372796,10356,'fi','NET kirjanpitoarvo',0),(372797,10356,'no','Netto balansefÃ¸rt verdi',0),(372798,10356,'da','RegnskabsmÃ¦ssig nettovÃ¦rdi',0),(372799,10356,'ko','ìˆœ ë‚˜ë¥´ëŠ” ê°€ì¹˜',0),(372800,10356,'he','×¢×¨×š ×”× ×˜×• × ×©×™××”',0),(372801,10356,'el','ÎšÎ±Î¸Î±ÏÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® Î±Î¾Î¯Î±',0),(372802,10356,'zh','è´¦é¢å‡€å€¼\r\n',0),(372803,10356,'sv','Netto bokfÃ¶rt vÃ¤rde',0),(372804,10356,'it','Valore contabile netto',0),(372805,10356,'tl','',0),(372806,10356,'th','à¸à¸£à¸°à¹€à¸›à¹‹à¸²à¸¡à¸¹à¸¥à¸„à¹ˆà¸²à¸ªà¸¸à¸—à¸˜à¸´',0),(372807,10356,'hi','à¤ªà¥‡à¤Ÿ à¤®à¥‡à¤‚ à¤¨à¥‡à¤Ÿ à¤®à¥‚à¤²à¥à¤¯',0),(372808,10356,'ms','Nilai dibawa bersih',0),(372809,10356,'ar','ØµØ§ÙÙŠ Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ø¯ÙØªØ±ÙŠØ©',0),(372810,10356,'fr','Valeur comptable nette',0),(372811,10356,'jp','ç´”å¸³ç°¿ä¾¡é¡',0),(372812,10356,'pt','Valor contabilÃ­stico lÃ­quido',0),(372813,10356,'ru','Ð§Ð¸ÑÑ‚Ð°Ñ Ð±Ð°Ð»Ð°Ð½ÑÐ¾Ð²Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(372814,10356,'es','Valor Neto Para Llevar',0),(372815,10356,'de','Netto-Buchwert',0),(372816,10356,'en','Net Carrying Value',0),(372817,10357,'is','',0),(372818,10357,'dr','ØªØ¹Ø¯Ø§Ø¯ ÙˆØ§Ø­Ø¯Ù‡Ø§',0),(372819,10357,'pr','ØªØ¹Ø¯Ø§Ø¯ ÙˆØ§Ø­Ø¯Ù‡Ø§',0),(372820,10357,'tr','Birim sayÄ±sÄ±',0),(372821,10357,'pl','Liczba jednostek',0),(372822,10357,'bg','Ð‘Ñ€Ð¾Ð¹ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(372823,10357,'ur','ÛŒÙˆÙ†Ù¹ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(372824,10357,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(372825,10357,'vi','sá»‘ Ä‘Æ¡n vá»‹',0),(372826,10357,'af','Aantal Eenhede',0),(372827,10357,'ro','NumÄƒr de unitÄƒÅ£i',0),(372828,10357,'et','Ãœhikute arv',0),(372829,10357,'si','Å tevilo enot',0),(372830,10357,'ba','Jumlah unit',0),(372831,10357,'nl','Aantal eenheden',0),(372832,10357,'fi','YksikÃ¶iden mÃ¤Ã¤rÃ¤',0),(372833,10357,'no','Antall enheter',0),(372834,10357,'da','Antal enheder',0),(372835,10357,'ko','ë‹¨ìœ„ì˜ ìˆ˜',0),(372836,10357,'he','×ž×¡×¤×¨ ×™×—×™×“×•×ª',0),(372837,10357,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(372838,10357,'zh','å•ä½æ•°ç›®\r\n',0),(372839,10357,'sv','Antalet enheter',0),(372840,10357,'it','Numero di unitÃ ',0),(372841,10357,'tl','',0),(372842,10357,'th','à¸ˆà¸³à¸™à¸§à¸™à¸‚à¸­à¸‡à¸«à¸™à¹ˆà¸§à¸¢',0),(372843,10357,'hi','à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(372844,10357,'ms','Bilangan unit',0),(372845,10357,'ar','Ø¹Ø¯Ø¯ Ø§Ù„ÙˆØ­Ø¯Ø§Øª',0),(372846,10357,'fr','Nombre d\'unitÃ©s',0),(372847,10357,'jp','å˜ä½æ•°',0),(372848,10357,'pt','NÃºmero de unidades',0),(372849,10357,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐµÐ´Ð¸Ð½Ð¸Ñ†',0),(372850,10357,'es','NÃºmero de Unidades',0),(372851,10357,'de','Anzahl der Einheiten',0),(372852,10357,'en','Number of Units',0),(372853,10358,'is','',0),(372854,10358,'dr','Ø¯Ø±ØµØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¨Ø³ØªÙ† Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ',0),(372855,10358,'pr','Ø¯Ø±ØµØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø¨Ø³ØªÙ† Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ',0),(372856,10358,'tr','KapanÄ±ÅŸ maliyetleri yÃ¼zde',0),(372857,10358,'pl','Procent koszty zamkniÄ™cia',0),(372858,10358,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°, Ð·Ð°Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(372859,10358,'ur','Ú©Ù„ÙˆØ²Ù†Ú¯ ÙÛŒØµØ¯',0),(372860,10358,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ñ˜Ðµ Ð·Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(372861,10358,'vi','pháº§n trÄƒm chi phÃ­ Ä‘Ã³ng',0),(372862,10358,'af','Persent sluit koste',0),(372863,10358,'ro','% Costurile de Ã®nchidere',0),(372864,10358,'et','Protsenti sulgemise kulud',0),(372865,10358,'si','Odstotkov, stroÅ¡ki zaprtja',0),(372866,10358,'ba','Persen biaya penutupan',0),(372867,10358,'nl','Procent sluiten kosten',0),(372868,10358,'fi','Prosenttia PÃ¤Ã¤tÃ¶skurssi kustannukset',0),(372869,10358,'no','Prosent avsluttende kostnader',0),(372870,10358,'da','Procent lukning omkostninger',0),(372871,10358,'ko','ë¹„ìš©ì„ ë‹«ëŠ” %',0),(372872,10358,'he','××—×•×– ×œ×¡×’×•×¨ ×ž×—×™×¨×™×',0),(372873,10358,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ, Î´Î±Ï€Î¬Î½ÎµÏ‚ ÎºÎ»ÎµÎ¹ÏƒÎ¯Î¼Î±Ï„Î¿Ï‚',0),(372874,10358,'zh','äº¤æ˜“è´¹ç”¨çš„ç™¾åˆ†æ¯”\r\n',0),(372875,10358,'sv','Procent stÃ¤ngning kostnader',0),(372876,10358,'it','% Costi di chiusura',0),(372877,10358,'tl','',0),(372878,10358,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸›à¸´à¸”à¸•à¹‰à¸™à¸—à¸¸à¸™',0),(372879,10358,'hi','à¤¸à¤®à¤¾à¤ªà¤¨ à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(372880,10358,'ms','Peratus yang menutup kos',0),(372881,10358,'ar','Ø¥ØºÙ„Ø§Ù‚ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(372882,10358,'fr','Pour cent de frais de clÃ´ture',0),(372883,10358,'jp','é–‰ä¼šã®ã‚³ã‚¹ãƒˆ ï¼…',0),(372884,10358,'pt','Por cento dos custos de fechamento',0),(372885,10358,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¸Ñ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(372886,10358,'es','Porcentaje de Costos de Terminar con el Acuerdo',0),(372887,10358,'de','Prozent GrundgebÃ¼hren',0),(372888,10358,'en','Percent Closing Costs',0),(372889,10359,'is','',0),(372890,10359,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(372891,10359,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(372892,10359,'tr','Bina satÄ±ÅŸ gÃ¼ncelleme',0),(372893,10359,'pl','Aktualizacja sprzedaÅ¼y budynku',0),(372894,10359,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(372895,10359,'ur','Ø¹Ù…Ø§Ø±Øª Ø³ÛŒÙ„Ø² ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(372896,10359,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(372897,10359,'vi','XÃ¢y dá»±ng bÃ¡n hÃ ng Cáº­p Nháº­t',0),(372898,10359,'af','Gebou verkope opdatering',0),(372899,10359,'ro','ClÄƒdire vÃ¢nzÄƒri Update',0),(372900,10359,'et','Hoone mÃ¼Ã¼gi uuendamine',0),(372901,10359,'si','Posodobitev prodaje stavbe',0),(372902,10359,'ba','Bangunan penjualan Update',0),(372903,10359,'nl','Gebouw verkoop Update',0),(372904,10359,'fi','Rakennus myynnin pÃ¤ivitys',0),(372905,10359,'no','Bygningen salg oppdatering',0),(372906,10359,'da','Bygning salg opdatering',0),(372907,10359,'ko','ê±´ë¬¼ íŒë§¤ ì—…ë°ì´íŠ¸',0),(372908,10359,'he','×¢×“×›×•×Ÿ ×ž×›×™×¨×•×ª ×”×‘× ×™×™×Ÿ',0),(372909,10359,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(372910,10359,'zh','å»ºç«‹é”€å”®æ›´æ–°\r\n',0),(372911,10359,'sv','Byggnaden fÃ¶rsÃ¤ljning uppdatering',0),(372912,10359,'it','Aggiornamento vendita edificio',0),(372913,10359,'tl','',0),(372914,10359,'th','à¸­à¸²à¸„à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸‚à¸²à¸¢',0),(372915,10359,'hi','à¤­à¤µà¤¨ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(372916,10359,'ms','Kemaskini jualan bangunan',0),(372917,10359,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¨Ù†Ù‰ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(372918,10359,'fr','Mise Ã  jour de vente de bÃ¢timent',0),(372919,10359,'jp','å»ºç‰©è²©å£²æ›´æ–°',0),(372920,10359,'pt','EdifÃ­cio vendas atualizaÃ§Ã£o',0),(372921,10359,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(372922,10359,'es','Actualizar Ventas de Edificios',0),(372923,10359,'de','GebÃ¤ude Sales Update',0),(372924,10359,'en','Building Sales Update',0),(372925,10360,'is','',0),(372926,10360,'dr','ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ Ø§Ø² ÙØ±ÙˆØ´',0),(372927,10360,'pr','ÙˆØ¬ÙˆÙ‡ Ù†Ù‚Ø¯ Ø§Ø² ÙØ±ÙˆØ´',0),(372928,10360,'tr','Nakit satÄ±ÅŸ',0),(372929,10360,'pl','ÅšrodkÃ³w pieniÄ™Å¼nych ze sprzedaÅ¼y',0),(372930,10360,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(372931,10360,'ur','Ù†Ù‚Ø¯ ÙØ±ÙˆØ®Øª Ø³Û’',0),(372932,10360,'sr','ÐÐ¾Ð²Ð°Ñ† Ð¾Ð´ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(372933,10360,'vi','Tiá»n tá»« bÃ¡n hÃ ng',0),(372934,10360,'af','Kontant vanaf Verkope',0),(372935,10360,'ro','Bani din vÃ¢nzarea',0),(372936,10360,'et','Raha mÃ¼Ã¼gist',0),(372937,10360,'si','Denar od prodaje',0),(372938,10360,'ba','Uang dari penjualan',0),(372939,10360,'nl','Kasstroom uit verkoop',0),(372940,10360,'fi','Liiketoiminnan myynnistÃ¤',0),(372941,10360,'no','Penger fra salg',0),(372942,10360,'da','Kontanter fra salg',0),(372943,10360,'ko','íŒë§¤ì—ì„œ í˜„ê¸ˆ',0),(372944,10360,'he','×”×›×¡×£ ×ž×ž×›×™×¨×ª',0),(372945,10360,'el','ÎœÎµÏ„ÏÎ·Ï„Î¬ Î±Ï€ÏŒ Ï€ÏŽÎ»Î·ÏƒÎ·',0),(372946,10360,'zh','å‡ºå”®äº§ç”Ÿçš„çŽ°é‡‘æµé‡\r\n',0),(372947,10360,'sv','Kontanter frÃ¥n fÃ¶rsÃ¤ljning',0),(372948,10360,'it','Denaro dalla vendita',0),(372949,10360,'tl','',0),(372950,10360,'th','à¹€à¸‡à¸´à¸™à¸ªà¸”à¸ˆà¸²à¸à¸à¸²à¸£à¸‚à¸²à¸¢',0),(372951,10360,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¥‡ à¤¨à¤•à¤¦',0),(372952,10360,'ms','Tunai daripada jualan',0),(372953,10360,'ar','Ø§Ù„ØªØ¯ÙÙ‚Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø§Ù„Ù…ØªØ£ØªÙŠØ© Ù…Ù† Ø¨ÙŠØ¹',0),(372954,10360,'fr','TrÃ©sorerie de vente',0),(372955,10360,'jp','è²©å£²ã‹ã‚‰ã®ç¾é‡‘',0),(372956,10360,'pt','Dinheiro da venda',0),(372957,10360,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(372958,10360,'es','Efectivo de la Venta',0),(372959,10360,'de','Geld aus dem Verkauf',0),(372960,10360,'en','Cash from Sale',0),(372961,10361,'is','',0),(372962,10361,'dr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ ',0),(372963,10361,'pr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÙŠ Ø¬Ø³ØªØ¬Ùˆ ',0),(372964,10361,'tr','Arama iÃ§in arama bilgi girin',0),(372965,10361,'pl','Wpisz Szukaj Info dla wyszukiwania',0),(372966,10361,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(372967,10361,'ur','Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Û’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(372968,10361,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð˜Ð½Ñ„Ð¾ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(372969,10361,'vi','nháº­p thÃ´ng tin tÃ¬m kiáº¿m Ä‘á»ƒ tra cá»©u',0),(372970,10361,'af','Voer Soektog Inligting in vir Opsoek',0),(372971,10361,'ro','IntroduceÅ£i informaÅ£ii de cÄƒutare pentru cÄƒutare',0),(372972,10361,'et','Sisestage otsing Info otsing',0),(372973,10361,'si','Vnesite iskanje informacij za iskanje',0),(372974,10361,'ba','Masukkan Cari Info untuk Lookup',0),(372975,10361,'nl','Voer Zoek Info voor Lookup',0),(372976,10361,'fi','Kirjoita haku Info-haku',0),(372977,10361,'no','Angi sÃ¸k Info for oppslag',0),(372978,10361,'da','Indtast sÃ¸gning Info for opslag',0),(372979,10361,'ko','ì¡°íšŒì— ëŒ€ í•œ ê²€ìƒ‰ ì •ë³´ë¥¼ ìž…ë ¥',0),(372980,10361,'he','×”×–×Ÿ ×ž×™×“×¢ ×—×™×¤×•×© ×¢×‘×•×¨ ×‘×“×™×§×ª ×ž×™×“×¢',0),(372981,10361,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î·Î½ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(372982,10361,'zh','è¾“å…¥æœç´¢æŸ¥æ‰¾ä¿¡æ¯\r\n',0),(372983,10361,'sv','Skriv in SÃ¶k Info fÃ¶r sÃ¶kning',0),(372984,10361,'it','Immettere informazioni di ricerca per la ricerca',0),(372985,10361,'tl','',0),(372986,10361,'th','à¸›à¹‰à¸­à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²',0),(372987,10361,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥à¤•à¤…à¤ª à¤–à¥‹à¤œ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(372988,10361,'ms','Masukkan maklumat carian untuk carian',0),(372989,10361,'ar','Ø£Ø¯Ø®Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¨Ø­Ø« Ù„Ù„Ø¨Ø­Ø« Ø¹Ù†',0),(372990,10361,'fr','Entrez la recherche d\'informations pour la recherche',0),(372991,10361,'jp','å‚ç…§ã®æ¤œç´¢æƒ…å ±ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(372992,10361,'pt','Digite busca informaÃ§Ã£o para pesquisa',0),(372993,10361,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐŸÐ¾Ð¸ÑÐº Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Ð´Ð»Ñ Ð¿Ð¾Ð¸ÑÐºÐ°',0),(372994,10361,'es','Entrar InformaciÃ³n de Busqueda para Buscar',0),(372995,10361,'de','Suche Infos fÃ¼r die Suche eingeben',0),(372996,10361,'en','Enter Search Info for Lookup',0),(372997,10362,'is','',0),(372998,10362,'dr','Ø´Ø±Ø­ Ø®Ù„Ø§ØµÙ‡ ',0),(372999,10362,'pr','Ø´Ø±Ø­ Ø®Ù„Ø§ØµÙ‡ ',0),(373000,10362,'tr','KÄ±sa aÃ§Ä±klama',0),(373001,10362,'pl','KrÃ³tki opis',0),(373002,10362,'bg','ÐšÑ€Ð°Ñ‚ÐºÐ¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(373003,10362,'ur','Ù…Ø®ØªØµØ± Ø¨ÛŒØ§Ù†',0),(373004,10362,'sr','ÐšÑ€Ð°Ñ‚Ð°Ðº Ð¾Ð¿Ð¸Ñ',0),(373005,10362,'vi','Diá»…n giáº£i ngáº¯n',0),(373006,10362,'af','Kort beskrywing',0),(373007,10362,'ro','Scurta descriere',0),(373008,10362,'et','LÃ¼hikirjeldus',0),(373009,10362,'si','Kratek opis',0),(373010,10362,'ba','Deskripsi singkat',0),(373011,10362,'nl','Korte beschrijving',0),(373012,10362,'fi','Lyhyt kuvaus',0),(373013,10362,'no','Kort beskrivelse',0),(373014,10362,'da','Kort beskrivelse',0),(373015,10362,'ko','ê°„ë‹¨í•œ ì„¤ëª…',0),(373016,10362,'he','×ª×™××•×¨ ×§×¦×¨',0),(373017,10362,'el','Î£ÏÎ½Ï„Î¿Î¼Î· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(373018,10362,'zh','ç®€çŸ­æè¿°\r\n',0),(373019,10362,'sv','Kort beskrivning',0),(373020,10362,'it','Breve descrizione',0),(373021,10362,'tl','',0),(373022,10362,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹‚à¸”à¸¢à¸¢à¹ˆà¸­',0),(373023,10362,'hi','à¤²à¤˜à¥ à¤µà¤°à¥à¤£à¤¨',0),(373024,10362,'ms','Huraian ringkas',0),(373025,10362,'ar','ÙˆØµÙ Ù‚ØµÙŠØ±',0),(373026,10362,'fr','BrÃ¨ve Description',0),(373027,10362,'jp','çŸ­ã„èª¬æ˜Ž',0),(373028,10362,'pt','Breve descriÃ§Ã£o',0),(373029,10362,'ru','ÐšÑ€Ð°Ñ‚ÐºÐ¾Ðµ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(373030,10362,'es','DescripciÃ³n Corto',0),(373031,10362,'de','Kurze Beschreibung',0),(373032,10362,'en','Short Description',0),(373033,10363,'is','',0),(373034,10363,'dr','(ÙØ±ÙˆØ´',0),(373035,10363,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø² Ø­Ø±Ø§Ø¬(ÙØ±ÙˆØ´',0),(373036,10363,'tr','Vergiye tabi satÄ±ÅŸ geliri',0),(373037,10363,'pl','DochÃ³d ze sprzedaÅ¼y',0),(373038,10363,'bg','ÐžÐ±Ð»Ð°Ð³Ð°ÐµÐ¼ Ð´Ð¾Ñ…Ð¾Ð´ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(373039,10363,'ur','ÙØ±ÙˆØ®Øª Ø³Û’ Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ Ø¢Ù…Ø¯Ù†ÛŒ',0),(373040,10363,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´ Ð¾Ð´ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(373041,10363,'vi','Thu nháº­p chá»‹u thuáº¿ tá»« doanh sá»‘',0),(373042,10363,'af','Belasbare Inkomste van Verkope',0),(373043,10363,'ro','Venituri impozabile la vÃ¢nzare',0),(373044,10363,'et','Maksustatava tulu mÃ¼Ã¼gist',0),(373045,10363,'si','ObdavÄljiv prihodek od prodaje',0),(373046,10363,'ba','Penghasilan kena pajak dari penjualan',0),(373047,10363,'nl','Belastbaar inkomen uit verkoop',0),(373048,10363,'fi','Verotettavaa tuloa myynnistÃ¤',0),(373049,10363,'no','Skattbar inntekt fra salg',0),(373050,10363,'da','Skattepligtige indkomst fra salg',0),(373051,10363,'ko','íŒë§¤ì—ì„œ ê³¼ì„¸ ì†Œë“',0),(373052,10363,'he','×”×›× ×¡×” ×—×™×™×‘×ª ×‘×ž×¡ ×ž×ž×›×™×¨×ª',0),(373053,10363,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­Î¿Ï… ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚ Î±Ï€ÏŒ Ï„Î·Î½ Ï€ÏŽÎ»Î·ÏƒÎ·',0),(373054,10363,'zh','é”€å”®åº”ç¨Žæ”¶å…¥\r\n',0),(373055,10363,'sv','Beskattningsbar inkomst frÃ¥n fÃ¶rsÃ¤ljning',0),(373056,10363,'it','Reddito imponibile da vendita',0),(373057,10363,'tl','',0),(373058,10363,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢',0),(373059,10363,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¥‡ à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ à¤†à¤¯',0),(373060,10363,'ms','Pendapatan yang boleh dikenakan cukai dari jualan',0),(373061,10363,'ar','Ø§Ù„Ø¯Ø®Ù„ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ù…Ù† Ø§Ù„Ø¨ÙŠØ¹',0),(373062,10363,'fr','Revenu imposable de vente',0),(373063,10363,'jp','è²©å£²ã‹ã‚‰ã®èª²ç¨Žæ‰€å¾—',0),(373064,10363,'pt','Rendimento tributÃ¡vel de venda',0),(373065,10363,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ñ‹Ð¹ Ð´Ð¾Ñ…Ð¾Ð´ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(373066,10363,'es','Renta Imponible de Esta Venta',0),(373067,10363,'de','Steuerpflichtige ErtrÃ¤ge aus Verkauf',0),(373068,10363,'en','Taxable Income from Sale',0),(373069,10364,'is','',0),(373070,10364,'dr','Ù…ØªÙ† Ø¯Ø± Ø´Ø±Ø­ ',0),(373071,10364,'pr','Ù…ØªÙ† Ø¯Ø± Ø´Ø±Ø­ ',0),(373072,10364,'tr','AÃ§Ä±klama metni',0),(373073,10364,'pl','Tekst w opisie',0),(373074,10364,'bg','Ð¢ÐµÐºÑÑ‚ Ð² Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸ÐµÑ‚Ð¾',0),(373075,10364,'ur','Ø¨ÛŒØ§Ù† Ú©Û’ Ù…ØªÙ†',0),(373076,10364,'sr','Ð¢ÐµÐºÑÑ‚ Ñƒ Ð¾Ð¿Ð¸Ñ',0),(373077,10364,'vi','VÄƒn báº£n trong mÃ´ táº£',0),(373078,10364,'af','Teks in Beskrywing',0),(373079,10364,'ro','Textul din Descriere',0),(373080,10364,'et','Teksti kirjeldus',0),(373081,10364,'si','Besedilo v opis',0),(373082,10364,'ba','Teks dalam deskripsi',0),(373083,10364,'nl','Tekst in het vak Beschrijving',0),(373084,10364,'fi','Tekstin kuvaus',0),(373085,10364,'no','Tekst i Beskrivelse',0),(373086,10364,'da','Teksten i Beskrivelse',0),(373087,10364,'ko','ì„¤ëª… í…ìŠ¤íŠ¸',0),(373088,10364,'he','×˜×§×¡×˜ ×‘×ª××•×¨',0),(373089,10364,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î·Î½ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(373090,10364,'zh','åœ¨æè¿°ä¸­çš„æ–‡æœ¬\r\n',0),(373091,10364,'sv','Text i beskrivningen',0),(373092,10364,'it','Testo nella descrizione',0),(373093,10364,'tl','',0),(373094,10364,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¹ƒà¸™à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢',0),(373095,10364,'hi','à¤ªà¤¾à¤  à¤µà¤°à¥à¤£à¤¨ à¤®à¥‡à¤‚',0),(373096,10364,'ms','Teks penerangan',0),(373097,10364,'ar','Ø§Ù„Ù†Øµ ÙÙŠ ÙˆØµÙ',0),(373098,10364,'fr','Texte de Description',0),(373099,10364,'jp','èª¬æ˜Žå†…ã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(373100,10364,'pt','Texto de descriÃ§Ã£o',0),(373101,10364,'ru','Ð¢ÐµÐºÑÑ‚ Ð² ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ð¸',0),(373102,10364,'es','Texto en la DescripciÃ³n',0),(373103,10364,'de','Text in Beschreibung',0),(373104,10364,'en','Text in Description',0),(373105,10365,'is','',0),(373106,10365,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡ Ù„ÙˆÙ„Ù‡ ÙƒØ´ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(373107,10365,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡ Ù„ÙˆÙ„Ù‡ ÙƒØ´ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(373108,10365,'tr','Yeni proje ardÄ±ÅŸÄ±k dÃ¼zen ayrÄ±ntÄ±larÄ±nÄ± ekle',0),(373109,10365,'pl','Dodaj nowy projekt gazociÄ…gu szczegÃ³Å‚y',0),(373110,10365,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ñ‚Ñ€ÑŠÐ±Ð¾Ð¿Ñ€Ð¾Ð²Ð¾Ð´ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(373111,10365,'ur','Ù†Ø¦Û’ Ù…Ù†ØµÙˆØ¨Û’ Ù¾Ø§Ø¦Ù¾ Ù„Ø§Ø¦Ù† ØªÙØµÛŒÙ„Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(373112,10365,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÐ°Ñ‚ Ð½Ð°Ñ„Ñ‚Ð¾Ð²Ð¾Ð´Ð° Ð´ÐµÑ‚Ð°Ñ™Ð¸',0),(373113,10365,'vi','ThÃªm má»›i dá»± Ã¡n Ä‘Æ°á»ng á»‘ng dáº«n chi tiáº¿t',0),(373114,10365,'af','Voeg nuwe projek pyplyn besonderhede',0),(373115,10365,'ro','Adauga noi proiectul conductei detalii',0),(373116,10365,'et','Lisada uue projekti mÃ¼Ã¼givÃµimaluste Ã¼ksikasjad',0),(373117,10365,'si','Dodaj nov cevovod podrobnosti projekta',0),(373118,10365,'ba','Menambahkan baru proyek pipa rincian',0),(373119,10365,'nl','Toevoegen van nieuwe Project pijpleiding Details',0),(373120,10365,'fi','Uusi putki projektitietojen lisÃ¤Ã¤minen',0),(373121,10365,'no','Legge til nye prosjektet rÃ¸rledning detaljer',0),(373122,10365,'da','TilfÃ¸je nye Project Pipeline detaljer',0),(373123,10365,'ko','ìƒˆ í”„ë¡œì íŠ¸ íŒŒì´í”„ë¼ì¸ ì„¸ë¶€ ì •ë³´ ì¶”ê°€',0),(373124,10365,'he','×”×•×¡×¤×ª ×¤×¨×˜×™× ×—×“×©×™× ×©×œ ×¦×™× ×•×¨ ×¤×¨×•×™×™×§×˜',0),(373125,10365,'el','Î ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Ï…Î½ Î½Î­Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Î³Ï‰Î³Î¿Ï Î­ÏÎ³Î¿Ï…',0),(373126,10365,'zh','å¢žåŠ æ–°é¡¹ç›®æµæ°´çº¿è¯¦æƒ…\r\n',0),(373127,10365,'sv','LÃ¤gga till nya projekt Pipeline Detaljer',0),(373128,10365,'it','Aggiungi nuovo progetto Pipeline dettagli',0),(373129,10365,'tl','',0),(373130,10365,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸‚à¸­à¸‡à¹‚à¸„à¸£à¸‡à¸à¸²à¸£à¹ƒà¸«à¸¡à¹ˆ',0),(373131,10365,'hi','à¤¨à¤ˆ à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤ªà¤¾à¤‡à¤ªà¤²à¤¾à¤‡à¤¨ à¤µà¤¿à¤µà¤°à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(373132,10365,'ms','Tambah butiran projek saluran paip yang baru',0),(373133,10365,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙØ§ØµÙŠÙ„ Ø®Ø· Ø£Ù†Ø§Ø¨ÙŠØ¨ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(373134,10365,'fr','Ajouter le nouveau projet Pipeline dÃ©tails',0),(373135,10365,'jp','æ–°ã—ã„ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®ãƒ‘ã‚¤ãƒ—ãƒ©ã‚¤ãƒ³ã®è©³ç´°ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(373136,10365,'pt','Adicionar novos detalhes de Pipeline Project',0),(373137,10365,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° Ñ‚Ñ€ÑƒÐ±Ð¾Ð¿Ñ€Ð¾Ð²Ð¾Ð´Ð°',0),(373138,10365,'es','Agregar Nuevo Proyecto de Detalles de SegmentaciÃ³n',0),(373139,10365,'de','FÃ¼gen Sie neue Details zum Projekt-Pipeline',0),(373140,10365,'en','Add New Project Pipeline Details',0),(373141,10366,'is','',0),(373142,10366,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡ Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø²',0),(373143,10366,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡ Ø³Ø§Ø®Øª Ùˆ Ø³Ø§Ø²',0),(373144,10366,'tr','Ä°nÅŸaat proje bilgilerini dÃ¼zenleme',0),(373145,10366,'pl','Edytowanie szczegÃ³Å‚Ã³w projektu budowy',0),(373146,10366,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° Ð½Ð° ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(373147,10366,'ur','Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(373148,10366,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð° Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÐµ',0),(373149,10366,'vi','Chá»‰nh sá»­a chi tiáº¿t dá»± Ã¡n xÃ¢y dá»±ng',0),(373150,10366,'af','Redigeer Konstruksie Projekte Besonderhede',0),(373151,10366,'ro','EditaÅ£i detalii de proiect de construcÅ£ie',0),(373152,10366,'et','Ehituse projekti Ã¼ksikasjade redigeerimine',0),(373153,10366,'si','Urejanje podrobnosti projekta gradnje',0),(373154,10366,'ba','Mengedit rincian proyek konstruksi',0),(373155,10366,'nl','Bouw projectdetails bewerken',0),(373156,10366,'fi','Muokkaa rakentaminen projektin tietoja',0),(373157,10366,'no','Redigere Bygg Prosjektdetaljer',0),(373158,10366,'da','Redigere projektet konstruktionsdetaljer',0),(373159,10366,'ko','ê±´ì„¤ í”„ë¡œì íŠ¸ ì„¸ë¶€ ì •ë³´ íŽ¸ì§‘',0),(373160,10366,'he','×¢×¨×™×›×ª ×¤×¨×˜×™ ×¤×¨×•×™×™×§×˜ ×‘× ×™×™×”',0),(373161,10366,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î±ÏƒÏ„Î¹ÎºÎ­Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï„Î¿Ï… Î­ÏÎ³Î¿Ï…',0),(373162,10366,'zh','å»ºè®¾é¡¹ç›®çš„è¯¦ç»†èµ„æ–™ç¼–è¾‘\r\n',0),(373163,10366,'sv','Redigera projektet konstruktionsdetaljer',0),(373164,10366,'it','Modificare i dettagli del progetto di costruzione',0),(373165,10366,'tl','',0),(373166,10366,'th','à¹à¸à¹‰à¹„à¸‚à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹‚à¸„à¸£à¸‡à¸à¸²à¸£à¸à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡',0),(373167,10366,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‡ à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(373168,10366,'ms','Mengedit butiran projek pembinaan',0),(373169,10366,'ar','ØªØ­Ø±ÙŠØ± ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(373170,10366,'fr','Modifier des dÃ©tails de projets de Construction',0),(373171,10366,'jp','å»ºè¨­ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®è©³ç´°ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(373172,10366,'pt','Editar detalhes do projeto de construÃ§Ã£o',0),(373173,10366,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ðµ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(373174,10366,'es','Editar Detalles del Proyecto de ConstrucciÃ³n',0),(373175,10366,'de','Bau-Projekt-Details bearbeiten',0),(373176,10366,'en','Edit Construction Project Details',0),(373177,10367,'is','',0),(373178,10367,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(373179,10367,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(373180,10367,'tr','Proje AyrÄ±ntÄ±larÄ± DÃ¼zenle',0),(373181,10367,'pl','Edytowanie szczegÃ³Å‚Ã³w projektu',0),(373182,10367,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(373183,10367,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(373184,10367,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(373185,10367,'vi','Chá»‰nh sá»­a chi tiáº¿t dá»± Ã¡n',0),(373186,10367,'af','Redigeer Projek Besonderhede',0),(373187,10367,'ro','EditaÅ£i detalii proiect',0),(373188,10367,'et','Projekti Ã¼ksikasjade redigeerimine',0),(373189,10367,'si','Urejanje podrobnosti projekta',0),(373190,10367,'ba','Mengedit rincian proyek',0),(373191,10367,'nl','Projectdetails bewerken',0),(373192,10367,'fi','Muokkaa projektin tietoja',0),(373193,10367,'no','Redigere Prosjektdetaljer',0),(373194,10367,'da','Rediger projektdetaljer',0),(373195,10367,'ko','í”„ë¡œì íŠ¸ ì„¸ë¶€ ì •ë³´ íŽ¸ì§‘',0),(373196,10367,'he','×¢×¨×™×›×ª ×¤×¨×˜×™ ×”×¤×¨×•×™×™×§×˜',0),(373197,10367,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î­ÏÎ³Î¿Ï…',0),(373198,10367,'zh','ç¼–è¾‘é¡¹ç›®ç»†èŠ‚\r\n',0),(373199,10367,'sv','Redigera projektinformation',0),(373200,10367,'it','Modificare i dettagli del progetto',0),(373201,10367,'tl','',0),(373202,10367,'th','à¹à¸à¹‰à¹„à¸‚à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹‚à¸„à¸£à¸‡à¸à¸²à¸£',0),(373203,10367,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‡ à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(373204,10367,'ms','Mengedit butiran projek',0),(373205,10367,'ar','ØªØ­Ø±ÙŠØ± ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(373206,10367,'fr','Modifier les dÃ©tails du projet',0),(373207,10367,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®è©³ç´°ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(373208,10367,'pt','Editar os detalhes do projeto',0),(373209,10367,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ð¹ Ð¾ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ðµ',0),(373210,10367,'es','Edittar Dealles del Proyecto',0),(373211,10367,'de','Details zum Projekt bearbeiten',0),(373212,10367,'en','Edit Project Details',0),(373213,10368,'is','',0),(373214,10368,'dr','ØµÙˆØ±Øª Ø¬Ø±ÙŠØ§Ù†Ù‡Ø§ÙŠ Ù†Ù‚Ø¯ÙŠ Ù…Ù†  ',0),(373215,10368,'pr','ØµÙˆØ±Øª Ø¬Ø±ÙŠØ§Ù†Ù‡Ø§ÙŠ Ù†Ù‚Ø¯ÙŠ Ù…Ù†  ',0),(373216,10368,'tr','Ä°fademi bir nakit akÄ±ÅŸÄ±',0),(373217,10368,'pl','Moje zestawienie przepÅ‚ywÃ³w pieniÄ™Å¼nych',0),(373218,10368,'bg','ÐœÐ¾ÑÑ‚ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸',0),(373219,10368,'ur','Ù…ÛŒØ±ÛŒ Ù†Ù‚Ø¯ Ø¨ÛØ§Ø¤ Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(373220,10368,'sr','ÐœÐ¾Ñ˜ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ñ‚Ð¾ÐºÐ¾Ð²Ð¸Ð¼Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ',0),(373221,10368,'vi','TÃ´i tuyÃªn bá»‘ cá»§a dÃ²ng tiá»n máº·t',0),(373222,10368,'af','My Staat van Kontantvloei',0),(373223,10368,'ro','DeclaraÅ£ia mea de fluxuri de numerar',0),(373224,10368,'et','Minu rahavoogude aruanne',0),(373225,10368,'si','Moj Izkaz denarnih tokov',0),(373226,10368,'ba','Saya laporan arus kas',0),(373227,10368,'nl','Mijn verklaring van kasstromen',0),(373228,10368,'fi','Konsernin rahavirtalaskelma',0),(373229,10368,'no','Min uttalelse kontantstrÃ¸mmer',0),(373230,10368,'da','Min erklÃ¦ring af pengestrÃ¸mme',0),(373231,10368,'ko','ë‚˜ì˜ ê³„ì‚° ì„œ í˜„ê¸ˆ íë¦„ì˜',0),(373232,10368,'he','×”×”×¦×”×¨×” ×©×œ ×ª×–×¨×™×ž×™ ×ž×–×•×ž× ×™×',0),(373233,10368,'el','ÎœÎ¿Ï… ÎšÎ‘Î¤Î‘Î£Î¤Î‘Î£Î— Î¤Î‘ÎœÎ•Î™Î‘ÎšÎ©Î Î¡ÎŸÎ©Î',0),(373234,10368,'zh','æˆ‘çš„çŽ°é‡‘æµé‡è¡¨\r\n',0),(373235,10368,'sv','Min rapport Ã¶ver kassaflÃ¶den',0),(373236,10368,'it','Il mio rendiconto finanziario',0),(373237,10368,'tl','',0),(373238,10368,'th','à¸‡à¸šà¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(373239,10368,'hi','à¤¨à¤•à¤¦ à¤ªà¥à¤°à¤µà¤¾à¤¹à¥‹à¤‚ à¤•à¥‡ à¤®à¥‡à¤°à¥‡ à¤µà¤•à¥à¤¤à¤µà¥à¤¯',0),(373240,10368,'ms','Penyata aliran tunai',0),(373241,10368,'ar','Ø¨Ù„Ø¯ÙŠ Ø¨ÙŠØ§Ù† Ø§Ù„ØªØ¯ÙÙ‚Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(373242,10368,'fr','Ma dÃ©claration des flux de trÃ©sorerie',0),(373243,10368,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ» ãƒ•ãƒ­ãƒ¼ã®ç§ã®æ–‡',0),(373244,10368,'pt','Minha declaraÃ§Ã£o de fluxos de caixa',0),(373245,10368,'ru','ÐœÐ¾Ðµ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð¾ Ð´Ð²Ð¸Ð¶ÐµÐ½Ð¸Ð¸ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(373246,10368,'es','Mi DeclaraciÃ³n de Flujos de Efectivo',0),(373247,10368,'de','Meine Geldflussrechnung',0),(373248,10368,'en','My Statement of Cash Flows',0),(373249,10369,'is','',0),(373250,10369,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡ Ø¬Ø¯ÙŠØ¯',0),(373251,10369,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù¾Ø±ÙˆÚ˜Ù‡ Ø¬Ø¯ÙŠØ¯',0),(373252,10369,'tr','Yeni proje detaylarÄ±',0),(373253,10369,'pl','Nowe szczegÃ³Å‚y projektu',0),(373254,10369,'bg','ÐÐ¾Ð²Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(373255,10369,'ur','Ù†Ø¦Û’ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(373256,10369,'sr','ÐÐ¾Ð²Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ð¸ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(373257,10369,'vi','Chi tiáº¿t dá»± Ã¡n má»›i',0),(373258,10369,'af','Nuwe projek besonderhede',0),(373259,10369,'ro','Noi detalii proiect',0),(373260,10369,'et','Uue projekti Ã¼ksikasjad',0),(373261,10369,'si','Nove podrobnosti o projektu',0),(373262,10369,'ba','Rincian proyek baru',0),(373263,10369,'nl','Nieuwe projectdetails',0),(373264,10369,'fi','Uuden projektin tiedot',0),(373265,10369,'no','Nye Prosjektdetaljer',0),(373266,10369,'da','Nyt projektdetaljer',0),(373267,10369,'ko','ìƒˆ í”„ë¡œì íŠ¸ ì •ë³´',0),(373268,10369,'he','×¤×¨×˜×™ ×”×¤×¨×•×™×™×§×˜ ×”×—×“×©',0),(373269,10369,'el','ÎÎ­ÎµÏ‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î­ÏÎ³Î¿Ï…',0),(373270,10369,'zh','æ–°é¡¹ç›®ç»†èŠ‚\r\n',0),(373271,10369,'sv','Nya projektdetaljer',0),(373272,10369,'it','Nuovi dettagli di progetto',0),(373273,10369,'tl','',0),(373274,10369,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹‚à¸„à¸£à¸‡à¸à¸²à¸£à¹ƒà¸«à¸¡à¹ˆ',0),(373275,10369,'hi','à¤¨à¤ˆ à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(373276,10369,'ms','Butiran projek baru',0),(373277,10369,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(373278,10369,'fr','Nouveaux dÃ©tails du projet',0),(373279,10369,'jp','æ–°ã—ã„ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®è©³ç´°',0),(373280,10369,'pt','Novos detalhes de projeto',0),(373281,10369,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(373282,10369,'es','Deaalles del Nuevo Proyecto',0),(373283,10369,'de','Neue Details zum Projekt',0),(373284,10369,'en','New Project Details',0),(373285,10370,'is','',0),(373286,10370,'dr','Ù‚ÙŠÙ…ØªÙ‡Ø§ Ø±Ø§ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(373287,10370,'pr','Ù‚ÙŠÙ…ØªÙ‡Ø§ Ø±Ø§ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÙŠØ¯ ',0),(373288,10370,'tr','Fiyatlar PO Ã¼zerinde gÃ¶sterme',0),(373289,10370,'pl','Nie pokazuj ceny na PO',0),(373290,10370,'bg','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ñ†ÐµÐ½Ð¸Ñ‚Ðµ Ð½Ð° PO',0),(373291,10370,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ù¾Ø± Ù¾Ùˆ Ù†Ù…Ø§ÛŒØ´ Ù†Û Ú©Ø±ÛŒÚº Û”',0),(373292,10370,'sr','ÐÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜ Ñ†ÐµÐ½Ðµ Ð½Ð° Ð¿Ð¾-Ð°',0),(373293,10370,'vi','KhÃ´ng hiá»‡n giÃ¡ trÃªn Ä‘á» nghá»‹ mua hÃ ng',0),(373294,10370,'af','Moenie Pryse Aandui op AB',0),(373295,10370,'ro','Nu aratÄƒ preÅ£urile pe PO',0),(373296,10370,'et','NÃ¤ita hindu PO',0),(373297,10370,'si','Cene ne kaÅ¾ejo na PO',0),(373298,10370,'ba','Tidak menunjukkan harga pada PO',0),(373299,10370,'nl','Vertonen geen prijzen op PO',0),(373300,10370,'fi','NÃ¤ytÃ¤ hinnat PO',0),(373301,10370,'no','Ikke Vis priser pÃ¥ PO',0),(373302,10370,'da','Vis ikke priserne pÃ¥ PO',0),(373303,10370,'ko','í¬ì— ê°€ê²©ì„ í‘œì‹œ í•˜ì§€ ì•ŠìŒ',0),(373304,10370,'he','××œ ×ª×¦×™×’ ××ª ×”×ž×—×™×¨×™× ×‘×¤×•',0),(373305,10370,'el','Î”ÎµÎ½ ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ Ï„Î¹Î¼Î­Ï‚ ÏƒÏ„Î·Î½ PO',0),(373306,10370,'zh','ä¸åœ¨é‡‡è´­è®¢å•ä¸Šæ˜¾ç¤ºä»·æ ¼\r\n',0),(373307,10370,'sv','Visa inte priserna pÃ¥ PO',0),(373308,10370,'it','Non mostrare i prezzi sul PO',0),(373309,10370,'tl','',0),(373310,10370,'th','à¹à¸ªà¸”à¸‡à¸£à¸²à¸„à¸²à¹ƒà¸™ PO',0),(373311,10370,'hi','à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤ªà¤° à¤ªà¥‹ à¤¨ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(373312,10370,'ms','Jangan tunjuk harga pada PO',0),(373313,10370,'ar','Ø¹Ø¯Ù… Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¹Ù„Ù‰ Ø¨Ùˆ',0),(373314,10370,'fr','Ne prÃ©sentent pas de prix par PO',0),(373315,10370,'jp','PO ã§ä¾¡æ ¼ã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(373316,10370,'pt','NÃ£o mostram os preÃ§os na PO',0),(373317,10370,'ru','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‹ Ð½Ð° PO',0),(373318,10370,'es','No Muestra Precios En El OC',0),(373319,10370,'de','Zeigen Sie keine Preise am PO',0),(373320,10370,'en','Do Not Show Prices On PO',0),(373321,10371,'is','',0),(373322,10371,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ ',0),(373323,10371,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ ',0),(373324,10371,'tr','Tahsisatlar tamamlandÄ±',0),(373325,10371,'pl','ZakoÅ„czeniu aktualizacji faktury',0),(373326,10371,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐ¸Ñ… Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(373327,10371,'ur','Ø®ØªÙ… ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(373328,10371,'sr','Ð—Ð°Ð²Ñ€ÑˆÐ¸Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(373329,10371,'vi','cáº­p nháº­t hÃ³a Ä‘Æ¡n Ä‘Ã£ káº¿t thÃºc',0),(373330,10371,'af','Opdatering van Fakture Afgehandel',0),(373331,10371,'ro','Terminat actualizarea facturi',0),(373332,10371,'et','LÃµpetanud arvete sisestamisel',0),(373333,10371,'si','DokonÄal posodabljanje raÄunov',0),(373334,10371,'ba','Selesai memperbarui faktur',0),(373335,10371,'nl','Klaar bent met het bijwerken van facturen',0),(373336,10371,'fi','PÃ¤ivittÃ¤nyt laskut',0),(373337,10371,'no','FullfÃ¸rt fakturaoppdatering',0),(373338,10371,'da','FÃ¦rdig med at opdatere fakturaer',0),(373339,10371,'ko','ì†¡ìž¥ ì—…ë°ì´íŠ¸ ì™„ë£Œ',0),(373340,10371,'he','×¡×™×•× ×¢×“×›×•×Ÿ ×—×©×‘×•× ×™×•×ª',0),(373341,10371,'el','Î¤ÎµÎ»ÎµÎ¯Ï‰ÏƒÎµ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(373342,10371,'zh','å®Œæˆæ›´æ–°å‘ç¥¨\r\n',0),(373343,10371,'sv','FÃ¤rdiga uppdatering av fakturor',0),(373344,10371,'it','Finito aggiornamento fatture',0),(373345,10371,'tl','',0),(373346,10371,'th','à¹ƒà¸šà¹€à¸ªà¸£à¹‡à¸ˆ',0),(373347,10371,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(373348,10371,'ms','Selesai mengemas kini invois',0),(373349,10371,'ar','Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ù…Ù† ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(373350,10371,'fr','TerminÃ© la mise Ã  jour des factures',0),(373351,10371,'jp','è«‹æ±‚æ›¸ã®æ›´æ–°ã‚’çµ‚äº†ã—ã¾ã—ãŸ',0),(373352,10371,'pt','Terminou a actualizaÃ§Ã£o de facturas',0),(373353,10371,'ru','Ð—Ð°ÐºÐ¾Ð½Ñ‡Ð¸Ð» Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(373354,10371,'es','Se Terminaron ActualizaciÃ³n de Facturas',0),(373355,10371,'de','Aktualisierung Rechnungen abgeschlossen',0),(373356,10371,'en','Finished Updating Invoices',0),(373357,10372,'is','',0),(373358,10372,'dr','ØªØ¹ÙŠÙŠÙ† ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ùˆ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(373359,10372,'pr','ØªØ¹ÙŠÙŠÙ† ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ùˆ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(373360,10372,'tr','KullanÄ±cÄ±larÄ± ve gruplarÄ± ata',0),(373361,10372,'pl','Przypisywanie uÅ¼ytkownikÃ³w i grup',0),(373362,10372,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸ Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸',0),(373363,10372,'ur','ØµØ§Ø±ÙÛŒÙ† Ø§ÙˆØ± Ú¯Ø±ÙˆÙ¾ Ú©Ùˆ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(373364,10372,'sr','Ð”Ð¾Ð´ÐµÑ™Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¸ Ð³Ñ€ÑƒÐ¿Ð°',0),(373365,10372,'vi','Chá»‰ Ä‘á»‹nh ngÆ°á»i sá»­ dá»¥ng vÃ  nhÃ³m',0),(373366,10372,'af','Toeken van Gebruikers en Groepe',0),(373367,10372,'ro','AtribuiÅ£i utilizatorilor ÅŸi grupurilor',0),(373368,10372,'et','Kasutajate ja rÃ¼hmade mÃ¤Ã¤ramine',0),(373369,10372,'si','Dodeliti uporabnikom in skupinam',0),(373370,10372,'ba','Menetapkan pengguna dan grup',0),(373371,10372,'nl','Gebruikers en groepen toewijzen',0),(373372,10372,'fi','Osoita kÃ¤yttÃ¤jiÃ¤ ja ryhmiÃ¤',0),(373373,10372,'no','Tilordne brukere og grupper',0),(373374,10372,'da','Tildele brugere og grupper',0),(373375,10372,'ko','ì‚¬ìš©ìž ë° ê·¸ë£¹ í• ë‹¹',0),(373376,10372,'he','×œ×”×§×¦×•×ª ×œ×ž×©×ª×ž×©×™× ×•×œ×§×‘×•×¦×•×ª',0),(373377,10372,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ ÎºÎ±Î¹ Î¿Î¼Î¬Î´ÎµÏ‚',0),(373378,10372,'zh','åˆ†é…ç”¨æˆ·å’Œç»„\r\n',0),(373379,10372,'sv','Tilldela anvÃ¤ndare och grupper',0),(373380,10372,'it','Assegnare gli utenti e gruppi',0),(373381,10372,'tl','',0),(373382,10372,'th','à¸à¸³à¸«à¸™à¸”à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹à¸¥à¸°à¸à¸¥à¸¸à¹ˆà¸¡',0),(373383,10372,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤”à¤° à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¥‹ à¤…à¤¸à¤¾à¤‡à¤¨',0),(373384,10372,'ms','Menguntukkan pengguna dan Kumpulan',0),(373385,10372,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† ÙˆØ§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø§Øª',0),(373386,10372,'fr','Affecter des utilisateurs et des groupes',0),(373387,10372,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã¨ã‚°ãƒ«ãƒ¼ãƒ—ã‚’å‰²ã‚Šå½“ã¦ã‚‹',0),(373388,10372,'pt','Atribuir usuÃ¡rios e grupos',0),(373389,10372,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ Ð¸ Ð³Ñ€ÑƒÐ¿Ð¿',0),(373390,10372,'es','Asignar Usuarios y Grupos',0),(373391,10372,'de','Zuweisen von Benutzern und Gruppen',0),(373392,10372,'en','Assign Users and Groups',0),(373393,10373,'is','',0),(373394,10373,'dr','Ù…Ø¬ÙˆØ² ÙƒØ³Ø¨ Ùˆ ÙƒØ§Ø±',0),(373395,10373,'pr','Ù…Ø¬ÙˆØ² ÙƒØ³Ø¨ Ùˆ ÙƒØ§Ø±',0),(373396,10373,'tr','Ä°ÅŸletme lisans',0),(373397,10373,'pl','Zezwolenia na prowadzenie dziaÅ‚alnoÅ›ci',0),(373398,10373,'bg','Ð‘Ð¸Ð·Ð½ÐµÑ Ð»Ð¸Ñ†ÐµÐ½Ð·',0),(373399,10373,'ur','Ú©Ø§Ø±ÙˆØ¨Ø§Ø±ÛŒ Ù„Ø§Ø¦Ø³Ù†Ø³',0),(373400,10373,'sr','ÐŸÐ¾ÑÐ»Ð¾Ð²Ð½Ðµ Ð»Ð¸Ñ†ÐµÐ½Ñ†Ðµ',0),(373401,10373,'vi','Giáº¥y phÃ©p Kinh Doanh',0),(373402,10373,'af','Besigheidslisensie',0),(373403,10373,'ro','LicenÅ£Äƒ de afaceri',0),(373404,10373,'et','Business litsents',0),(373405,10373,'si','Obrtno dovoljenje',0),(373406,10373,'ba','Izin usaha',0),(373407,10373,'nl','Bedrijfsvergunning',0),(373408,10373,'fi','Toimilupa',0),(373409,10373,'no','Business lisens',0),(373410,10373,'da','Erhvervslicens',0),(373411,10373,'ko','ì‚¬ì—… ë“±ë¡ì¦',0),(373412,10373,'he','×¨×©×™×•×Ÿ ×¢×¡×§',0),(373413,10373,'el','Î†Î´ÎµÎ¹Î± Î¬ÏƒÎºÎ·ÏƒÎ·Ï‚ ÎµÏ€Î¹Ï‡ÎµÎ¹ÏÎ·Î¼Î±Ï„Î¹ÎºÏŽÎ½ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï„Î®Ï„Ï‰Î½',0),(373414,10373,'zh','è¥ä¸šæ‰§ç…§\r\n',0),(373415,10373,'sv','Business-licens',0),(373416,10373,'it','Licenza commerciale',0),(373417,10373,'tl','',0),(373418,10373,'th','à¹ƒà¸šà¸­à¸™à¸¸à¸à¸²à¸•à¸›à¸£à¸°à¸à¸­à¸šà¸˜à¸¸à¸£à¸à¸´à¸ˆ',0),(373419,10373,'hi','à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤° à¤²à¤¾à¤‡à¤¸à¥‡à¤‚à¤¸',0),(373420,10373,'ms','Lesen perniagaan',0),(373421,10373,'ar','Ø±Ø®ØµØ© ØªØ¬Ø§Ø±ÙŠØ©',0),(373422,10373,'fr','Licence professionnelle',0),(373423,10373,'jp','ãƒ“ã‚¸ãƒã‚¹ ãƒ©ã‚¤ã‚»ãƒ³ã‚¹',0),(373424,10373,'pt','LicenÃ§a comercial',0),(373425,10373,'ru','Ð‘Ð¸Ð·Ð½ÐµÑ Ð»Ð¸Ñ†ÐµÐ½Ð·Ð¸Ñ',0),(373426,10373,'es','Licencia de Funcionamiento',0),(373427,10373,'de','Business-Lizenz',0),(373428,10373,'en','Business License',0),(373429,10374,'is','',0),(373430,10374,'dr','Ú¯ÙˆØ§Ù‡ÙŠ Ø¨ÙŠÙ…Ù‡',0),(373431,10374,'pr','Ú¯ÙˆØ§Ù‡ÙŠ Ø¨ÙŠÙ…Ù‡',0),(373432,10374,'tr','Sigorta sertifikasÄ±',0),(373433,10374,'pl','ZaÅ›wiadczenie o ubezpieczeniu',0),(373434,10374,'bg','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð·Ð° Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²ÐºÐ°',0),(373435,10374,'ur','Ø§Ù†Ø´ÙˆØ±Ù†Ø³ Ú©Ø§ ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û',0),(373436,10374,'sr','Ð¦ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ°',0),(373437,10374,'vi','Chá»©ng nháº­n báº£o hiá»ƒm',0),(373438,10374,'af','Versekeringssertifikaat',0),(373439,10374,'ro','Certificat de asigurare',0),(373440,10374,'et','Liikluskindlustuse',0),(373441,10374,'si','Potrdilo o zavarovanju',0),(373442,10374,'ba','Sertifikat asuransi',0),(373443,10374,'nl','Certificaat van verzekering',0),(373444,10374,'fi','Todistuskirja vakuutuksesta',0),(373445,10374,'no','Sertifikat for forsikring',0),(373446,10374,'da','Certifikat om forsikring',0),(373447,10374,'ko','ë³´í—˜ ì¦ëª…ì„œ',0),(373448,10374,'he','×ª×¢×•×“×ª ×‘×™×˜×•×—',0),(373449,10374,'el','Î Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŒ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚',0),(373450,10374,'zh','ä¿è¯è¯ä¹¦\r\n',0),(373451,10374,'sv','FÃ¶rsÃ¤kringsbevis',0),(373452,10374,'it','Certificato di assicurazione',0),(373453,10374,'tl','',0),(373454,10374,'th','à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡à¸à¸²à¸£à¸›à¸£à¸°à¸à¸±à¸™à¸ à¸±à¸¢',0),(373455,10374,'hi','à¤¬à¥€à¤®à¤¾ à¤•à¤¾ à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤°',0),(373456,10374,'ms','Sijil Insurans',0),(373457,10374,'ar','Ø´Ù‡Ø§Ø¯Ø© Ø§Ù„ØªØ£Ù…ÙŠÙ†',0),(373458,10374,'fr','Certificat d\'assurance',0),(373459,10374,'jp','ä¿é™ºè¨¼',0),(373460,10374,'pt','Certificado de seguro',0),(373461,10374,'ru','Ð¡Ð²Ð¸Ð´ÐµÑ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð¾ ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ð¸',0),(373462,10374,'es','Certificado de Seguros',0),(373463,10374,'de','Versicherungsnachweis',0),(373464,10374,'en','Certificate of Insurance',0),(373465,10375,'is','',0),(373466,10375,'dr','Ù„Ø·ÙØ§ ÙƒØ§Ø±Ø¨Ø± Ùˆ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(373467,10375,'pr','Ù„Ø·ÙØ§ ÙƒØ§Ø±Ø¨Ø± Ùˆ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(373468,10375,'tr','LÃ¼tfen kullanÄ±cÄ± veya grup ekleyin',0),(373469,10375,'pl','ProszÄ™ podaÄ‡ uÅ¼ytkownicy lub grupy',0),(373470,10375,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸ Ð¸Ð»Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸',0),(373471,10375,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ØµØ§Ø±ÙÛŒÙ† ÛŒØ§ Ú¯Ø±ÙˆÙ¾Ø³ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(373472,10375,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐµ Ð¸Ð»Ð¸ Ð³Ñ€ÑƒÐ¿Ðµ',0),(373473,10375,'vi','vui lÃ²ng thÃªm ngÆ°á»i sá»­ dá»¥ng hoáº·c nhÃ³m',0),(373474,10375,'af','Sluit asseblief Gebruikers of Groepe in',0),(373475,10375,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i utilizatori sau grupuri',0),(373476,10375,'et','Palun lisa kasutajad vÃµi kasutajagrupid',0),(373477,10375,'si','Prosimo, da vkljuÄite uporabnike ali skupine',0),(373478,10375,'ba','Sertakan pengguna atau grup',0),(373479,10375,'nl','Voeg gebruikers of groepen',0),(373480,10375,'fi','LiitÃ¤ kÃ¤yttÃ¤jÃ¤t tai ryhmÃ¤t',0),(373481,10375,'no','Behage inkludere brukere eller grupper',0),(373482,10375,'da','VedlÃ¦g brugere eller grupper',0),(373483,10375,'ko','ì‚¬ìš©ìž ë˜ëŠ” ê·¸ë£¹ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(373484,10375,'he','×× × ×›×œ×•×œ ×ž×©×ª×ž×©×™× ××• ×§×‘×•×¦×•×ª',0),(373485,10375,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Î® Î¿Î¼Î¬Î´ÎµÏ‚',0),(373486,10375,'zh','è¯·åˆ—å…¥ç”¨æˆ·æˆ–ç»„\r\n',0),(373487,10375,'sv','VÃ¤nligen inkludera anvÃ¤ndare eller grupper',0),(373488,10375,'it','Si prega di includere gli utenti o gruppi',0),(373489,10375,'tl','',0),(373490,10375,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸«à¸£à¸·à¸­à¸à¸¥à¸¸à¹ˆà¸¡',0),(373491,10375,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤¯à¤¾ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¥‹ à¤¶à¤¾à¤®à¤¿à¤²',0),(373492,10375,'ms','Sila sertakan pengguna atau Kumpulan',0),(373493,10375,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø£Ùˆ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø§Øª',0),(373494,10375,'fr','Veuillez inclure les utilisateurs ou les groupes',0),(373495,10375,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã¾ãŸã¯ã‚°ãƒ«ãƒ¼ãƒ—ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(373496,10375,'pt','Por favor, incluir usuÃ¡rios ou grupos',0),(373497,10375,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ Ð¸Ð»Ð¸ Ð³Ñ€ÑƒÐ¿Ð¿',0),(373498,10375,'es','Por Favor Incluye Usuarios o Grupos',0),(373499,10375,'de','Bitte geben Sie Benutzer oder Gruppen',0),(373500,10375,'en','Please Include Users or Groups',0),(373501,10376,'is','',0),(373502,10376,'dr','Ù…ÙˆØ§ÙÙ‚Øª Ù†Ø§Ù…Ù‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰ ÙŠØ§ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ ',0),(373503,10376,'pr','Ù…ÙˆØ§ÙÙ‚Øª Ù†Ø§Ù…Ù‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ ÙØ±Ø¹Ù‰ ÙŠØ§ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ ',0),(373504,10376,'tr','TaÅŸeron SÃ¶zleÅŸmesi veya imzalÄ± bir sÃ¶zleÅŸme',0),(373505,10376,'pl','Umowy z podwykonawcÄ… lub podpisanej umowy',0),(373506,10376,'bg','ÐŸÐ¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ» ÑÐ¿Ð¾Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ½Ð¸Ðµ Ð¸Ð»Ð¸ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(373507,10376,'ur','Subcontractor Ù…Ø¹Ø§ÛØ¯Û’ ÛŒØ§ Ø¯Ø³ØªØ®Ø· Ø´Ø¯Û Ù…Ø¹Ø§ÛØ¯Û',0),(373508,10376,'sr','ÐŸÐ¾Ð´Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð° ÑÐ¿Ð¾Ñ€Ð°Ð·ÑƒÐ¼ Ð¸Ð»Ð¸ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ð½ ÑƒÐ³Ð¾Ð²Ð¾Ñ€',0),(373509,10376,'vi','hiá»‡p Ä‘á»‹nh nhÃ  tháº§u phá»¥ hoáº·c há»£p Ä‘á»“ng Ä‘Ã£ kÃ½',0),(373510,10376,'af','Subkontrakteur ooreenkoms of getekende kontrak',0),(373511,10376,'ro','Subcontractant acord sau Contract semnat',0),(373512,10376,'et','AlltÃ¶Ã¶vÃµtu lepingu vÃµi sÃµlmitud lepingu',0),(373513,10376,'si','Podizvajalca ali podpisane pogodbe',0),(373514,10376,'ba','Subkontraktor perjanjian atau kontrak',0),(373515,10376,'nl','Onderaannemer overeenkomst of ondertekend Contract',0),(373516,10376,'fi','Alihankkijan tai allekirjoitetussa sopimuksessa',0),(373517,10376,'no','UnderleverandÃ¸r avtalen eller signert kontrakt',0),(373518,10376,'da','UnderleverandÃ¸r aftale eller underskrevet kontrakt',0),(373519,10376,'ko','í•˜ì²­ ê³„ì•½ ë˜ëŠ” ê³„ì•½',0),(373520,10376,'he','×§×‘×œ×Ÿ ×ž×©× ×” ×”×¡×›× ××• ×—×•×–×” ×—×ª×•×',0),(373521,10376,'el','Î£Ï…Î¼Ï†Ï‰Î½Î¯Î± Ï…Ï€ÎµÏÎ³Î¿Î»Î¬Î²Î¿ Î® Ï…Ï€Î¿Î³ÎµÎ³ÏÎ±Î¼Î¼Î­Î½Î¿ ÏƒÏ…Î¼Î²ÏŒÎ»Î±Î¹Î¿',0),(373522,10376,'zh','åˆ†åŒ…å•†ç­¾è®¢çš„åˆåŒæˆ–åè®®\r\n',0),(373523,10376,'sv','UnderleverantÃ¶r avtal eller undertecknat avtal',0),(373524,10376,'it','Subappaltatore accordo o contratto firmato',0),(373525,10376,'tl','',0),(373526,10376,'th','à¸œà¸¹à¹‰à¸£à¸±à¸šà¹€à¸«à¸¡à¸²à¸¢à¹ˆà¸­à¸¢à¸‚à¹‰à¸­à¸•à¸à¸¥à¸‡à¸«à¸£à¸·à¸­à¸ªà¸±à¸à¸à¸²à¸¥à¸‡à¸™à¸²à¸¡',0),(373527,10376,'hi','à¤‰à¤ªà¤ à¥‡à¤•à¥‡à¤¦à¤¾à¤° à¤¸à¤®à¤à¥Œà¤¤à¥‡ à¤¯à¤¾ à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤¿à¤¤ à¤…à¤¨à¥à¤¬à¤‚à¤§',0),(373528,10376,'ms','Perjanjian subkontraktor atau kontrak yang ditandatangani',0),(373529,10376,'ar','Ø§Ù„Ø§ØªÙØ§Ù‚ Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù† Ø£Ùˆ Ø§Ù„Ø¹Ù‚ÙˆØ¯ Ø§Ù„Ù…ÙˆÙ‚Ø¹Ø©',0),(373530,10376,'fr','Sous-traitant accord ou contrat signÃ©',0),(373531,10376,'jp','ä¸‹è«‹å¥‘ç´„ã¾ãŸã¯ç½²åã•ã‚ŒãŸå¥‘ç´„',0),(373532,10376,'pt','Subcontratante acordo ou contrato assinado',0),(373533,10376,'ru','Ð¡ÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´Ñ‡Ð¸Ðº ÑÐ¾Ð³Ð»Ð°ÑˆÐµÐ½Ð¸Ðµ Ð¸Ð»Ð¸ ÐºÐ¾Ð½Ñ‚Ñ€Ð°ÐºÑ‚',0),(373534,10376,'es','Acuerdo de Subcontractor o Contrato Firmado',0),(373535,10376,'de','Subunternehmer-Vertrag oder Vertrag',0),(373536,10376,'en','Subcontractor Agreement or Signed Contract',0),(373537,10377,'is','',0),(373538,10377,'dr','Ø§Ø¹Ù„Ø§Ù… Ø´Ø±Ø§ÙŠØ·   ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(373539,10377,'pr','Ø§Ø¹Ù„Ø§Ù… Ø´Ø±Ø§ÙŠØ·   ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(373540,10377,'tr','SatÄ±cÄ± gereksinimi bildirimleri',0),(373541,10377,'pl','Dostawcy obowiÄ…zku powiadomienia',0),(373542,10377,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ñ',0),(373543,10377,'ur','ÙˆÛŒÙ†ÚˆØ± ØªÙ‚Ø§Ø¶ÙˆÚº Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(373544,10377,'sr','ÐžÐ±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ° Ð¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(373545,10377,'vi','ThÃ´ng bÃ¡o yÃªu cáº§u cá»§a nhÃ  cung cáº¥p',0),(373546,10377,'af','Handelaar vereiste kennisgewings',0),(373547,10377,'ro','NotificÄƒrile de cerinÅ£a de furnizor',0),(373548,10377,'et','Hankija nÃµue teated',0),(373549,10377,'si','Obvestila dobavitelja zahteva',0),(373550,10377,'ba','Vendor persyaratan pemberitahuan',0),(373551,10377,'nl','Leverancier vereiste kennisgevingen',0),(373552,10377,'fi','Toimittajan vaatimus ilmoitukset',0),(373553,10377,'no','LeverandÃ¸ren kravet varsler',0),(373554,10377,'da','Kreditors krav anmeldelser',0),(373555,10377,'ko','ê³µê¸‰ ì—…ì²´ ìš”êµ¬ ì‚¬í•­ ì•Œë¦¼',0),(373556,10377,'he','×”×•×“×¢×•×ª ×“×¨×™×©×” ×”×¡×¤×§',0),(373557,10377,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Ï€Î±Î¯Ï„Î·ÏƒÎ· ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚',0),(373558,10377,'zh','ä¾›åº”å•†è¦æ±‚é€šçŸ¥\r\n',0),(373559,10377,'sv','Kravet leverantÃ¶rsmeddelanden',0),(373560,10377,'it','Fornitore requisito notifiche',0),(373561,10377,'tl','',0),(373562,10377,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸•à¹‰à¸­à¸‡à¹à¸ˆà¹‰à¸‡à¹ƒà¸«à¹‰à¸—à¸£à¸²à¸š',0),(373563,10377,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤',0),(373564,10377,'ms','Pembekal keperluan pemberitahuan',0),(373565,10377,'ar','Ø¨Ø§Ø¦Ø¹ Ø´Ø±Ø· Ø§Ù„Ø¥Ø®Ø·Ø§Ø±Ø§Øª',0),(373566,10377,'fr','Notifications d\'obligation du vendeur',0),(373567,10377,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶ã®é€šçŸ¥',0),(373568,10377,'pt','NotificaÃ§Ãµes de exigÃªncia do fornecedor',0),(373569,10377,'ru','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ Ð¾ Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸ÑÑ… ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(373570,10377,'es','Notificaciones de Requerimientos de Proveedor',0),(373571,10377,'de','Hersteller-Anforderung-Benachrichtigungen',0),(373572,10377,'en','Vendor Requirement Notifications',0),(373573,10378,'is','',0),(373574,10378,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¹Ù„Ø§Ù… Ø´Ø±Ø§ÙŠØ·   ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(373575,10378,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¹Ù„Ø§Ù… Ø´Ø±Ø§ÙŠØ·   ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(373576,10378,'tr','SatÄ±cÄ± gereksinimi bildirimleri eklenen hatasÄ±',0),(373577,10378,'pl','Dostawcy wymÃ³g powiadomienia o awarii dodane',0),(373578,10378,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð° Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(373579,10378,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¶Ø±ÙˆØ±Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ù†Ø§Ú©Ø§Ù…ÛŒ',0),(373580,10378,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÑƒÑÐ»Ð¾Ð² Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ° Ð´Ð¾Ð´Ð°Ñ‚Ð¸Ñ… Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(373581,10378,'vi','ThÃªm thÃ´ng bÃ¡o yÃªu cáº§u cá»§a nhÃ  cung cáº¥p Ä‘Ã£ tháº¥t báº¡i',0),(373582,10378,'af','Handelaar vereiste kennisgewings bygevoeg versuim',0),(373583,10378,'ro','Furnizor cerinÅ£Äƒ notificÄƒri adÄƒugat eÅŸec',0),(373584,10378,'et','Hankija nÃµue teated lisatud rike',0),(373585,10378,'si','Dobavitelja zahteva obvestila dodano neuspeh',0),(373586,10378,'ba','Vendor persyaratan pemberitahuan ditambahkan kegagalan',0),(373587,10378,'nl','Leverancier vereiste kennisgevingen toegevoegde mislukking',0),(373588,10378,'fi','Toimittajan vaatimus ilmoitukset lisÃ¤tty epÃ¤onnistuminen',0),(373589,10378,'no','LeverandÃ¸ren kravet varsler lagt feil',0),(373590,10378,'da','Kreditors krav meddelelser tilfÃ¸jet fiasko',0),(373591,10378,'ko','ê³µê¸‰ ì—…ì²´ ìš”êµ¬ ì‚¬í•­ ì•Œë¦¼ ì¶”ê°€ ì‹¤íŒ¨',0),(373592,10378,'he','×¡×¤×§ ×“×¨×™×©×” ×”×•×“×¢×•×ª ×›×©×œ × ×•×¡×£',0),(373593,10378,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Ï€Î±Î¯Ï„Î·ÏƒÎ· ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(373594,10378,'zh','ä¾›åº”å•†è¦æ±‚é€šçŸ¥æ–°å¢žå¤±è´¥\r\n',0),(373595,10378,'sv','LeverantÃ¶r krav anmÃ¤lningar lÃ¤ggas underlÃ¥tenhet',0),(373596,10378,'it','Fornitore requisito notifiche fallimento aggiunto',0),(373597,10378,'tl','',0),(373598,10378,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸•à¹‰à¸­à¸‡à¹à¸ˆà¹‰à¸‡à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(373599,10378,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤µà¤¿à¤«à¤²à¤¤à¤¾',0),(373600,10378,'ms','Pembekal keperluan pemberitahuan ditambah kegagalan',0),(373601,10378,'ar','ÙØ´Ù„ Ø¥Ø¶Ø§ÙØ© Ø¥Ø¹Ù„Ø§Ù…Ø§Øª Ø´Ø±Ø· Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(373602,10378,'fr','Fournisseur exigence Notifications Ã©chec supplÃ©mentaire',0),(373603,10378,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶é€šçŸ¥ã®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(373604,10378,'pt','Fornecedor exigÃªncia notificaÃ§Ãµes adicionado falha',0),(373605,10378,'ru','ÐÐµ Ð£Ð´Ð°Ð»Ð¾ÑÑŒ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ Ð¾ Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸ÑÑ… ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(373606,10378,'es','Notificaciones de Requerimientos de Proveedor Agregar FallÃ³',0),(373607,10378,'de','Hersteller Anforderung Benachrichtigungen hinzugefÃ¼gt Scheitern',0),(373608,10378,'en','Vendor Requirement Notifications Added Failure',0),(373609,10379,'is','',0),(373610,10379,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¹Ù„Ø§Ù… Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(373611,10379,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø¹Ù„Ø§Ù… Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(373612,10379,'tr','SatÄ±cÄ± gereksinimi bildirimleri baÅŸarÄ±yla eklendi',0),(373613,10379,'pl','Dostawcy wymogu powiadomienia dodano pomyÅ›lnie',0),(373614,10379,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(373615,10379,'ur','ÙˆÛŒÙ†ÚˆØ± ØªÙ‚Ø§Ø¶ÙˆÚº Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(373616,10379,'sr','ÐžÐ±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ° Ð¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(373617,10379,'vi','ThÃªm thÃ´ng bÃ¡o yÃªu cáº§u cá»§a nhÃ  cung cáº¥p Ä‘Ã£ thÃ nh cÃ´ng',0),(373618,10379,'af','Verskaffer Voorskrif Kennisgewings Suksesvol Bygevoeg',0),(373619,10379,'ro','Furnizor cerinÅ£Äƒ notificÄƒri adÄƒugat cu succes',0),(373620,10379,'et','Hankija nÃµue teated lisatud',0),(373621,10379,'si','Dobavitelja zahteva obvestila uspeÅ¡no dodani',0),(373622,10379,'ba','Vendor persyaratan pemberitahuan ditambahkan berhasil',0),(373623,10379,'nl','Leverancier vereiste meldingen met succes toegevoegd',0),(373624,10379,'fi','Toimittajan vaatimus ilmoitukset lisÃ¤Ã¤minen onnistui',0),(373625,10379,'no','LeverandÃ¸ren kravet varsler lagt',0),(373626,10379,'da','Kreditors krav anmeldelser tilfÃ¸jet',0),(373627,10379,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ê³µê¸‰ ì—…ì²´ ìš”êµ¬ ì‚¬í•­ ì•Œë¦¼',0),(373628,10379,'he','×”×•×“×¢×•×ª ×”×“×¨×™×©×” ×¡×¤×§ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(373629,10379,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Ï€Î±Î¯Ï„Î·ÏƒÎ· ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(373630,10379,'zh','ä¾›åº”å•†è¦æ±‚é€šçŸ¥æ·»åŠ æˆåŠŸ\r\n',0),(373631,10379,'sv','Kravet leverantÃ¶rsmeddelanden lagts',0),(373632,10379,'it','Notifiche di requisito fornitore aggiunte con successo',0),(373633,10379,'tl','',0),(373634,10379,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸•à¹‰à¸­à¸‡à¹à¸ˆà¹‰à¸‡à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(373635,10379,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(373636,10379,'ms','Notifikasi keperluan penjual yang berjaya menambah',0),(373637,10379,'ar','Ø¥Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ø´ØªØ±Ø§Ø· Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(373638,10379,'fr','Notifications d\'obligation du vendeur ajoutÃ©es avec succÃ¨s',0),(373639,10379,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶ã®é€šçŸ¥ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(373640,10379,'pt','NotificaÃ§Ãµes de exigÃªncia do fornecedor adicionadas com sucesso',0),(373641,10379,'ru','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ Ð¾ Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸ÑÑ… ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(373642,10379,'es','Notificaciones de Requerimientos de Proveedor Agregados Exitosamente',0),(373643,10379,'de','Hersteller Anforderung Benachrichtigungen erfolgreich hinzugefÃ¼gt',0),(373644,10379,'en','Vendor Requirement Notifications Added Successfully',0),(373645,10380,'is','',0),(373646,10380,'dr','W9',0),(373647,10380,'pr','W9',0),(373648,10380,'tr','W9',0),(373649,10380,'pl','W9',0),(373650,10380,'bg','W9',0),(373651,10380,'ur','W9',0),(373652,10380,'sr','W9',0),(373653,10380,'vi','W9',0),(373654,10380,'af','W9',0),(373655,10380,'ro','W9',0),(373656,10380,'et','W9',0),(373657,10380,'si','W9',0),(373658,10380,'ba','W9',0),(373659,10380,'nl','W9',0),(373660,10380,'fi','W9',0),(373661,10380,'no','W9',0),(373662,10380,'da','W9',0),(373663,10380,'ko','W9',0),(373664,10380,'he','W9',0),(373665,10380,'el','W9',0),(373666,10380,'zh','W9\r\n',0),(373667,10380,'sv','W9',0),(373668,10380,'it','W9',0),(373669,10380,'tl','',0),(373670,10380,'th','W9',0),(373671,10380,'hi','W9',0),(373672,10380,'ms','W9',0),(373673,10380,'ar','W9',0),(373674,10380,'fr','W9',0),(373675,10380,'jp','W9',0),(373676,10380,'pt','W9',0),(373677,10380,'ru','W9',0),(373678,10380,'es','W9',0),(373679,10380,'de','W9',0),(373680,10380,'en','W9',0),(373681,10381,'is','',0),(373682,10381,'dr','(Ø­Ù‚ ØªØµØ±Ù ÙˆØ«ÙŠÙ‚Ù‡',0),(373683,10381,'pr','ÙØ³Ø® Ø­Ù‚â€Œ Ú¯Ø±ÙˆÙŠâ€Œ(Ø­Ù‚ ØªØµØ±Ù ÙˆØ«ÙŠÙ‚Ù‡',0),(373684,10381,'tr','Liens feragat',0),(373685,10381,'pl','Zrzeczenia siÄ™ zastawu',0),(373686,10381,'bg','ÐžÑ‚ÐºÐ°Ð· Ð¾Ñ‚ Ð·Ð°Ð¿Ð°Ð·ÐµÐ½Ð¸ Ð¿Ñ€Ð°Ð²Ð°',0),(373687,10381,'ur','Ù„ÛŒÙ†Ø³ Ú©Ø§ Ú†Ú¾ÙˆÙ¹',0),(373688,10381,'sr','ÐžÐ´ÑƒÑÑ‚Ð°Ñ˜Ð°ÑšÐµ Ð¾Ð´ Ñ…Ð¸Ð¿Ð¾Ñ‚ÐµÐºÐµ Ð·Ð°',0),(373689,10381,'vi','Miá»…n cá»§a cÃ¡c khoáº£n tháº¿ cháº¥p',0),(373690,10381,'af','Kwytskelding van Retensieregte',0),(373691,10381,'ro','Renuntare la drept de retenÅ£ie',0),(373692,10381,'et','Puutumatuse kinnipidamisÃµigus',0),(373693,10381,'si','Opustitev zastavnih pravic',0),(373694,10381,'ba','Pengabaian hak gadai',0),(373695,10381,'nl','Opheffing van Verwijzigingen',0),(373696,10381,'fi','Luopuminen pantit',0),(373697,10381,'no','Fraskrivelse av Liens',0),(373698,10381,'da','OphÃ¦velse af panterettigheder',0),(373699,10381,'ko','Liensì˜ í¬ê¸°',0),(373700,10381,'he','×•×™×ª×•×¨ ×¢×œ ×©×™×¢×‘×•×“×™×',0),(373701,10381,'el','Î Î±ÏÎ±Î¯Ï„Î·ÏƒÎ· Î±Ï€ÏŒ Liens',0),(373702,10381,'zh','è±å…ç•™ç½®æƒ\r\n',0),(373703,10381,'sv','UpphÃ¤vande av Liens',0),(373704,10381,'it','Rinuncia di Liens',0),(373705,10381,'tl','',0),(373706,10381,'th','à¸ªà¸¥à¸° Liens',0),(373707,10381,'hi','à¤—à¥à¤°à¤¹à¤£à¤¾à¤§à¤¿à¤•à¤¾à¤° à¤•à¤¾ à¤›à¥‚à¤Ÿ à¤•à¥‡',0),(373708,10381,'ms','Pengecualian lien',0),(373709,10381,'ar','Ø§Ù„ØªÙ†Ø§Ø²Ù„ Ø¹Ù† Ø§Ù„Ø§Ù…ØªÙŠØ§Ø²Ø§Øª',0),(373710,10381,'fr','Renonciation au privilÃ¨ge',0),(373711,10381,'jp','ç•™ç½®æ¨©ã®æ”¾æ£„',0),(373712,10381,'pt','IsenÃ§Ã£o de gravames',0),(373713,10381,'ru','ÐžÑ‚ÐºÐ°Ð· Ð¾Ñ‚ Ð·Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(373714,10381,'es','Renuncia de Embargos',0),(373715,10381,'de','Verzicht auf Links',0),(373716,10381,'en','Waiver of Liens',0),(373717,10382,'is','',0),(373718,10382,'dr','Ú¯ÙˆØ§Ù‡ÙŠ Ø¨ÙŠÙ…Ù‡ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(373719,10382,'pr','Ú¯ÙˆØ§Ù‡ÙŠ Ø¨ÙŠÙ…Ù‡ ÙƒØ§Ø±Ú¯Ø±Ø§Ù† Ø´Ø±ÙƒØª',0),(373720,10382,'tr','Workmans zorunlu sigorta sertifikasÄ±',0),(373721,10382,'pl','Workmans komp Å›wiadectwo ubezpieczenia',0),(373722,10382,'bg','Workmans Comp Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ½ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(373723,10382,'ur','ÙˆÙˆØ±Ú©Ù…Ø¢Ù†Ø³ Ú©Ø¹Ù…Ù¾ Ø§Ù†Ø´ÙˆØ±Ù†Ø³ ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û',0),(373724,10382,'sr','WÐ¾Ñ€ÐºÐ¼Ð°Ð½Ñ Ð¦Ð¾Ð¼Ð¿ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ° Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(373725,10382,'vi','Giáº¥y chá»©ng nháº­n báº£o hiá»ƒm workman',0),(373726,10382,'af','Vergoedingskommisaris Sertifikaat',0),(373727,10382,'ro','Certificat de asigurare Workmans Comp',0),(373728,10382,'et','*Workmans Comp Insurance Certificate',0),(373729,10382,'si','Workmans Comp potrdilo o zavarovanju',0),(373730,10382,'ba','Sertifikat asuransi Comp Workmans',0),(373731,10382,'nl','Workmans Comp verzekeringscertificaat',0),(373732,10382,'fi','Workmans Comp vakuutustodistus',0),(373733,10382,'no','Workmans Comp sertifikat',0),(373734,10382,'da','Workmans Comp forsikringsbevis',0),(373735,10382,'ko','Workmans Comp ë³´í—˜ ì¦ëª…ì„œ',0),(373736,10382,'he','Workmans Comp ×ª×¢×•×“×ª ×‘×™×˜×•×—',0),(373737,10382,'el','Î Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŒ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚ Comp Workmans',0),(373738,10382,'zh','å·¥äººèµ”å¿ä¿é™©è¯ä¹¦\r\n',0),(373739,10382,'sv','Workmans Comp fÃ¶rsÃ¤kringsbevis',0),(373740,10382,'it','Certificato d\'assicurazione Comp workmans',0),(373741,10382,'tl','',0),(373742,10382,'th','à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡à¸›à¸£à¸°à¸à¸±à¸™à¸„à¸­à¸¡ Workmans',0),(373743,10382,'hi','Workmans à¤•à¤‚à¤ª à¤¬à¥€à¤®à¤¾ à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤°',0),(373744,10382,'ms','Sijil Insurans Comp Workmans',0),(373745,10382,'ar','ÙˆÙˆØ±ÙƒÙ…Ø§Ù†Ø³ Ø´Ø±ÙƒØ§Øª Ø§Ù„ØªØ£Ù…ÙŠÙ† Ø´Ù‡Ø§Ø¯Ø©',0),(373746,10382,'fr','Certificat d\'assurance d\'accidentÃ©s Comp',0),(373747,10382,'jp','æµå¤± Comp ä¿é™ºè¨¼',0),(373748,10382,'pt','Certificado de seguro direitoa Comp',0),(373749,10382,'ru','Workmans Comp ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð¾Ð¹ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(373750,10382,'es','Certificado de Seguro de CompensaciÃ³n a los Trabajadores',0),(373751,10382,'de','Workmans Comp Versicherungsnachweis',0),(373752,10382,'en','Workmans Comp Insurance Certificate',0),(373753,10383,'is','',0),(373754,10383,'dr','Ù…Ù†Ù‚Ø¶ÙŠ Ø´Ø¯Ù‡ ',0),(373755,10383,'pr','Ù…Ù†Ù‚Ø¶ÙŠ Ø´Ø¯Ù‡ ',0),(373756,10383,'tr','SÃ¼resi dolmuÅŸ',0),(373757,10383,'pl','MinÄ…Å‚',0),(373758,10383,'bg','Ð¡ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ» ÑÑ€Ð¾Ðº',0),(373759,10383,'ur','Ù…Ø¯Øª Ø®ØªÙ… ÛÙˆ Ú¯Ø¦ÛŒ',0),(373760,10383,'sr','Ð˜ÑÑ‚ÐµÐºÐ»Ð°',0),(373761,10383,'vi','ÄÃ£ káº¿t thÃºc',0),(373762,10383,'af','Verval',0),(373763,10383,'ro','Expirat',0),(373764,10383,'et','LÃµppkuupÃ¤ev',0),(373765,10383,'si','Potekel',0),(373766,10383,'ba','Kadaluarsa',0),(373767,10383,'nl','Verlopen',0),(373768,10383,'fi','Vanhentunut',0),(373769,10383,'no','UtlÃ¸pt',0),(373770,10383,'da','UdlÃ¸bet',0),(373771,10383,'ko','ë§Œë£Œ',0),(373772,10383,'he','×¤×’',0),(373773,10383,'el','Î›Î®Î¾ÎµÎ¹',0),(373774,10383,'zh','è¿‡æœŸ\r\n',0),(373775,10383,'sv','LÃ¶pt ut',0),(373776,10383,'it','Scaduto',0),(373777,10383,'tl','',0),(373778,10383,'th','à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(373779,10383,'hi','à¤•à¥€ à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤',0),(373780,10383,'ms','Tamat tempoh',0),(373781,10383,'ar','Ø§Ù†ØªÙ‡Øª Ù…Ø¯Ø© ØµÙ„Ø§Ø­ÙŠØ©',0),(373782,10383,'fr','ExpirÃ©',0),(373783,10383,'jp','æœ‰åŠ¹æœŸé™ãŒåˆ‡ã‚Œã¦ãã ã•ã„ã€‚',0),(373784,10383,'pt','Expirado',0),(373785,10383,'ru','Ð¡Ñ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð¸ÑÑ‚ÐµÐº',0),(373786,10383,'es','Vencido',0),(373787,10383,'de','Abgelaufen',0),(373788,10383,'en','Expired',0),(373789,10384,'is','',0),(373790,10384,'dr','Ù…Ù†Ù‚Ø¶ÙŠ Ø´Ø¯Ù† ',0),(373791,10384,'pr','Ù…Ù†Ù‚Ø¶ÙŠ Ø´Ø¯Ù† ',0),(373792,10384,'tr','Sona eriyor',0),(373793,10384,'pl','Wygasa',0),(373794,10384,'bg','Ð˜Ð·Ñ‚Ð¸Ñ‡Ð°',0),(373795,10384,'ur','Ø²Ø§ÛŒØ¯ Ù…ÛŒØ¹Ø§Ø¯ Ø§Ø²',0),(373796,10384,'sr','Ð˜ÑÑ‚Ð¸Ñ‡Ðµ',0),(373797,10384,'vi','Káº¿t thÃºc',0),(373798,10384,'af','Verval',0),(373799,10384,'ro','ExpirÄƒ',0),(373800,10384,'et','Aegub',0),(373801,10384,'si','PoteÄe',0),(373802,10384,'ba','Berakhir',0),(373803,10384,'nl','Verloopt',0),(373804,10384,'fi','PÃ¤Ã¤ttyy',0),(373805,10384,'no','UtlÃ¸per',0),(373806,10384,'da','UdlÃ¸ber',0),(373807,10384,'ko','ë§Œë£Œ',0),(373808,10384,'he','×¤×’ ×ª×•×§×£',0),(373809,10384,'el','Î›Î®Î³ÎµÎ¹',0),(373810,10384,'zh','è¿‡æœŸ\r\n',0),(373811,10384,'sv','UpphÃ¶r att gÃ¤lla',0),(373812,10384,'it','Scade',0),(373813,10384,'tl','',0),(373814,10384,'th','à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(373815,10384,'hi','à¤¸à¤®à¤¯à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¤à¥€ à¤¹à¥ˆ',0),(373816,10384,'ms','Tamat tempoh',0),(373817,10384,'ar','ÙˆØªÙ†ØªÙ‡ÙŠ',0),(373818,10384,'fr','Expire',0),(373819,10384,'jp','æœ‰åŠ¹æœŸé™ãŒåˆ‡ã‚Œã‚‹',0),(373820,10384,'pt','Expira',0),(373821,10384,'ru','Ð¡Ñ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(373822,10384,'es','Se Vence',0),(373823,10384,'de','GÃ¼ltig bis',0),(373824,10384,'en','Expires',0),(373825,10385,'is','',0),(373826,10385,'dr','Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡ ',0),(373827,10385,'pr','Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡ ',0),(373828,10385,'tr','GÃ¶z ardÄ±',0),(373829,10385,'pl','Ignorowane',0),(373830,10385,'bg','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð°Ð½Ð¸',0),(373831,10385,'ur','Ù†Ø¸Ø± Ø§Ù†Ø¯Ø§Ø² Ú©Ø± Ø¯ÛŒØ§',0),(373832,10385,'sr','Ð—Ð°Ð½ÐµÐ¼Ð°Ñ€ÐµÐ½Ð¸',0),(373833,10385,'vi','Bá» qua',0),(373834,10385,'af','GeÃ¯gnoreer',0),(373835,10385,'ro','Ignorate',0),(373836,10385,'et','Ignoreeritakse',0),(373837,10385,'si','Prezrta',0),(373838,10385,'ba','Diabaikan',0),(373839,10385,'nl','Genegeerd',0),(373840,10385,'fi','Huomiotta',0),(373841,10385,'no','Ignorert',0),(373842,10385,'da','Ignoreret',0),(373843,10385,'ko','ë¬´ì‹œ',0),(373844,10385,'he','×”×ž×¢×¨×›×ª ×ª×ª×¢×œ×',0),(373845,10385,'el','Î‘Î³Î½Î¿Î¿ÏÎ½Ï„Î±Î¹',0),(373846,10385,'zh','å¿½ç•¥\r\n',0),(373847,10385,'sv','Ignoreras',0),(373848,10385,'it','Ignorato',0),(373849,10385,'tl','',0),(373850,10385,'th','à¸¥à¸°à¹€à¸§à¹‰à¸™',0),(373851,10385,'hi','à¤¨à¤œà¤°à¤…à¤‚à¤¦à¤¾à¤œ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(373852,10385,'ms','Diabaikan',0),(373853,10385,'ar','ØªØ¬Ø§Ù‡Ù„',0),(373854,10385,'fr','IgnorÃ©',0),(373855,10385,'jp','ç„¡è¦–',0),(373856,10385,'pt','Ignorado',0),(373857,10385,'ru','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€ÑƒÐµÑ‚ÑÑ',0),(373858,10385,'es','Ignorado',0),(373859,10385,'de','Ignoriert',0),(373860,10385,'en','Ignored',0),(373861,10386,'is','',0),(373862,10386,'dr','Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡',0),(373863,10386,'pr','Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡',0),(373864,10386,'tr','Eksik',0),(373865,10386,'pl','Brakuje',0),(373866,10386,'bg','Ð›Ð¸Ð¿ÑÐ²Ð°',0),(373867,10386,'ur','ØºØ§Ø¦Ø¨',0),(373868,10386,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ',0),(373869,10386,'vi','Máº¥t tÃ­ch',0),(373870,10386,'af','Ontbreek',0),(373871,10386,'ro','LipsÄƒ',0),(373872,10386,'et','Kadunud',0),(373873,10386,'si','Manjka',0),(373874,10386,'ba','Hilang',0),(373875,10386,'nl','Ontbrekende',0),(373876,10386,'fi','Puuttuu',0),(373877,10386,'no','Mangler',0),(373878,10386,'da','Mangler',0),(373879,10386,'ko','ëˆ„ë½',0),(373880,10386,'he','×—×¡×¨×™×',0),(373881,10386,'el','Î›ÎµÎ¯Ï€ÎµÎ¹',0),(373882,10386,'zh','å¤±è¸ª\r\n',0),(373883,10386,'sv','Saknas',0),(373884,10386,'it','Manca',0),(373885,10386,'tl','',0),(373886,10386,'th','à¸‚à¸²à¸”à¸«à¸²à¸¢à¹„à¸›',0),(373887,10386,'hi','à¤²à¤¾à¤ªà¤¤à¤¾',0),(373888,10386,'ms','Hilang',0),(373889,10386,'ar','Ù…ÙÙ‚ÙˆØ¯',0),(373890,10386,'fr','Manquant',0),(373891,10386,'jp','ä¸è¶³ã—ã¦ã„ã¾ã™ã€‚',0),(373892,10386,'pt','Faltando',0),(373893,10386,'ru','ÐŸÑ€Ð¾Ð¿Ð°Ð²ÑˆÐ¸Ñ… Ð±ÐµÐ· Ð²ÐµÑÑ‚Ð¸',0),(373894,10386,'es','Extraviado',0),(373895,10386,'de','Fehlende',0),(373896,10386,'en','Missing',0),(373897,10387,'is','',0),(373898,10387,'dr','Ù‚Ø¨Ù„ Ø§Ø² Ø­Ø§Ø¯Ø«Ù‡',0),(373899,10387,'pr','Ù‚Ø¨Ù„ Ø§Ø² Ø­Ø§Ø¯Ø«Ù‡',0),(373900,10387,'tr','Olaydan Ã¶nce',0),(373901,10387,'pl','Przed zdarzeniem',0),(373902,10387,'bg','ÐŸÑ€ÐµÐ´Ð¸ ÑÑŠÐ±Ð¸Ñ‚Ð¸ÐµÑ‚Ð¾',0),(373903,10387,'ur','ØªÙ‚Ø±ÛŒØ¨ Ø³Û’ Ù¾ÛÙ„Û’',0),(373904,10387,'sr','ÐŸÑ€Ðµ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð°',0),(373905,10387,'vi','TrÆ°á»›c sá»± kiá»‡n',0),(373906,10387,'af','Voor die gebeurtenis',0),(373907,10387,'ro','ÃŽnainte de eveniment',0),(373908,10387,'et','Enne Ã¼rituse',0),(373909,10387,'si','Pred dogodkom',0),(373910,10387,'ba','Sebelum acara',0),(373911,10387,'nl','Gebeurtenis Before',0),(373912,10387,'fi','Ennen tapahtumaa',0),(373913,10387,'no','FÃ¸r hendelsen',0),(373914,10387,'da','FÃ¸r arrangementet',0),(373915,10387,'ko','ì´ë²¤íŠ¸ í•˜ê¸° ì „ì—',0),(373916,10387,'he','×œ×¤× ×™ ××¨×•×¢',0),(373917,10387,'el','Î ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎµÎºÎ´Î®Î»Ï‰ÏƒÎ·',0),(373918,10387,'zh','äº‹ä»¶å‰\r\n',0),(373919,10387,'sv','FÃ¶re hÃ¤ndelsen',0),(373920,10387,'it','Prima evento',0),(373921,10387,'tl','',0),(373922,10387,'th','à¸à¹ˆà¸­à¸™à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸“à¹Œ',0),(373923,10387,'hi','à¤˜à¤Ÿà¤¨à¤¾ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡',0),(373924,10387,'ms','Sebelum acara',0),(373925,10387,'ar','Ù‚Ø¨Ù„ Ø§Ù„Ø­Ø¯Ø«',0),(373926,10387,'fr','Avant l\'Ã©vÃ©nement',0),(373927,10387,'jp','ã‚¤ãƒ™ãƒ³ãƒˆã®å‰ã«',0),(373928,10387,'pt','Antes do evento',0),(373929,10387,'ru','Ð”Ð¾ ÑÐ¾Ð±Ñ‹Ñ‚Ð¸Ñ',0),(373930,10387,'es','Antes del Evento',0),(373931,10387,'de','Vor Veranstaltung',0),(373932,10387,'en','Before Event',0),(373933,10388,'is','',0),(373934,10388,'dr','Ø³Ø§Ø¹Øª',0),(373935,10388,'pr','Ø³Ø§Ø¹Øª',0),(373936,10388,'tr','Saat',0),(373937,10388,'pl','Godziny',0),(373938,10388,'bg','Ð§Ð°Ñ',0),(373939,10388,'ur','Ú¯Ú¾Ù†Ù¹Û',0),(373940,10388,'sr','Ð¡Ð°Ñ‚ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(373941,10388,'vi','Giá»',0),(373942,10388,'af','Uur',0),(373943,10388,'ro','OrÄƒ',0),(373944,10388,'et','Tund',0),(373945,10388,'si','Uro',0),(373946,10388,'ba','Jam',0),(373947,10388,'nl','Uur',0),(373948,10388,'fi','Fi',0),(373949,10388,'no','Time',0),(373950,10388,'da','Time',0),(373951,10388,'ko','ì‹œê°„',0),(373952,10388,'he','×©×¢×”',0),(373953,10388,'el','ÎÏÎ±',0),(373954,10388,'zh','å°æ—¶\r\n',0),(373955,10388,'sv','Timme',0),(373956,10388,'it','Ora',0),(373957,10388,'tl','',0),(373958,10388,'th','à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡',0),(373959,10388,'hi','à¤˜à¤‚à¤Ÿà¤¾',0),(373960,10388,'ms','Jam',0),(373961,10388,'ar','Ù…Ø¯Ø§Ø±',0),(373962,10388,'fr','Heure',0),(373963,10388,'jp','æ™‚é–“',0),(373964,10388,'pt','Hora',0),(373965,10388,'ru','Ð¡Ñ‚Ð¾Ð¹ÐºÐ°',0),(373966,10388,'es','Hora',0),(373967,10388,'de','Stunde',0),(373968,10388,'en','Hour',0),(373969,10389,'is','',0),(373970,10389,'dr','Ø¯Ø± Ù†Ø¸Ø± Ù†Ú¯Ø±ÙØªÙ†  Ø§Ù†Ù‚Ø¶Ø§Ø¡',0),(373971,10389,'pr','Ø¯Ø± Ù†Ø¸Ø± Ù†Ú¯Ø±ÙØªÙ†  Ø§Ù†Ù‚Ø¶Ø§Ø¡',0),(373972,10389,'tr','Sona erme yoksay',0),(373973,10389,'pl','Ignoruj wygaÅ›niÄ™cia',0),(373974,10389,'bg','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð°Ð¹ Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ',0),(373975,10389,'ur','Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©Ùˆ Ù†Ø¸Ø± Ø§Ù†Ø¯Ø§Ø² Ú©Ø±ÛŒÚº',0),(373976,10389,'sr','Ð—Ð°Ð½ÐµÐ¼Ð°Ñ€Ð¸ Ñ€Ð¾Ðº Ð²Ð°Ð¶ÐµÑšÐ°',0),(373977,10389,'vi','bá» qua sá»± káº¿t thÃºc',0),(373978,10389,'af','Ignoreer verstryking',0),(373979,10389,'ro','Ignora expirare',0),(373980,10389,'et','Ignoreeri aegumine',0),(373981,10389,'si','Prezreti zapadlost',0),(373982,10389,'ba','Mengabaikan kadaluarsa',0),(373983,10389,'nl','Vervaldatum negeren',0),(373984,10389,'fi','Ohita pÃ¤Ã¤ttyminen',0),(373985,10389,'no','Ignorere utlÃ¸p',0),(373986,10389,'da','Ignorere udlÃ¸b',0),(373987,10389,'ko','ë§Œë£Œë¥¼ ë¬´ì‹œ',0),(373988,10389,'he','×”×ª×¢×œ× ×ª×¤×•×’×”',0),(373989,10389,'el','Î‘Î³Î½Î¿Î¿ÏÎ½ Ï„Î· Î»Î®Î¾Î·',0),(373990,10389,'zh','å¿½ç•¥è¿‡æœŸ\r\n',0),(373991,10389,'sv','Ignorera fÃ¶rfallodatum',0),(373992,10389,'it','Ignorare la scadenza',0),(373993,10389,'tl','',0),(373994,10389,'th','à¸¥à¸°à¹€à¸§à¹‰à¸™à¸à¸²à¸£à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(373995,10389,'hi','à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤ªà¤° à¤§à¥à¤¯à¤¾à¤¨ à¤¨ à¤¦à¥‡à¤‚',0),(373996,10389,'ms','Abaikan tamat',0),(373997,10389,'ar','ØªØ¬Ø§Ù‡Ù„ Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØµÙ„Ø§Ø­ÙŠØ©',0),(373998,10389,'fr','Ignorer l\'Expiration',0),(373999,10389,'jp','æœ‰åŠ¹æœŸé™ã‚’ç„¡è¦–ã—ã¾ã™ã€‚',0),(374000,10389,'pt','Ignorar a expiraÃ§Ã£o',0),(374001,10389,'ru','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(374002,10389,'es','Ignora el Vencimiento',0),(374003,10389,'de','Ablauf zu ignorieren',0),(374004,10389,'en','Ignore Expiration',0),(374005,10390,'is','',0),(374006,10390,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(374007,10390,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(374008,10390,'tr','LÃ¼tfen baÅŸlangÄ±Ã§ tarihi ekle',0),(374009,10390,'pl','ProszÄ™ podaÄ‡ datÄ™ rozpoczÄ™cia',0),(374010,10390,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(374011,10390,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(374012,10390,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(374013,10390,'vi','vui lÃ²ng bao gá»“m ngÃ y báº¯t Ä‘áº§u',0),(374014,10390,'af','Sluit asseblief Begin Datum in',0),(374015,10390,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i data de Ã®nceput',0),(374016,10390,'et','Palun lisa alustamise kuupÃ¤ev',0),(374017,10390,'si','Prosimo, da vkljuÄite zaÄetni datum',0),(374018,10390,'ba','Harap sertakan tanggal mulai',0),(374019,10390,'nl','Gelieve te omvatten begindatum',0),(374020,10390,'fi','Kirjoita AloituspÃ¤ivÃ¤',0),(374021,10390,'no','Ta med start dato',0),(374022,10390,'da','Bedes du medtage Begin dato',0),(374023,10390,'ko','ì‹œìž‘ ë‚ ì§œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(374024,10390,'he','× × ×œ×›×œ×•×œ ×ª××¨×™×š ×”×”×ª×—×œ×”',0),(374025,10390,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(374026,10390,'zh','è¯·åˆ—å…¥å¼€å§‹æ—¥æœŸ\r\n',0),(374027,10390,'sv','VÃ¤nligen inkludera bÃ¶rja datum',0),(374028,10390,'it','Si prega di includere la data di inizio',0),(374029,10390,'tl','',0),(374030,10390,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(374031,10390,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(374032,10390,'ms','Sila Sertakan tarikh mulakan',0),(374033,10390,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(374034,10390,'fr','Veuillez indiquer la Date de dÃ©but',0),(374035,10390,'jp','é–‹å§‹æ—¥ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(374036,10390,'pt','Por favor, inclua a data de inÃ­cio',0),(374037,10390,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½ÑƒÑŽ Ð”Ð°Ñ‚Ñƒ',0),(374038,10390,'es','Por Favor Incluye Fecha de Comienxa',0),(374039,10390,'de','Bitte geben Sie Anfangsdatum',0),(374040,10390,'en','Please Include Begin Date',0),(374041,10391,'is','',0),(374042,10391,'dr','Ù„Ø·ÙØ§ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù†  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(374043,10391,'pr','Ù„Ø·ÙØ§ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù†  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(374044,10391,'tr','LÃ¼tfen bitiÅŸ tarihi iÃ§erir.',0),(374045,10391,'pl','ProszÄ™ podaÄ‡ datÄ™ zakoÅ„czenia',0),(374046,10391,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ ÐºÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(374047,10391,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ® Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(374048,10391,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(374049,10391,'vi','vui lÃ²ng bao gá»“m ngÃ y káº¿t thÃºc',0),(374050,10391,'af','Sluit asseblief End Datum in',0),(374051,10391,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i data de sfÃ¢rÅŸit',0),(374052,10391,'et','Palun lisa lÃµpp kuupÃ¤ev',0),(374053,10391,'si','Prosimo, da vkljuÄite konÄni datum',0),(374054,10391,'ba','Harap sertakan tanggal akhir',0),(374055,10391,'nl','Gelieve te omvatten einddatum',0),(374056,10391,'fi','Kirjoita pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(374057,10391,'no','Ta med dato',0),(374058,10391,'da','VedlÃ¦g slutdato',0),(374059,10391,'ko','ë ë‚ ì§œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(374060,10391,'he','×× × ×›×œ×•×œ ×ª××¨×™×š ×¡×™×•×',0),(374061,10391,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(374062,10391,'zh','è¯·åˆ—å…¥ç»“æŸæ—¥æœŸ\r\n',0),(374063,10391,'sv','VÃ¤nligen inkludera slutdatum',0),(374064,10391,'it','Si prega di includere la data di fine',0),(374065,10391,'tl','',0),(374066,10391,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(374067,10391,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(374068,10391,'ms','Sila Sertakan tarikh akhir',0),(374069,10391,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡',0),(374070,10391,'fr','Veuillez indiquer la Date de fin',0),(374071,10391,'jp','çµ‚äº†æ—¥ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(374072,10391,'pt','Por favor, inclua a data de tÃ©rmino',0),(374073,10391,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ ÐšÐ¾Ð½ÐµÑ‡Ð½ÑƒÑŽ Ð”Ð°Ñ‚Ñƒ',0),(374074,10391,'es','Por Favor Incluye Fecha de TerminaciÃ³n',0),(374075,10391,'de','Bitte geben Sie Enddatum',0),(374076,10391,'en','Please Include End Date',0),(374077,10392,'is','',0),(374078,10392,'dr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ù†ÙŠØ§Ø² Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(374079,10392,'pr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ù†ÙŠØ§Ø² Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(374080,10392,'tr','LÃ¼tfen Requirment tÃ¼rÃ¼ ekleyin',0),(374081,10392,'pl','Prosimy o podanie typu wymogu odnoszÄ…cego',0),(374082,10392,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ñ‚Ð¸Ð¿',0),(374083,10392,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø±ÛŒÙ‚Ø±Ù…Ø§Ù†Ù¹ Ù‚Ø³Ù… Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(374084,10392,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð²Ñ€ÑÑ‚Ñƒ Ð ÐµqÑƒÐ¸Ñ€Ð¼ÐµÐ½Ñ‚',0),(374085,10392,'vi','vui lÃ²ng bao gá»“m loáº¡i nhu cáº§u',0),(374086,10392,'af','Sluit asseblief Tipe Vereiste in',0),(374087,10392,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i Requirment tip',0),(374088,10392,'et','Palun lisage Requirment tÃ¼Ã¼p',0),(374089,10392,'si','Prosimo, da vkljuÄite Requirment tipa',0),(374090,10392,'ba','Sertakan tipe kepentingan',0),(374091,10392,'nl','Gelieve te omvatten Requirment Type',0),(374092,10392,'fi','LiitÃ¤ velvoitteista tyyppi',0),(374093,10392,'no','Behage inkludere Requirment',0),(374094,10392,'da','VedlÃ¦g Requirment Type',0),(374095,10392,'ko','Requirment ìœ í˜•ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(374096,10392,'he','×× × ×›×œ×•×œ ×¡×•×’ ×“×¨×™×©×”',0),(374097,10392,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ Ï…Ï€Î¿Ï‡ÏÎµÏ‰Ï„Î¹ÎºÏŒ Ï„ÏÏ€Î¿Ï…',0),(374098,10392,'zh','è¯·åˆ—å…¥éœ€æ±‚é‡çš„ç±»åž‹\r\n',0),(374099,10392,'sv','VÃ¤nligen inkludera Requirment typ',0),(374100,10392,'it','Si prega di includere il tipo Requirment',0),(374101,10392,'tl','',0),(374102,10392,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸™à¸´à¸” Requirment',0),(374103,10392,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ Requirment à¤ªà¥à¤°à¤•à¤¾à¤° à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(374104,10392,'ms','Sila sertakan Requirment jenis',0),(374105,10392,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ù†ÙˆØ¹ Ù…Ø·Ù„Ø¨',0),(374106,10392,'fr','S\'il vous plaÃ®t inclure Requirment Type',0),(374107,10392,'jp','éœ€è¦é‡ã®ç¨®é¡žã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(374108,10392,'pt','Por favor inclua o tipo Requirment',0),(374109,10392,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿ Requirment',0),(374110,10392,'es','Por Favor Incluye Tipo de Requerimiento',0),(374111,10392,'de','Bitte geben Sie Requirment Typ',0),(374112,10392,'en','Please Include Requirment Type',0),(374113,10393,'is','',0),(374114,10393,'dr','Ù„Ø·ÙØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(374115,10393,'pr','Ù„Ø·ÙØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(374116,10393,'tr','LÃ¼tfen satÄ±cÄ± iÃ§erir',0),(374117,10393,'pl','ProszÄ™ podaÄ‡ sprzedawcy',0),(374118,10393,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(374119,10393,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÙˆÛŒÙ†ÚˆØ± Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(374120,10393,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(374121,10393,'vi','vui lÃ²ng bao gá»“m nhÃ  cung cáº¥p',0),(374122,10393,'af','Sluit asseblief Verskaffer in',0),(374123,10393,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i furnizor',0),(374124,10393,'et','Palun lisa tarnija',0),(374125,10393,'si','Prosimo, da vkljuÄite dobavitelja',0),(374126,10393,'ba','Harap sertakan Vendor',0),(374127,10393,'nl','Gelieve te omvatten leverancier',0),(374128,10393,'fi','Kirjoita toimittaja',0),(374129,10393,'no','Ta med leverandÃ¸r',0),(374130,10393,'da','VedlÃ¦g leverandÃ¸r',0),(374131,10393,'ko','ê³µê¸‰ ì—…ì²´ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(374132,10393,'he','×× × ×›×œ×•×œ ×¡×¤×§',0),(374133,10393,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(374134,10393,'zh','è¯·åˆ—å…¥å–æ–¹\r\n',0),(374135,10393,'sv','VÃ¤nligen inkludera leverantÃ¶ren',0),(374136,10393,'it','Si prega di includere Vendor',0),(374137,10393,'tl','',0),(374138,10393,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸§à¸¡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(374139,10393,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(374140,10393,'ms','Sila sertakan penjual.',0),(374141,10393,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ù…ÙˆØ±Ø¯',0),(374142,10393,'fr','Veuillez inclure le nom du vendeur',0),(374143,10393,'jp','ä»•å…¥å…ˆã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(374144,10393,'pt','Por favor inclua o fornecedor',0),(374145,10393,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(374146,10393,'es','Por Favor Incluye Proveedor',0),(374147,10393,'de','Bitte geben Sie Hersteller',0),(374148,10393,'en','Please Include Vendor',0),(374149,10394,'is','',0),(374150,10394,'dr','Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(374151,10394,'pr','Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(374152,10394,'tr','SatÄ±cÄ± gereksinimleri',0),(374153,10394,'pl','Sprzedawca wymagania',0),(374154,10394,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð°Ð½Ð¸Ñ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°',0),(374155,10394,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©Û’ ØªÙ‚Ø§Ø¶Û’',0),(374156,10394,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð¸ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(374157,10394,'vi','YÃªu cáº§u cá»§a nhÃ  cung cáº¥p',0),(374158,10394,'af','Verskaffer Benodighede',0),(374159,10394,'ro','CerinÅ£ele de furnizor',0),(374160,10394,'et','Tarnija nÃµuded',0),(374161,10394,'si','Zahteve za dobavitelja',0),(374162,10394,'ba','Vendor persyaratan',0),(374163,10394,'nl','Leverancier eisen',0),(374164,10394,'fi','MyyjÃ¤n vaatimukset',0),(374165,10394,'no','LeverandÃ¸ren krav',0),(374166,10394,'da','Kreditors krav',0),(374167,10394,'ko','ê³µê¸‰ ì—…ì²´ ìš”êµ¬ ì‚¬í•­',0),(374168,10394,'he','×“×¨×™×©×•×ª ×¡×¤×§',0),(374169,10394,'el','Î‘Ï€Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(374170,10394,'zh','ä¾›åº”å•†è¦æ±‚\r\n',0),(374171,10394,'sv','Krav pÃ¥ leverantÃ¶ren',0),(374172,10394,'it','Requisiti del fornitore',0),(374173,10394,'tl','',0),(374174,10394,'th','à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(374175,10394,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾à¤à¤',0),(374176,10394,'ms','Syarat-syarat penjual.',0),(374177,10394,'ar','Ù…ØªØ·Ù„Ù‘Ø¨Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(374178,10394,'fr','Exigences du vendeur',0),(374179,10394,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶',0),(374180,10394,'pt','Requisitos do fornecedor',0),(374181,10394,'ru','Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ñ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(374182,10394,'es','Requerimientos de Proveedor ',0),(374183,10394,'de','Herstelleranforderungen',0),(374184,10394,'en','Vendor Requirements',0),(374185,10395,'is','',0),(374186,10395,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ·  ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(374187,10395,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ·  ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(374188,10395,'tr','SatÄ±cÄ± gereksinimi eklendi hatasÄ±',0),(374189,10395,'pl','Sprzedawca wymagania dodaÅ‚ awarii',0),(374190,10395,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(374191,10395,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¶Ø±ÙˆØ±Øª Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ù†Ø§Ú©Ø§Ù…ÛŒ',0),(374192,10395,'sr','Ð£ÑÐ»Ð¾Ð² Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð´Ð¾Ð´Ð°Ð¾ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(374193,10395,'vi','ThÃªm yÃªu cáº§u cá»§a nhÃ  cung cáº¥p tháº¥t báº¡i',0),(374194,10395,'af','Handelaar vereiste bygevoeg versuim',0),(374195,10395,'ro','CerinÅ£a de furnizor adÄƒugat eÅŸec',0),(374196,10395,'et','Hankija nÃµudele lisatud rike',0),(374197,10395,'si','Dobavitelja zahteva doda neuspeh',0),(374198,10395,'ba','Vendor persyaratan ditambahkan kegagalan',0),(374199,10395,'nl','Leverancier eis toegevoegd mislukking',0),(374200,10395,'fi','Toimittajan vaatimus lisÃ¤tÃ¤ epÃ¤onnistuminen',0),(374201,10395,'no','LeverandÃ¸ren krav lagt feil',0),(374202,10395,'da','Kreditors krav tilfÃ¸jet fiasko',0),(374203,10395,'ko','ê³µê¸‰ ì—…ì²´ ìš”ê±´ ì¶”ê°€ ì‹¤íŒ¨',0),(374204,10395,'he','×“×¨×™×©×ª ×”×¡×¤×§ ×”×•×¡×™×£ ×›×©×œ',0),(374205,10395,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Ï€Î±Î¯Ï„Î·ÏƒÎ· Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(374206,10395,'zh','ä¾›åº”å•†è¦æ±‚æ–°å¢žå¤±è´¥\r\n',0),(374207,10395,'sv','LeverantÃ¶rens krav lÃ¤ggas underlÃ¥tenhet',0),(374208,10395,'it','Fornitore requisito aggiunto fallimento',0),(374209,10395,'tl','',0),(374210,10395,'th','à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(374211,10395,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤µà¤¿à¤«à¤²à¤¤à¤¾',0),(374212,10395,'ms','Keperluan penjual ditambah kegagalan',0),(374213,10395,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±Ø· Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ø§Ù„ÙØ´Ù„',0),(374214,10395,'fr','Obligation du vendeur ajoutÃ© Ã©chec',0),(374215,10395,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶ã®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(374216,10395,'pt','ExigÃªncia de fornecedor adicionado falha',0),(374217,10395,'ru','ÐÐµ Ð£Ð´Ð°Ð»Ð¾ÑÑŒ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ñ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(374218,10395,'es','Requerimiento de Proveedor Agregar FallÃ³',0),(374219,10395,'de','Hersteller Anforderung hinzugefÃ¼gt Scheitern',0),(374220,10395,'en','Vendor Requirement Added Failure',0),(374221,10396,'is','',0),(374222,10396,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(374223,10396,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(374224,10396,'tr','SatÄ±cÄ± gereksinimi baÅŸarÄ±yla eklendi',0),(374225,10396,'pl','Sprzedawca wymagania pomyÅ›lnie dodane',0),(374226,10396,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(374227,10396,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©Û’ ØªÙ‚Ø§Ø¶ÙˆÚº Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(374228,10396,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÑƒÑÐ»Ð¾Ð² ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(374229,10396,'vi','ThÃªm yÃªu cáº§u cá»§a nhÃ  cung cáº¥p thÃ nh cÃ´ng',0),(374230,10396,'af','Verskaffer Voorskrifte Suksesvol Bygevoeg',0),(374231,10396,'ro','CerinÅ£a de furnizor adÄƒugat cu succes',0),(374232,10396,'et','Tarnija nÃµude lisamine Ãµnnestus',0),(374233,10396,'si','Dobavitelja zahteva uspeÅ¡no dodani',0),(374234,10396,'ba','Vendor persyaratan ditambahkan berhasil',0),(374235,10396,'nl','Leverancier eis toegevoegd',0),(374236,10396,'fi','Toimittajan vaatimus lisÃ¤ttiin',0),(374237,10396,'no','LeverandÃ¸ren krav lagt',0),(374238,10396,'da','Kreditors krav tilfÃ¸jet',0),(374239,10396,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ê³µê¸‰ ì—…ì²´ ìš”ê±´',0),(374240,10396,'he','×“×¨×™×©×ª ×”×¡×¤×§ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(374241,10396,'el','Î‘Ï€Î±Î¯Ï„Î·ÏƒÎ· Ï„Î¿Ï… Ï€Ï‰Î»Î·Ï„Î® Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(374242,10396,'zh','ä¾›åº”å•†è¦æ±‚æ·»åŠ æˆåŠŸ\r\n',0),(374243,10396,'sv','LeverantÃ¶rens krav lagts',0),(374244,10396,'it','Fornitore requisito aggiunto con successo',0),(374245,10396,'tl','',0),(374246,10396,'th','à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(374247,10396,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(374248,10396,'ms','Keperluan penjual yang berjaya menambah',0),(374249,10396,'ar','Ø£Ø¶ÙŠÙØª Ù…ØªØ·Ù„Ù‘Ø¨Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(374250,10396,'fr','Obligation du vendeur ajoutÃ©e avec succÃ¨s',0),(374251,10396,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(374252,10396,'pt','ExigÃªncia de fornecedor adicionada com sucesso',0),(374253,10396,'ru','Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ñ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(374254,10396,'es','Requerimiento de Proveedor Agregado Exitosamente',0),(374255,10396,'de','Hersteller-Anforderung erfolgreich hinzugefÃ¼gt',0),(374256,10396,'en','Vendor Requirement Added Successfully',0),(374257,10397,'is','',0),(374258,10397,'dr','Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(374259,10397,'pr','Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(374260,10397,'tr','SatÄ±cÄ± gereksinimi baÅŸarÄ±sÄ±zlÄ±k silindi',0),(374261,10397,'pl','Sprzedawca wymagania usuniÄ™ty bÅ‚Ä…d',0),(374262,10397,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(374263,10397,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¶Ø±ÙˆØ±Øª Ù†Ø§Ú©Ø§Ù…ÛŒ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ Û”',0),(374264,10397,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÑƒÑÐ»Ð¾Ð² Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(374265,10397,'vi','XÃ³a yÃªu cáº§u cá»§a nhÃ  cung cáº¥p tháº¥t báº¡i',0),(374266,10397,'af','Skraping van Verskaffer Voorskrifte het gefaal',0),(374267,10397,'ro','CerinÅ£a de furnizor eliminÄƒ eÅŸec',0),(374268,10397,'et','Hankija nÃµue jÃ¤etakse vÃ¤lja jÃ¤tmine',0),(374269,10397,'si','Dobavitelja zahteva Ärta neuspeh',0),(374270,10397,'ba','Vendor persyaratan dihapus kegagalan',0),(374271,10397,'nl','Leverancier eis verwijderd mislukking',0),(374272,10397,'fi','Toimittajan vaatimus poistaa vika',0),(374273,10397,'no','LeverandÃ¸ren kravet slettet feil',0),(374274,10397,'da','Kreditors krav slettet fiasko',0),(374275,10397,'ko','ê³µê¸‰ ì—…ì²´ ìš”ê±´ ì‚­ì œ ì‹¤íŒ¨',0),(374276,10397,'he','×“×¨×™×©×ª ×”×¡×¤×§ ×©× ×ž×—×§×• ×›×©×œ',0),(374277,10397,'el','Î‘Ï€Î±Î¯Ï„Î·ÏƒÎ· Ï„Î¿Ï… Ï€Ï‰Î»Î·Ï„Î® Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯ Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(374278,10397,'zh','ä¾›åº”å•†è¦æ±‚åˆ é™¤å¤±è´¥\r\n',0),(374279,10397,'sv','Krav pÃ¥ leverantÃ¶rens utgÃ¥ misslyckande',0),(374280,10397,'it','Fornitore requisito eliminato fallimento',0),(374281,10397,'tl','',0),(374282,10397,'th','à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(374283,10397,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤¹à¤Ÿà¤¾à¤ à¤—à¤',0),(374284,10397,'ms','Keperluan penjual dihapuskan kegagalan',0),(374285,10397,'ar','Ø­Ø°Ù Ø´Ø±Ø· Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ø§Ù„ÙØ´Ù„',0),(374286,10397,'fr','Obligation du vendeur supprimÃ© Ã©chec',0),(374287,10397,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶ã®å‰Šé™¤ã‚¨ãƒ©ãƒ¼',0),(374288,10397,'pt','ExigÃªncia de fornecedor excluÃ­do falha',0),(374289,10397,'ru','ÐÐµ Ð£Ð´Ð°Ð»Ð¾ÑÑŒ Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ñ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(374290,10397,'es','Requerimiento de Proveedor Eliminar FallÃ³',0),(374291,10397,'de','Hersteller Anforderung gelÃ¶scht Scheitern',0),(374292,10397,'en','Vendor Requirement Deleted Failure',0),(374293,10398,'is','',0),(374294,10398,'dr','Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(374295,10398,'pr','Ø­Ø°Ù Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(374296,10398,'tr','SatÄ±cÄ± gereksinimi baÅŸarÄ±yla silindi',0),(374297,10398,'pl','Sprzedawca wymagania przesâ”‚anie',0),(374298,10398,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(374299,10398,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(374300,10398,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÑƒÑÐ»Ð¾Ð² Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(374301,10398,'vi','XÃ³a yÃªu cáº§u cá»§a nhÃ  cung cáº¥p thÃ nh cÃ´ng',0),(374302,10398,'af','Verskaffer Voorskrifte Suksesvol Geskrap',0),(374303,10398,'ro','CerinÅ£a de furnizor eliminÄƒ cu succes',0),(374304,10398,'et','Hankija nÃµue edukalt kustutatud',0),(374305,10398,'si','Dobavitelja zahteva uspeÅ¡no izbrisana',0),(374306,10398,'ba','Vendor persyaratan dihapus berhasil',0),(374307,10398,'nl','Leverancier eis met succes verwijderd',0),(374308,10398,'fi','Toimittajan vaatimus poistettu',0),(374309,10398,'no','LeverandÃ¸ren kravet slettet',0),(374310,10398,'da','Kreditors krav slettet',0),(374311,10398,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ê³µê¸‰ ì—…ì²´ ìš”ê±´',0),(374312,10398,'he','×“×¨×™×©×ª ×”×¡×¤×§ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(374313,10398,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Ï€Î±Î¯Ï„Î·ÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(374314,10398,'zh','ä¾›åº”å•†è¦æ±‚åˆ é™¤æˆåŠŸ\r\n',0),(374315,10398,'sv','LeverantÃ¶rens krav raderades',0),(374316,10398,'it','Requisito di vendor eliminato con successo',0),(374317,10398,'tl','',0),(374318,10398,'th','à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(374319,10398,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(374320,10398,'ms','Keperluan penjual dihapuskan dengan jayanya',0),(374321,10398,'ar','Ø­Ø°ÙØª Ù…ØªØ·Ù„Ø¨Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(374322,10398,'fr','Obligation du vendeur supprimÃ©e avec succÃ¨s',0),(374323,10398,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶',0),(374324,10398,'pt','ExigÃªncia de fornecedor apagada com sucesso',0),(374325,10398,'ru','Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ñ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½Ñ‹',0),(374326,10398,'es','Requerimiento de Proveedor Eliminado Exitosamente',0),(374327,10398,'de','Hersteller-Anforderung erfolgreich gelÃ¶scht',0),(374328,10398,'en','Vendor Requirement Deleted Successfully',0),(374329,10399,'is','',0),(374330,10399,'dr','Ù†Ùˆ Ø³Ø§Ø²ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(374331,10399,'pr','Ù†Ùˆ Ø³Ø§Ø²ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(374332,10399,'tr','SatÄ±cÄ± ÅŸartÄ± yenilendi hatasÄ±',0),(374333,10399,'pl','Sprzedawca wymagania Odnowiona awarii',0),(374334,10399,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð¾Ð±Ð½Ð¾Ð²ÐµÐ½Ð° Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(374335,10399,'ur','ÙˆÛŒÙ†ÚˆØ± ØªÙ‚Ø§Ø¶ÙˆÚº Ú©ÛŒ Ù†Ø§Ú©Ø§Ù…ÛŒ ØªØ¬Ø¯ÛŒØ¯',0),(374336,10399,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑƒÑÐ»Ð¾Ð² Ð¾Ð±Ð½Ð¾Ð²Ñ™ÐµÐ½Ð° Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(374337,10399,'vi','LÃ m má»›i yÃªu cáº§u cá»§a nhÃ  cung cáº¥p tháº¥t báº¡i',0),(374338,10399,'af','Handelaar vereiste hernu versuim',0),(374339,10399,'ro','CerinÅ£a de furnizor reÃ®nnoit eÅŸec',0),(374340,10399,'et','Hankija nÃµue uuendada jÃ¤tmine',0),(374341,10399,'si','Dobavitelja zahteva obnovi neuspeh',0),(374342,10399,'ba','Vendor persyaratan diperbaharui kegagalan',0),(374343,10399,'nl','Leverancier eis vernieuwd mislukking',0),(374344,10399,'fi','Toimittajan vaatimus uudistaa epÃ¤onnistuminen',0),(374345,10399,'no','LeverandÃ¸ren kravet fornyet feil',0),(374346,10399,'da','Kreditors krav om fornyet fiasko',0),(374347,10399,'ko','ê³µê¸‰ ì—…ì²´ ìš”êµ¬ ì‚¬í•­ ê°±ì‹  ì‹¤íŒ¨',0),(374348,10399,'he','×¡×¤×§ ×“×¨×™×©×” ×ž×—×•×“×©×ª ×›×©×œ',0),(374349,10399,'el','Î‘Ï€Î±Î¯Ï„Î·ÏƒÎ· Ï„Î¿Ï… Ï€Ï‰Î»Î·Ï„Î® Î±Î½Î±Î½ÎµÏŽÎ½ÎµÏ„Î±Î¹ Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(374350,10399,'zh','ä¾›åº”å•†è¦æ±‚ç»­è®¢å¤±è´¥\r\n',0),(374351,10399,'sv','Krav pÃ¥ leverantÃ¶r fÃ¶rnyas misslyckande',0),(374352,10399,'it','Fornitore requisito rinnovato fallimento',0),(374353,10399,'tl','',0),(374354,10399,'th','à¸„à¸§à¸²à¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§à¹ƒà¸™à¸à¸²à¸£à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(374355,10399,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤•à¥‹ à¤¨à¤ à¤¸à¤¿à¤°à¥‡ à¤¸à¥‡ à¤µà¤¿à¤«à¤²à¤¤à¤¾',0),(374356,10399,'ms','Keperluan penjual diperbaharui kegagalan',0),(374357,10399,'ar','Ø§Ø´ØªØ±Ø§Ø· Ø§Ù„Ø¨Ø§Ø¦Ø¹ ØªØ¬Ø¯Ø¯ Ø§Ù„ÙØ´Ù„',0),(374358,10399,'fr','Obligation du vendeur renouvelÃ© Ã©chec',0),(374359,10399,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶æ›´æ–°å¤±æ•—',0),(374360,10399,'pt','ExigÃªncia de fornecedor renovada falha',0),(374361,10399,'ru','ÐÐµ Ð£Ð´Ð°Ð»Ð¾ÑÑŒ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ñ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(374362,10399,'es','Requerimiento de Proveedor Renovar FallÃ³',0),(374363,10399,'de','Hersteller Anforderung erneuert Scheitern',0),(374364,10399,'en','Vendor Requirement Renewed Failure',0),(374365,10400,'is','',0),(374366,10400,'dr','Ù†ÙˆØ³Ø§Ø²ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(374367,10400,'pr','Ù†ÙˆØ³Ø§Ø²ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(374368,10400,'tr','SatÄ±cÄ± ÅŸartÄ± yenilendi Succussfully&#xD;\n',0),(374369,10400,'pl','Sprzedawca wymagania odnowione Succussfully&#xD;\n',0),(374370,10400,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð¾Ð±Ð½Ð¾Ð²ÐµÐ½Ð° Succussfully&#xD;\n',0),(374371,10400,'ur','ÙˆÛŒÙ†ÚˆØ± ØªÙ‚Ø§Ø¶ÙˆÚº Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯ Ø³Ú©Ú©Ø³Ø³ÙØ§Ù„Ù„ÛŒ&#xD;\n',0),(374372,10400,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÑƒÑÐ»Ð¾Ð² Ð¾Ð±Ð½Ð¾Ð²Ñ™ÐµÐ½Ð° Ð¡ÑƒÑ†Ñ†ÑƒÑÑÑ„ÑƒÐ»Ð»y&#xD;\n',0),(374373,10400,'vi','LÃ m má»›i yÃªu cáº§u cá»§a nhÃ  cung cáº¥p thÃ nh cÃ´ng',0),(374374,10400,'af','Verskaffer Voorskrifte Suksesvol Hernu',0),(374375,10400,'ro','CerinÅ£a de furnizor reÃ®nnoit Succussfully&#xD;\n',0),(374376,10400,'et','Hankijale nÃµuet pikendada Succussfully&#xD;\n',0),(374377,10400,'si','Dobavitelja zahteva prenovljena Succussfully&#xD;\n',0),(374378,10400,'ba','Vendor persyaratan diperbaharui Succussfully&#xD;\n',0),(374379,10400,'nl','Leverancier eis vernieuwd Succussfully&#xD;\n',0),(374380,10400,'fi','Toimittajan vaatimus uudistaa Succussfully&#xD;\n',0),(374381,10400,'no','LeverandÃ¸ren kravet fornyet Succussfully&#xD;\n',0),(374382,10400,'da','Kreditors krav om fornyet Succussfully&#xD;\n',0),(374383,10400,'ko','ê³µê¸‰ ì—…ì²´ ìš”êµ¬ ì‚¬í•­ ê°±ì‹  Succussfully&#xD;\n',0),(374384,10400,'he','×¡×¤×§ ×“×¨×™×©×” ×ž×—×•×“×©×ª Succussfully&#xD;\n',0),(374385,10400,'el','Î‘Ï€Î±Î¯Ï„Î·ÏƒÎ· Ï„Î¿Ï… Ï€Ï‰Î»Î·Ï„Î® Î±Î½Î±Î½ÎµÏŽÎ½ÎµÏ„Î±Î¹ Succussfully&#xD;\n',0),(374386,10400,'zh','ä¾›åº”å•†è¦æ±‚ç»­è®¢æˆåŠŸ\r\n',0),(374387,10400,'sv','Krav pÃ¥ leverantÃ¶r fÃ¶rnyas Succussfully&#xD;\n',0),(374388,10400,'it','Fornitore requisito rinnovato Succussfully&#xD;\n',0),(374389,10400,'tl','',0),(374390,10400,'th','à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸ Succussfully&#xD;\n',0),(374391,10400,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ Succussfully à¤•à¥‹ à¤¨à¤ à¤¸à¤¿à¤°à¥‡ à¤¸à¥‡&#xD;\n',0),(374392,10400,'ms','Keperluan penjual diperbaharui Succussfully&#xD;\n',0),(374393,10400,'ar','Ø¬Ø¯Ù‘Ø¯Øª Ù…ØªØ·Ù„Ù‘Ø¨Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(374394,10400,'fr','Obligation du vendeur renouvelÃ© Succussfully&#xD;\n',0),(374395,10400,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶æ›´æ–°æˆåŠŸ',0),(374396,10400,'pt','ExigÃªncia de fornecedor renovada Succussfully&#xD;\n',0),(374397,10400,'ru','Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ñ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(374398,10400,'es','Requerimiento de Proveedor Renovados Exitosamente',0),(374399,10400,'de','Hersteller Anforderung erneuert Succussfully&#xD;\n',0),(374400,10400,'en','Vendor Requirement Renewed Succussfully\r\n',0),(374401,10401,'is','',0),(374402,10401,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(374403,10401,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(374404,10401,'tr','SatÄ±cÄ± gereksinimi gÃ¼ncelleme hatasÄ±',0),(374405,10401,'pl','Sprzedawca wymagania aktualizacja brak',0),(374406,10401,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(374407,10401,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¶Ø±ÙˆØ±Øª Ù†Ø§Ú©Ø§Ù…ÛŒ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§ ÛÛ’',0),(374408,10401,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÑƒÑÐ»Ð¾Ð² Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(374409,10401,'vi','Cáº­p nháº­t yÃªu cáº§u cá»§a nhÃ  cung cáº¥p tháº¥t báº¡i',0),(374410,10401,'af','Verskaffer Vereistes Opdatering Gefaal',0),(374411,10401,'ro','CerinÅ£a de furnizor actualizat eÅŸec',0),(374412,10401,'et','Hankija nÃµue uuendatud rike',0),(374413,10401,'si','Dobavitelja zahteva posodobitev neuspeh',0),(374414,10401,'ba','Vendor persyaratan diperbarui kegagalan',0),(374415,10401,'nl','Leverancier eis bijgewerkt mislukking',0),(374416,10401,'fi','Toimittajan vaatimus pÃ¤ivitetty epÃ¤onnistuminen',0),(374417,10401,'no','LeverandÃ¸ren krav oppdatert feil',0),(374418,10401,'da','Kreditors krav opdateret fiasko',0),(374419,10401,'ko','ê³µê¸‰ ì—…ì²´ ìš”êµ¬ ì‚¬í•­ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(374420,10401,'he','×”×“×¨×™×©×” ×œ×¡×¤×§ ×¢×“×›×•×Ÿ ×›×©×œ',0),(374421,10401,'el','Î‘Ï€Î±Î¯Ï„Î·ÏƒÎ· Ï„Î¿Ï… Ï€Ï‰Î»Î·Ï„Î® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(374422,10401,'zh','ä¾›åº”å•†è¦æ±‚æ›´æ–°çš„æ•…éšœ\r\n',0),(374423,10401,'sv','Krav pÃ¥ leverantÃ¶r uppdaterad misslyckande',0),(374424,10401,'it','Fornitore requisito aggiornato fallimento',0),(374425,10401,'tl','',0),(374426,10401,'th','à¸„à¸§à¸²à¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§à¹ƒà¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(374427,10401,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥€ à¤µà¤¿à¤«à¤²à¤¤à¤¾',0),(374428,10401,'ms','Keperluan penjual dikemaskini kegagalan',0),(374429,10401,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ù…ØªØ·Ù„Ø¨Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯',0),(374430,10401,'fr','Obligation du vendeur mis Ã  jour l\'Ã©chec',0),(374431,10401,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶æ›´æ–°å¤±æ•—',0),(374432,10401,'pt','ExigÃªncia de fornecedor atualizado falha',0),(374433,10401,'ru','ÐÐµ Ð£Ð´Ð°Ð»Ð¾ÑÑŒ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ñ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(374434,10401,'es','Requerimiento de Proveedor Actualizar FallÃ³',0),(374435,10401,'de','Hersteller Anforderung aktualisiert Fehler',0),(374436,10401,'en','Vendor Requirement Updated Failure',0),(374437,10402,'is','',0),(374438,10402,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(374439,10402,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(374440,10402,'tr','SatÄ±cÄ± Requirment baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(374441,10402,'pl','Dostawcy wymogu odnoszÄ…cego siÄ™ pomyÅ›lnie zaktualizowana',0),(374442,10402,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(374443,10402,'ur','ÙˆÛŒÙ†ÚˆØ± Ø±ÛŒÙ‚Ø±Ù…Ø§Ù†Ù¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(374444,10402,'sr','Ð ÐµqÑƒÐ¸Ñ€Ð¼ÐµÐ½Ñ‚ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(374445,10402,'vi','Cáº­p nháº­t yÃªu cáº§u cá»§a nhÃ  cung cáº¥p thÃ nh cÃ´ng',0),(374446,10402,'af','Verskaffer Vereistes Suksesvol Opdateer',0),(374447,10402,'ro','Furnizor Requirment actualizat cu succes',0),(374448,10402,'et','Hankija Requirment vÃ¤rskendamine Ãµnnestus',0),(374449,10402,'si','Prodajalec Requirment uspeÅ¡no posodobljena',0),(374450,10402,'ba','Penjual kepentingan berhasil',0),(374451,10402,'nl','Leverancier Requirment bijgewerkt',0),(374452,10402,'fi','Toimittajan velvoitteista pÃ¤ivitetty',0),(374453,10402,'no','LeverandÃ¸ren Requirment oppdatert',0),(374454,10402,'da','Kreditor Requirment opdateret',0),(374455,10402,'ko','ê³µê¸‰ ì—…ì²´ Requirment ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(374456,10402,'he','×”×¡×¤×§ Requirment ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(374457,10402,'el','Î¥Ï€Î¿Ï‡ÏÎµÏ‰Ï„Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(374458,10402,'zh','ä¾›åº”å•†è¦æ±‚æ›´æ–°æˆåŠŸ\r\n',0),(374459,10402,'sv','LeverantÃ¶r Requirment uppdaterats',0),(374460,10402,'it','Fornitore Requirment aggiornato con successo',0),(374461,10402,'tl','',0),(374462,10402,'th','à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢ Requirment à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(374463,10402,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ Requirment à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(374464,10402,'ms','Requirment penjual yang berjaya dikemas kini',0),(374465,10402,'ar','Ø­Ø¯Ù‘Ø«Øª Ù…ØªØ·Ù„Ø¨Ø§Øª Ø§Ù„Ù…ÙˆØ±Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(374466,10402,'fr','Fournisseur Requirment Updated Successfully',0),(374467,10402,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸãƒ™ãƒ³ãƒ€ãƒ¼éœ€è¦é‡',0),(374468,10402,'pt','Fornecedor Requirment atualizado com sucesso',0),(374469,10402,'ru','Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ñ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(374470,10402,'es','Requerimiento de Proveedor  Actualizado Exitosamente',0),(374471,10402,'de','Hersteller Requirment erfolgreich aktualisiert',0),(374472,10402,'en','Vendor Requirment Updated Successfully',0),(374473,10403,'is','',0),(374474,10403,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(374475,10403,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø§ÙŠØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(374476,10403,'tr','SatÄ±cÄ± gereksinim eklemek',0),(374477,10403,'pl','DodaÄ‡ dostawcÃ³w wymÃ³g',0),(374478,10403,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ',0),(374479,10403,'ur','ÙˆÛŒÙ†ÚˆØ± ØªÙ‚Ø§Ø¶ÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(374480,10403,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑƒÑÐ»Ð¾Ð²',0),(374481,10403,'vi','ThÃªm nhÃ  cung cáº¥p yÃªu cáº§u',0),(374482,10403,'af','Voeg handelaar vereiste',0),(374483,10403,'ro','Adauga cerinÅ£a de furnizor',0),(374484,10403,'et','Lisa tarnija nÃµue',0),(374485,10403,'si','Dodaj dobavitelja zahteva',0),(374486,10403,'ba','Tambahkan Vendor persyaratan',0),(374487,10403,'nl','Verplichting van de leverancier toevoegen',0),(374488,10403,'fi','LisÃ¤Ã¤ toimittajan vaatimus',0),(374489,10403,'no','Legge til leverandÃ¸ren krav',0),(374490,10403,'da','TilfÃ¸je kreditors krav',0),(374491,10403,'ko','ê³µê¸‰ ì—…ì²´ ìš”êµ¬ ì‚¬í•­ ì¶”ê°€',0),(374492,10403,'he','×”×•×¡×£ ×¡×¤×§ ×“×¨×™×©×”',0),(374493,10403,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ Î±Ï€Î±Î¯Ï„Î·ÏƒÎ· Ï„Î¿Ï… Ï€Ï‰Î»Î·Ï„Î®',0),(374494,10403,'zh','å¢žåŠ ä¾›åº”å•†çš„è¦æ±‚\r\n',0),(374495,10403,'sv','LÃ¤gga till krav pÃ¥ leverantÃ¶ren',0),(374496,10403,'it','Aggiungi venditore requisito',0),(374497,10403,'tl','',0),(374498,10403,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(374499,10403,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(374500,10403,'ms','Tambah keperluan penjual.',0),(374501,10403,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ØªØ·Ù„Ù‘Ø¨Ø§Øª Ù…ÙˆØ±Ù‘Ø¯',0),(374502,10403,'fr','Ajouter l\'obligation du vendeur',0),(374503,10403,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶ã«è¿½åŠ ã—ã¾ã™ã€‚',0),(374504,10403,'pt','Adicionar vendedor exigÃªncia',0),(374505,10403,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(374506,10403,'es','Agregar Requerimiento de Vendedor',0),(374507,10403,'de','HinzufÃ¼gen von Vendor-Anforderung',0),(374508,10403,'en','Add Vendor Requirement',0),(374509,10404,'is','',0),(374510,10404,'dr','Ù†Ùˆ Ø³Ø§Ø²ÙŠ',0),(374511,10404,'pr','Ù†Ùˆ Ø³Ø§Ø²ÙŠ',0),(374512,10404,'tr','Yenilemek',0),(374513,10404,'pl','OdnowiÄ‡',0),(374514,10404,'bg','ÐŸÐ¾Ð´Ð½Ð¾Ð²Ð¸',0),(374515,10404,'ur','Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯',0),(374516,10404,'sr','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚Ðµ',0),(374517,10404,'vi','Gia háº¡n',0),(374518,10404,'af','Hernu',0),(374519,10404,'ro','ReÃ®nnoi',0),(374520,10404,'et','Uuendada',0),(374521,10404,'si','Obnoviti',0),(374522,10404,'ba','Memperbaharui',0),(374523,10404,'nl','Vernieuwen',0),(374524,10404,'fi','Uudistaa',0),(374525,10404,'no','Fornye',0),(374526,10404,'da','Forny',0),(374527,10404,'ko','ê°±ì‹ ',0),(374528,10404,'he','×œ×—×“×©',0),(374529,10404,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ·',0),(374530,10404,'zh','æ›´æ–°\r\n',0),(374531,10404,'sv','FÃ¶rnya',0),(374532,10404,'it','Rinnovare',0),(374533,10404,'tl','',0),(374534,10404,'th','à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸',0),(374535,10404,'hi','à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤•à¤°à¥‡à¤‚',0),(374536,10404,'ms','Memperbaharui',0),(374537,10404,'ar','ØªØ¬Ø¯ÙŠØ¯',0),(374538,10404,'fr','Renouveler',0),(374539,10404,'jp','æ›´æ–°',0),(374540,10404,'pt','Renovar',0),(374541,10404,'ru','Ð’Ð¾Ð·Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(374542,10404,'es','Renovar',0),(374543,10404,'de','Erneuern',0),(374544,10404,'en','Renew',0),(374545,10405,'is','',0),(374546,10405,'dr','Ø¯Ø±ÙŠØ§ÙØªÙ‡Ø§ÙŠ Ù†Ù‚Ø¯ÙŠ',0),(374547,10405,'pr','Ø¯Ø±ÙŠØ§ÙØªÙ‡Ø§ÙŠ Ù†Ù‚Ø¯ÙŠ',0),(374548,10405,'tr','Nakit giriÅŸleri',0),(374549,10405,'pl','GotÃ³wkowe',0),(374550,10405,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚ÑŠÐ¿Ð»ÐµÐ½Ð¸Ñ',0),(374551,10405,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº',0),(374552,10405,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸Ð½ÑÐºÐµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(374553,10405,'vi','BiÃªn nháº­n tiá»n máº·t',0),(374554,10405,'af','Kontant ontvangste',0),(374555,10405,'ro','ÃŽncasÄƒri Ã®n numerar',0),(374556,10405,'et','Raha laekumine',0),(374557,10405,'si','Prejemki',0),(374558,10405,'ba','Terima kas',0),(374559,10405,'nl','Contante ontvangsten',0),(374560,10405,'fi','Saadut',0),(374561,10405,'no','Innbetalinger',0),(374562,10405,'da','Indbetalinger',0),(374563,10405,'ko','í˜„ê¸ˆ ì˜ìˆ˜ì¦',0),(374564,10405,'he','×§×‘×œ×•×ª ×ž×–×•×ž×Ÿ',0),(374565,10405,'el','Î•Î¹ÏƒÏ€ÏÎ¬Î¾ÎµÏ‰Î½',0),(374566,10405,'zh','çŽ°é‡‘æ”¶å…¥\r\n',0),(374567,10405,'sv','Inbetalningar',0),(374568,10405,'it','Incassi',0),(374569,10405,'tl','',0),(374570,10405,'th','à¹ƒà¸šà¹€à¸ªà¸£à¹‡à¸ˆà¸£à¸±à¸šà¹€à¸‡à¸´à¸™',0),(374571,10405,'hi','à¤¨à¤•à¤¦à¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿',0),(374572,10405,'ms','Terimaan Wang Tunai',0),(374573,10405,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(374574,10405,'fr','Encaissements',0),(374575,10405,'jp','ç¾é‡‘é ˜åŽæ›¸',0),(374576,10405,'pt','Recebimentos de caixa',0),(374577,10405,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ Ð¿Ð¾ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ',0),(374578,10405,'es','Recibos de Efectivo',0),(374579,10405,'de','ZahlungseingÃ¤nge',0),(374580,10405,'en','Cash Receipts',0),(374581,10406,'is','',0),(374582,10406,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± ',0),(374583,10406,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ± ',0),(374584,10406,'tr','-Fatura Ã¶deme',0),(374585,10406,'pl','PÅ‚atnoÅ›ci-faktura',0),(374586,10406,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(374587,10406,'ur','ØºÛŒØ± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(374588,10406,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° ÐºÐ¾Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(374589,10406,'vi','Thanh toÃ¡n khÃ´ng cÃ³ hÃ³a Ä‘Æ¡n',0),(374590,10406,'af','Nie-Faktuur Betaling',0),(374591,10406,'ro','Plati non-facturi',0),(374592,10406,'et','Arve tasumine',0),(374593,10406,'si','PlaÄilo raÄun',0),(374594,10406,'ba','Bebas-faktur pembayaran',0),(374595,10406,'nl','Niet-factuur betaling',0),(374596,10406,'fi','Lasku',0),(374597,10406,'no','Ikke-fakturabetalingen',0),(374598,10406,'da','Ikke-faktura betaling',0),(374599,10406,'ko','ë¹„ ì²­êµ¬ì„œ ì§€ë¶ˆ',0),(374600,10406,'he','×œ×œ× ×—×©×‘×•× ×™×ª ×ª×©×œ×•×',0),(374601,10406,'el','ÎœÎ·-Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(374602,10406,'zh','æ— å‘ç¥¨ä»˜æ¬¾\r\n',0),(374603,10406,'sv','Icke-faktura betalning',0),(374604,10406,'it','Pagamento fattura non',0),(374605,10406,'tl','',0),(374606,10406,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(374607,10406,'hi','à¤—à¥ˆà¤°-à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(374608,10406,'ms','Invois pembayaran',0),(374609,10406,'ar','ØªØ³Ø¯ÙŠØ¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(374610,10406,'fr','Paiement de la facture non',0),(374611,10406,'jp','éžè«‹æ±‚æ›¸æ”¯æ‰•',0),(374612,10406,'pt','Pagamento de fatura nÃ£o',0),(374613,10406,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð½Ð¾Ð¼ÐµÑ€Ð° ÑÑ‡ÐµÑ‚Ð°',0),(374614,10406,'es','Pago de No Facturado',0),(374615,10406,'de','Nicht-Rechnung Zahlung',0),(374616,10406,'en','Non-Invoice Payment',0),(374617,10407,'is','',0),(374618,10407,'dr','Ù¾Ø°ÙŠØ±ÙØªÙ† ',0),(374619,10407,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ† ',0),(374620,10407,'tr','Kabul etmek',0),(374621,10407,'pl','ZaakceptowaÄ‡',0),(374622,10407,'bg','ÐŸÑ€Ð¸ÐµÐ¼ÐµÑ‚Ðµ',0),(374623,10407,'ur','Ù¹Ú¾ÛŒÚ© ÛÛ’',0),(374624,10407,'sr','ÐŸÑ€Ð¸Ñ…Ð²Ð°Ñ‚Ð¸',0),(374625,10407,'vi','Cháº¥p nháº­n',0),(374626,10407,'af','Aanvaar',0),(374627,10407,'ro','Accepta',0),(374628,10407,'et','Aksepteeri',0),(374629,10407,'si','Sprejeti',0),(374630,10407,'ba','Menerima',0),(374631,10407,'nl','Accepteren',0),(374632,10407,'fi','HyvÃ¤ksy',0),(374633,10407,'no','Godta',0),(374634,10407,'da','Acceptere',0),(374635,10407,'ko','ìˆ˜ë½',0),(374636,10407,'he','×§×‘×œ',0),(374637,10407,'el','Î”ÎµÏ‡Î¸ÎµÎ¯',0),(374638,10407,'zh','æŽ¥å—\r\n',0),(374639,10407,'sv','Accept',0),(374640,10407,'it','Accettare',0),(374641,10407,'tl','',0),(374642,10407,'th','à¸¢à¸­à¸¡à¸£à¸±à¸š',0),(374643,10407,'hi','à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤°à¥‡à¤‚',0),(374644,10407,'ms','Menerima',0),(374645,10407,'ar','Ù‚Ø¨ÙˆÙ„',0),(374646,10407,'fr','Accepter',0),(374647,10407,'jp','å—ã‘å…¥ã‚Œã‚‹',0),(374648,10407,'pt','Aceitar',0),(374649,10407,'ru','ÐŸÑ€Ð¸Ð¼Ð¸Ñ‚Ðµ',0),(374650,10407,'es','Aceptar',0),(374651,10407,'de','Annehmen',0),(374652,10407,'en','Accept',0),(374653,10408,'is','',0),(374654,10408,'dr','/ Ø±Ø¯ ÙˆØ¬Ù‡ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡ Ø¨Ù‡ Ù…Ù†  ',0),(374655,10408,'pr','Ù¾Ø°ÙŠØ±ÙØªÙ† / Ø±Ø¯ ÙˆØ¬Ù‡ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡ Ø¨Ù‡ Ù…Ù†  ',0),(374656,10408,'tr','Beni transfer nakit kabul/Red',0),(374657,10408,'pl','Akceptuj/OdrzuÄ‡ Å›rodki pieniÄ™Å¼ne przekazane do mnie',0),(374658,10408,'bg','ÐŸÑ€Ð¸ÐµÐ¼Ð°Ð½Ðµ/Ð¾Ñ‚Ñ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð½Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°, Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÐµÐ½Ð¸ ÐºÑŠÐ¼ Ð¼ÐµÐ½',0),(374659,10408,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ù…Ø¬Û’ Ø¯ÛŒÙ†Û’ Ú©ÛŒÙ„Ø¡Û’ Ù…Ù†Ø¸ÙˆØ± ÛŒØ§ Ù†Ø§Ù…Ù†Ø¸ÙˆØ± Ú©Ø±ÛŒÚº',0),(374660,10408,'sr','ÐŸÑ€Ð¸Ñ…Ð²Ð°Ñ‚Ð¸ /Ð¾Ð´Ð±Ð°Ñ†Ð¸ Ð½Ð¾Ð²Ð°Ñ† Ð¿Ñ€ÐµÐ±Ð°Ñ‡ÐµÐ½ Ñƒ Ð¼ÐµÐ½Ðµ',0),(374661,10408,'vi','Cháº¥p nháº­n/tá»« chá»‘i chuá»ƒn tiá»n cho tÃ´i',0),(374662,10408,'af','Aanvaar/Verwerp Kontant Oorgeplaas na My',0),(374663,10408,'ro','Acceptare/respingere numerar transferate la mine',0),(374664,10408,'et','Aktsepteerimine vÃµi hÃ¼lgamine raha Ã¼le mulle',0),(374665,10408,'si','Sprejmi/Zavrni denar prenese na mene',0),(374666,10408,'ba','Menerima Tolak uang ditransfer ke saya',0),(374667,10408,'nl','Accepteren/afwijzen Cash overgebracht naar Me',0),(374668,10408,'fi','HyvÃ¤ksy tai hylkÃ¤Ã¤ rahaa siirtyi minulle',0),(374669,10408,'no','Godta/Avvis penger overfÃ¸rt til meg',0),(374670,10408,'da','Accepter/Afvis Cash overfÃ¸rt til mig',0),(374671,10408,'ko','ë‚˜ì— ê²Œ í—ˆìš©/ê±°ë¶€ í˜„ê¸ˆ ì „ì†¡',0),(374672,10408,'he','×œ×§×‘×œ×”/×“×—×™×™×” ×©×œ ×ž×–×•×ž× ×™× ×”×•×¢×‘×¨×• ××œ×™×™',0),(374673,10408,'el','Î‘Ï€Î¿Î´Î¿Ï‡Î®/Î±Ï€ÏŒÏÏÎ¹ÏˆÎ· Ï„Ï‰Î½ Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½ Ï€Î¿Ï… Î¼ÎµÏ„Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹ Î³Î¹Î± Î¼Î­Î½Î±',0),(374674,10408,'zh','æŽ¥å—/æ‹’ç»çŽ°é‡‘è½‰è³¬äºˆæœ¬äºº',0),(374675,10408,'sv','Acceptera / avvisa kontantÃ¶verfÃ¶ring till mig',0),(374676,10408,'it','Accetta/Rifiuta contanti a me trasferiti',0),(374677,10408,'tl','',0),(374678,10408,'th','à¹‚à¸­à¸™à¹€à¸‡à¸´à¸™à¸ªà¸”à¸£à¸±à¸š/à¸›à¸à¸´à¹€à¸ªà¸˜à¸‰à¸±à¸™',0),(374679,10408,'hi','à¤®à¥à¤à¥‡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤¿à¤¤ à¤¨à¤•à¤¦ à¤¸à¥à¤µà¥€à¤•à¤¾à¤°/à¤…à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤°à¥‡à¤‚',0),(374680,10408,'ms','Menerima/menolak Wang Tunai yang dipindahkan kepada saya',0),(374681,10408,'ar','Ù‚Ø¨ÙˆÙ„/Ø±ÙØ¶ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø§Ù„Ù…Ù†Ù‚ÙˆÙ„Ø© Ø¨Ø§Ù„Ù†Ø³Ø¨Ø© Ù„ÙŠ',0),(374682,10408,'fr','Accepter/refuser le cash transfÃ©rÃ© vers moi',0),(374683,10408,'jp','ç¾é‡‘ç§ã«è»¢é€ã®è¨±å¯/æ‹’å¦',0),(374684,10408,'pt','Aceitar/rejeitar o dinheiro transferido para mim',0),(374685,10408,'ru','ÐŸÑ€Ð¸Ð½ÑÑ‚ÑŒ/Ð¾Ñ‚ÐºÐ»Ð¾Ð½Ð¸Ñ‚ÑŒ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ´Ð°Ð½Ñ‹ Ð¼Ð½Ðµ',0),(374686,10408,'es','Aceptar/Rechazar Efectivo Transferido a Mi',0),(374687,10408,'de','Ablehnen Sie Cash versetzt mich annehmen /',0),(374688,10408,'en','Accept/Reject Cash Transferred to Me',0),(374689,10409,'is','',0),(374690,10409,'dr','(Ù…Ø±Ø­Ù„Ù‡ ) ÙØ¹Ø§Ù„ÙŠØª ',0),(374691,10409,'pr','Ø¯Ø±Ø¬Ù‡ (Ù…Ø±Ø­Ù„Ù‡ ) ÙØ¹Ø§Ù„ÙŠØª ',0),(374692,10409,'tr','Eylem adÄ±mÄ±',0),(374693,10409,'pl','Krok akcji',0),(374694,10409,'bg','Ð¡Ñ‚ÑŠÐ¿ÐºÐ° Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(374695,10409,'ur','Ø¹Ù…Ù„ Ú©Û’ Ù…Ø±Ø­Ù„Û',0),(374696,10409,'sr','ÐšÐ¾Ñ€Ð°Ðº Ñ€Ð°Ð´ÑšÐµ',0),(374697,10409,'vi','BÆ°á»›c thá»±c hÃ nh',0),(374698,10409,'af','Aksie stap',0),(374699,10409,'ro','AcÅ£iune pas',0),(374700,10409,'et','Toimingu samm',0),(374701,10409,'si','Akcijski korak',0),(374702,10409,'ba','Aksi langkah',0),(374703,10409,'nl','Actie stap',0),(374704,10409,'fi','Toiminnon vaihe',0),(374705,10409,'no','Handlingstrinn',0),(374706,10409,'da','Handling skridt',0),(374707,10409,'ko','ìž‘ì—… ë‹¨ê³„',0),(374708,10409,'he','×”×¤×¢×•×œ×”',0),(374709,10409,'el','Î”ÏÎ¬ÏƒÎ· Î²Î®Î¼Î±',0),(374710,10409,'zh','åŠ¨ä½œæ­¥éª¤\r\n',0),(374711,10409,'sv','Ã…tgÃ¤rden',0),(374712,10409,'it','Passo dell\'azione',0),(374713,10409,'tl','',0),(374714,10409,'th','à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£',0),(374715,10409,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤šà¤°à¤£',0),(374716,10409,'ms','Langkah tindakan',0),(374717,10409,'ar','Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡ Ø®Ø·ÙˆØ©',0),(374718,10409,'fr','Ã‰tape d\'action',0),(374719,10409,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ ã‚¹ãƒ†ãƒƒãƒ—',0),(374720,10409,'pt','Etapa da aÃ§Ã£o',0),(374721,10409,'ru','Ð­Ñ‚Ð°Ð¿ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(374722,10409,'es','Paso de AcciÃ³n',0),(374723,10409,'de','Aktion',0),(374724,10409,'en','Action Step',0),(374725,10410,'is','',0),(374726,10410,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(374727,10410,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(374728,10410,'tr','Nakit transferleri',0),(374729,10410,'pl','Przelewy pieniÄ™Å¼ne',0),(374730,10410,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ Ð¿Ñ€ÐµÐ²Ð¾Ð´Ð¸',0),(374731,10410,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(374732,10410,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ðµ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ðµ',0),(374733,10410,'vi','Chuyá»ƒn tiá»n',0),(374734,10410,'af','Kontant Oorplasings',0),(374735,10410,'ro','Transferuri de numerar',0),(374736,10410,'et','RahaÃ¼lekandeid',0),(374737,10410,'si','Prenosi denarnih sredstev',0),(374738,10410,'ba','Transfer tunai',0),(374739,10410,'nl','Contant geld overdrachten',0),(374740,10410,'fi','Tulonsiirrot',0),(374741,10410,'no','PengeoverfÃ¸ringer',0),(374742,10410,'da','Kontante overfÃ¸rsler',0),(374743,10410,'ko','í˜„ê¸ˆ ì´ì²´',0),(374744,10410,'he','×”×¢×‘×¨×•×ª ×ž×–×•×ž×Ÿ',0),(374745,10410,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚ Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½',0),(374746,10410,'zh','çŽ°é‡‘è½¬ç§»\r\n',0),(374747,10410,'sv','Transfereringssystemen',0),(374748,10410,'it','Trasferimenti di denaro',0),(374749,10410,'tl','',0),(374750,10410,'th','à¹‚à¸­à¸™à¹€à¸‡à¸´à¸™',0),(374751,10410,'hi','à¤¨à¤•à¤¦ à¤…à¤‚à¤¤à¤°à¤£',0),(374752,10410,'ms','Pemindahan Wang Tunai',0),(374753,10410,'ar','Ø§Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(374754,10410,'fr','Transferts en espÃ¨ces',0),(374755,10410,'jp','ç¾é‡‘è»¢é€',0),(374756,10410,'pt','TransferÃªncias de dinheiro',0),(374757,10410,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ñ‹',0),(374758,10410,'es','Transferencias de Efectivo',0),(374759,10410,'de','Bargeldtransfers',0),(374760,10410,'en','Cash Transfers',0),(374761,10411,'is','',0),(374762,10411,'dr','( ÙˆØ§Ú¯Ø°Ø§Ø± Ø´Ø¯Ù‡',0),(374763,10411,'pr','ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‚Ø§Ù„ ÙŠØ§ÙØªÙ‡ ( ÙˆØ§Ú¯Ø°Ø§Ø± Ø´Ø¯Ù‡',0),(374764,10411,'tr','Transfer tarihi',0),(374765,10411,'pl','Data przekazana',0),(374766,10411,'bg','Ð”Ð°Ñ‚Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÐµÐ½Ð¸',0),(374767,10411,'ur','ØªØ§Ø±ÛŒØ® Ù…ÛŒÚº Ù…Ù†ØªÙ‚Ù„',0),(374768,10411,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÐ±Ð°Ñ‡ÐµÐ½',0),(374769,10411,'vi','NgÃ y Ä‘Æ°á»£c chuyá»ƒn',0),(374770,10411,'af','Datum Oorgeplaas',0),(374771,10411,'ro','Data transferat',0),(374772,10411,'et','PÃ¤ev Ã¼le',0),(374773,10411,'si','Datum prenese',0),(374774,10411,'ba','Tanggal transfer',0),(374775,10411,'nl','Datum overgedragen',0),(374776,10411,'fi','PÃ¤ivÃ¤, jolloin siirretyt',0),(374777,10411,'no','Datoen overfÃ¸res',0),(374778,10411,'da','Datoen overfÃ¸res',0),(374779,10411,'ko','ì „ì†¡ ë‚ ì§œ',0),(374780,10411,'he','×ª××¨×™×š ×”×¢×‘×¨×ª',0),(374781,10411,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… Î¼ÎµÏ„Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹',0),(374782,10411,'zh','è½¬ç§»æ—¥æœŸ\r\n',0),(374783,10411,'sv','Datum Ã¶verfÃ¶rs',0),(374784,10411,'it','Data trasferito',0),(374785,10411,'tl','',0),(374786,10411,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¹‚à¸­à¸™',0),(374787,10411,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¤à¤¬à¤¾à¤¦à¤²à¤¾',0),(374788,10411,'ms','Tarikh dipindahkan',0),(374789,10411,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‚Ù„',0),(374790,10411,'fr','Date de transfert',0),(374791,10411,'jp','è­²æ¸¡æ—¥',0),(374792,10411,'pt','Data transferida',0),(374793,10411,'ru','Ð”Ð°Ñ‚Ð° Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(374794,10411,'es','Fecha Transferida',0),(374795,10411,'de','Datum Ã¼bertragen',0),(374796,10411,'en','Date Transferred',0),(374797,10412,'is','',0),(374798,10412,'dr','Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø² ',0),(374799,10412,'pr','Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø² ',0),(374800,10412,'tr','AlÄ±nan',0),(374801,10412,'pl','Otrzymane od',0),(374802,10412,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð¾Ñ‚',0),(374803,10412,'ur','Ù…ÙˆØµÙˆÙ„Û Ø§Ø²',0),(374804,10412,'sr','ÐŸÑ€Ð¸Ð¼Ð¸Ð¾ Ð¾Ð´',0),(374805,10412,'vi','Ä‘Ã£ nháº­n tá»«',0),(374806,10412,'af','Ontvang Vanaf',0),(374807,10412,'ro','Primit de la',0),(374808,10412,'et','Saadud',0),(374809,10412,'si','Prejeli od',0),(374810,10412,'ba','Diterima dari',0),(374811,10412,'nl','Ontvangen',0),(374812,10412,'fi','Saadut',0),(374813,10412,'no','Mottatt fra',0),(374814,10412,'da','Modtaget fra',0),(374815,10412,'ko','ë°›ì€',0),(374816,10412,'he','×”×ª×§×‘×œ ×ž××ª',0),(374817,10412,'el','ÎˆÎ»Î±Î²Îµ Î±Ï€ÏŒ',0),(374818,10412,'zh','æ”¶æ¬¾é¡¹æ¥è‡ª\r\n',0),(374819,10412,'sv','FÃ¥tt frÃ¥n',0),(374820,10412,'it','Ricevuto da',0),(374821,10412,'tl','',0),(374822,10412,'th','à¹„à¸”à¹‰à¸£à¸±à¸šà¸ˆà¸²à¸',0),(374823,10412,'hi','à¤¸à¥‡ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(374824,10412,'ms','Diterima daripada',0),(374825,10412,'ar','ÙˆØªÙ„Ù‚Ù‰ Ù…Ù†',0),(374826,10412,'fr','ReÃ§u de',0),(374827,10412,'jp','å—ä¿¡ã—ã¾ã—ãŸã€‚',0),(374828,10412,'pt','Recebido de',0),(374829,10412,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ð» Ð¾Ñ‚',0),(374830,10412,'es','Recibido De',0),(374831,10412,'de','Erhielt von',0),(374832,10412,'en','Received From',0),(374833,10413,'is','',0),(374834,10413,'dr','Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(374835,10413,'pr','Ø±Ø¯ ÙƒØ±Ø¯Ù†',0),(374836,10413,'tr','Reddet',0),(374837,10413,'pl','OdrzuciÄ‡',0),(374838,10413,'bg','ÐžÑ‚Ñ…Ð²ÑŠÑ€Ð»Ð¸',0),(374839,10413,'ur','Ø±Ø¯ Ú©Ø±ÛŒÚº',0),(374840,10413,'sr','ÐžÐ´Ð±Ð°Ñ†Ð¸',0),(374841,10413,'vi','tá»« chá»‘i',0),(374842,10413,'af','Verwerp',0),(374843,10413,'ro','Respinge',0),(374844,10413,'et','LÃ¼kka tagasi',0),(374845,10413,'si','Zavrni',0),(374846,10413,'ba','Menolak',0),(374847,10413,'nl','Weigeren',0),(374848,10413,'fi','HylkÃ¤Ã¤',0),(374849,10413,'no','Avvis',0),(374850,10413,'da','Afvis',0),(374851,10413,'ko','ê±°ë¶€',0),(374852,10413,'he','×“×—×”',0),(374853,10413,'el','Î‘Ï€ÏŒÏÏÎ¹ÏˆÎ·',0),(374854,10413,'zh','æ‹’ç»\r\n',0),(374855,10413,'sv','Avvisa',0),(374856,10413,'it','Rifiutare',0),(374857,10413,'tl','',0),(374858,10413,'th','à¸›à¸à¸´à¹€à¸ªà¸˜',0),(374859,10413,'hi','à¤…à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤°à¥‡à¤‚',0),(374860,10413,'ms','Menolak',0),(374861,10413,'ar','Ø±ÙØ¶',0),(374862,10413,'fr','Rejeter',0),(374863,10413,'jp','æ‹’å¦ã—ã¾ã™ã€‚',0),(374864,10413,'pt','Rejeitar',0),(374865,10413,'ru','ÐžÑ‚ÐºÐ»Ð¾Ð½Ð¸Ñ‚ÑŒ',0),(374866,10413,'es','Rechazar',0),(374867,10413,'de','Ablehnen',0),(374868,10413,'en','Reject',0),(374869,10414,'is','',0),(374870,10414,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø± Ù„ÙŠØ³Øª ',0),(374871,10414,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø± Ù„ÙŠØ³Øª ',0),(374872,10414,'tr','Listedeki toplam',0),(374873,10414,'pl','W liÅ›cie',0),(374874,10414,'bg','ÐžÐ±Ñ‰Ð¾ Ð² ÑÐ¿Ð¸ÑÑŠÐºÐ°',0),(374875,10414,'ur','ÙÛØ±Ø³Øª Ù…ÛŒÚº Ú©Ù„',0),(374876,10414,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð½Ð° Ð»Ð¸ÑÑ‚Ð¸',0),(374877,10414,'vi','Tá»•ng cá»™ng trong danh sÃ¡ch',0),(374878,10414,'af','Totaal in Lys',0),(374879,10414,'ro','Total Ã®n lista',0),(374880,10414,'et','Kogu nimekirja',0),(374881,10414,'si','Skupni seznam',0),(374882,10414,'ba','Total dalam daftar',0),(374883,10414,'nl','Totaal in de lijst',0),(374884,10414,'fi','YhteensÃ¤ luettelossa',0),(374885,10414,'no','Totalt i listen',0),(374886,10414,'da','Samlede i listen',0),(374887,10414,'ko','ëª©ë¡ì—ì„œ ì´',0),(374888,10414,'he','×¡×” ×› ×‘×¨×©×™×ž×”',0),(374889,10414,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÏƒÏ„Î· Î»Î¯ÏƒÏ„Î±',0),(374890,10414,'zh','åˆ—è¡¨æ€»æ—¢\r\n',0),(374891,10414,'sv','Totalt pÃ¥ listan.',0),(374892,10414,'it','Totale nell\'elenco',0),(374893,10414,'tl','',0),(374894,10414,'th','à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¹ƒà¸™à¸£à¸²à¸¢à¸à¸²à¸£',0),(374895,10414,'hi','à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤•à¥à¤²',0),(374896,10414,'ms','Jumlah dalam senarai',0),(374897,10414,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ ÙÙŠ Ù‚Ø§Ø¦Ù…Ø©',0),(374898,10414,'fr','Total dans la liste',0),(374899,10414,'jp','ãƒªã‚¹ãƒˆã®åˆè¨ˆ',0),(374900,10414,'pt','Total na lista',0),(374901,10414,'ru','Ð’ÑÐµÐ³Ð¾ Ð² ÑÐ¿Ð¸ÑÐºÐµ',0),(374902,10414,'es','Total en Lista',0),(374903,10414,'de','Gesamt in Liste',0),(374904,10414,'en','Total in List',0),(374905,10415,'is','',0),(374906,10415,'dr','(Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡) Ø¨Ù‡',0),(374907,10415,'pr','Ø­ÙˆØ§Ù„Ù‡ Ø´Ø¯Ù‡ (Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡) Ø¨Ù‡',0),(374908,10415,'tr','Transfer',0),(374909,10415,'pl','Przeniesiony do',0),(374910,10415,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÐµÐ½Ð¸ ÐºÑŠÐ¼',0),(374911,10415,'ur','Ù…Ù†ØªÙ‚Ù„ Ú©Ø± Ø¯ÛŒØ§',0),(374912,10415,'sr','ÐŸÑ€ÐµÐ±Ð°Ñ‡ÐµÐ½ Ñƒ',0),(374913,10415,'vi','ÄÃ£ chuyá»ƒn Ä‘áº¿n',0),(374914,10415,'af','Oorgeplaas Na',0),(374915,10415,'ro','Transferat',0),(374916,10415,'et','Ãœle',0),(374917,10415,'si','Prenese na',0),(374918,10415,'ba','Ditransfer ke',0),(374919,10415,'nl','Overgedragen aan',0),(374920,10415,'fi','SiirretÃ¤Ã¤n',0),(374921,10415,'no','OverfÃ¸rt til',0),(374922,10415,'da','OverfÃ¸rt til',0),(374923,10415,'ko','ì „ì†¡',0),(374924,10415,'he','×”×•×¢×‘×¨',0),(374925,10415,'el','ÎœÎµÏ„Î±Ï†ÎµÏÎ¸ÎµÎ¯ ÏƒÎµ',0),(374926,10415,'zh','è½¬è‡³\r\n',0),(374927,10415,'sv','Ã–verfÃ¶ras till',0),(374928,10415,'it','Trasferito a',0),(374929,10415,'tl','',0),(374930,10415,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¹„à¸›',0),(374931,10415,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤¿à¤¤ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(374932,10415,'ms','Dipindahkan ke',0),(374933,10415,'ar','Ù†Ù‚Ù„ Ø¥Ù„Ù‰',0),(374934,10415,'fr','TransfÃ©rÃ© Ã ',0),(374935,10415,'jp','è»¢é€',0),(374936,10415,'pt','Transferido para',0),(374937,10415,'ru','ÐŸÐµÑ€ÐµÐ²ÐµÐ´ÐµÐ½ Ð²',0),(374938,10415,'es','Transferido A',0),(374939,10415,'de','Versetzt',0),(374940,10415,'en','Transferred To',0),(374941,10416,'is','',0),(374942,10416,'dr','(Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡) Ø¨Ù‡',0),(374943,10416,'pr','Ø­ÙˆØ§Ù„Ù‡ Ø´Ø¯Ù‡ (Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡) Ø¨Ù‡',0),(374944,10416,'tr','Kabul edilen aktarÄ±m',0),(374945,10416,'pl','Przeniesienia, zaakceptowany',0),(374946,10416,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¸ÐµÑ‚Ð¸Ñ‚Ðµ',0),(374947,10416,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©Û’ Ù‚Ø¨ÙˆÙ„ Ú©Ø± Ù„ÛŒØ§',0),(374948,10416,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ Ñ˜Ðµ Ð¿Ñ€Ð¸Ñ…Ð²Ð°Ñ‚Ð¸Ð¾',0),(374949,10416,'vi','ÄÃ£ cháº¥p nháº­n chuyá»ƒn',0),(374950,10416,'af','Oorgeplasing Aanvaar',0),(374951,10416,'ro','Transferul acceptate',0),(374952,10416,'et','Vastu Ã¼leandmine',0),(374953,10416,'si','Prenos sprejetih',0),(374954,10416,'ba','Transfer diterima',0),(374955,10416,'nl','Overdracht aanvaard',0),(374956,10416,'fi','SiirtÃ¤Ã¤ hyvÃ¤ksytyn',0),(374957,10416,'no','OverfÃ¸re godtatte',0),(374958,10416,'da','OverfÃ¸re accepterede',0),(374959,10416,'ko','ì „ì†¡ í—ˆìš©',0),(374960,10416,'he','×”×”×¢×‘×¨×” ×”×ª×§×‘×œ×”',0),(374961,10416,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ Î±Ï€Î¿Î´ÎµÎºÏ„Î®',0),(374962,10416,'zh','æŽ¥å—è½¬è®©\r\n',0),(374963,10416,'sv','Ã–verfÃ¶ra godtagna',0),(374964,10416,'it','Trasferimento accettato',0),(374965,10416,'tl','',0),(374966,10416,'th','à¸£à¸±à¸šà¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(374967,10416,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤¿à¤ à¤œà¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(374968,10416,'ms','Pindahan yang diterima',0),(374969,10416,'ar','Ù†Ù‚Ù„ Ø§Ù„Ù…Ù‚Ø¨ÙˆÙ„Ø©',0),(374970,10416,'fr','Transfert acceptÃ©',0),(374971,10416,'jp','æ‰¿èªæ¸ˆã¿ã®è»¢é€ã—ã¾ã™ã€‚',0),(374972,10416,'pt','TransferÃªncia aceitada',0),(374973,10416,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸ Ð² Ð¿Ñ€Ð¸Ð½ÑÑ‚',0),(374974,10416,'es','Transferencia Aceptada',0),(374975,10416,'de','Transfer akzeptiert',0),(374976,10416,'en','Transfer Accepted',0),(374977,10417,'is','',0),(374978,10417,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„ Ø¯Ø§Ø¯Ù†) ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ù† Ø¨Ù‡ Ø´Ø®Øµ Ø¯ÙŠÚ¯Ø± ',0),(374979,10417,'pr','Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„ Ø¯Ø§Ø¯Ù†) ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ù† Ø¨Ù‡ Ø´Ø®Øµ Ø¯ÙŠÚ¯Ø± ',0),(374980,10417,'tr','BaÅŸka birine benim para transferi',0),(374981,10417,'pl','PrzenieÅ›Ä‡ mojÄ… kasÄ™ do innej osoby',0),(374982,10417,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð¼Ð¸ Ð¿Ð°Ñ€Ð¸ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð¾ Ð»Ð¸Ñ†Ðµ',0),(374983,10417,'ur','Ú©Ø³ÛŒ Ø§ÙˆØ± Ø´Ø®Øµ Ú©Ùˆ Ù…ÛŒØ±ÛŒ Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(374984,10417,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ Ð¼Ð¾Ñ˜ Ð½Ð¾Ð²Ð°Ñ† Ð´Ñ€ÑƒÐ³Ð¾Ñ˜ Ð¾ÑÐ¾Ð±Ð¸',0),(374985,10417,'vi','Chuyá»ƒn tiá»n máº·t cá»§a tÃ´i cho ngÆ°á»i khÃ¡c',0),(374986,10417,'af','Oorplasing - My Kontant na \'n Ander Persoon',0),(374987,10417,'ro','Transfera numerar meu la o altÄƒ persoanÄƒ',0),(374988,10417,'et','Minu raha teisele isikule Ã¼le anda',0),(374989,10417,'si','Prenos gotovine na drugo osebo',0),(374990,10417,'ba','Transfer tunai saya kepada orang lain',0),(374991,10417,'nl','Mijn geld overbrengen naar een andere persoon',0),(374992,10417,'fi','SiirtÃ¤Ã¤ rahani toiselle henkilÃ¶lle',0),(374993,10417,'no','OverfÃ¸re mine penger til en annen Person',0),(374994,10417,'da','OverfÃ¸re mine penge til en anden Person',0),(374995,10417,'ko','ë‹¤ë¥¸ ì‚¬ëžŒì— ê²Œ ë‚´ í˜„ê¸ˆì„ ì „ì†¡í•©ë‹ˆë‹¤',0),(374996,10417,'he','×”×¢×‘×¨×ª ×›×¡×¤×™ ×œ××“× ××—×¨',0),(374997,10417,'el','ÎœÎµÏ„Î±Ï†Î­ÏÎµÏ„Îµ Î¼ÎµÏ„ÏÎ·Ï„Î¬ Î¼Î¿Ï… ÏƒÎµ Î¬Î»Î»Î¿ Ï€ÏÏŒÏƒÏ‰Ï€Î¿',0),(374998,10417,'zh','æˆ‘çš„çŽ°é‡‘è½¬ç§»ç»™ä»–äºº\r\n',0),(374999,10417,'sv','Ã–verfÃ¶ra mina pengar till en annan Person',0),(375000,10417,'it','Trasferire il mio denaro ad un\'altra persona',0),(375001,10417,'tl','',0),(375002,10417,'th','à¹‚à¸­à¸™à¹€à¸‡à¸´à¸™à¹ƒà¸«à¹‰à¸šà¸¸à¸„à¸„à¸¥à¸­à¸·à¹ˆà¸™',0),(375003,10417,'hi','à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿ à¤•à¥‹ à¤®à¥‡à¤°à¥‡ à¤¨à¤•à¤¦ à¤…à¤‚à¤¤à¤°à¤£',0),(375004,10417,'ms','Pindahan tunai saya kepada orang lain',0),(375005,10417,'ar','Ù†Ù‚Ù„ Ø¨Ù„Ø¯ÙŠ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø¥Ù„Ù‰ Ø´Ø®Øµ Ø¢Ø®Ø±',0),(375006,10417,'fr','TransfÃ©rer mon argent Ã  une autre personne',0),(375007,10417,'jp','ä»–ã®äººã«ç§ã®ç¾é‡‘ã‚’è»¢é€ã—ã¾ã™ã€‚',0),(375008,10417,'pt','Transferir meu dinheiro para outra pessoa',0),(375009,10417,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‚ÑŒ Ð´ÐµÐ½ÑŒÐ³Ð¸ Ð´Ñ€ÑƒÐ³Ð¾Ð¼Ñƒ Ð»Ð¸Ñ†Ñƒ',0),(375010,10417,'es','Transfier Mi Efectivo a Otra Persona',0),(375011,10417,'de','Mein Geld auf eine andere Person Ã¼bertragen',0),(375012,10417,'en','Transfer My Cash to Another Person',0),(375013,10418,'is','',0),(375014,10418,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„) ØªØ¹ÙˆÛŒÙ‚',0),(375015,10418,'pr','Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„) Ù…Ø¹ÙˆÙ‚',0),(375016,10418,'tr','Bekleyen AktarÄ±m',0),(375017,10418,'pl','PrzesyÅ‚ania oczekujÄ…cych',0),(375018,10418,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð½Ð° Ð²Ð¸ÑÑÑ‰Ð¾',0),(375019,10418,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(375020,10418,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(375021,10418,'vi','Chá» chuyá»ƒn',0),(375022,10418,'af','Oordrag Afwagtend',0),(375023,10418,'ro','Transfera Ã®n aÅŸteptare',0),(375024,10418,'et','Transfer ootel',0),(375025,10418,'si','Prenos ÄakajoÄih',0),(375026,10418,'ba','Mentransfer tertunda',0),(375027,10418,'nl','Transfer in behandeling',0),(375028,10418,'fi','SiirtÃ¤Ã¤ vireillÃ¤',0),(375029,10418,'no','OverfÃ¸re ventende',0),(375030,10418,'da','OverfÃ¸re ventende',0),(375031,10418,'ko','ì „ì†¡ ë³´ë¥˜ ì¤‘',0),(375032,10418,'he','×”×¢×‘×¨×” ×ž×ž×ª×™× ×”',0),(375033,10418,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î±',0),(375034,10418,'zh','å¾…è½¬è®©\r\n',0),(375035,10418,'sv','Ã–verfÃ¶ra vÃ¤ntande',0),(375036,10418,'it','Trasferimento in sospeso',0),(375037,10418,'tl','',0),(375038,10418,'th','à¸–à¹ˆà¸²à¸¢à¹‚à¸­à¸™à¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(375039,10418,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£',0),(375040,10418,'ms','Pemindahan belum selesai',0),(375041,10418,'ar','Ù†Ù‚Ù„ Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(375042,10418,'fr','En attente de transfert',0),(375043,10418,'jp','ä¿ç•™ä¸­ã®è»¢é€ã—ã¾ã™ã€‚',0),(375044,10418,'pt','TransferÃªncia pendente',0),(375045,10418,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‡Ð° Ð´Ð¾',0),(375046,10418,'es','Transferencia Pendiente',0),(375047,10418,'de','Ausstehende Ã¼bertragen',0),(375048,10418,'en','Transfer Pending',0),(375049,10419,'is','',0),(375050,10419,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(375051,10419,'pr','Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(375052,10419,'tr','Transfer reddetti',0),(375053,10419,'pl','Przeniesienie odrzucone',0),(375054,10419,'bg','Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€ Ð½Ð° Ð¾Ñ‚Ñ…Ð²ÑŠÑ€Ð»ÐµÐ½Ð¸',0),(375055,10419,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©Ùˆ Ù…Ø³ØªØ±Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(375056,10419,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½',0),(375057,10419,'vi','Tá»« chá»‘i chuyá»ƒn',0),(375058,10419,'af','Oordrag Afgekeer',0),(375059,10419,'ro','Transferul respins',0),(375060,10419,'et','Ãœleandmine lÃ¼katakse tagasi',0),(375061,10419,'si','Prenos zavrnjena',0),(375062,10419,'ba','Transfer ditolak',0),(375063,10419,'nl','Overdracht verworpen',0),(375064,10419,'fi','Kuljetus hylkÃ¤si',0),(375065,10419,'no','OverfÃ¸re avvist',0),(375066,10419,'da','OverfÃ¸rsel afvist',0),(375067,10419,'ko','ì „ì†¡ ê±°ë¶€',0),(375068,10419,'he','×”×¢×‘×¨×ª ×“×—×”',0),(375069,10419,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ Î±Ï€Î­ÏÏÎ¹ÏˆÎµ',0),(375070,10419,'zh','æ‹’ç»ç§»äº¤\r\n',0),(375071,10419,'sv','Ã–verfÃ¶ring avvisade',0),(375072,10419,'it','Trasferimento rifiutato',0),(375073,10419,'tl','',0),(375074,10419,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸›à¸à¸´à¹€à¸ªà¸˜',0),(375075,10419,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤•à¥‹ à¤–à¤¾à¤°à¤¿à¤œ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(375076,10419,'ms','Pemindahan ditolak',0),(375077,10419,'ar','ÙˆØ±ÙØ¶ Ù†Ù‚Ù„',0),(375078,10419,'fr','Transfert a rejetÃ©',0),(375079,10419,'jp','è»¢é€ã‚’æ‹’å¦',0),(375080,10419,'pt','TransferÃªncia rejeitada',0),(375081,10419,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‡Ð° Ð¾Ñ‚ÐºÐ»Ð¾Ð½Ð¸Ð»',0),(375082,10419,'es','Transferencia Rechazada',0),(375083,10419,'de','Transfer abgelehnt',0),(375084,10419,'en','Transfer Rejected',0),(375085,10420,'is','',0),(375086,10420,'dr','Ù†Ù…Ø§ÙŠØ´ Ù‡Ù…Ù‡ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª ÙˆØ¬Ù‡ Ù†Ù‚Ø¯',0),(375087,10420,'pr','Ù†Ù…Ø§ÙŠØ´ Ù‡Ù…Ù‡ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª ÙˆØ¬Ù‡ Ù†Ù‚Ø¯',0),(375088,10420,'tr','TÃ¼m nakit transferleri gÃ¶rÃ¼ntÃ¼leyin',0),(375089,10420,'pl','Zobacz wszystkie przelewy pieniÄ™Å¼ne',0),(375090,10420,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(375091,10420,'ur','Ø³Ø§Ø±ÛŒ Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©Ø§ Ù…Ù†Ø¸Ø± Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(375092,10420,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÑÐ²Ð¸Ñ… Ð½Ð¾Ð²Ñ‡Ð°Ð½Ðµ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ðµ',0),(375093,10420,'vi','Xem táº¥t cáº£ cÃ¡c lá»‡nh chuyá»ƒn tiá»n máº·t',0),(375094,10420,'af','Besigtig ALLE Kontant Oorplasings',0),(375095,10420,'ro','Vezi toate transferurile de numerar',0),(375096,10420,'et','Vaata kÃµiki rahaÃ¼lekandeid',0),(375097,10420,'si','Poglej si vse denarne transferje',0),(375098,10420,'ba','Lihat semua transfer uang tunai',0),(375099,10420,'nl','Bekijk alle Cash Transfers',0),(375100,10420,'fi','Katso kaikki tulonsiirrot',0),(375101,10420,'no','Vis alle pengeoverfÃ¸ringer',0),(375102,10420,'da','Se alle kontante overfÃ¸rsler',0),(375103,10420,'ko','ëª¨ë“  í˜„ê¸ˆ ì´ì²´ë¥¼ ë³´ê¸°',0),(375104,10420,'he','×”×¦×’ ××ª ×›×œ ×”×¢×‘×¨×•×ª ×ž×–×•×ž×Ÿ',0),(375105,10420,'el','Î”ÎµÎ¯Ï„Îµ ÎŒÎ›Î•Î£ Ï„Î¹Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Ï‚ Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½',0),(375106,10420,'zh','æŸ¥çœ‹æ‰€æœ‰çš„çŽ°é‡‘è½¬ç§»\r\n',0),(375107,10420,'sv','Visa alla Transfereringssystemen',0),(375108,10420,'it','Mostra tutti i trasferimenti di denaro',0),(375109,10420,'tl','',0),(375110,10420,'th','à¸”à¸¹à¹‚à¸­à¸™à¹€à¸‡à¸´à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(375111,10420,'hi','à¤¸à¤­à¥€ à¤¨à¤•à¤¦à¥€ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¥‡à¤–à¥‡à¤‚',0),(375112,10420,'ms','Lihat semua pemindahan wang tunai',0),(375113,10420,'ar','Ø¹Ø±Ø¶ ÙƒÙ„ Ø§Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(375114,10420,'fr','DÃ©couvre tous les transferts en espÃ¨ces',0),(375115,10420,'jp','ã™ã¹ã¦ã®ç¾é‡‘è»¢é€ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(375116,10420,'pt','Ver os todas as transferÃªncias de dinheiro',0),(375117,10420,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð²ÑÐµ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ñ‹',0),(375118,10420,'es','Visionar TODAS las Transferencias de Efectivo',0),(375119,10420,'de','Zeigen Sie aller Transferzahlungen an',0),(375120,10420,'en','View ALL Cash Transfers',0),(375121,10421,'is','',0),(375122,10421,'dr','Ù†Ù…Ø§ÙŠØ´ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ø´Ø¯Ù‡ Ù…Ù†',0),(375123,10421,'pr','Ù†Ù…Ø§ÙŠØ´ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ø´Ø¯Ù‡ Ù…Ù†',0),(375124,10421,'tr','ParamÄ± kabul gÃ¶rmek',0),(375125,10421,'pl','Zobacz mojÄ… kasÄ™ akceptowane',0),(375126,10421,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¼Ð¸ Ð¿Ð°Ñ€Ð¸ Ð¿Ñ€Ð¸ÐµÐ¼Ð°Ñ‚',0),(375127,10421,'ur','Ù…Ù†Ø¸Ø± Ù…ÛŒØ±Û’ Ú©ÛŒØ´ Ù‚Ø¨ÙˆÙ„ Ú©Ø± Ù„ÛŒØ§',0),(375128,10421,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ñ€Ð¸Ñ…Ð²Ð°Ñ‚Ð¸Ð»Ð° Ð¼Ð¾Ñ˜Ðµ Ð¿Ð°Ñ€Ðµ',0),(375129,10421,'vi','Xem tiá»n cá»§a tÃ´i Ä‘Æ°á»£c cháº¥p nháº­n',0),(375130,10421,'af','Besigtig My Kontant Aanvaar',0),(375131,10421,'ro','Vezi meu bani acceptat',0),(375132,10421,'et','Vaata minu raha vastu',0),(375133,10421,'si','Poglej si svoj denar, sprejete',0),(375134,10421,'ba','Lihat saya uang tunai yang diterima',0),(375135,10421,'nl','Weergave mijn contant geld geaccepteerd',0),(375136,10421,'fi','Katso rahani hyvÃ¤ksytty',0),(375137,10421,'no','Vis mine penger akseptert',0),(375138,10421,'da','Se mine kontanter accepteret',0),(375139,10421,'ko','ë³´ê¸° ë‚´ í˜„ê¸ˆì„ ìˆ˜ë½',0),(375140,10421,'he','×”×¦×’ ××ª ×”×ž×–×•×ž×Ÿ ×©×œ×™ ×§×™×‘×œ',0),(375141,10421,'el','Î”ÎµÎ¯Ï„Îµ Î¼ÎµÏ„ÏÎ·Ï„Î¬ Î¼Î¿Ï… Î±Ï€Î¿Î´ÎµÎºÏ„Î­Ï‚',0),(375142,10421,'zh','æŸ¥çœ‹æˆ‘è¢«æŽ¥å—çš„çŽ°é‡‘\r\n',0),(375143,10421,'sv','Visa min kontanter accepteras',0),(375144,10421,'it','Mostra i miei contanti accettati',0),(375145,10421,'tl','',0),(375146,10421,'th','à¸”à¸¹à¹€à¸‡à¸´à¸™à¸¢à¸­à¸¡à¸£à¸±à¸š',0),(375147,10421,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤®à¥‡à¤°à¥‡ à¤¨à¤•à¤¦ à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤¿à¤ à¤œà¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(375148,10421,'ms','Melihat saya tunai yang diterima',0),(375149,10421,'ar','Ø¹Ø±Ø¶ Ø¨Ù„Ø¯ÙŠ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø§Ù„Ù…Ù‚Ø¨ÙˆÙ„Ø©',0),(375150,10421,'fr','DÃ©couvre mon Cash acceptÃ©s',0),(375151,10421,'jp','ãƒ“ãƒ¥ãƒ¼ã®ç§ã®ç¾é‡‘ã®å—ã‘å…¥ã‚Œ',0),(375152,10421,'pt','Ver os meu dinheiro aceitado',0),(375153,10421,'ru','Ð’Ð¸Ð´ Ð¼Ð¾Ð¹ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ð¼Ð¸',0),(375154,10421,'es','Visionar Mi Efectivo Aceptado',0),(375155,10421,'de','Zeigen Sie mein Bargeld akzeptiert an',0),(375156,10421,'en','View My Cash Accepted',0),(375157,10422,'is','',0),(375158,10422,'dr','Ù†Ù…Ø§ÙŠØ´ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡ Ù…Ù†',0),(375159,10422,'pr','Ù†Ù…Ø§ÙŠØ´ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡ Ù…Ù†',0),(375160,10422,'tr','Benim nakit transferleri gÃ¶rÃ¼ntÃ¼leyin',0),(375161,10422,'pl','Zobacz mÃ³j przelewy pieniÄ™Å¼ne',0),(375162,10422,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¼Ð¸ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(375163,10422,'ur','Ù…ÛŒØ±ÛŒ Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©Ø§ Ù…Ù†Ø¸Ø± Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(375164,10422,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¼Ð¾Ñ˜Ðµ Ð½Ð¾Ð²Ñ‡Ð°Ð½Ðµ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ðµ',0),(375165,10422,'vi','Xem cÃ¡c lá»‡nh chuyá»ƒn tiá»n cáº£u tÃ´i',0),(375166,10422,'af','Besigtig My Kontant Oorplasings',0),(375167,10422,'ro','Vezi transferuri de numerar meu',0),(375168,10422,'et','Vaata minu rahaÃ¼lekandeid',0),(375169,10422,'si','Poglej si svoj denar transferjev',0),(375170,10422,'ba','Lihat saya transfer uang tunai',0),(375171,10422,'nl','Bekijk mijn geld-overdrachten',0),(375172,10422,'fi','Katso minun tulonsiirrot',0),(375173,10422,'no','Vis min pengeoverfÃ¸ringer',0),(375174,10422,'da','Se min kontante overfÃ¸rsler',0),(375175,10422,'ko','ë‚´ í˜„ê¸ˆ ì´ì²´ë¥¼ ë³´ê¸°',0),(375176,10422,'he','×”×¦×’ ××ª ×”×¢×‘×¨×•×ª ×”×ž×–×•×ž× ×™× ×©×œ×™',0),(375177,10422,'el','Î”ÎµÏ‚ Î¼Î¿Ï… Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚ Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½',0),(375178,10422,'zh','æŸ¥çœ‹æˆ‘çš„çŽ°é‡‘è½¬ç§»\r\n',0),(375179,10422,'sv','Visa min Transfereringssystemen',0),(375180,10422,'it','Mostra i miei trasferimenti di denaro',0),(375181,10422,'tl','',0),(375182,10422,'th','à¸”à¸¹à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(375183,10422,'hi','à¤®à¥‡à¤°à¥‡ à¤ªà¥ˆà¤¸à¥‡ à¤•à¥‡ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡',0),(375184,10422,'ms','Melihat saya pemindahan wang tunai',0),(375185,10422,'ar','Ø¹Ø±Ø¶ Ø¨Ù„Ø¯ÙŠ Ø§Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(375186,10422,'fr','DÃ©couvre mes transferts en espÃ¨ces',0),(375187,10422,'jp','ç§ã®ç¾é‡‘è»¢é€ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(375188,10422,'pt','Ver os meus transferÃªncias de dinheiro',0),(375189,10422,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð¼Ð¾Ð¸ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ñ‹',0),(375190,10422,'es','Visionar Mis Transferencias de Efectivo',0),(375191,10422,'de','Meine BarÃ¼berweisungen anzeigen',0),(375192,10422,'en','View My Cash Transfers',0),(375193,10423,'is','',0),(375194,10423,'dr','Ù†Ù…Ø§ÙŠØ´ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø² Ø·Ø±Ù Ù…Ù†',0),(375195,10423,'pr','Ù†Ù…Ø§ÙŠØ´ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø² Ø·Ø±Ù Ù…Ù†',0),(375196,10423,'tr','Beni transfer gÃ¶rÃ¼nÃ¼mÃ¼ reddetti',0),(375197,10423,'pl','Widok odrzucony przelew ode mnie',0),(375198,10423,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ…Ð²ÑŠÑ€Ð»ÐµÐ½Ð¸ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸ Ð¾Ñ‚ Ð¼ÐµÐ½',0),(375199,10423,'ur','Ù…Ø¬Ú¾ Ø³Û’ Ù¹Ø±Ø§Ù†Ø³ÙØ± Ù†Ù‚Ø·Û Ù†Ø¸Ø± Ú©Ùˆ Ù…Ø³ØªØ±Ø¯ Ú©Ø± Ø¯ÛŒØ§ Û”',0),(375200,10423,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ˜Ðµ Ð¾Ð´Ð±Ð°Ñ†Ð¸Ð¾ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸ Ð¾Ð´ Ð¼ÐµÐ½Ðµ',0),(375201,10423,'vi','Xem cÃ¡c lá»‡nh chuyá»ƒn Ä‘Ã£ bá»‹ tá»« chá»‘i tá»« tÃ´i',0),(375202,10423,'af','Besigtig Verwerpte Oorplasings Van My Af',0),(375203,10423,'ro','Vezi transferuri de la mine a respins',0),(375204,10423,'et','Vaata minu poolt tagasilÃ¼katud Ã¼lekannete aruannet',0),(375205,10423,'si','Ogled zavrnjenih prenose od mene',0),(375206,10423,'ba','Lihat ditolak transfer dari saya',0),(375207,10423,'nl','Weergave verworpen Transfers van mij',0),(375208,10423,'fi','NÃ¤ytÃ¤ hylÃ¤tyt siirrot minulta',0),(375209,10423,'no','Vis avviste overfÃ¸ringer fra meg',0),(375210,10423,'da','Se afviste overfÃ¸rsler fra mig',0),(375211,10423,'ko','ë³´ê¸° ë‚´ì—ì„œ ê±°ë¶€',0),(375212,10423,'he','×ª×¦×•×’×ª ×“×—×” ×”×¢×‘×¨×•×ª ×ž×ž× ×™',0),(375213,10423,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Ï€Î­ÏÏÎ¹ÏˆÎµ Î¼ÎµÏ„Î±Î²Î¹Î²Î¬ÏƒÎµÎ¹Ï‚ Î±Ï€ÏŒ Î¼Î­Î½Î±',0),(375214,10423,'zh','æŸ¥çœ‹æ¥è‡ªæˆ‘çš„è¢«æ‹’ç»è½¬ç§»\r\n',0),(375215,10423,'sv','Visa avvisade Ã¶verfÃ¶ringar frÃ¥n mig',0),(375216,10423,'it','Vista rifiutato trasferimenti da Me',0),(375217,10423,'tl','',0),(375218,10423,'th','à¸”à¸¹à¸›à¸à¸´à¹€à¸ªà¸˜à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸ˆà¸²à¸',0),(375219,10423,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤¨à¥à¤¤à¤°à¤£ à¤®à¥à¤ à¤¸à¥‡ à¤–à¤¾à¤°à¤¿à¤œ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(375220,10423,'ms','Pandangan menolak pemindahan dari saya',0),(375221,10423,'ar','ÙˆØ±ÙØ¶ Ø¹Ø±Ø¶ Ø§Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª Ù…Ù† Ù„ÙŠ',0),(375222,10423,'fr','Vue rejetÃ© transferts de moi',0),(375223,10423,'jp','ãƒ“ãƒ¥ãƒ¼ã¯ç§ã‹ã‚‰è»¢é€ã‚’æ‹’å¦ã•ã‚Œã¾ã™ã€‚',0),(375224,10423,'pt','Vista rejeitou as transferÃªncias de mim',0),(375225,10423,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¾Ñ‚ÐºÐ»Ð¾Ð½Ð¸Ð» Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ñ‹ Ð¾Ñ‚ Ð¼ÐµÐ½Ñ',0),(375226,10423,'es','Visionar Transferencias Rechazadas de Mi',0),(375227,10423,'de','Ansicht abgelehnt Transfers von mir',0),(375228,10423,'en','View Rejected Transfers From Me',0),(375229,10424,'is','',0),(375230,10424,'dr','ÙƒØ¯Ø§Ù… ÙØ¹Ø§Ù„ÙŠØª ',0),(375231,10424,'pr','ÙƒØ¯Ø§Ù… ÙØ¹Ø§Ù„ÙŠØª ',0),(375232,10424,'tr','Ne eylem',0),(375233,10424,'pl','Jakie dziaÅ‚ania',0),(375234,10424,'bg','ÐšÐ°ÐºÐ²Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(375235,10424,'ur','Ø¹Ù…Ù„',0),(375236,10424,'sr','ÐšÐ°ÐºÐ²Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ñƒ',0),(375237,10424,'vi','HÃ nh Ä‘á»™ng nÃ o',0),(375238,10424,'af','Watter Aksie',0),(375239,10424,'ro','Ce acÅ£iuni',0),(375240,10424,'et','Mis toiming',0),(375241,10424,'si','KakÅ¡ne ukrepe',0),(375242,10424,'ba','Apa tindakan',0),(375243,10424,'nl','Welke maatregelen',0),(375244,10424,'fi','Mihin toimiin',0),(375245,10424,'no','Hva',0),(375246,10424,'da','Hvilke foranstaltninger',0),(375247,10424,'ko','ìž‘ì—…',0),(375248,10424,'he','××™×–×• ×¤×¢×•×œ×”',0),(375249,10424,'el','Î¤Î¹ Î´ÏÎ¬ÏƒÎ·',0),(375250,10424,'zh','ä»€ä¹ˆè¡ŒåŠ¨\r\n',0),(375251,10424,'sv','Vilka Ã¥tgÃ¤rder',0),(375252,10424,'it','Quale azione',0),(375253,10424,'tl','',0),(375254,10424,'th','à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£',0),(375255,10424,'hi','à¤•à¥à¤¯à¤¾ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(375256,10424,'ms','Apakah tindakan',0),(375257,10424,'ar','Ù…Ø§ Ù‡ÙŠ Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª',0),(375258,10424,'fr','Quelles mesures',0),(375259,10424,'jp','ã©ã®ã‚ˆã†ãªè¡Œå‹•',0),(375260,10424,'pt','Que aÃ§Ã£o',0),(375261,10424,'ru','ÐšÐ°ÐºÐ¾Ðµ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(375262,10424,'es','Cual AcciÃ³n',0),(375263,10424,'de','Welche MaÃŸnahmen',0),(375264,10424,'en','What Action',0),(375265,10425,'is','',0),(375266,10425,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø± Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ ',0),(375267,10425,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·Ø± Ù‚ÙŠÙ…Øª Ø¬Ø¯ÙŠØ¯ ',0),(375268,10425,'tr','Maliyet satÄ±rÄ± ekleyin',0),(375269,10425,'pl','DodaÄ‡ nowy wiersz kosztÃ³w',0),(375270,10425,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¸ÐºÐ¾Ð½Ð¾Ð¼Ð¸Ñ‡ÐµÑÐºÐ¸ Ñ€ÐµÐ´',0),(375271,10425,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª Ù„Ø§Ø¦Ù† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(375272,10425,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ñ€ÐµÐ´Ð°',0),(375273,10425,'vi','ThÃªm dÃ²ng cost má»›i',0),(375274,10425,'af','Nuwe Koste Lyn Byvoeg',0),(375275,10425,'ro','Adauga noi linii de Cost',0),(375276,10425,'et','Uus kulu rea lisamine',0),(375277,10425,'si','Dodajte novo vrstico stroÅ¡kovno',0),(375278,10425,'ba','Menambahkan baris baru biaya',0),(375279,10425,'nl','Nieuwe kosten regel toevoegen',0),(375280,10425,'fi','LisÃ¤Ã¤ uusi kustannusrivi',0),(375281,10425,'no','Legge til ny pris linje',0),(375282,10425,'da','TilfÃ¸je nye omkostninger linje',0),(375283,10425,'ko','ìƒˆë¡œìš´ ë¹„ìš© ì¶”ê°€',0),(375284,10425,'he','×”×•×¡×£ ×©×•×¨×ª ×¢×œ×•×ª ×—×“×©×”',0),(375285,10425,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î³ÏÎ±Î¼Î¼Î® ÎºÏŒÏƒÏ„Î¿Ï‚',0),(375286,10425,'zh','å¢žåŠ æ–°æˆæœ¬çº¿\r\n',0),(375287,10425,'sv','LÃ¤gg till ny kostnad rad',0),(375288,10425,'it','Aggiungi nuova linea costo',0),(375289,10425,'tl','',0),(375290,10425,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸£à¸£à¸—à¸±à¸”à¸•à¹‰à¸™à¸—à¸¸à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(375291,10425,'hi','à¤¨à¤ à¤²à¤¾à¤—à¤¤ à¤°à¥‡à¤–à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(375292,10425,'ms','Tambah Line baru yang kos',0),(375293,10425,'ar','Ø¥Ø¶Ø§ÙØ© Ø³Ø·Ø± Ø¬Ø¯ÙŠØ¯ ÙÙŠ Ø§Ù„ØªÙƒÙ„ÙØ©',0),(375294,10425,'fr','Ajouter la nouvelle ligne de coÃ»t',0),(375295,10425,'jp','è¿½åŠ ã™ã‚‹æ–°ã—ã„ã‚³ã‚¹ãƒˆè¡Œ',0),(375296,10425,'pt','Adicionar nova linha de custo',0),(375297,10425,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ ÑÑ‚Ñ€Ð¾ÐºÐ¸',0),(375298,10425,'es','Agregar Nueva Linea de Costo',0),(375299,10425,'de','FÃ¼gen Sie neue Kosten Zeile',0),(375300,10425,'en','Add New Cost Line',0),(375301,10426,'is','',0),(375302,10426,'dr','(Ø¨Ø±Ø§Øª)Ù‚Ø±Ø¹Ù‡ Ú©Ø´Ù‰',0),(375303,10426,'pr','ØªØ§Ø±ÙŠØ® (Ø¨Ø±Ø§Øª)Ù‚Ø±Ø¹Ù‡ Ú©Ø´Ù‰',0),(375304,10426,'tr','Tarihi Ã§izmek',0),(375305,10426,'pl','Data losowania',0),(375306,10426,'bg','Ð–Ñ€ÐµÐ±Ð¸ÑÑ‚ Ð´Ð°Ñ‚Ð°',0),(375307,10426,'ur','ØªØ§Ø±ÛŒØ® ÚˆØ±Ø§',0),(375308,10426,'sr','ÐÐ°Ñ†Ñ€Ñ‚Ð°Ñ˜ Ð´Ð°Ñ‚ÑƒÐ¼',0),(375309,10426,'vi','NgÃ y má»Ÿ sá»‘',0),(375310,10426,'af','Teken die datum',0),(375311,10426,'ro','Draw data',0),(375312,10426,'et','Juhtida kuupÃ¤eva',0),(375313,10426,'si','Pripravi datum',0),(375314,10426,'ba','Draw tanggal',0),(375315,10426,'nl','Draw datum',0),(375316,10426,'fi','KiinnittÃ¤Ã¤ pÃ¤ivÃ¤',0),(375317,10426,'no','Trekke dato',0),(375318,10426,'da','LodtrÃ¦knings dato',0),(375319,10426,'ko','ì¶”ì²¨ì¼',0),(375320,10426,'he','×œ×¦×™×™×¨ ×ª××¨×™×š',0),(375321,10426,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ»Î®ÏÏ‰ÏƒÎ·',0),(375322,10426,'zh','ç»˜åˆ¶æ—¥æœŸ\r\n',0),(375323,10426,'sv','Rita datum',0),(375324,10426,'it','Data sorteggio',0),(375325,10426,'tl','',0),(375326,10426,'th','à¸§à¸±à¸™à¸­à¸­à¸',0),(375327,10426,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤¡à¥à¤°à¤¾',0),(375328,10426,'ms','Tarikh yang menarik',0),(375329,10426,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø³Ø­Ø¨',0),(375330,10426,'fr','Date du tirage',0),(375331,10426,'jp','æŠ½é¸æ—¥',0),(375332,10426,'pt','Data do sorteio',0),(375333,10426,'ru','ÐÐ°Ñ€Ð¸ÑÑƒÐ¹Ñ‚Ðµ Ð”Ð°Ñ‚Ð°',0),(375334,10426,'es','Fecha de Quito',0),(375335,10426,'de','Ziehungsdatum',0),(375336,10426,'en','Draw Date',0),(375337,10427,'is','',0),(375338,10427,'dr','(Ù‚Ø±Ø¹Ù‡ ÙƒØ´ÙŠ ',0),(375339,10427,'pr','Ø´ØºÙ„ Ø±ÙˆÙŠ Ù†Ù…ÙˆØ¯Ø§Ø±(Ù‚Ø±Ø¹Ù‡ ÙƒØ´ÙŠ ',0),(375340,10427,'tr','Beraberlik iÅŸleri',0),(375341,10427,'pl','Praca na remis',0),(375342,10427,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð¼ÐµÑÑ‚Ð° Ð½Ð° Ñ‚ÐµÐ³Ð»ÐµÐ½Ðµ',0),(375343,10427,'ur','ÚˆØ±Ø§ Ù¾Ø± Ù†ÙˆÚ©Ø±ÛŒØ§Úº',0),(375344,10427,'sr','ÐŸÐ¾ÑÐ»Ð¾Ð²Ð¸ Ð½Ð° Ð”Ñ€Ð°w',0),(375345,10427,'vi','báº£ng váº½ cÃ´ng viá»‡c',0),(375346,10427,'af','Kontrakwerke op  ',0),(375347,10427,'ro','Locuri de munca pe Draw',0),(375348,10427,'et','TÃ¶Ã¶kohti on juhtida',0),(375349,10427,'si','Delovna mesta na pripravi',0),(375350,10427,'ba','Pekerjaan menarik',0),(375351,10427,'nl','Banen op Draw',0),(375352,10427,'fi','TyÃ¶paikkoja tehdÃ¤',0),(375353,10427,'no','Jobber pÃ¥ uavgjort',0),(375354,10427,'da','Job pÃ¥ uafgjort',0),(375355,10427,'ko','ê·¸ë¦¬ê¸° ìž‘ì—…',0),(375356,10427,'he','×¢×‘×•×“×•×ª ×¢×œ ×ª×™×§×•',0),(375357,10427,'el','Î˜Î­ÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÏƒÏ„Î·Î½ ÎºÎ»Î®ÏÏ‰ÏƒÎ·',0),(375358,10427,'zh','å·¥ä½œå‡†å¤‡\r\n',0),(375359,10427,'sv','Jobb pÃ¥ oavgjort',0),(375360,10427,'it','Lavori sul pareggio',0),(375361,10427,'tl','',0),(375362,10427,'th','à¸‡à¸²à¸™à¹ƒà¸™à¸à¸²à¸£à¸§à¸²à¸”',0),(375363,10427,'hi','à¤¡à¥à¤°à¤¾ à¤ªà¤° à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¤¾à¤‚',0),(375364,10427,'ms','Pekerjaan pada cabutan',0),(375365,10427,'ar','ÙˆØ¸Ø§Ø¦Ù ÙÙŠ Ø±Ø³Ù…',0),(375366,10427,'fr','Emplois sur tirage au sort',0),(375367,10427,'jp','æç”»ä¸Šã®ã‚¸ãƒ§ãƒ–',0),(375368,10427,'pt','Empregos no sorteio',0),(375369,10427,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð½Ð° ÐºÑ€ÑƒÐ³Ðµ',0),(375370,10427,'es','Trabajos Pagados por Adelantados',0),(375371,10427,'de','Jobs auf Unentschieden',0),(375372,10427,'en','Jobs on Draw',0),(375373,10428,'is','',0),(375374,10428,'dr','Ù‡ÙŠÚ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(375375,10428,'pr','Ù‡ÙŠÚ† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(375376,10428,'tr','Fatura bulundu',0),(375377,10428,'pl','Rachunki, nie znaleziono',0),(375378,10428,'bg','ÐÑÐ¼Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸',0),(375379,10428,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ù„ Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(375380,10428,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(375381,10428,'vi','khÃ´ng tÃ¬m tháº¥y hÃ³a Ä‘Æ¡n',0),(375382,10428,'af','Geen Rekeninge Gevind',0),(375383,10428,'ro','Nici facturile gÄƒsit',0),(375384,10428,'et','Ei leidnud arved',0),(375385,10428,'si','Ni raÄunov naÅ¡el',0),(375386,10428,'ba','Tagihan tidak ditemukan',0),(375387,10428,'nl','Geen rekeningen gevonden',0),(375388,10428,'fi','Ei laskuja lÃ¶ytyi',0),(375389,10428,'no','Ingen regninger funnet',0),(375390,10428,'da','Ingen regninger fundet',0),(375391,10428,'ko','ì•„ë¬´ ê³„ì‚° ì„œ ë°œê²¬',0),(375392,10428,'he','×‘×œ×™ ×—×©×‘×•× ×•×ª × ×ž×¦××•',0),(375393,10428,'el','Î”ÎµÎ½ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(375394,10428,'zh','æ²¡æœ‰æ‰¾åˆ°å¸å•\r\n',0),(375395,10428,'sv','Inga rÃ¤kningar hittade',0),(375396,10428,'it','No bollette trovate',0),(375397,10428,'tl','',0),(375398,10428,'th','à¸ªà¸¹à¸•à¸£à¹„à¸¡à¹ˆà¸žà¸š',0),(375399,10428,'hi','à¤•à¥‹à¤ˆ à¤¬à¤¿à¤² à¤®à¤¿à¤²à¤¾',0),(375400,10428,'ms','Tiada bil yang ditemui',0),(375401,10428,'ar','ÙÙˆØ§ØªÙŠØ± Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(375402,10428,'fr','Aucun projet de loi trouvÃ©',0),(375403,10428,'jp','ãªã„æ³•æ¡ˆãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(375404,10428,'pt','Sem notas encontradas',0),(375405,10428,'ru','ÐÐµ ÑÑ‡ÐµÑ‚Ð° Ð½Ð°ÑˆÐ»Ð¸',0),(375406,10428,'es','No se EncontrÃ³ Ningunos Recibos',0),(375407,10428,'de','Keine Rechnungen gefunden',0),(375408,10428,'en','No Bills Found',0),(375409,10429,'is','',0),(375410,10429,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(375411,10429,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(375412,10429,'tr','Bir tarih girmeniz gerekir',0),(375413,10429,'pl','NaleÅ¼y wprowadziÄ‡ datÄ™',0),(375414,10429,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð°',0),(375415,10429,'ur','Ø¢Ù¾ Ø§ÛŒÚ© ØªØ§Ø±ÛŒØ® Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(375416,10429,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ ÑƒÐ½ÐµÑ‚Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(375417,10429,'vi','Báº¡n pháº£i nháº­p ngÃ y',0),(375418,10429,'af','U moet \'n Datum Invoer',0),(375419,10429,'ro','Trebuie sÄƒ introduceÅ£i o datÄƒ',0),(375420,10429,'et','Te peate sisestama kuupÃ¤eva',0),(375421,10429,'si','Vnesti morate datum',0),(375422,10429,'ba','Anda harus memasukkan tanggal',0),(375423,10429,'nl','U moet een datum invoeren',0),(375424,10429,'fi','Anna pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(375425,10429,'no','Du mÃ¥ angi en dato',0),(375426,10429,'da','Du skal angive en dato',0),(375427,10429,'ko','ë‚ ì§œë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(375428,10429,'he','×¢×œ×™×š ×œ×”×›× ×™×¡ ×ª××¨×™×š',0),(375429,10429,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(375430,10429,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªæ—¥æœŸ\r\n',0),(375431,10429,'sv','Du mÃ¥ste ange ett datum',0),(375432,10429,'it','Ãˆ necessario immettere una data',0),(375433,10429,'tl','',0),(375434,10429,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸§à¸±à¸™',0),(375435,10429,'hi','à¤†à¤ª à¤•à¥‹à¤ˆ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(375436,10429,'ms','Anda mesti masukkan tarikh',0),(375437,10429,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ¯Ø®Ù„ ØªØ§Ø±ÙŠØ®Ø§',0),(375438,10429,'fr','Vous devez entrer une date.',0),(375439,10429,'jp','æ—¥ä»˜ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(375440,10429,'pt','VocÃª deve digitar uma data',0),(375441,10429,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ Ð”Ð°Ñ‚Ñƒ',0),(375442,10429,'es','Debe Entrar Una Fecha',0),(375443,10429,'de','Sie mÃ¼ssen ein Datum eingeben.',0),(375444,10429,'en','You Must Enter a Date',0),(375445,10430,'is','',0),(375446,10430,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„ Ø¯Ø§Ø¯Ù†) ÙŠØ§ Ø¯Ø±ÙŠØ§ÙØª Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª ÙˆØ¬Ù‡ Ù†Ù‚Ø¯',0),(375447,10430,'pr','Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„ Ø¯Ø§Ø¯Ù†) ÙŠØ§ Ø¯Ø±ÙŠØ§ÙØª Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª ÙˆØ¬Ù‡ Ù†Ù‚Ø¯',0),(375448,10430,'tr','Transfer veya para transferi almak',0),(375449,10430,'pl','PrzesyÅ‚ania lub odbierania przelewy pieniÄ™Å¼ne',0),(375450,10430,'bg','Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€ Ð¸Ð»Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(375451,10430,'ur','Ù¹Ø±Ø§Ù†Ø³ÙØ± ÛŒØ§ Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©Ùˆ Ù…ÙˆØµÙˆÙ„',0),(375452,10430,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¸Ð¼Ð°Ñ˜Ñƒ Ð½Ð¾Ð²Ñ‡Ð°Ð½Ðµ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ðµ',0),(375453,10430,'vi','Chuyá»ƒn hoáº·c nháº­n Ä‘Æ°á»£c tiá»n máº·t chuyá»ƒn',0),(375454,10430,'af','Oordra of kontant oordragte ontvang',0),(375455,10430,'ro','Transfera sau de a primi transferuri de numerar',0),(375456,10430,'et','Ãœle anda vÃµi saada sularaha Ã¼lekanded',0),(375457,10430,'si','Prenos ali prejemajo denarne transferje',0),(375458,10430,'ba','Transfer atau menerima transfer tunai',0),(375459,10430,'nl','Overdragen of ontvangen contant geld overdrachten',0),(375460,10430,'fi','SiirtÃ¤Ã¤ tai vastaanottaa tulonsiirrot',0),(375461,10430,'no','OverfÃ¸ring eller motta pengeoverfÃ¸ringer',0),(375462,10430,'da','OverfÃ¸re eller modtage kontante overfÃ¸rsler',0),(375463,10430,'ko','ì „ì†¡ í•˜ê±°ë‚˜ í˜„ê¸ˆ ì†¡ê¸ˆì˜ ë°›ì„',0),(375464,10430,'he','×”×¢×‘×¨×” ××• ×œ×§×‘×œ ×”×¢×‘×¨×•×ª ×ž×–×•×ž×Ÿ',0),(375465,10430,'el','ÎœÎµÏ„Î±Î²Î¯Î²Î±ÏƒÎ· Î® Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚ Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½',0),(375466,10430,'zh','è½¬ç§»æˆ–æŽ¥æ”¶çŽ°é‡‘è½¬ç§»\r\n',0),(375467,10430,'sv','Ã–verfÃ¶ra eller ta emot kontantÃ¶verfÃ¶ringar',0),(375468,10430,'it','Trasferire o ricevere trasferimenti di denaro',0),(375469,10430,'tl','',0),(375470,10430,'th','à¹‚à¸­à¸™ à¸«à¸£à¸·à¸­à¸£à¸±à¸šà¹‚à¸­à¸™à¹€à¸‡à¸´à¸™',0),(375471,10430,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤•à¤¦à¥€ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¯à¤¾ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£',0),(375472,10430,'ms','Memindahkan atau menerima pemindahan wang tunai',0),(375473,10430,'ar','Ù†Ù‚Ù„ Ø£Ùˆ Ø§Ø³ØªÙ„Ø§Ù… ØªØ­ÙˆÙŠÙ„Ø§Øª Ù†Ù‚Ø¯ÙŠØ©',0),(375474,10430,'fr','Transfert ou la rÃ©ception des transferts en espÃ¨ces',0),(375475,10430,'jp','è»¢é€ã¾ãŸã¯ç¾é‡‘è»¢é€ã®å—ä¿¡',0),(375476,10430,'pt','Transferir ou receber transferÃªncias de dinheiro',0),(375477,10430,'ru','ÐŸÐµÑ€ÐµÐ²ÐµÑÑ‚Ð¸ Ð¸Ð»Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ñ‹',0),(375478,10430,'es','Transferir o Recibir Transferencias de Efectivo',0),(375479,10430,'de','Ãœbertragen Sie oder empfangen Sie Bargeldtransfers',0),(375480,10430,'en','Transfer or Receive Cash Transfers',0),(375481,10431,'is','',0),(375482,10431,'dr','ØªÙ„Ø§Ø´ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù…ÙˆØ¬ÙˆØ¯',0),(375483,10431,'pr','ØªÙ„Ø§Ø´ Ø¬Ù‡Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù…ÙˆØ¬ÙˆØ¯',0),(375484,10431,'tr','Varolan bir veritabanÄ±nÄ± kullanmak Ã§alÄ±ÅŸÄ±lÄ±yor...',0),(375485,10431,'pl','PrÃ³by UÅ¼yj istniejÄ…cej bazy danych...',0),(375486,10431,'bg','Ð¡Ðµ Ð¾Ð¿Ð¸Ñ‚Ð²Ð°Ñ‚ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð°Ñ‚Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸...',0),(375487,10431,'ur','Ù…ÙˆØ¬ÙˆØ¯Û ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©Ùˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©ÛŒ Ú©ÙˆØ´Ø´ Ú©Ø± Ø±ÛØ§...',0),(375488,10431,'sr','ÐŸÐ¾ÐºÑƒÑˆÐ°Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ñƒ Ð±Ð°Ð·Ñƒ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°...',0),(375489,10431,'vi','Cá»‘ gáº¯ng Ä‘á»ƒ sá»­ dá»¥ng cÆ¡ sá»Ÿ dá»¯ liá»‡u hiá»‡n cÃ³ ...',0),(375490,10431,'af','Poging om Bestaande Databasis Te Gebruik...',0),(375491,10431,'ro','ÃŽncercarea de a utiliza baza de date existente...',0),(375492,10431,'et','Ãœritatakse kasutada olemasolevat andmebaasi...',0),(375493,10431,'si','PoskuÅ¡a uporabiti obstojeÄo zbirko podatkov...',0),(375494,10431,'ba','Mencoba untuk menggunakan Database yang ada...',0),(375495,10431,'nl','Proberen om bestaande Database te gebruiken...',0),(375496,10431,'fi','KÃ¤ytÃ¤ aiemmin luotua tietokantaa yritetÃ¤Ã¤n...',0),(375497,10431,'no','PrÃ¸ver Ã¥ bruke eksisterende Database...',0),(375498,10431,'da','ForsÃ¸ger at bruge eksisterende Database...',0),(375499,10431,'ko','ê¸°ì¡´ ë°ì´í„°ë² ì´ìŠ¤ë¥¼ ì‚¬ìš© í•˜ë ¤ê³ ...',0),(375500,10431,'he','×ž× ×¡×” ×œ×”×©×ª×ž×© ×‘×ž×¡×“ × ×ª×•× ×™× ×§×™×™×...',0),(375501,10431,'el','Î‘Ï€ÏŒÏ€ÎµÎ¹ÏÎ± Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ Î· Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎ± Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½...',0),(375502,10431,'zh','å°è¯•åˆ©ç”¨çŽ°æœ‰çš„æ•°æ®åº“...\r\n',0),(375503,10431,'sv','FÃ¶rsÃ¶k att anvÃ¤nda befintlig databas...',0),(375504,10431,'it','Tentando di utilizzare il Database esistente...',0),(375505,10431,'tl','',0),(375506,10431,'th','à¸žà¸¢à¸²à¸¢à¸²à¸¡à¹ƒà¸Šà¹‰à¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ...',0),(375507,10431,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¤¾ à¤ªà¥à¤°à¤¯à¤¾à¤¸...',0),(375508,10431,'ms','Cuba untuk menggunakan pangkalan data yang sedia ada...',0),(375509,10431,'ar','ØªØ¬Ø±ÙŠ Ù…Ø­Ø§ÙˆÙ„Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©...',0),(375510,10431,'fr','Tentative d\'utilisation de base de donnÃ©es existantes ...',0),(375511,10431,'jp','æ—¢å­˜ã®ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚’ä½¿ç”¨ã—ã‚ˆã†ã¨ã™ã‚‹ã¨.',0),(375512,10431,'pt','A tentativa de usar o banco de dados existente.',0),(375513,10431,'ru','ÐŸÐ¾Ð¿Ñ‹Ñ‚ÐºÐ° Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÑƒÑŽ Ð±Ð°Ð·Ñƒ Ð´Ð°Ð½Ð½Ñ‹Ñ…...',0),(375514,10431,'es','Intentando Usar Base de Datos Existente',0),(375515,10431,'de','Versucht, die vorhandene Datenbank verwenden...',0),(375516,10431,'en','Attempting To Use Existing Database...',0),(375517,10432,'is','',0),(375518,10432,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø§ØµÙ„ÙŠ  Ù†ÙŠØ³Øª',0),(375519,10432,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ø§ØµÙ„ÙŠ  Ù†ÙŠØ³Øª',0),(375520,10432,'tr','Ana veritabanÄ± kullanamazsÄ±nÄ±z',0),(375521,10432,'pl','Nie moÅ¼na uÅ¼yÄ‡ bazy danych gÅ‚Ã³wnych',0),(375522,10432,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(375523,10432,'ur','Ù…Ø±Ú©Ø²ÛŒ ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©Ùˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(375524,10432,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð³Ð»Ð°Ð²Ð½Ðµ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(375525,10432,'vi','KHÃ´ng thá»ƒ sá»­ dá»¥ng cÆ¡ sá»Ÿ dá»¯ liá»‡u chÃ­nh.',0),(375526,10432,'af','Kan nie Hoof Databasis Gebruik nie',0),(375527,10432,'ro','Nu puteÅ£i utiliza baza de date principalÄƒ',0),(375528,10432,'et','Peamine andmebaasi ei saa kasutada',0),(375529,10432,'si','Ne morete uporabljati glavne zbirke podatkov',0),(375530,10432,'ba','Tidak dapat menggunakan Database utama',0),(375531,10432,'nl','Belangrijkste Database niet gebruiken',0),(375532,10432,'fi','Voi kÃ¤yttÃ¤Ã¤ pÃ¤Ã¤tietokantaan',0),(375533,10432,'no','Kan ikke bruke hoveddatabasen',0),(375534,10432,'da','Kan ikke bruge hoveddatabasen',0),(375535,10432,'ko','ì£¼ ë°ì´í„°ë² ì´ìŠ¤ë¥¼ ì‚¬ìš©í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(375536,10432,'he','×œ× × ×™×ª×Ÿ ×œ×”×©×ª×ž×© ×ž×¡×“ ×”× ×ª×•× ×™× ×”×ž×¨×›×–×™',0),(375537,10432,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎ¿Ï…Î½ Ï„Î·Î½ ÎºÏÏÎ¹Î± Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(375538,10432,'zh','ä¸èƒ½ä½¿ç”¨ä¸»æ•°æ®åº“\r\n',0),(375539,10432,'sv','Kan inte anvÃ¤nda huvuddatabasen',0),(375540,10432,'it','Non Ã¨ possibile utilizzare il Database principale',0),(375541,10432,'tl','',0),(375542,10432,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹ƒà¸Šà¹‰à¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸«à¸¥à¸±à¸',0),(375543,10432,'hi','à¤®à¥à¤–à¥à¤¯ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤— à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(375544,10432,'ms','Tidak boleh menggunakan pangkalan data utama',0),(375545,10432,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(375546,10432,'fr','Ne pouvez pas utiliser la base de donnÃ©es principale',0),(375547,10432,'jp','ãƒ¡ã‚¤ãƒ³ ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã‚’ä½¿ç”¨ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(375548,10432,'pt','NÃ£o Ã© possÃ­vel usar o banco de dados principal',0),(375549,10432,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð“Ð»Ð°Ð²Ð½ÑƒÑŽ Ð‘Ð°Ð·Ñƒ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(375550,10432,'es','No se Puede Usar Base de Datos Principal',0),(375551,10432,'de','Datenbank kann nicht verwendet werden.',0),(375552,10432,'en','Cannot Use Main Database',0),(375553,10433,'is','',0),(375554,10433,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ØªØµØ§Ù„ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§   Ù†ÙŠØ³Øª',0),(375555,10433,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ØªØµØ§Ù„ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§   Ù†ÙŠØ³Øª',0),(375556,10433,'tr','VeritabanÄ±na baÄŸlanÄ±lamadÄ±',0),(375557,10433,'pl','Nie moÅ¼na poÅ‚Ä…czyÄ‡ do bazy danych',0),(375558,10433,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ ÑÐ²ÑŠÑ€Ð¶Ðµ Ñ Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸',0),(375559,10433,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ø³Û’ Ù†ÛÛŒÚº Ø¬Ú‘ Ø³Ú©Ø§',0),(375560,10433,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ð¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐµ ÑÐ° Ð±Ð°Ð·Ð¾Ð¼ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(375561,10433,'vi','khÃ´ng thá»ƒ káº¿t ná»‘i dá»¯ liá»‡u',0),(375562,10433,'af','Was nie Instaat om te Konnekteer Aan Databasis',0),(375563,10433,'ro','Nu sa putut conecta la baza de date',0),(375564,10433,'et','Ei saanud Ã¼hendust andmebaasiga',0),(375565,10433,'si','Ne more povezati zbirke podatkov',0),(375566,10433,'ba','Tidak dapat menyambung ke Database',0),(375567,10433,'nl','Could Not Connect To Database',0),(375568,10433,'fi','Ei pysty muodostamaan tietokantaan',0),(375569,10433,'no','Kan ikke koble til Database',0),(375570,10433,'da','Kunne ikke forbinde til databasen',0),(375571,10433,'ko','ë°ì´í„°ë² ì´ìŠ¤ì— ì—°ê²°í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(375572,10433,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×”×ª×—×‘×¨ ×œ×ž×¡×“ × ×ª×•× ×™×',0),(375573,10433,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· ÏƒÏÎ½Î´ÎµÏƒÎ· Î¼Îµ Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(375574,10433,'zh','æ— æ³•è¿žæŽ¥åˆ°æ•°æ®åº“\r\n',0),(375575,10433,'sv','Kunde inte ansluta till databasen',0),(375576,10433,'it','Non riesce a connettersi al Database',0),(375577,10433,'tl','',0),(375578,10433,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¸à¸±à¸šà¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(375579,10433,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥‡ à¤•à¤¨à¥‡à¤•à¥à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(375580,10433,'ms','Tidak dapat menyambung ke pangkalan data',0),(375581,10433,'ar','Ù„Ù… ÙŠÙ…ÙƒÙ† Ø§Ù„Ø§ØªØµØ§Ù„ Ø¨Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(375582,10433,'fr','Could Not Connect To Database',0),(375583,10433,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã«æŽ¥ç¶šã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(375584,10433,'pt','NÃ£o foi possÃ­vel conectar ao banco de dados',0),(375585,10433,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð¡Ð¾ÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒ Ð¡ Ð‘Ð°Ð·Ð¾Ð¹ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(375586,10433,'es','No se PodÃ­a Conectar al Base de Datos',0),(375587,10433,'de','Konnte nicht mit Datenbank verbinden',0),(375588,10433,'en','Could Not Connect To Database',0),(375589,10434,'is','',0),(375590,10434,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ØªØµØ§Ù„ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù…ÙˆØ¬ÙˆØ¯  Ù†ÙŠØ³Øª',0),(375591,10434,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ØªØµØ§Ù„ Ø¨Ù‡ Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù…ÙˆØ¬ÙˆØ¯  Ù†ÙŠØ³Øª',0),(375592,10434,'tr','Varolan bir veritabanÄ±na baÄŸlanÄ±lamadÄ±',0),(375593,10434,'pl','Nie moÅ¼na poÅ‚Ä…czyÄ‡ z istniejÄ…cÄ… bazÄ… danych',0),(375594,10434,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ ÑÐ²ÑŠÑ€Ð¶Ðµ ÐºÑŠÐ¼ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(375595,10434,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ú©ÙˆØ§Ø¦ÙÛŒÛ Ø³Û’ Ù†ÛÛŒÚº Ø¬Ú‘ Ø³Ú©Ø§',0),(375596,10434,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ð¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐµ ÑÐ° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¾Ð¼ Ð±Ð°Ð·Ð¾Ð¼ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(375597,10434,'vi','khÃ´ng thá»ƒ káº¿t ná»‘i dá»¯ liá»‡u Ä‘ang cÃ³',0),(375598,10434,'af','Was nie Instaat om te Konnekteer Aan Bestaande Databasis',0),(375599,10434,'ro','Nu sa putut conecta la baza de date existente',0),(375600,10434,'et','Olemasoleva andmebaasiga Ã¼henduse',0),(375601,10434,'si','Ni mogel povezati obstojeÄo zbirko podatkov',0),(375602,10434,'ba','Tidak dapat menyambung ke Database yang ada',0),(375603,10434,'nl','Kan geen verbinding maken met bestaande Database',0),(375604,10434,'fi','Ei voitu yhdistÃ¤Ã¤ aiemmin luotuun tietokantaan',0),(375605,10434,'no','Kan ikke koble til eksisterende Database',0),(375606,10434,'da','Kunne ikke forbinde til eksisterende Database',0),(375607,10434,'ko','ê¸°ì¡´ ë°ì´í„°ë² ì´ìŠ¤ì— ì—°ê²°í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(375608,10434,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×”×ª×—×‘×¨ ×œ×ž×¡×“ × ×ª×•× ×™× ×§×™×™×',0),(375609,10434,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· ÏƒÏÎ½Î´ÎµÏƒÎ· Î¼Îµ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎ± Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(375610,10434,'zh','æ— æ³•è¿žæŽ¥åˆ°çŽ°æœ‰çš„æ•°æ®åº“\r\n',0),(375611,10434,'sv','Kunde inte ansluta till befintlig databas',0),(375612,10434,'it','Potrebbe non connettersi a Database esistenti',0),(375613,10434,'tl','',0),(375614,10434,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¸à¸±à¸šà¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(375615,10434,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¥‡ à¤•à¤¨à¥‡à¤•à¥à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(375616,10434,'ms','Tidak dapat menyambung ke pangkalan data sedia ada',0),(375617,10434,'ar','Ù„Ù… ÙŠÙ…ÙƒÙ† Ø§Ù„Ø§ØªØµØ§Ù„ Ø¨Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(375618,10434,'fr','Connexion impossible Ã  la base de donnÃ©es existante',0),(375619,10434,'jp','æ—¢å­˜ã®ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã«æŽ¥ç¶šã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(375620,10434,'pt','NÃ£o foi possÃ­vel conectar ao banco de dados existente',0),(375621,10434,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð¡Ð¾ÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒ Ð¡ Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÐµÐ¹ Ð‘Ð°Ð·Ð¾Ð¹ Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(375622,10434,'es','Nose PodÃ­a Conectar al Base de Datos Existente',0),(375623,10434,'de','Konnte keine Verbindung zu vorhandenen Datenbank',0),(375624,10434,'en','Could Not Connect To Existing Database',0),(375625,10435,'is','',0),(375626,10435,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… Ø¯ÙØªØ± ÙƒÙ„',0),(375627,10435,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… Ø¯ÙØªØ± ÙƒÙ„',0),(375628,10435,'tr','DoÄŸrudan GL Ã¶deme giriÅŸleri',0),(375629,10435,'pl','Wpisy pÅ‚atnoÅ›ci bezpoÅ›rednie GL',0),(375630,10435,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ GL Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(375631,10435,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬ÛŒØ¬Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(375632,10435,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(375633,10435,'vi','Ghi vÃ o sá»• cÃ¡i thanh toÃ¡n trá»±c tiáº¿p',0),(375634,10435,'af','Direkte AG Betalinginskrywings',0),(375635,10435,'ro','IntrÄƒrile de platÄƒ directÄƒ GL',0),(375636,10435,'et','Otsene GL maksekannete',0),(375637,10435,'si','Neposredno GL plaÄila vpisov',0),(375638,10435,'ba','Entri pembayaran langsung GL',0),(375639,10435,'nl','Directe GL betalingsposten',0),(375640,10435,'fi','Suoraa GL maksu',0),(375641,10435,'no','Direkte GL betalingspostene',0),(375642,10435,'da','Direkte GL betalingsposter',0),(375643,10435,'ko','ì§ì ‘ GL ì§€ë¶ˆ í•­ëª©',0),(375644,10435,'he','×”×–× ×•×ª ×ª×©×œ×•× ×™×©×™×¨ GL',0),(375645,10435,'el','GL Î¬Î¼ÎµÏƒÎ· Ï€Î»Î·ÏÏ‰Î¼Î® ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(375646,10435,'zh','ç›´æŽ¥æ€»å¸ä»˜è´¹æ¡ç›®\r\n',0),(375647,10435,'sv','Direkt GL betalningsposter',0),(375648,10435,'it','Voci di pagamento diretto GL',0),(375649,10435,'tl','',0),(375650,10435,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ GL à¹‚à¸”à¸¢à¸•à¸£à¸‡',0),(375651,10435,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· GL à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚',0),(375652,10435,'ms','GL terus bayaran penyertaan',0),(375653,10435,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± GL',0),(375654,10435,'fr','EntrÃ©es de paiement direct GL',0),(375655,10435,'jp','GL æ”¯æ‰•ã‚¨ãƒ³ãƒˆãƒªã‚’ç›´æŽ¥ã—ã¾ã™ã€‚',0),(375656,10435,'pt','Entradas de pagamento directo GL',0),(375657,10435,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ GL',0),(375658,10435,'es','Entradas de Pagos Directos al LM',0),(375659,10435,'de','Direkte GL Zahlungsposten',0),(375660,10435,'en','Direct GL Payment Entries',0),(375661,10436,'is','',0),(375662,10436,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… Ø¯ÙØªØ± ÙƒÙ„ ',0),(375663,10436,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… Ø¯ÙØªØ± ÙƒÙ„ ',0),(375664,10436,'tr','Toplam doÄŸrudan GL Ã¶deme giriÅŸleri',0),(375665,10436,'pl','Wpisy pÅ‚atnoÅ›ci caÅ‚kowite bezpoÅ›rednie GL',0),(375666,10436,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ñ€ÐµÐºÐ¸ GL Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(375667,10436,'ur','Ú©Ù„ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬ÛŒØ¬Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(375668,10436,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(375669,10436,'vi','Táº¥t cáº£ GL trá»±c tiáº¿p thanh toÃ¡n má»¥c',0),(375670,10436,'af','Totale Direkte AG Betalingsinskrywings',0),(375671,10436,'ro','IntrÄƒrile de plata totalÄƒ GL directe',0),(375672,10436,'et','Kokku otsese GL maksekannete',0),(375673,10436,'si','Skupna neposredna GL plaÄila vpisov',0),(375674,10436,'ba','GL langsung Total pembayaran entri',0),(375675,10436,'nl','Totale directe GL betalingsposten',0),(375676,10436,'fi','YhteensÃ¤ suoraan GL maksun merkinnÃ¤t',0),(375677,10436,'no','Totalt direkte GL betalingspostene',0),(375678,10436,'da','Samlede direkte GL betalingsposter',0),(375679,10436,'ko','ì´ ì§ì ‘ GL ì§€ë¶ˆ í•­ëª©',0),(375680,10436,'he','×”×–× ×•×ª ×ª×©×œ×•× ×¡×š GL ×™×©×™×¨×”',0),(375681,10436,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ GL Î¬Î¼ÎµÏƒÎ· Ï€Î»Î·ÏÏ‰Î¼Î® ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(375682,10436,'zh','æ€»ç›´æŽ¥ä»˜æ¬¾é¡¹åŒ–éªŒ\r\n',0),(375683,10436,'sv','Totala direkta GL betalningsposter',0),(375684,10436,'it','Voci di pagamento totale diretto GL',0),(375685,10436,'tl','',0),(375686,10436,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ GL à¹‚à¸”à¸¢à¸•à¸£à¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(375687,10436,'hi','à¤•à¥à¤² à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· GL à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚',0),(375688,10436,'ms','GL terus jumlah bayaran penyertaan',0),(375689,10436,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ GL Ù…Ø¨Ø§Ø´Ø±Ø©',0),(375690,10436,'fr','GL Direct total paiement entrÃ©es',0),(375691,10436,'jp','åˆè¨ˆç›´æŽ¥ GL æ”¯æ‰•ã„ã®ã‚¨ãƒ³ãƒˆãƒª',0),(375692,10436,'pt','Entradas de pagamento total direto GL',0),(375693,10436,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð²ÑÐµÐ³Ð¾ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ GL',0),(375694,10436,'es','Total de Entradas de Pagos de LM',0),(375695,10436,'de','Gesamte direkte GL Zahlungsposten',0),(375696,10436,'en','Total Direct GL Payment Entries',0),(375697,10437,'is','',0),(375698,10437,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø«Ø¨Øª Ø¯Ø± Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡  Ø§Ø² ÙˆØ±ÙˆØ¯ÙŠ Ø¨Ø§Ù†Ùƒ ',0),(375699,10437,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø«Ø¨Øª Ø¯Ø± Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡  Ø§Ø² ÙˆØ±ÙˆØ¯ÙŠ Ø¨Ø§Ù†Ùƒ ',0),(375700,10437,'tr','Banka alma iÅŸleminde gÃ¼nlÃ¼k girdisi oluÅŸtur',0),(375701,10437,'pl','UtwÃ³rz wpis do dziennika z banku Import',0),(375702,10437,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ° Ð¾Ñ‚ Ð±Ð°Ð½ÐºÐ° Ð²Ð½Ð¾Ñ',0),(375703,10437,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø¨Ú¾ÛŒ Ø¨Ù†Ø§Ù†Û’ Ø³Û’ Ø¨ÛŒÙ†Ú© Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(375704,10437,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ Ð¸Ð· Ð±Ð°Ð½ÐºÐµ ÑƒÐ²Ð¾Ð·Ð°',0),(375705,10437,'vi','táº¡o bÃºt toÃ¡n ghi sá»• tá»« nháº­p dá»¯ liá»‡u ngÃ¢n hÃ ng',0),(375706,10437,'af','Skep Joernaalinskrywing Vanaf Bank Invoer',0),(375707,10437,'ro','Creare intrare Ã®n jurnal din banca de Import',0),(375708,10437,'et','Luua pÃ¤evikukanne panga Import',0),(375709,10437,'si','Iz banke uvoz ustvari vnos v dnevnik',0),(375710,10437,'ba','Membuat entri jurnal dari Bank impor',0),(375711,10437,'nl','Logboekitem maken van Bank importeren',0),(375712,10437,'fi','Luo pÃ¤ivyrimerkintÃ¤ pankin tuonti',0),(375713,10437,'no','Opprett oppfÃ¸ring fra Bank Import',0),(375714,10437,'da','Oprette journaloptegnelse fra Bank Import',0),(375715,10437,'ko','ì€í–‰ ìˆ˜ìž…ì—ì„œ ì—…ë¬´ ì¼ì§€ í•­ëª© ë§Œë“¤ê¸°',0),(375716,10437,'he','×¦×•×¨ ×¢×¨×š ×™×•×ž×Ÿ ×™×™×‘×•× ×‘× ×§',0),(375717,10437,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯Ï„Î±Î¹ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ¹ÏƒÎ· Ï‡ÏÎ¿Î½Î¹ÎºÎ¿Ï Î±Ï€ÏŒ Ï„ÏÎ¬Ï€ÎµÎ¶Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(375718,10437,'zh','è¿›å‡ºå£é“¶è¡Œåˆ›å»ºåˆ†è´¦æ¡ç›®\r\n',0),(375719,10437,'sv','Skapa journalpost frÃ¥n Bank Import',0),(375720,10437,'it','Creare il giornale di registrazione dall\'importazione di banca',0),(375721,10437,'tl','',0),(375722,10437,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¸ˆà¸²à¸à¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²à¸˜à¸™à¸²à¸„à¸²à¸£',0),(375723,10437,'hi','à¤¬à¥ˆà¤‚à¤• à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(375724,10437,'ms','Mencipta kemasukan jurnal dari Bank Import',0),(375725,10437,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù‚ÙŠØ¯ ÙŠÙˆÙ…ÙŠØ© Ù…Ù† Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…ØµØ±Ù',0),(375726,10437,'fr','CrÃ©er l\'entrÃ©e du Journal de banque Import',0),(375727,10437,'jp','éŠ€è¡Œã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆã‹ã‚‰ã‚¸ãƒ£ãƒ¼ãƒŠãƒ« ã‚¨ãƒ³ãƒˆãƒªã‚’ä½œæˆã—ã¾ã™ã€‚',0),(375728,10437,'pt','Criar a entrada de diÃ¡rio do banco de importaÃ§Ã£o',0),(375729,10437,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ Ð¾Ñ‚ Ð±Ð°Ð½ÐºÐ° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(375730,10437,'es','Crear Entrado de Diario de la Importacion Bancaria',0),(375731,10437,'de','Journaleintrag erstellen von Bank-Import',0),(375732,10437,'en','Create Journal Entry From Bank Import',0),(375733,10438,'is','',0),(375734,10438,'dr','Ø«Ø¨Øª Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(375735,10438,'pr','Ø«Ø¨Øª Ø¯ÙØªØ± Ø±ÙˆØ²Ù†Ø§Ù…Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(375736,10438,'tr','GÃ¼nlÃ¼k girdisi baÅŸarÄ±yla eklendi',0),(375737,10438,'pl','PomyÅ›lnie dodano wpis do dziennika',0),(375738,10438,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð·Ð°Ð¿Ð¸Ñ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(375739,10438,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(375740,10438,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ ÑÑ‚Ð°Ð²ÐºÑƒ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ',0),(375741,10438,'vi','Ä‘Ã£ thÃªm ghi chÃ©p hÃ ng ngÃ y thÃ nh cÃ´ng',0),(375742,10438,'af','Joernaalinskrywing Suksesvol Geskep',0),(375743,10438,'ro','Intrare Ã®n jurnal adÄƒugat cu succes',0),(375744,10438,'et','Lisatud pÃ¤evikukanne',0),(375745,10438,'si','UspeÅ¡no dodali vnos v dnevnik',0),(375746,10438,'ba','Entri jurnal ditambahkan berhasil',0),(375747,10438,'nl','Logboekitem met succes toegevoegd',0),(375748,10438,'fi','Tapahtuman lisÃ¤Ã¤minen onnistui',0),(375749,10438,'no','OppfÃ¸ring ble lagt til',0),(375750,10438,'da','Journaloptegnelse tilfÃ¸jet',0),(375751,10438,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª© ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(375752,10438,'he','. ×¨×™×©×•× ×™×•×ž×Ÿ ×ž×¡×¤×¨ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(375753,10438,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ¹ÏƒÎ· Ï‡ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(375754,10438,'zh','æ—¥å¿—æ¡ç›®æ·»åŠ æˆåŠŸ\r\n',0),(375755,10438,'sv','Journalpost lagts',0),(375756,10438,'it','Voce di diario aggiunto con successo',0),(375757,10438,'tl','',0),(375758,10438,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(375759,10438,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(375760,10438,'ms','Kemasukan jurnal yang berjaya menambah',0),(375761,10438,'ar','Ø£Ø¶ÙŠÙ Ù‚ÙŠØ¯ Ø§Ù„ÙŠÙˆÙ…ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­',0),(375762,10438,'fr','EntrÃ©e de journal ajoutÃ©e avec succÃ¨s',0),(375763,10438,'jp','ã‚¸ãƒ£ãƒ¼ãƒŠãƒ« ã‚¨ãƒ³ãƒˆãƒªãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(375764,10438,'pt','Entrada de diÃ¡rio adicionada com sucesso',0),(375765,10438,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(375766,10438,'es','Entrada al Diario Agregada Exitosamente',0),(375767,10438,'de','Journal-Eintrag erfolgreich hinzugefÃ¼gt',0),(375768,10438,'en','Journal Entry Added Successfully',0),(375769,10439,'is','',0),(375770,10439,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø¨Ø¹Ù„Øª Ø§Ø² Ø¯Ø³Øª Ø¯Ø§Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(375771,10439,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø¨Ø¹Ù„Øª Ø§Ø² Ø¯Ø³Øª Ø¯Ø§Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(375772,10439,'tr','Eksik bilgi nedeniyle baÅŸarÄ±sÄ±z Kaydet',0),(375773,10439,'pl','Zapisywanie nie powiodÅ‚o siÄ™ z powodu braku informacji',0),(375774,10439,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¸ Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð»Ð¸Ð¿ÑÐ²Ð°Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(375775,10439,'ur','Ù†Ø§Ú©Ø§Ù… ÛÙˆÙ†Û’ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ ØºØ§Ø¦Ø¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(375776,10439,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¿Ñ€Ð¾Ð¿Ð°Ð»Ð¸ Ð·Ð±Ð¾Ð³ Ð½ÐµÑÑ‚Ð°Ð»Ðµ Ð˜Ð½Ñ„Ð¾',0),(375777,10439,'vi','LÆ°u tháº¥t báº¡i do  thiáº¿u thÃ´ng tin',0),(375778,10439,'af','Berging het Gefaal Weens Vermisde Inligting',0),(375779,10439,'ro','Salva nu a reuÅŸit datoritÄƒ lipsesc informaÅ£ii',0),(375780,10439,'et','Salvesta ebaÃµnnestunud tÃµttu puudub Info',0),(375781,10439,'si','Shranjevanje ni uspelo zaradi manjkajoÄe Info',0),(375782,10439,'ba','Simpan gagal karena hilang Info',0),(375783,10439,'nl','Opslaan mislukt als gevolg van ontbrekende Info',0),(375784,10439,'fi','Tallennus epÃ¤onnistui koska puuttuvat tiedot',0),(375785,10439,'no','Lagring mislyktes pÃ¥ grunn av manglende informasjon',0),(375786,10439,'da','Gem mislykkedes pÃ¥ grund af manglende Info',0),(375787,10439,'ko','ëˆ„ë½ ëœ ì •ë³´ë¡œ ì¸í•´ ì‹¤íŒ¨ í•œ ì €ìž¥',0),(375788,10439,'he','×©×ž×™×¨×” × ×›×©×œ×” ×¢×§×‘ ×ž×™×“×¢ ×—×¡×¨',0),(375789,10439,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ Î»ÏŒÎ³Ï‰ Ï„Î·Ï‚ Î»ÎµÎ¯Ï€ÎµÎ¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(375790,10439,'zh','ä¿å­˜å¤±è´¥ï¼ŒåŽŸå› æ˜¯ç¼ºå°‘ä¿¡æ¯\r\n',0),(375791,10439,'sv','Spara misslyckades pÃ¥ grund av saknade information',0),(375792,10439,'it','Salvare fallito a causa di informazioni mancanti',0),(375793,10439,'tl','',0),(375794,10439,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§à¹€à¸™à¸·à¹ˆà¸­à¸‡à¸ˆà¸²à¸à¸‚à¸²à¸”à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(375795,10439,'hi','à¤¬à¤šà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¾à¤¦ à¤† à¤°à¤¹à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤•à¤¾à¤°à¤£ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(375796,10439,'ms','Simpan gagal kerana maklumat hilang',0),(375797,10439,'ar','Ø¥Ù†Ù‚Ø§Ø° ÙØ§Ø´Ù„Ø© Ø¨Ø³Ø¨Ø¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÙÙ‚ÙˆØ¯Ø©',0),(375798,10439,'fr','Sauver a Ã©chouÃ© en raison d\'informations manquantes',0),(375799,10439,'jp','ä¸è¶³ã—ã¦ã„ã‚‹æƒ…å ±ã®ãŸã‚ä¿å­˜ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(375800,10439,'pt','Salvar falhou devido a falta de informaÃ§Ã£o',0),(375801,10439,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¸Ð·-Ð·Ð° Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(375802,10439,'es','Guardar FallÃ³ Debido a InformaciÃ³n Extraviada',0),(375803,10439,'de','Speichern Sie fehlgeschlagen aufgrund fehlender Informationen',0),(375804,10439,'en','Save Failed Due To Missing Info',0),(375805,10440,'is','',0),(375806,10440,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ø±Ø­ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(375807,10440,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ø±Ø­ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(375808,10440,'tr','Bir aÃ§Ä±klama girmeniz gerekir',0),(375809,10440,'pl','NaleÅ¼y wprowadziÄ‡ opis',0),(375810,10440,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(375811,10440,'ur','Ø¢Ù¾ Ú©ÛŒ ØªØµØ±ÛŒØ­ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(375812,10440,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¾Ð¿Ð¸Ñ',0),(375813,10440,'vi','Báº¡n pháº£i nháº­p diá»…n giáº£i',0),(375814,10440,'af','U Moet \'n Beskrywing Invoer',0),(375815,10440,'ro','Trebuie sÄƒ introduceÅ£i o descriere',0),(375816,10440,'et','Te peate sisestama kirjelduse',0),(375817,10440,'si','Vnesite opis',0),(375818,10440,'ba','Anda harus memasukkan Deskripsi',0),(375819,10440,'nl','U moet een beschrijving invoeren',0),(375820,10440,'fi','Kirjoita kuvaus',0),(375821,10440,'no','Du mÃ¥ skrive inn en beskrivelse',0),(375822,10440,'da','Du skal indtaste en beskrivelse',0),(375823,10440,'ko','ì„¤ëª…ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(375824,10440,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ª×™××•×¨',0),(375825,10440,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(375826,10440,'zh','æ‚¨å¿…é¡»è¾“å…¥è¯´æè¿°\r\n',0),(375827,10440,'sv','Du mÃ¥ste ange en beskrivning',0),(375828,10440,'it','Ãˆ necessario immettere una descrizione',0),(375829,10440,'tl','',0),(375830,10440,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢',0),(375831,10440,'hi','à¤†à¤ªà¤•à¥‹ à¤à¤• à¤µà¤¿à¤µà¤°à¤£ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(375832,10440,'ms','Anda mesti masukkan Perihalan',0),(375833,10440,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ¯Ø®Ù„ ÙˆØµÙØ§',0),(375834,10440,'fr','Vous devez entrer une description.',0),(375835,10440,'jp','èª¬æ˜Žã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(375836,10440,'pt','VocÃª deve inserir uma descriÃ§Ã£o',0),(375837,10440,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(375838,10440,'es','Debe Entrar Una DescripciÃ³n',0),(375839,10440,'de','Sie mÃ¼ssen eine Beschreibung eingeben.',0),(375840,10440,'en','You Must Enter A Description',0),(375841,10441,'is','',0),(375842,10441,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ø§Ù‡ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(375843,10441,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ø§Ù‡ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(375844,10441,'tr','Bir ay sonrasÄ± iÃ§in girmelisiniz',0),(375845,10441,'pl','MiesiÄ…c naleÅ¼y wprowadziÄ‡ do Post',0),(375846,10441,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐµÐ´Ð¸Ð½ Ð¼ÐµÑÐµÑ† Ð¿Ð¾ÑÑ‚',0),(375847,10441,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù…Ø§Û Ú©Û’ Ù„Ø¦Û’ Ù¾ÙˆØ³Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(375848,10441,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¼ÐµÑÐµÑ† Ð½Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ',0),(375849,10441,'vi','Báº¡n pháº£i nháº­p má»™t thÃ¡ng Ä‘á»ƒ thÃ´ng bÃ¡o',0),(375850,10441,'af','U moet\'n Maand Invoer om na te Pos',0),(375851,10441,'ro','Trebuie sÄƒ introduceÅ£i o lunÄƒ post',0),(375852,10441,'et','Te peate sisestama postituskuupÃ¤eva',0),(375853,10441,'si','Morate vnesti mesec do objave',0),(375854,10441,'ba','Anda harus memasukkan sebulan untuk posting',0),(375855,10441,'nl','U moet ook een maand invoeren aan Post',0),(375856,10441,'fi','Anna kuukaudessa tehtÃ¤vÃ¤Ã¤n',0),(375857,10441,'no','Du mÃ¥ angi en mÃ¥ned til innlegget',0),(375858,10441,'da','Du skal angive en mÃ¥ned til indlÃ¦g',0),(375859,10441,'ko','ê²Œì‹œë¬¼ì— í•œ ë‹¬ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(375860,10441,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×—×•×“×© ×¤×•×¡×˜',0),(375861,10441,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Î¼Î®Î½Î± ÏƒÎµ Î±Î½Î¬ÏÏ„Î·ÏƒÎ·',0),(375862,10441,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªæœˆåŽ\r\n',0),(375863,10441,'sv','Du mÃ¥ste ange en mÃ¥nad till Post',0),(375864,10441,'it','Devi inserire un mese Post',0),(375865,10441,'tl','',0),(375866,10441,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¹€à¸”à¸·à¸­à¸™à¹€à¸žà¸·à¹ˆà¸­à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(375867,10441,'hi','à¤†à¤ª à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤®à¤¾à¤¹ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(375868,10441,'ms','Anda mesti masukkan setiap bulan ke jawatan',0),(375869,10441,'ar','Ù„Ø§Ø¨Ø¯ Ù…Ù† Ø¥Ø¯Ø®Ø§Ù„ Ø´Ù‡Ø± Ù„Ù„ØªØ±Ø­ÙŠÙ„',0),(375870,10441,'fr','Vous devez entrer un mois Ã  envoyer',0),(375871,10441,'jp','ãƒã‚¹ãƒˆã« 1 ã‚«æœˆã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(375872,10441,'pt','VocÃª deve digitar um mÃªs de Post',0),(375873,10441,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¼ÐµÑÑÑ† Ð¿Ð¾ÑÑ‚',0),(375874,10441,'es','Debe Entrar Un Mes Para Asentar',0),(375875,10441,'de','Sie mÃ¼ssen einen Monat zu Beitrag eingeben.',0),(375876,10441,'en','You Must Enter A Month To Post',0),(375877,10442,'is','',0),(375878,10442,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ø§Ù„ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(375879,10442,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ø§Ù„ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(375880,10442,'tr','Bir yÄ±l sonrasÄ± iÃ§in girmelisiniz',0),(375881,10442,'pl','Rok naleÅ¼y wprowadziÄ‡ do Post',0),(375882,10442,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐµÐ´Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° ÐºÑŠÐ¼ ÑÑ‚ÑŠÐ»Ð±',0),(375883,10442,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ Ù¾ÙˆØ³Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(375884,10442,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð½Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ',0),(375885,10442,'vi','Báº¡n pháº£i nháº­p má»™t nÄƒm Ä‘á»ƒ thÃ´ng bÃ¡o',0),(375886,10442,'af','U moet\'n Jaar Invoer om na te Pos',0),(375887,10442,'ro','Trebuie sÄƒ introduceÅ£i un an la Post',0),(375888,10442,'et','Te peate sisestama postitusaasta',0),(375889,10442,'si','Vnesti morate leto do objave',0),(375890,10442,'ba','Anda harus memasukkan tahun ke posting',0),(375891,10442,'nl','Moet u een jaar aan Post',0),(375892,10442,'fi','Kirjoita vuosi tekstiin',0),(375893,10442,'no','Du mÃ¥ angi et Ã¥r til posten',0),(375894,10442,'da','Du skal angive et Ã¥r til indlÃ¦g',0),(375895,10442,'ko','ê²Œì‹œë¬¼ì— 1 ë…„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(375896,10442,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×©× ×” ×¤×•×¡×˜',0),(375897,10442,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Ï‡ÏÏŒÎ½Î¿ ÏƒÎµ Î±Î½Î¬ÏÏ„Î·ÏƒÎ·',0),(375898,10442,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€å¹´åŽ\r\n',0),(375899,10442,'sv','Du mÃ¥ste ange ett Ã¥r till Post',0),(375900,10442,'it','Devi inserire un anno Post',0),(375901,10442,'tl','',0),(375902,10442,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸›à¸µà¸à¸²à¸£à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(375903,10442,'hi','à¤†à¤ª à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤µà¤°à¥à¤· à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(375904,10442,'ms','Anda mesti masukkan setahun ke jawatan',0),(375905,10442,'ar','Ù„Ø§Ø¨Ø¯ Ù…Ù† Ø¥Ø¯Ø®Ø§Ù„ Ø³Ù†Ø© Ù„Ù„ØªØ±Ø­ÙŠÙ„',0),(375906,10442,'fr','Vous devez entrer une annÃ©e pour envoi.',0),(375907,10442,'jp','ãƒã‚¹ãƒˆã« 1 å¹´ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(375908,10442,'pt','VocÃª deve digitar um ano de Post',0),(375909,10442,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð³Ð¾Ð´ Ð¿Ð¾ÑÑ‚',0),(375910,10442,'es','Debe EntrarUn AÃ±o Para Asentar',0),(375911,10442,'de','Sie mÃ¼ssen ein Jahr zu Beitrag eingeben.',0),(375912,10442,'en','You Must Enter A Year To Post',0),(375913,10443,'is','',0),(375914,10443,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯ÙØªØ± ÙƒÙ„',0),(375915,10443,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯ÙØªØ± ÙƒÙ„',0),(375916,10443,'tr','GL ekleyin',0),(375917,10443,'pl','DodaÄ‡ GL',0),(375918,10443,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ GL',0),(375919,10443,'ur','Ø¬ÛŒØ¬Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(375920,10443,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð“Ð›',0),(375921,10443,'vi','ThÃªm sá»• cÃ¡i',0),(375922,10443,'af','AG Byvoeg',0),(375923,10443,'ro','Adauga GL',0),(375924,10443,'et','Lisada GL',0),(375925,10443,'si','Dodaj GL',0),(375926,10443,'ba','Tambahkan GL',0),(375927,10443,'nl','GL toevoegen',0),(375928,10443,'fi','LisÃ¤Ã¤ GL',0),(375929,10443,'no','Legge til GL',0),(375930,10443,'da','TilfÃ¸je GL',0),(375931,10443,'ko','GLì— ì¶”ê°€',0),(375932,10443,'he','×œ×”×•×¡×™×£ GL',0),(375933,10443,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ GL',0),(375934,10443,'zh','å¢žåŠ æ€»å¸\r\n',0),(375935,10443,'sv','LÃ¤gg till GL',0),(375936,10443,'it','Aggiungi GL',0),(375937,10443,'tl','',0),(375938,10443,'th','à¹€à¸žà¸´à¹ˆà¸¡ GL',0),(375939,10443,'hi','à¤œà¥€à¤à¤² à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(375940,10443,'ms','Tambah GL',0),(375941,10443,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ø³ØªØ§Ø° Ø¹Ø§Ù…',0),(375942,10443,'fr','Ajouter GL',0),(375943,10443,'jp','GL ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(375944,10443,'pt','Adicionar GL',0),(375945,10443,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ GL',0),(375946,10443,'es','Agregar LM',0),(375947,10443,'de','HinzufÃ¼gen von GL',0),(375948,10443,'en','Add GL',0),(375949,10444,'is','',0),(375950,10444,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø¨Ø§Ù†Ùƒ',0),(375951,10444,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø¨Ø§Ù†Ùƒ',0),(375952,10444,'tr','Banka teÅŸhis kodu',0),(375953,10444,'pl','Identyfikator banku',0),(375954,10444,'bg','Ð˜Ð” Ð½Ð° Ð±Ð°Ð½ÐºÐ°Ñ‚Ð°',0),(375955,10444,'ur','Ø¨ÛŒÙ†Ú© Ø´Ù†Ø§Ø®Øª',0),(375956,10444,'sr','Ð‘Ð°Ð½ÐºÐ° Ð˜Ð”',0),(375957,10444,'vi','MÃ£ ngÃ¢n hÃ ng',0),(375958,10444,'af','Bank ID',0),(375959,10444,'ro','Banca ID',0),(375960,10444,'et','Panga ID',0),(375961,10444,'si','ID banke',0),(375962,10444,'ba','Bank ID',0),(375963,10444,'nl','Bank-ID',0),(375964,10444,'fi','Pankkitunnus',0),(375965,10444,'no','Bank-ID',0),(375966,10444,'da','Bank-ID',0),(375967,10444,'ko','ì€í–‰ ID',0),(375968,10444,'he','×ž×–×”×” ×‘× ×§',0),(375969,10444,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ID',0),(375970,10444,'zh','é“¶è¡Œç¼–å·\r\n',0),(375971,10444,'sv','Bank-ID',0),(375972,10444,'it','ID banca',0),(375973,10444,'tl','',0),(375974,10444,'th','à¸£à¸«à¸±à¸ªà¸˜à¸™à¸²à¸„à¸²à¸£',0),(375975,10444,'hi','à¤¬à¥ˆà¤‚à¤• à¤†à¤ˆà¤¡à¥€',0),(375976,10444,'ms','Bank ID',0),(375977,10444,'ar','Ù…Ø¹Ø±Ù‘Ù Ø§Ù„Ù…ØµØ±Ù',0),(375978,10444,'fr','ID de banque',0),(375979,10444,'jp','éŠ€è¡Œ ID',0),(375980,10444,'pt','NÃºmero de identificaÃ§Ã£o',0),(375981,10444,'ru','ÐšÐžÐ” Ð±Ð°Ð½ÐºÐ°',0),(375982,10444,'es','ID Bancario',0),(375983,10444,'de','Bank-ID',0),(375984,10444,'en','Bank ID',0),(375985,10445,'is','',0),(375986,10445,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙˆØ±ÙˆØ¯ÙŠ Ø¨Ø§Ù†Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(375987,10445,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙˆØ±ÙˆØ¯ÙŠ Ø¨Ø§Ù†Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(375988,10445,'tr','Banka alma verileri baÅŸarÄ±yla silindi',0),(375989,10445,'pl','Import danych usuniÄ™te pomyÅ›lnie',0),(375990,10445,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(375991,10445,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ø¯Ø±Ø¢Ù…Ø¯ÛŒ Ú©ÙˆØ§Ø¦Ù Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(375992,10445,'sr','Ð‘Ð°Ð½ÐºÐ° ÑƒÐ²Ð¾Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(375993,10445,'vi','ÄÃ£ xÃ³a ngÃ¢n hÃ ng dá»¯ liá»‡u nháº­p kháº©u thÃ nh cÃ´ng',0),(375994,10445,'af','Bank Ingevoerde Data Suksesvol Geskrap',0),(375995,10445,'ro','Banca de Import date eliminÄƒ cu succes',0),(375996,10445,'et','Panga edukalt kustutatud andmete importimine',0),(375997,10445,'si','Banka uvozna podatkov uspeÅ¡no izbrisana',0),(375998,10445,'ba','Bank impor Data dihapus berhasil',0),(375999,10445,'nl','Bankgegevens importeren met succes verwijderd',0),(376000,10445,'fi','Pankin tuontitiedot poistettu',0),(376001,10445,'no','Banken importdataene slettet',0),(376002,10445,'da','Bank importdata slettet',0),(376003,10445,'ko','ì€í–‰ ë°ì´í„° ê°€ì ¸ì˜¤ê¸° ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(376004,10445,'he','×‘× ×§ ×™×™×‘×•× × ×ª×•× ×™× × ×ž×—×§×• ×‘×”×¦×œ×—×”',0),(376005,10445,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(376006,10445,'zh','é“¶è¡Œå¯¼å…¥æ•°æ®æˆåŠŸåˆ é™¤\r\n',0),(376007,10445,'sv','Banken importera Data raderades',0),(376008,10445,'it','Banca dati di importazione eliminati con successo',0),(376009,10445,'tl','',0),(376010,10445,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸™à¸³à¹€à¸‚à¹‰à¸²à¸˜à¸™à¸²à¸„à¸²à¸£à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(376011,10445,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤¬à¥ˆà¤‚à¤• à¤¡à¥‡à¤Ÿà¤¾ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(376012,10445,'ms','Bank Data Import dihapuskan dengan jayanya',0),(376013,10445,'ar','Ø­Ø°ÙØª Ø¨ÙŠØ§Ù†Ø§Øª Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…ØµØ±Ù Ø¨Ù†Ø¬Ø§Ø­',0),(376014,10445,'fr','Banque importation donnÃ©es supprimÃ©es avec succÃ¨s',0),(376015,10445,'jp','éŠ€è¡ŒãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸãƒ‡ãƒ¼ã‚¿ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(376016,10445,'pt','Dados de banco de importaÃ§Ã£o apagados com sucesso',0),(376017,10445,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð‘Ð°Ð½Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(376018,10445,'es','Datos Bancarios de ImportaciÃ³n Eliminados Exitosamente',0),(376019,10445,'de','Bankdaten Import erfolgreich gelÃ¶scht',0),(376020,10445,'en','Bank Import Data Deleted Successfully',0),(376021,10446,'is','',0),(376022,10446,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙˆØ±ÙˆØ¯ÙŠ Ø¨Ø§Ù†Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(376023,10446,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ ÙˆØ±ÙˆØ¯ÙŠ Ø¨Ø§Ù†Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯',0),(376024,10446,'tr','Banka alma verileri baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(376025,10446,'pl','Import danych pomyÅ›lnie zaktualizowana',0),(376026,10446,'bg','Ð”Ð°Ð½Ð½Ð¸Ñ‚Ðµ Ð·Ð° Ð²Ð½Ð¾ÑÐ° Ð½Ð° Ð±Ð°Ð½ÐºÐ°Ñ‚Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(376027,10446,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ø¯Ø±Ø¢Ù…Ø¯ÛŒ Ú©ÙˆØ§Ø¦Ù Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(376028,10446,'sr','Ð‘Ð°Ð½ÐºÐ° ÑƒÐ²Ð¾Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(376029,10446,'vi','NgÃ¢n hÃ ng dá»¯ liá»‡u nháº­p kháº©u Cáº­p nháº­t thÃ nh cÃ´ng',0),(376030,10446,'af','Bank Ingevoerde Data Suksesvol Opdateer',0),(376031,10446,'ro','Banca de Import date actualizate cu succes',0),(376032,10446,'et','Panga andmete importimine, vÃ¤rskendamine Ãµnnestus',0),(376033,10446,'si','Banka uvozna podatkov uspeÅ¡no posodobljena',0),(376034,10446,'ba','Bank impor Data diperbarui berhasil',0),(376035,10446,'nl','Bankgegevens importeren met succes bijgewerkt',0),(376036,10446,'fi','Pankin tuontitiedot pÃ¤ivitetty',0),(376037,10446,'no','Banken importdataene oppdatert',0),(376038,10446,'da','Bank importdata opdateret',0),(376039,10446,'ko','ì€í–‰ ë°ì´í„° ê°€ì ¸ì˜¤ê¸° ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(376040,10446,'he','×‘× ×§ ×™×™×‘×•× × ×ª×•× ×™× ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(376041,10446,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î³Î¹Î± Ï„Î¹Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î­Ï‚ Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(376042,10446,'zh','é“¶è¡Œå¯¼å…¥æ•°æ®æ›´æ–°æˆåŠŸ\r\n',0),(376043,10446,'sv','Banken importera Data uppdaterades',0),(376044,10446,'it','Banca dati di importazione aggiornati con successo',0),(376045,10446,'tl','',0),(376046,10446,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸™à¸³à¹€à¸‚à¹‰à¸²à¸˜à¸™à¸²à¸„à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(376047,10446,'hi','à¤¬à¥ˆà¤‚à¤• à¤†à¤¯à¤¾à¤¤ à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(376048,10446,'ms','Bank Import Data berjaya dikemas kini',0),(376049,10446,'ar','Ø­Ø¯Ù‘Ø«Øª Ø¨ÙŠØ§Ù†Ø§Øª Ø¥Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…ØµØ±Ù Ø¨Ù†Ø¬Ø§Ø­',0),(376050,10446,'fr','Banque importation donnÃ©es mis Ã  jour avec succÃ¨s',0),(376051,10446,'jp','éŠ€è¡Œãƒ‡ãƒ¼ã‚¿ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆãŒæ­£å¸¸ã«æ›´æ–°',0),(376052,10446,'pt','Dados de banco de importaÃ§Ã£o atualizados com sucesso',0),(376053,10446,'ru','Ð‘Ð°Ð½Ðº Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(376054,10446,'es','Datos Bancarios de ImportaciÃ³n Actualizados Exitosamente',0),(376055,10446,'de','Bankdaten Import erfolgreich aktualisiert',0),(376056,10446,'en','Bank Import Data Updated Successfully',0),(376057,10447,'is','',0),(376058,10447,'dr','Ø§Ø³Ù†Ø§Ø¯ Ø¨Ø§Ù†ÙƒÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯',0),(376059,10447,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø¨Ø§Ù†ÙƒÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙˆØ§Ø±Ø¯ Ø´Ø¯',0),(376060,10447,'tr','Banka kayÄ±tlarÄ±nÄ± baÅŸarÄ±yla alÄ±ndÄ±',0),(376061,10447,'pl','PomyÅ›lnie zaimportowane rekordy banku',0),(376062,10447,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(376063,10447,'ur','Ø¨ÛŒÙ†Ú© Ú©ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯',0),(376064,10447,'sr','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð½Ðµ Ð¸Ð·Ð²Ð¾Ð´Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ²ÐµÐ·ÐµÐ½Ðµ',0),(376065,10447,'vi','Nháº­p há»“ sÆ¡ ngÃ¢n hÃ ng thÃ nh cÃ´ng',0),(376066,10447,'af','Bank Rekords Suksesvol Ingevoer',0),(376067,10447,'ro','Banca Records importat cu succes',0),(376068,10447,'et','Panga andmed edukalt imporditud',0),(376069,10447,'si','Banka zapisi, uvoÅ¾eni uspeÅ¡no',0),(376070,10447,'ba','Catatan Bank berhasil diimpor',0),(376071,10447,'nl','Bank Records geÃ¯mporteerd',0),(376072,10447,'fi','Pankeissa tuonti onnistui',0),(376073,10447,'no','Bankinformasjon importert',0),(376074,10447,'da','Bank poster importeret',0),(376075,10447,'ko','ì€í–‰ ë ˆì½”ë“œë¥¼ ì„±ê³µì ìœ¼ë¡œ ê°€ì ¸ì™”ëŠ”ë°',0),(376076,10447,'he','×¨×™×©×•×ž×™ ×”×‘× ×§ ×™×•×‘××• ×‘×”×¦×œ×—×”',0),(376077,10447,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(376078,10447,'zh','é“¶è¡Œè®°å½•æˆåŠŸå¯¼å…¥\r\n',0),(376079,10447,'sv','Bankposter har importerats',0),(376080,10447,'it','Banca record importato correttamente',0),(376081,10447,'tl','',0),(376082,10447,'th','à¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(376083,10447,'hi','à¤¬à¥ˆà¤‚à¤• à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤¯à¤¾à¤¤',0),(376084,10447,'ms','Rekod-rekod Bank yang berjaya diimport',0),(376085,10447,'ar','Ø¥Ø³ØªÙŠØ±Ø¯Øª Ø§Ù„Ø³Ø¬Ù„Ù‘Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(376086,10447,'fr','Dossiers de la Banque ont bien Ã©tÃ© importÃ©es',0),(376087,10447,'jp','éŠ€è¡Œã®è¨˜éŒ²ã‚’æ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã¾ã—ãŸ',0),(376088,10447,'pt','Banco registros importados com Ãªxito',0),(376089,10447,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(376090,10447,'es','Archivos Bancarios Importados Exitosamente',0),(376091,10447,'de','Bankunterlagen, die erfolgreich importiert',0),(376092,10447,'en','Bank Records Imported Successfully',0),(376093,10448,'is','',0),(376094,10448,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø®ÙˆØ§Ù†Ø¯Ù† ÙØ§ÙŠÙ„ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡  Ù†ÙŠØ³Øª',0),(376095,10448,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø®ÙˆØ§Ù†Ø¯Ù† ÙØ§ÙŠÙ„ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡  Ù†ÙŠØ³Øª',0),(376096,10448,'tr','YÃ¼klenen dosya okunamadÄ±',0),(376097,10448,'pl','Nie moÅ¼na odczytaÄ‡ pliku',0),(376098,10448,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð¿Ñ€Ð¾Ñ‡ÐµÑ‚Ðµ ÐºÐ°Ñ‡ÐµÐ½Ð¸Ñ Ñ„Ð°Ð¹Ð»',0),(376099,10448,'ur','Ø§Ù¾ Ù„ÙˆÚˆ Ù…Ø³Ù„ Ú©Ø§ Ù…Ø·Ø§Ù„Ø¹Û Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(376100,10448,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ðµ',0),(376101,10448,'vi','khÃ´ng thá»ƒ Ä‘á»c Ä‘Æ°á»£c file Ä‘Ã£ cáº­p nháº­t',0),(376102,10448,'af','Kon opgelaai lÃªer lees nie',0),(376103,10448,'ro','Imposibil de citit fiÅŸierul Ã®ncÄƒrcat',0),(376104,10448,'et','Ãœleslaetud faili ei saanud lugeda',0),(376105,10448,'si','Prenesene datoteke ni mogoÄe prebrati.',0),(376106,10448,'ba','Tidak bisa membaca File upload',0),(376107,10448,'nl','Kan ge-uploade bestand niet lezen',0),(376108,10448,'fi','Ladatun tiedoston lukeminen ei onnistunut',0),(376109,10448,'no','Kan ikke lese opplastede filen',0),(376110,10448,'da','Kunne ikke lÃ¦se uploadede fil',0),(376111,10448,'ko','ì—…ë¡œë“œ ëœ íŒŒì¼ì„ ì½ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(376112,10448,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×§×¨×•× ××ª ×”×§×•×‘×¥ ×©×”×•×¢×œ×”',0),(376113,10448,'el','Î”ÎµÎ½ Î®Ï„Î±Î½ Î´Ï…Î½Î±Ï„Î® Î· Î±Î½Î¬Î³Î½Ï‰ÏƒÎ· Ï†Î¿ÏÏ„ÏŽÎ½Ï‰ Î±ÏÏ‡ÎµÎ¯Î¿',0),(376114,10448,'zh','ä¸Šä¼ çš„æ–‡ä»¶æ— æ³•è¯»å–\r\n',0),(376115,10448,'sv','Kunde inte lÃ¤sa uppladdad fil',0),(376116,10448,'it','Non leggere File caricato',0),(376117,10448,'tl','',0),(376118,10448,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸­à¹ˆà¸²à¸™à¹à¸Ÿà¹‰à¸¡à¸—à¸µà¹ˆà¸­à¸±à¸›à¹‚à¸«à¸¥à¸”',0),(376119,10448,'hi','à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¥€ à¤—à¤ˆ à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¹à¥€à¤‚ à¤ªà¤¢ à¤¸à¤•à¤¾',0),(376120,10448,'ms','Tidak dapat membaca fail yang dimuat naik',0),(376121,10448,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ù‚Ø±Ø§Ø¡Ø© Ø§Ù„Ù…Ù„Ù Ø§Ù„Ø°ÙŠ ØªÙ… ØªØ­Ù…ÙŠÙ„Ù‡',0),(376122,10448,'fr','Pouvait pas lire le fichier tÃ©lÃ©chargÃ©',0),(376123,10448,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã•ã‚ŒãŸãƒ•ã‚¡ã‚¤ãƒ«ã‚’èª­ã¿å–ã‚Œã¾ã›ã‚“ã§ã—ãŸã€‚',0),(376124,10448,'pt','NÃ£o foi possÃ­vel ler o arquivo carregado',0),(376125,10448,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÐŸÑ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð—Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ð¹ Ð¤Ð°Ð¹Ð»',0),(376126,10448,'es','No se PodÃ­a Leer Archivo Subido',0),(376127,10448,'de','Hochgeladene Datei konnte nicht gelesen werden.',0),(376128,10448,'en','Could Not Read Uploaded File',0),(376129,10449,'is','',0),(376130,10449,'dr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ',0),(376131,10449,'pr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª ',0),(376132,10449,'tr','Son Ekstre tarihi',0),(376133,10449,'pl','Data zakoÅ„czenia instrukcja',0),(376134,10449,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(376135,10449,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(376136,10449,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(376137,10449,'vi','káº¿t thÃºc ngÃ y bÃ¡o cÃ¡o',0),(376138,10449,'af','End Staat Datum',0),(376139,10449,'ro','SfÃ¢rÅŸitul declaraÅ£ie datÄƒ',0),(376140,10449,'et','Aruande lÃµppkuupÃ¤ev',0),(376141,10449,'si','KonÄni datum izpiska',0),(376142,10449,'ba','Tanggal akhir pernyataan',0),(376143,10449,'nl','Verklaring einddatum',0),(376144,10449,'fi','Lausunto pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(376145,10449,'no','Setningen sluttdatoen',0),(376146,10449,'da','ErklÃ¦ring slutdato',0),(376147,10449,'ko','ìµœì¢… ê³„ì‚° ì„œ ë‚ ì§œ',0),(376148,10449,'he','×ª××¨×™×š ×¡×™×•× ×ž×©×¤×˜',0),(376149,10449,'el','Î”Î®Î»Ï‰ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(376150,10449,'zh','ç»“æŸå£°æ˜Žæ—¥æœŸ',0),(376151,10449,'sv','Uttalande slutdatum',0),(376152,10449,'it','Data di fine istruzione',0),(376153,10449,'tl','',0),(376154,10449,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸„à¸³à¸ªà¸±à¹ˆà¸‡',0),(376155,10449,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤•à¤¥à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(376156,10449,'ms','Tarikh penyata akhir',0),(376157,10449,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø¨ÙŠØ§Ù†',0),(376158,10449,'fr','Date de dÃ©claration de fin',0),(376159,10449,'jp','æœ€å¾Œã®ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã®æ—¥ä»˜',0),(376160,10449,'pt','Data da declaraÃ§Ã£o final',0),(376161,10449,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(376162,10449,'es','Fecha de DeclaraciÃ³n de TerminaciÃ³n',0),(376163,10449,'de','Ende Auszugsdatum',0),(376164,10449,'en','End Statement Date',0),(376165,10450,'is','',0),(376166,10450,'dr','Ø«Ø¨Øª Ø¯ÙØªØ± ÙƒÙ„',0),(376167,10450,'pr','Ø«Ø¨Øª Ø¯ÙØªØ± ÙƒÙ„',0),(376168,10450,'tr','GL giriÅŸ',0),(376169,10450,'pl','Wpis GL',0),(376170,10450,'bg','GL Ð·Ð°Ð¿Ð¸Ñ',0),(376171,10450,'ur','Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(376172,10450,'sr','Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐ°',0),(376173,10450,'vi','ghi sá»• cÃ¡i',0),(376174,10450,'af','AG Inskrywing',0),(376175,10450,'ro','Intrare GL',0),(376176,10450,'et','GL kanne',0),(376177,10450,'si','GL vstop',0),(376178,10450,'ba','GL entri',0),(376179,10450,'nl','GL Entry',0),(376180,10450,'fi','GL merkintÃ¤',0),(376181,10450,'no','GL oppfÃ¸ring',0),(376182,10450,'da','GL post',0),(376183,10450,'ko','GL í•­ëª©',0),(376184,10450,'he','×›× ×™×¡×” GL',0),(376185,10450,'el','GL ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(376186,10450,'zh','æ€»å¸æ¡ç›®\r\n',0),(376187,10450,'sv','GL intrÃ¤de',0),(376188,10450,'it','Voce GL',0),(376189,10450,'tl','',0),(376190,10450,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(376191,10450,'hi','GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(376192,10450,'ms','Kemasukan GL',0),(376193,10450,'ar','Ø¯Ø®ÙˆÙ„ GL',0),(376194,10450,'fr','EntrÃ©e GL',0),(376195,10450,'jp','GL ã‚¨ãƒ³ãƒˆãƒª',0),(376196,10450,'pt','Entrada GL',0),(376197,10450,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ GL',0),(376198,10450,'es','Entrada de LM',0),(376199,10450,'de','GL-Eintrag',0),(376200,10450,'en','GL Entry',0),(376201,10451,'is','',0),(376202,10451,'dr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(376203,10451,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ',0),(376204,10451,'tr','GL fiÅŸ',0),(376205,10451,'pl','GL Voucher',0),(376206,10451,'bg','GL Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(376207,10451,'ur','Ø¬ÛŒØ¬Û’ ÙˆØ§Ø¤Ú†Ø±',0),(376208,10451,'sr','Ð“Ð› Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(376209,10451,'vi','phiáº¿u sá»• cÃ¡i',0),(376210,10451,'af','AG Bewysstuk ',0),(376211,10451,'ro','GL Voucher',0),(376212,10451,'et','GL kanne',0),(376213,10451,'si','GL kupon',0),(376214,10451,'ba','GL Voucher',0),(376215,10451,'nl','GL Voucher',0),(376216,10451,'fi','GL tosite',0),(376217,10451,'no','GL bilag',0),(376218,10451,'da','GL Voucher',0),(376219,10451,'ko','GL ë°”ìš°ì²˜',0),(376220,10451,'he','×©×•×‘×¨ GL',0),(376221,10451,'el','GL ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(376222,10451,'zh','æ€»å¸å‡­è¯\r\n',0),(376223,10451,'sv','GL verifikation',0),(376224,10451,'it','Voucher GL',0),(376225,10451,'tl','',0),(376226,10451,'th','GL à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸',0),(376227,10451,'hi','à¤œà¥€à¤à¤² à¤µà¤¾à¤‰à¤šà¤°',0),(376228,10451,'ms','GL baucer',0),(376229,10451,'ar','Ù‚Ø³ÙŠÙ…Ø© GL',0),(376230,10451,'fr','Bon GL',0),(376231,10451,'jp','GL ä¼ç¥¨',0),(376232,10451,'pt','Voucher GL',0),(376233,10451,'ru','GL Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(376234,10451,'es','Voucher de LM',0),(376235,10451,'de','GL-Gutschein',0),(376236,10451,'en','GL Voucher',0),(376237,10452,'is','',0),(376238,10452,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù‡Ø§ÙŠ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ ',0),(376239,10452,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù‡Ø§ÙŠ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ ',0),(376240,10452,'tr','AlÄ±nan ifadeler',0),(376241,10452,'pl','Zaimportowane sprawozdania',0),(376242,10452,'bg','Ð’Ð½ÐµÑÐµÐ½Ð¸Ñ‚Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(376243,10452,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û Ø¨ÛŒØ§Ù†Ø§Øª',0),(376244,10452,'sr','Ð£Ð²ÐµÐ·ÐµÐ½Ð¸ Ð¸Ð·Ñ˜Ð°Ð²Ðµ',0),(376245,10452,'vi','Nháº­p báº£ng kÃª',0),(376246,10452,'af','Ingevoerde State',0),(376247,10452,'ro','Import afirmaÅ£ii',0),(376248,10452,'et','Imporditavate seletused',0),(376249,10452,'si','UvoÅ¾ene izjave',0),(376250,10452,'ba','Impor pernyataan',0),(376251,10452,'nl','GeÃ¯mporteerde verklaringen',0),(376252,10452,'fi','Tuodut lausunnot',0),(376253,10452,'no','Importerte uttalelser',0),(376254,10452,'da','Importerede udtalelser',0),(376255,10452,'ko','ìˆ˜ìž…ëœ ë¬¸',0),(376256,10452,'he','×”×¦×”×¨×•×ª ×ž×™×•×‘××™×',0),(376257,10452,'el','Î•Î¹ÏƒÎ±Î³ÏŒÎ¼ÎµÎ½Î± Î´Î·Î»ÏŽÏƒÎµÎ¹Ï‚',0),(376258,10452,'zh','å¯¼å…¥å£°æ˜Ž\r\n',0),(376259,10452,'sv','Importerade uttalanden',0),(376260,10452,'it','Dichiarazioni importate',0),(376261,10452,'tl','',0),(376262,10452,'th','à¸„à¸³à¸ªà¸±à¹ˆà¸‡à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(376263,10452,'hi','à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ à¤¬à¤¯à¤¾à¤¨',0),(376264,10452,'ms','Penyata yang diimport',0),(376265,10452,'ar','ÙƒØ´ÙˆÙØ§Øª Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(376266,10452,'fr','DÃ©clarations importÃ©es',0),(376267,10452,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆ',0),(376268,10452,'pt','InstruÃ§Ãµes importadas',0),(376269,10452,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð½Ñ‹Ðµ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ñ',0),(376270,10452,'es','Estados de Cuenta Importados',0),(376271,10452,'de','Importierte Anweisungen',0),(376272,10452,'en','Imported Statements',0),(376273,10453,'is','',0),(376274,10453,'dr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ø­Ø°Ù',0),(376275,10453,'pr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ø­Ø°Ù',0),(376276,10453,'tr','Silme iÅŸlemi baÅŸlayacak',0),(376277,10453,'pl','Data usuniÄ™cia rozp.',0),(376278,10453,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(376279,10453,'ur','Ø­Ø°Ù Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¢ØºØ§Ø²',0),(376280,10453,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð±Ñ€Ð¸ÑÐ°ÑšÐ°',0),(376281,10453,'vi','Báº¯t Ä‘áº§u xÃ³a ngÃ y',0),(376282,10453,'af','Begin skrapping datum',0),(376283,10453,'ro','ÃŽncepe ÅŸtergerea data',0),(376284,10453,'et','Alustada kustutamise aeg',0),(376285,10453,'si','ZaÄetni datum izbrisa',0),(376286,10453,'ba','Mulai tanggal penghapusan',0),(376287,10453,'nl','Begindatum schrapping',0),(376288,10453,'fi','Poiston aloituspÃ¤ivÃ¤',0),(376289,10453,'no','Begynn sletting dato',0),(376290,10453,'da','Begynde sletningen dato',0),(376291,10453,'ko','ì‚­ì œ ë‚ ì§œë¥¼ ì‹œìž‘',0),(376292,10453,'he','×ª××¨×™×š ×ž×—×™×§×” ×‘×’×™×Ÿ',0),(376293,10453,'el','Î‘ÏÏ‡Î¯ÏƒÎµÎ¹ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚',0),(376294,10453,'zh','å¼€å§‹åˆ é™¤æ—¥æœŸ',0),(376295,10453,'sv','BÃ¶rja ta bort datum',0),(376296,10453,'it','Iniziare data cancellazione',0),(376297,10453,'tl','',0),(376298,10453,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸à¸²à¸£à¸¥à¸š',0),(376299,10453,'hi','à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­',0),(376300,10453,'ms','Mula tarikh penghapusan',0),(376301,10453,'ar','ÙŠØ¨Ø¯Ø£ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø°Ù',0),(376302,10453,'fr','Date de suppression de Begin',0),(376303,10453,'jp','å‰Šé™¤æ—¥ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(376304,10453,'pt','ComeÃ§ar a data de exclusÃ£o',0),(376305,10453,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(376306,10453,'es','Comienza la fecha de eliminaciÃ³n',0),(376307,10453,'de','LÃ¶schdatum beginnen',0),(376308,10453,'en','Begin Deletion Date',0),(376309,10454,'is','',0),(376310,10454,'dr','ØªØ§Ø±ÛŒØ® Ø­Ø°Ù',0),(376311,10454,'pr','ØªØ§Ø±ÛŒØ® Ø­Ø°Ù',0),(376312,10454,'tr','Silme tarihi',0),(376313,10454,'pl','Data usuniÄ™cia',0),(376314,10454,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(376315,10454,'ur','Ø­Ø°Ù Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(376316,10454,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð±Ñ€Ð¸ÑÐ°ÑšÐ°',0),(376317,10454,'vi','XÃ³a ngÃ y',0),(376318,10454,'af','Skrapping datum',0),(376319,10454,'ro','Åžtergerea data',0),(376320,10454,'et','Kustutamise aeg',0),(376321,10454,'si','Datum izbrisa',0),(376322,10454,'ba','Penghapusan tanggal',0),(376323,10454,'nl','Schrapping datum',0),(376324,10454,'fi','Poiston pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(376325,10454,'no','Sletting dato',0),(376326,10454,'da','Sletning dato',0),(376327,10454,'ko','ì‚­ì œ ë‚ ì§œ',0),(376328,10454,'he','×ª××¨×™×š ×ž×—×™×§×”',0),(376329,10454,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚',0),(376330,10454,'zh','åˆ é™¤æ—¥æœŸ',0),(376331,10454,'sv','Strykningen datum',0),(376332,10454,'it','Data di cancellazione',0),(376333,10454,'tl','',0),(376334,10454,'th','à¸à¸²à¸£à¸¥à¸šà¸§à¸±à¸™',0),(376335,10454,'hi','à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(376336,10454,'ms','Tarikh penghapusan',0),(376337,10454,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø°Ù',0),(376338,10454,'fr','Date de la suppression',0),(376339,10454,'jp','å‰Šé™¤æ—¥',0),(376340,10454,'pt','Data de exclusÃ£o',0),(376341,10454,'ru','Ð”Ð°Ñ‚Ð° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ',0),(376342,10454,'es','Fecha de eliminaciÃ³n',0),(376343,10454,'de','LÃ¶schdatum',0),(376344,10454,'en','Deletion Date',0),(376345,10455,'is','',0),(376346,10455,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø°Ù',0),(376347,10455,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø°Ù',0),(376348,10455,'tr','Silme rapor',0),(376349,10455,'pl','UsuniÄ™cie raportu',0),(376350,10455,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(376351,10455,'ur','Ø­Ø°Ù Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(376352,10455,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(376353,10455,'vi','XÃ³a bÃ¡o cÃ¡o',0),(376354,10455,'af','Skrapping verslag',0),(376355,10455,'ro','Åžtergere raport',0),(376356,10455,'et','Kustutamise aruanne',0),(376357,10455,'si','Izbris poroÄilo',0),(376358,10455,'ba','Penghapusan laporan',0),(376359,10455,'nl','Schrapping verslag',0),(376360,10455,'fi','Poistaminen raportti',0),(376361,10455,'no','Sletting rapport',0),(376362,10455,'da','Sletning rapport',0),(376363,10455,'ko','ì‚­ì œ ë³´ê³ ì„œ',0),(376364,10455,'he','×“×•×— ×ž×—×™×§×”',0),(376365,10455,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(376366,10455,'zh','åˆ é™¤æŠ¥å‘Š',0),(376367,10455,'sv','Borttagning rapport',0),(376368,10455,'it','Rapporto di eliminazione',0),(376369,10455,'tl','',0),(376370,10455,'th','à¸à¸²à¸£à¸¥à¸šà¸£à¸²à¸¢à¸‡à¸²à¸™',0),(376371,10455,'hi','à¤µà¤¿à¤²à¥‹à¤ªà¤¨ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(376372,10455,'ms','Penghapusan Laporan',0),(376373,10455,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø­Ø°Ù',0),(376374,10455,'fr','Rapport de suppression',0),(376375,10455,'jp','å‰Šé™¤ãƒ¬ãƒãƒ¼ãƒˆ',0),(376376,10455,'pt','RelatÃ³rio de exclusÃ£o',0),(376377,10455,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(376378,10455,'es','Reporte de eliminaciÃ³n',0),(376379,10455,'de','LÃ¶schung-Bericht',0),(376380,10455,'en','Deletion Report',0),(376381,10456,'is','',0),(376382,10456,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¬Ø¯ÙŠØ¯ ',0),(376383,10456,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø¬Ø¯ÙŠØ¯ ',0),(376384,10456,'tr','Ä°Ã§e aktarÄ±mÄ± yeni',0),(376385,10456,'pl','Importuj nowe',0),(376386,10456,'bg','ÐÐ¾Ð² Ð²Ð½Ð¾Ñ',0),(376387,10456,'ur','Ù†Ø¦Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(376388,10456,'sr','Ð£Ð²Ð¾Ð· Ð½Ð¾Ð²Ð¾Ð³',0),(376389,10456,'vi','Nháº­p má»›i',0),(376390,10456,'af','Invoer van Nuwe',0),(376391,10456,'ro','Noi de import',0),(376392,10456,'et','Impordi uus',0),(376393,10456,'si','Uvoz novega',0),(376394,10456,'ba','Impor baru',0),(376395,10456,'nl','Nieuwe invoer',0),(376396,10456,'fi','Tuonti uusi',0),(376397,10456,'no','Importere nye',0),(376398,10456,'da','Importer nye',0),(376399,10456,'ko','ìƒˆë¡œìš´ ê°€ì ¸ì˜¤ê¸°',0),(376400,10456,'he','×™×™×‘×•× ×—×“×©',0),(376401,10456,'el','ÎÎ­Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(376402,10456,'zh','å¯¼å…¥æ–°\r\n',0),(376403,10456,'sv','Importera nya',0),(376404,10456,'it','Nuova importazione',0),(376405,10456,'tl','',0),(376406,10456,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹ƒà¸«à¸¡à¹ˆ',0),(376407,10456,'hi','à¤¨à¤ˆ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(376408,10456,'ms','Import baru',0),(376409,10456,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¬Ø¯ÙŠØ¯',0),(376410,10456,'fr','Importation nouveau',0),(376411,10456,'jp','æ–°ã—ã„ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(376412,10456,'pt','Nova importaÃ§Ã£o',0),(376413,10456,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐÐ¾Ð²Ð¾Ð³Ð¾',0),(376414,10456,'es','Importar Nuevo',0),(376415,10456,'de','Import von neu',0),(376416,10456,'en','Import New',0),(376417,10457,'is','',0),(376418,10457,'dr','(Ø¯ÙØ§ØªØ±)Ø¬Ø¯ÙŠØ¯ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯',0),(376419,10457,'pr','Ø§Ø³Ù†Ø§Ø¯(Ø¯ÙØ§ØªØ±)Ø¬Ø¯ÙŠØ¯ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯',0),(376420,10457,'tr','Yeni kayÄ±t eklendi',0),(376421,10457,'pl','Nie nowe dodaÄ‡ rekordy',0),(376422,10457,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ Ð½Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(376423,10457,'ur','Ú©ÙˆØ¦ÛŒ Ù†ÛŒØ§ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(376424,10457,'sr','ÐÐµÐ¼Ð° Ð½Ð¾Ð²Ð¸Ñ… Ð·Ð°Ð¿Ð¸ÑÐ°, Ð´Ð¾Ð´Ð°Ð¾ Ñ˜Ðµ',0),(376425,10457,'vi','khÃ´ng thÃªm Ä‘Æ°á»£c ghi chÃ©p má»›i',0),(376426,10457,'af','Geen Nuwe Rekords Bygevoeg',0),(376427,10457,'ro','Nici noile Ã®nregistrÄƒri adÄƒugate',0),(376428,10457,'et','Uued kirjeid ei lisatud',0),(376429,10457,'si','Ni novih zapisov, dodanih',0),(376430,10457,'ba','Tidak ada catatan baru ditambahkan',0),(376431,10457,'nl','Geen nieuwe Records toegevoegd',0),(376432,10457,'fi','Uusia tietueita ei lisÃ¤tÃ¤',0),(376433,10457,'no','Ingen nye oppfÃ¸ringer legges til',0),(376434,10457,'da','Ingen nye poster tilfÃ¸jet',0),(376435,10457,'ko','ì•„ë‹ˆ ìƒˆ ë ˆì½”ë“œ ì¶”ê°€',0),(376436,10457,'he','××™×Ÿ ×¨×©×•×ž×•×ª ×—×“×©×•×ª ×©× ×•×¡×¤×•',0),(376437,10457,'el','Î”ÎµÎ½ Î½Î­ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Ï€Î¿Ï… Ï€ÏÎ¿ÏƒÏ„Î¯Î¸ÎµÏ„Î±Î¹',0),(376438,10457,'zh','æ²¡æœ‰æ·»åŠ æ–°è®°å½•\r\n',0),(376439,10457,'sv','Inga nya poster lÃ¤ggs',0),(376440,10457,'it','Nessun nuovo record aggiunto',0),(376441,10457,'tl','',0),(376442,10457,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”à¹ƒà¸«à¸¡à¹ˆà¸—à¸µà¹ˆà¹€à¸žà¸´à¹ˆà¸¡',0),(376443,10457,'hi','à¤•à¥‹à¤ˆ à¤¨à¤¯à¤¾ à¤…à¤­à¤¿à¤²à¥‡à¤– à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(376444,10457,'ms','Tiada rekod baru yang ditambah',0),(376445,10457,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø³Ø¬Ù„Ø§Øª Ø¬Ø¯ÙŠØ¯Ø© ØªØ¶Ø§Ù',0),(376446,10457,'fr','Aucun nouveaux enregistrements ajoutÃ©s',0),(376447,10457,'jp','ã„ã„ãˆã€æ–°ã—ã„è¨˜éŒ²ã‚’è¿½åŠ ',0),(376448,10457,'pt','NÃ£o hÃ¡ novos registros adicionados',0),(376449,10457,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(376450,10457,'es','No se Agregaron Nuevos Records',0),(376451,10457,'de','Keine neue DatensÃ¤tze hinzugefÃ¼gt',0),(376452,10457,'en','No New Records Added',0),(376453,10458,'is','',0),(376454,10458,'dr','OFX ÙØ§ÙŠÙ„ ØªØ¨Ø§Ø¯Ù„Ø§Øª Ù…Ø§Ù„ÙŠ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ',0),(376455,10458,'pr','OFX ÙØ§ÙŠÙ„ ØªØ¨Ø§Ø¯Ù„Ø§Øª Ù…Ø§Ù„ÙŠ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ\r\n',0),(376456,10458,'tr','QFX-OFX-Web baÄŸlamak eÄŸe',0),(376457,10458,'pl','Web-OFX/QFX poÅ‚Ä…czyÄ‡ plik',0),(376458,10458,'bg','OFX/QFX/ÑƒÐµÐ± ÑÐ²ÑŠÑ€Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(376459,10458,'ur','Ø§/Ù‚Ù/ÙˆÛŒØ¨ Ù…Ø³Ù„ Ø³Û’ Ø¬Ú‘ÛŒÚº',0),(376460,10458,'sr','ÐžÐ¤X/QÐ¤X /WÐµÐ± Ð¿Ð¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(376461,10458,'vi','File OFX',0),(376462,10458,'af','OFX LÃªer',0),(376463,10458,'ro','QFX/OFX/Web conecta fiÅŸier',0),(376464,10458,'et','OFX/QFX/Web Ã¼hendust faili',0),(376465,10458,'si','OFX/QFX/ujeti povezavo datoteke',0),(376466,10458,'ba','OFX/QFX/Web menghubungkan File',0),(376467,10458,'nl','OFX/QFX/Web verbinding bestand',0),(376468,10458,'fi','OFX/QFX/Web LiitÃ¤ tiedosto',0),(376469,10458,'no','OFX/QFX/Web koble filen',0),(376470,10458,'da','OFX/QFX/Web forbinde fil',0),(376471,10458,'ko','OFX/QFX/ì›¹ ì—°ê²° íŒŒì¼',0),(376472,10458,'he','Ofx ×”×ª×•×¡×¤×ª/QFX/××™× ×˜×¨× ×˜ ×œ×”×ª×—×‘×¨ ×§×•×‘×¥',0),(376473,10458,'el','OFX/QFX/Web ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Î±ÏÏ‡ÎµÎ¯Î¿',0),(376474,10458,'zh','å¼€æ”¾çš„é‡‘èžäº¤æ˜“æ–‡ä»¶\r\n',0),(376475,10458,'sv','OFX/QFX/Web ansluta fil',0),(376476,10458,'it','Web/OFX/QFX collegare File',0),(376477,10458,'tl','',0),(376478,10458,'th','OFX QFX/à¹€à¸§à¹‡à¸š à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¹à¸Ÿà¹‰à¸¡',0),(376479,10458,'hi','OFX/QFX/à¤µà¥‡à¤¬ à¤•à¤¨à¥‡à¤•à¥à¤Ÿ à¤•à¤°à¥‡à¤‚ à¤«à¤¼à¤¾à¤‡à¤²',0),(376480,10458,'ms','OFX/QFX/Web sambung fail',0),(376481,10458,'ar','ÙÙƒØ³/QFX/ÙˆÙŠØ¨ Ø§Ù„Ø§ØªØµØ§Ù„ Ø§Ù„Ù…Ù„Ù',0),(376482,10458,'fr','OFX/QFX/Web Connect fichier',0),(376483,10458,'jp','Ofx ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ QFX/Web ã®æŽ¥ç¶šãƒ•ã‚¡ã‚¤ãƒ«',0),(376484,10458,'pt','Web/OFX/QFX conectar arquivo',0),(376485,10458,'ru','OFX/QFX/Ð²ÐµÐ±-Ð¿Ð¾Ð´ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ Ñ„Ð°Ð¹Ð»Ð°',0),(376486,10458,'es','File de OFX',0),(376487,10458,'de','OFX/QFX/Web-Connect-Datei',0),(376488,10458,'en','OFX/QFX/Web Connect File',0),(376489,10459,'is','',0),(376490,10459,'dr','OFX File',0),(376491,10459,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ ÙØ§ÙŠÙ„ Ø¨Ø§Ù†ÙƒÙŠ ØªØ¨Ø§Ø¯Ù„Ø§Øª Ù…Ø§Ù„ÙŠ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ  OFX File',0),(376492,10459,'tr','SELECT banka Web/OFX/QFX baÄŸlamak eÄŸe',0),(376493,10459,'pl','Wybierz Bank OFX/QFX/Web poÅ‚Ä…czyÄ‡ plik',0),(376494,10459,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð±Ð°Ð½ÐºÐ° OFX/QFX/ÑƒÐµÐ± ÑÐ²ÑŠÑ€Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(376495,10459,'ur','Ù…Ù†ØªØ®Ø¨ Ø¨ÛŒÙ†Ú© Ø§/Ù‚Ù/ÙˆÛŒØ¨ Ù…Ø³Ù„ Ø³Û’ Ø¬Ú‘ÛŒÚº',0),(376496,10459,'sr','ÐžÐ´Ð°Ð±Ð¸Ñ€ Ð±Ð°Ð½ÐºÐµ ÐžÐ¤X/QÐ¤X/WÐµÐ± Ð¿Ð¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(376497,10459,'vi','Chá»n táº­p tin OFX ngÃ¢n hÃ ng',0),(376498,10459,'af','Selekteer Bank OFX LÃªer',0),(376499,10459,'ro','SelectaÅ£i Banca OFX/QFX/Web conecta fiÅŸier',0),(376500,10459,'et','Valige pank OFX/QFX/Web Ã¼hendust faili',0),(376501,10459,'si','Izberite banke OFX/QFX/Web povezavo datoteke',0),(376502,10459,'ba','Pilih Bank OFX/QFX/Web menghubungkan File',0),(376503,10459,'nl','Selecteer Bank OFX/QFX/Web verbinding bestand',0),(376504,10459,'fi','Valitse pankki OFX/QFX/Web LiitÃ¤ tiedosto',0),(376505,10459,'no','Velg Bank OFX/QFX/Web koble filen',0),(376506,10459,'da','VÃ¦lg Bank OFX/QFX/Web forbinde fil',0),(376507,10459,'ko','ì„ íƒ ì€í–‰ OFX/QFX/ì›¹ ì—°ê²° íŒŒì¼',0),(376508,10459,'he','×‘×—×¨ ×‘× ×§ ofx ×”×ª×•×¡×¤×ª/QFX/××™× ×˜×¨× ×˜ ×œ×”×ª×—×‘×¨ ×§×•×‘×¥',0),(376509,10459,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¤ÏÎ¬Ï€ÎµÎ¶Î± OFX/QFX/Web ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Î±ÏÏ‡ÎµÎ¯Î¿',0),(376510,10459,'zh','é€‰æ‹©å­˜å‚¨å¼€æ”¾é‡‘èžä¿¡æ¯äº¤æ˜“æ‰€æ–‡ä»¶\r\n',0),(376511,10459,'sv','VÃ¤lj Bank OFX/QFX/Web ansluta fil',0),(376512,10459,'it','Seleziona Banca OFX/QFX/Web collegare File',0),(376513,10459,'tl','',0),(376514,10459,'th','à¹€à¸¥à¸·à¸­à¸ à¸˜à¸™à¸²à¸„à¸²à¸£ OFX/QFX/à¹€à¸§à¹‡à¸š à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¹à¸Ÿà¹‰à¸¡',0),(376515,10459,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤¬à¥ˆà¤‚à¤• OFX/QFX/à¤µà¥‡à¤¬ à¤•à¤¨à¥‡à¤•à¥à¤Ÿ',0),(376516,10459,'ms','Pilih Bank OFX/QFX/Web sambung fail',0),(376517,10459,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø¨Ù†Ùƒ ÙÙƒØ³/QFX/ÙˆÙŠØ¨ Ø§Ù„Ø§ØªØµØ§Ù„ Ø§Ù„Ù…Ù„Ù',0),(376518,10459,'fr','SÃ©lectionnez la Banque OFX/QFX/Web Connect fichier',0),(376519,10459,'jp','ã‚»ãƒ¬ã‚¯ãƒˆ ãƒãƒ³ã‚¯ ofx ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ QFX//web æŽ¥ç¶šãƒ•ã‚¡ã‚¤ãƒ«',0),(376520,10459,'pt','Selecionar Banco OFX/QFX/Web Connect arquivo',0),(376521,10459,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð±Ð°Ð½Ðº OFX/QFX/Ð²ÐµÐ±-Ð¿Ð¾Ð´ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ Ñ„Ð°Ð¹Ð»Ð°',0),(376522,10459,'es','Seleccionar File OFX de Banco',0),(376523,10459,'de','WÃ¤hlen Sie Bank OFX/QFX/Web-Connect-Datei',0),(376524,10459,'en','Select Bank OFX/QFX/Web Connect File',0),(376525,10460,'is','',0),(376526,10460,'dr','Ø§ÙŠÙ† ÙØ§ÙŠÙ„ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(376527,10460,'pr','Ø§ÙŠÙ† ÙØ§ÙŠÙ„ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(376528,10460,'tr','Bu dosya zaten Tarih',0),(376529,10460,'pl','Ten plik zostaÅ‚ juÅ¼ wgrany',0),(376530,10460,'bg','Ð¢Ð¾Ð·Ð¸ Ñ„Ð°Ð¹Ð» Ð²ÐµÑ‡Ðµ Ðµ Ð±Ð¸Ð» ÐºÐ°Ñ‡ÐµÐ½',0),(376531,10460,'ur','ÛŒÛ Ù…Ø³Ù„ Ù¾ÛÙ„Û’ ÛÛŒ Ø§Ù¾ Ù„ÙˆÚˆ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(376532,10460,'sr','ÐžÐ²Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð²ÐµÑ› Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ð°.',0),(376533,10460,'vi','táº­p tin nÃ y Ä‘Ã£ Ä‘Æ°á»£c táº£i lÃªn',0),(376534,10460,'af','Hierdie LÃªer Is Alreeds Opgelaai',0),(376535,10460,'ro','Acest fiÅŸier a fost Ã®ncÄƒrcat deja',0),(376536,10460,'et','See fail on juba Ã¼les laaditud',0),(376537,10460,'si','Ta datoteka je Å¾e prenesena',0),(376538,10460,'ba','File ini telah diunggah',0),(376539,10460,'nl','Dit bestand is reeds geupload',0),(376540,10460,'fi','TÃ¤mÃ¤ tiedosto on jo ladattu',0),(376541,10460,'no','Denne filen er allerede lastet opp',0),(376542,10460,'da','Denne fil er allerede blevet uploadet',0),(376543,10460,'ko','ì´ íŒŒì¼ì´ ì´ë¯¸ ì—…ë¡œë“œ ë˜ì—ˆëŠ”ì§€',0),(376544,10460,'he','×”×§×•×‘×¥ ×”×–×” ×›×‘×¨ ×”×•×¢×œ×”',0),(376545,10460,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î­Ï‡ÎµÎ¹ Ï†Î¿ÏÏ„Ï‰Î¸ÎµÎ¯ Î®Î´Î·',0),(376546,10460,'zh','æ­¤æ–‡ä»¶å·²ç»ä¸Šä¼ \r\n',0),(376547,10460,'sv','Denna fil har redan laddats upp',0),(376548,10460,'it','Questo File Ã¨ giÃ  stato caricato',0),(376549,10460,'tl','',0),(376550,10460,'th','à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¹à¸Ÿà¹‰à¸¡à¸™à¸µà¹‰à¹à¸¥à¹‰à¸§',0),(376551,10460,'hi','à¤¯à¤¹ à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(376552,10460,'ms','Fail ini telah pun dimuat naik',0),(376553,10460,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù…Ù„Ù Ù…Ø­Ù…Ù‘Ù„ Ù…Ø³Ø¨Ù‚Ø§',0),(376554,10460,'fr','Ce fichier a dÃ©jÃ  Ã©tÃ© tÃ©lÃ©chargÃ©',0),(376555,10460,'jp','ã“ã®ãƒ•ã‚¡ã‚¤ãƒ«ãŒæ—¢ã«ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(376556,10460,'pt','Este arquivo jÃ¡ foi carregado',0),(376557,10460,'ru','Ð­Ñ‚Ð¾Ñ‚ Ñ„Ð°Ð¹Ð» ÑƒÐ¶Ðµ Ð±Ñ‹Ð» Ð·Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½',0),(376558,10460,'es','Este File Ya Ha Sido Subido',0),(376559,10460,'de','Diese Datei wurde bereits hochgeladen',0),(376560,10460,'en','This File Has Already Been Uploaded',0),(376561,10461,'is','',0),(376562,10461,'dr','Ø§ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(376563,10461,'pr','Ø§ÙŠÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(376564,10461,'tr','Zaten bu iÅŸlem',0),(376565,10461,'pl','Ta transakcja juÅ¼ istnieje',0),(376566,10461,'bg','Ð¢Ð°Ð·Ð¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(376567,10461,'ur','ÛŒÛ Ù…Ø¹Ø§Ù…Ù„Û Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(376568,10461,'sr','ÐžÐ²Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(376569,10461,'vi','Giao dá»‹ch nÃ y Ä‘Ã£ Tá»“n táº¡i',0),(376570,10461,'af','Hierdie Transaksie Bestaan Alreeds',0),(376571,10461,'ro','AceastÄƒ tranzacÈ›ie deja existÄƒ',0),(376572,10461,'et','Selles tehingus juba olemas',0),(376573,10461,'si','To transakcijo Å¾e obstaja',0),(376574,10461,'ba','Transaksi ini sudah ada',0),(376575,10461,'nl','Deze transactie al bestaat',0),(376576,10461,'fi','Tapahtuma on jo olemassa',0),(376577,10461,'no','Denne transaksjonen allerede finnes',0),(376578,10461,'da','Denne transaktion allerede findes',0),(376579,10461,'ko','ì´ íŠ¸ëžœìž­ì…˜ì´ ì´ë¯¸ ì¡´ìž¬',0),(376580,10461,'he','×ª× ×•×¢×” ×–×• ×›×‘×¨ ×§×™×™×ž×ª',0),(376581,10461,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î±Ï…Ï„Î®Î½ Ï„Î· ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Î®Î´Î·',0),(376582,10461,'zh','è¿™é¡¹äº¤æ˜“å·²ç»å­˜åœ¨\r\n',0),(376583,10461,'sv','Denna transaktion redan finns',0),(376584,10461,'it','Esiste giÃ  questa transazione',0),(376585,10461,'tl','',0),(376586,10461,'th','à¸¡à¸µà¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸™à¸µà¹‰à¹à¸¥à¹‰à¸§',0),(376587,10461,'hi','à¤‡à¤¸ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(376588,10461,'ms','Urusniaga ini telah pun wujud',0),(376589,10461,'ar','Ø§Ù„Ø¹Ù…Ù„ÙŠØ© Ù…ÙˆØ¬ÙˆØ¯Ø© Ù…Ø³Ø¨Ù‚Ø§',0),(376590,10461,'fr','Cette Transaction dÃ©jÃ  existe',0),(376591,10461,'jp','ã“ã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™',0),(376592,10461,'pt','Esta transaÃ§Ã£o jÃ¡ existe',0),(376593,10461,'ru','Ð­Ñ‚Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(376594,10461,'es','Esta TransacciÃ³n Ya Existe',0),(376595,10461,'de','Diese Transaktion bereits vorhanden ist',0),(376596,10461,'en','This Transaction Already Exists',0),(376597,10462,'is','',0),(376598,10462,'dr','Ù„ÙŠÙ†Ùƒ Ù†Ø´Ø¯Ù‡ ',0),(376599,10462,'pr','Ù„ÙŠÙ†Ùƒ Ù†Ø´Ø¯Ù‡ ',0),(376600,10462,'tr','BaÄŸlantÄ±sÄ±nÄ± KaldÄ±r',0),(376601,10462,'pl','RozÅ‚Ä…cz',0),(376602,10462,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð½ÐµÑ‚Ðµ Ð²Ñ€ÑŠÐ·ÐºÐ°Ñ‚Ð°',0),(376603,10462,'ur','Ø¨Û’ Ø±Ø¨Ø· Ú©Ø±ÛŒÚº',0),(376604,10462,'sr','Ð Ð°ÑÐºÐ¸Ð´Ð°ÑšÐµ Ð²ÐµÐ·Ðµ',0),(376605,10462,'vi','thÃ¡o váº£i lÃ³t',0),(376606,10462,'af','Ontkoppel',0),(376607,10462,'ro','Deconectarea',0),(376608,10462,'et','TÃ¼hista linkimine',0),(376609,10462,'si','Prekini povezavo',0),(376610,10462,'ba','Tautan',0),(376611,10462,'nl','Ontkoppelen',0),(376612,10462,'fi','Poista linkitys',0),(376613,10462,'no','Koble fra',0),(376614,10462,'da','Fjerne sammenkÃ¦dningen',0),(376615,10462,'ko','ì—°ê²° í•´ì œ',0),(376616,10462,'he','×‘×˜×œ ×§×™×©×•×¨',0),(376617,10462,'el','Î‘Ï€Î¿ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(376618,10462,'zh','å–æ¶ˆé“¾æŽ¥\r\n',0),(376619,10462,'sv','AvlÃ¤nka',0),(376620,10462,'it','Scollegare',0),(376621,10462,'tl','',0),(376622,10462,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡',0),(376623,10462,'hi','à¤…à¤¨à¤²à¤¿à¤‚à¤• à¤•à¤°à¥‡à¤‚',0),(376624,10462,'ms','Nyahpaut',0),(376625,10462,'ar','ÙÙƒ Ø§Ø±ØªØ¨Ø§Ø·',0),(376626,10462,'fr','Supprimer le lien',0),(376627,10462,'jp','ãƒªãƒ³ã‚¯ã‚’è§£é™¤ã—ã¾ã™ã€‚',0),(376628,10462,'pt','Desvincular',0),(376629,10462,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÐ²ÑÐ·ÑŒ',0),(376630,10462,'es','Desconectar',0),(376631,10462,'de','Aufheben der VerknÃ¼pfung',0),(376632,10462,'en','Unlink',0),(376633,10463,'is','',0),(376634,10463,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(376635,10463,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(376636,10463,'tr','Son Ekstre tarihi girmeniz gerekir',0),(376637,10463,'pl','NaleÅ¼y wprowadziÄ‡ datÄ™ koÅ„cowÄ… instrukcja',0),(376638,10463,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð° Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð½Ð° ÐºÑ€Ð°Ñ',0),(376639,10463,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø§Ø®ØªØªØ§Ù…ÛŒ Ø¨ÛŒØ§Ù† ØªØ§Ø±ÛŒØ® Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(376640,10463,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ ÑƒÐ½ÐµÑ‚Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(376641,10463,'vi','Báº¡n pháº£i nháº­p ngÃ y cuá»‘i cÃ¹ng cá»§a bÃ¡o cÃ¡o',0),(376642,10463,'af','U moet \'n End-Staatdatum Invoer',0),(376643,10463,'ro','Trebuie sÄƒ introduceÅ£i o datÄƒ de sfÃ¢rÅŸit de declaraÅ£ie',0),(376644,10463,'et','Te peate sisetama lÃµpparuande kuupÃ¤eva',0),(376645,10463,'si','Vnesite konÄni datum izjave',0),(376646,10463,'ba','Anda harus memasukkan tanggal pernyataan akhir',0),(376647,10463,'nl','U moet een verklaring einddatum invoeren',0),(376648,10463,'fi','Anna pÃ¤Ã¤ttymispÃ¤ivÃ¤ ilmoitus',0),(376649,10463,'no','Du mÃ¥ angi en sluttdato for uttalelse',0),(376650,10463,'da','Du skal angive en slutdato erklÃ¦ring',0),(376651,10463,'ko','ìµœì¢… ê³„ì‚° ì„œ ë‚ ì§œë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(376652,10463,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ª××¨×™×š ×¡×™×•× ×ž×©×¤×˜',0),(376653,10463,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Î´Î®Î»Ï‰ÏƒÎ·',0),(376654,10463,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªç»“æŸå£°æ˜Žæ—¥æœŸ\r\n',0),(376655,10463,'sv','Du mÃ¥ste ange ett slutdatum fÃ¶r uttalande',0),(376656,10463,'it','Ãˆ necessario immettere una data di fine istruzione',0),(376657,10463,'tl','',0),(376658,10463,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸§à¸±à¸™à¸„à¸³à¸ªà¸±à¹ˆà¸‡à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(376659,10463,'hi','à¤†à¤ªà¤•à¥‹ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ à¤à¤• à¤…à¤‚à¤¤à¤¿à¤® à¤¬à¤¯à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(376660,10463,'ms','Anda mesti masukkan tarikh penyata yang akhir',0),(376661,10463,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„Ø¨ÙŠØ§Ù†',0),(376662,10463,'fr','Vous devez entrer une date de fin.',0),(376663,10463,'jp','çµ‚äº†ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã®æ—¥ä»˜ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(376664,10463,'pt','VocÃª deve digitar uma data de declaraÃ§Ã£o final',0),(376665,10463,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ Ð”Ð°Ñ‚Ñƒ ÐžÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(376666,10463,'es','Debe Entrar Una Fecha de Estado de Cuenta de TerminaciÃ³n',0),(376667,10463,'de','Sie mÃ¼ssen eine End-Anweisung-Datum eingeben.',0),(376668,10463,'en','You Must Enter An End Statement Date',0),(376669,10464,'is','',0),(376670,10464,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯',0),(376671,10464,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯',0),(376672,10464,'tr','Sen-meli koymak son ekstre tarihi',0),(376673,10464,'pl','NaleÅ¼y ustawiÄ‡ datÄ™ zakoÅ„czenia instrukcja',0),(376674,10464,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð° Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð½Ð° ÐºÑ€Ð°Ñ',0),(376675,10464,'ur','Ø¢Ù¾ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø¨ÛŒØ§Ù† Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(376676,10464,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(376677,10464,'vi','Báº¡n pháº£i thiáº¿t láº­p ngÃ y cuá»‘i cÃ¹ng cá»§a báº£n bÃ¡o cÃ¡o',0),(376678,10464,'af','U moet \'n End-Staatdatum Stel',0),(376679,10464,'ro','Trebuie sÄƒ setaÅ£i o datÄƒ de sfÃ¢rÅŸit de declaraÅ£ie',0),(376680,10464,'et','Te peate mÃ¤Ã¤rama End Statement Date',0),(376681,10464,'si','Nastavite konÄni datum izjave',0),(376682,10464,'ba','Anda harus mengatur tanggal pernyataan akhir',0),(376683,10464,'nl','U moet een instructie einddatum instellen',0),(376684,10464,'fi','MÃ¤Ã¤ritÃ¤ pÃ¤Ã¤ttymispÃ¤ivÃ¤ ilmoitus',0),(376685,10464,'no','Du mÃ¥ angi en sluttdato for uttalelse',0),(376686,10464,'da','Du skal angive en slutdato erklÃ¦ring',0),(376687,10464,'ko','ë¬¸ ì¢…ë£Œì¼ì„ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(376688,10464,'he','×¢×œ×™×š ×œ×”×’×“×™×¨ ×ª××¨×™×š ×ž×©×¤×˜ ×¡×™×•×',0),(376689,10464,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¯ÏƒÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î´Î®Î»Ï‰ÏƒÎ· Ï„Î­Î»Î¿Ï‚',0),(376690,10464,'zh','ä½ å¿…é¡»è®¾ç½®ä¸€ä¸ªç»“æŸå£°æ˜Žæ—¥æœŸ\r\n',0),(376691,10464,'sv','Du mÃ¥ste ange ett slutdatum fÃ¶r uttalande',0),(376692,10464,'it','Ãˆ necessario impostare una data di fine istruzione',0),(376693,10464,'tl','',0),(376694,10464,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸‡à¸š',0),(376695,10464,'hi','à¤¤à¥à¤® à¤à¤• à¤…à¤‚à¤¤à¤¿à¤® à¤¬à¤¯à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(376696,10464,'ms','Anda mesti menetapkan tarikh penyata yang akhir',0),(376697,10464,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ¹ÙŠÙŠÙ† ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø¨ÙŠØ§Ù†',0),(376698,10464,'fr','Vous devez fixer une date de fin',0),(376699,10464,'jp','End ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆæ—¥ä»˜ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(376700,10464,'pt','VocÃª deve definir uma data de declaraÃ§Ã£o final',0),(376701,10464,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð”Ð°Ñ‚Ñƒ ÐžÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð’Ñ‹Ð¿Ð¸ÑÐºÐ¸',0),(376702,10464,'es','Debe Establecer Una Fecha de Estado de Cuenta de TerminaciÃ³n',0),(376703,10464,'de','Sie mÃ¼ssen ein Enddatum fÃ¼r die Anweisung festlegen.',0),(376704,10464,'en','You Must Set An End Statement Date',0),(376705,10465,'is','',0),(376706,10465,'dr','OFX File',0),(376707,10465,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ ØªØ¨Ø§Ø¯Ù„Ø§Øª Ù…Ø§Ù„ÙŠ Ø§ÙŠÙ†ØªØ±Ù†ØªÙŠ Ø§Ø±Ø³Ø§Ù„ ÙƒÙ†ÙŠØ¯ OFX File',0),(376708,10465,'tr','Bir OFX dosyasÄ± gÃ¶ndermeniz gerekir',0),(376709,10465,'pl','Musisz przesÅ‚aÄ‡ plik OFX',0),(376710,10465,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð´Ð°Ð´ÐµÑ‚Ðµ OFX Ñ„Ð°Ð¹Ð»',0),(376711,10465,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø§ ÙØ§Ø¦Ù„ Ø¬Ù…Ø¹ Ú©Ø±ÙˆØ§Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(376712,10465,'sr','ÐÐµÐ¾Ð¿Ñ…Ð¾Ð´Ð½Ð¾ Ñ˜Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ ÐžÐ¤X',0),(376713,10465,'vi','Báº¡n pháº£i nÃ´p 1 táº­p tin OFX',0),(376714,10465,'af','U Moet \'n OFX LÃªer Indien',0),(376715,10465,'ro','Trebuie sa depuneti un dosar de OFX',0),(376716,10465,'et','Te peate sisestama OFX faili',0),(376717,10465,'si','Morate predloÅ¾iti OFX datoteke',0),(376718,10465,'ba','Anda harus mengirimkan OFX File',0),(376719,10465,'nl','U dient een bestand OFX',0),(376720,10465,'fi','Sinun on esitettÃ¤vÃ¤ OFX-tiedosto',0),(376721,10465,'no','Du mÃ¥ sende en OFX-fil',0),(376722,10465,'da','Du skal indsende en OFX fil',0),(376723,10465,'ko','OFX íŒŒì¼ì„ ì œì¶œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(376724,10465,'he','×¢×œ×™×š ×œ×”×’×™×© ×§×•×‘×¥ ofx ×”×ª×•×¡×¤×ª',0),(376725,10465,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï…Ï€Î¿Î²Î¬Î»ÎµÏ„Îµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿ OFX',0),(376726,10465,'zh','ä½ å¿…é¡»æäº¤OFXæ–‡ä»¶\r\n',0),(376727,10465,'sv','Du mÃ¥ste skicka en OFX-fil',0),(376728,10465,'it','Ãˆ necessario inviare un File OFX',0),(376729,10465,'tl','',0),(376730,10465,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸ªà¹ˆà¸‡à¹à¸Ÿà¹‰à¸¡ OFX',0),(376731,10465,'hi','à¤†à¤ª à¤•à¥‹à¤ˆ OFX à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(376732,10465,'ms','Anda mesti menyerahkan fail OFX yang',0),(376733,10465,'ar','ÙŠØ¬Ø¨ Ø¥Ø±Ø³Ø§Ù„ Ù…Ù„Ù ÙÙƒØ³',0),(376734,10465,'fr','Vous devez soumettre un fichier OFX',0),(376735,10465,'jp','OFX ãƒ•ã‚¡ã‚¤ãƒ«ã‚’æå‡ºã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(376736,10465,'pt','VocÃª deve enviar um arquivo OFX',0),(376737,10465,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ OFX Ñ„Ð°Ð¹Ð»Ð°',0),(376738,10465,'es','Debe Someter Un File de OFX',0),(376739,10465,'de','Sie mÃ¼ssen eine OFX-Datei einreichen.',0),(376740,10465,'en','You Must Submit An OFX File',0),(376741,10466,'is','',0),(376742,10466,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÙŠØ¯',0),(376743,10466,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ø¶Ø§ÙÙŠ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÙŠØ¯',0),(376744,10466,'tr','Ek POS vergi gruplarÄ±',0),(376745,10466,'pl','Grup dodatkowych podatkÃ³w POS',0),(376746,10466,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ POS Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸',0),(376747,10466,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ Ø§Ø¶Ø§ÙÛŒ Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÙ¾',0),(376748,10466,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÐŸÐžÐ¡ Ð¿Ð¾Ñ€ÐµÑÐºÐµ Ð³Ñ€ÑƒÐ¿Ðµ',0),(376749,10466,'vi','NhÃ³m Thuáº¿ POS bá»• sung',0),(376750,10466,'af','Addisionele PVV Belastinggroepe',0),(376751,10466,'ro','Grupuri suplimentare POS fiscale',0),(376752,10466,'et','TÃ¤iendav POS maksugruppe',0),(376753,10466,'si','Dodatne POS davÄne skupine',0),(376754,10466,'ba','Kelompok-kelompok pajak POS tambahan',0),(376755,10466,'nl','Extra POS Tax Groups',0),(376756,10466,'fi','LisÃ¤tietoja POS veroryhmiÃ¤',0),(376757,10466,'no','Ekstra POS-grupper',0),(376758,10466,'da','Yderligere POS momsgrupper',0),(376759,10466,'ko','ì¶”ê°€ POS ì„¸ê¸ˆ ê·¸ë£¹',0),(376760,10466,'he','×§×‘×•×¦×•×ª × ×•×¡×¤×•×ª POS ×ž×¡',0),(376761,10466,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î¿Ï‚ Ï†ÏŒÏÎ¿Ï‚ POS Î¿Î¼Î¬Î´ÎµÏ‚',0),(376762,10466,'zh','å¢žåŠ çš„POSæœºç¨Žç»„\r\n',0),(376763,10466,'sv','Ytterligare POS momsgrupper',0),(376764,10466,'it','Gruppi tasse addizionali POS',0),(376765,10466,'tl','',0),(376766,10466,'th','à¸à¸¥à¸¸à¹ˆà¸¡à¸ à¸²à¸©à¸µ POS à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(376767,10466,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ POS à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚',0),(376768,10466,'ms','Kumpulan tambahan POS cukai',0),(376769,10466,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø¥Ø¶Ø§ÙÙŠØ© Ù…Ù† Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹',0),(376770,10466,'fr','Groupes d\'impÃ´t additionnel de POS',0),(376771,10466,'jp','è¿½åŠ ã® POS ç¨Žã‚°ãƒ«ãƒ¼ãƒ—',0),(376772,10466,'pt','Grupos de imposto adicional de POS',0),(376773,10466,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ POS Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(376774,10466,'es','Grupos de Impuestos de Punto de Venta adicional',0),(376775,10466,'de','ZusÃ¤tzliche POS Steuergruppen',0),(376776,10466,'en','Additional POS Tax Groups',0),(376777,10467,'is','',0),(376778,10467,'dr','ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø§Ø¶Ø§ÙÙ‡ ÙŠØ§ Ø¨Ù‡ Ø±ÙˆØ² Ø´ÙˆØ¯',0),(376779,10467,'pr','ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø§Ø¶Ø§ÙÙ‡ ÙŠØ§ Ø¨Ù‡ Ø±ÙˆØ² Ø´ÙˆØ¯',0),(376780,10467,'tr','Eklemek veya gÃ¼ncelleÅŸtirmek iÃ§in tÄ±klatÄ±n',0),(376781,10467,'pl','Kliknij, aby dodaÄ‡ lub zaktualizowaÄ‡',0),(376782,10467,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð¸Ð»Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚Ðµ',0),(376783,10467,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº ÛŒØ§ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(376784,10467,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸ Ð·Ð° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¸Ð»Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(376785,10467,'vi','Nháº¥n vÃ o Ä‘á»ƒ thÃªm hoáº·c cáº­p nháº­t',0),(376786,10467,'af','Kliek Vir Byvoeging of Opdatering',0),(376787,10467,'ro','FaceÅ£i clic pentru a adÄƒuga sau actualiza',0),(376788,10467,'et','KlÃµpsake lisamiseks vÃµi vÃ¤rskendamiseks',0),(376789,10467,'si','Kliknite, Äe Å¾elite dodati ali posodobiti',0),(376790,10467,'ba','Klik untuk menambahkan atau memutakhirkan',0),(376791,10467,'nl','Klik op toevoegen of bijwerken',0),(376792,10467,'fi','Valitse LisÃ¤Ã¤ tai PÃ¤ivitÃ¤',0),(376793,10467,'no','Klikk for Ã¥ legge til eller oppdatere',0),(376794,10467,'da','Klik for at tilfÃ¸je eller opdatere',0),(376795,10467,'ko','ì¶”ê°€ ë˜ëŠ” ì—…ë°ì´íŠ¸ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(376796,10467,'he','×œ×—×¥ ×¢×œ ×›×“×™ ×œ×”×•×¡×™×£ ××• ×œ×¢×“×›×Ÿ',0),(376797,10467,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î® Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ',0),(376798,10467,'zh','å•å‡»æ·»åŠ æˆ–æ›´æ–°\r\n',0),(376799,10467,'sv','Klicka fÃ¶r att lÃ¤gga till eller uppdatera',0),(376800,10467,'it','Fare clic per aggiungere o aggiornare',0),(376801,10467,'tl','',0),(376802,10467,'th','à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­à¹€à¸žà¸´à¹ˆà¸¡ à¸«à¸£à¸·à¸­à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(376803,10467,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤¯à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(376804,10467,'ms','Klik untuk menambah atau mengemaskini',0),(376805,10467,'ar','Ø£Ù†Ù‚Ø± Ù„Ù„Ø¥Ø¶Ø§ÙØ© Ø£Ùˆ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(376806,10467,'fr','Cliquez ici pour ajouter ou mettre Ã  jour',0),(376807,10467,'jp','ã‚¯ãƒªãƒƒã‚¯ã—ã¦è¿½åŠ ã¾ãŸã¯æ›´æ–°ã™ã‚‹ã«ã¯',0),(376808,10467,'pt','Clique para adicionar ou atualizar',0),(376809,10467,'ru','ÐÐ°Ð¶Ð°Ñ‚ÑŒ Ð§Ñ‚Ð¾Ð±Ñ‹ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð˜Ð»Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(376810,10467,'es','Clic para Agregar o Actualizar',0),(376811,10467,'de','Klicken Sie auf HinzufÃ¼gen oder aktualisieren',0),(376812,10467,'en','Click To Add Or Update',0),(376813,10468,'is','',0),(376814,10468,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(376815,10468,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(376816,10468,'tr','POS vergi gruplarÄ±',0),(376817,10468,'pl','Grup podatkowych POS',0),(376818,10468,'bg','POS Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸',0),(376819,10468,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÙ¾',0),(376820,10468,'sr','ÐŸÐžÐ¡ Ð¿Ð¾Ñ€ÐµÑÐºÐµ Ð³Ñ€ÑƒÐ¿Ðµ',0),(376821,10468,'vi','nhÃ³m thuáº¿ POS',0),(376822,10468,'af','PVV Belastinggroepe',0),(376823,10468,'ro','Grupuri de POS fiscale',0),(376824,10468,'et','POS maksugruppe',0),(376825,10468,'si','POS davÄne skupine',0),(376826,10468,'ba','Kelompok-kelompok POS pajak',0),(376827,10468,'nl','POS Tax Groups',0),(376828,10468,'fi','POS veroryhmiÃ¤',0),(376829,10468,'no','POS-grupper',0),(376830,10468,'da','POS momsgrupper',0),(376831,10468,'ko','POS ì„¸ê¸ˆ ê·¸ë£¹',0),(376832,10468,'he','×§×‘×•×¦×•×ª ×ž×¡ POS',0),(376833,10468,'el','ÎŸÎ¼Î¬Î´Ï‰Î½ Ï†ÏŒÏÎ¿Ï… POS',0),(376834,10468,'zh','é”€å”®ç‚¹ç¨Žç»„\r\n',0),(376835,10468,'sv','POS momsgrupper',0),(376836,10468,'it','Gruppi fiscali POS',0),(376837,10468,'tl','',0),(376838,10468,'th','à¸à¸¥à¸¸à¹ˆà¸¡à¸ à¸²à¸©à¸µà¸‚à¸­à¸‡ POS',0),(376839,10468,'hi','POS à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚',0),(376840,10468,'ms','Kumpulan POS cukai',0),(376841,10468,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(376842,10468,'fr','Groupes de taxe POS',0),(376843,10468,'jp','POS ç¨Žã‚°ãƒ«ãƒ¼ãƒ—',0),(376844,10468,'pt','Grupos de impostos POS',0),(376845,10468,'ru','POS Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(376846,10468,'es','Grupos de Impuestos de PDV',0),(376847,10468,'de','POS Steuergruppen',0),(376848,10468,'en','POS Tax Groups',0),(376849,10469,'is','',0),(376850,10469,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´  Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(376851,10469,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´  Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(376852,10469,'tr','Yeni POS satÄ±ÅŸ vergisi gruplarÄ±',0),(376853,10469,'pl','Nowe grupy podatku od sprzedaÅ¼y POS',0),(376854,10469,'bg','ÐÐ¾Ð²Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸ Ð·Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð½Ð° ÐŸÐžÐ¡',0),(376855,10469,'ur','Ù†Ø¦Û’ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÙ¾',0),(376856,10469,'sr','ÐÐ¾Ð²Ðµ Ð³Ñ€ÑƒÐ¿Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ ÐŸÐžÐ¡',0),(376857,10469,'vi','NhÃ³m thuáº¿ bÃ¡n hÃ ng POS má»›i',0),(376858,10469,'af','PVV Verkoopsbelasting Groepe Skep',0),(376859,10469,'ro','Noi grupuri de impozitul pe vÃ¢nzÄƒri POS',0),(376860,10469,'et','Uus POS kÃ¤ibemaksugruppe',0),(376861,10469,'si','Nove skupine prometnega davka POS',0),(376862,10469,'ba','Kelompok-kelompok pajak penjualan POS baru',0),(376863,10469,'nl','Nieuwe POS Sales Tax Groups',0),(376864,10469,'fi','Uusi POS-arvonlisÃ¤veroryhmÃ¤t',0),(376865,10469,'no','Nye POS mva-grupper',0),(376866,10469,'da','Nye POS momsgrupper',0),(376867,10469,'ko','ìƒˆë¡œìš´ POS ë§¤ì¶œ ì„¸ê¸ˆ ê·¸ë£¹',0),(376868,10469,'he','×§×‘×•×¦×•×ª ×—×“×©×•×ª ×©×œ ×ž×¢ ×ž POS',0),(376869,10469,'el','ÎÎ­ÎµÏ‚ Î¿Î¼Î¬Î´ÎµÏ‚ Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ POS',0),(376870,10469,'zh','é”€å”®ç‚¹æ–°å¢žé”€å”®ç¨Žç»„\r\n',0),(376871,10469,'sv','Nya POS momsgrupper',0),(376872,10469,'it','Nuove fasce IVA POS',0),(376873,10469,'tl','',0),(376874,10469,'th','à¸à¸¥à¸¸à¹ˆà¸¡à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢ POS à¹ƒà¸«à¸¡à¹ˆ',0),(376875,10469,'hi','à¤¨à¤ˆ POS à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤° à¤¸à¤®à¥‚à¤¹',0),(376876,10469,'ms','Baru POS cukai jualan Kumpulan',0),(376877,10469,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª POS Ø¬Ø¯ÙŠØ¯',0),(376878,10469,'fr','Nouveaux groupes de taxe POS',0),(376879,10469,'jp','æ–°ã—ã„ POS å£²ä¸Šç¨Žã‚°ãƒ«ãƒ¼ãƒ—',0),(376880,10469,'pt','Novos grupos de impostos sobre vendas POS',0),(376881,10469,'ru','ÐÐ¾Ð²Ñ‹Ð¹ POS Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(376882,10469,'es','Agregar Grupos de IVA de PDV',0),(376883,10469,'de','Neue POS-Mehrwertsteuergruppen',0),(376884,10469,'en','New POS Sales Tax Groups',0),(376885,10470,'is','',0),(376886,10470,'dr','Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ù…Ø§Ù„ÙŠØ§Øª ',0),(376887,10470,'pr','Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ù…Ø§Ù„ÙŠØ§Øª ',0),(376888,10470,'tr','Vergi grubu adÄ±',0),(376889,10470,'pl','Nazwa grupy podatkowej',0),(376890,10470,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð¸Ð¼Ðµ',0),(376891,10470,'ur','Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÙ¾ Ú©Ø§ Ù†Ø§Ù…',0),(376892,10470,'sr','Ð˜Ð¼Ðµ Ð³Ñ€ÑƒÐ¿Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(376893,10470,'vi','TÃªn nhÃ³m thuáº¿',0),(376894,10470,'af','Belasting Groepnaam',0),(376895,10470,'ro','Nume grup fiscal',0),(376896,10470,'et','Maksu grupi nimi',0),(376897,10470,'si','Ime skupine davÄnih',0),(376898,10470,'ba','Nama grup pajak',0),(376899,10470,'nl','Tax Group naam',0),(376900,10470,'fi','RyhmÃ¤n nimi',0),(376901,10470,'no','Skatt gruppenavn',0),(376902,10470,'da','Momsgruppen navn',0),(376903,10470,'ko','ì„¸ê¸ˆ ê·¸ë£¹ ì´ë¦„',0),(376904,10470,'he','×©× ×§×‘×•×¦×ª ×ž×¡',0),(376905,10470,'el','ÎŒÎ½Î¿Î¼Î± Î¿Î¼Î¬Î´Î±Ï‚ Ï†ÏŒÏÎ¿Ï…',0),(376906,10470,'zh','ç¨Žç»„åç§°\r\n',0),(376907,10470,'sv','Momsgrupp namn',0),(376908,10470,'it','Gruppo imposta nome',0),(376909,10470,'tl','',0),(376910,10470,'th','à¸Šà¸·à¹ˆà¸­à¸‚à¸­à¸‡ à¸à¸¥à¸¸à¹ˆà¸¡à¸ à¸²à¸©à¸µ',0),(376911,10470,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¤®à¥‚à¤¹ à¤¨à¤¾à¤®',0),(376912,10470,'ms','Nama Kumpulan cukai',0),(376913,10470,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©',0),(376914,10470,'fr','Nom de groupe fiscal',0),(376915,10470,'jp','ç¨Žã‚°ãƒ«ãƒ¼ãƒ—å',0),(376916,10470,'pt','Nome do grupo de fiscais',0),(376917,10470,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐÐ°Ð»Ð¾Ð³Ð¾Ð²',0),(376918,10470,'es','Nombre de Grupo de Imuestos',0),(376919,10470,'de','Steuergruppe Name',0),(376920,10470,'en','Tax Group Name',0),(376921,10471,'is','',0),(376922,10471,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´  Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(376923,10471,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ÙØ±ÙˆØ´  Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ ',0),(376924,10471,'tr','POS satÄ±ÅŸ vergisi gruplarÄ±nÄ± DÃ¼zenle',0),(376925,10471,'pl','Edytowanie grupy podatku od sprzedaÅ¼y POS',0),(376926,10471,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° POS Ð´Ð°Ð½ÑŠÐº Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸',0),(376927,10471,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÙ¾ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(376928,10471,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ðµ ÐŸÐžÐ¡ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(376929,10471,'vi','chá»‰nh sá»­a nhÃ³m thuáº¿ bÃ¡n hÃ ng POS ',0),(376930,10471,'af','PVV Verkoopsbelasting Groepe Opdateer',0),(376931,10471,'ro','Editare grupuri de impozitul pe vÃ¢nzÄƒri POS',0),(376932,10471,'et','Redigeeri POS kÃ¤ibemaksugruppe',0),(376933,10471,'si','Urejanje skupin POS prometnega davka',0),(376934,10471,'ba','Mengedit POS pajak penjualan grup',0),(376935,10471,'nl','POS Sales Tax groepen bewerken',0),(376936,10471,'fi','Muokkaa Myyntipisteen arvonlisÃ¤veroryhmiÃ¤',0),(376937,10471,'no','Redigere POS varemva-grupper',0),(376938,10471,'da','Rediger POS momsgrupper',0),(376939,10471,'ko','POS íŒë§¤ ì„¸ê¸ˆ ê·¸ë£¹ íŽ¸ì§‘',0),(376940,10471,'he','×¢×¨×™×›×ª ×§×‘×•×¦×•×ª ×ž×¢ ×ž POS',0),(376941,10471,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ POS Î¿Î¼Î¬Î´ÎµÏ‚ Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(376942,10471,'zh','é”€å”®ç‚¹è¥ä¸šç¨Žç»„æ›´æ–°\r\n',0),(376943,10471,'sv','Redigera POS momsgrupper',0),(376944,10471,'it','Modifica fasce IVA POS',0),(376945,10471,'tl','',0),(376946,10471,'th','à¹à¸à¹‰à¹„à¸‚à¸à¸¥à¸¸à¹ˆà¸¡à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢ POS',0),(376947,10471,'hi','POS à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤° à¤¸à¤®à¥‚à¤¹ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(376948,10471,'ms','Edit POS cukai jualan Kumpulan',0),(376949,10471,'ar','ØªØ­Ø±ÙŠØ± Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª POS',0),(376950,10471,'fr','Modifier les groupes de taxe POS',0),(376951,10471,'jp','POS å£²ä¸Šç¨Žã‚°ãƒ«ãƒ¼ãƒ—ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(376952,10471,'pt','Editar grupos de impostos de vendas POS',0),(376953,10471,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ POS Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(376954,10471,'es','Actualizar Grupos de IVA de PDV',0),(376955,10471,'de','Bearbeiten von POS-Mehrwertsteuergruppen',0),(376956,10471,'en','Edit POS Sales Tax Groups',0),(376957,10472,'is','',0),(376958,10472,'dr','Ø¯Ø§ÙŠØ±ÙƒØªÙˆØ±ÙŠ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(376959,10472,'pr','Ø¯Ø§ÙŠØ±ÙƒØªÙˆØ±ÙŠ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(376960,10472,'tr','Dizin yok',0),(376961,10472,'pl','Katalog nie istnieje',0),(376962,10472,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸ÑÑ‚Ð° Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(376963,10472,'ur','ÚˆØ§Ø¦Ø±ÛŒÚ©Ù¹Ø±ÛŒ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(376964,10472,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ñ˜ÑƒÐ¼ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(376965,10472,'vi','Danh má»¥c khÃ´ng tá»“n táº¡i',0),(376966,10472,'af','Gids Bestaan nie',0),(376967,10472,'ro','Director nu exista',0),(376968,10472,'et','Kausta pole olemas',0),(376969,10472,'si','Imenik ne obstaja',0),(376970,10472,'ba','Direktori tidak ada',0),(376971,10472,'nl','Directory Does Not Exist',0),(376972,10472,'fi','Kansiota ei ole',0),(376973,10472,'no','Katalogen finnes ikke',0),(376974,10472,'da','Register findes ikke',0),(376975,10472,'ko','ë””ë ‰í† ë¦¬ê°€ ì¡´ìž¬ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(376976,10472,'he','×”×¡×¤×¨×™×” ××™× ×” ×§×™×™×ž×ª',0),(376977,10472,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚',0),(376978,10472,'zh','ç›®å½•ä¸å­˜åœ¨\r\n',0),(376979,10472,'sv','Katalogen finns inte',0),(376980,10472,'it','Directory non esiste',0),(376981,10472,'tl','',0),(376982,10472,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹„à¸”à¹€à¸£à¸à¸—à¸­à¸£à¸µ',0),(376983,10472,'hi','à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¤¿à¤•à¤¾ à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(376984,10472,'ms','Direktori tidak wujud',0),(376985,10472,'ar','Ø§Ù„Ø¯Ù„ÙŠÙ„ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(376986,10472,'fr','RÃ©pertoire n\'existe pas',0),(376987,10472,'jp','ãƒ‡ã‚£ãƒ¬ã‚¯ãƒˆãƒªãŒå­˜åœ¨ã—ã¾ã›ã‚“',0),(376988,10472,'pt','DiretÃ³rio nÃ£o existe',0),(376989,10472,'ru','ÐšÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(376990,10472,'es','Directorio no Existe',0),(376991,10472,'de','Verzeichnis existiert nicht',0),(376992,10472,'en','Directory Does Not Exist',0),(376993,10473,'is','',0),(376994,10473,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(376995,10473,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(376996,10473,'tr','Emir alma hatasÄ±',0),(376997,10473,'pl','BÅ‚Ä…d importowania zamÃ³wieÅ„',0),(376998,10473,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(376999,10473,'ur','Ù†Ù‚Øµ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±Ù†Û’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø§Ø±ÛŒ',0),(377000,10473,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ²Ð¾Ð·Ñƒ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(377001,10473,'vi','Lá»—i khi nháº­p Ä‘Æ¡n hÃ ng',0),(377002,10473,'af','Fout met Invoer van Bestellings',0),(377003,10473,'ro','Eroare importul comenzilor',0),(377004,10473,'et','TÃµrge importimisel tellimused',0),(377005,10473,'si','Napaka pri uvozu nalogov',0),(377006,10473,'ba','Kesalahan mengimpor pesanan',0),(377007,10473,'nl','Fout Orders importeren',0),(377008,10473,'fi','Virhe tuotaessa tilaukset',0),(377009,10473,'no','Feil importerer ordrer',0),(377010,10473,'da','Fejl import af ordrer',0),(377011,10473,'ko','ëª…ë ¹ ê°€ì ¸ì˜¤ê¸° ì˜¤ë¥˜',0),(377012,10473,'he','×©×’×™××” ×‘×™×™×‘×•× ×”×–×ž× ×•×ª',0),(377013,10473,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(377014,10473,'zh','é”™è¯¯å¯¼å…¥è®¢å•',0),(377015,10473,'sv','Fel importerar order',0),(377016,10473,'it','Errore durante l\'importazione di ordini',0),(377017,10473,'tl','',0),(377018,10473,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(377019,10473,'hi','à¤†à¤¦à¥‡à¤¶ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(377020,10473,'ms','Ralat mengimport pesanan',0),(377021,10473,'ar','Ø®Ø·Ø£ Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£ÙˆØ§Ù…Ø±',0),(377022,10473,'fr','Erreur importation de commandes',0),(377023,10473,'jp','æ³¨æ–‡ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ã‚¨ãƒ©ãƒ¼',0),(377024,10473,'pt','Erro ao importar as ordens',0),(377025,10473,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ðµ Ð—Ð°ÐºÐ°Ð·Ð¾Ð²',0),(377026,10473,'es','Error Importando Pedidos',0),(377027,10473,'de','Fehler beim Importieren von Bestellungen',0),(377028,10473,'en','Error Importing Orders',0),(377029,10474,'is','',0),(377030,10474,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ø¬Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(377031,10474,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ø¬Ù‡Øª ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(377032,10474,'tr','AlÄ±nacak fatura alanlarÄ± seÃ§in',0),(377033,10474,'pl','Wybierz pola faktury do importu',0),(377034,10474,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ð»ÐµÑ‚Ð°Ñ‚Ð° Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(377035,10474,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù‚Ø·Ø¹Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(377036,10474,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ™Ð° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(377037,10474,'vi','Chá»n lÄ©nh vá»±c hÃ³a Ä‘Æ¡n Ä‘á»ƒ nháº­p',0),(377038,10474,'af','Selekteer Faktuurvelde vir Invoer',0),(377039,10474,'ro','SelectaÅ£i cÃ¢mpurile de factura de Import',0),(377040,10474,'et','Valige vÃ¤ljadel impordiks',0),(377041,10474,'si','Izberite raÄun polja uvoza',0),(377042,10474,'ba','Pilih bidang faktur untuk impor',0),(377043,10474,'nl','Selecteer factuur velden om te importeren',0),(377044,10474,'fi','Valitse tuotavat kentÃ¤t',0),(377045,10474,'no','Velg feltene Importer',0),(377046,10474,'da','VÃ¦lg faktura felter til Import',0),(377047,10474,'ko','ì†¡ìž¥ í•„ë“œ ê°€ì ¸ì˜¤ê¸°ë¥¼ ì„ íƒ',0),(377048,10474,'he','×‘×—×¨ ×©×“×” ×—×©×‘×•× ×™×ª ×œ×™×‘×•×',0),(377049,10474,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÎµÎ´Î¯Ï‰Î½ Î³Î¹Î± Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(377050,10474,'zh','é€‰æ‹©å‘ç¥¨å­—æ®µä»¥å¯¼å…¥\r\n',0),(377051,10474,'sv','VÃ¤lj fakturera till Import',0),(377052,10474,'it','Selezionare i campi della fattura di importazione',0),(377053,10474,'tl','',0),(377054,10474,'th','à¹€à¸¥à¸·à¸­à¸à¹€à¸‚à¸•à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(377055,10474,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(377056,10474,'ms','Pilih medan invois untuk Import',0),(377057,10474,'ar','Ø§Ø®ØªØ± Ù…Ù„ÙØ§Øª Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(377058,10474,'fr','SÃ©lectionnez les champs de la facture d\'importation',0),(377059,10474,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹è«‹æ±‚æ›¸ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’é¸æŠžã—ã¾ã™',0),(377060,10474,'pt','Selecionar campos de factura de importaÃ§Ã£o',0),(377061,10474,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‡ÐµÑ‚Ð° Ð¿Ð¾Ð»ÐµÐ¹ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(377062,10474,'es','Selecciona Campos de Facturas para Importar',0),(377063,10474,'de','WÃ¤hlen Sie Rechnung Felder zu importieren',0),(377064,10474,'en','Select Invoice Fields To Import',0),(377065,10475,'is','',0),(377066,10475,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(377067,10475,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙØ§ÙŠÙ„ ÙØ§ÙƒØªÙˆØ± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(377068,10475,'tr','Bir fatura dosyasÄ± seÃ§melisiniz',0),(377069,10475,'pl','NaleÅ¼y wybraÄ‡ plik faktury',0),(377070,10475,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð» Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(377071,10475,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(377072,10475,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(377073,10475,'vi','Báº¡n Pháº£i Chá»n Má»™t táº­p tin hÃ³a Ä‘Æ¡n',0),(377074,10475,'af','U moet \'n Faktuur LÃªer Selekteer.',0),(377075,10475,'ro','Trebuie sÄƒ selectaÅ£i un fiÅŸier de facturÄƒ',0),(377076,10475,'et','Valige arve faili',0),(377077,10475,'si','Izbrati morate datoteko raÄuna',0),(377078,10475,'ba','Anda harus memilih File faktur',0),(377079,10475,'nl','U moet een factuur bestand selecteren',0),(377080,10475,'fi','Valitse lasku-tiedosto',0),(377081,10475,'no','Du mÃ¥ velge en faktura-fil',0),(377082,10475,'da','Du skal vÃ¦lge en faktura fil',0),(377083,10475,'ko','ì†¡ìž¥ íŒŒì¼ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(377084,10475,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×§×•×‘×¥ ×—×©×‘×•× ×™×ª',0),(377085,10475,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(377086,10475,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªå‘ç¥¨æ–‡ä»¶\r\n',0),(377087,10475,'sv','Du mÃ¥ste vÃ¤lja en faktura fil',0),(377088,10475,'it','Ãˆ necessario selezionare un File di fattura',0),(377089,10475,'tl','',0),(377090,10475,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¹à¸Ÿà¹‰à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(377091,10475,'hi','à¤†à¤ª à¤•à¥‹à¤ˆ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(377092,10475,'ms','Anda mesti memilih satu fail invois',0),(377093,10475,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ®ØªØ§Ø± Ù…Ù„Ù Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨',0),(377094,10475,'fr','Vous devez sÃ©lectionner une facture',0),(377095,10475,'jp','è«‹æ±‚æ›¸ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(377096,10475,'pt','VocÃª deve selecionar um arquivo de factura',0),(377097,10475,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(377098,10475,'es','Debe Seleccionar Un File de Facturas',0),(377099,10475,'de','Sie mÃ¼ssen eine Rechnungsdatei auswÃ¤hlen.',0),(377100,10475,'en','You Must Select An Invoice File',0),(377101,10476,'is','',0),(377102,10476,'dr','Ú¯Ø±ÙˆÙ‡ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø±',0),(377103,10476,'pr','Ú¯Ø±ÙˆÙ‡ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø±',0),(377104,10476,'tr','Bu kullanÄ±cÄ± iÃ§in POS vergi grubu',0),(377105,10476,'pl','POS Grupa podatkÃ³w dla tego uÅ¼ytkownika',0),(377106,10476,'bg','POS Ð´Ð°Ð½ÑŠÑ‡Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(377107,10476,'ur','Ø§Ø³ ØµØ§Ø±Ù Ú©Û’ Ù„Ø¦Û’ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ù¹ÛŒÚ©Ø³ Ú¯Ø±ÙˆÙ¾',0),(377108,10476,'sr','ÐŸÐžÐ¡ Ð¿Ð¾Ñ€ÐµÑÐºÐµ Ð³Ñ€ÑƒÐ¿Ðµ Ð·Ð° Ð¾Ð²Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(377109,10476,'vi','NhÃ³m thuáº¿ POS cho ngÆ°á»i sá»­ dá»¥ng nÃ y',0),(377110,10476,'af','PVV Belastinggroepe Vir Hierdie Jaar',0),(377111,10476,'ro','POS fiscale de grup pentru acest utilizator',0),(377112,10476,'et','POS kÃ¤ibemaksugrupi selle kasutaja',0),(377113,10476,'si','POS davÄne skupine za tega uporabnika',0),(377114,10476,'ba','Grup pajak POS untuk pengguna ini',0),(377115,10476,'nl','POS Tax Group voor deze gebruiker',0),(377116,10476,'fi','POS veroryhmÃ¤ tÃ¤mÃ¤n kÃ¤yttÃ¤jÃ¤n',0),(377117,10476,'no','POS-gruppen For denne brukeren',0),(377118,10476,'da','POS momsgruppen For denne bruger',0),(377119,10476,'ko','ì´ ì‚¬ìš©ìžì— ëŒ€ í•œ POS ì„¸ê¸ˆ ê·¸ë£¹',0),(377120,10476,'he','POS ×§×‘×•×¦×ª ×ž×¡ ×¢×‘×•×¨ ×ž×©×ª×ž×© ×–×”',0),(377121,10476,'el','ÎŸÎ¼Î¬Î´Î±Ï‚ Ï†ÏŒÏÎ¿Ï… POS Î³Î¹Î± Î±Ï…Ï„ÏŒÎ½ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(377122,10476,'zh','æ­¤ç”¨æˆ·çš„é”€å”®ç‚¹ç¨Žç»„\r\n',0),(377123,10476,'sv','POS momsgrupp fÃ¶r den hÃ¤r anvÃ¤ndaren',0),(377124,10476,'it','Gruppo imposta POS per questo utente',0),(377125,10476,'tl','',0),(377126,10476,'th','à¸à¸¥à¸¸à¹ˆà¸¡à¸ à¸²à¸©à¸µ POS à¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸™à¸µà¹‰',0),(377127,10476,'hi','POS à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤',0),(377128,10476,'ms','POS cukai Kumpulan untuk pengguna ini',0),(377129,10476,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¨ÙŠØ¹ Ù„Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(377130,10476,'fr','Groupe fiscal POS pour cet utilisateur',0),(377131,10476,'jp','ã“ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã® POS ç¨Žã‚°ãƒ«ãƒ¼ãƒ—',0),(377132,10476,'pt','POS grupo de fiscais para este usuÃ¡rio',0),(377133,10476,'ru','POS Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð°Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ð° Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(377134,10476,'es','Grupo de Impuestos de PDV Para Este Usuario',0),(377135,10476,'de','POS-Steuergruppe fÃ¼r diesen Benutzer',0),(377136,10476,'en','POS Tax Group For This User',0),(377137,10477,'is','',0),(377138,10477,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙˆØ±ÙˆØ¯ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§',0),(377139,10477,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙˆØ±ÙˆØ¯ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ù…Ø§Ù„ÙŠØ§Øª Ù‡Ø§',0),(377140,10477,'tr','Standart Walk-In vergiler kullanÄ±n',0),(377141,10477,'pl','Standardowe Walk-In podatkÃ³w',0),(377142,10477,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ð¿Ð¾Ð´Ð²Ð¸Ð¶ÐµÐ½ Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(377143,10477,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø§Ù„Ù…Ø§Ø±ÛŒ Ù…ÛŒÚº ÙˆØ§Ú© Ú©Û’ Ù¹ÛŒÚ©Ø³ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(377144,10477,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ñ„Ñ€Ð¸Ñ›Ð¸Ð´ÐµÑ€ Ð¿Ð¾Ñ€ÐµÐ·Ðµ',0),(377145,10477,'vi','Sá»­ dá»¥ng tiÃªu chuáº©n Walk trong thuáº¿',0),(377146,10477,'af','Gebruik standaard Walk-In belasting',0),(377147,10477,'ro','UtilizaÅ£i Standard Walk-In impozite',0),(377148,10477,'et','Standard Walk-In maksude kasutamisega',0),(377149,10477,'si','Uporabite standardne Walk-In davkov',0),(377150,10477,'ba','Menggunakan standar bilik pajak',0),(377151,10477,'nl','Gebruik standaard Walk-In belastingen',0),(377152,10477,'fi','KÃ¤yttÃ¤Ã¤ standardi Walk-In verot',0),(377153,10477,'no','Bruk Standard Walk-In skatter',0),(377154,10477,'da','Bruge Standard Walk-In skatter',0),(377155,10477,'ko','í‘œì¤€ ê±¸ì–´ ì„¸ê¸ˆì„ ì‚¬ìš© í•˜ ì—¬',0),(377156,10477,'he','×”×©×ª×ž×© ×ž×¡×™× ×¨×’×™×œ×™× ×œ×œ× ×”×–×ž× ×”',0),(377157,10477,'el','Standard ÎºÎ±Î¼Ï€Î¯Î½Î± Ï„Î¿Ï…Ï‚ Ï†ÏŒÏÎ¿Ï…Ï‚ Ï‡ÏÎ®ÏƒÎ·Ï‚',0),(377158,10477,'zh','ä½¿ç”¨æ ‡å‡†é—¨å¸‚ç¨Žæ”¶\r\n',0),(377159,10477,'sv','AnvÃ¤nda Standard Walk-In skatter',0),(377160,10477,'it','Utilizzare le tasse cabina Standard',0),(377161,10477,'tl','',0),(377162,10477,'th','à¹ƒà¸Šà¹‰à¸ à¸²à¸©à¸µà¹€à¸”à¸´à¸™à¹ƒà¸™à¸«à¹‰à¸­à¸‡à¸¡à¸²à¸•à¸£à¸à¸²à¸™',0),(377163,10477,'hi','à¤®à¤¾à¤¨à¤• à¤µà¤¾à¤²à¥à¤•-à¤‡à¤¨ à¤•à¤°à¥‹à¤‚ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(377164,10477,'ms','Menggunakan Bilik Standard cukai',0),(377165,10477,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ ØªÙ‚Ø¯ÙŠÙ…Ø§Øª Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(377166,10477,'fr','Utilisez des Taxes Standard Walk-in',0),(377167,10477,'jp','æ¨™æº–çš„ãªã‚¦ã‚©ãƒ¼ã‚¯ã‚¤ãƒ³ç¨Žé‡‘ã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(377168,10477,'pt','Use o Walk-in padrÃ£o impostos',0),(377169,10477,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ Walk-In Ð½Ð°Ð»Ð¾Ð³Ð¸',0),(377170,10477,'es','Usa los Impuestos Estandar',0),(377171,10477,'de','Verwenden Sie Standard begehbare Steuern',0),(377172,10477,'en','Use Standard Walk-In Taxes',0),(377173,10478,'is','',0),(377174,10478,'dr','ÙØ§ÙŠÙ„ Ø¬Ø§Ø±ÙŠ ',0),(377175,10478,'pr','ÙØ§ÙŠÙ„ Ø¬Ø§Ø±ÙŠ ',0),(377176,10478,'tr','GeÃ§erli dosya',0),(377177,10478,'pl','BieÅ¼Ä…cy plik',0),(377178,10478,'bg','Ð¢ÐµÐºÑƒÑ‰ Ñ„Ð°Ð¹Ð»',0),(377179,10478,'ur','Ø­Ø§Ù„ÛŒÛ Ù…Ø³Ù„',0),(377180,10478,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(377181,10478,'vi','file hiá»‡n nay',0),(377182,10478,'af','Huidige LÃªer',0),(377183,10478,'ro','FiÅŸier curent',0),(377184,10478,'et','Praeguse faili',0),(377185,10478,'si','Trenutno datoteko',0),(377186,10478,'ba','File saat ini',0),(377187,10478,'nl','Huidig bestand',0),(377188,10478,'fi','Nykyinen tiedosto',0),(377189,10478,'no','Gjeldende fil',0),(377190,10478,'da','Aktuelle fil',0),(377191,10478,'ko','í˜„ìž¬ íŒŒì¼',0),(377192,10478,'he','×§×•×‘×¥ × ×•×›×—×™',0),(377193,10478,'el','Î¤ÏÎ­Ï‡Î¿Î½ Î±ÏÏ‡ÎµÎ¯Î¿',0),(377194,10478,'zh','å½“å‰æ–‡ä»¶\r\n',0),(377195,10478,'sv','Aktuella filen',0),(377196,10478,'it','File corrente',0),(377197,10478,'tl','',0),(377198,10478,'th','à¹à¸Ÿà¹‰à¸¡à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(377199,10478,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤«à¤¼à¤¾à¤‡à¤²',0),(377200,10478,'ms','Fail semasa',0),(377201,10478,'ar','Ø§Ù„Ù…Ù„ÙÙ‘ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(377202,10478,'fr','Fichier en cours',0),(377203,10478,'jp','ç¾åœ¨ã®ãƒ•ã‚¡ã‚¤ãƒ«',0),(377204,10478,'pt','Arquivo atual',0),(377205,10478,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð¤Ð°Ð¹Ð»',0),(377206,10478,'es','Archivo Actual',0),(377207,10478,'de','Aktuelle Datei',0),(377208,10478,'en','Current File',0),(377209,10479,'is','',0),(377210,10479,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(377211,10479,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(377212,10479,'tr','Ã–zel yardÄ±m',0),(377213,10479,'pl','Pomoc niestandardowÄ…',0),(377214,10479,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ° Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(377215,10479,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù…Ø¯Ø¯',0),(377216,10479,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ð¼Ð¾Ñ›',0),(377217,10479,'vi','táº¡o trá»£ giÃºp',0),(377218,10479,'af','Aangepasde Hulp',0),(377219,10479,'ro','Ajutor particularizat',0),(377220,10479,'et','Kohandatud spikker',0),(377221,10479,'si','PomoÄ po meri',0),(377222,10479,'ba','Bantuan kustom',0),(377223,10479,'nl','Aangepaste Help-informatie',0),(377224,10479,'fi','Mukautetun ohjeen',0),(377225,10479,'no','Egendefinert hjelp',0),(377226,10479,'da','Brugerdefineret hjÃ¦lp',0),(377227,10479,'ko','ì‚¬ìš©ìž ì§€ì • ë„ì›€ë§',0),(377228,10479,'he','×¢×–×¨×” ×ž×•×ª××ž×ª ××™×©×™×ª',0),(377229,10479,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· Î²Î¿Î®Î¸ÎµÎ¹Î±',0),(377230,10479,'zh','è‡ªå®šä¹‰å¸®åŠ©\r\n',0),(377231,10479,'sv','Anpassad hjÃ¤lp',0),(377232,10479,'it','Guida personalizzata',0),(377233,10479,'tl','',0),(377234,10479,'th','à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡',0),(377235,10479,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤®à¤¦à¤¦',0),(377236,10479,'ms','Bantuan adat',0),(377237,10479,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ù…Ø®ØµØµØ©',0),(377238,10479,'fr','Aide personnalisÃ©e',0),(377239,10479,'jp','ã‚«ã‚¹ã‚¿ãƒ  ãƒ˜ãƒ«ãƒ—',0),(377240,10479,'pt','Ajuda personalizada',0),(377241,10479,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ð¹ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸',0),(377242,10479,'es','Ayuda de PersonalizaciÃ³n',0),(377243,10479,'de','Benutzerdefinierte Hilfe',0),(377244,10479,'en','Custom Help',0),(377245,10480,'is','',0),(377246,10480,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(377247,10480,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(377248,10480,'tr','Ã–zel yardÄ±m baÅŸarÄ±sÄ±zlÄ±k silindi',0),(377249,10480,'pl','Pomoc niestandardowÄ… usuniÄ™ty bÅ‚Ä…d',0),(377250,10480,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ° Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(377251,10480,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù…Ø¯Ø¯ Ù†Ø§Ú©Ø§Ù…ÛŒ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ Û”',0),(377252,10480,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ð¼Ð¾Ñ› Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(377253,10480,'vi','XÃ³a táº¡o trá»£ giÃºp tháº¥t báº¡i',0),(377254,10480,'af','Aangepasde Hulp Skraping het Gefaal',0),(377255,10480,'ro','Ajutor particularizat eliminÄƒ eÅŸec',0),(377256,10480,'et','Kohandatud spikri vÃ¤lja jÃ¤tmine',0),(377257,10480,'si','PomoÄ po meri izbrisana neuspeh',0),(377258,10480,'ba','Kustom bantuan dihapus kegagalan',0),(377259,10480,'nl','Aangepaste Help-informatie verwijderd mislukking',0),(377260,10480,'fi','Mukautetun ohjeen poistaa vika',0),(377261,10480,'no','Egendefinert hjelp slettet feil',0),(377262,10480,'da','Brugerdefineret hjÃ¦lp slettet fiasko',0),(377263,10480,'ko','ì‚¬ìš©ìž ì§€ì • ë„ì›€ë§ ì‚­ì œ ì‹¤íŒ¨',0),(377264,10480,'he','×¢×–×¨×” ×ž×•×ª××ž×ª ××™×©×™×ª ×©× ×ž×—×§×• ×›×©×œ',0),(377265,10480,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· Î²Î¿Î®Î¸ÎµÎ¹Î± Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯ Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(377266,10480,'zh','è‡ªå®šä¹‰å¸®åŠ©åˆ é™¤å¤±è´¥\r\n',0),(377267,10480,'sv','Anpassad hjÃ¤lp bort fel',0),(377268,10480,'it','Aiuto personalizzato eliminato fallimento',0),(377269,10480,'tl','',0),(377270,10480,'th','à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡à¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(377271,10480,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤®à¤¦à¤¦ à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤¹à¤Ÿà¤¾à¤ à¤—à¤',0),(377272,10480,'ms','Bantuan adat dihapuskan kegagalan',0),(377273,10480,'ar','Ø­Ø°Ù Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ù…Ø®ØµØµØ© Ø§Ù„ÙØ´Ù„',0),(377274,10480,'fr','Aide personnalisÃ©e supprimÃ© Ã©chec',0),(377275,10480,'jp','ã‚«ã‚¹ã‚¿ãƒ  ãƒ˜ãƒ«ãƒ—å‰Šé™¤å¤±æ•—',0),(377276,10480,'pt','Ajuda personalizada excluÃ­do falha',0),(377277,10480,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ð¹ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸ Ð¸ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ ÑÐ±Ð¾Ð¹',0),(377278,10480,'es','Ayuda de PersonalizaciÃ³n Eliminar FallÃ³',0),(377279,10480,'de','Benutzerdefinierte Hilfe gelÃ¶scht Scheitern',0),(377280,10480,'en','Custom Help Deleted Failure',0),(377281,10481,'is','',0),(377282,10481,'dr','Ø­Ø°Ù Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(377283,10481,'pr','Ø­Ø°Ù Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(377284,10481,'tr','Ã–zel yardÄ±m baÅŸarÄ±yla silindi',0),(377285,10481,'pl','Pomoc niestandardowÄ… przesâ”‚anie',0),(377286,10481,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ° Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(377287,10481,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©ÛŒ Ù…Ø¯Ø¯',0),(377288,10481,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ð¼Ð¾Ñ› ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(377289,10481,'vi','XÃ³a táº¡o trá»£ giÃºp thÃ nh cÃ´ng',0),(377290,10481,'af','Aangepasde Hulp Suksesvol Geskrap',0),(377291,10481,'ro','Ajutor particularizat eliminÄƒ cu succes',0),(377292,10481,'et','Kohandatud spikri edukalt kustutatud',0),(377293,10481,'si','PomoÄ po meri uspeÅ¡no izbrisana',0),(377294,10481,'ba','Kustom bantuan dihapus berhasil',0),(377295,10481,'nl','Aangepaste Help-informatie met succes verwijderd',0),(377296,10481,'fi','Mukautetun ohjeen poistettu',0),(377297,10481,'no','Egendefinert hjelp slettet',0),(377298,10481,'da','Brugerdefineret hjÃ¦lp slettet',0),(377299,10481,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì‚¬ìš©ìž ì§€ì • ë„ì›€ë§',0),(377300,10481,'he','×¢×–×¨×” ×ž×•×ª××ž×ª ××™×©×™×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(377301,10481,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· Î²Î¿Î®Î¸ÎµÎ¹Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(377302,10481,'zh','è‡ªå®šä¹‰å¸®åŠ©æˆåŠŸåˆ é™¤\r\n',0),(377303,10481,'sv','Anpassad hjÃ¤lp raderades',0),(377304,10481,'it','Aiuto personalizzato eliminato con successo',0),(377305,10481,'tl','',0),(377306,10481,'th','à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡à¸—à¸µà¹ˆà¸–à¸¹à¸à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(377307,10481,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤®à¤¦à¤¦ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(377308,10481,'ms','Bantuan adat yang dihapuskan dengan jayanya',0),(377309,10481,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ù…Ø®ØµØµØ© Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(377310,10481,'fr','Aide personnalisÃ©e supprimÃ©e avec succÃ¨s',0),(377311,10481,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸã‚«ã‚¹ã‚¿ãƒ ã®ãƒ˜ãƒ«ãƒ—',0),(377312,10481,'pt','Ajuda personalizada apagada com sucesso',0),(377313,10481,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ð¹ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(377314,10481,'es','Ayuda de PersonalizaciÃ³n Eliminada Exitosamente',0),(377315,10481,'de','Benutzerdefinierte Hilfe erfolgreich gelÃ¶scht',0),(377316,10481,'en','Custom Help Deleted Successfully',0),(377317,10482,'is','',0),(377318,10482,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(377319,10482,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(377320,10482,'tr','Ã–zel yardÄ±m gÃ¼ncelleÅŸtirmesi baÅŸarÄ±sÄ±z oldu',0),(377321,10482,'pl','Pomoc niestandardowÄ… aktualizacji nie powiodÅ‚o siÄ™',0),(377322,10482,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ° Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(377323,10482,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù…Ø¯Ø¯ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(377324,10482,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ð¼Ð¾Ñ› Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(377325,10482,'vi','Cáº­p nháº­t táº¡o trá»£ giÃºp tháº¥t báº¡i',0),(377326,10482,'af','Aangepasde Hulp Opdatering het Gefaal',0),(377327,10482,'ro','Ajutor particularizat Update nu a reuÈ™it',0),(377328,10482,'et','Kohandatud spikri vÃ¤rskendamine nurjus',0),(377329,10482,'si','PomoÄ po meri ni mogoÄe posodobiti',0),(377330,10482,'ba','Gagal Update kustom bantuan',0),(377331,10482,'nl','Aangepaste Help-Update mislukt',0),(377332,10482,'fi','Mukautetun ohjepÃ¤ivitys epÃ¤onnistui',0),(377333,10482,'no','Egendefinert hjelp-oppdatering mislyktes',0),(377334,10482,'da','Brugerdefineret HjÃ¦lp opdatering mislykkedes',0),(377335,10482,'ko','ì‚¬ìš©ìž ì§€ì • ë„ì›€ë§ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(377336,10482,'he','×¢×–×¨×” ×ž×•×ª××ž×ª ××™×©×™×ª ×”×¢×“×›×•×Ÿ × ×›×©×œ',0),(377337,10482,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· Î²Î¿Î®Î¸ÎµÎ¹Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(377338,10482,'zh','è‡ªå®šä¹‰å¸®åŠ©æ›´æ–°å¤±è´¥\r\n',0),(377339,10482,'sv','Anpassad hjÃ¤lp uppdateringen misslyckades',0),(377340,10482,'it','Aiuto personalizzato di aggiornamento non riuscito',0),(377341,10482,'tl','',0),(377342,10482,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¹à¸šà¸šà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(377343,10482,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤®à¤¦à¤¦ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²',0),(377344,10482,'ms','Kemas-kini bantuan adat yang gagal',0),(377345,10482,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« ØªØ¹Ù„ÙŠÙ…Ø§Øª Ù…Ø®ØµØµØ©',0),(377346,10482,'fr','Aide personnalisÃ©e mise Ã  jour a Ã©chouÃ©',0),(377347,10482,'jp','ã‚«ã‚¹ã‚¿ãƒ  ãƒ˜ãƒ«ãƒ—ã‚’æ›´æ–°ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(377348,10482,'pt','Falhado na atualizaÃ§Ã£o ajuda personalizada',0),(377349,10482,'ru','Ð¡Ð±Ð¾Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ð¹ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸',0),(377350,10482,'es','Ayuda de PersonalizaciÃ³n Actualizar FallÃ³',0),(377351,10482,'de','Benutzerdefinierte Hilfe-Update fehlgeschlagen',0),(377352,10482,'en','Custom Help Update Failed',0),(377353,10483,'is','',0),(377354,10483,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(377355,10483,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(377356,10483,'tr','Ã–zel yardÄ±m baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(377357,10483,'pl','Pomoc niestandardowÄ… pomyÅ›lnie zaktualizowana',0),(377358,10483,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ° Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(377359,10483,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù…Ø¯Ø¯ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(377360,10483,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ð¼Ð¾Ñ› Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(377361,10483,'vi','Cáº­p nháº­t táº¡o trá»£ giÃºp thÃ nh cÃ´ng',0),(377362,10483,'af','Aangepasde Hulp Suksesvol Opdateer',0),(377363,10483,'ro','Ajutor particularizat actualizat cu succes',0),(377364,10483,'et','Kohandatud spikri vÃ¤rskendatud',0),(377365,10483,'si','PomoÄ po meri uspeÅ¡no posodobljena',0),(377366,10483,'ba','Bantuan kustom yang berhasil',0),(377367,10483,'nl','Aangepaste Help-informatie bijgewerkt',0),(377368,10483,'fi','Mukautetun ohjeen pÃ¤ivittÃ¤minen onnistui',0),(377369,10483,'no','Egendefinert hjelp oppdatert',0),(377370,10483,'da','Brugerdefineret hjÃ¦lp opdateret',0),(377371,10483,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì‚¬ìš©ìž ì§€ì • ë„ì›€ë§',0),(377372,10483,'he','×¢×–×¨×” ×ž×•×ª××ž×ª ××™×©×™×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(377373,10483,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· Î²Î¿Î®Î¸ÎµÎ¹Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(377374,10483,'zh','è‡ªå®šä¹‰å¸®åŠ©æˆåŠŸæ›´æ–°\r\n',0),(377375,10483,'sv','Anpassad hjÃ¤lp uppdaterats',0),(377376,10483,'it','Aiuto personalizzato aggiornato con successo',0),(377377,10483,'tl','',0),(377378,10483,'th','à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(377379,10483,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤®à¤¦à¤¦ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(377380,10483,'ms','Bantuan adat yang berjaya dikemas kini',0),(377381,10483,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ù…Ø®ØµØµØ© ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(377382,10483,'fr','Aide personnalisÃ©e, mis Ã  jour avec succÃ¨s',0),(377383,10483,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸã‚«ã‚¹ã‚¿ãƒ ã®ãƒ˜ãƒ«ãƒ—',0),(377384,10483,'pt','Ajuda personalizada atualizada com sucesso',0),(377385,10483,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ð¹ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(377386,10483,'es','Ayuda Personalizada Actualizada Exitosamente',0),(377387,10483,'de','Benutzerdefinierte Hilfe erfolgreich aktualisiert',0),(377388,10483,'en','Custom Help Updated Successfully',0),(377389,10484,'is','',0),(377390,10484,'dr','Ù„Ø·ÙØ§ ÙØ§ÙŠÙ„ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(377391,10484,'pr','Ù„Ø·ÙØ§ ÙØ§ÙŠÙ„ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(377392,10484,'tr','LÃ¼tfen dosya iÃ§erir',0),(377393,10484,'pl','Prosimy o podanie pliku',0),(377394,10484,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð»',0),(377395,10484,'ur','Ø¨Ø±Ø§Û Ú©Ø±Ù… ÙØ§Ø¦Ù„ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(377396,10484,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(377397,10484,'vi','vui lÃ²ng bao gá»“m file',0),(377398,10484,'af','Sluit asb. \'n LÃªer in',0),(377399,10484,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i fiÅŸierul',0),(377400,10484,'et','Palun lisage faili',0),(377401,10484,'si','Prosimo, da vkljuÄite datoteko',0),(377402,10484,'ba','Sertakan File',0),(377403,10484,'nl','Voeg bestand',0),(377404,10484,'fi','LiitÃ¤ tiedosto',0),(377405,10484,'no','Vennligst inkluder filen',0),(377406,10484,'da','VedlÃ¦g fil',0),(377407,10484,'ko','íŒŒì¼ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(377408,10484,'he','×× × ×›×œ×•×œ ×§×•×‘×¥',0),(377409,10484,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(377410,10484,'zh','è¯·åˆ—å…¥æ–‡ä»¶\r\n',0),(377411,10484,'sv','VÃ¤nligen inkludera filen',0),(377412,10484,'it','Si prega di includere File',0),(377413,10484,'tl','',0),(377414,10484,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¹à¸Ÿà¹‰à¸¡',0),(377415,10484,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤«à¤¼à¤¾à¤‡à¤² à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(377416,10484,'ms','Sila Sertakan fail',0),(377417,10484,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø±ÙØ§Ù‚ Ù…Ù„Ù',0),(377418,10484,'fr','S\'il vous plaÃ®t inclure fichier',0),(377419,10484,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(377420,10484,'pt','Por favor, inclua o arquivo',0),(377421,10484,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ñ„Ð°Ð¹Ð»',0),(377422,10484,'es','Por Favor Incluye Archivo',0),(377423,10484,'de','Bitte Datei einbinden',0),(377424,10484,'en','Please Include File',0),(377425,10485,'is','',0),(377426,10485,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ ÙØ§ÙŠÙ„ Ù…Ø¹ØªØ¨Ø± Ø±Ø§ Ø¢Ù¾Ù„ÙˆØ¯ ÙƒÙ†ÙŠØ¯ ',0),(377427,10485,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ ÙØ§ÙŠÙ„ Ù…Ø¹ØªØ¨Ø± Ø±Ø§ Ø¢Ù¾Ù„ÙˆØ¯ ÙƒÙ†ÙŠØ¯ ',0),(377428,10485,'tr','LÃ¼tfen geÃ§erli bir dosya yÃ¼kleme',0),(377429,10485,'pl','ProszÄ™ przesÅ‚aÄ‡ plik waÅ¼ne',0),(377430,10485,'bg','ÐœÐ¾Ð»Ñ, ÐºÐ°Ñ‡ÐµÑ‚Ðµ Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ Ñ„Ð°Ð¹Ð»',0),(377431,10485,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø¬Ø§Ø¦Ø² Ù…Ø³Ù„ Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(377432,10485,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° Ð¿Ð¾ÑˆÐ°Ñ™ÐµÑ‚Ðµ Ð²Ð°Ð¶ÐµÑ›Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(377433,10485,'vi','vui lÃ²ng táº£i file cÃ³ giÃ¡ trá»‹',0),(377434,10485,'af','Laai Asseblief \'n Geldige LÃªer Op',0),(377435,10485,'ro','VÄƒ rugÄƒm sÄƒ Ã®ncÄƒrcaÅ£i un fiÅŸier Valid',0),(377436,10485,'et','Palun laadige sobiv fail',0),(377437,10485,'si','Prosim Upload veljavna datoteka',0),(377438,10485,'ba','Silahkan Upload sebuah File sah',0),(377439,10485,'nl','Gelieve een geldig bestand uploaden',0),(377440,10485,'fi','Lataa kelvollinen tiedosto',0),(377441,10485,'no','Last opp en gyldig fil',0),(377442,10485,'da','Upload en gyldig fil',0),(377443,10485,'ko','ì˜¬ë°”ë¥¸ íŒŒì¼ì„ ì—…ë¡œë“œ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(377444,10485,'he','×× × ×”×¢×œ×” ×§×•×‘×¥ ×ª×§×£',0),(377445,10485,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Î±Î½ÎµÎ²Î¬ÏƒÎµÏ„Îµ Î­Î½Î± Î­Î³ÎºÏ…ÏÎ¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(377446,10485,'zh','è¯·ä¸Šä¼ ä¸€ä¸ªæœ‰æ•ˆçš„æ–‡ä»¶\r\n',0),(377447,10485,'sv','Ladda upp en giltig fil',0),(377448,10485,'it','Si prega di caricare un File valido',0),(377449,10485,'tl','',0),(377450,10485,'th','à¹‚à¸›à¸£à¸”à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¹à¸Ÿà¹‰à¸¡à¸—à¸µà¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(377451,10485,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤®à¤¾à¤¨à¥à¤¯ à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(377452,10485,'ms','Sila muat naik fail yang sah',0),(377453,10485,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ù…ÙŠÙ„ Ù…Ù„Ù ØµØ§Ù„Ø­',0),(377454,10485,'fr','Merci d\'uploader un fichier valide',0),(377455,10485,'jp','æœ‰åŠ¹ãªãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã—ã¦ãã ã•ã„ã€‚',0),(377456,10485,'pt','Por favor, carregue um arquivo vÃ¡lido',0),(377457,10485,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð·Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚Ðµ Ñ„Ð°Ð¹Ð»',0),(377458,10485,'es','Por Favor Subir un File VÃ¡lido',0),(377459,10485,'de','Bitte eine gÃ¼ltige Datei hochladen',0),(377460,10485,'en','Please Upload a Valid File',0),(377461,10486,'is','',0),(377462,10486,'dr','ÙØ§ÙŠÙ„ Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† ',0),(377463,10486,'pr','ÙØ§ÙŠÙ„ Ø¬Ø§ÙŠÚ¯Ø²ÙŠÙ† ',0),(377464,10486,'tr','Yedek dosyasÄ±',0),(377465,10486,'pl','Plik wymiany',0),(377466,10486,'bg','Ð—Ð°Ð¼ÑÐ½Ð° Ñ„Ð°Ð¹Ð»',0),(377467,10486,'ur','Ù…Ø³Ù„ Ø¨Ø¯Ù„ÛŒ',0),(377468,10486,'sr','Ð—Ð°Ð¼ÐµÐ½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(377469,10486,'vi','file thay tháº¿',0),(377470,10486,'af','Vervanging lÃªer',0),(377471,10486,'ro','FiÅŸier de Ã®nlocuire',0),(377472,10486,'et','Asendusfaili',0),(377473,10486,'si','Zamenjavo datoteke',0),(377474,10486,'ba','Penggantian File',0),(377475,10486,'nl','Vervangende bestand',0),(377476,10486,'fi','Korvaavan tiedoston',0),(377477,10486,'no','Erstatningsfilen',0),(377478,10486,'da','Erstatningsfilen',0),(377479,10486,'ko','ëŒ€ì²´ íŒŒì¼',0),(377480,10486,'he','×§×•×‘×¥ ×”×”×—×œ×¤×”',0),(377481,10486,'el','Î‘Î½Ï„Î¹ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(377482,10486,'zh','æ›¿æ¢æ–‡ä»¶\r\n',0),(377483,10486,'sv','ErsÃ¤ttningsfilen',0),(377484,10486,'it','Sostituzione File',0),(377485,10486,'tl','',0),(377486,10486,'th','à¹à¸—à¸™à¹à¸Ÿà¹‰à¸¡',0),(377487,10486,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¸à¥à¤¥à¤¾à¤ªà¤¨ à¤«à¤¼à¤¾à¤‡à¤²',0),(377488,10486,'ms','Penggantian fail',0),(377489,10486,'ar','Ø§Ù„Ù…Ù„ÙÙ‘ Ø§Ù„Ø¨Ø¯ÙŠÙ„',0),(377490,10486,'fr','Fichier de remplacement',0),(377491,10486,'jp','ç½®æ›ãƒ•ã‚¡ã‚¤ãƒ«',0),(377492,10486,'pt','Arquivo de substituiÃ§Ã£o',0),(377493,10486,'ru','Ð—Ð°Ð¼ÐµÐ½Ð° Ñ„Ð°Ð¹Ð»Ð°',0),(377494,10486,'es','Archivo Sustituto',0),(377495,10486,'de','Ersatzdatei',0),(377496,10486,'en','Replacement File',0),(377497,10487,'is','',0),(377498,10487,'dr','( Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(377499,10487,'pr','Ø³Ø§Ø®Øª ( Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(377500,10487,'tr','Ä°nÅŸaat',0),(377501,10487,'pl','Budowlane',0),(377502,10487,'bg','Ð¡Ñ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(377503,10487,'ur','ØªØ¹Ù…ÛŒØ±',0),(377504,10487,'sr','Ð˜Ð·Ð³Ñ€Ð°Ð´ÑšÐ°',0),(377505,10487,'vi','cáº¥u trÃºc',0),(377506,10487,'af','Konstruksie',0),(377507,10487,'ro','Constructii',0),(377508,10487,'et','Ehitus',0),(377509,10487,'si','GradbeniÅ¡tvo',0),(377510,10487,'ba','Konstruksi',0),(377511,10487,'nl','Bouw',0),(377512,10487,'fi','Rakentaminen',0),(377513,10487,'no','Konstruksjon',0),(377514,10487,'da','Byggeri',0),(377515,10487,'ko','ê±´ì„¤',0),(377516,10487,'he','×‘× ×™×™×”',0),(377517,10487,'el','ÎšÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(377518,10487,'zh','å»ºè®¾\r\n',0),(377519,10487,'sv','Konstruktion',0),(377520,10487,'it','Costruzione',0),(377521,10487,'tl','',0),(377522,10487,'th','à¸à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡',0),(377523,10487,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(377524,10487,'ms','Pembinaan',0),(377525,10487,'ar','Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(377526,10487,'fr','Construction',0),(377527,10487,'jp','å»ºè¨­',0),(377528,10487,'pt','ConstruÃ§Ã£o',0),(377529,10487,'ru','Ð¡Ñ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾',0),(377530,10487,'es','ConstrucciÃ³n',0),(377531,10487,'de','Bau',0),(377532,10487,'en','Construction',0),(377533,10488,'is','',0),(377534,10488,'dr','Ø®Ø§Ù†Ù‡  ØªØ¨  Ú¯Ø²Ø§Ø±Ø´Ø§Øª',0),(377535,10488,'pr','Ø®Ø§Ù†Ù‡  ØªØ¨  Ú¯Ø²Ø§Ø±Ø´Ø§Øª',0),(377536,10488,'tr','GiriÅŸ sekmesi raporlarÄ±',0),(377537,10488,'pl','Strona gÅ‚Ã³wna karta raporty',0),(377538,10488,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ñ€Ð°Ð·Ð´ÐµÐ»Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(377539,10488,'ur','Ú¯Ú¾Ø± Ø¬Ø¯ÙˆÙ„ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(377540,10488,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ñƒ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(377541,10488,'vi','NhÃ  Tab bÃ¡o cÃ¡o',0),(377542,10488,'af','Tuis Tabuleerder Verslae',0),(377543,10488,'ro','Casa fila rapoarte',0),(377544,10488,'et','Avaleht jaotise aruanded',0),(377545,10488,'si','Dom zanka poroÄila',0),(377546,10488,'ba','Rumah Tab laporan',0),(377547,10488,'nl','Huis tabblad rapporten',0),(377548,10488,'fi','Aloitus-vÃ¤lilehden raportit',0),(377549,10488,'no','Kategorien Hjem rapporter',0),(377550,10488,'da','Fanen Hjem rapporter',0),(377551,10488,'ko','í™ˆ íƒ­ ë³´ê³ ì„œ',0),(377552,10488,'he','×”×›×¨×˜×™×¡×™×” \' ×‘×™×ª \' ×“×•×—×•×ª',0),(377553,10488,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÎºÎ±ÏÏ„Î­Î»Î± ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(377554,10488,'zh','ä¸»é¡µé€‰é¡¹å¡çš„æŠ¥å‘Š\r\n',0),(377555,10488,'sv','Fliken rapporter',0),(377556,10488,'it','Casa scheda rapporti',0),(377557,10488,'tl','',0),(377558,10488,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸‚à¸­à¸‡à¹à¸—à¹‡à¸šà¸«à¸™à¹‰à¸²à¹à¸£à¸',0),(377559,10488,'hi','à¤¹à¥‹à¤® à¤Ÿà¥ˆà¤¬ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥‡à¤‚',0),(377560,10488,'ms','Laporan-laporan utama Tab',0),(377561,10488,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¨ÙˆÙŠØ¨ Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(377562,10488,'fr','Rapports de l\'onglet Accueil',0),(377563,10488,'jp','[ãƒ›ãƒ¼ãƒ ] ã‚¿ãƒ–ã®ãƒ¬ãƒãƒ¼ãƒˆ',0),(377564,10488,'pt','Casa guia relatÃ³rios',0),(377565,10488,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ Ð²ÐºÐ»Ð°Ð´ÐºÐ° ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹',0),(377566,10488,'es','Informes de Ficha de Hogar',0),(377567,10488,'de','Home Tab-Berichte',0),(377568,10488,'en','Home Tab Reports',0),(377569,10489,'is','',0),(377570,10489,'dr','Ø®Ø§Ù†Ù‡  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªØ¨ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(377571,10489,'pr','Ø®Ø§Ù†Ù‡  Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªØ¨ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(377572,10489,'tr','GiriÅŸ sekmesi raporlarÄ± gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu',0),(377573,10489,'pl','Strona gÅ‚Ã³wna karta raporty aktualizacji nie powiodÅ‚o siÄ™',0),(377574,10489,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸Ñ‚Ðµ Ð½Ð° Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¾ Ð¾Ð³Ð½Ð¸Ñ‰Ðµ ÐŸÐµÑ‚Ð»Ð¸Ñ‡ÐºÐ°',0),(377575,10489,'ur','Ù†Ø§Ú©Ø§Ù… Ú¯Ú¾Ø± Ù¹ÛŒØ¨ Ø±Ù¾ÙˆØ±Ù¹ÛŒÚº ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(377576,10489,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ñƒ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(377577,10489,'vi','NhÃ  Tab bÃ¡o cÃ¡o Cáº­p Nháº­t khÃ´ng thÃ nh cÃ´ng',0),(377578,10489,'af','Tuis Tabuleerder Verslae Opdatering het Gefaal',0),(377579,10489,'ro','Casa fila rapoarte Update nu a reuÈ™it',0),(377580,10489,'et','Avaleht jaotise aruanded vÃ¤rskendamine nurjus',0),(377581,10489,'si','Dom zanka poroÄila ni mogoÄe posodobiti',0),(377582,10489,'ba','Rumah Tab laporan Update gagal',0),(377583,10489,'nl','Huis tabblad rapporten Update is mislukt',0),(377584,10489,'fi','Aloitus-vÃ¤lilehden raportit pÃ¤ivitys epÃ¤onnistui',0),(377585,10489,'no','Kategorien Hjem rapporter oppdatering mislyktes',0),(377586,10489,'da','Fanen Hjem rapporter opdatering mislykkedes',0),(377587,10489,'ko','í™ˆ íƒ­ ë³´ê³ ì„œ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(377588,10489,'he','×”×›×¨×˜×™×¡×™×” \' ×‘×™×ª \' ×“×•×—×•×ª ×”×¢×“×›×•×Ÿ × ×›×©×œ',0),(377589,10489,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÎºÎ±ÏÏ„Î­Î»Î± ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(377590,10489,'zh','æŠ¥å‘Šæ›´æ–°å¤±è´¥ä¸»é¡µé€‰é¡¹å¡\r\n',0),(377591,10489,'sv','Fliken rapporter uppdateringen misslyckades',0),(377592,10489,'it','Casa scheda report aggiornamento non riuscito',0),(377593,10489,'tl','',0),(377594,10489,'th','à¹à¸—à¹‡à¸šà¸šà¹‰à¸²à¸™à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸¢à¸‡à¸²à¸™à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(377595,10489,'hi','à¤¹à¥‹à¤® à¤Ÿà¥ˆà¤¬ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²',0),(377596,10489,'ms','Kemaskini laporan Tab rumah yang gagal',0),(377597,10489,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« ØªÙ‚Ø§Ø±ÙŠØ± Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¨ÙˆÙŠØ¨ Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(377598,10489,'fr','Accueil onglet rapports mise Ã  jour a Ã©chouÃ©',0),(377599,10489,'jp','[ãƒ›ãƒ¼ãƒ ] ã‚¿ãƒ–ã®ãƒ¬ãƒãƒ¼ãƒˆã‚’æ›´æ–°ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(377600,10489,'pt','Casa guia relatÃ³rios atualizaÃ§Ã£o falhada',0),(377601,10489,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð“Ð»Ð°Ð²Ð½Ð°Ñ Ð²ÐºÐ»Ð°Ð´ÐºÐ° ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹',0),(377602,10489,'es','Informes de Ficha de Hogar Actualizar FallÃ³',0),(377603,10489,'de','Home Tab-Berichte-Update fehlgeschlagen',0),(377604,10489,'en','Home Tab Reports Update Failed',0),(377605,10490,'is','',0),(377606,10490,'dr','Ø®Ø§Ù†Ù‡ ØªØ¨ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(377607,10490,'pr','Ø®Ø§Ù†Ù‡ ØªØ¨ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(377608,10490,'tr','GiriÅŸ sekmesi rapor baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(377609,10490,'pl','Strona gÅ‚Ã³wna karta raporty zostaâ”‚a zaktualizowana',0),(377610,10490,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ñ€Ð°Ð·Ð´ÐµÐ»Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(377611,10490,'ur','Ú¯Ú¾Ø± Ø¬Ø¯ÙˆÙ„ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©Ø± Ø¯ÛŒØ§',0),(377612,10490,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ñƒ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(377613,10490,'vi','NhÃ  Tab bÃ¡o cÃ¡o Cáº­p Nháº­t thÃ nh cÃ´ng',0),(377614,10490,'af','Tuis Tabuleerder Verslae Suksesvol Opdateer',0),(377615,10490,'ro','Casa fila rapoarte actualizate cu succes',0),(377616,10490,'et','Avaleht jaotise aruanded edukalt vÃ¤rskendatud',0),(377617,10490,'si','Dom zanka poroÄila uspeÅ¡no posodobljena',0),(377618,10490,'ba','Rumah Tab laporan diperbarui berhasil',0),(377619,10490,'nl','Huis tabblad rapporten met succes bijgewerkt',0),(377620,10490,'fi','Aloitus-vÃ¤lilehden raportit pÃ¤ivitetty',0),(377621,10490,'no','Kategorien Hjem rapporter oppdatert',0),(377622,10490,'da','Fanen Hjem rapporter opdateret',0),(377623,10490,'ko','í™ˆ íƒ­ ë³´ê³ ì„œ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(377624,10490,'he','×”×›×¨×˜×™×¡×™×” \' ×‘×™×ª \' ×“×•×—×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(377625,10490,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÎºÎ±ÏÏ„Î­Î»Î± ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(377626,10490,'zh','ä¸»é¡µé€‰é¡¹å¡æˆåŠŸæ›´æ–°æŠ¥å‘Š\r\n',0),(377627,10490,'sv','Fliken rapporter uppdaterats',0),(377628,10490,'it','Casa scheda report aggiornato con successo',0),(377629,10490,'tl','',0),(377630,10490,'th','à¹à¸—à¹‡à¸šà¸šà¹‰à¸²à¸™à¸£à¸²à¸¢à¸‡à¸²à¸™à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(377631,10490,'hi','à¤¹à¥‹à¤® à¤Ÿà¥ˆà¤¬ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(377632,10490,'ms','Laporan-laporan utama Tab yang berjaya dikemas kini',0),(377633,10490,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¨ÙˆÙŠØ¨ Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(377634,10490,'fr','Accueil onglet rapports mis Ã  jour avec succÃ¨s',0),(377635,10490,'jp','[ãƒ›ãƒ¼ãƒ ] ã‚¿ãƒ–ã®ãƒ¬ãƒãƒ¼ãƒˆã‚’æ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(377636,10490,'pt','Casa guia RelatÃ³rios atualizados com sucesso',0),(377637,10490,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ Ð²ÐºÐ»Ð°Ð´ÐºÐ° ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(377638,10490,'es','Informes de Ficha de Hogar Actualizados Exitosamente',0),(377639,10490,'de','Home Tab-Berichte, die erfolgreich aktualisiert',0),(377640,10490,'en','Home Tab Reports Updated Successfully',0),(377641,10491,'is','',0),(377642,10491,'dr','Ù„Ø·ÙØ§ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(377643,10491,'pr','Ù„Ø·ÙØ§ Ú¯Ø²Ø§Ø±Ø´Ø§Øª Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(377644,10491,'tr','LÃ¼tfen raporlarÄ± iÃ§erir',0),(377645,10491,'pl','ProszÄ™ podaÄ‡ sprawozdania',0),(377646,10491,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(377647,10491,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø±Ù¾ÙˆØ±Ù¹ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(377648,10491,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(377649,10491,'vi','vui lÃ²ng bao gá»“m cÃ¡c bÃ¡o cÃ¡o',0),(377650,10491,'af','Sluit asseblief Verslae in',0),(377651,10491,'ro','VÄƒ rugÄƒm sÄƒ includÄƒ rapoarte',0),(377652,10491,'et','Palun lisage aruanded',0),(377653,10491,'si','Prosimo, da vkljuÄite poroÄila',0),(377654,10491,'ba','Harap sertakan laporan',0),(377655,10491,'nl','Gelieve te omvatten rapporten',0),(377656,10491,'fi','LiitÃ¤ mukaan raportit',0),(377657,10491,'no','Ta med rapporter',0),(377658,10491,'da','VedlÃ¦g rapporter',0),(377659,10491,'ko','ë³´ê³ ì„œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(377660,10491,'he','×× × ×›×œ×•×œ ×“×•×—×•×ª',0),(377661,10491,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(377662,10491,'zh','è¯·åˆ—å…¥æŠ¥å‘Š\r\n',0),(377663,10491,'sv','VÃ¤nligen inkludera rapporter',0),(377664,10491,'it','Si prega di includere i rapporti',0),(377665,10491,'tl','',0),(377666,10491,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸§à¸¡à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(377667,10491,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(377668,10491,'ms','Sila sertakan Laporan',0),(377669,10491,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ±',0),(377670,10491,'fr','Veuillez inclure les rapports',0),(377671,10491,'jp','ãƒ¬ãƒãƒ¼ãƒˆã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(377672,10491,'pt','Por favor incluir relatÃ³rios',0),(377673,10491,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’Ð½ÐµÑÐ¸Ñ‚Ðµ ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹',0),(377674,10491,'es','Por Favor Incluye Informes',0),(377675,10491,'de','Bitte geben Sie Berichte',0),(377676,10491,'en','Please Include Reports',0),(377677,10492,'is','',0),(377678,10492,'dr','Ù…Ø¯ÙŠØ±ÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(377679,10492,'pr','Ù…Ø¯ÙŠØ±ÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(377680,10492,'tr','Gayrimenkul yÃ¶netimi',0),(377681,10492,'pl','ZarzÄ…dzanie nieruchomoÅ›ciami',0),(377682,10492,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚Ð¸',0),(377683,10492,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹',0),(377684,10492,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ð½ÐµÐºÑ€ÐµÑ‚Ð½Ð¸Ð½Ð°Ð¼Ð°',0),(377685,10492,'vi','quáº£n lÃ½ tÃ i sáº£n',0),(377686,10492,'af','Eiendom bestuur',0),(377687,10492,'ro','Gestionarea investitiilor',0),(377688,10492,'et','Kinnisvara haldamine',0),(377689,10492,'si','Upravljanje premoÅ¾enja',0),(377690,10492,'ba','Manajemen properti',0),(377691,10492,'nl','Beheer van onroerend goed',0),(377692,10492,'fi','Omaisuudenhoito',0),(377693,10492,'no','Eiendomsforvaltning',0),(377694,10492,'da','Ejendomsadministration',0),(377695,10492,'ko','ìž¬ì‚° ê´€ë¦¬',0),(377696,10492,'he','× ×™×”×•×œ × ×›×¡×™×',0),(377697,10492,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Î±ÎºÎ¹Î½Î®Ï„Ï‰Î½',0),(377698,10492,'zh','å±žæ€§ç®¡ç†\r\n',0),(377699,10492,'sv','FastighetsfÃ¶rvaltning',0),(377700,10492,'it','Gestione delle proprietÃ ',0),(377701,10492,'tl','',0),(377702,10492,'th','à¸à¸²à¸£à¸šà¸£à¸´à¸«à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(377703,10492,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨',0),(377704,10492,'ms','Pengurusan hartanah',0),(377705,10492,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(377706,10492,'fr','Gestion de la propriÃ©tÃ©',0),(377707,10492,'jp','è²¡ç”£ç®¡ç†',0),(377708,10492,'pt','GestÃ£o da propriedade',0),(377709,10492,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾Ð¼',0),(377710,10492,'es','GestiÃ³n de Propiedad',0),(377711,10492,'de','Hausverwaltung',0),(377712,10492,'en','Property Management',0),(377713,10493,'is','',0),(377714,10493,'dr','Ø§Ù†Ù‚Ø¶Ø§ÙŠ Ø´Ø±Ø§ÙŠØ·  ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(377715,10493,'pr','Ø§Ù†Ù‚Ø¶Ø§ÙŠ Ø´Ø±Ø§ÙŠØ·  ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(377716,10493,'tr','SatÄ±cÄ± gereksinim son kullanma',0),(377717,10493,'pl','Sprzedawca wymagania wygaÅ›niÄ™cia',0),(377718,10493,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ',0),(377719,10493,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¶Ø±ÙˆØ±Øª Ø®ØªÙ… ÛÙˆÙ†Û’',0),(377720,10493,'sr','Ð Ð¾Ðº Ð²Ð°Ð¶ÐµÑšÐ° ÑƒÑÐ»Ð¾Ð² Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(377721,10493,'vi','Háº¿t háº¡n yÃªu cáº§u cá»§a nhÃ  cung cáº¥p',0),(377722,10493,'af','Handelaar vereiste verstryking',0),(377723,10493,'ro','Furnizor de cerinÅ£a de expirare',0),(377724,10493,'et','Hankija nÃµude aegumine',0),(377725,10493,'si','Dobavitelja zahteva poteka',0),(377726,10493,'ba','Vendor persyaratan kadaluarsa',0),(377727,10493,'nl','Leverancier eis vervaldatum',0),(377728,10493,'fi','Toimittajan vaatimus pÃ¤Ã¤ttyminen',0),(377729,10493,'no','LeverandÃ¸ren kravet utlÃ¸p',0),(377730,10493,'da','Kreditors krav udlÃ¸b',0),(377731,10493,'ko','ê³µê¸‰ ì—…ì²´ ìš”ê±´ ë§Œë£Œ',0),(377732,10493,'he','×¡×¤×§ ×“×¨×™×©×” ×ª×¤×•×’×”',0),(377733,10493,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Ï€Î±Î¯Ï„Î·ÏƒÎ· Î»Î®Î¾Î·Ï‚',0),(377734,10493,'zh','ä¾›åº”å•†è¦æ±‚è¿‡æœŸ\r\n',0),(377735,10493,'sv','LeverantÃ¶rens krav fÃ¶rfallodatum',0),(377736,10493,'it','Scadenza obbligo vendor',0),(377737,10493,'tl','',0),(377738,10493,'th','à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(377739,10493,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿',0),(377740,10493,'ms','Pembekal keperluan tamat',0),(377741,10493,'ar','Ø¨Ø§Ø¦Ø¹ Ø´Ø±Ø· Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØµÙ„Ø§Ø­ÙŠØ©',0),(377742,10493,'fr','Expiration d\'obligation du vendeur',0),(377743,10493,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¦ä»¶ã®æœ‰åŠ¹æœŸé™',0),(377744,10493,'pt','ExpiraÃ§Ã£o de exigÃªncia do fornecedor',0),(377745,10493,'ru','Ð˜ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ðµ Ð¡Ñ€Ð¾ÐºÐ° Ð¢Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ð¹ ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(377746,10493,'es','Vencimiento del Requerimiento del Proveedor',0),(377747,10493,'de','Hersteller Anforderung Ablauf',0),(377748,10493,'en','Vendor Requirement Expiration',0),(377749,10494,'is','',0),(377750,10494,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„  Ù†ÙŠØ³Øª',0),(377751,10494,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ†  ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„  Ù†ÙŠØ³Øª',0),(377752,10494,'tr','Beraberlik Excel dosyasÄ± bulunamadÄ±',0),(377753,10494,'pl','Nie moÅ¼na odnaleÅºÄ‡ pliku Excel remis',0),(377754,10494,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Draw Excel Ñ„Ð°Ð¹Ð»',0),(377755,10494,'ur','ÚˆØ±Ø§ Excel Ù…Ø³Ù„ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§',0),(377756,10494,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð•xÑ†ÐµÐ» Ð”Ñ€Ð°w',0),(377757,10494,'vi','khÃ´ng thá»ƒ tÃ¬m tháº¥y file váº½ excel',0),(377758,10494,'af','Kon teken Excel lÃªer vind nie',0),(377759,10494,'ro','Imposibil de gÄƒsit fiÈ™ierul Excel Draw',0),(377760,10494,'et','Joonista Exceli faili ei leitud',0),(377761,10494,'si','Pripravi Excel datoteke ni mogoÄe najti',0),(377762,10494,'ba','Tidak dapat menemukan File Excel menarik',0),(377763,10494,'nl','Kon Draw Excel bestand niet vinden',0),(377764,10494,'fi','PiirrÃ¤ Excel-tiedostoa ei lÃ¶ydy',0),(377765,10494,'no','Finner ikke trekke Excel-fil',0),(377766,10494,'da','Draw Excel filen blev ikke fundet',0),(377767,10494,'ko','ë¬´ìŠ¹ë¶€ Excel íŒŒì¼ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(377768,10494,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×§×•×‘×¥ Excel ×œ×¦×™×™×¨',0),(377769,10494,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Excel Î¹ÏƒÎ¿Ï€Î±Î»Î¯Î±',0),(377770,10494,'zh','æ‰¾ä¸åˆ°ç»˜åˆ¶Excelæ–‡ä»¶\r\n',0),(377771,10494,'sv','Kunde inte hitta dra Excel-fil',0),(377772,10494,'it','Impossibile trovare il File di Excel Draw',0),(377773,10494,'tl','',0),(377774,10494,'th','à¹„à¸¡à¹ˆà¸žà¸šà¹à¸Ÿà¹‰à¸¡ Excel à¸­à¸­à¸',0),(377775,10494,'hi','à¤¡à¥à¤°à¤¾ Excel à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(377776,10494,'ms','Tidak dapat mencari fail Excel cabutan',0),(377777,10494,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ù„Ù Excel ÙÙŠ Ø±Ø³Ù…',0),(377778,10494,'fr','Tirage au sort Excel fichier introuvable',0),(377779,10494,'jp','æç”»ã® Excel ãƒ•ã‚¡ã‚¤ãƒ«ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(377780,10494,'pt','NÃ£o foi possÃ­vel localizar o arquivo de Excel Draw',0),(377781,10494,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ Ñ„Ð°Ð¹Ð» Excel Ð´Ñ€Ð¾',0),(377782,10494,'es','No se EncontrÃ³ Archivo de Dibujo Excel',0),(377783,10494,'de','Draw-Excel-Datei konnte nicht gefunden werden.',0),(377784,10494,'en','Could Not Find Draw Excel File',0),(377785,10495,'is','',0),(377786,10495,'dr','(Ø¨Ø±Ø§Øª) Ù‚Ø±Ø¹Ù‡ ÙƒØ´ÙŠ ',0),(377787,10495,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø¨Ø±Ú¯Ù‡(Ø¨Ø±Ø§Øª) Ù‚Ø±Ø¹Ù‡ ÙƒØ´ÙŠ ',0),(377788,10495,'tr','Beraberlik indiriniz',0),(377789,10495,'pl','Pobierz arkusz remis',0),(377790,10495,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÐµÑ‚Ðµ Ð»Ð¸ÑÑ‚ Ð·Ð° Ñ€Ð°Ð²ÐµÐ½ÑÑ‚Ð²Ð¾',0),(377791,10495,'ur','ÚˆØ±Ø§ ÙˆØ±Ù‚ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(377792,10495,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¼Ð¸Ñ‚Ðµ Ð»Ð¸ÑÑ‚ Ð·Ð° Ñ†Ñ€Ñ‚Ð°ÑšÐµ',0),(377793,10495,'vi','Táº£i báº£ng váº½',0),(377794,10495,'af','Trek vel aflaai',0),(377795,10495,'ro','Descarca Draw foaie',0),(377796,10495,'et','Lae Joonista lehe',0),(377797,10495,'si','Download pripravi list',0),(377798,10495,'ba','Download menggambar lembar',0),(377799,10495,'nl','Draw fiche',0),(377800,10495,'fi','Imuroi PiirrÃ¤ taulukko',0),(377801,10495,'no','Laste ned uavgjort arket',0),(377802,10495,'da','Downloade Draw ark',0),(377803,10495,'ko','ë¬´ìŠ¹ë¶€ ì‹œíŠ¸ ë‹¤ìš´ë¡œë“œ',0),(377804,10495,'he','×œ×”×•×¨×“×ª ×“×£ ×¦×™×•×¨',0),(377805,10495,'el','Î›Î®ÏˆÎ· Ï„Ï‰Î½ ÎºÎ»Î·ÏÏŽÏƒÎµÏ‰Î½',0),(377806,10495,'zh','ä¸‹è½½ç»˜å›¾æ¿\r\n',0),(377807,10495,'sv','HÃ¤mta dra blad',0),(377808,10495,'it','Scarica scheda Draw',0),(377809,10495,'tl','',0),(377810,10495,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹à¸œà¹ˆà¸™à¸­à¸­à¸',0),(377811,10495,'hi','à¤¡à¥à¤°à¤¾ à¤¶à¥€à¤Ÿ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡',0),(377812,10495,'ms','Muat turun kira-kira cabutan',0),(377813,10495,'ar','ØªØ­Ù…ÙŠÙ„ ÙˆØ±Ù‚Ø© Ø±Ø³Ù…',0),(377814,10495,'fr','TÃ©lÃ©charger alÃ¨se',0),(377815,10495,'jp','æç”»ã‚·ãƒ¼ãƒˆã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(377816,10495,'pt','Baixar lenÃ§ol',0),(377817,10495,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ Ð»Ð¸ÑÑ‚ Ñ€Ð¾Ð·Ñ‹Ð³Ñ€Ñ‹ÑˆÐ°',0),(377818,10495,'es','Descargar Hoja de Retiras del Dnero',0),(377819,10495,'de','Draw-Blatt herunterladen',0),(377820,10495,'en','Download Draw Sheet',0),(377821,10496,'is','',0),(377822,10496,'dr','(Ø¨Ø±Ø§Øª)Ù‚Ø±Ø¹Ù‡ Ú©Ø´Ù‰ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª',0),(377823,10496,'pr','Ø´Ù†Ø§Ø³Ù‡ (Ø¨Ø±Ø§Øª)Ù‚Ø±Ø¹Ù‡ Ú©Ø´Ù‰ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª',0),(377824,10496,'tr','Beraberlik kimliÄŸi ayarlanmamÄ±ÅŸ',0),(377825,10496,'pl','Remis ID nie zestaw',0),(377826,10496,'bg','Draw Ð˜Ð” Ð½Ðµ Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¾',0),(377827,10496,'ur','ÚˆØ±Ø§ ID Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(377828,10496,'sr','Ð”Ñ€Ð°w Ð˜Ð” Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(377829,10496,'vi','MÃ£ xÃ¡c nháº­n sá»‘ khÃ´ng Ä‘Æ°á»£c cÃ i',0),(377830,10496,'af','Teken ID stel nie',0),(377831,10496,'ro','Trage ID nu Set',0),(377832,10496,'et','Joonista ID pole mÃ¤Ã¤ratud',0),(377833,10496,'si','Pripravi ID ni nastavljena',0),(377834,10496,'ba','Menggambar ID tidak diatur',0),(377835,10496,'nl','Draw ID niet ingesteld',0),(377836,10496,'fi','PiirrÃ¤ tunnusta ei mÃ¤Ã¤ritetty',0),(377837,10496,'no','Draw-ID ikke angitt',0),(377838,10496,'da','Draw-ID\'ET ikke er angivet',0),(377839,10496,'ko','ê·¸ë¦¬ê¸° IDë¥¼ ì„¤ì • í•˜ì§€',0),(377840,10496,'he','×¦×™×™×¨ ×ž×–×”×” ××™× ×• ×ž×•×’×“×¨',0),(377841,10496,'el','ÎšÎ»Î®ÏÏ‰ÏƒÎ· ID Ï€Î¿Ï… Î´ÎµÎ½',0),(377842,10496,'zh','ç»˜åˆ¶IDæ²¡æœ‰è®¾ç½®\r\n',0),(377843,10496,'sv','Draw-ID inte anges',0),(377844,10496,'it','Sorteggio ID non impostato',0),(377845,10496,'tl','',0),(377846,10496,'th','à¸£à¸«à¸±à¸ªà¸­à¸­à¸à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²',0),(377847,10496,'hi','à¤¡à¥à¤°à¤¾ ID à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(377848,10496,'ms','Seri ID tidak disetkan',0),(377849,10496,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ø¹Ø±Ù Ø±Ø³Ù…',0),(377850,10496,'fr','Tirage au sort ID pas dÃ©fini',0),(377851,10496,'jp','æç”»ã® ID ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(377852,10496,'pt','Sorteio ID nÃ£o definido',0),(377853,10496,'ru','Ð Ð¾Ð·Ñ‹Ð³Ñ€Ñ‹Ñˆ ID Ð½Ðµ Ð·Ð°Ð´Ð°Ð½',0),(377854,10496,'es','ID de Retiro No Configurado',0),(377855,10496,'de','Draw-ID wurde nicht festgelegt.',0),(377856,10496,'en','Draw ID Not Set',0),(377857,10497,'is','',0),(377858,10497,'dr','ÙØ±Ø³ØªØ§Ø¯Ù†  Ø¨Ù‡ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø§ÙƒØ³Ù„ ',0),(377859,10497,'pr','ÙØ±Ø³ØªØ§Ø¯Ù†  Ø¨Ù‡ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø§ÙƒØ³Ù„ ',0),(377860,10497,'tr','Excel\'e ver',0),(377861,10497,'pl','Eksportuj do programu Excel',0),(377862,10497,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð² Excel',0),(377863,10497,'ur','Ø§ÛŒÚ©Ø³Ù„ Ú©Û’ Ù„Ø¦Û’ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(377864,10497,'sr','Ð˜Ð·Ð²Ð¾Ð· Ñƒ Ð•xÑ†ÐµÐ»',0),(377865,10497,'vi','káº¿t xuáº¥t ra excel',0),(377866,10497,'af','Uitvoer na Excel',0),(377867,10497,'ro','Export Ã®n Excel',0),(377868,10497,'et','Ekspordi Exceli',0),(377869,10497,'si','Izvoz v Excel',0),(377870,10497,'ba','Ekspor ke Excel',0),(377871,10497,'nl','Exporteren naar Excel',0),(377872,10497,'fi','Vieminen Exceliin',0),(377873,10497,'no','Eksporter til Excel',0),(377874,10497,'da','Eksportere til Excel',0),(377875,10497,'ko','Excelë¡œ ë‚´ë³´ë‚´ê¸°',0),(377876,10497,'he','×™×¦× ×œ××§×¡×œ',0),(377877,10497,'el','Î•Î¾Î±Î³Ï‰Î³Î® ÏƒÎµ Excel',0),(377878,10497,'zh','å¯¼å‡ºåˆ°Excel\r\n',0),(377879,10497,'sv','Exportera till Excel',0),(377880,10497,'it','Esportare in Excel',0),(377881,10497,'tl','',0),(377882,10497,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¹„à¸›à¸¢à¸±à¸‡ Excel',0),(377883,10497,'hi','Excel à¤•à¥‹ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(377884,10497,'ms','Eksport ke Excel',0),(377885,10497,'ar','Ø§Ù„ØªØµØ¯ÙŠØ± Ø¥Ù„Ù‰ Excel',0),(377886,10497,'fr','Exporter vers Excel',0),(377887,10497,'jp','Excel ã«ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã™ã‚‹ã«ã¯',0),(377888,10497,'pt','Exportar para o Excel',0),(377889,10497,'ru','Ð­ÑÐ¿Ð¾Ñ€Ñ‚ Ð² Excel',0),(377890,10497,'es','Exportar al Excel',0),(377891,10497,'de','Nach Excel exportieren',0),(377892,10497,'en','Export to Excel',0),(377893,10498,'is','',0),(377894,10498,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(377895,10498,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(377896,10498,'tr','MÃ¼ÅŸteri seÃ§melisiniz',0),(377897,10498,'pl','NaleÅ¼y wybraÄ‡ klienta',0),(377898,10498,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(377899,10498,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ú¯Ø§ÛÚ© Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(377900,10498,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(377901,10498,'vi','Báº¡n pháº£i chá»n 1 khÃ¡ch hÃ ng',0),(377902,10498,'af','U moet \'n Klant Kies',0),(377903,10498,'ro','Trebuie sa selectati un client',0),(377904,10498,'et','Te peate valima kliendi',0),(377905,10498,'si','Izbrati morate stranko',0),(377906,10498,'ba','Anda harus memilih pelanggan',0),(377907,10498,'nl','U moet Selecteer een klant',0),(377908,10498,'fi','Asiakas tÃ¤ytyy valita',0),(377909,10498,'no','Du mÃ¥ velge en kunde',0),(377910,10498,'da','Du skal vÃ¦lge en debitor',0),(377911,10498,'ko','ê³ ê°ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(377912,10498,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×œ×§×•×—',0),(377913,10498,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î±Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(377914,10498,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªå®¢æˆ·\r\n',0),(377915,10498,'sv','Du mÃ¥ste vÃ¤lja en kund',0),(377916,10498,'it','Ãˆ necessario selezionare un cliente',0),(377917,10498,'tl','',0),(377918,10498,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(377919,10498,'hi','à¤†à¤ª à¤•à¤¿à¤¸à¥€ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(377920,10498,'ms','Anda mesti memilih pelanggan',0),(377921,10498,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ®ØªØ§Ø± Ø²Ø¨ÙˆÙ†',0),(377922,10498,'fr','Vous devez sÃ©lectionner un client',0),(377923,10498,'jp','é¡§å®¢ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(377924,10498,'pt','VocÃª deve selecionar um cliente',0),(377925,10498,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(377926,10498,'es','Debe Seleccionar un Cliente',0),(377927,10498,'de','Sie mÃ¼ssen einen Kunden auswÃ¤hlen.',0),(377928,10498,'en','You Must Select a Customer',0),(377929,10499,'is','',0),(377930,10499,'dr','/Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù†Ø§Ø­ÙŠÙ‡',0),(377931,10499,'pr','Ø§ÙØ²ÙˆØ¯Ù† /Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ø§Ø­ÙŠÙ‡',0),(377932,10499,'tr','Alan Ekle/GÃ¼ncelle',0),(377933,10499,'pl','Obszar Dodaj/Aktualizuj',0),(377934,10499,'bg','ÐŸÐ»Ð¾Ñ‰ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(377935,10499,'ur','Ø¹Ù„Ø§Ù‚Û Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(377936,10499,'sr','ÐžÐ±Ð»Ð°ÑÑ‚/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(377937,10499,'vi','Khu vá»±c ThÃªm/Cáº­p Nháº­t',0),(377938,10499,'af','Area Byvoeg/Opdateer',0),(377939,10499,'ro','Zona AdÄƒugaÅ£i/actualizaÅ£i',0),(377940,10499,'et','Piirkond Lisa/Uuenda',0),(377941,10499,'si','ObmoÄje Dodaj/posodobi',0),(377942,10499,'ba','Daerah Tambahkan/Perbarui',0),(377943,10499,'nl','Gebied toevoegen/bijwerken',0),(377944,10499,'fi','Alueella lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(377945,10499,'no','OmrÃ¥det Legg til/Oppdater',0),(377946,10499,'da','OmrÃ¥det TilfÃ¸j/opdater',0),(377947,10499,'ko','ì˜ì—­ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(377948,10499,'he','××–×•×¨ ×”×•×¡×¤×”/×¢×“×›×•×Ÿ',0),(377949,10499,'el','Î ÎµÏÎ¹Î¿Ï‡Î® Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(377950,10499,'zh','åŒºæ–°å¢ž/æ›´æ–°\r\n',0),(377951,10499,'sv','OmrÃ¥det LÃ¤gg till/uppdatera',0),(377952,10499,'it','Zona aggiungere/aggiornare',0),(377953,10499,'tl','',0),(377954,10499,'th','à¸•à¸±à¹‰à¸‡à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(377955,10499,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(377956,10499,'ms','Kawasan Tambah/Kemaskini',0),(377957,10499,'ar','ØªØ­Ø¯ÙŠØ«/ÙÙŠ Ù…Ù†Ø·Ù‚Ø©',0),(377958,10499,'fr','Zone Ajouter/mettre Ã  jour',0),(377959,10499,'jp','ã‚¨ãƒªã‚¢ã‚’è¿½åŠ /æ›´æ–°',0),(377960,10499,'pt','Ãrea adicionar/atualizar',0),(377961,10499,'ru','ÐŸÐ»Ð¾Ñ‰Ð°Ð´ÑŒ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(377962,10499,'es','Area Agregar/Actualizar',0),(377963,10499,'de','Bereich hinzufÃ¼gen/aktualisieren',0),(377964,10499,'en','Area Add/Update',0),(377965,10500,'is','',0),(377966,10500,'dr','/Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(377967,10500,'pr','Ø§ÙØ²ÙˆØ¯Ù† /Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(377968,10500,'tr','Bina ekleyin/gÃ¼ncelleyin',0),(377969,10500,'pl','Budynku Dodaj/Aktualizuj',0),(377970,10500,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(377971,10500,'ur','Ø¹Ù…Ø§Ø±Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(377972,10500,'sr','Ð—Ð³Ñ€Ð°Ð´Ð°/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(377973,10500,'vi','XÃ¢y dá»±ng thÃªm/Cáº­p Nháº­t',0),(377974,10500,'af','Gebou Byvoeg/Opdateer',0),(377975,10500,'ro','Adauga clÄƒdire/Update',0),(377976,10500,'et','Hoone lisamine/uuendamine',0),(377977,10500,'si','Stavbe Dodaj/posodobi',0),(377978,10500,'ba','Bangunan Tambahkan/Perbarui',0),(377979,10500,'nl','Gebouw toevoegen/bijwerken',0),(377980,10500,'fi','Rakennuksen lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(377981,10500,'no','Bygningen/Oppdater',0),(377982,10500,'da','Bygning TilfÃ¸j/opdater',0),(377983,10500,'ko','ê±´ë¬¼ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(377984,10500,'he','×‘× ×™×™×Ÿ ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(377985,10500,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(377986,10500,'zh','å¤§æ¥¼æ–°å¢ž/æ›´æ–°\r\n',0),(377987,10500,'sv','Byggnad LÃ¤gg till/uppdatera',0),(377988,10500,'it','Aggiungere/aggiornare un edificio',0),(377989,10500,'tl','',0),(377990,10500,'th','à¸­à¸²à¸„à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(377991,10500,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(377992,10500,'ms','Bangunan Tambah/Kemaskini',0),(377993,10500,'ar','ØªØ­Ø¯ÙŠØ«/Ø¹Ù„Ù‰ Ø¨Ù†Ø§Ø¡',0),(377994,10500,'fr','BÃ¢timent ajouter/mettre Ã  jour',0),(377995,10500,'jp','å»ºç‰©ã‚’è¿½åŠ /æ›´æ–°',0),(377996,10500,'pt','EdifÃ­cio adicionar/atualizar',0),(377997,10500,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(377998,10500,'es','Edificios Agregar/Actualizar',0),(377999,10500,'de','GebÃ¤ude hinzufÃ¼gen/aktualisieren',0),(378000,10500,'en','Building Add/Update',0),(378001,10501,'is','',0),(378002,10501,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(378003,10501,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù†ÙˆØ¹ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(378004,10501,'tr','Bina tÃ¼rÃ¼ Ekle/GÃ¼ncelle',0),(378005,10501,'pl','Typ budynku Dodaj/Aktualizuj',0),(378006,10501,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ñ‚Ð¸Ð¿ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(378007,10501,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(378008,10501,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ñ‚Ð¸Ð¿Ð° Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(378009,10501,'vi','XÃ¢y dá»±ng loáº¡i ThÃªm/Cáº­p Nháº­t',0),(378010,10501,'af','Gebou tipe voeg/opdatering',0),(378011,10501,'ro','ClÄƒdire tip AdÄƒugaÅ£i/actualizaÅ£i',0),(378012,10501,'et','Hoone tÃ¼Ã¼p lisamine/uuendamine',0),(378013,10501,'si','Building tip Dodaj/posodobi',0),(378014,10501,'ba','Bangunan jenis Tambahkan/Perbarui',0),(378015,10501,'nl','Gebouw Type toevoegen/bijwerken',0),(378016,10501,'fi','Rakennuksen tyyppi lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(378017,10501,'no','Bygningen Type Legg til/Oppdater',0),(378018,10501,'da','Bygningen Type TilfÃ¸j/opdater',0),(378019,10501,'ko','ê±´ë¬¼ ìœ í˜• ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(378020,10501,'he','×¡×•×’ ×©×œ ×”×‘× ×™×™×Ÿ ×œ×”×•×¡×™×£/×¢×“×›×•×Ÿ',0),(378021,10501,'el','Î¤ÏÏ€Î¿Ï‚ ÎºÏ„Î¹ÏÎ¯Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(378022,10501,'zh','å»ºç­‘ç±»åž‹æ–°å¢ž/æ›´æ–°\r\n',0),(378023,10501,'sv','Byggnad typ LÃ¤gg till/uppdatera',0),(378024,10501,'it','Edificio tipo aggiungere/aggiornare',0),(378025,10501,'tl','',0),(378026,10501,'th','à¸­à¸²à¸„à¸²à¸£à¸Šà¸™à¸´à¸”à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(378027,10501,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(378028,10501,'ms','Bangunan jenis Tambah/Kemaskini',0),(378029,10501,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(378030,10501,'fr','BÃ¢timent Type ajouter/mettre Ã  jour',0),(378031,10501,'jp','å»ºç‰©ã®ç¨®é¡žã‚’è¿½åŠ /æ›´æ–°',0),(378032,10501,'pt','Tipo de edifÃ­cio adicionar/atualizar',0),(378033,10501,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(378034,10501,'es','Tipo de Edificio Agregar/Actualizar',0),(378035,10501,'de','GebÃ¤ude Typ hinzufÃ¼gen/aktualisieren',0),(378036,10501,'en','Building Type Add/Update',0),(378037,10502,'is','',0),(378038,10502,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† Ù‚Ø±Ø¹Ù‡ Ú©Ø´Ù‰',0),(378039,10502,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù‚Ø±Ø¹Ù‡ Ú©Ø´Ù‰',0),(378040,10502,'tr','Beraberlik ekleyin/gÃ¼ncelleyin',0),(378041,10502,'pl','Narysuj dodaÄ‡ aktualizacji',0),(378042,10502,'bg','ÐÐ°Ñ‡ÐµÑ€Ñ‚Ð°Ð¹Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(378043,10502,'ur','ÚˆØ±Ø§ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(378044,10502,'sr','ÐÐ°Ñ†Ñ€Ñ‚Ð°Ñ˜/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(378045,10502,'vi','Váº½ ThÃªm/Cáº­p Nháº­t',0),(378046,10502,'af','Teken voeg/opdatering',0),(378047,10502,'ro','Trage AdÄƒugaÅ£i/actualizaÅ£i',0),(378048,10502,'et','Joonista lisamine/uuendamine',0),(378049,10502,'si','Pripravi Dodaj/posodobi',0),(378050,10502,'ba','Menggambar menambahkan Update',0),(378051,10502,'nl','Draw toevoegen/bijwerken',0),(378052,10502,'fi','PiirrÃ¤ lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(378053,10502,'no','Tegn/Oppdater',0),(378054,10502,'da','TrÃ¦kke TilfÃ¸j/opdater',0),(378055,10502,'ko','ê·¸ë¦¬ê¸° ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(378056,10502,'he','×”×•×¡×£/×¢×“×›×Ÿ ×œ×¦×™×™×¨',0),(378057,10502,'el','Î™ÏƒÎ¿Ï€Î±Î»Î¯Î±-Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(378058,10502,'zh','ç»˜åˆ¶æ–°å¢ž/æ›´æ–°\r\n',0),(378059,10502,'sv','Rita LÃ¤gg till/uppdatera',0),(378060,10502,'it','Disegnare aggiungere/aggiornare',0),(378061,10502,'tl','',0),(378062,10502,'th','à¸§à¸²à¸”à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(378063,10502,'hi','à¤¡à¥à¤°à¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(378064,10502,'ms','Menarik Tambah/Kemaskini',0),(378065,10502,'ar','Ø±Ø³Ù… Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(378066,10502,'fr','Tirage ajouter/mettre Ã  jour',0),(378067,10502,'jp','æç”»ã‚’è¿½åŠ /æ›´æ–°',0),(378068,10502,'pt','Desenhar adicionar/atualizar',0),(378069,10502,'ru','ÐÐ°Ñ€Ð¸ÑÑƒÐ¹Ñ‚Ðµ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(378070,10502,'es','Retira del Dinero Agregar/Actualizar',0),(378071,10502,'de','Zeichnen hinzufÃ¼gen/aktualisieren',0),(378072,10502,'en','Draw Add/Update',0),(378073,10503,'is','',0),(378074,10503,'dr','Ø§Ø¨Ø²Ø§Ø± Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ  Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(378075,10503,'pr','Ø§Ø¨Ø²Ø§Ø± Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ  Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(378076,10503,'tr','Kira uygulama anket aracÄ±',0),(378077,10503,'pl','DzierÅ¼awa aplikacji badaÅ„ narzÄ™dzie',0),(378078,10503,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚',0),(378079,10503,'ur','Ù„ÛŒØ² Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù† Ø³Ø±ÙˆÛ’ Ù¹ÙˆÙ„',0),(378080,10503,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð°Ð»Ð°Ñ‚',0),(378081,10503,'vi','Cho thuÃª á»©ng dá»¥ng kháº£o sÃ¡t cÃ´ng cá»¥',0),(378082,10503,'af','Huurkontrak Aansoek Opname Instrument',0),(378083,10503,'ro','Leasing aplicarea sondajului instrument',0),(378084,10503,'et','Liisingu taotlus uuring vahend',0),(378085,10503,'si','Najem uporabe raziskava orodje',0),(378086,10503,'ba','Sewa aplikasi survei',0),(378087,10503,'nl','Lease toepassing Survey Tool',0),(378088,10503,'fi','Vuokra Application kyselytyÃ¶kalu',0),(378089,10503,'no','Lease program undersÃ¸kelsesverktÃ¸y',0),(378090,10503,'da','Leasing ansÃ¸gning spÃ¸rgeskemavÃ¦rktÃ¸j',0),(378091,10503,'ko','ìž„ëŒ€ ì‘ìš© í”„ë¡œê·¸ëž¨ ì„¤ë¬¸ ì¡°ì‚¬ ë„êµ¬',0),(378092,10503,'he','×©×›×™×¨×•×ª ×™×™×©×•× ×¡×§×¨ ×›×œ×™',0),(378093,10503,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ Î­ÏÎµÏ…Î½Î±Ï‚ ÎµÏ†Î±ÏÎ¼Î¿Î³Î®Ï‚',0),(378094,10503,'zh','ç§Ÿèµè°ƒæŸ¥å·¥å…·çš„åº”ç”¨\r\n',0),(378095,10503,'sv','Lease programmet enkÃ¤tverktyg',0),(378096,10503,'it','Locazione applicazione strumento di indagine',0),(378097,10503,'tl','',0),(378098,10503,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¸ªà¸³à¸£à¸§à¸ˆà¹‚à¸›à¸£à¹à¸à¸£à¸¡à¹€à¸Šà¹ˆà¸²',0),(378099,10503,'hi','à¤²à¥€à¤œ à¤†à¤µà¥‡à¤¦à¤¨ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤‰à¤ªà¤•à¤°à¤£',0),(378100,10503,'ms','Alat Ukur permohonan pajakan',0),(378101,10503,'ar','Ø¥ÙŠØ¬Ø§Ø± ØªØ·Ø¨ÙŠÙ‚ Ø£Ø¯Ø§Ø© Ø§Ù„Ù…Ø³Ø­',0),(378102,10503,'fr','Bail Application outil de sondage',0),(378103,10503,'jp','ãƒªãƒ¼ã‚¹ ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³èª¿æŸ»ãƒ„ãƒ¼ãƒ«',0),(378104,10503,'pt','Ferramenta de pesquisa de aplicaÃ§Ã£o de locaÃ§Ã£o',0),(378105,10503,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¹ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚',0),(378106,10503,'es','Herramienta InspecciÃ³n de Solicitud de Arrendamiento',0),(378107,10503,'de','Leasing-Anwendung-Umfrage-Tool',0),(378108,10503,'en','Lease Application Survey Tool',0),(378109,10504,'is','',0),(378110,10504,'dr','Ø§Ø¨Ø²Ø§Ø± Ù…Ø¯ÙŠØ±ÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(378111,10504,'pr','Ø§Ø¨Ø²Ø§Ø± Ù…Ø¯ÙŠØ±ÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(378112,10504,'tr','Ã–zellik YÃ¶netim AraÃ§larÄ±',0),(378113,10504,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ narzÄ™dzia zarzÄ…dzania',0),(378114,10504,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚Ð¸',0),(378115,10504,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ Ù¹ÙˆÙ„Ø²',0),(378116,10504,'sr','ÐÐ»Ð°Ñ‚ÐºÐµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ðµ',0),(378117,10504,'vi','CÃ´ng cá»¥ quáº£n lÃ½ tÃ i sáº£n',0),(378118,10504,'af','Eiendom bestuur hulpmiddels',0),(378119,10504,'ro','Instrumente de Management de proprietate',0),(378120,10504,'et','Kinnisvara haldamise tÃ¶Ã¶riistad',0),(378121,10504,'si','Orodja za upravljanje premoÅ¾enja',0),(378122,10504,'ba','Alat manajemen properti',0),(378123,10504,'nl','Eigenschap managementtools',0),(378124,10504,'fi','Omaisuuden hallinnan tyÃ¶kalut',0),(378125,10504,'no','Egenskapen verktÃ¸y',0),(378126,10504,'da','Property Management vÃ¦rktÃ¸jer',0),(378127,10504,'ko','ì†ì„± ê´€ë¦¬ ë„êµ¬',0),(378128,10504,'he','×›×œ×™ × ×™×”×•×œ ×¨×›×•×©',0),(378129,10504,'el','Î•ÏÎ³Î±Î»ÎµÎ¯Î± Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚ Î±ÎºÎ¹Î½Î®Ï„Ï‰Î½',0),(378130,10504,'zh','ç‰©ä¸šç®¡ç†å·¥å…·\r\n',0),(378131,10504,'sv','Egenskapen hanteringsverktyg',0),(378132,10504,'it','Strumenti di gestione di proprietÃ .',0),(378133,10504,'tl','',0),(378134,10504,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(378135,10504,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤‰à¤ªà¤•à¤°à¤£',0),(378136,10504,'ms','Alat pengurusan harta',0),(378137,10504,'ar','Ø£Ø¯ÙˆØ§Øª Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(378138,10504,'fr','Outils de gestion de propriÃ©tÃ©',0),(378139,10504,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ç®¡ç†ãƒ„ãƒ¼ãƒ«',0),(378140,10504,'pt','Ferramentas de gerenciamento de propriedade.',0),(378141,10504,'ru','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ñ‹ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(378142,10504,'es','Herramientas de GestiÃ³n de Propiedad',0),(378143,10504,'de','Eigenschaft Management-Tools',0),(378144,10504,'en','Property Management Tools',0),(378145,10505,'is','',0),(378146,10505,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ÙˆØ§Ø­Ø¯',0),(378147,10505,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙˆØ§Ø­Ø¯',0),(378148,10505,'tr','Birim Ekle/GÃ¼ncelle',0),(378149,10505,'pl','Jednostka Dodaj/Aktualizuj',0),(378150,10505,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(378151,10505,'ur','ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(378152,10505,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(378153,10505,'vi','ÄÆ¡n vá»‹ ThÃªm/Cáº­p Nháº­t',0),(378154,10505,'af','Eenheid Byvoeg/Opdateer',0),(378155,10505,'ro','Unitate AdÄƒugaÅ£i/actualizaÅ£i',0),(378156,10505,'et','Ãœksuse lisamine/uuendamine',0),(378157,10505,'si','Enota Dodaj/posodobi',0),(378158,10505,'ba','Unit Tambahkan/Perbarui',0),(378159,10505,'nl','Eenheid toevoegen/bijwerken',0),(378160,10505,'fi','YksikkÃ¶ lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(378161,10505,'no','Enhet/Oppdater',0),(378162,10505,'da','Enhed TilfÃ¸j/opdater',0),(378163,10505,'ko','ìž¥ì¹˜ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(378164,10505,'he','×™×—×™×“×ª ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(378165,10505,'el','ÎœÎ¿Î½Î¬Î´Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(378166,10505,'zh','å•ä½åœ°å€/æ›´æ–°\r\n',0),(378167,10505,'sv','LÃ¤gg till enhet/uppdatera',0),(378168,10505,'it','UnitÃ  aggiungere/aggiornare',0),(378169,10505,'tl','',0),(378170,10505,'th','à¸«à¸™à¹ˆà¸§à¸¢à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(378171,10505,'hi','à¤‡à¤•à¤¾à¤ˆ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(378172,10505,'ms','Unit Tambah/Kemaskini',0),(378173,10505,'ar','ÙˆØ­Ø¯Ø© Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(378174,10505,'fr','UnitÃ© ajouter/mettre Ã  jour',0),(378175,10505,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã‚’è¿½åŠ /æ›´æ–°',0),(378176,10505,'pt','Unidade adicionar/atualizar',0),(378177,10505,'ru','Ð‘Ð»Ð¾Ðº Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(378178,10505,'es','Unidad Actualizar/Actualizar',0),(378179,10505,'de','Einheit hinzufÃ¼gen/aktualisieren',0),(378180,10505,'en','Unit Add/Update',0),(378181,10506,'is','',0),(378182,10506,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(378183,10506,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(378184,10506,'tr','Ek YardÄ±m',0),(378185,10506,'pl','DodatkowÄ… pomoc',0),(378186,10506,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(378187,10506,'ur','Ø§Ø¶Ø§ÙÛŒ Ù…Ø¯Ø¯',0),(378188,10506,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ñƒ Ð¿Ð¾Ð¼Ð¾Ñ›',0),(378189,10506,'vi','Trá»£ giÃºp bá»• sung',0),(378190,10506,'af','Addisionele Hulp',0),(378191,10506,'ro','Ajutor suplimentar',0),(378192,10506,'et','TÃ¤iendav spikker',0),(378193,10506,'si','Dodatno pomoÄ',0),(378194,10506,'ba','Bantuan tambahan',0),(378195,10506,'nl','Extra hulp',0),(378196,10506,'fi','LisÃ¤ohjeita',0),(378197,10506,'no','Ytterligere hjelp',0),(378198,10506,'da','Yderligere hjÃ¦lp',0),(378199,10506,'ko','ì¶”ê°€ ë„ì›€ë§',0),(378200,10506,'he','×¢×–×¨×” × ×•×¡×¤×ª',0),(378201,10506,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î· Î²Î¿Î®Î¸ÎµÎ¹Î±',0),(378202,10506,'zh','æ›´å¤šå¸®åŠ©\r\n',0),(378203,10506,'sv','Ytterligare hjÃ¤lp',0),(378204,10506,'it','Aiuto aggiuntivo',0),(378205,10506,'tl','',0),(378206,10506,'th','à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(378207,10506,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤®à¤¦à¤¦',0),(378208,10506,'ms','Bantuan tambahan',0),(378209,10506,'ar','Ù…Ø³Ø§Ø¹Ø¯Ø© Ø¥Ø¶Ø§ÙÙŠØ©',0),(378210,10506,'fr','Aide additionnelle',0),(378211,10506,'jp','è¿½åŠ ã®ãƒ˜ãƒ«ãƒ—',0),(378212,10506,'pt','Ajuda adicional',0),(378213,10506,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ',0),(378214,10506,'es','Ayuda Adicional',0),(378215,10506,'de','ZusÃ¤tzliche Hilfe',0),(378216,10506,'en','Additional Help',0),(378217,10507,'is','',0),(378218,10507,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø±Ø§Ù‡Ù†Ù…Ø§ ',0),(378219,10507,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø±Ø§Ù‡Ù†Ù…Ø§ ',0),(378220,10507,'tr','YardÄ±m DÃ¼zenle',0),(378221,10507,'pl','EdytowaÄ‡ Pomoc',0),(378222,10507,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(378223,10507,'ur','Ù…Ø¯Ø¯ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(378224,10507,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾Ð¼Ð¾Ñ›',0),(378225,10507,'vi','Chá»‰nh sá»­a trá»£ giÃºp',0),(378226,10507,'af','Redigeer Hulp',0),(378227,10507,'ro','Editare ajutor',0),(378228,10507,'et','Redigeeri spikker',0),(378229,10507,'si','Urejanje pomoÄ',0),(378230,10507,'ba','Mengedit bantuan',0),(378231,10507,'nl','Bewerken van Help',0),(378232,10507,'fi','Muokkaamisen ohje',0),(378233,10507,'no','Redigere hjelp',0),(378234,10507,'da','Redigere hjÃ¦lp',0),(378235,10507,'ko','ìˆ˜ì • ë„ì›€ë§',0),(378236,10507,'he','×¢×¨×•×š ×¢×–×¨×”',0),(378237,10507,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î²Î¿Î·Î¸Î®ÏƒÎµÎ¹',0),(378238,10507,'zh','ç¼–è¾‘è¯´æ˜Ž\r\n',0),(378239,10507,'sv','Redigera hjÃ¤lp',0),(378240,10507,'it','Modifica aiuto',0),(378241,10507,'tl','',0),(378242,10507,'th','à¹à¸à¹‰à¹„à¸‚à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰',0),(378243,10507,'hi','à¤®à¤¦à¤¦ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(378244,10507,'ms','Edit bantuan',0),(378245,10507,'ar','ØªØ­Ø±ÙŠØ± ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(378246,10507,'fr','Edit Help',0),(378247,10507,'jp','ç·¨é›†ãƒ˜ãƒ«ãƒ—',0),(378248,10507,'pt','Editar ajuda',0),(378249,10507,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ',0),(378250,10507,'es','Editar Ayuda',0),(378251,10507,'de','Hilfe zu bearbeiten',0),(378252,10507,'en','Edit Help',0),(378253,10508,'is','',0),(378254,10508,'dr','ØªÙ‚ÙˆÙŠÙ…',0),(378255,10508,'pr','ØªÙ‚ÙˆÙŠÙ…',0),(378256,10508,'tr','Takvim',0),(378257,10508,'pl','Kalendarz',0),(378258,10508,'bg','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€',0),(378259,10508,'ur','Ú©ÛŒÙ„Ù†ÚˆØ±',0),(378260,10508,'sr','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€',0),(378261,10508,'vi','Lá»‹ch',0),(378262,10508,'af','Kalender',0),(378263,10508,'ro','Calendar',0),(378264,10508,'et','Kalender',0),(378265,10508,'si','Koledar',0),(378266,10508,'ba','Kalender',0),(378267,10508,'nl','Kalender',0),(378268,10508,'fi','Kalenteri',0),(378269,10508,'no','Kalender',0),(378270,10508,'da','Kalender',0),(378271,10508,'ko','ë‹¬ë ¥',0),(378272,10508,'he','×œ×•×— ×©× ×”',0),(378273,10508,'el','Î—Î¼ÎµÏÎ¿Î»ÏŒÎ³Î¹Î¿',0),(378274,10508,'zh','æ—¥åŽ†\r\n',0),(378275,10508,'sv','Kalender',0),(378276,10508,'it','Calendario',0),(378277,10508,'tl','',0),(378278,10508,'th','à¸›à¸à¸´à¸—à¸´à¸™',0),(378279,10508,'hi','à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤°',0),(378280,10508,'ms','Kalendar',0),(378281,10508,'ar','Ø§Ù„ØªÙ‚ÙˆÙŠÙ…',0),(378282,10508,'fr','Calendrier',0),(378283,10508,'jp','ã‚«ãƒ¬ãƒ³ãƒ€ãƒ¼',0),(378284,10508,'pt','CalendÃ¡rio',0),(378285,10508,'ru','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ÑŒ',0),(378286,10508,'es','Calendario',0),(378287,10508,'de','Kalender',0),(378288,10508,'en','Calendar',0),(378289,10509,'is','',0),(378290,10509,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„',0),(378291,10509,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„',0),(378292,10509,'tr','Takvim olay ekle',0),(378293,10509,'pl','Dodaj wydarzenie kalendarza',0),(378294,10509,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÑŠÐ±Ð¸Ñ‚Ð¸Ðµ Ð² ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð°',0),(378295,10509,'ur','Ú©ÛŒÙ„Ù†ÚˆØ± Ø§ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(378296,10509,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð°',0),(378297,10509,'vi','ThÃªm lá»‹ch sá»± kiá»‡n',0),(378298,10509,'af','Kalender Gebeurtenis Byvoeg',0),(378299,10509,'ro','Adauga Calendar evenimente',0),(378300,10509,'et','Lisa kalender sÃ¼ndmus',0),(378301,10509,'si','Dodaj koledar dogodkov',0),(378302,10509,'ba','Tambahkan kalender acara',0),(378303,10509,'nl','Gebeurtenis van de kalender toevoegen',0),(378304,10509,'fi','LisÃ¤Ã¤ kalenteritapahtuman',0),(378305,10509,'no','Legge til kalenderhendelser',0),(378306,10509,'da','TilfÃ¸je kalenderbegivenhed',0),(378307,10509,'ko','ìº˜ë¦°ë” ì´ë²¤íŠ¸ ì¶”ê°€',0),(378308,10509,'he','×”×•×¡×£ ××¨×•×¢ ×™×•×ž×Ÿ',0),(378309,10509,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î·Î¼ÎµÏÎ¿Î»ÏŒÎ³Î¹Î¿ ÏƒÏ…Î¼Î²Î¬Î½Ï„Ï‰Î½',0),(378310,10509,'zh','å¢žåŠ æ—¥åŽ†äº‹ä»¶\r\n',0),(378311,10509,'sv','LÃ¤gga till kalenderhÃ¤ndelse',0),(378312,10509,'it','Aggiungere il calendario eventi',0),(378313,10509,'tl','',0),(378314,10509,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸›à¸à¸´à¸—à¸´à¸™à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸“à¹Œ',0),(378315,10509,'hi','à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤° à¤ˆà¤µà¥‡à¤‚à¤Ÿ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(378316,10509,'ms','Tambah peristiwa kalendar',0),(378317,10509,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø¯Ø« Ø§Ù„ØªÙ‚ÙˆÙŠÙ…',0),(378318,10509,'fr','Ajouter le calendrier des Ã©vÃ©nements',0),(378319,10509,'jp','ã‚«ãƒ¬ãƒ³ãƒ€ãƒ¼ ã‚¤ãƒ™ãƒ³ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(378320,10509,'pt','Adicionar evento do calendÃ¡rio',0),(378321,10509,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ðµ Ð’ ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ÑŒ',0),(378322,10509,'es','Agregar Evento Calendario',0),(378323,10509,'de','Kalender-Termin hinzufÃ¼gen',0),(378324,10509,'en','Add Calendar Event',0),(378325,10510,'is','',0),(378326,10510,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡ ØªÙ‚ÙˆÙŠÙ… ',0),(378327,10510,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡ ØªÙ‚ÙˆÙŠÙ… ',0),(378328,10510,'tr','Takvimlerine ekleme',0),(378329,10510,'pl','DodaÄ‡ do kalendarzy',0),(378330,10510,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ ÐºÑŠÐ¼ ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð¸',0),(378331,10510,'ur','Ú©ÛŒÙ„Ù†ÚˆØ± Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(378332,10510,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð°',0),(378333,10510,'vi','ThÃªm lá»‹ch ',0),(378334,10510,'af','Byvoeging tot Kalender',0),(378335,10510,'ro','Adauga la calendare',0),(378336,10510,'et','Lisada kalendreid',0),(378337,10510,'si','Dodajte koledarje',0),(378338,10510,'ba','Tambahkan ke kalender',0),(378339,10510,'nl','Toevoegen aan agenda',0),(378340,10510,'fi','LisÃ¤Ã¤ kalentereita',0),(378341,10510,'no','Legge til kalendere',0),(378342,10510,'da','TilfÃ¸je til kalendere',0),(378343,10510,'ko','ìº˜ë¦°ë”ì— ì¶”ê°€',0),(378344,10510,'he','×”×•×¡×£ ×œ×™×•×ž× ×™×',0),(378345,10510,'el','Î‘Ï…Î¾Î¬Î½Ï‰ Î·Î¼ÎµÏÎ¿Î»ÏŒÎ³Î¹Î±',0),(378346,10510,'zh','å¢žåŠ åˆ°æ—¥åŽ†\r\n',0),(378347,10510,'sv','LÃ¤gga till kalendrar',0),(378348,10510,'it','Aggiungere ai calendari',0),(378349,10510,'tl','',0),(378350,10510,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸›à¸à¸´à¸—à¸´à¸™',0),(378351,10510,'hi','à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(378352,10510,'ms','Tambah kalendar',0),(378353,10510,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø§Ù„ØªÙ‚ÙˆÙŠÙ…Ø§Øª',0),(378354,10510,'fr','Ajouter aux calendriers',0),(378355,10510,'jp','äºˆå®šè¡¨ã«è¿½åŠ ã—ã¾ã™ã€‚',0),(378356,10510,'pt','Adicionar calendÃ¡rios',0),(378357,10510,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð’ ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ÑŒ',0),(378358,10510,'es','Agregar a Calendarios',0),(378359,10510,'de','Kalender hinzufÃ¼gen',0),(378360,10510,'en','Add to Calendars',0),(378361,10511,'is','',0),(378362,10511,'dr','Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„',0),(378363,10511,'pr','Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„',0),(378364,10511,'tr','Takvim olayÄ±',0),(378365,10511,'pl','Wydarzenia w kalendarzu',0),(378366,10511,'bg','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ Ð½Ð° ÑÑŠÐ±Ð¸Ñ‚Ð¸ÑÑ‚Ð°',0),(378367,10511,'ur','ÙˆØ§Ù‚Ø¹Û Ú©ÛŒÙ„Ù†ÚˆØ±',0),(378368,10511,'sr','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð°',0),(378369,10511,'vi','Lá»‹ch sá»± kiá»‡n',0),(378370,10511,'af','Kalender Aktiwiteit',0),(378371,10511,'ro','Calendar evenimente',0),(378372,10511,'et','Kalendri sÃ¼ndmus',0),(378373,10511,'si','Koledar dogodkov',0),(378374,10511,'ba','Kalender acara',0),(378375,10511,'nl','Gebeurtenis van de kalender',0),(378376,10511,'fi','Kalenteritapahtuman',0),(378377,10511,'no','Kalenderhendelse',0),(378378,10511,'da','Kalenderbegivenhed',0),(378379,10511,'ko','ìº˜ë¦°ë” ì´ë²¤íŠ¸',0),(378380,10511,'he','××™×¨×•×¢×™ ×œ×•×— ×©× ×”',0),(378381,10511,'el','Î ÏÏŒÎ³ÏÎ±Î¼Î¼Î± ÎµÎºÎ´Î·Î»ÏŽÏƒÎµÏ‰Î½',0),(378382,10511,'zh','æ—¥åŽ†äº‹ä»¶\r\n',0),(378383,10511,'sv','KalenderhÃ¤ndelse',0),(378384,10511,'it','Calendario eventi',0),(378385,10511,'tl','',0),(378386,10511,'th','à¸›à¸à¸´à¸—à¸´à¸™à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸“à¹Œ',0),(378387,10511,'hi','à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤° à¤‡à¤µà¥‡à¤‚à¤Ÿ',0),(378388,10511,'ms','Kalendar peristiwa',0),(378389,10511,'ar','ØªÙ‚ÙˆÙŠÙ… Ø§Ù„Ø£Ø­Ø¯Ø§Ø«',0),(378390,10511,'fr','Calendrier des Ã©vÃ©nements',0),(378391,10511,'jp','ã‚«ãƒ¬ãƒ³ãƒ€ãƒ¼ ã‚¤ãƒ™ãƒ³ãƒˆ',0),(378392,10511,'pt','Eventos de calendÃ¡rio',0),(378393,10511,'ru','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð½Ð¾Ðµ Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ðµ',0),(378394,10511,'es','Evento Calendario',0),(378395,10511,'de','Kalender Event',0),(378396,10511,'en','Calendar Event',0),(378397,10512,'is','',0),(378398,10512,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„',0),(378399,10512,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„',0),(378400,10512,'tr','Takvim olay ekleme hatasÄ±',0),(378401,10512,'pl','Wydarzenia w kalendarzu dodaÄ‡ awarii',0),(378402,10512,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÑŠÐ±Ð¸Ñ‚Ð¸Ðµ Ð² ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð° Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(378403,10512,'ur','ÙˆØ§Ù‚Ø¹Û Ú©ÛŒÙ„Ù†ÚˆØ± Ú©ÛŒ Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(378404,10512,'sr','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð° Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(378405,10512,'vi','ThÃªm lá»‹ch sá»± kiá»‡n khÃ´ng thÃ nh',0),(378406,10512,'af','Kalender gebeurtenis voeg versuim',0),(378407,10512,'ro','Calendar evenimente Adauga eÅŸec',0),(378408,10512,'et','Kalendrisse sÃ¼ndmuse lisamine rike',0),(378409,10512,'si','Koledar dogodkov dodajte neuspeh',0),(378410,10512,'ba','Kalender acara menambahkan kegagalan',0),(378411,10512,'nl','Gebeurtenis van de kalender toevoegen mislukking',0),(378412,10512,'fi','Kalenteritapahtuman lisÃ¤Ã¤minen epÃ¤onnistuminen',0),(378413,10512,'no','Kalenderhendelse legge feil',0),(378414,10512,'da','Kalenderbegivenhed tilfÃ¸je fiasko',0),(378415,10512,'ko','ìº˜ë¦°ë” ì´ë²¤íŠ¸ ì¶”ê°€ ì‹¤íŒ¨',0),(378416,10512,'he','××™×¨×•×¢×™ ×œ×•×— ×©× ×” ×œ×”×•×¡×™×£ ×›×©×œ',0),(378417,10512,'el','Î ÏÏŒÎ³ÏÎ±Î¼Î¼Î± ÎµÎºÎ´Î·Î»ÏŽÏƒÎµÏ‰Î½ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(378418,10512,'zh','æ—¥åŽ†äº‹ä»¶æ·»åŠ å¤±è´¥\r\n',0),(378419,10512,'sv','KalenderhÃ¤ndelse lÃ¤gga till misslyckande',0),(378420,10512,'it','Calendario eventi Aggiungi fallimento',0),(378421,10512,'tl','',0),(378422,10512,'th','à¸›à¸à¸´à¸—à¸´à¸™à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸“à¹Œà¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(378423,10512,'hi','à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤° à¤‡à¤µà¥‡à¤‚à¤Ÿ à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(378424,10512,'ms','Kegagalan Tambah peristiwa kalendar',0),(378425,10512,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø¯Ø« ØªÙ‚ÙˆÙŠÙ… ÙØ´Ù„',0),(378426,10512,'fr','Calendrier des Ã©vÃ©nements ajouter Ã©chec',0),(378427,10512,'jp','ã‚«ãƒ¬ãƒ³ãƒ€ãƒ¼ ã‚¤ãƒ™ãƒ³ãƒˆã‚’è¿½åŠ ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(378428,10512,'pt','Evento do calendÃ¡rio Adicionar falha',0),(378429,10512,'ru','ÐÐµ Ð£Ð´Ð°Ð»Ð¾ÑÑŒ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ðµ Ð’ ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ÑŒ',0),(378430,10512,'es','Evento Calendario Agregar FallÃ³',0),(378431,10512,'de','Kalenderereignis hinzufÃ¼gen Fehler',0),(378432,10512,'en','Calendar Event Add Failure',0),(378433,10513,'is','',0),(378434,10513,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(378435,10513,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(378436,10513,'tr','Takvim olayÄ± baÅŸarÄ±yla eklendi',0),(378437,10513,'pl','PomyÅ›lnie dodano zdarzenie kalendarza',0),(378438,10513,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÑŠÐ±Ð¸Ñ‚Ð¸Ðµ Ð² ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð°',0),(378439,10513,'ur','Ú©ÛŒÙ„Ù†ÚˆØ± Ø§ÛŒÙˆÙ†Ù¹ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(378440,10513,'sr','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(378441,10513,'vi','ThÃªm lá»‹ch sá»± kiá»‡n thÃ nh cÃ´ng',0),(378442,10513,'af','Kalender Geleentheid Suksesvol Bygevoeg',0),(378443,10513,'ro','Calendar evenimente adÄƒugat cu succes',0),(378444,10513,'et','Lisatud kalendrisÃ¼ndmuse',0),(378445,10513,'si','Koledar prireditev uspeÅ¡no dodani',0),(378446,10513,'ba','Kalender acara ditambahkan berhasil',0),(378447,10513,'nl','Gebeurtenis van de kalender toegevoegd',0),(378448,10513,'fi','Kalenteritapahtuman lisÃ¤Ã¤minen onnistui',0),(378449,10513,'no','Kalenderhendelse lagt',0),(378450,10513,'da','Kalenderbegivenhed tilfÃ¸jet',0),(378451,10513,'ko','ìº˜ë¦°ë” ì´ë²¤íŠ¸ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(378452,10513,'he','××™×¨×•×¢×™ ×œ×•×— ×©× ×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(378453,10513,'el','Î ÏÏŒÎ³ÏÎ±Î¼Î¼Î± ÎµÎºÎ´Î·Î»ÏŽÏƒÎµÏ‰Î½ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(378454,10513,'zh','æ—¥åŽ†äº‹ä»¶æ·»åŠ æˆåŠŸ\r\n',0),(378455,10513,'sv','KalenderhÃ¤ndelse som lagts',0),(378456,10513,'it','Calendario eventi aggiunto con successo',0),(378457,10513,'tl','',0),(378458,10513,'th','à¸›à¸à¸´à¸—à¸´à¸™à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸“à¹Œà¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(378459,10513,'hi','à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤° à¤‡à¤µà¥‡à¤‚à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(378460,10513,'ms','Kalendar Peristiwa berjaya menambah',0),(378461,10513,'ar','ØªÙ‚ÙˆÙŠÙ… Ø§Ù„Ø£Ø­Ø¯Ø§Ø« Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(378462,10513,'fr','Calendrier des Ã©vÃ©nements ajoutÃ© avec succÃ¨s',0),(378463,10513,'jp','äºˆå®šè¡¨ã®ã‚¤ãƒ™ãƒ³ãƒˆãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(378464,10513,'pt','Evento do calendÃ¡rio adicionado com sucesso',0),(378465,10513,'ru','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð½Ð¾Ðµ Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ðµ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾',0),(378466,10513,'es','Evento Calendario Agregado Exitosamente',0),(378467,10513,'de','Kalender Event erfolgreich hinzugefÃ¼gt',0),(378468,10513,'en','Calendar Event Added Successfully',0),(378469,10514,'is','',0),(378470,10514,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„',0),(378471,10514,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„',0),(378472,10514,'tr','Takvim olay silme hatasÄ±',0),(378473,10514,'pl','Kalendarz zdarzeÅ„ usuniÄ™cia awarii',0),(378474,10514,'bg','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ ÑÑŠÐ±Ð¸Ñ‚Ð¸Ðµ Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ Ð¾Ñ‚ÐºÐ°Ð·',0),(378475,10514,'ur','Ú©ÛŒÙ„Ù†ÚˆØ± ÙˆØ§Ù‚Ø¹Û Ø­Ø°Ù Ù†Ø§Ú©Ø§Ù…ÛŒ',0),(378476,10514,'sr','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð° Ð±Ñ€Ð¸ÑÐ°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(378477,10514,'vi','XÃ³a lá»‹ch sá»± kiá»‡n khÃ´ng thÃ nh',0),(378478,10514,'af','Kalender gebeurtenis skrap versuim',0),(378479,10514,'ro','Calendar evenimente ÅŸterge eÅŸec',0),(378480,10514,'et','Kalendri sÃ¼ndmuse kustutada rike',0),(378481,10514,'si','Koledar dogodkov brisanje napake',0),(378482,10514,'ba','Kalender acara Hapus kegagalan',0),(378483,10514,'nl','Kalender gebeurtenis verwijderen mislukking',0),(378484,10514,'fi','Kalenterin tapahtuman poistaminen epÃ¤onnistuminen',0),(378485,10514,'no','Kalenderen Event slette feil',0),(378486,10514,'da','Kalender Event slet fiasko',0),(378487,10514,'ko','ì¼ì • ì´ë²¤íŠ¸ ì‚­ì œ ì‹¤íŒ¨',0),(378488,10514,'he','×œ×•×— ×”×©× ×” ×”××™×¨×•×¢ Delete ×›×©×œ',0),(378489,10514,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ ÎµÎºÎ´Î®Î»Ï‰ÏƒÎ· Î·Î¼ÎµÏÎ¿Î»ÏŒÎ³Î¹Î¿',0),(378490,10514,'zh','æ—¥åŽ†äº‹ä»¶å·²åˆ é™¤å¤±è´¥\r\n',0),(378491,10514,'sv','Kalender hÃ¤ndelse ta bort fel',0),(378492,10514,'it','Calendario eventi eliminazione guasto',0),(378493,10514,'tl','',0),(378494,10514,'th','à¸›à¸à¸´à¸—à¸´à¸™à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸“à¹Œà¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(378495,10514,'hi','à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤° à¤‡à¤µà¥‡à¤‚à¤Ÿ à¤¹à¤Ÿà¤¾à¤à¤ à¤µà¤¿à¤«à¤²à¤¤à¤¾',0),(378496,10514,'ms','Kegagalan Hapus peristiwa kalendar',0),(378497,10514,'ar','ÙØ´Ù„ Ø­Ø°Ù Ø­Ø¯Ø« ØªÙ‚ÙˆÙŠÙ…',0),(378498,10514,'fr','Calendrier Ã©vÃ©nement Delete Ã©chec',0),(378499,10514,'jp','ã‚«ãƒ¬ãƒ³ãƒ€ãƒ¼ ã‚¤ãƒ™ãƒ³ãƒˆã®å‰Šé™¤ã®å¤±æ•—',0),(378500,10514,'pt','CalendÃ¡rio evento Delete falha',0),(378501,10514,'ru','ÐÐµ Ð£Ð´Ð°Ð»Ð¾ÑÑŒ Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ðµ Ð˜Ð· ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ñ',0),(378502,10514,'es','Evento Calendario Eliminar FallÃ³',0),(378503,10514,'de','Kalender Event lÃ¶schen Fehler',0),(378504,10514,'en','Calendar Event Delete Failure',0),(378505,10515,'is','',0),(378506,10515,'dr','Ø­Ø°Ù Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(378507,10515,'pr','Ø­Ø°Ù Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(378508,10515,'tr','Takvim olayÄ± baÅŸarÄ±yla silindi',0),(378509,10515,'pl','Wydarzenia w kalendarzu przesâ”‚anie',0),(378510,10515,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÑŠÐ±Ð¸Ñ‚Ð¸Ðµ Ð² ÐºÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð°',0),(378511,10515,'ur','Ú©ÛŒÙ„Ù†ÚˆØ± Ú©Û’ ÙˆØ§Ù‚Ø¹Û Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(378512,10515,'sr','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(378513,10515,'vi','XÃ³a lá»‹ch sá»± kiá»‡n thÃ nh cÃ´ng',0),(378514,10515,'af','Kalender Geleentheid Suksesvol Geskrap',0),(378515,10515,'ro','Calendar evenimente eliminÄƒ cu succes',0),(378516,10515,'et','Edukalt kustutatakse kalendrisÃ¼ndmuse',0),(378517,10515,'si','Koledar prireditev uspeÅ¡no izbrisana',0),(378518,10515,'ba','Kalender acara dihapus berhasil',0),(378519,10515,'nl','Gebeurtenis van de kalender met succes verwijderd',0),(378520,10515,'fi','Kalenteritapahtuman poistettu',0),(378521,10515,'no','Kalenderhendelse slettet',0),(378522,10515,'da','Kalenderbegivenhed slettet',0),(378523,10515,'ko','ìº˜ë¦°ë” ì´ë²¤íŠ¸ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(378524,10515,'he','××™×¨×•×¢×™ ×œ×•×— ×©× ×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(378525,10515,'el','Î ÏÏŒÎ³ÏÎ±Î¼Î¼Î± ÎµÎºÎ´Î·Î»ÏŽÏƒÎµÏ‰Î½ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(378526,10515,'zh','æ—¥åŽ†äº‹ä»¶æˆåŠŸåˆ é™¤\r\n',0),(378527,10515,'sv','KalenderhÃ¤ndelse raderades',0),(378528,10515,'it','Calendario eventi cancellati con successo',0),(378529,10515,'tl','',0),(378530,10515,'th','à¸›à¸à¸´à¸—à¸´à¸™à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸“à¹Œà¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(378531,10515,'hi','à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤° à¤‡à¤µà¥‡à¤‚à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(378532,10515,'ms','Peristiwa kalendar yang dihapuskan dengan jayanya',0),(378533,10515,'ar','ØªÙ‚ÙˆÙŠÙ… Ø§Ù„Ø£Ø­Ø¯Ø§Ø« Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(378534,10515,'fr','Calendrier des Ã©vÃ©nements supprimÃ© avec succÃ¨s',0),(378535,10515,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸã‚«ãƒ¬ãƒ³ãƒ€ãƒ¼ ã‚¤ãƒ™ãƒ³ãƒˆ',0),(378536,10515,'pt','CalendÃ¡rio evento excluÃ­do com sucesso',0),(378537,10515,'ru','Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ðµ Ð˜Ð· ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ñ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½Ð¾',0),(378538,10515,'es','Evento Calendario Eliminado Exitosamente',0),(378539,10515,'de','Kalender Event erfolgreich gelÃ¶scht',0),(378540,10515,'en','Calendar Event Deleted Successfully',0),(378541,10516,'is','',0),(378542,10516,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„',0),(378543,10516,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„',0),(378544,10516,'tr','Takvim olayÄ± gÃ¼ncelleme hatasÄ±',0),(378545,10516,'pl','Wydarzenia w kalendarzu aktualizacja brak',0),(378546,10516,'bg','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ Ð½Ð° ÑÑŠÐ±Ð¸Ñ‚Ð¸ÑÑ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(378547,10516,'ur','ÙˆØ§Ù‚Ø¹Û Ú©ÛŒÙ„Ù†ÚˆØ± Ú©ÛŒ Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(378548,10516,'sr','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð° Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(378549,10516,'vi',' Cáº­p nháº­tlá»‹ch sá»± kiá»‡n khÃ´ng thÃ nh',0),(378550,10516,'af','Kalender gebeurtenis bygewerk versuim',0),(378551,10516,'ro','Calendar evenimente actualizat eÅŸec',0),(378552,10516,'et','Kalender uuendatud rike',0),(378553,10516,'si','Koledar dogodkov posodobljen neuspeh',0),(378554,10516,'ba','Kalender acara diperbarui kegagalan',0),(378555,10516,'nl','Gebeurtenis van de kalender bijgewerkt mislukking',0),(378556,10516,'fi','Kalenteritapahtuman pÃ¤ivitetty epÃ¤onnistuminen',0),(378557,10516,'no','Kalenderhendelse oppdatert feil',0),(378558,10516,'da','Kalenderbegivenhed opdateret fiasko',0),(378559,10516,'ko','ì¼ì • ì´ë²¤íŠ¸ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(378560,10516,'he','××™×¨×•×¢×™ ×œ×•×— ×©× ×” ×ž×¢×•×“×›×Ÿ ×›×©×œ',0),(378561,10516,'el','Î ÏÏŒÎ³ÏÎ±Î¼Î¼Î± ÎµÎºÎ´Î·Î»ÏŽÏƒÎµÏ‰Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(378562,10516,'zh','æ—¥åŽ†äº‹ä»¶æ›´æ–°å¤±è´¥\r\n',0),(378563,10516,'sv','KalenderhÃ¤ndelse uppdaterad misslyckande',0),(378564,10516,'it','Calendario eventi aggiornato il fallimento',0),(378565,10516,'tl','',0),(378566,10516,'th','à¸›à¸à¸´à¸—à¸´à¸™à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸“à¹Œà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(378567,10516,'hi','à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤° à¤‡à¤µà¥‡à¤‚à¤Ÿ à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾',0),(378568,10516,'ms','Kegagalan Kemaskini peristiwa kalendar',0),(378569,10516,'ar','Ø§Ù„Ø­Ø¯Ø« Ø§Ù„ØªÙ‚ÙˆÙŠÙ… ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙØ´Ù„',0),(378570,10516,'fr','Calendrier des Ã©vÃ©nements mis Ã  jour l\'Ã©chec',0),(378571,10516,'jp','ã‚«ãƒ¬ãƒ³ãƒ€ãƒ¼ ã‚¤ãƒ™ãƒ³ãƒˆæ›´æ–°å¤±æ•—',0),(378572,10516,'pt','Evento do calendÃ¡rio atualizado falha',0),(378573,10516,'ru','ÐÐµ Ð£Ð´Ð°Ð»Ð¾ÑÑŒ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð½Ð¾Ðµ Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ðµ ',0),(378574,10516,'es','Evento Calendario Actualizar FallÃ³',0),(378575,10516,'de','Kalender Event aktualisiert Fehler',0),(378576,10516,'en','Calendar Event Updated Failure',0),(378577,10517,'is','',0),(378578,10517,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(378579,10517,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø­ÙˆØ§Ø¯Ø« Ø³Ø§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(378580,10517,'tr','Takvim olayÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(378581,10517,'pl','Wydarzenia w kalendarzu pomyÅ›lnie zaktualizowana',0),(378582,10517,'bg','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ Ð½Ð° ÑÑŠÐ±Ð¸Ñ‚Ð¸ÑÑ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(378583,10517,'ur','Ú©ÛŒÙ„Ù†ÚˆØ± Ú©ÛŒ ØªÙ‚Ø±ÛŒØ¨ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(378584,10517,'sr','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(378585,10517,'vi','Cáº­p nháº­t lá»‹ch sá»± kiá»‡n thÃ nh cÃ´ng',0),(378586,10517,'af','Kalender Geleentheid Suksesvol Opdateer',0),(378587,10517,'ro','Calendar evenimente actualizat cu succes',0),(378588,10517,'et','VÃ¤rskendatud kalendrisÃ¼ndmuse',0),(378589,10517,'si','Koledar prireditev uspeÅ¡no posodobljena',0),(378590,10517,'ba','Kalender acara diperbarui berhasil',0),(378591,10517,'nl','Gebeurtenis van de kalender bijgewerkt',0),(378592,10517,'fi','Kalenteritapahtuman pÃ¤ivitetty',0),(378593,10517,'no','Kalenderhendelse oppdatert',0),(378594,10517,'da','Kalenderbegivenhed opdateret',0),(378595,10517,'ko','ì¼ì • ì´ë²¤íŠ¸ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(378596,10517,'he','××™×¨×•×¢×™ ×œ×•×— ×©× ×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(378597,10517,'el','Î ÏÏŒÎ³ÏÎ±Î¼Î¼Î± ÎµÎºÎ´Î·Î»ÏŽÏƒÎµÏ‰Î½ Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(378598,10517,'zh','æˆåŠŸæ›´æ–°æ—¥åŽ†äº‹ä»¶\r\n',0),(378599,10517,'sv','KalenderhÃ¤ndelse uppdaterats',0),(378600,10517,'it','Calendario eventi aggiornato con successo',0),(378601,10517,'tl','',0),(378602,10517,'th','à¸›à¸à¸´à¸—à¸´à¸™à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸“à¹Œà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(378603,10517,'hi','à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤° à¤‡à¤µà¥‡à¤‚à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(378604,10517,'ms','Peristiwa kalendar yang berjaya dikemas kini',0),(378605,10517,'ar','Ø§Ù„Ø­Ø¯Ø« Ø§Ù„ØªÙ‚ÙˆÙŠÙ… ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(378606,10517,'fr','Calendrier des Ã©vÃ©nements mis Ã  jour avec succÃ¨s',0),(378607,10517,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸã‚«ãƒ¬ãƒ³ãƒ€ãƒ¼ ã‚¤ãƒ™ãƒ³ãƒˆ',0),(378608,10517,'pt','Evento do calendÃ¡rio atualizado com sucesso',0),(378609,10517,'ru','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð½Ð¾Ðµ Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ðµ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾',0),(378610,10517,'es','Evento Calendario Actualizado Exitosamente',0),(378611,10517,'de','Kalender Event erfolgreich aktualisiert',0),(378612,10517,'en','Calendar Event Updated Successfully',0),(378613,10518,'is','',0),(378614,10518,'dr','ØªØ§Ø±ÙŠØ® Ø­Ø§Ø¯Ø«Ù‡',0),(378615,10518,'pr','ØªØ§Ø±ÙŠØ® Ø­Ø§Ø¯Ø«Ù‡',0),(378616,10518,'tr','Etkinlik Tarihi',0),(378617,10518,'pl','Data wydarzenia',0),(378618,10518,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÑÑŠÐ±Ð¸Ñ‚Ð¸ÐµÑ‚Ð¾',0),(378619,10518,'ur','ÙˆØ§Ù‚Ø¹Û Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(378620,10518,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð°',0),(378621,10518,'vi','Sá»± kiá»‡n ngÃ y',0),(378622,10518,'af','Geleentheid datum',0),(378623,10518,'ro','Data evenimentului',0),(378624,10518,'et','SÃ¼ndmuse kuupÃ¤ev',0),(378625,10518,'si','Datum dogodek',0),(378626,10518,'ba','Tanggal acara',0),(378627,10518,'nl','Evenementdatum',0),(378628,10518,'fi','Tapahtuman pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(378629,10518,'no','Hendelsesdato',0),(378630,10518,'da','Dato for begivenheden',0),(378631,10518,'ko','ì´ë²¤íŠ¸ ë‚ ì§œ',0),(378632,10518,'he','×ª××¨×™×š ××¨×•×¢',0),(378633,10518,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î·Ï‚ ÎµÎºÎ´Î®Î»Ï‰ÏƒÎ·Ï‚',0),(378634,10518,'zh','æ´»åŠ¨æ—¥æœŸ\r\n',0),(378635,10518,'sv','HÃ¤ndelsedatum',0),(378636,10518,'it','Data dell\'evento',0),(378637,10518,'tl','',0),(378638,10518,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸§à¸±à¸™',0),(378639,10518,'hi','à¤˜à¤Ÿà¤¨à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(378640,10518,'ms','Tarikh acara',0),(378641,10518,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø¯Ø«',0),(378642,10518,'fr','Date de l\'Ã©vÃ©nement',0),(378643,10518,'jp','ã‚¤ãƒ™ãƒ³ãƒˆæ—¥ä»˜',0),(378644,10518,'pt','Data do evento',0),(378645,10518,'ru','Ð”Ð°Ñ‚Ð° Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ñ',0),(378646,10518,'es','PÃ¡gina de Eventos',0),(378647,10518,'de','Event Datum',0),(378648,10518,'en','Event Date',0),(378649,10519,'is','',0),(378650,10519,'dr','Ø²Ù…Ø§Ù† Ø­Ø§Ø¯Ø«Ù‡',0),(378651,10519,'pr','Ø²Ù…Ø§Ù† Ø­Ø§Ø¯Ø«Ù‡',0),(378652,10519,'tr','Olay saati',0),(378653,10519,'pl','Wydarzenie',0),(378654,10519,'bg','Ð¡ÑŠÐ±Ð¸Ñ‚Ð¸Ðµ Ð²Ñ€ÐµÐ¼Ðµ',0),(378655,10519,'ur','ÙˆÙ‚ÙˆØ¹Û Ú©Û’ ÙˆÙ‚Øª',0),(378656,10519,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð°',0),(378657,10519,'vi','Sá»± kiá»‡n thá»i gian',0),(378658,10519,'af','Gebeurtenis tyd',0),(378659,10519,'ro','Eveniment timp',0),(378660,10519,'et','SÃ¼ndmuse aeg',0),(378661,10519,'si','ÄŒas dogajanja',0),(378662,10519,'ba','Waktu acara',0),(378663,10519,'nl','Gebeurtenistijd',0),(378664,10519,'fi','Tapahtuman aika',0),(378665,10519,'no','Tidspunkt',0),(378666,10519,'da','Event tid',0),(378667,10519,'ko','ì´ë²¤íŠ¸ ì‹œê°„',0),(378668,10519,'he','×–×ž×Ÿ ××¨×•×¢',0),(378669,10519,'el','Î£Ï…Î¼Î²Î¬Î½ Ï‡ÏÏŒÎ½Î¿Ï…',0),(378670,10519,'zh','æ´»åŠ¨æ—¶é—´\r\n',0),(378671,10519,'sv','HÃ¤ndelsetiden',0),(378672,10519,'it','Ora evento',0),(378673,10519,'tl','',0),(378674,10519,'th','à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸“à¹Œà¹€à¸§à¸¥à¸²',0),(378675,10519,'hi','à¤˜à¤Ÿà¤¨à¤¾ à¤¸à¤®à¤¯',0),(378676,10519,'ms','Masa acara',0),(378677,10519,'ar','ÙˆÙ‚Øª Ø§Ù„Ø­Ø¯Ø«',0),(378678,10519,'fr','Heure de l\'Ã©vÃ©nement',0),(378679,10519,'jp','ã‚¤ãƒ™ãƒ³ãƒˆæ™‚é–“',0),(378680,10519,'pt','Hora do evento',0),(378681,10519,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ñ',0),(378682,10519,'es','Tiempo del Evento',0),(378683,10519,'de','Uhrzeit des Ereignisses',0),(378684,10519,'en','Event Time',0),(378685,10520,'is','',0),(378686,10520,'dr','Ø¬Ù…Ø¹Ù‡ ',0),(378687,10520,'pr','Ø¬Ù…Ø¹Ù‡ ',0),(378688,10520,'tr','Cuma',0),(378689,10520,'pl','PiÄ…tek',0),(378690,10520,'bg','ÐŸÐµÑ‚ÑŠÐº',0),(378691,10520,'ur','Ø¬Ù…Ø¹Û',0),(378692,10520,'sr','Ð£ Ð¿ÐµÑ‚Ð°Ðº',0),(378693,10520,'vi','thá»© sÃ¡u',0),(378694,10520,'af','Vrydag',0),(378695,10520,'ro','Vineri',0),(378696,10520,'et','Reede',0),(378697,10520,'si','Petek',0),(378698,10520,'ba','Jumat',0),(378699,10520,'nl','Vrijdag',0),(378700,10520,'fi','Perjantai',0),(378701,10520,'no','Fredag',0),(378702,10520,'da','Fredag',0),(378703,10520,'ko','ê¸ˆìš”ì¼',0),(378704,10520,'he','×™×•× ×©×™×©×™',0),(378705,10520,'el','Î Î±ÏÎ±ÏƒÎºÎµÏ…Î®',0),(378706,10520,'zh','æ˜ŸæœŸäº”\r\n',0),(378707,10520,'sv','Fredag',0),(378708,10520,'it','VenerdÃ¬',0),(378709,10520,'tl','',0),(378710,10520,'th','à¸§à¸±à¸™à¸¨à¸¸à¸à¸£à¹Œ',0),(378711,10520,'hi','à¤¶à¥à¤•à¥à¤°à¤µà¤¾à¤°',0),(378712,10520,'ms','Hari Jumaat',0),(378713,10520,'ar','Ø§Ù„Ø¬Ù…Ø¹Ø©',0),(378714,10520,'fr','Vendredi',0),(378715,10520,'jp','é‡‘æ›œæ—¥',0),(378716,10520,'pt','Sexta-feira',0),(378717,10520,'ru','ÐŸÑÑ‚Ð½Ð¸Ñ†Ð°',0),(378718,10520,'es','Viernes',0),(378719,10520,'de','Freitag',0),(378720,10520,'en','Friday',0),(378721,10521,'is','',0),(378722,10521,'dr','Ù„Ø·ÙØ§ ØªØ§Ø±ÙŠØ® Ø±ÙˆÙŠØ¯Ø§Ø¯ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(378723,10521,'pr','Ù„Ø·ÙØ§ ØªØ§Ø±ÙŠØ® Ø±ÙˆÙŠØ¯Ø§Ø¯ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(378724,10521,'tr','LÃ¼tfen etkinlik tarihi iÃ§erir.',0),(378725,10521,'pl','ProszÄ™ podaÄ‡ datÄ™ zdarzenia',0),(378726,10521,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° ÑÑŠÐ±Ð¸Ñ‚Ð¸ÐµÑ‚Ð¾',0),(378727,10521,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÙˆØ§Ù‚Ø¹Û ØªØ§Ø±ÛŒØ® Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(378728,10521,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð´Ð¾Ð³Ð°Ñ’Ð°Ñ˜Ð°',0),(378729,10521,'vi','vui lÃ²ng bao gá»“m ngÃ y sá»± kiá»‡n',0),(378730,10521,'af','Sluit asb. Geleentheidsdatum in',0),(378731,10521,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i data evenimentului',0),(378732,10521,'et','Palun lisage sÃ¼ndmuse kuupÃ¤ev',0),(378733,10521,'si','Prosimo, da vkljuÄite datum dogodek',0),(378734,10521,'ba','Harap sertakan tanggal acara',0),(378735,10521,'nl','Gelieve te omvatten Evenementdatum',0),(378736,10521,'fi','SisÃ¤llytÃ¤ tapahtuman pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(378737,10521,'no','Ta hendelsesdato',0),(378738,10521,'da','VedlÃ¦g Arrangementsdato',0),(378739,10521,'ko','ì´ë²¤íŠ¸ ë‚ ì§œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(378740,10521,'he','×× × ×›×œ×•×œ ×ª××¨×™×š ××¨×•×¢',0),(378741,10521,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î·Ï‚ ÎµÎºÎ´Î®Î»Ï‰ÏƒÎ·Ï‚',0),(378742,10521,'zh','è¯·åˆ—å…¥æ´»åŠ¨æ—¥æœŸ\r\n',0),(378743,10521,'sv','VÃ¤nligen inkludera evenemangsdatum',0),(378744,10521,'it','Si prega di includere data evento',0),(378745,10521,'tl','',0),(378746,10521,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸§à¸±à¸™à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸“à¹Œ',0),(378747,10521,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤‡à¤µà¥‡à¤‚à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(378748,10521,'ms','Sila Sertakan tarikh acara',0),(378749,10521,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø¯Ø«',0),(378750,10521,'fr','Date de l\'Ã©vÃ©nement, veuillez indiquer',0),(378751,10521,'jp','ã‚¤ãƒ™ãƒ³ãƒˆã®æ—¥ä»˜ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(378752,10521,'pt','Por favor, inclua a data do evento',0),(378753,10521,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð”Ð°Ñ‚Ñƒ Ð¡Ð¾Ð±Ñ‹Ñ‚Ð¸Ñ',0),(378754,10521,'es','Por Favor Incluye Fecha de Evento',0),(378755,10521,'de','Bitte geben Sie Ereignisdatum',0),(378756,10521,'en','Please Include Event Date',0),(378757,10522,'is','',0),(378758,10522,'dr','Ù„Ø·ÙØ§ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø±Ø§  Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯',0),(378759,10522,'pr','Ù„Ø·ÙØ§ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø±Ø§  Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯',0),(378760,10522,'tr','LÃ¼tfen anÄ±msatÄ±cÄ± eklemek',0),(378761,10522,'pl','ProszÄ™ podaÄ‡ przypomnienie',0),(378762,10522,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð½Ð°Ð¿Ð¾Ð¼Ð½ÑÐ½Ðµ',0),(378763,10522,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÛŒØ§Ø¯ Ø¯ÛØ§Ù†ÛŒ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(378764,10522,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¾Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(378765,10522,'vi','vui lÃ²ng bao gá»“m lá»i nháº¯c nhá»Ÿ',0),(378766,10522,'af','Sluit asseblief Herinneraar in',0),(378767,10522,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i memento',0),(378768,10522,'et','Palun lisage meeldetuletus',0),(378769,10522,'si','Prosimo, da vkljuÄite opomnik',0),(378770,10522,'ba','Harap sertakan pengingat',0),(378771,10522,'nl','Gelieve te omvatten herinnering',0),(378772,10522,'fi','LiitÃ¤ mukaan muistutus',0),(378773,10522,'no','Ta med pÃ¥minnelse',0),(378774,10522,'da','VedlÃ¦g pÃ¥mindelse',0),(378775,10522,'ko','ì•Œë¦¬ë¯¸ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(378776,10522,'he','×× × ×›×œ×•×œ ×ª×–×›×•×¨×ª',0),(378777,10522,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï…Ï€ÎµÎ½Î¸ÏÎ¼Î¹ÏƒÎ·',0),(378778,10522,'zh','è¯·åˆ—å…¥æé†’\r\n',0),(378779,10522,'sv','VÃ¤nligen inkludera pÃ¥minnelse',0),(378780,10522,'it','Si prega di includere promemoria',0),(378781,10522,'tl','',0),(378782,10522,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸ˆà¸”à¸«à¸¡à¸²à¸¢à¹€à¸•à¸·à¸­à¸™à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(378783,10522,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤¨à¥à¤¸à¥à¤®à¤¾à¤°à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(378784,10522,'ms','Sila sertakan peringatan',0),(378785,10522,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† ØªØ°ÙƒÙŠØ±',0),(378786,10522,'fr','Veuillez inclure le rappel',0),(378787,10522,'jp','æ€ã„å‡ºã•ã›ã‚‹ã‚‚ã®ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(378788,10522,'pt','Por favor inclua o lembrete',0),(378789,10522,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð½Ð°Ð¿Ð¾Ð¼Ð¸Ð½Ð°Ð½Ð¸Ðµ',0),(378790,10522,'es','Por Favor Incluye Recuerdo',0),(378791,10522,'de','Bitte geben Sie Erinnerung',0),(378792,10522,'en','Please Include Reminder',0),(378793,10523,'is','',0),(378794,10523,'dr','Ø´Ù†Ø¨Ù‡',0),(378795,10523,'pr','Ø´Ù†Ø¨Ù‡',0),(378796,10523,'tr','Cumartesi',0),(378797,10523,'pl','Sobota',0),(378798,10523,'bg','Ð¡ÑŠÐ±Ð¾Ñ‚Ð°',0),(378799,10523,'ur','ÛÙØªÛ’ Ú©Û’ Ø±ÙˆØ²',0),(378800,10523,'sr','Ð£ ÑÑƒÐ±Ð¾Ñ‚Ñƒ',0),(378801,10523,'vi','Thá»© 7',0),(378802,10523,'af','Saterdag',0),(378803,10523,'ro','SÃ¢mbÄƒtÄƒ',0),(378804,10523,'et','LaupÃ¤ev',0),(378805,10523,'si','Sobota',0),(378806,10523,'ba','Sabtu',0),(378807,10523,'nl','Zaterdag',0),(378808,10523,'fi','Lauantai',0),(378809,10523,'no','LÃ¸rdag',0),(378810,10523,'da','LÃ¸rdag',0),(378811,10523,'ko','í† ìš”ì¼',0),(378812,10523,'he','×©×‘×ª',0),(378813,10523,'el','Î£Î¬Î²Î²Î±Ï„Î¿',0),(378814,10523,'zh','æ˜ŸæœŸå…­\r\n',0),(378815,10523,'sv','LÃ¶rdag',0),(378816,10523,'it','Sabato',0),(378817,10523,'tl','',0),(378818,10523,'th','à¸§à¸±à¸™à¹€à¸ªà¸²à¸£à¹Œ',0),(378819,10523,'hi','à¤¶à¤¨à¤¿à¤µà¤¾à¤°',0),(378820,10523,'ms','Hari Sabtu',0),(378821,10523,'ar','Ø§Ù„Ø³Ø¨Øª',0),(378822,10523,'fr','Samedi',0),(378823,10523,'jp','åœŸæ›œæ—¥',0),(378824,10523,'pt','SÃ¡bado',0),(378825,10523,'ru','Ð¡ÑƒÐ±Ð±Ð¾Ñ‚Ð°',0),(378826,10523,'es','Sabado',0),(378827,10523,'de','Samstag',0),(378828,10523,'en','Saturday',0),(378829,10524,'is','',0),(378830,10524,'dr','Ù¾Ù†Ø¬ Ø´Ù†Ø¨Ù‡ ',0),(378831,10524,'pr','Ù¾Ù†Ø¬ Ø´Ù†Ø¨Ù‡ ',0),(378832,10524,'tr','PerÅŸembe',0),(378833,10524,'pl','Czwartek',0),(378834,10524,'bg','Ð§ÐµÑ‚Ð²ÑŠÑ€Ñ‚ÑŠÐº',0),(378835,10524,'ur','Ø¬Ù…Ø¹Ø±Ø§Øª',0),(378836,10524,'sr','Ð£ Ñ‡ÐµÑ‚Ð²Ñ€Ñ‚Ð°Ðº',0),(378837,10524,'vi','Thá»© 5',0),(378838,10524,'af','Donderdag',0),(378839,10524,'ro','Joi',0),(378840,10524,'et','NeljapÃ¤ev',0),(378841,10524,'si','ÄŒetrtek',0),(378842,10524,'ba','Kamis',0),(378843,10524,'nl','Donderdag',0),(378844,10524,'fi','Torstai',0),(378845,10524,'no','Torsdag',0),(378846,10524,'da','Torsdag',0),(378847,10524,'ko','ëª©ìš”ì¼',0),(378848,10524,'he','×™×•× ×—×ž×™×©×™',0),(378849,10524,'el','Î Î­Î¼Ï€Ï„Î·',0),(378850,10524,'zh','æ˜ŸæœŸå››\r\n',0),(378851,10524,'sv','Torsdag',0),(378852,10524,'it','GiovedÃ¬',0),(378853,10524,'tl','',0),(378854,10524,'th','à¸§à¸±à¸™à¸žà¸¤à¸«à¸±à¸ªà¸šà¸”à¸µ',0),(378855,10524,'hi','à¤—à¥à¤°à¥à¤µà¤¾à¤°',0),(378856,10524,'ms','Khamis',0),(378857,10524,'ar','Ø§Ù„ÙŠÙˆÙ… Ø§Ù„Ø®Ù…ÙŠØ³',0),(378858,10524,'fr','Jeudi',0),(378859,10524,'jp','æœ¨æ›œæ—¥',0),(378860,10524,'pt','Quinta-feira',0),(378861,10524,'ru','Ð§ÐµÑ‚Ð²ÐµÑ€Ð³',0),(378862,10524,'es','Jueves',0),(378863,10524,'de','Donnerstag',0),(378864,10524,'en','Thursday',0),(378865,10525,'is','',0),(378866,10525,'dr','Ø³Ù‡ Ø´Ù†Ø¨Ù‡ ',0),(378867,10525,'pr','Ø³Ù‡ Ø´Ù†Ø¨Ù‡ ',0),(378868,10525,'tr','SalÄ±',0),(378869,10525,'pl','We wtorek',0),(378870,10525,'bg','Ð’Ñ‚Ð¾Ñ€Ð½Ð¸Ðº',0),(378871,10525,'ur','Ù…Ù†Ú¯Ù„',0),(378872,10525,'sr','Ð£ ÑƒÑ‚Ð¾Ñ€Ð°Ðº',0),(378873,10525,'vi','Thá»© 3',0),(378874,10525,'af','Dinsdag',0),(378875,10525,'ro','MarÅ£i',0),(378876,10525,'et','TeisipÃ¤ev',0),(378877,10525,'si','Torek',0),(378878,10525,'ba','Selasa',0),(378879,10525,'nl','Dinsdag',0),(378880,10525,'fi','Tiistai',0),(378881,10525,'no','Tirsdag',0),(378882,10525,'da','Tirsdag',0),(378883,10525,'ko','í™”ìš”ì¼',0),(378884,10525,'he','×©×œ×™×©×™',0),(378885,10525,'el','Î¤ÏÎ¯Ï„Î·',0),(378886,10525,'zh','æ˜ŸæœŸäºŒ\r\n',0),(378887,10525,'sv','Tisdag',0),(378888,10525,'it','MartedÃ¬',0),(378889,10525,'tl','',0),(378890,10525,'th','à¸§à¸±à¸™à¸­à¸±à¸‡à¸„à¸²à¸£',0),(378891,10525,'hi','à¤®à¤‚à¤—à¤²à¤µà¤¾à¤°',0),(378892,10525,'ms','Selasa',0),(378893,10525,'ar','Ø§Ù„ÙŠÙˆÙ… Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡',0),(378894,10525,'fr','Mardi',0),(378895,10525,'jp','ç«æ›œæ—¥',0),(378896,10525,'pt','TerÃ§a-feira',0),(378897,10525,'ru','Ð’Ñ‚Ð¾Ñ€Ð½Ð¸Ðº',0),(378898,10525,'es','Martes',0),(378899,10525,'de','Dienstag',0),(378900,10525,'en','Tuesday',0),(378901,10526,'is','',0),(378902,10526,'dr','Ú†Ù‡Ø§Ø± Ø´Ù†Ø¨Ù‡',0),(378903,10526,'pr','Ú†Ù‡Ø§Ø± Ø´Ù†Ø¨Ù‡',0),(378904,10526,'tr','Ã‡arÅŸamba',0),(378905,10526,'pl','Åšroda',0),(378906,10526,'bg','Ð¡Ñ€ÑÐ´Ð°',0),(378907,10526,'ur','Ø¨Ø¯Ú¾ Ú©Û’ Ø±ÙˆØ²',0),(378908,10526,'sr','Ð£ ÑÑ€ÐµÐ´Ñƒ',0),(378909,10526,'vi','thá»© 4',0),(378910,10526,'af','Woensdag',0),(378911,10526,'ro','Miercuri',0),(378912,10526,'et','KolmapÃ¤ev',0),(378913,10526,'si','Sreda',0),(378914,10526,'ba','Rabu',0),(378915,10526,'nl','Woensdag',0),(378916,10526,'fi','Keskiviikko',0),(378917,10526,'no','Onsdag',0),(378918,10526,'da','Onsdag',0),(378919,10526,'ko','ìˆ˜ìš”ì¼',0),(378920,10526,'he','×¨×‘×™×¢×™',0),(378921,10526,'el','Î¤ÎµÏ„Î¬ÏÏ„Î·',0),(378922,10526,'zh','æ˜ŸæœŸä¸‰\r\n',0),(378923,10526,'sv','Onsdag',0),(378924,10526,'it','MercoledÃ¬',0),(378925,10526,'tl','',0),(378926,10526,'th','à¸§à¸±à¸™à¸žà¸¸à¸˜',0),(378927,10526,'hi','à¤¬à¥à¤§à¤µà¤¾à¤°',0),(378928,10526,'ms','Rabu',0),(378929,10526,'ar','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡',0),(378930,10526,'fr','Mercredi',0),(378931,10526,'jp','æ°´æ›œæ—¥',0),(378932,10526,'pt','Quarta-feira',0),(378933,10526,'ru','Ð¡Ñ€ÐµÐ´Ð°',0),(378934,10526,'es','Miercoles',0),(378935,10526,'de','Mittwoch',0),(378936,10526,'en','Wednesday',0),(378937,10527,'is','',0),(378938,10527,'dr','Ù…ØµØ±Ù  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø·Ø¨Ù‚ Ú¯Ø±ÙˆÙ‡ â€“ ÙŠÙƒ Ø³Ø§Ù„ ',0),(378939,10527,'pr','Ù…ØµØ±Ù  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø·Ø¨Ù‚ Ú¯Ø±ÙˆÙ‡ â€“ ÙŠÙƒ Ø³Ø§Ù„ ',0),(378940,10527,'tr','Kategoriye gÃ¶re stok kullanÄ±mÄ±: 1 yÄ±l',0),(378941,10527,'pl','ZuÅ¼ycie zapasÃ³w wedÅ‚ug kategorii: 1 rok',0),(378942,10527,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°ÐµÐ¼Ð¾ÑÑ‚ Ð½Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸: 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(378943,10527,'ur','Ø²Ù…Ø±Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ: 1 Ø³Ø§Ù„',0),(378944,10527,'sr','ÐšÐ¾Ñ€Ð¸ÑˆÑ‚ÐµÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°Ð¼Ð°: 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(378945,10527,'vi','HÃ ng HÃ³a Sá»­ Dá»¥ng Theo Thá»ƒ Loáº¡i: 1 nÄƒm',0),(378946,10527,'af','Voorraad Gebruik Per Kategorie - 1 Jr',0),(378947,10527,'ro','Stocuri de utilizare de categoria: 1 an',0),(378948,10527,'et','Varude kasutamine kategooriate kaupa: 1 aasta',0),(378949,10527,'si','Zaloge navada po kategoriji: 1 leto',0),(378950,10527,'ba','Persediaan penggunaan oleh Kategori: 1 tahun',0),(378951,10527,'nl','Voorraad gebruik per categorie: 1 jaar',0),(378952,10527,'fi','Sivustovaraston kÃ¤yttÃ¶ luokittain: 1 vuosi',0),(378953,10527,'no','Lager bruk av Kategori: 1 Ã¥r',0),(378954,10527,'da','Lageret brugen af kategori: 1 Ã¥r',0),(378955,10527,'ko','ì¹´í…Œê³ ë¦¬ë³„ ìž¬ê³  ì‚¬ìš©: 1 ë…„',0),(378956,10527,'he','×©×™×ž×•×© ×”×ž×œ××™ ×œ×¤×™ ×§×˜×’×•×¨×™×”: 1 ×©× ×”',0),(378957,10527,'el','Î§ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±: 1 Î­Ï„Î¿Ï‚',0),(378958,10527,'zh','åº“å­˜ä½¿ç”¨æŒ‰ç±»åˆ«-1å¹´\r\n',0),(378959,10527,'sv','Inventering anvÃ¤ndning av kategori: 1 Ã¥r',0),(378960,10527,'it','Utilizzo di inventario di categoria: 1 anno',0),(378961,10527,'tl','',0),(378962,10527,'th','à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸—: 1 à¸›à¸µ',0),(378963,10527,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥‚à¤šà¥€ à¤‰à¤ªà¤¯à¥‹à¤—: 1 à¤µà¤°à¥à¤·',0),(378964,10527,'ms','Penggunaan inventori mengikut Kategori: 1 tahun',0),(378965,10527,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø­Ø³Ø¨ Ø§Ù„ÙØ¦Ø©: 1 Ø³Ù†Ø©',0),(378966,10527,'fr','Utilisation de l\'inventaire par catÃ©gorie: 1 an',0),(378967,10527,'jp','ã‚«ãƒ†ã‚´ãƒªåˆ¥ã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®åˆ©ç”¨çŠ¶æ³: 1 å¹´',0),(378968,10527,'pt','Uso do inventÃ¡rio por categoria: 1 ano',0),(378969,10527,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÐ¼: 1 Ð³Ð¾Ð´',0),(378970,10527,'es','Uso de Inventario por CategorÃ­a - 1 AÃ±o',0),(378971,10527,'de','Inventar-Nutzung durch Kategorie: 1 Jahr',0),(378972,10527,'en','Inventory Usage By Category: 1 Year',0),(378973,10528,'is','',0),(378974,10528,'dr','30 Ø±ÙˆØ² ',0),(378975,10528,'pr','Ù…ØµØ±Ù  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ Ø·Ø¨Ù‚ Ú¯Ø±ÙˆÙ‡ â€“ 30 Ø±ÙˆØ² ',0),(378976,10528,'tr','Stok kullanÄ±mÄ± Kategori: 30 gÃ¼n',0),(378977,10528,'pl','Spis zwyczaj w kategorii: 30 dni',0),(378978,10528,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ: 30 Ð´Ð½Ð¸',0),(378979,10528,'ur','Ø³ÛÙˆÙ„ÛŒØ§Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø²Ù…Ø±Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’: 30 Ø¯Ù†',0),(378980,10528,'sr','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸: 30 Ð´Ð°Ð½Ð°',0),(378981,10528,'vi','HÃ ng HÃ³a Sá»­ Dá»¥ng Theo Thá»ƒ Loáº¡i: 30 ngÃ y',0),(378982,10528,'af','Item Gebruik per Kategorie - 30 Dae',0),(378983,10528,'ro','Inventar de categoria de utilizare: 30 zile',0),(378984,10528,'et','Varude kasutamine kategooriate kaupa: 30 pÃ¤eva',0),(378985,10528,'si','Popis navada po kategoriji: 30 dni',0),(378986,10528,'ba','Persediaan penggunaan oleh Kategori: 30 hari',0),(378987,10528,'nl','Inventaris van gebruik door categorie: 30 dagen',0),(378988,10528,'fi','Varaston kÃ¤yttÃ¶ luokittain: 30 pÃ¤ivÃ¤Ã¤',0),(378989,10528,'no','Lager bruk av Kategori: 30 dager',0),(378990,10528,'da','Lageret brugen af kategori: 30 dage',0),(378991,10528,'ko','ì¹´í…Œê³ ë¦¬ ì‚¬ìš© ìž¬ê³ : 30 ì¼',0),(378992,10528,'he','×ž×œ××™ ×”×©×™×ž×•×© ×œ×¤×™ ×§×˜×’×•×¨×™×”: 30 ×™×ž×™×',0),(378993,10528,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ Î³Î¹Î± Ï‡ÏÎ®ÏƒÎ· Î±Ï€ÏŒ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±: 30 Î·Î¼Î­ÏÎµÏ‚',0),(378994,10528,'zh','åº“å­˜ä½¿ç”¨åˆ†ç±»- 30å¤©\r\n',0),(378995,10528,'sv','Inventering anvÃ¤ndning av kategori: 30 dagar',0),(378996,10528,'it','Utilizzo di categoria di magazzino: 30 giorni',0),(378997,10528,'tl','',0),(378998,10528,'th','à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸—à¸‚à¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡: 30 à¸§à¸±à¸™',0),(378999,10528,'hi','à¤¸à¥‚à¤šà¥€ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—: 30 à¤¦à¤¿à¤¨',0),(379000,10528,'ms','Inventori penggunaan mengikut Kategori: 30 hari',0),(379001,10528,'ar','Ø­ØµØ± Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ø³Ø¨ Ø§Ù„ÙØ¦Ø©: 30 ÙŠÙˆÙ…Ø§',0),(379002,10528,'fr','L\'inventaire de l\'utilisation par catÃ©gorie : 30 jours',0),(379003,10528,'jp','ã‚«ãƒ†ã‚´ãƒªãŒä½¿ç”¨ã‚’åœ¨åº«ï¼š 30 æ—¥',0),(379004,10528,'pt','Uso por categoria de inventÃ¡rio: 30 dias',0),(379005,10528,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ: 30 Ð´Ð½ÐµÐ¹',0),(379006,10528,'es','Uso de Inventario por CategorÃ­a - 30 DÃ­as',0),(379007,10528,'de','Inventur-Nutzung durch Kategorie: 30 Tage',0),(379008,10528,'en','Inventory Usage by Category: 30 Days',0),(379009,10529,'is','',0),(379010,10529,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ø±Ø®ØµÙŠ',0),(379011,10529,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ø±Ø®ØµÙŠ',0),(379012,10529,'tr','Ä°stek sÃ¼resi Off',0),(379013,10529,'pl','Wniosek czas od',0),(379014,10529,'bg','Ð˜Ð·Ð¸ÑÐºÐ° Ð²Ñ€ÐµÐ¼Ðµ Ð¸Ð·Ð²ÑŠÐ½',0),(379015,10529,'ur','Ø¢Ù Ú©Û’ ÙˆÙ‚Øª Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(379016,10529,'sr','Ð—Ð°Ñ‚Ñ€Ð°Ð¶Ð¸Ñ‚Ðµ Ð¿ÑƒÑ‚ Ð²Ð°Ð½',0),(379017,10529,'vi','YÃªu cáº§u thá»i gian ra',0),(379018,10529,'af','Tyd af versoek',0),(379019,10529,'ro','Solicita timp Off',0),(379020,10529,'et','PÃ¤ringu vÃ¤lja',0),(379021,10529,'si','Zahteva Äas Off',0),(379022,10529,'ba','Meminta waktu Off',0),(379023,10529,'nl','Aanvragen van tijd af',0),(379024,10529,'fi','PyydÃ¤ aikaa pois',0),(379025,10529,'no','Be om tid av',0),(379026,10529,'da','Anmode om tid vÃ¦k',0),(379027,10529,'ko','ì˜¤í”„ ì‹œê°„ì„ ìš”ì²­',0),(379028,10529,'he','×œ×‘×§×© ×–×ž×Ÿ.',0),(379029,10529,'el','Î–Î·Ï„Î®ÏƒÎµÎ¹ Ï‡ÏÏŒÎ½Î¿ Î¼Î±ÎºÏÎ¹Î¬',0),(379030,10529,'zh','ç”³è¯·æ—¶é—´å…³é—­\r\n',0),(379031,10529,'sv','BegÃ¤ra tid av',0),(379032,10529,'it','Richiesta di tempo fuori',0),(379033,10529,'tl','',0),(379034,10529,'th','à¸‚à¸­à¹€à¸§à¸¥à¸²à¸›à¸´à¸”',0),(379035,10529,'hi','à¤¸à¤®à¤¯ à¤¸à¥‡ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(379036,10529,'ms','Meminta masa Off',0),(379037,10529,'ar','Ø·Ù„Ø¨ ÙˆÙ‚Øª Ø§Ù„Ø®Ø±ÙˆØ¬',0),(379038,10529,'fr','Demande de temps hors',0),(379039,10529,'jp','ã‚ªãƒ•æ™‚é–“ã‚’è¦æ±‚ã—ã¾ã™ã€‚',0),(379040,10529,'pt','Solicitar um tempo fora',0),(379041,10529,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ñƒ',0),(379042,10529,'es','Solicitar Tiempo Libre',0),(379043,10529,'de','Zeit aus anfordern',0),(379044,10529,'en','Request Time Off',0),(379045,10530,'is','',0),(379046,10530,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ ',0),(379047,10530,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ ',0),(379048,10530,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ saat kapalÄ± istekleri',0),(379049,10530,'pl','Widok czasu Å¼Ä…dania',0),(379050,10530,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð²Ñ€ÐµÐ¼Ðµ Ð¸Ð·Ð²ÑŠÐ½ Ð·Ð°ÑÐ²ÐºÐ¸',0),(379051,10530,'ur','Ù…Ù†Ø¸Ø± Ø¯ÙˆØ± Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(379052,10530,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° ÑÐ° Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð¸Ð¼Ð°',0),(379053,10530,'vi','Xem thá»i gian ra yÃªu cáº§u',0),(379054,10530,'af','Besigtig Aftye Versoeke',0),(379055,10530,'ro','Vezi timp cereri',0),(379056,10530,'et','Aja vaatamiseks vÃ¤ljas taotlusi',0),(379057,10530,'si','Pogled odsotnost zahteve',0),(379058,10530,'ba','Lihat masa Off permintaan',0),(379059,10530,'nl','Weergavetijd uit aanvragen',0),(379060,10530,'fi','Katso ajan pyynnÃ¶t',0),(379061,10530,'no','Se tid av forespÃ¸rsler',0),(379062,10530,'da','Se Afspadsering anmodninger',0),(379063,10530,'ko','ë³´ê¸° ì‹œê°„ ìš”ì²­',0),(379064,10530,'he','×ª×¦×•×’×ª ×—×•×¤×© ×‘×§×©×•×ª',0),(379065,10530,'el','Î ÏÎ¿Î²Î¿Î»Î® ÏŽÏÎ± Î±Î¹Ï„Î®Î¼Î±Ï„Î±',0),(379066,10530,'zh','è¯·æŸ¥çœ‹æ—¶é—´å…³é—­\r\n',0),(379067,10530,'sv','Visa ledighet fÃ¶rfrÃ¥gningar',0),(379068,10530,'it','Visualizzazione tempo fuori le richieste',0),(379069,10530,'tl','',0),(379070,10530,'th','à¸”à¸¹à¹€à¸§à¸¥à¸²à¸›à¸´à¸”à¸„à¸³à¸‚à¸­',0),(379071,10530,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¸à¤®à¤¯ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¬à¤‚à¤¦',0),(379072,10530,'ms','View masa Off permintaan',0),(379073,10530,'ar','Ø¹Ø±Ø¶ Ø·Ù„Ø¨Ø§Øª Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ù…Ø³ØªÙ‚Ø·Ø¹',0),(379074,10530,'fr','Affichage temps libre requÃªtes',0),(379075,10530,'jp','ãƒ“ãƒ¥ãƒ¼å®Ÿåƒå¤–æ™‚é–“è¦æ±‚',0),(379076,10530,'pt','Tempo de exibiÃ§Ã£o fora solicitaÃ§Ãµes',0),(379077,10530,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð²Ñ€ÐµÐ¼Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð²',0),(379078,10530,'es','Vistar Solicitudes para Tiempo Libre',0),(379079,10530,'de','Ansicht Zeit Anfragen',0),(379080,10530,'en','View Time Off Requests',0),(379081,10531,'is','',0),(379082,10531,'dr','Ù‡Ù…Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ ',0),(379083,10531,'pr','Ù‡Ù…Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ ',0),(379084,10531,'tr','Her zaman kapalÄ± istekleri',0),(379085,10531,'pl','CaÅ‚y czas siÄ™ Å¼Ä…dania',0),(379086,10531,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð¾Ñ‚ Ð·Ð°ÑÐ²ÐºÐ¸',0),(379087,10531,'ur','ÛØ± Ø¯ÙˆØ± Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(379088,10531,'sr','Ð¡Ð»Ð¾Ð±Ð¾Ð´Ð½Ð¾ Ð¿Ð¾Ð·Ð¸Ð²Ðµ Ð·Ð° ÑÐ²Ðµ Ð²Ñ€ÐµÐ¼Ðµ.',0),(379089,10531,'vi','Táº¥t cáº£  yÃªu cáº§u thá»i gian ngÆ°ng',0),(379090,10531,'af','Heeltyd af versoeke',0),(379091,10531,'ro','Toate timp cereri',0),(379092,10531,'et','Kogu aeg vÃ¤lja taotlused',0),(379093,10531,'si','Odsotnost zahteve',0),(379094,10531,'ba','Sepanjang masa Off permintaan',0),(379095,10531,'nl','Alle verlof aanvragen',0),(379096,10531,'fi','Kaikki-ajan pyynnÃ¶t',0),(379097,10531,'no','Tidene av forespÃ¸rsler',0),(379098,10531,'da','Alle Afspadsering anmodninger',0),(379099,10531,'ko','ëª¨ë“  ì‹œê°„ ìš”ì²­',0),(379100,10531,'he','×›×œ ×”×–×ž×Ÿ ××ª ×‘×§×©×•×ª',0),(379101,10531,'el','ÎŒÎ»Ï‰Î½ Ï„Ï‰Î½ ÎµÏ€Î¿Ï‡ÏŽÎ½ Î±Î¹Ï„Î®Î¼Î±Ï„Î±',0),(379102,10531,'zh','æ‰€æœ‰æ—¶é—´å…³é—­è¯·æ±‚\r\n',0),(379103,10531,'sv','All tid av fÃ¶rfrÃ¥gningar',0),(379104,10531,'it','Tutto il tempo fuori le richieste',0),(379105,10531,'tl','',0),(379106,10531,'th','à¹€à¸§à¸¥à¸²à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸­à¸­à¸à¸ˆà¸²à¸à¸„à¸³à¸‚à¸­',0),(379107,10531,'hi','à¤¸à¤­à¥€ à¤¸à¤®à¤¯ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¬à¤‚à¤¦',0),(379108,10531,'ms','Semua masa Off permintaan',0),(379109,10531,'ar','ÙƒÙ„ ÙˆÙ‚Øª Ø¥ÙŠÙ‚Ø§Ù Ø§Ù„Ø·Ù„Ø¨Ø§Øª',0),(379110,10531,'fr','Tous les congÃ©s des requÃªtes',0),(379111,10531,'jp','ã™ã¹ã¦å®Ÿåƒå¤–æ™‚é–“è¦æ±‚',0),(379112,10531,'pt','Tempo todos os pedidos',0),(379113,10531,'ru','Ð’ÑÐµ Ð²Ñ€ÐµÐ¼Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð²',0),(379114,10531,'es','Todos los Solicitudes para Tiempo Libre',0),(379115,10531,'de','Alle Zeit Anfragen',0),(379116,10531,'en','All Time Off Requests',0),(379117,10532,'is','',0),(379118,10532,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯ ',0),(379119,10532,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯ ',0),(379120,10532,'tr','DeÄŸil kaydedilen veriler',0),(379121,10532,'pl','Nie zapisanych danych',0),(379122,10532,'bg','Ð”Ð°Ð½Ð½Ð¸Ñ‚Ðµ Ð½Ðµ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ñ‚',0),(379123,10532,'ur','Ú©ÙˆØ§Ø¦Ù Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº',0),(379124,10532,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ðµ Ñ‡ÑƒÐ²Ð°Ñ˜Ñƒ.',0),(379125,10532,'vi','Dá»¯ liá»‡u chÆ°a Ä‘Æ°á»£c lÆ°u',0),(379126,10532,'af','Data Nie Gestoor',0),(379127,10532,'ro','Datele nesalvate',0),(379128,10532,'et','Andmeid ei salvestata',0),(379129,10532,'si','Podatkov ni shranjena',0),(379130,10532,'ba','Data yang tidak disimpan',0),(379131,10532,'nl','Gegevens niet opgeslagen',0),(379132,10532,'fi','Tietoja ei tallenneta',0),(379133,10532,'no','Data ikke lagret',0),(379134,10532,'da','Data ikke gemt',0),(379135,10532,'ko','ì €ìž¥ ë˜ì§€ ì•Šì€ ë°ì´í„°',0),(379136,10532,'he','×”× ×ª×•× ×™× ××™× × × ×©×ž×¨×™×',0),(379137,10532,'el','Î”ÎµÎ´Î¿Î¼Î­Î½Î± Î´ÎµÎ½ Î±Ï€Î¿Î¸Î·ÎºÎµÏÎ¿Î½Ï„Î±Î¹',0),(379138,10532,'zh','æ•°æ®ä¸ä¿å­˜\r\n',0),(379139,10532,'sv','Data som inte sparats',0),(379140,10532,'it','Dati non salvati',0),(379141,10532,'tl','',0),(379142,10532,'th','à¹„à¸¡à¹ˆà¸šà¸±à¸™à¸—à¸¶à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(379143,10532,'hi','à¤¨à¤¹à¥€à¤‚ à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¡à¥‡à¤Ÿà¤¾',0),(379144,10532,'ms','Data yang tidak disimpan',0),(379145,10532,'ar','Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ØºÙŠØ± Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø©',0),(379146,10532,'fr','DonnÃ©es non sauvegardÃ©es',0),(379147,10532,'jp','ä¿å­˜ã•ã‚Œã¦ã„ãªã„ãƒ‡ãƒ¼ã‚¿',0),(379148,10532,'pt','Dados nÃ£o salvos',0),(379149,10532,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ ÐÐµ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(379150,10532,'es','Datos No Guardados',0),(379151,10532,'de','Nicht gespeicherte Daten',0),(379152,10532,'en','Data Not Saved',0),(379153,10533,'is','',0),(379154,10533,'dr','ØªØ¨ØµØ±Ù‡ Ù‡Ø§ÙŠ Ø±Ø§ÙŠ',0),(379155,10533,'pr','ØªØ¨ØµØ±Ù‡ Ù‡Ø§ÙŠ Ø±Ø§ÙŠ',0),(379156,10533,'tr','Karar notlarÄ±',0),(379157,10533,'pl','ZauwaÅ¼a decyzja',0),(379158,10533,'bg','Ð ÐµÑˆÐµÐ½Ð¸Ðµ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(379159,10533,'ur','Ú©Û’ ÙÛŒØµÙ„Û’ Ú©Ø§ Ù†ÙˆÙ¹Ø³',0),(379160,10533,'sr','ÐžÐ´Ð»ÑƒÐºÐ° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(379161,10533,'vi','ThÃ´ng bÃ¡o quyáº¿t Ä‘á»‹nh',0),(379162,10533,'af','Besluit Notas',0),(379163,10533,'ro','Decizia note',0),(379164,10533,'et','Otsuse mÃ¤rkused',0),(379165,10533,'si','OdloÄba ugotavlja',0),(379166,10533,'ba','Keputusan catatan',0),(379167,10533,'nl','Besluit notities',0),(379168,10533,'fi','PÃ¤Ã¤tÃ¶ksessÃ¤ todetaan',0),(379169,10533,'no','Vedtaket notater',0),(379170,10533,'da','Beslutning noter',0),(379171,10533,'ko','ê²°ì • ë©”ëª¨',0),(379172,10533,'he','×”×”×—×œ×˜×” ×”×¢×¨×•×ª',0),(379173,10533,'el','Î‘Ï€ÏŒÏ†Î±ÏƒÎ· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(379174,10533,'zh','å†³å®šå€ºåˆ¸\r\n',0),(379175,10533,'sv','Beslut anteckningar',0),(379176,10533,'it','Note di decisione',0),(379177,10533,'tl','',0),(379178,10533,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸•à¸±à¸”à¸ªà¸´à¸™à¹ƒà¸ˆ',0),(379179,10533,'hi','à¤¨à¤¿à¤°à¥à¤£à¤¯ à¤¨à¥‹à¤Ÿ',0),(379180,10533,'ms','Nota-Nota keputusan',0),(379181,10533,'ar','ÙˆÙŠÙ„Ø§Ø­Ø¸ Ø§Ù„Ù‚Ø±Ø§Ø±',0),(379182,10533,'fr','Note de la dÃ©cision',0),(379183,10533,'jp','æ„æ€æ±ºå®šã®ãƒŽãƒ¼ãƒˆ',0),(379184,10533,'pt','Notas de decisÃ£o',0),(379185,10533,'ru','Ð ÐµÑˆÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(379186,10533,'es','Notas de DecisiÃ³n',0),(379187,10533,'de','Entscheidung Notes',0),(379188,10533,'en','Decision Notes',0),(379189,10534,'is','',0),(379190,10534,'dr','Ù…Ø¯ÙŠØ± ',0),(379191,10534,'pr','Ù…Ø¯ÙŠØ± ',0),(379192,10534,'tr','YÃ¶neticisi',0),(379193,10534,'pl','MenedÅ¼er',0),(379194,10534,'bg','ÐœÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€',0),(379195,10534,'ur','Ù…Ù†ÛŒØ¬Ø±',0),(379196,10534,'sr','ÐœÐµÐ½Ð°ÑŸÐµÑ€',0),(379197,10534,'vi','ngÆ°á»i quáº£n lÃ½',0),(379198,10534,'af','Bestuurder',0),(379199,10534,'ro','Manager',0),(379200,10534,'et','Haldur',0),(379201,10534,'si','Manager',0),(379202,10534,'ba','Manajer',0),(379203,10534,'nl','Manager',0),(379204,10534,'fi','Manager',0),(379205,10534,'no','Manager',0),(379206,10534,'da','Manager',0),(379207,10534,'ko','ê´€ë¦¬ìž',0),(379208,10534,'he','×ž× ×”×œ',0),(379209,10534,'el','Î”Î¹ÎµÏ…Î¸Ï…Î½Ï„Î®Ï‚',0),(379210,10534,'zh','ç»ç†\r\n',0),(379211,10534,'sv','Manager',0),(379212,10534,'it','Manager',0),(379213,10534,'tl','',0),(379214,10534,'th','à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸à¸²à¸£',0),(379215,10534,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤•',0),(379216,10534,'ms','Pengurus',0),(379217,10534,'ar','Ø§Ù„Ù…Ø¯ÙŠØ±',0),(379218,10534,'fr','Gestionnaire',0),(379219,10534,'jp','ãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼',0),(379220,10534,'pt','Gerente',0),(379221,10534,'ru','ÐœÐµÐ½ÐµÐ´Ð¶ÐµÑ€',0),(379222,10534,'es','Administrador',0),(379223,10534,'de','Manager',0),(379224,10534,'en','Manager',0),(379225,10535,'is','',0),(379226,10535,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ Ù…Ù† ',0),(379227,10535,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù…Ø±Ø®ØµÙŠ Ù…Ù† ',0),(379228,10535,'tr','Benim zaman kapalÄ± istekleri',0),(379229,10535,'pl','MÃ³j czas wolny Å¼Ä…dania',0),(379230,10535,'bg','ÐœÐ¾ÐµÑ‚Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð·Ð°ÑÐ²ÐºÐ¸',0),(379231,10535,'ur','Ø§Ù¾Ù†Û’ Ø¯ÙˆØ± Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(379232,10535,'sr','ÐœÐ¾Ñ˜ Ð¾Ð´Ð¼Ð¾Ñ€ Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ',0),(379233,10535,'vi','ÄÆ¡n xin nghá»‰ cá»§a tÃ´i',0),(379234,10535,'af','My tyd af versoeke',0),(379235,10535,'ro','Timpul meu Off cereri',0),(379236,10535,'et','Minu tÃ¶Ã¶lt taotlused',0),(379237,10535,'si','Svoj izostanek zahteve',0),(379238,10535,'ba','Saya masa Off permintaan',0),(379239,10535,'nl','Mijn tijd af aanvragen',0),(379240,10535,'fi','Ajan pyynnÃ¶t',0),(379241,10535,'no','Min fritid forespÃ¸rsler',0),(379242,10535,'da','Min Afspadsering anmodninger',0),(379243,10535,'ko','ë‚´ ìš”ì²­ ì‹œê°„',0),(379244,10535,'he','×©×œ×™ ×—×•×¤×© ×‘×§×©×•×ª',0),(379245,10535,'el','Î¤Î¿ Ï‡ÏÏŒÎ½Î¿ Î¼Î¿Ï… Î±Î¹Ï„Î®Î¼Î±Ï„Î±',0),(379246,10535,'zh','æˆ‘çš„ä¼‘å‡è¯·æ±‚\r\n',0),(379247,10535,'sv','Min ledighet fÃ¶rfrÃ¥gningar',0),(379248,10535,'it','Il mio tempo libero le richieste',0),(379249,10535,'tl','',0),(379250,10535,'th','à¹€à¸§à¸¥à¸²à¸­à¸­à¸à¸„à¸³à¸‚à¸­',0),(379251,10535,'hi','à¤®à¥‡à¤°à¤¾ à¤¸à¤®à¤¯ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¬à¤‚à¤¦',0),(379252,10535,'ms','Saya masa Off permintaan',0),(379253,10535,'ar','ÙˆÙ‚ØªÙŠ Ø¥ÙŠÙ‚Ø§Ù Ø§Ù„Ø·Ù„Ø¨Ø§Øª',0),(379254,10535,'fr','Mes demandes de congÃ©s',0),(379255,10535,'jp','ç§å®Ÿåƒå¤–æ™‚é–“è¦æ±‚',0),(379256,10535,'pt','Meu tempo livre solicitaÃ§Ãµes',0),(379257,10535,'ru','ÐœÐ¾Ðµ Ð²Ñ€ÐµÐ¼Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð²',0),(379258,10535,'es','Mis Solicitudes para Tiemp Libre',0),(379259,10535,'de','Meine Freizeit Anfragen',0),(379260,10535,'en','My Time Off Requests',0),(379261,10536,'is','',0),(379262,10536,'dr','Ù„Ø·ÙØ§ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(379263,10536,'pr','Ù„Ø·ÙØ§ ÙƒØ§Ø±Ù…Ù†Ø¯ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(379264,10536,'tr','LÃ¼tfen Ã§alÄ±ÅŸan iÃ§erir',0),(379265,10536,'pl','ProszÄ™ podaÄ‡ pracownika',0),(379266,10536,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(379267,10536,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù…Ù„Ø§Ø²Ù… Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(379268,10536,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(379269,10536,'vi','vui lÃ²ng bao gá»“m nhÃ¢n viÃªn',0),(379270,10536,'af','Sluit asb. \'n Werknemer in',0),(379271,10536,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i angajat',0),(379272,10536,'et','Palun lisage tÃ¶Ã¶taja',0),(379273,10536,'si','Prosimo, da vkljuÄite zaposlenega',0),(379274,10536,'ba','Harap sertakan karyawan',0),(379275,10536,'nl','Gelieve te omvatten werknemer',0),(379276,10536,'fi','LiitÃ¤ tyÃ¶ntekijÃ¤',0),(379277,10536,'no','Ta med ansatte',0),(379278,10536,'da','VedlÃ¦g medarbejder',0),(379279,10536,'ko','ì§ì›ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(379280,10536,'he','×× × ×›×œ×•×œ ×¢×•×‘×“',0),(379281,10536,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(379282,10536,'zh','è¯·åˆ—å…¥é›‡å‘˜\r\n',0),(379283,10536,'sv','VÃ¤nligen inkludera medarbetare',0),(379284,10536,'it','Si prega di includere dipendente',0),(379285,10536,'tl','',0),(379286,10536,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸§à¸¡à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(379287,10536,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(379288,10536,'ms','Sila sertakan pekerja',0),(379289,10536,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ù…ÙˆØ¸Ù',0),(379290,10536,'fr','S\'il vous plaÃ®t inclure employÃ©',0),(379291,10536,'jp','å¾“æ¥­å“¡ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(379292,10536,'pt','Por favor, inclua o funcionÃ¡rio',0),(379293,10536,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(379294,10536,'es','Por Favor Incluye Empleado',0),(379295,10536,'de','Bitte geben Sie Mitarbeiter',0),(379296,10536,'en','Please Include Employee',0),(379297,10537,'is','',0),(379298,10537,'dr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(379299,10537,'pr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(379300,10537,'tr','LÃ¼tfen tÃ¼rÃ¼ ekleyin',0),(379301,10537,'pl','Prosimy o podanie typu',0),(379302,10537,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿',0),(379303,10537,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù‚Ø³Ù… Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(379304,10537,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð²Ñ€ÑÑ‚Ñƒ',0),(379305,10537,'vi','vui lÃ²ng thÃªm loáº¡i',0),(379306,10537,'af','Sluit asseblief Tipe in',0),(379307,10537,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i tip',0),(379308,10537,'et','Palun lisage tÃ¼Ã¼p',0),(379309,10537,'si','Prosimo, da vkljuÄite tipa',0),(379310,10537,'ba','Sertakan tipe',0),(379311,10537,'nl','Gelieve te omvatten Type',0),(379312,10537,'fi','LiitÃ¤ tyyppi',0),(379313,10537,'no','Ta med Type',0),(379314,10537,'da','Inkluder venligst Type',0),(379315,10537,'ko','ìœ í˜•ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(379316,10537,'he','×× × ×›×œ×•×œ ×¡×•×’',0),(379317,10537,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„ÏÏ€Î¿Ï…',0),(379318,10537,'zh','è¯·åˆ—å…¥ç±»åž‹\r\n',0),(379319,10537,'sv','VÃ¤nligen inkludera typ',0),(379320,10537,'it','Si prega di includere tipo',0),(379321,10537,'tl','',0),(379322,10537,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸™à¸´à¸”',0),(379323,10537,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(379324,10537,'ms','Sila sertakan jenis',0),(379325,10537,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ù†ÙˆØ¹',0),(379326,10537,'fr','Veuillez indiquer le Type',0),(379327,10537,'jp','ç¨®é¡žã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(379328,10537,'pt','Por favor inclua o tipo',0),(379329,10537,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿',0),(379330,10537,'es','Por Favor Incluye el Tipo',0),(379331,10537,'de','Bitte geben Sie Typ',0),(379332,10537,'en','Please Include Type',0),(379333,10538,'is','',0),(379334,10538,'dr','Ø¯Ø± Ø®ÙˆØ§Ø³Øª Ù…Ø±Ø®ØµÙŠ ',0),(379335,10538,'pr','Ø¯Ø± Ø®ÙˆØ§Ø³Øª Ù…Ø±Ø®ØµÙŠ ',0),(379336,10538,'tr','Ä°zin isteÄŸi',0),(379337,10538,'pl','Urlopu na Å¼Ä…danie',0),(379338,10538,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð·Ð°ÑÐ²ÐºÐ°',0),(379339,10538,'ur','Ø¯ÙˆØ± Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(379340,10538,'sr','Ð¡Ð»Ð¾Ð±Ð¾Ð´Ð½Ð¾ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(379341,10538,'vi','YÃªu cáº§u táº¯t thá»i gian',0),(379342,10538,'af','Tyd af versoek',0),(379343,10538,'ro','Timp liber cerere',0),(379344,10538,'et','TÃ¶Ã¶lt Ã¤ra taotlus',0),(379345,10538,'si','Izostanek zahtevo',0),(379346,10538,'ba','Waktu Off permintaan',0),(379347,10538,'nl','Verlof verzoek',0),(379348,10538,'fi','PyynnÃ¶n aika',0),(379349,10538,'no','Fritid forespÃ¸rsel',0),(379350,10538,'da','Afspadsering anmodning',0),(379351,10538,'ko','ìš”ì²­ ì‹œê°„',0),(379352,10538,'he','×—×•×¤×© ×‘×§×©×”',0),(379353,10538,'el','Î†Î´ÎµÎ¹Î± Î±Ï€ÏŒ Ï„Î·Î½ Î±Î¯Ï„Î·ÏƒÎ·',0),(379354,10538,'zh','æ—¶é—´è¯·å‡ç”³è¯·\r\n',0),(379355,10538,'sv','Ledighet begÃ¤ran',0),(379356,10538,'it','Tempo libero richiesta',0),(379357,10538,'tl','',0),(379358,10538,'th','à¹€à¸§à¸¥à¸²à¸­à¸­à¸à¸„à¸³à¸‚à¸­',0),(379359,10538,'hi','à¤¸à¤®à¤¯ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¬à¤‚à¤¦',0),(379360,10538,'ms','Masa Off permintaan',0),(379361,10538,'ar','ÙˆÙ‚Øª Ø¥ÙŠÙ‚Ø§Ù Ø§Ù„Ø·Ù„Ø¨',0),(379362,10538,'fr','Demande de congÃ©',0),(379363,10538,'jp','è¦æ±‚ã‚ªãƒ•æ™‚é–“',0),(379364,10538,'pt','Folga do pedido',0),(379365,10538,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(379366,10538,'es','Solicitud para Tienpo Libre',0),(379367,10538,'de','Freistellung von der Anfrage',0),(379368,10538,'en','Time Off Request',0),(379369,10539,'is','',0),(379370,10539,'dr','Ø²Ù…Ø§Ù† Ø´Ø®ØµÙŠ ',0),(379371,10539,'pr','Ø²Ù…Ø§Ù† Ø´Ø®ØµÙŠ ',0),(379372,10539,'tr','KiÅŸisel zaman',0),(379373,10539,'pl','Osobowych czasu',0),(379374,10539,'bg','Ð›Ð¸Ñ‡Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(379375,10539,'ur','Ø°Ø§ØªÛŒ ÙˆÙ‚Øª',0),(379376,10539,'sr','Ð¡Ð»Ð¾Ð±Ð¾Ð´Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(379377,10539,'vi','Thá»i gian cÃ¡ nhÃ¢n',0),(379378,10539,'af','Persoonlike Tyd',0),(379379,10539,'ro','Timp personal',0),(379380,10539,'et','Isiklikku aega',0),(379381,10539,'si','Osebni Äas',0),(379382,10539,'ba','Waktu pribadi',0),(379383,10539,'nl','Persoonlijke tijd',0),(379384,10539,'fi','Oma aika',0),(379385,10539,'no','Personlig tid',0),(379386,10539,'da','Personlige tid',0),(379387,10539,'ko','ê°œì¸ ì‹œê°„',0),(379388,10539,'he','×–×ž×Ÿ ××™×©×™',0),(379389,10539,'el','Î ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÏŒ Ï‡ÏÏŒÎ½Î¿',0),(379390,10539,'zh','ä¸ªäººæ—¶é—´\r\n',0),(379391,10539,'sv','Personliga tid',0),(379392,10539,'it','Tempo personale',0),(379393,10539,'tl','',0),(379394,10539,'th','à¹€à¸§à¸¥à¸²à¸ªà¹ˆà¸§à¸™à¸•à¸±à¸§',0),(379395,10539,'hi','à¤µà¥à¤¯à¤•à¥à¤¤à¤¿à¤—à¤¤ à¤¸à¤®à¤¯',0),(379396,10539,'ms','Masa peribadi',0),(379397,10539,'ar','Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ø´Ø®ØµÙŠ',0),(379398,10539,'fr','Temps personnel',0),(379399,10539,'jp','å€‹äººçš„ãªæ™‚é–“',0),(379400,10539,'pt','Tempo pessoal',0),(379401,10539,'ru','Ð›Ð¸Ñ‡Ð½Ð¾Ðµ Ð’Ñ€ÐµÐ¼Ñ',0),(379402,10539,'es','Tiempo Personal',0),(379403,10539,'de','PersÃ¶nliche Zeit',0),(379404,10539,'en','Personal Time',0),(379405,10540,'is','',0),(379406,10540,'dr','Ø²Ù…Ø§Ù† Ø¨ÙŠÙ…Ø§Ø±ÙŠ',0),(379407,10540,'pr','Ø²Ù…Ø§Ù† Ø¨ÙŠÙ…Ø§Ø±ÙŠ',0),(379408,10540,'tr','Hasta zaman',0),(379409,10540,'pl','Chory czas',0),(379410,10540,'bg','Ð‘Ð¾Ð»Ð½Ð¸ Ð²Ñ€ÐµÐ¼Ðµ',0),(379411,10540,'ur','Ø¨ÛŒÙ…Ø§Ø± ÙˆÙ‚Øª',0),(379412,10540,'sr','Ð’Ñ€ÐµÐ¼ÐµÐ½Ð° Ð·Ð° Ð¾Ð´Ð¼Ð¾Ñ€',0),(379413,10540,'vi','Thá»i gian bá»‹ bá»‡nh',0),(379414,10540,'af','Siek tyd',0),(379415,10540,'ro','Timp de rÄƒu',0),(379416,10540,'et','Haige aeg',0),(379417,10540,'si','Odsotnost z dela',0),(379418,10540,'ba','Waktu sakit',0),(379419,10540,'nl','Ziekteverlof',0),(379420,10540,'fi','Sairasloma',0),(379421,10540,'no','SykefravÃ¦r',0),(379422,10540,'da','Syg tid',0),(379423,10540,'ko','ì•„í”ˆ ì‹œê°„',0),(379424,10540,'he','×–×ž×Ÿ ×ž×—×œ×”',0),(379425,10540,'el','Î‘Î½Î±ÏÏÏ‰Ï„Î¹ÎºÎ®Ï‚ Ï‡ÏÏŒÎ½Î¿',0),(379426,10540,'zh','ç”Ÿç—…çš„æ—¶å€™\r\n',0),(379427,10540,'sv','Sjukledighet',0),(379428,10540,'it','Tempo ammalato',0),(379429,10540,'tl','',0),(379430,10540,'th','à¹€à¸§à¸¥à¸²à¸›à¹ˆà¸§à¸¢',0),(379431,10540,'hi','à¤¬à¥€à¤®à¤¾à¤° à¤¸à¤®à¤¯',0),(379432,10540,'ms','Masa sakit',0),(379433,10540,'ar','Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ù…Ø±Ø¶Ù‰',0),(379434,10540,'fr','CongÃ©s',0),(379435,10540,'jp','ç—…æ¬ ',0),(379436,10540,'pt','Tempo doente',0),(379437,10540,'ru','Ð’Ñ€ÐµÐ¼ÐµÐ½Ð½Ð°Ñ Ð½ÐµÑ‚Ñ€ÑƒÐ´Ð¾ÑÐ¿Ð¾ÑÐ¾Ð±Ð½Ð¾ÑÑ‚ÑŒ',0),(379438,10540,'es','Tiempo de Enermedad',0),(379439,10540,'de','Krankentage',0),(379440,10540,'en','Sick Time',0),(379441,10541,'is','',0),(379442,10541,'dr','ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(379443,10541,'pr','ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(379444,10541,'tr','Ekipman',0),(379445,10541,'pl','SprzÄ™t',0),(379446,10541,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ',0),(379447,10541,'ur','Ø³Ø§Ù…Ø§Ù†',0),(379448,10541,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð°',0),(379449,10541,'vi','Thiáº¿t bá»‹',0),(379450,10541,'af','Toerusting',0),(379451,10541,'ro','Echipamente',0),(379452,10541,'et','Seadmed',0),(379453,10541,'si','Oprema',0),(379454,10541,'ba','Peralatan',0),(379455,10541,'nl','Apparatuur',0),(379456,10541,'fi','Laitteet',0),(379457,10541,'no','Utstyr',0),(379458,10541,'da','Udstyr',0),(379459,10541,'ko','ìž¥ë¹„',0),(379460,10541,'he','×¦×™×•×“',0),(379461,10541,'el','Î•Î¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚',0),(379462,10541,'zh','è®¾å¤‡',0),(379463,10541,'sv','Utrustning',0),(379464,10541,'it','Attrezzature',0),(379465,10541,'tl','',0),(379466,10541,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œ',0),(379467,10541,'hi','à¤‰à¤ªà¤•à¤°à¤£',0),(379468,10541,'ms','Peralatan',0),(379469,10541,'ar','Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(379470,10541,'fr','Ã‰quipement',0),(379471,10541,'jp','æ©Ÿå™¨',0),(379472,10541,'pt','Equipamento',0),(379473,10541,'ru','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(379474,10541,'es','Equipo',0),(379475,10541,'de','AusrÃ¼stung',0),(379476,10541,'en','Equipment',0),(379477,10542,'is','',0),(379478,10542,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(379479,10542,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(379480,10542,'tr','Ekipman Ekle',0),(379481,10542,'pl','Dodaj sprzÄ™t',0),(379482,10542,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ',0),(379483,10542,'ur','Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(379484,10542,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¾Ð¿Ñ€ÐµÐ¼Ðµ',0),(379485,10542,'vi','ThÃªm thiáº¿t bá»‹',0),(379486,10542,'af','Toerusting voeg',0),(379487,10542,'ro','Adauga echipamente',0),(379488,10542,'et','Seadmete lisamine',0),(379489,10542,'si','Dodaj oprema',0),(379490,10542,'ba','Tambahkan peralatan',0),(379491,10542,'nl','Apparatuur toevoegen',0),(379492,10542,'fi','Laitteiden lisÃ¤Ã¤minen',0),(379493,10542,'no','Legge til utstyr',0),(379494,10542,'da','Udstyr tilfÃ¸je',0),(379495,10542,'ko','ìž¥ë¹„ ì¶”ê°€',0),(379496,10542,'he','×œ×”×•×¡×™×£ ×¦×™×•×“',0),(379497,10542,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼Î¿Ï',0),(379498,10542,'zh','æ–°å¢žè®¾å¤‡',0),(379499,10542,'sv','LÃ¤gga till utrustning',0),(379500,10542,'it','Aggiungi attrezzature',0),(379501,10542,'tl','',0),(379502,10542,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¹€à¸žà¸´à¹ˆà¸¡',0),(379503,10542,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(379504,10542,'ms','Menambah peralatan',0),(379505,10542,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ø¯Ø§Øª',0),(379506,10542,'fr','Ajouter des Ã©quipements',0),(379507,10542,'jp','æ©Ÿå™¨ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(379508,10542,'pt','Adicionar o equipamento',0),(379509,10542,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(379510,10542,'es','Agregar Equipo',0),(379511,10542,'de','GerÃ¤te hinzufÃ¼gen',0),(379512,10542,'en','Equipment Add',0),(379513,10543,'is','',0),(379514,10543,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ¬Ù‡ÙŠØ²Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(379515,10543,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ¬Ù‡ÙŠØ²Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(379516,10543,'tr','BaÅŸarÄ±sÄ±zlÄ±k ekipman ekleme',0),(379517,10543,'pl','BÅ‚Ä…d dodawania sprzÄ™tu',0),(379518,10543,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½ÐµÑƒÑÐ¿ÐµÑ…',0),(379519,10543,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Û’ Ú©Ø§ Ø³Ø§Ù…Ø§Ù†',0),(379520,10543,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ Ð¾Ð¿Ñ€ÐµÐ¼Ðµ',0),(379521,10543,'vi','ThÃªm thiáº¿t bá»‹ tháº¥t báº¡i',0),(379522,10543,'af','Mislukking toevoeging van toerusting',0),(379523,10543,'ro','EÅŸecul adÄƒugarea echipamentelor',0),(379524,10543,'et','Rike lisades seadmed',0),(379525,10543,'si','Neuspeh dodajanjem opreme',0),(379526,10543,'ba','Kegagalan menambahkan peralatan',0),(379527,10543,'nl','Mislukking toevoegen van apparatuur',0),(379528,10543,'fi','EpÃ¤onnistuminen lisÃ¤Ã¤mÃ¤llÃ¤ laitteet',0),(379529,10543,'no','Feil Ã¥ legge utstyr',0),(379530,10543,'da','Manglende tilfÃ¸je udstyr',0),(379531,10543,'ko','ì‹¤íŒ¨ ì¶”ê°€ ìž¥ë¹„',0),(379532,10543,'he','×›×©×œ ×”×•×¡×¤×ª ×¦×™×•×“',0),(379533,10543,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼Î¿Ï',0),(379534,10543,'zh','å¢žåŠ è®¾å¤‡å¤±è´¥',0),(379535,10543,'sv','UnderlÃ¥tenhet att lÃ¤gga till utrustning',0),(379536,10543,'it','Mancata aggiunta di attrezzature',0),(379537,10543,'tl','',0),(379538,10543,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¹€à¸žà¸´à¹ˆà¸¡à¸„à¸§à¸²à¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(379539,10543,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤‰à¤ªà¤•à¤°à¤£',0),(379540,10543,'ms','Kegagalan menambah peralatan',0),(379541,10543,'ar','ÙØ´Ù„ Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ø¯Ø§Øª',0),(379542,10543,'fr','Ã‰chec ajout d\'Ã©quipement',0),(379543,10543,'jp','éšœå®³ã®è¿½åŠ æ©Ÿå™¨',0),(379544,10543,'pt','Falha adicionando equipamentos',0),(379545,10543,'ru','Ð¡Ð±Ð¾Ð¹ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(379546,10543,'es','FallÃ³ Agregar Equipo',0),(379547,10543,'de','Fehler HinzufÃ¼gen von Anlagen',0),(379548,10543,'en','Failure Adding Equipment',0),(379549,10544,'is','',0),(379550,10544,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ¬Ù‡ÙŠØ²Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(379551,10544,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ¬Ù‡ÙŠØ²Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(379552,10544,'tr','Ekipman baÅŸarÄ±yla eklendi',0),(379553,10544,'pl','UrzÄ…dzenie pomyÅ›lnie dodane',0),(379554,10544,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(379555,10544,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ú©Ø§ Ø³Ø§Ù…Ø§Ù†',0),(379556,10544,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(379557,10544,'vi','ÄÃ£ thÃªm thiáº¿t bá»‹ thÃ nh cÃ´ng',0),(379558,10544,'af','Gereedskap Suksesvol Bygevoeg',0),(379559,10544,'ro','Echipament adÄƒugat cu succes',0),(379560,10544,'et','Varustus edukalt',0),(379561,10544,'si','Oprema uspeÅ¡no dodani',0),(379562,10544,'ba','Peralatan ditambahkan berhasil',0),(379563,10544,'nl','Apparatuur met succes toegevoegd',0),(379564,10544,'fi','Laitteiden lisÃ¤Ã¤minen onnistui',0),(379565,10544,'no','Utstyr lagt',0),(379566,10544,'da','Udstyr tilfÃ¸jet',0),(379567,10544,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ìž¥ë¹„',0),(379568,10544,'he','×¦×™×•×“ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(379569,10544,'el','Î•Î¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(379570,10544,'zh','è®¾å¤‡æ·»åŠ æˆåŠŸ',0),(379571,10544,'sv','Utrustning lagts',0),(379572,10544,'it','Attrezzature aggiunta con successo',0),(379573,10544,'tl','',0),(379574,10544,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(379575,10544,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(379576,10544,'ms','Peralatan yang berjaya menambah',0),(379577,10544,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„Ù…Ø¹Ø¯Ù‘Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(379578,10544,'fr','Ã‰quipement ajoutÃ© avec succÃ¨s',0),(379579,10544,'jp','æ©Ÿå™¨ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(379580,10544,'pt','Equipamento adicionado com sucesso',0),(379581,10544,'ru','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(379582,10544,'es','Equipo Agregado Exitosamente',0),(379583,10544,'de','AusrÃ¼stung erfolgreich hinzugefÃ¼gt',0),(379584,10544,'en','Equipment Added Successfully',0),(379585,10545,'is','',0),(379586,10545,'dr','Ø­Ø°Ù ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(379587,10545,'pr','Ø­Ø°Ù ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(379588,10545,'tr','Ekipman Sil',0),(379589,10545,'pl','SprzÄ™t do usuwania',0),(379590,10545,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ Ð·Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(379591,10545,'ur','Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(379592,10545,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð¿Ñ€ÐµÐ¼Ðµ',0),(379593,10545,'vi','XÃ³a thiáº¿t bá»‹',0),(379594,10545,'af','Toerusting skrap',0),(379595,10545,'ro','Echipament de ÅŸtergere',0),(379596,10545,'et','Seadme kustutamine',0),(379597,10545,'si','IzbriÅ¡i oprema',0),(379598,10545,'ba','Hapus peralatan',0),(379599,10545,'nl','Apparatuur verwijderen',0),(379600,10545,'fi','Laitteiden poistaminen',0),(379601,10545,'no','Utstyr Slett',0),(379602,10545,'da','Udstyr slet',0),(379603,10545,'ko','ìž¥ë¹„ ì‚­ì œ',0),(379604,10545,'he','×¦×™×•×“ ×ž×—×§',0),(379605,10545,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚',0),(379606,10545,'zh','è®¾å¤‡åˆ é™¤\r\n',0),(379607,10545,'sv','Utrustning ta bort',0),(379608,10545,'it','Eliminazione di apparecchiature',0),(379609,10545,'tl','',0),(379610,10545,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸¥à¸š',0),(379611,10545,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤¹à¤Ÿà¤¾à¤à¤',0),(379612,10545,'ms','Peralatan memadam',0),(379613,10545,'ar','Ø­Ø°Ù Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(379614,10545,'fr','Suppression de l\'Ã©quipement',0),(379615,10545,'jp','æ©Ÿå™¨ã®å‰Šé™¤',0),(379616,10545,'pt','Excluir equipamento',0),(379617,10545,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(379618,10545,'es','Equipo Eliminar',0),(379619,10545,'de','GerÃ¤te lÃ¶schen',0),(379620,10545,'en','Equipment Delete',0),(379621,10546,'is','',0),(379622,10546,'dr','Ø­Ø°Ù ØªØ¬Ù‡ÙŠØ²Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(379623,10546,'pr','Ø­Ø°Ù ØªØ¬Ù‡ÙŠØ²Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(379624,10546,'tr','BaÅŸarÄ±sÄ±z silme ekipmanlarÄ±',0),(379625,10546,'pl','Usuwanie awarii sprzÄ™tu',0),(379626,10546,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ',0),(379627,10546,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ø­Ø°Ù Ú©Ø±Ù†Û’ Ú©Ø§ Ø³Ø§Ù…Ø§Ù†',0),(379628,10546,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ° Ð¾Ð¿Ñ€ÐµÐ¼Ðµ',0),(379629,10546,'vi','XÃ³a thiáº¿t bá»‹ tháº¥t báº¡i',0),(379630,10546,'af','Mislukking skrap toerusting',0),(379631,10546,'ro','EÅŸecul echipamente ÅŸtergerea',0),(379632,10546,'et','TÃµrge kustutamisel seadmed',0),(379633,10546,'si','Brisanje okvare opreme',0),(379634,10546,'ba','Kegagalan menghapus peralatan',0),(379635,10546,'nl','Mislukking verwijderen apparatuur',0),(379636,10546,'fi','Virhe poistettaessa laitteet',0),(379637,10546,'no','Feil slette utstyr',0),(379638,10546,'da','Manglende slette udstyr',0),(379639,10546,'ko','ì‹¤íŒ¨ ì‚­ì œ ìž¥ë¹„',0),(379640,10546,'he','×¦×™×•×“ ×‘×ž×—×™×§×ª ×›×©×œ',0),(379641,10546,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚',0),(379642,10546,'zh','åˆ é™¤è®¾å¤‡å¤±è´¥',0),(379643,10546,'sv','Fel ta bort utrustning',0),(379644,10546,'it','Apparecchiatura di eliminazione guasto',0),(379645,10546,'tl','',0),(379646,10546,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(379647,10546,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤‰à¤ªà¤•à¤°à¤£à¥‹à¤‚',0),(379648,10546,'ms','Kegagalan peralatan menghapuskan',0),(379649,10546,'ar','ÙØ´Ù„ Ø­Ø°Ù Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(379650,10546,'fr','Panne matÃ©riel suppression',0),(379651,10546,'jp','å¤±æ•—ã—ãŸå‰Šé™¤ã™ã‚‹è£…ç½®',0),(379652,10546,'pt','Equipamento de falha excluindo',0),(379653,10546,'ru','Ð¡Ð±Ð¾Ð¹ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(379654,10546,'es','FallÃ³ Eliminar Equipo',0),(379655,10546,'de','Fehler lÃ¶schen von AusrÃ¼stung',0),(379656,10546,'en','Failure Deleting Equipment',0),(379657,10547,'is','',0),(379658,10547,'dr','Ø­Ø°Ù ØªØ¬Ù‡ÙŠØ²Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(379659,10547,'pr','Ø­Ø°Ù ØªØ¬Ù‡ÙŠØ²Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(379660,10547,'tr','Ekipman baÅŸarÄ±yla silindi',0),(379661,10547,'pl','SprzÄ™t przesâ”‚anie',0),(379662,10547,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(379663,10547,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ø´Ø¯Û Ø³Ø§Ù…Ø§Ù†',0),(379664,10547,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(379665,10547,'vi','XÃ³a thiáº¿t bá»‹ thÃ nh cÃ´ng',0),(379666,10547,'af','Gereedskap Suksesvol Geskrap',0),(379667,10547,'ro','Echipament eliminÄƒ cu succes',0),(379668,10547,'et','Seadmed edukalt kustutatud',0),(379669,10547,'si','Oprema uspeÅ¡no izbrisana',0),(379670,10547,'ba','Peralatan dihapus berhasil',0),(379671,10547,'nl','Apparatuur met succes verwijderd',0),(379672,10547,'fi','Laite poistettu',0),(379673,10547,'no','Utstyr slettet',0),(379674,10547,'da','Udstyr slettet',0),(379675,10547,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ìž¥ë¹„',0),(379676,10547,'he','×¦×™×•×“ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(379677,10547,'el','Î•Î¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(379678,10547,'zh','è®¾å¤‡æˆåŠŸåˆ é™¤',0),(379679,10547,'sv','Utrustning raderades',0),(379680,10547,'it','Attrezzature eliminata con successo',0),(379681,10547,'tl','',0),(379682,10547,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(379683,10547,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤‰à¤ªà¤•à¤°à¤£',0),(379684,10547,'ms','Peralatan yang dihapuskan dengan jayanya',0),(379685,10547,'ar','Ø­Ø°ÙØª Ø§Ù„Ù…Ø¹Ø¯Ù‘Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(379686,10547,'fr','Ã‰quipement supprimÃ© avec succÃ¨s',0),(379687,10547,'jp','è£…ç½®ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(379688,10547,'pt','Equipamento apagado com sucesso',0),(379689,10547,'ru','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(379690,10547,'es','Equipo Eliminado Exitosamente',0),(379691,10547,'de','AusrÃ¼stung erfolgreich gelÃ¶scht',0),(379692,10547,'en','Equipment Deleted Successfully',0),(379693,10548,'is','',0),(379694,10548,'dr','(Ø§Ø«Ø§Ø«Ù‡',0),(379695,10548,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªØ¬Ù‡ÙŠØ²Ø§Øª(Ø§Ø«Ø§Ø«Ù‡',0),(379696,10548,'tr','DonanÄ±m GÃ¼ncelleÅŸtirme',0),(379697,10548,'pl','Aktualizacja urzÄ…dzenia',0),(379698,10548,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(379699,10548,'ur','Ø³Ø§Ù…Ø§Ù† ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(379700,10548,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¾Ð¿Ñ€ÐµÐ¼Ðµ',0),(379701,10548,'vi','Cáº­p nháº­t thiáº¿t bá»‹',0),(379702,10548,'af','Toerusting werk',0),(379703,10548,'ro','Echipament de actualizare',0),(379704,10548,'et','Seadmete vÃ¤rskendamine',0),(379705,10548,'si','Posodobitev opreme',0),(379706,10548,'ba','Peralatan Update',0),(379707,10548,'nl','Apparatuur Update',0),(379708,10548,'fi','Laitteiden pÃ¤ivitys',0),(379709,10548,'no','Utstyr oppdatering',0),(379710,10548,'da','Udstyr opdatering',0),(379711,10548,'ko','ìž¥ë¹„ ì—…ë°ì´íŠ¸',0),(379712,10548,'he','×¢×“×›×•×Ÿ ×¦×™×•×“',0),(379713,10548,'el','Î•Î¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(379714,10548,'zh','è®¾å¤‡æ›´æ–°',0),(379715,10548,'sv','Utrustning uppdatering',0),(379716,10548,'it','Aggiornamento di attrezzature',0),(379717,10548,'tl','',0),(379718,10548,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸­à¸¸à¸›à¸à¸£à¸“à¹Œ',0),(379719,10548,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(379720,10548,'ms','Kemaskini peralatan',0),(379721,10548,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(379722,10548,'fr','Mise Ã  jour de l\'Ã©quipement',0),(379723,10548,'jp','æ©Ÿå™¨æ›´æ–°',0),(379724,10548,'pt','AtualizaÃ§Ã£o de equipamentos',0),(379725,10548,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(379726,10548,'es','Equipo Actualizar',0),(379727,10548,'de','GerÃ¤te-Update',0),(379728,10548,'en','Equipment Update',0),(379729,10549,'is','',0),(379730,10549,'dr','(Ø§Ø«Ø§Ø«Ù‡ ) Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(379731,10549,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªØ¬Ù‡ÙŠØ²Ø§Øª(Ø§Ø«Ø§Ø«Ù‡ ) Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(379732,10549,'tr','BaÅŸarÄ±sÄ±z gÃ¼ncelleÅŸtirme ekipmanlarÄ±',0),(379733,10549,'pl','Brak aktualizacji sprzÄ™tu',0),(379734,10549,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(379735,10549,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ø³Ø§Ù…Ø§Ù† ØªØ§Ø²Û Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(379736,10549,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¾Ð¿Ñ€ÐµÐ¼Ðµ',0),(379737,10549,'vi','Cáº­p nháº­t thiáº¿t bá»‹ tháº¥t báº¡i',0),(379738,10549,'af','Mislukking Outobywerking toerusting',0),(379739,10549,'ro','EÅŸecul echipamente actualizarea',0),(379740,10549,'et','TÃµrge vÃ¤rskendamisel seadmed',0),(379741,10549,'si','Neuspeh posodabljanje opreme',0),(379742,10549,'ba','Kegagalan memperbarui peralatan',0),(379743,10549,'nl','Fout bijwerken apparatuur',0),(379744,10549,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ laitteet',0),(379745,10549,'no','Feil oppdatering utstyr',0),(379746,10549,'da','Manglende opdatering udstyr',0),(379747,10549,'ko','ì‹¤íŒ¨ ì—…ë°ì´íŠ¸ ìž¥ë¹„',0),(379748,10549,'he','×¦×™×•×“ ×”×ž×¢×“×›× ×ª ×›×©×œ',0),(379749,10549,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚',0),(379750,10549,'zh','è®¾å¤‡æ›´æ–°å¤±è´¥',0),(379751,10549,'sv','Fel uppdatering utrustning',0),(379752,10549,'it','Mancato aggiornamento attrezzature',0),(379753,10549,'tl','',0),(379754,10549,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(379755,10549,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤‰à¤ªà¤•à¤°à¤£',0),(379756,10549,'ms','Kegagalan mengemaskini peralatan',0),(379757,10549,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(379758,10549,'fr','Ã‰chec mise Ã  jour matÃ©riel',0),(379759,10549,'jp','å¤±æ•—ã—ãŸæ›´æ–°è£…ç½®',0),(379760,10549,'pt','Equipamento de falha atualizaÃ§Ã£o',0),(379761,10549,'ru','Ð¡Ð±Ð¾Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(379762,10549,'es','FallÃ³ Actualizar Equipo',0),(379763,10549,'de','Fehler Update AusrÃ¼stung',0),(379764,10549,'en','Failure Updating Equipment',0),(379765,10550,'is','',0),(379766,10550,'dr','(Ø§Ø«Ø§Ø«Ù‡ ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(379767,10550,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªØ¬Ù‡ÙŠØ²Ø§Øª(Ø§Ø«Ø§Ø«Ù‡ ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(379768,10550,'tr','Ekipman baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(379769,10550,'pl','UrzÄ…dzenie pomyÅ›lnie zaktualizowana',0),(379770,10550,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(379771,10550,'ur','Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(379772,10550,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(379773,10550,'vi','Cáº­p nháº­t thiáº¿t bá»‹ thÃ nh cÃ´ng',0),(379774,10550,'af','Gereedskap Suksesvol Opdateer',0),(379775,10550,'ro','Echipament actualizat cu succes',0),(379776,10550,'et','Seadmete vÃ¤rskendamine Ãµnnestus',0),(379777,10550,'si','Oprema, ki je uspeÅ¡no posodobljena',0),(379778,10550,'ba','Peralatan yang berhasil',0),(379779,10550,'nl','Apparatuur met succes bijgewerkt',0),(379780,10550,'fi','Laitteiden pÃ¤ivitetty',0),(379781,10550,'no','Utstyr oppdatert',0),(379782,10550,'da','Udstyr opdateret',0),(379783,10550,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ìž¥ë¹„',0),(379784,10550,'he','×¦×™×•×“ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(379785,10550,'el','Î•Î¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(379786,10550,'zh','è®¾å¤‡æ›´æ–°æˆåŠŸ',0),(379787,10550,'sv','Utrustning uppdaterats',0),(379788,10550,'it','Attrezzature aggiornata con successo',0),(379789,10550,'tl','',0),(379790,10550,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(379791,10550,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤‰à¤ªà¤•à¤°à¤£',0),(379792,10550,'ms','Peralatan yang berjaya dikemas kini',0),(379793,10550,'ar','Ø­Ø¯Ù‘Ø«Øª Ø§Ù„Ù…Ø¹Ø¯Ù‘Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(379794,10550,'fr','MatÃ©riel mise Ã  jour avec succÃ¨s',0),(379795,10550,'jp','è£…ç½®ãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(379796,10550,'pt','Equipamento atualizado com sucesso',0),(379797,10550,'ru','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(379798,10550,'es','Equipo Agregado Exitosamente',0),(379799,10550,'de','AusrÃ¼stung, die erfolgreich aktualisiert',0),(379800,10550,'en','Equipment Updated Successfully',0),(379801,10551,'is','',0),(379802,10551,'dr','/ Ø¢Ù¾Ø¯ÛŒØª  ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(379803,10551,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(379804,10551,'tr','DonanÄ±m Ekleme/GÃ¼ncelleme',0),(379805,10551,'pl','SprzÄ™t Dodaj/Aktualizuj',0),(379806,10551,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(379807,10551,'ur','Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(379808,10551,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð°/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ.',0),(379809,10551,'vi','Thiáº¿t bá»‹ thÃªm/Cáº­p Nháº­t',0),(379810,10551,'af','Toerusting voeg/opdatering',0),(379811,10551,'ro','Echipament AdÄƒugaÅ£i/actualizaÅ£i',0),(379812,10551,'et','Seadmete lisamine/uuendamine',0),(379813,10551,'si','Oprema Dodaj/posodobi',0),(379814,10551,'ba','Alat Tambahkan/Perbarui',0),(379815,10551,'nl','Apparatuur toevoegen/bijwerken',0),(379816,10551,'fi','Laitteet lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(379817,10551,'no','Utstyr/Oppdater',0),(379818,10551,'da','Udstyr TilfÃ¸j/opdater',0),(379819,10551,'ko','ìž¥ë¹„ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(379820,10551,'he','×¦×™×•×“ ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(379821,10551,'el','Î•Î¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(379822,10551,'zh','è®¾å¤‡æ–°å¢ž/æ›´æ–°',0),(379823,10551,'sv','Utrustning fÃ¶r LÃ¤gg till/uppdatera',0),(379824,10551,'it','Attrezzature aggiungere/aggiornare',0),(379825,10551,'tl','',0),(379826,10551,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(379827,10551,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(379828,10551,'ms','Peralatan Tambah/Kemaskini',0),(379829,10551,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(379830,10551,'fr','Ã‰quipement ajouter/mettre Ã  jour',0),(379831,10551,'jp','æ©Ÿå™¨ã‚’è¿½åŠ /æ›´æ–°',0),(379832,10551,'pt','Equipamento adicionar/atualizar',0),(379833,10551,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(379834,10551,'es','Equipo Agregar/Actualizar',0),(379835,10551,'de','GerÃ¤te hinzufÃ¼gen/aktualisieren',0),(379836,10551,'en','Equipment Add/Update',0),(379837,10552,'is','',0),(379838,10552,'dr','Ø§Ø³Ù†Ø§Ø¯ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(379839,10552,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(379840,10552,'tr','YapÄ± belgeleri',0),(379841,10552,'pl','Dokumenty budowy',0),(379842,10552,'bg','Ð¡Ñ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»Ð½Ð¸ ÐºÐ½Ð¸Ð¶Ð°',0),(379843,10552,'ur','Ø¹Ù…Ø§Ø±Øª Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(379844,10552,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð°',0),(379845,10552,'vi','TÃ i liá»‡u xÃ¢y dá»±ng',0),(379846,10552,'af','Gebou dokumente',0),(379847,10552,'ro','Constructii documente',0),(379848,10552,'et','Hoone dokumendid',0),(379849,10552,'si','Stavbe dokumentov',0),(379850,10552,'ba','Bangunan dokumen',0),(379851,10552,'nl','Gebouw documenten',0),(379852,10552,'fi','Rakennuksen asiakirjat',0),(379853,10552,'no','Bygningen dokumenter',0),(379854,10552,'da','Bygning dokumenter',0),(379855,10552,'ko','ê±´ë¬¼ ë¬¸ì„œ',0),(379856,10552,'he','×‘× ×™×™×Ÿ ×ž×¡×ž×›×™×',0),(379857,10552,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Î­Î³Î³ÏÎ±Ï†Î±',0),(379858,10552,'zh','å»ºè®¾æ–‡ä»¶\r\n',0),(379859,10552,'sv','Byggnaden dokument',0),(379860,10552,'it','Documenti di costruzione',0),(379861,10552,'tl','',0),(379862,10552,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹€à¸­à¸à¸ªà¸²à¸£',0),(379863,10552,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚',0),(379864,10552,'ms','Dokumen-dokumen bangunan',0),(379865,10552,'ar','ÙˆØ«Ø§Ø¦Ù‚ Ø¨Ù†Ø§Ø¡',0),(379866,10552,'fr','Documents de construction',0),(379867,10552,'jp','å»ºç‰©ã®ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ',0),(379868,10552,'pt','Documentos de construÃ§Ã£o',0),(379869,10552,'ru','Ð¡Ñ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(379870,10552,'es','Documentos de Edificio',0),(379871,10552,'de','GebÃ¤ude-Dokumente',0),(379872,10552,'en','Building Documents',0),(379873,10553,'is','',0),(379874,10553,'dr','Ø§Ø³Ù†Ø§Ø¯ ÙˆØ§Ø­Ø¯ ',0),(379875,10553,'pr','Ø§Ø³Ù†Ø§Ø¯ ÙˆØ§Ø­Ø¯ ',0),(379876,10553,'tr','Birim belgeler',0),(379877,10553,'pl','Jednostka dokumentÃ³w',0),(379878,10553,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(379879,10553,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(379880,10553,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð°',0),(379881,10553,'vi','ÄÆ¡n vá»‹ tÃ i liá»‡u',0),(379882,10553,'af','Eenheid Dokumente',0),(379883,10553,'ro','Unitate de documente',0),(379884,10553,'et','Ãœksuse dokumendid',0),(379885,10553,'si','Enota dokumentov',0),(379886,10553,'ba','Unit iklim dokumen',0),(379887,10553,'nl','Eenheid documenten',0),(379888,10553,'fi','YksikkÃ¶ asiakirjat',0),(379889,10553,'no','Enheten dokumenter',0),(379890,10553,'da','Enhed dokumenter',0),(379891,10553,'ko','ë‹¨ìœ„ ë¬¸ì„œ',0),(379892,10553,'he','×™×—×™×“×ª ×ž×¡×ž×›×™×',0),(379893,10553,'el','ÎœÎ¿Î½Î¬Î´Î± Î­Î³Î³ÏÎ±Ï†Î±',0),(379894,10553,'zh','å•ä½æ–‡ä»¶\r\n',0),(379895,10553,'sv','Enhet dokument',0),(379896,10553,'it','Documenti di unitÃ ',0),(379897,10553,'tl','',0),(379898,10553,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¸«à¸™à¹ˆà¸§à¸¢',0),(379899,10553,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚',0),(379900,10553,'ms','Dokumen-dokumen unit',0),(379901,10553,'ar','ÙˆØ«Ø§Ø¦Ù‚ Ø§Ù„ÙˆØ­Ø¯Ø©',0),(379902,10553,'fr','Documents de l\'unitÃ©',0),(379903,10553,'jp','å˜ä½“ã®ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ',0),(379904,10553,'pt','Documentos da unidade',0),(379905,10553,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(379906,10553,'es','Documentos del Unidad',0),(379907,10553,'de','Einheit-Dokumente',0),(379908,10553,'en','Unit Documents',0),(379909,10554,'is','',0),(379910,10554,'dr','Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(379911,10554,'pr','Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(379912,10554,'tr','YazdÄ±rma PO',0),(379913,10554,'pl','Drukowanie PO',0),(379914,10554,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° PO',0),(379915,10554,'ur','Ù¾Ùˆ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(379916,10554,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ ÐŸÐž',0),(379917,10554,'vi','in Ä‘Æ¡n mua hÃ ng',0),(379918,10554,'af','Druk AB',0),(379919,10554,'ro','Print op',0),(379920,10554,'et','Prindi PO',0),(379921,10554,'si','Tiskanje PO',0),(379922,10554,'ba','Cetak PO',0),(379923,10554,'nl','Afdrukken PO',0),(379924,10554,'fi','Tulosta PO',0),(379925,10554,'no','Skrive ut PO',0),(379926,10554,'da','Udskrive PO',0),(379927,10554,'ko','ì¸ì‡„ í¬',0),(379928,10554,'he','×”×“×¤×¡×” ×¤×•',0),(379929,10554,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· PO',0),(379930,10554,'zh','æ‰“å°è®¢å•\r\n',0),(379931,10554,'sv','Skriva ut PO',0),(379932,10554,'it','Stampa PO',0),(379933,10554,'tl','',0),(379934,10554,'th','à¸žà¸´à¸¡à¸žà¹Œ PO',0),(379935,10554,'hi','PO à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(379936,10554,'ms','Cetak PO',0),(379937,10554,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¨Ùˆ',0),(379938,10554,'fr','Imprimer PO',0),(379939,10554,'jp','PO ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(379940,10554,'pt','Imprimir PO',0),(379941,10554,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ PO',0),(379942,10554,'es','Imprimir OC',0),(379943,10554,'de','PO zu drucken',0),(379944,10554,'en','Print PO',0),(379945,10555,'is','',0),(379946,10555,'dr','(Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ)',0),(379947,10555,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ú¯Ø±ÙŠ (Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ)',0),(379948,10555,'tr','Umudu ayrÄ±ntÄ±larÄ±',0),(379949,10555,'pl','SzczegÃ³Å‚y perspektywa',0),(379950,10555,'bg','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°Ñ‚Ð° Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(379951,10555,'ur','Ø§Ù…Ú©Ø§Ù† Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(379952,10555,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¾ Ð¸Ð·Ð³Ð»ÐµÐ´Ð¸Ð¼Ð°',0),(379953,10555,'vi','KhÃ¡ch hÃ ng tiá»m nÄƒng chi tiáº¿t',0),(379954,10555,'af','Voornemende KliÃ«nt Details',0),(379955,10555,'ro','Perspectiva detalii',0),(379956,10555,'et','Potentsiaalse kliendi andmed',0),(379957,10555,'si','MoÅ¾nost podrobnosti',0),(379958,10555,'ba','Prospek rincian',0),(379959,10555,'nl','Vooruitzicht Details',0),(379960,10555,'fi','Prospektin tiedot',0),(379961,10555,'no','Prospektet detaljer',0),(379962,10555,'da','Udsigten detaljer',0),(379963,10555,'ko','ì „ë§ ì„¸ë¶€ ì‚¬í•­',0),(379964,10555,'he','×¤×¨×•×¡×¤×§×˜ ×¤×¨×˜×™×',0),(379965,10555,'el','Î ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ® Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(379966,10555,'zh','å±•æœ›è¯¦æƒ…\r\n',0),(379967,10555,'sv','Prospect Detaljer',0),(379968,10555,'it','Prospettiva dettagli',0),(379969,10555,'tl','',0),(379970,10555,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸‚à¸­à¸‡à¹‚à¸­à¸à¸²à¸ª',0),(379971,10555,'hi','à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(379972,10555,'ms','Maklumat prospek',0),(379973,10555,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ø­ØªÙ…Ø§Ù„',0),(379974,10555,'fr','DÃ©tails de la perspective',0),(379975,10555,'jp','è¦‹é€šã—ã®è©³ç´°',0),(379976,10555,'pt','Detalhes da perspectiva',0),(379977,10555,'ru','ÐŸÑ€Ð¾ÑÐ¿ÐµÐºÑ‚ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(379978,10555,'es','Detalles de Cliente Potencial',0),(379979,10555,'de','Aussicht auf Details',0),(379980,10555,'en','Prospect Details',0),(379981,10556,'is','',0),(379982,10556,'dr','(ØºØ±Ø¨Ø§Ù„ Ø²Ù†ÙŠ',0),(379983,10556,'pr','Ù†Ù…Ø§ÙŠØ´(ØºØ±Ø¨Ø§Ù„ Ø²Ù†ÙŠ',0),(379984,10556,'tr','Eleme',0),(379985,10556,'pl','Badania przesiewowe',0),(379986,10556,'bg','Ð¡ÐºÑ€Ð¸Ð½Ð¸Ð½Ð³',0),(379987,10556,'ur','Ø§Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯',0),(379988,10556,'sr','Ð¡ÐºÑ€Ð¸Ð½Ð¸Ð½Ð³',0),(379989,10556,'vi','Kiá»ƒm tra',0),(379990,10556,'af','Keuring',0),(379991,10556,'ro','Screening-ul',0),(379992,10556,'et','SÃµelumine',0),(379993,10556,'si','Pregled',0),(379994,10556,'ba','Skrining',0),(379995,10556,'nl','Screening',0),(379996,10556,'fi','Seulonta',0),(379997,10556,'no','Screening',0),(379998,10556,'da','Screening',0),(379999,10556,'ko','ì‹¬ì‚¬',0),(380000,10556,'he','×”×”×§×¨× ×”',0),(380001,10556,'el','Î ÏÎ¿ÏƒÏ…Î¼Ï€Ï„Ï‰Î¼Î±Ï„Î¹ÎºÎ¿Ï ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(380002,10556,'zh','ç­›é€‰\r\n',0),(380003,10556,'sv','Screening',0),(380004,10556,'it','Screening',0),(380005,10556,'tl','',0),(380006,10556,'th','à¸•à¸£à¸§à¸ˆà¸„à¸±à¸”à¸à¸£à¸­à¸‡',0),(380007,10556,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤—',0),(380008,10556,'ms','Saringan',0),(380009,10556,'ar','Ø§Ù„ÙØ±Ø²',0),(380010,10556,'fr','DÃ©pistage',0),(380011,10556,'jp','ã‚¹ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°',0),(380012,10556,'pt','Triagem',0),(380013,10556,'ru','Ð¡ÐºÑ€Ð¸Ð½Ð¸Ð½Ð³',0),(380014,10556,'es','AnÃ¡lisis',0),(380015,10556,'de','Screening',0),(380016,10556,'en','Screening',0),(380017,10557,'is','',0),(380018,10557,'dr','(ØºØ±Ø¨Ø§Ù„ Ø²Ù†ÙŠ',0),(380019,10557,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù†Ù…Ø§ÙŠØ´(ØºØ±Ø¨Ø§Ù„ Ø²Ù†ÙŠ',0),(380020,10557,'tr','Tarama yÃ¶nergeleri',0),(380021,10557,'pl','Przesiewowych',0),(380022,10557,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(380023,10557,'ur','Ø§Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯ Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(380024,10557,'sr','Ð¡ÐºÑ€Ð¸Ð½Ð¸Ð½Ð³ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(380025,10557,'vi','SÃ n lá»c nhá»¯ng sá»± hÆ°á»›ng dáº«n',0),(380026,10557,'af','Keuringsinstruksies',0),(380027,10557,'ro','InstrucÅ£iuni de screening',0),(380028,10557,'et','SÃµeluuringu juhiseid',0),(380029,10557,'si','Prebiranje navodili',0),(380030,10557,'ba','Skrining petunjuk',0),(380031,10557,'nl','Screening instructies',0),(380032,10557,'fi','Seulonta ohjeet',0),(380033,10557,'no','Screening instruksjoner',0),(380034,10557,'da','Screening instruktioner',0),(380035,10557,'ko','ì‹¬ì‚¬ ì§€ì¹¨',0),(380036,10557,'he','×”× ×—×™×•×ª ×”×”×§×¨× ×”',0),(380037,10557,'el','Î ÏÎ¿Î²Î¿Î»Î® Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(380038,10557,'zh','ç­›é€‰è¯´æ˜Ž\r\n',0),(380039,10557,'sv','Screening instruktioner',0),(380040,10557,'it','Istruzioni di screening',0),(380041,10557,'tl','',0),(380042,10557,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸„à¸±à¸”à¸à¸£à¸­à¸‡',0),(380043,10557,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤— à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(380044,10557,'ms','Arahan pemeriksaan',0),(380045,10557,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„ÙØ­Øµ',0),(380046,10557,'fr','Instructions de contrÃ´le',0),(380047,10557,'jp','ã‚¹ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°ã®æŒ‡ç¤º',0),(380048,10557,'pt','InstruÃ§Ãµes de seleÃ§Ã£o',0),(380049,10557,'ru','Ð¡ÐºÑ€Ð¸Ð½Ð¸Ð½Ð³ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(380050,10557,'es','Instrucciones e AnÃ¡lisis',0),(380051,10557,'de','Screening-Anweisungen',0),(380052,10557,'en','Screening Instructions',0),(380053,10558,'is','',0),(380054,10558,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø³ØªØ§Ø¬Ø± ',0),(380055,10558,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ù…Ø³ØªØ§Ø¬Ø± ',0),(380056,10558,'tr','KiracÄ± ayrÄ±ntÄ±larÄ±',0),(380057,10558,'pl','SzczegÃ³Å‚y najemcy',0),(380058,10558,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(380059,10558,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(380060,10558,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(380061,10558,'vi','Chi tiáº¿t ngÆ°á»i thuÃª nhÃ ',0),(380062,10558,'af','Huurder Besonderhede',0),(380063,10558,'ro','ChiriaÅŸ detalii',0),(380064,10558,'et','Rentniku andmed',0),(380065,10558,'si','Najemnik podrobnosti',0),(380066,10558,'ba','Penyewa rincian',0),(380067,10558,'nl','Huurder Details',0),(380068,10558,'fi','Vuokralainen tiedot',0),(380069,10558,'no','Leietaker detaljer',0),(380070,10558,'da','Lejer detaljer',0),(380071,10558,'ko','ê±°ì£¼ìž ì •ë³´',0),(380072,10558,'he','×¤×¨×˜×™ ×”×©×•×›×¨',0),(380073,10558,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï„Î¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(380074,10558,'zh','ä¸šæƒäººè¯¦æƒ…\r\n',0),(380075,10558,'sv','HyresgÃ¤sten Detaljer',0),(380076,10558,'it','Inquilino dettagli',0),(380077,10558,'tl','',0),(380078,10558,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(380079,10558,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤µà¤¿à¤µà¤°à¤£',0),(380080,10558,'ms','Maklumat penyewa',0),(380081,10558,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(380082,10558,'fr','DÃ©tails du locataire',0),(380083,10558,'jp','ãƒ†ãƒŠãƒ³ãƒˆã®å†…å®¹',0),(380084,10558,'pt','Detalhes de inquilino',0),(380085,10558,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(380086,10558,'es','Detalles de Inquilino',0),(380087,10558,'de','Mieter-Informationen',0),(380088,10558,'en','Tenant Details',0),(380089,10559,'is','',0),(380090,10559,'dr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯',0),(380091,10559,'pr','ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯',0),(380092,10559,'tr','Birimlerin dikkatine',0),(380093,10559,'pl','DostÄ™pne jednostki',0),(380094,10559,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(380095,10559,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ ÛŒÙˆÙ†Ù¹Ø³',0),(380096,10559,'sr','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(380097,10559,'vi','ÄÆ¡n vá»‹ cÃ³ sáºµn',0),(380098,10559,'af','Beskikbare Eenhede',0),(380099,10559,'ro','Disponibile unitÄƒÅ£i',0),(380100,10559,'et','Saadaolevate mÃµÃµtÃ¼hikute',0),(380101,10559,'si','Na voljo enote',0),(380102,10559,'ba','Tersedia unit',0),(380103,10559,'nl','Beschikbare eenheden',0),(380104,10559,'fi','Saatavilla olevista',0),(380105,10559,'no','Tilgjengelige enheter',0),(380106,10559,'da','TilgÃ¦ngelige enheder',0),(380107,10559,'ko','ì‚¬ìš© ê°€ëŠ¥í•œ ë‹¨ìœ„',0),(380108,10559,'he','×”×™×—×™×“×•×ª ×”×¤× ×•×™×•×ª',0),(380109,10559,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼ÎµÏ‚ Î¼Î¿Î½Î¬Î´ÎµÏ‚',0),(380110,10559,'zh','å¯ç”¨å•ä½\r\n',0),(380111,10559,'sv','TillgÃ¤ngliga enheter',0),(380112,10559,'it','UnitÃ  disponibili',0),(380113,10559,'tl','',0),(380114,10559,'th','à¸«à¸™à¹ˆà¸§à¸¢à¸‡à¸²à¸™à¸¡à¸µ',0),(380115,10559,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(380116,10559,'ms','Unit-unit disediakan',0),(380117,10559,'ar','Ø§Ù„ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(380118,10559,'fr','UnitÃ©s disponible',0),(380119,10559,'jp','åˆ©ç”¨å¯èƒ½ãªãƒ¦ãƒ‹ãƒƒãƒˆ',0),(380120,10559,'pt','Unidades disponÃ­veis',0),(380121,10559,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(380122,10559,'es','Unidades Disponibles',0),(380123,10559,'de','VerfÃ¼gbaren Einheiten',0),(380124,10559,'en','Available Units',0),(380125,10560,'is','',0),(380126,10560,'dr','(Ø§Ù†ØªØµØ§Ø¨',0),(380127,10560,'pr','Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª(Ø§Ù†ØªØµØ§Ø¨',0),(380128,10560,'tr','Randevu',0),(380129,10560,'pl','Termin',0),(380130,10560,'bg','Ð¡Ñ€ÐµÑ‰Ð°',0),(380131,10560,'ur','ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª',0),(380132,10560,'sr','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð° Ð¾Ð±Ð°Ð²ÐµÐ·Ð°',0),(380133,10560,'vi','Cuá»™c háº¹n',0),(380134,10560,'af','Afspraak',0),(380135,10560,'ro','Numirea',0),(380136,10560,'et','Kohtumine',0),(380137,10560,'si','Sestanek',0),(380138,10560,'ba','Janji temu',0),(380139,10560,'nl','Afspraak',0),(380140,10560,'fi','Tapaaminen',0),(380141,10560,'no','Avtale',0),(380142,10560,'da','UdnÃ¦vnelse',0),(380143,10560,'ko','ì•½ì†',0),(380144,10560,'he','×¤×’×™×©×”',0),(380145,10560,'el','Î¡Î±Î½Ï„ÎµÎ²Î¿Ï',0),(380146,10560,'zh','çº¦ä¼š\r\n',0),(380147,10560,'sv','Avtalad tid',0),(380148,10560,'it','Appuntamento',0),(380149,10560,'tl','',0),(380150,10560,'th','à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(380151,10560,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ',0),(380152,10560,'ms','Pelantikan',0),(380153,10560,'ar','Ù…ÙˆØ¹Ø¯',0),(380154,10560,'fr','Nomination',0),(380155,10560,'jp','äºˆå®š',0),(380156,10560,'pt','NomeaÃ§Ã£o',0),(380157,10560,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(380158,10560,'es','Cita',0),(380159,10560,'de','Termin',0),(380160,10560,'en','Appointment',0),(380161,10561,'is','',0),(380162,10561,'dr','Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª',0),(380163,10561,'pr','Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª',0),(380164,10561,'tr','Ä°letiÅŸim',0),(380165,10561,'pl','Komunikacji',0),(380166,10561,'bg','ÐšÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(380167,10561,'ur','Ù…ÙˆØ§ØµÙ„Ø§Øª',0),(380168,10561,'sr','ÐšÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(380169,10561,'vi','sá»± giao tiáº¿p',0),(380170,10561,'af','Kommunikasie',0),(380171,10561,'ro','ComunicaÅ£ii',0),(380172,10561,'et','Side',0),(380173,10561,'si','Komunikacije',0),(380174,10561,'ba','Komunikasi',0),(380175,10561,'nl','Communicatie',0),(380176,10561,'fi','ViestinnÃ¤n',0),(380177,10561,'no','Kommunikasjon',0),(380178,10561,'da','Kommunikation',0),(380179,10561,'ko','í†µì‹ ',0),(380180,10561,'he','×ª×§×©×•×¨×ª',0),(380181,10561,'el','Î•Ï€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÏŽÎ½',0),(380182,10561,'zh','é€šè®¯\r\n',0),(380183,10561,'sv','Kommunikation',0),(380184,10561,'it','Comunicazioni',0),(380185,10561,'tl','',0),(380186,10561,'th','à¸à¸²à¸£à¸ªà¸·à¹ˆà¸­à¸ªà¸²à¸£',0),(380187,10561,'hi','à¤¸à¤‚à¤šà¤¾à¤°',0),(380188,10561,'ms','Komunikasi',0),(380189,10561,'ar','Ø§Ù„Ø§ØªØµØ§Ù„Ø§Øª',0),(380190,10561,'fr','Communications',0),(380191,10561,'jp','é€šä¿¡',0),(380192,10561,'pt','ComunicaÃ§Ãµes',0),(380193,10561,'ru','Ð¡Ð²ÑÐ·ÑŒ',0),(380194,10561,'es','Comunicaciones',0),(380195,10561,'de','Kommunikation',0),(380196,10561,'en','Communications',0),(380197,10562,'is','',0),(380198,10562,'dr','ØµØ¯ÙˆØ± ÙØ§ÙƒØªÙˆØ± ',0),(380199,10562,'pr','ØµØ¯ÙˆØ± ÙØ§ÙƒØªÙˆØ± ',0),(380200,10562,'tr','Faturalama',0),(380201,10562,'pl','Fakturowanie',0),(380202,10562,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(380203,10562,'ur','Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯',0),(380204,10562,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(380205,10562,'vi','hÃ³a Ä‘Æ¡n',0),(380206,10562,'af','Fakturering',0),(380207,10562,'ro','Facturare',0),(380208,10562,'et','Arveldamine',0),(380209,10562,'si','Fakturiranje',0),(380210,10562,'ba','Faktur',0),(380211,10562,'nl','Facturering',0),(380212,10562,'fi','Laskutus',0),(380213,10562,'no','Fakturering',0),(380214,10562,'da','Fakturering',0),(380215,10562,'ko','ì²­êµ¬ì„œë¥¼ ìž‘ì„±',0),(380216,10562,'he','×”×¤×§×ª ×—×©×‘×•× ×™×ª',0),(380217,10562,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(380218,10562,'zh','è´§å“è®¡ä»·\r\n',0),(380219,10562,'sv','Fakturering',0),(380220,10562,'it','Fatturazione',0),(380221,10562,'tl','',0),(380222,10562,'th','à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(380223,10562,'hi','à¤šà¤¾à¤²à¤¾à¤¨',0),(380224,10562,'ms','Invois',0),(380225,10562,'ar','Ø§Ù„ÙÙˆØªØ±Ø©',0),(380226,10562,'fr','Facturation',0),(380227,10562,'jp','è«‹æ±‚æ›¸ç™ºè¡Œ',0),(380228,10562,'pt','FacturaÃ§Ã£o',0),(380229,10562,'ru','Ð’Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(380230,10562,'es','FacturaciÃ³n',0),(380231,10562,'de','Rechnungsstellung',0),(380232,10562,'en','Invoicing',0),(380233,10563,'is','',0),(380234,10563,'dr','Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ ',0),(380235,10563,'pr','Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ ',0),(380236,10563,'tr','BakÄ±m',0),(380237,10563,'pl','Konserwacja',0),(380238,10563,'bg','ÐŸÐ¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(380239,10563,'ur','Ø¯ÛŒÚ©Ú¾ Ø¨Ú¾Ø§Ù„',0),(380240,10563,'sr','ÐžÐ´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ',0),(380241,10563,'vi','Báº£o trÃ¬',0),(380242,10563,'af','Onderhoud',0),(380243,10563,'ro','Intretinere',0),(380244,10563,'et','Hooldus',0),(380245,10563,'si','VzdrÅ¾evanje',0),(380246,10563,'ba','Pemeliharaan',0),(380247,10563,'nl','Onderhoud',0),(380248,10563,'fi','Huolto',0),(380249,10563,'no','Vedlikehold',0),(380250,10563,'da','Vedligeholdelse',0),(380251,10563,'ko','ìœ ì§€ ë³´ìˆ˜',0),(380252,10563,'he','×ª×—×–×•×§×”',0),(380253,10563,'el','Î£Ï…Î½Ï„Î®ÏÎ·ÏƒÎ·',0),(380254,10563,'zh','ç»´æŠ¤\r\n',0),(380255,10563,'sv','UnderhÃ¥ll',0),(380256,10563,'it','Manutenzione',0),(380257,10563,'tl','',0),(380258,10563,'th','à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²',0),(380259,10563,'hi','à¤°à¤–à¤°à¤–à¤¾à¤µ',0),(380260,10563,'ms','Penyelenggaraan',0),(380261,10563,'ar','ØµÙŠØ§Ù†Ø©',0),(380262,10563,'fr','Entretien',0),(380263,10563,'jp','ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹',0),(380264,10563,'pt','ManutenÃ§Ã£o',0),(380265,10563,'ru','Ð¢ÐµÑ…Ð½Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(380266,10563,'es','Mantenimiento',0),(380267,10563,'de','Wartung',0),(380268,10563,'en','Maintenance',0),(380269,10564,'is','',0),(380270,10564,'dr','Ø·Ø±Ø­ Ø¨Ø§Ø²Ø§Ø± ÙŠØ§Ø¨ÙŠ',0),(380271,10564,'pr','Ø·Ø±Ø­ Ø¨Ø§Ø²Ø§Ø± ÙŠØ§Ø¨ÙŠ',0),(380272,10564,'tr','Pazarlama planÄ±',0),(380273,10564,'pl','Plan marketingowy',0),(380274,10564,'bg','ÐœÐ°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³ Ð¿Ð»Ð°Ð½',0),(380275,10564,'ur','Ù…Ø§Ø±Ú©ÛŒÙ¹Ù†Ú¯ Ù¾Ù„Ø§Ù†',0),(380276,10564,'sr','ÐœÐ°Ñ€ÐºÐµÑ‚Ð¸Ð½ÑˆÐºÐ¸ ÐŸÐ»Ð°Ð½',0),(380277,10564,'vi','Káº¿ hoáº¡ch tiáº¿p thá»‹',0),(380278,10564,'af','Bemarking Plan',0),(380279,10564,'ro','Planul de marketing',0),(380280,10564,'et','Turundusplaan',0),(380281,10564,'si','TrÅ¾enjski naÄrt',0),(380282,10564,'ba','Rencana pemasaran',0),(380283,10564,'nl','Marketingplan',0),(380284,10564,'fi','Markkinointi-suunnitelma',0),(380285,10564,'no','MarkedsfÃ¸ringsplan',0),(380286,10564,'da','Marketing Plan',0),(380287,10564,'ko','ë§ˆì¼€íŒ… ê³„íš',0),(380288,10564,'he','×ª×•×›× ×™×ª ×”×©×™×•×•×§',0),(380289,10564,'el','Î£Ï‡Î­Î´Î¹Î¿ Î¼Î¬ÏÎºÎµÏ„Î¹Î½Î³Îº',0),(380290,10564,'zh','è¥é”€è®¡åˆ’\r\n',0),(380291,10564,'sv','Marknadsplan',0),(380292,10564,'it','Piano di marketing',0),(380293,10564,'tl','',0),(380294,10564,'th','à¹à¸œà¸™à¸à¸²à¸£à¸•à¸¥à¸²à¸”',0),(380295,10564,'hi','à¤µà¤¿à¤ªà¤£à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾',0),(380296,10564,'ms','Pelan Pemasaran',0),(380297,10564,'ar','Ø§Ù„Ø®Ø·Ø© Ø§Ù„ØªØ³ÙˆÙŠÙ‚ÙŠØ©',0),(380298,10564,'fr','Plan de marketing',0),(380299,10564,'jp','ãƒžãƒ¼ã‚±ãƒ†ã‚£ãƒ³ã‚°è¨ˆç”»',0),(380300,10564,'pt','Plano de marketing',0),(380301,10564,'ru','ÐœÐ°Ñ€ÐºÐµÑ‚Ð¸Ð½Ð³Ð¾Ð²Ñ‹Ð¹ Ð¿Ð»Ð°Ð½',0),(380302,10564,'es','Plan de Mercadotecnia',0),(380303,10564,'de','Marketingplan',0),(380304,10564,'en','Marketing Plan',0),(380305,10565,'is','',0),(380306,10565,'dr','/ Ø®Ø§Ø±Ø¬(ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„',0),(380307,10565,'pr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ Ø¨Ù‡ Ø¯Ø§Ø®Ù„ / Ø®Ø§Ø±Ø¬(ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„\r\n Wizard',0),(380308,10565,'tr','Hareket giriÅŸ/Ã§Ä±kÄ±ÅŸ SihirbazÄ±',0),(380309,10565,'pl','PrzenieÅ›Ä‡ w/Kreator',0),(380310,10565,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð²Ð°Ð½Ðµ/Ð¸Ð·Ñ…Ð¾Ð´ ÑÑŠÐ²ÐµÑ‚Ð½Ð¸ÐºÐ°',0),(380311,10565,'ur','Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº/Ù…Ø¯Ø¯Ú¯Ø§Ø± Ø¨Ø§ÛØ±',0),(380312,10565,'sr','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚Ðµ Ð˜Ð½/ÐžÑƒÑ‚ Ñ‡Ð°Ñ€Ð¾Ð±ÑšÐ°Ðº',0),(380313,10565,'vi','Di chuyá»ƒn vÃ o/ra Wizard',0),(380314,10565,'af','Beweeg In/uit Ghoeroe',0),(380315,10565,'ro','Muta In/Out Expertul',0),(380316,10565,'et','Liikuda In/Out viisard',0),(380317,10565,'si','Premikanje In/Out Äarovnik',0),(380318,10565,'ba','Memindahkan In/Out Wizard',0),(380319,10565,'nl','Verplaatsen In/Out Wizard',0),(380320,10565,'fi','SiirrÃ¤ In/Out Ohjattu',0),(380321,10565,'no','Flytt inn/ut veiviseren',0),(380322,10565,'da','Flytte ind/ud guiden',0),(380323,10565,'ko','ì´ë™/ë§ˆë²•ì‚¬',0),(380324,10565,'he','×œ×”×–×™×– ×¤× ×™×ž×”/×”×—×•×¦×” ××©×£',0),(380325,10565,'el','ÎœÎµÏ„Î±ÎºÎ¹Î½Î®ÏƒÎµÏ„Îµ In/Out \"ÎŸÎ´Î·Î³ÏŒÏ‚\"',0),(380326,10565,'zh','ç§»åŠ¨/è¾“å‡ºå‘å¯¼\r\n',0),(380327,10565,'sv','Flytta In/ut guiden',0),(380328,10565,'it','Spostare/uscita guidata',0),(380329,10565,'tl','',0),(380330,10565,'th','à¸¢à¹‰à¸²à¸¢ à¹€à¸‚à¹‰à¸²/à¸­à¸­à¸à¸•à¸±à¸§à¸Šà¹ˆà¸§à¸¢à¸ªà¸£à¹‰à¸²à¸‡',0),(380331,10565,'hi','à¤®à¥‡à¤‚/à¤µà¤¿à¤œà¤¼à¤¾à¤°à¥à¤¡ à¤¬à¤¾à¤¹à¤° à¤²à¥‡ à¤œà¤¾à¤à¤',0),(380332,10565,'ms','Berpindah Masuk/Keluar Pendeta',0),(380333,10565,'ar','Ø§Ù„ØªØ­Ø±Ùƒ Ø¯Ø§Ø®Ù„/Ø®Ø§Ø±Ø¬ Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬',0),(380334,10565,'fr','DÃ©placer/sortie Assistant',0),(380335,10565,'jp','å†…ã‚’ç§»å‹•/ã‚¢ã‚¦ãƒˆ ã‚¦ã‚£ã‚¶ãƒ¼ãƒ‰',0),(380336,10565,'pt','Mover In/Out assistente',0),(380337,10565,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ/Ð¼Ð°ÑÑ‚ÐµÑ€',0),(380338,10565,'es','Wizard de Mover Dentro/Afuera',0),(380339,10565,'de','Verschieben Sie, ein-und Ausgang-Assistenten',0),(380340,10565,'en','Move In/Out Wizard',0),(380341,10566,'is','',0),(380342,10566,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø§Ø¬Ø§Ø±Ù‡ Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(380343,10566,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø§Ø¬Ø§Ø±Ù‡ Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÙŠØ¯ ',0),(380344,10566,'tr','Yeni kira & Ã¶deme ayrÄ±ntÄ±larÄ±',0),(380345,10566,'pl','Nowe & szczegÃ³Å‚Ã³w pÅ‚atnoÅ›ci',0),(380346,10566,'bg','ÐÐ¾Ð² Ð»Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð² Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ & Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸',0),(380347,10566,'ur','Ù†Ø¦ÛŒ Ù„ÛŒØ² & Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(380348,10566,'sr','ÐÐ¾Ð²Ð¸ Ð·Ð°ÐºÑƒÐ¿ & Ð´ÐµÑ‚Ð°Ñ™Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(380349,10566,'vi','Há»£p Ä‘á»“ng thuÃª má»›i &amp; chi tiáº¿t thanh toÃ¡n',0),(380350,10566,'af','Nuwe Huurkontrak & Betalingsdetail',0),(380351,10566,'ro','Contract de leasing nou & detaliu de platÄƒ',0),(380352,10566,'et','Uue liisingu & makse Ã¼ksikasjad',0),(380353,10566,'si','Nov najem & plaÄila podrobnosti',0),(380354,10566,'ba','Sewa baru & Detail pembayaran',0),(380355,10566,'nl','Nieuwe Lease & betaling Detail',0),(380356,10566,'fi','Uutta puhtia & maksu yksityiskohtaisesti',0),(380357,10566,'no','Ny leieavtale & betaling detaljer',0),(380358,10566,'da','Ny Lease & betaling detaljer',0),(380359,10566,'ko','ìƒˆë¡œìš´ ìž„ëŒ€ & ì§€ë¶ˆ ì„¸ë¶€ ì‚¬í•­',0),(380360,10566,'he','×—×›×™×¨×” ×—×“×©×” & ×¤×™×¨×•×˜ ×”×ª×©×œ×•×',0),(380361,10566,'el','ÎÎ­Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· & Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(380362,10566,'zh','æ–°ç§ŸèµåŠä»˜æ¬¾è¯¦æƒ…\r\n',0),(380363,10566,'sv','Nytt hyresavtal & utbetalning detalj',0),(380364,10566,'it','Nuovo contratto di locazione & dettaglio di pagamento',0),(380365,10566,'tl','',0),(380366,10566,'th','à¹€à¸Šà¹ˆà¸²à¹ƒà¸«à¸¡à¹ˆ & à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(380367,10566,'hi','à¤¨à¤ˆ à¤²à¥€à¤œ & à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤µà¤°à¤£',0),(380368,10566,'ms','Nafas baru & butiran pembayaran',0),(380369,10566,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø¬Ø¯ÙŠØ¯ Ø¢Ù†Ø¯ ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¯ÙØ¹',0),(380370,10566,'fr','Renouvellement du bail & dÃ©tail de paiement',0),(380371,10566,'jp','æ–°ã—ã„ãƒªãƒ¼ã‚¹ & ãŠæ”¯æ‰•ã„è©³ç´°',0),(380372,10566,'pt','Nova locaÃ§Ã£o & detalhes de pagamento',0),(380373,10566,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹ & Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(380374,10566,'es','Nuevo Arrendamiento & Detalle del Pago',0),(380375,10566,'de','Neues & Zahlung Details',0),(380376,10566,'en','New Lease & Payment Detail',0),(380377,10567,'is','',0),(380378,10567,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(380379,10567,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(380380,10567,'tr','Emlak detaylarÄ±',0),(380381,10567,'pl','NieruchomoÅ›ci',0),(380382,10567,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð·Ð° Ð¸Ð¼Ð¾Ñ‚',0),(380383,10567,'ur','Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(380384,10567,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¾ Ð½ÐµÐºÑ€ÐµÑ‚Ð½Ð¸Ð½Ð¸',0),(380385,10567,'vi','chi tiáº¿t tÃ i sáº£n',0),(380386,10567,'af','Eiendom besonderhede',0),(380387,10567,'ro','Detalii proprietate',0),(380388,10567,'et','Kinnisvara Details',0),(380389,10567,'si','VeÄ o nepremiÄnini',0),(380390,10567,'ba','Detail properti',0),(380391,10567,'nl','Eigenschap Details',0),(380392,10567,'fi','KiinteistÃ¶n yksityiskohdat',0),(380393,10567,'no','Bolig detaljer',0),(380394,10567,'da','Ejendom detaljer',0),(380395,10567,'ko','ìž¬ì‚° ì„¸ë¶€ ì‚¬í•­',0),(380396,10567,'he','×¤×¨×˜×™ ×”× ×›×¡',0),(380397,10567,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î‘ÎºÎ¹Î½Î®Ï„Î¿Ï…',0),(380398,10567,'zh','å±žæ€§æ˜Žç»†\r\n',0),(380399,10567,'sv','Egenskapen Detaljer',0),(380400,10567,'it','ProprietÃ  dettagli',0),(380401,10567,'tl','',0),(380402,10567,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(380403,10567,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(380404,10567,'ms','Butir-butir harta',0),(380405,10567,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ù„ÙƒÙŠØ©',0),(380406,10567,'fr','DÃ©tails de propriÃ©tÃ©',0),(380407,10567,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®è©³ç´°',0),(380408,10567,'pt','Detalhes da propriedade',0),(380409,10567,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(380410,10567,'es','Detalles de Propiedad',0),(380411,10567,'de','Details zu Eigenschaften',0),(380412,10567,'en','Property Details',0),(380413,10568,'is','',0),(380414,10568,'dr','(Ù…Ø¹ÙŠÙ† ) Ù…Ø³ØªØ§Ø¬Ø±',0),(380415,10568,'pr','Ø¯ÙØªØ± ÙƒÙ„ (Ù…Ø¹ÙŠÙ† ) Ù…Ø³ØªØ§Ø¬Ø±',0),(380416,10568,'tr','KiracÄ± defter',0),(380417,10568,'pl','Najemcy ksiÄ™gi',0),(380418,10568,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» ÐºÐ½Ð¸Ð³Ð°',0),(380419,10568,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Ú¾Ø§ØªØ§',0),(380420,10568,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ ÐºÑšÐ¸Ð³Ðµ',0),(380421,10568,'vi','NgÆ°á»i thuÃª nhÃ  Ledger',0),(380422,10568,'af','Huurder Grootboek',0),(380423,10568,'ro','ChiriaÅŸ reg.',0),(380424,10568,'et','ÃœÃ¼rnik pearaamatu',0),(380425,10568,'si','Ledger za najemnika',0),(380426,10568,'ba','Penyewa besar',0),(380427,10568,'nl','Huurder Ledger',0),(380428,10568,'fi','Vuokralainen kirjanpidon',0),(380429,10568,'no','Leietaker finans',0),(380430,10568,'da','Lejer finans',0),(380431,10568,'ko','í…Œ ë„Œ íŠ¸ ë ˆì €',0),(380432,10568,'he','×”×“×™×™×¨ ×¡×¤×¨ ×¨××©×™',0),(380433,10568,'el','Î›Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(380434,10568,'zh','ç§Ÿå®¢èŽ±æ°\r\n',0),(380435,10568,'sv','HyresgÃ¤sten redovisning',0),(380436,10568,'it','Inquilino Ledger',0),(380437,10568,'tl','',0),(380438,10568,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(380439,10568,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤–à¤¾à¤¤à¤¾à¤¬à¤¹à¥€',0),(380440,10568,'ms','Penyewa Lejar',0),(380441,10568,'ar','Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(380442,10568,'fr','Locataire Ledger',0),(380443,10568,'jp','ãƒ†ãƒŠãƒ³ãƒˆã®å…ƒå¸³',0),(380444,10568,'pt','Inquilino Ledger',0),(380445,10568,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ð“Ðš',0),(380446,10568,'es','Diario de Inquilino',0),(380447,10568,'de','Mieter-Ledger',0),(380448,10568,'en','Tenant Ledger',0),(380449,10569,'is','',0),(380450,10569,'dr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„',0),(380451,10569,'pr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙØ±ÙˆØ´ Ø¯ÙØªØ± ÙƒÙ„',0),(380452,10569,'tr','GL satÄ±ÅŸ hesaplarÄ± gizle',0),(380453,10569,'pl','Ukryj GL sprzedaÅ¼y kont',0),(380454,10569,'bg','Ð¡ÐºÑ€Ð¸Ð¹ GL ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(380455,10569,'ur','Ø¬ÛŒØ¬Û’ Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(380456,10569,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð“Ð› ÐºÐ¾Ð½Ñ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(380457,10569,'vi','Giáº¥u cÃ¡c sá»• cÃ¡i bÃ¡n hÃ ng',0),(380458,10569,'af','Verberg AG Verkope Rekeninge',0),(380459,10569,'ro','Ascunde GL vanzari conturi',0),(380460,10569,'et','Peida GL mÃ¼Ã¼gikontodega',0),(380461,10569,'si','Skrij GL prodajnih raÄunov',0),(380462,10569,'ba','Menyembunyikan account penjualan GL',0),(380463,10569,'nl','GL omzetrekeningen verbergen',0),(380464,10569,'fi','Piilota GL myyntitilit',0),(380465,10569,'no','Skjule GL salgskontoer',0),(380466,10569,'da','Skjule GL salgskonti',0),(380467,10569,'ko','GL íŒë§¤ ê³„ì • ìˆ¨ê¸°ê¸°',0),(380468,10569,'he','×œ×”×¡×ª×™×¨ ×—×©×‘×•× ×•×ª ×ž×›×™×¨×•×ª GL',0),(380469,10569,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(380470,10569,'zh','éšè—æ€»å¸é”€å”®å¸æˆ·\r\n',0),(380471,10569,'sv','DÃ¶lja GL fÃ¶rsÃ¤ljningskonton',0),(380472,10569,'it','Nascondere GL Sales account',0),(380473,10569,'tl','',0),(380474,10569,'th','à¸‹à¹ˆà¸­à¸™à¸šà¸±à¸à¸Šà¸µà¸‚à¸²à¸¢ GL',0),(380475,10569,'hi','à¤œà¥€à¤à¤² à¤µà¤¿à¤•à¥à¤°à¤¯ à¤²à¥‡à¤–à¤¾ à¤›à¥à¤ªà¤¾à¤à¤',0),(380476,10569,'ms','Sembunyi akaun jualan GL',0),(380477,10569,'ar','Ø¥Ø®ÙØ§Ø¡ Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ÙÙŠ ØµÙØ­Ø© Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(380478,10569,'fr','Masquer les ventes comptes GL',0),(380479,10569,'jp','GL è²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’éš ã™',0),(380480,10569,'pt','Esconder contas vendas GL',0),(380481,10569,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ GL Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(380482,10569,'es','Esconde Cuentas de Ventas de LM',0),(380483,10569,'de','GL Verkaufskonten zu verstecken',0),(380484,10569,'en','Hide GL Sales Accounts',0),(380485,10570,'is','',0),(380486,10570,'dr','ØªÙ†Ù‡Ø§ Ø²Ù…Ø§Ù†ÙŠ ÙƒØ§Ø± Ù…ÙŠ ÙƒÙ†Ø¯ Ø§Ú¯Ø± Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ØªÙ†Ø¸ÙŠÙ… Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(380487,10570,'pr','ØªÙ†Ù‡Ø§ Ø²Ù…Ø§Ù†ÙŠ ÙƒØ§Ø± Ù…ÙŠ ÙƒÙ†Ø¯ Ø§Ú¯Ø± Ù¾ÙŠØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÙŠ Ø¯ÙØªØ± ÙƒÙ„ ØªÙ†Ø¸ÙŠÙ… Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(380488,10570,'tr','VarsayÄ±lan GL hesaplarÄ± ayarladÄ±ysanÄ±z, yalnÄ±zca Ã§alÄ±ÅŸÄ±r',0),(380489,10570,'pl','DziaÅ‚a tylko, jeÅ›li domyÅ›lne konta GL',0),(380490,10570,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÑÐ° Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¸ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ GL ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(380491,10570,'ur','Ø·Û’ Ø´Ø¯Û Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ø³ÛŒÙ¹ Ú©ÛŒÛ’ Ú¯Ø¦Û’ ÛÛŒÚº Ø§Ú¯Ø± ØµØ±Ù Ú©Ø§Ù… Ú©Ø±ØªØ§ ÛÛ’',0),(380492,10570,'sr','Ð Ð°Ð´Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÑÑƒ Ð¿Ð¾Ð´ÐµÑˆÐµÐ½Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð›',0),(380493,10570,'vi','chá»‰ lÃ m viá»‡c náº¿u cÃ¡c tÃ i khoáº£n sá»• cÃ¡i máº·c Ä‘á»‹nh Ä‘Æ°á»£c  thiáº¿t láº­p',0),(380494,10570,'af','Slegs werk as verstek GL rekeninge is opgestel',0),(380495,10570,'ro','FuncÅ£ioneazÄƒ numai dacÄƒ sunt setate pe conturile de GL implicit',0),(380496,10570,'et','TÃ¶Ã¶tab ainult siis kui vaikimisi GL kontosid',0),(380497,10570,'si','Deluje samo, Äe so nastavljene privzete GL raÄunov',0),(380498,10570,'ba','Hanya bekerja jika Default GL account ditetapkan',0),(380499,10570,'nl','Werkt alleen als standaard GL Accounts zijn ingesteld',0),(380500,10570,'fi','Toimii vain jos GL oletustilit',0),(380501,10570,'no','Fungerer bare hvis standard GL kontoene settes',0),(380502,10570,'da','Virker kun hvis GL standardkonti er indstillet',0),(380503,10570,'ko','ê¸°ë³¸ GL ê³„ì •ì„ ì„¤ì •í•œ ê²½ìš°ì— ìž‘ë™',0),(380504,10570,'he','×¢×•×‘×“ ×¨×§ ×× ×”×•×’×“×¨×• ×—×©×‘×•× ×•×ª GL ×‘×¨×™×¨×ª ×”×ž×—×“×œ',0),(380505,10570,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³ÎµÎ¯ Î¼ÏŒÎ½Î¿ ÎµÎ¬Î½ Î­Ï‡Î¿Ï…Î½ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ GL',0),(380506,10570,'zh','åªæœ‰å½“é»˜è®¤æ€»å¸å¸æˆ·è®¾ç½®åŽå·¥ä½œ\r\n',0),(380507,10570,'sv','Fungerar bara om standard GL konton stÃ¤lls in',0),(380508,10570,'it','Funziona solo se conti GL predefinite vengono impostate',0),(380509,10570,'tl','',0),(380510,10570,'th','à¸ˆà¸°à¸—à¸³à¸‡à¸²à¸™à¹„à¸”à¹‰à¸–à¹‰à¸²à¸¡à¸µà¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸£à¸«à¸±à¸ªà¸šà¸±à¸à¸Šà¸µ',0),(380511,10570,'hi','à¤¯à¤¦à¤¿ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤•à¥‡à¤µà¤² à¤•à¤¾à¤® à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(380512,10570,'ms','Kerja-kerja hanya jika lalai GL akaun akan menyediakan',0),(380513,10570,'ar','ÙŠØ¹Ù…Ù„ ÙÙ‚Ø· Ø¥Ø°Ø§ ØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª GL Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(380514,10570,'fr','Ne fonctionne que si les comptes GL par dÃ©faut sont dÃ©finis',0),(380515,10570,'jp','æ—¢å®šã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¨­å®šã—ã¦ã„ã‚‹å ´åˆã«ã®ã¿å‹•ä½œã—ã¾ã™',0),(380516,10570,'pt','SÃ³ funciona se as contas GL padrÃ£o sÃ£o definidas',0),(380517,10570,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð°ÐµÑ‚ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð·Ð°Ð´Ð°Ð½Ñ‹ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ GL',0),(380518,10570,'es','Solo Funciona Si Las Cuentas LM por Defecto Estan Configuradas',0),(380519,10570,'de','Funktioniert nur, wenn Standard-GL-Konten festgelegt werden',0),(380520,10570,'en','Only Works If Default GL Accounts Are Set',0),(380521,10571,'is','',0),(380522,10571,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù† ØªØ®ÙÙŠÙ (ØªÙ†Ø²ÙŠÙ„ ',0),(380523,10571,'pr','Ø§ÙØ²ÙˆØ¯Ù†/ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªØ®ÙÙŠÙ (ØªÙ†Ø²ÙŠÙ„ ',0),(380524,10571,'tr','Ekleme/GÃ¼ncelleme indirim',0),(380525,10571,'pl','Dodaj/Aktualizuj rabat',0),(380526,10571,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(380527,10571,'ur','ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(380528,10571,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚Ð°/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(380529,10571,'vi','thÃªm chiáº¿t khÃ¡u/ cáº­p nháº­t',0),(380530,10571,'af','Kortings Byvoeg/Opdateer',0),(380531,10571,'ro','Reducere AdÄƒugaÅ£i/actualizaÅ£i',0),(380532,10571,'et','Soodus lisamine/uuendamine',0),(380533,10571,'si','Popust Dodaj/posodobi',0),(380534,10571,'ba','DISKON TERBAIK untuk menambahkan Update',0),(380535,10571,'nl','Korting toevoegen/bijwerken',0),(380536,10571,'fi','Alennus lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(380537,10571,'no','Rabatt Legg til/Oppdater',0),(380538,10571,'da','Discount TilfÃ¸j/opdater',0),(380539,10571,'ko','í• ì¸ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(380540,10571,'he','×”× ×—×” ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(380541,10571,'el','Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(380542,10571,'zh','æŠ˜æ‰£æ–°å¢ž/æ›´æ–°\r\n',0),(380543,10571,'sv','Rabatt LÃ¤gg till/uppdatera',0),(380544,10571,'it','Sconto aggiungere/aggiornare',0),(380545,10571,'tl','',0),(380546,10571,'th','à¸¥à¸”à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(380547,10571,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(380548,10571,'ms','Diskaun Tambah/Kemaskini',0),(380549,10571,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± ØªØ®ÙÙŠØ¶',0),(380550,10571,'fr','Ajouter/mettre Ã  jour d\'escompte',0),(380551,10571,'jp','å‰²å¼•ã‚’è¿½åŠ /æ›´æ–°',0),(380552,10571,'pt','Desconto adicionar/atualizar',0),(380553,10571,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(380554,10571,'es','Descuento Agregar/Actualizar',0),(380555,10571,'de','Rabatt hinzufÃ¼gen/aktualisieren',0),(380556,10571,'en','Discount Add/Update',0),(380557,10572,'is','',0),(380558,10572,'dr','ØªØ®ÙÙŠÙØ§Øª  ',0),(380559,10572,'pr','ØªØ®ÙÙŠÙØ§Øª  ',0),(380560,10572,'tr','Ä°ndirimler',0),(380561,10572,'pl','Rabaty',0),(380562,10572,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸',0),(380563,10572,'ur','Ø±Ø¹Ø§ÛŒØª',0),(380564,10572,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚Ð¸',0),(380565,10572,'vi','Chiáº¿t kháº¥u',0),(380566,10572,'af','Kortings',0),(380567,10572,'ro','Reduceri',0),(380568,10572,'et','Allahindlused',0),(380569,10572,'si','Popusti',0),(380570,10572,'ba','Diskon',0),(380571,10572,'nl','Kortingen',0),(380572,10572,'fi','Alennukset',0),(380573,10572,'no','Rabatter',0),(380574,10572,'da','Rabatter',0),(380575,10572,'ko','í• ì¸',0),(380576,10572,'he','×”× ×—×•×ª',0),(380577,10572,'el','Î•ÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ Î¾ÎµÎ½Î¿Î´Î¿Ï‡ÎµÎ¯Ï‰Î½ ÏƒÎµ',0),(380578,10572,'zh','æŠ˜æ‰£\r\n',0),(380579,10572,'sv','Rabatter',0),(380580,10572,'it','SCONTI',0),(380581,10572,'tl','',0),(380582,10572,'th','à¸ªà¹ˆà¸§à¸™à¸¥à¸”',0),(380583,10572,'hi','à¤›à¥‚à¤Ÿ',0),(380584,10572,'ms','Diskaun',0),(380585,10572,'ar','Ø§Ù„ØªØ®ÙÙŠØ¶Ø§Øª',0),(380586,10572,'fr','Remises',0),(380587,10572,'jp','å‰²å¼•',0),(380588,10572,'pt','Descontos',0),(380589,10572,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ¸',0),(380590,10572,'es','Descuentos',0),(380591,10572,'de','Rabatte',0),(380592,10572,'en','Discounts',0),(380593,10573,'is','',0),(380594,10573,'dr','Ø±ÙˆÙŠ ÙØ§ÙƒØªÙˆØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù†Ù…ÙˆÙ†Ù‡ Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ  Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±  Ø±Ø§ Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯',0),(380595,10573,'pr','Ø±ÙˆÙŠ ÙØ§ÙƒØªÙˆØ± ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ù†Ù…ÙˆÙ†Ù‡ Ø¢Ø²Ù…Ø§ÙŠØ´ÙŠ  Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±  Ø±Ø§ Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯',0),(380596,10573,'tr','Faturada iade faturasÄ± oluÅŸturmak iÃ§in tÄ±klatÄ±n',0),(380597,10573,'pl','Kliknij na faktura, tworzenie faktury korygujÄ…cej',0),(380598,10573,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð·Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(380599,10573,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚ Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ù„ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(380600,10573,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð»Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(380601,10573,'vi','Nháº¥n vÃ o hÃ³a Ä‘Æ¡n Ä‘á»ƒ táº¡o khoáº£n thu',0),(380602,10573,'af','Kliek Op Faktuur Om Krediet Memo Te Skep',0),(380603,10573,'ro','FaceÅ£i clic pe facturÄƒ pentru a crea note de Credit',0),(380604,10573,'et','Arvele kreeditarve loomiseks klÃµpsake',0),(380605,10573,'si','Kliknite na raÄun ustvarite dobropis',0),(380606,10573,'ba','Klik pada faktur untuk menciptakan Memo kredit',0),(380607,10573,'nl','Klik op factuur maken creditnota',0),(380608,10573,'fi','Klikkaa laskun Luo hyvityslasku',0),(380609,10573,'no','Klikk pÃ¥ faktura til Opprett kreditnota',0),(380610,10573,'da','Klik pÃ¥ faktura til Opret kreditnota',0),(380611,10573,'ko','ì†¡ìž¥ ì‹ ìš© ë©”ëª¨ ë§Œë“¤ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(380612,10573,'he','×œ×—×¥ ×¢×œ ×”×—×©×‘×•× ×™×ª ×›×“×™ ×œ×™×¦×•×¨ ×”×–×™×›×•×™',0),(380613,10573,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î³Î¹Î± Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ¿Ï Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(380614,10573,'zh','åœ¨å‘ç¥¨ä¸Šç‚¹å‡»åˆ›å»ºè´·é¡¹é€šçŸ¥å•\r\n',0),(380615,10573,'sv','Klicka pÃ¥ faktura skapa kreditnota',0),(380616,10573,'it','Fare clic su fattura per creare la nota di credito',0),(380617,10573,'tl','',0),(380618,10573,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œà¸šà¸±à¸™à¸—à¸¶à¸à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­',0),(380619,10573,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤¬à¤¨à¤¾à¤à¤ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(380620,10573,'ms','Klik pada invois untuk mencipta kredit Memo',0),(380621,10573,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¥Ù†Ø´Ø§Ø¡ Ù…Ø°ÙƒØ±Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(380622,10573,'fr','Cliquez sur facture pour crÃ©er la note de crÃ©dit',0),(380623,10573,'jp','è«‹æ±‚æ›¸ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ãƒ¡ãƒ¢ã‚’ä½œæˆã™ã‚‹ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(380624,10573,'pt','Clique na factura para criar nota de crÃ©dito',0),(380625,10573,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° ÑÑ‡ÐµÑ‚ Ð´Ð»Ñ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ñ‹',0),(380626,10573,'es','Clic En la Factura Para Crear Memo de CrÃ©dito',0),(380627,10573,'de','Klicken Sie auf Rechnung, Gutschrift zu erstellen',0),(380628,10573,'en','Click On Invoice To Create Credit Memo',0),(380629,10574,'is','',0),(380630,10574,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø¨Ø§Ø²Ø¯Ù‡',0),(380631,10574,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø¨Ø§Ø²Ø¯Ù‡',0),(380632,10574,'tr','DÃ¶nÃ¼ÅŸ oluÅŸturun',0),(380633,10574,'pl','Tworzenie powrÃ³t',0),(380634,10574,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ',0),(380635,10574,'ur','ÙˆØ§Ù¾Ø³ÛŒ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(380636,10574,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¿Ð¾Ð²Ñ€Ð°Ñ‚Ð°Ðº',0),(380637,10574,'vi','táº¡o tráº£ láº¡i',0),(380638,10574,'af','Skep terug',0),(380639,10574,'ro','Crea Ã®ntoarcerea',0),(380640,10574,'et','Loo tulu',0),(380641,10574,'si','Ustvarjanje donosa',0),(380642,10574,'ba','Menciptakan kembali',0),(380643,10574,'nl','Maken van terugkeer',0),(380644,10574,'fi','Luo paluu',0),(380645,10574,'no','Opprett retur',0),(380646,10574,'da','Oprette tilbagevenden',0),(380647,10574,'ko','ìˆ˜ìµì„ ë§Œë“¤',0),(380648,10574,'he','×™×¦×™×¨×ª ×”×—×–×¨',0),(380649,10574,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(380650,10574,'zh','åˆ›å»ºé€€è´§\r\n',0),(380651,10574,'sv','Skapa avkastning',0),(380652,10574,'it','Creare il ritorno',0),(380653,10574,'tl','',0),(380654,10574,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸œà¸¥à¸•à¸­à¸šà¹à¸—à¸™',0),(380655,10574,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤¬à¤¨à¤¾à¤à¤',0),(380656,10574,'ms','Mencipta kembali',0),(380657,10574,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù…Ø±Ø¯ÙˆØ¯Ø§Øª',0),(380658,10574,'fr','CrÃ©er le retour',0),(380659,10574,'jp','ãƒªã‚¿ãƒ¼ãƒ³ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(380660,10574,'pt','Criar o retorno',0),(380661,10574,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚',0),(380662,10574,'es','Crear DeclaraciÃ³n',0),(380663,10574,'de','RÃ¼ckkehr zu erstellen',0),(380664,10574,'en','Create Return',0),(380665,10575,'is','',0),(380666,10575,'dr','Ø«Ø¨Øª Ø´Ø§Ø®Øµ ÙÙŠÙ„ØªØ± Ø¬Ø³ØªØ¬Ùˆ ',0),(380667,10575,'pr','Ø«Ø¨Øª Ø´Ø§Ø®Øµ ÙÙŠÙ„ØªØ± Ø¬Ø³ØªØ¬Ùˆ ',0),(380668,10575,'tr','Arama filtresi deÄŸerleri girin',0),(380669,10575,'pl','WprowadÅº wartoÅ›ci filtru wyszukiwania',0),(380670,10575,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸Ñ‚Ðµ Ð½Ð° Ñ„Ð¸Ð»Ñ‚ÑŠÑ€Ð° Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(380671,10575,'ur','ØªÙ„Ø§Ø´ ÙÙ„Ù¹Ø± Ù‚Ø¯Ø±ÛŒÚº Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(380672,10575,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ñ„Ð¸Ð»Ñ‚ÐµÑ€Ð° Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(380673,10575,'vi','nháº­p giÃ¡ trá»‹ tÃ¬m kiáº¿m Ä‘Æ°á»£c lá»c',0),(380674,10575,'af','Voer Soekfilter Waardes In',0),(380675,10575,'ro','IntroduceÅ£i valori de filtru cÄƒutare',0),(380676,10575,'et','Sisestage otsingu Filter vÃ¤Ã¤rtused',0),(380677,10575,'si','Vnesite vrednosti filtra iskanja',0),(380678,10575,'ba','Memasukkan nilai-nilai Filter pencarian',0),(380679,10575,'nl','Search filterwaarden invoeren',0),(380680,10575,'fi','Kirjoittamalla Etsi suodatinarvot',0),(380681,10575,'no','Angi filterverdier',0),(380682,10575,'da','Angiv sÃ¸gevÃ¦rdier Filter',0),(380683,10575,'ko','ê²€ìƒ‰ í•„í„° ê°’ì„ ìž…ë ¥',0),(380684,10575,'he','×”×–×Ÿ ×¢×¨×›×™ ×ž×¡× ×Ÿ ×—×™×¤×•×©',0),(380685,10575,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î¹Î¼Î­Ï‚ Î¦Î¯Î»Ï„ÏÎ¿ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(380686,10575,'zh','è¾“å…¥æœç´¢è¿‡æ»¤ä»·å€¼\r\n',0),(380687,10575,'sv','Ange sÃ¶kvÃ¤rden Filter',0),(380688,10575,'it','Immettere i valori di filtro di ricerca',0),(380689,10575,'tl','',0),(380690,10575,'th','à¸›à¹‰à¸­à¸™à¸„à¹ˆà¸²à¸•à¸±à¸§à¸à¸£à¸­à¸‡à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²',0),(380691,10575,'hi','à¤–à¥‹à¤œ à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤° à¤®à¤¾à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(380692,10575,'ms','Masukkan nilai-nilai penapis carian',0),(380693,10575,'ar','Ø£Ø¯Ø®Ù„ Ù‚ÙŠÙ… Ø¹Ø§Ù…Ù„ ØªØµÙÙŠØ© Ø§Ù„Ø¨Ø­Ø«',0),(380694,10575,'fr','Entrez les valeurs de filtre de recherche',0),(380695,10575,'jp','æ¤œç´¢ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼ã®å€¤ã‚’å…¥åŠ›ã—ã¾ã™',0),(380696,10575,'pt','Insira os valores de filtro de pesquisa',0),(380697,10575,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ñ„Ð¸Ð»ÑŒÑ‚Ñ€Ð° Ð¿Ð¾Ð¸ÑÐºÐ°',0),(380698,10575,'es','Entrar Valores de Filtro de BÃºsqueda',0),(380699,10575,'de','Geben Sie Filter Suchwerte',0),(380700,10575,'en','Enter Search Filter Values',0),(380701,10576,'is','',0),(380702,10576,'dr','Ù‡ÙŠÚ† Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(380703,10576,'pr','Ù‡ÙŠÚ† Ù…Ø´Ø§Ø¨Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(380704,10576,'tr','Uygunu bulunamadÄ±',0),(380705,10576,'pl','Nie znaleziono',0),(380706,10576,'bg','ÐÐµ Ð±ÐµÑˆÐµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¾ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ',0),(380707,10576,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(380708,10576,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° ÑÐµ Ð½Ð°ÑˆÐ°Ð¾',0),(380709,10576,'vi','khÃ´ng tÃ¬m tháº¥y liÃªn káº¿t',0),(380710,10576,'af','Geen ooreenstemming gevind',0),(380711,10576,'ro','Nici un meci gÄƒsit',0),(380712,10576,'et','Ei leitud vasteid',0),(380713,10576,'si','No tekmo naÅ¡el',0),(380714,10576,'ba','Tidak ada pertandingan yang ditemukan',0),(380715,10576,'nl','Geen kanaal gevonden',0),(380716,10576,'fi','Osumia ei lÃ¶ytynyt',0),(380717,10576,'no','Ingen Match funnet',0),(380718,10576,'da','Ingen Match fundet',0),(380719,10576,'ko','ë°œê²¬ ì¼ì¹˜',0),(380720,10576,'he','×œ× × ×ž×¦××” ×”×ª××ž×”',0),(380721,10576,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ ÎºÎ±Î½Î­Î½Î± Î±Ï€Î¿Ï„Î­Î»ÎµÏƒÎ¼Î±',0),(380722,10576,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…\r\n',0),(380723,10576,'sv','Ingen matchning hittades',0),(380724,10576,'it','Nessuna corrispondenza trovata',0),(380725,10576,'tl','',0),(380726,10576,'th','à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸šà¸—à¸µà¹ˆà¸žà¸š',0),(380727,10576,'hi','à¤•à¥‹à¤ˆ à¤®à¤¿à¤²à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(380728,10576,'ms','Tiada padanan ditemui',0),(380729,10576,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªØ·Ø§Ø¨Ù‚ ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(380730,10576,'fr','Aucune correspondance trouvÃ©e',0),(380731,10576,'jp','ä¸€è‡´ã¯ã‚ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(380732,10576,'pt','Nenhuma correspondÃªncia encontrada',0),(380733,10576,'ru','Ð¡Ð¾Ð²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(380734,10576,'es','No Se EncontrÃ³ un Equivalencia',0),(380735,10576,'de','Nichts passendes gefunden',0),(380736,10576,'en','No Match Found',0),(380737,10577,'is','',0),(380738,10577,'dr','Ø¨Ø±Ú¯Ø´ØªÙŠ Ù‡Ø§ ',0),(380739,10577,'pr','Ø¨Ø±Ú¯Ø´ØªÙŠ Ù‡Ø§ ',0),(380740,10577,'tr','DÃ¶ner',0),(380741,10577,'pl','Zwraca',0),(380742,10577,'bg','Ð’Ñ€ÑŠÑ‰Ð°',0),(380743,10577,'ur','ÙˆØ§Ù¾Ø³ Ø¢ØªØ§ ÛÛ’',0),(380744,10577,'sr','Ð’Ñ€Ð°Ñ›Ð°',0),(380745,10577,'vi','trá»Ÿ láº¡i',0),(380746,10577,'af','Retoere',0),(380747,10577,'ro','ÃŽntoarce',0),(380748,10577,'et','Tagastab',0),(380749,10577,'si','Vrne',0),(380750,10577,'ba','Kembali',0),(380751,10577,'nl','Geeft als resultaat',0),(380752,10577,'fi','Palaa',0),(380753,10577,'no','Returnerer',0),(380754,10577,'da','Afkast',0),(380755,10577,'ko','ë°˜í™˜',0),(380756,10577,'he','×”×—×–×¨×•×ª',0),(380757,10577,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î­Ï‚',0),(380758,10577,'zh','è¿”å›ž\r\n',0),(380759,10577,'sv','Returnerar',0),(380760,10577,'it','Restituisce',0),(380761,10577,'tl','',0),(380762,10577,'th','à¸ªà¹ˆà¸‡à¸„à¸·à¸™',0),(380763,10577,'hi','à¤°à¤¿à¤Ÿà¤°à¥à¤¨',0),(380764,10577,'ms','Pulangan yang',0),(380765,10577,'ar','Ø§Ù„Ù…Ø±Ø¯ÙˆØ¯Ø§Øª',0),(380766,10577,'fr','Retours',0),(380767,10577,'jp','è¿”ã—ã¾ã™',0),(380768,10577,'pt','Retorna',0),(380769,10577,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÑ‚',0),(380770,10577,'es','Devoluciones',0),(380771,10577,'de','Gibt',0),(380772,10577,'en','Returns',0),(380773,10578,'is','',0),(380774,10578,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(380775,10578,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(380776,10578,'tr','Ä°ade faturasÄ±nÄ± oluÅŸturun',0),(380777,10578,'pl','Tworzenie faktury korygujÄ…cej',0),(380778,10578,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(380779,10578,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(380780,10578,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(380781,10578,'vi','táº¡o báº£ng ghi cÃ³',0),(380782,10578,'af','Skep Krediet Memo',0),(380783,10578,'ro','NotÄƒ de Credit de a crea',0),(380784,10578,'et','Lisa krediidi memo',0),(380785,10578,'si','Ustvarite dobropis',0),(380786,10578,'ba','Membuat Memo kredit',0),(380787,10578,'nl','Creditnota maken',0),(380788,10578,'fi','Luo hyvityslasku',0),(380789,10578,'no','Opprett kreditnota',0),(380790,10578,'da','Opret kreditnota',0),(380791,10578,'ko','ì‹ ìš© ë©”ëª¨ ë§Œë“¤ê¸°',0),(380792,10578,'he','×œ×™×¦×•×¨ ×”×–×™×›×•×™',0),(380793,10578,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(380794,10578,'zh','åˆ›å»ºä¿¡ç”¨å¤‡å¿˜å½•\r\n',0),(380795,10578,'sv','Skapa kreditnota',0),(380796,10578,'it','Creare la nota di credito',0),(380797,10578,'tl','',0),(380798,10578,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¸¥à¸”à¸«à¸™à¸µà¹‰',0),(380799,10578,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤¬à¤¨à¤¾à¤à¤',0),(380800,10578,'ms','Mencipta kredit Memo',0),(380801,10578,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù…Ø°ÙƒØ±Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(380802,10578,'fr','CrÃ©er la note de crÃ©dit',0),(380803,10578,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ãƒ¡ãƒ¢ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(380804,10578,'pt','Criar nota de crÃ©dito',0),(380805,10578,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ñƒ',0),(380806,10578,'es','Crear Memo de CrÃ©dito',0),(380807,10578,'de','Gutschrift erstellen',0),(380808,10578,'en','Create Credit Memo',0),(380809,10579,'is','',0),(380810,10579,'dr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(380811,10579,'pr','Ø®Ø·Ø§ ÙŠ Ø§ÙŠØ¬Ø§Ø¯ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(380812,10579,'tr','Hata oluÅŸturma iade faturasÄ±',0),(380813,10579,'pl','BÅ‚Ä…d tworzenia faktury korygujÄ…cej',0),(380814,10579,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(380815,10579,'ur','Ù†Ù‚Øµ Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(380816,10579,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(380817,10579,'vi','Lá»—i khi táº¡o báº£ng ghi cÃ³',0),(380818,10579,'af','Fout skep krediet Memo',0),(380819,10579,'ro','NotÄƒ de Credit crearea de eroare',0),(380820,10579,'et','TÃµrge loomisel kreeditarve',0),(380821,10579,'si','Napaka pri ustvarjanju dobropis',0),(380822,10579,'ba','Memo kredit membuat kesalahan',0),(380823,10579,'nl','Fout creditnota maken',0),(380824,10579,'fi','Virhe luodaan hyvityslasku',0),(380825,10579,'no','Feil under oppretting av kreditnotaen',0),(380826,10579,'da','Fejl at oprette kreditnotaen',0),(380827,10579,'ko','ì˜¤ë¥˜ëŠ” ì‹ ìš© ë©”ëª¨ ë§Œë“¤ê¸°',0),(380828,10579,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×”×–×™×›×•×™',0),(380829,10579,'el','Î£Ï†Î¬Î»Î¼Î± Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ¿Ï Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(380830,10579,'zh','é”™è¯¯åˆ›å»ºä¿¡ç”¨å¤‡å¿˜å½•',0),(380831,10579,'sv','Fel att skapa kreditnota',0),(380832,10579,'it','Errore creazione Nota credito',0),(380833,10579,'tl','',0),(380834,10579,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¸à¸²à¸£à¸ªà¸£à¹‰à¸²à¸‡à¸«à¸™à¸µà¹‰',0),(380835,10579,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤¬à¤¨à¤¾à¤¨à¤¾',0),(380836,10579,'ms','Ralat mencipta kredit Memo',0),(380837,10579,'ar','Ø®Ø·Ø£ Ø¥Ù†Ø´Ø§Ø¡ Ù…Ø°ÙƒØ±Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(380838,10579,'fr','Erreur crÃ©ation d\'un avoir',0),(380839,10579,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆãƒ¡ãƒ¢ã®ä½œæˆã‚¨ãƒ©ãƒ¼',0),(380840,10579,'pt','Erro criando a nota de crÃ©dito',0),(380841,10579,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ñ‹',0),(380842,10579,'es','Error Creando Nombre de CrÃ©dito',0),(380843,10579,'de','Fehler erstellen-Gutschrift',0),(380844,10579,'en','Error Creating Credit Memo',0),(380845,10580,'is','',0),(380846,10580,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ú¯Ø´Øª Ø´Ø¯Ù‡ ',0),(380847,10580,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ú¯Ø´Øª Ø´Ø¯Ù‡ ',0),(380848,10580,'tr','Ä°ade edilen miktar',0),(380849,10580,'pl','IloÅ›Ä‡ zwracanych',0),(380850,10580,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸',0),(380851,10580,'ur','Ù„ÙˆÙ¹Û’ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(380852,10580,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾',0),(380853,10580,'vi','Sá»‘ lÆ°á»£ng tráº£ láº¡i',0),(380854,10580,'af','Hoeveelheid teruggekeer',0),(380855,10580,'ro','Cantitate s-a Ã®ntors',0),(380856,10580,'et','Tagastatud kogus',0),(380857,10580,'si','KoliÄina vrnil',0),(380858,10580,'ba','Jumlah yang dikembalikan',0),(380859,10580,'nl','Hoeveelheid geretourneerd',0),(380860,10580,'fi','Palautettu mÃ¤Ã¤rÃ¤',0),(380861,10580,'no','Antallet returnerte',0),(380862,10580,'da','Antal returnerede',0),(380863,10580,'ko','ìˆ˜ëŸ‰ ë°˜í™˜',0),(380864,10580,'he','×›×ž×•×ª ×©×”×•×—×–×¨×”',0),(380865,10580,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ',0),(380866,10580,'zh','æ•°é‡è¿”å›ž\r\n',0),(380867,10580,'sv','Kvantiteten returnerade',0),(380868,10580,'it','QuantitÃ  restituita',0),(380869,10580,'tl','',0),(380870,10580,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¸„à¸·à¸™',0),(380871,10580,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤²à¥Œà¤Ÿà¥‡',0),(380872,10580,'ms','Kuantiti yang kembali',0),(380873,10580,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø±Ø¯ÙˆØ¯Ø§Øª',0),(380874,10580,'fr','QuantitÃ© retournÃ©e',0),(380875,10580,'jp','è¿”ã•ã‚Œã‚‹æ•°é‡',0),(380876,10580,'pt','Quantidade retornada',0),(380877,10580,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ',0),(380878,10580,'es','Cantidad Devuelto',0),(380879,10580,'de','RÃ¼ckgelieferte',0),(380880,10580,'en','Quantity Returned',0),(380881,10581,'is','',0),(380882,10581,'dr','(Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ',0),(380883,10581,'pr','ÙØ§ÙƒØªÙˆØ± (Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ',0),(380884,10581,'tr','Co fatura',0),(380885,10581,'pl','WspÃ³Å‚pracy faktury',0),(380886,10581,'bg','Ð¡ÑŠ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(380887,10581,'ur','Ù…Ø®Ù„ÙˆØ· Ø§Ù†ÙˆØ§Ø¦Ø³',0),(380888,10581,'sr','ÐšÐ¾Ð»ÐµÐ³Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(380889,10581,'vi','hÃ³a Ä‘Æ¡n cÃ´ng ty',0),(380890,10581,'af','Mede-faktuur',0),(380891,10581,'ro','Co-factura',0),(380892,10581,'et','KoostÃ¶Ã¶ arve',0),(380893,10581,'si','Co-raÄun',0),(380894,10581,'ba','Faktur Co',0),(380895,10581,'nl','Co factuur',0),(380896,10581,'fi','YhteistyÃ¶ssÃ¤ lasku',0),(380897,10581,'no','Co faktura',0),(380898,10581,'da','Co faktura',0),(380899,10581,'ko','ê³µë™ ì†¡ìž¥',0),(380900,10581,'he','×—×©×‘×•× ×™×ª ×œ×¢×‘×•×“×”',0),(380901,10581,'el','Î£Ï…Î½-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(380902,10581,'zh','è”åˆå‘ç¥¨\r\n',0),(380903,10581,'sv','Co faktura',0),(380904,10581,'it','Co-fattura',0),(380905,10581,'tl','',0),(380906,10581,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸£à¹ˆà¸§à¸¡',0),(380907,10581,'hi','à¤¸à¤¹ à¤šà¤¾à¤²à¤¾à¤¨',0),(380908,10581,'ms','Bersama invois',0),(380909,10581,'ar','ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø´Ø§Ø±Ùƒ',0),(380910,10581,'fr','Facture Co',0),(380911,10581,'jp','å…±åŒè«‹æ±‚',0),(380912,10581,'pt','Fatura co',0),(380913,10581,'ru','Ð¡Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(380914,10581,'es','Co-Factura',0),(380915,10581,'de','Co Rechnung',0),(380916,10581,'en','Co-Invoice',0),(380917,10582,'is','',0),(380918,10582,'dr','ØªØ®ÙÙŠÙØ§Øª Ø¨Ø¹Ø¯ Ø§Ø² Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† Ø§Ø¹Ù…Ø§Ù„ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(380919,10582,'pr','ØªØ®ÙÙŠÙØ§Øª Ø¨Ø¹Ø¯ Ø§Ø² Ø°Ø®ÙŠØ±Ù‡ ÙƒØ±Ø¯Ù† Ø§Ø¹Ù…Ø§Ù„ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ',0),(380920,10582,'tr','Kaydettikten sonra indirim uygulanacaktÄ±r',0),(380921,10582,'pl','Rabaty bÄ™dÄ… stosowane po zapisaniu',0),(380922,10582,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ñ‰Ðµ Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸ ÑÐ»ÐµÐ´ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(380923,10582,'ur','Ø¢Ø®Ø± Ù…ÛŒÚº Ú†Ú¾ÙˆÙ¹ Ú©Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ø¹Ø¯ Ù„Ú¯Ø§Ø¦Û’ Ø¬Ø§Ø¦ÛŒÚº Ú¯Û’',0),(380924,10582,'sr','ÐÐ°ÐºÐ¾Ð½ ÑˆÑ‚Ð¾ ÑÑƒ ÑÐ¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ðµ Ð·Ð° Ð·Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð¸ Ð½Ð°',0),(380925,10582,'vi','Chiáº¿t kháº¥u sáº½ Ä‘Æ°á»£c Ã¡p dá»¥ng sao khi trá»« ',0),(380926,10582,'af','Kortings Sal Toegepas Word Na Besparing',0),(380927,10582,'ro','Reducerile vor fi aplicate dupa salvare',0),(380928,10582,'et','Allahindlused rakendatakse peale salvestamist',0),(380929,10582,'si','Popusti veljajo po varÄevanje',0),(380930,10582,'ba','Diskon akan diterapkan setelah menyimpan',0),(380931,10582,'nl','Kortingen worden toegepast na het opslaan',0),(380932,10582,'fi','Alennukset sovelletaan tallentamisen jÃ¤lkeen',0),(380933,10582,'no','Avslag vil bli brukt etter lagring',0),(380934,10582,'da','Rabatter vil blive anvendt efter besparelse',0),(380935,10582,'ko','ì €ìž¥ í›„ í• ì¸ ì ìš©',0),(380936,10582,'he','×”× ×—×•×ª ×™×•×—×œ×• ×œ××—×¨ ×”×©×ž×™×¨×”',0),(380937,10582,'el','Î•ÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ Î¸Î± ÎµÏ†Î±ÏÎ¼Î¿ÏƒÏ„ÎµÎ¯ Î¼ÎµÏ„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·',0),(380938,10582,'zh','æŠ˜æ‰£å°†é€‚ç”¨äºŽä¿å­˜åŽ\r\n',0),(380939,10582,'sv','Rabatter kommer att tillÃ¤mpas efter att du sparat',0),(380940,10582,'it','SCONTI verranno applicati dopo il salvataggio',0),(380941,10582,'tl','',0),(380942,10582,'th','à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¸ˆà¸°à¹ƒà¸Šà¹‰à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸',0),(380943,10582,'hi','à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤›à¥‚à¤Ÿ à¤²à¤¾à¤—à¥‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾',0),(380944,10582,'ms','Diskaun akan dikenakan selepas Menyimpan',0),(380945,10582,'ar','Ø³ÙŠØªÙ… ØªØ·Ø¨ÙŠÙ‚ Ø®ØµÙˆÙ…Ø§Øª Ø¨Ø¹Ø¯ Ø§Ù„Ø­ÙØ¸',0),(380946,10582,'fr','Des rabais s\'appliquera aprÃ¨s la sauvegarde',0),(380947,10582,'jp','ä¿å­˜ã—ãŸå¾Œã«é©ç”¨ã•ã‚Œã‚‹å‰²å¼•',0),(380948,10582,'pt','Descontos serÃ£o aplicados apÃ³s salvar',0),(380949,10582,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ¸ Ð±ÑƒÐ´ÑƒÑ‚ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÑÑ‚ÑŒÑÑ Ð¿Ð¾ÑÐ»Ðµ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ',0),(380950,10582,'es','Descuentos Se AplicarÃ¡n DespuÃ©s de Guardar',0),(380951,10582,'de','Die Rabatte werden nach dem Speichern',0),(380952,10582,'en','Discounts Will Be Applied After Saving',0),(380953,10583,'is','',0),(380954,10583,'dr','Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø±Ø§ Ø¯Ø§Ø±Ø¯ ',0),(380955,10583,'pr','Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´ØªÙŠ Ø±Ø§ Ø¯Ø§Ø±Ø¯ ',0),(380956,10583,'tr','Bu fatura Ã¶ÄŸe dÃ¶ndÃ¼rmedi',0),(380957,10583,'pl','Faktura ta ma zwracane elementy',0),(380958,10583,'bg','Ð¢Ð°Ð·Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ðµ Ð²ÑŠÑ€Ð½Ð°Ð» ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(380959,10583,'ur','Ø§Ø³ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ø´ÛŒØ§Ø¡ ÙˆØ§Ù¾Ø³ Ú©ÛŒØ§ ÛÛ’',0),(380960,10583,'sr','ÐžÐ²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ',0),(380961,10583,'vi','HÃ³a Ä‘Æ¡n nÃ y Ä‘Ã£ tráº£ hÃ ng',0),(380962,10583,'af','Hierdie faktuur het Items terugbesorg',0),(380963,10583,'ro','AceastÄƒ facturÄƒ a revenit elemente',0),(380964,10583,'et','Selle arve on tagastatud kaupu',0),(380965,10583,'si','Ta raÄun je artikle vrnil',0),(380966,10583,'ba','Faktur ini telah kembali item',0),(380967,10583,'nl','Deze factuur is teruggekeerd Items',0),(380968,10583,'fi','TÃ¤mÃ¤ lasku on palauttanut nimikkeitÃ¤',0),(380969,10583,'no','Fakturaen har returnerte varer',0),(380970,10583,'da','Denne faktura returnerede elementer',0),(380971,10583,'ko','ì´ ì†¡ìž¥ í•­ëª© ë°˜í™˜',0),(380972,10583,'he','×—×©×‘×•× ×™×ª ×–×• ×—×–×¨ ×¤×¨×™×˜×™×',0),(380973,10583,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î­Ï‡ÎµÎ¹ ÎµÏ€Î¹ÏƒÏ„ÏÎ­ÏˆÎµÎ¹ Î±Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î±',0),(380974,10583,'zh','æœ¬å‘ç¥¨å½’è¿˜ç‰©å“\r\n',0),(380975,10583,'sv','Denna faktura har returnerat objekt',0),(380976,10583,'it','Questa fattura ha restituito elementi',0),(380977,10583,'tl','',0),(380978,10583,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸™à¸µà¹‰à¹„à¸”à¹‰à¸ªà¹ˆà¸‡à¸„à¸·à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(380979,10583,'hi','à¤‡à¤¸ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤†à¤‡à¤Ÿà¤® à¤µà¤¾à¤ªà¤¸ à¤† à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(380980,10583,'ms','Invois ini telah mengembalikan barang-barang',0),(380981,10583,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ù‡Ø°Ù‡ ØªØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ Ù…Ø±Ø¯ÙˆØ¯Ø§Øª',0),(380982,10583,'fr','Cette facture a des articles retournÃ©s',0),(380983,10583,'jp','ã“ã®è«‹æ±‚æ›¸ã®é …ç›®ãŒè¿”ã•ã‚Œã¾ã—ãŸã€‚',0),(380984,10583,'pt','Esta fatura tem retornado itens',0),(380985,10583,'ru','Ð­Ñ‚Ð¾Ñ‚ ÑÑ‡ÐµÑ‚ Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(380986,10583,'es','Esta Factura Contiene Items Devueltos',0),(380987,10583,'de','Diese Rechnung hat Elemente zurÃ¼ckgegeben.',0),(380988,10583,'en','This Invoice Has Returned Items',0),(380989,10584,'is','',0),(380990,10584,'dr','Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ ØªØºÙŠÙŠØ± Ø¯Ù‡ÙŠØ¯ Ù…Ú¯Ø± Ø§ÙŠÙ†ÙƒÙ‡ Ø§Ø¨ØªØ¯Ø§ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± Ù„ØºÙˆ Ø´ÙˆØ¯ ',0),(380991,10584,'pr','Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ ØªØºÙŠÙŠØ± Ø¯Ù‡ÙŠØ¯ Ù…Ú¯Ø± Ø§ÙŠÙ†ÙƒÙ‡ Ø§Ø¨ØªØ¯Ø§ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø± Ù„ØºÙˆ Ø´ÙˆØ¯ ',0),(380992,10584,'tr','Ä°ade faturasÄ± Ã¶nce iptal sÃ¼rece deÄŸiÅŸtiremezsiniz',0),(380993,10584,'pl','Nie moÅ¼na zmieniÄ‡, chyba Å¼e faktura korygujÄ…ca jest anulowane po raz pierwszy',0),(380994,10584,'bg','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÑÑ‚Ðµ, Ð¾ÑÐ²ÐµÐ½ Ð°ÐºÐ¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ñ‚Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ Ðµ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½ Ð¿ÑŠÑ€Ð²Ð¾',0),(380995,10584,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§ ÛÛ’ Ø¬Ø¨ ØªÚ© Ú©Û Ø¢Ù¾ ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(380996,10584,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ð¸ Ð¾ÑÐ¸Ð¼ Ð°ÐºÐ¾ Ñ˜Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ Ð¿Ñ€Ð²Ð¾ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(380997,10584,'vi','Báº¡n khÃ´ng thá»ƒ thay Ä‘á»•i trá»« khi thÃ´ng bÃ¡o tÃ­n dá»¥ng pháº£i Ä‘Æ°á»£c há»§y trÆ°á»›c',0),(380998,10584,'af','Jy kan nie verander nie tensy krediet Musina Is eers gekanselleer',0),(380999,10584,'ro','Nu se poate schimba cu excepÅ£ia cazului Ã®n nota de Credit este anulat Ã®n primul rÃ¢nd',0),(381000,10584,'et','Ei saa muuta, kui kreeditarve on esmalt tÃ¼histada',0),(381001,10584,'si','Ne morete spremeniti, razen Äe dobropis je preklical prvi',0),(381002,10584,'ba','Anda tidak dapat mengubah kecuali Memo kredit dibatalkan pertama',0),(381003,10584,'nl','U kunt niet wijzigen tenzij creditnota eerst wordt geannuleerd',0),(381004,10584,'fi','Et voi muuttaa ellet hyvityslasku on peruutettu ensin',0),(381005,10584,'no','Du kan ikke endre hvis kreditnotaen annulleres fÃ¸rst',0),(381006,10584,'da','Du kan ikke Ã¦ndre medmindre kreditnotaen er aflyst fÃ¸rst',0),(381007,10584,'ko','ì‹ ìš© ë©”ëª¨ë¥¼ ë¨¼ì € ì·¨ì†Œ í•˜ì§€ ì•ŠëŠ” í•œ ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(381008,10584,'he','×œ× × ×™×ª×Ÿ ×œ×©× ×•×ª ××œ× ×× ×”×–×™×›×•×™ ×‘×•×˜×œ×” ×§×•×“×',0),(381009,10584,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Î±Î»Î»Î¬Î¾ÎµÏ„Îµ, ÎµÎºÏ„ÏŒÏ‚ ÎµÎ¬Î½ Ï„Î¿ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î­Ï‡ÎµÎ¹ Î±ÎºÏ…ÏÏ‰Î¸ÎµÎ¯ Ï€ÏÏŽÏ„Î±',0),(381010,10584,'zh','æ‚¨ä¸èƒ½æ”¹å˜ï¼Œé™¤éžé¦–å…ˆå–æ¶ˆä¿¡ç”¨å¤‡å¿˜å½•\r\n',0),(381011,10584,'sv','Du kan inte Ã¤ndra om kreditnotan avbryts fÃ¶rst',0),(381012,10584,'it','Non puoi cambiare a meno che la nota di credito viene annullata prima',0),(381013,10584,'tl','',0),(381014,10584,'th','à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸¢à¸à¹€à¸§à¹‰à¸™à¸šà¸±à¸™à¸—à¸¶à¸à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¸–à¸¹à¸à¸¢à¸à¹€à¸¥à¸´à¸à¸à¹ˆà¸­à¸™',0),(381015,10584,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤ªà¤¹à¤²à¥‡ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤¹à¥ˆ à¤œà¤¬ à¤¤à¤• à¤•à¤¿ à¤†à¤ª à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(381016,10584,'ms','Anda tidak boleh berubah melainkan Memo kredit dibatalkan terlebih dahulu',0),(381017,10584,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ†Ùƒ ØªØºÙŠÙŠØ± Ù…Ø§ Ù„Ù… ÙŠØªÙ… Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ù…Ø°ÙƒØ±Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø£ÙˆÙ„Ø§Ù‹',0),(381018,10584,'fr','Vous ne pouvez pas modifier Ã  moins que la note de crÃ©dit est annulÃ© tout d\'abord',0),(381019,10584,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆãƒ¡ãƒ¢ã‚’æœ€åˆã«ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã—ãªã„é™ã‚Šå¤‰æ›´ã§ãã¾ã›ã‚“ã€‚',0),(381020,10584,'pt','VocÃª nÃ£o pode mudar a menos que a nota de crÃ©dito for cancelada, primeiro',0),(381021,10584,'ru','Ð’Ñ‹ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ, ÐµÑÐ»Ð¸ ÑÐ½Ð°Ñ‡Ð°Ð»Ð° Ð¾Ñ‚Ð¼ÐµÐ½ÑÐµÑ‚ÑÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ð°',0),(381022,10584,'es','No se Puede Cambiar Hasta Que Cancela el Memo de CrÃ©dito Primero',0),(381023,10584,'de','Sie kÃ¶nnen nicht Ã¤ndern, sofern Gutschrift zunÃ¤chst abgebrochen wird',0),(381024,10584,'en','You Cannot Change Unless Credit Memo Is Canceled First',0),(381025,10585,'is','',0),(381026,10585,'dr','ØªÙ…Ø§Ù… Ø¯ÙŠÚ¯Ø± Ù…Ø­Ù„ Ù‡Ø§',0),(381027,10585,'pr','ØªÙ…Ø§Ù… Ø¯ÙŠÚ¯Ø± Ù…Ø­Ù„ Ù‡Ø§',0),(381028,10585,'tr','DiÄŸer konumlar',0),(381029,10585,'pl','Wszystkie inne lokalizacje',0),(381030,10585,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ñ€ÑƒÐ³Ð¸ Ð¼ÐµÑÑ‚Ð°',0),(381031,10585,'ur','Ø¯ÛŒÚ¯Ø± ØªÙ…Ø§Ù… Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(381032,10585,'sr','Ð¡Ð²Ðµ Ð´Ñ€ÑƒÐ³Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(381033,10585,'vi','Táº¥t cáº£ cÃ¡c Ä‘á»‹a Ä‘iá»ƒm',0),(381034,10585,'af','Alle Ander Liggings',0),(381035,10585,'ro','Toate alte locaÅ£ii',0),(381036,10585,'et','KÃµik muud kohad',0),(381037,10585,'si','Vse druge lokacije',0),(381038,10585,'ba','Semua lokasi lain',0),(381039,10585,'nl','Alle andere locaties',0),(381040,10585,'fi','Muut kohteet',0),(381041,10585,'no','Alle andre plasseringer',0),(381042,10585,'da','Alle andre steder',0),(381043,10585,'ko','ë‹¤ë¥¸ ëª¨ë“  ìœ„ì¹˜',0),(381044,10585,'he','×œ×›×œ ×”×ž×™×§×•×ž×™× ×”××—×¨×™×',0),(381045,10585,'el','ÎŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î¬Î»Î»ÎµÏ‚ Î¸Î­ÏƒÎµÎ¹Ï‚',0),(381046,10585,'zh','æ‰€æœ‰å…¶ä»–åœ°ç‚¹\r\n',0),(381047,10585,'sv','Alla andra platser',0),(381048,10585,'it','Tutte le altre posizioni',0),(381049,10585,'tl','',0),(381050,10585,'th','à¸ªà¸–à¸²à¸™à¸­à¸·à¹ˆà¸™ à¹† à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(381051,10585,'hi','à¤…à¤¨à¥à¤¯ à¤¸à¤­à¥€ à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚',0),(381052,10585,'ms','Semua lokasi lain',0),(381053,10585,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ø£Ø®Ø±Ù‰',0),(381054,10585,'fr','Tous les autres endroits',0),(381055,10585,'jp','ä»–ã®ã™ã¹ã¦ã®å ´æ‰€',0),(381056,10585,'pt','Todos os outros locais',0),(381057,10585,'ru','Ð’ÑÐµ Ð”Ñ€ÑƒÐ³Ð¸Ðµ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(381058,10585,'es','Todos los Otros Localizaciones',0),(381059,10585,'de','Alle anderen Orte',0),(381060,10585,'en','All Other Locations',0),(381061,10586,'is','',0),(381062,10586,'dr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù„Ø§ Ø±Ø§ Ø§Ø² Ø§ÙŠÙ† Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ÙƒÙ¾ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(381063,10586,'pr','Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±ÙŠ ÙƒØ§Ù„Ø§ Ø±Ø§ Ø§Ø² Ø§ÙŠÙ† Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ÙƒÙ¾ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(381064,10586,'tr','Bu stok konumu Ã¶ÄŸesinin fiyatlandÄ±rma kopyalama',0),(381065,10586,'pl','Skopiuj element ceny z tej lokalizacji zapasÃ³w',0),(381066,10586,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð¾Ñ‚ Ñ‚Ð¾Ð²Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(381067,10586,'ur','Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº Ø´Û’ Ø§Ø³ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø³Û’ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(381068,10586,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÑƒ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ° ÑÐ° Ð¾Ð²Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(381069,10586,'vi','sao chÃ©p giÃ¡ hÃ ng tá»« má»¥c hÃ ng tá»“n kho',0),(381070,10586,'af','Kopieer Item Prysberekeninge Vanaf Hierdie Voorraadligging',0),(381071,10586,'ro','Copiere element de stabilire a preÅ£urilor de la aceastÄƒ locaÅ£ie de inventar',0),(381072,10586,'et','Kopeeri Ã¼ksuse hinnakujunduse selle varude asukoha',0),(381073,10586,'si','Prekopirajte element cenitev od to popis mesto',0),(381074,10586,'ba','Menyalin Item harga dari lokasi persediaan',0),(381075,10586,'nl','Kopieer Item prijzen vanaf deze locatie inventaris',0),(381076,10586,'fi','Kopioi kohteen hinnoittelu varaston sijainti',0),(381077,10586,'no','Kopier element priser fra denne lagerlokasjon',0),(381078,10586,'da','Kopiere elementet prisfastsÃ¦ttelse fra denne lagerlokation',0),(381079,10586,'ko','ìž¬ê³  ìœ„ì¹˜ì—ì„œ Pricing í•­ëª© ë³µì‚¬',0),(381080,10586,'he','×œ×”×¢×ª×™×§ ×¤×¨×™×˜ ×ª×ž×—×•×¨ ×ž×ž×™×§×•× ×–×” ×ž×œ××™',0),(381081,10586,'el','Î‘Î½Ï„Î¹Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Î±Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(381082,10586,'zh','ä»Žè¿™ä¸ªæ¸…å•ä½ç½®å¤åˆ¶é¡¹ç›®çš„å®šä»·\r\n',0),(381083,10586,'sv','Kopiera objektet prissÃ¤ttning frÃ¥n detta lagerstÃ¤lle',0),(381084,10586,'it','Copiare l\'elemento prezzi da questa Ubicazione di inventario',0),(381085,10586,'tl','',0),(381086,10586,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¸£à¸²à¸„à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ˆà¸²à¸à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸™à¸µà¹‰',0),(381087,10586,'hi','à¤†à¤‡à¤Ÿà¤® à¤‡à¤¸ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(381088,10586,'ms','Menyalin Item harga dari lokasi inventori ini',0),(381089,10586,'ar','Ù†Ø³Ø® Ø¨Ù†Ø¯ Ø§Ù„ØªØ³Ø¹ÙŠØ± Ù…Ù† Ù…ÙˆÙ‚Ø¹ Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(381090,10586,'fr','Copier l\'Ã©lÃ©ment prix depuis cet emplacement de l\'inventaire',0),(381091,10586,'jp','ã“ã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®å ´æ‰€ã‹ã‚‰ã®ã‚¢ã‚¤ãƒ†ãƒ ã®ä¾¡æ ¼ã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(381092,10586,'pt','Copiar Item preÃ§os deste local do inventÃ¡rio',0),(381093,10586,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ†ÐµÐ½Ñ‹ Ð¸Ð· ÑÑ‚Ð¾Ð³Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(381094,10586,'es','Copiar Precios de Items de Esta Sitio de Inventario',0),(381095,10586,'de','Kopieren Sie Element Preise aus diesem Inventar-Verzeichnis',0),(381096,10586,'en','Copy Item Pricing From This Inventory Location',0),(381097,10587,'is','',0),(381098,10587,'dr','ÙƒÙ¾ÙŠ Ù‚ÙŠÙ…Øª  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(381099,10587,'pr','ÙƒÙ¾ÙŠ Ù‚ÙŠÙ…Øª  Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(381100,10587,'tr','Stok fiyat kopyasÄ±',0),(381101,10587,'pl','zapasy cena kopii',0),(381102,10587,'bg','ÑÐºÐ»Ð°Ð´ Ñ†ÐµÐ½Ð° ÐºÐ¾Ð¿Ð¸Ðµ',0),(381103,10587,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù‚ÛŒÙ…Øª Ù†Ù‚Ù„',0),(381104,10587,'sr','Ð·Ð°Ð»Ð¸Ñ…Ð° Ñ†ÐµÐ½Ð° ÐºÐ¾Ð¿Ð¸Ñ˜Ñƒ',0),(381105,10587,'vi','hÃ ng tá»“n kho giÃ¡ báº£n sao',0),(381106,10587,'af','voorraad prys afskrif',0),(381107,10587,'ro','inventar Pret copii',0),(381108,10587,'et','varude hinna koopia',0),(381109,10587,'si','Cena kopija inventar',0),(381110,10587,'ba','persediaan harga Copy',0),(381111,10587,'nl','voorraad prijs kopie',0),(381112,10587,'fi','varaston hinta kopio',0),(381113,10587,'no','lager pris kopi',0),(381114,10587,'da','lager pris kopi',0),(381115,10587,'ko','ìž¬ê³  ê°€ê²© ë³µì‚¬',0),(381116,10587,'he','×ž×œ××™ ×ž×—×™×¨ ×¢×•×ª×§',0),(381117,10587,'el','Î±Ï€Î¿Î³ÏÎ±Ï†Î® Ï„Î¹Î¼Î® Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿',0),(381118,10587,'zh','åº“å­˜ä»·æ ¼å¤åˆ¶\r\n',0),(381119,10587,'sv','inventering pris kopia',0),(381120,10587,'it','inventario prezzo copia',0),(381121,10587,'tl','',0),(381122,10587,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¸£à¸²à¸„à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(381123,10587,'hi','à¤¸à¥‚à¤šà¥€ à¤®à¥‚à¤²à¥à¤¯ à¤ªà¥à¤°à¤¤à¤¿',0),(381124,10587,'ms','Inventori salinan harga',0),(381125,10587,'ar','Ø³Ø¹Ø± Ø§Ù„Ù†Ø³Ø®Ø© Ù„Ù„Ù…Ø®Ø²ÙˆÙ†',0),(381126,10587,'fr','inventaire prix copie',0),(381127,10587,'jp','åœ¨åº«ä¾¡æ ¼ã®ã‚³ãƒ”ãƒ¼',0),(381128,10587,'pt','PreÃ§o cÃ³pia do inventÃ¡rio',0),(381129,10587,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¦ÐµÐ½Ð° ÐºÐ¾Ð¿Ð¸Ð¸',0),(381130,10587,'es','Copia de Precio de Inventario',0),(381131,10587,'de','Preiskopie Warenbestand',0),(381132,10587,'en','inventory Price Copy',0),(381133,10588,'is','',0),(381134,10588,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ ÙƒÙ¾ÙŠ Ø´Ø¯ ',0),(381135,10588,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ ÙƒÙ¾ÙŠ Ø´Ø¯ ',0),(381136,10588,'tr','Kopyalanan fiyatlarÄ±',0),(381137,10588,'pl','Ceny skopiowane',0),(381138,10588,'bg','Ð¦ÐµÐ½Ð¸ Ð´Ð° ÑÐµ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ñ‚',0),(381139,10588,'ur','Ù†Ù‚Ù„ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº',0),(381140,10588,'sr','Ð¦ÐµÐ½Ð° Ñ˜Ðµ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð¾',0),(381141,10588,'vi','sao chÃ©p giÃ¡',0),(381142,10588,'af','Pryse gekopieer',0),(381143,10588,'ro','PreÅ£urile de copiat',0),(381144,10588,'et','Kopeeritud hinnad',0),(381145,10588,'si','Cene kopirati',0),(381146,10588,'ba','Harga disalin',0),(381147,10588,'nl','Prijzen gekopieerd',0),(381148,10588,'fi','Kopioi hinnat',0),(381149,10588,'no','Prisene kopiert',0),(381150,10588,'da','Priser kopieres',0),(381151,10588,'ko','ë³µì‚¬ ê°€ê²©',0),(381152,10588,'he','×ž×—×™×¨×™× ×œ×”×¢×ª×™×§',0),(381153,10588,'el','Î¤Î¹Î¼Î­Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Î½Ï„Î¹Î³ÏÎ±Ï†ÎµÎ¯',0),(381154,10588,'zh','ä»·æ ¼å¤åˆ¶\r\n',0),(381155,10588,'sv','Priserna kopieras',0),(381156,10588,'it','Prezzi copiati',0),(381157,10588,'tl','',0),(381158,10588,'th','à¸£à¸²à¸„à¸²à¸„à¸±à¸”à¸¥à¸­à¸',0),(381159,10588,'hi','à¤¨à¤•à¤² à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‡à¤‚',0),(381160,10588,'ms','Harga yang disalin',0),(381161,10588,'ar','Ø£Ø³Ø¹Ø§Ø± Ù†Ø³Ø®',0),(381162,10588,'fr','Prix copiÃ©s',0),(381163,10588,'jp','ã‚³ãƒ”ãƒ¼ã®ä¾¡æ ¼',0),(381164,10588,'pt','PreÃ§os copiados',0),(381165,10588,'ru','Ð¦ÐµÐ½Ñ‹ ÑÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½',0),(381166,10588,'es','Precios Copiados',0),(381167,10588,'de','Preise kopiert',0),(381168,10588,'en','Prices Copied',0),(381169,10589,'is','',0),(381170,10589,'dr','ÙƒÙ¾ÙŠ Ù‚ÙŠÙ…Øª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(381171,10589,'pr','ÙƒÙ¾ÙŠ Ù‚ÙŠÙ…Øª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(381172,10589,'tr','Fiyat kopyasÄ± baÅŸarÄ±sÄ±z oldu',0),(381173,10589,'pl','Cena kopii nie powiodÅ‚o siÄ™',0),(381174,10589,'bg','Ð¦ÐµÐ½Ð° ÐºÐ¾Ð¿Ð¸Ðµ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(381175,10589,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ù†Ù‚Ù„ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(381176,10589,'sr','Ð¦ÐµÐ½Ð° ÐºÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐ° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð°',0),(381177,10589,'vi','sao chÃ©p giÃ¡ tháº¥t báº¡i',0),(381178,10589,'af','Prys kopieer het misluk',0),(381179,10589,'ro','Pret copie a eÅŸuat',0),(381180,10589,'et','Hinna koopia nurjus',0),(381181,10589,'si','Cena izvoda ni uspela',0),(381182,10589,'ba','Harga Copy gagal',0),(381183,10589,'nl','Prijs kopie is mislukt',0),(381184,10589,'fi','Hinta kopiointi ei onnistunut',0),(381185,10589,'no','Pris kopi mislyktes',0),(381186,10589,'da','Pris kopi mislykkedes',0),(381187,10589,'ko','ê°€ê²©ì„ ë³µì‚¬ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤',0),(381188,10589,'he','×ž×—×™×¨ ×¢×•×ª×§ × ×›×©×œ',0),(381189,10589,'el','Î‘Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Ï„Î¹Î¼Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(381190,10589,'zh','ä»·æ ¼å¤åˆ¶å¤±è´¥\r\n',0),(381191,10589,'sv','Pris exemplar misslyckades',0),(381192,10589,'it','Prezzo copia non riuscita',0),(381193,10589,'tl','',0),(381194,10589,'th','à¸£à¸²à¸„à¸²à¸„à¸±à¸”à¸¥à¸­à¸à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(381195,10589,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤µà¤¿à¤«à¤²',0),(381196,10589,'ms','Salinan harga yang gagal',0),(381197,10589,'ar','ÙØ´Ù„ Ù†Ø³Ø® Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(381198,10589,'fr','Prix copie a Ã©chouÃ©',0),(381199,10589,'jp','ä¾¡æ ¼ã‚³ãƒ”ãƒ¼ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(381200,10589,'pt','PreÃ§o cÃ³pia falhada',0),(381201,10589,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¦ÐµÐ½Ð°',0),(381202,10589,'es','Copiar Precios FallÃ³',0),(381203,10589,'de','Preiskopie fehlgeschlagen',0),(381204,10589,'en','Price Copy Failed',0),(381205,10590,'is','',0),(381206,10590,'dr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(381207,10590,'pr','Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(381208,10590,'tr','Bu stok konumu',0),(381209,10590,'pl','Do tej lokalizacji zapasÃ³w',0),(381210,10590,'bg','Ð¢Ð¾Ð²Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(381211,10590,'ur','Ø§Ø³ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø±',0),(381212,10590,'sr','ÐÐ° Ð¾Ð²Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(381213,10590,'vi','Ä‘áº¿n kho hÃ ng nÃ y',0),(381214,10590,'af','Om hierdie voorraad ligging',0),(381215,10590,'ro','La aceastÄƒ locaÅ£ie de inventar',0),(381216,10590,'et','Selle lao kohta',0),(381217,10590,'si','Za to lokacijo zaloge',0),(381218,10590,'ba','Ke lokasi persediaan ini',0),(381219,10590,'nl','Naar de locatie van deze inventaris',0),(381220,10590,'fi','TÃ¤mÃ¤n varaston sijainnin',0),(381221,10590,'no','Til denne lagerlokasjon',0),(381222,10590,'da','Til denne lagerlokation',0),(381223,10590,'ko','ì´ ìž¬ê³  ìœ„ì¹˜',0),(381224,10590,'he','×œ×ž×™×§×•× ×–×” ×ž×œ××™',0),(381225,10590,'el','Î£Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î±Ï€Î¿Î³ÏÎ±Ï†Î® Î¸Î­ÏƒÎ·',0),(381226,10590,'zh','ä¸ºäº†è¿™ä¸ªåº“å­˜çš„ä½ç½®\r\n',0),(381227,10590,'sv','Till detta lagerstÃ¤lle',0),(381228,10590,'it','In questo percorso di inventario',0),(381229,10590,'tl','',0),(381230,10590,'th','à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸™à¸µà¹‰',0),(381231,10590,'hi','à¤‡à¤¸ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤°',0),(381232,10590,'ms','Ke lokasi inventori ini',0),(381233,10590,'ar','Ø¥Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(381234,10590,'fr','Ã€ cet endroit de l\'inventaire',0),(381235,10590,'jp','ã“ã®åœ¨åº«å ´æ‰€ã«',0),(381236,10590,'pt','Para este local do inventÃ¡rio',0),(381237,10590,'ru','ÐÐ° ÑÑ‚Ð¾Ð¼ ÑÐºÐ»Ð°Ð´Ðµ',0),(381238,10590,'es','A Este Sitio de Inventario',0),(381239,10590,'de','An diesem Lagerort',0),(381240,10590,'en','To This Inventory Location',0),(381241,10591,'is','',0),(381242,10591,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø¯ÙˆÙ† ÙØ±ÙˆØ´ Ù‡Ø§',0),(381243,10591,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† Ø¨Ø¯ÙˆÙ† ÙØ±ÙˆØ´ Ù‡Ø§',0),(381244,10591,'tr','Sadece mÃ¼ÅŸteriler satÄ±ÅŸ olmayan gÃ¶ster',0),(381245,10591,'pl','PokaÅ¼ tylko klienci nie prowadzÄ… sprzedaÅ¼y',0),(381246,10591,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ñ Ð½Ð¸ÐºÐ°ÐºÐ²Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(381247,10591,'ur','Ú¯Ø§ÛÚ© Ú©ÙˆØ¦ÛŒ Ø³ÛŒÙ„Ø² Ú©Û’ Ø³Ø§ØªÚ¾ ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(381248,10591,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð°Ð¾ ÑÐ°Ð¼Ð¾ ÐºÑƒÐ¿Ñ†Ðµ ÑÐ° Ð½ÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(381249,10591,'vi','chá»‰  thá»ƒ hiá»‡n nhá»¯ng khÃ¡ch hÃ ng khÃ´ng doanh sá»‘',0),(381250,10591,'af','Wys Alleenlik Klante/KliÃ«nte Met Geen Verkope',0),(381251,10591,'ro','AratÄƒ numai clienÅ£ii cu nici o vÃ¢nzare',0),(381252,10591,'et','Kuva ainult need kliendid, kellele pole mÃ¼Ã¼dud',0),(381253,10591,'si','PokaÅ¾i le stranke brez prodaje',0),(381254,10591,'ba','Tampilkan hanya pelanggan dengan tidak ada penjualan',0),(381255,10591,'nl','Toon alleen klanten waarin niets is verkocht',0),(381256,10591,'fi','NÃ¤ytÃ¤ vain Asiakkaat, joilla ei ole myyntiÃ¤',0),(381257,10591,'no','Vis bare kunder med ingen salg',0),(381258,10591,'da','Vis kun kunder med ingen salg',0),(381259,10591,'ko','ì‡¼ë§Œ ê³ ê°ì— íŒë§¤',0),(381260,10591,'he','×”×¦×’ ×¨×§ ××ª ×”×œ×§×•×—×•×ª ×¢× ××™×Ÿ ×ž×›×™×¨×•×ª',0),(381261,10591,'el','Î•Î¼Ï†Î±Î½Î¯Î¶ÎµÎ¹ Î¼ÏŒÎ½Î¿ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¿Ï… Î´ÎµÎ½ Ï€ÏÎ±Î³Î¼Î±Ï„Î¿Ï€Î¿Î¯Î·ÏƒÎ±Î½ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(381262,10591,'zh','ä»…æ˜¾ç¤ºæ²¡æœ‰é”€å”®çš„å®¢æˆ·\r\n',0),(381263,10591,'sv','Visa endast kunder med ingen fÃ¶rsÃ¤ljning',0),(381264,10591,'it','Visualizza solo i clienti con nessuna vendita',0),(381265,10591,'tl','',0),(381266,10591,'th','à¹à¸ªà¸”à¸‡à¹€à¸‰à¸žà¸²à¸°à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆ à¸¡à¸µà¸¢à¸­à¸”à¸‚à¸²à¸¢',0),(381267,10591,'hi','à¤•à¥‹à¤ˆ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¹à¥€ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(381268,10591,'ms','Menunjukkan hanya pelanggan dengan tiada jualan',0),(381269,10591,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ÙÙ‚Ø· Ù…Ø¹ Ù„Ø§ Ù…Ø¨ÙŠØ¹Ø§Øª',0),(381270,10591,'fr','Afficher uniquement les clients sans ventes',0),(381271,10591,'jp','ãªã„è²©å£²ã®é¡§å®¢ã ã‘ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(381272,10591,'pt','Mostrar apenas os clientes sem vendas',0),(381273,10591,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð‘ÐµÐ· ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(381274,10591,'es','Mostrar Solo Clientes Sin Ventas',0),(381275,10591,'de','Nur Kunden, die keine VerkÃ¤ufe anzeigen',0),(381276,10591,'en','Show Only Customers With No Sales',0),(381277,10592,'is','',0),(381278,10592,'dr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ Ù‡Ø§ Ø±Ø§ Ø¯Ø± Ø¬Ø§ÙŠ Ø¯ÙŠÚ¯Ø± ÙƒÙ¾ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(381279,10592,'pr','Ù‚ÙŠÙ…Øª Ù‡Ø§ÙŠ ÙƒØ§Ù„Ø§ Ù‡Ø§ Ø±Ø§ Ø¯Ø± Ø¬Ø§ÙŠ Ø¯ÙŠÚ¯Ø± ÙƒÙ¾ÙŠ ÙƒÙ†ÙŠØ¯ ',0),(381280,10592,'tr','Madde fiyatlarÄ±nÄ± baÅŸka bir konuma kopyala',0),(381281,10592,'pl','Skopiuj element ceny do innej lokalizacji',0),(381282,10592,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¸ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ ÐºÑŠÐ¼ Ð´Ñ€ÑƒÐ³Ð¾ Ð¼ÑÑÑ‚Ð¾',0),(381283,10592,'ur','Ø´Û’ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ùˆ Ø¯ÙˆØ³Ø±Û’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø± Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(381284,10592,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ñ†ÐµÐ½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð½Ð° Ð´Ñ€ÑƒÐ³Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(381285,10592,'vi','sao chÃ©p cÃ¡c má»¥c giÃ¡ Ä‘áº¿n nÆ¡i khÃ¡c',0),(381286,10592,'af','Kopieer Itempryse Na Ander Ligging',0),(381287,10592,'ro','CopiaÅ£i preÅ£urile articolelor Ã®n altÄƒ locaÅ£ie',0),(381288,10592,'et','Kaupade hinnad kopeerimiseks muude asukohta',0),(381289,10592,'si','Cene artiklov kopijo na drugo lokacijo',0),(381290,10592,'ba','Salin harga barang ke lokasi lain',0),(381291,10592,'nl','Artikelprijzen kopiÃ«ren naar andere locatie',0),(381292,10592,'fi','Kopioi nimikehinnat toiseen sijaintiin',0),(381293,10592,'no','Kopiere salgspriser til andre plasseringen',0),(381294,10592,'da','Kopiere varepriser til andre placering',0),(381295,10592,'ko','í•­ëª© ê°€ê²© ë‹¤ë¥¸ ìœ„ì¹˜ì— ë³µì‚¬',0),(381296,10592,'he','×”×¢×ª×§ ×ž×—×™×¨×™ ×¤×¨×™×˜×™× ×œ×ž×™×§×•× ××—×¨',0),(381297,10592,'el','Î‘Î½Ï„Î¹Î³ÏÎ±Ï†Î® Ï„Î¹Î¼ÏŽÎ½ ÎµÎ¹Î´ÏŽÎ½ ÏƒÎµ Î¬Î»Î»Î· Î¸Î­ÏƒÎ·',0),(381298,10592,'zh','å¤åˆ¶é¡¹ç›®ä»·æ ¼åˆ°å…¶ä»–ä½ç½®\r\n',0),(381299,10592,'sv','Kopiera artikelpriser till andra plats',0),(381300,10592,'it','Prezzi articoli copia altro percorso',0),(381301,10592,'tl','',0),(381302,10592,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¸£à¸²à¸„à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¹„à¸›à¸¢à¸±à¸‡à¸ªà¸–à¸²à¸™à¸­à¸·à¹ˆà¸™ à¹†',0),(381303,10592,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤…à¤¨à¥à¤¯ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤° à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(381304,10592,'ms','Salin Item harga ke lokasi lain',0),(381305,10592,'ar','Ù†Ø³Ø® Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø£ØµÙ†Ø§Ù Ø¥Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ Ø¢Ø®Ø±',0),(381306,10592,'fr','Prix article copie Ã  l\'autre endroit',0),(381307,10592,'jp','ä»–ã®å ´æ‰€ã«ã‚¢ã‚¤ãƒ†ãƒ ã®ä¾¡æ ¼ã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(381308,10592,'pt','PreÃ§os de Item copiar para outro local',0),(381309,10592,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¢Ð¾Ð²Ð°Ñ€Ð° Ð’ Ð”Ñ€ÑƒÐ³Ð¾Ðµ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(381310,10592,'es','Copiar Precios de Items a las Otras Localizaciones',0),(381311,10592,'de','Artikelpreise in anderen Speicherort kopieren',0),(381312,10592,'en','Copy Item Prices To Other Location',0),(381313,10593,'is','',0),(381314,10593,'dr','ÙƒÙ¾ÙŠ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±Ù‰',0),(381315,10593,'pr','ÙƒÙ¾ÙŠ Ù‚ÙŠÙ…Øª Ú¯Ø°Ø§Ø±Ù‰',0),(381316,10593,'tr','FiyatlandÄ±rma kopyalama',0),(381317,10593,'pl','Kopiowanie, ceny',0),(381318,10593,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(381319,10593,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(381320,10593,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ˜ Ñ†ÐµÐ½Ðµ',0),(381321,10593,'vi','Sao chÃ©p giÃ¡',0),(381322,10593,'af','Kopieer pryse',0),(381323,10593,'ro','Copia de stabilire a preÅ£urilor',0),(381324,10593,'et','Kopeeri hinnakujundus',0),(381325,10593,'si','Kopirati oblikovanje cen',0),(381326,10593,'ba','Menyalin harga',0),(381327,10593,'nl','KopiÃ«ren prijzen',0),(381328,10593,'fi','Kopioi hinnoittelu',0),(381329,10593,'no','Kopiere priser',0),(381330,10593,'da','Kopiere prissÃ¦tning',0),(381331,10593,'ko','ë³µì‚¬ ê°€ê²©',0),(381332,10593,'he','×”×¢×ª×§ ×ª×ž×—×•×¨',0),(381333,10593,'el','Î‘Î½Ï„Î¹Î³ÏÎ±Ï†Î® Ï„Î¹Î¼ÏŽÎ½',0),(381334,10593,'zh','å¤åˆ¶å®šä»·\r\n',0),(381335,10593,'sv','Kopiera prissÃ¤ttning',0),(381336,10593,'it','Copiare prezzi',0),(381337,10593,'tl','',0),(381338,10593,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¸£à¸²à¸„à¸²',0),(381339,10593,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(381340,10593,'ms','Salin harga',0),(381341,10593,'ar','Ù†Ø³Ø® Ø§Ù„ØªØ³Ø¹ÙŠØ±Ø©',0),(381342,10593,'fr','Copier la tarification',0),(381343,10593,'jp','ä¾¡æ ¼è¨­å®šã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(381344,10593,'pt','Copie os preÃ§os',0),(381345,10593,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ†ÐµÐ½',0),(381346,10593,'es','Copiar Precios',0),(381347,10593,'de','Preise kopieren',0),(381348,10593,'en','Copy Pricing',0),(381349,10594,'is','',0),(381350,10594,'dr','ØªØ®ÙÙŠÙØ§Øª ÙØ§ÙƒØªÙˆØ± ',0),(381351,10594,'pr','ØªØ®ÙÙŠÙØ§Øª ÙØ§ÙƒØªÙˆØ± ',0),(381352,10594,'tr','Fatura Ä°skontolarÄ±',0),(381353,10594,'pl','Rabaty faktur',0),(381354,10594,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(381355,10594,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø±Ø¹Ø§ÛŒØª',0),(381356,10594,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚Ð¸ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(381357,10594,'vi','hÃ³a Ä‘Æ¡n giáº£m giÃ¡',0),(381358,10594,'af','Faktuur Kortings',0),(381359,10594,'ro','Reduceri facturÄƒ',0),(381360,10594,'et','Arve hinnaalandid',0),(381361,10594,'si','Popusti raÄuna',0),(381362,10594,'ba','Faktur DISKON',0),(381363,10594,'nl','Factuurkortingen',0),(381364,10594,'fi','Laskualennukset',0),(381365,10594,'no','Fakturarabatter',0),(381366,10594,'da','Fakturarabatter',0),(381367,10594,'ko','ì²­êµ¬ì„œ í• ì¸',0),(381368,10594,'he','×”× ×—×•×ª ×—×©×‘×•× ×™×ª',0),(381369,10594,'el','Î•ÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(381370,10594,'zh','å‘ç¥¨æŠ˜æ‰£\r\n',0),(381371,10594,'sv','Fakturarabatter',0),(381372,10594,'it','Sconti fattura',0),(381373,10594,'tl','',0),(381374,10594,'th','à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œ',0),(381375,10594,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤›à¥‚à¤Ÿ',0),(381376,10594,'ms','Diskaun invois',0),(381377,10594,'ar','ØªØ®ÙÙŠØ¶Ø§Øª Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(381378,10594,'fr','Remises facture',0),(381379,10594,'jp','è«‹æ±‚æ›¸ã®å‰²å¼•',0),(381380,10594,'pt','Descontos de factura',0),(381381,10594,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ¸ ÑÑ‡ÐµÑ‚Ð°',0),(381382,10594,'es','Descuentos de Factura',0),(381383,10594,'de','Rechnungsrabatte',0),(381384,10594,'en','Invoice Discounts',0),(381385,10595,'is','',0),(381386,10595,'dr','Ø¨Ø±Ú¯Ø´Øª ÙƒØ§Ù„Ø§',0),(381387,10595,'pr','Ø¨Ø±Ú¯Ø´Øª ÙƒØ§Ù„Ø§',0),(381388,10595,'tr','Ã–ÄŸeyi dÃ¶ndÃ¼rÃ¼r',0),(381389,10595,'pl','Zwraca element',0),(381390,10595,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÑÐµ Ð²Ñ€ÑŠÑ‰Ð°',0),(381391,10595,'ur','Ø´Û’ Ù¾Ø± ÙˆØ§Ù¾Ø³ Ø¢ØªØ§ ÛÛ’',0),(381392,10595,'sr','Ð’Ñ€Ð°Ñ›Ð° ÑÑ‚Ð°Ð²ÐºÑƒ',0),(381393,10595,'vi','hÃ ng tráº£ láº¡i',0),(381394,10595,'af','Item Retoere',0),(381395,10595,'ro','Element de returnare',0),(381396,10595,'et','Kaubatagastuste',0),(381397,10595,'si','Artikel vrne',0),(381398,10595,'ba','Pengembalian barang',0),(381399,10595,'nl','Item Returns',0),(381400,10595,'fi','Nimikkeiden palautuksista',0),(381401,10595,'no','Returnerte varer',0),(381402,10595,'da','Post returnerer',0),(381403,10595,'ko','í•­ëª© ë°˜í™˜',0),(381404,10595,'he','×¤×¨×™×˜ ×—×•×–×¨',0),(381405,10595,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÏ€Î¹ÏƒÏ„ÏÎ­Ï†ÎµÎ¹',0),(381406,10595,'zh','é¡¹ç›®è¿”å›ž\r\n',0),(381407,10595,'sv','Artikelreturer',0),(381408,10595,'it','Elemento restituisce',0),(381409,10595,'tl','',0),(381410,10595,'th','à¸„à¸·à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(381411,10595,'hi','à¤†à¤‡à¤Ÿà¤® à¤°à¤¿à¤Ÿà¤°à¥à¤¨',0),(381412,10595,'ms','Item pulangan',0),(381413,10595,'ar','Ù…Ø±Ø¯ÙˆØ¯Ø§Øª Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(381414,10595,'fr','Item retourne',0),(381415,10595,'jp','é …ç›®ã‚’è¿”ã—ã¾ã™',0),(381416,10595,'pt','Item retorna',0),(381417,10595,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÑ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(381418,10595,'es','evoluciÃ³n de Items',0),(381419,10595,'de','Artikel Returns',0),(381420,10595,'en','Item Returns',0),(381421,10596,'is','',0),(381422,10596,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø§Ø² ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ùˆ Ø§ÙŠØ¬Ø§Ø¯ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†Ú©Ø§Ø±',0),(381423,10596,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ù„Ø§Ù‡Ø§ Ø§Ø² ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¨Ø±Ú¯Ø´Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ùˆ Ø§ÙŠØ¬Ø§Ø¯ Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡ Ø¨Ø³ØªØ§Ù†Ú©Ø§Ø±',0),(381424,10596,'tr','Ã–ÄŸeleri iade faturalarÄ±ndan seÃ§in ve iade faturasÄ± oluÅŸturun',0),(381425,10596,'pl','Wybierz pozycje z faktury zwracanych i utworzyÄ‡ fakturÄ™ korygujÄ…cÄ…',0),(381426,10596,'bg','Ð˜Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ ÑÐµ Ð²Ñ€ÑŠÑ‰Ð° Ð¸ Ð´Ð° ÑÐµ ÑÑŠÐ·Ð´Ð°Ð´Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(381427,10596,'ur','ÙˆØ¨Ø¬Ù„ÛŒ ÙˆØ§Ù¾Ø³ ÛÙˆÙ†Û’ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ø§Ø´ÛŒØ§Ø¡ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(381428,10596,'sr','Ð‘Ð¸Ñ€Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¸Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð²Ñ€Ð°Ñ›Ð°Ñ˜Ñƒ Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(381429,10596,'vi','Chá»n nhá»¯ng máº·t hÃ ng tá»« nhÃ¬n hÃ³a Ä‘Æ¡n bá»‹ tráº£ vá» vÃ  táº¡o má»™t báº£n ghi nhá»›',0),(381430,10596,'af','Kies Items van fakture word teruggestuur en skep krediet Memo',0),(381431,10596,'ro','SelectaÅ£i elementele din facturile sunt returnate ÅŸi de a crea note de Credit',0),(381432,10596,'et','Valida Ã¼ksused tagastatud arved ja Loo kreeditarve',0),(381433,10596,'si','Izberite elemente iz raÄunov, ki so bila vrnjena in ustvarite dobropis',0),(381434,10596,'ba','Pilih item dari tagihan dikembalikan dan membuat Memo kredit',0),(381435,10596,'nl','Selecteer Items vanaf teruggestuurd facturen en creditnota maken',0),(381436,10596,'fi','Valitse tuotteet palautetut laskut ja Luo hyvityslasku',0),(381437,10596,'no','Velg elementer fra fakturaer som returneres og Opprett kreditnota',0),(381438,10596,'da','VÃ¦lge elementer fra fakturaer returneres og Opret kreditnota',0),(381439,10596,'ko','ë°˜í™˜ ë˜ëŠ” ì²­êµ¬ì„œì—ì„œ í•­ëª©ì„ ì„ íƒ í•˜ ê³  ì‹ ìš© ë©”ëª¨ ë§Œë“¤ê¸°',0),(381440,10596,'he','×‘×—×¨ ×¤×¨×™×˜×™× ×ž×ª×•×š ×—×©×‘×•× ×™×•×ª ×ž×•×—×–×¨ ×•×œ×™×¦×•×¨ ×”×–×™×›×•×™',0),(381441,10596,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Ï€ÏŒ Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… ÎµÏ€Î¹ÏƒÏ„ÏÎ­Ï†ÎµÏ„Î±Î¹ ÎºÎ±Î¹ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(381442,10596,'zh','ä»Žå°†è¦é€€å›žçš„å‘ç¥¨ä¸­é€‰æ‹©é¡¹ç›®å¹¶åˆ›å»ºä¿¡ç”¨å¤‡å¿˜å½•\r\n',0),(381443,10596,'sv','Markera objekt frÃ¥n fakturor som returneras och skapa kreditnota',0),(381444,10596,'it','Selezionare gli elementi da fatture restituite e creare la nota di credito',0),(381445,10596,'tl','',0),(381446,10596,'th','à¹€à¸¥à¸·à¸­à¸à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ˆà¸²à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¸„à¸·à¸™ à¹à¸¥à¸°à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¸¥à¸”à¸«à¸™à¸µà¹‰',0),(381447,10596,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¥‡ à¤²à¥Œà¤Ÿà¤¾ à¤œà¤¾ à¤°à¤¹à¤¾ à¤†à¤‡à¤Ÿà¤® à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤¬à¤¨à¤¾à¤à¤',0),(381448,10596,'ms','Pilih item dari invois-invois yang dipulangkan dan mencipta kredit Memo',0),(381449,10596,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ù…Ù† Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªÙŠ ÙŠØªÙ… Ø¥Ø±Ø¬Ø§Ø¹Ù‡Ø§ ÙˆØ¥Ù†Ø´Ø§Ø¡ Ù…Ø°ÙƒØ±Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(381450,10596,'fr','SÃ©lectionnez des Ã©lÃ©ments dans les factures Ã©tant retournÃ©s et crÃ©er la note de crÃ©dit',0),(381451,10596,'jp','è¿”ã•ã‚Œã‚‹è«‹æ±‚æ›¸ã‹ã‚‰é …ç›®ã‚’é¸æŠžã—ã€ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ãƒ¡ãƒ¢ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(381452,10596,'pt','Selecionar itens de facturas sendo retornadas e criar nota de crÃ©dito',0),(381453,10596,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¸Ð· ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÑ‚ÑÑ Ð¸ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ñƒ',0),(381454,10596,'es','Selecciona Items de las Facturas Que se Devolvieron y Crear un Memo de CrÃ©dito',0),(381455,10596,'de','AuswÃ¤hlen von Elementen in Rechnungen zurÃ¼ckgeschickt und Gutschrift zu erstellen',0),(381456,10596,'en','Select Items From Invoices Being Returned And Create Credit Memo',0),(381457,10597,'is','',0),(381458,10597,'dr','Ø§Ø¬Ø§Ø²Ù‡ ØµØ¯ÙˆØ± ÙØ§ÙƒØªÙˆØ± Ù…Ø´ØªØ±Ùƒ ',0),(381459,10597,'pr','Ø§Ø¬Ø§Ø²Ù‡ ØµØ¯ÙˆØ± ÙØ§ÙƒØªÙˆØ± Ù…Ø´ØªØ±Ùƒ ',0),(381460,10597,'tr','Co faturalama izin ver',0),(381461,10597,'pl','UmoÅ¼liwienia wspÃ³Å‚pracy fakturowania',0),(381462,10597,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ ÑÑŠÐ²Ð¼ÐµÑÑ‚Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(381463,10597,'ur','ØªØ¹Ø§ÙˆÙ† Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(381464,10597,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ ÑÐ°Ñ€Ð°Ð´ÑšÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐ°',0),(381465,10597,'vi','Cho phÃ©p ghÃ©p chung hÃ³a Ä‘Æ¡n',0),(381466,10597,'af','Mede-Invoicing laat',0),(381467,10597,'ro','Permite co-facturare',0),(381468,10597,'et','VÃµimaldada koostÃ¶Ã¶d arveldamine',0),(381469,10597,'si','OmogoÄajo sodelovanje fakturiranja',0),(381470,10597,'ba','Memungkinkan Co faktur',0),(381471,10597,'nl','Toestaan dat mede facturering',0),(381472,10597,'fi','Salli yhteistyÃ¶ssÃ¤ laskutus',0),(381473,10597,'no','Tillate co fakturering',0),(381474,10597,'da','Tillad Co fakturering',0),(381475,10597,'ko','ê³µë™ ì¸ë³´ì´ìŠ¤ ë°œí–‰ í—ˆìš©',0),(381476,10597,'he','×œ××¤×©×¨ ×©×™×ª×•×£ ×—×©×‘×•× ×™×ª',0),(381477,10597,'el','Î•Ï€Î¹Ï„ÏÎ­ÏˆÎµÎ¹ ÏƒÏ…Î½-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(381478,10597,'zh','å…è®¸åˆä½œè¿›é”€å­˜\r\n',0),(381479,10597,'sv','TillÃ¥ta samarbete fakturering',0),(381480,10597,'it','Consentire co-fatturazione',0),(381481,10597,'tl','',0),(381482,10597,'th','à¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸£à¹ˆà¸§à¸¡',0),(381483,10597,'hi','à¤¸à¤¹-à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(381484,10597,'ms','Membenarkan bersama invois',0),(381485,10597,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨Ø§Ù„Ù…Ø´Ø§Ø±ÙƒØ© Ø§Ù„ÙÙˆØªØ±Ø©',0),(381486,10597,'fr','Permettre la facturation',0),(381487,10597,'jp','å…±åŒè«‹æ±‚æ›¸ç™ºè¡Œã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(381488,10597,'pt','Permitir co facturaÃ§Ã£o',0),(381489,10597,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ ÑÐ¾Ð²Ð¼ÐµÑÑ‚Ð½Ð¾Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(381490,10597,'es','Permite Co-FacturaciÃ³n',0),(381491,10597,'de','Co Rechnungsstellung zu ermÃ¶glichen',0),(381492,10597,'en','Allow Co-Invoicing',0),(381493,10598,'is','',0),(381494,10598,'dr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ÙˆØ§Ù‚Ø¹ÙŠ',0),(381495,10598,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ÙˆØ§Ù‚Ø¹ÙŠ',0),(381496,10598,'tr','Fiili kalan',0),(381497,10598,'pl','Rzeczywiste pozostaÅ‚e',0),(381498,10598,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð°Ñ‚Ð° Ð¾ÑÑ‚Ð°Ð²Ð°Ñ‚',0),(381499,10598,'ur','Ø§ØµÙ„ Ø¨Ø§Ù‚ÛŒ',0),(381500,10598,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð¸ Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾',0),(381501,10598,'vi','thá»±c táº¿ cÃ²n láº¡i',0),(381502,10598,'af','Werklike Oorblywende',0),(381503,10598,'ro','RÄƒmase reale',0),(381504,10598,'et','Tegeliku jÃ¤relejÃ¤Ã¤nud',0),(381505,10598,'si','Dejanski preostalih',0),(381506,10598,'ba','Sebenarnya tersisa',0),(381507,10598,'nl','Werkelijke resterende',0),(381508,10598,'fi','Todellinen jÃ¤ljellÃ¤',0),(381509,10598,'no','Faktiske gjenvÃ¦rende',0),(381510,10598,'da','Faktiske resterende',0),(381511,10598,'ko','ì‹¤ì œ ë‚¨ì€',0),(381512,10598,'he','×‘×¤×•×¢×œ × ×•×ª×¨×ª',0),(381513,10598,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® Ï€Î±ÏÎ±Î¼Î­Î½Î¿Ï…Î½',0),(381514,10598,'zh','å®žé™…å‰©ä½™\r\n',0),(381515,10598,'sv','Faktiska Ã¥terstÃ¥ende',0),(381516,10598,'it','Rimanendo effettivo',0),(381517,10598,'tl','',0),(381518,10598,'th','à¸„à¸‡à¹€à¸«à¸¥à¸·à¸­à¸ˆà¸£à¸´à¸‡',0),(381519,10598,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤¶à¥‡à¤·',0),(381520,10598,'ms','Baki sebenar',0),(381521,10598,'ar','Ø§Ù„ÙØ¹Ù„ÙŠØ© Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(381522,10598,'fr','RÃ©el restant',0),(381523,10598,'jp','æ®‹ã‚Šã®å®Ÿéš›',0),(381524,10598,'pt','Restante real',0),(381525,10598,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ð¾ÑÑ‚Ð°Ð²ÑˆÐµÐµÑÑ',0),(381526,10598,'es','Actual que Resta',0),(381527,10598,'de','TatsÃ¤chliche Nummer(n)',0),(381528,10598,'en','Actual Remaining',0),(381529,10599,'is','',0),(381530,10599,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø´Ø¯Ù‡',0),(381531,10599,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø´Ø¯Ù‡',0),(381532,10599,'tr','Ãœcret',0),(381533,10599,'pl','OpÅ‚ata',0),(381534,10599,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ñ‚',0),(381535,10599,'ur','Ø§Ù„Ø²Ø§Ù…',0),(381536,10599,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÑƒÑ˜Ðµ',0),(381537,10599,'vi','TÃ­nh phÃ­',0),(381538,10599,'af','Gehef',0),(381539,10599,'ro','Perceput',0),(381540,10599,'et','Tuleb maksta',0),(381541,10599,'si','ZaraÄuna',0),(381542,10599,'ba','Dikenai biaya',0),(381543,10599,'nl','Betalen',0),(381544,10599,'fi','Hintaan',0),(381545,10599,'no','Belastet',0),(381546,10599,'da','Opladet',0),(381547,10599,'ko','ì²­êµ¬',0),(381548,10599,'he','×˜×¢×•×Ÿ',0),(381549,10599,'el','Î§ÏÎµÏŽÎ½ÎµÏ„Î±Î¹',0),(381550,10599,'zh','æ”¶è´¹\r\n',0),(381551,10599,'sv','Debiteras',0),(381552,10599,'it','Addebitato',0),(381553,10599,'tl','',0),(381554,10599,'th','à¸„à¸´à¸”à¸„à¹ˆà¸²à¸šà¸£à¸´à¸à¸²à¸£',0),(381555,10599,'hi','à¤•à¤¾ à¤†à¤°à¥‹à¤ª',0),(381556,10599,'ms','Dikenakan bayaran',0),(381557,10599,'ar','Ø§ØªÙ‡Ù…',0),(381558,10599,'fr','FacturÃ©s',0),(381559,10599,'jp','è¿½åŠ æ–™é‡‘',0),(381560,10599,'pt','Cobrado',0),(381561,10599,'ru','Ð’Ð·Ð¸Ð¼Ð°ÐµÑ‚ÑÑ',0),(381562,10599,'es','Cargado',0),(381563,10599,'de','Aufgeladen',0),(381564,10599,'en','Charged',0),(381565,10600,'is','',0),(381566,10600,'dr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ù‡Ø²ÙŠÙ†Ù‡ Ø´Ø¯Ù‡',0),(381567,10600,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ù‡Ø²ÙŠÙ†Ù‡ Ø´Ø¯Ù‡',0),(381568,10600,'tr','Kalan Ã¼cret',0),(381569,10600,'pl','OpÅ‚ata za pozostaÅ‚e',0),(381570,10600,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ñ‚ Ð¾ÑÑ‚Ð°Ð²Ð°Ñ‚',0),(381571,10600,'ur','Ø¨Ø§Ù‚ÛŒ Ú©Ø§ Ø§Ù„Ø²Ø§Ù… Ù„Ú¯Ø§ÛŒØ§',0),(381572,10600,'sr','ÐžÐ¿Ñ‚ÑƒÐ¶ÐµÐ½ Ð´Ð° Ñ˜Ðµ Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾',0),(381573,10600,'vi','TÃ­nh phÃ­ cÃ²n láº¡i',0),(381574,10600,'af','Gehef oor',0),(381575,10600,'ro','Taxat rÄƒmase',0),(381576,10600,'et','Maksta jÃ¤Ã¤nud',0),(381577,10600,'si','ZaraÄuna preostalih',0),(381578,10600,'ba','Dikenai biaya tetap',0),(381579,10600,'nl','Resterende in rekening gebracht',0),(381580,10600,'fi','Hintaan jÃ¤ljellÃ¤',0),(381581,10600,'no','Beregnet gjenvÃ¦rende',0),(381582,10600,'da','OpkrÃ¦vet resterende',0),(381583,10600,'ko','ë‚¨ì€ ì¶©ì „',0),(381584,10600,'he','×˜×¢×•× ×” ×”× ×•×ª×¨×™×',0),(381585,10600,'el','Î§ÏÎµÏŽÎ½ÎµÏ„Î±Î¹ Ï„Î¿ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(381586,10600,'zh','æ”¶è´¹å‰©ä½™\r\n',0),(381587,10600,'sv','Debiteras Ã¥terstÃ¥ende',0),(381588,10600,'it','Carica rimanente',0),(381589,10600,'tl','',0),(381590,10600,'th','à¸„à¸´à¸”à¸„à¹ˆà¸²à¸šà¸£à¸´à¸à¸²à¸£à¸—à¸µà¹ˆà¹€à¸«à¸¥à¸·à¸­',0),(381591,10600,'hi','à¤¶à¥‡à¤· à¤•à¤¾ à¤†à¤°à¥‹à¤ª',0),(381592,10600,'ms','Dikenakan bayaran baki',0),(381593,10600,'ar','Ø§ØªÙ‡Ù… Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(381594,10600,'fr','Charge restante',0),(381595,10600,'jp','æ®‹ã‚Šã®è«‹æ±‚',0),(381596,10600,'pt','Cobrado o restante',0),(381597,10600,'ru','Ð’Ð·Ð¸Ð¼Ð°ÐµÑ‚ÑÑ Ð¾ÑÑ‚Ð°Ð²ÑˆÐ¸ÐµÑÑ',0),(381598,10600,'es','Carga Que Queda',0),(381599,10600,'de','Berechnet die verbleibende',0),(381600,10600,'en','Charged Remaining',0),(381601,10601,'is','',0),(381602,10601,'dr','(Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(381603,10601,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ  ÙØ§ÙƒØªÙˆØ± (Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(381604,10601,'tr','Co faturalar baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(381605,10601,'pl','WspÃ³Å‚pracy faktury pomyÅ›lnie zaktualizowana',0),(381606,10601,'bg','Ð¡ÑŠ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(381607,10601,'ur','Ù…Ø®Ù„ÙˆØ· ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(381608,10601,'sr','Ð¡Ð°Ñ€Ð°Ð´ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(381609,10601,'vi','cáº­p nháº­t hÃ³a Ä‘Æ¡n cÃ´ng ty thÃ nh cÃ´ng',0),(381610,10601,'af','Mede-Fakture Suksesvol Opdateer',0),(381611,10601,'ro','Co-facturi de actualizat cu succes',0),(381612,10601,'et','KoostÃ¶Ã¶ arvete vÃ¤rskendatud',0),(381613,10601,'si','Co-raÄunov uspeÅ¡no posodobljena',0),(381614,10601,'ba','Rekan faktur yang berhasil',0),(381615,10601,'nl','Co facturen bijgewerkt',0),(381616,10601,'fi','YhteistyÃ¶ssÃ¤ laskujen pÃ¤ivittÃ¤minen onnistui',0),(381617,10601,'no','Co fakturaer oppdatert',0),(381618,10601,'da','Co fakturaer opdateret',0),(381619,10601,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ê³µë™ ì²­êµ¬ì„œ',0),(381620,10601,'he','×©×™×ª×•×£ ×—×©×‘×•× ×™×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(381621,10601,'el','Î£Ï…Î½-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(381622,10601,'zh','è”åˆå‘ç¥¨æ›´æ–°æˆåŠŸ\r\n',0),(381623,10601,'sv','Co fakturor uppdaterats',0),(381624,10601,'it','Co-fatture aggiornate con successo',0),(381625,10601,'tl','',0),(381626,10601,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸£à¹ˆà¸§à¸¡à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(381627,10601,'hi','à¤¸à¤¹ à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(381628,10601,'ms','Bersama invois yang berjaya dikemas kini',0),(381629,10601,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø´Ø§Ø±Ùƒ Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(381630,10601,'fr','Co factures correctement mis Ã  jour',0),(381631,10601,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸå…±åŒè«‹æ±‚æ›¸',0),(381632,10601,'pt','Co faturas atualizadas com sucesso',0),(381633,10601,'ru','Ð¡Ð¾ ÑÑ‡ÐµÑ‚Ð°, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(381634,10601,'es','Co-Facturas Actualizadas Exitosamente',0),(381635,10601,'de','Co Rechnungen erfolgreich aktualisiert',0),(381636,10601,'en','Co-Invoices Updated Successfully',0),(381637,10602,'is','',0),(381638,10602,'dr','(Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†',0),(381639,10602,'pr','ÙØ§ÙƒØªÙˆØ± (Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†',0),(381640,10602,'tr','Co Fatura mÃ¼ÅŸteriler',0),(381641,10602,'pl','Odbiorcy faktur wspÃ³Å‚praca',0),(381642,10602,'bg','Ð¡ÑŠ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(381643,10602,'ur','Ú¯Ø§ÛÚ© Ú©Û’ ØªØ¹Ø§ÙˆÙ† Ø§Ù†ÙˆØ§Ø¦Ø³',0),(381644,10602,'sr','ÐšÐ¾Ð»ÐµÐ³Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÑƒÐ¿Ñ†Ð¸Ð¼Ð°',0),(381645,10602,'vi','hÃ³a Ä‘Æ¡n cÃ´ng ty khÃ¡ch hÃ ng',0),(381646,10602,'af','Mede-faktuur kliÃ«nte',0),(381647,10602,'ro','Co-factura clienÅ£ii',0),(381648,10602,'et','KoostÃ¶Ã¶s klientidega arveldada mitmest',0),(381649,10602,'si','Co-raÄuna stranke',0),(381650,10602,'ba','Pelanggan faktur Co',0),(381651,10602,'nl','Co factuur klanten',0),(381652,10602,'fi','YhteistyÃ¶ssÃ¤ lasku asiakkaat',0),(381653,10602,'no','Co fakturere kunder',0),(381654,10602,'da','Co fakturere kunder',0),(381655,10602,'ko','ê³µë™ ê³ ê° ì†¡ìž¥',0),(381656,10602,'he','×—×©×‘×•× ×™×ª ×©×™×ª×•×£ ×”×œ×§×•×—×•×ª',0),(381657,10602,'el','Î£Ï…Î½-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(381658,10602,'zh','åˆä½œå®¢æˆ·å‘ç¥¨\r\n',0),(381659,10602,'sv','Co faktura kunder',0),(381660,10602,'it','Co-fattura clienti',0),(381661,10602,'tl','',0),(381662,10602,'th','à¸£à¹ˆà¸§à¸¡à¸­à¸­à¸à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œà¸¥à¸¹à¸à¸„à¹‰à¸²',0),(381663,10602,'hi','à¤¸à¤¹ à¤šà¤¾à¤²à¤¾à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(381664,10602,'ms','Bersama invois pelanggan',0),(381665,10602,'ar','Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø´Ø§Ø±Ùƒ',0),(381666,10602,'fr','Co facture clients',0),(381667,10602,'jp','å…±åŒè«‹æ±‚ãŠå®¢æ§˜',0),(381668,10602,'pt','Clientes da fatura co',0),(381669,10602,'ru','Ð¡Ð¾ ÑÑ‡ÐµÑ‚Ð¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(381670,10602,'es','Co-Factura Clientes',0),(381671,10602,'de','Co Rechnung Kunden',0),(381672,10602,'en','Co-Invoice Customers',0),(381673,10603,'is','',0),(381674,10603,'dr','(Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ ',0),(381675,10603,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ± (Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ ',0),(381676,10603,'tr','Co fatura dÃ¼zenleme',0),(381677,10603,'pl','Edycja faktury wspÃ³Å‚pracy',0),(381678,10603,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° ÑÑŠÐ²Ð¼ÐµÑÑ‚Ð½Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(381679,10603,'ur','Ù…Ø®Ù„ÙˆØ· Ø§Ù†ÙˆØ§Ø¦Ø³ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(381680,10603,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑÐ°Ñ€Ð°Ð´ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(381681,10603,'vi','Chá»‰nh sá»­a hÃ³a Ä‘Æ¡n cÃ´ng ty',0),(381682,10603,'af','Mede-faktuur redigeer',0),(381683,10603,'ro','Editare co-factura',0),(381684,10603,'et','KoostÃ¶Ã¶ arve Edit',0),(381685,10603,'si','Urejanje Co-raÄun',0),(381686,10603,'ba','Edit faktur Co',0),(381687,10603,'nl','Co factuur bewerken',0),(381688,10603,'fi','YhteistyÃ¶ssÃ¤ laskun muokkaus',0),(381689,10603,'no','Co faktura Rediger',0),(381690,10603,'da','Co faktura Rediger',0),(381691,10603,'ko','ê³µë™ íŽ¸ì§‘ì„ ì†¡ìž¥',0),(381692,10603,'he','×¢×¨×™×›×” ×•×©×™×ª×•×£ ×—×©×‘×•× ×™×ª',0),(381693,10603,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ…Î½-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(381694,10603,'zh','è”åˆå‘ç¥¨ç¼–è¾‘\r\n',0),(381695,10603,'sv','Co faktura redigera',0),(381696,10603,'it','Modifica co-fattura',0),(381697,10603,'tl','',0),(381698,10603,'th','à¹à¸à¹‰à¹„à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸£à¹ˆà¸§à¸¡',0),(381699,10603,'hi','à¤¸à¤¹ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(381700,10603,'ms','Edit bersama invois',0),(381701,10603,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø´Ø§Ø±Ùƒ',0),(381702,10603,'fr','Facture co Edit',0),(381703,10603,'jp','å…±åŒè«‹æ±‚æ›¸ã®ç·¨é›†',0),(381704,10603,'pt','Editar fatura co',0),(381705,10603,'ru','ÐŸÑ€Ð°Ð²ÐºÐ° ÑÐ¾Ð²Ð¼ÐµÑÑ‚Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(381706,10603,'es','Co-Factura Editar',0),(381707,10603,'de','Co Rechnung bearbeiten',0),(381708,10603,'en','Co-Invoice Edit',0),(381709,10604,'is','',0),(381710,10604,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø³Ø·ÙˆØ­  Ø¨Ø§ Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(381711,10604,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÙŠ Ø³Ø·ÙˆØ­  Ø¨Ø§ Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ ',0),(381712,10604,'tr','Grup satÄ±rlarÄ±nÄ± satÄ±ÅŸ hesabÄ±',0),(381713,10604,'pl','Grupa wierszy sprzedaÅ¼y konta',0),(381714,10604,'bg','Ð“Ñ€ÑƒÐ¿Ð° Ð»Ð¸Ð½Ð¸Ð¸ Ð¾Ñ‚ ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(381715,10604,'ur','Ú¯Ø±ÙˆÙ¾ Ù„Ø§Ø¦Ù†ÙˆÚº Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³Û’',0),(381716,10604,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð»Ð¸Ð½Ð¸Ñ˜Ð° Ð¿Ð¾ Ð½Ð°Ð»Ð¾Ð³Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(381717,10604,'vi','nhÃ³m dÃ²ng theo tÃ i khoáº£n bÃ¡n hÃ ng',0),(381718,10604,'af','Groeplyne Per Verkoopsrekening',0),(381719,10604,'ro','Grupa linii de vÃ¢nzÄƒri cont',0),(381720,10604,'et','Read poolt MÃ¼Ã¼gikonto',0),(381721,10604,'si','Skupina vrstic prodaje kupca',0),(381722,10604,'ba','Kelompok garis penjualan rekening',0),(381723,10604,'nl','Groep lijnen door omzetrekening',0),(381724,10604,'fi','RyhmÃ¤n rivien myynnin tili',0),(381725,10604,'no','Linjer av salgskontoen',0),(381726,10604,'da','Gruppelinjer af salgskontoen',0),(381727,10604,'ko','ì˜ì—… ê³„ì •ìœ¼ë¡œ ê·¸ë£¹ ë¼ì¸',0),(381728,10604,'he','×§×‘×¥ ×©×•×¨×•×ª ×œ×¤×™ ×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª',0),(381729,10604,'el','ÎŸÎ¼Î¬Î´Î± Î³ÏÎ±Î¼Î¼ÏŽÎ½ Î±Ï€ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(381730,10604,'zh','æŒ‰é”€å”®å¸æˆ·åˆ†ç»„è¡Œ\r\n',0),(381731,10604,'sv','Rader av fÃ¶rsÃ¤ljning',0),(381732,10604,'it','Gruppo di linee di conto vendita',0),(381733,10604,'tl','',0),(381734,10604,'th','à¸ˆà¸±à¸”à¸à¸¥à¸¸à¹ˆà¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸²à¸¡à¸šà¸±à¸à¸Šà¸µà¸à¸²à¸£à¸‚à¸²à¸¢',0),(381735,10604,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤®à¥‚à¤¹ à¤²à¤¾à¤‡à¤¨à¥‡à¤‚',0),(381736,10604,'ms','Talian Kumpulan akaun jualan',0),(381737,10604,'ar','Ø®Ø·ÙˆØ· Ø§Ù„ÙØ±ÙŠÙ‚ Ø¨Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(381738,10604,'fr','Groupe de lignes par compte de vente',0),(381739,10604,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã«ã‚ˆã£ã¦ã‚°ãƒ«ãƒ¼ãƒ—è¡Œ',0),(381740,10604,'pt','Linhas do grupo por conta de vendas',0),(381741,10604,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð»Ð¸Ð½Ð¸Ð¸ Ð½Ð° ÑÑ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(381742,10604,'es','Lineas del Grupos Por Cuenta de Ventas',0),(381743,10604,'de','Gruppe Lines von Sales Account',0),(381744,10604,'en','Group Lines By Sales Account',0),(381745,10605,'is','',0),(381746,10605,'dr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø³Ø·Ø± Ø§ØµÙ„ÙŠ Ø±Ø§ Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÙŠØ¯ ',0),(381747,10605,'pr','ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø³Ø·Ø± Ø§ØµÙ„ÙŠ Ø±Ø§ Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÙŠØ¯ ',0),(381748,10605,'tr','Ã–zgÃ¼n satÄ±r Ã¶ÄŸeleri koru',0),(381749,10605,'pl','ZachowaÄ‡ oryginalne pozycje',0),(381750,10605,'bg','Ð—Ð°Ð¿Ð°Ð·Ð¸ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ Ñ€ÐµÐ´Ð¾Ð²Ðµ',0),(381751,10605,'ur','Ø§ØµÙ„ Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§Ø¡ Ø±Ú©Ú¾ÛŒÚº',0),(381752,10605,'sr','Ð—Ð°Ð´Ñ€Ð¶Ð¸ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ñ€ÐµÐ´Ð°',0),(381753,10605,'vi','giá»¯ báº£n gá»‘c cÃ¡c má»¥c hÃ ng theo dÃ²ng',0),(381754,10605,'af','Behou Oorspronklike Lynitems',0),(381755,10605,'ro','PÄƒstreazÄƒ elemente originale',0),(381756,10605,'et','Hoida originaal kirjeid',0),(381757,10605,'si','ObdrÅ¾ati samorasel vrstiÄne postavke',0),(381758,10605,'ba','Menyimpan asli item baris',0),(381759,10605,'nl','Oorspronkelijke regelitems houden',0),(381760,10605,'fi','SÃ¤ilyttÃ¤Ã¤ alkuperÃ¤isen Line',0),(381761,10605,'no','Holde opprinnelige linjeelementer',0),(381762,10605,'da','Holde oprindelige linjeelementer',0),(381763,10605,'ko','ì›ëž˜ ì¤„ í•­ëª©ì„ ìœ ì§€',0),(381764,10605,'he','×œ×©×ž×•×¨ ×¢×œ ×¤×¨×™×˜×™ ×”×©×•×¨×” ×”×ž×§×•×¨×™×ª',0),(381765,10605,'el','ÎšÏÎ±Ï„Î®ÏƒÎµÎ¹ Ï„Î¿ Î±ÏÏ‡Î¹ÎºÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(381766,10605,'zh','ä¿æŒåŽŸè¡Œé¡¹ç›®\r\n',0),(381767,10605,'sv','HÃ¥lla ursprungliga radartiklar',0),(381768,10605,'it','Mantenere le voci originali',0),(381769,10605,'tl','',0),(381770,10605,'th','à¹€à¸à¹‡à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸”à¸´à¸¡',0),(381771,10605,'hi','à¤®à¥‚à¤² à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤°à¤–à¥‡à¤‚',0),(381772,10605,'ms','Menyimpan barang-barang garis yang asal',0),(381773,10605,'ar','Ø§Ù„Ø§Ø­ØªÙØ§Ø¸ Ø¨Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø³Ø·Ø± Ø§Ù„Ø£ØµÙ„ÙŠ',0),(381774,10605,'fr','Gardez les objets originaux de ligne',0),(381775,10605,'jp','å…ƒã®ãƒ©ã‚¤ãƒ³ ã‚¢ã‚¤ãƒ†ãƒ ã‚’ä¿æŒã—ã¾ã™ã€‚',0),(381776,10605,'pt','Manter os itens de linha Original',0),(381777,10605,'ru','Ð¥Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ñ… Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¹',0),(381778,10605,'es','Guardar Items de Linea Original',0),(381779,10605,'de','Halten Original Einzelposten',0),(381780,10605,'en','Keep Original Line Items',0),(381781,10606,'is','',0),(381782,10606,'dr','Ù‡ÙŠÚ† Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(381783,10606,'pr','Ù‡ÙŠÚ† Ø®Ø±ÙŠØ¯Ø§Ø±ÙŠ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(381784,10606,'tr','SeÃ§ili mÃ¼ÅŸteri yok',0),(381785,10606,'pl','Nie klientÃ³w wybranych',0),(381786,10606,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(381787,10606,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ú¯Ø§ÛÚ©',0),(381788,10606,'sr','ÐÐµÐ¼Ð° ÐºÑƒÐ¿Ð°Ñ†Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½',0),(381789,10606,'vi','khÃ´ng cÃ³ khÃ¡ch hÃ ng Ä‘Ã£ chá»n',0),(381790,10606,'af','Geen klante gekies',0),(381791,10606,'ro','Nici clienÅ£ii selectate',0),(381792,10606,'et','Valitud kliente',0),(381793,10606,'si','Nobene stranke, izbrani',0),(381794,10606,'ba','Tidak ada pelanggan yang dipilih',0),(381795,10606,'nl','Geen klanten geselecteerd',0),(381796,10606,'fi','Valitut asiakkaita',0),(381797,10606,'no','Ingen kunder valgt',0),(381798,10606,'da','Ingen kunder har valgt',0),(381799,10606,'ko','ê³ ê° ì„ íƒ',0),(381800,10606,'he','×œ× × ×‘×—×¨×• ×œ×§×•×—×•×ª',0),(381801,10606,'el','Î”ÎµÎ½ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(381802,10606,'zh','æ²¡æœ‰å·²é€‰çš„å®¢æˆ·\r\n',0),(381803,10606,'sv','Inga kunder som valt',0),(381804,10606,'it','Clienti non selezionati',0),(381805,10606,'tl','',0),(381806,10606,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹„à¸¡à¹ˆà¹€à¸¥à¸·à¸­à¸',0),(381807,10606,'hi','à¤•à¥‹à¤ˆ à¤šà¤¯à¤¨à¤¿à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(381808,10606,'ms','Tiada pelanggan yang dipilih',0),(381809,10606,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(381810,10606,'fr','Pas de clients sÃ©lectionnÃ©s',0),(381811,10606,'jp','é¸æŠžã—ãŸé¡§å®¢',0),(381812,10606,'pt','NÃ£o hÃ¡ clientes selecionados',0),(381813,10606,'ru','ÐÐµÑ‚ Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(381814,10606,'es','No se SeleccionÃ³ Clients',0),(381815,10606,'de','Keine Kunden ausgewÃ¤hlt',0),(381816,10606,'en','No Customers Selected',0),(381817,10607,'is','',0),(381818,10607,'dr','(Ø³Ø§Ø¨Ù‚Ù‡) ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(381819,10607,'pr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ø«Ø¨Øª (Ø³Ø§Ø¨Ù‚Ù‡) ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(381820,10607,'tr','HiÃ§bir kayÄ±t kodu kÃ¼mesi',0),(381821,10607,'pl','Nie zestaw identyfikator rekordu',0),(381822,10607,'bg','ÐšÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚ Ð½ÑÐ¼Ð° Ð˜Ð” Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(381823,10607,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ ID Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(381824,10607,'sr','ÐÐµÐ¼Ð° Ð¡ÐµÑ‚ Ð˜Ð” Ð·Ð°Ð¿Ð¸ÑÐ°',0),(381825,10607,'vi','khÃ´ng táº­p há»£p ID ghi chÃ©p',0),(381826,10607,'af','Geen Rekord ID Gestel',0),(381827,10607,'ro','Nici un Set de Ã®nregistrÄƒri ID',0),(381828,10607,'et','Puudub kirje ID komplekt',0),(381829,10607,'si','Ni nastavljenega ID zapisa',0),(381830,10607,'ba','Set ID catatan ada',0),(381831,10607,'nl','Geen Record-ID-Set',0),(381832,10607,'fi','Ei Tietuetunnus asetettu',0),(381833,10607,'no','Ingen post-ID-sett',0),(381834,10607,'da','Ingen post-id sÃ¦t',0),(381835,10607,'ko','ì•„ë¬´ ë ˆì½”ë“œ ID ì„¤ì •',0),(381836,10607,'he','×œ× ×”×•×’×“×¨×• ×ž×–×”×” ×¨×©×•×ž×”',0),(381837,10607,'el','ÎšÎ±Î½Î­Î½Î± ÏƒÏÎ½Î¿Î»Î¿ ÏÎµÎºÏŒÏ ID',0),(381838,10607,'zh','æ²¡æœ‰è®¾ç½®è®°å½•ID\r\n',0),(381839,10607,'sv','Inget post-ID Set',0),(381840,10607,'it','Nessun ID Record Set',0),(381841,10607,'tl','',0),(381842,10607,'th','à¸Šà¸¸à¸”à¹„à¸¡à¹ˆà¸¡à¸µà¹€à¸£à¹‡à¸à¸„à¸­à¸£à¹Œà¸” ID',0),(381843,10607,'hi','à¤•à¥‹à¤ˆ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ ID à¤¸à¥‡à¤Ÿ',0),(381844,10607,'ms','Set ID rekod tidak',0),(381845,10607,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ø¹Ø±Ù Ø§Ù„Ø³Ø¬Ù„',0),(381846,10607,'fr','Aucun ensemble de Record ID',0),(381847,10607,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ ID ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(381848,10607,'pt','Nenhum conjunto de registro ID',0),(381849,10607,'ru','ÐÐ°Ð±Ð¾Ñ€ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(381850,10607,'es','No Hay Recod de Juego de ID',0),(381851,10607,'de','Kein Datensatz-ID-Set',0),(381852,10607,'en','No Record ID Set',0),(381853,10608,'is','',0),(381854,10608,'dr','Co-Invoice ',0),(381855,10608,'pr','ØªÙ†Ø¸ÙŠÙ… Ø­Ø¯Ø§Ù‚Ù„ ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø± ÙØ§ÙƒØªÙˆØ± Ù…Ø´ØªØ±Ùƒ  Co-Invoice \r\n',0),(381856,10608,'tr','En az bir mÃ¼ÅŸteri iÅŸbirliÄŸi fatura mÃ¼ÅŸterisi olarak ayarlayÄ±n',0),(381857,10608,'pl','Utworzenia co najmniej jednego klienta jako klienta faktury wspÃ³Å‚pracy',0),(381858,10608,'bg','Ð—Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ Ð¿Ð¾Ð½Ðµ ÐµÐ´Ð¸Ð½ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ°Ñ‚Ð¾ ÑÑŠ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(381859,10608,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø§ÛŒÚ© Ú©Ø³Ù¹Ù…Ø± ØªØ¹Ø§ÙˆÙ† Ø§Ù†ÙˆØ§Ø¦Ø³ Ú¯Ø§ÛÚ© Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù…Ø±ØªØ¨ Ú©Ø±ÛŒÚº',0),(381860,10608,'sr','ÐŸÐ¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð±Ð°Ñ€ÐµÐ¼ Ñ˜ÐµÐ´Ð°Ð½ ÐºÑƒÐ¿Ñ†Ð° ÐºÐ°Ð¾ ÐºÐ¾Ð»ÐµÐ³Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(381861,10608,'vi','Thiáº¿t láº­p Ã­t nháº¥t 1 khÃ¡ch hÃ ng nhÆ° lÃ  khÃ¡ch hÃ ng Co-invoice',0),(381862,10608,'af','Ten minste een kliÃ«nt As \'n mede-faktuur kliÃ«nt opgestel',0),(381863,10608,'ro','ÃŽnfiinÅ£at cel puÅ£in un client ca ÅŸi co-facturÄƒ client',0),(381864,10608,'et','Saate seadistada vÃ¤hemalt Ã¼hele kliendile kaas arve kliendi',0),(381865,10608,'si','Nastaviti vsaj eno stranko kot co-raÄun kupca',0),(381866,10608,'ba','Mengatur setidaknya satu pelanggan sebagai pelanggan faktur Co',0),(381867,10608,'nl','Ten minste Ã©Ã©n klant als een co factuur klant instelt',0),(381868,10608,'fi','VÃ¤hintÃ¤Ã¤n yksi asiakkaan yhteistyÃ¶ssÃ¤ laskun asiakkaan mÃ¤Ã¤rittÃ¤minen',0),(381869,10608,'no','Definer minst Ã©n kunde som co faktura kunde',0),(381870,10608,'da','Konfigurere mindst Ã©n kunde som co faktura kunde',0),(381871,10608,'ko','ì ì–´ë„ í•˜ë‚˜ì˜ ê³ ê° ê³µë™ ì†¡ìž¥ ê³ ê°ìœ¼ë¡œ ì„¤ì •',0),(381872,10608,'he','×”×’×“×¨×ª ×œ×§×•×— ××—×“ ×œ×¤×—×•×ª ×‘×ª×•×¨ ×œ×§×•×— ×œ×—×©×‘×•× ×™×ª ×©×™×ª×•×£',0),(381873,10608,'el','ÎˆÏ‡ÎµÎ¹ ÏƒÏ…ÏƒÏ„Î±Î¸ÎµÎ¯ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î­Î½Î± Ï€ÎµÎ»Î¬Ï„Î· Ï‰Ï‚ ÏƒÏ…Î½-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÎµÎ»Î¬Ï„Î·',0),(381874,10608,'zh','è®¾ç½®è‡³å°‘ä¸€ä¸ªå®¢æˆ·ä½œä¸ºå…±åŒå‘ç¥¨å®¢æˆ·\r\n',0),(381875,10608,'sv','StÃ¤ll in minst en kund som co faktura kund',0),(381876,10608,'it','Impostare almeno un cliente come co-fattura cliente',0),(381877,10608,'tl','',0),(381878,10608,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹€à¸›à¹‡à¸™à¸¥à¸¹à¸à¸„à¹‰à¸²à¸«à¸™à¸µà¹‰à¸£à¹ˆà¸§à¸¡',0),(381879,10608,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤à¤• à¤¸à¤¹ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(381880,10608,'ms','Sediakan sekurang-kurangnya seorang pelanggan sebagai pelanggan bersama invois',0),(381881,10608,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø¹Ù…ÙŠÙ„ ÙˆØ§Ø­Ø¯ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„ ÙƒØ¹Ù…ÙŠÙ„ ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø´Ø§Ø±Ùƒ',0),(381882,10608,'fr','Mis en place au moins un client comme un client de la facture de co',0),(381883,10608,'jp','å°‘ãªãã¨ã‚‚ 1 ã¤ã®é¡§å®¢ã¨ã—ã¦å…±åŒè«‹æ±‚æ›¸ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(381884,10608,'pt','Configurar pelo menos um cliente como um cliente de factura co',0),(381885,10608,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð¿Ð¾ ÐºÑ€Ð°Ð¹Ð½ÐµÐ¹ Ð¼ÐµÑ€Ðµ Ð¾Ð´Ð¸Ð½ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ°Ðº ÑÐ¾ ÑÑ‡ÐµÑ‚Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(381886,10608,'es','Configurar Por Lo Menos Un Cliente Como Cliente de Co-Factura',0),(381887,10608,'de','Richten Sie mindestens einen Kunden als Kunde Co Rechnung',0),(381888,10608,'en','Set Up At Least One Customer As A Co-Invoice Customer',0),(381889,10609,'is','',0),(381890,10609,'dr','Ù†Ù…Ø§ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆØ§Ù‚Ø¹ÙŠ',0),(381891,10609,'pr','Ù†Ù…Ø§ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆØ§Ù‚Ø¹ÙŠ',0),(381892,10609,'tr','GÃ¶steri gerÃ§ek para',0),(381893,10609,'pl','PokaÅ¼ rzeczywiste zapÅ‚acone',0),(381894,10609,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¾Ñ‚Ð¾ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(381895,10609,'ur','Ø´Ùˆ Ø§Ø¯Ø§ Ú©ÛŒ Ø§ØµÙ„',0),(381896,10609,'sr','Ð•Ð¼Ð¸ÑÐ¸Ñ˜Ð° ÑÑ‚Ð²Ð°Ñ€Ð½Ðµ Ð¿Ð»Ð°Ñ‚Ðµ',0),(381897,10609,'vi','Hiá»ƒn thá»‹ sá»‘ thá»±c táº¿ Ä‘Ã£ tráº£ tiá»n',0),(381898,10609,'af','Wys Werklik Betaal',0),(381899,10609,'ro','AratÄƒ reale plÄƒtite',0),(381900,10609,'et','NÃ¤ita tegelikult makstud',0),(381901,10609,'si','PrikaÅ¾i dejansko plaÄani',0),(381902,10609,'ba','Tampilkan sebenarnya dibayar',0),(381903,10609,'nl','Toon werkelijke betaald',0),(381904,10609,'fi','NÃ¤ytÃ¤ todellinen maksettu',0),(381905,10609,'no','Vis faktisk betalt',0),(381906,10609,'da','Vis faktiske betalte',0),(381907,10609,'ko','ì‡¼ëŠ” ì‹¤ì œ ì§€ë¶ˆ',0),(381908,10609,'he','×”×¦×’ ×‘×¤×•×¢×œ ×©×™×œ×',0),(381909,10609,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® ÎºÎ±Ï„Î±Î²Î»Î·Î¸ÎµÎ¯',0),(381910,10609,'zh','æ˜¾ç¤ºå®žé™…æ”¯ä»˜\r\n',0),(381911,10609,'sv','Visa faktiska betalas',0),(381912,10609,'it','Visualizza effettivo pagato',0),(381913,10609,'tl','',0),(381914,10609,'th','à¸”à¸¹à¸ˆà¹ˆà¸²à¸¢à¸ˆà¸£à¸´à¸‡',0),(381915,10609,'hi','à¤¶à¥‹ à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(381916,10609,'ms','Tayangan sebenar dibayar',0),(381917,10609,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙØ¹Ù„ÙŠØ© Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(381918,10609,'fr','Voir la rÃ©elle payÃ©e',0),(381919,10609,'jp','ã‚·ãƒ§ãƒ¼ã®å®Ÿéš›ã®æ”¯æ‰•',0);
INSERT INTO `langdef` VALUES (381920,10609,'pt','Visualizar real pago',0),(381921,10609,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸ ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ',0),(381922,10609,'es','Mostrar Pago Actual',0),(381923,10609,'de','Karte tatsÃ¤chlich bezahlt',0),(381924,10609,'en','Show Actual Paid',0),(381925,10610,'is','',0),(381926,10610,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„',0),(381927,10610,'pr','Ø±ÙˆØ´ Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„',0),(381928,10610,'tr','Transfer yÃ¶ntemi',0),(381929,10610,'pl','Metody transferu',0),(381930,10610,'bg','ÐœÐµÑ‚Ð¾Ð´ Ð·Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ',0),(381931,10610,'ur','Ø·Ø±ÛŒÙ‚Û Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(381932,10610,'sr','ÐœÐµÑ‚Ð¾Ð´ Ð¿Ñ€ÐµÐ½Ð¾ÑÐ°',0),(381933,10610,'vi','PhÆ°Æ¡ng phÃ¡p chuyá»ƒn',0),(381934,10610,'af','Oorplasingsmetode',0),(381935,10610,'ro','MetodÄƒ de transfer',0),(381936,10610,'et','Ãœlekande meetodil',0),(381937,10610,'si','NaÄin prenosa',0),(381938,10610,'ba','Metode transfer',0),(381939,10610,'nl','Methode transfer',0),(381940,10610,'fi','Siirtotapa',0),(381941,10610,'no','OverfÃ¸ringsmetoden',0),(381942,10610,'da','OverfÃ¸rselsmetode',0),(381943,10610,'ko','ì „ì†¡ ë°©ë²•',0),(381944,10610,'he','×©×™×˜×ª ×”×¢×‘×¨×”',0),(381945,10610,'el','ÎœÎ­Î¸Î¿Î´Î¿Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚',0),(381946,10610,'zh','è½¬è®©æ–¹æ³•\r\n',0),(381947,10610,'sv','Ã–verfÃ¶ringsmetod',0),(381948,10610,'it','Metodo di trasferimento',0),(381949,10610,'tl','',0),(381950,10610,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸–à¹ˆà¸²à¸¢à¹‚à¸­à¸™',0),(381951,10610,'hi','à¤…à¤‚à¤¤à¤°à¤£ à¤µà¤¿à¤§à¤¿',0),(381952,10610,'ms','Kaedah pemindahan',0),(381953,10610,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ù†Ù‚Ù„',0),(381954,10610,'fr','MÃ©thode de transfert',0),(381955,10610,'jp','è»¢é€æ–¹æ³•',0),(381956,10610,'pt','MÃ©todo de transferÃªncia',0),(381957,10610,'ru','ÐœÐµÑ‚Ð¾Ð´ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(381958,10610,'es','MÃ©todo de Transferencia',0),(381959,10610,'de','Transfer-Methode',0),(381960,10610,'en','Transfer Method',0),(381961,10611,'is','',0),(381962,10611,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ù…Ø´ØªØ±Ùƒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(381963,10611,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø±Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± Ù…Ø´ØªØ±Ùƒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(381964,10611,'tr','Co Faturalanacak mÃ¼ÅŸteri seÃ§melisiniz',0),(381965,10611,'pl','NaleÅ¼y wybraÄ‡ klienta do wspÃ³Å‚pracy faktury',0),(381966,10611,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð·Ð° ÑÑŠÐ²Ð¼ÐµÑÑ‚Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(381967,10611,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ú¯Ø§ÛÚ© Ù…Ø®Ù„ÙˆØ· Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(381968,10611,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð° Ð·Ð° ÑÐ°Ñ€Ð°Ð´ÑšÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(381969,10611,'vi','Báº¡n pháº£i chá»n 1 khÃ¡ch hÃ ng Ä‘áº¿n hÃ³a Ä‘Æ¡n',0),(381970,10611,'af','U moet \'n Klant Kies om ook te Faktureer',0),(381971,10611,'ro','Trebuie sÄƒ selectaÅ£i un client de a co-factura',0),(381972,10611,'et','Valige kliendi kaas arve',0),(381973,10611,'si','Izbrati morate stranko za co-fakturiranje',0),(381974,10611,'ba','Anda harus memilih pelanggan untuk faktur Co',0),(381975,10611,'nl','U moet een klant co factuur selecteren',0),(381976,10611,'fi','Sinun on valittava asiakas yhteistyÃ¶ssÃ¤ laskuun',0),(381977,10611,'no','Du mÃ¥ velge en kunde co fakturaen',0),(381978,10611,'da','Du skal vÃ¦lge en kunde til co faktura',0),(381979,10611,'ko','ê³µë™ ì†¡ìž¥ ê³ ê°ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(381980,10611,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×œ×œ×§×•×— ×—×©×‘×•× ×™×ª ×œ×¢×‘×•×“×”',0),(381981,10611,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î±Î½ Ï€ÎµÎ»Î¬Ï„Î· Î½Î± ÏƒÏ…Î½-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(381982,10611,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªå®¢æˆ·ä»¥è”åˆå‘ç¥¨\r\n',0),(381983,10611,'sv','Du mÃ¥ste vÃ¤lja en kund till co faktura',0),(381984,10611,'it','Ãˆ necessario selezionare un cliente a co-fattura',0),(381985,10611,'tl','',0),(381986,10611,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸žà¸·à¹ˆà¸­à¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸£à¹ˆà¸§à¸¡',0),(381987,10611,'hi','à¤¤à¥à¤® à¤¸à¤¹ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(381988,10611,'ms','Anda mesti memilih seorang pelanggan bersama invois',0),(381989,10611,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ­Ø¯ÙŠØ¯ Ø£Ø­Ø¯ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù„Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø´Ø§Ø±Ùƒ',0),(381990,10611,'fr','Vous devez sÃ©lectionner un client Ã  co-facturer',0),(381991,10611,'jp','å…±åŒè«‹æ±‚æ›¸ã«é¡§å®¢ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(381992,10611,'pt','VocÃª deve selecionar um cliente de factura co',0),(381993,10611,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÐ¾ ÑÑ‡ÐµÑ‚Ð°',0),(381994,10611,'es','Debe Seleccionar un Cliente Para Co-Facturar',0),(381995,10611,'de','Sie mÃ¼ssen ein Kunde Co Rechnung auswÃ¤hlen.',0),(381996,10611,'en','You Must Select A Customer To Co-Invoice',0),(381997,10612,'is','',0),(381998,10612,'dr','Ø´Ù…Ø§ Ù†Ø¨Ø§ÙŠØ¯ ÙØ§ÙƒØªÙˆØ± Ø§ØµÙ„ÙŠ Ø±Ø§ Ø¬Ù‡Øª Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯  Ù¾Ø³Øª ÙƒÙ†ÙŠØ¯ ',0),(381999,10612,'pr','Ø´Ù…Ø§ Ù†Ø¨Ø§ÙŠØ¯ ÙØ§ÙƒØªÙˆØ± Ø§ØµÙ„ÙŠ Ø±Ø§ Ø¬Ù‡Øª Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¬Ø¯ÙŠØ¯  Ù¾Ø³Øª ÙƒÙ†ÙŠØ¯ ',0),(382000,10612,'tr','Yeni faturalarÄ± eklemek iÃ§in orijinal fatura Unpost gerekir',0),(382001,10612,'pl','Musi Unpost oryginaÅ‚u faktury dodaÄ‡ nowej faktury',0),(382002,10612,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Unpost Ð¸ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð°Ñ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(382003,10612,'ur','Ø¢Ù¾ Ù†Ø¦Û’ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ø§Ø¶Ø§ÙÛ’ Ú©Û’ Ù„ÛŒÛ’ Ø§ØµÙ„ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ù†Ù¾ÙˆØ³Ù¹ Ú†Ø§ÛÛŒÛ’',0),(382004,10612,'sr','Ð¢Ð¸ Ð¼Ð¾Ñ€Ð° Ð´Ð° Ð¿Ð¾Ð²ÑƒÐ¸Ðµ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð½Ð¾Ð²Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(382005,10612,'vi','Báº¡n khÃ´ng Ä‘Æ°á»£c bá» hÃ³a Ä‘Æ¡n gá»‘c Ä‘á»ƒ thÃªm hÃ³a Ä‘Æ¡n má»›i',0),(382006,10612,'af','U Moet Die Oorspronklike Faktuur Ongeposteerd Laat Om Nuwe Fakture By te voeg',0),(382007,10612,'ro','Trebuie sÄƒ Unpost facturii originale pentru a adÄƒuga noi facturi',0),(382008,10612,'et','Peab Unpost algse arve lisada New arvetele',0),(382009,10612,'si','Mora Unpost originalni raÄun dodati nove raÄune',0),(382010,10612,'ba','Anda harus Unpost faktur asli untuk menambahkan baru faktur',0),(382011,10612,'nl','U moet de originele factuur als u wilt toevoegen van nieuwe facturen Unpost',0),(382012,10612,'fi','AlkuperÃ¤isen laskun voit lisÃ¤tÃ¤ uusia laskuja on Unpost',0),(382013,10612,'no','Du mÃ¥ Unpost den opprinnelige fakturaen for Ã¥ legge til nye fakturaer',0),(382014,10612,'da','Du skal Unpost den oprindelige faktura for at tilfÃ¸je nye fakturaer',0),(382015,10612,'ko','ìƒˆ ì†¡ìž¥ì„ ì¶”ê°€ ì›ëž˜ì˜ ì²­êµ¬ì„œë¥¼ Unpost í•´ì•¼ í•©ë‹ˆë‹¤.',0),(382016,10612,'he','. ××ª×” ×—×™×™×‘ Unpost ×”×—×©×‘×•× ×™×ª ×”×ž×§×•×¨×™×ª ×›×“×™ ×œ×”×•×¡×™×£ ×—×©×‘×•× ×™×•×ª ×—×“×©',0),(382017,10612,'el','Î£Î±Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Unpost Ï„Î¿ Î±ÏÏ‡Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î½Î­Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(382018,10612,'zh','ä½ å¿…é¡»ä¸å‘å¸ƒåŽŸå§‹å‘ç¥¨ä»¥æ·»åŠ æ–°å‘ç¥¨\r\n',0),(382019,10612,'sv','Du mÃ¥ste Unpost den ursprungliga fakturan fÃ¶r att lÃ¤gga till nya fakturor',0),(382020,10612,'it','Deve Unpost la fattura originale per aggiungere nuove fatture',0),(382021,10612,'tl','',0),(382022,10612,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡ Unpost à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œà¸”à¸±à¹‰à¸‡à¹€à¸”à¸´à¸¡à¹€à¸žà¸·à¹ˆà¸­à¹€à¸žà¸´à¹ˆà¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸«à¸¡à¹ˆ',0),(382023,10612,'hi','à¤†à¤ª à¤¨à¤ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‚à¤² à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ Unpost à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(382024,10612,'ms','Anda mesti Unpost invois asal untuk menambahkan invois baru',0),(382025,10612,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø£ÙˆÙ†Ø¨ÙˆØ³Øª Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø£ØµÙ„ÙŠØ© Ù„Ø¥Ø¶Ø§ÙØ© ÙÙˆØ§ØªÙŠØ± Ø¬Ø¯ÙŠØ¯Ø©',0),(382026,10612,'fr','Vous devez retirer la facture d\'origine pour ajouter de nouvelles factures.',0),(382027,10612,'jp','æ–°ã—ã„è«‹æ±‚æ›¸ã‚’è¿½åŠ ã™ã‚‹ã«ã¯ã€å…ƒã®è«‹æ±‚æ›¸ã‚’è¨˜å¸³ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(382028,10612,'pt','VocÃª deve Unpost a factura Original para adicionar novas facturas',0),(382029,10612,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Unpost Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð» ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð¾Ð²Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(382030,10612,'es','Debe Desasentar la Factura Original para Agregar Una Nueva Factura',0),(382031,10612,'de','Sie mÃ¼ssen die Originalrechnung fÃ¼gen neue Rechnungen Unpost.',0),(382032,10612,'en','You Must Unpost The Original Invoice To Add New Invoices',0),(382033,10613,'is','',0),(382034,10613,'dr','ØªØ®ÙÙŠÙ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(382035,10613,'pr','ØªØ®ÙÙŠÙ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(382036,10613,'tr','Ã–zel indirim',0),(382037,10613,'pl','Niestandardowe zniÅ¼ki',0),(382038,10613,'bg','ÐžÐ±Ð¸Ñ‡Ð°Ð¹ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(382039,10613,'ur','Ù…Ø®ØµÙˆØµ Ø±Ø¹Ø§ÛŒØª',0),(382040,10613,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¸ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(382041,10613,'vi','tá»± táº¡o chiáº¿t kháº¥u',0),(382042,10613,'af','Aangepasde Korting',0),(382043,10613,'ro','Reducere personalizat',0),(382044,10613,'et','Kohandatud allahindluse',0),(382045,10613,'si','Meri popust',0),(382046,10613,'ba','Diskon kustom',0),(382047,10613,'nl','Aangepaste korting',0),(382048,10613,'fi','Mukautetun alennus',0),(382049,10613,'no','Egendefinerte rabatt',0),(382050,10613,'da','Brugerdefinerede rabat',0),(382051,10613,'ko','ì‚¬ìš©ìž ì§€ì • í• ì¸',0),(382052,10613,'he','×“×™×¡×§×•× ×˜ ×ž×•×ª××ž×™× ××™×©×™×ª',0),(382053,10613,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· Î­ÎºÏ€Ï„Ï‰ÏƒÎ·',0),(382054,10613,'zh','è‡ªå®šä¹‰æŠ˜æ‰£\r\n',0),(382055,10613,'sv','Anpassade rabatt',0),(382056,10613,'it','Sconto personalizzato',0),(382057,10613,'tl','',0),(382058,10613,'th','à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¹à¸šà¸šà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡',0),(382059,10613,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤›à¥‚à¤Ÿ',0),(382060,10613,'ms','Diskaun adat',0),(382061,10613,'ar','Ø®ØµÙ… Ù…Ø®ØµØµ',0),(382062,10613,'fr','Remise personnalisÃ©e',0),(382063,10613,'jp','ã‚«ã‚¹ã‚¿ãƒ å‰²å¼•',0),(382064,10613,'pt','Desconto personalizado',0),(382065,10613,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ ÑÐºÐ¸Ð´ÐºÐ°',0),(382066,10613,'es','Descuento Personalizado',0),(382067,10613,'de','Benutzerdefinierte Rabatt',0),(382068,10613,'en','Custom Discount',0),(382069,10614,'is','',0),(382070,10614,'dr','(Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ',0),(382071,10614,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ§ÙƒØªÙˆØ± (Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ',0),(382072,10614,'tr','Co fatura bilgisi',0),(382073,10614,'pl','Informacji na temat wspÃ³Å‚pracy faktury',0),(382074,10614,'bg','Ð¡ÑŠ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(382075,10614,'ur','Ù…Ø®Ù„ÙˆØ· Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(382076,10614,'sr','ÐšÐ¾Ð»ÐµÐ³Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð˜Ð½Ñ„Ð¾',0),(382077,10614,'vi','thÃ´ng tin hÃ³a Ä‘Æ¡n cÃ´ng ty',0),(382078,10614,'af','Mede-faktuur Info',0),(382079,10614,'ro','Info co-facturÄƒ',0),(382080,10614,'et','KoostÃ¶Ã¶ arve Info',0),(382081,10614,'si','Co-raÄun Info',0),(382082,10614,'ba','Info faktur Co',0),(382083,10614,'nl','Co factuur Info',0),(382084,10614,'fi','YhteistyÃ¶ssÃ¤ laskun tiedot',0),(382085,10614,'no','Co faktura Info',0),(382086,10614,'da','Co faktura Info',0),(382087,10614,'ko','ê³µë™ ì†¡ìž¥ ì •ë³´',0),(382088,10614,'he','×—×©×‘×•× ×™×ª ×©×™×ª×•×£ ×ž×™×“×¢',0),(382089,10614,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ…Î½-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(382090,10614,'zh','è”åˆå‘ç¥¨ä¿¡æ¯\r\n',0),(382091,10614,'sv','Co faktura information',0),(382092,10614,'it','Info co-fattura',0),(382093,10614,'tl','',0),(382094,10614,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸£à¹ˆà¸§à¸¡',0),(382095,10614,'hi','à¤¸à¤¹ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(382096,10614,'ms','Info bersama invois',0),(382097,10614,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø´Ø§Ø±Ùƒ',0),(382098,10614,'fr','Info facture Co',0),(382099,10614,'jp','å…±åŒè«‹æ±‚æ›¸æƒ…å ±',0),(382100,10614,'pt','InformaÃ§Ã£o de fatura co',0),(382101,10614,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÑÐ¾ ÑÑ‡ÐµÑ‚Ð°',0),(382102,10614,'es','Co-Factura Info',0),(382103,10614,'de','Co Rechnung Info',0),(382104,10614,'en','Co-Invoice Info',0),(382105,10615,'is','',0),(382106,10615,'dr','(Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(382107,10615,'pr','ÙØ§ÙƒØªÙˆØ± (Ø´Ø±ÙƒØª ) Ù…Ø´ØªØ±Ùƒ Ø®Ø±ÙŠØ¯Ø§Ø±',0),(382108,10615,'tr','Birlikte mÃ¼ÅŸteriye fatura',0),(382109,10615,'pl','Faktura wspÃ³Å‚pracy klienta',0),(382110,10615,'bg','Ð¡ÑŠÐ²Ð¼ÐµÑÑ‚Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(382111,10615,'ur','Ú©Ø³Ù¹Ù…Ø± ØªØ¹Ø§ÙˆÙ† Ø§Ù†ÙˆØ§Ø¦Ø³',0),(382112,10615,'sr','ÐšÐ¾Ð»ÐµÐ³Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(382113,10615,'vi','hÃ³a Ä‘Æ¡n cÃ´ng ty khÃ¡ch hÃ ng',0),(382114,10615,'af','Mede-faktuur kliÃ«nt',0),(382115,10615,'ro','Co-facturÄƒ client',0),(382116,10615,'et','KoostÃ¶Ã¶ arve kliendi',0),(382117,10615,'si','Co-raÄun kupca',0),(382118,10615,'ba','Pelanggan faktur Co',0),(382119,10615,'nl','Co factuur klant',0),(382120,10615,'fi','YhteistyÃ¶ssÃ¤ laskuttaa asiakasta',0),(382121,10615,'no','Co fakturere kunden',0),(382122,10615,'da','Co fakturere kunden',0),(382123,10615,'ko','ê³µë™ ê³ ê° ì†¡ìž¥',0),(382124,10615,'he','×—×©×‘×•× ×™×ª ×•×©×™×ª×•×£ ×”×œ×§×•×—',0),(382125,10615,'el','Î£Ï…Î½-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÎµÎ»Î¬Ï„Î·',0),(382126,10615,'zh','è”åˆå‘ç¥¨å®¢æˆ·\r\n',0),(382127,10615,'sv','Co fakturera kund',0),(382128,10615,'it','Co-fattura cliente',0),(382129,10615,'tl','',0),(382130,10615,'th','à¸£à¹ˆà¸§à¸¡à¸­à¸­à¸à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œà¸¥à¸¹à¸à¸„à¹‰à¸²',0),(382131,10615,'hi','à¤¸à¤¹ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(382132,10615,'ms','Baca bersama invois',0),(382133,10615,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø´Ø§Ø±Ùƒ',0),(382134,10615,'fr','Co facture client',0),(382135,10615,'jp','å…±åŒé¡§å®¢è«‹æ±‚æ›¸ã—ã¾ã™ã€‚',0),(382136,10615,'pt','Cliente fatura co',0),(382137,10615,'ru','Ð¡Ð¾ ÑÑ‡ÐµÑ‚Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(382138,10615,'es','Co-Factura Cliente',0),(382139,10615,'de','Co Rechnung Kunden',0),(382140,10615,'en','Co-Invoice Customer',0),(382141,10616,'is','',0),(382142,10616,'dr','(Ø§Ø¬Ø±Ø§) Ø¯Ø± ÙØ±Ù…Ø§ÛŒØ´',0),(382143,10616,'pr','Ø§Ø¹Ù…Ø§Ù„(Ø§Ø¬Ø±Ø§) Ø¯Ø± Ø³ÙØ§Ø±Ø´',0),(382144,10616,'tr','SipariÅŸe Uygula',0),(382145,10616,'pl','Stosuje siÄ™ do porzÄ…dku',0),(382146,10616,'bg','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(382147,10616,'ur','Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¯Û’',0),(382148,10616,'sr','ÐŸÑ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ñ€ÐµÐ´',0),(382149,10616,'vi','Ãp dá»¥ng Äáº·t hÃ ng',0),(382150,10616,'af','Toepassing op bestelling',0),(382151,10616,'ro','Se aplicÄƒ la comanda',0),(382152,10616,'et','Selleks kohaldatakse',0),(382153,10616,'si','Veljajo za naroÄilo',0),(382154,10616,'ba','Berlaku untuk pesanan',0),(382155,10616,'nl','Toepassen op Order',0),(382156,10616,'fi','Sovelletaan tilaus',0),(382157,10616,'no','Gjelde for',0),(382158,10616,'da','GÃ¦lde for rÃ¦kkefÃ¸lge',0),(382159,10616,'ko','ìˆœì„œì— ì ìš©',0),(382160,10616,'he','×œ×”×—×™×œ ×¢×œ ×¡×“×¨',0),(382161,10616,'el','Î•Ï†Î±ÏÎ¼ÏŒÎ¶Î¿Ï…Î½ ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î·',0),(382162,10616,'zh','åº”ç”¨äºŽè®¢å•\r\n',0),(382163,10616,'sv','GÃ¤ller fÃ¶r Order',0),(382164,10616,'it','Applicare all\'ordine',0),(382165,10616,'tl','',0),(382166,10616,'th','à¹ƒà¸Šà¹‰à¸à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(382167,10616,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(382168,10616,'ms','Memohon perintah',0),(382169,10616,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(382170,10616,'fr','S\'appliquent aux ordres',0),(382171,10616,'jp','æ³¨æ–‡ã«é©ç”¨ã—ã¾ã™ã€‚',0),(382172,10616,'pt','Aplicar a ordem',0),(382173,10616,'ru','ÐŸÐ¾Ð´Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(382174,10616,'es','Aplica al Orden',0),(382175,10616,'de','Wenden Sie auf Bestellung',0),(382176,10616,'en','Apply To Order',0),(382177,10617,'is','',0),(382178,10617,'dr','Ø§Ø¹ØªØ¨Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(382179,10617,'pr','Ø§Ø¹ØªØ¨Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(382180,10617,'tr','Kredi kullanÄ±labilir',0),(382181,10617,'pl','Kredyt dostÄ™pny',0),(382182,10617,'bg','ÐÐ°Ð»Ð¸Ñ‡ÐµÐ½ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(382183,10617,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ø¯Ø³ØªÛŒØ§Ø¨',0),(382184,10617,'sr','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(382185,10617,'vi','cÃ³ tÃ­n dá»¥ng',0),(382186,10617,'af','Krediet Beskikbaar',0),(382187,10617,'ro','Credit disponibil',0),(382188,10617,'et','Olmas olev krediit',0),(382189,10617,'si','Kreditov, ki so na voljo',0),(382190,10617,'ba','Kredit yang tersedia',0),(382191,10617,'nl','Krediet beschikbaar',0),(382192,10617,'fi','KÃ¤ytettÃ¤vissÃ¤ oleva luotto',0),(382193,10617,'no','Kreditten som er tilgjengelig',0),(382194,10617,'da','Kreditter til rÃ¥dighed',0),(382195,10617,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” ì‹ ìš©',0),(382196,10617,'he','××©×¨××™ ×–×ž×™×Ÿ',0),(382197,10617,'el','Î Î¹ÏƒÏ„ÏŽÏƒÎµÏ‰Î½ Ï€Î¿Ï… Î´Î¹Î±Ï„Î¯Î¸ÎµÎ½Ï„Î±Î¹',0),(382198,10617,'zh','æä¾›ä¿¡è´·\r\n',0),(382199,10617,'sv','Kredit finns',0),(382200,10617,'it','Credito disponibile',0),(382201,10617,'tl','',0),(382202,10617,'th','à¸§à¸‡à¹€à¸‡à¸´à¸™à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­',0),(382203,10617,'hi','à¤‹à¤£ à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(382204,10617,'ms','Kredit yang tersedia',0),(382205,10617,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ù…ØªØ§Ø­',0),(382206,10617,'fr','CrÃ©dit disponible',0),(382207,10617,'jp','åˆ©ç”¨å¯èƒ½ãªã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ',0),(382208,10617,'pt','CrÃ©dito disponÃ­vel',0),(382209,10617,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ð¹ ÐšÑ€ÐµÐ´Ð¸Ñ‚',0),(382210,10617,'es','CrÃ©dito Disponible',0),(382211,10617,'de','Kredit erhÃ¤ltlich',0),(382212,10617,'en','Credit Available',0),(382213,10618,'is','',0),(382214,10618,'dr','Ú†Ú¯ÙˆÙ†Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´ÙˆØ¯ ',0),(382215,10618,'pr','Ú†Ú¯ÙˆÙ†Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´ÙˆØ¯ ',0),(382216,10618,'tr','NasÄ±l iÅŸlenir',0),(382217,10618,'pl','Jak proces',0),(382218,10618,'bg','ÐšÐ°Ðº Ð´Ð° ÑÐµ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð²Ð°Ñ‚',0),(382219,10618,'ur','Ø¹Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú©Ø³ Ø·Ø±Ø­',0),(382220,10618,'sr','ÐšÐ°ÐºÐ¾ ÑÐµ Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(382221,10618,'vi','LÃ m tháº¿ nÃ o Ä‘á»ƒ xá»­ lÃ½',0),(382222,10618,'af','Hoe Om te Verwerk',0),(382223,10618,'ro','Cum sÄƒ proces',0),(382224,10618,'et','Kuidas protsess',0),(382225,10618,'si','Kako se proces',0),(382226,10618,'ba','Bagaimana proses',0),(382227,10618,'nl','Hoe om te verwerken',0),(382228,10618,'fi','Miten kÃ¤sitellÃ¤',0),(382229,10618,'no','Hvordan Ã¥ behandle',0),(382230,10618,'da','Hvordan til at behandle',0),(382231,10618,'ko','ì²˜ë¦¬ í•˜ëŠ” ë°©ë²•',0),(382232,10618,'he','×›×™×¦×“ ×œ×¢×‘×“',0),(382233,10618,'el','Î ÏŽÏ‚ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î¬Î¶Î¿Î½Ï„Î±Î¹',0),(382234,10618,'zh','å¦‚ä½•å¤„ç†\r\n',0),(382235,10618,'sv','Hur att behandla',0),(382236,10618,'it','Come elaborare',0),(382237,10618,'tl','',0),(382238,10618,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥',0),(382239,10618,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥ˆà¤¸à¥‡',0),(382240,10618,'ms','Bagaimana untuk proses',0),(382241,10618,'ar','ÙƒÙŠÙ ÙŠÙ…ÙƒÙ† Ù„Ø¹Ù…Ù„ÙŠØ©',0),(382242,10618,'fr','Comment traiter les',0),(382243,10618,'jp','å‡¦ç†ã™ã‚‹æ–¹æ³•',0),(382244,10618,'pt','Como processo',0),(382245,10618,'ru','ÐšÐ°Ðº Ð¾Ð±Ñ€Ð°Ð±Ð°Ñ‚Ñ‹Ð²Ð°Ñ‚ÑŒ',0),(382246,10618,'es','Como Procesar',0),(382247,10618,'de','Gewusst wie: verarbeiten',0),(382248,10618,'en','How To Process',0),(382249,10619,'is','',0),(382250,10619,'dr','Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯  Ø§Ú¯Ø± Ø¨Ø±Ø±Ø³ÙŠ Ù†Ù…ÙŠ Ø´ÙˆØ¯',0),(382251,10619,'pr','Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯  Ø§Ú¯Ø± Ø¨Ø±Ø±Ø³ÙŠ Ù†Ù…ÙŠ Ø´ÙˆØ¯',0),(382252,10619,'tr','DeÄŸil tarama boÅŸ bÄ±rakÄ±n',0),(382253,10619,'pl','Pozostaw je puste, jeÅ›li nie skanowania',0),(382254,10619,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð°ÐºÐ¾ Ð½Ðµ ÑÐºÐ°Ð½Ð¸Ñ€Ð°Ð½Ðµ',0),(382255,10619,'ur','Ø³Ú©ÛŒÙ† Ú©Ø± Ø±ÛØ§ ÛÛ’ Ù†Û ØªÙˆ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº Û”',0),(382256,10619,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð°ÐºÐ¾ Ð½Ðµ ÑÐºÐµÐ½Ð¸Ñ€Ð°',0),(382257,10619,'vi','Äá»ƒ trá»‘ng náº¿u khÃ´ng quyÃ©t',0),(382258,10619,'af','LeÃ« verlaat as skandeer nie',0),(382259,10619,'ro','LÄƒsaÅ£i necompletat dacÄƒ nu de scanare',0),(382260,10619,'et','JÃ¤ta tÃ¼hjaks, kui pÃ¶Ã¶rduspunktiga',0),(382261,10619,'si','Pustite prazno, Äe ne ki se more skandirati',0),(382262,10619,'ba','Kosongkan jika tidak pemindaian',0),(382263,10619,'nl','Laat leeg indien niet scannen',0),(382264,10619,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi jos ei kartoittava',0),(382265,10619,'no','La stÃ¥ tomt hvis ikke skanning',0),(382266,10619,'da','Efterlad Blank hvis ikke Scanning',0),(382267,10619,'ko','ìŠ¤ìº” í•˜ì§€ ê²½ìš° ë¹ˆì„ ë– ë‚˜',0),(382268,10619,'he','×œ×”×©××™×¨ ×¨×™×§ ×× ××™× ×• ×¡×•×¨×§',0),(382269,10619,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ ÎµÎ¬Î½ Î´ÎµÎ½ ÏƒÎ¬ÏÏ‰ÏƒÎ·',0),(382270,10619,'zh','å¦‚æžœä¸æ‰«æç•™ç©º\r\n',0),(382271,10619,'sv','LÃ¤mna tomt om inte skanning',0),(382272,10619,'it','Lasciare vuoto se non la scansione',0),(382273,10619,'tl','',0),(382274,10619,'th','à¸›à¸¥à¹ˆà¸­à¸¢à¸§à¹ˆà¸²à¸‡à¹„à¸¡à¹ˆà¸ªà¹à¸à¸™',0),(382275,10619,'hi','à¤¯à¤¦à¤¿ à¤¸à¥à¤•à¥ˆà¤¨ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ à¤¨à¤¹à¥€à¤‚ à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚',0),(382276,10619,'ms','Tinggalkan kosong jika tidak mengimbas',0),(382277,10619,'ar','ØªØ±Ùƒ ÙØ§Ø±ØºØ© ÙÙŠ Ø­Ø§Ù„Ø© Ø¹Ø¯Ù… Ø§Ù„Ù…Ø³Ø­',0),(382278,10619,'fr','Laisser en blanc si ne pas numÃ©riser',0),(382279,10619,'jp','ã‚¹ã‚­ãƒ£ãƒ³ã—ãªã„å ´åˆã¯ç©ºç™½ã‚’ã¾ã¾',0),(382280,10619,'pt','Deixe em branco se nÃ£o analisar',0),(382281,10619,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, ÐµÑÐ»Ð¸ Ð½Ðµ ÑÐºÐ°Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(382282,10619,'es','Deja en Blanco si no Esta Escaneando',0),(382283,10619,'de','Lassen Sie leer, falls nicht scannen',0),(382284,10619,'en','Leave Blank If Not Scanning',0),(382285,10620,'is','',0),(382286,10620,'dr','Ø«Ø¨Øª Ø¯Ø³ØªÙŠ ',0),(382287,10620,'pr','Ø«Ø¨Øª Ø¯Ø³ØªÙŠ ',0),(382288,10620,'tr','El ile girin',0),(382289,10620,'pl','WprowadÅº rÄ™cznie',0),(382290,10620,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ€ÑŠÑ‡Ð½Ð¾',0),(382291,10620,'ur','Ø¯Ø³ØªÛŒ Ø·ÙˆØ± Ù¾Ø± Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(382292,10620,'sr','Ð ÑƒÑ‡Ð½Ð¾ ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ',0),(382293,10620,'vi','Nháº­p thá»§ cÃ´ng',0),(382294,10620,'af','Invoer Per Hand',0),(382295,10620,'ro','Introduce manual',0),(382296,10620,'et','KÃ¤sitsi sisestada',0),(382297,10620,'si','RoÄno vnesite',0),(382298,10620,'ba','Secara manual memasukkan',0),(382299,10620,'nl','Handmatig invoeren',0),(382300,10620,'fi','Manuaalisesti',0),(382301,10620,'no','Angi manuelt',0),(382302,10620,'da','Angiv manuelt',0),(382303,10620,'ko','ìˆ˜ë™ìœ¼ë¡œ ìž…ë ¥',0),(382304,10620,'he','×”×–×Ÿ ×‘××•×¤×Ÿ ×™×“× ×™',0),(382305,10620,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï‡ÎµÎ¹ÏÎ¿ÎºÎ¯Î½Î·Ï„Î±',0),(382306,10620,'zh','æ‰‹åŠ¨è¾“å…¥\r\n',0),(382307,10620,'sv','Ange manuellt',0),(382308,10620,'it','Immettere manualmente',0),(382309,10620,'tl','',0),(382310,10620,'th','à¸›à¹‰à¸­à¸™à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(382311,10620,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤°à¥‚à¤ª à¤¸à¥‡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(382312,10620,'ms','Secara manual masukkan',0),(382313,10620,'ar','Ø£Ø¯Ø®Ù„ ÙŠØ¯ÙˆÙŠØ§Ù‹',0),(382314,10620,'fr','Saisir manuellement',0),(382315,10620,'jp','æ‰‹å‹•ã§å…¥åŠ›ã—ã¾ã™ã€‚',0),(382316,10620,'pt','Inserir manualmente',0),(382317,10620,'ru','Ð’Ð²ÐµÑÑ‚Ð¸ Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ',0),(382318,10620,'es','Entrar Manualmente',0),(382319,10620,'de','Manuell eingeben',0),(382320,10620,'en','Manually Enter',0),(382321,10621,'is','',0),(382322,10621,'dr','ÙƒØ§Ø±Øª Ø§Ø³ÙƒÙ†',0),(382323,10621,'pr','ÙƒØ§Ø±Øª Ø§Ø³ÙƒÙ†',0),(382324,10621,'tr','Kart tarama',0),(382325,10621,'pl','Zeskanuj kartÄ™',0),(382326,10621,'bg','Ð¡ÐºÐ°Ð½Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(382327,10621,'ur','Ú©Ø§Ø±Úˆ Ø§Ø³Ú©ÛŒÙ†',0),(382328,10621,'sr','Ð¡ÐºÐµÐ½Ð¸Ñ€Ð°Ñ˜ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(382329,10621,'vi','quÃ©t tháº»',0),(382330,10621,'af','Skandeer kaart',0),(382331,10621,'ro','Scanare carte',0),(382332,10621,'et','Skanneeri kaart',0),(382333,10621,'si','Skeniranje kartice',0),(382334,10621,'ba','Scan kartu',0),(382335,10621,'nl','Scannen van kaart',0),(382336,10621,'fi','Skannaa kortti',0),(382337,10621,'no','Skanne kort',0),(382338,10621,'da','Scanne kortet',0),(382339,10621,'ko','ì¹´ë“œ ìŠ¤ìº”',0),(382340,10621,'he','×¡×¨×•×§ ×›×¨×˜×™×¡',0),(382341,10621,'el','Î£Î¬ÏÏ‰ÏƒÎ· ÎºÎ¬ÏÏ„Î±',0),(382342,10621,'zh','æ‰«æå¡\r\n',0),(382343,10621,'sv','Skanna kort',0),(382344,10621,'it','Scansione scheda',0),(382345,10621,'tl','',0),(382346,10621,'th','à¸ªà¹à¸à¸™à¸šà¸±à¸•à¸£',0),(382347,10621,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤¸à¥à¤•à¥ˆà¤¨ à¤•à¤°à¥‡à¤‚',0),(382348,10621,'ms','Mengimbas Kad',0),(382349,10621,'ar','Ù…Ø³Ø­ Ø§Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(382350,10621,'fr','Scanner carte',0),(382351,10621,'jp','ã‚«ãƒ¼ãƒ‰ã‚’ã‚¹ã‚­ãƒ£ãƒ³ã—ã¾ã™ã€‚',0),(382352,10621,'pt','VerificaÃ§Ã£o de cartÃ£o',0),(382353,10621,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÐºÐ°Ñ€Ñ‚Ñ‹',0),(382354,10621,'es','Escanear Tarjeta',0),(382355,10621,'de','Card Scan',0),(382356,10621,'en','Scan Card',0),(382357,10622,'is','',0),(382358,10622,'dr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø¯Ø§Ø¯Ù‡',0),(382359,10622,'pr','Ù¾ÙŠÚ¯ÙŠØ±ÙŠ Ø¯Ø§Ø¯Ù‡',0),(382360,10622,'tr','Verileri izlemek',0),(382361,10622,'pl','Åšledzenie danych',0),(382362,10622,'bg','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸',0),(382363,10622,'ur','Ù¹Ø±ÛŒÚ© Ú©ÙˆØ§Ø¦Ù',0),(382364,10622,'sr','ÐŸÑ€Ð°Ñ›ÐµÑšÐµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(382365,10622,'vi','Theo dÃµi dá»¯ liá»‡u',0),(382366,10622,'af','Spoor Data',0),(382367,10622,'ro','UrmÄƒri datele',0),(382368,10622,'et','Pala andmed',0),(382369,10622,'si','Spremljanje podatkov',0),(382370,10622,'ba','Melacak Data',0),(382371,10622,'nl','Gegevens bijhouden',0),(382372,10622,'fi','Kappaleen tiedot',0),(382373,10622,'no','Spore Data',0),(382374,10622,'da','Spordata',0),(382375,10622,'ko','íŠ¸ëž™ ë°ì´í„°',0),(382376,10622,'he','×ž×¢×§×‘ ××—×¨ × ×ª×•× ×™',0),(382377,10622,'el','Î Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ· Ï„Ï‰Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(382378,10622,'zh','è½¨é“æ•°æ®\r\n',0),(382379,10622,'sv','SpÃ¥ra Data',0),(382380,10622,'it','Tenere traccia dei dati',0),(382381,10622,'tl','',0),(382382,10622,'th','à¸•à¸´à¸”à¸•à¸²à¸¡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(382383,10622,'hi','à¤Ÿà¥à¤°à¥ˆà¤• à¤¡à¥‡à¤Ÿà¤¾',0),(382384,10622,'ms','Mengesan Data',0),(382385,10622,'ar','ØªØ¹Ù‚Ø¨ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(382386,10622,'fr','Suivi des donnÃ©es',0),(382387,10622,'jp','ãƒ‡ãƒ¼ã‚¿ã‚’è¿½è·¡ã—ã¾ã™ã€‚',0),(382388,10622,'pt','Trilha de dados',0),(382389,10622,'ru','ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(382390,10622,'es','Rastrear Datos',0),(382391,10622,'de','Streckendaten',0),(382392,10622,'en','Track Data',0),(382393,10623,'is','',0),(382394,10623,'dr','Ø¨Ø§ÙŠØ¯ Ù…Ø­Ù„ Ø®Ø§ØµÙŠ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(382395,10623,'pr','Ø¨Ø§ÙŠØ¯ Ù…Ø­Ù„ Ø®Ø§ØµÙŠ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯ ',0),(382396,10623,'tr','Ã–zel konumu seÃ§melisiniz',0),(382397,10623,'pl','NaleÅ¼y wybraÄ‡ okreÅ›lonej lokalizacji',0),(382398,10623,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(382399,10623,'ur','Ø§Ø®ØªØµØ§ØµÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(382400,10623,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(382401,10623,'vi','Pháº£i chá»n vá»‹ trÃ­ Ä‘áº·c biá»‡t',0),(382402,10623,'af','Moet kies spesifieke ligging',0),(382403,10623,'ro','Trebuie sÄƒ selectaÅ£i locaÅ£ie specificÄƒ',0),(382404,10623,'et','Peate valima asukoha',0),(382405,10623,'si','Morate izbrati doloÄeno lokacijo',0),(382406,10623,'ba','Harus memilih lokasi tertentu',0),(382407,10623,'nl','Specifieke locatie moet selecteren',0),(382408,10623,'fi','Valitse tietyssÃ¤ paikassa',0),(382409,10623,'no','MÃ¥ velge spesifikk plassering',0),(382410,10623,'da','Skal vÃ¦lge specifikke placering',0),(382411,10623,'ko','íŠ¹ì • ìœ„ì¹˜ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(382412,10623,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×ž×™×§×•× ×¡×¤×¦×™×¤×™',0),(382413,10623,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Ï„Î· ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î· Î¸Î­ÏƒÎ·',0),(382414,10623,'zh','å¿…é¡»é€‰æ‹©ç‰¹å®šåœ°ç‚¹\r\n',0),(382415,10623,'sv','MÃ¥ste vÃ¤lja viss plats',0),(382416,10623,'it','Necessario selezionare un percorso specifico',0),(382417,10623,'tl','',0),(382418,10623,'th','à¸•à¹‰à¸­à¸‡à¸£à¸°à¸šà¸¸',0),(382419,10623,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(382420,10623,'ms','Mesti pilih lokasi tertentu',0),(382421,10623,'ar','ÙŠØ¬Ø¨ ØªØ­Ø¯ÙŠØ¯ Ù…ÙˆÙ‚Ø¹ Ù…Ø¹ÙŠÙ†',0),(382422,10623,'fr','Devez sÃ©lectionner emplacement spÃ©cifique',0),(382423,10623,'jp','ç‰¹å®šã®å ´æ‰€ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(382424,10623,'pt','Deve selecionar o local especÃ­fico',0),(382425,10623,'ru','ÐÐ°Ð´Ð¾ Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ð¾Ðµ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(382426,10623,'es','Debe Seleccionar un Sitio EspecÃ­fico',0),(382427,10623,'de','MÃ¼ssen bestimmten Ort auswÃ¤hlen',0),(382428,10623,'en','Must Select Specific Location',0),(382429,10624,'is','',0),(382430,10624,'dr','Ú¯Ø²ÙŠÙ†Ù‡ Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ ÙŠØ§ Ú¯Ø±ÙˆÙ‡ Ø§Ø² ÙƒØ§Ù„Ø§ Ú¯Ù… Ø´Ø¯Ù‡ ',0),(382431,10624,'pr','Ú¯Ø²ÙŠÙ†Ù‡ Ù†Ø§Ù… ÙˆØ§Ø­Ø¯ ÙŠØ§ Ú¯Ø±ÙˆÙ‡ Ø§Ø² ÙƒØ§Ù„Ø§ Ú¯Ù… Ø´Ø¯Ù‡ ',0),(382432,10624,'tr','Birim adÄ± seÃ§im veya kategori Ã¶ÄŸesine ait eksik olduÄŸunu&#xD;\nÄ°lk ana Ã¶ÄŸesi verilerini kaydetmeyi deneyin',0),(382433,10624,'pl','WybÃ³r nazwy jednostki lub kategorii jest chybianie z przedmiotu&#xD;\nSprÃ³buj najpierw zapisywanie danych gÅ‚Ã³wnych element',0),(382434,10624,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° Ð¸Ð¼Ðµ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð»Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð»Ð¸Ð¿ÑÐ²Ð° Ð¾Ñ‚ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚&#xD;\nÐžÐ¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ ÑÐµ Ð´Ð° Ð·Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð´Ð°Ð½Ð½Ð¸ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²ÐµÐ½ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ Ð¿ÑŠÑ€Ð²Ð¾',0),(382435,10624,'ur','ÛŒÙˆÙ†Ù¹ Ú©Ø§ Ù†Ø§Ù… Ù¾Ø³Ù†Ø¯ ÛŒØ§ Ø²Ù…Ø±Û Ø´Û’ Ø³Û’ ØºØ§Ø¦Ø¨ ÛÛ’&#xD;\nØ³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§ØµÙ„ Ø´Û’ Ú©ÙˆØ§Ø¦Ù Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(382436,10624,'sr','Ð˜Ð·Ð±Ð¾Ñ€ Ð¸Ð¼ÐµÐ½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð»Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸ Ñ˜Ðµ Ð½ÐµÑÑ‚Ð°Ð»Ð° Ð¸Ð· ÑÑ‚Ð°Ð²ÐºÐµ&#xD;\nÐŸÑ€Ð¾Ð±Ð°Ñ˜ Ð¿Ñ€Ð²Ð¾ Ñ‡ÑƒÐ²Ð°ÑšÐ° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð³Ð»Ð°Ð²Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(382437,10624,'vi','Chá»n tÃªn Ä‘Æ¡n vá»‹ hoáº·c hÃ ng hÃ³a bá»‹ thiáº¿u trong danh má»¥c',0),(382438,10624,'af','Eenheid naam keuse of kategorie is Missing van Item&#xD;\nProbeer eers belangrikste Item Data stoor',0),(382439,10624,'ro','Alegerea de nume de unitatea sau categorie este lipsÄƒ de element&#xD;\nÃŽncercaÈ›i sÄƒ salvaÈ›i elementul principal date Ã®n primul rÃ¢nd',0),(382440,10624,'et','Ãœksuse nime valik vÃµi kategooria on kadunud Ã¼ksus&#xD;\nProovige salvestada peamine kirje andmed esmalt',0),(382441,10624,'si','Izbira ime enote ali kategorija manjka iz postavke&#xD;\nPoskusite shraniti glavni element podatkov najprej',0),(382442,10624,'ba','Unit nama pilihan atau kategori yang hilang dari Item&#xD;\nMencoba menyimpan Data Item utama pertama',0),(382443,10624,'nl','Eenheid naam keuze of categorie ontbreekt van Item&#xD;\nProbeer op te slaan belangrijkste Item gegevens eerst',0),(382444,10624,'fi','YksikÃ¶n nimi valinta tai ryhmÃ¤ on puuttuva kohde&#xD;\nYritÃ¤ tallentaa tÃ¤rkeimmÃ¤t kohteen tiedot ensin',0),(382445,10624,'no','Enheten navnevalget eller kategori er mangler fra element&#xD;\nPrÃ¸v Ã¥ lagre viktigste elementdata fÃ¸rst',0),(382446,10624,'da','Enhed navn valg eller kategori er savnet fra vare&#xD;\nPrÃ¸ve at gemme vigtigste varedata fÃ¸rst',0),(382447,10624,'ko','ìž¥ì¹˜ ì´ë¦„ì„ ì„ íƒ í•˜ê±°ë‚˜ ë²”ì£¼ëŠ” í•­ëª©ì—ì„œ ëˆ„ë½&#xD;\në¨¼ì € ì£¼ìš” í•­ëª© ë°ì´í„°ë¥¼ ì €ìž¥ í•˜ë ¤ê³  í•˜ë©´',0),(382448,10624,'he','×”×‘×—×™×¨×” ×©× ×™×—×™×“×” ××• ×§×˜×’×•×¨×™×” ×”×•× ×—×¡×¨ ×ž×¤×¨×™×˜&#xD;\n× ×¡×” ×œ×©×ž×•×¨ × ×ª×•× ×™ ×¤×¨×™×˜ ×”×¨××©×™ ×§×•×“×',0),(382449,10624,'el','Î•Ï€Î¹Î»Î¿Î³Î® Î¿Î½ÏŒÎ¼Î±Ï„Î¿Ï‚ Î¼Î¿Î½Î¬Î´Î± Î® ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î»ÎµÎ¯Ï€ÎµÎ¹ Î±Ï€ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿&#xD;\nÎ•Ï€Î¹Ï‡ÎµÎ¹ÏÎ®ÏƒÏ„Îµ Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î¿ ÎºÏÏÎ¹Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï€ÏÏŽÏ„Î±',0),(382450,10624,'zh','å•ä½åç§°é€‰æ‹©æˆ–ç±»åˆ«æ˜¯ä»Žé¡¹ç›®ä¸­ä¸¢å¤±\r\n',0),(382451,10624,'sv','Enhet namn val eller kategori saknas frÃ¥n objekt&#xD;\nFÃ¶rsÃ¶k spara huvudpunkten Data fÃ¶rst',0),(382452,10624,'it','Scelta di nome unitÃ  o categoria Ã¨ mancante dalla voce&#xD;\nSalvare i dati dell\'elemento principale prima',0),(382453,10624,'tl','',0),(382454,10624,'th','à¹€à¸¥à¸·à¸­à¸à¸Šà¸·à¹ˆà¸­à¸«à¸™à¹ˆà¸§à¸¢à¸«à¸£à¸·à¸­à¸›à¸£à¸°à¹€à¸ à¸—à¸ˆà¸°à¸«à¸²à¸¢à¹„à¸›à¸ˆà¸²à¸à¸£à¸²à¸¢à¸à¸²à¸£&#xD;\nà¸žà¸¢à¸²à¸¢à¸²à¸¡à¸šà¸±à¸™à¸—à¸¶à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¸´à¸™à¸„à¹‰à¸²à¸«à¸¥à¸±à¸à¹à¸£à¸',0),(382455,10624,'hi','à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤¨à¤¾à¤® à¤šà¤¯à¤¨ à¤¯à¤¾ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤†à¤‡à¤Ÿà¤® à¤¸à¥‡ à¤—à¥à¤® à¤¹à¥ˆ&#xD;\nà¤ªà¤¹à¤²à¥€ à¤¬à¤¾à¤° à¤®à¥à¤–à¥à¤¯ à¤†à¤‡à¤Ÿà¤® à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤•à¤¾ à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚',0),(382456,10624,'ms','Pilihan nama unit atau kategori yang hilang dari perkara&#xD;\nCuba simpan Data utama Item pertama',0),(382457,10624,'ar','Ø§Ø®ØªÙŠØ§Ø± Ø§Ø³Ù… Ø§Ù„ÙˆØ­Ø¯Ø© Ø£Ùˆ Ø§Ù„ÙØ¦Ø© Ù‡Ùˆ Ù…ÙÙ‚ÙˆØ¯ Ù…Ù† Ø§Ù„Ø¨Ù†Ø¯&#xD;\nØ­Ø§ÙˆÙ„ Ø­ÙØ¸ Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ Ø§Ù„Ø£ÙˆÙ„',0),(382458,10624,'fr','Choix de nom de groupe ou catÃ©gorie est manquant sur le point&#xD;\nEssayez d\'enregistrer les donnÃ©es d\'Ã©lÃ©ment principal tout d\'abord',0),(382459,10624,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆåã‚’é¸æŠžã¾ãŸã¯ã‚«ãƒ†ã‚´ãƒªã¯é …ç›®ã‹ã‚‰ä¸è¶³ã§ã™ã€‚ã¾ãšãƒ¡ã‚¤ãƒ³é …ç›®ãƒ‡ãƒ¼ã‚¿ã‚’ä¿å­˜ã—ã¦ãã ã•ã„ã€‚',0),(382460,10624,'pt','Escolha de nome de unidade ou categoria Ã© ausente do Item&#xD;\nTente salvar dados do principal Item primeiro',0),(382461,10624,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ Ð¸Ð¼Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð¸Ð»Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚&#xD;\nÐŸÐ¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð¾ÑÐ½Ð¾Ð²Ð½Ñ‹Ñ… ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÑÐ½Ð°Ñ‡Ð°Ð»Ð°',0),(382462,10624,'es','SelecciÃ³n o CategorÃ­a de Nombre de Unidad Se Falta del Item.\nIntenta Guardar Datos del Item Principal Primero',0),(382463,10624,'de','Einheit Name Wahl oder Kategorie fehlt von Element&#xD;\nVersuchen Sie zuerst Hauptsache Daten zu speichern',0),(382464,10624,'en','Unit Name Choice or Category is Missing from Item\r\nTry Saving Main Item Data First',0),(382465,10625,'is','',0),(382466,10625,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª ØªØ§Ø¨Ù„Ùˆ Ø±ÙˆÛŒØ¯Ø§Ø¯Ù‡Ø§ ',0),(382467,10625,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª ØªØ§Ø¨Ù„Ùˆ Ø±ÙˆÛŒØ¯Ø§Ø¯Ù‡Ø§ ',0),(382468,10625,'tr','Pano raporlar',0),(382469,10625,'pl','Panel raporty',0),(382470,10625,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ‡Ð½Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(382471,10625,'ur','ÚˆÛŒØ´ Ø¨ÙˆØ±Úˆ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(382472,10625,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸Ð¼Ð° ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ñ‚Ð°Ð±Ð»Ðµ',0),(382473,10625,'vi','bÃ¡o cÃ¡o dashboard',0),(382474,10625,'af','Paneelbord Verslae',0),(382475,10625,'ro','Rapoarte de tabloul de bord',0),(382476,10625,'et','Armatuurlaua aruannetes',0),(382477,10625,'si','Armaturni ploÅ¡Äi poroÄila',0),(382478,10625,'ba','Laporan dasbor',0),(382479,10625,'nl','Dashboardrapporten',0),(382480,10625,'fi','Tilannevedoksia',0),(382481,10625,'no','Dashboard rapporter',0),(382482,10625,'da','Dashboard rapporter',0),(382483,10625,'ko','ëŒ€ì‹œë³´ë“œ ë³´ê³ ì„œ',0),(382484,10625,'he','×œ×•×— ×”×ž×—×•×•× ×™× ×“×•×—×•×ª',0),(382485,10625,'el','Î•ÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ Ï„Î¿Ï… Ï„Î±Î¼Ï€Î»ÏŒ',0),(382486,10625,'zh','ä»ªè¡¨æ¿æŠ¥è¡¨\r\n',0),(382487,10625,'sv','Instrumentpanelen rapporter',0),(382488,10625,'it','Dashboard Reports',0),(382489,10625,'tl','',0),(382490,10625,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸‚à¸­à¸‡à¹à¸”à¸Šà¸šà¸­à¸£à¹Œà¸”',0),(382491,10625,'hi','à¤¡à¥ˆà¤¶à¤¬à¥‹à¤°à¥à¤¡ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(382492,10625,'ms','Papan pemuka Laporan',0),(382493,10625,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ù„ÙˆØ­Ø© Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(382494,10625,'fr','Rapports du tableau de bord',0),(382495,10625,'jp','ãƒ€ãƒƒã‚·ãƒ¥ ãƒœãƒ¼ãƒ‰ã®ãƒ¬ãƒãƒ¼ãƒˆ',0),(382496,10625,'pt','RelatÃ³rios do painel de controle',0),(382497,10625,'ru','ÐžÑ‚Ñ‡ÐµÑ‚Ñ‹ Ð¿Ð°Ð½ÐµÐ»Ð¸ Ð¼Ð¾Ð½Ð¸Ñ‚Ð¾Ñ€Ð¸Ð½Ð³Ð°',0),(382498,10625,'es','Informes de Dashboard',0),(382499,10625,'de','Dashboard-Berichte',0),(382500,10625,'en','Dashboard Reports',0),(382501,10626,'is','',0),(382502,10626,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø²Ø§Ø±Ø´Ø§Øª ØªØ§Ø¨Ù„Ùˆ Ø±ÙˆÛŒØ¯Ø§Ø¯Ù‡Ø§',0),(382503,10626,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ú¯Ø²Ø§Ø±Ø´Ø§Øª ØªØ§Ø¨Ù„Ùˆ Ø±ÙˆÛŒØ¯Ø§Ø¯Ù‡Ø§',0),(382504,10626,'tr','Pano raporlar gÃ¼ncelleÅŸtirme hatasÄ±',0),(382505,10626,'pl','Niepowodzenia aktualizacji pulpitu nawigacyjnego raporty',0),(382506,10626,'bg','Ð¢Ð°Ð±Ð»Ð¾ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(382507,10626,'ur','ÚˆÛŒØ´ Ø¨ÙˆØ±Úˆ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…ÛŒ',0),(382508,10626,'sr','ÐÐµÑƒÑÐ¿ÐµÑ… Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ñ‚Ð°Ð±Ð»Ðµ',0),(382509,10626,'vi','cáº­p nháº­t bÃ¡o cÃ¡o dashboard tháº¥t báº¡i',0),(382510,10626,'af','Dashboard verslae bywerking versuim',0),(382511,10626,'ro','Tabloul de bord rapoarte Update eÅŸec',0),(382512,10626,'et','Armatuurlaua aruannetes Update rike',0),(382513,10626,'si','Armaturni ploÅ¡Äi poroÄila posodobitev neuspeh',0),(382514,10626,'ba','Kegagalan Update laporan dasbor',0),(382515,10626,'nl','Dashboard rapporten Update mislukt',0),(382516,10626,'fi','Dashboard raportit pÃ¤ivityksen epÃ¤onnistumisen',0),(382517,10626,'no','Dashboard rapporter oppdatere dÃ¥rlig',0),(382518,10626,'da','Dashboard rapporter Update fejl',0),(382519,10626,'ko','ëŒ€ì‹œë³´ë“œ ë³´ê³ ì„œ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(382520,10626,'he','×œ×•×— ×ž×—×•×•× ×™× ×›×©×œ ×¢×“×›×•×Ÿ ×“×™×•×•×—×™×',0),(382521,10626,'el','Î¤Î·Î½ Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î± Î±Î½Î±Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³ÏŽÎ½ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ Ï„Î±Î¼Ï€Î»ÏŒ',0),(382522,10626,'zh','ä»ªè¡¨æ¿æŠ¥è¡¨æ›´æ–°å¤±è´¥\r\n',0),(382523,10626,'sv','Instrumentpanelen rapporter uppdatering underlÃ¥tenhet',0),(382524,10626,'it','Errore di aggiornamento dashboard Reports',0),(382525,10626,'tl','',0),(382526,10626,'th','à¹à¸”à¸Šà¸šà¸­à¸£à¹Œà¸”à¸£à¸²à¸¢à¸‡à¸²à¸™à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(382527,10626,'hi','à¤¡à¥ˆà¤¶à¤¬à¥‹à¤°à¥à¤¡ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²à¤¤à¤¾',0),(382528,10626,'ms','Papan pemuka laporan Kemaskini kegagalan',0),(382529,10626,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« ØªÙ‚Ø§Ø±ÙŠØ± Ù„ÙˆØ­Ø© Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(382530,10626,'fr','Tableau de bord des rapports Ã©chec de mise Ã  jour',0),(382531,10626,'jp','ãƒ€ãƒƒã‚·ãƒ¥ ãƒœãƒ¼ãƒ‰ã®ãƒ¬ãƒãƒ¼ãƒˆã®æ›´æ–°ã®å¤±æ•—',0),(382532,10626,'pt','Falha de atualizaÃ§Ã£o do painel de controle relatÃ³rios',0),(382533,10626,'ru','Ð¡Ð±Ð¾Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ð°Ð½ÐµÐ»Ð¸ Ð¼Ð¾Ð½Ð¸Ñ‚Ð¾Ñ€Ð¸Ð½Ð³Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¾Ð²',0),(382534,10626,'es','Informes de Dashboard Actualizar FallÃ³',0),(382535,10626,'de','Dashboard Reports Aktualisierungsfehler',0),(382536,10626,'en','Dashboard Reports Update Failure',0),(382537,10627,'is','',0),(382538,10627,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª ØªØ§Ø¨Ù„Ùˆ Ø±ÙˆÛŒØ¯Ø§Ø¯Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(382539,10627,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª ØªØ§Ø¨Ù„Ùˆ Ø±ÙˆÛŒØ¯Ø§Ø¯Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(382540,10627,'tr','Pano raporlar gÃ¼ncelleÅŸtirme baÅŸarÄ±lÄ±',0),(382541,10627,'pl','Aktualizacja Dashboard raporty sukces',0),(382542,10627,'bg','Ð¢Ð°Ð±Ð»Ð¾ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(382543,10627,'ur','ÚˆÛŒØ´ Ø¨ÙˆØ±Úˆ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ ØªØ§Ø²Û Ú©Ø§Ù…ÛŒØ§Ø¨',0),(382544,10627,'sr','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ð° Ñ‚Ð°Ð±Ð»Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð°',0),(382545,10627,'vi','cáº­p nháº­t bÃ¡o cÃ¡o dashboard thÃ nh cÃ´ng',0),(382546,10627,'af','Paneelbord Verslae Suksesvol Opdateer',0),(382547,10627,'ro','Tabloul de bord rapoarte Update de succes',0),(382548,10627,'et','Armatuurlaua aruannetes vÃ¤rskendamine Ãµnnestus',0),(382549,10627,'si','Armaturni ploÅ¡Äi poroÄila posodobitev uspeÅ¡no',0),(382550,10627,'ba','Dasbor laporan Update berhasil',0),(382551,10627,'nl','Dashboard rapporten Update succesvol',0),(382552,10627,'fi','Dashboard raportit pÃ¤ivitys onnistui',0),(382553,10627,'no','Dashboard rapporter vellykket oppdatering',0),(382554,10627,'da','Dashboard rapporter Update vellykket',0),(382555,10627,'ko','ëŒ€ì‹œë³´ë“œ ë³´ê³ ì„œ ì—…ë°ì´íŠ¸ ì„±ê³µ',0),(382556,10627,'he','×¢×“×›×•×Ÿ ×“×•×—×•×ª ×œ×•×— ×”×ž×—×•×•× ×™× ×ž×•×¦×œ×—',0),(382557,10627,'el','Î¤Î±Î¼Ï€Î»ÏŒ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎµÏ€Î¹Ï„Ï…Ï‡Î®Ï‚',0),(382558,10627,'zh','ä»ªè¡¨æ¿æŠ¥è¡¨æ›´æ–°æˆåŠŸ\r\n',0),(382559,10627,'sv','Dashboard rapporter uppdatering framgÃ¥ngsrika',0),(382560,10627,'it','Cruscotto report Aggiornamento riuscito',0),(382561,10627,'tl','',0),(382562,10627,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸¢à¸‡à¸²à¸™à¸‚à¸­à¸‡à¹à¸”à¸Šà¸šà¸­à¸£à¹Œà¸”à¸›à¸£à¸°à¸ªà¸šà¸„à¸§à¸²à¸¡à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(382563,10627,'hi','à¤¡à¥ˆà¤¶à¤¬à¥‹à¤°à¥à¤¡ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤«à¤²',0),(382564,10627,'ms','Kemaskini laporan Dashboard',0),(382565,10627,'ar','Ù„ÙˆØ­Ø© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù†Ø§Ø¬Ø­Ø©',0),(382566,10627,'fr','Tableau de bord des rapports mise Ã  jour rÃ©ussie',0),(382567,10627,'jp','æ­£å¸¸ã«ãƒ€ãƒƒã‚·ãƒ¥ ãƒœãƒ¼ãƒ‰ ãƒ¬ãƒãƒ¼ãƒˆæ›´æ–°',0),(382568,10627,'pt','Painel de controle relatÃ³rios atualizaÃ§Ã£o bem sucedida',0),(382569,10627,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð°Ð½ÐµÐ»Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(382570,10627,'es','Informes de Dashboard Actualizados Exitosamente',0),(382571,10627,'de','Dashboard Reports Update erfolgreich',0),(382572,10627,'en','Dashboard Reports Update Successful',0),(382573,10628,'is','',0),(382574,10628,'dr','Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ø´ØªØ±Ù‰',0),(382575,10628,'pr','Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ø´ØªØ±Ù‰',0),(382576,10628,'tr','Nakit giriÅŸi istemci',0),(382577,10628,'pl','NapÅ‚yw Å›rodkÃ³w pieniÄ™Å¼nych klienta',0),(382578,10628,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ñ€Ð¸Ñ‚Ð¾Ðº ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(382579,10628,'ur','Ù†Ù‚Ø¯ Inflow ÙˆØµÙˆÙ„ Ú©Ø§Ø±',0),(382580,10628,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ð¿Ñ€Ð¸Ð»Ð¸Ð² Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ',0),(382581,10628,'vi','Tiá»n máº·t dÃ²ng khÃ¡ch hÃ ng',0),(382582,10628,'af','Kontant invloei kliÃ«nt',0),(382583,10628,'ro','Client de fluxul de numerar',0),(382584,10628,'et','Raha sissevool klient',0),(382585,10628,'si','Denarnega pritoka odjemalca',0),(382586,10628,'ba','Cash Inflow klien',0),(382587,10628,'nl','Contant geld instroom Client',0),(382588,10628,'fi','Cash virtaamaan asiakas',0),(382589,10628,'no','Kontanter tilsig klient',0),(382590,10628,'da','Kontant indstrÃ¸mning klient',0),(382591,10628,'ko','í˜„ê¸ˆ ìœ ìž… í´ë¼ì´ì–¸íŠ¸',0),(382592,10628,'he','×œ×§×•×— ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(382593,10628,'el','Î ÎµÎ»Î¬Ï„Î· ÎµÎ¹ÏƒÏÎ¿Î® Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½',0),(382594,10628,'zh','å®¢æˆ·çŽ°é‡‘æµå…¥\r\n',0),(382595,10628,'sv','Kontant inflÃ¶de klient',0),(382596,10628,'it','Cassa afflusso Client',0),(382597,10628,'tl','',0),(382598,10628,'th','à¹„à¸„à¸¥à¹€à¸­à¹‡à¸™à¸•à¹Œà¸‚à¸­à¸‡à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(382599,10628,'hi','à¤¨à¤•à¤¦à¥€ à¤ªà¥à¤°à¤µà¤¾à¤¹ à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ',0),(382600,10628,'ms','Pelanggan aliran masuk Tunai',0),(382601,10628,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(382602,10628,'fr','Cash Inflow Client',0),(382603,10628,'jp','ç¾é‡‘æµå…¥ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆ',0),(382604,10628,'pt','Cliente de influxo de dinheiro',0),(382605,10628,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ñ€Ð¸Ñ‚Ð¾Ðº Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(382606,10628,'es','Cliente de Insumo de Efectivo',0),(382607,10628,'de','Cash-Zufluss-Client',0),(382608,10628,'en','Cash Inflow Client',0),(382609,10629,'is','',0),(382610,10629,'dr','Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯\r\n GFD',0),(382611,10629,'pr','Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯\r\n GFD',0),(382612,10629,'tr','Nakit giriÅŸi GFD',0),(382613,10629,'pl','GotÃ³wkowy GFD',0),(382614,10629,'bg','ÐÐ°Ð¼Ð°Ð»ÑÐ²Ð°Ñ‰Ð¸ Ð‘Ð’Ð”',0),(382615,10629,'ur','Ù†Ù‚Ø¯ Inflow Ú¯ÙØ¯',0),(382616,10629,'sr','ÐŸÑ€Ð¸Ð»Ð¸Ð² Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ Ð“Ð¤Ð”',0),(382617,10629,'vi','Tiá»n máº·t dÃ²ng GFD',0),(382618,10629,'af','Kontant invloei GFD',0),(382619,10629,'ro','Afluxul de numerar GFD',0),(382620,10629,'et','Raha sissevool GFD',0),(382621,10629,'si','Denarnega pritoka GFD',0),(382622,10629,'ba','Cash Inflow GFD',0),(382623,10629,'nl','Kasstroom GFD',0),(382624,10629,'fi','Kassavirta sisÃ¤Ã¤n GFD',0),(382625,10629,'no','KontantstrÃ¸mmen GFD',0),(382626,10629,'da','PengestrÃ¸mme GFD',0),(382627,10629,'ko','í˜„ê¸ˆ ìœ ìž… GFD',0),(382628,10629,'he','×ª×–×¨×™× ×ž×–×•×ž× ×™× × ×›× ×¡ GFD',0),(382629,10629,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÏŽÎ½ ÏÎ¿ÏŽÎ½ GFD',0),(382630,10629,'zh','çŽ°é‡‘æµå…¥èˆ¹é˜Ÿç§‘\r\n',0),(382631,10629,'sv','KassainflÃ¶de GFD',0),(382632,10629,'it','Flusso di cassa GFD',0),(382633,10629,'tl','',0),(382634,10629,'th','à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¹€à¸‚à¹‰à¸² GFD',0),(382635,10629,'hi','à¤¨à¤•à¤¦à¥€ à¤ªà¥à¤°à¤µà¤¾à¤¹ GFD',0),(382636,10629,'ms','Aliran masuk tunai GFD',0),(382637,10629,'ar','Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ Ø³Ø§Ø±ÙŠ Ø§Ù„Ù…ÙØ¹ÙˆÙ„',0),(382638,10629,'fr','RentrÃ©es de fonds Gisiger',0),(382639,10629,'jp','ç¾é‡‘æµå…¥ GFD',0),(382640,10629,'pt','Entrada de caixa Eliana',0),(382641,10629,'ru','ÐŸÑ€Ð¸Ñ‚Ð¾Ðº Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð² GFD',0),(382642,10629,'es','Entrada de Efectivo GFD',0),(382643,10629,'de','Mittelzufluss GFD',0),(382644,10629,'en','Cash Inflow GFD',0),(382645,10630,'is','',0),(382646,10630,'dr','Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯\r\n Rex',0),(382647,10630,'pr','Ø¬Ø±ÙŠØ§Ù† ÙˆØ±ÙˆØ¯ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯\r\n Rex',0),(382648,10630,'tr','Nakit giriÅŸi Rex',0),(382649,10630,'pl','Rex napÅ‚ywu Å›rodkÃ³w pieniÄ™Å¼nych',0),(382650,10630,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡ÐµÐ½ Ð¿Ñ€Ð¸Ñ‚Ð¾Ðº Ð ÐµÐºÑ',0),(382651,10630,'ur','Ù†Ù‚Ø¯ Inflow Ø±ÛŒÚ©Ø³',0),(382652,10630,'sr','Ð Ðµx Ð¿Ñ€Ð¸Ð»Ð¸Ð² Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ',0),(382653,10630,'vi','Tiá»n máº·t dÃ²ng Rex',0),(382654,10630,'af','Kontant invloei Rex',0),(382655,10630,'ro','Rex de fluxul de numerar',0),(382656,10630,'et','Raha sissevool Rex',0),(382657,10630,'si','Denarni pritok Rex',0),(382658,10630,'ba','Cash Inflow Rex',0),(382659,10630,'nl','Contant geld instroom Rex',0),(382660,10630,'fi','Cash virtaamaan Rex',0),(382661,10630,'no','Kontanter tilsig Rex',0),(382662,10630,'da','Kontant indstrÃ¸mning Rex',0),(382663,10630,'ko','í˜„ê¸ˆ ìœ ìž… ë ‰ìŠ¤',0),(382664,10630,'he','×¨×§×¡ ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(382665,10630,'el','Rex ÎµÎ¹ÏƒÏÎ¿Î® Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½',0),(382666,10630,'zh','çŽ°é‡‘æµå…¥é›·å…‹æ–¯\r\n',0),(382667,10630,'sv','Kontant inflÃ¶de Rex',0),(382668,10630,'it','Cassa afflusso Rex',0),(382669,10630,'tl','',0),(382670,10630,'th','à¹€à¸£à¹‡à¸à¸‹à¹Œà¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(382671,10630,'hi','à¤¨à¤•à¤¦ à¤‡à¤¨à¤«à¥à¤²à¥‹ à¤°à¥‡à¤•à¥à¤¸',0),(382672,10630,'ms','Rex aliran masuk Tunai',0),(382673,10630,'ar','Ø±ÙŠÙƒØ³ Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(382674,10630,'fr','Cash Inflow Rex',0),(382675,10630,'jp','ç¾é‡‘æµå…¥ãƒ¬ãƒƒã‚¯ã‚¹',0),(382676,10630,'pt','Rex de influxo de dinheiro',0),(382677,10630,'ru','Ð ÐµÐºÑ Ð¿Ñ€Ð¸Ñ‚Ð¾Ðº Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(382678,10630,'es','Entrada de Efectivo Rex',0),(382679,10630,'de','Bargeld Zufluss Rex',0),(382680,10630,'en','Cash Inflow Rex',0),(382681,10631,'is','',0),(382682,10631,'dr','Ø¬Ø±ÙŠØ§Ù† Ø®Ø±ÙˆØ¬ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ø´ØªØ±ÙŠ',0),(382683,10631,'pr','Ø¬Ø±ÙŠØ§Ù† Ø®Ø±ÙˆØ¬ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ Ù…Ø´ØªØ±ÙŠ',0),(382684,10631,'tr','Nakit Ã‡â€ºkâ€ºflâ€º istemci',0),(382685,10631,'pl','OdpÅ‚yw Å›rodkÃ³w pieniÄ™Å¼nych klienta',0),(382686,10631,'bg','ÐŸÐ°Ñ€Ð¸ Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½ÐµÑ‚Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(382687,10631,'ur','Ù†Ù‚Ø¯ Ø¨Ú¾Ø§Ø¤ ÙˆØµÙˆÙ„ Ú©Ø§Ø±',0),(382688,10631,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ð¾Ð´Ð»Ð¸Ð² Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ',0),(382689,10631,'vi','Tiá»n máº·t cháº£y ra khÃ¡ch hÃ ng',0),(382690,10631,'af','Kontant uitvloei kliÃ«nt',0),(382691,10631,'ro','Client de fluxul de numerar',0),(382692,10631,'et','Raha vÃ¤ljavool klient',0),(382693,10631,'si','Denarni odtok odjemalca',0),(382694,10631,'ba','Kas keluar klien',0),(382695,10631,'nl','Contant geld uitstroom Client',0),(382696,10631,'fi','KÃ¤teistÃ¤ ulos asiakkaan',0),(382697,10631,'no','Kontanter ut klient',0),(382698,10631,'da','Kontant udstrÃ¸mning klient',0),(382699,10631,'ko','í˜„ê¸ˆ ìœ ì¶œ í´ë¼ì´ì–¸íŠ¸',0),(382700,10631,'he','×œ×§×•×— ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(382701,10631,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ® ÎµÎºÏÎ¿Î® Ï€ÎµÎ»Î¬Ï„Î·',0),(382702,10631,'zh','å®¢æˆ·çŽ°é‡‘æµå‡º\r\n',0),(382703,10631,'sv','Kontant utflÃ¶de klient',0),(382704,10631,'it','Cash Outflow Client',0),(382705,10631,'tl','',0),(382706,10631,'th','à¹„à¸„à¸¥à¹€à¸­à¹‡à¸™à¸•à¹Œà¸‚à¸­à¸‡à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(382707,10631,'hi','à¤¨à¤•à¤¦ à¤¬à¤¹à¤¿à¤°à¥à¤µà¤¾à¤¹ à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ',0),(382708,10631,'ms','Pelanggan aliran keluar Wang Tunai',0),(382709,10631,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(382710,10631,'fr','Client de sortie de trÃ©sorerie',0),(382711,10631,'jp','ç¾é‡‘ã®æµå‡ºã®ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆ',0),(382712,10631,'pt','Cliente de saÃ­da de dinheiro',0),(382713,10631,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¾Ñ‚Ñ‚Ð¾Ðº Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(382714,10631,'es','Cliente de Salida de Efectivo',0),(382715,10631,'de','Bargeld-Abfluss-Client',0),(382716,10631,'en','Cash Outflow Client',0),(382717,10632,'is','',0),(382718,10632,'dr','Ø¬Ø±ÙŠØ§Ù† Ø®Ø±ÙˆØ¬ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯\r\n GFD',0),(382719,10632,'pr','Ø¬Ø±ÙŠØ§Ù† Ø®Ø±ÙˆØ¬ ÙˆØ¬Ù‡ Ù†Ù‚Ø¯\r\n GFD',0),(382720,10632,'tr','Nakit Ã‡â€ºkâ€ºflâ€º GFD',0),(382721,10632,'pl','Rozchody GFD',0),(382722,10632,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸ Ð‘Ð’Ð”',0),(382723,10632,'ur','Ù†Ù‚Ø¯ Ø¨Ú¾Ø§Ø¤ Ú¯ÙØ¯',0),(382724,10632,'sr','ÐžÐ´Ð»Ð¸Ð² Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ Ð“Ð¤Ð”',0),(382725,10632,'vi','Tiá»n máº·t cháº£y ra GFD',0),(382726,10632,'af','Uitvloei van kontant GFD',0),(382727,10632,'ro','Fluxul de numerar GFD',0),(382728,10632,'et','Raha vÃ¤ljavool GFD',0),(382729,10632,'si','Denarni odtok GFD',0),(382730,10632,'ba','Kas keluar GFD',0),(382731,10632,'nl','Uitstroom van kasmiddelen GFD',0),(382732,10632,'fi','Kassavirta ulos GFD',0),(382733,10632,'no','KontantstrÃ¸mmen ut GFD',0),(382734,10632,'da','PengestrÃ¸m GFD',0),(382735,10632,'ko','í˜„ê¸ˆ ìœ ì¶œ GFD',0),(382736,10632,'he','×ª×–×¨×™× ×ž×–×•×ž× ×™× ×™×•×¦× GFD',0),(382737,10632,'el','Î•ÎºÏÎ¿Î® Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½ GFD',0),(382738,10632,'zh','çŽ°é‡‘æµå‡ºèˆ¹é˜Ÿç§‘\r\n',0),(382739,10632,'sv','KassautflÃ¶det GFD',0),(382740,10632,'it','Deflusso di cassa GFD',0),(382741,10632,'tl','',0),(382742,10632,'th','à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”à¸­à¸­à¸ GFD',0),(382743,10632,'hi','à¤¨à¤•à¤¦ à¤¬à¤¹à¤¿à¤°à¥à¤µà¤¾à¤¹ GFD',0),(382744,10632,'ms','Aliran keluar tunai GFD',0),(382745,10632,'ar','Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ Ø§Ù„Ø®Ø§Ø±Ø¬ Ø³Ø§Ø±ÙŠ Ø§Ù„Ù…ÙØ¹ÙˆÙ„',0),(382746,10632,'fr','Sorties de fonds Gisiger',0),(382747,10632,'jp','ç¾é‡‘ã®æµå‡º GFD',0),(382748,10632,'pt','SaÃ­da de dinheiro Eliana',0),(382749,10632,'ru','ÐžÑ‚Ñ‚Ð¾Ðº Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð² GFD',0),(382750,10632,'es','Salida de Efectivo GFD',0),(382751,10632,'de','Mittelabfluss GFD',0),(382752,10632,'en','Cash Outflow GFD',0),(382753,10633,'is','',0),(382754,10633,'dr','Ù‡Ø²ÙŠÙ†Ù‡  Ù…Ø¹Ù…Ø§Ø±Ù‰',0),(382755,10633,'pr','Ù‡Ø²ÙŠÙ†Ù‡  Ù…Ø¹Ù…Ø§Ø±Ù‰',0),(382756,10633,'tr','Maliyet mimari',0),(382757,10633,'pl','Koszt architektoniczne',0),(382758,10633,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð°Ñ€Ñ…Ð¸Ñ‚ÐµÐºÑ‚ÑƒÑ€Ð½Ð¸',0),(382759,10633,'ur','Ù…Ø¹Ù…Ø§Ø±ÛŒ Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(382760,10633,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð°Ñ€Ñ…Ð¸Ñ‚ÐµÐºÑ‚Ð¾Ð½ÑÐºÐ¸',0),(382761,10633,'vi','chi phÃ­ xÃ¢y dá»±ng',0),(382762,10633,'af','Koste argitektoniese',0),(382763,10633,'ro','Costul arhitecturale',0),(382764,10633,'et','Kulu arhitektuuri',0),(382765,10633,'si','StroÅ¡ki arhitekturne',0),(382766,10633,'ba','Biaya arsitektur',0),(382767,10633,'nl','Kosten architecturale',0),(382768,10633,'fi','Kustannukset arkkitehtuurin',0),(382769,10633,'no','Kostnaden arkitektoniske',0),(382770,10633,'da','Omkostninger arkitektoniske',0),(382771,10633,'ko','ê±´ì¶• ë¹„ìš©',0),(382772,10633,'he','×¢×œ×•×ª ××“×¨×™×›×œ×™',0),(382773,10633,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±ÏÏ‡Î¹Ï„ÎµÎºÏ„Î¿Î½Î¹ÎºÎ¬',0),(382774,10633,'zh','å»ºç­‘æˆæœ¬\r\n',0),(382775,10633,'sv','Kostnad arkitektoniska',0),(382776,10633,'it','Costo architettonico',0),(382777,10633,'tl','',0),(382778,10633,'th','à¸ªà¸–à¸²à¸›à¸±à¸•à¸¢à¸à¸£à¸£à¸¡à¸•à¹‰à¸™à¸—à¸¸à¸™',0),(382779,10633,'hi','à¤²à¤¾à¤—à¤¤ à¤µà¤¾à¤¸à¥à¤¤à¥',0),(382780,10633,'ms','Kos seni bina',0),(382781,10633,'ar','Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ù…Ø¹Ù…Ø§Ø±ÙŠØ©',0),(382782,10633,'fr','CoÃ»t Architectural',0),(382783,10633,'jp','å»ºç¯‰ã‚³ã‚¹ãƒˆ',0),(382784,10633,'pt','Custo arquitetÃ´nico',0),(382785,10633,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð°Ñ€Ñ…Ð¸Ñ‚ÐµÐºÑ‚ÑƒÑ€Ð½Ð¾Ð³Ð¾',0),(382786,10633,'es','Costo Arquitectural',0),(382787,10633,'de','Kosten Architektur',0),(382788,10633,'en','Cost Architectural',0),(382789,10634,'is','',0),(382790,10634,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø¬ÙˆØ² Ø¨Ø§Ø²Ø±Ø³ÙŠ',0),(382791,10634,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø¬ÙˆØ² Ø¨Ø§Ø²Ø±Ø³ÙŠ',0),(382792,10634,'tr','Maliyet denetim izni',0),(382793,10634,'pl','Koszty kontroli zezwoleÅ„',0),(382794,10634,'bg','Ð¦ÐµÐ½Ð° Ð¸Ð½ÑÐ¿ÐµÐºÑ†Ð¸Ð¸ Ñ€Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÐµÐ»Ð½Ð¸',0),(382795,10634,'ur','Ù„Ø§Ú¯Øª Ú©Ø§ Ù…Ø¹Ø§Ø¦Ù†Û Ú©Ø±Ù†Û’ Ú©Û’ Ø§Ø¬Ø§Ø²Øª Ù†Ø§Ù…Û’',0),(382796,10634,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¸Ð½ÑÐ¿ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ðµ',0),(382797,10634,'vi','giáº¥y phÃ©p kiá»ƒm Ä‘á»‹nh chi phÃ­',0),(382798,10634,'af','Koste inspeksies permitte',0),(382799,10634,'ro','Cost inspecÈ›iilor permise',0),(382800,10634,'et','Andja kulude kontrolli',0),(382801,10634,'si','StroÅ¡ki pregledov dovoljenj',0),(382802,10634,'ba','Biaya pemeriksaan izin',0),(382803,10634,'nl','Kosten inspecties vergunningen',0),(382804,10634,'fi','Kustannusten tarkastukset luvat',0),(382805,10634,'no','Kostnader inspeksjoner tillatelser',0),(382806,10634,'da','Omkostninger inspektioner tilladelser',0),(382807,10634,'ko','ë¹„ìš©ëœ ê²€ì‚¬ í—ˆê°€',0),(382808,10634,'he','×¢×œ×•×ª ×”×‘×“×™×§×•×ª ×”×™×ª×¨×™×',0),(382809,10634,'el','Î†Î´ÎµÎ¹ÎµÏ‚ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎµÏ€Î¹Î¸ÎµÏ‰ÏÎ®ÏƒÎµÏ‰Î½',0),(382810,10634,'zh','æ£€æŸ¥è®¸å¯è¯è´¹ç”¨\r\n',0),(382811,10634,'sv','Kostnad inspektioner tillstÃ¥nd',0),(382812,10634,'it','Ispezioni costo permessi',0),(382813,10634,'tl','',0),(382814,10634,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸•à¹‰à¸™à¸—à¸¸à¸™à¹ƒà¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(382815,10634,'hi','à¤²à¤¾à¤—à¤¤ à¤¨à¤¿à¤°à¥€à¤•à¥à¤·à¤£ à¤ªà¤°à¤®à¤¿à¤Ÿ',0),(382816,10634,'ms','Kos pemeriksaan permit',0),(382817,10634,'ar','Ø±Ø®Øµ ØªÙƒÙ„ÙØ© Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„ØªÙØªÙŠØ´',0),(382818,10634,'fr','Inspections coÃ»t permis',0),(382819,10634,'jp','ã‚³ã‚¹ãƒˆã®æ¤œæŸ»ã®è¨±å¯',0),(382820,10634,'pt','InspecÃ§Ãµes custo de licenÃ§as',0),(382821,10634,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ð¹',0),(382822,10634,'es','Permisos de Inspecciones e Costos',0),(382823,10634,'de','Kosten Inspektionen Genehmigungen',0),(382824,10634,'en','Cost Inspections Permits',0),(382825,10635,'is','',0),(382826,10635,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ù‡Ø±Ù‡ ',0),(382827,10635,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ù‡Ø±Ù‡ ',0),(382828,10635,'tr','Maliyet faiz',0),(382829,10635,'pl','Koszty odsetek',0),(382830,10635,'bg','Ð˜ÐºÐ¾Ð½Ð¾Ð¼Ð¸Ñ‡ÐµÑÐºÐ¸ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(382831,10635,'ur','Ù„Ø§Ú¯Øª Ø¯Ù„Ú†Ø³Ù¾ÛŒ',0),(382832,10635,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(382833,10635,'vi','chi phÃ­ lÃ£i',0),(382834,10635,'af','Koste rente',0),(382835,10635,'ro','Costul dobÃ¢nzii',0),(382836,10635,'et','Kulude huvi',0),(382837,10635,'si','StroÅ¡ki obresti',0),(382838,10635,'ba','Biaya bunga',0),(382839,10635,'nl','Kosten belang',0),(382840,10635,'fi','Kustannusten etua',0),(382841,10635,'no','Pris interesse',0),(382842,10635,'da','Omkostninger interesse',0),(382843,10635,'ko','ë¹„ìš©ëœ ê´€ì‹¬ì‚¬',0),(382844,10635,'he','×¢×œ×•×ª ×¨×™×‘×™×ª',0),(382845,10635,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï„ÏŒÎºÏ‰Î½',0),(382846,10635,'zh','æˆæœ¬çš„åˆ©æ¯\r\n',0),(382847,10635,'sv','Kostnad intresse',0),(382848,10635,'it','Costo di interesse',0),(382849,10635,'tl','',0),(382850,10635,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢',0),(382851,10635,'hi','à¤²à¤¾à¤—à¤¤ à¤¬à¥à¤¯à¤¾à¤œ',0),(382852,10635,'ms','Kos faedah',0),(382853,10635,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(382854,10635,'fr','CoÃ»t des intÃ©rÃªts',0),(382855,10635,'jp','ã‚³ã‚¹ãƒˆã®åˆ©æ¯',0),(382856,10635,'pt','Custo de juros',0),(382857,10635,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(382858,10635,'es','InterÃ©ses de Costos',0),(382859,10635,'de','Kosten Zinsen',0),(382860,10635,'en','Cost Interest',0),(382861,10636,'is','',0),(382862,10636,'dr','(Ø²ÙŠØ§Ø¯',0),(382863,10636,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø³Ø®Øª (Ø²ÙŠØ§Ø¯',0),(382864,10636,'tr','Sabit maliyetler',0),(382865,10636,'pl','Koszty',0),(382866,10636,'bg','Ð¢Ð²ÑŠÑ€Ð´ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(382867,10636,'ur','Ù…Ø´Ú©Ù„ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(382868,10636,'sr','Ð¢ÐµÑˆÐºÐ¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(382869,10636,'vi','chi phÃ­ thÃ´',0),(382870,10636,'af','Harde koste',0),(382871,10636,'ro','Costurile de greu',0),(382872,10636,'et','Raske kanda',0),(382873,10636,'si','Trdo stroÅ¡ke',0),(382874,10636,'ba','Biaya keras',0),(382875,10636,'nl','Vaste kosten',0),(382876,10636,'fi','Kova kustannukset',0),(382877,10636,'no','Harde kostnadene',0),(382878,10636,'da','HÃ¥rde omkostninger',0),(382879,10636,'ko','í•˜ë“œ ë¹„ìš©',0),(382880,10636,'he','×¢×œ×•×™×•×ª ×§×©×”',0),(382881,10636,'el','Î£ÎºÎ»Î·ÏÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(382882,10636,'zh','è¾›è‹¦è´¹\r\n',0),(382883,10636,'sv','HÃ¥rd kostnader',0),(382884,10636,'it','Costi duri',0),(382885,10636,'tl','',0),(382886,10636,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸¢à¸²à¸',0),(382887,10636,'hi','à¤®à¥à¤¶à¥à¤•à¤¿à¤² à¤²à¤¾à¤—à¤¤',0),(382888,10636,'ms','Kos yang keras',0),(382889,10636,'ar','Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø«Ø§Ø¨ØªØ©',0),(382890,10636,'fr','Frais durs',0),(382891,10636,'jp','ãƒãƒ¼ãƒ‰é¢ã®ã‚³ã‚¹ãƒˆ',0),(382892,10636,'pt','Custos de difÃ­cil',0),(382893,10636,'ru','Ð–ÐµÑÑ‚ÐºÐ¸Ð¹ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(382894,10636,'es','Costos Fijos',0),(382895,10636,'de','Schwer Kosten',0),(382896,10636,'en','Hard Costs',0),(382897,10637,'is','',0),(382898,10637,'dr','ÙˆØ±ÙˆØ¯ÙŠ  Ùˆ Ø®Ø±ÙˆØ¬ÙŠ ',0),(382899,10637,'pr','ÙˆØ±ÙˆØ¯ÙŠ  Ùˆ Ø®Ø±ÙˆØ¬ÙŠ ',0),(382900,10637,'tr','GiriÅŸ akÄ±mÄ± & Ã§Ä±kÄ±ÅŸ',0),(382901,10637,'pl','NapÅ‚yw & odpÅ‚ywu',0),(382902,10637,'bg','ÐŸÑ€Ð¸Ñ‚Ð¾ÐºÑŠÑ‚ & Ð¾Ñ‚Ñ‚Ð¾Ðº',0),(382903,10637,'ur','Inflow & Ø¨Ú¾Ø§Ø¤',0),(382904,10637,'sr','ÐŸÑ€Ð¸Ð»Ð¸Ð²Ð° Ð¸ Ð¾Ð´Ð»Ð¸Ð²Ð°',0),(382905,10637,'vi','DÃ²ng &amp; Friedrichskoog',0),(382906,10637,'af','Invloei & Uitvloei',0),(382907,10637,'ro','Afluxul & scurgerea',0),(382908,10637,'et','Sissevool & vÃ¤ljavool',0),(382909,10637,'si','Priliv odliv &',0),(382910,10637,'ba','Aliran & keluar',0),(382911,10637,'nl','Instroom & uitstroom',0),(382912,10637,'fi','Virtaamaan & ulosvirtaus',0),(382913,10637,'no','Tilsig & utlÃ¸p',0),(382914,10637,'da','IndstrÃ¸mning & udstrÃ¸mning',0),(382915,10637,'ko','ìœ ìž… & ìœ ì¶œ',0),(382916,10637,'he','×™×¦×•× ×ª×–×¨×™× &',0),(382917,10637,'el','Î•Î¹ÏƒÏÎ¿Î® & ÎµÎºÏÎ¿Î®',0),(382918,10637,'zh','æµå…¥åŠæµå‡º\r\n',0),(382919,10637,'sv','InflÃ¶de & utflÃ¶de',0),(382920,10637,'it','Afflusso & deflusso',0),(382921,10637,'tl','',0),(382922,10637,'th','à¸à¸£à¸°à¹à¸ªà¹„à¸«à¸¥à¹€à¸‚à¹‰à¸² &',0),(382923,10637,'hi','à¤‡à¤¨à¤«à¥à¤²à¥‹ & à¤¬à¤¹à¤¿à¤°à¥à¤µà¤¾à¤¹',0),(382924,10637,'ms','Aliran masuk & aliran keluar',0),(382925,10637,'ar','ØªØ¯ÙÙ‚ ØªØ¯ÙÙ‚ Ø¢Ù†Ø¯',0),(382926,10637,'fr','Flux entrant & flux sortant',0),(382927,10637,'jp','æµå…¥ & æµå‡º',0),(382928,10637,'pt','VazÃ£o de influxo &',0),(382929,10637,'ru','ÐŸÑ€Ð¸Ñ‚Ð¾Ðº & Ð¾Ñ‚Ñ‚Ð¾Ðº',0),(382930,10637,'es','Entradas & Salidas',0),(382931,10637,'de','Zufluss & Abfluss',0),(382932,10637,'en','Inflow & Outflow',0),(382933,10638,'is','',0),(382934,10638,'dr','ÙƒØ¯ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(382935,10638,'pr','ÙƒØ¯ Ù¾Ø±ÙˆÚ˜Ù‡ ',0),(382936,10638,'tr','Proje kodu',0),(382937,10638,'pl','Kod projektu',0),(382938,10638,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(382939,10638,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©Û’ Ú©ÙˆÚˆ',0),(382940,10638,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(382941,10638,'vi','mÃ¡ dá»± Ã¡n',0),(382942,10638,'af','Projekkode',0),(382943,10638,'ro','Cod proiect',0),(382944,10638,'et','Projekti kood',0),(382945,10638,'si','Å ifra projekta',0),(382946,10638,'ba','Kode proyek',0),(382947,10638,'nl','Projectcode',0),(382948,10638,'fi','Projektikoodi',0),(382949,10638,'no','Prosjektkode',0),(382950,10638,'da','Projektkode',0),(382951,10638,'ko','í”„ë¡œì íŠ¸ ì½”ë“œ',0),(382952,10638,'he','×§×•×“ ×¤×¨×•×™×™×§×˜',0),(382953,10638,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î•Î¡Î“ÎŸÎ¥',0),(382954,10638,'zh','é¡¹ç›®ä»£ç \r\n',0),(382955,10638,'sv','Projektkod',0),(382956,10638,'it','Codice di progetto',0),(382957,10638,'tl','',0),(382958,10638,'th','à¸£à¸«à¸±à¸ªà¹‚à¸„à¸£à¸‡à¸à¸²à¸£',0),(382959,10638,'hi','à¤ªà¥à¤°à¥‹à¤œà¥‡à¤•à¥à¤Ÿ à¤•à¥‹à¤¡',0),(382960,10638,'ms','Kod projek',0),(382961,10638,'ar','Ø±Ù…Ø² Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(382962,10638,'fr','Code du projet',0),(382963,10638,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆ ã‚³ãƒ¼ãƒ‰',0),(382964,10638,'pt','CÃ³digo de projeto',0),(382965,10638,'ru','ÐšÐ¾Ð´ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð°',0),(382966,10638,'es','CÃ³digo de Proyecto',0),(382967,10638,'de','Projektcode',0),(382968,10638,'en','Project Code',0),(382969,10639,'is','',0),(382970,10639,'dr','Ø¬Ù…Ø¹ ÙƒÙ„ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙˆØ¬  Ø¨Ø§ÙŠØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(382971,10639,'pr','Ø¬Ù…Ø¹ ÙƒÙ„ Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø®Ø±ÙˆØ¬  Ø¨Ø§ÙŠØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯ ',0),(382972,10639,'tr','Toplam kalan sÄ±fÄ±r Ã§Ä±kÄ±ÅŸ olmalÄ±',0),(382973,10639,'pl','PozostaÅ‚a suma musi byÄ‡ Zero do wyjÅ›cia',0),(382974,10639,'bg','ÐžÑÑ‚Ð°Ð½Ð°Ð»Ð¸Ñ‚Ðµ Ð¾Ð±Ñ‰Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð½ÑƒÐ»Ð° Ð·Ð° Ð¸Ð·Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(382975,10639,'ur','Ú©Ù„ Ø¨Ø§Ù‚ÛŒ ØµÙØ± Ú©Û’ Ø®Ø±ÙˆØ¬ Ú©Û’ Ù„ÛŒÛ’ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(382976,10639,'sr','ÐŸÑ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾ ÑƒÐºÑƒÐ¿Ð½Ð¾ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð½ÑƒÐ»Ð° Ð´Ð¾ Ð¸Ð·Ð»Ð°Ð·Ð°',0),(382977,10639,'vi','Ä‘á»ƒ thoÃ¡t ra thÃ¬ tá»•ng sá»‘ cÃ²n láº¡i pháº£i báº±ng 0',0),(382978,10639,'af','Totale oorblywende moet word nul te verlaat',0),(382979,10639,'ro','RÄƒmase Total trebuie sÄƒ fie Zero la ieÅŸire',0),(382980,10639,'et','JÃ¤Ã¤k kokku peab olema null vÃ¤ljumist',0),(382981,10639,'si','Ostanejo skupaj mora biti niÄ izhod',0),(382982,10639,'ba','Total yang tersisa harus nol untuk keluar',0),(382983,10639,'nl','Resterende totaal moet nul naar uitgang',0),(382984,10639,'fi','JÃ¤ljellÃ¤ yhteensÃ¤ on oltava nolla exit',0),(382985,10639,'no','GjenvÃ¦rende totalt mÃ¥ vÃ¦re null forÂ¯avslutte',0),(382986,10639,'da','Resterende samlede skal vÃ¦re nul til Exit',0),(382987,10639,'ko','ì´ ìž”ì—¬ ì¶œêµ¬ 0 ì´ì–´ì•¼',0),(382988,10639,'he','×”× ×•×ª×¨×™× ×¡×š ×”×›×œ ×—×™×™×‘ ×œ×”×™×•×ª ××¤×¡ ×¢×œ ×™×¦×™××”',0),(382989,10639,'el','Î¥Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼Î·Î´Î­Î½ Î­Î¾Î¿Î´Î¿',0),(382990,10639,'zh','å‰©ä½™çš„æ€»æ•°å¿…é¡»æ˜¯ä¸º0ä»¥é€€å‡º\r\n',0),(382991,10639,'sv','Resterande summan mÃ¥ste vara noll till Exit',0),(382992,10639,'it','Residuo totale deve essere Zero per uscita',0),(382993,10639,'tl','',0),(382994,10639,'th','à¸—à¸µà¹ˆà¹€à¸«à¸¥à¸·à¸­ à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸•à¹‰à¸­à¸‡à¹€à¸›à¹‡à¸™à¸¨à¸¹à¸™à¸¢à¹Œà¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(382995,10639,'hi','à¤•à¥à¤² à¤¶à¥‡à¤· à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤¨à¤¿à¤•à¤²à¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥‚à¤¨à¥à¤¯ à¤¹à¥‹à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(382996,10639,'ms','Baki jumlah mesti sifar untuk keluar',0),(382997,10639,'ar','Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ© Ù…Ø¬Ù…ÙˆØ¹Ø© ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† ØµÙØ±Ø§Ù‹ Ù„Ù„Ø®Ø±ÙˆØ¬',0),(382998,10639,'fr','Restant Total doit Ãªtre de zÃ©ro jusqu\'Ã  la sortie',0),(382999,10639,'jp','å‡ºå£ã‚’ã‚¼ãƒ­ã«ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™æ®‹ã‚Šã®åˆè¨ˆ',0),(383000,10639,'pt','Restante Total deve ser Zero para saÃ­da',0),(383001,10639,'ru','ÐžÑÑ‚Ð°Ð²ÑˆÐ¸ÐµÑÑ Ð²ÑÐµÐ³Ð¾ Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð²Ð½Ð¾ Ð½ÑƒÐ»ÑŽ Ð´Ð»Ñ Ð²Ñ‹Ñ…Ð¾Ð´Ð°',0),(383002,10639,'es','Total que Queda Debe Ser Cero para Salir',0),(383003,10639,'de','Verbleibende Summe muss null bis Ausfahrt sein',0),(383004,10639,'en','Remaining Total Must Be Zero to Exit',0),(383005,10640,'is','',0),(383006,10640,'dr','ÙÙ‡Ø±Ø³Øª',0),(383007,10640,'pr','ÙÙ‡Ø±Ø³Øª',0),(383008,10640,'tr','Zamanlama',0),(383009,10640,'pl','Harmonogram',0),(383010,10640,'bg','Ð“Ñ€Ð°Ñ„Ð¸Ðº',0),(383011,10640,'ur','Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ÛŒ',0),(383012,10640,'sr','Ð Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´',0),(383013,10640,'vi','Lá»‹ch trÃ¬nh',0),(383014,10640,'af','Skedule',0),(383015,10640,'ro','Programul',0),(383016,10640,'et','Ajakava',0),(383017,10640,'si','Urnik',0),(383018,10640,'ba','Jadwal',0),(383019,10640,'nl','Schema',0),(383020,10640,'fi','Aikataulu',0),(383021,10640,'no','Tidsplan',0),(383022,10640,'da','Tidsplan',0),(383023,10640,'ko','ì¼ì •',0),(383024,10640,'he','×œ×•×— ×”×–×ž× ×™×',0),(383025,10640,'el','Î§ÏÎ¿Î½Î¿Î´Î¹Î¬Î³ÏÎ±Î¼Î¼Î±',0),(383026,10640,'zh','é™„è¡¨\r\n',0),(383027,10640,'sv','Schema',0),(383028,10640,'it','Schedule',0),(383029,10640,'tl','',0),(383030,10640,'th','à¸à¸³à¸«à¸™à¸”à¸à¸²à¸£',0),(383031,10640,'hi','à¤…à¤¨à¥à¤¸à¥‚à¤šà¥€',0),(383032,10640,'ms','Jadual',0),(383033,10640,'ar','Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø²Ù…Ù†ÙŠ',0),(383034,10640,'fr','Annexe',0),(383035,10640,'jp','ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ«',0),(383036,10640,'pt','Agenda',0),(383037,10640,'ru','Ð Ð°ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(383038,10640,'es','Agenda',0),(383039,10640,'de','Zeitplan',0),(383040,10640,'en','Schedule',0),(383041,10641,'is','',0),(383042,10641,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø³Ø¨Ùƒ ',0),(383043,10641,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø³Ø¨Ùƒ ',0),(383044,10641,'tr','YumuÅŸak maliyeti',0),(383045,10641,'pl','Koszty miÄ™kkie',0),(383046,10641,'bg','ÐœÐµÐºÐ¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(383047,10641,'ur','Ù†Ø±Ù… Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(383048,10641,'sr','ÐœÐµÐºÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(383049,10641,'vi','Chi phÃ­ má»m',0),(383050,10641,'af','Sagte koste',0),(383051,10641,'ro','Costurile de moale',0),(383052,10641,'et','Pehme kulud',0),(383053,10641,'si','Mehkega stroÅ¡kov',0),(383054,10641,'ba','Biaya lembut',0),(383055,10641,'nl','Zachte kosten',0),(383056,10641,'fi','PehmeitÃ¤ aiheutuvia kustannuksia',0),(383057,10641,'no','Indirekte kostnader',0),(383058,10641,'da','BlÃ¸de omkostninger',0),(383059,10641,'ko','ë¶€ë“œëŸ¬ìš´ ë¹„ìš©',0),(383060,10641,'he','×¢×œ×•×™×•×ª ×¨×š',0),(383061,10641,'el','ÎœÎ±Î»Î±ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(383062,10641,'zh','è½¯æˆæœ¬\r\n',0),(383063,10641,'sv','Mjuka kostnader',0),(383064,10641,'it','Costi morbidi',0),(383065,10641,'tl','',0),(383066,10641,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸—à¸µà¹ˆà¸­à¹ˆà¸­à¸™',0),(383067,10641,'hi','à¤¨à¤°à¤® à¤²à¤¾à¤—à¤¤',0),(383068,10641,'ms','Kos yang lembut',0),(383069,10641,'ar','ØªÙƒØ§Ù„ÙŠÙ Ù„ÙŠÙ†Ø©',0),(383070,10641,'fr','CoÃ»ts accessoires',0),(383071,10641,'jp','æŸ”ã‚‰ã‹ã„è²»ç”¨',0),(383072,10641,'pt','Custos macios',0),(383073,10641,'ru','ÐœÑÐ³ÐºÐ¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(383074,10641,'es','Costos Minores',0),(383075,10641,'de','Weiche Kosten',0),(383076,10641,'en','Soft Costs',0),(383077,10642,'is','',0),(383078,10642,'dr','Ø¯ÙˆØ±Ù‡ Ø§Ø³ØªÙ‡Ù„Ø§Ùƒ ',0),(383079,10642,'pr','Ø¯ÙˆØ±Ù‡ Ø§Ø³ØªÙ‡Ù„Ø§Ùƒ ',0),(383080,10642,'tr','Amortisman dÃ¶nemleri',0),(383081,10642,'pl','Okresy amortyzacji',0),(383082,10642,'bg','ÐÐ¼Ð¾Ñ€Ñ‚Ð¸Ð·Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸',0),(383083,10642,'ur','Ø¨Û’ Ø¨Ø§Ù‚ÛŒ Ø§Ø¯ÙˆØ§Ø±',0),(383084,10642,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸ Ð·Ð° Ð°Ð¼Ð¾Ñ€Ñ‚Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(383085,10642,'vi','Giai Ä‘oáº¡n  kháº¥u hao',0),(383086,10642,'af','Amortization periodes',0),(383087,10642,'ro','Perioadele de amortizare',0),(383088,10642,'et','Amortisatsiooni perioodid',0),(383089,10642,'si','Dobe vraÄanja',0),(383090,10642,'ba','Periode amortisasi',0),(383091,10642,'nl','Afschrijving perioden',0),(383092,10642,'fi','Poistot kaudet',0),(383093,10642,'no','Amortisering perioder',0),(383094,10642,'da','Amortisering perioder',0),(383095,10642,'ko','ìƒê° ê¸°ê°„',0),(383096,10642,'he','×ª×§×•×¤×•×ª ×¡×™×œ×•×§×™×Ÿ',0),(383097,10642,'el','Î ÎµÏÎ¹ÏŒÎ´Î¿Ï…Ï‚ Î±Ï€ÏŒÏƒÎ²ÎµÏƒÎ·Ï‚',0),(383098,10642,'zh','æ‘Šé”€æœŸé™\r\n',0),(383099,10642,'sv','Avskrivningar perioder',0),(383100,10642,'it','Periodi di ammortamento',0),(383101,10642,'tl','',0),(383102,10642,'th','à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸à¸²à¸£à¸•à¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(383103,10642,'hi','à¤ªà¤°à¤¿à¤¶à¥‹à¤§à¤¨ à¤…à¤µà¤§à¤¿',0),(383104,10642,'ms','Tempoh pelunasan',0),(383105,10642,'ar','ÙØªØ±Ø§Øª Ø§Ù„Ø§Ø³ØªÙ‡Ù„Ø§Ùƒ',0),(383106,10642,'fr','PÃ©riodes d\'amortissement',0),(383107,10642,'jp','å„Ÿå´æœŸé–“',0),(383108,10642,'pt','PerÃ­odos de amortizaÃ§Ã£o',0),(383109,10642,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´Ñ‹ ÐÐ¼Ð¾Ñ€Ñ‚Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(383110,10642,'es','PerÃ­odos de AmortizaciÃ³n',0),(383111,10642,'de','Abschreibungen auf Perioden',0),(383112,10642,'en','Amortization Periods',0),(383113,10643,'is','',0),(383114,10643,'dr','(Ø®Ø¯Ù…Ø§Øª Ø¨ÙŠÙ…Ù‡ Ø¢Ø³ÙŠØ¨ Ø¯ÙŠØ¯Ú¯ÙŠ)',0),(383115,10643,'pr','ØªØ®ÙÙŠÙ Ù…Ø´Ù…ÙˆÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§ØµÙ„ Ùˆ ÙØ±Ø¹(Ø®Ø¯Ù…Ø§Øª Ø¨ÙŠÙ…Ù‡ Ø¢Ø³ÙŠØ¨ Ø¯ÙŠØ¯Ú¯ÙŠ)',0),(383116,10643,'tr','Hizmet kapsamÄ± Dsc',0),(383117,10643,'pl','UsÅ‚uga pokrycia Dsc',0),(383118,10643,'bg','Ð£ÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ Dsc',0),(383119,10643,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ Ú©ÙˆØ±ÛŒØ¬ Ø¯ÛŒ Dsc',0),(383120,10643,'sr','Ð”ÑÑ† Ð¿Ð¾ÐºÑ€Ð¸Ð²ÐµÐ½Ð¾ÑÑ‚ ÑƒÑÐ»ÑƒÐ³Ðµ',0),(383121,10643,'vi','báº£ng tin dá»‹ch vá»¥',0),(383122,10643,'af','Diensdekking Beskryw.',0),(383123,10643,'ro','Servicii de acoperire Dsc',0),(383124,10643,'et','Teenuse ulatus Dsc',0),(383125,10643,'si','Storitev pokritost Dsc',0),(383126,10643,'ba','Dsc cakupan layanan',0),(383127,10643,'nl','Service dekking Dsc',0),(383128,10643,'fi','Palvelu kattaa Dsc',0),(383129,10643,'no','Tjenesten dekning Dsc',0),(383130,10643,'da','Service dÃ¦kning Dsc',0),(383131,10643,'ko','ì„œë¹„ìŠ¤ ë²”ìœ„ Dsc',0),(383132,10643,'he','×©×™×¨×•×ª ×›×™×¡×•×™ Dsc',0),(383133,10643,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± ÎºÎ¬Î»Ï…ÏˆÎ·Ï‚ Dsc',0),(383134,10643,'zh','æœåŠ¡èŒƒå›´æè¿°\r\n',0),(383135,10643,'sv','TjÃ¤nsten tÃ¤ckning-Dsc',0),(383136,10643,'it','Servizio copertura Dsc',0),(383137,10643,'tl','',0),(383138,10643,'th','Dsc à¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡à¸šà¸£à¸´à¸à¸²à¸£',0),(383139,10643,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¤µà¤°à¥‡à¤œ Dsc',0),(383140,10643,'ms','Perkhidmatan perlindungan Dsc',0),(383141,10643,'ar','Ø®Ø¯Ù…Ø© Ø§Ù„ØªØºØ·ÙŠØ© Dsc',0),(383142,10643,'fr','Service couverture Dsc',0),(383143,10643,'jp','ã‚µãƒ¼ãƒ“ã‚¹é©ç”¨ç¯„å›² Dsc',0),(383144,10643,'pt','Dsc de cobertura do serviÃ§o',0),(383145,10643,'ru','Ð¡Ð»ÑƒÐ¶Ð±Ñ‹ Ð¿Ð¾ÐºÑ€Ñ‹Ñ‚Ð¸Ñ Dsc',0),(383146,10643,'es','Cobertura de Servicios DSC',0),(383147,10643,'de','Service-Abdeckung-Dsc',0),(383148,10643,'en','Service Coverage Dsc',0),(383149,10644,'is','',0),(383150,10644,'dr','( Ù…Ù‚Ø·ÙˆØ¹',0),(383151,10644,'pr','Ø«Ø§Ø¨Øª ( Ù…Ù‚Ø·ÙˆØ¹',0),(383152,10644,'tr','Sabit',0),(383153,10644,'pl','StaÅ‚e',0),(383154,10644,'bg','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ð°',0),(383155,10644,'ur','Ù…Ù‚Ø±Ø±Û',0),(383156,10644,'sr','ÐŸÐ¾Ð¿Ñ€Ð°Ð²Ð¸Ð¾',0),(383157,10644,'vi','cá»‘ Ä‘á»‹nh',0),(383158,10644,'af','Vaste',0),(383159,10644,'ro','Fix',0),(383160,10644,'et','Fikseeritud',0),(383161,10644,'si','Osnovna',0),(383162,10644,'ba','Tetap',0),(383163,10644,'nl','Vaste',0),(383164,10644,'fi','KiinteÃ¤',0),(383165,10644,'no','Fast',0),(383166,10644,'da','Fast',0),(383167,10644,'ko','ê³ ì •',0),(383168,10644,'he','×§×‘×•×¢',0),(383169,10644,'el','Î£Ï„Î±Î¸ÎµÏÏŒ',0),(383170,10644,'zh','å®šé¢\r\n',0),(383171,10644,'sv','Fast',0),(383172,10644,'it','Fisso',0),(383173,10644,'tl','',0),(383174,10644,'th','à¸–à¸²à¸§à¸£',0),(383175,10644,'hi','à¤¤à¤¯ à¤•à¥€',0),(383176,10644,'ms','Tetap',0),(383177,10644,'ar','Ø«Ø§Ø¨Øª',0),(383178,10644,'fr','Fixe',0),(383179,10644,'jp','å›ºå®š',0),(383180,10644,'pt','Fixo',0),(383181,10644,'ru','Ð˜ÑÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(383182,10644,'es','Fijo',0),(383183,10644,'de','Behoben',0),(383184,10644,'en','Fixed',0),(383185,10645,'is','',0),(383186,10645,'dr','( Ø´Ù†Ø§ÙˆØ±',0),(383187,10645,'pr','Ù…ØªØºÙŠÙŠØ± ( Ø´Ù†Ø§ÙˆØ±',0),(383188,10645,'tr','YÃ¼zen',0),(383189,10645,'pl','PÅ‚ywajÄ…ce',0),(383190,10645,'bg','ÐŸÐ»Ð°Ð²Ð°Ñ‰',0),(383191,10645,'ur','Ø³ÛŒØ§Ù„',0),(383192,10645,'sr','ÐŸÐ»ÑƒÑ‚Ð°',0),(383193,10645,'vi','thay Ä‘á»•i',0),(383194,10645,'af','Swaai',0),(383195,10645,'ro','Plutitoare',0),(383196,10645,'et','Ujuvad',0),(383197,10645,'si','Plava',0),(383198,10645,'ba','Mengambang',0),(383199,10645,'nl','Drijvende',0),(383200,10645,'fi','Kelluva',0),(383201,10645,'no','Flytende',0),(383202,10645,'da','Flydende',0),(383203,10645,'ko','ë¶€ë™',0),(383204,10645,'he','×¦×£',0),(383205,10645,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Ï…Î½',0),(383206,10645,'zh','æµ®åŠ¨\r\n',0),(383207,10645,'sv','Flytande',0),(383208,10645,'it','Galleggianti',0),(383209,10645,'tl','',0),(383210,10645,'th','à¸¥à¸­à¸¢à¸•à¸±à¸§',0),(383211,10645,'hi','à¤«à¤¼à¥à¤²à¥‹à¤Ÿà¤¿à¤‚à¤—',0),(383212,10645,'ms','Terapung',0),(383213,10645,'ar','Ø§Ù„Ø¹Ø§Ø¦Ù…Ø©',0),(383214,10645,'fr','Flottant',0),(383215,10645,'jp','ãƒ•ãƒ­ãƒ¼ãƒ†ã‚£ãƒ³ã‚°',0),(383216,10645,'pt','Flutuante',0),(383217,10645,'ru','ÐŸÐ»Ð°Ð²Ð°ÑŽÑ‰Ð¸Ð¹',0),(383218,10645,'es','Flotante',0),(383219,10645,'de','Schwimmende',0),(383220,10645,'en','Floating',0),(383221,10646,'is','',0),(383222,10646,'dr','(Ù…ÙØ§Ø¯) Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø¯Ø± Ø®Ø¯Ù…Øª Ø§Ø±ØªØ´  Ø§Ø³Øª',0),(383223,10646,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ù‡Ø±Ù‡ (Ø³ÙˆØ¯) Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø¯Ø± Ø®Ø¯Ù…Øª Ø§Ø±ØªØ´  Ø§Ø³Øª',0),(383224,10646,'tr','GL hesabÄ± hizmet ne zaman ilgi iÃ§in',0),(383225,10646,'pl','GL konto za zainteresowanie w usÅ‚ugi',0),(383226,10646,'bg','GL Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÑÐ²Ð°Ñ‚ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ ÐºÐ¾Ð³Ð°Ñ‚Ð¾ ÑƒÑÐ»ÑƒÐ³Ð°',0),(383227,10646,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¬Ø¨ Ø®Ø¯Ù…Øª Ù…ÛŒÚº Ø¯Ù„Ú†Ø³Ù¾ÛŒ',0),(383228,10646,'sr','Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½ Ð·Ð° ÐºÐ°Ð¼Ð°Ñ‚Ðµ ÐºÐ°Ð´Ð° ÑÐµ Ð½Ð°Ð»Ð°Ð·Ð¸Ñ‚Ðµ Ñƒ ÑÐµÑ€Ð²Ð¸Ñ',0),(383229,10646,'vi','TK sá»• cÃ¡i cho tiá»n lÃ£i khi cÃ³ dá»‹ch vá»¥',0),(383230,10646,'af','AG Rekening vir Rente wanneer In Diens',0),(383231,10646,'ro','GL cont pentru interesul Ã®n serviciu',0),(383232,10646,'et','Kui huvi pearaamatukontole',0),(383233,10646,'si','GL raÄun za obresti v ko',0),(383234,10646,'ba','GL akun untuk kepentingan ketika dalam Layanan',0),(383235,10646,'nl','GL Account voor belang bij Service',0),(383236,10646,'fi','Kirjanpitotilin pÃ¤Ã¤tilin kiinnostuksestaan palvelu',0),(383237,10646,'no','GI-konto for interesse i tjenesten',0),(383238,10646,'da','GL konto for interesse i Service',0),(383239,10646,'ko','ë•Œ ì„œë¹„ìŠ¤ì—ì—ì„œ ëŒ€ í•œ ê´€ì‹¬ì— ëŒ€ í•œ GL ê³„ì •',0),(383240,10646,'he','GL ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×¨×™×‘×™×ª ×‘×¢×ª ×‘×©×™×¨×•×ª',0),(383241,10646,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± Ï„Î¿ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½ ÏŒÏ„Î±Î½ ÏƒÏ„Î·Î½ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±',0),(383242,10646,'zh','æœåŠ¡æ—¶æ€»å¸å¸æˆ·ä¸ºåˆ©æ¯\r\n',0),(383243,10646,'sv','GL konto fÃ¶r intresse nÃ¤r Service',0),(383244,10646,'it','GL Account per interesse quando si Ã¨ In servizio',0),(383245,10646,'tl','',0),(383246,10646,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸ªà¸³à¸«à¸£à¸±à¸šà¸„à¸§à¸²à¸¡à¸ªà¸™à¹ƒà¸ˆà¹ƒà¸™à¸šà¸£à¸´à¸à¸²à¸£',0),(383247,10646,'hi','à¤œà¤¬ à¤¸à¥‡à¤µà¤¾ à¤®à¥‡à¤‚ à¤°à¥à¤šà¤¿ à¤•à¥‡ à¤²à¤¿à¤ GL à¤–à¤¾à¤¤à¤¾',0),(383248,10646,'ms','GL akaun untuk kepentingan semasa dalam Perkhidmatan',0),(383249,10646,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(383250,10646,'fr','GL compte des intÃ©rÃªts en cas de Service',0),(383251,10646,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ ã‚µãƒ¼ãƒ“ã‚¹ã«é–¢å¿ƒã‚’',0),(383252,10646,'pt','GL conta pelo interesse quando em serviÃ§o',0),(383253,10646,'ru','Ð¡Ñ‡ÐµÑ‚ GL Ð´Ð»Ñ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑÐ°, ÐºÐ¾Ð³Ð´Ð° Ð² ÑÐ»ÑƒÐ¶Ð±Ðµ',0),(383254,10646,'es','Cuenta LM para Intereses Cuando EstÃ¡ en el Trabajo',0),(383255,10646,'de','Sako fÃ¼r Interesse im Service',0),(383256,10646,'en','GL Account for Interest when In Service',0),(383257,10647,'is','',0),(383258,10647,'dr','(Ù…ÙØ§Ø¯) Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø¯Ø± Ø¯Ø³Øª Ø³Ø§Ø®Øª Ø§Ø³Øª',0),(383259,10647,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ù‡Ø±Ù‡ (Ø³ÙˆØ¯) Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ø¯Ø± Ø¯Ø³Øª Ø³Ø§Ø®Øª Ø§Ø³Øª',0),(383260,10647,'tr','GL hesap ilgi iÃ§in yapÄ±m aÅŸamasÄ±nda iken',0),(383261,10647,'pl','GL konto za zainteresowanie, a w budowie',0),(383262,10647,'bg','GL Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÑÐ²Ð°Ñ‚ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ ÐºÐ°Ñ‚Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð½Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ',0),(383263,10647,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…ÙØ§Ø¯ Ú©Û’ ØªØ­Øª ØªØ¹Ù…ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(383264,10647,'sr','Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½ Ð·Ð° ÐºÐ°Ð¼Ð°Ñ‚Ñƒ Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÐµ Ð¿Ð¾Ð´',0),(383265,10647,'vi','TK sá»• cÃ¡i cho tiá»n lÃ£i Ä‘ang Ä‘Æ°á»£c xÃ¢y dá»±ng',0),(383266,10647,'af','GL rekening vir rente terwyl onder konstruksie',0),(383267,10647,'ro','GL cont pentru interesul Ã®n timp ce Ã®n construcÅ£ie',0),(383268,10647,'et','Pearaamatukontole huvi ehituse ajal',0),(383269,10647,'si','GL raÄun za obresti, medtem ko Under Construction',0),(383270,10647,'ba','GL akun untuk kepentingan sementara di bawah konstruksi',0),(383271,10647,'nl','GL Account voor rente terwijl Under Construction',0),(383272,10647,'fi','Kirjanpitotilin pÃ¤Ã¤tilin mielenkiinnosta kun rakenteilla',0),(383273,10647,'no','GI-konto for rentene mens Under konstruksjon',0),(383274,10647,'da','GL konto for interesse mens Under opbygning',0),(383275,10647,'ko','ê±´ì„¤ í•˜ëŠ” ë™ì•ˆ ê´€ì‹¬ì— ëŒ€ í•œ GL ê³„ì •',0),(383276,10647,'he','GL ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×¨×™×‘×™×ª ×‘×¢×ª ×‘×”×§×ž×”',0),(383277,10647,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± Ï„ÏŒÎºÎ¿Ï…Ï‚, ÎµÎ½ÏŽ Ï…Ï€ÏŒ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(383278,10647,'zh','æ­£åœ¨å»ºè®¾ä¸­æ—¶æ€»å¸å¸æˆ·ä¸ºåˆ©æ¯\r\n',0),(383279,10647,'sv','GL konto fÃ¶r intresse medan Under konstruktion',0),(383280,10647,'it','GL Account per interesse mentre in costruzione',0),(383281,10647,'tl','',0),(383282,10647,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸ªà¸³à¸«à¸£à¸±à¸šà¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¹ƒà¸™à¸‚à¸“à¸°à¸—à¸µà¹ˆà¸à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡à¸ à¸²à¸¢à¹ƒà¸•à¹‰',0),(383283,10647,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤¤à¤¹à¤¤ à¤œà¤¬à¤•à¤¿ à¤¬à¥à¤¯à¤¾à¤œ à¤•à¥‡ à¤²à¤¿à¤ GL à¤–à¤¾à¤¤à¤¾',0),(383284,10647,'ms','GL akaun untuk faedah semasa pembinaan di bawah',0),(383285,10647,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(383286,10647,'fr','Compte GL pour intÃ©rÃªt tandis que Under Construction',0),(383287,10647,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ä¸‹ã§å»ºè¨­ä¸­ã®åˆ©ç›Šã®ãŸã‚',0),(383288,10647,'pt','GL conta para juros enquanto Under Construction',0),(383289,10647,'ru','Ð¡Ñ‡ÐµÑ‚ GL Ð´Ð»Ñ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑÐ° Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ñ ÑÑ‚Ð°Ð´Ð¸Ð¸ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(383290,10647,'es','Cuenta LM para Intereses Mientras Que EstÃ¡ Bajo ConstrucciÃ³n',0),(383291,10647,'de','Sako fÃ¼r Interesse wÃ¤hrend Under Construction',0),(383292,10647,'en','GL Account for Interest while Under Construction',0),(383293,10648,'is','',0),(383294,10648,'dr','(Ù…Ø§Ù„Ùƒ Ø¹Ù…Ø¯Ù‡',0),(383295,10648,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø´Ø±ÙƒØª Ø§ØµÙ„ÙŠ(Ù…Ø§Ù„Ùƒ Ø¹Ù…Ø¯Ù‡',0),(383296,10648,'tr','GL hesap sorumlusu',0),(383297,10648,'pl','GL konta dla podmiotu',0),(383298,10648,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð³Ð»Ð°Ð²Ð½Ð¸Ñ†Ð°Ñ‚Ð°',0),(383299,10648,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾Ø±Ù†Ø³Ù¾Ù„ Ú©Û’ Ù„ÛŒÛ’',0),(383300,10648,'sr','Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð°',0),(383301,10648,'vi','TK sá»• cÃ¡i cho chá»§ yáº¿u',0),(383302,10648,'af','AG Rekening vir Prinsipaal',0),(383303,10648,'ro','GL cont pentru comitent',0),(383304,10648,'et','GL moodustavad pÃµhiosa',0),(383305,10648,'si','GL raÄun za glavnico',0),(383306,10648,'ba','GL Account untuk kepala sekolah',0),(383307,10648,'nl','GL Account voor Principal',0),(383308,10648,'fi','Kirjanpitotilin pÃ¤Ã¤tilin Principal',0),(383309,10648,'no','GI-konto for rektor',0),(383310,10648,'da','GL konto for agenturgiveren',0),(383311,10648,'ko','ë³´ì•ˆ ì£¼ì²´ì— ëŒ€ í•œ GL ê³„ì •',0),(383312,10648,'he','GL ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×”×ž× ×”×œ',0),(383313,10648,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± Ï„Î¿Î½ ÎµÎ½Ï„Î¿Î»Î­Î±',0),(383314,10648,'zh','ä¸»è¦æ€»å¸å¸æˆ·\r\n',0),(383315,10648,'sv','GL konto fÃ¶r huvudmannen',0),(383316,10648,'it','GL conto Principal',0),(383317,10648,'tl','',0),(383318,10648,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸ªà¸³à¸«à¸£à¸±à¸šà¸«à¸¥à¸±à¸',0),(383319,10648,'hi','à¤ªà¥à¤°à¤¾à¤šà¤¾à¤°à¥à¤¯ à¤•à¥‡ à¤²à¤¿à¤ GL à¤–à¤¾à¤¤à¤¾',0),(383320,10648,'ms','GL akaun utama',0),(383321,10648,'ar','Ø­Ø³Ø§Ø¨ GL Ù„Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(383322,10648,'fr','GL compte pour Principal',0),(383323,10648,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ãƒ—ãƒªãƒ³ã‚·ãƒ‘ãƒ«',0),(383324,10648,'pt','GL conta para diretor',0),(383325,10648,'ru','Ð¡Ñ‡ÐµÑ‚ GL Ð´Ð»Ñ ÑƒÑ‡Ð°ÑÑ‚Ð½Ð¸ÐºÐ°',0),(383326,10648,'es','Cuenta LM Para el Prinicipal',0),(383327,10648,'de','Sako fÃ¼r Prinzipal',0),(383328,10648,'en','GL Account for Principal',0),(383329,10649,'is','',0),(383330,10649,'dr','(Ù…ÙØ§Ø¯) ÙŠØ§ Ø³Ø±Ù…Ø§ÙŠÙ‡ Ø§ÙˆÙ„ÙŠÙ‡ Ù…ÙˆØ³Ø³Ø§Ù† Ø´Ø±Ú©Øª',0),(383331,10649,'pr','Ø¨Ù‡Ø±Ù‡ (Ø³ÙˆØ¯) ÙŠØ§ Ø³Ø±Ù…Ø§ÙŠÙ‡ Ø§ÙˆÙ„ÙŠÙ‡ Ù…ÙˆØ³Ø³Ø§Ù† Ø´Ø±Ú©Øª',0),(383332,10649,'tr','Faiz ve anapara',0),(383333,10649,'pl','Odsetek i kapitaÅ‚u',0),(383334,10649,'bg','Ð›Ð¸Ñ…Ð²Ð¸ Ð¸ Ð³Ð»Ð°Ð²Ð½Ð¸Ñ†Ð°',0),(383335,10649,'ur','Ø³ÙˆØ¯ Ø§ÙˆØ± Ù¾Ø±Ù†Ø³Ù¾Ù„',0),(383336,10649,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ðµ Ð¸ Ð³Ð»Ð°Ð²Ð½Ð¸Ñ†Ñƒ',0),(383337,10649,'vi','LÃ£i vÃ  vá»‘n',0),(383338,10649,'af','Rente en skoolhoof',0),(383339,10649,'ro','Interes ÅŸi Principal',0),(383340,10649,'et','Intressikandvad vÃµlakohustused',0),(383341,10649,'si','Obresti in glavnice',0),(383342,10649,'ba','Bunga dan Pokoknya',0),(383343,10649,'nl','Rente en hoofdsom',0),(383344,10649,'fi','Korko ja pÃ¤Ã¤oma',0),(383345,10649,'no','Renter og avdrag',0),(383346,10649,'da','Renter og hovedstol',0),(383347,10649,'ko','ê´€ì‹¬ê³¼ êµìž¥',0),(383348,10649,'he','×¨×™×‘×™×ª ×•×§×¨×Ÿ',0),(383349,10649,'el','Î¤ÏŒÎºÎ¿Ï…Ï‚ ÎºÎ±Î¹ ÎµÎ½Ï„Î¿Î»Î­Î±',0),(383350,10649,'zh','åˆ©æ¯å’Œæœ¬é‡‘\r\n',0),(383351,10649,'sv','Intresse och rektor',0),(383352,10649,'it','Interessi e capitale',0),(383353,10649,'tl','',0),(383354,10649,'th','à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¹à¸¥à¸°à¹€à¸‡à¸´à¸™à¸•à¹‰à¸™',0),(383355,10649,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤”à¤° à¤®à¥‚à¤²à¤§à¤¨',0),(383356,10649,'ms','Faedah dan prinsipal',0),(383357,10649,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(383358,10649,'fr','IntÃ©rÃªts et du Principal',0),(383359,10649,'jp','åˆ©æ¯ãŠã‚ˆã³å…ƒæœ¬',0),(383360,10649,'pt','Juros e Principal',0),(383361,10649,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹ Ð¸ Ð¾ÑÐ½Ð¾Ð²Ð½ÑƒÑŽ',0),(383362,10649,'es','InterÃ©s y Prinicipal',0),(383363,10649,'de','Zins- und Tilgungszahlungen',0),(383364,10649,'en','Interest and Principal',0),(383365,10650,'is','',0),(383366,10650,'dr','(ØªÙ†Ø²ÙŠÙ„ ) Ø¯ Ø±Ø³Ø§Ù„ ',0),(383367,10650,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¨Ù‡Ø±Ù‡ (ØªÙ†Ø²ÙŠÙ„ ) Ø¯ Ø±Ø³Ø§Ù„ ',0),(383368,10650,'tr','YÄ±lda faiz gÃ¼n',0),(383369,10650,'pl','Odsetek dni rocznie',0),(383370,10650,'bg','Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ Ð´Ð½Ð¸ Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¾',0),(383371,10650,'ur','Ø³ÙˆØ¯ Ú©Û’ Ø¯Ù† ÛØ± Ø³Ø§Ù„',0),(383372,10650,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ð° Ð´Ð°Ð½Ð° Ð³Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(383373,10650,'vi','ngÃ y tráº£ lÃ£i trong 1 nÄƒm',0),(383374,10650,'af','Rente Dae per Jaar',0),(383375,10650,'ro','Interes de zile pe an',0),(383376,10650,'et','Huvi pÃ¤eva aastas',0),(383377,10650,'si','Obresti dni na leto',0),(383378,10650,'ba','Bunga hari per tahun',0),(383379,10650,'nl','Belang dagen per jaar',0),(383380,10650,'fi','Edun pÃ¤ivÃ¤Ã¤ vuodessa',0),(383381,10650,'no','Interesse dager per Ã¥r',0),(383382,10650,'da','Interesse dage om Ã¥ret',0),(383383,10650,'ko','ì—°ê°„ ì´ìž ì¼',0),(383384,10650,'he','×¢× ×™×™×Ÿ ×™×ž×™× ×‘×©× ×”',0),(383385,10650,'el','Î•Î½Î´Î¹Î±Ï†Î­ÏÎ¿Î½ Î·Î¼Î­ÏÎµÏ‚ Î±Î½Î¬ Î­Ï„Î¿Ï‚',0),(383386,10650,'zh','æ¯ä¸€å¹´çš„åˆ©æ¯å¤©\r\n',0),(383387,10650,'sv','Intresse dagar per Ã¥r',0),(383388,10650,'it','Interesse giorni all\'anno',0),(383389,10650,'tl','',0),(383390,10650,'th','à¸ªà¸™à¹ƒà¸ˆà¸§à¸±à¸™à¸•à¹ˆà¸­à¸›à¸µ',0),(383391,10650,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤· à¤¬à¥à¤¯à¤¾à¤œ à¤¦à¤¿à¤¨',0),(383392,10650,'ms','Kepentingan hari setahun',0),(383393,10650,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(383394,10650,'fr','IntÃ©rÃªt jours par an',0),(383395,10650,'jp','å¹´é–“ã®åˆ©æ¯æ—¥',0),(383396,10650,'pt','Dias de juros por ano',0),(383397,10650,'ru','Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ Ð´Ð½ÐµÐ¹ Ð² Ð³Ð¾Ð´',0),(383398,10650,'es','DÃ­as de Intereses po AÃ±o',0),(383399,10650,'de','Interesse Tage pro Jahr',0),(383400,10650,'en','Interest Days per Year',0),(383401,10651,'is','',0),(383402,10651,'dr','(Ù…ÙØ§Ø¯',0),(383403,10651,'pr','ÙÙ‚Ø· Ø¨Ù‡Ø±Ù‡(Ø³ÙˆØ¯',0),(383404,10651,'tr','Sadece faiz',0),(383405,10651,'pl','Odsetki tylko',0),(383406,10651,'bg','Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ ÑÐ°Ð¼Ð¾',0),(383407,10651,'ur','ØµØ±Ù Ø³ÙˆØ¯',0),(383408,10651,'sr','Ð¡Ð°Ð¼Ð¾ ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(383409,10651,'vi','chá»‰ lÃ£i suáº¥t',0),(383410,10651,'af','Rente Alleenlik',0),(383411,10651,'ro','Interes numai',0),(383412,10651,'et','Huvi ainult',0),(383413,10651,'si','Samo obresti',0),(383414,10651,'ba','Bunga hanya',0),(383415,10651,'nl','Alleen de rente',0),(383416,10651,'fi','Korot vain',0),(383417,10651,'no','Kun',0),(383418,10651,'da','Interesse kun',0),(383419,10651,'ko','ê´€ì‹¬ë§Œ',0),(383420,10651,'he','×”×¨×™×‘×™×ª ×‘×œ×‘×“',0),(383421,10651,'el','Î•Î½Î´Î¹Î±Ï†Î­ÏÎ¿Î½ Î¼ÏŒÎ½Î¿',0),(383422,10651,'zh','ä»…åˆ©æ¯\r\n',0),(383423,10651,'sv','Intresse bara',0),(383424,10651,'it','Interesse solo',0),(383425,10651,'tl','',0),(383426,10651,'th','à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(383427,10651,'hi','à¤•à¥‡à¤µà¤² à¤¬à¥à¤¯à¤¾à¤œ',0),(383428,10651,'ms','Faedah sahaja',0),(383429,10651,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(383430,10651,'fr','IntÃ©rÃªt seulement',0),(383431,10651,'jp','åˆ©æ¯ã®ã¿',0),(383432,10651,'pt','Interesse apenas',0),(383433,10651,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(383434,10651,'es','Intereses Solo',0),(383435,10651,'de','Nur Interesse',0),(383436,10651,'en','Interest Only',0),(383437,10652,'is','',0),(383438,10652,'dr','(ØªÙ†Ø²ÙŠÙ„ )  Ø¯Ø± Ù…Ø§Ù‡ ',0),(383439,10652,'pr','Ø¯Ø±ØµØ¯ Ø¨Ù‡Ø±Ù‡ (ØªÙ†Ø²ÙŠÙ„ )  Ø¯Ø± Ù…Ø§Ù‡ ',0),(383440,10652,'tr','AylÄ±k faiz %',0),(383441,10652,'pl','Stopy % miesiÄ™cznie',0),(383442,10652,'bg','Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ % Ð½Ð° Ð¼ÐµÑÐµÑ†',0),(383443,10652,'ur','Ø³ÙˆØ¯ Ùª ÙÛŒ Ù…ÛÛŒÙ†Û',0),(383444,10652,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ð° % Ð¼ÐµÑÐµÑ‡Ð½Ð¾',0),(383445,10652,'vi','% lÃ£i suáº¥t trong 1 thÃ¡ng',0),(383446,10652,'af','Rente % Per Maand',0),(383447,10652,'ro','Interes % pe lunÄƒ',0),(383448,10652,'et','Intressi % kuus',0),(383449,10652,'si','% Obresti na mesec',0),(383450,10652,'ba','Bunga % Per bulan',0),(383451,10652,'nl','Rente % Per maand',0),(383452,10652,'fi','Korko % kuukaudessa',0),(383453,10652,'no','Interesse % Per mÃ¥ned',0),(383454,10652,'da','Interesse % pr. mÃ¥ned',0),(383455,10652,'ko','í•œë‹¬ì— ì´ìž %',0),(383456,10652,'he','% ×¨×™×‘×™×ª ×œ×—×•×“×©',0),(383457,10652,'el','Î•Î½Î´Î¹Î±Ï†Î­ÏÎ¿Î½ % Î±Î½Î¬ Î¼Î®Î½Î±',0),(383458,10652,'zh','ï¼…ï¼Œæ¯æœˆåˆ©æ¯\r\n',0),(383459,10652,'sv','Intresse % Per mÃ¥nad',0),(383460,10652,'it','% Di interessi al mese',0),(383461,10652,'tl','',0),(383462,10652,'th','à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢%à¸•à¹ˆà¸­à¹€à¸”à¸·à¸­à¸™',0),(383463,10652,'hi','à¤¬à¥à¤¯à¤¾à¤œ % à¤ªà¥à¤°à¤¤à¤¿ à¤®à¤¾à¤¹',0),(383464,10652,'ms','Faedah % sebulan',0),(383465,10652,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(383466,10652,'fr','% D\'intÃ©rÃªt par mois',0),(383467,10652,'jp','1 ãƒ¶æœˆã‚ãŸã‚Šã®åˆ©ç›Š %',0),(383468,10652,'pt','% De juros por mÃªs',0),(383469,10652,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ð°Ñ ÑÑ‚Ð°Ð²ÐºÐ° % Ð² Ð¼ÐµÑÑÑ†',0),(383470,10652,'es','% Intereses Por Mes',0),(383471,10652,'de','% Zinsen pro Monat',0),(383472,10652,'en','Interest % Per Month',0),(383473,10653,'is','',0),(383474,10653,'dr','( ØªÙ†Ø²ÙŠÙ„',0),(383475,10653,'pr','Ù†ÙˆØ¹ Ø¨Ù‡Ø±Ù‡ ( ØªÙ†Ø²ÙŠÙ„',0),(383476,10653,'tr','Faiz tÃ¼rÃ¼',0),(383477,10653,'pl','Zainteresowanie typu',0),(383478,10653,'bg','Ð˜Ð½Ñ‚ÐµÑ€ÐµÑ Ñ‚Ð¸Ð¿',0),(383479,10653,'ur','Ø³ÙˆØ¯ Ú©ÛŒ Ù‚Ø³Ù…',0),(383480,10653,'sr','Ð’Ñ€ÑÑ‚Ð° ÐºÐ°Ð¼Ð°Ñ‚Ðµ',0),(383481,10653,'vi','loáº¡i lÃ£i suáº¥t',0),(383482,10653,'af','Rente Tipe',0),(383483,10653,'ro','Tipul de interes',0),(383484,10653,'et','Huvide tÃ¼Ã¼bi',0),(383485,10653,'si','Tip obrestne',0),(383486,10653,'ba','Jenis bunga',0),(383487,10653,'nl','Belang Type',0),(383488,10653,'fi','Edun tyyppi',0),(383489,10653,'no','Interesse Type',0),(383490,10653,'da','Interesse Type',0),(383491,10653,'ko','ê´€ì‹¬ ìœ í˜•',0),(383492,10653,'he','×¡×•×’ ×”×¨×™×‘×™×ª',0),(383493,10653,'el','Î•Î½Î´Î¹Î±Ï†Î­ÏÎ¿Î½ Ï„ÏÏ€Î¿Ï…',0),(383494,10653,'zh','åˆ©æ¯ç±»åž‹\r\n',0),(383495,10653,'sv','Intresse typ',0),(383496,10653,'it','Tipo di interesse',0),(383497,10653,'tl','',0),(383498,10653,'th','à¸Šà¸™à¸´à¸”à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢',0),(383499,10653,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(383500,10653,'ms','Jenis faedah',0),(383501,10653,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(383502,10653,'fr','Type d\'intÃ©rÃªt',0),(383503,10653,'jp','é‡‘åˆ©ã‚¿ã‚¤ãƒ—',0),(383504,10653,'pt','Tipo de interesse',0),(383505,10653,'ru','Ð¢Ð¸Ð¿ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(383506,10653,'es','Tipo de InterÃ©s',0),(383507,10653,'de','Interesse-Typ',0),(383508,10653,'en','Interest Type',0),(383509,10654,'is','',0),(383510,10654,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø®Ø¯Ù…Øª',0),(383511,10654,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø®Ø¯Ù…Øª',0),(383512,10654,'tr','Hizmetinde',0),(383513,10654,'pl','W sÅ‚uÅ¼bie',0),(383514,10654,'bg','Ð’ ÐµÐºÑÐ¿Ð»Ð¾Ð°Ñ‚Ð°Ñ†Ð¸Ñ',0),(383515,10654,'ur','Ø®Ø¯Ù…Øª Ù…ÛŒÚº',0),(383516,10654,'sr','Ð£ ÑÐ»ÑƒÐ¶Ð±Ð¸',0),(383517,10654,'vi','theo dá»‹ch vá»¥',0),(383518,10654,'af','Indiens',0),(383519,10654,'ro','ÃŽn serviciul',0),(383520,10654,'et','Teenus',0),(383521,10654,'si','V storitev',0),(383522,10654,'ba','Dalam Layanan',0),(383523,10654,'nl','In dienst',0),(383524,10654,'fi','Palvelu',0),(383525,10654,'no','I tjeneste',0),(383526,10654,'da','I Service',0),(383527,10654,'ko','ì„œë¹„ìŠ¤ì—ì„œ',0),(383528,10654,'he','×‘×©×¨×•×ª',0),(383529,10654,'el','Î£Ï„Î·Î½ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±',0),(383530,10654,'zh','åœ¨æœåŠ¡\r\n',0),(383531,10654,'sv','I tjÃ¤nst',0),(383532,10654,'it','In servizio',0),(383533,10654,'tl','',0),(383534,10654,'th','à¹ƒà¸™à¸šà¸£à¸´à¸à¸²à¸£',0),(383535,10654,'hi','à¤¸à¥‡à¤µà¤¾ à¤®à¥‡à¤‚',0),(383536,10654,'ms','Dalam Perkhidmatan',0),(383537,10654,'ar','ÙÙŠ Ø§Ù„Ø®Ø¯Ù…Ø©',0),(383538,10654,'fr','En Service',0),(383539,10654,'jp','ã‚µãƒ¼ãƒ“ã‚¹',0),(383540,10654,'pt','Em serviÃ§o',0),(383541,10654,'ru','Ð’ ÑÐ»ÑƒÐ¶Ð±Ðµ',0),(383542,10654,'es','En el Trabajo',0),(383543,10654,'de','Im Dienst',0),(383544,10654,'en','In Service',0),(383545,10655,'is','',0),(383546,10655,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙˆØ§Ù… ',0),(383547,10655,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙˆØ§Ù… ',0),(383548,10655,'tr','Kredi eklemek',0),(383549,10655,'pl','DodaÄ‡ kredytu',0),(383550,10655,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð·Ð°ÐµÐ¼',0),(383551,10655,'ur','Ù‚Ø±Ø¶ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(383552,10655,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(383553,10655,'vi','Cho vay thÃªm',0),(383554,10655,'af','Lening Byvoeg',0),(383555,10655,'ro','Adauga Ã®mprumut',0),(383556,10655,'et','Laenu lisamine',0),(383557,10655,'si','Dodaj posojilo',0),(383558,10655,'ba','Tambahkan pinjaman',0),(383559,10655,'nl','Lening toevoegen',0),(383560,10655,'fi','Lainan lisÃ¤tÃ¤',0),(383561,10655,'no','LÃ¥n legge',0),(383562,10655,'da','LÃ¥n tilfÃ¸je',0),(383563,10655,'ko','ëŒ€ì¶œ ì¶”ê°€',0),(383564,10655,'he','×”×œ×•×•××” ×œ×”×•×¡×™×£',0),(383565,10655,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î´Î¬Î½ÎµÎ¹Î¿',0),(383566,10655,'zh','æ–°å¢žè´·æ¬¾\r\n',0),(383567,10655,'sv','LÃ¥n lÃ¤gga till',0),(383568,10655,'it','Aggiungi prestito',0),(383569,10655,'tl','',0),(383570,10655,'th','à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰à¸¢à¸·à¸¡à¹€à¸žà¸´à¹ˆà¸¡',0),(383571,10655,'hi','à¤‹à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(383572,10655,'ms','Tambah pinjaman',0),(383573,10655,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø±Ø¶',0),(383574,10655,'fr','Ajouter prÃªt',0),(383575,10655,'jp','ãƒ­ãƒ¼ãƒ³ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(383576,10655,'pt','Adicionar o emprÃ©stimo',0),(383577,10655,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(383578,10655,'es','Prestamo Agregar',0),(383579,10655,'de','Darlehen hinzufÃ¼gen',0),(383580,10655,'en','Loan Add',0),(383581,10656,'is','',0),(383582,10656,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙˆØ§Ù… Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(383583,10656,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙˆØ§Ù… Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(383584,10656,'tr','Kredi baÅŸarÄ±yla eklendi',0),(383585,10656,'pl','Kredyt dodany pomyÅ›lnie',0),(383586,10656,'bg','Ð—Ð°ÐµÐ¼, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(383587,10656,'ur','Ù‚Ø±Ø¶ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(383588,10656,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(383589,10656,'vi','ÄÃ£ thÃªm cho vay thÃ nh cÃ´ng',0),(383590,10656,'af','Skep van Lening Suksesvol ',0),(383591,10656,'ro','ÃŽmprumut adÄƒugat cu succes',0),(383592,10656,'et','Lisatud laenu',0),(383593,10656,'si','Posojilo uspeÅ¡no dodani',0),(383594,10656,'ba','Pinjaman yang ditambahkan berhasil',0),(383595,10656,'nl','Lening met succes toegevoegd',0),(383596,10656,'fi','Lainan lisÃ¤Ã¤minen onnistui',0),(383597,10656,'no','LÃ¥net ble lagt til',0),(383598,10656,'da','LÃ¥n tilfÃ¸jet',0),(383599,10656,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ëŒ€ì¶œ',0),(383600,10656,'he','×”×œ×•×•××” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(383601,10656,'el','Î”Î¬Î½ÎµÎ¹Î¿ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(383602,10656,'zh','è´·æ¬¾æˆåŠŸæ·»åŠ \r\n',0),(383603,10656,'sv','LÃ¥n som lagts',0),(383604,10656,'it','Prestito aggiunto con successo',0),(383605,10656,'tl','',0),(383606,10656,'th','à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰à¸¢à¸·à¸¡à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(383607,10656,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤‹à¤£',0),(383608,10656,'ms','Pinjaman yang berjaya menambah',0),(383609,10656,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ù‚Ø±Ø¶ Ø¨Ù†Ø¬Ø§Ø­',0),(383610,10656,'fr','PrÃªt ajoutÃ© avec succÃ¨s',0),(383611,10656,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸè²¸ä»˜ã‘é‡‘',0),(383612,10656,'pt','EmprÃ©stimo adicionado com sucesso',0),(383613,10656,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(383614,10656,'es','Prestamo Agregado Exitosamente',0),(383615,10656,'de','Darlehen erfolgreich hinzugefÃ¼gt',0),(383616,10656,'en','Loan Added Successfully',0),(383617,10657,'is','',0),(383618,10657,'dr','ÙˆØ§Ù… Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(383619,10657,'pr','ÙˆØ§Ù… Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯ ',0),(383620,10657,'tr','Kredi zaten var',0),(383621,10657,'pl','PoÅ¼yczki juÅ¼ istnieje',0),(383622,10657,'bg','Ð—Ð°ÐµÐ¼ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(383623,10657,'ur','Ù‚Ø±Ø¶ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(383624,10657,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(383625,10657,'vi','Khoáº£n vay Ä‘Ã£ cÃ³',0),(383626,10657,'af','Lening Bestaan Alreeds',0),(383627,10657,'ro','ÃŽmprumut existÄƒ deja',0),(383628,10657,'et','Laen on juba olemas',0),(383629,10657,'si','Posojilo Å¾e obstaja',0),(383630,10657,'ba','Pinjaman sudah ada',0),(383631,10657,'nl','Lening bestaat al',0),(383632,10657,'fi','Laina on jo olemassa',0),(383633,10657,'no','LÃ¥n finnes allerede',0),(383634,10657,'da','LÃ¥n findes allerede',0),(383635,10657,'ko','ì´ë¯¸ ì¡´ìž¬ í•˜ëŠ” ëŒ€ì¶œ',0),(383636,10657,'he','×”×”×œ×•×•××” ×›×‘×¨ ×§×™×™×',0),(383637,10657,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Ï„Î¿ Î´Î¬Î½ÎµÎ¹Î¿',0),(383638,10657,'zh','è´·æ¬¾å·²å­˜åœ¨\r\n',0),(383639,10657,'sv','LÃ¥n finns redan',0),(383640,10657,'it','Prestito esiste giÃ ',0),(383641,10657,'tl','',0),(383642,10657,'th','à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(383643,10657,'hi','à¤‹à¤£ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(383644,10657,'ms','Pinjaman telah wujud',0),(383645,10657,'ar','Ø§Ù„Ù‚Ø±Ø¶ Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„',0),(383646,10657,'fr','PrÃªt existe dÃ©jÃ ',0),(383647,10657,'jp','è²¸ä»˜ã‘é‡‘ã¯æ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(383648,10657,'pt','EmprÃ©stimo jÃ¡ existe',0),(383649,10657,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(383650,10657,'es','Prestamo Ya Existe',0),(383651,10657,'de','Darlehen ist bereits vorhanden.',0),(383652,10657,'en','Loan Already Exists',0),(383653,10658,'is','',0),(383654,10658,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙˆØ§Ù… ',0),(383655,10658,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙˆØ§Ù… ',0),(383656,10658,'tr','Kredi bilgi',0),(383657,10658,'pl','SzczegÃ³Å‚y kredytu',0),(383658,10658,'bg','Ð—Ð°ÐµÐ¼ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(383659,10658,'ur','Ù‚Ø±Ø¶ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(383660,10658,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ñƒ',0),(383661,10658,'vi','chi tiáº¿t khoáº£n vay',0),(383662,10658,'af','Lening Besonderhede',0),(383663,10658,'ro','ÃŽmprumut detalii',0),(383664,10658,'et','Pandi kirjendus',0),(383665,10658,'si','Posojilo podrobnosti',0),(383666,10658,'ba','Informasi pinjaman',0),(383667,10658,'nl','Lening Details',0),(383668,10658,'fi','Lainan tiedot',0),(383669,10658,'no','LÃ¥net detaljer',0),(383670,10658,'da','LÃ¥n detaljer',0),(383671,10658,'ko','ëŒ€ ë¶€ ì„¸ë¶€ ì‚¬í•­',0),(383672,10658,'he','×¤×¨×˜×™ ×”×”×œ×•×•××”',0),(383673,10658,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î´Î±Î½ÎµÎ¯Î¿Ï…',0),(383674,10658,'zh','è´·æ¬¾ç»†èŠ‚\r\n',0),(383675,10658,'sv','LÃ¥n Detaljer',0),(383676,10658,'it','Dettagli del prestito',0),(383677,10658,'tl','',0),(383678,10658,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰',0),(383679,10658,'hi','à¤‹à¤£ à¤µà¤¿à¤µà¤°à¤£',0),(383680,10658,'ms','Butir-butir pinjaman',0),(383681,10658,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù‚Ø±Ø¶',0),(383682,10658,'fr','DÃ©tails de prÃªt',0),(383683,10658,'jp','ãƒ­ãƒ¼ãƒ³ã®è©³ç´°',0),(383684,10658,'pt','Detalhes do emprÃ©stimo',0),(383685,10658,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(383686,10658,'es','Prestamo Detalles',0),(383687,10658,'de','Kreditdetails',0),(383688,10658,'en','Loan Details',0),(383689,10659,'is','',0),(383690,10659,'dr','ÙˆØ§Ù… Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(383691,10659,'pr','ÙˆØ§Ù… Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(383692,10659,'tr','Kredi ekledi',0),(383693,10659,'pl','PoÅ¼yczki nie dodaje',0),(383694,10659,'bg','Ð—Ð°ÐµÐ¼ Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¾',0),(383695,10659,'ur','Ù‚Ø±Ø¶ Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©ÛŒØ§',0),(383696,10659,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ñ‚',0),(383697,10659,'vi','khoáº£n vay khÃ´ng Ä‘Æ°á»£c thÃªm',0),(383698,10659,'af','Lening Nie Bygevoeg Nie',0),(383699,10659,'ro','ÃŽmprumut nu adÄƒugat',0),(383700,10659,'et','Laenu ei lisatud',0),(383701,10659,'si','Posojila ne doda',0),(383702,10659,'ba','Pinjaman yang tidak ditambahkan',0),(383703,10659,'nl','Lening niet toegevoegd',0),(383704,10659,'fi','Laina ei lisÃ¤tÃ¤',0),(383705,10659,'no','LÃ¥net ikke lagt',0),(383706,10659,'da','LÃ¥n ikke tilfÃ¸jet',0),(383707,10659,'ko','ì¶”ê°€ ëŒ€ì¶œ',0),(383708,10659,'he','×”×”×œ×•×•××” ×œ× ×”×•×¡×™×£',0),(383709,10659,'el','Î”Î¬Î½ÎµÎ¹Î¿ Î´ÎµÎ½ Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯',0),(383710,10659,'zh','è´·æ¬¾ä¸æ·»åŠ \r\n',0),(383711,10659,'sv','LÃ¥n inte lÃ¤ggas',0),(383712,10659,'it','Prestito non aggiunto',0),(383713,10659,'tl','',0),(383714,10659,'th','à¹„à¸¡à¹ˆà¹€à¸žà¸´à¹ˆà¸¡à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰à¸¢à¸·à¸¡',0),(383715,10659,'hi','à¤‹à¤£ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(383716,10659,'ms','Pinjaman yang tidak ditambah',0),(383717,10659,'ar','Ø§Ù„Ù‚Ø±Ø¶ Ù„Ø§ ØªØ¶Ø§Ù',0),(383718,10659,'fr','PrÃªt ne pas ajoutÃ©',0),(383719,10659,'jp','ãƒ­ãƒ¼ãƒ³ã‚’è¿½åŠ ã—ã¦ã„ã¾ã›ã‚“',0),(383720,10659,'pt','EmprÃ©stimo nÃ£o adicionado',0),(383721,10659,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(383722,10659,'es','Prestamo No Agregado',0),(383723,10659,'de','Darlehen nicht hinzugefÃ¼gt',0),(383724,10659,'en','Loan Not Added',0),(383725,10660,'is','',0),(383726,10660,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙˆØ§Ù… ',0),(383727,10660,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙˆØ§Ù… ',0),(383728,10660,'tr','Kredi numarasÄ±',0),(383729,10660,'pl','Numer poÅ¼yczki',0),(383730,10660,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð·Ð°ÐµÐ¼',0),(383731,10660,'ur','Ù‚Ø±Ø¶ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(383732,10660,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(383733,10660,'vi','Sá»‘ khoáº£n vay',0),(383734,10660,'af','Lening Nommer',0),(383735,10660,'ro','NumÄƒrul de Ã®mprumut',0),(383736,10660,'et','Laenu Number',0),(383737,10660,'si','Posojilo Å¡tevilka',0),(383738,10660,'ba','Jumlah pinjaman',0),(383739,10660,'nl','Lening nummer',0),(383740,10660,'fi','Lainan mÃ¤Ã¤rÃ¤',0),(383741,10660,'no','LÃ¥n nummer',0),(383742,10660,'da','LÃ¥n nummer',0),(383743,10660,'ko','ëŒ€ì¶œ ë²ˆí˜¸',0),(383744,10660,'he','×ž×¡×¤×¨ ×”×”×œ×•×•××•×ª',0),(383745,10660,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´Î±Î½ÎµÎ¯Î¿Ï…',0),(383746,10660,'zh','è´·æ¬¾å·ç \r\n',0),(383747,10660,'sv','LÃ¥n nummer',0),(383748,10660,'it','Numero di prestito',0),(383749,10660,'tl','',0),(383750,10660,'th','à¸ˆà¸³à¸™à¸§à¸™à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰',0),(383751,10660,'hi','à¤‹à¤£ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(383752,10660,'ms','Jumlah pinjaman',0),(383753,10660,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ù‚Ø±ÙˆØ¶',0),(383754,10660,'fr','Nombre de prÃªt',0),(383755,10660,'jp','ãƒ­ãƒ¼ãƒ³ç•ªå·',0),(383756,10660,'pt','NÃºmero de emprÃ©stimos',0),(383757,10660,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(383758,10660,'es','Numero de Prestamo',0),(383759,10660,'de','Darlehen-Anzahl',0),(383760,10660,'en','Loan Number',0),(383761,10661,'is','',0),(383762,10661,'dr','ØªØ§Ø±ÙŠØ® Ø§ØµÙ„ ÙˆØ§Ù… ',0),(383763,10661,'pr','ØªØ§Ø±ÙŠØ® Ø§ØµÙ„ ÙˆØ§Ù… ',0),(383764,10661,'tr','Kredi kÃ¶ken tarihi',0),(383765,10661,'pl','Data powstania poÅ¼yczki',0),(383766,10661,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð²ÑŠÐ·Ð½Ð¸ÐºÐ²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°ÐµÐ¼',0),(383767,10661,'ur','Ù‚Ø±Ø¶ Ø´ÛŒØ¹ÛŒØª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(383768,10661,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð¿Ð¾Ñ€ÐµÐºÐ»Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼',0),(383769,10661,'vi','ngÃ y vay khoáº£n tiá»n gá»‘c',0),(383770,10661,'af','Lening Oorspronklike Datum',0),(383771,10661,'ro','Data de iniÅ£ierea de Ã®mprumut',0),(383772,10661,'et','Laenu tekkimise kuupÃ¤ev',0),(383773,10661,'si','Posojilo izvor datum',0),(383774,10661,'ba','Pinjaman Origination tanggal',0),(383775,10661,'nl','Lening Origination datum',0),(383776,10661,'fi','Lainan lÃ¤hdeverkkona pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(383777,10661,'no','LÃ¥n Origination dato',0),(383778,10661,'da','LÃ¥n opkaldsoprindelse dato',0),(383779,10661,'ko','ëŒ€ì¶œ ê°œì‹œ ë‚ ì§œ',0),(383780,10661,'he','×”×œ×•×•××” ×œ×—×™×•×’ ×ª××¨×™×š',0),(383781,10661,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎºÎºÎ¯Î½Î·ÏƒÎ·Ï‚ Î´Î±Î½ÎµÎ¯Î¿Ï…',0),(383782,10661,'zh','è´·æ¬¾å‘æ”¾æ—¥æœŸ\r\n',0),(383783,10661,'sv','LÃ¥n originering datum',0),(383784,10661,'it','Prestito Origination data',0),(383785,10661,'tl','',0),(383786,10661,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­',0),(383787,10661,'hi','à¤‹à¤£ à¤µà¥à¤¯à¥à¤¤à¥à¤ªà¤¤à¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(383788,10661,'ms','Tarikh permulaan pinjaman',0),(383789,10661,'ar','ØªØ§Ø±ÙŠØ® Ù†Ø´Ø£Ø© Ø§Ù„Ù‚Ø±Ø¶',0),(383790,10661,'fr','Date de dÃ©part de prÃªt',0),(383791,10661,'jp','ãƒ­ãƒ¼ãƒ³ã®ã‚ªãƒªã‚¸ãƒãƒ¼ã‚·ãƒ§ãƒ³ã®æ—¥ä»˜',0),(383792,10661,'pt','Data de originaÃ§Ã£o de emprÃ©stimo',0),(383793,10661,'ru','Ð”Ð°Ñ‚Ð° Ð²Ð¾Ð·Ð½Ð¸ÐºÐ½Ð¾Ð²ÐµÐ½Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(383794,10661,'es','Fecha de OrganizaciÃ³n de Prestamo',0),(383795,10661,'de','Ausleihdatum Origination',0),(383796,10661,'en','Loan Origination Date',0),(383797,10662,'is','',0),(383798,10662,'dr','Ù†Ø±Ø® Ø¨Ù‡Ø±Ù‡ ÙˆØ§Ù… ',0),(383799,10662,'pr','Ù†Ø±Ø® Ø¨Ù‡Ø±Ù‡ ÙˆØ§Ù… ',0),(383800,10662,'tr','Kredi deÄŸerini (LTV)',0),(383801,10662,'pl','Kredytu do wartoÅ›ci (LTV)',0),(383802,10662,'bg','Ð—Ð°ÐµÐ¼ Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ (LTV)',0),(383803,10662,'ur','Ù‚Ø¯Ø± (Ù„Ù¹Ùˆ) Ù‚Ø±Ø¶',0),(383804,10662,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð° Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ (Ð›Ð¢Ð’)',0),(383805,10662,'vi','mÃ³n vay cÃ³ giÃ¡',0),(383806,10662,'af','Lening tot waarde (Ëš LTW)',0),(383807,10662,'ro','ÃŽmprumut la valoare (LTV)',0),(383808,10662,'et','Laenu vÃ¤Ã¤rtuse (LTV)',0),(383809,10662,'si','Posojila za vrednost (LTV)',0),(383810,10662,'ba','Pinjaman untuk nilai (LTV)',0),(383811,10662,'nl','Lening aan waarde (LTV)',0),(383812,10662,'fi','Lainan arvosta (LTV)',0),(383813,10662,'no','LÃ¥n til verdi (LTV)',0),(383814,10662,'da','LÃ¥net til vÃ¦rdi (LTV)',0),(383815,10662,'ko','ëŒ€ì¶œ ê°’ (LTV)',0),(383816,10662,'he','×”×œ×•×•××” ×œ×¢×¨×š (LTV)',0),(383817,10662,'el','Î”Î¬Î½ÎµÎ¹Î¿ ÏƒÏ„Î·Î½ Î±Î¾Î¯Î± (LTV)',0),(383818,10662,'zh','è´·æ¬¾ä¸Žä»·å€¼ï¼ˆæŒ‰æ­â€‹â€‹ï¼‰\r\n',0),(383819,10662,'sv','LÃ¥n till vÃ¤rde (LTV)',0),(383820,10662,'it','Loan to Value (LTV)',0),(383821,10662,'tl','',0),(383822,10662,'th','à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰à¸¢à¸·à¸¡à¸„à¹ˆà¸² (LTV)',0),(383823,10662,'hi','à¤®à¥‚à¤²à¥à¤¯ (LTV) à¤•à¥‹ à¤‹à¤£',0),(383824,10662,'ms','Pinjaman kepada nilai (LTV)',0),(383825,10662,'ar','Ù‚Ø±Ø¶ Ø¨Ù‚ÙŠÙ…Ø© (Ø§Ù„Ù…Ø±ÙƒØ¨Ø© Ø§Ù„ØªÙƒØªÙŠÙƒÙŠØ© Ø§Ù„Ø®ÙÙŠÙØ©)',0),(383826,10662,'fr','Loan to Value (LTV)',0),(383827,10662,'jp','ä»˜åŠ ä¾¡å€¤ ï¼ˆLTVï¼‰ ã¸ã®èžè³‡',0),(383828,10662,'pt','EmprÃ©stimo para Value (LTV)',0),(383829,10662,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð° Ðº ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ (LTV)',0),(383830,10662,'es','Prestamo al Valor (PAV)',0),(383831,10662,'de','Darlehen an Wert (LTV)',0),(383832,10662,'en','Loan to Value (LTV)',0),(383833,10663,'is','',0),(383834,10663,'dr','(Ù…ÙØ§Ø¯ ) Ù…Ø§Ù‡Ø§Ù†Ù‡ ',0),(383835,10663,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ù‡Ø±Ù‡ (Ø³ÙˆØ¯ ) Ù…Ø§Ù‡Ø§Ù†Ù‡ ',0),(383836,10663,'tr','AylÄ±k faiz tutarÄ±',0),(383837,10663,'pl','MiesiÄ™czna kwota odsetek',0),(383838,10663,'bg','ÐœÐµÑÐµÑ‡Ð½Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ð»Ð¸Ñ…Ð²Ð¸Ñ‚Ðµ',0),(383839,10663,'ur','Ù…Ø§ÛØ§Ù†Û Ø³ÙˆØ¯ Ú©ÛŒ Ø±Ù‚Ù…',0),(383840,10663,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(383841,10663,'vi','tiá»n lÃ£i hÃ ng thÃ¡ng',0),(383842,10663,'af','Maandelikse rente bedrag',0),(383843,10663,'ro','Lunar suma de interes',0),(383844,10663,'et','Iga kuu intressisumma',0),(383845,10663,'si','MeseÄni znesek obresti',0),(383846,10663,'ba','Bulanan jumlah bunga',0),(383847,10663,'nl','Maandelijkse rentebedrag',0),(383848,10663,'fi','Kuukausittain Korkosumma',0),(383849,10663,'no','MÃ¥nedlig rentebelÃ¸pet',0),(383850,10663,'da','MÃ¥nedlige rentebelÃ¸bet',0),(383851,10663,'ko','ì›” ì´ìž ì§€ê¸‰ì•¡',0),(383852,10663,'he','×¡×›×•× ×¨×™×‘×™×ª ×—×•×“×©×™',0),(383853,10663,'el','ÎœÎ·Î½Î¹Î±Î¯Î¿ Ï€Î¿ÏƒÏŒ Ï„ÏŒÎºÎ¿Ï…',0),(383854,10663,'zh','æ¯æœˆåˆ©æ¯é‡‘é¢\r\n',0),(383855,10663,'sv','RÃ¤nta mÃ¥nadsbelopp',0),(383856,10663,'it','Importo mensile di interesse',0),(383857,10663,'tl','',0),(383858,10663,'th','à¸¢à¸­à¸”à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¸£à¸²à¸¢à¹€à¸”à¸·à¸­à¸™',0),(383859,10663,'hi','à¤®à¤¾à¤¸à¤¿à¤• à¤¬à¥à¤¯à¤¾à¤œ à¤°à¤¾à¤¶à¤¿',0),(383860,10663,'ms','Jumlah faedah bulanan',0),(383861,10663,'ar','Ø±Ø¨Ø§ - Ø²Ù‚Ù‘ÙˆÙ…',0),(383862,10663,'fr','Montant des intÃ©rÃªts mensuels',0),(383863,10663,'jp','æ¯Žæœˆã®åˆ©å­é¡',0),(383864,10663,'pt','Montante de juros mensal',0),(383865,10663,'ru','Ð•Ð¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ñ‹Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(383866,10663,'es','Monto de InterÃ©s Mensual',0),(383867,10663,'de','Monatliche Zinsbetrag',0),(383868,10663,'en','Monthly Interest Amount',0),(383869,10664,'is','',0),(383870,10664,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³Ø±Ù…Ø§ÙŠÙ‡ Ø§ÙˆÙ„ÙŠÙ‡ Ù…ÙˆØ³Ø³Ø§Ù† Ø´Ø±Ú©Øª Ù…Ø§Ù‡Ø§Ù†Ù‡ ',0),(383871,10664,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³Ø±Ù…Ø§ÙŠÙ‡ Ø§ÙˆÙ„ÙŠÙ‡ Ù…ÙˆØ³Ø³Ø§Ù† Ø´Ø±Ú©Øª Ù…Ø§Ù‡Ø§Ù†Ù‡ ',0),(383872,10664,'tr','AylÄ±k anapara tutarÄ±',0),(383873,10664,'pl','MiesiÄ™czne kwoty gÅ‚Ã³wnej',0),(383874,10664,'bg','ÐœÐµÑÐµÑ‡Ð½Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ð³Ð»Ð°Ð²Ð½Ð¸Ñ†Ð°Ñ‚Ð°',0),(383875,10664,'ur','Ù¾Ø±Ù†Ø³Ù¾Ù„ Ú©Û’ Ù…Ø§ÛØ§Ù†Û Ø±Ù‚Ù…',0),(383876,10664,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð°',0),(383877,10664,'vi','tiá»n gá»‘c hÃ ng thÃ¡ng',0),(383878,10664,'af','Maandelikse bedrag van die skoolhoof',0),(383879,10664,'ro','Lunar suma de principalul',0),(383880,10664,'et','Igakuine pÃµhiosa',0),(383881,10664,'si','MeseÄni znesek glavnice',0),(383882,10664,'ba','Bulanan jumlah kepala',0),(383883,10664,'nl','Maandelijks bedrag van de hoofdsom',0),(383884,10664,'fi','Rehtori kuukausimÃ¤Ã¤rÃ¤n',0),(383885,10664,'no','Rektor mÃ¥nedsinntekt',0),(383886,10664,'da','MÃ¥nedlige Principal belÃ¸b',0),(383887,10664,'ko','ë§¤ì›” ì›ê¸ˆ ê¸ˆì•¡',0),(383888,10664,'he','×¡×›×•× ×—×•×“×©×™ ×©×œ ×”×ž× ×”×œ',0),(383889,10664,'el','ÎœÎ·Î½Î¹Î±Î¯Î¿ Ï€Î¿ÏƒÏŒ ÎºÎµÏ†Î±Î»Î±Î¯Î¿Ï…',0),(383890,10664,'zh','æ¯æœˆæœ¬é‡‘\r\n',0),(383891,10664,'sv','Rektor mÃ¥nadsbelopp',0),(383892,10664,'it','Importo mensile Principal',0),(383893,10664,'tl','',0),(383894,10664,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸•à¹‰à¸™à¸£à¸²à¸¢à¹€à¸”à¸·à¸­à¸™',0),(383895,10664,'hi','à¤®à¤¾à¤¸à¤¿à¤• à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤ªà¥à¤°à¤¾à¤šà¤¾à¤°à¥à¤¯',0),(383896,10664,'ms','Jumlah prinsipal bulanan',0),(383897,10664,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ø£Ø³Ø§Ø³ÙŠ Ø§Ù„Ø´Ù‡Ø±ÙŠ',0),(383898,10664,'fr','Montant mensuel de capital',0),(383899,10664,'jp','æ¯Žæœˆã®å…ƒæœ¬é‡‘é¡',0),(383900,10664,'pt','Quantia mensal Principal',0),(383901,10664,'ru','Ð•Ð¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ð°Ñ ÑÑƒÐ¼Ð¼Ð° Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð³Ð¾',0),(383902,10664,'es','Monto de Principal Mensual',0),(383903,10664,'de','Monatliche getilgte',0),(383904,10664,'en','Monthly Principal Amount',0),(383905,10665,'is','',0),(383906,10665,'dr','Ø®Ø§Ù„Øµ Ù…Ø§Ù†Ø¯Ù‡ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ',0),(383907,10665,'pr','Ø®Ø§Ù„Øµ Ù…Ø§Ù†Ø¯Ù‡ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ',0),(383908,10665,'tr','NET taÅŸÄ±ma bakiyesi',0),(383909,10665,'pl','RÃ³wnowagi bilansowej netto',0),(383910,10665,'bg','ÐÐµÑ‚Ð½Ð° Ð±Ð°Ð»Ð°Ð½ÑÐ¾Ð²Ð° Ð±Ð°Ð»Ð°Ð½Ñ',0),(383911,10665,'ur','Ø¬Ø§Ù„ Ù¾Ú©Ú‘Û’ ÛÙˆØ¦Û’ ØªÙˆØ§Ø²Ù†',0),(383912,10665,'sr','ÐÐµÑ‚Ð¾ Ð½Ð¾ÑÐ¸ ÑÐ°Ð»Ð´Ð¾',0),(383913,10665,'vi','Sá»‘ dÆ° thá»±c táº¿ chuyá»ƒn sang',0),(383914,10665,'af','Netto billike balans',0),(383915,10665,'ro','Soldul net contabilÄƒ',0),(383916,10665,'et','Bilansilist saldot',0),(383917,10665,'si','Neto knjigovodsko stanje',0),(383918,10665,'ba','Saldo membawa bersih',0),(383919,10665,'nl','Netto boekwaarde saldo',0),(383920,10665,'fi','Kuljettaa nettomÃ¤Ã¤rÃ¤',0),(383921,10665,'no','BÃ¦rer nettosaldo',0),(383922,10665,'da','Netto regnskabsmÃ¦ssige Balance',0),(383923,10665,'ko','Net ìš´ë°˜ ëŒ€ì°¨',0),(383924,10665,'he','×ž××–×Ÿ × ×©×™××” × ×˜×•',0),(383925,10665,'el','ÎšÎ±Î¸Î±ÏÎ¿Ï Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚ Ï…Ï€Î¿Î»Î¿Î¯Ï€Î¿Ï…',0),(383926,10665,'zh','è´¦é¢å‡€å€¼ä½™é¢\r\n',0),(383927,10665,'sv','Netto redovisat saldo',0),(383928,10665,'it','Saldo netto contabile',0),(383929,10665,'tl','',0),(383930,10665,'th','à¸”à¸¸à¸¥à¸ªà¸¸à¸—à¸˜à¸´à¸–à¸·à¸­à¸„à¸£à¸­à¸‡',0),(383931,10665,'hi','à¤¨à¥‡à¤Ÿ à¤ªà¥‡à¤Ÿ à¤¸à¤‚à¤¤à¥à¤²à¤¨',0),(383932,10665,'ms','Baki dibawa bersih',0),(383933,10665,'ar','ØµØ§ÙÙŠ Ø§Ù„Ø±ØµÙŠØ¯ ØªØ­Ù…Ù„',0),(383934,10665,'fr','Solde comptable',0),(383935,10665,'jp','æ­£å‘³å¸³ç°¿æ®‹é«˜',0),(383936,10665,'pt','Saldo contabilÃ­stico',0),(383937,10665,'ru','Ð§Ð¸ÑÑ‚Ñ‹Ð¹ Ð¾ÑÑ‚Ð°Ñ‚Ð¾Ðº Ð±Ð°Ð»Ð°Ð½ÑÐ¾Ð²Ð¾Ð¹',0),(383938,10665,'es','Balance Neto para llevar',0),(383939,10665,'de','Buchwert Saldo',0),(383940,10665,'en','Net Carrying Balance',0),(383941,10666,'is','',0),(383942,10666,'dr','Ù…Ø§Ù†Ø¯Ù‡ Ø§ØµÙ„ÙŠ ÙˆØ§Ù…',0),(383943,10666,'pr','Ù…Ø§Ù†Ø¯Ù‡ Ø§ØµÙ„ÙŠ ÙˆØ§Ù…',0),(383944,10666,'tr','Orijinal kredi dengesi',0),(383945,10666,'pl','Oryginalny salda kredytu',0),(383946,10666,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÐµÐ½ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð±Ð°Ð»Ð°Ð½Ñ',0),(383947,10666,'ur','Ø§ØµÙ„ Ù‚Ø±Ø¶ ØªÙˆØ§Ø²Ù†',0),(383948,10666,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ ÑÐ°Ð»Ð´Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(383949,10666,'vi','cÃ¢n Ä‘á»‘i ná»£ gá»‘c',0),(383950,10666,'af','Oorspronklike lening balans',0),(383951,10666,'ro','Original Soldul creditului',0),(383952,10666,'et','Algne laenujÃ¤Ã¤k',0),(383953,10666,'si','Original posojila bilance',0),(383954,10666,'ba','Asli saldo pinjaman',0),(383955,10666,'nl','Oorspronkelijke lening saldo',0),(383956,10666,'fi','AlkuperÃ¤inen laina tasapaino',0),(383957,10666,'no','Opprinnelige lÃ¥nesaldo',0),(383958,10666,'da','Oprindelige lÃ¥n Balance',0),(383959,10666,'ko','ì›ëž˜ ëŒ€ì¶œ ìž”ì•¡',0),(383960,10666,'he','×™×ª×¨×ª ×”×”×œ×•×•××” ×”×ž×§×•×¨×™×ª',0),(383961,10666,'el','Î‘ÏÏ‡Î¹ÎºÏŒ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ Ï„Î¿Ï… Î´Î±Î½ÎµÎ¯Î¿Ï…',0),(383962,10666,'zh','åŽŸè´·æ¬¾ä½™é¢\r\n',0),(383963,10666,'sv','Ursprungliga lÃ¥net balans',0),(383964,10666,'it','Saldo del prestito originale',0),(383965,10666,'tl','',0),(383966,10666,'th','à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¹€à¸”à¸´à¸¡',0),(383967,10666,'hi','à¤®à¥‚à¤² à¤‹à¤£ à¤¶à¥‡à¤·',0),(383968,10666,'ms','Baki pinjaman asal',0),(383969,10666,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…ØªØ¨Ù‚ÙŠ Ù…Ù† Ø§Ù„Ù‚Ø±Ø¶ Ø§Ù„Ø£ØµÙ„ÙŠ',0),(383970,10666,'fr','Solde du prÃªt initial',0),(383971,10666,'jp','å…ƒã®ãƒ­ãƒ¼ãƒ³æ®‹é«˜',0),(383972,10666,'pt','Saldo do emprÃ©stimo original',0),(383973,10666,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¾ÑÑ‚Ð°Ñ‚Ð¾Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(383974,10666,'es','Saldo del Prestamo Original',0),(383975,10666,'de','Original Kreditsaldo',0),(383976,10666,'en','Original Loan Balance',0),(383977,10667,'is','',0),(383978,10667,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø±ÙˆØ² Ø§Ø² Ù…Ø§Ù‡ ',0),(383979,10667,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø±ÙˆØ² Ø§Ø² Ù…Ø§Ù‡ ',0),(383980,10667,'tr','Ã–deme gÃ¼nÃ¼, ayÄ±n',0),(383981,10667,'pl','PÅ‚atnoÅ›ci dzieÅ„ miesiÄ…ca',0),(383982,10667,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð´ÐµÐ½ Ð½Ð° Ð¼ÐµÑÐµÑ†',0),(383983,10667,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¯Ù† Ù…ÛÛŒÙ†Û’ Ú©Û’',0),(383984,10667,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ð´Ð°Ð½ Ñƒ Ð¼ÐµÑÐµÑ†Ñƒ',0),(383985,10667,'vi','NgÃ y thanh toÃ¡n cá»§a thÃ¡ng',0),(383986,10667,'af','Betalingsdag van Maand',0),(383987,10667,'ro','Plata zi a lunii',0),(383988,10667,'et','Tasumise pÃ¤ev kuu',0),(383989,10667,'si','PlaÄilni dan meseca',0),(383990,10667,'ba','Bulan pembayaran',0),(383991,10667,'nl','Betaling dag van maand',0),(383992,10667,'fi','Kuukauden maksupÃ¤ivÃ¤',0),(383993,10667,'no','Betalingsdagen i mÃ¥neden',0),(383994,10667,'da','Betalingsdagen mÃ¥nedens',0),(383995,10667,'ko','ë‹¬ì˜ ì§€ë¶ˆ ì¼',0),(383996,10667,'he','×™×•× ×”×ª×©×œ×•× ×©×œ ×—×•×“×©',0),(383997,10667,'el','Î—Î¼Î­ÏÎ± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï„Î¿Ï… Î¼Î®Î½Î±',0),(383998,10667,'zh','æœˆä»˜æ¬¾æ—¥\r\n',0),(383999,10667,'sv','Betalningsdagen i mÃ¥naden',0),(384000,10667,'it','Giorno di pagamento del mese',0),(384001,10667,'tl','',0),(384002,10667,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¹€à¸”à¸·à¸­à¸™',0),(384003,10667,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨',0),(384004,10667,'ms','Pembayaran hari bulan',0),(384005,10667,'ar','ÙŠÙˆÙ… Ø§Ù„Ø¯ÙØ¹ Ù„Ø´Ù‡Ø±',0),(384006,10667,'fr','Jour de paiement du mois',0),(384007,10667,'jp','æ¯Žæœˆã®æ”¯æ‰•ã„ã®æ—¥',0),(384008,10667,'pt','Dia de pagamento do mÃªs',0),(384009,10667,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ Ð”ÐµÐ½ÑŒ ÐœÐµÑÑÑ†Ð°',0),(384010,10667,'es','Pago DÃ­a del MÃ©s',0),(384011,10667,'de','Zahlungstag des Monats',0),(384012,10667,'en','Payment Day of Month',0),(384013,10668,'is','',0),(384014,10668,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø´Ø±Ø§ÙŠØ· ',0),(384015,10668,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø´Ø±Ø§ÙŠØ· ',0),(384016,10668,'tr','ÅžartlarÄ± ayrÄ±ntÄ±larÄ±',0),(384017,10668,'pl','SzczegÃ³Å‚y warunkÃ³w',0),(384018,10668,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(384019,10668,'ur','Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(384020,10668,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¾ ÑƒÑÐ»Ð¾Ð²Ð¸Ð¼Ð°',0),(384021,10668,'vi','chi tiáº¿t cÃ¡c danh má»¥c',0),(384022,10668,'af','Bepalings besonderhede',0),(384023,10668,'ro','Termeni detalii',0),(384024,10668,'et','Tingimuste Ã¼ksikasjad',0),(384025,10668,'si','Pogoji podrobnosti',0),(384026,10668,'ba','Istilah rincian',0),(384027,10668,'nl','Voorwaarden Details',0),(384028,10668,'fi','Koskevat tiedot.',0),(384029,10668,'no','VilkÃ¥rene detaljer',0),(384030,10668,'da','VilkÃ¥r detaljer',0),(384031,10668,'ko','ì¡°ê±´ ì„¸ë¶€ ì‚¬í•­',0),(384032,10668,'he','×ž×•× ×—×™ ×¤×¨×˜×™×',0),(384033,10668,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï„Ï‰Î½ ÏŒÏÏ‰Î½',0),(384034,10668,'zh','æ¡æ¬¾è¯¦æƒ…\r\n',0),(384035,10668,'sv','Villkor Detaljer',0),(384036,10668,'it','Termini particolari',0),(384037,10668,'tl','',0),(384038,10668,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚',0),(384039,10668,'hi','à¤¨à¤¿à¤¯à¤® à¤µà¤¿à¤µà¤°à¤£',0),(384040,10668,'ms','Butir-butir terma-terma',0),(384041,10668,'ar','ØªÙØ§ØµÙŠÙ„ Ø´Ø±ÙˆØ·',0),(384042,10668,'fr','DÃ©tails des conditions',0),(384043,10668,'jp','æ¡ä»¶ã®è©³ç´°',0),(384044,10668,'pt','Detalhes de termos',0),(384045,10668,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(384046,10668,'es','Detalles de TÃ©rminos',0),(384047,10668,'de','Begriffe-Informationen',0),(384048,10668,'en','Terms Details',0),(384049,10669,'is','',0),(384050,10669,'dr','Ø¯Ø±Ø¯Ø³Øª Ø³Ø§Ø®Øª',0),(384051,10669,'pr','Ø¯Ø±Ø¯Ø³Øª Ø³Ø§Ø®Øª',0),(384052,10669,'tr','YapÄ±m aÅŸamasÄ±nda',0),(384053,10669,'pl','W budowie',0),(384054,10669,'bg','Ð’ ÑÑ‚Ñ€Ð¾ÐµÐ¶',0),(384055,10669,'ur','Ø²ÛŒØ± ØªØ¹Ù…ÛŒØ±',0),(384056,10669,'sr','Ð£ Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÐ¸',0),(384057,10669,'vi','Äang xÃ¢y dá»±ng',0),(384058,10669,'af','Onder Konstruksie',0),(384059,10669,'ro','ÃŽn construcÅ£ie',0),(384060,10669,'et','ValmimisjÃ¤rgus',0),(384061,10669,'si','V gradnji',0),(384062,10669,'ba','Di bawah konstruksi',0),(384063,10669,'nl','In aanbouw',0),(384064,10669,'fi','Rakenteilla',0),(384065,10669,'no','Under bygging',0),(384066,10669,'da','Under opfÃ¸relse',0),(384067,10669,'ko','ê³µì‚¬ì¤‘',0),(384068,10669,'he','×‘×‘× ×™×™×”',0),(384069,10669,'el','Î¥Ï€ÏŒ ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(384070,10669,'zh','æ­£åœ¨å»ºè®¾ä¸­\r\n',0),(384071,10669,'sv','Under konstruktion',0),(384072,10669,'it','In costruzione',0),(384073,10669,'tl','',0),(384074,10669,'th','à¸à¸³à¸¥à¸±à¸‡à¸à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡',0),(384075,10669,'hi','à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤¤à¤¹à¤¤',0),(384076,10669,'ms','Dalam pembinaan',0),(384077,10669,'ar','ØªØ­Øª Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(384078,10669,'fr','En cours de Construction',0),(384079,10669,'jp','å·¥äº‹ä¸­',0),(384080,10669,'pt','Em construÃ§Ã£o',0),(384081,10669,'ru','Ð¡Ñ‚Ð°Ð´Ð¸Ð¸ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(384082,10669,'es','Bajo ConstrucciÃ³n',0),(384083,10669,'de','Im Bau',0),(384084,10669,'en','Under Construction',0),(384085,10670,'is','',0),(384086,10670,'dr','(Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡Ù‡Ø§',0),(384087,10670,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ (Ø¯Ø³ØªÙ…Ø²Ø¯Ù‡Ø§',0),(384088,10670,'tr','Ã–demelerin toplamÄ±nÄ±',0),(384089,10670,'pl','DodaÄ‡ pÅ‚atnoÅ›ci',0),(384090,10670,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(384091,10670,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(384092,10670,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(384093,10670,'vi','ThÃªm thanh toÃ¡n',0),(384094,10670,'af','Betaling Byvoeg',0),(384095,10670,'ro','Adauga plÄƒÅ£i',0),(384096,10670,'et','Lisada maksed',0),(384097,10670,'si','Dodaj plaÄila',0),(384098,10670,'ba','Tambahkan pembayaran',0),(384099,10670,'nl','Toevoegen van betalingen',0),(384100,10670,'fi','LisÃ¤Ã¤ maksut',0),(384101,10670,'no','Legge til betalinger',0),(384102,10670,'da','TilfÃ¸je betalinger',0),(384103,10670,'ko','ì¶”ê°€ ì§€ë¶ˆ',0),(384104,10670,'he','×”×•×¡×£ ×ª×©×œ×•×ž×™×',0),(384105,10670,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(384106,10670,'zh','å¢žåŠ ä»˜æ¬¾\r\n',0),(384107,10670,'sv','LÃ¤gg till betalningar',0),(384108,10670,'it','Aggiungere i pagamenti',0),(384109,10670,'tl','',0),(384110,10670,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(384111,10670,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(384112,10670,'ms','Tambah bayaran',0),(384113,10670,'ar','Ø£Ø¶Ù Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(384114,10670,'fr','Ajouter des paiements',0),(384115,10670,'jp','æ”¯æ‰•ã„ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(384116,10670,'pt','Adicionar pagamentos',0),(384117,10670,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸',0),(384118,10670,'es','Agregar Pagos',0),(384119,10670,'de','HinzufÃ¼gen von Zahlungen',0),(384120,10670,'en','Add Payments',0),(384121,10671,'is','',0),(384122,10671,'dr','(Ø­Ø±Ø§Ø¬',0),(384123,10671,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´ (Ø­Ø±Ø§Ø¬',0),(384124,10671,'tr','SatÄ±lÄ±k Ekle',0),(384125,10671,'pl','DodaÄ‡ sprzedaÅ¼',0),(384126,10671,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(384127,10671,'ur','ÙØ±ÙˆØ®Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(384128,10671,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(384129,10671,'vi','ThÃªm BÃ¡n hÃ ng',0),(384130,10671,'af','Verkope Byvoeg',0),(384131,10671,'ro','Adauga vÃ¢nzare',0),(384132,10671,'et','Lisada mÃ¼Ã¼k',0),(384133,10671,'si','PoveÄati prodajo',0),(384134,10671,'ba','Tambahkan dijual',0),(384135,10671,'nl','Verkoop toevoegen',0),(384136,10671,'fi','LisÃ¤tÃ¤ myyntiÃ¤',0),(384137,10671,'no','Legge til salgs',0),(384138,10671,'da','TilfÃ¸je salg',0),(384139,10671,'ko','ì¶”ê°€ íŒë§¤',0),(384140,10671,'he','×œ×”×•×¡×™×£ ×œ×ž×›×™×¨×”',0),(384141,10671,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ Ï€ÏŽÎ»Î·ÏƒÎ·',0),(384142,10671,'zh','å¢žåŠ é”€å”®\r\n',0),(384143,10671,'sv','LÃ¤gg till salu',0),(384144,10671,'it','Aggiungi vendita',0),(384145,10671,'tl','',0),(384146,10671,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸²à¸£à¸‚à¸²à¸¢',0),(384147,10671,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(384148,10671,'ms','Menambah jualan',0),(384149,10671,'ar','Ø£Ø¶Ù Ø§Ù„Ø¨ÙŠØ¹',0),(384150,10671,'fr','Ajouter vente',0),(384151,10671,'jp','å£²å´ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(384152,10671,'pt','Adicionar venda',0),(384153,10671,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°',0),(384154,10671,'es','Agregar Venta',0),(384155,10671,'de','Verkauf hinzufÃ¼gen',0),(384156,10671,'en','Add Sale',0),(384157,10672,'is','',0),(384158,10672,'dr','ÙˆØ¶Ø¹ÙŠØª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(384159,10672,'pr','ÙˆØ¶Ø¹ÙŠØª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(384160,10672,'tr','Fatura durumu',0),(384161,10672,'pl','Stan rachunku',0),(384162,10672,'bg','Ð‘Ð¸Ð» ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(384163,10672,'ur','Ø¨Ù„ Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(384164,10672,'sr','Ð‘Ð¸Ð» Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(384165,10672,'vi','TÃ¬nh tráº¡ng',0),(384166,10672,'af','Wetsontwerp Status',0),(384167,10672,'ro','Statutul de Bill',0),(384168,10672,'et','Arve olek',0),(384169,10672,'si','Status zakona',0),(384170,10672,'ba','Bill Status',0),(384171,10672,'nl','Bill Status',0),(384172,10672,'fi','Laskun tila',0),(384173,10672,'no','Bill Status',0),(384174,10672,'da','Bill Status',0),(384175,10672,'ko','ë¹Œ ìƒíƒœ',0),(384176,10672,'he','×ž×¦×‘ ×—×©×‘×•×Ÿ',0),(384177,10672,'el','Bill ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(384178,10672,'zh','å¸å•çŠ¶æ€\r\n',0),(384179,10672,'sv','Bill Status',0),(384180,10672,'it','Bill Status',0),(384181,10672,'tl','',0),(384182,10672,'th','à¸ªà¸–à¸²à¸™à¸°à¸‚à¸­à¸‡à¸•à¸±à¹‹à¸§',0),(384183,10672,'hi','à¤¬à¤¿à¤² à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(384184,10672,'ms','Rang undang-undang Status',0),(384185,10672,'ar','Ù…Ø±ÙƒØ² Ø¨ÙŠÙ„',0),(384186,10672,'fr','Statut du projet de loi',0),(384187,10672,'jp','è«‹æ±‚æ›¸ã®ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(384188,10672,'pt','Bill Status',0),(384189,10672,'ru','Ð‘Ð¸Ð»Ð» ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(384190,10672,'es','Estado de la Factura',0),(384191,10672,'de','Bill-Status',0),(384192,10672,'en','Bill Status',0),(384193,10673,'is','',0),(384194,10673,'dr','(Ø§Ù†Ù‚Ø·Ø§Ø¹) ÙˆØ§Ù…',0),(384195,10673,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙƒÙˆØªØ§Ù‡ Ø³Ø§Ø²ÙŠ (Ø§Ù†Ù‚Ø·Ø§Ø¹) ÙˆØ§Ù…',0),(384196,10673,'tr','Kredi talihsizlikti miktarÄ±',0),(384197,10673,'pl','Ograniczenie kwoty poÅ¼yczki',0),(384198,10673,'bg','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡Ð°Ð²Ð°Ð½Ðµ Ñ€Ð°Ð·Ð¼ÐµÑ€Ð° Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(384199,10673,'ur','Ù‚Ø±Ø¶ Ú©ÛŒ Ø±Ù‚Ù… Ú©ÙˆØ±Ù¹Ø§ÛŒÙ„Ù…ÛŒÙ†Ù¹',0),(384200,10673,'sr','Ð¦ÑƒÑ€Ñ‚Ð°Ð¸Ð»Ð¼ÐµÐ½Ñ‚ Ð¸Ð·Ð½Ð¾Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(384201,10673,'vi','sá»‘ khoáº£n vay rÃºt bá»›t',0),(384202,10673,'af','Leningsbedrag Curtailment',0),(384203,10673,'ro','Suma de restricÈ›ionare Ã®mprumut',0),(384204,10673,'et','Laenusumma piiramist',0),(384205,10673,'si','Znesek posojila skrÄenja',0),(384206,10673,'ba','Pengurangan jumlah pinjaman',0),(384207,10673,'nl','Het bedrag van de belangrijke inperking van lening',0),(384208,10673,'fi','Supistamisen lainamÃ¤Ã¤rÃ¤',0),(384209,10673,'no','LÃ¥nebelÃ¸pet forkortelse',0),(384210,10673,'da','IndskrÃ¦nkning heraf lÃ¥nebelÃ¸bet',0),(384211,10673,'ko','ëŒ€ì¶œ ì ˆê° ê¸ˆì•¡',0),(384212,10673,'he','×¡×›×•× ×”×”×œ×•×•××” ×œ×¤×’×™×¢×”',0),(384213,10673,'el','Î ÎµÏÎ¹ÎºÎ¿Ï€Î® Ï€Î¿ÏƒÎ¿Ï Î´Î±Î½ÎµÎ¯Î¿Ï…',0),(384214,10673,'zh','è´·æ¬¾ç¼©å‡é¢\r\n',0),(384215,10673,'sv','LÃ¥nebeloppet inskrÃ¤nkning',0),(384216,10673,'it','Importo del prestito Curtailment',0),(384217,10673,'tl','',0),(384218,10673,'th','à¸ˆà¸³à¸™à¸§à¸™à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰ Curtailment',0),(384219,10673,'hi','à¤‹à¤£ Curtailment à¤°à¤¾à¤¶à¤¿',0),(384220,10673,'ms','Jumlah pinjaman PEMENDEKAN',0),(384221,10673,'ar','ØªÙ‚Ù„ÙŠØµ Ø§Ù„Ù‚Ø±Ø¶',0),(384222,10673,'fr','Montant de la rÃ©duction',0),(384223,10673,'jp','èžè³‡å‰Šæ¸›é¡',0),(384224,10673,'pt','Montante do emprÃ©stimo cerceamento',0),(384225,10673,'ru','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸Ðµ ÑÑƒÐ¼Ð¼Ñ‹ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(384226,10673,'es','Monto de Recorte del Prestamo',0),(384227,10673,'de','Beschneidung Darlehensbetrag',0),(384228,10673,'en','Loan Curtailment Amount',0),(384229,10674,'is','',0),(384230,10674,'dr','ÙˆØ§Ù… Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(384231,10674,'pr','ÙˆØ§Ù… Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(384232,10674,'tr','Kredi baÅŸarÄ±yla silindi',0),(384233,10674,'pl','PoÅ¼yczki przesâ”‚anie',0),(384234,10674,'bg','Ð—Ð°ÐµÐ¼, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(384235,10674,'ur','Ù‚Ø±Ø¶ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(384236,10674,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(384237,10674,'vi','XÃ³a khoáº£n vay thÃ nh cÃ´ng',0),(384238,10674,'af','Skrap van Lening Suksesvol ',0),(384239,10674,'ro','ÃŽmprumut eliminÄƒ cu succes',0),(384240,10674,'et','Edukalt kustutatud laen',0),(384241,10674,'si','Posojilo uspeÅ¡no izbrisana',0),(384242,10674,'ba','Pinjaman dihapus berhasil',0),(384243,10674,'nl','Lening met succes verwijderd',0),(384244,10674,'fi','Lainan poistettu',0),(384245,10674,'no','LÃ¥n slettet',0),(384246,10674,'da','LÃ¥n slettet',0),(384247,10674,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ëŒ€ì¶œ',0),(384248,10674,'he','×”×œ×•×•××” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(384249,10674,'el','Î”Î¬Î½ÎµÎ¹Î¿ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(384250,10674,'zh','è´·æ¬¾æˆåŠŸåˆ é™¤\r\n',0),(384251,10674,'sv','LÃ¥n raderades',0),(384252,10674,'it','Prestito eliminato con successo',0),(384253,10674,'tl','',0),(384254,10674,'th','à¸à¸¹à¹‰à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(384255,10674,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤‹à¤£',0),(384256,10674,'ms','Pinjaman dihapuskan dengan jayanya',0),(384257,10674,'ar','Ø­Ø°Ù Ø§Ù„Ù‚Ø±Ø¶ Ø¨Ù†Ø¬Ø§Ø­',0),(384258,10674,'fr','PrÃªt supprimÃ© avec succÃ¨s',0),(384259,10674,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸè²¸ä»˜ã‘é‡‘',0),(384260,10674,'pt','EmprÃ©stimo apagado com sucesso',0),(384261,10674,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(384262,10674,'es','Prestamo Eliminado Exitosamente',0),(384263,10674,'de','Darlehen erfolgreich gelÃ¶scht',0),(384264,10674,'en','Loan Deleted Successfully',0),(384265,10675,'is','',0),(384266,10675,'dr','(Ù¾Ø±Ø¯Ø§Ø®Øª) ÙˆØ§Ù… ',0),(384267,10675,'pr','Ø§Ù‚Ø³Ø§Ø·(Ù¾Ø±Ø¯Ø§Ø®Øª) ÙˆØ§Ù… ',0),(384268,10675,'tr','Kredi Ã¶demeleri',0),(384269,10675,'pl','WypÅ‚aty poÅ¼yczki',0),(384270,10675,'bg','Ð—Ð°ÐµÐ¼ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(384271,10675,'ur','Ù‚Ø±Ø¶ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(384272,10675,'sr','Ð¢Ñ€Ð°Ð½ÑˆÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(384273,10675,'vi','thanh toÃ¡n khoáº£n vay',0),(384274,10675,'af','Lening Betalings',0),(384275,10675,'ro','PlÄƒÅ£i de Ã®mprumut',0),(384276,10675,'et','Laenumaksete',0),(384277,10675,'si','Posojilo plaÄila',0),(384278,10675,'ba','Pembayaran pinjaman',0),(384279,10675,'nl','Leningsbetalingen',0),(384280,10675,'fi','Lainan maksut',0),(384281,10675,'no','LÃ¥net utbetalinger',0),(384282,10675,'da','LÃ¥n betalinger',0),(384283,10675,'ko','ëŒ€ì¶œê¸ˆ ìƒí™˜',0),(384284,10675,'he','×ª×©×œ×•×ž×™× ×œ×”×—×–×¨ ×”×”×œ×•×•××”',0),(384285,10675,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Î´Î±Î½ÎµÎ¯Î¿Ï…',0),(384286,10675,'zh','è´·æ¬¾æ”¯ä»˜\r\n',0),(384287,10675,'sv','LÃ¥nebetalningar',0),(384288,10675,'it','Pagamenti di prestito',0),(384289,10675,'tl','',0),(384290,10675,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰',0),(384291,10675,'hi','à¤‹à¤£ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(384292,10675,'ms','Bayaran pinjaman',0),(384293,10675,'ar','Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù‚Ø±Ø¶',0),(384294,10675,'fr','Paiements de prÃªt',0),(384295,10675,'jp','ãƒ­ãƒ¼ãƒ³ã®æ”¯æ‰•ã„',0),(384296,10675,'pt','Pagamentos de emprÃ©stimo',0),(384297,10675,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ Ð¿Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ñƒ',0),(384298,10675,'es','Pagos de Prestamo',0),(384299,10675,'de','Kreditzahlungen',0),(384300,10675,'en','Loan Payments',0),(384301,10676,'is','',0),(384302,10676,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙˆØ§Ù… ',0),(384303,10676,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙˆØ§Ù… ',0),(384304,10676,'tr','Kredi gÃ¼ncelleÅŸtirme',0),(384305,10676,'pl','Aktualizacja poÅ¼yczki',0),(384306,10676,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð·Ð°ÐµÐ¼',0),(384307,10676,'ur','Ù‚Ø±Ø¶ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(384308,10676,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(384309,10676,'vi','cáº­p nháº­t khoáº£n vay',0),(384310,10676,'af','Lening Opdateer',0),(384311,10676,'ro','ÃŽmprumut de actualizare',0),(384312,10676,'et','Laenu Update',0),(384313,10676,'si','Posojilo posodobitev',0),(384314,10676,'ba','Pinjaman Update',0),(384315,10676,'nl','Lening Update',0),(384316,10676,'fi','Lainan pÃ¤ivitys',0),(384317,10676,'no','LÃ¥n oppdatering',0),(384318,10676,'da','LÃ¥n opdatering',0),(384319,10676,'ko','ëŒ€ì¶œ ì—…ë°ì´íŠ¸',0),(384320,10676,'he','×¢×“×›×•×Ÿ ×”×œ×•×•××”',0),(384321,10676,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Î´Î±Î½ÎµÎ¯Î¿Ï…',0),(384322,10676,'zh','è´·æ¬¾æ›´æ–°\r\n',0),(384323,10676,'sv','LÃ¥n uppdatering',0),(384324,10676,'it','Aggiornamento prestito',0),(384325,10676,'tl','',0),(384326,10676,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰',0),(384327,10676,'hi','à¤‹à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(384328,10676,'ms','Kemaskini pinjaman',0),(384329,10676,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù‚Ø±Ø¶',0),(384330,10676,'fr','Mise Ã  jour du prÃªt',0),(384331,10676,'jp','ãƒ­ãƒ¼ãƒ³æ›´æ–°',0),(384332,10676,'pt','AtualizaÃ§Ã£o de emprÃ©stimo',0),(384333,10676,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(384334,10676,'es','ActualizaciÃ³n de Prstamo',0),(384335,10676,'de','Darlehen-Update',0),(384336,10676,'en','Loan Update',0),(384337,10677,'is','',0),(384338,10677,'dr','Ø¬Ø±Ø¦ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(384339,10677,'pr','Ø¬Ø±Ø¦ÙŠØ§Øª ÙØ±ÙˆØ´ ',0),(384340,10677,'tr','SatÄ±ÅŸ detayÄ±',0),(384341,10677,'pl','SzczegÃ³Å‚y sprzedaÅ¼y',0),(384342,10677,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÐµÑ‚Ð°Ð¹Ð»',0),(384343,10677,'ur','Ø³ÛŒÙ„Ø² ØªÙØµÛŒÙ„',0),(384344,10677,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ð´ÐµÑ‚Ð°Ñ™',0),(384345,10677,'vi','Chi tiáº¿t bÃ¡n hÃ ng',0),(384346,10677,'af','Verkope Besonderhede',0),(384347,10677,'ro','VÃ¢nzÄƒri detaliu',0),(384348,10677,'et','MÃ¼Ã¼gi Detail',0),(384349,10677,'si','Prodaje podrobno',0),(384350,10677,'ba','Detail penjualan',0),(384351,10677,'nl','Verkoop Detail',0),(384352,10677,'fi','Myynnin tiedot',0),(384353,10677,'no','Salg detaljer',0),(384354,10677,'da','Salg detaljer',0),(384355,10677,'ko','íŒë§¤ ì„¸ë¶€ ì‚¬í•­',0),(384356,10677,'he','×¤×¨×˜×™ ×ž×›×™×¨×•×ª',0),(384357,10677,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(384358,10677,'zh','é”€å”®è¯¦æƒ…\r\n',0),(384359,10677,'sv','FÃ¶rsÃ¤ljning detalj',0),(384360,10677,'it','Vendita dettaglio',0),(384361,10677,'tl','',0),(384362,10677,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸‚à¸²à¸¢',0),(384363,10677,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(384364,10677,'ms','Butiran jualan',0),(384365,10677,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(384366,10677,'fr','Vente dÃ©tail',0),(384367,10677,'jp','å£²ã‚Šä¸Šã’é«˜ã®è©³ç´°',0),(384368,10677,'pt','Detalhe de vendas',0),(384369,10677,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ ÐŸÑ€Ð¾Ð´Ð°Ð¶',0),(384370,10677,'es','Detalle de Venta',0),(384371,10677,'de','Vertrieb Detail',0),(384372,10677,'en','Sales Detail',0),(384373,10678,'is','',0),(384374,10678,'dr','ØªØ§Ø±ÙŠØ® ÙØ±ÙˆØ´ ',0),(384375,10678,'pr','ØªØ§Ø±ÙŠØ® ÙØ±ÙˆØ´ ',0),(384376,10678,'tr','SatÄ±ÅŸ tarihi',0),(384377,10678,'pl','Data sprzedaÅ¼y',0),(384378,10678,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(384379,10678,'ur','ÙØ±ÙˆØ®Øª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(384380,10678,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(384381,10678,'vi','NgÃ y bÃ¡n hÃ ng',0),(384382,10678,'af','Verkoopsdatum',0),(384383,10678,'ro','Data de vÃ¢nzare',0),(384384,10678,'et','MÃ¼Ã¼gi kuupÃ¤ev',0),(384385,10678,'si','Datum prodaje',0),(384386,10678,'ba','Tanggal penjualan',0),(384387,10678,'nl','Verkoopdatum',0),(384388,10678,'fi','MyyntipÃ¤ivÃ¤',0),(384389,10678,'no','Salg dato',0),(384390,10678,'da','Salg dato',0),(384391,10678,'ko','íŒë§¤ ë‚ ì§œ',0),(384392,10678,'he','×ª××¨×™×š ×ž×›×™×¨×”',0),(384393,10678,'el','Î ÏŽÎ»Î·ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(384394,10678,'zh','é”€å”®æ—¥æœŸ\r\n',0),(384395,10678,'sv','FÃ¶rsÃ¤ljning datum',0),(384396,10678,'it','Data di vendita',0),(384397,10678,'tl','',0),(384398,10678,'th','à¸§à¸±à¸™à¸‚à¸²à¸¢',0),(384399,10678,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(384400,10678,'ms','Tarikh dijual',0),(384401,10678,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨ÙŠØ¹',0),(384402,10678,'fr','Date de la vente',0),(384403,10678,'jp','ç™ºå£²æ—¥',0),(384404,10678,'pt','Data de venda',0),(384405,10678,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(384406,10678,'es','Fecha e Venta',0),(384407,10678,'de','Verkaufsdatum',0),(384408,10678,'en','Sale Date',0),(384409,10679,'is','',0),(384410,10679,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙˆØ®Øª Ø´Ø¯Ù‡',0),(384411,10679,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙˆØ®Øª Ø´Ø¯Ù‡',0),(384412,10679,'tr','Writeoff tutar',0),(384413,10679,'pl','Kwota Writeoff',0),(384414,10679,'bg','Writeoff ÑÑƒÐ¼Ð°',0),(384415,10679,'ur','ÙˆØ±Ø§Ù¹ÛŒÙˆÙ Ù…Ù‚Ø¯Ø§Ø±',0),(384416,10679,'sr','WÑ€Ð¸Ñ‚ÐµÐ¾Ñ„Ñ„ Ð¸Ð·Ð½Ð¾Ñ',0),(384417,10679,'vi','ghi giáº£m tiá»n',0),(384418,10679,'af','Afgeskryfte Bedrag',0),(384419,10679,'ro','Suma Writeoff',0),(384420,10679,'et','Writeoff summa',0),(384421,10679,'si','Writeoff znesek',0),(384422,10679,'ba','Jumlah Writeoff',0),(384423,10679,'nl','Dienen bedrag',0),(384424,10679,'fi','Writeoff mÃ¤Ã¤rÃ¤',0),(384425,10679,'no','Writeoff belÃ¸p',0),(384426,10679,'da','Writeoff belÃ¸b',0),(384427,10679,'ko','Writeoff ê¸ˆì•¡',0),(384428,10679,'he','×›×ž×•×ª Writeoff',0),(384429,10679,'el','Writeoff Ï€Î¿ÏƒÏŒ',0),(384430,10679,'zh','æ³¨é”€é‡‘é¢\r\n',0),(384431,10679,'sv','Writeoff belopp',0),(384432,10679,'it','Importo writeoff',0),(384433,10679,'tl','',0),(384434,10679,'th','à¸ˆà¸³à¸™à¸§à¸™à¹€à¸‡à¸´à¸™ Writeoff',0),(384435,10679,'hi','Writeoff à¤°à¤¾à¤¶à¤¿',0),(384436,10679,'ms','Jumlah Writeoff',0),(384437,10679,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø±ÙŠØªÙŠÙˆÙ',0),(384438,10679,'fr','Profits',0),(384439,10679,'jp','å¸³æ¶ˆã—é‡',0),(384440,10679,'pt','Quantidade de cancelamento',0),(384441,10679,'ru','Ð¡Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑÑƒÐ¼Ð¼Ñ‹',0),(384442,10679,'es','Monto de la CancelaciÃ³n',0),(384443,10679,'de','Abzugsbetrag',0),(384444,10679,'en','Write-off Amount',0),(384445,10680,'is','',0),(384446,10680,'dr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ø§ÙŠÙ† Ø¨Ø§ÙŠØ¯ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯',0),(384447,10680,'pr','Ø¨Ø±Ø±Ø³ÙŠ ÙƒÙ†ÙŠØ¯ Ø§Ú¯Ø± Ø§ÙŠÙ† Ø¨Ø§ÙŠØ¯ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´ÙˆØ¯',0),(384448,10680,'tr','Bunlar gÃ¶stermesi gerektiÄŸini, kontrol',0),(384449,10680,'pl','SprawdÅº, czy te powinny PokaÅ¼',0),(384450,10680,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ð»Ð¸ Ñ‚Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚',0),(384451,10680,'ur','Ø§Ù† Ú©Ø§ Ù…Ø¸Ø§ÛØ±Û Ú©Ø±Ù†Ø§ Ú†Ø§ÛØ¦Û’ Ø§Ú¯Ø± ØªÙˆ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„',0),(384452,10680,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð´Ð° Ð»Ð¸ Ð¾Ð²Ð¾ Ñ‚Ñ€ÐµÐ±Ð° Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚Ð¸',0),(384453,10680,'vi','Kiá»ƒm tra náº¿u hiá»ƒn thá»‹',0),(384454,10680,'af','Kyk as dit moet wys',0),(384455,10680,'ro','VerificaÅ£i dacÄƒ acestea ar trebui sÄƒ arate',0),(384456,10680,'et','Kontrollige, kas need peaks nÃ¤itama',0),(384457,10680,'si','Preverite, Äe to Should razstava',0),(384458,10680,'ba','Periksa apakah ini harus menunjukkan',0),(384459,10680,'nl','Controleer of deze moet worden weergegeven',0),(384460,10680,'fi','Tarkista, onko nÃ¤istÃ¤ olisi kÃ¤ytÃ¤vÃ¤ ilmi',0),(384461,10680,'no','Sjekk om disse skal vise',0),(384462,10680,'da','KontrollÃ©r, om disse skal vise',0),(384463,10680,'ko','í™•ì¸ì´ í‘œì‹œ í•´ì•¼ í•˜ëŠ” ê²½ìš°',0),(384464,10680,'he','×ª×‘×“×•×§ ×× ××œ×” ×¦×¨×™×š ×œ×”×¨××•×ª',0),(384465,10680,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î±Î½ Î±Ï…Ï„Î¬ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÎ¿Ï…Î½',0),(384466,10680,'zh','æ£€æŸ¥è¿™äº›åº”è¯¥æ˜¾ç¤º\r\n',0),(384467,10680,'sv','Kontrollera om dessa bÃ¶r Visa',0),(384468,10680,'it','Controllare se questi dovrebbe mostrare',0),(384469,10680,'tl','',0),(384470,10680,'th','à¸à¸²à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¸™à¸µà¹‰à¸–à¹‰à¸²à¸„à¸§à¸£à¹à¸ªà¸”à¸‡',0),(384471,10680,'hi','à¤…à¤—à¤° à¤¯à¥‡ à¤¦à¤¿à¤–à¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(384472,10680,'ms','Semak jika ini perlu menunjukkan',0),(384473,10680,'ar','Ù…Ø¹Ø±ÙØ© Ù…Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù† ÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ØªØ¨ÙŠÙ† Ù‡Ø°Ù‡',0),(384474,10680,'fr','VÃ©rifier si ceux-ci devraient montrer',0),(384475,10680,'jp','å ´åˆã€ã“ã‚Œã‚‰ã®ãƒã‚§ãƒƒã‚¯ã‚’è¡¨ç¤ºã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(384476,10680,'pt','Verifique se estes devem mostrar',0),(384477,10680,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð½Ð°Ð´Ð¾ Ð»Ð¸ Ð­Ñ‚Ð¾ ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ',0),(384478,10680,'es','Checar Si Estos se RevelarÃ­an',0),(384479,10680,'de','ÃœberprÃ¼fen Sie, ob diese angezeigt werden soll',0),(384480,10680,'en','Check if These Should Show',0),(384481,10681,'is','',0),(384482,10681,'dr','Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ ØµÙØ±',0),(384483,10681,'pr','Ù†Ù…Ø§ÙŠØ´ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ ØµÙØ±',0),(384484,10681,'tr','SÄ±fÄ±r faaliyet hesaplarÄ±nÄ± gÃ¶ster',0),(384485,10681,'pl','PokaÅ¼ zerowÄ… aktywnoÅ›Ä‡ konta',0),(384486,10681,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð° Ð½ÑƒÐ»ÐµÐ²Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(384487,10681,'ur','ØµÙØ± Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(384488,10681,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½ÑƒÐ»Ñ‚Ñƒ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(384489,10681,'vi','Thá»ƒ hiá»‡n nhá»¯ng tÃ i khoáº£n zero',0),(384490,10681,'af','Wys zero Aktiwiteitsrekeninge',0),(384491,10681,'ro','AratÄƒ Zero conturi de activitate',0),(384492,10681,'et','NÃ¤ita nulli tegevusele kontod',0),(384493,10681,'si','Show raÄuni niÄ dejavnost',0),(384494,10681,'ba','Menunjukkan aktivitas akun',0),(384495,10681,'nl','Nul activiteit Accounts weergeven',0),(384496,10681,'fi','NÃ¤ytÃ¤ nolla toiminnan osuus',0),(384497,10681,'no','Vis null aktivitet kontoer',0),(384498,10681,'da','Vis nul aktivitet konti',0),(384499,10681,'ko','ì œë¡œ í™œë™ ê³„ì • í‘œì‹œ',0),(384500,10681,'he','×”×¦×’ ××¤×¡ ×—×©×‘×•× ×•×ª ×¤×¢×™×œ×•×ª',0),(384501,10681,'el','Î”ÎµÎ¯Ï‡Î½Î¿Ï…Î½ Ï„Î· Î¼Î·Î´Î­Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(384502,10681,'zh','æ˜¾ç¤ºé›¶æ´»åŠ¨å¸æˆ·\r\n',0),(384503,10681,'sv','Visa noll aktivitet konton',0),(384504,10681,'it','Visualizza Zero conti attivitÃ ',0),(384505,10681,'tl','',0),(384506,10681,'th','à¹à¸ªà¸”à¸‡à¸šà¸±à¸à¸Šà¸µà¸¨à¸¹à¸™à¸¢à¹Œà¸à¸´à¸ˆà¸à¸£à¸£à¸¡',0),(384507,10681,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤–à¤¾à¤¤à¥‹à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(384508,10681,'ms','Menunjukkan akaun aktiviti sifar',0),(384509,10681,'ar','ÙˆØªØ¸Ù‡Ø± Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù†Ø´Ø§Ø· ØµÙØ±',0),(384510,10681,'fr','Afficher zÃ©ro comptes d\'activitÃ©',0),(384511,10681,'jp','ã‚¼ãƒ­æ´»å‹•è³‡ç”£ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(384512,10681,'pt','Mostrar Zero contas de actividade',0),(384513,10681,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð½ÑƒÐ»ÐµÐ²Ð¾Ð¹ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ ÑÑ‡ÐµÑ‚Ð°',0),(384514,10681,'es','Mostra Cuentas Sin Actividad',0),(384515,10681,'de','Null AktivitÃ¤t Konten anzeigen',0),(384516,10681,'en','Show Zero Activity Accounts',0),(384517,10682,'is','',0),(384518,10682,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ Ø¨Ø§ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´ÙˆÙ†Ø¯',0),(384519,10682,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ Ø¨Ø§ÙŠØ¯ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´ÙˆÙ†Ø¯',0),(384520,10682,'tr','Fatura Ã¶demeleri iÃ§in oluÅŸturulacak',0),(384521,10682,'pl','Rachunki ma byÄ‡ utworzony dla pÅ‚atnoÅ›ci',0),(384522,10682,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(384523,10682,'ur','Ø¨Ù„ÙˆÚº Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’',0),(384524,10682,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð° Ð·Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(384525,10682,'vi','HÃ³a Ä‘Æ¡n Ä‘Æ°á»£c táº¡o Ä‘á»ƒ thanh toÃ¡n',0),(384526,10682,'af','Rekeninge wat Geskep moet word vir Betalings',0),(384527,10682,'ro','Facturile sÄƒ fie creat pentru plÄƒÅ£ile',0),(384528,10682,'et','Arved maksete jaoks loodud',0),(384529,10682,'si','RaÄunov, ustvarjenih za plaÄila',0),(384530,10682,'ba','Tagihan yang akan dibuat untuk pembayaran',0),(384531,10682,'nl','Facturen voor betalingen moet worden gemaakt',0),(384532,10682,'fi','Laskut luodaan maksut',0),(384533,10682,'no','Regninger opprettes for betalinger',0),(384534,10682,'da','Regninger skal oprettes for betalinger',0),(384535,10682,'ko','ì²­êµ¬ì„œë¥¼ ì§€ë¶ˆì— ëŒ€ í•œ ë§Œë“¤ ìˆ˜',0),(384536,10682,'he','×”×—×©×‘×•× ×•×ª ×©×™×•×•×¦×¨×• ×¢×‘×•×¨ ×ª×©×œ×•×ž×™×',0),(384537,10682,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î¸Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸Î¿ÏÎ½ Î³Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(384538,10682,'zh','å¼€è®¾ç¥¨æ®ç”¨äºŽä»˜æ¬¾\r\n',0),(384539,10682,'sv','RÃ¤kningar ska skapas fÃ¶r betalningar',0),(384540,10682,'it','Fatture per i pagamenti',0),(384541,10682,'tl','',0),(384542,10682,'th','à¸ªà¸¹à¸•à¸£à¸—à¸µà¹ˆà¸ˆà¸°à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(384543,10682,'hi','à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(384544,10682,'ms','Bil-bil untuk dibuat pembayaran',0),(384545,10682,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø±Ø§Ø¯ Ø¥Ù†Ø´Ø§Ø¤Ù‡ Ù„Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(384546,10682,'fr','Projets de loi Ã  crÃ©er pour les paiements',0),(384547,10682,'jp','è«‹æ±‚æ›¸ã®æ”¯æ‰•ã„ç”¨ã«ä½œæˆã™ã‚‹ã«ã¯',0),(384548,10682,'pt','Contas a ser criado para pagamentos',0),(384549,10682,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð´Ð»Ñ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹',0),(384550,10682,'es','Facturas que Sean Creadas por Pagos',0),(384551,10682,'de','Rechnungen fÃ¼r Zahlungen erstellt werden',0),(384552,10682,'en','Bills to be Created for Payments',0),(384553,10683,'is','',0),(384554,10683,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙˆØ§Ù…',0),(384555,10683,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙˆØ§Ù…',0),(384556,10683,'tr','Bill kredi eklemek',0),(384557,10683,'pl','PoÅ¼yczki Bill dodaÄ‡',0),(384558,10683,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ ÑÐ¼ÐµÑ‚ÐºÐ° Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(384559,10683,'ur','Ø¨Ù„ Ù‚Ø±Ø¶ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(384560,10683,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð‘Ð¸Ð» Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ',0),(384561,10683,'vi','thÃªm hÃ³a Ä‘Æ¡n cho vay',0),(384562,10683,'af','Lening Wetsontwerp voeg',0),(384563,10683,'ro','ÃŽmprumut Bill Adauga',0),(384564,10683,'et','Laenu Bill lisamine',0),(384565,10683,'si','Posojilo zakona dodati',0),(384566,10683,'ba','Pinjaman Bill menambahkan',0),(384567,10683,'nl','Lening Bill toevoegen',0),(384568,10683,'fi','Laina Bill lisÃ¤Ã¤',0),(384569,10683,'no','LÃ¥n Bill legge',0),(384570,10683,'da','LÃ¥n Bill tilfÃ¸je',0),(384571,10683,'ko','ëŒ€ì¶œ ê³„ì‚° ì¶”ê°€',0),(384572,10683,'he','×”×œ×•×•××” ×‘×™×œ ×œ×”×•×¡×™×£',0),(384573,10683,'el','Î”Î¬Î½ÎµÎ¹Î¿ Bill Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ',0),(384574,10683,'zh','è´·æ¬¾å¸å•\r\n',0),(384575,10683,'sv','LÃ¥n Bill lÃ¤gga till',0),(384576,10683,'it','Prestito Bill aggiungere',0),(384577,10683,'tl','',0),(384578,10683,'th','à¸à¸¹à¹‰à¸•à¸±à¹‹à¸§à¹€à¸žà¸´à¹ˆà¸¡',0),(384579,10683,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤‹à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(384580,10683,'ms','Pinjaman bil Tambah',0),(384581,10683,'ar','Ù‚Ø±Ø¶ Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ø¥Ø¶Ø§ÙØ©',0),(384582,10683,'fr','Projet de loi de prÃªt ajouter',0),(384583,10683,'jp','æ³•æ¡ˆã‚’èžè³‡ã‚’è¿½åŠ ',0),(384584,10683,'pt','EmprÃ©stimo Bill adicionar',0),(384585,10683,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð‘Ð¸Ð»Ð» Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(384586,10683,'es','Estado de Prestamo Agregar',0),(384587,10683,'de','Darlehen Bill hinzufÃ¼gen',0),(384588,10683,'en','Loan Bill Add',0),(384589,10684,'is','',0),(384590,10684,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆØ§Ù… Ø¨Ø±Ø§ÙŠ ÙˆØ§Ù… ',0),(384591,10684,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙˆØ§Ù… Ø¨Ø±Ø§ÙŠ ÙˆØ§Ù… ',0),(384592,10684,'tr','BorÃ§ Ã¶deme kredi iÃ§in',0),(384593,10684,'pl','SpÅ‚ata kredytu, kredyt',0),(384594,10684,'bg','Ð—Ð°ÐµÐ¼ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð·Ð° Ð·Ð°ÐµÐ¼',0),(384595,10684,'ur','Ù‚Ø±Ø¶ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù‚Ø±Ø¶ Ú©Û’ Ù„Ø¦Û’',0),(384596,10684,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ð° Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(384597,10684,'vi','thanh toÃ¡n khoáº£n vay cho mÃ³n vay',0),(384598,10684,'af','Lening Betalings vir Lening',0),(384599,10684,'ro','ÃŽmprumut de platÄƒ pentru Ã®mprumut',0),(384600,10684,'et','Laenumakse laenu',0),(384601,10684,'si','Posojilo plaÄilo za posojilo',0),(384602,10684,'ba','Pembayaran pinjaman untuk pinjaman',0),(384603,10684,'nl','Lening betaling voor lening',0),(384604,10684,'fi','Lainan maksun laina',0),(384605,10684,'no','LÃ¥n tilbakebetaling for lÃ¥n',0),(384606,10684,'da','LÃ¥n betaling for lÃ¥n',0),(384607,10684,'ko','ëŒ€ì¶œ ëŒ€ì¶œ ìƒí™˜ê¸ˆ',0),(384608,10684,'he','×”×œ×•×•××” ×”×ª×©×œ×•× ×¢×‘×•×¨ ×”×œ×•×•××”',0),(384609,10684,'el','Î”Î¬Î½ÎµÎ¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î® Î³Î¹Î± Î´Î¬Î½ÎµÎ¹Î¿',0),(384610,10684,'zh','è´·æ¬¾æ”¯ä»˜è´·æ¬¾\r\n',0),(384611,10684,'sv','LÃ¥n betalning fÃ¶r lÃ¥n',0),(384612,10684,'it','Pagamento prestito prestito',0),(384613,10684,'tl','',0),(384614,10684,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰à¸¢à¸·à¸¡',0),(384615,10684,'hi','à¤‹à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤‹à¤£ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(384616,10684,'ms','Bayaran pinjaman bagi pinjaman',0),(384617,10684,'ar','Ø³Ø¯Ø§Ø¯ Ø§Ù„Ù‚Ø±Ø¶ Ù„Ù„Ù‚Ø±Ø¶',0),(384618,10684,'fr','Remboursement de prÃªt prÃªt',0),(384619,10684,'jp','è²¸ä»˜ã‘é‡‘ã®ãŸã‚ã®ãƒ­ãƒ¼ãƒ³ã®æ”¯æ‰•ã„',0),(384620,10684,'pt','Pagamento de emprÃ©stimo para emprÃ©stimo',0),(384621,10684,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð° Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(384622,10684,'es','Pagos de Prestamo para el Prestamo',0),(384623,10684,'de','Kreditzahlung fÃ¼r Darlehen',0),(384624,10684,'en','Loan Payment for Loan',0),(384625,10685,'is','',0),(384626,10685,'dr','Ù‚Ø¨ÙˆÙ„ Ø¬Ù‡Øª Ø§ÙŠØ¬Ø§Ø¯ ÙƒØ±Ø¯Ù† ',0),(384627,10685,'pr','Ù‚Ø¨ÙˆÙ„ Ø¬Ù‡Øª Ø§ÙŠØ¬Ø§Ø¯ ÙƒØ±Ø¯Ù† ',0),(384628,10685,'tr','Tamam oluÅŸturmak iÃ§in',0),(384629,10685,'pl','OK, aby utworzyÄ‡',0),(384630,10685,'bg','OK, Ð·Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ',0),(384631,10685,'ur','Ù¹Ú¾ÛŒÚ© Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(384632,10685,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð»Ð¸',0),(384633,10685,'vi','Äá»“ng Ã½ táº¡o',0),(384634,10685,'af','Om orde te skep',0),(384635,10685,'ro','OK pentru a crea',0),(384636,10685,'et','OK, et luua',0),(384637,10685,'si','Ali Å¾elite ustvariti',0),(384638,10685,'ba','OK untuk membuat',0),(384639,10685,'nl','OK om te maken',0),(384640,10685,'fi','Haluatko luoda',0),(384641,10685,'no','OK for Ã¥ opprette',0),(384642,10685,'da','OK for at oprette',0),(384643,10685,'ko','í™•ì¸ì„ ë§Œë“¤í•©ë‹ˆë‹¤',0),(384644,10685,'he','×‘×¨×¦×•× ×š ×œ×™×¦×•×¨',0),(384645,10685,'el','OK Î³Î¹Î± Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ',0),(384646,10685,'zh','ç¡®å®šåˆ›å»º\r\n',0),(384647,10685,'sv','OK fÃ¶r att skapa',0),(384648,10685,'it','OK per creare',0),(384649,10685,'tl','',0),(384650,10685,'th','à¸•à¸à¸¥à¸‡à¹€à¸žà¸·à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡',0),(384651,10685,'hi','à¤ à¥€à¤• à¤¹à¥ˆ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(384652,10685,'ms','OK untuk mencipta',0),(384653,10685,'ar','\"Ù…ÙˆØ§ÙÙ‚\" Ù„Ø¥Ù†Ø´Ø§Ø¡',0),(384654,10685,'fr','OK pour crÃ©er',0),(384655,10685,'jp','[Ok] ã‚’ä½œæˆã™ã‚‹ã«ã¯',0),(384656,10685,'pt','OK para criar',0),(384657,10685,'ru','OK Ð´Ð»Ñ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ',0),(384658,10685,'es','OK para Crear',0),(384659,10685,'de','OK zum Erstellen',0),(384660,10685,'en','OK to Create',0),(384661,10686,'is','',0),(384662,10686,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙƒÙ‡ Ù‚Ø¨Ù„Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(384663,10686,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙƒÙ‡ Ù‚Ø¨Ù„Ø§ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(384664,10686,'tr','Daha Ã¶nce oluÅŸturulan faturalarÄ± Ã¶demesi iÃ§in',0),(384665,10686,'pl','WczeÅ›niej stworzyÅ‚ rachunki dla pÅ‚atnoÅ›ci',0),(384666,10686,'bg','ÐŸÐ¾-Ñ€Ð°Ð½Ð¾ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(384667,10686,'ur','Ù¾ÛÙ„Û’ Ø¨Ù†Ø§Ø¦ÛŒ Ú¯Ø¦ÛŒ Ø¨Ù„ÙˆÚº Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’',0),(384668,10686,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ',0),(384669,10686,'vi','táº¡o hÃ³a Ä‘Æ¡n trÆ°á»›c Ä‘á»ƒ thanh toÃ¡n ',0),(384670,10686,'af','Vorige Geskepte Rekeninge vir Betaling',0),(384671,10686,'ro','Anterior create facturi de platÄƒ',0),(384672,10686,'et','Varem loodud arvete tasumiseks',0),(384673,10686,'si','Prej ustvarili menice za plaÄilo',0),(384674,10686,'ba','Sebelumnya dibuat tagihan pembayaran',0),(384675,10686,'nl','Eerder gemaakte rekeningen voor betaling',0),(384676,10686,'fi','Aiemmin luotujen laskujen maksamisesta',0),(384677,10686,'no','Tidligere opprettet regninger for betaling',0),(384678,10686,'da','Tidligere oprettede regninger til betaling',0),(384679,10686,'ko','ì´ì „ì— ë§Œë“ ëœ ì²­êµ¬ì„œ ì§€ë¶ˆì— ëŒ€ í•œ',0),(384680,10686,'he','×‘×¢×‘×¨ ×©× ×•×¦×¨ ×—×©×‘×•× ×•×ª ×œ×ª×©×œ×•×',0),(384681,10686,'el','Î ÏÎ¿Î·Î³Î¿Ï…Î¼Î­Î½Ï‰Ï‚ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(384682,10686,'zh','ä»¥å‰åˆ›å»ºçš„ä»˜æ¬¾ç¥¨æ®\r\n',0),(384683,10686,'sv','Tidigare skapade fakturor fÃ¶r betalning',0),(384684,10686,'it','Precedentemente create fatture per il pagamento',0),(384685,10686,'tl','',0),(384686,10686,'th','à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(384687,10686,'hi','à¤ªà¤¹à¤²à¥‡ à¤¬à¤¨à¤¾à¤ à¤—à¤ à¤¬à¤¿à¤² à¤•à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤',0),(384688,10686,'ms','Sebelum ini diwujudkan bil untuk pembayaran',0),(384689,10686,'ar','Ø³Ø¨Ù‚ Ø¥Ù†Ø´Ø§Ø¡ ÙÙˆØ§ØªÙŠØ± Ù„Ù„Ø¯ÙØ¹',0),(384690,10686,'fr','PrÃ©cÃ©demment crÃ©Ã©s factures de paiement',0),(384691,10686,'jp','ä»¥å‰ä½œæˆã—ãŸæ‰‹å½¢æ”¯æ‰•',0),(384692,10686,'pt','Anteriormente criadas contas para pagamento',0),(384693,10686,'ru','Ð Ð°Ð½ÐµÐµ ÑÐ¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(384694,10686,'es','Facturas Hechas Previamente para Pago',0),(384695,10686,'de','Zuvor erstellten Rechnungen zur Zahlung',0),(384696,10686,'en','Previously Created Bills for Payment',0),(384697,10687,'is','',0),(384698,10687,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø§ÙŠØ¬Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ ØªØ¹ÙŠÙŠÙ† Ø´ÙˆØ¯ ',0),(384699,10687,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø§ÙŠØ¬Ø§Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ ØªØ¹ÙŠÙŠÙ† Ø´ÙˆØ¯ ',0),(384700,10687,'tr','SatÄ±cÄ± oluÅŸturma Ã¶demeler Ã¶nce atanmÄ±ÅŸ olmalÄ±dÄ±r.',0),(384701,10687,'pl','Dostawcy muszÄ… byÄ‡ przypisane przed tworzenie pÅ‚atnoÅ›ci',0),(384702,10687,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½ Ð¿Ñ€ÐµÐ´Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(384703,10687,'ur','ÙˆÛŒÙ†ÚˆØ± ØªÙÙˆÛŒØ¶ Ø³Û’ Ù¾ÛÙ„Û’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(384704,10687,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð´Ð¾Ð´ÐµÑ™ÐµÐ½ Ð¿Ñ€Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐ° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(384705,10687,'vi','NhÃ  cung cáº¥p pháº£i Ä‘Æ°á»£c Ä‘Æ°á»£c chá»‰ Ä‘á»‹nh TrÆ°á»›c khi Táº¡o Thanh toÃ¡n',0),(384706,10687,'af','Verskaffer Moet Aangewys word Alvorens Betalings Geskep kan word.',0),(384707,10687,'ro','VÃ¢nzÄƒtorul trebuie sÄƒ fie atribuite Ã®nainte de crearea de plÄƒÅ£i',0),(384708,10687,'et','Hankija peab olema mÃ¤Ã¤ratud enne luues maksed',0),(384709,10687,'si','Prodajalec mora biti dodeljena pred ustvarjanjem plaÄila',0),(384710,10687,'ba','Penjual harus ditetapkan sebelum membuat pembayaran',0),(384711,10687,'nl','Leverancier moet worden toegewezen voor het maken van betalingen',0),(384712,10687,'fi','Toimittajan on oltava mÃ¤Ã¤ritetty ennen luominen maksut',0),(384713,10687,'no','LeverandÃ¸ren mÃ¥ vÃ¦re tilordnet fÃ¸r skape betalinger',0),(384714,10687,'da','LeverandÃ¸ren skal vÃ¦re tildelt fÃ¸r oprettelse af betalinger',0),(384715,10687,'ko','ê³µê¸‰ ì—…ì²´ ë§Œë“¤ê¸° ì§€ë¶ˆ í•˜ê¸° ì „ì— í• ë‹¹ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(384716,10687,'he','×”×¡×¤×§ ×—×™×™×‘ ×œ×”×™×•×ª ×ž×•×§×¦×” ×œ×¤× ×™ ×™×¦×™×¨×ª ×ª×©×œ×•×ž×™×',0),(384717,10687,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®, Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î±Î½Î±Ï„ÎµÎ¸ÎµÎ¯ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(384718,10687,'zh','ä¾›åº”å•†å¿…é¡»åœ¨åˆ›å»ºä»˜æ¬¾ä¹‹å‰è¢«åˆ†é…\r\n',0),(384719,10687,'sv','LeverantÃ¶ren mÃ¥ste vara tilldelade innan skapa betalningar',0),(384720,10687,'it','Fornitore deve essere assegnato prima creazione dei pagamenti',0),(384721,10687,'tl','',0),(384722,10687,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸•à¹‰à¸­à¸‡à¸à¸³à¸«à¸™à¸”à¸à¹ˆà¸­à¸™à¸—à¸µà¹ˆà¸ˆà¸°à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(384723,10687,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(384724,10687,'ms','Penjual hendaklah diberikan sebelum membuat pembayaran',0),(384725,10687,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø§Ù„Ù…ÙˆØ±Ø¯ \"Ø§Ù„Ù…Ø¹ÙŠÙ† Ù‚Ø¨Ù„ Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª\"',0),(384726,10687,'fr','Vendeur doit Ãªtre assignÃ©s avant de crÃ©er des paiements',0),(384727,10687,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’ä½œæˆã™ã‚‹ãŠæ”¯æ‰•ã„å‰ã«å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(384728,10687,'pt','Vendedor deve ser atribuÃ­do antes de criar os pagamentos',0),(384729,10687,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½ Ð´Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(384730,10687,'es','Proveedor se Debe Asignar Antes Que Crear Pagos',0),(384731,10687,'de','Anbieter muss vor dem Erstellen von Zahlungen zugeordnet sein',0),(384732,10687,'en','Vendor Must be Assigned Before Creating Payments',0),(384733,10688,'is','',0),(384734,10688,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙˆØ§Ù… ',0),(384735,10688,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙˆØ§Ù… ',0),(384736,10688,'tr','Kredi fatura gÃ¼ncelleÅŸtirme',0),(384737,10688,'pl','PoÅ¼yczki Bill aktualizacji',0),(384738,10688,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚ ÑÐ¼ÐµÑ‚ÐºÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(384739,10688,'ur','Ù‚Ø±Ø¶ Ú©Û’ Ø¨Ù„ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(384740,10688,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð‘Ð¸Ð» ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(384741,10688,'vi','cáº­p nháº­t hÃ³a Ä‘Æ¡n cho vay',0),(384742,10688,'af','Lening Wetsontwerp bywerking',0),(384743,10688,'ro','Actualizare de Bill Ã®mprumut',0),(384744,10688,'et','Laenu Bill uuendamine',0),(384745,10688,'si','Posojilo Bill posodobitev',0),(384746,10688,'ba','Pinjaman Bill Update',0),(384747,10688,'nl','Lening Bill Update',0),(384748,10688,'fi','Lainan Bill pÃ¤ivitys',0),(384749,10688,'no','LÃ¥n Bill oppdatering',0),(384750,10688,'da','LÃ¥n Bill opdatering',0),(384751,10688,'ko','ëŒ€ì¶œ ë¹Œ ì—…ë°ì´íŠ¸',0),(384752,10688,'he','×¢×“×›×•×Ÿ ×—×©×‘×•×Ÿ ×”×”×œ×•×•××”',0),(384753,10688,'el','Î”Î¬Î½ÎµÎ¹Î¿ Bill ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(384754,10688,'zh','è´·æ¬¾å¸å•æ›´æ–°\r\n',0),(384755,10688,'sv','LÃ¥n Bill uppdatering',0),(384756,10688,'it','Prestito Bill aggiornamento',0),(384757,10688,'tl','',0),(384758,10688,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰à¸¢à¸·à¸¡',0),(384759,10688,'hi','à¤‹à¤£ à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(384760,10688,'ms','Pinjaman Rang undang-undang Update',0),(384761,10688,'ar','ØªØ­Ø¯ÙŠØ« ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù‚Ø±Ø¶',0),(384762,10688,'fr','Mise Ã  jour du projet de loi de prÃªt',0),(384763,10688,'jp','ãƒ­ãƒ¼ãƒ³è«‹æ±‚æ›¸æ›´æ–°',0),(384764,10688,'pt','AtualizaÃ§Ã£o de conta de emprÃ©stimo',0),(384765,10688,'ru','Ð‘Ð¸Ð»Ð» Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(384766,10688,'es','Estado de Prestamo Actualizar',0),(384767,10688,'de','Darlehen-Bill-Update',0),(384768,10688,'en','Loan Bill Update',0),(384769,10689,'is','',0),(384770,10689,'dr','(Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ) ÙˆØ§Ù… ',0),(384771,10689,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ (Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ ) ÙˆØ§Ù… ',0),(384772,10689,'tr','Kredi satÄ±ÅŸ Ekle',0),(384773,10689,'pl','SprzedaÅ¼y kredytÃ³w dodaÄ‡',0),(384774,10689,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(384775,10689,'ur','Ù‚Ø±Ø¶ Ú©ÛŒ ÙØ±ÙˆØ®Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(384776,10689,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(384777,10689,'vi','thÃªm mÃ³n vay bÃ¡n hÃ ng',0),(384778,10689,'af','Lening verkope voeg',0),(384779,10689,'ro','Adauga credit vÃ¢nzÄƒri',0),(384780,10689,'et','Laenude mÃ¼Ã¼gi lisamine',0),(384781,10689,'si','PoveÄati prodajo posojil',0),(384782,10689,'ba','Tambahkan penjualan pinjaman',0),(384783,10689,'nl','Lening verkoop toevoegen',0),(384784,10689,'fi','Lainojen myynnin lisÃ¤Ã¤minen',0),(384785,10689,'no','LÃ¥n salg legge',0),(384786,10689,'da','LÃ¥n salg tilfÃ¸je',0),(384787,10689,'ko','ëŒ€ì¶œ íŒë§¤ ì¶”ê°€',0),(384788,10689,'he','×”×œ×•×•××” ×ž×›×™×¨×•×ª ×œ×”×•×¡×™×£',0),(384789,10689,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î´Î±Î½ÎµÎ¯Ï‰Î½',0),(384790,10689,'zh','è´·æ¬¾é”€å”®æ·»åŠ \r\n',0),(384791,10689,'sv','LÃ¥n fÃ¶rsÃ¤ljning lÃ¤gga till',0),(384792,10689,'it','Aggiungi prestito vendite',0),(384793,10689,'tl','',0),(384794,10689,'th','à¸‚à¸²à¸¢à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰à¸¢à¸·à¸¡à¹€à¸žà¸´à¹ˆà¸¡',0),(384795,10689,'hi','à¤‹à¤£ à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(384796,10689,'ms','Menambah jualan pinjaman',0),(384797,10689,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ù‚Ø±ÙˆØ¶',0),(384798,10689,'fr','Ajouter ventes de prÃªt',0),(384799,10689,'jp','ãƒ­ãƒ¼ãƒ³ã®è²©å£²ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(384800,10689,'pt','Vendas de emprÃ©stimo adicionar',0),(384801,10689,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(384802,10689,'es','Ventas de Prestamos Agregar',0),(384803,10689,'de','Loan Sales hinzufÃ¼gen',0),(384804,10689,'en','Loan Sales Add',0),(384805,10690,'is','',0),(384806,10690,'dr','ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ Ù‚Ø¨Ù„ÙŠ',0),(384807,10690,'pr','ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ Ù‚Ø¨Ù„ÙŠ',0),(384808,10690,'tr','Ã–nceki satÄ±ÅŸ',0),(384809,10690,'pl','SprzedaÅ¼ w poprzednim',0),(384810,10690,'bg','ÐŸÑ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(384811,10690,'ur','Ù¾Ú†Ú¾Ù„Ø§ Ø³ÛŒÙ„Ø²',0),(384812,10690,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð°',0),(384813,10690,'vi','bÃ¡n hÃ ng ká»³ trÆ°á»›c',0),(384814,10690,'af','Vorige Verkope',0),(384815,10690,'ro','VÃ¢nzÄƒri anterioare',0),(384816,10690,'et','Eelmine mÃ¼Ã¼k',0),(384817,10690,'si','PrejÅ¡nje prodaje',0),(384818,10690,'ba','Sebelumnya penjualan',0),(384819,10690,'nl','Vorige verkoop',0),(384820,10690,'fi','Edellisten myynti',0),(384821,10690,'no','Tidligere salg',0),(384822,10690,'da','Tidligere salg',0),(384823,10690,'ko','ì´ì „ íŒë§¤',0),(384824,10690,'he','×§×•×“× ×‘×ž×›×™×¨×•×ª',0),(384825,10690,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(384826,10690,'zh','ä»¥å¾€çš„é”€å”®ä¸šç»©\r\n',0),(384827,10690,'sv','Tidigare fÃ¶rsÃ¤ljning',0),(384828,10690,'it','Vendite precedenti',0),(384829,10690,'tl','',0),(384830,10690,'th','à¸‚à¸²à¸¢à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(384831,10690,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(384832,10690,'ms','Lepas jualan',0),(384833,10690,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(384834,10690,'fr','Ventes prÃ©cÃ©dentes',0),(384835,10690,'jp','å‰ã®è²©å£²',0),(384836,10690,'pt','Vendas anteriores',0),(384837,10690,'ru','ÐŸÑ€ÐµÐ´Ð¸Ð´ÑƒÑ‰Ð¸Ðµ ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸',0),(384838,10690,'es','Ventas Previas',0),(384839,10690,'de','Vorherige Verkauf',0),(384840,10690,'en','Previous Sales',0),(384841,10691,'is','',0),(384842,10691,'dr','ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(384843,10691,'pr','ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(384844,10691,'tr','SatÄ±lÄ±k baÅŸarÄ±yla eklendi',0),(384845,10691,'pl','SprzedaÅ¼, dodano pomyÅ›lnie',0),(384846,10691,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(384847,10691,'ur','Ù„ÙŠØ¦Û’ Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(384848,10691,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(384849,10691,'vi','ThÃªm doanh sá»‘ thÃ nh cÃ´ng',0),(384850,10691,'af','Verkope Suksesvol Bygevoeg',0),(384851,10691,'ro','VÃ¢nzare adÄƒugat cu succes',0),(384852,10691,'et','Lisatud mÃ¼Ã¼k',0),(384853,10691,'si','Prodajo uspeÅ¡no dodani',0),(384854,10691,'ba','Dijual ditambahkan berhasil',0),(384855,10691,'nl','Koop met succes toegevoegd',0),(384856,10691,'fi','Myynnin lisÃ¤Ã¤minen onnistui',0),(384857,10691,'no','Salg lagt',0),(384858,10691,'da','Salg tilfÃ¸jet',0),(384859,10691,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ íŒë§¤',0),(384860,10691,'he','×ž×›×™×¨×” × ×•×¡×¤×” ×‘×”×¦×œ×—×”',0),(384861,10691,'el','Î ÏŽÎ»Î·ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(384862,10691,'zh','æˆåŠŸæ·»åŠ å‡ºå”®\r\n',0),(384863,10691,'sv','FÃ¶rsÃ¤ljning lagts',0),(384864,10691,'it','Vendita aggiunto con successo',0),(384865,10691,'tl','',0),(384866,10691,'th','à¸‚à¸²à¸¢à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(384867,10691,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(384868,10691,'ms','Jualan yang berjaya menambah',0),(384869,10691,'ar','Ø¨ÙŠØ¹ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(384870,10691,'fr','Vente ajoutÃ© avec succÃ¨s',0),(384871,10691,'jp','è²©å£²ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(384872,10691,'pt','Venda adicionada com sucesso',0),(384873,10691,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(384874,10691,'es','Venta Agregada Exitosamente',0),(384875,10691,'de','Verkauf erfolgreich hinzugefÃ¼gt',0),(384876,10691,'en','Sale Added Successfully',0),(384877,10692,'is','',0),(384878,10692,'dr','( Ø³Ø§Ø¨Ù‚Ù‡ )Ø¢ÙˆÛŒØ² ÙØ±ÙˆØ´',0),(384879,10692,'pr','Ø­Ø°Ù Ø§ÙŠÙ† Ø«Ø¨Øª ( Ø³Ø§Ø¨Ù‚Ù‡ )Ù…Ø¯Ø±Ùƒ ÙØ±ÙˆØ´',0),(384880,10692,'tr','Bu satÄ±ÅŸ kaydÄ± sil',0),(384881,10692,'pl','UsuÅ„ ten rekord sprzedaÅ¼y',0),(384882,10692,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹Ñ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(384883,10692,'ur','Ø§Ø³ ÙØ±ÙˆØ®Øª Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ùˆ Ø­Ø°Ù',0),(384884,10692,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(384885,10692,'vi','XÃ³a bÃ¡o cÃ¡o bÃ¡n hÃ ng nÃ y',0),(384886,10692,'af','Skrap hierdie verkoop rekord',0),(384887,10692,'ro','È˜tergeÈ›i aceastÄƒ Ã®nregistrare Ã®n vÃ¢nzare',0),(384888,10692,'et','See mÃ¼Ã¼k kirje kustutamine',0),(384889,10692,'si','IzbriÅ¡ite zapis prodajo',0),(384890,10692,'ba','Menghapus catatan penjualan ini',0),(384891,10692,'nl','Verwijder deze Record verkoop',0),(384892,10692,'fi','MyytÃ¤vÃ¤nÃ¤ tietueen poistaminen',0),(384893,10692,'no','Slette salg posten',0),(384894,10692,'da','Slet dette salg',0),(384895,10692,'ko','ì´ íŒë§¤ ë ˆì½”ë“œ ì‚­ì œ',0),(384896,10692,'he','×œ×ž×—×•×§ ×¨×©×•×ž×” ×–×• ×œ×ž×›×™×¨×”',0),(384897,10692,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÎ³Î³ÏÎ±Ï†Î® Ï€ÏŽÎ»Î·ÏƒÎ·',0),(384898,10692,'zh','åˆ é™¤æ­¤é”€å”®çºªå½•\r\n',0),(384899,10692,'sv','Ta bort postens fÃ¶rsÃ¤ljning',0),(384900,10692,'it','Eliminare questo Record di vendita',0),(384901,10692,'tl','',0),(384902,10692,'th','à¸¥à¸šà¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”à¸™à¸µà¹‰à¸‚à¸²à¸¢',0),(384903,10692,'hi','à¤‡à¤¸ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥‡ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(384904,10692,'ms','Menghapuskan rekod jualan ini',0),(384905,10692,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø³Ø¬Ù„ Ø§Ù„Ø¨ÙŠØ¹',0),(384906,10692,'fr','Supprimer ce dossier de vente',0),(384907,10692,'jp','ã“ã®è²©å£²ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(384908,10692,'pt','Excluir este registro de venda',0),(384909,10692,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°',0),(384910,10692,'es','Eliminar Este Record de la Venta',0),(384911,10692,'de','Dieser Verkauf Datensatz lÃ¶schen',0),(384912,10692,'en','Delete This Sale Record',0),(384913,10693,'is','',0),(384914,10693,'dr','(Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ  ',0),(384915,10693,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ ÙˆØ§Ù… ÙØ±ÙˆØ´ Ù‡Ø§ (Ø¨Ø§Ø²Ø§Ø±ÙŠØ§Ø¨ÙŠ  ',0),(384916,10693,'tr','Kredi satÄ±ÅŸ DÃ¼zenle',0),(384917,10693,'pl','Edycja sprzedaÅ¼y poÅ¼yczki',0),(384918,10693,'bg','Ð—Ð°ÐµÐ¼ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(384919,10693,'ur','Ù‚Ø±Ø¶ Ø³ÛŒÙ„Ø² ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(384920,10693,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(384921,10693,'vi','chá»‰nh sá»­a mÃ³n vay bÃ¡n hÃ ng',0),(384922,10693,'af','Lening verkope redigeer',0),(384923,10693,'ro','Credit vÃ¢nzÄƒri Edit',0),(384924,10693,'et','Laenu mÃ¼Ã¼gi Edit',0),(384925,10693,'si','Posojila prodaje Uredi',0),(384926,10693,'ba','Edit penjualan pinjaman',0),(384927,10693,'nl','Lening verkoop bewerken',0),(384928,10693,'fi','Laina myynti muokkaus',0),(384929,10693,'no','LÃ¥n salg Rediger',0),(384930,10693,'da','LÃ¥n salg Rediger',0),(384931,10693,'ko','ëŒ€ì¶œ ì˜ì—… íŽ¸ì§‘',0),(384932,10693,'he','×¢×¨×™×›×” ×ž×›×™×¨×•×ª ×”×œ×•×•××”',0),(384933,10693,'el','Î”Î¬Î½ÎµÎ¹Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(384934,10693,'zh','è´·æ¬¾é”€å”®ç¼–è¾‘\r\n',0),(384935,10693,'sv','LÃ¥n fÃ¶rsÃ¤ljning redigera',0),(384936,10693,'it','Modifica vendita prestito',0),(384937,10693,'tl','',0),(384938,10693,'th','à¹à¸à¹‰à¹„à¸‚à¸à¸²à¸£à¸‚à¸²à¸¢à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­',0),(384939,10693,'hi','à¤‹à¤£ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(384940,10693,'ms','Edit jualan pinjaman',0),(384941,10693,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ù‚Ø±Ø¶ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(384942,10693,'fr','Edit vente prÃªt',0),(384943,10693,'jp','ãƒ­ãƒ¼ãƒ³è²©å£²ç·¨é›†',0),(384944,10693,'pt','Editar vendas de emprÃ©stimo',0),(384945,10693,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(384946,10693,'es','Ventas de Prestamos Editar',0),(384947,10693,'de','Darlehen Vertrieb bearbeiten',0),(384948,10693,'en','Loan Sales Edit',0),(384949,10694,'is','',0),(384950,10694,'dr','ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(384951,10694,'pr','ÙØ±ÙˆØ´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(384952,10694,'tr','SatÄ±lÄ±k baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(384953,10694,'pl','SprzedaÅ¼ pomyÅ›lnie zaktualizowana',0),(384954,10694,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(384955,10694,'ur','ÙØ±ÙˆØ®Øª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(384956,10694,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(384957,10694,'vi','Cáº­p nháº­t bÃ¡n hÃ ng thÃ nh cÃ´ng',0),(384958,10694,'af','Verkope Suksesvol Opdateer',0),(384959,10694,'ro','VÃ¢nzare actualizat cu succes',0),(384960,10694,'et','VÃ¤rskendatud mÃ¼Ã¼k',0),(384961,10694,'si','Prodajo uspeÅ¡no posodobljena',0),(384962,10694,'ba','Penjualan yang berhasil',0),(384963,10694,'nl','Verkoop bijgewerkt',0),(384964,10694,'fi','PÃ¤ivitetty myytÃ¤vÃ¤nÃ¤',0),(384965,10694,'no','Salg oppdatert',0),(384966,10694,'da','Salg opdateret',0),(384967,10694,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ íŒë§¤',0),(384968,10694,'he','×œ×ž×›×™×¨×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(384969,10694,'el','Î ÏŽÎ»Î·ÏƒÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(384970,10694,'zh','é”€å”®æ›´æ–°æˆåŠŸ\r\n',0),(384971,10694,'sv','Salu uppdaterats',0),(384972,10694,'it','Vendita aggiornato con successo',0),(384973,10694,'tl','',0),(384974,10694,'th','à¸‚à¸²à¸¢à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(384975,10694,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(384976,10694,'ms','Jualan yang berjaya dikemas kini',0),(384977,10694,'ar','Ø§Ù„Ø¨ÙŠØ¹ Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(384978,10694,'fr','Vente mis Ã  jour avec succÃ¨s',0),(384979,10694,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸè²©å£²',0),(384980,10694,'pt','Venda atualizado com sucesso',0),(384981,10694,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(384982,10694,'es','Venta Actualizada Exitosamente',0),(384983,10694,'de','Verkauf erfolgreich aktualisiert',0),(384984,10694,'en','Sale Updated Successfully',0),(384985,10695,'is','',0),(384986,10695,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§Ø®ØªÙ…Ø§Ù† ',0),(384987,10695,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø§Ø®ØªÙ…Ø§Ù† ',0),(384988,10695,'tr','Eklemek binanÄ±n',0),(384989,10695,'pl','DodaÄ‡ budynku',0),(384990,10695,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°',0),(384991,10695,'ur','Ø¹Ù…Ø§Ø±Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(384992,10695,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(384993,10695,'vi','ThÃªm xÃ¢y dá»±ng',0),(384994,10695,'af','Gebou Byvoeg',0),(384995,10695,'ro','Adauga clÄƒdire',0),(384996,10695,'et','Lisatakse hoone',0),(384997,10695,'si','Dodaj stavbe',0),(384998,10695,'ba','Menambahkan bangunan',0),(384999,10695,'nl','Toevoegen van gebouw',0),(385000,10695,'fi','LisÃ¤Ã¤ rakennuksen',0),(385001,10695,'no','Legge til bygning',0),(385002,10695,'da','TilfÃ¸je bygning',0),(385003,10695,'ko','ê±´ë¬¼ ì¶”ê°€',0),(385004,10695,'he','×”×•×¡×£ ×‘× ×™×™×Ÿ',0),(385005,10695,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(385006,10695,'zh','å¢žåŠ å»ºè®¾\r\n',0),(385007,10695,'sv','LÃ¤gg till byggnaden',0),(385008,10695,'it','Aggiungi edificio',0),(385009,10695,'tl','',0),(385010,10695,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸­à¸²à¸„à¸²à¸£',0),(385011,10695,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(385012,10695,'ms','Menambah bangunan',0),(385013,10695,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø§Ø¡',0),(385014,10695,'fr','Ajouter bÃ¢timent',0),(385015,10695,'jp','å»ºç‰©ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(385016,10695,'pt','Adicionar o edifÃ­cio',0),(385017,10695,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð´Ð°Ð½Ð¸Ðµ',0),(385018,10695,'es','Agregar Edificio',0),(385019,10695,'de','GebÃ¤ude hinzufÃ¼gen',0),(385020,10695,'en','Add Building',0),(385021,10696,'is','',0),(385022,10696,'dr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯Ø§Ù† ',0),(385023,10696,'pr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ú¯Ø§Ù† ',0),(385024,10696,'tr','Ajanlar',0),(385025,10696,'pl','Agenci',0),(385026,10696,'bg','ÐÐ³ÐµÐ½Ñ‚Ð¸',0),(385027,10696,'ur','Ø³Ø§Ø²Ù†Ø¯Û',0),(385028,10696,'sr','ÐÐ³ÐµÐ½Ñ‚Ð¸',0),(385029,10696,'vi','CÃ¡c Ä‘áº¡i lÃ½',0),(385030,10696,'af','Agente',0),(385031,10696,'ro','AgenÅ£i',0),(385032,10696,'et','Agendid',0),(385033,10696,'si','Zastopniki',0),(385034,10696,'ba','Agen',0),(385035,10696,'nl','Agenten',0),(385036,10696,'fi','Aineet',0),(385037,10696,'no','Agenter',0),(385038,10696,'da','Agenter',0),(385039,10696,'ko','ì—ì´ì „íŠ¸',0),(385040,10696,'he','×¡×•×›× ×™×',0),(385041,10696,'el','Î ÏÎ¬ÎºÏ„Î¿ÏÎµÏ‚',0),(385042,10696,'zh','ä»£ç†\r\n',0),(385043,10696,'sv','Agenter',0),(385044,10696,'it','Agenti',0),(385045,10696,'tl','',0),(385046,10696,'th','à¸•à¸±à¸§à¹à¸—à¸™',0),(385047,10696,'hi','à¤à¤œà¥‡à¤‚à¤Ÿà¥‹à¤‚',0),(385048,10696,'ms','Ejen-ejen',0),(385049,10696,'ar','Ø§Ù„ÙˆÙƒÙ„Ø§Ø¡',0),(385050,10696,'fr','Agents',0),(385051,10696,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆ',0),(385052,10696,'pt','Agentes',0),(385053,10696,'ru','ÐÐ³ÐµÐ½Ñ‚Ñ‹',0),(385054,10696,'es','Agentes',0),(385055,10696,'de','Agenten',0),(385056,10696,'en','Agents',0),(385057,10697,'is','',0),(385058,10697,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(385059,10697,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(385060,10697,'tr','Ajanlar baÅŸarÄ±sÄ±zlÄ±k eklendi',0),(385061,10697,'pl','Dodano awarii agentÃ³w',0),(385062,10697,'bg','ÐÐ³ÐµÐ½Ñ‚Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(385063,10697,'ur','Ø§ÛŒØ¬Ù†Ù¹ÙˆÚº Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ù†Ø§Ú©Ø§Ù…ÛŒ',0),(385064,10697,'sr','ÐÐ³ÐµÐ½Ñ‚Ð¸ Ð´Ð¾Ð´Ð°Ð¾ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(385065,10697,'vi','ThÃªm Ä‘áº¡i lÃ½ khÃ´ng thÃ nh cÃ´ng',0),(385066,10697,'af','Middels bygevoeg versuim',0),(385067,10697,'ro','AgenÅ£i adÄƒugat eÅŸec',0),(385068,10697,'et','Agendid lisatud rike',0),(385069,10697,'si','Agenti doda neuspeh',0),(385070,10697,'ba','Agen ditambahkan kegagalan',0),(385071,10697,'nl','Agenten toegevoegd mislukking',0),(385072,10697,'fi','Aineet lisÃ¤tÃ¤Ã¤n epÃ¤onnistuminen',0),(385073,10697,'no','Agenter lagt feil',0),(385074,10697,'da','Agenter tilfÃ¸jet fiasko',0),(385075,10697,'ko','ì—ì´ì „íŠ¸ ì¶”ê°€ ì‹¤íŒ¨',0),(385076,10697,'he','×›×©×œ × ×•×¡×£ ×¡×•×›× ×™×',0),(385077,10697,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î± Ï€ÏÎ¬ÎºÏ„Î¿ÏÎµÏ‚',0),(385078,10697,'zh','ä»£ç†å¢žåŠ å¤±è´¥\r\n',0),(385079,10697,'sv','Agenter lÃ¤ggas underlÃ¥tenhet',0),(385080,10697,'it','Agenti aggiunto fallimento',0),(385081,10697,'tl','',0),(385082,10697,'th','à¸•à¸±à¸§à¹à¸—à¸™à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(385083,10697,'hi','à¤à¤œà¥‡à¤‚à¤Ÿà¥‹à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤µà¤¿à¤«à¤²à¤¤à¤¾',0),(385084,10697,'ms','Ejen-ejen ditambah kegagalan',0),(385085,10697,'ar','ÙØ´Ù„ Ø¥Ø¶Ø§ÙØ© Ø§Ù„ÙˆÙƒÙ„Ø§Ø¡',0),(385086,10697,'fr','Ajoute des agents de dÃ©faillance',0),(385087,10697,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã®éšœå®³ã‚’è¿½åŠ ',0),(385088,10697,'pt','Agentes adicionado falha',0),(385089,10697,'ru','ÐÐ³ÐµÐ½Ñ‚Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ð» Ð¾Ñ‚ÐºÐ°Ð·',0),(385090,10697,'es','FallÃ³ Agregar Agente',0),(385091,10697,'de','-Agents hinzugefÃ¼gt Scheitern',0),(385092,10697,'en','Agents Added Failure',0),(385093,10698,'is','',0),(385094,10698,'dr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù†Ø¯ ',0),(385095,10698,'pr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù†Ø¯ ',0),(385096,10698,'tr','AracÄ±larÄ± baÅŸarÄ±yla eklendi',0),(385097,10698,'pl','Agenci dodano pomyÅ›lnie',0),(385098,10698,'bg','ÐÐ³ÐµÐ½Ñ‚Ð¸, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(385099,10698,'ur','Ø§ÛŒØ¬Ù†Ù¹ÙˆÚº Ù†Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(385100,10698,'sr','ÐÐ³ÐµÐ½Ñ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(385101,10698,'vi','ThÃªm Ä‘áº¡i lÃ½ thÃ nh cÃ´ng',0),(385102,10698,'af','Agente Suksesvol Bygevoeg',0),(385103,10698,'ro','AgenÅ£i adÄƒugat cu succes',0),(385104,10698,'et','Lisatud ained',0),(385105,10698,'si','Zastopniki, ki so dodani',0),(385106,10698,'ba','Agen ditambahkan berhasil',0),(385107,10698,'nl','Agenten met succes toegevoegd',0),(385108,10698,'fi','TekijÃ¶iden lisÃ¤Ã¤minen onnistui',0),(385109,10698,'no','Agenter lagt',0),(385110,10698,'da','Agenter tilfÃ¸jet',0),(385111,10698,'ko','ì—ì´ì „íŠ¸ê°€ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(385112,10698,'he','×¡×•×›× ×™× × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(385113,10698,'el','Î ÏÎ¬ÎºÏ„Î¿ÏÎµÏ‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(385114,10698,'zh','ä»£ç†å¢žåŠ æˆåŠŸ\r\n',0),(385115,10698,'sv','Agenter som lagts',0),(385116,10698,'it','Agenti aggiunti con successo',0),(385117,10698,'tl','',0),(385118,10698,'th','à¸•à¸±à¸§à¹à¸—à¸™à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(385119,10698,'hi','à¤à¤œà¥‡à¤‚à¤Ÿà¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(385120,10698,'ms','Ejen-ejen yang berjaya menambah',0),(385121,10698,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„ÙˆÙƒÙ„Ø§Ø¡ Ø¨Ù†Ø¬Ø§Ø­',0),(385122,10698,'fr','Agents ajoutÃ©s avec succÃ¨s',0),(385123,10698,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(385124,10698,'pt','Agentes adicionados com sucesso',0),(385125,10698,'ru','ÐÐ³ÐµÐ½Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(385126,10698,'es','Agents Agregados Exitosamente',0),(385127,10698,'de','Agenten erfolgreich hinzugefÃ¼gt',0),(385128,10698,'en','Agents Added Successfully',0),(385129,10699,'is','',0),(385130,10699,'dr','Ø­Ø°Ù Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(385131,10699,'pr','Ø­Ø°Ù Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(385132,10699,'tr','Ajanlar silme hatasÄ±',0),(385133,10699,'pl','Agenci usuwanie awarii',0),(385134,10699,'bg','ÐÐ³ÐµÐ½Ñ‚Ð¸ Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ Ð¾Ñ‚ÐºÐ°Ð·',0),(385135,10699,'ur','Ø§ÛŒØ¬Ù†Ù¹ÙˆÚº Ú©ÛŒ Ù†Ø§Ú©Ø§Ù…ÛŒ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(385136,10699,'sr','ÐÐ³ÐµÐ½Ñ‚Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÐµ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(385137,10699,'vi','Há»§y Ä‘áº¡i lÃ½ khÃ´ng thÃ nh cÃ´ng',0),(385138,10699,'af','Agente skrap versuim',0),(385139,10699,'ro','AgenÅ£i ÅŸterge eÅŸec',0),(385140,10699,'et','Agendid kustutada rike',0),(385141,10699,'si','Agenti izbrisati neuspeh',0),(385142,10699,'ba','Agen menghapus kegagalan',0),(385143,10699,'nl','Agenten verwijderen mislukking',0),(385144,10699,'fi','TekijÃ¶iden poistaminen epÃ¤onnistuminen',0),(385145,10699,'no','Agenter slette feil',0),(385146,10699,'da','Agenter slette fiasko',0),(385147,10699,'ko','ì—ì´ì „íŠ¸ ì‚­ì œ ì‹¤íŒ¨',0),(385148,10699,'he','×¡×•×›× ×™× ×œ×ž×—×•×§ ×›×©×œ×•×Ÿ',0),(385149,10699,'el','Î ÏÎ¬ÎºÏ„Î¿ÏÎµÏ‚ Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(385150,10699,'zh','ä»£ç†åˆ é™¤å¤±è´¥\r\n',0),(385151,10699,'sv','Ombud ta bort fel',0),(385152,10699,'it','Agenti eliminare il guasto',0),(385153,10699,'tl','',0),(385154,10699,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸•à¸±à¸§à¹à¸—à¸™à¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(385155,10699,'hi','à¤à¤œà¥‡à¤‚à¤Ÿà¥‹à¤‚ à¤¹à¤Ÿà¤¾à¤à¤ à¤µà¤¿à¤«à¤²à¤¤à¤¾',0),(385156,10699,'ms','Ejen-ejen menghapuskan kegagalan',0),(385157,10699,'ar','ÙØ´Ù„ Ø¥Ø²Ø§Ù„Ø© Ø§Ù„ÙˆÙƒÙ„Ø§Ø¡',0),(385158,10699,'fr','Agents supprimer Ã©chec',0),(385159,10699,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆå‰Šé™¤ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(385160,10699,'pt','Agentes excluir falha',0),(385161,10699,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð°Ð³ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ñ€Ð¾Ð²Ð°Ð»',0),(385162,10699,'es','FallÃ³ Eliminar Agentes',0),(385163,10699,'de','Agenten lÃ¶schen Fehler',0),(385164,10699,'en','Agents Delete Failure',0),(385165,10700,'is','',0),(385166,10700,'dr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯Ù†Ø¯ ',0),(385167,10700,'pr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯Ù†Ø¯ ',0),(385168,10700,'tr','AracÄ±larÄ± baÅŸarÄ±yla silindi',0),(385169,10700,'pl','Agenci przesâ”‚anie',0),(385170,10700,'bg','ÐÐ³ÐµÐ½Ñ‚Ð¸, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(385171,10700,'ur','Ø§ÛŒØ¬Ù†Ù¹ÙˆÚº Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(385172,10700,'sr','ÐÐ³ÐµÐ½Ñ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(385173,10700,'vi','Há»§y Ä‘áº¡i lÃ½ thÃ nh cÃ´ng',0),(385174,10700,'af','Agente Suksesvol Geskrap',0),(385175,10700,'ro','AgenÅ£i eliminÄƒ cu succes',0),(385176,10700,'et','Agendid edukalt kustutatud',0),(385177,10700,'si','Agenti uspeÅ¡no izbrisana',0),(385178,10700,'ba','Agen berhasil dihapus',0),(385179,10700,'nl','Agenten met succes verwijderd',0),(385180,10700,'fi','Aineet poistettu',0),(385181,10700,'no','Agenter slettet',0),(385182,10700,'da','Agenter slettet',0),(385183,10700,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì—ì´ì „íŠ¸',0),(385184,10700,'he','×¡×•×›× ×™× × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(385185,10700,'el','Î Î±ÏÎ¬Î³Î¿Î½Ï„ÎµÏ‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(385186,10700,'zh','ä»£ç†æˆåŠŸåˆ é™¤\r\n',0),(385187,10700,'sv','Agenter raderades',0),(385188,10700,'it','Agenti eliminati con successo',0),(385189,10700,'tl','',0),(385190,10700,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸•à¸±à¸§à¹à¸—à¸™à¸¥à¸šà¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(385191,10700,'hi','à¤à¤œà¥‡à¤‚à¤Ÿà¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(385192,10700,'ms','Ejen-ejen yang dihapuskan dengan jayanya',0),(385193,10700,'ar','Ø£Ø²ÙŠÙ„ Ø§Ù„ÙˆÙƒÙ„Ø§Ø¡ Ø¨Ù†Ø¬Ø§Ø­',0),(385194,10700,'fr','Agents supprimÃ©s avec succÃ¨s',0),(385195,10700,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(385196,10700,'pt','Agentes apagados com sucesso',0),(385197,10700,'ru','ÐÐ³ÐµÐ½Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(385198,10700,'es','Agentes Eliminados Exitosamente',0),(385199,10700,'de','Agenten erfolgreich gelÃ¶scht',0),(385200,10700,'en','Agents Deleted Successfully',0),(385201,10701,'is','',0),(385202,10701,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(385203,10701,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(385204,10701,'tr','AracÄ±larÄ±nÄ± gÃ¼ncelleÅŸtirme hatasÄ±',0),(385205,10701,'pl','AgentÃ³w aktualizacji brak',0),(385206,10701,'bg','ÐÐ³ÐµÐ½Ñ‚Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(385207,10701,'ur','Ø§ÛŒØ¬Ù†Ù¹ÙˆÚº Ú©ÛŒ Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(385208,10701,'sr','ÐÐ³ÐµÐ½Ñ‚Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ð¸ Ð³Ñ€ÐµÑˆÐºÐ°',0),(385209,10701,'vi','cáº­p nháº­t Ä‘áº¡i lÃ½ khÃ´ng thÃ nh cÃ´ng',0),(385210,10701,'af','Agente werk versuim',0),(385211,10701,'ro','AgenÅ£i actualizaÅ£i eÅŸec',0),(385212,10701,'et','Agendid uuendada jÃ¤tmine',0),(385213,10701,'si','Agenti posodobiti neuspeh',0),(385214,10701,'ba','Agen Update gagal',0),(385215,10701,'nl','Agenten bijwerken storing',0),(385216,10701,'fi','Agentit pÃ¤ivittÃ¤Ã¤ epÃ¤onnistuminen',0),(385217,10701,'no','Agenter oppdatere feil',0),(385218,10701,'da','Agenter opdatere fejl',0),(385219,10701,'ko','ì—ì´ì „íŠ¸ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(385220,10701,'he','×¡×•×›× ×™× ×œ×¢×“×›×Ÿ ×›×©×œ',0),(385221,10701,'el','Î ÏÎ¬ÎºÏ„Î¿ÏÎµÏ‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(385222,10701,'zh','ä»£ç†æ›´æ–°å¤±è´¥\r\n',0),(385223,10701,'sv','Agenter uppdatera fel',0),(385224,10701,'it','Agenti aggiornare fallimento',0),(385225,10701,'tl','',0),(385226,10701,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸•à¸±à¸§à¹à¸—à¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(385227,10701,'hi','à¤à¤œà¥‡à¤‚à¤Ÿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²à¤¤à¤¾',0),(385228,10701,'ms','Ejen-ejen Kemaskini Terakhir kegagalan',0),(385229,10701,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙˆÙƒÙ„Ø§Ø¡',0),(385230,10701,'fr','Mise Ã  jour de l\'Ã©chec des agents',0),(385231,10701,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã®æ›´æ–°ã®å¤±æ•—',0),(385232,10701,'pt','Agentes atualizar falha',0),(385233,10701,'ru','ÐÐ³ÐµÐ½Ñ‚Ñ‹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ±Ð¾Ð¹',0),(385234,10701,'es','FallÃ³ Actualizar Agentes',0),(385235,10701,'de','Agenten aktualisieren Fehler',0),(385236,10701,'en','Agents Update Failure',0),(385237,10702,'is','',0),(385238,10702,'dr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù†Ø¯ ',0),(385239,10702,'pr','Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù†Ø¯ ',0),(385240,10702,'tr','AracÄ±larÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(385241,10702,'pl','Agenci pomyÅ›lnie zaktualizowana',0),(385242,10702,'bg','ÐÐ³ÐµÐ½Ñ‚Ð¸, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(385243,10702,'ur','Ø§ÛŒØ¬Ù†Ù¹ÙˆÚº Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(385244,10702,'sr','ÐÐ³ÐµÐ½Ñ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(385245,10702,'vi','Cáº­p nháº­t Ä‘áº¡i lÃ½ thÃ nh cÃ´ng',0),(385246,10702,'af','Agente Suksesvol Opdateer',0),(385247,10702,'ro','AgenÅ£i actualizat cu succes',0),(385248,10702,'et','VÃ¤rskendatud mÃµjurid',0),(385249,10702,'si','Agenti uspeÅ¡no posodobljena',0),(385250,10702,'ba','Agen yang berhasil',0),(385251,10702,'nl','Agenten met succes bijgewerkt',0),(385252,10702,'fi','Agentit pÃ¤ivitetty',0),(385253,10702,'no','Agenter oppdatert',0),(385254,10702,'da','Agenter opdateret',0),(385255,10702,'ko','ì—ì´ì „íŠ¸ê°€ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(385256,10702,'he','×¡×•×›× ×™× ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(385257,10702,'el','Î ÏÎ¬ÎºÏ„Î¿ÏÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¸ÎµÎ¯ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(385258,10702,'zh','æˆåŠŸæ›´æ–°ä»£ç†\r\n',0),(385259,10702,'sv','Agenter uppdaterats',0),(385260,10702,'it','Agenti aggiornati con successo',0),(385261,10702,'tl','',0),(385262,10702,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸•à¸±à¸§à¹à¸—à¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(385263,10702,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤à¤œà¥‡à¤‚à¤Ÿ',0),(385264,10702,'ms','Ejen-ejen yang berjaya dikemas kini',0),(385265,10702,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„ÙˆÙƒÙ„Ø§Ø¡ Ø¨Ù†Ø¬Ø§Ø­',0),(385266,10702,'fr','Agents mis Ã  jour avec succÃ¨s',0),(385267,10702,'jp','ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(385268,10702,'pt','Agentes atualizados com sucesso',0),(385269,10702,'ru','ÐÐ³ÐµÐ½Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(385270,10702,'es','Agentes Actualizados Exitosamente',0),(385271,10702,'de','Agenten, die erfolgreich aktualisiert',0),(385272,10702,'en','Agents Updated Successfully',0),(385273,10703,'is','',0),(385274,10703,'dr','Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø±Ø§ÙŠ',0),(385275,10703,'pr','Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø±Ø§ÙŠ',0),(385276,10703,'tr','Binalar iÃ§in',0),(385277,10703,'pl','Budynki',0),(385278,10703,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð¸ Ð·Ð°',0),(385279,10703,'ur','Ø¹Ù…Ø§Ø±ØªÙˆÚº Ú©Û’ Ù„Ø¦Û’',0),(385280,10703,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð·Ð°',0),(385281,10703,'vi','TÃ²a nhÃ  cho',0),(385282,10703,'af','Geboue Vir',0),(385283,10703,'ro','ClÄƒdiri pentru',0),(385284,10703,'et','Hoonete jaoks',0),(385285,10703,'si','Stavbe za',0),(385286,10703,'ba','Bangunan untuk',0),(385287,10703,'nl','Gebouwen voor',0),(385288,10703,'fi','Rakennukset',0),(385289,10703,'no','Bygninger For',0),(385290,10703,'da','Bygninger til',0),(385291,10703,'ko','ê±´ë¬¼ì— ëŒ€ í•œ',0),(385292,10703,'he','×ž×‘× ×™×',0),(385293,10703,'el','ÎšÏ„Î¯ÏÎ¹Î± Î³Î¹Î±',0),(385294,10703,'zh','å»ºç­‘ç‰©\r\n',0),(385295,10703,'sv','Byggnader fÃ¶r',0),(385296,10703,'it','Edifici per',0),(385297,10703,'tl','',0),(385298,10703,'th','à¸­à¸²à¸„à¸²à¸£à¸ªà¸³à¸«à¸£à¸±à¸š',0),(385299,10703,'hi','à¤­à¤µà¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤',0),(385300,10703,'ms','Bangunan bagi',0),(385301,10703,'ar','Ø§Ù„Ù…Ø¨Ø§Ù†ÙŠ',0),(385302,10703,'fr','BÃ¢timents pour',0),(385303,10703,'jp','ãŸã‚ã®å»ºç‰©',0),(385304,10703,'pt','EdifÃ­cios para',0),(385305,10703,'ru','Ð—Ð´Ð°Ð½Ð¸Ñ Ð´Ð»Ñ',0),(385306,10703,'es','Edificios Por',0),(385307,10703,'de','GebÃ¤ude fÃ¼r',0),(385308,10703,'en','Buildings For',0),(385309,10704,'is','',0),(385310,10704,'dr','Ø«Ø§Ø¨Øª ',0),(385311,10704,'pr','Ø«Ø§Ø¨Øª ',0),(385312,10704,'tr','DÃ¼z',0),(385313,10704,'pl','Mieszkanie',0),(385314,10704,'bg','ÐŸÐ»Ð¾ÑÑŠÐº',0),(385315,10704,'ur','ÙÙ„ÛŒÙ¹',0),(385316,10704,'sr','Ð¡Ñ‚Ð°Ð½',0),(385317,10704,'vi','máº·t báº±ng',0),(385318,10704,'af','Plat',0),(385319,10704,'ro','Plat',0),(385320,10704,'et','Korter',0),(385321,10704,'si','Stanovanje',0),(385322,10704,'ba','Datar',0),(385323,10704,'nl','Flat',0),(385324,10704,'fi','Taulu',0),(385325,10704,'no','Flatskjerm',0),(385326,10704,'da','Flad',0),(385327,10704,'ko','í”Œëž«',0),(385328,10704,'he','×©×˜×•×—',0),(385329,10704,'el','Î•Ï€Î¯Ï€ÎµÎ´Î·Ï‚',0),(385330,10704,'zh','å›ºå®š\r\n',0),(385331,10704,'sv','Platt',0),(385332,10704,'it','Piatto',0),(385333,10704,'tl','',0),(385334,10704,'th','à¹à¸šà¸™',0),(385335,10704,'hi','à¤«à¥à¤²à¥ˆà¤Ÿ',0),(385336,10704,'ms','Rata',0),(385337,10704,'ar','Ù…Ø³Ø·Ø­Ø©',0),(385338,10704,'fr','Plat',0),(385339,10704,'jp','ãƒ•ãƒ©ãƒƒãƒˆ',0),(385340,10704,'pt','Apartamento',0),(385341,10704,'ru','ÐšÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ð°',0),(385342,10704,'es','Sin Intereses',0),(385343,10704,'de','Wohnung',0),(385344,10704,'en','Flat',0),(385345,10705,'is','',0),(385346,10705,'dr','(Ø§Ø®ÙŠØ±',0),(385347,10705,'pr','Ø¯Ø±ØµØ¯ Ú¯Ø°Ø´ØªÙ‡ (Ø§Ø®ÙŠØ±',0),(385348,10705,'tr','GeÃ§ yÃ¼zdesi',0),(385349,10705,'pl','Koniec procent',0),(385350,10705,'bg','ÐšÑŠÑÐ½Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(385351,10705,'ur','Ù…Ø±Ø­ÙˆÙ… ØªÙ†Ø§Ø³Ø¨',0),(385352,10705,'sr','ÐŸÐ¾ÐºÐ¾Ñ˜Ð½Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚',0),(385353,10705,'vi','tá»· lá»‡ muá»™n',0),(385354,10705,'af','Laat persentasie',0),(385355,10705,'ro','Procentul de Ã®ntÃ¢rziere',0),(385356,10705,'et','Hilja protsent',0),(385357,10705,'si','Pozno odstotek',0),(385358,10705,'ba','Akhir persentase',0),(385359,10705,'nl','Laat Percentage',0),(385360,10705,'fi','Lopulla osuus',0),(385361,10705,'no','Sen prosent',0),(385362,10705,'da','Sen procentdel',0),(385363,10705,'ko','ëŠ¦ì€ ë¹„ìœ¨',0),(385364,10705,'he','××—×•×– ×ž××•×—×¨',0),(385365,10705,'el','Î¤Î­Î»Î· Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(385366,10705,'zh','æ»žçº³ç™¾åˆ†æ¯”\r\n',0),(385367,10705,'sv','Sen procent',0),(385368,10705,'it','Percentuale di fine',0),(385369,10705,'tl','',0),(385370,10705,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸›à¸¥à¸²à¸¢',0),(385371,10705,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(385372,10705,'ms','Peratusan lewat',0),(385373,10705,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© ÙÙŠ ÙˆÙ‚Øª Ù…ØªØ£Ø®Ø±',0),(385374,10705,'fr','Pourcentage de fin',0),(385375,10705,'jp','å¾ŒåŠã®å‰²åˆ',0),(385376,10705,'pt','Porcentagem final',0),(385377,10705,'ru','ÐŸÐ¾Ð·Ð´Ð½Ð¸Ð¹ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(385378,10705,'es','Porcentaje por Atrasado',0),(385379,10705,'de','SpÃ¤ten Prozentsatz',0),(385380,10705,'en','Late Percentage',0),(385381,10706,'is','',0),(385382,10706,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(385383,10706,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ ',0),(385384,10706,'tr','Yeni kira',0),(385385,10706,'pl','Nowe umowy najmu',0),(385386,10706,'bg','ÐÐ¾Ð² Ð»Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð² Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(385387,10706,'ur','Ù†Ø¦ÛŒ Ø§Ù…ÛŒØ¯',0),(385388,10706,'sr','ÐÐ¾Ð²Ð¸ Ð·Ð°ÐºÑƒÐ¿',0),(385389,10706,'vi','thuÃª má»›i',0),(385390,10706,'af','Nuwe Huurkontrak',0),(385391,10706,'ro','Contract de leasing nou',0),(385392,10706,'et','Uue liisingu',0),(385393,10706,'si','Nove najemne pogodbe',0),(385394,10706,'ba','Sewa baru',0),(385395,10706,'nl','Nieuwe Lease',0),(385396,10706,'fi','Uutta puhtia',0),(385397,10706,'no','Ny leieavtale',0),(385398,10706,'da','Ny Lease',0),(385399,10706,'ko','ìƒˆë¡œìš´ ìž„ëŒ€',0),(385400,10706,'he','×—×›×™×¨×” ×—×“×©×”',0),(385401,10706,'el','ÎÎ­Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·',0),(385402,10706,'zh','æ–°ç§Ÿèµ\r\n',0),(385403,10706,'sv','Nytt hyresavtal',0),(385404,10706,'it','Nuovo contratto di locazione',0),(385405,10706,'tl','',0),(385406,10706,'th','à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¹ƒà¸«à¸¡à¹ˆ',0),(385407,10706,'hi','à¤¨à¤ˆ à¤²à¥€à¤œ',0),(385408,10706,'ms','Nafas baru',0),(385409,10706,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø¬Ø¯ÙŠØ¯',0),(385410,10706,'fr','Renouvellement du bail',0),(385411,10706,'jp','æ–°ã—ã„ãƒªãƒ¼ã‚¹',0),(385412,10706,'pt','Nova locaÃ§Ã£o',0),(385413,10706,'ru','ÐÐ¾Ð²Ð°Ñ Ð°Ñ€ÐµÐ½Ð´Ð°',0),(385414,10706,'es','Nuevo Arrendamiento',0),(385415,10706,'de','Neue Lebensperspektiven',0),(385416,10706,'en','New Lease',0),(385417,10707,'is','',0),(385418,10707,'dr','Ø«Ø§Ø¨Øª Ø¬Ø¯ÙŠØ¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(385419,10707,'pr','Ø«Ø§Ø¨Øª Ø¬Ø¯ÙŠØ¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(385420,10707,'tr','Yeni kira Daire',0),(385421,10707,'pl','Nowe wynajmowaÄ‡ mieszkanie',0),(385422,10707,'bg','ÐÐ¾Ð²Ð° Ð¾Ñ‚Ð´Ð°Ð²Ð° Ð°Ð¿Ð°Ñ€Ñ‚Ð°Ð¼ÐµÐ½Ñ‚',0),(385423,10707,'ur','Ù†Ø¦ÛŒ Ù„ÛŒØ² ÙÙ„ÛŒÙ¹',0),(385424,10707,'sr','ÐÐ¾Ð²Ð¸ Ð·Ð°ÐºÑƒÐ¿ ÑÑ‚Ð°Ð½Ð°',0),(385425,10707,'vi','máº·t báº±ng thuÃª má»›i',0),(385426,10707,'af','Nuwe Woonstel Huurkontrak',0),(385427,10707,'ro','Nou leasing plat',0),(385428,10707,'et','Uus korter rendile',0),(385429,10707,'si','New najem stanovanje',0),(385430,10707,'ba','Baru sewa datar',0),(385431,10707,'nl','Nieuwe Lease Flat',0),(385432,10707,'fi','Uusi vuokrata taulu',0),(385433,10707,'no','Nye leie leilighet',0),(385434,10707,'da','Ny Lease flad',0),(385435,10707,'ko','ìƒˆ ì•„íŒŒíŠ¸ ìž„ëŒ€',0),(385436,10707,'he','×—×“×© ×œ×”×—×›×™×¨ ×©×˜×•×—',0),(385437,10707,'el','ÎÎ­Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· ÎµÏ€Î¯Ï€ÎµÎ´Î·Ï‚',0),(385438,10707,'zh','æ–°å›ºå®šç§Ÿèµ\r\n',0),(385439,10707,'sv','Ny hyra lÃ¤genhet',0),(385440,10707,'it','Nuova locazione Flat',0),(385441,10707,'tl','',0),(385442,10707,'th','à¹ƒà¸«à¸¡à¹ˆà¹€à¸Šà¹ˆà¸²à¹à¸Ÿà¸¥à¸•',0),(385443,10707,'hi','à¤¨à¤ˆ à¤²à¥€à¤œ à¤«à¥à¤²à¥ˆà¤Ÿ',0),(385444,10707,'ms','Baru pajakan rata',0),(385445,10707,'ar','Ø¬Ø¯ÙŠØ¯ Ø¥ÙŠØ¬Ø§Ø± Ø´Ù‚Ø©',0),(385446,10707,'fr','Nouvelle location appartement',0),(385447,10707,'jp','æ–°ã—ã„ãƒ•ãƒ©ãƒƒãƒˆã‚’ãƒªãƒ¼ã‚¹',0),(385448,10707,'pt','Nova locaÃ§Ã£o apartamento',0),(385449,10707,'ru','ÐÐ¾Ð²Ð°Ñ Ð°Ñ€ÐµÐ½Ð´Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ð°',0),(385450,10707,'es','Nuevo Arrendamiento Precio Fijo',0),(385451,10707,'de','Neue Wohnung zu vermieten',0),(385452,10707,'en','New Lease Flat',0),(385453,10708,'is','',0),(385454,10708,'dr','Ø¯Ø±ØµØ¯ Ø¬Ø¯ÙŠØ¯ Ø§Ø¬Ø§Ø±Ù‡',0),(385455,10708,'pr','Ø¯Ø±ØµØ¯ Ø¬Ø¯ÙŠØ¯ Ø§Ø¬Ø§Ø±Ù‡',0),(385456,10708,'tr','Yeni kira yÃ¼zde',0),(385457,10708,'pl','Nowe umowy najmu procent',0),(385458,10708,'bg','ÐÐ¾Ð² Ð»Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð² Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ %',0),(385459,10708,'ur','Ù†Ø¦ÛŒ Ù„ÛŒØ² ÙÛŒØµØ¯',0),(385460,10708,'sr','ÐÐ¾Ð²Ð¸ Ð·Ð°ÐºÑƒÐ¿ %',0),(385461,10708,'vi','pháº§n trÄƒm thuÃª má»›i',0),(385462,10708,'af','Nuwe Huurkontrak Persentasie',0),(385463,10708,'ro','Nou contract de leasing la sutÄƒ',0),(385464,10708,'et','Uue liisingu protsenti',0),(385465,10708,'si','Nove najemne pogodbe odstotkov',0),(385466,10708,'ba','Baru Lease persen',0),(385467,10708,'nl','Nieuwe Lease procent',0),(385468,10708,'fi','Uusi vuokrasopimus prosenttia',0),(385469,10708,'no','Ny leieavtale prosent',0),(385470,10708,'da','Ny Lease procent',0),(385471,10708,'ko','ìƒˆë¡œìš´ ìž„ëŒ€ %',0),(385472,10708,'he','××—×•×– ×—×›×™×¨×” ×—×“×©',0),(385473,10708,'el','ÎÎ­Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(385474,10708,'zh','æ–°ç§Ÿèµç™¾åˆ†æ¯”\r\n',0),(385475,10708,'sv','Nya leasingavtal procent',0),(385476,10708,'it','Nuovo contratto di locazione per cento',0),(385477,10708,'tl','',0),(385478,10708,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²à¹ƒà¸«à¸¡à¹ˆ',0),(385479,10708,'hi','à¤¨à¤ˆ à¤²à¥€à¤œ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(385480,10708,'ms','Baru pajakan peratus',0),(385481,10708,'ar','ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(385482,10708,'fr','Nouveau bail pour cent',0),(385483,10708,'jp','æ–°ã—ã„ãƒªãƒ¼ã‚¹ %',0),(385484,10708,'pt','Nova locaÃ§Ã£o %',0),(385485,10708,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹ %',0),(385486,10708,'es','Nuevo Arrendamiento Porcentaje',0),(385487,10708,'de','Neue Leasing-Prozent',0),(385488,10708,'en','New Lease Percent',0),(385489,10709,'is','',0),(385490,10709,'dr','30 Ø±ÙˆØ² ',0),(385491,10709,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² 30 Ø±ÙˆØ² ',0),(385492,10709,'tr','30 gÃ¼n iÃ§inde',0),(385493,10709,'pl','Ponad 30 dni',0),(385494,10709,'bg','ÐÐ°Ð´ 30 Ð´Ð½Ð¸',0),(385495,10709,'ur','Û³Ù  Ø¯ÙÙ† Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(385496,10709,'sr','Ð’Ð¸ÑˆÐµ Ð¾Ð´ 30 Ð´Ð°Ð½Ð°',0),(385497,10709,'vi','quÃ¡ 30 ngÃ y',0),(385498,10709,'af','Meer As 30 Dae',0),(385499,10709,'ro','Peste 30 de zile',0),(385500,10709,'et','30 pÃ¤eva jooksul',0),(385501,10709,'si','VeÄ kot 30 dni',0),(385502,10709,'ba','Lebih dari 30 hari',0),(385503,10709,'nl','Meer dan 30 dagen',0),(385504,10709,'fi','Yli 30 pÃ¤ivÃ¤Ã¤',0),(385505,10709,'no','Over 30 dager',0),(385506,10709,'da','Over 30 dage',0),(385507,10709,'ko','30 ì¼ ë™ì•ˆ',0),(385508,10709,'he','×ž×¢×œ 30 ×™×•×',0),(385509,10709,'el','Î Î¬Î½Ï‰ Î±Ï€ÏŒ 30 Î·Î¼Î­ÏÎµÏ‚',0),(385510,10709,'zh','è¶…è¿‡30å¤©\r\n',0),(385511,10709,'sv','I 30 dagar',0),(385512,10709,'it','Oltre 30 giorni',0),(385513,10709,'tl','',0),(385514,10709,'th','à¸à¸§à¹ˆà¸² 30 à¸§à¸±à¸™',0),(385515,10709,'hi','30 à¤¦à¤¿à¤¨ à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(385516,10709,'ms','Lebih daripada 30 hari',0),(385517,10709,'ar','Ø£ÙƒØ«Ø± Ù…Ù† 30 ÙŠÙˆÙ…Ø§',0),(385518,10709,'fr','Plus de 30 jours',0),(385519,10709,'jp','30 æ—¥é–“',0),(385520,10709,'pt','Mais de 30 dias',0),(385521,10709,'ru','Ð‘Ð¾Ð»ÐµÐµ 30 Ð”Ð½ÐµÐ¹',0),(385522,10709,'es','MÃ¡s Que 30 DÃ­as',0),(385523,10709,'de','Ãœber 30 Tage',0),(385524,10709,'en','Over 30 Days',0),(385525,10710,'is','',0),(385526,10710,'dr','30 Ø±ÙˆØ² ÙÛŒØµØ¯ Ø§Ø®ÙŠØ±',0),(385527,10710,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² 30 Ø±ÙˆØ² Ø¯Ø±ØµØ¯ Ø§Ø®ÙŠØ±',0),(385528,10710,'tr','30 gÃ¼n geÃ§ yÃ¼zdesi',0),(385529,10710,'pl','Ponad 30 dni koniec procent',0),(385530,10710,'bg','ÐšÑŠÑÐ½Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð½Ð°Ð´ 30 Ð´Ð½Ð¸',0),(385531,10710,'ur','30 Ø³Û’ Ø²Ø§Ø¦Ø¯ Ø¯Ù† Ù…Ø±Ø­ÙˆÙ… ØªÙ†Ø§Ø³Ø¨',0),(385532,10710,'sr','ÐŸÐ¾ÐºÐ¾Ñ˜Ð½Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð¿Ñ€ÐµÐºÐ¾ 30 Ð´Ð°Ð½Ð°',0),(385533,10710,'vi','pháº§n trÄƒm cháº­m quÃ¡ 30 ngÃ y',0),(385534,10710,'af','Oor 30 dae laat persentasie',0),(385535,10710,'ro','Peste 30 de zile Ã®ntÃ¢rziere procent',0),(385536,10710,'et','Ãœle 30 pÃ¤eva lÃµpus protsent',0),(385537,10710,'si','VeÄ kot 30 dni pozno odstotek',0),(385538,10710,'ba','Lebih dari 30 hari akhir persentase',0),(385539,10710,'nl','Meer dan 30 dagen laat Percentage',0),(385540,10710,'fi','Yli 30 pÃ¤ivÃ¤Ã¤ myÃ¶hÃ¤ssÃ¤ prosenttiosuus',0),(385541,10710,'no','Over 30 dager sen prosent',0),(385542,10710,'da','Over 30 dage forsinket procentdel',0),(385543,10710,'ko','30 ì¼ ëŠ¦ì€ ë¹„ìœ¨',0),(385544,10710,'he','××—×•×– ×ž××•×—×¨ ×™×•×ª×¨ ×ž- 30 ×™×ž×™×',0),(385545,10710,'el','Î¤Î­Î»Î· Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ 30 Î·Î¼Î­ÏÎµÏ‚',0),(385546,10710,'zh','é€¾æœŸè¶…è¿‡30å¤©çš„ç™¾åˆ†æ¯”\r\n',0),(385547,10710,'sv','Ã–ver 30 dagar sen procent',0),(385548,10710,'it','Percentuale tardiva oltre 30 giorni',0),(385549,10710,'tl','',0),(385550,10710,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸Šà¹‰à¸²à¸à¸§à¹ˆà¸² 30 à¸§à¸±à¸™',0),(385551,10710,'hi','30 à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¦à¤¿à¤¨ à¤¦à¥‡à¤° à¤¸à¥‡ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(385552,10710,'ms','Peratusan lewat lebih daripada 30 hari',0),(385553,10710,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ø£ÙˆØ§Ø®Ø± Ø£ÙŠØ§Ù… Ù…Ø§ ÙŠØ²ÙŠØ¯ Ø¹Ù„Ù‰ 30',0),(385554,10710,'fr','Pourcentage fin de plus de 30 jours',0),(385555,10710,'jp','ä»¥ä¸Š 30 æ—¥å¾ŒæœŸå‰²åˆ',0),(385556,10710,'pt','Percentagem final de mais de 30 dias',0),(385557,10710,'ru','ÐŸÐ¾Ð·Ð´Ð½Ð¸Ð¹ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ ÑÐ²Ñ‹ÑˆÐµ 30 Ð´Ð½ÐµÐ¹',0),(385558,10710,'es','MÃ¡s Que 30 DÃ­as Atrasado Porcentaje',0),(385559,10710,'de','Mehr als 30 Tage zu spÃ¤t Prozentsatz',0),(385560,10710,'en','Over 30 Days Late Percentage',0),(385561,10711,'is','',0),(385562,10711,'dr','60 Ø±ÙˆØ² ',0),(385563,10711,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² 60 Ø±ÙˆØ² ',0),(385564,10711,'tr','60 gÃ¼n iÃ§inde',0),(385565,10711,'pl','Ponad 60 dni',0),(385566,10711,'bg','ÐÐ°Ð´ 60 Ð´Ð½Ð¸',0),(385567,10711,'ur','60 Ø¯Ù† Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(385568,10711,'sr','Ð’Ð¸ÑˆÐµ Ð¾Ð´ 60 Ð´Ð°Ð½Ð°',0),(385569,10711,'vi','quÃ¡ 60 ngÃ y',0),(385570,10711,'af','Meer As 60 Dae',0),(385571,10711,'ro','Peste 60 de zile',0),(385572,10711,'et','Ãœle 60 pÃ¤eva',0),(385573,10711,'si','VeÄ kot 60 dni',0),(385574,10711,'ba','Lebih dari 60 hari',0),(385575,10711,'nl','Meer dan 60 dagen',0),(385576,10711,'fi','Yli 60 pÃ¤ivÃ¤Ã¤',0),(385577,10711,'no','Over 60 dager',0),(385578,10711,'da','Over 60 dage',0),(385579,10711,'ko','60 ì¼ ì´ìƒ',0),(385580,10711,'he','×‘×ž×©×š 60 ×™×ž×™×',0),(385581,10711,'el','Î Î¬Î½Ï‰ Î±Ï€ÏŒ 60 Î·Î¼Î­ÏÎµÏ‚',0),(385582,10711,'zh','è¶…è¿‡60å¤©\r\n',0),(385583,10711,'sv','Under 60 dagar',0),(385584,10711,'it','Oltre 60 giorni',0),(385585,10711,'tl','',0),(385586,10711,'th','à¸à¸§à¹ˆà¸² 60 à¸§à¸±à¸™',0),(385587,10711,'hi','60 à¤¦à¤¿à¤¨ à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(385588,10711,'ms','Lebih daripada 60 hari',0),(385589,10711,'ar','Ø£ÙƒØ«Ø± Ù…Ù† 60 ÙŠÙˆÙ…Ø§',0),(385590,10711,'fr','Plus de 60 jours',0),(385591,10711,'jp','60 æ—¥é–“',0),(385592,10711,'pt','Mais de 60 dias',0),(385593,10711,'ru','Ð‘Ð¾Ð»ÐµÐµ 60 Ð”Ð½ÐµÐ¹',0),(385594,10711,'es','MÃ¡s Que 60 DÃ­as',0),(385595,10711,'de','Mehr als 60 Tage',0),(385596,10711,'en','Over 60 Days',0),(385597,10712,'is','',0),(385598,10712,'dr','60 Ø±ÙˆØ² ÙÛŒØµØ¯ Ø§Ø®ÙŠØ±',0),(385599,10712,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² 60 Ø±ÙˆØ² Ø¯Ø±ØµØ¯ Ø§Ø®ÙŠØ±',0),(385600,10712,'tr','60 gÃ¼n geÃ§ yÃ¼zdesi',0),(385601,10712,'pl','Ponad 60 dni koniec procent',0),(385602,10712,'bg','ÐÐ°Ð´ 60 Ð´Ð½Ð¸ ÐºÑŠÑÐ½Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(385603,10712,'ur','Ù…Ø±Ø­ÙˆÙ… Ù¾Ø± 60 Ø¯Ù†ÙˆÚº Ú©ÛŒ ÙÛŒ ØµØ¯',0),(385604,10712,'sr','Ð’Ð¸ÑˆÐµ Ð¾Ð´ 60 Ð´Ð°Ð½Ð° ÐºÐ°ÑÐ½Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚',0),(385605,10712,'vi','pháº§n trÄƒm cháº­m quÃ¡ 60 ngÃ y',0),(385606,10712,'af','Oor 60 dae laat persentasie',0),(385607,10712,'ro','Peste 60 de zile de Ã®ntÃ¢rziere procent',0),(385608,10712,'et','Ãœle 60 pÃ¤eva lÃµpus protsent',0),(385609,10712,'si','VeÄ kot 60 dni prepozno odstotek',0),(385610,10712,'ba','Lebih dari 60 hari terlambat persentase',0),(385611,10712,'nl','Meer dan 60 dagen laat Percentage',0),(385612,10712,'fi','Yli 60 pÃ¤ivÃ¤Ã¤ myÃ¶hÃ¤ssÃ¤ prosenttiosuus',0),(385613,10712,'no','Over 60 dager sent prosent',0),(385614,10712,'da','Over 60 dage forsinket procentdel',0),(385615,10712,'ko','60 ì—¬ ì¼ ëŠ¦ì€ ë¹„ìœ¨',0),(385616,10712,'he','××—×•×– ×ž××•×—×¨ ×™×•×ª×¨ ×ž 60 ×™×ž×™×',0),(385617,10712,'el','Î¤Î­Î»Î· Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ 60 Î·Î¼Î­ÏÎµÏ‚',0),(385618,10712,'zh','é€¾æœŸè¶…è¿‡60å¤©çš„ç™¾åˆ†æ¯”\r\n',0),(385619,10712,'sv','Ã–ver 60 dagar sen procent',0),(385620,10712,'it','Percentuale di ritardo oltre 60 giorni',0),(385621,10712,'tl','',0),(385622,10712,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸Šà¹‰à¸²à¸à¸§à¹ˆà¸² 60 à¸§à¸±à¸™',0),(385623,10712,'hi','60 à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¦à¤¿à¤¨ à¤¦à¥‡à¤° à¤¸à¥‡ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(385624,10712,'ms','Peratusan lewat lebih daripada 60 hari',0),(385625,10712,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ø£ÙˆØ§Ø®Ø± Ø£ÙŠØ§Ù… Ù…Ø§ ÙŠØ²ÙŠØ¯ Ø¹Ù„Ù‰ 60',0),(385626,10712,'fr','Pourcentage fin de plus de 60 jours',0),(385627,10712,'jp','ä»¥ä¸Š 60 æ—¥é…ã‚Œã¦å‰²åˆ',0),(385628,10712,'pt','Percentagem final de mais de 60 dias',0),(385629,10712,'ru','ÐŸÐ¾Ð·Ð´Ð½Ð¸Ð¹ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð±Ð¾Ð»ÐµÐµ 60 Ð´Ð½ÐµÐ¹',0),(385630,10712,'es','MÃ¡s Que 60 DÃ­as Atrasado Porcentaje',0),(385631,10712,'de','Mehr als 60 Tage spÃ¤t Prozentsatz',0),(385632,10712,'en','Over 60 Days Late Percentage',0),(385633,10713,'is','',0),(385634,10713,'dr','90 Ø±ÙˆØ² ÙÛŒØµØ¯ Ø§Ø®ÙŠØ±',0),(385635,10713,'pr','Ø¨ÙŠØ´ØªØ± Ø§Ø² 90 Ø±ÙˆØ² Ø¯Ø±ØµØ¯ Ø§Ø®ÙŠØ±',0),(385636,10713,'tr','90 gÃ¼n geÃ§ yÃ¼zdesi',0),(385637,10713,'pl','Koniec procent ponad 90 dni',0),(385638,10713,'bg','ÐÐ°Ð´ 90 Ð´Ð½Ð¸ ÐºÑŠÑÐ½Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(385639,10713,'ur','Ø²ÛŒØ§Ø¯Û 90 Ø¯Ù†ÙˆÚº Ù…Ø±Ø­ÙˆÙ… ØªÙ†Ø§Ø³Ø¨',0),(385640,10713,'sr','ÐŸÐ¾ÐºÐ¾Ñ˜Ð½Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð¿Ñ€ÐµÐºÐ¾ 90 Ð´Ð°Ð½Ð°',0),(385641,10713,'vi','pháº§n trÄƒm cháº­m quÃ¡ 90 ngÃ y',0),(385642,10713,'af','Meer as 90 dae laat persentasie',0),(385643,10713,'ro','Peste 90 de zile de Ã®ntÃ¢rziere procent',0),(385644,10713,'et','Ãœle 90 pÃ¤eva hilinenud protsent',0),(385645,10713,'si','Pozno odstotek veÄ kot 90 dni',0),(385646,10713,'ba','Lebih dari 90 hari akhir persentase',0),(385647,10713,'nl','Meer dan 90 dagen laat Percentage',0),(385648,10713,'fi','Yli 90 pÃ¤ivÃ¤Ã¤ myÃ¶hÃ¤ssÃ¤ prosenttiosuus',0),(385649,10713,'no','Over 90 dager sen prosent',0),(385650,10713,'da','Over 90 dage forsinket procentdel',0),(385651,10713,'ko','90 ì¼ ëŠ¦ì€ ë¹„ìœ¨',0),(385652,10713,'he','××—×•×– ×ž××•×—×¨ ×™×•×ª×¨ ×ž 90 ×™×•×',0),(385653,10713,'el','Î¤Î­Î»Î· Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ 90 Î·Î¼Î­ÏÎµÏ‚',0),(385654,10713,'zh','é€¾æœŸ90å¤©ä»¥ä¸Šçš„ç™¾åˆ†æ¯”\r\n',0),(385655,10713,'sv','Ã–ver 90 dagar sen procent',0),(385656,10713,'it','Percentuale di ritardo oltre 90 giorni',0),(385657,10713,'tl','',0),(385658,10713,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸Šà¹‰à¸²à¸à¸§à¹ˆà¸² 90 à¸§à¸±à¸™',0),(385659,10713,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤• 90 à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤¦à¤¿à¤µà¤‚à¤—à¤¤ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(385660,10713,'ms','Peratusan lewat lebih dari 90 hari',0),(385661,10713,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ø£ÙˆØ§Ø®Ø± Ø£ÙŠØ§Ù… Ù…Ø§ ÙŠØ²ÙŠØ¯ Ø¹Ù„Ù‰ 90',0),(385662,10713,'fr','Plus de 90 jours fin pourcentage',0),(385663,10713,'jp','ä»¥ä¸Š 90 æ—¥å¾ŒåŠå‰²åˆ',0),(385664,10713,'pt','Percentagem final de mais de 90 dias',0),(385665,10713,'ru','ÐŸÐ¾Ð·Ð´Ð½Ð¸Ð¹ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð±Ð¾Ð»ÐµÐµ 90 Ð´Ð½ÐµÐ¹',0),(385666,10713,'es','MÃ¡s Que 90 DÃ­as Atrasado Porcentaje',0),(385667,10713,'de','Mehr als 90 Tage spÃ¤t Prozentsatz',0),(385668,10713,'en','Over 90 Days Late Percentage',0),(385669,10714,'is','',0),(385670,10714,'dr','ØªØ¬Ø¯ÙŠØ¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(385671,10714,'pr','ØªØ¬Ø¯ÙŠØ¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(385672,10714,'tr','Kira yenileme',0),(385673,10714,'pl','Odnowienia dzierÅ¼awy',0),(385674,10714,'bg','ÐŸÐ¾Ð´Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(385675,10714,'ur','Ù„ÛŒØ² Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯',0),(385676,10714,'sr','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚Ð¸ Ð·Ð°ÐºÑƒÐ¿',0),(385677,10714,'vi','lÃ m má»›i láº¡i há»£p Ä‘á»“ng thuÃª ',0),(385678,10714,'af','Hernu Verhurings',0),(385679,10714,'ro','ReÃ®nnoi leasing',0),(385680,10714,'et','ÃœÃ¼rilepingu pikendamisest',0),(385681,10714,'si','Obnovijo zakup',0),(385682,10714,'ba','Memperbaharui sewa',0),(385683,10714,'nl','Lease vernieuwen',0),(385684,10714,'fi','Uusi vuokrasopimus',0),(385685,10714,'no','Fornye leieavtalen',0),(385686,10714,'da','Forny rettigheden',0),(385687,10714,'ko','ìž„ëŒ€ ê°±ì‹ ',0),(385688,10714,'he','×œ×—×“×© ×—×•×–×” ×”×©×›×™×¨×•×ª',0),(385689,10714,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ· Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(385690,10714,'zh','ç»­è®¢ç§Ÿèµ\r\n',0),(385691,10714,'sv','FÃ¶rnya lÃ¥n',0),(385692,10714,'it','Rinnovare il contratto di locazione',0),(385693,10714,'tl','',0),(385694,10714,'th','à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(385695,10714,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥‹ à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤',0),(385696,10714,'ms','Memperbaharui pajakan',0),(385697,10714,'ar','ØªØ¬Ø¯ÙŠØ¯ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(385698,10714,'fr','Renouveler le bail',0),(385699,10714,'jp','ãƒªãƒ¼ã‚¹ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(385700,10714,'pt','Renovar concessÃ£o',0),(385701,10714,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(385702,10714,'es','Renovar Arrendamiento',0),(385703,10714,'de','Lease erneuern',0),(385704,10714,'en','Renew Lease',0),(385705,10715,'is','',0),(385706,10715,'dr','(Ø«Ø§Ø¨Øª',0),(385707,10715,'pr','ØªØ¬Ø¯ÙŠØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ø¢Ù¾Ø§Ø±ØªÙ…Ø§Ù† (Ø«Ø§Ø¨Øª',0),(385708,10715,'tr','Kira yenileme daire',0),(385709,10715,'pl','Odnowienia dzierÅ¼awy z pÅ‚askim',0),(385710,10715,'bg','ÐŸÐ¾Ð´Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ Ð·Ð° Ð½Ð°ÐµÐ¼ Ñ Ð¿Ð»Ð¾ÑÑŠÐº',0),(385711,10715,'ur','Ù„ÛŒØ² ÙÙ„ÛŒÙ¹',0),(385712,10715,'sr','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚Ð¸ Ð·Ð°ÐºÑƒÐ¿ ÑÑ‚Ð°Ð½Ð°',0),(385713,10715,'vi','lÃ m má»›i láº¡i máº·t báº±ng thuÃª',0),(385714,10715,'af','Huurkontrak hernu plat',0),(385715,10715,'ro','ReÃ®nnoi leasing plat',0),(385716,10715,'et','Pikendada Ã¼Ã¼rilepingu korter',0),(385717,10715,'si','Obnoviti najem stanovanje',0),(385718,10715,'ba','Memperbaharui sewa datar',0),(385719,10715,'nl','Lease vernieuwen Flat',0),(385720,10715,'fi','Uusi vuokrasopimus tasainen',0),(385721,10715,'no','Fornye leieavtalen Flat',0),(385722,10715,'da','Forny rettigheden flad',0),(385723,10715,'ko','ìž„ëŒ€ë¥¼ ê°±ì‹  í”Œëž«',0),(385724,10715,'he','×œ×—×“×© ×—×•×–×” ×”×©×›×™×¨×•×ª ×©×˜×•×—',0),(385725,10715,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ· Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î·Ï‚',0),(385726,10715,'zh','ç»­è®¢å›ºå®šç§Ÿèµ\r\n',0),(385727,10715,'sv','FÃ¶rnya lÃ¥n platt',0),(385728,10715,'it','Rinnovare il contratto di locazione appartamento',0),(385729,10715,'tl','',0),(385730,10715,'th','à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¹à¸Ÿà¸¥à¸•',0),(385731,10715,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥‹ à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤«à¥à¤²à¥ˆà¤Ÿ',0),(385732,10715,'ms','Memperbaharui pajakan rata',0),(385733,10715,'ar','ØªØ¬Ø¯ÙŠØ¯ Ø¹Ù‚Ø¯ Ø¥ÙŠØ¬Ø§Ø± Ø´Ù‚Ø©',0),(385734,10715,'fr','Renouveler le bail d\'appartement',0),(385735,10715,'jp','ãƒªãƒ¼ã‚¹æ›´æ–°ãƒ•ãƒ©ãƒƒãƒˆ',0),(385736,10715,'pt','Renovar a locaÃ§Ã£o apartamento',0),(385737,10715,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹ ÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ð°',0),(385738,10715,'es','Renovar Arrendamiento Fijo',0),(385739,10715,'de','Lease erneuern Flat',0),(385740,10715,'en','Renew Lease Flat',0),(385741,10716,'is','',0),(385742,10716,'dr','Ø¯Ø±ØµØ¯ ØªØ¬Ø¯ÙŠØ¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(385743,10716,'pr','Ø¯Ø±ØµØ¯ ØªØ¬Ø¯ÙŠØ¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(385744,10716,'tr','KirayÄ± yÃ¼zde yenilemek',0),(385745,10716,'pl','OdnowiÄ‡ dzierÅ¼awÄ™ procent',0),(385746,10716,'bg','ÐŸÐ¾Ð´Ð½Ð¾Ð²Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(385747,10716,'ur','ÙÛŒØµØ¯ Ù„ÛŒØ² Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯',0),(385748,10716,'sr','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚Ð¸ Ð·Ð°ÐºÑƒÐ¿ %',0),(385749,10716,'vi','lÃ m má»›i láº¡i tá»· lá»‡ thuÃª ',0),(385750,10716,'af','Hernu Huurkontrak Persentasie',0),(385751,10716,'ro','ReÃ®nnoire contract de leasing la sutÄƒ',0),(385752,10716,'et','Pikendada Ã¼Ã¼rilepingu protsenti',0),(385753,10716,'si','Obnovijo zakup odstotkov',0),(385754,10716,'ba','Memperbaharui sewa persen',0),(385755,10716,'nl','Procent van de Lease vernieuwen',0),(385756,10716,'fi','Uusia vuokrasopimuksen prosenttia',0),(385757,10716,'no','Fornye leieavtalen prosent',0),(385758,10716,'da','Forny leasingkontrakt procent',0),(385759,10716,'ko','ìž„ëŒ€ % ê°±ì‹ ',0),(385760,10716,'he','×—×™×“×•×© ×”×—×›×™×¨×” ××—×•×–×™×',0),(385761,10716,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ· Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(385762,10716,'zh','ç»­è®¢ç§Ÿèµç™¾åˆ†æ¯”\r\n',0),(385763,10716,'sv','FÃ¶rnya lÃ¥net procent',0),(385764,10716,'it','Rinnovare il Lease per cento',0),(385765,10716,'tl','',0),(385766,10716,'th','à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œ',0),(385767,10716,'hi','à¤²à¥€à¤œ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¥‹ à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤',0),(385768,10716,'ms','Memperbaharui pajakan peratus',0),(385769,10716,'ar','ØªØ¬Ø¯ÙŠØ¯ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(385770,10716,'fr','Renouveler le bail pour cent',0),(385771,10716,'jp','æ›´æ–°ãƒªãƒ¼ã‚¹ %',0),(385772,10716,'pt','Renovar o contrato de arrendamento por cento',0),(385773,10716,'ru','ÐŸÑ€Ð¾Ð´Ð»Ð¸Ñ‚ÑŒ Ð°Ñ€ÐµÐ½Ð´Ñƒ %',0),(385774,10716,'es','Renovar Arendamiento Porcentaje',0),(385775,10716,'de','Prozent der Lease erneuern',0),(385776,10716,'en','Renew Lease Percent',0),(385777,10717,'is','',0),(385778,10717,'dr','(ÙˆØ§Ø¨Ø³ØªÚ¯ÙŠ ) Ø¨Ø§ Ø§ÙŠÙ† Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¯Ø§Ø±Ø¯ ',0),(385779,10717,'pr','Ø§ÙŠÙ† Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ø§Ø±ØªØ¨Ø§Ø·ÙŠ (ÙˆØ§Ø¨Ø³ØªÚ¯ÙŠ ) Ø¨Ø§ Ø§ÙŠÙ† Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¯Ø§Ø±Ø¯ ',0),(385780,10717,'tr','Bu Ajan zaten bir iliÅŸki ile bu bina vardÄ±r.',0),(385781,10717,'pl','Åšrodek ten ma juÅ¼ skojarzenie z tym budynku',0),(385782,10717,'bg','Ð¢Ð¾Ð·Ð¸ Ð°Ð³ÐµÐ½Ñ‚ Ð²ÐµÑ‡Ðµ Ð¸Ð¼Ð° Ð²Ñ€ÑŠÐ·ÐºÐ° Ñ Ñ‚Ð¾Ð²Ð° ÑÐ³Ñ€Ð°Ð´Ð°',0),(385783,10717,'ur','ÛŒÛ Ø§ÛŒØ¬Ù†Ù¹ Ù…ÛŒÚº Ù¾ÛÙ„Û’ ÛÛŒ Ø§Ø³ Ú©Û’ Ø³Ø§ØªÚ¾ Ú©Ø³ÛŒ Ø§ÛŒØ³ÙˆØ³ÛŒ Ø§ÛŒØ´Ù† Ø¹Ù…Ø§Ø±Øª ÛÛ’',0),(385784,10717,'sr','ÐžÐ²Ð°Ñ˜ ÐÐ³ÐµÐ½Ñ‚ Ñ˜Ðµ Ð²ÐµÑ› Ð¿Ð¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐ° Ñ Ð¾Ð²Ð¾ Ð·Ð³Ñ€Ð°Ð´Ð°',0),(385785,10717,'vi','TÃ¡c nhÃ¢n nÃ y Ä‘Ã£ cÃ³ má»™t hiá»‡p há»™i vá»›i Ä‘iá»u nÃ y xÃ¢y dá»±ng',0),(385786,10717,'af','Hierdie Agent het reeds \'n vereniging met hierdie gebou',0),(385787,10717,'ro','Acest Agent are deja o asociere cu aceastÄƒ clÄƒdire',0),(385788,10717,'et','See aine on juba Ã¼histu selle hoone',0),(385789,10717,'si','Ta Agent Å¾e ima povezavo s tem stavbe',0),(385790,10717,'ba','Agen ini sudah memiliki asosiasi dengan ini bangunan',0),(385791,10717,'nl','Deze Agent heeft al een associatie met dit gebouw',0),(385792,10717,'fi','TÃ¤mÃ¤ agentti jo on yhdessÃ¤ rakennuksessa',0),(385793,10717,'no','Denne agenten har allerede en tilknytning med denne bygningen',0),(385794,10717,'da','Denne Agent har allerede en tilknytning til denne bygning',0),(385795,10717,'ko','ì´ ì—ì´ì „íŠ¸ëŠ” ì´ë¯¸ì´ í˜‘íšŒ ê±´ë¬¼',0),(385796,10717,'he','×¡×•×›×Ÿ ×–×” ×›×‘×¨ ×™×© ××¡×•×¦×™××¦×™×” ×¢× ×–×” ×‘× ×™×™×Ÿ',0),(385797,10717,'el','Î‘Ï…Ï„ÏŒÏ‚ Î¿ Ï€ÏÎ¬ÎºÏ„Î¿ÏÎ±Ï‚ Î­Ï‡ÎµÎ¹ Î®Î´Î· ÏƒÏ…Î½Î´Î­ÏƒÎµÏ‰Ï‚ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÏ„Î¯ÏÎ¹Î¿',0),(385798,10717,'zh','è¿™ä¸ªä»£ç†å·²ç»æœ‰ä¸€ä¸ªè¿™ä¸ªå»ºç­‘åä¼š\r\n',0),(385799,10717,'sv','Denna Agent har redan en Association med denna byggnad',0),(385800,10717,'it','Questo agente Ã¨ giÃ  un\'associazione con questo edificio',0),(385801,10717,'tl','',0),(385802,10717,'th','à¹€à¸­à¹€à¸ˆà¸™à¸•à¹Œà¸™à¸µà¹‰à¹à¸¥à¹‰à¸§à¸„à¸§à¸²à¸¡à¸ªà¸±à¸¡à¸žà¸±à¸™à¸˜à¹Œà¸™à¸µà¹‰à¸­à¸²à¸„à¸²à¸£',0),(385803,10717,'hi','à¤‡à¤¸ à¤à¤œà¥‡à¤‚à¤Ÿ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤¸ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤à¤¸à¥‹à¤¸à¤¿à¤à¤¶à¤¨ à¤­à¤µà¤¨ à¤¹à¥ˆ',0),(385804,10717,'ms','Ejen ini sudah pun mempunyai perkaitan dengan bangunan',0),(385805,10717,'ar','Ù‡Ø°Ø§ Ø§Ù„Ø¹Ø§Ù…Ù„ Ù„Ø¯ÙŠÙ‡Ø§ Ø¨Ø§Ù„ÙØ¹Ù„ Ø§Ù‚ØªØ±Ø§Ù† Ù…Ø¹ Ù‡Ø°Ø§ Ø§Ù„Ù…Ø¨Ù†Ù‰',0),(385806,10717,'fr','Cet Agent a dÃ©jÃ  une liaison avec ce bÃ¢timent',0),(385807,10717,'jp','ã“ã®ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã¯æ—¢ã«ã“ã‚Œã¨é–¢é€£ã®å»ºç‰©',0),(385808,10717,'pt','Este agente jÃ¡ tem uma associaÃ§Ã£o com este edifÃ­cio',0),(385809,10717,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð°Ð³ÐµÐ½Ñ‚ ÑƒÐ¶Ðµ Ð¸Ð¼ÐµÐµÑ‚ ÑÐ²ÑÐ·ÑŒ Ñ ÑÑ‚Ð¸Ð¼ Ð·Ð´Ð°Ð½Ð¸Ðµ',0),(385810,10717,'es','Este Agente Ya Tiene una AsociaciÃ³n Con Este Edificio',0),(385811,10717,'de','Dieser Agent verfÃ¼gt bereits Ã¼ber eine Vereinigung mit diesem GebÃ¤ude',0),(385812,10717,'en','This Agent Already Has an Association With This Building',0),(385813,10718,'is','',0),(385814,10718,'dr','On-Site.com ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø¬Ø§Ø±ÙŠ Ø¯Ø± Ø³Ø§ÙŠØª ',0),(385815,10718,'pr',' On-Site.com ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø¬Ø§Ø±ÙŠ Ø¯Ø± Ø³Ø§ÙŠØª ',0),(385816,10718,'tr','GeÃ§erli tarih-Site.com kurulumlarÄ±',0),(385817,10718,'pl','BieÅ¼Ä…cej konfiguracji na Site.com',0),(385818,10718,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸Ñ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð½Ð° Ð½Ð° Site.com',0),(385819,10718,'ur','Ù¾Ø± Site.com Ú©Û’ Ø­Ø§Ù„ÛŒÛ Ø³ÛŒÙ¹Ùˆ',0),(385820,10718,'sr','Ð¦ÑƒÑ€Ñ€ÐµÐ½Ñ‚ ÐžÐ½-Site.com Ð¡ÐµÑ‚ÑƒÐ¿Ñ',0),(385821,10718,'vi','hiá»‡n nay thiáº¿t láº­p on-site.com ',0),(385822,10718,'af','Huidige op-Site.com Setups',0),(385823,10718,'ro','Curent setÄƒri de pe-Site.com',0),(385824,10718,'et','Praeguse linna Site.com seadistused',0),(385825,10718,'si','Trenutno na Site.com postavitve',0),(385826,10718,'ba','Saat ini pada Site.com setup',0),(385827,10718,'nl','Huidige op-Site.com Setups',0),(385828,10718,'fi','Nykyinen-Site.com asetelmia',0),(385829,10718,'no','Gjeldende pÃ¥-Site.com oppsett',0),(385830,10718,'da','NuvÃ¦rende pÃ¥-Site.com opsÃ¦tninger',0),(385831,10718,'ko','í˜„ìž¬-Site.com ì„¤ì •',0),(385832,10718,'he','×›×™×•×•× ×•× ×™× ×¢×œ-Site.com ×”× ×•×›×—×™',0),(385833,10718,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎµÏ‚ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚-Site.com',0),(385834,10718,'zh','å½“å‰ç½‘å€æ•´å¤‡\r\n',0),(385835,10718,'sv','Nuvarande pÃ¥-Site.com uppstÃ¤llningar',0),(385836,10718,'it','Corrente su-Site.com Setups',0),(385837,10718,'tl','',0),(385838,10718,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™ Site.com à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(385839,10718,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ªà¤° Site.com Setups',0),(385840,10718,'ms','Semasa di Site.com Setups',0),(385841,10718,'ar','Ø§Ù„Ø­Ø§Ù„ÙŠ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ø¬Ù‡Ø²Ø© ÙÙŠ Site.com',0),(385842,10718,'fr','Configurations actuelles de sur-site.com',0),(385843,10718,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã®ç¾åœ¨',0),(385844,10718,'pt','Atual na-Site.com Setups',0),(385845,10718,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð½Ð° Site.com',0),(385846,10718,'es','Configuaciones Actuales de On-Site.com',0),(385847,10718,'de','Aktuelle auf-Site.com-Setups',0),(385848,10718,'en','Current On-Site.com Setups',0),(385849,10719,'is','',0),(385850,10719,'dr','NolaProÛŒÙˆØ²Ø±',0),(385851,10719,'pr','NolaProÙƒØ§Ø±Ø¨Ø±',0),(385852,10719,'tr','Sistem kullanÄ±cÄ±sÄ±',0),(385853,10719,'pl','UÅ¼ytkownika systemu',0),(385854,10719,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼ÐµÐ½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(385855,10719,'ur','Ù†Ø¸Ø§Ù… ØµØ§Ø±Ù',0),(385856,10719,'sr','Ð¡Ð¸ÑÑ‚ÐµÐ¼ÑÐºÐ¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº',0),(385857,10719,'vi','ngÆ°á»i sá»­ dá»¥ng há»‡ thá»‘ng',0),(385858,10719,'af','NolaPro Gebruiker',0),(385859,10719,'ro','Sistem de utilizator',0),(385860,10719,'et','SÃ¼steemi kasutaja',0),(385861,10719,'si','Uporabnik sistema',0),(385862,10719,'ba','Sistem pengguna',0),(385863,10719,'nl','Systeemgebruiker',0),(385864,10719,'fi','JÃ¤rjestelmÃ¤n kÃ¤yttÃ¤jÃ¤',0),(385865,10719,'no','Bruker',0),(385866,10719,'da','Systembruger',0),(385867,10719,'ko','ì‹œìŠ¤í…œ ì‚¬ìš©ìž',0),(385868,10719,'he','×ž×¢×¨×›×ª ×”×ž×©×ª×ž×©',0),(385869,10719,'el','Î§ÏÎ®ÏƒÏ„Î·Ï‚ Î´Î¹ÎºÏ„ÏÎ¿Ï…',0),(385870,10719,'zh','ç³»ç»Ÿç”¨æˆ·\r\n',0),(385871,10719,'sv','System-anvÃ¤ndare',0),(385872,10719,'it','Utente del sistema',0),(385873,10719,'tl','',0),(385874,10719,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸£à¸°à¸šà¸š',0),(385875,10719,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(385876,10719,'ms','Pengguna sistem',0),(385877,10719,'ar','Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ù†Ø¸Ø§Ù…',0),(385878,10719,'fr','Utilisateur du systÃ¨me',0),(385879,10719,'jp','ã‚·ã‚¹ãƒ†ãƒ  ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(385880,10719,'pt','UsuÃ¡rio do sistema',0),(385881,10719,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ NolaPro',0),(385882,10719,'es','Usuario de NolaPro',0),(385883,10719,'de','Systembenutzer',0),(385884,10719,'en','System User',0),(385885,10720,'is','',0),(385886,10720,'dr','On-Site.com Ù†Ù…Ø¨Ø± ØµØ§Ø¯Ø± ÙƒÙ†Ù†Ø¯Ù‡ ',0),(385887,10720,'pr','On-Site.com Ø´Ù†Ø§Ø³Ù‡ ØµØ§Ø¯Ø± ÙƒÙ†Ù†Ø¯Ù‡ ',0),(385888,10720,'tr','Site.com GÃ¶nderen KimliÄŸi',0),(385889,10720,'pl','ID na Site.com autora',0),(385890,10720,'bg','ÐŸÐ¾ Site.com Ð½Ð°Ñ€ÐµÐ´Ð¸Ñ‚ÐµÐ»Ñ Ð˜Ð”',0),(385891,10720,'ur','Ù¾Ø± Site.com Ù…ÙˆØ¬Ø¯ Ø´Ù†Ø§Ø®Øª',0),(385892,10720,'sr','ÐžÐ½ -Site.com ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ñ‚Ð¾Ñ€ Ð˜Ð”',0),(385893,10720,'vi','Táº¡o ID trÃªn On-Site.com',0),(385894,10720,'af','Op-Site.com Originator ID',0),(385895,10720,'ro','Pe-Site.com ordonatorului ID',0),(385896,10720,'et','Site.com algataja ID',0),(385897,10720,'si','Nalogodajalec na Site.com ID',0),(385898,10720,'ba','Pada Site.com pencetus ID',0),(385899,10720,'nl','Op-Site.com opdrachtgever ID',0),(385900,10720,'fi','-Site.com aloittajan tunnus',0),(385901,10720,'no','PÃ¥-Site.com opphavsmannen ID',0),(385902,10720,'da','PÃ¥-Site.com afsender-ID',0),(385903,10720,'ko','Site.com ì†¡ì‹ ìž ID',0),(385904,10720,'he','×ž×–×”×” ×™×•×–× ×‘- Site.com',0),(385905,10720,'el','ID-Site.com ÎµÎ½Ï„Î¿Î»Î­Î±',0),(385906,10720,'zh','ç½‘å€å‘èµ·æ–¹èº«ä»½è¯\r\n',0),(385907,10720,'sv','PÃ¥-Site.com bestÃ¤llaren ID',0),(385908,10720,'it','ID su-Site.com creatore',0),(385909,10720,'tl','',0),(385910,10720,'th','à¸œà¸¹à¹‰à¸£à¸´à¹€à¸£à¸´à¹ˆà¸¡à¹ƒà¸™ Site.com ID',0),(385911,10720,'hi','à¤ªà¤° Site.com à¤ªà¥à¤°à¤µà¤°à¥à¤¤à¤• ID',0),(385912,10720,'ms','ID pemilik asal pada Site.com',0),(385913,10720,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ù†Ø´Ø¦ ÙÙŠ Site.com',0),(385914,10720,'fr','ID d\'appelant sur-site.com',0),(385915,10720,'jp','Site.com ã«ç™ºä¿¡è€… ID',0),(385916,10720,'pt','ID do originador na-Site.com',0),(385917,10720,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ñ‚Ð¾Ñ€Ð° Ð½Ð° Site.com',0),(385918,10720,'es','On-Site.com ID de Originador',0),(385919,10720,'de','Auf-Site.com Ursprungskennung',0),(385920,10720,'en','On-Site.com Originator ID',0),(385921,10721,'is','',0),(385922,10721,'dr','On-Site.com',0),(385923,10721,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±On-Site.com',0),(385924,10721,'tr','Site.com ÅŸifre',0),(385925,10721,'pl','HasÅ‚o na Site.com',0),(385926,10721,'bg','ÐŸÐ¾ Site.com Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(385927,10721,'ur','Ù¾Ø± Site.com Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(385928,10721,'sr','ÐžÐ½ -Site.com ÐŸÐ°ÑÑwÐ¾Ñ€Ð´',0),(385929,10721,'vi','Máº­t kháº©u trÃªn On- Site.com',0),(385930,10721,'af','Op-Site.com-wagwoord',0),(385931,10721,'ro','Pe-Site.com parola',0),(385932,10721,'et','Site.com parooli',0),(385933,10721,'si','Na Site.com geslo',0),(385934,10721,'ba','Password pada Site.com',0),(385935,10721,'nl','Op-Site.com wachtwoord',0),(385936,10721,'fi','-Site.com salasana',0),(385937,10721,'no','PÃ¥-Site.com passord',0),(385938,10721,'da','PÃ¥-Site.com adgangskode',0),(385939,10721,'ko','Site.com ì•”í˜¸',0),(385940,10721,'he','×”×¡×™×¡×ž×” ×‘- Site.com',0),(385941,10721,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚-Site.com',0),(385942,10721,'zh','ç½‘å€å¯†ç \r\n',0),(385943,10721,'sv','PÃ¥-Site.com lÃ¶senord',0),(385944,10721,'it','Su-Site.com Password',0),(385945,10721,'tl','',0),(385946,10721,'th','à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸šà¸™ Site.com',0),(385947,10721,'hi','Site.com à¤ªà¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡',0),(385948,10721,'ms','Kata laluan pada Site.com',0),(385949,10721,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ø³Ø± ÙÙŠ Site.com',0),(385950,10721,'fr','Mot de passe sur-site.com',0),(385951,10721,'jp','Site.com ã«ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰',0),(385952,10721,'pt','Senha na-Site.com',0),(385953,10721,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ Ð½Ð° Site.com',0),(385954,10721,'es','On-Site.com ContraseÃ±a',0),(385955,10721,'de','Auf-Site.com-Passwort',0),(385956,10721,'en','On-Site.com Password',0),(385957,10722,'is','',0),(385958,10722,'dr','On-Site.com ',0),(385959,10722,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø¯Ø§Ø±Ø§Ø¦ÙŠ On-Site.com ',0),(385960,10722,'tr','Site.com Ã¶zellik kimliÄŸi',0),(385961,10722,'pl','Identyfikator wÅ‚aÅ›ciwoÅ›ci na Site.com',0),(385962,10722,'bg','ÐŸÐ¾ Site.com Ð˜Ð” Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(385963,10722,'ur','Ù¾Ø± Site.com Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ø´Ù†Ø§Ø®Øª',0),(385964,10722,'sr','ÐžÐ½ -Site.com ÐŸÑ€Ð¾Ð¿ÐµÑ€Ñ‚y Ð˜Ð”',0),(385965,10722,'vi','MÃ£ tÃ i sáº£n trÃªn On-Site.com',0),(385966,10722,'af','Op-Site.com eiendom ID',0),(385967,10722,'ro','ID de proprietate pe-Site.com',0),(385968,10722,'et','Site.com atribuudi ID',0),(385969,10722,'si','ID lastnosti na Site.com',0),(385970,10722,'ba','Pada Site.com Properti ID',0),(385971,10722,'nl','Op-Site.com eigenschap ID',0),(385972,10722,'fi','-Site.com tunnus',0),(385973,10722,'no','PÃ¥-Site.com egenskaps-ID',0),(385974,10722,'da','PÃ¥-Site.com egenskabs-ID',0),(385975,10722,'ko','Site.com ì†ì„± ID',0),(385976,10722,'he','×ž×–×”×” ×”×ž××¤×™×™×Ÿ ×‘- Site.com',0),(385977,10722,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î±ÎºÎ¹Î½Î®Ï„Î¿Ï…-Site.com',0),(385978,10722,'zh','ç½‘å€å±žæ€§ç¼–å·\r\n',0),(385979,10722,'sv','PÃ¥-Site.com egenskaps-ID',0),(385980,10722,'it','Su-Site.com proprietÃ  ID',0),(385981,10722,'tl','',0),(385982,10722,'th','à¸£à¸«à¸±à¸ªà¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸šà¸™ Site.com',0),(385983,10722,'hi','à¤ªà¤° Site.com à¤—à¥à¤£ ID',0),(385984,10722,'ms','MS ciri pada Site.com',0),(385985,10722,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ø®Ø§ØµÙŠØ© Ø¹Ù„Ù‰ Site.com',0),(385986,10722,'fr','ID de propriÃ©tÃ© de sur-site.com',0),(385987,10722,'jp','Site.com ã«ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ ID',0),(385988,10722,'pt','ID da propriedade na-Site.com',0),(385989,10722,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°-Site.com',0),(385990,10722,'es','On-Site.com ID de Propiedad',0),(385991,10722,'de','Auf-Site.com-Property-ID',0),(385992,10722,'en','On-Site.com Property ID',0),(385993,10723,'is','',0),(385994,10723,'dr','On-Site.com',0),(385995,10723,'pr','  Ø§ÙØ²ÙˆØ¯Ù† ØªÙ†Ø¸ÙŠÙ…Ø§ØªOn-Site.com',0),(385996,10723,'tr','Site.com kurulum Ekle',0),(385997,10723,'pl','Dodaj ustawienie na Site.com',0),(385998,10723,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾ Site.com Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(385999,10723,'ur','Ù¾Ø± Site.com Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(386000,10723,'sr','ÐžÐ½ -Site.com Ð¡ÐµÑ‚ÑƒÐ¿ ÐÐ´Ð´',0),(386001,10723,'vi','thiáº¿t láº­p thÃªm trÃªn On-Site.com',0),(386002,10723,'af','Op-Site.com opstelling voeg',0),(386003,10723,'ro','Adauga pe-Site.com Setup',0),(386004,10723,'et','Site.com Setup lisada',0),(386005,10723,'si','Na Site.com Setup dodate',0),(386006,10723,'ba','Tambahkan Setup pada Site.com',0),(386007,10723,'nl','Op-Site.com Setup toevoegen',0),(386008,10723,'fi','-Site.com asennusohjelma lisÃ¤Ã¤',0),(386009,10723,'no','PÃ¥-Site.com installasjonsprogrammet legge',0),(386010,10723,'da','PÃ¥-Site.com installationsprogrammet tilfÃ¸je',0),(386011,10723,'ko','Site.com ì„¤ì • ì¶”ê°€',0),(386012,10723,'he','×”×•×¡×¤×ª ×”×’×“×¨×ª ×‘- Site.com',0),(386013,10723,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Site.com Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÏ‰',0),(386014,10723,'zh','æ·»åŠ -ç½‘å€å®‰è£…\r\n',0),(386015,10723,'sv','PÃ¥-Site.com installationen lÃ¤gga till',0),(386016,10723,'it','Aggiungi su-Site.com Setup',0),(386017,10723,'tl','',0),(386018,10723,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™ Site.com',0),(386019,10723,'hi','à¤ªà¤°-Site.com à¤¸à¥‡à¤Ÿà¤…à¤ª à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(386020,10723,'ms','Persediaan terakhir Site.com Tambah',0),(386021,10723,'ar','Ø£Ø¶Ù Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø¹Ù„Ù‰ Site.com',0),(386022,10723,'fr','Ajouter le programme d\'installation de sur-site.com',0),(386023,10723,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(386024,10723,'pt','Adicionar configuraÃ§Ã£o na-Site.com',0),(386025,10723,'ru','ÐÐ° Site.com ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(386026,10723,'es','On-Site.com Agregar ConfiguraciÃ³n',0),(386027,10723,'de','Auf-Site.com Setup hinzufÃ¼gen',0),(386028,10723,'en','On-Site.com Setup Add',0),(386029,10724,'is','',0),(386030,10724,'dr','On-Site.com',0),(386031,10724,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯On-Site.com',0),(386032,10724,'tr','Site.com Kurulum ekleme hatasÄ±',0),(386033,10724,'pl','Na Site.com konfiguracji Dodaj brak',0),(386034,10724,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Site.com Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(386035,10724,'ur','Site.com Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(386036,10724,'sr','ÐžÐ½ -Site.com Ð¡ÐµÑ‚ÑƒÐ¿ ÐÐ´Ð´ Ð¤Ð°Ð¸Ð»ÑƒÑ€Ðµ',0),(386037,10724,'vi','thiáº¿t láº­p thÃªm On-Site.com tháº¥t báº¡i',0),(386038,10724,'af','Op-Site.com opstelling voeg versuim',0),(386039,10724,'ro','Pe-Site.com Setup Adauga eÅŸec',0),(386040,10724,'et','Site.com Setup lisada rike',0),(386041,10724,'si','Na Site.com Setup dodate neuspeh',0),(386042,10724,'ba','Pada Site.com Setup menambahkan kegagalan',0),(386043,10724,'nl','Op-Site.com Setup toevoegen mislukking',0),(386044,10724,'fi','-Site.com asennusohjelma lisÃ¤Ã¤ epÃ¤onnistuminen',0),(386045,10724,'no','PÃ¥-Site.com installasjonsprogrammet legger feil',0),(386046,10724,'da','PÃ¥-Site.com installationsprogrammet tilfÃ¸je fiasko',0),(386047,10724,'ko','Site.com ì„¤ì¹˜ ì¶”ê°€ ì‹¤íŒ¨',0),(386048,10724,'he','×œ×ª×•×›× ×™×ª ×”×”×ª×§× ×” ×‘- Site.com ×œ×”×•×¡×™×£ ×›×©×œ',0),(386049,10724,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Site.com Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÏ‰ Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(386050,10724,'zh','ç½‘å€å®‰è£…æ·»åŠ å¤±è´¥\r\n',0),(386051,10724,'sv','PÃ¥-Site.com installationen lÃ¤gga till misslyckande',0),(386052,10724,'it','Installazione su-Site.com aggiungere fallimento',0),(386053,10724,'tl','',0),(386054,10724,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™ Site.com à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸§à¸²à¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(386055,10724,'hi','Site.com à¤ªà¤° à¤¸à¥‡à¤Ÿà¤…à¤ª à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(386056,10724,'ms','Persediaan terakhir Site.com Tambah kegagalan',0),(386057,10724,'ar','Ø£Ø¶Ù Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Site.com Ø¹Ù„Ù‰ Ø§Ù„ÙØ´Ù„',0),(386058,10724,'fr','Installation sur-site.com ajouter Ã©chec',0),(386059,10724,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è¿½åŠ ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(386060,10724,'pt','InstalaÃ§Ã£o de no-Site.com Adicionar falha',0),(386061,10724,'ru','ÐÐ° Site.com ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ñ‚ÐºÐ°Ð·',0),(386062,10724,'es','On-Site.com ConfiguraciÃ³n Agregar FallÃ³',0),(386063,10724,'de','Auf-Site.com Setup hinzufÃ¼gen Fehler',0),(386064,10724,'en','On-Site.com Setup Add Failure',0),(386065,10725,'is','',0),(386066,10725,'dr','On-Site.com',0),(386067,10725,'pr','     Ø§ÙØ²ÙˆØ¯Ù† ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯On-Site.com',0),(386068,10725,'tr','Site.com kurulum baÅŸarÄ±yla eklendi',0),(386069,10725,'pl','PomyÅ›lnie dodano instalacji na Site.com',0),(386070,10725,'bg','ÐŸÐ¾ Site.com Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(386071,10725,'ur','Site.com Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ù†Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(386072,10725,'sr','ÐžÐ½ -Site.com Ð¡ÐµÑ‚ÑƒÐ¿ ÐÐ´Ð´ÐµÐ´ Ð¡ÑƒÑ†Ñ†ÐµÑÑÑ„ÑƒÐ»Ð»y',0),(386073,10725,'vi','ÄÃ£ thiáº¿t láº­p thÃªm On-Site.com thÃ nh cÃ´ng',0),(386074,10725,'af','Op-Site.com opstelling suksesvol bygevoeg',0),(386075,10725,'ro','Pe-Site.com Setup adÄƒugat cu succes',0),(386076,10725,'et','Lisatud-Site.com seadistamine',0),(386077,10725,'si','Na Site.com Setup uspeÅ¡no dodani',0),(386078,10725,'ba','Pada Site.com Setup ditambahkan berhasil',0),(386079,10725,'nl','Op-Site.com Setup met succes toegevoegd',0),(386080,10725,'fi','-Site.com asetukset lisÃ¤Ã¤minen onnistui',0),(386081,10725,'no','PÃ¥-Site.com Setup lagt',0),(386082,10725,'da','PÃ¥-Site.com Setup tilfÃ¸jet',0),(386083,10725,'ko','Site.com ì„¤ì¹˜ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(386084,10725,'he','×‘- Site.com ×”×ª×§× ×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(386085,10725,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Site.com Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(386086,10725,'zh','ç½‘å€å®‰è£…æˆåŠŸæ·»åŠ \r\n',0),(386087,10725,'sv','PÃ¥-Site.com Setup lagts',0),(386088,10725,'it','Installazione su-Site.com aggiunto con successo',0),(386089,10725,'tl','',0),(386090,10725,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™ Site.com à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(386091,10725,'hi','à¤ªà¤°-Site.com à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(386092,10725,'ms','Persediaan terakhir Site.com yang berjaya menambah',0),(386093,10725,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ ÙÙŠ Site.com Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(386094,10725,'fr','Programme d\'installation sur-site.com a ajoutÃ© avec succÃ¨s',0),(386095,10725,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(386096,10725,'pt','InstalaÃ§Ã£o de no-Site.com adicionada com sucesso',0),(386097,10725,'ru','ÐÐ° Site.com ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(386098,10725,'es','On-Site.com Configuracion Agregada Exitosamente',0),(386099,10725,'de','Auf-Site.com-Setup wurde erfolgreich hinzugefÃ¼gt',0),(386100,10725,'en','On-Site.com Setup Added Successfully',0),(386101,10726,'is','',0),(386102,10726,'dr','On-Site.com',0),(386103,10726,'pr','Ø­Ø°Ù ØªÙ†Ø¸ÙŠÙ…Ø§Øª On-Site.com',0),(386104,10726,'tr','Site.com Kur Sil',0),(386105,10726,'pl','UsuÅ„ ustawienia na Site.com',0),(386106,10726,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Site.com Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(386107,10726,'ur','Site.com Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(386108,10726,'sr','ÐžÐ½ -Site.com Ð¡ÐµÑ‚ÑƒÐ¿ Ð”ÐµÐ»ÐµÑ‚Ðµ',0),(386109,10726,'vi','XÃ³a thiáº¿t láº­p On-Site.com',0),(386110,10726,'af','Skrap op-Site.com opstel',0),(386111,10726,'ro','Pe-Site.com Setup Delete',0),(386112,10726,'et','Site.com Setup kustutamine',0),(386113,10726,'si','Na Site.com Setup Delete',0),(386114,10726,'ba','Delete konfigurasi pada Site.com',0),(386115,10726,'nl','Op-Site.com Setup verwijderen',0),(386116,10726,'fi','-Site.com asennuksen poistaminen',0),(386117,10726,'no','PÃ¥-Site.com Setup Slett',0),(386118,10726,'da','PÃ¥-Site.com Setup slet',0),(386119,10726,'ko','Site.com ì„¤ì¹˜ ì‚­ì œ',0),(386120,10726,'he','×ž×—×™×§×ª ×”×”×ª×§× ×” ×‘- Site.com',0),(386121,10726,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î®-Site.com ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(386122,10726,'zh','ç½‘å€çš„è®¾ç½®åˆ é™¤\r\n',0),(386123,10726,'sv','PÃ¥-Site.com Setup Delete',0),(386124,10726,'it','Installazione su-Site.com Delete',0),(386125,10726,'tl','',0),(386126,10726,'th','à¸¥à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™ Site.com',0),(386127,10726,'hi','à¤ªà¤°-Site.com à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¹à¤Ÿà¤¾à¤à¤',0),(386128,10726,'ms','Persediaan terakhir Site.com padam',0),(386129,10726,'ar','Ø­Ø°Ù Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø¹Ù„Ù‰ Site.com',0),(386130,10726,'fr','Supprimer le programme d\'installation de sur-site.com',0),(386131,10726,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã®å‰Šé™¤',0),(386132,10726,'pt','InstalaÃ§Ã£o de no-Site.com Delete',0),(386133,10726,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð½Ð° Site.com',0),(386134,10726,'es','On-Site.com ConfiguraciÃ³n Eliminar',0),(386135,10726,'de','Auf-Site.com Setup lÃ¶schen',0),(386136,10726,'en','On-Site.com Setup Delete',0),(386137,10727,'is','',0),(386138,10727,'dr','On-Site.com',0),(386139,10727,'pr','Ø­Ø°Ù ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯On-Site.com',0),(386140,10727,'tr','Site.com Kur silme baÅŸarÄ±sÄ±z oldu',0),(386141,10727,'pl','Ustawienie na Site.com usuniÄ™cie nie powiodÅ‚o siÄ™',0),(386142,10727,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Site.com Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(386143,10727,'ur','Site.com Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ù†Ø§Ú©Ø§Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(386144,10727,'sr','ÐžÐ½ -Site.com Ð¡ÐµÑ‚ÑƒÐ¿ Ð”ÐµÐ»ÐµÑ‚Ðµ Ð¤Ð°Ð¸Ð»ÐµÐ´',0),(386145,10727,'vi','XÃ³a thiáº¿t láº­p On-Site.com tháº¥t báº¡i',0),(386146,10727,'af','Op-Site.com opstelling Delete het misluk',0),(386147,10727,'ro','Pe-Site.com Setup Delete Failed',0),(386148,10727,'et','Site.com Setup kustutamine nurjus',0),(386149,10727,'si','Na Site.com Setup brisanje neuspelih',0),(386150,10727,'ba','Hapus pada Site.com Setup gagal',0),(386151,10727,'nl','Mislukte op-Site.com Setup wissen',0),(386152,10727,'fi','-Site.com asennuksen poisto epÃ¤onnistui',0),(386153,10727,'no','PÃ¥-Site.com Setup sletting mislyktes',0),(386154,10727,'da','PÃ¥-Site.com Setup sletning mislykkedes',0),(386155,10727,'ko','Site.com ì„¤ì¹˜ ì‚­ì œ ì‹¤íŒ¨',0),(386156,10727,'he','×ž×—×™×§×” ×¢×œ-Site.com ×”×”×ª×§× ×” × ×›×©×œ×”',0),(386157,10727,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· Î´Î¹Î±Î³ÏÎ±Ï†Î®-Site.com ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(386158,10727,'zh','ç½‘å€å®‰è£…åˆ é™¤å¤±è´¥\r\n',0),(386159,10727,'sv','PÃ¥-Site.com Setup Delete misslyckades',0),(386160,10727,'it','Eliminazione di su-Site.com installazione non riuscita',0),(386161,10727,'tl','',0),(386162,10727,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸¥à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™ Site.com',0),(386163,10727,'hi','à¤ªà¤°-Site.com à¤¸à¥à¤¥à¤¾à¤ªà¤¨à¤¾ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(386164,10727,'ms','Hapus persediaan pada Site.com yang gagal',0),(386165,10727,'ar','ÙØ´Ù„ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø¹Ù„Ù‰ Site.com',0),(386166,10727,'fr','Ã‰chouÃ© de la suppression d\'installation sur-site.com',0),(386167,10727,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã®å‰Šé™¤ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(386168,10727,'pt','Falhado ao excluir na-Site.com Setup',0),(386169,10727,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð½Ð° Site.com',0),(386170,10727,'es','On-Site.com ConfiguraciÃ³n Eliminar FallÃ³',0),(386171,10727,'de','Auf-Site.com Setup LÃ¶schen fehlgeschlagen',0),(386172,10727,'en','On-Site.com Setup Delete Failed',0),(386173,10728,'is','',0),(386174,10728,'dr','On-Site.com',0),(386175,10728,'pr','Ø­Ø°Ù ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯On-Site.com',0),(386176,10728,'tr','Site.com Kur baÅŸarÄ±lÄ± silme',0),(386177,10728,'pl','Na Site.com instalacji UsuÅ„ sukces',0),(386178,10728,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Site.com Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(386179,10728,'ur','Site.com Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Ø§Ù…ÛŒØ§Ø¨ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(386180,10728,'sr','ÐžÐ½ -Site.com Ð¡ÐµÑ‚ÑƒÐ¿ Ð”ÐµÐ»ÐµÑ‚Ðµ Ð¡ÑƒÑ†Ñ†ÐµÑÑÑ„ÑƒÐ»',0),(386181,10728,'vi','XÃ³a thiáº¿t láº­p On-Site.com thÃ nh cÃ´ng',0),(386182,10728,'af','Op-Site.com opstelling skrap suksesvolle',0),(386183,10728,'ro','Pe-Site.com Setup ÅŸterge de succes',0),(386184,10728,'et','Site.com Setup kustutada edukas',0),(386185,10728,'si','Na Site.com Setup brisanje uspeÅ¡no',0),(386186,10728,'ba','Pada Site.com Setup menghapus sukses',0),(386187,10728,'nl','Op-Site.com Setup verwijderen succesvol',0),(386188,10728,'fi','-Site.com asennusohjelma poistaa onnistunut',0),(386189,10728,'no','PÃ¥-Site.com installasjonsprogrammet sletter vellykket',0),(386190,10728,'da','PÃ¥-Site.com Setup slette vellykket',0),(386191,10728,'ko','Site.com ì„¤ì¹˜ ì‚­ì œ ì„±ê³µ',0),(386192,10728,'he','×ž×—×™×§×” ×¢×œ-Site.com ×”×ª×§× ×” ×ž×•×¦×œ×—×ª',0),(386193,10728,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î®-Site.com ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÎµÏ€Î¹Ï„Ï…Ï‡Î®Ï‚',0),(386194,10728,'zh','ç½‘å€å®‰è£…åˆ é™¤æˆåŠŸ\r\n',0),(386195,10728,'sv','PÃ¥-Site.com installationsprogrammet bort framgÃ¥ngsrika',0),(386196,10728,'it','Installazione su-Site.com eliminare successo',0),(386197,10728,'tl','',0),(386198,10728,'th','à¸¥à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™ Site.com à¸—à¸µà¹ˆà¸›à¸£à¸°à¸ªà¸šà¸„à¸§à¸²à¸¡à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(386199,10728,'hi','à¤ªà¤°-Site.com à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¸à¤«à¤² à¤¹à¤Ÿà¤¾à¤à¤',0),(386200,10728,'ms','Persediaan terakhir Site.com menghapuskan berjaya',0),(386201,10728,'ar','Ø­Ø°Ù Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø¹Ù„Ù‰ Site.com Ø§Ù„Ù†Ø§Ø¬Ø­Ø©',0),(386202,10728,'fr','Delete sur-site.com installation rÃ©ussie',0),(386203,10728,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(386204,10728,'pt','Delete na-Site.com instalaÃ§Ã£o bem sucedida',0),(386205,10728,'ru','ÐÐ° Site.com ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(386206,10728,'es','On-Site.com ConfiguraciÃ³n Eliminada Exitosamente',0),(386207,10728,'de','Auf-Site.com Setup erfolgreich lÃ¶schen',0),(386208,10728,'en','On-Site.com Setup Delete Successful',0),(386209,10729,'is','',0),(386210,10729,'dr','On-Site.com',0),(386211,10729,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙ†Ø¸ÙŠÙ…Ø§Øª On-Site.com',0),(386212,10729,'tr','Site.com Kur gÃ¼ncelleÅŸtirme',0),(386213,10729,'pl','Aktualizacja na Site.com instalacji',0),(386214,10729,'bg','ÐŸÐ¾ Site.com Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(386215,10729,'ur','Site.com Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(386216,10729,'sr','ÐžÐ½ -Site.com Ð¡ÐµÑ‚ÑƒÐ¿ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(386217,10729,'vi','Cáº­p nháº­t thiáº¿t láº­p On-Site.com',0),(386218,10729,'af','Op-Site.com opstelling bywerking',0),(386219,10729,'ro','Update Setup pe-Site.com',0),(386220,10729,'et','Site.com seadistuse uuendamine',0),(386221,10729,'si','Na Site.com namestitev posodobitev',0),(386222,10729,'ba','Update pada Site.com Setup',0),(386223,10729,'nl','Op-Site.com Setup Update',0),(386224,10729,'fi','-Site.com asennusohjelman pÃ¤ivitykset',0),(386225,10729,'no','Oppdatering av pÃ¥-Site.com installasjonsprogrammet',0),(386226,10729,'da','PÃ¥-Site.com Setup opdatering',0),(386227,10729,'ko','Site.com ì„¤ì¹˜ ì—…ë°ì´íŠ¸',0),(386228,10729,'he','×¢×“×›×•×Ÿ ×ª×•×›× ×™×ª ×”×”×ª×§× ×” ×‘- Site.com',0),(386229,10729,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ·-Site.com ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(386230,10729,'zh','ç½‘å€å®‰è£…æ›´æ–°\r\n',0),(386231,10729,'sv','PÃ¥-Site.com Setup Update',0),(386232,10729,'it','Aggiornamento su-Site.com Setup',0),(386233,10729,'tl','',0),(386234,10729,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™ Site.com',0),(386235,10729,'hi','à¤ªà¤°-Site.com à¤¸à¥‡à¤Ÿà¤…à¤ª à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(386236,10729,'ms','Kemaskini Terakhir Site.com persediaan',0),(386237,10729,'ar','ØªØ­Ø¯ÙŠØ« Ø¨Ø±Ù†Ø§Ù…Ø¬ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø¹Ù„Ù‰ Site.com',0),(386238,10729,'fr','Mise Ã  jour d\'installation sur-site.com',0),(386239,10729,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—æ›´æ–°',0),(386240,10729,'pt','AtualizaÃ§Ã£o de configuraÃ§Ã£o na-Site.com',0),(386241,10729,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð½Ð° Site.com',0),(386242,10729,'es','On-Site.com ConiguraciÃ³n Actualizar',0),(386243,10729,'de','Auf-Site.com Setup-Update',0),(386244,10729,'en','On-Site.com Setup Update',0),(386245,10730,'is','',0),(386246,10730,'dr','On-Site.com',0),(386247,10730,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯On-Site.com',0),(386248,10730,'tr','Site.com Kur gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu',0),(386249,10730,'pl','Nie moÅ¼na zaktualizowaÄ‡ ustawienia na Site.com',0),(386250,10730,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð° Site.com Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(386251,10730,'ur','Site.com Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(386252,10730,'sr','ÐžÐ½ -Site.com Ð¡ÐµÑ‚ÑƒÐ¿ Ð£Ð¿Ð´Ð°Ñ‚Ðµ Ð¤Ð°Ð¸Ð»ÐµÐ´',0),(386253,10730,'vi','Cáº­p nháº­t thiáº¿t láº­p On-Site.com tháº¥t báº¡i',0),(386254,10730,'af','Op-Site.com opstelling bywerking het misluk',0),(386255,10730,'ro','Pe-Site.com Setup Update nu a reuÈ™it',0),(386256,10730,'et','Site.com installiprogrammi vÃ¤rskendamine nurjus',0),(386257,10730,'si','Na Site.com namestitev posodobitev ni uspela',0),(386258,10730,'ba','Update pada Site.com Setup gagal',0),(386259,10730,'nl','Op-Site.com Setup-Update mislukt',0),(386260,10730,'fi','-Site.com asennusohjelman pÃ¤ivitys epÃ¤onnistui',0),(386261,10730,'no','PÃ¥-Site.com Setup oppdatering mislyktes',0),(386262,10730,'da','PÃ¥-Site.com Setup opdateringen mislykkedes',0),(386263,10730,'ko','Site.com ì„¤ì¹˜ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(386264,10730,'he','×¢×“×›×•×Ÿ ×”×”×ª×§× ×” ×‘- Site.com × ×›×©×œ',0),(386265,10730,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·-Site.com ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(386266,10730,'zh','ç½‘å€å®‰è£…æ›´æ–°å¤±è´¥\r\n',0),(386267,10730,'sv','PÃ¥-Site.com Setup uppdateringen misslyckades',0),(386268,10730,'it','Su-Site.com installazione aggiornamento non riuscito',0),(386269,10730,'tl','',0),(386270,10730,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™ Site.com à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(386271,10730,'hi','à¤ªà¤°-Site.com à¤¸à¥‡à¤Ÿà¤…à¤ª à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²',0),(386272,10730,'ms','Kemaskini Terakhir Site.com persediaan yang gagal',0),(386273,10730,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø¹Ù„Ù‰ Site.com',0),(386274,10730,'fr','Mise Ã  jour sur-site.com le programme d\'installation a Ã©chouÃ©',0),(386275,10730,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—æ›´æ–°ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(386276,10730,'pt','Falha na atualizaÃ§Ã£o de configuraÃ§Ã£o na-Site.com',0),(386277,10730,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð½Ð° Site.com',0),(386278,10730,'es','On-Site.com ConfiguraciÃ³n Actualizar FallÃ³',0),(386279,10730,'de','Auf-Site.com Setup-Update fehlgeschlagen',0),(386280,10730,'en','On-Site.com Setup Update Failed',0),(386281,10731,'is','',0),(386282,10731,'dr','On-Site.com',0),(386283,10731,'pr',' Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯On-Site.com',0),(386284,10731,'tr','Site.com kurulum baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(386285,10731,'pl','Na Site.com Instalator pomyÅ›lnie zaktualizowana',0),(386286,10731,'bg','ÐŸÐ¾ Site.com Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ñ‰Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð° Ð±ÐµÑˆÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(386287,10731,'ur','Site.com Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(386288,10731,'sr','ÐžÐ½ -Site.com Ð¡ÐµÑ‚ÑƒÐ¿ Ð£Ð¿Ð´Ð°Ñ‚ÐµÐ´ Ð¡ÑƒÑ†Ñ†ÐµÑÑÑ„ÑƒÐ»Ð»y',0),(386289,10731,'vi','Cáº­p nháº­t thiáº¿t láº­p On-Site.com thÃ nh cÃ´ng',0),(386290,10731,'af','Op-Site.com opstelling suksesvol bygewerk',0),(386291,10731,'ro','Pe-Site.com Setup actualizat cu succes',0),(386292,10731,'et','Site.com installiprogrammi vÃ¤rskendamine Ãµnnestus',0),(386293,10731,'si','Na Site.com Setup uspeÅ¡no posodobljena',0),(386294,10731,'ba','Setup pada Site.com yang berhasil',0),(386295,10731,'nl','Op-Site.com Setup met succes bijgewerkt',0),(386296,10731,'fi','-Site.com asennusohjelman pÃ¤ivittÃ¤minen onnistui',0),(386297,10731,'no','PÃ¥-Site.com installasjonen oppdatert',0),(386298,10731,'da','PÃ¥-Site.com Setup opdateret',0),(386299,10731,'ko','Site.com ì„¤ì¹˜ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(386300,10731,'he','×”×”×ª×§× ×” ×¢×œ-Site.com ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(386301,10731,'el','-Site.com ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(386302,10731,'zh','ç½‘å€å®‰è£…æ›´æ–°æˆåŠŸ\r\n',0),(386303,10731,'sv','PÃ¥-Site.com Setup uppdaterats',0),(386304,10731,'it','Su-Site.com Setup aggiornato con successo',0),(386305,10731,'tl','',0),(386306,10731,'th','à¸•à¸´à¸”à¸•à¸±à¹‰à¸‡à¸šà¸™ Site.com à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(386307,10731,'hi','à¤ªà¤°-Site.com à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(386308,10731,'ms','Persediaan terakhir Site.com yang berjaya dikemas kini',0),(386309,10731,'ar','Site.com Ø¹Ù„Ù‰ Ø¨Ø±Ù†Ø§Ù…Ø¬ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(386310,10731,'fr','Programme d\'installation sur-site.com mis Ã  jour avec succÃ¨s',0),(386311,10731,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(386312,10731,'pt','InstalaÃ§Ã£o de no-Site.com atualizada com sucesso',0),(386313,10731,'ru','ÐÐ° Site.com ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(386314,10731,'es','On-Site.com ConfiguraciÃ³n Actualizada Exitosamente',0),(386315,10731,'de','Auf-Site.com-Setup wurde erfolgreich aktualisiert',0),(386316,10731,'en','On-Site.com Setup Updated Successfully',0),(386317,10732,'is','',0),(386318,10732,'dr','On-Site.comÙ†Ø§Ù… ÛŒÙˆØ²Ø±ÙŠ ',0),(386319,10732,'pr','On-Site.comÙ†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ ',0),(386320,10732,'tr','Site.com Username',0),(386321,10732,'pl','Nazwa uÅ¼ytkownika na Site.com',0),(386322,10732,'bg','ÐŸÐ¾ Site.com Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ',0),(386323,10732,'ur','Site.com Ù¾Ø± ØµØ§Ø±Ù Ù†Ø§Ù…',0),(386324,10732,'sr','ÐžÐ½ -Site.com Ð£ÑÐµÑ€Ð½Ð°Ð¼Ðµ',0),(386325,10732,'vi','NgÆ°á»i sá»­ dá»¥ng On-site.com',0),(386326,10732,'af','On-Site.com Gebruikernaam',0),(386327,10732,'ro','Numele de utilizator pe-Site.com',0),(386328,10732,'et','Site.com kasutajanimi',0),(386329,10732,'si','Na Site.com uporabniÅ¡ko ime',0),(386330,10732,'ba','Username pada Site.com',0),(386331,10732,'nl','Op-Site.com gebruikersnaam',0),(386332,10732,'fi','-Site.com kÃ¤yttÃ¤jÃ¤tunnus',0),(386333,10732,'no','PÃ¥-Site.com brukernavn',0),(386334,10732,'da','PÃ¥-Site.com Username',0),(386335,10732,'ko','Site.com ì‚¬ìš©ìž ì´ë¦„',0),(386336,10732,'he','×©× ×ž×©×ª×ž×© ×‘- Site.com',0),(386337,10732,'el','ÎŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î·-Site.com',0),(386338,10732,'zh','ç½‘å€ç”¨æˆ·å\r\n',0),(386339,10732,'sv','PÃ¥-Site.com anvÃ¤ndarnamn',0),(386340,10732,'it','Nome utente su-Site.com',0),(386341,10732,'tl','',0),(386342,10732,'th','à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸šà¸™ Site.com',0),(386343,10732,'hi','à¤ªà¤° Site.com à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤®',0),(386344,10732,'ms','Nama pengguna di Site.com',0),(386345,10732,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¹Ù„Ù‰ Site.com',0),(386346,10732,'fr','Nom d\'utilisateur sur-site.com',0),(386347,10732,'jp','Site.com ã«ãƒ¦ãƒ¼ã‚¶ãƒ¼å',0),(386348,10732,'pt','Nome de usuÃ¡rio na-Site.com',0),(386349,10732,'ru','On-Site.com Ð˜Ð¼Ñ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(386350,10732,'es','On-Site.com Nombre de Usuario',0),(386351,10732,'de','Auf-Site.com Username',0),(386352,10732,'en','On-Site.com Username',0),(386353,10733,'is','',0),(386354,10733,'dr','Ù„Ø·ÙØ§ ÙƒØ§Ø±Ø¨Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(386355,10733,'pr','Ù„Ø·ÙØ§ ÙƒØ§Ø±Ø¨Ø± Ø§ÙŠÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(386356,10733,'tr','LÃ¼tfen sistem kullanÄ±cÄ± ekleyin',0),(386357,10733,'pl','Prosimy o podanie uÅ¼ytkownika systemu',0),(386358,10733,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼ÐµÐ½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(386359,10733,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù†Ø¸Ø§Ù… ØµØ§Ø±Ù Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(386360,10733,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(386361,10733,'vi','vui lÃ²ng bao gá»“m ngÆ°á»i sá»­ dá»¥ng há»‡ thá»‘ng',0),(386362,10733,'af','Sluit asb. NolaPro Gebruiker In',0),(386363,10733,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i utilizator sistem',0),(386364,10733,'et','Palun lisage sÃ¼steemi kasutaja',0),(386365,10733,'si','Prosimo, da vkljuÄite uporabnik sistema',0),(386366,10733,'ba','Sertakan pengguna sistem',0),(386367,10733,'nl','Gelieve te omvatten systeemgebruiker',0),(386368,10733,'fi','SisÃ¤llytÃ¤ jÃ¤rjestelmÃ¤n kÃ¤yttÃ¤jÃ¤',0),(386369,10733,'no','Ta med System-bruker',0),(386370,10733,'da','VedlÃ¦g systembruger',0),(386371,10733,'ko','ì‹œìŠ¤í…œ ì‚¬ìš©ìžë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(386372,10733,'he','NolaPro ×× × ×›×œ×•×œ ×ž×©×ª×ž×©',0),(386373,10733,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î·',0),(386374,10733,'zh','è¯·åˆ—å…¥ç³»ç»Ÿç”¨æˆ·\r\n',0),(386375,10733,'sv','VÃ¤nligen inkludera System-anvÃ¤ndare',0),(386376,10733,'it','Si prega di includere utente sistema',0),(386377,10733,'tl','',0),(386378,10733,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸£à¸°à¸šà¸š',0),(386379,10733,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(386380,10733,'ms','Sila sertakan pengguna sistem',0),(386381,10733,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(386382,10733,'fr','Veuillez inclure l\'utilisateur du systÃ¨me',0),(386383,10733,'jp','ã‚·ã‚¹ãƒ†ãƒ ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(386384,10733,'pt','Por favor inclua o usuÃ¡rio do sistema',0),(386385,10733,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ NolaPro',0),(386386,10733,'es','Por Favor Incluye Usuario de NolaPro',0),(386387,10733,'de','Bitte geben Sie Systembenutzer',0),(386388,10733,'en','Please Include System User',0),(386389,10734,'is','',0),(386390,10734,'dr','On-Site.com ',0),(386391,10734,'pr','Ù„Ø·ÙØ§ ØµØ§Ø¯Ø± ÙƒÙ†Ù†Ø¯Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ø±Ø§ Ø§Ø² Ø³Ø§ÙŠØª Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ On-Site.com \r\n',0),(386392,10734,'tr','LÃ¼tfen-Site.com iletiyi gÃ¶nderen KÄ±mlÄ±ÄŸÄ± iÃ§erir',0),(386393,10734,'pl','ProszÄ™ podaÄ‡ ID na Site.com autora',0),(386394,10734,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¿Ð¾ Site.com Ð½Ð°Ñ€ÐµÐ´Ð¸Ñ‚ÐµÐ»Ñ Ð˜Ð”',0),(386395,10734,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Site.com Ù¾Ø± Ù…ÙˆØ¬Ø¯ Ø´Ù†Ø§Ø®Øª Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(386396,10734,'sr','ÐŸÐ»ÐµÐ°ÑÐµ Ð˜Ð½Ñ†Ð»ÑƒÐ´Ðµ ÐžÐ½-Site.com ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ñ‚Ð¾Ñ€ Ð˜Ð”',0),(386397,10734,'vi','vui long bao gá»“m ngÆ°á»i táº¡o ID on-site.com',0),(386398,10734,'af','Sluit asseblief On-Site.com Ontwerper ID in',0),(386399,10734,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i pe-Site.com ordonatorului ID',0),(386400,10734,'et','Palun lisage-Site.com algataja ID',0),(386401,10734,'si','Prosimo, da vkljuÄite na Site.com nalogodajalec ID',0),(386402,10734,'ba','Harap sertakan ID pencetus pada Site.com',0),(386403,10734,'nl','Gelieve te omvatten op-Site.com opdrachtgever ID',0),(386404,10734,'fi','LiitÃ¤-Site.com aloittajan tunnus',0),(386405,10734,'no','Ta pÃ¥-Site.com opphavsmannen ID',0),(386406,10734,'da','Inkluder venligst pÃ¥-Site.com afsender-ID',0),(386407,10734,'ko','Site.com ì†¡ì‹ ìž IDë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(386408,10734,'he','× × ×œ×›×œ×•×œ ×ž×–×”×” ×™×•×–× ×‘- Site.com',0),(386409,10734,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï„Î¿Ï… ÎµÎ½Ï„Î¿Î»Î­Î±-Site.com',0),(386410,10734,'zh','è¯·åˆ—å…¥ç½‘å€å‘èµ·æ–¹èº«ä»½è¯\r\n',0),(386411,10734,'sv','VÃ¤nligen inkludera pÃ¥-Site.com bestÃ¤llaren-ID',0),(386412,10734,'it','Si prega di includere ID su-Site.com creatore',0),(386413,10734,'tl','',0),(386414,10734,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸£à¸´à¹€à¸£à¸´à¹ˆà¸¡à¹ƒà¸™ Site.com',0),(386415,10734,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤° Site.com à¤ªà¥à¤°à¤µà¤°à¥à¤¤à¤• ID à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(386416,10734,'ms','Sila sertakan ID pemilik asal pada Site.com',0),(386417,10734,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ù†Ø´Ø¦ ÙÙŠ Site.com',0),(386418,10734,'fr','Veuillez inclure des ID d\'appelant sur-site.com',0),(386419,10734,'jp','Site.com ã«ç™ºä¿¡è€… ID ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(386420,10734,'pt','Por favor inclua o ID do originador na-Site.com',0),(386421,10734,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ñ‚Ð¾Ñ€Ð° Ð½Ð° Site.com',0),(386422,10734,'es','Por Favor Incluye On-Site.com ID de Originador',0),(386423,10734,'de','Bitte geben Sie auf-Site.com Ursprungskennung',0),(386424,10734,'en','Please Include On-Site.com Originator ID',0),(386425,10735,'is','',0),(386426,10735,'dr','On-Site.com ',0),(386427,10735,'pr','Ù„Ø·ÙØ§ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø±Ø§ Ø§Ø²  Ø³Ø§ÙŠØª    Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯On-Site.com ',0),(386428,10735,'tr','LÃ¼tfen-Site.com parola ekleyin',0),(386429,10735,'pl','ProszÄ™ podaÄ‡ hasÅ‚o na Site.com',0),(386430,10735,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¿Ð¾ Site.com Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(386431,10735,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Site.com Ù¾Ø± Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(386432,10735,'sr','ÐŸÐ»ÐµÐ°ÑÐµ Ð˜Ð½Ñ†Ð»ÑƒÐ´Ðµ ÐžÐ½-Site.com ÐŸÐ°ÑÑwÐ¾Ñ€Ð´',0),(386433,10735,'vi','vui lÃ²ng bao gá»“m máº­t kháº©u on-site.com',0),(386434,10735,'af','Sluit asseblief On-Site.com Wagwoord in',0),(386435,10735,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i pe-Site.com parola',0),(386436,10735,'et','Palun lisage-Site.com parooli',0),(386437,10735,'si','Prosimo, da vkljuÄite na Site.com geslo',0),(386438,10735,'ba','Harap sertakan Password pada Site.com',0),(386439,10735,'nl','Gelieve te omvatten op-Site.com wachtwoord',0),(386440,10735,'fi','LiitÃ¤-Site.com salasana',0),(386441,10735,'no','Ta pÃ¥-Site.com passord',0),(386442,10735,'da','Inkluder venligst pÃ¥-Site.com adgangskode',0),(386443,10735,'ko','Site.com ì•”í˜¸ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(386444,10735,'he','× × ×œ×›×œ×•×œ ××ª ×”×¡×™×¡×ž×” ×‘- Site.com',0),(386445,10735,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚-Site.com',0),(386446,10735,'zh','è¯·åˆ—å…¥ç½‘å€å¯†ç ',0),(386447,10735,'sv','VÃ¤nligen inkludera pÃ¥-Site.com lÃ¶senord',0),(386448,10735,'it','Si prega di includere Password su-Site.com',0),(386449,10735,'tl','',0),(386450,10735,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸šà¸™ Site.com',0),(386451,10735,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ Site.com à¤ªà¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(386452,10735,'ms','Sila masukkan kata laluan pada Site.com',0),(386453,10735,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± ÙÙŠ Site.com',0),(386454,10735,'fr','Veuillez indiquer le mot de passe sur-site.com',0),(386455,10735,'jp','Site.com ã«ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(386456,10735,'pt','Por favor, inclua na-Site.com senha',0),(386457,10735,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð½Ð° Site.com',0),(386458,10735,'es','Por Favor Incluye On-Site.com ContraseÃ±a',0),(386459,10735,'de','Bitte geben Sie auf-Site.com-Passwort',0),(386460,10735,'en','Please Include On-Site.com Password',0),(386461,10736,'is','',0),(386462,10736,'dr','Ù„Ø·ÙØ§ Ø´Ù†Ø§Ø³Ù‡  Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø±Ø§ Ø§Ø² Ø³Ø§ÙŠØª Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(386463,10736,'pr','Ù„Ø·ÙØ§ Ø´Ù†Ø§Ø³Ù‡  Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø±Ø§ Ø§Ø² Ø³Ø§ÙŠØª Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(386464,10736,'tr','LÃ¼tfen-Site.com Ã¶zellik kimliÄŸi iÃ§erir',0),(386465,10736,'pl','ProszÄ™ podaÄ‡ identyfikator wÅ‚aÅ›ciwoÅ›ci na Site.com',0),(386466,10736,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¿Ð¾ Site.com Ð˜Ð” Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(386467,10736,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Site.com Ù¾Ø± Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ø´Ù†Ø§Ø®Øª Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(386468,10736,'sr','ÐŸÐ»ÐµÐ°ÑÐµ Ð˜Ð½Ñ†Ð»ÑƒÐ´Ðµ ÐžÐ½-Site.com ÐŸÑ€Ð¾Ð¿ÐµÑ€Ñ‚y Ð˜Ð”',0),(386469,10736,'vi','vui lÃ²ng bao gá»“m mÃ£ tÃ i sáº£n on-site.com',0),(386470,10736,'af','Sluit asseblief On-Site.com Eiendom ID in',0),(386471,10736,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i pe-Site.com proprietatea ID',0),(386472,10736,'et','Palun lisage-Site.com atribuudi ID',0),(386473,10736,'si','Prosimo, da vkljuÄite na Site.com ID lastnosti',0),(386474,10736,'ba','Harap sertakan di Site.com Properti ID',0),(386475,10736,'nl','Gelieve te omvatten op-Site.com eigenschap ID',0),(386476,10736,'fi','LiitÃ¤-Site.com tunnus',0),(386477,10736,'no','Ta pÃ¥-Site.com egenskaps-ID',0),(386478,10736,'da','Inkluder venligst pÃ¥-Site.com egenskabs-ID',0),(386479,10736,'ko','Site.com ì†ì„± IDë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(386480,10736,'he','× × ×œ×›×œ×•×œ ×ž×–×”×” ×”×ž××¤×™×™×Ÿ ×‘- Site.com',0),(386481,10736,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Î¹Î´Î¹ÏŒÏ„Î·Ï„Î±Ï‚-Site.com',0),(386482,10736,'zh','è¯·åˆ—å…¥ç½‘å€å±žæ€§ç¼–å·\r\n',0),(386483,10736,'sv','VÃ¤nligen inkludera pÃ¥-Site.com egenskaps-ID',0),(386484,10736,'it','Si prega di includere su-Site.com proprietÃ  ID',0),(386485,10736,'tl','',0),(386486,10736,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸£à¸«à¸±à¸ªà¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸šà¸™ Site.com',0),(386487,10736,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤° Site.com à¤—à¥à¤£ ID à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(386488,10736,'ms','Sila sertakan ID harta pada Site.com',0),(386489,10736,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ù…Ø¹Ø±Ù Ø§Ù„Ø®Ø§ØµÙŠØ© Ø¹Ù„Ù‰ Site.com',0),(386490,10736,'fr','Veuillez inclure les ID de propriÃ©tÃ© de sur-site.com',0),(386491,10736,'jp','Site.com ã«ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ ID ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(386492,10736,'pt','Por favor, inclua na-Site.com Propriedade ID',0),(386493,10736,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°-Site.com',0),(386494,10736,'es','Por Favor Incluye On-Site.com ID de Propiedad',0),(386495,10736,'de','Bitte geben Sie auf-Site.com-Property-ID',0),(386496,10736,'en','Please Include On-Site.com Property ID',0),(386497,10737,'is','',0),(386498,10737,'dr','On-Site.com ',0),(386499,10737,'pr','Ù„Ø·ÙØ§ Ù†Ø§Ù… ÙƒØ§Ø±Ø¨Ø±ÙŠ  Ø±Ø§ Ø§Ø² Ø³Ø§ÙŠØª Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ On-Site.com ',0),(386500,10737,'tr','LÃ¼tfen-Site.com kullanÄ±cÄ± adÄ±nÄ±zÄ± eklemek',0),(386501,10737,'pl','ProszÄ™ podaÄ‡ nazwÄ™ uÅ¼ytkownika na Site.com',0),(386502,10737,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¿Ð¾ Site.com Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ',0),(386503,10737,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Site.com Ù¾Ø± ØµØ§Ø±Ù Ù†Ø§Ù… Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(386504,10737,'sr','ÐŸÐ»ÐµÐ°ÑÐµ Ð˜Ð½Ñ†Ð»ÑƒÐ´Ðµ ÐžÐ½-Site.com Ð£ÑÐµÑ€Ð½Ð°Ð¼Ðµ',0),(386505,10737,'vi','vui lÃ²ng bao gá»“m ngÆ°á»i sá»­ dá»¥ng on-site.com',0),(386506,10737,'af','Sluit asseblief On-Site.com Gebruikernaam in',0),(386507,10737,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i numele de utilizator pe-Site.com',0),(386508,10737,'et','Palun lisage-Site.com kasutajanimi',0),(386509,10737,'si','Prosimo, da vkljuÄite na Site.com uporabniÅ¡ko ime',0),(386510,10737,'ba','Harap Sertakan nama pengguna pada Site.com',0),(386511,10737,'nl','Vermeldt dan aub op-Site.com gebruikersnaam',0),(386512,10737,'fi','LiitÃ¤-Site.com kÃ¤yttÃ¤jÃ¤tunnus',0),(386513,10737,'no','Ta pÃ¥-Site.com brukernavn',0),(386514,10737,'da','Inkluder venligst pÃ¥-Site.com Username',0),(386515,10737,'ko','Site.com ì‚¬ìš©ìž ì´ë¦„ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(386516,10737,'he','× × ×œ×›×œ×•×œ ××ª ×©× ×”×ž×©×ª×ž×© ×‘- Site.com',0),(386517,10737,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î·-Site.com',0),(386518,10737,'zh','è¯·åˆ—å…¥ç½‘å€ç”¨æˆ·å\r\n',0),(386519,10737,'sv','VÃ¤nligen inkludera pÃ¥-Site.com anvÃ¤ndarnamn',0),(386520,10737,'it','Si prega di includere nome utente su-Site.com',0),(386521,10737,'tl','',0),(386522,10737,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸šà¸™ Site.com',0),(386523,10737,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ Site.com à¤ªà¤° à¤ªà¥à¤°à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(386524,10737,'ms','Sila masukkan nama pengguna di Site.com',0),(386525,10737,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¹Ù„Ù‰ Site.com',0),(386526,10737,'fr','Veuillez inclure le nom d\'utilisateur sur-site.com',0),(386527,10737,'jp','Site.com ã«ãƒ¦ãƒ¼ã‚¶ãƒ¼åã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(386528,10737,'pt','Por favor inclua o nome de usuÃ¡rio na-Site.com',0),(386529,10737,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð˜Ð¼Ñ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ On-Site.com',0),(386530,10737,'es','Por Favor Incluye On-Site.com Nombre de Usuario',0),(386531,10737,'de','Bitte geben Sie Benutzernamen auf-Site.com',0),(386532,10737,'en','Please Include On-Site.com Username',0),(386533,10738,'is','',0),(386534,10738,'dr','Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø¯Ø± Ø³Ø§ÙŠØª Ø²ÙŠØ± Ø¯Ø§Ø±Ø¯\r\n  On-Site.com ',0),(386535,10738,'pr','Ø§ÙŠÙ† ÙƒØ§Ø±Ø¨Ø± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ø¯Ø± Ø³Ø§ÙŠØª Ø²ÙŠØ± Ø¯Ø§Ø±Ø¯\r\n  On-Site.com ',0),(386536,10738,'tr','Bu kullanÄ±cÄ± zaten-Site.com kurulum var.',0),(386537,10738,'pl','Ten uÅ¼ytkownik ma juÅ¼ instalacji na Site.com',0),(386538,10738,'bg','Ð¢Ð¾Ð·Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð²ÐµÑ‡Ðµ Ð¸Ð¼Ð° Ð¿Ð¾ Site.com Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(386539,10738,'ur','Ø§Ø³ ØµØ§Ø±Ù Ú©Ùˆ Ø§ÛŒÚ© Site.com Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾ ÛÛ’',0),(386540,10738,'sr','Ð¢Ñ…Ð¸Ñ Ð£ÑÐµÑ€ ÐÐ»Ñ€ÐµÐ°Ð´y Ð¥Ð°Ñ Ð°Ð½ ÐžÐ½-Site.com Ð¡ÐµÑ‚ÑƒÐ¿',0),(386541,10738,'vi','ThÃ nh viÃªn nÃ y Ä‘Ã£ CÃ³ má»™t cÃ i Ä‘áº·t On-Site.com',0),(386542,10738,'af','Hierdie Gebruiker is alreeds op On-Site.com Opgestel',0),(386543,10738,'ro','Acest utilizator are deja o configurare de pe-Site.com',0),(386544,10738,'et','Sellel kasutajal juba on-Site.com seadistamine',0),(386545,10738,'si','Ta uporabnik je Å¾e na Site.com Setup',0),(386546,10738,'ba','Pengguna ini sudah memiliki Setup pada Site.com',0),(386547,10738,'nl','Deze gebruiker heeft al een Setup op-Site.com',0),(386548,10738,'fi','KÃ¤yttÃ¤jÃ¤llÃ¤ on jo-Site.com asetukset',0),(386549,10738,'no','Denne brukeren har allerede et pÃ¥-Site.com oppsett',0),(386550,10738,'da','Denne bruger har allerede en pÃ¥-Site.com Setup',0),(386551,10738,'ko','ì´ ì‚¬ìš©ìžëŠ” ì´ë¯¸-Site.com ì„¤ì¹˜',0),(386552,10738,'he','×ž×©×ª×ž×© ×–×” ×›×‘×¨ ×™×© ×”×ª×§× ×” ×‘- Site.com',0),(386553,10738,'el','Î‘Ï…Ï„ÏŒÏ‚ Î¿ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ Î­Ï‡ÎµÎ¹ Î®Î´Î· Î¼Î¹Î± ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Site.com',0),(386554,10738,'zh','è¿™ä¸ªç”¨æˆ·å·²ç»æœ‰ä¸€ä¸ªç«™ç‚¹è®¾ç½®\r\n',0),(386555,10738,'sv','Denna anvÃ¤ndare har en pÃ¥-Site.com Setup',0),(386556,10738,'it','Questo utente ha giÃ  un\'installazione su-Site.com',0),(386557,10738,'tl','',0),(386558,10738,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸£à¸²à¸¢à¸™à¸µà¹‰à¸¡à¸µà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™ Site.com',0),(386559,10738,'hi','à¤¯à¤¹ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤à¤• Site.com à¤ªà¤° à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¹à¥ˆ',0),(386560,10738,'ms','Pengguna ini sudah pun mempunyai persediaan pada Site.com yang',0),(386561,10738,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù„Ø¯ÙŠÙ‡ Ø¨Ø§Ù„ÙØ¹Ù„ Ø¥Ø¹Ø¯Ø§Ø¯ Ø¹Ù„Ù‰ Site.com',0),(386562,10738,'fr','Cet utilisateur dispose dÃ©jÃ  d\'une installation sur-site.com',0),(386563,10738,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã¯æ—¢ã«ã“ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(386564,10738,'pt','Este usuÃ¡rio jÃ¡ possui uma configuraÃ§Ã£o na-Site.com',0),(386565,10738,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ ÑƒÐ¶Ðµ Ð¸Ð¼ÐµÐµÑ‚ Ð½Ð° Site.com ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(386566,10738,'es','Este Usuario Ya Tiene Una ConfiguraciÃ³n en On-Site.com',0),(386567,10738,'de','Dieser Benutzer hat bereits eine Ã¼ber-Site.com-Setup',0),(386568,10738,'en','This User Already Has an On-Site.com Setup',0),(386569,10739,'is','',0),(386570,10739,'dr','Ø¯Ø± Ø¯Ø³Øª ØªØ¹Ù…ÙŠØ± ',0),(386571,10739,'pr','Ø¯Ø± Ø¯Ø³Øª ØªØ¹Ù…ÙŠØ± ',0),(386572,10739,'tr','Tamir altÄ±nda',0),(386573,10739,'pl','W remoncie',0),(386574,10739,'bg','Ð’ Ñ€ÐµÐ¼Ð¾Ð½Ñ‚',0),(386575,10739,'ur','Ù…Ø±Ù…Øª Ú©Û’ ØªØ­Øª',0),(386576,10739,'sr','Ð£ Ñ‚Ð¾ÐºÑƒ Ñ˜Ðµ Ð¿Ð¾Ð¿Ñ€Ð°Ð²ÐºÐ°',0),(386577,10739,'vi','Äang sá»¯a chá»¯a',0),(386578,10739,'af','Onder herstel',0),(386579,10739,'ro','ÃŽn reparaÅ£ie',0),(386580,10739,'et','All remont',0),(386581,10739,'si','Po popravilu',0),(386582,10739,'ba','Dalam perbaikan',0),(386583,10739,'nl','Onder reparatie',0),(386584,10739,'fi','Korjattavana',0),(386585,10739,'no','Under reparasjon',0),(386586,10739,'da','Under reparation',0),(386587,10739,'ko','ìˆ˜ë¦¬ ì•„ëž˜',0),(386588,10739,'he','×ª×—×ª ×ª×™×§×•×Ÿ',0),(386589,10739,'el','Î¥Ï€ÏŒ ÎµÏ€Î¹ÏƒÎºÎµÏ…Î®',0),(386590,10739,'zh','åœ¨ä¿®å¤\r\n',0),(386591,10739,'sv','Under reparation',0),(386592,10739,'it','In riparazione',0),(386593,10739,'tl','',0),(386594,10739,'th','à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸‹à¹ˆà¸­à¸¡à¹à¸‹à¸¡',0),(386595,10739,'hi','à¤®à¤°à¤®à¥à¤®à¤¤ à¤•à¥‡ à¤¤à¤¹à¤¤',0),(386596,10739,'ms','Di bawah pembaikan',0),(386597,10739,'ar','Ù‚ÙŠØ¯ Ø§Ù„ØªØ±Ù…ÙŠÙ…',0),(386598,10739,'fr','En cours de rÃ©paration',0),(386599,10739,'jp','ä¿®ç†ã®ä¸‹ã§',0),(386600,10739,'pt','Em reparaÃ§Ã£o',0),(386601,10739,'ru','Ð’ Ñ€ÐµÐ¼Ð¾Ð½Ñ‚Ðµ',0),(386602,10739,'es','Bajo Reparaciones',0),(386603,10739,'de','In Reparatur',0),(386604,10739,'en','Under Repair',0),(386605,10740,'is','',0),(386606,10740,'dr','ØªØ°ÙƒØ±Ø§Øª Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø±',0),(386607,10740,'pr','ØªØ°ÙƒØ±Ø§Øª Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø±',0),(386608,10740,'tr','Ä°ÅŸ emri tebliÄŸ',0),(386609,10740,'pl','Pracy kolejnoÅ›Ä‡ zgÅ‚oszeÅ„',0),(386610,10740,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(386611,10740,'ur','Ú©Ø§Ù… Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(386612,10740,'sr','Ð Ð°Ð´ Ñ€ÐµÐ´ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ°',0),(386613,10740,'vi','ThÃ´ng bÃ¡o lá»‡nh',0),(386614,10740,'af','Werkbestelling Kennisgewings',0),(386615,10740,'ro','NotificÄƒrile de ordine de lucru',0),(386616,10740,'et','TÃ¶Ã¶ tellimus teated',0),(386617,10740,'si','Delo reda oznanilo',0),(386618,10740,'ba','Kerja perintah pemberitahuan',0),(386619,10740,'nl','Werk om kennisgevingen',0),(386620,10740,'fi','TyÃ¶ ilmoitukset',0),(386621,10740,'no','Arbeid for varsler',0),(386622,10740,'da','Arbejde for meddelelser',0),(386623,10740,'ko','ìž‘ì—… ì£¼ë¬¸ ì•Œë¦¼',0),(386624,10740,'he','×”×•×“×¢×•×ª ×¡×“×¨ ×”×¢×‘×•×“×”',0),(386625,10740,'el','Î‘Î½Î±ÎºÎ¿Î¹Î½ÏŽÏƒÎµÎ¹Ï‚ Ï„Î¬Î¾Î·Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(386626,10740,'zh','å·¥ä½œè®¢å•é€šçŸ¥\r\n',0),(386627,10740,'sv','Arbete fÃ¶r anmÃ¤lningar',0),(386628,10740,'it','Notifiche di ordine di lavoro',0),(386629,10740,'tl','',0),(386630,10740,'th','à¸à¸²à¸£à¹à¸ˆà¹‰à¸‡à¹€à¸•à¸·à¸­à¸™à¸¥à¸³à¸”à¸±à¸šà¸‡à¸²à¸™',0),(386631,10740,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤',0),(386632,10740,'ms','Pemberitahuan perintah kerja',0),(386633,10740,'ar','Ø¹Ù…Ù„ Ø¥Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù…',0),(386634,10740,'fr','Notifications d\'ordre de travail',0),(386635,10740,'jp','ä½œæ¥­æ³¨æ–‡ã®é€šçŸ¥',0),(386636,10740,'pt','NotificaÃ§Ãµes de ordem de trabalho',0),(386637,10740,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(386638,10740,'es','Notificaciones de los Ordenes de Trabajo',0),(386639,10740,'de','Arbeit Auftrag Mitteilungen',0),(386640,10740,'en','Work Order Notifications',0),(386641,10741,'is','',0),(386642,10741,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ°ÙƒØ±Ø§Øª Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(386643,10741,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ°ÙƒØ±Ø§Øª Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(386644,10741,'tr','Ä°ÅŸ emri bildirimleri baÅŸarÄ±sÄ±z ekleme',0),(386645,10741,'pl','Pracy kolejnoÅ›Ä‡ zgÅ‚oszeÅ„ dodaÄ‡ nie powiodÅ‚o siÄ™',0),(386646,10741,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(386647,10741,'ur','Ú©Ø§Ù… ØªØ±ØªÛŒØ¨ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù†Ø§Ú©Ø§Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(386648,10741,'sr','Ð Ð°Ð´ Ñ€ÐµÐ´ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ° Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¿Ð°Ð»Ð¸',0),(386649,10741,'vi','ThÃªm thÃ´ng bÃ¡o lá»‡nh Ä‘Ã£ tháº¥t báº¡i',0),(386650,10741,'af','Werkbestelling Kennisgewings Byvoeging het Gefaal.',0),(386651,10741,'ro','NotificÄƒrile de ordine de lucru Adauga nu a reuÅŸit',0),(386652,10741,'et','TÃ¶Ã¶ tellimuse teatiste lisamine nurjus',0),(386653,10741,'si','Delo reda oznanilo dodati ni',0),(386654,10741,'ba','Kerja perintah pemberitahuan menambahkan gagal',0),(386655,10741,'nl','Werk om kennisgevingen toevoegen mislukte',0),(386656,10741,'fi','TyÃ¶ ilmoitukset lisÃ¤ys epÃ¤onnistui',0),(386657,10741,'no','Arbeid for varsler legge mislyktes',0),(386658,10741,'da','Arbejde for meddelelser tilfÃ¸je mislykkedes',0),(386659,10741,'ko','ìž‘ì—… ìˆœì„œ ì•Œë¦¼ì„ ì¶”ê°€ ì‹¤íŒ¨',0),(386660,10741,'he','×”×•×“×¢×•×ª ×¡×“×¨ ×”×¢×‘×•×“×” ×œ×”×•×¡×™×£ ×©× ×›×©×œ×•',0),(386661,10741,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÏƒÎµÎ¹ÏÎ¬ ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(386662,10741,'zh','å·¥ä½œè®¢å•é€šçŸ¥æ·»åŠ å¤±è´¥\r\n',0),(386663,10741,'sv','Arbete ordning meddelanden lÃ¤gga till misslyckades',0),(386664,10741,'it','Le notifiche di ordine di lavoro aggiungere fallito',0),(386665,10741,'tl','',0),(386666,10741,'th','à¹à¸ˆà¹‰à¸‡à¸‡à¸²à¸™à¸ªà¸±à¹ˆà¸‡à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(386667,10741,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤ à¤µà¤¿à¤«à¤² à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(386668,10741,'ms','Pemberitahuan perintah kerja Tambah gagal',0),(386669,10741,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ÙØ§Ø´Ù„Ø©',0),(386670,10741,'fr','Notifications d\'ordre de travail ajouter ayant Ã©chouÃ©',0),(386671,10741,'jp','è¿½åŠ ã®ä½œæ¥­æ³¨æ–‡ã®é€šçŸ¥ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(386672,10741,'pt','NotificaÃ§Ãµes de ordem de trabalho Adicionar falha',0),(386673,10741,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(386674,10741,'es','Notificaciones de los Ordenes de Trabajo Agregar FallÃ¡ron',0),(386675,10741,'de','Arbeit Auftrag Mitteilungen hinzufÃ¼gen fehlgeschlagen',0),(386676,10741,'en','Work Order Notifications Add Failed',0),(386677,10742,'is','',0),(386678,10742,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ°ÙƒØ±Ø§Øª Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(386679,10742,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ°ÙƒØ±Ø§Øª Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(386680,10742,'tr','Ä°ÅŸ emri tebliÄŸ baÅŸarÄ±yla eklendi',0),(386681,10742,'pl','Pracy kolejnoÅ›Ä‡ zgÅ‚oszeÅ„ dodano pomyÅ›lnie',0),(386682,10742,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(386683,10742,'ur','Ú©Ø§Ù… Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(386684,10742,'sr','Ð Ð°Ð´ Ñ€ÐµÐ´ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(386685,10742,'vi','ThÃªm thÃ´ng bÃ¡o lá»‡nh thÃ nh cÃ´ng',0),(386686,10742,'af','Werk Bestelling Kennisgewings Suksesvol Bygevoeg',0),(386687,10742,'ro','Activitatea comanda notificÄƒri adÄƒugat cu succes',0),(386688,10742,'et','TÃ¶Ã¶ tellimus teated lisatud',0),(386689,10742,'si','Delo reda oznanilo uspeÅ¡no dodani',0),(386690,10742,'ba','Pemberitahuan Order pekerjaan ditambahkan berhasil',0),(386691,10742,'nl','Werk om kennisgevingen toegevoegd',0),(386692,10742,'fi','TyÃ¶ ilmoitukset lisÃ¤Ã¤minen onnistui',0),(386693,10742,'no','Arbeid for varsler lagt',0),(386694,10742,'da','Arbejde for anmeldelser tilfÃ¸jet',0),(386695,10742,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ìž‘ì—… ìˆœì„œ ì•Œë¦¼',0),(386696,10742,'he','×”×•×“×¢×•×ª ×¡×“×¨ ×¢×‘×•×“×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(386697,10742,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÏƒÎµÎ¹ÏÎ¬ ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(386698,10742,'zh','æˆåŠŸæ·»åŠ å·¥ä½œç§©è®¢å•é€šçŸ¥\r\n',0),(386699,10742,'sv','Arbete fÃ¶r anmÃ¤lningar lagts',0),(386700,10742,'it','Notifiche di ordine di lavoro aggiunte con successo',0),(386701,10742,'tl','',0),(386702,10742,'th','à¹à¸ˆà¹‰à¸‡à¹€à¸•à¸·à¸­à¸™à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(386703,10742,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(386704,10742,'ms','Notis arahan kerja yang berjaya menambah',0),(386705,10742,'ar','Ø¹Ù…Ù„ Ø¥Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù… Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(386706,10742,'fr','Notifications d\'ordre travail ajoutÃ©es avec succÃ¨s',0),(386707,10742,'jp','ä½œæ¥­æ³¨æ–‡ã®é€šçŸ¥ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(386708,10742,'pt','NotificaÃ§Ãµes de ordem de trabalho adicionadas com sucesso',0),(386709,10742,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(386710,10742,'es','Notificaciones de los Ordenes de Trabajo Agregados Exitosamente',0),(386711,10742,'de','Arbeit Auftrag Mitteilungen erfolgreich hinzugefÃ¼gt',0),(386712,10742,'en','Work Order Notifications Added Successfully',0),(386713,10743,'is','',0),(386714,10743,'dr','Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(386715,10743,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª ',0),(386716,10743,'tr','Vergiye tabi gelir',0),(386717,10743,'pl','DochÃ³d do opodatkowania',0),(386718,10743,'bg','ÐžÐ±Ð»Ð°Ð³Ð°ÐµÐ¼ Ð´Ð¾Ñ…Ð¾Ð´',0),(386719,10743,'ur','Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ Ø¢Ù…Ø¯Ù†ÛŒ',0),(386720,10743,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´',0),(386721,10743,'vi','Thu nháº­p chá»‹u thuáº¿',0),(386722,10743,'af','Belasbare Inkomste',0),(386723,10743,'ro','Venituri impozabile',0),(386724,10743,'et','Maksustatav tulu',0),(386725,10743,'si','ObdavÄljiv prihodek',0),(386726,10743,'ba','Penghasilan kena pajak',0),(386727,10743,'nl','Belastbaar inkomen',0),(386728,10743,'fi','Verotettavat tulot',0),(386729,10743,'no','Skattbar inntekt',0),(386730,10743,'da','Skattepligtig indkomst',0),(386731,10743,'ko','ê³¼ì„¸ ì†Œë“',0),(386732,10743,'he','×”×›× ×¡×” ×—×™×™×‘×ª ×‘×ž×¡',0),(386733,10743,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­Î¿ ÎµÎ¹ÏƒÏŒÎ´Î·Î¼Î±',0),(386734,10743,'zh','åº”çº³ç¨Žæ‰€å¾—é¢\r\n',0),(386735,10743,'sv','Beskattningsbar inkomst',0),(386736,10743,'it','Reddito imponibile',0),(386737,10743,'tl','',0),(386738,10743,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µ',0),(386739,10743,'hi','à¤•à¤° à¤¯à¥‹à¤—à¥ à¤¯ à¤†à¤¯',0),(386740,10743,'ms','Pendapatan boleh cukai',0),(386741,10743,'ar','Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(386742,10743,'fr','Revenu imposable',0),(386743,10743,'jp','èª²ç¨Žæ‰€å¾—',0),(386744,10743,'pt','Rendimento tributÃ¡vel',0),(386745,10743,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ñ‹Ð¹ Ð´Ð¾Ñ…Ð¾Ð´',0),(386746,10743,'es','Renta Imponible',0),(386747,10743,'de','Steuerbares Einkommen',0),(386748,10743,'en','Taxable Income',0),(386749,10744,'is','',0),(386750,10744,'dr','On-Site.com',0),(386751,10744,'pr','ØªÙ†Ø¸ÙŠÙ…Ø§Øª On-Site.com',0),(386752,10744,'tr','Site.com Kur',0),(386753,10744,'pl','Na Site.com instalacji',0),(386754,10744,'bg','ÐŸÐ¾ Site.com Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(386755,10744,'ur','Site.com Ù¾Ø± Ø³ÛŒÙ¹ Ø§Ù¾',0),(386756,10744,'sr','ÐžÐ½ -Site.com Ð¡ÐµÑ‚ÑƒÐ¿',0),(386757,10744,'vi','Thiáº¿t láº­p trÃªn Site.com',0),(386758,10744,'af','Opstelling van op-Site.com',0),(386759,10744,'ro','Pe-Site.com Setup',0),(386760,10744,'et','Site.com seadistamine',0),(386761,10744,'si','Na Site.com Setup',0),(386762,10744,'ba','Setup pada Site.com',0),(386763,10744,'nl','Op-Site.com Setup',0),(386764,10744,'fi','-Site.com asetukset',0),(386765,10744,'no','PÃ¥-Site.com oppsett',0),(386766,10744,'da','PÃ¥-Site.com Setup',0),(386767,10744,'ko','Site.com ì„¤ì¹˜',0),(386768,10744,'he','×”×”×ª×§× ×” ×‘- Site.com',0),(386769,10744,'el','-Site.com ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(386770,10744,'zh','ç½‘å€å®‰è£…\r\n',0),(386771,10744,'sv','PÃ¥-Site.com Setup',0),(386772,10744,'it','Installazione su-Site.com',0),(386773,10744,'tl','',0),(386774,10744,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™ Site.com',0),(386775,10744,'hi','à¤ªà¤°-Site.com à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(386776,10744,'ms','Persediaan terakhir Site.com',0),(386777,10744,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ ÙÙŠ Site.com',0),(386778,10744,'fr','Installation sur-site.com',0),(386779,10744,'jp','Site.com ã«ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(386780,10744,'pt','InstalaÃ§Ã£o de no-Site.com',0),(386781,10744,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð½Ð° Site.com',0),(386782,10744,'es','On-Site.com ConfiguraciÃ³n',0),(386783,10744,'de','Auf-Site.com-Setup',0),(386784,10744,'en','On-Site.com Setup',0),(386785,10745,'is','',0),(386786,10745,'dr','(ÙˆØ±ÙˆØ¯ÙŠ',0),(386787,10745,'pr','Ù¾Ø±ØªØ§Ù„ (ÙˆØ±ÙˆØ¯ÙŠ',0),(386788,10745,'tr','Portal',0),(386789,10745,'pl','Portal',0),(386790,10745,'bg','ÐŸÐ¾Ñ€Ñ‚Ð°Ð»',0),(386791,10745,'ur','Ù¾ÙˆØ±Ù¹Ù„',0),(386792,10745,'sr','ÐŸÐ¾Ñ€Ñ‚Ð°Ð»',0),(386793,10745,'vi','Cá»•ng thÃ´ng tin',0),(386794,10745,'af','Portaal',0),(386795,10745,'ro','Portal',0),(386796,10745,'et','Portaal',0),(386797,10745,'si','Portal',0),(386798,10745,'ba','Portal',0),(386799,10745,'nl','Portaal',0),(386800,10745,'fi','Portaali',0),(386801,10745,'no','Portal',0),(386802,10745,'da','Portal',0),(386803,10745,'ko','í¬í„¸',0),(386804,10745,'he','×¤×•×¨×˜×œ',0),(386805,10745,'el','Î ÏÎ»Î·',0),(386806,10745,'zh','é—¨æˆ·ç½‘ç«™\r\n',0),(386807,10745,'sv','Portal',0),(386808,10745,'it','Portal',0),(386809,10745,'tl','',0),(386810,10745,'th','à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ',0),(386811,10745,'hi','à¤ªà¥‹à¤°à¥à¤Ÿà¤²',0),(386812,10745,'ms','Portal',0),(386813,10745,'ar','Ø¨ÙˆØ§Ø¨Ø©',0),(386814,10745,'fr','Portail',0),(386815,10745,'jp','ãƒãƒ¼ã‚¿ãƒ«',0),(386816,10745,'pt','Portal',0),(386817,10745,'ru','ÐŸÐ¾Ñ€Ñ‚Ð°Ð»',0),(386818,10745,'es','Portal',0),(386819,10745,'de','Portal',0),(386820,10745,'en','Portal',0),(386821,10746,'is','',0),(386822,10746,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ø±',0),(386823,10746,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ø±',0),(386824,10746,'tr','Ä°ÅŸ sipariÅŸleri',0),(386825,10746,'pl','ZleceÅ„',0),(386826,10746,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð·Ð°ÑÐ²ÐºÐ¸',0),(386827,10746,'ur','Ú©Ø§Ù… Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(386828,10746,'sr','Ð Ð°Ð´Ð½Ð¸Ð¼ Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð°',0),(386829,10746,'vi','Lá»‡nh lÃ m viá»‡c',0),(386830,10746,'af','Werkbestellings',0),(386831,10746,'ro','Comenzi de lucru',0),(386832,10746,'et','TÃ¶Ã¶d jÃ¤rjekorras',0),(386833,10746,'si','Delovnih nalogov',0),(386834,10746,'ba','Kerja perintah',0),(386835,10746,'nl','Werkorders',0),(386836,10746,'fi','TyÃ¶tilaukset',0),(386837,10746,'no','Arbeidsordre',0),(386838,10746,'da','Arbejdsordrer',0),(386839,10746,'ko','ìž‘ì—… ìˆœì„œ',0),(386840,10746,'he','×”×–×ž× ×•×ª ×¢×‘×•×“×”',0),(386841,10746,'el','Î”Î¹Î±Ï„Î±Î³Î­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(386842,10746,'zh','å·¥ä½œå•\r\n',0),(386843,10746,'sv','Arbetsorder',0),(386844,10746,'it','Ordini di lavoro',0),(386845,10746,'tl','',0),(386846,10746,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™',0),(386847,10746,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤†à¤¦à¥‡à¤¶',0),(386848,10746,'ms','Arahan kerja',0),(386849,10746,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¹Ù…Ù„',0),(386850,10746,'fr','Bons de travail',0),(386851,10746,'jp','ä½œæ¥­æŒ‡ç¤º',0),(386852,10746,'pt','Ordens de trabalho',0),(386853,10746,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹',0),(386854,10746,'es','Ordenes de Trabajo',0),(386855,10746,'de','ArbeitsauftrÃ¤ge',0),(386856,10746,'en','Work Orders',0),(386857,10747,'is','',0),(386858,10747,'dr','(ÙˆØ±ÙˆØ¯ÙŠ)Ø¨Ø±Ù†Ø§Ù…Ù‡  Ø§ÙƒØ³Ø³(Ø¯Ø³ØªØ±Ø³ÙŠ',0),(386859,10747,'pr','Ù…Ø¯ÙŠØ±ÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù¾Ø±ØªØ§Ù„ (ÙˆØ±ÙˆØ¯ÙŠ)Ø¨Ø±Ù†Ø§Ù…Ù‡  Ø§ÙƒØ³Ø³(Ø¯Ø³ØªØ±Ø³ÙŠ',0),(386860,10747,'tr','MÃ¼lkiyet yÃ¶netimi Portal eriÅŸim',0),(386861,10747,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ zarzÄ…dzanie dostÄ™pu do portalu',0),(386862,10747,'bg','Ð˜Ð¼Ð¾Ñ‚Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€Ñ‚Ð°Ð»Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(386863,10747,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ Ù¾ÙˆØ±Ù¹Ù„ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ',0),(386864,10747,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐ° Ð¿Ð¾Ñ€Ñ‚Ð°Ð»Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð°',0),(386865,10747,'vi','Báº¥t Ä‘á»™ng sáº£n quáº£n lÃ½ cá»•ng thÃ´ng tin truy cáº­p',0),(386866,10747,'af','Eiendom bestuur Portal toegang',0),(386867,10747,'ro','Proprietatea gestionare acces Portal',0),(386868,10747,'et','Kinnisvara haldamise sissepÃ¤Ã¤s',0),(386869,10747,'si','Lastnosti upravljanja dostopa do portala',0),(386870,10747,'ba','Properti manajemen Portal akses',0),(386871,10747,'nl','Eigenschap beheer Portal-toegang',0),(386872,10747,'fi','Omaisuuden hallinta portaalin',0),(386873,10747,'no','Egenskapstilgang Management Portal',0),(386874,10747,'da','Property Management portalen adgang',0),(386875,10747,'ko','ì†ì„± ê´€ë¦¬ í¬í„¸ ì•¡ì„¸ìŠ¤',0),(386876,10747,'he','×’×™×©×ª ×¤×•×¨×˜×œ × ×™×”×•×œ ×¨×›×•×©',0),(386877,10747,'el','Î ÏÎ»Î· Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚ Î±ÎºÎ¹Î½Î®Ï„Ï‰Î½',0),(386878,10747,'zh','ç‰©ä¸šç®¡ç†é—¨æˆ·è®¿é—®\r\n',0),(386879,10747,'sv','Property Management Portal tillgÃ¥ng',0),(386880,10747,'it','ProprietÃ  gestione accesso portale',0),(386881,10747,'tl','',0),(386882,10747,'th','à¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¸žà¸­à¸£à¹Œà¸—à¸±à¸¥à¸ˆà¸±à¸”à¸à¸²à¸£à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(386883,10747,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤ªà¥‹à¤°à¥à¤Ÿà¤² à¤¤à¤• à¤ªà¤¹à¥à¤à¤š',0),(386884,10747,'ms','Akses Portal Pengurusan Harta',0),(386885,10747,'ar','Ø®Ø§ØµÙŠØ© Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø¯Ø®Ù„',0),(386886,10747,'fr','AccÃ¨s portail de gestion de propriÃ©tÃ©',0),(386887,10747,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ç®¡ç†ãƒãƒ¼ã‚¿ãƒ«ã¸ã®ã‚¢ã‚¯ã‚»ã‚¹',0),(386888,10747,'pt','Acesso Portal de gestÃ£o de propriedade',0),(386889,10747,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿ Ðº Ð¿Ð¾Ñ€Ñ‚Ð°Ð»Ñƒ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(386890,10747,'es','GestiÃ³n de Propiedad Acceso al Portal',0),(386891,10747,'de','Eigenschaftenzugriff Management Portal',0),(386892,10747,'en','Property Management Portal Access',0),(386893,10748,'is','',0),(386894,10748,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ',0),(386895,10748,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÙŠ',0),(386896,10748,'tr','Daha fazla bilgi',0),(386897,10748,'pl','Dodatkowe informacje',0),(386898,10748,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(386899,10748,'ur','Ø§Ø¶Ø§ÙÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(386900,10748,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(386901,10748,'vi','ThÃ´ng tin bá»• sung',0),(386902,10748,'af','Addisionele Inligting',0),(386903,10748,'ro','InformaÈ›ii suplimentare despre',0),(386904,10748,'et','Lisateave',0),(386905,10748,'si','Dodatne informacije',0),(386906,10748,'ba','Informasi tambahan',0),(386907,10748,'nl','Extra informatie',0),(386908,10748,'fi','LisÃ¤tietoja',0),(386909,10748,'no','Tilleggsinformasjon',0),(386910,10748,'da','Yderligere oplysninger',0),(386911,10748,'ko','ì¶”ê°€ ì •ë³´',0),(386912,10748,'he','×ž×™×“×¢ × ×•×¡×£',0),(386913,10748,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(386914,10748,'zh','é™„åŠ ä¿¡æ¯\r\n',0),(386915,10748,'sv','Ytterligare Information',0),(386916,10748,'it','Informazioni aggiuntive',0),(386917,10748,'tl','',0),(386918,10748,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(386919,10748,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(386920,10748,'ms','Maklumat tambahan',0),(386921,10748,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ©',0),(386922,10748,'fr','Plus d\'informations',0),(386923,10748,'jp','è¿½åŠ æƒ…å ±',0),(386924,10748,'pt','InformaÃ§Ãµes adicionais',0),(386925,10748,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(386926,10748,'es','InformaciÃ³n adicional',0),(386927,10748,'de','Weitere Informationen',0),(386928,10748,'en','Additional Information',0),(386929,10749,'is','',0),(386930,10749,'dr','( Ú¯Ø²ÙŠÙ†Ø´- ØºØ±Ø¨Ø§Ù„ Ú¯ÙŠØ±ÙŠ',0),(386931,10749,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¢Ø²Ù…Ø§ÙŠØ´ ( Ú¯Ø²ÙŠÙ†Ø´- ØºØ±Ø¨Ø§Ù„ Ú¯ÙŠØ±ÙŠ',0),(386932,10749,'tr','Tarama Ekle',0),(386933,10749,'pl','DodaÄ‡ pokaz',0),(386934,10749,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(386935,10749,'ur','Ø§Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(386936,10749,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(386937,10749,'vi','ThÃªm  chá»n lá»c',0),(386938,10749,'af','Keuring Byvoeg',0),(386939,10749,'ro','Adauga Screening',0),(386940,10749,'et','Lisada sÃµelumine',0),(386941,10749,'si','Dodaj presejalni',0),(386942,10749,'ba','Tambahkan skrining',0),(386943,10749,'nl','Toevoegen van Screening',0),(386944,10749,'fi','LisÃ¤Ã¤ seulonta',0),(386945,10749,'no','Legge til Screening',0),(386946,10749,'da','TilfÃ¸je Screening',0),(386947,10749,'ko','ì¶”ê°€ ìƒì˜',0),(386948,10749,'he','×œ×”×•×¡×™×£ ×”×”×§×¨× ×”',0),(386949,10749,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î­Î»ÎµÎ³Ï‡Î¿',0),(386950,10749,'zh','å¢žåŠ ç­›é€‰\r\n',0),(386951,10749,'sv','LÃ¤gg till Screening',0),(386952,10749,'it','Aggiungi Screening',0),(386953,10749,'tl','',0),(386954,10749,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸²à¸£à¸„à¸±à¸”à¸à¸£à¸­à¸‡',0),(386955,10749,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤— à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(386956,10749,'ms','Tambah saringan',0),(386957,10749,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„ÙØ­Øµ',0),(386958,10749,'fr','Ajouter le dÃ©pistage',0),(386959,10749,'jp','ã‚¹ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(386960,10749,'pt','Adicionar seleÃ§Ã£o',0),(386961,10749,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(386962,10749,'es','Agregar Filtros',0),(386963,10749,'de','Screening hinzufÃ¼gen',0),(386964,10749,'en','Add Screening',0),(386965,10750,'is','',0),(386966,10750,'dr','Ø¯Ø±Ø¢Ù…Ø¯ Ø³Ø§Ù„Ø§Ù†Ù‡ ',0),(386967,10750,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ø³Ø§Ù„Ø§Ù†Ù‡ ',0),(386968,10750,'tr','YÄ±llÄ±k gelir',0),(386969,10750,'pl','Roczny dochÃ³d',0),(386970,10750,'bg','Ð“Ð¾Ð´Ð¸ÑˆÐµÐ½ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´',0),(386971,10750,'ur','Ø³Ø§Ù„Ø§Ù†Û Ø¢Ù…Ø¯Ù†ÛŒ',0),(386972,10750,'sr','Ð“Ð¾Ð´Ð¸ÑˆÑšÐ¸ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´',0),(386973,10750,'vi','Thu nháº­p hÃ ng nÄƒm',0),(386974,10750,'af','Jaarlikse Inkomste',0),(386975,10750,'ro','Venitul anual',0),(386976,10750,'et','Aastatulu',0),(386977,10750,'si','Letni prihodek',0),(386978,10750,'ba','Pendapatan tahunan',0),(386979,10750,'nl','Jaarlijkse inkomen',0),(386980,10750,'fi','Vuositulot',0),(386981,10750,'no','Ã…rsinntekt',0),(386982,10750,'da','Ã…rsindtÃ¦gt',0),(386983,10750,'ko','ì—°ê°„ ì†Œë“',0),(386984,10750,'he','×”×›× ×¡×” ×©× ×ª×™×ª',0),(386985,10750,'el','Î•Ï„Î®ÏƒÎ¹Î¿ ÎµÎ¹ÏƒÏŒÎ´Î·Î¼Î±',0),(386986,10750,'zh','å¹´æ”¶å…¥\r\n',0),(386987,10750,'sv','Ã…rsinkomst',0),(386988,10750,'it','Reddito annuo',0),(386989,10750,'tl','',0),(386990,10750,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¸•à¹ˆà¸­à¸›à¸µ',0),(386991,10750,'hi','à¤µà¤¾à¤°à¥à¤·à¤¿à¤• à¤†à¤¯',0),(386992,10750,'ms','Pendapatan tahunan',0),(386993,10750,'ar','Ø§Ù„Ø¯Ø®Ù„ Ø§Ù„Ø³Ù†ÙˆÙŠ',0),(386994,10750,'fr','Revenu annuel',0),(386995,10750,'jp','å¹´é–“åŽå…¥',0),(386996,10750,'pt','Rendimento anual',0),(386997,10750,'ru','Ð“Ð¾Ð´Ð¾Ð²Ð¾Ð¹ Ð´Ð¾Ñ…Ð¾Ð´',0),(386998,10750,'es','Ingreso Anual',0),(386999,10750,'de','Jahreseinkommen',0),(387000,10750,'en','Annual Income',0),(387001,10751,'is','',0),(387002,10751,'dr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯',0),(387003,10751,'pr','ØªØ§Ø±ÙŠØ® ØªÙˆÙ„Ø¯',0),(387004,10751,'tr','DoÄŸum gÃ¼nÃ¼',0),(387005,10751,'pl','Data urodzenia',0),(387006,10751,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ',0),(387007,10751,'ur','ØªØ§Ø±ÛŒØ®Ù Ù¾ÛŒØ¯Ø§Ø¦Ø´',0),(387008,10751,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ€Ð¾Ñ’ÐµÑšÐ°',0),(387009,10751,'vi','ngÃ y sinh',0),(387010,10751,'af','Geboortedatum',0),(387011,10751,'ro','Data naÅŸterii',0),(387012,10751,'et','SÃ¼nnikuupÃ¤ev',0),(387013,10751,'si','Datum rojstva',0),(387014,10751,'ba','Tanggal Lahir',0),(387015,10751,'nl','Geboortedatum',0),(387016,10751,'fi','SyntymÃ¤aika',0),(387017,10751,'no','FÃ¸dselsdato',0),(387018,10751,'da','FÃ¸dselsdato',0),(387019,10751,'ko','ìƒë…„ì›”ì¼',0),(387020,10751,'he','×ª××¨×™×š ×œ×™×“×”',0),(387021,10751,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î³Î­Î½Î½Î·ÏƒÎ·Ï‚',0),(387022,10751,'zh','å‡ºç”Ÿæ—¥æœŸ\r\n',0),(387023,10751,'sv','FÃ¶delsedatum',0),(387024,10751,'it','Data di nascita',0),(387025,10751,'tl','',0),(387026,10751,'th','à¸§à¸±à¸™à¹€à¸à¸´à¸”',0),(387027,10751,'hi','à¤œà¤¨à¥à¤® à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(387028,10751,'ms','Tarikh lahir',0),(387029,10751,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ÙŠÙ„Ø§Ø¯',0),(387030,10751,'fr','Date de naissance',0),(387031,10751,'jp','å‡ºç”Ÿå¹´æœˆæ—¥',0),(387032,10751,'pt','Data de nascimento',0),(387033,10751,'ru','Ð”Ð°Ñ‚Ð° Ð Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(387034,10751,'es','Fecha de Nacimiento',0),(387035,10751,'de','Geburtsdatum',0),(387036,10751,'en','Birth Date',0),(387037,10752,'is','',0),(387038,10752,'dr','Ø¶Ø§ÙŠØ¹Ø§Øª ÙØ¹Ù„ÙŠ ',0),(387039,10752,'pr','Ø¶Ø§ÙŠØ¹Ø§Øª ÙØ¹Ù„ÙŠ ',0),(387040,10752,'tr','GeÃ§erli gÃ¶sterimleri',0),(387041,10752,'pl','Aktualne pokazy',0),(387042,10752,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¿Ñ€Ð¾Ð¶ÐµÐºÑ†Ð¸Ð¸',0),(387043,10752,'ur','Ø­Ø§Ù„ÛŒÛ ØªØ§Ø±ÛŒØ®',0),(387044,10752,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(387045,10752,'vi','mÃ n hÃ¬nh hiá»‡n nay',0),(387046,10752,'af','Huidige Keurings',0),(387047,10752,'ro','ProiecÅ£ii de curent',0),(387048,10752,'et','Praegune piletid',0),(387049,10752,'si','Trenutne projekcije',0),(387050,10752,'ba','Pemutaran saat ini',0),(387051,10752,'nl','Huidige Screenings',0),(387052,10752,'fi','Nykyinen nÃ¤ytÃ¶kset',0),(387053,10752,'no','Gjeldende visninger',0),(387054,10752,'da','NuvÃ¦rende screeninger',0),(387055,10752,'ko','í˜„ìž¬ ê²€ ì§„',0),(387056,10752,'he','×”×§×¨× ×•×ª ×”× ×•×›×—×™',0),(387057,10752,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎµÏ‚ Ï€ÏÎ¿Î²Î¿Î»Î­Ï‚',0),(387058,10752,'zh','å½“å‰æ”¾æ˜ \r\n',0),(387059,10752,'sv','Aktuella fÃ¶restÃ¤llningar',0),(387060,10752,'it','Proiezioni attuali',0),(387061,10752,'tl','',0),(387062,10752,'th','à¸‰à¸²à¸à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(387063,10752,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤­à¥‚à¤¸à¥€',0),(387064,10752,'ms','Semasa main balik',0),(387065,10752,'ar','Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(387066,10752,'fr','Examens prÃ©alables',0),(387067,10752,'jp','ç¾åœ¨ä¸Šæ˜ ',0),(387068,10752,'pt','Atual Screenings',0),(387069,10752,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ ÑÐµÐ°Ð½ÑÑ‹',0),(387070,10752,'es','Filtraciones Corrientes',0),(387071,10752,'de','Aktuelle VorfÃ¼hrungen',0),(387072,10752,'en','Current Screenings',0),(387073,10753,'is','',0),(387074,10753,'dr','Ø±Ø§ÙŠ',0),(387075,10753,'pr','Ø±Ø§ÙŠ',0),(387076,10753,'tr','Karar',0),(387077,10753,'pl','Decyzja',0),(387078,10753,'bg','Ð ÐµÑˆÐµÐ½Ð¸Ðµ',0),(387079,10753,'ur','ÙÛŒØµÙ„Û',0),(387080,10753,'sr','ÐžÐ´Ð»ÑƒÐºÐ°',0),(387081,10753,'vi','Quyáº¿t Ä‘á»‹nh',0),(387082,10753,'af','Besluit',0),(387083,10753,'ro','Decizia',0),(387084,10753,'et','Otsus',0),(387085,10753,'si','OdloÄitev',0),(387086,10753,'ba','Keputusan',0),(387087,10753,'nl','Besluit',0),(387088,10753,'fi','PÃ¤Ã¤tÃ¶s',0),(387089,10753,'no','AvgjÃ¸relse',0),(387090,10753,'da','AfgÃ¸relse',0),(387091,10753,'ko','ê²°ì •',0),(387092,10753,'he','×”×—×œ×˜×”',0),(387093,10753,'el','Î‘Ï€ÏŒÏ†Î±ÏƒÎ·',0),(387094,10753,'zh','å†³ç­–\r\n',0),(387095,10753,'sv','Beslut',0),(387096,10753,'it','Decisione',0),(387097,10753,'tl','',0),(387098,10753,'th','à¸à¸²à¸£à¸•à¸±à¸”à¸ªà¸´à¸™à¹ƒà¸ˆ',0),(387099,10753,'hi','à¤¨à¤¿à¤°à¥à¤£à¤¯',0),(387100,10753,'ms','Keputusan',0),(387101,10753,'ar','Ù‚Ø±Ø§Ø±',0),(387102,10753,'fr','DÃ©cision',0),(387103,10753,'jp','æ„æ€æ±ºå®š',0),(387104,10753,'pt','DecisÃ£o',0),(387105,10753,'ru','Ð ÐµÑˆÐµÐ½Ð¸Ðµ',0),(387106,10753,'es','DecisiÃ³n',0),(387107,10753,'de','Entscheidung',0),(387108,10753,'en','Decision',0),(387109,10754,'is','',0),(387110,10754,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ ',0),(387111,10754,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ ',0),(387112,10754,'tr','Umudu DÃ¼zenle',0),(387113,10754,'pl','Edytuj perspektywa',0),(387114,10754,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(387115,10754,'ur','Ù…Ù†Ø¸Ø± ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(387116,10754,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(387117,10754,'vi','Sá»­a khÃ¡ch hÃ ng triá»ƒn vá»ng',0),(387118,10754,'af','Redigeer Voornemende KliÃ«nt',0),(387119,10754,'ro','Editare Prospect',0),(387120,10754,'et','Redigeeri vÃ¤ljavaade',0),(387121,10754,'si','Uredi moÅ¾nosti',0),(387122,10754,'ba','Mengedit prospek',0),(387123,10754,'nl','Vooruitzicht bewerken',0),(387124,10754,'fi','Muokkaa prospektia',0),(387125,10754,'no','Redigere prospektet',0),(387126,10754,'da','Redigere udsigten',0),(387127,10754,'ko','ì „ë§ íŽ¸ì§‘',0),(387128,10754,'he','×¢×¨×™×›×ª ×¤×¨×•×¡×¤×§×˜',0),(387129,10754,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ®',0),(387130,10754,'zh','ç¼–è¾‘å±•æœ›\r\n',0),(387131,10754,'sv','Redigera utsikter',0),(387132,10754,'it','Modificare la prospettiva',0),(387133,10754,'tl','',0),(387134,10754,'th','à¹à¸à¹‰à¹„à¸‚à¹‚à¸­à¸à¸²à¸ª',0),(387135,10754,'hi','à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(387136,10754,'ms','Edit Prospect',0),(387137,10754,'ar','ØªØ­Ø±ÙŠØ± Ø¢ÙØ§Ù‚',0),(387138,10754,'fr','Modifier la perspective',0),(387139,10754,'jp','è¦‹é€šã—ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(387140,10754,'pt','Editar perspectiva',0),(387141,10754,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(387142,10754,'es','Editar Cliente Potencial',0),(387143,10754,'de','Perspektive bearbeiten',0),(387144,10754,'en','Edit Prospect',0),(387145,10755,'is','',0),(387146,10755,'dr','Ø®Ø·Ø§  Ø´Ø±Ø­ ',0),(387147,10755,'pr','Ø®Ø·Ø§  Ø´Ø±Ø­ ',0),(387148,10755,'tr','Hata aÃ§Ä±klamasÄ±',0),(387149,10755,'pl','Opis bÅ‚Ä™du',0),(387150,10755,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð³Ñ€ÐµÑˆÐºÐ°Ñ‚Ð°',0),(387151,10755,'ur','ØªØµØ±ÛŒØ­ Ù†Ù‚Øµ',0),(387152,10755,'sr','ÐžÐ¿Ð¸Ñ Ð³Ñ€ÐµÑˆÐºÐµ',0),(387153,10755,'vi','Lá»—i mÃ´ táº£',0),(387154,10755,'af','Fout Beskrywing',0),(387155,10755,'ro','Descriere eroare',0),(387156,10755,'et','TÃµrke kirjeldus',0),(387157,10755,'si','Opis napake',0),(387158,10755,'ba','Deskripsi error',0),(387159,10755,'nl','Foutbeschrijving',0),(387160,10755,'fi','Virheen kuvaus',0),(387161,10755,'no','Feilbeskrivelse',0),(387162,10755,'da','Fejlbeskrivelse',0),(387163,10755,'ko','ì˜¤ë¥˜ ì„¤ëª…',0),(387164,10755,'he','×ª×™××•×¨ ×©×’×™××”',0),(387165,10755,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚',0),(387166,10755,'zh','é”™è¯¯è¯´æ˜Ž',0),(387167,10755,'sv','Felbeskrivning',0),(387168,10755,'it','Errore descrizione',0),(387169,10755,'tl','',0),(387170,10755,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(387171,10755,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤µà¤°à¥à¤£à¤¨',0),(387172,10755,'ms','Keterangan kesalahan',0),(387173,10755,'ar','ÙˆØµÙ Ø§Ù„Ø®Ø·Ø£',0),(387174,10755,'fr','Description de l\'erreur',0),(387175,10755,'jp','ã‚¨ãƒ©ãƒ¼ã®èª¬æ˜Ž',0),(387176,10755,'pt','DescriÃ§Ã£o do erro',0),(387177,10755,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(387178,10755,'es','Error DescripciÃ³n',0),(387179,10755,'de','Fehlerbeschreibung',0),(387180,10755,'en','Error Description',0),(387181,10756,'is','',0),(387182,10756,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¬ÙˆØ§Ø¨ Ø¯Ø§Ø¯Ù† Ø§Ø²  Ø³Ø§ÙŠØª  \r\n On-Site.com',0),(387183,10756,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¬ÙˆØ§Ø¨ Ø¯Ø§Ø¯Ù† Ø§Ø²  Ø³Ø§ÙŠØª  \r\n On-Site.com',0),(387184,10756,'tr','Site.com hata yanÄ±tÄ±',0),(387185,10756,'pl','BÅ‚Ä…d odpowiedzi na Site.com',0),(387186,10756,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ Ð¾Ñ‚ Ð½Ð°-Site.com',0),(387187,10756,'ur','Ù†Ù‚Øµ Ú©Û’ Ø¬ÙˆØ§Ø¨ Ù¾Ø± Site.com Ø³Û’',0),(387188,10756,'sr','Ð•Ñ€Ñ€Ð¾Ñ€ Ð ÐµÑÐ¿Ð¾Ð½ÑÐµ Ñ„Ñ€Ð¾Ð¼ ÐžÐ½-Site.com',0),(387189,10756,'vi','Lá»—i tráº£ lá»i tá»« On-Site.com',0),(387190,10756,'af','Fout reaksie van op-Site.com',0),(387191,10756,'ro','RÄƒspuns de eroare de pe-Site.com',0),(387192,10756,'et','TÃµrge vastust Site.com',0),(387193,10756,'si','Napaka odziv na Site.com',0),(387194,10756,'ba','Respon kesalahan dari pada Site.com',0),(387195,10756,'nl','Fout antwoord van op-Site.com',0),(387196,10756,'fi','Virhe vastausta-Site.com',0),(387197,10756,'no','Feilsvar fra pÃ¥-Site.com',0),(387198,10756,'da','Fejlsvar fra pÃ¥-Site.com',0),(387199,10756,'ko','Site.comì—ì„œ ì˜¤ë¥˜ ì‘ë‹µ',0),(387200,10756,'he','×ª×’×•×‘×ª ×©×’×™××” ×ž ×‘- Site.com',0),(387201,10756,'el','Î›Î¬Î¸Î¿Ï‚ Î±Ï€Î¬Î½Ï„Î·ÏƒÎ· Î±Ï€ÏŒ ÏƒÎµ-Site.com',0),(387202,10756,'zh','é”™è¯¯å“åº”ä»Žä¸Šç½‘å€\r\n',0),(387203,10756,'sv','Felsvar frÃ¥n pÃ¥-Site.com',0),(387204,10756,'it','Risposta di errore da su-Site.com',0),(387205,10756,'tl','',0),(387206,10756,'th','à¸•à¸­à¸šà¸ªà¸™à¸­à¸‡à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¸ˆà¸²à¸à¹ƒà¸™ Site.com',0),(387207,10756,'hi','à¤ªà¤°-Site.com à¤¸à¥‡ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¤à¤¿à¤¸à¤¾à¤¦',0),(387208,10756,'ms','Kesilapan jawapan dari pada Site.com',0),(387209,10756,'ar','Ø§Ø³ØªØ¬Ø§Ø¨Ø© Ø§Ù„Ø®Ø·Ø£ Ù…Ù† Ø´Ø£Ù† Site.com',0),(387210,10756,'fr','RÃ©ponse d\'erreur de sur-site.com',0),(387211,10756,'jp','Site.com ã«ã‹ã‚‰ã®ã‚¨ãƒ©ãƒ¼å¿œç­”',0),(387212,10756,'pt','Resposta de erro no-Site.com',0),(387213,10756,'ru','ÐžÑ‚Ð²ÐµÑ‚ Ð¾Ð± Ð¾ÑˆÐ¸Ð±ÐºÐµ Ð¾Ñ‚ Ð½Ð° Site.com',0),(387214,10756,'es','Error Respuesta del On-Site.com',0),(387215,10756,'de','Fehlermeldung vom auf-Site.com',0),(387216,10756,'en','Error Response from On-Site.com',0),(387217,10757,'is','',0),(387218,10757,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(387219,10757,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(387220,10757,'tr','AylÄ±k kira',0),(387221,10757,'pl','MiesiÄ™czny czynsz',0),(387222,10757,'bg','ÐœÐµÑÐµÑ‡ÐµÐ½ Ð½Ð°ÐµÐ¼',0),(387223,10757,'ur','Ù…Ø§ÛØ§Ù†Û Ú©Ø±Ø§ÛŒÛ Ø¯ÛŒÙ†Û’ Ú©Û’',0),(387224,10757,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¸ ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ñƒ',0),(387225,10757,'vi','tiá»n thuÃª hÃ ng thÃ¡ng',0),(387226,10757,'af','Maandelikse huur',0),(387227,10757,'ro','Chiria lunara',0),(387228,10757,'et','Igakuine Rent',0),(387229,10757,'si','MeseÄna najemnina',0),(387230,10757,'ba','Sewa bulanan',0),(387231,10757,'nl','Maandelijkse huur',0),(387232,10757,'fi','Kuukausittainen vuokra',0),(387233,10757,'no','MÃ¥nedlig leie',0),(387234,10757,'da','MÃ¥nedlig leje',0),(387235,10757,'ko','ì›” ì„¸',0),(387236,10757,'he','×©×›×™×¨×•×ª ×—×•×“×©×™×ª',0),(387237,10757,'el','ÎœÎ·Î½Î¹Î±Î¯Î¿ ÎµÎ½Î¿Î¯ÎºÎ¹Î¿',0),(387238,10757,'zh','æœˆç§Ÿé‡‘\r\n',0),(387239,10757,'sv','MÃ¥nadshyra',0),(387240,10757,'it','Affitto mensile',0),(387241,10757,'tl','',0),(387242,10757,'th','à¹€à¸Šà¹ˆà¸²à¸£à¸²à¸¢à¹€à¸”à¸·à¸­à¸™',0),(387243,10757,'hi','à¤®à¤¾à¤¸à¤¿à¤• à¤•à¤¿à¤°à¤¾à¤¯à¤¾',0),(387244,10757,'ms','Sewa bulanan',0),(387245,10757,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø´Ù‡Ø±ÙŠ',0),(387246,10757,'fr','Loyer mensuel',0),(387247,10757,'jp','æœˆé¡è³ƒæ–™',0),(387248,10757,'pt','Aluguel mensal',0),(387249,10757,'ru','ÐœÐµÑÑÑ‡Ð½Ð°Ñ ÐÑ€ÐµÐ½Ð´Ð°',0),(387250,10757,'es','Renta Mensual',0),(387251,10757,'de','Monatliche Miete',0),(387252,10757,'en','Monthly Rent',0),(387253,10758,'is','',0),(387254,10758,'dr','On-Site.com Ø·Ø¨Ù‚ Ø¬ÙˆØ§Ø¨',0),(387255,10758,'pr','On-Site.com Ø·Ø¨Ù‚ Ø¬ÙˆØ§Ø¨',0),(387256,10758,'tr','Site.com yanÄ±t',0),(387257,10758,'pl','Odpowiedzi na Site.com',0),(387258,10758,'bg','ÐŸÐ¾ Site.com Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(387259,10758,'ur','Ù¾Ø± Site.com Ú©Ø§ Ø¬ÙˆØ§Ø¨',0),(387260,10758,'sr','ÐžÐ½ -Site.com Ð ÐµÑÐ¿Ð¾Ð½ÑÐµ',0),(387261,10758,'vi','Tráº£ lá»i On-site.com',0),(387262,10758,'af','Reaksie op-Site.com',0),(387263,10758,'ro','Pe-Site.com rÄƒspuns',0),(387264,10758,'et','Site.com vastus',0),(387265,10758,'si','Odziv na Site.com',0),(387266,10758,'ba','Respon pada Site.com',0),(387267,10758,'nl','Op-Site.com reactie',0),(387268,10758,'fi','-Site.com vastaus',0),(387269,10758,'no','PÃ¥-Site.com svar',0),(387270,10758,'da','PÃ¥-Site.com svar',0),(387271,10758,'ko','Site.com ì‘ë‹µ',0),(387272,10758,'he','×‘- Site.com ×ª×’×•×‘×”',0),(387273,10758,'el','-Site.com Î±Ï€Î¬Î½Ï„Î·ÏƒÎ·',0),(387274,10758,'zh','ç½‘å€å“åº”\r\n',0),(387275,10758,'sv','PÃ¥-Site.com svar',0),(387276,10758,'it','Risposta di su-Site.com',0),(387277,10758,'tl','',0),(387278,10758,'th','à¸•à¸­à¸šà¸ªà¸™à¸­à¸‡à¸šà¸™ Site.com',0),(387279,10758,'hi','à¤ªà¤°-Site.com à¤ªà¥à¤°à¤¤à¤¿à¤•à¥à¤°à¤¿à¤¯à¤¾',0),(387280,10758,'ms','Respon pada Site.com',0),(387281,10758,'ar','ÙˆØ±Ø¯Ø§ Ø¹Ù„Ù‰ Site.com',0),(387282,10758,'fr','RÃ©ponse de sur-site.com',0),(387283,10758,'jp','Site.com ã«å¿œç­”',0),(387284,10758,'pt','Resposta na-Site.com',0),(387285,10758,'ru','ÐžÑ‚Ð²ÐµÑ‚ Ð½Ð° Site.com',0),(387286,10758,'es','On-Site.com Responder',0),(387287,10758,'de','Antwort auf-Site.com',0),(387288,10758,'en','On-Site.com Response',0),(387289,10759,'is','',0),(387290,10759,'dr','Ù„Ø·ÙØ§ Ø§Ø¬Ø§Ø±Ù‡ Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(387291,10759,'pr','Ù„Ø·ÙØ§ Ø§Ø¬Ø§Ø±Ù‡ Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(387292,10759,'tr','LÃ¼tfen aylÄ±k kira iÃ§erir',0),(387293,10759,'pl','ProszÄ™ podaÄ‡ MiesiÄ™czny czynsz',0),(387294,10759,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¼ÐµÑÐµÑ‡ÐµÐ½ Ð½Ð°ÐµÐ¼',0),(387295,10759,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù…Ø§ÛØ§Ù†Û Ú©Ø±Ø§Ø¦Û’ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(387296,10759,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¼ÐµÑÐµÑ‡Ð½Ðµ ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ñƒ',0),(387297,10759,'vi','vui lÃ²ng bao gá»“m thÃ¡ng thuÃª',0),(387298,10759,'af','Sluit asb. Maandelikse Huur in',0),(387299,10759,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i lunar chirie',0),(387300,10759,'et','Palun lisage igakuine Rent',0),(387301,10759,'si','Prosimo, da vkljuÄite meseÄne najemnine',0),(387302,10759,'ba','Harap sertakan sewa bulanan',0),(387303,10759,'nl','Gelieve te omvatten maandelijkse huur',0),(387304,10759,'fi','LiitÃ¤ mukaan kuukausivuokra',0),(387305,10759,'no','Ta mÃ¥nedlig leie',0),(387306,10759,'da','VedlÃ¦g mÃ¥nedlig leje',0),(387307,10759,'ko','ì›” ì„¸ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(387308,10759,'he','×× × ×›×œ×•×œ ×©×›×¨ ×“×™×¨×” ×—×•×“×©×™',0),(387309,10759,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ Î¼Î·Î½Î¹Î±Î¯Î¿ ÎµÎ½Î¿Î¯ÎºÎ¹Î¿',0),(387310,10759,'zh','è¯·åˆ—å…¥æœˆç§Ÿ\r\n',0),(387311,10759,'sv','VÃ¤nligen inkludera mÃ¥nadshyra',0),(387312,10759,'it','Si prega di includere affitto mensile',0),(387313,10759,'tl','',0),(387314,10759,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸§à¸¡à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²à¸£à¸²à¸¢à¹€à¸”à¸·à¸­à¸™',0),(387315,10759,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤®à¤¾à¤¸à¤¿à¤• à¤•à¤¿à¤°à¤¾à¤ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(387316,10759,'ms','Sila termasuk sewa bulanan',0),(387317,10759,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø´Ù‡Ø±ÙŠ',0),(387318,10759,'fr','Veuillez inclure le loyer mensuel',0),(387319,10759,'jp','æœˆé¡è³ƒæ–™ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(387320,10759,'pt','Por favor inclua o aluguel mensal',0),(387321,10759,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ ÐœÐµÑÑÑ‡Ð½ÑƒÑŽ ÐÑ€ÐµÐ½Ð´Ñƒ',0),(387322,10759,'es','Por Favor Incluye Renta Mensual',0),(387323,10759,'de','Bitte geben Sie monatliche Miete',0),(387324,10759,'en','Please Include Monthly Rent',0),(387325,10760,'is','',0),(387326,10760,'dr','(Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ) Ø¢Ù…Ø§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø¢Ø²Ù…Ø§ÙŠØ´ (ØºØ±Ø¨Ø§Ù„ Ú¯Ø±ÙŠ)',0),(387327,10760,'pr','Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ú¯Ø±ÙŠ (Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ) Ø¢Ù…Ø§Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ø¢Ø²Ù…Ø§ÙŠØ´ (ØºØ±Ø¨Ø§Ù„ Ú¯Ø±ÙŠ)',0),(387328,10760,'tr','Tarama iÃ§in hazÄ±r umudu',0),(387329,10760,'pl','Perspektywa gotowy do badaÅ„ przesiewowych',0),(387330,10760,'bg','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°Ñ‚Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¸ Ð·Ð° ÑÐºÑ€Ð¸Ð½Ð¸Ð½Ð³',0),(387331,10760,'ur','Ø§Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯ Ú©Û’ Ù„Ø¦Û’ Ø§Ù…Ú©Ø§Ù† ØªÛŒØ§Ø±',0),(387332,10760,'sr','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð° , ÑÐ¿Ñ€ÐµÐ¼Ð½Ð¸ Ð·Ð° ÑÐ½Ð¸Ð¼Ð°ÑšÐµ',0),(387333,10760,'vi','táº¥t cáº£ sÃ£n sÃ ng Ä‘á»ƒ trÃ¬nh chiáº¿u',0),(387334,10760,'af','Voornemende KliÃ«nt Gereed vir Keuring',0),(387335,10760,'ro','Perspectiva gata pentru screening-ul',0),(387336,10760,'et','Potentsiaalne klient valmis sÃµelumine',0),(387337,10760,'si','MoÅ¾nost pripravljen za pregled',0),(387338,10760,'ba','Prospek siap untuk skrining',0),(387339,10760,'nl','Vooruitzicht klaar voor Screening',0),(387340,10760,'fi','Mahdollisuus valmis seulontaan',0),(387341,10760,'no','Prospektet klar for Screening',0),(387342,10760,'da','Udsigten klar til Screening',0),(387343,10760,'ko','ì‹¬ì‚¬ì— ëŒ€ í•œ ì „ë§ ì¤€ë¹„',0),(387344,10760,'he','×¤×¨×•×¡×¤×§×˜ ×ž×•×›×Ÿ ×œ×”×§×¨× ×”',0),(387345,10760,'el','Î ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ® Î­Ï„Î¿Î¹Î¼Î¿ Î³Î¹Î± Ï„Î· Î´Î¹Î±Î»Î¿Î³Î®',0),(387346,10760,'zh','å‰æ™¯ç­›é€‰å°±ç»ª\r\n',0),(387347,10760,'sv','Prospect redo fÃ¶r Screening',0),(387348,10760,'it','Prospettiva pronto per lo Screening',0),(387349,10760,'tl','',0),(387350,10760,'th','à¸žà¸£à¹‰à¸­à¸¡à¹‚à¸­à¸à¸²à¸ªà¹ƒà¸™à¸à¸²à¸£à¸„à¸±à¸”à¸à¸£à¸­à¸‡',0),(387351,10760,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¯à¤¾à¤°',0),(387352,10760,'ms','Prospek sedia untuk pemeriksaan',0),(387353,10760,'ar','Ø§Ø­ØªÙ…Ø§Ù„ Ø¬Ø§Ù‡Ø²Ø© Ù„Ù„ÙØ­Øµ',0),(387354,10760,'fr','Perspective prÃªt pour le dÃ©pistage',0),(387355,10760,'jp','ã‚¹ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°ã®ãŸã‚ã®è¦‹é€šã—ã®æº–å‚™',0),(387356,10760,'pt','Perspectiva pronto para a seleÃ§Ã£o',0),(387357,10760,'ru','ÐŸÑ€Ð¾ÑÐ¿ÐµÐºÑ‚ Ð³Ð¾Ñ‚Ð¾Ð² Ð´Ð»Ñ ÑÐºÑ€Ð¸Ð½Ð¸Ð½Ð³Ð°',0),(387358,10760,'es','Cliente Potencial Listo para InvestigaciÃ³n',0),(387359,10760,'de','Aussicht auf Ready fÃ¼r Screening',0),(387360,10760,'en','Prospect Ready for Screening',0),(387361,10761,'is','',0),(387362,10761,'dr','Ø´Ù†Ø§Ø³Ù‡ Ú¯Ø²Ø§Ø±Ø´ ',0),(387363,10761,'pr','Ø´Ù†Ø§Ø³Ù‡ Ú¯Ø²Ø§Ø±Ø´ ',0),(387364,10761,'tr','Rapor KimliÄŸi',0),(387365,10761,'pl','Identyfikator raportu',0),(387366,10761,'bg','Ð˜Ð” Ð½Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(387367,10761,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(387368,10761,'sr','Ð˜Ð” Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(387369,10761,'vi','ID bÃ¡o cÃ¡o',0),(387370,10761,'af','Verslag ID',0),(387371,10761,'ro','ID-ul raportului',0),(387372,10761,'et','Aruande ID',0),(387373,10761,'si','ID poroÄila',0),(387374,10761,'ba','ID laporan',0),(387375,10761,'nl','Lijst-ID',0),(387376,10761,'fi','Raporttitunnus',0),(387377,10761,'no','Rapport-ID',0),(387378,10761,'da','Rapport-ID',0),(387379,10761,'ko','ë³´ê³ ì„œ ID',0),(387380,10761,'he','×ž×–×”×” ×“×•×—',0),(387381,10761,'el','ID ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(387382,10761,'zh','æŠ¥å‘Šç¼–å·\r\n',0),(387383,10761,'sv','Rapport-ID',0),(387384,10761,'it','Relazione ID',0),(387385,10761,'tl','',0),(387386,10761,'th','ID à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(387387,10761,'hi','ID à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(387388,10761,'ms','ID Laporan',0),(387389,10761,'ar','Ù…Ø¹Ø±Ù Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(387390,10761,'fr','ID du rapport',0),(387391,10761,'jp','ãƒ¬ãƒãƒ¼ãƒˆ ID',0),(387392,10761,'pt','RelatÃ³rio ID',0),(387393,10761,'ru','ID ÐžÑ‚Ñ‡ÐµÑ‚Ð°',0),(387394,10761,'es','ID de Informe',0),(387395,10761,'de','Berichts-ID',0),(387396,10761,'en','Report ID',0),(387397,10762,'is','',0),(387398,10762,'dr','(Ø­Ø³Ø§Ø¨',0),(387399,10762,'pr','Ù†Ù…Ø±Ù‡(Ø­Ø³Ø§Ø¨',0),(387400,10762,'tr','Puan',0),(387401,10762,'pl','Wynik',0),(387402,10762,'bg','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚',0),(387403,10762,'ur','Ø§Ø³Ú©ÙˆØ±',0),(387404,10762,'sr','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚',0),(387405,10762,'vi','Äiá»ƒm ',0),(387406,10762,'af','Telling',0),(387407,10762,'ro','Scor',0),(387408,10762,'et','Keskmine',0),(387409,10762,'si','Rezultat',0),(387410,10762,'ba','Skor',0),(387411,10762,'nl','Score',0),(387412,10762,'fi','Pisteet',0),(387413,10762,'no','Poengsum',0),(387414,10762,'da','Score',0),(387415,10762,'ko','ì ìˆ˜',0),(387416,10762,'he','×”×¦×™×•×Ÿ',0),(387417,10762,'el','Î£ÎºÎ¿Ï',0),(387418,10762,'zh','åˆ†æ•°\r\n',0),(387419,10762,'sv','PoÃ¤ng',0),(387420,10762,'it','Punteggio',0),(387421,10762,'tl','',0),(387422,10762,'th','à¸„à¸°à¹à¸™à¸™',0),(387423,10762,'hi','à¤¸à¥à¤•à¥‹à¤°',0),(387424,10762,'ms','Skor',0),(387425,10762,'ar','Ù†Ù‚Ø§Ø·',0),(387426,10762,'fr','Score',0),(387427,10762,'jp','ã‚¹ã‚³ã‚¢',0),(387428,10762,'pt','PontuaÃ§Ã£o',0),(387429,10762,'ru','ÐžÑ†ÐµÐ½ÐºÐ°',0),(387430,10762,'es','CalificaciÃ³n',0),(387431,10762,'de','Partitur',0),(387432,10762,'en','Score',0),(387433,10763,'is','',0),(387434,10763,'dr','(ØºØ±Ø¨Ø§Ù„ Ø²Ù†ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(387435,10763,'pr','Ù†Ù…Ø§ÙŠØ´(ØºØ±Ø¨Ø§Ù„ Ø²Ù†ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(387436,10763,'tr','Tarama baÅŸarÄ±yla eklendi',0),(387437,10763,'pl','Dodane pomyÅ›lnie badaÅ„ przesiewowych',0),(387438,10763,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(387439,10763,'ur','Ø§Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(387440,10763,'sr','Ð¡ÐºÑ€Ð¸Ð½Ð¸Ð½Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(387441,10763,'vi','ThÃªm sÃ n lá»c thÃ nh cÃ´ng',0),(387442,10763,'af','Keuring Suksesvol Bygevoeg',0),(387443,10763,'ro','Screening-ul adÄƒugat cu succes',0),(387444,10763,'et','Lisatud sÃµelumine',0),(387445,10763,'si','Presejalni uspeÅ¡no dodani',0),(387446,10763,'ba','Skrining ditambahkan berhasil',0),(387447,10763,'nl','Screening toegevoegd',0),(387448,10763,'fi','Seulonta lisÃ¤Ã¤minen onnistui',0),(387449,10763,'no','Screening lagt',0),(387450,10763,'da','Screening tilfÃ¸jet',0),(387451,10763,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ìƒì˜',0),(387452,10763,'he','×¡×™× ×•×Ÿ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(387453,10763,'el','Î”Î¹Î±Î»Î¿Î³Î® Ï€ÏÎ¿ÏƒÏ„Î¹Î¸Î­Î¼ÎµÎ½Î¿Ï‚ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(387454,10763,'zh','ç­›é€‰æ·»åŠ æˆåŠŸ\r\n',0),(387455,10763,'sv','Screening lagts',0),(387456,10763,'it','Screening aggiunto con successo',0),(387457,10763,'tl','',0),(387458,10763,'th','à¸„à¸±à¸”à¸à¸£à¸­à¸‡à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(387459,10763,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(387460,10763,'ms','Pemeriksaan yang berjaya menambah',0),(387461,10763,'ar','Ø§Ù„ÙØ­Øµ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(387462,10763,'fr','DÃ©pistage ajoutÃ© avec succÃ¨s',0),(387463,10763,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸã‚¹ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°',0),(387464,10763,'pt','Rastreio adicionado com sucesso',0),(387465,10763,'ru','Ð¡ÐºÑ€Ð¸Ð½Ð¸Ð½Ð³, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(387466,10763,'es','AnÃ¡lisis Agregado Exitosamente',0),(387467,10763,'de','Screening erfolgreich hinzugefÃ¼gt',0),(387468,10763,'en','Screening Added Successfully',0),(387469,10764,'is','',0),(387470,10764,'dr','(ØºØ±Ø¨Ø§Ù„ Ø²Ù†ÙŠ',0),(387471,10764,'pr','ØªØ§Ø±ÙŠØ® Ù†Ù…Ø§ÙŠØ´(ØºØ±Ø¨Ø§Ù„ Ø²Ù†ÙŠ',0),(387472,10764,'tr','Tarama tarihi',0),(387473,10764,'pl','Data badaÅ„ przesiewowych',0),(387474,10764,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð´Ð°Ñ‚Ð°Ñ‚Ð°',0),(387475,10764,'ur','Ø§Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(387476,10764,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(387477,10764,'vi','NgÃ y sÃ n lá»c',0),(387478,10764,'af','Keuringsdatum',0),(387479,10764,'ro','Data de screening',0),(387480,10764,'et','LÃ¤bivaatuse kuupÃ¤ev',0),(387481,10764,'si','Datum pregleda',0),(387482,10764,'ba','Skrining tanggal',0),(387483,10764,'nl','Screening datum',0),(387484,10764,'fi','Seulonta pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(387485,10764,'no','Screening dato',0),(387486,10764,'da','Screening dato',0),(387487,10764,'ko','ìƒì˜ ë‚ ì§œ',0),(387488,10764,'he','×”×§×¨× ×ª ×ª××¨×™×š',0),(387489,10764,'el','Î”Î¹Î±Î»Î¿Î³Î®Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(387490,10764,'zh','ç­›é€‰æ—¥æœŸ\r\n',0),(387491,10764,'sv','Screening datum',0),(387492,10764,'it','Data di screening',0),(387493,10764,'tl','',0),(387494,10764,'th','à¸§à¸±à¸™à¸„à¸±à¸”à¸à¸£à¸­à¸‡',0),(387495,10764,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤— à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(387496,10764,'ms','Tarikh saringan',0),(387497,10764,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ­Øµ',0),(387498,10764,'fr','Date de projection',0),(387499,10764,'jp','ã‚¹ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°ã®æ—¥ä»˜',0),(387500,10764,'pt','Data de exibiÃ§Ã£o',0),(387501,10764,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(387502,10764,'es','Fecha de AnÃ¡lisis',0),(387503,10764,'de','Screening Termin',0),(387504,10764,'en','Screening Date',0),(387505,10765,'is','',0),(387506,10765,'dr','(ØºØ±Ø¨Ø§Ù„ Ø²Ù†ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯ ',0),(387507,10765,'pr','Ù†Ù…Ø§ÙŠØ´(ØºØ±Ø¨Ø§Ù„ Ø²Ù†ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²  Ø´Ø¯ ',0),(387508,10765,'tr','Tarama baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(387509,10765,'pl','Pokaz pomyÅ›lnie zaktualizowana',0),(387510,10765,'bg','Ð¡ÐºÑ€Ð¸Ð½Ð¸Ð½Ð³ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(387511,10765,'ur','Ø§Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(387512,10765,'sr','Ð¡ÐºÑ€Ð¸Ð½Ð¸Ð½Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(387513,10765,'vi','Cáº­p nháº­t sÃ n lá»c thÃ nh cÃ´ng',0),(387514,10765,'af','Keuring Suksesvol Opdateer',0),(387515,10765,'ro','Screening-ul actualizat cu succes',0),(387516,10765,'et','SÃµelumine edukalt vÃ¤rskendatud',0),(387517,10765,'si','Presejalni uspeÅ¡no posodobljena',0),(387518,10765,'ba','Skrining yang berhasil',0),(387519,10765,'nl','Screening bijgewerkt',0),(387520,10765,'fi','Seulonta pÃ¤ivitetty',0),(387521,10765,'no','Screening oppdatert',0),(387522,10765,'da','Screening opdateret',0),(387523,10765,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ê²€ì‚¬',0),(387524,10765,'he','×”×”×§×¨× ×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(387525,10765,'el','Î”Î¹Î±Î»Î¿Î³Î® ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(387526,10765,'zh','ç­›é€‰æ›´æ–°æˆåŠŸ\r\n',0),(387527,10765,'sv','Screening uppdaterats',0),(387528,10765,'it','Screening aggiornato con successo',0),(387529,10765,'tl','',0),(387530,10765,'th','à¸„à¸±à¸”à¸à¸£à¸­à¸‡à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(387531,10765,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(387532,10765,'ms','Pemeriksaan yang berjaya dikemas kini',0),(387533,10765,'ar','ÙØ­Øµ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(387534,10765,'fr','DÃ©pistage mis Ã  jour avec succÃ¨s',0),(387535,10765,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸã‚¹ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°',0),(387536,10765,'pt','Rastreio atualizado com sucesso',0),(387537,10765,'ru','Ð¡ÐºÑ€Ð¸Ð½Ð¸Ð½Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(387538,10765,'es','AnÃ¡lisis Actualizado',0),(387539,10765,'de','Screening erfolgreich aktualisiert',0),(387540,10765,'en','Screening Updated Successfully',0),(387541,10766,'is','',0),(387542,10766,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù¾ÙŠØ´â€Œ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§',0),(387543,10766,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ù¾ÙŠØ´â€Œ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§',0),(387544,10766,'tr','Arama umutlarÄ±',0),(387545,10766,'pl','Szukaj perspektywy',0),(387546,10766,'bg','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð¸Ñ‚Ðµ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(387547,10766,'ur','ØªÙ„Ø§Ø´ Ú©Û’ Ø§Ù…Ú©Ø§Ù†Ø§Øª',0),(387548,10766,'sr','Ð˜Ð·Ð³Ð»ÐµÐ´Ð¸ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(387549,10766,'vi','tÃ¬m kiáº¿m triá»ƒn vá»ng',0),(387550,10766,'af','Soek Voornemende KliÃ«nte',0),(387551,10766,'ro','Perspectivele de cÄƒutare',0),(387552,10766,'et','Otsi vÃ¤ljavaateid',0),(387553,10766,'si','Iskanje moÅ¾nosti',0),(387554,10766,'ba','Cari prospek',0),(387555,10766,'nl','Zoek vooruitzichten',0),(387556,10766,'fi','Etsi nÃ¤kymÃ¤t',0),(387557,10766,'no','SÃ¸k etter potensielle kunder',0),(387558,10766,'da','SÃ¸g perspektiver',0),(387559,10766,'ko','ê²€ìƒ‰ ì „ë§',0),(387560,10766,'he','×œ××¤×©×¨×•×™×•×ª ×—×™×¤×•×©',0),(387561,10766,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ­Ï‚',0),(387562,10766,'zh','æœç´¢å‰æ™¯\r\n',0),(387563,10766,'sv','SÃ¶k framtidsutsikter',0),(387564,10766,'it','Prospettive di ricerca',0),(387565,10766,'tl','',0),(387566,10766,'th','à¸„à¹‰à¸™à¸«à¸²à¹à¸™à¸§à¹‚à¸™à¹‰à¸¡',0),(387567,10766,'hi','à¤–à¥‹à¤œ à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾à¤“à¤‚',0),(387568,10766,'ms','Cari prospek',0),(387569,10766,'ar','Ø¢ÙØ§Ù‚ Ø§Ù„Ø¨Ø­Ø«',0),(387570,10766,'fr','Perspectives de recherche',0),(387571,10766,'jp','æ¤œç´¢ã®è¦‹é€šã—',0),(387572,10766,'pt','Perspectivas de pesquisa',0),(387573,10766,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ñ‹',0),(387574,10766,'es','Buscar Clientes Potenciales',0),(387575,10766,'de','Suche Aussichten',0),(387576,10766,'en','Search Prospects',0),(387577,10767,'is','',0),(387578,10767,'dr','(ØºØ±Ø¨Ø§Ù„ Ú¯Ø±ÙŠ )Ø§Ø² Ø¯Ø³Øª Ù…ÙŠ Ø¯Ù‡Ø¯',0),(387579,10767,'pr','Ø§ÙŠÙ† Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø² Ø²ÙŠØ± Ø±Ø§ Ø¨Ø±Ø§ÙŠ Ú¯Ø²ÙŠÙ†Ø´(ØºØ±Ø¨Ø§Ù„ Ú¯Ø±ÙŠ )Ø§Ø² Ø¯Ø³Øª Ù…ÙŠ Ø¯Ù‡Ø¯',0),(387580,10767,'tr','Bu umudu filtreleme iÃ§in aÅŸaÄŸÄ±daki gerekli bilgileri eksik',0),(387581,10767,'pl','Ta perspektywa jest brak nastÄ™pujÄ…ce informacje wymagane dla badaÅ„ przesiewowych',0),(387582,10767,'bg','Ð¢Ð°Ð·Ð¸ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð° Ðµ Ð»Ð¸Ð¿ÑÐ²Ð° ÑÐ»ÐµÐ´Ð½Ð°Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ, Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(387583,10767,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ù…Ø·Ù„ÙˆØ¨Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯ Ú©Û’ Ù„Ø¦Û’ ÛŒÛ Ø§Ù…Ú©Ø§Ù† ØºØ§Ø¦Ø¨ ÛÛ’',0),(387584,10767,'sr','Ð¢Ð° Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð° Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ñƒ ÑÐ»ÐµÐ´ÐµÑ›Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ',0),(387585,10767,'vi','Sá»± trÃ´ng mong Ä‘ang thiáº¿u cÃ¡c thÃ´ng tin Ä‘Æ°á»£c Ä‘Ã²i há»i Ä‘á»ƒ sÃ n lá»c',0),(387586,10767,'af','By Hierdie Voornemende KliÃ«nt is die Volgende Inligting Vermis wat Benodig word vir Keuring',0),(387587,10767,'ro','AceastÄƒ perspectivÄƒ este lipsesc urmÄƒtoarele informaÅ£ii necesare pentru screening-ul',0),(387588,10767,'et','See vÃµimalus puudub, jÃ¤rgmise teabe nÃµutava sÃµeluuringuid',0),(387589,10767,'si','Ta moÅ¾nost je odsoten, naslednje informacije, zahtevane za pregled',0),(387590,10767,'ba','Prospek ini hilang informasi berikut diperlukan untuk skrining',0),(387591,10767,'nl','Dit perspectief ontbreekt de volgende informatie vereist voor Screening',0),(387592,10767,'fi','TÃ¤mÃ¤ mahdollisuus puuttuu seuraavat pyydetyt seulonta',0),(387593,10767,'no','Dette prospektet mangler den fÃ¸lgende informasjonen som kreves for Screening',0),(387594,10767,'da','Dette perspektiv mangler fÃ¸lgende oplysninger krÃ¦ves til Screening',0),(387595,10767,'ko','ì´ ì „ë§ ì‹¬ì‚¬ì— ëŒ€ í•œ ë‹¤ìŒ ì •ë³´ê°€ í•„ìš”í•œ ëˆ„ë½',0),(387596,10767,'he','×¤×¨×•×¡×¤×§×˜ ×–×” ×—×¡×¨ ××ª ×”×‘××™× ×”×¤×¨×˜×™× ×”×“×¨×•×©×™× ×œ×”×§×¨× ×”',0),(387597,10767,'el','Î‘Ï…Ï„Î® Î· Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ® Î»ÎµÎ¯Ï€ÎµÎ¹ Ï„Î¿ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Ï„Î· Î´Î¹Î±Î»Î¿Î³Î®',0),(387598,10767,'zh','è¿™ä¸€å‰æ™¯ç¼ºå°‘ç­›é€‰æ‰€éœ€çš„ä»¥ä¸‹ä¿¡æ¯\r\n',0),(387599,10767,'sv','Detta perspektiv saknas i fÃ¶ljande Information som krÃ¤vs fÃ¶r Screening',0),(387600,10767,'it','Questa prospettiva Ã¨ mancante le seguenti informazioni necessarie per lo Screening',0),(387601,10767,'tl','',0),(387602,10767,'th','à¸‚à¸²à¸”à¹‚à¸­à¸à¸²à¸ªà¸™à¸µà¹‰à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ˆà¸³à¹€à¸›à¹‡à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸„à¸±à¸”à¸à¸£à¸­à¸‡',0),(387603,10767,'hi','à¤‡à¤¸ à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤†à¤µà¤¶à¥à¤¯à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤— à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§ à¤¹à¥ˆ',0),(387604,10767,'ms','Prospek ini kehilangan maklumat yang berikut diperlukan bagi pemeriksaan',0),(387605,10767,'ar','ÙˆÙ‡Ø°Ø§ Ø§Ù„Ø§Ø­ØªÙ…Ø§Ù„ ÙŠÙØªÙ‚Ø¯ \"Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ§Ù„ÙŠØ© Ù…Ø·Ù„ÙˆØ¨Ø©\" Ù„Ù„ÙØ­Øµ',0),(387606,10767,'fr','Cette perspective est manquant, la suivante Information nÃ©cessaire pour le dÃ©pistage',0),(387607,10767,'jp','ã“ã®è¦‹é€šã—ã¯ã‚¹ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°ã®ãŸã‚å¿…è¦ãªæ¬¡ã®æƒ…å ±ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(387608,10767,'pt','Esta perspectiva estÃ¡ faltando as seguintes informaÃ§Ãµes necessÃ¡rias para a seleÃ§Ã£o',0),(387609,10767,'ru','Ð­Ñ‚Ð° Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð° Ð½Ðµ Ñ…Ð²Ð°Ñ‚Ð°ÐµÑ‚ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ¹ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸, Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾Ð¹ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(387610,10767,'es','Este Client Potencial se Falta la Siguiente InformaciÃ³n Requerida para investigaciÃ³n de Antecedentes',0),(387611,10767,'de','Diese Perspektive fehlt die folgenden Informationen erforderlich fÃ¼r Screening',0),(387612,10767,'en','This Prospect is Missing the Following Information Required for Screening',0),(387613,10768,'is','',0),(387614,10768,'dr','(ØºØ±Ø¨Ø§Ù„ Ú¯Ø±ÙŠ',0),(387615,10768,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¢Ø²Ù…Ø§ÙŠØ´(ØºØ±Ø¨Ø§Ù„ Ú¯Ø±ÙŠ',0),(387616,10768,'tr','GÃ¼ncelleÅŸtirme Tarama',0),(387617,10768,'pl','Aktualizacja przeglÄ…du',0),(387618,10768,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐºÑ€Ð¸Ð½Ð¸Ð½Ð³',0),(387619,10768,'ur','Ø§Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(387620,10768,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(387621,10768,'vi','Táº£i cÃ³ sÃ ng lá»c',0),(387622,10768,'af','Opdateer Keuring',0),(387623,10768,'ro','Actualizare de Screening',0),(387624,10768,'et','Update sÃµelumine',0),(387625,10768,'si','Update pregleda',0),(387626,10768,'ba','Memperbarui skrining',0),(387627,10768,'nl','Update Screening',0),(387628,10768,'fi','PÃ¤ivitÃ¤ seulonta',0),(387629,10768,'no','Oppdatere Screening',0),(387630,10768,'da','Opdatere Screening',0),(387631,10768,'ko','ì—…ë°ì´íŠ¸ ê²€ì‚¬',0),(387632,10768,'he','×¢×“×›×•×Ÿ ×”×”×§×¨× ×”',0),(387633,10768,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(387634,10768,'zh','æ›´æ–°ç­›é€‰\r\n',0),(387635,10768,'sv','Uppdatera Screening',0),(387636,10768,'it','Aggiornamento Screening',0),(387637,10768,'tl','',0),(387638,10768,'th','à¸„à¸±à¸”à¸à¸£à¸­à¸‡à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(387639,10768,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤—',0),(387640,10768,'ms','Kemaskini Terakhir pemeriksaan',0),(387641,10768,'ar','ÙØ­Øµ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(387642,10768,'fr','Mise Ã  jour prÃ©alable',0),(387643,10768,'jp','æ›´æ–°å¯©æŸ»',0),(387644,10768,'pt','Rastreio de atualizaÃ§Ã£o',0),(387645,10768,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐºÑ€Ð¸Ð½Ð¸Ð½Ð³',0),(387646,10768,'es','Actualizar InvestigaciÃ³n de Antecedentes',0),(387647,10768,'de','Update-Screening',0),(387648,10768,'en','Update Screening',0),(387649,10769,'is','',0),(387650,10769,'dr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø·Ø§',0),(387651,10769,'pr','Ù†Ù…Ø§ÙŠØ´ Ø®Ø·Ø§',0),(387652,10769,'tr','GÃ¶rÃ¼nÃ¼m hatasÄ±',0),(387653,10769,'pl','Widok bÅ‚Ä™dÃ³w',0),(387654,10769,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð³Ñ€ÐµÑˆÐºÐ°',0),(387655,10769,'ur','Ù…Ù†Ø¸Ø± Ù†Ù‚Øµ',0),(387656,10769,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð³Ñ€ÐµÑˆÐºÐµ',0),(387657,10769,'vi','Xem lá»—i',0),(387658,10769,'af','Besigtig Fout',0),(387659,10769,'ro','Vezi eroare',0),(387660,10769,'et','Kuva tÃµrge',0),(387661,10769,'si','Zmota pogled',0),(387662,10769,'ba','Lihat kesalahan',0),(387663,10769,'nl','Weergave fout',0),(387664,10769,'fi','NÃ¤yttÃ¤Ã¤ virhe',0),(387665,10769,'no','Vis feil',0),(387666,10769,'da','Se fejl',0),(387667,10769,'ko','ë³´ê¸° ì˜¤ë¥˜',0),(387668,10769,'he','×©×’×™××ª ×ª×¦×•×’×”',0),(387669,10769,'el','Î ÏÎ¿Î²Î¿Î»Î® ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚',0),(387670,10769,'zh','æŸ¥çœ‹é”™è¯¯\r\n',0),(387671,10769,'sv','Visa Error',0),(387672,10769,'it','Errore di visualizzazione',0),(387673,10769,'tl','',0),(387674,10769,'th','à¸”à¸¹à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(387675,10769,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(387676,10769,'ms','Lihat ralat',0),(387677,10769,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¹Ø±Ø¶',0),(387678,10769,'fr','Erreur d\'affichage',0),(387679,10769,'jp','ãƒ“ãƒ¥ãƒ¼ã®ã‚¨ãƒ©ãƒ¼',0),(387680,10769,'pt','Vista erro',0),(387681,10769,'ru','Ð¡Ð¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÐžÑˆÐ¸Ð±ÐºÑƒ',0),(387682,10769,'es','Vistar Error',0),(387683,10769,'de','Ansicht-Fehler',0),(387684,10769,'en','View Error',0),(387685,10770,'is','',0),(387686,10770,'dr','(ØºØ±Ø¨Ø§Ù„ Ú¯Ø±ÙŠ',0),(387687,10770,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¢Ø²Ù…Ø§ÙŠØ´(ØºØ±Ø¨Ø§Ù„ Ú¯Ø±ÙŠ',0),(387688,10770,'tr','GÃ¶rÃ¼nÃ¼m tarama',0),(387689,10770,'pl','Zobacz pokaz',0),(387690,10770,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÑÐºÑ€Ð¸Ð½Ð¸Ð½Ð³',0),(387691,10770,'ur','Ù…Ù†Ø¸Ø± Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯',0),(387692,10770,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(387693,10770,'vi','Xem mÃ n hÃ¬nh',0),(387694,10770,'af','Besigtig Keuring',0),(387695,10770,'ro','Vezi Screening',0),(387696,10770,'et','Kuva lÃ¤bivaatus',0),(387697,10770,'si','Pogled presejalni',0),(387698,10770,'ba','Lihat penyaringan',0),(387699,10770,'nl','Weergave Screening',0),(387700,10770,'fi','Katso seulonta',0),(387701,10770,'no','Vis Screening',0),(387702,10770,'da','Se Screening',0),(387703,10770,'ko','ë³´ê¸° ì‹¬ì‚¬',0),(387704,10770,'he','×ª×¦×•×’×ª ×”×”×§×¨× ×”',0),(387705,10770,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€ÏÎ¿Î²Î¿Î»Î®',0),(387706,10770,'zh','æŸ¥çœ‹ç­›é€‰\r\n',0),(387707,10770,'sv','Visa Screening',0),(387708,10770,'it','Screening della vista',0),(387709,10770,'tl','',0),(387710,10770,'th','à¸•à¸£à¸§à¸ˆà¸”à¸¹',0),(387711,10770,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤—',0),(387712,10770,'ms','Pemeriksaan paparan',0),(387713,10770,'ar','ÙØ±Ø² Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¹Ø±Ø¶',0),(387714,10770,'fr','DÃ©pistage de la vue',0),(387715,10770,'jp','ãƒ“ãƒ¥ãƒ¼ã®ã‚¹ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°',0),(387716,10770,'pt','Rastreio de visÃ£o',0),(387717,10770,'ru','Ð’Ð¸Ð´ ÑÐºÑ€Ð¸Ð½Ð¸Ð½Ð³Ð°',0),(387718,10770,'es','Vistar InspecciÃ³n de Antecedentes',0),(387719,10770,'de','Ansicht-Screening',0),(387720,10770,'en','View Screening',0),(387721,10771,'is','',0),(387722,10771,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(387723,10771,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(387724,10771,'tr','Kira oluÅŸturun',0),(387725,10771,'pl','Tworzenie dzierÅ¼awy',0),(387726,10771,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(387727,10771,'ur','Ù„ÛŒØ² Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(387728,10771,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð·Ð°ÐºÑƒÐ¿',0),(387729,10771,'vi','Táº¡o cho thuÃª',0),(387730,10771,'af','Skep Huurkontrakte',0),(387731,10771,'ro','Crea leasing',0),(387732,10771,'et','Loo rendi',0),(387733,10771,'si','Ustvarjanje najema',0),(387734,10771,'ba','Membuat sewa',0),(387735,10771,'nl','Maken van Lease',0),(387736,10771,'fi','Luo vuokrasopimuksen',0),(387737,10771,'no','Opprette Lease',0),(387738,10771,'da','Oprette Lease',0),(387739,10771,'ko','ìž„ëŒ€ë¥¼ ë§Œë“¤ê¸°',0),(387740,10771,'he','×œ×™×¦×•×¨ ×—×•×–×” ×©×›×™×¨×•×ª',0),(387741,10771,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(387742,10771,'zh','åˆ›å»ºç§Ÿèµ\r\n',0),(387743,10771,'sv','Skapa Lease',0),(387744,10771,'it','Creare il contratto di locazione',0),(387745,10771,'tl','',0),(387746,10771,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²',0),(387747,10771,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(387748,10771,'ms','Membuat pajakan',0),(387749,10771,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(387750,10771,'fr','CrÃ©er le bail',0),(387751,10771,'jp','ãƒªãƒ¼ã‚¹ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(387752,10771,'pt','Criar locaÃ§Ã£o',0),(387753,10771,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(387754,10771,'es','Crear Arrendimiento',0),(387755,10771,'de','Lease erstellen',0),(387756,10771,'en','Create Lease',0),(387757,10772,'is','',0),(387758,10772,'dr','Ù†ØµÙ Ø§Ø±ØªÙØ§Ø¹ Ø¨Ù‡  Ù‡ÙØª  ÙƒØ§Ù„Ø§ Ù…Ø­Ø¯ÙˆØ¯ Ù…ÙŠ Ø´ÙˆØ¯ â€“ Ø¯ÙŠÚ¯Ø± Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ Ø±Ø§ Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ù…ÙŠ Ú¯ÙŠØ±Ø¯ ',0),(387759,10772,'pr','Ù†ØµÙ Ø§Ø±ØªÙØ§Ø¹ Ø¨Ù‡  Ù‡ÙØª  ÙƒØ§Ù„Ø§ Ù…Ø­Ø¯ÙˆØ¯ Ù…ÙŠ Ø´ÙˆØ¯ â€“ Ø¯ÙŠÚ¯Ø± Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ Ø±Ø§ Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ù…ÙŠ Ú¯ÙŠØ±Ø¯ ',0),(387760,10772,'tr','7 yarÄ±m boy sÄ±nÄ±rÄ± Ã¶ÄŸeleri - diÄŸer biÃ§imlendirme seÃ§eneklerini yoksayar',0),(387761,10772,'pl','PoÅ‚owie wysokoÅ›ci ograniczyÄ‡ 7 elementÃ³w - ignoruje inne opcje formatu',0),(387762,10772,'bg','ÐŸÐ¾Ð»Ð¾Ð²Ð¸Ð½ Ð²Ð¸ÑÐ¾Ñ‡Ð¸Ð½Ð° Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡Ð¸ 7 ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ - Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð° Ð´Ñ€ÑƒÐ³Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸ Ð·Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(387763,10772,'ur','Ø¢Ø¯Ú¾ÛŒ Ø§ÙˆÙ†Ú†Ø§Ø¦ÛŒ ØªÚ© Ù…Ø­Ø¯ÙˆØ¯ 7 Ø§Ø´ÛŒØ§Ø¡ - Ø¯ÛŒÚ¯Ø± ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ù†Ø¸Ø±Ø§Ù†Ø¯Ø§Ø² Ú©Ø±ØªØ§ ÛÛ’',0),(387764,10772,'sr','ÐŸÐ¾Ð»Ð° Ð²Ð¸ÑÐ¸Ð½Ðµ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡Ð¸Ñ‚Ðµ 7 ÑÑ‚Ð°Ð²ÐºÐ¸ - Ð·Ð°Ð½ÐµÐ¼Ð°Ñ€ÑƒÑ˜Ðµ Ð´Ñ€ÑƒÐ³Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¾Ð±Ð»Ð¸ÐºÐ¾Ð²Ð°ÑšÐµ',0),(387765,10772,'vi','giá»›i háº¡n má»™t ná»­a chiá»u cao cá»§a 7 má»¥c- bá» Ä‘i cÃ¡c lá»±a chá»n khÃ¡c',0),(387766,10772,'af','Halwe hoogte beperk 7 Items - ignoreer ander formaat opsies',0),(387767,10772,'ro','JumÄƒtate Ã®nÄƒlÅ£imea limitÄƒ 7 elemente - ignorÄƒ alte opÅ£iuni de Format',0),(387768,10772,'et','Pool kÃµrgust piirata 7 kirjed - ignoreerib muud vormingusuvandid',0),(387769,10772,'si','Polovici viÅ¡ine omejitev 7 predmetov - zanemarja druge oblikovne moÅ¾nosti',0),(387770,10772,'ba','Half Height membatasi 7 item - mengabaikan pilihan Format lain',0),(387771,10772,'nl','Halfhoog beperken 7 Items - negeert andere opmaakopties',0),(387772,10772,'fi','Puoli korkeus rajoittaa 7 tuotteet - ohittaa muut muotoiluasetukset',0),(387773,10772,'no','HalvhÃ¸ydes begrense 7 elementer - ignorerer andre formateringsalternativer',0),(387774,10772,'da','Halv hÃ¸jde begrÃ¦nse 7 elementer - ignorerer andre formatindstillinger',0),(387775,10772,'ko','ì ˆë°˜ ë†’ì´ ì œí•œ 7 í•­ëª©-ë‹¤ë¥¸ ì„œì‹ ì˜µì…˜ ë¬´ì‹œ',0),(387776,10772,'he','×‘×—×¦×™ ×’×•×‘×” ×œ×”×’×‘×™×œ 7 ×¤×¨×™×˜×™× - ×ž×ª×¢×œ× ××¤×©×¨×•×™×•×ª ×ª×‘× ×™×ª × ×•×¡×¤×•×ª',0),(387777,10772,'el','ÎœÎ¹ÏƒÏŒ ÏÏˆÎ¿Ï‚ ÏŒÏÎ¹Î¿ 7 ÎšÎ±Ï„Î±ÏƒÏ„Î®Î¼Î±Ï„Î± ÎÏ…Ï†Î¹ÎºÏŽÎ½ - Î±Î³Î½Î¿ÎµÎ¯ Î¬Î»Î»ÎµÏ‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î¼Î¿ÏÏ†Î®',0),(387778,10772,'zh','åŠé«˜é™åˆ¶7ä¸ªé¡¹ç›®-å¿½ç•¥äº†å…¶ä»–æ ¼å¼é€‰é¡¹\r\n',0),(387779,10772,'sv','Halva hÃ¶jden begrÃ¤nsa 7 objekt - ignorerar andra formateringsalternativ',0),(387780,10772,'it','Mezza altezza limite 7 articoli - ignora altre opzioni di formato',0),(387781,10772,'tl','',0),(387782,10772,'th','à¸„à¸§à¸²à¸¡à¸ªà¸¹à¸‡à¸„à¸£à¸¶à¹ˆà¸‡à¸ˆà¸³à¸à¸±à¸” 7 à¸£à¸²à¸¢à¸à¸²à¸£ - à¸¥à¸°à¹€à¸§à¹‰à¸™à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸£à¸¹à¸›à¹à¸šà¸šà¸­à¸·à¹ˆà¸™ à¹†',0),(387783,10772,'hi','à¤†à¤§à¥€ à¤Šà¤‚à¤šà¤¾à¤ˆ à¤¸à¥€à¤®à¤¾ 7 à¤†à¤‡à¤Ÿà¤® - à¤…à¤¨à¥à¤¯ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤µà¤¿à¤•à¤²à¥à¤ªà¥‹à¤‚ à¤ªà¤° à¤§à¥à¤¯à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤¦à¥‡à¤¤à¤¾',0),(387784,10772,'ms','Separuh tinggi had 7 item - mengabaikan pilihan Format lain',0),(387785,10772,'ar','Ù†ØµÙ Ø§Ù„Ø§Ø±ØªÙØ§Ø¹ Ø§Ù„Ø­Ø¯ 7 Ø§Ù„Ø¨Ù†ÙˆØ¯--ØªØ¬Ø§Ù‡Ù„ Ø®ÙŠØ§Ø±Ø§Øª ØªÙ†Ø³ÙŠÙ‚ Ø£Ø®Ø±Ù‰',0),(387786,10772,'fr','Demi hauteur limite 7 points - ne tient pas compte des autres Options de Format',0),(387787,10772,'jp','åŠåˆ†ã®é«˜ã•åˆ¶é™ 7 é …ç›® - ãã®ä»–ã®å½¢å¼ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’ç„¡è¦–ã—ã¾ã™',0),(387788,10772,'pt','Metade da altura limite 7 itens - ignora outras opÃ§Ãµes de formato',0),(387789,10772,'ru','ÐŸÐ¾Ð»Ð¾Ð²Ð¸Ð½Ð° Ð²Ñ‹ÑÐ¾Ñ‚Ñ‹ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡Ð¸Ñ‚ÑŒ 7 Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð¾Ð² - Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€ÑƒÐµÑ‚ Ð´Ñ€ÑƒÐ³Ð¸Ðµ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð°',0),(387790,10772,'es','Limite de 7 Items de Altura Media - Se Ignora Otras Opciones de Formatos',0),(387791,10772,'de','Halbe HÃ¶he begrenzt 7 Elemente - ignoriert andere Formatoptionen',0),(387792,10772,'en','Half Height Limit 7 Items - Ignores Other Format Options',0),(387793,10773,'is','',0),(387794,10773,'dr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… Ø¯ÙØªØ± ÙƒÙ„ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù†Ø¨ÙˆØ¯ ',0),(387795,10773,'pr','Ø«Ø¨Øª Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÙŠÙ… Ø¯ÙØªØ± ÙƒÙ„ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ù†Ø¨ÙˆØ¯ ',0),(387796,10773,'tr','DoÄŸrudan GL Ã¶deme giriÅŸlerinin deyim Ã¼zerinde deÄŸil',0),(387797,10773,'pl','Wpisy pÅ‚atnoÅ›ci bezpoÅ›rednie GL nie na oÅ›wiadczenie',0),(387798,10773,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¾ Ð½Ð° Ð²Ð¿Ð¸ÑÐ²Ð°Ð½Ð¸ÑÑ‚Ð° GL Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(387799,10773,'ur','Ø¬ÛŒØ¬Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù†ÛÛŒÚº Ø¨ÛŒØ§Ù† Ù¾Ø± Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª',0),(387800,10773,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð½Ðµ Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(387801,10773,'vi','Ghi sá»• cÃ¡i thanh toÃ n khÃ´ng kÃ¨m báº£ng kÃª',0),(387802,10773,'af','Direkte AG Betalinginskrywings Nie op Staat',0),(387803,10773,'ro','PlatÄƒ directÄƒ GL intrÄƒri nu declaraÅ£ie',0),(387804,10773,'et','Otsene GL maksekannete ole teatisel',0),(387805,10773,'si','Neposredno GL plaÄilne postavke ne na izjavo',0),(387806,10773,'ba','Pembayaran langsung GL entri tidak pada pernyataan',0),(387807,10773,'nl','Directe GL betalingsposten niet over de verklaring van',0),(387808,10773,'fi','Suoraa GL maksu ei julkilausumasta',0),(387809,10773,'no','Direkte GL betalingspostene ikke pÃ¥ uttalelse',0),(387810,10773,'da','Direkte GL betalingsposter ikke pÃ¥ kontoudtog',0),(387811,10773,'ko','ê³„ì‚° ì„œì— ì§ì ‘ GL ì§€ë¶ˆ í•­ëª©',0),(387812,10773,'he','×”×–× ×•×ª ×ª×©×œ×•× ×™×©×™×¨ GL ×œ× ×¢×œ ×”×”×¦×”×¨×”',0),(387813,10773,'el','GL Î¬Î¼ÎµÏƒÎ· Ï€Î»Î·ÏÏ‰Î¼Î® ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î´ÎµÎ½ Ï„Î·Î½ Î´Î®Î»Ï‰ÏƒÎ·',0),(387814,10773,'zh','ç›´æŽ¥æ€»å¸ä»˜æ¬¾æ¡ç›®ä¸åœ¨è¯´æ˜Žä¸Š\r\n',0),(387815,10773,'sv','Direkt GL betalningsposter inte pÃ¥ uttalande',0),(387816,10773,'it','Voci di pagamento diretto GL non su istruzione',0),(387817,10773,'tl','',0),(387818,10773,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ GL à¹‚à¸”à¸¢à¸•à¸£à¸‡à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸‡à¸š',0),(387819,10773,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· GL à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¯à¤¾à¤¨ à¤ªà¤° à¤¨à¤¹à¥€à¤‚',0),(387820,10773,'ms','GL terus bayaran penyertaan tidak pada penyata',0),(387821,10773,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ø¯ÙØ¹ GL Ù…Ø¨Ø§Ø´Ø±Ø© Ù„Ø§ ÙÙŠ Ø§Ù„Ø¨ÙŠØ§Ù†',0),(387822,10773,'fr','EntrÃ©es de paiement direct GL pas sur la dÃ©claration',0),(387823,10773,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã§ã¯ãªã GL æ”¯æ‰•ã‚¨ãƒ³ãƒˆãƒªã‚’ç›´æŽ¥ã—ã¾ã™ã€‚',0),(387824,10773,'pt','Entradas de pagamento directo GL nÃ£o na instruÃ§Ã£o',0),(387825,10773,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ GL Ð½Ðµ Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(387826,10773,'es','Entradas de Pagos Directos de LM No EstÃ¡ en el Documento',0),(387827,10773,'de','Direkte GL Zahlungsposten nicht auf Anweisung',0),(387828,10773,'en','Direct GL Payment Entries Not On Statement',0),(387829,10774,'is','',0),(387830,10774,'dr','Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ Ù…Ø³ØªÙ‚ÙŠÙ… Ø¯ÙØªØ± ÙƒÙ„ ',0),(387831,10774,'pr','Ø±Ø³ÙŠØ¯Ù‡Ø§ÙŠ Ù…Ø³ØªÙ‚ÙŠÙ… Ø¯ÙØªØ± ÙƒÙ„ ',0),(387832,10774,'tr','DoÄŸrudan GL makbuzlarÄ±',0),(387833,10774,'pl','WpÅ‚ywy bezpoÅ›rednie GL',0),(387834,10774,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ GL Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ¸',0),(387835,10774,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬ÛŒØ¬Û’ Ø±Ø³ÛŒØ¯ÛŒÚº',0),(387836,10774,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ',0),(387837,10774,'vi','BiÃªn lai trá»±c tiáº¿p GL',0),(387838,10774,'af','Direkte GL kwitansies',0),(387839,10774,'ro','Veniturile directe GL',0),(387840,10774,'et','Otsene GL sissetulekute',0),(387841,10774,'si','Neposredno GL prejemki',0),(387842,10774,'ba','Penerimaan langsung GL',0),(387843,10774,'nl','Directe GL ontvangsten',0),(387844,10774,'fi','Suora GL vastaanotot',0),(387845,10774,'no','Direkte GL mottak',0),(387846,10774,'da','Direkte GL kvitteringer',0),(387847,10774,'ko','ì§ì ‘ GL ì˜ìˆ˜ì¦',0),(387848,10774,'he','GL ×™×©×™×¨×” ×§×‘×œ×•×ª',0),(387849,10774,'el','Î†Î¼ÎµÏƒÎ· GL Ï€Î±ÏÎ±Î»Î±Î²Î­Ï‚',0),(387850,10774,'zh','ç›´æŽ¥å‰å°”æ”¶æ®\r\n',0),(387851,10774,'sv','Direkt GL kvitton',0),(387852,10774,'it','Incassi diretti GL',0),(387853,10774,'tl','',0),(387854,10774,'th','GL à¹‚à¸”à¸¢à¸•à¸£à¸‡à¸£à¸±à¸š',0),(387855,10774,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· GL à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚',0),(387856,10774,'ms','GL terus resit',0),(387857,10774,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª GL Ù…Ø¨Ø§Ø´Ø±Ø©',0),(387858,10774,'fr','GL directs reÃ§us',0),(387859,10774,'jp','ç›´æŽ¥ GL é ˜åŽæ›¸',0),(387860,10774,'pt','Recibos GL direto',0),(387861,10774,'ru','ÐŸÐ¾ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ Ð¿Ñ€ÑÐ¼Ñ‹Ñ… GL',0),(387862,10774,'es','Recibos Directos de LM',0),(387863,10774,'de','Direkte GL Quittungen',0),(387864,10774,'en','Direct GL Receipts',0),(387865,10775,'is','',0),(387866,10775,'dr',' Ø¨Ø¯Ù‡ÙŠ',0),(387867,10775,'pr',' Ø¨Ø¯Ù‡ÙŠ',0),(387868,10775,'tr','BorÃ§',0),(387869,10775,'pl','DÅ‚ug',0),(387870,10775,'bg','Ð”ÑŠÐ»Ð³',0),(387871,10775,'ur','Ù‚Ø±Ø¶',0),(387872,10775,'sr','Ð”ÑƒÐ³Ð°',0),(387873,10775,'vi','Ná»£',0),(387874,10775,'af','Skuld',0),(387875,10775,'ro','Datoriei',0),(387876,10775,'et','VÃµla',0),(387877,10775,'si','Dolga',0),(387878,10775,'ba','Utang',0),(387879,10775,'nl','Schuld',0),(387880,10775,'fi','Velka',0),(387881,10775,'no','Gjeld',0),(387882,10775,'da','GÃ¦ld',0),(387883,10775,'ko','ë¶€ì±„',0),(387884,10775,'he','×”×—×•×‘',0),(387885,10775,'el','Î§ÏÎ­Î¿Ï‚',0),(387886,10775,'zh','å€ºåŠ¡\r\n',0),(387887,10775,'sv','Skuld',0),(387888,10775,'it','Debito',0),(387889,10775,'tl','',0),(387890,10775,'th','à¸«à¸™à¸µà¹‰',0),(387891,10775,'hi','à¤‹à¤£',0),(387892,10775,'ms','Hutang',0),(387893,10775,'ar','Ø§Ù„Ø¯ÙŠÙˆÙ†',0),(387894,10775,'fr','Dette',0),(387895,10775,'jp','å‚µå‹™',0),(387896,10775,'pt','DÃ­vida',0),(387897,10775,'ru','Ð”Ð¾Ð»Ð³',0),(387898,10775,'es','Deuda',0),(387899,10775,'de','Schulden',0),(387900,10775,'en','Debt',0),(387901,10776,'is','',0),(387902,10776,'dr','.',0),(387903,10776,'pr','Ø¢Ø¯Ø±Ø³ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÙŠ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ÙƒÙ†ÙˆÙ†ÙŠ ÙƒØ§Ø±Øª Ø¯Ø±Ù†Ø¸Ø± Ú¯Ø±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª.',0),(387904,10776,'tr','Fatura adresi kartÄ± mevcut iÅŸlemlerinde yoksayÄ±lÄ±r',0),(387905,10776,'pl','Adres fakturowania jest ignorowana dla obecnych Transakcje kartÄ…',0),(387906,10776,'bg','ÐÐ´Ñ€ÐµÑ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ ÑÐµ Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð° Ð·Ð° Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ñ ÐºÐ°Ñ€Ñ‚Ð¸',0),(387907,10776,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù¾ØªØ§ Ú©Ø§Ø±Úˆ Ù…ÙˆØ¬ÙˆØ¯ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ù†Ø¸Ø±Ø§Ù†Ø¯Ø§Ø² Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(387908,10776,'sr','ÐÐ´Ñ€ÐµÑÐ° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ ÑÐµ Ð·Ð°Ð½ÐµÐ¼Ð°Ñ€ÑƒÑ˜Ðµ Ð·Ð° Ð¿Ð¾ÐºÐ»Ð¾Ð½ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(387909,10776,'vi','Äá»‹a chá»‰ HÃ³a  Ä‘Æ¡n ÄÆ°á»£c bá» qua Äá»‘i vá»›i cÃ¡c giao dá»‹ch tháº» hiá»‡n táº¡i',0),(387910,10776,'af','Verekeningsadres Word Ignoreer vir Huidige Kaart Transaksies',0),(387911,10776,'ro','Adresa de facturare este ignorat pentru tranzacÅ£iile prezente',0),(387912,10776,'et','Arved aadress eiratakse kohal kaarditehingute',0),(387913,10776,'si','Naslov je prezrto za kartico prisotna transakcije',0),(387914,10776,'ba','Alamat penagihan diabaikan untuk hadir kartu transaksi',0),(387915,10776,'nl','Factuuradres wordt genegeerd voor huidige kaarttransacties',0),(387916,10776,'fi','Laskutusosoite vaikuta lÃ¤snÃ¤ liiketoimet',0),(387917,10776,'no','Faktureringsadresse ignoreres For nÃ¥vÃ¦rende transaksjoner',0),(387918,10776,'da','Faktureringsadresse ignoreres For nuvÃ¦rende transaktioner',0),(387919,10776,'ko','ì¹´ë“œ ì„ ë¬¼ ê±°ëž˜ì— ëŒ€ í•œ ê²°ì œ ì£¼ì†ŒëŠ” ë¬´ì‹œ ë©ë‹ˆë‹¤.',0),(387920,10776,'he','×›×ª×•×‘×ª ×œ×—×™×•×‘ ×ž×ª×¢×œ×ž×ª ×œ×¢×¡×§××•×ª × ×•×›×— ×›×¨×˜×™×¡',0),(387921,10776,'el','Î§Î¡Î•Î©Î£Î—Î£ Î±Î³Î½Î¿ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ Ï€Î±ÏÎ¿ÏÏƒÎ± ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ ÎºÎ±ÏÏ„ÏŽÎ½',0),(387922,10776,'zh','å¸å•åœ°å€è¢«å¿½ç•¥å› ä¸ºå¡æ­£åœ¨äº¤æ˜“\r\n',0),(387923,10776,'sv','Faktureringsadress ignoreras fÃ¶r nÃ¤rvarande korttransaktioner',0),(387924,10776,'it','Indirizzo di fatturazione viene ignorato per le transazioni con carta presente',0),(387925,10776,'tl','',0),(387926,10776,'th','à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸ˆà¸°à¸–à¸¹à¸à¸¥à¸°à¹€à¸§à¹‰à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¸šà¸±à¸•à¸£',0),(387927,10776,'hi','à¤¬à¤¿à¤² à¤¸à¤®à¥à¤¬à¤‚à¤§à¥€ à¤ªà¤¤à¤¾ à¤•à¤¾à¤°à¥à¤¡ à¤‰à¤ªà¤¸à¥à¤¥à¤¿à¤¤ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤œà¤°à¤…à¤‚à¤¦à¤¾à¤œ à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤¹à¥ˆ',0),(387928,10776,'ms','Alamat bil diabaikan bagi transaksi Kad yang hadir',0),(387929,10776,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„ÙÙˆØªØ±Ø© Ù‡Ùˆ ØªØ¬Ø§Ù‡Ù„ Ù„Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ù„Ø­Ø§Ù„ÙŠØ© Ø¨Ø·Ø§Ù‚Ø©',0),(387930,10776,'fr','Adresse de facturation est ignorÃ© pour les prÃ©sentes Transactions carte',0),(387931,10776,'jp','è«‹æ±‚å…ˆä½æ‰€ã¯ã‚«ãƒ¼ãƒ‰ã®ç¾åœ¨ã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã¯ç„¡è¦–ã•ã‚Œã¾ã™ã€‚',0),(387932,10776,'pt','EndereÃ§o de facturaÃ§Ã£o Ã© ignorado para transaÃ§Ãµes com cartÃ£o de presente',0),(387933,10776,'ru','ÐÐ´Ñ€ÐµÑ Ð´Ð»Ñ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð° Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ Ð½Ñ‹Ð½ÐµÑˆÐ½ÐµÐ¹ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ ÐºÐ°Ñ€Ñ‚Ð°Ð¼',0),(387934,10776,'es','DirecciÃ³n de FacturaciÃ³n se Ignora Para Transacciones Actuales de Tarjeta',0),(387935,10776,'de','Rechnungsadresse ist fÃ¼r vorhanden Kartentransaktionen ignoriert.',0),(387936,10776,'en','Billing Address Is Ignored For Card Present Transactions',0),(387937,10777,'is','',0),(387938,10777,'dr','ØªØ§Ø±ÙŠØ® ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(387939,10777,'pr','ØªØ§Ø±ÙŠØ® ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(387940,10777,'tr','Tarihi doÄŸruladÄ±',0),(387941,10777,'pl','Data potwierdzenia',0),(387942,10777,'bg','Ð”Ð°Ñ‚Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´Ð¸',0),(387943,10777,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø³ Ø¨Ø§Øª Ú©ÛŒ ØªØµØ¯ÛŒÙ‚',0),(387944,10777,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ð¾',0),(387945,10777,'vi','NgÃ y Ä‘Æ°á»£c xÃ¡c nháº­n',0),(387946,10777,'af','Datum Bevestig',0),(387947,10777,'ro','Data confirmat',0),(387948,10777,'et','KuupÃ¤eva kinnitas',0),(387949,10777,'si','Datum potrdila',0),(387950,10777,'ba','Tanggal dikonfirmasi',0),(387951,10777,'nl','Bevestigde de datum',0),(387952,10777,'fi','Varmistettu pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(387953,10777,'no','Datoen bekreftet',0),(387954,10777,'da','Dato bekrÃ¦ftet',0),(387955,10777,'ko','ë‚ ì§œ í™•ì¸',0),(387956,10777,'he','×ª××¨×™×š ××™×©×•×¨',0),(387957,10777,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎµ',0),(387958,10777,'zh','ç¡®è®¤æ—¥æœŸ\r\n',0),(387959,10777,'sv','Datum bekrÃ¤ftas',0),(387960,10777,'it','Data confermata',0),(387961,10777,'tl','',0),(387962,10777,'th','à¸§à¸±à¸™à¹„à¸”à¹‰à¸£à¸±à¸šà¸à¸²à¸£à¸¢à¸·à¸™à¸¢à¸±à¸™',0),(387963,10777,'hi','à¤¤à¤¿à¤¥à¤¿ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¥€',0),(387964,10777,'ms','Tarikh disahkan',0),(387965,10777,'ar','ØªØ§Ø±ÙŠØ® ØªØ£ÙƒÙŠØ¯',0),(387966,10777,'fr','Date confirmÃ©e',0),(387967,10777,'jp','æ—¥ã‚’ç¢ºèª',0),(387968,10777,'pt','Data confirmada',0),(387969,10777,'ru','Ð”Ð°Ñ‚Ð° ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð°',0),(387970,10777,'es','Fecha Confirmada',0),(387971,10777,'de','Datum bestÃ¤tigt',0),(387972,10777,'en','Date Confirmed',0),(387973,10778,'is','',0),(387974,10778,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ø± Ù…Ø¹ÙˆÙ‚',0),(387975,10778,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ÙƒØ§Ø± Ù…Ø¹ÙˆÙ‚',0),(387976,10778,'tr','Bekleyen iÅŸ detay',0),(387977,10778,'pl','Czasu pracy',0),(387978,10778,'bg','Ð Ð°Ð±Ð¾Ñ‚ÑÑ‚ Ñ Ð´ÐµÑ‚Ð°Ð¹Ð»',0),(387979,10778,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Ø§Ù… Ú©ÛŒ ØªÙØµÛŒÙ„',0),(387980,10778,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ñ€Ð°Ð´Ð½Ðµ Ð¾Ð±Ð²ÐµÐ·Ðµ',0),(387981,10778,'vi','chÆ°a lÃ m chi tiáº¿t cÃ´ng viá»‡c',0),(387982,10778,'af','Hangende werk Detail',0),(387983,10778,'ro','Detaliu de lucru Ã®n aÅŸteptare',0),(387984,10778,'et','Ootel tÃ¶Ã¶ Detail',0),(387985,10778,'si','Delo v ÄakajoÄa podrobnosti',0),(387986,10778,'ba','Tertunda kerja rinci',0),(387987,10778,'nl','In behandeling werk Detail',0),(387988,10778,'fi','Kesken tyÃ¶n yksityiskohtia',0),(387989,10778,'no','Ventende arbeid detaljer',0),(387990,10778,'da','Ventende arbejde detaljer',0),(387991,10778,'ko','ë³´ë¥˜ ì¤‘ì¸ ìž‘ì—… ì„¸ë¶€ ì‚¬í•­',0),(387992,10778,'he','×¤×™×¨×•×˜ ×”×¢×‘×•×“×” ×ž×ž×ª×™× ×”',0),(387993,10778,'el','Î•ÎºÎºÏÎµÎ¼Î®Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(387994,10778,'zh','å¾…åŠžå·¥ä½œç»†èŠ‚\r\n',0),(387995,10778,'sv','PÃ¥gÃ¥ende arbete i detalj',0),(387996,10778,'it','Dettaglio di lavoro in sospeso',0),(387997,10778,'tl','',0),(387998,10778,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸‡à¸²à¸™à¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(387999,10778,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤•à¤¾à¤® à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(388000,10778,'ms','Butiran kerja yang belum selesai',0),(388001,10778,'ar','ØªÙØ§ØµÙŠÙ„ Ø£Ø¹Ù…Ø§Ù„ Ù…Ø¹Ù„Ù‚Ø©',0),(388002,10778,'fr','DÃ©tail des travaux en attente',0),(388003,10778,'jp','ä¿ç•™ä¸­ã®ä½œæ¥­ã®è©³ç´°',0),(388004,10778,'pt','Detalhe de trabalho pendente',0),(388005,10778,'ru','ÐžÐ¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ñ… Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(388006,10778,'es','Grupo de Trabajo Pendiente',0),(388007,10778,'de','Ausstehende Detail',0),(388008,10778,'en','Pending Work Detail',0),(388009,10779,'is','',0),(388010,10779,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø³ÙŠØ³ØªÙ… ',0),(388011,10779,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ù†Ø¯ Ø³ÙŠØ³ØªÙ… ',0),(388012,10779,'tr','Sistem belge ekleme',0),(388013,10779,'pl','Dodawanie dokumentu System',0),(388014,10779,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ ÑÐ¸ÑÑ‚ÐµÐ¼Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(388015,10779,'ur','Ù†Ø¸Ø§Ù… Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(388016,10779,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼',0),(388017,10779,'vi','ThÃªm tÃ i liá»‡u há»‡ thá»‘ng',0),(388018,10779,'af','Voeg stelsel dokument',0),(388019,10779,'ro','Adauga sistem de Document',0),(388020,10779,'et','Lisa sÃ¼steemi dokument',0),(388021,10779,'si','Dodaj dokument sistem',0),(388022,10779,'ba','Tambahkan dokumen sistem',0),(388023,10779,'nl','Systeem Document toevoegen',0),(388024,10779,'fi','LisÃ¤Ã¤ jÃ¤rjestelmÃ¤n tiedosto',0),(388025,10779,'no','Legge til System-dokumentet',0),(388026,10779,'da','TilfÃ¸je System-dokument',0),(388027,10779,'ko','ì‹œìŠ¤í…œ ë¬¸ì„œ ì¶”ê°€',0),(388028,10779,'he','×”×•×¡×£ ×ž×¡×ž×š System',0),(388029,10779,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÏƒÏÏƒÏ„Î·Î¼Î± Î­Î³Î³ÏÎ±Ï†Î¿',0),(388030,10779,'zh','å¢žåŠ ç³»ç»Ÿæ–‡ä»¶\r\n',0),(388031,10779,'sv','LÃ¤gg till System-dokument',0),(388032,10779,'it','Aggiungi documento sistema',0),(388033,10779,'tl','',0),(388034,10779,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸°à¸šà¸šà¹€à¸­à¸à¸ªà¸²à¸£',0),(388035,10779,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(388036,10779,'ms','Tambah dokumen sistem',0),(388037,10779,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø³ØªÙ†Ø¯ Ù†Ø¸Ø§Ù…',0),(388038,10779,'fr','Ajouter Document System',0),(388039,10779,'jp','ã‚·ã‚¹ãƒ†ãƒ ã®ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(388040,10779,'pt','Adicionar documento do sistema',0),(388041,10779,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹',0),(388042,10779,'es','Agregar Documento del Sistema',0),(388043,10779,'de','Systemdokument hinzufÃ¼gen',0),(388044,10779,'en','Add System Document',0),(388045,10780,'is','',0),(388046,10780,'dr','ØªØ§Ù…ÙŠÙ† Ù…Ø§Ù„ÙŠ',0),(388047,10780,'pr','ØªØ§Ù…ÙŠÙ† Ù…Ø§Ù„ÙŠ',0),(388048,10780,'tr','Finansman',0),(388049,10780,'pl','Finansowanie',0),(388050,10780,'bg','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€Ð°Ð½Ðµ',0),(388051,10780,'ur','Ù…Ø§Ù„ÛŒ Ù…Ø¹Ø§ÙˆÙ†Øª',0),(388052,10780,'sr','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€Ð°ÑšÐµ',0),(388053,10780,'vi','TÃ i chÃ­nh',0),(388054,10780,'af','Finansiering',0),(388055,10780,'ro','FinanÅ£area',0),(388056,10780,'et','Rahastamine',0),(388057,10780,'si','Financiranje',0),(388058,10780,'ba','Pembiayaan',0),(388059,10780,'nl','Financiering',0),(388060,10780,'fi','Rahoitus',0),(388061,10780,'no','Finansiering',0),(388062,10780,'da','Finansiering',0),(388063,10780,'ko','íŒŒì´ ë‚¸ ì‹±',0),(388064,10780,'he','×ž×™×ž×•×Ÿ',0),(388065,10780,'el','Î§ÏÎ·Î¼Î±Ï„Î¿Î´ÏŒÏ„Î·ÏƒÎ·',0),(388066,10780,'zh','èžèµ„\r\n',0),(388067,10780,'sv','Finansiering',0),(388068,10780,'it','Finanziamento',0),(388069,10780,'tl','',0),(388070,10780,'th','à¸—à¸²à¸‡à¸à¸²à¸£à¹€à¸‡à¸´à¸™',0),(388071,10780,'hi','à¤µà¤¿à¤¤à¥à¤¤à¤ªà¥‹à¤·à¤£',0),(388072,10780,'ms','Pembiayaan',0),(388073,10780,'ar','ØªÙ…ÙˆÙŠÙ„',0),(388074,10780,'fr','Financement',0),(388075,10780,'jp','è³‡é‡‘èª¿é”',0),(388076,10780,'pt','Financiamento',0),(388077,10780,'ru','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(388078,10780,'es','Financimiento',0),(388079,10780,'de','Finanzierung',0),(388080,10780,'en','Financing',0),(388081,10781,'is','',0),(388082,10781,'dr','GFD Ú¯Ø±ÙØªÙ† Ø¢ÙˆÛŒØ²Ù‡Ø§ÛŒ Ù…Ø­Ù…ÙˆÙ„Ù‡  ',0),(388083,10781,'pr','GFD Ú¯Ø±ÙØªÙ† Ù…Ø¯Ø§Ø±Ùƒ Ù…Ø­Ù…ÙˆÙ„Ù‡  ',0),(388084,10781,'tr','GFD',0),(388085,10781,'pl','GFD',0),(388086,10781,'bg','Ð‘Ð’Ð”',0),(388087,10781,'ur','Ú¯ÙØ¯',0),(388088,10781,'sr','Ð“Ð¤Ð”',0),(388089,10781,'vi','GFD',0),(388090,10781,'af','GFD',0),(388091,10781,'ro','GFD',0),(388092,10781,'et','GFD',0),(388093,10781,'si','GFD',0),(388094,10781,'ba','GFD',0),(388095,10781,'nl','GFD',0),(388096,10781,'fi','GFD',0),(388097,10781,'no','GFD',0),(388098,10781,'da','GFD',0),(388099,10781,'ko','GFD',0),(388100,10781,'he','GFD',0),(388101,10781,'el','GFD',0),(388102,10781,'zh','æ™®é€šåŠŸèƒ½æè¿°\r\n',0),(388103,10781,'sv','GFD',0),(388104,10781,'it','GFD',0),(388105,10781,'tl','',0),(388106,10781,'th','GFD',0),(388107,10781,'hi','GFD',0),(388108,10781,'ms','GFD',0),(388109,10781,'ar','Ø³Ø§Ø±ÙŠ Ø§Ù„Ù…ÙØ¹ÙˆÙ„',0),(388110,10781,'fr','GISIGER',0),(388111,10781,'jp','åœ°çƒæµä½“é›»è„³',0),(388112,10781,'pt','ELIANA',0),(388113,10781,'ru','GFD',0),(388114,10781,'es','GFD',0),(388115,10781,'de','GFD',0),(388116,10781,'en','GFD',0),(388117,10782,'is','',0),(388118,10782,'dr','ÙˆØ§Ù… Ù…Ø´Ø§Ø±ÙƒØª Ù…Ø´ØªØ±ÙŠ ',0),(388119,10782,'pr','ÙˆØ§Ù… Ù…Ø´Ø§Ø±ÙƒØª Ù…Ø´ØªØ±ÙŠ ',0),(388120,10782,'tr','Kredi katkÄ± istemci',0),(388121,10782,'pl','Kredytu skÅ‚adka klienta',0),(388122,10782,'bg','Ð—Ð°ÐµÐ¼ Ð²Ð½Ð¾ÑÐºÐ° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(388123,10782,'ur','Ù‚Ø±Ø¶ Ø§Ø¹Ø§Ù†Øª ÙˆØµÙˆÙ„ Ú©Ø§Ø±',0),(388124,10782,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾Ñ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(388125,10782,'vi','Vay vá»‘n khÃ¡ch hÃ ng',0),(388126,10782,'af','Lening bydrae kliÃ«nt',0),(388127,10782,'ro','ÃŽmprumut de contributia clientului',0),(388128,10782,'et','Toetus krediidivÃµimelisuse',0),(388129,10782,'si','Posojilo prispevek odjemalca',0),(388130,10782,'ba','Pinjaman kontribusi klien',0),(388131,10782,'nl','Lening bijdrage Client',0),(388132,10782,'fi','Lainan osuus asiakas',0),(388133,10782,'no','LÃ¥n bidrag klient',0),(388134,10782,'da','LÃ¥n bidrag klient',0),(388135,10782,'ko','ëŒ€ì¶œ ê¸°ì—¬ í´ë¼ì´ì–¸íŠ¸',0),(388136,10782,'he','×”×œ×•×•××” ×”×ª×¨×•×ž×” ×œ×§×•×—',0),(388137,10782,'el','Î”Î¬Î½ÎµÎ¹Î¿ ÏƒÏ…Î¼Î²Î¿Î»Î® Ï€ÎµÎ»Î¬Ï„Î·',0),(388138,10782,'zh','è´·æ¬¾èµ„åŠ©å®¢æˆ·\r\n',0),(388139,10782,'sv','LÃ¥n bidrag klient',0),(388140,10782,'it','Client contributo prestito',0),(388141,10782,'tl','',0),(388142,10782,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¸ªà¹ˆà¸§à¸™',0),(388143,10782,'hi','à¤‹à¤£ à¤¯à¥‹à¤—à¤¦à¤¾à¤¨ à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ',0),(388144,10782,'ms','Pinjaman caruman pelanggan',0),(388145,10782,'ar','Ø§Ù„Ù‚Ø±Ø¶ Ù…Ø³Ø§Ù‡Ù…Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(388146,10782,'fr','PrÃªt Contribution Client',0),(388147,10782,'jp','èžè³‡è²¢çŒ®ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆ',0),(388148,10782,'pt','Cliente de contribuiÃ§Ã£o de emprÃ©stimo',0),(388149,10782,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð²ÐºÐ»Ð°Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(388150,10782,'es','Cliente de ContribuciÃ³n al Prestamo',0),(388151,10782,'de','Darlehen Beitrag Client',0),(388152,10782,'en','Loan Contribution Client',0),(388153,10783,'is','',0),(388154,10783,'dr','GFD',0),(388155,10783,'pr','ÙˆØ§Ù… Ù…Ø´Ø§Ø±ÙƒØª GFD',0),(388156,10783,'tr','Kredi katkÄ± GFD',0),(388157,10783,'pl','WkÅ‚ad poÅ¼yczki GFD',0),(388158,10783,'bg','Ð—Ð°ÐµÐ¼ Ð²Ð½Ð¾ÑÐºÐ° Ð‘Ð’Ð”',0),(388159,10783,'ur','Ù‚Ø±Ø¶ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú¯ÙØ¯',0),(388160,10783,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾Ñ Ð“Ð¤Ð”',0),(388161,10783,'vi','vá»‘n vay GFD',0),(388162,10783,'af','Lening bydrae GFD',0),(388163,10783,'ro','ÃŽmprumut contribuÅ£ia GFD',0),(388164,10783,'et','Laenu panus GFD',0),(388165,10783,'si','Posojilo prispevek GFD',0),(388166,10783,'ba','Pinjaman kontribusi GFD',0),(388167,10783,'nl','Lening bijdrage GFD',0),(388168,10783,'fi','Lainojen osuus GFD',0),(388169,10783,'no','LÃ¥n bidrag GFD',0),(388170,10783,'da','LÃ¥n bidrag GFD',0),(388171,10783,'ko','ëŒ€ì¶œ ê¸°ì—¬ GFD',0),(388172,10783,'he','×”×œ×•×•××” ×”×ª×¨×•×ž×” GFD',0),(388173,10783,'el','Î”Î¬Î½ÎµÎ¹Î¿ ÏƒÏ…Î¼Î²Î¿Î»Î® GFD',0),(388174,10783,'zh','è´·æ¬¾èµ„åŠ©æ™®é€šåŠŸèƒ½æè¿°\r\n',0),(388175,10783,'sv','LÃ¥n bidrag GFD',0),(388176,10783,'it','Contributo prestito GFD',0),(388177,10783,'tl','',0),(388178,10783,'th','à¸ªà¸±à¸”à¸ªà¹ˆà¸§à¸™à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­ GFD',0),(388179,10783,'hi','à¤‹à¤£ à¤¯à¥‹à¤—à¤¦à¤¾à¤¨ GFD',0),(388180,10783,'ms','Sumbangan pinjaman GFD',0),(388181,10783,'ar','Ù…Ø³Ø§Ù‡Ù…Ø© Ø§Ù„Ù‚Ø±Ø¶ Ø³Ø§Ø±ÙŠ Ø§Ù„Ù…ÙØ¹ÙˆÙ„',0),(388182,10783,'fr','Contribution de prÃªt Gisiger',0),(388183,10783,'jp','èžè³‡ã®è²¢çŒ® GFD',0),(388184,10783,'pt','ContribuiÃ§Ã£o de emprÃ©stimo Eliana',0),(388185,10783,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð²ÐºÐ»Ð°Ð´ GFD',0),(388186,10783,'es','ContribuciÃ³n al Prestamo GFD',0),(388187,10783,'de','Darlehen Beitrag GFD',0),(388188,10783,'en','Loan Contribution GFD',0),(388189,10784,'is','',0),(388190,10784,'dr','REX',0),(388191,10784,'pr','ÙˆØ§Ù… Ù…Ø´Ø§Ø±ÙƒØª REX',0),(388192,10784,'tr','Kredi katkÄ± REX',0),(388193,10784,'pl','PoÅ¼yczki wkÅ‚ad REX',0),(388194,10784,'bg','Ð—Ð°ÐµÐ¼ Ð²Ð½Ð¾ÑÐºÐ° Ð ÐµÐºÑ',0),(388195,10784,'ur','Ù‚Ø±Ø¶ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ø±ÛŒÚ©Ø³',0),(388196,10784,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾Ñ Ð Ð•X',0),(388197,10784,'vi','vá»‘n vay REX',0),(388198,10784,'af','Lening bydrae REX',0),(388199,10784,'ro','ÃŽmprumut contribuÅ£ia REX',0),(388200,10784,'et','Laenu panus REX',0),(388201,10784,'si','Posojilo prispevek REX',0),(388202,10784,'ba','Pinjaman kontribusi REX',0),(388203,10784,'nl','Lening bijdrage REX',0),(388204,10784,'fi','Lainan osuus REX',0),(388205,10784,'no','LÃ¥n bidrag REX',0),(388206,10784,'da','LÃ¥n bidrag REX',0),(388207,10784,'ko','ëŒ€ì¶œ ê¸°ì—¬ ë ‰ìŠ¤',0),(388208,10784,'he','×”×œ×•×•××” ×”×ª×¨×•×ž×” ×¨×§×¡',0),(388209,10784,'el','Î”Î¬Î½ÎµÎ¹Î¿ ÏƒÏ…Î¼Î²Î¿Î»Î® REX',0),(388210,10784,'zh','è´·æ¬¾èµ„åŠ©REX\r\n',0),(388211,10784,'sv','LÃ¥n bidrag REX',0),(388212,10784,'it','REX contributo prestito',0),(388213,10784,'tl','',0),(388214,10784,'th','à¹€à¸‡à¸´à¸™à¸à¸¹à¹‰à¸¢à¸·à¸¡à¸ªà¹ˆà¸§à¸™à¹€à¸£à¹‡à¸à¸‹à¹Œ',0),(388215,10784,'hi','à¤‹à¤£ à¤¯à¥‹à¤—à¤¦à¤¾à¤¨ à¤°à¥‡à¤•à¥à¤¸',0),(388216,10784,'ms','Pinjaman caruman REX',0),(388217,10784,'ar','Ø±ÙŠÙƒØ³ Ù…Ø³Ø§Ù‡Ù…Ø© Ø§Ù„Ù‚Ø±ÙˆØ¶',0),(388218,10784,'fr','PrÃªt Contribution REX',0),(388219,10784,'jp','èžè³‡è²¢çŒ®ãƒ¬ãƒƒã‚¯ã‚¹',0),(388220,10784,'pt','EmprÃ©stimo contribuiÃ§Ã£o REX',0),(388221,10784,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð²ÐºÐ»Ð°Ð´ Ð ÐµÐºÑ',0),(388222,10784,'es','ContribuciÃ³n al Prestamo REX',0),(388223,10784,'de','Darlehen Beitrag REX',0),(388224,10784,'en','Loan Contribution REX',0),(388225,10785,'is','',0),(388226,10785,'dr','Ù†Ø±Ø® Ø¨Ù‡Ø±Ù‡ ÙˆØ§Ù… \r\n',0),(388227,10785,'pr','Ù†Ø±Ø® Ø¨Ù‡Ø±Ù‡ ÙˆØ§Ù… \r\n',0),(388228,10785,'tr','LTV',0),(388229,10785,'pl','LTV',0),(388230,10785,'bg','LTV',0),(388231,10785,'ur','Ù„Ù¹Ùˆ',0),(388232,10785,'sr','Ð›Ð¢Ð’',0),(388233,10785,'vi','LTV',0),(388234,10785,'af','LTW',0),(388235,10785,'ro','LTV',0),(388236,10785,'et','PIIRATUD TERRITORIAALSE KEHTIVUSEGA',0),(388237,10785,'si','LTV',0),(388238,10785,'ba','LTV',0),(388239,10785,'nl','LTV',0),(388240,10785,'fi','LTV',0),(388241,10785,'no','LTV',0),(388242,10785,'da','LTV',0),(388243,10785,'ko','LTV',0),(388244,10785,'he','LTV',0),(388245,10785,'el','LTV',0),(388246,10785,'zh','æŒ‰æ­æˆæ•°\r\n',0),(388247,10785,'sv','LTV',0),(388248,10785,'it','LTV',0),(388249,10785,'tl','',0),(388250,10785,'th','LTV',0),(388251,10785,'hi','LTV',0),(388252,10785,'ms','LTV',0),(388253,10785,'ar','Ø§Ù„Ù…Ø±ÙƒØ¨Ø© Ø§Ù„ØªÙƒØªÙŠÙƒÙŠØ© Ø§Ù„Ø®ÙÙŠÙØ©',0),(388254,10785,'fr','LTV',0),(388255,10785,'jp','LTV',0),(388256,10785,'pt','LTV',0),(388257,10785,'ru','LTV',0),(388258,10785,'es','LTV',0),(388259,10785,'de','LTV',0),(388260,10785,'en','LTV',0),(388261,10786,'is','',0),(388262,10786,'dr','Ø®Ø§Ù„Øµ ØªØ§Ù…ÙŠÙ† Ù…Ø§Ù„ÙŠ',0),(388263,10786,'pr','Ø®Ø§Ù„Øµ ØªØ§Ù…ÙŠÙ† Ù…Ø§Ù„ÙŠ',0),(388264,10786,'tr','NET finansman',0),(388265,10786,'pl','Finansowania netto',0),(388266,10786,'bg','ÐÐµÑ‚Ð½Ð¾ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€Ð°Ð½Ðµ',0),(388267,10786,'ur','Ù†ÛŒÙ¹ ÙˆØ±Ú© Ú©ÛŒ Ù…Ø§Ù„ÛŒ Ø§Ù…Ø¯Ø§Ø¯',0),(388268,10786,'sr','ÐÐµÑ‚Ð¾ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€Ð°ÑšÐµ',0),(388269,10786,'vi','tÃ i chÃ­nh thuáº§n',0),(388270,10786,'af','Netto finansiering',0),(388271,10786,'ro','NetÄƒ de finanÅ£are',0),(388272,10786,'et','Net rahastamine',0),(388273,10786,'si','Neto financiranje',0),(388274,10786,'ba','Pembiayaan bersih',0),(388275,10786,'nl','Netto financiering',0),(388276,10786,'fi','Laskelman mukainen likvidien',0),(388277,10786,'no','Netto finansiering',0),(388278,10786,'da','Netto finansiering',0),(388279,10786,'ko','ìˆœ ìœµìž',0),(388280,10786,'he','×ž×™×ž×•×Ÿ × ×˜×•',0),(388281,10786,'el','ÎšÎ±Î¸Î±ÏÎ® Ï‡ÏÎ·Î¼Î±Ï„Î¿Î´ÏŒÏ„Î·ÏƒÎ·',0),(388282,10786,'zh','å‡€èžèµ„\r\n',0),(388283,10786,'sv','Net finansiering',0),(388284,10786,'it','Finanziamento netto',0),(388285,10786,'tl','',0),(388286,10786,'th','à¹€à¸‡à¸´à¸™à¸ªà¸¸à¸—à¸˜à¸´',0),(388287,10786,'hi','à¤¶à¥à¤¦à¥à¤§ à¤µà¤¿à¤¤à¥à¤¤à¤ªà¥‹à¤·à¤£',0),(388288,10786,'ms','Pembiayaan bersih',0),(388289,10786,'ar','ØµØ§ÙÙŠ Ø§Ù„ØªÙ…ÙˆÙŠÙ„',0),(388290,10786,'fr','Financement net',0),(388291,10786,'jp','ç´”è³‡é‡‘èª¿é”',0),(388292,10786,'pt','Financiamento lÃ­quido',0),(388293,10786,'ru','Ð§Ð¸ÑÑ‚Ð¾Ðµ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(388294,10786,'es','Financimiento Neto',0),(388295,10786,'de','NET-Finanzierung',0),(388296,10786,'en','Net Financing',0),(388297,10787,'is','',0),(388298,10787,'dr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡',0),(388299,10787,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡',0),(388300,10787,'tr','Geri kalan',0),(388301,10787,'pl','PozostaÅ‚a czÄ™Å›Ä‡',0),(388302,10787,'bg','ÐžÑÑ‚Ð°Ñ‚ÑŠÐº',0),(388303,10787,'ur','Ø¨Ø§Ù‚ÛŒ',0),(388304,10787,'sr','ÐžÑÑ‚Ð°Ñ‚Ð°Ðº Ð¿Ñ€Ð¸ Ð´ÐµÑ™ÐµÑšÑƒ',0),(388305,10787,'vi','váº­t cÃ²n láº¡i',0),(388306,10787,'af','Restant',0),(388307,10787,'ro','Restul',0),(388308,10787,'et','ÃœlejÃ¤Ã¤nud',0),(388309,10787,'si','Preostanek',0),(388310,10787,'ba','Sisanya',0),(388311,10787,'nl','Rest',0),(388312,10787,'fi','Loput',0),(388313,10787,'no','Resten',0),(388314,10787,'da','Resten',0),(388315,10787,'ko','ë‚˜ë¨¸ì§€',0),(388316,10787,'he','×”×©××¨×™×ª',0),(388317,10787,'el','Î¥Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(388318,10787,'zh','å…¶ä½™\r\n',0),(388319,10787,'sv','Resten',0),(388320,10787,'it','Resto',0),(388321,10787,'tl','',0),(388322,10787,'th','à¸ªà¹ˆà¸§à¸™à¸—à¸µà¹ˆà¹€à¸«à¸¥à¸·à¸­',0),(388323,10787,'hi','à¤¶à¥‡à¤·',0),(388324,10787,'ms','Baki',0),(388325,10787,'ar','Ø§Ù„Ù…Ø¯Ø© Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(388326,10787,'fr','Reste',0),(388327,10787,'jp','æ®‹ã‚Šã®éƒ¨åˆ†',0),(388328,10787,'pt','Restante',0),(388329,10787,'ru','ÐžÑÑ‚Ð°Ñ‚Ð¾Ðº',0),(388330,10787,'es','Saldo',0),(388331,10787,'de','Rest',0),(388332,10787,'en','Remainder',0),(388333,10788,'is','',0),(388334,10788,'dr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ù…ØµØ§Ø±Ù ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ ',0),(388335,10788,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ù…ØµØ§Ø±Ù ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ ',0),(388336,10788,'tr','Kalan para kullanÄ±mlarÄ±',0),(388337,10788,'pl','PozostaÅ‚e Å›rodki pieniÄ™Å¼ne zwyczaje',0),(388338,10788,'bg','ÐžÑÑ‚Ð°Ð½Ð°Ð»Ð¸Ñ‚Ðµ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ Ð¾Ð±Ð¸Ñ‡Ð°Ð¸',0),(388339,10788,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©Û’ Ø¨Ø§Ù‚ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„Ø§Øª',0),(388340,10788,'sr','ÐŸÑ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¸ Ð½Ð¾Ð²Ð°Ñ† Ð¸Ð½Ð´ÑƒÑÑ‚Ñ€Ð¸Ñ˜Ð°Ð¼Ð°',0),(388341,10788,'vi','cÃ²n tiá»n sá»­ dá»¥ng',0),(388342,10788,'af','Behou Kontant Gebruik',0),(388343,10788,'ro','UzanÅ£ele numerar rÄƒmase',0),(388344,10788,'et','ÃœlejÃ¤Ã¤nud raha tavadega',0),(388345,10788,'si','Preostali denar rabe',0),(388346,10788,'ba','Penggunaan uang tunai yang tersisa',0),(388347,10788,'nl','Resterende Cash Usages',0),(388348,10788,'fi','JÃ¤ljellÃ¤ kÃ¤teistÃ¤ kÃ¤yttÃ¶kohteita',0),(388349,10788,'no','GjenvÃ¦rende penger bruksomrÃ¥der',0),(388350,10788,'da','Resterende kontanter kutymer',0),(388351,10788,'ko','ë‚˜ë¨¸ì§€ í˜„ê¸ˆ ì‚¬ìš©',0),(388352,10788,'he','×©×™×ž×•×©×™× ×”×ž×–×•×ž× ×™× ×”× ×•×ª×¨×™×',0),(388353,10788,'el','Î¥Ï€ÏŒÎ»Î¿Î¹Ï€ÎµÏ‚ Ï‡ÏÎ®ÏƒÎµÎ¹Ï‚ Î¼ÎµÏ„ÏÎ·Ï„Î¬',0),(388354,10788,'zh','ä½™ä¸‹çš„çŽ°é‡‘ç”¨æ³•\r\n',0),(388355,10788,'sv','Ã…terstÃ¥ende kontanter seder',0),(388356,10788,'it','Utilizzi di cassa rimanenti',0),(388357,10788,'tl','',0),(388358,10788,'th','à¸›à¸£à¸°à¹€à¸žà¸“à¸µà¹€à¸‡à¸´à¸™à¸ªà¸”à¸„à¸‡à¹€à¸«à¸¥à¸·à¸­',0),(388359,10788,'hi','à¤¶à¥‡à¤· à¤¨à¤•à¤¦à¥€ Usages',0),(388360,10788,'ms','Baki tunai penggunaan',0),(388361,10788,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù…Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(388362,10788,'fr','Autres Usages de Cash',0),(388363,10788,'jp','æ®‹ã‚Šã®ç¾é‡‘ã®ä½¿ç”¨æ³•',0),(388364,10788,'pt','Restantes usos do dinheiro',0),(388365,10788,'ru','ÐžÑÑ‚Ð°Ð²ÑˆÐ¸ÐµÑÑ Ð´ÐµÐ½ÑŒÐ³Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ð¹',0),(388366,10788,'es','Usos de Efectivo Restantes',0),(388367,10788,'de','Verbleibenden Cash-Verwendungen',0),(388368,10788,'en','Remaining Cash Usages',0),(388369,10789,'is','',0),(388370,10789,'dr','REX Ù¾Ø§Ø¯Ø´Ø§Ù‡ (Ø§ØµÙ„Ø§Ø­ Ù‡Ø²ÙŠÙ†Ù‡',0),(388371,10789,'pr','REX Ù¾Ø§Ø¯Ø´Ø§Ù‡ (Ø§ØµÙ„Ø§Ø­ Ù‡Ø²ÙŠÙ†Ù‡',0),(388372,10789,'tr','REX',0),(388373,10789,'pl','REX',0),(388374,10789,'bg','Ð Ð•ÐšÐ¡',0),(388375,10789,'ur','Ø±ÛŒÚ©Ø³',0),(388376,10789,'sr','Ð Ð•X',0),(388377,10789,'vi','REX',0),(388378,10789,'af','REX',0),(388379,10789,'ro','REX',0),(388380,10789,'et','REX',0),(388381,10789,'si','REX',0),(388382,10789,'ba','REX',0),(388383,10789,'nl','REX',0),(388384,10789,'fi','REX',0),(388385,10789,'no','REX',0),(388386,10789,'da','REX',0),(388387,10789,'ko','ë ‰ìŠ¤',0),(388388,10789,'he','×¨×§×¡',0),(388389,10789,'el','REX',0),(388390,10789,'zh','åŠ›å£«\r\n',0),(388391,10789,'sv','REX',0),(388392,10789,'it','REX',0),(388393,10789,'tl','',0),(388394,10789,'th','REX',0),(388395,10789,'hi','à¤°à¥‡à¤•à¥à¤¸',0),(388396,10789,'ms','REX',0),(388397,10789,'ar','Ø±ÙŠÙƒØ³',0),(388398,10789,'fr','REX',0),(388399,10789,'jp','ãƒ¬ãƒƒã‚¯ã‚¹',0),(388400,10789,'pt','REX',0),(388401,10789,'ru','Ð Ð•ÐšÐ¡',0),(388402,10789,'es','REX',0),(388403,10789,'de','REX',0),(388404,10789,'en','REX',0),(388405,10790,'is','',0),(388406,10790,'dr','(Ù…Ø¬Ù…ÙˆØ¹ÙŠ',0),(388407,10790,'pr','Ø³Ø§ÙŠØª Ùˆ Ø¹Ù…ÙˆÙ…ÙŠ(ÙƒÙ„ÙŠ',0),(388408,10790,'tr','Site & genel',0),(388409,10790,'pl','Strona & ogÃ³lne',0),(388410,10790,'bg','Ð¡Ð°Ð¹Ñ‚ & Ð³ÐµÐ½ÐµÑ€Ð°Ð»',0),(388411,10790,'ur','Ø³Ø§Ø¦Ù¹ & Ø¬Ù†Ø±Ù„',0),(388412,10790,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð¸ Ð“ÐµÐ½ÐµÑ€Ð°Ð»',0),(388413,10790,'vi','Trang web vÃ  tá»•ng thá»ƒ',0),(388414,10790,'af','Terrein & Algemeen',0),(388415,10790,'ro','Site-ul & General',0),(388416,10790,'et','Saidi & kindral',0),(388417,10790,'si','Mesto & General',0),(388418,10790,'ba','Situs & umum',0),(388419,10790,'nl','Site & generaal',0),(388420,10790,'fi','Sivuston & yleinen',0),(388421,10790,'no','Nettstedet & generelt',0),(388422,10790,'da','Site & General',0),(388423,10790,'ko','ì‚¬ì´íŠ¸ & ì¼ë°˜',0),(388424,10790,'he','××ª×¨ & ×’× ×¨×œ',0),(388425,10790,'el','Site & Î³ÎµÎ½Î¹ÎºÎ®',0),(388426,10790,'zh','ç½‘ç«™åŠä¸€èˆ¬\r\n',0),(388427,10790,'sv','Webbplats & allmÃ¤nna',0),(388428,10790,'it','Sito & generale',0),(388429,10790,'tl','',0),(388430,10790,'th','à¹„à¸‹à¸•à¹Œ & à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(388431,10790,'hi','à¤¸à¤¾à¤‡à¤Ÿ & à¤œà¤¨à¤°à¤²',0),(388432,10790,'ms','Lokasi & Agung',0),(388433,10790,'ar','Ù…ÙˆÙ‚Ø¹ Ø¢Ù†Ø¯ Ø§Ù„Ø¹Ø§Ù…Ø©',0),(388434,10790,'fr','Site & gÃ©nÃ©rale',0),(388435,10790,'jp','ã‚µã‚¤ãƒˆ & å…¨èˆ¬',0),(388436,10790,'pt','Site & geral',0),(388437,10790,'ru','Ð¡Ð°Ð¹Ñ‚ Ð¸ ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ðµ',0),(388438,10790,'es','Sitio & General',0),(388439,10790,'de','Website- & -General',0),(388440,10790,'en','Site & General',0),(388441,10791,'is','',0),(388442,10791,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù…ØµØ§Ø±Ù ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ ',0),(388443,10791,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù…ØµØ§Ø±Ù ÙˆØ¬Ù‡ Ù†Ù‚Ø¯ ',0),(388444,10791,'tr','Toplam para kullanÄ±mlarÄ±',0),(388445,10791,'pl','ÅÄ…czny gotÃ³wkowy zwyczaje',0),(388446,10791,'bg','ÐžÐ±Ñ‰Ð¸ÑÑ‚ Ð±Ñ€Ð¾Ð¹ Ð¾Ð±Ð¸Ñ‡Ð°Ð¸',0),(388447,10791,'ur','Ú©Ù„ Ù†Ù‚Ø¯ Ø§Ø³ØªØ¹Ù…Ø§Ù„Ø§Øª',0),(388448,10791,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ Ð¸Ð½Ð´ÑƒÑÑ‚Ñ€Ð¸Ñ˜Ð°Ð¼Ð°',0),(388449,10791,'vi','Tá»•ng sá»­ dá»¥ng tiá»n máº·t',0),(388450,10791,'af','Totale Kontantgebruik',0),(388451,10791,'ro','Total bani uzanÅ£ele',0),(388452,10791,'et','Kokku sularaha tavadega',0),(388453,10791,'si','Skupni denarni rabe',0),(388454,10791,'ba','Penggunaan Total Kas',0),(388455,10791,'nl','Totaal bedrag in Cash Usages',0),(388456,10791,'fi','Kassavarat kÃ¤yttÃ¶kohteita',0),(388457,10791,'no','Totalt bruksomrÃ¥der',0),(388458,10791,'da','Likviditeten kutymer',0),(388459,10791,'ko','ì´ í˜„ê¸ˆ ì‚¬ìš©',0),(388460,10791,'he','×ž×–×•×ž× ×™× ×”×›×•×œ×œ ×©×™×ž×•×©×™×',0),(388461,10791,'el','Î¤Î¿ ÏƒÏ…Î½Î¿Î»Î¹ÎºÏŒ Ï€Î¿ÏƒÏŒ Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½ Ï‡ÏÎ®ÏƒÎµÎ¹Ï‚',0),(388462,10791,'zh','æ€»è®¡çŽ°é‡‘ä½¿ç”¨\r\n',0),(388463,10791,'sv','Totala Cash anvÃ¤ndningsomrÃ¥den',0),(388464,10791,'it','Usi contanti totale',0),(388465,10791,'tl','',0),(388466,10791,'th','à¹€à¸‡à¸´à¸™à¸ªà¸”à¸£à¸§à¸¡à¸›à¸£à¸°à¹€à¸žà¸“à¸µ',0),(388467,10791,'hi','à¤•à¥à¤² à¤¨à¤•à¤¦à¥€ Usages',0),(388468,10791,'ms','Penggunaan Tunai',0),(388469,10791,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù…Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ©',0),(388470,10791,'fr','Usages du total de l\'encaisse',0),(388471,10791,'jp','åˆè¨ˆç¾é‡‘ã®ä½¿ç”¨æ³•',0),(388472,10791,'pt','Total de dinheiro que usos',0),(388473,10791,'ru','ÐžÐ±Ñ‰Ð¸Ðµ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ð¹',0),(388474,10791,'es','Usos de Efectivo Totales',0),(388475,10791,'de','Gesamt-Cash-Verwendungen',0),(388476,10791,'en','Total Cash Usages',0),(388477,10792,'is','',0),(388478,10792,'dr','(Ø³Ù†Ú¯ÙŠÙ†) Ø³Ø®Øª ',0),(388479,10792,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ(Ø³Ù†Ú¯ÙŠÙ†) Ø³Ø®Øª ',0),(388480,10792,'tr','Toplam sabit maliyetler',0),(388481,10792,'pl','CaÅ‚kowite koszty',0),(388482,10792,'bg','ÐžÐ±Ñ‰Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ñ‚Ð²ÑŠÑ€Ð´',0),(388483,10792,'ur','Ú©Ù„ Ù…Ø´Ú©Ù„ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(388484,10792,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ñ‚ÐµÑˆÐºÐ¾',0),(388485,10792,'vi','tá»•ng cá»™ng chi phÃ­ cá»©ng',0),(388486,10792,'af','Totale kostes in die harde',0),(388487,10792,'ro','Costurile totale de greu',0),(388488,10792,'et','Kokku raske kanda',0),(388489,10792,'si','Skupni stroÅ¡ki teÅ¾ko',0),(388490,10792,'ba','Total biaya keras',0),(388491,10792,'nl','Totale vaste kosten',0),(388492,10792,'fi','Kova kokonaiskustannukset',0),(388493,10792,'no','Hard totalkostnader',0),(388494,10792,'da','HÃ¥rde kostbelÃ¸b',0),(388495,10792,'ko','ì´ í•˜ë“œ ë¹„ìš©',0),(388496,10792,'he','×”×¢×œ×•×™×•×ª ×§×©×”',0),(388497,10792,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚ ÏƒÎºÎ»Î·ÏÏŒ',0),(388498,10792,'zh','æ€»è®¡ç¡¬æˆæœ¬\r\n',0),(388499,10792,'sv','HÃ¥rd totalkostnader',0),(388500,10792,'it','Totali costi duri',0),(388501,10792,'tl','',0),(388502,10792,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸£à¸§à¸¡à¸‚à¸­à¸‡à¸®à¸²à¸£à¹Œà¸”à¸”à¸´à¸ªà¸à¹Œ',0),(388503,10792,'hi','à¤•à¥à¤² à¤¹à¤¾à¤°à¥à¤¡ à¤²à¤¾à¤—à¤¤',0),(388504,10792,'ms','Jumlah kos yang keras',0),(388505,10792,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø«Ø§Ø¨ØªØ©',0),(388506,10792,'fr','Totales coÃ»ts',0),(388507,10792,'jp','åˆè¨ˆãƒãƒ¼ãƒ‰é¢ã®ã‚³ã‚¹ãƒˆ',0),(388508,10792,'pt','Totais custos',0),(388509,10792,'ru','Ð’ÑÐµÐ³Ð¾ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð½Ð° Ð¶ÐµÑÑ‚ÐºÐ¸Ð¹',0),(388510,10792,'es','Totalde Costos Duros',0),(388511,10792,'de','Harte Gesamtkosten',0),(388512,10792,'en','Total Hard Costs',0),(388513,10793,'is','',0),(388514,10793,'dr','ÙƒÙ„ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„ÙŠ ',0),(388515,10793,'pr','ÙƒÙ„ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø¹Ù…ÙˆÙ„ÙŠ ',0),(388516,10793,'tr','YumuÅŸak toplam maliyetler',0),(388517,10793,'pl','CaÅ‚kowite koszty miÄ™kkie',0),(388518,10793,'bg','ÐžÐ±Ñ‰Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð¼ÐµÐºÐ¸',0),(388519,10793,'ur','Ú©Ù„ Ù†Ø±Ù… Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(388520,10793,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð¼ÐµÐºÐ°Ð½',0),(388521,10793,'vi','Tá»•ng chi phÃ­ má»m',0),(388522,10793,'af','Totale kostes in die sagte',0),(388523,10793,'ro','Costurile totale moale',0),(388524,10793,'et','Pehme kulud kokku',0),(388525,10793,'si','Skupni mehkega stroÅ¡kov',0),(388526,10793,'ba','Biaya total lembut',0),(388527,10793,'nl','Totale zachte kosten',0),(388528,10793,'fi','PehmeÃ¤ kokonaiskustannukset',0),(388529,10793,'no','Myk totalkostnader',0),(388530,10793,'da','BlÃ¸d kostbelÃ¸b',0),(388531,10793,'ko','ë¶€ë“œëŸ¬ìš´ ë¹„ìš©',0),(388532,10793,'he','×¡×” ×› ×¢×œ×•×™×•×ª ×¨×š',0),(388533,10793,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚ Î¼Î±Î»Î±ÎºÏŒ',0),(388534,10793,'zh','æ€»è®¡è½¯æˆæœ¬\r\n',0),(388535,10793,'sv','Mjuk totalkostnader',0),(388536,10793,'it','Totali costi morbidi',0),(388537,10793,'tl','',0),(388538,10793,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸£à¸§à¸¡à¸—à¸µà¹ˆà¸­à¹ˆà¸­à¸™',0),(388539,10793,'hi','à¤•à¥à¤² à¤¨à¤°à¤® à¤²à¤¾à¤—à¤¤',0),(388540,10793,'ms','Jumlah kos yang lembut',0),(388541,10793,'ar','Ù…Ø¬Ù…ÙˆØ¹ ØªÙƒØ§Ù„ÙŠÙ Ù„ÙŠÙ†Ø©',0),(388542,10793,'fr','Totales coÃ»ts accessoires',0),(388543,10793,'jp','ã‚½ãƒ•ãƒˆã®ç·ã‚³ã‚¹ãƒˆ',0),(388544,10793,'pt','Custos totais macios',0),(388545,10793,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¼ÑÐ³ÐºÐ¾Ð¹',0),(388546,10793,'es','Total de Costos Suaves',0),(388547,10793,'de','Weichen Gesamtkosten',0),(388548,10793,'en','Total Soft Costs',0),(388549,10794,'is','',0),(388550,10794,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(388551,10794,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(388552,10794,'tr','Fatura fatura numarasÄ±',0),(388553,10794,'pl','Numer faktury Bill',0),(388554,10794,'bg','Ð‘Ð¸Ð» Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¾Ð¼ÐµÑ€',0),(388555,10794,'ur','Ø¨Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(388556,10794,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð‘Ð¸Ð» Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(388557,10794,'vi','Láº­p sá»‘ hÃ³a Ä‘Æ¡n',0),(388558,10794,'af','Wetsontwerp faktuur nommer',0),(388559,10794,'ro','NumÄƒrul facturii Bill',0),(388560,10794,'et','Maksja arve Number',0),(388561,10794,'si','Å tevilka raÄuna Bill',0),(388562,10794,'ba','Nomor faktur tagihan',0),(388563,10794,'nl','Bill factuurnummer',0),(388564,10794,'fi','Bill laskun numero',0),(388565,10794,'no','Bill fakturanummer',0),(388566,10794,'da','Bill fakturanummer',0),(388567,10794,'ko','ë¹Œ ì†¡ìž¥ ë²ˆí˜¸',0),(388568,10794,'he','×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª ×‘×™×œ',0),(388569,10794,'el','Bill Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(388570,10794,'zh','å¸å•çš„å‘ç¥¨å·ç \r\n',0),(388571,10794,'sv','Bill fakturanummer',0),(388572,10794,'it','Numero fattura fattura',0),(388573,10794,'tl','',0),(388574,10794,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(388575,10794,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(388576,10794,'ms','Nombor invois Rang undang-undang',0),(388577,10794,'ar','Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙØ§ØªÙˆØ±Ø©',0),(388578,10794,'fr','NumÃ©ro de la facture de Bill',0),(388579,10794,'jp','è«‹æ±‚æ›¸ã®è«‹æ±‚æ›¸ç•ªå·',0),(388580,10794,'pt','NÃºmero da fatura',0),(388581,10794,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð‘Ð¸Ð»Ð»',0),(388582,10794,'es','Numero de Factura del Recibo',0),(388583,10794,'de','Bill Rechnungsnummer',0),(388584,10794,'en','Bill Invoice Number',0),(388585,10795,'is','',0),(388586,10795,'dr','Ù†Ø§Ù… ÙØ§ÙŠÙ„',0),(388587,10795,'pr','Ù†Ø§Ù… ÙØ§ÙŠÙ„',0),(388588,10795,'tr','Dosya adÄ±',0),(388589,10795,'pl','Nazwa pliku',0),(388590,10795,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(388591,10795,'ur','Ù†Ø§Ù… Ù…Ø³Ù„',0),(388592,10795,'sr','Ð˜Ð¼Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(388593,10795,'vi','tÃªn há»“ sÆ¡',0),(388594,10795,'af','LÃªernaam',0),(388595,10795,'ro','Nume fisier',0),(388596,10795,'et','Faili nimi',0),(388597,10795,'si','Ime datoteke',0),(388598,10795,'ba','Nama file',0),(388599,10795,'nl','Bestandsnaam',0),(388600,10795,'fi','Tiedostonimi',0),(388601,10795,'no','Filnavn',0),(388602,10795,'da','Filnavn',0),(388603,10795,'ko','íŒŒì¼ ì´ë¦„',0),(388604,10795,'he','×©× ×§×•×‘×¥',0),(388605,10795,'el','ÎŒÎ½Î¿Î¼Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(388606,10795,'zh','æ–‡ä»¶å\r\n',0),(388607,10795,'sv','Filnamn',0),(388608,10795,'it','Nome del file',0),(388609,10795,'tl','',0),(388610,10795,'th','à¸Šà¸·à¹ˆà¸­à¹à¸Ÿà¹‰à¸¡',0),(388611,10795,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤¨à¤¾à¤®',0),(388612,10795,'ms','Nama fail',0),(388613,10795,'ar','Ø¥Ø³Ù… Ø§Ù„Ù…Ù„Ù',0),(388614,10795,'fr','Nom de fichier',0),(388615,10795,'jp','ãƒ•ã‚¡ã‚¤ãƒ«å',0),(388616,10795,'pt','Nome do arquivo',0),(388617,10795,'ru','Ð˜Ð¼Ñ Ð¤Ð°Ð¹Ð»Ð°',0),(388618,10795,'es','Nombre de Archivo',0),(388619,10795,'de','Dateiname',0),(388620,10795,'en','Filename',0),(388621,10796,'is','',0),(388622,10796,'dr','Ù…Ø±ÙˆØ±Ú¯Ø± ÙØ§ÙŠÙ„ ',0),(388623,10796,'pr','Ù…Ø±ÙˆØ±Ú¯Ø± ÙØ§ÙŠÙ„ ',0),(388624,10796,'tr','Dosya tarayÄ±cÄ±',0),(388625,10796,'pl','PrzeglÄ…darka plikÃ³w',0),(388626,10796,'bg','Ð¤Ð°Ð¹Ð» Ð±Ñ€Ð°ÑƒÐ·ÑŠÑ€',0),(388627,10796,'ur','Ù…Ø³Ù„ Ø¨Ø±Ø§Ø¤Ø²Ø±',0),(388628,10796,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‡Ð°',0),(388629,10796,'vi','quÃ©t file',0),(388630,10796,'af','LÃªer blaaier',0),(388631,10796,'ro','File Browser',0),(388632,10796,'et','File Browser',0),(388633,10796,'si','Datoteko brskalnik',0),(388634,10796,'ba','File Browser',0),(388635,10796,'nl','Browser van het dossier',0),(388636,10796,'fi','File Browser',0),(388637,10796,'no','Filleseren',0),(388638,10796,'da','Filbrowser',0),(388639,10796,'ko','íŒŒì¼ ë¸Œë¼ìš°ì €',0),(388640,10796,'he','×“×¤×“×¤×Ÿ ×§×•×‘×¥',0),(388641,10796,'el','ÎœÎ·Ï‡Î±Î½Î® Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚ Î±ÏÏ‡ÎµÎ¯Ï‰Î½',0),(388642,10796,'zh','æ–‡ä»¶æµè§ˆå™¨\r\n',0),(388643,10796,'sv','Fil webblÃ¤sare',0),(388644,10796,'it','File Browser',0),(388645,10796,'tl','',0),(388646,10796,'th','à¹€à¸šà¸£à¸²à¸§à¹Œà¹€à¸‹à¸­à¸£à¹Œà¹à¸Ÿà¹‰à¸¡',0),(388647,10796,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¬à¥à¤°à¤¾à¤‰à¤œà¤¼à¤°',0),(388648,10796,'ms','Pelayar',0),(388649,10796,'ar','Ù…ØªØµÙÙ‘Ø­ Ø§Ù„Ù…Ù„ÙÙ‘Ø§Øª',0),(388650,10796,'fr','Navigateur de fichiers',0),(388651,10796,'jp','ãƒ•ã‚¡ã‚¤ãƒ« ãƒ» ãƒ–ãƒ©ã‚¦ã‚¶ãƒ¼',0),(388652,10796,'pt','Navegador de arquivos',0),(388653,10796,'ru','Ð‘Ñ€Ð°ÑƒÐ·ÐµÑ€ Ð¤Ð°Ð¹Ð»Ð°',0),(388654,10796,'es','Buscador de Archivo',0),(388655,10796,'de','Datei-Browser',0),(388656,10796,'en','File Browser',0),(388657,10797,'is','',0),(388658,10797,'dr','Ù‡ÙŠÚ† ÙØ§ÙŠÙ„ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(388659,10797,'pr','Ù‡ÙŠÚ† ÙØ§ÙŠÙ„ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(388660,10797,'tr','Dosya bulunamadÄ±',0),(388661,10797,'pl','Nie znaleziono plikÃ³w',0),(388662,10797,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(388663,10797,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø³Ù„ Ù†ÛÛŒÚº Ù…Ù„ÛŒ',0),(388664,10797,'sr','ÐÐ¸ÑÑƒ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(388665,10797,'vi','khÃ´ng tÃ¬m tháº¥y file',0),(388666,10797,'af','Geen LÃªers Gevind',0),(388667,10797,'ro','Nu fiÅŸierele gÄƒsite',0),(388668,10797,'et','Ãœhtki faili ei leidunud',0),(388669,10797,'si','Ni najdene datoteke',0),(388670,10797,'ba','File tidak ditemukan',0),(388671,10797,'nl','Geen bestanden gevonden',0),(388672,10797,'fi','Tiedostoja ei lÃ¶ytynyt',0),(388673,10797,'no','Finner ingen filer',0),(388674,10797,'da','Ingen filer fundet',0),(388675,10797,'ko','ì°¾ì„ íŒŒì¼ì´ ì—†ìŠµë‹ˆë‹¤',0),(388676,10797,'he','×œ× × ×ž×¦××• ×§×‘×¦×™×',0),(388677,10797,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î±ÏÏ‡ÎµÎ¯Î±',0),(388678,10797,'zh','æ²¡æœ‰æ‰¾åˆ°çš„æ–‡ä»¶\r\n',0),(388679,10797,'sv','Inga filer Funna',0),(388680,10797,'it','Nessun file trovato',0),(388681,10797,'tl','',0),(388682,10797,'th','à¹„à¸¡à¹ˆà¸žà¸šà¹à¸Ÿà¹‰à¸¡',0),(388683,10797,'hi','à¤•à¥‹à¤ˆ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€à¤‚',0),(388684,10797,'ms','Tiada fail dijumpai',0),(388685,10797,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ù„ÙØ§Øª',0),(388686,10797,'fr','Aucun fichier trouvÃ©',0),(388687,10797,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(388688,10797,'pt','Nenhum arquivo encontrado',0),(388689,10797,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(388690,10797,'es','No se EncontrÃ³ Archivos',0),(388691,10797,'de','Keine Dateien gefunden',0),(388692,10797,'en','No Files Found',0),(388693,10798,'is','',0),(388694,10798,'dr','Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ',0),(388695,10798,'pr','Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ',0),(388696,10798,'tr','TarafÄ±ndan yÃ¼kledi',0),(388697,10798,'pl','PrzesÅ‚ane przez',0),(388698,10798,'bg','ÐšÐ°Ñ‡ÐµÐ½ Ð¾Ñ‚',0),(388699,10798,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ù¾ Ù„ÙˆÚˆ',0),(388700,10798,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð¸Ñ‚Ð¸ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(388701,10798,'vi','Táº£i báº±ng cÃ¡ch',0),(388702,10798,'af','Opgelaai Deur',0),(388703,10798,'ro','ÃŽncÄƒrcat de',0),(388704,10798,'et','Uploaded By',0),(388705,10798,'si','Dodal',0),(388706,10798,'ba','Diunggah oleh',0),(388707,10798,'nl','GeÃ¼pload door',0),(388708,10798,'fi','Lataaja',0),(388709,10798,'no','Lastet opp av',0),(388710,10798,'da','Uploadet af',0),(388711,10798,'ko','ì—…ë¡œë“œ',0),(388712,10798,'he','×”×•×¢×œ×” ×¢\"×™',0),(388713,10798,'el','ÎœÎµÏ„Î±Ï†ÏŒÏÏ„Ï‰ÏƒÎ· Î±Ï€ÏŒ',0),(388714,10798,'zh','ä¸Šä¼ \r\n',0),(388715,10798,'sv','Uppladdad av',0),(388716,10798,'it','Caricato da',0),(388717,10798,'tl','',0),(388718,10798,'th','à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¹‚à¸”à¸¢',0),(388719,10798,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(388720,10798,'ms','Uploaded By',0),(388721,10798,'ar','Ø­Ù…Ù‘Ù„ Ø¨ÙˆØ§Ø³Ø·Ø©',0),(388722,10798,'fr','PostÃ© par',0),(388723,10798,'jp','ã«ã‚ˆã£ã¦ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã•ã‚Œã¾ã—ãŸã€‚',0),(388724,10798,'pt','Carregado por',0),(388725,10798,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ðµ',0),(388726,10798,'es','Subido Por',0),(388727,10798,'de','Hochgeladen von',0),(388728,10798,'en','Uploaded By',0),(388729,10799,'is','',0),(388730,10799,'dr','Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ø±Ø¨Ø± ',0),(388731,10799,'pr','Ú¯Ø±ÙˆÙ‡ ÙƒØ§Ø±Ø¨Ø± ',0),(388732,10799,'tr','KullanÄ±cÄ± grubu',0),(388733,10799,'pl','Grupy uÅ¼ytkownika',0),(388734,10799,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ° Ð³Ñ€ÑƒÐ¿Ð°',0),(388735,10799,'ur','ØµØ§Ø±Ù Ú¯Ø±ÙˆÙ¾',0),(388736,10799,'sr','Ð“Ñ€ÑƒÐ¿Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(388737,10799,'vi','NhÃ³m ngÆ°á»i dÃ¹ng',0),(388738,10799,'af','Gebruikergroep',0),(388739,10799,'ro','Grup de utilizatori',0),(388740,10799,'et','Kasutajagrupp',0),(388741,10799,'si','Skupina uporabnikov',0),(388742,10799,'ba','Kelompok pengguna',0),(388743,10799,'nl','Gebruikersgroep',0),(388744,10799,'fi','KÃ¤yttÃ¤jÃ¤ryhmÃ¤',0),(388745,10799,'no','Brukergruppe',0),(388746,10799,'da','Brugergruppe',0),(388747,10799,'ko','ì‚¬ìš©ìž ê·¸ë£¹',0),(388748,10799,'he','×§×‘×•×¦×ª ×ž×©×ª×ž×©',0),(388749,10799,'el','ÎŸÎ¼Î¬Î´Î± Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½',0),(388750,10799,'zh','ç”¨æˆ·ç»„\r\n',0),(388751,10799,'sv','User Group',0),(388752,10799,'it','Gruppo di utenti',0),(388753,10799,'tl','',0),(388754,10799,'th','à¸à¸¥à¸¸à¹ˆà¸¡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(388755,10799,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¤®à¥‚à¤¹',0),(388756,10799,'ms','Kumpulan pengguna',0),(388757,10799,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(388758,10799,'fr','Groupe d\'utilisateurs',0),(388759,10799,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ ã‚°ãƒ«ãƒ¼ãƒ—',0),(388760,10799,'pt','Grupo de usuÃ¡rios',0),(388761,10799,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(388762,10799,'es','Grupo de Usuario',0),(388763,10799,'de','Benutzergruppe',0),(388764,10799,'en','User Group',0),(388765,10800,'is','',0),(388766,10800,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(388767,10800,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(388768,10800,'tr','Bordro verilerini yÃ¼kleme',0),(388769,10800,'pl','Pobieranie danych listy pÅ‚ac',0),(388770,10800,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸',0),(388771,10800,'ur','Ù¾Û’ Ø±ÙˆÙ„ ÚˆÛŒÙ¹Ø§ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(388772,10800,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð³ ÑÐ¿Ð¸ÑÐºÐ°',0),(388773,10800,'vi','Táº£i dá»¯ liá»‡u lÆ°Æ¡ng',0),(388774,10800,'af','Aflaai van Loonrol Data',0),(388775,10800,'ro','DescÄƒrcarea de date de salarizare',0),(388776,10800,'et','Lae palgaandmed',0),(388777,10800,'si','Prenos podatkov na izplaÄane plaÄe',0),(388778,10800,'ba','Men-download Data penggajian',0),(388779,10800,'nl','Payroll-Data downloaden',0),(388780,10800,'fi','Imuroi palkkatiedot',0),(388781,10800,'no','Last ned lÃ¸nnsdata',0),(388782,10800,'da','Download lÃ¸ndata',0),(388783,10800,'ko','ê¸‰ì—¬ ë°ì´í„°ë¥¼ ë‹¤ìš´ë¡œë“œ',0),(388784,10800,'he','×œ×”×•×¨×™×“ × ×ª×•× ×™ ×©×›×¨',0),(388785,10800,'el','Î›Î®ÏˆÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(388786,10800,'zh','è–ªé‡‘æ•°æ®ä¸‹è½½\r\n',0),(388787,10800,'sv','HÃ¤mta lÃ¶nedata',0),(388788,10800,'it','Scarica dati paghe',0),(388789,10800,'tl','',0),(388790,10800,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(388791,10800,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤¡à¤¾à¤Ÿà¤¾ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡',0),(388792,10800,'ms','Muat turun Data senarai gaji',0),(388793,10800,'ar','ØªØ­Ù…ÙŠÙ„ Ø¨ÙŠØ§Ù†Ø§Øª ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(388794,10800,'fr','TÃ©lÃ©charger les donnÃ©es de paie',0),(388795,10800,'jp','çµ¦ä¸Žãƒ‡ãƒ¼ã‚¿ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(388796,10800,'pt','Download de dados de folha de pagamento',0),(388797,10800,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ð”Ð°Ð½Ð½Ñ‹Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð¾Ð¹ Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸',0),(388798,10800,'es','Descargar Datos de Nomina',0),(388799,10800,'de','Download Abrechnungsdaten',0),(388800,10800,'en','Download Payroll Data',0),(388801,10801,'is','',0),(388802,10801,'dr','(Ø«Ø¨Øª Ø®Ø±ÙˆØ¬',0),(388803,10801,'pr','Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ (Ø«Ø¨Øª Ø®Ø±ÙˆØ¬',0),(388804,10801,'tr','Oturum kapatÄ±ldÄ±',0),(388805,10801,'pl','Wylogowanie',0),(388806,10801,'bg','Ð˜Ð·Ð»ÐµÐ·Ð»Ð¸',0),(388807,10801,'ur','Ø³Ø§Ø¦Ù†',0),(388808,10801,'sr','ÐžÐ´Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð¸',0),(388809,10801,'vi','ÄÄƒng xuáº¥t',0),(388810,10801,'af','Afgeteken',0),(388811,10801,'ro','Deconectat',0),(388812,10801,'et','VÃ¤lja loginud',0),(388813,10801,'si','Izpisani',0),(388814,10801,'ba','Sign Out',0),(388815,10801,'nl','Afgemeld',0),(388816,10801,'fi','Kirjautunut ulos',0),(388817,10801,'no','Logget av',0),(388818,10801,'da','Underskrevet',0),(388819,10801,'ko','ë¡œê·¸ ì•„ì›ƒ',0),(388820,10801,'he','×”×•×¦×™×',0),(388821,10801,'el','Î•ÎºÏ„ÏŒÏ‚ ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚',0),(388822,10801,'zh','ç™»å‡º\r\n',0),(388823,10801,'sv','Loggat ut',0),(388824,10801,'it','Firmato',0),(388825,10801,'tl','',0),(388826,10801,'th','à¸­à¸­à¸à¸ˆà¸²à¸à¸£à¸°à¸šà¸š',0),(388827,10801,'hi','à¤¸à¤¾à¤‡à¤¨ à¤†à¤‰à¤Ÿ',0),(388828,10801,'ms','Didaftar Keluar',0),(388829,10801,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬',0),(388830,10801,'fr','DÃ©connectÃ©',0),(388831,10801,'jp','ã‚µã‚¤ãƒ³ã‚¢ã‚¦ãƒˆ',0),(388832,10801,'pt','Assinado para fora',0),(388833,10801,'ru','Ð˜Ð· Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ð°',0),(388834,10801,'es','Se AnotÃ³ al salir ',0),(388835,10801,'de','Abgemeldet',0),(388836,10801,'en','Signed Out',0),(388837,10802,'is','',0),(388838,10802,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(388839,10802,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ Ø·Ø¨Ù‚',0),(388840,10802,'tr','TarafÄ±ndan imzalanmÄ±ÅŸ',0),(388841,10802,'pl','Podpisanym przez',0),(388842,10802,'bg','Ð˜Ð·Ð»ÐµÐ·Ð»Ð¸ Ð¾Ñ‚',0),(388843,10802,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¯Ø³ØªØ®Ø· Ø´Ø¯Û',0),(388844,10802,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ°Ð¾',0),(388845,10802,'vi','ÄÄƒng xuáº¥t bá»Ÿi',0),(388846,10802,'af','Afgeteken deur',0),(388847,10802,'ro','Semnat de',0),(388848,10802,'et','Poolt allkirjastatud',0),(388849,10802,'si','Izpisani z',0),(388850,10802,'ba','Sign Out oleh',0),(388851,10802,'nl','Afgemeld door',0),(388852,10802,'fi','Allekirjoittaa rikki luona',0),(388853,10802,'no','Signert av',0),(388854,10802,'da','Underskrevet af',0),(388855,10802,'ko','ì— ì˜í•´ ì„œëª…',0),(388856,10802,'he','×‘×—×ª×™×ž×ª',0),(388857,10802,'el','Î‘Ï€Î¿ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯ Î±Ï€ÏŒ',0),(388858,10802,'zh','æŒ‰ç™»å‡º\r\n',0),(388859,10802,'sv','Undertecknad av',0),(388860,10802,'it','Firmato da',0),(388861,10802,'tl','',0),(388862,10802,'th','à¸­à¸­à¸à¸ˆà¸²à¸à¸£à¸°à¸šà¸šà¹‚à¸”à¸¢',0),(388863,10802,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤¿à¤¤',0),(388864,10802,'ms','Didaftar keluar oleh',0),(388865,10802,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬ Ù…Ù†',0),(388866,10802,'fr','DÃ©connectÃ© par',0),(388867,10802,'jp','ã«ã‚ˆã£ã¦ã‚µã‚¤ãƒ³ã‚¢ã‚¦ãƒˆ',0),(388868,10802,'pt','Autorizado por',0),(388869,10802,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(388870,10802,'es','Se AnotÃ³ al salir Por',0),(388871,10802,'de','Von abgemeldet',0),(388872,10802,'en','Signed Out By',0),(388873,10803,'is','',0),(388874,10803,'dr','(Ø«Ø¨Øª ÙˆØ±ÙˆØ¯) Ø§ÙŠÙ† Ù‚Ø³Ù…Øª Ø§Ø² ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(388875,10803,'pr','Ø«Ø¨Øª Ù†Ø§Ù… (Ø«Ø¨Øª ÙˆØ±ÙˆØ¯) Ø§ÙŠÙ† Ù‚Ø³Ù…Øª Ø§Ø² ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(388876,10803,'tr','Ekipman bu parÃ§a imzalamak',0),(388877,10803,'pl','Zarejestruj siÄ™ w ten kawaÅ‚ek sprzÄ™tu',0),(388878,10803,'bg','Ð’Ð»ÐµÐ·Ñ‚Ðµ Ð² Ñ‚Ð°Ð·Ð¸ Ñ‡Ð°ÑÑ‚ Ð¾Ñ‚ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½ÐµÑ‚Ð¾',0),(388879,10803,'ur','Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ú©Ø§ ÛŒÛ Ù¹Ú©Ú‘Ø§ Ù…ÛŒÚº Ø³Ø§Ø¦Ù† Ø§Ù† Ú©Ø±ÛŒÚº',0),(388880,10803,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ ÐºÐ¾Ð¼Ð°Ð´ Ð¾Ð¿Ñ€ÐµÐ¼Ðµ',0),(388881,10803,'vi','ÄÄƒng nháº­p vÃ o thiáº¿t bá»‹ nÃ y',0),(388882,10803,'af','Teken In hierdie stuk toerusting',0),(388883,10803,'ro','ConectaÅ£i-vÄƒ aceastÄƒ piesÄƒ de echipament',0),(388884,10803,'et','See seade sisse',0),(388885,10803,'si','Vpis v ta kos opreme',0),(388886,10803,'ba','Masuk ini sepotong peralatan',0),(388887,10803,'nl','Meld u bij dit stuk van apparatuur',0),(388888,10803,'fi','Kirjaudu sisÃ¤Ã¤n varuste',0),(388889,10803,'no','Logge pÃ¥ dette stykke utstyr',0),(388890,10803,'da','Log pÃ¥ dette stykke udstyr',0),(388891,10803,'ko','ìž¥ë¹„ì˜ì´ ì¡°ê°ì€ì— ë¡œê·¸ì¸',0),(388892,10803,'he','×›× ×™×¡×” ×–×• ×—×ª×™×›×ª ×¦×™×•×“',0),(388893,10803,'el','Î•Î³Î³ÏÎ±Ï†ÎµÎ¯Ï„Îµ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ Ï„Î¿Ï… ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼Î¿Ï',0),(388894,10803,'zh','æƒ³åœ¨è¿™å°è®¾å¤‡\r\n',0),(388895,10803,'sv','Logga In denna del av utrustningen',0),(388896,10803,'it','Firmare In questo pezzo di equipaggiamento',0),(388897,10803,'tl','',0),(388898,10803,'th','à¸¥à¸‡à¹ƒà¸™à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸Šà¸´à¹‰à¸™à¸™à¸µà¹‰',0),(388899,10803,'hi','à¤‰à¤ªà¤•à¤°à¤£à¥‹à¤‚ à¤•à¥‡ à¤‡à¤¸ à¤Ÿà¥à¤•à¤¡à¤¼à¥‡ à¤®à¥‡à¤‚ à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(388900,10803,'ms','Masuk ini',0),(388901,10803,'ar','Ù‚Ù… Ø¨ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ù‡Ø°Ø§ Ø§Ù„Ù‚Ø·Ø¹Ø© Ù…Ù† Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(388902,10803,'fr','Connectez-vous Ã  cette piÃ¨ce d\'Ã©quipement',0),(388903,10803,'jp','æ©Ÿå™¨ã®ã“ã®ä½œå“ã«ã‚µã‚¤ãƒ³ã‚¤ãƒ³ã—ã¾ã™ã€‚',0),(388904,10803,'pt','Cadastre-se neste pedaÃ§o de equipamento',0),(388905,10803,'ru','Ð’Ñ…Ð¾Ð´ Ð² ÑÑ‚Ñƒ Ñ‡Ð°ÑÑ‚ÑŒ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(388906,10803,'es','Anotarse al Entrar Esta Pieza de Equipo',0),(388907,10803,'de','Melden Sie In diesem GerÃ¤t',0),(388908,10803,'en','Sign In This Piece of Equipment',0),(388909,10804,'is','',0),(388910,10804,'dr','(Ø«Ø¨Øª Ø®Ø±ÙˆØ¬) Ø§ÙŠÙ† Ù‚Ø³Ù…Øª Ø§Ø² ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(388911,10804,'pr','Ø«Ø¨Øª Ù†Ø§Ù… (Ø«Ø¨Øª Ø®Ø±ÙˆØ¬) Ø§ÙŠÙ† Ù‚Ø³Ù…Øª Ø§Ø² ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(388912,10804,'tr','Ekipman bu parÃ§a oturum',0),(388913,10804,'pl','PodpisywaÄ‡ siÄ™ ten kawaÅ‚ek sprzÄ™tu',0),(388914,10804,'bg','Ð˜Ð·Ð»ÐµÐ·Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ñ‡Ð°ÑÑ‚ Ð¾Ñ‚ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½ÐµÑ‚Ð¾',0),(388915,10804,'ur','Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ú©Ø§ ÛŒÛ Ù¹Ú©Ú‘Ø§ Ø¨Ø§ÛØ± Ø³Ø§Ø¦Ù† Ø§Ù† Ú©Ø±ÛŒÚº',0),(388916,10804,'sr','ÐžÐ´Ñ˜Ð°Ð²Ð¸ ÑÐµ Ð¾Ð²Ð°Ñ˜ ÐºÐ¾Ð¼Ð°Ð´ Ð¾Ð¿Ñ€ÐµÐ¼Ðµ',0),(388917,10804,'vi','ÄÄƒng xuáº¥t vÃ o thiáº¿t bá»‹ nÃ y',0),(388918,10804,'af','Teken uit hierdie stuk toerusting',0),(388919,10804,'ro','DeconectaÅ£i-vÄƒ aceastÄƒ piesÄƒ de echipament',0),(388920,10804,'et','See seade vÃ¤lja',0),(388921,10804,'si','IzpiÅ¡ite ta kos opreme',0),(388922,10804,'ba','Keluar ini bagian dari peralatan',0),(388923,10804,'nl','Meld u af deze stuk van apparatuur',0),(388924,10804,'fi','Kirjaudu ulos varuste',0),(388925,10804,'no','Logg denne stykke utstyret',0),(388926,10804,'da','Logge ud dette stykke udstyr',0),(388927,10804,'ko','ìž¥ë¹„ì˜ì´ ì¡°ê°ì„ ë°–ìœ¼ë¡œ ì„œëª…',0),(388928,10804,'he','×™×¦×™××” ×–×• ×—×ª×™×›×ª ×¦×™×•×“',0),(388929,10804,'el','Î•Î¾Î­Î»Î¸ÎµÏ„Îµ Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ Ï„Î¿Ï… ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼Î¿Ï',0),(388930,10804,'zh','ç™»å‡ºè¿™å°è®¾å¤‡\r\n',0),(388931,10804,'sv','Logga ut denna del av utrustningen',0),(388932,10804,'it','Esci da questo pezzo di equipaggiamento',0),(388933,10804,'tl','',0),(388934,10804,'th','à¸­à¸­à¸à¸ˆà¸²à¸à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸Šà¸´à¹‰à¸™à¸™à¸µà¹‰',0),(388935,10804,'hi','à¤‰à¤ªà¤•à¤°à¤£à¥‹à¤‚ à¤•à¤¾ à¤¯à¤¹ à¤Ÿà¥à¤•à¤¡à¤¼à¤¾ à¤¬à¤¾à¤¹à¤° à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(388936,10804,'ms','Daftar keluar ini',0),(388937,10804,'ar','Ù‚Ù… Ø¨ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬ Ù‡Ø°Ø§ Ø§Ù„Ù‚Ø·Ø¹Ø© Ù…Ù† Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(388938,10804,'fr','Cette piÃ¨ce d\'Ã©quipement se dÃ©connecter',0),(388939,10804,'jp','æ©Ÿå™¨ã®ã“ã®ä½œå“ã‚’ã‚µã‚¤ãƒ³ã‚¢ã‚¦ãƒˆã—ã¾ã™ã€‚',0),(388940,10804,'pt','Assinar este pedaÃ§o de equipamento',0),(388941,10804,'ru','Ð’Ñ‹Ð¹Ñ‚Ð¸ Ð¸Ð· ÑÑ‚Ð¾Ð³Ð¾ Ñ‡Ð°ÑÑ‚ÑŒ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(388942,10804,'es','Anotarse al Salir Esta Pieza de Equipo',0),(388943,10804,'de','Melden Sie sich dieses StÃ¼ck AusrÃ¼stung',0),(388944,10804,'en','Sign Out This Piece of Equipment',0),(388945,10805,'is','',0),(388946,10805,'dr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(388947,10805,'pr','Ù†Ù…Ø§ÙŠØ´ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ ',0),(388948,10805,'tr','GÃ¶rÃ¼nÃ¼m PO',0),(388949,10805,'pl','Widok PO',0),(388950,10805,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¿Ð¾',0),(388951,10805,'ur','Ù…Ù†Ø¸Ø± Ù¾Ùˆ',0),(388952,10805,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐŸÐž',0),(388953,10805,'vi','Xem Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(388954,10805,'af','Besigtig AB',0),(388955,10805,'ro','Vezi PO',0),(388956,10805,'et','Vaade PO',0),(388957,10805,'si','Pogled PO',0),(388958,10805,'ba','Lihat PO',0),(388959,10805,'nl','Weergave PO',0),(388960,10805,'fi','Katso PO',0),(388961,10805,'no','Vis PO',0),(388962,10805,'da','Se PO',0),(388963,10805,'ko','ë³´ê¸° í¬',0),(388964,10805,'he','×ª×¦×•×’×ª ×¤×•',0),(388965,10805,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Î½Î¬',0),(388966,10805,'zh','æŸ¥çœ‹è®¢å•\r\n',0),(388967,10805,'sv','Visa PO',0),(388968,10805,'it','Vista PO',0),(388969,10805,'tl','',0),(388970,10805,'th','à¸”à¸¹ PO',0),(388971,10805,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤ªà¥‹',0),(388972,10805,'ms','View PO',0),(388973,10805,'ar','Øµ. Ø¨ Ø§Ù„Ø¹Ø±Ø¶',0),(388974,10805,'fr','Vue PO',0),(388975,10805,'jp','ãƒ“ãƒ¥ãƒ¼ ãƒãƒ¼',0),(388976,10805,'pt','Vista PO',0),(388977,10805,'ru','Ð’Ð¸Ð´ PO',0),(388978,10805,'es','Vistar el OP',0),(388979,10805,'de','Ansicht-PO',0),(388980,10805,'en','View PO',0),(388981,10806,'is','',0),(388982,10806,'dr','Ø«Ø¨Øª ÙˆØ±ÙˆØ¯  ØªØ¬Ù‡ÙŠØ²Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(388983,10806,'pr','Ø«Ø¨Øª ÙˆØ±ÙˆØ¯  ØªØ¬Ù‡ÙŠØ²Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(388984,10806,'tr','Ekipman oturum aÃ§ma baÅŸarÄ±sÄ±z oldu',0),(388985,10806,'pl','Znak urzÄ…dzenia nie powiodÅ‚o siÄ™',0),(388986,10806,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ Ð·Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð½Ðµ ÑƒÑÐ¿Ñ',0),(388987,10806,'ur','Ù…ÛŒÚº Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ø³Ø§Ø¦Ù† Ø§Ù† Ù†Ø§Ú©Ø§Ù…',0),(388988,10806,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ðµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(388989,10806,'vi','KÃ½ hiá»‡u thiáº¿t bá»‹ tháº¥t báº¡i',0),(388990,10806,'af','Toerusting teken In het misluk',0),(388991,10806,'ro','Echipament Sign In nereuÅŸit',0),(388992,10806,'et','Seadmete sisselogimine nurjus',0),(388993,10806,'si','Oprema za vpis ni uspel',0),(388994,10806,'ba','Peralatan masuk gagal',0),(388995,10806,'nl','Apparatuur aanmelden is mislukt',0),(388996,10806,'fi','Laitteet SisÃ¤Ã¤nkirjautuminen epÃ¤onnistui',0),(388997,10806,'no','Utstyr Logg mislyktes',0),(388998,10806,'da','Udstyr log ind mislykkedes',0),(388999,10806,'ko','ìž¥ë¹„ ë¡œê·¸ì¸ ì‹¤íŒ¨',0),(389000,10806,'he','×¦×™×•×“ ×”×›× ×™×¡×” × ×›×©×œ',0),(389001,10806,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· ÎµÎ¯ÏƒÎ¿Î´Î¿Ï‚ ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼Î¿Ï',0),(389002,10806,'zh','è®¾å¤‡ç™»å½•å¤±è´¥',0),(389003,10806,'sv','Utrustning inloggning misslyckades',0),(389004,10806,'it','Segno di attrezzature nel fallito',0),(389005,10806,'tl','',0),(389006,10806,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(389007,10806,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤®à¥‡à¤‚ à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(389008,10806,'ms','Peralatan Daftar Masuk gagal',0),(389009,10806,'ar','ÙØ´Ù„ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(389010,10806,'fr','Ã‰quipement signe en Ã©chec',0),(389011,10806,'jp','æ©Ÿå™¨ã¯ã€ã‚µã‚¤ãƒ³ã‚¤ãƒ³ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(389012,10806,'pt','Sinal de equipamentos em falha',0),(389013,10806,'ru','Ð¡Ð±Ð¾Ð¹ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ Ð·Ð½Ð°Ðº Ð²',0),(389014,10806,'es','Equipo Entrada por Firma FallÃ³',0),(389015,10806,'de','AusrÃ¼stung \"Anmelden\" ist fehlgeschlagen',0),(389016,10806,'en','Equipment Sign In Failed',0),(389017,10807,'is','',0),(389018,10807,'dr','Ø«Ø¨Øª ÙˆØ±ÙˆØ¯ ØªØ¬Ù‡ÙŠØ²Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(389019,10807,'pr','Ø«Ø¨Øª ÙˆØ±ÙˆØ¯ ØªØ¬Ù‡ÙŠØ²Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(389020,10807,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde oturum ekipmanlarÄ±',0),(389021,10807,'pl','UrzÄ…dzenie pomyÅ›lnie zalogowany',0),(389022,10807,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ Ð·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(389023,10807,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø³Ø§Ø¦Ù† Ø§Ù† Ú©Ø§ Ø³Ø§Ù…Ø§Ù†',0),(389024,10807,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ð½ Ñƒ',0),(389025,10807,'vi','KÃ½ hiá»‡u thiáº¿t bá»‹ vÃ o thÃ nh cÃ´ng',0),(389026,10807,'af','Gereedskap Suksesvol Ingeteken',0),(389027,10807,'ro','Echipament conectat cu succes',0),(389028,10807,'et','Seadmete sisse logitud',0),(389029,10807,'si','Oprema za uspeÅ¡en vpis',0),(389030,10807,'ba','Peralatan masuk berhasil',0),(389031,10807,'nl','Apparatuur met succes is ingelogd',0),(389032,10807,'fi','Laitteiden kirjautunut',0),(389033,10807,'no','Utstyret ble logget',0),(389034,10807,'da','Udstyr underskrevet med succes',0),(389035,10807,'ko','ìž¥ë¹„ì— ì„±ê³µì ìœ¼ë¡œ ë¡œê·¸ì¸',0),(389036,10807,'he','×¦×™×•×“ ×©× ×—×ª× ×‘ ×‘×”×¦×œ×—×”',0),(389037,10807,'el','Î•Î¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚ Ï€Î¿Ï… Ï…Ï€ÎµÎ³ÏÎ¬Ï†Î· ÏƒÏ„Î¿ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(389038,10807,'zh','è£…å¤‡ç™»å…¥æˆåŠŸ\r\n',0),(389039,10807,'sv','Utrustning inloggad framgÃ¥ngsrikt',0),(389040,10807,'it','Attrezzature firmata con successo',0),(389041,10807,'tl','',0),(389042,10807,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸¥à¸‡à¹ƒà¸™à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(389043,10807,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾',0),(389044,10807,'ms','Peralatan yang log masuk berjaya',0),(389045,10807,'ar','Ù…Ø¹Ø¯Ø§Øª ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø¨Ù†Ø¬Ø§Ø­',0),(389046,10807,'fr','Ã‰quipement connectÃ© avec succÃ¨s',0),(389047,10807,'jp','æ­£å¸¸ã«ã‚µã‚¤ãƒ³ã‚¤ãƒ³æ©Ÿå™¨',0),(389048,10807,'pt','Equipamento logado com sucesso',0),(389049,10807,'ru','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½ Ð²',0),(389050,10807,'es','Equipo Entrada por Firma Exitosamente',0),(389051,10807,'de','AusrÃ¼stung erfolgreich eingeloggt',0),(389052,10807,'en','Equipment Signed In Successfully',0),(389053,10808,'is','',0),(389054,10808,'dr','Ø«Ø¨Øª Ø®Ø±ÙˆØ¬ ØªØ¬Ù‡ÙŠØ²Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(389055,10808,'pr','Ø«Ø¨Øª Ø®Ø±ÙˆØ¬ ØªØ¬Ù‡ÙŠØ²Ø§Øª Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(389056,10808,'tr','Ekipman oturum kapatma baÅŸarÄ±sÄ±z oldu',0),(389057,10808,'pl','Equpment znak siÄ™ nie powiodÅ‚o siÄ™',0),(389058,10808,'bg','Ð¦ÐÐœ Ð¸Ð·Ñ…Ð¾Ð´ Ð½Ðµ Ðµ',0),(389059,10808,'ur','Ø§Ù‚Ù¾Ù…Ø§Ù†Ù¹ Ø³Ø§Ø¦Ù† Ø¢Ø¤Ù¹ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§',0),(389060,10808,'sr','Ð•qÑƒÐ¿Ð¼ÐµÐ½Ñ‚ Ð·Ð½Ð°Ðº Ð½Ð°Ð¿Ð¾Ñ™Ñƒ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾.',0),(389061,10808,'vi','Thiáº¿t bá»‹ ra tháº¥t báº¡i',0),(389062,10808,'af','Equpment advertensie uit het misluk',0),(389063,10808,'ro','Equpment Sign Out nu a reuÈ™it',0),(389064,10808,'et','Equpment Logi vÃ¤lja nurjus',0),(389065,10808,'si','Equpment odjava ni uspela',0),(389066,10808,'ba','Equpment keluar gagal',0),(389067,10808,'nl','Equpment afmelden is mislukt',0),(389068,10808,'fi','Equpment Kirjaudu ulos epÃ¤onnistui',0),(389069,10808,'no','Equpment Logg mislyktes',0),(389070,10808,'da','Equpment log ud mislykkedes',0),(389071,10808,'ko','Equpment ë¡œê·¸ ì•„ì›ƒ ì‹¤íŒ¨',0),(389072,10808,'he','Equpment ×™×¦×™××” × ×›×©×œ×”',0),(389073,10808,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· equpment Î­Î¾Î¿Î´Î¿Ï‚',0),(389074,10808,'zh','é“å…·è½¬æ¢ç™»å‡ºå¤±è´¥',0),(389075,10808,'sv','Equpment logga ut misslyckades',0),(389076,10808,'it','Equpment Esci non riuscita',0),(389077,10808,'tl','',0),(389078,10808,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡ Equpment à¸­à¸­à¸à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(389079,10808,'hi','Equpment à¤¸à¤¾à¤‡à¤¨ à¤†à¤‰à¤Ÿ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(389080,10808,'ms','Equpment Daftar keluar gagal',0),(389081,10808,'ar','ÙØ´Ù„ Equpment ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬',0),(389082,10808,'fr','Equpment dÃ©connexion a Ã©chouÃ©',0),(389083,10808,'jp','Equpment ãƒ­ã‚°ã‚¢ã‚¦ãƒˆã«å¤±æ•—ã—ã¾ã—ãŸ',0),(389084,10808,'pt','Falha de sinal equpment fora',0),(389085,10808,'ru','Equpment Ð²Ñ‹Ð¹Ñ‚Ð¸ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(389086,10808,'es','Equipo Salir por firma FallÃ³',0),(389087,10808,'de','Equpment Abmelden ist fehlgeschlagen',0),(389088,10808,'en','Equpment Sign Out Failed',0),(389089,10809,'is','',0),(389090,10809,'dr','(Ø§Ø«Ø§Ø«Ù‡ )  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(389091,10809,'pr','Ø«Ø¨Øª Ø®Ø±ÙˆØ¬  ØªØ¬Ù‡ÙŠØ²Ø§Øª(Ø§Ø«Ø§Ø«Ù‡ )  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(389092,10809,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde oturum ekipmanlarÄ±',0),(389093,10809,'pl','UrzÄ…dzenie pomyÅ›lnie wylogowany',0),(389094,10809,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ, Ð¸Ð·Ð»ÐµÐ·Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(389095,10809,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø³Ø§Ø¦Ù† Ú©Ø§ Ø³Ø§Ù…Ø§Ù†',0),(389096,10809,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¾Ð´Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð¸',0),(389097,10809,'vi','Thiáº¿t bá»‹ ra thÃ nh cÃ´ng',0),(389098,10809,'af','Gereedskap Suksesvol Uitgeteken',0),(389099,10809,'ro','Echipament deconectat cu succes',0),(389100,10809,'et','Seadmed edukalt vÃ¤lja loginud',0),(389101,10809,'si','Oprema, ki se uspeÅ¡no odjavili',0),(389102,10809,'ba','Peralatan sign Out berhasil',0),(389103,10809,'nl','Apparatuur met succes afgemeld',0),(389104,10809,'fi','Laitteet onnistuneesti kirjautunut ulos',0),(389105,10809,'no','Utstyr avlogget vellykket',0),(389106,10809,'da','Udstyr underskrevet med succes',0),(389107,10809,'ko','ì„±ê³µì ìœ¼ë¡œ ë¡œê·¸ ì•„ì›ƒ í•˜ëŠ” ìž¥ë¹„',0),(389108,10809,'he','×¦×™×•×“ ×”×•×¦×™× ×‘×”×¦×œ×—×”',0),(389109,10809,'el','Î•Î¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚ ÎµÎºÏ„ÏŒÏ‚ ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(389110,10809,'zh','è®¾å¤‡ç™»å‡ºæˆåŠŸ',0),(389111,10809,'sv','Utrustning loggat ut framgÃ¥ngsrikt',0),(389112,10809,'it','Attrezzature firmata con successo',0),(389113,10809,'tl','',0),(389114,10809,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸—à¸µà¹ˆà¸­à¸­à¸à¸ˆà¸²à¸à¸£à¸°à¸šà¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(389115,10809,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¾à¤‡à¤¨ à¤†à¤‰à¤Ÿ',0),(389116,10809,'ms','Peralatan yang didaftar keluar berjaya',0),(389117,10809,'ar','Ù…Ø¹Ø¯Ø§Øª ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬ Ø¨Ù†Ø¬Ø§Ø­',0),(389118,10809,'fr','Ã‰quipement dÃ©connectÃ© avec succÃ¨s',0),(389119,10809,'jp','è£…ç½®ãŒæ­£å¸¸ã«ã‚µã‚¤ãƒ³ã‚¢ã‚¦ãƒˆ',0),(389120,10809,'pt','Equipamento saiu com sucesso',0),(389121,10809,'ru','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¸Ð· Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(389122,10809,'es','Equipo SaliÃ³ por firma Exitosamente',0),(389123,10809,'de','AusrÃ¼stung erfolgreich abgemeldet',0),(389124,10809,'en','Equipment Signed Out Successfully',0),(389125,10810,'is','',0),(389126,10810,'dr','(Ø§Ø«Ø§Ø«Ù‡',0),(389127,10810,'pr','Ø«Ø¨Øª ÙˆØ±ÙˆØ¯  ØªØ¬Ù‡ÙŠØ²Ø§Øª(Ø§Ø«Ø§Ø«Ù‡',0),(389128,10810,'tr','Ekipman oturum aÃ§ma',0),(389129,10810,'pl','SprzÄ™t Zaloguj',0),(389130,10810,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ Ð·Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(389131,10810,'ur','Ù…ÛŒÚº Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ú©ÛŒ Ù†Ø´Ø§Ù†ÛŒ',0),(389132,10810,'sr','Ð—Ð½Ð°Ðº Ð¾Ð¿Ñ€ÐµÐ¼Ðµ Ñƒ',0),(389133,10810,'vi','KÃ½ hiá»‡u thiáº¿t bá»‹ vÃ o',0),(389134,10810,'af','Toerusting teken In',0),(389135,10810,'ro','Echipament de conectare',0),(389136,10810,'et','Seadmete sisselogimine',0),(389137,10810,'si','Oprema za vpis',0),(389138,10810,'ba','Peralatan masuk',0),(389139,10810,'nl','Apparatuur inloggen',0),(389140,10810,'fi','Laitteet merkki',0),(389141,10810,'no','Utstyr pÃ¥loggingsprogrammet',0),(389142,10810,'da','Udstyr tegn i',0),(389143,10810,'ko','ìž¥ë¹„ ë¡œê·¸ì¸',0),(389144,10810,'he','×¦×™×•×“ ×”×™×›× ×¡',0),(389145,10810,'el','Î•Î¯ÏƒÎ¿Î´Î¿Ï‚ ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼Î¿Ï',0),(389146,10810,'zh','è®¾å¤‡ç™»å…¥',0),(389147,10810,'sv','Utrustning Logga In',0),(389148,10810,'it','Segno di attrezzature In',0),(389149,10810,'tl','',0),(389150,10810,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¹ƒà¸™',0),(389151,10810,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤®à¥‡à¤‚ à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(389152,10810,'ms','Peralatan Daftar Masuk',0),(389153,10810,'ar','Ù…Ø¹Ø¯Ø§Øª ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(389154,10810,'fr','Signe d\'Ã©quipement en',0),(389155,10810,'jp','æ©Ÿå™¨ã®ã‚µã‚¤ãƒ³ã‚¤ãƒ³',0),(389156,10810,'pt','Sinal de equipamento em',0),(389157,10810,'ru','Ð—Ð½Ð°Ðº Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ Ð²',0),(389158,10810,'es','Equipo Entrar por firma',0),(389159,10810,'de','AusrÃ¼stung \"Anmelden\"',0),(389160,10810,'en','Equipment Sign In',0),(389161,10811,'is','',0),(389162,10811,'dr','Ø«Ø¨Øª Ø®Ø±ÙˆØ¬ ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(389163,10811,'pr','Ø«Ø¨Øª Ø®Ø±ÙˆØ¬ ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(389164,10811,'tr','Ekipman oturumu kapat',0),(389165,10811,'pl','SprzÄ™t Wyloguj',0),(389166,10811,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ Ð·Ð° Ð¸Ð·Ñ…Ð¾Ð´',0),(389167,10811,'ur','Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ø³Ø§Ø¦Ù† Ø¢Ø¤Ù¹',0),(389168,10811,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð° Ð·Ð½Ð°Ðº Ð½Ð°Ð¿Ð¾Ñ™Ñƒ',0),(389169,10811,'vi','KÃ½ hiá»‡u thiáº¿t bá»‹ ra',0),(389170,10811,'af','Toerusting teken uit',0),(389171,10811,'ro','Echipament de Sign Out',0),(389172,10811,'et','Seadmete Logi vÃ¤lja',0),(389173,10811,'si','Oprema odjava',0),(389174,10811,'ba','Peralatan keluar',0),(389175,10811,'nl','Apparatuur afmelden',0),(389176,10811,'fi','Laitteiden Kirjaudu ulos',0),(389177,10811,'no','Utstyr Logg',0),(389178,10811,'da','Udstyr log ud',0),(389179,10811,'ko','ìž¥ë¹„ ë¡œê·¸ ì•„ì›ƒ',0),(389180,10811,'he','×¦×™×•×“ ×™×¦×™××”',0),(389181,10811,'el','Î•Î¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚ Î­Î¾Î¿Î´Î¿Ï‚',0),(389182,10811,'zh','è®¾å¤‡ç™»å‡º',0),(389183,10811,'sv','Utrustning logga ut',0),(389184,10811,'it','Attrezzatura Esci',0),(389185,10811,'tl','',0),(389186,10811,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸­à¸­à¸',0),(389187,10811,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤¸à¤¾à¤‡à¤¨ à¤†à¤‰à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(389188,10811,'ms','Peralatan Daftar keluar',0),(389189,10811,'ar','Ù…Ø¹Ø¯Ø§Øª ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬',0),(389190,10811,'fr','DÃ©connexion de matÃ©riel',0),(389191,10811,'jp','æ©Ÿå™¨ã®ã‚µã‚¤ãƒ³ã‚¢ã‚¦ãƒˆ',0),(389192,10811,'pt','Sinal de equipamento fora',0),(389193,10811,'ru','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð²Ñ‹Ð¹Ñ‚Ð¸',0),(389194,10811,'es','Equipo Salir por firma',0),(389195,10811,'de','GerÃ¤te abmelden',0),(389196,10811,'en','Equipment Sign Out',0),(389197,10812,'is','',0),(389198,10812,'dr','Ø¯Ø± Ø§ÙŠÙ† Ù‚Ø³Ù…Øª ØªØ¹Ù‡Ø¯Ø§Øª Ø±Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†ÙŠØ¯ ',0),(389199,10812,'pr','Ø¯Ø± Ø§ÙŠÙ† Ù‚Ø³Ù…Øª ØªØ¹Ù‡Ø¯Ø§Øª Ø±Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†ÙŠØ¯ ',0),(389200,10812,'tr','Ekipman bu parÃ§a giriÅŸ yapmalÄ±sÄ±nÄ±z',0),(389201,10812,'pl','NaleÅ¼y zarejestrowaÄ‡ w ten kawaÅ‚ek sprzÄ™tu',0),(389202,10812,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²Ð»ÐµÐ·ÐµÑ‚Ðµ Ð² Ñ‚Ð°Ð·Ð¸ Ñ‡Ð°ÑÑ‚ Ð¾Ñ‚ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½ÐµÑ‚Ð¾',0),(389203,10812,'ur','Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ú©Ø§ ÛŒÛ Ù¹Ú©Ú‘Ø§ Ù…ÛŒÚº Ø³Ø§Ø¦Ù† Ø§Ù† Ú©Ø±ÛŒÚº',0),(389204,10812,'sr','ÐœÐ¾Ñ€Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸ Ð¾Ð²Ð°Ñ˜ ÐºÐ¾Ð¼Ð°Ð´ Ð¾Ð¿Ñ€ÐµÐ¼Ðµ',0),(389205,10812,'vi','Pháº£i Ä‘Ã¡nh vÃ o pháº§n cá»§a thiáº¿t bá»‹',0),(389206,10812,'af','In hierdie stuk toerusting moet onderteken',0),(389207,10812,'ro','Trebuie sÄƒ semneze Ã®n aceastÄƒ piesÄƒ de echipament',0),(389208,10812,'et','See seade peab alla kirjutama',0),(389209,10812,'si','Vpisati se morate ta kos opreme',0),(389210,10812,'ba','Harus masuk ini sepotong peralatan',0),(389211,10812,'nl','Dit stuk van apparatuur moet inloggen',0),(389212,10812,'fi','On allekirjoitettava varuste',0),(389213,10812,'no','MÃ¥ logge pÃ¥ dette stykke utstyr',0),(389214,10812,'da','Skal underskrive i dette stykke udstyr',0),(389215,10812,'ko','ìž¥ë¹„ì˜ì´ ì¡°ê°ì€ì— ë¡œê·¸ì¸ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(389216,10812,'he','×¢×œ×™×š ×œ×”×™×›× ×¡ ×–×” ×—×ª×™×›×ª ×¦×™×•×“',0),(389217,10812,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ¿Î¼Î¼Î¬Ï„Î¹ Ï„Î¿Ï… ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼Î¿Ï',0),(389218,10812,'zh','å¿…é¡»ç™»å½•è¿™å°è®¾å¤‡\r\n',0),(389219,10812,'sv','MÃ¥ste logga in denna del av utrustningen',0),(389220,10812,'it','Devono firmare in questo pezzo di equipaggiamento',0),(389221,10812,'tl','',0),(389222,10812,'th','à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸Šà¸´à¹‰à¸™à¸ªà¹ˆà¸§à¸™à¸‚à¸­à¸‡à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸™à¸µà¹‰',0),(389223,10812,'hi','à¤‰à¤ªà¤•à¤°à¤£à¥‹à¤‚ à¤•à¥‡ à¤‡à¤¸ à¤Ÿà¥à¤•à¤¡à¤¼à¥‡ à¤®à¥‡à¤‚ à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(389224,10812,'ms','Mesti mendaftar masuk ini',0),(389225,10812,'ar','ÙˆÙŠØ¬Ø¨ Ø£Ù† ÙŠÙˆÙ‚Ø¹ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù‚Ø·Ø¹Ø© Ù…Ù† Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(389226,10812,'fr','Doit signer dans cette piÃ¨ce d\'Ã©quipement',0),(389227,10812,'jp','æ©Ÿå™¨ã®ã“ã®éƒ¨åˆ†ã«ç½²åã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(389228,10812,'pt','Deve assinar nesta peÃ§a de equipamento',0),(389229,10812,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð¾Ð¹Ñ‚Ð¸ Ð² ÑÑ‚Ñƒ Ñ‡Ð°ÑÑ‚ÑŒ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(389230,10812,'es','Debe Entrar Este Pieza de Equipo por Firma',0),(389231,10812,'de','MÃ¼ssen in diesem GerÃ¤t anmelden',0),(389232,10812,'en','Must Sign in This Piece of Equipment',0),(389233,10813,'is','',0),(389234,10813,'dr','Ù„Ø·ÙØ§ ØªØ¬Ù‡ÙŠØ²Ø§Øª Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(389235,10813,'pr','Ù„Ø·ÙØ§ ØªØ¬Ù‡ÙŠØ²Ø§Øª Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(389236,10813,'tr','LÃ¼tfen ekipman dahil',0),(389237,10813,'pl','ProszÄ™ podaÄ‡ sprzÄ™t',0),(389238,10813,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ',0),(389239,10813,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø³Ø§Ø²ÙˆØ³Ø§Ù…Ø§Ù† Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(389240,10813,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¾Ð¿Ñ€ÐµÐ¼Ðµ',0),(389241,10813,'vi','vui lÃ²ng bao gá»“m thiáº¿t bá»‹',0),(389242,10813,'af','Sluit asb. Gereedskap in',0),(389243,10813,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i echipamente',0),(389244,10813,'et','Palun lisage seadmed',0),(389245,10813,'si','Prosimo, da vkljuÄite oprema',0),(389246,10813,'ba','Harap sertakan peralatan',0),(389247,10813,'nl','Gelieve te omvatten apparatuur',0),(389248,10813,'fi','SisÃ¤llytÃ¤ laitteet',0),(389249,10813,'no','Ta med utstyr',0),(389250,10813,'da','VedlÃ¦g udstyr',0),(389251,10813,'ko','ìž¥ë¹„ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(389252,10813,'he','×× × ×›×œ×•×œ ×¦×™×•×“',0),(389253,10813,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚',0),(389254,10813,'zh','è¯·åˆ—å…¥è®¾å¤‡\r\n',0),(389255,10813,'sv','VÃ¤nligen inkludera utrustning',0),(389256,10813,'it','Si prega di includere attrezzature',0),(389257,10813,'tl','',0),(389258,10813,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸­à¸¸à¸›à¸à¸£à¸“à¹Œ',0),(389259,10813,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤‰à¤ªà¤•à¤°à¤£ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(389260,10813,'ms','Sila sertakan peralatan',0),(389261,10813,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(389262,10813,'fr','Veuillez inclure les Ã©quipements',0),(389263,10813,'jp','æ©Ÿå™¨ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(389264,10813,'pt','Por favor inclua o equipamento',0),(389265,10813,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(389266,10813,'es','Por Favor Incluye Equipo',0),(389267,10813,'de','Bitte geben Sie AusrÃ¼stung',0),(389268,10813,'en','Please Include Equipment',0),(389269,10814,'is','',0),(389270,10814,'dr','(Ø«Ø¨Øª ÙˆØ±ÙˆØ¯',0),(389271,10814,'pr','Ø«Ø¨Øª Ù†Ø§Ù… (Ø«Ø¨Øª ÙˆØ±ÙˆØ¯',0),(389272,10814,'tr','Oturum AÃ§',0),(389273,10814,'pl','Rejestrowanie',0),(389274,10814,'bg','Ð’Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(389275,10814,'ur','Ù…ÛŒÚº Ø³Ø§Ø¦Ù† Ø§Ù† Ú©Ø±ÛŒÚº',0),(389276,10814,'sr','ÑƒÐ¿Ð¸ÑˆÐ¸ ÑÐµ',0),(389277,10814,'vi','Ä‘Äƒng nháº­p',0),(389278,10814,'af','Teken aan',0),(389279,10814,'ro','conecteazÄƒ-te',0),(389280,10814,'et','Logi sisse',0),(389281,10814,'si','prijava',0),(389282,10814,'ba','Tandatangan',0),(389283,10814,'nl','Aanmelden',0),(389284,10814,'fi','Kirjaudu sisÃ¤Ã¤n',0),(389285,10814,'no','logg inn',0),(389286,10814,'da','Log pÃ¥',0),(389287,10814,'ko','ë¡œê·¸ì¸',0),(389288,10814,'he','×”×™×¨×©×',0),(389289,10814,'el','Î•Î¯ÏƒÎ¿Î´Î¿Ï‚',0),(389290,10814,'zh','ç™»å½•\r\n',0),(389291,10814,'sv','Logga in',0),(389292,10814,'it','Accedi',0),(389293,10814,'tl','',0),(389294,10814,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(389295,10814,'hi','à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(389296,10814,'ms','daftar masuk',0),(389297,10814,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(389298,10814,'fr','Connexion',0),(389299,10814,'jp','ã‚µã‚¤ãƒ³ã‚¤ãƒ³',0),(389300,10814,'pt','Entrar',0),(389301,10814,'ru','Ð’Ð¾Ð¹Ñ‚Ð¸',0),(389302,10814,'es','Anotarse al Entrar',0),(389303,10814,'de','Anmelden',0),(389304,10814,'en','Sign In',0),(389305,10815,'is','',0),(389306,10815,'dr','(Ø«Ø¨Øª Ø®Ø±ÙˆØ¬',0),(389307,10815,'pr','Ø«Ø¨Øª Ù†Ø§Ù… (Ø«Ø¨Øª Ø®Ø±ÙˆØ¬',0),(389308,10815,'tr','Oturumu Kapat',0),(389309,10815,'pl','Zarejestruj',0),(389310,10815,'bg','Ð˜Ð·Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(389311,10815,'ur','Ø³Ø§Ø¦Ù† Ø¢Ø¤Ù¹ Ú©Ø±ÛŒÚº',0),(389312,10815,'sr','ÐžÐ´Ñ˜Ð°Ð²Ð¸ ÑÐµ',0),(389313,10815,'vi','ÄÄƒng xuáº¥t',0),(389314,10815,'af','Teken',0),(389315,10815,'ro','FaceÅ£i Sign Out',0),(389316,10815,'et','Leia meid Facebook\'ist',0),(389317,10815,'si','Izpisati',0),(389318,10815,'ba','Keluar',0),(389319,10815,'nl','Afmelden',0),(389320,10815,'fi','Kirjaudu ulos',0),(389321,10815,'no','Logg',0),(389322,10815,'da','Log ud',0),(389323,10815,'ko','ë¡œê·¸ ì•„ì›ƒ',0),(389324,10815,'he','×”×ª× ×ª×§',0),(389325,10815,'el','Î•Î¾Î­Î»Î¸ÎµÏ„Îµ',0),(389326,10815,'zh','ç™»å‡º\r\n',0),(389327,10815,'sv','Logga ut',0),(389328,10815,'it','Esci',0),(389329,10815,'tl','',0),(389330,10815,'th','à¸¥à¸‡à¸Šà¸·à¹ˆà¸­à¸­à¸­à¸',0),(389331,10815,'hi','à¤¸à¤¾à¤‡à¤¨ à¤†à¤‰à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(389332,10815,'ms','Daftar keluar',0),(389333,10815,'ar','Ù‚Ù… Ø¨ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬',0),(389334,10815,'fr','Se dÃ©connecter',0),(389335,10815,'jp','ã‚µã‚¤ãƒ³ã‚¢ã‚¦ãƒˆã—ã¾ã™ã€‚',0),(389336,10815,'pt','Cadastre-se para fora',0),(389337,10815,'ru','Ð’Ñ‹Ñ…Ð¾Ð´',0),(389338,10815,'es','Anotarse al Salir',0),(389339,10815,'de','Melden Sie sich',0),(389340,10815,'en','Sign Out',0),(389341,10816,'is','',0),(389342,10816,'dr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® Ø®Ø±ÙˆØ¬',0),(389343,10816,'pr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® Ø®Ø±ÙˆØ¬',0),(389344,10816,'tr','BaÅŸlangÄ±Ã§ tarihi',0),(389345,10816,'pl','Data rozpoczÄ™cia siÄ™',0),(389346,10816,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(389347,10816,'ur','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ø¨Ø§ÛØ±',0),(389348,10816,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð½Ð°Ð¿Ð¾Ñ™Ðµ',0),(389349,10816,'vi','NgÃ y báº¯t Ä‘áº§u thoÃ¡t',0),(389350,10816,'af','Begin datum uit',0),(389351,10816,'ro','ÃŽncepeÅ£i datÄƒ afarÄƒ',0),(389352,10816,'et','VÃ¤lja AlguskuupÃ¤ev',0),(389353,10816,'si','ZaÄetni datum',0),(389354,10816,'ba','Tanggal mulai keluar',0),(389355,10816,'nl','Begindatum uit',0),(389356,10816,'fi','AloituspÃ¤ivÃ¤',0),(389357,10816,'no','Start dato ut',0),(389358,10816,'da','Start dato ud',0),(389359,10816,'ko','ë°–ìœ¼ë¡œ ì‹œìž‘ ë‚ ì§œ',0),(389360,10816,'he','×ª××¨×™×š ×”×”×ª×—×œ×”.',0),(389361,10816,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Î­Î¾Ï‰',0),(389362,10816,'zh','å¼€å§‹æ—¥æœŸè¾“å‡º\r\n',0),(389363,10816,'sv','BÃ¶rja dagen ut',0),(389364,10816,'it','Data inizio fuori',0),(389365,10816,'tl','',0),(389366,10816,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸­à¸­à¸',0),(389367,10816,'hi','à¤¬à¤¾à¤¹à¤° à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(389368,10816,'ms','Mulakan tarikh Keluar',0),(389369,10816,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡ Ø¨Ù‡Ø§',0),(389370,10816,'fr','Date de dÃ©but des',0),(389371,10816,'jp','ã†ã¡ã®é–‹å§‹æ—¥',0),(389372,10816,'pt','Data de inÃ­cio para fora',0),(389373,10816,'ru','Ð”Ð°Ñ‚Ñ‹ Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(389374,10816,'es','Empieza Fecha Fuera',0),(389375,10816,'de','Anfangsdatum',0),(389376,10816,'en','Begin Date Out',0),(389377,10817,'is','',0),(389378,10817,'dr','ÙØ¹Ù„Ø§ Ø®Ø§Ø±Ø¬ ',0),(389379,10817,'pr','ÙØ¹Ù„Ø§ Ø®Ø§Ø±Ø¬ ',0),(389380,10817,'tr','Åžu anda dÄ±ÅŸarÄ±',0),(389381,10817,'pl','Obecnie na zewnÄ…trz',0),(389382,10817,'bg','Ð’ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° ÑÐµ',0),(389383,10817,'ur','Ø§Ø³ ÙˆÙ‚Øª Ø¨Ø§ÛØ±',0),(389384,10817,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ ÑÐµ',0),(389385,10817,'vi','hiá»‡n ra',0),(389386,10817,'af','Huidiglike Uit',0),(389387,10817,'ro','ÃŽn prezent afarÄƒ',0),(389388,10817,'et','Praegu vÃ¤lja',0),(389389,10817,'si','Trenutno jasno',0),(389390,10817,'ba','Saat ini keluar',0),(389391,10817,'nl','Op dit moment buiten',0),(389392,10817,'fi','TÃ¤llÃ¤ hetkellÃ¤ ulos',0),(389393,10817,'no','ForelÃ¸pig ut',0),(389394,10817,'da','I Ã¸jeblikket ud',0),(389395,10817,'ko','í˜„ìž¬ ë°–ìœ¼ë¡œ',0),(389396,10817,'he','×›×™×•× ×”×—×•×¦×”',0),(389397,10817,'el','Î‘Ï…Ï„Î® Ï„Î· ÏƒÏ„Î¹Î³Î¼Î® Î­Î¾Ï‰',0),(389398,10817,'zh','ç›®å‰ä¸åœ¨\r\n',0),(389399,10817,'sv','FÃ¶r nÃ¤rvarande ut',0),(389400,10817,'it','Attualmente fuori',0),(389401,10817,'tl','',0),(389402,10817,'th','à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¸­à¸­à¸',0),(389403,10817,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¬à¤¾à¤¹à¤°',0),(389404,10817,'ms','Sedang Keluar',0),(389405,10817,'ar','Ø­Ø§Ù„ÙŠØ§ Ø®Ø§Ø±Ø¬',0),(389406,10817,'fr','Actuellement dehors',0),(389407,10817,'jp','ç¾åœ¨ä½¿ç”¨ã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(389408,10817,'pt','Atualmente, fora',0),(389409,10817,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð¸Ð·',0),(389410,10817,'es','Actualmente Afuera',0),(389411,10817,'de','Derzeit raus',0),(389412,10817,'en','Currently Out',0),(389413,10818,'is','',0),(389414,10818,'dr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø®Ø±ÙˆØ¬ ',0),(389415,10818,'pr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø®Ø±ÙˆØ¬ ',0),(389416,10818,'tr','BitiÅŸ tarihi',0),(389417,10818,'pl','Data zakoÅ„czenia',0),(389418,10818,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð°',0),(389419,10818,'ur','Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ® Ø¨Ø§ÛØ±',0),(389420,10818,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°.',0),(389421,10818,'vi','ngÃ y háº¿t háº¡n',0),(389422,10818,'af','Einddatum uit',0),(389423,10818,'ro','Data de sfÃ¢rÅŸit afarÄƒ',0),(389424,10818,'et','VÃ¤lja lÃµppkuupÃ¤ev',0),(389425,10818,'si','KonÄni datum',0),(389426,10818,'ba','Akhir tanggal keluar',0),(389427,10818,'nl','Einddatum uit',0),(389428,10818,'fi','Loppuun mennessÃ¤',0),(389429,10818,'no','Sluttdato ut',0),(389430,10818,'da','Slutdato ud',0),(389431,10818,'ko','ë°–ìœ¼ë¡œ ì¢…ë£Œ ë‚ ì§œ',0),(389432,10818,'he','×ª××¨×™×š ×¡×™×•×.',0),(389433,10818,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Î­Î¾Ï‰',0),(389434,10818,'zh','ç»“æŸæ—¥æœŸè¾“å‡º',0),(389435,10818,'sv','Slutdatum ut',0),(389436,10818,'it','Data fine fuori',0),(389437,10818,'tl','',0),(389438,10818,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸­à¸­à¸',0),(389439,10818,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¸à¥‡ à¤¬à¤¾à¤¹à¤°',0),(389440,10818,'ms','Tarikh tamat Keluar',0),(389441,10818,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø®Ø±ÙˆØ¬',0),(389442,10818,'fr','Date de fin des',0),(389443,10818,'jp','ã†ã¡ã®çµ‚äº†æ—¥',0),(389444,10818,'pt','Data de tÃ©rmino para fora',0),(389445,10818,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(389446,10818,'es','Fecha de TerminaciÃ³n Fuera',0),(389447,10818,'de','End-Datum',0),(389448,10818,'en','End Date Out',0),(389449,10819,'is','',0),(389450,10819,'dr','(Ø§Ø«Ø§Ø«Ù‡',0),(389451,10819,'pr','Ø«Ø¨Øª Ø®Ø±ÙˆØ¬  ØªØ¬Ù‡ÙŠØ²Ø§Øª(Ø§Ø«Ø§Ø«Ù‡',0),(389452,10819,'tr','Ekipman oturum kapatÄ±ldÄ±',0),(389453,10819,'pl','SprzÄ™t wylogowany',0),(389454,10819,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ, Ð¸Ð·Ð»ÐµÐ·Ð»Ð¸',0),(389455,10819,'ur','Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Ø¦Û’',0),(389456,10819,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð° Ð¾Ð´Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð¸',0),(389457,10819,'vi','Thiáº¿t bá»‹ ra',0),(389458,10819,'af','Toerusting afgeteken',0),(389459,10819,'ro','Echipament deconectat',0),(389460,10819,'et','Seadmed vÃ¤lja loginud',0),(389461,10819,'si','Oprema, ki se odjavili',0),(389462,10819,'ba','Peralatan sign Out',0),(389463,10819,'nl','Apparatuur afgemeld',0),(389464,10819,'fi','Laitteiden kirjautunut ulos',0),(389465,10819,'no','Utstyr logget av',0),(389466,10819,'da','Udstyr logget ud',0),(389467,10819,'ko','ë¡œê·¸ ì•„ì›ƒ í•˜ëŠ” ìž¥ë¹„',0),(389468,10819,'he','×¦×™×•×“ ×ž× ×•×ª×§',0),(389469,10819,'el','Î•Î¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚ ÎµÎºÏ„ÏŒÏ‚ ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚',0),(389470,10819,'zh','è®¾å¤‡ç™»å‡º',0),(389471,10819,'sv','Utrustning loggat ut',0),(389472,10819,'it','Attrezzature firmata',0),(389473,10819,'tl','',0),(389474,10819,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸—à¸µà¹ˆà¸­à¸­à¸à¸ˆà¸²à¸à¸£à¸°à¸šà¸š',0),(389475,10819,'hi','à¤¸à¤¾à¤‡à¤¨ à¤†à¤‰à¤Ÿ à¤‰à¤ªà¤•à¤°à¤£',0),(389476,10819,'ms','Peralatan yang didaftar Keluar',0),(389477,10819,'ar','Ù…Ø¹Ø¯Ø§Øª ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬',0),(389478,10819,'fr','Ã‰quipement dÃ©connectÃ©',0),(389479,10819,'jp','ã‚µã‚¤ãƒ³ã‚¢ã‚¦ãƒˆæ©Ÿå™¨',0),(389480,10819,'pt','Equipamento assinado para fora',0),(389481,10819,'ru','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¸Ð· Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ð°',0),(389482,10819,'es','Equipo Salir por firma',0),(389483,10819,'de','GerÃ¤te abgemeldet',0),(389484,10819,'en','Equipment Signed Out',0),(389485,10820,'is','',0),(389486,10820,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø¢ÙˆØ±Ø¯',0),(389487,10820,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø¢ÙˆØ±Ø¯',0),(389488,10820,'tr','DeÄŸerlendirme tutar',0),(389489,10820,'pl','Ocena iloÅ›ci',0),(389490,10820,'bg','ÐžÑ†ÐµÐ½ÐºÐ° Ð½Ð° ÑÑƒÐ¼Ð°',0),(389491,10820,'ur','ØªØ´Ø®ÛŒØµ Ø±Ù‚Ù…',0),(389492,10820,'sr','ÐŸÑ€Ð¾Ñ†Ñ˜ÐµÐ½Ð° Ð¸Ð·Ð½Ð¾ÑÐ°',0),(389493,10820,'vi','ÄÃ¡nh giÃ¡ Sá»‘ tiá»n',0),(389494,10820,'af','Assessering bedrag',0),(389495,10820,'ro','Suma de evaluare',0),(389496,10820,'et','Hinnang summa',0),(389497,10820,'si','Ocena zneska',0),(389498,10820,'ba','Jumlah penilaian',0),(389499,10820,'nl','Beoordeling bedrag',0),(389500,10820,'fi','Arviointi mÃ¤Ã¤rÃ¤',0),(389501,10820,'no','Vurdering belÃ¸p',0),(389502,10820,'da','Vurdering belÃ¸b',0),(389503,10820,'ko','í‰ê°€ ê¸ˆì•¡',0),(389504,10820,'he','×”×¢×¨×›×ª ×›×ž×•×ª',0),(389505,10820,'el','Î‘Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ· Ï€Î¿ÏƒÏŒ',0),(389506,10820,'zh','è¯„ä¼°é¢\r\n',0),(389507,10820,'sv','BedÃ¶mning belopp',0),(389508,10820,'it','Valutazione quantitÃ ',0),(389509,10820,'tl','',0),(389510,10820,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸›à¸£à¸°à¹€à¸¡à¸´à¸™',0),(389511,10820,'hi','à¤®à¥‚à¤²à¥à¤¯à¤¾à¤‚à¤•à¤¨ à¤°à¤¾à¤¶à¤¿',0),(389512,10820,'ms','Jumlah penilaian',0),(389513,10820,'ar','ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ù…Ø¨Ù„Øº',0),(389514,10820,'fr','Montant de l\'Ã©valuation',0),(389515,10820,'jp','è©•ä¾¡é¡',0),(389516,10820,'pt','Quantidade de avaliaÃ§Ã£o',0),(389517,10820,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¾Ñ†ÐµÐ½ÐºÐ¸',0),(389518,10820,'es','Monto de ValoraciÃ³n',0),(389519,10820,'de','Bewertung Betrag',0),(389520,10820,'en','Assessment Amount',0),(389521,10821,'is','',0),(389522,10821,'dr','ØªØ§Ø±ÙŠØ® Ø¨Ø±Ø¢ÙˆØ±Ø¯',0),(389523,10821,'pr','ØªØ§Ø±ÙŠØ® Ø¨Ø±Ø¢ÙˆØ±Ø¯',0),(389524,10821,'tr','DeÄŸerlendirme tarihi',0),(389525,10821,'pl','Data oceny',0),(389526,10821,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(389527,10821,'ur','ØªØ´Ø®ÛŒØµ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(389528,10821,'sr','ÐŸÑ€Ð¾Ñ†Ñ˜ÐµÐ½Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(389529,10821,'vi','ÄÃ¡nh giÃ¡ ngÃ y',0),(389530,10821,'af','Assessering datum',0),(389531,10821,'ro','Data de evaluare',0),(389532,10821,'et','Arvestuslik kuupÃ¤ev',0),(389533,10821,'si','Ocena datum',0),(389534,10821,'ba','Penilaian tanggal',0),(389535,10821,'nl','Datum beoordeling',0),(389536,10821,'fi','ArviointipÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n',0),(389537,10821,'no','OppgjÃ¸rsdatoen',0),(389538,10821,'da','OpgÃ¸relsesdato',0),(389539,10821,'ko','í‰ê°€ ë‚ ì§œ',0),(389540,10821,'he','×”×¢×¨×›×ª ×ª××¨×™×š',0),(389541,10821,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(389542,10821,'zh','è¯„ä¼°æ—¥æœŸ\r\n',0),(389543,10821,'sv','BedÃ¶mningsdatum',0),(389544,10821,'it','Data di valutazione',0),(389545,10821,'tl','',0),(389546,10821,'th','à¸§à¸±à¸™à¸›à¸£à¸°à¹€à¸¡à¸´à¸™',0),(389547,10821,'hi','à¤®à¥‚à¤²à¥à¤¯à¤¾à¤‚à¤•à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(389548,10821,'ms','Tarikh penilaian',0),(389549,10821,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙ‚ÙŠÙŠÙ…',0),(389550,10821,'fr','Date de l\'Ã©valuation',0),(389551,10821,'jp','è©•ä¾¡æ—¥ä»˜',0),(389552,10821,'pt','Data de avaliaÃ§Ã£o',0),(389553,10821,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ñ†ÐµÐ½ÐºÐ¸',0),(389554,10821,'es','Fecha de ValoraciÃ³n',0),(389555,10821,'de','Bewertung Datum',0),(389556,10821,'en','Assessment Date',0),(389557,10822,'is','',0),(389558,10822,'dr','.',0),(389559,10822,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙŠÙƒÙŠ Ø´Ø¯Ù‡  ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ù…ØªÙ†Ø§Ø³Ø¨  Ù†Ø¯Ø§Ø±Ø¯.',0),(389560,10822,'tr','Ä°liÅŸkili fatura eÅŸleÅŸen GL hesabÄ± yok',0),(389561,10822,'pl','Bill zwiÄ…zane nie pasujÄ…ce konto GL',0),(389562,10822,'bg','Ð¡Ð²ÑŠÑ€Ð·Ð°Ð½ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð½Ðµ Ðµ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(389563,10822,'ur','ÙˆØ§Ø¨Ø³ØªÛ Ø¨Ù„ Ø§ÛŒÚ© Ù…Ø´Ø§Ø¨Û Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†ÛÛŒÚº ÛÛ’',0),(389564,10822,'sr','ÐŸÑ€Ð¸Ð´Ñ€ÑƒÐ¶ÐµÐ½Ð¸ Ð‘Ð¸Ð» Ð½ÐµÐ¼Ð° Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð°Ñ˜ÑƒÑ›Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð“Ð›',0),(389565,10822,'vi','LiÃªn quan Ä‘áº¿n hÃ³a Ä‘Æ¡n khÃ´ng cÃ³ má»™t tÃ i khoáº£n GL phÃ¹ há»£p',0),(389566,10822,'af','Geassosieerde Rekening Het Nie \'n Gepasde AG Rekening Nie',0),(389567,10822,'ro','Bill asociate nu are un cont de potrivire GL',0),(389568,10822,'et','Seotud arve ei ole vastavaid pearaamatukontole',0),(389569,10822,'si','Povezan raÄun nima ustreznega raÄuna GL',0),(389570,10822,'ba','Terkait RUU tidak memiliki rekening GL pencocokan',0),(389571,10822,'nl','Bijbehorende Bill beschikt niet over een overeenkomende GL-Account',0),(389572,10822,'fi','LiittyvÃ¤n laskun ei ole vastaavia GL-tiliÃ¤',0),(389573,10822,'no','Tilknyttede Bill har ikke en samsvarende gi-konto',0),(389574,10822,'da','Tilknyttede Bill har ikke en tilsvarende GL konto',0),(389575,10822,'ko','ê´€ë ¨ëœ ë²•ì•ˆì—ëŠ” ì¼ì¹˜ í•˜ëŠ” GL ê³„ì •',0),(389576,10822,'he','×‘×™×œ ×”×ž×©×•×™×›×ª ×œ× ×§×™×™× ×—×©×‘×•×Ÿ GL ×ª×•××ž×•×ª',0),(389577,10822,'el','Î£Ï…Î½Î±Ï†ÎµÎ¯Ï‚ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¼Î¹Î± Î±Î½Ï„Î¯ÏƒÏ„Î¿Î¹Ï‡Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(389578,10822,'zh','ç›¸å…³æ³•æ¡ˆä¸åŒ¹é…çš„GLå¸æˆ·\r\n',0),(389579,10822,'sv','TillhÃ¶rande Bill har inte ett matchande GL-konto',0),(389580,10822,'it','Bill associato non ha un corrispondente conto GL',0),(389581,10822,'tl','',0),(389582,10822,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¹€à¸à¸µà¹ˆà¸¢à¸§à¸‚à¹‰à¸­à¸‡à¸¡à¸µà¸šà¸±à¸à¸Šà¸µ GL à¸•à¸£à¸‡',0),(389583,10822,'hi','à¤¸à¤‚à¤¬à¤‚à¤§à¤¿à¤¤ à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤à¤• à¤®à¤¿à¤²à¤¾à¤¨ GL à¤–à¤¾à¤¤à¥‡ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(389584,10822,'ms','Rang undang-undang berkaitan tidak mempunyai akaun GL yang sepadan',0),(389585,10822,'ar','Ø¨ÙŠÙ„ Ø§Ù„Ù…Ø±ØªØ¨Ø·Ø© Ø¨Ù‡Ø§ Ù„Ø§ ØªÙ…Ù„Ùƒ Ø­Ø³Ø§Ø¨ GL Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(389586,10822,'fr','Bill associÃ© n\'a pas un compte GL correspondant',0),(389587,10822,'jp','é–¢é€£æ³•æ¡ˆã¯ã€ä¸€è‡´ã™ã‚‹ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(389588,10822,'pt','Bill associado nÃ£o tem uma correspondente conta GL',0),(389589,10822,'ru','Ð¡Ð²ÑÐ·Ð°Ð½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð½Ðµ Ð¸Ð¼ÐµÐµÑ‚ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ ÑÑ‡ÐµÑ‚ GL',0),(389590,10822,'es','Factura Asociada no Tiene Cuenta de LM Coincidente',0),(389591,10822,'de','Damit verbundenen Bill verfÃ¼gt nicht Ã¼ber ein entsprechendes GL-Konto',0),(389592,10822,'en','Associated Bill Does Not Have a Matching GL Account',0),(389593,10823,'is','',0),(389594,10823,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(389595,10823,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(389596,10823,'tr','Eklemek binanÄ±n emlak vergisi',0),(389597,10823,'pl','Podatek od nieruchomoÅ›ci budynku Dodaj',0),(389598,10823,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð° Ð´Ð°Ð½ÑŠÐº',0),(389599,10823,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(389600,10823,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð³Ñ€Ð°Ð´Ðµ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð½ÐµÐºÑ€ÐµÑ‚Ð½Ð¸Ð½Ðµ',0),(389601,10823,'vi','XÃ¢y dá»±ng báº¥t Ä‘á»™ng sáº£n thuáº¿ thÃªm',0),(389602,10823,'af','Gebou eiendom belasting voeg',0),(389603,10823,'ro','Adauga impozitul pe clÄƒdire',0),(389604,10823,'et','Hoone maamaks lisamine',0),(389605,10823,'si','Dodati davek stavbo',0),(389606,10823,'ba','Pajak properti bangunan menambahkan',0),(389607,10823,'nl','Gebouw onroerende voorheffing toevoegen',0),(389608,10823,'fi','Rakennuksen kiinteistÃ¶vero lisÃ¤Ã¤',0),(389609,10823,'no','Bygningen eiendomsskatt legge',0),(389610,10823,'da','Bygning ejendomsskat tilfÃ¸je',0),(389611,10823,'ko','ê±´ë¬¼ ìž¬ì‚°ì„¸ ì¶”ê°€',0),(389612,10823,'he','×ž×¡ ×¨×›×•×© ×”×‘× ×™×™×Ÿ ×œ×”×•×¡×™×£',0),(389613,10823,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎºÏ„Î¹ÏÎ¯Î¿Ï… Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚',0),(389614,10823,'zh','æˆ¿äº§ç¨Žæ–°å¢ž\r\n',0),(389615,10823,'sv','Byggnaden fastighetsskatt lÃ¤gga till',0),(389616,10823,'it','Aggiungi edificio proprietÃ  fiscale',0),(389617,10823,'tl','',0),(389618,10823,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸­à¸²à¸„à¸²à¸£',0),(389619,10823,'hi','à¤¬à¤¿à¤²à¥à¤¡à¤¿à¤‚à¤— à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(389620,10823,'ms','Tambah cukai harta bangunan',0),(389621,10823,'ar','Ø¥Ø¶Ø§ÙØ© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ Ø¨Ù†Ø§Ø¡',0),(389622,10823,'fr','Ajouter des impÃ´ts fonciers de bÃ¢timent',0),(389623,10823,'jp','å»ºç‰©ã®è²¡ç”£ç¨Žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(389624,10823,'pt','Adicionar Propriedade predial',0),(389625,10823,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(389626,10823,'es','Agregar Impuesto Predial del Edificio',0),(389627,10823,'de','Bausteuer Eigenschaft hinzufÃ¼gen',0),(389628,10823,'en','Building Property Tax Add',0),(389629,10824,'is','',0),(389630,10824,'dr','Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(389631,10824,'pr','Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(389632,10824,'tr','Bina emlak vergisi Sil',0),(389633,10824,'pl','UsuÅ„ budynku podatek od nieruchomoÅ›ci',0),(389634,10824,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ð´Ð°Ð½ÑŠÐº Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(389635,10824,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(389636,10824,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð·Ð³Ñ€Ð°Ð´Ð° Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ',0),(389637,10824,'vi','XÃ¢y dá»±ng báº¥t Ä‘á»™ng sáº£n thuáº¿ xÃ³a',0),(389638,10824,'af','Gebou eiendom belasting skrap',0),(389639,10824,'ro','Åžtergere de impozitul pe clÄƒdire',0),(389640,10824,'et','Hoone maamaks kustutamine',0),(389641,10824,'si','Brisanje stavbe davek na nepremiÄnine',0),(389642,10824,'ba','Bangunan pajak properti Hapus',0),(389643,10824,'nl','Gebouw onroerende voorheffing verwijderen',0),(389644,10824,'fi','Rakennuksen kiinteistÃ¶vero Poista',0),(389645,10824,'no','Bygningen eiendomsskatt Slett',0),(389646,10824,'da','Bygning ejendomsskat slet',0),(389647,10824,'ko','ê±´ë¬¼ ìž¬ì‚°ì„¸ ì‚­ì œ',0),(389648,10824,'he','×‘× ×™×™×Ÿ ×ž×¡ ×¨×›×•×© ×ž×—×§',0),(389649,10824,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï†ÏŒÏÎ¿Ï… Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï„Î¿Ï… ÎºÏ„Î¹ÏÎ¯Î¿Ï…',0),(389650,10824,'zh','æˆ¿äº§ç¨Žåˆ é™¤\r\n',0),(389651,10824,'sv','Byggnaden fastighetsskatt Delete',0),(389652,10824,'it','Edificio proprietÃ  fiscale Delete',0),(389653,10824,'tl','',0),(389654,10824,'th','à¸¥à¸šà¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸­à¸²à¸„à¸²à¸£',0),(389655,10824,'hi','à¤¬à¤¿à¤²à¥à¤¡à¤¿à¤‚à¤— à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(389656,10824,'ms','Hapus cukai harta bangunan',0),(389657,10824,'ar','Ø­Ø°Ù Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ Ø¨Ù†Ø§Ø¡',0),(389658,10824,'fr','Suppression taxe fonciÃ¨re bÃ¢timent',0),(389659,10824,'jp','å»ºç‰©ã®å›ºå®šè³‡ç”£ç¨Žã®å‰Šé™¤',0),(389660,10824,'pt','EdifÃ­cio imposto sobre a propriedade de excluir',0),(389661,10824,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð·Ð´Ð°Ð½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾',0),(389662,10824,'es','Impuesto Predial del Edificio Eliminar',0),(389663,10824,'de','GebÃ¤ude Grundsteuer lÃ¶schen',0),(389664,10824,'en','Building Property Tax Delete',0),(389665,10825,'is','',0),(389666,10825,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(389667,10825,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(389668,10825,'tr','Bina emlak vergisi gÃ¼ncelleÅŸtirme',0),(389669,10825,'pl','Budynku podatek od nieruchomoÅ›ci aktualizacji',0),(389670,10825,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ð´Ð°Ð½ÑŠÐº Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(389671,10825,'ur','Ø¹Ù…Ø§Ø±Øª Ú©ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(389672,10825,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð·Ð³Ñ€Ð°Ð´Ðµ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð½ÐµÐºÑ€ÐµÑ‚Ð½Ð¸Ð½Ðµ',0),(389673,10825,'vi','XÃ¢y dá»±ng thuáº¿ báº¥t Ä‘á»™ng sáº£n Cáº­p Nháº­t',0),(389674,10825,'af','Gebou eiendom belasting bywerking',0),(389675,10825,'ro','Actualizare de impozitul pe clÄƒdire',0),(389676,10825,'et','Hoone maamaks Update',0),(389677,10825,'si','Davek na nepremiÄnine posodobitev stavbe',0),(389678,10825,'ba','Bangunan pajak properti Update',0),(389679,10825,'nl','Gebouw onroerende voorheffing Update',0),(389680,10825,'fi','Rakennuksen kiinteistÃ¶vero pÃ¤ivitys',0),(389681,10825,'no','Bygningen eiendomsskatt oppdatering',0),(389682,10825,'da','Bygning ejendomsskat opdatering',0),(389683,10825,'ko','ê±´ë¬¼ ìž¬ì‚°ì„¸ ì—…ë°ì´íŠ¸',0),(389684,10825,'he','×‘× ×™×™×Ÿ ×ž×¡ ×¨×›×•×© ×¢×“×›×•×Ÿ',0),(389685,10825,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(389686,10825,'zh','æˆ¿äº§ç¨Žæ›´æ–°\r\n',0),(389687,10825,'sv','Byggnaden fastighetsskatt uppdatering',0),(389688,10825,'it','Edificio proprietÃ  fiscali aggiornamento',0),(389689,10825,'tl','',0),(389690,10825,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸­à¸²à¸„à¸²à¸£',0),(389691,10825,'hi','à¤¬à¤¿à¤²à¥à¤¡à¤¿à¤‚à¤— à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(389692,10825,'ms','Kemaskini cukai harta bangunan',0),(389693,10825,'ar','Ø¨Ù†Ø§Ø¡ Ø§Ù„ØªØ­Ø¯ÙŠØ« Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ',0),(389694,10825,'fr','Mise Ã  jour des impÃ´ts fonciers de bÃ¢timent',0),(389695,10825,'jp','å»ºç‰©ã®å›ºå®šè³‡ç”£ç¨Žã®æ›´æ–°',0),(389696,10825,'pt','AtualizaÃ§Ã£o de imposto sobre a propriedade do edifÃ­cio',0),(389697,10825,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(389698,10825,'es','Impuesto Predial del Edificio Actualizar',0),(389699,10825,'de','GebÃ¤ude-Grundsteuer-Update',0),(389700,10825,'en','Building Property Tax Update',0),(389701,10826,'is','',0),(389702,10826,'dr','Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(389703,10826,'pr','Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(389704,10826,'tr','Bina vergisi silinemedi',0),(389705,10826,'pl','Budynek podatku usuniÄ™cie nie powiodÅ‚o siÄ™',0),(389706,10826,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ð´Ð°Ð½ÑŠÐº Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ðµ Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(389707,10826,'ur','Ù¹ÛŒÚ©Ø³ Ø­Ø°Ù ØªØ¹Ù…ÛŒØ± Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§',0),(389708,10826,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð±Ñ€Ð¸ÑÐ°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(389709,10826,'vi','XÃ¢y dá»±ng thuáº¿ Delete tháº¥t báº¡i',0),(389710,10826,'af','Gebou belasting Delete het misluk',0),(389711,10826,'ro','Construirea fiscale Delete Failed',0),(389712,10826,'et','Hoone maksu kustutamine nurjus',0),(389713,10826,'si','Delete davÄne gradnjo uspela',0),(389714,10826,'ba','Bangunan pajak Hapus gagal',0),(389715,10826,'nl','Gebouw belasting verwijderen is mislukt',0),(389716,10826,'fi','Rakennuksen veron poistaminen epÃ¤onnistui',0),(389717,10826,'no','Bygge skatt Slett mislyktes',0),(389718,10826,'da','Bygning skat slet mislykkedes',0),(389719,10826,'ko','ê±´ë¬¼ ì„¸ê¸ˆ ì‚­ì œ ì‹¤íŒ¨',0),(389720,10826,'he','×‘× ×™×™×Ÿ ×ž×¡ ×ž×—×™×§×” × ×›×©×œ×”',0),(389721,10826,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï†ÏŒÏÎ¿Ï… ÎºÏ„Î¯ÏÎ¹Î¿ Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(389722,10826,'zh','æˆ¿å±‹ç¨Žåˆ é™¤å¤±è´¥\r\n',0),(389723,10826,'sv','Det gick inte att bygga skatt Delete',0),(389724,10826,'it','Edificio fiscale eliminazione non riuscita',0),(389725,10826,'tl','',0),(389726,10826,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸ à¸²à¸©à¸µà¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(389727,10826,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤µà¤¿à¤«à¤² à¤¹à¥à¤†',0),(389728,10826,'ms','Hapus cukai bangunan gagal',0),(389729,10826,'ar','ÙØ´Ù„ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø¨Ù†Ø§Ø¡',0),(389730,10826,'fr','Ã‰chec de la suppression de la taxe de construction',0),(389731,10826,'jp','å»ºç‰©ç¨Žå‰Šé™¤ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(389732,10826,'pt','Falhado ao excluir imposto edifÃ­cio',0),(389733,10826,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(389734,10826,'es','Impuesto del Edificio Eliminar FallÃ³',0),(389735,10826,'de','GebÃ¤ude Steuern LÃ¶schen fehlgeschlagen',0),(389736,10826,'en','Building Tax Delete Failed',0),(389737,10827,'is','',0),(389738,10827,'dr','Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(389739,10827,'pr','Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(389740,10827,'tr','Bina vergisi baÅŸarÄ±yla silindi',0),(389741,10827,'pl','Podatek od budynku przesâ”‚anie',0),(389742,10827,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ð´Ð°Ð½ÑŠÐº Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(389743,10827,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø¹Ù…Ø§Ø±Øª Ù¹ÛŒÚ©Ø³',0),(389744,10827,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(389745,10827,'vi','XÃ¢y dá»±ng thuáº¿ Ä‘Ã£ xÃ³a thÃ nh cÃ´ng',0),(389746,10827,'af','Gebou belasting suksesvol geskrap',0),(389747,10827,'ro','ClÄƒdire fiscale eliminÄƒ cu succes',0),(389748,10827,'et','Hoone maksu edukalt kustutatud',0),(389749,10827,'si','Davek stavbo uspeÅ¡no izbrisana',0),(389750,10827,'ba','Bangunan pajak dihapus berhasil',0),(389751,10827,'nl','Gebouw belasting met succes verwijderd',0),(389752,10827,'fi','Rakennuksen vero poistettu',0),(389753,10827,'no','Bygningen skatt slettet',0),(389754,10827,'da','Bygning skat slettet',0),(389755,10827,'ko','ê±´ë¬¼ ì„¸ê¸ˆ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(389756,10827,'he','×‘× ×™×™×Ÿ ×ž×¡ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(389757,10827,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Ï†ÏŒÏÎ¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(389758,10827,'zh','æˆ¿å±‹ç¨ŽæˆåŠŸåˆ é™¤\r\n',0),(389759,10827,'sv','Byggnaden skatt raderades',0),(389760,10827,'it','Edificio fiscale eliminato con successo',0),(389761,10827,'tl','',0),(389762,10827,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸ à¸²à¸©à¸µà¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(389763,10827,'hi','à¤­à¤µà¤¨ à¤•à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(389764,10827,'ms','Bangunan cukai dihapuskan dengan jayanya',0),(389765,10827,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø¨Ù†Ø§Ø¡ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(389766,10827,'fr','BÃ¢timent impÃ´t supprimÃ© avec succÃ¨s',0),(389767,10827,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸå»ºç‰©ç¨Ž',0),(389768,10827,'pt','ContribuiÃ§Ã£o predial apagada com sucesso',0),(389769,10827,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(389770,10827,'es','Impuesto del Edificio Eliminado Exitosamente',0),(389771,10827,'de','Bausteuer erfolgreich gelÃ¶scht',0),(389772,10827,'en','Building Tax Deleted Successfully',0),(389773,10828,'is','',0),(389774,10828,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(389775,10828,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(389776,10828,'tr','Bina vergisi gÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu',0),(389777,10828,'pl','Budynek podatku aktualizacji nie powiodÅ‚o siÄ™',0),(389778,10828,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°Ñ‚Ð° Ð´Ð°Ð½ÑŠÐº',0),(389779,10828,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯ ØªØ¹Ù…ÛŒØ± Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§',0),(389780,10828,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð·Ð³Ñ€Ð°Ð´Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(389781,10828,'vi','XÃ¢y dá»±ng thuáº¿ Cáº­p Nháº­t khÃ´ng thÃ nh cÃ´ng',0),(389782,10828,'af','Gebou belasting bywerking het misluk',0),(389783,10828,'ro','Construirea fiscale Update nu a reuÈ™it',0),(389784,10828,'et','Hoone maksu vÃ¤rskendamine nurjus',0),(389785,10828,'si','Gradnjo davÄne Update ni uspela',0),(389786,10828,'ba','Bangunan pajak Update gagal',0),(389787,10828,'nl','Gebouw fiscale Update is mislukt',0),(389788,10828,'fi','Rakennuksen vero-pÃ¤ivitys epÃ¤onnistui',0),(389789,10828,'no','Bygningen skatt oppdatering mislyktes',0),(389790,10828,'da','Bygning skat opdatering mislykkedes',0),(389791,10828,'ko','ê±´ë¬¼ ì„¸ê¸ˆ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(389792,10828,'he','×‘× ×™×™×Ÿ ×ž×¡ ×”×¢×“×›×•×Ÿ × ×›×©×œ',0),(389793,10828,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(389794,10828,'zh','æˆ¿å±‹ç¨Žæ›´æ–°å¤±è´¥\r\n',0),(389795,10828,'sv','Byggnaden skatt uppdateringen misslyckades',0),(389796,10828,'it','Edificio fiscali aggiornamento non riuscito',0),(389797,10828,'tl','',0),(389798,10828,'th','à¸­à¸²à¸„à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ à¸²à¸©à¸µà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(389799,10828,'hi','à¤‡à¤®à¤¾à¤°à¤¤ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²',0),(389800,10828,'ms','Kemaskini cukai bangunan gagal',0),(389801,10828,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø¨Ù†Ø§Ø¡',0),(389802,10828,'fr','BÃ¢timent fiscale mise Ã  jour a Ã©chouÃ©',0),(389803,10828,'jp','ç¨Žå‹™ã‚¢ãƒƒãƒ—ãƒ‡ãƒ¼ãƒˆã®æ§‹ç¯‰ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(389804,10828,'pt','EdifÃ­cio imposto atualizaÃ§Ã£o falhada',0),(389805,10828,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð·Ð´Ð°Ð½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹',0),(389806,10828,'es','Impuesto del Edificio ActualizaciÃ³n FallÃ³',0),(389807,10828,'de','GebÃ¤ude-Steuer-Update fehlgeschlagen',0),(389808,10828,'en','Building Tax Update Failed',0),(389809,10829,'is','',0),(389810,10829,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(389811,10829,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(389812,10829,'tr','Bina vergisi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(389813,10829,'pl','Podatek od budynku pomyÅ›lnie zaktualizowana',0),(389814,10829,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ð´Ð°Ð½ÑŠÐº Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(389815,10829,'ur','Ø¹Ù…Ø§Ø±Øª Ú©Û’ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(389816,10829,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(389817,10829,'vi','XÃ¢y dá»±ng thuáº¿ Cáº­p Nháº­t thÃ nh cÃ´ng',0),(389818,10829,'af','Gebou belasting suksesvol bygewerk',0),(389819,10829,'ro','ClÄƒdire fiscal actualizat cu succes',0),(389820,10829,'et','Hoone maksu vÃ¤rskendatud',0),(389821,10829,'si','Davek stavbo uspeÅ¡no posodobljena',0),(389822,10829,'ba','Bangunan pajak berhasil',0),(389823,10829,'nl','Gebouw belasting bijgewerkt',0),(389824,10829,'fi','Rakennuksen vero pÃ¤ivitetty',0),(389825,10829,'no','Bygningen skatt oppdatert',0),(389826,10829,'da','Bygning skat opdateret',0),(389827,10829,'ko','ê±´ë¬¼ ì„¸ê¸ˆ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(389828,10829,'he','×‘× ×™×™×Ÿ ×ž×¡ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(389829,10829,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Ï†ÏŒÏÎ¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(389830,10829,'zh','æˆ¿å±‹ç¨ŽæˆåŠŸæ›´æ–°\r\n',0),(389831,10829,'sv','Byggnaden skatt uppdaterats',0),(389832,10829,'it','Edificio fiscale aggiornato con successo',0),(389833,10829,'tl','',0),(389834,10829,'th','à¸ à¸²à¸©à¸µà¸­à¸²à¸„à¸²à¸£à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(389835,10829,'hi','à¤­à¤µà¤¨ à¤•à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(389836,10829,'ms','Cukai bangunan berjaya dikemas kini',0),(389837,10829,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø¨Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(389838,10829,'fr','Taxe de construction mis Ã  jour avec succÃ¨s',0),(389839,10829,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸå»ºç‰©ç¨Ž',0),(389840,10829,'pt','ContribuiÃ§Ã£o predial atualizada com sucesso',0),(389841,10829,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(389842,10829,'es','Impuesto del Edificio Actualizado Exitosamente',0),(389843,10829,'de','Bausteuer erfolgreich aktualisiert',0),(389844,10829,'en','Building Tax Updated Successfully',0),(389845,10830,'is','',0),(389846,10830,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§ÙˆÙ„ÙŠÙ‡ ',0),(389847,10830,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ÙˆÙ„ÙŠÙ‡ ',0),(389848,10830,'tr','Erken bir miktar',0),(389849,10830,'pl','PoczÄ…tku kwotÄ™',0),(389850,10830,'bg','Ð Ð°Ð½Ð½Ð¸ ÑÑƒÐ¼Ð°',0),(389851,10830,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ø±Ù‚Ù…',0),(389852,10830,'sr','Ð Ð°Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(389853,10830,'vi','Sá»‘ lÆ°á»£ng Ä‘áº§u',0),(389854,10830,'af','VroeÃ« bedrag',0),(389855,10830,'ro','ÃŽnceputul anului suma',0),(389856,10830,'et','Varajane summa',0),(389857,10830,'si','Zgodnje znesek',0),(389858,10830,'ba','Jumlah awal',0),(389859,10830,'nl','Vroege bedrag',0),(389860,10830,'fi','Alussa mÃ¤Ã¤rÃ¤',0),(389861,10830,'no','Tidlig belÃ¸p',0),(389862,10830,'da','Tidlig belÃ¸b',0),(389863,10830,'ko','ì´ˆê¸° ê¸ˆì•¡',0),(389864,10830,'he','×›×ž×•×ª ×ž×•×§×“×',0),(389865,10830,'el','Î‘ÏÏ‡Î­Ï‚ Ï€Î¿ÏƒÏŒ',0),(389866,10830,'zh','æ—©æœŸçš„é‡‘é¢\r\n',0),(389867,10830,'sv','Tidig belopp',0),(389868,10830,'it','Importo iniziale',0),(389869,10830,'tl','',0),(389870,10830,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸•à¹‰à¸™',0),(389871,10830,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤°à¤¾à¤¶à¤¿',0),(389872,10830,'ms','Jumlah awal',0),(389873,10830,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¨ÙƒØ±',0),(389874,10830,'fr','Montant anticipÃ©',0),(389875,10830,'jp','åˆæœŸé‡',0),(389876,10830,'pt','Quantidade inicial',0),(389877,10830,'ru','Ð Ð°Ð½Ð½Ð¸Ðµ ÑÑƒÐ¼Ð¼Ð°',0),(389878,10830,'es','Monto al Comienzo',0),(389879,10830,'de','FrÃ¼he Betrag',0),(389880,10830,'en','Early Amount',0),(389881,10831,'is','',0),(389882,10831,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ú†Ú¯ÙˆÙ†Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ØŸ',0),(389883,10831,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ú†Ú¯ÙˆÙ†Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª ØŸ',0),(389884,10831,'tr','Vergisi nasÄ±l hesaplanÄ±r',0),(389885,10831,'pl','Jak obliczany jest podatek',0),(389886,10831,'bg','ÐšÐ°Ðº ÑÐµ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð° Ð´Ð°Ð½ÑŠÐº',0),(389887,10831,'ur','Ú©ØªÙ†Ø§ Ù¹ÛŒÚ©Ø³ Ú©Ø§ Ø­Ø³Ø§Ø¨ Ù„Ú¯Ø§ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(389888,10831,'sr','ÐšÐ°ÐºÐ¾ ÑÐµ Ð¿Ð¾Ñ€ÐµÐ· Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°.',0),(389889,10831,'vi','Thuáº¿ Ä‘Æ°á»£c tÃ­nh nhÆ° tháº¿ nÃ o',0),(389890,10831,'af','Hoe word Belasting Bereken',0),(389891,10831,'ro','Cum se calculeazÄƒ impozitul',0),(389892,10831,'et','KÃ¤ibemaksu arvutamise',0),(389893,10831,'si','Kako se izraÄuna davÄna',0),(389894,10831,'ba','Bagaimana pajak dihitung',0),(389895,10831,'nl','Hoe de belasting wordt berekend',0),(389896,10831,'fi','Miten vero lasketaan',0),(389897,10831,'no','Hvordan mva',0),(389898,10831,'da','Hvordan afgiften beregnes',0),(389899,10831,'ko','ì„¸ê¸ˆì˜ ê³„ì‚° ë°©ë²•',0),(389900,10831,'he','××™×š ×ž×—×•×©×‘ ×”×ž×¡',0),(389901,10831,'el','Î ÏŽÏ‚ Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÏ„Î±Î¹ Î¿ Ï†ÏŒÏÎ¿Ï‚',0),(389902,10831,'zh','å¦‚ä½•è®¡ç®—ç¨Žæ¬¾çš„\r\n',0),(389903,10831,'sv','Hur skatten berÃ¤knas',0),(389904,10831,'it','Come viene calcolata la tassa',0),(389905,10831,'tl','',0),(389906,10831,'th','à¸§à¸´à¸˜à¸µà¸„à¸³à¸™à¸§à¸“à¸ à¸²à¸©à¸µ',0),(389907,10831,'hi','à¤•à¥ˆà¤¸à¥‡ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤¹à¥ˆ',0),(389908,10831,'ms','Bagaimana Cukai dikira',0),(389909,10831,'ar','ÙƒÙŠÙ ÙŠØªÙ… Ø­Ø³Ø§Ø¨ Ø¶Ø±ÙŠØ¨Ø©',0),(389910,10831,'fr','Comment calcule-t-on les impÃ´ts',0),(389911,10831,'jp','ç¨Žã®è¨ˆç®—æ–¹æ³•',0),(389912,10831,'pt','Como Ã© calculado o imposto',0),(389913,10831,'ru','ÐšÐ°Ðº Ð¡ÐºÐ°Ð»ÑŒÐºÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½ ÐÐ°Ð»Ð¾Ð³',0),(389914,10831,'es','Como El Impuesto se Calcula',0),(389915,10831,'de','Wie wird die Steuer berechnet',0),(389916,10831,'en','How Tax is Calculated',0),(389917,10832,'is','',0),(389918,10832,'dr','(Ø§Ø®ÙŠØ±',0),(389919,10832,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú¯Ø°Ø´ØªÙ‡ (Ø§Ø®ÙŠØ±',0),(389920,10832,'tr','GeÃ§ bir miktar',0),(389921,10832,'pl','Koniec kwota',0),(389922,10832,'bg','ÐšÑŠÑÐ½Ð¾ ÑÑƒÐ¼Ð°',0),(389923,10832,'ur','Ù…Ø±Ø­ÙˆÙ… Ú©ÛŒ Ø±Ù‚Ù…',0),(389924,10832,'sr','ÐŸÐ¾ÐºÐ¾Ñ˜Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(389925,10832,'vi','Sá»‘ tiá»n cuá»‘i',0),(389926,10832,'af','Laat bedrag',0),(389927,10832,'ro','SfÃ¢rÅŸitul anului suma',0),(389928,10832,'et','Hilja summa',0),(389929,10832,'si','Pozno znesek',0),(389930,10832,'ba','Jumlah yang terlambat',0),(389931,10832,'nl','Laat bedrag',0),(389932,10832,'fi','Lopulla mÃ¤Ã¤rÃ¤',0),(389933,10832,'no','Sen belÃ¸p',0),(389934,10832,'da','Sen belÃ¸b',0),(389935,10832,'ko','ëŠ¦ì€ ê¸ˆì•¡',0),(389936,10832,'he','×›×ž×•×ª ×ž××•×—×¨',0),(389937,10832,'el','Î¤Î­Î»Î· Ï€Î¿ÏƒÏŒ',0),(389938,10832,'zh','é€¾æœŸé‡‘é¢\r\n',0),(389939,10832,'sv','Sen belopp',0),(389940,10832,'it','Fine quantitÃ ',0),(389941,10832,'tl','',0),(389942,10832,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸¥à¹ˆà¸²à¸Šà¹‰à¸²',0),(389943,10832,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤°à¤¾à¤¶à¤¿',0),(389944,10832,'ms','Jumlah lewat',0),(389945,10832,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…ØªØ£Ø®Ø±',0),(389946,10832,'fr','Montant fin',0),(389947,10832,'jp','å¾ŒåŠã®é‡',0),(389948,10832,'pt','Montante final',0),(389949,10832,'ru','ÐšÐ¾Ð½Ñ†Ðµ ÑÑƒÐ¼Ð¼Ð°',0),(389950,10832,'es','Monto de Ser Tarde',0),(389951,10832,'de','SpÃ¤ten Betrag',0),(389952,10832,'en','Late Amount',0),(389953,10833,'is','',0),(389954,10833,'dr','(Ø§Ø®ÙŠØ±) Ø§Ú¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ø¹Ø¯ Ø§Ø² ',0),(389955,10833,'pr','Ú¯Ø°Ø´ØªÙ‡ (Ø§Ø®ÙŠØ±) Ø§Ú¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ø¹Ø¯ Ø§Ø² ',0),(389956,10833,'tr','Sonra geÃ§ If Ã¶denen',0),(389957,10833,'pl','JeÅ›li pÃ³Åºno wypÅ‚acane po',0),(389958,10833,'bg','ÐšÑ€Ð°Ñ Ð¸ Ð°ÐºÐ¾ Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ ÑÐ»ÐµÐ´',0),(389959,10833,'ur','Ø§Ú¯Ø± Ù…Ø±Ø­ÙˆÙ… Ú©Û’ Ø¨Ø¹Ø¯ Ø§Ø¯Ø§ Ú©ÛŒ',0),(389960,10833,'sr','ÐšÐ°ÑÐ½Ð¾ Ð°ÐºÐ¾ Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾ Ð½Ð°ÐºÐ¾Ð½',0),(389961,10833,'vi','Cuá»‘i náº¿u tráº£ sau',0),(389962,10833,'af','Laat indien Betaal Na',0),(389963,10833,'ro','DacÄƒ tÃ¢rzii plÄƒtite dupÄƒ',0),(389964,10833,'et','Hilja kui tasutakse pÃ¤rast',0),(389965,10833,'si','Pozno Äe plaÄa po',0),(389966,10833,'ba','Jika terlambat dibayar setelah',0),(389967,10833,'nl','Laat als betaald na',0),(389968,10833,'fi','MyÃ¶hÃ¤ssÃ¤, jos maksettu jÃ¤lkeen',0),(389969,10833,'no','Sent hvis betalt etter',0),(389970,10833,'da','Sen hvis betalt efter',0),(389971,10833,'ko','ëŠ¦ì€ ê²½ìš° í›„ ì§€ê¸‰',0),(389972,10833,'he','×× ×”×ž× ×•×— ×©×™×œ× ×œ××—×¨',0),(389973,10833,'el','Î¤Î­Î»Î· Î±Î½ Ï€Î»Î·ÏÏŽÎ½ÎµÏ„Î±Î¹',0),(389974,10833,'zh','å¦‚æžœé€¾æœŸåŽæ”¯ä»˜\r\n',0),(389975,10833,'sv','Sen om betalas efter',0),(389976,10833,'it','Fine se pagato dopo',0),(389977,10833,'tl','',0),(389978,10833,'th','à¸–à¹‰à¸²à¸ªà¸²à¸¢à¸Šà¸³à¸£à¸°à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸',0),(389979,10833,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ if à¤•à¥‡ à¤¬à¤¾à¤¦ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(389980,10833,'ms','Jika lewat dibayar selepas',0),(389981,10833,'ar','Ø¥Ø°Ø§ ØªØ£Ø®Ø± Ø¯ÙØ¹ Ø¨Ø¹Ø¯',0),(389982,10833,'fr','If tardive versÃ©e aprÃ¨s',0),(389983,10833,'jp','å ´åˆã¯å¾ŒåŠä»¥é™å¾Œã«æ”¯æ‰•ã‚ã‚Œã‚‹',0),(389984,10833,'pt','Tarde se paga apÃ³s o',0),(389985,10833,'ru','ÐšÐ¾Ð½ÐµÑ† ÐµÑÐ»Ð¸ Ð²Ñ‹Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ Ð¿Ð¾ÑÐ»Ðµ',0),(389986,10833,'es','Tade si Paga DepuÃ©s De',0),(389987,10833,'de','Nach dem spÃ¤ten If gezahlt',0),(389988,10833,'en','Late if Paid After',0),(389989,10834,'is','',0),(389990,10834,'dr','Ù†Ø§Ù… Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(389991,10834,'pr','Ù†Ø§Ù… Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ',0),(389992,10834,'tr','AdÄ± Bill doÄŸum',0),(389993,10834,'pl','Nazwa na rachunku',0),(389994,10834,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(389995,10834,'ur','Ù†Ø§Ù… Ú©Û’ Ø¨Ù„ Ù¾Ø±',0),(389996,10834,'sr','Ð˜Ð¼Ðµ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(389997,10834,'vi','TÃªn cá»§a hÃ³a Ä‘Æ¡n',0),(389998,10834,'af','Naam op die Wetsontwerp',0),(389999,10834,'ro','Numele de pe factura',0),(390000,10834,'et','Maksja nimi',0),(390001,10834,'si','Ime na raÄunu',0),(390002,10834,'ba','Nama pada tagihan',0),(390003,10834,'nl','Naam op factuur',0),(390004,10834,'fi','Nimi Bill',0),(390005,10834,'no','Navn pÃ¥ Bill',0),(390006,10834,'da','Navn pÃ¥ Bill',0),(390007,10834,'ko','ê³„ì‚° ì„œì— ì´ë¦„',0),(390008,10834,'he','×”×©× ×¢×œ ×‘×™×œ',0),(390009,10834,'el','ÎŒÎ½Î¿Î¼Î± ÏƒÏ„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(390010,10834,'zh','å¸å•åç§°\r\n',0),(390011,10834,'sv','Namn pÃ¥ faktura',0),(390012,10834,'it','Nome su Bill',0),(390013,10834,'tl','',0),(390014,10834,'th','à¸Šà¸·à¹ˆà¸­à¸šà¸™à¸•à¸±à¹‹à¸§',0),(390015,10834,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤ªà¤° à¤¨à¤¾à¤®',0),(390016,10834,'ms','Nama pada bil',0),(390017,10834,'ar','Ø§Ù„Ø§Ø³Ù… Ø¹Ù„Ù‰ Ø¨ÙŠÙ„',0),(390018,10834,'fr','Nom sur le projet de loi',0),(390019,10834,'jp','è«‹æ±‚æ›¸ä¸Šã®åå‰',0),(390020,10834,'pt','Nome na conta',0),(390021,10834,'ru','Ð˜Ð¼Ñ Ð½Ð° Ð‘Ð¸Ð»Ð»Ð°',0),(390022,10834,'es','Nombre en el Recibo',0),(390023,10834,'de','Namen auf Rechnung',0),(390024,10834,'en','Name on Bill',0),(390025,10835,'is','',0),(390026,10835,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ù‡ Ù…ÙˆÙ‚Ø¹',0),(390027,10835,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ù‡ Ù…ÙˆÙ‚Ø¹',0),(390028,10835,'tr','KaldÄ±nÄ±z tutar',0),(390029,10835,'pl','Kwota OnTime',0),(390030,10835,'bg','ÐžÐ½Ñ‚Ð°Ð¹Ð¼ ÑÑƒÐ¼Ð°',0),(390031,10835,'ur','Ø§ÙˆÙ†Ù¹Ø§Ù…ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(390032,10835,'sr','ÐÐ°Ð²Ñ€Ð¸Ñ˜ÐµÐ¼Ðµ Ð¸Ð·Ð½Ð¾Ñ',0),(390033,10835,'vi','Sá»‘ tiá»n Ontime',0),(390034,10835,'af','Ontime bedrag',0),(390035,10835,'ro','ONTIME suma',0),(390036,10835,'et','Ontime summa',0),(390037,10835,'si','Ontime znesek',0),(390038,10835,'ba','Peningkatan jumlah',0),(390039,10835,'nl','OnTime bedrag',0),(390040,10835,'fi','Ontime mÃ¤Ã¤rÃ¤',0),(390041,10835,'no','OnTime belÃ¸p',0),(390042,10835,'da','Ontime belÃ¸b',0),(390043,10835,'ko','Ontime ê¸ˆì•¡',0),(390044,10835,'he','×›×ž×•×ª Ontime',0),(390045,10835,'el','Ontime Ï€Î¿ÏƒÏŒ',0),(390046,10835,'zh','é¾™æ³°é‡‘é¢\r\n',0),(390047,10835,'sv','Ontime belopp',0),(390048,10835,'it','OnTime quantitÃ ',0),(390049,10835,'tl','',0),(390050,10835,'th','Ontime à¸¢à¸­à¸”',0),(390051,10835,'hi','Ontime à¤°à¤¾à¤¶à¤¿',0),(390052,10835,'ms','Jumlah Ontime',0),(390053,10835,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ontime',0),(390054,10835,'fr','OnTime montant',0),(390055,10835,'jp','Ontime é‡',0),(390056,10835,'pt','Ontime quantidade',0),(390057,10835,'ru','OnTime ÑÑƒÐ¼Ð¼Ð°',0),(390058,10835,'es','Monto a Tiempo',0),(390059,10835,'de','OnTime-Betrag',0),(390060,10835,'en','Ontime Amount',0),(390061,10836,'is','',0),(390062,10836,'dr','Ø¨Ø±Ø§ÙŠ Ø§ÙˆØ§ÙŠÙ„ â€“ Ø­Ù‚ÙˆÙ‚ Ù‚Ø¨Ù„ Ø§Ø² ',0),(390063,10836,'pr','Ø¨Ø±Ø§ÙŠ Ø§ÙˆØ§ÙŠÙ„ â€“ Ø­Ù‚ÙˆÙ‚ Ù‚Ø¨Ù„ Ø§Ø² ',0),(390064,10836,'tr','Erken, Ã¶nce Ã¶deme',0),(390065,10836,'pl','Na poczÄ…tku pÅ‚aciÄ‡ przed',0),(390066,10836,'bg','Ð—Ð° Ñ€Ð°Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð¿Ñ€ÐµÐ´Ð¸',0),(390067,10836,'ur','Ø¬Ù„Ø¯ Ú©Û’ Ù„ÛŒÛ’ØŒ Ø§Ø¯Ø§ Ø³Û’ Ù¾ÛÙ„Û’',0),(390068,10836,'sr','Ð—Ð° Ñ€Ð°Ð½Ð¾, Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ñ€Ðµ',0),(390069,10836,'vi','Cho sá»›m, tráº£ tiá»n trÆ°á»›c khi',0),(390070,10836,'af','Vir VroeÃ« Betaling, Betaal Voor',0),(390071,10836,'ro','Pentru devreme, plÄƒtiÅ£i Ã®nainte',0),(390072,10836,'et','Standardiseeritud, maksab enne',0),(390073,10836,'si','Za predÄasno plaÄilo pred',0),(390074,10836,'ba','Untuk lebih awal, membayar sebelum',0),(390075,10836,'nl','Voor vroeg, betalen voordat',0),(390076,10836,'fi','Alussa maksaa ennen',0),(390077,10836,'no','For tidlig, betale fÃ¸r',0),(390078,10836,'da','For tidligt, betale fÃ¸r',0),(390079,10836,'ko','ì¼ì° ì§€ë¶ˆ í•˜ê¸° ì „ì—',0),(390080,10836,'he','. ×ž×•×§×“×, ×œ×©×œ× ×œ×¤× ×™',0),(390081,10836,'el','Î“Î¹Î± Ï„Î¿ Î½Ï‰ÏÎ¯Ï‚, Î½Î± Ï€Î»Î·ÏÏŽÏƒÎµÎ¹ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ',0),(390082,10836,'zh','æ—©æœŸå‰æ”¯ä»˜\r\n',0),(390083,10836,'sv','FÃ¶r tidigt, betala innan',0),(390084,10836,'it','Per l\'inizio, pagare prima',0),(390085,10836,'tl','',0),(390086,10836,'th','à¹ƒà¸™à¸Šà¹ˆà¸§à¸‡à¸•à¹‰à¸™ à¸Šà¸³à¸£à¸°à¸à¹ˆà¸­à¸™',0),(390087,10836,'hi','à¤œà¤²à¥à¤¦à¥€ à¤•à¥‡ à¤²à¤¿à¤, à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(390088,10836,'ms','Bagi awal, membayar sebelum',0),(390089,10836,'ar','Ø¯ÙØ¹ Ù…Ø¨ÙƒØ±Ø§ØŒ Ù‚Ø¨Ù„',0),(390090,10836,'fr','Pour tÃ´t, payer avant',0),(390091,10836,'jp','å‰ã«ã€æ—©ãæ”¯æ‰•ã†',0),(390092,10836,'pt','Para o inÃ­cio, a pagar antes',0),(390093,10836,'ru','Ð”Ð»Ñ Ñ€Ð°Ð½Ð¾ Ð¿ÐµÑ€ÐµÐ´ Ñ‚ÐµÐ¼ ÐºÐ°Ðº Ð¾Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ',0),(390094,10836,'es','Para Temprano, Paga Antes',0),(390095,10836,'de','Zahlen Sie fÃ¼r frÃ¼h vor',0),(390096,10836,'en','For Early, Pay Before',0),(390097,10837,'is','',0),(390098,10837,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(390099,10837,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ',0),(390100,10837,'tr','SatÄ±cÄ±nÄ±n adÄ± iÃ§in Ã¶deme',0),(390101,10837,'pl','OpÅ‚aca siÄ™ nazwa dostawcy',0),(390102,10837,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð° Ð¸Ð¼Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(390103,10837,'ur','ÙˆÛŒÙ†ÚˆØ± Ù†Ø§Ù… Ù…ÛŒÚº Ø§Ø¯Ø§',0),(390104,10837,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð° Ð¸Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(390105,10837,'vi','thanh toÃ¡n cho nhÃ  cung cáº¥p tÃªn',0),(390106,10837,'af','Betaal Aan Verskaffer Naam',0),(390107,10837,'ro','Plati furnizor de nume',0),(390108,10837,'et','Tasuma mÃ¼Ã¼ja nimetus',0),(390109,10837,'si','PlaÄati za ime dobavitelja',0),(390110,10837,'ba','Membayar untuk nama Penjual',0),(390111,10837,'nl','Betalen aan naam van leverancier',0),(390112,10837,'fi','Maksaa toimittajan nimi',0),(390113,10837,'no','Betale til leverandÃ¸r',0),(390114,10837,'da','Betale til kreditornavnet',0),(390115,10837,'ko','ê³µê¸‰ ì—…ì²´ ì´ë¦„ì— ì§€ë¶ˆ',0),(390116,10837,'he','×œ×©×œ× ×¢×œ ×©× ×”×¡×¤×§',0),(390117,10837,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ ÏƒÏ„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(390118,10837,'zh','æ”¶æ¬¾ä¾›åº”å•†åç§°\r\n',0),(390119,10837,'sv','Betala till leverantÃ¶rens namn',0),(390120,10837,'it','Pagare a nome del fornitore',0),(390121,10837,'tl','',0),(390122,10837,'th','à¸Šà¸³à¸£à¸°à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(390123,10837,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤¨à¤¾à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(390124,10837,'ms','Membayar kepada penjual nama',0),(390125,10837,'ar','Ø¯ÙØ¹ Ø¥Ù„Ù‰ Ø§Ø³Ù… Ø§Ù„Ù…ÙˆØ±Ø¯',0),(390126,10837,'fr','Payer au nom du vendeur',0),(390127,10837,'jp','æ”¯æ‰•ã„å…ˆã®ä»•å…¥å…ˆåå‰',0),(390128,10837,'pt','Pagar ao fornecedor nome',0),(390129,10837,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð¸Ð¼Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(390130,10837,'es','Paga a Nombre de Proveedor',0),(390131,10837,'de','Anbieter Namen bezahlen',0),(390132,10837,'en','Pay To Vendor Name',0),(390133,10838,'is','',0),(390134,10838,'dr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(390135,10838,'pr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(390136,10838,'tr','LÃ¼tfen vergi tÃ¼rÃ¼ ekleyin',0),(390137,10838,'pl','ProszÄ™ podaÄ‡ typ podatku',0),(390138,10838,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð”Ð”Ð¡',0),(390139,10838,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù¹ÛŒÚ©Ø³ Ù‚Ø³Ù… Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(390140,10838,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð²Ñ€ÑÑ‚Ñƒ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(390141,10838,'vi','vui lÃ²ng bao gá»“m loáº¡i thuáº¿',0),(390142,10838,'af','Sluit asseblief Belastingtipe in',0),(390143,10838,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i taxa tip',0),(390144,10838,'et','Palun lisage maksu liik',0),(390145,10838,'si','Prosimo, da vkljuÄite izstavljenih',0),(390146,10838,'ba','Sertakan tipe pajak',0),(390147,10838,'nl','Gelieve te omvatten belasting Type',0),(390148,10838,'fi','LiitÃ¤ ALV-tyyppi',0),(390149,10838,'no','Ta med mva-typen',0),(390150,10838,'da','VedlÃ¦g afgiftstype.',0),(390151,10838,'ko','ì„¸ê¸ˆ ìœ í˜• í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(390152,10838,'he','×× × ×›×œ×•×œ ×¡×•×’ ×ž×¡',0),(390153,10838,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„ÏÏ€Î¿Ï‚ Î¦Î Î‘',0),(390154,10838,'zh','è¯·åˆ—å…¥ç¨ŽåŠ¡ç±»åž‹\r\n',0),(390155,10838,'sv','VÃ¤nligen inkludera typ av skatte',0),(390156,10838,'it','Si prega di includere tipo di tassa',0),(390157,10838,'tl','',0),(390158,10838,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸™à¸´à¸”à¸ à¸²à¸©à¸µ',0),(390159,10838,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(390160,10838,'ms','Sila sertakan jenis cukai',0),(390161,10838,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(390162,10838,'fr','Veuillez indiquer le Type de taxe',0),(390163,10838,'jp','ç¨Žã®ç¨®é¡žã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(390164,10838,'pt','Por favor inclua o tipo de imposto',0),(390165,10838,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(390166,10838,'es','Por Favor Incluye Tipo de Impuesto',0),(390167,10838,'de','Bitte geben Sie Steuerart',0),(390168,10838,'en','Please Include Tax Type',0),(390169,10839,'is','',0),(390170,10839,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø®ØªÙ…Ø§Ù† ',0),(390171,10839,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ø®ØªÙ…Ø§Ù† ',0),(390172,10839,'tr','Ä°nÅŸaat emlak vergileri',0),(390173,10839,'pl','Podatki od nieruchomoÅ›ci dla budynku',0),(390174,10839,'bg','Ð”Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚Ñ‚Ð° Ð·Ð° Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ',0),(390175,10839,'ur','Ø¹Ù…Ø§Ø±Øª Ú©Û’ Ù„Ø¦Û’ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³',0),(390176,10839,'sr','ÐŸÐ¾Ñ€ÐµÐ·Ðµ Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð·Ð° Ð·Ð³Ñ€Ð°Ð´Ñƒ',0),(390177,10839,'vi','Thuáº¿ báº¥t Ä‘á»™ng sáº£n cho xÃ¢y dá»±ng',0),(390178,10839,'af','Eiendomsbelasting vir Gebou',0),(390179,10839,'ro','Impozitele pe proprietate pentru constructii',0),(390180,10839,'et','Maamaksuga hoone',0),(390181,10839,'si','Davkov na nepremiÄnine za stavbe',0),(390182,10839,'ba','Pajak properti untuk bangunan',0),(390183,10839,'nl','Belastingen van het bezit voor gebouw',0),(390184,10839,'fi','KiinteistÃ¶veron rakentamiseen',0),(390185,10839,'no','Eiendomsskatt for bygg',0),(390186,10839,'da','Ejendomsskatter for bygningen',0),(390187,10839,'ko','ê±´ë¬¼ì— ëŒ€ í•œ ìž¬ì‚°ì„¸',0),(390188,10839,'he','×ž×¡×™ ×§×¨×§×¢ ×œ×‘× ×™×”',0),(390189,10839,'el','Î¤Î¿Ï…Ï‚ Ï†ÏŒÏÎ¿Ï…Ï‚ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ Î³Î¹Î± ÎºÏ„Î®ÏÎ¹Î¿',0),(390190,10839,'zh','å»ºç­‘åœ°äº§ç¨Ž\r\n',0),(390191,10839,'sv','Fastighetsskatt fÃ¶r byggnad',0),(390192,10839,'it','Tasse di proprietÃ  per l\'edilizia',0),(390193,10839,'tl','',0),(390194,10839,'th','à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¹ƒà¸™à¸­à¸²à¸„à¸²à¸£',0),(390195,10839,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤°à¥‹à¤‚ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤²à¤¿à¤',0),(390196,10839,'ms','Cukai harta bagi bangunan',0),(390197,10839,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ© Ù„Ø¨Ù†Ø§Ø¡',0),(390198,10839,'fr','ImpÃ´ts fonciers pour la construction',0),(390199,10839,'jp','å»ºç‰©ã®å›ºå®šè³‡ç”£ç¨Ž',0),(390200,10839,'pt','Impostos de propriedade para a construÃ§Ã£o',0),(390201,10839,'ru','ÐÐ°Ð»Ð¾Ð³Ð¸ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ð´Ð»Ñ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(390202,10839,'es','Impuesto Predial para Edificio',0),(390203,10839,'de','Grundsteuern fÃ¼r GebÃ¤ude',0),(390204,10839,'en','Property Taxes for Building',0),(390205,10840,'is','',0),(390206,10840,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ',0),(390207,10840,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª ',0),(390208,10840,'tr','Ã–denen vergi ve benzerleri',0),(390209,10840,'pl','PÅ‚atnoÅ›ci podatku',0),(390210,10840,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(390211,10840,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº',0),(390212,10840,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(390213,10840,'vi','Thanh toÃ¡n thuáº¿',0),(390214,10840,'af','Belasting Betalings',0),(390215,10840,'ro','PlÄƒÅ£ile fiscale',0),(390216,10840,'et','Tulumaksu',0),(390217,10840,'si','PlaÄila davka',0),(390218,10840,'ba','Pembayaran pajak',0),(390219,10840,'nl','Fiscaal betalingen',0),(390220,10840,'fi','Verojen maksut',0),(390221,10840,'no','-Betalinger',0),(390222,10840,'da','Skattebetalinger',0),(390223,10840,'ko','ì„¸ê¸ˆ ë‚©ë¶€',0),(390224,10840,'he','×ª×©×œ×•×ž×™ ×ž×™×¡×™×',0),(390225,10840,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï†ÏŒÏÏ‰Î½',0),(390226,10840,'zh','çº³ç¨Ž\r\n',0),(390227,10840,'sv','Skattebetalningar',0),(390228,10840,'it','Pagamenti fiscali',0),(390229,10840,'tl','',0),(390230,10840,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¸ à¸²à¸©à¸µ',0),(390231,10840,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(390232,10840,'ms','Bayaran cukai',0),(390233,10840,'ar','Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(390234,10840,'fr','Paiements d\'impÃ´t',0),(390235,10840,'jp','ç¨Žã®æ”¯æ‰•ã„',0),(390236,10840,'pt','Pagamento de impostos',0),(390237,10840,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸',0),(390238,10840,'es','Pagos de Impuestos',0),(390239,10840,'de','Steuerzahlungen',0),(390240,10840,'en','Tax Payments',0),(390241,10841,'is','',0),(390242,10841,'dr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(390243,10841,'pr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(390244,10841,'tr','Emlak vergisi tÃ¼rÃ¼',0),(390245,10841,'pl','Typ podatku od nieruchomoÅ›ci',0),(390246,10841,'bg','Ð¢Ð¸Ð¿ Ð´Ð°Ð½ÑŠÐº',0),(390247,10841,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù…',0),(390248,10841,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ñ‚Ð¸Ð¿Ð°',0),(390249,10841,'vi','loáº¡i thuáº¿ tÃ i sáº£n',0),(390250,10841,'af','Eiendomsbelasting Tipe',0),(390251,10841,'ro','Tip de proprietate fiscale',0),(390252,10841,'et','Maamaks tÃ¼Ã¼p',0),(390253,10841,'si','Vrsta davka na nepremiÄnine',0),(390254,10841,'ba','Jenis pajak properti',0),(390255,10841,'nl','Onroerende voorheffing Type',0),(390256,10841,'fi','KiinteistÃ¶vero tyyppi',0),(390257,10841,'no','Eiendomsskatt Type',0),(390258,10841,'da','Ejendomsskat Type',0),(390259,10841,'ko','ë¶€ë™ì‚° ì„¸ê¸ˆ ì¢…ë¥˜',0),(390260,10841,'he','×¡×•×’ ×ž×¡ ×¨×›×•×©',0),(390261,10841,'el','Î¤ÏÏ€Î¿Ï‚ Ï†ÏŒÏÎ¿Ï… Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚',0),(390262,10841,'zh','ç‰©ä¸šç¨Žç±»åž‹\r\n',0),(390263,10841,'sv','Fastighetsskatt typ',0),(390264,10841,'it','Tipo di tassa di proprietÃ .',0),(390265,10841,'tl','',0),(390266,10841,'th','à¸Šà¸™à¸´à¸”à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(390267,10841,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤ªà¥à¤°à¤•à¤¾à¤°',0),(390268,10841,'ms','Jenis cukai harta',0),(390269,10841,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ©',0),(390270,10841,'fr','Type de taxe fonciÃ¨re',0),(390271,10841,'jp','è²¡ç”£ç¨Žã®ç¨®é¡ž',0),(390272,10841,'pt','Tipo de imposto sobre a propriedade',0),(390273,10841,'ru','Ð¢Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾',0),(390274,10841,'es','Impuesto Predial Tipo',0),(390275,10841,'de','Grundsteuer-Typ',0),(390276,10841,'en','Property Tax Type',0),(390277,10842,'is','',0),(390278,10842,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†ÙˆØ§Ø¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(390279,10842,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†ÙˆØ§Ø¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(390280,10842,'tr','Emlak vergisi tÃ¼rleri ekleme',0),(390281,10842,'pl','DodaÄ‡ rodzaj podatku od nieruchomoÅ›ci',0),(390282,10842,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(390283,10842,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ø§Ù‚Ø³Ø§Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(390284,10842,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ‚Ð¸Ð¿Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ',0),(390285,10842,'vi','thÃªm loáº¡i thuáº¿ tÃ i sáº£n',0),(390286,10842,'af','Eiendomsbelasting Tipes Byvoeg',0),(390287,10842,'ro','Adauga impozitul pe tipuri',0),(390288,10842,'et','Maamaks tÃ¼Ã¼pide lisamine',0),(390289,10842,'si','Dodati davek od premoÅ¾enja vrste',0),(390290,10842,'ba','Menambahkan jenis pajak properti',0),(390291,10842,'nl','Onroerende voorheffing typen toevoegen',0),(390292,10842,'fi','KiinteistÃ¶vero tyypit lisÃ¤Ã¤',0),(390293,10842,'no','Eiendomsskatt typer legge',0),(390294,10842,'da','Ejendomsskat typer tilfÃ¸je',0),(390295,10842,'ko','ë¶€ë™ì‚° ì„¸ê¸ˆ ì¢…ë¥˜ ì¶”ê°€',0),(390296,10842,'he','×œ×”×•×¡×™×£ ×¡×•×’×™ ×ž×¡ ×¨×›×•×©',0),(390297,10842,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï„ÏÏ€Î¿Ï…Ï‚ Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï… Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚',0),(390298,10842,'zh','ç‰©ä¸šç¨Žç§æ·»åŠ \r\n',0),(390299,10842,'sv','Fastighetsskatt typer lÃ¤gga till',0),(390300,10842,'it','Aggiungere tipi di tasse di proprietÃ .',0),(390301,10842,'tl','',0),(390302,10842,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸›à¸£à¸°à¹€à¸ à¸—',0),(390303,10842,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(390304,10842,'ms','Tambah jenis cukai harta',0),(390305,10842,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù†ÙˆØ§Ø¹ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ',0),(390306,10842,'fr','Ajouter des Types d\'impÃ´t foncier',0),(390307,10842,'jp','å›ºå®šè³‡ç”£ç¨Žã®ç¨®é¡žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(390308,10842,'pt','Adicionar tipos de imposto de propriedade.',0),(390309,10842,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾',0),(390310,10842,'es','Impuesto Predial Agregar Tipos',0),(390311,10842,'de','Grundsteuer-Typen hinzufÃ¼gen',0),(390312,10842,'en','Property Tax Types Add',0),(390313,10843,'is','',0),(390314,10843,'dr','Ø­Ø°Ù Ø§Ù†ÙˆØ§Ø¹  Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(390315,10843,'pr','Ø­Ø°Ù Ø§Ù†ÙˆØ§Ø¹  Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(390316,10843,'tr','Emlak vergisi tÃ¼rÃ¼ Sil',0),(390317,10843,'pl','UsuÅ„ rodzaj podatku od nieruchomoÅ›ci',0),(390318,10843,'bg','Ð”Ð°Ð½ÑŠÐº Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(390319,10843,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ø§Ù‚Ø³Ø§Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(390320,10843,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸ Ð”ÐµÐ»ÐµÑ‚Ðµ',0),(390321,10843,'vi','xÃ³a loáº¡i thuáº¿ tÃ i sáº£n',0),(390322,10843,'af','Eiendomsbelasting Tipes Skrap',0),(390323,10843,'ro','Åžtergere de tipuri de proprietate fiscale',0),(390324,10843,'et','Maamaks tÃ¼Ã¼bid kustutamine',0),(390325,10843,'si','Davek na nepremiÄnine vrste IzbriÅ¡i',0),(390326,10843,'ba','Hapus jenis pajak properti',0),(390327,10843,'nl','Onroerende voorheffing typen verwijderen',0),(390328,10843,'fi','KiinteistÃ¶vero tyypit Poista',0),(390329,10843,'no','Eiendomsskatt typer Slett',0),(390330,10843,'da','Ejendomsskat typer slet',0),(390331,10843,'ko','ë¶€ë™ì‚° ì„¸ê¸ˆ ì¢…ë¥˜ ì‚­ì œ',0),(390332,10843,'he','×ž×—×§ ×¡×•×’×™ ×ž×¡ ×¨×›×•×©',0),(390333,10843,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„ÏÏ€Î¿Ï…Ï‚ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚',0),(390334,10843,'zh','ç‰©ä¸šç¨Žç§åˆ é™¤\r\n',0),(390335,10843,'sv','Fastighetsskatt typer ta bort',0),(390336,10843,'it','Elimina tipi di imposta fondiaria',0),(390337,10843,'tl','',0),(390338,10843,'th','à¸¥à¸šà¸Šà¸™à¸´à¸”à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(390339,10843,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(390340,10843,'ms','Hapuskan jenis cukai harta',0),(390341,10843,'ar','Ø­Ø°Ù Ø£Ù†ÙˆØ§Ø¹ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ',0),(390342,10843,'fr','Suppression de Types de taxes fonciÃ¨res',0),(390343,10843,'jp','å›ºå®šè³‡ç”£ç¨Žã®ç¨®é¡žã®å‰Šé™¤',0),(390344,10843,'pt','Excluir tipos de imposto sobre a propriedade',0),(390345,10843,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð¾Ð² Ð½Ð°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾',0),(390346,10843,'es','Impuesto Predial Eliminar Tipos',0),(390347,10843,'de','Grundsteuer Typen lÃ¶schen',0),(390348,10843,'en','Property Tax Types Delete',0),(390349,10844,'is','',0),(390350,10844,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†ÙˆØ§Ø¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(390351,10844,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†ÙˆØ§Ø¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(390352,10844,'tr','Emlak vergisi tÃ¼rlerini gÃ¼ncelleÅŸtirme',0),(390353,10844,'pl','Podatek od nieruchomoÅ›ci typy aktualizacji',0),(390354,10844,'bg','Ð”Ð°Ð½ÑŠÐº Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(390355,10844,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ø§Ù‚Ø³Ø§Ù… ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(390356,10844,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ð¸Ð¿Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ',0),(390357,10844,'vi','cáº­p nháº­t loáº¡i thuáº¿ tÃ i sáº£n',0),(390358,10844,'af','Eiendomsbelasting Tipes Opdateer',0),(390359,10844,'ro','Actualizare de tipuri de proprietate fiscale',0),(390360,10844,'et','Maamaks tÃ¼Ã¼bid Update',0),(390361,10844,'si','Davek na nepremiÄnine vrste posodobitev',0),(390362,10844,'ba','Pajak properti jenis Update',0),(390363,10844,'nl','Onroerende voorheffing typen Update',0),(390364,10844,'fi','KiinteistÃ¶vero tyypit pÃ¤ivitys',0),(390365,10844,'no','Eiendomsskatt typer oppdatering',0),(390366,10844,'da','Ejendomsskat typer opdatering',0),(390367,10844,'ko','ìž¬ì‚°ì„¸ í˜•ì‹ ì—…ë°ì´íŠ¸',0),(390368,10844,'he','×¢×“×›×•×Ÿ ×¡×•×’×™× ×ž×¡ ×¨×›×•×©',0),(390369,10844,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï…Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(390370,10844,'zh','ç‰©ä¸šç¨Žç§æ›´æ–°\r\n',0),(390371,10844,'sv','Fastighetsskatt typer uppdatering',0),(390372,10844,'it','Aggiornamento tipi di tassa di proprietÃ .',0),(390373,10844,'tl','',0),(390374,10844,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸›à¸£à¸°à¹€à¸ à¸—',0),(390375,10844,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(390376,10844,'ms','Kemaskini jenis cukai harta',0),(390377,10844,'ar','ØªØ­Ø¯ÙŠØ« Ø£Ù†ÙˆØ§Ø¹ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ',0),(390378,10844,'fr','Mise Ã  jour des Types de taxes fonciÃ¨res',0),(390379,10844,'jp','å›ºå®šè³‡ç”£ç¨Žã®ç¨®é¡žã®æ›´æ–°ãƒ—ãƒ­ã‚°ãƒ©ãƒ ',0),(390380,10844,'pt','AtualizaÃ§Ã£o de tipos de imposto sobre a propriedade',0),(390381,10844,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð¾Ð² Ð½Ð°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾',0),(390382,10844,'es','Impuesto Predial Actualizar Tipos',0),(390383,10844,'de','Grundsteuer-Typen-Update',0),(390384,10844,'en','Property Tax Types Update',0),(390385,10845,'is','',0),(390386,10845,'dr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(390387,10845,'pr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(390388,10845,'tr','Emlak vergisi tÃ¼rÃ¼ baÅŸarÄ±yla eklendi',0),(390389,10845,'pl','PomyÅ›lnie dodano typ podatku od nieruchomoÅ›ci',0),(390390,10845,'bg','Ð”Ð°Ð½ÑŠÐº ÑÐ³Ñ€Ð°Ð´Ð¸ Ñ‚Ð¸Ð¿ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(390391,10845,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù…',0),(390392,10845,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(390393,10845,'vi','Ä‘Ã£ thÃªm loáº¡i thuáº¿ tÃ i sáº£n thÃ nh cÃ´ng',0),(390394,10845,'af','Eiendomsbelastingtipe Suksesvol Bygevoeg',0),(390395,10845,'ro','Tip de proprietate fiscale adÄƒugat cu succes',0),(390396,10845,'et','Maamaks tÃ¼Ã¼p lisatud',0),(390397,10845,'si','UspeÅ¡no dodana vrsta davka na nepremiÄnine',0),(390398,10845,'ba','Jenis pajak properti ditambahkan berhasil',0),(390399,10845,'nl','Onroerende voorheffing Type toegevoegd',0),(390400,10845,'fi','KiinteistÃ¶vero tyyppi lisÃ¤Ã¤minen onnistui',0),(390401,10845,'no','Eiendomsskatt Type lagt',0),(390402,10845,'da','Ejendomsskat Type tilfÃ¸jet',0),(390403,10845,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ìž¬ì‚°ì„¸ ìœ í˜•',0),(390404,10845,'he','×¡×•×’ ×ž×¡ ×¨×›×•×© × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(390405,10845,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(390406,10845,'zh','ç‰©ä¸šç¨Žç±»åž‹æ·»åŠ æˆåŠŸ\r\n',0),(390407,10845,'sv','Fastighetsskatt typ lagts',0),(390408,10845,'it','Tipo di proprietÃ  fiscale aggiunto con successo',0),(390409,10845,'tl','',0),(390410,10845,'th','à¸Šà¸™à¸´à¸”à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(390411,10845,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(390412,10845,'ms','Jenis cukai harta yang berjaya menambah',0),(390413,10845,'ar','Ø£Ø¶ÙŠÙ Ù†ÙˆØ¹ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(390414,10845,'fr','Type de taxe fonciÃ¨re ajoutÃ© avec succÃ¨s',0),(390415,10845,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ç¨Žã‚¿ã‚¤ãƒ—',0),(390416,10845,'pt','Tipo de propriedade imposto adicionado com sucesso',0),(390417,10845,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(390418,10845,'es','Impuesto Predial Tipo Agregado Exitosamente',0),(390419,10845,'de','Grundsteuer Typ erfolgreich hinzugefÃ¼gt',0),(390420,10845,'en','Property Tax Type Added Successfully',0),(390421,10846,'is','',0),(390422,10846,'dr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ù‡ Ø«Ø¨Øª Ù…Ø§Ù„ÙŠØ§Øª Ù¾ÙŠÙˆØ³Øª Ø´Ø¯ ',0),(390423,10846,'pr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ù‡ Ø«Ø¨Øª Ù…Ø§Ù„ÙŠØ§Øª Ù¾ÙŠÙˆØ³Øª Ø´Ø¯ ',0),(390424,10846,'tr','GiriÅŸ vergi baÄŸlÄ± emlak vergisi tÃ¼rÃ¼',0),(390425,10846,'pl','Podatek od nieruchomoÅ›ci typu doÅ‚Ä…czone do opodatkowania wpisu',0),(390426,10846,'bg','Ð”Ð°Ð½ÑŠÐº Ð²Ð¸Ð´ ÐºÑŠÐ¼ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð¸Ñ',0),(390427,10846,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ù‚Ø³Ù… Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù¹ÛŒÚ©Ø³ Ø³Û’ Ù…Ù†Ø³Ù„Ú©',0),(390428,10846,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ñ‚Ð¸Ð¿Ð° Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¼ Ð¿Ð¾Ñ€ÐµÑÐºÐ¸Ð¼ ÑÑ‚Ð°Ð²ÐºÐ°',0),(390429,10846,'vi','loáº¡i thuáº¿ tÃ i sáº£n Ä‘Æ°á»£c Ä‘Ã­nh kÃ¨m Ä‘á»ƒ ghi thuáº¿',0),(390430,10846,'af','Eiendomsbelastingtipe is Verbind met Belastinginskrywing',0),(390431,10846,'ro','Tip de proprietate fiscale ataÅŸat pentru a taxa de intrare',0),(390432,10846,'et','Maamaks seotud maksu kande tÃ¼Ã¼p',0),(390433,10846,'si','Davek na nepremiÄnine vrsto pritrjena davÄnega postavke',0),(390434,10846,'ba','Jenis pajak properti yang melekat pada pajak entri',0),(390435,10846,'nl','Onroerende voorheffing Type aangesloten fiscale Entry',0),(390436,10846,'fi','KiinteistÃ¶vero tyyppi liitetty ALV-tapahtuma',0),(390437,10846,'no','Eiendomsskatt Type knyttet til oppfÃ¸ringen',0),(390438,10846,'da','Ejendomsskat Type knyttet til at beskatte post',0),(390439,10846,'ko','ìž¬ì‚°ì„¸ ìœ í˜• ì„¸ê¸ˆ í•­ëª©ì— ì—°ê²° ëœ',0),(390440,10846,'he','×¡×•×’ ×ž×¡ ×¨×›×•×© ×”×ž×¦×•×¨×¤×ª ×ž×¡ ×¢×¨×š',0),(390441,10846,'el','Î¦ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï… Ï€Î¿Ï… ÏƒÏ…Î½Î´Î­Î¿Î½Ï„Î±Î¹ Î¼Îµ Ï„Î·Î½ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® ÎµÎ³Î³ÏÎ±Ï†Î®',0),(390442,10846,'zh','ç‰©ä¸šç¨Žé™„åŠ åˆ°ç¨Žæ¡ç›®\r\n',0),(390443,10846,'sv','Fastighetsskatt typ kopplad till posten',0),(390444,10846,'it','Tipo di tassa di proprietÃ  associata a imposta la voce',0),(390445,10846,'tl','',0),(390446,10846,'th','à¸Šà¸™à¸´à¸”à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸à¸±à¸šà¸ à¸²à¸©à¸µà¸£à¸²à¸¢à¸à¸²à¸£',0),(390447,10846,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¥‡ à¤œà¥à¤¡à¤¼à¥€',0),(390448,10846,'ms','Jenis cukai harta yang melekat pada cukai kemasukan',0),(390449,10846,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ© Ø§Ù„Ù…Ø±ÙÙ‚Ø© Ù„Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(390450,10846,'fr','Type de taxe fonciÃ¨re jointe Ã  la taxe d\'entrÃ©e',0),(390451,10846,'jp','ç¨Žã®ã‚¨ãƒ³ãƒˆãƒªã«æŽ¥ç¶šã•ã‚Œã¦ã„ã‚‹å›ºå®šè³‡ç”£ç¨Žã‚¿ã‚¤ãƒ—',0),(390452,10846,'pt','Tipo de imposto sobre a propriedade anexado para entrada de impostos',0),(390453,10846,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ñ‚Ð¸Ð¿Ð° Ð¿Ñ€Ð¸Ð´Ð°ÐµÑ‚ Ð½Ð°Ð»Ð¾Ð³',0),(390454,10846,'es','Impuesto Predial Tipo Juntado a la Entrada de Impuesto',0),(390455,10846,'de','Grundsteuer Typ angefÃ¼gt, um die Steuer-Eintrag',0),(390456,10846,'en','Property Tax Type Attached to Tax Entry',0),(390457,10847,'is','',0),(390458,10847,'dr','Ø­Ø°Ù Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(390459,10847,'pr','Ø­Ø°Ù Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(390460,10847,'tr','Emlak vergisi tÃ¼rÃ¼ silme baÅŸarÄ±sÄ±z oldu-',0),(390461,10847,'pl','Podatek od nieruchomoÅ›ci typu usunÄ…Ä‡ - nie powiodÅ‚o siÄ™',0),(390462,10847,'bg','Ð”Ð°Ð½ÑŠÐº ÑÐ³Ñ€Ð°Ð´Ð¸ Ñ‚Ð¸Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ - Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(390463,10847,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§-',0),(390464,10847,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ñ‚Ð¸Ð¿Ð° Ð±Ñ€Ð¸ÑÐ°ÑšÐµ - Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(390465,10847,'vi','xÃ³a loáº¡i thuáº¿ tÃ i sáº£n- tháº¥t báº¡i\r\n',0),(390466,10847,'af','Skraping van Eiendomsbelasting Tipe - Gefaal',0),(390467,10847,'ro','Proprietate fiscale tip ÅŸterge - nu a reuÈ™it',0),(390468,10847,'et','Maamaks tÃ¼Ã¼bi Delete - nurjus',0),(390469,10847,'si','Davek na nepremiÄnine tipa Delete - ni uspelo',0),(390470,10847,'ba','Hapus jenis pajak properti - gagal',0),(390471,10847,'nl','Onroerende voorheffing Type verwijderen - is mislukt',0),(390472,10847,'fi','KiinteistÃ¶vero tyyppi poisto - epÃ¤onnistui',0),(390473,10847,'no','Eiendomsskatt Type slette - mislyktes',0),(390474,10847,'da','Ejendomsskat Type slet - mislykkedes',0),(390475,10847,'ko','ìž¬ì‚°ì„¸ ìœ í˜• ì‚­ì œ-ì‹¤íŒ¨',0),(390476,10847,'he','×ž×—×§ ×¡×•×’ ×ž×¡ ×¨×›×•×© - × ×›×©×œ',0),(390477,10847,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï… Î´Î¹Î±Î³ÏÎ±Ï†Î® - Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(390478,10847,'zh','ç‰©ä¸šç¨Žç±»åž‹åˆ é™¤ -å¤±è´¥\r\n',0),(390479,10847,'sv','Fastighetsskatt typ bort - misslyckades',0),(390480,10847,'it','Eliminazione di tipo imposta fondiaria - non riuscita',0),(390481,10847,'tl','',0),(390482,10847,'th','à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸Šà¸™à¸´à¸”à¸¥à¸š - à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(390483,10847,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤¹à¤Ÿà¤¾à¤à¤ - à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(390484,10847,'ms','Hapuskan jenis cukai harta - gagal',0),(390485,10847,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ©--ÙØ´Ù„',0),(390486,10847,'fr','Ã‰chouÃ© de la taxe fonciÃ¨re Type suppression-',0),(390487,10847,'jp','å›ºå®šè³‡ç”£ç¨Žã®ç¨®é¡žå‰Šé™¤ - å¤±æ•—',0),(390488,10847,'pt','Imposto sobre a propriedade tipo - falha ao excluir',0),(390489,10847,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ñ‚Ð¸Ð¿Ð° Delete - Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(390490,10847,'es','Impuesto Predial Eliminar Tipo - FallÃ³',0),(390491,10847,'de','Grundsteuer Typ LÃ¶schen - fehlgeschlagen',0),(390492,10847,'en','Property Tax Type Delete - Failed',0),(390493,10848,'is','',0),(390494,10848,'dr','Ø­Ø°Ù Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(390495,10848,'pr','Ø­Ø°Ù Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(390496,10848,'tr','Emlak vergisi tÃ¼rÃ¼ baÅŸarÄ±yla silindi',0),(390497,10848,'pl','UsuniÄ™ty typ podatku od nieruchomoÅ›ci',0),(390498,10848,'bg','Ð”Ð°Ð½ÑŠÐº ÑÐ³Ñ€Ð°Ð´Ð¸ Ñ‚Ð¸Ð¿ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(390499,10848,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù…',0),(390500,10848,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(390501,10848,'vi','xÃ³a loáº¡i thuáº¿ tÃ i sáº£n- thÃ nh cÃ´ng',0),(390502,10848,'af','Eiendomsbelastingtipe Suksesvol Geskrap',0),(390503,10848,'ro','Tip de proprietate fiscale eliminÄƒ cu succes',0),(390504,10848,'et','Maamaks tÃ¼Ã¼p edukalt kustutatud',0),(390505,10848,'si','Davek na nepremiÄnine vrsto uspeÅ¡no izbrisana',0),(390506,10848,'ba','Jenis pajak properti dihapus berhasil',0),(390507,10848,'nl','Onroerende voorheffing Type met succes verwijderd',0),(390508,10848,'fi','KiinteistÃ¶vero tyyppi poistettu',0),(390509,10848,'no','Eiendomsskatt Type slettet',0),(390510,10848,'da','Ejendomsskat Type slettet',0),(390511,10848,'ko','ìž¬ì‚°ì„¸ ìœ í˜•ì„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(390512,10848,'he','×¡×•×’ ×ž×¡ ×¨×›×•×© × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(390513,10848,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(390514,10848,'zh','ç‰©ä¸šç¨Žåž‹æˆåŠŸåˆ é™¤\r\n',0),(390515,10848,'sv','Fastighetsskatt typ raderades',0),(390516,10848,'it','Tipo di tassa di proprietÃ  eliminato con successo',0),(390517,10848,'tl','',0),(390518,10848,'th','à¸Šà¸™à¸´à¸”à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(390519,10848,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(390520,10848,'ms','Jenis harta cukai dihapuskan dengan jayanya',0),(390521,10848,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(390522,10848,'fr','Type de taxe fonciÃ¨re supprimÃ© avec succÃ¨s',0),(390523,10848,'jp','å›ºå®šè³‡ç”£ç¨Žã‚¿ã‚¤ãƒ—ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(390524,10848,'pt','Tipo de propriedade imposto excluÃ­do com sucesso',0),(390525,10848,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(390526,10848,'es','Impuesto Predial Tipo Eliminado Exitosamente',0),(390527,10848,'de','Grundsteuer Typ erfolgreich gelÃ¶scht',0),(390528,10848,'en','Property Tax Type Deleted Successfully',0),(390529,10849,'is','',0),(390530,10849,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(390531,10849,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(390532,10849,'tr','Emlak vergisi tÃ¼rÃ¼ gÃ¼ncelleÅŸtirilemedi',0),(390533,10849,'pl','Podatek od nieruchomoÅ›ci typ aktualizacji nie powiodÅ‚o siÄ™',0),(390534,10849,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº ÑÐ³Ñ€Ð°Ð´Ð¸ Ñ‚Ð¸Ð¿',0),(390535,10849,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ù‚Ø³Ù… Ú©Û’ ØªØ¬Ø¯ÛŒØ¯ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§',0),(390536,10849,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ñ‚Ð¸Ð¿Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(390537,10849,'vi','cáº­p nháº­t loáº¡i thuáº¿ tÃ i sáº£n tháº¥t báº¡i',0),(390538,10849,'af','Opdatering van Eiendomsbelasting Tipe - Gefaal',0),(390539,10849,'ro','Impozitul pe proprietate de tip Update nu a reuÈ™it',0),(390540,10849,'et','Maamaks tÃ¼Ã¼p vÃ¤rskendamine nurjus',0),(390541,10849,'si','Davek na nepremiÄnine ni mogoÄe posodobiti za vrsto',0),(390542,10849,'ba','Gagal Update jenis pajak properti',0),(390543,10849,'nl','Onroerende voorheffing Type Update is mislukt',0),(390544,10849,'fi','KiinteistÃ¶vero tyypin pÃ¤ivitys epÃ¤onnistui',0),(390545,10849,'no','Eiendomsskatt Type oppdatering mislyktes',0),(390546,10849,'da','Ejendomsskat Type opdatering mislykkedes',0),(390547,10849,'ko','ìž¬ì‚°ì„¸ í˜•ì‹ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(390548,10849,'he','×ž×¡ ×¨×›×•×© ×¡×•×’ ×”×¢×“×›×•×Ÿ × ×›×©×œ',0),(390549,10849,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï… ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(390550,10849,'zh','ç‰©ä¸šç¨Žçš„å½¢å¼æ›´æ–°å¤±è´¥\r\n',0),(390551,10849,'sv','Fastighetsskatt typ uppdateringen misslyckades',0),(390552,10849,'it','ProprietÃ  fiscale tipo aggiornamento non riuscito',0),(390553,10849,'tl','',0),(390554,10849,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸Šà¸™à¸´à¸”à¸—à¸µà¹ˆà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(390555,10849,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤²',0),(390556,10849,'ms','Kemaskini jenis cukai harta yang gagal',0),(390557,10849,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ',0),(390558,10849,'fr','ImpÃ´t foncier Type mise Ã  jour a Ã©chouÃ©',0),(390559,10849,'jp','å›ºå®šè³‡ç”£ç¨Žã®ç¨®é¡žã‚’æ›´æ–°ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(390560,10849,'pt','Imposto sobre a propriedade tipo atualizaÃ§Ã£o falhada',0),(390561,10849,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾',0),(390562,10849,'es','Impuesto Predial Tipo ActualizaciÃ³n FallÃ³',0),(390563,10849,'de','Grundsteuer-Typ-Update fehlgeschlagen',0),(390564,10849,'en','Property Tax Type Update Failed',0),(390565,10850,'is','',0),(390566,10850,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(390567,10850,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙˆØ¹ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(390568,10850,'tr','Emlak vergisi tÃ¼rÃ¼ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(390569,10850,'pl','Podatek od nieruchomoÅ›ci typu pomyÅ›lnie zaktualizowana',0),(390570,10850,'bg','Ð”Ð°Ð½ÑŠÐº ÑÐ³Ñ€Ð°Ð´Ð¸ Ñ‚Ð¸Ð¿ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(390571,10850,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù…',0),(390572,10850,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(390573,10850,'vi','cáº­p nháº­t loáº¡i thuáº¿ tÃ i sáº£n thÃ nh cÃ´ng',0),(390574,10850,'af','Eiendomsbelastingtipe Suksesvol Opdateer',0),(390575,10850,'ro','Tip de proprietate fiscal actualizat cu succes',0),(390576,10850,'et','Maamaks tÃ¼Ã¼p vÃ¤rskendamine Ãµnnestus',0),(390577,10850,'si','Davek na nepremiÄnine vrsto uspeÅ¡no posodobljena',0),(390578,10850,'ba','Jenis pajak properti yang berhasil',0),(390579,10850,'nl','Onroerende voorheffing Type bijgewerkt',0),(390580,10850,'fi','KiinteistÃ¶vero tyyppi pÃ¤ivitetty',0),(390581,10850,'no','Eiendomsskatt Type oppdatert',0),(390582,10850,'da','Ejendomsskat Type opdateret',0),(390583,10850,'ko','ìž¬ì‚°ì„¸ ìœ í˜•ì„ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(390584,10850,'he','×¡×•×’ ×ž×¡ ×¨×›×•×© ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(390585,10850,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(390586,10850,'zh','ç‰©ä¸šç¨Žç±»åž‹æ›´æ–°æˆåŠŸ\r\n',0),(390587,10850,'sv','Fastighetsskatt typ uppdaterats',0),(390588,10850,'it','Tipo di proprietÃ  fiscale aggiornato con successo',0),(390589,10850,'tl','',0),(390590,10850,'th','à¸Šà¸™à¸´à¸”à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(390591,10850,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤‚à¤ªà¤¦à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(390592,10850,'ms','Jenis cukai harta yang berjaya dikemas kini',0),(390593,10850,'ar','Ø­Ø¯Ù‘Ø« Ù†ÙˆØ¹ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(390594,10850,'fr','Type de taxe fonciÃ¨re mis Ã  jour avec succÃ¨s',0),(390595,10850,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸè³‡ç”£ç¨Žã‚¿ã‚¤ãƒ—',0),(390596,10850,'pt','Tipo de propriedade imposto atualizado com sucesso',0),(390597,10850,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ñ‚Ð¸Ð¿Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(390598,10850,'es','Impuesto Predial Actualizado Exitosamente',0),(390599,10850,'de','Grundsteuer-Typ, die erfolgreich aktualisiert',0),(390600,10850,'en','Property Tax Type Updated Successfully',0),(390601,10851,'is','',0),(390602,10851,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(390603,10851,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(390604,10851,'tr','Emlak vergisi ekleme baÅŸarÄ±sÄ±z',0),(390605,10851,'pl','Podatek od nieruchomoÅ›ci Dodaj nie powiodÅ‚o siÄ™',0),(390606,10851,'bg','Ð”Ð°Ð½ÑŠÐº Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(390607,10851,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ù†Ø§Ú©Ø§Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(390608,10851,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¿Ð°Ð»Ð¸',0),(390609,10851,'vi','thÃªm loáº¡i tÃ i sáº£n tháº¥t báº¡i',0),(390610,10851,'af','Byvoeging van Eiendomsbelasting Tipe Gefaal',0),(390611,10851,'ro','Impozitul pe proprietate Adauga nu a reuÅŸit',0),(390612,10851,'et','Maamaks lisamine nurjus',0),(390613,10851,'si','Dodati davek na nepremiÄnine ni',0),(390614,10851,'ba','Pajak properti menambahkan gagal',0),(390615,10851,'nl','Onroerende voorheffing mislukte toevoegen',0),(390616,10851,'fi','KiinteistÃ¶vero lisÃ¤ys epÃ¤onnistui',0),(390617,10851,'no','Eiendomsskatt legge mislyktes',0),(390618,10851,'da','Ejendomsskat tilfÃ¸je mislykkedes',0),(390619,10851,'ko','ë¶€ë™ì‚° ì„¸ê¸ˆ ì¶”ê°€ ì‹¤íŒ¨',0),(390620,10851,'he','×ž×¡ ×¨×›×•×© ×œ×”×•×¡×™×£ ×©× ×›×©×œ×•',0),(390621,10851,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(390622,10851,'zh','ç‰©ä¸šç¨Žæ·»åŠ å¤±è´¥\r\n',0),(390623,10851,'sv','Fastighetsskatt lÃ¤gga till misslyckades',0),(390624,10851,'it','ProprietÃ  fiscale aggiungere fallito',0),(390625,10851,'tl','',0),(390626,10851,'th','à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(390627,10851,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(390628,10851,'ms','Cukai harta Tambah gagal',0),(390629,10851,'ar','Ø¥Ø¶Ø§ÙØ© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ Ø§Ù„ÙØ§Ø´Ù„Ø©',0),(390630,10851,'fr','ImpÃ´t foncier ajouter ayant Ã©chouÃ©',0),(390631,10851,'jp','å›ºå®šè³‡ç”£ç¨Žè¿½åŠ ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(390632,10851,'pt','Imposto sobre a propriedade Adicionar falha',0),(390633,10851,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾',0),(390634,10851,'es','Impuesto Predial Agregar FallÃ³',0),(390635,10851,'de','Grundsteuer hinzufÃ¼gen fehlgeschlagen',0),(390636,10851,'en','Property Tax Add Failed',0),(390637,10852,'is','',0),(390638,10852,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø³Ø§Ù„ ØªØ­ØµÙŠÙ„ÙŠ ',0),(390639,10852,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø³Ø§Ù„ ØªØ­ØµÙŠÙ„ÙŠ ',0),(390640,10852,'tr','Akademik yÄ±l kira',0),(390641,10852,'pl','Rok akademicki dzierÅ¼awy',0),(390642,10852,'bg','ÐÐºÐ°Ð´ÐµÐ¼Ð¸Ñ‡Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(390643,10852,'ur','Ø³Ø§Ù„Ø§Ù†Û Ú©Ø±Ø§Ø¡Û’ Ú©ÛŒ ÙˆØµÙˆÙ„ÛŒ',0),(390644,10852,'sr','ÐÐºÐ°Ð´ÐµÐ¼ÑÐºÐµ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð·Ð°ÐºÑƒÐ¿',0),(390645,10852,'vi','há»£p Ä‘á»“ng nÄƒm há»c',0),(390646,10852,'af','Akademiese Jaar Huurkontrak',0),(390647,10852,'ro','An academic leasing',0),(390648,10852,'et','Ã•ppeaasta Ã¼Ã¼rileping',0),(390649,10852,'si','Å tudijskem letu najema',0),(390650,10852,'ba','Tahun akademik sewa',0),(390651,10852,'nl','Academisch jaar Lease',0),(390652,10852,'fi','Lukuvuoden vuokrasopimuksen',0),(390653,10852,'no','StudieÃ¥ret Lease',0),(390654,10852,'da','Akademiske Ã¥r Lease',0),(390655,10852,'ko','ë…„ë„ ìž„ëŒ€',0),(390656,10852,'he','×©× ×” ××§×“×ž×™×ª ×—×›×™×¨×”',0),(390657,10852,'el','Î‘ÎºÎ±Î´Î·Î¼Î±ÏŠÎºÏŒ Î­Ï„Î¿Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(390658,10852,'zh','å­¦æœ¯å¹´ç§Ÿçº¦\r\n',0),(390659,10852,'sv','Akademiskt Ã¥rshyra',0),(390660,10852,'it','Locazione anno accademico',0),(390661,10852,'tl','',0),(390662,10852,'th','à¹€à¸Šà¹ˆà¸²à¸›à¸µà¸à¸²à¸£à¸¨à¸¶à¸à¸©à¸²',0),(390663,10852,'hi','à¤¶à¥ˆà¤•à¥à¤·à¤£à¤¿à¤• à¤µà¤°à¥à¤· à¤•à¥‡ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(390664,10852,'ms','Tahun akademik pajakan',0),(390665,10852,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ø£ÙƒØ§Ø¯ÙŠÙ…ÙŠØ©',0),(390666,10852,'fr','Bail d\'annÃ©e acadÃ©mique',0),(390667,10852,'jp','å¹´åº¦ã®ãƒªãƒ¼ã‚¹',0),(390668,10852,'pt','LocaÃ§Ã£o de ano lectivo',0),(390669,10852,'ru','ÐÑ€ÐµÐ½Ð´Ð° ÑƒÑ‡ÐµÐ±Ð½Ñ‹Ð¹ Ð³Ð¾Ð´',0),(390670,10852,'es','Arendamiento para el aÃ±o escolar',0),(390671,10852,'de','Akademisches Jahr Leasing',0),(390672,10852,'en','Academic Year Lease',0),(390673,10853,'is','',0),(390674,10853,'dr','Ù…Ø§Ù‡ Ù‡Ø§ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ±',0),(390675,10853,'pr','Ù…Ø§Ù‡ Ù‡Ø§ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ±',0),(390676,10853,'tr','Ay fatura tarihinden sonra',0),(390677,10853,'pl','MiesiÄ™cy od daty wystawienia faktury',0),(390678,10853,'bg','ÐœÐµÑÐµÑ†Ð° ÑÐ»ÐµÐ´ Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(390679,10853,'ur','Ù…Ø§Û Ø¨Ø¹Ø¯ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(390680,10853,'sr','ÐœÐµÑÐµÑ†Ð¸ Ð½Ð°ÐºÐ¾Ð½ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(390681,10853,'vi','thÃ¡ng sau ngÃ y hÃ³a Ä‘Æ¡n',0),(390682,10853,'af','Maande na faktuur datum',0),(390683,10853,'ro','Luni de la data facturii',0),(390684,10853,'et','Kuud pÃ¤rast arve kuupÃ¤ev',0),(390685,10853,'si','Mesecih po datumu raÄuna',0),(390686,10853,'ba','Bulan setelah tanggal faktur',0),(390687,10853,'nl','Maanden na factuurdatum',0),(390688,10853,'fi','Kuukauden kuluttua laskutuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(390689,10853,'no','MÃ¥neder etter fakturadatoen',0),(390690,10853,'da','MÃ¥neder efter fakturadatoen',0),(390691,10853,'ko','ì†¡ìž¥ ë‚ ì§œ í›„ì— ë‹¬',0),(390692,10853,'he','×—×•×“×©×™× ×œ××—×¨ ×ª××¨×™×š ×—×©×‘×•× ×™×ª',0),(390693,10853,'el','ÎœÎ®Î½ÎµÏ‚ Î¼ÎµÏ„Î¬ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(390694,10853,'zh','å‘ç¥¨æ—¥æœŸåŽæœˆæ•°\r\n',0),(390695,10853,'sv','MÃ¥nader efter fakturadatum',0),(390696,10853,'it','Mesi dopo la data della fattura',0),(390697,10853,'tl','',0),(390698,10853,'th','à¹€à¸”à¸·à¸­à¸™à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸§à¸±à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(390699,10853,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‡ à¤¬à¤¾à¤¦ à¤®à¤¹à¥€à¤¨à¥‹à¤‚',0),(390700,10853,'ms','Bulan selepas tarikh invois',0),(390701,10853,'ar','Ø£Ø´Ù‡Ø± Ø¨Ø¹Ø¯ ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(390702,10853,'fr','Mois aprÃ¨s la Date de la facture',0),(390703,10853,'jp','è«‹æ±‚æ›¸ã®æ—¥ä»˜ã‹ã‚‰ 3ãƒ¶æœˆ',0),(390704,10853,'pt','Meses apÃ³s a data da factura',0),(390705,10853,'ru','ÐœÐµÑÑÑ†ÐµÐ² Ð¿Ð¾ÑÐ»Ðµ Ð´Ð°Ñ‚Ñ‹ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(390706,10853,'es','Meses DespuÃ©s de la Fecha de Factura',0),(390707,10853,'de','Monate nach Rechnungsdatum',0),(390708,10853,'en','Months After Invoice Date',0),(390709,10854,'is','',0),(390710,10854,'dr','Ø¯Ø±ØµØ¯ Ø¯Ø±Ø¢Ù…Ø¯',0),(390711,10854,'pr','Ø¯Ø±ØµØ¯ Ø¯Ø±Ø¢Ù…Ø¯',0),(390712,10854,'tr','YÃ¼zde gelir',0),(390713,10854,'pl','Procent dochodÃ³w',0),(390714,10854,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸',0),(390715,10854,'ur','ÙÛŒØµØ¯ Ø±ÛŒÙˆÙ†ÛŒÙˆ',0),(390716,10854,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(390717,10854,'vi','pháº§n trÄƒm doanh thu',0),(390718,10854,'af','Persentasie inkomste',0),(390719,10854,'ro','Procent venituri',0),(390720,10854,'et','Protsenti tulud',0),(390721,10854,'si','Odstotkov prihodkov',0),(390722,10854,'ba','Persen pendapatan',0),(390723,10854,'nl','Percentage inkomsten',0),(390724,10854,'fi','Prosenttia tuloista',0),(390725,10854,'no','Prosent inntekter',0),(390726,10854,'da','Procent indtÃ¦gter',0),(390727,10854,'ko','% ìˆ˜ìµ',0),(390728,10854,'he','×”×›× ×¡×•×ª ×‘××—×•×–×™×',0),(390729,10854,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎµÏƒÏŒÎ´Ï‰Î½',0),(390730,10854,'zh','æ”¶å…¥çš„ç™¾åˆ†æ¯”\r\n',0),(390731,10854,'sv','Procent intÃ¤kter',0),(390732,10854,'it','Percentuale delle entrate',0),(390733,10854,'tl','',0),(390734,10854,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¸£à¹‰à¸­à¸¢à¸¥à¸°',0),(390735,10854,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤°à¤¾à¤œà¤¸à¥à¤µ',0),(390736,10854,'ms','Peratus pendapatan',0),(390737,10854,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù…Ù† Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª',0),(390738,10854,'fr','Pourcentage des revenus',0),(390739,10854,'jp','ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆã®åŽç›Š',0),(390740,10854,'pt','Por cento das receitas',0),(390741,10854,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð´Ð¾Ñ…Ð¾Ð´Ð°',0),(390742,10854,'es','Renta Porciento',0),(390743,10854,'de','Prozent Umsatz',0),(390744,10854,'en','Percent Revenue',0),(390745,10855,'is','',0),(390746,10855,'dr','Ø´Ù†Ø§Ø³Ø§ÙŠÙŠ Ø¯Ø±Ø¢Ù…Ø¯',0),(390747,10855,'pr','Ø´Ù†Ø§Ø³Ø§ÙŠÙŠ Ø¯Ø±Ø¢Ù…Ø¯',0),(390748,10855,'tr','Gelirlerden',0),(390749,10855,'pl','Ujmowanie przychodÃ³w',0),(390750,10855,'bg','ÐŸÑ€Ð¸Ð·Ð½Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(390751,10855,'ur','Ø±ÛŒÙˆÙ†ÛŒÙˆ Ø´Ù†Ø§Ø³ÛŒ',0),(390752,10855,'sr','ÐŸÑ€Ð¸Ñ…Ð¾Ð´ Ð¾Ð´ Ð¿Ñ€Ð¸Ð·Ð½Ð°Ð²Ð°ÑšÐ°',0),(390753,10855,'vi','ghi nháº­n doanh thu',0),(390754,10855,'af','Inkomste erkenning',0),(390755,10855,'ro','RecunoaÅŸterea veniturilor',0),(390756,10855,'et','Tulu kajastamine',0),(390757,10855,'si','Pripoznavanje prihodkov',0),(390758,10855,'ba','Pengakuan pendapatan',0),(390759,10855,'nl','Opbrengstverantwoording',0),(390760,10855,'fi','Tuloutus',0),(390761,10855,'no','InntektsfÃ¸ring',0),(390762,10855,'da','IndtÃ¦gter anerkendelse',0),(390763,10855,'ko','ìˆ˜ìµ ì¸ì‹',0),(390764,10855,'he','×”×›×¨×” ×‘×”×›× ×¡×•×ª',0),(390765,10855,'el','Î‘Î½Î±Î³Î½ÏŽÏÎ¹ÏƒÎ· ÎµÏƒÏŒÎ´Ï‰Î½',0),(390766,10855,'zh','æ”¶å…¥ç¡®è®¤\r\n',0),(390767,10855,'sv','IntÃ¤ktsredovisning',0),(390768,10855,'it','Riconoscimento dei ricavi',0),(390769,10855,'tl','',0),(390770,10855,'th','à¸à¸²à¸£à¸£à¸±à¸šà¸£à¸¹à¹‰à¸£à¸²à¸¢à¹„à¸”à¹‰',0),(390771,10855,'hi','à¤°à¤¾à¤œà¤¸à¥à¤µ à¤®à¤¾à¤¨à¥à¤¯à¤¤à¤¾',0),(390772,10855,'ms','Pengiktirafan hasil',0),(390773,10855,'ar','Ø§Ù„Ø§Ø¹ØªØ±Ø§Ù Ø¨Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª',0),(390774,10855,'fr','Constatation des produits',0),(390775,10855,'jp','åŽç›Šã®èªè­˜',0),(390776,10855,'pt','Reconhecimento de receita',0),(390777,10855,'ru','ÐŸÑ€Ð¸Ð·Ð½Ð°Ð½Ð¸Ðµ Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð²',0),(390778,10855,'es','Reconocimiento de Ingreso',0),(390779,10855,'de','Umsatzrealisierung',0),(390780,10855,'en','Revenue Recognition',0),(390781,10856,'is','',0),(390782,10856,'dr','Ø´Ù†Ø§Ø³Ø§ÙŠÙŠ Ø¯Ø±Ø¢Ù…Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(390783,10856,'pr','Ø´Ù†Ø§Ø³Ø§ÙŠÙŠ Ø¯Ø±Ø¢Ù…Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(390784,10856,'tr','Gelirlerden baÅŸarÄ±yla kaydedildi',0),(390785,10856,'pl','Ujmowanie przychodÃ³w zapisane',0),(390786,10856,'bg','ÐŸÑ€Ð¸Ð·Ð½Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(390787,10856,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ø±ÛŒÙˆÙ†ÛŒÙˆ Ø´Ù†Ø§Ø³ÛŒ',0),(390788,10856,'sr','ÐŸÑ€Ð¸Ñ…Ð¾Ð´ Ð¾Ð´ Ð¿Ñ€Ð¸Ð·Ð½Ð°Ð²Ð°ÑšÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(390789,10856,'vi','Ä‘Ã£ lÆ°u ghi nháº­n doanh thu thÃ nh cÃ´ng',0),(390790,10856,'af','Ontvanger van Inkomste Erkening Suksesvol Gestoor',0),(390791,10856,'ro','RecunoaÅŸterea veniturilor salvat cu succes',0),(390792,10856,'et','Tulu kajastamine edukalt salvestatud',0),(390793,10856,'si','Prihodki priznanje uspeÅ¡no shranjen',0),(390794,10856,'ba','Pengakuan pendapatan yang berhasil diselamatkan',0),(390795,10856,'nl','Opbrengstverantwoording succesvol opgeslagen',0),(390796,10856,'fi','Tallennettu tuloutus',0),(390797,10856,'no','InntektsfÃ¸ring lagret',0),(390798,10856,'da','IndtÃ¦gter anerkendelse gemt med succes',0),(390799,10856,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” ìˆ˜ìµ ì¸ì‹',0),(390800,10856,'he','×”×›×¨×” ×‘×”×›× ×¡×•×ª ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(390801,10856,'el','Î‘Î½Î±Î³Î½ÏŽÏÎ¹ÏƒÎ· ÎµÏƒÏŒÎ´Ï‰Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(390802,10856,'zh','æ”¶å…¥ç¡®è®¤ä¿å­˜æˆåŠŸ\r\n',0),(390803,10856,'sv','IntÃ¤ktsredovisning som sparats',0),(390804,10856,'it','Riconoscimento delle entrate salvato correttamente',0),(390805,10856,'tl','',0),(390806,10856,'th','à¸à¸²à¸£à¸£à¸±à¸šà¸£à¸¹à¹‰à¸£à¸²à¸¢à¹„à¸”à¹‰à¸—à¸µà¹ˆà¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(390807,10856,'hi','à¤°à¤¾à¤œà¤¸à¥à¤µ à¤®à¤¾à¤¨à¥à¤¯à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(390808,10856,'ms','Pengiktirafan hasil yang berjaya disimpan',0),(390809,10856,'ar','Ø§Ù„Ø§Ø¹ØªØ±Ø§Ù Ø¨Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø­ÙØ¸Ù‡ Ø¨Ù†Ø¬Ø§Ø­',0),(390810,10856,'fr','Constatation des produits correctement enregistrÃ©e',0),(390811,10856,'jp','åŽç›Šã®èªè­˜ãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(390812,10856,'pt','Reconhecimento de receita salvo com sucesso',0),(390813,10856,'ru','ÐŸÑ€Ð¸Ð·Ð½Ð°Ð½Ð¸Ðµ Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð², ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(390814,10856,'es','Reconocimiento de Ingreso Guardado Exitosamente',0),(390815,10856,'de','Umsatzrealisierung erfolgreich gespeichert',0),(390816,10856,'en','Revenue Recognition Saved Successfully',0),(390817,10857,'is','',0),(390818,10857,'dr','Ø§Ø¬Ø§Ø±Ù‡  Ù†ÙŠÙ…Ø³Ø§Ù„ ØªØ­ØµÙŠÙ„ÙŠ',0),(390819,10857,'pr','Ø§Ø¬Ø§Ø±Ù‡  Ù†ÙŠÙ…Ø³Ø§Ù„ ØªØ­ØµÙŠÙ„ÙŠ',0),(390820,10857,'tr','DÃ¶nem kira',0),(390821,10857,'pl','Semestr dzierÅ¼awy',0),(390822,10857,'bg','Ð¡ÐµÐ¼ÐµÑÑ‚ÑŠÑ€ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(390823,10857,'ur','Ø³Ù…Ø³Ù¹Ø± Ù„ÛŒØ²',0),(390824,10857,'sr','Ð¡ÐµÐ¼ÐµÑÑ‚Ð°Ñ€ Ð·Ð°ÐºÑƒÐ¿',0),(390825,10857,'vi','Cho thuÃª há»c ká»³',0),(390826,10857,'af','Semester Verhuring',0),(390827,10857,'ro','Semestru leasing',0),(390828,10857,'et','Semestri Ã¼Ã¼rileping',0),(390829,10857,'si','Semester najema',0),(390830,10857,'ba','Semester sewa',0),(390831,10857,'nl','Semester Lease',0),(390832,10857,'fi','Lukukauden vuokrasopimuksen',0),(390833,10857,'no','Semester Lease',0),(390834,10857,'da','Semester Lease',0),(390835,10857,'ko','í•™ê¸° ìž„ëŒ€',0),(390836,10857,'he','×©×›×™×¨×•×ª ×”×¡×ž×¡×˜×¨',0),(390837,10857,'el','Î•Î¾Î¬Î¼Î·Î½Î¿ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(390838,10857,'zh','å­¦æœŸç§Ÿèµ\r\n',0),(390839,10857,'sv','Termin Lease',0),(390840,10857,'it','Semestre Lease',0),(390841,10857,'tl','',0),(390842,10857,'th','à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²à¹€à¸—à¸­à¸¡à¸à¸²à¸£à¸¨à¸¶à¸à¸©à¸²',0),(390843,10857,'hi','à¤¸à¥‡à¤®à¥‡à¤¸à¥à¤Ÿà¤° à¤•à¥‡ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(390844,10857,'ms','Pajakan semester',0),(390845,10857,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„ÙØµÙ„ Ø§Ù„Ø¯Ø±Ø§Ø³ÙŠ',0),(390846,10857,'fr','Location semestre',0),(390847,10857,'jp','å­¦æœŸãƒªãƒ¼ã‚¹',0),(390848,10857,'pt','LocaÃ§Ã£o de semestre',0),(390849,10857,'ru','ÐÑ€ÐµÐ½Ð´Ð° ÑÐµÐ¼ÐµÑÑ‚Ñ€',0),(390850,10857,'es','Arrrendamiento Semestral',0),(390851,10857,'de','Semester-Leasing',0),(390852,10857,'en','Semester Lease',0),(390853,10858,'is','',0),(390854,10858,'dr','100 Ø¨Ø§Ø´Ø¯ ',0),(390855,10858,'pr','Ø¯Ø±ØµØ¯ Ø¬Ù…Ø¹ ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø³Ø§Ù„ ØªØ­ØµÙŠÙ„ÙŠ Ø¨Ø§ÙŠØ¯ Ù…Ø¹Ø§Ø¯Ù„ 100 Ø¨Ø§Ø´Ø¯ ',0),(390856,10858,'tr','Akademik yÄ±l iÃ§in Toplam yÃ¼zde 100\'e eÅŸit olmalÄ±',0),(390857,10858,'pl','CaÅ‚kowity procent na rok akademicki musi byÄ‡ rÃ³wna 100',0),(390858,10858,'bg','ÐžÐ±Ñ‰Ð¸ÑÑ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð·Ð° ÑƒÑ‡ÐµÐ±Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ñ€Ð°Ð²Ð½Ð¾ 100',0),(390859,10858,'ur','100 ØªØ¹Ù„ÛŒÙ…ÛŒ Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ Ú©Ù„ ÙÛŒØµØ¯ Ú©Û’ Ø¨Ø±Ø§Ø¨Ø± Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(390860,10858,'sr','Ð£ÐºÑƒÐ¿Ð°Ð½ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð·Ð° Ð°ÐºÐ°Ð´ÐµÐ¼ÑÐºÐµ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ñ˜ÐµÐ´Ð½Ð°Ðº 100',0),(390861,10858,'vi','Tá»•ng pháº§n trÄƒm cho nÄƒm há»c pháº£i báº±ng 100',0),(390862,10858,'af','Die Totale Persentasie vir Akademiese Jaar Moet 100 wees',0),(390863,10858,'ro','Total % pentru anul Academic trebuie egal cu 100',0),(390864,10858,'et','Ã•ppeaastal kokku protsent peab olema 100',0),(390865,10858,'si','Skupni odstotek za Å¡tudijsko leto mora biti enaka 100',0),(390866,10858,'ba','Total persen untuk tahun akademik harus sama dengan 100',0),(390867,10858,'nl','Het totale percentage voor academisch jaar moet gelijk zijn aan 100',0),(390868,10858,'fi','YhteensÃ¤ prosenttia lukuvuonna on oltava 100',0),(390869,10858,'no','Den totale fullfÃ¸ringsprosenten for studieÃ¥r mÃ¥ vÃ¦re lik 100',0),(390870,10858,'da','Den samlede procent for skoleÃ¥ret skal vÃ¦re lig med 100',0),(390871,10858,'ko','ë…„ë„ ì´ %100 ë™ì¼ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(390872,10858,'he','×¡×” ×› ×”××—×•×– ×œ×©× ×” ×”××§×“×ž×™×ª ×©×•×•×” ×œ- 100',0),(390873,10858,'el','Î¤Î¿ ÏƒÏ…Î½Î¿Î»Î¹ÎºÏŒ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î³Î¹Î± Ï„Î¿ Î±ÎºÎ±Î´Î·Î¼Î±ÏŠÎºÏŒ Î­Ï„Î¿Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¹ÏƒÎ¿ÏÏ„Î±Î¹ Ï€ÏÎ¿Ï‚ 100',0),(390874,10858,'zh','æœ¬å­¦å¹´æ€»ç™¾åˆ†ä¹‹å¿…é¡»ç­‰äºŽ100\r\n',0),(390875,10858,'sv','Den totala procenten lÃ¤sÃ¥ret mÃ¥ste vara lika med 100',0),(390876,10858,'it','La percentuale totale per l\'anno accademico Ã¨ pari a 100',0),(390877,10858,'tl','',0),(390878,10858,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸£à¸§à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸µà¸à¸²à¸£à¸¨à¸¶à¸à¸©à¸²à¸•à¹‰à¸­à¸‡à¹€à¸—à¹ˆà¸²à¸à¸±à¸š 100',0),(390879,10858,'hi','à¤¶à¥ˆà¤•à¥à¤·à¤£à¤¿à¤• à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤² à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ 100 à¤¬à¤°à¤¾à¤¬à¤° à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(390880,10858,'ms','Jumlah peratus bagi tahun akademik mesti sama dengan 100',0),(390881,10858,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ© Ù„Ù„Ø³Ù†Ø© Ø§Ù„Ø£ÙƒØ§Ø¯ÙŠÙ…ÙŠØ© ÙŠØ¬Ø¨ Ø£Ù† ÙŠØ³Ø§ÙˆÙŠ 100',0),(390882,10858,'fr','Le pourcentage Total pour l\'annÃ©e scolaire doit Ãªtre Ã©gal Ã  100',0),(390883,10858,'jp','å¹´åº¦ã®ç·è¨ˆã®ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆã¯ 100 ã¨ç­‰ã—ããªã‘ã‚Œã°ãªã‚Šã¾ã›ã‚“',0),(390884,10858,'pt','O Total por cento para o ano lectivo deve ser igual a 100',0),(390885,10858,'ru','ÐžÐ±Ñ‰Ð¸Ð¹ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð·Ð° ÑƒÑ‡ÐµÐ±Ð½Ñ‹Ð¹ Ð³Ð¾Ð´ Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð²Ð½Ð¾ 100',0),(390886,10858,'es','el Porcentaje Total Para El AÃ±o Escolar debe Ser 100 %',0),(390887,10858,'de','Die insgesamt Prozent fÃ¼r Studienjahr muss 100 ergeben.',0),(390888,10858,'en','The Total Percent for Academic Year Must Equal 100',0),(390889,10859,'is','',0),(390890,10859,'dr','100 Ø¨Ø§Ø´Ø¯',0),(390891,10859,'pr','Ø¯Ø±ØµØ¯ Ø¬Ù…Ø¹ ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù†ÙŠÙ…Ø³Ø§Ù„ ØªØ­ØµÙŠÙ„ÙŠ  Ø¨Ø§ÙŠØ¯ Ù…Ø¹Ø§Ø¯Ù„ 100 Ø¨Ø§Ø´Ø¯',0),(390892,10859,'tr','DÃ¶nem iÃ§in Toplam yÃ¼zde 100\'e eÅŸit olmalÄ±',0),(390893,10859,'pl','CaÅ‚kowity procent na semestr musi byÄ‡ rÃ³wna 100',0),(390894,10859,'bg','ÐžÐ±Ñ‰Ð¸ÑÑ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð·Ð° ÑÐµÐ¼ÐµÑÑ‚ÑŠÑ€ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ñ€Ð°Ð²Ð½Ð¾ 100',0),(390895,10859,'ur','100 Ø³Ù…Ø³Ù¹Ø± Ú©Û’ Ù„Ø¦Û’ Ú©Ù„ ÙÛŒØµØ¯ Ú©Û’ Ø¨Ø±Ø§Ø¨Ø± Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(390896,10859,'sr','Ð£ÐºÑƒÐ¿Ð°Ð½ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð·Ð° ÑÐµÐ¼ÐµÑÑ‚Ð°Ñ€ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ñ˜ÐµÐ´Ð½Ð°Ðº 100',0),(390897,10859,'vi','Tá»•ng pháº§n trÄƒm cho há»c ká»³ pháº£i báº±ng 100',0),(390898,10859,'af','Die totale persent vir Semester gelyk moet wees aan 100',0),(390899,10859,'ro','Total % pentru semestrul trebuie egal cu 100',0),(390900,10859,'et','Semestril kokku protsent peab olema 100',0),(390901,10859,'si','Skupni odstotek za Semester mora biti enaka 100',0),(390902,10859,'ba','Persentase Total untuk Semester harus sama dengan 100',0),(390903,10859,'nl','Het totale percentage voor Semester moet gelijk zijn aan 100',0),(390904,10859,'fi','YhteensÃ¤ prosenttia lukukauden on oltava 100',0),(390905,10859,'no','Den totale fullfÃ¸ringsprosenten for semesteret mÃ¥ vÃ¦re lik 100',0),(390906,10859,'da','Den samlede procent for Semester skal vÃ¦re lig med 100',0),(390907,10859,'ko','í•™ê¸° ì´ %100 ë™ì¼ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(390908,10859,'he','×”××—×•×– ×”×›×•×œ×œ ×œ×¡×ž×¡×˜×¨ ×©×•×•×” ×œ- 100',0),(390909,10859,'el','Î¤Î¿ ÏƒÏ…Î½Î¿Î»Î¹ÎºÏŒ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î³Î¹Î± ÎµÎ¾Î¬Î¼Î·Î½Î¿ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¹ÏƒÎ¿ÏÏ„Î±Î¹ Ï€ÏÎ¿Ï‚ 100',0),(390910,10859,'zh','æœ¬å­¦æœŸæ€»ç™¾åˆ†æ¯”å¿…é¡»ç­‰äºŽ100\r\n',0),(390911,10859,'sv','Den totala procenten fÃ¶r termin mÃ¥ste vara lika med 100',0),(390912,10859,'it','La percentuale totale per semestre Ã¨ pari a 100',0),(390913,10859,'tl','',0),(390914,10859,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸£à¸§à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸ à¸²à¸„à¸à¸²à¸£à¸¨à¸¶à¸à¸©à¸²à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¹€à¸—à¹ˆà¸²à¸à¸±à¸š 100',0),(390915,10859,'hi','à¤¸à¥‡à¤®à¥‡à¤¸à¥à¤Ÿà¤° à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤² à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ 100 à¤¬à¤°à¤¾à¤¬à¤° à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(390916,10859,'ms','Peratus jumlah semester mesti sama dengan 100',0),(390917,10859,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ© Ù„Ù„ÙØµÙ„ Ø§Ù„Ø¯Ø±Ø§Ø³ÙŠ ÙŠØ¬Ø¨ Ø£Ù† ÙŠØ³Ø§ÙˆÙŠ 100',0),(390918,10859,'fr','Le pourcentage Total semestre doit Ãªtre Ã©gal Ã  100',0),(390919,10859,'jp','å­¦æœŸã®ç·è¨ˆã®ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆã¯ 100 ã¨ç­‰ã—ããªã‘ã‚Œã°ãªã‚Šã¾ã›ã‚“',0),(390920,10859,'pt','A porcentagem Total por semestre deve ser igual a 100',0),(390921,10859,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð² Ð½Ð° ÑÐµÐ¼ÐµÑÑ‚Ñ€ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð²ÐµÐ½ 100',0),(390922,10859,'es','el Porcentaje Total Para El Semestre Debe Ser 100',0),(390923,10859,'de','Die insgesamt Prozent fÃ¼r Semester muss 100 ergeben.',0),(390924,10859,'en','The Total Percent for Semester Must Equal 100',0),(390925,10860,'is','',0),(390926,10860,'dr','(  ØªØ¹ÙŠÙŠÙ† )Ø´Ø¯Ù‡ Ø¨Ù‡',0),(390927,10860,'pr','Ø­ÙˆØ§Ù„Ù‡(  ØªØ¹ÙŠÙŠÙ† )Ø´Ø¯Ù‡ Ø¨Ù‡',0),(390928,10860,'tr','Atanan',0),(390929,10860,'pl','Przypisane do',0),(390930,10860,'bg','Ð’ÑŠÐ·Ð»Ð¾Ð¶ÐµÐ½Ð¸ Ð½Ð°',0),(390931,10860,'ur','ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯ÛŒ Ú¯Ø¦ÛŒ',0),(390932,10860,'sr','Ð”Ð¾Ð´ÐµÑ™ÐµÐ½',0),(390933,10860,'vi','ÄÆ°á»£c Chá»‰ Ä‘á»‹nh cho',0),(390934,10860,'af','Toegestaan Aan',0),(390935,10860,'ro','Atribuite',0),(390936,10860,'et','MÃ¤Ã¤ratud',0),(390937,10860,'si','Dodeljeno',0),(390938,10860,'ba','Ditetapkan ke',0),(390939,10860,'nl','Toegewezen aan',0),(390940,10860,'fi','Liitetty',0),(390941,10860,'no','Tilordnet til',0),(390942,10860,'da','Tildelt',0),(390943,10860,'ko','ì— í• ë‹¹',0),(390944,10860,'he','×©×”×•×§×¦×•',0),(390945,10860,'el','Î‘Î½Î±Ï„ÎµÎ¸ÎµÎ¯',0),(390946,10860,'zh','åˆ†é…ç»™\r\n',0),(390947,10860,'sv','Tilldelats',0),(390948,10860,'it','Assegnate a',0),(390949,10860,'tl','',0),(390950,10860,'th','à¸à¸³à¸«à¸™à¸”à¹ƒà¸«à¹‰',0),(390951,10860,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(390952,10860,'ms','Diperuntukkan kepada',0),(390953,10860,'ar','ØªØ¹ÙŠÙŠÙ† Ø¥Ù„Ù‰',0),(390954,10860,'fr','AssignÃ©s Ã ',0),(390955,10860,'jp','å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ã¾ã™ã€‚',0),(390956,10860,'pt','AtribuÃ­do a',0),(390957,10860,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½',0),(390958,10860,'es','Asignado A',0),(390959,10860,'de','Zugewiesen',0),(390960,10860,'en','Assigned To',0),(390961,10861,'is','',0),(390962,10861,'dr','Ø­ÙˆØ§Ù„Ù‡ ÙƒØ±Ø¯Ù† Ø¨Ù‡',0),(390963,10861,'pr','Ø­ÙˆØ§Ù„Ù‡ ÙƒØ±Ø¯Ù† Ø¨Ù‡',0),(390964,10861,'tr','Atama',0),(390965,10861,'pl','PrzypisaÄ‡ do',0),(390966,10861,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð°',0),(390967,10861,'ur','ØªÙÙˆÛŒØ¶',0),(390968,10861,'sr','Ð”Ð¾Ð´ÐµÑ™Ð¸Ð²Ð°ÑšÐµ',0),(390969,10861,'vi','Chá»‰ Ä‘á»‹nh cho',0),(390970,10861,'af','Toestaan Aan',0),(390971,10861,'ro','AsociaÅ£i',0),(390972,10861,'et','MÃ¤Ã¤rata',0),(390973,10861,'si','Dodeliti',0),(390974,10861,'ba','Menetapkan ke',0),(390975,10861,'nl','Toewijzen aan',0),(390976,10861,'fi','LiittÃ¤minen',0),(390977,10861,'no','Tilordnes',0),(390978,10861,'da','Tildele',0),(390979,10861,'ko','ì— í• ë‹¹',0),(390980,10861,'he','×œ×”×§×¦×•×ª',0),(390981,10861,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ ÏƒÎµ',0),(390982,10861,'zh','åˆ†é…ç»™\r\n',0),(390983,10861,'sv','Tilldela',0),(390984,10861,'it','Assegnare a',0),(390985,10861,'tl','',0),(390986,10861,'th','à¸à¸³à¸«à¸™à¸”à¹ƒà¸«à¹‰',0),(390987,10861,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(390988,10861,'ms','Peruntukan kepada',0),(390989,10861,'ar','ØªØ¹ÙŠÙŠÙ† Ø¥Ù„Ù‰',0),(390990,10861,'fr','Affecter Ã ',0),(390991,10861,'jp','å‰²ã‚Šå½“ã¦ã‚‹',0),(390992,10861,'pt','Atribuir a',0),(390993,10861,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ Ð´Ð»Ñ',0),(390994,10861,'es','Asignar A',0),(390995,10861,'de','Zuweisen',0),(390996,10861,'en','Assign To',0),(390997,10862,'is','',0),(390998,10862,'dr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø«Ø¨Øª',0),(390999,10862,'pr','ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø«Ø¨Øª',0),(391000,10862,'tr','GiriÅŸ tarihinden baÅŸlamak',0),(391001,10862,'pl','Data wpisu rozp.',0),(391002,10862,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(391003,10862,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¢ØºØ§Ø²',0),(391004,10862,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° ÑÑ‚Ð°Ð²ÐºÐµ',0),(391005,10862,'vi','NgÃ y báº¯t Ä‘áº§u nháº­p liá»‡u',0),(391006,10862,'af','Begin datum van inskrywing',0),(391007,10862,'ro','ÃŽncepe data intrÄƒrii',0),(391008,10862,'et','Kande alguskuupÃ¤ev',0),(391009,10862,'si','ZaÄetni datum vstopa',0),(391010,10862,'ba','Mulai tanggal entri',0),(391011,10862,'nl','Datum van de Entry beginnen',0),(391012,10862,'fi','Tapahtuman alkamispÃ¤ivÃ¤',0),(391013,10862,'no','Starte oppfÃ¸ringsdatoen',0),(391014,10862,'da','Begynde tilmeldningsfrist',0),(391015,10862,'ko','ìž…êµ­ ë‚ ì§œë¥¼ ì‹œìž‘',0),(391016,10862,'he','×ª××¨×™×š ×›× ×™×¡×” ×‘×’×™×Ÿ',0),(391017,10862,'el','Î‘ÏÏ‡Î¯ÏƒÎµÎ¹ Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(391018,10862,'zh','å¼€å§‹è¾“å…¥æ—¥æœŸ\r\n',0),(391019,10862,'sv','BÃ¶rja bloggpostens datum',0),(391020,10862,'it','Iniziare la data di entrata',0),(391021,10862,'tl','',0),(391022,10862,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¸§à¸±à¸™',0),(391023,10862,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¶à¥à¤°à¥‚ à¤¹à¥‹',0),(391024,10862,'ms','Mula tarikh kemasukan',0),(391025,10862,'ar','ØªØ¨Ø¯Ø£ Ù…Ù† ØªØ§Ø±ÙŠØ® Ø¯Ø®ÙˆÙ„',0),(391026,10862,'fr','Date d\'entrÃ©e de Begin',0),(391027,10862,'jp','ã‚¨ãƒ³ãƒˆãƒªã®æ—¥ä»˜ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(391028,10862,'pt','Data de entrada do Begin',0),(391029,10862,'ru','ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½Ð°Ñ Ð”Ð°Ñ‚Ð° Ð—Ð°Ð¿Ð¸ÑÐ¸',0),(391030,10862,'es','Empieza Fecha de Entrada',0),(391031,10862,'de','Eintrag vom beginnen',0),(391032,10862,'en','Begin Entry Date',0),(391033,10863,'is','',0),(391034,10863,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¬Ù‡Øª',0),(391035,10863,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¬Ù‡Øª',0),(391036,10863,'tr','Ãœcret',0),(391037,10863,'pl','Za',0),(391038,10863,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð°',0),(391039,10863,'ur','Ú©Û’ Ù„Ø¦Û’ Ú†Ø§Ø±Ø¬',0),(391040,10863,'sr','ÐÐ°Ð¿ÑƒÐ½Ð¸Ñ‚Ðµ Ð½Ð°',0),(391041,10863,'vi','PhÃ­ Ä‘á»ƒ',0),(391042,10863,'af','Hef om',0),(391043,10863,'ro','Taxa pentru a',0),(391044,10863,'et','Tasuta',0),(391045,10863,'si','StroÅ¡ek',0),(391046,10863,'ba','Biaya untuk',0),(391047,10863,'nl','Laden om te',0),(391048,10863,'fi','Maksutta',0),(391049,10863,'no','Gratis',0),(391050,10863,'da','Afgift til',0),(391051,10863,'ko','ìš”ê¸ˆ',0),(391052,10863,'he','. ×œ×˜×¢×•×Ÿ ×œ',0),(391053,10863,'el','Î§ÏÎ­Ï‰ÏƒÎ· Î½Î±',0),(391054,10863,'zh','æ”¶è´¹åˆ°\r\n',0),(391055,10863,'sv','Avgift till',0),(391056,10863,'it','Addebitare a',0),(391057,10863,'tl','',0),(391058,10863,'th','à¸„à¸´à¸”à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(391059,10863,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(391060,10863,'ms','Mengenakan bayaran untuk',0),(391061,10863,'ar','ØªÙˆØ¬ÙŠÙ‡ Ø§Ù„Ø§ØªÙ‡Ø§Ù… Ø¥Ù„Ù‰',0),(391062,10863,'fr','Facturer Ã ',0),(391063,10863,'jp','å……é›»ã™ã‚‹ã«ã¯',0),(391064,10863,'pt','Carregue em',0),(391065,10863,'ru','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(391066,10863,'es','Cargar a Cuenta De',0),(391067,10863,'de','Kostenlos zu',0),(391068,10863,'en','Charge To',0),(391069,10864,'is','',0),(391070,10864,'dr','ÙÙ‚Ø· Ø¬Ø§Ø±ÙŠ ',0),(391071,10864,'pr','ÙÙ‚Ø· Ø¬Ø§Ø±ÙŠ ',0),(391072,10864,'tr','YalnÄ±zca geÃ§erli',0),(391073,10864,'pl','Tylko prÄ…d',0),(391074,10864,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ ÑÐ°Ð¼Ð¾',0),(391075,10864,'ur','ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯Û',0),(391076,10864,'sr','Ð¡Ð°Ð¼Ð¾ ÑÑ‚Ñ€ÑƒÑ˜Ð°',0),(391077,10864,'vi','chá»‰ hiá»‡n nay',0),(391078,10864,'af','Slegs Huidige',0),(391079,10864,'ro','Curent numai',0),(391080,10864,'et','Praegune ainult',0),(391081,10864,'si','Trenutno samo',0),(391082,10864,'ba','Saat ini hanya',0),(391083,10864,'nl','Huidige alleen',0),(391084,10864,'fi','Nykyinen vain',0),(391085,10864,'no','Gjeldende bare',0),(391086,10864,'da','NuvÃ¦rende kun',0),(391087,10864,'ko','í˜„ìž¬ë§Œ',0),(391088,10864,'he','×”× ×•×›×—×™ ×‘×œ×‘×“',0),(391089,10864,'el','ÎœÏŒÎ½Î¿ ÏÎµÏÎ¼Î±',0),(391090,10864,'zh','å½“å‰åªæœ‰\r\n',0),(391091,10864,'sv','StrÃ¶m endast',0),(391092,10864,'it','Solo corrente',0),(391093,10864,'tl','',0),(391094,10864,'th','à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(391095,10864,'hi','à¤•à¥‡à¤µà¤² à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨',0),(391096,10864,'ms','Semasa sahaja',0),(391097,10864,'ar','Ø§Ù„Ø­Ø§Ù„ÙŠ ÙÙ‚Ø·',0),(391098,10864,'fr','Courant seulement',0),(391099,10864,'jp','ç¾åœ¨ã®ã¿',0),(391100,10864,'pt','Corrente apenas',0),(391101,10864,'ru','Ð¢Ð¾ÐºÐ° Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(391102,10864,'es','Actual Solamente',0),(391103,10864,'de','Strom nur',0),(391104,10864,'en','Current Only',0),(391105,10865,'is','',0),(391106,10865,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ø±ÙŠ ÙØ¹Ù„ÙŠ ',0),(391107,10865,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ø±ÙŠ ÙØ¹Ù„ÙŠ ',0),(391108,10865,'tr','GeÃ§erli iÅŸ sipariÅŸleri',0),(391109,10865,'pl','BieÅ¼Ä…cych zleceÅ„',0),(391110,10865,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð·Ð°ÑÐ²ÐºÐ¸',0),(391111,10865,'ur','Ú©Ø§Ù… Ú©Û’ Ø­Ø§Ù„ÛŒÛ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(391112,10865,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ñ€Ð°Ð´Ð½Ð¸Ð¼ Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð°',0),(391113,10865,'vi','nhá»¯ng Ä‘Æ¡n Ä‘áº·t hÃ ng hiá»‡n nay',0),(391114,10865,'af','Huidige Werksbestellings',0),(391115,10865,'ro','Comenzi de lucru curent',0),(391116,10865,'et','Praegune tÃ¶Ã¶kÃ¤sud',0),(391117,10865,'si','Trenutni delovnih nalogov',0),(391118,10865,'ba','Arus kerja perintah',0),(391119,10865,'nl','Huidige werkorders',0),(391120,10865,'fi','Nykyinen TyÃ¶tilaukset',0),(391121,10865,'no','Gjeldende Arbeidsordre',0),(391122,10865,'da','NuvÃ¦rende arbejdsordrer',0),(391123,10865,'ko','í˜„ìž¬ ìž‘ì—… ìˆœì„œ',0),(391124,10865,'he','×”×–×ž× ×•×ª ×¢×‘×•×“×” ×”× ×•×›×—×™',0),(391125,10865,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(391126,10865,'zh','å½“å‰çš„å·¥ä½œè®¢å•\r\n',0),(391127,10865,'sv','Nuvarande arbetsorder',0),(391128,10865,'it','Ordini di lavoro corrente',0),(391129,10865,'tl','',0),(391130,10865,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸œà¸¥à¸´à¸•à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(391131,10865,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤¾à¤°à¥à¤¯ à¤†à¤¦à¥‡à¤¶',0),(391132,10865,'ms','Semasa arahan kerja',0),(391133,10865,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(391134,10865,'fr','Ordres de travail actuelle',0),(391135,10865,'jp','ç¾åœ¨ã®ä½œæ¥­æ³¨æ–‡',0),(391136,10865,'pt','Ordens de trabalho atual',0),(391137,10865,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(391138,10865,'es','Ordenes de Trabajo Actuales',0),(391139,10865,'de','Aktuelle ArbeitsauftrÃ¤ge',0),(391140,10865,'en','Current Work Orders',0),(391141,10866,'is','',0),(391142,10866,'dr','Ø¯Ù„ÙŠÙ„ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(391143,10866,'pr','Ø¯Ù„ÙŠÙ„ Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(391144,10866,'tr','Reddedilen bir neden',0),(391145,10866,'pl','Powodu odmowy',0),(391146,10866,'bg','ÐžÑ‚ÐºÐ°Ð·Ð°Ð½ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(391147,10866,'ur','ÙˆØ¬Û Ø³Û’ Ø§Ù†Ú©Ø§Ø± Ú©ÛŒØ§',0),(391148,10866,'sr','ÐžÐ´Ð±Ð¸Ñ˜ÐµÐ½Ð¾ Ñ€Ð°Ð·Ð»Ð¾Ð³',0),(391149,10866,'vi','LÃ½ do bá»‹ tá»« chá»‘i',0),(391150,10866,'af','Rede geweier',0),(391151,10866,'ro','Motivul refuzului',0),(391152,10866,'et','Lennureisist pÃµhjus',0),(391153,10866,'si','Razlog zavrnitve',0),(391154,10866,'ba','Alasan ditolak',0),(391155,10866,'nl','Geweigerde reden',0),(391156,10866,'fi','EvÃ¤tty syystÃ¤',0),(391157,10866,'no','Grunn',0),(391158,10866,'da','Denied grund',0),(391159,10866,'ko','ê±°ë¶€ ì´ìœ ',0),(391160,10866,'he','×¡×™×‘×” ×œ×©×œ×™×œ×ª',0),(391161,10866,'el','Î›ÏŒÎ³Î¿ Î¬ÏÎ½Î·ÏƒÎ·Ï‚',0),(391162,10866,'zh','è¢«æ‹’ç»çš„åŽŸå› \r\n',0),(391163,10866,'sv','Nekad anledning',0),(391164,10866,'it','Motivo negato',0),(391165,10866,'tl','',0),(391166,10866,'th','à¹€à¸«à¸•à¸¸à¸œà¸¥à¸—à¸µà¹ˆà¸–à¸¹à¸à¸›à¸à¸´à¹€à¸ªà¸˜',0),(391167,10866,'hi','à¤•à¤¾à¤°à¤£ à¤•à¥‡ à¤¨à¤¿à¤·à¥‡à¤§',0),(391168,10866,'ms','Menafikan alasan',0),(391169,10866,'ar','Ù†ÙÙŠ Ø§Ù„Ø³Ø¨Ø¨',0),(391170,10866,'fr','Motif de refus',0),(391171,10866,'jp','æ‹’å¦ã•ã‚ŒãŸç†ç”±',0),(391172,10866,'pt','Motivo de recusado',0),(391173,10866,'ru','Ð—Ð°Ð¿Ñ€ÐµÑ‰ÐµÐ½ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ðµ',0),(391174,10866,'es','Razon por DenegaciÃ³n',0),(391175,10866,'de','Verweigerte Grund',0),(391176,10866,'en','Denied Reason',0),(391177,10867,'is','',0),(391178,10867,'dr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø«Ø¨Øª',0),(391179,10867,'pr',' ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø«Ø¨Øª',0),(391180,10867,'tr','Son giriÅŸ tarihi',0),(391181,10867,'pl','Data zakoÅ„czenia wpisu',0),(391182,10867,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(391183,10867,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(391184,10867,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° ÑÑ‚Ð°Ð²ÐºÐµ',0),(391185,10867,'vi','káº¿t thÃºc ngÃ y ghi sá»•',0),(391186,10867,'af','Inskrywing Einddatum',0),(391187,10867,'ro','Data de intrare sfÃ¢rÅŸitul',0),(391188,10867,'et','Kande lÃµppkuupÃ¤ev',0),(391189,10867,'si','Vnos konÄnega datuma',0),(391190,10867,'ba','Akhir tanggal entri',0),(391191,10867,'nl','Einddatum voor de vermelding',0),(391192,10867,'fi','Tapahtuman pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(391193,10867,'no','OppfÃ¸ringen sluttdatoen',0),(391194,10867,'da','Ende tilmeldningsfrist',0),(391195,10867,'ko','ì¢…ë£Œì¼ ìž…ë ¥',0),(391196,10867,'he','×ª××¨×™×š ×¡×™×•× ×”×–× ×ª',0),(391197,10867,'el','Î¤Î­Î»Î¿Ï‚ Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(391198,10867,'zh','ç»“æŸè¾“å…¥æ—¥æœŸ',0),(391199,10867,'sv','Posten slutdatum',0),(391200,10867,'it','Data di fine iscrizione',0),(391201,10867,'tl','',0),(391202,10867,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸£à¸²à¸¢à¸à¸²à¸£',0),(391203,10867,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(391204,10867,'ms','Tarikh akhir kemasukan',0),(391205,10867,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(391206,10867,'fr','Date d\'entrÃ©e de fin',0),(391207,10867,'jp','æœ€å¾Œã®è¨˜å…¥é …ç›®ã®æ—¥ä»˜',0),(391208,10867,'pt','Data de entrada do final',0),(391209,10867,'ru','ÐšÐ¾Ð½ÐµÑ‡Ð½Ð°Ñ Ð”Ð°Ñ‚Ð° Ð—Ð°Ð¿Ð¸ÑÐ¸',0),(391210,10867,'es','Terminar Fecha de Entrada',0),(391211,10867,'de','Eintrag vom Ende',0),(391212,10867,'en','End Entry Date',0),(391213,10868,'is','',0),(391214,10868,'dr','ØªØ¬Ù‡ÙŠØ²Ø§Øª Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ø± ',0),(391215,10868,'pr','ØªØ¬Ù‡ÙŠØ²Ø§Øª Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† ÙƒØ§Ø± ',0),(391216,10868,'tr','Bu iÅŸ iÃ§in donatÄ±m',0),(391217,10868,'pl','SprzÄ™t do tej pracy',0),(391218,10868,'bg','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(391219,10868,'ur','Ø§Ø³ Ú©Ø§Ù… Ú©Û’ Ù„Ø¦Û’ Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù†',0),(391220,10868,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð° Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾',0),(391221,10868,'vi','Thiáº¿t bá»‹ cho cÃ´ng viá»‡c nÃ y',0),(391222,10868,'af','Toerusting vir hierdie werk',0),(391223,10868,'ro','Echipament pentru acest lucru',0),(391224,10868,'et','Varustus selle tÃ¶Ã¶ eest',0),(391225,10868,'si','Opremo za to delo',0),(391226,10868,'ba','Peralatan untuk pekerjaan ini',0),(391227,10868,'nl','Apparatuur voor dit werk',0),(391228,10868,'fi','Laitteet tÃ¤stÃ¤ tyÃ¶stÃ¤',0),(391229,10868,'no','Utstyr for dette arbeidet',0),(391230,10868,'da','Udstyr til dette arbejde',0),(391231,10868,'ko','ì´ ìž‘ì—…ì„ ìœ„í•œ ìž¥ë¹„',0),(391232,10868,'he','×¦×™×•×“ ×œ×¢×‘×•×“×” ×–×•',0),(391233,10868,'el','Î•Î¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ Î­ÏÎ³Î¿',0),(391234,10868,'zh','è®¾å¤‡å¯¹è¿™é¡¹å·¥ä½œ',0),(391235,10868,'sv','Utrustning fÃ¶r detta arbete',0),(391236,10868,'it','Attrezzature per questo lavoro',0),(391237,10868,'tl','',0),(391238,10868,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸ªà¸³à¸«à¸£à¸±à¸šà¸‡à¸²à¸™à¸™à¸µà¹‰',0),(391239,10868,'hi','à¤‡à¤¸ à¤•à¤¾à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤•à¤°à¤£',0),(391240,10868,'ms','Peralatan untuk kerja-kerja ini',0),(391241,10868,'ar','Ø§Ù„Ù…Ø¹Ø¯Ø§Øª Ø§Ù„Ù„Ø§Ø²Ù…Ø© Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù…Ù„',0),(391242,10868,'fr','Ã‰quipements pour ce travail',0),(391243,10868,'jp','ã“ã®ä»•äº‹ã®ãŸã‚ã®æ©Ÿå™¨',0),(391244,10868,'pt','Equipamento para este trabalho',0),(391245,10868,'ru','ÐžÐ±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(391246,10868,'es','Equipo para Este Trabajo',0),(391247,10868,'de','AusrÃ¼stung fÃ¼r diese Arbeit',0),(391248,10868,'en','Equipment for This Work',0),(391249,10869,'is','',0),(391250,10869,'dr','Ø¨Ù‡Ø³Ø§Ø²ÙŠ ',0),(391251,10869,'pr','Ø¨Ù‡Ø³Ø§Ø²ÙŠ ',0),(391252,10869,'tr','Ä°yileÅŸtirme',0),(391253,10869,'pl','Poprawa',0),(391254,10869,'bg','ÐŸÐ¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(391255,10869,'ur','Ø¨ÛØªØ±ÛŒ',0),(391256,10869,'sr','ÐŸÐ¾Ð±Ð¾Ñ™ÑˆÐ°ÑšÐµ',0),(391257,10869,'vi','Sá»± tiáº¿n bá»™',0),(391258,10869,'af','Verbetering',0),(391259,10869,'ro','ÃŽmbunÄƒtÄƒÅ£irea',0),(391260,10869,'et','Parandamine',0),(391261,10869,'si','IzboljÅ¡anje',0),(391262,10869,'ba','Perbaikan',0),(391263,10869,'nl','Verbetering',0),(391264,10869,'fi','Parantaminen',0),(391265,10869,'no','Forbedring',0),(391266,10869,'da','Forbedring',0),(391267,10869,'ko','ê°œì„ ',0),(391268,10869,'he','×©×™×¤×•×¨',0),(391269,10869,'el','Î’ÎµÎ»Ï„Î¯Ï‰ÏƒÎ·',0),(391270,10869,'zh','æ”¹è¿›\r\n',0),(391271,10869,'sv','FÃ¶rbÃ¤ttring',0),(391272,10869,'it','Miglioramento',0),(391273,10869,'tl','',0),(391274,10869,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(391275,10869,'hi','à¤¸à¥à¤§à¤¾à¤°',0),(391276,10869,'ms','Peningkatan',0),(391277,10869,'ar','ØªØ­Ø³ÙŠÙ†',0),(391278,10869,'fr','AmÃ©lioration',0),(391279,10869,'jp','æ”¹å–„',0),(391280,10869,'pt','Melhoria',0),(391281,10869,'ru','Ð£Ð»ÑƒÑ‡ÑˆÐµÐ½Ð¸Ðµ',0),(391282,10869,'es','Mejoras',0),(391283,10869,'de','Verbesserung',0),(391284,10869,'en','Improvement',0),(391285,10870,'is','',0),(391286,10870,'dr','ØµØ§Ø¯Ø± ÙƒØ±Ø¯Ù†',0),(391287,10870,'pr','ØµØ§Ø¯Ø± ÙƒØ±Ø¯Ù†',0),(391288,10870,'tr','Sorunu',0),(391289,10870,'pl','Problem',0),(391290,10870,'bg','ÐŸÑ€Ð¾Ð±Ð»ÐµÐ¼',0),(391291,10870,'ur','Ù…Ø³Ø¦Ù„Û',0),(391292,10870,'sr','ÐŸÐ¸Ñ‚Ð°ÑšÐµ',0),(391293,10870,'vi','phÃ¡t',0),(391294,10870,'af','Uitreik',0),(391295,10870,'ro','Problema',0),(391296,10870,'et','KÃ¼simus',0),(391297,10870,'si','VpraÅ¡anje',0),(391298,10870,'ba','Masalah',0),(391299,10870,'nl','Probleem',0),(391300,10870,'fi','Kysymys',0),(391301,10870,'no','Problemet',0),(391302,10870,'da','SpÃ¸rgsmÃ¥l',0),(391303,10870,'ko','ë¬¸ì œ',0),(391304,10870,'he','×‘×¢×™×”',0),(391305,10870,'el','Î˜Î­Î¼Î±',0),(391306,10870,'zh','å‘è¡Œ\r\n',0),(391307,10870,'sv','FrÃ¥ga',0),(391308,10870,'it','Problema',0),(391309,10870,'tl','',0),(391310,10870,'th','à¸›à¸±à¸à¸«à¸²',0),(391311,10870,'hi','à¤®à¥à¤¦à¥à¤¦à¤¾',0),(391312,10870,'ms','Isu',0),(391313,10870,'ar','Ø§Ù„Ù‚Ø¶ÙŠØ©',0),(391314,10870,'fr','Question',0),(391315,10870,'jp','å•é¡Œ',0),(391316,10870,'pt','QuestÃ£o',0),(391317,10870,'ru','Ð’Ñ‹Ð¿ÑƒÑÐº',0),(391318,10870,'es','Emitir',0),(391319,10870,'de','Problem',0),(391320,10870,'en','Issue',0),(391321,10871,'is','',0),(391322,10871,'dr','Ø¢ÙŠØ§ Ø§ÙƒÙ†ÙˆÙ† ÙØ¹Ø§Ù„ Ø§Ø³Øª ',0),(391323,10871,'pr','Ø¢ÙŠØ§ Ø§ÙƒÙ†ÙˆÙ† ÙØ¹Ø§Ù„ Ø§Ø³Øª ',0),(391324,10871,'tr','ArtÄ±k etkindir',0),(391325,10871,'pl','Teraz jest aktywny',0),(391326,10871,'bg','Ð’ÐµÑ‡Ðµ Ðµ Ð°ÐºÑ‚Ð¸Ð²ÐµÐ½',0),(391327,10871,'ur','Ø§Ø¨ Ø²ÛŒØ± Ø¹Ù…Ù„ ÛÛ’',0),(391328,10871,'sr','Ð¡Ð°Ð´Ð° Ñ˜Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð°Ð½',0),(391329,10871,'vi','hoáº¡t Ä‘á»™ng bÃ¢y giá»',0),(391330,10871,'af','Is nou aktief',0),(391331,10871,'ro','Acum este activ',0),(391332,10871,'et','NÃ¼Ã¼d on aktiivne',0),(391333,10871,'si','Je aktiven',0),(391334,10871,'ba','Kini aktif',0),(391335,10871,'nl','Is nu actief',0),(391336,10871,'fi','On nyt aktiivinen',0),(391337,10871,'no','Er nÃ¥ aktiv',0),(391338,10871,'da','Er nu aktiv',0),(391339,10871,'ko','í™œë™ì ì¸ ì§€ê¸ˆ ì´ë‹¤',0),(391340,10871,'he','×¤×¢×™×œ ×›×¢×ª',0),(391341,10871,'el','Î¤ÏŽÏÎ± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹',0),(391342,10871,'zh','ç›®å‰æ­£æ´»åŠ¨\r\n',0),(391343,10871,'sv','Ã„r nu aktiv',0),(391344,10871,'it','Ãˆ ora attivo',0),(391345,10871,'tl','',0),(391346,10871,'th','à¸•à¸­à¸™à¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆ',0),(391347,10871,'hi','à¤…à¤¬ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤¹à¥ˆ',0),(391348,10871,'ms','Sekarang aktif',0),(391349,10871,'ar','ÙˆÙŠÙ†Ø´Ø· Ø­Ø§Ù„ÙŠØ§',0),(391350,10871,'fr','Est maintenant actif',0),(391351,10871,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã«ãªã‚Šã¾ã—ãŸ',0),(391352,10871,'pt','Agora estÃ¡ ativo',0),(391353,10871,'ru','Ð¡ÐµÐ¹Ñ‡Ð°Ñ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾',0),(391354,10871,'es','Ya Es Activo',0),(391355,10871,'de','Ist jetzt aktiv',0),(391356,10871,'en','Is Now Active',0),(391357,10872,'is','',0),(391358,10872,'dr','Ù…ØªÙˆØ³Ø·',0),(391359,10872,'pr','Ù…ØªÙˆØ³Ø·',0),(391360,10872,'tr','Orta',0),(391361,10872,'pl','Umiarkowany',0),(391362,10872,'bg','Ð£Ð¼ÐµÑ€ÐµÐ½Ð¾',0),(391363,10872,'ur','Ù…Ø¹ØªØ¯Ù„',0),(391364,10872,'sr','Ð£Ð±Ð»Ð°Ð¶Ð¸',0),(391365,10872,'vi','vá»«a pháº£i',0),(391366,10872,'af','Gemagtigde',0),(391367,10872,'ro','ModeratÄƒ',0),(391368,10872,'et','MÃµÃµdukas',0),(391369,10872,'si','Zmerno',0),(391370,10872,'ba','Moderat',0),(391371,10872,'nl','Matige',0),(391372,10872,'fi','Kohtalainen',0),(391373,10872,'no','Moderat',0),(391374,10872,'da','Moderat',0),(391375,10872,'ko','ë³´í†µ',0),(391376,10872,'he','×‘×™× ×•× ×™',0),(391377,10872,'el','ÎœÎ­Ï„ÏÎ¹Î±',0),(391378,10872,'zh','ç¨³å¥çš„\r\n',0),(391379,10872,'sv','MÃ¥ttlig',0),(391380,10872,'it','Moderata',0),(391381,10872,'tl','',0),(391382,10872,'th','à¸›à¸²à¸™à¸à¸¥à¸²à¸‡',0),(391383,10872,'hi','à¤®à¥‰à¤¡à¤°à¥‡à¤Ÿ',0),(391384,10872,'ms','Sederhana',0),(391385,10872,'ar','Ù…ØªÙˆØ³Ø·Ø©',0),(391386,10872,'fr','ModÃ©rÃ©e',0),(391387,10872,'jp','ä¸­ç­‰åº¦',0),(391388,10872,'pt','Moderada',0),(391389,10872,'ru','Ð£Ð¼ÐµÑ€ÐµÐ½Ð½Ñ‹Ð¹',0),(391390,10872,'es','Moderado',0),(391391,10872,'de','Moderate',0),(391392,10872,'en','Moderate',0),(391393,10873,'is','',0),(391394,10873,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø¬Ø¯ÙŠØ¯ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(391395,10873,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø¬Ø¯ÙŠØ¯ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(391396,10873,'tr','Yeni iÅŸ ekleme baÅŸarÄ±sÄ±z',0),(391397,10873,'pl','Nowe zadanie dodaÄ‡ nie powiodÅ‚o siÄ™',0),(391398,10873,'bg','ÐÐ¾Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(391399,10873,'ur','Ù†Ø¦ÛŒ Ø¬Ø§Ø¨ Ø§Ø¶Ø§ÙÛ Ù†Ø§Ú©Ø§Ù…',0),(391400,10873,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¿Ð°Ð»Ð¸',0),(391401,10873,'vi','thÃªm cÃ´ng viá»‡c má»›i Ä‘Ã£ tháº¥t báº¡i',0),(391402,10873,'af','Nuwe taak voeg het misluk',0),(391403,10873,'ro','Loc de muncÄƒ nou adÄƒuga nu a reuÅŸit',0),(391404,10873,'et','Uus tÃ¶Ã¶koht lisamine nurjus',0),(391405,10873,'si','Dodajte novo zaposlitev ni',0),(391406,10873,'ba','Pekerjaan baru menambahkan gagal',0),(391407,10873,'nl','Nieuwe baan mislukte toevoegen',0),(391408,10873,'fi','TyÃ¶paikkojen lisÃ¤ys epÃ¤onnistui',0),(391409,10873,'no','Ny jobb legge mislyktes',0),(391410,10873,'da','Nye Job tilfÃ¸je mislykkedes',0),(391411,10873,'ko','ìƒˆ ìž‘ì—… ì¶”ê°€ ì‹¤íŒ¨',0),(391412,10873,'he','×¢×‘×•×“×” ×—×“×©×” ×œ×”×•×¡×™×£ ×©× ×›×©×œ×•',0),(391413,10873,'el','ÎÎ­Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(391414,10873,'zh','æ–°çš„å·¥ä½œæ·»åŠ å¤±è´¥\r\n',0),(391415,10873,'sv','Nytt jobb lÃ¤gga till misslyckades',0),(391416,10873,'it','Nuovo lavoro Aggiungi fallito',0),(391417,10873,'tl','',0),(391418,10873,'th','à¸‡à¸²à¸™à¹ƒà¸«à¸¡à¹ˆà¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(391419,10873,'hi','à¤¨à¤¯à¤¾ à¤•à¤¾à¤°à¥à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(391420,10873,'ms','Pekerjaan baru Tambah gagal',0),(391421,10873,'ar','ÙØ´Ù„ Ø¥Ø¶Ø§ÙØ© ÙˆØ¸ÙŠÙØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(391422,10873,'fr','Nouvel emploi ajouter ayant Ã©chouÃ©',0),(391423,10873,'jp','æ–°ã—ã„ã‚¸ãƒ§ãƒ–è¿½åŠ ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(391424,10873,'pt','Novo emprego Adicionar falha',0),(391425,10873,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(391426,10873,'es','Nuevo Trabajo Agregar FallÃ³',0),(391427,10873,'de','Neuer Job hinzufÃ¼gen fehlgeschlagen',0),(391428,10873,'en','New Job Add Failed',0),(391429,10874,'is','',0),(391430,10874,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø¬Ø¯ÙŠØ¯ Ø¨Ø§Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(391431,10874,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´ØºÙ„ Ø¬Ø¯ÙŠØ¯ Ø¨Ø§Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(391432,10874,'tr','Yeni iÅŸ baÅŸarÄ±yla eklendi',0),(391433,10874,'pl','Nowe zadanie pomyÅ›lne dodanie',0),(391434,10874,'bg','ÐÐ¾Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(391435,10874,'ur','Ù†Ø¦ÛŒ Ø¬Ø§Ø¨ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(391436,10874,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾, Ð´Ð¾Ð´Ð°Ð¾ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(391437,10874,'vi','ÄÃ£ thÃªm cÃ´ng viá»‡c má»›i thÃ nh cÃ´ng',0),(391438,10874,'af','Nuwe Werkstuk Suksesvol Bygevoeg',0),(391439,10874,'ro','Job nou adÄƒugat cu succes',0),(391440,10874,'et','Lisatud uus tÃ¶Ã¶koht',0),(391441,10874,'si','Novo delovno mesto, uspeÅ¡no dodani',0),(391442,10874,'ba','Pekerjaan baru yang ditambahkan berhasil',0),(391443,10874,'nl','Nieuwe baan met succes toegevoegd',0),(391444,10874,'fi','Uuden tyÃ¶n lisÃ¤Ã¤minen onnistui',0),(391445,10874,'no','Ny jobb lagt',0),(391446,10874,'da','Nye Job tilfÃ¸jet',0),(391447,10874,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ìƒˆë¡œìš´ ìž‘ì—…',0),(391448,10874,'he','×ª×¤×§×™×“ ×—×“×© × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(391449,10874,'el','ÎÎ­Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(391450,10874,'zh','æ–°çš„å·¥ä½œæ·»åŠ æˆåŠŸ\r\n',0),(391451,10874,'sv','Nytt jobb lagts',0),(391452,10874,'it','Nuovo lavoro aggiunto con successo',0),(391453,10874,'tl','',0),(391454,10874,'th','à¸‡à¸²à¸™à¹ƒà¸«à¸¡à¹ˆà¸—à¸µà¹ˆà¸–à¸¹à¸à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(391455,10874,'hi','à¤¨à¤ˆ à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(391456,10874,'ms','Pekerjaan baru yang berjaya menambah',0),(391457,10874,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(391458,10874,'fr','Nouvel emploi ajoutÃ© avec succÃ¨s',0),(391459,10874,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸæ–°ã—ã„ã‚¸ãƒ§ãƒ–',0),(391460,10874,'pt','Novo trabalho adicionado com sucesso',0),(391461,10874,'ru','ÐÐ¾Ð²Ð°Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(391462,10874,'es','Nuevo Trabajo Agregado Exitosamente',0),(391463,10874,'de','Neuen Job erfolgreich hinzugefÃ¼gt',0),(391464,10874,'en','New Job Added Successfully',0),(391465,10875,'is','',0),(391466,10875,'dr','Ù‡ÙŠÚ†Ú©Ø³',0),(391467,10875,'pr','Ù‡ÙŠÚ†Ú©Ø³',0),(391468,10875,'tr','HiÃ§ kimse',0),(391469,10875,'pl','Nikt',0),(391470,10875,'bg','ÐÐ¸ÐºÐ¾Ð¹ Ð½Ðµ',0),(391471,10875,'ur','Ú©ÙˆØ¦ÛŒ Ù†ÛÛŒÚº',0),(391472,10875,'sr','ÐÐ¸ÐºÐ¾',0),(391473,10875,'vi','khÃ´ng ai',0),(391474,10875,'af','Geen Een',0),(391475,10875,'ro','Nici unul',0),(391476,10875,'et','Keegi',0),(391477,10875,'si','NihÄe',0),(391478,10875,'ba','Tidak ada yang',0),(391479,10875,'nl','Niemand',0),(391480,10875,'fi','Kukaan',0),(391481,10875,'no','Ingen',0),(391482,10875,'da','Ingen',0),(391483,10875,'ko','ì•„ë¬´ë„',0),(391484,10875,'he','××£ ××—×“',0),(391485,10875,'el','ÎšÎ±Î½ÎµÎ¯Ï‚',0),(391486,10875,'zh','æ²¡æœ‰äºº\r\n',0),(391487,10875,'sv','Ingen',0),(391488,10875,'it','Nessuno',0),(391489,10875,'tl','',0),(391490,10875,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸„à¸£',0),(391491,10875,'hi','à¤•à¥‹à¤ˆ à¤­à¥€',0),(391492,10875,'ms','Tiada siapa',0),(391493,10875,'ar','Ù„Ø§ Ø£Ø­Ø¯',0),(391494,10875,'fr','Personne ne',0),(391495,10875,'jp','èª°',0),(391496,10875,'pt','NinguÃ©m',0),(391497,10875,'ru','ÐÐ¸ ÐžÐ´Ð¸Ð½',0),(391498,10875,'es','Ninguno',0),(391499,10875,'de','Niemand',0),(391500,10875,'en','No One',0),(391501,10876,'is','',0),(391502,10876,'dr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(391503,10876,'pr','Ù‡ÙŠÚ† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(391504,10876,'tr','Bulunan hiÃ§bir iÅŸ sipariÅŸleri',0),(391505,10876,'pl','Nie znaleziono zamÃ³wieÅ„',0),(391506,10876,'bg','ÐÑÐ¼Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(391507,10876,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ú©Ø§Ù… Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(391508,10876,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ð´Ð½Ð¸Ð¼ Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(391509,10876,'vi','khÃ´ng tÃ¬m tháº¥y Ä‘áº·t cÃ´ng viá»‡c',0),(391510,10876,'af','Geen Werkbestellings Gevind',0),(391511,10876,'ro','Comenzi de lucru constatat',0),(391512,10876,'et','Ei leidnud tÃ¶Ã¶kÃ¤sud',0),(391513,10876,'si','Ni delovnih nalogov, najti',0),(391514,10876,'ba','Pesanan kerja tidak ditemukan',0),(391515,10876,'nl','Geen werkorders gevonden',0),(391516,10876,'fi','TyÃ¶ tilauksia ei lÃ¶ytynyt',0),(391517,10876,'no','Ingen Arbeidsordre funnet',0),(391518,10876,'da','Ingen arbejdsordrer fundet',0),(391519,10876,'ko','ë°œê²¬ ì—†ìŒ ìž‘ì—… ìˆœì„œ',0),(391520,10876,'he','×œ× × ×ž×¦××• ×”×–×ž× ×•×ª ×¢×‘×•×“×”',0),(391521,10876,'el','Î”ÎµÎ½ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(391522,10876,'zh','æ²¡æœ‰æ‰¾åˆ°å·¥ä½œå•\r\n',0),(391523,10876,'sv','Ingen arbetsorder hittade',0),(391524,10876,'it','Nessun ordine di lavoro trovato',0),(391525,10876,'tl','',0),(391526,10876,'th','à¹„à¸¡à¹ˆà¸žà¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™',0),(391527,10876,'hi','à¤•à¥‹à¤ˆ à¤•à¤¾à¤°à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤ªà¤¾à¤¯à¤¾',0),(391528,10876,'ms','Tiada arahan kerja yang ditemui',0),(391529,10876,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¹Ù…Ù„ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(391530,10876,'fr','Aucun ordre de travail trouvÃ©',0),(391531,10876,'jp','ä½œæ¥­æ³¨æ–‡ã¯ã‚ã‚Šã¾ã›ã‚“ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(391532,10876,'pt','NÃ£o hÃ¡ ordens de trabalho encontrados',0),(391533,10876,'ru','Ð‘ÐµÐ· Ð½Ð°Ñ€ÑÐ´Ð¾Ð² Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(391534,10876,'es','Ningunos Ordenes de Trabajo Se Encontraron',0),(391535,10876,'de','Keine AuftrÃ¤ge gefunden',0),(391536,10876,'en','No Work Orders Found',0),(391537,10877,'is','',0),(391538,10877,'dr','Ù„Ø·ÙØ§ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØªØ®Ù…ÙŠÙ†ÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(391539,10877,'pr','Ù„Ø·ÙØ§ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØªØ®Ù…ÙŠÙ†ÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(391540,10877,'tr','LÃ¼tfen tahmini bitiÅŸ tarihini iÃ§erir.',0),(391541,10877,'pl','ProszÄ™ podaÄ‡ datÄ™ koÅ„cowÄ… szacuje',0),(391542,10877,'bg','ÐœÐ¾Ð»Ñ, Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ð°Ñ‚Ð° ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(391543,10877,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ® Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(391544,10877,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð·Ð°Ð²Ñ€ÑˆÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(391545,10877,'vi','vui lÃ²ng bao gá»“m Æ°á»›c tÃ­nh ngÃ y káº¿t thÃºc',0),(391546,10877,'af','Sluit asb. Kwotasie Vervaldatum in',0),(391547,10877,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i data estimatÄƒ sfÃ¢rÅŸitul',0),(391548,10877,'et','Palun lisage eeldatav lÃµppkuupÃ¤ev',0),(391549,10877,'si','Prosimo, da vkljuÄite ocenjeni konÄni datum',0),(391550,10877,'ba','Sertakan perkiraan akhir tanggal',0),(391551,10877,'nl','Gelieve te omvatten geschatte einddatum',0),(391552,10877,'fi','Ilmoita arvioitu pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(391553,10877,'no','Ta med anslÃ¥tt avslutningsdato',0),(391554,10877,'da','Medtag anslÃ¥ede slutdato',0),(391555,10877,'ko','ì˜ˆìƒëœ ì¢…ë£Œ ë‚ ì§œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(391556,10877,'he','× × ×œ×›×œ×•×œ ×ª××¨×™×š ×¡×™×•× ×ž×©×•×¢×¨',0),(391557,10877,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î•ÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î»Î®Î¾Î·',0),(391558,10877,'zh','è¯·åˆ—å…¥é¢„è®¡ç»“æŸæ—¥æœŸ\r\n',0),(391559,10877,'sv','VÃ¤nligen inkludera uppskattade slutdatum',0),(391560,10877,'it','Si prega di includere data fine stimata',0),(391561,10877,'tl','',0),(391562,10877,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¹‚à¸”à¸¢à¸›à¸£à¸°à¸¡à¸²à¸“',0),(391563,10877,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(391564,10877,'ms','Sila Sertakan tarikh akhir anggaran',0),(391565,10877,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„Ù…Ù‚Ø¯Ø±Ø©',0),(391566,10877,'fr','Veuillez indiquer la Date de fin estimÃ©e',0),(391567,10877,'jp','äºˆå®šã®çµ‚äº†æ—¥ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(391568,10877,'pt','Por favor, inclua a data de tÃ©rmino estimado',0),(391569,10877,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ð»Ð°Ð³Ð°ÐµÐ¼Ð¾Ðµ ÐºÐ¾Ð½ÐµÑ‡Ð½Ð°Ñ Ð´Ð°Ñ‚Ð°',0),(391570,10877,'es','Por Favor Incluye Fecha de TeminaciÃ³n Estimado',0),(391571,10877,'de','Bitte geben Sie geschÃ¤tzte Enddatum',0),(391572,10877,'en','Please Include Estimated End Date',0),(391573,10878,'is','',0),(391574,10878,'dr','Ù„Ø·ÙØ§ Ø´Ø±ÙƒØª  Ø±Ø§ Ø¬Ù‡Øª Ø¨Ø¯Ù‡ÙƒØ§Ø± Ù†Ù…ÙˆØ¯Ù†  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ',0),(391575,10878,'pr','Ù„Ø·ÙØ§ Ø´Ø±ÙƒØª  Ø±Ø§ Ø¬Ù‡Øª Ø¨Ø¯Ù‡ÙƒØ§Ø± Ù†Ù…ÙˆØ¯Ù†  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ',0),(391576,10878,'tr','LÃ¼tfen ÅŸirket iÃ§in Ã¼cret ekleyin',0),(391577,10878,'pl','Prosimy o podanie firmy bezpÅ‚atnie',0),(391578,10878,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð·Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð°',0),(391579,10878,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú†Ø§Ø±Ø¬ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(391580,10878,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ Ð·Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ñƒ Ñƒ',0),(391581,10878,'vi','vui long bao gá»“m cÃ´ng ty Ä‘á»ƒ chá»‹u cho',0),(391582,10878,'af','Sluit asb. Onderneming van wie Koste Verhaal moet Word in',0),(391583,10878,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i companiei de a taxa de',0),(391584,10878,'et','Palun lisage firma tasu',0),(391585,10878,'si','Prosimo, da vkljuÄite podjetje brezplaÄno',0),(391586,10878,'ba','Harap sertakan perusahaan untuk',0),(391587,10878,'nl','Gelieve te omvatten bedrijf tot heffing van',0),(391588,10878,'fi','LiitÃ¤ mukaan yhtiÃ¶n maksu',0),(391589,10878,'no','Ta selskapet til Ã¥',0),(391590,10878,'da','VedlÃ¦g selskab til at',0),(391591,10878,'ko','íšŒì‚¬ì— ìš”ê¸ˆì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(391592,10878,'he','× × ×œ×›×œ×•×œ ××ª ×”×—×‘×¨×” ×œ×©×œ×',0),(391593,10878,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î½Î± ÎµÏ€Î¹Î²Î±ÏÏÎ½ÎµÎ¹',0),(391594,10878,'zh','è¯·åˆ—å…¥æ”¶æ¬¾å…¬å¸\r\n',0),(391595,10878,'sv','VÃ¤nligen inkludera fÃ¶retag till att',0),(391596,10878,'it','Si prega di includere azienda addebitare a',0),(391597,10878,'tl','',0),(391598,10878,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹ƒà¸«à¹‰à¸šà¸£à¸´à¸©à¸±à¸—',0),(391599,10878,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‹ à¤šà¤¾à¤°à¥à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(391600,10878,'ms','Sila sertakan Syarikat kepada',0),(391601,10878,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ù„Ø´Ø±ÙƒØ© Ù„ØªÙˆØ¬ÙŠÙ‡ Ø§Ù„Ø§ØªÙ‡Ø§Ù… Ø¥Ù„Ù‰',0),(391602,10878,'fr','S\'il vous plaÃ®t inclure Company Ã  Charge Ã ',0),(391603,10878,'jp','ä¼šç¤¾ã«æ–™é‡‘ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(391604,10878,'pt','Por favor inclua a empresa a carga para',0),(391605,10878,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(391606,10878,'es','Por Favor Incluye Empresa Para Cargar A',0),(391607,10878,'de','Bitte fÃ¼gen Sie Unternehmen kostenlos an',0),(391608,10878,'en','Please Include Company to Charge To',0),(391609,10879,'is','',0),(391610,10879,'dr','Ù„Ø·ÙØ§ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(391611,10879,'pr','Ù„Ø·ÙØ§ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(391612,10879,'tr','LÃ¼tfen baÅŸlangÄ±Ã§ tarihi iÃ§erir.',0),(391613,10879,'pl','ProszÄ™ podaÄ‡ datÄ™ rozpoczÄ™cia',0),(391614,10879,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(391615,10879,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ú©ÛŒ Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØªØ§Ø±ÛŒØ® Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(391616,10879,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(391617,10879,'vi','vui lÃ²ng bao gá»“m ngÃ y báº¯t Ä‘áº§u',0),(391618,10879,'af','Sluit asseblief Aanvangsdatum in',0),(391619,10879,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i data de Ã®nceput',0),(391620,10879,'et','Palun lisage alguskuupÃ¤ev',0),(391621,10879,'si','Prosimo, da vkljuÄite zaÄetni datum',0),(391622,10879,'ba','Harap sertakan tanggal mulai',0),(391623,10879,'nl','Gelieve te omvatten begindatum',0),(391624,10879,'fi','Kirjoita AloituspÃ¤ivÃ¤',0),(391625,10879,'no','Ta med startdato',0),(391626,10879,'da','VedlÃ¦g startdato',0),(391627,10879,'ko','ì‹œìž‘ ë‚ ì§œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(391628,10879,'he','×× × ×›×œ×•×œ ×ª××¨×™×š ×”×ª×—×œ×”',0),(391629,10879,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(391630,10879,'zh','è¯·åˆ—å…¥å¼€å§‹æ—¥æœŸ\r\n',0),(391631,10879,'sv','VÃ¤nligen inkludera startdatum',0),(391632,10879,'it','Si prega di includere la data di inizio',0),(391633,10879,'tl','',0),(391634,10879,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(391635,10879,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(391636,10879,'ms','Sila masukkan tarikh mula',0),(391637,10879,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(391638,10879,'fr','Veuillez indiquer la Date de dÃ©part',0),(391639,10879,'jp','é–‹å§‹æ—¥ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(391640,10879,'pt','Por favor, inclua a data de inÃ­cio',0),(391641,10879,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ñƒ Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(391642,10879,'es','Por Favor Incluye Fecha de Comienzo',0),(391643,10879,'de','Bitte geben Sie Startdatum',0),(391644,10879,'en','Please Include Start Date',0),(391645,10880,'is','',0),(391646,10880,'dr','Ù…Ø§Ù†Ø¹',0),(391647,10880,'pr','Ù…Ø§Ù†Ø¹',0),(391648,10880,'tr','Ã–nleyici',0),(391649,10880,'pl','Zapobiegawczych',0),(391650,10880,'bg','ÐŸÑ€ÐµÐ²Ð°Ð½Ñ‚Ð¸Ð²Ð½Ð¸',0),(391651,10880,'ur','Ø¨Ø±Ø¬Øª',0),(391652,10880,'sr','ÐŸÑ€ÐµÐ²ÐµÐ½Ñ‚Ð¸Ð²Ð½Ð°',0),(391653,10880,'vi','ngÄƒn ngá»«a',0),(391654,10880,'af','Voorkomende',0),(391655,10880,'ro','PreventivÄƒ',0),(391656,10880,'et','Ennetus',0),(391657,10880,'si','Preventivni',0),(391658,10880,'ba','Pencegahan',0),(391659,10880,'nl','Preventieve',0),(391660,10880,'fi','EnnaltaehkÃ¤isy',0),(391661,10880,'no','Forebyggende',0),(391662,10880,'da','Forebyggende',0),(391663,10880,'ko','ì˜ˆë°©',0),(391664,10880,'he','×ž× ×™×¢×”',0),(391665,10880,'el','Î ÏÎ¿Î»Î·Ï€Ï„Î¹ÎºÎ¬',0),(391666,10880,'zh','é¢„é˜²\r\n',0),(391667,10880,'sv','FÃ¶rebyggande',0),(391668,10880,'it','Preventivo',0),(391669,10880,'tl','',0),(391670,10880,'th','à¸›à¹‰à¸­à¸‡à¸à¸±à¸™',0),(391671,10880,'hi','à¤¨à¤¿à¤µà¤¾à¤°à¤•',0),(391672,10880,'ms','Pencegahan',0),(391673,10880,'ar','Ø§Ù„ÙˆÙ‚Ø§Ø¦ÙŠØ©',0),(391674,10880,'fr','PrÃ©ventive',0),(391675,10880,'jp','äºˆé˜²',0),(391676,10880,'pt','Preventiva',0),(391677,10880,'ru','ÐŸÑ€Ð¾Ñ„Ð¸Ð»Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ',0),(391678,10880,'es','Preventivo',0),(391679,10880,'de','Vorbeugende',0),(391680,10880,'en','Preventive',0),(391681,10881,'is','',0),(391682,10881,'dr','ØªØ¹Ù…ÙŠØ±Ø§Øª',0),(391683,10881,'pr','ØªØ¹Ù…ÙŠØ±Ø§Øª',0),(391684,10881,'tr','OnarÄ±m',0),(391685,10881,'pl','Naprawy',0),(391686,10881,'bg','Ð ÐµÐ¼Ð¾Ð½Ñ‚Ð¸',0),(391687,10881,'ur','Ù…Ø±Ù…Øª',0),(391688,10881,'sr','ÐŸÐ¾Ð¿Ñ€Ð°Ð²ÐºÐµ',0),(391689,10881,'vi','sá»­a chá»¯a',0),(391690,10881,'af','Herstelwerk',0),(391691,10881,'ro','Reparatii',0),(391692,10881,'et','Remont',0),(391693,10881,'si','Popravila',0),(391694,10881,'ba','Perbaikan',0),(391695,10881,'nl','Reparaties',0),(391696,10881,'fi','Korjaukset',0),(391697,10881,'no','Reparasjoner',0),(391698,10881,'da','Reparationer',0),(391699,10881,'ko','ìˆ˜ë¦¬',0),(391700,10881,'he','×ª×™×§×•× ×™×',0),(391701,10881,'el','Î•Ï€Î¹ÏƒÎºÎµÏ…Î­Ï‚',0),(391702,10881,'zh','ç»´ä¿®\r\n',0),(391703,10881,'sv','Reparationer',0),(391704,10881,'it','Riparazioni',0),(391705,10881,'tl','',0),(391706,10881,'th','à¸‹à¹ˆà¸­à¸¡à¹à¸‹à¸¡',0),(391707,10881,'hi','à¤®à¤°à¤®à¥à¤®à¤¤',0),(391708,10881,'ms','Pembaikan',0),(391709,10881,'ar','Ø§Ù„ØªØµÙ„ÙŠØ­',0),(391710,10881,'fr','RÃ©parations',0),(391711,10881,'jp','ä¿®ç†',0),(391712,10881,'pt','Reparos',0),(391713,10881,'ru','Ð ÐµÐ¼Ð¾Ð½Ñ‚',0),(391714,10881,'es','Reparaciones',0),(391715,10881,'de','Reparaturen',0),(391716,10881,'en','Repairs',0),(391717,10882,'is','',0),(391718,10882,'dr','ÙˆØ¶ÙˆØ­',0),(391719,10882,'pr','ÙˆØ¶ÙˆØ­',0),(391720,10882,'tr','Ã‡Ã¶zÃ¼nÃ¼rlÃ¼k',0),(391721,10882,'pl','RozdzielczoÅ›Ä‡',0),(391722,10882,'bg','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»Ð½Ð° ÑÐ¿Ð¾ÑÐ¾Ð±Ð½Ð¾ÑÑ‚',0),(391723,10882,'ur','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(391724,10882,'sr','Ð ÐµÐ·Ð¾Ð»ÑƒÑ†Ð¸Ñ˜Ð°',0),(391725,10882,'vi','quyáº¿t Ä‘á»‹nh',0),(391726,10882,'af','Resolusie',0),(391727,10882,'ro','RezoluÅ£ie',0),(391728,10882,'et','Resolutsioon',0),(391729,10882,'si','Resolucija',0),(391730,10882,'ba','Resolusi',0),(391731,10882,'nl','Resolutie',0),(391732,10882,'fi','PÃ¤Ã¤tÃ¶slauselma',0),(391733,10882,'no','OpplÃ¸sning',0),(391734,10882,'da','OplÃ¸sning',0),(391735,10882,'ko','í•´ìƒë„',0),(391736,10882,'he','×¨×–×•×œ×•×¦×™×”',0),(391737,10882,'el','Î¨Î®Ï†Î¹ÏƒÎ¼Î±',0),(391738,10882,'zh','å†³è®®\r\n',0),(391739,10882,'sv','UpplÃ¶sning',0),(391740,10882,'it','Risoluzione',0),(391741,10882,'tl','',0),(391742,10882,'th','à¸„à¸§à¸²à¸¡à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”',0),(391743,10882,'hi','à¤¸à¤‚à¤•à¤²à¥à¤ª',0),(391744,10882,'ms','Resolusi',0),(391745,10882,'ar','Ù‚Ø±Ø§Ø±',0),(391746,10882,'fr','RÃ©solution',0),(391747,10882,'jp','è§£åƒåº¦',0),(391748,10882,'pt','ResoluÃ§Ã£o',0),(391749,10882,'ru','Ð ÐµÐ·Ð¾Ð»ÑŽÑ†Ð¸Ñ',0),(391750,10882,'es','ResoluciÃ³n',0),(391751,10882,'de','AuflÃ¶sung',0),(391752,10882,'en','Resolution',0),(391753,10883,'is','',0),(391754,10883,'dr','(Ø«Ø¨Øª Ø®Ø±ÙˆØ¬) ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(391755,10883,'pr','Ø«Ø¨Øª Ù†Ø§Ù… (Ø«Ø¨Øª Ø®Ø±ÙˆØ¬) ØªØ¬Ù‡ÙŠØ²Ø§Øª',0),(391756,10883,'tr','KayÄ±t EkipmanÄ±',0),(391757,10883,'pl','Zarejestruj siÄ™, sprzÄ™t',0),(391758,10883,'bg','Ð˜Ð·Ð»ÐµÐ·Ñ‚Ðµ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð²Ð°Ð½Ðµ',0),(391759,10883,'ur','Ø³Ø§Ù…Ø§Ù† Ú©Ùˆ Ø¨Ø§ÛØ± Ø³Ø§Ø¦Ù† Ø§Ù† Ú©Ø±ÛŒÚº',0),(391760,10883,'sr','ÐžÐ´Ñ˜Ð°Ð²Ð¸ ÑÐµ Ð¾Ð¿Ñ€ÐµÐ¼Ð°',0),(391761,10883,'vi','ÄÄƒng xuáº¥t vÃ o thiáº¿t bá»‹ nÃ y',0),(391762,10883,'af','Teken uit toerusting',0),(391763,10883,'ro','DeconectaÅ£i-vÄƒ echipamentele',0),(391764,10883,'et','Logi vÃ¤lja seadmed',0),(391765,10883,'si','IzpiÅ¡ite oprema',0),(391766,10883,'ba','Keluar peralatan',0),(391767,10883,'nl','Meld u af apparatuur',0),(391768,10883,'fi','Kirjaudu ulos laitteet',0),(391769,10883,'no','Logg utstyr',0),(391770,10883,'da','Log af udstyr',0),(391771,10883,'ko','ë¡œê·¸ ì•„ì›ƒ ìž¥ë¹„',0),(391772,10883,'he','×¦× ×¦×™×•×“',0),(391773,10883,'el','Î•Î¾Î­Î»Î¸ÎµÏ„Îµ ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼ÏŒÏ‚',0),(391774,10883,'zh','èµ¶å¿«å‡ºè®¾å¤‡\r\n',0),(391775,10883,'sv','Logga ut utrustning',0),(391776,10883,'it','Esci attrezzature',0),(391777,10883,'tl','',0),(391778,10883,'th','à¸­à¸­à¸à¸ˆà¸²à¸à¸­à¸¸à¸›à¸à¸£à¸“à¹Œ',0),(391779,10883,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤¬à¤¾à¤¹à¤° à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(391780,10883,'ms','Daftar keluar peralatan',0),(391781,10883,'ar','Ù‚Ù… Ø¨ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬ Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(391782,10883,'fr','Signer l\'Ã©quipement',0),(391783,10883,'jp','æ©Ÿå™¨ã‚’ã‚µã‚¤ãƒ³ã‚¢ã‚¦ãƒˆã—ã¾ã™ã€‚',0),(391784,10883,'pt','Cadastre-se para fora do equipamento',0),(391785,10883,'ru','Ð’Ñ‹Ñ…Ð¾Ð´ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(391786,10883,'es','Anotarse al Salir Equipo',0),(391787,10883,'de','GerÃ¤te abmelden',0),(391788,10883,'en','Sign Out Equipment',0),(391789,10884,'is','',0),(391790,10884,'dr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯',0),(391791,10884,'pr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ØªØ§ÙŠÙŠØ¯',0),(391792,10884,'tr','Onay iÃ§in gÃ¶nderilen',0),(391793,10884,'pl','Wniosek o homologacjÄ™',0),(391794,10884,'bg','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²ÐµÐ½Ð¾ Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(391795,10884,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒÙ„Ø¦Û’ Ø§Ø±Ø³Ø§Ù„ Ú©Ø±Ø¯ÛŒØ§',0),(391796,10884,'sr','ÐŸÐ¾Ð´Ð½ÐµÑ‚Ð° Ð½Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ',0),(391797,10884,'vi','Gá»­i Ä‘á»ƒ phÃª duyá»‡t',0),(391798,10884,'af','Ingedien vir Goedkeuring',0),(391799,10884,'ro','Prezentat pentru omologare',0),(391800,10884,'et','Heakskiitmiseks',0),(391801,10884,'si','Odobritev',0),(391802,10884,'ba','Diajukan untuk persetujuan',0),(391803,10884,'nl','Ter goedkeuring voorgelegd',0),(391804,10884,'fi','HyvÃ¤ksyttÃ¤vÃ¤ksi',0),(391805,10884,'no','Sendt til godkjenning',0),(391806,10884,'da','Indsendt til godkendelse',0),(391807,10884,'ko','ìŠ¹ì¸ì„ ìœ„í•´ ì œì¶œ',0),(391808,10884,'he','×œ××™×©×•×¨',0),(391809,10884,'el','Î¥Ï€Î¿Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ Î³Î¹Î± Î­Î³ÎºÏÎ¹ÏƒÎ·',0),(391810,10884,'zh','æŠ¥æ‰¹\r\n',0),(391811,10884,'sv','FÃ¶r godkÃ¤nnande',0),(391812,10884,'it','Sottoposti ad approvazione',0),(391813,10884,'tl','',0),(391814,10884,'th','à¸ªà¹ˆà¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(391815,10884,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤',0),(391816,10884,'ms','Dikemukakan untuk kelulusan',0),(391817,10884,'ar','Ø§Ù„Ù…Ù‚Ø¯Ù…Ø© Ù„Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„ÙŠÙ‡Ø§',0),(391818,10884,'fr','Soumis Ã  l\'approbation',0),(391819,10884,'jp','æ‰¿èªç”¨ã«é€ä¿¡',0),(391820,10884,'pt','Submetido Ã  aprovaÃ§Ã£o',0),(391821,10884,'ru','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½ Ð½Ð° ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(391822,10884,'es','Presentar para AprobaciÃ³n',0),(391823,10884,'de','Zur Genehmigung vorgelegt',0),(391824,10884,'en','Submitted for Approval',0),(391825,10885,'is','',0),(391826,10885,'dr','Ø¯Ø± Ø¯Ø³ØªØ±Ø³ÙŠ Ù…Ø³ØªØ§Ø¬Ø± ',0),(391827,10885,'pr','Ø¯Ø± Ø¯Ø³ØªØ±Ø³ÙŠ Ù…Ø³ØªØ§Ø¬Ø± ',0),(391828,10885,'tr','KiracÄ± kullanÄ±labilirliÄŸi',0),(391829,10885,'pl','DostÄ™pnoÅ›Ä‡ najemcy',0),(391830,10885,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚',0),(391831,10885,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©ÛŒ Ø¯Ø³ØªÛŒØ§Ø¨ÛŒ',0),(391832,10885,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¾ÑÑ‚',0),(391833,10885,'vi','NgÆ°á»i thuÃª nhÃ  Ä‘Ã£ cÃ³ sáºµn',0),(391834,10885,'af','Huurder Beskikbaarheid',0),(391835,10885,'ro','ChiriaÅŸ disponibilitatea',0),(391836,10885,'et','ÃœÃ¼rnik kÃ¤ttesaadavus',0),(391837,10885,'si','Najemnik razpoloÅ¾ljivost',0),(391838,10885,'ba','Ketersediaan penyewa',0),(391839,10885,'nl','Huurder beschikbaarheid',0),(391840,10885,'fi','Vuokralainen saatavuus',0),(391841,10885,'no','Leietaker tilgjengelighet',0),(391842,10885,'da','Lejer tilgÃ¦ngelighed',0),(391843,10885,'ko','ê±°ì£¼ìž ì—¬ë¶€',0),(391844,10885,'he','×”×“×™×™×¨ ×–×ž×™× ×•×ª',0),(391845,10885,'el','Î”Î¹Î±Î¸ÎµÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î± Î¼Î¹ÏƒÎ¸Ï‰Ï„ÏŽÎ½',0),(391846,10885,'zh','ä¸šæƒäººå¯ç”¨æ€§\r\n',0),(391847,10885,'sv','HyresgÃ¤sten tillgÃ¤nglighet',0),(391848,10885,'it','DisponibilitÃ  di inquilino',0),(391849,10885,'tl','',0),(391850,10885,'th','à¸žà¸£à¹‰à¸­à¸¡à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(391851,10885,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤•à¥€ à¤‰à¤ªà¤²à¤¬à¥à¤§à¤¤à¤¾',0),(391852,10885,'ms','Ketersediaan penyewa',0),(391853,10885,'ar','ØªÙˆØ§ÙØ± Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(391854,10885,'fr','DisponibilitÃ© du locataire',0),(391855,10885,'jp','ãƒ†ãƒŠãƒ³ãƒˆã®å¯ç”¨æ€§',0),(391856,10885,'pt','Disponibilidade de inquilino',0),(391857,10885,'ru','ÐÐ°Ð»Ð¸Ñ‡Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð°',0),(391858,10885,'es','Disponibilidad de Inquilino',0),(391859,10885,'de','Mieter-VerfÃ¼gbarkeit',0),(391860,10885,'en','Tenant Availability',0),(391861,10886,'is','',0),(391862,10886,'dr','Ø´Ø±Ø­ Ù…Ø³ØªØ§Ø¬Ø± ',0),(391863,10886,'pr','Ø´Ø±Ø­ Ù…Ø³ØªØ§Ø¬Ø± ',0),(391864,10886,'tr','KiracÄ± aÃ§Ä±klamasÄ±',0),(391865,10886,'pl','Opis najemcy',0),(391866,10886,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(391867,10886,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(391868,10886,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð¾Ð¿Ð¸Ñ',0),(391869,10886,'vi','diá»‡n máº¡o ngÆ°á»i thuÃª nhÃ ',0),(391870,10886,'af','Huurder Beskrywing',0),(391871,10886,'ro','ChiriaÅŸ Descriere',0),(391872,10886,'et','ÃœÃ¼rnik kirjeldus',0),(391873,10886,'si','Najemnik opis',0),(391874,10886,'ba','Deskripsi penyewa',0),(391875,10886,'nl','Beschrijving van de huurder',0),(391876,10886,'fi','Vuokralainen kuvaus',0),(391877,10886,'no','Leietaker beskrivelse',0),(391878,10886,'da','Lejer beskrivelse',0),(391879,10886,'ko','í…Œ ë„Œ íŠ¸ ì„¤ëª…',0),(391880,10886,'he','×ª×™××•×¨ ×”×“×™×™×¨',0),(391881,10886,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(391882,10886,'zh','ä¸šæƒäººæè¿°\r\n',0),(391883,10886,'sv','HyresgÃ¤sten Beskrivning',0),(391884,10886,'it','Descrizione di inquilino',0),(391885,10886,'tl','',0),(391886,10886,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(391887,10886,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤µà¤¿à¤µà¤°à¤£',0),(391888,10886,'ms','Description/kawalan penyewa',0),(391889,10886,'ar','ÙˆØµÙ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(391890,10886,'fr','Description du locataire',0),(391891,10886,'jp','ãƒ†ãƒŠãƒ³ãƒˆã®èª¬æ˜Ž',0),(391892,10886,'pt','DescriÃ§Ã£o de inquilino',0),(391893,10886,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(391894,10886,'es','DescripciÃ³n de Inquilino',0),(391895,10886,'de','Mieter Beschreibung',0),(391896,10886,'en','Tenant Description',0),(391897,10887,'is','',0),(391898,10887,'dr','Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ ',0),(391899,10887,'pr','Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ ',0),(391900,10887,'tr','SonlandÄ±rÄ±ldÄ±',0),(391901,10887,'pl','ZakoÅ„czone',0),(391902,10887,'bg','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‚ÐµÐ½Ð¾',0),(391903,10887,'ur','Ø®ØªÙ… ÛÙˆ Ú¯ÛŒØ§',0),(391904,10887,'sr','ÐŸÑ€ÐµÐºÐ¸Ð½ÑƒÑ‚',0),(391905,10887,'vi','ÄÃ£ cháº¥m dá»©t',0),(391906,10887,'af','BeÃ«indig',0),(391907,10887,'ro','Reziliat',0),(391908,10887,'et','LÃµpetada',0),(391909,10887,'si','Prekinjen',0),(391910,10887,'ba','Dihentikan',0),(391911,10887,'nl','BeÃ«indigd',0),(391912,10887,'fi','PÃ¤Ã¤ttyy',0),(391913,10887,'no','Avsluttet',0),(391914,10887,'da','Opsagt',0),(391915,10887,'ko','ì¢…ë£Œ',0),(391916,10887,'he','×”×¡×ª×™×™×',0),(391917,10887,'el','Î¤ÎµÏÎ¼Î±Ï„Î¯Î¶ÎµÏ„Î±Î¹',0),(391918,10887,'zh','ç»ˆæ­¢\r\n',0),(391919,10887,'sv','Avslutade',0),(391920,10887,'it','Terminato',0),(391921,10887,'tl','',0),(391922,10887,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸¥à¸‡',0),(391923,10887,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤ˆ',0),(391924,10887,'ms','Ditamatkan',0),(391925,10887,'ar','Ø¥Ù†Ù‡Ø§Ø¡',0),(391926,10887,'fr','RÃ©siliÃ©',0),(391927,10887,'jp','çµ‚äº†',0),(391928,10887,'pt','Finalizado',0),(391929,10887,'ru','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‰ÐµÐ½Ð¾',0),(391930,10887,'es','Terminado',0),(391931,10887,'de','Beendet',0),(391932,10887,'en','Terminated',0),(391933,10888,'is','',0),(391934,10888,'dr','ÙÙˆØ±Ù‰',0),(391935,10888,'pr','ÙÙˆØ±Ù‰',0),(391936,10888,'tr','Acil',0),(391937,10888,'pl','Pilne',0),(391938,10888,'bg','Ð¡Ð¿ÐµÑˆÐ½Ð¾',0),(391939,10888,'ur','ÙÙˆØ±ÛŒ',0),(391940,10888,'sr','Ð¥Ð¸Ñ‚Ð½Ð¾',0),(391941,10888,'vi','Kháº©n cáº¥p',0),(391942,10888,'af','Dringend',0),(391943,10888,'ro','Urgente',0),(391944,10888,'et','Kiireloomulised',0),(391945,10888,'si','Nujno',0),(391946,10888,'ba','Mendesak',0),(391947,10888,'nl','Dringende',0),(391948,10888,'fi','Kiireellinen',0),(391949,10888,'no','Haster',0),(391950,10888,'da','Presserende',0),(391951,10888,'ko','ê¸´ê¸‰',0),(391952,10888,'he','×“×—×•×£',0),(391953,10888,'el','Î•Ï€ÎµÎ¯Î³Î¿Ï…ÏƒÎ±',0),(391954,10888,'zh','ç´§æ€¥\r\n',0),(391955,10888,'sv','BrÃ¥dskande',0),(391956,10888,'it','Urgente',0),(391957,10888,'tl','',0),(391958,10888,'th','à¸”à¹ˆà¸§à¸™',0),(391959,10888,'hi','à¤…à¤¤à¥à¤¯à¤¾à¤µà¤¶à¥à¤¯à¤•',0),(391960,10888,'ms','Segera',0),(391961,10888,'ar','Ø¹Ø§Ø¬Ù„',0),(391962,10888,'fr','Urgent',0),(391963,10888,'jp','ç·Šæ€¥',0),(391964,10888,'pt','Urgente',0),(391965,10888,'ru','Ð¡Ñ€Ð¾Ñ‡Ð½Ð¾',0),(391966,10888,'es','Ugente',0),(391967,10888,'de','Dringende',0),(391968,10888,'en','Urgent',0),(391969,10889,'is','',0),(391970,10889,'dr','Ø¶Ù…Ø§Ù†Øª ÙƒØ§Ø± ',0),(391971,10889,'pr','Ø¶Ù…Ø§Ù†Øª ÙƒØ§Ø± ',0),(391972,10889,'tr','Garanti iÅŸ',0),(391973,10889,'pl','Gwarancja pracy',0),(391974,10889,'bg','Ð“Ð°Ñ€Ð°Ð½Ñ†Ð¸Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(391975,10889,'ur','ÙˆØ§Ø±Ù†Ù¹ÛŒ Ú©Ø§Ù…',0),(391976,10889,'sr','Ð“Ð°Ñ€Ð°Ð½Ñ‚Ð½Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(391977,10889,'vi','Báº£o hÃ nh cÃ´ng viá»‡c',0),(391978,10889,'af','Waarborg werk',0),(391979,10889,'ro','GaranÅ£ie de lucru',0),(391980,10889,'et','Garantii tÃ¶Ã¶le',0),(391981,10889,'si','Garancija dela',0),(391982,10889,'ba','Garansi pekerjaan',0),(391983,10889,'nl','Garantie werk',0),(391984,10889,'fi','Takuun tyÃ¶n',0),(391985,10889,'no','Garantiarbeid',0),(391986,10889,'da','Garanti arbejde',0),(391987,10889,'ko','ë³´ì¦ ì—…ë¬´',0),(391988,10889,'he','××—×¨×™×•×ª ×‘×¢×‘×•×“×”',0),(391989,10889,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÎµÎ¾Î¿Ï…ÏƒÎ¹Î¿Î´ÏŒÏ„Î·ÏƒÎ·Ï‚',0),(391990,10889,'zh','ä¿ä¿®å·¥ä½œ\r\n',0),(391991,10889,'sv','Garantiarbete',0),(391992,10889,'it','Garanzia lavoro',0),(391993,10889,'tl','',0),(391994,10889,'th','à¸£à¸±à¸šà¸›à¸£à¸°à¸à¸±à¸™à¸‡à¸²à¸™',0),(391995,10889,'hi','à¤µà¤¾à¤°à¤‚à¤Ÿà¥€ à¤•à¤¾à¤®',0),(391996,10889,'ms','Jaminan kerja',0),(391997,10889,'ar','Ø¹Ù…Ù„ Ø§Ù„Ø¶Ù…Ø§Ù†',0),(391998,10889,'fr','Travaux sous garantie',0),(391999,10889,'jp','ä¿è¨¼ã®ä»•äº‹',0),(392000,10889,'pt','Trabalho de garantia',0),(392001,10889,'ru','Ð“Ð°Ñ€Ð°Ð½Ñ‚Ð¸Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(392002,10889,'es','Trabajo Bajo GarantÃ­a',0),(392003,10889,'de','GewÃ¤hrleistungsarbeiten',0),(392004,10889,'en','Warranty Work',0),(392005,10890,'is','',0),(392006,10890,'dr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ÙØ¹Ø§Ù„ ',0),(392007,10890,'pr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ÙØ¹Ø§Ù„ ',0),(392008,10890,'tr','Ä°ÅŸ sipariÅŸi etkin',0),(392009,10890,'pl','Praca zlecenia aktywne',0),(392010,10890,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð°ÐºÑ‚Ð¸Ð²ÐµÐ½',0),(392011,10890,'ur','ØªØ±ØªÛŒØ¨ Ø²ÛŒØ± Ø¹Ù…Ù„ Ú©Ø§Ù…',0),(392012,10890,'sr','ÐÐºÑ‚Ð¸Ð²Ð°Ð½ Ñ€Ð°Ð´ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(392013,10890,'vi','lá»‡nh lÃ m viá»‡c Ä‘Ã£ cÃ³ hiá»‡u lá»±c',0),(392014,10890,'af','Werkbestelling Aktief',0),(392015,10890,'ro','Lucra ordin Active',0),(392016,10890,'et','TÃ¶Ã¶ tellimus aktiivne',0),(392017,10890,'si','Aktivni nalog delo',0),(392018,10890,'ba','Kerja Order aktif',0),(392019,10890,'nl','Work Order Active',0),(392020,10890,'fi','TyÃ¶ jÃ¤rjestyksessÃ¤ aktiivinen',0),(392021,10890,'no','Arbeid for aktiv',0),(392022,10890,'da','Arbejde for aktiv',0),(392023,10890,'ko','ìž‘ì—… ìˆœì„œ í™œì„±',0),(392024,10890,'he','×¤×¢×™×œ ×¡×“×¨ ×”×¢×‘×•×“×”',0),(392025,10890,'el','Î•Î½ÎµÏÎ³Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(392026,10890,'zh','æ´»è·ƒå·¥ä½œå•\r\n',0),(392027,10890,'sv','Arbete fÃ¶r aktiv',0),(392028,10890,'it','Lavoro ordine attivo',0),(392029,10890,'tl','',0),(392030,10890,'th','à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™',0),(392031,10890,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤¸à¤•à¥à¤°à¤¿à¤¯',0),(392032,10890,'ms','Aktif perintah kerja',0),(392033,10890,'ar','Ø¹Ù…Ù„ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ù†Ø´Ø·Ø©',0),(392034,10890,'fr','Travail ordre actif',0),(392035,10890,'jp','ä½œæ¥­é †åºã‚¢ã‚¯ãƒ†ã‚£ãƒ–',0),(392036,10890,'pt','Ativos da ordem de trabalho',0),(392037,10890,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ð¹ Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(392038,10890,'es','Orden de Trabajo Activo',0),(392039,10890,'de','Work Order Active',0),(392040,10890,'en','Work Order Active',0),(392041,10891,'is','',0),(392042,10891,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(392043,10891,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(392044,10891,'tr','Ã‡alÄ±ÅŸma dÃ¼zenini ekleme',0),(392045,10891,'pl','Dodaj zlecenie',0),(392046,10891,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ°',0),(392047,10891,'ur','Ú©Ø§Ù… Ú©Û’ Ø­Ú©Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(392048,10891,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ€Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(392049,10891,'vi','ThÃªm lá»‡nh',0),(392050,10891,'af','Werkbestelling Byvoeg',0),(392051,10891,'ro','AdÄƒugaÅ£i comanda de lucru',0),(392052,10891,'et','TÃ¶Ã¶kÃ¤su lisamine',0),(392053,10891,'si','Dodaj delovni nalog',0),(392054,10891,'ba','Tambahkan perintah kerja',0),(392055,10891,'nl','Werkorder toevoegen',0),(392056,10891,'fi','TyÃ¶tilaus lisÃ¤Ã¤',0),(392057,10891,'no','Arbeidsordre legge',0),(392058,10891,'da','Arbejdsordre tilfÃ¸je',0),(392059,10891,'ko','ìž‘ì—… ìˆœì„œ ì¶”ê°€',0),(392060,10891,'he','×”×–×ž× ×ª ×”×¢×‘×•×“×” ×œ×”×•×¡×™×£',0),(392061,10891,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÎ½Ï„Î¿Î»Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(392062,10891,'zh','å·¥ä½œå•æ–°å¢ž\r\n',0),(392063,10891,'sv','Arbetsorder lÃ¤gga till',0),(392064,10891,'it','Ordine di lavoro aggiungere',0),(392065,10891,'tl','',0),(392066,10891,'th','à¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™à¹€à¸žà¸´à¹ˆà¸¡',0),(392067,10891,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(392068,10891,'ms','Menambah arahan kerja',0),(392069,10891,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù…Ø± Ø§Ù„Ø¹Ù…Ù„',0),(392070,10891,'fr','Bon de travail ajouter',0),(392071,10891,'jp','ä½œæ¥­é †åºã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(392072,10891,'pt','Ordem de trabalho adicionar',0),(392073,10891,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(392074,10891,'es','Orden de Trabajo Agregar',0),(392075,10891,'de','Arbeitsauftrag hinzufÃ¼gen',0),(392076,10891,'en','Work Order Add',0),(392077,10892,'is','',0),(392078,10892,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(392079,10892,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(392080,10892,'tr','Ã‡alÄ±ÅŸma dÃ¼zenini ekleme baÅŸarÄ±sÄ±z',0),(392081,10892,'pl','Zlecenie dodaÄ‡ nie powiodÅ‚o siÄ™',0),(392082,10892,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(392083,10892,'ur','Ú©Ø§Ù… Ø­Ú©Ù… Ù†Ø§Ú©Ø§Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(392084,10892,'sr','Ð Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð´Ð¾Ð´Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¿Ð°Ð»Ð¸',0),(392085,10892,'vi','ThÃªm lá»‡nh tháº¥t báº¡i',0),(392086,10892,'af','Werkbestelling Byvoeg het Gefaal',0),(392087,10892,'ro','Comanda de lucru Adauga nu a reuÅŸit',0),(392088,10892,'et','TÃ¶Ã¶kÃ¤su lisamine nurjus',0),(392089,10892,'si','Delo nalog dodati ni',0),(392090,10892,'ba','Urutan kerja menambahkan gagal',0),(392091,10892,'nl','Werkorder mislukte toevoegen',0),(392092,10892,'fi','TyÃ¶tilaus lisÃ¤ys epÃ¤onnistui',0),(392093,10892,'no','Arbeidsordre legge mislyktes',0),(392094,10892,'da','Arbejdsordre tilfÃ¸je mislykkedes',0),(392095,10892,'ko','ìž‘ì—… ìˆœì„œ ì¶”ê°€ ì‹¤íŒ¨',0),(392096,10892,'he','×”×–×ž× ×ª ×”×¢×‘×•×“×” ×œ×”×•×¡×™×£ ×©× ×›×©×œ×•',0),(392097,10892,'el','Î•Î½Ï„Î¿Î»Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(392098,10892,'zh','å·¥ä½œå•æ·»åŠ å¤±è´¥\r\n',0),(392099,10892,'sv','Arbetsorder lÃ¤gga till misslyckades',0),(392100,10892,'it','Ordine di lavoro aggiungere fallito',0),(392101,10892,'tl','',0),(392102,10892,'th','à¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(392103,10892,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(392104,10892,'ms','Arahan kerja Tambah gagal',0),(392105,10892,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù…Ø± Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ÙØ§Ø´Ù„Ø©',0),(392106,10892,'fr','Bon de travail ajouter ayant Ã©chouÃ©',0),(392107,10892,'jp','ä½œæ¥­æ³¨æ–‡è¿½åŠ ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(392108,10892,'pt','Ordem de trabalho Adicionar falha',0),(392109,10892,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(392110,10892,'es','Orden de Trabajo Agregar FallÃ³',0),(392111,10892,'de','Arbeitsauftrag hinzufÃ¼gen fehlgeschlagen',0),(392112,10892,'en','Work Order Add Failed',0),(392113,10893,'is','',0),(392114,10893,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(392115,10893,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(392116,10893,'tr','Ä°ÅŸ emri baÅŸarÄ±yla eklendi',0),(392117,10893,'pl','Zlecenie dodano pomyÅ›lnie',0),(392118,10893,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(392119,10893,'ur','Ú©Ø§Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(392120,10893,'sr','Ð Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(392121,10893,'vi','Lá»‡nh Ä‘Ã£ thÃªm vÃ o thÃ nh cÃ´ng',0),(392122,10893,'af','Werk Bestelling Suksesvol Bygevoeg',0),(392123,10893,'ro','Comanda de lucru adÄƒugat cu succes',0),(392124,10893,'et','Lisatud tÃ¶Ã¶kÃ¤su',0),(392125,10893,'si','Delovnega naloga uspeÅ¡no dodani',0),(392126,10893,'ba','Urutan kerja ditambahkan berhasil',0),(392127,10893,'nl','Werkorder toegevoegd',0),(392128,10893,'fi','TyÃ¶tilaus lisÃ¤Ã¤minen onnistui',0),(392129,10893,'no','Arbeidsordre lagt',0),(392130,10893,'da','Arbejdsordre tilfÃ¸jet',0),(392131,10893,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ìž‘ì—… ìˆœì„œ',0),(392132,10893,'he','×”×–×ž× ×ª ×”×¢×‘×•×“×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(392133,10893,'el','Î•Î½Ï„Î¿Î»Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(392134,10893,'zh','å·¥ä½œå•æˆåŠŸæ·»åŠ \r\n',0),(392135,10893,'sv','Arbetsorder som lagts',0),(392136,10893,'it','Ordine di lavoro aggiunto con successo',0),(392137,10893,'tl','',0),(392138,10893,'th','à¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(392139,10893,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(392140,10893,'ms','Arahan kerja yang berjaya menambah',0),(392141,10893,'ar','ÙŠØ¹Ù…Ù„ Ø§Ù„Ù†Ø¸Ø§Ù… Ø¨Ù†Ø¬Ø§Ø­ ÙˆØ£Ø¶Ø§Ù',0),(392142,10893,'fr','Bon de travail ajoutÃ© avec succÃ¨s',0),(392143,10893,'jp','ä½œæ¥­ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸé †åº',0),(392144,10893,'pt','Ordem de serviÃ§o adicionado com sucesso',0),(392145,10893,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(392146,10893,'es','Orden de Trabajo Agregado Exitosamente',0),(392147,10893,'de','Arbeitsauftrag erfolgreich hinzugefÃ¼gt',0),(392148,10893,'en','Work Order Added Successfully',0),(392149,10894,'is','',0),(392150,10894,'dr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(392151,10894,'pr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(392152,10894,'tr','Ä°ÅŸ sipariÅŸi sil',0),(392153,10894,'pl','UsuÅ„ zamÃ³wienie praca',0),(392154,10894,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(392155,10894,'ur','ØªØ±ØªÛŒØ¨ Ú©Ø§Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(392156,10894,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ñ€Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(392157,10894,'vi','XÃ³a lá»‡nh',0),(392158,10894,'af','Werkbestelling Skrap',0),(392159,10894,'ro','FuncÅ£ioneazÄƒ comanda Delete',0),(392160,10894,'et','TÃ¶Ã¶ korralduse kustutamine',0),(392161,10894,'si','Brisanje dela nalog',0),(392162,10894,'ba','Urutan kerja Hapus',0),(392163,10894,'nl','Werk Order verwijderen',0),(392164,10894,'fi','TyÃ¶tÃ¤ tilauksen poistaminen',0),(392165,10894,'no','Jobb for sletting',0),(392166,10894,'da','Arbejde for slet',0),(392167,10894,'ko','ìž‘ì—… ìˆœì„œ ì‚­ì œ',0),(392168,10894,'he','×ž×—×§ ×”×–×ž× ×” ×œ×¢×‘×•×“',0),(392169,10894,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î³Î¹Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(392170,10894,'zh','åˆ é™¤å·¥ä½œå•\r\n',0),(392171,10894,'sv','Arbete ordning ta bort',0),(392172,10894,'it','Cancella ordine lavoro',0),(392173,10894,'tl','',0),(392174,10894,'th','à¸¥à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™',0),(392175,10894,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤¹à¤Ÿà¤¾à¤à¤',0),(392176,10894,'ms','Padam perintah kerja',0),(392177,10894,'ar','Ø­Ø°Ù Ø£Ù…Ø± Ø§Ù„Ø¹Ù…Ù„',0),(392178,10894,'fr','Supprimer de l\'ordre de travail',0),(392179,10894,'jp','ä½œæ¥­æ³¨æ–‡ã®å‰Šé™¤',0),(392180,10894,'pt','Ordem de trabalho Delete',0),(392181,10894,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ',0),(392182,10894,'es','Orden de Trabajo Eliminar',0),(392183,10894,'de','Arbeit Bestellung lÃ¶schen',0),(392184,10894,'en','Work Order Delete',0),(392185,10895,'is','',0),(392186,10895,'dr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(392187,10895,'pr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(392188,10895,'tr','Ä°ÅŸ sipariÅŸi sil baÅŸarÄ±sÄ±z oldu',0),(392189,10895,'pl','UsuÅ„ zamÃ³wienie pracy nie powiodÅ‚o siÄ™',0),(392190,10895,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ðµ Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(392191,10895,'ur','Ù†Ø§Ú©Ø§Ù… Ú©Ø§Ù… Ø­Ú©Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(392192,10895,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ð¾ÑÐ»Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(392193,10895,'vi','XÃ³a lá»‡nh tháº¥t báº¡i',0),(392194,10895,'af','Werkbestelling Skrapping het Gefaal',0),(392195,10895,'ro','Activitatea comanda Delete nu a reuÈ™it',0),(392196,10895,'et','TÃ¶Ã¶ korralduse kustutamine nurjus',0),(392197,10895,'si','Delo nalog brisanje ni uspela',0),(392198,10895,'ba','Kerja perintah Delete gagal',0),(392199,10895,'nl','Werk Order verwijderen is mislukt',0),(392200,10895,'fi','TyÃ¶n tilauksen poistaminen epÃ¤onnistui',0),(392201,10895,'no','Arbeid for sletting mislyktes',0),(392202,10895,'da','Arbejde for sletning mislykkedes',0),(392203,10895,'ko','ìž‘ì—… ìˆœì„œ ì‚­ì œ ì‹¤íŒ¨',0),(392204,10895,'he','×ž×—×§ ×¡×“×¨ ×”×¢×‘×•×“×” × ×›×©×œ×”',0),(392205,10895,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÏƒÎµÎ¹ÏÎ¬ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(392206,10895,'zh','å·¥ä½œå•åˆ é™¤å¤±è´¥\r\n',0),(392207,10895,'sv','Arbete fÃ¶r Delete misslyckades',0),(392208,10895,'it','Lavoro ordine eliminazione non riuscita',0),(392209,10895,'tl','',0),(392210,10895,'th','à¸¥à¸šà¸¥à¸³à¸”à¸±à¸šà¸‡à¸²à¸™à¸—à¸µà¹ˆà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(392211,10895,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤¹à¤Ÿà¤¾à¤à¤ à¤µà¤¿à¤«à¤²',0),(392212,10895,'ms','Padam perintah kerja yang gagal',0),(392213,10895,'ar','Ø­Ø°Ù Ø£Ù…Ø± Ø§Ù„Ø¹Ù…Ù„ ÙØ´Ù„Øª',0),(392214,10895,'fr','Ã‰chouÃ© de la suppression travail ordonnance',0),(392215,10895,'jp','ä½œæ¥­é †åºå‰Šé™¤ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(392216,10895,'pt','Falhado ao excluir trabalho ordem',0),(392217,10895,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(392218,10895,'es','Orden de Trabajo Eliminar FallÃ³',0),(392219,10895,'de','Arbeit Auftrag LÃ¶schen fehlgeschlagen',0),(392220,10895,'en','Work Order Delete Failed',0),(392221,10896,'is','',0),(392222,10896,'dr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(392223,10896,'pr','Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(392224,10896,'tr','Ä°ÅŸ emri baÅŸarÄ±yla silindi',0),(392225,10896,'pl','Zlecenie przesâ”‚anie',0),(392226,10896,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(392227,10896,'ur','Ú©Ø§Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ù†ÛÛŒÚº Ú©ÛŒ',0),(392228,10896,'sr','Ð Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(392229,10896,'vi','XÃ³a lá»‡nh thÃ nh cÃ´ng',0),(392230,10896,'af','Werk Bestelling Suksesvol Geskrap',0),(392231,10896,'ro','Comanda de lucru eliminÄƒ cu succes',0),(392232,10896,'et','TÃ¶Ã¶kÃ¤su edukalt kustutatud',0),(392233,10896,'si','Delovnega naloga uspeÅ¡no izbrisana',0),(392234,10896,'ba','Urutan kerja dihapus berhasil',0),(392235,10896,'nl','Werkorder succesvol verwijderd',0),(392236,10896,'fi','TyÃ¶tilaus poistettu',0),(392237,10896,'no','Arbeidsordre slettet',0),(392238,10896,'da','Arbejdsordre slettet',0),(392239,10896,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ìž‘ì—… ìˆœì„œ',0),(392240,10896,'he','×”×–×ž× ×ª ×”×¢×‘×•×“×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(392241,10896,'el','Î•Î½Ï„Î¿Î»Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(392242,10896,'zh','å·¥ä½œå•æˆåŠŸåˆ é™¤\r\n',0),(392243,10896,'sv','Arbetsorder raderades',0),(392244,10896,'it','Ordine di lavoro eliminato con successo',0),(392245,10896,'tl','',0),(392246,10896,'th','à¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(392247,10896,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(392248,10896,'ms','Arahan kerja yang dihapuskan dengan jayanya',0),(392249,10896,'ar','ÙŠØ¹Ù…Ù„ Ø§Ù„Ù†Ø¸Ø§Ù… Ø¨Ù†Ø¬Ø§Ø­ Ø­Ø°Ù',0),(392250,10896,'fr','Bon de travail supprimÃ© avec succÃ¨s',0),(392251,10896,'jp','ä½œæ¥­é †åºã‚’æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(392252,10896,'pt','Ordem de trabalho excluÃ­do com sucesso',0),(392253,10896,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(392254,10896,'es','Orden de Trabajo Eliminado Exitosamente',0),(392255,10896,'de','Arbeitsauftrag erfolgreich gelÃ¶scht',0),(392256,10896,'en','Work Order Deleted Successfully',0),(392257,10897,'is','',0),(392258,10897,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(392259,10897,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(392260,10897,'tr','Ä°ÅŸ sipariÅŸi gÃ¼ncelleÅŸtirmesi',0),(392261,10897,'pl','Praca zamÃ³wienia aktualizacji',0),(392262,10897,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(392263,10897,'ur','Ú©Ø§Ù… ØªØ±ØªÛŒØ¨ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(392264,10897,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ð¾ÑÐ»Ð°',0),(392265,10897,'vi','Cáº­p nháº­t lá»‡nh',0),(392266,10897,'af','Werksbestelling Opdateer',0),(392267,10897,'ro','Actualizare de ordine de lucru',0),(392268,10897,'et','TÃ¶Ã¶ Tootmistellimuse vÃ¤rskendamine',0),(392269,10897,'si','Delo da posodobitev',0),(392270,10897,'ba','Kerja perintah Update',0),(392271,10897,'nl','Werk volgorde Update',0),(392272,10897,'fi','TyÃ¶n pÃ¤ivitys',0),(392273,10897,'no','Arbeid ordreoppdatering',0),(392274,10897,'da','Arbejde ordrevedligeholdelse',0),(392275,10897,'ko','ìž‘ì—… ì£¼ë¬¸ ì—…ë°ì´íŠ¸',0),(392276,10897,'he','×¢×“×›×•×Ÿ ×¡×“×¨ ×”×¢×‘×•×“×”',0),(392277,10897,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î´Î¹Î¬Ï„Î±Î¾Î· Update',0),(392278,10897,'zh','å·¥ä½œå•æ›´æ–°\r\n',0),(392279,10897,'sv','Arbete orderuppdatering',0),(392280,10897,'it','Aggiornamento ordine lavoro',0),(392281,10897,'tl','',0),(392282,10897,'th','à¸à¸²à¸£à¸­à¸±à¸žà¹€à¸”à¸•à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸œà¸¥à¸´à¸•',0),(392283,10897,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(392284,10897,'ms','Kemaskini perintah kerja',0),(392285,10897,'ar','ØªØ­Ø¯ÙŠØ« Ù†Ø¸Ø§Ù… Ø§Ù„Ø¹Ù…Ù„',0),(392286,10897,'fr','Mise Ã  jour de commande de travaux',0),(392287,10897,'jp','ä½œæ¥­æ³¨æ–‡ã®æ›´æ–°',0),(392288,10897,'pt','AtualizaÃ§Ã£o de ordem de trabalho',0),(392289,10897,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(392290,10897,'es','Orden de Trabajo Actualizar',0),(392291,10897,'de','Arbeit-Auftrag-Update',0),(392292,10897,'en','Work Order Update',0),(392293,10898,'is','',0),(392294,10898,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(392295,10898,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(392296,10898,'tr','Ä°ÅŸ sipariÅŸi gÃ¼ncelleÅŸtirmesi baÅŸarÄ±sÄ±z oldu',0),(392297,10898,'pl','Praca zamÃ³wienia aktualizacji nie powiodÅ‚o siÄ™',0),(392298,10898,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(392299,10898,'ur','Ù†Ø§Ú©Ø§Ù… Ú©Ø§Ù… ØªØ±ØªÛŒØ¨ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(392300,10898,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ð¾ÑÐ»Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(392301,10898,'vi','Cáº­p nháº­t lá»‡nh tháº¥t báº¡i',0),(392302,10898,'af','Werksbestelling Opdatering het Gefaal',0),(392303,10898,'ro','Activitatea comanda Update nu a reuÈ™it',0),(392304,10898,'et','TÃ¶Ã¶ Tootmistellimuse vÃ¤rskendamine nurjus',0),(392305,10898,'si','Delo naloga ni mogoÄe posodobiti',0),(392306,10898,'ba','Gagal Update Order pekerjaan',0),(392307,10898,'nl','Werk volgorde Update is mislukt',0),(392308,10898,'fi','TyÃ¶n pÃ¤ivitys epÃ¤onnistui',0),(392309,10898,'no','Arbeid oppdateringen mislyktes',0),(392310,10898,'da','Arbejde ordrevedligeholdelse mislykkedes',0),(392311,10898,'ko','ìž‘ì—… ìˆœì„œ ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(392312,10898,'he','×¢×“×›×•×Ÿ ×¡×“×¨ ×”×¢×‘×•×“×” × ×›×©×œ×”',0),(392313,10898,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î´Î¹Î¬Ï„Î±Î¾Î· Update Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(392314,10898,'zh','å·¥ä½œå•æ›´æ–°å¤±è´¥\r\n',0),(392315,10898,'sv','Arbete fÃ¶r uppdateringen misslyckades',0),(392316,10898,'it','Ordine di lavoro aggiornamento non riuscito',0),(392317,10898,'tl','',0),(392318,10898,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸à¸²à¸£à¸¥à¸³à¸”à¸±à¸šà¸‡à¸²à¸™à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(392319,10898,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(392320,10898,'ms','Kerja-kerja Kemaskini perintah yang gagal',0),(392321,10898,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù…Ù„',0),(392322,10898,'fr','Ordre de travaux mise Ã  jour a Ã©chouÃ©',0),(392323,10898,'jp','ä»•äº‹ã®é †åºã‚’æ›´æ–°ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(392324,10898,'pt','Ordem de trabalho atualizaÃ§Ã£o falhada',0),(392325,10898,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(392326,10898,'es','Orden de Trabajo Actualizar FallÃ³',0),(392327,10898,'de','Arbeit-Auftrag-Update fehlgeschlagen',0),(392328,10898,'en','Work Order Update Failed',0),(392329,10899,'is','',0),(392330,10899,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(392331,10899,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(392332,10899,'tr','Ä°ÅŸ emri baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(392333,10899,'pl','Zlecenie pomyÅ›lnie zaktualizowana',0),(392334,10899,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(392335,10899,'ur','Ú©Ø§Ù… Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(392336,10899,'sr','Ð Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(392337,10899,'vi','Cáº­p nháº­t lá»‡nh thÃ nh cÃ´ng',0),(392338,10899,'af','Werk Bestelling Suksesvol Opdateer',0),(392339,10899,'ro','Comanda de lucru actualizat cu succes',0),(392340,10899,'et','TÃ¶Ã¶ Tootmistellimuse vÃ¤rskendamine Ãµnnestus',0),(392341,10899,'si','Delovnega naloga uspeÅ¡no posodobljena',0),(392342,10899,'ba','Urutan kerja yang berhasil',0),(392343,10899,'nl','Werkorder bijgewerkt',0),(392344,10899,'fi','TyÃ¶tilaus pÃ¤ivitetty',0),(392345,10899,'no','Arbeidsordre oppdatert',0),(392346,10899,'da','Arbejdsordre opdateret',0),(392347,10899,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ìž‘ì—… ìˆœì„œ',0),(392348,10899,'he','×”×–×ž× ×ª ×”×¢×‘×•×“×” ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(392349,10899,'el','Î•Î½Ï„Î¿Î»Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(392350,10899,'zh','å·¥ä½œå•æˆåŠŸæ›´æ–°\r\n',0),(392351,10899,'sv','Arbetsorder uppdaterats',0),(392352,10899,'it','Ordine di lavoro aggiornato con successo',0),(392353,10899,'tl','',0),(392354,10899,'th','à¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(392355,10899,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(392356,10899,'ms','Arahan kerja yang berjaya dikemas kini',0),(392357,10899,'ar','Ø£Ù…Ø± Ø¹Ù…Ù„ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(392358,10899,'fr','Bon de travail mis Ã  jour avec succÃ¨s',0),(392359,10899,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸä»•äº‹é †åº',0),(392360,10899,'pt','Ordem de trabalho atualizado com sucesso',0),(392361,10899,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(392362,10899,'es','Orden de Trabajo Actualizado Exitosamente',0),(392363,10899,'de','Arbeitsauftrag erfolgreich aktualisiert',0),(392364,10899,'en','Work Order Updated Successfully',0),(392365,10900,'is','',0),(392366,10900,'dr','Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†ÙŠØ¯ ',0),(392367,10900,'pr','Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø±Ø§ ØªØ§ÙŠÙŠØ¯ ÙƒÙ†ÙŠØ¯ ',0),(392368,10900,'tr','Bu iÅŸ emri onaylayamam',0),(392369,10900,'pl','Nie popieram tej kolejnoÅ›ci pracy',0),(392370,10900,'bg','Ð’Ð¸Ðµ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð¸ Ñ‚Ð°Ð·Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(392371,10900,'ur','Ø¢Ù¾ Ø§Ø³ Ú©Ø§Ù… Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ù…Ù†Ø¸ÙˆØ± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(392372,10900,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ñ€Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(392373,10900,'vi','Báº¡n khÃ´ng thá»ƒ duyá»‡t lá»‡nh nÃ y',0),(392374,10900,'af','U Kan Nie Hierdie Werksbestelling Goedkeur Nie.',0),(392375,10900,'ro','Tu nu poate aproba aceastÄƒ ordine de lucru',0),(392376,10900,'et','Ei saa kinnitada kÃ¤esoleva tÃ¶Ã¶ korralduse',0),(392377,10900,'si','Ne more odobriti ta delovni nalog',0),(392378,10900,'ba','Anda tidak bisa menyetujui urutan kerja ini',0),(392379,10900,'nl','U instemmen niet met deze werkorder',0),(392380,10900,'fi','Voi hyvÃ¤ksyÃ¤ tyÃ¶n jÃ¤rjestyksen',0),(392381,10900,'no','Du kan ikke godkjenne denne Arbeidsordre',0),(392382,10900,'da','Du kan ikke godkende denne arbejdsordre',0),(392383,10900,'ko','ì´ ìž‘ì—… ìˆœì„œë¥¼ ìŠ¹ì¸í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(392384,10900,'he','××ª×” ×™×›×•×œ ×œ××©×¨ ×¦×• ×–×” ×¢×‘×•×“×”',0),(392385,10900,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± ÎµÎ³ÎºÏÎ¯Î½ÎµÏ„Îµ Î±Ï…Ï„ÏŒ ÎµÎ½Ï„Î¿Î»Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(392386,10900,'zh','æ‚¨ä¸èƒ½æ‰¹å‡†è¿™é¡¹å·¥ä½œå•\r\n',0),(392387,10900,'sv','Du kan inte godkÃ¤nna denna arbetsorder',0),(392388,10900,'it','Lei non puÃ² approvare questo ordine di lavoro',0),(392389,10900,'tl','',0),(392390,10900,'th','à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸à¸²à¸£à¸œà¸¥à¸´à¸•à¸™à¸µà¹‰',0),(392391,10900,'hi','à¤¤à¥à¤® à¤‡à¤¸ à¤•à¤¾à¤® à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(392392,10900,'ms','Anda tidak boleh meluluskan arahan kerja ini',0),(392393,10900,'ar','ÙŠÙ…ÙƒÙ†Ùƒ Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù… ÙÙŠ Ø§Ù„Ø¹Ù…Ù„',0),(392394,10900,'fr','Vous ne peut pas approuver ce bon de travail',0),(392395,10900,'jp','ã“ã®ä½œæ¥­æ³¨æ–‡ã‚’æ‰¿èªã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(392396,10900,'pt','VocÃª nÃ£o pode aprovar esta ordem de serviÃ§o',0),(392397,10900,'ru','ÐÐµÐ»ÑŒÐ·Ñ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´Ð°Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº ÑÑ‚Ð¾Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(392398,10900,'es','No Puede Aprobar Este Orden de Trabajo ',0),(392399,10900,'de','Sie kÃ¶nnen diese Arbeitsauftrag nicht zustimmen.',0),(392400,10900,'en','You Cannot Approve This Work Order',0),(392401,10901,'is','',0),(392402,10901,'dr','Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø±Ø§ Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(392403,10901,'pr','Ø´Ù…Ø§ Ù†Ù…ÙŠ ØªÙˆØ§Ù†ÙŠØ¯ Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø±Ø§ Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(392404,10901,'tr','Bu iÅŸ emri inkar edemez',0),(392405,10901,'pl','Nie moÅ¼na zaprzeczyÄ‡, to zlecenie',0),(392406,10901,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ñ‚Ñ€ÐµÑ‡Ðµ Ñ‚Ð°Ð·Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ°',0),(392407,10901,'ur','Ø¢Ù¾ Ø§Ø³ Ú©Ø§Ù… Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ø³Û’ Ø§Ù†Ú©Ø§Ø± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(392408,10901,'sr','Ð‘Ð»Ð°ÐºÐµ Ð¾Ð²Ð°Ñ˜ Ñ€Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(392409,10901,'vi','Báº¡n khÃ´ng thá»ƒ tá»« chá»‘i lá»‡nh nÃ y',0),(392410,10901,'af','U Kan Nie Hierdie Werkbestelling Ignoreer Nie',0),(392411,10901,'ro','Nu se poate nega aceastÄƒ ordine de lucru',0),(392412,10901,'et','Ei saa eitada seda tÃ¶Ã¶kÃ¤su',0),(392413,10901,'si','Ne moremo zanikati tega dela nalog',0),(392414,10901,'ba','Anda tidak dapat menyangkal urutan kerja ini',0),(392415,10901,'nl','Je kunt niet ontkennen deze werkorder',0),(392416,10901,'fi','Et voi kieltÃ¤Ã¤ tÃ¤mÃ¤ TyÃ¶tilaus',0),(392417,10901,'no','Du kan ikke nekte denne Arbeidsordre',0),(392418,10901,'da','Du kan ikke benÃ¦gte denne arbejdsordre',0),(392419,10901,'ko','ì´ ìž‘ì—… ìˆœì„œë¥¼ ë¶€ì •í•  ìˆ˜ ì—†ì–´',0),(392420,10901,'he','××ª×” ×œ× ×™×›×•×œ ×œ×”×›×—×™×© ××ª ×¡×“×¨ ×”×¢×‘×•×“×”',0),(392421,10901,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Î±ÏÎ½Î·Î¸ÎµÎ¯Ï„Îµ Î±Ï…Ï„ÏŒ ÎµÎ½Ï„Î¿Î»Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(392422,10901,'zh','ä½ ä¸èƒ½å¦è®¤æ­¤å·¥ä½œå•\r\n',0),(392423,10901,'sv','Du kan inte fÃ¶rneka detta arbetsorder',0),(392424,10901,'it','Non si puÃ² negare questo ordine di lavoro',0),(392425,10901,'tl','',0),(392426,10901,'th','à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™à¸™à¸µà¹‰',0),(392427,10901,'hi','à¤†à¤ª à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤•à¤¾à¤® à¤¸à¥‡ à¤‡à¤¨à¤•à¤¾à¤° à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(392428,10901,'ms','Anda tidak boleh menafikan perintah kerja ini',0),(392429,10901,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ†Ùƒ Ø£Ù† ØªÙ†ÙƒØ± Ù‡Ø°Ø§ Ø§Ù„Ø£Ù…Ø± Ø§Ù„Ø¹Ù…Ù„',0),(392430,10901,'fr','Vous ne pouvez pas nier ce bon de travail',0),(392431,10901,'jp','ã“ã®ä»•äº‹ã®é †åºã‚’å¦å®šã§ãã¾ã›ã‚“ã€‚',0),(392432,10901,'pt','VocÃª nÃ£o pode negar esta ordem de serviÃ§o',0),(392433,10901,'ru','Ð’Ñ‹ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(392434,10901,'es','No Puede Negar Este Orden de Trabajo ',0),(392435,10901,'de','Sie kÃ¶nnen diese Arbeitsauftrag nicht leugnen.',0),(392436,10901,'en','You Cannot Deny This Work Order',0),(392437,10902,'is','',0),(392438,10902,'dr','1099 Ø§Ú¯Ø± Ù¾ÙŠÙ…Ø§Ù†ÙƒØ§Ø± Ø¯Ø³Øª Ø¯ÙˆÙ… Ù…Ø¹Ø§Ù Ø§Ø³Øª',0),(392439,10902,'pr','Ø«Ø¨Øª 1099 Ø§Ú¯Ø± Ù¾ÙŠÙ…Ø§Ù†ÙƒØ§Ø± Ø¯Ø³Øª Ø¯ÙˆÙ… Ù…Ø¹Ø§Ù Ø§Ø³Øª',0),(392440,10902,'tr','1099 girin muaf taÅŸeron',0),(392441,10902,'pl','WprowadÅº 1099, jeÅ¼eli zwolniony podwykonawcy',0),(392442,10902,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ 1099 Ð°ÐºÐ¾ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð´ÐµÐ½Ð¸ Ð¿Ð¾Ð´Ð¸Ð·Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»',0),(392443,10902,'ur','1099 Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº Ø§Ú¯Ø± Subcontractor Ù…Ø¨Ø±Ø§',0),(392444,10902,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ 1099 ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð° Ð°ÐºÐ¾ Ð¸Ð·ÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ð¾Ð´Ð¸Ð·Ð²Ð¾Ñ’Ð°Ñ‡Ð°',0),(392445,10902,'vi','Nháº­p 1099 náº¿u miá»…n Subcontractor',0),(392446,10902,'af','Voer 1099, indien \'n Vrygestelde Sub-Kontrakteur',0),(392447,10902,'ro','IntroduceÅ£i 1099, dacÄƒ subcontractorul scutite',0),(392448,10902,'et','Saate sisestada 1099 kui maksuvaba alltÃ¶Ã¶vÃµtja',0),(392449,10902,'si','Vnesite 1099 Äe izvzeti podizvajalca',0),(392450,10902,'ba','Masukkan 1099 jika subkontraktor dibebaskan',0),(392451,10902,'nl','Voer in 1099 als vrijgesteld onderaannemer',0),(392452,10902,'fi','SyÃ¶tÃ¤ 1099 jos vapautettu alihankkija',0),(392453,10902,'no','Angi 1099 hvis unntatt underleverandÃ¸r',0),(392454,10902,'da','Angiv 1099 hvis undtaget underleverandÃ¸r',0),(392455,10902,'ko','ë§Œì•½ 1099ë¥¼ ìž…ë ¥ ë©´ì œ í•˜ì²­',0),(392456,10902,'he','×”×–×Ÿ 1099 ×× ×§×‘×œ×Ÿ ×¤×˜×•×¨',0),(392457,10902,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ 1099 Î±Î½ Î±Ï€Î±Î»Î»Î¬ÏƒÏƒÎ¿Î½Ï„Î±Î¹ Ï…Ï€ÎµÏÎ³Î¿Î»Î¬Î²Î¿',0),(392458,10902,'zh','å¦‚æžœå…é™¤åˆ†åŒ…å•†è¿›å…¥1099',0),(392459,10902,'sv','Ange 1099 om undantagna underleverantÃ¶r',0),(392460,10902,'it','Immettere 1099 se subappaltatore esenti',0),(392461,10902,'tl','',0),(392462,10902,'th','à¸›à¹‰à¸­à¸™ 1099 à¸–à¹‰à¸²à¹€à¸«à¸¡à¸²à¸¢à¸à¹€à¸§à¹‰à¸™',0),(392463,10902,'hi','1099 à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤¯à¤¦à¤¿ à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤‰à¤ªà¤ à¥‡à¤•à¥‡à¤¦à¤¾à¤°',0),(392464,10902,'ms','Masukkan 1099 jika subkontraktor yang dikecualikan',0),(392465,10902,'ar','Ø£Ø¯Ø®Ù„ 1099 Ø¥Ø°Ø§ \"ÙŠØ¹ÙÙŠ Ø§Ù„Ù…Ù‚Ø§ÙˆÙ„ Ù…Ù† Ø§Ù„Ø¨Ø§Ø·Ù†\"',0),(392466,10902,'fr','Entrez 1099 si sous-traitant exonÃ©rÃ©',0),(392467,10902,'jp','1099 ã‚’å…¥åŠ›å ´åˆå…é™¤ä¸‹è«‹ã‘',0),(392468,10902,'pt','Digite 1099 se isentar subcontratante',0),(392469,10902,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ 1099, ÐµÑÐ»Ð¸ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°ÑŽÑ‚ÑÑ ÑÑƒÐ±Ð¿Ð¾Ð´Ñ€ÑÐ´Ñ‡Ð¸ÐºÐ°',0),(392470,10902,'es','entrar 1099 si el Subcontractor es Exento',0),(392471,10902,'de','Geben Sie 1099, wenn ausgenommen Subunternehmer',0),(392472,10902,'en','Enter 1099 if Exempt Subcontractor',0),(392473,10903,'is','',0),(392474,10903,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª',0),(392475,10903,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª',0),(392476,10903,'tr','Real Estate bina vergisi',0),(392477,10903,'pl','Real Estate budynku podatek',0),(392478,10903,'bg','Ð”Ð°Ð½ÑŠÐº Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¸ Ð¸Ð¼Ð¾Ñ‚Ð¸ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÐµÐ½',0),(392479,10903,'ur','Ø±Ø¦ÛŒÙ„ Ø§Ø³Ù¹ÛŒÙ¹ Ø¨Ù„ÚˆÙ†Ú¯ Ù¹ÛŒÚ©Ø³',0),(392480,10903,'sr','ÐŸÑ€Ð°Ð²Ð¸ Ð•ÑÑ‚Ð°Ñ‚Ðµ Ð·Ð³Ñ€Ð°Ð´Ñƒ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(392481,10903,'vi','Thuáº¿ báº¥t Ä‘á»™ng sáº£n xÃ¢y dá»±ng',0),(392482,10903,'af','Vaste Eiendom Belasting op Verbeteringe',0),(392483,10903,'ro','Real Estate clÄƒdire fiscale',0),(392484,10903,'et','Real Estate hoone maksu',0),(392485,10903,'si','Real Estate stavbe davka',0),(392486,10903,'ba','Perumahan bangunan pajak',0),(392487,10903,'nl','Real Estate gebouw belasting',0),(392488,10903,'fi','Real Estate rakennuksen vero',0),(392489,10903,'no','Real Estate bygningen skatt',0),(392490,10903,'da','Real Estate bygning skat',0),(392491,10903,'ko','ì‹¤ì œ ë¶€ë™ì‚° ê±´ë¬¼ ì„¸ê¸ˆ',0),(392492,10903,'he','×ž×™×¡×•×™ × ×“×œ ×Ÿ ×‘× ×™×™×”',0),(392493,10903,'el','Î¦ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Ï‰Î½ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¹ÏŽÎ½ ÎºÏ„Î¯ÏÎ¹Î¿',0),(392494,10903,'zh','æˆ¿åœ°äº§æˆ¿å±‹ç¨Ž\r\n',0),(392495,10903,'sv','Real Estate byggnad skatt',0),(392496,10903,'it','Real Estate edificio fiscale',0),(392497,10903,'tl','',0),(392498,10903,'th','à¸ à¸²à¸©à¸µà¸ˆà¸£à¸´à¸‡à¸­à¸ªà¸±à¸‡à¸«à¸²à¸£à¸´à¸¡à¸—à¸£à¸±à¸žà¸¢à¹Œà¸­à¸²à¸„à¸²à¸£',0),(392499,10903,'hi','à¤°à¤¿à¤¯à¤² à¤à¤¸à¥à¤Ÿà¥‡à¤Ÿ à¤¬à¤¿à¤²à¥à¤¡à¤¿à¤‚à¤— à¤Ÿà¥ˆà¤•à¥à¤¸',0),(392500,10903,'ms','Cukai tanah estet bangunan',0),(392501,10903,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ© Ø¨Ù†Ø§Ø¡ Ø§Ù„Ø¹Ù‚Ø§Ø±Ø§Øª',0),(392502,10903,'fr','Real Estate bÃ¢timent impÃ´t',0),(392503,10903,'jp','ä¸å‹•ç”£ãƒ“ãƒ«ç¨Ž',0),(392504,10903,'pt','Real Estate predial',0),(392505,10903,'ru','Ð ÐµÐ°Ð»ÑŒÐ½Ð¾Ð³Ð¾ ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð° Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(392506,10903,'es','Impuesto Predial del Edificio',0),(392507,10903,'de','Real Estate Bausteuer',0),(392508,10903,'en','Real Estate Building Tax',0),(392509,10904,'is','',0),(392510,10904,'dr','Ø§Ù†ÙˆØ§Ø¹ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª ',0),(392511,10904,'pr','Ø§Ù†ÙˆØ§Ø¹ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª ',0),(392512,10904,'tr','Emlak vergisi tÃ¼rleri',0),(392513,10904,'pl','Typy prawdziwe podatku od nieruchomoÅ›ci',0),(392514,10904,'bg','Ð”Ð°Ð½ÑŠÐº Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¸ Ð¸Ð¼Ð¾Ñ‚Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(392515,10904,'ur','Ø­Ù‚ÛŒÙ‚ÛŒ Ø§Ø³Ù¹ÛŒÙ¹ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(392516,10904,'sr','Ð¢Ð¸Ð¿Ð¾Ð²Ð¸ Ð¿Ñ€Ð°Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ',0),(392517,10904,'vi','CÃ¡c loáº¡i báº¥t Ä‘á»™ng sáº£n thuáº¿',0),(392518,10904,'af','Vaste Eiendom Belasting Tipes',0),(392519,10904,'ro','Tipuri de Real Estate fiscale',0),(392520,10904,'et','Real Estate maksude liigid',0),(392521,10904,'si','Real Estate stroÅ¡kovni nosilci',0),(392522,10904,'ba','Real Estate pajak jenis',0),(392523,10904,'nl','Real Estate Tax typen',0),(392524,10904,'fi','KiinteistÃ¶vero tyypit',0),(392525,10904,'no','Ekte eiendom skatt typer',0),(392526,10904,'da','Real Estate skat typer',0),(392527,10904,'ko','ë¶€ë™ì‚° ì„¸ê¸ˆ ì¢…ë¥˜',0),(392528,10904,'he','×¡×•×’×™ ×”×ž×¡ ×Ÿ ××ž×™×ª×™',0),(392529,10904,'el','Î¤ÏÏ€Î¿Î¹ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÏŒ Ï†ÏŒÏÎ¿ Î¼ÎµÏ„Î±Î²Î¯Î²Î±ÏƒÎ·Ï‚ Î±ÎºÎ¹Î½Î®Ï„Ï‰Î½',0),(392530,10904,'zh','æˆ¿åœ°äº§ç¨Žç§\r\n',0),(392531,10904,'sv','Verkliga fastighetsskatt typer',0),(392532,10904,'it','Tipi di Real Estate Tax',0),(392533,10904,'tl','',0),(392534,10904,'th','à¸Šà¸™à¸´à¸”à¸ à¸²à¸©à¸µà¸­à¸ªà¸±à¸‡à¸«à¸²à¸£à¸´à¸¡à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ˆà¸£à¸´à¸‡',0),(392535,10904,'hi','à¤°à¤¿à¤¯à¤² à¤à¤¸à¥à¤Ÿà¥‡à¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(392536,10904,'ms','Jenis-jenis cukai harta sebenar',0),(392537,10904,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ© Ø§Ù„Ø­Ù‚ÙŠÙ‚ÙŠØ©',0),(392538,10904,'fr','Types d\'impÃ´t sur les biens rÃ©els',0),(392539,10904,'jp','ä¸å‹•ç”£ç¨Žã®ç¨®é¡ž',0),(392540,10904,'pt','Tipos de Real Estate Tax',0),(392541,10904,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(392542,10904,'es','Impuesto Predial Tipos',0),(392543,10904,'de','Real Estate Steuerarten',0),(392544,10904,'en','Real Estate Tax Types',0),(392545,10905,'is','',0),(392546,10905,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  ÙØ±Ù…Ø§ÛŒØ´ ÙƒØ§Ø± ',0),(392547,10905,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(392548,10905,'tr','Ä°ÅŸ sipariÅŸleri ekleyin/gÃ¼ncelleyin',0),(392549,10905,'pl','Zlecenia pracy Dodaj/Aktualizuj',0),(392550,10905,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(392551,10905,'ur','Ú©Ø§Ù… Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(392552,10905,'sr','Ð Ð°Ð´ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð”Ð¾Ð´Ð°Ñ˜/ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜',0),(392553,10905,'vi','CÃ´ng viá»‡c Ä‘Æ¡n Ä‘áº·t hÃ ng ThÃªm/Cáº­p Nháº­t',0),(392554,10905,'af','Werkbestellings Byvoeg/Opdateer',0),(392555,10905,'ro','Munca comenzi AdÄƒugaÅ£i/actualizaÅ£i',0),(392556,10905,'et','TÃ¶Ã¶ tellimuste lisamine/uuendamine',0),(392557,10905,'si','Delo naroÄil Dodaj/posodobi',0),(392558,10905,'ba','Kerja perintah Tambahkan/Perbarui',0),(392559,10905,'nl','Werk Orders toevoegen/bijwerken',0),(392560,10905,'fi','TyÃ¶tÃ¤ tilausten lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(392561,10905,'no','Arbeid/Oppdater bestillinger',0),(392562,10905,'da','Arbejde ordrer TilfÃ¸j/opdater',0),(392563,10905,'ko','ìž‘ì—… ëª…ë ¹ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(392564,10905,'he','×”×–×ž× ×•×ª ×¢×‘×•×“×” ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(392565,10905,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î­ÏÎ³Î¿ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(392566,10905,'zh','å·¥ä½œå•æ–°å¢ž/æ›´æ–°\r\n',0),(392567,10905,'sv','Arbete order LÃ¤gg till/uppdatera',0),(392568,10905,'it','Lavoro ordini aggiungere/aggiornare',0),(392569,10905,'tl','',0),(392570,10905,'th','à¸‡à¸²à¸™à¸ªà¸±à¹ˆà¸‡à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(392571,10905,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(392572,10905,'ms','Kerja-kerja pesanan Tambah/Kemaskini',0),(392573,10905,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¹Ù…Ù„',0),(392574,10905,'fr','Travail commandes ajouter/mettre Ã  jour',0),(392575,10905,'jp','ä½œæ¥­æ³¨æ–‡ã‚’è¿½åŠ /æ›´æ–°',0),(392576,10905,'pt','Ordens de trabalho adicionar/atualizar',0),(392577,10905,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(392578,10905,'es','Ordenes de Trabajo Agregar/Actualizar',0),(392579,10905,'de','Arbeit Bestellungen hinzufÃ¼gen/aktualisieren',0),(392580,10905,'en','Work Orders Add/Update',0),(392581,10906,'is','',0),(392582,10906,'dr','Ø§Ø³Ù†Ø§Ø¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(392583,10906,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(392584,10906,'tr','Kira belgeleri',0),(392585,10906,'pl','DokumentÃ³w umowy najmu',0),(392586,10906,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(392587,10906,'ur','Ù„ÛŒØ² Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(392588,10906,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾ Ð·Ð°ÐºÑƒÐ¿Ñƒ',0),(392589,10906,'vi','chá»©ng tá»« thuÃª',0),(392590,10906,'af','Huurkontrak Dokumente',0),(392591,10906,'ro','Leasing documente',0),(392592,10906,'et','ÃœÃ¼rilepingu dokumendid',0),(392593,10906,'si','Zakup dokumentov',0),(392594,10906,'ba','Dokumen-dokumen sewa',0),(392595,10906,'nl','Lease documenten',0),(392596,10906,'fi','Vuokrasopimuksen asiakirjat',0),(392597,10906,'no','Leieavtalen dokumenter',0),(392598,10906,'da','Lease dokumenter',0),(392599,10906,'ko','ìž„ëŒ€ ë¬¸ì„œ',0),(392600,10906,'he','×ž×¡×ž×›×™ ×©×›×™×¨×•×ª',0),(392601,10906,'el','ÎˆÎ³Î³ÏÎ±Ï†Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(392602,10906,'zh','ç§Ÿèµæ–‡ä»¶\r\n',0),(392603,10906,'sv','Hyresavtal dokument',0),(392604,10906,'it','Contratto di locazione documenti',0),(392605,10906,'tl','',0),(392606,10906,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(392607,10906,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚',0),(392608,10906,'ms','Dokumen-dokumen pajakan',0),(392609,10906,'ar','ÙˆØ«Ø§Ø¦Ù‚ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(392610,10906,'fr','Documents de location',0),(392611,10906,'jp','ãƒªãƒ¼ã‚¹æ–‡æ›¸',0),(392612,10906,'pt','Documentos locaÃ§Ã£o',0),(392613,10906,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹ Ð´Ð»Ñ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(392614,10906,'es','Documentos de Arrendamiento',0),(392615,10906,'de','Leasing-Dokumente',0),(392616,10906,'en','Lease Documents',0),(392617,10907,'is','',0),(392618,10907,'dr','Ø§Ù…Ø¶Ø§ Ø§ÙŠÙ…ÙŠÙ„ ',0),(392619,10907,'pr','Ø§Ù…Ø¶Ø§ Ø§ÙŠÙ…ÙŠÙ„ ',0),(392620,10907,'tr','E-imza',0),(392621,10907,'pl','E-podpisu',0),(392622,10907,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð¿Ð¾Ð´Ð¿Ð¸Ñ',0),(392623,10907,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø¯Ø³ØªØ®Ø·',0),(392624,10907,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸Ñ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(392625,10907,'vi','Email Signature',0),(392626,10907,'af','E-pos Handtekening',0),(392627,10907,'ro','PoÅŸtÄƒ electronicÄƒ semnÄƒturÄƒ',0),(392628,10907,'et','E-posti allkiri',0),(392629,10907,'si','E-poÅ¡tni podpis',0),(392630,10907,'ba','Email Signature',0),(392631,10907,'nl','E-mailhandtekening',0),(392632,10907,'fi','SÃ¤hkÃ¶postin allekirjoitus',0),(392633,10907,'no','E-signatur',0),(392634,10907,'da','E-mail-signatur',0),(392635,10907,'ko','ì´ë©”ì¼ ì„œëª…',0),(392636,10907,'he','×‘×—×ª×™×ž×ª ×”×“×•××¨ ×”××œ×§×˜×¨×•× ×™',0),(392637,10907,'el','Î¥Ï€Î¿Î³ÏÎ±Ï†Î® Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(392638,10907,'zh','ç”µå­é‚®ä»¶ç­¾å\r\n',0),(392639,10907,'sv','E-underskrift',0),(392640,10907,'it','Firma e-mail',0),(392641,10907,'tl','',0),(392642,10907,'th','à¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™à¸­à¸µà¹€à¸¡à¸¥',0),(392643,10907,'hi','à¤ˆà¤®à¥‡à¤² à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°',0),(392644,10907,'ms','Tandatangan e-mel',0),(392645,10907,'ar','ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(392646,10907,'fr','Signature d\'email',0),(392647,10907,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«ã®ç½²å',0),(392648,10907,'pt','Assinatura de e-mail',0),(392649,10907,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÑŒ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(392650,10907,'es','Firma de Email',0),(392651,10907,'de','E-Mail-Signatur',0),(392652,10907,'en','Email Signature',0),(392653,10908,'is','',0),(392654,10908,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØ¹Ù…ÙŠØ± Ùˆ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ ',0),(392655,10908,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØ¹Ù…ÙŠØ± Ùˆ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ ',0),(392656,10908,'tr','BakÄ±m istek Ekle',0),(392657,10908,'pl','Dodawanie obsÅ‚ugi Å¼Ä…dania',0),(392658,10908,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð·Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(392659,10908,'ur','Ø¨Ø­Ø§Ù„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(392660,10908,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ',0),(392661,10908,'vi','ThÃªm yÃªu cáº§u báº£o trÃ¬',0),(392662,10908,'af','Voeg onderhoud versoek',0),(392663,10908,'ro','Adauga cerere de Ã®ntreÅ£inere',0),(392664,10908,'et','Lisa sÃ¤ilitamise soov',0),(392665,10908,'si','Dodaj vzdrÅ¾evanje zahtevo',0),(392666,10908,'ba','Tambahkan pemeliharaan permintaan',0),(392667,10908,'nl','Onderhoud verzoek toevoegen',0),(392668,10908,'fi','Huolto lisÃ¤Ã¤mispyyntÃ¶',0),(392669,10908,'no','Legge til vedlikehold forespÃ¸rsel',0),(392670,10908,'da','TilfÃ¸j vedligeholdelse anmodning',0),(392671,10908,'ko','ìœ ì§€ ë³´ìˆ˜ ìš”ì²­ ì¶”ê°€',0),(392672,10908,'he','×”×•×¡×£ ×“×¨×™×©×ª ×ª×—×–×•×§×”',0),(392673,10908,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ· Î±Î¯Ï„Î·ÏƒÎ·',0),(392674,10908,'zh','å¢žåŠ ç»´æŠ¤è¦æ±‚\r\n',0),(392675,10908,'sv','LÃ¤gg till underhÃ¥ll begÃ¤ran',0),(392676,10908,'it','Aggiungere la richiesta di manutenzione',0),(392677,10908,'tl','',0),(392678,10908,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸³à¸‚à¸­à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²',0),(392679,10908,'hi','à¤°à¤–à¤°à¤–à¤¾à¤µ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(392680,10908,'ms','Menambah permintaan penyenggaraan',0),(392681,10908,'ar','Ø¥Ø¶Ø§ÙØ© Ø·Ù„Ø¨ ØµÙŠØ§Ù†Ø©',0),(392682,10908,'fr','Ajouter demande d\'entretien',0),(392683,10908,'jp','è¿½åŠ ã™ã‚‹ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹è¦æ±‚',0),(392684,10908,'pt','Adicionar solicitaÃ§Ã£o de manutenÃ§Ã£o',0),(392685,10908,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(392686,10908,'es','Agregar Solicitud de Mantenimiento',0),(392687,10908,'de','Instandhaltung Anforderung hinzufÃ¼gen',0),(392688,10908,'en','Add Maintenance Request',0),(392689,10909,'is','',0),(392690,10909,'dr','(Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù†',0),(392691,10909,'pr','Ù‚Ø§Ø¨Ù„ÙŠØª Ø§Ø³ØªÙØ§Ø¯Ù‡ (Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù†',0),(392692,10909,'tr','KullanÄ±labilirliÄŸi',0),(392693,10909,'pl','DostÄ™pnoÅ›Ä‡',0),(392694,10909,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚',0),(392695,10909,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ÛŒ',0),(392696,10909,'sr','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¾ÑÑ‚',0),(392697,10909,'vi','CÃ³ sáºµn',0),(392698,10909,'af','Beskikbaarheid',0),(392699,10909,'ro','Disponibilitatea',0),(392700,10909,'et','KÃ¤ttesaadavus',0),(392701,10909,'si','RazpoloÅ¾ljivost',0),(392702,10909,'ba','Ketersediaan',0),(392703,10909,'nl','Beschikbaarheid',0),(392704,10909,'fi','Saatavuus',0),(392705,10909,'no','Tilgjengelighet',0),(392706,10909,'da','TilgÃ¦ngelighed',0),(392707,10909,'ko','ê°€ìš©ì„±',0),(392708,10909,'he','×–×ž×™× ×•×ª',0),(392709,10909,'el','Î”Î¹Î±Î¸ÎµÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î±',0),(392710,10909,'zh','å¯ç”¨æ€§\r\n',0),(392711,10909,'sv','TillgÃ¤nglighet',0),(392712,10909,'it','DisponibilitÃ ',0),(392713,10909,'tl','',0),(392714,10909,'th','à¸„à¸§à¸²à¸¡à¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(392715,10909,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§à¤¤à¤¾',0),(392716,10909,'ms','Ketersediaan',0),(392717,10909,'ar','ØªÙˆØ§ÙØ±',0),(392718,10909,'fr','DisponibilitÃ©',0),(392719,10909,'jp','å¯ç”¨æ€§',0),(392720,10909,'pt','Disponibilidade',0),(392721,10909,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ÑÑ‚ÑŒ',0),(392722,10909,'es','Disponibilidad',0),(392723,10909,'de','VerfÃ¼gbarkeit',0),(392724,10909,'en','Availability',0),(392725,10910,'is','',0),(392726,10910,'dr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª ØªØ¹Ù…ÙŠØ± Ùˆ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ø¬Ø§Ø±ÙŠ',0),(392727,10910,'pr','Ú¯Ø²Ø§Ø±Ø´Ø§Øª ØªØ¹Ù…ÙŠØ± Ùˆ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ø¬Ø§Ø±ÙŠ',0),(392728,10910,'tr','GeÃ§erli bakÄ±m istekleri',0),(392729,10910,'pl','BieÅ¼Ä…cej obsÅ‚ugi Å¼Ä…daÅ„',0),(392730,10910,'bg','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð¸ÑÐºÐ°Ð½Ð¸Ñ',0),(392731,10910,'ur','Ø­Ø§Ù„ÛŒÛ Ø¯ÛŒÚ©Ú¾ Ø¨Ú¾Ø§Ù„ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(392732,10910,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð¿Ð¾Ð·Ð¸Ð²Ðµ Ð·Ð° Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ',0),(392733,10910,'vi','Ä‘á» nghá»‹ báº£o dÆ°á»¡ng hiá»‡n nay',0),(392734,10910,'af','Huidige onderhoud versoeke',0),(392735,10910,'ro','Curent intretinere cereri',0),(392736,10910,'et','Jooksva hoolduse taotlused',0),(392737,10910,'si','Trenutne zahteve za vzdrÅ¾evanje',0),(392738,10910,'ba','Saat ini permintaan pemeliharaan',0),(392739,10910,'nl','Huidige onderhoud aanvragen',0),(392740,10910,'fi','Nykyiset huolto pyynnÃ¶t',0),(392741,10910,'no','Gjeldende vedlikehold forespÃ¸rsler',0),(392742,10910,'da','NuvÃ¦rende vedligeholdelse anmodninger',0),(392743,10910,'ko','í˜„ìž¬ ìœ ì§€ ë³´ìˆ˜ ìš”ì²­',0),(392744,10910,'he','×‘×§×©×•×ª ×”×ª×—×–×•×§×” ×”× ×•×›×—×™',0),(392745,10910,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎµÏ‚ Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ·Ï‚',0),(392746,10910,'zh','å½“å‰ç»´æŠ¤è¦æ±‚\r\n',0),(392747,10910,'sv','Aktuella underhÃ¥ll begÃ¤randen',0),(392748,10910,'it','Richieste di manutenzione corrente',0),(392749,10910,'tl','',0),(392750,10910,'th','à¸„à¸³à¸‚à¸­à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(392751,10910,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤°à¤–à¤°à¤–à¤¾à¤µ à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚',0),(392752,10910,'ms','Semasa penyelenggaraan permintaan',0),(392753,10910,'ar','Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØµÙŠØ§Ù†Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(392754,10910,'fr','Demandes de Maintenance actuel',0),(392755,10910,'jp','ç¾åœ¨ã®ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹ ãƒªã‚¯ã‚¨ã‚¹ãƒˆ',0),(392756,10910,'pt','SolicitaÃ§Ãµes de manutenÃ§Ã£o atual',0),(392757,10910,'ru','Ð¢ÐµÐºÑƒÑ‰ÐµÐµ Ñ‚ÐµÑ…Ð½Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð²',0),(392758,10910,'es','Solicitaciones de Mantenimiento Actuales',0),(392759,10910,'de','Aktuelle Pflege-Anforderungen',0),(392760,10910,'en','Current Maintenance Requests',0),(392761,10911,'is','',0),(392762,10911,'dr','ØªØ¹ÙŠÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(392763,10911,'pr','ØªØ¹ÙŠÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(392764,10911,'tr','Tarihi saptamak',0),(392765,10911,'pl','UstaliÄ‡ datÄ™',0),(392766,10911,'bg','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÑÑ‚ Ð´Ð°Ñ‚Ð°',0),(392767,10911,'ur','ØªØ§Ø±ÛŒØ® Ø¯Ø±Ø³Øª Ú©Ø±ÛŒÚº',0),(392768,10911,'sr','ÐŸÐ¾Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(392769,10911,'vi','ngÃ y cá»‘ Ä‘á»‹nh',0),(392770,10911,'af','Datum reg',0),(392771,10911,'ro','StabileascÄƒ data',0),(392772,10911,'et','Kindlaks kuupÃ¤evaks',0),(392773,10911,'si','DoloÄijo datum',0),(392774,10911,'ba','Memperbaiki tanggal',0),(392775,10911,'nl','Verschijningsdatum vaststellen',0),(392776,10911,'fi','Vahvistaa pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n',0),(392777,10911,'no','Fastsette dato',0),(392778,10911,'da','FastsÃ¦tte dato',0),(392779,10911,'ko','ë‚ ì§œ ìˆ˜ì •',0),(392780,10911,'he','×œ×ª×§×Ÿ ××ª ×”×ª××¨×™×š',0),(392781,10911,'el','ÎšÎ±Î¸Î¿ÏÎ¯ÏƒÎµÎ¹ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(392782,10911,'zh','ä¿®æ­£æ—¥æœŸ\r\n',0),(392783,10911,'sv','FaststÃ¤lla datum',0),(392784,10911,'it','DifficoltÃ  data',0),(392785,10911,'tl','',0),(392786,10911,'th','à¹à¸à¹‰à¹„à¸‚à¸§à¸±à¸™',0),(392787,10911,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤ à¥€à¤• à¤•à¤°à¥‡à¤‚',0),(392788,10911,'ms','Menetapkan tarikh',0),(392789,10911,'ar','ØªØ­Ø¯ÙŠØ¯ Ù…ÙˆØ¹Ø¯',0),(392790,10911,'fr','DifficultÃ© Date',0),(392791,10911,'jp','æ—¥ä»˜ã‚’ä¿®æ­£ã—ã¾ã™ã€‚',0),(392792,10911,'pt','Fixar a data',0),(392793,10911,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð´Ð°Ñ‚Ñƒ',0),(392794,10911,'es','Fijar Fecha',0),(392795,10911,'de','Verlegenheit Datum',0),(392796,10911,'en','Fix Date',0),(392797,10912,'is','',0),(392798,10912,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ ',0),(392799,10912,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ ',0),(392800,10912,'tr','BakÄ±m istek',0),(392801,10912,'pl','Å»Ä…dania obsÅ‚ugi',0),(392802,10912,'bg','Ð—Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(392803,10912,'ur','Ø¨Ø­Ø§Ù„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(392804,10912,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ',0),(392805,10912,'vi','Äá» nghá»‹ báº£o dÆ°á»¡ng',0),(392806,10912,'af','Onderhoud versoek',0),(392807,10912,'ro','Cerere de Ã®ntreÅ£inere',0),(392808,10912,'et','Hooldus taotlus',0),(392809,10912,'si','VzdrÅ¾evanje zahtevo',0),(392810,10912,'ba','Pemeliharaan permintaan',0),(392811,10912,'nl','Onderhoud verzoek',0),(392812,10912,'fi','Huolto pyyntÃ¶',0),(392813,10912,'no','Vedlikehold forespÃ¸rsel',0),(392814,10912,'da','Vedligeholdelse anmodning',0),(392815,10912,'ko','ìœ ì§€ ë³´ìˆ˜ ìš”ì²­',0),(392816,10912,'he','×‘×§×©×” ×ª×—×–×•×§×”',0),(392817,10912,'el','Î£Ï…Î½Ï„Î®ÏÎ·ÏƒÎ· Î±Î¯Ï„Î·ÏƒÎ·',0),(392818,10912,'zh','ç»´æŠ¤è¦æ±‚\r\n',0),(392819,10912,'sv','UnderhÃ¥ll begÃ¤ran',0),(392820,10912,'it','Richiesta di manutenzione',0),(392821,10912,'tl','',0),(392822,10912,'th','à¸„à¸³à¸‚à¸­à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²',0),(392823,10912,'hi','à¤°à¤–à¤°à¤–à¤¾à¤µ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(392824,10912,'ms','Permintaan penyenggaraan',0),(392825,10912,'ar','Ø·Ù„Ø¨ ØµÙŠØ§Ù†Ø©',0),(392826,10912,'fr','Demande d\'entretien',0),(392827,10912,'jp','ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹è¦æ±‚',0),(392828,10912,'pt','Pedido de manutenÃ§Ã£o',0),(392829,10912,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(392830,10912,'es','Solicitud de Mantenimiento',0),(392831,10912,'de','Wartung-Anfrage',0),(392832,10912,'en','Maintenance Request',0),(392833,10913,'is','',0),(392834,10913,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(392835,10913,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(392836,10913,'tr','BakÄ±m istek baÅŸarÄ±yla eklendi',0),(392837,10913,'pl','ObsÅ‚ugi Å¼Ä…dania dodane pomyÅ›lnie',0),(392838,10913,'bg','Ð—Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(392839,10913,'ur','Ø¨Ø­Ø§Ù„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(392840,10913,'sr','ÐžÐ´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(392841,10913,'vi','Ä‘Ã£ thÃªm Ä‘á» nghá»‹ báº£o dÆ°á»¡ng thÃ nh cÃ´ng',0),(392842,10913,'af','Instandhoudingsversoek Suksesvol Bygevoeg',0),(392843,10913,'ro','Cerere de Ã®ntreÅ£inere adÄƒugat cu succes',0),(392844,10913,'et','Hooldus taotlusele lisatud',0),(392845,10913,'si','VzdrÅ¾evanje zahteva uspeÅ¡no dodani',0),(392846,10913,'ba','Pemeliharaan permintaan ditambahkan berhasil',0),(392847,10913,'nl','Onderhoud verzoek toegevoegd',0),(392848,10913,'fi','YllÃ¤pito pyytÃ¤Ã¤ lisÃ¤Ã¤minen onnistui',0),(392849,10913,'no','Vedlikehold forespÃ¸rsel lagt',0),(392850,10913,'da','Vedligeholdelse anmodning tilfÃ¸jet',0),(392851,10913,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ìœ ì§€ ë³´ìˆ˜ ìš”ì²­',0),(392852,10913,'he','×‘×§×©×” ×ª×—×–×•×§×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(392853,10913,'el','Î£Ï…Î½Ï„Î®ÏÎ·ÏƒÎ· Î±Î¯Ï„Î·Î¼Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(392854,10913,'zh','ç»´æŠ¤è¦æ±‚æ·»åŠ æˆåŠŸ\r\n',0),(392855,10913,'sv','UnderhÃ¥ll begÃ¤ran lagts',0),(392856,10913,'it','Richiesta di manutenzione aggiunto con successo',0),(392857,10913,'tl','',0),(392858,10913,'th','à¸„à¸³à¸‚à¸­à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(392859,10913,'hi','à¤°à¤–à¤°à¤–à¤¾à¤µ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(392860,10913,'ms','Permintaan penyenggaraan yang berjaya menambah',0),(392861,10913,'ar','Ø§Ù„ØµÙŠØ§Ù†Ø© Ø·Ù„Ø¨ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(392862,10913,'fr','Demande d\'entretien ajoutÃ© avec succÃ¨s',0),(392863,10913,'jp','ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹ã®è¦æ±‚ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(392864,10913,'pt','SolicitaÃ§Ã£o de manutenÃ§Ã£o adicionada com sucesso',0),(392865,10913,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(392866,10913,'es','Solicitud de Mantenimiento Agegado Exitosamente',0),(392867,10913,'de','Wartung-Anforderung erfolgreich hinzugefÃ¼gt',0),(392868,10913,'en','Maintenance Request Added Successfully',0),(392869,10914,'is','',0),(392870,10914,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(392871,10914,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(392872,10914,'tr','BakÄ±m istek baÅŸarÄ±yla silindi',0),(392873,10914,'pl','Å»Ä…danie obsÅ‚ugi przesâ”‚anie',0),(392874,10914,'bg','Ð—Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(392875,10914,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©ÛŒ Ø¨Ø­Ø§Ù„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(392876,10914,'sr','ÐžÐ´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(392877,10914,'vi','Ä‘Ã£ xÃ³a Ä‘á» nghá»‹ báº£o dÆ°á»¡ng thÃ nh cÃ´ng',0),(392878,10914,'af','Instandhoudingsversoek Suksesvol Geskrap',0),(392879,10914,'ro','Cerere de Ã®ntreÅ£inere eliminÄƒ cu succes',0),(392880,10914,'et','Hoolduse korral edukalt kustutatud',0),(392881,10914,'si','VzdrÅ¾evanje zahteva uspeÅ¡no izbrisana',0),(392882,10914,'ba','Pemeliharaan permintaan dihapus berhasil',0),(392883,10914,'nl','Onderhoud verzoek succesvol verwijderd',0),(392884,10914,'fi','Huolto pyynnÃ¶stÃ¤ poistettu',0),(392885,10914,'no','Vedlikehold forespÃ¸rsel slettet',0),(392886,10914,'da','Vedligeholdelse anmodning slettet',0),(392887,10914,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ìœ ì§€ ë³´ìˆ˜ ìš”ì²­',0),(392888,10914,'he','×‘×§×©×” ×ª×—×–×•×§×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(392889,10914,'el','Î£Ï…Î½Ï„Î®ÏÎ·ÏƒÎ· Î±Î¯Ï„Î·ÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(392890,10914,'zh','ç»´æŠ¤è¦æ±‚åˆ é™¤æˆåŠŸ\r\n',0),(392891,10914,'sv','UnderhÃ¥ll begÃ¤ran raderades',0),(392892,10914,'it','Richiesta di manutenzione eliminato con successo',0),(392893,10914,'tl','',0),(392894,10914,'th','à¸„à¸³à¸‚à¸­à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(392895,10914,'hi','à¤°à¤–à¤°à¤–à¤¾à¤µ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(392896,10914,'ms','Penyelenggaraan permintaan dihapuskan dengan jayanya',0),(392897,10914,'ar','Ø§Ù„ØµÙŠØ§Ù†Ø© Ø·Ù„Ø¨ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(392898,10914,'fr','Demande d\'entretien supprimÃ© avec succÃ¨s',0),(392899,10914,'jp','ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹ã®è¦æ±‚ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(392900,10914,'pt','SolicitaÃ§Ã£o de manutenÃ§Ã£o apagada com sucesso',0),(392901,10914,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(392902,10914,'es','Solicitud de Mantenimiento Eliminado Exitosamente',0),(392903,10914,'de','Wartung-Anforderung erfolgreich gelÃ¶scht',0),(392904,10914,'en','Maintenance Request Deleted Successfully',0),(392905,10915,'is','',0),(392906,10915,'dr','Ù‡ÙŠÚ† Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(392907,10915,'pr','Ù‡ÙŠÚ† Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(392908,10915,'tr','HiÃ§bir bakÄ±m istekleri bulundu',0),(392909,10915,'pl','Å»adne Å¼Ä…dania obsÅ‚ugi znalazÅ‚em',0),(392910,10915,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð¼Ð¾Ð»Ð±Ð¸ Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(392911,10915,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ø¯ÛŒÚ©Ú¾ Ø¨Ú¾Ø§Ù„ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(392912,10915,'sr','ÐÐµÐ¼Ð° Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐ° Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ Ð½Ð°ÑˆÐ»Ð¸',0),(392913,10915,'vi','khÃ´ng tÃ¬m tháº¥y Ä‘á» nghá»‹ báº£o hÃ nh',0),(392914,10915,'af','Geen onderhoud versoeke gevind',0),(392915,10915,'ro','Nici o Ã®ntreÅ£inere cereri gÄƒsit',0),(392916,10915,'et','Mitte hooldus taotlusi leitud',0),(392917,10915,'si','Zahteve ne vzdrÅ¾evanja, najti',0),(392918,10915,'ba','Tidak ada permintaan pemeliharaan yang ditemukan',0),(392919,10915,'nl','Geen onderhoud aanvragen dat is gevonden',0),(392920,10915,'fi','Huolto-pyyntÃ¶jÃ¤ ei lÃ¶ytynyt',0),(392921,10915,'no','Ingen vedlikehold forespÃ¸rsler funnet',0),(392922,10915,'da','Ingen vedligeholdelse anmodninger fundet',0),(392923,10915,'ko','ë°œê²¬ ì—†ìŒ ìœ ì§€ ë³´ìˆ˜ ìš”ì²­',0),(392924,10915,'he','××™×Ÿ ×‘×§×©×•×ª ×ª×—×–×•×§×” ×ž×¦××•',0),(392925,10915,'el','ÎšÎ±Î¼Î¯Î± ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ· Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(392926,10915,'zh','æ²¡æœ‰æ‰¾åˆ°ç»´ä¿®è¯·æ±‚\r\n',0),(392927,10915,'sv','Inget underhÃ¥ll begÃ¤randen som hittats',0),(392928,10915,'it','Nessuna richiesta di manutenzione trovata',0),(392929,10915,'tl','',0),(392930,10915,'th','à¸„à¸³à¸‚à¸­à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²à¹„à¸¡à¹ˆà¸žà¸š',0),(392931,10915,'hi','à¤•à¥‹à¤ˆ à¤°à¤–à¤°à¤–à¤¾à¤µ à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(392932,10915,'ms','Tiada permohonan penyelenggaraan yang ditemui',0),(392933,10915,'ar','Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØµÙŠØ§Ù†Ø© Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(392934,10915,'fr','Aucune demande d\'entretien trouvÃ©',0),(392935,10915,'jp','è¦‹ã¤ã‹ã£ãŸãªã„ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹è¦æ±‚',0),(392936,10915,'pt','NÃ£o hÃ¡ solicitaÃ§Ãµes de manutenÃ§Ã£o encontradas',0),(392937,10915,'ru','Ð—Ð°Ð¿Ñ€Ð¾ÑÑ‹ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ, Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(392938,10915,'es','Ningunos Solicitudes de Mantenimiento se Encontraron',0),(392939,10915,'de','Keine Wartung Anforderungen gefunden',0),(392940,10915,'en','No Maintenance Requests Found',0),(392941,10916,'is','',0),(392942,10916,'dr','Ù„Ø·ÙØ§ Ù…Ø´ÙƒÙ„ Ø±Ø§  Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯',0),(392943,10916,'pr','Ù„Ø·ÙØ§ Ù…Ø´ÙƒÙ„ Ø±Ø§  Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯',0),(392944,10916,'tr','LÃ¼tfen sorun iÃ§erir',0),(392945,10916,'pl','ProszÄ™ podaÄ‡ Problem',0),(392946,10916,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼',0),(392947,10916,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù…Ø³Ø¦Ù„Û Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(392948,10916,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐŸÑ€Ð¾Ð±Ð»ÐµÐ¼',0),(392949,10916,'vi','vui lÃ²ng bao gá»“m váº¥n Ä‘á»',0),(392950,10916,'af','Sluit asseblief Probleem in',0),(392951,10916,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i problemÄƒ',0),(392952,10916,'et','Palun lisage probleem',0),(392953,10916,'si','Prosimo, da vkljuÄite Problem',0),(392954,10916,'ba','Harap sertakan masalah',0),(392955,10916,'nl','Gelieve te omvatten probleem',0),(392956,10916,'fi','Ilmoita ongelma',0),(392957,10916,'no','Ta Problem',0),(392958,10916,'da','VedlÃ¦g Problem',0),(392959,10916,'ko','ë¬¸ì œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(392960,10916,'he','×× × ×›×œ×•×œ ×‘×¢×™×”',0),(392961,10916,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ Ï€ÏÏŒÎ²Î»Î·Î¼Î±',0),(392962,10916,'zh','è¯·åˆ—å…¥é—®é¢˜\r\n',0),(392963,10916,'sv','VÃ¤nligen inkludera Problem',0),(392964,10916,'it','Si prega di includere problema',0),(392965,10916,'tl','',0),(392966,10916,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸§à¸¡à¸›à¸±à¸à¸«à¸²',0),(392967,10916,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¤®à¤¸à¥à¤¯à¤¾ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(392968,10916,'ms','Sila sertakan masalah',0),(392969,10916,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ù„Ù…Ø´ÙƒÙ„Ø©',0),(392970,10916,'fr','Veuillez indiquer le problÃ¨me',0),(392971,10916,'jp','ãã ã•ã„å•é¡ŒãŒã‚ã‚Šã¾ã™ã€‚',0),(392972,10916,'pt','Por favor inclua o problema',0),(392973,10916,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ñƒ',0),(392974,10916,'es','Por Favor Incluye Problema',0),(392975,10916,'de','Bitte geben Sie Problem',0),(392976,10916,'en','Please Include Problem',0),(392977,10917,'is','',0),(392978,10917,'dr','Ù…Ø´ÙƒÙ„ ',0),(392979,10917,'pr','Ù…Ø´ÙƒÙ„ ',0),(392980,10917,'tr','Sorun',0),(392981,10917,'pl','Problem',0),(392982,10917,'bg','ÐŸÑ€Ð¾Ð±Ð»ÐµÐ¼',0),(392983,10917,'ur','Ù…Ø³Ø¦Ù„Û',0),(392984,10917,'sr','ÐŸÑ€Ð¾Ð±Ð»ÐµÐ¼',0),(392985,10917,'vi','váº¥n Ä‘á»',0),(392986,10917,'af','Probleem',0),(392987,10917,'ro','Problema',0),(392988,10917,'et','Probleem',0),(392989,10917,'si','Problem',0),(392990,10917,'ba','Masalah',0),(392991,10917,'nl','Probleem',0),(392992,10917,'fi','Ongelma',0),(392993,10917,'no','Problem',0),(392994,10917,'da','Problem',0),(392995,10917,'ko','ë¬¸ì œ',0),(392996,10917,'he','×”×‘×¢×™×”',0),(392997,10917,'el','Î ÏÏŒÎ²Î»Î·Î¼Î±',0),(392998,10917,'zh','é—®é¢˜\r\n',0),(392999,10917,'sv','Problem',0),(393000,10917,'it','Problema',0),(393001,10917,'tl','',0),(393002,10917,'th','à¸›à¸±à¸à¸«à¸²',0),(393003,10917,'hi','à¤¸à¤®à¤¸à¥à¤¯à¤¾',0),(393004,10917,'ms','Masalah',0),(393005,10917,'ar','Ø§Ù„Ù…Ø´ÙƒÙ„Ø©',0),(393006,10917,'fr','ProblÃ¨me',0),(393007,10917,'jp','å•é¡Œ',0),(393008,10917,'pt','Problema',0),(393009,10917,'ru','ÐŸÑ€Ð¾Ð±Ð»ÐµÐ¼Ð°',0),(393010,10917,'es','Problema',0),(393011,10917,'de','Problem',0),(393012,10917,'en','Problem',0),(393013,10918,'is','',0),(393014,10918,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ùˆ ØªØ¹Ù…ÙŠØ±',0),(393015,10918,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ùˆ ØªØ¹Ù…ÙŠØ±',0),(393016,10918,'tr','BakÄ±m yardÄ±m istemek',0),(393017,10918,'pl','PoprosiÄ‡ o pomoc konserwacji',0),(393018,10918,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(393019,10918,'ur','Ø¨Ø­Ø§Ù„ÛŒ Ù…Ø¯Ø¯ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(393020,10918,'sr','Ð—Ð°Ñ‚Ñ€Ð°Ð¶Ð¸Ñ‚Ðµ Ð¿Ð¾Ð¼Ð¾Ñ› Ð·Ð° Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ',0),(393021,10918,'vi','Ä‘á» nghá»‹ giÃºp báº£o dÆ°á»¡ng',0),(393022,10918,'af','Versoek Hulp met Instandhouding',0),(393023,10918,'ro','Solicita ajutor de Ã®ntreÅ£inere',0),(393024,10918,'et','Hooldus abi palumine',0),(393025,10918,'si','Zahteva vzdrÅ¾evanje pomoÄ',0),(393026,10918,'ba','Meminta bantuan pemeliharaan',0),(393027,10918,'nl','Onderhoud hulp vragen',0),(393028,10918,'fi','PyytÃ¤Ã¤ huolto ohje',0),(393029,10918,'no','Be om vedlikehold hjelp',0),(393030,10918,'da','Anmode om hjÃ¦lp til vedligeholdelse',0),(393031,10918,'ko','ìœ ì§€ ê´€ë¦¬ ë„ì›€ë§ ìš”ì²­',0),(393032,10918,'he','×‘×§×©×ª ×¢×–×¨×” ×ª×—×–×•×§×”',0),(393033,10918,'el','Î–Î·Ï„Î®ÏƒÎµÏ„Îµ Î²Î¿Î®Î¸ÎµÎ¹Î± ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ·Ï‚',0),(393034,10918,'zh','è¯·æ±‚ç»´æŠ¤æ–¹é¢çš„å¸®åŠ©\r\n',0),(393035,10918,'sv','BegÃ¤r underhÃ¥ll hjÃ¤lp',0),(393036,10918,'it','Richiesta di aiuto per manutenzione',0),(393037,10918,'tl','',0),(393038,10918,'th','à¸‚à¸­à¸„à¸§à¸²à¸¡à¸Šà¹ˆà¸§à¸¢à¹€à¸«à¸¥à¸·à¸­à¹ƒà¸™à¸à¸²à¸£à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²',0),(393039,10918,'hi','à¤°à¤–à¤°à¤–à¤¾à¤µ à¤•à¥€ à¤®à¤¦à¤¦ à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(393040,10918,'ms','Meminta bantuan penyelenggaraan',0),(393041,10918,'ar','Ø·Ù„Ø¨ Ù…Ø³Ø§Ø¹Ø¯Ø© ØµÙŠØ§Ù†Ø©',0),(393042,10918,'fr','Demander l\'aide de la Maintenance',0),(393043,10918,'jp','ä¿å®ˆã®ãƒ˜ãƒ«ãƒ—ã‚’è¦æ±‚ã—ã¾ã™ã€‚',0),(393044,10918,'pt','Solicitar ajuda de manutenÃ§Ã£o',0),(393045,10918,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸',0),(393046,10918,'es','Peticionar Ayuda de Mantenimiento',0),(393047,10918,'de','Wartung Hilfe anfordern',0),(393048,10918,'en','Request Maintenance Help',0),(393049,10919,'is','',0),(393050,10919,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ùˆ ØªØ¹Ù…ÙŠØ±',0),(393051,10919,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ùˆ ØªØ¹Ù…ÙŠØ±',0),(393052,10919,'tr','BakÄ±m yardÄ±m talimatlarÄ± isteÄŸi',0),(393053,10919,'pl','Uzyskaj pomoc instrukcje konserwacji',0),(393054,10919,'bg','Ð˜ÑÐºÐ°Ð½Ðµ Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(393055,10919,'ur','Ø¨Ø­Ø§Ù„ÛŒ Ù…Ø¯Ø¯ ÛØ¯Ø§ÛŒØ§Øª Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø±ÛŒÚº',0),(393056,10919,'sr','Ð—Ð°Ñ‚Ñ€Ð°Ð¶Ð¸Ñ‚Ðµ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸ Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐ°',0),(393057,10919,'vi','Ä‘á» nghá»‹ hÆ°á»›ng dáº«n giÃºp bá»a dÆ°á»¡ng',0),(393058,10919,'af','Versoek Instruksies omtrent Hulp met Instandhouding',0),(393059,10919,'ro','Solicita instrucÅ£iuni de ajutor de Ã®ntreÅ£inere',0),(393060,10919,'et','Taotleda abi hooldusjuhendid',0),(393061,10919,'si','Zahteva pomoÄ navodila za vzdrÅ¾evanje',0),(393062,10919,'ba','Meminta petunjuk bantuan pemeliharaan',0),(393063,10919,'nl','Verzoek hulp onderhoudsinstructies',0),(393064,10919,'fi','PyytÃ¤Ã¤ huolto auttaa ohjeet',0),(393065,10919,'no','Be om hjelp bruksanvisning',0),(393066,10919,'da','Anmode om hjÃ¦lp vedligeholdelsesvejledning',0),(393067,10919,'ko','ìœ ì§€ ê´€ë¦¬ ë„ì›€ë§ ì§€ì‹œ ìš”ì²­',0),(393068,10919,'he','×‘×§×©×ª ×¢×–×¨×” ×”×•×¨××•×ª ××—×–×§×”',0),(393069,10919,'el','Î–Î·Ï„Î®ÏƒÎµÏ„Îµ Î²Î¿Î®Î¸ÎµÎ¹Î± Î¿Î´Î·Î³Î¯ÎµÏ‚ ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ·Ï‚',0),(393070,10919,'zh','è¯·æ±‚ç»´æŠ¤æ–¹é¢çš„å¸®åŠ©è¯´æ˜Ž\r\n',0),(393071,10919,'sv','BegÃ¤ra hjÃ¤lp underhÃ¥llsinstruktioner',0),(393072,10919,'it','Richiedere aiuto istruzioni di manutenzione',0),(393073,10919,'tl','',0),(393074,10919,'th','à¸‚à¸­à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¸à¸²à¸£à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²',0),(393075,10919,'hi','à¤°à¤–à¤°à¤–à¤¾à¤µ à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(393076,10919,'ms','Permintaan arahan bantuan penyelenggaraan',0),(393077,10919,'ar','Ø·Ù„Ø¨ ØµÙŠØ§Ù†Ø© Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(393078,10919,'fr','Demander l\'aide d\'entretien',0),(393079,10919,'jp','ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹ã€ãƒ˜ãƒ«ãƒ—ã®èª¬æ˜Žã‚’è¦æ±‚ã—ã¾ã™ã€‚',0),(393080,10919,'pt','SolicitaÃ§Ã£o de manutenÃ§Ã£o InstruÃ§Ãµes de ajuda',0),(393081,10919,'ru','Ð—Ð°Ð¿Ñ€Ð¾ÑÐ¸Ñ‚ÑŒ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒ Ð¿Ð¾ Ñ‚ÐµÑ…Ð½Ð¸Ñ‡ÐµÑÐºÐ¾Ð¼Ñƒ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸ÑŽ',0),(393082,10919,'es','Peticionar Ayuda de Mantenimiento Instrucciones',0),(393083,10919,'de','Wartungsanleitungen Hilfe anfordern',0),(393084,10919,'en','Request Maintenance Help Instructions',0),(393085,10920,'is','',0),(393086,10920,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ùˆ ØªØ¹Ù…ÙŠØ±',0),(393087,10920,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ùˆ ØªØ¹Ù…ÙŠØ±',0),(393088,10920,'tr','BakÄ±m talimatlarÄ± isteÄŸi',0),(393089,10920,'pl','Instrukcje obsÅ‚ugi',0),(393090,10920,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ°',0),(393091,10920,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Û’ Ø¨Ø­Ø§Ù„ÛŒ Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(393092,10920,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(393093,10920,'vi','Ä‘á» nghá»‹ hÆ°á»›ng dáº«n báº£o dÆ°á»¡ng',0),(393094,10920,'af','Versoek onderhoud instruksies',0),(393095,10920,'ro','InstrucÈ›iuni de Ã®ntreÈ›inere cerere',0),(393096,10920,'et','Taotlus hooldamise juhised',0),(393097,10920,'si','Zahtevajo navodila za vzdrÅ¾evanje',0),(393098,10920,'ba','Permintaan pemeliharaan petunjuk',0),(393099,10920,'nl','Verzoek onderhoudsinstructies',0),(393100,10920,'fi','PyytÃ¤Ã¤ huolto-ohjeet',0),(393101,10920,'no','ForespÃ¸rsel bruksanvisning',0),(393102,10920,'da','Anmodning vedligeholdelsesvejledning',0),(393103,10920,'ko','ìš”ì²­ ìœ ì§€ ê´€ë¦¬ ì§€ì¹¨',0),(393104,10920,'he','×‘×§×©×ª ×”×•×¨××•×ª ××—×–×§×”',0),(393105,10920,'el','Î–Î·Ï„Î·Î¸Î¿ÏÎ½ Î¿Î´Î·Î³Î¯ÎµÏ‚ ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ·Ï‚',0),(393106,10920,'zh','è¦æ±‚ç»´ä¿®æŒ‡å—\r\n',0),(393107,10920,'sv','BegÃ¤ra instruktioner fÃ¶r underhÃ¥ll',0),(393108,10920,'it','Istruzioni di manutenzione richiesta',0),(393109,10920,'tl','',0),(393110,10920,'th','à¸‚à¸­à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸à¸²à¸£à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²',0),(393111,10920,'hi','à¤…à¤¨à¥à¤°à¥‹à¤§ à¤°à¤–à¤°à¤–à¤¾à¤µ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(393112,10920,'ms','Arahan penyelenggaraan permintaan',0),(393113,10920,'ar','Ø·Ù„Ø¨ ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„ØµÙŠØ§Ù†Ø©',0),(393114,10920,'fr','Demander des Instructions de Maintenance',0),(393115,10920,'jp','ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹æŒ‡ç¤ºã‚’è¦æ±‚ã—ã¾ã™ã€‚',0),(393116,10920,'pt','InstruÃ§Ãµes de manutenÃ§Ã£o do pedido',0),(393117,10920,'ru','Ð—Ð°Ð¿Ñ€Ð¾ÑÐ¸Ñ‚ÑŒ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð¿Ð¾ Ñ‚ÐµÑ…Ð½Ð¸Ñ‡ÐµÑÐºÐ¾Ð¼Ñƒ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸ÑŽ',0),(393118,10920,'es','Peticionar Instrucciones de Mantenimiento',0),(393119,10920,'de','Anfrage-Wartungsanleitung',0),(393120,10920,'en','Request Maintenance Instructions',0),(393121,10921,'is','',0),(393122,10921,'dr','_ Ù¾ÙŠØ´ Ø¯Ø±ÙŠØ§ÙØª',0),(393123,10921,'pr','Ø¯Ø±Ø¢Ù…Ø¯Ù‡Ø§ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ Ø¨Ù‡ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÙŠ Ø¢ØªÙŠ _ Ù¾ÙŠØ´ Ø¯Ø±ÙŠØ§ÙØª',0),(393124,10921,'tr','Ertelenmifl gelir',0),(393125,10921,'pl','Przychody przyszÅ‚ych okresÃ³w',0),(393126,10921,'bg','ÐžÑ‚Ð»Ð¾Ð¶ÐµÐ½Ð¸ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸',0),(393127,10921,'ur','Ù…Ù„ØªÙˆÛŒ Ø¢Ù…Ø¯Ù†ÛŒ',0),(393128,10921,'sr','ÐžÐ´Ð»Ð¾Ð¶ÐµÐ½Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(393129,10921,'vi','Doanh thu tráº£ cháº­m',0),(393130,10921,'af','Uitgestelde inkomste',0),(393131,10921,'ro','AmÃ¢nate venituri',0),(393132,10921,'et','Ettemakstud tulud',0),(393133,10921,'si','OdloÅ¾eni prihodki',0),(393134,10921,'ba','Ditangguhkan pendapatan',0),(393135,10921,'nl','Uitgestelde inkomsten',0),(393136,10921,'fi','Laskennalliset tulot',0),(393137,10921,'no','Utsatt inntekt',0),(393138,10921,'da','Udskudte indtÃ¦gter',0),(393139,10921,'ko','ì§€ì—° ëœ ìˆ˜ìµ',0),(393140,10921,'he','×”×”×›× ×¡×•×ª ×©× ×“×—×•',0),(393141,10921,'el','Î ÏÎ¿ÎµÎ¹ÏƒÏ€ÏÎ±Ï‡Î¸Î­Î½Ï„Î± Î­ÏƒÎ¿Î´Î±',0),(393142,10921,'zh','é€’å»¶æ”¶å…¥\r\n',0),(393143,10921,'sv','FÃ¶rutbetalda intÃ¤kter',0),(393144,10921,'it','Risconti',0),(393145,10921,'tl','',0),(393146,10921,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¸£à¸­à¸à¸²à¸£à¸•à¸±à¸”à¸šà¸±à¸à¸Šà¸µ',0),(393147,10921,'hi','à¤µà¤¿à¤²à¤‚à¤¬à¤¿à¤¤ à¤°à¤¾à¤œà¤¸à¥à¤µ',0),(393148,10921,'ms','Pendapatan tertunda',0),(393149,10921,'ar','Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø¤Ø¬Ù„Ø©',0),(393150,10921,'fr','Produits reportÃ©s',0),(393151,10921,'jp','ç¹°å»¶æ­³å…¥',0),(393152,10921,'pt','Receitas diferidas',0),(393153,10921,'ru','Ð”Ð¾Ñ…Ð¾Ð´Ñ‹ Ð±ÑƒÐ´ÑƒÑ‰Ð¸Ñ… Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¾Ð²',0),(393154,10921,'es','Renta Diferida',0),(393155,10921,'de','Rechnungsabgrenzungsposten',0),(393156,10921,'en','Deferred Revenue',0),(393157,10922,'is','',0),(393158,10922,'dr','Ú¯ÙˆØ§Ù‡ÙŠÙ†Ø§Ù…Ù‡ Ø³ÙŠØ³ØªÙ… Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(393159,10922,'pr','Ú¯ÙˆØ§Ù‡ÙŠÙ†Ø§Ù…Ù‡ Ø³ÙŠØ³ØªÙ… Ø­Ø°Ù Ø´Ø¯Ù‡ ',0),(393160,10922,'tr','Sistem belge kaldÄ±rÄ±ldÄ±',0),(393161,10922,'pl','Dokumentacja systemu usuniÄ™te',0),(393162,10922,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸',0),(393163,10922,'ur','Ù†Ø¸Ø§Ù… Ø¯Ø³ØªØ§ÙˆÛŒØ² ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(393164,10922,'sr','Ð¡Ð¸ÑÑ‚ÐµÐ¼ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ ÑƒÐºÐ»Ð¾ÑšÐµÐ½',0),(393165,10922,'vi','Há»‡ thá»‘ng tÃ i liá»‡u loáº¡i bá»',0),(393166,10922,'af','Stelsel dokument verwyder',0),(393167,10922,'ro','Sistem de Document eliminat',0),(393168,10922,'et','Eemaldatud sÃ¼steemi dokument',0),(393169,10922,'si','Sistem dokumenta odstraniti',0),(393170,10922,'ba','Sistem dokumen dihapus',0),(393171,10922,'nl','Systeem Document verwijderd',0),(393172,10922,'fi','JÃ¤rjestelmÃ¤n asiakirja poistettu',0),(393173,10922,'no','System-dokumentet fjernet',0),(393174,10922,'da','Dokumentet vedrÃ¸rende systemet fjernet',0),(393175,10922,'ko','ì‹œìŠ¤í…œ ë¬¸ì„œ ì œê±°',0),(393176,10922,'he','×”×ž×¡×ž×š ×”×ž×¢×¨×›×ª ×”×•×¡×¨',0),(393177,10922,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚ Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯',0),(393178,10922,'zh','ç³»ç»Ÿæ–‡æ¡£åˆ é™¤\r\n',0),(393179,10922,'sv','System-dokumentet tas bort',0),(393180,10922,'it','Documento sistema rimosso',0),(393181,10922,'tl','',0),(393182,10922,'th','à¹€à¸­à¸²à¹€à¸­à¸à¸ªà¸²à¸£à¸£à¸°à¸šà¸š',0),(393183,10922,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¹à¤Ÿà¤¾',0),(393184,10922,'ms','Dokumen sistem yang dikeluarkan',0),(393185,10922,'ar','ÙˆØ«ÙŠÙ‚Ø© Ù†Ø¸Ø§Ù… Ø¥Ø²Ø§Ù„Ø©',0),(393186,10922,'fr','SystÃ¨me Document supprimÃ©',0),(393187,10922,'jp','ã‚·ã‚¹ãƒ†ãƒ ã®ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã®å‰Šé™¤',0),(393188,10922,'pt','Sistema documento removido',0),(393189,10922,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(393190,10922,'es','Documento del Sistema Eliminado',0),(393191,10922,'de','System-Dokument entfernt',0),(393192,10922,'en','System Document Removed',0),(393193,10923,'is','',0),(393194,10923,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø®ÙŠØ± ',0),(393195,10923,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø®ÙŠØ± ',0),(393196,10923,'tr','Gecikme bedeli',0),(393197,10923,'pl','Dodatkowa opÅ‚ata za pÃ³Åºne',0),(393198,10923,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° ÐºÑŠÑÐ½Ð¾',0),(393199,10923,'ur','Ù…Ø±Ø­ÙˆÙ… Ú©ÛŒ ÙÛŒØ³',0),(393200,10923,'sr','ÐžÐ¿Ð¾Ð¼ÐµÐ½Ð°',0),(393201,10923,'vi','phÃ­ cháº­m',0),(393202,10923,'af','Laat fooi',0),(393203,10923,'ro','TaxÄƒ de Ã®ntÃ¢rziere',0),(393204,10923,'et','Viivis',0),(393205,10923,'si','Pozno pristojbina',0),(393206,10923,'ba','Keterlambatan',0),(393207,10923,'nl','Te late betaling',0),(393208,10923,'fi','ViivÃ¤styskorko',0),(393209,10923,'no','Sen gebyr',0),(393210,10923,'da','Sen gebyr',0),(393211,10923,'ko','ì—°ì²´ ë£Œ',0),(393212,10923,'he','×“×ž×™ ×”××™×—×•×¨',0),(393213,10923,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Î±Î¼Î¿Î¹Î²Î®',0),(393214,10923,'zh','æ»žçº³é‡‘\r\n',0),(393215,10923,'sv','Avgift fÃ¶r sen',0),(393216,10923,'it','Late a pagamento',0),(393217,10923,'tl','',0),(393218,10923,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸¥à¹ˆà¸²à¸Šà¹‰à¸²',0),(393219,10923,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤¶à¥à¤²à¥à¤•',0),(393220,10923,'ms','Yuran lewat',0),(393221,10923,'ar','Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(393222,10923,'fr','Frais de retard',0),(393223,10923,'jp','ãƒ¬ã‚¤ãƒˆ',0),(393224,10923,'pt','Taxa de atraso',0),(393225,10923,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ð·Ð´Ð½Ð¸Ð¹',0),(393226,10923,'es','Cuota de Ser Tarde',0),(393227,10923,'de','GebÃ¼hr fÃ¼r verspÃ¤tete',0),(393228,10923,'en','Late Fee',0),(393229,10924,'is','',0),(393230,10924,'dr','PetØ§Ø¬Ø§Ø±Ù‡ ',0),(393231,10924,'pr','PetØ§Ø¬Ø§Ø±Ù‡ ',0),(393232,10924,'tr','Evde beslenen hayvan kira',0),(393233,10924,'pl','PieÅ›ciÄ‡ Wynajem',0),(393234,10924,'bg','Ð”Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð»ÑŽÐ±Ð¸Ð¼Ñ†Ð¸ Ð½Ð°ÐµÐ¼',0),(393235,10924,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± Ú©Ø±Ø§Ø¦Û’',0),(393236,10924,'sr','Ð‰ÑƒÐ±Ð¸Ð¼Ð°Ñ† ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ñƒ',0),(393237,10924,'vi','thuÃª riÃªng',0),(393238,10924,'af','Troeteldier huur',0),(393239,10924,'ro','Animal de casÄƒ chirie',0),(393240,10924,'et','Lemmikloomade Rent',0),(393241,10924,'si','Jjeza najemnine',0),(393242,10924,'ba','Hewan peliharaan Disewa',0),(393243,10924,'nl','Huisdier huur',0),(393244,10924,'fi','HellitellÃ¤ vuokrattavana',0),(393245,10924,'no','Pet leie',0),(393246,10924,'da','Pet leje',0),(393247,10924,'ko','ì• ì™„ ë™ë¬¼ ì§‘ ì„¸',0),(393248,10924,'he','×”×©×›×¨×” ×œ×—×™×•×ª ×ž×—×ž×“',0),(393249,10924,'el','ÎšÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ Î¶ÏŽÎ¿ ÎµÎ½Î¿Î¹ÎºÎ¯Î±ÏƒÎ·',0),(393250,10924,'zh','å® ç‰©ç§Ÿ\r\n',0),(393251,10924,'sv','SÃ¤llskapsdjur hyra',0),(393252,10924,'it','Affitto dell\'animale domestico',0),(393253,10924,'tl','',0),(393254,10924,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(393255,10924,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤ªà¤¶à¥ à¤¬à¤¾à¤‡à¤• à¤•à¤¿à¤°à¤¾à¤',0),(393256,10924,'ms','Sewa haiwan kesayangan',0),(393257,10924,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ©',0),(393258,10924,'fr','Louer pour animaux de compagnie',0),(393259,10924,'jp','ãƒšãƒƒãƒˆã®å®¶è³ƒ',0),(393260,10924,'pt','Aluguel de animais',0),(393261,10924,'ru','ÐŸÐ­Ð¢ ÐÑ€ÐµÐ½Ð´Ð°',0),(393262,10924,'es','Renta de Mascota',0),(393263,10924,'de','Haustier mieten',0),(393264,10924,'en','Pet Rent',0),(393265,10925,'is','',0),(393266,10925,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„',0),(393267,10925,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„',0),(393268,10925,'tr','Transfer Ã¼creti',0),(393269,10925,'pl','OpÅ‚ata za transferowa',0),(393270,10925,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ',0),(393271,10925,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ ÙÛŒØ³',0),(393272,10925,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ñƒ Ð·Ð° Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€',0),(393273,10925,'vi','PhÃ­ chuyá»ƒn',0),(393274,10925,'af','Oorplasingsfooi',0),(393275,10925,'ro','Taxa de transfer',0),(393276,10925,'et','Ãœlekande tasu',0),(393277,10925,'si','Prenos pristojbine',0),(393278,10925,'ba','Biaya transfer',0),(393279,10925,'nl','Transfersom',0),(393280,10925,'fi','Siirtomaksu',0),(393281,10925,'no','OverfÃ¸re avgift',0),(393282,10925,'da','Transfersummen',0),(393283,10925,'ko','ì†¡ê¸ˆ ìˆ˜ìˆ˜ë£Œ',0),(393284,10925,'he','×ª×©×œ×•× ×”×¢×‘×¨×”',0),(393285,10925,'el','ÎœÎµÏ„Î±Î³ÏÎ±Ï†Î®',0),(393286,10925,'zh','è½¬è®©è´¹\r\n',0),(393287,10925,'sv','Avgift',0),(393288,10925,'it','Tassa di trasferimento',0),(393289,10925,'tl','',0),(393290,10925,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹‚à¸­à¸™',0),(393291,10925,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤¶à¥à¤²à¥à¤•',0),(393292,10925,'ms','Yuran pemindahan',0),(393293,10925,'ar','Ø±Ø³ÙˆÙ… Ù†Ù‚Ù„',0),(393294,10925,'fr','Frais de transfert',0),(393295,10925,'jp','æŒ¯è¾¼æ‰‹æ•°æ–™',0),(393296,10925,'pt','Taxa de transferÃªncia',0),(393297,10925,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´',0),(393298,10925,'es','Cuota de Transferencia',0),(393299,10925,'de','AblÃ¶sesumme',0),(393300,10925,'en','Transfer Fee',0),(393301,10926,'is','',0),(393302,10926,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(393303,10926,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(393304,10926,'tr','Bina vergisi Ekle - baÅŸarÄ±sÄ±z oldu',0),(393305,10926,'pl','Budynek podatku dodaÄ‡ - nie powiodÅ‚o siÄ™',0),(393306,10926,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº ÑÐ³Ñ€Ð°Ð´Ð¸ - Ð½Ðµ ÑƒÑÐ¿Ñ',0),(393307,10926,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº - Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(393308,10926,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ - Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(393309,10926,'vi','XÃ¢y dá»±ng thuáº¿ thÃªm - tháº¥t báº¡i',0),(393310,10926,'af','Voeg bou belasting - het misluk',0),(393311,10926,'ro','Construirea fiscale Adauga - nu a reuÈ™it',0),(393312,10926,'et','Hoone kÃ¤ibemaksu lisamine - nurjus',0),(393313,10926,'si','Gradnjo davka dodati - ni uspelo',0),(393314,10926,'ba','Bangunan pajak menambahkan - gagal',0),(393315,10926,'nl','Gebouw belasting toevoegen - is mislukt',0),(393316,10926,'fi','Rakennuksen veroa lisÃ¤Ã¤ - epÃ¤onnistui',0),(393317,10926,'no','Bygge skatt Add - mislyktes',0),(393318,10926,'da','Bygning skat tilfÃ¸je - mislykkedes',0),(393319,10926,'ko','ì¶”ê°€ ì„¸ê¸ˆì„ ê±´ë¬¼-ì‹¤íŒ¨',0),(393320,10926,'he','×‘× ×™×™×Ÿ ×ž×¡ ×œ×”×•×¡×™×£ - × ×›×©×œ',0),(393321,10926,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Ï†ÏŒÏÎ¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ - Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(393322,10926,'zh','æˆ¿å±‹ç¨Žæ–°å¢ž- å¤±è´¥\r\n',0),(393323,10926,'sv','Bygga skatt tillÃ¤gga - misslyckades',0),(393324,10926,'it','Edificio fiscale aggiungere - non riuscita',0),(393325,10926,'tl','',0),(393326,10926,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸ à¸²à¸©à¸µà¹€à¸žà¸´à¹ˆà¸¡ - à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(393327,10926,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ - à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(393328,10926,'ms','Bangunan cukai Tambah - gagal',0),(393329,10926,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¨Ù†Ù‰ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨--ÙØ´Ù„',0),(393330,10926,'fr','Taxe de construction d\'ajouter - a Ã©chouÃ©',0),(393331,10926,'jp','ç¨Žã‚’è¿½åŠ  - å¤±æ•—',0),(393332,10926,'pt','Predial adicionar - falhou',0),(393333,10926,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ - Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ',0),(393334,10926,'es','Impuesto del Edificio - FallÃ³',0),(393335,10926,'de','GebÃ¤ude Steuern hinzufÃ¼gen - Fehler',0),(393336,10926,'en','Building Tax Add - Failed',0),(393337,10927,'is','',0),(393338,10927,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(393339,10927,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(393340,10927,'tr','Bina vergisi baÅŸarÄ±yla eklendi',0),(393341,10927,'pl','Budynku podatek dodany pomyÅ›lnie',0),(393342,10927,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ð´Ð°Ð½ÑŠÐº Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(393343,10927,'ur','Ø¹Ù…Ø§Ø±Øª Ú©Û’ Ù¹ÛŒÚ©Ø³ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(393344,10927,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(393345,10927,'vi','XÃ¢y dá»±ng thuáº¿ thÃªm thÃ nh cÃ´ng',0),(393346,10927,'af','Gebou belasting suksesvol bygevoeg',0),(393347,10927,'ro','ClÄƒdire fiscale adÄƒugat cu succes',0),(393348,10927,'et','Hoone maksu lisatud',0),(393349,10927,'si','Stavbi davek dodan uspeÅ¡no',0),(393350,10927,'ba','Bangunan pajak ditambahkan berhasil',0),(393351,10927,'nl','Gebouw belasting toegevoegd',0),(393352,10927,'fi','Rakennuksen verotuksen lisÃ¤Ã¤minen onnistui',0),(393353,10927,'no','Bygningen skatt lagt',0),(393354,10927,'da','Bygning skat tilfÃ¸jet',0),(393355,10927,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ê±´ë¬¼ ì„¸ê¸ˆ',0),(393356,10927,'he','×‘× ×™×™×Ÿ ×ž×¡ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(393357,10927,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Ï†ÏŒÏÎ¿ Ï€ÏÎ¿ÏƒÏ„Î¹Î¸Î­Î¼ÎµÎ½Î·Ï‚ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(393358,10927,'zh','æˆ¿å±‹ç¨Žæ·»åŠ æˆåŠŸ\r\n',0),(393359,10927,'sv','Byggnaden skatt lagts',0),(393360,10927,'it','Edificio fiscale aggiunto con successo',0),(393361,10927,'tl','',0),(393362,10927,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸ à¸²à¸©à¸µà¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(393363,10927,'hi','à¤­à¤µà¤¨ à¤•à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(393364,10927,'ms','Cukai bangunan yang berjaya menambah',0),(393365,10927,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø¨Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(393366,10927,'fr','BÃ¢timent taxe ajoutÃ©e avec succÃ¨s',0),(393367,10927,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸå»ºç‰©ç¨Ž',0),(393368,10927,'pt','ContribuiÃ§Ã£o predial adicionada com sucesso',0),(393369,10927,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(393370,10927,'es','Impuesto del Edificio Agregado Exitosamente',0),(393371,10927,'de','Bausteuer erfolgreich hinzugefÃ¼gt',0),(393372,10927,'en','Building Tax Added Successfully',0),(393373,10928,'is','',0),(393374,10928,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯',0),(393375,10928,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø§ÙŠØ¬Ø§Ø¯ Ø´Ø¯',0),(393376,10928,'tr','Bill hazÄ±rlandÄ±',0),(393377,10928,'pl','Bill stworzony',0),(393378,10928,'bg','Ð‘Ð¸Ð» ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½',0),(393379,10928,'ur','Ø¨Ù„ Ú©ÛŒ Ù¾ÛŒØ¯Ø§',0),(393380,10928,'sr','Ð‘Ð¸Ð» ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½',0),(393381,10928,'vi','ÄÃ£ táº¡o ho1s Ä‘Æ¡n',0),(393382,10928,'af','Wetsontwerp geskep',0),(393383,10928,'ro','Creat de Bill',0),(393384,10928,'et','Arve loonud',0),(393385,10928,'si','Bill ustvaril',0),(393386,10928,'ba','Bill dibuat',0),(393387,10928,'nl','Bill gemaakt',0),(393388,10928,'fi','Bill luotu',0),(393389,10928,'no','Bill opprettet',0),(393390,10928,'da','Bill lavet',0),(393391,10928,'ko','ì²­êµ¬ì„œ ìž‘ì„±',0),(393392,10928,'he','×”×—×©×‘×•×Ÿ × ×•×¦×¨',0),(393393,10928,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Ï„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(393394,10928,'zh','å¸å•å»ºç«‹\r\n',0),(393395,10928,'sv','Bill skapad',0),(393396,10928,'it','Bill creato',0),(393397,10928,'tl','',0),(393398,10928,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£',0),(393399,10928,'hi','à¤¬à¤¿à¤² à¤¬à¤¨à¤¾à¤¯à¤¾',0),(393400,10928,'ms','Rang undang-undang dicipta',0),(393401,10928,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙØ§ØªÙˆØ±Ø©',0),(393402,10928,'fr','Projet de loi crÃ©Ã©',0),(393403,10928,'jp','è«‹æ±‚æ›¸ã®ä½œæˆ',0),(393404,10928,'pt','Bill criado',0),(393405,10928,'ru','Ð‘Ð¸Ð»Ð» ÑÐ¾Ð·Ð´Ð°Ð»',0),(393406,10928,'es','Recibo Creado',0),(393407,10928,'de','Erstellt von Bill',0),(393408,10928,'en','Bill Created',0),(393409,10929,'is','',0),(393410,10929,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(393411,10929,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯',0),(393412,10929,'tr','Bina emlak vergisi - BorÃ§lar iÃ§in ekleyin',0),(393413,10929,'pl','Budynek podatku od nieruchomoÅ›ci - Dodaj do zobowiÄ…zania',0),(393414,10929,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº ÑÐ³Ñ€Ð°Ð´Ð¸ - Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐºÑŠÐ¼ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(393415,10929,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ - Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ù„Ø¦Û’ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(393416,10929,'sr','Ð—Ð³Ñ€Ð°Ð´Ð° Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ - Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(393417,10929,'vi','CÃ¡c khoáº£n thuáº¿ bÃ¢t Ä‘Ã´ng sáº£n pháº£i tráº£',0),(393418,10929,'af','Eiendom belasting - gebou by Waardedalingstoetse',0),(393419,10929,'ro','ClÄƒdire de proprietate fiscal - Adauga la datorii',0),(393420,10929,'et','Hoone maamaksu - lisada vÃµlad',0),(393421,10929,'si','Davek na nepremiÄnine - stavbe dodati obveznosti',0),(393422,10929,'ba','Bangunan pajak properti - menambah hutang',0),(393423,10929,'nl','Onroerende voorheffing - gebouw toevoegen aan schulden',0),(393424,10929,'fi','Rakennuksen kiinteistÃ¶vero - lisÃ¤tÃ¤ Ostovelat',0),(393425,10929,'no','Bygge eiendomsskatt - legge til leverandÃ¸rgjeld',0),(393426,10929,'da','Bygning ejendomsskat - tilfÃ¸je til gÃ¦ld',0),(393427,10929,'ko','ê±´ë¬¼ ìž¬ì‚°ì„¸-ë¯¸ì§€ê¸‰ê¸ˆì— ì¶”ê°€',0),(393428,10929,'he','×‘× ×™×™×Ÿ ×ž×¡ ×¨×›×•×© - ×œ×”×•×¡×™×£ ×–×›××™×',0),(393429,10929,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ - Î±Ï…Î¾Î¬Î½Ï‰ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(393430,10929,'zh','æˆ¿äº§ç¨Ž- åŠ å…¥åº”ä»˜è´¦æ¬¾\r\n',0),(393431,10929,'sv','Bygga fastighetsskatt - lÃ¤gga till leverantÃ¶rsskulder',0),(393432,10929,'it','Edificio proprietÃ  fiscale - aggiungere ai debiti',0),(393433,10929,'tl','',0),(393434,10929,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™ - à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸±à¸à¸Šà¸µà¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰',0),(393435,10929,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° - à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤²à¤¿à¤ Payables à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(393436,10929,'ms','Bangunan cukai harta - menambah kepada pemiutang',0),(393437,10929,'ar','Ø¨Ù†Ø§Ø¡ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ-Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(393438,10929,'fr','BÃ¢timent des impÃ´ts fonciers - ajouter des comptes Ã  payer',0),(393439,10929,'jp','å»ºç‰©ã®å›ºå®šè³‡ç”£ç¨Žã®å‚µå‹™ã‚’è¿½åŠ ',0),(393440,10929,'pt','Propriedade predial - adicionar ao contas a pagar',0),(393441,10929,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ - Ð·Ð´Ð°Ð½Ð¸Ðµ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(393442,10929,'es','Impuesto Predial del Edificio - Agregar a Pagables',0),(393443,10929,'de','Grundsteuer - GebÃ¤ude hinzufÃ¼gen Verbindlichkeiten',0),(393444,10929,'en','Building Property Tax - Add to Payables',0),(393445,10930,'is','',0),(393446,10930,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(393447,10930,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù†',0),(393448,10930,'tr','Bina emlak vergisi raporu',0),(393449,10930,'pl','Budowa raportu podatku od nieruchomoÅ›ci',0),(393450,10930,'bg','Ð¡Ð³Ñ€Ð°Ð´Ð° Ð´Ð°Ð½ÑŠÐº Ð´Ð¾ÐºÐ»Ð°Ð´',0),(393451,10930,'ur','Ø¹Ù…Ø§Ø±Øª Ú©Û’ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(393452,10930,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ð·Ð³Ñ€Ð°Ð´Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ',0),(393453,10930,'vi','XÃ¢y dá»±ng thuáº¿ báº¥t Ä‘á»™ng sáº£n bÃ¡o cÃ¡o',0),(393454,10930,'af','Gebou eiendom belasting verslag',0),(393455,10930,'ro','Raport de impozitul pe clÄƒdire',0),(393456,10930,'et','Hoone maamaks aruanne',0),(393457,10930,'si','Davek na nepremiÄnine poroÄilo stavbe',0),(393458,10930,'ba','Laporan pajak properti bangunan',0),(393459,10930,'nl','Gebouw onroerende voorheffing verslag',0),(393460,10930,'fi','Building kiinteistÃ¶vero raportti',0),(393461,10930,'no','Rapport fra byggeplass eiendomsskatt',0),(393462,10930,'da','Bygning ejendomsskat rapport',0),(393463,10930,'ko','ê±´ë¬¼ ìž¬ì‚°ì„¸ ë³´ê³ ì„œ',0),(393464,10930,'he','×“×•×— ×ž×¡ ×¨×›×•×© ×‘× ×™×™×Ÿ',0),(393465,10930,'el','ÎšÏ„Î¯ÏÎ¹Î¿ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Î­ÎºÎ¸ÎµÏƒÎ·',0),(393466,10930,'zh','æˆ¿äº§ç¨Žçš„æŠ¥å‘Š\r\n',0),(393467,10930,'sv','Byggnaden fastighetsskatt rapport',0),(393468,10930,'it','Edificio proprietÃ  fiscale relazione',0),(393469,10930,'tl','',0),(393470,10930,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸­à¸²à¸„à¸²à¸£',0),(393471,10930,'hi','à¤¬à¤¿à¤²à¥à¤¡à¤¿à¤‚à¤— à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(393472,10930,'ms','Laporan cukai harta bangunan',0),(393473,10930,'ar','ØªÙ‚Ø±ÙŠØ± Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ Ø¨Ù†Ø§Ø¡',0),(393474,10930,'fr','Rapport d\'impÃ´t foncier construction',0),(393475,10930,'jp','å»ºç‰©ã®å›ºå®šè³‡ç”£ç¨Žãƒ¬ãƒãƒ¼ãƒˆ',0),(393476,10930,'pt','RelatÃ³rio de imposto sobre a propriedade do edifÃ­cio',0),(393477,10930,'ru','Ð—Ð´Ð°Ð½Ð¸Ðµ Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(393478,10930,'es','Impuesto Predial del Edificio Informe',0),(393479,10930,'de','GebÃ¤ude-Grundsteuer-Bericht',0),(393480,10930,'en','Building Property Tax Report',0),(393481,10931,'is','',0),(393482,10931,'dr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨â€ŒÙ‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(393483,10931,'pr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨â€ŒÙ‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(393484,10931,'tr','BorÃ§lar iÃ§in gÃ¶nderilen',0),(393485,10931,'pl','WysÅ‚ane do zobowiÄ…zania',0),(393486,10931,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾ Ð´Ð¾ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(393487,10931,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(393488,10931,'sr','ÐŸÐ¾ÑÐ»Ð°Ñ‚ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(393489,10931,'vi','ÄÃ£ gá»­i Ä‘áº¿n bá»™ pháº­n pháº£i tráº£',0),(393490,10931,'af','Stuur na Uitgawes (RB)',0),(393491,10931,'ro','Trimis la datorii',0),(393492,10931,'et','Saata hankijatele',0),(393493,10931,'si','Poslati obveznosti',0),(393494,10931,'ba','Dikirim ke hutang',0),(393495,10931,'nl','Verzonden naar schulden',0),(393496,10931,'fi','LÃ¤hetetÃ¤Ã¤n Ostovelat',0),(393497,10931,'no','Sendt til leverandÃ¸rgjeld',0),(393498,10931,'da','Sendt til gÃ¦ld',0),(393499,10931,'ko','ë¯¸ì§€ê¸‰ê¸ˆì„ ì „ì†¡',0),(393500,10931,'he','× ×©×œ×— ×–×›××™×',0),(393501,10931,'el','Î£Ï„Î±Î»Î¿ÏÎ½ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(393502,10931,'zh','å‘é€åˆ°åº”ä»˜è´¦æ¬¾\r\n',0),(393503,10931,'sv','Skickas till leverantÃ¶rsskulder',0),(393504,10931,'it','Inviato a debiti',0),(393505,10931,'tl','',0),(393506,10931,'th','à¸ªà¹ˆà¸‡à¹„à¸›à¸¢à¸±à¸‡à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰',0),(393507,10931,'hi','Payables à¤•à¥‹ à¤­à¥‡à¤œà¤¾',0),(393508,10931,'ms','Dihantar kepada pemiutang',0),(393509,10931,'ar','Ø£Ø±Ø³Ù„Øª Ù„Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(393510,10931,'fr','EnvoyÃ© Ã  des comptes fournisseurs',0),(393511,10931,'jp','å‚µå‹™ã«é€ä¿¡',0),(393512,10931,'pt','Enviado para contas a pagar',0),(393513,10931,'ru','ÐŸÐ¾ÑÐ»Ð°Ð» Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(393514,10931,'es','Enviado a Pagables',0),(393515,10931,'de','Gesendet auf Verbindlichkeiten',0),(393516,10931,'en','Sent to Payables',0),(393517,10932,'is','',0),(393518,10932,'dr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ¯Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(393519,10932,'pr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ¯Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ù‡Ø§',0),(393520,10932,'tr','Hangi gruplarÄ± gÃ¶ster',0),(393521,10932,'pl','PokaÅ¼ ktÃ³re grupy',0),(393522,10932,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ð¸ Ð³Ñ€ÑƒÐ¿Ð¸',0),(393523,10932,'ur','Ø¬Ø³ Ú¯Ø±ÙˆÙ¾ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(393524,10932,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð³Ñ€ÑƒÐ¿Ðµ ÐºÐ¾Ñ˜Ðµ',0),(393525,10932,'vi','Thá»ƒ hiá»‡n nhá»¯ng nhÃ³m nÃ o',0),(393526,10932,'af','Wys watter groepe',0),(393527,10932,'ro','AratÄƒ care grupuri',0),(393528,10932,'et','Kuva rÃ¼hmad',0),(393529,10932,'si','PokaÅ¾i skupine, ki',0),(393530,10932,'ba','Menunjukkan kelompok',0),(393531,10932,'nl','Toon van welke groepen',0),(393532,10932,'fi','NÃ¤ytÃ¤ kÃ¤yttÃ¤jÃ¤ryhmÃ¤t',0),(393533,10932,'no','Vis hvilke grupper',0),(393534,10932,'da','Vis hvilke grupper',0),(393535,10932,'ko','ì–´ëŠ ê·¸ë£¹ ë³´ê¸°',0),(393536,10932,'he','. ×ª×¨××” ××™×œ×• ×§×‘×•×¦×•×ª',0),(393537,10932,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¿Î¼Î¬Î´Ï‰Î½ Ï€Î¿Ï…',0),(393538,10932,'zh','æ˜¾ç¤ºå“ªäº›ç»„\r\n',0),(393539,10932,'sv','Visa vilka grupper',0),(393540,10932,'it','Mostrano che i gruppi',0),(393541,10932,'tl','',0),(393542,10932,'th','à¹à¸ªà¸”à¸‡à¸§à¹ˆà¸²à¸à¸¥à¸¸à¹ˆà¸¡à¹ƒà¸”',0),(393543,10932,'hi','à¤•à¥Œà¤¨ à¤¸à¤¾ à¤¸à¤®à¥‚à¤¹ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(393544,10932,'ms','Menunjukkan Kumpulan yang',0),(393545,10932,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„ØªÙŠ',0),(393546,10932,'fr','Montrer quels groupes',0),(393547,10932,'jp','ã©ã®ã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(393548,10932,'pt','Mostrar quais os grupos',0),(393549,10932,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐšÐ°ÐºÐ¸Ðµ Ð“Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(393550,10932,'es','Muestra Cuales Grupos',0),(393551,10932,'de','Welche Gruppen anzeigen',0),(393552,10932,'en','Show Which Groups',0),(393553,10933,'is','',0),(393554,10933,'dr','Ø³Ø§Ù„ Ø¨Ø±Ø§ÙŠ Ù…Ù‚Ø§Ø¯ÙŠØ± ',0),(393555,10933,'pr','Ø³Ø§Ù„ Ø¨Ø±Ø§ÙŠ Ù…Ù‚Ø§Ø¯ÙŠØ± ',0),(393556,10933,'tr','YÄ±l tutarlar iÃ§in',0),(393557,10933,'pl','Roku do kwoty',0),(393558,10933,'bg','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð·Ð° ÑÑƒÐ¼Ð¸',0),(393559,10933,'ur','Ù…Ù‚Ø¯Ø§Ø± Ú©Û’ Ø³Ø§Ù„',0),(393560,10933,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ Ð·Ð° Ð¸Ð·Ð½Ð¾ÑÐµ',0),(393561,10933,'vi','NÄƒm Ä‘á»‘i vá»›i sá»‘ tiá»n',0),(393562,10933,'af','Jaar vir Bedrae',0),(393563,10933,'ro','An pentru sumele',0),(393564,10933,'et','Aasta summad',0),(393565,10933,'si','Leto za zneske',0),(393566,10933,'ba','Tahun untuk jumlah',0),(393567,10933,'nl','Jaar voor bedragen',0),(393568,10933,'fi','Vuosi mÃ¤Ã¤rÃ¤',0),(393569,10933,'no','Ã…r for belÃ¸p',0),(393570,10933,'da','Ã…r for belÃ¸b',0),(393571,10933,'ko','ê¸ˆì•¡ì— ëŒ€ í•œ 1 ë…„',0),(393572,10933,'he','×©× ×” ×¢×‘×•×¨ ×›×ž×•×™×•×ª',0),(393573,10933,'el','ÎˆÏ„Î¿Ï‚ Î³Î¹Î± Ï€Î¿ÏƒÎ¬',0),(393574,10933,'zh','å¹´é‡‘é¢\r\n',0),(393575,10933,'sv','Ã…r fÃ¶r belopp',0),(393576,10933,'it','Anno per gli importi',0),(393577,10933,'tl','',0),(393578,10933,'th','à¸›à¸µà¸ªà¸³à¸«à¸£à¸±à¸šà¸¢à¸­à¸”à¹€à¸‡à¸´à¸™',0),(393579,10933,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤°à¥à¤·',0),(393580,10933,'ms','Tahun bagi jumlah',0),(393581,10933,'ar','Ø§Ù„Ø¹Ø§Ù… Ù„Ù„Ù…Ø¨Ø§Ù„Øº',0),(393582,10933,'fr','AnnÃ©e pour les montants',0),(393583,10933,'jp','é‡ã®ãŸã‚ã®å¹´',0),(393584,10933,'pt','Ano para quantidades',0),(393585,10933,'ru','Ð“Ð¾Ð´ Ð´Ð»Ñ ÑÑƒÐ¼Ð¼',0),(393586,10933,'es','AÃ±o Para Montos',0),(393587,10933,'de','Jahr fÃ¼r BetrÃ¤ge',0),(393588,10933,'en','Year for Amounts',0),(393589,10934,'is','',0),(393590,10934,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ùˆ Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(393591,10934,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ùˆ Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(393592,10934,'tr','Malzeme ve diÄŸer Ã¼cretleri ekleme',0),(393593,10934,'pl','Dodawanie materiaÅ‚Ã³w i innych opÅ‚at',0),(393594,10934,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð¸ Ð´Ñ€ÑƒÐ³Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(393595,10934,'ur','Ù…ÙˆØ§Ø¯ Ø§ÙˆØ± Ø¯ÛŒÚ¯Ø± Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(393596,10934,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð° Ð¸ Ð¾ÑÑ‚Ð°Ð»Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(393597,10934,'vi','ThÃªm phÃ­ nguyÃªn liá»‡u vÃ  phÃ­ khÃ¡c.',0),(393598,10934,'af','Byvoeging van Materiaal en Ander Kostes',0),(393599,10934,'ro','Adauga materiale È™i alte taxe',0),(393600,10934,'et','Lisa materjalid ja muud tasud',0),(393601,10934,'si','Dodaj materialov in drugih dajatev',0),(393602,10934,'ba','Tambahkan bahan dan biaya lainnya',0),(393603,10934,'nl','Toevoegen van materialen en andere heffingen',0),(393604,10934,'fi','LisÃ¤Ã¤ materiaaleja ja muut maksut',0),(393605,10934,'no','Legge til materialer og andre avgifter',0),(393606,10934,'da','TilfÃ¸je materialer og andre afgifter',0),(393607,10934,'ko','ì¶”ê°€ ìžë£Œ ë° ê¸°íƒ€ ë¹„ìš©',0),(393608,10934,'he','×”×•×¡×£ ×—×•×ž×¨×™× ×•×—×™×•×‘×™× ××—×¨×™×',0),(393609,10934,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î± Ï…Î»Î¹ÎºÎ¬ ÎºÎ±Î¹ Ï„Î± Î»Î¿Î¹Ï€Î¬ Î­Î¾Î¿Î´Î±',0),(393610,10934,'zh','å¢žåŠ ææ–™åŠå…¶ä»–è´¹ç”¨\r\n',0),(393611,10934,'sv','LÃ¤gga till material och andra avgifter',0),(393612,10934,'it','Aggiungere i materiali e gli altri oneri',0),(393613,10934,'tl','',0),(393614,10934,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸§à¸±à¸ªà¸”à¸¸à¹à¸¥à¸°à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸­à¸·à¹ˆà¸™ à¹†',0),(393615,10934,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¤¿à¤¯à¥‹à¤‚ à¤”à¤° à¤…à¤¨à¥à¤¯ à¤†à¤°à¥‹à¤ªà¥‹à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(393616,10934,'ms','Tambah bahan-bahan dan lain-lain caj',0),(393617,10934,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…ÙˆØ§Ø¯ ÙˆØ§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ø£Ø®Ø±Ù‰',0),(393618,10934,'fr','Ajouter les matÃ©riaux et autres frais',0),(393619,10934,'jp','ææ–™ãŠã‚ˆã³ä»–ã®æ–™é‡‘ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(393620,10934,'pt','Adicionar materiais e outros encargos',0),(393621,10934,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÑÑ‚ÑŒ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹ Ð¸ Ð´Ñ€ÑƒÐ³Ð¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(393622,10934,'es','Agregar Materiales u Otros Cargos',0),(393623,10934,'de','HinzufÃ¼gen von Materialien und sonstige Belastungen',0),(393624,10934,'en','Add Materials and Other Charges',0),(393625,10935,'is','',0),(393626,10935,'dr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡',0),(393627,10935,'pr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡',0),(393628,10935,'tr','Begin tahmini bitiÅŸ tarihi',0),(393629,10935,'pl','BEGIN Szacowana data zakoÅ„czenia',0),(393630,10935,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð° ÐºÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(393631,10935,'ur','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø§Ù†Ø¯Ø§Ø²Û Ù„Ú¯Ø§ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(393632,10935,'sr','ÐžÐ·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(393633,10935,'vi','NgÃ y dá»± kiáº¿n káº¿t thÃºc',0),(393634,10935,'af','Begin beraam Einddatum',0),(393635,10935,'ro','Incep estimat data de sfÃ¢rÅŸit',0),(393636,10935,'et','Alusta eeldatav lÃµppkuupÃ¤ev',0),(393637,10935,'si','ZaÄetek ocenjeni konÄni datum',0),(393638,10935,'ba','Mulailah perkiraan tanggal akhir',0),(393639,10935,'nl','Begin geschatte einddatum',0),(393640,10935,'fi','Aloita arvioitu pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(393641,10935,'no','Start anslÃ¥tt avslutningsdato',0),(393642,10935,'da','Begynd anslÃ¥et slutdato',0),(393643,10935,'ko','ì‹œìž‘ ì˜ˆìƒ ì¢…ë£Œì¼',0),(393644,10935,'he','×ª××¨×™×š ×¡×™×•× ×ž×©×•×¢×¨ ×‘×’×™×Ÿ',0),(393645,10935,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ ÎµÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(393646,10935,'zh','é¢„è®¡ç»“æŸæ—¥æœŸå¼€å§‹\r\n',0),(393647,10935,'sv','BÃ¶rja berÃ¤knat slutdatum',0),(393648,10935,'it','Begin End data stimata',0),(393649,10935,'tl','',0),(393650,10935,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸›à¸£à¸°à¸¡à¸²à¸“à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(393651,10935,'hi','à¤¶à¥à¤°à¥‚ à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(393652,10935,'ms','Mulakan anggaran tarikh akhir',0),(393653,10935,'ar','ØªØ¨Ø¯Ø£ Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ù‚Ø¯Ø±',0),(393654,10935,'fr','Begin estime la Date de fin',0),(393655,10935,'jp','é–‹å§‹ã¨çµ‚äº†æ—¥ã‚’æŽ¨å®š',0),(393656,10935,'pt','Begin estimado data final',0),(393657,10935,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð´Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(393658,10935,'es','Empieza Fecha de TerminaciÃ³n Estimada',0),(393659,10935,'de','BEGIN geschÃ¤tzt Enddatum',0),(393660,10935,'en','Begin Estimated End Date',0),(393661,10936,'is','',0),(393662,10936,'dr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ù‡Øª ØµØ¯ÙˆØ± ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ÙŠØ¯ ØªÙ†Ø¸ÙŠÙ… Ø´ÙˆØ¯',0),(393663,10936,'pr','Ø®Ø±ÙŠØ¯Ø§Ø± Ø¬Ù‡Øª ØµØ¯ÙˆØ± ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ÙŠØ¯ ØªÙ†Ø¸ÙŠÙ… Ø´ÙˆØ¯',0),(393664,10936,'tr','MÃ¼ÅŸteri Fatura gerekir iÃ§in ayarlanmasÄ±',0),(393665,10936,'pl','Klientowi faktury muszÄ… byÄ‡ zestaw',0),(393666,10936,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÐºÑŠÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¸',0),(393667,10936,'ur','Ú©Ø³Ù¹Ù…Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ú†Ø§ÛÛŒÛ’ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ú©ÛŒØ§',0),(393668,10936,'sr','ÐšÑƒÐ¿Ñ†Ð° Ð´Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°.',0),(393669,10936,'vi','hÃ³a Ä‘Æ¡n cho khÃ¡ch hÃ ng pháº£i Ä‘Æ°á»£c táº¡o',0),(393670,10936,'af','Klant om die faktuur moet opgestel word',0),(393671,10936,'ro','Client pentru factura trebuie sÄƒ fie setat',0),(393672,10936,'et','Kliendi arve peab olema esitatud',0),(393673,10936,'si','Kupec na raÄunu mora biti nastavljena',0),(393674,10936,'ba','Pelanggan untuk faktur harus diatur',0),(393675,10936,'nl','Klant voor factuur moet worden ingesteld',0),(393676,10936,'fi','Asiakkaan laskun on mÃ¤Ã¤ritettÃ¤vÃ¤',0),(393677,10936,'no','Kunden fakturaen mÃ¥ angis',0),(393678,10936,'da','Kunden at faktura skal angives',0),(393679,10936,'ko','ê³ ê° ì†¡ìž¥ í•´ì•¼ í•©ë‹ˆë‹¤ì„ ì„¤ì •',0),(393680,10936,'he','×œ×œ×§×•×— ×—×©×‘×•× ×™×ª ×—×™×™×‘ ×œ×”×™×•×ª ×ž×•×’×“×¨',0),(393681,10936,'el','Î ÎµÎ»Î¬Ï„Î·, ÏƒÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(393682,10936,'zh','å®¢æˆ·å‘ç¥¨å¿…é¡»è®¾ç½®\r\n',0),(393683,10936,'sv','Kunden att fakturan mÃ¥ste stÃ¤llas in',0),(393684,10936,'it','Cliente di fattura deve essere impostato',0),(393685,10936,'tl','',0),(393686,10936,'th','à¸à¸³à¸«à¸™à¸”à¹ƒà¸«à¹‰à¸•à¹‰à¸­à¸‡à¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(393687,10936,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾',0),(393688,10936,'ms','Pelanggan untuk invois hendaklah ditetapkan',0),(393689,10936,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ \"Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙŠØ¬Ø¨ Ø£Ù†\" ÙŠÙƒÙˆÙ† ØªØ¹ÙŠÙŠÙ†',0),(393690,10936,'fr','Client de la facture doit Ãªtre rÃ©glÃ©e',0),(393691,10936,'jp','é¡§å®¢ã«è«‹æ±‚ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(393692,10936,'pt','Cliente, a factura deve ser definido',0),(393693,10936,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‡Ð¸ÐºÑƒ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(393694,10936,'es','Cliente a Factura \nDebe Estar Configurado',0),(393695,10936,'de','Kunden, die Rechnung muss eingestellt werden',0),(393696,10936,'en','Customer to Invoice Must be Set',0),(393697,10937,'is','',0),(393698,10937,'dr','Ø²Ù…Ø§Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(393699,10937,'pr','Ø²Ù…Ø§Ù† ÙƒØ§Ø±Ù…Ù†Ø¯ ',0),(393700,10937,'tr','Ã‡alÄ±ÅŸanÄ±n zaman',0),(393701,10937,'pl','Czas pracownika',0),(393702,10937,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð²Ñ€ÐµÐ¼Ðµ',0),(393703,10937,'ur','Ù…Ù„Ø§Ø²Ù… ÙˆÙ‚Øª',0),(393704,10937,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(393705,10937,'vi','thá»i gian nhÃ¢n viÃªn',0),(393706,10937,'af','Werknemer Tyd',0),(393707,10937,'ro','Angajat timp',0),(393708,10937,'et','TÃ¶Ã¶taja aeg',0),(393709,10937,'si','ÄŒas zaposlenih',0),(393710,10937,'ba','Karyawan waktu',0),(393711,10937,'nl','Werknemer tijd',0),(393712,10937,'fi','TyÃ¶aikaa',0),(393713,10937,'no','Ansattes tid',0),(393714,10937,'da','Medarbejder tid',0),(393715,10937,'ko','ì§ì› ì‹œê°„',0),(393716,10937,'he','×–×ž×Ÿ ×¢×•×‘×“',0),(393717,10937,'el','Î§ÏÏŒÎ½Î¿ Ï…Ï€Î±Î»Î»Î®Î»Ï‰Î½',0),(393718,10937,'zh','å‘˜å·¥çš„æ—¶é—´\r\n',0),(393719,10937,'sv','AnstÃ¤lld tid',0),(393720,10937,'it','Tempo impiegato',0),(393721,10937,'tl','',0),(393722,10937,'th','à¹€à¸§à¸¥à¸²à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(393723,10937,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤®à¤¯',0),(393724,10937,'ms','Masa pekerja yang',0),(393725,10937,'ar','ÙˆÙ‚Øª Ø§Ù„Ù…ÙˆØ¸Ù',0),(393726,10937,'fr','Temps employÃ©',0),(393727,10937,'jp','å¾“æ¥­å“¡ã®æ™‚é–“',0),(393728,10937,'pt','Tempo empregado',0),(393729,10937,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(393730,10937,'es','Tiempo de Empleado',0),(393731,10937,'de','Mitarbeiter Zeit',0),(393732,10937,'en','Employee Time',0),(393733,10938,'is','',0),(393734,10938,'dr','   Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ ',0),(393735,10938,'pr','   Ù¾Ø§ÙŠØ§Ù† ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø´Ø¯Ù‡ ',0),(393736,10938,'tr','Sonu tahmini bitiÅŸ tarihi',0),(393737,10938,'pl','Koniec Szacowana data zakoÅ„czenia',0),(393738,10938,'bg','ÐšÑ€Ð°Ð¹ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð° ÐºÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(393739,10938,'ur','Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ú©Ø§ ØªØ®Ù…ÛŒÙ†Û',0),(393740,10938,'sr','ÐšÑ€Ð°Ñ˜ Ð¿Ñ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(393741,10938,'vi','káº¿t thÃºc ngÃ y háº¿t háº¡n dá»± tÃ­nh',0),(393742,10938,'af','Einde Geraamde Einddatum',0),(393743,10938,'ro','SfÃ¢rÅŸitul estimat data de sfÃ¢rÅŸit',0),(393744,10938,'et','LÃµpuks eeldatav lÃµppkuupÃ¤ev',0),(393745,10938,'si','KonÄni ocenjeni konÄni datum',0),(393746,10938,'ba','Akhir perkiraan tanggal akhir',0),(393747,10938,'nl','Einde geschatte einddatum',0),(393748,10938,'fi','Arviolta pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(393749,10938,'no','Slutten anslÃ¥tt avslutningsdato',0),(393750,10938,'da','Ende anslÃ¥et slutdato',0),(393751,10938,'ko','ìµœì¢… ì˜ˆìƒ ë ë‚ ì§œ',0),(393752,10938,'he','×¡×•×£ ×¡×•×£ ×ª××¨×™×š ×ž×©×•×¢×¨',0),(393753,10938,'el','Î¤Î­Î»Î¿Ï‚ ÎµÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(393754,10938,'zh','ç»“æŸä¼°è®¡ç»“æŸæ—¥æœŸ\r\n',0),(393755,10938,'sv','Slutet berÃ¤knat slutdatum',0),(393756,10938,'it','Fine fine data stimata',0),(393757,10938,'tl','',0),(393758,10938,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¹‚à¸”à¸¢à¸›à¸£à¸°à¸¡à¸²à¸“',0),(393759,10938,'hi','à¤…à¤‚à¤¤ à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(393760,10938,'ms','Akhir anggaran tarikh akhir',0),(393761,10938,'ar','Ù†Ù‡Ø§ÙŠØ© Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ù‚Ø¯Ø±',0),(393762,10938,'fr','Fin estimÃ©e de la Date de fin',0),(393763,10938,'jp','ã‚¨ãƒ³ãƒ‰æŽ¨å®šçµ‚äº†æ—¥',0),(393764,10938,'pt','Final estimado data final',0),(393765,10938,'ru','ÐšÐ¾Ð½ÐµÑ† Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð´Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(393766,10938,'es','Terminar Fecha de TerminaciÃ³n Estimada',0),(393767,10938,'de','Ende geschÃ¤tzt Enddatum',0),(393768,10938,'en','End Estimated End Date',0),(393769,10939,'is','',0),(393770,10939,'dr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(393771,10939,'pr','ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† ØªØ®Ù…ÙŠÙ†ÙŠ ',0),(393772,10939,'tr','EST bitiÅŸ tarihi',0),(393773,10939,'pl','Data zakoÅ„czenia Est',0),(393774,10939,'bg','EST ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(393775,10939,'ur','Est Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ®',0),(393776,10939,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° ÐµÑÑ‚',0),(393777,10939,'vi','Dá»± trÃ¹ ngÃ y káº¿t thÃºc',0),(393778,10939,'af','Est Einddatum',0),(393779,10939,'ro','Data de sfÃ¢rÅŸit de Est',0),(393780,10939,'et','EST lÃµppkuupÃ¤ev',0),(393781,10939,'si','EST konÄni datum',0),(393782,10939,'ba','Tanggal akhir Est',0),(393783,10939,'nl','Est einddatum',0),(393784,10939,'fi','Est pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(393785,10939,'no','EST sluttdatoen',0),(393786,10939,'da','EST slutdato',0),(393787,10939,'ko','Est ë ë‚ ì§œ',0),(393788,10939,'he','×ª××¨×™×š ×¡×™×•× Est',0),(393789,10939,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ EST',0),(393790,10939,'zh','é¢„è®¡ç»“æŸæ—¥æœŸ\r\n',0),(393791,10939,'sv','Est slutdatum',0),(393792,10939,'it','Data fine est',0),(393793,10939,'tl','',0),(393794,10939,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸” Est',0),(393795,10939,'hi','Est à¤…à¤‚à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(393796,10939,'ms','Tarikh akhir Est',0),(393797,10939,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Est',0),(393798,10939,'fr','Date de fin est',0),(393799,10939,'jp','ç±³å›½æ±éƒ¨æ¨™æº–æ™‚åˆ»ã®çµ‚äº†æ—¥',0),(393800,10939,'pt','Data de tÃ©rmino de est',0),(393801,10939,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ EST',0),(393802,10939,'es','Fecha de TerminaciÃ³n Est.',0),(393803,10939,'de','EST-Enddatum',0),(393804,10939,'en','Est End Date',0),(393805,10940,'is','',0),(393806,10940,'dr','Ù…Ø¨Ø§Ù„Øº ÙƒÙ„ ',0),(393807,10940,'pr','Ù…Ø¨Ø§Ù„Øº ÙƒÙ„ ',0),(393808,10940,'tr','Genel toplam',0),(393809,10940,'pl','Sumy',0),(393810,10940,'bg','ÐžÐ±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸',0),(393811,10940,'ur','Ú¯Ø±ÛŒÙ†Úˆ Ù…ÛŒØ²Ø§Ù†',0),(393812,10940,'sr','Ð¡Ð²ÐµÑƒÐºÑƒÐ¿Ð½Ð¸Ñ…',0),(393813,10940,'vi','CÃ¡c tá»•ng sá»‘',0),(393814,10940,'af','Groot Totale',0),(393815,10940,'ro','Totaluri',0),(393816,10940,'et','Koond',0),(393817,10940,'si','Vsote',0),(393818,10940,'ba','Grand Total',0),(393819,10940,'nl','Eindtotalen',0),(393820,10940,'fi','Loppusummat',0),(393821,10940,'no','Totalsummer',0),(393822,10940,'da','Hovedtotaler',0),(393823,10940,'ko','ì´í•©ê³„',0),(393824,10940,'he','×¡×›×•×ž×™× ×›×•×œ×œ×™×',0),(393825,10940,'el','Î‘Î¸ÏÎ¿Î¯ÏƒÎ¼Î±Ï„Î±',0),(393826,10940,'zh','æ€»è®¡\r\n',0),(393827,10940,'sv','Totalsummor',0),(393828,10940,'it','Totali complessivi',0),(393829,10940,'tl','',0),(393830,10940,'th','à¸œà¸¥à¸£à¸§à¸¡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(393831,10940,'hi','à¤®à¤¹à¤¾à¤¯à¥‹à¤—',0),(393832,10940,'ms','Jumlah Grand',0),(393833,10940,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹ Ø§Ù„ÙƒÙ„ÙŠØ©',0),(393834,10940,'fr','Totaux gÃ©nÃ©raux',0),(393835,10940,'jp','ç·è¨ˆ',0),(393836,10940,'pt','Totais gerais',0),(393837,10940,'ru','ÐžÐ±Ñ‰Ð¸Ðµ Ð¸Ñ‚Ð¾Ð³Ð¸',0),(393838,10940,'es','Sumas Totales',0),(393839,10940,'de','Gesamtergebnisse',0),(393840,10940,'en','Grand Totals',0),(393841,10941,'is','',0),(393842,10941,'dr','Ø¯Ø±ØµØ¯  Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(393843,10941,'pr','Ø¯Ø±ØµØ¯  Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´',0),(393844,10941,'tr','BiÃ§imlendirme yÃ¼zdesi',0),(393845,10941,'pl','Znaczniki procent',0),(393846,10941,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð½Ð° Ð½Ð°Ð´Ñ†ÐµÐ½ÐºÐ°',0),(393847,10941,'ur','Ù†Ø´Ø§Ù† ÙÛŒ ØµØ¯',0),(393848,10941,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚',0),(393849,10941,'vi','pháº§n trÄƒm cá»™ng thÃªm',0),(393850,10941,'af','Markup persentasie',0),(393851,10941,'ro','Procent de marcare',0),(393852,10941,'et','Juurdehindluse',0),(393853,10941,'si','OznaÄevalnem odstotek',0),(393854,10941,'ba','Persentase markup',0),(393855,10941,'nl','Markup Percentage',0),(393856,10941,'fi','LisÃ¤prosentti',0),(393857,10941,'no','Markup prosentandel',0),(393858,10941,'da','Avanceprocenten',0),(393859,10941,'ko','íƒœê·¸ ë¹„ìœ¨',0),(393860,10941,'he','××—×•×– ×”×™×™×§×•×¨',0),(393861,10941,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(393862,10941,'zh','æ ‡è®°ç™¾åˆ†æ¯”\r\n',0),(393863,10941,'sv','Markup procent',0),(393864,10941,'it','Percentuale di markup',0),(393865,10941,'tl','',0),(393866,10941,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸²à¸„à¸²',0),(393867,10941,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤®à¤¾à¤°à¥à¤•à¤…à¤ª',0),(393868,10941,'ms','Peratusan penanda',0),(393869,10941,'ar','Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ©',0),(393870,10941,'fr','Pourcentage de balisage',0),(393871,10941,'jp','ãƒžãƒ¼ã‚¯ã‚¢ãƒƒãƒ—çŽ‡',0),(393872,10941,'pt','Percentual de marcaÃ§Ã£o',0),(393873,10941,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(393874,10941,'es','Encarecimiento Porcentaje',0),(393875,10941,'de','Markup-Prozentsatz',0),(393876,10941,'en','Markup Percentage',0),(393877,10942,'is','',0),(393878,10942,'dr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ùˆ Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ',0),(393879,10942,'pr','Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÙŠÙ‡ Ùˆ Ø¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ',0),(393880,10942,'tr','Malzeme ve diÄŸer Ã¼cretler',0),(393881,10942,'pl','MateriaÅ‚y i inne opÅ‚aty',0),(393882,10942,'bg','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð¸ Ð´Ñ€ÑƒÐ³Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(393883,10942,'ur','Ù…ÙˆØ§Ø¯ Ø§ÙˆØ± Ø¯ÛŒÚ¯Ø± Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(393884,10942,'sr','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ðµ Ð¸ Ð¾ÑÑ‚Ð°Ð»Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(393885,10942,'vi','PhÃ­ váº­t liá»‡u vÃ  khÃ¡c',0),(393886,10942,'af','Materiale en Ander Kostes',0),(393887,10942,'ro','Materialele È™i alte taxe',0),(393888,10942,'et','Materjalid ja muud tasud',0),(393889,10942,'si','Materialov in drugih dajatev',0),(393890,10942,'ba','Bahan dan biaya lainnya',0),(393891,10942,'nl','Materialen en andere heffingen',0),(393892,10942,'fi','Materiaalit ja muut maksut',0),(393893,10942,'no','Materialer og andre avgifter',0),(393894,10942,'da','Materialer og andre afgifter',0),(393895,10942,'ko','ìž¬ë£Œ ë° ê¸°íƒ€ ë¹„ìš©',0),(393896,10942,'he','×—×•×ž×¨×™× ×•×—×™×•×‘×™× ××—×¨×™×',0),(393897,10942,'el','Î¥Î»Î¹ÎºÎ¬ ÎºÎ±Î¹ Î¬Î»Î»ÎµÏ‚ ÎµÏ€Î¹Î²Î±ÏÏÎ½ÏƒÎµÎ¹Ï‚',0),(393898,10942,'zh','ææ–™åŠå…¶ä»–è´¹ç”¨\r\n',0),(393899,10942,'sv','Material och andra avgifter',0),(393900,10942,'it','Materiali e altri oneri',0),(393901,10942,'tl','',0),(393902,10942,'th','à¸§à¸±à¸ªà¸”à¸¸à¹à¸¥à¸°à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸­à¸·à¹ˆà¸™ à¹†',0),(393903,10942,'hi','à¤¸à¤¾à¤®à¤—à¥à¤°à¤¿à¤¯à¥‹à¤‚ à¤”à¤° à¤…à¤¨à¥à¤¯ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(393904,10942,'ms','Bahan-bahan dan lain-lain caj',0),(393905,10942,'ar','Ø§Ù„Ù…ÙˆØ§Ø¯ ÙˆØ§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ø£Ø®Ø±Ù‰',0),(393906,10942,'fr','MatÃ©riaux et autres frais',0),(393907,10942,'jp','ææ–™ãŠã‚ˆã³ä»–ã®æ–™é‡‘',0),(393908,10942,'pt','Materiais e outros encargos',0),(393909,10942,'ru','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹ Ð¸ Ð´Ñ€ÑƒÐ³Ð¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(393910,10942,'es','Materiales y Otros Cargos',0),(393911,10942,'de','Materialien und sonstige Belastungen',0),(393912,10942,'en','Materials and Other Charges',0),(393913,10943,'is','',0),(393914,10943,'dr','Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø± Ù¾Ø±Ø³Ù†Ù„',0),(393915,10943,'pr','Ø³Ø§Ø¹Ø§Øª ÙƒØ§Ø± Ù¾Ø±Ø³Ù†Ù„',0),(393916,10943,'tr','Personel saat',0),(393917,10943,'pl','PracownikÃ³w godzin',0),(393918,10943,'bg','Ð˜Ð·Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ Ñ‡Ð°ÑÐ¾Ð²Ðµ',0),(393919,10943,'ur','Ø¹Ù…Ù„Û’ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª',0),(393920,10943,'sr','ÐžÑÐ¾Ð±Ñ™Ðµ ÑÐ°Ñ‚Ð¸',0),(393921,10943,'vi','Giá» nhÃ¢n viÃªn',0),(393922,10943,'af','Personeel Ure',0),(393923,10943,'ro','Personalul de ore',0),(393924,10943,'et','Tundi',0),(393925,10943,'si','Osebje ur',0),(393926,10943,'ba','Staf jam',0),(393927,10943,'nl','Personeel uur',0),(393928,10943,'fi','HenkilÃ¶kunta tuntia',0),(393929,10943,'no','Heltidspersonale timer',0),(393930,10943,'da','Personale timer',0),(393931,10943,'ko','ì§ì› ì‹œê°„',0),(393932,10943,'he','×¦×•×•×ª ×©×¢×•×ª',0),(393933,10943,'el','Î ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÏŒ ÏŽÏÎµÏ‚',0),(393934,10943,'zh','äººå‘˜çš„å·¥ä½œæ—¶é—´\r\n',0),(393935,10943,'sv','Personal timmar',0),(393936,10943,'it','Ore del personale',0),(393937,10943,'tl','',0),(393938,10943,'th','à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¸šà¸£à¸´à¸à¸²à¸£',0),(393939,10943,'hi','à¤¸à¥à¤Ÿà¤¾à¤« à¤˜à¤‚à¤Ÿà¥‡',0),(393940,10943,'ms','Jam kakitangan',0),(393941,10943,'ar','Ø³Ø§Ø¹Ø§Øª Ø¹Ù…Ù„ Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(393942,10943,'fr','Heures du personnel',0),(393943,10943,'jp','ã‚¹ã‚¿ãƒƒãƒ•ã®æ™‚é–“',0),(393944,10943,'pt','Horas da equipe',0),(393945,10943,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¸ Ñ‡Ð°ÑÐ¾Ð²',0),(393946,10943,'es','Horario de Cuerpo Administrativo',0),(393947,10943,'de','Personal-Stunden',0),(393948,10943,'en','Staff Hours',0),(393949,10944,'is','',0),(393950,10944,'dr','ÙƒÙ„ Ù‡Ø²ÙŠÙ†Ù‡ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø±',0),(393951,10944,'pr','ÙƒÙ„ Ù‡Ø²ÙŠÙ†Ù‡ Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø±',0),(393952,10944,'tr','Toplam Ã§alÄ±ÅŸma sipariÅŸ maliyeti',0),(393953,10944,'pl','CaÅ‚kowita praca zamÃ³wienia koszt',0),(393954,10944,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð·Ð° Ð¾Ð±Ñ‰Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(393955,10944,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ú©Ø§Ù… Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(393956,10944,'sr','Ð£ÐºÑƒÐ¿Ð°Ð½ Ð¿Ð¾ÑÐ°Ð¾ Ð½Ð°Ð»Ð¾Ð³ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(393957,10944,'vi','Tá»•ng chi phÃ­ lÃ m viá»‡c',0),(393958,10944,'af','Totale werk orde koste',0),(393959,10944,'ro','Costul de ordine totalÄƒ de lucru',0),(393960,10944,'et','KogutÃ¶Ã¶ tellimuse maksumus',0),(393961,10944,'si','Skupno delo naloga stroÅ¡kov',0),(393962,10944,'ba','Kerja Total Order biaya',0),(393963,10944,'nl','Totale hoeveelheid werk orderkosten',0),(393964,10944,'fi','TyÃ¶n kokonaismÃ¤Ã¤rÃ¤n alennus',0),(393965,10944,'no','Totale bestillingen kostnaden',0),(393966,10944,'da','Samlede arbejde ordre omkostninger',0),(393967,10944,'ko','ì „ì²´ ìž‘ì—… ìˆœì„œ ë¹„ìš©',0),(393968,10944,'he','×¢×œ×•×ª ×”×–×ž× ×ª ×”×¢×‘×•×“×” ×”×›×•×œ×œ×ª',0),(393969,10944,'el','ÎšÎŸÎ£Î¤ÎŸÎ£ Î Î‘Î¡Î‘Î“Î“Î•Î›Î™Î‘Î£ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ® ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(393970,10944,'zh','æ€»è®¡å·¥ä½œè®¢å•æˆæœ¬\r\n',0),(393971,10944,'sv','Totala arbetet bestÃ¤llning kostnad',0),(393972,10944,'it','Costo di lavoro totale ordine',0),(393973,10944,'tl','',0),(393974,10944,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(393975,10944,'hi','à¤•à¥à¤² à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤²à¤¾à¤—à¤¤',0),(393976,10944,'ms','Kos perintah keseluruhan kerja',0),(393977,10944,'ar','ØªÙƒÙ„ÙØ© ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(393978,10944,'fr','CoÃ»t total de travaux de la commande',0),(393979,10944,'jp','åˆè¨ˆä½œæ¥­ã‚³ã‚¹ãƒˆ',0),(393980,10944,'pt','Custo de ordem de trabalho total',0),(393981,10944,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð° Ð¾Ð±Ñ‰Ð°Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(393982,10944,'es','Total de Costos de Ordenes de Trabajo',0),(393983,10944,'de','Gesamtaufwand Bestellung Kosten',0),(393984,10944,'en','Total Work Order Cost',0),(393985,10945,'is','',0),(393986,10945,'dr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ§ÙŠÙŠØ¯ Ø´ÙˆØ¯ ',0),(393987,10945,'pr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ø²Ø¦ÙŠØ§Øª ØªØ§ÙŠÙŠØ¯ Ø´ÙˆØ¯ ',0),(393988,10945,'tr','Ä°ÅŸ emri olmalÄ± onaylanmÄ±ÅŸ Ã¶nce AyrÄ±ntÄ±lar eklenebilir',0),(393989,10945,'pl','Praca zamÃ³wienia musi zostaÄ‡ zatwierdzony przed szczegÃ³Å‚y mogÄ… byÄ‡ dodawane',0),(393990,10945,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½ Ð¿Ñ€ÐµÐ´Ð¸ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° ÑÐµ Ð´Ð¾Ð±Ð°Ð²ÑÑ‚',0),(393991,10945,'ur','ØªØ±ØªÛŒØ¨ Ú©Ø§Ù… Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’ ÛÙˆ Ø¬Ø§ Ø§Ø¶Ø§ÙÛ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ Ù‚Ø¨Ù„ ØªÙØµÛŒÙ„Ø§Øª Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(393992,10945,'sr','Ð Ð°Ð´Ð½Ð¾Ð³ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½ Ð¿Ñ€Ðµ Ð´ÐµÑ‚Ð°Ñ™Ð¸ Ð¼Ð¾Ð³Ñƒ ÑÐµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(393993,10945,'vi','Lá»‡nh pháº£i Ä‘Æ°á»£c phÃª duyá»‡t trÆ°á»›c khi thÃªm chi tiáº¿t vÃ o',0),(393994,10945,'af','Werkbestelling Moet Goedgekeur Wees, Alvorens Details Bygevoeg Kan Word.',0),(393995,10945,'ro','Activitatea comanda trebuie sÄƒ fie aprobat Ã®nainte de detalii pot fi adÄƒugate',0),(393996,10945,'et','TÃ¶Ã¶ tellimus peab olema kinnitatud enne Ã¼ksikasjad saate lisada',0),(393997,10945,'si','Delo nalog mora biti odobrena pred podrobnosti lahko doda',0),(393998,10945,'ba','Kerja Order harus disetujui sebelum rincian dapat ditambahkan',0),(393999,10945,'nl','Werk volgorde moet worden goedgekeurd voordat Details kunnen worden toegevoegd',0),(394000,10945,'fi','TyÃ¶n jÃ¤rjestyksen on oltava hyvÃ¤ksytty ennen kuin tiedot lisÃ¤tÃ¤Ã¤n',0),(394001,10945,'no','Arbeidet ordre mÃ¥ vÃ¦re godkjent fÃ¸r detaljene kan legges',0),(394002,10945,'da','Arbejde ordre skal vÃ¦re godkendt fÃ¸r detaljer kan tilfÃ¸jes',0),(394003,10945,'ko','ìž‘ì—… ìˆœì„œ ìžˆì–´ì•¼ ìŠ¹ì¸ì„ í•˜ê¸° ì „ì— ì„¸ë¶€ ì‚¬í•­ì„ ì¶”ê°€í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤',0),(394004,10945,'he','×¢×‘×•×“×” ×¡×“×¨ ×—×™×™×‘ ×œ×”×™×•×ª ×ž××•×©×¨ ×œ×¤× ×™ ×¤×¨×˜×™× × ×™×ª×Ÿ ×œ×”×•×¡×™×£',0),(394005,10945,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î¸Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸Î¿ÏÎ½',0),(394006,10945,'zh','å·¥ä½œå•å¿…é¡»å…ˆè¢«æ ¸å‡†ï¼ŒåŽæ–¹å¯æ·»åŠ è¯¦æƒ…',0),(394007,10945,'sv','Arbete ordning mÃ¥ste vara godkÃ¤nd innan detaljer kan lÃ¤ggas',0),(394008,10945,'it','Ordine di lavoro deve essere approvato prima di dettagli possono essere aggiunti',0),(394009,10945,'tl','',0),(394010,10945,'th','à¸•à¹‰à¸­à¸‡à¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™à¸ˆà¸°à¹„à¸”à¹‰à¸£à¸±à¸šà¸à¸²à¸£à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸à¹ˆà¸­à¸™à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸žà¸´à¹ˆà¸¡',0),(394011,10945,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¤¾à¤® à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥‹ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤µà¤¿à¤µà¤°à¤£ à¤œà¥‹à¤¡à¤¼à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(394012,10945,'ms','Kerja-kerja pesanan mesti diluluskan sebelum maklumat boleh ditambah',0),(394013,10945,'ar','Ø¹Ù…Ù„ \"Ø§Ù„Ù†Ø¸Ø§Ù… ÙŠØ¬Ø¨ Ø£Ù†\" ØªÙƒÙˆÙ† \"Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ù‚Ø¨Ù„ ØªÙØ§ØµÙŠÙ„ ÙŠÙ…ÙƒÙ†\" Ø¥Ø¶Ø§ÙØªÙ‡Ø§',0),(394014,10945,'fr','Ordre de travail doivent Ãªtre approuvÃ©s avant de dÃ©tails peuvent Ãªtre ajoutÃ©s',0),(394015,10945,'jp','ä½œæ¥­æ³¨æ–‡ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™è¿½åŠ ã‚’æ‰¿èªã™ã‚‹å‰ã«è©³ç´°ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™',0),(394016,10945,'pt','Ordem de trabalho deve ser aprovado antes de detalhes podem ser adicionados',0),(394017,10945,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½ Ð´Ð¾ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(394018,10945,'es','Orden de Trabajo Debe Estar Aprobado Antes que Agregar los Detalles',0),(394019,10945,'de','Arbeit Reihenfolge muÃŸ genehmigt vor Details kÃ¶nnen hinzugefÃ¼gt werden',0),(394020,10945,'en','Work Order Must be Approved Before Details Can be Added',0),(394021,10946,'is','',0),(394022,10946,'dr','Ù…Ø§Ù‡ Ù‡Ø§ ',0),(394023,10946,'pr','Ù…Ø§Ù‡ Ù‡Ø§ ',0),(394024,10946,'tr','Ay',0),(394025,10946,'pl','MiesiÄ™cy',0),(394026,10946,'bg','ÐœÐµÑÐµÑ†Ð°',0),(394027,10946,'ur','Ù…Ø§Û',0),(394028,10946,'sr','ÐœÐµÑÐµÑ†Ð¸',0),(394029,10946,'vi','ThÃ¡ng',0),(394030,10946,'af','Maande',0),(394031,10946,'ro','Luni',0),(394032,10946,'et','Kuu',0),(394033,10946,'si','Mesecev',0),(394034,10946,'ba','Bulan',0),(394035,10946,'nl','Maanden',0),(394036,10946,'fi','Kuukauden',0),(394037,10946,'no','MÃ¥neder',0),(394038,10946,'da','MÃ¥neder',0),(394039,10946,'ko','ë‹¬',0),(394040,10946,'he','×—×•×“×©×™×',0),(394041,10946,'el','ÎœÎ®Î½ÎµÏ‚',0),(394042,10946,'zh','ä¸ªæœˆ\r\n',0),(394043,10946,'sv','MÃ¥nader',0),(394044,10946,'it','Mesi',0),(394045,10946,'tl','',0),(394046,10946,'th','à¹€à¸”à¸·à¸­à¸™',0),(394047,10946,'hi','à¤®à¤¹à¥€à¤¨à¥‹à¤‚',0),(394048,10946,'ms','Bulan',0),(394049,10946,'ar','Ø£Ø´Ù‡Ø±',0),(394050,10946,'fr','Mois',0),(394051,10946,'jp','ãƒ¶æœˆ',0),(394052,10946,'pt','Meses',0),(394053,10946,'ru','ÐœÐµÑÑÑ†Ñ‹',0),(394054,10946,'es','Meses',0),(394055,10946,'de','Monate',0),(394056,10946,'en','Months',0),(394057,10947,'is','',0),(394058,10947,'dr','Ù†ÙŠÙ…Ø³Ø§Ù„ Ù‡Ø§ÙŠ ØªØ­ØµÙŠÙ„ÙŠ',0),(394059,10947,'pr','Ù†ÙŠÙ…Ø³Ø§Ù„ Ù‡Ø§ÙŠ ØªØ­ØµÙŠÙ„ÙŠ',0),(394060,10947,'tr','DÃ¶nem',0),(394061,10947,'pl','Semestry',0),(394062,10947,'bg','Ð¡ÐµÐ¼ÐµÑÑ‚ÑŠÑ€Ð°',0),(394063,10947,'ur','Ø³ÛŒÙ…ÛŒØ³Ù¹Ø±Ø³',0),(394064,10947,'sr','Ð¡ÐµÐ¼ÐµÑÑ‚Ñ€Ð°',0),(394065,10947,'vi','Há»c ká»³',0),(394066,10947,'af','Semesters',0),(394067,10947,'ro','Semestre',0),(394068,10947,'et','Semestrit',0),(394069,10947,'si','Semestrov',0),(394070,10947,'ba','Semester',0),(394071,10947,'nl','Semesters',0),(394072,10947,'fi','Lukukauden',0),(394073,10947,'no','Semestre',0),(394074,10947,'da','Semestre',0),(394075,10947,'ko','í•™ê¸°',0),(394076,10947,'he','×¡×ž×¡×˜×¨',0),(394077,10947,'el','Î•Î¾Î¬Î¼Î·Î½Î±',0),(394078,10947,'zh','å­¦æœŸ\r\n',0),(394079,10947,'sv','Terminer',0),(394080,10947,'it','Semestri',0),(394081,10947,'tl','',0),(394082,10947,'th','à¸ à¸²à¸„',0),(394083,10947,'hi','à¤›à¤ƒ à¤®à¤¾à¤¹à¥€',0),(394084,10947,'ms','Semester',0),(394085,10947,'ar','ÙØµÙˆÙ„ Ø¯Ø±Ø§Ø³ÙŠØ©',0),(394086,10947,'fr','Semestres',0),(394087,10947,'jp','å­¦æœŸ',0),(394088,10947,'pt','Semestres',0),(394089,10947,'ru','Ð¡ÐµÐ¼ÐµÑÑ‚Ñ€Ñ‹',0),(394090,10947,'es','Semstres',0),(394091,10947,'de','Semester',0),(394092,10947,'en','Semesters',0),(394093,10948,'is','',0),(394094,10948,'dr','Ù‡ÙØªÙ‡ Ù‡Ø§ ',0),(394095,10948,'pr','Ù‡ÙØªÙ‡ Ù‡Ø§ ',0),(394096,10948,'tr','Hafta',0),(394097,10948,'pl','Tygodni',0),(394098,10948,'bg','Ð¡ÐµÐ´Ð¼Ð¸Ñ†Ð¸',0),(394099,10948,'ur','ÛÙØªÙˆÚº',0),(394100,10948,'sr','ÐÐµÐ´ÐµÑ™Ð°',0),(394101,10948,'vi','Tuáº§n',0),(394102,10948,'af','Weke',0),(394103,10948,'ro','SÄƒptÄƒmÃ¢ni',0),(394104,10948,'et','NÃ¤dala',0),(394105,10948,'si','Tednov',0),(394106,10948,'ba','Minggu',0),(394107,10948,'nl','Weken',0),(394108,10948,'fi','Viikon',0),(394109,10948,'no','Uker',0),(394110,10948,'da','Uger',0),(394111,10948,'ko','ì£¼',0),(394112,10948,'he','×©×‘×•×¢×•×ª',0),(394113,10948,'el','Î•Î²Î´Î¿Î¼Î¬Î´ÎµÏ‚',0),(394114,10948,'zh','å‘¨\r\n',0),(394115,10948,'sv','Veckor',0),(394116,10948,'it','Settimane',0),(394117,10948,'tl','',0),(394118,10948,'th','à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œà¸—à¸µà¹ˆà¸œà¹ˆà¸²à¸™à¸¡à¸²',0),(394119,10948,'hi','à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(394120,10948,'ms','Minggu',0),(394121,10948,'ar','Ø£Ø³Ø§Ø¨ÙŠØ¹',0),(394122,10948,'fr','Semaines',0),(394123,10948,'jp','é€±é–“',0),(394124,10948,'pt','Semanas',0),(394125,10948,'ru','ÐÐµÐ´ÐµÐ»Ð¸',0),(394126,10948,'es','Semanas',0),(394127,10948,'de','Wochen',0),(394128,10948,'en','Weeks',0),(394129,10949,'is','',0),(394130,10949,'dr','100% Ø¯Ø± Ù…ÙˆØ¹Ø¯ Ù…Ù‚Ø±Ø±',0),(394131,10949,'pr','100% Ø¯Ø± Ù…ÙˆØ¹Ø¯ Ù…Ù‚Ø±Ø±',0),(394132,10949,'tr','% 100 olarak vade tarihi',0),(394133,10949,'pl','100% na Due Date',0),(394134,10949,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° 100 % Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶',0),(394135,10949,'ur','so fisd',0),(394136,10949,'sr','100 % Ð½Ð° ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(394137,10949,'vi','100% Ä‘áº¿n háº¡n thanh toÃ¡n',0),(394138,10949,'af','100% op Verskuldigde Datum',0),(394139,10949,'ro','Data de 100% cuvenit',0),(394140,10949,'et','100% Due Date',0),(394141,10949,'si','100 % na ustreznem datum',0),(394142,10949,'ba','100% pada jatuh tempo',0),(394143,10949,'nl','100% op Due Date',0),(394144,10949,'fi','100 % Due Date',0),(394145,10949,'no','100% pÃ¥ grunn av dato',0),(394146,10949,'da','100% pÃ¥ behÃ¸rig dato',0),(394147,10949,'ko','ë•Œë¬¸ì— 100% ë‚ ì§œ',0),(394148,10949,'he','100% ×¢×œ ×™×¢×“ ×ª××¨×™×š',0),(394149,10949,'el','100% ÏƒÏ„Î· Î´Î­Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(394150,10949,'zh','100ï¼… åˆ°æœŸæ—¥\r\n',0),(394151,10949,'sv','100% pÃ¥ fÃ¶rfallodagen',0),(394152,10949,'it','100% su Due Data',0),(394153,10949,'tl','',0),(394154,10949,'th','100% à¹ƒà¸™à¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™',0),(394155,10949,'hi','100% à¤ªà¤° à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¾à¤°à¥€à¤–',0),(394156,10949,'ms','100% pada tarikh',0),(394157,10949,'ar','Ø­ØªÙ‰ Ø§Ù„Ø¢Ù† 100% Ø¹Ù„Ù‰ Ø§Ù„ÙˆØ§Ø¬Ø¨',0),(394158,10949,'fr','100% sur Date d\'Ã‰chÃ©ance',0),(394159,10949,'jp','æ—¥ä»˜ã®ãŸã‚ã® 100%',0),(394160,10949,'pt','100% na devida Data',0),(394161,10949,'ru','100% Ð½Ð° Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð¼ Ð”Ð°Ñ‚Ð°',0),(394162,10949,'es','100% en la Fecha de Vencimiento',0),(394163,10949,'de','100 % auf Due Date',0),(394164,10949,'en','100% on Due Date',0),(394165,10950,'is','',0),(394166,10950,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡ ',0),(394167,10950,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡ ',0),(394168,10950,'tr','Kira faturalarÄ± eklemek',0),(394169,10950,'pl','Dodawanie faktury dzierÅ¼awy',0),(394170,10950,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(394171,10950,'ur','Ù„ÛŒØ² ÙˆØ¨Ø¬Ù„ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(394172,10950,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð°ÐºÑƒÐ¿ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(394173,10950,'vi','ThÃªm cho thuÃª hÃ³a Ä‘Æ¡n',0),(394174,10950,'af','Huurkontrak Fakture Byvoeg',0),(394175,10950,'ro','Adauga facturile de leasing',0),(394176,10950,'et','Lisada rendi arveid',0),(394177,10950,'si','Dodaj zakup raÄunov',0),(394178,10950,'ba','Tambahkan sewa faktur',0),(394179,10950,'nl','Lease facturen toevoegen',0),(394180,10950,'fi','Vuokrasopimuksen laskut',0),(394181,10950,'no','Legge til leie fakturaer',0),(394182,10950,'da','TilfÃ¸je Lease fakturaer',0),(394183,10950,'ko','ìž„ëŒ€ ì†¡ìž¥ ì¶”ê°€',0),(394184,10950,'he','×”×•×¡×£ ×—×©×‘×•× ×™×•×ª ×©×›×™×¨×•×ª',0),(394185,10950,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(394186,10950,'zh','å¢žåŠ ç§Ÿèµå‘ç¥¨\r\n',0),(394187,10950,'sv','LÃ¤gg till hyresavtalet fakturor',0),(394188,10950,'it','Aggiungi fatture leasing',0),(394189,10950,'tl','',0),(394190,10950,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²',0),(394191,10950,'hi','à¤²à¥€à¤œ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(394192,10950,'ms','Tambah invois pajakan',0),(394193,10950,'ar','Ø¥Ø¶Ø§ÙØ© ÙÙˆØ§ØªÙŠØ± Ø¥ÙŠØ¬Ø§Ø±',0),(394194,10950,'fr','Ajouter des factures de location',0),(394195,10950,'jp','ãƒªãƒ¼ã‚¹ã®è«‹æ±‚æ›¸ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(394196,10950,'pt','Adicionar facturas de locaÃ§Ã£o',0),(394197,10950,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð°Ñ€ÐµÐ½Ð´Ñ‹ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(394198,10950,'es','Agregar Facturas de Arendamientop',0),(394199,10950,'de','Leasing Rechnungen hinzufÃ¼gen',0),(394200,10950,'en','Add Lease Invoices',0),(394201,10951,'is','',0),(394202,10951,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø³ØªÙˆØ± Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡',0),(394203,10951,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø³ØªÙˆØ± Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡',0),(394204,10951,'tr','Kira faturalarÄ± yÃ¶nergeler ekleyin',0),(394205,10951,'pl','DodaÄ‡ instrukcje faktury dzierÅ¼awy',0),(394206,10951,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(394207,10951,'ur','Ù„ÛŒØ² ÙˆØ¨Ø¬Ù„ÛŒ ÛØ¯Ø§ÛŒØ§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(394208,10951,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð¾ Ð·Ð°ÐºÑƒÐ¿Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(394209,10951,'vi','ThÃªm xÃ¢y dá»±ng thuÃª',0),(394210,10951,'af','Huurkontrak Fakture Instruksies Byvoeg',0),(394211,10951,'ro','Adauga instrucÅ£iuni de facturile de leasing',0),(394212,10951,'et','Rendi arveid juhiste lisamine',0),(394213,10951,'si','Dodaj zakup raÄuni navodila',0),(394214,10951,'ba','Tambahkan sewa faktur petunjuk',0),(394215,10951,'nl','Lease facturen instructies toevoegen',0),(394216,10951,'fi','LisÃ¤tÃ¤ vuokrasopimuksen laskujen ohjeita',0),(394217,10951,'no','Legge til leie fakturaer instruksjoner',0),(394218,10951,'da','TilfÃ¸je Lease fakturaer instruktioner',0),(394219,10951,'ko','ìž„ëŒ€ ì†¡ìž¥ ì§€ì¹¨ ì¶”ê°€',0),(394220,10951,'he','×œ×”×•×¡×™×£ ×”×•×¨××•×ª ×—×•×–×” ×”×©×›×™×¨×•×ª ×—×©×‘×•× ×™×•×ª',0),(394221,10951,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¿Î´Î·Î³Î¯ÎµÏ‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(394222,10951,'zh','å¢žåŠ ç§Ÿèµå‘ç¥¨è¯´æ˜Ž\r\n',0),(394223,10951,'sv','LÃ¤gg till hyresavtalet fakturor instruktioner',0),(394224,10951,'it','Aggiungere istruzioni di fatture di leasing',0),(394225,10951,'tl','',0),(394226,10951,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸³à¹à¸™à¸°à¸™à¸³à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²',0),(394227,10951,'hi','à¤²à¥€à¤œ à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(394228,10951,'ms','Menambah arahan invois pajakan',0),(394229,10951,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø±Ø´Ø§Ø¯Ø§Øª ÙÙˆØ§ØªÙŠØ± Ø¥ÙŠØ¬Ø§Ø±',0),(394230,10951,'fr','Ajoutez des Instructions de factures de location',0),(394231,10951,'jp','ãƒªãƒ¼ã‚¹ã®è«‹æ±‚æ›¸ã®èª¬æ˜Žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(394232,10951,'pt','Adicionar instruÃ§Ãµes de facturas de locaÃ§Ã£o',0),(394233,10951,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ ÑÑ‡ÐµÑ‚Ð° Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(394234,10951,'es','Agregar Instrucciones de Facturas de Arrendamiento',0),(394235,10951,'de','Leasing Rechnungen Anweisungen hinzufÃ¼gen',0),(394236,10951,'en','Add Lease Invoices Instructions',0),(394237,10952,'is','',0),(394238,10952,'dr','Ù…Ø³ØªØ§Ø¬Ø± Ù…Ø´ØªØ±Ùƒ ',0),(394239,10952,'pr','Ù…Ø³ØªØ§Ø¬Ø± Ù…Ø´ØªØ±Ùƒ ',0),(394240,10952,'tr','Ortak kiracÄ±',0),(394241,10952,'pl','WspÃ³Å‚pracy najemca',0),(394242,10952,'bg','Ð¡ÑŠ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»',0),(394243,10952,'ur','Ù…Ø®Ù„ÙˆØ· Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±',0),(394244,10952,'sr','ÐšÐ¾Ð»ÐµÐ³Ð° ÑÑ‚Ð°Ð½Ð°Ñ€',0),(394245,10952,'vi','Tenant cÃ´ng ty',0),(394246,10952,'af','Mede-Huurder',0),(394247,10952,'ro','Co-chirias',0),(394248,10952,'et','KoostÃ¶Ã¶ Ã¼Ã¼rnik',0),(394249,10952,'si','Co-najemnik',0),(394250,10952,'ba','Penyewa Co',0),(394251,10952,'nl','Co huurder',0),(394252,10952,'fi','YhteistyÃ¶tÃ¤ vuokralainen',0),(394253,10952,'no','Co leietaker',0),(394254,10952,'da','Co lejer',0),(394255,10952,'ko','ê³µë™ ì„¸ ìž…ìž',0),(394256,10952,'he','×”×“×™×™×¨ ×©×•×ª×£',0),(394257,10952,'el','Î£Ï…Î½-Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(394258,10952,'zh','åˆç§Ÿ\r\n',0),(394259,10952,'sv','Co hyresgÃ¤sten',0),(394260,10952,'it','Co-inquilino',0),(394261,10952,'tl','',0),(394262,10952,'th','à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¸£à¹ˆà¸§à¸¡',0),(394263,10952,'hi','à¤¸à¤¹ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°',0),(394264,10952,'ms','Bersama penyewa',0),(394265,10952,'ar','Ù…Ø³ØªØ£Ø¬Ø±',0),(394266,10952,'fr','Colocataire',0),(394267,10952,'jp','å…±åŒãƒ†ãƒŠãƒ³ãƒˆ',0),(394268,10952,'pt','Inquilino co',0),(394269,10952,'ru','Ð¡Ð¾Ð¿Ñ€ÐµÐ´ÑÐµÐ´Ð°Ñ‚ÐµÐ»ÑŒ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð°',0),(394270,10952,'es','Coarrendatario',0),(394271,10952,'de','Co Mieter',0),(394272,10952,'en','Co-Tenant',0),(394273,10953,'is','',0),(394274,10953,'dr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡',0),(394275,10953,'pr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡',0),(394276,10953,'tr','Ä°Ã§in kira faturalarÄ± oluÅŸtur',0),(394277,10953,'pl','Tworzenie faktury za dzierÅ¼awÄ™',0),(394278,10953,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(394279,10953,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ù¾Ù¹Û’ Ù¾Ø± Ø¯ÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(394280,10953,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð·Ð° Ð·Ð°ÐºÑƒÐ¿',0),(394281,10953,'vi','táº¡o hÃ³a Ä‘Æ¡n thuÃª',0),(394282,10953,'af','Skep Fakture vir Huurkontrakte',0),(394283,10953,'ro','Crea facturile de leasing',0),(394284,10953,'et','Luua arveid Ã¼Ã¼rimine',0),(394285,10953,'si','Ustvarite raÄune za najem',0),(394286,10953,'ba','Membuat faktur untuk sewa',0),(394287,10953,'nl','Maken facturen voor Lease',0),(394288,10953,'fi','Luo laskut vuokrasopimus',0),(394289,10953,'no','Opprett fakturaer for leasing',0),(394290,10953,'da','Opret fakturaer for Lease',0),(394291,10953,'ko','ìž„ëŒ€ì— ëŒ€ í•œ ì†¡ìž¥ ìƒì„±',0),(394292,10953,'he','×™×¦×™×¨×ª ×—×©×‘×•× ×™×•×ª ×œ×”×©×›×¨×”',0),(394293,10953,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î³Î¹Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·',0),(394294,10953,'zh','åˆ›å»ºç§Ÿèµå‘ç¥¨\r\n',0),(394295,10953,'sv','Skapa fakturor fÃ¶r leasing',0),(394296,10953,'it','Creare fatture di leasing',0),(394297,10953,'tl','',0),(394298,10953,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(394299,10953,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(394300,10953,'ms','Mencipta invois bagi pajakan',0),(394301,10953,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙÙˆØ§ØªÙŠØ± Ù„Ù„ØªØ£Ø¬ÙŠØ±',0),(394302,10953,'fr','CrÃ©er des factures Ã  louer',0),(394303,10953,'jp','ãƒªãƒ¼ã‚¹ã®ãŸã‚ã®è«‹æ±‚æ›¸ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(394304,10953,'pt','Criar facturas para locaÃ§Ã£o',0),(394305,10953,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð² Ð´Ð»Ñ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(394306,10953,'es','Crear Facturas para Arrendamiento',0),(394307,10953,'de','Erstellen von Rechnungen fÃ¼r Miete',0),(394308,10953,'en','Create Invoices for Lease',0),(394309,10954,'is','',0),(394310,10954,'dr','_ Ù¾ÙŠØ´ Ø¯Ø±ÙŠØ§ÙØª',0),(394311,10954,'pr','Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯Ù‡Ø§ÙŠ Ø§Ù†ØªÙ‚Ø§Ù„ÙŠ Ø¨Ù‡ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÙŠ Ø¢ØªÙŠ _ Ù¾ÙŠØ´ Ø¯Ø±ÙŠØ§ÙØª',0),(394312,10954,'tr','Ertelenmifl gelir hesabÄ±',0),(394313,10954,'pl','Konto przychodÃ³w przyszÅ‚ych okresÃ³w',0),(394314,10954,'bg','ÐžÑ‚Ð»Ð¾Ð¶ÐµÐ½Ð¸ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(394315,10954,'ur','Ù…Ù„ØªÙˆÛŒ Ø¢Ù…Ø¯Ù†ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(394316,10954,'sr','ÐžÐ´Ð»Ð¾Ð¶ÐµÐ½Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(394317,10954,'vi','TÃ i khoáº£n táº¡m tÃ­nh doanh thu',0),(394318,10954,'af','Uitgestelde inkomste rekening',0),(394319,10954,'ro','Contul de venituri amÃ¢nate',0),(394320,10954,'et','EdasilÃ¼kkunud tulu konto',0),(394321,10954,'si','OdloÅ¾eni prihodki raÄun',0),(394322,10954,'ba','Pendapatan ditangguhkan Account',0),(394323,10954,'nl','Uitgestelde inkomstenrekening',0),(394324,10954,'fi','LykÃ¤tyn tuoton tilille',0),(394325,10954,'no','Utsatt inntektskontoen',0),(394326,10954,'da','Udskudte indtÃ¦gtskonto',0),(394327,10954,'ko','ì§€ì—° ëœ ìˆ˜ìµ ê³„ì •',0),(394328,10954,'he','×—×©×‘×•×Ÿ ×”×”×›× ×¡×•×ª ×©× ×“×—×•',0),(394329,10954,'el','Î ÏÎ¿ÎµÎ¹ÏƒÏ€ÏÎ±Ï‡Î¸Î­Î½Ï„Î± Î­ÏƒÎ¿Î´Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(394330,10954,'zh','é€’å»¶æ”¶å…¥å¸ç›®\r\n',0),(394331,10954,'sv','FÃ¶rutbetalda intÃ¤kter-konto',0),(394332,10954,'it','Risconti conto',0),(394333,10954,'tl','',0),(394334,10954,'th','à¸šà¸±à¸à¸Šà¸µà¸£à¸²à¸¢à¹„à¸”à¹‰à¸£à¸­à¸à¸²à¸£à¸•à¸±à¸”à¸šà¸±à¸à¸Šà¸µ',0),(394335,10954,'hi','à¤µà¤¿à¤²à¤‚à¤¬à¤¿à¤¤ à¤°à¤¾à¤œà¤¸à¥à¤µ à¤–à¤¾à¤¤à¥‡',0),(394336,10954,'ms','Akaun pendapatan tertunda',0),(394337,10954,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø¤Ø¬Ù„Ø©',0),(394338,10954,'fr','Compte des revenus reportÃ©s',0),(394339,10954,'jp','ç¹°å»¶åŽç›Šå‹˜å®š',0),(394340,10954,'pt','Conta de receita diferida',0),(394341,10954,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¾Ñ‚ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ð¿Ð¾ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ð¹',0),(394342,10954,'es','Cuenta de Renta Diferida',0),(394343,10954,'de','ErlÃ¶sabgrenzungskonto',0),(394344,10954,'en','Deferred Revenue Account',0),(394345,10955,'is','',0),(394346,10955,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(394347,10955,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ',0),(394348,10955,'tr','OluÅŸturmak fatura',0),(394349,10955,'pl','Generowanie faktur',0),(394350,10955,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(394351,10955,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(394352,10955,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(394353,10955,'vi','taá» cÃ¡c hÃ³a Ä‘Æ¡n',0),(394354,10955,'af','Genereer Fakture',0),(394355,10955,'ro','Facturi',0),(394356,10955,'et','Loo arved',0),(394357,10955,'si','Ustvarjanje raÄunov',0),(394358,10955,'ba','Menghasilkan faktur',0),(394359,10955,'nl','Genereren van facturen',0),(394360,10955,'fi','Luoda laskuja',0),(394361,10955,'no','Generere fakturaer',0),(394362,10955,'da','Generer fakturaer',0),(394363,10955,'ko','ì†¡ìž¥ ìƒì„±',0),(394364,10955,'he','×—×•×œ×œ ×—×©×‘×•× ×™×•×ª',0),(394365,10955,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î¤Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(394366,10955,'zh','ç”Ÿæˆå‘ç¥¨\r\n',0),(394367,10955,'sv','Generera fakturor',0),(394368,10955,'it','Generare fatture',0),(394369,10955,'tl','',0),(394370,10955,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(394371,10955,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨',0),(394372,10955,'ms','Menjana invois',0),(394373,10955,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(394374,10955,'fr','GÃ©nÃ©rer des factures',0),(394375,10955,'jp','è«‹æ±‚æ›¸ã‚’ç”Ÿæˆã—ã¾ã™ã€‚',0),(394376,10955,'pt','Gerar faturas',0),(394377,10955,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(394378,10955,'es','Generar Facturas',0),(394379,10955,'de','Rechnungen erzeugen',0),(394380,10955,'en','Generate Invoices',0),(394381,10956,'is','',0),(394382,10956,'dr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø§Ø¬Ø§Ø±Ù‡',0),(394383,10956,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø§Ø¬Ø§Ø±Ù‡',0),(394384,10956,'tr','Bu kira faturalarÄ±',0),(394385,10956,'pl','Faktury dla tej dzierÅ¼awy',0),(394386,10956,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(394387,10956,'ur','ÛŒÛ Ù„ÛŒØ² Ú©Û’ Ù„Ø¦Û’ ÙˆØ¨Ø¬Ù„ÛŒ',0),(394388,10956,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð·Ð° Ð¾Ð²Ð°Ñ˜ ÑƒÐ³Ð¾Ð²Ð¾Ñ€',0),(394389,10956,'vi','hÃ³a Ä‘Æ¡n cho viá»‡c thuÃª nÃ y',0),(394390,10956,'af','Fakture vir Hierdie Huurkontrak',0),(394391,10956,'ro','Facturile pentru acest contract de leasing',0),(394392,10956,'et','KÃ¤esoleva rendilepingu arved',0),(394393,10956,'si','RaÄuni za ta zakup',0),(394394,10956,'ba','Faktur ini disewakan',0),(394395,10956,'nl','Facturen voor deze huurovereenkomst',0),(394396,10956,'fi','Laskujen vuokrasopimuksen',0),(394397,10956,'no','Fakturaer for denne leieavtalen',0),(394398,10956,'da','Fakturaer for denne lejekontrakt',0),(394399,10956,'ko','ì´ ìž„ëŒ€ì— ëŒ€ í•œ ì²­êµ¬ì„œ',0),(394400,10956,'he','×—×©×‘×•× ×™×•×ª ×¢×‘×•×¨ ×—×•×–×” ×”×©×›×™×¨×•×ª',0),(394401,10956,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î³Î¹Î± Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÎºÎ¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·',0),(394402,10956,'zh','æœ¬ç§Ÿçº¦å‘ç¥¨\r\n',0),(394403,10956,'sv','Fakturor fÃ¶r detta hyresavtal',0),(394404,10956,'it','Fatture per questo contratto di locazione',0),(394405,10956,'tl','',0),(394406,10956,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¸™à¸µà¹‰',0),(394407,10956,'hi','à¤‡à¤¸ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(394408,10956,'ms','Invois bagi pajakan ini',0),(394409,10956,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ù„Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ù‡Ø°Ø§',0),(394410,10956,'fr','Factures pour ce contrat de location',0),(394411,10956,'jp','ã“ã®ãƒªãƒ¼ã‚¹ã®è«‹æ±‚',0),(394412,10956,'pt','Facturas para o arrendamento',0),(394413,10956,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(394414,10956,'es','Facturas para Este Arrendamiento',0),(394415,10956,'de','Rechnungen fÃ¼r diese Lease',0),(394416,10956,'en','Invoices for This Lease',0),(394417,10957,'is','',0),(394418,10957,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(394419,10957,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(394420,10957,'tr','KiralarÄ± baÅŸarÄ±yla eklendi',0),(394421,10957,'pl','PomyÅ›lnie dodano leasing',0),(394422,10957,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(394423,10957,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ Ù„ÙÛŒØ²Ø²',0),(394424,10957,'sr','Ð£Ð³Ð¾Ð²Ð¾Ñ€Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(394425,10957,'vi','Cho thuÃª thÃªm thÃ nh cÃ´ng',0),(394426,10957,'af','Huurkontrakte Suksesvol Bygevoeg',0),(394427,10957,'ro','Contracte de leasing adÄƒugat cu succes',0),(394428,10957,'et','Lisatud rent',0),(394429,10957,'si','Najemi uspeÅ¡no dodani',0),(394430,10957,'ba','Sewa ditambahkan berhasil',0),(394431,10957,'nl','Lease-overeenkomsten met succes toegevoegd',0),(394432,10957,'fi','Vuokrasopimukset lisÃ¤Ã¤minen onnistui',0),(394433,10957,'no','Lisenser lagt',0),(394434,10957,'da','LejemÃ¥l tilfÃ¸jet',0),(394435,10957,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ìž„ëŒ€',0),(394436,10957,'he','×—×›×™×¨×” × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(394437,10957,'el','ÎœÎ¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(394438,10957,'zh','ç§Ÿèµæ·»åŠ æˆåŠŸ\r\n',0),(394439,10957,'sv','Leasingavtal som lagts',0),(394440,10957,'it','Locazioni aggiunti con successo',0),(394441,10957,'tl','',0),(394442,10957,'th','à¹€à¸Šà¹ˆà¸²à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(394443,10957,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(394444,10957,'ms','Pajakan yang berjaya menambah',0),(394445,10957,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±Ø§Øª Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(394446,10957,'fr','Baux ajoutÃ© avec succÃ¨s',0),(394447,10957,'jp','ãƒªãƒ¼ã‚¹ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(394448,10957,'pt','LocaÃ§Ãµes adicionadas com sucesso',0),(394449,10957,'ru','ÐÑ€ÐµÐ½Ð´Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(394450,10957,'es','Arrendamientos Agregados Exitosamente',0),(394451,10957,'de','Lease erfolgreich hinzugefÃ¼gt',0),(394452,10957,'en','Leases Added Successfully',0),(394453,10958,'is','',0),(394454,10958,'dr','ØªØºÙŠÙŠØ± Ø§Ø¬Ø§Ø±Ù‡ ',0),(394455,10958,'pr','ØªØºÙŠÙŠØ± Ø§Ø¬Ø§Ø±Ù‡ ',0),(394456,10958,'tr','Kira giderleri',0),(394457,10958,'pl','OpÅ‚aty najmu',0),(394458,10958,'bg','Ð¢Ð°ÐºÑÐ° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(394459,10958,'ur','Ù„ÛŒØ² Ú†Ø§Ø±Ø¬',0),(394460,10958,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð¿ÑƒÑšÐµÑšÐµ',0),(394461,10958,'vi','Cho thuÃª phÃ­',0),(394462,10958,'af','Huurkontrak Heffing',0),(394463,10958,'ro','Taxa de inchiriere',0),(394464,10958,'et','Rendi tasu',0),(394465,10958,'si','StroÅ¡ek najema',0),(394466,10958,'ba','Biaya sewa',0),(394467,10958,'nl','Lease-kosten',0),(394468,10958,'fi','Vuokrasopimuksen ilmaiseksi',0),(394469,10958,'no','Leieavtalen kostnad',0),(394470,10958,'da','Lease afgift',0),(394471,10958,'ko','ìž„ëŒ€ ìš”ê¸ˆ',0),(394472,10958,'he','×ª×©×œ×•× ×©×›×™×¨×•×ª',0),(394473,10958,'el','Î”Î±Ï€Î¬Î½Î· Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(394474,10958,'zh','ç§Ÿèµè´¹\r\n',0),(394475,10958,'sv','Leasing kostnad',0),(394476,10958,'it','Carica di locazione',0),(394477,10958,'tl','',0),(394478,10958,'th','à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(394479,10958,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(394480,10958,'ms','Bayaran pajakan',0),(394481,10958,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(394482,10958,'fr','Frais de bail',0),(394483,10958,'jp','ãƒªãƒ¼ã‚¹æ–™',0),(394484,10958,'pt','Carga de locaÃ§Ã£o',0),(394485,10958,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(394486,10958,'es','Cargo de Arrendamiento',0),(394487,10958,'de','Mietvertrag kostenlos',0),(394488,10958,'en','Lease Charge',0),(394489,10959,'is','',0),(394490,10959,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(394491,10959,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(394492,10959,'tr','Kira Ã¶deme',0),(394493,10959,'pl','OpÅ‚aty leasingowe',0),(394494,10959,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð²Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(394495,10959,'ur','Ù„ÛŒØ² Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(394496,10959,'sr','ÐÐ°Ñ˜Ð°Ð¼ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(394497,10959,'vi','thanh toÃ¡n há»£p Ä‘á»“ng thuÃª',0),(394498,10959,'af','Huurkontrak Betaling',0),(394499,10959,'ro','Plata de leasing',0),(394500,10959,'et','Liisingmakse',0),(394501,10959,'si','LizinÅ¡kih plaÄil',0),(394502,10959,'ba','Pembayaran sewa',0),(394503,10959,'nl','Lease-betaling',0),(394504,10959,'fi','Leasingmaksu',0),(394505,10959,'no','Leiebetaling',0),(394506,10959,'da','Leasingforpligtelser',0),(394507,10959,'ko','ìž„ëŒ€ ì§€ë¶ˆ',0),(394508,10959,'he','×ª×©×œ×•× ×©×›×™×¨×•×ª',0),(394509,10959,'el','ÎœÎ¯ÏƒÎ¸Ï‰Î¼Î±',0),(394510,10959,'zh','ç§Ÿèµä»˜æ¬¾\r\n',0),(394511,10959,'sv','Leasingavgiften',0),(394512,10959,'it','Pagamento di locazione',0),(394513,10959,'tl','',0),(394514,10959,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²',0),(394515,10959,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(394516,10959,'ms','Bayaran pajakan',0),(394517,10959,'ar','Ø¯ÙØ¹ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(394518,10959,'fr','Paiement de location',0),(394519,10959,'jp','ãƒªãƒ¼ã‚¹ã®æ”¯æ‰•ã„',0),(394520,10959,'pt','Pagamento da locaÃ§Ã£o',0),(394521,10959,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(394522,10959,'es','Pago de Arrendamiento',0),(394523,10959,'de','Leasing-Rate',0),(394524,10959,'en','Lease Payment',0),(394525,10960,'is','',0),(394526,10960,'dr','Ù…Ø¯Øª Ø§Ø¬Ø§Ø±Ù‡',0),(394527,10960,'pr','Ù…Ø¯Øª Ø§Ø¬Ø§Ø±Ù‡',0),(394528,10960,'tr','Kira sÃ¼resi',0),(394529,10960,'pl','Leasingu',0),(394530,10960,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð²Ð¸Ñ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(394531,10960,'ur','Ù„ÛŒØ² Ú©ÛŒ Ù…Ø¯Øª',0),(394532,10960,'sr','Ð—Ð°ÐºÑƒÐ¿ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð°',0),(394533,10960,'vi','Thá»i háº¡n thuÃª',0),(394534,10960,'af','Huurkontrak Termyn',0),(394535,10960,'ro','Contract de leasing pe termen',0),(394536,10960,'et','Rendiperioodi jooksul',0),(394537,10960,'si','Najema',0),(394538,10960,'ba','Jangka waktu sewa',0),(394539,10960,'nl','Leaseperiode',0),(394540,10960,'fi','Vuokra-ajan',0),(394541,10960,'no','Leieperioden',0),(394542,10960,'da','Leasingperioden',0),(394543,10960,'ko','ìž„ëŒ€ ê¸°ê°„',0),(394544,10960,'he','×ª×§×•×¤×ª ×”×—×›×™×¨×”',0),(394545,10960,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(394546,10960,'zh','ç§Ÿèµæ¡æ¬¾\r\n',0),(394547,10960,'sv','Leasingperioden',0),(394548,10960,'it','Durata del leasing',0),(394549,10960,'tl','',0),(394550,10960,'th','à¹€à¸Šà¹ˆà¸²',0),(394551,10960,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¤¾à¤°à¥à¤¯à¤•à¤¾à¤²',0),(394552,10960,'ms','Tempoh pajakan',0),(394553,10960,'ar','Ù…Ø¯Ø© Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(394554,10960,'fr','DurÃ©e du bail',0),(394555,10960,'jp','ãƒªãƒ¼ã‚¹æœŸé–“',0),(394556,10960,'pt','Prazo da locaÃ§Ã£o',0),(394557,10960,'ru','Ð¡Ñ€Ð¾Ðº Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(394558,10960,'es','PerÃ­odo del Arrendamiento',0),(394559,10960,'de','Laufzeit des LeasingverhÃ¤ltnisses',0),(394560,10960,'en','Lease Term',0),(394561,10961,'is','',0),(394562,10961,'dr','((ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„',0),(394563,10961,'pr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ Ø¨Ù‡ Ø®Ø§Ø±Ø¬ ((ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„',0),(394564,10961,'tr','TaÅŸÄ±nmak',0),(394565,10961,'pl','WyprowadziÄ‡',0),(394566,10961,'bg','Ð˜Ð·Ð½ÐµÑÐ°Ñ‚',0),(394567,10961,'ur','Ù…Ù†ØªÙ‚Ù„',0),(394568,10961,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚',0),(394569,10961,'vi','chuyá»ƒn ra',0),(394570,10961,'af','Trek uit',0),(394571,10961,'ro','Muta',0),(394572,10961,'et','Kolima',0),(394573,10961,'si','Izseliti',0),(394574,10961,'ba','Pindah',0),(394575,10961,'nl','Verhuizen',0),(394576,10961,'fi','SiirrÃ¤ ulos',0),(394577,10961,'no','Flytte ut',0),(394578,10961,'da','Flytte',0),(394579,10961,'ko','ë°–ìœ¼ë¡œ ì´ë™',0),(394580,10961,'he','×–×•×–×•',0),(394581,10961,'el','Î‘Ï€Î¿Î¼Î±ÎºÏÏ…Î½Î¸ÎµÎ¯Ï„Îµ Î±Ï€ÏŒ',0),(394582,10961,'zh','è¿å‡º\r\n',0),(394583,10961,'sv','Flytta ut',0),(394584,10961,'it','Spostare',0),(394585,10961,'tl','',0),(394586,10961,'th','à¸¢à¹‰à¸²à¸¢à¸­à¸­à¸',0),(394587,10961,'hi','à¤²à¥‡ à¤œà¤¾à¤à¤',0),(394588,10961,'ms','Alih',0),(394589,10961,'ar','Ø§Ù„Ø®Ø±ÙˆØ¬',0),(394590,10961,'fr','On doit Ã©carter',0),(394591,10961,'jp','å¤–ã«ç§»å‹•ã—ã¾ã™ã€‚',0),(394592,10961,'pt','Mover para fora',0),(394593,10961,'ru','Ð’Ñ‹Ð¹Ñ‚Ð¸',0),(394594,10961,'es','Mudarse',0),(394595,10961,'de','Ausziehen',0),(394596,10961,'en','Move Out',0),(394597,10962,'is','',0),(394598,10962,'dr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ø§Ø¬Ø§Ø±Ù‡ Ø§ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(394599,10962,'pr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ø§Ø¬Ø§Ø±Ù‡ Ø§ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(394600,10962,'tr','Kira kimliÄŸi ayarla',0),(394601,10962,'pl','Brak identyfikatora dzierÅ¼awy jest zestaw',0),(394602,10962,'bg','ÐÑÐ¼Ð° Ð˜Ð” Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐ½',0),(394603,10962,'ur','Ù„ÛŒØ² Ú©ÛŒ Ú©ÙˆØ¦ÛŒ Ø´Ù†Ø§Ø®Øª Ù…Ù‚Ø±Ø± Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(394604,10962,'sr','ÐÐµÐ¼Ð° Ð·Ð°ÐºÑƒÐ¿ Ð˜Ð” Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(394605,10962,'vi','khÃ´ng táº­p há»£p ID há»£p Ä‘á»“ng thuÃª',0),(394606,10962,'af','Geen Huurkontrak ID is Opgestel.',0),(394607,10962,'ro','Nici un ID de leasing este setat',0),(394608,10962,'et','ÃœÃ¼rilepingu ID on seatud',0),(394609,10962,'si','Ni zakup ID nastavljena',0),(394610,10962,'ba','Ada sewa ID terletak',0),(394611,10962,'nl','Geen Lease-ID Is ingesteld',0),(394612,10962,'fi','Ei ole vuokrasopimuksen tunnusta ei mÃ¤Ã¤ritetty',0),(394613,10962,'no','Ingen Lease-ID er angitt',0),(394614,10962,'da','Ingen leasing-ID er angivet',0),(394615,10962,'ko','ìž„ëŒ€ ID ì„¤ì •',0),(394616,10962,'he','×ž×–×”×” ×—×•×–×” ×©×›×™×¨×•×ª ×œ× ×ž×•×’×“×¨',0),(394617,10962,'el','Î§Ï‰ÏÎ¯Ï‚ Ï„Î±Ï…Ï„ÏŒÏ„Î·Ï„Î± Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(394618,10962,'zh','æœªè®¾ç½®ç§Ÿçº¦èº«ä»½è¯\r\n',0),(394619,10962,'sv','Inget Lease-ID har angetts',0),(394620,10962,'it','Nessun ID Lease Ã¨ impostato',0),(394621,10962,'tl','',0),(394622,10962,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸«à¸±à¸ªà¹€à¸Šà¹ˆà¸²à¹„à¸§à¹‰',0),(394623,10962,'hi','à¤•à¥‹à¤ˆ à¤ªà¤Ÿà¥à¤Ÿà¤¾ ID à¤¸à¥‡à¤Ÿ à¤¹à¥ˆ',0),(394624,10962,'ms','ID pajakan tidak disetkan',0),(394625,10962,'ar','ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ø¹Ø±Ù Ù„Ø§ Ø¹Ù‚Ø¯ Ø¥ÙŠØ¬Ø§Ø±',0),(394626,10962,'fr','Aucun ID de bail n\'a',0),(394627,10962,'jp','ãƒªãƒ¼ã‚¹ ID ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(394628,10962,'pt','Sem identificaÃ§Ã£o de locaÃ§Ã£o Ã© definida',0),(394629,10962,'ru','ÐÑ€ÐµÐ½Ð´Ð° ID Ð¸Ð¼ÐµÐµÑ‚ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(394630,10962,'es','NingÃºn ID de Arrendamiento se Configura',0),(394631,10962,'de','Keine Lease-ID wird festgelegt',0),(394632,10962,'en','No Lease ID Is Set',0),(394633,10963,'is','',0),(394634,10963,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³Ø±Ø´ÙƒÙ† Ø´Ø¯Ù‡ ',0),(394635,10963,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³Ø±Ø´ÙƒÙ† Ø´Ø¯Ù‡ ',0),(394636,10963,'tr','EÅŸit daÄŸÄ±tÄ±lmÄ±ÅŸ tutarÄ±',0),(394637,10963,'pl','Proporcjonalna',0),(394638,10963,'bg','Ð Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸ ÑÑƒÐ¼Ð°',0),(394639,10963,'ur','Ù¾Ø±ÙˆØ±ÛŒÙ¹Ø¯ Ù…Ù‚Ø¯Ø§Ø±',0),(394640,10963,'sr','ÐŸÑ€Ð¾Ð¿Ð¾Ñ€Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(394641,10963,'vi','sá»‘ tá»· lá»‡',0),(394642,10963,'af','Verdeelde Bedrag',0),(394643,10963,'ro','ProporÅ£ie suma',0),(394644,10963,'et','Ãœhtlase suuruse',0),(394645,10963,'si','Proporcionalni znesek',0),(394646,10963,'ba','Jumlah prorata',0),(394647,10963,'nl','Pro rata bedrag',0),(394648,10963,'fi','Jaettu summa',0),(394649,10963,'no','Proporsjonalt fordelt belÃ¸p',0),(394650,10963,'da','ForholdsmÃ¦ssige belÃ¸b',0),(394651,10963,'ko','ë°°ë¶„ëœ ê¸ˆì•¡',0),(394652,10963,'he','×›×ž×•×ª ×ž×¦×˜×‘×¨×•×ª',0),(394653,10963,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹Î¶ÏŒÎ¼ÎµÎ½Î· Ï€Î¿ÏƒÏŒ',0),(394654,10963,'zh','æŒ‰æ¯”ä¾‹åˆ†æ‘Šé¢\r\n',0),(394655,10963,'sv','Proportionellt fÃ¶rdelat belopp',0),(394656,10963,'it','Importo proporzionale',0),(394657,10963,'tl','',0),(394658,10963,'th','à¸ªà¸±à¸”',0),(394659,10963,'hi','Prorated à¤°à¤¾à¤¶à¤¿',0),(394660,10963,'ms','Jumlah yang pro-rata',0),(394661,10963,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„ØªÙ†Ø§Ø³Ø¨ÙŠØ©',0),(394662,10963,'fr','Montant calculÃ© au prorata',0),(394663,10963,'jp','æ—¥å‰²ã‚Šé¡',0),(394664,10963,'pt','Montante rateado',0),(394665,10963,'ru','ÐŸÑ€Ð¾Ð¿Ð¾Ñ€Ñ†Ð¸Ð¾Ð½Ð°Ð»ÑŒÐ½Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(394666,10963,'es','Monto Prorrateado',0),(394667,10963,'de','Anteilige Betrag',0),(394668,10963,'en','Prorated Amount',0),(394669,10964,'is','',0),(394670,10964,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø³Ø±Ø´ÙƒÙ† Ø´Ø¯Ù‡',0),(394671,10964,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø³Ø±Ø´ÙƒÙ† Ø´Ø¯Ù‡',0),(394672,10964,'tr','Hesaplanarak kira',0),(394673,10964,'pl','Proporcjonalnego Wynajem',0),(394674,10964,'bg','ÐŸÑ€Ð¾Ð¿Ð¾Ñ€Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð° Ð½Ð°ÐµÐ¼',0),(394675,10964,'ur','Ù¾Ø±ÙˆØ±ÛŒÙ¹Ø¯ Ú©Ø±Ø§Ø¦Û’',0),(394676,10964,'sr','ÐŸÑ€Ð¾Ð¿Ð¾Ñ€Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð° ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ñƒ',0),(394677,10964,'vi','tá»· lá»‡ thuÃª',0),(394678,10964,'af','Verdeelde Huurgeld',0),(394679,10964,'ro','ProporÅ£ie chirie',0),(394680,10964,'et','Soetatakse Rent',0),(394681,10964,'si','Proporcionalni najemnine',0),(394682,10964,'ba','Prorata Disewa',0),(394683,10964,'nl','Pro rata te huur',0),(394684,10964,'fi','Jaettu vuokrattavana',0),(394685,10964,'no','Fordelte leie',0),(394686,10964,'da','ForholdsmÃ¦ssig leje',0),(394687,10964,'ko','ìž„ëŒ€ í• ë‹¹ëœ',0),(394688,10964,'he','×”×©×›×¨×” ×ž×¦×˜×‘×¨×•×ª',0),(394689,10964,'el','Î‘Î½Î±Î»Î¿Î³Î¿ÏÏƒÎ± ÎµÎ½Î¿Î¹ÎºÎ¯Î±ÏƒÎ·',0),(394690,10964,'zh','æŒ‰æ¯”ä¾‹åˆ†é…ç§Ÿé‡‘\r\n',0),(394691,10964,'sv','Proportionellt hyra',0),(394692,10964,'it','Affitto rateizzato',0),(394693,10964,'tl','',0),(394694,10964,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²à¸ªà¸´à¸™à¸—à¸£à¸±à¸žà¸¢à¹Œà¹à¸šà¹ˆà¸‡à¸•à¸²à¸¡à¸ªà¹ˆà¸§à¸™',0),(394695,10964,'hi','Prorated à¤¬à¤¾à¤‡à¤• à¤•à¤¿à¤°à¤¾à¤',0),(394696,10964,'ms','Pro-rata sewa',0),(394697,10964,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„ØªÙ†Ø§Ø³Ø¨ÙŠØ©',0),(394698,10964,'fr','Loyer au prorata',0),(394699,10964,'jp','æ—¥å‰²ã‚Šå®¶è³ƒ',0),(394700,10964,'pt','Aluguel proporcional',0),(394701,10964,'ru','ÐŸÑ€Ð¾Ð¿Ð¾Ñ€Ñ†Ð¸Ð¾Ð½Ð°Ð»ÑŒÐ½Ð¾ ÐÑ€ÐµÐ½Ð´Ð°',0),(394702,10964,'es','Renta Prorrateada',0),(394703,10964,'de','Anteilige Miete',0),(394704,10964,'en','Prorated Rent',0),(394705,10965,'is','',0),(394706,10965,'dr','ØªÙƒØ±Ø§Ø± Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯ÙˆÙ… ',0),(394707,10965,'pr','ØªÙƒØ±Ø§Ø± Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯ÙˆÙ… ',0),(394708,10965,'tr','Ä°kinci Ã¶deme iÃ§in tekrarlanan',0),(394709,10965,'pl','Powtarzane dla drugiej pÅ‚atnoÅ›ci',0),(394710,10965,'bg','ÐŸÐ¾Ð²Ñ‚Ð°Ñ€Ñ Ð·Ð° Ð²Ñ‚Ð¾Ñ€Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(394711,10965,'ur','Ø¯ÙˆØ³Ø±ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø¨Ø§Ø± Ø¨Ø§Ø±',0),(394712,10965,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¸Ñ‚Ð¸ Ð·Ð° Ð´Ñ€ÑƒÐ³Ð¸ Ð´Ð¸Ð¾ Ð¸ÑÐ¿Ð»Ð°Ñ‚Ðµ',0),(394713,10965,'vi','láº·p láº¡i láº§n thanh toÃ¡n thá»© 2',0),(394714,10965,'af','Herhaal vir Tweede Betaling',0),(394715,10965,'ro','Repetate pentru a doua platÄƒ',0),(394716,10965,'et','Korrata teist makset',0),(394717,10965,'si','Ponovi za drugo plaÄilo',0),(394718,10965,'ba','Diulang untuk kedua pembayaran',0),(394719,10965,'nl','Herhaald voor tweede betaling',0),(394720,10965,'fi','Toistetaan toinen maksu',0),(394721,10965,'no','Gjentatt for andre betaling',0),(394722,10965,'da','Gentages for anden betaling',0),(394723,10965,'ko','ë‘ ë²ˆì§¸ ì§€ë¶ˆì— ëŒ€ í•œ ë°˜ë³µ',0),(394724,10965,'he','×—×•×–×¨ ×¢×œ ×¢×¦×ž×• ×¢×‘×•×¨ ×ª×©×œ×•× ×©× ×™',0),(394725,10965,'el','Î•Ï€Î±Î½Î­Î»Î±Î²Îµ Î³Î¹Î± Î´ÎµÏÏ„ÎµÏÎ· Ï€Î»Î·ÏÏ‰Î¼Î®',0),(394726,10965,'zh','é‡å¤ç¬¬äºŒç¬”ä»˜æ¬¾\r\n',0),(394727,10965,'sv','Upprepas fÃ¶r andra betalning',0),(394728,10965,'it','Ripetuta per il secondo pagamento',0),(394729,10965,'tl','',0),(394730,10965,'th','à¸—à¸³à¸‹à¹‰à¸³à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸ªà¸­à¸‡',0),(394731,10965,'hi','à¤¦à¥‚à¤¸à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¥‹à¤¹à¤°à¤¾à¤¯à¤¾',0),(394732,10965,'ms','Diulang bagi bayaran kedua',0),(394733,10965,'ar','ÙˆÙƒØ±Ø± Ù„ØªØ³Ø¯ÙŠØ¯ Ø§Ù„Ø¯ÙØ¹Ø© Ø§Ù„Ø«Ø§Ù†ÙŠØ©',0),(394734,10965,'fr','RÃ©pÃ©tÃ©e pour le deuxiÃ¨me versement',0),(394735,10965,'jp','ç¬¬äºŒã®æ”¯æ‰•ã„ã«å¯¾ã—ã¦ç¹°ã‚Šè¿”ã•ã‚Œã¾ã™',0),(394736,10965,'pt','Repetido para o segundo pagamento',0),(394737,10965,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÐµÑ‚ÑÑ Ð´Ð»Ñ Ð²Ñ‚Ð¾Ñ€Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(394738,10965,'es','Repetido Para el Segundo Pago',0),(394739,10965,'de','FÃ¼r die zweite Zahlung wiederholt',0),(394740,10965,'en','Repeated for Second Payment',0),(394741,10966,'is','',0),(394742,10966,'dr','( Ø±Ø²Ø±Ùˆ',0),(394743,10966,'pr','Ø­Ø³Ø§Ø¨ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø°Ø®ÙŠØ±Ù‡( Ø±Ø²Ø±Ùˆ',0),(394744,10966,'tr','Rezervasyon Ã¼creti hesabÄ±',0),(394745,10966,'pl','Rezerwacji opÅ‚ata za konto',0),(394746,10966,'bg','Ð ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ Ñ‚Ð°ÐºÑÐ° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(394747,10966,'ur','Ø¨Ú©Ù†Ú¯ ÙÛŒØ³ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(394748,10966,'sr','Ð ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ˜Ð° Ð½Ð°ÐºÐ½Ð°Ð´Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(394749,10966,'vi','tÃ i khoáº£n phÃ­ Ä‘áº·t trÆ°á»›c',0),(394750,10966,'af','Besprekingsfooi Rekening',0),(394751,10966,'ro','Cont de taxa de rezervare',0),(394752,10966,'et','Broneeringu tasu konto',0),(394753,10966,'si','Rezervacijo pristojbino raÄun',0),(394754,10966,'ba','Rekening biaya reservasi',0),(394755,10966,'nl','Reservering vergoeding rekening',0),(394756,10966,'fi','Varaus lisÃ¤maksun tili',0),(394757,10966,'no','Reservasjon gebyr konto',0),(394758,10966,'da','Reservation gebyr konto',0),(394759,10966,'ko','ì˜ˆì•½ ìˆ˜ìˆ˜ë£Œ ê³„ì •',0),(394760,10966,'he','×—×©×‘×•×Ÿ ×“×ž×™ ×”×–×ž× ×”',0),(394761,10966,'el','ÎšÏÎ¬Ï„Î·ÏƒÎ· Î±Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î±Î¼Î¿Î¹Î²ÏŽÎ½',0),(394762,10966,'zh','é¢„è®¢è´¹ç”¨å¸æˆ·\r\n',0),(394763,10966,'sv','Bokning Avgiftskontots',0),(394764,10966,'it','Conto di tassa di prenotazione',0),(394765,10966,'tl','',0),(394766,10966,'th','à¸šà¸±à¸à¸Šà¸µà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸ˆà¸­à¸‡',0),(394767,10966,'hi','à¤†à¤°à¤•à¥à¤·à¤£ à¤¶à¥à¤²à¥à¤• à¤–à¤¾à¤¤à¤¾',0),(394768,10966,'ms','Akaun yuran tempahan',0),(394769,10966,'ar','Ø­Ø³Ø§Ø¨ Ø±Ø³ÙˆÙ… Ø§Ù„Ø­Ø¬Ø²',0),(394770,10966,'fr','Compte de frais de rÃ©servation',0),(394771,10966,'jp','äºˆç´„æ–™ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(394772,10966,'pt','Conta de taxa de reserva',0),(394773,10966,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° ÑÑ‡ÐµÑ‚ Ð±Ñ€Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(394774,10966,'es','Cuenta de Cuota para ReservaciÃ³n',0),(394775,10966,'de','Reservierung GebÃ¼hrenkonto',0),(394776,10966,'en','Reservation Fee Account',0),(394777,10967,'is','',0),(394778,10967,'dr','Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯',0),(394779,10967,'pr','Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯',0),(394780,10967,'tr','Gelir hesabÄ±',0),(394781,10967,'pl','Konto przychodÃ³w',0),(394782,10967,'bg','ÐŸÑ€Ð¸Ñ…Ð¾Ð´Ð½Ð°Ñ‚Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(394783,10967,'ur','Ø±ÛŒÙˆÛŒÙ†ÛŒÙˆ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(394784,10967,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(394785,10967,'vi','tÃ i khoáº£n doanh thu',0),(394786,10967,'af','Inkomste Rekening',0),(394787,10967,'ro','Contul de venituri',0),(394788,10967,'et','Tulude konto',0),(394789,10967,'si','RaÄun prihodkov',0),(394790,10967,'ba','Rekening pendapatan',0),(394791,10967,'nl','Inkomstenrekening',0),(394792,10967,'fi','Tuottotili',0),(394793,10967,'no','Inntektskontoen',0),(394794,10967,'da','OmsÃ¦tningskonto',0),(394795,10967,'ko','ìˆ˜ìµ ê³„ì •',0),(394796,10967,'he','×—×©×‘×•×Ÿ ×”×›× ×¡×•×ª',0),(394797,10967,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÎµÏƒÏŒÎ´Ï‰Î½',0),(394798,10967,'zh','æ”¶å…¥å¸\r\n',0),(394799,10967,'sv','IntÃ¤ktskonto',0),(394800,10967,'it','Conto ricavi',0),(394801,10967,'tl','',0),(394802,10967,'th','à¸šà¸±à¸à¸Šà¸µà¸£à¸²à¸¢à¹„à¸”à¹‰',0),(394803,10967,'hi','à¤°à¤¾à¤œà¤¸à¥à¤µ à¤–à¤¾à¤¤à¥‡',0),(394804,10967,'ms','Akaun pendapatan',0),(394805,10967,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª',0),(394806,10967,'fr','Compte des recettes',0),(394807,10967,'jp','åŽç›Šå‹˜å®š',0),(394808,10967,'pt','Conta de receita',0),(394809,10967,'ru','Ð¡Ñ‡ÐµÑ‚ Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð²',0),(394810,10967,'es','Cuenta de Ingresos',0),(394811,10967,'de','Ertragskonto',0),(394812,10967,'en','Revenue Account',0),(394813,10968,'is','',0),(394814,10968,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø§Ø¬Ø§Ø±Ù‡ ',0),(394815,10968,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø§Ø¬Ø§Ø±Ù‡ ',0),(394816,10968,'tr','Ä°nceleme kira',0),(394817,10968,'pl','PrzeglÄ…d umowy najmu',0),(394818,10968,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(394819,10968,'ur','Ù„ÛŒØ² Ú©Ø§ Ø¬Ø§Ø¦Ø²Û',0),(394820,10968,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð·Ð°ÐºÑƒÐ¿',0),(394821,10968,'vi','Xem xÃ©t cho thuÃª',0),(394822,10968,'af','Hersiening huurkontrak',0),(394823,10968,'ro','Recenzie de leasing',0),(394824,10968,'et','Ãœlevaade Ã¼Ã¼rileping',0),(394825,10968,'si','Pregled najema',0),(394826,10968,'ba','Sewa Tinjauan',0),(394827,10968,'nl','Beoordeling Lease',0),(394828,10968,'fi','Uudelleen vuokrasopimus',0),(394829,10968,'no','Gjennomgang Lease',0),(394830,10968,'da','Anmeldelse Lease',0),(394831,10968,'ko','ê²€í†  ìž„ëŒ€',0),(394832,10968,'he','×¡×§×™×¨×” ×—×›×™×¨×”',0),(394833,10968,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(394834,10968,'zh','å®¡æŸ¥ç§Ÿèµ\r\n',0),(394835,10968,'sv','Recension Lease',0),(394836,10968,'it','Recensione Lease',0),(394837,10968,'tl','',0),(394838,10968,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(394839,10968,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¥‡ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(394840,10968,'ms','Kajian pajakan',0),(394841,10968,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ø¹Ù‚Ø¯ Ø¥ÙŠØ¬Ø§Ø±',0),(394842,10968,'fr','Examen bail',0),(394843,10968,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼ ãƒªãƒ¼ã‚¹',0),(394844,10968,'pt','LocaÃ§Ã£o de revisÃ£o',0),(394845,10968,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(394846,10968,'es','Revisar Arrendamiento',0),(394847,10968,'de','ÃœberprÃ¼fung Mietvertrag',0),(394848,10968,'en','Review Lease',0),(394849,10969,'is','',0),(394850,10969,'dr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ ÙÙ‡Ø±Ø³Øª Ø´Ø¯Ù‡ ',0),(394851,10969,'pr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ ÙÙ‡Ø±Ø³Øª Ø´Ø¯Ù‡ ',0),(394852,10969,'tr','ZamanlanmÄ±ÅŸ faturalar',0),(394853,10969,'pl','Zaplanowane faktur',0),(394854,10969,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(394855,10969,'ur','Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ ÙˆØ¨Ø¬Ù„ÛŒ',0),(394856,10969,'sr','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð°Ð½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(394857,10969,'vi','Theo lá»‹ch trÃ¬nh hÃ³a Ä‘Æ¡n',0),(394858,10969,'af','Geskeduleerde Fakture',0),(394859,10969,'ro','Facturile programate',0),(394860,10969,'et','Planeeritud arved',0),(394861,10969,'si','Seznama raÄunov',0),(394862,10969,'ba','Dijadwalkan faktur',0),(394863,10969,'nl','Geplande facturen',0),(394864,10969,'fi','Ajoitettu laskut',0),(394865,10969,'no','Planlagte fakturaer',0),(394866,10969,'da','Planlagte fakturaer',0),(394867,10969,'ko','ì˜ˆì•½ ëœ ì²­êµ¬ì„œ',0),(394868,10969,'he','×—×©×‘×•× ×™×•×ª ×ž×ª×•×–×ž× ×ª',0),(394869,10969,'el','Î ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÎ¼Î­Î½Î· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(394870,10969,'zh','é™„åŠ å‘ç¥¨\r\n',0),(394871,10969,'sv','Planerade fakturor',0),(394872,10969,'it','Fatture pianificate',0),(394873,10969,'tl','',0),(394874,10969,'th','à¸à¸³à¸«à¸™à¸”à¸à¸²à¸£à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(394875,10969,'hi','à¤¶à¥‡à¤¡à¥à¤¯à¥‚à¤² à¤•à¤¿à¤ à¤—à¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(394876,10969,'ms','Invois yang dijadualkan',0),(394877,10969,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø¬Ø¯ÙˆÙ„Ø©',0),(394878,10969,'fr','Factures rÃ©guliers',0),(394879,10969,'jp','ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ«ã•ã‚ŒãŸè«‹æ±‚æ›¸',0),(394880,10969,'pt','Faturas regulares',0),(394881,10969,'ru','Ð ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(394882,10969,'es','Facturas Programadas',0),(394883,10969,'de','Geplante Rechnungen',0),(394884,10969,'en','Scheduled Invoices',0),(394885,10970,'is','',0),(394886,10970,'dr','Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø±',0),(394887,10970,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø±',0),(394888,10970,'tr','GÃ¼venlik KasasÄ±',0),(394889,10970,'pl','Depozyt zabezpieczajÄ…cy',0),(394890,10970,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚-Ð³Ð°Ñ€Ð°Ð½Ñ†Ð¸Ñ',0),(394891,10970,'ur','Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ ÚˆÙ¾Ø§Ø²Ù¹',0),(394892,10970,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¾ÑÐ½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(394893,10970,'vi','Tiá»n cá»c an ninh',0),(394894,10970,'af','Sekuriteit deposito',0),(394895,10970,'ro','Depozit de securitate',0),(394896,10970,'et','Tagatisraha',0),(394897,10970,'si','VarÅ¡Äine',0),(394898,10970,'ba','Jaminan',0),(394899,10970,'nl','Borg',0),(394900,10970,'fi','Pantti',0),(394901,10970,'no','Depositum',0),(394902,10970,'da','Sikkerhedsdepositum',0),(394903,10970,'ko','ë³´ì¦ê¸ˆ',0),(394904,10970,'he','×¤×™×§×“×•×Ÿ',0),(394905,10970,'el','Î ÏÎ¿ÎºÎ±Ï„Î±Î²Î¿Î»Î®',0),(394906,10970,'zh','ä¿è¯é‡‘\r\n',0),(394907,10970,'sv','Deposition',0),(394908,10970,'it','Deposito cauzionale',0),(394909,10970,'tl','',0),(394910,10970,'th','à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸„à¸§à¸²à¸¡à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢',0),(394911,10970,'hi','à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤œà¤®à¤¾ à¤°à¤¾à¤¶à¤¿',0),(394912,10970,'ms','Deposit sekuriti',0),(394913,10970,'ar','Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø£Ù…Ù†',0),(394914,10970,'fr','DÃ©pÃ´t de garantie',0),(394915,10970,'jp','ä¿è¨¼é‡‘',0),(394916,10970,'pt','DepÃ³sito de seguranÃ§a',0),(394917,10970,'ru','Ð—Ð°Ð»Ð¾Ð³',0),(394918,10970,'es','DepÃ³sito de Seguridad',0),(394919,10970,'de','Kaution',0),(394920,10970,'en','Security Deposit',0),(394921,10971,'is','',0),(394922,10971,'dr','Ø­Ø³Ø§Ø¨ Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø±',0),(394923,10971,'pr','Ø­Ø³Ø§Ø¨ Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø±',0),(394924,10971,'tr','GÃ¼venlik Mevduat hesabÄ±',0),(394925,10971,'pl','BezpieczeÅ„stwa wpÅ‚acie na konto:',0),(394926,10971,'bg','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(394927,10971,'ur','Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ ÚˆÙ¾Ø§Ø²Ù¹ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹',0),(394928,10971,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð±ÐµÐ·Ð±ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(394929,10971,'vi','TÃ i khoáº£n tiá»n cá»c an ninh',0),(394930,10971,'af','Sekuriteit deposito rekening',0),(394931,10971,'ro','Cont de depozit de securitate',0),(394932,10971,'et','Turvalisuse jooksevkonto',0),(394933,10971,'si','Varnost Å¾iro raÄun',0),(394934,10971,'ba','Rekening Deposito Keamanan',0),(394935,10971,'nl','Security deposito-rekeningen',0),(394936,10971,'fi','Turvallisuus talletustili',0),(394937,10971,'no','Sikkerhet innskudd konto',0),(394938,10971,'da','Sikkerhed Depositum konto',0),(394939,10971,'ko','ë³´ì•ˆ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(394940,10971,'he','×—×©×‘×•×Ÿ ×¤×™×§×“×•×Ÿ ×”××‘×˜×—×”',0),(394941,10971,'el','Î‘ÏƒÏ†Î¬Î»ÎµÎ¹Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(394942,10971,'zh','é“¶è¡Œä¿è¯é‡‘å¸å·\r\n',0),(394943,10971,'sv','SÃ¤kerhetskonto',0),(394944,10971,'it','Conto di deposito di sicurezza',0),(394945,10971,'tl','',0),(394946,10971,'th','à¸šà¸±à¸à¸Šà¸µà¹€à¸‡à¸´à¸™à¸à¸²à¸à¸‚à¸­à¸‡à¸£à¸±à¸à¸©à¸²à¸„à¸§à¸²à¸¡à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢',0),(394947,10971,'hi','à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤œà¤®à¤¾ à¤–à¤¾à¤¤à¤¾',0),(394948,10971,'ms','Akaun Deposit sekuriti',0),(394949,10971,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ø£Ù…Ù†',0),(394950,10971,'fr','Compte de dÃ©pÃ´t de sÃ©curitÃ©',0),(394951,10971,'jp','ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£é é‡‘å£åº§',0),(394952,10971,'pt','Conta de depÃ³sito de seguranÃ§a',0),(394953,10971,'ru','Ð‘ÐµÐ·Ð¾Ð¿Ð°ÑÐ½Ð¾ÑÑ‚Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(394954,10971,'es','DepÃ³sito de Seguridad Monto',0),(394955,10971,'de','Security Deposit-Konto',0),(394956,10971,'en','Security Deposit Account',0),(394957,10972,'is','',0),(394958,10972,'dr','Ù†ÙˆØ¹ Ø´Ø±Ø· ',0),(394959,10972,'pr','Ù†ÙˆØ¹ Ø´Ø±Ø· ',0),(394960,10972,'tr','DÃ¶nem tÃ¼rÃ¼',0),(394961,10972,'pl','OkreÅ›lenie typu',0),(394962,10972,'bg','Ð¢ÐµÑ€Ð¼Ð¸Ð½ÑŠÑ‚ Ñ‚Ð¸Ð¿',0),(394963,10972,'ur','Ø§ØµØ·Ù„Ø§Ø­ Ú©ÛŒ Ù‚Ø³Ù…',0),(394964,10972,'sr','Ð˜Ð·Ñ€Ð°Ð· Ñ‚Ð¸Ð¿Ð°',0),(394965,10972,'vi','Loáº¡i ká»³ háº¡n',0),(394966,10972,'af','Termyn Tipe',0),(394967,10972,'ro','Termenul de tip',0),(394968,10972,'et','Aja liik',0),(394969,10972,'si','Izraz tip',0),(394970,10972,'ba','Jenis istilah',0),(394971,10972,'nl','Termijn Type',0),(394972,10972,'fi','AikavÃ¤lin tyyppi',0),(394973,10972,'no','Terminaltype',0),(394974,10972,'da','Terminaltype',0),(394975,10972,'ko','ìš©ì–´ ìœ í˜•',0),(394976,10972,'he','×”×ž×•× ×— ×¡×•×’',0),(394977,10972,'el','ÎŒÏÎ¿Ï‚ Ï„ÏÏ€Î¿Ï…',0),(394978,10972,'zh','æ¡æ¬¾ç±»åž‹\r\n',0),(394979,10972,'sv','Terminaltyp',0),(394980,10972,'it','Tipo di termine',0),(394981,10972,'tl','',0),(394982,10972,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸„à¸³',0),(394983,10972,'hi','à¤…à¤µà¤§à¤¿ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(394984,10972,'ms','Jenis jangka',0),(394985,10972,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù…ØµØ·Ù„Ø­',0),(394986,10972,'fr','Type de l\'expression',0),(394987,10972,'jp','ç”¨èªžã®ç¨®é¡ž',0),(394988,10972,'pt','Tipo de termo',0),(394989,10972,'ru','Ð¢ÐµÑ€Ð¼Ð¸Ð½ Ñ‚Ð¸Ð¿',0),(394990,10972,'es','Tipo de PerÃ­odo',0),(394991,10972,'de','Bezeichnung Typ',0),(394992,10972,'en','Term Type',0),(394993,10973,'is','',0),(394994,10973,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡ ',0),(394995,10973,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡ ',0),(394996,10973,'tr','Toplam kira Ã¶demeleri',0),(394997,10973,'pl','CaÅ‚kowita leasingowych',0),(394998,10973,'bg','ÐžÐ±Ñ‰Ð¾ Ð»Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(394999,10973,'ur','Ú©Ù„ Ù„ÛŒØ² Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(395000,10973,'sr','Ð£ÐºÑƒÐ¿Ð°Ð½ Ð½Ð°Ñ˜Ð°Ð¼ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(395001,10973,'vi','Tá»•ng cá»™ng cÃ¡c khoáº£n thanh toÃ¡n tiá»n thuÃª',0),(395002,10973,'af','Totale Verhuring Betalings',0),(395003,10973,'ro','PlÄƒÅ£ile de leasing total',0),(395004,10973,'et','Kokku kapitalirendi maksed',0),(395005,10973,'si','Skupne vsote najemnin',0),(395006,10973,'ba','Pembayaran Total sewa',0),(395007,10973,'nl','Totale leasebetalingen',0),(395008,10973,'fi','YhteensÃ¤ vuokrasopimuksista aiheutuvat maksut',0),(395009,10973,'no','Totalt Lease betalinger',0),(395010,10973,'da','Samlede leasingydelser',0),(395011,10973,'ko','ì´ ìž„ëŒ€ ì§€ë¶ˆ',0),(395012,10973,'he','×—×›×™×¨×” ×¡×›×•× ×”×ª×©×œ×•×ž×™×',0),(395013,10973,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Î•Î¼Ï†Ï…Ï„ÎµÏ…Ï„Î¹ÎºÎ­Ï‚ Î´ÏŒÏƒÎµÎ¹Ï‚',0),(395014,10973,'zh','å…±æœ‰ç§Ÿèµä»˜æ¬¾\r\n',0),(395015,10973,'sv','Totala leasingavgifter',0),(395016,10973,'it','Totale dei pagamenti',0),(395017,10973,'tl','',0),(395018,10973,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(395019,10973,'hi','à¤•à¥à¤² à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(395020,10973,'ms','Jumlah bayaran pajakan',0),(395021,10973,'ar','Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(395022,10973,'fr','Paiements de location total',0),(395023,10973,'jp','ãƒªãƒ¼ã‚¹æ–™ç·é¡ã®ãŠæ”¯æ‰•ã„',0),(395024,10973,'pt','Pagamentos da locaÃ§Ã£o total',0),(395025,10973,'ru','Ð’ÑÐµÐ³Ð¾ Ð»Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð²Ñ‹Ñ… Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(395026,10973,'es','Total de Pagos de Arrendimiento',0),(395027,10973,'de','Total Leasingraten',0),(395028,10973,'en','Total Lease Payments',0),(395029,10974,'is','',0),(395030,10974,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø¹ÙˆÙ‚ Ø¯ÙØªØ± ÙƒÙ„  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(395031,10974,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø¹ÙˆÙ‚ Ø¯ÙØªØ± ÙƒÙ„  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(395032,10974,'tr','Ertelenmifl gelir GL hesabÄ± seÃ§melisiniz',0),(395033,10974,'pl','NaleÅ¼y wybraÄ‡ konto GL odroczonych przychodÃ³w',0),(395034,10974,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð·Ð° GL Ð½Ð° Ð¾Ñ‚Ð»Ð¾Ð¶ÐµÐ½Ð¸ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸',0),(395035,10974,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù…Ù„ØªÙˆÛŒ Ø¢Ù…Ø¯Ù†ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(395036,10974,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð½Ñ‚Ð¾ Ð“Ð› Ð¾Ð´Ð»Ð¾Ð¶ÐµÐ½Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(395037,10974,'vi','Báº¡n Pháº£i Chá»n má»™t TÃ i khoáº£n GL Doanh thu hoÃ£n láº¡i',0),(395038,10974,'af','Jy moet \'n uitgestelde inkomste GL rekening kies',0),(395039,10974,'ro','Trebuie sÄƒ selectaÅ£i un cont de venituri amÃ¢nate GL',0),(395040,10974,'et','Valige konto Ettemakstud tulud GL',0),(395041,10974,'si','Izbrati morate GL kontu OdloÅ¾eni prihodki',0),(395042,10974,'ba','Anda harus memilih rekening GL ditangguhkan pendapatan',0),(395043,10974,'nl','U moet een uitgestelde inkomstenrekening GL selecteren',0),(395044,10974,'fi','Valitse laskennallisen tuottotili GL',0),(395045,10974,'no','Du mÃ¥ velge en utsatt inntektskonto for GL',0),(395046,10974,'da','Du skal vÃ¦lge en udskudte indtÃ¦gter GL konto',0),(395047,10974,'ko','ì§€ì—° ëœ ìˆ˜ìµ GL ê³„ì •ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(395048,10974,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×—×©×‘×•×Ÿ GL ×”×”×›× ×¡×•×ª ×©× ×“×—×•',0),(395049,10974,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± Ï€ÏÎ¿ÎµÎ¹ÏƒÏ€ÏÎ±Ï‡Î¸Î­Î½Ï„Î± Î­ÏƒÎ¿Î´Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(395050,10974,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªé€’å»¶æ”¶å…¥æ€»å¸å¸æˆ·\r\n',0),(395051,10974,'sv','Du mÃ¥ste vÃ¤lja en fÃ¶rutbetalda intÃ¤kter GL konto',0),(395052,10974,'it','Ãˆ necessario selezionare un Account GL risconti',0),(395053,10974,'tl','',0),(395054,10974,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸šà¸±à¸à¸Šà¸µà¸£à¸²à¸¢à¹„à¸”à¹‰à¸£à¸­à¸à¸²à¸£à¸•à¸±à¸”à¸šà¸±à¸à¸Šà¸µ GL',0),(395055,10974,'hi','à¤¤à¥à¤® à¤à¤• à¤µà¤¿à¤²à¤‚à¤¬à¤¿à¤¤ à¤°à¤¾à¤œà¤¸à¥à¤µ GL à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(395056,10974,'ms','Anda mesti memilih akaun GL hasil tertunda',0),(395057,10974,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ­Ø¯ÙŠØ¯ Ø­Ø³Ø§Ø¨ GL Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø¤Ø¬Ù„Ø©',0),(395058,10974,'fr','Vous devez sÃ©lectionner un compte GL Ã  revenus diffÃ©rÃ©s.',0),(395059,10974,'jp','ç¹°å»¶æ­³å…¥ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(395060,10974,'pt','VocÃª deve selecionar uma conta GL Receitas diferidas',0),(395061,10974,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚ GL Ð¾Ñ‚ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ð¿Ð¾ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ð¹',0),(395062,10974,'es','Debe Seleccionar Una Cuenta LM de Ingresos Diferidos',0),(395063,10974,'de','Sie mÃ¼ssen ein Rechnungsabgrenzungsposten GL-Konto auswÃ¤hlen.',0),(395064,10974,'en','You Must Select a Deferred Revenue GL Account',0),(395065,10975,'is','',0),(395066,10975,'dr','(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ù„ÛŒØ¬Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(395067,10975,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø³Ù¾Ø±Ø¯Ù‡(Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª) Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(395068,10975,'tr','Mevduat GL hesabÄ± seÃ§melisiniz',0),(395069,10975,'pl','NaleÅ¼y wybraÄ‡ konto depozytowe GL',0),(395070,10975,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ GL',0),(395071,10975,'ur','Ø¢Ù¾ Ø§ÛŒÚ© ÚˆÙ¾Ø§Ø²Ù¹ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(395072,10975,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð“Ð› Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(395073,10975,'vi','Báº¡n Pháº£i Chá»n má»™t GL tÃ i khoáº£n tiá»n gá»­i',0),(395074,10975,'af','U Moet \'n Deposito AG Rekening Kies',0),(395075,10975,'ro','Trebuie sÄƒ selectaÅ£i un cont de depozit GL',0),(395076,10975,'et','Valige hoiuse pearaamatukontole',0),(395077,10975,'si','Izbrati morate depozitni raÄun GL',0),(395078,10975,'ba','Anda harus memilih rekening deposito GL',0),(395079,10975,'nl','U moet een storting GL Account selecteren',0),(395080,10975,'fi','Valitse GL talletustili',0),(395081,10975,'no','Du mÃ¥ velge en depositumskonto GL',0),(395082,10975,'da','Du skal vÃ¦lge en indlÃ¥nskonto GL',0),(395083,10975,'ko','ì˜ˆê¸ˆ GL ê³„ì •ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(395084,10975,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×—×©×‘×•×Ÿ GL',0),(395085,10975,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î¼Î¹Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(395086,10975,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªæ€»å¸å¸æˆ·å­˜æ¬¾\r\n',0),(395087,10975,'sv','Du mÃ¥ste vÃ¤lja ett konto GL',0),(395088,10975,'it','Ãˆ necessario selezionare un conto di deposito GL',0),(395089,10975,'tl','',0),(395090,10975,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸à¸²à¸',0),(395091,10975,'hi','à¤¤à¥à¤® à¤à¤• à¤œà¤®à¤¾ GL à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(395092,10975,'ms','Anda mesti memilih akaun GL Deposit',0),(395093,10975,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ­Ø¯ÙŠØ¯ Ø­Ø³Ø§Ø¨ GL Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(395094,10975,'fr','Vous devez sÃ©lectionner un compte GL de dÃ©pot.',0),(395095,10975,'jp','GL ã®é é‡‘å£åº§ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(395096,10975,'pt','VocÃª deve selecionar a conta de depÃ³sito GL',0),(395097,10975,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ GL',0),(395098,10975,'es','Debe Seleccionar Una Cuenta LM de DepÃ³sitos',0),(395099,10975,'de','Sie mÃ¼ssen ein Guthabenkonto GL auswÃ¤hlen.',0),(395100,10975,'en','You Must Select a Deposit GL Account',0),(395101,10976,'is','',0),(395102,10976,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ø±Ø²Ø±Ùˆ Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(395103,10976,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ Ø±Ø²Ø±Ùˆ Ø¯ÙØªØ± ÙƒÙ„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(395104,10976,'tr','Bir rezervasyon Ã¼creti GL hesabÄ± seÃ§melisiniz',0),(395105,10976,'pl','NaleÅ¼y wybraÄ‡ konto rezerwacji opÅ‚ata GL',0),(395106,10976,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð·Ð° GL Ð½Ð° Ñ€ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ Ñ‚Ð°ÐºÑÐ°',0),(395107,10976,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø¨Ú©Ù†Ú¯ ÙÛŒØ³ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(395108,10976,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð“Ð› Ð½Ð°ÐºÐ½Ð°Ð´Ñƒ Ð·Ð° Ñ€ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(395109,10976,'vi','Báº¡n pháº£i chá»n 1 tÃ i khoáº£n GL phÃ­ Ä‘áº·t phÃ²ng',0),(395110,10976,'af','U Moet \'n Besprekingsfooi AG Rekening Kies',0),(395111,10976,'ro','Trebuie sÄƒ selectaÅ£i o taxa de rezervare GL cont',0),(395112,10976,'et','Broneeringu tasu pearaamatukontole valige',0),(395113,10976,'si','Izbrati morate rezervacijo pristojbino GL raÄun',0),(395114,10976,'ba','Anda harus memilih rekening GL biaya reservasi',0),(395115,10976,'nl','U moet een reservering vergoeding GL Account selecteren',0),(395116,10976,'fi','Valitse Varauksen maksutiliÃ¤ GL',0),(395117,10976,'no','Du mÃ¥ velge en reservasjon gebyr gi-konto',0),(395118,10976,'da','Du skal vÃ¦lge en Reservation gebyr GL konto',0),(395119,10976,'ko','ì˜ˆì•½ ìˆ˜ìˆ˜ë£Œ GL ê³„ì •ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(395120,10976,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×—×©×‘×•×Ÿ GL ×¢×ž×œ×ª ×”×–×ž× ×”',0),(395121,10976,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î¼Î¹Î± ÎºÏÎ¬Ï„Î·ÏƒÎ· Î±Î¼Î¿Î¹Î²Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(395122,10976,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªé¢„è®¢è´¹ç”¨æ€»å¸å¸æˆ·\r\n',0),(395123,10976,'sv','Du mÃ¥ste vÃ¤lja en bokning avgift GL konto',0),(395124,10976,'it','Ãˆ necessario selezionare un Account GL tassa di prenotazione',0),(395125,10976,'tl','',0),(395126,10976,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸šà¸±à¸à¸Šà¸µ GL à¸„à¹ˆà¸²à¸ˆà¸­à¸‡',0),(395127,10976,'hi','à¤¤à¥à¤® à¤à¤• à¤†à¤°à¤•à¥à¤·à¤£ à¤¶à¥à¤²à¥à¤• GL à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(395128,10976,'ms','Anda mesti memilih akaun GL bayaran Tempahan yang',0),(395129,10976,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ­Ø¯ÙŠØ¯ Ø­Ø³Ø§Ø¨ GL Ø±Ø³ÙˆÙ… Ø§Ù„Ø­Ø¬Ø²',0),(395130,10976,'fr','Vous devez sÃ©lectionner un compte GL de commission de rÃ©servation.',0),(395131,10976,'jp','äºˆç´„æ–™ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(395132,10976,'pt','VocÃª deve selecionar uma conta GL de taxa de reserva',0),(395133,10976,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð±Ñ€Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(395134,10976,'es','Debe Seleccionar Una Cuenta LM de Cuotas para Reservaciones',0),(395135,10976,'de','Sie mÃ¼ssen eine Reservierung GL GebÃ¼hrenkonto auswÃ¤hlen.',0),(395136,10976,'en','You Must Select a Reservation Fee GL Account',0),(395137,10977,'is','',0),(395138,10977,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙØªØ± ÙƒÙ„  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(395139,10977,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙØªØ± ÙƒÙ„  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(395140,10977,'tr','Gelir GL hesabÄ± seÃ§melisiniz',0),(395141,10977,'pl','NaleÅ¼y wybraÄ‡ konto przychodÃ³w GL',0),(395142,10977,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð·Ð° GL Ð½Ð° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(395143,10977,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø±ÛŒÙˆÙ†ÛŒÙˆ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(395144,10977,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð½Ñ‚Ð¾ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð° Ð“Ð›',0),(395145,10977,'vi','Báº¡n Pháº£i Chá»n má»™t tÃ i khoáº£n GL Doanh thu',0),(395146,10977,'af','U Moet \'n Inkomste AG Rekening Kies',0),(395147,10977,'ro','Trebuie sÄƒ selectaÅ£i un cont de venituri GL',0),(395148,10977,'et','Valige GL tulukonto',0),(395149,10977,'si','Izbrati morate raÄun glavne knjige prihodkov',0),(395150,10977,'ba','Anda harus memilih rekening GL pendapatan',0),(395151,10977,'nl','Moet u een inkomstenrekening GL',0),(395152,10977,'fi','Valitse GL tuottotili',0),(395153,10977,'no','Du mÃ¥ velge en inntektskonto for GL',0),(395154,10977,'da','Du skal vÃ¦lge en omsÃ¦tningskonto GL',0),(395155,10977,'ko','ìˆ˜ìµ GL ê³„ì •ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(395156,10977,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×—×©×‘×•×Ÿ ×”×›× ×¡×•×ª GL',0),(395157,10977,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± Î­ÏƒÎ¿Î´Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(395158,10977,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªæ”¶å…¥æ€»å¸å¸æˆ·\r\n',0),(395159,10977,'sv','Du mÃ¥ste vÃ¤lja ett intÃ¤ktskonto GL',0),(395160,10977,'it','Ãˆ necessario selezionare un Account GL entrate',0),(395161,10977,'tl','',0),(395162,10977,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸£à¸²à¸¢à¹„à¸”à¹‰',0),(395163,10977,'hi','à¤¤à¥à¤® à¤à¤• à¤°à¤¾à¤œà¤¸à¥à¤µ GL à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(395164,10977,'ms','Anda mesti memilih akaun GL pendapatan',0),(395165,10977,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø¥Ø®ØªÙŠØ§Ø± Ø­Ø³Ø§Ø¨ Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ù…Ù† Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(395166,10977,'fr','Vous devez sÃ©lectionner un compte GL de revenus.',0),(395167,10977,'jp','åŽå…¥ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(395168,10977,'pt','VocÃª deve selecionar uma conta GL receitas',0),(395169,10977,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð²',0),(395170,10977,'es','Debe Seleccionar Una Cuenta LM de Ingresos',0),(395171,10977,'de','Sie mÃ¼ssen ein Ertragskonto GL auswÃ¤hlen.',0),(395172,10977,'en','You Must Select a Revenue GL Account',0),(395173,10978,'is','',0),(395174,10978,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡ ',0),(395175,10978,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡ ',0),(395176,10978,'tr','Kira Ã¶demeleri',0),(395177,10978,'pl','OpÅ‚aty leasingowe',0),(395178,10978,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð²Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(395179,10978,'ur','Ù„ÛŒØ² Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(395180,10978,'sr','Ð—Ð°ÐºÑƒÐ¿ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(395181,10978,'vi','thanh toÃ¡n há»£p Ä‘á»“ng thuÃª',0),(395182,10978,'af','Huurkontrak Betalings',0),(395183,10978,'ro','PlÄƒÅ£ile de leasing',0),(395184,10978,'et','Kasutusrendi maksed',0),(395185,10978,'si','Zakupnine',0),(395186,10978,'ba','Pembayaran sewa guna usaha',0),(395187,10978,'nl','Leasebetalingen',0),(395188,10978,'fi','PitkÃ¤aikaisesta vuokrasopimuksesta aiheutuvat maksut',0),(395189,10978,'no','Lease betalinger',0),(395190,10978,'da','Leasingydelser',0),(395191,10978,'ko','ìž„ëŒ€ ì§€ë¶ˆ',0),(395192,10978,'he','×”×—×›×¨×ª',0),(395193,10978,'el','Î•Î¼Ï†Ï…Ï„ÎµÏ…Ï„Î¹ÎºÎ­Ï‚ Î´ÏŒÏƒÎµÎ¹Ï‚',0),(395194,10978,'zh','ç§Ÿèµä»˜æ¬¾\r\n',0),(395195,10978,'sv','Leasingavgifter',0),(395196,10978,'it','Pagamenti leasing',0),(395197,10978,'tl','',0),(395198,10978,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²',0),(395199,10978,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(395200,10978,'ms','Bayaran pajakan',0),(395201,10978,'ar','Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(395202,10978,'fr','Paiements de location',0),(395203,10978,'jp','æ”¯æ‰•ãƒªãƒ¼ã‚¹æ–™',0),(395204,10978,'pt','Pagamentos da locaÃ§Ã£o',0),(395205,10978,'ru','ÐÑ€ÐµÐ½Ð´Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(395206,10978,'es','Pagos de Arrendamiento',0),(395207,10978,'de','Leasing-Zahlungen',0),(395208,10978,'en','Lease Payments',0),(395209,10979,'is','',0),(395210,10979,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(395211,10979,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(395212,10979,'tr','Kira Ã¶deme talimatlarÄ±',0),(395213,10979,'pl','Instrukcje dotyczÄ…ce pÅ‚atnoÅ›ci leasingu',0),(395214,10979,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(395215,10979,'ur','Ù„ÛŒØ² Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(395216,10979,'sr','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ Ð·Ð°ÐºÑƒÐ¿Ð°',0),(395217,10979,'vi','hÆ°á»›ng dáº«n thanh toÃ¡n há»£p Ä‘á»“ng thuÃª',0),(395218,10979,'af','Huurkontrak Betalingsinstruksies',0),(395219,10979,'ro','Instructiunile de plata de leasing',0),(395220,10979,'et','ÃœÃ¼rilepingu maksekorraldused',0),(395221,10979,'si','Zakup plaÄilnih navodil',0),(395222,10979,'ba','Instruksi pembayaran sewa',0),(395223,10979,'nl','Lease betalingsinstructies',0),(395224,10979,'fi','Vuokrasopimuksen maksuohjeet',0),(395225,10979,'no','Leieavtalen betalingsinstruksjoner',0),(395226,10979,'da','Lease betalingsinstrukser',0),(395227,10979,'ko','ìž„ëŒ€ ì§€ë¶ˆ ë°©ë²•',0),(395228,10979,'he','×”×•×¨××•×ª ×ª×©×œ×•× ×©×›×™×¨×•×ª',0),(395229,10979,'el','ÎŸÎ´Î·Î³Î¯ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(395230,10979,'zh','ç§Ÿèµä»˜æ¬¾è¯´æ˜Ž\r\n',0),(395231,10979,'sv','Hyresavtalet betalningsinstruktioner',0),(395232,10979,'it','Istruzioni di pagamento del contratto di locazione',0),(395233,10979,'tl','',0),(395234,10979,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²',0),(395235,10979,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(395236,10979,'ms','Arahan pembayaran pajakan',0),(395237,10979,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø¯ÙØ¹ Ø¥ÙŠØ¬Ø§Ø±',0),(395238,10979,'fr','Instructions de paiement de location',0),(395239,10979,'jp','ãƒªãƒ¼ã‚¹ã®ãŠæ”¯æ‰•ã„æ–¹æ³•',0),(395240,10979,'pt','InstruÃ§Ãµes de pagamento de locaÃ§Ã£o',0),(395241,10979,'ru','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð¿Ð¾ Ð¾Ð¿Ð»Ð°Ñ‚Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(395242,10979,'es','Pago de Arrendamiento Instrucciones',0),(395243,10979,'de','Leasing-Zahlungshinweise',0),(395244,10979,'en','Lease Payment Instructions',0),(395245,10980,'is','',0),(395246,10980,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø§ÙˆÙ„ÙŠÙ‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(395247,10980,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø§ÙˆÙ„ÙŠÙ‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(395248,10980,'tr','Ä°lk kirayÄ± Ã¶dedi',0),(395249,10980,'pl','PoczÄ…tkowe leasingu zostaÅ‚a juÅ¼ wypÅ‚acona',0),(395250,10980,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð²Ð¸Ñ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ Ð²ÐµÑ‡Ðµ Ðµ Ð±Ð¸Ð»Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð°',0),(395251,10980,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù„ÛŒØ² Ù¾ÛÙ„Û’ ÛÛŒ Ø¯ÛŒ Ø¬Ø§ØªÛŒ ÛÛ’',0),(395252,10980,'sr','Ð˜Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ Ð·Ð°ÐºÑƒÐ¿ Ð²ÐµÑ› Ñ˜Ðµ Ð¿Ð»Ð°Ñ›ÐµÐ½Ð°',0),(395253,10980,'vi','Há»£p Ä‘á»“ng thuÃª ban Ä‘áº§u Ä‘Ã£ Ä‘Æ°á»£c tráº£',0),(395254,10980,'af','Die Aanvanklike Huurkontrak is Alreeds Betaal',0),(395255,10980,'ro','Contractul de Ã®nchiriere iniÅ£ialÄƒ a fost deja plÄƒtit',0),(395256,10980,'et','Esialgne Ã¼Ã¼rileping on juba vÃ¤lja makstud',0),(395257,10980,'si','ZaÄetnega najema Å¾e plaÄana',0),(395258,10980,'ba','Sewa awal telah dibayar',0),(395259,10980,'nl','De eerste lease-overeenkomst is reeds betaald',0),(395260,10980,'fi','EnsimmÃ¤inen vuokrasopimus on jo maksettu',0),(395261,10980,'no','Den fÃ¸rste leieavtalen er allerede betalt',0),(395262,10980,'da','Den oprindelige lejekontrakt er blevet betalt',0),(395263,10980,'ko','ì´ˆê¸° ìž„ëŒ€ ì§€ë¶ˆ ì´ë¯¸',0),(395264,10980,'he','×”×”×¡×›× ×”×¨××©×•× ×™ ×›×‘×¨ ×©×•×œ×ž×•',0),(395265,10980,'el','Î— Î±ÏÏ‡Î¹ÎºÎ® Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· Ï€Î¿Ï… Î­Ï‡ÎµÎ¹ Î®Î´Î· ÎºÎ±Ï„Î±Î²Î»Î·Î¸ÎµÎ¯',0),(395266,10980,'zh','åˆå§‹ç§Ÿèµå·²æ”¯ä»˜\r\n',0),(395267,10980,'sv','FÃ¶rsta lÃ¥net har redan betalats',0),(395268,10980,'it','Il contratto di locazione iniziale Ã¨ giÃ  stato pagato',0),(395269,10980,'tl','',0),(395270,10980,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹à¸¥à¹‰à¸§',0),(395271,10980,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(395272,10980,'ms','Pajakan asal yang telah dibayar',0),(395273,10980,'ar','ÙˆÙ‚Ø¯ Ø¯ÙØ¹Øª Ø¨Ø§Ù„ÙØ¹Ù„ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(395274,10980,'fr','Le bail Initial a dÃ©jÃ  Ã©tÃ© payÃ©',0),(395275,10980,'jp','åˆæœŸãƒªãƒ¼ã‚¹æ—¢ã«æ”¯æ‰•ã‚ã‚Œã¦ã„ã¾ã™ã€‚',0),(395276,10980,'pt','O contrato inicial jÃ¡ tiver sido paga',0),(395277,10980,'ru','ÐŸÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ Ð°Ñ€ÐµÐ½Ð´Ñ‹ ÑƒÐ¶Ðµ ÑƒÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð°',0),(395278,10980,'es','El Arrendamiento Inicial Ya Se HabÃ­a Pagado',0),(395279,10980,'de','Der ursprÃ¼ngliche Mietvertrag wurde bereits bezahlt',0),(395280,10980,'en','The Initial Lease Has Already Been Paid',0),(395281,10981,'is','',0),(395282,10981,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±Ø§ØªØ± Ø§Ø² Ø§Ù†ØªØ¸Ø§Ø± ',0),(395283,10981,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±Ø§ØªØ± Ø§Ø² Ø§Ù†ØªØ¸Ø§Ø± ',0),(395284,10981,'tr','Fiorentina Cap Amt',0),(395285,10981,'pl','Amt nadmiar Cap',0),(395286,10981,'bg','ÐžÑ‚Ð¾Ð¿Ð»Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ ÐžÐ¡ÐŸ Amt',0),(395287,10981,'ur','Ø§ÙˆÙˆØ±Ø§Ø¬ Ù¹ÙˆÙ¾ÛŒ Ø§Ù…Ù¹',0),(395288,10981,'sr','Ð Ð•Ð¤ . Ð’Ð°Ð» Ð¿Ñ€ÐµÑÑ‚Ð°Ñ€ ÐºÐ°Ð¿Ñƒ.',0),(395289,10981,'vi','Overage Cap Amt',0),(395290,10981,'af','Overage Cap Amt',0),(395291,10981,'ro','Supradozarea Cap Amt',0),(395292,10981,'et','Aegunud Cap Amt',0),(395293,10981,'si','Overage SKP Amt',0),(395294,10981,'ba','Kelebihan Cap Amt',0),(395295,10981,'nl','Overdosering GLB Amt',0),(395296,10981,'fi','Yli-ikÃ¤inen Cap Amt',0),(395297,10981,'no','Overage Cap Amt',0),(395298,10981,'da','Overdosering Cap Amt',0),(395299,10981,'ko','ë„˜ëŠ” ëª¨ìž Amt',0),(395300,10981,'he','×›×•×‘×¢ ×¢×•×“×¤×•×ª Amt',0),(395301,10981,'el','Î ÎµÏÎ¯ÏƒÏƒÎµÎ¹Î± ÎšÎ“Î  Amt',0),(395302,10981,'zh','AMTçš„è¶…é¾„ç¬¬\r\n',0),(395303,10981,'sv','Ã–versatsning Cap Amt',0),(395304,10981,'it','Cap eccesso Amt',0),(395305,10981,'tl','',0),(395306,10981,'th','à¸«à¸¡à¸§à¸à¹€à¸à¸´à¸™à¸ˆà¸³à¸™à¸§à¸™',0),(395307,10981,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤Ÿà¥‹à¤ªà¥€ Amt',0),(395308,10981,'ms','Amt overage Cap',0),(395309,10981,'ar','Amt ÙƒØ§Ø¨ Ø§Ù„ØªØºØ·ÙŠØ©',0),(395310,10981,'fr','Amt Cap excÃ©dentaire',0),(395311,10981,'jp','è¶…éŽã‚­ãƒ£ãƒƒãƒ— Amt',0),(395312,10981,'pt','TampÃ£o excedente Amt',0),(395313,10981,'ru','Ð˜Ð·Ð»Ð¸ÑˆÐºÐ¸ Cap Amt',0),(395314,10981,'es','Tope de Cobertura Monto',0),(395315,10981,'de','Overage Cap Amt',0),(395316,10981,'en','Overage Cap Amt',0),(395317,10982,'is','',0),(395318,10982,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(395319,10982,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(395320,10982,'tr','FaturalarÄ± eklemek',0),(395321,10982,'pl','Dodawanie faktury',0),(395322,10982,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(395323,10982,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(395324,10982,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(395325,10982,'vi','ThÃªm hÃ³ Ä‘Æ¡n',0),(395326,10982,'af','Fakture Byvoeg',0),(395327,10982,'ro','Adauga facturi',0),(395328,10982,'et','Lisada arved',0),(395329,10982,'si','Dodati, raÄuni',0),(395330,10982,'ba','Tambahkan faktur',0),(395331,10982,'nl','Toevoegen van facturen',0),(395332,10982,'fi','Laskut',0),(395333,10982,'no','Legge til fakturaer',0),(395334,10982,'da','FÃ¸je fakturaer',0),(395335,10982,'ko','ì†¡ìž¥ ì¶”ê°€',0),(395336,10982,'he','×”×•×¡×£ ×—×©×‘×•× ×™×•×ª',0),(395337,10982,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(395338,10982,'zh','å¢žåŠ å‘ç¥¨\r\n',0),(395339,10982,'sv','LÃ¤gga till fakturor',0),(395340,10982,'it','Aggiungi fatture',0),(395341,10982,'tl','',0),(395342,10982,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(395343,10982,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(395344,10982,'ms','Tambah invois',0),(395345,10982,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚ÙˆØ§Ø¦Ù… Ø­Ø³Ø§Ø¨',0),(395346,10982,'fr','Ajouter des factures',0),(395347,10982,'jp','è«‹æ±‚æ›¸ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(395348,10982,'pt','Adicionar facturas',0),(395349,10982,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚Ð°',0),(395350,10982,'es','Agregar Facturas',0),(395351,10982,'de','HinzufÃ¼gen von Rechnungen',0),(395352,10982,'en','Add Invoices',0),(395353,10983,'is','',0),(395354,10983,'dr','Ø¢Ø®Ø±ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª ',0),(395355,10983,'pr','Ø¢Ø®Ø±ÙŠÙ† ÙØ¹Ø§Ù„ÙŠØª ',0),(395356,10983,'tr','Son Aktivitesi',0),(395357,10983,'pl','Ostatnia aktywnoÅ›Ä‡',0),(395358,10983,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(395359,10983,'ur','Ø¢Ø®Ø±ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(395360,10983,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(395361,10983,'vi','hÃ nh Ä‘á»™ng cuá»‘i',0),(395362,10983,'af','Laaste Aktiwiteite',0),(395363,10983,'ro','Ultima activitate',0),(395364,10983,'et','Viimati aktiivne',0),(395365,10983,'si','Zadnja dejavnost',0),(395366,10983,'ba','Aktivitas terakhir',0),(395367,10983,'nl','Laatste activiteit',0),(395368,10983,'fi','Viimeksi nÃ¤hty',0),(395369,10983,'no','Siste aktivitet',0),(395370,10983,'da','Seneste aktivitet',0),(395371,10983,'ko','ë§ˆì§€ë§‰ í™œë™',0),(395372,10983,'he','×¤×¢×™×œ×•×ª ××—×¨×•× ×”',0),(395373,10983,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(395374,10983,'zh','æœ€åŽæ´»åŠ¨\r\n',0),(395375,10983,'sv','Senaste aktivitet',0),(395376,10983,'it','Ultima attivitÃ ',0),(395377,10983,'tl','',0),(395378,10983,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(395379,10983,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(395380,10983,'ms','Aktiviti terkini',0),(395381,10983,'ar','Ø§Ù„Ù†Ø´Ø§Ø· Ø§Ù„Ø£Ø®ÙŠØ±',0),(395382,10983,'fr','DerniÃ¨re activitÃ©',0),(395383,10983,'jp','æœ€å¾Œã®ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£',0),(395384,10983,'pt','Ãšltima atividade',0),(395385,10983,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÑÑ ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ',0),(395386,10983,'es','Ultimo Actividad',0),(395387,10983,'de','Letzte AktivitÃ¤t',0),(395388,10983,'en','Last Activity',0),(395389,10984,'is','',0),(395390,10984,'dr','(Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(395391,10984,'pr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ(Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(395392,10984,'tr','Ä°Ã§eri girin baÅŸarÄ±yla silindi',0),(395393,10984,'pl','PrzenieÅ›Ä‡ przesâ”‚anie',0),(395394,10984,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(395395,10984,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(395396,10984,'sr','Ð£ÑÐµÐ»Ð¸ ÑÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(395397,10984,'vi','Di chuyá»ƒn trong xÃ³a thÃ nh cÃ´ng',0),(395398,10984,'af','Beweeg suksesvol geskrap',0),(395399,10984,'ro','Muta eliminÄƒ cu succes',0),(395400,10984,'et','Liikuda edukalt kustutatud',0),(395401,10984,'si','Premakniti uspeÅ¡no izbrisana',0),(395402,10984,'ba','Bergerak dalam dihapus berhasil',0),(395403,10984,'nl','Verplaatsen met succes verwijderd',0),(395404,10984,'fi','SiirrÃ¤ poistettu',0),(395405,10984,'no','Flytte i slettet',0),(395406,10984,'da','Flytte slettet',0),(395407,10984,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ì´ë™',0),(395408,10984,'he','×œ×’×•×¨ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(395409,10984,'el','ÎšÎ¹Î½Î¿ÏÎ½Ï„Î±Î¹ ÏƒÎµ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(395410,10984,'zh','ç§»åŠ¨æˆåŠŸåˆ é™¤\r\n',0),(395411,10984,'sv','Flytta i raderades',0),(395412,10984,'it','Spostare eliminato con successo',0),(395413,10984,'tl','',0),(395414,10984,'th','à¸¢à¹‰à¸²à¸¢à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(395415,10984,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤²à¥‡ à¤œà¤¾à¤à¤',0),(395416,10984,'ms','Bergerak dalam dihapuskan dengan jayanya',0),(395417,10984,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(395418,10984,'fr','Se dÃ©placer supprimÃ© avec succÃ¨s',0),(395419,10984,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸç§»å‹•ã—ã¾ã™ã€‚',0),(395420,10984,'pt','Mover-se apagado com sucesso',0),(395421,10984,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð² ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(395422,10984,'es','Mudarse Dentro Eliminad Exitosamente',0),(395423,10984,'de','Einziehen erfolgreich gelÃ¶scht',0),(395424,10984,'en','Move In Deleted Successfully',0),(395425,10985,'is','',0),(395426,10985,'dr','/ Ø®Ø§Ø±Ø¬',0),(395427,10985,'pr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ Ø¨Ù‡ Ø¯Ø§Ø®Ù„ / Ø®Ø§Ø±Ø¬\r\n Wizard',0),(395428,10985,'tr','Sihirbaz iÃ§inde hareket',0),(395429,10985,'pl','PoruszaÄ‡ siÄ™ w Kreatora',0),(395430,10985,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸ Ð² ÑÑŠÐ²ÐµÑ‚Ð½Ð¸ÐºÐ°',0),(395431,10985,'ur','ÙˆØ²Ø§Ø±Úˆ Ù…ÛŒÚº Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(395432,10985,'sr','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚Ðµ Ñƒ Ñ‡Ð°Ñ€Ð¾Ð±ÑšÐ°ÐºÑƒ Ð·Ð°',0),(395433,10985,'vi','Di chuyá»ƒn trong thuáº­t sÄ©',0),(395434,10985,'af','Beweeg In Ghoeroe',0),(395435,10985,'ro','Muta Ã®n Expertul',0),(395436,10985,'et','Liikuda viisard',0),(395437,10985,'si','Korak Äarovnika za',0),(395438,10985,'ba','Bergerak dalam Wizard',0),(395439,10985,'nl','Verplaatsen In Wizard',0),(395440,10985,'fi','SiirtÃ¤Ã¤ ohjatun',0),(395441,10985,'no','Flytte i veiviseren',0),(395442,10985,'da','Flytte i guiden',0),(395443,10985,'ko','ë§ˆë²•ì‚¬ì—ì„œ ì´ë™',0),(395444,10985,'he','×œ×”×–×™×– ××©×£',0),(395445,10985,'el','ÎœÎµÏ„Î±ÎºÎ¹Î½Î®ÏƒÎµÏ„Îµ ÏƒÏ„Î¿Î½ \"Î¿Î´Î·Î³ÏŒ\"',0),(395446,10985,'zh','ç§»åŠ¨å‘å¯¼\r\n',0),(395447,10985,'sv','Flytta i guiden',0),(395448,10985,'it','Spostare nella procedura guidata',0),(395449,10985,'tl','',0),(395450,10985,'th','à¸¢à¹‰à¸²à¸¢à¹ƒà¸™à¸•à¸±à¸§à¸Šà¹ˆà¸§à¸¢à¸ªà¸£à¹‰à¸²à¸‡',0),(395451,10985,'hi','à¤µà¤¿à¤œà¤¼à¤¾à¤°à¥à¤¡ à¤®à¥‡à¤‚ à¤²à¥‡ à¤œà¤¾à¤à¤',0),(395452,10985,'ms','Bergerak dalam pendeta',0),(395453,10985,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ ÙÙŠ Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬',0),(395454,10985,'fr','Se dÃ©placer dans l\'Assistant',0),(395455,10985,'jp','ã‚¦ã‚£ã‚¶ãƒ¼ãƒ‰ã§ã®ç§»å‹•ã—ã¾ã™ã€‚',0),(395456,10985,'pt','Mover no assistente',0),(395457,10985,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð¼Ð°ÑÑ‚ÐµÑ€Ð°',0),(395458,10985,'es','Venir a Vivir Wizard',0),(395459,10985,'de','Verschieben Sie im Assistenten',0),(395460,10985,'en','Move In Wizard',0),(395461,10986,'is','',0),(395462,10986,'dr','Wizard ',0),(395463,10986,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ Ø¨Ù‡ Ø¯Ø§Ø®Ù„  Wizard \r\n',0),(395464,10986,'tr','Sihirbazdaki yÃ¶nergeleri iÃ§inde hareket',0),(395465,10986,'pl','PrzenieÅ›Ä‡ w instrukcje kreatora',0),(395466,10986,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸ Ð² ÑÑŠÐ²ÐµÑ‚Ð½Ð¸ÐºÐ° Ð·Ð° ÑƒÐºÐ°Ð·Ð°Ð½Ð¸Ñ',0),(395467,10986,'ur','Ù…Ø¯Ø¯Ú¯Ø§Ø± ÛØ¯Ø§ÛŒØ§Øª Ù…ÛŒÚº Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(395468,10986,'sr','Ð§Ð°Ñ€Ð¾Ð±ÑšÐ°Ðº Ð·Ð° ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð´Ð° ÑÐµ ÑƒÑÐµÐ»Ð¸Ð¼',0),(395469,10986,'vi','Di chuyá»ƒn trong thuáº­t sÄ© hÆ°á»›ng dáº«n',0),(395470,10986,'af','Beweeg In Ghoeroe instruksies',0),(395471,10986,'ro','Muta Ã®n instrucÅ£iunile expertului',0),(395472,10986,'et','Liikuda viisardi juhiseid',0),(395473,10986,'si','Premakniti v navodila Äarovnika',0),(395474,10986,'ba','Bergerak dalam Wizard instruksi',0),(395475,10986,'nl','Verplaatsen In de instructies van de Wizard',0),(395476,10986,'fi','SiirtÃ¤Ã¤ ohjatun toiminnon ohjeita',0),(395477,10986,'no','Flytte i instruksjonene for',0),(395478,10986,'da','Flytte i instruktionerne i guiden',0),(395479,10986,'ko','ë§ˆë²•ì‚¬ì˜ ì§€ì‹œì— ì´ë™',0),(395480,10986,'he','×”×–×– ×‘×”×•×¨××•×ª ×”×§×•×¡×',0),(395481,10986,'el','ÎšÎ¹Î½Î¿ÏÎ½Ï„Î±Î¹ Ï€ÏÎ¿Ï‚ Ï„Î¹Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚ Ï„Î¿Ï… Î¿Î´Î·Î³Î¿Ï',0),(395482,10986,'zh','ç§»åŠ¨åœ¨å‘å¯¼çš„è¯´æ˜Ž\r\n',0),(395483,10986,'sv','Flytta i anvisningarna i guiden',0),(395484,10986,'it','Spostare nelle istruzioni della procedura guidata',0),(395485,10986,'tl','',0),(395486,10986,'th','à¸¢à¹‰à¸²à¸¢à¹ƒà¸™à¸•à¸±à¸§à¸Šà¹ˆà¸§à¸¢à¸ªà¸£à¹‰à¸²à¸‡à¸„à¸³à¹à¸™à¸°à¸™à¸³',0),(395487,10986,'hi','à¤µà¤¿à¤œà¤¼à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤¿à¤¤',0),(395488,10986,'ms','Bergerak dalam arahan Pendeta',0),(395489,10986,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ ÙÙŠ ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬',0),(395490,10986,'fr','Se dÃ©placer dans les Instructions de l\'Assistant',0),(395491,10986,'jp','ã‚¦ã‚£ã‚¶ãƒ¼ãƒ‰ã®æŒ‡ç¤ºã«ç§»å‹•ã—ã¾ã™ã€‚',0),(395492,10986,'pt','Mover-se em instruÃ§Ãµes do assistente',0),(395493,10986,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð² Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð¼Ð°ÑÑ‚ÐµÑ€Ð°',0),(395494,10986,'es','Venir a Vivir Wizard Instrucciones',0),(395495,10986,'de','Verschieben Sie In den Anweisungen des Assistenten',0),(395496,10986,'en','Move In Wizard Instructions',0),(395497,10987,'is','',0),(395498,10987,'dr','Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(395499,10987,'pr','Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(395500,10987,'tr','Yeni bir hareketle',0),(395501,10987,'pl','Nowy ruszyÄ‡ z miejsca w',0),(395502,10987,'bg','ÐÐ¾Ð² Ñ…Ð¾Ð´ Ð²',0),(395503,10987,'ur','Ù…ÛŒÚº Ù†ÛŒØ§ Ø§Ù‚Ø¯Ø§Ù…',0),(395504,10987,'sr','ÐÐ¾Ð²Ð¸ ÐºÐ¾Ñ€Ð°Ðº Ñƒ',0),(395505,10987,'vi','Má»›i di chuyá»ƒn trong',0),(395506,10987,'af','Nuwe skuif In',0),(395507,10987,'ro','Noua miÅŸcare Ã®n',0),(395508,10987,'et','Uus samm',0),(395509,10987,'si','Nov korak v',0),(395510,10987,'ba','Baru bergerak dalam',0),(395511,10987,'nl','Nieuwe beweging In',0),(395512,10987,'fi','Uusi askel',0),(395513,10987,'no','Ny bevege i',0),(395514,10987,'da','Nye skridt i',0),(395515,10987,'ko','ìƒˆë¡œìš´ ì´ë™',0),(395516,10987,'he','×”×ž×”×œ×š ×”×—×“×© ×‘',0),(395517,10987,'el','ÎÎ­Î± ÎºÎ¯Î½Î·ÏƒÎ· ÏƒÎµ',0),(395518,10987,'zh','åœ¨æ–°ä¸¾æŽª\r\n',0),(395519,10987,'sv','Nya steg i',0),(395520,10987,'it','Nuova mossa In',0),(395521,10987,'tl','',0),(395522,10987,'th','à¸¢à¸±à¸‡à¹ƒà¸«à¸¡à¹ˆ',0),(395523,10987,'hi','à¤¨à¤ˆ à¤šà¤¾à¤² à¤®à¥‡à¤‚',0),(395524,10987,'ms','Langkah baru dalam',0),(395525,10987,'ar','Ø§Ù„ØªØ­Ø±Ùƒ Ø§Ù„Ø¬Ø¯ÙŠØ¯ ÙÙŠ',0),(395526,10987,'fr','Nouveau dÃ©mÃ©nagement en',0),(395527,10987,'jp','æ–°ã—ã„ç§»å‹•ã§',0),(395528,10987,'pt','Novo movimento na',0),(395529,10987,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÑˆÐ°Ð³ Ð²',0),(395530,10987,'es','Venir a Vivir Nuevo',0),(395531,10987,'de','Neue Bewegung In',0),(395532,10987,'en','New Move In',0),(395533,10988,'is','',0),(395534,10988,'dr','Ø¢Ù…Ø§Ø¯Ù‡ Ø¬Ù‡Øª ',0),(395535,10988,'pr','Ø¢Ù…Ø§Ø¯Ù‡ Ø¬Ù‡Øª ',0),(395536,10988,'tr','HazÄ±r mÄ±sÄ±nÄ±z',0),(395537,10988,'pl','Gotowy do',0),(395538,10988,'bg','Ð“Ð¾Ñ‚Ð¾Ð²Ð¸ Ð´Ð°',0),(395539,10988,'ur','Ú©Û’ Ù„ÛŒÛ’ ØªÛŒØ§Ø±',0),(395540,10988,'sr','Ð¡Ð¿Ñ€ÐµÐ¼Ð°Ð½ Ð´Ð°',0),(395541,10988,'vi','Sáºµn sÃ ng Ä‘á»ƒ',0),(395542,10988,'af','Gereed om te',0),(395543,10988,'ro','Gata sÄƒ',0),(395544,10988,'et','Valmis',0),(395545,10988,'si','Pripravljen za',0),(395546,10988,'ba','Siap untuk',0),(395547,10988,'nl','Klaar om te',0),(395548,10988,'fi','Valmis',0),(395549,10988,'no','Klar til Ã¥',0),(395550,10988,'da','Klar til at',0),(395551,10988,'ko','ì¤€ë¹„ê°€',0),(395552,10988,'he','×ž×•×›× ×™×',0),(395553,10988,'el','ÎˆÏ„Î¿Î¹Î¼Î¿Î¹ Î½Î±',0),(395554,10988,'zh','å‡†å¤‡\r\n',0),(395555,10988,'sv','Redo att',0),(395556,10988,'it','Pronto a',0),(395557,10988,'tl','',0),(395558,10988,'th','à¸žà¸£à¹‰à¸­à¸¡à¸—à¸µà¹ˆà¸ˆà¸°',0),(395559,10988,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¯à¤¾à¤°',0),(395560,10988,'ms','Bersedia untuk',0),(395561,10988,'ar','Ø¬Ø§Ù‡Ø²Ø© Ø¥Ù„Ù‰',0),(395562,10988,'fr','PrÃªt Ã ',0),(395563,10988,'jp','æº–å‚™ãŒã§ãã¦',0),(395564,10988,'pt','Pronto para',0),(395565,10988,'ru','Ð“Ð¾Ñ‚Ð¾Ð² Ðº',0),(395566,10988,'es','Listo Para',0),(395567,10988,'de','Bereit',0),(395568,10988,'en','Ready To',0),(395569,10989,'is','',0),(395570,10989,'dr','Ø­Ø°Ù ÙƒØ±Ø¯Ù†',0),(395571,10989,'pr','Ø­Ø°Ù ÙƒØ±Ø¯Ù†',0),(395572,10989,'tr','KaldÄ±r',0),(395573,10989,'pl','UsuÅ„',0),(395574,10989,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ Ð½Ð°',0),(395575,10989,'ur','ÛÙ¹Ø§Ù†Ø§',0),(395576,10989,'sr','Ð£ÐºÐ»Ð¾Ð½Ð¸Ñ‚Ðµ',0),(395577,10989,'vi','bá»',0),(395578,10989,'af','Verwyder',0),(395579,10989,'ro','Elimina',0),(395580,10989,'et','Eemaldamine',0),(395581,10989,'si','Odstrani',0),(395582,10989,'ba','Hapus',0),(395583,10989,'nl','Verwijderen',0),(395584,10989,'fi','Poista',0),(395585,10989,'no','Fjerne',0),(395586,10989,'da','Fjern',0),(395587,10989,'ko','ì œê±°',0),(395588,10989,'he','×”×¡×¨',0),(395589,10989,'el','ÎšÎ±Ï„Î¬ÏÎ³Î·ÏƒÎ·',0),(395590,10989,'zh','ç§»é™¤\r\n',0),(395591,10989,'sv','Ta bort',0),(395592,10989,'it','Rimuovere',0),(395593,10989,'tl','',0),(395594,10989,'th','à¹€à¸­à¸²à¸­à¸­à¸',0),(395595,10989,'hi','à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚',0),(395596,10989,'ms','Alih Keluar',0),(395597,10989,'ar','Ø¥Ø²Ø§Ù„Ø©',0),(395598,10989,'fr','Supprimer',0),(395599,10989,'jp','å‰Šé™¤',0),(395600,10989,'pt','Remover',0),(395601,10989,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ',0),(395602,10989,'es','Eliminar',0),(395603,10989,'de','Entfernen',0),(395604,10989,'en','Remove',0),(395605,10990,'is','',0),(395606,10990,'dr','Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡ ',0),(395607,10990,'pr','Ø´Ø±ÙˆØ¹ Ø´Ø¯Ù‡ ',0),(395608,10990,'tr','BaÅŸlatan',0),(395609,10990,'pl','ZaczÄ…Å‚',0),(395610,10990,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð°',0),(395611,10990,'ur','Ø´Ø±ÙˆØ¹ Ú©Ø± Ø¯ÛŒØ§',0),(395612,10990,'sr','ÐŸÐ¾Ñ‡ÐµÐ»Ð°',0),(395613,10990,'vi','ÄÃ£ báº¯t Ä‘áº§u',0),(395614,10990,'af','Begin',0),(395615,10990,'ro','A Ã®nceput',0),(395616,10990,'et','Alustatud',0),(395617,10990,'si','ZaÄel',0),(395618,10990,'ba','Mulai',0),(395619,10990,'nl','Begonnen',0),(395620,10990,'fi','Alkoi',0),(395621,10990,'no','Startet',0),(395622,10990,'da','Startede',0),(395623,10990,'ko','ì‹œìž‘',0),(395624,10990,'he','×”×ª×—×™×œ',0),(395625,10990,'el','ÎžÎµÎºÎ¯Î½Î·ÏƒÎµ',0),(395626,10990,'zh','å¼€å§‹\r\n',0),(395627,10990,'sv','BÃ¶rjade',0),(395628,10990,'it','Iniziato',0),(395629,10990,'tl','',0),(395630,10990,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(395631,10990,'hi','à¤¶à¥à¤°à¥‚ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(395632,10990,'ms','Bermula',0),(395633,10990,'ar','Ø¨Ø¯Ø£Øª',0),(395634,10990,'fr','DÃ©marrÃ©',0),(395635,10990,'jp','é–‹å§‹',0),(395636,10990,'pt','ComeÃ§ou',0),(395637,10990,'ru','ÐÐ°Ñ‡Ð°Ð»',0),(395638,10990,'es','Comenzado',0),(395639,10990,'de','Gestartet',0),(395640,10990,'en','Started',0),(395641,10991,'is','',0),(395642,10991,'dr','Ø§Ø¬Ø§Ø±Ù‡',0),(395643,10991,'pr','Ø§Ø¬Ø§Ø±Ù‡',0),(395644,10991,'tr','Kira',0),(395645,10991,'pl','DzierÅ¼awy',0),(395646,10991,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³',0),(395647,10991,'ur','Ù„ÛŒØ²',0),(395648,10991,'sr','ÐÐ°Ñ˜Ð°Ð¼',0),(395649,10991,'vi','Cho thuÃª',0),(395650,10991,'af','Huurkontrak',0),(395651,10991,'ro','Contract de leasing',0),(395652,10991,'et','Kapitalirendi',0),(395653,10991,'si','Zakup',0),(395654,10991,'ba','Sewa',0),(395655,10991,'nl','Lease',0),(395656,10991,'fi','Vuokrasopimus',0),(395657,10991,'no','Leieavtalen',0),(395658,10991,'da','Leasing',0),(395659,10991,'ko','ìž„ëŒ€',0),(395660,10991,'he','×—×›×™×¨×”',0),(395661,10991,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ·',0),(395662,10991,'zh','ç§Ÿèµ\r\n',0),(395663,10991,'sv','Hyresavtal',0),(395664,10991,'it','Contratto di locazione',0),(395665,10991,'tl','',0),(395666,10991,'th','à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(395667,10991,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾',0),(395668,10991,'ms','Pajakan',0),(395669,10991,'ar','Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(395670,10991,'fr','Contrat de location',0),(395671,10991,'jp','ãƒªãƒ¼ã‚¹',0),(395672,10991,'pt','LocaÃ§Ã£o',0),(395673,10991,'ru','ÐÑ€ÐµÐ½Ð´Ð°',0),(395674,10991,'es','Arrendamiento',0),(395675,10991,'de','Leasing',0),(395676,10991,'en','Lease',0),(395677,10992,'is','',0),(395678,10992,'dr','(ÙˆÙŠÚ˜Ú¯ÙŠ) Ø¢Ù¾Ù„ÙˆØ¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(395679,10992,'pr','Ù‡ÙŠÚ† ÙØ§ÙŠÙ„ Ø§Ø¬Ø§Ø±Ù‡ Ø§ÙŠ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø¯Ø§Ø±Ø§Ø¦ÙŠ(ÙˆÙŠÚ˜Ú¯ÙŠ) Ø¢Ù¾Ù„ÙˆØ¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(395680,10992,'tr','Bu Ã¶zellik iÃ§in hiÃ§bir kira dosya yÃ¼kledi',0),(395681,10992,'pl','Nie wgrane plik dzierÅ¼awy tej wÅ‚aÅ›ciwoÅ›Ä‡',0),(395682,10992,'bg','ÐÑÐ¼Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ñ„Ð°Ð¹Ð» ÐºÐ°Ñ‡Ð¸Ð» Ð·Ð° Ñ‚Ð¾Ð²Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(395683,10992,'ur','Ø§Ø³ Ú©ÛŒ Ø®Ø§ØµÛŒØª Ú©Û’ Ù„Ø¦Û’ Ú©ÙˆØ¦ÛŒ Ù„ÛŒØ² Ù…Ø³Ù„ Ø§Ù¾ Ù„ÙˆÚˆ',0),(395684,10992,'sr','ÐÐµÐ¼Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð·Ð° Ð·Ð°ÐºÑƒÐ¿ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ð° Ð·Ð° Ð¾Ð²Ð¾ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð¾',0),(395685,10992,'vi','KhÃ´ng cÃ³ táº­p tin thuÃª táº£i lÃªn cho tÃ i sáº£n nÃ y',0),(395686,10992,'af','Geen HuurkontraklÃªer is Vir Hierdie EiGeen Huurkontrak Gevind nie.endeom Opgelaai nie.',0),(395687,10992,'ro','Nici un fiÅŸier de leasing Ã®ncÄƒrcat pentru aceastÄƒ proprietate',0),(395688,10992,'et','ÃœÃ¼rilepingu faili laadinud selle atribuudi',0),(395689,10992,'si','Ni zakup datoteke naloÅ¾ili za to lastnost',0),(395690,10992,'ba','Tidak ada sewa File upload untuk properti ini',0),(395691,10992,'nl','Geen Lease-bestand geÃ¼pload voor deze eigenschap',0),(395692,10992,'fi','TÃ¤lle ominaisuudelle ei ole vuokrasopimuksen tiedosto',0),(395693,10992,'no','Ingen Lease fil lastet For denne egenskapen',0),(395694,10992,'da','Ingen leasing fil uploadet til denne egenskab',0),(395695,10992,'ko','ì´ ì†ì„±ì— ëŒ€ í•œ ìž„ëŒ€ íŒŒì¼ ì—…ë¡œë“œ',0),(395696,10992,'he','××™×Ÿ ×§×•×‘×¥ ×—×›×™×¨×” ×©×”×•×¢×œ×• ×¢×‘×•×¨ ×ž××¤×™×™×Ÿ ×–×”',0),(395697,10992,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î±ÏÏ‡ÎµÎ¯Î¿ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ Ï€Î¿Ï… Ï†Î¿ÏÏ„ÏŽÎ¸Î·ÎºÎµ Î³Î¹Î± Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Î¹Î´Î¹ÏŒÏ„Î·Ï„Î±',0),(395698,10992,'zh','æ— ç§Ÿçº¦æ–‡ä»¶ä¸Šä¼ æ­¤å±žæ€§\r\n',0),(395699,10992,'sv','Ingen leasing filen upp fÃ¶r den hÃ¤r egenskapen',0),(395700,10992,'it','Nessun contratto di locazione File caricati per questa proprietÃ ',0),(395701,10992,'tl','',0),(395702,10992,'th','à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¹à¸Ÿà¹‰à¸¡à¹„à¸¡à¹ˆà¹€à¸Šà¹ˆà¸²à¸ªà¸³à¸«à¸£à¸±à¸šà¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸™à¸µà¹‰',0),(395703,10992,'hi','à¤‡à¤¸ à¤—à¥à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(395704,10992,'ms','Tiada fail pajakan yang dimuat naik bagi harta ini',0),(395705,10992,'ar','ØªØ­Ù…ÙŠÙ„ Ù„Ø§ Ù…Ù„Ù Ø§Ù„ØªØ£Ø¬ÙŠØ± Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø®Ø§ØµÙŠØ©',0),(395706,10992,'fr','Aucun fichier de bail tÃ©lÃ©chargÃ©e pour cette propriÃ©tÃ©',0),(395707,10992,'jp','ã“ã®ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®ãƒªãƒ¼ã‚¹ ãƒ•ã‚¡ã‚¤ãƒ«ã¯ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã•ã‚Œã¾ã›ã‚“ã€‚',0),(395708,10992,'pt','Nenhum arquivo de locaÃ§Ã£o enviado para esta propriedade.',0),(395709,10992,'ru','Ð¤Ð°Ð¹Ð» Ð½Ðµ Ð°Ñ€ÐµÐ½Ð´Ñƒ, Ð·Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ðµ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(395710,10992,'es','NingÃºn Archivo de Arrendamiento Subido para Este Propiedad',0),(395711,10992,'de','Keine Lease-Datei hochgeladen, fÃ¼r diese Eigenschaft',0),(395712,10992,'en','No Lease File Uploaded For This Property',0),(395713,10993,'is','',0),(395714,10993,'dr','Ù„ÙŠØ³Øª Ø´ØºÙ„ ',0),(395715,10993,'pr','Ù„ÙŠØ³Øª Ø´ØºÙ„ ',0),(395716,10993,'tr','Ä°ÅŸ listesi',0),(395717,10993,'pl','Lista zadaÅ„',0),(395718,10993,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¸',0),(395719,10993,'ur','Ú©Ø§Ù… ÙÛØ±Ø³Øª',0),(395720,10993,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ð¾ÑÐ»Ð¾Ð²Ð°',0),(395721,10993,'vi','danh sÃ¡ch cÃ´ng viá»‡c',0),(395722,10993,'af','Kontrakwerk Lys',0),(395723,10993,'ro','Lista posturilor',0),(395724,10993,'et','TÃ¶Ã¶de loend',0),(395725,10993,'si','Seznam zaposlitev',0),(395726,10993,'ba','Daftar pekerjaan',0),(395727,10993,'nl','Projectoverzicht',0),(395728,10993,'fi','TyÃ¶luettelo',0),(395729,10993,'no','Jobblisten',0),(395730,10993,'da','Joblisten',0),(395731,10993,'ko','ìž‘ì—… ëª©ë¡',0),(395732,10993,'he','×¨×©×™×ž×ª ×”×¢×‘×•×“×•×ª',0),(395733,10993,'el','Î›Î¯ÏƒÏ„Î± ÎµÏÎ³Î±ÏƒÎ¹ÏŽÎ½',0),(395734,10993,'zh','èŒä½åˆ—è¡¨\r\n',0),(395735,10993,'sv','Jobblistan',0),(395736,10993,'it','Lista di lavoro',0),(395737,10993,'tl','',0),(395738,10993,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸‡à¸²à¸™',0),(395739,10993,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¥‚à¤šà¥€',0),(395740,10993,'ms','Senarai kerja',0),(395741,10993,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„ÙˆØ¸Ø§Ø¦Ù',0),(395742,10993,'fr','Liste des travaux',0),(395743,10993,'jp','ã‚¸ãƒ§ãƒ–ã®ä¸€è¦§',0),(395744,10993,'pt','Lista de trabalhos',0),(395745,10993,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°Ð´Ð°Ð½Ð¸Ð¹',0),(395746,10993,'es','Lista de Trabajo',0),(395747,10993,'de','Auftragsliste',0),(395748,10993,'en','Job List',0),(395749,10994,'is','',0),(395750,10994,'dr','(ÙŠØ§Ø¯Ø¢ÙˆØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡',0),(395751,10994,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ (ÙŠØ§Ø¯Ø¢ÙˆØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡',0),(395752,10994,'tr','AnÄ±msatÄ±cÄ± ekleme',0),(395753,10994,'pl','Dodaj przypomnienie',0),(395754,10994,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð°Ð¿Ð¾Ð¼Ð½ÑÐ½Ðµ',0),(395755,10994,'ur','ÛŒØ§Ø¯Ø¯ÛØ§Ù†ÛŒ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(395756,10994,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ð´ÑÐµÑ‚Ð½Ð¸ÐºÐ°',0),(395757,10994,'vi','ThÃªm ghi nhá»›',0),(395758,10994,'af','Herinneraar Byvoeg',0),(395759,10994,'ro','Adauga memento',0),(395760,10994,'et','Meeldetuletuse lisamine',0),(395761,10994,'si','Dodaj opomnik',0),(395762,10994,'ba','Menambahkan pengingat',0),(395763,10994,'nl','Herinnering toevoegen',0),(395764,10994,'fi','LisÃ¤Ã¤ muistutus',0),(395765,10994,'no','Legg til pÃ¥minnelse',0),(395766,10994,'da','TilfÃ¸j pÃ¥mindelse',0),(395767,10994,'ko','ë¯¸ë¦¬ ì•Œë¦¼ ì¶”ê°€',0),(395768,10994,'he','×”×•×¡×£ ×ª×–×›×•×¨×ª',0),(395769,10994,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï…Ï€ÎµÎ½Î¸ÏÎ¼Î¹ÏƒÎ·Ï‚',0),(395770,10994,'zh','å¢žåŠ æé†’\r\n',0),(395771,10994,'sv','LÃ¤gga till pÃ¥minnelse',0),(395772,10994,'it','Aggiungi promemoria',0),(395773,10994,'tl','',0),(395774,10994,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ˆà¸”à¸«à¸¡à¸²à¸¢à¹€à¸•à¸·à¸­à¸™à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(395775,10994,'hi','à¤…à¤¨à¥à¤¸à¥à¤®à¤¾à¤°à¤• à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(395776,10994,'ms','Tambah peringatan',0),(395777,10994,'ar','Ø¥Ø¶Ø§ÙØ© ØªØ°ÙƒÙŠØ±',0),(395778,10994,'fr','Ajouter rappel',0),(395779,10994,'jp','ã‚¢ãƒ©ãƒ¼ãƒ ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(395780,10994,'pt','Adicionar Lembrete',0),(395781,10994,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐÐ°Ð¿Ð¾Ð¼Ð¸Ð½Ð°Ð½Ð¸Ðµ',0),(395782,10994,'es','Agregar un Recuerdo',0),(395783,10994,'de','FÃ¼gen Erinnerung hinzu',0),(395784,10994,'en','Add Reminder',0),(395785,10995,'is','',0),(395786,10995,'dr','( ÙŠØ§Ø¯Ø¢ÙˆØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ Ù‡Ø§',0),(395787,10995,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ù‡Ø§  ( ÙŠØ§Ø¯Ø¢ÙˆØ±ÙŠ ÙƒÙ†Ù†Ø¯Ù‡ Ù‡Ø§',0),(395788,10995,'tr','AnÄ±msatÄ±cÄ±larÄ±',0),(395789,10995,'pl','Przypomnienia',0),(395790,10995,'bg','ÐÐ°Ð¿Ð¾Ð¼Ð½ÑÐ½Ð¸Ñ',0),(395791,10995,'ur','ÛŒØ§Ø¯ Ø¯ÛØ§Ù†ÛŒØ§Úº',0),(395792,10995,'sr','ÐžÐ¿Ð¾Ð¼ÐµÐ½Ð°',0),(395793,10995,'vi','nháº¯c nhá»Ÿ',0),(395794,10995,'af','Herinneraars',0),(395795,10995,'ro','Memento-uri',0),(395796,10995,'et','Meeldetuletused',0),(395797,10995,'si','Opomniki',0),(395798,10995,'ba','Pengingat',0),(395799,10995,'nl','Herinneringen',0),(395800,10995,'fi','Muistutukset',0),(395801,10995,'no','PÃ¥minnelser',0),(395802,10995,'da','PÃ¥mindelser',0),(395803,10995,'ko','ë¯¸ë¦¬ ì•Œë¦¼',0),(395804,10995,'he','×ª×–×›×•×¨×•×ª',0),(395805,10995,'el','Î¥Ï€ÎµÎ½Î¸Ï…Î¼Î¯ÏƒÎµÎ¹Ï‚',0),(395806,10995,'zh','æé†’\r\n',0),(395807,10995,'sv','PÃ¥minnelser',0),(395808,10995,'it','Promemoria',0),(395809,10995,'tl','',0),(395810,10995,'th','à¸ˆà¸”à¸«à¸¡à¸²à¸¢à¹€à¸•à¸·à¸­à¸™à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(395811,10995,'hi','à¤…à¤¨à¥à¤¸à¥à¤®à¤¾à¤°à¤•',0),(395812,10995,'ms','Peringatan',0),(395813,10995,'ar','ØªØ°ÙƒÙŠØ±Ø§Øª',0),(395814,10995,'fr','Rappels',0),(395815,10995,'jp','ã‚¢ãƒ©ãƒ¼ãƒ ',0),(395816,10995,'pt','Lembretes',0),(395817,10995,'ru','ÐÐ°Ð¿Ð¾Ð¼Ð¸Ð½Ð°Ð½Ð¸Ñ',0),(395818,10995,'es','Recordatorios',0),(395819,10995,'de','Erinnerungen',0),(395820,10995,'en','Reminders',0),(395821,10996,'is','',0),(395822,10996,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÙŠÙ† ',0),(395823,10996,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÙŠÙ† ',0),(395824,10996,'tr','Bunu kullanÄ±n',0),(395825,10996,'pl','UÅ¼yj tego',0),(395826,10996,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ‚Ð¾Ð²Ð°',0),(395827,10996,'ur','Ø§Ø³ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(395828,10996,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¾Ð²Ð¾',0),(395829,10996,'vi','Sá»­ dá»¥ng cÃ¡i nÃ y',0),(395830,10996,'af','Gebruik Dit',0),(395831,10996,'ro','UtilizaÅ£i aceastÄƒ',0),(395832,10996,'et','Kasutage seda',0),(395833,10996,'si','Raba to',0),(395834,10996,'ba','Menggunakan ini',0),(395835,10996,'nl','Gebruik dit',0),(395836,10996,'fi','KÃ¤ytÃ¤ tÃ¤tÃ¤',0),(395837,10996,'no','Bruk denne',0),(395838,10996,'da','Brug denne',0),(395839,10996,'ko','ì´ê²ƒì„ ì‚¬ìš© í•˜ ì—¬',0),(395840,10996,'he','×”×©×ª×ž×© ×‘×–×”',0),(395841,10996,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Î±Ï…Ï„ÏŒ',0),(395842,10996,'zh','ä½¿ç”¨æ­¤\r\n',0),(395843,10996,'sv','AnvÃ¤nda detta',0),(395844,10996,'it','Utilizzare questo',0),(395845,10996,'tl','',0),(395846,10996,'th','à¹ƒà¸Šà¹‰à¸™à¸µà¹‰',0),(395847,10996,'hi','à¤‡à¤¸ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(395848,10996,'ms','Menggunakan ini',0),(395849,10996,'ar','Ø§Ø³ØªØ®Ø¯Ù… Ù‡Ø°Ø§',0),(395850,10996,'fr','Utilisez cette',0),(395851,10996,'jp','ã“ã‚Œã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(395852,10996,'pt','Use isto',0),(395853,10996,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ñƒ',0),(395854,10996,'es','Usa Esto',0),(395855,10996,'de','Verwenden Sie diese',0),(395856,10996,'en','Use This',0),(395857,10997,'is','',0),(395858,10997,'dr','Ø§ÙƒÙ†ÙˆÙ† Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(395859,10997,'pr','Ø§ÙƒÙ†ÙˆÙ† Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(395860,10997,'tr','Åžimdi OluÅŸtur',0),(395861,10997,'pl','UtwÃ³rz teraz',0),(395862,10997,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ ÑÐ¸ ÑÐµÐ³Ð°',0),(395863,10997,'ur','Ø§Ø¨ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(395864,10997,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ ÑÐ°Ð´Ð°',0),(395865,10997,'vi','táº¡o bÃ¢y giá»',0),(395866,10997,'af','Skep Nou',0),(395867,10997,'ro','CreaÅ£i acum',0),(395868,10997,'et','Looge nÃ¼Ã¼d',0),(395869,10997,'si','Ustvarite zdaj',0),(395870,10997,'ba','Buat sekarang',0),(395871,10997,'nl','Maak nu',0),(395872,10997,'fi','Luo nyt',0),(395873,10997,'no','Opprette nÃ¥',0),(395874,10997,'da','Opret nu',0),(395875,10997,'ko','ì§€ê¸ˆ ìž‘ì„±',0),(395876,10997,'he','×¦×•×¨ ×¢×›×©×™×•',0),(395877,10997,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„ÏŽÏÎ±',0),(395878,10997,'zh','ç«‹å³å»ºç«‹\r\n',0),(395879,10997,'sv','Skapa nu',0),(395880,10997,'it','Creare ora',0),(395881,10997,'tl','',0),(395882,10997,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸•à¸­à¸™à¸™à¸µà¹‰',0),(395883,10997,'hi','à¤…à¤¬ à¤¬à¤¨à¤¾à¤à¤',0),(395884,10997,'ms','Mencipta sekarang',0),(395885,10997,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø¢Ù†',0),(395886,10997,'fr','CrÃ©ez maintenant',0),(395887,10997,'jp','ä»Šã™ãä½œæˆã—ã¾ã™ã€‚',0),(395888,10997,'pt','Criar agora',0),(395889,10997,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¡ÐµÐ¹Ñ‡Ð°Ñ',0),(395890,10997,'es','Crear Ahora',0),(395891,10997,'de','Erstellen Sie jetzt',0),(395892,10997,'en','Create Now',0),(395893,10998,'is','',0),(395894,10998,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± ',0),(395895,10998,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª ÙØ§ÙƒØªÙˆØ± ',0),(395896,10998,'tr','Faturalanacak miktar',0),(395897,10998,'pl','Kwota do zafakturowania',0),(395898,10998,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(395899,10998,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø±Ù‚Ù…',0),(395900,10998,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(395901,10998,'vi','Sá»‘ tiá»n láº­p hÃ³a Ä‘Æ¡n',0),(395902,10998,'af','Bedrag vir Fakturering',0),(395903,10998,'ro','Suma de facturÄƒ',0),(395904,10998,'et','Arve summa',0),(395905,10998,'si','Znesek raÄuna',0),(395906,10998,'ba','Jumlah tagihan',0),(395907,10998,'nl','Te factureren bedrag',0),(395908,10998,'fi','Laskun mÃ¤Ã¤rÃ¤',0),(395909,10998,'no','BelÃ¸p til fakturaen',0),(395910,10998,'da','BelÃ¸be sig til faktura',0),(395911,10998,'ko','ì†¡ìž¥ ê¸ˆì•¡',0),(395912,10998,'he','×¡×›×•× ×—×©×‘×•× ×™×ª',0),(395913,10998,'el','Î‘Î½Î­Î»Î¸ÎµÎ¹ ÏƒÎµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(395914,10998,'zh','å‘ç¥¨é‡‘é¢\r\n',0),(395915,10998,'sv','UppgÃ¥ till faktura',0),(395916,10998,'it','Ammontano a fattura',0),(395917,10998,'tl','',0),(395918,10998,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(395919,10998,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¾à¤¶à¤¿',0),(395920,10998,'ms','Jumlah invois',0),(395921,10998,'ar','Ù…Ø¨Ù„Øº Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(395922,10998,'fr','Le montant de la facture',0),(395923,10998,'jp','è«‹æ±‚é¡ã—ã¾ã™ã€‚',0),(395924,10998,'pt','Montante a facturar',0),(395925,10998,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÑ‡ÐµÑ‚Ð°',0),(395926,10998,'es','Cantidad para Facturar',0),(395927,10998,'de','Belaufen sich auf Rechnung',0),(395928,10998,'en','Amount to Invoice',0),(395929,10999,'is','',0),(395930,10999,'dr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ùˆ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø²Ù…Ø§Ù† Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(395931,10999,'pr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ùˆ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø²Ù…Ø§Ù† Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ',0),(395932,10999,'tr','PO ve saat veri servis sipariÅŸine taÅŸÄ±yÄ±n',0),(395933,10999,'pl','PrzenieÅ›Ä‡ PO i czas dane zlecenie serwisowe',0),(395934,10999,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð²Ð°Ð½Ðµ Ð½Ð° PO Ð¸ Ð²Ñ€ÐµÐ¼Ðµ Ð´Ð°Ð½Ð½Ð¸ Ð² Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(395935,10999,'ur','Ù¾Ùˆ Ø§ÙˆØ± ÙˆÙ‚Øª Ú©ÙˆØ§Ø¦Ù Ø®Ø¯Ù…Øª Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†ØªÙ‚Ù„ Ú©Ø±ÛŒÚº Û”',0),(395936,10999,'sr','ÐŸÐ¾Ñ‚ÐµÐ· Ð¿Ð¾-Ð° Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ñƒ Ñƒ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(395937,10999,'vi','chuyá»ƒn Ä‘á» nghá»‹ mua hÃ ng vÃ  dá»¯ liá»‡u thá»i gian thÃ nh Ä‘Æ¡n hÃ ng dá»‹ch vá»¥',0),(395938,10999,'af','Skuif AB en Tyd Data na Diens Bestelling',0),(395939,10999,'ro','Muta PO ÅŸi date Ã®n timp la comandÄƒ de Service',0),(395940,10999,'et','PO ja kellaaeg kolida teenuse tellimine',0),(395941,10999,'si','Premikanje PO in podatki za servisni nalog',0),(395942,10999,'ba','PO bergerak dan waktu Data untuk Order Layanan',0),(395943,10999,'nl','PO en tijdgegevens verplaatsen naar serviceorder',0),(395944,10999,'fi','SiirrÃ¤ PO- ja aikatietoja huoltotilaukseen',0),(395945,10999,'no','Flytte PO og tidsdata til serviceordre',0),(395946,10999,'da','Flytte PO og tidsdata til serviceordre',0),(395947,10999,'ko','ì„œë¹„ìŠ¤ ì˜¤ë” í¬ ë° ì‹œê°„ ë°ì´í„° ì´ë™',0),(395948,10999,'he','×œ×¢×‘×•×¨ ×¤×• ×•× ×ª×•× ×™× ×‘×–×ž×Ÿ ×”×–×ž× ×ª ×©×™×¨×•×ª',0),(395949,10999,'el','ÎšÎ¯Î½Î·ÏƒÎ· ÎŸÎ  ÎºÎ±Î¹ Î´ÎµÎ´Î¿Î¼Î­Î½Î± ÏŽÏÎ±Ï‚ ÎµÎ½Ï„Î¿Î»Î® Ï„ / Ï…',0),(395950,10999,'zh','ç§»åŠ¨é‡‡è´­è®¢å•å’Œæ—¶é—´æ•°æ®æœåŠ¡ä»¤\r\n',0),(395951,10999,'sv','Flytta PO och tidsdata till serviceorder',0),(395952,10999,'it','Spostare PO Data e ora in ordine di servizio',0),(395953,10999,'tl','',0),(395954,10999,'th','à¸¢à¹‰à¸²à¸¢ PO à¹à¸¥à¸°à¹€à¸§à¸¥à¸²à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸šà¸£à¸´à¸à¸²à¸£',0),(395955,10999,'hi','PO à¤”à¤° à¤¸à¤®à¤¯ à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¥‡à¤µà¤¾ à¤•à¥à¤°à¤® à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥‡ à¤œà¤¾à¤à¤',0),(395956,10999,'ms','PO langkah dan masa Data pesanan Perkhidmatan',0),(395957,10999,'ar','Ø­Ø±Ùƒ Ø¨Ùˆ ÙˆØ¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ÙˆÙ‚Øª Ù„Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(395958,10999,'fr','DÃ©placer PO et heure Ã  l\'ordre de Service',0),(395959,10999,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã« PO ã¨æ™‚é–“ã®ãƒ‡ãƒ¼ã‚¿ã‚’ç§»å‹•ã—ã¾ã™ã€‚',0),(395960,10999,'pt','PO de movimento e tempo dados a ordem de serviÃ§o',0),(395961,10999,'ru','PO Ð¸ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ¼ÐµÑ‰Ð°ÑŽÑ‚ÑÑ Ð² ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð·',0),(395962,10999,'es','Mueve Datos de OC y Tiempo al Orden de ServicioNuevo ',0),(395963,10999,'de','Verschieben von PO und Zeitdaten Serviceauftrag',0),(395964,10999,'en','Move PO and Time Data to Service Order',0),(395965,11000,'is','',0),(395966,11000,'dr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ùˆ Ø¯Ø§Ø¯Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(395967,11000,'pr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ùˆ Ø¯Ø§Ø¯Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(395968,11000,'tr','Hareketli PO ve saat veri baÅŸarÄ±sÄ±z oldu',0),(395969,11000,'pl','Nie powiodÅ‚o siÄ™ PO ruchu i czas danych',0),(395970,11000,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€ÐµÐ¼ÐµÑÑ‚Ð²Ð°Ð½Ðµ PO Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð²Ñ€ÐµÐ¼Ðµ',0),(395971,11000,'ur','Ø­Ø±Ú©Øª Ù¾Ø°ÛŒØ± Ù¾Ùˆ Ø§ÙˆØ± ÚˆÛŒÙ¹Ø§ ÙˆÙ‚Øª Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§',0),(395972,11000,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾ Ð¿Ð¾ÐºÑ€ÐµÑ‚Ð½Ð¸ Ð¿Ð¾-Ð° Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ñƒ',0),(395973,11000,'vi','chuyá»n dá»¯ liá»‡u thá»i gian & ÄÆ¡n mua hÃ ng tháº¥t báº¡i',0),(395974,11000,'af','Kon beweeg PO en tyd Data',0),(395975,11000,'ro','Nu a reuÅŸit Ã®n miÅŸcare PO ÅŸi date Ã®n timp',0),(395976,11000,'et','Ei ole liikuvaid PO ja kellaaeg',0),(395977,11000,'si','Premikanje PO in Äasovne podatke',0),(395978,11000,'ba','Gagal PO bergerak dan waktu Data',0),(395979,11000,'nl','Mislukte bewegende PO en tijdgegevens',0),(395980,11000,'fi','EpÃ¤onnistui liikkuvan PO ja tiedot',0),(395981,11000,'no','Kan ikke flytte PO og klokkeslett',0),(395982,11000,'da','Kunne ikke flytte PO og tidsdata',0),(395983,11000,'ko','ì‹¤íŒ¨ í•œ ì´ë™ í¬ ë° ì‹œê°„ ë°ì´í„°',0),(395984,11000,'he','× ×›×©×œ ×¤×• × ×¢ ×•× ×ª×•× ×™× ×–×ž×Ÿ',0),(395985,11000,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ ÎºÎ¹Î½ÎµÎ¯Ï„Î±Î¹ ÎŸÎ  ÎºÎ±Î¹ Î´ÎµÎ´Î¿Î¼Î­Î½Î± ÏŽÏÎ±Ï‚',0),(395986,11000,'zh','æ— æ³•ç§»åŠ¨è®¢å•å’Œæ—¶é—´æ•°æ®\r\n',0),(395987,11000,'sv','Misslyckades rÃ¶rliga PO och tidsdata',0),(395988,11000,'it','Fallito PO commovente Data e ora',0),(395989,11000,'tl','',0),(395990,11000,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸¢à¹‰à¸²à¸¢ PO à¹à¸¥à¸°à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸§à¸¥à¸²',0),(395991,11000,'hi','à¤šà¤²à¤¤à¥€ PO à¤”à¤° à¤¸à¤®à¤¯ à¤¡à¥‡à¤Ÿà¤¾ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(395992,11000,'ms','Gagal bergerak PO dan masa Data',0),(395993,11000,'ar','ÙØ´Ù„ Ø¨Ùˆ ØªØªØ­Ø±Ùƒ ÙˆØ§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ÙˆÙ‚Øª',0),(395994,11000,'fr','N\'a pas de mouvement PO et heure',0),(395995,11000,'jp','å¤±æ•—ã—ãŸç§»å‹• PO ã¨æ™‚é–“ã®ãƒ‡ãƒ¼ã‚¿',0),(395996,11000,'pt','Falha PO em movimento e dados em tempo',0),(395997,11000,'ru','ÐÐµ Ð´Ð²Ð¸Ð¶ÑƒÑ‰Ð¸Ñ…ÑÑ PO Ð¸ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(395998,11000,'es','FallÃ³ Mover Los Datos de Tiempo y OC',0),(395999,11000,'de','Fehler beim Verschieben PO und Zeitdaten',0),(396000,11000,'en','Failed Moving PO and Time Data',0),(396001,11001,'is','',0),(396002,11001,'dr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ùˆ Ø¯Ø§Ø¯Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(396003,11001,'pr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ùˆ Ø¯Ø§Ø¯Ù‡ Ø²Ù…Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(396004,11001,'tr','PO ve saat veri baÅŸarÄ±yla taÅŸÄ±ndÄ±',0),(396005,11001,'pl','PO i czas danych przeniÃ³sÅ‚ siÄ™ pomyÅ›lnie',0),(396006,11001,'bg','ÐžÐŸ Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð²Ñ€ÐµÐ¼Ðµ Ð¿Ñ€ÐµÐ¼ÐµÑÑ‚ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(396007,11001,'ur','Ù¾Ùˆ Ø§ÙˆØ± ÙˆÙ‚Øª Ú©ÙˆØ§Ø¦Ù Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ù†ØªÙ‚Ù„ Ú©Ø±Ø¯ÛŒØ§',0),(396008,11001,'sr','ÐŸÐ¾ -Ð° Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð²Ñ€ÐµÐ¼ÐµÐ½Ñƒ ÑÑƒ ÑÐµ Ð¿Ñ€ÐµÑÐµÐ»Ð¸Ð»Ð¸ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(396009,11001,'vi','ÄÆ¡n mua hÃ ng & dá»¯ liá»‡u thá»i gian Ä‘Æ°á»£c chuyá»ƒn thÃ nh cÃ´ng',0),(396010,11001,'af','AB en Tyd Data Suksesvol Geskuif',0),(396011,11001,'ro','PO ÅŸi date de timp sa mutat cu succes',0),(396012,11001,'et','PO ja kellaaeg kolis edukalt',0),(396013,11001,'si','PO in Äasovne podatke uspeÅ¡no prestavljena',0),(396014,11001,'ba','PO dan waktu Data pindah berhasil',0),(396015,11001,'nl','PO en tijdgegevens verplaatst',0),(396016,11001,'fi','PO ja tiedot siirretty onnistuneesti',0),(396017,11001,'no','PO og tidsdata flyttet korrekt',0),(396018,11001,'da','PO og tidsdata flyttet korrekt',0),(396019,11001,'ko','í¬ ë° ì‹œê°„ ë°ì´í„°ëŠ” ì„±ê³µì ìœ¼ë¡œ ì´ë™',0),(396020,11001,'he','×¤×• ×•××ª ×”×–×ž×Ÿ ×”× ×ª×•× ×™× ×¢×‘×¨ ×‘×”×¦×œ×—×”',0),(396021,11001,'el','ÎŸÎ  ÎºÎ±Î¹ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï‡ÏÏŒÎ½Î¿Ï… Î¼ÎµÏ„Î±Ï†Î­ÏÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(396022,11001,'zh','è®¢å•å’Œæ—¶é—´æ•°æ®ç§»åŠ¨æˆåŠŸ\r\n',0),(396023,11001,'sv','PO och tidsdata flyttades',0),(396024,11001,'it','PO Data e ora spostato con successo',0),(396025,11001,'tl','',0),(396026,11001,'th','PO à¹à¸¥à¸°à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸§à¸¥à¸²à¸¢à¹‰à¸²à¸¢à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(396027,11001,'hi','PO à¤”à¤° à¤¸à¤®à¤¯ à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤¿à¤¤',0),(396028,11001,'ms','PO dan masa Data dipindahkan berjaya',0),(396029,11001,'ar','Øµ. Ø¨ ÙˆØ¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ÙˆÙ‚Øª Ø§Ù†ØªÙ‚Ù„Øª Ø¨Ù†Ø¬Ø§Ø­',0),(396030,11001,'fr','PO et les donnÃ©es de temps dÃ©placÃ© avec succÃ¨s',0),(396031,11001,'jp','PO ã¨æ™‚é–“ã®ãƒ‡ãƒ¼ã‚¿ãŒæ­£å¸¸ã«ç§»å‹•',0),(396032,11001,'pt','PO e dados de tempo mudou-se com sucesso',0),(396033,11001,'ru','PO Ð¸ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð´Ð°Ð½Ð½Ñ‹Ñ… ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿ÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ñ‹',0),(396034,11001,'es','Los Datos de Tiempo y OC se Movieron Exitosamente',0),(396035,11001,'de','PO und Zeitdaten erfolgreich verschoben',0),(396036,11001,'en','PO and Time Data Moved Successfully',0),(396037,11002,'is','',0),(396038,11002,'dr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù‚Ø¨Ù„Ø§ Ø¬Ø§Ø¨Ø¬Ø§ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(396039,11002,'pr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù‚Ø¨Ù„Ø§ Ø¬Ø§Ø¨Ø¬Ø§ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(396040,11002,'tr','Bu iÅŸ emri zaten taÅŸÄ±nmÄ±ÅŸ',0),(396041,11002,'pl','Ta kolejnoÅ›Ä‡ pracy zostaÅ‚ juÅ¼ poruszony',0),(396042,11002,'bg','Ð¢Ð°Ð·Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð²ÐµÑ‡Ðµ Ðµ Ð¿Ñ€ÐµÐ¼ÐµÑÑ‚ÐµÐ½',0),(396043,11002,'ur','Ø§Ø³ Ú©Ø§Ù… Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ù¾ÛÙ„Û’ ÛÛŒ Ø¨Ú‘Ú¾Ø§ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(396044,11002,'sr','ÐžÐ²Ð°Ñ˜ Ñ€Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð²ÐµÑ› Ñ˜Ðµ Ð¿Ñ€ÐµÐ¼ÐµÑˆÑ‚ÐµÐ½',0),(396045,11002,'vi','Lá»‡nh nÃ y lÃ m viá»‡c Ä‘Ã£ Ä‘Æ°á»£c chuyá»ƒn',0),(396046,11002,'af','Hierdie werk orde het reeds geskuif',0),(396047,11002,'ro','AceastÄƒ ordine de lucru a fost deja mutat',0),(396048,11002,'et','See tÃ¶Ã¶kÃ¤sk on juba teisaldatud',0),(396049,11002,'si','Ta delovni nalog je Å¾e bil prestavljen',0),(396050,11002,'ba','Urutan kerja ini telah dipindahkan',0),(396051,11002,'nl','Deze volgorde van werk is al verplaatst',0),(396052,11002,'fi','TyÃ¶n jÃ¤rjestyksen on jo siirretty',0),(396053,11002,'no','Denne Arbeidsordre har allerede flyttet',0),(396054,11002,'da','Denne arbejdsordre er blevet flyttet',0),(396055,11002,'ko','ì´ ìž‘ì—… ìˆœì„œëŠ” ì´ë¯¸ ì´ë™ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(396056,11002,'he','×”×–×ž× ×ª ×¢×‘×•×“×” ×–×• ×›×‘×¨ ×”×•×¢×‘×¨×”',0),(396057,11002,'el','Î‘Ï…Ï„Î® Î· ÎµÎ½Ï„Î¿Î»Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î­Ï‡ÎµÎ¹ Î®Î´Î· Î¼ÎµÏ„Î±Ï†ÎµÏÎ¸ÎµÎ¯',0),(396058,11002,'zh','è¿™é¡¹å·¥ä½œç§©åºå·²ç»è¢«ç§»åŠ¨\r\n',0),(396059,11002,'sv','En ordning fÃ¶r detta arbete har redan flyttats',0),(396060,11002,'it','Questo ordine di lavoro Ã¨ giÃ  stato spostato',0),(396061,11002,'tl','',0),(396062,11002,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸à¸²à¸£à¸œà¸¥à¸´à¸•à¸™à¸µà¹‰à¹„à¸”à¹‰à¸–à¸¹à¸à¸¢à¹‰à¸²à¸¢',0),(396063,11002,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤•à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤¿à¤¤ à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(396064,11002,'ms','Arahan kerja-kerja ini telah dipindahkan',0),(396065,11002,'ar','Ù„Ù‚Ø¯ ØªÙ… Ù†Ù‚Ù„ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¹Ù…Ù„',0),(396066,11002,'fr','Ce bon de travail a dÃ©jÃ  Ã©tÃ© dÃ©placÃ©',0),(396067,11002,'jp','ã“ã®ä½œæ¥­ã®é †åºã¯æ—¢ã«ç§»å‹•ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(396068,11002,'pt','Esta ordem de serviÃ§o jÃ¡ foi movido',0),(396069,11002,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑƒÐ¶Ðµ Ð±Ñ‹Ð»Ð° Ð¿ÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð°',0),(396070,11002,'es','Este Orden de Trabajo Ya Se MoviÃ³',0),(396071,11002,'de','Dieser Auftrag ist bereits umgezogen',0),(396072,11002,'en','This Work Order Has Already Been Moved',0),(396073,11003,'is','',0),(396074,11003,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§  ÙŠÙƒ Ù…Ø§Ø¯Ù‡ Ø§ÙˆÙ„ÙŠÙ‡  Ùˆ Ø¯ÙŠÚ¯Ø± ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø±Ø§ Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(396075,11003,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø§Ø¨ØªØ¯Ø§  ÙŠÙƒ Ù…Ø§Ø¯Ù‡ Ø§ÙˆÙ„ÙŠÙ‡  Ùˆ Ø¯ÙŠÚ¯Ø± ØªØºÙŠÙŠØ±Ø§Øª Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø±Ø§ Ø§ÙŠØ¬Ø§Ø¯ ÙƒÙ†ÙŠØ¯ ',0),(396076,11003,'tr','Bir malzeme ve diÄŸer deÄŸiÅŸiklikler oluÅŸturmanÄ±z gerekir ilk servis sipariÅŸi',0),(396077,11003,'pl','NaleÅ¼y utworzyÄ‡ materiaÅ‚y i inne zmiany, pierwsze zlecenie serwisowe',0),(396078,11003,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð¸ Ð´Ñ€ÑƒÐ³Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¿ÑŠÑ€Ð²Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(396079,11003,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù…ÙˆØ§Ø¯ Ø§ÙˆØ± Ø¯ÛŒÚ¯Ø± ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©Ùˆ Ø¨Ù†Ø§Ù†Ø§ Ú†Ø§ÛÛŒÛ’ Ù¾ÛÙ„Û’ Ø¢Ø±ÚˆØ± Ø³Ø±ÙˆØ³',0),(396080,11003,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ ÐºÐ°Ð¾ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ðµ Ð¸ Ð´Ñ€ÑƒÐ³Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð¿Ñ€Ð²Ð¾ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(396081,11003,'vi','Báº¡n pháº£i táº¡o má»›i váº­t liá»‡u vÃ  dá»‹ch vá»¥ thay Ä‘á»•i khÃ¡c trÆ°á»›c',0),(396082,11003,'af','U moet Eers \'n Materiale- en Ander Heffings Bestelling Skep',0),(396083,11003,'ro','Trebuie sÄƒ creaÅ£i o materiale ÅŸi alte modificÄƒri de ordin de serviciu primul',0),(396084,11003,'et','Tuleb luua materjale ja muud muudatused teenuse tellimuse esmalt',0),(396085,11003,'si','Morate ustvariti z materiali in druge spremembe servisnega naloga najprej',0),(396086,11003,'ba','Anda harus membuat bahan-bahan dan perubahan lain layanan urutan pertama',0),(396087,11003,'nl','U moet een materialen en andere wijzigingen maken Service Order eerst',0),(396088,11003,'fi','Materiaalien ja muut muutokset on luotava ensin Huoltotilaus',0),(396089,11003,'no','Du mÃ¥ opprette en materialer og andre endringer serviceordre fÃ¸rst',0),(396090,11003,'da','Du skal oprette en materialer og andre Ã¦ndringer tjeneste rÃ¦kkefÃ¸lge fÃ¸rst',0),(396091,11003,'ko','ìžë£Œ ë° ê¸°íƒ€ ë³€ê²½ ë§Œë“¤ì–´ì•¼ í•©ë‹ˆë‹¤ ë¨¼ì € ì£¼ë¬¸ ì„œë¹„ìŠ¤',0),(396092,11003,'he','×¢×œ×™×š ×œ×™×¦×•×¨ ×—×•×ž×¨×™× ×•×©×™× ×•×™×™× ××—×¨×™× ×‘×©×™×¨×•×ª ×”×¡×“×¨ ×§×•×“×',0),(396093,11003,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î­Î½Î± Ï…Î»Î¹ÎºÎ¬ ÎºÎ±Î¹ Î¬Î»Î»ÎµÏ‚ Î±Î»Î»Î±Î³Î­Ï‚ ÎµÎ½Ï„Î¿Î»Î® Ï„/Ï… Ï€ÏÏŽÏ„Î±',0),(396094,11003,'zh','æ‚¨å¿…é¡»é¦–å…ˆåˆ›å»ºä¸€ä¸ªæœåŠ¡ææ–™å’Œå…¶ä»–æ›´æ”¹çš„æœåŠ¡è®¢å•\r\n',0),(396095,11003,'sv','Du mÃ¥ste skapa ett material och andra fÃ¶rÃ¤ndringar serviceorder fÃ¶rst',0),(396096,11003,'it','Ãˆ necessario creare un materiali e altre modifiche servizio ordine prima',0),(396097,11003,'tl','',0),(396098,11003,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¸œà¸¥à¸´à¸•à¹à¸¥à¸°à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸­à¸·à¹ˆà¸™ à¹† à¸à¹ˆà¸­à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸šà¸£à¸´à¸à¸²à¸£',0),(396099,11003,'hi','à¤¤à¥à¤® à¤à¤• à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤”à¤° à¤…à¤¨à¥à¤¯ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤šà¤¾à¤¹à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤¸à¥‡à¤µà¤¾ à¤ªà¤¹à¤²à¥‡',0),(396100,11003,'ms','Anda mesti mencipta bahan-bahan a dan perubahan lain Perkhidmatan Pesanan pertama',0),(396101,11003,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙˆØ§Ø¯ ÙˆØªØºÙŠÙŠØ±Ø§Øª Ø£Ø®Ø±Ù‰ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© Ø£ÙˆÙ„Ø§Ù‹',0),(396102,11003,'fr','Vous devez crÃ©er un matÃ©riel et autres changements Service ordre d\'abord',0),(396103,11003,'jp','ææ–™ãŠã‚ˆã³ãã®ä»–ã®å¤‰æ›´ã‚’ä½œæˆã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™æœ€åˆã«é †åºã‚’ã‚µãƒ¼ãƒ“ã‚¹',0),(396104,11003,'pt','VocÃª deve criar um materiais e outras alteraÃ§Ãµes de ordem de serviÃ§o primeiro',0),(396105,11003,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹ Ð¸ Ð´Ñ€ÑƒÐ³Ð¸Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ ÑÐ½Ð°Ñ‡Ð°Ð»Ð° Ð¡Ð»ÑƒÐ¶Ð±Ð° Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°',0),(396106,11003,'es','Debe Crear un Orden de Servico de Materiales y Otros Cambios Primero',0),(396107,11003,'de','Sie mÃ¼ssen ein Materialien und andere Ã„nderungen erstellen zuerst Serviceauftrag',0),(396108,11003,'en','You Must Create a Materials and Other Changes Service Order First',0),(396109,11004,'is','',0),(396110,11004,'dr','(Ù…Ø¹Ø§Ø´',0),(396111,11004,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙˆØ§Ù… Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª (Ø­Ù‚ÙˆÙ‚',0),(396112,11004,'tr','Kredi gÃ¼ncelleÅŸtirme & Ã¶deme',0),(396113,11004,'pl','Aktualizacja poÅ¼yczki & zapÅ‚aciÄ‡',0),(396114,11004,'bg','Ð—Ð°ÐµÐ¼ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ & Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(396115,11004,'ur','Ù‚Ø±Ø¶ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº & ØªÙ†Ø®ÙˆØ§Û',0),(396116,11004,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð£Ð¿Ð´Ð°Ñ‚Ðµ & Ð¿Ð»Ð°Ñ‚Ðµ',0),(396117,11004,'vi','Cáº­p Nháº­t cho vay &amp; tráº£',0),(396118,11004,'af','Lening Opdateer & Betaal',0),(396119,11004,'ro','ÃŽmprumut Update & plata',0),(396120,11004,'et','Laenu Update & tasu',0),(396121,11004,'si','Posojilo posodobitev & plaÄati',0),(396122,11004,'ba','Pinjaman Update & membayar',0),(396123,11004,'nl','Lening Update & Pay',0),(396124,11004,'fi','Lainan pÃ¤ivitys & maksu',0),(396125,11004,'no','LÃ¥n oppdateringen & lÃ¸nn',0),(396126,11004,'da','LÃ¥n opdatering & lÃ¸n',0),(396127,11004,'ko','ëŒ€ì¶œ ì—…ë°ì´íŠ¸ & ì§€ë¶ˆ',0),(396128,11004,'he','×¢×“×›×•×Ÿ ×”×œ×•×•××” & ×”×©×›×¨',0),(396129,11004,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Î´Î±Î½ÎµÎ¯Î¿Ï… & Pay',0),(396130,11004,'zh','è´·æ¬¾æ›´æ–°åŠæ”¶è´¹\r\n',0),(396131,11004,'sv','LÃ¥n uppdatering & lÃ¶n',0),(396132,11004,'it','Aggiornamento prestito & Pay',0),(396133,11004,'tl','',0),(396134,11004,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¸™ & à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(396135,11004,'hi','à¤‹à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨ & à¤ªà¥‡',0),(396136,11004,'ms','Kemaskini pinjaman & gaji',0),(396137,11004,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù‚Ø±Ø¶ Ø¢Ù†Ø¯ Ø§Ù„Ø£Ø¬Ø±',0),(396138,11004,'fr','Mise Ã  jour de prÃªt & de rÃ©munÃ©ration',0),(396139,11004,'jp','ãƒ­ãƒ¼ãƒ³æ›´æ–° & æœ‰æ–™',0),(396140,11004,'pt','AtualizaÃ§Ã£o de emprÃ©stimo & de pagamento',0),(396141,11004,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð° & ÐŸÐ»Ð°Ñ‚Ð½Ð¾Ðµ',0),(396142,11004,'es','ActualizaciÃ³n y Pago de PrÃ©stamo',0),(396143,11004,'de','Darlehen Update & Zahlen',0),(396144,11004,'en','Loan Update & Pay',0),(396145,11005,'is','',0),(396146,11005,'dr','(ÙˆØ¸ÙŠÙÙ‡',0),(396147,11005,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø´ØºÙ„ (ÙˆØ¸ÙŠÙÙ‡',0),(396148,11005,'tr','Ä°ÅŸ Makaleler',0),(396149,11005,'pl','Pracy dokumentÃ³w',0),(396150,11005,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(396151,11005,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(396152,11005,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(396153,11005,'vi','TÃ i liá»‡u viá»‡c lÃ m',0),(396154,11005,'af','Kontrakwerk Dokumente',0),(396155,11005,'ro','Job documente',0),(396156,11005,'et','TÃ¶Ã¶ dokumentidega',0),(396157,11005,'si','Delovnih dokumentih',0),(396158,11005,'ba','Dokumen pekerjaan',0),(396159,11005,'nl','Baan documenten',0),(396160,11005,'fi','TyÃ¶ asiakirjoja',0),(396161,11005,'no','Jobb dokumenter',0),(396162,11005,'da','Job dokumenter',0),(396163,11005,'ko','ìž‘ì—… ë¬¸ì„œ',0),(396164,11005,'he','×¢×‘×•×“×” ×©×œ ×ž×¡×ž×›×™×',0),(396165,11005,'el','ÎˆÎ³Î³ÏÎ±Ï†Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(396166,11005,'zh','å·¥ä½œæ–‡ä»¶\r\n',0),(396167,11005,'sv','Jobb dokument',0),(396168,11005,'it','Documenti di lavoro',0),(396169,11005,'tl','',0),(396170,11005,'th','à¸‡à¸²à¸™à¹€à¸­à¸à¸ªà¸²à¸£',0),(396171,11005,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚',0),(396172,11005,'ms','Dokumen-dokumen kerja',0),(396173,11005,'ar','ÙˆØ«Ø§Ø¦Ù‚ Ù…Ù‡Ù…Ø©',0),(396174,11005,'fr','Documents de travail',0),(396175,11005,'jp','ã‚¸ãƒ§ãƒ–æ–‡æ›¸',0),(396176,11005,'pt','Documentos de trabalho',0),(396177,11005,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(396178,11005,'es','Documentos de Trabajo',0),(396179,11005,'de','Job-Dokumente',0),(396180,11005,'en','Job Documents',0),(396181,11006,'is','',0),(396182,11006,'dr','Ø§Ø³Ù†Ø§Ø¯ ÙˆØ§Ù… ',0),(396183,11006,'pr','Ø§Ø³Ù†Ø§Ø¯ ÙˆØ§Ù… ',0),(396184,11006,'tr','Kredi belgeleri',0),(396185,11006,'pl','Dokumenty kredytowe',0),(396186,11006,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(396187,11006,'ur','Ù‚Ø±Ø¶ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(396188,11006,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð°',0),(396189,11006,'vi','TÃ i liá»‡u cho vay',0),(396190,11006,'af','Lening Dokumente',0),(396191,11006,'ro','ÃŽmprumutul documentelor',0),(396192,11006,'et','Laenu dokumendid',0),(396193,11006,'si','Posojilo dokumentov',0),(396194,11006,'ba','Dokumen pinjaman',0),(396195,11006,'nl','Lening documenten',0),(396196,11006,'fi','Laina-asiakirjat',0),(396197,11006,'no','LÃ¥n dokumenter',0),(396198,11006,'da','LÃ¥n dokumenter',0),(396199,11006,'ko','ëŒ€ì¶œ ì„œë¥˜',0),(396200,11006,'he','×ž×¡×ž×›×™ ×”×œ×•×•××”',0),(396201,11006,'el','ÎˆÎ³Î³ÏÎ±Ï†Î± Î´Î±Î½ÎµÎ¯Î¿Ï…',0),(396202,11006,'zh','è´·æ¬¾æ–‡ä»¶\r\n',0),(396203,11006,'sv','LÃ¥n dokument',0),(396204,11006,'it','Prestito documenti',0),(396205,11006,'tl','',0),(396206,11006,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­',0),(396207,11006,'hi','à¤‹à¤£ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚',0),(396208,11006,'ms','Dokumen-dokumen pinjaman',0),(396209,11006,'ar','ÙˆØ«Ø§Ø¦Ù‚ Ø§Ù„Ù‚Ø±Ø¶',0),(396210,11006,'fr','Documents du prÃªt',0),(396211,11006,'jp','ãƒ­ãƒ¼ãƒ³ã®æ›¸é¡ž',0),(396212,11006,'pt','EmprÃ©stimo de documentos',0),(396213,11006,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹ Ð´Ð»Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(396214,11006,'es','Documentos de PrÃ©stamo',0),(396215,11006,'de','Kreditunterlagen',0),(396216,11006,'en','Loan Documents',0),(396217,11007,'is','',0),(396218,11007,'dr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø§Ø¬Ø§Ø±Ù‡',0),(396219,11007,'pr','Ø¨Ø§Ø²Ø¨ÙŠÙ†ÙŠ Ø§Ø¬Ø§Ø±Ù‡',0),(396220,11007,'tr','Kira incelemesi',0),(396221,11007,'pl','PrzeglÄ…d umowy najmu',0),(396222,11007,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(396223,11007,'ur','Ù„ÛŒØ² Ú©Ø§ Ø¬Ø§Ø¦Ø²Û',0),(396224,11007,'sr','ÐÐ°Ñ˜Ð°Ð¼ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(396225,11007,'vi','xem xÃ©t láº¡i há»£p Ä‘á»“ng thuÃª',0),(396226,11007,'af','Huurkontrak Herbesigtig',0),(396227,11007,'ro','Contract de leasing de revizuire',0),(396228,11007,'et','ÃœÃ¼rilepingu lÃ¤bivaatamine',0),(396229,11007,'si','Zakup pregled',0),(396230,11007,'ba','Sewa Review',0),(396231,11007,'nl','Lease recensie',0),(396232,11007,'fi','Vuokrasopimuksen tarkastelu',0),(396233,11007,'no','Leieavtalen gjennomgang',0),(396234,11007,'da','Lease anmeldelse',0),(396235,11007,'ko','ìž„ëŒ€ ê²€í† ',0),(396236,11007,'he','×©×›×™×¨×•×ª ×¡×§×™×¨×”',0),(396237,11007,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·',0),(396238,11007,'zh','ç§Ÿèµé‡æ–°å®¡æ ¸\r\n',0),(396239,11007,'sv','Hyresavtalet recension',0),(396240,11007,'it','Recensione di locazione',0),(396241,11007,'tl','',0),(396242,11007,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(396243,11007,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(396244,11007,'ms','Kajian pajakan',0),(396245,11007,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ø¹Ù‚Ø¯ Ø¥ÙŠØ¬Ø§Ø±',0),(396246,11007,'fr','RÃ©vision du bail',0),(396247,11007,'jp','ãƒªãƒ¼ã‚¹ã®ç¢ºèª',0),(396248,11007,'pt','RevisÃ£o de contrato de arrendamento',0),(396249,11007,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(396250,11007,'es','RevisiÃ³n de Arrendamiento',0),(396251,11007,'de','Leasing-Review',0),(396252,11007,'en','Lease Review',0),(396253,11008,'is','',0),(396254,11008,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(396255,11008,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(396256,11008,'tr','Geri kira iÃ§in',0),(396257,11008,'pl','WrÃ³Ä‡ do dzierÅ¼awy',0),(396258,11008,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(396259,11008,'ur','ÙˆØ§Ù¾Ø³ Ù¾Ù¹Û’ Ù¾Ø± Ø¯ÛŒÙ†Û’ Ú©ÛŒ',0),(396260,11008,'sr','ÐÐ°Ð·Ð°Ð´ Ñƒ Ð·Ð°ÐºÑƒÐ¿',0),(396261,11008,'vi','quay láº¡i cho thuÃª ',0),(396262,11008,'af','Terug na Huurkontrak',0),(396263,11008,'ro','ÃŽnapoi la leasing',0),(396264,11008,'et','Aastasse Ã¼Ã¼rileping',0),(396265,11008,'si','Nazaj v najem',0),(396266,11008,'ba','Kembali ke sewa',0),(396267,11008,'nl','Terug naar Lease',0),(396268,11008,'fi','Palaa vuokrasopimuksen',0),(396269,11008,'no','Til leie',0),(396270,11008,'da','Tilbage til leasing',0),(396271,11008,'ko','ìž„ëŒ€ ëŒì•„ê°€ê¸°',0),(396272,11008,'he','×—×–×¨×” ×¢×œ ×”×—×›×™×¨×”',0),(396273,11008,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î¹Ï‚ Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(396274,11008,'zh','å›žåˆ°ç§Ÿèµ\r\n',0),(396275,11008,'sv','Tillbaka till hyresavtalet',0),(396276,11008,'it','Al contratto di locazione',0),(396277,11008,'tl','',0),(396278,11008,'th','à¹„à¸›à¹€à¸Šà¹ˆà¸²',0),(396279,11008,'hi','à¤µà¤¾à¤ªà¤¸ à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(396280,11008,'ms','Kembali ke pajakan',0),(396281,11008,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(396282,11008,'fr','Retour Ã  bail',0),(396283,11008,'jp','ãƒªãƒ¼ã‚¹ã«æˆ»ã‚‹',0),(396284,11008,'pt','Voltar para locaÃ§Ã£o',0),(396285,11008,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ Ð² Ð°Ñ€ÐµÐ½Ð´Ñƒ',0),(396286,11008,'es','Regresa al Contrato de Arrendamiento',0),(396287,11008,'de','ZurÃ¼ck zu vermieten',0),(396288,11008,'en','Back to Lease',0),(396289,11009,'is','',0),(396290,11009,'dr','Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ±ÙŠ ØªØ§ÙƒÙ†ÙˆÙ† Ø§ÙŠØ¬Ø§Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(396291,11009,'pr','Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ±ÙŠ ØªØ§ÙƒÙ†ÙˆÙ† Ø§ÙŠØ¬Ø§Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(396292,11009,'tr','HiÃ§ fatura henÃ¼z yapÄ±lmÄ±ÅŸ',0),(396293,11009,'pl','Nie wprowadzono jeszcze',0),(396294,11009,'bg','ÐÑÐ¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÐ½Ð¸ Ð¾Ñ‰Ðµ',0),(396295,11009,'ur','Ú©ÙˆØ¦ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ø§Ø¨Ú¾ÛŒ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(396296,11009,'sr','ÐˆÐ¾Ñˆ ÑƒÐ²ÐµÐº Ð½Ð¸ÑÑƒ Ð½Ð°Ð¿Ñ€Ð°Ð²Ñ™ÐµÐ½Ð¸ Ð½ÐµÐ¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(396297,11009,'vi','khÃ´ng cÃ³ hÃ³a Ä‘Æ¡n Ä‘Ã£ Ä‘Æ°á»£c lÃ m chÆ°a',0),(396298,11009,'af','Geen Fakture Is Tans Uitgereik',0),(396299,11009,'ro','Nici facturile au fost fÄƒcute Ã®ncÄƒ',0),(396300,11009,'et','Teinud ega arveid veel',0),(396301,11009,'si','Ni raÄunih so bile Å¡e',0),(396302,11009,'ba','Faktur tidak telah membuat',0),(396303,11009,'nl','Nog hebt geen facturen geboekt',0),(396304,11009,'fi','Laskuja ole vielÃ¤ tehty',0),(396305,11009,'no','Ingen fakturaer er gjort ennÃ¥',0),(396306,11009,'da','Ingen fakturaer er blevet gjort endnu',0),(396307,11009,'ko','ì•„ë‹ˆ ì²­êµ¬ì„œ ì•„ì§ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(396308,11009,'he','×—×©×‘×•× ×™×•×ª ×œ× × ×¢×©×• ×¢×“×™×™×Ÿ',0),(396309,11009,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î´ÎµÎ½ Î­Ï‡Î¿Ï…Î½ Î³Î¯Î½ÎµÎ¹ Î±ÎºÏŒÎ¼Î·',0),(396310,11009,'zh','æ²¡æœ‰å‘ç¥¨å½¢æˆ\r\n',0),(396311,11009,'sv','Inga fakturor har gjorts Ã¤nnu',0),(396312,11009,'it','Nessun fatture sono state fatte ancora',0),(396313,11009,'tl','',0),(396314,11009,'th','à¹„à¸”à¹‰à¸—à¸³à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(396315,11009,'hi','à¤…à¤­à¥€ à¤¤à¤• à¤•à¥‹à¤ˆ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(396316,11009,'ms','Tiada invois yang telah dibuat tetapi',0),(396317,11009,'ar','ÙˆÙ‚Ø¯ Ø¨Ø°Ù„Øª Ø­ØªÙ‰ Ø§Ù„Ø¢Ù† Ø£ÙŠ ÙÙˆØ§ØªÙŠØ±',0),(396318,11009,'fr','Aucune facture n\'a encore Ã©tÃ© faite',0),(396319,11009,'jp','è«‹æ±‚ãŒã¾ã è¡Œã‚ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(396320,11009,'pt','NÃ£o hÃ¡ facturas foram feitas ainda',0),(396321,11009,'ru','ÐŸÐ¾ÐºÐ° ÐÐµÑ‚ Ð¡Ð´ÐµÐ»Ð°Ð½Ð½Ñ‹Ñ… Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(396322,11009,'es','Ya No HabÃ­an Escritos las Facturas',0),(396323,11009,'de','Keine Rechnungen wurden noch vorgenommen',0),(396324,11009,'en','No Invoices Have Been Made Yet',0),(396325,11010,'is','',0),(396326,11010,'dr','Ù†Ù…Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(396327,11010,'pr','Ù†Ù…Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(396328,11010,'tr','FaturalarÄ±nÄ± gÃ¶rÃ¼ntÃ¼leme',0),(396329,11010,'pl','Zobacz faktury',0),(396330,11010,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(396331,11010,'ur','Ù…Ù†Ø¸Ø± ÙˆØ¨Ø¬Ù„ÛŒ',0),(396332,11010,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(396333,11010,'vi','Xem cÃ¡c hÃ³a Ä‘Æ¡n',0),(396334,11010,'af','Besigtig Fature',0),(396335,11010,'ro','Vezi facturi',0),(396336,11010,'et','Arvete vaatamine',0),(396337,11010,'si','PrikaÅ¾i raÄuni',0),(396338,11010,'ba','Lihat faktur',0),(396339,11010,'nl','Weergave facturen',0),(396340,11010,'fi','NÃ¤ytÃ¤ laskut',0),(396341,11010,'no','Vis fakturaer',0),(396342,11010,'da','Se fakturaer',0),(396343,11010,'ko','ë³´ê¸° ì²­êµ¬ì„œ',0),(396344,11010,'he','×ª×¦×•×’×ª ×—×©×‘×•× ×™×•×ª',0),(396345,11010,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(396346,11010,'zh','æŸ¥çœ‹å‘ç¥¨\r\n',0),(396347,11010,'sv','Visa fakturor',0),(396348,11010,'it','Visualizzare le fatture',0),(396349,11010,'tl','',0),(396350,11010,'th','à¸”à¸¹à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(396351,11010,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤šà¤¾à¤²à¤¾à¤¨',0),(396352,11010,'ms','Lihat invois',0),(396353,11010,'ar','Ø¹Ø±Ø¶ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(396354,11010,'fr','Affichage factures',0),(396355,11010,'jp','è«‹æ±‚æ›¸ã®è¡¨ç¤º',0),(396356,11010,'pt','ExibiÃ§Ã£o de faturas',0),(396357,11010,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚Ð°',0),(396358,11010,'es','Visionar Facturas',0),(396359,11010,'de','Anzeigen-Rechnungen',0),(396360,11010,'en','View Invoices',0),(396361,11011,'is','',0),(396362,11011,'dr','(ØºØ±Ø¨Ø§Ù„ Ú¯Ø±ÙŠ',0),(396363,11011,'pr','Ø²Ù…ÙŠÙ†Ù‡ Ù†Ù…Ø§ÙŠØ´(ØºØ±Ø¨Ø§Ù„ Ú¯Ø±ÙŠ',0),(396364,11011,'tr','Arka planda tarama',0),(396365,11011,'pl','Przesiewowych w tle',0),(396366,11011,'bg','Ð¤Ð¾Ð½Ð° ÑÐºÑ€Ð¸Ð½Ð¸Ð½Ð³',0),(396367,11011,'ur','Ù¾Ø³ Ù…Ù†Ø¸Ø±ÛŒ Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯',0);
INSERT INTO `langdef` VALUES (396368,11011,'sr','ÐŸÐ¾Ð·Ð°Ð´Ð¸Ð½Ð° Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(396369,11011,'vi','Ná»n kiá»ƒm tra',0),(396370,11011,'af','Agtergrond Keuring ',0),(396371,11011,'ro','Fundal de Screening',0),(396372,11011,'et','Tausta sÃµelumine',0),(396373,11011,'si','Pregled ozadje',0),(396374,11011,'ba','Pemeriksaan latar belakang',0),(396375,11011,'nl','Achtergrond Screening',0),(396376,11011,'fi','Tausta seulonta',0),(396377,11011,'no','Bakgrunnen Screening',0),(396378,11011,'da','Baggrunden Screening',0),(396379,11011,'ko','ë°°ê²½ ì‹¬ì‚¬',0),(396380,11011,'he','×¨×§×¢ ×”×”×§×¨× ×”',0),(396381,11011,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï†ÏŒÎ½Ï„Î¿Ï…',0),(396382,11011,'zh','èƒŒæ™¯å®¡æŸ¥\r\n',0),(396383,11011,'sv','Bakgrunden Screening',0),(396384,11011,'it','Sfondo Screening',0),(396385,11011,'tl','',0),(396386,11011,'th','à¸„à¸±à¸”à¸à¸£à¸­à¸‡à¸žà¸·à¹‰à¸™à¸«à¸¥à¸±à¸‡',0),(396387,11011,'hi','à¤ªà¥ƒà¤·à¥à¤ à¤­à¥‚à¤®à¤¿ à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤—',0),(396388,11011,'ms','Pemeriksaan latar belakang',0),(396389,11011,'ar','ÙØ­Øµ Ø§Ù„Ø®Ù„ÙÙŠØ©',0),(396390,11011,'fr','DÃ©pistage de l\'arriÃ¨re-plan',0),(396391,11011,'jp','èƒŒæ™¯ã®ã‚¹ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°',0),(396392,11011,'pt','PrÃ©-seleÃ§Ã£o do fundo',0),(396393,11011,'ru','Ð¤Ð¾Ð½ ÑÐºÑ€Ð¸Ð½Ð¸Ð½Ð³',0),(396394,11011,'es','AnÃ¡lisis de Antecedentes',0),(396395,11011,'de','Hintergrund-Screening',0),(396396,11011,'en','Background Screening',0),(396397,11012,'is','',0),(396398,11012,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ù…Ø³ØªØ§Ø¬Ø± ',0),(396399,11012,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ù…Ø³ØªØ§Ø¬Ø± ',0),(396400,11012,'tr','E-posta kiracÄ±',0),(396401,11012,'pl','E-mail najemcy',0),(396402,11012,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»',0),(396403,11012,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±',0),(396404,11012,'sr','Ð•Ð¼Ð°Ð¸Ð» ÑÑ‚Ð°Ð½Ð°Ñ€',0),(396405,11012,'vi','Email ngÆ°á»i thuÃª nhÃ ',0),(396406,11012,'af','E-pos Huurder',0),(396407,11012,'ro','E-mail chiriaÅŸ',0),(396408,11012,'et','E-posti Ã¼Ã¼rnik',0),(396409,11012,'si','Email najemnik',0),(396410,11012,'ba','Email penyewa',0),(396411,11012,'nl','E-mail huurder',0),(396412,11012,'fi','SÃ¤hkÃ¶posti vuokralainen',0),(396413,11012,'no','E-leietaker',0),(396414,11012,'da','E-mail lejer',0),(396415,11012,'ko','ì´ë©”ì¼ ê±°ì£¼ìž',0),(396416,11012,'he','×”×“×™×™×¨ ×“×•×',0),(396417,11012,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(396418,11012,'zh','ç”µå­é‚®ä»¶ç§Ÿå®¢\r\n',0),(396419,11012,'sv','E-hyresgÃ¤st',0),(396420,11012,'it','E-mail inquilino',0),(396421,11012,'tl','',0),(396422,11012,'th','à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(396423,11012,'hi','à¤ˆà¤®à¥‡à¤² à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°',0),(396424,11012,'ms','E-mel penyewa',0),(396425,11012,'ar','Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(396426,11012,'fr','Courriel locataire',0),(396427,11012,'jp','ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒŠãƒ³ãƒˆ',0),(396428,11012,'pt','E-mail inquilino',0),(396429,11012,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(396430,11012,'es','Email de Inquilino',0),(396431,11012,'de','E-Mail-Mieter',0),(396432,11012,'en','Email Tenant',0),(396433,11013,'is','',0),(396434,11013,'dr','Ø³Ø± Ø±Ø³ÙŠØ¯ Ú¯Ø°Ø´ØªÙ‡',0),(396435,11013,'pr','Ø³Ø± Ø±Ø³ÙŠØ¯ Ú¯Ø°Ø´ØªÙ‡',0),(396436,11013,'tr','Vade',0),(396437,11013,'pl','ZalegÅ‚oÅ›ci',0),(396438,11013,'bg','ÐÐ°Ð´ Ð¿Ð¾Ñ€Ð°Ð´Ð¸',0),(396439,11013,'ur','Ø§ÙˆÙˆØ± Ú©ÛŒ ÙˆØ¬Û Ø³Û’',0),(396440,11013,'sr','ÐŸÑ€Ð°ÑÑ‚Ð°Ñ€Ð¾',0),(396441,11013,'vi','quÃ¡ háº¡n',0),(396442,11013,'af','Agterstallig',0),(396443,11013,'ro','Peste cuvenit',0),(396444,11013,'et','TÃ¤htaja Ã¼letanud',0),(396445,11013,'si','Zapadle',0),(396446,11013,'ba','Berakhir karena',0),(396447,11013,'nl','Over tijd',0),(396448,11013,'fi','Yli, koska',0),(396449,11013,'no','Forfalte',0),(396450,11013,'da','Over Due',0),(396451,11013,'ko','ë•Œë¬¸ì—',0),(396452,11013,'he','×¤×’',0),(396453,11013,'el','Î Î­ÏÎ± Î±Ï€ÏŒ Ï„Î· Î´Î­Î¿Ï…ÏƒÎ±',0),(396454,11013,'zh','ç”±äºŽæˆªæ­¢æ—¥æœŸ\r\n',0),(396455,11013,'sv','Ã–ver Due',0),(396456,11013,'it','Sul debito',0),(396457,11013,'tl','',0),(396458,11013,'th','à¹€à¸à¸´à¸™à¸à¸³à¸«à¸™à¸”à¸Šà¸³à¸£à¸°',0),(396459,11013,'hi','à¤–à¤¤à¥à¤® à¤•à¤¾à¤°à¤£',0),(396460,11013,'ms','Lebih disebabkan oleh',0),(396461,11013,'ar','Ø£ÙƒØ«Ø± Ù…Ù† Ø§Ù„ÙˆØ§Ø¬Ø¨',0),(396462,11013,'fr','Ã€ Ã©chÃ©ance',0),(396463,11013,'jp','åŽŸå› ã§',0),(396464,11013,'pt','Sobre o vencimento',0),(396465,11013,'ru','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ',0),(396466,11013,'es','Demoroso',0),(396467,11013,'de','ÃœberfÃ¤llig',0),(396468,11013,'en','Over Due',0),(396469,11014,'is','',0),(396470,11014,'dr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ±Ø¯ ',0),(396471,11014,'pr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ±Ø¯ ',0),(396472,11014,'tr','Son fatura',0),(396473,11014,'pl','Ostatnich faktur',0),(396474,11014,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(396475,11014,'ur','Ø­Ø§Ù„ÛŒÛ ÙˆØ¨Ø¬Ù„ÛŒ',0),(396476,11014,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(396477,11014,'vi','nhá»¯ng hÃ³a Ä‘Æ¡n gáº§n Ä‘Ã¢y',0),(396478,11014,'af','Onlangse Fakture',0),(396479,11014,'ro','Recente facturi',0),(396480,11014,'et','Viimatised arved',0),(396481,11014,'si','Nedavni raÄuni',0),(396482,11014,'ba','Tanggal faktur',0),(396483,11014,'nl','Recente facturen',0),(396484,11014,'fi','Ã„skettÃ¤isiÃ¤ laskuja',0),(396485,11014,'no','Siste fakturaer',0),(396486,11014,'da','Nylige fakturaer',0),(396487,11014,'ko','ìµœê·¼ ì²­êµ¬ì„œ',0),(396488,11014,'he','×—×©×‘×•× ×™×•×ª ××—×¨×•× ×•×ª',0),(396489,11014,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(396490,11014,'zh','æœ€è¿‘çš„å‘ç¥¨\r\n',0),(396491,11014,'sv','Senaste fakturor',0),(396492,11014,'it','Fatture recenti',0),(396493,11014,'tl','',0),(396494,11014,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(396495,11014,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤•à¥€ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸',0),(396496,11014,'ms','Hari invois',0),(396497,11014,'ar','Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø­Ø¯ÙŠØ«Ø©',0),(396498,11014,'fr','Factures rÃ©centes',0),(396499,11014,'jp','æœ€è¿‘ã®è«‹æ±‚æ›¸',0),(396500,11014,'pt','Facturas recentes',0),(396501,11014,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(396502,11014,'es','Facuras Recientes',0),(396503,11014,'de','Den letzten Rechnungen',0),(396504,11014,'en','Recent Invoices',0),(396505,11015,'is','',0),(396506,11015,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ø± Ø§Ø®ÙŠØ± ',0),(396507,11015,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙƒØ§Ø± Ø§Ø®ÙŠØ± ',0),(396508,11015,'tr','Son iÅŸ sipariÅŸleri',0),(396509,11015,'pl','Ostatnich zleceÅ„',0),(396510,11015,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð·Ð°ÑÐ²ÐºÐ¸',0),(396511,11015,'ur','Ú©Ø§Ù… Ú©Û’ Ø­Ø§Ù„ÛŒÛ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(396512,11015,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ñ€Ð°Ð´Ð½Ð¸Ð¼ Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð°',0),(396513,11015,'vi','Táº¡i cÃ´ng viá»‡c Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(396514,11015,'af','Onlangse Werksbestellings',0),(396515,11015,'ro','Ultimele comenzi de lucru',0),(396516,11015,'et','Tehtud tÃ¶Ã¶d jÃ¤rjekorras',0),(396517,11015,'si','Nedavnih delovnih nalogov',0),(396518,11015,'ba','Hari kerja perintah',0),(396519,11015,'nl','Recente werkorders',0),(396520,11015,'fi','Hotelliin TyÃ¶tilaukset',0),(396521,11015,'no','Siste Arbeidsordre',0),(396522,11015,'da','Seneste arbejdsordrer',0),(396523,11015,'ko','ìµœê·¼ ìž‘ì—… ìˆœì„œ',0),(396524,11015,'he','×”×–×ž× ×•×ª ×¢×‘×•×“×” ××—×¨×•× ×•×ª',0),(396525,11015,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(396526,11015,'zh','æœ€è¿‘çš„å·¥ä½œè®¢å•\r\n',0),(396527,11015,'sv','Senaste arbetsorder',0),(396528,11015,'it','Ordini di lavoro recenti',0),(396529,11015,'tl','',0),(396530,11015,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(396531,11015,'hi','à¤¹à¤¾à¤² à¤•à¤¾à¤°à¥à¤¯ à¤†à¤¦à¥‡à¤¶',0),(396532,11015,'ms','Hari arahan kerja',0),(396533,11015,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(396534,11015,'fr','Ordres de travail rÃ©cents',0),(396535,11015,'jp','æœ€è¿‘ã®ä»•äº‹ã®å—æ³¨',0),(396536,11015,'pt','Ordens de trabalho recente',0),(396537,11015,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(396538,11015,'es','Ordenes de Trabajo Recientes',0),(396539,11015,'de','Den letzten ArbeitsauftrÃ¤ge',0),(396540,11015,'en','Recent Work Orders',0),(396541,11016,'is','',0),(396542,11016,'dr','Ù†Ù…Ø§ÙŠØ´ Ú†Ùƒ Ù„ÙŠØ³Øª ',0),(396543,11016,'pr','Ù†Ù…Ø§ÙŠØ´ Ú†Ùƒ Ù„ÙŠØ³Øª ',0),(396544,11016,'tr','GÃ¶rÃ¼nÃ¼m denetim listesi',0),(396545,11016,'pl','Zobacz Lista kontrolna',0),(396546,11016,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(396547,11016,'ur','Ù…Ù†Ø¸Ø± ÙÛØ±Ø³Øª',0),(396548,11016,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(396549,11016,'vi','Xem Danh sÃ¡ch kiá»ƒm tra',0),(396550,11016,'af','Besigtig Nasienlys',0),(396551,11016,'ro','Vezi lista de verificare',0),(396552,11016,'et','Vaade Meelespea',0),(396553,11016,'si','Kontrolni pogled',0),(396554,11016,'ba','Lihat daftar',0),(396555,11016,'nl','Weergave Checklist',0),(396556,11016,'fi','NÃ¤ytÃ¤ tarkistusluettelo',0),(396557,11016,'no','Vis sjekkliste',0),(396558,11016,'da','Se checkliste',0),(396559,11016,'ko','ë³´ê¸° ì²´í¬ ë¦¬ìŠ¤íŠ¸',0),(396560,11016,'he','×ª×¦×•×’×ª ×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢',0),(396561,11016,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€Î¯Î½Î±ÎºÎ± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(396562,11016,'zh','æŸ¥çœ‹æ¸…å•\r\n',0),(396563,11016,'sv','Visa checklista',0),(396564,11016,'it','Vista Checklist',0),(396565,11016,'tl','',0),(396566,11016,'th','à¸”à¸¹à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(396567,11016,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ',0),(396568,11016,'ms','Lihat senarai semak',0),(396569,11016,'ar','Ø¹Ø±Ø¶ Ù‚Ø§Ø¦Ù…Ø© Ù…Ø±Ø¬Ø¹ÙŠØ©',0),(396570,11016,'fr','Voir liste de vÃ©rification',0),(396571,11016,'jp','ãƒ“ãƒ¥ãƒ¼ã®ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆ',0),(396572,11016,'pt','Exibir lista de verificaÃ§Ã£o',0),(396573,11016,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€',0),(396574,11016,'es','Visionar Lista de ComprobaciÃ³n',0),(396575,11016,'de','Ansicht-Checkliste',0),(396576,11016,'en','View Checklist',0),(396577,11017,'is','',0),(396578,11017,'dr','(ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„)',0),(396579,11017,'pr','(ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„)\r\n Wizard',0),(396580,11017,'tr','Sihirbaz hareket',0),(396581,11017,'pl','WyprowadziÄ‡ Kreatora',0),(396582,11017,'bg','Ð˜Ð·Ð½ÐµÑÐ°Ñ‚ ÑÑŠÐ²ÐµÑ‚Ð½Ð¸ÐºÐ°',0),(396583,11017,'ur','Ø¨Ø§ÛØ± Ù…Ø¯Ø¯Ú¯Ø§Ø± Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(396584,11017,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚ Ñ‡Ð°Ñ€Ð¾Ð±ÑšÐ°Ðº',0),(396585,11017,'vi','Di chuyá»ƒn trong thuáº­t sÄ©',0),(396586,11017,'af','Beweeg uit Ghoeroe',0),(396587,11017,'ro','Muta Expertul',0),(396588,11017,'et','Kolima viisard',0),(396589,11017,'si','Izseliti Äarovnik',0),(396590,11017,'ba','Pindah Wizard',0),(396591,11017,'nl','Verhuizen van Wizard',0),(396592,11017,'fi','SiirrÃ¤ pois Ohjattu',0),(396593,11017,'no','Flytte ut veiviseren',0),(396594,11017,'da','Flytte ud guiden',0),(396595,11017,'ko','ë§ˆë²•ì‚¬ ë°–ìœ¼ë¡œ ì´ë™',0),(396596,11017,'he','×–×•×– ××©×£',0),(396597,11017,'el','ÎœÎµÏ„Î±ÎºÎ¿Î¼Î¯Î¶Î¿Ï…Î½ Î¿Î´Î·Î³ÏŒÏ‚',0),(396598,11017,'zh','è¿å‡ºå‘å¯¼\r\n',0),(396599,11017,'sv','Flytta ut guiden',0),(396600,11017,'it','Spostare il Wizard',0),(396601,11017,'tl','',0),(396602,11017,'th','à¸¢à¹‰à¸²à¸¢à¸­à¸­à¸à¸•à¸±à¸§à¸Šà¹ˆà¸§à¸¢à¸ªà¸£à¹‰à¸²à¸‡',0),(396603,11017,'hi','à¤µà¤¿à¤œà¤¼à¤¾à¤°à¥à¤¡ à¤¬à¤¾à¤¹à¤° à¤²à¥‡ à¤œà¤¾à¤à¤',0),(396604,11017,'ms','Mengalih keluar Pendeta',0),(396605,11017,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ø¥Ù„Ù‰ Ù…Ø¹Ø§Ù„Ø¬',0),(396606,11017,'fr','On doit Ã©carter Assistant',0),(396607,11017,'jp','ã‚¦ã‚£ã‚¶ãƒ¼ãƒ‰ã‚’ç§»å‹•ã—ã¾ã™ã€‚',0),(396608,11017,'pt','Sair do assistente',0),(396609,11017,'ru','Ð’Ñ‹Ð¹Ñ‚Ð¸ Ð¼Ð°ÑÑ‚ÐµÑ€',0),(396610,11017,'es','Wizard para Mover Afuera',0),(396611,11017,'de','Ausziehen, Assistent',0),(396612,11017,'en','Move Out Wizard',0),(396613,11018,'is','',0),(396614,11018,'dr','Ø¨Ù‡ Ú†Ùƒ Ù„ÙŠØ³Øª  ØªØ§Ø²Ù‡ Ù…Ù†ØªÙ‚Ù„ Ú©Ø±Ø¯Ù†',0),(396615,11018,'pr','Ø¨Ù‡ Ú†Ùƒ Ù„ÙŠØ³Øª  ØªØ§Ø²Ù‡ Ù…Ù†ØªÙ‚Ù„ Ú©Ø±Ø¯Ù†',0),(396616,11018,'tr','Kontrol Cetveli iÃ§inde hareket',0),(396617,11018,'pl','Ruch w temacie Lista kontrolna',0),(396618,11018,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸ Ð² ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº',0),(396619,11018,'ur','Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª Ù…ÛŒÚº Ù…Ù†ØªÙ‚Ù„ Ú©Ø±ÛŒÚº',0),(396620,11018,'sr','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚Ðµ Ñƒ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ñƒ Ð»Ð¸ÑÑ‚Ñƒ',0),(396621,11018,'vi','Di chuyá»ƒn trong danh sÃ¡ch kiá»ƒm tra',0),(396622,11018,'af','Skuif in Nasienlys',0),(396623,11018,'ro','Mutare Ã®n lista de verificare',0),(396624,11018,'et','Kontroll-loendi teisaldamine',0),(396625,11018,'si','Premakniti v kontrolni seznam',0),(396626,11018,'ba','Bergerak dalam daftar periksa',0),(396627,11018,'nl','Verplaatsen In Controlelijst',0),(396628,11018,'fi','Liikkuvat tarkistuslista',0),(396629,11018,'no','Flytte i Sjekkliste',0),(396630,11018,'da','Flytte i tjekliste',0),(396631,11018,'ko','ê²€ì‚¬ ëª©ë¡ì—ì„œ ì´ë™',0),(396632,11018,'he','×œ×”×¢×‘×™×¨ ×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢',0),(396633,11018,'el','ÎœÎµÏ„Î±ÎºÎ¯Î½Î·ÏƒÎ· ÏƒÏ„Î· Î»Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(396634,11018,'zh','ç§»åŠ¨æ¸…å•\r\n',0),(396635,11018,'sv','Flytta i Checklista',0),(396636,11018,'it','Spostare In Checklist',0),(396637,11018,'tl','',0),(396638,11018,'th','à¸¢à¹‰à¸²à¸¢à¹ƒà¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(396639,11018,'hi','à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ à¤®à¥‡à¤‚ à¤²à¥‡ à¤œà¤¾à¤à¤',0),(396640,11018,'ms','Bergerak dalam senarai semak',0),(396641,11018,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ ÙÙŠ Ù…Ø±Ø¬Ø¹ÙŠØ©',0),(396642,11018,'fr','Se dÃ©placer dans la liste de contrÃ´le',0),(396643,11018,'jp','ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆå†…ã®ç§»å‹•ã—ã¾ã™ã€‚',0),(396644,11018,'pt','Mover-se na lista de verificaÃ§Ã£o',0),(396645,11018,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð² ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(396646,11018,'es','Mueve en Lista de ComprobaciÃ³n',0),(396647,11018,'de','Checkliste einziehen',0),(396648,11018,'en','Move In Checklist',0),(396649,11019,'is','',0),(396650,11019,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ ',0),(396651,11019,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ ',0),(396652,11019,'tr','YÃ¶netim Ã¼creti hesabÄ±',0),(396653,11019,'pl','Konto opÅ‚aty za zarzÄ…dzanie',0),(396654,11019,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ñ‚Ð°ÐºÑÐ¸ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(396655,11019,'ur','Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ ÙÛŒØ³ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(396656,11019,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ',0),(396657,11019,'vi','Quáº£n lÃ½ chi phÃ­ tÃ i khoáº£n',0),(396658,11019,'af','Bestuursfooie Rekening',0),(396659,11019,'ro','Cont de taxele de gestionare',0),(396660,11019,'et','Juhtimise tasu konto',0),(396661,11019,'si','Upravljanje raÄuna takse',0),(396662,11019,'ba','Rekening biaya manajemen',0),(396663,11019,'nl','Verslag over de bedrijfsvoering vergoedingen',0),(396664,11019,'fi','Maksujen osuus',0),(396665,11019,'no','Avgifter kontoen',0),(396666,11019,'da','Driftsregnskab gebyrer',0),(396667,11019,'ko','ê´€ë¦¬ ë¹„ìš© ê³„ì •',0),(396668,11019,'he','×“×ž×™ × ×™×”×•×œ ×—×©×‘×•×Ÿ',0),(396669,11019,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Ï„Î­Î»Î· Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚',0),(396670,11019,'zh','å¸æˆ·ç®¡ç†è´¹\r\n',0),(396671,11019,'sv','Hantering avgifter konto',0),(396672,11019,'it','Gestione Account tasse',0),(396673,11019,'tl','',0),(396674,11019,'th','à¸šà¸±à¸à¸Šà¸µà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£',0),(396675,11019,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤¶à¥à¤²à¥à¤• à¤–à¤¾à¤¤à¤¾',0),(396676,11019,'ms','Akaun yuran pengurusan',0),(396677,11019,'ar','Ø­Ø³Ø§Ø¨ Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥Ø¯Ø§Ø±Ø©',0),(396678,11019,'fr','Compte de frais de gestion',0),(396679,11019,'jp','ç®¡ç†æ–™',0),(396680,11019,'pt','Conta as taxas de gestÃ£o',0),(396681,11019,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð»Ð°Ñ‚Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(396682,11019,'es','Cuotas de AdministraciÃ³n Cuenta',0),(396683,11019,'de','Management-GebÃ¼hren-Konto',0),(396684,11019,'en','Management Fees Account',0),(396685,11020,'is','',0),(396686,11020,'dr','Ø¯Ø±Ø¢Ù…Ø¯ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ ',0),(396687,11020,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ ',0),(396688,11020,'tr','YÃ¶netim Ã¼cretleri gelir',0),(396689,11020,'pl','ZarzÄ…dzanie opÅ‚aty dochodÃ³w',0),(396690,11020,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ñ‚Ð°ÐºÑÐ¸ Ð´Ð¾Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(396691,11020,'ur','Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ ÙÛŒØ³ Ú©ÛŒ Ø¢Ù…Ø¯Ù†ÛŒ',0),(396692,11020,'sr','ÐŸÑ€Ð¸Ñ…Ð¾Ð´ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ',0),(396693,11020,'vi','Quáº£n lÃ½ chi phÃ­ thu nháº­p',0),(396694,11020,'af','Bestuursfooie Inkomste',0),(396695,11020,'ro','Managementul taxelor venituri',0),(396696,11020,'et','Juhtimise tasu tulu',0),(396697,11020,'si','Upravljanje pristojbine dohodka',0),(396698,11020,'ba','Manajemen biaya pendapatan',0),(396699,11020,'nl','Beheer vergoedingen inkomen',0),(396700,11020,'fi','Johdon palkkiot tuloja',0),(396701,11020,'no','Management avgifter inntekt',0),(396702,11020,'da','Ledelse gebyrer indkomst',0),(396703,11020,'ko','ê´€ë¦¬ ìˆ˜ìˆ˜ë£Œ ìˆ˜ìž…',0),(396704,11020,'he','×”×›× ×¡×•×ª ×“×ž×™ × ×™×”×•×œ',0),(396705,11020,'el','Î•Î¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚ Ï„Î­Î»Î· Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚',0),(396706,11020,'zh','ç®¡ç†è´¹æ”¶å…¥\r\n',0),(396707,11020,'sv','Hantering avgifter inkomst',0),(396708,11020,'it','Gestione tasse reddito',0),(396709,11020,'tl','',0),(396710,11020,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£',0),(396711,11020,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤¶à¥à¤²à¥à¤• à¤†à¤¯',0),(396712,11020,'ms','Pendapatan yuran pengurusan',0),(396713,11020,'ar','Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥Ø¯Ø§Ø±Ø©',0),(396714,11020,'fr','Revenus de frais de gestion',0),(396715,11020,'jp','ç®¡ç†æ‰‹æ•°æ–™åŽå…¥',0),(396716,11020,'pt','Renda de taxas de gestÃ£o',0),(396717,11020,'ru','Ð”Ð¾Ñ…Ð¾Ð´ Ð¿Ð»Ð°Ñ‚Ñ‹ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(396718,11020,'es','Cuotas de AdministraciÃ³n Ingreso',0),(396719,11020,'de','Management-GebÃ¼hren-Einnahmen',0),(396720,11020,'en','Management Fees Income',0),(396721,11021,'is','',0),(396722,11021,'dr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ Ø¨Ù‡ ',0),(396723,11021,'pr','Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ Ø¨Ù‡ ',0),(396724,11021,'tr','Ä°Ã§in fatura',0),(396725,11021,'pl','Zapowiadane na',0),(396726,11021,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¾',0),(396727,11021,'ur','Ú©Ùˆ Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(396728,11021,'sr','ÐÐ°Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(396729,11021,'vi','Láº­p hÃ³a Ä‘Æ¡n cho',0),(396730,11021,'af','Te weerspieÃ«l',0),(396731,11021,'ro','Facturat la',0),(396732,11021,'et','Arve',0),(396733,11021,'si','ZaraÄunavajo za',0),(396734,11021,'ba','Ditagih ke',0),(396735,11021,'nl','Gefactureerd aan',0),(396736,11021,'fi','Laskutetaan',0),(396737,11021,'no','Faktureres til',0),(396738,11021,'da','Faktureret til',0),(396739,11021,'ko','ì²­êµ¬',0),(396740,11021,'he','×œ×—×™×™×‘',0),(396741,11021,'el','Î§ÏÎµÏŽÎ½Î¿Ï…Î½',0),(396742,11021,'zh','å¸å•åˆ°\r\n',0),(396743,11021,'sv','Faktureras till',0),(396744,11021,'it','Fatturati al',0),(396745,11021,'tl','',0),(396746,11021,'th','à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(396747,11021,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾',0),(396748,11021,'ms','Dibilkan kepada',0),(396749,11021,'ar','ÙØ§ØªÙˆØ±Ø© Ø¥Ù„Ù‰',0),(396750,11021,'fr','FacturÃ©e au',0),(396751,11021,'jp','ã‚’è«‹æ±‚',0),(396752,11021,'pt','Faturado para',0),(396753,11021,'ru','Ð’Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚ Ð½Ð°',0),(396754,11021,'es','Facturada A',0),(396755,11021,'de','In Rechnung gestellt',0),(396756,11021,'en','Billed To',0),(396757,11022,'is','',0),(396758,11022,'dr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙƒØªÙˆØ± Ù‡Ø§',0),(396759,11022,'pr','Ø§ÙŠØ¬Ø§Ø¯  ÙØ§ÙƒØªÙˆØ± Ù‡Ø§',0),(396760,11022,'tr','FaturalarÄ± OluÅŸtur',0),(396761,11022,'pl','Tworzenie faktur',0),(396762,11022,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(396763,11022,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(396764,11022,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(396765,11022,'vi','táº¡o hÃ³a Ä‘Æ¡n',0),(396766,11022,'af','Fakture Skep',0),(396767,11022,'ro','CreaÅ£i facturi',0),(396768,11022,'et','Loo arved',0),(396769,11022,'si','Ustvarite raÄune',0),(396770,11022,'ba','Membuat faktur',0),(396771,11022,'nl','Maken facturen',0),(396772,11022,'fi','Laskujen luominen',0),(396773,11022,'no','Lage fakturaer',0),(396774,11022,'da','Opret fakturaer',0),(396775,11022,'ko','ì²­êµ¬ì„œë¥¼ ìž‘ì„±',0),(396776,11022,'he','×™×¦×™×¨×ª ×—×©×‘×•× ×™×•×ª',0),(396777,11022,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(396778,11022,'zh','åˆ›å»ºå‘ç¥¨\r\n',0),(396779,11022,'sv','Skapa fakturor',0),(396780,11022,'it','Creare fatture',0),(396781,11022,'tl','',0),(396782,11022,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(396783,11022,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¬à¤¨à¤¾à¤à¤',0),(396784,11022,'ms','Cipta invois',0),(396785,11022,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(396786,11022,'fr','CrÃ©er des factures',0),(396787,11022,'jp','è«‹æ±‚æ›¸ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(396788,11022,'pt','Criar facturas',0),(396789,11022,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚Ð°',0),(396790,11022,'es','Crear Facturas',0),(396791,11022,'de','Rechnungen erstellen',0),(396792,11022,'en','Create Invoices',0),(396793,11023,'is','',0),(396794,11023,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(396795,11023,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¯ÙØªØ± ÙƒÙ„ ',0),(396796,11023,'tr','Masraf GL',0),(396797,11023,'pl','Koszt GL',0),(396798,11023,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° GL',0),(396799,11023,'ur','Ø¬ÛŒØ¬Û’ Ø®Ø±Ú†Û’',0),(396800,11023,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ð“Ð›',0),(396801,11023,'vi','Sá»• cÃ¡i chi phÃ­',0),(396802,11023,'af','Uitgawe AG',0),(396803,11023,'ro','Cheltuiala GL',0),(396804,11023,'et','Kulu GL',0),(396805,11023,'si','StroÅ¡ke GL',0),(396806,11023,'ba','Biaya GL',0),(396807,11023,'nl','Kosten GL',0),(396808,11023,'fi','Kustannuksella GL',0),(396809,11023,'no','Bekostning GL',0),(396810,11023,'da','Udgift GL',0),(396811,11023,'ko','ê²½ë¹„ GL',0),(396812,11023,'he','×”×•×¦××•×ª GL',0),(396813,11023,'el','Î”Î±Ï€Î¬Î½Î· GL',0),(396814,11023,'zh','è´¹ç”¨æ€»å¸\r\n',0),(396815,11023,'sv','Bekostnad GL',0),(396816,11023,'it','Spesa GL',0),(396817,11023,'tl','',0),(396818,11023,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢ GL',0),(396819,11023,'hi','à¤µà¥à¤¯à¤¯ GL',0),(396820,11023,'ms','Perbelanjaan GL',0),(396821,11023,'ar','Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(396822,11023,'fr','Frais GL',0),(396823,11023,'jp','çµŒè²» GL',0),(396824,11023,'pt','Despesa GL',0),(396825,11023,'ru','Ð¡Ñ‡ÐµÑ‚ GL',0),(396826,11023,'es','LM de Gastos',0),(396827,11023,'de','Kosten GL',0),(396828,11023,'en','Expense GL',0),(396829,11024,'is','',0),(396830,11024,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙŠ ',0),(396831,11024,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø¶Ø§ÙÙŠ ',0),(396832,11024,'tr','Ekstra Ã¼cret',0),(396833,11024,'pl','Za dodatkowÄ… opÅ‚atÄ…',0),(396834,11024,'bg','Ð¡Ñ€ÐµÑ‰Ñƒ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(396835,11024,'ur','Ø§Ø¶Ø§ÙÛŒ Ú†Ø§Ø±Ø¬',0),(396836,11024,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¾Ð³ Ð¿ÑƒÑšÐµÑšÐ°',0),(396837,11024,'vi','phÃ­ thÃªm',0),(396838,11024,'af','Ekstra las',0),(396839,11024,'ro','Taxa suplimentara',0),(396840,11024,'et','Lisatasu',0),(396841,11024,'si','DoplaÄila',0),(396842,11024,'ba','Biaya tambahan',0),(396843,11024,'nl','Extra kosten',0),(396844,11024,'fi','LisÃ¤maksusta',0),(396845,11024,'no','Ekstra kostnad',0),(396846,11024,'da','Ekstra gebyr',0),(396847,11024,'ko','ì¶”ê°€ ìš”ê¸ˆ',0),(396848,11024,'he','×—×™×•×‘ × ×•×¡×£',0),(396849,11024,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(396850,11024,'zh','é¢å¤–æ”¶è´¹\r\n',0),(396851,11024,'sv','Extra kostnad',0),(396852,11024,'it','Supplemento',0),(396853,11024,'tl','',0),(396854,11024,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢',0),(396855,11024,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(396856,11024,'ms','Bayaran tambahan',0),(396857,11024,'ar','Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ©',0),(396858,11024,'fr','SupplÃ©ment',0),(396859,11024,'jp','è¿½åŠ æ–™é‡‘',0),(396860,11024,'pt','Custo extra',0),(396861,11024,'ru','Ð—Ð° Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½ÑƒÑŽ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(396862,11024,'es','Cargos Para Extras',0),(396863,11024,'de','Gegen GebÃ¼hr',0),(396864,11024,'en','Extra Charge',0),(396865,11025,'is','',0),(396866,11025,'dr','Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ø²Ø¯',0),(396867,11025,'pr','Ø¯Ø±ØµØ¯ ÙƒØ§Ø±Ù…Ø²Ø¯',0),(396868,11025,'tr','Ãœcreti yÃ¼zde',0),(396869,11025,'pl','Procent opÅ‚aty',0),(396870,11025,'bg','Ð¢Ð°ÐºÑÐ° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(396871,11025,'ur','ÙÛŒØ³ ÙÛŒ ØµØ¯',0),(396872,11025,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ð° Ð¿Ð¾ÑÑ‚Ð¾',0),(396873,11025,'vi','pháº§n trÄƒm phÃ­',0),(396874,11025,'af','Fooi persent',0),(396875,11025,'ro','Taxa la sutÄƒ',0),(396876,11025,'et','LÃµivu %',0),(396877,11025,'si','Pristojbina odstotkov',0),(396878,11025,'ba','Persen biaya',0),(396879,11025,'nl','Vergoeding procent',0),(396880,11025,'fi','LisÃ¤maksun prosentti',0),(396881,11025,'no','Avgift prosent',0),(396882,11025,'da','Gebyr procent',0),(396883,11025,'ko','ìˆ˜ìˆ˜ë£Œ %',0),(396884,11025,'he','××—×•×– ×“×ž×™',0),(396885,11025,'el','Î‘Î¼Î¿Î¹Î²Î® Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(396886,11025,'zh','è´¹çš„ç™¾åˆ†ä¹‹\r\n',0),(396887,11025,'sv','Avgift procent',0),(396888,11025,'it','Per cento del canone',0),(396889,11025,'tl','',0),(396890,11025,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(396891,11025,'hi','à¤¶à¥à¤²à¥à¤• à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(396892,11025,'ms','Peratus yuran',0),(396893,11025,'ar','ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ø±Ø³ÙˆÙ…',0),(396894,11025,'fr','Frais pour cent',0),(396895,11025,'jp','æ–™é‡‘ã® ï¼…',0),(396896,11025,'pt','Por cento de taxa',0),(396897,11025,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(396898,11025,'es','Cuota Porcentaje',0),(396899,11025,'de','GebÃ¼hr Prozent',0),(396900,11025,'en','Fee Percent',0),(396901,11026,'is','',0),(396902,11026,'dr','Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙƒØªÙˆØ± Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(396903,11026,'pr','Ø§ÙŠØ¬Ø§Ø¯ ÙØ§ÙƒØªÙˆØ± Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(396904,11026,'tr','Fatura oluÅŸturma baÅŸarÄ±sÄ±z oldu',0),(396905,11026,'pl','Tworzenie faktury nie powiodÅ‚o siÄ™',0),(396906,11026,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(396907,11026,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†Ø§Ú©Ø§Ù…ÛŒ',0),(396908,11026,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(396909,11026,'vi','táº¡o hÃ³a Ä‘Æ¡n tháº¥t báº¡i',0),(396910,11026,'af','Faktuur-skepping het misluk',0),(396911,11026,'ro','Crearea de facturi nu a reuÈ™it',0),(396912,11026,'et','Arve loomine nurjus',0),(396913,11026,'si','Ustvarjanje raÄuna ni uspelo',0),(396914,11026,'ba','Penciptaan faktur yang gagal',0),(396915,11026,'nl','Factuur creatie is mislukt',0),(396916,11026,'fi','Laskun luominen epÃ¤onnistui',0),(396917,11026,'no','Faktura oppretting mislyktes',0),(396918,11026,'da','Faktura oprettelse mislykkedes',0),(396919,11026,'ko','ì²­êµ¬ì„œ ì°½ì¡°ëŠ” ì‹¤íŒ¨ í–ˆë‹¤',0),(396920,11026,'he','×™×¦×™×¨×ª ×—×©×‘×•× ×™×ª × ×›×©×œ×”',0),(396921,11026,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(396922,11026,'zh','å‘ç¥¨åˆ›å»ºå¤±è´¥\r\n',0),(396923,11026,'sv','Gick inte att skapa faktura',0),(396924,11026,'it','Creazione fattura non riuscita',0),(396925,11026,'tl','',0),(396926,11026,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(396927,11026,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤µà¤¿à¤«à¤² à¤¹à¥à¤†',0),(396928,11026,'ms','Penciptaan invois yang gagal',0),(396929,11026,'ar','ÙØ´Ù„ Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(396930,11026,'fr','CrÃ©ation de facture a Ã©chouÃ©',0),(396931,11026,'jp','è«‹æ±‚æ›¸ä½œæˆã«å¤±æ•—ã—ã¾ã—ãŸ',0),(396932,11026,'pt','CriaÃ§Ã£o de faturas falhada',0),(396933,11026,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(396934,11026,'es','FallÃ³ CreaciÃ³n de Factura',0),(396935,11026,'de','Fehler bei der Rechnungserstellung',0),(396936,11026,'en','Invoice Creation Failed',0),(396937,11027,'is','',0),(396938,11027,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ ',0),(396939,11027,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ ',0),(396940,11027,'tr','YÃ¶netim Ã¼creti',0),(396941,11027,'pl','OpÅ‚aty za zarzÄ…dzanie',0),(396942,11027,'bg','Ð¢Ð°ÐºÑÐ¸Ñ‚Ðµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(396943,11027,'ur','Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ ÙÛŒØ³',0),(396944,11027,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ',0),(396945,11027,'vi','cÃ¡c phÃ­ quáº£n lÃ½',0),(396946,11027,'af','Bestuursfooie',0),(396947,11027,'ro','Taxele de gestionare',0),(396948,11027,'et','Halduskulud',0),(396949,11027,'si','Provizij za upravljanje',0),(396950,11027,'ba','Biaya manajemen',0),(396951,11027,'nl','Beheervergoedingen',0),(396952,11027,'fi','Hallinnointipalkkiot',0),(396953,11027,'no','Forvaltningshonorarer',0),(396954,11027,'da','Administrationsgebyrer',0),(396955,11027,'ko','ê´€ë¦¬ ë¹„',0),(396956,11027,'he','×“×ž×™ ×”× ×™×”×•×œ',0),(396957,11027,'el','ÎˆÎ¾Î¿Î´Î± Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚',0),(396958,11027,'zh','ç®¡ç†è´¹\r\n',0),(396959,11027,'sv','FÃ¶rvaltningsavgifter',0),(396960,11027,'it','Commissioni di gestione',0),(396961,11027,'tl','',0),(396962,11027,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£',0),(396963,11027,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤¶à¥à¤²à¥à¤•',0),(396964,11027,'ms','Yuran pengurusan',0),(396965,11027,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥Ø¯Ø§Ø±Ø©',0),(396966,11027,'fr','Frais de gestion',0),(396967,11027,'jp','ç®¡ç†æ–™',0),(396968,11027,'pt','Taxa de administraÃ§Ã£o',0),(396969,11027,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(396970,11027,'es','Cuotas de AdministraciÃ³n',0),(396971,11027,'de','VerwaltungsgebÃ¼hren',0),(396972,11027,'en','Management Fees',0),(396973,11028,'is','',0),(396974,11028,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ',0),(396975,11028,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ',0),(396976,11028,'tr','YÃ¶netim Ã¼cretleri raporu',0),(396977,11028,'pl','Sprawozdanie zarzÄ…du opÅ‚aty',0),(396978,11028,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð½Ð° Ñ‚Ð°ÐºÑÐ¸Ñ‚Ðµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(396979,11028,'ur','Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ ÙÛŒØ³ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(396980,11028,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ',0),(396981,11028,'vi','bÃ¡o cÃ¡o phÃ­ quáº£n lÃ½',0),(396982,11028,'af','Bestuursfooie Verslag',0),(396983,11028,'ro','Raport de taxe de gestiune',0),(396984,11028,'et','Tasude aruandes',0),(396985,11028,'si','PoroÄilo o upravljanju pristojbine',0),(396986,11028,'ba','Laporan biaya manajemen',0),(396987,11028,'nl','Rapport van de kosten van het beheer',0),(396988,11028,'fi','Johdon palkkiot raportti',0),(396989,11028,'no','Rapport til ledelsen avgifter',0),(396990,11028,'da','Ledelsesberetningen gebyrer',0),(396991,11028,'ko','ê´€ë¦¬ ë¹„ìš© ë³´ê³ ì„œ',0),(396992,11028,'he','×— ×“×ž×™ × ×™×”×•×œ',0),(396993,11028,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î­Î»Î· Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚',0),(396994,11028,'zh','ç®¡ç†è´¹çš„æŠ¥å‘Š\r\n',0),(396995,11028,'sv','Rapporten om fÃ¶rvaltningen avgifter',0),(396996,11028,'it','Relazione sulla gestione tasse',0),(396997,11028,'tl','',0),(396998,11028,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£',0),(396999,11028,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤¶à¥à¤²à¥à¤• à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(397000,11028,'ms','Laporan yuran pengurusan',0),(397001,11028,'ar','ØªÙ‚Ø±ÙŠØ± Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥Ø¯Ø§Ø±Ø©',0),(397002,11028,'fr','Rapport de frais de gestion',0),(397003,11028,'jp','ç®¡ç†æ–™ãƒ¬ãƒãƒ¼ãƒˆ',0),(397004,11028,'pt','RelatÃ³rio de taxas de gestÃ£o',0),(397005,11028,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ±Ð¾Ñ€Ð¾Ð²',0),(397006,11028,'es','Cuotas de AdministraciÃ³n Informe',0),(397007,11028,'de','GebÃ¼hren-Lagebericht',0),(397008,11028,'en','Management Fees Report',0),(397009,11029,'is','',0),(397010,11029,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ Ø§Ø² Ø·Ø±ÙŠÙ‚',0),(397011,11029,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ Ø§Ø² Ø·Ø±ÙŠÙ‚',0),(397012,11029,'tr','YÃ¶netim Ã¼creti Ã¼zerinden',0),(397013,11029,'pl','OpÅ‚aty za zarzÄ…dzanie poprzez',0),(397014,11029,'bg','Ð¢Ð°ÐºÑÐ¸Ñ‚Ðµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‡Ñ€ÐµÐ·',0),(397015,11029,'ur','Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ ÙÛŒØ³ Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(397016,11029,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ ÐºÑ€Ð¾Ð·',0),(397017,11029,'vi','phÃ­ quáº£n lÃ½ qua',0),(397018,11029,'af','Bestuurskoste deur',0),(397019,11029,'ro','Managementul taxelor prin',0),(397020,11029,'et','Haldustasud kaudu',0),(397021,11029,'si','Provizij za upravljanje z',0),(397022,11029,'ba','Biaya manajemen melalui',0),(397023,11029,'nl','Beheervergoedingen door middel van',0),(397024,11029,'fi','Hallinnointipalkkiot kautta',0),(397025,11029,'no','Forvaltningshonorarer gjennom',0),(397026,11029,'da','Administrationsgebyrer gennem',0),(397027,11029,'ko','í†µí•´ ê´€ë¦¬ ë¹„',0),(397028,11029,'he','×“×ž×™ ×”× ×™×”×•×œ ×‘××ž×¦×¢×•×ª',0),(397029,11029,'el','ÎˆÎ¾Î¿Î´Î± Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚ Î¼Î­ÏƒÏ‰',0),(397030,11029,'zh','é€šè¿‡ç®¡ç†è´¹\r\n',0),(397031,11029,'sv','FÃ¶rvaltningsavgifter genom',0),(397032,11029,'it','Commissioni di gestione attraverso',0),(397033,11029,'tl','',0),(397034,11029,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£à¸œà¹ˆà¸²à¸™',0),(397035,11029,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤¶à¥à¤²à¥à¤• à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡',0),(397036,11029,'ms','Yuran pengurusan melalui',0),(397037,11029,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø¥Ø¯Ø§Ø±Ø© Ù…Ù† Ø®Ù„Ø§Ù„',0),(397038,11029,'fr','Frais de gestion Ã  travers',0),(397039,11029,'jp','æ‰‹æ•°æ–™ã‚’ç®¡ç†',0),(397040,11029,'pt','Taxas de gestÃ£o atravÃ©s de',0),(397041,11029,'ru','ÐŸÐ»Ð°Ñ‚Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ñ‡ÐµÑ€ÐµÐ·',0),(397042,11029,'es','Cuotas de AdministraciÃ³n Por',0),(397043,11029,'de','VerwaltungsgebÃ¼hren durch',0),(397044,11029,'en','Management Fees Through',0),(397045,11030,'is','',0),(397046,11030,'dr','Ù‡ÙŠÚ† Ø³Ø§Ø®ØªÙ…Ø§Ù†ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(397047,11030,'pr','Ù‡ÙŠÚ† Ø³Ø§Ø®ØªÙ…Ø§Ù†ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(397048,11030,'tr','HiÃ§bir binalar bulundu',0),(397049,11030,'pl','Nie ma budynkÃ³w, Znalezione',0),(397050,11030,'bg','ÐÑÐ¼Ð° ÑÐ³Ñ€Ð°Ð´Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(397051,11030,'ur','Ú©ÙˆØ¦ÛŒ Ø¹Ù…Ø§Ø±Øª Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(397052,11030,'sr','ÐÐµÐ¼Ð° Ð·Ð³Ñ€Ð°Ð´Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(397053,11030,'vi','TÃ²a nhÃ  khÃ´ng tÃ¬m tháº¥y',0),(397054,11030,'af','Geen geboue gevind',0),(397055,11030,'ro','Nici clÄƒdiri gÄƒsit',0),(397056,11030,'et','Ei leidnud hooned',0),(397057,11030,'si','Stavbe najdemo',0),(397058,11030,'ba','Tidak ada bangunan yang ditemukan',0),(397059,11030,'nl','Geen gebouwen gevonden',0),(397060,11030,'fi','Ole rakennuksia lÃ¶ytynyt',0),(397061,11030,'no','Ingen bygninger funnet',0),(397062,11030,'da','Ingen bygninger fundet',0),(397063,11030,'ko','ì•„ë‹ˆ ê±´ë¬¼ ë°œê²¬',0),(397064,11030,'he','×œ× × ×ž×¦××• ×‘× ×™×™× ×™×',0),(397065,11030,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Ï„Î± ÎºÏ„Î¯ÏÎ¹Î±',0),(397066,11030,'zh','æ²¡æœ‰å»ºç­‘ç‰©å‘çŽ°\r\n',0),(397067,11030,'sv','Inga byggnader finns',0),(397068,11030,'it','No edifici trovati',0),(397069,11030,'tl','',0),(397070,11030,'th','à¸­à¸²à¸„à¸²à¸£à¹„à¸¡à¹ˆà¸žà¸š',0),(397071,11030,'hi','à¤•à¥‹à¤ˆ à¤‡à¤®à¤¾à¤°à¤¤à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(397072,11030,'ms','Tiada bangunan yang ditemui',0),(397073,11030,'ar','Ø§Ù„Ù…Ø¨Ø§Ù†ÙŠ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(397074,11030,'fr','Pas trouvÃ©s de bÃ¢timents',0),(397075,11030,'jp','ãªã„å»ºç‰©ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(397076,11030,'pt','NÃ£o hÃ¡ edifÃ­cios encontrados',0),(397077,11030,'ru','ÐÐµ Ð·Ð´Ð°Ð½Ð¸Ð¹',0),(397078,11030,'es','No se Encontraron Edificios',0),(397079,11030,'de','Keine GebÃ¤ude gefunden',0),(397080,11030,'en','No Buildings Found',0),(397081,11031,'is','',0),(397082,11031,'dr','(Ø§Ù‚Ø³Ø§Ø·) Ù‚Ø¨Ù„ Ø§Ø² ',0),(397083,11031,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ(Ø§Ù‚Ø³Ø§Ø·) Ù‚Ø¨Ù„ Ø§Ø² ',0),(397084,11031,'tr','Ã–nce Ã¶demeleri',0),(397085,11031,'pl','PÅ‚atnoÅ›ci przed',0),(397086,11031,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð°',0),(397087,11031,'ur','Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø³Û’ Ù¾ÛÙ„Û’',0),(397088,11031,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ Ñ˜ÐµÐ´Ð½Ð°Ðº',0),(397089,11031,'vi','khoáº£n thanh toÃ¡n trÆ°á»›c Ä‘áº¿n',0),(397090,11031,'af','Betalings Voor',0),(397091,11031,'ro','PlÄƒÅ£ile Ã®nainte de a',0),(397092,11031,'et','Maksed enne',0),(397093,11031,'si','PlaÄila pred',0),(397094,11031,'ba','Pembayaran sebelum',0),(397095,11031,'nl','Betalingen voorafgaand aan',0),(397096,11031,'fi','Maksut ennen',0),(397097,11031,'no','Betaling fÃ¸r',0),(397098,11031,'da','Betalinger forud for',0),(397099,11031,'ko','ì´ì „ì— ì§€ë¶ˆ',0),(397100,11031,'he','×ª×©×œ×•×ž×™× ×œ×¤× ×™',0),(397101,11031,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½',0),(397102,11031,'zh','ä»˜æ¬¾å‰\r\n',0),(397103,11031,'sv','Betalningar fÃ¶re',0),(397104,11031,'it','Pagamenti prima di',0),(397105,11031,'tl','',0),(397106,11031,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸à¹ˆà¸­à¸™',0),(397107,11031,'hi','à¤•à¥‹ à¤ªà¤¹à¤²à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(397108,11031,'ms','Bayaran sebelum',0),(397109,11031,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ù‚Ø¨Ù„',0),(397110,11031,'fr','Paiements avant',0),(397111,11031,'jp','å‰ã«ãŠæ”¯æ‰•ã„',0),(397112,11031,'pt','Pagamentos antes de',0),(397113,11031,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ Ð´Ð¾',0),(397114,11031,'es','Pagos Antes De',0),(397115,11031,'de','Zahlungen vor',0),(397116,11031,'en','Payments Prior To',0),(397117,11032,'is','',0),(397118,11032,'dr','( ÙÙŠ) Ù…Ø¬Ù…ÙˆØ¹',0),(397119,11032,'pr','Ø¨Ù‡Ø§Ù‰ ÙˆØ§Ø­Ø¯( ÙÙŠ) ÙƒÙ„',0),(397120,11032,'tr','Toplam Ã¼cret',0),(397121,11032,'pl','OpÅ‚ata caÅ‚kowita',0),(397122,11032,'bg','ÐžÐ±Ñ‰Ð° Ñ‚Ð°ÐºÑÐ°',0),(397123,11032,'ur','Ú©Ù„ ÙÛŒØ³',0),(397124,11032,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð½Ð°ÐºÐ½Ð°Ð´Ð°',0),(397125,11032,'vi','Tá»•ng chi phÃ­',0),(397126,11032,'af','Totale Fooi',0),(397127,11032,'ro','Taxa totalÄƒ',0),(397128,11032,'et','LÃµivu kogusumma',0),(397129,11032,'si','Skupna vsota pristojbin',0),(397130,11032,'ba','Total biaya',0),(397131,11032,'nl','Totale vergoeding vaststellen',0),(397132,11032,'fi','Maksun kokonaismÃ¤Ã¤rÃ¤n',0),(397133,11032,'no','Totalprisen',0),(397134,11032,'da','Samlede gebyr',0),(397135,11032,'ko','ì´ ìš”ê¸ˆ',0),(397136,11032,'he','×¡×” ×› ×“×ž×™',0),(397137,11032,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® Î±Î¼Î¿Î¹Î²Î®',0),(397138,11032,'zh','æ€»è´¹ç”¨\r\n',0),(397139,11032,'sv','Total avgift',0),(397140,11032,'it','Costo totale',0),(397141,11032,'tl','',0),(397142,11032,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸£à¸§à¸¡',0),(397143,11032,'hi','à¤•à¥à¤² à¤¶à¥à¤²à¥à¤•',0),(397144,11032,'ms','Jumlah yuran',0),(397145,11032,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø±Ø³ÙˆÙ…',0),(397146,11032,'fr','Prix total Ã  payer',0),(397147,11032,'jp','åˆè¨ˆæ–™é‡‘',0),(397148,11032,'pt','Taxa total',0),(397149,11032,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(397150,11032,'es','Cuota Total',0),(397151,11032,'de','GesamtgebÃ¼hr',0),(397152,11032,'en','Total Fee',0),(397153,11033,'is','',0),(397154,11033,'dr','Ù†Ø±Ø® Ù¾Ø§ÙŠÙ‡ Ø¨Ø±Ù‚',0),(397155,11033,'pr','Ù†Ø±Ø® Ù¾Ø§ÙŠÙ‡ Ø¨Ø±Ù‚',0),(397156,11033,'tr','Elektrik oranÄ± temeli',0),(397157,11033,'pl','Elektryczne stawki',0),(397158,11033,'bg','Ð•Ð»ÐµÐºÑ‚Ñ€Ð¸Ñ‡ÐµÑÐºÐ¸ Ð¾ÑÐ½Ð¾Ð²Ð°',0),(397159,11033,'ur','Ø¨Ø¬Ù„ÛŒ Ú©ÛŒ Ø´Ø±Ø­ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯',0),(397160,11033,'sr','Ð•Ð»ÐµÐºÑ‚Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ‚Ð¾Ð¿Ð° Ð¾ÑÐ½Ð¾Ð²Ð°',0),(397161,11033,'vi','CÆ¡ sá» tá»· lá»‡ Ä‘iá»‡n ',0),(397162,11033,'af','Elektriese Basis Tarief',0),(397163,11033,'ro','Baza electrice Rate',0),(397164,11033,'et','Elektri hinda aluseks',0),(397165,11033,'si','ElektriÄni stopnja podlaga',0),(397166,11033,'ba','Dasar tarif listrik',0),(397167,11033,'nl','Elektrische tarief Basis',0),(397168,11033,'fi','Electric perusteella',0),(397169,11033,'no','Elektriske Rate Basis',0),(397170,11033,'da','Elektrisk sats',0),(397171,11033,'ko','ì „ê¸° ìš”ê¸ˆ ê¸°ì¤€',0),(397172,11033,'he','×‘×¡×™×¡ ×—×©×ž×œ×™',0),(397173,11033,'el','Î—Î»ÎµÎºÏ„ÏÎ¹ÎºÏŒ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î²Î¬ÏƒÎ·',0),(397174,11033,'zh','ç‚¹è´¹çŽ‡åŸºç¡€\r\n',0),(397175,11033,'sv','Elektriska rÃ¤ntesats',0),(397176,11033,'it','Base della tariffa elettrica',0),(397177,11033,'tl','',0),(397178,11033,'th','à¸­à¸±à¸•à¸£à¸²à¹„à¸Ÿà¸Ÿà¹‰à¸²à¸žà¸·à¹‰à¸™à¸à¸²à¸™',0),(397179,11033,'hi','à¤¬à¤¿à¤œà¤²à¥€ à¤¦à¤° à¤†à¤§à¤¾à¤°',0),(397180,11033,'ms','Kadar elektrik',0),(397181,11033,'ar','Ø£Ø³Ø§Ø³ Ù…Ø¹Ø¯Ù„ Ø§Ù„ÙƒÙ‡Ø±Ø¨Ø§Ø¦ÙŠØ©',0),(397182,11033,'fr','Base taux Ã©lectrique',0),(397183,11033,'jp','é›»æ°—æ–™é‡‘ã®åŸºç¤Ž',0),(397184,11033,'pt','ElÃ©trica taxa base',0),(397185,11033,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ð¾Ð¹ ÑÑ‚Ð°Ð²ÐºÐµ',0),(397186,11033,'es','Base de Factores de Tarifas de Luz',0),(397187,11033,'de','Elektro Tarif Basis',0),(397188,11033,'en','Electric Rate Basis',0),(397189,11034,'is','',0),(397190,11034,'dr','( Ø¨Ù†Ø²ÙŠÙ†',0),(397191,11034,'pr','Ù…Ø¨Ù†Ø§ÙŠ Ù†Ø±Ø® Ú¯Ø§Ø²( Ø¨Ù†Ø²ÙŠÙ†',0),(397192,11034,'tr','Gaz oranÄ± temeli',0),(397193,11034,'pl','Gaz stawki',0),(397194,11034,'bg','Ð“Ð°Ð· Ð¾ÑÐ½Ð¾Ð²Ð°',0),(397195,11034,'ur','Ú¯ÛŒØ³ Ú©ÛŒ Ø´Ø±Ø­ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯',0),(397196,11034,'sr','ÐžÑÐ½Ð¾Ð²Ð° ÑÑ‚Ð¾Ð¿Ð° Ð³Ð°ÑÐ°',0),(397197,11034,'vi','tá»· lá»‡ gas cÆ¡ báº£n',0),(397198,11034,'af','Brandstof Tarief Basis',0),(397199,11034,'ro','Baza de Rate de gaz',0),(397200,11034,'et','Gaasi mÃ¤Ã¤ra alusel',0),(397201,11034,'si','Plin stopnja podlaga',0),(397202,11034,'ba','Dasar TARIF gas',0),(397203,11034,'nl','Gas tarief Basis',0),(397204,11034,'fi','Kaasun perusteella',0),(397205,11034,'no','Gass Rate Basis',0),(397206,11034,'da','Gas sats',0),(397207,11034,'ko','ê°€ìŠ¤ ìš”ê¸ˆ ê¸°ì¤€',0),(397208,11034,'he','×’×– ×ª×¢×¨×™×£ ×‘×¡×™×¡',0),(397209,11034,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î²Î¬ÏƒÎ· Î±ÎµÏÎ¯Î¿Ï…',0),(397210,11034,'zh','ç‡ƒæ°”çŽ‡çš„åŸºç¡€\r\n',0),(397211,11034,'sv','Gas rÃ¤ntesats',0),(397212,11034,'it','Gas tasso base',0),(397213,11034,'tl','',0),(397214,11034,'th','à¸à¹Šà¸²à¸‹à¸­à¸±à¸•à¸£à¸²à¸žà¸·à¹‰à¸™à¸à¸²à¸™',0),(397215,11034,'hi','à¤—à¥ˆà¤¸ à¤•à¥€ à¤¦à¤° à¤†à¤§à¤¾à¤°',0),(397216,11034,'ms','Asas kadar gas',0),(397217,11034,'ar','Ø£Ø³Ø§Ø³ Ø³Ø¹Ø± Ø§Ù„ØºØ§Ø²',0),(397218,11034,'fr','Base de taux de gaz',0),(397219,11034,'jp','ã‚¬ã‚¹æ–™é‡‘ãƒ™ãƒ¼ã‚¹',0),(397220,11034,'pt','GÃ¡s taxa base',0),(397221,11034,'ru','ÐžÑÐ½Ð¾Ð²Ñ‹ ÑÐºÐ¾Ñ€Ð¾ÑÑ‚ÑŒ Ð³Ð°Ð·Ð°',0),(397222,11034,'es','Base de Factores de Tarifas de Gas',0),(397223,11034,'de','Gas Tarif Basis',0),(397224,11034,'en','Gas Rate Basis',0),(397225,11035,'is','',0),(397226,11035,'dr','Ù…Ø¨Ù†Ø§ÙŠ Ù¾ÙˆÙ„ Ø§Ø¨',0),(397227,11035,'pr','Ù…Ø¨Ù†Ø§ÙŠ Ù¾ÙˆÙ„ Ø§Ø¨',0),(397228,11035,'tr','Su oranÄ± temeli',0),(397229,11035,'pl','Wody stawki',0),(397230,11035,'bg','Ð’Ð¾Ð´Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ð°',0),(397231,11035,'ur','Ù¾Ø§Ù†ÛŒ Ú©ÛŒ Ø´Ø±Ø­ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯',0),(397232,11035,'sr','ÐžÑÐ½Ð¾Ð²Ð° ÑÑ‚Ð¾Ð¿Ð° Ð²Ð¾Ð´Ðµ',0),(397233,11035,'vi','CÆ¡ sá»Ÿ tá»· lá»‡ nÆ°á»›c',0),(397234,11035,'af','Water Basis Tarief',0),(397235,11035,'ro','BazÄƒ ratÄƒ de apÄƒ',0),(397236,11035,'et','Vee mÃ¤Ã¤ra alusel',0),(397237,11035,'si','Osnovi vode stopnja',0),(397238,11035,'ba','Dasar TARIF air',0),(397239,11035,'nl','Water tarief Basis',0),(397240,11035,'fi','Veden perusteella',0),(397241,11035,'no','Vann Rate Basis',0),(397242,11035,'da','Vand sats',0),(397243,11035,'ko','ë¬¼ ì†ë„ ê¸°ì¤€',0),(397244,11035,'he','×‘×¡×™×¡ ×ª×¢×¨×™×£ ×”×ž×™×',0),(397245,11035,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î½ÎµÏÎ¿Ï Î²Î¬ÏƒÎ·',0),(397246,11035,'zh','æ°´çŽ‡çš„åŸºç¡€\r\n',0),(397247,11035,'sv','Vatten rÃ¤ntesats',0),(397248,11035,'it','Acqua tasso base',0),(397249,11035,'tl','',0),(397250,11035,'th','à¹€à¸à¸“à¸‘à¹Œà¸­à¸±à¸•à¸£à¸²à¸™à¹‰à¸³',0),(397251,11035,'hi','à¤ªà¤¾à¤¨à¥€ à¤•à¥€ à¤¦à¤° à¤†à¤§à¤¾à¤°',0),(397252,11035,'ms','Kadar air',0),(397253,11035,'ar','Ø£Ø³Ø§Ø³ Ù…Ø¹Ø¯Ù„ Ø§Ù„Ù…ÙŠØ§Ù‡',0),(397254,11035,'fr','Base de la taxe de l\'eau',0),(397255,11035,'jp','æ°´é“æ–™é‡‘ã®åŸºç¤Ž',0),(397256,11035,'pt','Base de taxa de Ã¡gua',0),(397257,11035,'ru','ÐžÑÐ½Ð¾Ð²Ðµ Ð²Ð¾Ð´Ñ‹',0),(397258,11035,'es','Base de Cuota de Agua',0),(397259,11035,'de','Wasser-Rate-Basis',0),(397260,11035,'en','Water Rate Basis',0),(397261,11036,'is','',0),(397262,11036,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ù‡Ø§',0),(397263,11036,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ù‡Ø§',0),(397264,11036,'tr','Komisyon hesaplama',0),(397265,11036,'pl','Obliczenia prowizji',0),(397266,11036,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ñ‚Ðµ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸',0),(397267,11036,'ur','Ú©Ù…ÛŒØ´Ù† Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(397268,11036,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ðµ',0),(397269,11036,'vi','TÃ­nh hoa há»“ng',0),(397270,11036,'af','Bereken Kommissies',0),(397271,11036,'ro','Calcula comisioanele',0),(397272,11036,'et','Komisjonitasu',0),(397273,11036,'si','IzraÄunati provizije',0),(397274,11036,'ba','Menghitung komisi',0),(397275,11036,'nl','Berekenen van commissies',0),(397276,11036,'fi','Laskee palkkiot',0),(397277,11036,'no','Beregne provisjon',0),(397278,11036,'da','Beregn kommissioner',0),(397279,11036,'ko','ìˆ˜ìˆ˜ë£Œ ê³„ì‚°',0),(397280,11036,'he','×—×™×©×•×‘ ×”×¢×ž×œ×•×ª',0),(397281,11036,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯ÏƒÏ„Îµ Ï„Î¹Ï‚ Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚',0),(397282,11036,'zh','è®¡ç®—ä½£é‡‘\r\n',0),(397283,11036,'sv','BerÃ¤kna provisioner',0),(397284,11036,'it','Calcolare le commissioni',0),(397285,11036,'tl','',0),(397286,11036,'th','à¸„à¸³à¸™à¸§à¸“à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™',0),(397287,11036,'hi','à¤—à¤£à¤¨à¤¾ à¤†à¤¯à¥‹à¤—à¥‹à¤‚',0),(397288,11036,'ms','Kira komisen',0),(397289,11036,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù„Ø¬Ø§Ù†',0),(397290,11036,'fr','Calculer les Commissions',0),(397291,11036,'jp','æ‰‹æ•°æ–™ã‚’è¨ˆç®—ã—ã¾ã™ã€‚',0),(397292,11036,'pt','Calcular comissÃµes',0),(397293,11036,'ru','Ð Ð°ÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ ÐšÐ¾Ð¼Ð¼Ð¸ÑÑÐ¸ÑŽ',0),(397294,11036,'es','Calcula Comisiones',0),(397295,11036,'de','Provisionen berechnen',0),(397296,11036,'en','Calculate Commissions',0),(397297,11037,'is','',0),(397298,11037,'dr','Ù…Ø§Ù…ÙˆØ±ÙŠØª',0),(397299,11037,'pr','Ù…Ø§Ù…ÙˆØ±ÙŠØª',0),(397300,11037,'tr','Komisyonlar',0),(397301,11037,'pl','Prowizje',0),(397302,11037,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸',0),(397303,11037,'ur','Ú©Ù…ÛŒØ´Ù†',0),(397304,11037,'sr','ÐŸÑ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ð°',0),(397305,11037,'vi','hoa há»“ng',0),(397306,11037,'af','Kommissies',0),(397307,11037,'ro','Comisioane',0),(397308,11037,'et','Komisjonid',0),(397309,11037,'si','Komisij',0),(397310,11037,'ba','Komisi',0),(397311,11037,'nl','Commissies',0),(397312,11037,'fi','Palkkiot',0),(397313,11037,'no','Provisjoner',0),(397314,11037,'da','Provisioner',0),(397315,11037,'ko','ìˆ˜ìˆ˜ë£Œ',0),(397316,11037,'he','×¢×ž×œ×•×ª',0),(397317,11037,'el','Î ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚',0),(397318,11037,'zh','ä½£é‡‘\r\n',0),(397319,11037,'sv','Provisioner',0),(397320,11037,'it','Commissioni',0),(397321,11037,'tl','',0),(397322,11037,'th','à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™',0),(397323,11037,'hi','à¤†à¤¯à¥‹à¤—à¥‹à¤‚',0),(397324,11037,'ms','Komisen',0),(397325,11037,'ar','Ø§Ù„Ø¹Ù…ÙˆÙ„Ø§Øª',0),(397326,11037,'fr','Commissions',0),(397327,11037,'jp','æ‰‹æ•°æ–™',0),(397328,11037,'pt','ComissÃµes',0),(397329,11037,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(397330,11037,'es','Comisiones',0),(397331,11037,'de','Kommissionen',0),(397332,11037,'en','Commissions',0),(397333,11038,'is','',0),(397334,11038,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù…Ø­Ø§Ø³Ø¨Ù‡ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ù‡Ø§',0),(397335,11038,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù…Ø­Ø§Ø³Ø¨Ù‡ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ù‡Ø§',0),(397336,11038,'tr','BaÅŸarÄ±sÄ±zlÄ±k komisyonlarÄ± hesaplama',0),(397337,11038,'pl','Brak obliczania prowizji',0),(397338,11038,'bg','ÐÐµÑƒÑÐ¿ÐµÑ… Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸',0),(397339,11038,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©Ù…ÛŒØ´Ù†ÙˆÚº Ú©Û’ Ø­Ø³Ø§Ø¨',0),(397340,11038,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ðµ',0),(397341,11038,'vi','tÃ­nh toÃ¡n hoa há»“ng tháº¥t báº¡i',0),(397342,11038,'af','Mislukking berekening van kommissies',0),(397343,11038,'ro','EÅŸecul calcularea comisioane',0),(397344,11038,'et','Rike arvutamisel komisjonitasud',0),(397345,11038,'si','Neuspeh izraÄun provizije',0),(397346,11038,'ba','Kegagalan menghitung komisi',0),(397347,11038,'nl','Mislukking berekening van commissies',0),(397348,11038,'fi','Virhe laskettaessa palkkiot',0),(397349,11038,'no','Feil beregning av provisjon',0),(397350,11038,'da','Manglende beregning af provisioner',0),(397351,11038,'ko','ì‹¤íŒ¨ ê³„ì‚° ìˆ˜ìˆ˜ë£Œ',0),(397352,11038,'he','×›×©×œ ×—×™×©×•×‘ ×”×¢×ž×œ×•×ª',0),(397353,11038,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Ï„Î¿Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚',0),(397354,11038,'zh','è®¡ç®—ä½£é‡‘å¤±è´¥\r\n',0),(397355,11038,'sv','Fel berÃ¤kning av provisioner',0),(397356,11038,'it','Errore calcolo commissioni',0),(397357,11038,'tl','',0),(397358,11038,'th','à¸„à¸§à¸²à¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§à¹ƒà¸™à¸à¸²à¸£à¸„à¸³à¸™à¸§à¸“à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™',0),(397359,11038,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤—à¤£à¤¨à¤¾ à¤†à¤¯à¥‹à¤—à¥‹à¤‚',0),(397360,11038,'ms','Kegagalan mengira komisen',0),(397361,11038,'ar','ÙØ´Ù„ Ø­Ø³Ø§Ø¨ Ø§Ù„Ù„Ø¬Ø§Ù†',0),(397362,11038,'fr','Ã‰chec calcul des Commissions',0),(397363,11038,'jp','å¤±æ•—ã®æ‰‹æ•°æ–™ã‚’è¨ˆç®—ã—ã¾ã™ã€‚',0),(397364,11038,'pt','Falha cÃ¡lculo de comissÃµes',0),(397365,11038,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ñ€Ð°ÑÑ‡ÐµÑ‚Ð° ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¹',0),(397366,11038,'es','FallÃ³ Calculando Comisiones',0),(397367,11038,'de','Ausfall berechnen Kommissionen',0),(397368,11038,'en','Failure Calculating Commissions',0),(397369,11039,'is','',0),(397370,11039,'dr','ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ù‡Ø§  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯',0),(397371,11039,'pr','ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ù‡Ø§  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯',0),(397372,11039,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde hesaplanan komisyon',0),(397373,11039,'pl','Prowizje obliczane pomyÅ›lnie',0),(397374,11039,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸, Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(397375,11039,'ur','Ú©Ù…ÛŒØ´Ù† Ù†Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø³Ø§Ø¨',0),(397376,11039,'sr','ÐŸÑ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ð° Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(397377,11039,'vi','tÃ­nh toÃ¡n hoa há»“ng thÃ nh cÃ´ng',0),(397378,11039,'af','Kommissies Suksesvol Bereken',0),(397379,11039,'ro','Comisioane calculatÄƒ cu succes',0),(397380,11039,'et','Komisjonitasu arvutamise edukalt',0),(397381,11039,'si','Komisij, izraÄuna uspeÅ¡no',0),(397382,11039,'ba','Komisi dihitung berhasil',0),(397383,11039,'nl','Commissies berekend met succes',0),(397384,11039,'fi','Palkkioiden laskenta onnistui',0),(397385,11039,'no','Provisjoner beregnes vellykket',0),(397386,11039,'da','Provision beregnet korrekt',0),(397387,11039,'ko','ì„±ê³µì ìœ¼ë¡œ ê³„ì‚° í•˜ëŠ” ìœ„ì›íšŒ',0),(397388,11039,'he','×¢×ž×œ×•×ª ×ž×—×•×©×‘ ×‘×”×¦×œ×—×”',0),(397389,11039,'el','Î ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚ Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(397390,11039,'zh','ä½£é‡‘è®¡ç®—æˆåŠŸ\r\n',0),(397391,11039,'sv','Provisioner berÃ¤knas framgÃ¥ngsrikt',0),(397392,11039,'it','Commissioni calcolate correttamente',0),(397393,11039,'tl','',0),(397394,11039,'th','à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™à¸—à¸µà¹ˆà¸„à¸³à¸™à¸§à¸“à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(397395,11039,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤†à¤¯à¥‹à¤—à¥‹à¤‚',0),(397396,11039,'ms','Komisyen dikira berjaya',0),(397397,11039,'ar','Ø­Ø³Ø¨Øª Ø§Ù„Ø¹Ù…ÙˆÙ„Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(397398,11039,'fr','Commissions calculÃ©es avec succÃ¨s',0),(397399,11039,'jp','æ­£å¸¸ã«è¨ˆç®—æ‰‹æ•°æ–™',0),(397400,11039,'pt','ComissÃµes calculadas com sucesso',0),(397401,11039,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ñ‹Ð²Ð°ÐµÑ‚ÑÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(397402,11039,'es','Comisiones Calculados Exitosamente',0),(397403,11039,'de','Provisionen berechnet erfolgreich',0),(397404,11039,'en','Commissions Calculated Successfully',0),(397405,11040,'is','',0),(397406,11040,'dr','Ø«Ø§Ø¨Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(397407,11040,'pr','Ø«Ø§Ø¨Øª ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(397408,11040,'tr','Komisyon, dÃ¼z',0),(397409,11040,'pl','Komisji z pÅ‚askim',0),(397410,11040,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð¿Ð»Ð¾ÑÑŠÐº',0),(397411,11040,'ur','Ú©ØªØ±Ù†ÙˆÚº ÙÙ„ÛŒÙ¹',0),(397412,11040,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° ÑÑ‚Ð°Ð½',0),(397413,11040,'vi','máº·t báº±ng hoa há»“ng',0),(397414,11040,'af','Doen plat',0),(397415,11040,'ro','Comision plat',0),(397416,11040,'et','Komisjoni Ã¼htse',0),(397417,11040,'si','Komisije stanovanje',0),(397418,11040,'ba','Komisi datar',0),(397419,11040,'nl','Flat van de Commissie',0),(397420,11040,'fi','Komission taulu',0),(397421,11040,'no','Kommisjonen Flat',0),(397422,11040,'da','Kommissionens faste',0),(397423,11040,'ko','íŽ¸í‰í•œ ìœ„ì›íšŒ',0),(397424,11040,'he','×¢×ž×œ×” ×©×˜×•×—',0),(397425,11040,'el','Î¤Î·Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î·Ï‚',0),(397426,11040,'zh','å›ºå®šä½£é‡‘\r\n',0),(397427,11040,'sv','Kommissionens platt',0),(397428,11040,'it','Piatto della Commissione',0),(397429,11040,'tl','',0),(397430,11040,'th','à¹à¸šà¸™à¸„à¸“à¸°à¸à¸£à¸£à¸¡à¸à¸²à¸£',0),(397431,11040,'hi','à¤†à¤¯à¥‹à¤— à¤•à¥‡ à¤«à¥à¤²à¥ˆà¤Ÿ',0),(397432,11040,'ms','Suruhanjaya rata',0),(397433,11040,'ar','Ù‡ÙŠØ¦Ø© Ù…Ø³Ø·Ø­Ø©',0),(397434,11040,'fr','Plat de la Commission',0),(397435,11040,'jp','å§”å“¡ä¼šã¯ãƒ•ãƒ©ãƒƒãƒˆ',0),(397436,11040,'pt','Plano da ComissÃ£o',0),(397437,11040,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ñ Ñ Ð¿Ð»Ð¾ÑÐºÐ¸Ð¼',0),(397438,11040,'es','ComisiÃ³n Fijo',0),(397439,11040,'de','Wohnung der Kommission',0),(397440,11040,'en','Commission Flat',0),(397441,11041,'is','',0),(397442,11041,'dr','Ø¯Ø±ØµØ¯ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(397443,11041,'pr','Ø¯Ø±ØµØ¯ ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† ',0),(397444,11041,'tr','Komisyon yÃ¼zdesi',0),(397445,11041,'pl','Procent Komisji',0),(397446,11041,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(397447,11041,'ur','Ú©Ù…ÛŒØ´Ù† Ù…ÛŒÚº Ø´Ø±Ø­ ÙÛŒ ØµØ¯',0),(397448,11041,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚',0),(397449,11041,'vi','tá»· lá»‡ hoa há»“ng',0),(397450,11041,'af','Kommissie Persentasie',0),(397451,11041,'ro','Procentul de Comisia',0),(397452,11041,'et','Komisjonitasu protsent',0),(397453,11041,'si','Komisija odstotek',0),(397454,11041,'ba','Persentase komisi',0),(397455,11041,'nl','Commissie Percentage',0),(397456,11041,'fi','Komission osuutta',0),(397457,11041,'no','Provisjonssats i prosent',0),(397458,11041,'da','Kommissionen procentdel',0),(397459,11041,'ko','ìž„ë¬´ ë°±ë¶„ìœ¨',0),(397460,11041,'he','×¢×ž×œ×ª ××—×•×–×™×',0),(397461,11041,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(397462,11041,'zh','ä½£é‡‘ç™¾åˆ†æ¯”\r\n',0),(397463,11041,'sv','Kommissionen procent',0),(397464,11041,'it','Commissione percentuale',0),(397465,11041,'tl','',0),(397466,11041,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™',0),(397467,11041,'hi','à¤•à¤®à¥€à¤¶à¤¨ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(397468,11041,'ms','Peratus komisyen',0),(397469,11041,'ar','Ù†Ø³Ø¨Ø© Ø§Ù„Ø¹Ù…ÙˆÙ„Ø©',0),(397470,11041,'fr','Pourcentage des commissions',0),(397471,11041,'jp','ä»»å‹™ã®ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ',0),(397472,11041,'pt','Porcentagem de ComissÃ£o',0),(397473,11041,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(397474,11041,'es','ComisiÃ³n Porcentaje',0),(397475,11041,'de','Kommission Prozent',0),(397476,11041,'en','Commission Percentage',0),(397477,11042,'is','',0),(397478,11042,'dr','ÙƒØ³Ø¨ Ø´Ø¯Ù‡ ',0),(397479,11042,'pr','ÙƒØ³Ø¨ Ø´Ø¯Ù‡ ',0),(397480,11042,'tr','KazanÄ±lan',0),(397481,11042,'pl','ZdobyÅ‚',0),(397482,11042,'bg','Ð¡Ð¿ÐµÑ‡ÐµÐ»ÐµÐ½Ð¸',0),(397483,11042,'ur','Ú©Ù…Ø§Ø¦ÛŒ',0),(397484,11042,'sr','Ð—Ð°Ñ€Ð°Ð´Ð¸Ð¾',0),(397485,11042,'vi','Kiáº¿m Ä‘Æ°á»£c',0),(397486,11042,'af','Verdien',0),(397487,11042,'ro','A cÃ¢ÅŸtigat',0),(397488,11042,'et','Teenitud',0),(397489,11042,'si','PrisluÅ¾il',0),(397490,11042,'ba','Diterima',0),(397491,11042,'nl','Verdiend',0),(397492,11042,'fi','Ansainnut',0),(397493,11042,'no','Opptjent',0),(397494,11042,'da','Tjent',0),(397495,11042,'ko','ì ë¦½',0),(397496,11042,'he','×ž×–×•×›×”',0),(397497,11042,'el','ÎšÎµÏÎ´Î¯ÏƒÎµÎ¹',0),(397498,11042,'zh','æŒ£å¾—\r\n',0),(397499,11042,'sv','TjÃ¤nat',0),(397500,11042,'it','Guadagnato',0),(397501,11042,'tl','',0),(397502,11042,'th','à¹„à¸”à¹‰à¸£à¸±à¸š',0),(397503,11042,'hi','à¤…à¤°à¥à¤œà¤¿à¤¤ à¤•à¤¿à¤¯à¤¾',0),(397504,11042,'ms','Diperolehi',0),(397505,11042,'ar','Ø­ØµÙ„',0),(397506,11042,'fr','GagnÃ©',0),(397507,11042,'jp','ç²å¾—',0),(397508,11042,'pt','Ganhou',0),(397509,11042,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð»',0),(397510,11042,'es','Devengado',0),(397511,11042,'de','Verdient',0),(397512,11042,'en','Earned',0),(397513,11043,'is','',0),(397514,11043,'dr','Ù‡ÙŠÚ† ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ø¯Ø§Ø±Ø§ÙŠ ØµÙ„Ø§Ø­ÙŠØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(397515,11043,'pr','Ù‡ÙŠÚ† ÙƒÙ…ÙŠØ³ÙŠÙˆÙ† Ø¯Ø§Ø±Ø§ÙŠ ØµÙ„Ø§Ø­ÙŠØªÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(397516,11043,'tr','Ã–n eleme komisyon kurmak yok',0),(397517,11043,'pl','Brak kwalifikacji prowizji znaleÅºÄ‡',0),(397518,11043,'bg','Ð‘ÐµÐ· ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð¸ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(397519,11043,'ur','Ú©ÙˆØ¦ÛŒ Ú©ÙˆØ§Ù„ÛŒÙØ§Ø¦Ù†Ú¯ Ú©Ù…ÛŒØ´Ù†ÙˆÚº Ù¾Ø§ÛŒØ§',0),(397520,11043,'sr','ÐÐµÐ¼Ð° ÐºÐ²Ð°Ð»Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½Ðµ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð°Ð¼Ð° Ð½Ð°ÑˆÐ»Ð¸',0),(397521,11043,'vi','khÃ´ng tÃ¬m tháº¥y tiÃªu chuáº©n chiáº¿t kháº¥u',0),(397522,11043,'af','Geen Kwalifiserende Kommissies Gevind',0),(397523,11043,'ro','Nu comisioane calificare gÄƒsit',0),(397524,11043,'et','Ei leitud olulist osalust komisjonitasud',0),(397525,11043,'si','Ne kvalificirani komisij naÅ¡el',0),(397526,11043,'ba','Tidak ada komisi kualifikasi yang ditemukan',0),(397527,11043,'nl','Geen kwalificatie commissies gevonden',0),(397528,11043,'fi','Ei lÃ¶ytynyt oikeutettuja palkkiot',0),(397529,11043,'no','Ingen kvalifiserte provisjon funnet',0),(397530,11043,'da','Ingen kvalificerende provisioner fundet',0),(397531,11043,'ko','ë°œê²¬ ìžê²© ìˆ˜ìˆ˜ë£Œ',0),(397532,11043,'he','××™×Ÿ ×¢×ž×œ×•×ª ×ž×•×§×“×ž×•×ª × ×ž×¦××•',0),(397533,11043,'el','Î”ÎµÎ½ Ï€Î»Î·ÏÎµÎ¯ Ï„Î¹Ï‚ Ï€ÏÎ¿Ï‹Ï€Î¿Î¸Î­ÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(397534,11043,'zh','æ²¡æœ‰æ‰¾åˆ°èµ„æ ¼å®¡æŸ¥å§”å‘˜ä¼š\r\n',0),(397535,11043,'sv','Inga kvalificerande provisioner hittade',0),(397536,11043,'it','Nessuna Commissione di qualificazione trovata',0),(397537,11043,'tl','',0),(397538,11043,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸„à¸“à¸°à¸à¸£à¸£à¸¡à¸à¸²à¸£à¸„à¸±à¸”à¹€à¸¥à¸·à¸­à¸à¸—à¸µà¹ˆà¸žà¸š',0),(397539,11043,'hi','à¤•à¥‹à¤ˆ à¤¯à¥‹à¤—à¥à¤¯à¤¤à¤¾ à¤•à¤®à¥€à¤¶à¤¨ à¤®à¤¿à¤²à¤¾',0),(397540,11043,'ms','Tiada komisen kelayakan yang ditemui',0),(397541,11043,'ar','Ù„Ø§ Ø§Ù„Ù„Ø¬Ø§Ù† Ø§Ù„Ù…Ø¤Ù‡Ù„Ø© Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(397542,11043,'fr','Pas trouvÃ©es de Commissions admissibles',0),(397543,11043,'jp','ç™ºè¦‹äºˆé¸æ‰‹æ•°æ–™ãªã—',0),(397544,11043,'pt','Sem comissÃµes de qualificaÃ§Ã£o encontradas',0),(397545,11043,'ru','ÐšÐ²Ð°Ð»Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½Ð½Ñ‹Ðµ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(397546,11043,'es','No se Encontraron Comisiones Calificadas',0),(397547,11043,'de','Keine qualifizierte AuftrÃ¤ge gefunden',0),(397548,11043,'en','No Qualifying Commissions Found',0),(397549,11044,'is','',0),(397550,11044,'dr','(ÙƒØ³Ø¨ Ù†Ø´Ø¯Ù‡',0),(397551,11044,'pr','Ø¯Ø±ÙŠØ§ÙØª Ù†Ø´Ø¯Ù‡ (ÙƒØ³Ø¨ Ù†Ø´Ø¯Ù‡',0),(397552,11044,'tr','KazanÄ±lmamÄ±ÅŸ',0),(397553,11044,'pl','Niezrealizowane',0),(397554,11044,'bg','ÐŸÑ€ÐµÐ½ÐµÑÐµÐ½Ð¸Ñ‚Ðµ',0),(397555,11044,'ur','Ø§Ù†ÛŒØ¢Ø±Ù†Ø§Ø¯',0),(397556,11044,'sr','ÐÐµÐ·Ð°Ñ€Ð°Ñ’ÐµÐ½Ð¾Ð³',0),(397557,11044,'vi','Thu nháº­p khÃ´ng lÃ m viá»‡c mÃ  cÃ³',0),(397558,11044,'af','Onverdiend',0),(397559,11044,'ro','NeÃ®ncasate',0),(397560,11044,'et','Ettemakstud',0),(397561,11044,'si','Prenosne',0),(397562,11044,'ba','Tanpa kerja',0),(397563,11044,'nl','Onverdiende',0),(397564,11044,'fi','Ansaitsematon',0),(397565,11044,'no','GjenstÃ¥ende',0),(397566,11044,'da','Ufortjent',0),(397567,11044,'ko','ë¶ˆë¡œ',0),(397568,11044,'he','×™×•×›×œ',0),(397569,11044,'el','ÎœÎ· Î´ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Î±',0),(397570,11044,'zh','é¢„æ”¶\r\n',0),(397571,11044,'sv','Ej intjÃ¤nade',0),(397572,11044,'it','Non acquisiti',0),(397573,11044,'tl','',0),(397574,11044,'th','à¸•à¹ˆà¸­',0),(397575,11044,'hi','à¤…à¤¨à¤°à¥à¤œà¤¿à¤¤',0),(397576,11044,'ms','Belum diperolehi',0),(397577,11044,'ar','ØºÙŠØ± Ù…ÙƒØªØ³Ø¨',0),(397578,11044,'fr','Non acquises',0),(397579,11044,'jp','æœªçµŒéŽ',0),(397580,11044,'pt','NÃ£o adquiridos',0),(397581,11044,'ru','ÐÐµÐ·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½Ð½Ñ‹Ðµ',0),(397582,11044,'es','No Devengado',0),(397583,11044,'de','Unverdienten',0),(397584,11044,'en','Unearned',0),(397585,11045,'is','',0),(397586,11045,'dr','ÙÙˆØª Ù…Ø±Ø¨Ø¹ ',0),(397587,11045,'pr','ÙÙˆØª Ù…Ø±Ø¨Ø¹ ',0),(397588,11045,'tr','Metrekare',0),(397589,11045,'pl','MetrÃ³w kwadratowych',0),(397590,11045,'bg','ÐšÐ²Ð°Ð´Ñ€Ð°Ñ‚Ð½Ð¸ Ð¼ÐµÑ‚Ñ€Ð°',0),(397591,11045,'ur','Ù…Ø±Ø¨Ø¹ ÙÙ¹',0),(397592,11045,'sr','ÐšÐ²Ð°Ð´Ñ€Ð°Ñ‚Ð½Ð¸Ñ… Ð¼ÐµÑ‚Ð°Ñ€Ð°',0),(397593,11045,'vi','Feet vuÃ´ng',0),(397594,11045,'af','Vierkantige voete',0),(397595,11045,'ro','PÄƒtraÅ£i',0),(397596,11045,'et','Ruutmeetrit',0),(397597,11045,'si','Kvadratnih metrov',0),(397598,11045,'ba','Kaki persegi',0),(397599,11045,'nl','Vierkante voet',0),(397600,11045,'fi','NeliÃ¶metriÃ¤',0),(397601,11045,'no','Spesielle sÃ¦rtrekk',0),(397602,11045,'da','Kvadratfod',0),(397603,11045,'ko','í‰ë°© í”¼íŠ¸',0),(397604,11045,'he','×ž×˜×¨ ×ž×¨×•×‘×¢',0),(397605,11045,'el','Î¤ÎµÏ„ÏÎ±Î³Ï‰Î½Î¹ÎºÎ¬ Ï€ÏŒÎ´Î¹Î±',0),(397606,11045,'zh','å¹³æ–¹è‹±å°º\r\n',0),(397607,11045,'sv','Kvadratfot',0),(397608,11045,'it','Piedi quadrati',0),(397609,11045,'tl','',0),(397610,11045,'th','à¸•à¸²à¸£à¸²à¸‡à¸Ÿà¸¸à¸•',0),(397611,11045,'hi','à¤µà¤°à¥à¤— à¤«à¥à¤Ÿ',0),(397612,11045,'ms','Kaki persegi',0),(397613,11045,'ar','Ù‚Ø¯Ù… Ù…Ø±Ø¨Ø¹',0),(397614,11045,'fr','Pieds carrÃ©s',0),(397615,11045,'jp','å¹³æ–¹ãƒ•ã‚£ãƒ¼ãƒˆ',0),(397616,11045,'pt','PÃ©s quadrados',0),(397617,11045,'ru','ÐšÐ²Ð°Ð´Ñ€Ð°Ñ‚Ð½Ñ‹Ñ… Ñ„ÑƒÑ‚Ð¾Ð²',0),(397618,11045,'es','Pies Cuadrados',0),(397619,11045,'de','Quadrat-FuÃŸ',0),(397620,11045,'en','Square Feet',0),(397621,11046,'is','',0),(397622,11046,'dr','SB  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(397623,11046,'pr','SB  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´',0),(397624,11046,'tr','SB',0),(397625,11046,'pl','SB',0),(397626,11046,'bg','SB',0),(397627,11046,'ur','ÙØ±ÛŒØ¶Û Ø³Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯Û’',0),(397628,11046,'sr','Ð¡Ð‘',0),(397629,11046,'vi','SB',0),(397630,11046,'af','SB',0),(397631,11046,'ro','SB',0),(397632,11046,'et','SB',0),(397633,11046,'si','SB',0),(397634,11046,'ba','SB',0),(397635,11046,'nl','SB',0),(397636,11046,'fi','SB',0),(397637,11046,'no','SB',0),(397638,11046,'da','SB',0),(397639,11046,'ko','SB',0),(397640,11046,'he','SB',0),(397641,11046,'el','SB',0),(397642,11046,'zh','æœåŠ¡å…¬å‘Š\r\n',0),(397643,11046,'sv','SB',0),(397644,11046,'it','SB',0),(397645,11046,'tl','',0),(397646,11046,'th','SB',0),(397647,11046,'hi','SB',0),(397648,11046,'ms','SB',0),(397649,11046,'ar','Ø¨ÙŠÙ†Ø§Ù„ÙŠ Ø§Ù„Ø´Ø§Ø±Ù‚Ø©',0),(397650,11046,'fr','SB',0),(397651,11046,'jp','SB',0),(397652,11046,'pt','SB',0),(397653,11046,'ru','SB',0),(397654,11046,'es','SB',0),(397655,11046,'de','SB',0),(397656,11046,'en','SB',0),(397657,11047,'is','',0),(397658,11047,'dr','ÙØ§ÙƒØªÙˆØ±   ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ',0),(397659,11047,'pr','ÙØ§ÙƒØªÙˆØ±   ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ',0),(397660,11047,'tr','Fatura yÃ¶netim Ã¼creti',0),(397661,11047,'pl','OpÅ‚aty za zarzÄ…dzanie faktury',0),(397662,11047,'bg','Ð¢Ð°ÐºÑÐ¸Ñ‚Ðµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(397663,11047,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø§Ù†ØªØ¸Ø§Ù… Ú©ÛŒ ÙÛŒØ³',0),(397664,11047,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(397665,11047,'vi','HoÃ¡ Ä‘Æ¡n quáº£n lÃ½ chi phÃ­',0),(397666,11047,'af','Faktuur bestuurskoste',0),(397667,11047,'ro','Taxele de Management factura',0),(397668,11047,'et','Arve valitsemistasud',0),(397669,11047,'si','Provizij za upravljanje raÄuna',0),(397670,11047,'ba','Biaya manajemen faktur',0),(397671,11047,'nl','Factuur beheervergoedingen',0),(397672,11047,'fi','Laskun hallinnointipalkkiot',0),(397673,11047,'no','Faktura forvaltningshonorarer',0),(397674,11047,'da','Faktura administrationsgebyrer',0),(397675,11047,'ko','ì†¡ìž¥ ê´€ë¦¬ ìˆ˜ìˆ˜ë£Œ',0),(397676,11047,'he','×“×ž×™ ×”× ×™×”×•×œ ×—×©×‘×•× ×™×ª',0),(397677,11047,'el','ÎˆÎ¾Î¿Î´Î± Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(397678,11047,'zh','å‘ç¥¨ç®¡ç†è´¹\r\n',0),(397679,11047,'sv','Faktura fÃ¶rvaltningsavgifter',0),(397680,11047,'it','Commissioni di gestione fattura',0),(397681,11047,'tl','',0),(397682,11047,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(397683,11047,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤¶à¥à¤²à¥à¤•',0),(397684,11047,'ms','Yuran pengurusan invois',0),(397685,11047,'ar','Ø±Ø³ÙˆÙ… Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(397686,11047,'fr','Facture des frais de gestion',0),(397687,11047,'jp','è«‹æ±‚ç®¡ç†æ‰‹æ•°æ–™',0),(397688,11047,'pt','Taxas de gestÃ£o factura',0),(397689,11047,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(397690,11047,'es','Cuotas de GestiÃ³n de Facturas',0),(397691,11047,'de','Invoice Management-GebÃ¼hren',0),(397692,11047,'en','Invoice Management Fees',0),(397693,11048,'is','',0),(397694,11048,'dr','Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ Ø¯Ø± Ú¯Ø±ÙØªÙ† ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ÙØ§ÙƒØªÙˆØ± ',0),(397695,11048,'pr','Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ Ø¯Ø± Ú¯Ø±ÙØªÙ† ÙØ§ÙŠÙ„ Ù¾ÙŠ Ø¯ÙŠ Ø§Ù ÙØ§ÙƒØªÙˆØ± ',0),(397696,11048,'tr','Fatura PDF alÄ±namadÄ±',0),(397697,11048,'pl','UdaÅ‚o siÄ™ uzyskaÄ‡ faktur PDF',0),(397698,11048,'bg','ÐÐµ ÑƒÑÐ¿Ñ Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° PDF',0),(397699,11048,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ PDF Ø­Ø§ØµÙ„ Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(397700,11048,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð° Ð´Ð° Ð´Ð¾Ð±Ð¸Ñ˜Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ ÐŸÐ”Ð¤',0),(397701,11048,'vi','Tháº¥t báº¡i trong viá»‡c nháº­n Ä‘Æ°á»£c hÃ³a Ä‘Æ¡n PDF',0),(397702,11048,'af','Kon kry van faktuur PDF',0),(397703,11048,'ro','Nu pentru a obÅ£ine facturii PDF',0),(397704,11048,'et','Ei saanud arve PDF',0),(397705,11048,'si','Uspelo dobiti raÄuna PDF',0),(397706,11048,'ba','Gagal mendapatkan faktur PDF',0),(397707,11048,'nl','Failed to Get factuur PDF',0),(397708,11048,'fi','Ei saanut laskun PDF',0),(397709,11048,'no','Kan ikke hente faktura PDF',0),(397710,11048,'da','Det lykkedes ikke at fÃ¥ faktura PDF',0),(397711,11048,'ko','ì¸ë³´ì´ìŠ¤ PDFë¥¼ ê°€ì ¸ì˜¤ëŠ” ë° ì‹¤íŒ¨',0),(397712,11048,'he','×§×‘×œ×ª ×—×©×‘×•× ×™×ª PDF × ×›×©×œ×”',0),(397713,11048,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· Î»Î®ÏˆÎ· Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… PDF',0),(397714,11048,'zh','æ— æ³•å–å¾—å‘ç¥¨PDFæ ¼å¼\r\n',0),(397715,11048,'sv','Det gick inte att fÃ¥ faktura PDF',0),(397716,11048,'it','Impossibile ottenere fattura PDF',0),(397717,11048,'tl','',0),(397718,11048,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸£à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ PDF',0),(397719,11048,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ PDF à¤ªà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¥‡',0),(397720,11048,'ms','Gagal mendapatkan invois PDF',0),(397721,11048,'ar','ÙØ´Ù„ ÙÙŠ Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø© PDF',0),(397722,11048,'fr','Impossible d\'obtenir la facture PDF',0),(397723,11048,'jp','Pdf ãƒ•ã‚¡ã‚¤ãƒ«ã®è«‹æ±‚æ›¸ã‚’å–å¾—ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(397724,11048,'pt','Falha ao obter a factura PDF',0),(397725,11048,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð° PDF',0),(397726,11048,'es','FallÃ³ Agarrar PDF de Factura',0),(397727,11048,'de','Fehler beim Abrufen der Rechnung PDF',0),(397728,11048,'en','Failed to Get Invoice PDF',0),(397729,11049,'is','',0),(397730,11049,'dr','Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ Ø¯Ø± ÙØ±Ø³ØªØ§Ø¯Ù† ',0),(397731,11049,'pr','Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ Ø¯Ø± ÙØ±Ø³ØªØ§Ø¯Ù† ',0),(397732,11049,'tr','GÃ¶ndermek iÃ§in baÅŸarÄ±sÄ±z oldu',0),(397733,11049,'pl','Nie udaÅ‚o siÄ™ wysÅ‚aÄ‡',0),(397734,11049,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ',0),(397735,11049,'ur','Ø¨Ú¾ÛŒØ¬ÛŒÚº Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§',0),(397736,11049,'sr','Ð¡Ð»Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(397737,11049,'vi','KhÃ´ng gá»­i',0),(397738,11049,'af','Kon stuur nie',0),(397739,11049,'ro','Nu a trimite',0),(397740,11049,'et','Saatmine nurjus',0),(397741,11049,'si','PoÅ¡iljanje ni uspelo',0),(397742,11049,'ba','Gagal untuk mengirim',0),(397743,11049,'nl','Failed to Send',0),(397744,11049,'fi','Ei voitu lÃ¤hettÃ¤Ã¤',0),(397745,11049,'no','Kunne ikke sende',0),(397746,11049,'da','Undladt at sende',0),(397747,11049,'ko','ì†¡ì‹  ì‹¤íŒ¨',0),(397748,11049,'he','× ×›×©×œ×” ×©×œ×—',0),(397749,11049,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(397750,11049,'zh','å‘é€å¤±è´¥\r\n',0),(397751,11049,'sv','Det gick inte att skicka',0),(397752,11049,'it','Impossibile inviare',0),(397753,11049,'tl','',0),(397754,11049,'th','à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§à¹ƒà¸™à¸à¸²à¸£à¸ªà¹ˆà¸‡',0),(397755,11049,'hi','à¤­à¥‡à¤œà¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(397756,11049,'ms','Gagal untuk hantar',0),(397757,11049,'ar','ÙØ´Ù„ ÙÙŠ Ø¥Ø±Ø³Ø§Ù„',0),(397758,11049,'fr','Impossible d\'envoyer',0),(397759,11049,'jp','é€ä¿¡ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(397760,11049,'pt','Falha ao enviar',0),(397761,11049,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ',0),(397762,11049,'es','FallÃ³ Enviar',0),(397763,11049,'de','Fehler beim Senden',0),(397764,11049,'en','Failed to Send',0),(397765,11050,'is','',0),(397766,11050,'dr','Ù„Ø·ÙØ§ Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒÙ†ÙŠØ¯ Ø¨Ø§ ',0),(397767,11050,'pr','Ù„Ø·ÙØ§ Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒÙ†ÙŠØ¯ Ø¨Ø§ ',0),(397768,11050,'tr','LÃ¼tfen Ã¶deme',0),(397769,11050,'pl','ZapÅ‚aÄ‡ przez',0),(397770,11050,'bg','ÐœÐ¾Ð»Ñ, Ð¾Ð±ÑŠÑ€Ð½ÐµÑ‚Ðµ Ð¾Ñ‚',0),(397771,11050,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø¯Ø§ Ú©Ø±ØªÛ’ Û”',0),(397772,11050,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° Ð¿Ð»Ð°Ñ‚Ð¸',0),(397773,11050,'vi','Xin vui lÃ²ng thanh toÃ¡n báº±ng',0),(397774,11050,'af','Betaal Asseblief Per',0),(397775,11050,'ro','VÄƒ rugÄƒm sÄƒ plÄƒteascÄƒ de',0),(397776,11050,'et','Palun maksta',0),(397777,11050,'si','Prosim plaÄati z',0),(397778,11050,'ba','Silakan bayar oleh',0),(397779,11050,'nl','Betaal door',0),(397780,11050,'fi','Haluta maksaa',0),(397781,11050,'no','VÃ¦r av',0),(397782,11050,'da','Kan du betale med',0),(397783,11050,'ko','í•˜ ì—¬ ì§€ë¶ˆ í•˜ì‹­ì‹œì˜¤',0),(397784,11050,'he','×× × ×©×œ× ×¢\"×™',0),(397785,11050,'el','Î£Î±Ï‚ Ï€Î±ÏÎ±ÎºÎ±Î»ÏŽ Î½Î± Î´ÏŽÏƒÎ¿Ï…Î½ Î±Ï€ÏŒ',0),(397786,11050,'zh','è¯·è‡ªè´Ÿ\r\n',0),(397787,11050,'sv','VÃ¤nligen betala av',0),(397788,11050,'it','Si prega di pagare da',0),(397789,11050,'tl','',0),(397790,11050,'th','à¸Šà¸³à¸£à¸°à¸„à¹ˆà¸²à¸šà¸£à¸´à¸à¸²à¸£',0),(397791,11050,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(397792,11050,'ms','Sila bayar mengikut',0),(397793,11050,'ar','ÙŠØ±Ø¬Ù‰ Ø§Ù„Ø¯ÙØ¹ Ø¨ÙˆØ§Ø³Ø·Ø©',0),(397794,11050,'fr','S\'il vous plaÃ®t payer par',0),(397795,11050,'jp','ãŠæ”¯æ‰•ã„ãã ã•ã„ã€‚',0),(397796,11050,'pt','Por favor pague por',0),(397797,11050,'ru','ÐŸÑ€Ð¾ÑÑŒÐ±Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ',0),(397798,11050,'es','Por Favor Paga Por',0),(397799,11050,'de','Bitte beachten Sie durch',0),(397800,11050,'en','Please Pay By',0),(397801,11051,'is','',0),(397802,11051,'dr','ÙØ§ÙƒØªÙˆØ± Ø§Ø®ÙŠØ± Ø´Ù…Ø§ Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯ ',0),(397803,11051,'pr','ÙØ§ÙƒØªÙˆØ± Ø§Ø®ÙŠØ± Ø´Ù…Ø§ Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯ ',0),(397804,11051,'tr','En son faturanÄ±n baÄŸlÄ± olduÄŸu',0),(397805,11051,'pl','Najnowsze faktury jest doÅ‚Ä…czony',0),(397806,11051,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½',0),(397807,11051,'ur','Ø§Ù¾Ù†Û’ ØªØ§Ø²Û ØªØ±ÛŒÙ† Ø§Ù†ÙˆØ§Ø¦Ø³ Ø³Û’ Ù…Ù†Ø³Ù„Ú© ÛÛ’',0),(397808,11051,'sr','Ð¢Ð²Ð¾Ñ˜Ðµ Ð½Ð°Ñ˜Ð½Ð¾Ð²Ð¸Ñ˜Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ñ˜Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½.',0),(397809,11051,'vi','HoÃ¡ Ä‘Æ¡n Ä‘áº·t cá»§a báº¡n Ä‘Æ°á»£c gáº¯n',0),(397810,11051,'af','U Nuutste Faktuur is Aangeheg',0),(397811,11051,'ro','Ultima factura este ataÅŸat',0),(397812,11051,'et','Viimase arve on kinnitatud',0),(397813,11051,'si','PrikljuÄen zadnje raÄuna',0),(397814,11051,'ba','Faktur terbaru Anda terpasang',0),(397815,11051,'nl','Uw laatste factuur Is gekoppeld',0),(397816,11051,'fi','Uusimman laskun liitteenÃ¤',0),(397817,11051,'no','Siste fakturaen er festet',0),(397818,11051,'da','Din seneste faktura er vedlagt',0),(397819,11051,'ko','ìµœì‹  ì†¡ìž¥ ì²¨ë¶€',0),(397820,11051,'he','×ž×¦×•×¨×¤×ª ×—×©×‘×•× ×™×ª ×”××—×¨×•× ×” ×©×œ×š',0),(397821,11051,'el','Î Î¹ÏŒ Ï€ÏÏŒÏƒÏ†Î±Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹ÏŒ ÏƒÎ±Ï‚ ÎµÏ€Î¹ÏƒÏ…Î½Î¬Ï€Ï„ÎµÏ„Î±Î¹',0),(397822,11051,'zh','æœ€æ–°å‘ç¥¨é™„\r\n',0),(397823,11051,'sv','Din senaste faktura bifogas',0),(397824,11051,'it','Ultima fattura Ã¨ allegata',0),(397825,11051,'tl','',0),(397826,11051,'th','à¹à¸™à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸¥à¹ˆà¸²à¸ªà¸¸à¸”à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(397827,11051,'hi','à¤…à¤ªà¤¨à¥‡ à¤¨à¤µà¥€à¤¨à¤¤à¤® à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¥‡ à¤œà¥à¤¡à¤¼à¥€ à¤¹à¥ˆ',0),(397828,11051,'ms','Invois Tempahan dilampirkan',0),(397829,11051,'ar','ÙŠØªÙ… Ø¥Ø±ÙØ§Ù‚ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ Ø£Ø­Ø¯Ø«',0),(397830,11051,'fr','Votre derniÃ¨re facture est jointe',0),(397831,11051,'jp','æœ€æ–°ã®è«‹æ±‚æ›¸ã®æ·»ä»˜ã—ã¾ã™ã€‚',0),(397832,11051,'pt','Sua Ãºltima fatura Ã© anexada.',0),(397833,11051,'ru','Ð’Ð°ÑˆÐ¸ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°ÐµÑ‚ÑÑ',0),(397834,11051,'es','Su Ultima Factura se Anexa',0),(397835,11051,'de','Ihre aktuelle Rechnung ist beigefÃ¼gt.',0),(397836,11051,'en','Your Latest Invoice Is Attached',0),(397837,11052,'is','',0),(397838,11052,'dr','Ù…Ø§Ù‡ Ø§Ø±Ø³Ø§Ù„ ',0),(397839,11052,'pr','Ù…Ø§Ù‡ Ø§Ø±Ø³Ø§Ù„ ',0),(397840,11052,'tr','AylÄ±k ihracat',0),(397841,11052,'pl','Eksport miesiÄ…ca',0),(397842,11052,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¼ÐµÑÐµÑ†',0),(397843,11052,'ur','Ù…Ø§Û Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(397844,11052,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¼ÐµÑÐµÑ†Ð°',0),(397845,11052,'vi','Káº¿t xuáº¥t thÃ¡ng',0),(397846,11052,'af','Uitvoer Maand',0),(397847,11052,'ro','Luna de export',0),(397848,11052,'et','Ekspordi kuu',0),(397849,11052,'si','Izvoz mesec',0),(397850,11052,'ba','Ekspor bulan',0),(397851,11052,'nl','Maand exporteren',0),(397852,11052,'fi','Vie kuukauden',0),(397853,11052,'no','Eksportere mÃ¥ned',0),(397854,11052,'da','Eksportere mÃ¥ned',0),(397855,11052,'ko','ìˆ˜ì¶œ ë‹¬',0),(397856,11052,'he','×™×™×¦×•× ×—×•×“×©',0),(397857,11052,'el','Î•Î¾Î±Î³Ï‰Î³Î® Î¼Î®Î½Î±',0),(397858,11052,'zh','å‡ºå£æœˆ\r\n',0),(397859,11052,'sv','Exportera mÃ¥nad',0),(397860,11052,'it','Esportazione mese',0),(397861,11052,'tl','',0),(397862,11052,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¹€à¸”à¸·à¸­à¸™',0),(397863,11052,'hi','à¤®à¤¾à¤¹ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(397864,11052,'ms','Eksport bulan',0),(397865,11052,'ar','Ø§Ù„ØªØµØ¯ÙŠØ± ÙÙŠ Ø§Ù„Ø´Ù‡Ø±',0),(397866,11052,'fr','Mois de l\'exportation',0),(397867,11052,'jp','æœˆã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(397868,11052,'pt','MÃªs de exportaÃ§Ã£o',0),(397869,11052,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ ÐœÐµÑÑÑ†Ð°',0),(397870,11052,'es','Mes de ExportaciÃ³n',0),(397871,11052,'de','Export-Monat',0),(397872,11052,'en','Export Month',0),(397873,11053,'is','',0),(397874,11053,'dr','CAM    Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø®ØªØµØ§ØµÙŠ  Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯',0),(397875,11053,'pr','CAM    Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø®ØªØµØ§ØµÙŠ  Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯',0),(397876,11053,'tr','CAM ayÄ±rma Ã¼cretleri',0),(397877,11053,'pl','CAM alokacja opÅ‚at',0),(397878,11053,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð½Ð° CAM',0),(397879,11053,'ur','Ú©ÛŒÙ… Ù…Ø®ØªØµ Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(397880,11053,'sr','Ð¦ÐÐœ Ð´Ð¾Ð´ÐµÐ»Ðµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(397881,11053,'vi','PhÃ¢n bá»• chi phÃ­',0),(397882,11053,'af','CAM toekenning kostes',0),(397883,11053,'ro','Taxe de alocare CAM',0),(397884,11053,'et','CAM jaotamise tasud',0),(397885,11053,'si','CAM dodelitev stroÅ¡kov',0),(397886,11053,'ba','CAM alokasi biaya',0),(397887,11053,'nl','CAM toewijzing kosten',0),(397888,11053,'fi','CAM jakamista maksut',0),(397889,11053,'no','CAM tildeling kostnader',0),(397890,11053,'da','CAM tildeling afgifter',0),(397891,11053,'ko','ìº  í• ë‹¹ ìš”ê¸ˆ',0),(397892,11053,'he','×ž×¦×œ×ž×ª ×”×§×¦××ª ×—×™×•×‘×™×',0),(397893,11053,'el','CAM ÎºÎ±Ï„Î±Î½Î¿Î¼Î® ÎµÏ€Î¹Î²Î±ÏÏÎ½ÏƒÎµÏ‰Î½',0),(397894,11053,'zh','ç¤¾åŒºæœåŠ¡è´¹çš„åˆ†é…è´¹ç”¨\r\n',0),(397895,11053,'sv','CAM fÃ¶rdelning avgifter',0),(397896,11053,'it','CAM ripartizione spese',0),(397897,11053,'tl','',0),(397898,11053,'th','CAM à¸à¸²à¸£à¸›à¸±à¸™à¸ªà¹ˆà¸§à¸™à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(397899,11053,'hi','à¤•à¥ˆà¤® à¤†à¤µà¤‚à¤Ÿà¤¨ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(397900,11053,'ms','CAM peruntukan caj',0),(397901,11053,'ar','Ø±Ø³ÙˆÙ… ØªØ®ØµÙŠØµ ÙƒØ§Ù…',0),(397902,11053,'fr','CAM Allocation frais',0),(397903,11053,'jp','ã‚«ãƒ ã®å‰²ã‚Šå½“ã¦æ–™é‡‘',0),(397904,11053,'pt','Taxas de alocaÃ§Ã£o de CAM',0),(397905,11053,'ru','CAM Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(397906,11053,'es','CAM Cargos de AsignaciÃ³n',0),(397907,11053,'de','CAM-Zuteilung-GebÃ¼hren',0),(397908,11053,'en','CAM Allocation Charges',0),(397909,11054,'is','',0),(397910,11054,'dr','CAM  Ø¬Ø²Ø¦ÙŠØ§Øª  Ø§Ø®ØªØµØ§Øµ Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯',0),(397911,11054,'pr','CAM  Ø¬Ø²Ø¦ÙŠØ§Øª  Ø§Ø®ØªØµØ§Øµ Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯',0),(397912,11054,'tr','CAM YÃ¼kleme ayrÄ±ntÄ±larÄ±',0),(397913,11054,'pl','SzczegÃ³Å‚y przydziaÅ‚u CAM',0),(397914,11054,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð½Ð° CAM',0),(397915,11054,'ur','Ú©ÛŒÙ… Ù…Ø®ØªØµ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(397916,11054,'sr','Ð¦ÐÐœ Ð´Ð¾Ð´ÐµÐ»Ðµ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(397917,11054,'vi','CAM chi tiáº¿t phÃ¢n bá»•',0),(397918,11054,'af','CAM toekenning besonderhede',0),(397919,11054,'ro','Detalii de alocare CAM',0),(397920,11054,'et','CAM eraldamise Ã¼ksikasjad',0),(397921,11054,'si','CAM dodelitve podrobnosti',0),(397922,11054,'ba','CAM alokasi rincian',0),(397923,11054,'nl','CAM toewijzing Details',0),(397924,11054,'fi','CAM kohdistuksen yksityiskohdat',0),(397925,11054,'no','CAM tildeling detaljer',0),(397926,11054,'da','CAM tildeling detaljer',0),(397927,11054,'ko','ìº  í• ë‹¹ ì„¸ë¶€ ì •ë³´',0),(397928,11054,'he','×¤×¨×˜×™ ×”×§×¦××” ×§××',0),(397929,11054,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÎºÎ±Ï„Î±Î½Î¿Î¼Î®Ï‚ CAM',0),(397930,11054,'zh','ç¤¾åŒºæœåŠ¡è´¹çš„åˆ†é…è¯¦æƒ…\r\n',0),(397931,11054,'sv','CAM fÃ¶rdelning Detaljer',0),(397932,11054,'it','CAM allocazione dettagli',0),(397933,11054,'tl','',0),(397934,11054,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸à¸²à¸£à¸›à¸±à¸™à¸ªà¹ˆà¸§à¸™ CAM',0),(397935,11054,'hi','à¤•à¥ˆà¤® à¤†à¤¬à¤‚à¤Ÿà¤¨ à¤µà¤¿à¤µà¤°à¤£',0),(397936,11054,'ms','CAM peruntukan butiran',0),(397937,11054,'ar','ØªÙØ§ØµÙŠÙ„ ØªÙˆØ²ÙŠØ¹ ÙƒØ§Ù…',0),(397938,11054,'fr','CAM Allocation dÃ©tails',0),(397939,11054,'jp','ã‚«ãƒ ã®å‰²ã‚Šå½“ã¦ã®è©³ç´°',0),(397940,11054,'pt','Detalhes de alocaÃ§Ã£o de CAM',0),(397941,11054,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ CAM',0),(397942,11054,'es','CAM Detalles de AsignaciÃ³n',0),(397943,11054,'de','CAM-Zuteilung-Details',0),(397944,11054,'en','CAM Allocation Details',0),(397945,11055,'is','',0),(397946,11055,'dr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ø§Ø®ØªØµØ§ØµÙŠ  Ø³Ø§Ø®Øª Ø¨ÙˆØ³ÙŠÙ„Ù‡ ÙƒØ§Ù…Ù¾ÙˆØªØ± ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª  ',0),(397947,11055,'pr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ø§Ø®ØªØµØ§ØµÙŠ  Ø³Ø§Ø®Øª Ø¨ÙˆØ³ÙŠÙ„Ù‡ ÙƒØ§Ù…Ù¾ÙˆØªØ± ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª  ',0),(397948,11055,'tr','HayÄ±r CAM tahsisat numarasÄ± koymak',0),(397949,11055,'pl','Nie CAM alokacji identyfikator zestaw',0),(397950,11055,'bg','ÐÑÐ¼Ð° ÐºÐ°Ð¼ÐµÑ€Ð° Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð˜Ð” Ð½Ð° Ð½Ð°Ð±Ð¾Ñ€',0),(397951,11055,'ur','Ú©ÛŒÙ… Ù…Ø®ØªØµ ID Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(397952,11055,'sr','ÐÐµÐ¼Ð° Ð¦ÐÐœ Ð´Ð¾Ð´ÐµÐ»Ðµ Ð˜Ð” Ð¡ÐµÑ‚',0),(397953,11055,'vi','khÃ´ng thiáº¿t láº­p vá»‹ trÃ­ CAM ID',0),(397954,11055,'af','Geen CAM toekenning ID stel',0),(397955,11055,'ro','Nu CAM alocarea ID Set',0),(397956,11055,'et','CAM jaotamise ID komplekt',0),(397957,11055,'si','Ni CAM dodelitev ID nabora',0),(397958,11055,'ba','Tidak ada CAM alokasi ID Set',0),(397959,11055,'nl','Geen CAM Set voor de ID van de toewijzing',0),(397960,11055,'fi','Ei CAM kohdistuksen tunnus asetettu',0),(397961,11055,'no','Ingen CAM tildeling ID sett',0),(397962,11055,'da','Ingen CAM tildeling ID sÃ¦t',0),(397963,11055,'ko','ìº  í• ë‹¹ ID ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(397964,11055,'he','×œ× ×”×•×’×“×¨×• ×ž×–×”×” ×”×§×¦××” ×©×œ ×§××',0),(397965,11055,'el','ÎšÎ±Î½Î­Î½Î± ÏƒÏÎ½Î¿Î»Î¿ ID ÎºÎ±Ï„Î±Î½Î¿Î¼Î® CAM',0),(397966,11055,'zh','æ²¡æœ‰ç”µè„‘è¾…åŠ©åˆ¶é€ åˆ†é…IDè®¾ç½®\r\n',0),(397967,11055,'sv','Ingen CAM fÃ¶rdelning ID Set',0),(397968,11055,'it','Nessun CAM allocazione ID impostato',0),(397969,11055,'tl','',0),(397970,11055,'th','à¹„à¸¡à¹ˆ CAM à¸à¸²à¸£à¸›à¸±à¸™à¸ªà¹ˆà¸§à¸™à¸£à¸«à¸±à¸ªà¸Šà¸¸à¸”',0),(397971,11055,'hi','à¤•à¥‹à¤ˆ à¤¸à¤¾à¤‚à¤šà¤¾ à¤†à¤µà¤‚à¤Ÿà¤¨ ID à¤¸à¥‡à¤Ÿ',0),(397972,11055,'ms','Ada CAM peruntukan ID Set',0),(397973,11055,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ø¹Ø±Ù ØªØ®ØµÙŠØµ ÙƒØ§Ù…',0),(397974,11055,'fr','Aucune Allocation de CAM ID Set',0),(397975,11055,'jp','ã‚«ãƒ ã®å‰²ã‚Šå½“ã¦ ID ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(397976,11055,'pt','Nenhum conjunto de ID de alocaÃ§Ã£o de CAM',0),(397977,11055,'ru','ÐÐ°Ð±Ð¾Ñ€ ID Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ Ð½Ðµ CAM',0),(397978,11055,'es','Ninguna ID de AsignaciÃ³n de CAM Configurada',0),(397979,11055,'de','Keine CAM Zuweisung ID Set',0),(397980,11055,'en','No CAM Allocation ID Set',0),(397981,11056,'is','',0),(397982,11056,'dr','ÙÙˆØª Ù…Ø±Ø¨Ø¹ ',0),(397983,11056,'pr','ÙÙˆØª Ù…Ø±Ø¨Ø¹ ',0),(397984,11056,'tr','Sq Ft',0),(397985,11056,'pl','MÂ²',0),(397986,11056,'bg','ÐšÐ²Ð°Ð´Ñ€Ð°Ñ‚ÐµÐ½ Ñ„ÑƒÑ‚',0),(397987,11056,'ur','Ù…Ø±Ø¨Ø¹ ÙÛŒÙ¹',0),(397988,11056,'sr','ÐšÐ²Ð°Ð´Ñ€Ð°Ñ‚Ð½Ð¸Ñ… Ð¤Ñ‚',0),(397989,11056,'vi','Sq Ft',0),(397990,11056,'af','Vierkante Ft',0),(397991,11056,'ro','MÂ²',0),(397992,11056,'et','Sq Ft',0),(397993,11056,'si','Sq Ft',0),(397994,11056,'ba','Sq Ft',0),(397995,11056,'nl','Sq Ft',0),(397996,11056,'fi','MÂ²',0),(397997,11056,'no','Sq Ft',0),(397998,11056,'da','Sq Ft',0),(397999,11056,'ko','í‰ë°© í”¼íŠ¸',0),(398000,11056,'he','Sq Ft',0),(398001,11056,'el','Î¤ÎµÏ„ÏÎ±Î³Ï‰Î½Î¹ÎºÎ¬ Ï€ÏŒÎ´Î¹Î±',0),(398002,11056,'zh','å¹³æ–¹å‘Ž\r\n',0),(398003,11056,'sv','MÂ²',0),(398004,11056,'it','Sq Ft',0),(398005,11056,'tl','',0),(398006,11056,'th','à¸•à¸²à¸£à¸²à¸‡à¸Ÿà¸¸à¸•',0),(398007,11056,'hi','à¤µà¤°à¥à¤— à¤«à¥à¤Ÿ',0),(398008,11056,'ms','Kaki persegi',0),(398009,11056,'ar','Ù…ØªØ± Ù…Ø±Ø¨Ø¹',0),(398010,11056,'fr','SQ Ft',0),(398011,11056,'jp','å¹³æ–¹ãƒ•ã‚£ãƒ¼ãƒˆ',0),(398012,11056,'pt','PÃ©s quadrados',0),(398013,11056,'ru','ÐšÐ²Ð°Ð´Ñ€Ð°Ñ‚Ð½Ñ‹Ñ… Ñ„ÑƒÑ‚Ð¾Ð²',0),(398014,11056,'es','Pies Cuadrados',0),(398015,11056,'de','SQ Ft',0),(398016,11056,'en','Sq Ft',0),(398017,11057,'is','',0),(398018,11057,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ØªØ®ØµÙŠØµ Ø³Ø§Ø®Øª ÙƒØ§Ù…Ù¾ÙŠÙˆØªØ±ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(398019,11057,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ØªØ®ØµÙŠØµ Ø³Ø§Ø®Øª ÙƒØ§Ù…Ù¾ÙŠÙˆØªØ±ÙŠ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(398020,11057,'tr','CAM ayÄ±rma Ã¼cretleri ekleme',0),(398021,11057,'pl','DodaÄ‡ CAM alokacja opÅ‚at',0),(398022,11057,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð°ÐºÑÐ¸ Ð·Ð° Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð½Ð° CAM',0),(398023,11057,'ur','Ú©ÛŒÙ… Ù…Ø®ØªØµ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(398024,11057,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¦ÐÐœ Ð´Ð¾Ð´ÐµÐ»Ðµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(398025,11057,'vi','ThÃªm phÃ­ phÃ¢n bá»• CAM',0),(398026,11057,'af','Voeg CAM toekenning kostes',0),(398027,11057,'ro','Adauga taxe de alocare CAM',0),(398028,11057,'et','Lisada CAM jaotamise tasud',0),(398029,11057,'si','Dodaj CAM dodelitev stroÅ¡kov',0),(398030,11057,'ba','Tambahkan CAM alokasi biaya',0),(398031,11057,'nl','CAM toewijzing kosten toevoegen',0),(398032,11057,'fi','LisÃ¤Ã¤ CAM jakaminen kulut',0),(398033,11057,'no','Legge til CAM tildeling kostnader',0),(398034,11057,'da','TilfÃ¸je CAM tildeling afgifter',0),(398035,11057,'ko','ìº  í• ë‹¹ ìš”ê¸ˆ ì¶”ê°€',0),(398036,11057,'he','×œ×”×•×¡×™×£ ×ž×¦×œ×ž×ª ×”×§×¦××ª ×—×™×•×‘×™×',0),(398037,11057,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ CAM ÎºÎ±Ï„Î±Î½Î¿Î¼Î® ÎµÏ€Î¹Î²Î±ÏÏÎ½ÏƒÎµÏ‰Î½',0),(398038,11057,'zh','å¢žåŠ CAMçš„åˆ†é…è´¹ç”¨\r\n',0),(398039,11057,'sv','LÃ¤gg till CAM fÃ¶rdelning avgifter',0),(398040,11057,'it','Aggiungere CAM ripartizione spese',0),(398041,11057,'tl','',0),(398042,11057,'th','à¹€à¸žà¸´à¹ˆà¸¡ CAM à¸à¸²à¸£à¸›à¸±à¸™à¸ªà¹ˆà¸§à¸™à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(398043,11057,'hi','à¤•à¥ˆà¤® à¤†à¤µà¤‚à¤Ÿà¤¨ à¤ªà¥à¤°à¤­à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(398044,11057,'ms','Tambah CAM peruntukan caj',0),(398045,11057,'ar','Ø¥Ø¶Ø§ÙØ© Ø±Ø³ÙˆÙ… ØªØ®ØµÙŠØµ ÙƒØ§Ù…',0),(398046,11057,'fr','Ajouter frais de rÃ©partition CAM',0),(398047,11057,'jp','ã‚«ãƒ ã®å‰²ã‚Šå½“ã¦æ–™é‡‘ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(398048,11057,'pt','Adicionar taxas de alocaÃ§Ã£o de CAM',0),(398049,11057,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ CAM Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(398050,11057,'es','Agregar Cargos de AsignaciÃ³n',0),(398051,11057,'de','CAM Zuweisung GebÃ¼hren hinzufÃ¼gen',0),(398052,11057,'en','Add CAM Allocation Charges',0),(398053,11058,'is','',0),(398054,11058,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ ',0),(398055,11058,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ ',0),(398056,11058,'tr','Ãœcret Ekle',0),(398057,11058,'pl','Dodaj bezpÅ‚atnie',0),(398058,11058,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ñ‚Ð°ÐºÑÐ°',0),(398059,11058,'ur','Ø­Ú©Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(398060,11058,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(398061,11058,'vi','ThÃªm phÃ­',0),(398062,11058,'af','Voeg las',0),(398063,11058,'ro','Adauga taxa',0),(398064,11058,'et','Lisa tasuta',0),(398065,11058,'si','Dodate dajatev',0),(398066,11058,'ba','Menambahkan biaya',0),(398067,11058,'nl','Gratis toevoegen',0),(398068,11058,'fi','LisÃ¤Ã¤ ilmaiseksi',0),(398069,11058,'no','Legger til',0),(398070,11058,'da','TilfÃ¸je afgift',0),(398071,11058,'ko','ìš”ê¸ˆ ì¶”ê°€',0),(398072,11058,'he','×”×•×¡×£ ×—×™×•×‘',0),(398073,11058,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(398074,11058,'zh','å¢žåŠ æ”¶è´¹\r\n',0),(398075,11058,'sv','LÃ¤gg till kostnad',0),(398076,11058,'it','Aggiungi carica',0),(398077,11058,'tl','',0),(398078,11058,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(398079,11058,'hi','à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(398080,11058,'ms','Tambah caj',0),(398081,11058,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙ‡Ù…Ø©',0),(398082,11058,'fr','Ajouter gratuitement',0),(398083,11058,'jp','è¿½åŠ æ–™é‡‘',0),(398084,11058,'pt','Adicionar carga',0),(398085,11058,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(398086,11058,'es','Agregar Cargo',0),(398087,11058,'de','FÃ¼gen Sie kostenlos',0),(398088,11058,'en','Add Charge',0),(398089,11059,'is','',0),(398090,11059,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(398091,11059,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(398092,11059,'tr','Ãœcretleri ekleme',0),(398093,11059,'pl','DodaÄ‡ opÅ‚aty',0),(398094,11059,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð°ÐºÑÐ¸',0),(398095,11059,'ur','Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(398096,11059,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(398097,11059,'vi','ThÃªm cÃ¡c phÃ­',0),(398098,11059,'af','Kostes Byvoeg',0),(398099,11059,'ro','Adauga taxe',0),(398100,11059,'et','Lisage makse',0),(398101,11059,'si','Dodaj stroÅ¡ki',0),(398102,11059,'ba','Tambahkan tuduhan',0),(398103,11059,'nl','Kosten toevoegen',0),(398104,11059,'fi','LisÃ¤Ã¤ kulut',0),(398105,11059,'no','Legg til tillegg',0),(398106,11059,'da','TilfÃ¸je afgifter',0),(398107,11059,'ko','ì¶”ê°€ ìš”ê¸ˆ',0),(398108,11059,'he','×”×•×¡×£ ×—×™×•×‘×™×',0),(398109,11059,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î± Ï„Î­Î»Î·',0),(398110,11059,'zh','å¢žåŠ æ”¶è´¹\r\n',0),(398111,11059,'sv','LÃ¤gg till avgifter',0),(398112,11059,'it','Aggiungere spese',0),(398113,11059,'tl','',0),(398114,11059,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(398115,11059,'hi','à¤†à¤°à¥‹à¤ªà¥‹à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(398116,11059,'ms','Tambah caj',0),(398117,11059,'ar','Ø¥Ø¶Ø§ÙØ© Ø±Ø³ÙˆÙ…',0),(398118,11059,'fr','Ajouter des Charges',0),(398119,11059,'jp','è¿½åŠ æ–™é‡‘',0),(398120,11059,'pt','Adicionar cargas',0),(398121,11059,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(398122,11059,'es','Agregar Cargos',0),(398123,11059,'de','HinzufÃ¼gen von GebÃ¼hren',0),(398124,11059,'en','Add Charges',0),(398125,11060,'is','',0),(398126,11060,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø³ØªØ§Ø¬Ø±',0),(398127,11060,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø³ØªØ§Ø¬Ø±',0),(398128,11060,'tr','KiracÄ± Ã¼cretleri ekleme',0),(398129,11060,'pl','DodaÄ‡ najemcy opÅ‚at',0),(398130,11060,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ñ‚Ð°ÐºÑÐ¸',0),(398131,11060,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(398132,11060,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð½Ð°Ñ€ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(398133,11060,'vi','ThÃªm phÃ­ ngÆ°á»i thuÃª',0),(398134,11060,'af','Huurder Kostes Byvoeg',0),(398135,11060,'ro','Adauga taxele de chiriaÅŸ',0),(398136,11060,'et','Lisada Ã¼Ã¼rnik tasu',0),(398137,11060,'si','Dodaj stroÅ¡ke najemnika',0),(398138,11060,'ba','Tambahkan tuduhan penyewa',0),(398139,11060,'nl','Huurder kosten toevoegen',0),(398140,11060,'fi','LisÃ¤Ã¤ vuokralainen kulut',0),(398141,11060,'no','Legge til leietaker kostnader',0),(398142,11060,'da','TilfÃ¸je lejer afgifter',0),(398143,11060,'ko','ê±°ì£¼ìž ìš”ê¸ˆ ì¶”ê°€',0),(398144,11060,'he','×œ×”×•×¡×™×£ ×”×“×™×™×¨ ×—×™×•×‘×™×',0),(398145,11060,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î± Î­Î¾Î¿Î´Î± Ï„Î¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(398146,11060,'zh','å¢žåŠ æ‰¿ç§Ÿäººæ”¶è´¹\r\n',0),(398147,11060,'sv','LÃ¤gg till hyresgÃ¤sten avgifter',0),(398148,11060,'it','Aggiungere spese inquilino',0),(398149,11060,'tl','',0),(398150,11060,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²',0),(398151,11060,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤•à¥‡ à¤†à¤°à¥‹à¤ª à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(398152,11060,'ms','Tambah caj penyewa',0),(398153,11060,'ar','Ø¥Ø¶Ø§ÙØ© Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(398154,11060,'fr','Ajouter frais de locataire',0),(398155,11060,'jp','ãƒ†ãƒŠãƒ³ãƒˆæ–™ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(398156,11060,'pt','Adicionar cargas de inquilino',0),(398157,11060,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð°',0),(398158,11060,'es','Agregar Cargos de Inquilino',0),(398159,11060,'de','Mieter GebÃ¼hren hinzufÃ¼gen',0),(398160,11060,'en','Add Tenant Charges',0),(398161,11061,'is','',0),(398162,11061,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù…ÙƒØ§Ù†Ø§Øª Ø±ÙØ§Ù‡ÙŠ ÙˆØ¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø³ØªØ§Ø¬Ø±',0),(398163,11061,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù…ÙƒØ§Ù†Ø§Øª Ø±ÙØ§Ù‡ÙŠ ÙˆØ¯ÙŠÚ¯Ø± Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø³ØªØ§Ø¬Ø±',0),(398164,11061,'tr','KiracÄ± yardÄ±mcÄ± programÄ± ve diÄŸer Ã¼cretleri ekleme',0),(398165,11061,'pl','DodaÄ‡ narzÄ™dzie najemcÃ³w i innych opÅ‚at',0),(398166,11061,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¿Ð¾Ð»ÐµÐ·Ð½Ð¾ÑÑ‚ Ð¸ Ð´Ñ€ÑƒÐ³Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(398167,11061,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©ÛŒ Ø§ÙØ§Ø¯ÛŒØª Ø§ÙˆØ± Ø¯ÛŒÚ¯Ø± Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(398168,11061,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð½Ð°Ñ€ ÑƒÑÐ»ÑƒÐ¶Ð½Ð¸ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼ Ð¸ Ð¾ÑÑ‚Ð°Ð»Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(398169,11061,'vi','ThÃªm phÃ­ tiá»‡n Ã­ch vÃ  phÃ­ khÃ¡c',0),(398170,11061,'af','Byvoeging van Materiaal en Ander Kostes',0),(398171,11061,'ro','Adauga chiriaÅŸ utilitate ÅŸi alte cheltuieli',0),(398172,11061,'et','Lisa rentnike kommunaalteenuste ja muud tasud',0),(398173,11061,'si','Dodaj najemnik korist in drugih dajatev',0),(398174,11061,'ba','Tambahkan penyewa utilitas dan biaya lainnya',0),(398175,11061,'nl','Huurder Utility en andere heffingen toevoegen',0),(398176,11061,'fi','LisÃ¤Ã¤ vuokralainen hyÃ¶dyllisyys ja muut maksut',0),(398177,11061,'no','Legge til leietaker verktÃ¸yet og andre avgifter',0),(398178,11061,'da','TilfÃ¸je lejer nytte og andre afgifter',0),(398179,11061,'ko','ì„¸ ìž…ìž ìœ í‹¸ë¦¬í‹° ë° ê¸°íƒ€ ë¹„ìš©ì´ ì¶”ê°€',0),(398180,11061,'he','×”×•×¡×£ ×›×œ×™ ×”×“×™×™×¨ ×•×—×™×•×‘×™× ××—×¨×™×',0),(398181,11061,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î· Ï‡ÏÎ·ÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î± Ï„Î¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„Î® ÎºÎ±Î¹ Î¬Î»Î»ÎµÏ‚ ÎµÏ€Î¹Î²Î±ÏÏÎ½ÏƒÎµÎ¹Ï‚',0),(398182,11061,'zh','å¢žåŠ æ‰¿ç§Ÿäººå…¬ç”¨è®¾æ–½åŠå…¶ä»–è´¹ç”¨\r\n',0),(398183,11061,'sv','LÃ¤gga till hyresgÃ¤sten verktyg och andra avgifter',0),(398184,11061,'it','Aggiungi utilitÃ  inquilino e altre spese',0),(398185,11061,'tl','',0),(398186,11061,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸­à¸£à¸£à¸–à¸›à¸£à¸°à¹‚à¸¢à¸Šà¸™à¹Œà¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¹à¸¥à¸°à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸­à¸·à¹ˆà¸™ à¹†',0),(398187,11061,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤‰à¤ªà¤¯à¥‹à¤—à¤¿à¤¤à¤¾ à¤”à¤° à¤…à¤¨à¥à¤¯ à¤†à¤°à¥‹à¤ªà¥‹à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(398188,11061,'ms','Tambah penyewa utiliti dan lain-lain caj',0),(398189,11061,'ar','Ø¥Ø¶Ø§ÙØ© ÙØ§Ø¦Ø¯Ø© Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± ÙˆØ§Ù„Ù…ØµØ§Ø±ÙŠÙ Ø§Ù„Ø£Ø®Ø±Ù‰',0),(398190,11061,'fr','Ajouter locataire utilitaire et autres frais',0),(398191,11061,'jp','ãƒ†ãƒŠãƒ³ãƒˆ ãƒ¦ãƒ¼ãƒ†ã‚£ãƒªãƒ†ã‚£ã¨ãã®ä»–ã®æ–™é‡‘ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(398192,11061,'pt','Adicionar o utilitÃ¡rio de inquilino e outros encargos',0),(398193,11061,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð¾Ð¼ ÐºÐ¾Ð¼Ð¼ÑƒÐ½Ð°Ð»ÑŒÐ½Ñ‹Ñ… Ð¸ Ð´Ñ€ÑƒÐ³Ð¸Ñ… Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(398194,11061,'es','Agregar Servicios y Otros Cargos al Inquilino',0),(398195,11061,'de','FÃ¼gen Sie Mieter Dienstprogramm und sonstige Abgaben',0),(398196,11061,'en','Add Tenant Utility and Other Charges',0),(398197,11062,'is','',0),(398198,11062,'dr','(Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ) Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡ ',0),(398199,11062,'pr','Ù…Ù‚Ø¯Ø§Ø± (Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ) Ø§ÙŠÙ† Ø¯ÙˆØ±Ù‡ ',0),(398200,11062,'tr','AMT bu dÃ¶nem',0),(398201,11062,'pl','UrzÄ…d ten okres',0),(398202,11062,'bg','Amt Ñ‚Ð¾Ð·Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(398203,11062,'ur','Ø§Ù…Ù¹ Ø§Ø³ Ø¯ÙˆØ±',0),(398204,11062,'sr','ÐÐœÐ¢ Ð¾Ð²Ð¾Ð³ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(398205,11062,'vi','Sá»‘ tiá»n kÃ½ nÃ y',0),(398206,11062,'af','AMT hierdie tydperk',0),(398207,11062,'ro','AMT aceastÄƒ perioadÄƒ',0),(398208,11062,'et','Amt selle aja',0),(398209,11062,'si','Amt to obdobje',0),(398210,11062,'ba','Amt periode ini',0),(398211,11062,'nl','Amt deze periode',0),(398212,11062,'fi','AMT mÃ¤Ã¤rÃ¤aikaa',0),(398213,11062,'no','Amt denne perioden',0),(398214,11062,'da','Amt denne periode',0),(398215,11062,'ko','Amtì´ì´ ê¸°ê°„',0),(398216,11062,'he','Amt ×‘×ª×§×•×¤×” ×–×•',0),(398217,11062,'el','AMT Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(398218,11062,'zh','è¿™ä¸ªæ—¶æœŸçš„é‡‘é¢\r\n',0),(398219,11062,'sv','AMT denna Period',0),(398220,11062,'it','Questo periodo di AMT',0),(398221,11062,'tl','',0),(398222,11062,'th','à¸ˆà¸³à¸™à¸§à¸™à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸™à¸µà¹‰',0),(398223,11062,'hi','Amt à¤‡à¤¸ à¤…à¤µà¤§à¤¿',0),(398224,11062,'ms','AMT tempoh ini',0),(398225,11062,'ar','Amt Ù‡Ø°Ù‡ Ø§Ù„ÙØªØ±Ø©',0),(398226,11062,'fr','AMT cette pÃ©riode',0),(398227,11062,'jp','Amt ã“ã®æœŸé–“',0),(398228,11062,'pt','AMT neste perÃ­odo',0),(398229,11062,'ru','AMT ÑÑ‚Ð¾Ñ‚ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(398230,11062,'es','Cantidad Este PerÃ­odo',0),(398231,11062,'de','Amt dieser Zeit',0),(398232,11062,'en','Amt This Period',0),(398233,11063,'is','',0),(398234,11063,'dr','(Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ) Ø¬Ù‡Øª ØªØ®ØµÙŠØµ ',0),(398235,11063,'pr','Ù…Ù‚Ø¯Ø§Ø± (Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ) Ø¬Ù‡Øª ØªØ®ØµÙŠØµ ',0),(398236,11063,'tr','Amt tahsis etmek',0),(398237,11063,'pl','Amt przydzieliÄ‡',0),(398238,11063,'bg','Amt Ð·Ð° Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÑÐ½Ðµ',0),(398239,11063,'ur','Ø§Ù…Ù¹ Ù…Ø®ØªØµ Ú©Ø±Ù†Û’',0),(398240,11063,'sr','ÐÐœÐ¢ Ð´Ð° Ð¸Ð·Ð´Ð²Ð¾Ñ˜Ð¸',0),(398241,11063,'vi','sá»‘ tiá»n phÃ¢n bá»•',0),(398242,11063,'af','AMT toewys',0),(398243,11063,'ro','AMT sÄƒ aloce',0),(398244,11063,'et','Amt eraldada',0),(398245,11063,'si','Amt dodeliti',0),(398246,11063,'ba','Amt mengalokasikan',0),(398247,11063,'nl','Amt toe te wijzen',0),(398248,11063,'fi','AMT varata',0),(398249,11063,'no','Amt tildele',0),(398250,11063,'da','Amt til at afsÃ¦tte',0),(398251,11063,'ko','Amt í• ë‹¹',0),(398252,11063,'he','Amt ×œ×”×§×¦×•×ª',0),(398253,11063,'el','AMT Î½Î± Î´Î¹Î±Î¸Î­ÏƒÎµÎ¹',0),(398254,11063,'zh','é‡‘é¢åˆ†é…\r\n',0),(398255,11063,'sv','AMT att fÃ¶rdela',0),(398256,11063,'it','AMT per allocare',0),(398257,11063,'tl','',0),(398258,11063,'th','à¸ˆà¸³à¸™à¸§à¸™à¸à¸²à¸£à¸›à¸±à¸™à¸ªà¹ˆà¸§à¸™',0),(398259,11063,'hi','Amt à¤•à¤¾ à¤†à¤µà¤‚à¤Ÿà¤¨',0),(398260,11063,'ms','AMT untuk memperuntukkan',0),(398261,11063,'ar','Ø§Ù„Ù‚Ø¶Ø§Ø© Ø§Ù„ØªÙˆÙ†Ø³ÙŠÙŠÙ† ØªØ®ØµÙŠØµ',0),(398262,11063,'fr','AMT d\'allouer',0),(398263,11063,'jp','Amt ã«å‰²ã‚Šå½“ã¦ã‚‹',0),(398264,11063,'pt','AMT para alocar',0),(398265,11063,'ru','AMT Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‚ÑŒ',0),(398266,11063,'es','Cantidad Para Asignar',0),(398267,11063,'de','Amt zuordnen',0),(398268,11063,'en','Amt To Allocate',0),(398269,11064,'is','',0),(398270,11064,'dr','CAM Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø®ØªØµØ§ØµÙŠ  Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(398271,11064,'pr','CAM Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø®ØªØµØ§ØµÙŠ  Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(398272,11064,'tr','CAM ayÄ±rma Ã¼cretleri baÅŸarÄ±yla eklendi',0),(398273,11064,'pl','CAM alokacja opÅ‚at dodaÅ‚ pomyÅ›lnie',0),(398274,11064,'bg','CAM Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ñ‚Ð°ÐºÑÐ¸ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(398275,11064,'ur','Ú©ÛŒÙ… Ù…Ø®ØªØµ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(398276,11064,'sr','Ð¦ÐÐœ Ð´Ð¾Ð´ÐµÐ»Ðµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(398277,11064,'vi','CAM thÃªm phÃ¢n bá»• chi phÃ­ thÃ nh cÃ´ng',0),(398278,11064,'af','CAM toekenning koste bygevoeg suksesvol',0),(398279,11064,'ro','CAM alocarea taxe adÄƒugat cu succes',0),(398280,11064,'et','CAM jaotamise eest lisatud edukalt',0),(398281,11064,'si','CAM dodelitev stroÅ¡kov uspeÅ¡no dodani',0),(398282,11064,'ba','Biaya alokasi CAM ditambahkan berhasil',0),(398283,11064,'nl','CAM toewijzing kosten toegevoegd',0),(398284,11064,'fi','CAM jakamista maksujen lisÃ¤Ã¤minen onnistui',0),(398285,11064,'no','CAM tildeling kostnader lagt',0),(398286,11064,'da','CAM tildeling gebyrer tilfÃ¸jet',0),(398287,11064,'ko','ìº  í• ë‹¹ ìš”ê¸ˆ ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(398288,11064,'he','×ž×¦×œ×ž×ª ×”×§×¦××ª ×—×™×•×‘×™× × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(398289,11064,'el','CAM ÎºÎ±Ï„Î±Î½Î¿Î¼Î® ÎµÏ€Î¹Î²Î±ÏÏÎ½ÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Ï€ÏÎ¿ÏƒÏ„Î¯Î¸ÎµÎ½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(398290,11064,'zh','ç¤¾åŒºæœåŠ¡è´¹çš„åˆ†é…è´¹ç”¨æ·»åŠ æˆåŠŸ\r\n',0),(398291,11064,'sv','CAM fÃ¶rdelning kostnader lagts',0),(398292,11064,'it','CAM ripartizione spese aggiunti con successo',0),(398293,11064,'tl','',0),(398294,11064,'th','CAM à¸à¸²à¸£à¸›à¸±à¸™à¸ªà¹ˆà¸§à¸™à¹€à¸žà¸´à¹ˆà¸¡à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(398295,11064,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤¸à¤¾à¤‚à¤šà¤¾ à¤†à¤µà¤‚à¤Ÿà¤¨ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(398296,11064,'ms','Caj-caj peruntukan CAM yang berjaya menambah',0),(398297,11064,'ar','ÙƒØ§Ù… ØªØ®ØµÙŠØµ Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(398298,11064,'fr','CAM Allocation frais ajoutÃ©s avec succÃ¨s',0),(398299,11064,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸã‚«ãƒ å‰²ã‚Šå½“ã¦æ–™é‡‘',0),(398300,11064,'pt','Taxas de alocaÃ§Ã£o CAM adicionadas com sucesso',0),(398301,11064,'ru','CAM Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(398302,11064,'es','CAM Cargos de AsignaciÃ³n Agregados Exitosamente',0),(398303,11064,'de','CAM Zuweisung GebÃ¼hren erfolgreich hinzugefÃ¼gt',0),(398304,11064,'en','CAM Allocation Charges Added Successfully',0),(398305,11065,'is','',0),(398306,11065,'dr','CAM  Ø¬Ø²Ø¦ÙŠØ§Øª  Ø§Ø®ØªØµØ§Øµ Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯',0),(398307,11065,'pr','CAM  Ø¬Ø²Ø¦ÙŠØ§Øª  Ø§Ø®ØªØµØ§Øµ Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯',0),(398308,11065,'tr','CAM yÃ¼kleme ayrÄ±ntÄ±',0),(398309,11065,'pl','SzczegÃ³Å‚owy podziaÅ‚ CAM',0),(398310,11065,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð½Ð° CAM',0),(398311,11065,'ur','Ú©ÛŒÙ… Ù…Ø®ØªØµ ØªÙØµÛŒÙ„',0),(398312,11065,'sr','Ð¦ÐÐœ Ð´Ð¾Ð´ÐµÐ»Ðµ Ð´ÐµÑ‚Ð°Ñ™',0),(398313,11065,'vi','CAM chi tiáº¿t phÃ¢n bá»•',0),(398314,11065,'af','CAM toekenning Detail',0),(398315,11065,'ro','Detaliu de alocare CAM',0),(398316,11065,'et','CAM eraldamise Ã¼ksikasjad',0),(398317,11065,'si','CAM dodelitve podrobnosti',0),(398318,11065,'ba','CAM alokasi Detail',0),(398319,11065,'nl','CAM toewijzing Detail',0),(398320,11065,'fi','CAM kohdentaminen yksityiskohtaisesti',0),(398321,11065,'no','CAM tildeling detaljer',0),(398322,11065,'da','CAM tildeling detaljer',0),(398323,11065,'ko','ìº  í• ë‹¹ ì„¸ë¶€ ì‚¬í•­',0),(398324,11065,'he','×¤×™×¨×•×˜ ×”×§×¦××ª ×§××',0),(398325,11065,'el','CAM ÎºÎ±Ï„Î±Î½Î¿Î¼Î® Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(398326,11065,'zh','ç¤¾åŒºæœåŠ¡è´¹çš„åˆ†é…æ˜Žç»†\r\n',0),(398327,11065,'sv','CAM fÃ¶rdelning i detalj',0),(398328,11065,'it','Dettaglio di allocazione CAM',0),(398329,11065,'tl','',0),(398330,11065,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸à¸²à¸£à¸›à¸±à¸™à¸ªà¹ˆà¸§à¸™ CAM',0),(398331,11065,'hi','à¤•à¥ˆà¤® à¤†à¤¬à¤‚à¤Ÿà¤¨ à¤µà¤¿à¤µà¤°à¤£',0),(398332,11065,'ms','CAM peruntukan butiran',0),(398333,11065,'ar','ØªÙØ§ØµÙŠÙ„ ØªÙˆØ²ÙŠØ¹ ÙƒØ§Ù…',0),(398334,11065,'fr','DÃ©tail Allocation CAM',0),(398335,11065,'jp','ã‚«ãƒ ã®å‰²ã‚Šå½“ã¦ã®è©³ç´°',0),(398336,11065,'pt','Detalhe de alocaÃ§Ã£o de CAM',0),(398337,11065,'ru','CAM Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(398338,11065,'es','CAM Detalle de AsignaciÃ³n',0),(398339,11065,'de','CAM-Zuteilung-Detail',0),(398340,11065,'en','CAM Allocation Detail',0),(398341,11066,'is','',0),(398342,11066,'dr','CAM  Ù‡Ø²ÙŠÙ†Ù‡  Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(398343,11066,'pr','CAM  Ù‡Ø²ÙŠÙ†Ù‡  Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(398344,11066,'tr','CAM Ã¼cretleri baÅŸarÄ±yla silindi',0),(398345,11066,'pl','CAM opÅ‚aty przesâ”‚anie',0),(398346,11066,'bg','CAM Ñ‚Ð°ÐºÑÐ¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(398347,11066,'ur','Ú©ÛŒÙ… Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(398348,11066,'sr','Ð¦ÐÐœ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(398349,11066,'vi','Xoa chi phÃ­ thÃ nh cÃ´ng',0),(398350,11066,'af','CAM koste suksesvol geskrap',0),(398351,11066,'ro','Taxe CAM sterse cu succes',0),(398352,11066,'et','CAM tasude edukalt kustutatud',0),(398353,11066,'si','CAM stroÅ¡ki uspeÅ¡no izbrisana',0),(398354,11066,'ba','Biaya CAM dihapus berhasil',0),(398355,11066,'nl','CAM kosten met succes verwijderd',0),(398356,11066,'fi','CAM maksut poistettu',0),(398357,11066,'no','CAM kostnader slettet',0),(398358,11066,'da','CAM afgifter slettet',0),(398359,11066,'ko','ìº  ì²­êµ¬ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(398360,11066,'he','×ž×¦×œ×ž×ª ×—×™×•×‘×™× × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(398361,11066,'el','Î§ÏÎµÏŽÏƒÎµÎ¹Ï‚ CAM Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(398362,11066,'zh','ç¤¾åŒºæœåŠ¡è´¹çš„æ”¶è´¹æˆåŠŸåˆ é™¤\r\n',0),(398363,11066,'sv','CAM avgifter raderades',0),(398364,11066,'it','CAM oneri eliminati con successo',0),(398365,11066,'tl','',0),(398366,11066,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡ CAM à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(398367,11066,'hi','à¤•à¥ˆà¤® à¤†à¤°à¥‹à¤ª à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(398368,11066,'ms','CAM caj dihapuskan dengan jayanya',0),(398369,11066,'ar','Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ ÙƒØ§Ù… Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(398370,11066,'fr','Frais de CAM supprimÃ©s avec succÃ¨s',0),(398371,11066,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸã‚«ãƒ æ–™é‡‘',0),(398372,11066,'pt','CAM acusaÃ§Ãµes apagadas com sucesso',0),(398373,11066,'ru','Ð¡Ð±Ð¾Ñ€Ñ‹ CAM ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(398374,11066,'es','CAM Cargos Eliminados Exitosamente',0),(398375,11066,'de','CAM GebÃ¼hren erfolgreich gelÃ¶scht',0),(398376,11066,'en','CAM Charges Deleted Successfully',0),(398377,11067,'is','',0),(398378,11067,'dr','CAM ØªÙØµÛŒÙ„  Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯',0),(398379,11067,'pr','CAM Ø´Ø±Ø­ Ø¯ÙˆØ±Ø¨ÙŠÙ†(Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙƒØ§Ù…Ù¾ÙˆØªØ± Ø¯Ø± ØªÙˆÙ„ÙŠØ¯',0),(398380,11067,'tr','CAM tanÄ±mÄ±',0),(398381,11067,'pl','Opis CAM',0),(398382,11067,'bg','CAM Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(398383,11067,'ur','Ù†Ù…ÙˆÙ†Û Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(398384,11067,'sr','Ð¦ÐÐœ Ð¾Ð¿Ð¸Ñ',0),(398385,11067,'vi','Diá»…n giáº£i',0),(398386,11067,'af','CAM Beskrywing',0),(398387,11067,'ro','CAM Descriere',0),(398388,11067,'et','CAM kirjeldus',0),(398389,11067,'si','CAM opis',0),(398390,11067,'ba','Deskripsi CAM',0),(398391,11067,'nl','CAM beschrijving',0),(398392,11067,'fi','CAM kuvaus',0),(398393,11067,'no','CAM beskrivelse',0),(398394,11067,'da','CAM beskrivelse',0),(398395,11067,'ko','ìº  ì„¤ëª…',0),(398396,11067,'he','×ª×™××•×¨ ×§××',0),(398397,11067,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Ï‰Î½ CAM',0),(398398,11067,'zh','ç¤¾åŒºæœåŠ¡è´¹çš„è¯´æ˜Ž\r\n',0),(398399,11067,'sv','CAM Beskrivning',0),(398400,11067,'it','Descrizione di CAM',0),(398401,11067,'tl','',0),(398402,11067,'th','à¸­à¸˜à¸´à¸šà¸²à¸¢ CAM',0),(398403,11067,'hi','à¤•à¥ˆà¤® à¤µà¤¿à¤µà¤°à¤£',0),(398404,11067,'ms','Keterangan CAM',0),(398405,11067,'ar','ÙˆØµÙ ÙƒØ§Ù…',0),(398406,11067,'fr','Description de la CAM',0),(398407,11067,'jp','ã‚«ãƒ ã®èª¬æ˜Ž',0),(398408,11067,'pt','DescriÃ§Ã£o de CAM',0),(398409,11067,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐºÐ°Ð¼ÐµÑ€Ñ‹',0),(398410,11067,'es','CAM DescripciÃ³n',0),(398411,11067,'de','CAM-Beschreibung',0),(398412,11067,'en','CAM Description',0),(398413,11068,'is','',0),(398414,11068,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(398415,11068,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(398416,11068,'tr','Åžarj baÅŸarÄ±yla eklendi',0),(398417,11068,'pl','Za pomyÅ›lne dodanie',0),(398418,11068,'bg','Ð¢Ð°ÐºÑÐ°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(398419,11068,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø´Ø§Ù…Ù„ Ú†Ø§Ø±Ø¬',0),(398420,11068,'sr','ÐŸÑƒÑšÐµÑšÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(398421,11068,'vi','ThÃªm phÃ­ thÃ nh cÃ´nng',0),(398422,11068,'af','Koste Suksesvol Bygevoeg',0),(398423,11068,'ro','Taxa adÄƒugat cu succes',0),(398424,11068,'et','Lisatud tasu',0),(398425,11068,'si','Doda uspeÅ¡no',0),(398426,11068,'ba','Biaya menambahkan berhasil',0),(398427,11068,'nl','Gratis toegevoegd',0),(398428,11068,'fi','Maksun lisÃ¤Ã¤minen onnistui',0),(398429,11068,'no','Gratis lagt',0),(398430,11068,'da','Afgift tilfÃ¸jet',0),(398431,11068,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì¶©ì „',0),(398432,11068,'he','×ª×©×œ×•× × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(398433,11068,'el','Î§ÏÎ­Ï‰ÏƒÎ· Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(398434,11068,'zh','æ”¶è´¹æ·»åŠ æˆåŠŸ\r\n',0),(398435,11068,'sv','Avgift som lagts',0),(398436,11068,'it','Carica aggiunto con successo',0),(398437,11068,'tl','',0),(398438,11068,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§à¸„à¹ˆà¸²',0),(398439,11068,'hi','à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(398440,11068,'ms','Caj yang berjaya menambah',0),(398441,11068,'ar','Ø£Ø¶ÙŠÙØª Ø§Ù„Ø±Ø³ÙˆÙ… Ø¨Ù†Ø¬Ø§Ø­',0),(398442,11068,'fr','Frais ajoutÃ© avec succÃ¨s',0),(398443,11068,'jp','å……é›»ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(398444,11068,'pt','Carga adicionada com sucesso',0),(398445,11068,'ru','Ð—Ð°Ñ€ÑÐ´, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(398446,11068,'es','Cargo Agregado Exitosamente',0),(398447,11068,'de','Kostenlos erfolgreich hinzugefÃ¼gt',0),(398448,11068,'en','Charge Added Successfully',0),(398449,11069,'is','',0),(398450,11069,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(398451,11069,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(398452,11069,'tr','Åžarj baÅŸarÄ±yla silindi',0),(398453,11069,'pl','Za przesâ”‚anie',0),(398454,11069,'bg','Ð¢Ð°ÐºÑÐ° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(398455,11069,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú†Ø§Ø±Ø¬',0),(398456,11069,'sr','ÐŸÑƒÑšÐµÑšÐµ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(398457,11069,'vi','XÃ³a phÃ­ thÃ nh cÃ´ng',0),(398458,11069,'af','Koste Suksesvol Geskrap',0),(398459,11069,'ro','Taxa eliminÄƒ cu succes',0),(398460,11069,'et','Tasu edukalt kustutatud',0),(398461,11069,'si','Naboj uspeÅ¡no izbrisana',0),(398462,11069,'ba','Biaya dihapus berhasil',0),(398463,11069,'nl','Gratis met succes verwijderd',0),(398464,11069,'fi','Ilmaiseksi poistettu',0),(398465,11069,'no','Gratis slettet',0),(398466,11069,'da','Afgift slettet',0),(398467,11069,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ìš”ê¸ˆ',0),(398468,11069,'he','×ª×©×œ×•× × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(398469,11069,'el','Î§ÏÎ­Ï‰ÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(398470,11069,'zh','æ”¶è´¹æˆåŠŸåˆ é™¤\r\n',0),(398471,11069,'sv','Avgift raderades',0),(398472,11069,'it','Carica eliminato con successo',0),(398473,11069,'tl','',0),(398474,11069,'th','à¸„à¹ˆà¸²à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(398475,11069,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(398476,11069,'ms','Caj dihapuskan dengan jayanya',0),(398477,11069,'ar','Ø­Ø°ÙØª Ø§Ù„Ø±Ø³ÙˆÙ… Ø¨Ù†Ø¬Ø§Ø­',0),(398478,11069,'fr','Charge supprimÃ©e avec succÃ¨s',0),(398479,11069,'jp','å……é›»ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(398480,11069,'pt','Carga apagada com sucesso',0),(398481,11069,'ru','Ð—Ð°Ñ€ÑÐ´, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(398482,11069,'es','Cargo Eliminado Exitosamente',0),(398483,11069,'de','Kostenlos erfolgreich gelÃ¶scht',0),(398484,11069,'en','Charge Deleted Successfully',0),(398485,11070,'is','',0),(398486,11070,'dr','Ø¨Ø±Ù‚',0),(398487,11070,'pr','Ø¨Ø±Ù‚',0),(398488,11070,'tr','Elektrik',0),(398489,11070,'pl','Elektryczne',0),(398490,11070,'bg','Ð•Ð»ÐµÐºÑ‚Ñ€Ð¸Ñ‡ÐµÑÐºÐ¸',0),(398491,11070,'ur','Ø¨Ø±Ù‚ÛŒ',0),(398492,11070,'sr','Ð•Ð»ÐµÐºÑ‚Ñ€Ð¸Ñ‡Ð½Ð¸',0),(398493,11070,'vi','Äiá»‡n',0),(398494,11070,'af','Elektriese',0),(398495,11070,'ro','Electrice',0),(398496,11070,'et','Elektriliste',0),(398497,11070,'si','ElektriÄni',0),(398498,11070,'ba','Listrik',0),(398499,11070,'nl','Elektrische',0),(398500,11070,'fi','Electric',0),(398501,11070,'no','Elektrisk',0),(398502,11070,'da','Elektrisk',0),(398503,11070,'ko','ì „ê¸°',0),(398504,11070,'he','×—×©×ž×œ×™',0),(398505,11070,'el','Î—Î»ÎµÎºÏ„ÏÎ¹ÎºÎ¬',0),(398506,11070,'zh','ç”µ\r\n',0),(398507,11070,'sv','Elektriska',0),(398508,11070,'it','Elettrico',0),(398509,11070,'tl','',0),(398510,11070,'th','à¹„à¸Ÿà¸Ÿà¹‰à¸²',0),(398511,11070,'hi','à¤‡à¤²à¥‡à¤•à¥à¤Ÿà¥à¤°à¤¿à¤•',0),(398512,11070,'ms','Elektrik',0),(398513,11070,'ar','ÙƒÙ‡Ø±Ø¨Ø§Ø¦ÙŠ',0),(398514,11070,'fr','Ã‰lectrique',0),(398515,11070,'jp','é›»æ°—',0),(398516,11070,'pt','ElÃ©trica',0),(398517,11070,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ',0),(398518,11070,'es','Luz',0),(398519,11070,'de','Elektrische',0),(398520,11070,'en','Electric',0),(398521,11071,'is','',0),(398522,11071,'dr','Ú¯Ø§Ø² ',0),(398523,11071,'pr','Ú¯Ø§Ø² ',0),(398524,11071,'tr','Gaz',0),(398525,11071,'pl','Gazu',0),(398526,11071,'bg','Ð“Ð°Ð·',0),(398527,11071,'ur','Ú¯ÛŒØ³',0),(398528,11071,'sr','Ð“Ð°Ñ',0),(398529,11071,'vi','gas',0),(398530,11071,'af','Gas',0),(398531,11071,'ro','Gaz',0),(398532,11071,'et','Gaasi',0),(398533,11071,'si','Plina',0),(398534,11071,'ba','Gas',0),(398535,11071,'nl','Gas',0),(398536,11071,'fi','Kaasu',0),(398537,11071,'no','Gass',0),(398538,11071,'da','Gas',0),(398539,11071,'ko','ê°€ìŠ¤',0),(398540,11071,'he','×’×–',0),(398541,11071,'el','Î‘ÎµÏÎ¯Î¿Ï…',0),(398542,11071,'zh','ç“¦æ–¯\r\n',0),(398543,11071,'sv','Gas',0),(398544,11071,'it','Gas',0),(398545,11071,'tl','',0),(398546,11071,'th','à¸à¹Šà¸²à¸‹',0),(398547,11071,'hi','à¤—à¥ˆà¤¸',0),(398548,11071,'ms','Gas',0),(398549,11071,'ar','Ø§Ù„ØºØ§Ø²',0),(398550,11071,'fr','Gaz',0),(398551,11071,'jp','ã‚¬ã‚¹',0),(398552,11071,'pt','GÃ¡s',0),(398553,11071,'ru','Ð“Ð°Ð·',0),(398554,11071,'es','Gas',0),(398555,11071,'de','Gas',0),(398556,11071,'en','Gas',0),(398557,11072,'is','',0),(398558,11072,'dr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(398559,11072,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(398560,11072,'tr','Fatura ekstra masraf',0),(398561,11072,'pl','Faktura dodatkowych opÅ‚at',0),(398562,11072,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(398563,11072,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ø¶Ø§ÙÛŒ Ú†Ø§Ø±Ø¬Ø²',0),(398564,11072,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(398565,11072,'vi','hÃ³a Ä‘Æ¡n thÃªm phÃ­',0),(398566,11072,'af','Faktureer Bykomende Kostes',0),(398567,11072,'ro','Factura taxe suplimentare',0),(398568,11072,'et','Arve lisatasu',0),(398569,11072,'si','DoplaÄila na raÄunu',0),(398570,11072,'ba','Faktur biaya tambahan',0),(398571,11072,'nl','Toeslagen factureren',0),(398572,11072,'fi','Laskun lisÃ¤maksu',0),(398573,11072,'no','Fakturere ekstrakostnader',0),(398574,11072,'da','Fakturere ekstra afgifter',0),(398575,11072,'ko','ì¶”ê°€ ìš”ê¸ˆ ì²­êµ¬ì„œ',0),(398576,11072,'he','×—×©×‘×•× ×™×ª ×—×™×•×‘×™× × ×•×¡×¤×™×',0),(398577,11072,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(398578,11072,'zh','å‘ç¥¨é¢å¤–è´¹ç”¨\r\n',0),(398579,11072,'sv','Fakturera Extra avgifter',0),(398580,11072,'it','Fattura spese Extra',0),(398581,11072,'tl','',0),(398582,11072,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸žà¸´à¹€à¸¨à¸©',0),(398583,11072,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(398584,11072,'ms','Invois caj-caj tambahan',0),(398585,11072,'ar','ÙØ§ØªÙˆØ±Ø© Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ©',0),(398586,11072,'fr','Facturer des frais supplÃ©mentaires',0),(398587,11072,'jp','è¿½åŠ æ–™é‡‘ã‚’è«‹æ±‚',0),(398588,11072,'pt','Custos extras de faturas',0),(398589,11072,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð½Ð°Ñ†ÐµÐ½ÐºÐ¸',0),(398590,11072,'es','Cargos Extras de Factura',0),(398591,11072,'de','Gegen GebÃ¼hr in Rechnung zu stellen',0),(398592,11072,'en','Invoice Extra Charges',0),(398593,11073,'is','',0),(398594,11073,'dr','(Ø®ÙˆØ§Ù†Ø¯Ù†) Ø§Ø³ØªÙ†Ø¨Ø§Ø· ',0),(398595,11073,'pr','Ø¢Ø®Ø±ÙŠÙ†(Ø®ÙˆØ§Ù†Ø¯Ù†) Ø§Ø³ØªÙ†Ø¨Ø§Ø· ',0),(398596,11073,'tr','Son okuma',0),(398597,11073,'pl','Ostatni odczyt',0),(398598,11073,'bg','ÐŸÑ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸ Ñ‡ÐµÑ‚ÐµÐ½Ðµ',0),(398599,11073,'ur','Ø¢Ø®Ø±ÛŒ Ù¾Ú‘Ú¾Ù†Ø§',0),(398600,11073,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ñ‡Ð¸Ñ‚Ð°ÑšÐ°',0),(398601,11073,'vi','Ä‘á»c trÆ°á»›c',0),(398602,11073,'af','Laaste Lesing',0),(398603,11073,'ro','Ultima citire',0),(398604,11073,'et','Viimane lugemine',0),(398605,11073,'si','Zadnji branje',0),(398606,11073,'ba','Terakhir membaca',0),(398607,11073,'nl','Laatste lezing',0),(398608,11073,'fi','ViimeisessÃ¤ kÃ¤sittelyssÃ¤',0),(398609,11073,'no','Siste lese',0),(398610,11073,'da','Sidste lÃ¦sning',0),(398611,11073,'ko','ë§ˆì§€ë§‰ ì½ê¸°',0),(398612,11073,'he','×§×¨×™××” ××—×¨×•× ×”',0),(398613,11073,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î±Î½Î¬Î³Î½Ï‰ÏƒÎ·',0),(398614,11073,'zh','æœ€åŽçš„è¯»æ•°\r\n',0),(398615,11073,'sv','Sista behandlingen',0),(398616,11073,'it','Ultima lettura',0),(398617,11073,'tl','',0),(398618,11073,'th','à¸­à¹ˆà¸²à¸™à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(398619,11073,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤ªà¤¢à¤¼à¤¨à¤¾',0),(398620,11073,'ms','Lepas membaca',0),(398621,11073,'ar','Ø§Ù„Ù‚Ø±Ø§Ø¡Ø© Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(398622,11073,'fr','DerniÃ¨re lecture',0),(398623,11073,'jp','æœ€å¾Œã®èª­æ›¸',0),(398624,11073,'pt','Ãšltima leitura',0),(398625,11073,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ñ‡Ñ‚ÐµÐ½Ð¸Ñ',0),(398626,11073,'es','Ultimo Lectura',0),(398627,11073,'de','Letzte Lesung',0),(398628,11073,'en','Last Reading',0),(398629,11074,'is','',0),(398630,11074,'dr','ØªØ§Ø³ÙŠØ³Ø§Øª Ùˆ ÙˆØ³Ø§ÙŠÙ„ Ø±ÙØ§Ù‡Ù‰ Ú©Ø§Ø±Ù‡Ø§Ù‰ Ø¹Ù…ÙˆÙ…Ù‰ ÙŠØ§ Ø®Ø¯Ù…Ø§ØªÙ‰ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ±ÙŠ Ø´Ø¯ ',0),(398631,11074,'pr','ØªØ§Ø³ÙŠØ³Ø§Øª Ùˆ ÙˆØ³Ø§ÙŠÙ„ Ø±ÙØ§Ù‡Ù‰ Ú©Ø§Ø±Ù‡Ø§Ù‰ Ø¹Ù…ÙˆÙ…Ù‰ ÙŠØ§ Ø®Ø¯Ù…Ø§ØªÙ‰ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ±ÙŠ Ø´Ø¯ ',0),(398632,11074,'tr','Ã–lÃ§Ã¼lÃ¼ yardÄ±mcÄ± programÄ±',0),(398633,11074,'pl','Pomiar przy wydawaniu narzÄ™dzie',0),(398634,11074,'bg','Ð˜Ð·Ð¼ÐµÑ€Ð²Ð° Ð¿Ð¾Ð»ÐµÐ·Ð½Ð¾ÑÑ‚',0),(398635,11074,'ur','Ø¨Ø§Ø²ÛŒ Ø§ÙØ§Ø¯Û Ú©Û’ Ù„Ø¦Û’',0),(398636,11074,'sr','Ð”Ð¾Ð·Ð¸Ñ€Ð°Ñ‚Ðµ ÑƒÑÐ»ÑƒÐ¶Ð½Ð¸ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼',0),(398637,11074,'vi','dá»¥ng cá»¥ Ä‘o',0),(398638,11074,'af','Gemete nut',0),(398639,11074,'ro','Utilitar de mÄƒsurat',0),(398640,11074,'et','MÃµÃµdetud kasuliku',0),(398641,11074,'si','Merjen korist',0),(398642,11074,'ba','Meteran utilitas',0),(398643,11074,'nl','Gemeten Utility',0),(398644,11074,'fi','Mitatusta apuohjelma',0),(398645,11074,'no','MÃ¥les verktÃ¸yet',0),(398646,11074,'da','AfmÃ¥lt nytte',0),(398647,11074,'ko','Metered ìœ í‹¸ë¦¬í‹°',0),(398648,11074,'he','×ž×•× ×™×•×ª ×”×©×™×¨×•×ª',0),(398649,11074,'el','Î”Î¿ÏƒÎ¹Î¼ÎµÏ„ÏÎ¹ÎºÎ­Ï‚ Ï‡ÏÎ·ÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î±',0),(398650,11074,'zh','æ¶ˆæ¯è®¾å¤‡\r\n',0),(398651,11074,'sv','UppmÃ¤tt verktyg',0),(398652,11074,'it','UtilitÃ  con tassametro',0),(398653,11074,'tl','',0),(398654,11074,'th','à¸­à¸£à¸£à¸–à¸£à¸–',0),(398655,11074,'hi','à¤®à¥€à¤Ÿà¤° à¤•à¥‡ à¤œà¤°à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤¿à¤¤à¤¾',0),(398656,11074,'ms','Utiliti meter',0),(398657,11074,'ar','Ø§Ù„Ø£Ø¯Ø§Ø© Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø© Ù„Ø£Ø¬Ù‡Ø²Ø© Ø§Ù„Ø§Ø³ØªÙ†Ø´Ø§Ù‚ Ø¨Ø§Ù„Ø¬Ø±Ø¹Ø§Øª',0),(398658,11074,'fr','Utilitaire de compteur',0),(398659,11074,'jp','å¾“é‡åˆ¶ã®ãƒ¦ãƒ¼ãƒ†ã‚£ãƒªãƒ†ã‚£',0),(398660,11074,'pt','UtilitÃ¡rio de inaladores',0),(398661,11074,'ru','Ð”Ð¾Ð·Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… ÑƒÑ‚Ð¸Ð»Ð¸Ñ‚Ð°',0),(398662,11074,'es','Servicios con Medidor',0),(398663,11074,'de','Gemessenen Dienstprogramm',0),(398664,11074,'en','Metered Utility',0),(398665,11075,'is','',0),(398666,11075,'dr','Ø®ÙˆØ§Ù†Ø¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ±ÙŠ Ø¬Ø¯ÙŠØ¯',0),(398667,11075,'pr','Ø®ÙˆØ§Ù†Ø¯Ù† Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú¯ÙŠØ±ÙŠ Ø¬Ø¯ÙŠØ¯',0),(398668,11075,'tr','Yeni sayaÃ§ okuma',0),(398669,11075,'pl','Nowego licznika',0),(398670,11075,'bg','ÐÐ¾Ð²Ð¸ Ð¾Ñ‚Ñ‡Ð¸Ñ‚Ð°Ð½Ðµ',0),(398671,11075,'ur','Ù†ÛŒØ§ Ù…ÛŒÙ¹Ø± Ø±ÛŒÚˆÙ†Ú¯',0),(398672,11075,'sr','ÐÐ¾Ð²Ð¾ Ð¾Ñ‡Ð¸Ñ‚Ð°Ð²Ð°ÑšÐµ Ð±Ñ€Ð¾Ñ˜Ð¸Ð»Ð°',0),(398673,11075,'vi','dá»¥ng cá»¥ Ä‘á»c má»›i',0),(398674,11075,'af','Nuwe Meter lees',0),(398675,11075,'ro','Noi contorului',0),(398676,11075,'et','Uue arvesti nÃ¤it',0),(398677,11075,'si','Nov Meter Reading',0),(398678,11075,'ba','Baru pembacaan Meter',0),(398679,11075,'nl','Nieuwe Meter lezing',0),(398680,11075,'fi','Uuden mittarilukema',0),(398681,11075,'no','Nye mÃ¥leravlesning',0),(398682,11075,'da','Nye mÃ¥leraflÃ¦sning',0),(398683,11075,'ko','ìƒˆë¡œìš´ ê²€ì¹¨',0),(398684,11075,'he','×§×¨×™××ª ×ž×•× ×™× ×—×“×©',0),(398685,11075,'el','ÎÎ­Î¿ Î¼ÎµÏ„ÏÎ·Ï„Î®',0),(398686,11075,'zh','æ–°è®¡é‡è¯»å–\r\n',0),(398687,11075,'sv','Nya mÃ¤taravlÃ¤sning',0),(398688,11075,'it','Nuova lettura del contatore',0),(398689,11075,'tl','',0),(398690,11075,'th','à¸­à¹ˆà¸²à¸™à¸„à¹ˆà¸²à¸¡à¸´à¹€à¸•à¸­à¸£à¹Œà¹ƒà¸«à¸¡à¹ˆ',0),(398691,11075,'hi','à¤¨à¤ à¤®à¥€à¤Ÿà¤° à¤°à¥€à¤¡à¤¿à¤‚à¤—',0),(398692,11075,'ms','Bacaan Meter baru',0),(398693,11075,'ar','Ù‚Ø±Ø§Ø¡Ø© Ø¹Ø¯Ø§Ø¯ Ø¬Ø¯ÙŠØ¯Ø©',0),(398694,11075,'fr','Nouveau relevÃ© de compteur',0),(398695,11075,'jp','æ–°ã—ã„ãƒ¡ãƒ¼ã‚¿ãƒ¼ã®èª­ã¿å–ã‚Š',0),(398696,11075,'pt','Nova leitura do medidor',0),(398697,11075,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¼ÐµÑ‚Ñ€ Ñ‡Ñ‚ÐµÐ½Ð¸Ðµ',0),(398698,11075,'es','Nueva Lectura e Meidor',0),(398699,11075,'de','Neue ZÃ¤hlerablesung',0),(398700,11075,'en','New Meter Reading',0),(398701,11076,'is','',0),(398702,11076,'dr','(Ù…Ø´Ø±ÙˆØ·',0),(398703,11076,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ Ù…Ø¹ÙˆÙ‚(Ù…Ø´Ø±ÙˆØ·',0),(398704,11076,'tr','Bekleyen ekstra masraf',0),(398705,11076,'pl','ZalegÅ‚ych opÅ‚at dodatkowych',0),(398706,11076,'bg','ÐÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(398707,11076,'ur','Ø§Ø¶Ø§ÙÛŒ Ú†Ø§Ø±Ø¬Ø² Ù†ÛÛŒÚº Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(398708,11076,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(398709,11076,'vi','chÆ°a lÃ m phÃ­ thÃªm',0),(398710,11076,'af','Afwagtende Bykomende Kostes',0),(398711,11076,'ro','Taxe suplimentare Ã®n aÅŸteptare',0),(398712,11076,'et','Ootel lisatasud',0),(398713,11076,'si','ÄŒakajoÄe doplaÄila',0),(398714,11076,'ba','Biaya tambahan yang tertunda',0),(398715,11076,'nl','Openstaande Extra bedragen',0),(398716,11076,'fi','Odottava lisÃ¤maksut',0),(398717,11076,'no','Ventende ekstrakostnader',0),(398718,11076,'da','Ventende tillÃ¦gsgebyrer',0),(398719,11076,'ko','ë³´ë¥˜ ì¤‘ì¸ ì¶”ê°€ ìš”ê¸ˆ',0),(398720,11076,'he','×—×™×•×‘×™× × ×•×¡×¤×™× ×ž×ž×ª×™× ×™×',0),(398721,11076,'el','Î•ÎºÎºÏÎµÎ¼ÎµÎ¯ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(398722,11076,'zh','å¾…åŠžçš„é¢å¤–è´¹ç”¨\r\n',0),(398723,11076,'sv','VÃ¤ntande Extra avgifter',0),(398724,11076,'it','Spese Extra in sospeso',0),(398725,11076,'tl','',0),(398726,11076,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸žà¸´à¹€à¸¨à¸©à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸žà¸´à¸ˆà¸²à¸£à¸“à¸²',0),(398727,11076,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(398728,11076,'ms','Caj-caj tambahan yang belum selesai',0),(398729,11076,'ar','Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ© Ù…Ø¹Ù„Ù‚Ø©',0),(398730,11076,'fr','Frais supplÃ©mentaires en attente',0),(398731,11076,'jp','ä¿ç•™ä¸­ã®è¿½åŠ æ–™é‡‘',0),(398732,11076,'pt','Custos extras pendentes',0),(398733,11076,'ru','ÐžÐ¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÐ±Ð¾Ñ€Ñ‹',0),(398734,11076,'es','Cargos Extras Pendientes',0),(398735,11076,'de','Ausstehende Nebenkosten',0),(398736,11076,'en','Pending Extra Charges',0),(398737,11077,'is','',0),(398738,11077,'dr','CAM ',0),(398739,11077,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù‚Ø¨Ù„ÙŠ ØªØ®ØµÙŠØµ Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙƒØ§Ù…Ù¾ÙˆØªØ±ÙŠ Ø³Ø§Ø®Øª  CAM ',0),(398740,11077,'tr','Ã–nceki CAM ayÄ±rma Ã¼cretleri',0),(398741,11077,'pl','Poprzedni CAM alokacja opÅ‚at',0),(398742,11077,'bg','ÐŸÑ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ CAM Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ñ‚Ð°ÐºÑÐ¸',0),(398743,11077,'ur','Ù¾Ú†Ú¾Ù„Ø§ Ú©ÛŒÙ… Ù…Ø®ØªØµ Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(398744,11077,'sr','Ð Ð°Ð½Ð¸Ñ˜Ðµ Ð¦ÐÐœ Ð´Ð¾Ð´ÐµÐ»Ðµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(398745,11077,'vi','phÃ­ Ä‘á»‹a Ä‘iá»ƒm CAN trÆ°á»›c',0),(398746,11077,'af','Vorige CAM toekenning kostes',0),(398747,11077,'ro','AnterioarÄƒ CAM alocarea taxe',0),(398748,11077,'et','Eelmise kaamera jaotamise tasud',0),(398749,11077,'si','PrejÅ¡njega CAM dodelitev stroÅ¡kov',0),(398750,11077,'ba','Sebelumnya CAM alokasi biaya',0),(398751,11077,'nl','Vorige CAM toewijzing kosten',0),(398752,11077,'fi','Edellinen CAM jakamista maksut',0),(398753,11077,'no','Forrige CAM tildeling avgifter',0),(398754,11077,'da','Tidligere CAM tildeling afgifter',0),(398755,11077,'ko','ì´ì „ ìº  í• ë‹¹ ìš”ê¸ˆ',0),(398756,11077,'he','×”×§×•×“× ×ž×¦×œ×ž×ª ×”×§×¦××ª ×—×™×•×‘×™×',0),(398757,11077,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚ ÎºÎ±Ï„Î±Î½Î¿Î¼Î® CAM',0),(398758,11077,'zh','ä»¥å‰çš„ç”µè„‘è¾…åŠ©åˆ†é…è´¹ç”¨\r\n',0),(398759,11077,'sv','Tidigare CAM fÃ¶rdelning avgifter',0),(398760,11077,'it','Precedente CAM ripartizione spese',0),(398761,11077,'tl','',0),(398762,11077,'th','à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰ CAM à¸à¸²à¸£à¸›à¸±à¸™à¸ªà¹ˆà¸§à¸™à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(398763,11077,'hi','à¤ªà¤¿à¤›à¤²à¤¾ à¤•à¥ˆà¤® à¤†à¤µà¤‚à¤Ÿà¤¨ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(398764,11077,'ms','Sebelumnya CAM peruntukan caj',0),(398765,11077,'ar','ÙƒØ§Ù… Ø§Ù„Ø³Ø§Ø¨Ù‚Ø© ØªØ®ØµÙŠØµ Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ',0),(398766,11077,'fr','Accusations antÃ©rieures de rÃ©partition CAM',0),(398767,11077,'jp','ä»¥å‰ã®ã‚«ãƒ ã®å‰²ã‚Šå½“ã¦æ–™é‡‘',0),(398768,11077,'pt','Taxas de alocaÃ§Ã£o anteriores CAM',0),(398769,11077,'ru','ÐŸÑ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ðµ ÐºÐ°Ð¼ÐµÑ€Ñ‹ Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(398770,11077,'es','Cargos Previos de AsignaciÃ³n de CAM',0),(398771,11077,'de','Vorherige CAM Zuweisung GebÃ¼hren',0),(398772,11077,'en','Previous CAM Allocation Charges',0),(398773,11078,'is','',0),(398774,11078,'dr','Ù†Ø±Ø® Ù¾Ø§ÙŠÙ‡ ',0),(398775,11078,'pr','Ù†Ø±Ø® Ù¾Ø§ÙŠÙ‡ ',0),(398776,11078,'tr','OranÄ± temeli',0),(398777,11078,'pl','Stawki',0),(398778,11078,'bg','ÐžÑÐ½Ð¾Ð²Ð°',0),(398779,11078,'ur','Ø´Ø±Ø­ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯',0),(398780,11078,'sr','Ð¡Ñ‚Ð¾Ð¿Ð° Ð¾ÑÐ½Ð¾Ð²Ð°',0),(398781,11078,'vi','Tá»· lá»‡ cÆ¡ báº£n',0),(398782,11078,'af','Tarief Basies',0),(398783,11078,'ro','Rata de bazÄƒ',0),(398784,11078,'et','MÃ¤Ã¤ra alusel',0),(398785,11078,'si','TeÄaj osnove',0),(398786,11078,'ba','Tingkat dasar',0),(398787,11078,'nl','Basis tarief',0),(398788,11078,'fi','Perusteella',0),(398789,11078,'no','Rente Basis',0),(398790,11078,'da','Sats',0),(398791,11078,'ko','í‰ê°€ ê¸°ì¤€',0),(398792,11078,'he','×ª×¢×¨×™×£ ×‘×¡×™×¡',0),(398793,11078,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î²Î¬ÏƒÎ·',0),(398794,11078,'zh','çŽ‡çš„åŸºç¡€\r\n',0),(398795,11078,'sv','RÃ¤ntesats',0),(398796,11078,'it','Tasso base',0),(398797,11078,'tl','',0),(398798,11078,'th','à¹€à¸à¸“à¸‘à¹Œà¸­à¸±à¸•à¸£à¸²',0),(398799,11078,'hi','à¤¦à¤° à¤†à¤§à¤¾à¤°',0),(398800,11078,'ms','Kadar asas',0),(398801,11078,'ar','Ø£Ø³Ø§Ø³ Ù…Ø¹Ø¯Ù„',0),(398802,11078,'fr','Base de taux',0),(398803,11078,'jp','æ–™é‡‘ãƒ™ãƒ¼ã‚¹',0),(398804,11078,'pt','Taxa base',0),(398805,11078,'ru','ÐšÑƒÑ€Ñ Ð¾ÑÐ½Ð¾Ð²Ñ‹',0),(398806,11078,'es','Base de Tasas',0),(398807,11078,'de','Tarif Basis',0),(398808,11078,'en','Rate Basis',0),(398809,11079,'is','',0),(398810,11079,'dr','ÙˆØ§Ø­Ø¯ ØªÙÙƒÙŠÙƒ',0),(398811,11079,'pr','ÙˆØ§Ø­Ø¯ ØªÙÙƒÙŠÙƒ',0),(398812,11079,'tr','Birim Ã§Ã¶zÃ¼mleme',0),(398813,11079,'pl','PodziaÅ‚ jednostki',0),(398814,11079,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(398815,11079,'ur','ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚',0),(398816,11079,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° ÑÐ»Ð¾Ð¼',0),(398817,11079,'vi','PhÃ¢n tÃ­ch Ä‘Æ¡n vá»‹',0),(398818,11079,'af','Eenheid Ontleding',0),(398819,11079,'ro','Unitate defalcare',0),(398820,11079,'et','Ãœksuse jaotus',0),(398821,11079,'si','Enota razÄlenitev',0),(398822,11079,'ba','Unit Breakdown',0),(398823,11079,'nl','Eenheid verdeling',0),(398824,11079,'fi','YksikkÃ¶ erittely',0),(398825,11079,'no','Enheten sammenbrudd',0),(398826,11079,'da','Enhed opdeling',0),(398827,11079,'ko','ìž¥ì¹˜ ê³ ìž¥',0),(398828,11079,'he','×™×—×™×“×ª ×”×ª×ž×•×˜×˜×•×ª',0),(398829,11079,'el','ÎœÎ¿Î½Î¬Î´Î± ÎºÎ±Ï„Î±Î½Î¿Î¼Î®',0),(398830,11079,'zh','å•ä½åˆ†è§£\r\n',0),(398831,11079,'sv','Enhet uppdelning',0),(398832,11079,'it','Avaria',0),(398833,11079,'tl','',0),(398834,11079,'th','à¸à¸²à¸£à¹à¸šà¹ˆà¸‡à¸«à¸™à¹ˆà¸§à¸¢',0),(398835,11079,'hi','à¤‡à¤•à¤¾à¤ˆ à¤Ÿà¥‚à¤Ÿà¤¨à¥‡',0),(398836,11079,'ms','Pecahan unit',0),(398837,11079,'ar','Ø§Ù†Ù‡ÙŠØ§Ø± Ø§Ù„ÙˆØ­Ø¯Ø©',0),(398838,11079,'fr','Ventilation d\'unitÃ©',0),(398839,11079,'jp','å˜ä½ã®å†…è¨³',0),(398840,11079,'pt','Colapso da unidade',0),(398841,11079,'ru','Ð Ð°Ð·Ð±Ð¸Ð²ÐºÐ° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(398842,11079,'es','Detalle Completo de Unidad',0),(398843,11079,'de','Einheit-AufschlÃ¼sselung',0),(398844,11079,'en','Unit Breakdown',0),(398845,11080,'is','',0),(398846,11080,'dr','(ØªØ³Ù‡ÙŠÙ„Ø§Øª',0),(398847,11080,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ(ØªØ³Ù‡ÙŠÙ„Ø§Øª',0),(398848,11080,'tr','YardÄ±mcÄ± programlar',0),(398849,11080,'pl','NarzÄ™dzia',0),(398850,11080,'bg','ÐšÐ¾Ð¼ÑƒÐ½Ð°Ð»Ð½Ð¸ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(398851,11080,'ur','Ø§ÙØ§Ø¯ÛŒØª',0),(398852,11080,'sr','ÐšÐ¾Ð¼ÑƒÐ½Ð°Ð»Ð½Ðµ ÑƒÑÐ»ÑƒÐ³Ðµ',0),(398853,11080,'vi','Tiá»‡n Ã­ch',0),(398854,11080,'af','Nutsitems',0),(398855,11080,'ro','Utilitati',0),(398856,11080,'et','Utiliidid',0),(398857,11080,'si','Utilities',0),(398858,11080,'ba','Utilitas',0),(398859,11080,'nl','Hulpprogramma \'s',0),(398860,11080,'fi','Utilities',0),(398861,11080,'no','VerktÃ¸y',0),(398862,11080,'da','HjÃ¦lpeprogrammer',0),(398863,11080,'ko','ìœ í‹¸ë¦¬í‹°',0),(398864,11080,'he','×›×œ×™ ×¢×–×¨',0),(398865,11080,'el','Î’Î¿Î·Î¸Î·Ï„Î¹ÎºÎ¬ Ï€ÏÎ¿Î³ÏÎ¬Î¼Î¼Î±Ï„Î±',0),(398866,11080,'zh','å…¬ç”¨äº‹ä¸š\r\n',0),(398867,11080,'sv','Verktyg',0),(398868,11080,'it','Programmi di utilitÃ ',0),(398869,11080,'tl','',0),(398870,11080,'th','à¹‚à¸›à¸£à¹à¸à¸£à¸¡à¸­à¸£à¸£à¸–à¸›à¸£à¸°à¹‚à¸¢à¸Šà¸™à¹Œ',0),(398871,11080,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤¿à¤¤à¤¾à¤à¤',0),(398872,11080,'ms','Utiliti',0),(398873,11080,'ar','Ø§Ù„Ù…Ø±Ø§ÙÙ‚ Ø§Ù„Ø¹Ø§Ù…Ø©',0),(398874,11080,'fr','Utilitaires',0),(398875,11080,'jp','ãƒ¦ãƒ¼ãƒ†ã‚£ãƒªãƒ†ã‚£',0),(398876,11080,'pt','UtilitÃ¡rios',0),(398877,11080,'ru','Ð£Ñ‚Ð¸Ð»Ð¸Ñ‚Ñ‹',0),(398878,11080,'es','Servicios',0),(398879,11080,'de','Dienstprogramme',0),(398880,11080,'en','Utilities',0),(398881,11081,'is','',0),(398882,11081,'dr','Ø¢Ø¨ ',0),(398883,11081,'pr','Ø¢Ø¨ ',0),(398884,11081,'tr','Su',0),(398885,11081,'pl','Wody',0),(398886,11081,'bg','Ð’Ð¾Ð´Ð°',0),(398887,11081,'ur','Ù¾Ø§Ù†ÛŒ',0),(398888,11081,'sr','Ð’Ð¾Ð´Ð°',0),(398889,11081,'vi','nÆ°á»›c',0),(398890,11081,'af','Water',0),(398891,11081,'ro','ApÄƒ',0),(398892,11081,'et','Vee',0),(398893,11081,'si','Vode',0),(398894,11081,'ba','Air',0),(398895,11081,'nl','Water',0),(398896,11081,'fi','Vesi',0),(398897,11081,'no','Vann',0),(398898,11081,'da','Vand',0),(398899,11081,'ko','ë¬¼',0),(398900,11081,'he','×ž×™×',0),(398901,11081,'el','ÎÎµÏÏŒ',0),(398902,11081,'zh','æ°´\r\n',0),(398903,11081,'sv','Vatten',0),(398904,11081,'it','Acqua',0),(398905,11081,'tl','',0),(398906,11081,'th','à¸™à¹‰à¸³',0),(398907,11081,'hi','à¤ªà¤¾à¤¨à¥€',0),(398908,11081,'ms','Air',0),(398909,11081,'ar','Ø§Ù„Ù…ÙŠØ§Ù‡',0),(398910,11081,'fr','Eau',0),(398911,11081,'jp','æ°´',0),(398912,11081,'pt','Ãgua',0),(398913,11081,'ru','Ð’Ð¾Ð´Ñ‹',0),(398914,11081,'es','Agua',0),(398915,11081,'de','Wasser',0),(398916,11081,'en','Water',0),(398917,11082,'is','',0),(398918,11082,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(398919,11082,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(398920,11082,'tr','Bir bina seÃ§melisiniz',0),(398921,11082,'pl','NaleÅ¼y wybraÄ‡ budynku',0),(398922,11082,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ´Ð½Ð° ÑÐ³Ñ€Ð°Ð´Ð°',0),(398923,11082,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø¹Ù…Ø§Ø±Øª Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(398924,11082,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð·Ð³Ñ€Ð°Ð´Ð°',0),(398925,11082,'vi','Báº¡n pháº£i chá»n má»™t tÃ²a nhÃ ',0),(398926,11082,'af','U Moet \'n Gebou Selekteer',0),(398927,11082,'ro','Trebuie sÄƒ selectaÅ£i o clÄƒdire',0),(398928,11082,'et','Te peate valima hoone',0),(398929,11082,'si','Izbrati morate stavbe',0),(398930,11082,'ba','Anda harus memilih sebuah bangunan',0),(398931,11082,'nl','Moet u een gebouw',0),(398932,11082,'fi','Valitse rakennuksen',0),(398933,11082,'no','Du mÃ¥ velge en bygning',0),(398934,11082,'da','Du skal vÃ¦lge en bygning',0),(398935,11082,'ko','ê±´ë¬¼ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(398936,11082,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×‘× ×™×™×Ÿ',0),(398937,11082,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± ÎºÏ„Î¯ÏÎ¹Î¿',0),(398938,11082,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªå¤§åŽ¦\r\n',0),(398939,11082,'sv','Du mÃ¥ste vÃ¤lja en byggnad',0),(398940,11082,'it','Ãˆ necessario selezionare un edificio',0),(398941,11082,'tl','',0),(398942,11082,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸­à¸²à¸„à¸²à¸£',0),(398943,11082,'hi','à¤†à¤ª à¤à¤• à¤‡à¤®à¤¾à¤°à¤¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(398944,11082,'ms','Anda mesti memilih sebuah bangunan',0),(398945,11082,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ­Ø¯ÙŠØ¯ Ù…Ø¨Ù†Ù‰',0),(398946,11082,'fr','Vous devez sÃ©lectionner un bÃ¢timent',0),(398947,11082,'jp','å»ºç‰©ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(398948,11082,'pt','VocÃª deve selecionar um edifÃ­cio',0),(398949,11082,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð·Ð´Ð°Ð½Ð¸Ðµ',0),(398950,11082,'es','Debe Seleccionar Un Edificio',0),(398951,11082,'de','Sie mÃ¼ssen ein GebÃ¤ude auswÃ¤hlen.',0),(398952,11082,'en','You Must Select A Building',0),(398953,11083,'is','',0),(398954,11083,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ø³ØªØ§Ø¬Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(398955,11083,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ø³ØªØ§Ø¬Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(398956,11083,'tr','KiracÄ± seÃ§melisiniz',0),(398957,11083,'pl','NaleÅ¼y wybraÄ‡ najemcy',0),(398958,11083,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ´Ð¸Ð½ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»',0),(398959,11083,'ur','Ø¢Ù¾ Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(398960,11083,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÑ‚Ð°Ð½Ð°Ñ€Ð°',0),(398961,11083,'vi','Báº¡n Pháº£i Chá»n Má»™t ngÆ°á»i thuÃª nhÃ ',0),(398962,11083,'af','U moet \'n Huurder Kies',0),(398963,11083,'ro','Trebuie sÄƒ selectaÅ£i un chiriaÅŸ',0),(398964,11083,'et','Valige Ã¼Ã¼rnik',0),(398965,11083,'si','Morate izbrati najemnika',0),(398966,11083,'ba','Anda harus memilih penyewa',0),(398967,11083,'nl','U moet een huurder selecteren',0),(398968,11083,'fi','Valitse vuokralainen',0),(398969,11083,'no','Du mÃ¥ velge en leietaker',0),(398970,11083,'da','Du skal vÃ¦lge en lejer',0),(398971,11083,'ko','ì„¸ ìž…ìžë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(398972,11083,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×“×™×™×¨',0),(398973,11083,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± ÎµÎ½Î¿Î¹ÎºÎ¹Î±ÏƒÏ„Î®',0),(398974,11083,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªç§Ÿå®¢\r\n',0),(398975,11083,'sv','Du mÃ¥ste vÃ¤lja en hyresgÃ¤st',0),(398976,11083,'it','Ãˆ necessario selezionare un inquilino',0),(398977,11083,'tl','',0),(398978,11083,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(398979,11083,'hi','à¤¤à¥à¤® à¤à¤• à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(398980,11083,'ms','Anda mesti memilih penyewa',0),(398981,11083,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ­Ø¯ÙŠØ¯ Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(398982,11083,'fr','Vous devez sÃ©lectionner un locataire.',0),(398983,11083,'jp','ãƒ†ãƒŠãƒ³ãƒˆã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(398984,11083,'pt','VocÃª deve selecionar um inquilino',0),(398985,11083,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð°',0),(398986,11083,'es','Debe Seleccionar Un Inquilino',0),(398987,11083,'de','Sie mÃ¼ssen einen Mieter auswÃ¤hlen.',0),(398988,11083,'en','You Must Select A Tenant',0),(398989,11084,'is','',0),(398990,11084,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯',0),(398991,11084,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ§ÙƒØªÙˆØ± Ø´Ø¯',0),(398992,11084,'tr','BaÅŸarÄ±yla faturalandÄ±rÄ±lmamÄ±ÅŸ Ã¼cretleri',0),(398993,11084,'pl','Koszty zafakturowane pomyÅ›lnie',0),(398994,11084,'bg','Ð¢Ð°ÐºÑÐ¸, Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(398995,11084,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(398996,11084,'sr','ÐžÐ¿Ñ‚ÑƒÐ¶Ð±Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(398997,11084,'vi','TÃ­nh phÃ­ ho1s Ä‘Æ¡nm thÃ nh cÃ´ng',0),(398998,11084,'af','Kostes Suksesvol Gefaktureer',0),(398999,11084,'ro','Taxe facturate cu succes',0),(399000,11084,'et','SissenÃµutavaid transpordikulusid edukalt',0),(399001,11084,'si','StroÅ¡ki, zaraÄunani uspeÅ¡no',0),(399002,11084,'ba','Biaya ditagih berhasil',0),(399003,11084,'nl','Kosten gefactureerd met succes',0),(399004,11084,'fi','Kulujen laskutettu onnistuneesti',0),(399005,11084,'no','Avgifter faktureres vellykket',0),(399006,11084,'da','Afgifter faktureres med succes',0),(399007,11084,'ko','ì„±ê³µì ìœ¼ë¡œ ì²­êµ¬ í•˜ëŠ” ìš”ê¸ˆ',0),(399008,11084,'he','×ª×œ×•× ×” ×”×•×’×©×” ×—×©×‘×•× ×™×ª ×‘×”×¦×œ×—×”',0),(399009,11084,'el','ÎˆÎ¾Î¿Î´Î± Ï„Î± Î¿Ï€Î¿Î¯Î± Ï‡ÏÎµÏŽÎ½Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(399010,11084,'zh','æ”¶è´¹å¼€å…·å‘ç¥¨çš„æˆåŠŸ\r\n',0),(399011,11084,'sv','Avgifter faktureras framgÃ¥ngsrikt',0),(399012,11084,'it','Spese fatturate con successo',0),(399013,11084,'tl','',0),(399014,11084,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(399015,11084,'hi','à¤†à¤°à¥‹à¤ª à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(399016,11084,'ms','Bayaran invois berjaya',0),(399017,11084,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø¨Ù†Ø¬Ø§Ø­',0),(399018,11084,'fr','Frais facturÃ©s avec succÃ¨s',0),(399019,11084,'jp','æ­£å¸¸ã«è«‹æ±‚ã•ã‚Œã‚‹æ–™é‡‘',0),(399020,11084,'pt','Encargos facturados com sucesso',0),(399021,11084,'ru','ÐžÐ±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ, Ð²Ñ‹ÑÑ‚Ð°Ð²Ð¸Ð»Ð° ÑÑ‡ÐµÑ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(399022,11084,'es','Cargos Facturados Exitosamente',0),(399023,11084,'de','GebÃ¼hren, die erfolgreich in Rechnung gestellt',0),(399024,11084,'en','Charges Invoiced Successfully',0),(399025,11085,'is','',0),(399026,11085,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(399027,11085,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(399028,11085,'tr','Fazladan fatura giderleri',0),(399029,11085,'pl','Dodatkowe faktury opÅ‚aty',0),(399030,11085,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(399031,11085,'ur','Ø§Ø¶Ø§ÙÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(399032,11085,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(399033,11085,'vi','thÃªm phÃ­ hÃ³a Ä‘Æ¡n',0),(399034,11085,'af','Bykomende Faktuurkostes',0),(399035,11085,'ro','Taxe suplimentare facturÄƒ',0),(399036,11085,'et','Eest arve maksud',0),(399037,11085,'si','StroÅ¡ki raÄuna',0),(399038,11085,'ba','Biaya tambahan faktur',0),(399039,11085,'nl','Extra factuur kosten',0),(399040,11085,'fi','Kun laskun kuluille',0),(399041,11085,'no','Ekstra faktura kostnader',0),(399042,11085,'da','Ekstra faktura afgifter',0),(399043,11085,'ko','ì¶”ê°€ ì²­êµ¬ì„œ ìš”ê¸ˆ',0),(399044,11085,'he','×—×©×‘×•× ×™×ª × ×•×¡×¤×ª ×—×™×•×‘×™×',0),(399045,11085,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(399046,11085,'zh','é¢å¤–æ”¶è´¹å‘ç¥¨\r\n',0),(399047,11085,'sv','Extra fakturaavgifter',0),(399048,11085,'it','Addebiti in fattura extra',0),(399049,11085,'tl','',0),(399050,11085,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(399051,11085,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤†à¤°à¥‹à¤ª',0),(399052,11085,'ms','Caj-caj tambahan invois',0),(399053,11085,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(399054,11085,'fr','Frais de facture supplÃ©mentaire',0),(399055,11085,'jp','ä½™åˆ†ãªè«‹æ±‚æ›¸ã®æ–™é‡‘',0),(399056,11085,'pt','AcusaÃ§Ãµes de fatura extra',0),(399057,11085,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð° ÑÐ±Ð¾Ñ€Ñ‹',0),(399058,11085,'es','Cargos de Facturas Extra',0),(399059,11085,'de','ZusÃ¤tzliche Rechnung GebÃ¼hren',0),(399060,11085,'en','Extra Invoice Charges',0),(399061,11086,'is','',0),(399062,11086,'dr','( Ú¯Ø±ÙØªÙ† ) Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ',0),(399063,11086,'pr','ØªÙ‡ÙŠÙ‡( Ú¯Ø±ÙØªÙ† ) Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ',0),(399064,11086,'tr','Ãœcretler almak',0),(399065,11086,'pl','SiÄ™ opÅ‚at',0),(399066,11086,'bg','Ð’Ð·ÐµÐ¼Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(399067,11086,'ur','Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Û’ ØªØ­Øª Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(399068,11086,'sr','ÐŸÐ¾ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ð¸',0),(399069,11086,'vi','láº­p phÃ­',0),(399070,11086,'af','Verkry Kostes',0),(399071,11086,'ro','ObÅ£ine taxele',0),(399072,11086,'et','Saada tasu',0),(399073,11086,'si','Se dajatve',0),(399074,11086,'ba','Mendapatkan biaya',0),(399075,11086,'nl','Krijgen van de kosten',0),(399076,11086,'fi','Saavat maksuista',0),(399077,11086,'no','FÃ¥ kostnader',0),(399078,11086,'da','FÃ¥ afgifter',0),(399079,11086,'ko','ìš”ê¸ˆì„ ì–»ì„',0),(399080,11086,'he','×œ×§×‘×œ ×›×ª×‘ ××™×©×•×',0),(399081,11086,'el','Î Î¬ÏÎµÎ¹ Ï„Ï‰Î½ Ï„ÎµÎ»ÏŽÎ½',0),(399082,11086,'zh','èŽ·å–æ”¶è´¹\r\n',0),(399083,11086,'sv','FÃ¥ avgifter',0),(399084,11086,'it','Ottenere cariche',0),(399085,11086,'tl','',0),(399086,11086,'th','à¹„à¸”à¹‰à¸£à¸±à¸šà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(399087,11086,'hi','à¤†à¤°à¥‹à¤ª à¤¹à¥‹ à¤œà¤¾à¤“',0),(399088,11086,'ms','Mendapatkan caj',0),(399089,11086,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø±Ø³ÙˆÙ…',0),(399090,11086,'fr','Obtenir les Charges',0),(399091,11086,'jp','è«‹æ±‚ã‚’å–å¾—ã—ã¾ã™ã€‚',0),(399092,11086,'pt','AcusaÃ§Ãµes',0),(399093,11086,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(399094,11086,'es','Agarrar Cargos',0),(399095,11086,'de','GebÃ¼hren zu erhalten',0),(399096,11086,'en','Get Charges',0),(399097,11087,'is','',0),(399098,11087,'dr','Ø´Ø§Ù…Ù„ ÙØ§ÙƒØªÙˆØ± Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(399099,11087,'pr','Ø´Ø§Ù…Ù„ ÙØ§ÙƒØªÙˆØ± Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(399100,11087,'tr','Dahil fatura',0),(399101,11087,'pl','ZawierajÄ… zafakturowany',0),(399102,11087,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(399103,11087,'ur','Ø´Ø§Ù…Ù„ ÛÛŒÚº Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯',0),(399104,11087,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð¸',0),(399105,11087,'vi','Bao gá»“m hÃ³a Ä‘Æ¡n',0),(399106,11087,'af','Gefakturedes Ingesluit',0),(399107,11087,'ro','Includ facturate',0),(399108,11087,'et','Kaasata arveldatud',0),(399109,11087,'si','VkljuÄujejo fakturirano',0),(399110,11087,'ba','Termasuk ditagih',0),(399111,11087,'nl','Omvatten gefactureerd',0),(399112,11087,'fi','Ovat laskutettu',0),(399113,11087,'no','Er fakturert',0),(399114,11087,'da','Omfatte faktureret',0),(399115,11087,'ko','í¬í•¨ ë˜ì–´ ì²­êµ¬',0),(399116,11087,'he','×›×•×œ×œ×™× ×—×•×™×‘',0),(399117,11087,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î·',0),(399118,11087,'zh','åŒ…æ‹¬å‘ç¥¨\r\n',0),(399119,11087,'sv','Inkluderar fakturerade',0),(399120,11087,'it','Sono fatturati',0),(399121,11087,'tl','',0),(399122,11087,'th','à¸¡à¸µà¸à¸²à¸£à¸­à¸­à¸à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œ',0),(399123,11087,'hi','à¤¶à¤¾à¤®à¤¿à¤² à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(399124,11087,'ms','Termasuklah invois',0),(399125,11087,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ù…ÙÙˆØªØ±',0),(399126,11087,'fr','Sont facturÃ©es',0),(399127,11087,'jp','å«ã‚ã‚‹è«‹æ±‚',0),(399128,11087,'pt','Incluem facturado',0),(399129,11087,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚',0),(399130,11087,'es','Incluir los Facturados',0),(399131,11087,'de','Enthalten in Rechnung gestellt',0),(399132,11087,'en','Include Invoiced',0),(399133,11088,'is','',0),(399134,11088,'dr','Ù‡ÙŠÚ† Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø¹ÙˆÙ‚ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(399135,11088,'pr','Ù‡ÙŠÚ† Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø¹ÙˆÙ‚ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(399136,11088,'tr','HayÄ±r bekleyen Ã¶demeler bulundu',0),(399137,11088,'pl','Nie znalazÅ‚ czasu opÅ‚aty',0),(399138,11088,'bg','ÐÑÐ¼Ð° Ñ‡Ð°ÐºÐ°Ñ‰Ð¸ Ñ‚Ð°ÐºÑÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(399139,11088,'ur','Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Û’ ØªØ­Øª Ø²ÛŒØ±Ù Ø§Ù„ØªÙˆØ§ Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(399140,11088,'sr','ÐÐµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(399141,11088,'vi','khÃ´ng tÃ¬m tháº¥y phÃ­ Ä‘ang treo',0),(399142,11088,'af','Geen Afwagtende Kostes Gevind',0),(399143,11088,'ro','Nu Ã®n aÅŸteptare taxe gÄƒsit',0),(399144,11088,'et','Nr tasumata makseid leitud',0),(399145,11088,'si','Ni ÄakajoÄih stroÅ¡ki naÅ¡el',0),(399146,11088,'ba','Tidak menunggu biaya ditemukan',0),(399147,11088,'nl','Geen hangende lasten gevonden',0),(399148,11088,'fi','Ei odottavia maksuja lÃ¶ytyi',0),(399149,11088,'no','Ingen utestÃ¥ende belÃ¸p funnet',0),(399150,11088,'da','Ingen fundet afventende debiteringer',0),(399151,11088,'ko','ìš”ê¸ˆ ë³´ë¥˜ ë” ë°œê²¬',0),(399152,11088,'he','. ×œ× ×—×™×•×‘×™× ×ž×ž×ª×™× ×™× ×ž×¦×',0),(399153,11088,'el','ÎŒÏ‡Î¹ Î¿Î¹ ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(399154,11088,'zh','æ²¡æœ‰æ‰¾åˆ°å¾…è¡¥æ”¶è´¹\r\n',0),(399155,11088,'sv','Ingen hittade vÃ¤ntan avgifter',0),(399156,11088,'it','No, in attesa di oneri trovato',0),(399157,11088,'tl','',0),(399158,11088,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(399159,11088,'hi','à¤•à¥‹à¤ˆ à¤²à¤‚à¤¬à¤¿à¤¤ à¤†à¤°à¥‹à¤ª à¤ªà¤¾à¤¯à¤¾',0),(399160,11088,'ms','Tidak menunggu bayaran mendapati',0),(399161,11088,'ar','Ù„Ø§ Ø±ÙŠØ«Ù…Ø§ ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø±Ø³ÙˆÙ…',0),(399162,11088,'fr','Non, lesquelles pesaient des accusations trouvÃ©',0),(399163,11088,'jp','ä¿ç•™ä¸­ã®æ–™é‡‘ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(399164,11088,'pt','NÃ£o pendentes acusaÃ§Ãµes encontrado',0),(399165,11088,'ru','ÐÐµ Ð´Ð¾ ÑÐ±Ð¾Ñ€Ð¾Ð² Ð½Ð°ÑˆÐ»Ð¸',0),(399166,11088,'es','No se Encontraron Cargos Pendientes',0),(399167,11088,'de','Ausstehende GebÃ¼hren nicht gefunden',0),(399168,11088,'en','No Pending Charges Found',0),(399169,11089,'is','',0),(399170,11089,'dr','Ø§Ø±Ø³Ø§Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(399171,11089,'pr','Ø§Ø±Ø³Ø§Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ ÙØ§ÙƒØªÙˆØ± ',0),(399172,11089,'tr','SonrasÄ± fatura ekstra masraf',0),(399173,11089,'pl','Post faktury opÅ‚aty dodatkowe',0),(399174,11089,'bg','ÐŸÐ¾ÑÑ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(399175,11089,'ur','Ù¾ÙˆØ³Ù¹ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ø¶Ø§ÙÛŒ Ú†Ø§Ø±Ø¬Ø²',0),(399176,11089,'sr','ÐšÑšÐ¸Ð¶ÐµÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐµÐºÑÑ‚Ñ€Ð° Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(399177,11089,'vi','káº¿t chuyá»ƒn thÃªm phÃ­ hÃ³a Ä‘Æ¡n',0),(399178,11089,'af','Posteer Faktuur Bykomende Kostes',0),(399179,11089,'ro','Post factura taxe suplimentare',0),(399180,11089,'et','Post arve lisatasu',0),(399181,11089,'si','Post raÄun dodatnih stroÅ¡kov',0),(399182,11089,'ba','Posting faktur biaya tambahan',0),(399183,11089,'nl','Post factuur Extra kosten',0),(399184,11089,'fi','Postitse laskun lisÃ¤maksu',0),(399185,11089,'no','Innlegget faktura ekstra kostnader',0),(399186,11089,'da','Post faktura ekstra afgifter',0),(399187,11089,'ko','ê²Œì‹œë¬¼ ì†¡ìž¥ ì¶”ê°€ ìš”ê¸ˆ',0),(399188,11089,'he','×¤×•×¡×˜ ×—×©×‘×•× ×™×ª ×—×™×•×‘×™× × ×•×¡×¤×™×',0),(399189,11089,'el','Î˜Î­ÏƒÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(399190,11089,'zh','å‘å¸ƒå‘ç¥¨é¢å¤–æ”¶è´¹\r\n',0),(399191,11089,'sv','InlÃ¤gget Extra fakturaavgifter',0),(399192,11089,'it','Post fattura spese Extra',0),(399193,11089,'tl','',0),(399194,11089,'th','à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¹ˆà¸²à¸šà¸£à¸´à¸à¸²à¸£à¹€à¸ªà¸£à¸´à¸¡',0),(399195,11089,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(399196,11089,'ms','Post invois caj-caj tambahan',0),(399197,11089,'ar','Ø¢Ø®Ø± ÙØ§ØªÙˆØ±Ø© Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ©',0),(399198,11089,'fr','Post facture des frais supplÃ©mentaires',0),(399199,11089,'jp','éƒµä¾¿è«‹æ±‚æ–™é‡‘',0),(399200,11089,'pt','Post factura sobretaxas',0),(399201,11089,'ru','ÐŸÐ¾ÑÑ‚ ÑÑ‡ÐµÑ‚Ð° Ð½Ð°Ñ†ÐµÐ½ÐºÐ¸',0),(399202,11089,'es','Asentar Cargos Extras de Factura',0),(399203,11089,'de','Post Rechnung gegen GebÃ¼hr',0),(399204,11089,'en','Post Invoice Extra Charges',0),(399205,11090,'is','',0),(399206,11090,'dr','Ø§Ø±Ø³Ø§Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø¹ÙˆÙ‚',0),(399207,11090,'pr','Ø§Ø±Ø³Ø§Ù„ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø¹ÙˆÙ‚',0),(399208,11090,'tr','Posta giderleri bekleyen',0),(399209,11090,'pl','Po oczekiwaniu na opÅ‚aty',0),(399210,11090,'bg','ÐŸÐ¾ÑÑ‚ Ð½ÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸Ñ‚Ðµ Ñ‚Ð°ÐºÑÐ¸',0),(399211,11090,'ur','Ù¾ÙˆØ³Ù¹ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Û’ ØªØ­Øª Ø²ÛŒØ±Ù Ø§Ù„ØªÙˆØ§',0),(399212,11090,'sr','ÐŸÐ¾ÑÑ‚ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(399213,11090,'vi','káº¿t chuyá»ƒn phÃ­ Ä‘ang treo',0),(399214,11090,'af','Posteer Afwagtende Kostes',0),(399215,11090,'ro','Post pÃ¢nÄƒ la taxe',0),(399216,11090,'et','Post tasumata makseid',0),(399217,11090,'si','Post, ki Äakajo na obdelavo',0),(399218,11090,'ba','Posting tertunda biaya',0),(399219,11090,'nl','Post in afwachting van kosten',0),(399220,11090,'fi','Post maksamattomat maksut',0),(399221,11090,'no','Innlegget utestÃ¥ende belÃ¸p',0),(399222,11090,'da','Post afventende debiteringer',0),(399223,11090,'ko','ìš”ê¸ˆ ë³´ë¥˜ ê²Œì‹œë¬¼',0),(399224,11090,'he','×¤×•×¡×˜ ×—×™×•×‘×™× ×ž×ž×ª×™× ×™×',0),(399225,11090,'el','Î˜Î­ÏƒÎ· Î¿Î¹ ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(399226,11090,'zh','å‘å¸ƒæœªç»“è´¹ç”¨\r\n',0),(399227,11090,'sv','Post vÃ¤ntande avgifter',0),(399228,11090,'it','Post in attesa di oneri',0),(399229,11090,'tl','',0),(399230,11090,'th','à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(399231,11090,'hi','à¤†à¤°à¥‹à¤ª à¤²à¤‚à¤¬à¤¿à¤¤ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(399232,11090,'ms','Post sementara menunggu bayaran',0),(399233,11090,'ar','ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù†ÙÙ‚Ø§Øª Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(399234,11090,'fr','Post lesquelles pesaient des accusations',0),(399235,11090,'jp','ä¿ç•™ä¸­ã®æ–™é‡‘ãƒã‚¹ãƒˆ',0),(399236,11090,'pt','Post pendente acusaÃ§Ãµes',0),(399237,11090,'ru','ÐŸÐ¾ÑÑ‚ Ð´Ð¾ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(399238,11090,'es','Asentar Cargos Pendientes',0),(399239,11090,'de','Post ausstehende GebÃ¼hren',0),(399240,11090,'en','Post Pending Charges',0),(399241,11091,'is','',0),(399242,11091,'dr','Ø¬Ø³ØªØ¬Ùˆ ÙŠ Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ',0),(399243,11091,'pr','Ø¬Ø³ØªØ¬Ùˆ ÙŠ Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ ',0),(399244,11091,'tr','Arama Ã¼cretleri',0),(399245,11091,'pl','Szukaj za opÅ‚aty',0),(399246,11091,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð·Ð° Ñ‚Ð°ÐºÑÐ¸',0),(399247,11091,'ur','Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(399248,11091,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð³Ð° Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(399249,11091,'vi','TÃ¬m kiáº¿m cÃ¡c chi phÃ­',0),(399250,11091,'af','Soek vir Kostes',0),(399251,11091,'ro','CÄƒutare pentru taxe',0),(399252,11091,'et','Otsi tasud',0),(399253,11091,'si','Iskanje za stroÅ¡ke',0),(399254,11091,'ba','Cari untuk biaya',0),(399255,11091,'nl','Zoek kosten',0),(399256,11091,'fi','Etsi maksut',0),(399257,11091,'no','SÃ¸k etter avgifter',0),(399258,11091,'da','SÃ¸g efter afgifter',0),(399259,11091,'ko','ìš”ê¸ˆì— ëŒ€ í•œ ê²€ìƒ‰',0),(399260,11091,'he','×—×™×¤×•×© ×¢×‘×•×¨ ×—×™×•×‘×™×',0),(399261,11091,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± Ï„Î± Ï„Î­Î»Î·',0),(399262,11091,'zh','æœç´¢æ”¶è´¹\r\n',0),(399263,11091,'sv','SÃ¶k efter avgifter',0),(399264,11091,'it','Ricerca per oneri',0),(399265,11091,'tl','',0),(399266,11091,'th','à¸„à¹‰à¸™à¸«à¸²à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(399267,11091,'hi','à¤†à¤°à¥‹à¤ªà¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ',0),(399268,11091,'ms','Carian untuk caj',0),(399269,11091,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ',0),(399270,11091,'fr','Recherche de Charges',0),(399271,11091,'jp','æ–™é‡‘æ¤œç´¢',0),(399272,11091,'pt','Busca de cargas',0),(399273,11091,'ru','ÐŸÐ¾Ð¸ÑÐº Ð´Ð»Ñ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(399274,11091,'es','Buscar Cargos',0),(399275,11091,'de','Suche nach GebÃ¼hren',0),(399276,11091,'en','Search for Charges',0),(399277,11092,'is','',0),(399278,11092,'dr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø´Ø±ÙˆØ¹',0),(399279,11092,'pr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø´Ø±ÙˆØ¹',0),(399280,11092,'tr','BaÅŸlangÄ±Ã§ aralÄ±ÄŸÄ±',0),(399281,11092,'pl','PoczÄ…tkowy zakres',0),(399282,11092,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð¸ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(399283,11092,'ur','Ø¢ØºØ§Ø² Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(399284,11092,'sr','ÐžÐ·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¾Ð¿ÑÐµÐ³Ð°',0),(399285,11092,'vi','Báº¯t Ä‘áº§u pháº¡m vi',0),(399286,11092,'af','Begin reeks',0),(399287,11092,'ro','ÃŽnceput interval',0),(399288,11092,'et','Alustada erinevaid',0),(399289,11092,'si','ZaÄetni obseg',0),(399290,11092,'ba','Mulailah rentang',0),(399291,11092,'nl','Begin bereik',0),(399292,11092,'fi','Aloita alue',0),(399293,11092,'no','Start utvalg',0),(399294,11092,'da','Begynd vifte',0),(399295,11092,'ko','ì‹œìž‘ ë²”ìœ„',0),(399296,11092,'he','×˜×•×•×— ×‘×’×™×Ÿ',0),(399297,11092,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Ï†Î¬ÏƒÎ¼Î±',0),(399298,11092,'zh','å¼€å§‹èŒƒå›´\r\n',0),(399299,11092,'sv','BÃ¶rja spÃ¤nna',0),(399300,11092,'it','Gamma di Begin',0),(399301,11092,'tl','',0),(399302,11092,'th','à¸Šà¹ˆà¸§à¸‡à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(399303,11092,'hi','à¤¶à¥à¤°à¥‚ à¤¸à¥€à¤®à¤¾',0),(399304,11092,'ms','Mulakan pelbagai',0),(399305,11092,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¨Ø¯Ø¡',0),(399306,11092,'fr','Gamme Begin',0),(399307,11092,'jp','é–‹å§‹ç¯„å›²',0),(399308,11092,'pt','Begin gama',0),(399309,11092,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð°',0),(399310,11092,'es','Comienza el Rango',0),(399311,11092,'de','BEGIN-Bereich',0),(399312,11092,'en','Begin Range',0),(399313,11093,'is','',0),(399314,11093,'dr','Ù¾Ø§ÙŠØ§Ù† Ù…Ø­Ø¯ÙˆØ¯Ù‡',0),(399315,11093,'pr','Ù¾Ø§ÙŠØ§Ù† Ù…Ø­Ø¯ÙˆØ¯Ù‡',0),(399316,11093,'tr','BitiÅŸ aralÄ±ÄŸÄ±',0),(399317,11093,'pl','Koniec zakresu',0),(399318,11093,'bg','ÐšÑ€Ð°ÐµÐ½ Ð¾Ð±Ñ…Ð²Ð°Ñ‚',0),(399319,11093,'ur','Ø§Ø®ØªØªØ§Ù…ÛŒ Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(399320,11093,'sr','Ð—Ð°Ð²Ñ€ÑˆÐ¸ Ð¾Ð¿ÑÐµÐ³',0),(399321,11093,'vi','káº¿t thÃºc chuá»—i',0),(399322,11093,'af','Einde reeks',0),(399323,11093,'ro','SfÃ¢rÅŸitul gama',0),(399324,11093,'et','LÃµpuks valik',0),(399325,11093,'si','KonÄaj obseg',0),(399326,11093,'ba','Akhir rentang',0),(399327,11093,'nl','Einde bereik',0),(399328,11093,'fi','Lopulta alue',0),(399329,11093,'no','Enden rekkevidde',0),(399330,11093,'da','Ende sortiment',0),(399331,11093,'ko','ë ë²”ìœ„',0),(399332,11093,'he','×§×¦×” ×”×˜×•×•×—',0),(399333,11093,'el','Î¤Î­Î»Î¿Ï‚ ÏƒÎµÎ¹ÏÎ¬',0),(399334,11093,'zh','ç»“æŸèŒƒå›´',0),(399335,11093,'sv','Slutet spÃ¤nna',0),(399336,11093,'it','Fine intervallo',0),(399337,11093,'tl','',0),(399338,11093,'th','à¸Šà¹ˆà¸§à¸‡à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(399339,11093,'hi','à¤…à¤‚à¤¤ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(399340,11093,'ms','Akhir julat',0),(399341,11093,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ù†Ø·Ø§Ù‚',0),(399342,11093,'fr','Fin de plage',0),(399343,11093,'jp','çµ‚äº†ç¯„å›²',0),(399344,11093,'pt','Intervalo de final',0),(399345,11093,'ru','ÐšÐ¾Ð½ÐµÑ† Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð°',0),(399346,11093,'es','Termina Rango',0),(399347,11093,'de','End-Bereich',0),(399348,11093,'en','End Range',0),(399349,11094,'is','',0),(399350,11094,'dr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ',0),(399351,11094,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ',0),(399352,11094,'tr','GÃ¶nderilen faturalar',0),(399353,11094,'pl','Faktury wysyÅ‚ane',0),(399354,11094,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ‚Ðµ, Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ð¸',0),(399355,11094,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ú¾ÛŒØ¬Ø§',0),(399356,11094,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(399357,11094,'vi','hÃ³a Ä‘Æ¡n Ä‘Ã£ gá»­i',0),(399358,11094,'af','Fakture Gestuur',0),(399359,11094,'ro','Facturile trimise',0),(399360,11094,'et','Arveid saadetakse',0),(399361,11094,'si','Poslani raÄuni',0),(399362,11094,'ba','Faktur dikirim',0),(399363,11094,'nl','Facturen verzonden',0),(399364,11094,'fi','Laskut lÃ¤hetetÃ¤Ã¤n',0),(399365,11094,'no','Fakturaer sendt',0),(399366,11094,'da','Fakturaer sendes',0),(399367,11094,'ko','ì²­êµ¬ì„œ ë°œì†¡',0),(399368,11094,'he','×—×©×‘×•× ×™×•×ª ×©× ×©×œ×—×•',0),(399369,11094,'el','Î¤Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… Î´Î¹Î±Î²Î¹Î²Î¬Î¶Î¿Î½Ï„Î±Î¹',0),(399370,11094,'zh','å‘ç¥¨å·²å‘é€\r\n',0),(399371,11094,'sv','Fakturor skickas',0),(399372,11094,'it','Fatture inviate',0),(399373,11094,'tl','',0),(399374,11094,'th','à¸ªà¹ˆà¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(399375,11094,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥‡à¤œà¤¾',0),(399376,11094,'ms','Invois-invois yang dihantar',0),(399377,11094,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø±Ø³Ù„Ø©',0),(399378,11094,'fr','Factures envoyÃ©es',0),(399379,11094,'jp','è«‹æ±‚æ›¸ã®é€ä¿¡',0),(399380,11094,'pt','Facturas enviadas',0),(399381,11094,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(399382,11094,'es','Facturas Enviadas',0),(399383,11094,'de','Rechnungen geschickt',0),(399384,11094,'en','Invoices Sent',0),(399385,11095,'is','',0),(399386,11095,'dr','ÙØ§ÙƒØªÙˆØ± Ø§Ø¹Ù„Ø§Ù… Ù‡Ø§ ',0),(399387,11095,'pr','ÙØ§ÙƒØªÙˆØ± Ø§Ø¹Ù„Ø§Ù… Ù‡Ø§ ',0),(399388,11095,'tr','Fatura bildirimleri',0),(399389,11095,'pl','Faktura powiadomienia',0),(399390,11095,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ñ',0),(399391,11095,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(399392,11095,'sr','ÐžÐ±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ° Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(399393,11095,'vi','nhá»¯ng ghi chÃº hÃ³a Ä‘Æ¡n',0),(399394,11095,'af','Faktuur Kennisgewings',0),(399395,11095,'ro','NotificÄƒrile de facturÄƒ',0),(399396,11095,'et','Arve teated',0),(399397,11095,'si','RaÄuna obvestila',0),(399398,11095,'ba','Faktur pemberitahuan',0),(399399,11095,'nl','Factuur meldingen',0),(399400,11095,'fi','Laskun ilmoitukset',0),(399401,11095,'no','Faktura varsler',0),(399402,11095,'da','Faktura anmeldelser',0),(399403,11095,'ko','ì†¡ìž¥ ì•Œë¦¼',0),(399404,11095,'he','×—×©×‘×•× ×™×ª ×”×•×“×¢×•×ª',0),(399405,11095,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚',0),(399406,11095,'zh','å‘ç¥¨çš„é€šçŸ¥\r\n',0),(399407,11095,'sv','Faktura anmÃ¤lningar',0),(399408,11095,'it','Notifiche di fattura',0),(399409,11095,'tl','',0),(399410,11095,'th','à¸à¸²à¸£à¹à¸ˆà¹‰à¸‡à¹€à¸•à¸·à¸­à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(399411,11095,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤',0),(399412,11095,'ms','Pemberitahuan invois',0),(399413,11095,'ar','Ø¥Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(399414,11095,'fr','Notifications de la facture',0),(399415,11095,'jp','è«‹æ±‚æ›¸ã®é€šçŸ¥',0),(399416,11095,'pt','NotificaÃ§Ãµes de factura',0),(399417,11095,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(399418,11095,'es','Notificaciones de Facturas',0),(399419,11095,'de','Rechnung-Benachrichtigungen',0),(399420,11095,'en','Invoice Notifications',0),(399421,11096,'is','',0),(399422,11096,'dr','(Ø´Ù…Ø§Ø±Ù‡ ) ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(399423,11096,'pr','ØªØ¹Ø¯Ø§Ø¯(Ø´Ù…Ø§Ø±Ù‡ ) ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(399424,11096,'tr','GÃ¶nderilen Num',0),(399425,11096,'pl','NUM wysÅ‚ane',0),(399426,11096,'bg','NUM Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(399427,11096,'ur','Ø¨Ú¾ÛŒØ¬Ø§ Num',0),(399428,11096,'sr','ÐÐ£Ðœ Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(399429,11096,'vi','Ä‘Ã£ gá»­i num',0),(399430,11096,'af','NUM gestuur',0),(399431,11096,'ro','Num trimis',0),(399432,11096,'et','NUM saadetud',0),(399433,11096,'si','NUM poslal',0),(399434,11096,'ba','Num dikirim',0),(399435,11096,'nl','Num verzonden',0),(399436,11096,'fi','NUM lÃ¤hetti',0),(399437,11096,'no','NUM sendt',0),(399438,11096,'da','NUM sendt',0),(399439,11096,'ko','ë³´ë‚¸ Num',0),(399440,11096,'he','Num ×©×œ×—',0),(399441,11096,'el','NUM Î­ÏƒÏ„ÎµÎ¹Î»Îµ',0),(399442,11096,'zh','åºå·å‘é€\r\n',0),(399443,11096,'sv','NUM skickas',0),(399444,11096,'it','Num inviati',0),(399445,11096,'tl','',0),(399446,11096,'th','à¹€à¸¥à¸‚à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡',0),(399447,11096,'hi','Num à¤­à¥‡à¤œà¤¾',0),(399448,11096,'ms','NUM yang dihantar',0),(399449,11096,'ar','Num Ø§Ù„Ù…Ø±Ø³Ù„Ø©',0),(399450,11096,'fr','Num envoyÃ©',0),(399451,11096,'jp','Num ä»¶ã®é€ä¿¡',0),(399452,11096,'pt','Num enviou',0),(399453,11096,'ru','Num Ð¿Ð¾ÑÐ»Ð°Ð»',0),(399454,11096,'es','NÃºmero Enviado',0),(399455,11096,'de','NUM gesendet',0),(399456,11096,'en','Num Sent',0),(399457,11097,'is','',0),(399458,11097,'dr','ØªØ°ÙƒØ±Ø§Øª Ù‚Ø¨Ù„ÙŠ',0),(399459,11097,'pr','ØªØ°ÙƒØ±Ø§Øª Ù‚Ø¨Ù„ÙŠ',0),(399460,11097,'tr','Ã–nceki bildirimler',0),(399461,11097,'pl','Poprzedniego powiadomienia',0),(399462,11097,'bg','ÐŸÑ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ Ð½Ð¾Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(399463,11097,'ur','Ø³Ø§Ø¨Ù‚Û Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(399464,11097,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¸ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ°',0),(399465,11097,'vi','ghi chÃº trÆ°á»›c',0),(399466,11097,'af','Vorige kennisgewings',0),(399467,11097,'ro','NotificÄƒri anterioare',0),(399468,11097,'et','Varasemad teated',0),(399469,11097,'si','PrejÅ¡nja obvestila',0),(399470,11097,'ba','Pemberitahuan sebelumnya',0),(399471,11097,'nl','Vorige berichten',0),(399472,11097,'fi','Aiemmat ilmoitukset',0),(399473,11097,'no','Tidligere meldinger',0),(399474,11097,'da','Tidligere meddelelser',0),(399475,11097,'ko','ì´ì „ ì•Œë¦¼',0),(399476,11097,'he','×ž×”×•×“×¢×•×ª ×§×•×“×ž×•×ª',0),(399477,11097,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ ÎµÎ¹Î´Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚',0),(399478,11097,'zh','ä»¥å‰çš„é€šçŸ¥\r\n',0),(399479,11097,'sv','Tidigare meddelanden',0),(399480,11097,'it','Notifiche precedenti',0),(399481,11097,'tl','',0),(399482,11097,'th','à¹à¸ˆà¹‰à¸‡à¹€à¸•à¸·à¸­à¸™à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(399483,11097,'hi','à¤ªà¤¿à¤›à¤²à¤¾ à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤',0),(399484,11097,'ms','Pemberitahuan terdahulu',0),(399485,11097,'ar','Ø§Ù„Ø¥Ø®Ø·Ø§Ø±Ø§Øª Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(399486,11097,'fr','Avis prÃ©cÃ©dents',0),(399487,11097,'jp','å‰ã®é€šçŸ¥',0),(399488,11097,'pt','NotificaÃ§Ãµes anteriores',0),(399489,11097,'ru','ÐŸÑ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ðµ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(399490,11097,'es','Notificaciones Previos',0),(399491,11097,'de','Vorherige Benachrichtigungen',0),(399492,11097,'en','Previous Notifications',0),(399493,11098,'is','',0),(399494,11098,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ÙØ§ÙƒØªÙˆØ±',0),(399495,11098,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ÙØ§ÙƒØªÙˆØ±',0),(399496,11098,'tr','Fatura vade tarihi aralÄ±ÄŸÄ±nÄ± SeÃ§',0),(399497,11098,'pl','Wybierz zakres dat powodu faktury',0),(399498,11098,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð°Ð´ÐµÐ¶ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(399499,11098,'ur','Ù…Ù†ØªØ®Ø¨ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(399500,11098,'sr','Ð˜Ð·Ð±Ð¾Ñ€ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¾Ð¿ÑÐµÐ³Ð°',0),(399501,11098,'vi','Chá»n pháº¡m vi ngÃ y hÃ³a Ä‘Æ¡n trong háº¡n',0),(399502,11098,'af','Kies faktuur verskuldigde datum reeks',0),(399503,11098,'ro','SelectaÅ£i factura cuvenit intervalul de Date',0),(399504,11098,'et','Valige arve tÃ¤htaeg kuupÃ¤evavahemik',0),(399505,11098,'si','Izberite raÄun zaradi datumski obseg',0),(399506,11098,'ba','Pilih rentang tanggal jatuh tempo faktur',0),(399507,11098,'nl','Selecteer factuur Due datumbereik',0),(399508,11098,'fi','Valitse laskun erÃ¤pÃ¤ivÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤vÃ¤li',0),(399509,11098,'no','Velg fakturaen forfallsdato datointervall',0),(399510,11098,'da','VÃ¦lg faktura Due Date Range',0),(399511,11098,'ko','ì†¡ìž¥ ê¸°í•œ ë‚ ì§œ ë²”ìœ„ ì„ íƒ',0),(399512,11098,'he','×‘×—×¨ ×—×©×‘×•× ×™×ª ×‘×©×œ ×˜×•×•×— ×ª××¨×™×›×™×',0),(399513,11098,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ ÎµÏÏÎ¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½',0),(399514,11098,'zh','é€‰æ‹©å‘ç¥¨åˆ°æœŸæ—¥æœŸèŒƒå›´\r\n',0),(399515,11098,'sv','Markera fakturan vederbÃ¶rlig datumintervall',0),(399516,11098,'it','Seleziona fattura scadenza data intervallo',0),(399517,11098,'tl','',0),(399518,11098,'th','à¸Šà¹ˆà¸§à¸‡à¸§à¸±à¸™à¹€à¸¥à¸·à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”',0),(399519,11098,'hi','à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€',0),(399520,11098,'ms','Pilih julat tarikh habis tempoh invois',0),(399521,11098,'ar','Ø­Ø¯Ø¯ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„ÙˆØ§Ø¬Ø¨ Ù†Ø·Ø§Ù‚ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(399522,11098,'fr','SÃ©lection facture Due dates',0),(399523,11098,'jp','è«‹æ±‚æ›¸æœŸé™ã®æ—¥ä»˜ç¯„å›²ã®é¸æŠž',0),(399524,11098,'pt','Selecione fatura devido intervalo de datas',0),(399525,11098,'ru','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚ Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‡ÐµÑ‚ Ð½Ð°Ð´Ð»ÐµÐ¶Ð°Ñ‰ÐµÐ³Ð¾',0),(399526,11098,'es','Selecciona Rango de Fechas de Vencimiento de Factura',0),(399527,11098,'de','WÃ¤hlen Sie Rechnung Due Date Range',0),(399528,11098,'en','Select Invoice Due Date Range',0),(399529,11099,'is','',0),(399530,11099,'dr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø§Ø¹Ù„Ø§Ù…  ÙØ§ÙƒØªÙˆØ±',0),(399531,11099,'pr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø§Ø¹Ù„Ø§Ù…  ÙØ§ÙƒØªÙˆØ±',0),(399532,11099,'tr','Fatura bildirimleri gÃ¶nder',0),(399533,11099,'pl','WyÅ›lij powiadomienia faktury',0),(399534,11099,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ñ',0),(399535,11099,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ú¾ÛŒØ¬Ù†Û’',0),(399536,11099,'sr','Ð¨Ð°Ñ™ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ°',0),(399537,11099,'vi','Gá»­i thÃ´ng bÃ¡o hÃ³a Ä‘Æ¡',0),(399538,11099,'af','Stuur Faktuur Kennisgewing',0),(399539,11099,'ro','Trimite factura notificÄƒri',0),(399540,11099,'et','Arve teatiste saatmine',0),(399541,11099,'si','PoÅ¡iljanje obvestil raÄuna',0),(399542,11099,'ba','Mengirim faktur pemberitahuan',0),(399543,11099,'nl','Factuur kennisgevingen',0),(399544,11099,'fi','Laskuun ilmoitusten lÃ¤hettÃ¤minen',0),(399545,11099,'no','Sende fakturaen meldinger',0),(399546,11099,'da','Send faktura anmeldelser',0),(399547,11099,'ko','ì†¡ìž¥ ì•Œë¦¼ ë³´ë‚´ê¸°',0),(399548,11099,'he','×œ×©×œ×•×— ×”×•×“×¢×•×ª ×—×©×‘×•× ×™×ª',0),(399549,11099,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÎ¹Î´Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ‰Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(399550,11099,'zh','å‘é€å‘ç¥¨çš„é€šçŸ¥\r\n',0),(399551,11099,'sv','Skicka faktura meddelanden',0),(399552,11099,'it','Inviare notifiche di fattura',0),(399553,11099,'tl','',0),(399554,11099,'th','à¸ªà¹ˆà¸‡à¸à¸²à¸£à¹à¸ˆà¹‰à¸‡à¹€à¸•à¸·à¸­à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(399555,11099,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤‚ à¤­à¥‡à¤œà¥‡à¤‚',0),(399556,11099,'ms','Menghantar pemberitahuan invois',0),(399557,11099,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¥Ø®Ø·Ø§Ø±Ø§Øª Ø¨Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(399558,11099,'fr','Envoyer des Notifications de facture',0),(399559,11099,'jp','è«‹æ±‚æ›¸ã®é€šçŸ¥ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(399560,11099,'pt','Enviar notificaÃ§Ãµes de factura',0),(399561,11099,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°',0),(399562,11099,'es','Envia Notificaciones de Facturas',0),(399563,11099,'de','Rechnung-Benachrichtigungen senden',0),(399564,11099,'en','Send Invoice Notifications',0),(399565,11100,'is','',0),(399566,11100,'dr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ØªÙˆØ³Ø·',0),(399567,11100,'pr','ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ØªÙˆØ³Ø·',0),(399568,11100,'tr','TarafÄ±ndan gÃ¶nderildi',0),(399569,11100,'pl','WysÅ‚ane przez',0),(399570,11100,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾ Ð¾Ñ‚',0),(399571,11100,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¨Ú¾ÛŒØ¬Û’ Ú¯Ø¦Û’',0),(399572,11100,'sr','ÐŸÐ¾ÑÐ»Ð°Ð¾',0),(399573,11100,'vi','ÄÃ£ gá»­i bá»Ÿi',0),(399574,11100,'af','Gestuur Deur',0),(399575,11100,'ro','Trimis de',0),(399576,11100,'et','Saadetud',0),(399577,11100,'si','Ki ga je poslal',0),(399578,11100,'ba','Dikirim oleh',0),(399579,11100,'nl','Verzonden door',0),(399580,11100,'fi','LÃ¤hettÃ¤nyt',0),(399581,11100,'no','Sendt av',0),(399582,11100,'da','Sendt af',0),(399583,11100,'ko','ì „ì†¡í•œ',0),(399584,11100,'he','× ×©×œ×— ×¢\"×™',0),(399585,11100,'el','Î‘Ï€Î­ÏƒÏ„ÎµÎ¹Î»Îµ',0),(399586,11100,'zh','å‘é€æ–¹å¼\r\n',0),(399587,11100,'sv','Skickas av',0),(399588,11100,'it','Inviato da',0),(399589,11100,'tl','',0),(399590,11100,'th','à¸ªà¹ˆà¸‡à¹‚à¸”à¸¢',0),(399591,11100,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥‡à¤œà¥‡ à¤—à¤',0),(399592,11100,'ms','Dihantar oleh',0),(399593,11100,'ar','Ù…Ø±Ø³Ù„Ø© Ù…Ù†',0),(399594,11100,'fr','EnvoyÃ© par',0),(399595,11100,'jp','ã«ã‚ˆã£ã¦é€ä¿¡ã•ã‚Œã¾ã—ãŸã€‚',0),(399596,11100,'pt','Enviado por',0),(399597,11100,'ru','ÐŸÑ€Ð¸ÑÐ»Ð°Ð»',0),(399598,11100,'es','Enviado Por',0),(399599,11100,'de','Per',0),(399600,11100,'en','Sent By',0),(399601,11101,'is','',0),(399602,11101,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(399603,11101,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(399604,11101,'tr','BitiÅŸ tarihi girmeniz gerekir',0),(399605,11101,'pl','NaleÅ¼y wprowadziÄ‡ datÄ™ koÅ„cowÄ…',0),(399606,11101,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(399607,11101,'ur','Ø¢Ù¾ Ù†Û’ Ú©Ø³ÛŒ Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ® Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(399608,11101,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ ÑƒÐ½ÐµÑ‚Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(399609,11101,'vi','Báº¡n pháº£i nháº­p ngÃ y cuá»‘i cÃ¹ng',0),(399610,11101,'af','U moet \'n Enddatum Invoer',0),(399611,11101,'ro','Trebuie sÄƒ introduceÅ£i o datÄƒ de sfÃ¢rÅŸit',0),(399612,11101,'et','Sisestage lÃµppkuupÃ¤ev',0),(399613,11101,'si','Vnesite konÄni datum',0),(399614,11101,'ba','Anda harus memasukkan tanggal akhir',0),(399615,11101,'nl','U moet een einddatum invoeren',0),(399616,11101,'fi','Anna pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(399617,11101,'no','Du mÃ¥ angi en sluttdato',0),(399618,11101,'da','Du skal angive en slutdato',0),(399619,11101,'ko','ë ë‚ ì§œë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(399620,11101,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ª××¨×™×š ×¡×™×•×',0),(399621,11101,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(399622,11101,'zh','æ‚¨å¿…é¡»è¾“å…¥ç»“æŸæ—¥æœŸ\r\n',0),(399623,11101,'sv','Du mÃ¥ste ange ett slutdatum',0),(399624,11101,'it','Ãˆ necessario immettere una data di fine',0),(399625,11101,'tl','',0),(399626,11101,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(399627,11101,'hi','à¤†à¤ª à¤à¤• à¤…à¤‚à¤¤à¤¿à¤® à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(399628,11101,'ms','Anda mesti masukkan tarikh tamat',0),(399629,11101,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡',0),(399630,11101,'fr','Vous devez saisir une Date de fin',0),(399631,11101,'jp','çµ‚äº†æ—¥ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(399632,11101,'pt','VocÃª deve digitar uma data de tÃ©rmino',0),(399633,11101,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ ÐšÐ¾Ð½ÐµÑ‡Ð½ÑƒÑŽ Ð”Ð°Ñ‚Ñƒ',0),(399634,11101,'es','Debe Entrar Una Fecha de TerminaciÃ³n',0),(399635,11101,'de','Sie mÃ¼ssen ein Enddatum eingeben.',0),(399636,11101,'en','You Must Enter An End Date',0),(399637,11102,'is','',0),(399638,11102,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(399639,11102,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(399640,11102,'tr','Bir baÅŸlangÄ±Ã§ tarihi girmeniz gerekir',0),(399641,11102,'pl','NaleÅ¼y wprowadziÄ‡ datÄ™ rozpoczÄ™cia',0),(399642,11102,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(399643,11102,'ur','Ø¢Ù¾ Ù†Û’ Ø§Ø¨ØªØ¯Ø§ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(399644,11102,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(399645,11102,'vi','Báº¡n pháº£i nháº­p ngÃ y báº¯t Ä‘áº§u',0),(399646,11102,'af','U moet \'n Begindatum Invoer',0),(399647,11102,'ro','Trebuie sÄƒ introduceÅ£i o datÄƒ de Ã®nceput',0),(399648,11102,'et','Sisestage algus kuupÃ¤ev',0),(399649,11102,'si','Vnesite zaÄetni datum',0),(399650,11102,'ba','Anda harus memasukkan tanggal mulai',0),(399651,11102,'nl','U moet een begindatum invoeren',0),(399652,11102,'fi','Aloita pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ on syÃ¶tettÃ¤vÃ¤',0),(399653,11102,'no','Du mÃ¥ angi start dato',0),(399654,11102,'da','Du skal angive en Start dato',0),(399655,11102,'ko','ì‹œìž‘ ë‚ ì§œë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(399656,11102,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ª××¨×™×š ×”×”×ª×—×œ×”',0),(399657,11102,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(399658,11102,'zh','æ‚¨å¿…é¡»è¾“å…¥å¼€å§‹æ—¥æœŸ\r\n',0),(399659,11102,'sv','Du mÃ¥ste ange ett Begin-datum',0),(399660,11102,'it','Ãˆ necessario immettere una data di inizio',0),(399661,11102,'tl','',0),(399662,11102,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(399663,11102,'hi','à¤†à¤ª à¤à¤• à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(399664,11102,'ms','Anda mesti masukkan tarikh mulakan',0),(399665,11102,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(399666,11102,'fr','Vous devez entrer une date de dÃ©but.',0),(399667,11102,'jp','é–‹å§‹æ—¥ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(399668,11102,'pt','VocÃª deve digitar uma data de inÃ­cio',0),(399669,11102,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ ÐÐ°Ñ‡Ð°Ð»ÑŒÐ½ÑƒÑŽ Ð”Ð°Ñ‚Ñƒ',0),(399670,11102,'es','Debe Entrar Una Fecha de Comienza',0),(399671,11102,'de','Sie mÃ¼ssen ein Anfangsdatum eingeben.',0),(399672,11102,'en','You Must Enter A Begin Date',0),(399673,11103,'is','',0),(399674,11103,'dr','\r\nØ§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± \r\n',0),(399675,11103,'pr','\r\nØ§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ± \r\n',0),(399676,11103,'tr','Fatura Ã¼cretleri ekleme',0),(399677,11103,'pl','Dodawanie faktury opÅ‚aty',0),(399678,11103,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð°ÐºÑÐ¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(399679,11103,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(399680,11103,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(399681,11103,'vi','ThÃªm phÃ­ hÃ³a Ä‘Æ¡n',0),(399682,11103,'af','Faktuur Kostes Byvoeg',0),(399683,11103,'ro','Adauga factura taxe',0),(399684,11103,'et','Lisada arve maksud',0),(399685,11103,'si','Dodaj raÄun stroÅ¡kov',0),(399686,11103,'ba','Tambahkan tuduhan faktur',0),(399687,11103,'nl','Factuur kosten toevoegen',0),(399688,11103,'fi','LisÃ¤Ã¤ laskun kulut',0),(399689,11103,'no','Legge til fakturaen kostnader',0),(399690,11103,'da','TilfÃ¸je faktura afgifter',0),(399691,11103,'ko','ì²­êµ¬ì„œ ìš”ê¸ˆ ì¶”ê°€',0),(399692,11103,'he','×”×•×¡×£ ××ª ×—×™×•×‘×™ ×”×—×©×‘×•× ×™×ª',0),(399693,11103,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„ÎµÎ»ÏŽÎ½',0),(399694,11103,'zh','å¢žåŠ å‘ç¥¨æ”¶è´¹\r\n',0),(399695,11103,'sv','LÃ¤gg till fakturaavgifter',0),(399696,11103,'it','Aggiungi addebiti in fattura',0),(399697,11103,'tl','',0),(399698,11103,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(399699,11103,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤†à¤°à¥‹à¤ª à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(399700,11103,'ms','Tambah caj invois',0),(399701,11103,'ar','Ø¥Ø¶Ø§ÙØ© Ø±Ø³ÙˆÙ… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(399702,11103,'fr','Ajouter frais de facture',0),(399703,11103,'jp','è«‹æ±‚æ›¸ã®æ–™é‡‘ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(399704,11103,'pt','Adicionar cargas de factura',0),(399705,11103,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(399706,11103,'es','Agregar Cargos de Factura',0),(399707,11103,'de','Rechnung GebÃ¼hren hinzufÃ¼gen',0),(399708,11103,'en','Add Invoice Charges',0),(399709,11104,'is','',0),(399710,11104,'dr','(ØªØ°ÙƒØ±Ø§Øª) Ø§Ø¹Ù„Ø§Ù… Ù‡Ø§ Ùˆ Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(399711,11104,'pr','ÙØ±Ø³ØªØ§Ø¯Ù†(ØªØ°ÙƒØ±Ø§Øª) Ø§Ø¹Ù„Ø§Ù… Ù‡Ø§ Ùˆ Ø§ÙØ²ÙˆØ¯Ù† Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø§Ø¶Ø§ÙÙŠ',0),(399712,11104,'tr','Bildirimleri gÃ¶nder ve ekstra Ã¼cretleri ekleme',0),(399713,11104,'pl','WysyÅ‚anie powiadomieÅ„ i dodaÄ‡ dodatkowe opÅ‚aty',0),(399714,11104,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ñ Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(399715,11104,'ur','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ú¾ÛŒØ¬Ù†Û’ Ø§ÙˆØ± Ø§Ø¶Ø§ÙÛŒ Ú†Ø§Ø±Ø¬Ø² Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(399716,11104,'sr','Ð¡Ð»Ð°Ñ‚Ð¸ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ° Ð¸ Ð´Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(399717,11104,'vi','Gá»­i thÃ´ng bÃ¡o vÃ  thÃªm phÃ­ phá»¥ thu',0),(399718,11104,'af','Stuur Kennisgewings En Voeg Bykomende Kostes By',0),(399719,11104,'ro','Trimite notificÄƒri ÅŸi se adaugÄƒ taxe suplimentare',0),(399720,11104,'et','Saada teatised ja lisatakse lisatasud',0),(399721,11104,'si','PoÅ¡iljanje obvestil in dodajanje dodatnih stroÅ¡kov',0),(399722,11104,'ba','Mengirim pemberitahuan dan menambahkan biaya tambahan',0),(399723,11104,'nl','Kennisgevingen en Extra kosten toevoegen',0),(399724,11104,'fi','LÃ¤hettÃ¤Ã¤ ilmoituksia ja lisÃ¤tÃ¤ ylimÃ¤Ã¤rÃ¤isiÃ¤ maksuja',0),(399725,11104,'no','Sende meldinger og legge til ekstra kostnader',0),(399726,11104,'da','Send meddelelser og tilfÃ¸je ekstra afgifter',0),(399727,11104,'ko','ì•Œë¦¼ ë³´ë‚´ê¸° ë° ì¶”ê°€ ìš”ê¸ˆ ì¶”ê°€',0),(399728,11104,'he','×œ×©×œ×•×— ×”×•×“×¢×•×ª ×•×œ×”×•×¡×™×£ ×—×™×•×‘×™× × ×•×¡×¤×™×',0),(399729,11104,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÎ¹Î´Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ‰Î½ ÎºÎ±Î¹ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(399730,11104,'zh','å‘é€é€šçŸ¥ï¼Œå¹¶æ·»åŠ é¢å¤–çš„è´¹ç”¨\r\n',0),(399731,11104,'sv','Skicka meddelanden och lÃ¤gga till Extra avgifter',0),(399732,11104,'it','Inviare notifiche e aggiungere spese Extra',0),(399733,11104,'tl','',0),(399734,11104,'th','à¸ªà¹ˆà¸‡à¸à¸²à¸£à¹à¸ˆà¹‰à¸‡à¹€à¸•à¸·à¸­à¸™ à¹à¸¥à¸°à¹€à¸žà¸´à¹ˆà¸¡à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸žà¸´à¹€à¸¨à¸©',0),(399735,11104,'hi','à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤ à¤­à¥‡à¤œà¥‡à¤‚ à¤”à¤° à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤° à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(399736,11104,'ms','Menghantar pemberitahuan dan tambah caj-caj tambahan',0),(399737,11104,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¥Ø®Ø·Ø§Ø±Ø§Øª ÙˆØ¥Ø¶Ø§ÙØ© Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ©',0),(399738,11104,'fr','Envoyer des Notifications et d\'ajouter des frais supplÃ©mentaires',0),(399739,11104,'jp','é€šçŸ¥ã‚’é€ä¿¡ã—ã€è¿½åŠ æ–™é‡‘ã‚’è¿½åŠ ',0),(399740,11104,'pt','Enviar notificaÃ§Ãµes e adicionar custos extras',0),(399741,11104,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÐ±Ð¾Ñ€Ñ‹',0),(399742,11104,'es','Envia Notificaciones y Agregar Cargos Extras',0),(399743,11104,'de','Senden Sie Benachrichtigungen und fÃ¼gen Sie zusÃ¤tzliche GebÃ¼hren',0),(399744,11104,'en','Send Notifications And Add Extra Charges',0),(399745,11105,'is','',0),(399746,11105,'dr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†',0),(399747,11105,'pr','ÙˆÙŠØ±Ø§ÙŠØ´ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù†',0),(399748,11105,'tr','MÃ¼ÅŸteriler DÃ¼zenle',0),(399749,11105,'pl','Edycja klientÃ³w',0),(399750,11105,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(399751,11105,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(399752,11105,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÑƒÐ¿Ñ†Ðµ',0),(399753,11105,'vi','thÃªm khÃ¡ch hÃ ng',0),(399754,11105,'af','Redigeer Klante',0),(399755,11105,'ro','Editare clienÅ£ii',0),(399756,11105,'et','Redigeeri kliente',0),(399757,11105,'si','Urejanje stranke',0),(399758,11105,'ba','Mengedit pelanggan',0),(399759,11105,'nl','Bewerken van klanten',0),(399760,11105,'fi','Muokkaa asiakkaat',0),(399761,11105,'no','Redigere kunder',0),(399762,11105,'da','Redigere kunder',0),(399763,11105,'ko','ê³ ê° íŽ¸ì§‘',0),(399764,11105,'he','×¢×¨×•×š ×œ×§×•×—×•×ª',0),(399765,11105,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(399766,11105,'zh','ç¼–è¾‘å®¢æˆ·\r\n',0),(399767,11105,'sv','Redigera kunder',0),(399768,11105,'it','Modificare i clienti',0),(399769,11105,'tl','',0),(399770,11105,'th','à¹à¸à¹‰à¹„à¸‚à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(399771,11105,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(399772,11105,'ms','Edit pelanggan',0),(399773,11105,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†',0),(399774,11105,'fr','Modifier des clients',0),(399775,11105,'jp','é¡§å®¢ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(399776,11105,'pt','Editar clientes',0),(399777,11105,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(399778,11105,'es','Editar Clientes',0),(399779,11105,'de','Kunden bearbeiten',0),(399780,11105,'en','Edit Customers',0),(399781,11106,'is','',0),(399782,11106,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(399783,11106,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(399784,11106,'tr','MÃ¼ÅŸteri bilgileri baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(399785,11106,'pl','Odbiorcy informacji pomyÅ›lnie zaktualizowana',0),(399786,11106,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(399787,11106,'ur','Ú¯Ø§ÛÚ© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(399788,11106,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð˜Ð½Ñ„Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(399789,11106,'vi','cáº­p nháº­t thÃ´ng tin khÃ¡ch hÃ ng thÃ nh cÃ´ng',0),(399790,11106,'af','Klant / KliÃ«nt Inligting Suksesvol Opdateer',0),(399791,11106,'ro','Info client actualizat cu succes',0),(399792,11106,'et','Kliendi Info vÃ¤rskendamine Ãµnnestus',0),(399793,11106,'si','Kupec Info uspeÅ¡no posodobljena',0),(399794,11106,'ba','Info Pelanggan yang berhasil',0),(399795,11106,'nl','Klant-Info bijgewerkt',0),(399796,11106,'fi','Asiakkaan tiedot pÃ¤ivitetty',0),(399797,11106,'no','Kundeinfo oppdatert',0),(399798,11106,'da','Kundeoplysninger opdateret',0),(399799,11106,'ko','ê³ ê° ì •ë³´ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(399800,11106,'he','×¤×¨×˜×™ ×œ×§×•×— ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(399801,11106,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÎµÎ»Î¬Ï„Î· ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(399802,11106,'zh','å®¢æˆ·ä¿¡æ¯æ›´æ–°æˆåŠŸ\r\n',0),(399803,11106,'sv','Kund information uppdaterades',0),(399804,11106,'it','Info cliente aggiornato con successo',0),(399805,11106,'tl','',0),(399806,11106,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(399807,11106,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾',0),(399808,11106,'ms','Maklumat pelanggan yang berjaya dikemas kini',0),(399809,11106,'ar','Ø­Ø¯Ù‘Ø«Øª Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø²Ø¨ÙˆÙ† Ø¨Ù†Ø¬Ø§Ø­',0),(399810,11106,'fr','Infos client mis Ã  jour avec succÃ¨s',0),(399811,11106,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸãŠå®¢æ§˜æƒ…å ±',0),(399812,11106,'pt','InformaÃ§Ã£o de cliente atualizada com sucesso',0),(399813,11106,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ðž ÐšÐ»Ð¸ÐµÐ½Ñ‚Ðµ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(399814,11106,'es','Info de Cliente Actualizado Exitosamente',0),(399815,11106,'de','Kundeninfo erfolgreich aktualisiert',0),(399816,11106,'en','Customer Info Updated Successfully',0),(399817,11107,'is','',0),(399818,11107,'dr','Ø¨Ø±ÙˆÙŠØ¯ Ø¨Ù‡ ØµÙØ­Ù‡ ',0),(399819,11107,'pr','Ø¨Ø±ÙˆÙŠØ¯ Ø¨Ù‡ ØµÙØ­Ù‡ ',0),(399820,11107,'tr','Sayfaya git',0),(399821,11107,'pl','PrzejdÅº do strony',0),(399822,11107,'bg','ÐžÑ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(399823,11107,'ur','ØµÙØ­Û Ù¾Ø± Ø¬Ø§Ø¦ÛŒÚº',0),(399824,11107,'sr','Ð˜Ð´Ð¸ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(399825,11107,'vi','tá»›i trang',0),(399826,11107,'af','Gaan na Bladsy',0),(399827,11107,'ro','Du-te la filme',0),(399828,11107,'et','Mine lehele',0),(399829,11107,'si','Pojdite na stran',0),(399830,11107,'ba','Pergi ke halaman',0),(399831,11107,'nl','Ga naar pagina',0),(399832,11107,'fi','Siirry sivulle',0),(399833,11107,'no','GÃ¥ til siden',0),(399834,11107,'da','GÃ¥ til side',0),(399835,11107,'ko','íŽ˜ì´ì§€ë¡œ ì´ë™',0),(399836,11107,'he','×¢×‘×•×¨ ×œ×“×£',0),(399837,11107,'el','ÎœÎµÏ„Î±Î²ÎµÎ¯Ï„Îµ ÏƒÏ„Î· ÏƒÎµÎ»Î¯Î´Î±',0),(399838,11107,'zh','è½¬åˆ°é¡µ\r\n',0),(399839,11107,'sv','GÃ¥ till sida',0),(399840,11107,'it','Vai alla pagina',0),(399841,11107,'tl','',0),(399842,11107,'th','à¹„à¸›à¸—à¸µà¹ˆà¸«à¸™à¹‰à¸²',0),(399843,11107,'hi','à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤œà¤¾à¤à¤',0),(399844,11107,'ms','Pergi ke Laman',0),(399845,11107,'ar','Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰ ØµÙØ­Ø©',0),(399846,11107,'fr','Aller Ã£ la Page',0),(399847,11107,'jp','ãƒšãƒ¼ã‚¸ã«è¡Œã',0),(399848,11107,'pt','Ir para pÃ¡gina',0),(399849,11107,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(399850,11107,'es','Va a la PÃ¡gina',0),(399851,11107,'de','Gehe zu Seite',0),(399852,11107,'en','Go To Page',0),(399853,11108,'is','',0),(399854,11108,'dr','(Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ',0),(399855,11108,'pr','Ø¨Ø¯ÙˆÙ† Ø´Ø±Ø§ÙŠØ· Ø§Ø¹ØªØ¨Ø§Ø± Ø¯Ù‡ÙŠ(Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ',0),(399856,11108,'tr','HayÄ±r Kredi ÅŸartlarÄ±',0),(399857,11108,'pl','Nie warunki kredytu',0),(399858,11108,'bg','ÐÑÐ¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ',0),(399859,11108,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø·',0),(399860,11108,'sr','ÐÐµÐ¼Ð° ÑƒÑÐ»Ð¾Ð²Ðµ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸Ñ€Ð°ÑšÐµ',0),(399861,11108,'vi','khÃ´ng cÃ³ Ä‘iá»u khoáº£n tÃ­n dá»¥ng',0),(399862,11108,'af','Geen Kredietterme',0),(399863,11108,'ro','Nu termeni de Credit',0),(399864,11108,'et','No krediiditingimused',0),(399865,11108,'si','Ne kreditni pogoji',0),(399866,11108,'ba','Tidak ada persyaratan kredit',0),(399867,11108,'nl','Geen kredietvoorwaarden',0),(399868,11108,'fi','Ei luottoehdot',0),(399869,11108,'no','Ingen kredittperioder',0),(399870,11108,'da','Ingen kreditvilkÃ¥r',0),(399871,11108,'ko','ì•„ë‹ˆ ì‹ ìš© ì¡°ê±´',0),(399872,11108,'he','××™×Ÿ ×ª× ××™ ×”××©×¨××™',0),(399873,11108,'el','Î”ÎµÎ½ ÏŒÏÎ¿Ï…Ï‚ Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚',0),(399874,11108,'zh','æ²¡æœ‰ä¿¡ç”¨æ¡æ¬¾\r\n',0),(399875,11108,'sv','Ingen kreditvillkor',0),(399876,11108,'it','No condizioni di credito',0),(399877,11108,'tl','',0),(399878,11108,'th','à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¹„à¸¡à¹ˆ',0),(399879,11108,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(399880,11108,'ms','Tiada terma-terma kredit',0),(399881,11108,'ar','Ø§Ù„Ø¥Ù‚ØªØµØ§Ø± Ø¹Ù„Ù‰ Ø¹Ø±Ø¶ Ø§Ù„Ø²Ø¨Ø§Ø¦Ù† Ø§Ù„Ù‘Ø°ÙŠÙ† Ù„Ø¯ÙŠÙ‡Ù… Ø·Ù„Ø¨ÙŠØ§Øª Ù…Ù†Ø° ',0),(399882,11108,'fr','Aucune des conditions de crÃ©dit',0),(399883,11108,'jp','ä¿¡ç”¨æ¡ä»¶ãŒãªã„ã§ã™ã€‚',0),(399884,11108,'pt','NÃ£o hÃ¡ condiÃ§Ãµes de crÃ©dito',0),(399885,11108,'ru','ÐÐµ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(399886,11108,'es','No Hay TÃ©rminos de CrÃ©dito',0),(399887,11108,'de','Keine Kredit-Begriffe',0),(399888,11108,'en','No Credit Terms',0),(399889,11109,'is','',0),(399890,11109,'dr','Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ø¯ÙˆÙ† Ø´Ø±Ø§ÙŠØ·',0),(399891,11109,'pr','Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ø¯ÙˆÙ† Ø´Ø±Ø§ÙŠØ·',0),(399892,11109,'tr','HiÃ§bir ÅŸartlar nedeni',0),(399893,11109,'pl','PowÃ³d nie ma warunkÃ³w',0),(399894,11109,'bg','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð°Ñ‚Ð° Ð·Ð° Ð½ÑÐ¼Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ',0),(399895,11109,'ur','Ú©ÙˆØ¦ÛŒ Ø´Ø±Ø§Ø¦Ø· Ú©ÛŒ ÙˆØ¬Û',0),(399896,11109,'sr','Ð Ð°Ð·Ð»Ð¾Ð³ Ð½ÐµÐ¼Ð° Ð¿Ð¾Ñ˜Ð¼Ð¾Ð²Ð°',0),(399897,11109,'vi','lÃ½ do khÃ´ng cÃ³ Ä‘iá»u khoáº£n',0),(399898,11109,'af','Rede Vir Geen Terme',0),(399899,11109,'ro','Motivul pentru care nu termeni',0),(399900,11109,'et','PÃµhjus termineid',0),(399901,11109,'si','Razlog za ni pogoji',0),(399902,11109,'ba','Sebab tidak ada istilah',0),(399903,11109,'nl','Reden voor geen termen',0),(399904,11109,'fi','Syy ei liity termejÃ¤',0),(399905,11109,'no','Ã…rsaken ingen termer',0),(399906,11109,'da','Ã…rsagen til ingen vilkÃ¥r',0),(399907,11109,'ko','ì•„ë¬´ ì¡°ê±´ì— ëŒ€ í•œ ì´ìœ ',0),(399908,11109,'he','×¡×™×‘×” ×œ×œ× ×ª× ××™',0),(399909,11109,'el','Î›ÏŒÎ³Î¿ Î³Î¹Î± ÏŒÏ‡Î¹ ÏŒÏÎ¿Ï…Ï‚',0),(399910,11109,'zh','æ— æ¡æ¬¾åŽŸå› \r\n',0),(399911,11109,'sv','Anledningen inga termer',0),(399912,11109,'it','Motivo per non termini',0),(399913,11109,'tl','',0),(399914,11109,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹€à¸«à¸•à¸¸à¸œà¸¥',0),(399915,11109,'hi','à¤•à¤¾à¤°à¤£ à¤¸à¥‡ à¤•à¥‹à¤ˆ à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(399916,11109,'ms','Sebab tiada syarat',0),(399917,11109,'ar','ÙˆØ§Ù„Ø³Ø¨Ø¨ Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø´Ø±ÙˆØ·',0),(399918,11109,'fr','Raison de pas de modalitÃ©s',0),(399919,11109,'jp','æ¡ä»¶ãŒãªã„ç†ç”±',0),(399920,11109,'pt','RazÃ£o para nÃ£o termos',0),(399921,11109,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ðµ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð¾Ð²',0),(399922,11109,'es','Motivo de No Permitir TÃ©rminos',0),(399923,11109,'de','Grund fÃ¼r keine Begriffe',0),(399924,11109,'en','Reason For No Terms',0),(399925,11110,'is','',0),(399926,11110,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(399927,11110,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ø·Ø­ Ù‚ÙŠÙ…Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(399928,11110,'tr','TÃ¼m fiyat seviyeleri girmeniz gerekir',0),(399929,11110,'pl','NaleÅ¼y wprowadziÄ‡ wszystkie poziomy cen',0),(399930,11110,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ñ€Ð°Ð²Ð½Ð¸Ñ‰Ð°',0),(399931,11110,'ur','Ø¢Ù¾ ÛØ± Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(399932,11110,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑÐ²Ðµ Ð½Ð¸Ð²Ð¾Ðµ Ñ†ÐµÐ½Ð°',0),(399933,11110,'vi','Báº¡n pháº£i nháº­p táº¥t cáº£ má»©c giÃ¡',0),(399934,11110,'af','U Moet \'n Prysvlak Invoer',0),(399935,11110,'ro','IntroduceÅ£i toate nivelurile de preÅ£',0),(399936,11110,'et','Peate sisestama kÃµik hinnatasemete',0),(399937,11110,'si','Vnesti morate vse ravni cen',0),(399938,11110,'ba','Anda harus memasukkan semua tingkat harga',0),(399939,11110,'nl','U moet alle prijsniveaus invoeren',0),(399940,11110,'fi','Anna kaikki hintataso',0),(399941,11110,'no','Du mÃ¥ angi alle prisklasser',0),(399942,11110,'da','Du skal angive alle prisklasser',0),(399943,11110,'ko','ëª¨ë“  ê°€ê²© ë ˆë²¨ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(399944,11110,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×‘×›×œ ×¨×ž×•×ª ×ž×—×™×¨',0),(399945,11110,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ ÏŒÎ»Î± Ï„Î± ÎµÏ€Î¯Ï€ÎµÎ´Î± Ï„Î¹Î¼ÏŽÎ½',0),(399946,11110,'zh','æ‚¨å¿…é¡»è¾“å…¥æ‰€æœ‰ä»·æ ¼æ°´å¹³\r\n',0),(399947,11110,'sv','Du mÃ¥ste ange alla prisnivÃ¥er',0),(399948,11110,'it','Ãˆ necessario inserire tutti i livelli di prezzo',0),(399949,11110,'tl','',0),(399950,11110,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸—à¸¸à¸à¸£à¸°à¸”à¸±à¸šà¸£à¸²à¸„à¸²',0),(399951,11110,'hi','à¤†à¤ªà¤•à¥‹ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ à¤¸à¤­à¥€ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°',0),(399952,11110,'ms','Anda mesti masukkan semua paras harga',0),(399953,11110,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ Ø¬Ù…ÙŠØ¹ Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(399954,11110,'fr','Vous devez entrer un nniveau de prix.',0),(399955,11110,'jp','ã™ã¹ã¦ã®ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(399956,11110,'pt','VocÃª deve digitar todos os nÃ­veis de preÃ§o',0),(399957,11110,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ Ð£Ñ€Ð¾Ð²ÐµÐ½ÑŒ Ð¦ÐµÐ½',0),(399958,11110,'es','Debe Entrar Un Nivel de Precios',0),(399959,11110,'de','Sie mÃ¼ssen alle Preisniveaus eingeben.',0),(399960,11110,'en','You Must Enter All Price Levels',0),(399961,11111,'is','',0),(399962,11111,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(399963,11111,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø´Ø±Ø§ÙŠØ· ÙØ§ÙƒØªÙˆØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(399964,11111,'tr','TÃ¼m fatura ÅŸartlarÄ± girmeniz gerekir',0),(399965,11111,'pl','NaleÅ¼y wprowadziÄ‡ wszystkie faktury warunki',0),(399966,11111,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(399967,11111,'ur','Ø¢Ù¾ ØªÙ…Ø§Ù… Ø§Ù†ÙˆØ§Ø¦Ø³ Ø´Ø±Ø§Ø¦Ø· Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(399968,11111,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑÐ²Ðµ ÑƒÑÐ»Ð¾Ð²Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(399969,11111,'vi','Báº¡n pháº£i nháº­p táº¥t cáº£ Ä‘iá»u khoáº£n cá»§a hÃ³a Ä‘Æ¡n',0),(399970,11111,'af','U Moet Faktuur Terme Invoer',0),(399971,11111,'ro','IntroduceÅ£i toÅ£i termenii de facturÄƒ',0),(399972,11111,'et','Peate sisestama kÃµik arve tingimused',0),(399973,11111,'si','Vnesti morate vse pogoje raÄuna',0),(399974,11111,'ba','Anda harus memasukkan semua istilah-istilah faktur',0),(399975,11111,'nl','U moet alle voorwaarden van de factuur invoeren',0),(399976,11111,'fi','Anna kaikkien laskun ehtojen',0),(399977,11111,'no','Du mÃ¥ angi alle faktureringsvilkÃ¥r',0),(399978,11111,'da','Du skal angive alle faktura vilkÃ¥r',0),(399979,11111,'ko','ëª¨ë“  ì†¡ìž¥ ì¡°ê±´ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(399980,11111,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×›×œ ×ž×•× ×—×™ ×—×©×‘×•× ×™×ª',0),(399981,11111,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ ÏŒÎ»Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(399982,11111,'zh','æ‚¨å¿…é¡»è¾“å…¥æ‰€æœ‰å‘ç¥¨æ¡æ¬¾\r\n',0),(399983,11111,'sv','Du mÃ¥ste ange alla faktura villkor',0),(399984,11111,'it','Ãˆ necessario inserire tutti i termini di fattura',0),(399985,11111,'tl','',0),(399986,11111,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¹ƒà¸™à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œ',0),(399987,11111,'hi','à¤†à¤ª à¤¸à¤­à¥€ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¶à¤°à¥à¤¤à¥‡à¤‚ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(399988,11111,'ms','Anda mesti memasukkan semua terma-terma invois',0),(399989,11111,'ar','Ù„Ø§Ø¨Ø¯ Ù…Ù† Ø¥Ø¯Ø®Ø§Ù„ Ø´Ø±ÙˆØ· Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(399990,11111,'fr','Vous devez entrer les termes de la facture.',0),(399991,11111,'jp','è«‹æ±‚æ›¸ã®ã™ã¹ã¦ã®æ¡ä»¶ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(399992,11111,'pt','VocÃª deve digitar todos os termos de factura',0),(399993,11111,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð²ÑÐµ ÑÑ‡ÐµÑ‚Ð° Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ñ‹',0),(399994,11111,'es','Debe Entrar Los TÃ©rminos de Factura',0),(399995,11111,'de','Sie mÃ¼ssen alle Rechnung Begriffe eingeben.',0),(399996,11111,'en','You Must Enter All Invoice Terms',0),(399997,11112,'is','',0),(399998,11112,'dr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø³ÙˆØ®Øª Ø´Ø¯Ù‡ ',0),(399999,11112,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ø³ÙˆØ®Øª Ø´Ø¯Ù‡ ',0),(400000,11112,'tr','GL hesabÄ± iÃ§in yazma-off',0),(400001,11112,'pl','GL konto do umorzenia',0),(400002,11112,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð¾Ñ‚Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(400003,11112,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Write-Off Ú©Û’ Ù„ÛŒÛ’',0),(400004,11112,'sr','Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¾Ñ‚Ð¿Ð¸Ñ',0),(400005,11112,'vi','TK sá»• cÃ¡i cho xÃ³a bá»',0),(400006,11112,'af','GL rekening vir afskrywing',0),(400007,11112,'ro','GL cont pentru anularea',0),(400008,11112,'et','GL konto kustutamine',0),(400009,11112,'si','GL raÄun za odpis',0),(400010,11112,'ba','GL Account untuk Write-Off',0),(400011,11112,'nl','GL Account voor afschrijving',0),(400012,11112,'fi','Kirjanpitotilin pÃ¤Ã¤tilin anteeksi',0),(400013,11112,'no','GI-konto For avskrivning',0),(400014,11112,'da','GL konto For afskrivning',0),(400015,11112,'ko','ì“°ê¸°ì— ëŒ€ í•œ GL ê³„ì •',0),(400016,11112,'he','GL ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×ž×—×™×§×” ×‘×”×ª××',0),(400017,11112,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(400018,11112,'zh','æ€»å¸å¸æˆ·æ³¨é”€\r\n',0),(400019,11112,'sv','GL konto fÃ¶r avskrivning',0),(400020,11112,'it','GL Account per storno',0),(400021,11112,'tl','',0),(400022,11112,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸•à¸±à¸”à¸ˆà¹ˆà¸²à¸¢',0),(400023,11112,'hi','GL à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¿à¤–à¤¨à¥‡ à¤¬à¤¨à¤¾à¤¨à¤¾',0),(400024,11112,'ms','Akaun GL untuk pelupusan',0),(400025,11112,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„ØªØ®Ø±ÙŠØ¯ ÙÙŠ Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(400026,11112,'fr','Compte GL par profits et pertes',0),(400027,11112,'jp','å„Ÿå´ã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(400028,11112,'pt','GL conta para write-off',0),(400029,11112,'ru','GL ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(400030,11112,'es','Cuenta LM Para Borrar Deuda',0),(400031,11112,'de','Sako fÃ¼r Abschreibung',0),(400032,11112,'en','GL Account For Write-off',0),(400033,11113,'is','',0),(400034,11113,'dr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø­Ù…Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´ÙˆØ¯',0),(400035,11113,'pr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø­Ù…Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´ÙˆØ¯',0),(400036,11113,'tr','Bu sÄ±rada nakliye daha Ã¶nce Ã¶denmiÅŸ olmalÄ±dÄ±r',0),(400037,11113,'pl','Tym celu naleÅ¼y dokonaÄ‡ przedpÅ‚aty przed wysyÅ‚kÄ…',0),(400038,11113,'bg','Ð¢Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ñ€ÐµÐ´Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(400039,11113,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ø´Ù¾Ù†Ú¯ Ú©Û’ Ø³Ø§Ù…Ù†Û’ Ù¾Ø±ÛŒÙ¾Ø¦ÛŒØ¯ Ú†Ø§ÛÛŒÛ’',0),(400040,11113,'sr','ÐžÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ð° Ð¼Ð¾Ñ€Ð° Ð¸Ð·Ð²Ñ€ÑˆÐ¸Ñ‚Ð¸ Ð¿Ñ€Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(400041,11113,'vi','ÄÆ¡n hÃ ng nÃ y pháº£i Ä‘Æ°á»£c thanh toÃ¡n trÆ°á»›c khi xuáº¥t hÃ ng',0),(400042,11113,'af','Hierdie Bestelling Moet Vooruitbetaal wees Alvorens Versending kan plaasvind',0),(400043,11113,'ro','AceastÄƒ ordine trebuie sÄƒ fie plata Ã®n avans Ã®nainte de expediere',0),(400044,11113,'et','Selle tellimuse makstakse tagasi enne Shipping',0),(400045,11113,'si','Ta nalog mora se poplaÄa pred ladijskega prometa',0),(400046,11113,'ba','Urutan ini harus prabayar sebelum pengiriman',0),(400047,11113,'nl','Deze volgorde moet vooraf worden betaald vÃ³Ã³r verzending',0),(400048,11113,'fi','TÃ¤mÃ¤ jÃ¤rjestys on Prepaid ennen toimitusta',0),(400049,11113,'no','Denne bestillingen forhÃ¥ndsbetales fÃ¸r forsendelse',0),(400050,11113,'da','Denne ordre skal forudbetales fÃ¸r forsendelse',0),(400051,11113,'ko','ì´ ìˆœì„œë¥¼ ë°œì†¡ í•˜ê¸° ì „ì— ì„ ë¶ˆ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(400052,11113,'he','×¦×• ×–×” ×—×™×™×‘ ×œ×”×™×•×ª ×ž×¨××© ×œ×¤× ×™ ×”×ž×©×œ×•×—',0),(400053,11113,'el','Î‘Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€ÏÎ¿Ï€Î»Î·ÏÏŽÎ½Î¿Î½Ï„Î±Î¹ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î· Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(400054,11113,'zh','è¿™ç§è®¢å•å¿…é¡»åœ¨è£…è¿å‰é¢„ä»˜\r\n',0),(400055,11113,'sv','Denna ordning mÃ¥ste fÃ¶rskottsbetalas innan leverans',0),(400056,11113,'it','Questo ordine deve essere prepagato prima della spedizione',0),(400057,11113,'tl','',0),(400058,11113,'th','à¸ªà¸±à¹ˆà¸‡à¸™à¸µà¹‰à¸•à¹‰à¸­à¸‡à¸ˆà¹ˆà¸²à¸¢à¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²à¸à¹ˆà¸­à¸™à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(400059,11113,'hi','à¤‡à¤¸ à¤•à¥à¤°à¤® à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤ªà¥à¤°à¥€à¤ªà¥‡à¤¡ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(400060,11113,'ms','Perintah ini mestilah dibayar terdahulu sebelum penghantaran',0),(400061,11113,'ar','Ù„Ø§ Ø¨Ø¯Ù‘ Ù…Ù† Ø³Ø¯Ø§Ø¯ Ù‡Ø°Ù‡ Ø§Ù„Ø·Ù„Ø¨ÙŠÙ‘Ø© Ù‚Ø¨Ù„ Ø´Ø­Ù†Ù‡Ø§',0),(400062,11113,'fr','Le prÃ©sent arrÃªtÃ© doit Ãªtre prÃ©payÃ© avant l\'expÃ©dition',0),(400063,11113,'jp','ã“ã®é †åºã¯å‡ºè·å‰ã«å‰æ‰•ã„ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(400064,11113,'pt','Esta ordem deve ser prÃ©-pagas antes do envio',0),(400065,11113,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð¾Ð¿Ð»Ð°Ñ‚Ð° Ð¿ÐµÑ€ÐµÐ´ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¾Ð¹',0),(400066,11113,'es','Este Orden Debe Ser Prepagado Antes Que Enviar',0),(400067,11113,'de','Diese Reihenfolge muss vor dem Versand voraus bezahlt werden',0),(400068,11113,'en','This Order Must Be Prepaid Before Shipping',0),(400069,11114,'is','',0),(400070,11114,'dr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ÙØ§ÙƒØªÙˆØ± Ø´ÙˆØ¯ ØªØ§ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´ÙˆØ¯',0),(400071,11114,'pr','Ø§ÙŠÙ† Ø³ÙØ§Ø±Ø´ Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ ÙØ§ÙƒØªÙˆØ± Ø´ÙˆØ¯ ØªØ§ Ø²Ù…Ø§Ù†ÙŠ ÙƒÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´ÙˆØ¯',0),(400072,11114,'tr','Bu sÄ±rada Ã¶denene kadar faturalanamaz',0),(400073,11114,'pl','To zamÃ³wienie nie zostanie wystawiona wpÅ‚acenia',0),(400074,11114,'bg','Ð¢Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð°, Ð´Ð¾ÐºÐ°Ñ‚Ð¾ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(400075,11114,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ø§Ø¯Ø§ Ú©ÛŒØ§ ÛŒÛØ§Úº ØªÚ© Ú©Û Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ø¬Ø§ Ø³Ú©ØªØ§',0),(400076,11114,'sr','ÐžÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ð° ÑÐµ Ð½Ðµ Ð¼Ð¾Ð³Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ Ð´Ð¾Ðº ÑÐµ Ð½Ðµ',0),(400077,11114,'vi','ÄÆ¡n Ä‘áº·t hÃ ng nÃ y cÃ³ thá»ƒ khÃ´ng Ä‘Æ°á»£c xuáº¥t hÃ³a Ä‘Æ¡n cho tá»›i khi Ä‘Æ°á»£c thanh toÃ¡n',0),(400078,11114,'af','Hierdie Bestelling Kan Nie Gefaktureerd Word Voordat dit Nie Betaal is',0),(400079,11114,'ro','Acest ordin nu poate fi facturat pÃ¢nÄƒ la plata',0),(400080,11114,'et','Tellimus ei saa arveldada enne maksmist',0),(400081,11114,'si','Ta naloga ne morete fakturirati, dokler se ne plaÄa',0),(400082,11114,'ba','Urutan ini tidak ditagih sampai dibayar',0),(400083,11114,'nl','Deze volgorde kan niet worden gefactureerd totdat betaald',0),(400084,11114,'fi','TÃ¤mÃ¤ tilaus ei voi laskuttaa ennen kuin maksettu',0),(400085,11114,'no','Denne bestillingen faktureres til betalt',0),(400086,11114,'da','Denne ordre kan blive faktureret indtil betalt',0),(400087,11114,'ko','ì´ ìˆœì„œê¹Œì§€ ì§€ë¶ˆ ì²­êµ¬ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(400088,11114,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×—×™×™×‘ ×¦×• ×–×” ×¢×“ ×©×™×œ×',0),(400089,11114,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î·Î¸Î¿ÏÎ½ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬, Î¼Î­Ï‡ÏÎ¹ Î½Î± ÎºÎ±Ï„Î±Î²Î»Î·Î¸ÎµÎ¯',0),(400090,11114,'zh','è¿™ä¸ªè®¢å•ä¸èƒ½å¼€å…·å‘ç¥¨ï¼Œç›´è‡³ä»˜æ¸…\r\n',0),(400091,11114,'sv','Denna ordning kan inte faktureras tills betalas',0),(400092,11114,'it','Questo ordine non puÃ² essere fatturato fino al pagamento',0),(400093,11114,'tl','',0),(400094,11114,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸­à¸­à¸à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸™à¸µà¹‰à¸ˆà¹ˆà¸²à¸¢',0),(400095,11114,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤¤à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(400096,11114,'ms','Perintah ini tidak dapat invois sehingga dibayar',0),(400097,11114,'ar','Ù‡Ø°Ø§ Ø§Ù„Ø£Ù…Ø± Ù„Ø§ ÙŠÙ…ÙƒÙ† ÙÙˆØªØ±ØªÙ‡Ø§ Ø­ØªÙ‰ ÙŠØ¯ÙØ¹',0),(400098,11114,'fr','Cette commande ne peut pas Ãªtre facturÃ©e jusqu\'au paiement',0),(400099,11114,'jp','æ”¯æ‰•ã‚ã‚Œã‚‹ã¾ã§ã€ã“ã®æ³¨æ–‡ã‚’è«‹æ±‚ã§ãã¾ã›ã‚“ã€‚',0),(400100,11114,'pt','Esta ordem nÃ£o pode ser facturada atÃ© pago',0),(400101,11114,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚ Ð´Ð¾ ÑƒÐ¿Ð»Ð°Ñ‚Ñ‹',0),(400102,11114,'es','Este Orden No Se Puede Factura Hasta Que Se Paga',0),(400103,11114,'de','Diese Reihenfolge kann nicht in Rechnung gestellt, bis zur Bezahlung',0),(400104,11114,'en','This Order Cannot Be Invoiced Until Paid',0),(400105,11115,'is','',0),(400106,11115,'dr','ÙØ¹Ø§Ù„ Ùˆ ØºÙŠØ± ÙØ¹Ø§Ù„',0),(400107,11115,'pr','ÙØ¹Ø§Ù„ Ùˆ ØºÙŠØ± ÙØ¹Ø§Ù„',0),(400108,11115,'tr','Etkin & etkin deÄŸil',0),(400109,11115,'pl','Aktywne & nieaktywne',0),(400110,11115,'bg','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ & Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸',0),(400111,11115,'ur','Ø²ÛŒØ± Ø¹Ù…Ù„ & ØºÛŒØ± ÙØ¹Ø§Ù„',0),(400112,11115,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ðµ Ð¸ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ðµ',0),(400113,11115,'vi','kÃ­ch hoáº¡t & khÃ´ng kÃ­ch hoáº¡t',0),(400114,11115,'af','Aktief & Onaktief',0),(400115,11115,'ro','Activ & inactiv',0),(400116,11115,'et','Aktiivne & mitteaktiivsete',0),(400117,11115,'si','Aktivno & neaktivni',0),(400118,11115,'ba','Aktif & tidak aktif',0),(400119,11115,'nl','Actieve & inactief',0),(400120,11115,'fi','Aktiivinen & passiivinen',0),(400121,11115,'no','Aktive & inaktiv',0),(400122,11115,'da','Aktive & inaktive',0),(400123,11115,'ko','í™œì„± & ë¹„í™œì„±',0),(400124,11115,'he','×¤×¢×™×œ ×•×œ× ×¤×¢×™×œ',0),(400125,11115,'el','Î•Î½ÎµÏÎ³ÏŒ & Î±Î½ÎµÎ½ÎµÏÎ³ÏŒ',0),(400126,11115,'zh','æ´»è·ƒèˆ‡éžæ´»è·ƒ\r\n\r\n',0),(400127,11115,'sv','Aktiva & inaktiva',0),(400128,11115,'it','Attivo & inattivo',0),(400129,11115,'tl','',0),(400130,11115,'th','à¸‡à¸²à¸™ & à¸‡à¸²à¸™',0),(400131,11115,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ & à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯',0),(400132,11115,'ms','Aktif & tidak aktif',0),(400133,11115,'ar','Ø§Ù„Ù†Ù‘Ø´Ø·ÙˆÙ† Ùˆ Ø§Ù„Ø®Ø§Ù…Ù„ÙˆÙ†',0),(400134,11115,'fr','Prospects actifs et non-actifs',0),(400135,11115,'jp','Active & éžã‚¢ã‚¯ãƒ†ã‚£ãƒ–',0),(400136,11115,'pt','Ativo & inativo',0),(400137,11115,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ & ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ',0),(400138,11115,'es','Activo e Inactivo',0),(400139,11115,'de','Aktive & inaktiv',0),(400140,11115,'en','Active & Inactive',0),(400141,11116,'is','',0),(400142,11116,'dr','ÙÙ‚Ø· ÙØ¹Ø§Ù„ ',0),(400143,11116,'pr','ÙÙ‚Ø· ÙØ¹Ø§Ù„ ',0),(400144,11116,'tr','YalnÄ±zca etkin',0),(400145,11116,'pl','Aktywne tylko',0),(400146,11116,'bg','Ð¡Ð°Ð¼Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸Ñ‚Ðµ',0),(400147,11116,'ur','ØµØ±Ù Ø²ÛŒØ± Ø¹Ù…Ù„',0),(400148,11116,'sr','Ð¡Ð°Ð¼Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾',0),(400149,11116,'vi','chá»‰ kÃ­ch hoáº¡t',0),(400150,11116,'af','Alleenlik Aktief',0),(400151,11116,'ro','Activ numai',0),(400152,11116,'et','Ainult aktiivne',0),(400153,11116,'si','Aktivni le',0),(400154,11116,'ba','Aktif hanya',0),(400155,11116,'nl','Alleen actieve',0),(400156,11116,'fi','Vain kÃ¤ytÃ¶ssÃ¤ olevat',0),(400157,11116,'no','Aktiv bare',0),(400158,11116,'da','Aktiv kun',0),(400159,11116,'ko','í™œì„±ë§Œ',0),(400160,11116,'he','×¤×¢×™×œ ×‘×œ×‘×“',0),(400161,11116,'el','Î•Î½ÎµÏÎ³ÏŒ Î¼ÏŒÎ½Î¿',0),(400162,11116,'zh','ä»…æ´»è·ƒ\r\n',0),(400163,11116,'sv','Aktiv endast',0),(400164,11116,'it','Attiva solo',0),(400165,11116,'tl','',0),(400166,11116,'th','à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸­à¸¢à¸¹à¹ˆà¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(400167,11116,'hi','à¤•à¥‡à¤µà¤² à¤¸à¤•à¥à¤°à¤¿à¤¯',0),(400168,11116,'ms','Aktif sahaja',0),(400169,11116,'ar','Ø§Ù„Ù†Ø´Ø·Ø© ÙÙ‚Ø·',0),(400170,11116,'fr','Prospects actifs',0),(400171,11116,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã®ã¿',0),(400172,11116,'pt','Somente ativo',0),(400173,11116,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ',0),(400174,11116,'es','Solo Activo',0),(400175,11116,'de','Nur aktiv',0),(400176,11116,'en','Active Only',0),(400177,11117,'is','',0),(400178,11117,'dr','Ù‡Ù…Ù‡ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(400179,11117,'pr','Ù‡Ù…Ù‡ ÙƒØ§Ù„Ø§Ù‡Ø§',0),(400180,11117,'tr','TÃ¼m Ã¶ÄŸeler',0),(400181,11117,'pl','Wszystkie elementy',0),(400182,11117,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(400183,11117,'ur','ØªÙ…Ø§Ù… Ø§Ø´ÛŒØ§Ø¡',0),(400184,11117,'sr','Ð¡Ð²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(400185,11117,'vi','Táº¥t cáº£ cÃ¡c háº¡n má»¥c',0),(400186,11117,'af','Alle Items',0),(400187,11117,'ro','Toate elementele',0),(400188,11117,'et','KÃµik Ã¼ksused',0),(400189,11117,'si','Vse elemente',0),(400190,11117,'ba','Semua item',0),(400191,11117,'nl','Alle Items',0),(400192,11117,'fi','Kaikki kohteet',0),(400193,11117,'no','Alle elementer',0),(400194,11117,'da','Alle varer',0),(400195,11117,'ko','ëª¨ë“  í•­ëª©',0),(400196,11117,'he','×›×œ ×”×¤×¨×™×˜×™×',0),(400197,11117,'el','ÎŒÎ»Î± Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(400198,11117,'zh','å…¨éƒ¨é¡¹ç›®\r\n',0),(400199,11117,'sv','Alla artiklar',0),(400200,11117,'it','Tutti gli articoli',0),(400201,11117,'tl','',0),(400202,11117,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(400203,11117,'hi','à¤¸à¤­à¥€ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(400204,11117,'ms','Semua item',0),(400205,11117,'ar','Ø¬Ù…ÙŠØ¹ Ø§ï»·ØµÙ†Ø§Ù',0),(400206,11117,'fr','Tous les Articles',0),(400207,11117,'jp','ã™ã¹ã¦ã®é …ç›®',0),(400208,11117,'pt','Todos os itens',0),(400209,11117,'ru','Ð’ÑÐµ Ð¢Ð¾Ð²Ð°Ñ€Ñ‹',0),(400210,11117,'es','Todos los Items',0),(400211,11117,'de','Alle Elemente',0),(400212,11117,'en','All Items',0),(400213,11118,'is','',0),(400214,11118,'dr','ÙÙ‚Ø· ØºÙŠØ± ÙØ¹Ø§Ù„ ',0),(400215,11118,'pr','ÙÙ‚Ø· ØºÙŠØ± ÙØ¹Ø§Ù„ ',0),(400216,11118,'tr','Etkin olmayan sadece',0),(400217,11118,'pl','Nieaktywny tylko',0),(400218,11118,'bg','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸ ÑÐ°Ð¼Ð¾',0),(400219,11118,'ur','ØºÛŒØ± ÙØ¹Ø§Ù„ ÛÛŒ',0),(400220,11118,'sr','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸ ÑÐ°Ð¼Ð¾',0),(400221,11118,'vi','Chá»‰ khÃ´ng hoáº¡t Ä‘á»™ng',0),(400222,11118,'af','Onaktief Alleenlik',0),(400223,11118,'ro','Inactiv numai',0),(400224,11118,'et','Passiivsed ainult',0),(400225,11118,'si','Neaktivni le',0),(400226,11118,'ba','Tidak aktif hanya',0),(400227,11118,'nl','Inactieve alleen',0),(400228,11118,'fi','Aktiivinen vain',0),(400229,11118,'no','Inaktive bare',0),(400230,11118,'da','Inaktive kun',0),(400231,11118,'ko','ë¹„í™œì„±ë§Œ',0),(400232,11118,'he','×œ× ×¤×¢×™×œ×™× ×‘×œ×‘×“',0),(400233,11118,'el','Î‘Î½ÎµÎ½ÎµÏÎ³Î® Î¼ÏŒÎ½Î¿',0),(400234,11118,'zh','åªæœ‰éžæ´»åŠ¨\r\n',0),(400235,11118,'sv','Inaktiva endast',0),(400236,11118,'it','Inattivo solo',0),(400237,11118,'tl','',0),(400238,11118,'th','à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(400239,11118,'hi','à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯ à¤•à¥‡à¤µà¤²',0),(400240,11118,'ms','Tidak aktif hanya',0),(400241,11118,'ar','Ø§Ù„Ø®Ø§Ù…Ù„ÙˆÙ† ÙÙ‚Ø·',0),(400242,11118,'fr','Inactif seulement',0),(400243,11118,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã§ãªã„ã ã‘',0),(400244,11118,'pt','Inativos somente',0),(400245,11118,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ',0),(400246,11118,'es','Inactivo Solo',0),(400247,11118,'de','Inaktive nur',0),(400248,11118,'en','Inactive Only',0),(400249,11119,'is','',0),(400250,11119,'dr','ÙÙ‚Ø· ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø®Ø§Ø±Ø¬ Ø§Ø² Ø³Ø¨Ø¯ Ø®Ø±ÙŠØ¯',0),(400251,11119,'pr','ÙÙ‚Ø· ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ø®Ø§Ø±Ø¬ Ø§Ø² Ø³Ø¨Ø¯ Ø®Ø±ÙŠØ¯',0),(400252,11119,'tr','Sadece sigara alÄ±ÅŸveriÅŸ sepeti Ã¶ÄŸeleri',0),(400253,11119,'pl','Tylko-zakupy koszyka pozycje',0),(400254,11119,'bg','Ð¡Ð°Ð¼Ð¾ Ð½Ðµ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐºÐ°Ñ‚Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(400255,11119,'ur','ØµØ±Ù ØºÛŒØ±-Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ú©ÛŒ Ø§Ø´ÛŒØ§Ø¡',0),(400256,11119,'sr','Ð¡Ð°Ð¼Ð¾ Ð±ÐµÐ· ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ðµ ÐºÐ¾Ð»Ð¸Ñ†Ð° ÑÑ‚Ð°Ð²ÐºÐµ',0),(400257,11119,'vi','Chá»‰ khÃ´ng chuyá»ƒn xe hÃ ng nÃ y',0),(400258,11119,'af','Slegs Nie-Winkelwaentjie Items',0),(400259,11119,'ro','Numai Non-Shopping Cart elementele',0),(400260,11119,'et','Ainult-Shopping Cart Ã¼ksused',0),(400261,11119,'si','Samo-Shopping voziÄek elementov',0),(400262,11119,'ba','Hanya Non-belanja troli barang',0),(400263,11119,'nl','Alleen niet-Shopping Cart Items',0),(400264,11119,'fi','Vain ei-ostosten ostoskorinimikkeet',0),(400265,11119,'no','Bare ikke-Shopping Cart elementer',0),(400266,11119,'da','Kun ikke-Shopping Cart elementer',0),(400267,11119,'ko','-ì‡¼í•‘ ì¹´íŠ¸ í•­ëª©ë§Œ',0),(400268,11119,'he','×¤×¨×™×˜×™× ×‘×œ×‘×“ ×œ×œ× ×§× ×™×•×ª ×¢×’×œ×”',0),(400269,11119,'el','ÎœÏŒÎ½Î¿ Î¼Î·-Shopping Cart ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(400270,11119,'zh','éžå”¯ä¸€çš„è´­ç‰©è½¦é¡¹ç›®\r\n',0),(400271,11119,'sv','Endast icke-Shopping Cart objekt',0),(400272,11119,'it','Solo Non-Shopping Cart elementi',0),(400273,11119,'tl','',0),(400274,11119,'th','à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™à¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆà¸Šà¹‡à¸­à¸›à¸›à¸´à¹‰à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¹ƒà¸™à¸£à¸–à¹€à¸‚à¹‡à¸™',0),(400275,11119,'hi','à¤—à¥ˆà¤°-à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤®à¤¦à¥‹à¤‚ à¤•à¥‡à¤µà¤²',0),(400276,11119,'ms','Hanya-Shopping Cart item',0),(400277,11119,'ar','Ø¨Ù†ÙˆØ¯ Ø³Ù„Ø© Ø§Ù„ØªØ³ÙˆÙ‚ ØºÙŠØ± ÙÙ‚Ø·',0),(400278,11119,'fr','Seulement Non-Shopping Cart Items',0),(400279,11119,'jp','-ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚° ã‚«ãƒ¼ãƒˆã®ã‚¢ã‚¤ãƒ†ãƒ ã®ã¿',0),(400280,11119,'pt','NÃ£o-comercial somente itens de carrinho',0),(400281,11119,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð½Ðµ Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº ÐšÐ¾Ñ€Ð·Ð¸Ð½Ð° Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(400282,11119,'es','SÃ³lo Items que no EstÃ¡n en el Carito de Compras',0),(400283,11119,'de','Nur nicht-Shopping Cart Produkte',0),(400284,11119,'en','Only Non-Shopping Cart Items',0),(400285,11120,'is','',0),(400286,11120,'dr','ÙÙ‚Ø· ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø³Ø¨Ø¯ Ø®Ø±ÙŠØ¯ ',0),(400287,11120,'pr','ÙÙ‚Ø· ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø³Ø¨Ø¯ Ø®Ø±ÙŠØ¯ ',0),(400288,11120,'tr','Sadece alÄ±ÅŸveriÅŸ sepeti Ã¶ÄŸeleri',0),(400289,11120,'pl','Tylko zakupy koszyka pozycje',0),(400290,11120,'bg','Ð¡Ð°Ð¼Ð¾ Ð¿Ð°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐºÐ° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(400291,11120,'ur','ØµØ±Ù Ú¯Ø§Ú‘ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(400292,11120,'sr','Ð¡Ð°Ð¼Ð¾ Ñƒ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ñƒ ÐºÐ¾Ð»Ð¸Ñ†Ð° ÑÑ‚Ð°Ð²ÐºÐµ',0),(400293,11120,'vi','chá»‰ váº­n chuyá»ƒn xe hÃ ng ',0),(400294,11120,'af','Slegs Shopping Cart Items',0),(400295,11120,'ro','Numai Shopping Cart elemente',0),(400296,11120,'et','Ainult Shopping ostukorvi kaupu',0),(400297,11120,'si','Samo nakupovalni voziÄek elementov',0),(400298,11120,'ba','Hanya belanja troli barang',0),(400299,11120,'nl','Alleen winkelen kar Items',0),(400300,11120,'fi','Vain ostoksia ostoskorinimikkeet',0),(400301,11120,'no','Bare Shopping Cart elementer',0),(400302,11120,'da','Kun Shopping Cart elementer',0),(400303,11120,'ko','ë‹¨ì§€ ì‡¼í•‘ ì¹´íŠ¸ í•­ëª©',0),(400304,11120,'he','×¨×§ ×§× ×™×•×ª ×¤×¨×™×˜×™ ×”×¢×’×œ×”',0),(400305,11120,'el','Î¨ÏŽÎ½Î¹Î± Î¼ÏŒÎ½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î·Ï‚ Cart',0),(400306,11120,'zh','åªæœ‰æ‚¨é€‰è´­çš„äº§å“\r\n',0),(400307,11120,'sv','Bara Shopping shoppingvagnsartiklar',0),(400308,11120,'it','Solo lo Shopping Cart elementi',0),(400309,11120,'tl','',0),(400310,11120,'th','à¹€à¸žà¸µà¸¢à¸‡ à¸‹à¸·à¹‰à¸­à¸ªà¸´à¸™à¸„à¹‰à¸²à¹ƒà¸™à¸£à¸–à¹€à¸‚à¹‡à¸™',0),(400311,11120,'hi','à¤•à¥‡à¤µà¤² à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤®à¤¦à¥‹à¤‚',0),(400312,11120,'ms','Barang-barang dalam troli membeli-belah hanya',0),(400313,11120,'ar','ÙÙ‚Ø· Ù„Ù„ØªØ³ÙˆÙ‚ Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø¹Ø±Ø¨Ø©',0),(400314,11120,'fr','Seulement Shopping Cart Items',0),(400315,11120,'jp','ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚° ã‚«ãƒ¼ãƒˆé …ç›®ã®ã¿',0),(400316,11120,'pt','Somente itens do carrinho de compras',0),(400317,11120,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº ÐšÐ¾Ñ€Ð·Ð¸Ð½Ð° Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(400318,11120,'es','SÃ³lo Items que EstÃ¡n en el Carito de Compras',0),(400319,11120,'de','Nur Shopping Cart Produkte',0),(400320,11120,'en','Only Shopping Cart Items',0),(400321,11121,'is','',0),(400322,11121,'dr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ¯Ø§Ù… ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(400323,11121,'pr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ¯Ø§Ù… ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ø®Ø±ÙŠØ¯ ',0),(400324,11121,'tr','AlÄ±ÅŸveriÅŸ sepeti Ã¶ÄŸeleri gÃ¶ster:',0),(400325,11121,'pl','PokaÅ¼ elementy koszyka zakupÃ³w',0),(400326,11121,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ð¸ Ð¿Ð°Ð·Ð°Ñ€ÑƒÐ²Ð°Ð½Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐºÐ° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(400327,11121,'ur','Ø¬Ùˆ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ø§Ø´ÛŒØ§ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(400328,11121,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ ÐºÐ¾Ñ˜Ðµ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ†Ð°',0),(400329,11121,'vi','thá»ƒ hiá»‡n máº·t hÃ ng mua sáº¯m nÃ o',0),(400330,11121,'af','Wys watter Items Shopping Cart',0),(400331,11121,'ro','AratÄƒ care articole de coÅŸ de cumpÄƒrÄƒturi',0),(400332,11121,'et','Kuva Shopping Cart Ã¼ksused',0),(400333,11121,'si','PrikaÅ¾i nakupovalni voziÄek predmeti',0),(400334,11121,'ba','Tampilkan item mana keranjang belanja',0),(400335,11121,'nl','Welke Shopping Cart Items weergeven',0),(400336,11121,'fi','NÃ¤ytÃ¤ hotelli ostokset ostoskorinimikkeet',0),(400337,11121,'no','Vis Shopping Cart elementer',0),(400338,11121,'da','Vis som Shopping Cart elementer',0),(400339,11121,'ko','ì‡¼í•‘ ì¹´íŠ¸ í•­ëª© í‘œì‹œ',0),(400340,11121,'he','. ×ª×¨××” ××™×œ×• ×¤×¨×™×˜×™× ×‘×¢×’×œ×ª ×”×§× ×™×•×ª',0),(400341,11121,'el','Î”ÎµÎ¯Ï„Îµ Ï€Î¿Î¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÎºÎ±Î»Î¬Î¸Î¹ Î±Î³Î¿ÏÏŽÎ½',0),(400342,11121,'zh','æ˜¾ç¤ºå“ªäº›ç‰©å“è´­ç‰©è½¦\r\n',0),(400343,11121,'sv','Visa vilka artiklar som Shopping Cart',0),(400344,11121,'it','Visualizza gli elementi Shopping Cart',0),(400345,11121,'tl','',0),(400346,11121,'th','à¹à¸ªà¸”à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸–à¹€à¸‚à¹‡à¸™à¸Šà¹‡à¸­à¸›à¸›à¸´à¹‰à¸‡',0),(400347,11121,'hi','à¤œà¥‹ à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤•à¥€ à¤Ÿà¥‹à¤•à¤°à¥€ à¤†à¤‡à¤Ÿà¤® à¤¦à¤¿à¤–à¤¾à¤à¤',0),(400348,11121,'ms','Tunjuk butiran troli membeli-belah yang',0),(400349,11121,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„ØªÙŠ Ø¹Ø±Ø¨Ø© Ø§Ù„ØªØ³ÙˆÙ‚',0),(400350,11121,'fr','Montrer quels Ã©lÃ©ments de panier Shopping',0),(400351,11121,'jp','ã©ã®ã‚·ãƒ§ãƒƒãƒ”ãƒ³ã‚° ã‚«ãƒ¼ãƒˆ ã‚¢ã‚¤ãƒ†ãƒ ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(400352,11121,'pt','Mostrar quais itens do carrinho de compras',0),(400353,11121,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÐºÐ¾Ñ€Ð·Ð¸Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº',0),(400354,11121,'es','Muestra Cuales Items de Carrito de Compras',0),(400355,11121,'de','Welche Shopping Cart-Elemente anzeigen',0),(400356,11121,'en','Show Which Shopping Cart Items',0),(400357,11122,'is','',0),(400358,11122,'dr','Ù‡ÙŠÚ† Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ â€“Ù†Ø³ÙŠÙ‡ Ù…Ø¬Ø§Ø² Ù†ÙŠØ³Øª ',0),(400359,11122,'pr','Ù‡ÙŠÚ† Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ â€“Ù†Ø³ÙŠÙ‡ Ù…Ø¬Ø§Ø² Ù†ÙŠØ³Øª ',0),(400360,11122,'tr','Ä°zin verilen kredi yok',0),(400361,11122,'pl','Nie wolno kredytu',0),(400362,11122,'bg','ÐÐµ ÑÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(400363,11122,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(400364,11122,'sr','ÐÐµÐ¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°, Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(400365,11122,'vi','khÃ´ng ghi cÃ³',0),(400366,11122,'af','Geen Krediet Toegelaat',0),(400367,11122,'ro','Nici un Credit permis',0),(400368,11122,'et','Ei ole lubatud krediiti',0),(400369,11122,'si','Å t Credit dovoljeno',0),(400370,11122,'ba','Tidak ada kredit yang diperbolehkan',0),(400371,11122,'nl','Geen krediet toegestaan',0),(400372,11122,'fi','Ei hyvitys',0),(400373,11122,'no','Ingen kreditt tillatt',0),(400374,11122,'da','Ingen kredit tilladt',0),(400375,11122,'ko','ìˆ˜ ì‹ ìš©',0),(400376,11122,'he','××™×Ÿ ××©×¨××™ ×ž×•×ª×¨',0),(400377,11122,'el','ÎšÎ±Î¼Î¯Î± Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ· ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(400378,11122,'zh','æ²¡æœ‰å…è®¸çš„ä¿¡ç”¨\r\n',0),(400379,11122,'sv','Ingen kredit tillÃ¥tet',0),(400380,11122,'it','Nessun credito ammessi',0),(400381,11122,'tl','',0),(400382,11122,'th','à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(400383,11122,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(400384,11122,'ms','Tiada kredit yang dibenarkan',0),(400385,11122,'ar','Ù„Ø§ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(400386,11122,'fr','Aucun crÃ©dit accordÃ©',0),(400387,11122,'jp','è¨±å¯ãªã—ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰',0),(400388,11122,'pt','Nenhum crÃ©dito permitido',0),(400389,11122,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ ÐÐµ Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½',0),(400390,11122,'es','El CrÃ©dito no Esta Permitido',0),(400391,11122,'de','Kein Kredit erlaubt',0),(400392,11122,'en','No Credit Allowed',0),(400393,11123,'is','',0),(400394,11123,'dr','Ø¨Ø¯ÙˆÙ† Ø´Ø±Ø­ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ ',0),(400395,11123,'pr','Ø¨Ø¯ÙˆÙ† Ø´Ø±Ø­ Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ ',0),(400396,11123,'tr','Kredi aÃ§Ä±klamasÄ± yok',0),(400397,11123,'pl','Nie wyjaÅ›nienie kredytu',0),(400398,11123,'bg','ÐÑÐ¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð¾Ð±ÑÑÐ½ÐµÐ½Ð¸Ðµ',0),(400399,11123,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(400400,11123,'sr','ÐÐµÐ¼Ð° Ð¾Ð±Ñ˜Ð°ÑˆÑšÐµÑšÐ° Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(400401,11123,'vi','khÃ´ng diá»…n giáº£i bÃªn cÃ³',0),(400402,11123,'af','Geen Krediet Verduideliking',0),(400403,11123,'ro','Nici o explicaÅ£ie de Credit',0),(400404,11123,'et','No Credit selgitus',0),(400405,11123,'si','Ne kredit razlaga',0),(400406,11123,'ba','Tidak ada penjelasan kredit',0),(400407,11123,'nl','Geen Credit-verklaring',0),(400408,11123,'fi','MitÃ¤Ã¤n luotto selitystÃ¤',0),(400409,11123,'no','Ingen kreditt forklaring',0),(400410,11123,'da','Ingen kredit forklaring',0),(400411,11123,'ko','ì•„ë‹ˆ ì‹ ìš© ì„¤ëª…',0),(400412,11123,'he','××™×Ÿ ×”×¡×‘×¨ ××©×¨××™',0),(400413,11123,'el','ÎšÎ±Î¼Î¯Î± ÎµÎ¾Î®Î³Î·ÏƒÎ· Ï„Ï‰Î½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½',0),(400414,11123,'zh','æ²¡æœ‰ä¿¡ç”¨çš„è§£é‡Š\r\n',0),(400415,11123,'sv','Ingen kredit fÃ¶rklaring',0),(400416,11123,'it','Nessuna spiegazione di credito',0),(400417,11123,'tl','',0),(400418,11123,'th','à¸­à¸˜à¸´à¸šà¸²à¸¢à¹„à¸¡à¹ˆà¹€à¸„à¸£à¸”à¸´à¸•',0),(400419,11123,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¸à¥à¤ªà¤·à¥à¤Ÿà¥€à¤•à¤°à¤£',0),(400420,11123,'ms','Tiada penjelasan kredit',0),(400421,11123,'ar','Ø£ÙŠ ØªÙØ³ÙŠØ± Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(400422,11123,'fr','Aucune explication du crÃ©dit',0),(400423,11123,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã®èª¬æ˜Žãªã—',0),(400424,11123,'pt','Nenhuma explicaÃ§Ã£o de crÃ©dito',0),(400425,11123,'ru','ÐÐ¸ÐºÐ°ÐºÐ¸Ñ… Ð¾Ð±ÑŠÑÑÐ½ÐµÐ½Ð¸Ð¹ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(400426,11123,'es','No Hay ExplicaciÃ³n de CrÃ©dito',0),(400427,11123,'de','Keine Kredit-ErklÃ¤rung',0),(400428,11123,'en','No Credit Explanation',0),(400429,11124,'is','',0),(400430,11124,'dr','Ø¨Ø¯ÙˆÙ† Ø§Ø¹ØªØ¨Ø§Ø± ØªÙ…Ø¯ÙŠØ¯ Ø´Ø¯Ù‡ ',0),(400431,11124,'pr','Ø¨Ø¯ÙˆÙ† Ø§Ø¹ØªØ¨Ø§Ø± ØªÙ…Ø¯ÙŠØ¯ Ø´Ø¯Ù‡ ',0),(400432,11124,'tr','Ä°zin verilen kredi yok',0),(400433,11124,'pl','Nie wolno kredytu',0),(400434,11124,'bg','ÐÐµ ÑÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(400435,11124,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(400436,11124,'sr','ÐÐµÐ¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°, Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(400437,11124,'vi','khÃ´ng ghi cÃ³',0),(400438,11124,'af','Geen krediet toegelaat',0),(400439,11124,'ro','Nici un Credit permis',0),(400440,11124,'et','Ei ole lubatud krediiti',0),(400441,11124,'si','Å t Credit dovoljeno',0),(400442,11124,'ba','Tidak ada kredit yang diperbolehkan',0),(400443,11124,'nl','Geen krediet toegestaan',0),(400444,11124,'fi','Ei hyvitys',0),(400445,11124,'no','Ingen kreditt tillatt',0),(400446,11124,'da','Ingen kredit tilladt',0),(400447,11124,'ko','ìˆ˜ ì‹ ìš©',0),(400448,11124,'he','××™×Ÿ ××©×¨××™ ×ž×•×ª×¨',0),(400449,11124,'el','ÎšÎ±Î¼Î¯Î± Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ· ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(400450,11124,'zh','æ²¡æœ‰ä¿¡ç”¨å»¶ä¼¸\r\n',0),(400451,11124,'sv','Ingen kredit tillÃ¥tet',0),(400452,11124,'it','Nessun credito ammessi',0),(400453,11124,'tl','',0),(400454,11124,'th','à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(400455,11124,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(400456,11124,'ms','Tiada kredit yang dibenarkan',0),(400457,11124,'ar','ØºÙŠØ± Ù…Ø³Ù…ÙˆØ­ Ø¨Ø§Ù„Ø¯Ù‘ÙŠÙ† - Ø§Ù„ØªÙˆØ¶ÙŠØ­',0),(400458,11124,'fr','Aucun crÃ©dit accordÃ©',0),(400459,11124,'jp','è¨±å¯ãªã—ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰',0),(400460,11124,'pt','Nenhum crÃ©dito permitido',0),(400461,11124,'ru','ÐÐµ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(400462,11124,'es','No se Ofrezca CrÃ©ditos',0),(400463,11124,'de','Kein Kredit erlaubt',0),(400464,11124,'en','No Credit Allowed',0),(400465,11125,'is','',0),(400466,11125,'dr','(Ø³Ù†Ø¯Ø±Ø³Ù…Ù‰ Ú©Ù‡ Ø¨Ø¯Ø³Øª Ø´Ø®Øµ Ø«Ø§Ù„Ø«Ù‰ Ø³Ù¾Ø±Ø¯Ù‡ Ø´Ø¯Ù‡ Ùˆ Ù¾Ø³ Ø§Ø² Ø§Ù†Ø¬Ø§Ù… Ø´Ø±Ø·Ù‰ Ù‚Ø§Ø¨Ù„ Ø§Ø¬Ø±Ø§ÙŠØ§ Ù‚Ø§Ø¨Ù„ Ø§Ø¬Ø±Ø§ ÙŠØ§Ù‚Ø§Ø¨Ù„ Ø§Ø¨Ø·Ø§Ù„ Ø¨Ø§Ø´Ø¯',0),(400467,11125,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª(Ø³Ù†Ø¯Ø±Ø³Ù…Ù‰ Ú©Ù‡ Ø¨Ø¯Ø³Øª Ø´Ø®Øµ Ø«Ø§Ù„Ø«Ù‰ Ø³Ù¾Ø±Ø¯Ù‡ Ø´Ø¯Ù‡ Ùˆ Ù¾Ø³ Ø§Ø² Ø§Ù†Ø¬Ø§Ù… Ø´Ø±Ø·Ù‰ Ù‚Ø§Ø¨Ù„ Ø§Ø¬Ø±Ø§ÙŠØ§ Ù‚Ø§Ø¨Ù„ Ø§Ø¬Ø±Ø§ ÙŠØ§Ù‚Ø§Ø¨Ù„ Ø§Ø¨Ø·Ø§Ù„ Ø¨Ø§Ø´Ø¯',0),(400468,11125,'tr','Emlak vergisi Emanet',0),(400469,11125,'pl','Escrow prawdziwe podatku od nieruchomoÅ›ci',0),(400470,11125,'bg','Ð”Ð°Ð½ÑŠÐº Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¸ Ð¸Ð¼Ð¾Ñ‚Ð¸ ÐµÑÐºÑ€Ð¾Ñƒ',0),(400471,11125,'ur','Ø­Ù‚ÛŒÙ‚ÛŒ Ø§Ø³Ù¹ÛŒÙ¹ Ù¹ÛŒÚ©Ø³ ÛŒØ³Ú©Ø±Ùˆ',0),(400472,11125,'sr','ÐŸÑ€Ð°Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð•ÑÑ†Ñ€Ð¾w',0),(400473,11125,'vi','MÃ´i giá»›i báº¥t Ä‘á»™ng sáº£n thuáº¿',0),(400474,11125,'af','Vaste Eiendom Belasting Borg',0),(400475,11125,'ro','Real Estate fiscale Escrow',0),(400476,11125,'et','Real Estate maksu deponeerimine',0),(400477,11125,'si','Real Estate davka hrambi',0),(400478,11125,'ba','Real Estate pajak Escrow',0),(400479,11125,'nl','Real Estate Tax borg',0),(400480,11125,'fi','KiinteistÃ¶vero Escrow',0),(400481,11125,'no','Ekte eiendom skatt Escrow',0),(400482,11125,'da','Real Estate skat spÃ¦rrede',0),(400483,11125,'ko','ë¶€ë™ì‚° ì„¸ ì¡°ê±´ë¶€ ë‚ ì¸ ì¦ì„œ',0),(400484,11125,'he','×—×©×‘×•×Ÿ ×”×©×œ×©×” ×ž×¡ ×”×¢×™×–×‘×•×Ÿ ××ž×™×ª×™',0),(400485,11125,'el','ÎœÎµÏƒÎµÎ³Î³ÏÎ·ÏƒÎ·Ï‚ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÏŒ Ï†ÏŒÏÎ¿ Î¼ÎµÏ„Î±Î²Î¯Î²Î±ÏƒÎ·Ï‚ Î±ÎºÎ¹Î½Î®Ï„Ï‰Î½',0),(400486,11125,'zh','æˆ¿åœ°äº§ç¨Žä¸­ä»‹\r\n',0),(400487,11125,'sv','Verkliga fastighetsskatt Escrow',0),(400488,11125,'it','Real Estate Tax Escrow',0),(400489,11125,'tl','',0),(400490,11125,'th','à¹€à¸‰à¸žà¸²à¸°à¸ à¸²à¸©à¸µà¸­à¸ªà¸±à¸‡à¸«à¸²à¸£à¸´à¸¡à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ˆà¸£à¸´à¸‡',0),(400491,11125,'hi','à¤°à¤¿à¤¯à¤² à¤à¤¸à¥à¤Ÿà¥‡à¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤à¤¸à¥à¤•à¥à¤°à¥Œ',0),(400492,11125,'ms','Real Estate cukai Escrow',0),(400493,11125,'ar','Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø­Ù‚ÙŠÙ‚ÙŠ Ù…Ù† Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ©',0),(400494,11125,'fr','ImpÃ´t sur les biens rÃ©els Escrow',0),(400495,11125,'jp','ä¸å‹•ç”£ç¨Žã‚¨ã‚¹ã‚¯ãƒ­ãƒ¼',0),(400496,11125,'pt','Compromisso Real Estate Tax',0),(400497,11125,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³ Ð½Ð° Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(400498,11125,'es','GarantÃ­a en DepÃ³sito de Predial',0),(400499,11125,'de','Real Estate Tax Treuhand',0),(400500,11125,'en','Real Estate Tax Escrow',0),(400501,11126,'is','',0),(400502,11126,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª',0),(400503,11126,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª',0),(400504,11126,'tr','Emlak vergisi gideri',0),(400505,11126,'pl','Koszt rzeczywisty podatku od nieruchomoÅ›ci',0),(400506,11126,'bg','Ð”Ð°Ð½ÑŠÐº Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¸ Ð¸Ð¼Ð¾Ñ‚Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(400507,11126,'ur','Ø­Ù‚ÛŒÙ‚ÛŒ Ø§Ø³Ù¹ÛŒÙ¹ Ù¹ÛŒÚ©Ø³ Ø®Ø±Ú†Û’',0),(400508,11126,'sr','ÐŸÑ€Ð°Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð½ÐµÐºÑ€ÐµÑ‚Ð½Ð¸Ð½Ðµ Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð°',0),(400509,11126,'vi','Báº¥t Ä‘á»™ng sáº£n thuáº¿ chi phÃ­',0),(400510,11126,'af','Vaste Eiendom Belasting Uitgawe',0),(400511,11126,'ro','Real Estate fiscale cheltuieli',0),(400512,11126,'et','Real Estate maksukulu',0),(400513,11126,'si','Odhodek za davek Real Estate',0),(400514,11126,'ba','Real Estate pajak',0),(400515,11126,'nl','Real Estate belastinglasten',0),(400516,11126,'fi','KiinteistÃ¶vero kustannuksella',0),(400517,11126,'no','Real Estate skattekostnad',0),(400518,11126,'da','Real Estate skatteudgifter',0),(400519,11126,'ko','ë¶€ë™ì‚° ì„¸ê¸ˆ ë¹„ìš©',0),(400520,11126,'he','×”×•×¦××•×ª ×ž×¡ ×”×¢×™×–×‘×•×Ÿ ××ž×™×ª×™',0),(400521,11126,'el','Î”Î±Ï€Î¬Î½Î· Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÏŒ Ï†ÏŒÏÎ¿ Î¼ÎµÏ„Î±Î²Î¯Î²Î±ÏƒÎ·Ï‚ Î±ÎºÎ¹Î½Î®Ï„Ï‰Î½',0),(400522,11126,'zh','æˆ¿åœ°äº§æ‰€å¾—ç¨Žè´¹ç”¨\r\n',0),(400523,11126,'sv','Real Estate skattekostnad',0),(400524,11126,'it','Real Estate oneri',0),(400525,11126,'tl','',0),(400526,11126,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸ à¸²à¸©à¸µà¸­à¸ªà¸±à¸‡à¸«à¸²à¸£à¸´à¸¡à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ˆà¸£à¸´à¸‡',0),(400527,11126,'hi','à¤°à¤¿à¤¯à¤² à¤à¤¸à¥à¤Ÿà¥‡à¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤µà¥à¤¯à¤¯',0),(400528,11126,'ms','Perbelanjaan sebenar cukai harta',0),(400529,11126,'ar','Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ© Ø§Ù„Ø­Ù‚ÙŠÙ‚ÙŠØ©',0),(400530,11126,'fr','ImpÃ´ts sur Real Estate',0),(400531,11126,'jp','ä¸å‹•ç”£ç¨Žè²»ç”¨',0),(400532,11126,'pt','Despesa de imposto de propriedade real',0),(400533,11126,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð½Ð° Ð½Ð°Ð»Ð¾Ð³ Ð½Ð° Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(400534,11126,'es','Gastos de Predial',0),(400535,11126,'de','Real Estate Steueraufwand',0),(400536,11126,'en','Real Estate Tax Expense',0),(400537,11127,'is','',0),(400538,11127,'dr','Ø¨Ø¯Ù‡ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª',0),(400539,11127,'pr','Ø¨Ø¯Ù‡ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª',0),(400540,11127,'tr','Emlak vergisi yÃ¼kÃ¼mlÃ¼lÃ¼ÄŸÃ¼',0),(400541,11127,'pl','Real Estate podatku dochodowego',0),(400542,11127,'bg','Ð”Ð°Ð½ÑŠÐº Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¸ Ð¸Ð¼Ð¾Ñ‚Ð¸ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€Ð½Ð¾ÑÑ‚',0),(400543,11127,'ur','Ø­Ù‚ÛŒÙ‚ÛŒ Ø§Ø³Ù¹ÛŒÙ¹ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø°Ù…Û Ø¯Ø§Ø±ÛŒ',0),(400544,11127,'sr','ÐŸÑ€Ð°Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€Ð½Ð¾ÑÑ‚Ð¸',0),(400545,11127,'vi','Báº¥t Ä‘á»™ng sáº£n thuáº¿ trÃ¡ch nhiá»‡m phÃ¡p lÃ½',0),(400546,11127,'af','Vaste Eiendom Belasting Las',0),(400547,11127,'ro','Real Estate impozitul',0),(400548,11127,'et','Real Estate maksukohustus',0),(400549,11127,'si','Real Estate davÄne obveznosti',0),(400550,11127,'ba','Real Estate Pajak Perseroan',0),(400551,11127,'nl','Real Estate belastingverplichting',0),(400552,11127,'fi','KiinteistÃ¶vero vastuu',0),(400553,11127,'no','Real Estate skatteplikt',0),(400554,11127,'da','Real Estate skattepligt',0),(400555,11127,'ko','ë¶€ë™ì‚° ì„¸ê¸ˆ ì±…ìž„',0),(400556,11127,'he','×—×‘×•×ª ×ž×¡ ×Ÿ ××ž×™×ª×™',0),(400557,11127,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î± Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Ï…Ï€Î¿Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(400558,11127,'zh','æˆ¿åœ°äº§ç¨Žçš„æ³•å¾‹è´£ä»»\r\n',0),(400559,11127,'sv','Real Estate skatteskuld',0),(400560,11127,'it','Real Estate tributaria',0),(400561,11127,'tl','',0),(400562,11127,'th','à¸ à¸²à¸£à¸°à¸ à¸²à¸©à¸µà¸­à¸ªà¸±à¸‡à¸«à¸²à¸£à¸´à¸¡à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ˆà¸£à¸´à¸‡',0),(400563,11127,'hi','à¤°à¤¿à¤¯à¤² à¤à¤¸à¥à¤Ÿà¥‡à¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¦à¥‡à¤¯à¤¤à¤¾',0),(400564,11127,'ms','Real Estate cukai liabiliti',0),(400565,11127,'ar','Ø§Ù„Ø­Ù‚ÙŠÙ‚ÙŠØ© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ©',0),(400566,11127,'fr','Real Estate impÃ´t Ã  payer',0),(400567,11127,'jp','ä¸å‹•ç”£ç¨Žè²¬ä»»',0),(400568,11127,'pt','Responsabilidade Real Estate Tax',0),(400569,11127,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ',0),(400570,11127,'es','Responsabilidad para el Predial',0),(400571,11127,'de','Real Estate Steuerschuld',0),(400572,11127,'en','Real Estate Tax Liability',0),(400573,11128,'is','',0),(400574,11128,'dr','Ø§Ù†Ù‚Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(400575,11128,'pr','Ø§Ù†Ù‚Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(400576,11128,'tr','Kira sona erme kurallarÄ±',0),(400577,11128,'pl','Wygasania umowy najmu',0),(400578,11128,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Expirations',0),(400579,11128,'ur','Ù„ÛŒØ² Ù¾Ø§Ø±Ø§Ù¹Ø§Ù†Ø³',0),(400580,11128,'sr','ÐÐ°Ñ˜Ð°Ð¼ Ð•xÐ¿Ð¸Ñ€Ð°Ñ‚Ð¸Ð¾Ð½Ñ',0),(400581,11128,'vi','gia háº¡n há»£p Ä‘á»“ng thuÃª',0),(400582,11128,'af','Huurkontrak Expirations',0),(400583,11128,'ro','ExpirÄƒrile de leasing',0),(400584,11128,'et','Liisingu Expirations',0),(400585,11128,'si','Izteku roka najema',0),(400586,11128,'ba','Sewa Expirations',0),(400587,11128,'nl','Lease verloopt',0),(400588,11128,'fi','Vuokrasopimuksen vanhenemista',0),(400589,11128,'no','Leieavtale utlÃ¸per',0),(400590,11128,'da','Lease afvisninger',0),(400591,11128,'ko','ìž„ëŒ€ ë§Œë£Œ',0),(400592,11128,'he','×©×›×™×¨×•×ª ×ª×¤×•×’×•×ª',0),(400593,11128,'el','Î›Î®Î³ÎµÎ¹ Î· Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·',0),(400594,11128,'zh','ç§Ÿçº¦åˆ°æœŸæ—¶é—´\r\n',0),(400595,11128,'sv','Hyresavtalet fÃ¶rfallodagar',0),(400596,11128,'it','Scadenze del contratto di locazione',0),(400597,11128,'tl','',0),(400598,11128,'th','à¸«à¸¡à¸”à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(400599,11128,'hi','à¤²à¥€à¤œ à¤¨à¤¿à¤¶à¥à¤µà¤¾à¤¸à¤¿à¤¤',0),(400600,11128,'ms','Penutupan pajakan',0),(400601,11128,'ar','Ø§Ù†ØªÙ‡Ø§Ø¡ ØµÙ„Ø§Ø­ÙŠØ© Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(400602,11128,'fr','Expiration du bail',0),(400603,11128,'jp','ãƒªãƒ¼ã‚¹ã®æœ‰åŠ¹æœŸé™',0),(400604,11128,'pt','ExpiraÃ§Ãµes de locaÃ§Ã£o',0),(400605,11128,'ru','Ð˜ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ðµ ÑÑ€Ð¾ÐºÐ° Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(400606,11128,'es','Vencimiento de Arrendamientos',0),(400607,11128,'de','Leasing Ablaufzeiten',0),(400608,11128,'en','Lease Expirations',0),(400609,11129,'is','',0),(400610,11129,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(400611,11129,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(400612,11129,'tr','Emlak detaylarÄ±',0),(400613,11129,'pl','NieruchomoÅ›ci',0),(400614,11129,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð·Ð° Ð¸Ð¼Ð¾Ñ‚',0),(400615,11129,'ur','Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(400616,11129,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¾ Ð½ÐµÐºÑ€ÐµÑ‚Ð½Ð¸Ð½Ð¸',0),(400617,11129,'vi','Báº¥t Ä‘á»™ng sáº£n thÃ´ng tin chi tiáº¿t',0),(400618,11129,'af','Eiendom Beskrywings',0),(400619,11129,'ro','Detalii proprietate',0),(400620,11129,'et','Kinnisvara Details',0),(400621,11129,'si','VeÄ o nepremiÄnini',0),(400622,11129,'ba','Detail properti',0),(400623,11129,'nl','Eigenschap Details',0),(400624,11129,'fi','KiinteistÃ¶n yksityiskohdat',0),(400625,11129,'no','Bolig detaljer',0),(400626,11129,'da','Ejendom detaljer',0),(400627,11129,'ko','ìž¬ì‚° ì„¸ë¶€ ì‚¬í•­',0),(400628,11129,'he','×¤×¨×˜×™ ×”× ×›×¡',0),(400629,11129,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î‘ÎºÎ¹Î½Î®Ï„Î¿Ï…',0),(400630,11129,'zh','ç‰©ä¸šèµ„æ–™\r\n',0),(400631,11129,'sv','Egenskapen Detaljer',0),(400632,11129,'it','ProprietÃ  dettagli',0),(400633,11129,'tl','',0),(400634,11129,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(400635,11129,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(400636,11129,'ms','Butir-butir harta',0),(400637,11129,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ù„ÙƒÙŠØ©',0),(400638,11129,'fr','DÃ©tails de propriÃ©tÃ©',0),(400639,11129,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®è©³ç´°',0),(400640,11129,'pt','Detalhes da propriedade',0),(400641,11129,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(400642,11129,'es','Detalles del Propiedad',0),(400643,11129,'de','Details zu Eigenschaften',0),(400644,11129,'en','Property Details',0),(400645,11130,'is','',0),(400646,11130,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù†Ø§Ù…Ù‡ ',0),(400647,11130,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù†Ø§Ù…Ù‡ ',0),(400648,11130,'tr','Kira rulo',0),(400649,11130,'pl','Wynajem buÅ‚ka',0),(400650,11130,'bg','ÐÐ°ÐµÐ¼ Ñ€Ð¾Ð»ÐºÐ°',0),(400651,11130,'ur','Ú©Ø±Ø§Ø¦Û’ Ú©Û’ Ø±ÙˆÙ„',0),(400652,11130,'sr','ÐÐ°Ñ˜Ð°Ð¼ Ð Ð¾Ð»Ð»',0),(400653,11130,'vi','danh sÃ¡ch thuÃª',0),(400654,11130,'af','Huur rol',0),(400655,11130,'ro','Chirie Roll',0),(400656,11130,'et','ÃœÃ¼ri rulli',0),(400657,11130,'si','Najem Roll',0),(400658,11130,'ba','Sewa Roll',0),(400659,11130,'nl','Huur Roll',0),(400660,11130,'fi','Vuokrattavana Roll',0),(400661,11130,'no','Leie Roll',0),(400662,11130,'da','Leje Roll',0),(400663,11130,'ko','ì§‘ ì„¸ ë¡¤',0),(400664,11130,'he','×”×©×›×¨×” ×¨×•×œ',0),(400665,11130,'el','Î•Î½Î¿Î¹ÎºÎ¯Î±ÏƒÎ· Roll',0),(400666,11130,'zh','åœ°ç§Ÿç™»è®°å†Œ\r\n',0),(400667,11130,'sv','Hyra rulle',0),(400668,11130,'it','Affitto Roll',0),(400669,11130,'tl','',0),(400670,11130,'th','à¸¡à¹‰à¸§à¸™à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²',0),(400671,11130,'hi','à¤¬à¤¾à¤‡à¤• à¤•à¤¿à¤°à¤¾à¤ à¤ªà¤° à¤°à¥‹à¤²',0),(400672,11130,'ms','Sewa Roll',0),(400673,11130,'ar','Ù„ÙØ© Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(400674,11130,'fr','Location rouleau',0),(400675,11130,'jp','ãƒ¬ãƒ³ã‚¿ãƒ« ãƒ­ãƒ¼ãƒ«',0),(400676,11130,'pt','Rolo de aluguel',0),(400677,11130,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ñ€Ð¾Ð»Ð»',0),(400678,11130,'es','Lista de Rentas',0),(400679,11130,'de','Miete Roll',0),(400680,11130,'en','Rent Roll',0),(400681,11131,'is','',0),(400682,11131,'dr','Ù„ØºÙˆ Ø´Ø¯Ù‡  ÙŠØ§ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ ',0),(400683,11131,'pr','Ù„ØºÙˆ Ø´Ø¯Ù‡  ÙŠØ§ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ ',0),(400684,11131,'tr','Ä°ptal veya iÅŸten Ã§Ä±karÄ±lan kiralar',0),(400685,11131,'pl','UniewaÅ¼nienia lub rozwiÄ…zania umowy najmu',0),(400686,11131,'bg','ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ð¸ Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÐµÐ½Ð¸Ñ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(400687,11131,'ur','Ø±ÛŒØ³Ú©Ø§Ù†ÚˆØ¯ ÛŒØ§ Ù…Ù†Ù‚Ø·Ø¹ Ù„ÙÛŒØ²Ø²',0),(400688,11131,'sr','ÐžÐ´Ð±Ð¸Ñ˜ÐµÐ½Ð° Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐºÐ¸Ð½ÑƒÐ¾ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(400689,11131,'vi','há»§y bá» hoáº·c cháº¥m dá»©t há»£p Ä‘á»“ng thuÃª',0),(400690,11131,'af','Geskik of beÃ«indig huurooreenkomste',0),(400691,11131,'ro','Contracte de leasing anulate sau reziliat',0),(400692,11131,'et','TÃ¼histatud vÃµi lÃµpetatud rent',0),(400693,11131,'si','Kupnine ali prekinjeni najemi',0),(400694,11131,'ba','Sewa dicabut atau dihentikan',0),(400695,11131,'nl','Ingetrokken of beÃ«indigd veroorzakende Leases',0),(400696,11131,'fi','Purkaa myyntisopimusta tai irtisanotusta vuokrasopimukset',0),(400697,11131,'no','Opphevet eller avsluttet leieavtaler',0),(400698,11131,'da','Opsagte eller opsagte leasingkontrakter',0),(400699,11131,'ko','íì§€ ë˜ëŠ” ì¢…ë£Œ ëœ ìž„ëŒ€',0),(400700,11131,'he','×—×›×™×¨×” ×œ×‘×˜×œ ××• ×”×¡×ª×™×™×',0),(400701,11131,'el','Î‘Î½Î±ÎºÎ±Î»ÎµÏƒÎ¼Î­Î½Î¿Ï‚ Î® ÎºÎ±Ï„Î±Î³Î³ÎµÎ»Î¸ÎµÎ¯ÏƒÎ±Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(400702,11131,'zh','æ’¤é”€æˆ–ç»ˆæ­¢ç§Ÿçº¦\r\n',0),(400703,11131,'sv','UpphÃ¤vt eller avslutade hyresavtal',0),(400704,11131,'it','Revocata o terminati contratti di locazione',0),(400705,11131,'tl','',0),(400706,11131,'th','à¹€à¸Šà¹ˆà¸² rescinded à¸«à¸£à¸·à¸­à¸«à¸¢à¸¸à¸”à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™',0),(400707,11131,'hi','à¤°à¥à¤• à¤¯à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤•à¤¿à¤ à¤—à¤ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚',0),(400708,11131,'ms','Pajakan ditarik balik atau ditamatkan',0),(400709,11131,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±Ø§Øª Ù†Ø³Ø®Ù‡Ø§ Ø£Ùˆ Ø£Ù†Ù‡ÙŠØª',0),(400710,11131,'fr','Baux annulÃ© ou rÃ©siliÃ©',0),(400711,11131,'jp','å–ã‚Šæ¶ˆã—ã¾ãŸã¯çµ‚äº†ã—ãŸãƒªãƒ¼ã‚¹',0),(400712,11131,'pt','LocaÃ§Ãµes rescisÃ£o ou rescindidas',0),(400713,11131,'ru','ÐžÑ‚Ð¼ÐµÐ½ÑÑŽÑ‚ÑÑ Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‰ÐµÐ½Ð½Ñ‹Ñ… Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð¾Ð² Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(400714,11131,'es','Arrendamientos Rescindidos o Terminados',0),(400715,11131,'de','Widerrufen oder beendet Adressleases',0),(400716,11131,'en','Rescinded or Terminated Leases',0),(400717,11132,'is','',0),(400718,11132,'dr','Ø¢ÙŠØ§ Ø§ÙŠÙ† ÙŠÙƒ Ø´Ø±ÙƒØª Ù…Ø´ØªØ±ÙŠ Ø§Ø³Øª ',0),(400719,11132,'pr','Ø¢ÙŠØ§ Ø§ÙŠÙ† ÙŠÙƒ Ø´Ø±ÙƒØª Ù…Ø´ØªØ±ÙŠ Ø§Ø³Øª ',0),(400720,11132,'tr','Bu bir mÃ¼ÅŸteri ÅŸirket mi',0),(400721,11132,'pl','Jest to firma klienta',0),(400722,11132,'bg','Ð¢Ð¾Ð²Ð° Ðµ Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð°-ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(400723,11132,'ur','ÛŒÛ Ø§ÛŒÚ© Ú©Ù„Ø§Ø¦Ù†Ù¹ Ú©ÛŒ Ú©Ù…Ù¾Ù†ÛŒ ÛÛ’',0),(400724,11132,'sr','Ð”Ð° Ð»Ð¸ Ñ˜Ðµ Ð¾Ð²Ð¾ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ðµ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(400725,11132,'vi','ÄÃ¢y cÃ³ pháº£i lÃ  má»™t cÃ´ng ty khÃ¡ch hÃ ng',0),(400726,11132,'af','Is Dit \'n Klient Onderneming?',0),(400727,11132,'ro','Aceasta este o companie de Client',0),(400728,11132,'et','Kas see klient firma',0),(400729,11132,'si','Je to podjetje odjemalec',0),(400730,11132,'ba','Apakah ini sebuah perusahaan klien',0),(400731,11132,'nl','Is dit een opdrachtgever',0),(400732,11132,'fi','Onko tÃ¤mÃ¤ asiakas yritys',0),(400733,11132,'no','Er dette en klient selskapet',0),(400734,11132,'da','Er dette en klient selskab',0),(400735,11132,'ko','ì´ í´ë¼ì´ì–¸íŠ¸ íšŒì‚¬',0),(400736,11132,'he','? ×”×× ×–×” ×—×‘×¨×” ×œ×§×•×—',0),(400737,11132,'el','Î ÏÏŒÎºÎµÎ¹Ï„Î±Î¹ Î³Î¹Î± Î¼Î¹Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±-Ï€ÎµÎ»Î¬Ï„Î·',0),(400738,11132,'zh','è¿™æ˜¯ä¸€ä¸ªå®¢æˆ·å…¬å¸\r\n',0),(400739,11132,'sv','Ã„r detta ett klient-fÃ¶retag',0),(400740,11132,'it','Ãˆ questo un cliente azienda',0),(400741,11132,'tl','',0),(400742,11132,'th','à¸™à¸µà¹ˆ à¸šà¸£à¸´à¸©à¸±à¸—à¹„à¸„à¸¥à¹€à¸­à¸™à¸•à¹Œà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(400743,11132,'hi','à¤¯à¤¹ à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤‚à¤ªà¤¨à¥€ à¤¹à¥ˆ',0),(400744,11132,'ms','Adakah ini sebuah syarikat pelanggan',0),(400745,11132,'ar','Ù‡Ø°Ø§ Ù‡Ùˆ Ø´Ø±ÙƒØ© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(400746,11132,'fr','Est-ce une entreprise cliente',0),(400747,11132,'jp','ã“ã‚Œã¯ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆä¼æ¥­ã§ã™ã€‚',0),(400748,11132,'pt','Isto Ã© uma empresa de cliente',0),(400749,11132,'ru','Ð­Ñ‚Ð¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸-ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(400750,11132,'es','Â¿Es una Empresa Cliente',0),(400751,11132,'de','Ist das ein Kundenunternehmen',0),(400752,11132,'en','Is This a Client Company',0),(400753,11133,'is','',0),(400754,11133,'dr','ØªØ¨ØµØ±Ù‡ Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡ ',0),(400755,11133,'pr','ØªØ¨ØµØ±Ù‡ Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡ ',0),(400756,11133,'tr','Lease notlar',0),(400757,11133,'pl','DzierÅ¼awy notatki',0),(400758,11133,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(400759,11133,'ur','Ù„ÛŒØ² Ù†ÙˆÙ¹',0),(400760,11133,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(400761,11133,'vi','Ghi chÃº cho thuÃª',0),(400762,11133,'af','Huurkontrak Notas',0),(400763,11133,'ro','Note de leasing',0),(400764,11133,'et','ÃœÃ¼rilepingu mÃ¤rkmed',0),(400765,11133,'si','Zakup opombe',0),(400766,11133,'ba','Sewa catatan',0),(400767,11133,'nl','Lease notities',0),(400768,11133,'fi','Vuokrasopimuksen toteaa',0),(400769,11133,'no','Leieavtalen notater',0),(400770,11133,'da','Lease noter',0),(400771,11133,'ko','ìž„ëŒ€ ì£¼',0),(400772,11133,'he','×©×›×™×¨×•×ª ×”×¢×¨×•×ª',0),(400773,11133,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(400774,11133,'zh','ç§Ÿèµå€ºåˆ¸\r\n',0),(400775,11133,'sv','Hyresavtalet anteckningar',0),(400776,11133,'it','Note di contratto di locazione',0),(400777,11133,'tl','',0),(400778,11133,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(400779,11133,'hi','à¤²à¥€à¤œ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(400780,11133,'ms','Nota-Nota pajakan',0),(400781,11133,'ar','ÙˆØªÙ„Ø§Ø­Ø¸ Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(400782,11133,'fr','Informations sur la location',0),(400783,11133,'jp','ãƒªãƒ¼ã‚¹ ãƒŽãƒ¼ãƒˆ',0),(400784,11133,'pt','Notas de locaÃ§Ã£o',0),(400785,11133,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(400786,11133,'es','Notas de Arrendamientos',0),(400787,11133,'de','Leasing-Notes',0),(400788,11133,'en','Lease Notes',0),(400789,11134,'is','',0),(400790,11134,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(400791,11134,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(400792,11134,'tr','Kredi kartÄ± ekleme',0),(400793,11134,'pl','Dodawanie karty kredytowej',0),(400794,11134,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(400795,11134,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(400796,11134,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(400797,11134,'vi','ThÃªm tháº» TÃ­n dá»¥ng',0),(400798,11134,'af','Kredietkaart Byvoeg',0),(400799,11134,'ro','Adauga Card de Credit',0),(400800,11134,'et','Lisa krediitkaart',0),(400801,11134,'si','Dodaj kreditne kartice',0),(400802,11134,'ba','Menambahkan kartu kredit',0),(400803,11134,'nl','Creditcard toevoegen',0),(400804,11134,'fi','Luottokortin lisÃ¤Ã¤minen',0),(400805,11134,'no','Legger til kredittkort',0),(400806,11134,'da','TilfÃ¸j kreditkort',0),(400807,11134,'ko','ì‹ ìš© ì¹´ë“œ ì¶”ê°€',0),(400808,11134,'he','×”×•×¡×£ ×›×¨×˜×™×¡ ××©×¨××™',0),(400809,11134,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(400810,11134,'zh','å¢žåŠ ä¿¡ç”¨å¡\r\n',0),(400811,11134,'sv','LÃ¤gg till kreditkort',0),(400812,11134,'it','Aggiungi carta di credito',0),(400813,11134,'tl','',0),(400814,11134,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(400815,11134,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(400816,11134,'ms','Tambah kad kredit',0),(400817,11134,'ar','Ø¥Ø¶Ø§ÙØ© Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(400818,11134,'fr','Ajouter la carte de crÃ©dit',0),(400819,11134,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(400820,11134,'pt','Adicionar cartÃ£o de crÃ©dito',0),(400821,11134,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½ÑƒÑŽ ÐšÐ°Ñ€Ñ‚Ñƒ',0),(400822,11134,'es','Agregar Tarjeta de CrÃ©dito',0),(400823,11134,'de','Kreditkarte hinzufÃ¼gen',0),(400824,11134,'en','Add Credit Card',0),(400825,11135,'is','',0),(400826,11135,'dr','ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(400827,11135,'pr','ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(400828,11135,'tr','Kredi kartlarÄ±',0),(400829,11135,'pl','Karty kredytowe',0),(400830,11135,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(400831,11135,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ',0),(400832,11135,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(400833,11135,'vi','tháº» tÃ­n dá»¥ng',0),(400834,11135,'af','Kredietkaarte',0),(400835,11135,'ro','Carduri de credit',0),(400836,11135,'et','Krediitkaardid',0),(400837,11135,'si','Kreditne kartice',0),(400838,11135,'ba','Kartu kredit',0),(400839,11135,'nl','Credit Cards',0),(400840,11135,'fi','Luottokortit',0),(400841,11135,'no','Kredittkort',0),(400842,11135,'da','Kreditkort',0),(400843,11135,'ko','ì‹ ìš© ì¹´ë“œ',0),(400844,11135,'he','×›×¨×˜×™×¡×™ ××©×¨××™',0),(400845,11135,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(400846,11135,'zh','ä¿¡ç”¨å¡\r\n',0),(400847,11135,'sv','Kreditkort',0),(400848,11135,'it','Carte di credito',0),(400849,11135,'tl','',0),(400850,11135,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(400851,11135,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡',0),(400852,11135,'ms','Kad-kad kredit',0),(400853,11135,'ar','Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(400854,11135,'fr','Cartes de crÃ©dit',0),(400855,11135,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰',0),(400856,11135,'pt','CartÃµes de crÃ©dito',0),(400857,11135,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐšÐ°Ñ€Ñ‚Ñ‹',0),(400858,11135,'es','Tarjetas de CrÃ©dito',0),(400859,11135,'de','Kreditkarten',0),(400860,11135,'en','Credit Cards',0),(400861,11136,'is','',0),(400862,11136,'dr','Ø¯Ø³ØªÙˆØ± Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(400863,11136,'pr','Ø¯Ø³ØªÙˆØ± Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(400864,11136,'tr','Kredi kartlarÄ± yÃ¶nergeleri',0),(400865,11136,'pl','Instrukcje karty kredytowe',0),(400866,11136,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(400867,11136,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ ÛØ¯Ø§ÛŒØ§Øª',0),(400868,11136,'sr','Ð£Ð¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(400869,11136,'vi','hÆ°á»›ng dáº«n tháº» tÃ­n dá»¥ng',0),(400870,11136,'af','Kredietkaarte Instruksies',0),(400871,11136,'ro','InstrucÅ£iuni de carduri de credit',0),(400872,11136,'et','Krediitkaartide juhiseid',0),(400873,11136,'si','Kreditne kartice navodila',0),(400874,11136,'ba','Kartu kredit petunjuk',0),(400875,11136,'nl','Creditcards instructies',0),(400876,11136,'fi','Luottokortti ohjeet',0),(400877,11136,'no','Kort instruksjoner',0),(400878,11136,'da','Kreditkort instruktioner',0),(400879,11136,'ko','ì‹ ìš© ì¹´ë“œ ì§€ì¹¨',0),(400880,11136,'he','×”×•×¨××•×ª ×›×¨×˜×™×¡×™ ××©×¨××™',0),(400881,11136,'el','ÎŸÎ´Î·Î³Î¯ÎµÏ‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(400882,11136,'zh','ä¿¡ç”¨å¡è¯´æ˜Ž\r\n',0),(400883,11136,'sv','Kreditkort instruktioner',0),(400884,11136,'it','Istruzioni di carte di credito',0),(400885,11136,'tl','',0),(400886,11136,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(400887,11136,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(400888,11136,'ms','Kad kredit arahan',0),(400889,11136,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(400890,11136,'fr','Instructions de cartes de crÃ©dit',0),(400891,11136,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®æŒ‡ç¤º',0),(400892,11136,'pt','InstruÃ§Ãµes de cartÃµes de crÃ©dito',0),(400893,11136,'ru','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ðš ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¼ ÐšÐ°Ñ€Ñ‚Ð°Ð¼',0),(400894,11136,'es','Instrucciones de Tarjetas de CrÃ©dito',0),(400895,11136,'de','Kreditkarten-Anweisungen',0),(400896,11136,'en','Credit Cards Instructions',0),(400897,11137,'is','',0),(400898,11137,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(400899,11137,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(400900,11137,'tr','Kredi kartÄ± baÅŸarÄ±yla eklendi',0),(400901,11137,'pl','PomyÅ›lnie dodano kartÄ™ kredytowÄ…',0),(400902,11137,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(400903,11137,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(400904,11137,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(400905,11137,'vi','ÄÃ£ thÃªm tháº» tÃ­n dá»¥ng thÃ nh cÃ´ng',0),(400906,11137,'af','Kredietkaart Suksesvol Geskep',0),(400907,11137,'ro','Card de credit adÄƒugat cu succes',0),(400908,11137,'et','Lisatud krediitkaardi',0),(400909,11137,'si','Kreditne kartice, uspeÅ¡no dodani',0),(400910,11137,'ba','Kartu kredit yang ditambahkan berhasil',0),(400911,11137,'nl','Creditcard met succes toegevoegd',0),(400912,11137,'fi','Luottokortin lisÃ¤Ã¤minen onnistui',0),(400913,11137,'no','Kredittkort lagt',0),(400914,11137,'da','Kreditkort tilfÃ¸jet',0),(400915,11137,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ëœ ì‹ ìš© ì¹´ë“œ',0),(400916,11137,'he','×›×¨×˜×™×¡ ××©×¨××™ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(400917,11137,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(400918,11137,'zh','ä¿¡ç”¨å¡æ·»åŠ æˆåŠŸ\r\n',0),(400919,11137,'sv','Kreditkort som lagts',0),(400920,11137,'it','Carta di credito aggiunto con successo',0),(400921,11137,'tl','',0),(400922,11137,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(400923,11137,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(400924,11137,'ms','Kad kredit yang berjaya menambah',0),(400925,11137,'ar','Ø£Ø¶ÙŠÙØª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¨Ù†Ø¬Ø§Ø­',0),(400926,11137,'fr','Carte de crÃ©dit a ajoutÃ© avec succÃ¨s',0),(400927,11137,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(400928,11137,'pt','CartÃ£o de crÃ©dito adicionado com sucesso',0),(400929,11137,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ ÐšÐ°Ñ€Ñ‚Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð°',0),(400930,11137,'es','Tarjeta de CrÃ©dito Agregada Exitosamente',0),(400931,11137,'de','Kreditkarte erfolgreich hinzugefÃ¼gt',0),(400932,11137,'en','Credit Card Added Successfully',0),(400933,11138,'is','',0),(400934,11138,'dr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(400935,11138,'pr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(400936,11138,'tr','Kredi kartÄ± baÅŸarÄ±yla silindi',0),(400937,11138,'pl','Karta kredytowa przesâ”‚anie',0),(400938,11138,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(400939,11138,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(400940,11138,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(400941,11138,'vi','Ä‘Ã£ xÃ³a tháº» tÃ­n dá»¥ng thÃ nh cÃ´ng',0),(400942,11138,'af','Kredietkaartkoste Suksesvol Geskrap',0),(400943,11138,'ro','Credit Card È™ters cu succes',0),(400944,11138,'et','Edukalt kustutatud krediitkaardi',0),(400945,11138,'si','Kreditne kartice, uspeÅ¡no izbrisana',0),(400946,11138,'ba','Kartu kredit yang berhasil dihapus',0),(400947,11138,'nl','Creditcard met succes verwijderd',0),(400948,11138,'fi','Luottokortin poistettu',0),(400949,11138,'no','Kredittkort slettet',0),(400950,11138,'da','Kreditkort slettet',0),(400951,11138,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì‹ ìš© ì¹´ë“œ',0),(400952,11138,'he','×›×¨×˜×™×¡ ××©×¨××™ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(400953,11138,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(400954,11138,'zh','ä¿¡ç”¨å¡æˆåŠŸåˆ é™¤\r\n',0),(400955,11138,'sv','Kreditkort raderades',0),(400956,11138,'it','Carta di credito eliminato con successo',0),(400957,11138,'tl','',0),(400958,11138,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸–à¸¹à¸à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(400959,11138,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(400960,11138,'ms','Kad kredit dihapuskan dengan jayanya',0),(400961,11138,'ar','Ø­Ø°ÙØª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¨Ù†Ø¬Ø§Ø­',0),(400962,11138,'fr','Carte de crÃ©dit supprimÃ© avec succÃ¨s',0),(400963,11138,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(400964,11138,'pt','CartÃ£o de crÃ©dito excluÃ­do com sucesso',0),(400965,11138,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ ÐšÐ°Ñ€Ñ‚Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð£Ð´Ð°Ð»ÐµÐ½Ð°',0),(400966,11138,'es','Tarjeta de CrÃ©dito Eliminada Exitosamente',0),(400967,11138,'de','Kreditkarte erfolgreich gelÃ¶scht',0),(400968,11138,'en','Credit Card Deleted Successfully',0),(400969,11139,'is','',0),(400970,11139,'dr','ØªØ§Ø±ÙŠØ® Ø§Ù†Ù‚Ø¶Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø®Ø§Ø±Ø¬ Ø§Ø² Ù…Ø­Ø¯ÙˆØ¯Ù‡ ',0),(400971,11139,'pr','ØªØ§Ø±ÙŠØ® Ø§Ù†Ù‚Ø¶Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø®Ø§Ø±Ø¬ Ø§Ø² Ù…Ø­Ø¯ÙˆØ¯Ù‡ ',0),(400972,11139,'tr','Kredi kartÄ± sona erme tarihi aralÄ±k dÄ±ÅŸÄ±nda',0),(400973,11139,'pl','Data waÅ¼noÅ›ci karty kredytowej z zakresu',0),(400974,11139,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° ÑÐ²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð° Ð¸Ð·Ð²ÑŠÐ½ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð°',0),(400975,11139,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ø³Û’ Ø¨Ø§ÛØ±',0),(400976,11139,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸ÑÑ‚ÐµÐºÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ñƒ Ð´Ð¾Ð¼ÐµÑ‚Ñƒ',0),(400977,11139,'vi','gia háº¡n tháº» tÃ­n dá»¥ng ngoÃ i vÃ¹ng',0),(400978,11139,'af','Kredietkaart verstryking datum buite bestek',0),(400979,11139,'ro','Data de expirare a cardului de credit din gama',0),(400980,11139,'et','Krediitkaardi aegumiskuupÃ¤eva vahemikust vÃ¤ljas',0),(400981,11139,'si','Datum zapadlosti kreditne kartice zunaj obsega',0),(400982,11139,'ba','Tanggal kadaluarsa kartu kredit di luar jangkauan',0),(400983,11139,'nl','Creditcard vervaldatum buiten het bereik',0),(400984,11139,'fi','Luottokortin vanhenemispÃ¤ivÃ¤ alueen ulkopuolella',0),(400985,11139,'no','UtlÃ¸psdato for kredittkort utenfor omrÃ¥det',0),(400986,11139,'da','Kreditkort udlÃ¸bsdato uden for rÃ¦kkevidde',0),(400987,11139,'ko','ì‹ ìš© ì¹´ë“œ ë§Œë£Œ ë‚ ì§œ ë²”ìœ„ë¥¼ ë²—ì–´ë‚¬ìŠµë‹ˆë‹¤.',0),(400988,11139,'he','×ª××¨×™×š ×ª×¤×•×’×ª ×”×›×¨×˜×™×¡ ××©×¨××™ ×ž×—×•×¥ ×œ×˜×•×•×—',0),(400989,11139,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï„Î·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ Î±Ï€ÏŒ Ï„Î· ÏƒÎµÎ¹ÏÎ¬',0),(400990,11139,'zh','ä¿¡ç”¨å¡åˆ°æœŸæ—¥æœŸè¶…å‡ºèŒƒå›´\r\n',0),(400991,11139,'sv','Kreditkort utandning datum utanfÃ¶r intervallet',0),(400992,11139,'it','Data di scadenza carta di credito fuori dalla portata',0),(400993,11139,'tl','',0),(400994,11139,'th','à¸§à¸±à¸™à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸™à¸­à¸à¸Šà¹ˆà¸§à¸‡',0),(400995,11139,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤¬à¤¾à¤¹à¤°',0),(400996,11139,'ms','Tarikh tamat tempoh kad kredit di luar julat',0),(400997,11139,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ ØµÙ„Ø§Ø­ÙŠØ© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø®Ø§Ø±Ø¬ Ø§Ù„Ù†Ø·Ø§Ù‚',0),(400998,11139,'fr','Date d\'Expiration de carte de crÃ©dit hors de portÃ©e',0),(400999,11139,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®æœ‰åŠ¹æœŸé™æ—¥ä»˜ãŒç¯„å›²å¤–',0),(401000,11139,'pt','Data de validade de cartÃ£o de crÃ©dito fora do alcance',0),(401001,11139,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð”Ð°Ñ‚Ð° Ð¸ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ñ Ð´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð¾Ð³Ð¾ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð°',0),(401002,11139,'es','Fecha de Venciiento de Tarjeta de CrÃ©dito Afuera del Rango',0),(401003,11139,'de','Kreditkarte gÃ¼ltig bis auÃŸerhalb des gÃ¼ltigen Bereichs',0),(401004,11139,'en','Credit Card Expiration Date Out of Range',0),(401005,11140,'is','',0),(401006,11140,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(401007,11140,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(401008,11140,'tr','Kredi kartÄ± yardÄ±m',0),(401009,11140,'pl','Pomocy karta kredytowa',0),(401010,11140,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(401011,11140,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ù…Ø¯Ø¯',0),(401012,11140,'sr','ÐŸÐ¾Ð¼Ð¾Ñ› Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(401013,11140,'vi','trá»£ giÃºp tháº» tÃ­n dá»¥ng',0),(401014,11140,'af','Kredietkaart Hulp',0),(401015,11140,'ro','Ajutor de Card de credit',0),(401016,11140,'et','Krediitkaardi spikker',0),(401017,11140,'si','Kreditna kartica pomoÄ',0),(401018,11140,'ba','Bantuan kartu kredit',0),(401019,11140,'nl','Creditcard Help',0),(401020,11140,'fi','Luottokortilla apua',0),(401021,11140,'no','Kredittkort hjelp',0),(401022,11140,'da','Kreditkort hjÃ¦lp',0),(401023,11140,'ko','ì‹ ìš© ì¹´ë“œ ë„ì›€ë§',0),(401024,11140,'he','×›×¨×˜×™×¡ ××©×¨××™ ×¢×–×¨×”',0),(401025,11140,'el','Î’Î¿Î®Î¸ÎµÎ¹Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(401026,11140,'zh','ä¿¡ç”¨å¡å¸®åŠ©\r\n',0),(401027,11140,'sv','Kreditkort hjÃ¤lp',0),(401028,11140,'it','Aiuto carta di credito',0),(401029,11140,'tl','',0),(401030,11140,'th','à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(401031,11140,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤®à¤¦à¤¦',0),(401032,11140,'ms','Bantuan kad kredit',0),(401033,11140,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(401034,11140,'fr','Aide de la carte de crÃ©dit',0),(401035,11140,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ ãƒ˜ãƒ«ãƒ—',0),(401036,11140,'pt','Ajuda do cartÃ£o de crÃ©dito',0),(401037,11140,'ru','ÐŸÐ¾Ð¼Ð¾Ñ‰ÑŒ Ð¡ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ð¾Ð¹',0),(401038,11140,'es','Ayuda de Tarjeta de CrÃ©dito',0),(401039,11140,'de','Kreditkarte Hilfe',0),(401040,11140,'en','Credit Card Help',0),(401041,11141,'is','',0),(401042,11141,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„Ù‡Ø§ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(401043,11141,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„Ù‡Ø§ÙŠ Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(401044,11141,'tr','Kredi kartÄ± yardÄ±m talimatlarÄ±nÄ±',0),(401045,11141,'pl','Karta kredytowa pomocy instrukcji',0),(401046,11141,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(401047,11141,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ù…Ø¯Ø¯ ÛØ¯Ø§ÛŒØ§Øª',0),(401048,11141,'sr','Ð£Ð¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð·Ð° Ð¿Ð¾Ð¼Ð¾Ñ› ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(401049,11141,'vi','hÆ°á»›ng dáº«n trá»£ giÃºp tháº» tÃ­n dá»¥ng',0),(401050,11141,'af','Kredietkaart Hulp Instruksies',0),(401051,11141,'ro','InstrucÅ£iuni de ajutor Card de credit',0),(401052,11141,'et','Krediitkaardi aidata juhiste',0),(401053,11141,'si','Kreditna kartica pomoÄ navodila',0),(401054,11141,'ba','Petunjuk Bantuan kartu kredit',0),(401055,11141,'nl','Creditcard hulp instructies',0),(401056,11141,'fi','Luottokortin auttaa ohjeet',0),(401057,11141,'no','Kredittkort hjelp instruksjoner',0),(401058,11141,'da','Kreditkort hjÃ¦lp instruktioner',0),(401059,11141,'ko','ì‹ ìš© ì¹´ë“œ ë„ì›€ë§ ì§€ì¹¨',0),(401060,11141,'he','×”×•×¨××•×ª ×¢×–×¨×” ×›×¨×˜×™×¡ ××©×¨××™',0),(401061,11141,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Î²Î¿Î®Î¸ÎµÎ¹Î± Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(401062,11141,'zh','ä¿¡ç”¨å¡å¸®åŠ©è¯´æ˜Ž\r\n',0),(401063,11141,'sv','Kreditkort hjÃ¤lpinstruktioner',0),(401064,11141,'it','Carta di credito Help istruzioni',0),(401065,11141,'tl','',0),(401066,11141,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(401067,11141,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤®à¤¦à¤¦ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(401068,11141,'ms','Arahan bantuan kad kredit',0),(401069,11141,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(401070,11141,'fr','Instructions d\'aide de carte de crÃ©dit',0),(401071,11141,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã€ãƒ˜ãƒ«ãƒ—ã®èª¬æ˜Ž',0),(401072,11141,'pt','InstruÃ§Ãµes de ajuda do cartÃ£o de crÃ©dito',0),(401073,11141,'ru','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ ÐŸÐ¾Ð¼Ð¾Ñ‰Ð¸ Ð”Ð»Ñ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐšÐ°Ñ€Ñ‚',0),(401074,11141,'es','Ayuda de Tarjeta de CrÃ©dito Instrucciones',0),(401075,11141,'de','Kreditkarte Hilfe Anweisungen',0),(401076,11141,'en','Credit Card Help Instructions',0),(401077,11142,'is','',0),(401078,11142,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(401079,11142,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(401080,11142,'tr','Kredi kartÄ± numarasÄ±',0),(401081,11142,'pl','Numer karty kredytowej',0),(401082,11142,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(401083,11142,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù†Ù…Ø¨Ø±',0),(401084,11142,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(401085,11142,'vi','sá»‘ tháº» tÃ­n dá»¥ng',0),(401086,11142,'af','Kredietkaart Nommer',0),(401087,11142,'ro','NumÄƒrul cardului de credit',0),(401088,11142,'et','Krediitkaardi Number',0),(401089,11142,'si','Å tevilka kreditne kartice',0),(401090,11142,'ba','Nomor kartu kredit',0),(401091,11142,'nl','Credit cardnummer',0),(401092,11142,'fi','Luottokorttinumero',0),(401093,11142,'no','Kredittkortnummer',0),(401094,11142,'da','Kreditkortnummer',0),(401095,11142,'ko','ì‹ ìš© ì¹´ë“œ ë²ˆí˜¸',0),(401096,11142,'he','×ž×¡×¤×¨ ×›×¨×˜×™×¡ ×”××©×¨××™',0),(401097,11142,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(401098,11142,'zh','ä¿¡ç”¨å¡å·ç \r\n',0),(401099,11142,'sv','Kreditkortsnummer',0),(401100,11142,'it','Numero di carta di credito',0),(401101,11142,'tl','',0),(401102,11142,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(401103,11142,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¨à¤‚à¤¬à¤°',0),(401104,11142,'ms','Nombor kad kredit',0),(401105,11142,'ar','Ø±Ù‚Ù… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø¥Ø¦ØªÙ…Ø§Ù†',0),(401106,11142,'fr','NumÃ©ro de carte de crÃ©dit',0),(401107,11142,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ç•ªå·',0),(401108,11142,'pt','NÃºmero de cartÃ£o de crÃ©dito',0),(401109,11142,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ñ‹',0),(401110,11142,'es','NÃºmero de Tarjeta de CrÃ©dito',0),(401111,11142,'de','Kreditkartennummer',0),(401112,11142,'en','Credit Card Number',0),(401113,11143,'is','',0),(401114,11143,'dr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(401115,11143,'pr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(401116,11143,'tr','Kredi kartÄ± sipariÅŸi baÅŸarÄ±yla kaydedildi',0),(401117,11143,'pl','ZamÃ³wienie karty kredytowej zapisane',0),(401118,11143,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(401119,11143,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Ø§ Ø¢Ø±ÚˆØ± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(401120,11143,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð½Ð°Ð»Ð¾Ð³Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(401121,11143,'vi','Ä‘Ã£ lÆ°u Ä‘áº·t hÃ ng tháº» tÃ­n dá»¥ng',0),(401122,11143,'af','Kredietkaart Bestelling Suksesvol Gestoor',0),(401123,11143,'ro','Card de credit comanda salvat cu succes',0),(401124,11143,'et','Krediitkaarti et edukalt salvestatud',0),(401125,11143,'si','Credit Card Order uspeÅ¡no shranjen',0),(401126,11143,'ba','Order kartu kredit disimpan berhasil',0),(401127,11143,'nl','Credit Card bestelling succesvol opgeslagen',0),(401128,11143,'fi','Luottokortti jÃ¤rjestys tallennettu',0),(401129,11143,'no','Kredittkort for lagret',0),(401130,11143,'da','Kreditkort rÃ¦kkefÃ¸lge gemt med succes',0),(401131,11143,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ ëœ ì‹ ìš© ì¹´ë“œ ì£¼ë¬¸',0),(401132,11143,'he','×”×–×ž× ×ª ×›×¨×˜×™×¡ ××©×¨××™ ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(401133,11143,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Î· Î´Î¹Î±Ï„Î±Î³Î® Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(401134,11143,'zh','ä¿¡ç”¨å¡è®¢è´­ä¿å­˜æˆåŠŸ\r\n',0),(401135,11143,'sv','Kreditkort bestÃ¤lla sparats',0),(401136,11143,'it','Carta di credito ordine salvata correttamente',0),(401137,11143,'tl','',0),(401138,11143,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸ªà¸±à¹ˆà¸‡à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(401139,11143,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(401140,11143,'ms','Pesanan kad kredit yang berjaya disimpan',0),(401141,11143,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø£Ù…Ø± Ø­ÙØ¸ Ø¨Ù†Ø¬Ø§Ø­',0),(401142,11143,'fr','Commande de carte de crÃ©dit enregistrÃ© avec succÃ¨s',0),(401143,11143,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚ŒãŸã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ã”æ³¨æ–‡',0),(401144,11143,'pt','Pedido de cartÃ£o de crÃ©dito com sucesso',0),(401145,11143,'ru','Ð—Ð°ÐºÐ°Ð· ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ñ‹ Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½',0),(401146,11143,'es','Orden de Tarjeta de CrÃ©dito Guardado Exitosamente',0),(401147,11143,'de','Kreditkarte Auftrag erfolgreich gespeichert',0),(401148,11143,'en','Credit Card Order Saved Successfully',0),(401149,11144,'is','',0),(401150,11144,'dr','Ù†ÙˆØ¹ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ØªØ´Ø®ÙŠØµ Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯ ',0),(401151,11144,'pr','Ù†ÙˆØ¹ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ØªØ´Ø®ÙŠØµ Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯ ',0),(401152,11144,'tr','Kredi kartÄ± tÃ¼rÃ¼ tanÄ±nmadÄ±',0),(401153,11144,'pl','Typ karty kredytowej, nie rozpoznany',0),(401154,11144,'bg','Ð¢Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð½Ðµ ÑÐµ Ñ€Ð°Ð·Ð¿Ð¾Ð·Ð½Ð°Ð²Ð°',0),(401155,11144,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ù‚Ø³Ù… Ù†ÛÛŒÚº Ù¾ÛÚ†Ø§Ù†Ø§',0),(401156,11144,'sr','Ð¢Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€ÐµÐ¿Ð¾Ð·Ð½Ð°Ñ‚',0),(401157,11144,'vi','loáº¡i tháº» tÃ­n dá»¥ng khÃ´ng xÃ¡c nháº­n',0),(401158,11144,'af','Kredietkaart Tipe Nie Herken',0),(401159,11144,'ro','Tipul de Card de credit nu este recunoscut',0),(401160,11144,'et','Krediitkaardi tÃ¼Ã¼p ei tunnistata',0),(401161,11144,'si','Kreditno kartico tipa, ne priznava',0),(401162,11144,'ba','Jenis kartu kredit tidak diakui',0),(401163,11144,'nl','Creditcard Type niet herkend',0),(401164,11144,'fi','Luottokorttityyppi ei tunnista',0),(401165,11144,'no','Kredittkorttype gjenkjennes ikke',0),(401166,11144,'da','Kreditkorttype blev ikke genkendt',0),(401167,11144,'ko','ì¸ì‹ ë˜ì§€ ì•ŠëŠ” ì‹ ìš© ì¹´ë“œ ì¢…ë¥˜',0),(401168,11144,'he','×¡×•×’ ×›×¨×˜×™×¡ ×”××©×¨××™ ××™× ×• ×ž×–×•×”×”',0),(401169,11144,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Ï„ÏÏ€Î¿Ï… Ï€Î¿Ï… Î´ÎµÎ½ Î±Î½Î±Î³Î½Ï‰ÏÎ¯Î¶ÎµÏ„Î±Î¹',0),(401170,11144,'zh','ä¿¡ç”¨å¡äº¤æ˜“æŠ¥å‘Š\r\n',0),(401171,11144,'sv','Kreditkortstyp kÃ¤nns inte igen',0),(401172,11144,'it','Tipo di carta di credito non riconosciuto',0),(401173,11144,'tl','',0),(401174,11144,'th','à¹„à¸¡à¹ˆà¸£à¸¹à¹‰à¸ˆà¸±à¸à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(401175,11144,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤ªà¤¹à¤šà¤¾à¤¨à¤¾ à¤¨à¤¹à¥€à¤‚ à¤—à¤¯à¤¾',0),(401176,11144,'ms','Jenis kad kredit yang tidak diiktiraf',0),(401177,11144,'ar','Ù†ÙˆØ¹ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ØºÙŠØ± Ù…Ø¹ØªØ±Ù Ø¨Ù‡Ø§',0),(401178,11144,'fr','Type de carte de crÃ©dit non reconnu',0),(401179,11144,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ç¨®é¡žã‚’èªè­˜ã§ãã¾ã›ã‚“ã€‚',0),(401180,11144,'pt','Tipo de cartÃ£o de crÃ©dito nÃ£o reconhecido',0),(401181,11144,'ru','Ð¢Ð¸Ð¿ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ñ‹ ÐÐµ Ð Ð°ÑÐ¿Ð¾Ð·Ð½Ð°ÐµÑ‚ÑÑ',0),(401182,11144,'es','Tipo de Tarjeta de CrÃ©dito No se Reconoce',0),(401183,11144,'de','Kreditkartentyp nicht erkannt',0),(401184,11144,'en','Credit Card Type Not Recognized',0),(401185,11145,'is','',0),(401186,11145,'dr','Ù…Ø§Ù‡ Ø§Ù†Ù‚Ø¶Ø§Ø¡ ',0),(401187,11145,'pr','Ù…Ø§Ù‡ Ø§Ù†Ù‚Ø¶Ø§Ø¡ ',0),(401188,11145,'tr','Sona erme ay',0),(401189,11145,'pl','MiesiÄ…c wygaÅ›niÄ™cia',0),(401190,11145,'bg','Ð˜Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ Ð¼ÐµÑÐµÑ†',0),(401191,11145,'ur','Ù…Ø¯Øª Ù…ÛÛŒÙ†Û',0),(401192,11145,'sr','ÐœÐµÑÐµÑ† Ð¸ÑÑ‚Ð¸Ñ†Ð°ÑšÐ° Ñ€Ð¾ÐºÐ° Ð²Ð°Ð¶ÐµÑšÐ°',0),(401193,11145,'vi','Káº¿t thÃºc thÃ¡ng',0),(401194,11145,'af','Verstryking maand',0),(401195,11145,'ro','Luna de expirare',0),(401196,11145,'et','LÃµppemise kuu',0),(401197,11145,'si','Mesec poteka',0),(401198,11145,'ba','Berakhirnya bulan',0),(401199,11145,'nl','Vervaldatum maand',0),(401200,11145,'fi','Kulunut kuukausi',0),(401201,11145,'no','Gyldig til mÃ¥ned',0),(401202,11145,'da','UdlÃ¸bsmÃ¥neden',0),(401203,11145,'ko','ë§Œë£Œ ì›”',0),(401204,11145,'he','×—×•×“×© ×ª×¤×•×’×”',0),(401205,11145,'el','ÎœÎ®Î½Î± Î»Î®Î¾Î·Ï‚',0),(401206,11145,'zh','åˆ°æœŸæœˆä»½\r\n',0),(401207,11145,'sv','FÃ¶rfallodagen mÃ¥nad',0),(401208,11145,'it','Mese di scadenza',0),(401209,11145,'tl','',0),(401210,11145,'th','à¹€à¸”à¸·à¸­à¸™à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(401211,11145,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤®à¤¾à¤¹',0),(401212,11145,'ms','Tamat tempoh bulan',0),(401213,11145,'ar','Ø´Ù‡Ø± Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØµÙ„Ø§Ø­ÙŠØ©',0),(401214,11145,'fr','Mois d\'expiration',0),(401215,11145,'jp','æœ‰åŠ¹æœŸé™æœˆ',0),(401216,11145,'pt','MÃªs de vencimento',0),(401217,11145,'ru','ÐœÐµÑÑÑ† Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ ÑÑ€Ð¾ÐºÐ° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(401218,11145,'es','Mes de Vencimiento',0),(401219,11145,'de','Ablaufmonat',0),(401220,11145,'en','Expiration Month',0),(401221,11146,'is','',0),(401222,11146,'dr','Ø³Ø§Ù„ Ø§Ù†Ù‚Ø¶Ø§Ø¡',0),(401223,11146,'pr','Ø³Ø§Ù„ Ø§Ù†Ù‚Ø¶Ø§Ø¡',0),(401224,11146,'tr','BitiÅŸ yÄ±lÄ±',0),(401225,11146,'pl','Rok wygaÅ›niÄ™cia',0),(401226,11146,'bg','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð½Ð° ÑÐ²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ',0),(401227,11146,'ur','Ø³Ø§Ù„ Ø®ØªÙ… ÛÙˆÙ†Û’',0),(401228,11146,'sr','Ð˜ÑÑ‚ÐµÐºÐ° Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(401229,11146,'vi','Káº¿t thÃºc nÄƒm',0),(401230,11146,'af','Verstryking jaar',0),(401231,11146,'ro','An expirare',0),(401232,11146,'et','TÃ¤htaja mÃ¶Ã¶dumine aastal',0),(401233,11146,'si','Leto poteka',0),(401234,11146,'ba','Tahun kadaluarsa',0),(401235,11146,'nl','Vervaldatum jaar',0),(401236,11146,'fi','Kulunut vuosi',0),(401237,11146,'no','UtlÃ¸p Ã¥r',0),(401238,11146,'da','UdlÃ¸b Ã¥r',0),(401239,11146,'ko','ë§Œë£Œ ë…„',0),(401240,11146,'he','×©× ×ª ×”×ª×¤×•×’×”',0),(401241,11146,'el','Î§ÏÏŒÎ½Î¿ Î»Î®Î¾Î·Ï‚',0),(401242,11146,'zh','åˆ°æœŸå¹´ä»½\r\n',0),(401243,11146,'sv','UpphÃ¶r att gÃ¤lla Ã¥r',0),(401244,11146,'it','Anno di scadenza',0),(401245,11146,'tl','',0),(401246,11146,'th','à¸›à¸µà¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(401247,11146,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤µà¤°à¥à¤·',0),(401248,11146,'ms','Tahun tamat',0),(401249,11146,'ar','Ø³Ù†Ø© Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØµÙ„Ø§Ø­ÙŠØ©',0),(401250,11146,'fr','AnnÃ©e d\'expiration',0),(401251,11146,'jp','æœ‰åŠ¹æœŸé™å¹´',0),(401252,11146,'pt','Ano de validade',0),(401253,11146,'ru','Ð“Ð¾Ð´ Ð¸ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ñ ÑÑ€Ð¾ÐºÐ° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(401254,11146,'es','AÃ±o de Vencimiento',0),(401255,11146,'de','Ablaufjahr',0),(401256,11146,'en','Expiration Year',0),(401257,11147,'is','',0),(401258,11147,'dr','ÙƒØ§Ø±Øª Ø¶Ø§Ù…Ù† ',0),(401259,11147,'pr','ÙƒØ§Ø±Øª Ø¶Ø§Ù…Ù† ',0),(401260,11147,'tr','GarantÃ¶r kartÄ±',0),(401261,11147,'pl','Gwarant karty',0),(401262,11147,'bg','Ð“Ð°Ñ€Ð°Ð½Ñ‚ ÐºÐ°Ñ€Ñ‚Ð°',0),(401263,11147,'ur','Ø¶Ø§Ù…Ù† Ú©Ø§Ø±Úˆ',0),(401264,11147,'sr','Ð“Ð°Ñ€Ð°Ð½Ñ‚ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(401265,11147,'vi','tháº» báº£o hÃ nh',0),(401266,11147,'af','Borg kaart',0),(401267,11147,'ro','Garant Card',0),(401268,11147,'et','KÃ¤endaja kaart',0),(401269,11147,'si','Garant kartice',0),(401270,11147,'ba','Penjamin kartu',0),(401271,11147,'nl','Borg kaart',0),(401272,11147,'fi','Takaajan kortti',0),(401273,11147,'no','Garantist kort',0),(401274,11147,'da','Garant kort',0),(401275,11147,'ko','ë³´ì¦ì¸ ì¹´ë“œ',0),(401276,11147,'he','×¢×¨×‘ ×§×œ×¤×™×',0),(401277,11147,'el','Î•Î³Î³Ï…Î·Ï„Î®Ï‚ ÎºÎ¬ÏÏ„Î±',0),(401278,11147,'zh','æ‹…ä¿äººå¡\r\n',0),(401279,11147,'sv','Garant-kort',0),(401280,11147,'it','Carta di garante',0),(401281,11147,'tl','',0),(401282,11147,'th','à¸šà¸±à¸•à¸£à¸œà¸¹à¹‰à¸„à¹‰à¸³à¸›à¸£à¸°à¸à¸±à¸™',0),(401283,11147,'hi','à¤—à¤¾à¤°à¤‚à¤Ÿà¥€ à¤•à¤¾à¤°à¥à¤¡',0),(401284,11147,'ms','Penjamin Kad',0),(401285,11147,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø¶Ø§Ù…Ù†',0),(401286,11147,'fr','Carte de garant',0),(401287,11147,'jp','ä¿è¨¼ã‚«ãƒ¼ãƒ‰',0),(401288,11147,'pt','CartÃ£o fiador',0),(401289,11147,'ru','Ð“Ð°Ñ€Ð°Ð½Ñ‚ ÐºÐ°Ñ€Ñ‚Ð°',0),(401290,11147,'es','Tarjeta de Garantor',0),(401291,11147,'de','Garant-Karte',0),(401292,11147,'en','Guarantor Card',0),(401293,11148,'is','',0),(401294,11148,'dr','Ù†Ø§Ù… Ø¯Ø± ÙƒØ§Ø±Øª ',0),(401295,11148,'pr','Ù†Ø§Ù… Ø¯Ø± ÙƒØ§Ø±Øª ',0),(401296,11148,'tr','KartÄ±nÄ±n',0),(401297,11148,'pl','Nazwa na karcie',0),(401298,11148,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(401299,11148,'ur','Ú©Ø§Ø±Úˆ Ù¾Ø± Ù†Ø§Ù…',0),(401300,11148,'sr','Ð˜Ð¼Ðµ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸',0),(401301,11148,'vi','TÃªn cá»§a tháº»',0),(401302,11148,'af','Naam Op Kaart',0),(401303,11148,'ro','Numele de pe Card',0),(401304,11148,'et','Nimi kaardil',0),(401305,11148,'si','Ime na kartico',0),(401306,11148,'ba','Nama pada kartu',0),(401307,11148,'nl','Naam op kaart',0),(401308,11148,'fi','Kortin',0),(401309,11148,'no','Navnet pÃ¥ kortet',0),(401310,11148,'da','Navn pÃ¥ kortet',0),(401311,11148,'ko','ì¹´ë“œì— ì´ë¦„',0),(401312,11148,'he','×”×©× ×¢×œ ×›×¨×˜×™×¡',0),(401313,11148,'el','ÎŒÎ½Î¿Î¼Î± ÎºÎ±ÏÏ„Î­Î»Î±Ï‚',0),(401314,11148,'zh','ä¿¡ç”¨å¡æŒæœ‰äººå§“å\r\n',0),(401315,11148,'sv','Namn pÃ¥ kort',0),(401316,11148,'it','Nome su carta',0),(401317,11148,'tl','',0),(401318,11148,'th','à¸Šà¸·à¹ˆà¸­à¹ƒà¸™à¸šà¸±à¸•à¸£',0),(401319,11148,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤ªà¤° à¤¨à¤¾à¤®',0),(401320,11148,'ms','Nama pada kad',0),(401321,11148,'ar','Ø§Ù„Ø§Ø³Ù… Ø¹Ù„Ù‰ Ø§Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(401322,11148,'fr','Nom sur la carte',0),(401323,11148,'jp','ã‚«ãƒ¼ãƒ‰ã®åå‰',0),(401324,11148,'pt','Nome no cartÃ£o',0),(401325,11148,'ru','Ð˜Ð¼Ñ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ðµ',0),(401326,11148,'es','Nombre en la Tarjeta',0),(401327,11148,'de','Name auf Karte',0),(401328,11148,'en','Name On Card',0),(401329,11149,'is','',0),(401330,11149,'dr','Ù‡ÙŠÚ† ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(401331,11149,'pr','Ù‡ÙŠÚ† ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(401332,11149,'tr','Yok, kredi kartÄ± bulundu',0),(401333,11149,'pl','Karty kredytowe, nie znaleziono',0),(401334,11149,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(401335,11149,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(401336,11149,'sr','ÐÐµÐ¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ, Ð½Ð°ÑˆÐ°Ð¾',0),(401337,11149,'vi','khÃ´ng tÃ¬m tháº¥y tháº» tÃ­n dá»¥ng',0),(401338,11149,'af','Geen Kredietkaarte Gevind',0),(401339,11149,'ro','Nici o carte de Credit gÄƒsit',0),(401340,11149,'et','Leitud krediitkaardid',0),(401341,11149,'si','Kreditnih kartic ne najdemo',0),(401342,11149,'ba','Tidak ada kartu kredit yang ditemukan',0),(401343,11149,'nl','Geen Credit Cards gevonden',0),(401344,11149,'fi','Luottokortteja ei lÃ¶ytynyt',0),(401345,11149,'no','Ingen kredittkort funnet',0),(401346,11149,'da','Ingen kreditkort fundet',0),(401347,11149,'ko','ë°œê²¬ ì‹ ìš© ì¹´ë“œ',0),(401348,11149,'he','×œ× × ×ž×¦××• ×›×¨×˜×™×¡×™ ××©×¨××™',0),(401349,11149,'el','Î”ÎµÎ½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(401350,11149,'zh','æ²¡æœ‰æ‰¾åˆ°ä¿¡ç”¨å¡\r\n',0),(401351,11149,'sv','Inga kreditkort hittade',0),(401352,11149,'it','No carte di credito trovato',0),(401353,11149,'tl','',0),(401354,11149,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¹„à¸¡à¹ˆà¸žà¸š',0),(401355,11149,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤®à¤¿à¤²à¤¾',0),(401356,11149,'ms','Tiada kad kredit yang ditemui',0),(401357,11149,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¨Ø·Ø§Ù‚Ø§Øª Ø¥ØªØ¦Ù…Ø§Ù†',0),(401358,11149,'fr','Pas trouvÃ© de cartes de crÃ©dit',0),(401359,11149,'jp','ç™ºè¦‹ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ãªã—',0),(401360,11149,'pt','Sem cartÃµes de crÃ©dito encontrados',0),(401361,11149,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐšÐ°Ñ€Ñ‚Ñ‹ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(401362,11149,'es','No se EncontrÃ³ Tarjetas de CrÃ©dito',0),(401363,11149,'de','Keine Kreditkarten gefunden',0),(401364,11149,'en','No Credit Cards Found',0),(401365,11150,'is','',0),(401366,11150,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù…Ø§Ù‡ Ø§Ù†Ù‚Ø¶Ø§Ø¡  Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(401367,11150,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù…Ø§Ù‡ Ø§Ù†Ù‚Ø¶Ø§Ø¡  Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(401368,11150,'tr','LÃ¼tfen son kullanÄ±m ay iÃ§erir',0),(401369,11150,'pl','ProszÄ™ podaÄ‡ miesiÄ…c wygaÅ›niÄ™cia',0),(401370,11150,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ Ð¼ÐµÑÐµÑ†',0),(401371,11150,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©Û’ Ø§ÛŒÚ© Ù…ÛÛŒÙ†Û’ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(401372,11150,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ñ˜ÐµÐ´Ð°Ð½ Ð¼ÐµÑÐµÑ† Ð¸ÑÑ‚Ð¸Ñ†Ð°ÑšÐ° Ñ€Ð¾ÐºÐ° Ð²Ð°Ð¶ÐµÑšÐ°',0),(401373,11150,'vi','vui lÃ²ng bao gá»“m 1 thÃ¡ng káº¿t thÃºc',0),(401374,11150,'af','Sluit \'n Vervalmaand In',0),(401375,11150,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i o luna de expirare',0),(401376,11150,'et','Palun lisage lÃµppemise kuu',0),(401377,11150,'si','Prosimo, da vkljuÄite poteka mesec',0),(401378,11150,'ba','Harap sertakan bulan kadaluarsa',0),(401379,11150,'nl','Gelieve te omvatten een maand verlopen',0),(401380,11150,'fi','LiitÃ¤ mukaan kulunut kuukausi',0),(401381,11150,'no','Vennligst oppgi et gyldig til mÃ¥ned',0),(401382,11150,'da','VedlÃ¦g en udlÃ¸bsmÃ¥neden',0),(401383,11150,'ko','ë§Œë£Œ ë‹¬ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(401384,11150,'he','× × ×œ×›×œ×•×œ ××ª ×—×•×“×© ×”×ª×¤×•×’×”',0),(401385,11150,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î±Î½ Î¼Î®Î½Î± Î»Î®Î¾Î·Ï‚',0),(401386,11150,'zh','è¯·åˆ—å…¥ä¸€ä¸ªåˆ°æœŸæœˆä»½\r\n',0),(401387,11150,'sv','VÃ¤nligen inkludera en utandning mÃ¥nad',0),(401388,11150,'it','Si prega di includere un mese di scadenza',0),(401389,11150,'tl','',0),(401390,11150,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¹€à¸”à¸·à¸­à¸™à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(401391,11150,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¸à¤®à¤¯ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤®à¤¾à¤¹ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(401392,11150,'ms','Sila sertakan satu bulan tamat tempoh',0),(401393,11150,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ù…Ø¯Ø© Ø´Ù‡Ø± Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØµÙ„Ø§Ø­ÙŠØ©',0),(401394,11150,'fr','Veuillez inclure un mois d\'Expiration',0),(401395,11150,'jp','æœ‰åŠ¹æœŸé™ã®æœˆã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(401396,11150,'pt','Por favor inclua um mÃªs de vencimento',0),(401397,11150,'ru','Ð£ÐºÐ°Ð¶Ð¸Ñ‚Ðµ ÑÑ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð¼ÐµÑÑÑ†',0),(401398,11150,'es','Por Favor Incluye un Mes de Vencimiento',0),(401399,11150,'de','Bitte geben Sie eine Ablaufmonat',0),(401400,11150,'en','Please Include an Expiration Month',0),(401401,11151,'is','',0),(401402,11151,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø³Ø§Ù„ Ø§Ù†Ù‚Ø¶Ø§Ø¡  Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(401403,11151,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø³Ø§Ù„ Ø§Ù†Ù‚Ø¶Ø§Ø¡  Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(401404,11151,'tr','LÃ¼tfen son kullanÄ±m yÄ±l dahil',0),(401405,11151,'pl','ProszÄ™ podaÄ‡ rok wygaÅ›niÄ™cia',0),(401406,11151,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð³Ð¾Ð´Ð¸Ð½Ð° Ð½Ð° ÑÐ²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ',0),(401407,11151,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ù…Ø¯Øª Ø³Ø§Ù„ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(401408,11151,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ñƒ Ð¸ÑÑ‚ÐµÐºÐ° Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(401409,11151,'vi','vui lÃ²ng bao gá»“m 1 nÄƒm káº¿t thÃºc',0),(401410,11151,'af','Sluit \'n Vervaljaar In',0),(401411,11151,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i un an expirare',0),(401412,11151,'et','Palun lisage tÃ¤htaja mÃ¶Ã¶dumine aastal',0),(401413,11151,'si','Prosimo, da vkljuÄite poteka leto',0),(401414,11151,'ba','Harap sertakan tahun kadaluarsa',0),(401415,11151,'nl','Gelieve te omvatten een jaar vervaldatum',0),(401416,11151,'fi','SisÃ¤llytÃ¤ viimeinen vuosi',0),(401417,11151,'no','Ta en utlÃ¸psdato Ã¥r',0),(401418,11151,'da','VedlÃ¦g en udlÃ¸b Ã¥r',0),(401419,11151,'ko','ë§Œë£Œ 1 ë…„ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(401420,11151,'he','× × ×œ×›×œ×•×œ ××ª ×”×©× ×” ×ª×¤×•×’×”',0),(401421,11151,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î± Î­Ï„Î¿Ï‚ Î»Î®Î¾Î·Ï‚',0),(401422,11151,'zh','è¯·åˆ—å…¥ä¸€ä¸ªåˆ°æœŸå¹´ä»½\r\n',0),(401423,11151,'sv','VÃ¤nligen inkludera ett fÃ¶rfallodatum Ã¥r',0),(401424,11151,'it','Si prega di includere un anno di scadenza',0),(401425,11151,'tl','',0),(401426,11151,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸›à¸µà¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(401427,11151,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¸à¤®à¤¯ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤µà¤°à¥à¤· à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(401428,11151,'ms','Sila sertakan satu tahun tamat',0),(401429,11151,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„Ø³Ù†Ø©',0),(401430,11151,'fr','Veuillez indiquer l\'annÃ©e d\'Expiration',0),(401431,11151,'jp','æœ‰åŠ¹æœŸé™ã®å¹´ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(401432,11151,'pt','Por favor inclua um ano de validade',0),(401433,11151,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð³Ð¾Ð´ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(401434,11151,'es','Por Favor Incluye un AÃ±o de Vencimiento',0),(401435,11151,'de','Bitte geben Sie eine Ablaufjahr',0),(401436,11151,'en','Please Include an Expiration Year',0),(401437,11152,'is','',0),(401438,11152,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø§Ø³Ù… Ø±ÙˆÙŠ ÙƒØ§Ø±Øª Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(401439,11152,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø§Ø³Ù… Ø±ÙˆÙŠ ÙƒØ§Ø±Øª Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(401440,11152,'tr','Bir isim kartÄ± lÃ¼tfen ekleyin',0),(401441,11152,'pl','ProszÄ™ podaÄ‡ nazwÄ™ karty',0),(401442,11152,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(401443,11152,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù†Ø§Ù… Ú©Ø§Ø±Úˆ Ù¾Ø± Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(401444,11152,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¸Ð¼Ðµ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸',0),(401445,11152,'vi','vui lÃ²ng cÃ³ tÃªn trÃªn tháº»',0),(401446,11152,'af','Sluit \'n Naam op Kaart In',0),(401447,11152,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i un nume de pe Card',0),(401448,11152,'et','Palun lisada nimi kaardil',0),(401449,11152,'si','Prosimo, vkljuÄite ime na kartico',0),(401450,11152,'ba','Harap Sertakan nama pada kartu',0),(401451,11152,'nl','Geef een naam op kaart',0),(401452,11152,'fi','LiitÃ¤ mukaan nimi kortin',0),(401453,11152,'no','Ta med et navn pÃ¥ kortet',0),(401454,11152,'da','Inkluder venligst et navn pÃ¥ kortet',0),(401455,11152,'ko','ì¹´ë“œì— ì´ë¦„ì„ í¬í•¨ ì‹œì¼œ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(401456,11152,'he','× × ×œ×›×œ×•×œ ×©× ×‘×›×¨×˜×™×¡',0),(401457,11152,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± ÏƒÏ„Î·Î½ ÎºÎ¬ÏÏ„Î±',0),(401458,11152,'zh','è¯·åˆ—å…¥ä¸€ä¸ªå¡ä¸Šçš„åç§°\r\n',0),(401459,11152,'sv','Ange ett namn pÃ¥ kort',0),(401460,11152,'it','Si prega di includere un nome sulla carta',0),(401461,11152,'tl','',0),(401462,11152,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­à¸šà¸™à¸šà¸±à¸•à¸£',0),(401463,11152,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤¾à¤°à¥à¤¡ à¤ªà¤° à¤à¤• à¤¨à¤¾à¤® à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(401464,11152,'ms','Sila sertakan nama pada kad',0),(401465,11152,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† Ø§Ø³Ù… Ø¹Ù„Ù‰ Ø§Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(401466,11152,'fr','Veuillez indiquer un nom sur la carte',0),(401467,11152,'jp','ã‚«ãƒ¼ãƒ‰ã®åå‰ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(401468,11152,'pt','Por favor inclua um nome no cartÃ£o',0),(401469,11152,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð¸Ð¼Ñ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ðµ',0),(401470,11152,'es','Por Favor Incluye un Nombre en la Tarjeta',0),(401471,11152,'de','Bitte geben Sie einen Namen auf Karte',0),(401472,11152,'en','Please Include a Name on Card',0),(401473,11153,'is','',0),(401474,11153,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù…Ø³ØªØ§Ø¬Ø±  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(401475,11153,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ù…Ø³ØªØ§Ø¬Ø±  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(401476,11153,'tr','LÃ¼tfen bir kiracÄ± iÃ§erir',0),(401477,11153,'pl','ProszÄ™ podaÄ‡ najemcy',0),(401478,11153,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»',0),(401479,11153,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(401480,11153,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÑÑ‚Ð°Ð½Ð°Ñ€Ð°',0),(401481,11153,'vi','vui lÃ²ng cÃ³ nhÃ¢n viÃªn',0),(401482,11153,'af','Sluit \'n Huurder In',0),(401483,11153,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i un chiriaÅŸ',0),(401484,11153,'et','Palun lisage Ã¼Ã¼rnik',0),(401485,11153,'si','Prosimo, da vkljuÄite najemnik',0),(401486,11153,'ba','Harap sertakan penyewa',0),(401487,11153,'nl','Gelieve te omvatten een huurder',0),(401488,11153,'fi','LiitÃ¤ mukaan vuokralainen',0),(401489,11153,'no','Ta en leietaker',0),(401490,11153,'da','VedlÃ¦g en lejer',0),(401491,11153,'ko','ì„¸ ìž…ìžë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(401492,11153,'he','× × ×œ×›×œ×•×œ ×“×™×™×¨',0),(401493,11153,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î± ÎµÎ½Î¿Î¹ÎºÎ¹Î±ÏƒÏ„Î®',0),(401494,11153,'zh','è¯·åˆ—å…¥ä¸€ä¸ªç§Ÿå®¢\r\n',0),(401495,11153,'sv','VÃ¤nligen inkludera en hyresgÃ¤st',0),(401496,11153,'it','Si prega di includere un inquilino',0),(401497,11153,'tl','',0),(401498,11153,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸§à¸¡à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(401499,11153,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(401500,11153,'ms','Sila sertakan penyewa',0),(401501,11153,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(401502,11153,'fr','Veuillez inclure un locataire',0),(401503,11153,'jp','ãƒ†ãƒŠãƒ³ãƒˆã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(401504,11153,'pt','Por favor inclua um inquilino',0),(401505,11153,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð°',0),(401506,11153,'es','Por Favor Incluye un Inquilino',0),(401507,11153,'de','Bitte geben Sie einen Mieter',0),(401508,11153,'en','Please Include a Tenant',0),(401509,11154,'is','',0),(401510,11154,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ù…Ø¹ØªØ¨Ø± ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(401511,11154,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø´Ù…Ø§Ø±Ù‡ Ù…Ø¹ØªØ¨Ø± ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(401512,11154,'tr','LÃ¼tfen geÃ§erli bir kredi kartÄ± numarasÄ±nÄ± iÃ§erir',0),(401513,11154,'pl','ProszÄ™ podaÄ‡ numer waÅ¼nej karty kredytowej',0),(401514,11154,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð²Ð°Ð»Ð¸Ð´Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(401515,11154,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø¬Ø§Ø¦Ø² Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù†Ù…Ø¨Ø± Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(401516,11154,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð²Ð°Ð¶ÐµÑ›Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(401517,11154,'vi','vui lÃ²ng bao gá»“m sá»• tháº» tÃ­n dá»¥ng cÃ³ giÃ¡ trá»‹',0),(401518,11154,'af','Sluit asb. \'n geldige Kredietkaartnommer in',0),(401519,11154,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i un numÄƒr Valid de Card de Credit',0),(401520,11154,'et','Palun lisage kehtiv krediitkaardinumber',0),(401521,11154,'si','Prosimo, da vkljuÄite kreditno kartico veljavno Å¡tevilko',0),(401522,11154,'ba','Harap sertakan nomor kartu kredit yang Valid',0),(401523,11154,'nl','Geef een geldig creditcardnummer',0),(401524,11154,'fi','Ilmoita voimassa olevan luottokorttinumeron',0),(401525,11154,'no','Ta med et gyldig kredittkortnummer',0),(401526,11154,'da','Inkluder venligst et gyldigt kreditkortnummer',0),(401527,11154,'ko','ìœ íš¨í•œ ì‹ ìš© ì¹´ë“œ ë²ˆí˜¸ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(401528,11154,'he','× × ×œ×›×œ×•×œ ×ž×¡×¤×¨ ×›×¨×˜×™×¡ ××©×¨××™ ×ª×§×£',0),(401529,11154,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î± Î­Î³ÎºÏ…ÏÎ¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(401530,11154,'zh','è¯·åˆ—å…¥ä¸€ä¸ªæœ‰æ•ˆçš„ä¿¡ç”¨å¡å·ç \r\n',0),(401531,11154,'sv','Ange ett giltigt kreditkortsnummer',0),(401532,11154,'it','Si prega di includere un numero di carta di credito valida',0),(401533,11154,'tl','',0),(401534,11154,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(401535,11154,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤®à¤¾à¤¨à¥à¤¯ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¨à¤‚à¤¬à¤° à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(401536,11154,'ms','Sila sertakan nombor kad kredit yang sah',0),(401537,11154,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø±Ù‚Ù… Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù† ØµØ§Ù„Ø­Ø©',0),(401538,11154,'fr','Veuillez indiquer un numÃ©ro de carte de crÃ©dit valide',0),(401539,11154,'jp','æœ‰åŠ¹ãªã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ•°ã‚’å«ã‚ã¦ä¸‹ã•ã„',0),(401540,11154,'pt','Por favor, inclua um nÃºmero vÃ¡lido de cartÃ£o de crÃ©dito',0),(401541,11154,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(401542,11154,'es','Por Favor Incluye una Tarjeta de CrÃ©dito VÃ¡lido',0),(401543,11154,'de','Bitte geben Sie eine gÃ¼ltige Kreditkartennummer',0),(401544,11154,'en','Please Include a Valid Credit Card Number',0),(401545,11155,'is','',0),(401546,11155,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø³ÙØ§Ø±Ø´',0),(401547,11155,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø³ÙØ§Ø±Ø´',0),(401548,11155,'tr','DÃ¼zeni Kaydet',0),(401549,11155,'pl','Zapisz kolejnoÅ›Ä‡',0),(401550,11155,'bg','Ð—Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´',0),(401551,11155,'ur','ØªØ±ØªÛŒØ¨ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(401552,11155,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´',0),(401553,11155,'vi','LÆ°u Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(401554,11155,'af','Stoor orde',0),(401555,11155,'ro','Salvare comandÄƒ',0),(401556,11155,'et','Salvesta jÃ¤rjestus',0),(401557,11155,'si','Shrani naroÄilo',0),(401558,11155,'ba','Simpan Order',0),(401559,11155,'nl','Volgorde opslaan',0),(401560,11155,'fi','Tallenna tilaus',0),(401561,11155,'no','Lagre rekkefÃ¸lge',0),(401562,11155,'da','Gemme rÃ¦kkefÃ¸lge',0),(401563,11155,'ko','ìˆœì„œë¥¼ ì €ìž¥',0),(401564,11155,'he','×©×ž×•×¨ ×”×–×ž× ×”',0),(401565,11155,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÎ¹ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(401566,11155,'zh','ä¿å­˜è®¢å•\r\n',0),(401567,11155,'sv','Spara Order',0),(401568,11155,'it','Salvare l\'ordine',0),(401569,11155,'tl','',0),(401570,11155,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸¥à¸³à¸”à¸±à¸š',0),(401571,11155,'hi','à¤•à¥à¤°à¤® à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(401572,11155,'ms','Menyimpan perintah',0),(401573,11155,'ar','Ø­ÙØ¸ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(401574,11155,'fr','Enregistrez la commande',0),(401575,11155,'jp','é †åºã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(401576,11155,'pt','Salvar a ordem',0),(401577,11155,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð—Ð°ÐºÐ°Ð·',0),(401578,11155,'es','Guardar Orden',0),(401579,11155,'de','Auftrag speichern',0),(401580,11155,'en','Save Order',0),(401581,11156,'is','',0),(401582,11156,'dr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(401583,11156,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(401584,11156,'tr','Faturalar baÅŸarÄ±yla eklendi',0),(401585,11156,'pl','Faktur dodano pomyÅ›lnie',0),(401586,11156,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(401587,11156,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(401588,11156,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(401589,11156,'vi','ÄÃ£ thÃªm hÃ³a Ä‘Æ¡n thÃ nh cÃ´ng',0),(401590,11156,'af','Fakure Suksesvol Geskep.',0),(401591,11156,'ro','Facturi adÄƒugat cu succes',0),(401592,11156,'et','Arvetele lisatud',0),(401593,11156,'si','RaÄunov uspeÅ¡no dodani',0),(401594,11156,'ba','Faktur ditambahkan berhasil',0),(401595,11156,'nl','Facturen met succes toegevoegd',0),(401596,11156,'fi','Laskujen lisÃ¤Ã¤minen onnistui',0),(401597,11156,'no','Fakturaer lagt',0),(401598,11156,'da','Fakturaer tilfÃ¸jet',0),(401599,11156,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ì²­êµ¬ì„œ',0),(401600,11156,'he','×—×©×‘×•× ×™×•×ª × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(401601,11156,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(401602,11156,'zh','å‘ç¥¨æ·»åŠ æˆåŠŸ\r\n',0),(401603,11156,'sv','Fakturor lagts',0),(401604,11156,'it','Fatture aggiunte con successo',0),(401605,11156,'tl','',0),(401606,11156,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(401607,11156,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(401608,11156,'ms','Invois-invois yang berjaya menambah',0),(401609,11156,'ar','Ø£Ø¶ÙŠÙØª Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(401610,11156,'fr','Factures ajoutÃ©s avec succÃ¨s',0),(401611,11156,'jp','è«‹æ±‚æ›¸ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(401612,11156,'pt','Facturas adicionadas com sucesso',0),(401613,11156,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(401614,11156,'es','Facturas Agregadas Exitosamente',0),(401615,11156,'de','Rechnungen, die erfolgreich hinzugefÃ¼gt',0),(401616,11156,'en','Invoices Added Successfully',0),(401617,11157,'is','',0),(401618,11157,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø§Ø¬Ø§Ø±Ù‡',0),(401619,11157,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø§Ø¬Ø§Ø±Ù‡',0),(401620,11157,'tr','Kira silme hatasÄ±',0),(401621,11157,'pl','BÅ‚Ä…d podczas usuwania dzierÅ¼awy',0),(401622,11157,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(401623,11157,'ur','Ù„ÛŒØ² Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(401624,11157,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð·Ð°ÐºÑƒÐ¿',0),(401625,11157,'vi','Lá»—i xÃ³a cho thuÃª',0),(401626,11157,'af','Fout het ontstaan met Skraping van Huurooreenkoms',0),(401627,11157,'ro','Eroare la È™tergerea de leasing',0),(401628,11157,'et','TÃµrge kustutamisel Ã¼Ã¼rileping',0),(401629,11157,'si','Napaka izbris najemne pogodbe',0),(401630,11157,'ba','Error menghapus sewa',0),(401631,11157,'nl','Fout bij het verwijderen van Lease',0),(401632,11157,'fi','Virhe poistettaessa vuokrasopimuksen',0),(401633,11157,'no','Feil ved sletting av leieavtalen',0),(401634,11157,'da','Fejl ved sletning af lejemÃ¥let',0),(401635,11157,'ko','ìž„ëŒ€ë¥¼ ì‚­ì œ í•˜ë©´ ì˜¤ë¥˜',0),(401636,11157,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×”×—×›×™×¨×”',0),(401637,11157,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(401638,11157,'zh','é”™è¯¯åˆ é™¤ç§Ÿèµ',0),(401639,11157,'sv','Fel nÃ¤r lÃ¥n tas bort',0),(401640,11157,'it','Errore cancellando il contratto di locazione',0),(401641,11157,'tl','',0),(401642,11157,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸¥à¸šà¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²',0),(401643,11157,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(401644,11157,'ms','Ralat Menghapuskan pajakan',0),(401645,11157,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(401646,11157,'fr','Erreur de suppression de bail',0),(401647,11157,'jp','ãƒªãƒ¼ã‚¹ã®å‰Šé™¤ã‚¨ãƒ©ãƒ¼',0),(401648,11157,'pt','Erro ao excluir o contrato de arrendamento',0),(401649,11157,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(401650,11157,'es','Error Eliminado el Arrendamiento',0),(401651,11157,'de','Fehler beim LÃ¶schen der Lease',0),(401652,11157,'en','Error Deleting Lease',0),(401653,11158,'is','',0),(401654,11158,'dr','Ù„ØºÙˆ  ',0),(401655,11158,'pr','Ù„ØºÙˆ  ',0),(401656,11158,'tr','Ä°ptal edin',0),(401657,11158,'pl','UniewaÅ¼niÄ‡',0),(401658,11158,'bg','ÐÐ½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð°',0),(401659,11158,'ur','Ú©Ø§Ù¹Ù†Ø§',0),(401660,11158,'sr','ÐŸÐ¾Ð½Ð¸ÑˆÑ‚Ð¸',0),(401661,11158,'vi','Há»§y bá»',0),(401662,11158,'af','Wyslg',0),(401663,11158,'ro','Anula',0),(401664,11158,'et','TÃ¼histada',0),(401665,11158,'si','Odstopi od',0),(401666,11158,'ba','Membatalkan',0),(401667,11158,'nl','Ontbinding',0),(401668,11158,'fi','Purkaa',0),(401669,11158,'no','Annuller',0),(401670,11158,'da','OphÃ¦ve',0),(401671,11158,'ko','ì² íšŒ',0),(401672,11158,'he','×ž×‘×˜×œ×ª',0),(401673,11158,'el','ÎšÎ±Ï„Î±Î³Î³ÎµÎ¯Î»ÎµÎ¹',0),(401674,11158,'zh','åºŸæ­¢\r\n',0),(401675,11158,'sv','UpphÃ¤va',0),(401676,11158,'it','Recedere',0),(401677,11158,'tl','',0),(401678,11158,'th','Rescind',0),(401679,11158,'hi','à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¥‡à¤¨à¤¾',0),(401680,11158,'ms','Membatalkan',0),(401681,11158,'ar','Ø¥Ù„ØºØ§Ø¡',0),(401682,11158,'fr','Annuler',0),(401683,11158,'jp','å–ã‚Šæ¶ˆã™ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(401684,11158,'pt','Rescindir',0),(401685,11158,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(401686,11158,'es','Rescindir',0),(401687,11158,'de','ZurÃ¼cktreten',0),(401688,11158,'en','Rescind',0),(401689,11159,'is','',0),(401690,11159,'dr','Ù„ØºÙˆ Ú©Ø±Ø¯Ù†  Ù…Ø¬Ø§Ø² Ù†ÙŠØ³Øª ',0),(401691,11159,'pr','Ù„ØºÙˆ Ú©Ø±Ø¯Ù†  Ù…Ø¬Ø§Ø² Ù†ÙŠØ³Øª ',0),(401692,11159,'tr','Ä°zin verilen iptal edin deÄŸil',0),(401693,11159,'pl','UniewaÅ¼niÄ‡ nie dozwolone',0),(401694,11159,'bg','ÐÐµ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð° Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸',0),(401695,11159,'ur','Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº Ú©Ø§Ù¹Ù†Ø§',0),(401696,11159,'sr','ÐŸÐ¾Ð½Ð¸ÑˆÑ‚Ð¸ Ð½Ð¸ÑÑƒ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¸',0),(401697,11159,'vi','Há»§y bá» khÃ´ng Ä‘Æ°á»£c phÃ©p',0),(401698,11159,'af','Wyslg nie toegelaat',0),(401699,11159,'ro','Nu anula permise',0),(401700,11159,'et','TÃ¼histada ei lubatud',0),(401701,11159,'si','Odstopi ni dovoljeno',0),(401702,11159,'ba','Membatalkan tidak diperbolehkan',0),(401703,11159,'nl','Ontbinden niet toegestaan',0),(401704,11159,'fi','Purkaa ei sallittu',0),(401705,11159,'no','Annuller ikke tillatt',0),(401706,11159,'da','OphÃ¦ve ikke tilladt',0),(401707,11159,'ko','í—ˆìš© ì² íšŒ',0),(401708,11159,'he','×œ× ×ž×‘×˜×œ×ª ×”×ž×•×ª×¨',0),(401709,11159,'el','ÎšÎ±Ï„Î±Î³Î³ÎµÎ¯Î»ÎµÎ¹ Î´ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(401710,11159,'zh','ä¸å…è®¸è§£é™¤æƒ\r\n',0),(401711,11159,'sv','UpphÃ¤va inte tillÃ¥tna',0),(401712,11159,'it','Recedere non consentiti',0),(401713,11159,'tl','',0),(401714,11159,'th','Rescind à¹„à¸¡à¹ˆà¸­à¸™à¸¸à¸à¸²à¸•',0),(401715,11159,'hi','à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¥‡à¤¨à¤¾',0),(401716,11159,'ms','Membatalkan tidak dibenarkan',0),(401717,11159,'ar','Ù„Ø§ ØªÙ„ØºÙŠ Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡Ø§',0),(401718,11159,'fr','N\'annule pas autorisÃ©s',0),(401719,11159,'jp','ãªã„è¨±å¯ã‚’å–ã‚Šæ¶ˆã™',0),(401720,11159,'pt','Rescindir nÃ£o permitidos',0),(401721,11159,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð½Ðµ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(401722,11159,'es','No se Permite Rescindir',0),(401723,11159,'de','RÃ¼cktritt nicht erlaubt',0),(401724,11159,'en','Rescind Not Allowed',0),(401725,11160,'is','',0),(401726,11160,'dr','(ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(401727,11160,'pr','Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ Ø¨Ù‡ Ø®Ø§Ø±Ø¬ (ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„) Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(401728,11160,'tr','Harekete baÅŸarÄ±yla silindi',0),(401729,11160,'pl','WyprowadziÄ‡, usuniÄ™ty',0),(401730,11160,'bg','Ð˜Ð·Ð½ÐµÑÐ°Ñ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(401731,11160,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(401732,11160,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(401733,11160,'vi','Di chuyá»ƒn xÃ³a thÃ nh cÃ´ng',0),(401734,11160,'af','Uittrek nie suksesvol geskrap',0),(401735,11160,'ro','Muta eliminÄƒ cu succes',0),(401736,11160,'et','Kolima, edukalt kustutatud',0),(401737,11160,'si','Umaknite se uspeÅ¡no izbrisana',0),(401738,11160,'ba','Bergerak keluar berhasil dihapus',0),(401739,11160,'nl','Verhuizen met succes verwijderd',0),(401740,11160,'fi','SiirrÃ¤ pois poistettu',0),(401741,11160,'no','Flytte ut slettet',0),(401742,11160,'da','Flytte slettet',0),(401743,11160,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤ ë°–ìœ¼ë¡œ ì´ë™',0),(401744,11160,'he','×–×•×– × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(401745,11160,'el','ÎœÎµÏ„Î±ÎºÎ¿Î¼Î¯Î¶Î¿Ï…Î½ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(401746,11160,'zh','è¿å‡ºæˆåŠŸåˆ é™¤\r\n',0),(401747,11160,'sv','Flytta ut raderades',0),(401748,11160,'it','Spostare eliminato con successo',0),(401749,11160,'tl','',0),(401750,11160,'th','à¸¢à¹‰à¸²à¸¢à¸­à¸­à¸à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(401751,11160,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤²à¥‡ à¤œà¤¾à¤à¤',0),(401752,11160,'ms','Mengalih dihapuskan dengan jayanya',0),(401753,11160,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(401754,11160,'fr','On doit Ã©carter supprimÃ© avec succÃ¨s',0),(401755,11160,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸç§»å‹•ã—ã¾ã™ã€‚',0),(401756,11160,'pt','Mover para fora apagado com sucesso',0),(401757,11160,'ru','Ð’Ñ‹Ð¹Ñ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(401758,11160,'es','Salida Eliminada Exitosamente',0),(401759,11160,'de','Ausziehen erfolgreich gelÃ¶scht',0),(401760,11160,'en','Move Out Deleted Successfully',0),(401761,11161,'is','',0),(401762,11161,'dr','(ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„',0),(401763,11161,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„(ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„\r\n Wizard \r\n',0),(401764,11161,'tr','Sihirbaz yÃ¶nergelerini taÅŸÄ±mak',0),(401765,11161,'pl','WyprowadziÄ‡ instrukcje kreatora',0),(401766,11161,'bg','Ð˜Ð·Ð½ÐµÑÐ°Ñ‚ ÑÑŠÐ²ÐµÑ‚Ð½Ð¸ÐºÐ° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(401767,11161,'ur','Ù…Ø¯Ø¯Ú¯Ø§Ø± ÛØ¯Ø§ÛŒØ§Øª Ø¨Ø§ÛØ± Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(401768,11161,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚ ÑƒÐ¿ÑƒÑ‚Ðµ Ñ‡Ð°Ñ€Ð¾Ð±ÑšÐ°ÐºÐ° Ð·Ð°',0),(401769,11161,'vi','Di chuyá»ƒn trong thuáº­t sÄ© hÆ°á»›ng dáº«n',0),(401770,11161,'af','Skuif Ghoeroe opdragte',0),(401771,11161,'ro','Muta Expertul instrucÅ£iuni',0),(401772,11161,'et','Kolima viisardi juhiseid',0),(401773,11161,'si','Izseliti navodila Äarovnika',0),(401774,11161,'ba','Pindah Wizard instruksi',0),(401775,11161,'nl','Verhuizen van instructies van de Wizard',0),(401776,11161,'fi','SiirtÃ¤Ã¤ ohjatun toiminnon ohjeita',0),(401777,11161,'no','Flytte ut instruksjonene for',0),(401778,11161,'da','Flytte ud instruktionerne i guiden',0),(401779,11161,'ko','ë§ˆë²•ì‚¬ì˜ ì§€ì‹œì— ë°–ìœ¼ë¡œ ì´ë™',0),(401780,11161,'he','×œ×”×–×™×– ××ª ×”×”×•×¨××•×ª ×©×œ ××©×£',0),(401781,11161,'el','Î‘Ï€Î¿Î¼Î±ÎºÏÏ…Î½Î¸ÎµÎ¯Ï„Îµ Î±Ï€ÏŒ Ï„Î¹Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚ Ï„Î¿Ï… Î¿Î´Î·Î³Î¿Ï',0),(401782,11161,'zh','è¿å‡ºå‘å¯¼çš„è¯´æ˜Ž\r\n',0),(401783,11161,'sv','Flytta ut anvisningarna i guiden',0),(401784,11161,'it','Spostare le istruzioni della procedura guidata',0),(401785,11161,'tl','',0),(401786,11161,'th','à¸¢à¹‰à¸²à¸¢à¸•à¸±à¸§à¸Šà¹ˆà¸§à¸¢à¸ªà¸£à¹‰à¸²à¸‡à¸„à¸³à¹à¸™à¸°à¸™à¸³',0),(401787,11161,'hi','à¤µà¤¿à¤œà¤¼à¤¾à¤°à¥à¤¡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¾à¤¹à¤° à¤²à¥‡ à¤œà¤¾à¤¨à¤¾',0),(401788,11161,'ms','Mengalih keluar arahan Pendeta',0),(401789,11161,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ø¥Ù„Ù‰ ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬',0),(401790,11161,'fr','On doit Ã©carter les Instructions de l\'Assistant',0),(401791,11161,'jp','ã‚¦ã‚£ã‚¶ãƒ¼ãƒ‰ã®æŒ‡ç¤ºã‚’ç§»å‹•ã—ã¾ã™ã€‚',0),(401792,11161,'pt','Mover as instruÃ§Ãµes do assistente',0),(401793,11161,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð¼Ð°ÑÑ‚ÐµÑ€Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(401794,11161,'es','Instrucciones de Wizard de Salida',0),(401795,11161,'de','Anweisungen des Assistenten ausziehen',0),(401796,11161,'en','Move Out Wizard Instructions',0),(401797,11162,'is','',0),(401798,11162,'dr','ØªØ®Ù„ÙŠÙ‡ Ø¬Ø¯ÙŠØ¯ ',0),(401799,11162,'pr','ØªØ®Ù„ÙŠÙ‡ Ø¬Ø¯ÙŠØ¯ ',0),(401800,11162,'tr','Yeni hareket et',0),(401801,11162,'pl','Nowy ruszyÄ‡ z miejsca',0),(401802,11162,'bg','ÐÐ¾Ð² Ñ…Ð¾Ð´',0),(401803,11162,'ur','Ù†Ø¦Û’ Ø§Ù‚Ø¯Ø§Ù… Ø¨Ø§ÛØ±',0),(401804,11162,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾ÐºÑ€ÐµÑ‚',0),(401805,11162,'vi','Má»›i di chuyá»ƒn ra',0),(401806,11162,'af','Nuwe skuif uit',0),(401807,11162,'ro','Noua miÅŸcare afarÄƒ',0),(401808,11162,'et','Uus kolima',0),(401809,11162,'si','Novi potezo',0),(401810,11162,'ba','Baru pindah keluar',0),(401811,11162,'nl','Nieuwe beweging uit',0),(401812,11162,'fi','Uusi liike',0),(401813,11162,'no','Nye trekk ut',0),(401814,11162,'da','Nye flytte ud',0),(401815,11162,'ko','ë°–ìœ¼ë¡œ ìƒˆë¡œìš´ ì´ë™',0),(401816,11162,'he','×”×ž×”×œ×š ×”×—×“×©.',0),(401817,11162,'el','ÎÎ­Î± ÎºÎ¯Î½Î·ÏƒÎ· Î­Î¾Ï‰',0),(401818,11162,'zh','æ–°è¿å‡º\r\n',0),(401819,11162,'sv','Nya flytta ut',0),(401820,11162,'it','Nuova mossa fuori',0),(401821,11162,'tl','',0),(401822,11162,'th','à¸¢à¹‰à¸²à¸¢à¹ƒà¸«à¸¡à¹ˆà¸­à¸­à¸',0),(401823,11162,'hi','à¤¬à¤¾à¤¹à¤° à¤¨à¤ à¤•à¤¦à¤®',0),(401824,11162,'ms','Langkah baru Keluar',0),(401825,11162,'ar','Ø§Ù„ØªØ­Ø±Ùƒ Ø§Ù„Ø¬Ø¯ÙŠØ¯ Ø¨Ù‡Ø§',0),(401826,11162,'fr','Nouveau mouvement sur',0),(401827,11162,'jp','ã†ã¡ã®æ–°ã—ã„å‹•ã',0),(401828,11162,'pt','Nova jogada fora',0),(401829,11162,'ru','ÐÐ¾Ð²Ð¾Ðµ Ð´Ð²Ð¸Ð¶ÐµÐ½Ð¸Ðµ',0),(401830,11162,'es','Nueva Salida',0),(401831,11162,'de','Neue ausschwÃ¤rmen',0),(401832,11162,'en','New Move Out',0),(401833,11163,'is','',0),(401834,11163,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø®Ø±ÙˆØ¬',0),(401835,11163,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø®Ø±ÙˆØ¬',0),(401836,11163,'tr','SÃ¼recini devam',0),(401837,11163,'pl','Proces przenoszenia',0),(401838,11163,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑÑŠÑ‚ ÑÐµ Ð¸Ð·Ð½ÐµÑÐ°Ñ‚',0),(401839,11163,'ur','Ø¨Ø§ÛØ± Ø¹Ù…Ù„ Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(401840,11163,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ , Ð¿Ð¾ÐºÑ€ÐµÑ‚',0),(401841,11163,'vi','tiá»n hÃ nh chuyá»ƒn ',0),(401842,11163,'af','Proses uittrek',0),(401843,11163,'ro','Procesul se mute',0),(401844,11163,'et','Protsessi kolima',0),(401845,11163,'si','Proces izseliti',0),(401846,11163,'ba','Proses pindah',0),(401847,11163,'nl','Proces verhuizen',0),(401848,11163,'fi','Prosessi on siirtÃ¤Ã¤ pois',0),(401849,11163,'no','Prosessen flytte ut',0),(401850,11163,'da','Proces flytter',0),(401851,11163,'ko','ê³¼ì • ë°–ìœ¼ë¡œ ì´ë™',0),(401852,11163,'he','×ª×”×œ×™×š ×œ×¢×‘×•×¨ ×“×™×¨×”',0),(401853,11163,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± ÎºÎ¹Î½Î·Î¸ÎµÎ¯ Î­Î¾Ï‰',0),(401854,11163,'zh','å¤„ç†è¿å‡º\r\n',0),(401855,11163,'sv','Processen flytta ut',0),(401856,11163,'it','Spostare il processo',0),(401857,11163,'tl','',0),(401858,11163,'th','à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£à¸¢à¹‰à¸²à¸¢à¸­à¸­à¸',0),(401859,11163,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤¦à¤®',0),(401860,11163,'ms','Proses berpindah keluar',0),(401861,11163,'ar','Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ø®Ø±ÙˆØ¬',0),(401862,11163,'fr','Processus de dÃ©mÃ©nager',0),(401863,11163,'jp','ãƒ—ãƒ­ã‚»ã‚¹å¤–ã«ç§»å‹•ã—ã¾ã™ã€‚',0),(401864,11163,'pt','Processo de mover para fora',0),(401865,11163,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ Ð¿ÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ñ',0),(401866,11163,'es','Procesar Salida',0),(401867,11163,'de','Prozess ausziehen',0),(401868,11163,'en','Process Move Out',0),(401869,11164,'is','',0),(401870,11164,'dr','(ØªØ®Ù„ÙŠÙ‡) Ø®Ø±ÙˆØ¬ ',0),(401871,11164,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†ÙˆØ¹ (ØªØ®Ù„ÙŠÙ‡) Ø®Ø±ÙˆØ¬ ',0),(401872,11164,'tr','Hareket tÃ¼rÃ¼ dÄ±ÅŸarÄ± seÃ§in',0),(401873,11164,'pl','Wybierz opcjÄ™ PrzenieÅ› typu',0),(401874,11164,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð²Ð¸Ð´',0),(401875,11164,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ø¢Ø¤Ù¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(401876,11164,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾ÐºÑ€ÐµÑ‚ Ñ‚Ð¸Ð¿',0),(401877,11164,'vi','Chá»n loáº¡i tiá»n ra',0),(401878,11164,'af','Kies skuif uit tipe',0),(401879,11164,'ro','SelectaÈ›i mutare tip',0),(401880,11164,'et','Valige Teisalda vÃ¤lja tÃ¼Ã¼p',0),(401881,11164,'si','Izberite Premakni, vrsta',0),(401882,11164,'ba','Pilih bergerak keluar tipe',0),(401883,11164,'nl','Selecteer verplaatsen uit Type',0),(401884,11164,'fi','Valitse SiirrÃ¤ ulos tyyppi',0),(401885,11164,'no','Velg Trekk ut',0),(401886,11164,'da','VÃ¦lg Flyt ud Type',0),(401887,11164,'ko','ì„ íƒ í˜•ì‹ ë°–ìœ¼ë¡œ ì´ë™',0),(401888,11164,'he','×‘×—×¨ ×œ×”×¢×‘×™×¨ ××ª ×¡×•×’',0),(401889,11164,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼ÎµÏ„Î±ÎºÎ¯Î½Î·ÏƒÎ· Î­Î¾Ï‰ Ï„ÏÏ€Î¿Ï…',0),(401890,11164,'zh','é€‰æ‹©è¿å‡ºç±»åž‹\r\n',0),(401891,11164,'sv','VÃ¤lj flytta ut typ',0),(401892,11164,'it','Selezionare sposta fuori tipo',0),(401893,11164,'tl','',0),(401894,11164,'th','à¹€à¸¥à¸·à¸­à¸à¸¢à¹‰à¸²à¸¢à¸­à¸­à¸à¸Šà¸™à¸´à¸”',0),(401895,11164,'hi','à¤ªà¥à¤°à¤•à¤¾à¤° à¤¬à¤¾à¤¹à¤° à¤²à¥‡ à¤œà¤¾à¤à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(401896,11164,'ms','Pilih bergerak keluar jenis',0),(401897,11164,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ø¥Ù„Ù‰ Ù†ÙˆØ¹',0),(401898,11164,'fr','SÃ©lectionnez dÃ©placer type',0),(401899,11164,'jp','ç§»å‹•ã®ç¨®é¡žã‚’é¸æŠžã—ã¾ã™',0),(401900,11164,'pt','Selecione sair do tipo',0),(401901,11164,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿ÐµÑ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚ÑŒ, Ñ‚Ð¸Ð¿',0),(401902,11164,'es','Selecciona Tipo de Salida',0),(401903,11164,'de','WÃ¤hlen Sie nach Art',0),(401904,11164,'en','Select Move Out Type',0),(401905,11165,'is','',0),(401906,11165,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(401907,11165,'pr','Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(401908,11165,'tr','Mevduat kredi',0),(401909,11165,'pl','Depozyt kredytowa',0),(401910,11165,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°',0),(401911,11165,'ur','Ø¬Ù…Ø¹ Ú©Ø±ÛŒÚˆÙ¹',0),(401912,11165,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ ÑÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¾Ð¼',0),(401913,11165,'vi','TÃ­n dá»¥ng khoáº£n tiá»n gá»­i',0),(401914,11165,'af','Deposito krediet',0),(401915,11165,'ro','Depozit de Credit',0),(401916,11165,'et','Tagatisraha krediidi',0),(401917,11165,'si','Depozit kreditna',0),(401918,11165,'ba','Deposit kredit',0),(401919,11165,'nl','Storting krediet',0),(401920,11165,'fi','Talletus luotto',0),(401921,11165,'no','Depositum kreditt',0),(401922,11165,'da','Depositum kredit',0),(401923,11165,'ko','ì˜ˆê¸ˆ ì‹ ìš©',0),(401924,11165,'he','×¤×™×§×“×•×Ÿ ××©×¨××™',0),(401925,11165,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚',0),(401926,11165,'zh','å­˜æ¬¾ä¿¡ç”¨\r\n',0),(401927,11165,'sv','In kredit',0),(401928,11165,'it','Credito di deposito',0),(401929,11165,'tl','',0),(401930,11165,'th','à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¹€à¸‡à¸´à¸™à¸à¸²à¸',0),(401931,11165,'hi','à¤œà¤®à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(401932,11165,'ms','Kredit Deposit',0),(401933,11165,'ar','Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†ÙŠØ©',0),(401934,11165,'fr','CrÃ©dit de dÃ©pÃ´t',0),(401935,11165,'jp','é é‡‘ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ',0),(401936,11165,'pt','DepÃ³sito crÃ©dito',0),(401937,11165,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(401938,11165,'es','CrÃ©dito de DepÃ³sito',0),(401939,11165,'de','Einzahlung Credit',0),(401940,11165,'en','Deposit Credit',0),(401941,11166,'is','',0),(401942,11166,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(401943,11166,'pr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(401944,11166,'tr','Depozito iadesi',0),(401945,11166,'pl','Zwrotu kaucji',0),(401946,11166,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(401947,11166,'ur','Ø¬Ù…Ø¹ Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(401948,11166,'sr','ÐŸÐ¾Ð²Ñ€Ð°Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(401949,11166,'vi','Tráº£ láº¡i Ä‘áº·t cá»c',0),(401950,11166,'af','Deposito Terugbetaling',0),(401951,11166,'ro','Depozit restituire',0),(401952,11166,'et','Tagatisraha tagastamise',0),(401953,11166,'si','ZajamÄenih vlog nadomestil',0),(401954,11166,'ba','Pengembalian dana deposito',0),(401955,11166,'nl','Deposito restitutie',0),(401956,11166,'fi','Palauttaa',0),(401957,11166,'no','Tilbakebetaling innskudd',0),(401958,11166,'da','Depositum restitution',0),(401959,11166,'ko','ë³´ì¦ê¸ˆ í™˜ë¶ˆ',0),(401960,11166,'he','×”×—×–×¨ ×›×¡×¤×™ ×”×¤×™×§×“×•×Ÿ',0),(401961,11166,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½',0),(401962,11166,'zh','é€€è¿˜æŒ‰é‡‘\r\n',0),(401963,11166,'sv','InsÃ¤ttning Ã¥terbetalning',0),(401964,11166,'it','Rimborso del deposito',0),(401965,11166,'tl','',0),(401966,11166,'th','à¸„à¸·à¸™à¹€à¸‡à¸´à¸™à¸à¸²à¸',0),(401967,11166,'hi','à¤œà¤®à¤¾ à¤µà¤¾à¤ªà¤¸à¥€',0),(401968,11166,'ms','Bayaran balik Deposit',0),(401969,11166,'ar','Ø§Ø³ØªØ±Ø¬Ø§Ø¹ Ø§Ù„ØªØ£Ù…ÙŠÙ†',0),(401970,11166,'fr','Consigne',0),(401971,11166,'jp','é é‡‘ã®æ‰•ã„æˆ»ã—',0),(401972,11166,'pt','RestituiÃ§Ã£o do depÃ³sito',0),(401973,11166,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(401974,11166,'es','DevoluciÃ³n de DepÃ³sito',0),(401975,11166,'de','Kaution RÃ¼ckerstattung',0),(401976,11166,'en','Deposit Refund',0),(401977,11167,'is','',0),(401978,11167,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ø¨Ø§Ù‚ÙŠØ¨ÛŒÙ„Ø§Ù†Ø³',0),(401979,11167,'pr','Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡',0),(401980,11167,'tr','Geri kalan mevduat',0),(401981,11167,'pl','WpÅ‚aciÄ‡ pozostaÅ‚Ä…',0),(401982,11167,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¾ÑÑ‚Ð°Ñ‚ÑŠÐº',0),(401983,11167,'ur','Ø¨Ø§Ù‚ÛŒ Ú©ÛŒ Ø¬Ù…Ø¹',0),(401984,11167,'sr','ÐžÑÑ‚Ð°Ñ‚Ð°Ðº Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(401985,11167,'vi','Pháº§n Ä‘áº·t cá»c cÃ²n láº¡i',0),(401986,11167,'af','Deposito Herinneraar',0),(401987,11167,'ro','Restul de depozit',0),(401988,11167,'et','Hoiuste jÃ¤Ã¤k',0),(401989,11167,'si','Preostanek depozit',0),(401990,11167,'ba','Sisa setoran',0),(401991,11167,'nl','Storting rest',0),(401992,11167,'fi','Talletus jÃ¤ljellÃ¤',0),(401993,11167,'no','Innskudd resten',0),(401994,11167,'da','Indbetal resten',0),(401995,11167,'ko','ë‚˜ë¨¸ì§€ ë³´ì¦ê¸ˆ',0),(401996,11167,'he','×™×ª×¨×ª ×”×¤×™×§×“×•×Ÿ',0),(401997,11167,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(401998,11167,'zh','å­˜æ¬¾ä½™é¢\r\n',0),(401999,11167,'sv','InsÃ¤ttning resten',0),(402000,11167,'it','Resto del deposito',0),(402001,11167,'tl','',0),(402002,11167,'th','à¸¢à¸­à¸”à¸„à¸‡à¹€à¸«à¸¥à¸·à¸­à¸‚à¸­à¸‡à¹€à¸‡à¸´à¸™à¸à¸²à¸',0),(402003,11167,'hi','à¤œà¤®à¤¾ à¤¶à¥‡à¤·',0),(402004,11167,'ms','Baki Deposit',0),(402005,11167,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ø§ ØªØ¨Ù‚Ù‰',0),(402006,11167,'fr','DÃ©pÃ´t reste',0),(402007,11167,'jp','æ²ˆæ®¿ç‰©ã®æ®‹ã‚Š',0),(402008,11167,'pt','DepÃ³sito restante',0),(402009,11167,'ru','ÐžÑÑ‚Ð°Ñ‚Ð¾Ðº Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(402010,11167,'es','Saldo de DepÃ³sito',0),(402011,11167,'de','Anzahlung Rest',0),(402012,11167,'en','Deposit Remainder',0),(402013,11168,'is','',0),(402014,11168,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø´Ø¯Ù‡ ',0),(402015,11168,'pr','Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø´Ø¯Ù‡ ',0),(402016,11168,'tr','Tutulan mevduat',0),(402017,11168,'pl','Depozyt zachowane',0),(402018,11168,'bg','Ð—Ð°Ð´Ð°Ñ‚ÑŠÐº',0),(402019,11168,'ur','Ø¬Ù…Ø¹ Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾ÛŒ',0),(402020,11168,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÐµ Ð·Ð°Ð´Ñ€Ð¶Ð°Ð²Ð°',0),(402021,11168,'vi','Giá»¯ láº¡i pháº§n Ä‘áº·t cá»c',0),(402022,11168,'af','Deposito behou',0),(402023,11168,'ro','Depozit reÅ£inute',0),(402024,11168,'et','KÃ¤siraha',0),(402025,11168,'si','ObdrÅ¾ane',0),(402026,11168,'ba','Deposit yang dipertahankan',0),(402027,11168,'nl','Storting behouden',0),(402028,11168,'fi','KÃ¤sirahan',0),(402029,11168,'no','Innskudd beholdt',0),(402030,11168,'da','Depositum beholdes',0),(402031,11168,'ko','ì˜ˆê¸ˆ ìœ ì§€',0),(402032,11168,'he','×¤×™×§×“×•×Ÿ × ×©×ž×¨',0),(402033,11168,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î´Î¹Î±Ï„Î·ÏÎ¿ÏÎ½Ï„Î±Î¹',0),(402034,11168,'zh','å­˜æ¬¾ä¿ç•™\r\n',0),(402035,11168,'sv','InsÃ¤ttning behÃ¶ll',0),(402036,11168,'it','Deposito conservato',0),(402037,11168,'tl','',0),(402038,11168,'th','à¸à¸²à¸à¹€à¸à¹‡à¸šà¹„à¸§à¹‰',0),(402039,11168,'hi','à¤œà¤®à¤¾ à¤¬à¤°à¤•à¤°à¤¾à¤° à¤°à¤–à¤¾',0),(402040,11168,'ms','Deposit yang disimpan',0),(402041,11168,'ar','Ø§Ù„Ø§Ø­ØªÙØ§Ø¸ Ø¨Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹',0),(402042,11168,'fr','DÃ©pÃ´t conservÃ©',0),(402043,11168,'jp','é é‡‘ã‚’ä¿æŒ',0),(402044,11168,'pt','DepÃ³sito retido',0),(402045,11168,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÐ¾Ñ…Ñ€Ð°Ð½ÑÐµÑ‚ÑÑ',0),(402046,11168,'es','DepÃ³sito Retenido',0),(402047,11168,'de','Kaution behalten',0),(402048,11168,'en','Deposit Retained',0),(402049,11169,'is','',0),(402050,11169,'dr','( Ù…ÙØ§Ø¯ ) Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(402051,11169,'pr','Ø¯Ø±Ø¢Ù…Ø¯ ( Ø³ÙˆØ¯ ) Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(402052,11169,'tr','Teminat gelir',0),(402053,11169,'pl','Depozyt dochodÃ³w',0),(402054,11169,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸',0),(402055,11169,'ur','Ø±ÛŒÙˆÙ†ÛŒÙˆ Ø¬Ù…Ø¹',0),(402056,11169,'sr','ÐŸÑ€Ð¸Ñ…Ð¾Ð´ Ð¾Ð´ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(402057,11169,'vi','Doanh thu tiá»n gá»­i',0),(402058,11169,'af','Deposito Inkomste',0),(402059,11169,'ro','Depozit venituri',0),(402060,11169,'et','Tagatisraha tulud',0),(402061,11169,'si','Depozit prihodkov',0),(402062,11169,'ba','Deposit pendapatan',0),(402063,11169,'nl','Storting inkomsten',0),(402064,11169,'fi','Internet tulot',0),(402065,11169,'no','Innskudd inntekter',0),(402066,11169,'da','Depositum indtÃ¦gter',0),(402067,11169,'ko','ë³´ì¦ê¸ˆ ìˆ˜ìµ',0),(402068,11169,'he','×”×¤×§×“×ª ×”×”×›× ×¡×•×ª',0),(402069,11169,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÏƒÏŒÎ´Ï‰Î½',0),(402070,11169,'zh','å­˜æ¬¾æ”¶å…¥\r\n',0),(402071,11169,'sv','InsÃ¤ttning intÃ¤kter',0),(402072,11169,'it','Deposito entrate',0),(402073,11169,'tl','',0),(402074,11169,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¹€à¸‡à¸´à¸™à¸à¸²à¸',0),(402075,11169,'hi','à¤œà¤®à¤¾ à¤°à¤¾à¤œà¤¸à¥à¤µ',0),(402076,11169,'ms','Hasil Deposit',0),(402077,11169,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª',0),(402078,11169,'fr','Recettes de dÃ©pÃ´t',0),(402079,11169,'jp','é é‡‘ã®åŽç›Š',0),(402080,11169,'pt','DepÃ³sito de receitas',0),(402081,11169,'ru','Ð”Ð¾Ñ…Ð¾Ð´ Ð²ÐºÐ»Ð°Ð´Ð°',0),(402082,11169,'es','Ingreso del DepÃ³sito',0),(402083,11169,'de','Einzahlung Einnahmen',0),(402084,11169,'en','Deposit Revenue',0),(402085,11170,'is','',0),(402086,11170,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(402087,11170,'pr','Ø­Ø³Ø§Ø¨ Ø¯Ø± Ø¢Ù…Ø¯  Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(402088,11170,'tr','Teminat gelir hesabÄ±',0),(402089,11170,'pl','WpÅ‚acie na konto dochodÃ³w',0),(402090,11170,'bg','ÐŸÑ€Ð¸Ñ…Ð¾Ð´Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(402091,11170,'ur','Ø¬Ù…Ø¹ Ø±ÛŒÙˆÛŒÙ†ÛŒÙˆ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(402092,11170,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð° Ð¾Ð´ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(402093,11170,'vi','TÃ i khoáº£n doanh thu tiá»n gá»­i',0),(402094,11170,'af','Deposito Inkomste Rekening',0),(402095,11170,'ro','Cont de depozit la venituri',0),(402096,11170,'et','Tagatisraha tulukonto',0),(402097,11170,'si','Depozitni raÄun prihodkov',0),(402098,11170,'ba','Rekening pendapatan',0),(402099,11170,'nl','Depositorekening inkomsten',0),(402100,11170,'fi','Tulot talletustili',0),(402101,11170,'no','Innskudd inntektskontoen',0),(402102,11170,'da','IndtÃ¦gter indlÃ¥nskonto',0),(402103,11170,'ko','ë³´ì¦ê¸ˆ ìˆ˜ìµ ê³„ì •',0),(402104,11170,'he','×—×©×‘×•×Ÿ ×”×›× ×¡×•×ª ×”×¤×§×“×”',0),(402105,11170,'el','ÎšÎ±Ï„Î±Î¸ÎµÏ„Î¹ÎºÏŒÏ‚ Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÎµÏƒÏŒÎ´Ï‰Î½',0),(402106,11170,'zh','å­˜æ¬¾æ”¶å…¥å¸ç›®\r\n',0),(402107,11170,'sv','IntÃ¤ktskonto',0),(402108,11170,'it','Deposito conto ricavi',0),(402109,11170,'tl','',0),(402110,11170,'th','à¸šà¸±à¸à¸Šà¸µà¹€à¸‡à¸´à¸™à¸à¸²à¸à¸£à¸²à¸¢à¹„à¸”à¹‰',0),(402111,11170,'hi','à¤œà¤®à¤¾ à¤°à¤¾à¤œà¤¸à¥à¤µ à¤–à¤¾à¤¤à¥‡',0),(402112,11170,'ms','Akaun hasil Deposit',0),(402113,11170,'ar','Ø­Ø³Ø§Ø¨ Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª',0),(402114,11170,'fr','Compte de revenu de dÃ©pÃ´t',0),(402115,11170,'jp','é é‡‘ã®åŽç›Šå‹˜å®š',0),(402116,11170,'pt','DepÃ³sito em conta de receita',0),(402117,11170,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð²',0),(402118,11170,'es','Cuenta de Ingreso del DepÃ³sito',0),(402119,11170,'de','Einnahmen-Guthabenkonto',0),(402120,11170,'en','Deposit Revenue Account',0),(402121,11171,'is','',0),(402122,11171,'dr','ØªØ¬Ø¯ÙŠØ¯  Ø§Ø¬Ø§Ø±Ù‡ ',0),(402123,11171,'pr','ØªØ¬Ø¯ÙŠØ¯  Ø§Ø¬Ø§Ø±Ù‡ ',0),(402124,11171,'tr','Kira yenileme',0),(402125,11171,'pl','Odnawianie dzierÅ¼awy',0),(402126,11171,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ð¾Ð´Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(402127,11171,'ur','Ù„ÛŒØ² Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯',0),(402128,11171,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð¾Ð±Ð½Ð¾Ð²Ðµ',0),(402129,11171,'vi','gia háº¡n há»£p Ä‘á»“ng thuÃª',0),(402130,11171,'af','Huurkontrak Hernuwing',0),(402131,11171,'ro','ReÃ®nnoire contract de leasing',0),(402132,11171,'et','ÃœÃ¼rilepingu pikendamine',0),(402133,11171,'si','PodaljÅ¡anje najemne pogodbe',0),(402134,11171,'ba','Perpanjangan sewa',0),(402135,11171,'nl','Lease-overeenkomst verlenging',0),(402136,11171,'fi','Varauksen uusiminen',0),(402137,11171,'no','Fornying av leieavtalen',0),(402138,11171,'da','Rettighedsfornyelse',0),(402139,11171,'ko','ìž„ëŒ€ ê°±ì‹ ',0),(402140,11171,'he','×—×™×“×•×© ×”×—×›×™×¨×”',0),(402141,11171,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ· Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(402142,11171,'zh','ç»­çº¦\r\n',0),(402143,11171,'sv','Hyresavtalet fÃ¶rnyas',0),(402144,11171,'it','Rinnovo contratto di locazione',0),(402145,11171,'tl','',0),(402146,11171,'th','à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(402147,11171,'hi','à¤²à¥€à¤œ à¤¨à¤µà¥€à¤•à¤°à¤£',0),(402148,11171,'ms','Pembaharuan pajakan',0),(402149,11171,'ar','ØªØ¬Ø¯ÙŠØ¯ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(402150,11171,'fr','Renouvellement de bail',0),(402151,11171,'jp','ãƒªãƒ¼ã‚¹ã®æ›´æ–°',0),(402152,11171,'pt','RenovaÃ§Ã£o de concessÃ£o',0),(402153,11171,'ru','Ð’Ð¾Ð·Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(402154,11171,'es','RenovaciÃ³n de Arrendamiento',0),(402155,11171,'de','Erneuerung der Lease',0),(402156,11171,'en','Lease Renewal',0),(402157,11172,'is','',0),(402158,11172,'dr','ØªØ¬Ø¯ÙŠØ¯  Ø§Ø¬Ø§Ø±Ù‡  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(402159,11172,'pr','ØªØ¬Ø¯ÙŠØ¯  Ø§Ø¬Ø§Ø±Ù‡  Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(402160,11172,'tr','Kira baÅŸarÄ±yla yenilendi',0),(402161,11172,'pl','DzierÅ¼awa odnawiana pomyÅ›lnie',0),(402162,11172,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³, Ð¿Ð¾Ð´Ð½Ð¾Ð²ÑÐ²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(402163,11172,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ¬Ø¯ÛŒØ¯ Ù„ÛŒØ²',0),(402164,11172,'sr','Ð—Ð°ÐºÑƒÐ¿ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ñ™ÐµÐ½Ð°',0),(402165,11172,'vi','gia háº¡n há»£p Ä‘á»“ng thuÃª thÃ nh cÃ´ng',0),(402166,11172,'af','Hernu van Huurooreenkoms Suksesvol',0),(402167,11172,'ro','Leasing reÃ®nnoit cu succes',0),(402168,11172,'et','ÃœÃ¼rilepingu pikendamist edukalt',0),(402169,11172,'si','Najem podaljÅ¡a uspeÅ¡no',0),(402170,11172,'ba','Sewa memperbaharui berhasil',0),(402171,11172,'nl','Lease vernieuwd met succes',0),(402172,11172,'fi','Vuokrasopimuksen uudelleen onnistuneesti',0),(402173,11172,'no','Leieavtalen fornyet vellykket',0),(402174,11172,'da','Lease fornyes med succes',0),(402175,11172,'ko','ì„±ê³µì ìœ¼ë¡œ ê°±ì‹  ìž„ëŒ€',0),(402176,11172,'he','×©×›×™×¨×•×ª ×ž×ª×—×“×© ×‘×”×¦×œ×—×”',0),(402177,11172,'el','ÎœÎ¹ÏƒÎ¸ÏŽÏƒÎµÏ‰Î½ Î±Î½Î±Î½Î­Ï‰ÏƒÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(402178,11172,'zh','ç»­è®¢ç§ŸèµæˆåŠŸ\r\n',0),(402179,11172,'sv','Hyresavtalet fÃ¶rnyas framgÃ¥ngsrikt',0),(402180,11172,'it','Contratto di locazione rinnovato con successo',0),(402181,11172,'tl','',0),(402182,11172,'th','à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¸—à¸µà¹ˆà¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(402183,11172,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(402184,11172,'ms','Pajakan yang diperbaharui berjaya',0),(402185,11172,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø¬Ø¯ÙŠØ¯ Ø¨Ù†Ø¬Ø§Ø­',0),(402186,11172,'fr','Bail renouvelÃ© avec succÃ¨s',0),(402187,11172,'jp','ãƒªãƒ¼ã‚¹ã®æ›´æ–°ã«æˆåŠŸã€‚',0),(402188,11172,'pt','Contrato renovado com Ãªxito',0),(402189,11172,'ru','ÐÑ€ÐµÐ½Ð´Ð°, Ð²Ð½Ð¾Ð²ÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(402190,11172,'es','Arrendamiento Renovado Exitosamente',0),(402191,11172,'de','Lease erfolgreich erneuert',0),(402192,11172,'en','Lease Renewed Successfully',0),(402193,11173,'is','',0),(402194,11173,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ Ø§Ø³Øª  ',0),(402195,11173,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ Ø§Ø³Øª  ',0),(402196,11173,'tr','Kira baÅŸarÄ±yla sonlandÄ±rÄ±ldÄ±',0),(402197,11173,'pl','DzierÅ¼awy zakoÅ„czone pomyÅ›lnie',0),(402198,11173,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð² Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€, Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(402199,11173,'ur','Ù„ÛŒØ² Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø®ØªÙ… Ú©Ø± Ø¯ÛŒØ§',0),(402200,11173,'sr','Ð—Ð°ÐºÑƒÐ¿ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€ÐµÐºÐ¸Ð½ÑƒÑ‚Ð°',0),(402201,11173,'vi','Káº¿t thÃºc há»£p Ä‘á»“ng thuÃª thÃ nh cÃ´ng',0),(402202,11173,'af','Huurkontrak Suksesvol BeÃ«indig',0),(402203,11173,'ro','Contract de Ã®nchiriere Ã®ncheiat cu succes',0),(402204,11173,'et','ÃœÃ¼rileping lÃµpetatakse edukalt',0),(402205,11173,'si','Zakup konÄa uspeÅ¡no',0),(402206,11173,'ba','Sewa dihentikan berhasil',0),(402207,11173,'nl','Lease met succes beÃ«indigd',0),(402208,11173,'fi','Vuokrasopimus pÃ¤Ã¤ttyy onnistuneesti',0),(402209,11173,'no','Leieavtalen avsluttet vellykket',0),(402210,11173,'da','Lejekontrakten afsluttes med succes',0),(402211,11173,'ko','ìž„ëŒ€ ì„±ê³µì ìœ¼ë¡œ ì¢…ë£Œ',0),(402212,11173,'he','×—×•×–×” ×”×©×›×™×¨×•×ª ×”×¡×ª×™×™×ž×” ×‘×”×¦×œ×—×”',0),(402213,11173,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(402214,11173,'zh','æˆåŠŸç»ˆæ­¢ç§Ÿèµ\r\n',0),(402215,11173,'sv','Hyresavtalet avslutas framgÃ¥ngsrikt',0),(402216,11173,'it','Leasing terminato con successo',0),(402217,11173,'tl','',0),(402218,11173,'th','à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸¥à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(402219,11173,'hi','à¤²à¥€à¤œ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤ˆ',0),(402220,11173,'ms','Pajakan yang diberhentikan telah berjaya',0),(402221,11173,'ar','Ø§Ù„ØªØ£Ø¬ÙŠØ± Ø§Ù„ØªÙŠ Ø£Ù†Ù‡ÙŠØª Ø¨Ù†Ø¬Ø§Ø­',0),(402222,11173,'fr','Bail rÃ©siliÃ© avec succÃ¨s',0),(402223,11173,'jp','ãƒªãƒ¼ã‚¹ãŒæ­£å¸¸ã«çµ‚äº†',0),(402224,11173,'pt','Contrato encerrado com Ãªxito',0),(402225,11173,'ru','ÐÑ€ÐµÐ½Ð´Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°',0),(402226,11173,'es','Arrendamiento Terminado Exitosamente',0),(402227,11173,'de','Lease erfolgreich beendet',0),(402228,11173,'en','Lease Terminated Successfully',0),(402229,11174,'is','',0),(402230,11174,'dr','Pet DepositØ§Ø¹ØªØ¨Ø§Ø± (Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±',0),(402231,11174,'pr','Pet DepositØ§Ø¹ØªØ¨Ø§Ø± (Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±\r\n',0),(402232,11174,'tr','Evde beslenen hayvan mevduat kredi',0),(402233,11174,'pl','Depozyt pieÅ›ciÄ‡ kredytowe',0),(402234,11174,'bg','Ð”Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð»ÑŽÐ±Ð¸Ð¼Ñ†Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°',0),(402235,11174,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± Ø¬Ù…Ø¹ Ú©Ø±ÛŒÚˆÙ¹',0),(402236,11174,'sr','Ð‰ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ',0),(402237,11174,'vi','Váº­t nuÃ´i tiá»n gá»­i tÃ­n dá»¥ng',0),(402238,11174,'af','Troeteldier deposito krediet',0),(402239,11174,'ro','Animal de casÄƒ depozit de Credit',0),(402240,11174,'et','Lemmikloomade hoiuse krediidi',0),(402241,11174,'si','HiÅ¡nih depozita kreditne',0),(402242,11174,'ba','Hewan peliharaan Deposit kredit',0),(402243,11174,'nl','Huisdier storting krediet',0),(402244,11174,'fi','LemmikkielÃ¤inten talletus luotto',0),(402245,11174,'no','Pet depositum kreditt',0),(402246,11174,'da','KÃ¦ledyr depositum kredit',0),(402247,11174,'ko','ì• ì™„ ë™ë¬¼ ì˜ˆê¸ˆ ì‹ ìš©',0),(402248,11174,'he','××©×¨××™ ×”×¤×™×§×“×•×Ÿ ×œ×—×™×•×ª ×ž×—×ž×“',0),(402249,11174,'el','ÎšÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½',0),(402250,11174,'zh','å® ç‰©å…¥å¸\r\n',0),(402251,11174,'sv','SÃ¤llskapsdjur in kredit',0),(402252,11174,'it','Credito di deposito domestico',0),(402253,11174,'tl','',0),(402254,11174,'th','à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(402255,11174,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤œà¤®à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(402256,11174,'ms','Kredit Deposit haiwan kesayangan',0),(402257,11174,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ©',0),(402258,11174,'fr','Pour animaux de compagnie de crÃ©dit',0),(402259,11174,'jp','ãƒšãƒƒãƒˆ ãƒ‡ãƒã‚¸ãƒƒãƒˆ ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ',0),(402260,11174,'pt','CrÃ©dito depÃ³sito de animais',0),(402261,11174,'ru','Pet Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(402262,11174,'es','CrÃ©dito de DepÃ³sito Para Mascota',0),(402263,11174,'de','Haustier Einzahlung Credit',0),(402264,11174,'en','Pet Deposit Credit',0),(402265,11175,'is','',0),(402266,11175,'dr','Pet Deposit Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(402267,11175,'pr','Pet Deposit Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(402268,11175,'tr','Evde beslenen hayvan Depozito iadesi',0),(402269,11175,'pl','Zwrotu kaucji zwierzÄ™',0),(402270,11175,'bg','Ð”Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð»ÑŽÐ±Ð¸Ð¼Ñ†Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(402271,11175,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± Ø¬Ù…Ø¹ Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(402272,11175,'sr','ÐŸÐ¾Ð²Ñ€Ð°Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð·Ð° ÐºÑƒÑ›Ð½Ðµ Ñ™ÑƒÐ±Ð¸Ð¼Ñ†Ðµ',0),(402273,11175,'vi','tráº£ láº¡i tiá»n gá»­i Ä‘áº·c biá»‡t',0),(402274,11175,'af','Troeteldier deposito terugbetaling',0),(402275,11175,'ro','Animal de casÄƒ depozit restituire',0),(402276,11175,'et','Lemmikloomade hoiuse toetuse',0),(402277,11175,'si','HiÅ¡nih depozita nadomestila',0),(402278,11175,'ba','Pengembalian dana deposito hewan peliharaan',0),(402279,11175,'nl','Huisdier deposito restitutie',0),(402280,11175,'fi','HellitellÃ¤ palauttaa',0),(402281,11175,'no','Pet innskudd tilbakebetaling',0),(402282,11175,'da','KÃ¦ledyr depositum restitution',0),(402283,11175,'ko','ì• ì™„ ë™ë¬¼ ë³´ì¦ê¸ˆ í™˜ë¶ˆ',0),(402284,11175,'he','×”×—×–×¨ ×›×¡×¤×™ ×”×¤×™×§×“×•×Ÿ ×œ×—×™×•×ª ×ž×—×ž×“',0),(402285,11175,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½',0),(402286,11175,'zh','å® ç‰©è¿”è¿˜å®šé‡‘\r\n',0),(402287,11175,'sv','PET insÃ¤ttning Ã¥terbetalning',0),(402288,11175,'it','Rimborso deposito domestico',0),(402289,11175,'tl','',0),(402290,11175,'th','à¸„à¸·à¸™à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(402291,11175,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤œà¤®à¤¾ à¤µà¤¾à¤ªà¤¸à¥€',0),(402292,11175,'ms','Bayaran balik Deposit haiwan kesayangan',0),(402293,11175,'ar','Ø§Ø³ØªØ±Ø¬Ø§Ø¹ Ø§Ù„ØªØ£Ù…ÙŠÙ† Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ©',0),(402294,11175,'fr','Consigne pour animaux de compagnie',0),(402295,11175,'jp','ãƒšãƒƒãƒˆã®é é‡‘ã®æ‰•ã„æˆ»ã—',0),(402296,11175,'pt','RestituiÃ§Ã£o de depÃ³sito de animais',0),(402297,11175,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° ÐŸÐ­Ð¢',0),(402298,11175,'es','DevoluciÃ³n de DepÃ³sito Para Mascota',0),(402299,11175,'de','Haustier Kaution RÃ¼ckerstattung',0),(402300,11175,'en','Pet Deposit Refund',0),(402301,11176,'is','',0),(402302,11176,'dr','Pet DepositØ¨Ø§Ù‚ÙŠ Ø¨ÛŒÙ„Ø§Ù†Ø³ ',0),(402303,11176,'pr','Pet DepositØ¨Ø§Ù‚ÙŠ Ù…Ø§Ù†Ø¯Ù‡ ',0),(402304,11176,'tr','Evde beslenen hayvan depozito geri kalan',0),(402305,11176,'pl','PieÅ›ciÄ‡ wpÅ‚aty pozostaÅ‚ej',0),(402306,11176,'bg','Ð“Ð°Ð»ÐµÐ½Ð¸Ðº Ð²Ð»Ð¾Ð³ Ð¾ÑÑ‚Ð°Ñ‚ÑŠÐº',0),(402307,11176,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± Ø¬Ù…Ø¹ Ø¨Ø§Ù‚ÛŒ',0),(402308,11176,'sr','ÐžÑÑ‚Ð°Ñ‚Ð°Ðº Ð¿Ñ€Ð¸ Ð´ÐµÑ™ÐµÑšÑƒ Ñ™ÑƒÐ±Ð¸Ð¼Ñ†Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(402309,11176,'vi','cÃ²n láº¡i tiá»n gá»­i Ä‘áº·c biá»‡t',0),(402310,11176,'af','Troeteldier deposito Restant',0),(402311,11176,'ro','Animal de casÄƒ depozit restul',0),(402312,11176,'et','Lemmikloomade hoiuse jÃ¤Ã¤k',0),(402313,11176,'si','Preostanek hiÅ¡nih depozita',0),(402314,11176,'ba','Sisa Deposit hewan peliharaan',0),(402315,11176,'nl','Huisdier storting rest',0),(402316,11176,'fi','LemmikkielÃ¤inten talletus jÃ¤ljellÃ¤',0),(402317,11176,'no','Pet innskudd resten',0),(402318,11176,'da','KÃ¦ledyr depositum resten',0),(402319,11176,'ko','ì• ì™„ ë™ë¬¼ ë³´ì¦ê¸ˆ ë‚˜ë¨¸ì§€',0),(402320,11176,'he','×™×ª×¨×ª ×”×¤×™×§×“×•×Ÿ ×œ×—×™×•×ª ×ž×—×ž×“',0),(402321,11176,'el','Î¥Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½',0),(402322,11176,'zh','å® ç‰©å­˜æ¬¾ä½™é¢\r\n',0),(402323,11176,'sv','PET insÃ¤ttning resten',0),(402324,11176,'it','Resto dell\'animale domestico del deposito',0),(402325,11176,'tl','',0),(402326,11176,'th','à¸ªà¹ˆà¸§à¸™à¸—à¸µà¹ˆà¹€à¸«à¸¥à¸·à¸­à¸à¸²à¸à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(402327,11176,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤œà¤®à¤¾ à¤¶à¥‡à¤·',0),(402328,11176,'ms','Baki Deposit haiwan kesayangan',0),(402329,11176,'ar','Ø§Ù„Ø¨Ø§Ù‚ÙŠ Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ©',0),(402330,11176,'fr','Reste de dÃ©pÃ´t pour animaux de compagnie',0),(402331,11176,'jp','ãƒšãƒƒãƒˆ ãƒ‡ãƒã‚¸ãƒƒãƒˆæ®‹ã‚Š',0),(402332,11176,'pt','Restante do depÃ³sito de animais',0),(402333,11176,'ru','ÐžÑÑ‚Ð°Ñ‚Ð¾Ðº Pet Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(402334,11176,'es','Saldo de DepÃ³sito Para Mascota',0),(402335,11176,'de','Haustier Anzahlung Rest',0),(402336,11176,'en','Pet Deposit Remainder',0),(402337,11177,'is','',0),(402338,11177,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø§Ø¬Ø§Ø±Ù‡ ',0),(402339,11177,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø§Ø¬Ø§Ø±Ù‡ ',0),(402340,11177,'tr','Ä°ÅŸlem kira',0),(402341,11177,'pl','Proces dzierÅ¼awy',0),(402342,11177,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑÐ° Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(402343,11177,'ur','Ø¹Ù…Ù„ Ù„ÛŒØ²',0),(402344,11177,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ Ð·Ð°ÐºÑƒÐ¿Ð°',0),(402345,11177,'vi','tiáº¿n hÃ nh thuÃª',0),(402346,11177,'af','Prosesseer Huurkontrak',0),(402347,11177,'ro','Procesul de Ã®nchiriere',0),(402348,11177,'et','Protsessi rendile',0),(402349,11177,'si','Postopek najema',0),(402350,11177,'ba','Proses sewa',0),(402351,11177,'nl','Proces Lease',0),(402352,11177,'fi','Prosessin vuokrasopimuksen',0),(402353,11177,'no','Prosessen Lease',0),(402354,11177,'da','Processen Lease',0),(402355,11177,'ko','í”„ë¡œì„¸ìŠ¤ ìž„ëŒ€',0),(402356,11177,'he','×ª×”×œ×™×š ×—×›×™×¨×”',0),(402357,11177,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(402358,11177,'zh','å¤„ç†ç§Ÿèµ\r\n',0),(402359,11177,'sv','Processen Lease',0),(402360,11177,'it','Processo Lease',0),(402361,11177,'tl','',0),(402362,11177,'th','à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£à¹€à¸Šà¹ˆà¸²',0),(402363,11177,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‡ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(402364,11177,'ms','Proses pajakan',0),(402365,11177,'ar','Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(402366,11177,'fr','Bail de processus',0),(402367,11177,'jp','ãƒªãƒ¼ã‚¹ ãƒ—ãƒ­ã‚»ã‚¹',0),(402368,11177,'pt','LocaÃ§Ã£o de processo',0),(402369,11177,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(402370,11177,'es','Procesar Arrendamiento',0),(402371,11177,'de','Prozess-Leasing',0),(402372,11177,'en','Process Lease',0),(402373,11178,'is','',0),(402374,11178,'dr','Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø±',0),(402375,11178,'pr','Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø±',0),(402376,11178,'tr','GÃ¼venlik Depozito iadesi',0),(402377,11178,'pl','Zwrot depozytu gwarancyjnego',0),(402378,11178,'bg','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(402379,11178,'ur','Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ Ø¬Ù…Ø¹ Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(402380,11178,'sr','ÐŸÐ¾Ð²Ñ€Ð°Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð±ÐµÐ·Ð±ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(402381,11178,'vi','HoÃ n tráº£ tiá»n cá»c an ninh',0),(402382,11178,'af','Sekuriteit deposito terugbetaling',0),(402383,11178,'ro','Restituirea de depozit de securitate',0),(402384,11178,'et','Turvalisus hoiuste tagastamise',0),(402385,11178,'si','Security depozit nadomestila',0),(402386,11178,'ba','Pengembalian dana deposito keamanan',0),(402387,11178,'nl','Security deposito restitutie',0),(402388,11178,'fi','Arvopaperi palauttaa',0),(402389,11178,'no','Sikkerhet innskudd tilbakebetaling',0),(402390,11178,'da','Sikkerhed depositum restitution',0),(402391,11178,'ko','ë³´ì•ˆ ë³´ì¦ê¸ˆ í™˜ë¶ˆ',0),(402392,11178,'he','×”×—×–×¨ ×¤×™×§×“×•×Ÿ ×”××‘×˜×—×”',0),(402393,11178,'el','Î‘ÏƒÏ†Î¬Î»ÎµÎ¹Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚',0),(402394,11178,'zh','é€€è¿˜ä¿è¯é‡‘\r\n',0),(402395,11178,'sv','SÃ¤kerhet deposition Ã¥terbetalning',0),(402396,11178,'it','Restituzione di deposito di sicurezza',0),(402397,11178,'tl','',0),(402398,11178,'th','à¸„à¸·à¸™à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸„à¸§à¸²à¸¡à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢',0),(402399,11178,'hi','à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤œà¤®à¤¾ à¤µà¤¾à¤ªà¤¸à¥€',0),(402400,11178,'ms','Bayaran balik Deposit sekuriti',0),(402401,11178,'ar','Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ø£Ù…Ù†',0),(402402,11178,'fr','Consigne de sÃ©curitÃ©',0),(402403,11178,'jp','ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£é é‡‘ã®æ‰•ã„æˆ»ã—',0),(402404,11178,'pt','RestituiÃ§Ã£o de depÃ³sito de seguranÃ§a',0),(402405,11178,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð±ÐµÐ·Ð¾Ð¿Ð°ÑÐ½Ð¾ÑÑ‚Ð¸',0),(402406,11178,'es','DevoluciÃ³n de DepÃ³sito de Seguridad',0),(402407,11178,'de','Sicherheit Kaution RÃ¼ckerstattung',0),(402408,11178,'en','Security Deposit Refund',0),(402409,11179,'is','',0),(402410,11179,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†ÙˆØ¹',0),(402411,11179,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†ÙˆØ¹',0),(402412,11179,'tr','TÃ¼rÃ¼ seÃ§in',0),(402413,11179,'pl','Wybierz typ',0),(402414,11179,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿',0),(402415,11179,'ur','Ù‚Ø³Ù… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(402416,11179,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿',0),(402417,11179,'vi','Chá»n loáº¡i',0),(402418,11179,'af','Kies tipe',0),(402419,11179,'ro','SelectaÅ£i tipul de',0),(402420,11179,'et','Valige tÃ¼Ã¼p',0),(402421,11179,'si','Izberite vrsto',0),(402422,11179,'ba','Pilih jenis',0),(402423,11179,'nl','Selecteer Type',0),(402424,11179,'fi','Valitse tyyppi',0),(402425,11179,'no','Velg Type',0),(402426,11179,'da','VÃ¦lg Type',0),(402427,11179,'ko','ìœ í˜• ì„ íƒ',0),(402428,11179,'he','×‘×—×¨ ×¡×•×’',0),(402429,11179,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„ÏÏ€Î¿',0),(402430,11179,'zh','é€‰æ‹©ç±»åž‹\r\n',0),(402431,11179,'sv','VÃ¤lj typ',0),(402432,11179,'it','Selezionare il tipo',0),(402433,11179,'tl','',0),(402434,11179,'th','à¹€à¸¥à¸·à¸­à¸à¸Šà¸™à¸´à¸”',0),(402435,11179,'hi','à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(402436,11179,'ms','Pilih jenis',0),(402437,11179,'ar','Ø§Ø®ØªØ± Ù†ÙˆØ¹',0),(402438,11179,'fr','SÃ©lectionnez le Type',0),(402439,11179,'jp','ã‚¿ã‚¤ãƒ—ã‚’é¸æŠžã—ã¾ã™',0),(402440,11179,'pt','Selecione o tipo',0),(402441,11179,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¢Ð¸Ð¿',0),(402442,11179,'es','Selecciona el Tipo',0),(402443,11179,'de','WÃ¤hlen Sie Art',0),(402444,11179,'en','Select Type',0),(402445,11180,'is','',0),(402446,11180,'dr','(Ø¹Ø¨Ø§Ø±Øª',0),(402447,11180,'pr','Ø´Ø±Ø§ÙŠØ·(Ø¹Ø¨Ø§Ø±Øª',0),(402448,11180,'tr','Terimi',0),(402449,11180,'pl','Termin',0),(402450,11180,'bg','Ð¢ÐµÑ€Ð¼Ð¸Ð½ÑŠÑ‚',0),(402451,11180,'ur','Ø§ØµØ·Ù„Ø§Ø­',0),(402452,11180,'sr','Ð¢ÐµÑ€Ð¼Ð¸Ð½',0),(402453,11180,'vi','danh má»¥c',0),(402454,11180,'af','Termyn',0),(402455,11180,'ro','Termen',0),(402456,11180,'et','MÃµiste',0),(402457,11180,'si','Izraz',0),(402458,11180,'ba','Istilah',0),(402459,11180,'nl','Termijn',0),(402460,11180,'fi','AikavÃ¤lillÃ¤',0),(402461,11180,'no','Begrepet',0),(402462,11180,'da','Sigt',0),(402463,11180,'ko','ìš©ì–´',0),(402464,11180,'he','×”×ž×•× ×—',0),(402465,11180,'el','ÎŒÏÎ¿Ï‚',0),(402466,11180,'zh','æ¡æ¬¾\r\n',0),(402467,11180,'sv','Termen',0),(402468,11180,'it','Termine',0),(402469,11180,'tl','',0),(402470,11180,'th','à¸£à¸°à¸¢à¸°',0),(402471,11180,'hi','à¤¶à¤¬à¥à¤¦',0),(402472,11180,'ms','Istilah',0),(402473,11180,'ar','Ù…ØµØ·Ù„Ø­',0),(402474,11180,'fr','Terme',0),(402475,11180,'jp','ç”¨èªž',0),(402476,11180,'pt','Termo',0),(402477,11180,'ru','Ð¡Ñ€Ð¾Ðº',0),(402478,11180,'es','TÃ©rmino',0),(402479,11180,'de','Begriff',0),(402480,11180,'en','Term',0),(402481,11181,'is','',0),(402482,11181,'dr','Ù¾Ø§ÙŠØ§Ù† Ø§Ø¬Ø§Ø±Ù‡ ',0),(402483,11181,'pr','Ù¾Ø§ÙŠØ§Ù† Ø§Ø¬Ø§Ø±Ù‡ ',0),(402484,11181,'tr','Kira sonlandÄ±rmak',0),(402485,11181,'pl','Wypowiedzenia umowy najmu',0),(402486,11181,'bg','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‚Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(402487,11181,'ur','Ù„ÛŒØ² Ø®ØªÙ…',0),(402488,11181,'sr','ÐŸÑ€ÐµÐºÐ¸Ð½ÑƒÑ‚Ð¸ Ð½Ð°Ñ˜Ð°Ð¼',0),(402489,11181,'vi','Cháº¥m dá»©t cho thuÃª',0),(402490,11181,'af','BeÃ«indig Huurkontrak',0),(402491,11181,'ro','Rezilieze leasing',0),(402492,11181,'et','LÃµpetada Ã¼Ã¼rileping',0),(402493,11181,'si','Prekinitev najemne pogodbe',0),(402494,11181,'ba','Mengakhiri sewa',0),(402495,11181,'nl','BeÃ«indigen van Lease',0),(402496,11181,'fi','Irtisanoa vuokrasopimuksen',0),(402497,11181,'no','Avslutte Lease',0),(402498,11181,'da','Opsige lejemÃ¥let',0),(402499,11181,'ko','ìž„ëŒ€ ì¢…ë£Œ',0),(402500,11181,'he','×œ×¡×™×™× ××ª ×”×—×›×™×¨×”',0),(402501,11181,'el','Î¤ÎµÏÎ¼Î±Ï„Î¹ÏƒÎ¼ÏŒÏ‚ Lease',0),(402502,11181,'zh','ç»ˆæ­¢ç§Ÿèµ\r\n',0),(402503,11181,'sv','SÃ¤ga upp hyresavtalet',0),(402504,11181,'it','Rescindere il contratto di locazione',0),(402505,11181,'tl','',0),(402506,11181,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(402507,11181,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤',0),(402508,11181,'ms','Menamatkan pajakan',0),(402509,11181,'ar','Ø¥Ù†Ù‡Ø§Ø¡ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(402510,11181,'fr','RÃ©silier le bail',0),(402511,11181,'jp','ãƒªãƒ¼ã‚¹ã‚’çµ‚äº†ã—ã¾ã™ã€‚',0),(402512,11181,'pt','Rescindir o contrato de arrendamento',0),(402513,11181,'ru','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð°Ñ€ÐµÐ½Ð´Ñƒ',0),(402514,11181,'es','Terminar Arrendamiento',0),(402515,11181,'de','Mietvertrag kÃ¼ndigen',0),(402516,11181,'en','Terminate Lease',0),(402517,11182,'is','',0),(402518,11182,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„) Ø§Ø¬Ø§Ø±Ù‡',0),(402519,11182,'pr','Ø­ÙˆØ§Ù„Ù‡(Ø§Ù†ØªÙ‚Ø§Ù„) Ø§Ø¬Ø§Ø±Ù‡',0),(402520,11182,'tr','Transfer kira',0),(402521,11182,'pl','Przeniesienie umowy najmu',0),(402522,11182,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(402523,11182,'ur','Ù„ÛŒØ² Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(402524,11182,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(402525,11182,'vi','Chuyá»ƒn cho thuÃª',0),(402526,11182,'af','Oordae van Huurkontrak',0),(402527,11182,'ro','Contract de leasing se transferÄƒ',0),(402528,11182,'et','ÃœÃ¼rilepingu Ã¼leandmine',0),(402529,11182,'si','Prenos najema',0),(402530,11182,'ba','Mentransfer sewa',0),(402531,11182,'nl','Overdracht Lease',0),(402532,11182,'fi','Siirto vuokrasopimuksen',0),(402533,11182,'no','OverfÃ¸re Lease',0),(402534,11182,'da','OverfÃ¸re Lease',0),(402535,11182,'ko','ì „ì†¡ ìž„ëŒ€',0),(402536,11182,'he','×”×¢×‘×¨×ª ×©×›×™×¨×•×ª',0),(402537,11182,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(402538,11182,'zh','è½¬è®©ç§Ÿèµ\r\n',0),(402539,11182,'sv','Ã–verfÃ¶ra Lease',0),(402540,11182,'it','Trasferire il contratto di locazione',0),(402541,11182,'tl','',0),(402542,11182,'th','à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¹‚à¸­à¸™',0),(402543,11182,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤Ÿà¥à¤Ÿà¤¾',0),(402544,11182,'ms','Memindahkan pajakan',0),(402545,11182,'ar','Ù†Ù‚Ù„ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(402546,11182,'fr','Transfert de bail',0),(402547,11182,'jp','è»¢é€ãƒªãƒ¼ã‚¹',0),(402548,11182,'pt','TransferÃªncia de locaÃ§Ã£o',0),(402549,11182,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð´ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(402550,11182,'es','Transferir Arrendamiento',0),(402551,11182,'de','Transfer-Leasing',0),(402552,11182,'en','Transfer Lease',0),(402553,11183,'is','',0),(402554,11183,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø§Ø¬Ø§Ø±Ù‡ ',0),(402555,11183,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø§Ø¬Ø§Ø±Ù‡ ',0),(402556,11183,'tr','Kira seÃ§in',0),(402557,11183,'pl','Wybierz leasing',0),(402558,11183,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(402559,11183,'ur','Ù„ÛŒØ² Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(402560,11183,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ñ˜Ð°Ð¼',0),(402561,11183,'vi','Chá»n cho thuÃª',0),(402562,11183,'af','Kies Verhuring',0),(402563,11183,'ro','SelectaÅ£i leasing',0),(402564,11183,'et','Valige Ã¼Ã¼rileping',0),(402565,11183,'si','Izberite najema',0),(402566,11183,'ba','Pilih sewa',0),(402567,11183,'nl','Selecteer Lease',0),(402568,11183,'fi','Valitse vuokrasopimuksen',0),(402569,11183,'no','Velg Lease',0),(402570,11183,'da','VÃ¦lg Lease',0),(402571,11183,'ko','ìž„ëŒ€ë¥¼ ì„ íƒ',0),(402572,11183,'he','×‘×—×¨ ×—×›×™×¨×”',0),(402573,11183,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(402574,11183,'zh','é€‰æ‹©ç§Ÿèµ\r\n',0),(402575,11183,'sv','VÃ¤lj Lease',0),(402576,11183,'it','Selezionare il contratto di locazione',0),(402577,11183,'tl','',0),(402578,11183,'th','à¹€à¸¥à¸·à¸­à¸à¹€à¸Šà¹ˆà¸²',0),(402579,11183,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(402580,11183,'ms','Pilih pajakan',0),(402581,11183,'ar','Ø­Ø¯Ø¯ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(402582,11183,'fr','SÃ©lectionnez le bail',0),(402583,11183,'jp','ãƒªãƒ¼ã‚¹ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(402584,11183,'pt','Selecione locaÃ§Ã£o',0),(402585,11183,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐÑ€ÐµÐ½Ð´Ð°',0),(402586,11183,'es','Selecciona el Arrendamiento',0),(402587,11183,'de','WÃ¤hlen Sie Leasing',0),(402588,11183,'en','Select Lease',0),(402589,11184,'is','',0),(402590,11184,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù…Ø³ØªØ§Ø¬Ø± ',0),(402591,11184,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù…Ø³ØªØ§Ø¬Ø± ',0),(402592,11184,'tr','Faturalar kiracÄ± yÃ¶nergeleri',0),(402593,11184,'pl','Najemcy faktury instrukcje',0),(402594,11184,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(402595,11184,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± ÛØ¯Ø§ÛŒØ§Øª ÙˆØ¨Ø¬Ù„ÛŒ',0),(402596,11184,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(402597,11184,'vi','HÆ°á»›ng dáº«n cho hÃ³a Ä‘Æ¡n ngÆ°á»i thuÃª nhÃ ',0),(402598,11184,'af','Huurder Fakture Instruksies',0),(402599,11184,'ro','ChiriaÅŸ facturi instrucÅ£iuni',0),(402600,11184,'et','ÃœÃ¼rnik arved juhiseid',0),(402601,11184,'si','Najemnik raÄuni navodila',0),(402602,11184,'ba','Penyewa faktur petunjuk',0),(402603,11184,'nl','Huurder facturen instructies',0),(402604,11184,'fi','Vuokralainen laskut ohjeet',0),(402605,11184,'no','Leietaker fakturaer instruksjoner',0),(402606,11184,'da','Lejer fakturaer instruktioner',0),(402607,11184,'ko','ì„¸ ìž…ìž ì†¡ìž¥ ì§€ì¹¨',0),(402608,11184,'he','×”×“×™×™×¨ ×—×©×‘×•× ×™×•×ª ×”×•×¨××•×ª',0),(402609,11184,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(402610,11184,'zh','ä¸šæƒäººå‘ç¥¨è¯´æ˜Ž\r\n',0),(402611,11184,'sv','HyresgÃ¤sten fakturor instruktioner',0),(402612,11184,'it','Inquilino fatture istruzioni',0),(402613,11184,'tl','',0),(402614,11184,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(402615,11184,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤šà¤¾à¤²à¤¾à¤¨',0),(402616,11184,'ms','Penyewa invois arahan',0),(402617,11184,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(402618,11184,'fr','Locataire les factures Instructions',0),(402619,11184,'jp','è«‹æ±‚æ›¸ã®å€Ÿç”¨è€…å‘½ä»¤',0),(402620,11184,'pt','Inquilino Invoices instruÃ§Ãµes',0),(402621,11184,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð° ÑÑ‡ÐµÑ‚Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(402622,11184,'es','Instrucciones de Facturas de Inquilinos',0),(402623,11184,'de','Mieter Rechnungen Anweisungen',0),(402624,11184,'en','Tenant Invoices Instructions',0),(402625,11185,'is','',0),(402626,11185,'dr','(Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ',0),(402627,11185,'pr','ØªØ§Ø±ÙŠØ® Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ(Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ',0),(402628,11185,'tr','Hareket tarihi',0),(402629,11185,'pl','PoruszaÄ‡ siÄ™ w dniu',0),(402630,11185,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸ Ð² Ð´Ð°Ñ‚Ð°',0),(402631,11185,'ur','ØªØ§Ø±ÛŒØ® Ù…ÛŒÚº Ù…Ù†ØªÙ‚Ù„ Ú©Ø±ÛŒÚº',0),(402632,11185,'sr','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚Ðµ Ñƒ Ð´Ð°Ñ‚ÑƒÐ¼',0),(402633,11185,'vi','chuyá»ƒn trong ngÃ y',0),(402634,11185,'af','Beweeg In datum',0),(402635,11185,'ro','Muta Ã®n data',0),(402636,11185,'et','KuupÃ¤eva teisaldamine',0),(402637,11185,'si','Premakniti v datum',0),(402638,11185,'ba','Bergerak dalam tanggal',0),(402639,11185,'nl','Verplaatsen In datum',0),(402640,11185,'fi','SiirrÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(402641,11185,'no','Flytte dato',0),(402642,11185,'da','Flytte i dato',0),(402643,11185,'ko','ë‚ ì§œ ì´ë™',0),(402644,11185,'he','×œ×”×¢×‘×™×¨ ×ª××¨×™×š',0),(402645,11185,'el','ÎšÎ¹Î½Î¿ÏÎ½Ï„Î±Î¹ ÏƒÎµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(402646,11185,'zh','è¿å…¥æ—¥æœŸ\r\n',0),(402647,11185,'sv','Flytta i datum',0),(402648,11185,'it','Spostare In data',0),(402649,11185,'tl','',0),(402650,11185,'th','à¸¢à¹‰à¸²à¸¢à¹ƒà¸™à¸§à¸±à¸™',0),(402651,11185,'hi','à¤¤à¤¿à¤¥à¤¿ à¤®à¥‡à¤‚ à¤²à¥‡ à¤œà¤¾à¤à¤',0),(402652,11185,'ms','Pada tarikh',0),(402653,11185,'ar','Ù†Ù‚Ù„ ÙÙŠ ØªØ§Ø±ÙŠØ®',0),(402654,11185,'fr','Se dÃ©placer en Date',0),(402655,11185,'jp','æ—¥ä»˜ã‚’ç§»å‹•ã—ã¾ã™ã€‚',0),(402656,11185,'pt','Mover-se em data',0),(402657,11185,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð”Ð°Ñ‚Ð°',0),(402658,11185,'es','DÃ­a de Entrada',0),(402659,11185,'de','Datum einziehen',0),(402660,11185,'en','Move In Date',0),(402661,11186,'is','',0),(402662,11186,'dr','(ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„',0),(402663,11186,'pr','ØªØ§Ø±ÙŠØ® Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ Ø¨Ù‡ Ø®Ø§Ø±Ø¬(ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„',0),(402664,11186,'tr','Ã‡Ä±kÄ±ÅŸ tarihi taÅŸÄ±mak',0),(402665,11186,'pl','WyprowadziÄ‡ Data',0),(402666,11186,'bg','Ð˜Ð·Ð½ÐµÑÐ°Ñ‚ Ð´Ð°Ñ‚Ð°',0),(402667,11186,'ur','ØªØ§Ø±ÛŒØ® Ø¨Ø§ÛØ± Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(402668,11186,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ , Ð¿Ð¾ÐºÑ€ÐµÑ‚',0),(402669,11186,'vi','chuyá»ƒn ra ngÃ y',0),(402670,11186,'af','Beweeg uit datum',0),(402671,11186,'ro','Muta data',0),(402672,11186,'et','Kolima kuupÃ¤ev',0),(402673,11186,'si','Izseliti datum',0),(402674,11186,'ba','Pindah tanggal',0),(402675,11186,'nl','Verhuizen van datum',0),(402676,11186,'fi','SiirrÃ¤ pois pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(402677,11186,'no','Flytte ut dato',0),(402678,11186,'da','Flytte ud dato',0),(402679,11186,'ko','ë‚ ì§œ ì´ë™',0),(402680,11186,'he','×œ×”×–×™×– ××ª ×”×ª××¨×™×š',0),(402681,11186,'el','Î‘Ï€Î¿Î¼Î±ÎºÏÏ…Î½Î¸ÎµÎ¯Ï„Îµ Î±Ï€ÏŒ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(402682,11186,'zh','è¿å‡ºæ—¥æœŸ\r\n',0),(402683,11186,'sv','Flytta ut-datum',0),(402684,11186,'it','Spostare le Date',0),(402685,11186,'tl','',0),(402686,11186,'th','à¸¢à¹‰à¸²à¸¢à¸§à¸±à¸™à¸—à¸µà¹ˆ',0),(402687,11186,'hi','à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤²à¥‡ à¤œà¤¾à¤à¤',0),(402688,11186,'ms','Mengalih keluar tarikh',0),(402689,11186,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ø¥Ù„Ù‰ ØªØ§Ø±ÙŠØ®',0),(402690,11186,'fr','On doit Ã©carter la Date',0),(402691,11186,'jp','æ—¥ä»˜ã®å¤–ã«ç§»å‹•ã—ã¾ã™ã€‚',0),(402692,11186,'pt','Mover para fora de data',0),(402693,11186,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð”Ð°Ñ‚Ð°',0),(402694,11186,'es','Fecha de Salida',0),(402695,11186,'de','Ausziehen, Datum',0),(402696,11186,'en','Move Out Date',0),(402697,11187,'is','',0),(402698,11187,'dr','Ù‡ÙŠÚ† Ø§Ø¬Ø§Ø±Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(402699,11187,'pr','Ù‡ÙŠÚ† Ø§Ø¬Ø§Ø±Ù‡ Ø§ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(402700,11187,'tr','HiÃ§bir kira bulundu',0),(402701,11187,'pl','DzierÅ¼awy, nie znaleziono',0),(402702,11187,'bg','ÐÑÐ¼Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(402703,11187,'ur','Ú©ÙˆØ¦ÛŒ Ù„ÛŒØ² Ù¾Ø§ÛŒØ§',0),(402704,11187,'sr','ÐÐµÐ¼Ð° Ð½Ð¸ Ð·Ð°ÐºÑƒÐ¿Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(402705,11187,'vi','khÃ´ng tÃ¬m tháº¥y há»£p Ä‘á»“ng thuÃª',0),(402706,11187,'af','Geen Huurkontrak Gevind nie.',0),(402707,11187,'ro','Nici un contract de leasing gÄƒsit',0),(402708,11187,'et','Ei leidnud Ã¼Ã¼rileping',0),(402709,11187,'si','Ni zakup naÅ¡el',0),(402710,11187,'ba','Sewa tidak ditemukan',0),(402711,11187,'nl','Geen Lease gevonden',0),(402712,11187,'fi','Ei ole vuokrasopimuksen lÃ¶ytyi',0),(402713,11187,'no','Ingen Lease funnet',0),(402714,11187,'da','Ingen leasing fundet',0),(402715,11187,'ko','ì•„ë‹ˆ ìž„ëŒ€ ë°œê²¬',0),(402716,11187,'he','××™×Ÿ ×—×•×–×” ×©×›×™×¨×•×ª × ×ž×¦××•',0),(402717,11187,'el','Î”ÎµÎ½ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(402718,11187,'zh','ç§Ÿçº¦æœªæ‰¾åˆ°\r\n',0),(402719,11187,'sv','Ingen hyra hittade',0),(402720,11187,'it','Trovato nessun contratto di locazione',0),(402721,11187,'tl','',0),(402722,11187,'th','à¹€à¸Šà¹ˆà¸²à¹„à¸¡à¹ˆà¸žà¸š',0),(402723,11187,'hi','à¤•à¥‹à¤ˆ à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤®à¤¿à¤²à¤¾',0),(402724,11187,'ms','Pajakan tidak ditemui',0),(402725,11187,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(402726,11187,'fr','Pas trouvÃ© de bail',0),(402727,11187,'jp','ã„ã„ãˆãƒªãƒ¼ã‚¹ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(402728,11187,'pt','Nenhum contrato encontrado',0),(402729,11187,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(402730,11187,'es','No se EncontrÃ³ Arrendamiento',0),(402731,11187,'de','Keine Lease gefunden',0),(402732,11187,'en','No Lease Found',0),(402733,11188,'is','',0),(402734,11188,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø³Ø±Ø´ÙƒÙ† Ø´Ø¯Ù‡ ',0),(402735,11188,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø³Ø±Ø´ÙƒÙ† Ø´Ø¯Ù‡ ',0),(402736,11188,'tr','Hesaplanarak gÃ¼n',0),(402737,11188,'pl','Proporcjonalnie do dni',0),(402738,11188,'bg','ÐŸÑ€Ð¾Ð¿Ð¾Ñ€Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð° Ð´Ð½Ð¸',0),(402739,11188,'ur','Ù¾Ø±ÙˆØ±ÛŒÙ¹Ø¯ Ø¯Ù†',0),(402740,11188,'sr','ÐŸÑ€Ð¾Ð¿Ð¾Ñ€Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð° Ð´Ð°Ð½Ð°',0),(402741,11188,'vi','ngÃ y tá»· lá»‡',0),(402742,11188,'af','Verdeelde Dae',0),(402743,11188,'ro','ProporÅ£ie de zile',0),(402744,11188,'et','Soetatakse pÃ¤eva',0),(402745,11188,'si','Sorazmerno dni',0),(402746,11188,'ba','Prorata hari',0),(402747,11188,'nl','Pro rata dagen',0),(402748,11188,'fi','Jaettu pÃ¤ivÃ¤Ã¤',0),(402749,11188,'no','Fordelte dager',0),(402750,11188,'da','ForholdsmÃ¦ssig dage',0),(402751,11188,'ko','í• ë‹¹ëœ ì¼',0),(402752,11188,'he','×™×ž×™× ×ž×¦×˜×‘×¨×•×ª',0),(402753,11188,'el','Î‘Î½Î±Î»Î¿Î³Î¿ÏÏƒÎ± Î·Î¼Î­ÏÎµÏ‚',0),(402754,11188,'zh','æŒ‰æ¯”ä¾‹åˆ†é…å¤©æ•°\r\n',0),(402755,11188,'sv','Proportionellt dagar',0),(402756,11188,'it','Giorni rateizzati',0),(402757,11188,'tl','',0),(402758,11188,'th','à¸•à¸²à¸¡à¸ªà¸±à¸”à¸ªà¹ˆà¸§à¸™à¸ˆà¸³à¸™à¸§à¸™à¸§à¸±à¸™',0),(402759,11188,'hi','Prorated à¤¦à¤¿à¤¨à¥‹à¤‚',0),(402760,11188,'ms','Hari pro-rata',0),(402761,11188,'ar','Ø£ÙŠØ§Ù… Ø§Ù„ØªÙ†Ø§Ø³Ø¨ÙŠØ©',0),(402762,11188,'fr','CalculÃ© au prorata des jours',0),(402763,11188,'jp','æ—¥å‰²ã‚Šã®æ—¥',0),(402764,11188,'pt','Rateado dias',0),(402765,11188,'ru','ÐŸÑ€Ð¾Ð¿Ð¾Ñ€Ñ†Ð¸Ð¾Ð½Ð°Ð»ÑŒÐ½Ð¾ Ð´Ð½ÐµÐ¹',0),(402766,11188,'es','DÃ­as a Prorrata',0),(402767,11188,'de','Anteilige Tage',0),(402768,11188,'en','Prorated Days',0),(402769,11189,'is','',0),(402770,11189,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ±',0),(402771,11189,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ±',0),(402772,11189,'tr','Son kiralarÄ±',0),(402773,11189,'pl','Ostatnie leasing',0),(402774,11189,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(402775,11189,'ur','Ø­Ø§Ù„ÛŒÛ Ù„ÙÛŒØ²Ø²',0),(402776,11189,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(402777,11189,'vi','thuÃª gáº§n Ä‘Ã¢y',0),(402778,11189,'af','Huidige Verhurings',0),(402779,11189,'ro','Ultimele contracte de leasing',0),(402780,11189,'et','Tehtud rendilepingute',0),(402781,11189,'si','Nedavni najemi',0),(402782,11189,'ba','Sewa terbaru',0),(402783,11189,'nl','Recente Leases',0),(402784,11189,'fi','Hotelliin vuokrasopimukset',0),(402785,11189,'no','Siste leieavtaler',0),(402786,11189,'da','Seneste lejemÃ¥l',0),(402787,11189,'ko','ìµœê·¼ ìž„ëŒ€',0),(402788,11189,'he','×—×›×™×¨×” ×”××—×¨×•× ×•×ª',0),(402789,11189,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(402790,11189,'zh','æœ€è¿‘çš„ç§Ÿèµ\r\n',0),(402791,11189,'sv','Senaste leasingavtal',0),(402792,11189,'it','Recenti contratti di locazione',0),(402793,11189,'tl','',0),(402794,11189,'th','à¹€à¸Šà¹ˆà¸²à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(402795,11189,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚',0),(402796,11189,'ms','Pajakan hari',0),(402797,11189,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±Ø§Øª Ù…Ø¤Ø®Ø±Ø§',0),(402798,11189,'fr','Baux rÃ©cents',0),(402799,11189,'jp','æœ€è¿‘ã®ãƒªãƒ¼ã‚¹',0),(402800,11189,'pt','LocaÃ§Ãµes recentes',0),(402801,11189,'ru','Ð‘Ñ€Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(402802,11189,'es','Aresndamientos Recientes',0),(402803,11189,'de','Aktuelle Leasing',0),(402804,11189,'en','Recent Leases',0),(402805,11190,'is','',0),(402806,11190,'dr','Ø§Ø¬Ø§Ø±Ù‡ ÙƒØ±Ø¯Ù†',0),(402807,11190,'pr','Ø§Ø¬Ø§Ø±Ù‡ ÙƒØ±Ø¯Ù†',0),(402808,11190,'tr','Kira',0),(402809,11190,'pl','Wynajem',0),(402810,11190,'bg','ÐÐ°ÐµÐ¼',0),(402811,11190,'ur','Ú©Ø±Ø§ÛŒÛ',0),(402812,11190,'sr','ÐÐ°Ñ˜Ð°Ð¼',0),(402813,11190,'vi','thuÃª',0),(402814,11190,'af','Huur',0),(402815,11190,'ro','Chirie',0),(402816,11190,'et','Rent',0),(402817,11190,'si','Najem',0),(402818,11190,'ba','Sewa',0),(402819,11190,'nl','Te huur',0),(402820,11190,'fi','Vuokrattavana',0),(402821,11190,'no','Leie',0),(402822,11190,'da','Leje',0),(402823,11190,'ko','ìž„ëŒ€',0),(402824,11190,'he','×©×›×™×¨×•×ª',0),(402825,11190,'el','Î•Î½Î¿Î¹ÎºÎ¯Î±ÏƒÎ·',0),(402826,11190,'zh','ç§Ÿ\r\n',0),(402827,11190,'sv','Hyra',0),(402828,11190,'it','Affitto Appartamento',0),(402829,11190,'tl','',0),(402830,11190,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²',0),(402831,11190,'hi','à¤¬à¤¾à¤‡à¤• à¤•à¤¿à¤°à¤¾à¤ à¤ªà¤°',0),(402832,11190,'ms','Sewa',0),(402833,11190,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(402834,11190,'fr','Loyer',0),(402835,11190,'jp','å®¶è³ƒ',0),(402836,11190,'pt','Aluguel',0),(402837,11190,'ru','ÐÑ€ÐµÐ½Ð´Ð°',0),(402838,11190,'es','Renta',0),(402839,11190,'de','Mieten',0),(402840,11190,'en','Rent',0),(402841,11191,'is','',0),(402842,11191,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡ Ù…Ø³ØªØ§Ø¬Ø± ',0),(402843,11191,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡ Ù…Ø³ØªØ§Ø¬Ø± ',0),(402844,11191,'tr','TalimatlarÄ± kiracÄ± kiralama',0),(402845,11191,'pl','Najemca dzierÅ¼awy instrukcje',0),(402846,11191,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(402847,11191,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± ÛØ¯Ø§ÛŒØ§Øª Ù„ÙÛŒØ²Ø²',0),(402848,11191,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð¸Ð·Ð½Ð°Ñ˜Ð¼Ñ™ÑƒÑ˜Ðµ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(402849,11191,'vi','HÆ°á»›ng dáº«n cho ngÆ°á»i thuÃª nhÃ  thuÃª',0),(402850,11191,'af','Huurder Huurkontrak Instruksies',0),(402851,11191,'ro','ChiriaÅŸ contractele de leasing instrucÅ£iuni',0),(402852,11191,'et','Rentnik kapitalirendi juhiseid',0),(402853,11191,'si','Zakupnik zakup navodila',0),(402854,11191,'ba','Penyewa sewa petunjuk',0),(402855,11191,'nl','Huurder lease-overeenkomsten instructies',0),(402856,11191,'fi','Vuokralainen vuokraa ohjeet',0),(402857,11191,'no','Leietaker leier instruksjoner',0),(402858,11191,'da','Lejer leaser instruktioner',0),(402859,11191,'ko','ì„¸ ìž…ìž ìž„ëŒ€ ì§€ì¹¨',0),(402860,11191,'he','×”×“×™×™×¨ ×—×›×™×¨×” ×”×•×¨××•×ª',0),(402861,11191,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î® Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(402862,11191,'zh','ä¸šæƒäººç§Ÿèµè¯´æ˜Ž\r\n',0),(402863,11191,'sv','HyresgÃ¤sten hyr instruktioner',0),(402864,11191,'it','Locatario in leasing istruzioni',0),(402865,11191,'tl','',0),(402866,11191,'th','à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¹€à¸Šà¹ˆà¸²à¸„à¸³à¹à¸™à¸°à¸™à¸³',0),(402867,11191,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(402868,11191,'ms','Penyewa pajakan arahan',0),(402869,11191,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(402870,11191,'fr','Locataire loue des Instructions',0),(402871,11191,'jp','ãƒ†ãƒŠãƒ³ãƒˆ ãƒªãƒ¼ã‚¹ã®æŒ‡ç¤º',0),(402872,11191,'pt','Inquilino aluga instruÃ§Ãµes',0),(402873,11191,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ð°Ñ€ÐµÐ½Ð´ÑƒÐµÑ‚ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(402874,11191,'es','Instrucciones de Arrendamientos de Inquilinos',0),(402875,11191,'de','Mieter vermietet Anweisungen',0),(402876,11191,'en','Tenant Leases Instructions',0),(402877,11192,'is','',0),(402878,11192,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ú¯Ø°Ø´ØªÙ‡ ',0),(402879,11192,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ú¯Ø°Ø´ØªÙ‡ ',0),(402880,11192,'tr','Gecikme (gÃ¼n)',0),(402881,11192,'pl','Dni pod koniec',0),(402882,11192,'bg','Ð”Ð½Ð¸ Ð·Ð°ÐºÑŠÑÐ½ÐµÐ½Ð¸Ðµ',0),(402883,11192,'ur','Ø¯Ù†ÙˆÚº Ú©ÛŒ ØªØ§Ø®ÛŒØ±',0),(402884,11192,'sr','Ð”Ð°Ð½Ð° Ð´Ð¾ ÐºÐ°ÑÐ½Ð¾',0),(402885,11192,'vi','NgÃ y muá»™n',0),(402886,11192,'af','Dae Laat',0),(402887,11192,'ro','ÃŽntÃ¢rziere de zile',0),(402888,11192,'et','PÃ¤eva eest',0),(402889,11192,'si','Dni prepozno',0),(402890,11192,'ba','Hari terlambat',0),(402891,11192,'nl','Dagen te laat',0),(402892,11192,'fi','PÃ¤ivÃ¤Ã¤ myÃ¶hÃ¤ssÃ¤',0),(402893,11192,'no','Dager for sent',0),(402894,11192,'da','Dage for sent',0),(402895,11192,'ko','ëŠ¦ì€ ì¼',0),(402896,11192,'he','×ž××—×¨ ×™×ž×™×',0),(402897,11192,'el','Î—Î¼Î­ÏÎµÏ‚ ÎºÎ±Î¸Ï…ÏƒÏ„Î­ÏÎ·ÏƒÎ·',0),(402898,11192,'zh','é€¾æœŸå¤©æ•°\r\n',0),(402899,11192,'sv','Dagar fÃ¶r sent',0),(402900,11192,'it','Giorni di ritardo',0),(402901,11192,'tl','',0),(402902,11192,'th','à¸§à¸±à¸™à¸ªà¸²à¸¢',0),(402903,11192,'hi','à¤¦à¤¿à¤¨ à¤¦à¥‡à¤°',0),(402904,11192,'ms','Hari lewat',0),(402905,11192,'ar','Ø£ÙŠØ§Ù… Ù…ØªØ£Ø®Ø±Ø©',0),(402906,11192,'fr','Jours de retard',0),(402907,11192,'jp','æ—¥é…ã‚Œ',0),(402908,11192,'pt','Dias de atraso',0),(402909,11192,'ru','Ð”Ð½ÐµÐ¹ Ð¿Ð¾Ð·Ð´Ð½Ð¾',0),(402910,11192,'es','DÃ­as Morosos',0),(402911,11192,'de','Tage zu spÃ¤t',0),(402912,11192,'en','Days Late',0),(402913,11193,'is','',0),(402914,11193,'dr','(Ø§Ù‚Ø³Ø§Ø·)Ù…Ø³ØªØ§Ø¬Ø±',0),(402915,11193,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ(Ø§Ù‚Ø³Ø§Ø·)Ù…Ø³ØªØ§Ø¬Ø±',0),(402916,11193,'tr','KiracÄ± Ã¶deme talimatlarÄ±',0),(402917,11193,'pl','Instrukcje pÅ‚atnoÅ›ci lokator',0),(402918,11193,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(402919,11193,'ur','Ú©Ø±Ø§ÛŒÛ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(402920,11193,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ñ˜Ðµ',0),(402921,11193,'vi','HÆ°á»›ng dáº«n ngÆ°á»i thuÃª nhÃ  thanh toÃ¡n',0),(402922,11193,'af','Huurder Betalings Instruksies',0),(402923,11193,'ro','InstrucÅ£iuni de plÄƒÅ£i chiriaÅŸ',0),(402924,11193,'et','Rentnike maksed juhiseid',0),(402925,11193,'si','Najemnik plaÄila navodila',0),(402926,11193,'ba','Instruksi pembayaran penyewa',0),(402927,11193,'nl','Huurder betalingen instructies',0),(402928,11193,'fi','Vuokralainen maksujen ohjeet',0),(402929,11193,'no','Leietaker betalinger instruksjoner',0),(402930,11193,'da','Lejer betalinger instruktioner',0),(402931,11193,'ko','ê±°ì£¼ìž ì§€ê¸‰ ì§€ì¹¨',0),(402932,11193,'he','×”×“×™×™×¨ ×ª×©×œ×•×ž×™× ×”×•×¨××•×ª',0),(402933,11193,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î® Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(402934,11193,'zh','ä¸šæƒäººæ”¯ä»˜è¯´æ˜Ž\r\n',0),(402935,11193,'sv','HyresgÃ¤sten betalningar instruktioner',0),(402936,11193,'it','Istruzioni pagamenti inquilino',0),(402937,11193,'tl','',0),(402938,11193,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(402939,11193,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(402940,11193,'ms','Arahan bayaran penyewa',0),(402941,11193,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø¯ÙØ¹ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(402942,11193,'fr','Instructions de paiements locataire',0),(402943,11193,'jp','ãƒ†ãƒŠãƒ³ãƒˆã®æ”¯æ‰•ã„å‘½ä»¤',0),(402944,11193,'pt','InstruÃ§Ãµes de pagamentos de inquilino',0),(402945,11193,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(402946,11193,'es','Instrucciones de Pagos de Inquilinos',0),(402947,11193,'de','Mieter-Zahlungen-Anweisungen',0),(402948,11193,'en','Tenant Payments Instructions',0),(402949,11194,'is','',0),(402950,11194,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¬Ø§Ø±Ù‡',0),(402951,11194,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¬Ø§Ø±Ù‡',0),(402952,11194,'tr','Kira tutarÄ±',0),(402953,11194,'pl','DzierÅ¼awy',0),(402954,11194,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ ÑÑƒÐ¼Ð°',0),(402955,11194,'ur','Ù„ÛŒØ² Ú©ÛŒ Ø±Ù‚Ù…',0),(402956,11194,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð°ÐºÑƒÐ¿Ð°',0),(402957,11194,'vi','sá»‘ tiá»n thuÃª',0),(402958,11194,'af','Huurkontrak Bedrag',0),(402959,11194,'ro','SumÄƒ Ã®nchiriere',0),(402960,11194,'et','Rendisumma',0),(402961,11194,'si','Znesek zakupa',0),(402962,11194,'ba','Jumlah sewa',0),(402963,11194,'nl','Lease-bedrag',0),(402964,11194,'fi','Vuokrasopimuksen mÃ¤Ã¤rÃ¤Ã¤',0),(402965,11194,'no','Lease belÃ¸p',0),(402966,11194,'da','Leasing belÃ¸b',0),(402967,11194,'ko','ìž„ëŒ€ ê¸ˆì•¡',0),(402968,11194,'he','×¡×›×•× ×”×©×›×™×¨×•×ª',0),(402969,11194,'el','ÎœÎ¯ÏƒÎ¸Ï‰Î¼Î±',0),(402970,11194,'zh','ç§Ÿèµé‡‘é¢\r\n',0),(402971,11194,'sv','LÃ¥n belopp',0),(402972,11194,'it','Importo del contratto di locazione',0),(402973,11194,'tl','',0),(402974,11194,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²',0),(402975,11194,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥€ à¤°à¤¾à¤¶à¤¿',0),(402976,11194,'ms','Jumlah pajakan',0),(402977,11194,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(402978,11194,'fr','Montant de la location',0),(402979,11194,'jp','ãƒªãƒ¼ã‚¹é‡‘é¡',0),(402980,11194,'pt','Quantidade de locaÃ§Ã£o',0),(402981,11194,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(402982,11194,'es','Monto de Arrendamiento',0),(402983,11194,'de','Leasingrate',0),(402984,11194,'en','Lease Amount',0),(402985,11195,'is','',0),(402986,11195,'dr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§',0),(402987,11195,'pr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§',0),(402988,11195,'tr','GÃ¶rÃ¼nÃ¼m kiralarÄ±',0),(402989,11195,'pl','Widok leasing',0),(402990,11195,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(402991,11195,'ur','Ù…Ù†Ø¸Ø± Ù„ÙÛŒØ²Ø²',0),(402992,11195,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(402993,11195,'vi','Xem thuÃª tÃ i sáº£n',0),(402994,11195,'af','Besigtig Verhurings',0),(402995,11195,'ro','Vezi leasing',0),(402996,11195,'et','Vaade rent',0),(402997,11195,'si','Pogled najemi',0),(402998,11195,'ba','Lihat sewa',0),(402999,11195,'nl','Weergave Leases',0),(403000,11195,'fi','Katso vuokrasopimukset',0),(403001,11195,'no','Vis leieavtaler',0),(403002,11195,'da','Se lejemÃ¥l',0),(403003,11195,'ko','ë³´ê¸° ìž„ëŒ€',0),(403004,11195,'he','×ª×¦×•×’×ª ×—×›×™×¨×”',0),(403005,11195,'el','Î ÏÎ¿Î²Î¿Î»Î® Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(403006,11195,'zh','æŸ¥çœ‹ç§Ÿèµ\r\n',0),(403007,11195,'sv','Visa leasingavtal',0),(403008,11195,'it','Vista locazioni',0),(403009,11195,'tl','',0),(403010,11195,'th','à¹€à¸Šà¹ˆà¸²à¸”à¸¹',0),(403011,11195,'hi','à¤¦à¥ƒà¤¶à¥ à¤¯ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚',0),(403012,11195,'ms','Lihat pajakan',0),(403013,11195,'ar','Ø¹Ø±Ø¶ Ø¹Ù‚ÙˆØ¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(403014,11195,'fr','Vue baux',0),(403015,11195,'jp','ãƒ“ãƒ¥ãƒ¼ã®ãƒªãƒ¼ã‚¹',0),(403016,11195,'pt','LocaÃ§Ãµes de exibiÃ§Ã£o',0),(403017,11195,'ru','Ð’Ð¸Ð´ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(403018,11195,'es','Visionar Arrendamientos',0),(403019,11195,'de','Ansicht Leases',0),(403020,11195,'en','View Leases',0),(403021,11196,'is','',0),(403022,11196,'dr','Ù†Ù…Ø§ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(403023,11196,'pr','Ù†Ù…Ø§ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(403024,11196,'tr','GÃ¶rÃ¼nÃ¼m Ã¶demeleri',0),(403025,11196,'pl','Widok pÅ‚atnoÅ›ci',0),(403026,11196,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(403027,11196,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Ø§ Ù…Ù†Ø¸Ø±',0),(403028,11196,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(403029,11196,'vi','Xem thanh toÃ¡n',0),(403030,11196,'af','Besigtig Betaligns',0),(403031,11196,'ro','Vezi plÄƒÅ£i',0),(403032,11196,'et','Vaade maksed',0),(403033,11196,'si','Pogled plaÄila',0),(403034,11196,'ba','Lihat pembayaran',0),(403035,11196,'nl','Weergave betalingen',0),(403036,11196,'fi','Katso maksut',0),(403037,11196,'no','Vis betalinger',0),(403038,11196,'da','Se betalinger',0),(403039,11196,'ko','ë³´ê¸° ì§€ë¶ˆ',0),(403040,11196,'he','×ª×¦×•×’×ª ×ª×©×œ×•×ž×™×',0),(403041,11196,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(403042,11196,'zh','æŸ¥çœ‹ä»˜æ¬¾\r\n',0),(403043,11196,'sv','Visa betalningar',0),(403044,11196,'it','Visualizzazione pagamenti',0),(403045,11196,'tl','',0),(403046,11196,'th','à¸”à¸¹à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(403047,11196,'hi','à¤¦à¥ƒà¤¶à¥ à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(403048,11196,'ms','Paparan pembayaran',0),(403049,11196,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(403050,11196,'fr','Vue paiements',0),(403051,11196,'jp','ãƒ“ãƒ¥ãƒ¼ã®æ”¯æ‰•ã„',0),(403052,11196,'pt','Ver pagamentos',0),(403053,11196,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐŸÐ»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(403054,11196,'es','Visionar Pagos',0),(403055,11196,'de','Zahlungen ansehen',0),(403056,11196,'en','View Payments',0),(403057,11197,'is','',0),(403058,11197,'dr','(ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„',0),(403059,11197,'pr','Ú†Ùƒ Ù„ÙŠØ³Øª Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ Ø¨Ù‡ Ø®Ø§Ø±Ø¬(ØªØ®Ù„ÙŠÙ‡ Ù…Ù†Ø²Ù„',0),(403060,11197,'tr','Kontrol Cetveli taÅŸÄ±',0),(403061,11197,'pl','PrzesuÅ„ siÄ™ lista kontrolna',0),(403062,11197,'bg','Ð˜Ð·Ð½ÐµÑÐ°Ñ‚ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº',0),(403063,11197,'ur','Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Ùˆ Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(403064,11197,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(403065,11197,'vi','chuyá»ƒn ra khá»i danh sÃ¡ch kiá»ƒm tra',0),(403066,11197,'af','Skuif uit Nasienlys',0),(403067,11197,'ro','Mutare Ã®n lista de verificare',0),(403068,11197,'et','Kolima Meelespea',0),(403069,11197,'si','Izseliti kontrolni seznam',0),(403070,11197,'ba','Pindah Checklist',0),(403071,11197,'nl','Verhuizen van controlelijst',0),(403072,11197,'fi','SiirrÃ¤ pois tarkistuslista',0),(403073,11197,'no','Flytte ut sjekkliste',0),(403074,11197,'da','Flytte ud tjekliste',0),(403075,11197,'ko','ì´ì‚¬ ê²€ì‚¬ ëª©ë¡',0),(403076,11197,'he','×œ×”×¢×‘×™×¨ ××ª ×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢',0),(403077,11197,'el','ÎœÎµÏ„Î±ÎºÎ¿Î¼Î¯Î¶Î¿Ï…Î½ Î»Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(403078,11197,'zh','è¿å‡ºæ¸…å•\r\n',0),(403079,11197,'sv','Flytta ut checklista',0),(403080,11197,'it','Traslocare Checklist',0),(403081,11197,'tl','',0),(403082,11197,'th','à¸¢à¹‰à¸²à¸¢à¸­à¸­à¸à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(403083,11197,'hi','à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ à¤¬à¤¾à¤¹à¤° à¤²à¥‡ à¤œà¤¾à¤à¤',0),(403084,11197,'ms','Mengalih keluar senarai semak',0),(403085,11197,'ar','Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ø¥Ù„Ù‰ Ù‚Ø§Ø¦Ù…Ø© Ù…Ø±Ø¬Ø¹ÙŠØ©',0),(403086,11197,'fr','On doit Ã©carter la Checklist',0),(403087,11197,'jp','ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆã‚’ç§»å‹•ã—ã¾ã™ã€‚',0),(403088,11197,'pt','Sair da lista de verificaÃ§Ã£o',0),(403089,11197,'ru','Ð’Ñ‹Ð¹Ñ‚Ð¸ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(403090,11197,'es','Lista de Tareas de Salida',0),(403091,11197,'de','Ausziehen Checkliste',0),(403092,11197,'en','Move Out Checklist',0),(403093,11198,'is','',0),(403094,11198,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ù…Ø³ØªØºÙ„Ø§Øª Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(403095,11198,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ù…Ø³ØªØºÙ„Ø§Øª Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(403096,11198,'tr','AylÄ±k emlak vergisi',0),(403097,11198,'pl','MiesiÄ™czny podatek od nieruchomoÅ›ci',0),(403098,11198,'bg','ÐœÐµÑÐµÑ‡ÐµÐ½ Ð´Ð°Ð½ÑŠÐº Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¸ Ð¸Ð¼Ð¾Ñ‚Ð¸',0),(403099,11198,'ur','Ù…Ø§ÛØ§Ù†Û Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ù¹ÛŒÚ©Ø³',0),(403100,11198,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð½ÐµÐ¿Ð¾ÐºÑ€ÐµÑ‚Ð½Ñƒ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ',0),(403101,11198,'vi','thuáº¿ Ä‘áº¥t hÃ ng thÃ¡ng',0),(403102,11198,'af','Maandelikse Vaste Eiendom Belasting',0),(403103,11198,'ro','Lunar Real Estate fiscale',0),(403104,11198,'et','Igakuine kinnisvaramaks',0),(403105,11198,'si','MeseÄni nepremiÄninski davek',0),(403106,11198,'ba','Bulanan pajak Real estat',0),(403107,11198,'nl','Maandelijkse onroerend goed belasting',0),(403108,11198,'fi','Kuukausittain kiinteistÃ¶vero',0),(403109,11198,'no','MÃ¥nedlig eiendomsskatt',0),(403110,11198,'da','MÃ¥nedlige ejendomsskat',0),(403111,11198,'ko','ì›”ê°„ ë¶€ë™ì‚° ì„¸ê¸ˆ',0),(403112,11198,'he','×ž×™×¡×•×™ ×ž×§×¨×§×¢×™×Ÿ ×—×•×“×©×™',0),(403113,11198,'el','ÎœÎ·Î½Î¹Î±Î¯Î¿ Ï„Î­Î»Î¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚',0),(403114,11198,'zh','æ¯æœˆæˆ¿åœ°äº§ç¨Ž\r\n',0),(403115,11198,'sv','MÃ¥natliga fastighetsskatt',0),(403116,11198,'it','Mensile tassa immobiliare',0),(403117,11198,'tl','',0),(403118,11198,'th','à¹€à¸”à¸·à¸­à¸™à¸ à¸²à¸©à¸µà¸­à¸ªà¸±à¸‡à¸«à¸²à¸£à¸´à¸¡à¸—à¸£à¸±à¸žà¸¢à¹Œ',0),(403119,11198,'hi','à¤®à¤¾à¤¸à¤¿à¤• à¤°à¤¿à¤¯à¤² à¤à¤¸à¥à¤Ÿà¥‡à¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(403120,11198,'ms','Bulanan cukai hartanah',0),(403121,11198,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ© Ø§Ù„Ø´Ù‡Ø±ÙŠØ©',0),(403122,11198,'fr','ImpÃ´t foncier mensuel',0),(403123,11198,'jp','æœˆåˆŠä¸å‹•ç”£ç¨Ž',0),(403124,11198,'pt','Imposto mensal de imÃ³veis',0),(403125,11198,'ru','ÐœÐµÑÑÑ‡Ð½Ñ‹Ð¹ ÐÐ°Ð»Ð¾Ð³ ÐÐ° ÐÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(403126,11198,'es','Impuesto Mensual de Predial',0),(403127,11198,'de','Monatliche Immobiliensteuer',0),(403128,11198,'en','Monthly Real Estate Tax',0),(403129,11199,'is','',0),(403130,11199,'dr','Escrow ',0),(403131,11199,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø§Ù„ÙŠØ§Øª Ù…ÙˆØ§ÙÙ‚Øª Ù†Ø§Ù…Ù‡ Ø¨ÙŠÙ† Ø¯ÙˆÙ†ÙØ±Ú©Ù‡ Ø¨Ø§Ù…Ø§Ù†Øª Ù†Ø²Ø¯Ø´Ø®Øµ Ø«Ø§Ù„Ø«Ù‰ Ø³Ù¾Ø±Ø¯Ù‡ Ø´ÙˆØ¯ÙˆØªØ§Ø­ØµÙˆÙ„ Ø´Ø±Ø§ÙŠØ· Ø¨Ø®ØµÙˆØµ Ø¨Ø¯ÙˆÙ† Ø§Ø¹ØªØ¨Ø§Ø±Ø¨Ø§Ø´Ø¯ Escrow ',0),(403132,11199,'tr','Vergi Escrow tutar',0),(403133,11199,'pl','Kwota podatku Escrow',0),(403134,11199,'bg','Ð”Ð°Ð½ÑŠÐºÐ° Ð²ÑŠÑ€Ñ…Ñƒ ÐµÑÐºÑ€Ð¾Ñƒ',0),(403135,11199,'ur','Ù¹ÛŒÚ©Ø³ ÛŒØ³Ú©Ø±Ùˆ Ø±Ù‚Ù…',0),(403136,11199,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð•ÑÑ†Ñ€Ð¾w',0),(403137,11199,'vi','Sá»‘ tiá»n thuáº¿ kÃ½ quá»¹',0),(403138,11199,'af','Belasting borg bedrag',0),(403139,11199,'ro','Suma de Escrow taxe',0),(403140,11199,'et','Tingdeposiidileping maksusumma',0),(403141,11199,'si','Deponirana znesek davka',0),(403142,11199,'ba','Jumlah Escrow pajak',0),(403143,11199,'nl','Borg belastingbedrag',0),(403144,11199,'fi','Escrow vero',0),(403145,11199,'no','Escrow avgiftsbelÃ¸p',0),(403146,11199,'da','SpÃ¦rrede momsbelÃ¸b',0),(403147,11199,'ko','ì„¸ê¸ˆ ì—ìŠ¤í¬ë¡œ ê¸ˆì•¡',0),(403148,11199,'he','×¡×›×•× ×”×—×•×–×” ×ž×¡',0),(403149,11199,'el','Î”ÎµÏƒÎ¼ÎµÏ…Î¼Î­Î½Î¿ Ï€Î¿ÏƒÏŒ Ï†ÏŒÏÎ¿Ï…',0),(403150,11199,'zh','ç¨ŽåŠ¡ä¸­ä»‹é‡‘é¢\r\n',0),(403151,11199,'sv','Skattebeloppet Escrow',0),(403152,11199,'it','Importo di imposta Escrow',0),(403153,11199,'tl','',0),(403154,11199,'th','à¸ à¸²à¸©à¸µà¹€à¸‰à¸žà¸²à¸°',0),(403155,11199,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤à¤¸à¥à¤•à¥à¤°à¥Œ à¤°à¤¾à¤¶à¤¿',0),(403156,11199,'ms','Jumlah Escrow cukai',0),(403157,11199,'ar','Ù…Ø¨Ù„Øº Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¶Ù…Ø§Ù†',0),(403158,11199,'fr','Montant d\'impÃ´t Escrow',0),(403159,11199,'jp','æ¡ä»¶ä»˜ã‘æºå°è¨¼æ›¸ç¨Žé¡',0),(403160,11199,'pt','Valor de depÃ³sito do imposto',0),(403161,11199,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ ÑÑƒÐ¼Ð¼Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(403162,11199,'es','Monto de Impuesto en Custodia',0),(403163,11199,'de','Escrow Steuerbetrag',0),(403164,11199,'en','Tax Escrow Amount',0),(403165,11200,'is','',0),(403166,11200,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§Øª ',0),(403167,11200,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø§Ù„ÙŠØ§Øª ',0),(403168,11200,'tr','Vergi gideri',0),(403169,11200,'pl','Podatku dochodowego',0),(403170,11200,'bg','Ð”Ð°Ð½ÑŠÑ‡ÐµÐ½ Ñ€Ð°Ð·Ñ…Ð¾Ð´',0),(403171,11200,'ur','Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(403172,11200,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(403173,11200,'vi','Chi phÃ­ thuáº¿',0),(403174,11200,'af','Belasting uitgawe',0),(403175,11200,'ro','Cheltuieli impozitul',0),(403176,11200,'et','Tulumaksu kulu',0),(403177,11200,'si','Odhodek za davek',0),(403178,11200,'ba','Pajak',0),(403179,11200,'nl','Belastinglasten',0),(403180,11200,'fi','ALV-menot',0),(403181,11200,'no','Skattekostnad',0),(403182,11200,'da','Skatteudgifter',0),(403183,11200,'ko','ì„¸ê¸ˆ ë¹„ìš©',0),(403184,11200,'he','×”×•×¦××•×ª ×ž×¡',0),(403185,11200,'el','Î¤Î¿ Î­Î¾Î¿Î´Î¿ Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï…',0),(403186,11200,'zh','ç¨Žæ”¶è´¹ç”¨\r\n',0),(403187,11200,'sv','Skattekostnad',0),(403188,11200,'it','Spese fiscali',0),(403189,11200,'tl','',0),(403190,11200,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸ à¸²à¸©à¸µ',0),(403191,11200,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤µà¥à¤¯à¤¯',0),(403192,11200,'ms','Perbelanjaan cukai',0),(403193,11200,'ar','Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(403194,11200,'fr','Charges d\'impÃ´ts',0),(403195,11200,'jp','ç¨Žé‡‘è²»ç”¨',0),(403196,11200,'pt','Despesa de imposto',0),(403197,11200,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(403198,11200,'es','Gastos de Impuesto',0),(403199,11200,'de','Steueraufwand',0),(403200,11200,'en','Tax Expense',0),(403201,11201,'is','',0),(403202,11201,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø±Ø§ÙŠ Ù…ÙˆØ§ÙÙ‚Øª Ù†Ø§Ù…Ù‡ Ø¨ÙŠÙ† Ø¯ÙˆÙ†ÙØ±Ú©Ù‡ Ø¨Ø§Ù…Ø§Ù†Øª Ù†Ø²Ø¯Ø´Ø®Øµ Ø«Ø§Ù„Ø«Ù‰ Ø³Ù¾Ø±Ø¯Ù‡ Ø´ÙˆØ¯ÙˆØªØ§Ø­ØµÙˆÙ„ Ø´Ø±Ø§ÙŠØ· Ø¨Ø®ØµÙˆØµ Ø¨Ø¯ÙˆÙ† Ø§Ø¹ØªØ¨Ø§Ø±Ø¨Ø§Ø´Ø¯\r\n Escrow',0),(403203,11201,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø±Ø§ÙŠ Ù…ÙˆØ§ÙÙ‚Øª Ù†Ø§Ù…Ù‡ Ø¨ÙŠÙ† Ø¯ÙˆÙ†ÙØ±Ú©Ù‡ Ø¨Ø§Ù…Ø§Ù†Øª Ù†Ø²Ø¯Ø´Ø®Øµ Ø«Ø§Ù„Ø«Ù‰ Ø³Ù¾Ø±Ø¯Ù‡ Ø´ÙˆØ¯ÙˆØªØ§Ø­ØµÙˆÙ„ Ø´Ø±Ø§ÙŠØ· Ø¨Ø®ØµÙˆØµ Ø¨Ø¯ÙˆÙ† Ø§Ø¹ØªØ¨Ø§Ø±Ø¨Ø§Ø´Ø¯\r\n Escrow',0),(403204,11201,'tr','Escrow iÃ§in vergi',0),(403205,11201,'pl','Podatku dla usÅ‚ugi Escrow',0),(403206,11201,'bg','Ð”Ð°Ð½ÑŠÐº Ð·Ð° ÐµÑÐºÑ€Ð¾Ñƒ',0),(403207,11201,'ur','ÛŒØ³Ú©Ø±Ùˆ Ú©Û’ Ù„Ø¦Û’ Ù¹ÛŒÚ©Ø³',0),(403208,11201,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð•ÑÑ†Ñ€Ð¾w',0),(403209,11201,'vi','KÃ½ quá»¹ thuáº¿',0),(403210,11201,'af','Belasting vir borg',0),(403211,11201,'ro','Taxa pentru Escrow',0),(403212,11201,'et','Tingdeposiidileping makse',0),(403213,11201,'si','Davek za deponirana',0),(403214,11201,'ba','Pajak untuk Escrow',0),(403215,11201,'nl','Belasting voor borg',0),(403216,11201,'fi','Vero Escrow',0),(403217,11201,'no','Avgiften For dokument',0),(403218,11201,'da','Skat For spÃ¦rrede',0),(403219,11201,'ko','ì—ìŠ¤í¬ë¡œ ëŒ€ í•œ ì„¸ê¸ˆ',0),(403220,11201,'he','×ž×¡ ×¢×‘×•×¨ ×¦×“ ×©×œ×™×©×™',0),(403221,11201,'el','Î¦ÏŒÏÎ¿Ï‚ Î³Î¹Î± Ï„Î· Î¼ÎµÏ„Î±Î²Î¯Î²Î±ÏƒÎ·',0),(403222,11201,'zh','ç¨ŽåŠ¡æå­˜\r\n',0),(403223,11201,'sv','Skatt fÃ¶r Escrow',0),(403224,11201,'it','Tassa per il deposito a garanzia',0),(403225,11201,'tl','',0),(403226,11201,'th','à¸ à¸²à¸©à¸µà¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰',0),(403227,11201,'hi','à¤à¤¸à¥à¤•à¥à¤°à¥Œ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤°',0),(403228,11201,'ms','Cukai bagi Escrow',0),(403229,11201,'ar','Ø¶Ø±ÙŠØ¨Ø© Ù„Ù„Ø¶Ù…Ø§Ù†',0),(403230,11201,'fr','Taxe de dÃ©pÃ´t fiduciaire',0),(403231,11201,'jp','æ¡ä»¶ä»˜ã‘æºå°è¨¼æ›¸ã®ç¨Ž',0),(403232,11201,'pt','Imposto para compromisso',0),(403233,11201,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° ÑÐ´ÐµÐ»ÐºÐ¸',0),(403234,11201,'es','Impuesto Para Custodia',0),(403235,11201,'de','Steuer fÃ¼r Treuhandservice',0),(403236,11201,'en','Tax For Escrow',0),(403237,11202,'is','',0),(403238,11202,'dr','Ø¨Ø¯Ù‡ÙŠ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(403239,11202,'pr','Ø¨Ø¯Ù‡ÙŠ Ù…Ø§Ù„ÙŠØ§ØªÙŠ ',0),(403240,11202,'tr','Vergi yÃ¼kÃ¼mlÃ¼lÃ¼ÄŸÃ¼',0),(403241,11202,'pl','Podatku dochodowego',0),(403242,11202,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(403243,11202,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø°Ù…Û Ø¯Ø§Ø±ÛŒ',0),(403244,11202,'sr','ÐŸÐ¾Ñ€ÐµÑÐºÐ¸ Ð´ÑƒÐ³',0),(403245,11202,'vi','trÃ¡ch nhiá»‡m phÃ¡p lÃ½ thuáº¿',0),(403246,11202,'af','Belasting-aanspreeklikheid',0),(403247,11202,'ro','Obligatia fiscala',0),(403248,11202,'et','Maksukohustus',0),(403249,11202,'si','DavÄne obveznosti',0),(403250,11202,'ba','Kewajiban pajak',0),(403251,11202,'nl','Belastingverplichting',0),(403252,11202,'fi','Verovelka',0),(403253,11202,'no','Skatteplikt',0),(403254,11202,'da','Skattepligt',0),(403255,11202,'ko','ë‚©ì„¸ ì˜ë¬´',0),(403256,11202,'he','×”×—×‘×•×ª ×‘×ž×¡',0),(403257,11202,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Ï…Ï€Î¿Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(403258,11202,'zh','ç¨ŽåŠ¡è´£ä»»\r\n',0),(403259,11202,'sv','Skatteskuld',0),(403260,11202,'it','ResponsabilitÃ  fiscale',0),(403261,11202,'tl','',0),(403262,11202,'th','à¸ à¸²à¸£à¸°à¸ à¸²à¸©à¸µ',0),(403263,11202,'hi','à¤•à¤° à¤¦à¥‡à¤¯à¤¤à¤¾',0),(403264,11202,'ms','Liabiliti cukai',0),(403265,11202,'ar','Ø§Ù„Ù…Ø³Ø¤ÙˆÙ„ÙŠØ© Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©',0),(403266,11202,'fr','Assujettissement Ã  l\'impÃ´t',0),(403267,11202,'jp','ç¨Žè² æ‹…',0),(403268,11202,'pt','Responsabilidade tributÃ¡ria',0),(403269,11202,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(403270,11202,'es','Impuesto Debido',0),(403271,11202,'de','Steuerpflicht',0),(403272,11202,'en','Tax Liability',0),(403273,11203,'is','',0),(403274,11203,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¬Ù‡Øª Ù…ÙˆØ§ÙÙ‚Øª Ù†Ø§Ù…Ù‡ Ø¨ÙŠÙ† Ø¯ÙˆÙ†ÙØ±Ú©Ù‡ Ø¨Ø§Ù…Ø§Ù†Øª Ù†Ø²Ø¯Ø´Ø®Øµ Ø«Ø§Ù„Ø«Ù‰ Ø³Ù¾Ø±Ø¯Ù‡ Ø´ÙˆØ¯ÙˆØªØ§Ø­ØµÙˆÙ„ Ø´Ø±Ø§ÙŠØ· Ø¨Ø®ØµÙˆØµ Ø¨Ø¯ÙˆÙ† Ø§Ø¹ØªØ¨Ø§Ø±Ø¨Ø§Ø´Ø¯\r\n Escrow',0),(403275,11203,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¬Ù‡Øª Ù…ÙˆØ§ÙÙ‚Øª Ù†Ø§Ù…Ù‡ Ø¨ÙŠÙ† Ø¯ÙˆÙ†ÙØ±Ú©Ù‡ Ø¨Ø§Ù…Ø§Ù†Øª Ù†Ø²Ø¯Ø´Ø®Øµ Ø«Ø§Ù„Ø«Ù‰ Ø³Ù¾Ø±Ø¯Ù‡ Ø´ÙˆØ¯ÙˆØªØ§Ø­ØµÙˆÙ„ Ø´Ø±Ø§ÙŠØ· Ø¨Ø®ØµÙˆØµ Ø¨Ø¯ÙˆÙ† Ø§Ø¹ØªØ¨Ø§Ø±Ø¨Ø§Ø´Ø¯\r\n Escrow',0),(403276,11203,'tr','Escrow vergi',0),(403277,11203,'pl','Podatku Escrow',0),(403278,11203,'bg','Ð”Ð°Ð½ÑŠÐº Ð·Ð° ÐµÑÐºÑ€Ð¾Ñƒ',0),(403279,11203,'ur','ÛŒØ³Ú©Ø±Ùˆ Ú©Ùˆ Ù¹ÛŒÚ©Ø³',0),(403280,11203,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð•ÑÑ†Ñ€Ð¾w',0),(403281,11203,'vi','KÃ½ quá»¹ thuáº¿',0),(403282,11203,'af','Belasting te borg',0),(403283,11203,'ro','Taxa pentru Escrow',0),(403284,11203,'et','Tingdeposiidileping makse',0),(403285,11203,'si','Davek na hrambi',0),(403286,11203,'ba','Pajak Escrow',0),(403287,11203,'nl','Belasting op borg',0),(403288,11203,'fi','Veron Escrow',0),(403289,11203,'no','Mva Escrow',0),(403290,11203,'da','Skat til depotet',0),(403291,11203,'ko','ì¡°ê±´ë¶€ ë‚ ì¸ ì¦ì„œ ì„¸ê¸ˆ',0),(403292,11203,'he','×ž×¡ ×¢×œ ×¦×“ ×©×œ×™×©×™',0),(403293,11203,'el','Î¦ÏŒÏÎ¿Ï… Î¼ÎµÏƒÎµÎ³Î³ÏÎ·ÏƒÎ·Ï‚',0),(403294,11203,'zh','ç¨Žï¼Œä»¥æ‰˜ç®¡\r\n',0),(403295,11203,'sv','Skatt till spÃ¤rrade',0),(403296,11203,'it','Tassa di deposito a garanzia',0),(403297,11203,'tl','',0),(403298,11203,'th','à¸ à¸²à¸©à¸µà¸—à¸µà¹ˆà¸œà¸¹à¹‰',0),(403299,11203,'hi','à¤à¤¸à¥à¤•à¥à¤°à¥Œ à¤•à¥‹ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(403300,11203,'ms','Cukai Escrow',0),(403301,11203,'ar','Ø¶Ø±ÙŠØ¨Ø© Ù„Ù„Ø¶Ù…Ø§Ù†',0),(403302,11203,'fr','Taxe de dÃ©pÃ´t fiduciaire',0),(403303,11203,'jp','æ¡ä»¶ä»˜ã‘æºå°è¨¼æ›¸ã‚’ç¨Ž',0),(403304,11203,'pt','Imposto de compromisso',0),(403305,11203,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° ÑÐ´ÐµÐ»ÐºÐ¸',0),(403306,11203,'es','Impuesto a Custodia',0),(403307,11203,'de','Steuer an Escrow',0),(403308,11203,'en','Tax to Escrow',0),(403309,11204,'is','',0),(403310,11204,'dr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(403311,11204,'pr','Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(403312,11204,'tr','YÃ¶netim Ã¼cretleri',0),(403313,11204,'pl','ZarzÄ…dzanie opÅ‚aty',0),(403314,11204,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ñ‚Ð°ÐºÑÐ¸Ñ‚Ðµ, Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(403315,11204,'ur','Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ ÙÛŒØ³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(403316,11204,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(403317,11204,'vi','phÃ­ quáº£n lÃ½ Ä‘Ã£ tráº£',0),(403318,11204,'af','Bestuursfooie Betaal',0),(403319,11204,'ro','Managementul taxelor plÄƒtite',0),(403320,11204,'et','Makstud haldustasud',0),(403321,11204,'si','Upravljanje pristojbine, plaÄane',0),(403322,11204,'ba','Manajemen biaya dibayar',0),(403323,11204,'nl','Beheervergoedingen betaald',0),(403324,11204,'fi','Johdon palkkiot',0),(403325,11204,'no','Ledelsen betalt',0),(403326,11204,'da','Administrationsgebyrer betalt',0),(403327,11204,'ko','ê´€ë¦¬ ë¹„ ì§€ë¶ˆ',0),(403328,11204,'he','× ×™×”×•×œ ×ª×©×œ×•×ž×™× ×©×©×•×œ×ž×•',0),(403329,11204,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Î±Î¼Î¿Î¹Î²ÏŽÎ½',0),(403330,11204,'zh','ç®¡ç†è´¹æ”¯ä»˜\r\n',0),(403331,11204,'sv','Hantering av arvoden',0),(403332,11204,'it','Gestione tasse pagate',0),(403333,11204,'tl','',0),(403334,11204,'th','à¸Šà¸³à¸£à¸°à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£',0),(403335,11204,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤¶à¥à¤²à¥à¤• à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(403336,11204,'ms','Yuran pengurusan dibayar',0),(403337,11204,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(403338,11204,'fr','Frais de gestion versÃ©s',0),(403339,11204,'jp','æ”¯æ‰•ã‚ã‚ŒãŸç®¡ç†æ‰‹æ•°æ–™',0),(403340,11204,'pt','Taxas de administraÃ§Ã£o pagas',0),(403341,11204,'ru','ÐŸÐ»Ð°Ñ‚Ñ‹ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(403342,11204,'es','Cuotas de Mantenimiento Pagadas',0),(403343,11204,'de','Management-GebÃ¼hren bezahlt',0),(403344,11204,'en','Management Fees Paid',0),(403345,11205,'is','',0),(403346,11205,'dr','Ù„ÙŠØ³Øª Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡',0),(403347,11205,'pr','Ù„ÙŠØ³Øª Ù‡Ø²ÙŠÙ†Ù‡ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¨Ø§Ù†ÙƒÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡',0),(403348,11205,'tr','Liste yÃ¶netim Ã¼cretleri',0),(403349,11205,'pl','OpÅ‚aty za zarzÄ…dzanie uiszczane listy',0),(403350,11205,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ñ‚Ð°ÐºÑÐ¸Ñ‚Ðµ, Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(403351,11205,'ur','Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ ÙÛŒØ³ Ø§Ø¯Ø§ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(403352,11205,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾ Ð»Ð¸ÑÑ‚Ð°',0),(403353,11205,'vi','danh sÃ¡ch phÃ­ quáº£n lÃ½ Ä‘Ã£ tráº£',0),(403354,11205,'af','Bestuursfooie Betaalde Lys',0),(403355,11205,'ro','Managementul taxelor plÄƒtite lista',0),(403356,11205,'et','Juhtimise tasudega loend',0),(403357,11205,'si','Upravljanje plaÄajo seznam',0),(403358,11205,'ba','Manajemen biaya dibayar daftar',0),(403359,11205,'nl','Beheervergoedingen betaalde lijst',0),(403360,11205,'fi','Johdon palkkiot luettelo',0),(403361,11205,'no','Ledelsen betalt liste',0),(403362,11205,'da','Administrationsgebyrer betalt liste',0),(403363,11205,'ko','ê´€ë¦¬ ë¹„ ë‚©ë¶€ ëª©ë¡',0),(403364,11205,'he','× ×™×”×•×œ ×ª×©×œ×•×ž×™× ×©×©×•×œ×ž×• ×¨×©×™×ž×”',0),(403365,11205,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Î±Î¼Î¿Î¹Î²ÏŽÎ½ Î»Î¯ÏƒÏ„Î±',0),(403366,11205,'zh','ç®¡ç†è´¹æ”¯ä»˜åˆ—è¡¨\r\n',0),(403367,11205,'sv','Hantering avgifter lista',0),(403368,11205,'it','Gestione tasse pagate elenco',0),(403369,11205,'tl','',0),(403370,11205,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸ˆà¸±à¸”à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¸£à¸²à¸¢à¸à¸²à¸£',0),(403371,11205,'hi','à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤¶à¥à¤²à¥à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¥‚à¤šà¥€',0),(403372,11205,'ms','Yuran pengurusan dibayar senarai',0),(403373,11205,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© Ù‚Ø§Ø¦Ù…Ø©',0),(403374,11205,'fr','Frais de gestion payÃ©s liste',0),(403375,11205,'jp','ç®¡ç†æ–™ä¸€è¦§',0),(403376,11205,'pt','Taxas de administraÃ§Ã£o pagas lista',0),(403377,11205,'ru','ÐŸÐ»Ð°Ñ‚Ñ‹ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(403378,11205,'es','Lista de Cuotas de Mantenimiento Pagadas',0),(403379,11205,'de','ManagementgebÃ¼hren-Liste',0),(403380,11205,'en','Management Fees Paid List',0),(403381,11206,'is','',0),(403382,11206,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†ÙŠØ³Øª',0),(403383,11206,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† ÙØ§ÙŠÙ„ Ø§ÙƒØ³Ù„ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†ÙŠØ³Øª',0),(403384,11206,'tr','Bordro Excel dosyasÄ± bulunamadÄ±',0),(403385,11206,'pl','Nie moÅ¼na odnaleÅºÄ‡ pliku Excel listy pÅ‚ac',0),(403386,11206,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð¢Ð Ð— Excel Ñ„Ð°Ð¹Ð»',0),(403387,11206,'ur','Ù¾Û’ Ø±ÙˆÙ„ Excel Ù…Ø³Ù„ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§',0),(403388,11206,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð•xÑ†ÐµÐ» Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ',0),(403389,11206,'vi','khÃ´ng thá»ƒ tÃ¬m tháº§y file lÆ°Æ¡ng',0),(403390,11206,'af','Was nie in staat om die Loonrol Excel LÃªer te Find',0),(403391,11206,'ro','Imposibil de gÄƒsit fiÈ™ierul Excel salarizare',0),(403392,11206,'et','Palgaarvestuse Exceli faili ei leitud',0),(403393,11206,'si','IzplaÄane plaÄe Excel datoteke ni mogoÄe najti',0),(403394,11206,'ba','Tidak dapat menemukan File Excel penggajian',0),(403395,11206,'nl','Kan Payroll Excel bestand niet vinden',0),(403396,11206,'fi','Palkanlaskennan Excel-tiedostoa ei lÃ¶ydy',0),(403397,11206,'no','Finner ikke lÃ¸nn Excel-fil',0),(403398,11206,'da','Kunne ikke finde Excel lÃ¸nfilen',0),(403399,11206,'ko','ê¸‰ì—¬ ì—‘ì…€ íŒŒì¼ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(403400,11206,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×§×•×‘×¥ Excel ×ž×©×›×•×¨×•×ª',0),(403401,11206,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Excel Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(403402,11206,'zh','æ‰¾ä¸åˆ°è–ªé‡‘Excelæ–‡ä»¶\r\n',0),(403403,11206,'sv','Kunde inte hitta LÃ¶nelista Excel-fil',0),(403404,11206,'it','Impossibile trovare il File di Excel di Payroll',0),(403405,11206,'tl','',0),(403406,11206,'th','à¹„à¸¡à¹ˆà¸žà¸šà¹à¸Ÿà¹‰à¸¡ Excel à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(403407,11206,'hi','à¤ªà¥‡à¤°à¥‹à¤² Excel à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(403408,11206,'ms','Tidak dapat mencari fail Excel gaji',0),(403409,11206,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ù„Ù Excel Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(403410,11206,'fr','Fichier Excel paie est introuvable',0),(403411,11206,'jp','çµ¦ä¸Žè¨ˆç®— Excel ãƒ•ã‚¡ã‚¤ãƒ«ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(403412,11206,'pt','NÃ£o foi possÃ­vel localizar o arquivo de Excel de folha de pagamento',0),(403413,11206,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ Ñ„Ð°Ð¹Ð» Excel Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(403414,11206,'es','No PodÃ­a Encontrar El File Excel de NÃ³minaa',0),(403415,11206,'de','Gehaltsabrechnung Excel-Datei konnte nicht gefunden werden.',0),(403416,11206,'en','Could Not Find Payroll Excel File',0),(403417,11207,'is','',0),(403418,11207,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø¨Ø±Ú¯Ù‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(403419,11207,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø¨Ø±Ú¯Ù‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(403420,11207,'tr','Bordro indiriniz',0),(403421,11207,'pl','Pobierz arkusz pÅ‚ac',0),(403422,11207,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ñ‚Ð° Ð»Ð¸ÑÑ‚',0),(403423,11207,'ur','Ù¾Û’ Ø±ÙˆÙ„ ÙˆØ±Ù‚ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(403424,11207,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¼Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð»Ð¸ÑÑ‚',0),(403425,11207,'vi','Táº£i báº£ng lÆ°Æ¡ng',0),(403426,11207,'af','Aflaai van Loonrol Vel',0),(403427,11207,'ro','DescÄƒrcaÈ›i fiÈ™a de salarizare',0),(403428,11207,'et','Lae Palgaarvestus leht',0),(403429,11207,'si','Download list na izplaÄane plaÄe',0),(403430,11207,'ba','Download penggajian lembar',0),(403431,11207,'nl','Payroll fiche',0),(403432,11207,'fi','Lataa Palkanlaskenta Sheet',0),(403433,11207,'no','Laste ned lÃ¸nn arket',0),(403434,11207,'da','Download lÃ¸nningslisten ark',0),(403435,11207,'ko','ë‹¤ìš´ë¡œë“œ ê¸‰ì—¬ ì‹œíŠ¸',0),(403436,11207,'he','×œ×”×•×¨×“×ª ×“×£ ×ž×©×›×•×¨×•×ª',0),(403437,11207,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ Ï†ÏÎ»Î»Î¿ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(403438,11207,'zh','å·¥èµ„è¡¨ä¸‹è½½\r\n',0),(403439,11207,'sv','HÃ¤mta lÃ¶nelistan blad',0),(403440,11207,'it','Scarica scheda libro paga',0),(403441,11207,'tl','',0),(403442,11207,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹à¸œà¹ˆà¸™à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(403443,11207,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤¶à¥€à¤Ÿ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡',0),(403444,11207,'ms','Muat turun kira-kira gaji',0),(403445,11207,'ar','ØªØ­Ù…ÙŠÙ„ ÙˆØ±Ù‚Ø© ÙƒØ´Ù Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(403446,11207,'fr','TÃ©lÃ©chargez la fiche de paie',0),(403447,11207,'jp','çµ¦ä¸Žè¨ˆç®—ã‚·ãƒ¼ãƒˆã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(403448,11207,'pt','Baixar folha de folha de pagamento',0),(403449,11207,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½ÑƒÑŽ Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚ÑŒ',0),(403450,11207,'es','Descarga Hoja de Nomina',0),(403451,11207,'de','Payroll-Datenblatt herunterladen',0),(403452,11207,'en','Download Payroll Sheet',0),(403453,11208,'is','',0),(403454,11208,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø±Ø§ÙŠ  Ù¾Ø±Ø¯Ø§Ø²Ø´Ú¯Ø± ',0),(403455,11208,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÙŠ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø±Ø§ÙŠ  Ù¾Ø±Ø¯Ø§Ø²Ø´Ú¯Ø± ',0),(403456,11208,'tr','Bordro verilerini vermek iÃ§in iÅŸlemci',0),(403457,11208,'pl','Eksport danych listy pÅ‚ac dla procesora',0),(403458,11208,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸ Ð½Ð° Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ñ‚Ð° Ð·Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€',0),(403459,11208,'ur','Ù¾Ø±ÙˆØ³ÛŒØ³Ø± Ú©Û’ Ù„Ø¦Û’ Ù¾Û’ Ø±ÙˆÙ„ Ú©ÙˆØ§Ø¦Ù Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(403460,11208,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñƒ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð·Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€',0),(403461,11208,'vi','káº¿t xuáº¥t dá»¯ liá»‡u lÆ°Æ¡ng cho bá»™ xá»­ lÃ½',0),(403462,11208,'af','Uitvoer van Loonrol Data vir Prosessering',0),(403463,11208,'ro','Export date de salarizare pentru procesor',0),(403464,11208,'et','Protsessor palgaandmete eksport',0),(403465,11208,'si','Izvoz podatkov na izplaÄane plaÄe za procesor',0),(403466,11208,'ba','Ekspor Data penggajian untuk prosesor',0),(403467,11208,'nl','Payroll gegevens exporteren voor Processor',0),(403468,11208,'fi','Palkanlaskennan tietojen vieminen-prosessori',0),(403469,11208,'no','Eksportere lÃ¸nnsdata for prosessor',0),(403470,11208,'da','Eksportere lÃ¸ndata for Processor',0),(403471,11208,'ko','í”„ë¡œì„¸ì„œì— ëŒ€ í•œ ê¸‰ì—¬ ë°ì´í„°ë¥¼ ë‚´ë³´ë‚´ê¸°',0),(403472,11208,'he','×™×™×¦×•× × ×ª×•× ×™ ×©×›×¨ ×¢×‘×•×¨ ×ž×¢×‘×“',0),(403473,11208,'el','Î•Î¾Î±Î³Ï‰Î³Î® Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Î³Î¹Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î®',0),(403474,11208,'zh','å¤„ç†å™¨å‡ºå£è–ªé…¬æ•°æ®\r\n',0),(403475,11208,'sv','Exportera lÃ¶nedata fÃ¶r Processor',0),(403476,11208,'it','Esportare i dati sui salari per processore',0),(403477,11208,'tl','',0),(403478,11208,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸•à¸±à¸§à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥',0),(403479,11208,'hi','à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‡à¤°à¥‹à¤² à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(403480,11208,'ms','Mengeksport Data gaji untuk pemproses',0),(403481,11208,'ar','ØªØµØ¯ÙŠØ± Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ù„Ù„Ù…Ø¹Ø§Ù„Ø¬',0),(403482,11208,'fr','Exportation des donnÃ©es de paie pour processeur',0),(403483,11208,'jp','ãƒ—ãƒ­ã‚»ãƒƒã‚µã®ãŸã‚ã®çµ¦ä¸Žãƒ‡ãƒ¼ã‚¿ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(403484,11208,'pt','Exportar dados de folha de pagamento para processador',0),(403485,11208,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð´Ð»Ñ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€Ð°',0),(403486,11208,'es','Exportar Datos de Nominas Para procesador',0),(403487,11208,'de','Export Abrechnungsdaten fÃ¼r Prozessor',0),(403488,11208,'en','Export Payroll Data for Processor',0),(403489,11209,'is','',0),(403490,11209,'dr','Ù‡ÙŠÚ† Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(403491,11209,'pr','Ù‡ÙŠÚ† Ù„ÛŒØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ÙŠ  Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(403492,11209,'tr','HiÃ§bir bordrolarÄ±nÄ±n bulundu',0),(403493,11209,'pl','Nie pÅ‚ac znaleÅºÄ‡',0),(403494,11209,'bg','ÐÐµ Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(403495,11209,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø§Ø±Ù¾ÙˆØ±ÛŒØ´Ù†ÛŒÚº Ù¾Ø§ÛŒØ§',0),(403496,11209,'sr','ÐÐµÐ¼Ð° Ð¿Ð»Ð°Ñ‚Ð½Ðµ ÑÐ¿Ð¸ÑÐºÐ¾Ð²Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(403497,11209,'vi','khÃ´ng tÃ¬m tháº¥y tiá»n lÆ°Æ¡ng Ä‘Ã£ tráº£',0),(403498,11209,'af','Geen Loonrolle Gevind',0),(403499,11209,'ro','Nici state de salarii a constatat',0),(403500,11209,'et','Ei leidnud Payrolls',0),(403501,11209,'si','Ne Payrolls naÅ¡el',0),(403502,11209,'ba','Payrolls tidak ditemukan',0),(403503,11209,'nl','Geen totale loonsom gevonden',0),(403504,11209,'fi','Ei lÃ¶ytynyt palkkalistat',0),(403505,11209,'no','Ingen lÃ¸nn funnet',0),(403506,11209,'da','Ingen Payrolls fundet',0),(403507,11209,'ko','ì•„ë¬´ ì¼ìžë¦¬ ë°œê²¬',0),(403508,11209,'he','××™×Ÿ ×©×™×™×¨×•×ª ×ª×©×œ×•×ž×™× ×›××œ×” × ×ž×¦××•',0),(403509,11209,'el','Î”ÎµÎ½ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(403510,11209,'zh','æ²¡æœ‰æ‰¾åˆ°è–ªé…¬\r\n',0),(403511,11209,'sv','Ingen lÃ¶nelistor hittade',0),(403512,11209,'it','Nessun Payrolls trovato',0),(403513,11209,'tl','',0),(403514,11209,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸­à¸µà¸à¹„à¸¡à¹ˆà¸žà¸š',0),(403515,11209,'hi','à¤•à¥‹à¤ˆ Payrolls à¤ªà¤¾à¤¯à¤¾',0),(403516,11209,'ms','Tiada Payrolls yang ditemui',0),(403517,11209,'ar','Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(403518,11209,'fr','Aucune rÃ©munÃ©ration trouvÃ©e',0),(403519,11209,'jp','ãªã„é›‡ç”¨è€…æ•°ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(403520,11209,'pt','NÃ£o encontradas de folhas de pagamento',0),(403521,11209,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ðµ Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ð¸ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹',0),(403522,11209,'es','No se Encuentra Nominas',0),(403523,11209,'de','Keine Lohn-und Gehaltslisten gefunden',0),(403524,11209,'en','No Payrolls Found',0),(403525,11210,'is','',0),(403526,11210,'dr','Ø®ÙˆØ¯ÙƒØ§Ø±',0),(403527,11210,'pr','Ø®ÙˆØ¯ÙƒØ§Ø±',0),(403528,11210,'tr','Otomatik',0),(403529,11210,'pl','Automatycznie',0),(403530,11210,'bg','ÐÐ²Ñ‚Ð¾',0),(403531,11210,'ur','Ø®ÙˆØ¯ Ú©Ø§Ø±',0),(403532,11210,'sr','ÐÑƒÑ‚Ð¾',0),(403533,11210,'vi','Tá»± Ä‘á»™ng',0),(403534,11210,'af','Outomaties',0),(403535,11210,'ro','Auto',0),(403536,11210,'et','Auto',0),(403537,11210,'si','Auto',0),(403538,11210,'ba','Auto',0),(403539,11210,'nl','Auto',0),(403540,11210,'fi','Auto',0),(403541,11210,'no','Automatisk',0),(403542,11210,'da','Auto',0),(403543,11210,'ko','ìžë™',0),(403544,11210,'he','××•×˜×•×ž×˜×™',0),(403545,11210,'el','Auto',0),(403546,11210,'zh','è‡ªåŠ¨\r\n',0),(403547,11210,'sv','Auto',0),(403548,11210,'it','Automatico',0),(403549,11210,'tl','',0),(403550,11210,'th','à¸£à¸–',0),(403551,11210,'hi','à¤‘à¤Ÿà¥‹',0),(403552,11210,'ms','Auto',0),(403553,11210,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(403554,11210,'fr','Auto',0),(403555,11210,'jp','è‡ªå‹•',0),(403556,11210,'pt','AutomÃ¡tico',0),(403557,11210,'ru','ÐÐ²Ñ‚Ð¾',0),(403558,11210,'es','Auto',0),(403559,11210,'de','Auto',0),(403560,11210,'en','Auto',0),(403561,11211,'is','',0),(403562,11211,'dr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨  Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙƒØ§Ù…Ù„ Ø´Ø¯',0),(403563,11211,'pr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨  Ø®ÙˆØ¯ÙƒØ§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙƒØ§Ù…Ù„ Ø´Ø¯',0),(403564,11211,'tr','Otomatik fatura baÅŸarÄ±yla tamamlandÄ±',0),(403565,11211,'pl','Auto rozliczeniowe zakoÅ„czone pomyÅ›lnie',0),(403566,11211,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(403567,11211,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ú©Ù…Ù„ Ø¢Ù¹Ùˆ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(403568,11211,'sr','ÐÑƒÑ‚Ð¾ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð·Ð°Ð²Ñ€ÑˆÐµÐ½Ð°',0),(403569,11211,'vi','Tá»± Ä‘á»™nghanh toÃ¡n hoÃ n thÃ nh ',0),(403570,11211,'af','Outo-Verekening is Suksesvol Voltooi',0),(403571,11211,'ro','Facturare automatÄƒ finalizatÄƒ cu succes',0),(403572,11211,'et','Automaatne arvete edukalt lÃµpule',0),(403573,11211,'si','Auto zaraÄunavanje uspeÅ¡no',0),(403574,11211,'ba','Otomatis penagihan berhasil diselesaikan',0),(403575,11211,'nl','Automatische facturering voltooid',0),(403576,11211,'fi','Automaattinen laskutuksen onnistui',0),(403577,11211,'no','Automatisk fakturering fullfÃ¸rt',0),(403578,11211,'da','Auto fakturering fuldfÃ¸rt',0),(403579,11211,'ko','ìžë™ ê²°ì œ ì™„ë£Œ',0),(403580,11211,'he','×—×™×•×‘ ××•×˜×•×ž×˜×™ ×”×•×©×œ× ×‘×”×¦×œ×—×”',0),(403581,11211,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· Ï‡ÏÎ­Ï‰ÏƒÎ· Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(403582,11211,'zh','æˆåŠŸå®Œæˆè‡ªåŠ¨è®¡è´¹\r\n',0),(403583,11211,'sv','Auto fakturering slutfÃ¶rts',0),(403584,11211,'it','Fatturazione automatica completata',0),(403585,11211,'tl','',0),(403586,11211,'th','à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢',0),(403587,11211,'hi','à¤‘à¤Ÿà¥‹ à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¥‚à¤°à¥à¤£ à¤¹à¥à¤†',0),(403588,11211,'ms','Bil automatik yang telah berjaya diselesaikan',0),(403589,11211,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(403590,11211,'fr','Facturation automatique terminÃ©e avec succÃ¨s',0),(403591,11211,'jp','æ­£å¸¸ã«å®Œäº†ã—ãŸè‡ªå‹•èª²é‡‘',0),(403592,11211,'pt','Auto facturaÃ§Ã£o foi concluÃ­da com Ãªxito',0),(403593,11211,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð², ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°',0),(403594,11211,'es','Auto FacturaciÃ³n Completada Exitosamente',0),(403595,11211,'de','Automatische Abrechnung erfolgreich abgeschlossen',0),(403596,11211,'en','Auto Billing Completed Successfully',0),(403597,11212,'is','',0),(403598,11212,'dr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(403599,11212,'pr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(403600,11212,'tr','Fatura hatasÄ±',0),(403601,11212,'pl','Brak pÅ‚atnoÅ›ci',0),(403602,11212,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ð½Ðµ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ÑÑ‚',0),(403603,11212,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…ÛŒ',0),(403604,11212,'sr','ÐÐ°Ð¿Ð»Ð°Ñ‚Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(403605,11212,'vi','Láº­p hÃ³a Ä‘Æ¡n khÃ´ng thÃ nh',0),(403606,11212,'af','Verekening Stad/Dorp',0),(403607,11212,'ro','EÅŸecul de facturare',0),(403608,11212,'et','Arved rike',0),(403609,11212,'si','ZaraÄunavanje neuspeh',0),(403610,11212,'ba','Kegagalan penagihan',0),(403611,11212,'nl','Facturering mislukking',0),(403612,11212,'fi','Laskutus virhe',0),(403613,11212,'no','Fakturering feil',0),(403614,11212,'da','Fakturering fejl',0),(403615,11212,'ko','ê²°ì œ ì‹¤íŒ¨',0),(403616,11212,'he','×›×©×œ ×—×™×•×‘',0),(403617,11212,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(403618,11212,'zh','è®¡è´¹å¤±è´¥\r\n',0),(403619,11212,'sv','Fakturering fel',0),(403620,11212,'it','Mancata fatturazione',0),(403621,11212,'tl','',0),(403622,11212,'th','à¸„à¸§à¸²à¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§à¹ƒà¸™à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(403623,11212,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤µà¤¿à¤«à¤²à¤¤à¤¾',0),(403624,11212,'ms','Kegagalan bil',0),(403625,11212,'ar','ÙØ´Ù„ Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(403626,11212,'fr','Ã‰chec de la facturation',0),(403627,11212,'jp','èª²é‡‘éšœå®³',0),(403628,11212,'pt','Falha de faturamento',0),(403629,11212,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(403630,11212,'es','Fallo de FacturaciÃ³n',0),(403631,11212,'de','Abrechnung Fehler',0),(403632,11212,'en','Billing Failure',0),(403633,11213,'is','',0),(403634,11213,'dr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù…Ù†Ù‚Ø¶Ù‰ Ø´Ø¯Ù‡',0),(403635,11213,'pr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù…Ù†Ù‚Ø¶Ù‰ Ø´Ø¯Ù‡',0),(403636,11213,'tr','Kredi kartÄ± sona erdi',0),(403637,11213,'pl','Karta kredytowa jest skoÅ„czony',0),(403638,11213,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ‚Ð° ÐºÐ°Ñ€Ñ‚Ð° Ðµ Ñ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ» ÑÑ€Ð¾Ðº',0),(403639,11213,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ù…Ø¯Øª Ø®ØªÙ… ÛÙˆ Ú¯Ø¦ÛŒ ÛÛ’',0),(403640,11213,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ñ˜Ðµ Ð¸ÑÑ‚ÐµÐºÐ»Ð°.',0),(403641,11213,'vi','tháº» tÃ­n dá»¥ng Ä‘Æ°á»£c gia háº¡n',0),(403642,11213,'af','Kredietkaart het Verval',0),(403643,11213,'ro','Card de credit este expirat',0),(403644,11213,'et','Krediitkaart on aegunud',0),(403645,11213,'si','Kreditna kartica je potekla',0),(403646,11213,'ba','Kartu kredit kadaluarsa',0),(403647,11213,'nl','Creditcard is verlopen',0),(403648,11213,'fi','Luottokortti on vanhentunut',0),(403649,11213,'no','Kredittkortet er utlÃ¸pt',0),(403650,11213,'da','Kreditkort er udlÃ¸bet',0),(403651,11213,'ko','ì‹ ìš© ì¹´ë“œ ë§Œë£Œ',0),(403652,11213,'he','×›×¨×˜×™×¡ ××©×¨××™ ×©×¤×’ ×ª×•×§×¤×•',0),(403653,11213,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Î­Ï‡ÎµÎ¹ Î»Î®Î¾ÎµÎ¹',0),(403654,11213,'zh','ä¿¡ç”¨å¡å·²è¿‡æœŸ\r\n',0),(403655,11213,'sv','Kreditkort Ã¤r andas ut',0),(403656,11213,'it','Carta di credito Ã¨ scaduta',0),(403657,11213,'tl','',0),(403658,11213,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(403659,11213,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹ à¤—à¤ˆ à¤¹à¥ˆ',0),(403660,11213,'ms','Kad kredit luput',0),(403661,11213,'ar','Ø§Ù†ØªÙ‡Øª ØµÙ„Ø§Ø­ÙŠØ© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(403662,11213,'fr','Carte de crÃ©dit a expirÃ©',0),(403663,11213,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®æœ‰åŠ¹æœŸé™ãŒåˆ‡ã‚Œã¦ãã ã•ã„ã€‚',0),(403664,11213,'pt','CartÃ£o de crÃ©dito expirou',0),(403665,11213,'ru','Ð¡Ñ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ñ‹ Ð˜ÑÑ‚ÐµÐº',0),(403666,11213,'es','Tarjeta de CrÃ©dito Se VenciÃ³',0),(403667,11213,'de','Kreditkarte ist abgelaufen',0),(403668,11213,'en','Credit Card is Expired',0),(403669,11214,'is','',0),(403670,11214,'dr','(ØªÙ„Ø§Ø´Ù‡Ø§) Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(403671,11214,'pr','Ø¢Ø²Ù…Ø§ÙŠØ´Ø§Øª(ØªÙ„Ø§Ø´Ù‡Ø§) Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(403672,11214,'tr','BaÅŸarÄ±sÄ±z giriÅŸim',0),(403673,11214,'pl','Nieudanych prÃ³b',0),(403674,11214,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¸ Ð¾Ð¿Ð¸Ñ‚Ð°',0),(403675,11214,'ur','Ù†Ø§Ú©Ø§Ù… Ú©ÙˆØ´Ø´ÛŒÚº',0),(403676,11214,'sr','ÐŸÑ€Ð¾Ð¿Ð°Ð»Ð¸ Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ð¸',0),(403677,11214,'vi','láº§n thá»­ tháº¥t báº¡i',0),(403678,11214,'af','Mislukte pogings',0),(403679,11214,'ro','ÃŽncercÄƒri nu a reuÅŸit',0),(403680,11214,'et','EbaÃµnnestunud katseid',0),(403681,11214,'si','NeuspeÅ¡nih poskusov',0),(403682,11214,'ba','Usaha yang gagal',0),(403683,11214,'nl','Mislukte pogingen',0),(403684,11214,'fi','EpÃ¤onnistunut',0),(403685,11214,'no','Mislykkede forsÃ¸k',0),(403686,11214,'da','Mislykkede forsÃ¸g',0),(403687,11214,'ko','ì‹¤íŒ¨ í•œ ì‹œë„',0),(403688,11214,'he','× ×™×¡×™×•× ×•×ª ×›×•×©×œ×™×',0),(403689,11214,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î·Î¼Î­Î½ÎµÏ‚ Ï€ÏÎ¿ÏƒÏ€Î¬Î¸ÎµÎ¹ÎµÏ‚',0),(403690,11214,'zh','å¤±è´¥çš„å°è¯•\r\n',0),(403691,11214,'sv','Misslyckade fÃ¶rsÃ¶k',0),(403692,11214,'it','Tentativi falliti',0),(403693,11214,'tl','',0),(403694,11214,'th','à¸„à¸§à¸²à¸¡à¸žà¸¢à¸²à¸¢à¸²à¸¡à¸—à¸µà¹ˆà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(403695,11214,'hi','à¤…à¤¸à¤«à¤² à¤ªà¥à¤°à¤¯à¤¾à¤¸',0),(403696,11214,'ms','Usaha yang gagal',0),(403697,11214,'ar','Ø§Ù„Ù…Ø­Ø§ÙˆÙ„Ø§Øª Ø§Ù„ÙØ§Ø´Ù„Ø©',0),(403698,11214,'fr','Tentatives infructueuses',0),(403699,11214,'jp','è©¦è¡Œå¤±æ•—',0),(403700,11214,'pt','Tentativas frustradas',0),(403701,11214,'ru','ÐÐµÑƒÐ´Ð°Ñ‡Ð½Ñ‹Ðµ Ð¿Ð¾Ð¿Ñ‹Ñ‚ÐºÐ¸',0),(403702,11214,'es','Intentos Fallados',0),(403703,11214,'de','Fehlgeschlagene Versuche',0),(403704,11214,'en','Failed Attempts',0),(403705,11215,'is','',0),(403706,11215,'dr','ÙØ§ÙƒØªÙˆØ± ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø±',0),(403707,11215,'pr','ÙØ§ÙƒØªÙˆØ± ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø±',0),(403708,11215,'tr','Fatura otomatik Ã¶deme',0),(403709,11215,'pl','Faktura automatyczne fakturowanie',0),(403710,11215,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(403711,11215,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¢Ù¹Ùˆ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(403712,11215,'sr','ÐÐ°Ð¿Ð»Ð°Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐÑƒÑ‚Ð¾',0),(403713,11215,'vi','phÃ¡t hÃ nh hÃ³a Ä‘Æ¡n tá»± Ä‘á»™ng',0),(403714,11215,'af','Faktuur Outo fakturering',0),(403715,11215,'ro','FacturÄƒ Auto facturare',0),(403716,11215,'et','Arve automaatne arvete',0),(403717,11215,'si','RaÄun Auto zaraÄunavanje',0),(403718,11215,'ba','Faktur penagihan otomatis',0),(403719,11215,'nl','Factuur automatische facturering',0),(403720,11215,'fi','Laskun Auto laskutus',0),(403721,11215,'no','Faktura automatisk fakturering',0),(403722,11215,'da','Fakturaen Auto fakturering',0),(403723,11215,'ko','ì†¡ìž¥ ìžë™ ê²°ì œ',0),(403724,11215,'he','×—×©×‘×•× ×™×ª ×—×™×•×‘ ××•×˜×•×ž×˜×™',0),(403725,11215,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î·Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(403726,11215,'zh','å‘ç¥¨è‡ªåŠ¨è®¡è´¹\r\n',0),(403727,11215,'sv','Faktura automatisk fakturering',0),(403728,11215,'it','Fattura fatturazione automatica',0),(403729,11215,'tl','',0),(403730,11215,'th','à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(403731,11215,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤‘à¤Ÿà¥‹ à¤¬à¤¿à¤²à¤¿à¤‚à¤—',0),(403732,11215,'ms','Bil automatik invois',0),(403733,11215,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(403734,11215,'fr','Facturation automatique de facture',0),(403735,11215,'jp','è«‹æ±‚æ›¸ã®è‡ªå‹•è«‹æ±‚',0),(403736,11215,'pt','Fatura Auto facturaÃ§Ã£o',0),(403737,11215,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(403738,11215,'es','Factura Auto FacturaciÃ³n',0),(403739,11215,'de','Rechnung automatische Abrechnung',0),(403740,11215,'en','Invoice Auto Billing',0),(403741,11216,'is','',0),(403742,11216,'dr','ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯ ',0),(403743,11216,'pr','ÙØ§ÙƒØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯ ',0),(403744,11216,'tr','BaÅŸarÄ±yla Ã¶denen fatura',0),(403745,11216,'pl','Faktury pÅ‚atne pomyÅ›lnie',0),(403746,11216,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(403747,11216,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¯Ø§',0),(403748,11216,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ð»Ð°Ñ›ÐµÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(403749,11216,'vi','hÃ³a Ä‘Æ¡n Ä‘Ã£ tráº£ thÃ nh cÃ´ng',0),(403750,11216,'af','Faktuur Suksesvol Betaal',0),(403751,11216,'ro','Facturii achitate cu succes',0),(403752,11216,'et','Arve makstud edukalt',0),(403753,11216,'si','UspeÅ¡no plaÄan raÄun',0),(403754,11216,'ba','Faktur dibayar berhasil',0),(403755,11216,'nl','Factuur betaald met succes',0),(403756,11216,'fi','Lasku maksettu onnistuneesti',0),(403757,11216,'no','Faktura betalt vellykket',0),(403758,11216,'da','Faktura betales med succes',0),(403759,11216,'ko','ì„±ê³µì ìœ¼ë¡œ ì§€ë¶ˆ ì²­êµ¬ì„œ',0),(403760,11216,'he','×”×—×©×‘×•× ×™×ª ×©×•×œ×ž×” ×‘×”×¦×œ×—×”',0),(403761,11216,'el','ÎœÎµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± ÎµÎ¾Î¿Ï†Î»Î·Î¸Î­Î½Ï„Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(403762,11216,'zh','å‘ç¥¨æ”¯ä»˜æˆåŠŸ\r\n',0),(403763,11216,'sv','Fakturan betalas framgÃ¥ngsrikt',0),(403764,11216,'it','Fattura pagata con successo',0),(403765,11216,'tl','',0),(403766,11216,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(403767,11216,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸',0),(403768,11216,'ms','Invois dibayar berjaya',0),(403769,11216,'ar','Ø³Ø¯Ù‘Ø¯Øª Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¨Ù†Ø¬Ø§Ø­',0),(403770,11216,'fr','Facture payÃ©e avec succÃ¨s',0),(403771,11216,'jp','æ­£å¸¸ã«æ”¯æ‰•ã‚ã‚Œã‚‹è«‹æ±‚æ›¸',0),(403772,11216,'pt','Fatura paga com Ãªxito',0),(403773,11216,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(403774,11216,'es','Factura Pagada Exitosamente',0),(403775,11216,'de','Rechnung bezahlt erfolgreich',0),(403776,11216,'en','Invoice Paid Successfully',0),(403777,11217,'is','',0),(403778,11217,'dr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø± Ø§Ø¬Ø§Ø±Ù‡ ',0),(403779,11217,'pr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø± Ø§Ø¬Ø§Ø±Ù‡ ',0),(403780,11217,'tr','Kira otomatik fatura',0),(403781,11217,'pl','Automatyczne rozliczanie najmu',0),(403782,11217,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(403783,11217,'ur','Ù„ÛŒØ² Ø®ÙˆØ¯ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(403784,11217,'sr','ÐÐ°Ñ˜Ð°Ð¼ ÐÑƒÑ‚Ð¾ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(403785,11217,'vi','hÃ³a Ä‘Æ¡n cho thuÃª tá»± Ä‘á»™ng',0),(403786,11217,'af','Huurkontrak Outo fakturering',0),(403787,11217,'ro','Leasing Auto de facturare',0),(403788,11217,'et','Rendi Auto arved',0),(403789,11217,'si','Najem avto zaraÄunavanje',0),(403790,11217,'ba','Sewa mobil penagihan',0),(403791,11217,'nl','Lease Auto facturering',0),(403792,11217,'fi','Vuokrata Auto laskutus',0),(403793,11217,'no','Leieavtalen automatisk fakturering',0),(403794,11217,'da','Lease Auto fakturering',0),(403795,11217,'ko','ìž„ëŒ€ ìžë™ ê²°ì œ',0),(403796,11217,'he','×—×™×•×‘ ××•×˜×•×ž×˜×™ ×—×›×™×¨×”',0),(403797,11217,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î·Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(403798,11217,'zh','ç§Ÿèµè‡ªåŠ¨æ±½è½¦å¸å•\r\n',0),(403799,11217,'sv','Leasa automatisk fakturering',0),(403800,11217,'it','Leasing Auto fatturazione',0),(403801,11217,'tl','',0),(403802,11217,'th','à¹€à¸Šà¹ˆà¸²à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(403803,11217,'hi','à¤²à¥€à¤œ à¤‘à¤Ÿà¥‹ à¤¬à¤¿à¤²à¤¿à¤‚à¤—',0),(403804,11217,'ms','Bil automatik pajakan',0),(403805,11217,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(403806,11217,'fr','Location Auto facturation',0),(403807,11217,'jp','è‡ªå‹•è«‹æ±‚ã‚’ãƒªãƒ¼ã‚¹ã—ã¾ã™ã€‚',0),(403808,11217,'pt','LocaÃ§Ã£o de Auto facturaÃ§Ã£o',0),(403809,11217,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð°Ñ€ÐµÐ½Ð´Ñ‹ Ð°Ð²Ñ‚Ð¾',0),(403810,11217,'es','Auto FacturaciÃ³n de Arrendamiento',0),(403811,11217,'de','Leasing Auto Billing',0),(403812,11217,'en','Lease Auto Billing',0),(403813,11218,'is','',0),(403814,11218,'dr','Ù†ØªØ§ÙŠØ¬ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø± Ø§Ø¬Ø§Ø±Ù‡ ',0),(403815,11218,'pr','Ù†ØªØ§ÙŠØ¬ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø± Ø§Ø¬Ø§Ø±Ù‡ ',0),(403816,11218,'tr','Kira otomatik fatura sonuÃ§larÄ±',0),(403817,11218,'pl','Wyniki rozliczeÅ„ Auto leasing',0),(403818,11218,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸',0),(403819,11218,'ur','Ù„ÛŒØ² Ø®ÙˆØ¯ Ú©Û’ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù†ØªØ§Ø¦Ø¬',0),(403820,11218,'sr','ÐÐ°Ñ˜Ð°Ð¼ ÐÑƒÑ‚Ð¾ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ðµ',0),(403821,11218,'vi','káº¿t quáº£ hÃ³a Ä‘Æ¡n cho thuÃª tá»± Ä‘á»™ng',0),(403822,11218,'af','Huurkontrak Outo fakturering resultate',0),(403823,11218,'ro','Leasing Auto facturare rezultate',0),(403824,11218,'et','Rendi Auto arved tulemused',0),(403825,11218,'si','Najem avto zaraÄunavanje rezultatov',0),(403826,11218,'ba','Sewa mobil penagihan hasil',0),(403827,11218,'nl','Lease Auto facturering resultaten',0),(403828,11218,'fi','Vuokra Auto laskutus tulokset',0),(403829,11218,'no','Leieavtalen automatisk fakturering resultater',0),(403830,11218,'da','LejemÃ¥let automatisk fakturering resultater',0),(403831,11218,'ko','ìž„ëŒ€ ìžë™ ê²°ì œ ê²°ê³¼',0),(403832,11218,'he','×©×›×™×¨×•×ª ××•×˜×•×ž×˜×™×ª ×—×™×•×‘ ×ª×•×¦××•×ª',0),(403833,11218,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î·Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚ Î±Ï€Î¿Ï„ÎµÎ»Î­ÏƒÎ¼Î±Ï„Î±',0),(403834,11218,'zh','ç§Ÿèµè‡ªåŠ¨ç»“ç®—ç»“æžœ\r\n',0),(403835,11218,'sv','Hyresavtalet Auto fakturering resultat',0),(403836,11218,'it','Leasing Auto fatturazione risultati',0),(403837,11218,'tl','',0),(403838,11218,'th','à¸œà¸¥à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¹€à¸Šà¹ˆà¸²',0),(403839,11218,'hi','à¤²à¥€à¤œ à¤‘à¤Ÿà¥‹ à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤ªà¤°à¤¿à¤£à¤¾à¤®',0),(403840,11218,'ms','Pajakan Auto bil keputusan',0),(403841,11218,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù†ØªØ§Ø¦Ø¬',0),(403842,11218,'fr','Location Auto facturation rÃ©sultats',0),(403843,11218,'jp','ãƒªãƒ¼ã‚¹è‡ªå‹•èª²é‡‘çµæžœ',0),(403844,11218,'pt','LocaÃ§Ã£o de Auto facturaÃ§Ã£o resultados',0),(403845,11218,'ru','Ð ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ð° Ð°Ñ€ÐµÐ½Ð´Ñ‹ Ð°Ð²Ñ‚Ð¾',0),(403846,11218,'es','Resultados de Auto FacturaciÃ³n de Arrendamiento',0),(403847,11218,'de','Leasing Auto Billing Ergebnisse',0),(403848,11218,'en','Lease Auto Billing Results',0),(403849,11219,'is','',0),(403850,11219,'dr','Ù‡ÙŠÚ† ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(403851,11219,'pr','Ù‡ÙŠÚ† ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(403852,11219,'tr','Mevcut kredi kartÄ± yok',0),(403853,11219,'pl','Karty kredytowe nie dostÄ™pna',0),(403854,11219,'bg','ÐÑÐ¼Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿Ð½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(403855,11219,'ur','Ú©ÙˆØ¦ÛŒ Ø¯Ø³ØªÛŒØ§Ø¨ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±ÚˆØ²',0),(403856,11219,'sr','ÐÐµÐ¼Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸Ñ… ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸Ñ… ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(403857,11219,'vi','tháº» tÃ­n dá»¥ng khÃ´ng sáºµn cÃ³',0),(403858,11219,'af','Geen beskikbare krediet kaarte',0),(403859,11219,'ro','Nici o carte de Credit disponibil',0),(403860,11219,'et','Saadaval krediitkaardid',0),(403861,11219,'si','Kreditnih kartic ne na voljo',0),(403862,11219,'ba','Kartu kredit tidak tersedia',0),(403863,11219,'nl','Geen beschikbare Credit Cards',0),(403864,11219,'fi','Luottokortteja ei saatavilla',0),(403865,11219,'no','Ingen tilgjengelig kredittkort',0),(403866,11219,'da','Ingen tilgÃ¦ngelige kreditkort',0),(403867,11219,'ko','ì‚¬ìš© ê°€ëŠ¥í•œ ì‹ ìš© ì¹´ë“œ',0),(403868,11219,'he','××™×Ÿ ×›×¨×˜×™×¡×™ ××©×¨××™ ×–×ž×™× ×™×',0),(403869,11219,'el','ÎšÎ±Î¼Î¯Î± Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(403870,11219,'zh','æ²¡æœ‰å¯ç”¨çš„ä¿¡ç”¨å¡\r\n',0),(403871,11219,'sv','Inga tillgÃ¤ngliga kreditkort',0),(403872,11219,'it','No carte di credito disponibili',0),(403873,11219,'tl','',0),(403874,11219,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¹„à¸¡à¹ˆà¸¡à¸µ',0),(403875,11219,'hi','à¤•à¥‹à¤ˆ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡',0),(403876,11219,'ms','Tiada kad kredit yang tersedia',0),(403877,11219,'ar','Ù„ÙŠØ³Øª Ù‡Ù†Ø§Ùƒ Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ø¦ØªÙ…Ø§Ù† Ù…ØªØ§Ø­Ø©',0),(403878,11219,'fr','Aucune carte de crÃ©dit disponible',0),(403879,11219,'jp','åˆ©ç”¨å¯èƒ½ãªã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ãªã—',0),(403880,11219,'pt','Sem cartÃµes de crÃ©dito disponÃ­veis',0),(403881,11219,'ru','ÐÐµÑ‚ Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ñ… ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐšÐ°Ñ€Ñ‚',0),(403882,11219,'es','Tarjetas de CrÃ©dito No Hay Disponibles',0),(403883,11219,'de','Keine verfÃ¼gbaren Kreditkarten',0),(403884,11219,'en','No Available Credit Cards',0),(403885,11220,'is','',0),(403886,11220,'dr','(Ø´Ù…Ø§Ø±Ù‡ ) Ù…ÙˆÙÙ‚ ',0),(403887,11220,'pr','ØªØ¹Ø¯Ø§Ø¯(Ø´Ù…Ø§Ø±Ù‡ ) Ù…ÙˆÙÙ‚ ',0),(403888,11220,'tr','SayÄ± baÅŸarÄ±lÄ±',0),(403889,11220,'pl','Liczba udanych',0),(403890,11220,'bg','Ð‘Ñ€Ð¾Ð¹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¸',0),(403891,11220,'ur','ØªØ¹Ø¯Ø§Ø¯ Ú©Ø§Ù…ÛŒØ§Ø¨',0),(403892,11220,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(403893,11220,'vi','sá»‘ thÃ nh cÃ´ng',0),(403894,11220,'af','Getal suksesvolle',0),(403895,11220,'ro','NumÄƒrul de succes',0),(403896,11220,'et','Mitmed edukad',0),(403897,11220,'si','Å tevilo uspeÅ¡no',0),(403898,11220,'ba','Nomor sukses',0),(403899,11220,'nl','Aantal succesvolle',0),(403900,11220,'fi','Useita onnistuneita',0),(403901,11220,'no','Antall vellykkede',0),(403902,11220,'da','Antal vellykkede',0),(403903,11220,'ko','ìˆ˜ ì„±ê³µ',0),(403904,11220,'he','×ž×¡×¤×¨ ×ž×•×¦×œ×—',0),(403905,11220,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÏ€Î¹Ï„Ï…Ï‡Î®Ï‚',0),(403906,11220,'zh','æ•°ç›®æˆåŠŸ\r\n',0),(403907,11220,'sv','Antal lyckade',0),(403908,11220,'it','Numero di successo',0),(403909,11220,'tl','',0),(403910,11220,'th','à¹€à¸¥à¸‚à¸—à¸µà¹ˆà¸›à¸£à¸°à¸ªà¸šà¸„à¸§à¸²à¸¡à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(403911,11220,'hi','à¤¸à¤«à¤² à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(403912,11220,'ms','Jumlah yang berjaya',0),(403913,11220,'ar','Ø¹Ø¯Ø¯ Ù†Ø§Ø¬Ø­Ø©',0),(403914,11220,'fr','Nombre de succÃ¨s',0),(403915,11220,'jp','æˆåŠŸæ•°',0),(403916,11220,'pt','NÃºmero bem sucedido',0),(403917,11220,'ru','Ð§Ð¸ÑÐ»Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ñ‹Ñ…',0),(403918,11220,'es','NÃºmero Exitoso',0),(403919,11220,'de','Anzahl erfolgreich',0),(403920,11220,'en','Number Successful',0),(403921,11221,'is','',0),(403922,11221,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(403923,11221,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(403924,11221,'tr','BaÅŸarÄ±yla Ã¶denen',0),(403925,11221,'pl','WypÅ‚acane pomyÅ›lnie',0),(403926,11221,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(403927,11221,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ø¯Ø§ Ú©ÛŒØ§',0),(403928,11221,'sr','Ð£ÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(403929,11221,'vi','ÄÃ£ thanh toÃ¡n thÃ nh cÃ´ng',0),(403930,11221,'af','Susesvol Betaal',0),(403931,11221,'ro','PlÄƒtit cu succes',0),(403932,11221,'et','Makstud edukalt',0),(403933,11221,'si','PlaÄa uspeÅ¡no',0),(403934,11221,'ba','Dibayar berhasil',0),(403935,11221,'nl','Betaald met succes',0),(403936,11221,'fi','Maksettu onnistuneesti',0),(403937,11221,'no','Betalt vellykket',0),(403938,11221,'da','Betalt med succes',0),(403939,11221,'ko','ì„±ê³µì ìœ¼ë¡œ ì§€ë¶ˆ',0),(403940,11221,'he','×©×™×œ× ×‘×”×¦×œ×—×”',0),(403941,11221,'el','ÎšÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(403942,11221,'zh','æ”¯ä»˜æˆåŠŸ\r\n',0),(403943,11221,'sv','Betalas framgÃ¥ngsrikt',0),(403944,11221,'it','Pagato con successo',0),(403945,11221,'tl','',0),(403946,11221,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(403947,11221,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(403948,11221,'ms','Dibayar berjaya',0),(403949,11221,'ar','Ø³Ø¯Ù‘Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(403950,11221,'fr','PayÃ© avec succÃ¨s',0),(403951,11221,'jp','æ­£å¸¸ã«æ”¯æ‰•ã£ãŸ',0),(403952,11221,'pt','Pago com sucesso',0),(403953,11221,'ru','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(403954,11221,'es','Pagado Exitosamente',0),(403955,11221,'de','Erfolgreich bezahlt',0),(403956,11221,'en','Paid Successfully',0),(403957,11222,'is','',0),(403958,11222,'dr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø± Ø±Ø§ Ø§Ø¬Ø±Ø§ ÙƒÙ†ÙŠØ¯ ',0),(403959,11222,'pr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø± Ø±Ø§ Ø§Ø¬Ø±Ø§ ÙƒÙ†ÙŠØ¯ ',0),(403960,11222,'tr','Otomatik fatura Ã§alÄ±ÅŸtÄ±rmak',0),(403961,11222,'pl','UruchomiÄ‡ automatyczne fakturowanie',0),(403962,11222,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½Ð¸ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(403963,11222,'ur','Ø¢Ù¹Ùˆ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú†Ù„Øª Ú©Ø±ÛŒÚº',0),(403964,11222,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸ ÐÑƒÑ‚Ð¾ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(403965,11222,'vi','cháº¡y hÃ³a Ä‘Æ¡n tá»± Ä‘á»™ng',0),(403966,11222,'af','Loop Outo fakturering',0),(403967,11222,'ro','Facturare Auto a alerga',0),(403968,11222,'et','KÃ¤ivitage automaatne arvete',0),(403969,11222,'si','ZaÅ¾enite samodejno obraÄunavanje',0),(403970,11222,'ba','Jalankan Auto penagihan',0),(403971,11222,'nl','Uitvoeren van automatische facturering',0),(403972,11222,'fi','Suorita automaattinen laskutus',0),(403973,11222,'no','KjÃ¸re automatisk fakturering',0),(403974,11222,'da','KÃ¸r Auto fakturering',0),(403975,11222,'ko','ìžë™ ê²°ì œë¥¼ ì‹¤í–‰',0),(403976,11222,'he','×œ×”×¤×¢×™×œ ×—×™×•×‘ ××•×˜×•×ž×˜×™',0),(403977,11222,'el','Î•ÎºÏ„ÎµÎ»Î­ÏƒÏ„Îµ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(403978,11222,'zh','è¿è¡Œè‡ªåŠ¨è®¡è´¹\r\n',0),(403979,11222,'sv','KÃ¶r automatisk fakturering',0),(403980,11222,'it','Eseguire la fatturazione automatica',0),(403981,11222,'tl','',0),(403982,11222,'th','à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¸—à¸µà¹ˆà¸—à¸³à¸‡à¸²à¸™',0),(403983,11222,'hi','à¤‘à¤Ÿà¥‹ à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤šà¤²à¤¾à¤à¤',0),(403984,11222,'ms','Bil automatik yang berjalan',0),(403985,11222,'ar','ØªØ´ØºÙŠÙ„ ØªÙ„Ù‚Ø§Ø¦ÙŠ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(403986,11222,'fr','ExÃ©cuter l\'Auto facturation',0),(403987,11222,'jp','è‡ªå‹•è«‹æ±‚ã‚’å®Ÿè¡Œã—ã¾ã™ã€‚',0),(403988,11222,'pt','Executar o faturamento automÃ¡tico',0),(403989,11222,'ru','Ð—Ð°Ð¿ÑƒÑÑ‚Ð¸Ñ‚Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(403990,11222,'es','Activar Auto FacturaciÃ³n',0),(403991,11222,'de','FÃ¼hren Sie automatische Abrechnung',0),(403992,11222,'en','Run Auto Billing',0),(403993,11223,'is','',0),(403994,11223,'dr','Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ§Ø±Øª Ù‡Ø§ ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø³Ø§Ø²Ù…Ø§Ù†Ø¯Ù‡ÙŠ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(403995,11223,'pr','Ø§ÙŠÙ† Ø´Ø±ÙƒØª Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ§Ø±Øª Ù‡Ø§ ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø³Ø§Ø²Ù…Ø§Ù†Ø¯Ù‡ÙŠ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(403996,11223,'tr','Bu ÅŸirketin iÅŸlem kredi kartlarÄ± iÃ§in yapÄ±landÄ±rÄ±lmamÄ±ÅŸ',0),(403997,11223,'pl','Ta firma nie jest skonfigurowany do procesu karty kredytowe',0),(403998,11223,'bg','Ð¢Ð°Ð·Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð½Ðµ Ðµ ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð¸Ñ€Ð°Ð½ Ð·Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(403999,11223,'ur','ÛŒÛ Ú©Ù…Ù¾Ù†ÛŒ Ø¹Ù…Ù„ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ù„Ø¦Û’ ØªØ´Ú©ÛŒÙ„ Ø´Ø¯Û Ù†ÛÛŒÚº ÛÛ’',0),(404000,11223,'sr','ÐžÐ²Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð¸ÑÐ°Ð½ Ð·Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(404001,11223,'vi','CÃ´ng ty nÃ y khÃ´ng Ä‘Æ°á»£c cáº¥u hÃ¬nh Ä‘á»ƒ sá»­ dá»¥ng tháº» tÃ­n dá»¥ng',0),(404002,11223,'af','Hierdie Onderneming Is Nie Opgestel om Kredietkaarte te Prosesseer',0),(404003,11223,'ro','AceastÄƒ companie nu este configurat pentru cardurile de Credit proces',0),(404004,11223,'et','See ettevÃµte ei ole konfigureeritud kasutama krediitkaarte',0),(404005,11223,'si','To podjetje ni konfiguriran za proces kreditne kartice',0),(404006,11223,'ba','Perusahaan ini tidak dikonfigurasi untuk proses kartu kredit',0),(404007,11223,'nl','Dit bedrijf Is niet geconfigureerd voor het proces Credit Cards',0),(404008,11223,'fi','TÃ¤mÃ¤ yritys ei ole mÃ¤Ã¤ritetty prosessi luottokortit',0),(404009,11223,'no','Dette selskapet er ikke konfigurert til prosessen kredittkort',0),(404010,11223,'da','Dette selskab er ikke konfigureret til processen kreditkort',0),(404011,11223,'ko','ì´ íšŒì‚¬ í”„ë¡œì„¸ìŠ¤ ì‹ ìš© ì¹´ë“œì— êµ¬ì„± ë˜ì–´ ìžˆì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(404012,11223,'he','×”×—×‘×¨×” ×”×–××ª ×œ× × ×§×‘×¢×” ×ª×”×œ×™×š ×›×¨×˜×™×¡×™ ××©×¨××™',0),(404013,11223,'el','Î‘Ï…Ï„Î® Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ ÏÏ…Î¸Î¼Î¹ÏƒÏ„ÎµÎ¯ Î½Î± Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(404014,11223,'zh','è¿™å®¶å…¬å¸æ˜¯æœªé…ç½®ä¸ºå¤„ç†ä¿¡ç”¨å¡\r\n',0),(404015,11223,'sv','Detta fÃ¶retag Ã¤r inte konfigurerad fÃ¶r att processen kreditkort',0),(404016,11223,'it','Questa azienda non Ã¨ configurata per il processo di carte di credito',0),(404017,11223,'tl','',0),(404018,11223,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸à¸³à¸«à¸™à¸”à¸„à¹ˆà¸²à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(404019,11223,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥€ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‰à¤¨à¥à¤«à¤¼à¤¿à¤—à¤° à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(404020,11223,'ms','Syarikat ini tidak dikonfigurasikan untuk proses kad kredit',0),(404021,11223,'ar','Ù„Ù… ÙŠØªÙ… ØªÙƒÙˆÙŠÙ† Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ© Ø¥Ù„Ù‰ Ø¹Ù…Ù„ÙŠØ© Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(404022,11223,'fr','Cette sociÃ©tÃ© n\'est pas configurÃ©e pour les cartes de crÃ©dit de processus',0),(404023,11223,'jp','ã“ã®ä¼šç¤¾ã¯ã€ãƒ—ãƒ­ã‚»ã‚¹ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã«æ§‹æˆã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(404024,11223,'pt','Esta empresa nÃ£o estÃ¡ configurada para o processo de cartÃµes de crÃ©dito',0),(404025,11223,'ru','Ð­Ñ‚Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð½Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐ½ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(404026,11223,'es','Esta Empresa No Esta Configurado Para Procesar Tarjetas de CrÃ©dito',0),(404027,11223,'de','Diese Firma ist Prozess-Kreditkarten nicht konfiguriert.',0),(404028,11223,'en','This Company Is Not Configured to Process Credit Cards',0),(404029,11224,'is','',0),(404030,11224,'dr','(Ù‡Ø²ÙŠÙ†Ù‡ Ø´Ø¯Ù‡',0),(404031,11224,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ (Ù‡Ø²ÙŠÙ†Ù‡ Ø´Ø¯Ù‡',0),(404032,11224,'tr','Toplam fatura',0),(404033,11224,'pl','Sumie zapowiadane',0),(404034,11224,'bg','ÐžÐ±Ñ‰Ð¾ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸',0),(404035,11224,'ur','Ú©Ù„ Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(404036,11224,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(404037,11224,'vi','Tá»•ng cá»™ng sá»‘ Ä‘Ã£ quáº£ng cÃ¡o',0),(404038,11224,'af','Totaal weerspieÃ«l',0),(404039,11224,'ro','Total facturat',0),(404040,11224,'et','Arve kokku',0),(404041,11224,'si','ZaraÄunano',0),(404042,11224,'ba','Total tagihan',0),(404043,11224,'nl','Totaal gefactureerd',0),(404044,11224,'fi','Laskutettu yhteensÃ¤',0),(404045,11224,'no','Fakturert totalt',0),(404046,11224,'da','Samlet faktureret',0),(404047,11224,'ko','ì´ ì²­êµ¬',0),(404048,11224,'he','×¡×” ×› ×—×™×•×‘',0),(404049,11224,'el','Î£Ï…Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚',0),(404050,11224,'zh','æ€»è®¡å…¥è´¦\r\n',0),(404051,11224,'sv','Totalt faktureras',0),(404052,11224,'it','Totale fatturato',0),(404053,11224,'tl','',0),(404054,11224,'th','à¸œà¸¥à¸£à¸§à¸¡à¸—à¸µà¹ˆà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(404055,11224,'hi','à¤•à¥à¤² à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾',0),(404056,11224,'ms','Jumlah yang dibilkan',0),(404057,11224,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(404058,11224,'fr','Total facturÃ©',0),(404059,11224,'jp','åˆè¨ˆè«‹æ±‚',0),(404060,11224,'pt','Total faturado',0),(404061,11224,'ru','Ð’ÑÐµÐ³Ð¾ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¾',0),(404062,11224,'es','Total Facturado',0),(404063,11224,'de','Insgesamt in Rechnung gestellt',0),(404064,11224,'en','Total Billed',0),(404065,11225,'is','',0),(404066,11225,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(404067,11225,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø®Ø±ÙŠØ¯Ø§Ø±Ø§Ù† ',0),(404068,11225,'tr','Toplam mÃ¼ÅŸteriler',0),(404069,11225,'pl','CaÅ‚kowita klientÃ³w',0),(404070,11225,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(404071,11225,'ur','Ú©Ù„ Ú©Û’ ØµØ§Ø±ÙÛŒÙ†',0),(404072,11225,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÐºÑƒÐ¿Ñ†Ð¸',0),(404073,11225,'vi','Tá»•ng sá»‘ cÃ¡c khÃ¡ch hÃ ng',0),(404074,11225,'af','Totale KliÃ«nte / Klante',0),(404075,11225,'ro','ClienÅ£ii totalÄƒ',0),(404076,11225,'et','Klientide arv',0),(404077,11225,'si','Skupno stranke',0),(404078,11225,'ba','Jumlah pelanggan',0),(404079,11225,'nl','Totaal aantal klanten',0),(404080,11225,'fi','YhteensÃ¤ asiakkaat',0),(404081,11225,'no','Totalt kunder',0),(404082,11225,'da','Samlede kunder',0),(404083,11225,'ko','ì´ ê³ ê°',0),(404084,11225,'he','×”×œ×§×•×—×•×ª ×”×›×•×œ×œ',0),(404085,11225,'el','Î£Ï…Î½ÏŒÎ»Î¿Ï… Ï„Ï‰Î½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(404086,11225,'zh','åˆè®¡å®¢æˆ·\r\n',0),(404087,11225,'sv','Totala kunder',0),(404088,11225,'it','Totali clienti',0),(404089,11225,'tl','',0),(404090,11225,'th','à¸£à¸§à¸¡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(404091,11225,'hi','à¤•à¥à¤² à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(404092,11225,'ms','Jumlah pelanggan',0),(404093,11225,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(404094,11225,'fr','Totales clients',0),(404095,11225,'jp','ç·é¡§å®¢',0),(404096,11225,'pt','Total de clientes',0),(404097,11225,'ru','Ð’ÑÐµÐ³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(404098,11225,'es','Total Clientes',0),(404099,11225,'de','Kunden gesamt',0),(404100,11225,'en','Total Customers',0),(404101,11226,'is','',0),(404102,11226,'dr','(Ø¶Ø¨Ø·) Ø´Ø¯Ù‡ ',0),(404103,11226,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ(Ø¶Ø¨Ø·) Ø´Ø¯Ù‡ ',0),(404104,11226,'tr','Under tutar',0),(404105,11226,'pl','Kwoty zÅ‚oÅ¼one',0),(404106,11226,'bg','Ð¡ÑƒÐ¼Ð° Ð¿Ð¸Ð»Ð°',0),(404107,11226,'ur','Ø±Ù‚Ù… Ø¯Ø§Ø¦Ø±',0),(404108,11226,'sr','Ð˜Ð·Ð½Ð¾Ñ Ñ˜Ðµ Ð¿Ð¾Ð´Ð½ÐµÐ¾',0),(404109,11226,'vi','Sá»‘ tiá»n Ä‘Ã£ ná»™p',0),(404110,11226,'af','Bedrag geliasseer',0),(404111,11226,'ro','Suma depusÄƒ',0),(404112,11226,'et','Esitatud summa',0),(404113,11226,'si','Znesek pila',0),(404114,11226,'ba','Jumlah yang diajukan',0),(404115,11226,'nl','Bedrag geplaatst',0),(404116,11226,'fi','MÃ¤Ã¤rÃ¤ arkistoida',0),(404117,11226,'no','BelÃ¸pet arkivert',0),(404118,11226,'da','BelÃ¸b, der er gemt',0),(404119,11226,'ko','ì‹ ì²­ ê¸ˆì•¡',0),(404120,11226,'he','×›×ž×•×ª ×”×§×˜×’×•×¨×™×•×ª',0),(404121,11226,'el','Î Î¿ÏƒÏŒ ÎºÎ±Ï„Î±Ï„Î¯Î¸ÎµÏ„Î±Î¹',0),(404122,11226,'zh','é‡‘é¢å­˜æ¡£\r\n',0),(404123,11226,'sv','Beloppet arkiverat',0),(404124,11226,'it','Importo depositato',0),(404125,11226,'tl','',0),(404126,11226,'th','à¸ˆà¸³à¸™à¸§à¸™à¸—à¸µà¹ˆà¸¢à¸·à¹ˆà¸™',0),(404127,11226,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤¤à¤¹à¤¤ à¤¦à¤¾à¤¯à¤°',0),(404128,11226,'ms','Jumlah yang difailkan',0),(404129,11226,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù‚Ø¯Ù…',0),(404130,11226,'fr','Montant dÃ©posÃ©',0),(404131,11226,'jp','é‡ã«æå‡º',0),(404132,11226,'pt','Quantidade arquivada',0),(404133,11226,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð´Ð°Ð½Ð½Ð¾Ð¹',0),(404134,11226,'es','Cantidad Pedido',0),(404135,11226,'de','Betrag abgelegt',0),(404136,11226,'en','Amount Filed',0),(404137,11227,'is','',0),(404138,11227,'dr','Ù…Ø­Ù„ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(404139,11227,'pr','Ù…Ø­Ù„ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(404140,11227,'tr','Mahkeme baÅŸvurularÄ±',0),(404141,11227,'pl','OpiÅ‚kami sÄ…du',0),(404142,11227,'bg','Ð¡ÑŠÐ´ÐµÐ±Ð½Ð° ÑÑ‚Ñ€ÑƒÐ¶ÐºÐ¸',0),(404143,11227,'ur','Ø¹Ø¯Ø§Ù„Øª Ù†Û’ Ø±ÛŒØª',0),(404144,11227,'sr','Ð¡ÑƒÐ´Ñƒ Ð¿Ð¾Ð´Ð½ÐµÑÐºÐµ',0),(404145,11227,'vi','Ä‘áº¿m file',0),(404146,11227,'af','Hof Filings',0),(404147,11227,'ro','PiliturÄƒ de Curtea',0),(404148,11227,'et','Kohus viilmed',0),(404149,11227,'si','SodiÅ¡Äe opilki',0),(404150,11227,'ba','Pengajuan pengadilan',0),(404151,11227,'nl','Hof depots',0),(404152,11227,'fi','Tuomioistuin viilaus',0),(404153,11227,'no','Retten registreringer',0),(404154,11227,'da','Retten hÃ¸vle',0),(404155,11227,'ko','ë²•ì› ì„œë¥˜',0),(404156,11227,'he','×§×•×¨×˜ ×©×‘×‘×™',0),(404157,11227,'el','Î¡Î¹Î½Î¯ÏƒÎ¼Î±Ï„Î± Î´Î¹ÎºÎ±ÏƒÏ„Î®ÏÎ¹Î¿',0),(404158,11227,'zh','æ³•åº­æ–‡ä»¶\r\n',0),(404159,11227,'sv','StÃ¤mningsansÃ¶kan',0),(404160,11227,'it','Processuale',0),(404161,11227,'tl','',0),(404162,11227,'th','à¸¢à¸·à¹ˆà¸™à¹€à¸­à¸à¸ªà¸²à¸£à¹à¸ˆà¹‰à¸‡à¸¨à¸²à¸¥',0),(404163,11227,'hi','à¤…à¤¦à¤¾à¤²à¤¤ à¤¬à¥à¤°à¤¾à¤¦à¤¾',0),(404164,11227,'ms','Filings Mahkamah',0),(404165,11227,'ar','Ø¨Ø±Ø§Ø¯Ø© Ø§Ù„Ù…Ø­ÙƒÙ…Ø©',0),(404166,11227,'fr','DÃ©pÃ´ts de Cour',0),(404167,11227,'jp','è£åˆ¤æ‰€ãƒ•ã‚¡ã‚¤ãƒªãƒ³ã‚°',0),(404168,11227,'pt','Tribunal limalha',0),(404169,11227,'ru','Ð¡ÑƒÐ´ Ð·Ð°ÑÐ²Ð¾Ðº',0),(404170,11227,'es','Interposiciones Legales',0),(404171,11227,'de','Gericht eingereichten Unterlagen',0),(404172,11227,'en','Court Filings',0),(404173,11228,'is','',0),(404174,11228,'dr','ØªØ§Ø±ÙŠØ® Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø´Ø¯Ù‡ ',0),(404175,11228,'pr','ØªØ§Ø±ÙŠØ® Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø´Ø¯Ù‡ ',0),(404176,11228,'tr','Under tarihi',0),(404177,11228,'pl','Dnia',0),(404178,11228,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð°',0),(404179,11228,'ur','Ù‚Ø·Ø¹Û ØªØ§Ø±ÛŒØ®',0),(404180,11228,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ Ð¿Ð¾Ð´Ð½ÐµÐ¾',0),(404181,11228,'vi','Äiá»n ngÃ y',0),(404182,11228,'af','Datum geliasseer',0),(404183,11228,'ro','Data depusÄƒ',0),(404184,11228,'et','KuupÃ¤eva esitatud',0),(404185,11228,'si','Datuma',0),(404186,11228,'ba','Tanggal diajukan',0),(404187,11228,'nl','Datum ingediend',0),(404188,11228,'fi','PÃ¤ivÃ¤, jona',0),(404189,11228,'no','Dato arkivert',0),(404190,11228,'da','Dato',0),(404191,11228,'ko','ë‚ ì§œì— ì‹ ì²­',0),(404192,11228,'he','×ª××¨×™×š ×”×’×™×©',0),(404193,11228,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(404194,11228,'zh','æ—¥æœŸé€’äº¤\r\n',0),(404195,11228,'sv','Dag in',0),(404196,11228,'it','Data archiviato',0),(404197,11228,'tl','',0),(404198,11228,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸¢à¸·à¹ˆà¸™',0),(404199,11228,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‡ à¤¤à¤¹à¤¤ à¤¦à¤¾à¤¯à¤°',0),(404200,11228,'ms','Tarikh yang difailkan',0),(404201,11228,'ar','ØªØ§Ø±ÙŠØ® Ø±ÙØ¹Ù‡Ø§',0),(404202,11228,'fr','Date de dÃ©pÃ´t',0),(404203,11228,'jp','æå‡ºæ—¥',0),(404204,11228,'pt','Data arquivada',0),(404205,11228,'ru','Ð”Ð°Ñ‚Ð° Ð—Ð°Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð°',0),(404206,11228,'es','Fecha Llenada',0),(404207,11228,'de','Datum abgelegt',0),(404208,11228,'en','Date Filed',0),(404209,11229,'is','',0),(404210,11229,'dr','Ø¹Ù†ÙˆØ§Ù† Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ ',0),(404211,11229,'pr','Ø¹Ù†ÙˆØ§Ù† Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ ',0),(404212,11229,'tr','Dosyalama AdÄ±',0),(404213,11229,'pl','TytuÅ‚ zgÅ‚oszenia',0),(404214,11229,'bg','Ð—Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ',0),(404215,11229,'ur','Ø¹Ù†ÙˆØ§Ù† Ø¯Ø§Ø®Ù„',0),(404216,11229,'sr','ÐŸÐ¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ Ð½Ð°ÑÐ»Ð¾Ð²',0),(404217,11229,'vi','tÃªn file',0),(404218,11229,'af','Liassering titel',0),(404219,11229,'ro','Titlul de depunere',0),(404220,11229,'et','Esitamise nimetus',0),(404221,11229,'si','VloÅ¾itve naslov',0),(404222,11229,'ba','Pengajuan judul',0),(404223,11229,'nl','Indienen van titel',0),(404224,11229,'fi','Arkistointi otsikko',0),(404225,11229,'no','Innlevering tittel',0),(404226,11229,'da','Arkivering titel',0),(404227,11229,'ko','ì‹ ê³  ì œëª©',0),(404228,11229,'he','×”×’×©×ª ×”×ª×•××¨',0),(404229,11229,'el','Î¥Ï€Î¿Î²Î¿Î»Î® Ï„Î¯Ï„Î»Î¿Ï…',0),(404230,11229,'zh','æ–‡ä»¶æ ‡é¢˜\r\n',0),(404231,11229,'sv','AnsÃ¶kan titel',0),(404232,11229,'it','Titolo di deposito',0),(404233,11229,'tl','',0),(404234,11229,'th','à¸¢à¸·à¹ˆà¸™à¹€à¸£à¸·à¹ˆà¸­à¸‡',0),(404235,11229,'hi','à¤«à¤¾à¤‡à¤²à¤¿à¤‚à¤— à¤¶à¥€à¤°à¥à¤·à¤•',0),(404236,11229,'ms','Tajuk fail',0),(404237,11229,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„ØªÙ‚Ø¯ÙŠÙ…',0),(404238,11229,'fr','Titre de la production',0),(404239,11229,'jp','ã‚¿ã‚¤ãƒˆãƒ«ã‚’æå‡º',0),(404240,11229,'pt','TÃ­tulo da apresentaÃ§Ã£o',0),(404241,11229,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(404242,11229,'es','Titulo de Archivado',0),(404243,11229,'de','Titel der Einreichung',0),(404244,11229,'en','Filing Title',0),(404245,11230,'is','',0),(404246,11230,'dr','ØªØ§Ø±ÙŠØ® Ø¯Ø§Ø¯Ø±Ø³ÙŠ ',0),(404247,11230,'pr','ØªØ§Ø±ÙŠØ® Ø¯Ø§Ø¯Ø±Ø³ÙŠ ',0),(404248,11230,'tr','Karar tarihi',0),(404249,11230,'pl','Data wyroku',0),(404250,11230,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ',0),(404251,11230,'ur','Ø¹Ø¯Ø§Ù„Øª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(404252,11230,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ð´Ð»ÑƒÐºÐµ',0),(404253,11230,'vi','NgÃ y quyáº¿t Ä‘á»‹nh',0),(404254,11230,'af','Oordeel datum',0),(404255,11230,'ro','HotÄƒrÃ¢re data',0),(404256,11230,'et','Otsuse kuupÃ¤ev',0),(404257,11230,'si','Datum sodbe',0),(404258,11230,'ba','Penghakiman tanggal',0),(404259,11230,'nl','Arrest datum',0),(404260,11230,'fi','Tuomion pÃ¤ivÃ¤',0),(404261,11230,'no','Dom dato',0),(404262,11230,'da','Doms dato',0),(404263,11230,'ko','ì‹¬íŒ ë‚ ì§œ',0),(404264,11230,'he','×¤×¡×§ ×“×™×Ÿ ×ª××¨×™×š',0),(404265,11230,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€ÏŒÏ†Î±ÏƒÎ·Ï‚',0),(404266,11230,'zh','åˆ¤å†³æ—¥æœŸ\r\n',0),(404267,11230,'sv','Dom datum',0),(404268,11230,'it','Data della sentenza',0),(404269,11230,'tl','',0),(404270,11230,'th','à¸§à¸±à¸™à¸žà¸´à¸žà¸²à¸à¸©à¸²',0),(404271,11230,'hi','à¤«à¥ˆà¤¸à¤²à¥‡ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(404272,11230,'ms','Tarikh penghakiman',0),(404273,11230,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­ÙƒÙ…',0),(404274,11230,'fr','Date de l\'arrÃªt',0),(404275,11230,'jp','åˆ¤æ±ºæ—¥',0),(404276,11230,'pt','Data de julgamento',0),(404277,11230,'ru','Ð”Ð°Ñ‚Ð° Ñ€ÐµÑˆÐµÐ½Ð¸Ñ',0),(404278,11230,'es','Fecha de Sentencia',0),(404279,11230,'de','Urteil-Datum',0),(404280,11230,'en','Judgment Date',0),(404281,11231,'is','',0),(404282,11231,'dr','Ù…Ø¨Ù„Øº Ø¯Ø§Ø¯Ø±Ø³ÙŠ',0),(404283,11231,'pr','Ù…Ø¨Ù„Øº Ø¯Ø§Ø¯Ø±Ø³ÙŠ',0),(404284,11231,'tr','YargÄ± tutar',0),(404285,11231,'pl','WysokoÅ›ci orzeczenia',0),(404286,11231,'bg','Ð ÐµÑˆÐµÐ½Ð¸Ðµ ÑÑƒÐ¼Ð°',0),(404287,11231,'ur','Ø¹Ø¯Ø§Ù„Øª Ú©ÛŒ Ø±Ù‚Ù…',0),(404288,11231,'sr','Ð¡ÑƒÐ´ Ð¸Ð·Ð½Ð¾Ñ',0),(404289,11231,'vi','Sá»‘ quyáº¿t Ä‘á»‹nh',0),(404290,11231,'af','Oordeel bedrag',0),(404291,11231,'ro','Judecata suma',0),(404292,11231,'et','Otsuse summa',0),(404293,11231,'si','Sodba znesek',0),(404294,11231,'ba','Jumlah penghakiman',0),(404295,11231,'nl','Arrest bedrag',0),(404296,11231,'fi','Tuomion mÃ¤Ã¤rÃ¤',0),(404297,11231,'no','Dom belÃ¸p',0),(404298,11231,'da','Dom belÃ¸b',0),(404299,11231,'ko','íŒë‹¨ ê¸ˆì•¡',0),(404300,11231,'he','×¡×›×•× ×¤×¡×§ ×”×“×™×Ÿ',0),(404301,11231,'el','Î Î¿ÏƒÏŒ Ï„Î·Ï‚ Î±Ï€ÏŒÏ†Î±ÏƒÎ·Ï‚',0),(404302,11231,'zh','åˆ¤å†³é‡‘é¢\r\n',0),(404303,11231,'sv','Dom belopp',0),(404304,11231,'it','Sentenza importo',0),(404305,11231,'tl','',0),(404306,11231,'th','à¸¢à¸­à¸”à¸„à¸³à¸žà¸´à¸žà¸²à¸à¸©à¸²',0),(404307,11231,'hi','à¤¨à¤¿à¤°à¥à¤£à¤¯ à¤°à¤¾à¤¶à¤¿',0),(404308,11231,'ms','Jumlah penghakiman',0),(404309,11231,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø­ÙƒÙ…',0),(404310,11231,'fr','Montant du jugement',0),(404311,11231,'jp','åˆ¤æ±ºé¡',0),(404312,11231,'pt','Quantidade de julgamento',0),(404313,11231,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÑƒÐ¶Ð´ÐµÐ½Ð¸Ñ',0),(404314,11231,'es','Monto de Sentencia',0),(404315,11231,'de','Urteil-Betrag',0),(404316,11231,'en','Judgment Amount',0),(404317,11232,'is','',0),(404318,11232,'dr','Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(404319,11232,'pr','Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(404320,11232,'tr','Dosyalama sebebi',0),(404321,11232,'pl','Powodem zgÅ‚oszenia',0),(404322,11232,'bg','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð·Ð°Ð²ÐµÐ¶Ð´Ð°Ð½Ðµ',0),(404323,11232,'ur','ÙˆØ¬Û Ø¨ØªØ§Ø¦ÛŒÚº',0),(404324,11232,'sr','Ð£Ð·Ñ€Ð¾Ðº Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°ÑšÐ°',0),(404325,11232,'vi','nguyÃªn nhÃ¢n lÃ m Ä‘áº§y',0),(404326,11232,'af','Rede vir indiening',0),(404327,11232,'ro','Motiv pentru depunerea',0),(404328,11232,'et','Arhiivimise pÃµhjus',0),(404329,11232,'si','Vzrok za arhiviranje',0),(404330,11232,'ba','Alasan untuk pengajuan',0),(404331,11232,'nl','Reden voor indiening',0),(404332,11232,'fi','Syy arkistoimiseen',0),(404333,11232,'no','Ã…rsak til lagring',0),(404334,11232,'da','Ã…rsagen til arkivering',0),(404335,11232,'ko','ì œì¶œì— ëŒ€ í•œ ì´ìœ ',0),(404336,11232,'he','×”×¡×™×‘×” ×œ×”×’×©×ª',0),(404337,11232,'el','Î›ÏŒÎ³Î¿Ï‚ Î³Î¹Î± Ï„Î·Î½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(404338,11232,'zh','ç”³æŠ¥çš„åŽŸå› \r\n',0),(404339,11232,'sv','SkÃ¤l fÃ¶r ansÃ¶kan',0),(404340,11232,'it','Motivo per il deposito',0),(404341,11232,'tl','',0),(404342,11232,'th','à¹€à¸«à¸•à¸¸à¸œà¸¥à¹ƒà¸™à¸à¸²à¸£à¸¢à¸·à¹ˆà¸™',0),(404343,11232,'hi','à¤¦à¤¾à¤–à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾à¤°à¤£',0),(404344,11232,'ms','Sebab untuk difailkan',0),(404345,11232,'ar','Ø§Ù„Ø³Ø¨Ø¨ Ù„Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(404346,11232,'fr','Raison de la production',0),(404347,11232,'jp','ç”³ç«‹ã¦ã®ç†ç”±',0),(404348,11232,'pt','RazÃ£o para a apresentaÃ§Ã£o',0),(404349,11232,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð¾Ð¹ Ð´Ð»Ñ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸',0),(404350,11232,'es','ExplicaciÃ³n de La InteposiciÃ³n',0),(404351,11232,'de','Grund fÃ¼r die Einreichung',0),(404352,11232,'en','Reason for Filing',0),(404353,11233,'is','',0),(404354,11233,'dr','Ø­Ú©Ù… Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(404355,11233,'pr','Ø­Ú©Ù… Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(404356,11233,'tr','AlÄ±nan karar',0),(404357,11233,'pl','OtrzymaÅ‚ wyrok',0),(404358,11233,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¾Ñ‚Ð¾ Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ',0),(404359,11233,'ur','Ù…ÙˆØµÙˆÙ„Û Ø¹Ø¯Ø§Ù„Øª',0),(404360,11233,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð¿Ñ€ÐµÑÑƒÐ´Ñƒ',0),(404361,11233,'vi','Ä‘Ã£ nháº­n quyáº¿t Ä‘á»‹nh',0),(404362,11233,'af','Oordeel ontvang',0),(404363,11233,'ro','Primit judecata',0),(404364,11233,'et','VastuvÃµetud otsus',0),(404365,11233,'si','Prejela sodbo',0),(404366,11233,'ba','Menerima penilaian',0),(404367,11233,'nl','Ontvangen arrest',0),(404368,11233,'fi','Sai tuomion',0),(404369,11233,'no','Mottatte dom',0),(404370,11233,'da','Modtog dommen',0),(404371,11233,'ko','ë°›ì€ ì‹¬íŒ',0),(404372,11233,'he','×¤×¡×§ ×“×™×Ÿ ×©×”×ª×§×‘×œ',0),(404373,11233,'el','ÎˆÎ»Î±Î²Îµ Î±Ï€ÏŒÏ†Î±ÏƒÎ·',0),(404374,11233,'zh','æ”¶æ¬¾åˆ¤æ–­\r\n',0),(404375,11233,'sv','Fick dom',0),(404376,11233,'it','Sentenza ricevuto',0),(404377,11233,'tl','',0),(404378,11233,'th','à¹„à¸”à¹‰à¸£à¸±à¸šà¸„à¸³à¸žà¸´à¸žà¸²à¸à¸©à¸²',0),(404379,11233,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¿à¤°à¥à¤£à¤¯',0),(404380,11233,'ms','Menerima penghakiman',0),(404381,11233,'ar','ØªÙ„Ù‚ÙŠ Ø§Ù„Ø­ÙƒÙ…',0),(404382,11233,'fr','ArrÃªt reÃ§u',0),(404383,11233,'jp','å—ä¿¡ã—ãŸåˆ¤æ±º',0),(404384,11233,'pt','AcÃ³rdÃ£o recebido',0),(404385,11233,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ð¾Ðµ Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ',0),(404386,11233,'es','Sentencia Recibida',0),(404387,11233,'de','Empfangene Urteil',0),(404388,11233,'en','Received Judgment',0),(404389,11234,'is','',0),(404390,11234,'dr','(Ø§Ø«Ø§Ø«Ù‡ ',0),(404391,11234,'pr','Ù…ÙˆØ¬ÙˆØ¯ÙŠ ØªØ¬Ù‡ÙŠØ²Ø§Øª(Ø§Ø«Ø§Ø«Ù‡ ',0),(404392,11234,'tr','Envanter donanÄ±mlarÄ±',0),(404393,11234,'pl','Spis sprzÄ™tu',0),(404394,11234,'bg','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ñ‚Ð¾Ñ‡ÐºÐ°Ñ‚Ð°',0),(404395,11234,'ur','Ø³Ø§Ø² Ùˆ Ø³Ø§Ù…Ø§Ù† Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(404396,11234,'sr','Ð—Ð°Ð»Ð¸Ñ…Ðµ Ð¾Ð¿Ñ€ÐµÐ¼Ðµ',0),(404397,11234,'vi','Kho thiáº¿t bá»‹',0),(404398,11234,'af','Toerusting voorraad',0),(404399,11234,'ro','Echipament de inventar',0),(404400,11234,'et','Varustuse ladu',0),(404401,11234,'si','Popis opreme',0),(404402,11234,'ba','Persediaan peralatan',0),(404403,11234,'nl','Inventaris van uitrusting',0),(404404,11234,'fi','Laitteiden luettelo',0),(404405,11234,'no','Utstyr',0),(404406,11234,'da','Udstyr Inventory',0),(404407,11234,'ko','ìž¥ë¹„ ìž¬ê³ ',0),(404408,11234,'he','×ž×œ××™ ×¦×™×•×“',0),(404409,11234,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼Î¿Ï',0),(404410,11234,'zh','è®¾å¤‡åº“å­˜',0),(404411,11234,'sv','Utrustning inventering',0),(404412,11234,'it','Inventario attrezzature',0),(404413,11234,'tl','',0),(404414,11234,'th','à¸­à¸¸à¸›à¸à¸£à¸“à¹Œà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(404415,11234,'hi','à¤‰à¤ªà¤•à¤°à¤£ à¤¸à¥‚à¤šà¥€',0),(404416,11234,'ms','Inventori peralatan',0),(404417,11234,'ar','Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø¹Ø¯Ø§Øª',0),(404418,11234,'fr','Inventaire matÃ©riel',0),(404419,11234,'jp','æ©Ÿå™¨ã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒª',0),(404420,11234,'pt','InventÃ¡rio de equipamentos',0),(404421,11234,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¾Ð±Ð¾Ñ€ÑƒÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(404422,11234,'es','Inventory de Equipo',0),(404423,11234,'de','GerÃ¤tebestands',0),(404424,11234,'en','Equipment Inventory',0),(404425,11235,'is','',0),(404426,11235,'dr','Ø¶Ø§Ù…Ù†',0),(404427,11235,'pr','Ø¶Ø§Ù…Ù†',0),(404428,11235,'tr','Kefil',0),(404429,11235,'pl','Gwarant',0),(404430,11235,'bg','Ð“Ð°Ñ€Ð°Ð½Ñ‚',0),(404431,11235,'ur','Ø¶Ø§Ù…Ù†',0),(404432,11235,'sr','Ð“Ð°Ñ€Ð°Ð½Ñ‚',0),(404433,11235,'vi','ngÆ°á»i báº£o lÃ£nh',0),(404434,11235,'af','Borg',0),(404435,11235,'ro','Garant',0),(404436,11235,'et','KÃ¤endaja',0),(404437,11235,'si','Garant',0),(404438,11235,'ba','Penjamin',0),(404439,11235,'nl','Borg',0),(404440,11235,'fi','Takaajan',0),(404441,11235,'no','Garantist',0),(404442,11235,'da','Garant',0),(404443,11235,'ko','ë³´ì¦ì¸',0),(404444,11235,'he','×¢×¨×‘',0),(404445,11235,'el','Î•Î³Î³Ï…Î·Ï„Î®',0),(404446,11235,'zh','æ‹…ä¿äºº\r\n',0),(404447,11235,'sv','Garant',0),(404448,11235,'it','Garante',0),(404449,11235,'tl','',0),(404450,11235,'th','à¸œà¸¹à¹‰à¸„à¹‰à¸³à¸›à¸£à¸°à¸à¸±à¸™',0),(404451,11235,'hi','à¤—à¤¾à¤°à¤‚à¤Ÿà¤°',0),(404452,11235,'ms','Penjamin',0),(404453,11235,'ar','Ø§Ù„Ø¶Ø§Ù…Ù†',0),(404454,11235,'fr','Garant',0),(404455,11235,'jp','é€£å¸¯ä¿è¨¼äºº',0),(404456,11235,'pt','Fiador',0),(404457,11235,'ru','Ð“Ð°Ñ€Ð°Ð½Ñ‚',0),(404458,11235,'es','Fiador',0),(404459,11235,'de','Garant',0),(404460,11235,'en','Guarantor',0),(404461,11236,'is','',0),(404462,11236,'dr','Ø¢Ø¯Ø±Ø³ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¶Ø§Ù…Ù† ',0),(404463,11236,'pr','Ø¢Ø¯Ø±Ø³ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¶Ø§Ù…Ù† ',0),(404464,11236,'tr','GarantÃ¶r fatura adresi',0),(404465,11236,'pl','Gwarant adres fakturowania',0),(404466,11236,'bg','Ð“Ð°Ñ€Ð°Ð½Ñ‚ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð°Ð´Ñ€ÐµÑ',0),(404467,11236,'ur','Ø¶Ø§Ù…Ù† Ú©Û’ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø¹Ù†ÙˆØ§Ù†',0),(404468,11236,'sr','ÐÐ´Ñ€ÐµÑÐ° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð°',0),(404469,11236,'vi','Ä‘á»‹a chá»‰ viáº¿t hÃ³a Ä‘Æ¡n báº£o hÃ nh',0),(404470,11236,'af','Waarborggewer Verekeningsadres',0),(404471,11236,'ro','Adresa de facturare garant',0),(404472,11236,'et','KÃ¤endaja arve esitamise aadress',0),(404473,11236,'si','Garant naslov',0),(404474,11236,'ba','Alamat penagihan penjamin',0),(404475,11236,'nl','Borg factuuradres',0),(404476,11236,'fi','Takaajan laskutusosoite',0),(404477,11236,'no','Garantist faktureringsadresse',0),(404478,11236,'da','Garant faktureringsadresse',0),(404479,11236,'ko','ë³´ì¦ì¸ ì²­êµ¬ ì£¼ì†Œ',0),(404480,11236,'he','×›×ª×•×‘×ª ×—×™×•×‘ ×¢×¨×‘',0),(404481,11236,'el','Î•Î³Î³Ï…Î·Ï„Î®Ï‚ Î§Î¡Î•Î©Î£Î—Î£',0),(404482,11236,'zh','æ‹…ä¿äººå¸å•åœ°å€\r\n',0),(404483,11236,'sv','Garant faktureringsadress',0),(404484,11236,'it','Indirizzo di fatturazione del garante',0),(404485,11236,'tl','',0),(404486,11236,'th','à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸œà¸¹à¹‰à¸„à¹‰à¸³à¸›à¸£à¸°à¸à¸±à¸™à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(404487,11236,'hi','à¤—à¤¾à¤°à¤‚à¤Ÿà¥€ à¤¬à¤¿à¤² à¤¸à¤®à¥à¤¬à¤‚à¤§à¥€ à¤ªà¤¤à¤¾',0),(404488,11236,'ms','Alamat bil penjamin',0),(404489,11236,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„ÙÙˆØªØ±Ø© Ø§Ù„Ø¶Ø§Ù…Ù†',0),(404490,11236,'fr','Adresse de facturation de garant',0),(404491,11236,'jp','é€£å¸¯ä¿è¨¼äººã®è«‹æ±‚å…ˆä½æ‰€',0),(404492,11236,'pt','EndereÃ§o de facturaÃ§Ã£o do fiador',0),(404493,11236,'ru','ÐÐ´Ñ€ÐµÑ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð° Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð°',0),(404494,11236,'es','DirecciÃ³n de FacturaciÃ³n de Fiador',0),(404495,11236,'de','Garant-Rechnungsadresse',0),(404496,11236,'en','Guarantor Billing Address',0),(404497,11237,'is','',0),(404498,11237,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¶Ø§Ù…Ù† ',0),(404499,11237,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¶Ø§Ù…Ù† ',0),(404500,11237,'tr','Bilgileri kefilin',0),(404501,11237,'pl','Gwarant Info',0),(404502,11237,'bg','Ð“Ð°Ñ€Ð°Ð½Ñ‚-Ð¸Ð½Ñ„Ð¾',0),(404503,11237,'ur','Ø¶Ø§Ù…Ù† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(404504,11237,'sr','Ð“Ð°Ñ€Ð°Ð½Ñ‚ Ð˜Ð½Ñ„Ð¾',0),(404505,11237,'vi','thÃ´ng tin báº£o hÃ nh',0),(404506,11237,'af','Borg Info',0),(404507,11237,'ro','Garant Info',0),(404508,11237,'et','KÃ¤endaja Info',0),(404509,11237,'si','Garant Info',0),(404510,11237,'ba','Info penjamin',0),(404511,11237,'nl','Borg Info',0),(404512,11237,'fi','Takaajan tiedot',0),(404513,11237,'no','Garantist Info',0),(404514,11237,'da','Garant Info',0),(404515,11237,'ko','ë³´ì¦ì¸ ì •ë³´',0),(404516,11237,'he','×¢×¨×‘ ×¤×¨×˜×™',0),(404517,11237,'el','Î•Î³Î³Ï…Î·Ï„Î®Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(404518,11237,'zh','æ‹…ä¿äººä¿¡æ¯\r\n',0),(404519,11237,'sv','Garant information',0),(404520,11237,'it','Garante Info',0),(404521,11237,'tl','',0),(404522,11237,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸œà¸¹à¹‰à¸„à¹‰à¸³à¸›à¸£à¸°à¸à¸±à¸™',0),(404523,11237,'hi','à¤—à¤¾à¤°à¤‚à¤Ÿà¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(404524,11237,'ms','Maklumat penjamin',0),(404525,11237,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ÙƒÙÙŠÙ„',0),(404526,11237,'fr','Info garant',0),(404527,11237,'jp','ä¿è¨¼æƒ…å ±',0),(404528,11237,'pt','InformaÃ§Ãµes do fiador',0),(404529,11237,'ru','Ð“Ð°Ñ€Ð°Ð½Ñ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(404530,11237,'es','Info de Fiador',0),(404531,11237,'de','Garant-Info',0),(404532,11237,'en','Guarantor Info',0),(404533,11238,'is','',0),(404534,11238,'dr','(ØªÙÙƒÙŠÙƒ',0),(404535,11238,'pr','ÙØ§ÙƒØªÙˆØ± Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ø®Ø±Ø§Ø¨ÙŠ(ØªÙÙƒÙŠÙƒ',0),(404536,11238,'tr','Fatura masraf daÄŸÄ±lÄ±mÄ±',0),(404537,11238,'pl','PodziaÅ‚ opÅ‚at za faktury',0),(404538,11238,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ‚Ð°ÐºÑÐ¸ Ñ€Ð°Ð·Ð±Ð¸Ð²ÐºÐ°',0),(404539,11238,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚',0),(404540,11238,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ ÑÐ»Ð¾Ð¼',0),(404541,11238,'vi','phÃ­ hÃ³a Ä‘Æ¡n chia',0),(404542,11238,'af','Faktuurkostes Ontleding',0),(404543,11238,'ro','Defalcare de cheltuieli facturÄƒ',0),(404544,11238,'et','Arve makse jaotus',0),(404545,11238,'si','RazÄlenitev stroÅ¡kov raÄun',0),(404546,11238,'ba','Rincian biaya tagihan',0),(404547,11238,'nl','Factuur kosten verdeling',0),(404548,11238,'fi','Laskun kulujen erittely',0),(404549,11238,'no','Faktura kostnader sammenbrudd',0),(404550,11238,'da','Faktura afgifter opdeling',0),(404551,11238,'ko','ì²­êµ¬ì„œ ìš”ê¸ˆ ë‚´ì—­',0),(404552,11238,'he','×¤×™×¨×•×˜ ×—×™×•×‘×™× ×œ×—×©×‘×•× ×™×ª',0),(404553,11238,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„ÎµÎ»ÏŽÎ½ ÎºÎ±Ï„Î±Î½Î¿Î¼Î®',0),(404554,11238,'zh','å‘ç¥¨è´¹ç”¨çš„ç»†ç›®\r\n',0),(404555,11238,'sv','Faktura avgifter uppdelning',0),(404556,11238,'it','Ripartizione spese fattura',0),(404557,11238,'tl','',0),(404558,11238,'th','à¹€à¸ªà¸µà¸¢à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(404559,11238,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤†à¤°à¥‹à¤ª à¤Ÿà¥‚à¤Ÿà¤¨à¥‡',0),(404560,11238,'ms','Pecahan bayaran invois',0),(404561,11238,'ar','ØªÙˆØ²ÙŠØ¹ Ø±Ø³ÙˆÙ… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(404562,11238,'fr','RÃ©partition de Charges de facture',0),(404563,11238,'jp','è«‹æ±‚æ›¸ã®æ–™é‡‘å†…è¨³',0),(404564,11238,'pt','RepartiÃ§Ã£o de encargos de factura',0),(404565,11238,'ru','Ð Ð°Ð·Ð±Ð¸Ð²ÐºÐ° Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð² ÑÑ‡ÐµÑ‚Ð°',0),(404566,11238,'es','Detalle de Cargos de Factura',0),(404567,11238,'de','Rechnung GebÃ¼hren AufschlÃ¼sselung',0),(404568,11238,'en','Invoice Charges Breakdown',0),(404569,11239,'is','',0),(404570,11239,'dr','(Ø¯ÛŒÙˆÙ† ØªØ³ÙˆÙŠÙ‡ Ù†Ø´Ø¯Ù‡',0),(404571,11239,'pr','Ø¹Ø§Ù„ÙŠ(Ø¨Ø¯Ù‡ÙŠ ØªØ³ÙˆÙŠÙ‡ Ù†Ø´Ø¯Ù‡',0),(404572,11239,'tr','ÃœstÃ¼n',0),(404573,11239,'pl','Wybitne',0),(404574,11239,'bg','ÐÐµÐ¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸',0),(404575,11239,'ur','Ø¨Ù‚Ø§ÛŒØ§',0),(404576,11239,'sr','ÐÐµÐ¿Ð»Ð°Ñ›ÐµÐ½Ð¸',0),(404577,11239,'vi','cÃ²n tá»“n táº¡i',0),(404578,11239,'af','Uitstaande',0),(404579,11239,'ro','Restante',0),(404580,11239,'et','Tasumata',0),(404581,11239,'si','Izjemne',0),(404582,11239,'ba','Luar biasa',0),(404583,11239,'nl','Uitstaande',0),(404584,11239,'fi','Erinomainen',0),(404585,11239,'no','EnestÃ¥ende',0),(404586,11239,'da','UdestÃ¥ende',0),(404587,11239,'ko','ë›°ì–´ë‚œ',0),(404588,11239,'he','×™×•×¦× ×ž×Ÿ ×”×›×œ×œ',0),(404589,11239,'el','Î•Î¾Î±Î¹ÏÎµÏ„Î¹ÎºÎ®',0),(404590,11239,'zh','çªå‡º\r\n',0),(404591,11239,'sv','EnastÃ¥ende',0),(404592,11239,'it','Eccezionale',0),(404593,11239,'tl','',0),(404594,11239,'th','à¹‚à¸”à¸”à¹€à¸”à¹ˆà¸™',0),(404595,11239,'hi','à¤¬à¤•à¤¾à¤¯à¤¾',0),(404596,11239,'ms','Cemerlang',0),(404597,11239,'ar','Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(404598,11239,'fr','Exceptionnelle',0),(404599,11239,'jp','å“è¶Šã—ã¾ã—ãŸã€‚',0),(404600,11239,'pt','Pendentes',0),(404601,11239,'ru','Ð’Ñ‹Ð´Ð°ÑŽÑ‰Ð¸ÐµÑÑ',0),(404602,11239,'es','Por Resolver',0),(404603,11239,'de','Herausragende',0),(404604,11239,'en','Outstanding',0),(404605,11240,'is','',0),(404606,11240,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(404607,11240,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ',0),(404608,11240,'tr','Ã–denmiÅŸ miktar',0),(404609,11240,'pl','WypÅ‚acona kwota',0),(404610,11240,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(404611,11240,'ur','ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ Ø±Ù‚Ù…',0),(404612,11240,'sr','ÐŸÐ»Ð°Ñ›ÐµÐ½Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(404613,11240,'vi','Sá»‘ Ä‘Ã£ tráº£',0),(404614,11240,'af','Betaalde Bedrag',0),(404615,11240,'ro','PlÄƒtit suma',0),(404616,11240,'et','Makstud summa',0),(404617,11240,'si','PlaÄani znesek',0),(404618,11240,'ba','Jumlah yang dibayar',0),(404619,11240,'nl','Betaalde bedrag',0),(404620,11240,'fi','Maksettu summa',0),(404621,11240,'no','Betalt belÃ¸p',0),(404622,11240,'da','Betalte belÃ¸b',0),(404623,11240,'ko','ì§€ë¶ˆëœ ê¸ˆì•¡',0),(404624,11240,'he','×¡×›×•× ×©×©×•×œ×',0),(404625,11240,'el','ÎšÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹ Ï€Î¿ÏƒÏŒ',0),(404626,11240,'zh','æ”¯ä»˜çš„é‡‘é¢\r\n',0),(404627,11240,'sv','Betalade beloppet',0),(404628,11240,'it','Importo pagato',0),(404629,11240,'tl','',0),(404630,11240,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸Šà¸³à¸£à¸°',0),(404631,11240,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿',0),(404632,11240,'ms','Jumlah yang dibayar',0),(404633,11240,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(404634,11240,'fr','Montant payÃ©',0),(404635,11240,'jp','æ”¯æ‰•é‡‘é¡',0),(404636,11240,'pt','Valor pago',0),(404637,11240,'ru','ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(404638,11240,'es','Cantidad Pagado',0),(404639,11240,'de','Eingezahlten Betrages',0),(404640,11240,'en','Paid Amount',0),(404641,11241,'is','',0),(404642,11241,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ§ÙƒØªÙˆØ±Ø´Ø¯Ù‡ ',0),(404643,11241,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ§ÙƒØªÙˆØ±Ø´Ø¯Ù‡ ',0),(404644,11241,'tr','Toplam fatura',0),(404645,11241,'pl','Zafakturowane ogÃ³Å‚em',0),(404646,11241,'bg','ÐžÐ±Ñ‰Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¾',0),(404647,11241,'ur','Ú©Ù„ Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯',0),(404648,11241,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð°',0),(404649,11241,'vi','Tá»•ng cá»™ng sá»‘ Ä‘Ã£ láº­p hoÃ¡ Ä‘Æ¡n',0),(404650,11241,'af','Totaal Invoiced',0),(404651,11241,'ro','Total facturat',0),(404652,11241,'et','Kokku arveldatud',0),(404653,11241,'si','Skupno fakturirano',0),(404654,11241,'ba','Total tagihan',0),(404655,11241,'nl','Totaal gefactureerd',0),(404656,11241,'fi','Kokonaislaskutus',0),(404657,11241,'no','Totalt fakturert',0),(404658,11241,'da','Samlet faktureret',0),(404659,11241,'ko','ì´ ì²­êµ¬',0),(404660,11241,'he','×¡×” ×› ×”×•×’×©×” ×—×©×‘×•× ×™×ª',0),(404661,11241,'el','Î£ÏÎ½Î¿Î»Î¿ Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Ï‰Î½',0),(404662,11241,'zh','æ€»è®¡å‘ç¥¨\r\n',0),(404663,11241,'sv','Totalt fakturerade',0),(404664,11241,'it','Totale fatturata',0),(404665,11241,'tl','',0),(404666,11241,'th','à¸¢à¸­à¸”à¸£à¸§à¸¡à¸—à¸µà¹ˆà¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(404667,11241,'hi','à¤•à¥à¤² à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(404668,11241,'ms','Jumlah invois',0),(404669,11241,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(404670,11241,'fr','Total facturÃ©',0),(404671,11241,'jp','åˆè¨ˆè«‹æ±‚',0),(404672,11241,'pt','Total facturado',0),(404673,11241,'ru','Ð’ÑÐµÐ³Ð¾ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚',0),(404674,11241,'es','Total Facturado',0),(404675,11241,'de','Insgesamt in Rechnung gestellt',0),(404676,11241,'en','Total Invoiced',0),(404677,11242,'is','',0),(404678,11242,'dr','( Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ Ùˆ ØªØ®Ù„ÙŠÙ‡) Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ø²Ø¯ÙŠÙƒ',0),(404679,11242,'pr','ÙˆØ±ÙˆØ¯ÙŠ Ù‡Ø§ Ùˆ Ø®Ø±ÙˆØ¬ÙŠ Ù‡Ø§ÙŠ( Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ Ùˆ ØªØ®Ù„ÙŠÙ‡) Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ø²Ø¯ÙŠÙƒ',0),(404680,11242,'tr','YaklaÅŸan hareket-ins ve hareket-baÅŸlangÄ±Ã§',0),(404681,11242,'pl','NadchodzÄ…ce przejÅ›cie ins i ruch out',0),(404682,11242,'bg','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸ Ñ…Ð¾Ð´-ins Ð¸ ÑÐµ Ð¿Ñ€ÐµÐ¼ÐµÑÑ‚Ð¸-Ð°ÑƒÑ‚Ð°',0),(404683,11242,'ur','Ø§Ù†Û’ ÙˆØ§Ù„Û’ Ø§Ù‚Ø¯Ø§Ù… Ø¬Ø§Øª Ø§ÙˆØ± Ø§Ù‚Ø¯Ø§Ù… Ú©ÛŒ Ø§ÙˆÙ¹',0),(404684,11242,'sr','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ Ð¿Ð¾Ñ‚ÐµÐ· Ð´Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¸ Ð¿Ð¾Ñ‚ÐµÐ· Ð·Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð°ÑšÐµ',0),(404685,11242,'vi','Tiá»n ra vÃ  tiá»n vÃ´ sáº¯p tá»›i',0),(404686,11242,'af','Opkomende In Besit neem En Uittrek',0),(404687,11242,'ro','Mutare-uri viitoare ÅŸi Mutare-out',0),(404688,11242,'et','Tulemas liikuda-ins ja liikuda elektrikatkestusi',0),(404689,11242,'si','PrihajajoÄi prehod-ins in premik-outs',0),(404690,11242,'ba','Bergerak-ins mendatang dan bergerak-Out',0),(404691,11242,'nl','Aanstaande verhuizing-ins en beweging-outs',0),(404692,11242,'fi','Tuleva liikkua-jk lÃ¤pikotaisin siirto',0),(404693,11242,'no','Kommende flytte-ins og trekk-ut',0),(404694,11242,'da','Kommende Move-ins og flytte-outs',0),(404695,11242,'ko','ê³§ ì´ë™ ê¸°ëŠ¥ ë° ì´ë™ ì•„ì›ƒ',0),(404696,11242,'he','×”×¢×‘×¨ ×”×§×¨×•×‘-in ×•×ž×”×œ×š-outs',0),(404697,11242,'el','Î•Ï€ÎµÏÏ‡ÏŒÎ¼ÎµÎ½Î· ÎºÎ¯Î½Î·ÏƒÎ·-ins ÎºÎ±Î¹ outs-ÎºÎ¯Î½Î·ÏƒÎ·',0),(404698,11242,'zh','å³å°†æŽ¨å‡ºçš„ç§»å…¥å’Œç§»å‡º\r\n',0),(404699,11242,'sv','Kommande flytta-ins och flytta-outs',0),(404700,11242,'it','Prossima mossa-ins e Move-out',0),(404701,11242,'tl','',0),(404702,11242,'th','à¸à¸³à¸¥à¸±à¸‡à¸ˆà¸°à¸¢à¹‰à¸²à¸¢-ins à¹à¸¥à¸°à¸¢à¹‰à¸²à¸¢à¸¥à¸¶à¸à¸«à¸™à¸²à¸šà¸²à¸‡',0),(404703,11242,'hi','à¤†à¤—à¤¾à¤®à¥€ à¤•à¤¦à¤®-ins à¤”à¤° à¤šà¤¾à¤²-à¤¬à¤¹à¤¿à¤·à¥à¤•à¤¾à¤°',0),(404704,11242,'ms','Akan datang pindah masuk dan pindah-out',0),(404705,11242,'ar','Ø§Ù„Ø®Ø·ÙˆØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ© Ø§Ù„Ù‚Ø§Ø¯Ù…Ø© ÙˆØ§Ù„ØªØ­Ø±Ùƒ-Ø¹Ù…ÙˆÙ…ÙŠØ§Øª',0),(404706,11242,'fr','DÃ©mÃ©nagement Ã  venir-ins et Move-outs',0),(404707,11242,'jp','ä»Šå¾Œç§»å‹•ã‚¤ãƒ³ã‚’ç§»å‹•ã‚¢ã‚¦ãƒˆ',0),(404708,11242,'pt','PrÃ³ximo passo-ins e movimento-outs',0),(404709,11242,'ru','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸Ðµ Move Ð¼Ð¾Ð´ÑƒÐ»Ð¸ Ð¸ Ð´Ð²Ð¸Ð³Ð°Ñ‚ÑŒÑÑ Ð°ÑƒÑ‚Ð¾Ð²',0),(404710,11242,'es','Entradas y Salidas PrÃ³ximas',0),(404711,11242,'de','Bevorstehende Schritt-ins und Move-outs',0),(404712,11242,'en','Upcoming Move-ins And Move-outs',0),(404713,11243,'is','',0),(404714,11243,'dr','ÙÙŠÙ„Ø¯ Ù‡Ø§ ',0),(404715,11243,'pr','ÙÙŠÙ„Ø¯ Ù‡Ø§ ',0),(404716,11243,'tr','AlanlarÄ±',0),(404717,11243,'pl','Pola',0),(404718,11243,'bg','ÐŸÐ¾Ð»ÐµÑ‚Ð°',0),(404719,11243,'ur','Ù‚Ø·Ø¹Ø§Øª',0),(404720,11243,'sr','ÐŸÐ¾Ñ™Ð°',0),(404721,11243,'vi','cÃ¡c trÆ°á»ng',0),(404722,11243,'af','Velde',0),(404723,11243,'ro','CÃ¢mpuri',0),(404724,11243,'et','VÃ¤ljad',0),(404725,11243,'si','Polja',0),(404726,11243,'ba','Bidang',0),(404727,11243,'nl','Velden',0),(404728,11243,'fi','KentÃ¤t',0),(404729,11243,'no','Felt',0),(404730,11243,'da','Felter',0),(404731,11243,'ko','í•„ë“œ',0),(404732,11243,'he','×©×“×•×ª',0),(404733,11243,'el','Î ÎµÎ´Î¯Î±',0),(404734,11243,'zh','å­—æ®µ\r\n',0),(404735,11243,'sv','FÃ¤lt',0),(404736,11243,'it','Campi',0),(404737,11243,'tl','',0),(404738,11243,'th','à¹€à¸‚à¸•à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(404739,11243,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡à¥ à¤¸',0),(404740,11243,'ms','Bidang-bidang',0),(404741,11243,'ar','Ø§Ù„Ø­Ù‚ÙˆÙ„',0),(404742,11243,'fr','Champs',0),(404743,11243,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(404744,11243,'pt','Campos',0),(404745,11243,'ru','ÐŸÐ¾Ð»Ñ',0),(404746,11243,'es','Campos',0),(404747,11243,'de','Felder',0),(404748,11243,'en','Fields',0),(404749,11244,'is','',0),(404750,11244,'dr','Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ Ø¨ÙˆØ¯ ',0),(404751,11244,'pr','Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø§Ø·Ù„ Ø´Ø¯Ù‡ Ø¨ÙˆØ¯ ',0),(404752,11244,'tr','GL kÄ±lÄ±ndÄ±ÄŸÄ±',0),(404753,11244,'pl','GL zostaÅ‚ uniewaÅ¼niony',0),(404754,11244,'bg','GL Ðµ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½',0),(404755,11244,'ur','Ø¬ÛŒØ¬Û’ ÙˆÙˆØ§ÚˆÛŒØ¯ ØªÚ¾Ø§',0),(404756,11244,'sr','Ð“Ð› Ð¿Ð¾Ð½Ð¸ÑˆÑ‚ÐµÐ½',0),(404757,11244,'vi','sá»• cÃ¡i Ä‘Ã£ bá»‹ xÃ³a',0),(404758,11244,'af','GL Was ontlaste',0),(404759,11244,'ro','GL a fost anulat',0),(404760,11244,'et','GL oli kehtetu',0),(404761,11244,'si','GL je razveljavil',0),(404762,11244,'ba','GL ini dibatalkan',0),(404763,11244,'nl','GL Was ongeldig',0),(404764,11244,'fi','GL mitÃ¤tÃ¶innin',0),(404765,11244,'no','GL ble kansellert',0),(404766,11244,'da','GL blev annulleret',0),(404767,11244,'ko','GLì€ ë¬´íš¨ ì²˜ë¦¬',0),(404768,11244,'he','GL ×‘×•×˜×œ',0),(404769,11244,'el','Î‰Ï„Î±Î½ Î¬ÎºÏ…ÏÎ·, GL',0),(404770,11244,'zh','æ€»å¸æ— æ•ˆ\r\n',0),(404771,11244,'sv','GL makulerades',0),(404772,11244,'it','GL Ã¨ stata annullata',0),(404773,11244,'tl','',0),(404774,11244,'th','GL à¸–à¸¹à¸à¸¢à¸à¹€à¸¥à¸´à¸',0),(404775,11244,'hi','à¤œà¥€à¤à¤² Voided à¤¥à¤¾',0),(404776,11244,'ms','GL Voided',0),(404777,11244,'ar','ÙˆÙƒØ§Ù† Ø¥Ù„ØºØ§Ø¡ Ø¬ÙŠ Ø§Ù„',0),(404778,11244,'fr','GL a Ã©tÃ© annulÃ©',0),(404779,11244,'jp','GL ãŒå–ã‚Šé™¤ã‹ã‚Œã¾ã—ãŸã€‚',0),(404780,11244,'pt','GL foi anulada',0),(404781,11244,'ru','GL Ð±Ñ‹Ð» Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½',0),(404782,11244,'es','LM Se AnulÃ³',0),(404783,11244,'de','GL wurde storniert',0),(404784,11244,'en','GL Was Voided',0),(404785,11245,'is','',0),(404786,11245,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª ',0),(404787,11245,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª ',0),(404788,11245,'tr','Emlak vergisi Ã¶denmiÅŸ',0),(404789,11245,'pl','Podatku od nieruchomoÅ›ci',0),(404790,11245,'bg','ÐÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¸ Ð¸Ð¼Ð¾Ñ‚Ð¸ Ð´Ð°Ð½ÑŠÐº, Ð¿Ð»Ð°Ñ‚ÐµÐ½ Ð´Ð°Ð½ÑŠÐº',0),(404791,11245,'ur','Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ù¹ÛŒÚ©Ø³ Ø§Ø¯Ø§ Ú©ÛŒØ§',0),(404792,11245,'sr','ÐŸÐ»Ð°Ñ‚Ð¸Ð¾ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð½ÐµÐ¿Ð¾ÐºÑ€ÐµÑ‚Ð½Ñƒ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ',0),(404793,11245,'vi','Ä‘Ã£ tráº£ thuáº¿ Ä‘áº¥t ',0),(404794,11245,'af','Vaste Eiendom Belasting Betaal',0),(404795,11245,'ro','Real Estate impozitul plÄƒtit',0),(404796,11245,'et','Kinnisvara maksu maksta',0),(404797,11245,'si','PlaÄanega davka na nepremiÄnine',0),(404798,11245,'ba','Real Estate pajak dibayar',0),(404799,11245,'nl','Onroerend goed belasting',0),(404800,11245,'fi','KiinteistÃ¶vero maksetaan',0),(404801,11245,'no','Fast eiendom-skatt betalt',0),(404802,11245,'da','Ejendomsskat betalt',0),(404803,11245,'ko','ë¶€ë™ì‚° ì„¸ê¸ˆ ì§€ë¶ˆ',0),(404804,11245,'he','×ž×™×¡×•×™ ×ž×§×¨×§×¢×™×Ÿ ×©×™×œ×',0),(404805,11245,'el','Î¦ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹',0),(404806,11245,'zh','æˆ¿åœ°äº§ç¨Žæ¬¾\r\n',0),(404807,11245,'sv','Fastighetsskatt som betalas',0),(404808,11245,'it','Immobiliare tassa pagata',0),(404809,11245,'tl','',0),(404810,11245,'th','à¸Šà¸³à¸£à¸°à¸ à¸²à¸©à¸µà¸­à¸ªà¸±à¸‡à¸«à¸²à¸£à¸´à¸¡à¸—à¸£à¸±à¸žà¸¢à¹Œ',0),(404811,11245,'hi','à¤°à¤¿à¤¯à¤² à¤à¤¸à¥à¤Ÿà¥‡à¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(404812,11245,'ms','Cukai hartanah yang dibayar',0),(404813,11245,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ© ØªØ¯ÙØ¹',0),(404814,11245,'fr','ImpÃ´t foncier payÃ©',0),(404815,11245,'jp','ä¸å‹•ç”£ç¨Žã‚’æ”¯æ‰•ã£ãŸ',0),(404816,11245,'pt','ImÃ³veis imposto pago',0),(404817,11245,'ru','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ð» Ð½Ð°Ð»Ð¾Ð³ Ð½Ð° Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(404818,11245,'es','Impuesto Predial Pagado',0),(404819,11245,'de','Immobilien versteuert',0),(404820,11245,'en','Real Estate Tax Paid',0),(404821,11246,'is','',0),(404822,11246,'dr','Ø§Ø¬Ø§Ø±Ù‡ ÙƒØ³Ø¨ Ø´Ø¯Ù‡',0),(404823,11246,'pr','Ø§Ø¬Ø§Ø±Ù‡ ÙƒØ³Ø¨ Ø´Ø¯Ù‡',0),(404824,11246,'tr','KazanÄ±lan kira',0),(404825,11246,'pl','Wynajem zdobyÅ‚',0),(404826,11246,'bg','ÐÐ°ÐµÐ¼ ÑÐ¿ÐµÑ‡ÐµÐ»ÐµÐ½Ð¸',0),(404827,11246,'ur','Ú©Ø±Ø§ÛŒÛ Ú©ÛŒ Ú©Ù…Ø§Ø¦ÛŒ',0),(404828,11246,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ð° Ñ˜Ðµ Ð·Ð°Ñ€Ð°Ð´Ð¸Ð¾',0),(404829,11246,'vi','tiá»n thuÃª kiáº¿m Ä‘Æ°á»£c',0),(404830,11246,'af','Huur verdien',0),(404831,11246,'ro','Chirie cÃ¢ÅŸtigat',0),(404832,11246,'et','Teenitud rent',0),(404833,11246,'si','Najem zasluÅ¾il',0),(404834,11246,'ba','Sewa yang diterima',0),(404835,11246,'nl','Huur verdiend',0),(404836,11246,'fi','Vuokrattavana ansainnut',0),(404837,11246,'no','Leie opptjent',0),(404838,11246,'da','Leje tjent',0),(404839,11246,'ko','ìž„ëŒ€ ì ë¦½',0),(404840,11246,'he','×”×©×›×¨×” ×ž×–×•×›×”',0),(404841,11246,'el','Î•Î½Î¿Î¹ÎºÎ¯Î±ÏƒÎ· ÎºÎµÏÎ´Î¯ÏƒÎµÎ¹',0),(404842,11246,'zh','èµšåˆ°çš„ç§Ÿé‡‘\r\n',0),(404843,11246,'sv','Hyra tjÃ¤nat',0),(404844,11246,'it','Affitto guadagnato',0),(404845,11246,'tl','',0),(404846,11246,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸š',0),(404847,11246,'hi','à¤¬à¤¾à¤‡à¤• à¤•à¤¿à¤°à¤¾à¤ à¤ªà¤° à¤…à¤°à¥à¤œà¤¿à¤¤ à¤•à¤¿à¤¯à¤¾',0),(404848,11246,'ms','Sewa yang diperolehi',0),(404849,11246,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ù…ÙƒØªØ³Ø¨Ø©',0),(404850,11246,'fr','Loyer gagnÃ©',0),(404851,11246,'jp','å®¶è³ƒã‚’ç²å¾—',0),(404852,11246,'pt','Aluguel ganhado',0),(404853,11246,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð»',0),(404854,11246,'es','Renta Ganado',0),(404855,11246,'de','Miete erworben',0),(404856,11246,'en','Rent Earned',0),(404857,11247,'is','',0),(404858,11247,'dr','Ø§Ø¬Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(404859,11247,'pr','Ø§Ø¬Ø§Ø± Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡ ',0),(404860,11247,'tr','AlÄ±nan kira',0),(404861,11247,'pl','Wynajem otrzymaÅ‚',0),(404862,11247,'bg','ÐÐ°ÐµÐ¼ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸',0),(404863,11247,'ur','Ú©Ø±Ø§ÛŒÛ ÙˆØµÙˆÙ„ Ú©ÛŒ',0),(404864,11247,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ð° Ñ˜Ðµ Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾',0),(404865,11247,'vi','nháº­n cho thuÃª',0),(404866,11247,'af','Huur Ontvang',0),(404867,11247,'ro','Chirie primite',0),(404868,11247,'et','Saadud Ã¼Ã¼ri',0),(404869,11247,'si','Najemnina prejeta',0),(404870,11247,'ba','Sewa yang diterima',0),(404871,11247,'nl','Huur ontvangen',0),(404872,11247,'fi','Vuokrattavana sai',0),(404873,11247,'no','Leie mottatt',0),(404874,11247,'da','Leje modtaget',0),(404875,11247,'ko','ìž„ëŒ€ ë°›ì€',0),(404876,11247,'he','×©×›×¨ ×”×“×™×¨×” ×”×ª×§×‘×œ',0),(404877,11247,'el','Î•Î½Î¿Î¯ÎºÎ¹Î¿ Ï€Î¿Ï… Î»Î±Î¼Î²Î¬Î½ÎµÏ„Î±Î¹',0),(404878,11247,'zh','ç§Ÿé‡‘æ”¶åˆ°\r\n',0),(404879,11247,'sv','Hyra fick',0),(404880,11247,'it','Affitto ricevuto',0),(404881,11247,'tl','',0),(404882,11247,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸š',0),(404883,11247,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤¿à¤°à¤¾à¤¯à¤¾',0),(404884,11247,'ms','Sewa diterima',0),(404885,11247,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„ÙˆØ§Ø±Ø¯Ø©',0),(404886,11247,'fr','Loyer perÃ§u',0),(404887,11247,'jp','å®¶è³ƒã‚’å—ã‘å–ã£ãŸ',0),(404888,11247,'pt','Aluguel recebido',0),(404889,11247,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»',0),(404890,11247,'es','Renta Recibida',0),(404891,11247,'de','Miete empfangen',0),(404892,11247,'en','Rent Received',0),(404893,11248,'is','',0),(404894,11248,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù†Ø§Ù…Ù‡  Ø§Ø² ØªØ§Ø±ÙŠØ®',0),(404895,11248,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù†Ø§Ù…Ù‡  Ø§Ø² ØªØ§Ø±ÙŠØ®',0),(404896,11248,'tr','Kira rulo olarak',0),(404897,11248,'pl','Wynajem buÅ‚ka z',0),(404898,11248,'bg','ÐÐ°ÐµÐ¼ Ð¿Ð¾Ð¸Ð¼ÐµÐ½Ð½Ð¾ ÐºÐ°Ñ‚Ð¾ Ð¾Ñ‚',0),(404899,11248,'ur','Ú©Ø±Ø§Ø¦Û’ Ú©Û’ Ø±ÙˆÙ„ Ú©Û’ Ø·ÙˆØ± Ù¾Ø±',0),(404900,11248,'sr','ÐÐ°Ñ˜Ð°Ð¼ Ñ€Ð¾Ð»Ð½Ñƒ ÐºÐ°Ð¾',0),(404901,11248,'vi','danh sÃ¡ch thuÃª cá»§a',0),(404902,11248,'af','Huur rol As',0),(404903,11248,'ro','Chirie rola ca de',0),(404904,11248,'et','ÃœÃ¼ri rulli nagu',0),(404905,11248,'si','Najem Roll kot',0),(404906,11248,'ba','Roll Disewa sebagai dari',0),(404907,11248,'nl','Huur Roll als van',0),(404908,11248,'fi','Vuokrattavana rulla kuin',0),(404909,11248,'no','Leie Roll som',0),(404910,11248,'da','Leje rulle som',0),(404911,11248,'ko','ì§‘ ì„¸ ë¡¤ìœ¼ë¡œ',0),(404912,11248,'he','×’×œ×™×œ ×©×›×¨ ×›×ž×• ×©×œ',0),(404913,11248,'el','Î•Î½Î¿Î¹ÎºÎ¯Î±ÏƒÎ· ÏÎ¿Î»ÏŒ Ï‰Ï‚',0),(404914,11248,'zh','åœ°ç§Ÿç™»è®°å†Œä½œä¸º\r\n',0),(404915,11248,'sv','Hyra rulle som',0),(404916,11248,'it','Rotolo in affitto come di',0),(404917,11248,'tl','',0),(404918,11248,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²à¸¡à¹‰à¸§à¸™à¹€à¸›à¹‡à¸™',0),(404919,11248,'hi','à¤¬à¤¾à¤‡à¤• à¤•à¤¿à¤°à¤¾à¤ à¤•à¥‡ à¤°à¥‹à¤² à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚',0),(404920,11248,'ms','Sewa Roll sebagai',0),(404921,11248,'ar','Ù„ÙØ© Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± ÙƒÙ…Ù†',0),(404922,11248,'fr','Location rouleau comme de',0),(404923,11248,'jp','è³ƒè²¸ãƒ­ãƒ¼ãƒ«',0),(404924,11248,'pt','Rolo de aluguel a partir de',0),(404925,11248,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ñ€Ð¾Ð»Ð» Ð¿Ð¾ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸ÑŽ Ð½Ð°',0),(404926,11248,'es','Lista de Rentas A Partir De',0),(404927,11248,'de','Miete Rolle als',0),(404928,11248,'en','Rent Roll As Of',0),(404929,11249,'is','',0),(404930,11249,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ù„ÛŒØ¬Ø± ',0),(404931,11249,'pr','Ø­Ø³Ø§Ø¨ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ) Ø¯ÙØªØ± ÙƒÙ„ ',0),(404932,11249,'tr','Mevduat GL hesabÄ±',0),(404933,11249,'pl','WpÅ‚acie na konto: GL',0),(404934,11249,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(404935,11249,'ur','Ø¬Ù…Ø¹ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(404936,11249,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð“Ð›',0),(404937,11249,'vi','TÃ i khoáº£n sá»• cÃ¡i tiá»n gá»­i',0),(404938,11249,'af','Deposito AG Rekening',0),(404939,11249,'ro','Cont de depozit la GL',0),(404940,11249,'et','GL jooksevkonto',0),(404941,11249,'si','Depozitni raÄun GL',0),(404942,11249,'ba','Rekening deposito GL',0),(404943,11249,'nl','Depositorekening GL',0),(404944,11249,'fi','GL talletustili',0),(404945,11249,'no','GL depositumskonto',0),(404946,11249,'da','GL indlÃ¥nskonto',0),(404947,11249,'ko','ë³´ì¦ê¸ˆ GL ê³„ì •',0),(404948,11249,'he','××ª ×”×—×©×‘×•×Ÿ GL',0),(404949,11249,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(404950,11249,'zh','æ€»å¸å¸æˆ·å­˜æ¬¾\r\n',0),(404951,11249,'sv','GL konto',0),(404952,11249,'it','Conto di deposito GL',0),(404953,11249,'tl','',0),(404954,11249,'th','à¸à¸²à¸à¹€à¸‡à¸´à¸™à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(404955,11249,'hi','à¤œà¤®à¤¾ GL à¤–à¤¾à¤¤à¥‡',0),(404956,11249,'ms','Akaun Deposit GL',0),(404957,11249,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹Ø§Øª Ù„Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(404958,11249,'fr','Compte de dÃ©pÃ´t GL',0),(404959,11249,'jp','GL ã®é é‡‘å£åº§',0),(404960,11249,'pt','DepÃ³sito em conta de GL',0),(404961,11249,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐŸÑ€Ð¾Ñ„Ð¸Ð»Ñ Ð“Ðš',0),(404962,11249,'es','Cuenta LM de DepÃ³sito',0),(404963,11249,'de','GL-Guthabenkonto',0),(404964,11249,'en','Deposit GL Account',0),(404965,11250,'is','',0),(404966,11250,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø´Ø¯Ù‡  ',0),(404967,11250,'pr','Ø³Ù†Ø¯ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÙŠ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª )  Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø´Ø¯Ù‡  ',0),(404968,11250,'tr','Teminat Ã§eki muhafaza',0),(404969,11250,'pl','Depozyt zachowane Voucher',0),(404970,11250,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð·Ð°Ð¿Ð°Ð·Ð²Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(404971,11250,'ur','ÙˆØ§Ø¤Ú†Ø± ÚˆÙ¾Ø§Ø²Ù¹ Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾ÛŒ',0),(404972,11250,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð·Ð°Ð´Ñ€Ð¶Ð°Ð²Ð°Ñ˜Ñƒ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(404973,11250,'vi','Phiáº¿u giá»¯ láº¡i tiá»n Ä‘áº·t cá»c',0),(404974,11250,'af','Deposito behou bewys',0),(404975,11250,'ro','Depozit pÄƒstrat Voucher',0),(404976,11250,'et','Tagatisraha jÃ¤Ã¤b kande',0),(404977,11250,'si','Depozit zadrÅ¾i kupon',0),(404978,11250,'ba','Deposit dipertahankan Voucher',0),(404979,11250,'nl','Storten van ingehouden Voucher',0),(404980,11250,'fi','Talletus sÃ¤ilyttÃ¤Ã¤ tosite',0),(404981,11250,'no','Innskudd beholdt bilag',0),(404982,11250,'da','Depositum beholdes Voucher',0),(404983,11250,'ko','ì˜ˆê¸ˆ ì¦ì„œë¥¼ ìœ ì§€',0),(404984,11250,'he','×”×¤×§×“×ª ×™×ª×¨×ª ×”×©×•×‘×¨',0),(404985,11250,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î´Î¹Î±Ï„Î·ÏÎ¿ÏÎ½Ï„Î±Î¹ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(404986,11250,'zh','å­˜æ¬¾ç•™æ”¯ä»˜å‡­è¯\r\n',0),(404987,11250,'sv','InsÃ¤ttning behÃ¶ll kupongen',0),(404988,11250,'it','Acconto trattenuto Voucher',0),(404989,11250,'tl','',0),(404990,11250,'th','à¸à¸²à¸à¹€à¸à¹‡à¸šà¸£à¸±à¸à¸©à¸²à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸',0),(404991,11250,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤œà¤®à¤¾ à¤¬à¤°à¤•à¤°à¤¾à¤° à¤°à¤–à¤¾',0),(404992,11250,'ms','Deposit terkumpul baucer',0),(404993,11250,'ar','Ø§Ù„Ø§Ø­ØªÙØ§Ø¸ Ø¨Ù‚Ø³ÙŠÙ…Ø© Ø¥ÙŠØ¯Ø§Ø¹',0),(404994,11250,'fr','DÃ©pÃ´t conservÃ© bon',0),(404995,11250,'jp','é é‡‘ä¼ç¥¨ã‚’ä¿æŒ',0),(404996,11250,'pt','DepÃ³sito retido Voucher',0),(404997,11250,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÐ¾Ñ…Ñ€Ð°Ð½ÑÐµÑ‚ÑÑ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(404998,11250,'es','Voucher Retenido de DepÃ³sito',0),(404999,11250,'de','Einzahlung erhalten Gutschein',0),(405000,11250,'en','Deposit Retained Voucher',0),(405001,11251,'is','',0),(405002,11251,'dr','( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(405003,11251,'pr','ÙØ§ÙƒØªÙˆØ± Ø¨Ø±Ú¯Ø´ØªÙŠ Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(405004,11251,'tr','Depozito iade faturasÄ±',0),(405005,11251,'pl','Depozyt zwracany faktury',0),(405006,11251,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚, Ð²Ñ€ÑŠÑ‰Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(405007,11251,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ ÚˆÙ¾ÙˆØ²Ù¹ ÙˆØ§Ù¾Ø³ ÛÙˆÚ¯ÛŒ Û”',0),(405008,11251,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ˜Ðµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(405009,11251,'vi','HÃ³a Ä‘Æ¡n tráº£ láº¡i tiá»n Ä‘áº·t cá»c',0),(405010,11251,'af','Deposito teruggekeer faktuur',0),(405011,11251,'ro','Depozit a revenit facturÄƒ',0),(405012,11251,'et','Tagatisraha tagastatakse arve',0),(405013,11251,'si','Depozit vrne raÄuna',0),(405014,11251,'ba','Deposit kembali faktur',0),(405015,11251,'nl','Borg terug factuur',0),(405016,11251,'fi','Maksu palautetaan laskun',0),(405017,11251,'no','Innskuddet tilbake faktura',0),(405018,11251,'da','Depositum returneres faktura',0),(405019,11251,'ko','ë³´ì¦ê¸ˆ ë°˜í™˜ ì²­êµ¬ì„œ',0),(405020,11251,'he','×¤×™×§×“×•×Ÿ ×”×ž×•×—×–×¨ ×—×©×‘×•× ×™×ª',0),(405021,11251,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(405022,11251,'zh','å­˜æ¬¾é€€å›žå‘ç¥¨\r\n',0),(405023,11251,'sv','Depositionen tillbaka fakturan',0),(405024,11251,'it','Deposito restituito fattura',0),(405025,11251,'tl','',0),(405026,11251,'th','à¸à¸²à¸à¸ªà¹ˆà¸‡à¸„à¸·à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(405027,11251,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤œà¤®à¤¾ à¤²à¥Œà¤Ÿà¥‡',0),(405028,11251,'ms','Deposit yang dikembalikan invois',0),(405029,11251,'ar','Ø¹Ø§Ø¯ Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(405030,11251,'fr','Caution restituÃ©e facture',0),(405031,11251,'jp','ãƒ‡ãƒã‚¸ãƒƒãƒˆã®è¿”é‡‘è«‹æ±‚',0),(405032,11251,'pt','DepÃ³sito devolvido na factura',0),(405033,11251,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÑ‚ÑÑ ÑÑ‡ÐµÑ‚Ð°',0),(405034,11251,'es','Factura de DevoluciÃ³n de DepÃ³sito',0),(405035,11251,'de','Kaution zurÃ¼ck Rechnung',0),(405036,11251,'en','Deposit Returned Invoice',0),(405037,11252,'is','',0),(405038,11252,'dr','Pet Deposit Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø´Ø¯Ù‡ ',0),(405039,11252,'pr','Pet Deposit Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø´Ø¯Ù‡ ',0),(405040,11252,'tr','Evde beslenen hayvan mevduat muhafaza',0),(405041,11252,'pl','PieÅ›ciÄ‡ depozytu zachowane',0),(405042,11252,'bg','Ð”Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð»ÑŽÐ±Ð¸Ð¼Ñ†Ð¸ Ð·Ð°Ð´Ð°Ñ‚ÑŠÐº',0),(405043,11252,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± Ø¬Ù…Ø¹ Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾ÛŒ',0),(405044,11252,'sr','Ð‰ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð·Ð°Ð´Ñ€Ð¶Ð°Ð²Ð°Ñ˜Ñƒ',0),(405045,11252,'vi','giá»¯ láº¡i tiá»n gá»­i Ä‘áº·c biá»‡t',0),(405046,11252,'af','Troeteldier deposito behou',0),(405047,11252,'ro','Animal de casÄƒ depozit reÅ£inute',0),(405048,11252,'et','Lemmikloomade kÃ¤siraha',0),(405049,11252,'si','Jjeza obdrÅ¾ane',0),(405050,11252,'ba','Hewan peliharaan Deposit yang dipertahankan',0),(405051,11252,'nl','Huisdier storting behouden',0),(405052,11252,'fi','HellitellÃ¤ kÃ¤sirahan',0),(405053,11252,'no','Pet innskudd beholdt',0),(405054,11252,'da','KÃ¦ledyr depositum beholdes',0),(405055,11252,'ko','ìœ ì§€ ì• ì™„ ë™ë¬¼ ë³´ì¦ê¸ˆ',0),(405056,11252,'he','×¤×™×§×“×•×Ÿ ×ž×—×ž×“ × ×©×ž×¨',0),(405057,11252,'el','ÎšÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½ Ï€Î¿Ï… Î´Î¹Î±Ï„Î·ÏÎ¿ÏÎ½Ï„Î±Î¹',0),(405058,11252,'zh','å® ç‰©å­˜æ¬¾ä¿ç•™\r\n',0),(405059,11252,'sv','PET insÃ¤ttning behÃ¶ll',0),(405060,11252,'it','Deposito domestico mantenuto',0),(405061,11252,'tl','',0),(405062,11252,'th','à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡à¸à¸²à¸à¸£à¸±à¸à¸©à¸²',0),(405063,11252,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤œà¤®à¤¾ à¤¬à¤°à¤•à¤°à¤¾à¤° à¤°à¤–à¤¾',0),(405064,11252,'ms','Haiwan peliharaan Deposit yang disimpan',0),(405065,11252,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø§Ù„Ø§Ø­ØªÙØ§Ø¸',0),(405066,11252,'fr','Pour animaux de compagnie dÃ©pÃ´t conservÃ©',0),(405067,11252,'jp','ãƒšãƒƒãƒˆ ãƒ‡ãƒã‚¸ãƒƒãƒˆã‚’ä¿æŒ',0),(405068,11252,'pt','DepÃ³sito de animais mantido',0),(405069,11252,'ru','Pet Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° ÑÐ¾Ñ…Ñ€Ð°Ð½ÑÐµÑ‚ÑÑ',0),(405070,11252,'es','DepÃ³sito de Mascota Retenido',0),(405071,11252,'de','Haustier Kaution behalten',0),(405072,11252,'en','Pet Deposit Retained',0),(405073,11253,'is','',0),(405074,11253,'dr','Pet Deposit Ø¨Ø§Ø²Ú¯Ø´ØªÙŠ ',0),(405075,11253,'pr','Pet Deposit Ø¨Ø§Ø²Ú¯Ø´ØªÙŠ ',0),(405076,11253,'tr','Evde beslenen hayvan depozito iade',0),(405077,11253,'pl','PieÅ›ciÄ‡ depozyt zwracany',0),(405078,11253,'bg','Ð“Ð°Ð»ÐµÐ½Ð¸Ðº Ð²Ð»Ð¾Ð³ Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸',0),(405079,11253,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± ÚˆÙ¾Ø§Ø²Ù¹ ÙˆØ§Ù¾Ø³',0),(405080,11253,'sr','Ð‰ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾',0),(405081,11253,'vi','tráº£ láº¡i tiá»n gá»­i Ä‘áº·c biá»‡t',0),(405082,11253,'af','Troeteldier deposito teruggekeer',0),(405083,11253,'ro','Animal de casÄƒ depozit s-a Ã®ntors',0),(405084,11253,'et','Lemmikloomade tagastatud deposiit',0),(405085,11253,'si','HiÅ¡nih depozita vrnili',0),(405086,11253,'ba','Hewan peliharaan Deposit kembali',0),(405087,11253,'nl','Huisdier borg terug',0),(405088,11253,'fi','LemmikkielÃ¤inten talletus palautetaan',0),(405089,11253,'no','Pet innskuddet tilbake',0),(405090,11253,'da','KÃ¦ledyr depositum tilbage',0),(405091,11253,'ko','ì• ì™„ ë™ë¬¼ ë³´ì¦ê¸ˆ ë°˜í™˜',0),(405092,11253,'he','×ž×—×ž×“ ×¤×™×§×“×•×Ÿ ×”×ž×•×—×–×¨',0),(405093,11253,'el','ÎšÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½ Ï€Î¿Ï… ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ',0),(405094,11253,'zh','å® ç‰©å­˜æ¬¾è¿”å›ž\r\n',0),(405095,11253,'sv','PET insÃ¤ttning tillbaka',0),(405096,11253,'it','Deposito domestico restituito',0),(405097,11253,'tl','',0),(405098,11253,'th','à¸à¸²à¸à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¸„à¸·à¸™',0),(405099,11253,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤œà¤®à¤¾ à¤²à¥Œà¤Ÿà¥‡',0),(405100,11253,'ms','Haiwan peliharaan Deposit yang dikembalikan',0),(405101,11253,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø¹Ø§Ø¯',0),(405102,11253,'fr','Pour animaux de compagnie dÃ©pÃ´t retournÃ©',0),(405103,11253,'jp','è¿”ã•ã‚Œã‚‹ãƒšãƒƒãƒˆã®é ã‹ã‚Š',0),(405104,11253,'pt','DepÃ³sito de estimaÃ§Ã£o retornado',0),(405105,11253,'ru','Pet Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÑ‚ÑÑ',0),(405106,11253,'es','DepÃ³sito de Mascota Devuelto',0),(405107,11253,'de','Haustier Einzahlung zurÃ¼ckgegeben',0),(405108,11253,'en','Pet Deposit Returned',0),(405109,11254,'is','',0),(405110,11254,'dr','Ø§ØµÙ„Ø§Ø­ Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø±',0),(405111,11254,'pr','Ø§ØµÙ„Ø§Ø­ Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø±',0),(405112,11254,'tr','GÃ¼venlik Mevduat mutabakatlarÄ±',0),(405113,11254,'pl','BezpieczeÅ„stwa depozytÃ³w uzgodnienia',0),(405114,11254,'bg','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÑŠÐ¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(405115,11254,'ur','Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ ÚˆÙ¾Ø§Ø²Ù¹ Ú©Û’ Ø±ÛŒÚ©ÙˆÙ†Ú©Ø§Ù„ÛŒØ§Ù¹Ø§Ù†Ø³',0),(405116,11254,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¿Ð¾Ð¼Ð¸Ñ€ÐµÑšÐ°',0),(405117,11254,'vi','Äá»‘i chiáº¿u tiá»n cá»c an ninh',0),(405118,11254,'af','Sekuriteit deposito Reconciliations',0),(405119,11254,'ro','Reconcilieri de depozit de securitate',0),(405120,11254,'et','Turvalisus hoiuste vÃµrdlevalt',0),(405121,11254,'si','Security depozit uskladitve',0),(405122,11254,'ba','Security Deposit rekonsiliasi',0),(405123,11254,'nl','Security Deposit aansluitingen',0),(405124,11254,'fi','Turvallisuus talletus tÃ¤smÃ¤ytykset',0),(405125,11254,'no','Sikkerhet innskudd avstemminger',0),(405126,11254,'da','Sikkerhed depositum afstemninger',0),(405127,11254,'ko','ë³´ì•ˆ ë³´ì¦ê¸ˆ ì¡°ì •',0),(405128,11254,'he','×”×ª××ž×•×ª ×¤×™×§×“×•×Ÿ ×”××‘×˜×—×”',0),(405129,11254,'el','Î‘ÏƒÏ†Î¬Î»ÎµÎ¹Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÏ…Î¼Ï†Î¹Î»Î¹ÏŽÏƒÎµÎ¹Ï‚',0),(405130,11254,'zh','ä¿è¯é‡‘å¯¹è´¦\r\n',0),(405131,11254,'sv','SÃ¤kerhet deposition avstÃ¤mningar',0),(405132,11254,'it','Sicurezza deposito riconciliazioni',0),(405133,11254,'tl','',0),(405134,11254,'th','à¸à¸£à¸°à¸—à¸šà¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸„à¸§à¸²à¸¡à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢',0),(405135,11254,'hi','à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤œà¤®à¤¾ Reconciliations',0),(405136,11254,'ms','Penyesuaian Deposit sekuriti',0),(405137,11254,'ar','Ø§Ù„Ø£Ù…Ù† Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„ØªØ³ÙˆÙŠØ§Øª',0),(405138,11254,'fr','Rapprochements de dÃ©pÃ´t de sÃ©curitÃ©',0),(405139,11254,'jp','ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£ ãƒ‡ãƒã‚¸ãƒƒãƒˆèª¿æ•´',0),(405140,11254,'pt','ReconciliaÃ§Ãµes de depÃ³sito de seguranÃ§a',0),(405141,11254,'ru','Ð’Ñ‹Ð²ÐµÑ€ÐºÐ¸ Ð±ÐµÐ·Ð¾Ð¿Ð°ÑÐ½Ð¾ÑÑ‚Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(405142,11254,'es','Reconciliaciones de DepÃ³sito de Seguridad',0),(405143,11254,'de','Security Deposit Abstimmungen',0),(405144,11254,'en','Security Deposit Reconciliations',0),(405145,11255,'is','',0),(405146,11255,'dr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø±',0),(405147,11255,'pr','Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø±',0),(405148,11255,'tr','GÃ¼venlik depozitosu muhafaza',0),(405149,11255,'pl','Depozyt zabezpieczajÄ…cy zachowane',0),(405150,11255,'bg','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚ Ð·Ð°Ð´Ð°Ñ‚ÑŠÐº',0),(405151,11255,'ur','Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ ÚˆÙ¾Ø§Ø²Ù¹ Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾ÛŒ',0),(405152,11255,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð·Ð°Ð´Ñ€Ð¶Ð°Ð²Ð°Ñ˜Ñƒ',0),(405153,11255,'vi','Tiá»n cá»c an ninh giá»¯ láº¡i',0),(405154,11255,'af','Sekuriteit deposito behou',0),(405155,11255,'ro','Depozit de securitate reÅ£inute',0),(405156,11255,'et','Turvalisuse kÃ¤siraha',0),(405157,11255,'si','Varnost obdrÅ¾ane',0),(405158,11255,'ba','Uang jaminan yang dipertahankan',0),(405159,11255,'nl','Borg behouden',0),(405160,11255,'fi','Turvallisuus kÃ¤sirahan',0),(405161,11255,'no','Depositum beholdt',0),(405162,11255,'da','Sikkerhedsdepositum beholdes',0),(405163,11255,'ko','ë³´ì¦ê¸ˆ ìœ ì§€',0),(405164,11255,'he','×¤×™×§×“×•×Ÿ × ×©×ž×¨',0),(405165,11255,'el','Î ÏÎ¿ÎºÎ±Ï„Î±Î²Î¿Î»Î® Ï€Î¿Ï… Î´Î¹Î±Ï„Î·ÏÎ¿ÏÎ½Ï„Î±Î¹',0),(405166,11255,'zh','ä¿è¯é‡‘ä¿ç•™\r\n',0),(405167,11255,'sv','Deposition behÃ¶ll',0),(405168,11255,'it','Deposito cauzionale trattenuto',0),(405169,11255,'tl','',0),(405170,11255,'th','à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸„à¸§à¸²à¸¡à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¹„à¸§à¹‰',0),(405171,11255,'hi','à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤œà¤®à¤¾ à¤¬à¤°à¤•à¤°à¤¾à¤° à¤°à¤–à¤¾',0),(405172,11255,'ms','Deposit sekuriti yang dikekalkan',0),(405173,11255,'ar','ÙˆØ¯ÙŠØ¹Ø© Ø¶Ù…Ø§Ù† Ø§Ù„Ø¥Ø¨Ù‚Ø§Ø¡ Ø¹Ù„Ù‰',0),(405174,11255,'fr','DÃ©pÃ´t de garantie conservÃ©',0),(405175,11255,'jp','ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£ ãƒ» ãƒ‡ãƒã‚¸ãƒƒãƒˆã‚’ä¿æŒ',0),(405176,11255,'pt','DepÃ³sito de seguranÃ§a mantido',0),(405177,11255,'ru','Ð—Ð°Ð»Ð¾Ð³ ÑÐ¾Ñ…Ñ€Ð°Ð½ÑÐµÑ‚ÑÑ',0),(405178,11255,'es','DepÃ³sito de Seguridad Retenido',0),(405179,11255,'de','Kaution beibehalten',0),(405180,11255,'en','Security Deposit Retained',0),(405181,11256,'is','',0),(405182,11256,'dr','Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø± Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(405183,11256,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ø§ÙˆØ±Ø§Ù‚ Ø¨Ù‡Ø§Ø¯Ø§Ø± Ø¨Ø±Ú¯Ø´ØªÙŠ',0),(405184,11256,'tr','GÃ¼venlik depozitosu iade',0),(405185,11256,'pl','Depozyt zwracany',0),(405186,11256,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚-Ð³Ð°Ñ€Ð°Ð½Ñ†Ð¸Ñ Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸',0),(405187,11256,'ur','ÙˆØ§Ù¾Ø³ÛŒ Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ ÚˆÙ¾Ø§Ø²Ù¹',0),(405188,11256,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¾ÑÐ½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ˜Ðµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾',0),(405189,11256,'vi','Tiá»n cá»c an ninh hoÃ n tráº£',0),(405190,11256,'af','Sekuriteit deposito teruggekeer',0),(405191,11256,'ro','Depozit de securitate s-a Ã®ntors',0),(405192,11256,'et','Tagatisraha tagastatakse',0),(405193,11256,'si','Security depozit vrne',0),(405194,11256,'ba','Uang jaminan kembali',0),(405195,11256,'nl','Borg terug',0),(405196,11256,'fi','Takuumaksu palautetaan',0),(405197,11256,'no','Depositum tilbake',0),(405198,11256,'da','Depositum returneres',0),(405199,11256,'ko','ë³´ì¦ê¸ˆ ë°˜í™˜',0),(405200,11256,'he','×¤×™×§×“×•×Ÿ ×”×ž×•×—×–×¨',0),(405201,11256,'el','Î ÏÎ¿ÎºÎ±Ï„Î±Î²Î¿Î»Î® ÎµÏ€Î¹ÏƒÏ„ÏÎ­Ï†ÎµÏ„Î±Î¹',0),(405202,11256,'zh','é€€å›žä¿è¯é‡‘\r\n',0),(405203,11256,'sv','Deposition tillbaka',0),(405204,11256,'it','Deposito cauzionale restituito',0),(405205,11256,'tl','',0),(405206,11256,'th','à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸„à¸§à¸²à¸¡à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢à¸à¸¥à¸±à¸šà¸¡à¸²',0),(405207,11256,'hi','à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤œà¤®à¤¾ à¤°à¤¾à¤¶à¤¿ à¤²à¥Œà¤Ÿà¤¾',0),(405208,11256,'ms','Deposit jaminan, dipulangkan',0),(405209,11256,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø£Ù…Ù† Ø¹Ø§Ø¯',0),(405210,11256,'fr','DÃ©pÃ´t de garantie retournÃ©',0),(405211,11256,'jp','è¿”ã•ã‚ŒãŸã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£é é‡‘',0),(405212,11256,'pt','DepÃ³sito de seguranÃ§a retornado',0),(405213,11256,'ru','Ð—Ð°Ð»Ð¾Ð³ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÑ‚ÑÑ',0),(405214,11256,'es','DepÃ³sito de Seguridad Devuelto',0),(405215,11256,'de','Kaution zurÃ¼ckgegeben',0),(405216,11256,'en','Security Deposit Returned',0),(405217,11257,'is','',0),(405218,11257,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯',0),(405219,11257,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯',0),(405220,11257,'tr','Mevcut kira',0),(405221,11257,'pl','Leasing dostÄ™pne',0),(405222,11257,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(405223,11257,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ Ù„ÙÛŒØ²Ø²',0),(405224,11257,'sr','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ð¿Ð¾Ñ™Ð°',0),(405225,11257,'vi','THuÃª tÃ i sáº£n sáºµn cÃ³',0),(405226,11257,'af','Beskikbare Huurkontrak',0),(405227,11257,'ro','Contractele de Ã®nchiriere disponibile',0),(405228,11257,'et','Saadaval rent',0),(405229,11257,'si','Na voljo najemi',0),(405230,11257,'ba','Tersedia sewa',0),(405231,11257,'nl','Beschikbare Leases',0),(405232,11257,'fi','Saatavilla vuokrasopimukset',0),(405233,11257,'no','Tilgjengelige leieavtaler',0),(405234,11257,'da','Ledige lejemÃ¥l',0),(405235,11257,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” ìž„ëŒ€',0),(405236,11257,'he','×—×›×™×¨×” ×–×ž×™×Ÿ',0),(405237,11257,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(405238,11257,'zh','å¯ä¾›ç§Ÿèµ\r\n',0),(405239,11257,'sv','TillgÃ¤ngliga lÃ¥n',0),(405240,11257,'it','Locazioni disponibili',0),(405241,11257,'tl','',0),(405242,11257,'th','à¹€à¸Šà¹ˆà¸²à¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(405243,11257,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚',0),(405244,11257,'ms','Pajakan yang disediakan',0),(405245,11257,'ar','ØªØ£Ø¬ÙŠØ±Ø§Øª Ù…ØªÙˆÙØ±Ø©',0),(405246,11257,'fr','Baux disponibles',0),(405247,11257,'jp','ä½¿ç”¨å¯èƒ½ãªãƒªãƒ¼ã‚¹',0),(405248,11257,'pt','LocaÃ§Ãµes disponÃ­veis',0),(405249,11257,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ð°Ñ€ÐµÐ½Ð´Ð°',0),(405250,11257,'es','Arendamientos Disponibles',0),(405251,11257,'de','VerfÃ¼gbaren Leases',0),(405252,11257,'en','Available Leases',0),(405253,11258,'is','',0),(405254,11258,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(405255,11258,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(405256,11258,'tr','Kiralanan deÄŸil',0),(405257,11258,'pl','Nie Å‚Ä…czy dzierÅ¼awionych',0),(405258,11258,'bg','ÐÐµ Ð½Ð°ÐµÑ‚Ð¸',0),(405259,11258,'ur','Ù†Û Ù¾Ù¹ÛŒ Ù¾Ø± Ø¯ÛŒ Ú¯Ø¦ÛŒ',0),(405260,11258,'sr','ÐÐ¸ÑÐ°Ð¼ Ð¸Ð·Ð½Ð°Ñ˜Ð¼Ð¸Ð¾',0),(405261,11258,'vi','khÃ´ng Ä‘Æ°á»£c thuÃª',0),(405262,11258,'af','Nie Verhuur nie.',0),(405263,11258,'ro','Nu Ã®nchiriate',0),(405264,11258,'et','Mitte renditud',0),(405265,11258,'si','Ni zakupljenih',0),(405266,11258,'ba','Tidak disewakan',0),(405267,11258,'nl','Niet verhuurd',0),(405268,11258,'fi','Ei vuokrattu',0),(405269,11258,'no','Ikke tillatt',0),(405270,11258,'da','Ikke udlejet',0),(405271,11258,'ko','ì•„ë‹ˆ ìž„ëŒ€',0),(405272,11258,'he','×œ× ×ž×•×©×›×¨',0),(405273,11258,'el','Î”ÎµÎ½ Î¼Î¹ÏƒÎ¸Ï‰Î¼Î­Î½Ï‰Î½',0),(405274,11258,'zh','ä¸å‡ºç§Ÿ',0),(405275,11258,'sv','Inte hyrda',0),(405276,11258,'it','Non affittate',0),(405277,11258,'tl','',0),(405278,11258,'th','à¹„à¸¡à¹ˆà¹€à¸Šà¹ˆà¸²',0),(405279,11258,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤° à¤¨à¤¹à¥€à¤‚',0),(405280,11258,'ms','Tidak dipajak',0),(405281,11258,'ar','Ù„Ø§ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±Ø©',0),(405282,11258,'fr','Pas louÃ©',0),(405283,11258,'jp','ãƒªãƒ¼ã‚¹ã„ã¾ã›ã‚“ã€‚',0),(405284,11258,'pt','NÃ£o alugadas',0),(405285,11258,'ru','ÐÐµ Ð² Ð°Ñ€ÐµÐ½Ð´Ñƒ',0),(405286,11258,'es','No Arrendado',0),(405287,11258,'de','Nicht geleast',0),(405288,11258,'en','Not Leased',0),(405289,11259,'is','',0),(405290,11259,'dr','Ø¯Ø±ØµØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(405291,11259,'pr','Ø¯Ø±ØµØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(405292,11259,'tr','DeÄŸil kiralanan yÃ¼zdesi',0),(405293,11259,'pl','Procent nie Å‚Ä…czy dzierÅ¼awionych',0),(405294,11259,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð½Ðµ Ð½Ð°ÐµÑ‚Ð¸',0),(405295,11259,'ur','Ø´Ø±Ø­ ÙÛŒ ØµØ¯ Ù†Û Ù¾Ù¹ÛŒ Ù¾Ø± Ø¯ÛŒ Ú¯Ø¦ÛŒ',0),(405296,11259,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð½Ð¸Ñ˜Ðµ Ð¸Ð·Ð´Ð°Ñ‚',0),(405297,11259,'vi','pháº§n trÄƒm khÃ´ng Ä‘Æ°á»£c thuÃª',0),(405298,11259,'af','Persentasie Nie Verhuur',0),(405299,11259,'ro','Procent nu Ã®nchiriate',0),(405300,11259,'et','ProtsendimÃ¤Ã¤ra ei renditud',0),(405301,11259,'si','Odstotek ni zakupljenih',0),(405302,11259,'ba','Persentase tidak disewakan',0),(405303,11259,'nl','Percentage niet verhuurd',0),(405304,11259,'fi','Prosenttiosuus ei vuokrattu',0),(405305,11259,'no','Prosent ikke tillatt',0),(405306,11259,'da','Procentdel ikke udlejet',0),(405307,11259,'ko','ì•„ë‹ˆ ìž„ëŒ€ ë¹„ìœ¨',0),(405308,11259,'he','××—×•×– ×œ× ×ž×•×©×›×¨',0),(405309,11259,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï€Î¿Ï… Î´ÎµÎ½ Î¼Î¹ÏƒÎ¸Ï‰Î¼Î­Î½ÎµÏ‚',0),(405310,11259,'zh','éžå‡ºç§ŸçŽ‡\r\n',0),(405311,11259,'sv','Andel som inte hyrs',0),(405312,11259,'it','Percentuale non affittati',0),(405313,11259,'tl','',0),(405314,11259,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¹„à¸¡à¹ˆà¹€à¸Šà¹ˆà¸²',0),(405315,11259,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¨à¤¹à¥€à¤‚ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤°',0),(405316,11259,'ms','Peratusan tidak dipajak',0),(405317,11259,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù„ÙŠØ³Øª Ù…Ø³ØªØ£Ø¬Ø±Ø©',0),(405318,11259,'fr','Pourcentage non louÃ©',0),(405319,11259,'jp','ãƒªãƒ¼ã‚¹ã„ãªã„å‰²åˆ',0),(405320,11259,'pt','Porcentagem nÃ£o arrendada',0),(405321,11259,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð½Ðµ Ð°Ñ€ÐµÐ½Ð´Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ',0),(405322,11259,'es','Porcentaje No Arrendado',0),(405323,11259,'de','Prozentsatz nicht geleast',0),(405324,11259,'en','Percentage Not Leased',0),(405325,11260,'is','',0),(405326,11260,'dr','Ø¯Ø±ØµØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(405327,11260,'pr','Ø¯Ø±ØµØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(405328,11260,'tr','KiralarÄ± yÃ¼zde onayladÄ±',0),(405329,11260,'pl','Procent ratyfikowane umowy najmu',0),(405330,11260,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ñ€Ð°Ñ‚Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(405331,11260,'ur','Ù¾Ø±Ø³Ù†Ù¹ÛŒØ¬ Ù„ÙÛŒØ²Ø² ØªÙˆØ«ÛŒÙ‚',0),(405332,11260,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ñ€Ð°Ñ‚Ð¸Ñ„Ð¸ÐºÐ¾Ð²Ð°Ð¾ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(405333,11260,'vi','pháº§n trÄƒm há»£p Ä‘á»“ng thuÃª Ä‘Æ°á»£c duyá»‡t',0),(405334,11260,'af','Persentasie bekragtig huurooreenkomste',0),(405335,11260,'ro','Procentul ratificat contracte de leasing',0),(405336,11260,'et','Protsent ratifitseerinud rent',0),(405337,11260,'si','Odstotek ratificirale najemi',0),(405338,11260,'ba','Persentase meratifikasi sewa',0),(405339,11260,'nl','Percentage geratificeerd lease-overeenkomsten',0),(405340,11260,'fi','Prosenttiosuus ratifioinut vuokrasopimukset',0),(405341,11260,'no','Prosentandel ratifisert leieavtaler',0),(405342,11260,'da','Procentdel ratificeret lejemÃ¥l',0),(405343,11260,'ko','ë°±ë¶„ìœ¨ ë¹„ì¤€ ìž„ëŒ€',0),(405344,11260,'he','××—×•×– ××©×¨×¨×” ×—×›×™×¨×”',0),(405345,11260,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎµÏ€Î¹ÎºÏ…ÏÏ‰Î¸ÎµÎ¯ Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(405346,11260,'zh','æ‰¹å‡†ç§Ÿèµç™¾åˆ†æ¯”\r\n',0),(405347,11260,'sv','Andel ratificerat leasingavtal',0),(405348,11260,'it','Percentuale ratificato locazioni',0),(405349,11260,'tl','',0),(405350,11260,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸ªà¸³à¸„à¸±à¸à¹€à¸Šà¹ˆà¸²',0),(405351,11260,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¥‡ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚ à¤•à¤¾ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¤¿à¤¯à¤¾',0),(405352,11260,'ms','Peratusan diratifikasi pajakan',0),(405353,11260,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© ØµØ§Ø¯Ù‚Øª Ø¹Ù„Ù‰ Ø¹Ù‚ÙˆØ¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(405354,11260,'fr','Pourcentage ratifiÃ© baux',0),(405355,11260,'jp','å‰²åˆæ‰¹å‡†ãƒªãƒ¼ã‚¹',0),(405356,11260,'pt','Percentagem ratificado locaÃ§Ãµes',0),(405357,11260,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ñ€Ð°Ñ‚Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð¾Ð²Ð°Ð»Ð¸ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(405358,11260,'es','Porcentaje de Arrendamientos Ratificados',0),(405359,11260,'de','Prozentsatz ratifiziert Leases',0),(405360,11260,'en','Percentage Ratified Leases',0),(405361,11261,'is','',0),(405362,11261,'dr','Ø¯Ø±ØµØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø±Ø²Ø±Ùˆ Ø´Ø¯Ù‡ ',0),(405363,11261,'pr','Ø¯Ø±ØµØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø±Ø²Ø±Ùˆ Ø´Ø¯Ù‡ ',0),(405364,11261,'tr','KiralarÄ± yÃ¼zde saklÄ±dÄ±r',0),(405365,11261,'pl','Procentowy udziaÅ‚ funduszy zarezerwowanych leasing',0),(405366,11261,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð·Ð°Ð¿Ð°Ð·Ð²Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(405367,11261,'ur','Ù¾Ø±Ø³Ù†Ù¹ÛŒØ¬ Ù„ÙÛŒØ²Ø² Ù…Ø­ÙÙˆØ¸ ÛÛŒÚº',0),(405368,11261,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð·Ð°Ð´Ñ€Ð¶Ð°Ð½Ð° ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(405369,11261,'vi','pháº§n trÄƒm há»£p Ä‘á»“ng thuÃª Ä‘áº·t trÆ°á»›c',0),(405370,11261,'af','Persentasie voorbehou huurooreenkomste',0),(405371,11261,'ro','Procentul rezervate contracte de leasing',0),(405372,11261,'et','Protsent reserveeritud rent',0),(405373,11261,'si','Odstotek pridrÅ¾ane najemi',0),(405374,11261,'ba','Persentase milik sewa',0),(405375,11261,'nl','Percentage voorbehouden lease-overeenkomsten',0),(405376,11261,'fi','Prosenttiosuus pidÃ¤tetÃ¤Ã¤n vuokrasopimukset',0),(405377,11261,'no','Prosentandel reservert leieavtaler',0),(405378,11261,'da','Procentdel forbeholdt lejemÃ¥l',0),(405379,11261,'ko','ë¹„ìœ¨ì´ ìž„ëŒ€ ì˜ˆì•½',0),(405380,11261,'he','××—×•×– ×©×ž×•×¨×•×ª ×—×›×™×¨×”',0),(405381,11261,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î´Î¹Î±Ï„Î·ÏÎ¿ÏÎ½Ï„Î±Î¹ Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(405382,11261,'zh','ä¿ç•™ç§Ÿèµç™¾åˆ†æ¯”\r\n',0),(405383,11261,'sv','Andel reserverade leasingavtal',0),(405384,11261,'it','Percentuale riservata leasing',0),(405385,11261,'tl','',0),(405386,11261,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸ˆà¸­à¸‡à¹€à¸Šà¹ˆà¸²',0),(405387,11261,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤†à¤°à¤•à¥à¤·à¤¿à¤¤',0),(405388,11261,'ms','Peratusan terpelihara pajakan',0),(405389,11261,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù…Ø­ÙÙˆØ¸Ø© Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±Ø§Øª',0),(405390,11261,'fr','Pourcentage rÃ©servÃ© baux',0),(405391,11261,'jp','å‰²åˆäºˆç´„ã®ãƒªãƒ¼ã‚¹',0),(405392,11261,'pt','Porcentagem reservada locaÃ§Ãµes',0),(405393,11261,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð·Ð°Ñ€ÐµÐ·ÐµÑ€Ð²Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(405394,11261,'es','Porcentaje de Arrendamientos Reservados',0),(405395,11261,'de','Prozentsatz vorbehalten Leases',0),(405396,11261,'en','Percentage Reserved Leases',0),(405397,11262,'is','',0),(405398,11262,'dr','Ø¯Ø±ØµØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ ',0),(405399,11262,'pr','Ø¯Ø±ØµØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ ',0),(405400,11262,'tr','KiralarÄ± yÃ¼zde imzaladÄ±',0),(405401,11262,'pl','Procent podpisane umowy najmu',0),(405402,11262,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð¸ Ð·Ð° Ð½Ð°ÐµÐ¼',0),(405403,11262,'ur','Ù¾Ø±Ø³Ù†Ù¹ÛŒØ¬ Ù„ÙÛŒØ²Ø² Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©ÛŒÛ’ Û”',0),(405404,11262,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ð½Ð¸ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(405405,11262,'vi','pháº§n trÄƒm há»£p Ä‘á»“ng thuÃª Ä‘Ã£ kÃ½',0),(405406,11262,'af','Persentasie huurooreenkomste onderteken',0),(405407,11262,'ro','Procentul semnat contracte de leasing',0),(405408,11262,'et','Protsent sÃµlmitud Ã¼Ã¼rilepingud',0),(405409,11262,'si','Odstotek podpisala najemi',0),(405410,11262,'ba','Persentase menandatangani sewa',0),(405411,11262,'nl','Percentage ondertekend lease-overeenkomsten',0),(405412,11262,'fi','Prosenttiosuus allekirjoitettu vuokrasopimukset',0),(405413,11262,'no','Prosentandel signert leiekontrakter',0),(405414,11262,'da','Procentdel underskrives lejekontrakter',0),(405415,11262,'ko','ë°±ë¶„ìœ¨ ì„œëª… ìž„ëŒ€',0),(405416,11262,'he','××—×•×– ×—×ª× ×¢×œ ×—×›×™×¨×”',0),(405417,11262,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï…Ï€Î­Î³ÏÎ±ÏˆÎµ Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(405418,11262,'zh','ç­¾è®¢ç§Ÿèµç™¾åˆ†æ¯”\r\n',0),(405419,11262,'sv','Andel undertecknat leasingavtal',0),(405420,11262,'it','Percentuale firmato contratti di locazione',0),(405421,11262,'tl','',0),(405422,11262,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸¥à¸‡à¸™à¸²à¸¡à¹€à¸Šà¹ˆà¸²',0),(405423,11262,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤¿à¤',0),(405424,11262,'ms','Peratusan ditandatangani pajakan',0),(405425,11262,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© ÙˆÙ‚Ø¹Øª Ø¹Ù‚ÙˆØ¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(405426,11262,'fr','Pourcentage signÃ© des baux',0),(405427,11262,'jp','ãƒ‘ãƒ¼ã‚»ãƒ³ãƒ†ãƒ¼ã‚¸ç½²åãƒªãƒ¼ã‚¹',0),(405428,11262,'pt','Percentagem assinado locaÃ§Ãµes',0),(405429,11262,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð½Ñ‹Ñ… Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð¾Ð² Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(405430,11262,'es','Porcentaje de Arrendamientos Firmados',0),(405431,11262,'de','Prozentsatz unterzeichnete PachtvertrÃ¤ge',0),(405432,11262,'en','Percentage Signed Leases',0),(405433,11263,'is','',0),(405434,11263,'dr','Ø¯Ø±ØµØ¯ ÙƒÙ„ÙŠ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§',0),(405435,11263,'pr','Ø¯Ø±ØµØ¯ ÙƒÙ„ÙŠ Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§',0),(405436,11263,'tr','YÃ¼zde toplam Kiralama',0),(405437,11263,'pl','Procent caÅ‚kowitej leasing',0),(405438,11263,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¾Ð±Ñ‰Ð¾ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(405439,11263,'ur','Ø´Ø±Ø­ ÙÛŒ ØµØ¯ Ú©Ù„ Ù„ÙÛŒØ²Ø²',0),(405440,11263,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ ÑƒÐºÑƒÐ¿Ð½Ð¾Ð³ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(405441,11263,'vi','pháº§n trÄƒm tá»“ng há»£p Ä‘á»“ng thuÃª',0),(405442,11263,'af','Persentasie totale huurooreenkomste',0),(405443,11263,'ro','Procentul Total leasing',0),(405444,11263,'et','Protsent kokku rent',0),(405445,11263,'si','Odstotek skupno najemi',0),(405446,11263,'ba','Persentase Total sewa',0),(405447,11263,'nl','Percentage totale Leases',0),(405448,11263,'fi','Osuus yhteensÃ¤ vuokrasopimukset',0),(405449,11263,'no','Prosent totale leieavtaler',0),(405450,11263,'da','Procentdel samlede lejemÃ¥l',0),(405451,11263,'ko','ë°±ë¶„ìœ¨ ì´ ìž„ëŒ€',0),(405452,11263,'he','×—×›×™×¨×” ×”×›×•×œ×œ ××—×•×–',0),(405453,11263,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¿Ï Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(405454,11263,'zh','ç§Ÿèµæ€»é¢çš„ç™¾åˆ†æ¯”\r\n',0),(405455,11263,'sv','Andel totala lÃ¥n',0),(405456,11263,'it','Percentuale totale leasing',0),(405457,11263,'tl','',0),(405458,11263,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸£à¸§à¸¡à¹€à¸Šà¹ˆà¸²',0),(405459,11263,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¥‡ à¤•à¥à¤² à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚',0),(405460,11263,'ms','Peratusan jumlah pajakan',0),(405461,11263,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±Ø§Øª',0),(405462,11263,'fr','Pourcentage Total baux',0),(405463,11263,'jp','ãƒ‘ãƒ¼ã‚»ãƒ³ãƒ†ãƒ¼ã‚¸ç·ãƒªãƒ¼ã‚¹',0),(405464,11263,'pt','Percentagem Total locaÃ§Ãµes',0),(405465,11263,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¾Ð±Ñ‰ÐµÐ¹ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(405466,11263,'es','Porcentaje de Arrrendamientos Totales',0),(405467,11263,'de','Prozentsatz insgesamt Leases',0),(405468,11263,'en','Percentage Total Leases',0),(405469,11264,'is','',0),(405470,11264,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(405471,11264,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(405472,11264,'tr','LÃ¼tfen Tarih eklemek',0),(405473,11264,'pl','ProszÄ™ podaÄ‡ datÄ™',0),(405474,11264,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð´Ð°Ñ‚Ð°Ñ‚Ð°',0),(405475,11264,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© ØªØ§Ø±ÛŒØ® Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(405476,11264,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(405477,11264,'vi','vui lÃ²ng bao gá»“m má»™t ngÃ y ',0),(405478,11264,'af','Sluit Asseblief \'n Datum In',0),(405479,11264,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i o datÄƒ',0),(405480,11264,'et','Palun lisada kuupÃ¤ev',0),(405481,11264,'si','Prosimo, da vkljuÄite datum',0),(405482,11264,'ba','Harap sertakan kencan',0),(405483,11264,'nl','Gelieve te omvatten een datum',0),(405484,11264,'fi','SisÃ¤llytÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(405485,11264,'no','Ta med en dato',0),(405486,11264,'da','Inkluder venligst en dato',0),(405487,11264,'ko','ë‚ ì§œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(405488,11264,'he','× × ×œ×›×œ×•×œ ×ª××¨×™×š',0),(405489,11264,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(405490,11264,'zh','è¯·åˆ—å…¥ä¸€ä¸ªæ—¥æœŸ\r\n',0),(405491,11264,'sv','VÃ¤nligen inkludera ett datum',0),(405492,11264,'it','Si prega di includere una data',0),(405493,11264,'tl','',0),(405494,11264,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸§à¸±à¸™',0),(405495,11264,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤¿à¤¸à¥€ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(405496,11264,'ms','Sila Sertakan tarikh',0),(405497,11264,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† ØªØ§Ø±ÙŠØ®',0),(405498,11264,'fr','Veuillez inclure une Date',0),(405499,11264,'jp','æ—¥ä»˜ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(405500,11264,'pt','Por favor, inclua uma data',0),(405501,11264,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð”Ð°Ñ‚Ñƒ',0),(405502,11264,'es','Por Favor Incluye Una Fecha',0),(405503,11264,'de','Bitte geben Sie ein Datum',0),(405504,11264,'en','Please Include A Date',0),(405505,11265,'is','',0),(405506,11265,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(405507,11265,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(405508,11265,'tr','OnaylamÄ±ÅŸ kiralarÄ±',0),(405509,11265,'pl','Ratyfikowane umowy najmu',0),(405510,11265,'bg','Ð Ð°Ñ‚Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(405511,11265,'ur','Ù…Ù†Ø¸ÙˆØ± Ø´Ø¯Û Ù„ÙÛŒØ²Ø²',0),(405512,11265,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¾Ð³ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(405513,11265,'vi','há»£p Ä‘á»“ng thuÃª Ä‘Ã£ thÃ´ng qua',0),(405514,11265,'af','Bekragtig Verhurings',0),(405515,11265,'ro','Ratificat leasing',0),(405516,11265,'et','Ratifitseeritud rent',0),(405517,11265,'si','Ratificirane najemi',0),(405518,11265,'ba','Disahkan sewa',0),(405519,11265,'nl','Lease-overeenkomsten geratificeerd',0),(405520,11265,'fi','Ratifioidun vuokrasopimukset',0),(405521,11265,'no','Ratifisert leieavtaler',0),(405522,11265,'da','Ratificeret lejemÃ¥l',0),(405523,11265,'ko','ë¹„ì¤€ëœ ìž„ëŒ€',0),(405524,11265,'he','×—×›×™×¨×” ××•×©×¨×¨×•',0),(405525,11265,'el','ÎšÏ…ÏÏŽÎ¸Î·ÎºÎµ ÏƒÏ„Î¹Ï‚ Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(405526,11265,'zh','æ‰¹å‡†ç§Ÿèµ\r\n',0),(405527,11265,'sv','Ratificerade leasingavtal',0),(405528,11265,'it','Locazioni ratificati',0),(405529,11265,'tl','',0),(405530,11265,'th','à¹€à¸Šà¹ˆà¸²à¸—à¸µà¹ˆà¸ªà¸³à¸„à¸±à¸',0),(405531,11265,'hi','à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚',0),(405532,11265,'ms','Pajakan diratifikasi',0),(405533,11265,'ar','Ø¹Ù‚ÙˆØ¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ù…ØµØ§Ø¯Ù‚ Ø¹Ù„ÙŠÙ‡Ø§',0),(405534,11265,'fr','Baux ratifiÃ©es',0),(405535,11265,'jp','æ‰¹å‡†ã•ã‚ŒãŸãƒªãƒ¼ã‚¹',0),(405536,11265,'pt','Ratificado locaÃ§Ãµes',0),(405537,11265,'ru','Ð Ð°Ñ‚Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð¾Ð² Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(405538,11265,'es','Arrendamientos Ratificados',0),(405539,11265,'de','Ratifizierte Leases',0),(405540,11265,'en','Ratified Leases',0),(405541,11266,'is','',0),(405542,11266,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯Ù‡ ',0),(405543,11266,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯Ù‡ ',0),(405544,11266,'tr','AyrÄ±lmÄ±ÅŸ kiralarÄ±',0),(405545,11266,'pl','ZastrzeÅ¼one leasing',0),(405546,11266,'bg','Ð—Ð°Ð¿Ð°Ð·ÐµÐ½Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(405547,11266,'ur','Ù…Ø­ÙÙˆØ¸ Ø´Ø¯Û Ù„ÙÛŒØ²Ø²',0),(405548,11266,'sr','Ð ÐµÐ·ÐµÑ€Ð²Ð¸ÑÐ°Ð½Ð° ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(405549,11266,'vi','Ä‘Ã£ thuÃª trÆ°á»›c',0),(405550,11266,'af','Voorbehou huurooreenkomste',0),(405551,11266,'ro','Contracte de leasing rezervate',0),(405552,11266,'et','Reserveeritud rent',0),(405553,11266,'si','PridrÅ¾ane najemi',0),(405554,11266,'ba','Reserved sewa',0),(405555,11266,'nl','Gereserveerde Leases',0),(405556,11266,'fi','Varattu vuokrasopimukset',0),(405557,11266,'no','Reserverte leieavtaler',0),(405558,11266,'da','Reserverede lejemÃ¥l',0),(405559,11266,'ko','ì˜ˆì•½ ëœ ìž„ëŒ€',0),(405560,11266,'he','×—×›×™×¨×” ×©×ž×•×¨×•×ª',0),(405561,11266,'el','Î”ÎµÏƒÎ¼ÎµÏ…Î¼Î­Î½Î¿ Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(405562,11266,'zh','ä¿ç•™ç§Ÿèµ\r\n',0),(405563,11266,'sv','Reserverade leasingavtal',0),(405564,11266,'it','Contratti di locazione riservate',0),(405565,11266,'tl','',0),(405566,11266,'th','à¹€à¸Šà¹ˆà¸²à¸ªà¸‡à¸§à¸™à¹„à¸§à¹‰',0),(405567,11266,'hi','à¤¸à¤°à¥à¤µà¤¾à¤§à¤¿à¤•à¤¾à¤° à¤¸à¥à¤°à¤•à¥à¤·à¤¿à¤¤ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚',0),(405568,11266,'ms','Pajakan yang terpelihara',0),(405569,11266,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±Ø§Øª Ù…Ø­Ø¬ÙˆØ²',0),(405570,11266,'fr','Baux rÃ©servÃ©',0),(405571,11266,'jp','äºˆç´„ã®ãƒªãƒ¼ã‚¹',0),(405572,11266,'pt','Reservados locaÃ§Ãµes',0),(405573,11266,'ru','Ð—Ð°Ñ€ÐµÐ·ÐµÑ€Ð²Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(405574,11266,'es','Arrendamientos Reservados',0),(405575,11266,'de','Reservierte Leases',0),(405576,11266,'en','Reserved Leases',0),(405577,11267,'is','',0),(405578,11267,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡',0),(405579,11267,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡',0),(405580,11267,'tr','Kira imzaladÄ±',0),(405581,11267,'pl','Podpisane umowy najmu',0),(405582,11267,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¾ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(405583,11267,'ur','Ø¯Ø³ØªØ®Ø· Ù„ÙÛŒØ²Ø²',0),(405584,11267,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ°Ð½Ð¸ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(405585,11267,'vi','bÃªn cho thuÃª kÃ½',0),(405586,11267,'af','Getekende Huurkontrakte',0),(405587,11267,'ro','Semnat contracte de leasing',0),(405588,11267,'et','SÃµlmitud Ã¼Ã¼rilepingud',0),(405589,11267,'si','Podpisana najemi',0),(405590,11267,'ba','Menandatangani sewa',0),(405591,11267,'nl','Lease-overeenkomsten ondertekend',0),(405592,11267,'fi','Vuokrasopimukset',0),(405593,11267,'no','Signert leiekontrakter',0),(405594,11267,'da','Underskrives lejekontrakter',0),(405595,11267,'ko','ìž„ëŒ€ì— ì„œëª…',0),(405596,11267,'he','×—×ª× ×¢×œ ×—×›×™×¨×”',0),(405597,11267,'el','Î¥Ï€ÎµÎ³ÏÎ¬Ï†Î· Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚',0),(405598,11267,'zh','ç­¾è®¢ç§Ÿèµ\r\n',0),(405599,11267,'sv','Undertecknat leasingavtal',0),(405600,11267,'it','Firmato contratti di locazione',0),(405601,11267,'tl','',0),(405602,11267,'th','à¸¥à¸‡à¸™à¸²à¸¡à¹€à¸Šà¹ˆà¸²',0),(405603,11267,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤¿à¤',0),(405604,11267,'ms','Ditandatangani pajakan',0),(405605,11267,'ar','ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù‚ÙˆØ¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(405606,11267,'fr','SignÃ© des baux',0),(405607,11267,'jp','ãƒªãƒ¼ã‚¹ã«ç½²å',0),(405608,11267,'pt','Assinado locaÃ§Ãµes',0),(405609,11267,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¾ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð¾Ð² Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(405610,11267,'es','Arrendamientos Firmados',0),(405611,11267,'de','MietvertrÃ¤ge unterzeichnet',0),(405612,11267,'en','Signed Leases',0),(405613,11268,'is','',0),(405614,11268,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(405615,11268,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(405616,11268,'tr','Ä°tibaren kira imzaladÄ±',0),(405617,11268,'pl','Podpisany jako dzierÅ¼awa',0),(405618,11268,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¾ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ ÐºÐ°ÐºÑ‚Ð¾ Ð½Ð°',0),(405619,11268,'ur','Ù„ÙÛŒØ²Ø² Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ø´Ø¯Û',0),(405620,11268,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ°Ð½Ð¸ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸ ÐºÐ°Ð¾ Ð¾Ð´',0),(405621,11268,'vi','bÃªn cho thuÃª kÃ½ ',0),(405622,11268,'af','Getekende Huurkontrakte soos vanaf ',0),(405623,11268,'ro','Semnat contracte de leasing ca de',0),(405624,11268,'et','Allkirjastatud Liising AS',0),(405625,11268,'si','Podpisana Najemi kot od',0),(405626,11268,'ba','Menandatangani sewa sebagai',0),(405627,11268,'nl','Ondertekening van lease-overeenkomsten als van',0),(405628,11268,'fi','Vuokrasopimukset sekÃ¤',0),(405629,11268,'no','Signert leiekontrakter for',0),(405630,11268,'da','Underskrevet lejemÃ¥l som',0),(405631,11268,'ko','ë¡œ ìž„ëŒ€ì— ì„œëª…',0),(405632,11268,'he','×—×ª× ×¢×œ ×—×›×™×¨×” ×›×ž×• ×©×œ',0),(405633,11268,'el','Î¥Ï€ÎµÎ³ÏÎ¬Ï†Î· Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚ Ï‰Ï‚',0),(405634,11268,'zh','ä½œä¸ºç­¾ç½²ç§Ÿèµ\r\n',0),(405635,11268,'sv','Undertecknat leasingavtal som av',0),(405636,11268,'it','Firmato contratti di locazione come di',0),(405637,11268,'tl','',0),(405638,11268,'th','à¸¥à¸‡à¸™à¸²à¸¡à¹€à¸Šà¹ˆà¸²à¹€à¸›à¹‡à¸™à¸‚à¸­à¸‡',0),(405639,11268,'hi','à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤¿à¤',0),(405640,11268,'ms','Ditandatangani pajakan sebagai',0),(405641,11268,'ar','ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù‚ÙˆØ¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± ÙƒÙ…Ù†',0),(405642,11268,'fr','SignÃ© le bail comme de',0),(405643,11268,'jp','ç½²åã¨ã—ã¦ã®ãƒªãƒ¼ã‚¹',0),(405644,11268,'pt','Assinado locaÃ§Ãµes a partir de',0),(405645,11268,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¾ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð¾Ð² Ð°Ñ€ÐµÐ½Ð´Ñ‹ Ð¿Ð¾ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸ÑŽ Ð½Ð°',0),(405646,11268,'es','Arrendamientos Firmados Desde',0),(405647,11268,'de','Leasing als von unterzeichnet',0),(405648,11268,'en','Signed Leases as of',0),(405649,11269,'is','',0),(405650,11269,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡ Ø´Ø¯Ù‡ ',0),(405651,11269,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡ Ø´Ø¯Ù‡ ',0),(405652,11269,'tr','Kiralanan toplam',0),(405653,11269,'pl','CaÅ‚kowity leasingu',0),(405654,11269,'bg','ÐžÐ±Ñ‰Ð¾ Ð½Ð°ÐµÑ‚Ð¸',0),(405655,11269,'ur','Ú©Ù„ Ù¾Ù¹ÛŒ Ù¾Ø± Ø¯ÛŒ Ú¯Ø¦ÛŒ',0),(405656,11269,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ñ˜Ðµ Ð¸Ð·Ð½Ð°Ñ˜Ð¼Ð¸Ð¾',0),(405657,11269,'vi','Tá»•ng cá»™ng phÃ­ Ä‘Ã£ thuÃª',0),(405658,11269,'af','Totaal Uitverhuur',0),(405659,11269,'ro','Total Ã®nchiriate',0),(405660,11269,'et','Liisitud kokku',0),(405661,11269,'si','Skupno zakupljenih',0),(405662,11269,'ba','Total disewakan',0),(405663,11269,'nl','Totaal verhuurd',0),(405664,11269,'fi','Vuokrattu yhteensÃ¤',0),(405665,11269,'no','Totalt leid',0),(405666,11269,'da','Alt udlejet',0),(405667,11269,'ko','ì´ ìž„ëŒ€',0),(405668,11269,'he','×¡×š ×”×›×œ ×ž×•×©×›×¨',0),(405669,11269,'el','Î£ÏÎ½Î¿Î»Î¿ Î¼Î¹ÏƒÎ¸Ï‰Î¼Î­Î½Ï‰Î½',0),(405670,11269,'zh','æ€»ç§Ÿèµ\r\n',0),(405671,11269,'sv','Totalt leasade',0),(405672,11269,'it','Totale leasing',0),(405673,11269,'tl','',0),(405674,11269,'th','à¸£à¸§à¸¡à¹€à¸Šà¹ˆà¸²',0),(405675,11269,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤° à¤•à¥à¤²',0),(405676,11269,'ms','Jumlah yang dipajak',0),(405677,11269,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±Ø©',0),(405678,11269,'fr','Total louÃ©',0),(405679,11269,'jp','åˆè¨ˆãƒªãƒ¼ã‚¹',0),(405680,11269,'pt','Total arrendado',0),(405681,11269,'ru','Ð’ÑÐµÐ³Ð¾ Ð² Ð°Ñ€ÐµÐ½Ð´Ñƒ',0),(405682,11269,'es','Total Arrendado',0),(405683,11269,'de','Gesamt, die verpachtet',0),(405684,11269,'en','Total Leased',0),(405685,11270,'is','',0),(405686,11270,'dr','ØªØ§Ø±ÙŠØ® ÙØ§Ø±Øº Ø§Ù„ØªØ­ØµÙŠÙ„Ù‰ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ø´Ø¯Ù‡ ',0),(405687,11270,'pr','ØªØ§Ø±ÙŠØ® ÙØ§Ø±Øº Ø§Ù„ØªØ­ØµÙŠÙ„Ù‰ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ø´Ø¯Ù‡ ',0),(405688,11270,'tr','Beklenen mezuniyet tarihi',0),(405689,11270,'pl','Data ukoÅ„czenia przewidywany',0),(405690,11270,'bg','ÐžÑ‡Ð°ÐºÐ²Ð°Ð½Ð¸Ñ‚Ðµ Ð´Ð¸Ð¿Ð»Ð¾Ð¼Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð´Ð°Ñ‚Ð°',0),(405691,11270,'ur','Ú¯Ù„ÛŒØ²Ø± Ú¯Ø±ÛŒØ¬ÙˆÛŒØ´Ù† Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(405692,11270,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ñ‡ÐµÐºÐ¸Ð²Ð°Ð½Ð¾Ð³ Ð·Ð°Ð²Ñ€ÑÐµÑ‚ÐºÐ°',0),(405693,11270,'vi','NgÃ y dá»± kiáº¿n â€‹â€‹tá»‘t nghiá»‡p',0),(405694,11270,'af','Verwagte gradeplegtigheid datum',0),(405695,11270,'ro','Data de absolvire anticipat',0),(405696,11270,'et','Eeldatava lÃµpetamise kuupÃ¤eva',0),(405697,11270,'si','Datum priÄakovane diplomi',0),(405698,11270,'ba','Tanggal diantisipasi wisuda',0),(405699,11270,'nl','Verwachte afstuderen datum',0),(405700,11270,'fi','Arvioitu valmistumisaika',0),(405701,11270,'no','Forventet konfirmasjonen dato',0),(405702,11270,'da','Forventede graduering dato',0),(405703,11270,'ko','ì˜ˆìƒëœ ì¡¸ì—… ë‚ ì§œ',0),(405704,11270,'he','×ª××¨×™×š ×”×¡×™×•× ×”×¦×¤×•×™',0),(405705,11270,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î½Î±Î¼ÎµÎ½ÏŒÎ¼ÎµÎ½Î·Ï‚ Î±Ï€Î¿Ï†Î¿Î¯Ï„Î·ÏƒÎ·Ï‚',0),(405706,11270,'zh','é¢„è®¡æ¯•ä¸šæ—¥æœŸ\r\n',0),(405707,11270,'sv','EfterlÃ¤ngtade examen datum',0),(405708,11270,'it','Data di laurea anticipata',0),(405709,11270,'tl','',0),(405710,11270,'th','à¸§à¸±à¸™à¸„à¸²à¸”à¸§à¹ˆà¸²à¸ˆà¸°à¸ˆà¸š',0),(405711,11270,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤¾à¤¶à¤¿à¤¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤§à¤¨ à¤¤à¤¿à¤¥à¤¿',0),(405712,11270,'ms','Tarikh dijangka tamat pengajian',0),(405713,11270,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ®Ø±Ø¬ Ø§Ù„Ù…ØªÙˆÙ‚Ø¹',0),(405714,11270,'fr','Date de remise des diplÃ´mes prÃ©vue',0),(405715,11270,'jp','äºˆæƒ³ã•ã‚Œã‚‹å’æ¥­æ—¥',0),(405716,11270,'pt','Data de formatura antecipado',0),(405717,11270,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ð¶Ð¸Ð´Ð°ÐµÐ¼Ð¾Ð³Ð¾ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(405718,11270,'es','Fecha de GraduaciÃ³n',0),(405719,11270,'de','Voraussichtlichen Abschluss Datum',0),(405720,11270,'en','Anticipated Graduation Date',0),(405721,11271,'is','',0),(405722,11271,'dr','( Ù…Ø¬Ù…ÙˆØ¹Ø§Ø³ ) Ø¬Ø§Ø±ÙŠ ',0),(405723,11271,'pr','Ø·Ø¨Ù‚Ù‡ ( ÙƒÙ„Ø§Ø³ ) Ø¬Ø§Ø±ÙŠ ',0),(405724,11271,'tr','GeÃ§erli sÄ±nÄ±f',0),(405725,11271,'pl','BieÅ¼Ä…ca Klasa',0),(405726,11271,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸Ñ ÐºÐ»Ð°Ñ',0),(405727,11271,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ú©Ù„Ø§Ø³',0),(405728,11271,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ ÐºÐ»Ð°ÑÐ°',0),(405729,11271,'vi','lá»›p hiá»‡n nay',0),(405730,11271,'af','Huidige Klasifikasie',0),(405731,11271,'ro','Clasa de curent',0),(405732,11271,'et','Praegune klass',0),(405733,11271,'si','Trenutni razred',0),(405734,11271,'ba','Kelas saat ini',0),(405735,11271,'nl','Huidige klasse',0),(405736,11271,'fi','Nykyinen luokka',0),(405737,11271,'no','Gjeldende klasse',0),(405738,11271,'da','Aktuelle klasse',0),(405739,11271,'ko','í˜„ìž¬ í´ëž˜ìŠ¤',0),(405740,11271,'he','×”×©×™×¢×•×¨ ×”× ×•×›×—×™',0),(405741,11271,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎºÎ»Î¬ÏƒÎ·',0),(405742,11271,'zh','ç›®å‰ç­‰çº§\r\n',0),(405743,11271,'sv','Aktuella klassen',0),(405744,11271,'it','Classe attuale',0),(405745,11271,'tl','',0),(405746,11271,'th','à¸Šà¸±à¹‰à¸™à¹€à¸£à¸µà¸¢à¸™à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(405747,11271,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤µà¤°à¥à¤—',0),(405748,11271,'ms','Semasa kelas',0),(405749,11271,'ar','Ø§Ù„ÙØ¦Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(405750,11271,'fr','Classe actuelle',0),(405751,11271,'jp','ç¾åœ¨ã®ã‚¯ãƒ©ã‚¹',0),(405752,11271,'pt','Classe atual',0),(405753,11271,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ ÐºÐ»Ð°ÑÑ',0),(405754,11271,'es','Clase Actual',0),(405755,11271,'de','Aktuelle Klasse',0),(405756,11271,'en','Current Class',0),(405757,11272,'is','',0),(405758,11272,'dr','Ø±Ø¯Ù‡ Ø¯Ø§Ù†Ø´ Ø¢Ù…ÙˆØ²',0),(405759,11272,'pr','Ø±Ø¯Ù‡ Ø¯Ø§Ù†Ø´ Ø¢Ù…ÙˆØ²',0),(405760,11272,'tr','Ã–ÄŸrenci sÄ±nÄ±f',0),(405761,11272,'pl','UczeÅ„ klasy',0),(405762,11272,'bg','Ð¡Ñ‚ÑƒÐ´ÐµÐ½Ñ‚ÑÐºÐ¸ ÐºÐ»Ð°Ñ',0),(405763,11272,'ur','Ø·Ø§Ù„Ø¨ Ø¹Ù„Ù… Ú©Ù„Ø§Ø³',0),(405764,11272,'sr','Ð¡Ñ‚ÑƒÐ´ÐµÐ½Ñ‚ÑÐºÐµ ÐºÐ»Ð°ÑÐµ',0),(405765,11272,'vi','Lá»›p sinh viÃªn',0),(405766,11272,'af','Student Klasifikasie',0),(405767,11272,'ro','Clasa de student',0),(405768,11272,'et','Ã•pilaste klass',0),(405769,11272,'si','Å tudent razred',0),(405770,11272,'ba','Siswa kelas',0),(405771,11272,'nl','Student klasse',0),(405772,11272,'fi','Opiskelija luokan',0),(405773,11272,'no','Student klasse',0),(405774,11272,'da','Studerende klasse',0),(405775,11272,'ko','í•™ìƒ í´ëž˜ìŠ¤',0),(405776,11272,'he','×ª×œ×ž×™×“ ×‘×›×™×ª×”',0),(405777,11272,'el','Î¦Î¿Î¹Ï„Î·Ï„Î®Ï‚ Ï„Î¬Î¾Î·',0),(405778,11272,'zh','å­¦ç”Ÿç±»\r\n',0),(405779,11272,'sv','Student klass',0),(405780,11272,'it','Classe Student',0),(405781,11272,'tl','',0),(405782,11272,'th','à¸™à¸±à¸à¹€à¸£à¸µà¸¢à¸™à¸Šà¸±à¹‰à¸™',0),(405783,11272,'hi','à¤µà¤¿à¤¦à¥à¤¯à¤¾à¤°à¥à¤¥à¥€ à¤µà¤°à¥à¤—',0),(405784,11272,'ms','Pelajar kelas',0),(405785,11272,'ar','ÙØ¦Ø© Ø§Ù„Ø·Ø§Ù„Ø¨',0),(405786,11272,'fr','Classe Student',0),(405787,11272,'jp','Student ã‚¯ãƒ©ã‚¹',0),(405788,11272,'pt','Classe aluno',0),(405789,11272,'ru','ÐšÐ»Ð°ÑÑ Student',0),(405790,11272,'es','Clase de Estudiantes',0),(405791,11272,'de','Student-Klasse',0),(405792,11272,'en','Student Class',0),(405793,11273,'is','',0),(405794,11273,'dr','Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ ',0),(405795,11273,'pr','Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ ',0),(405796,11273,'tr','Sona erdi',0),(405797,11273,'pl','ZakoÅ„czyÅ‚ siÄ™',0),(405798,11273,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐ¸',0),(405799,11273,'ur','Ø®ØªÙ… ÛÙˆ Ú¯ÛŒØ§',0),(405800,11273,'sr','Ð—Ð°Ð²Ñ€ÑˆÐµÐ½',0),(405801,11273,'vi','ÄÃ£ káº¿t thÃºc',0),(405802,11273,'af','GeÃ«indig',0),(405803,11273,'ro','S-a Ã®ncheiat',0),(405804,11273,'et','LÃµppenud',0),(405805,11273,'si','KonÄalo',0),(405806,11273,'ba','Berakhir',0),(405807,11273,'nl','Eindigde',0),(405808,11273,'fi','PÃ¤Ã¤ttyi',0),(405809,11273,'no','Avsluttet',0),(405810,11273,'da','Endte',0),(405811,11273,'ko','ì¢…ë£Œ',0),(405812,11273,'he','×”×¡×ª×™×™×',0),(405813,11273,'el','ÎˆÎ»Î·Î¾Îµ',0),(405814,11273,'zh','æˆªè‡³\r\n',0),(405815,11273,'sv','Slutade',0),(405816,11273,'it','Si Ã¨ conclusa',0),(405817,11273,'tl','',0),(405818,11273,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸¥à¸‡',0),(405819,11273,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹ à¤—à¤¯à¤¾',0),(405820,11273,'ms','Berakhir',0),(405821,11273,'ar','Ø§Ù†ØªÙ‡Øª',0),(405822,11273,'fr','TerminÃ©',0),(405823,11273,'jp','çµ‚äº†ã—ã¾ã—ãŸ',0),(405824,11273,'pt','Terminou',0),(405825,11273,'ru','Ð—Ð°ÐºÐ¾Ð½Ñ‡Ð¸Ð»Ð°ÑÑŒ',0),(405826,11273,'es','Terminado',0),(405827,11273,'de','Beendet',0),(405828,11273,'en','Ended',0),(405829,11274,'is','',0),(405830,11274,'dr','(ØªØ¬Ø¯ÙŠØ¯ Ø´Ø¯Ù‡',0),(405831,11274,'pr','Ù†Ùˆ Ø´Ø¯Ù‡ (ØªØ¬Ø¯ÙŠØ¯ Ø´Ø¯Ù‡',0),(405832,11274,'tr','Yenilendi',0),(405833,11274,'pl','Odnowione',0),(405834,11274,'bg','ÐŸÐ¾Ð´Ð½Ð¾Ð²ÑÐ²Ð°',0),(405835,11274,'ur','Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯',0),(405836,11274,'sr','ÐžÐ±Ð½Ð¾Ð²Ñ™ÐµÐ½Ð°',0),(405837,11274,'vi','Ä‘Ã£ khÃ´i phá»¥c',0),(405838,11274,'af','Hernu',0),(405839,11274,'ro','ReÃ®nnoit',0),(405840,11274,'et','Uuendatud',0),(405841,11274,'si','Prenovljena',0),(405842,11274,'ba','Diperbarui',0),(405843,11274,'nl','Vernieuwd',0),(405844,11274,'fi','Uusia',0),(405845,11274,'no','Fornyet',0),(405846,11274,'da','Fornyet',0),(405847,11274,'ko','ê°±ì‹ ',0),(405848,11274,'he','×—×™×“×•×©',0),(405849,11274,'el','Î‘Î½Î±Î½ÎµÏŽÎ½ÎµÏ„Î±Î¹',0),(405850,11274,'zh','ç»­æœŸ\r\n',0),(405851,11274,'sv','FÃ¶rnyas',0),(405852,11274,'it','Rinnovato',0),(405853,11274,'tl','',0),(405854,11274,'th','à¸à¸²à¸£à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸',0),(405855,11274,'hi','à¤¨à¤ à¤¸à¤¿à¤°à¥‡ à¤¸à¥‡',0),(405856,11274,'ms','Diperbaharui',0),(405857,11274,'ar','ÙˆØ¬Ø¯Ø¯',0),(405858,11274,'fr','RenouvelÃ©',0),(405859,11274,'jp','ãƒªãƒ‹ãƒ¥ãƒ¼ã‚¢ãƒ«',0),(405860,11274,'pt','Renovada',0),(405861,11274,'ru','Ð’Ð¾Ð·Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾',0),(405862,11274,'es','Renovado',0),(405863,11274,'de','Erneuert',0),(405864,11274,'en','Renewed',0),(405865,11275,'is','',0),(405866,11275,'dr','Ø®Ù„Ø§ØµÙ‡ Ø¹Ù…Ù„ÙƒØ±Ø¯ Ù…Ø³ØªØ§Ø¬Ø± ',0),(405867,11275,'pr','Ø®Ù„Ø§ØµÙ‡ Ø¹Ù…Ù„ÙƒØ±Ø¯ Ù…Ø³ØªØ§Ø¬Ø± ',0),(405868,11275,'tr','KiracÄ± performans Ã–zeti',0),(405869,11275,'pl','Podsumowanie wydajnoÅ›ci najemcy',0),(405870,11275,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð½Ð° ÐµÑ„ÐµÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(405871,11275,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(405872,11275,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐµ Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(405873,11275,'vi','TÃ³m lÆ°á»£t sá»± thá»±c hiá»‡n cá»§a ngÆ°á»i  thuÃª nhÃ ',0),(405874,11275,'af','Huurder Prestasie Opsomming',0),(405875,11275,'ro','Rezumat de performanÅ£Äƒ chiriaÅŸ',0),(405876,11275,'et','ÃœÃ¼rnik tÃ¤itmise KokkuvÃµte',0),(405877,11275,'si','Najemnik uspeÅ¡nosti Povzetek',0),(405878,11275,'ba','Ringkasan kinerja penyewa',0),(405879,11275,'nl','Huurder prestaties samenvatting',0),(405880,11275,'fi','Vuokralainen suorituskyvyn yhteenveto',0),(405881,11275,'no','Leietaker Ytelsessammendrag',0),(405882,11275,'da','Lejer ydeevne ResumÃ©',0),(405883,11275,'ko','ì„¸ ìž…ìž ì„±ëŠ¥ ìš”ì•½',0),(405884,11275,'he','×”×“×™×™×¨ ×‘×™×¦×•×¢×™× ×¡×™×›×•×',0),(405885,11275,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î® Î±Ï€ÏŒÎ´Î¿ÏƒÎ· Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(405886,11275,'zh','ä¸šæƒäººç»©æ•ˆçŽ°æ‘˜è¦\r\n',0),(405887,11275,'sv','HyresgÃ¤sten prestanda Sammanfattning',0),(405888,11275,'it','Riepilogo prestazioni inquilino',0),(405889,11275,'tl','',0),(405890,11275,'th','à¸ªà¸£à¸¸à¸›à¸à¸²à¸£à¸›à¸à¸´à¸šà¸±à¸•à¸´à¸‡à¸²à¸™à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(405891,11275,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(405892,11275,'ms','Ringkasan prestasi penyewa',0),(405893,11275,'ar','Ù…Ù„Ø®Øµ Ø£Ø¯Ø§Ø¡ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(405894,11275,'fr','Locataire Sommaire de la Performance',0),(405895,11275,'jp','ãƒ†ãƒŠãƒ³ãƒˆã®ãƒ‘ãƒ•ã‚©ãƒ¼ãƒžãƒ³ã‚¹ã®æ¦‚è¦',0),(405896,11275,'pt','Resumo de desempenho de inquilino',0),(405897,11275,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(405898,11275,'es','Resumen de Cumplimiento de Inquilino',0),(405899,11275,'de','Mieter Leistungszusammenfassung',0),(405900,11275,'en','Tenant Performance Summary',0),(405901,11276,'is','',0),(405902,11276,'dr','(Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡',0),(405903,11276,'pr','Ø­ÙˆØ§Ù„Ù‡ Ø´Ø¯Ù‡ (Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡',0),(405904,11276,'tr','Transfer',0),(405905,11276,'pl','Przeniesione',0),(405906,11276,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÐµÐ½Ð¸',0),(405907,11276,'ur','Ù…Ù†ØªÙ‚Ù„',0),(405908,11276,'sr','ÐŸÑ€ÐµÐ½Ð¾ÑÐµ',0),(405909,11276,'vi','Ä‘Ã£ chuyá»ƒn',0),(405910,11276,'af','Oorgeplaas',0),(405911,11276,'ro','Transferat',0),(405912,11276,'et','Ãœle kantud',0),(405913,11276,'si','Prenese',0),(405914,11276,'ba','Ditransfer',0),(405915,11276,'nl','Overgedragen',0),(405916,11276,'fi','Siirretty',0),(405917,11276,'no','OverfÃ¸rt',0),(405918,11276,'da','OverfÃ¸rt',0),(405919,11276,'ko','ì „ì†¡',0),(405920,11276,'he','×”×•×¢×‘×¨',0),(405921,11276,'el','ÎœÎµÏ„Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹',0),(405922,11276,'zh','è½¬ç§»\r\n',0),(405923,11276,'sv','Ã–verfÃ¶rs',0),(405924,11276,'it','Trasferito',0),(405925,11276,'tl','',0),(405926,11276,'th','à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(405927,11276,'hi','à¤¤à¤¬à¤¾à¤¦à¤²à¤¾',0),(405928,11276,'ms','Dipindahkan',0),(405929,11276,'ar','Ù†Ù‚Ù„',0),(405930,11276,'fr','TransfÃ©rÃ©',0),(405931,11276,'jp','è»¢é€',0),(405932,11276,'pt','Transferido',0),(405933,11276,'ru','ÐŸÐµÑ€ÐµÐ²ÐµÐ´ÐµÐ½Ñ‹',0),(405934,11276,'es','Transferido',0),(405935,11276,'de','Ãœbertragen',0),(405936,11276,'en','Transferred',0),(405937,11277,'is','',0),(405938,11277,'dr','Ù„ØºÙˆ Ø´Ø¯Ù‡ ',0),(405939,11277,'pr','Ù„ØºÙˆ Ø´Ø¯Ù‡ ',0),(405940,11277,'tr','Ä°ptal edildi',0),(405941,11277,'pl','WymÃ³wienie',0),(405942,11277,'bg','ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ð¸',0),(405943,11277,'ur','Ø±ÛŒØ³Ú©Ø§Ù†ÚˆØ¯',0),(405944,11277,'sr','Ð£ÐºÐ¸Ð½ÑƒÑ‚Ð¸',0),(405945,11277,'vi','Ä‘Ã£ há»§y bá»',0),(405946,11277,'af','Geskik',0),(405947,11277,'ro','Anulat',0),(405948,11277,'et','TÃ¼histatud',0),(405949,11277,'si','Kupnine',0),(405950,11277,'ba','Dicabut',0),(405951,11277,'nl','Ontbinding',0),(405952,11277,'fi','Kumottu',0),(405953,11277,'no','Opphevet',0),(405954,11277,'da','OphÃ¦vet',0),(405955,11277,'ko','ì² íšŒ',0),(405956,11277,'he','×œ×‘×˜×œ',0),(405957,11277,'el','Î¥Ï€Î±Î½Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹',0),(405958,11277,'zh','æ’¤é”€\r\n',0),(405959,11277,'sv','Ã…terkallas',0),(405960,11277,'it','Annullato',0),(405961,11277,'tl','',0),(405962,11277,'th','Rescinded',0),(405963,11277,'hi','à¤°à¥à¤•',0),(405964,11277,'ms','Ditarik balik',0),(405965,11277,'ar','Ø£Ù„ØºØª',0),(405966,11277,'fr','AnnulÃ©e',0),(405967,11277,'jp','å–ã‚Šæ¶ˆã—ãŸ',0),(405968,11277,'pt','RescisÃ£o',0),(405969,11277,'ru','ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ñ‹',0),(405970,11277,'es','Rescindido',0),(405971,11277,'de','Aufgehoben',0),(405972,11277,'en','Rescinded',0),(405973,11278,'is','',0),(405974,11278,'dr','ÙÙ‚Ø· Ù„ØºÙˆ Ø´Ø¯Ù‡ ',0),(405975,11278,'pr','ÙÙ‚Ø· Ù„ØºÙˆ Ø´Ø¯Ù‡ ',0),(405976,11278,'tr','Sadece iptal edildi',0),(405977,11278,'pl','Uchylone tylko',0),(405978,11278,'bg','ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ð¾ ÑÐ°Ð¼Ð¾',0),(405979,11278,'ur','ØµØ±Ù Ø±ÛŒØ³Ú©Ø§Ù†ÚˆØ¯',0),(405980,11278,'sr','Ð£ÐºÐ¸Ð½ÑƒÑ‚Ð¸ ÑÐ°Ð¼Ð¾',0),(405981,11278,'vi','chá»‰ há»§y bá»',0),(405982,11278,'af','Net geskik',0),(405983,11278,'ro','Anulate numai',0),(405984,11278,'et','TÃ¼histada ainult',0),(405985,11278,'si','PrekliÄe samo',0),(405986,11278,'ba','Dibatalkan hanya',0),(405987,11278,'nl','Alleen herroepen',0),(405988,11278,'fi','Peruuttaa vain',0),(405989,11278,'no','Opphevet bare',0),(405990,11278,'da','OphÃ¦vet kun',0),(405991,11278,'ko','ë§Œ ì² íšŒ',0),(405992,11278,'he','×œ×‘×˜×œ ×¨×§',0),(405993,11278,'el','Î‘ÎºÏ…ÏÏ‰Î¸ÎµÎ¯ Î¼ÏŒÎ½Î¿',0),(405994,11278,'zh','ä»…æ’¤é”€\r\n',0),(405995,11278,'sv','Ã…terkallas endast',0),(405996,11278,'it','Annullato solo',0),(405997,11278,'tl','',0),(405998,11278,'th','Rescinded à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(405999,11278,'hi','à¤•à¥‡à¤µà¤² à¤°à¥à¤•',0),(406000,11278,'ms','Ditarik balik hanya',0),(406001,11278,'ar','Ø£Ù„ØºÙ‰ ÙÙ‚Ø·',0),(406002,11278,'fr','AnnulÃ©e seulement',0),(406003,11278,'jp','ã®ã¿ã‚’å–ã‚Šæ¶ˆã—ãŸ',0),(406004,11278,'pt','Anulada apenas',0),(406005,11278,'ru','ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ñ‹ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(406006,11278,'es','Rescindido Solamente',0),(406007,11278,'de','Nur aufgehoben',0),(406008,11278,'en','Rescinded Only',0),(406009,11279,'is','',0),(406010,11279,'dr','ÙÙ‚Ø· Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ ',0),(406011,11279,'pr','ÙÙ‚Ø· Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ ',0),(406012,11279,'tr','YalnÄ±zca sonlandÄ±rÄ±ldÄ±',0),(406013,11279,'pl','Tylko zakoÅ„czone',0),(406014,11279,'bg','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‚ÑÐ²Ð° ÑÐ°Ð¼Ð¾',0),(406015,11279,'ur','ØµØ±Ù Ø®ØªÙ… Ú©Ø± Ø¯ÛŒØ§',0),(406016,11279,'sr','ÐŸÑ€ÐµÐºÐ¸Ð½ÑƒÑ‚ ÑÐ°Ð¼Ð¾',0),(406017,11279,'vi','chá»‰ cháº¥m dá»©t',0),(406018,11279,'af','Slegs beÃ«indig',0),(406019,11279,'ro','Reziliat doar',0),(406020,11279,'et','LÃµpetada ainult',0),(406021,11279,'si','Prekine samo',0),(406022,11279,'ba','Hanya dihentikan',0),(406023,11279,'nl','Alleen beÃ«indigd',0),(406024,11279,'fi','Lopettaa vain',0),(406025,11279,'no','Avsluttes bare',0),(406026,11279,'da','Opsagt kun',0),(406027,11279,'ko','ë§Œ ì¢…ë£Œ',0),(406028,11279,'he','×”×¡×ª×™×™× ×¨×§',0),(406029,11279,'el','Î¤ÎµÏÎ¼Î±Ï„Î¯ÏƒÏ„Î·ÎºÎµ Î¼ÏŒÎ½Î¿',0),(406030,11279,'zh','ä»…ç»ˆæ­¢\r\n',0),(406031,11279,'sv','Avslutade endast',0),(406032,11279,'it','Terminato solo',0),(406033,11279,'tl','',0),(406034,11279,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(406035,11279,'hi','à¤•à¥‡à¤µà¤² à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤ˆ',0),(406036,11279,'ms','Ditamatkan sahaja',0),(406037,11279,'ar','Ø£Ù†Ù‡Ù‰ ÙÙ‚Ø·',0),(406038,11279,'fr','RÃ©siliÃ© uniquement',0),(406039,11279,'jp','ã®ã¿çµ‚äº†',0),(406040,11279,'pt','Terminada somente',0),(406041,11279,'ru','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‰ÐµÐ½Ð¾ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(406042,11279,'es','Terminado Solamente',0),(406043,11279,'de','Beendet nur',0),(406044,11279,'en','Terminated Only',0),(406045,11280,'is','',0),(406046,11280,'dr','(ØªØ³Ù‡ÙŠÙ„Ø§Øª',0),(406047,11280,'pr','ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÙŠ Ø®Ø¯Ù…Ø§Øª Ø¹Ù…ÙˆÙ…ÙŠ(ØªØ³Ù‡ÙŠÙ„Ø§Øª',0),(406048,11280,'tr','Utility faturalama',0),(406049,11280,'pl','NarzÄ™dzie fakturowania',0),(406050,11280,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰Ð½Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(406051,11280,'ur','ÛŒÙˆÙ¹ÛŒÙ„Ù¹ÛŒ Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯',0),(406052,11280,'sr','Ð£ÑÐ»ÑƒÐ¶Ð½Ð¸ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(406053,11280,'vi','HÃ³a Ä‘Æ¡n tiá»‡n Ã­ch',0),(406054,11280,'af','Nutsprogram fakturering',0),(406055,11280,'ro','Utilitarul de facturare',0),(406056,11280,'et','Utility arveldamine',0),(406057,11280,'si','PripomoÄek za fakturiranje',0),(406058,11280,'ba','Faktur Utility',0),(406059,11280,'nl','Hulpprogramma voor facturering',0),(406060,11280,'fi','Utility laskutus',0),(406061,11280,'no','VerktÃ¸yet fakturering',0),(406062,11280,'da','Utility fakturering',0),(406063,11280,'ko','ìœ í‹¸ë¦¬í‹° ì²­êµ¬ì„œ',0),(406064,11280,'he','×—×©×‘×•× ×™×•×ª ×”×©×™×¨×•×ª',0),(406065,11280,'el','Î’Î¿Î·Î¸Î·Ï„Î¹ÎºÏŒ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(406066,11280,'zh','å…¬ç”¨äº‹ä¸šå•æ®\r\n',0),(406067,11280,'sv','Utility fakturering',0),(406068,11280,'it','UtilitÃ  di fatturazione',0),(406069,11280,'tl','',0),(406070,11280,'th','à¹‚à¸›à¸£à¹à¸à¸£à¸¡à¸­à¸£à¸£à¸–à¸›à¸£à¸°à¹‚à¸¢à¸Šà¸™à¹Œà¸à¸²à¸£à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(406071,11280,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤‰à¤ªà¤¯à¥‹à¤—à¤¿à¤¤à¤¾',0),(406072,11280,'ms','Invois utiliti',0),(406073,11280,'ar','Ø§Ù„Ø£Ø¯Ø§Ø© Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø© Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(406074,11280,'fr','Utilitaire de facturation',0),(406075,11280,'jp','ãƒ¦ãƒ¼ãƒ†ã‚£ãƒªãƒ†ã‚£ã®è«‹æ±‚æ›¸ç™ºè¡Œ',0),(406076,11280,'pt','UtilitÃ¡rio de facturaÃ§Ã£o',0),(406077,11280,'ru','ÐŸÑ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ð° Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(406078,11280,'es','FacturaciÃ³n de Servicios',0),(406079,11280,'de','Dienstprogramm Rechnungsstellung',0),(406080,11280,'en','Utility Invoicing',0),(406081,11281,'is','',0),(406082,11281,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¨Ø§Ø² ',0),(406083,11281,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¨Ø§Ø² ',0),(406084,11281,'tr','GÃ¼n aÃ§Ä±k',0),(406085,11281,'pl','Dni otwarte',0),(406086,11281,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½ Ð² Ð´Ð½Ð¸',0),(406087,11281,'ur','Ø¯Ù† Ú©Ùˆ Ú©Ú¾ÙˆÙ„ÛŒÚº',0),(406088,11281,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾ (Ð´Ð°Ð½Ð¸)',0),(406089,11281,'vi','NgÃ y má»Ÿ',0),(406090,11281,'af','Dae oop',0),(406091,11281,'ro','Zile deschise',0),(406092,11281,'et','PÃ¤eva avamine',0),(406093,11281,'si','Odprite dni',0),(406094,11281,'ba','Buka hari',0),(406095,11281,'nl','Dagen Open',0),(406096,11281,'fi','Avoimet pÃ¤ivÃ¤t',0),(406097,11281,'no','Dager Ã¥pne',0),(406098,11281,'da','Dage Ã…bn',0),(406099,11281,'ko','ì¼ ì—´',0),(406100,11281,'he','×™×ž×™× ×œ×¤×ª×•×—',0),(406101,11281,'el','Î‘Î½Î¿Î¯Î¾Ï„Îµ Î·Î¼Î­ÏÎµÏ‚',0),(406102,11281,'zh','å¤©\r\n',0),(406103,11281,'sv','Dagar Ã¶ppna',0),(406104,11281,'it','Giorni aprire',0),(406105,11281,'tl','',0),(406106,11281,'th','à¸§à¸±à¸™à¹€à¸›à¸´à¸”',0),(406107,11281,'hi','à¤–à¥à¤²à¤¾ à¤¦à¤¿à¤¨',0),(406108,11281,'ms','Hari terbuka',0),(406109,11281,'ar','Ø£ÙŠØ§Ù… ÙØªØ­',0),(406110,11281,'fr','VÃªlage',0),(406111,11281,'jp','æ—¥ã‚’é–‹ã',0),(406112,11281,'pt','Dias aberto',0),(406113,11281,'ru','Ð”Ð½ÐµÐ¹ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð´Ð²ÐµÑ€ÐµÐ¹',0),(406114,11281,'es','DÃ­as Abiertos',0),(406115,11281,'de','Tage der offenen',0),(406116,11281,'en','Days Open',0),(406117,11282,'is','',0),(406118,11282,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(406119,11282,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§',0),(406120,11282,'tr','Toplam Ã¼cretler',0),(406121,11282,'pl','Suma opÅ‚at',0),(406122,11282,'bg','ÐžÐ±Ñ‰Ð¾ Ñ‚Ð°ÐºÑÐ¸',0),(406123,11282,'ur','Ú©Ù„ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(406124,11282,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(406125,11282,'vi','Tá»•ng sá»‘ phÃ­ ',0),(406126,11282,'af','Totale Kostes',0),(406127,11282,'ro','Total taxe',0),(406128,11282,'et','Kulud kokku',0),(406129,11282,'si','Skupni stroÅ¡ki',0),(406130,11282,'ba','Total biaya',0),(406131,11282,'nl','Totaal lasten',0),(406132,11282,'fi','Kulut yhteensÃ¤',0),(406133,11282,'no','Totale kostnader',0),(406134,11282,'da','Samlede gebyrer',0),(406135,11282,'ko','ì´ ìš”ê¸ˆ',0),(406136,11282,'he','×¡×” ×› ×—×™×•×‘×™×',0),(406137,11282,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ­Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎµÎ¹Ï‚',0),(406138,11282,'zh','æ€»å…±æ”¶è´¹\r\n',0),(406139,11282,'sv','Totala avgifter',0),(406140,11282,'it','Totale oneri',0),(406141,11282,'tl','',0),(406142,11282,'th','à¸£à¸§à¸¡à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(406143,11282,'hi','à¤•à¥à¤² à¤¶à¥à¤²à¥à¤•',0),(406144,11282,'ms','Jumlah caj',0),(406145,11282,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ',0),(406146,11282,'fr','Total des frais',0),(406147,11282,'jp','åˆè¨ˆæ–™é‡‘',0),(406148,11282,'pt','Totais encargos',0),(406149,11282,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑƒÐ¼Ð¼Ð° Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(406150,11282,'es','Total de Cargos',0),(406151,11282,'de','GesamtgebÃ¼hren',0),(406152,11282,'en','Total Charges',0),(406153,11283,'is','',0),(406154,11283,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø²Ù…Ø§Ù† Ø¨Ø§Ø²  Ø´Ø¯Ù†',0),(406155,11283,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø²Ù…Ø§Ù† Ø¨Ø§Ø²  Ø´Ø¯Ù†',0),(406156,11283,'tr','Ortalama sÃ¼re aÃ§',0),(406157,11283,'pl','Åšredni czas dziaÅ‚ania operacji otwartego',0),(406158,11283,'bg','Ð¡Ñ€ÐµÐ´Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð¾Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ',0),(406159,11283,'ur','Ø§ÙˆØ³Ø· ÙˆÙ‚Øª Ú©Ú¾ÙˆÙ„ÛŒÚº',0),(406160,11283,'sr','ÐŸÑ€Ð¾ÑÐµÑ‡Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾',0),(406161,11283,'vi','Má»Ÿ thá»i gian trung bÃ¬nh',0),(406162,11283,'af','Gemiddelde tyd oop',0),(406163,11283,'ro','Timp mediu Open',0),(406164,11283,'et','Keskmine aeg Ava',0),(406165,11283,'si','PovpreÄen Äas plan',0),(406166,11283,'ba','Rata-rata waktu buka',0),(406167,11283,'nl','Gemiddelde tijd Open',0),(406168,11283,'fi','KeskimÃ¤Ã¤rÃ¤inen aika avoin',0),(406169,11283,'no','Gjennomsnittlig tid Ã¥pen',0),(406170,11283,'da','Gennemsnitlig tid Ã¥bne',0),(406171,11283,'ko','í‰ê·  ì‹œê°„ ì˜¤í”ˆ',0),(406172,11283,'he','×”×–×ž×Ÿ ×”×ž×ž×•×¦×¢ ×¤×ª×•×—',0),(406173,11283,'el','ÎœÎ­ÏƒÎ¿Ï‚ Ï‡ÏÏŒÎ½Î¿Ï‚ Î¬Î½Î¿Î¹Î³Î¼Î±',0),(406174,11283,'zh','å¹³å‡æ—¶é—´å¼€æ”¾\r\n',0),(406175,11283,'sv','Genomsnittlig tid Ã¶ppna',0),(406176,11283,'it','Tempo medio Open',0),(406177,11283,'tl','',0),(406178,11283,'th','à¹€à¸›à¸´à¸”à¹€à¸§à¸¥à¸²à¹€à¸‰à¸¥à¸µà¹ˆà¸¢',0),(406179,11283,'hi','à¤”à¤¸à¤¤ à¤¸à¤®à¤¯ à¤–à¥‹à¤²à¥‡à¤‚',0),(406180,11283,'ms','Purata masa terbuka',0),(406181,11283,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ø°ÙŠ ÙØªØ­',0),(406182,11283,'fr','Temps moyen ouvert',0),(406183,11283,'jp','å¹³å‡æ™‚é–“ã‚’é–‹ã',0),(406184,11283,'pt','Tempo mÃ©dio aberto',0),(406185,11283,'ru','Ð¡Ñ€ÐµÐ´Ð½ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚ÑŒ',0),(406186,11283,'es','Tiempo Promedio Abierto',0),(406187,11283,'de','Durchschnittliche Zeit Ã¶ffnen',0),(406188,11283,'en','Average Time Open',0),(406189,11284,'is','',0),(406190,11284,'dr','Ù…Ø´ØªØ±ÙŠØ§Ù† ',0),(406191,11284,'pr','Ù…Ø´ØªØ±ÙŠØ§Ù† ',0),(406192,11284,'tr','Ä°stemciler',0),(406193,11284,'pl','KlientÃ³w',0),(406194,11284,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(406195,11284,'ur','Ú¯Ø§ÛÚ©',0),(406196,11284,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸',0),(406197,11284,'vi','Nhá»¯ng khÃ¡ch hÃ ng.',0),(406198,11284,'af','Kliente',0),(406199,11284,'ro','Clientii',0),(406200,11284,'et','Klientidele',0),(406201,11284,'si','Odjemalci',0),(406202,11284,'ba','Klien',0),(406203,11284,'nl','Klanten',0),(406204,11284,'fi','Asiakkaiden',0),(406205,11284,'no','Klienter',0),(406206,11284,'da','Klienter',0),(406207,11284,'ko','í´ë¼ì´ì–¸íŠ¸',0),(406208,11284,'he','×œ×§×•×—×•×ª',0),(406209,11284,'el','Î ÎµÎ»Î¬Ï„ÎµÏ‚',0),(406210,11284,'zh','å®¢æˆ·ç«¯\r\n',0),(406211,11284,'sv','Klienter',0),(406212,11284,'it','Clienti',0),(406213,11284,'tl','',0),(406214,11284,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(406215,11284,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(406216,11284,'ms','Pelanggan-pelanggan',0),(406217,11284,'ar','Ø¹Ù…Ù„Ø§Ø¡',0),(406218,11284,'fr','Clients',0),(406219,11284,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆ',0),(406220,11284,'pt','Clientes',0),(406221,11284,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹',0),(406222,11284,'es','Clientes',0),(406223,11284,'de','Kunden',0),(406224,11284,'en','Clients',0),(406225,11285,'is','',0),(406226,11285,'dr','Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ø¯ÙŠÚ¯Ø± ',0),(406227,11285,'pr','Ø´Ø±ÙƒØª Ù‡Ø§ÙŠ Ø¯ÙŠÚ¯Ø± ',0),(406228,11285,'tr','DiÄŸer ÅŸirketler',0),(406229,11285,'pl','Innych firm',0),(406230,11285,'bg','Ð”Ñ€ÑƒÐ³Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(406231,11285,'ur','Ø¯ÛŒÚ¯Ø± Ú©Ù…Ù¾Ù†ÛŒØ§Úº',0),(406232,11285,'sr','Ð”Ñ€ÑƒÐ³Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(406233,11285,'vi','CÃ¡c cÃ´ng ty khÃ¡c',0),(406234,11285,'af','Ander maatskappye',0),(406235,11285,'ro','Alte companii',0),(406236,11285,'et','Muud Ã¤riÃ¼hingud',0),(406237,11285,'si','Druga podjetja',0),(406238,11285,'ba','Perusahaan lain',0),(406239,11285,'nl','Andere bedrijven',0),(406240,11285,'fi','Muut yritykset',0),(406241,11285,'no','Andre selskaper',0),(406242,11285,'da','Andre virksomheder',0),(406243,11285,'ko','ë‹¤ë¥¸ íšŒì‚¬',0),(406244,11285,'he','×—×‘×¨×•×ª ××—×¨×•×ª',0),(406245,11285,'el','Î†Î»Î»ÎµÏ‚ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚',0),(406246,11285,'zh','å…¶å®ƒå…¬å¸\r\n',0),(406247,11285,'sv','Andra fÃ¶retag',0),(406248,11285,'it','Altre societÃ ',0),(406249,11285,'tl','',0),(406250,11285,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸­à¸·à¹ˆà¸™ à¹†',0),(406251,11285,'hi','à¤…à¤¨à¥à¤¯ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¤¾à¤‚',0),(406252,11285,'ms','Syarikat-syarikat lain',0),(406253,11285,'ar','Ø´Ø±ÙƒØ§Øª Ø£Ø®Ø±Ù‰',0),(406254,11285,'fr','Autres entreprises',0),(406255,11285,'jp','ä»–ã®ä¼æ¥­',0),(406256,11285,'pt','Outras empresas',0),(406257,11285,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(406258,11285,'es','Otras Empresas',0),(406259,11285,'de','Andere Unternehmen',0),(406260,11285,'en','Other Companies',0),(406261,11286,'is','',0),(406262,11286,'dr','Ø¢Ù…Ø§Ø± Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(406263,11286,'pr','Ø¢Ù…Ø§Ø± Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± ',0),(406264,11286,'tr','Ä°ÅŸ sipariÅŸi istatistikleri',0),(406265,11286,'pl','Statystyki zlecenia pracy',0),(406266,11286,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(406267,11286,'ur','Ú©Ø§Ù… ØªØ±ØªÛŒØ¨ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ÙˆØ´Ù…Ø§Ø±',0),(406268,11286,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ð¾ÑÐ»Ð°',0),(406269,11286,'vi','Sá»‘ liá»‡u thá»‘ng kÃª lá»‡nh',0),(406270,11286,'af','Werk orde statistiek',0),(406271,11286,'ro','Statistici de ordine de lucru',0),(406272,11286,'et','TÃ¶Ã¶ tellimus statistika',0),(406273,11286,'si','Delo nalog statistika',0),(406274,11286,'ba','Kerja perintah Statistik',0),(406275,11286,'nl','Werk volgorde Stats',0),(406276,11286,'fi','TyÃ¶n tilaus tilastot',0),(406277,11286,'no','Arbeid for statistikk',0),(406278,11286,'da','Arbejde ordre statistik',0),(406279,11286,'ko','ìž‘ì—… ìˆœì„œ í†µê³„',0),(406280,11286,'he','×¡×˜×˜×™×¡×˜×™×§×” ×¡×“×¨ ×”×¢×‘×•×“×”',0),(406281,11286,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÏƒÎµÎ¹ÏÎ¬ ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬',0),(406282,11286,'zh','å·¥ä½œå•ç»Ÿè®¡\r\n',0),(406283,11286,'sv','Arbete fÃ¶r statistik',0),(406284,11286,'it','Statistiche di ordine di lavoro',0),(406285,11286,'tl','',0),(406286,11286,'th','à¸ªà¸–à¸´à¸•à¸´à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸à¸²à¸£à¸œà¸¥à¸´à¸•',0),(406287,11286,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤†à¤à¤•à¤¡à¤¼à¥‡',0),(406288,11286,'ms','Statistik perintah kerja',0),(406289,11286,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù…Ù„',0),(406290,11286,'fr','Stats d\'ordre de travail',0),(406291,11286,'jp','ä½œæ¥­é †åºçµ±è¨ˆ',0),(406292,11286,'pt','EstatÃ­sticas de ordem de trabalho',0),(406293,11286,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°ÐºÐ°Ð· ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(406294,11286,'es','EstadÃ­sticas de Ordenes de Trabajo',0),(406295,11286,'de','Arbeit Reihenfolge Stats',0),(406296,11286,'en','Work Order Stats',0),(406297,11287,'is','',0),(406298,11287,'dr','Ø¢Ù…Ø§Ø± Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(406299,11287,'pr','Ø¢Ù…Ø§Ø± Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ø§Ø² ØªØ§Ø±ÙŠØ® ',0),(406300,11287,'tr','Ä°ÅŸ emri istatistiksel olarak',0),(406301,11287,'pl','ZamÃ³wienie statystyki pracy jako',0),(406302,11287,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÐºÐ°Ñ‚Ð¾ Ð¾Ñ‚',0),(406303,11287,'ur','Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ú©Ø§Ù… ØªØ±ØªÛŒØ¨ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ÙˆØ´Ù…Ø§Ø±',0),(406304,11287,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ñ€Ð°Ð´ ÐºÐ°Ð¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(406305,11287,'vi','Sá»‘ liá»‡u thá»‘ng kÃª lá»‡nh cá»§a',0),(406306,11287,'af','Werk orde verbruikerstatistieke As van',0),(406307,11287,'ro','Activitatea comanda Stats ca de',0),(406308,11287,'et','TÃ¶Ã¶ hooldustellimuse statistika seisuga',0),(406309,11287,'si','Delo nalog statistika kot',0),(406310,11287,'ba','Statistik Order pekerjaan sebagai',0),(406311,11287,'nl','Werk volgorde Stats als van',0),(406312,11287,'fi','TyÃ¶ jÃ¤rjestyksessÃ¤ tilastot kuin',0),(406313,11287,'no','Arbeidet ordre statistikken som',0),(406314,11287,'da','Arbejde ordre statistik som af',0),(406315,11287,'ko','ë¡œ ìž‘ì—… ìˆœì„œ í†µê³„',0),(406316,11287,'he','×¡×˜×˜×™×¡×˜×™×§×” ×¡×“×¨ ×¢×‘×•×“×” ×›×ž×• ×©×œ',0),(406317,11287,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î± Ï‰Ï‚ Ï„Î·Ï‚',0),(406318,11287,'zh','å·¥ä½œå•ç»Ÿè®¡ä½œä¸º',0),(406319,11287,'sv','Arbete fÃ¶r statistik som av',0),(406320,11287,'it','Statistiche di ordine di lavoro come di',0),(406321,11287,'tl','',0),(406322,11287,'th','à¸ªà¸–à¸´à¸•à¸´à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸œà¸¥à¸´à¸•à¹€à¸›à¹‡à¸™à¸‚à¸­à¸‡',0),(406323,11287,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤†à¤à¤•à¤¡à¤¼à¥‡',0),(406324,11287,'ms','Statistik perintah kerja sehingga',0),(406325,11287,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù…Ù„ ÙƒÙ…Ù†',0),(406326,11287,'fr','Travail ordre Stats comme des',0),(406327,11287,'jp','ä½œæ¥­é †åºçµ±è¨ˆæƒ…å ±ã¨ã—ã¦',0),(406328,11287,'pt','EstatÃ­sticas de ordem de trabalho a partir de',0),(406329,11287,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°ÐºÐ°Ð· ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð¿Ð¾ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸ÑŽ Ð½Ð°',0),(406330,11287,'es','Ordenes de Trabajo Desde',0),(406331,11287,'de','Arbeit Auftrag Statistiken als der',0),(406332,11287,'en','Work Order Stats As Of',0),(406333,11288,'is','',0),(406334,11288,'dr','Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬  Ø´Ø±ÙƒØª Ø¨Ø±Ø§ÙŠ ',0),(406335,11288,'pr','Ø³Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬  Ø´Ø±ÙƒØª Ø¨Ø±Ø§ÙŠ ',0),(406336,11288,'tr','Åžirket Timeclock iÅŸ iÃ§in',0),(406337,11288,'pl','Firma Timeclock pracy dla',0),(406338,11288,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Timeclock Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°',0),(406339,11288,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ú©Ø§Ù… Ú©Û’ Ù„Ø¦Û’',0),(406340,11288,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ñ€Ð°Ð´ Ð·Ð°',0),(406341,11288,'vi','CÃ´ng ty Timeclock lÃ m viá»‡c cho',0),(406342,11288,'af','Maatskappy Timeclock werk vir',0),(406343,11288,'ro','Compania ceas de lucru pentru',0),(406344,11288,'et','Firma Timeclock tÃ¶Ã¶d',0),(406345,11288,'si','Podjetje Timeclock delo za',0),(406346,11288,'ba','Perusahaan Timeclock bekerja untuk',0),(406347,11288,'nl','Bedrijf klok werk voor',0),(406348,11288,'fi','Yrityksen Timeclock tyÃ¶tÃ¤',0),(406349,11288,'no','Selskapet Timeclock arbeid For',0),(406350,11288,'da','Firma Timeclock arbejde For',0),(406351,11288,'ko','íšŒì‚¬ Timeclock ìž‘ì—…ì— ëŒ€ í•œ',0),(406352,11288,'he','×—×‘×¨×ª Timeclock ×œ×¢×‘×•×“×”',0),(406353,11288,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± Timeclock ÎµÏÎ³Î±ÏƒÎ¯Î± Î³Î¹Î±',0),(406354,11288,'zh','ä¸Šç­æ—¶é—´å…¨å¤©å€™å·¥ä½œå¯¹äºŽ\r\n',0),(406355,11288,'sv','FÃ¶retaget Timeclock arbete fÃ¶r',0),(406356,11288,'it','Azienda Timeclock lavoro per',0),(406357,11288,'tl','',0),(406358,11288,'th','à¸šà¸£à¸´à¸©à¸±à¸— Timeclock à¸‡à¸²à¸™',0),(406359,11288,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾à¤® Timeclock',0),(406360,11288,'ms','Kerja-kerja Timeclock Syarikat bagi',0),(406361,11288,'ar','Ø´Ø±ÙƒØ© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ Ø¹Ù…Ù„',0),(406362,11288,'fr','La compagnie Timeclock travail pour',0),(406363,11288,'jp','ä¼šç¤¾ã«å‹¤ã‚ã¦ã„ã¦ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯',0),(406364,11288,'pt','Empresa Timeclock trabalho para',0),(406365,11288,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Timeclock Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(406366,11288,'es','Trabajo de Reloj Checador de Empresa Para',0),(406367,11288,'de','Firma Timeclock erarbeiten',0),(406368,11288,'en','Company Timeclock Work For',0),(406369,11289,'is','',0),(406370,11289,'dr','Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(406371,11289,'pr','Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(406372,11289,'tr','BakÄ±m stok',0),(406373,11289,'pl','Utrzymania zapasÃ³w',0),(406374,11289,'bg','ÐŸÐ¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(406375,11289,'ur','Ø¯ÛŒÚ©Ú¾ Ø¨Ú¾Ø§Ù„ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(406376,11289,'sr','ÐžÐ´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(406377,11289,'vi','HÃ ng tá»“n kho báº£o trÃ¬',0),(406378,11289,'af','Onderhoud voorraad',0),(406379,11289,'ro','Inventarul de Ã®ntreÅ£inere',0),(406380,11289,'et','Hooldus varude',0),(406381,11289,'si','VzdrÅ¾evanje zaloge',0),(406382,11289,'ba','Pemeliharaan inventaris',0),(406383,11289,'nl','Onderhoud inventaris',0),(406384,11289,'fi','Huolto varaston',0),(406385,11289,'no','Vedlikehold lager',0),(406386,11289,'da','Vedligeholdelse lager',0),(406387,11289,'ko','ìž¬ê³  ëª©ë¡ ìœ ì§€ ê´€ë¦¬',0),(406388,11289,'he','×ª×—×–×•×§×” ×ž×œ××™',0),(406389,11289,'el','Î£Ï…Î½Ï„Î®ÏÎ·ÏƒÎ· Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(406390,11289,'zh','ç»´ä¿®æ¸…å•\r\n',0),(406391,11289,'sv','UnderhÃ¥ll inventering',0),(406392,11289,'it','Manutenzione magazzino',0),(406393,11289,'tl','',0),(406394,11289,'th','à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(406395,11289,'hi','à¤°à¤–à¤°à¤–à¤¾à¤µ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€',0),(406396,11289,'ms','Penyelenggaraan inventori',0),(406397,11289,'ar','ØµÙŠØ§Ù†Ø© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(406398,11289,'fr','Entretien l\'inventaire',0),(406399,11289,'jp','ç¶­æŒã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒª',0),(406400,11289,'pt','InventÃ¡rio de manutenÃ§Ã£o',0),(406401,11289,'ru','ÐŸÐ¾Ð´Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ðµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(406402,11289,'es','Inventario de mantenimiento',0),(406403,11289,'de','Wartung-Inventar',0),(406404,11289,'en','Maintenance Inventory',0),(406405,11290,'is','',0),(406406,11290,'dr','Ù…ÙŠØ²Ø§Ù† Ø¯Ø³ØªØ±Ø³ÙŠ ÙˆØ§Ø­Ø¯ ',0),(406407,11290,'pr','Ù…ÙŠØ²Ø§Ù† Ø¯Ø³ØªØ±Ø³ÙŠ ÙˆØ§Ø­Ø¯ ',0),(406408,11290,'tr','Birim kullanÄ±m olanaÄŸÄ±',0),(406409,11290,'pl','DostÄ™pnoÅ›Ä‡ jednostek',0),(406410,11290,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(406411,11290,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ø¯Ø³ØªÛŒØ§Ø¨ÛŒ',0),(406412,11290,'sr','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¾ÑÑ‚',0),(406413,11290,'vi','ÄÆ¡n vá»‹ tÃ­nh kháº£ dá»¥ng',0),(406414,11290,'af','Eenheid Beskikbaarheid',0),(406415,11290,'ro','Disponibilitate unitate',0),(406416,11290,'et','Hiku kÃ¤ttesaadavus',0),(406417,11290,'si','RazpoloÅ¾ljivost enote',0),(406418,11290,'ba','Keterangan lebih lanjut.',0),(406419,11290,'nl','Beschikbaarheid in eenheden',0),(406420,11290,'fi','YksikÃ¶n kÃ¤ytettÃ¤vyys',0),(406421,11290,'no','Enhetstilgjengelighet',0),(406422,11290,'da','EnhedstilgÃ¦ngelighed',0),(406423,11290,'ko','ìž¥ì¹˜ ì´ìš©',0),(406424,11290,'he','×–×ž×™× ×•×ª ×™×—×™×“×”',0),(406425,11290,'el','Î”Î¹Î±Î¸ÎµÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î± Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(406426,11290,'zh','å•ä½å¯ç”¨æ€§\r\n',0),(406427,11290,'sv','TillgÃ¤nglighet',0),(406428,11290,'it','DisponibilitÃ  di unitÃ ',0),(406429,11290,'tl','',0),(406430,11290,'th','à¸«à¸™à¹ˆà¸§à¸¢à¸„à¸§à¸²à¸¡à¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(406431,11290,'hi','à¤‡à¤•à¤¾à¤ˆ à¤‰à¤ªà¤²à¤¬à¥à¤§à¤¤à¤¾',0),(406432,11290,'ms','Ketersediaan unit',0),(406433,11290,'ar','ØªÙˆÙØ± ÙˆØ­Ø¯Ø©',0),(406434,11290,'fr','UnitÃ©s disponibles',0),(406435,11290,'jp','å‰²ã‚Šå½“ã¦å¯èƒ½å˜ä½æ•°',0),(406436,11290,'pt','Disponibilidade da unidade',0),(406437,11290,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ÑÑ‚ÑŒ Ð² ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°Ñ…',0),(406438,11290,'es','Disponibilidad de Unidades',0),(406439,11290,'de','VerfÃ¼gbare Einheiten',0),(406440,11290,'en','Unit Availability',0),(406441,11291,'is','',0),(406442,11291,'dr','Ø§Ø³Ù†Ø§Ø¯ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(406443,11291,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(406444,11291,'tr','Mahkeme dosyalama Makaleler',0),(406445,11291,'pl','SÄ…d zÅ‚oÅ¼enia dokumentÃ³w',0),(406446,11291,'bg','Ð¡ÑŠÐ´ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(406447,11291,'ur','Ø¹Ø¯Ø§Ù„Øª Ù†Û’ Ø¨ØªØ§Ø¦ÛŒÚº Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(406448,11291,'sr','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð°',0),(406449,11291,'vi','Ná»™p há»“ sÆ¡ tÃ²a Ã¡n tÃ i liá»‡u',0),(406450,11291,'af','Hof liassering dokumente',0),(406451,11291,'ro','Curtea depunerea documentelor',0),(406452,11291,'et','Kohus registreerimistaotluse dokumendid',0),(406453,11291,'si','SodiÅ¡Äe vloÅ¾itev dokumentov',0),(406454,11291,'ba','Dokumen-dokumen pengadilan pengajuan',0),(406455,11291,'nl','Hof indiening documenten',0),(406456,11291,'fi','Tuomioistuimen rekisterin asiakirjat',0),(406457,11291,'no','Retten Filing dokumenter',0),(406458,11291,'da','Domstol arkivering dokumenter',0),(406459,11291,'ko','ë²•ì›ì— ì œì¶œí•œ ë¬¸ì„œ',0),(406460,11291,'he','×”×ž×©×¤×˜ ×œ×”×’×©×ª ×ž×¡×ž×›×™×',0),(406461,11291,'el','Î‘ÏÏ‡ÎµÎ¹Î¿Î¸Î­Ï„Î·ÏƒÎ· Î´Î¹ÎºÎ±ÏƒÏ„Î·ÏÎ¯Ï‰Î½ Î­Î³Î³ÏÎ±Ï†Î±',0),(406462,11291,'zh','æ³•é™¢æ–‡ä¹¦ç«‹å·\r\n',0),(406463,11291,'sv','TingsrÃ¤tten dokument',0),(406464,11291,'it','Corte deposito documenti',0),(406465,11291,'tl','',0),(406466,11291,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¸¢à¸·à¹ˆà¸™à¸¨à¸²à¸¥',0),(406467,11291,'hi','à¤•à¥‹à¤°à¥à¤Ÿ à¤«à¤¾à¤‡à¤²à¤¿à¤‚à¤— à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼',0),(406468,11291,'ms','Dokumen-dokumen difailkan Mahkamah',0),(406469,11291,'ar','ÙˆØ«Ø§Ø¦Ù‚ Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø­ÙƒÙ…Ø©',0),(406470,11291,'fr','Les Documents de dÃ©pÃ´t de la Cour',0),(406471,11291,'jp','è£åˆ¤æ‰€ã®å‡ºé¡˜æ›¸é¡žã—ã¾ã™ã€‚',0),(406472,11291,'pt','ApresentaÃ§Ã£o de tribunal documentos',0),(406473,11291,'ru','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(406474,11291,'es','Documentos de InterposiciÃ³n Legal ',0),(406475,11291,'de','Court Filing Dokumente',0),(406476,11291,'en','Court Filing Documents',0),(406477,11292,'is','',0),(406478,11292,'dr','Ø§Ù†Ù‚Ø¶Ø§ÙŠ ÙƒØ§Ø±Øª',0),(406479,11292,'pr','Ø§Ù†Ù‚Ø¶Ø§ÙŠ ÙƒØ§Ø±Øª',0),(406480,11292,'tr','KartÄ± sona erme',0),(406481,11292,'pl','DatÄ™ wygaÅ›niÄ™cia karty',0),(406482,11292,'bg','ÐšÐ°Ñ€Ñ‚Ð° Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ',0),(406483,11292,'ur','Ú©Ø§Ø±Úˆ Ø®ØªÙ… ÛÙˆÙ†Û’',0),(406484,11292,'sr','Ð Ð¾Ðº Ð²Ð°Ð¶ÐµÑšÐ° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(406485,11292,'vi','Tháº» háº¿t háº¡n',0),(406486,11292,'af','Kaart Vervaldatum',0),(406487,11292,'ro','Carte de expirare',0),(406488,11292,'et','Kaart aegub',0),(406489,11292,'si','Kartico poteka',0),(406490,11292,'ba','Kartu kadaluarsa',0),(406491,11292,'nl','Vervaldatum van de kaart',0),(406492,11292,'fi','Kortin voimassaolon',0),(406493,11292,'no','Kortet utlÃ¸per',0),(406494,11292,'da','Kort udlÃ¸b',0),(406495,11292,'ko','ì¹´ë“œ ë§Œë£Œ',0),(406496,11292,'he','×ª×¤×•×’×ª ×›×¨×˜×™×¡',0),(406497,11292,'el','Î›Î®Î¾Î· ÎºÎ¬ÏÏ„Î±Ï‚',0),(406498,11292,'zh','æœŸæ»¡å¡\r\n',0),(406499,11292,'sv','Kort utgÃ¥ngsdatum',0),(406500,11292,'it','Scadenza carta',0),(406501,11292,'tl','',0),(406502,11292,'th','à¸šà¸±à¸•à¸£à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(406503,11292,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿',0),(406504,11292,'ms','Tamat tempoh Kad',0),(406505,11292,'ar','Ø§Ù†ØªÙ‡Ø§Ø¡ ØµÙ„Ø§Ø­ÙŠØ© Ø§Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(406506,11292,'fr','Expiration de la carte',0),(406507,11292,'jp','ã‚«ãƒ¼ãƒ‰æœ‰åŠ¹æœŸé™',0),(406508,11292,'pt','ExpiraÃ§Ã£o do cartÃ£o',0),(406509,11292,'ru','Ð¡Ñ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(406510,11292,'es','ExpiraciÃ³n de Tarjeta',0),(406511,11292,'de','Karte-Ablauf',0),(406512,11292,'en','Card Expiration',0),(406513,11293,'is','',0),(406514,11293,'dr','Ù†Ø§Ù… ÙƒØ§Ø±Øª',0),(406515,11293,'pr','Ù†Ø§Ù… ÙƒØ§Ø±Øª',0),(406516,11293,'tr','Kart adÄ±',0),(406517,11293,'pl','Karta imiÄ™',0),(406518,11293,'bg','ÐšÐ°Ñ€Ñ‚Ð° Ð¸Ð¼Ðµ',0),(406519,11293,'ur','Ú©Ø§Ø±Úˆ Ú©Û’ Ù¾ÛÙ„Û’ Ú©Û’ Ù†Ø§Ù…',0),(406520,11293,'sr','Ð˜Ð¼Ðµ Ð¿Ñ€Ð²Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(406521,11293,'vi','TÃªn Ä‘áº§u cá»§a tháº»',0),(406522,11293,'af','Kaart Voornaam',0),(406523,11293,'ro','Numele de prima carte',0),(406524,11293,'et','Kaardil olev eesnimi',0),(406525,11293,'si','Ime kartice',0),(406526,11293,'ba','Kartu nama',0),(406527,11293,'nl','Kaart-voornaam',0),(406528,11293,'fi','Kortin ensimmÃ¤inen nimi',0),(406529,11293,'no','Kort fornavn',0),(406530,11293,'da','Kortet fornavn',0),(406531,11293,'ko','ì¹´ë“œ ì´ë¦„',0),(406532,11293,'he','×©× ×¤×¨×˜×™ ×›×¨×˜×™×¡',0),(406533,11293,'el','ÎšÎ¬ÏÏ„Î± ÏŒÎ½Î¿Î¼Î±',0),(406534,11293,'zh','å¡å¤´å\r\n',0),(406535,11293,'sv','Kort fÃ¶rnamn',0),(406536,11293,'it','Nome carta',0),(406537,11293,'tl','',0),(406538,11293,'th','à¸šà¸±à¸•à¸£à¸Šà¸·à¹ˆà¸­',0),(406539,11293,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤®',0),(406540,11293,'ms','Kad nama',0),(406541,11293,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„',0),(406542,11293,'fr','Carte prÃ©nom',0),(406543,11293,'jp','ã‚«ãƒ¼ãƒ‰å',0),(406544,11293,'pt','Nome cartÃ£o',0),(406545,11293,'ru','Ð˜Ð¼Ñ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(406546,11293,'es','Tarjeta Nombre(s)',0),(406547,11293,'de','Karte-Vorname',0),(406548,11293,'en','Card First Name',0),(406549,11294,'is','',0),(406550,11294,'dr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ ÙƒØ§Ø±Øª',0),(406551,11294,'pr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ ÙƒØ§Ø±Øª',0),(406552,11294,'tr','Kart soyadÄ±',0),(406553,11294,'pl','Karta nazwisko',0),(406554,11294,'bg','ÐšÐ°Ñ€Ñ‚Ð° Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(406555,11294,'ur','Ú©Ø§Ø±Úˆ Ú©Û’ Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù…',0),(406556,11294,'sr','ÐšÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(406557,11294,'vi','Há» cá»§a tháº»',0),(406558,11294,'af','Kaart Van',0),(406559,11294,'ro','Numele de familie carte',0),(406560,11294,'et','Kaardil olev perekonnanimi',0),(406561,11294,'si','Priimek kartice',0),(406562,11294,'ba','Kartu nama',0),(406563,11294,'nl','Kaart-achternaam',0),(406564,11294,'fi','Kortin sukunimi',0),(406565,11294,'no','Kort etternavn',0),(406566,11294,'da','Kortet efternavn',0),(406567,11294,'ko','ì¹´ë“œ ì„±',0),(406568,11294,'he','×›×¨×˜×™×¡ ×©× ×ž×©×¤×—×”',0),(406569,11294,'el','ÎšÎ¬ÏÏ„Î± ÎµÏ€ÏŽÎ½Ï…Î¼Î¿',0),(406570,11294,'zh','å¡å§“\r\n',0),(406571,11294,'sv','Kort efternamn',0),(406572,11294,'it','Ultimo nome carta',0),(406573,11294,'tl','',0),(406574,11294,'th','à¸™à¸²à¸¡à¸šà¸±à¸•à¸£',0),(406575,11294,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤•à¤¾ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤®',0),(406576,11294,'ms','Kad nama',0),(406577,11294,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£Ø®ÙŠØ±',0),(406578,11294,'fr','Nom de famille de carte',0),(406579,11294,'jp','ã‚«ãƒ¼ãƒ‰ã®æœ€å¾Œã®åå‰',0),(406580,11294,'pt','Ãšltimo nome do cartÃ£o',0),(406581,11294,'ru','Ð¤Ð°Ð¼Ð¸Ð»Ð¸Ñ ÐÐ° ÐšÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐµ',0),(406582,11294,'es','Tarjeta Apellido(s)',0),(406583,11294,'de','Karte-Nachname',0),(406584,11294,'en','Card Last Name',0),(406585,11295,'is','',0),(406586,11295,'dr','Ø§ÙŠØ¬Ø§Ø¯ Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(406587,11295,'pr','Ø§ÙŠØ¬Ø§Ø¯ Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(406588,11295,'tr','Ã–deme talimatlarÄ± olun',0),(406589,11295,'pl','ZrobiÄ‡ instrukcje dotyczÄ…ce pÅ‚atnoÅ›ci',0),(406590,11295,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(406591,11295,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª Ø¯Û’',0),(406592,11295,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ',0),(406593,11295,'vi','lÃ m hÆ°á»›ng dáº«n thanh toÃ¡n',0),(406594,11295,'af','Maak Betaling Instruksies',0),(406595,11295,'ro','Face instrucÅ£iunile de platÄƒ',0),(406596,11295,'et','Tee maksekorraldused',0),(406597,11295,'si','Izdelovanje plaÄilnih navodil',0),(406598,11295,'ba','Membuat instruksi pembayaran',0),(406599,11295,'nl','Betalingsinstructies maken',0),(406600,11295,'fi','TehdÃ¤ maksuohjeet',0),(406601,11295,'no','GjÃ¸re betalingsinstruksjoner',0),(406602,11295,'da','GÃ¸re betalingsinstrukser',0),(406603,11295,'ko','ì§€ë¶ˆ ë°©ë²• í™•ì¸',0),(406604,11295,'he','×œ×”×›×™×Ÿ ×”×•×¨××•×ª ×ª×©×œ×•×',0),(406605,11295,'el','ÎšÎ¬Î½ÎµÎ¹ Î¿Î´Î·Î³Î¯ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(406606,11295,'zh','ä»˜æ¬¾è¯´æ˜Ž\r\n',0),(406607,11295,'sv','GÃ¶ra betalningsinstruktioner',0),(406608,11295,'it','Rendere le istruzioni di pagamento',0),(406609,11295,'tl','',0),(406610,11295,'th','à¹ƒà¸«à¹‰à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(406611,11295,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶ à¤¬à¤¨à¤¾à¤¨à¥‡',0),(406612,11295,'ms','Membuat arahan pembayaran',0),(406613,11295,'ar','Ø¬Ø¹Ù„ ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø³Ø¯Ø§Ø¯',0),(406614,11295,'fr','Faire des Instructions de paiement',0),(406615,11295,'jp','ãŠæ”¯æ‰•ã®æ–¹æ³•ã‚’ä½œã‚‹',0),(406616,11295,'pt','Fazer as instruÃ§Ãµes de pagamento',0),(406617,11295,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(406618,11295,'es','Instrucciones de Hacer Pago',0),(406619,11295,'de','Zahlungsanweisungen zu machen',0),(406620,11295,'en','Make Payment Instructions',0),(406621,11296,'is','',0),(406622,11296,'dr','Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ ',0),(406623,11296,'pr','Ø¨Ø¯ÙˆÙ† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø¬Ø§Ø±ÙŠ ',0),(406624,11296,'tr','HiÃ§bir geÃ§erli fatura',0),(406625,11296,'pl','Nie bieÅ¼Ä…cej faktury',0),(406626,11296,'bg','ÐÑÐ¼Ð° Ñ‚ÐµÐºÑƒÑ‰Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(406627,11296,'ur','Ú©ÙˆØ¦ÛŒ Ø­Ø§Ù„ÛŒÛ ÙˆØ¨Ø¬Ù„ÛŒ',0),(406628,11296,'sr','ÐÐµÐ¼Ð° Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(406629,11296,'vi','khÃ´ng cÃ³ hÃ³a Ä‘Æ¡n hiá»‡n nay',0),(406630,11296,'af','Geen Huidige Fakture',0),(406631,11296,'ro','Nu curent facturi',0),(406632,11296,'et','Praeguse arve',0),(406633,11296,'si','Nobenih sedanjih raÄunov',0),(406634,11296,'ba','Faktur tidak saat ini',0),(406635,11296,'nl','Geen huidige facturen',0),(406636,11296,'fi','Nykyinen laskuja',0),(406637,11296,'no','Ingen gjeldende fakturaer',0),(406638,11296,'da','Ingen aktuelle fakturaer',0),(406639,11296,'ko','ì•„ë‹ˆ í˜„ìž¬ ì²­êµ¬ì„œ',0),(406640,11296,'he','××™×Ÿ ×—×©×‘×•× ×™×•×ª ×”× ×•×›×—×™',0),(406641,11296,'el','Î”ÎµÎ½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(406642,11296,'zh','æ²¡æœ‰å½“å‰å‘ç¥¨\r\n',0),(406643,11296,'sv','Inga aktuella fakturor',0),(406644,11296,'it','Nessuna corrente fatture',0),(406645,11296,'tl','',0),(406646,11296,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(406647,11296,'hi','à¤•à¥‹à¤ˆ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤šà¤¾à¤²à¤¾à¤¨',0),(406648,11296,'ms','Tiada invois semasa',0),(406649,11296,'ar','Ù„Ø§ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(406650,11296,'fr','Aucune facture actuelle',0),(406651,11296,'jp','ç¾åœ¨ã®è«‹æ±‚æ›¸ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(406652,11296,'pt','NÃ£o hÃ¡ facturas atuais',0),(406653,11296,'ru','ÐÐµÑ‚ Ð¢ÐµÐºÑƒÑ‰Ð¸Ñ… Ð¡Ñ‡ÐµÑ‚Ð¾Ð²',0),(406654,11296,'es','No Hay Facturas Actuales',0),(406655,11296,'de','Keine aktuellen Rechnungen',0),(406656,11296,'en','No Current Invoices',0),(406657,11297,'is','',0),(406658,11297,'dr','Ù‡ÙŠÚ† Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®ØªÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯',0),(406659,11297,'pr','Ù‡ÙŠÚ† Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®ØªÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯',0),(406660,11297,'tr','Ã–deme tutarÄ± ayarlanmadÄ±',0),(406661,11297,'pl','Nie zestaw kwota pÅ‚atnoÅ›ci',0),(406662,11297,'bg','ÐÑÐ¼Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÑÑƒÐ¼Ð° Ð½Ð°Ð±Ð¾Ñ€',0),(406663,11297,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù‚Ù… Ù…Ù‚Ø±Ø±',0),(406664,11297,'sr','ÐÐµÐ¼Ð° Ð¡ÐµÑ‚ Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(406665,11297,'vi','khÃ´ng táº­p há»£p sá»‘ thanh toÃ¡n',0),(406666,11297,'af','Geen Betalingsbedrag Gestel',0),(406667,11297,'ro','Nici un Set de suma de platÄƒ',0),(406668,11297,'et','Makse summa komplekt',0),(406669,11297,'si','Ni nastavljenega znesek plaÄila',0),(406670,11297,'ba','Tidak ada pembayaran jumlah Set',0),(406671,11297,'nl','Geen betaling bedrag Set',0),(406672,11297,'fi','Ei maksun summa asetettu',0),(406673,11297,'no','Ingen betaling belÃ¸pet sett',0),(406674,11297,'da','Ingen betaling belÃ¸b sÃ¦t',0),(406675,11297,'ko','ê²°ì œ ê¸ˆì•¡ ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(406676,11297,'he','×œ× ×”×•×’×“×¨×• ×¡×›×•× ×”×ª×©×œ×•×',0),(406677,11297,'el','ÎšÎ±Î½Î­Î½Î± ÏƒÏÎ½Î¿Î»Î¿ Ï€Î¿ÏƒÏŒ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(406678,11297,'zh','æ²¡æœ‰è®¾ç½®çš„æ”¯ä»˜é‡‘é¢\r\n',0),(406679,11297,'sv','Ingen betalning belopp uppsÃ¤ttning',0),(406680,11297,'it','Nessun pagamento importo Set',0),(406681,11297,'tl','',0),(406682,11297,'th','à¹„à¸¡à¹ˆà¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸ˆà¸³à¸™à¸§à¸™à¸Šà¸¸à¸”',0),(406683,11297,'hi','à¤•à¥‹à¤ˆ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡à¤Ÿ',0),(406684,11297,'ms','Tanpa menetapkan jumlah bayaran',0),(406685,11297,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù„Ø¯ÙØ¹',0),(406686,11297,'fr','Aucun ensemble de montant de paiement',0),(406687,11297,'jp','ãŠæ”¯æ‰•ã„é¡ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(406688,11297,'pt','Nenhum conjunto de quantidade de pagamento',0),(406689,11297,'ru','ÐÐµ Ð½Ð°Ð±Ð¾Ñ€ ÑÑƒÐ¼Ð¼Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(406690,11297,'es','Cantidad Por Pagar no Establecido',0),(406691,11297,'de','Keine Zahlung Betrag festgelegt',0),(406692,11297,'en','No Payment Amount Set',0),(406693,11298,'is','',0),(406694,11298,'dr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ÙŠ Ø¨Ø§Ø²',0),(406695,11298,'pr','ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ ÙŠ Ø¨Ø§Ø²',0),(406696,11298,'tr','AÃ§Ä±k faturalar',0),(406697,11298,'pl','Otwartych rachunkÃ³w',0),(406698,11298,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(406699,11298,'ur','Ú©Ú¾Ù„ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ',0),(406700,11298,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(406701,11298,'vi','Má»Ÿ hÃ³a Ä‘Æ¡n',0),(406702,11298,'af','Oop Fakture',0),(406703,11298,'ro','Facturilor deschise',0),(406704,11298,'et','Avatud arved',0),(406705,11298,'si','Odprtih raÄunov',0),(406706,11298,'ba','Faktur yang terbuka',0),(406707,11298,'nl','Openstaande facturen',0),(406708,11298,'fi','Avoimet laskut',0),(406709,11298,'no','Ã…pne fakturaer',0),(406710,11298,'da','Ã…bne fakturaer',0),(406711,11298,'ko','ì˜¤í”ˆ ì¸ë³´ì´ìŠ¤',0),(406712,11298,'he','×—×©×‘×•× ×™×•×ª ×¤×ª×•×—×•×ª',0),(406713,11298,'el','Î‘Î½Î¿Î¹ÎºÏ„Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(406714,11298,'zh','å¼€ä¸“ç”¨å‘ç¥¨\r\n',0),(406715,11298,'sv','Ã–ppna fakturor',0),(406716,11298,'it','Fatture aperte',0),(406717,11298,'tl','',0),(406718,11298,'th','à¹€à¸›à¸´à¸”à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(406719,11298,'hi','à¤–à¥à¤²à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(406720,11298,'ms','Invois yang terbuka',0),(406721,11298,'ar','ÙÙˆØ§ØªÙŠØ± Ù…ÙØªÙˆØ­Ø©',0),(406722,11298,'fr','Factures ouvertes',0),(406723,11298,'jp','ã‚ªãƒ¼ãƒ—ãƒ³è«‹æ±‚',0),(406724,11298,'pt','Faturas em aberto',0),(406725,11298,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð¡Ñ‡ÐµÑ‚Ð°',0),(406726,11298,'es','Facturas Abiertas',0),(406727,11298,'de','Offene Rechnungen',0),(406728,11298,'en','Open Invoices',0),(406729,11299,'is','',0),(406730,11299,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(406731,11299,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(406732,11299,'tr','Ã–deme baÅŸarÄ±yla eklendi',0),(406733,11299,'pl','PÅ‚atnoÅ›ci dodane pomyÅ›lnie',0),(406734,11299,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(406735,11299,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(406736,11299,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(406737,11299,'vi','ÄÃ£ thÃªm thanh toÃ¡n thÃ nh cÃ´ng',0),(406738,11299,'af','Betaling Suksesvol Bygevoeg',0),(406739,11299,'ro','Plata adÄƒugat cu succes',0),(406740,11299,'et','Makse edukalt lisatud',0),(406741,11299,'si','PlaÄilo uspeÅ¡no dodani',0),(406742,11299,'ba','Pembayaran ditambahkan berhasil',0),(406743,11299,'nl','Betaling met succes toegevoegd',0),(406744,11299,'fi','Maksun lisÃ¤Ã¤minen onnistui',0),(406745,11299,'no','Betaling lagt',0),(406746,11299,'da','Betaling tilfÃ¸jet',0),(406747,11299,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì§€ë¶ˆ',0),(406748,11299,'he','×ª×©×œ×•× × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(406749,11299,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(406750,11299,'zh','ä»˜æ¬¾æˆåŠŸæ·»åŠ \r\n',0),(406751,11299,'sv','Betalningen lagts',0),(406752,11299,'it','Pagamento aggiunto con successo',0),(406753,11299,'tl','',0),(406754,11299,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(406755,11299,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(406756,11299,'ms','Pembayaran berjaya menambah',0),(406757,11299,'ar','Ø§Ù„Ø¯ÙØ¹ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(406758,11299,'fr','Paiement ajoutÃ© avec succÃ¨s',0),(406759,11299,'jp','ãŠæ”¯æ‰•ã„ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(406760,11299,'pt','Pagamento adicionado com sucesso',0),(406761,11299,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(406762,11299,'es','Pago Agregado Exitosamente',0),(406763,11299,'de','Zahlung erfolgreich hinzugefÃ¼gt',0),(406764,11299,'en','Payment Added Successfully',0),(406765,11300,'is','',0),(406766,11300,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ø§Ù‡ Ø§Ù†Ù‚Ø¶Ø§Ø¡ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406767,11300,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ø§Ù‡ Ø§Ù†Ù‚Ø¶Ø§Ø¡ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406768,11300,'tr','Bir sÃ¼re sonu ay girmeniz gerekir',0),(406769,11300,'pl','Musisz wpisaÄ‡ miesiÄ…c wygaÅ›niÄ™cia',0),(406770,11300,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ Ð¼ÐµÑÐµÑ†',0),(406771,11300,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù…Ø¯Øª Ù…ÛÛŒÙ†Û Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(406772,11300,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ñ˜ÐµÐ´Ð°Ð½ Ð¼ÐµÑÐµÑ† Ð¸ÑÑ‚Ð¸Ñ†Ð°ÑšÐ° Ñ€Ð¾ÐºÐ° Ð²Ð°Ð¶ÐµÑšÐ°',0),(406773,11300,'vi','Báº¡n pháº£i nháº­p thÃ¡ng háº¿t háº¡n',0),(406774,11300,'af','U moet \'n Vervalmaand Invoer',0),(406775,11300,'ro','Trebuie sÄƒ introduceÅ£i o luna de expirare',0),(406776,11300,'et','Peate sisestama lÃµppemise kuu',0),(406777,11300,'si','Vnesti morate poteka mesec',0),(406778,11300,'ba','Anda harus memasukkan bulan kadaluarsa',0),(406779,11300,'nl','U moet een vervaldatum maand invoeren',0),(406780,11300,'fi','Anna kulunut kuukausi',0),(406781,11300,'no','Du mÃ¥ angi en gyldig til mÃ¥ned',0),(406782,11300,'da','Du skal angive en udlÃ¸bsmÃ¥neden',0),(406783,11300,'ko','ë§Œë£Œ ë‹¬ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(406784,11300,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×—×•×“×© ×”×ª×¤×•×’×”',0),(406785,11300,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Î¼Î®Î½Î± Î»Î®Î¾Î·Ï‚',0),(406786,11300,'zh','æ‚¨å¿…é¡»è¾“å…¥åˆ°æœŸæœˆä»½\r\n\r\næ‚¨å¿…é¡»è¾“å…¥åˆ°æœŸæœˆä»½\r\n\r\næ‚¨å¿…é¡»è¾“å…¥åˆ°æœŸæœˆä»½\r\n\r\næ‚¨å¿…é¡»è¾“å…¥åˆ°æœŸæœˆä»½\r\n\r\næ‚¨å¿…é¡»è¾“å…¥åˆ°æœŸæœˆä»½\r\n\r\næ‚¨å¿…é¡»è¾“å…¥åˆ°æœŸæœˆä»½\r\n\r\næ‚¨å¿…é¡»è¾“å…¥åˆ°æœŸæœˆä»½\r\n\r\næ‚¨å¿…é¡»è¾“å…¥åˆ°æœŸæœˆä»½\r\n\r\næ‚¨å¿…ï',0),(406787,11300,'sv','Du mÃ¥ste ange ett fÃ¶rfallodatum mÃ¥nad',0),(406788,11300,'it','Ãˆ necessario immettere un mese di scadenza',0),(406789,11300,'tl','',0),(406790,11300,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¹€à¸”à¸·à¸­à¸™à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(406791,11300,'hi','à¤†à¤ª à¤à¤• à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤®à¤¾à¤¹ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(406792,11300,'ms','Anda mesti masukkan bulan tamat tempoh untuk',0),(406793,11300,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø¯Ø© Ø´Ù‡Ø± Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØµÙ„Ø§Ø­ÙŠØ©',0),(406794,11300,'fr','Vous devez entrer un mois de fin.',0),(406795,11300,'jp','æœ‰åŠ¹æœŸé™ã®æœˆã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(406796,11300,'pt','VocÃª deve digitar um mÃªs de vencimento',0),(406797,11300,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ ÑÑ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð¼ÐµÑÑÑ†',0),(406798,11300,'es','Debe Entrar Un Mes de Vencimiento',0),(406799,11300,'de','Sie mÃ¼ssen eine Ablaufmonat eingeben.',0),(406800,11300,'en','You Must Enter An Expiration Month',0),(406801,11301,'is','',0),(406802,11301,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ø§Ù„  Ø§Ù†Ù‚Ø¶Ø§Ø¡ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406803,11301,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³Ø§Ù„  Ø§Ù†Ù‚Ø¶Ø§Ø¡ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406804,11301,'tr','Sona erme yÄ±l girmeniz gerekir',0),(406805,11301,'pl','Musisz podaÄ‡ rok wygaÅ›niÄ™cia',0),(406806,11301,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð³Ð¾Ð´Ð¸Ð½Ð° Ð½Ð° ÑÐ²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ',0),(406807,11301,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù…Ø¯Øª Ø³Ø§Ù„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(406808,11301,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ñƒ Ð¸ÑÑ‚ÐµÐºÐ° Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(406809,11301,'vi','Báº¡n pháº£i nháº­p nÄƒm háº¿t háº¡n',0),(406810,11301,'af','U moet \'n Vervaljaar Invoer',0),(406811,11301,'ro','Trebuie sÄƒ introduceÅ£i un an expirare',0),(406812,11301,'et','Peate sisestama tÃ¤htaja mÃ¶Ã¶dumine aastal',0),(406813,11301,'si','Vnesti morate poteka leto',0),(406814,11301,'ba','Anda harus memasukkan tahun kadaluarsa',0),(406815,11301,'nl','U moet een jaar vervaldatum opgeven',0),(406816,11301,'fi','Anna viimeinen vuosi',0),(406817,11301,'no','Du mÃ¥ angi en utlÃ¸psdato Ã¥r',0),(406818,11301,'da','Du skal angive en udlÃ¸bsdato Ã¥r',0),(406819,11301,'ko','ë§Œë£Œ ì—°ë„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(406820,11301,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ××ª ×”×©× ×” ×ª×¤×•×’×”',0),(406821,11301,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Î­Ï„Î¿Ï‚ Î»Î®Î¾Î·Ï‚',0),(406822,11301,'zh','æ‚¨å¿…é¡»è¾“å…¥åˆ°æœŸå¹´ä»½\r\n',0),(406823,11301,'sv','Du mÃ¥ste ange ett fÃ¶rfallodatum Ã¥r',0),(406824,11301,'it','Ãˆ necessario inserire un anno di scadenza',0),(406825,11301,'tl','',0),(406826,11301,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸›à¸µà¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¸à¸²à¸£',0),(406827,11301,'hi','à¤†à¤ª à¤à¤• à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤µà¤°à¥à¤· à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(406828,11301,'ms','Anda mesti masukkan satu tahun tamat',0),(406829,11301,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø¯Ø© Ø³Ù†Ø© Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØµÙ„Ø§Ø­ÙŠØ©',0),(406830,11301,'fr','Vous devez entrer une annÃ©e de fin.',0),(406831,11301,'jp','æœ‰åŠ¹æœŸé™ã®å¹´ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(406832,11301,'pt','VocÃª deve digitar um ano de validade',0),(406833,11301,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð³Ð¾Ð´ Ð¸ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ñ ÑÑ€Ð¾ÐºÐ° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(406834,11301,'es','Debe Entrar Un AÃ±o de Vencimiento',0),(406835,11301,'de','Sie mÃ¼ssen eine Ablaufjahr eingeben.',0),(406836,11301,'en','You Must Enter An Expiration Year',0),(406837,11302,'is','',0),(406838,11302,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¢Ø¯Ø±Ø³ Ø¨Ø±Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406839,11302,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¢Ø¯Ø±Ø³ Ø¨Ø±Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406840,11302,'tr','Fatura adresi girmelisiniz',0),(406841,11302,'pl','NaleÅ¼y wprowadziÄ‡ adres fakturowania',0),(406842,11302,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð°Ð´Ñ€ÐµÑ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(406843,11302,'ur','Ø¢Ù¾ Ù†Û’ Ø§ÛŒÚ© Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø¹Ù†ÙˆØ§Ù† Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(406844,11302,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð°Ð´Ñ€ÐµÑÑƒ Ð·Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ñƒ',0),(406845,11302,'vi','Báº¡n pháº£i nháº­p Ä‘á»‹a chá»‰ thanh toÃ¡n',0),(406846,11302,'af','U Moet \'n Verekeningsadres Invoer',0),(406847,11302,'ro','Trebuie sÄƒ introduceÅ£i o adresÄƒ de facturare',0),(406848,11302,'et','Sisestage arve esitamise aadress',0),(406849,11302,'si','Vnesite naslov za zaraÄunavanje',0),(406850,11302,'ba','Anda harus memasukkan alamat penagihan',0),(406851,11302,'nl','Moet u een factuuradres',0),(406852,11302,'fi','Anna laskutusosoite',0),(406853,11302,'no','Du mÃ¥ angi en faktureringsadresse',0),(406854,11302,'da','Du skal angive en faktureringsadresse',0),(406855,11302,'ko','ëŒ€ê¸ˆ ì²­êµ¬ ì£¼ì†Œë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(406856,11302,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×›×ª×•×‘×ª ×—×™×•×‘',0),(406857,11302,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ Î¼Î¹Î± Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(406858,11302,'zh','æ‚¨å¿…é¡»è¾“å…¥å¸å•åœ°å€\r\n',0),(406859,11302,'sv','Du mÃ¥ste ange en faktureringsadress',0),(406860,11302,'it','Ãˆ necessario immettere un indirizzo di fatturazione',0),(406861,11302,'tl','',0),(406862,11302,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(406863,11302,'hi','à¤†à¤ª à¤à¤• à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤ªà¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(406864,11302,'ms','Anda mesti masukkan alamat bil',0),(406865,11302,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„ÙÙˆØªØ±Ø©',0),(406866,11302,'fr','Vous devez entrer une adresse de facturation.',0),(406867,11302,'jp','è«‹æ±‚å…ˆä½æ‰€ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(406868,11302,'pt','VocÃª deve digitar um endereÃ§o de facturaÃ§Ã£o',0),(406869,11302,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð°Ð´Ñ€ÐµÑ Ð´Ð»Ñ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°',0),(406870,11302,'es','Debe Entrar Una DirecciÃ³n de FacturaciÃ³n',0),(406871,11302,'de','Sie mÃ¼ssen eine Rechnungsadresse eingeben.',0),(406872,11302,'en','You Must Enter A Billing Address',0),(406873,11303,'is','',0),(406874,11303,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ù‡Ø±Ø¨Ø±Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨   ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406875,11303,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø´Ù‡Ø±Ø¨Ø±Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨   ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406876,11303,'tr','Bir fatura ÅŸehir girmeniz gerekir',0),(406877,11303,'pl','Musisz wpisaÄ‡ miasto rozliczeÅ„',0),(406878,11303,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ, Ð³Ñ€Ð°Ð´',0),(406879,11303,'ur','Ø¢Ù¾ Ù†Û’ Ø§ÛŒÚ© Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø´ÛØ± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(406880,11303,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð³Ñ€Ð°Ð´ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(406881,11303,'vi','Báº¡n pháº£i nháº­p thÃ nh phá»‘ thanh toÃ¡n',0),(406882,11303,'af','U Moet \'n Verekening Stad/Dorp Invoer',0),(406883,11303,'ro','Trebuie sÄƒ introduceÅ£i un oraÅŸ de facturare',0),(406884,11303,'et','Sisestage arvete City',0),(406885,11303,'si','Morate vnesti naslov plaÄnika â€“ mesto',0),(406886,11303,'ba','Anda harus memasukkan sebuah kota penagihan',0),(406887,11303,'nl','U moet een facturering plaats opgeven',0),(406888,11303,'fi','SyÃ¶tÃ¤ laskutus kaupunki',0),(406889,11303,'no','Du mÃ¥ angi en faktureringsadresse, poststed',0),(406890,11303,'da','Du skal angive en fakturering byen',0),(406891,11303,'ko','ê²°ì œ ì‹œ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(406892,11303,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×¢×™×¨ ×—×™×•×‘',0),(406893,11303,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Ï€ÏŒÎ»Î· Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(406894,11303,'zh','æ‚¨å¿…é¡»è¾“å…¥å¸å•åŸŽå¸‚\r\n',0),(406895,11303,'sv','Du mÃ¥ste ange en fakturering stad',0),(406896,11303,'it','Ãˆ necessario immettere una cittÃ  di fatturazione',0),(406897,11303,'tl','',0),(406898,11303,'th','à¸•à¹‰à¸­à¸‡à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¹€à¸¡à¸·à¸­à¸‡',0),(406899,11303,'hi','à¤†à¤ªà¤•à¥‹ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ à¤à¤• à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤¶à¤¹à¤°',0),(406900,11303,'ms','Anda mesti masukkan bandar bil',0),(406901,11303,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø¯ÙŠÙ†Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(406902,11303,'fr','Vous devez entrer une ville de facturation.',0),(406903,11303,'jp','è«‹æ±‚ã®éƒ½å¸‚ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(406904,11303,'pt','VocÃª deve digitar uma cidade de faturamento',0),(406905,11303,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð³Ð¾Ñ€Ð¾Ð´ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³',0),(406906,11303,'es','Debe Entrar Una Ciudad de FacturaciÃ³n',0),(406907,11303,'de','Sie mÃ¼ssen eine Abrechnung Stadt eingeben.',0),(406908,11303,'en','You Must Enter A Billing City',0),(406909,11304,'is','',0),(406910,11304,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø§Ø³ØªØ§Ù† Ø¨Ø±Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406911,11304,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø§Ø³ØªØ§Ù† Ø¨Ø±Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406912,11304,'tr','Fatura durumu girmeniz gerekir',0),(406913,11304,'pl','NaleÅ¼y wprowadziÄ‡ stan rozliczeÅ„',0),(406914,11304,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ, Ñ‰Ð°Ñ‚',0),(406915,11304,'ur','Ø¢Ù¾ Ù†Û’ Ø§ÛŒÚ© Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø±ÛŒØ§Ø³Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(406916,11304,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ñƒ ÑÑ‚Ð°ÑšÐµ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(406917,11304,'vi','Báº¡n pháº£i nháº­p tÃ¬nh tráº¡ng thanh toÃ¡n',0),(406918,11304,'af','U Moet \'n Verekening Staat Invoer',0),(406919,11304,'ro','Trebuie sÄƒ introduceÅ£i o stare de facturare',0),(406920,11304,'et','Peate sisestama arveldusaadressi osariik',0),(406921,11304,'si','Morate vnesti naslov plaÄnika â€“ drÅ¾ava',0),(406922,11304,'ba','Anda harus memasukkan negara penagihan',0),(406923,11304,'nl','U moet een facturatie provincie opgeven',0),(406924,11304,'fi','Sinun tÃ¤ytyy syÃ¶ttÃ¤Ã¤ Laskutusosoitteen osavaltio',0),(406925,11304,'no','Du mÃ¥ angi en fakturering tilstand',0),(406926,11304,'da','Du skal angive en fakturering tilstand',0),(406927,11304,'ko','ê²°ì œ ìƒíƒœë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(406928,11304,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ž×¦×‘ ×—×™×•×‘',0),(406929,11304,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Î¼Î­Î»Î¿Ï‚ Ï„Î·Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(406930,11304,'zh','æ‚¨å¿…é¡»è¾“å…¥å¸å•çŠ¶æ€\r\n',0),(406931,11304,'sv','Du mÃ¥ste ange en fakturering stat',0),(406932,11304,'it','Deve entrare in uno stato di fatturazione',0),(406933,11304,'tl','',0),(406934,11304,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(406935,11304,'hi','à¤†à¤ª à¤à¤• à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤°à¤¾à¤œà¥à¤¯ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(406936,11304,'ms','Anda mesti memasukkan Negeri bil',0),(406937,11304,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø­Ø§Ù„Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(406938,11304,'fr','Vous devez entrer une Ã©tat de facturation.',0),(406939,11304,'jp','èª²é‡‘çŠ¶æ…‹ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(406940,11304,'pt','VocÃª deve entrar em um estado de faturamento',0),(406941,11304,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ñ…Ð¾Ð´Ð¸Ñ‚ÑŒ Ð’ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(406942,11304,'es','Debe Entrar Un Estado de FacturaciÃ³n',0),(406943,11304,'de','Sie mÃ¼ssen ein Bundesland eingeben.',0),(406944,11304,'en','You Must Enter A Billing State',0),(406945,11305,'is','',0),(406946,11305,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø¨Ø±Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406947,11305,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø¨Ø±Ø§ÙŠ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406948,11305,'tr','Fatura ZIP girmeniz gerekir',0),(406949,11305,'pl','NaleÅ¼y wprowadziÄ‡ rozliczenia Zip',0),(406950,11305,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ Zip',0),(406951,11305,'ur','Ø¢Ù¾ Ù†Û’ Ø§ÛŒÚ© Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø²Ù¾ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(406952,11305,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð—Ð¸Ð¿',0),(406953,11305,'vi','Báº¡n pháº£i nháº­p 1 Zip thanh toÃ¡n',0),(406954,11305,'af','U Moet \'n Verekening Poskode Invoer',0),(406955,11305,'ro','Trebuie sÄƒ introduceÅ£i un Zip de facturare',0),(406956,11305,'et','Sisestage arvete Zip',0),(406957,11305,'si','Vnesti morate zaraÄunavanje Zip',0),(406958,11305,'ba','Anda harus memasukkan Zip penagihan',0),(406959,11305,'nl','U moet een Zip facturering invoeren',0),(406960,11305,'fi','Anna laskutuksen Zip',0),(406961,11305,'no','Du mÃ¥ angi en fakturering Zip',0),(406962,11305,'da','Du skal angive en fakturering Zip',0),(406963,11305,'ko','ëŒ€ê¸ˆ ì²­êµ¬ ìš°íŽ¸ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(406964,11305,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ Zip ×—×™×•×‘',0),(406965,11305,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Zip Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(406966,11305,'zh','æ‚¨å¿…é¡»è¾“å…¥å¸å•é‚®ç¼–\r\n',0),(406967,11305,'sv','Du mÃ¥ste ange en fakturering Zip',0),(406968,11305,'it','Ãˆ necessario immettere una Zip di fatturazione',0),(406969,11305,'tl','',0),(406970,11305,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(406971,11305,'hi','à¤†à¤ªà¤•à¥‹ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ à¤à¤• à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤œà¤¼à¤¿à¤ª',0),(406972,11305,'ms','Anda mesti masukkan Zip bil',0),(406973,11305,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø±Ù…Ø² Ø¨Ø±ÙŠØ¯ÙŠ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(406974,11305,'fr','Vous devez entrer un code postal de facturation.',0),(406975,11305,'jp','è«‹æ±‚å…ˆéƒµä¾¿ç•ªå·ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(406976,11305,'pt','VocÃª deve inserir um Zip de faturamento',0),(406977,11305,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³ Zip',0),(406978,11305,'es','Debe Entrar Un CÃ³digo Postal de FacturaciÃ³n',0),(406979,11305,'de','Sie mÃ¼ssen eine Billing-Zip eingeben.',0),(406980,11305,'en','You Must Enter A Billing Zip',0),(406981,11306,'is','',0),(406982,11306,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙƒØ¯ ÙƒØ§Ø±Øª ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406983,11306,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙƒØ¯ ÙƒØ§Ø±Øª ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(406984,11306,'tr','Bir kart kodu girmelisiniz',0),(406985,11306,'pl','NaleÅ¼y wprowadziÄ‡ kod karty',0),(406986,11306,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ð´ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(406987,11306,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§ÛŒÚ© Ú©Ø§Ø±Úˆ Ú©ÙˆÚˆ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(406988,11306,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(406989,11306,'vi','Báº¡n pháº£i nháº­p mÃ£ tháº»',0),(406990,11306,'af','U Moet \'n Kaart Kode Invoer',0),(406991,11306,'ro','Trebuie sÄƒ introduceÅ£i un cod de carte',0),(406992,11306,'et','Sisestage kaardi kood',0),(406993,11306,'si','Vnesti morate kodo kartice',0),(406994,11306,'ba','Anda harus memasukkan kode kartu',0),(406995,11306,'nl','U moet een kaart-Code invoeren',0),(406996,11306,'fi','Sinun tÃ¤ytyy syÃ¶ttÃ¤Ã¤ kortin koodi',0),(406997,11306,'no','Du mÃ¥ angi en kode',0),(406998,11306,'da','Du skal angive en kort kode',0),(406999,11306,'ko','ì¹´ë“œ ì½”ë“œë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(407000,11306,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×§×•×“ ×”×›×¨×˜×™×¡',0),(407001,11306,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï„Î·Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(407002,11306,'zh','æ‚¨å¿…é¡»è¾“å…¥å¡ä»£ç \r\n',0),(407003,11306,'sv','Du mÃ¥ste ange en kort kod',0),(407004,11306,'it','Ãˆ necessario inserire un codice di carta',0),(407005,11306,'tl','',0),(407006,11306,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸£à¸«à¸±à¸ªà¸šà¸±à¸•à¸£',0),(407007,11306,'hi','à¤†à¤ª à¤à¤• à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‹à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(407008,11306,'ms','Anda mesti masukkan kod Kad',0),(407009,11306,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù…Ø² Ø§Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(407010,11306,'fr','Vous devez entrer un code de carte.',0),(407011,11306,'jp','ã‚«ãƒ¼ãƒ‰ã®ã‚³ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(407012,11306,'pt','VocÃª deve digitar um cÃ³digo do cartÃ£o',0),(407013,11306,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ ÐºÐ¾Ð´ ÐºÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(407014,11306,'es','Debe Entrar Un CÃ³digo de Tarjeta',0),(407015,11306,'de','Sie mÃ¼ssen einen Card-Code eingeben.',0),(407016,11306,'en','You Must Enter A Card Code',0),(407017,11307,'is','',0),(407018,11307,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(407019,11307,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(407020,11307,'tr','Kredi kartÄ± numarasÄ± girmelisiniz',0),(407021,11307,'pl','NaleÅ¼y wprowadziÄ‡ numer karty kredytowej',0),(407022,11307,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(407023,11307,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(407024,11307,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð±Ñ€Ð¾Ñ˜ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(407025,11307,'vi','Báº¡n Pháº£i Nháº­p sá»‘ tháº» tÃ­n dá»¥ng',0),(407026,11307,'af','U Moet \'n Kredietkaart Nommer Invoer',0),(407027,11307,'ro','Trebuie sÄƒ introduceÅ£i un numÄƒr de Card de Credit',0),(407028,11307,'et','Sisestage krediitkaardi Number',0),(407029,11307,'si','Morate vnesti Å¡tevilko kreditne kartice',0),(407030,11307,'ba','Anda harus memasukkan nomor kartu kredit',0),(407031,11307,'nl','Moet u een Credit cardnummer',0),(407032,11307,'fi','Anna luottokorttinumero',0),(407033,11307,'no','Du mÃ¥ angi et kredittkortnummer',0),(407034,11307,'da','Du skal angive et kreditkortnummer',0),(407035,11307,'ko','ì‹ ìš© ì¹´ë“œ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(407036,11307,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ž×¡×¤×¨ ×›×¨×˜×™×¡ ××©×¨××™',0),(407037,11307,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(407038,11307,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¿¡ç”¨å¡å·ç \r\n',0),(407039,11307,'sv','Du mÃ¥ste ange ett kreditkortsnummer',0),(407040,11307,'it','Ãˆ necessario immettere un numero di carta di credito',0),(407041,11307,'tl','',0),(407042,11307,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(407043,11307,'hi','à¤†à¤ª à¤à¤• à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¨à¤‚à¤¬à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(407044,11307,'ms','Anda mesti masukkan nombor kad kredit',0),(407045,11307,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(407046,11307,'fr','Vous devez entrer un numÃ©ro de carte de crÃ©dit.',0),(407047,11307,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ç•ªå·ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(407048,11307,'pt','VocÃª deve digitar um nÃºmero de cartÃ£o de crÃ©dito',0),(407049,11307,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ ÐÐ¾Ð¼ÐµÑ€ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ñ‹',0),(407050,11307,'es','Debe Entrar Un NÃºmero de Tarjeta de CrÃ©dito',0),(407051,11307,'de','Sie mÃ¼ssen eine Kreditkartennummer eingeben.',0),(407052,11307,'en','You Must Enter A Credit Card Number',0),(407053,11308,'is','',0),(407054,11308,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(407055,11308,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(407056,11308,'tr','Bir ad girmelisiniz',0),(407057,11308,'pl','NaleÅ¼y wprowadziÄ‡ imiÄ™',0),(407058,11308,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ Ð¸Ð¼Ðµ',0),(407059,11308,'ur','Ø¢Ù¾ Ù†Û’ Ù¾ÛÙ„Ø§ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(407060,11308,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð¼Ðµ',0),(407061,11308,'vi','Báº¡n pháº£i nháº­p tÃªn riÃªng',0),(407062,11308,'af','U moet \'n Voornaam Invoer',0),(407063,11308,'ro','Trebuie sÄƒ introduceÅ£i un nume',0),(407064,11308,'et','Sisestage eesnimi',0),(407065,11308,'si','Vnesti morate ime prve',0),(407066,11308,'ba','Anda harus memasukkan nama pertama',0),(407067,11308,'nl','U moet een eerste naam invoeren',0),(407068,11308,'fi','Kirjoita etunimi',0),(407069,11308,'no','Du mÃ¥ angi et fornavn',0),(407070,11308,'da','Du skal angive et fornavn',0),(407071,11308,'ko','ì²« ë²ˆì§¸ ì´ë¦„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(407072,11308,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×©× ×¤×¨×˜×™',0),(407073,11308,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î±',0),(407074,11308,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªåå­—\r\n',0),(407075,11308,'sv','Du mÃ¥ste ange ett fÃ¶rnamn',0),(407076,11308,'it','Ãˆ necessario immettere un nome',0),(407077,11308,'tl','',0),(407078,11308,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­',0),(407079,11308,'hi','à¤†à¤ª à¤•à¤¿à¤¸à¥€ à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(407080,11308,'ms','Anda mesti masukkan nama pertama',0),(407081,11308,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ¯Ø®Ù„ Ø§Ù„Ø¥Ø³Ù… Ø§Ù„Ø£ÙˆÙ„',0),(407082,11308,'fr','Vous devez entrer un prÃ©nom.',0),(407083,11308,'jp','æœ€åˆã®åå‰ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(407084,11308,'pt','VocÃª deve digitar um nome',0),(407085,11308,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ Ð˜Ð¼Ñ ',0),(407086,11308,'es','Debe Entrar Un Nombre',0),(407087,11308,'de','Sie mÃ¼ssen einen Vornamen eingeben.',0),(407088,11308,'en','You Must Enter A First Name',0),(407089,11309,'is','',0),(407090,11309,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(407091,11309,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(407092,11309,'tr','Soy adÄ± girmelisiniz',0),(407093,11309,'pl','NaleÅ¼y wpisaÄ‡ nazwisko',0),(407094,11309,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(407095,11309,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(407096,11309,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ ÑƒÐ½ÐµÑ‚Ð¸ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(407097,11309,'vi','Báº¡n pháº£i nháº­p tÃªn há»',0),(407098,11309,'af','U moet \'n Van Invoer',0),(407099,11309,'ro','Trebuie sÄƒ introduceÅ£i un nume de familie',0),(407100,11309,'et','Sisestage Viimane nimi',0),(407101,11309,'si','Vnesite priimek',0),(407102,11309,'ba','Anda harus memasukkan nama terakhir',0),(407103,11309,'nl','U moet een achternaam invoeren',0),(407104,11309,'fi','Kirjoita sukunimi',0),(407105,11309,'no','Du mÃ¥ angi et etternavn',0),(407106,11309,'da','Du skal angive et efternavn',0),(407107,11309,'ko','ë§ˆì§€ë§‰ ì´ë¦„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(407108,11309,'he','×¢×œ×™×š ×œ×”×›× ×™×¡ ×©× ×ž×©×¤×—×”',0),(407109,11309,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± ÎµÏ€ÏŽÎ½Ï…Î¼Î¿',0),(407110,11309,'zh','æ‚¨å¿…é¡»è¾“å…¥å§“æ°\r\n',0),(407111,11309,'sv','Du mÃ¥ste ange ett efternamn',0),(407112,11309,'it','Ãˆ necessario immettere un cognome',0),(407113,11309,'tl','',0),(407114,11309,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹ƒà¸ªà¹ˆà¸™à¸²à¸¡à¸ªà¸à¸¸à¸¥',0),(407115,11309,'hi','à¤¤à¥à¤® à¤à¤• à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(407116,11309,'ms','Anda harus masukkan nama terakhir',0),(407117,11309,'ar','ÙŠØ¬Ø¨ Ø§Ù† ØªØ¯Ø®Ù„ Ø§Ø¥Ø³Ù… Ø§Ù„Ø£Ø®ÙŠØ±',0),(407118,11309,'fr','Vous devez entrer un nom.',0),(407119,11309,'jp','æœ€å¾Œã®åå‰ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(407120,11309,'pt','VocÃª deve digitar um nome de Ãºltimo',0),(407121,11309,'ru','Ð’Ñ‹ Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð’Ð²ÐµÑÑ‚Ð¸ Ð¤Ð°Ð¼Ð¸Ð»Ð¸ÑŽ',0),(407122,11309,'es','Debe Entrar Un Apellido',0),(407123,11309,'de','Sie mÃ¼ssen einen Nachnamen eingeben.',0),(407124,11309,'en','You Must Enter A Last Name',0),(407125,11310,'is','',0),(407126,11310,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(407127,11310,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª  Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(407128,11310,'tr','Ã–deme tutarÄ± girmeniz gerekir',0),(407129,11310,'pl','NaleÅ¼y wprowadziÄ‡ kwotÄ™ pÅ‚atnoÅ›ci',0),(407130,11310,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÑƒÐ¼Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(407131,11310,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù‚Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(407132,11310,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð·Ð½Ð¾Ñ Ð·Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ñƒ',0),(407133,11310,'vi','Báº¡n pháº£i nháº­p Má»™t sá»‘ tiá»n thanh toÃ¡n',0),(407134,11310,'af','U moet \'n Betalingsbedrag Invoer',0),(407135,11310,'ro','Trebuie sÄƒ introduceÅ£i o sumÄƒ de platÄƒ',0),(407136,11310,'et','Sisestage makse summa',0),(407137,11310,'si','Vnesite znesek plaÄila',0),(407138,11310,'ba','Anda harus memasukkan jumlah pembayaran',0),(407139,11310,'nl','U moet een bedrag opgeven',0),(407140,11310,'fi','Kirjoita maksusumma',0),(407141,11310,'no','Du mÃ¥ angi et BetalingsbelÃ¸p',0),(407142,11310,'da','Du skal angive et indbetalingsbelÃ¸b',0),(407143,11310,'ko','ì§€ë¶ˆ ê¸ˆì•¡ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(407144,11310,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×¡×›×•× ×”×ª×©×œ×•×',0),(407145,11310,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Ï€Î¿ÏƒÏŒ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(407146,11310,'zh','æ‚¨å¿…é¡»è¾“å…¥ä»˜æ¬¾é‡‘é¢\r\n',0),(407147,11310,'sv','Du mÃ¥ste ange ett betalningsbelopp',0),(407148,11310,'it','Ãˆ necessario inserire un importo di pagamento',0),(407149,11310,'tl','',0),(407150,11310,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(407151,11310,'hi','à¤†à¤ª à¤à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(407152,11310,'ms','Anda mesti masukkan jumlah bayaran yang',0),(407153,11310,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ ÙƒÙ…ÙŠØ© Ø§Ù„Ø¯ÙØ¹',0),(407154,11310,'fr','Vous devez entrer un montant de paiement',0),(407155,11310,'jp','æ”¯æ‰•é¡ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(407156,11310,'pt','VocÃª deve digitar um valor de pagamento',0),(407157,11310,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ ÑÑƒÐ¼Ð¼Ñƒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(407158,11310,'es','Debe Entrar Una Cantidad de Pago',0),(407159,11310,'de','Sie mÃ¼ssen einen Betrag eingeben.',0),(407160,11310,'en','You Must Enter A Payment Amount',0),(407161,11311,'is','',0),(407162,11311,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­ÙˆØ·Ù‡ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(407163,11311,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­ÙˆØ·Ù‡ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(407164,11311,'tr','Mahkeme dosya ekle',0),(407165,11311,'pl','DodaÄ‡ sÄ…dowego',0),(407166,11311,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ ÑÑŠÐ´ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ',0),(407167,11311,'ur','Ø¹Ø¯Ø§Ù„Øª Ù†Û’ Ø¨ØªØ§Ø¦ÛŒÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(407168,11311,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑƒÐ´ Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°ÑšÐ°',0),(407169,11311,'vi','ThÃªm sáº¯p Ä‘áº·t ',0),(407170,11311,'af','Voeg hof indiening',0),(407171,11311,'ro','Adauga Curtea depunerea',0),(407172,11311,'et','Lisada kohtule esitamise',0),(407173,11311,'si','Dodaj sodiÅ¡Äe vloÅ¾itve',0),(407174,11311,'ba','Tambahkan pengajuan pengadilan',0),(407175,11311,'nl','Hof indienen toevoegen',0),(407176,11311,'fi','LisÃ¤Ã¤ tuomioistuimen rekisterin',0),(407177,11311,'no','Legge til retten innlevering',0),(407178,11311,'da','TilfÃ¸je domstol arkivering',0),(407179,11311,'ko','ë²•ì›ì— ì œì¶œí•œ ì¶”ê°€',0),(407180,11311,'he','×”×•×¡×£ ×ž×©×¤×˜ ×ª×™×•×§',0),(407181,11311,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î±ÏÏ‡ÎµÎ¹Î¿Î¸Î­Ï„Î·ÏƒÎ· Î´Î¹ÎºÎ±ÏƒÏ„Î·ÏÎ¯Ï‰Î½',0),(407182,11311,'zh','å¢žåŠ æ³•åº­æ–‡ä»¶\r\n',0),(407183,11311,'sv','LÃ¤gg till tingsrÃ¤tten',0),(407184,11311,'it','Aggiungi Court Filing',0),(407185,11311,'tl','',0),(407186,11311,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸¢à¸·à¹ˆà¸™à¸¨à¸²à¸¥',0),(407187,11311,'hi','à¤•à¥‹à¤°à¥à¤Ÿ à¤«à¤¾à¤‡à¤²à¤¿à¤‚à¤— à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(407188,11311,'ms','Tambah fail Mahkamah',0),(407189,11311,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø­ÙƒÙ…Ø©',0),(407190,11311,'fr','Ajouter le dÃ©pÃ´t de la Cour',0),(407191,11311,'jp','è£åˆ¤æ‰€ã«æå‡ºã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(407192,11311,'pt','Adicionar arquivo tribunal',0),(407193,11311,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑƒÐ´ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸',0),(407194,11311,'es','Agregar Demanda Ante el Corte',0),(407195,11311,'de','HinzufÃ¼gen von Court Filing',0),(407196,11311,'en','Add Court Filing',0),(407197,11312,'is','',0),(407198,11312,'dr','(Ø¶Ø¨Ø·) Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(407199,11312,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ(Ø¶Ø¨Ø·) Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ ',0),(407200,11312,'tr','Miktar iÃ§in aÃ§tÄ±',0),(407201,11312,'pl','Kwoty zÅ‚oÅ¼one do',0),(407202,11312,'bg','Ð¡ÑƒÐ¼Ð°, Ð¿Ð¾Ð´Ð°Ð´Ðµ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°',0),(407203,11312,'ur','Ø±Ù‚Ù… Ú©Û’ Ù„Ø¦Û’ Ø¯Ø§Ø¦Ø±',0),(407204,11312,'sr','Ð˜Ð·Ð½Ð¾Ñ Ñ˜Ðµ Ð¿Ð¾Ð´Ð½ÐµÐ¾ Ð·Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð°',0),(407205,11312,'vi','Sá»‘ tiá»n  Ä‘Ã£ ná»™p cho',0),(407206,11312,'af','Bedrag geliasseer vir',0),(407207,11312,'ro','Suma depusÄƒ pentru',0),(407208,11312,'et','Esitatud summa',0),(407209,11312,'si','Znesek, ki je vloÅ¾ila zahtevo za',0),(407210,11312,'ba','Jumlah mengajukan',0),(407211,11312,'nl','Bedrag aangevraagd',0),(407212,11312,'fi','MÃ¤Ã¤rÃ¤ haki',0),(407213,11312,'no','BelÃ¸pet arkivert For',0),(407214,11312,'da','BelÃ¸b, der er gemt For',0),(407215,11312,'ko','ì‹ ì²­ ê¸ˆì•¡',0),(407216,11312,'he','×›×ž×•×ª ×”×’×™×© ×‘×§×©×”',0),(407217,11312,'el','Î Î¿ÏƒÏŒ ÎºÎ±Ï„Î±Ï„Î¯Î¸ÎµÏ„Î±Î¹ Î³Î¹Î±',0),(407218,11312,'zh','æäº¤çš„æ³¨å†Œé‡‘é¢\r\n',0),(407219,11312,'sv','Belopp i',0),(407220,11312,'it','Importo depositato per',0),(407221,11312,'tl','',0),(407222,11312,'th','à¸ˆà¸³à¸™à¸§à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¸³à¸«à¸£à¸±à¸š',0),(407223,11312,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤¾à¤¯à¤° à¤•à¥€',0),(407224,11312,'ms','Jumlah yang difailkan',0),(407225,11312,'ar','Ù‚Ø¯Ù… Ù„Ù„Ù…Ø¨Ù„Øº',0),(407226,11312,'fr','Montant dÃ©posÃ© pour',0),(407227,11312,'jp','é‡ã®ãŸã‚ã«æå‡º',0),(407228,11312,'pt','Quantidade arquivada para',0),(407229,11312,'ru','Ð¡ÑƒÐ¼Ð¼Ð°, Ð¿Ð¾Ð´Ð°Ð»Ð° Ð½Ð°',0),(407230,11312,'es','Cantidad Pedido Por',0),(407231,11312,'de','Betrag reichte die',0),(407232,11312,'en','Amount Filed For',0),(407233,11313,'is','',0),(407234,11313,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ  Ù…Ø­Ù„ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ ',0),(407235,11313,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ  Ù…Ø­Ù„ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ ',0),(407236,11313,'tr','Mahkeme dosyalama yÃ¶nergeleri',0),(407237,11313,'pl','SÄ…d zgÅ‚oszenia instrukcje',0),(407238,11313,'bg','Ð¡ÑŠÐ´ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ ÑƒÐºÐ°Ð·Ð°Ð½Ð¸Ñ',0),(407239,11313,'ur','Ø¹Ø¯Ø§Ù„Øª Ù†Û’ Ø¨ØªØ§Ø¦ÛŒÚº ÛØ¯Ø§ÛŒØ§Øª',0),(407240,11313,'sr','Ð£Ð¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð·Ð° Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ ÑÑƒÐ´Ñƒ',0),(407241,11313,'vi','Ä‘áº¿m file hÆ°á»›ng dáº«n',0),(407242,11313,'af','Hof liassering instruksies',0),(407243,11313,'ro','InstrucÅ£iunile de depunere Curtea',0),(407244,11313,'et','Kohtule esitamise juhised',0),(407245,11313,'si','SodiÅ¡Äe vloÅ¾itve navodila',0),(407246,11313,'ba','Petunjuk pengajuan pengadilan',0),(407247,11313,'nl','Hof indienen instructies',0),(407248,11313,'fi','Tuomioistuin arkistointi ohjeet',0),(407249,11313,'no','Retten innlevering instruksjoner',0),(407250,11313,'da','Domstol arkivering instruktioner',0),(407251,11313,'ko','ë²•ì› ì œì¶œ ì§€ì¹¨',0),(407252,11313,'he','×‘×™×ª ×”×ž×©×¤×˜ ×”×•×¨××•×ª ×ª×™×•×§',0),(407253,11313,'el','ÎŸÎ´Î·Î³Î¯ÎµÏ‚ Î±ÏÏ‡ÎµÎ¹Î¿Î¸Î­Ï„Î·ÏƒÎ·Ï‚ Î”Î¹ÎºÎ±ÏƒÏ„Î·ÏÎ¯Î¿Ï…',0),(407254,11313,'zh','æ³•åº­æ–‡ä»¶è¯´æ˜Ž\r\n',0),(407255,11313,'sv','Domstolen ansÃ¶kan instruktioner',0),(407256,11313,'it','Istruzioni deposito Tribunale',0),(407257,11313,'tl','',0),(407258,11313,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¹ƒà¸™à¸à¸²à¸£à¸¢à¸·à¹ˆà¸™à¸¨à¸²à¸¥',0),(407259,11313,'hi','à¤¨à¥à¤¯à¤¾à¤¯à¤¾à¤²à¤¯ à¤¦à¤¾à¤–à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(407260,11313,'ms','Arahan pemfailan Mahkamah',0),(407261,11313,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø­ÙƒÙ…Ø©',0),(407262,11313,'fr','Instructions de dÃ©pÃ´t de Cour',0),(407263,11313,'jp','è£åˆ¤æ‰€ã®ãƒ•ã‚¡ã‚¤ãƒªãƒ³ã‚°ã®æ‰‹é †',0),(407264,11313,'pt','InstruÃ§Ãµes de preenchimento do Tribunal',0),(407265,11313,'ru','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(407266,11313,'es','Instrucciones de Interposiciones Legales',0),(407267,11313,'de','Court Filing Anweisungen',0),(407268,11313,'en','Court Filing Instructions',0),(407269,11314,'is','',0),(407270,11314,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(407271,11314,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(407272,11314,'tr','Mahkeme dosyalama baÅŸarÄ±yla eklendi',0),(407273,11314,'pl','SÄ…d zgÅ‚oszenia dodano pomyÅ›lnie',0),(407274,11314,'bg','Ð¡ÑŠÐ´ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(407275,11314,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ø¹Ø¯Ø§Ù„Øª Ù†Û’ Ø¨ØªØ§Ø¦ÛŒÚº',0),(407276,11314,'sr','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(407277,11314,'vi','Ä‘Ã£ thÃªm  file Ä‘áº¿m thÃ nh cÃ´ng',0),(407278,11314,'af','Hof liassering suksesvol bygevoeg',0),(407279,11314,'ro','Curtea depunerea adÄƒugat cu succes',0),(407280,11314,'et','Kohtule esitamise lisatud',0),(407281,11314,'si','SodiÅ¡Äe vloÅ¾itve uspeÅ¡no dodani',0),(407282,11314,'ba','Pengajuan pengadilan ditambahkan berhasil',0),(407283,11314,'nl','Hof indienen toegevoegd',0),(407284,11314,'fi','Tuomioistuimen rekisterin lisÃ¤Ã¤minen onnistui',0),(407285,11314,'no','Retten innlevering lagt',0),(407286,11314,'da','Domstol arkivering tilfÃ¸jet',0),(407287,11314,'ko','ë²•ì • ì„œë¥˜ ì œê¸° ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€',0),(407288,11314,'he','×ª×™×•×§ ×ž×©×¤×˜ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(407289,11314,'el','Î‘ÏÏ‡ÎµÎ¹Î¿Î¸Î­Ï„Î·ÏƒÎ· Î´Î¹ÎºÎ±ÏƒÏ„Î·ÏÎ¯Ï‰Î½ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(407290,11314,'zh','æ³•åº­æ–‡ä»¶æ·»åŠ æˆåŠŸ\r\n',0),(407291,11314,'sv','TingsrÃ¤tten lagts',0),(407292,11314,'it','Deposito di Corte aggiunto con successo',0),(407293,11314,'tl','',0),(407294,11314,'th','à¸¢à¸·à¹ˆà¸™à¸¨à¸²à¸¥à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(407295,11314,'hi','à¤•à¥‹à¤°à¥à¤Ÿ à¤«à¤¾à¤‡à¤²à¤¿à¤‚à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(407296,11314,'ms','Pemfailan Mahkamah yang berjaya menambah',0),(407297,11314,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø­ÙƒÙ…Ø© Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(407298,11314,'fr','DÃ©pÃ´t de Cour ajoutÃ© avec succÃ¨s',0),(407299,11314,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸè£åˆ¤æ‰€ã«æå‡º',0),(407300,11314,'pt','ApresentaÃ§Ã£o do Tribunal adicionada com sucesso',0),(407301,11314,'ru','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(407302,11314,'es','InterposiciÃ³n Legal Agregada Exitosamente',0),(407303,11314,'de','Court Filing erfolgreich hinzugefÃ¼gt',0),(407304,11314,'en','Court Filing Added Successfully',0),(407305,11315,'is','',0),(407306,11315,'dr','Ø­Ø°Ù Ù…Ø­Ù„ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(407307,11315,'pr','Ø­Ø°Ù Ù…Ø­Ù„ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(407308,11315,'tr','Mahkeme dosyalama baÅŸarÄ±yla silindi',0),(407309,11315,'pl','SÄ…d zgÅ‚oszenia przesâ”‚anie',0),(407310,11315,'bg','Ð¡ÑŠÐ´ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(407311,11315,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ø¹Ø¯Ø§Ù„Øª Ø¨ØªØ§Ø¦ÛŒÚº',0),(407312,11315,'sr','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(407313,11315,'vi','Ä‘Ã£ xÃ³a file Ä‘áº¿m thÃ nh cÃ´ng',0),(407314,11315,'af','Hof liassering suksesvol geskrap',0),(407315,11315,'ro','Curtea depunerea eliminÄƒ cu succes',0),(407316,11315,'et','Kohtule esitamise edukalt kustutatud',0),(407317,11315,'si','SodiÅ¡Äe vloÅ¾itve uspeÅ¡no izbrisana',0),(407318,11315,'ba','Pengajuan pengadilan dihapus berhasil',0),(407319,11315,'nl','Hof indiening met succes verwijderd',0),(407320,11315,'fi','Tuomioistuimen rekisterin poistettu',0),(407321,11315,'no','Retten innlevering slettet',0),(407322,11315,'da','Domstol arkivering slettet',0),(407323,11315,'ko','ë²•ì • ì„œë¥˜ ì œê¸° ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(407324,11315,'he','×”×ž×©×¤×˜ ×œ×”×’×©×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(407325,11315,'el','Î‘ÏÏ‡ÎµÎ¹Î¿Î¸Î­Ï„Î·ÏƒÎ· Î´Î¹ÎºÎ±ÏƒÏ„Î·ÏÎ¯Ï‰Î½ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(407326,11315,'zh','æ³•åº­æ–‡ä»¶æˆåŠŸåˆ é™¤\r\n',0),(407327,11315,'sv','TingsrÃ¤tten raderades',0),(407328,11315,'it','Deposito di Corte eliminato con successo',0),(407329,11315,'tl','',0),(407330,11315,'th','à¸¢à¸·à¹ˆà¸™à¸¨à¸²à¸¥à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(407331,11315,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤•à¥‹à¤°à¥à¤Ÿ à¤«à¤¾à¤‡à¤²à¤¿à¤‚à¤—',0),(407332,11315,'ms','Pemfailan Mahkamah dihapuskan dengan jayanya',0),(407333,11315,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø­ÙƒÙ…Ø© Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(407334,11315,'fr','DÃ©pÃ´t de Cour supprimÃ© avec succÃ¨s',0),(407335,11315,'jp','è£åˆ¤æ‰€ã®ç”³è«‹ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(407336,11315,'pt','ApresentaÃ§Ã£o do Tribunal apagada com sucesso',0),(407337,11315,'ru','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(407338,11315,'es','InterposiciÃ³n Legal Eliminada Exitosamente',0),(407339,11315,'de','Court Filing erfolgreich gelÃ¶scht',0),(407340,11315,'en','Court Filing Deleted Successfully',0),(407341,11316,'is','',0),(407342,11316,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(407343,11316,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(407344,11316,'tr','Mahkeme dosyalama bilgileri',0),(407345,11316,'pl','SÄ…d zÅ‚oÅ¼enia informacji',0),(407346,11316,'bg','Ð¡ÑŠÐ´ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(407347,11316,'ur','Ø¹Ø¯Ø§Ù„Øª Ù†Û’ Ø¨ØªØ§Ø¦ÛŒÚº Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(407348,11316,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÑƒÐ¿Ð¸ÑÑƒ ÑÑƒÐ´',0),(407349,11316,'vi','thÃ´ng tin Ä‘áº¿m file',0),(407350,11316,'af','Hof liassering inligting',0),(407351,11316,'ro','Curtea depunerea informaÅ£iilor',0),(407352,11316,'et','Kohtule esitamise andmed',0),(407353,11316,'si','SodiÅ¡Äe vloÅ¾itve informacije',0),(407354,11316,'ba','Informasi pengajuan pengadilan',0),(407355,11316,'nl','Hof indiening informatie',0),(407356,11316,'fi','Tuomioistuin hakemuksen tiedot',0),(407357,11316,'no','Retten innlevering informasjon',0),(407358,11316,'da','Domstolen indgive oplysninger',0),(407359,11316,'ko','ë²•ì› ì œì¶œ ì •ë³´',0),(407360,11316,'he','×”×ž×©×¤×˜ ×œ×”×’×©×ª ×ž×™×“×¢',0),(407361,11316,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚ Î´Î¹ÎºÎ±ÏƒÏ„Î®ÏÎ¹Î¿',0),(407362,11316,'zh','æ³•åº­æ–‡ä»¶ä¿¡æ¯\r\n',0),(407363,11316,'sv','Domstolen ansÃ¶kan Information',0),(407364,11316,'it','Informazioni deposito Tribunale',0),(407365,11316,'tl','',0),(407366,11316,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¢à¸·à¹ˆà¸™à¸¨à¸²à¸¥',0),(407367,11316,'hi','à¤¨à¥à¤¯à¤¾à¤¯à¤¾à¤²à¤¯ à¤¦à¤¾à¤–à¤¿à¤² à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(407368,11316,'ms','Maklumat fail Mahkamah',0),(407369,11316,'ar','Ø§Ù„Ù…Ø­ÙƒÙ…Ø© Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(407370,11316,'fr','Cour production Information',0),(407371,11316,'jp','è£åˆ¤æ‰€ãƒ•ã‚¡ã‚¤ãƒªãƒ³ã‚°æƒ…å ±',0),(407372,11316,'pt','InformaÃ§Ãµes de depÃ³sito do Tribunal',0),(407373,11316,'ru','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸',0),(407374,11316,'es','InformaciÃ³n de InterposiciÃ³n Legal ',0),(407375,11316,'de','Court Filing Informationen',0),(407376,11316,'en','Court Filing Information',0),(407377,11317,'is','',0),(407378,11317,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(407379,11317,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(407380,11317,'tr','Mahkeme dosyalama bilgi yardÄ±m',0),(407381,11317,'pl','SÄ…d zgÅ‚oszenia informacje pomocy',0),(407382,11317,'bg','Ð¡ÑŠÐ´ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(407383,11317,'ur','Ø¹Ø¯Ø§Ù„Øª Ù†Û’ Ø¨ØªØ§Ø¦ÛŒÚº Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø¯Ø¯',0),(407384,11317,'sr','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸',0),(407385,11317,'vi','trá»£ giÃºp thÃ´ng tin Ä‘áº¿m file',0),(407386,11317,'af','Hof liassering inligting Help',0),(407387,11317,'ro','Curtea depunerea informaÅ£iilor ajutor',0),(407388,11317,'et','Kohus taotluse esitamise informatsiooni abi',0),(407389,11317,'si','SodiÅ¡Äe vloÅ¾itve informacije pomoÄ',0),(407390,11317,'ba','Pengadilan pengajuan informasi bantuan',0),(407391,11317,'nl','Hof indiening informatiehulp',0),(407392,11317,'fi','Tuomioistuin hakemuksen tiedot ohje',0),(407393,11317,'no','Retten innlevering informasjon hjelp',0),(407394,11317,'da','Domstolen indgive oplysninger hjÃ¦lp',0),(407395,11317,'ko','ë²•ì› ì œì¶œ ì •ë³´ ë„ì›€ë§',0),(407396,11317,'he','×”×ž×©×¤×˜ ×œ×”×’×©×ª ×ž×™×“×¢ ×¢×–×¨×”',0),(407397,11317,'el','Î”Î¹ÎºÎ±ÏƒÏ„Î®ÏÎ¹Î¿ Î²Î¿Î®Î¸ÎµÎ¹Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(407398,11317,'zh','æ³•åº­æ–‡ä»¶ä¿¡æ¯\r\n',0),(407399,11317,'sv','Domstolen ansÃ¶kan Information hjÃ¤lp',0),(407400,11317,'it','Corte limatura informazioni aiuto',0),(407401,11317,'tl','',0),(407402,11317,'th','à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¢à¸·à¹ˆà¸™à¸¨à¸²à¸¥',0),(407403,11317,'hi','à¤¨à¥à¤¯à¤¾à¤¯à¤¾à¤²à¤¯ à¤¦à¤¾à¤–à¤¿à¤² à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¤¦à¤¦',0),(407404,11317,'ms','Mahkamah pemfailan maklumat bantuan',0),(407405,11317,'ar','Ø§Ù„Ù…Ø­ÙƒÙ…Ø© Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(407406,11317,'fr','Cour production Information aide',0),(407407,11317,'jp','è£åˆ¤æ‰€ãƒ•ã‚¡ã‚¤ãƒªãƒ³ã‚°æƒ…å ±ãƒ˜ãƒ«ãƒ—',0),(407408,11317,'pt','Tribunal depÃ³sito informaÃ§Ãµes ajuda',0),(407409,11317,'ru','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð°Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒ',0),(407410,11317,'es','Aytuda de InformaciÃ³n de InterposiciÃ³n Legal ',0),(407411,11317,'de','Gericht-Anmeldung-Informationen-Hilfe',0),(407412,11317,'en','Court Filing Information Help',0),(407413,11318,'is','',0),(407414,11318,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ  Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(407415,11318,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ  Ù…ÙˆØ±Ø¯ Ù†ÙŠØ§Ø²',0),(407416,11318,'tr','Bilgi yardÄ±m dosyalama mahkeme gerekli alanlar',0),(407417,11318,'pl','SÄ…d zÅ‚oÅ¼enia informacji wymagane pola',0),(407418,11318,'bg','ÐŸÐ¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð½Ð° ÑÑŠÐ´Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(407419,11318,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø¯Ø¯ Ø¯Ø§Ø®Ù„ Ø¹Ø¯Ø§Ù„Øª Ù†Û’ Ù…Ø·Ù„ÙˆØ¨Û Ù‚Ø·Ø¹Ø§Øª',0),(407420,11318,'sr','Ð¡ÑƒÐ´ Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¿Ð¾Ð¼Ð¾Ñ› Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð¿Ð¾Ñ™Ð°',0),(407421,11318,'vi','cÃ¡c trÆ°á»ng yÃªu cáº§u trá»£ giÃºp thÃ´ng tin Ä‘áº¿m file',0),(407422,11318,'af','Hof liassering van inligting hulp benodig velde',0),(407423,11318,'ro','Curtea depunerea informaÅ£iilor ajutor cÃ¢mpuri obligatorii',0),(407424,11318,'et','Kohus esitab teabe abi kohustuslikud vÎ´ljad',0),(407425,11318,'si','SodiÅ¡Äe vloÅ¾itve informacije pomoÄ obvezna polja',0),(407426,11318,'ba','Pengadilan pengajuan informasi bantuan diperlukan bidang',0),(407427,11318,'nl','Hof indienen informatiehulp verplichte velden',0),(407428,11318,'fi','Tuomioistuin hakemuksen tiedot auttavat pakolliset kentÃ¤t',0),(407429,11318,'no','Retten innlevering informasjon hjelp nÃ¸dvendige felt',0),(407430,11318,'da','Domstolen indgive oplysninger hjÃ¦lp obligatoriske felter',0),(407431,11318,'ko','ë²•ì› ì •ë³´ ë„ì›€ë§ ì œì¶œ í•„ìˆ˜ í•­ëª©',0),(407432,11318,'he','×”×ž×©×¤×˜ ×”×’×©×ª ×¢×–×¨×” ×ž×™×“×¢ ×©×“×•×ª ×—×•×‘×”',0),(407433,11318,'el','Î”Î¹ÎºÎ±ÏƒÏ„Î®ÏÎ¹Î¿ Ï€Î¿Ï… Î±ÏÏ‡ÎµÎ¹Î¿Î¸ÎµÏ„ÎµÎ¯ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î²Î¿Î®Î¸ÎµÎ¹Î± Ï…Ï€Î¿Ï‡ÏÎµÏ‰Ï„Î¹ÎºÎ¬ Ï€ÎµÎ´Î¯Î±',0),(407434,11318,'zh','æ³•åº­æ–‡ä»¶ä¿¡æ¯å¸®åŠ©å¿…å¡«\r\n',0),(407435,11318,'sv','Domstolen Filing Information hjÃ¤lp krÃ¤vs fÃ¤lt',0),(407436,11318,'it','Corte limatura informazioni aiuto campi obbligatori',0),(407437,11318,'tl','',0),(407438,11318,'th','à¸¨à¸²à¸¥à¸¢à¸·à¹ˆà¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¹€à¸‚à¸•à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¸à¸²à¸£',0),(407439,11318,'hi','à¤¨à¥à¤¯à¤¾à¤¯à¤¾à¤²à¤¯ à¤¦à¤¾à¤–à¤¿à¤² à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¤¦à¤¦ à¤†à¤µà¤¶à¥à¤¯à¤• à¤«à¤¼à¥€à¤²à¥à¤¡',0),(407440,11318,'ms','Mahkamah memfailkan bantuan maklumat diperlukan bidang',0),(407441,11318,'ar','Ø§Ù„Ù…Ø­ÙƒÙ…Ø© ØªÙ‚Ø¯ÙŠÙ… Ù…Ø³Ø§Ø¹Ø¯Ø© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø­Ù‚ÙˆÙ„ Ù…Ø·Ù„ÙˆØ¨Ø©',0),(407442,11318,'fr','DÃ©pÃ´t d\'Information aide les champs obligatoires',0),(407443,11318,'jp','å¿…é ˆãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã®æ³•å»·ãƒ•ã‚¡ã‚¤ãƒªãƒ³ã‚°æƒ…å ±ãƒ˜ãƒ«ãƒ—',0),(407444,11318,'pt','Tribunal arquivando informaÃ§Ãµes ajuda exigido campos',0),(407445,11318,'ru','Ð¡ÑƒÐ´, Ð¿Ð¾Ð´Ð°Ñ‡Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¿Ð¾Ð»Ñ',0),(407446,11318,'es','Campos Requeridos de Ayuda de InformaciÃ³n de InterposiciÃ³n Legal ',0),(407447,11318,'de','Gericht einreichen Informationen Hilfe Pflichtfelder',0),(407448,11318,'en','Court Filing Information Help Required Fields',0),(407449,11319,'is','',0),(407450,11319,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(407451,11319,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ù…Ø­Ù„ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(407452,11319,'tr','Mahkeme dosyalama baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(407453,11319,'pl','SÄ…d zgÅ‚oszenia pomyÅ›lnie zaktualizowana',0),(407454,11319,'bg','Ð¡ÑŠÐ´ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(407455,11319,'ur','Ø¹Ø¯Ø§Ù„Øª Ù†Û’ Ø¨ØªØ§Ø¦ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(407456,11319,'sr','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(407457,11319,'vi','cáº­p nháº­t file Ä‘áº¿m thÃ nh cÃ´ng',0),(407458,11319,'af','Hof liassering suksesvol bygewerk',0),(407459,11319,'ro','Curtea depunerea actualizate cu succes',0),(407460,11319,'et','Kohtule esitamise vÃ¤rskendatud',0),(407461,11319,'si','SodiÅ¡Äe vloÅ¾itve uspeÅ¡no posodobljena',0),(407462,11319,'ba','Pengajuan pengadilan yang berhasil',0),(407463,11319,'nl','Hof indiening bijgewerkt',0),(407464,11319,'fi','Tuomioistuimen rekisterin pÃ¤ivittÃ¤minen onnistui',0),(407465,11319,'no','Retten innlevering oppdatert',0),(407466,11319,'da','Domstol arkivering opdateret',0),(407467,11319,'ko','ë²•ì • ì„œë¥˜ ì œê¸° ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(407468,11319,'he','×ª×™×•×§ ×”×ž×©×¤×˜ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(407469,11319,'el','Î‘ÏÏ‡ÎµÎ¹Î¿Î¸Î­Ï„Î·ÏƒÎ· Î´Î¹ÎºÎ±ÏƒÏ„Î·ÏÎ¯Ï‰Î½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(407470,11319,'zh','æ³•åº­æ–‡ä»¶æ›´æ–°æˆåŠŸ\r\n',0),(407471,11319,'sv','TingsrÃ¤tten uppdaterats',0),(407472,11319,'it','Deposito di Corte aggiornato con successo',0),(407473,11319,'tl','',0),(407474,11319,'th','à¸¢à¸·à¹ˆà¸™à¸¨à¸²à¸¥à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(407475,11319,'hi','à¤•à¥‹à¤°à¥à¤Ÿ à¤«à¤¾à¤‡à¤²à¤¿à¤‚à¤— à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(407476,11319,'ms','Pemfailan Mahkamah yang berjaya dikemas kini',0),(407477,11319,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ù…Ø­ÙƒÙ…Ø© ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(407478,11319,'fr','DÃ©pÃ´t de Cour mis Ã  jour avec succÃ¨s',0),(407479,11319,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸè£åˆ¤æ‰€ã«æå‡º',0),(407480,11319,'pt','Tribunal depÃ³sito atualizado com sucesso',0),(407481,11319,'ru','Ð¡ÑƒÐ´ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(407482,11319,'es','InterposiciÃ³n Legal Actualizada Exitosamente',0),(407483,11319,'de','Court Filing erfolgreich aktualisiert',0),(407484,11319,'en','Court Filing Updated Successfully',0),(407485,11320,'is','',0),(407486,11320,'dr','ØªØ§Ø±ÙŠØ® Ø¯Ø§Ø¯Ø±Ø³ÙŠ',0),(407487,11320,'pr','ØªØ§Ø±ÙŠØ® Ø¯Ø§Ø¯Ø±Ø³ÙŠ',0),(407488,11320,'tr','Karar tarihi',0),(407489,11320,'pl','Data wyroku',0),(407490,11320,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ',0),(407491,11320,'ur','Ø¹Ø¯Ø§Ù„Øª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(407492,11320,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ð´Ð»ÑƒÐºÐµ',0),(407493,11320,'vi','NgÃ y quyáº¿t Ä‘á»‹nh',0),(407494,11320,'af','Oordeel datum',0),(407495,11320,'ro','HotÄƒrÃ¢re data',0),(407496,11320,'et','Otsuse kuupÃ¤ev',0),(407497,11320,'si','Datum sodbe',0),(407498,11320,'ba','Penghakiman tanggal',0),(407499,11320,'nl','Arrest datum',0),(407500,11320,'fi','Tuomion pÃ¤ivÃ¤',0),(407501,11320,'no','Dom dato',0),(407502,11320,'da','Doms dato',0),(407503,11320,'ko','ì‹¬íŒ ë‚ ì§œ',0),(407504,11320,'he','×¤×¡×§ ×“×™×Ÿ ×ª××¨×™×š',0),(407505,11320,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€ÏŒÏ†Î±ÏƒÎ·Ï‚',0),(407506,11320,'zh','åˆ¤å†³æ—¥æœŸ\r\n',0),(407507,11320,'sv','Dom datum',0),(407508,11320,'it','Data della sentenza',0),(407509,11320,'tl','',0),(407510,11320,'th','à¸§à¸±à¸™à¸žà¸´à¸žà¸²à¸à¸©à¸²',0),(407511,11320,'hi','à¤«à¥ˆà¤¸à¤²à¥‡ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(407512,11320,'ms','Tarikh penghakiman',0),(407513,11320,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­ÙƒÙ…',0),(407514,11320,'fr','Date de l\'arrÃªt',0),(407515,11320,'jp','åˆ¤æ±ºæ—¥',0),(407516,11320,'pt','Data de julgamento',0),(407517,11320,'ru','Ð”Ð°Ñ‚Ð° Ñ€ÐµÑˆÐµÐ½Ð¸Ñ',0),(407518,11320,'es','Fecha de Sentencia',0),(407519,11320,'de','Urteil-Datum',0),(407520,11320,'en','Judgment Date',0),(407521,11321,'is','',0),(407522,11321,'dr','Ù‡ÙŠÚ† Ù…Ø­ÙˆØ·Ù‡ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(407523,11321,'pr','Ù‡ÙŠÚ† Ù…Ø­ÙˆØ·Ù‡ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(407524,11321,'tr','HiÃ§bir mahkeme Filings bulundu',0),(407525,11321,'pl','Nie opiÅ‚kami sÄ…du Znalezione',0),(407526,11321,'bg','ÐÑÐ¼Ð° ÑÑŠÐ´ÐµÐ±Ð½Ð° ÑÑ‚Ñ€ÑƒÐ¶ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(407527,11321,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ø¹Ø¯Ø§Ù„Øª Ú†ÙˆØ±Ø§',0),(407528,11321,'sr','ÐÐµÐ¼Ð° ÑÑƒÐ´Ð° Ð¿Ð¾Ð´Ð½ÐµÑÐºÐµ Ð½Ð°ÑˆÐ°Ð¾',0),(407529,11321,'vi','khÃ´ng tÃ¬m tháº¥y pháº§n Ä‘iá»n',0),(407530,11321,'af','Geen hof Filings gevind',0),(407531,11321,'ro','Nu pilitura instanÅ£a gÄƒsit',0),(407532,11321,'et','Ãœkski kohus viilmed leitud',0),(407533,11321,'si','No sodiÅ¡Äe opilki naÅ¡el',0),(407534,11321,'ba','Pengajuan pengadilan tidak ditemukan',0),(407535,11321,'nl','Geen rechter aanmeldingen gevonden',0),(407536,11321,'fi','Ei ole tuomioistuin viilaus lÃ¶ytyi',0),(407537,11321,'no','Ingen domstol registreringer funnet',0),(407538,11321,'da','Ingen domstol hÃ¸vle fundet',0),(407539,11321,'ko','ì•„ë‹ˆ ë²•ì› ì„œë¥˜ ë°œê²¬',0),(407540,11321,'he','×©×‘×‘×™ ×‘×™×ª ×”×ž×©×¤×˜ ×œ× ×ž×¦×',0),(407541,11321,'el','Î”ÎµÎ½ ÏÎ¹Î½Î¯ÏƒÎ¼Î±Ï„Î± Î´Î¹ÎºÎ±ÏƒÏ„Î®ÏÎ¹Î¿ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(407542,11321,'zh','æ³•åº­æ–‡ä»¶æ²¡æœ‰æ‰¾åˆ°\r\n',0),(407543,11321,'sv','Ingen stÃ¤mningsansÃ¶kan hittade',0),(407544,11321,'it','Nessun processuale trovati',0),(407545,11321,'tl','',0),(407546,11321,'th','à¸¢à¸·à¹ˆà¸™à¹€à¸­à¸à¸ªà¸²à¸£à¹à¸ˆà¹‰à¸‡à¸¨à¸²à¸¥à¹„à¸¡à¹ˆà¸žà¸š',0),(407547,11321,'hi','à¤•à¥‹à¤ˆ à¤…à¤¦à¤¾à¤²à¤¤ à¤¬à¥à¤°à¤¾à¤¦à¤¾ à¤®à¤¿à¤²à¤¾',0),(407548,11321,'ms','Tiada Filings Mahkamah yang mendapati',0),(407549,11321,'ar','Ø¨Ø±Ø§Ø¯Ø© Ø§Ù„Ù…Ø­ÙƒÙ…Ø© Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(407550,11321,'fr','Aucune notifications, Cour',0),(407551,11321,'jp','è¦‹ã¤ã‹ã£ãŸãªã„è£åˆ¤æ‰€ãƒ•ã‚¡ã‚¤ãƒªãƒ³ã‚°',0),(407552,11321,'pt','Nenhum tribunal limalha encontrada',0),(407553,11321,'ru','ÐÐµÑ‚ Ð·Ð°ÑÐ²Ð¾Ðº ÑÑƒÐ´ Ð½Ð°ÑˆÐµÐ»',0),(407554,11321,'es','No se Encuentra Inteposiciones Legales',0),(407555,11321,'de','Kein Gericht eingereichten Unterlagen gefunden',0),(407556,11321,'en','No Court Filings Found',0),(407557,11322,'is','',0),(407558,11322,'dr','Ù†ØªÙŠØ¬Ù‡ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(407559,11322,'pr','Ù†ØªÙŠØ¬Ù‡ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ',0),(407560,11322,'tr','Dosyalama sonucu',0),(407561,11322,'pl','Wyniku zgÅ‚oszenia',0),(407562,11322,'bg','Ð ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚ Ð½Ð° Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ',0),(407563,11322,'ur','Ú©Û’ Ù†ØªØ§Ø¦Ø¬',0),(407564,11322,'sr','Ð˜ÑÑ…Ð¾Ð´ Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°ÑšÐ°',0),(407565,11322,'vi','tÃ¡c Ä‘á»™ng cá»§a lÃ m Ä‘áº§y',0),(407566,11322,'af','Uitkoms van indiening',0),(407567,11322,'ro','Rezultatul de depunere',0),(407568,11322,'et','Tulemuste esitamine',0),(407569,11322,'si','Izid vloÅ¾itve',0),(407570,11322,'ba','Hasil pengajuan',0),(407571,11322,'nl','Resultaat van indiening',0),(407572,11322,'fi','Tulosta arkistointi',0),(407573,11322,'no','Utfallet av innlevering',0),(407574,11322,'da','Resultatet af arkivering',0),(407575,11322,'ko','ì„œë¥˜ ì •ë¦¬ì˜ ê²°ê³¼',0),(407576,11322,'he','×”×ª×•×¦××” ×©×œ ×ª×™×•×§',0),(407577,11322,'el','Î‘Ï€Î¿Ï„Î­Î»ÎµÏƒÎ¼Î± Ï„Î·Ï‚ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(407578,11322,'zh','å¡«å†™çš„ç»“æžœ\r\n',0),(407579,11322,'sv','Resultatet av ansÃ¶kan',0),(407580,11322,'it','Esito del deposito',0),(407581,11322,'tl','',0),(407582,11322,'th','à¸œà¸¥à¸‚à¸­à¸‡à¸à¸²à¸£à¸¢à¸·à¹ˆà¸™',0),(407583,11322,'hi','à¤¦à¤¾à¤–à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤ªà¤°à¤¿à¤£à¤¾à¤®',0),(407584,11322,'ms','Hasil pemfailan',0),(407585,11322,'ar','Ù†ØªØ§Ø¦Ø¬ Ø§Ù„ØªÙ‚Ø¯ÙŠÙ…',0),(407586,11322,'fr','RÃ©sultat du dÃ©pÃ´t',0),(407587,11322,'jp','ãƒ•ã‚¡ã‚¤ãƒªãƒ³ã‚°ã®çµæžœ',0),(407588,11322,'pt','Resultado do depÃ³sito',0),(407589,11322,'ru','Ð ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸',0),(407590,11322,'es','Resultado de InterposiciÃ³n',0),(407591,11322,'de','Ergebnis der Anmeldung',0),(407592,11322,'en','Outcome Of Filing',0),(407593,11323,'is','',0),(407594,11323,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ ÙÙŠÙ„Ø¯ ØªØ§Ø±ÙŠØ®  Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407595,11323,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ ÙÙŠÙ„Ø¯ ØªØ§Ø±ÙŠØ®  Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407596,11323,'tr','LÃ¼tfen eÄŸe Tarih eklemek',0),(407597,11323,'pl','ProszÄ™ podaÄ‡ datÄ™ zÅ‚oÅ¼ony',0),(407598,11323,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð´Ð°Ñ‚Ð°Ñ‚Ð°',0),(407599,11323,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¯Ø§Ø¦Ø± Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(407600,11323,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ Ð¿Ð¾Ð´Ð½ÐµÐ¾',0),(407601,11323,'vi','vui lÃ²ng bao gá»“m má»™t trÆ°á»ng ngÃ y ',0),(407602,11323,'af','Sluit Asseblief \'n Liaseringsdatum in ',0),(407603,11323,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i o datÄƒ dosar',0),(407604,11323,'et','Palun lisage kuupÃ¤eva esitatud',0),(407605,11323,'si','Prosimo, da vkljuÄite datum pila',0),(407606,11323,'ba','Harap sertakan tanggal yang diajukan',0),(407607,11323,'nl','Gelieve te omvatten een datum ingediend',0),(407608,11323,'fi','SisÃ¤llytÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ arkistoida',0),(407609,11323,'no','Ta med en dato arkivert',0),(407610,11323,'da','Inkluder venligst en dato',0),(407611,11323,'ko','ì‹ ì²­ ë‚ ì§œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(407612,11323,'he','× × ×œ×›×œ×•×œ ×ª××¨×™×š ×”×’×™×©',0),(407613,11323,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… Î­Ï‡ÎµÎ¹ ÎºÎ±Ï„Î±Ï„ÎµÎ¸ÎµÎ¯',0),(407614,11323,'zh','è¯·åˆ—å…¥ä¸€ä¸ªé€’äº¤æ—¥æœŸ\r\n',0),(407615,11323,'sv','VÃ¤nligen inkludera en dag in',0),(407616,11323,'it','Si prega di includere una data archiviata',0),(407617,11323,'tl','',0),(407618,11323,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸§à¸±à¸™à¸—à¸µà¹ˆà¸¢à¸·à¹ˆà¸™',0),(407619,11323,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆ à¤à¤• à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‡ à¤¤à¤¹à¤¤ à¤¦à¤¾à¤¯à¤°',0),(407620,11323,'ms','Sila Sertakan tarikh yang difailkan',0),(407621,11323,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† ØªØ§Ø±ÙŠØ® Ø±ÙØ¹Ù‡Ø§',0),(407622,11323,'fr','Veuillez indiquer une Date de dÃ©pÃ´t',0),(407623,11323,'jp','æå‡ºã•ã‚ŒãŸæ—¥ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(407624,11323,'pt','Por favor, inclua uma data arquivada',0),(407625,11323,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ñƒ Ð¿Ð¾Ð´Ð°Ð»Ð°',0),(407626,11323,'es','Por Favor Incluye Una Fecha de InteposiciÃ³n Legal',0),(407627,11323,'de','Bitte geben Sie ein Datum abgelegt',0),(407628,11323,'en','Please Include A Date Filed',0),(407629,11324,'is','',0),(407630,11324,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¹Ù†ÙˆØ§Ù† Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407631,11324,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¹Ù†ÙˆØ§Ù† Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407632,11324,'tr','LÃ¼tfen bir dosyalama baÅŸlÄ±k iÃ§erir',0),(407633,11324,'pl','Prosimy o podanie tytuÅ‚u zgÅ‚oszenia',0),(407634,11324,'bg','ÐœÐ¾Ð»Ñ Ð´Ð° Ð²ÐºÐ»ÑŽÑ‡Ð²Ð° Ð·Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ',0),(407635,11324,'ur','Ø¨Ø±Ø§Ø¦Û’ Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¨ØªØ§Ø¦ÛŒÚº Ø¹Ù†ÙˆØ§Ù† Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(407636,11324,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ Ð½Ð°ÑÐ»Ð¾Ð²',0),(407637,11324,'vi','vui lÃ²ng cÃ³ chá»©c danh',0),(407638,11324,'af','Sluit Asseblief \'n Liaseringstitel in ',0),(407639,11324,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i un titlu de depunere',0),(407640,11324,'et','Palun lisage taotluse esitamise nimetus',0),(407641,11324,'si','Prosimo, da vkljuÄite naslov vloÅ¾itve',0),(407642,11324,'ba','Sertakan judul pengajuan',0),(407643,11324,'nl','Gelieve te omvatten een indiening titel',0),(407644,11324,'fi','LiitÃ¤ hakemuksen otsikko',0),(407645,11324,'no','Ta en innlevering tittel',0),(407646,11324,'da','VedlÃ¦g en arkivering titel',0),(407647,11324,'ko','ì‹ ê³  ì œëª© í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(407648,11324,'he','× × ×œ×›×œ×•×œ ×›×•×ª×¨×ª ×ª×™×•×§',0),(407649,11324,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î±Î½ Ï„Î¯Ï„Î»Î¿ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚',0),(407650,11324,'zh','è¯·åˆ—å…¥ä¸€ä¸ªæ¡£æ¡ˆåç§°\r\n',0),(407651,11324,'sv','VÃ¤nligen inkludera en ansÃ¶kan titel',0),(407652,11324,'it','Si prega di includere un titolo di deposito',0),(407653,11324,'tl','',0),(407654,11324,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­à¸¢à¸·à¹ˆà¸™',0),(407655,11324,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¦à¤¾à¤–à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤¶à¥€à¤°à¥à¤·à¤• à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤²',0),(407656,11324,'ms','Sila sertakan tajuk fail',0),(407657,11324,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(407658,11324,'fr','Veuillez inclure un titre de dÃ©pÃ´t',0),(407659,11324,'jp','ãƒ•ã‚¡ã‚¤ãƒªãƒ³ã‚° ã‚¿ã‚¤ãƒˆãƒ«ã‚’è¨˜è¼‰ã—ã¦ãã ã•ã„ã€‚',0),(407660,11324,'pt','Por favor inclua um tÃ­tulo de apresentaÃ§Ã£o',0),(407661,11324,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸',0),(407662,11324,'es','Por Favor Incluye Un Titulo de la InteposiciÃ³n Legal',0),(407663,11324,'de','Bitte geben Sie einen Titel der Einreichung',0),(407664,11324,'en','Please Include A Filing Title',0),(407665,11325,'is','',0),(407666,11325,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407667,11325,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¯Ù„ÙŠÙ„ Ø¨Ø±Ø§ÙŠ Ø¨Ø§ÙŠÚ¯Ø§Ù†ÙŠ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407668,11325,'tr','LÃ¼tfen doldurmak iÃ§in bir sebep ekleyin',0),(407669,11325,'pl','ProszÄ™ podaÄ‡ powÃ³d zgÅ‚oszenia',0),(407670,11325,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ',0),(407671,11325,'ur','Ø¨Ø±Ø§Ø¦Û’ Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¨ØªØ§Ø¦ÛŒÚº Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© ÙˆØ¬Û Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(407672,11325,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ñ€Ð°Ð·Ð»Ð¾Ð³ Ð·Ð° Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ',0),(407673,11325,'vi','vui lÃ²ng cÃ³ lÃ½ do ',0),(407674,11325,'af','Sluit Asseblief \'n Rede vir Liasering in ',0),(407675,11325,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i un motiv pentru depunerea',0),(407676,11325,'et','Palun lisage arhiivimise pÃµhjus',0),(407677,11325,'si','Prosimo, da vkljuÄite vzrok za arhiviranje',0),(407678,11325,'ba','Harap menyertakan alasan untuk pengajuan',0),(407679,11325,'nl','Gelieve te omvatten een reden voor indiening',0),(407680,11325,'fi','Ilmoita syy arkistoimiseen',0),(407681,11325,'no','Ta en Ã¥rsak til lagring',0),(407682,11325,'da','VedlÃ¦g en grund for indgivelse',0),(407683,11325,'ko','ì œì¶œì— ëŒ€ í•œ ì´ìœ ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(407684,11325,'he','× × ×œ×›×œ×•×œ ×¡×™×‘×” ×œ×”×’×©×ª',0),(407685,11325,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î±Î½ Î»ÏŒÎ³Î¿ Î³Î¹Î± Ï„Î·Î½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·',0),(407686,11325,'zh','è¯·åˆ—å…¥ä¸€ä¸ªå½’æ¡£çš„åŽŸå› \r\n',0),(407687,11325,'sv','VÃ¤nligen inkludera ett skÃ¤l fÃ¶r ansÃ¶kan',0),(407688,11325,'it','Si prega di includere una ragione per deposito',0),(407689,11325,'tl','',0),(407690,11325,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¹€à¸«à¸•à¸¸à¸œà¸¥à¹ƒà¸™à¸à¸²à¸£à¸¢à¸·à¹ˆà¸™',0),(407691,11325,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆ à¤à¤• à¤•à¤¾à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¾à¤‡à¤²à¤¿à¤‚à¤—',0),(407692,11325,'ms','Sila sertakan alasan untuk difailkan',0),(407693,11325,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø³Ø¨Ø¨Ø§ Ù„Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(407694,11325,'fr','Veuillez inclure une raison pour dÃ©pÃ´t',0),(407695,11325,'jp','ç”³ç«‹ã¦ã®ç†ç”±ã‚’è¨˜è¼‰ã—ã¦ãã ã•ã„ã€‚',0),(407696,11325,'pt','Por favor, inclua uma razÃ£o para a apresentaÃ§Ã£o',0),(407697,11325,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ñƒ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸',0),(407698,11325,'es','Por Favor Incluye Una ExplicaciÃ³n de la InteposiciÃ³n Legal',0),(407699,11325,'de','Bitte geben Sie einen Grund fÃ¼r die Einreichung',0),(407700,11325,'en','Please Include A Reason for Filing',0),(407701,11326,'is','',0),(407702,11326,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ù¾ÙŠØ¯Ø§ Ø´ÙˆØ¯',0),(407703,11326,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§ÙƒØªÙˆØ± Ù†Ù…ÙŠ ØªÙˆØ§Ù†Ø¯ Ù¾ÙŠØ¯Ø§ Ø´ÙˆØ¯',0),(407704,11326,'tr','Fatura numarasÄ± bulunamadÄ±',0),(407705,11326,'pl','Nie moÅ¼na odnaleÅºÄ‡ numer faktury',0),(407706,11326,'bg','ÐÐ¾Ð¼ÐµÑ€Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð°',0),(407707,11326,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ ØªØ¹Ø¯Ø§Ø¯ ÚˆÚ¾ÙˆÙ†ÚˆØ§ Ù†ÛÛŒÚº Ø¬Ø§ Ø³Ú©Ø§',0),(407708,11326,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(407709,11326,'vi','Sá»‘ hÃ³a Ä‘Æ¡n nÃ y khÃ´ng thá»… tÃ¬m tháº¥y',0),(407710,11326,'af','Die Faktuurnommer Kon Nie Gevind Word Nie',0),(407711,11326,'ro','Imposibil de gÄƒsit numÄƒrul facturii',0),(407712,11326,'et','Arve numbrit ei leitud',0),(407713,11326,'si','Å tevilko raÄuna ni bilo mogoÄe najti',0),(407714,11326,'ba','Nomor faktur tidak dapat ditemukan',0),(407715,11326,'nl','Het factuurnummer kon niet worden gevonden',0),(407716,11326,'fi','Laskunumeroa ei lÃ¶ytynyt',0),(407717,11326,'no','Finner ikke fakturanummeret',0),(407718,11326,'da','Fakturanummeret kunne ikke findes',0),(407719,11326,'ko','ì†¡ìž¥ ë²ˆí˜¸ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(407720,11326,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª',0),(407721,11326,'el','Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î²ÏÎµÎ¸ÎµÎ¯ Î¿ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(407722,11326,'zh','å‘ç¥¨å·ç æ‰¾ä¸åˆ°\r\n',0),(407723,11326,'sv','Fakturanumret kunde inte hittas',0),(407724,11326,'it','Non Ã¨ possibile trovare il numero di fattura',0),(407725,11326,'tl','',0),(407726,11326,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œ',0),(407727,11326,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤¢à¥‚à¤à¤¢à¤¼à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤¸à¤•à¤¾',0),(407728,11326,'ms','Nombor invois tidak dijumpai',0),(407729,11326,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(407730,11326,'fr','Le numÃ©ro de facture est introuvable',0),(407731,11326,'jp','è«‹æ±‚æ›¸ç•ªå·ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(407732,11326,'pt','O nÃºmero da factura nÃ£o pÃ´de ser encontrado',0),(407733,11326,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(407734,11326,'es','El NÃºmero de Factura No Se EncontrÃ³',0),(407735,11326,'de','Die Rechnungsnummer konnte nicht gefunden werden',0),(407736,11326,'en','The Invoice Number Could Not Be Found',0),(407737,11327,'is','',0),(407738,11327,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¢Ø¯Ø±Ø³ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ',0),(407739,11327,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¢Ø¯Ø±Ø³ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯ ',0),(407740,11327,'tr','LÃ¼tfen bir adres ekleyin',0),(407741,11327,'pl','Prosimy o podanie adresu',0),(407742,11327,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð°Ð´Ñ€ÐµÑ',0),(407743,11327,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ù¾ØªÛ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(407744,11327,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð°Ð´Ñ€ÐµÑÑƒ',0),(407745,11327,'vi','vui lÃ²ng bao gá»“m 1 Ä‘á»‹a chá»‰',0),(407746,11327,'af','Sluit Asseblief \'n Adres In',0),(407747,11327,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i adresa',0),(407748,11327,'et','Palun lisage aadress',0),(407749,11327,'si','Prosimo, da vkljuÄite naslov',0),(407750,11327,'ba','Sertakan alamat',0),(407751,11327,'nl','Vermeld een adres',0),(407752,11327,'fi','LiitÃ¤ osoite',0),(407753,11327,'no','Ta en adresse',0),(407754,11327,'da','VedlÃ¦g en adresse',0),(407755,11327,'ko','ì£¼ì†Œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(407756,11327,'he','× × ×œ×›×œ×•×œ ×›×ª×•×‘×ª',0),(407757,11327,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î¼Î¹Î± Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(407758,11327,'zh','è¯·åˆ—å…¥ä¸€ä¸ªåœ°å€\r\n',0),(407759,11327,'sv','VÃ¤nligen inkludera en adress',0),(407760,11327,'it','Si prega di includere un indirizzo',0),(407761,11327,'tl','',0),(407762,11327,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸­à¸¢à¸¹à¹ˆ',0),(407763,11327,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤ªà¤¤à¤¾ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(407764,11327,'ms','Sila sertakan alamat',0),(407765,11327,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø¹Ù†ÙˆØ§Ù†',0),(407766,11327,'fr','Veuillez indiquer une adresse',0),(407767,11327,'jp','ãã ã•ã„ã€ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’å«ã‚ã‚‹',0),(407768,11327,'pt','Por favor inclua um endereÃ§o',0),(407769,11327,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð°Ð´Ñ€ÐµÑ',0),(407770,11327,'es','Por Favor Incluye la DirecciÃ³n',0),(407771,11327,'de','Bitte geben Sie eine Adresse',0),(407772,11327,'en','Please Include An Address',0),(407773,11328,'is','',0),(407774,11328,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø´Ù‡Ø±  Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407775,11328,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø´Ù‡Ø±  Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407776,11328,'tr','LÃ¼tfen bir ÅŸehir dahil',0),(407777,11328,'pl','ProszÄ™ podaÄ‡ miasto',0),(407778,11328,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð³Ñ€Ð°Ð´',0),(407779,11328,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø´ÛØ± Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(407780,11328,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð³Ñ€Ð°Ð´',0),(407781,11328,'vi','vui lÃ²ng bao gá»“m thÃ nh phá»‘ ',0),(407782,11328,'af','Sluit Asseblief \'n Stad In',0),(407783,11328,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i un oraÅŸ',0),(407784,11328,'et','Palun lisage linn',0),(407785,11328,'si','Prosimo, da vkljuÄite mesto',0),(407786,11328,'ba','Harap sertakan kota',0),(407787,11328,'nl','Gelieve te omvatten een stad',0),(407788,11328,'fi','SisÃ¤llytÃ¤ kaupunki',0),(407789,11328,'no','Ta en by',0),(407790,11328,'da','VedlÃ¦g en by',0),(407791,11328,'ko','ë„ì‹œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(407792,11328,'he','× × ×œ×›×œ×•×œ ×¢×™×¨',0),(407793,11328,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î¼Î¹Î± Ï€ÏŒÎ»Î·',0),(407794,11328,'zh','è¯·åˆ—å…¥ä¸€ä¸ªåŸŽå¸‚\r\n',0),(407795,11328,'sv','VÃ¤nligen inkludera en stad',0),(407796,11328,'it','Si prega di includere una cittÃ ',0),(407797,11328,'tl','',0),(407798,11328,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¹€à¸¡à¸·à¸­à¸‡',0),(407799,11328,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¶à¤¹à¤° à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(407800,11328,'ms','Sila masukkan bandar',0),(407801,11328,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ù…Ø¯ÙŠÙ†Ø©',0),(407802,11328,'fr','Veuillez inclure une ville',0),(407803,11328,'jp','éƒ½å¸‚ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(407804,11328,'pt','Por favor, inclua uma cidade',0),(407805,11328,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ð“Ð¾Ñ€Ð¾Ð´',0),(407806,11328,'es','Por Favor Incluye Una Ciudad',0),(407807,11328,'de','Bitte geben Sie eine Stadt',0),(407808,11328,'en','Please Include A City',0),(407809,11329,'is','',0),(407810,11329,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø§Ø³ØªØ§Ù†  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407811,11329,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø§Ø³ØªØ§Ù†  Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407812,11329,'tr','LÃ¼tfen bir duruma dahil',0),(407813,11329,'pl','Prosimy o podanie PaÅ„stwa',0),(407814,11329,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(407815,11329,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø±ÛŒØ§Ø³Øª Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(407816,11329,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð£ ÑÑ‚Ð°ÑšÐµ',0),(407817,11329,'vi','vui lÃ²ng cÃ³ trÆ°á»ng',0),(407818,11329,'af','Sluit Asseblief \'n Staat (Landsgebied) in ',0),(407819,11329,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i un stat',0),(407820,11329,'et','Palun lisage riik',0),(407821,11329,'si','Prosimo, da vkljuÄite drÅ¾ava',0),(407822,11329,'ba','Harap sertakan keadaan',0),(407823,11329,'nl','Gelieve te omvatten een staat',0),(407824,11329,'fi','SisÃ¤llytÃ¤ tila',0),(407825,11329,'no','Ta en tilstand',0),(407826,11329,'da','VedlÃ¦g en stat',0),(407827,11329,'ko','êµ­ê°€ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(407828,11329,'he','× × ×œ×›×œ×•×œ ×ž×“×™× ×”',0),(407829,11329,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î± Î¼Î­Î»Î¿Ï‚',0),(407830,11329,'zh','è¯·åˆ—å…¥ä¸€ä¸ªå›½å®¶\r\n',0),(407831,11329,'sv','VÃ¤nligen inkludera en stat',0),(407832,11329,'it','Si prega di includere uno stato',0),(407833,11329,'tl','',0),(407834,11329,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸§à¸¡à¸£à¸±à¸',0),(407835,11329,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤°à¤¾à¤œà¥à¤¯ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(407836,11329,'ms','Sila sertakan sebuah negeri',0),(407837,11329,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(407838,11329,'fr','Veuillez inclure un Ã‰tat',0),(407839,11329,'jp','çŠ¶æ…‹ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(407840,11329,'pt','Por favor inclua um estado',0),(407841,11329,'ru','Ð£ÐºÐ°Ð¶Ð¸Ñ‚Ðµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(407842,11329,'es','Por Favor Incluye Un Estado',0),(407843,11329,'de','Bitte geben Sie einen Zustand',0),(407844,11329,'en','Please Include A State',0),(407845,11330,'is','',0),(407846,11330,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407847,11330,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ ÙƒØ¯ Ù¾Ø³ØªÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(407848,11330,'tr','LÃ¼tfen bir Zip iÃ§erir',0),(407849,11330,'pl','ProszÄ™ podaÄ‡ pocztowy',0),(407850,11330,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸',0),(407851,11330,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø²Ù¾ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(407852,11330,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð—Ð¸Ð¿',0),(407853,11330,'vi','vui lÃ²ng bao gá»“m zip',0),(407854,11330,'af','Sluit Asseblief \'n Poskode in ',0),(407855,11330,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i un Zip',0),(407856,11330,'et','Palun lisage Zip',0),(407857,11330,'si','Prosimo, da vkljuÄite Zip',0),(407858,11330,'ba','Harap sertakan Zip',0),(407859,11330,'nl','Gelieve te omvatten een Zip',0),(407860,11330,'fi','LiitÃ¤ Zip',0),(407861,11330,'no','Ta en Zip',0),(407862,11330,'da','VedlÃ¦g en Zip',0),(407863,11330,'ko','ìš°íŽ¸ ë²ˆí˜¸ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(407864,11330,'he','× × ×œ×›×œ×•×œ Zip',0),(407865,11330,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î± Zip',0),(407866,11330,'zh','è¯·åˆ—å…¥ä¸€ä¸ªé‚®ç¼–\r\n',0),(407867,11330,'sv','VÃ¤nligen inkludera en Zip',0),(407868,11330,'it','Si prega di includere una Zip',0),(407869,11330,'tl','',0),(407870,11330,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸à¸²à¸£à¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œ',0),(407871,11330,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤œà¤¼à¤¿à¤ª à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(407872,11330,'ms','Sila sertakan satu Zip',0),(407873,11330,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(407874,11330,'fr','Veuillez inclure un Zip',0),(407875,11330,'jp','Zip ãƒ•ã‚¡ã‚¤ãƒ«ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(407876,11330,'pt','Por favor inclua um Zip',0),(407877,11330,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Zip',0),(407878,11330,'es','Por Favor Incluye Un CÃ³digo Postal',0),(407879,11330,'de','Bitte geben Sie eine ZIP-Datei',0),(407880,11330,'en','Please Include A Zip',0),(407881,11331,'is','',0),(407882,11331,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø±',0),(407883,11331,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø±',0),(407884,11331,'tr','Otomatik fatura',0),(407885,11331,'pl','Auto Bill',0),(407886,11331,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(407887,11331,'ur','Ø¢Ù¹Ùˆ Ø¨Ù„',0),(407888,11331,'sr','ÐÑƒÑ‚Ð¾ Ð‘Ð¸Ð»',0),(407889,11331,'vi','Tá»± Ä‘á»™ng hÃ³a Ä‘Æ¡n',0),(407890,11331,'af','Outo-Wetsontwerp',0),(407891,11331,'ro','Auto Bill',0),(407892,11331,'et','Auto eelnÃµu',0),(407893,11331,'si','Auto Bill',0),(407894,11331,'ba','Tagihan otomatis',0),(407895,11331,'nl','Auto Bill',0),(407896,11331,'fi','Auto Bill',0),(407897,11331,'no','Auto Bill',0),(407898,11331,'da','Auto Bill',0),(407899,11331,'ko','ìžë™ ë¹Œ',0),(407900,11331,'he','×‘×™×œ ××•×˜×•×ž×˜×™',0),(407901,11331,'el','Auto Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(407902,11331,'zh','è‡ªåŠ¨è®°å¸\r\n',0),(407903,11331,'sv','Auto Bill',0),(407904,11331,'it','Bill auto',0),(407905,11331,'tl','',0),(407906,11331,'th','à¸•à¸±à¹‹à¸§à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(407907,11331,'hi','à¤‘à¤Ÿà¥‹ à¤µà¤¿à¤§à¥‡à¤¯à¤•',0),(407908,11331,'ms','Rang undang-undang auto',0),(407909,11331,'ar','Ø¨ÙŠÙ„ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª',0),(407910,11331,'fr','Bill auto',0),(407911,11331,'jp','è‡ªå‹•ãƒ“ãƒ«',0),(407912,11331,'pt','Bill auto',0),(407913,11331,'ru','Ð‘Ð¸Ð»Ð» Ð°Ð²Ñ‚Ð¾',0),(407914,11331,'es','Auto Factura',0),(407915,11331,'de','Auto-Bill',0),(407916,11331,'en','Auto Bill',0),(407917,11332,'is','',0),(407918,11332,'dr','ÙˆØ§Ø­Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(407919,11332,'pr','ÙˆØ§Ø­Ø¯ Ø¬Ø¯ÙŠØ¯ ',0),(407920,11332,'tr','Yeni birim',0),(407921,11332,'pl','Nowa jednostka',0),(407922,11332,'bg','ÐÐ¾Ð²Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(407923,11332,'ur','Ù†Ø¦Û’ ÛŒÙˆÙ†Ù¹',0),(407924,11332,'sr','ÐÐ¾Ð²Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(407925,11332,'vi','Ä‘Æ¡n vá»‹ má»›i',0),(407926,11332,'af','Nuwe Eenheid',0),(407927,11332,'ro','Noua unitate',0),(407928,11332,'et','Uus Ã¼ksus',0),(407929,11332,'si','Nove enote',0),(407930,11332,'ba','Unit baru',0),(407931,11332,'nl','Nieuwe eenheid',0),(407932,11332,'fi','Uusi yksikkÃ¶',0),(407933,11332,'no','Ny enhet',0),(407934,11332,'da','Ny enhed',0),(407935,11332,'ko','ìƒˆë¡œìš´ ë‹¨ìœ„',0),(407936,11332,'he','×™×—×™×“×” ×—×“×©×”',0),(407937,11332,'el','ÎÎ­Î± Î¼Î¿Î½Î¬Î´Î±',0),(407938,11332,'zh','æ–°å•ä½\r\n',0),(407939,11332,'sv','Ny enhet',0),(407940,11332,'it','Nuova unitÃ ',0),(407941,11332,'tl','',0),(407942,11332,'th','à¸«à¸™à¹ˆà¸§à¸¢à¹ƒà¸«à¸¡à¹ˆ',0),(407943,11332,'hi','à¤¨à¤ˆ à¤‡à¤•à¤¾à¤ˆ',0),(407944,11332,'ms','Unit baru',0),(407945,11332,'ar','ÙˆØ­Ø¯Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(407946,11332,'fr','Nouvelle unitÃ©',0),(407947,11332,'jp','æ–°ã—ã„ãƒ¦ãƒ‹ãƒƒãƒˆ',0),(407948,11332,'pt','Nova unidade',0),(407949,11332,'ru','ÐÐ¾Ð²Ð¾Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(407950,11332,'es','Nueva Unidad',0),(407951,11332,'de','Neue Einheit',0),(407952,11332,'en','New Unit',0),(407953,11333,'is','',0),(407954,11333,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ù…Ù†ØªÙ‚Ù„  Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(407955,11333,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª  Ù…Ù†ØªÙ‚Ù„  Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(407956,11333,'tr','BaÅŸarÄ±yla aktarÄ±lan kira',0),(407957,11333,'pl','Leasingu przeniesione pomyÅ›lnie',0),(407958,11333,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³, Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(407959,11333,'ur','Ù„ÛŒØ² Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ù†ØªÙ‚Ù„ Ú©Ø± Ø¯ÛŒØ§',0),(407960,11333,'sr','Ð—Ð°ÐºÑƒÐ¿ ÑÑƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€ÐµÐ½ÐµÑ‚Ðµ',0),(407961,11333,'vi','Chuyá»ƒn há»£p Ä‘á»“ng thuÃª thÃ nh cÃ´ng',0),(407962,11333,'af','Huurkontrak Suksesvol Oorgedra',0),(407963,11333,'ro','Leasing transferat cu succes',0),(407964,11333,'et','ÃœÃ¼rilepingu Ã¼le edukalt',0),(407965,11333,'si','Zakup uspeÅ¡no prenesli',0),(407966,11333,'ba','Sewa ditransfer berhasil',0),(407967,11333,'nl','Lease met succes overgebracht',0),(407968,11333,'fi','Vuokrasopimuksen siirretty onnistuneesti',0),(407969,11333,'no','Leieavtalen overfÃ¸res',0),(407970,11333,'da','Lease overfÃ¸rt med succes',0),(407971,11333,'ko','ìž„ëŒ€ ì„±ê³µì ìœ¼ë¡œ ì „ì†¡',0),(407972,11333,'he','×©×›×™×¨×•×ª ×”×•×¢×‘×¨ ×‘×”×¦×œ×—×”',0),(407973,11333,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ Ï€Î¿Ï… Î¼ÎµÏ„Î±Ï†Î­ÏÎ¸Î·ÎºÎ±Î½ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(407974,11333,'zh','ç§ŸèµæˆåŠŸè½¬ç§»\r\n',0),(407975,11333,'sv','Hyresavtalet Ã¶verfÃ¶rts framgÃ¥ngsrikt',0),(407976,11333,'it','Locazione trasferiti con successo',0),(407977,11333,'tl','',0),(407978,11333,'th','à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¹‚à¸­à¸™à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(407979,11333,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤¿à¤¤ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(407980,11333,'ms','Pajakan yang dipindahkan berjaya',0),(407981,11333,'ar','Ø¥ÙŠØ¬Ø§Ø± Ù†Ù‚Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(407982,11333,'fr','Bail transfÃ©rÃ© avec succÃ¨s',0),(407983,11333,'jp','ãƒªãƒ¼ã‚¹ãŒæ­£å¸¸ã«è»¢é€',0),(407984,11333,'pt','LocaÃ§Ã£o transferida com sucesso',0),(407985,11333,'ru','ÐÑ€ÐµÐ½Ð´Ñ‹ Ð¿ÐµÑ€ÐµÐ´Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(407986,11333,'es','Arrendamiento Transferido Exitosamente',0),(407987,11333,'de','Lease erfolgreich Ã¼bertragen',0),(407988,11333,'en','Lease Transferred Successfully',0),(407989,11334,'is','',0),(407990,11334,'dr','ØªØ§Ø±ÙŠØ® Ø§ØªÙ…Ø§Ù…',0),(407991,11334,'pr','ØªØ§Ø±ÙŠØ® Ø§ØªÙ…Ø§Ù…',0),(407992,11334,'tr','Son kullanma tarihi',0),(407993,11334,'pl','Data zakoÅ„czenia',0),(407994,11334,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÑÐ²Ð°Ð½Ðµ',0),(407995,11334,'ur','Ù…Ù†Ø³ÙˆØ®ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(407996,11334,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÐºÐ¸Ð´Ð° Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð¾Ð´Ð½Ð¾ÑÐ°',0),(407997,11334,'vi','NgÃ y cháº¥m dá»©t',0),(407998,11334,'af','Datum van diensbeÃ«indiging',0),(407999,11334,'ro','Data de terminare',0),(408000,11334,'et','Lahkumise kuupÃ¤ev',0),(408001,11334,'si','Datum prenehanja',0),(408002,11334,'ba','Tanggal penghentian',0),(408003,11334,'nl','Einddatum',0),(408004,11334,'fi','TyÃ¶suhteen loppumispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(408005,11334,'no','Oppsigelse',0),(408006,11334,'da','Afslutningsdatoen',0),(408007,11334,'ko','ì¢…ë£Œ ë‚ ì§œ',0),(408008,11334,'he','×ª××¨×™×š ×¡×™×•×',0),(408009,11334,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(408010,11334,'zh','ç»ˆæ­¢æ—¥æœŸ\r\n',0),(408011,11334,'sv','UppsÃ¤gningsdatum',0),(408012,11334,'it','Data di cessazione',0),(408013,11334,'tl','',0),(408014,11334,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(408015,11334,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(408016,11334,'ms','Tarikh penamatan',0),(408017,11334,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ù†Ù‡Ø§Ø¡',0),(408018,11334,'fr','Date d\'expiration',0),(408019,11334,'jp','çµ‚äº†æ—¥',0),(408020,11334,'pt','Data de cessaÃ§Ã£o',0),(408021,11334,'ru','Ð”Ð°Ñ‚Ð° ÑƒÐ²Ð¾Ð»ÑŒÐ½ÐµÐ½Ð¸Ñ',0),(408022,11334,'es','Fecha de TerminaciÃ³n',0),(408023,11334,'de','KÃ¼ndigungstermin',0),(408024,11334,'en','Termination Date',0),(408025,11335,'is','',0),(408026,11335,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„ Ø¯Ø§Ø¯Ù†) Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² ÙŠØ§ Ù‡Ù…Ø²Ù…Ø§Ù† Ø¨Ø§ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§Ø´Ø¯ ',0),(408027,11335,'pr','ØªØ§Ø±ÙŠØ® Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„ Ø¯Ø§Ø¯Ù†) Ø¨Ø§ÙŠØ¯ Ù‚Ø¨Ù„ Ø§Ø² ÙŠØ§ Ù‡Ù…Ø²Ù…Ø§Ù† Ø¨Ø§ ØªØ§Ø±ÙŠØ® Ù¾Ø§ÙŠØ§Ù† Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§Ø´Ø¯ ',0),(408028,11335,'tr','Transfer tarihinden Ã¶nce veya kira bitiÅŸ tarihi olmalÄ±',0),(408029,11335,'pl','Data przelewu musi byÄ‡ przed lub w dniu zakoÅ„czenia leasingu',0),(408030,11335,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ñ€ÐµÐ´Ð¸ Ð¸Ð»Ð¸ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(408031,11335,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø³Û’ Ù¾ÛÙ„Û’ ÛŒØ§ Ù„ÛŒØ² Ø§Ø®ØªØªØ§Ù… ØªØ§Ø±ÛŒØ® Ù¾Ø± ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒÛ’',0),(408032,11335,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ðµ Ð¸Ð»Ð¸ Ð½Ð° Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð·Ð°ÐºÑƒÐ¿Ð°',0),(408033,11335,'vi','NgÃ y chuyá»ƒn pháº£i trÆ°á»›c hoáº·c Ä‘Ãºng ngÃ y thuÃª cuá»‘i cÃ¹ng',0),(408034,11335,'af','Oorplasingsdatum Moet Voor of Op Huurkontrak Enddatum Wees',0),(408035,11335,'ro','Data transferului trebuie sÄƒ fie Ã®nainte sau pe data de terminare leasing',0),(408036,11335,'et','Ãœleandmise kuupÃ¤ev peab olema enne vÃµi rendilepingu lÃµppkuupÃ¤ev',0),(408037,11335,'si','Datum prenosa mora biti pred ali na konÄni datum najema',0),(408038,11335,'ba','Tanggal transfer harus sebelum atau pada tanggal akhir sewa',0),(408039,11335,'nl','Datum van overdracht moet vÃ³Ã³r of op de einddatum van de lease-overeenkomst',0),(408040,11335,'fi','SiirtopÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n on oltava ennen tai vuokrasopimuksen pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(408041,11335,'no','Dato mÃ¥ vÃ¦re tidligere eller opp pÃ¥ Lease sluttdatoen',0),(408042,11335,'da','OverfÃ¸rsel datoen skal vÃ¦re fÃ¸r eller pÃ¥ Lease slutdato',0),(408043,11335,'ko','ì „ì†¡ ë‚ ì§œ ì´ì „ ë˜ëŠ” ìž„ëŒ€ ì¢…ë£Œì¼ì— í•´ì•¼ í•©ë‹ˆë‹¤.',0),(408044,11335,'he','×ª××¨×™×š ×”×”×¢×‘×¨×” ×—×™×™×‘ ×œ×”×™×•×ª ×œ×¤× ×™ ××• ×¢×œ ×ª××¨×™×š ×¡×™×•× ×©×›×™×¨×•×ª',0),(408045,11335,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î­Ï‰Ï‚ ÎºÎ±Î¹ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(408046,11335,'zh','è½¬è®©æ—¥æœŸå¿…é¡»åœ¨ç§Ÿèµç»“æŸæ—¥æœŸæˆ–ä¹‹å‰\r\n',0),(408047,11335,'sv','Ã–verfÃ¶ringsdatum mÃ¥ste vara innan eller pÃ¥ hyresavtalet slutdatum',0),(408048,11335,'it','Data di trasferimento deve essere prima o data di fine contratto di locazione',0),(408049,11335,'tl','',0),(408050,11335,'th','à¸§à¸±à¸™à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸•à¹‰à¸­à¸‡à¹€à¸›à¹‡à¸™à¸à¹ˆà¸­à¸™ à¸«à¸£à¸·à¸­ à¹ƒà¸™à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(408051,11335,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¯à¤¾ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¤à¤¿à¤¥à¤¿ à¤ªà¤° à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(408052,11335,'ms','Tarikh pemindahan mestilah sebelum atau pada tarikh tamat pajakan',0),(408053,11335,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† ØªØ§Ø±ÙŠØ® Ù†Ù‚Ù„ Ù‚Ø¨Ù„ Ø£Ùˆ ÙÙŠ ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(408054,11335,'fr','Date de transfert doit Ãªtre avant ou sur la Date de fin de bail',0),(408055,11335,'jp','è­²æ¸¡æ—¥å‰ã«ã€ã¾ãŸã¯ãƒªãƒ¼ã‚¹çµ‚äº†æ—¥ã«ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(408056,11335,'pt','Data de transferÃªncia deve ser antes ou na data de tÃ©rmino de locaÃ§Ã£o',0),(408057,11335,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‡Ð° Ð”Ð°Ñ‚Ð° Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ Ð´Ð¾ Ð¸Ð»Ð¸ Ð½Ð° Ð´Ð°Ñ‚Ñƒ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(408058,11335,'es','Fecha de Transferencia Debe Estar Antes O En La Fecha de TerminaciÃ³n de Arrendamiento',0),(408059,11335,'de','Transfer Datum muss vor bzw. bei Lease-Enddatum liegen.',0),(408060,11335,'en','Transfer Date Must Be Before Or On Lease End Date',0),(408061,11336,'is','',0),(408062,11336,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„ Ø¯Ø§Ø¯Ù†) Ø¨Ø§ÙŠØ¯ Ù‡Ù…Ø²Ù…Ø§Ù† ÙŠØ§Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§Ø´Ø¯ ',0),(408063,11336,'pr','ØªØ§Ø±ÙŠØ® Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„ Ø¯Ø§Ø¯Ù†) Ø¨Ø§ÙŠØ¯ Ù‡Ù…Ø²Ù…Ø§Ù† ÙŠØ§Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø´Ø±ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§Ø´Ø¯ ',0),(408064,11336,'tr','Transfer tarihi veya kira baÅŸlangÄ±Ã§ tarihinden sonra olmalÄ±dÄ±r',0),(408065,11336,'pl','Transferu Data musi byÄ‡ w lub po dacie rozpoczÄ™cia leasingu',0),(408066,11336,'bg','Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€ Ð½Ð° Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ð½Ð° Ð¸Ð»Ð¸ ÑÐ»ÐµÐ´ Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(408067,11336,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ù¾Ø± ÛŒØ§ Ù„ÛŒØ² Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Û’ Ø¨Ø¹Ø¯ ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒÛ’',0),(408068,11336,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð½Ð° Ð¸Ð»Ð¸ Ð½Ð°ÐºÐ¾Ð½ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð·Ð°ÐºÑƒÐ¿Ð°',0),(408069,11336,'vi','NgÃ y chuyá»ƒn pháº£i Ä‘Ãºng ngÃ y hoáº·c sau ngÃ y báº¯t Ä‘áº§u thuÃª',0),(408070,11336,'af','Oorplasingsdatum Moet Op of Na Huurkontrak Begindatum Wees',0),(408071,11336,'ro','Data transferului trebuie sÄƒ fie la sau dupÄƒ data de inceput de leasing',0),(408072,11336,'et','Ãœleandmise kuupÃ¤ev peab olema rendi alguse kuupÃ¤eval vÃµi pÃ¤rast',0),(408073,11336,'si','Ali po najemu zaÄetni datum mora biti datum prenosa',0),(408074,11336,'ba','Tanggal transfer harus pada atau setelah tanggal dimulai sewa',0),(408075,11336,'nl','Datum van overdracht moet op of na de begindatum van de lease-overeenkomst',0),(408076,11336,'fi','SiirtopÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n on oltava tai sen jÃ¤lkeen vuokrasopimuksen aloituspÃ¤ivÃ¤',0),(408077,11336,'no','Dato mÃ¥ vÃ¦re pÃ¥ eller etter Lease Start dato',0),(408078,11336,'da','OverfÃ¸rselsdato skal vÃ¦re pÃ¥ eller efter lejemÃ¥let Start dato',0),(408079,11336,'ko','ì „ì†¡ ë‚ ì§œì— ë˜ëŠ” ìž„ëŒ€ ì‹œìž‘ ë‚ ì§œ ì´í›„ ì—¬ì•¼ í•©ë‹ˆë‹¤.',0),(408080,11336,'he','×ª××¨×™×š ×”×”×¢×‘×¨×” ×—×™×™×‘ ×œ×”×™×•×ª ×¤×¢×™×œ ××• ×œ××—×¨ ×ª××¨×™×š ×‘×’×™×Ÿ ×—×›×™×¨×”',0),(408081,11336,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï„Î·Î½ Î® Î¼ÎµÏ„Î¬ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(408082,11336,'zh','è½¬è®©æ—¥æœŸå¿…é¡»åœ¨ç§Ÿèµå¼€å§‹æ—¥æˆ–ä¹‹åŽ\r\n',0),(408083,11336,'sv','Ã–verfÃ¶ringsdatum mÃ¥ste vara pÃ¥ eller efter Lease bÃ¶rja datum',0),(408084,11336,'it','Data di trasferimento deve essere o dopo la data di inizio locazione',0),(408085,11336,'tl','',0),(408086,11336,'th','à¸§à¸±à¸™à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸•à¹‰à¸­à¸‡à¹€à¸›à¹‡à¸™à¸šà¸™ à¸«à¸£à¸·à¸­à¸«à¸¥à¸±à¸‡ à¸ˆà¸²à¸à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(408087,11336,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤ªà¤° à¤¯à¤¾ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(408088,11336,'ms','Tarikh pemindahan mestilah pada atau selepas tarikh mulakan pajakan',0),(408089,11336,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ­ÙˆÙŠÙ„ ÙÙŠ Ø£Ùˆ Ø¨Ø¹Ø¯ ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(408090,11336,'fr','Date de transfert doit Ãªtre sur ou aprÃ¨s la Date de dÃ©but de bail',0),(408091,11336,'jp','è­²æ¸¡æ—¥ã¯ãƒªãƒ¼ã‚¹é–‹å§‹æ—¥ä»¥é™ã«ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(408092,11336,'pt','Data de transferÃªncia deve ser em ou apÃ³s a data de inÃ­cio de locaÃ§Ã£o',0),(408093,11336,'ru','Ð”Ð°Ñ‚Ð° Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸ Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ Ð½Ð° Ð¸Ð»Ð¸ Ð¿Ð¾ÑÐ»Ðµ Ð´Ð°Ñ‚Ñ‹ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(408094,11336,'es','Fecha de Transferencia Debe Estar Antes O En La Fecha de Comienza de Arrendamiento',0),(408095,11336,'de','Buchungsdatum muss am oder nach dem Mietvertrag Anfangsdatum sein.',0),(408096,11336,'en','Transfer Date Must Be On Or After Lease Begin Date',0),(408097,11337,'is','',0),(408098,11337,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‚Ø§Ù„  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(408099,11337,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‚Ø§Ù„  Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(408100,11337,'tr','Transfer tarihi seÃ§meniz gerekir',0),(408101,11337,'pl','NaleÅ¼y wybraÄ‡ datÄ™ przeniesienia',0),(408102,11337,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð°',0),(408103,11337,'ur','Ø¢Ù¾ Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(408104,11337,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÐ½Ð¾ÑÐ°',0),(408105,11337,'vi','Báº¡n Pháº£i Chá»n má»™t ngÃ y chuyá»ƒn',0),(408106,11337,'af','U moet \'n Oordragsdatum Kies',0),(408107,11337,'ro','Trebuie sÄƒ selectaÅ£i o data transferului',0),(408108,11337,'et','Valige Ã¼leandmise kuupÃ¤eva',0),(408109,11337,'si','Izberite datum prenosa',0),(408110,11337,'ba','Anda harus memilih tanggal Transfer',0),(408111,11337,'nl','Moet u een datum van overdracht',0),(408112,11337,'fi','Valitse siirron pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(408113,11337,'no','Du mÃ¥ velge en dato',0),(408114,11337,'da','Du skal vÃ¦lge en overfÃ¸rselsdato',0),(408115,11337,'ko','ì „ì†¡ ë‚ ì§œë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(408116,11337,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×ª××¨×™×š ×”×¢×‘×¨×”',0),(408117,11337,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚',0),(408118,11337,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªè½¬è®©æœŸ\r\n',0),(408119,11337,'sv','Du mÃ¥ste vÃ¤lja en Ã¶verfÃ¶ringsdatum',0),(408120,11337,'it','Ãˆ necessario selezionare una data di trasferimento',0),(408121,11337,'tl','',0),(408122,11337,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸§à¸±à¸™à¹‚à¸­à¸™',0),(408123,11337,'hi','à¤†à¤ª à¤•à¥‹à¤ˆ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(408124,11337,'ms','Anda mesti pilih tarikh pemindahan',0),(408125,11337,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ­Ø¯ÙŠØ¯ Ù…ÙˆØ¹Ø¯ Ù†Ù‚Ù„',0),(408126,11337,'fr','Vous devez sÃ©lectionner une date de transfert.',0),(408127,11337,'jp','é€é‡‘æ—¥ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(408128,11337,'pt','VocÃª deve selecionar uma data de transferÃªncia',0),(408129,11337,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð´Ð°Ñ‚Ñƒ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(408130,11337,'es','Debe Seleccionar Una Fecha de Transferencia',0),(408131,11337,'de','Sie mÃ¼ssen ein Transfer-Datum auswÃ¤hlen.',0),(408132,11337,'en','You Must Select a Transfer Date',0),(408133,11338,'is','',0),(408134,11338,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙˆØ§Ø­Ø¯ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(408135,11338,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ ÙˆØ§Ø­Ø¯ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(408136,11338,'tr','Bir birim seÃ§meniz gerekir',0),(408137,11338,'pl','NaleÅ¼y wybraÄ‡ jednostkÄ™',0),(408138,11338,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(408139,11338,'ur','Ø¢Ù¾ Ø§ÛŒÚ© ÛŒÙˆÙ†Ù¹ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(408140,11338,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(408141,11338,'vi','Báº¡n Pháº£i Chá»n má»™t Ä‘Æ¡n vá»‹',0),(408142,11338,'af','U moet \'n Eenheid Kies',0),(408143,11338,'ro','Trebuie sÄƒ selectaÅ£i o unitate de',0),(408144,11338,'et','Valige Ã¼ksus',0),(408145,11338,'si','Izbrati morate enoto',0),(408146,11338,'ba','Anda harus memilih sebuah Unit',0),(408147,11338,'nl','U moet een eenheid selecteren',0),(408148,11338,'fi','YksikkÃ¶ tÃ¤ytyy valita',0),(408149,11338,'no','Du mÃ¥ velge en enhet',0),(408150,11338,'da','Du skal vÃ¦lge en enhed',0),(408151,11338,'ko','ë‹¨ìœ„ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(408152,11338,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×™×—×™×“×”',0),(408153,11338,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î¼Î¹Î± Î¼Î¿Î½Î¬Î´Î±',0),(408154,11338,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªå•ä½\r\n',0),(408155,11338,'sv','Du mÃ¥ste vÃ¤lja en enhet',0),(408156,11338,'it','Ãˆ necessario selezionare un\'unitÃ ',0),(408157,11338,'tl','',0),(408158,11338,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸«à¸™à¹ˆà¸§à¸¢',0),(408159,11338,'hi','à¤†à¤ª à¤à¤• à¤‡à¤•à¤¾à¤ˆ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(408160,11338,'ms','Anda mesti memilih satu Unit',0),(408161,11338,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØ®ØªØ§Ø± ÙˆØ­Ø¯Ø©',0),(408162,11338,'fr','Vous devez sÃ©lectionner une unitÃ©',0),(408163,11338,'jp','å˜ä½ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(408164,11338,'pt','VocÃª deve selecionar uma unidade',0),(408165,11338,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(408166,11338,'es','Debe Seleccionar Una Unidad',0),(408167,11338,'de','Sie mÃ¼ssen eine Einheit auswÃ¤hlen.',0),(408168,11338,'en','You Must Select a Unit',0),(408169,11339,'is','',0),(408170,11339,'dr','ÙØ§ÙƒØªÙˆØ± Ø±Ø§ Ø¶Ù…ÙŠÙ…Ù‡ ÙƒÙ†ÙŠØ¯',0),(408171,11339,'pr','ÙØ§ÙƒØªÙˆØ± Ø±Ø§ Ø¶Ù…ÙŠÙ…Ù‡ ÙƒÙ†ÙŠØ¯',0),(408172,11339,'tr','Fatura ekleme',0),(408173,11339,'pl','ZaÅ‚Ä…czyÄ‡ faktury',0),(408174,11339,'bg','ÐŸÑ€Ð¸ÐºÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(408175,11339,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ù†Ø³Ù„Ú© Ú©Ø±ÛŒÚº',0),(408176,11339,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(408177,11339,'vi','ÄÃ­nh kÃ¨m cÃ¡c hÃ³a Ä‘Æ¡n',0),(408178,11339,'af','Faktuur Aanheg',0),(408179,11339,'ro','AtaÅŸaÅ£i facturÄƒ',0),(408180,11339,'et','Lisada arve',0),(408181,11339,'si','PriloÅ¾ite raÄun',0),(408182,11339,'ba','Melampirkan faktur',0),(408183,11339,'nl','Factuur koppelen',0),(408184,11339,'fi','LiittÃ¤Ã¤ laskun',0),(408185,11339,'no','Knytte faktura',0),(408186,11339,'da','Knytte faktura',0),(408187,11339,'ko','ì†¡ìž¥ ì²¨ë¶€',0),(408188,11339,'he','×œ×¦×¨×£ ×—×©×‘×•× ×™×ª',0),(408189,11339,'el','Î•Ï€Î¹ÏƒÏ…Î½Î¬ÏˆÏ„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(408190,11339,'zh','é™„ä¸Šå‘ç¥¨\r\n',0),(408191,11339,'sv','Bifoga fakturan',0),(408192,11339,'it','Allegare fattura',0),(408193,11339,'tl','',0),(408194,11339,'th','à¹à¸™à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(408195,11339,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤…à¤¨à¥à¤²à¤—à¥à¤¨ à¤•à¤°à¥‡à¤‚',0),(408196,11339,'ms','Sertakan invois',0),(408197,11339,'ar','Ø¥Ø±ÙØ§Ù‚ Ù‚Ø§Ø¦Ù…Ø© Ø­Ø³Ø§Ø¨',0),(408198,11339,'fr','Joindre facture',0),(408199,11339,'jp','è«‹æ±‚æ›¸ã‚’æ·»ä»˜ã—ã¾ã™ã€‚',0),(408200,11339,'pt','Anexar factura',0),(408201,11339,'ru','ÐŸÑ€Ð¸ÐºÑ€ÐµÐ¿Ð¸Ñ‚ÑŒ Ð¡Ñ‡ÐµÑ‚',0),(408202,11339,'es','Anexar Factura',0),(408203,11339,'de','FÃ¼gen Sie Rechnung',0),(408204,11339,'en','Attach Invoice',0),(408205,11340,'is','',0),(408206,11340,'dr','(Ù…Ø´Ø±ÙˆØ·',0),(408207,11340,'pr','ØªØ§ÙŠÙŠØ¯ Ù…Ø¹Ù„Ù‚(Ù…Ø´Ø±ÙˆØ·',0),(408208,11340,'tr','Onay bekliyor',0),(408209,11340,'pl','OczekujÄ…ce na zatwierdzenie',0),(408210,11340,'bg','Ð§Ð°ÐºÐ°Ñ‰Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(408211,11340,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ',0),(408212,11340,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ Ð½ÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾',0),(408213,11340,'vi','Äang chá» phÃª duyá»‡t',0),(408214,11340,'af','Hangende goedkeuring',0),(408215,11340,'ro','ÃŽn aÅŸteptarea aprobÄƒrii',0),(408216,11340,'et','Kinnitamise ootel',0),(408217,11340,'si','ÄŒakajoÄa odobritev',0),(408218,11340,'ba','Pending Approval',0),(408219,11340,'nl','Wacht op goedkeuring',0),(408220,11340,'fi','Odottaa hyvÃ¤ksyntÃ¤Ã¤',0),(408221,11340,'no','Avventer godkjenning',0),(408222,11340,'da','Afventer godkendelse',0),(408223,11340,'ko','ë³´ë¥˜ ì¤‘ì¸ ìŠ¹ì¸',0),(408224,11340,'he','×œ××—×¨ ××™×©×•×¨',0),(408225,11340,'el','ÎˆÎ³ÎºÏÎ¹ÏƒÎ· ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î±',0),(408226,11340,'zh','å¾…æ‰¹å‡†\r\n',0),(408227,11340,'sv','VÃ¤ntar pÃ¥ godkÃ¤nnande',0),(408228,11340,'it','In attesa di approvazione',0),(408229,11340,'tl','',0),(408230,11340,'th','à¸£à¸­à¸à¸²à¸£à¸£à¸±à¸šà¸£à¸­à¸‡',0),(408231,11340,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¸à¥à¤µà¥€à¤•à¥ƒà¤¤à¤¿',0),(408232,11340,'ms','Menunggu kelulusan',0),(408233,11340,'ar','Ø¨Ø§Ù†ØªØ¸Ø§Ø± Ø§Ù„Ù‚Ø¨ÙˆÙ„',0),(408234,11340,'fr','En attente d\'approbation',0),(408235,11340,'jp','ä¿ç•™ä¸­ã®æ‰¿èª',0),(408236,11340,'pt','AprovaÃ§Ã£o pendente',0),(408237,11340,'ru','ÐžÐ¶Ð¸Ð´Ð°ÐµÑ‚ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(408238,11340,'es','AprobaciÃ³n Pendiente',0),(408239,11340,'de','Ausstehende Genehmigung',0),(408240,11340,'en','Pending Approval',0),(408241,11341,'is','',0),(408242,11341,'dr','ØªØºÙŠÙŠØ± Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(408243,11341,'pr','ØªØºÙŠÙŠØ± Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(408244,11341,'tr','DeÄŸiÅŸiklik iste',0),(408245,11341,'pl','Å»Ä…danie zmiany',0),(408246,11341,'bg','Ð˜ÑÐºÐ°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(408247,11341,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ ÙØ±Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(408248,11341,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñƒ',0),(408249,11341,'vi','YÃªu cáº§u thay Ä‘á»•i',0),(408250,11341,'af','Verandering te versoek',0),(408251,11341,'ro','Cerere de schimbare',0),(408252,11341,'et','Taotle muudatust',0),(408253,11341,'si','Zahtevajte spremembo',0),(408254,11341,'ba','Permintaan perubahan',0),(408255,11341,'nl','Verzoek tot wijziging',0),(408256,11341,'fi','PyydÃ¤ muutosta',0),(408257,11341,'no','Be om endring',0),(408258,11341,'da','Anmod om Ã¦ndring',0),(408259,11341,'ko','ë³€ê²½ ìš”ì²­',0),(408260,11341,'he','×ž×‘×§×© ×œ×©× ×•×ª.',0),(408261,11341,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î±Î»Î»Î±Î³Î®Ï‚',0),(408262,11341,'zh','æ›´æ”¹è¯·æ±‚\r\n',0),(408263,11341,'sv','BegÃ¤r Ã¤ndring av',0),(408264,11341,'it','Richiesta modifica',0),(408265,11341,'tl','',0),(408266,11341,'th','à¸‚à¸­à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(408267,11341,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(408268,11341,'ms','Perubahan permintaan',0),(408269,11341,'ar','Ø·Ù„Ø¨ ØªØºÙŠÙŠØ±',0),(408270,11341,'fr','Demande de changement',0),(408271,11341,'jp','å¤‰æ›´ã‚’è¦æ±‚ã—ã¾ã™ã€‚',0),(408272,11341,'pt','SolicitaÃ§Ã£o de mudanÃ§a',0),(408273,11341,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(408274,11341,'es','Cambio de Solicitud',0),(408275,11341,'de','Ã„nderung anfordern',0),(408276,11341,'en','Request Change',0),(408277,11342,'is','',0),(408278,11342,'dr','(ÙˆÙŠÚ˜Ù‡) Ø¯Ø± Ú¯Ø¯Ø§Ù… Ø¬Ù†Ø³ ',0),(408279,11342,'pr','Ù…ÙƒØ§Ù† Ø«Ø§Ø¨Øª(ÙˆÙŠÚ˜Ù‡) Ø¯Ø± Ø§Ù†Ø¨Ø§Ø± ÙƒØ§Ù„Ø§ ',0),(408280,11342,'tr','Ambar iÃ§inde belirli konum',0),(408281,11342,'pl','SzczegÃ³lne miejsce w magazynie',0),(408282,11342,'bg','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð² ÑÐºÐ»Ð°Ð´Ð°',0),(408283,11342,'ur','Ú¯ÙˆØ¯Ø§Ù… Ú©Û’ Ø§Ù†Ø¯Ø± Ù…Ø®ØµÙˆØµ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(408284,11342,'sr','ÐžÐ´Ñ€ÐµÑ’ÐµÐ½Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ ÑƒÐ½ÑƒÑ‚Ð°Ñ€ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ð°',0),(408285,11342,'vi','Vá»‹ trÃ­ Ä‘áº·c biá»‡t trong nhÃ  kho',0),(408286,11342,'af','Spesifieke ligging binne pakhuis',0),(408287,11342,'ro','LocaÅ£ie specifice din cadrul depozitului',0),(408288,11342,'et','Kindlas asukohas laoruumides',0),(408289,11342,'si','DoloÄenem mestu v skladiÅ¡Äu',0),(408290,11342,'ba','Lokasi tertentu dalam gudang gambar',0),(408291,11342,'nl','Specifieke locatie binnen magazijn',0),(408292,11342,'fi','Erityinen sijainti varastossa',0),(408293,11342,'no','Bestemt plassering pÃ¥ lageret',0),(408294,11342,'da','Bestemt placering inden for lageret',0),(408295,11342,'ko','ì°½ ê³  ë‚´ì˜ íŠ¹ì • ìœ„ì¹˜',0),(408296,11342,'he','×ž×™×§×•× ×¡×¤×¦×™×¤×™ ×‘×ª×•×š ×”×ž×—×¡×Ÿ',0),(408297,11342,'el','Î£Ï…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î· Î¸Î­ÏƒÎ· Î¼Î­ÏƒÎ± ÏƒÏ„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎ·',0),(408298,11342,'zh','åœ¨ä»“åº“å†…çš„å…·ä½“ä½ç½®\r\n',0),(408299,11342,'sv','Viss plats inom lager',0),(408300,11342,'it','Posizione specifica all\'interno del magazzino',0),(408301,11342,'tl','',0),(408302,11342,'th','à¸£à¸°à¸šà¸¸à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸ à¸²à¸¢à¹ƒà¸™à¸„à¸¥à¸±à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(408303,11342,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤¸à¥à¤¥à¤¾à¤¨',0),(408304,11342,'ms','Lokasi yang tertentu dalam gudang',0),(408305,11342,'ar','Ù…ÙˆÙ‚Ø¹ Ù…Ø­Ø¯Ø¯ Ø¯Ø§Ø®Ù„ Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹',0),(408306,11342,'fr','Emplacement spÃ©cifique au sein de l\'entrepÃ´t',0),(408307,11342,'jp','å€‰åº«å†…ã®ç‰¹å®šã®å ´æ‰€',0),(408308,11342,'pt','LocalizaÃ§Ã£o especÃ­fica dentro de armazÃ©m',0),(408309,11342,'ru','ÐšÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ð¾Ðµ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð² ÑÐºÐ»Ð°Ð´',0),(408310,11342,'es','UbicaciÃ³n EspecÃ­fico del Almacen',0),(408311,11342,'de','Bestimmten Position in Lager',0),(408312,11342,'en','Specific Location Within Warehouse',0),(408313,11343,'is','',0),(408314,11343,'dr',' Ú†Ùƒ Ø¯Ø± ÙˆØ³Ø· ØªÙ‡ Ú†Ùƒ Ø¨Ø§Ù„Ø§  Ùˆ ØªÙ‡ Ú†Ùƒ Ù¾Ø§ÙŠÙŠÙ† ',0),(408315,11343,'pr',' Ú†Ùƒ Ø¯Ø± ÙˆØ³Ø· ØªÙ‡ Ú†Ùƒ Ø¨Ø§Ù„Ø§  Ùˆ ØªÙ‡ Ú†Ùƒ Ù¾Ø§ÙŠÙŠÙ† ',0),(408316,11343,'tr','YukarÄ±da orta bir saplama ve bir saplama aÅŸaÄŸÄ±da kontrol edin',0),(408317,11343,'pl','SprawdÅº w Å›rodku jeden skrÃ³towych powyÅ¼ej i jeden Pniak poniÅ¼ej',0),(408318,11343,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð² ÑÑ€ÐµÐ´Ð°Ñ‚Ð° ÐµÐ´Ð¸Ð½ Ð¿ÑŠÐ½ Ð³Ð¾Ñ€Ðµ Ð¸ ÐµÐ´Ð¸Ð½ Ñ‚Ð°Ð»Ð¾Ð½ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ',0),(408319,11343,'ur','Ø¯Ø±Ù…ÛŒØ§Ù†ÛŒ Ø§ÛŒÚ© Ø¯Ø§Ú‘Ú¾ Ú©Û’ Ø§ÙˆÙ¾Ø± Ø§ÙˆØ± Ù†ÛŒÚ†Û’ Ø§ÛŒÚ© Ø¯Ø§Ú‘Ú¾ Ù…ÛŒÚº Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(408320,11343,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ñƒ ÑÑ€ÐµÐ´Ð¸Ð½Ð¸ Ñ˜ÐµÐ´Ð°Ð½ Ð¾Ð´Ñ€ÐµÐ·Ð°Ðº Ð¸Ð·Ð½Ð°Ð´ Ð¸ Ð¸ÑÐ¿Ð¾Ð´ Ñ˜ÐµÐ´Ð½Ð¾Ð³ Ð¾Ð´ÑÐµÑ‡Ð°Ðº',0),(408321,11343,'vi','Kiá»ƒm tra trong khoáº£n giá»¯a cuá»‘n trÃªn vÃ  cuá»‘n dÆ°á»›i',0),(408322,11343,'af','Kontroleer In die middelste een saadjie bo en een saadjie hieronder',0),(408323,11343,'ro','Check-In mijloc un ciot de mai sus ÅŸi mai jos un ciot',0),(408324,11343,'et','Sisse keskel Ã¼ks VÃ¤lislingid kohal ja Ã¼ks VÃ¤lislingid allpool',0),(408325,11343,'si','Preverite v sredini en Å¡tor zgoraj in spodaj en Å¡tor',0),(408326,11343,'ba','Check In tengah rintisan satu atas dan satu rintisan di bawah ini',0),(408327,11343,'nl','Midden een Stub boven en Ã©Ã©n Stub hieronder inchecken',0),(408328,11343,'fi','Tarkistaa keskellÃ¤ yksi kanta edellÃ¤ ja yksi tynkÃ¤ alla',0),(408329,11343,'no','Sjekk i midten et Stub over og Ã©n Stub nedenfor',0),(408330,11343,'da','Check i midten en Stub ovenfor og en Stub nedenfor',0),(408331,11343,'ko','ìœ„ì˜ ì¤‘ê°„ í•œ ìŠ¤í… ë° í•œ ìŠ¤í… ì•„ëž˜ì— ì²´í¬',0),(408332,11343,'he','×¦\'×§ ××™×Ÿ ×‘×“×œ ××—×“ ×”××ž×¦×¢×™ ×œ×¢×™×œ, ×‘×“×œ ××—×“ ×œ×ž×˜×”',0),(408333,11343,'el','ÎœÎµÏƒÎ±Î¯Î¿ ÏƒÏ„Î­Î»ÎµÏ‡Î¿Ï‚ Î­Î½Î± Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ ÎºÎ±Î¹ Î­Î½Î± ÏƒÏ„Î­Î»ÎµÏ‡Î¿Ï‚ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰',0),(408334,11343,'zh','æ£€æŸ¥ä¸­é—´æœ‰ä¸Šé¢çš„å­˜æ ¹å’Œä¸‹é¢çš„å­˜æ ¹\r\n',0),(408335,11343,'sv','Kolla i mitten en Stub ovan och en Stub nedan',0),(408336,11343,'it','Check-In mezzo uno Stub sopra e sotto di uno Stub',0),(408337,11343,'tl','',0),(408338,11343,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸‚à¸±à¹‰à¸§à¸«à¸™à¸¶à¹ˆà¸‡à¸•à¸£à¸‡à¸à¸¥à¸²à¸‡à¸”à¹‰à¸²à¸™à¸šà¸™à¹à¸¥à¸°à¸‚à¸±à¹‰à¸§à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡à¸«à¸™à¸¶à¹ˆà¸‡',0),(408339,11343,'hi','à¤Šà¤ªà¤° à¤®à¤§à¥à¤¯ à¤à¤• à¤¸à¥à¤Ÿà¤¬ à¤”à¤° à¤à¤• à¤¸à¥à¤Ÿà¤¬ à¤¨à¥€à¤šà¥‡ à¤®à¥‡à¤‚ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(408340,11343,'ms','Masuk pertengahan rencana tunas yang satu di atas dan satu rencana di bawah',0),(408341,11343,'ar','ØªØ­Ù‚Ù‚ ÙÙŠ Ø§Ù„Ø£ÙˆØ³Ø· ÙƒØ¹Ø¨ ÙˆØ§Ø­Ø¯ Ø£Ø¹Ù„Ø§Ù‡ ÙˆØ£Ø¯Ù†Ø§Ù‡ ÙˆØ§Ø­Ø¯ ÙƒØ¹Ø¨',0),(408342,11343,'fr','VÃ©rifier en milieu un talon au-dessus et ci-dessous un Stub',0),(408343,11343,'jp','ä¸Šè¨˜ã®ä¸­é–“ã® 1 ã¤ã®ã‚¹ã‚¿ãƒ–ã¨ 1 ã¤ã®ã‚¹ã‚¿ãƒ–ä¸‹ãƒã‚§ãƒƒã‚¯ã‚¤ãƒ³ã—ã¾ã™ã€‚',0),(408344,11343,'pt','Verifique em mÃ©dia um esboÃ§o acima e abaixo um esboÃ§o',0),(408345,11343,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð² ÑÑ€ÐµÐ´Ð½ÐµÐ¼ Ð¾Ð´Ð½Ð¾Ð¹ Ð·Ð°Ð³Ð»ÑƒÑˆÐºÐ¸ Ð²Ñ‹ÑˆÐµ Ð¸ Ð½Ð¸Ð¶Ðµ Ð¾Ð´Ð½Ð¾Ð¹ Ð·Ð°Ð³Ð»ÑƒÑˆÐºÐ¸',0),(408346,11343,'es','Selecciona el Medio Un TalÃ³n Arriba y Un TalÃ³n Abajo',0),(408347,11343,'de','Check-In Mitte ein Stub oben und unten ein Stub',0),(408348,11343,'en','Check In Middle One Stub Above And One Stub Below',0),(408349,11344,'is','',0),(408350,11344,'dr','Ú†Ùƒ  Ø±ÙˆÙŠ Ø¯Ùˆ ØªÙ‡ Ú†Ùƒ Ø²ÙŠØ±',0),(408351,11344,'pr','Ú†Ùƒ  Ø±ÙˆÙŠ Ø¯Ùˆ ØªÙ‡ Ú†Ùƒ Ø²ÙŠØ±',0),(408352,11344,'tr','En iyi iki taslaklarÄ± Ã§eke izleyin',0),(408353,11344,'pl','SprawdÅº na gÃ³rÄ™ dwa odcinki po',0),(408354,11344,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð¿ÑŠÑ€Ð²Ð¸Ñ‚Ðµ Ð´Ð²Ðµ ÐœÑŠÐ½Ð¸Ñ‡ÐµÑ‚Ð° ÑÐ»ÐµÐ´Ð²Ð°Ñ‚',0),(408355,11344,'ur','Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± Ø¯Ùˆ Ú©Ø¦ Ù¾Ø± Ù¾Ú‘ØªØ§Ù„ Ú©ÛŒ Ù¾ÛŒØ±ÙˆÛŒ Ú©Ø±ÛŒÚº',0),(408356,11344,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð½Ð° Ð²Ñ€Ñ…Ñƒ Ð´Ð²Ð° Ð¾Ð´ÑÐµÑ‡Ñ†Ð¸Ð¼Ð° Ð¿Ñ€Ð°Ñ‚Ð¸',0),(408357,11344,'vi','SÃ©c Ä‘áº§u theo 2 cuá»‘n',0),(408358,11344,'af','Kyk op die boonste twee tjekteenblaaie volg',0),(408359,11344,'ro','Verifica pe Top douÄƒ Cioturi urmaÅ£i',0),(408360,11344,'et','Top kaks ootavad kontrollimiseks jÃ¤rgige',0),(408361,11344,'si','Potrdite na vrhu dveh Å¡krbin slediti',0),(408362,11344,'ba','Memeriksa atas dua bertopik mengikuti',0),(408363,11344,'nl','Controle op de bovenste twee Stubs volgen',0),(408364,11344,'fi','Tarkista alkuun kaksi Luokka: seuraa',0),(408365,11344,'no','Sjekk pÃ¥ toppen to andre fÃ¸lger',0),(408366,11344,'da','Check pÃ¥ Top to Stubs fÃ¸lge',0),(408367,11344,'ko','ìµœê³  2 ê°œì˜ ëª…ì„¸ì„œì— í™•ì¸ì— ë”°ë¼',0),(408368,11344,'he','×‘×¦×¢ ×‘×“×™×§×” ×¢×œ ×”×¡×¤×—×™× ×©× ×™ ×”×¢×œ×™×•×Ÿ',0),(408369,11344,'el','Î‘ÎºÎ¿Î»Î¿Ï…Î¸Î®ÏƒÏ„Îµ ÎµÎ»Î­Î³Ï‡Î¿Ï… ÏƒÏ„Î·Î½ ÎºÎ¿ÏÏ…Ï†Î® Î´ÏÎ¿ ÎµÏ€Î­ÎºÏ„Î±ÏƒÎ·',0),(408370,11344,'zh','æ£€æŸ¥å‰ä¸¤åå­˜æ ¹è·Ÿè¸ª\r\n',0),(408371,11344,'sv','Kolla pÃ¥ topp tvÃ¥ stubbar fÃ¶lja',0),(408372,11344,'it','Controllo sui primi due stub seguire',0),(408373,11344,'tl','',0),(408374,11344,'th','à¸ªà¸•à¸±à¸šà¸Šà¸±à¹‰à¸™à¸ªà¸­à¸‡à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸•à¸²à¸¡',0),(408375,11344,'hi','à¤¶à¥€à¤°à¥à¤· à¤¦à¥‹ Stubs à¤ªà¤° à¤œà¤¾à¤‚à¤š à¤•à¤¾ à¤ªà¤¾à¤²à¤¨ à¤•à¤°à¥‡à¤‚',0),(408376,11344,'ms','Mengikut Daftar di atas dua tunas',0),(408377,11344,'ar','Ø§ØªØ¨Ø¹ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ÙÙŠ Ø£Ø¹Ù„Ù‰ ÙˆØ£Ø±ÙˆÙ…Ø© Ø§Ø«Ù†ÙŠÙ†',0),(408378,11344,'fr','VÃ©rification sur les talons de deux albums de suivre',0),(408379,11344,'jp','ä¸Šã® 2 ã¤ã®ã‚¹ã‚¿ãƒ–ã«ãƒã‚§ãƒƒã‚¯ã«å¾“ã†',0),(408380,11344,'pt','Siga o cheque no topo dois Stubs',0),(408381,11344,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÑƒ Ð½Ð° Ð²ÐµÑ€Ñ…Ð½ÐµÐ¹ Ð´Ð²Ðµ Ð·Ð°Ð³Ð»ÑƒÑˆÐºÐ¸',0),(408382,11344,'es','Checa el Encima y Siguen Dos Talones',0),(408383,11344,'de','ÃœberprÃ¼fung der oberen zwei Stubs folgen',0),(408384,11344,'en','Check On Top Two Stubs Follow',0),(408385,11345,'is','',0),(408386,11345,'dr','ØªØ±ØªÙŠØ¨ ØªÙ‡ Ú†Ùƒ ',0),(408387,11345,'pr','ØªØ±ØªÙŠØ¨ ØªÙ‡ Ú†Ùƒ ',0),(408388,11345,'tr','Saplama dÃ¼zenleme',0),(408389,11345,'pl','â†‘ Porozumienie',0),(408390,11345,'bg','Ð’ÑÐµ Ð¾Ñ‰Ðµ Ð¼ÑŠÐ½Ð¸Ñ‡Ðµ Ð¿Ð¾Ð´Ñ€ÐµÐ¶Ð´Ð°Ð½Ðµ',0),(408391,11345,'ur','Ø¯Ø§Ú‘Ú¾ Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù…',0),(408392,11345,'sr','ÐžÐ´ÑÐµÑ‡Ð°Ðº Ð°Ñ€Ð°Ð½Ð¶Ð¼Ð°Ð½Ð°',0),(408393,11345,'vi','Sá»± sáº¯p xáº¿p ',0),(408394,11345,'af','Saadjie reÃ«ling',0),(408395,11345,'ro','Aranjament de ciot',0),(408396,11345,'et','VÃ¤lislingid paigutus',0),(408397,11345,'si','Å tor dogovora',0),(408398,11345,'ba','Rintisan pengaturan',0),(408399,11345,'nl','Stub regeling',0),(408400,11345,'fi','EmÃ¤lippu jÃ¤rjestely',0),(408401,11345,'no','Opprydning Arrangement',0),(408402,11345,'da','Stub Arrangement',0),(408403,11345,'ko','ìŠ¤í… ë°°ì—´',0),(408404,11345,'he','×§×¦×¨×ž×¨ ×œ×”×¡×“×¨',0),(408405,11345,'el','Î£Ï„Î­Î»ÎµÏ‡Î¿Ï‚ ÏÏÎ¸Î¼Î¹ÏƒÎ·',0),(408406,11345,'zh','å­˜æ ¹å®‰æŽ’\r\n',0),(408407,11345,'sv','Stub arrangemang',0),(408408,11345,'it','Arrangiamento di stub',0),(408409,11345,'tl','',0),(408410,11345,'th','à¸ˆà¸±à¸”à¹€à¸£à¸µà¸¢à¸‡à¸‚à¸±à¹‰à¸§',0),(408411,11345,'hi','à¤¸à¥à¤Ÿà¤¬ à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾',0),(408412,11345,'ms','Urusan tunas',0),(408413,11345,'ar','ØªØ±ØªÙŠØ¨ ÙƒØ¹Ø¨ Ø§Ù„Ø±ÙˆØªÙŠÙ†',0),(408414,11345,'fr','Arrangement de talon',0),(408415,11345,'jp','ã‚¹ã‚¿ãƒ–ã®é…ç½®',0),(408416,11345,'pt','Arranjo de esboÃ§o',0),(408417,11345,'ru','Ð—Ð°Ð³Ð»ÑƒÑˆÐºÐ° ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ',0),(408418,11345,'es','OrdenaciÃ³n de Talones',0),(408419,11345,'de','Stub-Anordnung',0),(408420,11345,'en','Stub Arrangement',0),(408421,11346,'is','',0),(408422,11346,'dr','Ø®Ø·Ø§   Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù†  Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ  Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(408423,11346,'pr','Ø®Ø·Ø§   Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù†  Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ  Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(408424,11346,'tr','DB hata dizini ekleme',0),(408425,11346,'pl','DB bÅ‚Ä…d dodanie indeksu',0),(408426,11346,'bg','DB Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð½Ð´ÐµÐºÑ',0),(408427,11346,'ur','DB Ù†Ù‚Øµ Ø§Ø´Ø§Ø±ÛŒÛ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(408428,11346,'sr','Ð”Ð‘ Ð³Ñ€ÐµÑˆÐºÐµ Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ Ð¸Ð½Ð´ÐµÐºÑÐ°',0),(408429,11346,'vi','Lá»—i do thÃªm chá»‰ sá»‘',0),(408430,11346,'af','DB kon voeg indeks',0),(408431,11346,'ro','DB eroare adÄƒugarea Index',0),(408432,11346,'et','DB viga lisades indeksi',0),(408433,11346,'si','DB napaka dodajanje indeksa',0),(408434,11346,'ba','DB kesalahan menambahkan indeks',0),(408435,11346,'nl','DB fout toe te voegen Index',0),(408436,11346,'fi','DB virhe lisÃ¤Ã¤mÃ¤llÃ¤ Index',0),(408437,11346,'no','DB feil legge indeks',0),(408438,11346,'da','DB fejl tilfÃ¸jer indeks',0),(408439,11346,'ko','DB ì˜¤ë¥˜ ì¶”ê°€ ì¸ë±ìŠ¤',0),(408440,11346,'he','DB ×©×’×™××” ×”×•×¡×¤×ª ××™× ×“×§×¡',0),(408441,11346,'el','DB ÏƒÏ†Î¬Î»Î¼Î± Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î´ÎµÎ¯ÎºÏ„Î·Ï‚',0),(408442,11346,'zh','æ•°æ®åº“é”™è¯¯æ·»åŠ æŒ‡æ•°\r\n',0),(408443,11346,'sv','DB fel att lÃ¤gga till Index',0),(408444,11346,'it','Indice di errore aggiungendo DB',0),(408445,11346,'tl','',0),(408446,11346,'th','à¸”à¸±à¸Šà¸™à¸µà¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸” DB',0),(408447,11346,'hi','DB à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¸à¥‚à¤šà¤•à¤¾à¤‚à¤•',0),(408448,11346,'ms','DB ralat menambah Indeks',0),(408449,11346,'ar','Ø®Ø·Ø£ Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø§Ù„ÙÙ‡Ø±Ø³',0),(408450,11346,'fr','DB erreur ajout d\'Index',0),(408451,11346,'jp','DB ã‚¨ãƒ©ãƒ¼ã®è¿½åŠ ã‚¤ãƒ³ãƒ‡ãƒƒã‚¯ã‚¹',0),(408452,11346,'pt','DB erro adicionando Ã­ndice',0),(408453,11346,'ru','DB Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¸Ð½Ð´ÐµÐºÑ',0),(408454,11346,'es','Error de DB Agregando Indice',0),(408455,11346,'de','DB Fehlerindex hinzufÃ¼gen',0),(408456,11346,'en','DB Error Adding Index',0),(408457,11347,'is','',0),(408458,11347,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¯Ø±ÙŠØ§ÙØª Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ  Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(408459,11347,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¯Ø±ÙŠØ§ÙØª Ø±Ø§Ù‡Ù†Ù…Ø§ÙŠ  Ø¨Ø§Ù†Ùƒ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ ',0),(408460,11347,'tr','Dizin alma DB hatasÄ±',0),(408461,11347,'pl','BÅ‚Ä…d DB indeksÃ³w',0),(408462,11347,'bg','DB Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ð´ÐµÐºÑÐ¸',0),(408463,11347,'ur','DB Ú©Û’ Ø§Ø´Ø§Ø±ÛŒÛ Ø¬Ø§Øª Ø­Ø§ØµÙ„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(408464,11347,'sr','Ð”Ð‘ Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐ° Ð¸Ð½Ð´ÐµÐºÑÐµ',0),(408465,11347,'vi','Lá»—i do láº¥y chá»‰ sá»‘',0),(408466,11347,'af','DB fout kry indekse',0),(408467,11347,'ro','Eroare DB indexuri',0),(408468,11347,'et','DB viga saada indeksid',0),(408469,11347,'si','Napaka DB indeksov',0),(408470,11347,'ba','DB kesalahan indeks',0),(408471,11347,'nl','DB Error Getting indexen',0),(408472,11347,'fi','DB Virhe haettaessa indeksit',0),(408473,11347,'no','DB feil fÃ¥ indekser',0),(408474,11347,'da','DB fejl at fÃ¥ indeks',0),(408475,11347,'ko','DB ì˜¤ë¥˜ ì¸ë±ìŠ¤ë¥¼ ì§€ ê³ ',0),(408476,11347,'he','DB ××™×¨×¢×” ×©×’×™××” ××™× ×“×§×¡×™×',0),(408477,11347,'el','DB ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î»Î®ÏˆÎ· ÎµÏ…ÏÎµÏ„Î®ÏÎ¹Î±',0),(408478,11347,'zh','æ•°æ®åº“é”™è¯¯èŽ·å–æŒ‡æ ‡\r\n',0),(408479,11347,'sv','DB fel vid index',0),(408480,11347,'it','Errore DB ottenendo indici',0),(408481,11347,'tl','',0),(408482,11347,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸” DB à¸£à¸±à¸šà¸”à¸±à¸Šà¸™à¸µ',0),(408483,11347,'hi','à¤…à¤¨à¥à¤•à¥à¤°à¤®à¤¿à¤¤ à¤¹à¥‹ à¤°à¤¹à¥€ DB à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(408484,11347,'ms','Ralat DB yang mendapatkan Indeks',0),(408485,11347,'ar','Ø®Ø·Ø£ Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¬Ø§Ø¹ Ø§Ù„ÙÙ‡Ø§Ø±Ø³',0),(408486,11347,'fr','Erreur DB Indexes',0),(408487,11347,'jp','DB ã‚¨ãƒ©ãƒ¼ã®ã‚¤ãƒ³ãƒ‡ãƒƒã‚¯ã‚¹ã‚’å–å¾—',0),(408488,11347,'pt','DB erro ao obter Ã­ndices',0),(408489,11347,'ru','DB Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ð¸Ð½Ð´ÐµÐºÑÑ‹',0),(408490,11347,'es','Error de DB Consiguendo Indices',0),(408491,11347,'de','DB Fehler beim Abrufen der Indizes',0),(408492,11347,'en','DB Error Getting Indexes',0),(408493,11348,'is','',0),(408494,11348,'dr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ Ù‡Ø³ØªÙ†Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(408495,11348,'pr','ØªØ§Ø±ÙŠØ® Ù‡Ø§ Ù‡Ø³ØªÙ†Ø¯ Ø¨Ø±Ø§ÙŠ ',0),(408496,11348,'tr','Tarihler iÃ§in vardÄ±r.',0),(408497,11348,'pl','Daty sÄ… dla',0),(408498,11348,'bg','Ð”Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐ° Ð·Ð°',0),(408499,11348,'ur','ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©Û’ Ù„Ø¦Û’ ÛÛŒÚº Û”',0),(408500,11348,'sr','Ð”Ð°Ñ‚ÑƒÐ¼Ð¸ ÑÑƒ Ð·Ð°',0),(408501,11348,'vi','cÃ¡c ngÃ y lÃ  cho',0),(408502,11348,'af','Datums Is Vir',0),(408503,11348,'ro','Datele sunt pentru',0),(408504,11348,'et','KuupÃ¤evad on',0),(408505,11348,'si','Datumi so za',0),(408506,11348,'ba','Tanggal adalah untuk',0),(408507,11348,'nl','Datums zijn voor',0),(408508,11348,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t ovat',0),(408509,11348,'no','Datoer er',0),(408510,11348,'da','Datoer er For',0),(408511,11348,'ko','ë‚ ì§œëŠ”',0),(408512,11348,'he','×”×ª××¨×™×›×™× ×”× ×¢×‘×•×¨',0),(408513,11348,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚ Î±Ï†Î¿ÏÎ¿ÏÎ½',0),(408514,11348,'zh','æ—¥æœŸä¸º\r\n',0),(408515,11348,'sv','Datum Ã¤r fÃ¶r',0),(408516,11348,'it','Le date sono per',0),(408517,11348,'tl','',0),(408518,11348,'th','à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¸¡à¸µà¸ªà¸³à¸«à¸£à¸±à¸š',0),(408519,11348,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¤¾à¤°à¥€à¤–à¥‹à¤‚ à¤¹à¥ˆà¤‚',0),(408520,11348,'ms','Tarikh akan bagi',0),(408521,11348,'ar','Ø§Ù„ØªÙˆØ§Ø±ÙŠØ®',0),(408522,11348,'fr','Les dates sont pour',0),(408523,11348,'jp','æ—¥ä»˜ã¯',0),(408524,11348,'pt','As datas sÃ£o para',0),(408525,11348,'ru','Ð”Ð°Ñ‚Ñ‹ Ð”Ð»Ñ',0),(408526,11348,'es','Fechas Son Para',0),(408527,11348,'de','Termine sind fÃ¼r',0),(408528,11348,'en','Dates Are For',0),(408529,11349,'is','',0),(408530,11349,'dr','ØªØ§Ø±ÙŠØ® Ø§ÙˆÙ„ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(408531,11349,'pr','ØªØ§Ø±ÙŠØ® Ø§ÙˆÙ„ÙŠÙ† ÙØ§ÙƒØªÙˆØ± ',0),(408532,11349,'tr','Ä°lk fatura tarihi',0),(408533,11349,'pl','Data pierwszej fakturze',0),(408534,11349,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿ÑŠÑ€Ð²Ð°Ñ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(408535,11349,'ur','ØªØ§Ø±ÛŒØ® Ù¾ÛÙ„ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(408536,11349,'sr','ÐŸÑ€Ð²Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(408537,11349,'vi','NgÃ y Ä‘áº§u tiÃªn cá»§a hÃ³a Ä‘Æ¡n',0),(408538,11349,'af','Datum Eerste Faktuur',0),(408539,11349,'ro','Data prima factura',0),(408540,11349,'et','KuupÃ¤ev esimese arve',0),(408541,11349,'si','Datum prvega raÄuna',0),(408542,11349,'ba','Tanggal faktur pertama',0),(408543,11349,'nl','Datum eerste factuur',0),(408544,11349,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ ensimmÃ¤isen laskun',0),(408545,11349,'no','Dato fÃ¸rste faktura',0),(408546,11349,'da','Dato fÃ¸rste faktura',0),(408547,11349,'ko','ë‚ ì§œ ì²« ë²ˆì§¸ ì¸ë³´ì´ìŠ¤',0),(408548,11349,'he','×ª××¨×™×š ×”×—×©×‘×•× ×™×ª ×”×¨××©×•× ×”',0),(408549,11349,'el','Î ÏÏŽÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹ÏŒ ÏƒÎ±Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(408550,11349,'zh','ç¬¬ä¸€å¼ å‘ç¥¨æ—¥æœŸ\r\n',0),(408551,11349,'sv','Datum fÃ¶rsta fakturan',0),(408552,11349,'it','Data prima fattura',0),(408553,11349,'tl','',0),(408554,11349,'th','à¸§à¸±à¸™à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œà¹à¸£à¸',0),(408555,11349,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤ªà¤¹à¤²à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(408556,11349,'ms','Tarikh pertama invois',0),(408557,11349,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(408558,11349,'fr','Date premiÃ¨re facture',0),(408559,11349,'jp','æœ€åˆã®è«‹æ±‚æ›¸ã®æ—¥ä»˜',0),(408560,11349,'pt','Data primeira fatura',0),(408561,11349,'ru','Ð”Ð°Ñ‚Ð° ÐŸÐµÑ€Ð²Ð¾Ð³Ð¾ Ð¡Ñ‡ÐµÑ‚Ð°',0),(408562,11349,'es','Fecha de Primera Factura',0),(408563,11349,'de','Datum erste Rechnung',0),(408564,11349,'en','Date First Invoice',0),(408565,11350,'is','',0),(408566,11350,'dr','Ø¯Ø± Ø³ÙŠØ³ØªÙ… Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(408567,11350,'pr','Ø¯Ø± Ø³ÙŠØ³ØªÙ… Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(408568,11350,'tr','Sisteme girilen',0),(408569,11350,'pl','Wprowadzone do systemu',0),(408570,11350,'bg','Ð’Ð»ÑÐ·ÑŠÐ» Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(408571,11350,'ur','Ù†Ø¸Ø§Ù… Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(408572,11350,'sr','Ð£Ð½ÐµÑ‚Ðµ Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼',0),(408573,11350,'vi','Ä‘Ã£ nháº­p vÃ o há»‡ thá»‘ng',0),(408574,11350,'af','Stelsel aangegaan',0),(408575,11350,'ro','Introduse Ã®n sistem',0),(408576,11350,'et','SÃ¼steemi sisestatud',0),(408577,11350,'si','Vneseni v sistem',0),(408578,11350,'ba','Masuk ke dalam sistem',0),(408579,11350,'nl','In systeem ingevoerd',0),(408580,11350,'fi','Tuli jÃ¤rjestelmÃ¤Ã¤n',0),(408581,11350,'no','Inn i systemet',0),(408582,11350,'da','IndgÃ¥et i System',0),(408583,11350,'ko','ì‹œìŠ¤í…œì— ìž…ë ¥',0),(408584,11350,'he','× ×›× ×¡ ×œ×ª×•×š ×”×ž×¢×¨×›×ª',0),(408585,11350,'el','ÎˆÏ‡Î¿Ï…Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¸ÎµÎ¯ ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(408586,11350,'zh','è¿›å…¥ç³»ç»Ÿ\r\n',0),(408587,11350,'sv','In i systemet',0),(408588,11350,'it','Inseriti nel sistema',0),(408589,11350,'tl','',0),(408590,11350,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(408591,11350,'hi','à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(408592,11350,'ms','Dimasukkan ke dalam sistem',0),(408593,11350,'ar','Ø¯Ø®Ù„Øª ÙÙŠ Ù†Ø¸Ø§Ù…',0),(408594,11350,'fr','EntrÃ© dans le systÃ¨me',0),(408595,11350,'jp','ã‚·ã‚¹ãƒ†ãƒ ã«å…¥åŠ›ã•ã‚Œã¾ã™ã€‚',0),(408596,11350,'pt','Entrou no sistema',0),(408597,11350,'ru','Ð’Ð²ÐµÐ´ÐµÐ½Ð¾ Ð’ Ð¡Ð¸ÑÑ‚ÐµÐ¼Ñƒ',0),(408598,11350,'es','Entrado Dentro de Sistema',0),(408599,11350,'de','In System eingegeben',0),(408600,11350,'en','Entered Into System',0),(408601,11351,'is','',0),(408602,11351,'dr','Ø§ÙˆÙ„ÙŠÙ† ÙØ§ÙƒØªÙˆØ± Ø¨ÙŠÙ† ',0),(408603,11351,'pr','Ø§ÙˆÙ„ÙŠÙ† ÙØ§ÙƒØªÙˆØ± Ø¨ÙŠÙ† ',0),(408604,11351,'tr','Ä°lk fatura arasÄ±nda',0),(408605,11351,'pl','Pierwsza faktura miÄ™dzy',0),(408606,11351,'bg','ÐŸÑŠÑ€Ð²Ð°Ñ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¼ÐµÐ¶Ð´Ñƒ',0),(408607,11351,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù†',0),(408608,11351,'sr','ÐŸÑ€Ð²Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¸Ð·Ð¼ÐµÑ’Ñƒ',0),(408609,11351,'vi','hÃ³a Ä‘Æ¡n Ä‘áº§u tiÃªn giá»¯a',0),(408610,11351,'af','Eerste faktuur tussen',0),(408611,11351,'ro','Prima factura Ã®ntre',0),(408612,11351,'et','Esimene arve vahel',0),(408613,11351,'si','Prvi raÄun med',0),(408614,11351,'ba','Faktur pertama antara',0),(408615,11351,'nl','Eerste factuur tussen',0),(408616,11351,'fi','EnsimmÃ¤isen laskun vÃ¤lillÃ¤',0),(408617,11351,'no','FÃ¸rste faktura mellom',0),(408618,11351,'da','FÃ¸rste faktura mellem',0),(408619,11351,'ko','ì‚¬ì´ ì²« ë²ˆì§¸ ì¸ë³´ì´ìŠ¤',0),(408620,11351,'he','×”×—×©×‘×•× ×™×ª ×”×¨××©×•× ×” ×‘×™×Ÿ',0),(408621,11351,'el','Î ÏÏŽÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹ÏŒ ÏƒÎ±Ï‚ Î¼ÎµÏ„Î±Î¾Ï',0),(408622,11351,'zh','ç¬¬ä¸€å¼ å‘ç¥¨ä¹‹é—´\r\n',0),(408623,11351,'sv','FÃ¶rsta fakturan mellan',0),(408624,11351,'it','Prima fattura tra',0),(408625,11351,'tl','',0),(408626,11351,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹à¸£à¸à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡',0),(408627,11351,'hi','à¤•à¥‡ à¤¬à¥€à¤š à¤ªà¤¹à¤²à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(408628,11351,'ms','Invois yang pertama antara',0),(408629,11351,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø£ÙˆÙ„Ù‰ Ø¨ÙŠÙ†',0),(408630,11351,'fr','PremiÃ¨re facture entre',0),(408631,11351,'jp','é–“æœ€åˆã®è«‹æ±‚',0),(408632,11351,'pt','Primeira fatura entre',0),(408633,11351,'ru','ÐŸÐµÑ€Ð²Ñ‹Ð¹ Ð¡Ñ‡ÐµÑ‚ ÐœÐµÐ¶Ð´Ñƒ',0),(408634,11351,'es','Primera Factura Entre',0),(408635,11351,'de','Ersten Rechnung zwischen',0),(408636,11351,'en','First Invoice Between',0),(408637,11352,'is','',0),(408638,11352,'dr','ÙŠØ§ ÙØ§ÙƒØªÙˆØ± Ø§ÙˆÙ„ÙŠÙ‡ Ø¨ÙŠÙ† ',0),(408639,11352,'pr','ÙŠØ§ ÙØ§ÙƒØªÙˆØ± Ø§ÙˆÙ„ÙŠÙ‡ Ø¨ÙŠÙ† ',0),(408640,11352,'tr','Veya arasÄ±nda ilk fatura',0),(408641,11352,'pl','Lub pierwszej fakturze miÄ™dzy',0),(408642,11352,'bg','Ð˜Ð»Ð¸ Ð¿ÑŠÑ€Ð²Ð°Ñ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¼ÐµÐ¶Ð´Ñƒ',0),(408643,11352,'ur','ÛŒØ§ Ù¾ÛÙ„Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù†',0),(408644,11352,'sr','Ð˜Ð»Ð¸ Ð¿Ñ€Ð²Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¸Ð·Ð¼ÐµÑ’Ñƒ',0),(408645,11352,'vi','Hoáº·c cÃ¡c hÃ³a Ä‘Æ¡n Ä‘áº§u tiÃªn giá»¯a',0),(408646,11352,'af','Of eerste faktuur tussen',0),(408647,11352,'ro','Sau prima factura Ã®ntre',0),(408648,11352,'et','VÃµi esimese arve vahel',0),(408649,11352,'si','Ali prvega raÄuna med',0),(408650,11352,'ba','Atau faktur pertama antara',0),(408651,11352,'nl','Of eerste factuur tussen',0),(408652,11352,'fi','Tai ensimmÃ¤isen laskun vÃ¤lillÃ¤',0),(408653,11352,'no','Eller fÃ¸rste faktura mellom',0),(408654,11352,'da','Eller fÃ¸rste faktura mellem',0),(408655,11352,'ko','ë˜ëŠ” ì²« ë²ˆì§¸ ì¸ë³´ì´ìŠ¤ ì‚¬ì´',0),(408656,11352,'he','××• ×—×©×‘×•× ×™×ª ×¨××©×•× ×” ×‘×™×Ÿ',0),(408657,11352,'el','Î‰ Ï€ÏÏŽÏ„Î· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¼ÎµÏ„Î±Î¾Ï',0),(408658,11352,'zh','æˆ–ç¬¬ä¸€æœŸå‘ç¥¨\r\n',0),(408659,11352,'sv','Eller fÃ¶rsta faktura mellan',0),(408660,11352,'it','O prima fattura tra',0),(408661,11352,'tl','',0),(408662,11352,'th','à¸«à¸£à¸·à¸­à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹à¸£à¸à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡',0),(408663,11352,'hi','à¤¯à¤¾ à¤¬à¥€à¤š à¤ªà¤¹à¤²à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(408664,11352,'ms','Atau invois pertama antara',0),(408665,11352,'ar','Ø£Ùˆ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø£ÙˆÙ„Ù‰ Ø¨ÙŠÙ†',0),(408666,11352,'fr','Ou premiÃ¨re facture entre',0),(408667,11352,'jp','é–“æœ€åˆã®è«‹æ±‚æ›¸ã¾ãŸã¯',0),(408668,11352,'pt','Ou primeira fatura entre',0),(408669,11352,'ru','Ð˜Ð»Ð¸ ÐŸÐµÑ€Ð²Ñ‹Ð¹ Ð¡Ñ‡ÐµÑ‚ Ð’ ÐŸÐµÑ€Ð¸Ð¾Ð´ ',0),(408670,11352,'es','O Primera Factura Entre',0),(408671,11352,'de','Oder ersten Rechnung zwischen',0),(408672,11352,'en','Or First Invoice Between',0),(408673,11353,'is','',0),(408674,11353,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡',0),(408675,11353,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ø§Ø¬Ø§Ø±Ù‡',0),(408676,11353,'tr','Sadece kira faturalarÄ± gÃ¶ster',0),(408677,11353,'pl','PokaÅ¼ tylko faktury dzierÅ¼awy',0),(408678,11353,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(408679,11353,'ur','ÙÙ‚Ø· Ù„ÛŒØ² ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(408680,11353,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð·Ð°ÐºÑƒÐ¿ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(408681,11353,'vi','Hiá»ƒn thá»‹ chá»‰ thuÃª hÃ³a Ä‘Æ¡n',0),(408682,11353,'af','Wys Slegs Fakture vir Verhurings',0),(408683,11353,'ro','AratÄƒ doar facturile de leasing',0),(408684,11353,'et','NÃ¤ita ainult rendi arveid',0),(408685,11353,'si','PokaÅ¾i le zakup raÄunov',0),(408686,11353,'ba','Tampilkan hanya sewa faktur',0),(408687,11353,'nl','Toon alleen Lease facturen',0),(408688,11353,'fi','NÃ¤ytÃ¤ vain leasing laskut',0),(408689,11353,'no','Vis bare Lease fakturaer',0),(408690,11353,'da','Vis kun Lease fakturaer',0),(408691,11353,'ko','ìž„ëŒ€ ì²­êµ¬ì„œë§Œ í‘œì‹œ',0),(408692,11353,'he','×”×¦×’ ×¨×§ ×©×›×™×¨×•×ª ×—×©×‘×•× ×™×•×ª',0),(408693,11353,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(408694,11353,'zh','ä»…æ˜¾ç¤ºç§Ÿèµå‘ç¥¨\r\n',0),(408695,11353,'sv','Visa endast hyra fakturor',0),(408696,11353,'it','Visualizza solo le fatture di leasing',0),(408697,11353,'tl','',0),(408698,11353,'th','à¹à¸ªà¸”à¸‡à¹€à¸‰à¸žà¸²à¸°à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸‚à¸­à¸‡à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(408699,11353,'hi','à¤•à¥‡à¤µà¤² à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤šà¤¾à¤²à¤¾à¤¨ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(408700,11353,'ms','Menunjukkan hanya pajakan invois',0),(408701,11353,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªØ£Ø¬ÙŠØ± ÙÙ‚Ø·',0),(408702,11353,'fr','Afficher uniquement les factures de location',0),(408703,11353,'jp','ãƒªãƒ¼ã‚¹ã®è«‹æ±‚æ›¸ã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(408704,11353,'pt','Mostrar apenas locaÃ§Ã£o de facturas',0),(408705,11353,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð°Ñ€ÐµÐ½Ð´Ñƒ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(408706,11353,'es','Muestra Solamente Facturas de Arrendamiento',0),(408707,11353,'de','Nur Leasing Rechnungen anzeigen',0),(408708,11353,'en','Show Only Lease Invoices',0),(408709,11354,'is','',0),(408710,11354,'dr','Ù…Ø¹Ù…Ø§Ø±',0),(408711,11354,'pr','Ù…Ø¹Ù…Ø§Ø±',0),(408712,11354,'tr','Mimar',0),(408713,11354,'pl','Architekt',0),(408714,11354,'bg','ÐÑ€Ñ…Ð¸Ñ‚ÐµÐºÑ‚',0),(408715,11354,'ur','Ù…Ø¹Ù…Ø§Ø±',0),(408716,11354,'sr','ÐÑ€Ñ…Ð¸Ñ‚ÐµÐºÑ‚Ð°',0),(408717,11354,'vi','Kiáº¿n trÃºc sÆ°',0),(408718,11354,'af','Argitek',0),(408719,11354,'ro','Arhitect',0),(408720,11354,'et','Arhidekt',0),(408721,11354,'si','Arhitekt',0),(408722,11354,'ba','Arsitek',0),(408723,11354,'nl','Architect',0),(408724,11354,'fi','Arkkitehti',0),(408725,11354,'no','Arkitekt',0),(408726,11354,'da','Arkitekt',0),(408727,11354,'ko','ê±´ì¶•ê°€',0),(408728,11354,'he','××“×¨×™×›×œ',0),(408729,11354,'el','Î‘ÏÏ‡Î¹Ï„Î­ÎºÏ„Î¿Î½Î±Ï‚',0),(408730,11354,'zh','å»ºç­‘å¸ˆ\r\n',0),(408731,11354,'sv','Arkitekt',0),(408732,11354,'it','Architetto',0),(408733,11354,'tl','',0),(408734,11354,'th','à¸ªà¸–à¸²à¸›à¸™à¸´à¸',0),(408735,11354,'hi','à¤µà¤¾à¤¸à¥à¤¤à¥à¤•à¤¾à¤°',0),(408736,11354,'ms','Arkitek',0),(408737,11354,'ar','Ù…Ù‡Ù†Ø¯Ø³ Ù…Ø¹Ù…Ø§Ø±ÙŠ',0),(408738,11354,'fr','Architecte',0),(408739,11354,'jp','å»ºç¯‰å®¶',0),(408740,11354,'pt','Arquiteto',0),(408741,11354,'ru','ÐÑ€Ñ…Ð¸Ñ‚ÐµÐºÑ‚Ð¾Ñ€',0),(408742,11354,'es','Arquitecto',0),(408743,11354,'de','Architekt',0),(408744,11354,'en','Architect',0),(408745,11355,'is','',0),(408746,11355,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾Ø±ÙˆÚ˜Ù‡ Ù…Ø´ØªØ±ÙŠ ',0),(408747,11355,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾Ø±ÙˆÚ˜Ù‡ Ù…Ø´ØªØ±ÙŠ ',0),(408748,11355,'tr','Ä°stemci proje numarasÄ±',0),(408749,11355,'pl','Numer projektu klienta',0),(408750,11355,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(408751,11355,'ur','ÙˆØµÙˆÙ„ Ú©Ø§Ø± Ù¾Ø±Ø§Ø¬ÛŒÚ©Ù¹ Ù†Ù…Ø¨Ø±',0),(408752,11355,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð° Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ‚Ð°',0),(408753,11355,'vi','Sá»‘ dá»± Ã¡n khÃ¡ch hÃ ng',0),(408754,11355,'af','Klient Projeknommer',0),(408755,11355,'ro','NumÄƒrul de proiect client',0),(408756,11355,'et','Kliendi projekti Number',0),(408757,11355,'si','Å tevilka projekta odjemalca',0),(408758,11355,'ba','Jumlah Proyek client',0),(408759,11355,'nl','Project klantnummer',0),(408760,11355,'fi','Asiakasnumero projektin',0),(408761,11355,'no','Prosjektnummeret for klient',0),(408762,11355,'da','Klienten projektnummer',0),(408763,11355,'ko','í´ë¼ì´ì–¸íŠ¸ í”„ë¡œì íŠ¸ ë²ˆí˜¸',0),(408764,11355,'he','×ž×¡×¤×¨ ×”×¤×¨×•×™×™×§×˜ ×œ×œ×§×•×—',0),(408765,11355,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î­ÏÎ³Î¿Ï… Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(408766,11355,'zh','å®¢æˆ·é¡¹ç›®ç¼–å·\r\n',0),(408767,11355,'sv','Projektet kundnummer',0),(408768,11355,'it','Numero progetto client',0),(408769,11355,'tl','',0),(408770,11355,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹‚à¸„à¸£à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¹„à¸„à¸¥à¹€à¸­à¹‡à¸™à¸•à¹Œ',0),(408771,11355,'hi','à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ à¤ªà¥à¤°à¥‹à¤œà¥‡à¤•à¥à¤Ÿ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(408772,11355,'ms','Nombor projek klien',0),(408773,11355,'ar','Ø±Ù‚Ù… Ø§Ù„Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(408774,11355,'fr','NumÃ©ro du projet client',0),(408775,11355,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆ ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®æ•°',0),(408776,11355,'pt','NÃºmero do projeto cliente',0),(408777,11355,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(408778,11355,'es','Cliente NÃºmero de Proyecto',0),(408779,11355,'de','Client-Projektnummer',0),(408780,11355,'en','Client Project Number',0),(408781,11356,'is','',0),(408782,11356,'dr','ØªØ§Ø±ÙŠØ® Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(408783,11356,'pr','ØªØ§Ø±ÙŠØ® Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(408784,11356,'tr','SÃ¶zleÅŸme tarihi',0),(408785,11356,'pl','Data umowy',0),(408786,11356,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(408787,11356,'ur','Ù…Ø¹Ø§ÛØ¯Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(408788,11356,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð°',0),(408789,11356,'vi','ngÃ y há»£p Ä‘á»“ng',0),(408790,11356,'af','Kontrak Datum',0),(408791,11356,'ro','Data contractului',0),(408792,11356,'et','Lepingu kuupÃ¤ev',0),(408793,11356,'si','Datum pogodbe',0),(408794,11356,'ba','Tanggal kontrak',0),(408795,11356,'nl','Datum van het contract',0),(408796,11356,'fi','Sopimuksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(408797,11356,'no','Kontrakten dato',0),(408798,11356,'da','Kontraktens dato',0),(408799,11356,'ko','ê³„ì•½ ë‚ ì§œ',0),(408800,11356,'he','×ª××¨×™×š ×—×•×–×”',0),(408801,11356,'el','Î ÎµÏÎ±Î¯Ï‰ÏƒÎ·',0),(408802,11356,'zh','åˆåŒæ—¥æœŸ\r\n',0),(408803,11356,'sv','Avtalsdagen',0),(408804,11356,'it','Data di contratto',0),(408805,11356,'tl','',0),(408806,11356,'th','à¸§à¸±à¸™à¸‚à¸­à¸‡à¸ªà¸±à¸à¸à¸²',0),(408807,11356,'hi','à¤…à¤¨à¥à¤¬à¤‚à¤§ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(408808,11356,'ms','Tarikh kontrak',0),(408809,11356,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¹Ù‚Ø¯',0),(408810,11356,'fr','Date du contrat',0),(408811,11356,'jp','å¥‘ç´„ç· çµæ—¥',0),(408812,11356,'pt','Data do contrato',0),(408813,11356,'ru','Ð”Ð°Ñ‚Ð° ÐºÐ¾Ð½Ñ‚Ñ€Ð°ÐºÑ‚Ð°',0),(408814,11356,'es','Fecha de Contrato',0),(408815,11356,'de','Vertragsdatum',0),(408816,11356,'en','Contract Date',0),(408817,11357,'is','',0),(408818,11357,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§ Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ù†ÙŠØ³Øª',0),(408819,11357,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§ Ù…Ù‚Ø¯Ø§Ø± ØªØ¹Ù‡Ø¯ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ù†ÙŠØ³Øª',0),(408820,11357,'tr','BÃ¼tÃ§e tutarÄ±nÄ±n taahhÃ¼t tutarÄ± eÅŸleÅŸmiyor',0),(408821,11357,'pl','Kwota budÅ¼etu nie pasuje kwota zobowiÄ…zania',0),(408822,11357,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð° ÑÑƒÐ¼Ð° Ð½Ðµ ÑÑŠÐ²Ð¿Ð°Ð´Ð° Ñ Ð°Ð½Ð³Ð°Ð¶Ð¸Ð¼ÐµÐ½Ñ‚ ÑÑƒÐ¼Ð°',0),(408823,11357,'ur','Ø¨Ø¬Ù¹ Ú©ÛŒ Ø±Ù‚Ù… Ú©Û’ Ø³Ø§ØªÚ¾ ÙˆØ§Ø¨Ø³ØªÚ¯ÛŒ Ú©ÛŒ Ø±Ù‚Ù… Ú©Û’ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº',0),(408824,11357,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð±ÑƒÑŸÐµÑ‚Ð° Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐµ Ð¸Ð·Ð½Ð¾Ñ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(408825,11357,'vi','Sá» tiá»n ngÃ¢n sÃ¡ch khÃ´ng khá»›p vá»›i sá»‘ tiá»n cam káº¿t',0),(408826,11357,'af','Begroting beloop verbintenis bedrag ooreen nie',0),(408827,11357,'ro','Buget suma nu se potriveÅŸte cu cantitatea de angajament',0),(408828,11357,'et','Eelarvesumma vastavad kulukohustuste summa',0),(408829,11357,'si','ProraÄun ne ujema znesek obveznosti',0),(408830,11357,'ba','Anggaran jumlah tidak sesuai jumlah komitmen',0),(408831,11357,'nl','Gebudgetteerd bedrag komt niet overeen met het inzet bedrag',0),(408832,11357,'fi','Budjettisumma ei vastaa sitoutumista summaa',0),(408833,11357,'no','BudsjettbelÃ¸pet samsvarer ikke med engasjement belÃ¸p',0),(408834,11357,'da','BudgetbelÃ¸bet stemmer ikke overens med engagement belÃ¸b',0),(408835,11357,'ko','ì˜ˆì‚° ê¸ˆì•¡ íˆ¬ìž… ê¸ˆì•¡ì„ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(408836,11357,'he','×›×ž×•×ª ×”×ª×§×¦×™×‘ ××™× ×• ×ª×•×× ×›×ž×•×ª ×”×ž×—×•×™×‘×•×ª',0),(408837,11357,'el','Î Î¿ÏƒÏŒ Ï„Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î¼Îµ Î´Î­ÏƒÎ¼ÎµÏ…ÏƒÎ· Ï€Î¿ÏƒÎ¿Ï',0),(408838,11357,'zh','é¢„ç®—é‡‘é¢ä¸Žæ‰¿è¯ºé¢ä¸åŒ¹é…\r\n',0),(408839,11357,'sv','Budgetbeloppet matchar inte engagemang belopp',0),(408840,11357,'it','Bilancio quantitÃ  non corrisponde a quantitÃ  di impegno',0),(408841,11357,'tl','',0),(408842,11357,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸•à¸£à¸‡à¸à¸±à¸šà¸¢à¸­à¸”à¸¡à¸±à¹ˆà¸™',0),(408843,11357,'hi','à¤¬à¤œà¤Ÿ à¤°à¤¾à¤¶à¤¿ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§à¤¤à¤¾ à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(408844,11357,'ms','Jumlah bajet tidak sepadan dengan jumlah komitmen',0),(408845,11357,'ar','Ù„Ø§ ÙŠØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ù…Ù‚Ø¯Ø§Ø± Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù…Ø¨Ù„Øº Ø§Ù„Ø§Ù„ØªØ²Ø§Ù…',0),(408846,11357,'fr','Montant du budget ne correspond pas Ã  la quantitÃ© de l\'engagement',0),(408847,11357,'jp','äºˆç®—é¡ã¯ã‚³ãƒŸãƒƒãƒˆãƒ¡ãƒ³ãƒˆé¡ã¨ä¸€è‡´ã—ã¾ã›ã‚“',0),(408848,11357,'pt','Quantidade de orÃ§amento nÃ£o corresponde a quantidade de compromisso',0),(408849,11357,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð°Ñ ÑÑƒÐ¼Ð¼Ð° Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÑÑƒÐ¼Ð¼Ðµ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(408850,11357,'es','Cantidad de Presupuesto No Se Empareja la Cantidad Comprometido',0),(408851,11357,'de','Budgetbetrag stimmt nicht mit dem Engagement Betrag Ã¼berein.',0),(408852,11357,'en','Budget Amount Does Not Match Commitment Amount',0),(408853,11358,'is','',0),(408854,11358,'dr','ØªØ¹Ù‡Ø¯',0),(408855,11358,'pr','ØªØ¹Ù‡Ø¯',0),(408856,11358,'tr','BaÄŸlÄ±lÄ±k',0),(408857,11358,'pl','ZaangaÅ¼owanie',0),(408858,11358,'bg','ÐÐ½Ð³Ð°Ð¶Ð¸Ð¼ÐµÐ½Ñ‚',0),(408859,11358,'ur','Ø¹Ø²Ù…',0),(408860,11358,'sr','ÐžÐ±Ð°Ð²ÐµÐ·Ð°',0),(408861,11358,'vi','sá»± cam káº¿t',0),(408862,11358,'af','Verbintenis',0),(408863,11358,'ro','Angajamentul',0),(408864,11358,'et','Kohustus',0),(408865,11358,'si','Zavezanost',0),(408866,11358,'ba','Komitmen',0),(408867,11358,'nl','Inzet',0),(408868,11358,'fi','Sitoutuminen',0),(408869,11358,'no','Forpliktelse',0),(408870,11358,'da','Engagement',0),(408871,11358,'ko','í—Œì‹ ',0),(408872,11358,'he','×ž×—×•×™×‘×•×ª',0),(408873,11358,'el','Î”Î­ÏƒÎ¼ÎµÏ…ÏƒÎ·',0),(408874,11358,'zh','æ‰¿è¯ºä»˜æ¬¾\r\n',0),(408875,11358,'sv','Engagemang',0),(408876,11358,'it','Impegno',0),(408877,11358,'tl','',0),(408878,11358,'th','à¸„à¸§à¸²à¸¡à¸¡à¸¸à¹ˆà¸‡à¸¡à¸±à¹ˆà¸™',0),(408879,11358,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§à¤¤à¤¾',0),(408880,11358,'ms','Komitmen',0),(408881,11358,'ar','Ø§Ù„ØªØ²Ø§Ù…',0),(408882,11358,'fr','Engagement',0),(408883,11358,'jp','ã‚³ãƒŸãƒƒãƒˆãƒ¡ãƒ³ãƒˆ',0),(408884,11358,'pt','Compromisso',0),(408885,11358,'ru','ÐžÐ±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾',0),(408886,11358,'es','Compromiso',0),(408887,11358,'de','Engagement',0),(408888,11358,'en','Commitment',0),(408889,11359,'is','',0),(408890,11359,'dr','Ù‡ÙŠÚ† Ø¯Ø§Ø¯Ù‡ Ø§ÙŠ Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(408891,11359,'pr','Ù‡ÙŠÚ† Ø¯Ø§Ø¯Ù‡ Ø§ÙŠ Ø°Ø®ÙŠØ±Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(408892,11359,'tr','Kaydedilen veri yok',0),(408893,11359,'pl','Å»adne dane nie zostaÅ‚y zapisane',0),(408894,11359,'bg','ÐÑÐ¼Ð° Ð´Ð°Ð½Ð½Ð¸ Ðµ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½',0),(408895,11359,'ur','Ú©ÙˆØ¦ÛŒ ÚˆÛŒÙ¹Ø§ Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(408896,11359,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñ˜Ðµ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½Ð°.',0),(408897,11359,'vi','khÃ´ng cÃ³ dá»¯ liá»‡u Ä‘Ã£ lÆ°u',0),(408898,11359,'af','Geen Data Is Gestoor',0),(408899,11359,'ro','Nu existÄƒ date a fost salvat',0),(408900,11359,'et','Andmeid ei salvestatud',0),(408901,11359,'si','Je bil shranjen brez podatkov',0),(408902,11359,'ba','Tidak ada Data telah disimpan',0),(408903,11359,'nl','Geen gegevens zijn opgeslagen',0),(408904,11359,'fi','Tietoja ei tallennettu',0),(408905,11359,'no','Ingen Data er lagret',0),(408906,11359,'da','Ingen Data er blevet gemt',0),(408907,11359,'ko','ë°ì´í„°ë¥¼ ì €ìž¥',0),(408908,11359,'he','×œ× × ×©×ž×¨×• ×©×•× × ×ª×•× ×™×',0),(408909,11359,'el','Î”ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯',0),(408910,11359,'zh','æ²¡æœ‰å·²è¢«ä¿å­˜çš„æ•°æ®\r\n',0),(408911,11359,'sv','Inga Data har sparats',0),(408912,11359,'it','Nessun dato Ã¨ stato salvato',0),(408913,11359,'tl','',0),(408914,11359,'th','à¸¡à¸µà¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(408915,11359,'hi','à¤•à¥‹à¤ˆ à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(408916,11359,'ms','Tiada Data yang telah disimpan',0),(408917,11359,'ar','Ù„Ù… ØªØ®Ø²Ù‘Ù† Ø£ÙŠ Ø¨ÙŠØ§Ù†Ø§Øª',0),(408918,11359,'fr','Aucune donnÃ©e n\'a Ã©tÃ© enregistrÃ©e',0),(408919,11359,'jp','ãƒ‡ãƒ¼ã‚¿ã¯ä¿å­˜ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(408920,11359,'pt','Nenhum dado foi salvo',0),(408921,11359,'ru','ÐÐµÑ‚ Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ñ… Ð”Ð°Ð½Ð½Ñ‹Ñ…',0),(408922,11359,'es','No Hay Datos Guadados',0),(408923,11359,'de','Keine Daten wurde gespeichert',0),(408924,11359,'en','No Data Has Been Saved',0),(408925,11360,'is','',0),(408926,11360,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ ØªØºÙŠÙŠØ± Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(408927,11360,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ ØªØºÙŠÙŠØ± Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(408928,11360,'tr','GÃ¶stermek sadece sÄ±ra deÄŸiÅŸtirme iÅŸlemi sayÄ±sÄ±',0),(408929,11360,'pl','PokaÅ¼ tylko zmiany zamÃ³wienia',0),(408930,11360,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð° ÑÐ°Ð¼Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(408931,11360,'ur','ØµØ±Ù ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(408932,11360,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð°Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñƒ',0),(408933,11360,'vi','Chá»‰ thá»ƒ hiá»‡n nhá»¯ng Ä‘Æ¡n hÃ ng thay Ä‘á»•i',0),(408934,11360,'af','Wys net verander bestellings',0),(408935,11360,'ro','AratÄƒ doar schimba comenzi',0),(408936,11360,'et','NÃ¤ita ainult muuta tellimused',0),(408937,11360,'si','PokaÅ¾i le spremembe naroÄila',0),(408938,11360,'ba','Tampilkan hanya mengubah perintah',0),(408939,11360,'nl','Toon alleen Orders wijzigen',0),(408940,11360,'fi','NÃ¤ytÃ¤ vain muuttaa tilaukset',0),(408941,11360,'no','Vis bare endringsordrer',0),(408942,11360,'da','Vis kun Ã¦ndre ordrer',0),(408943,11360,'ko','í‘œì‹œ ìˆœì„œ ë³€ê²½',0),(408944,11360,'he','×”×¦×’ ×¨×§ ×©×™× ×•×™ ×”×–×ž× ×•×ª',0),(408945,11360,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î±Î»Î»Î¬Î¾ÎµÏ„Îµ Î¼ÏŒÎ½Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(408946,11360,'zh','ä»…æ˜¾ç¤ºæ›´æ”¹è®¢å•\r\n',0),(408947,11360,'sv','Visa endast Ã¤ndringsorder',0),(408948,11360,'it','Visualizza solo gli ordini di modifica',0),(408949,11360,'tl','',0),(408950,11360,'th','à¹à¸ªà¸”à¸‡à¹€à¸‰à¸žà¸²à¸°à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(408951,11360,'hi','à¤•à¥‡à¤µà¤² à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤–à¤¾à¤“',0),(408952,11360,'ms','Papar hanya mengubah perintah',0),(408953,11360,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙÙ‚Ø· Ø£ÙˆØ§Ù…Ø± Ø§Ù„ØªØºÙŠÙŠØ±',0),(408954,11360,'fr','Montrer seulement les ordres de modification',0),(408955,11360,'jp','å¤‰æ›´å‘½ä»¤ã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(408956,11360,'pt','Mostrar apenas os pedidos de alteraÃ§Ã£o',0),(408957,11360,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ€Ð°ÑÐ¿Ð¾Ñ€ÑÐ¶ÐµÐ½Ð¸Ð¹ Ð¾Ð± Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¸',0),(408958,11360,'es','Muestra Solamente Ordenes de Cambio',0),(408959,11360,'de','Nur Ã„nderungs-Bestellungen anzeigen',0),(408960,11360,'en','Show Only Change Orders',0),(408961,11361,'is','',0),(408962,11361,'dr','Ø®Ù„Ø§ØµÙ‡ Ø§Ø¬Ø§Ø±Ù‡ Ø¯Ø§Ø±ÙŠ ',0),(408963,11361,'pr','Ø®Ù„Ø§ØµÙ‡ Ø§Ø¬Ø§Ø±Ù‡ Ø¯Ø§Ø±ÙŠ ',0),(408964,11361,'tr','Recap leasing',0),(408965,11361,'pl','Leasing Recap',0),(408966,11361,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ñ€ÐµÐºÐ°Ð¿Ð¸Ñ‚ÑƒÐ»Ð°Ñ†Ð¸Ñ',0),(408967,11361,'ur','Ø±ÛŒÚ©Ø§Ù¾ Ù„ÛŒØ²',0),(408968,11361,'sr','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ñ€ÐµÐºÐ°Ð¿Ð¸Ñ‚ÑƒÐ»Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(408969,11361,'vi','thiáº¿t bá»‹ thuÃª',0),(408970,11361,'af','Verhuring opsom',0),(408971,11361,'ro','Recapitulare de leasing',0),(408972,11361,'et','Liisingu Recap',0),(408973,11361,'si','Leasing Rekapitulacija',0),(408974,11361,'ba','Leasing rekap',0),(408975,11361,'nl','Leasing Recap',0),(408976,11361,'fi','Leasing kertaus',0),(408977,11361,'no','Leasing oppsummering',0),(408978,11361,'da','Leasing Recap',0),(408979,11361,'ko','ìš”ì  ë˜í’€ì´ í•˜ë‹¤ë¥¼ ìž„ëŒ€',0),(408980,11361,'he','×œ×™×¡×™× ×’ Recap',0),(408981,11361,'el','Î§ÏÎ·Î¼Î±Ï„Î¿Î´Î¿Ï„Î¹ÎºÎ® Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· Recap',0),(408982,11361,'zh','ç§Ÿèµå°ç»“\r\n',0),(408983,11361,'sv','Leasing resumÃ©',0),(408984,11361,'it','Recap di leasing',0),(408985,11361,'tl','',0),(408986,11361,'th','à¹€à¸Šà¹ˆà¸²à¸›à¸°à¸¢à¸²à¸‡à¸£à¸–',0),(408987,11361,'hi','à¤ªà¥à¤¨à¤°à¥à¤•à¤¥à¤¨ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤°',0),(408988,11361,'ms','Pajakan ditemubual',0),(408989,11361,'ar','Ø§Ù„ØªØ£Ø¬ÙŠØ± Ø¨Ø§Ø®ØªØµØ§Ø±',0),(408990,11361,'fr','Location Recap',0),(408991,11361,'jp','è¦ç´„ã‚’ãƒªãƒ¼ã‚¹',0),(408992,11361,'pt','RecapitulaÃ§Ã£o de leasing',0),(408993,11361,'ru','Ð›Ð¸Ð·Ð¸Ð½Ð³ Recap',0),(408994,11361,'es','Resumen de Arrendamiento',0),(408995,11361,'de','Leasing Recap',0),(408996,11361,'en','Leasing Recap',0),(408997,11362,'is','',0),(408998,11362,'dr','(Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ',0),(408999,11362,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø­Ø±ÙƒØª (Ø¬Ø§Ø¨Ø¬Ø§ÙŠÙŠ',0),(409000,11362,'tr','AVG hareketli',0),(409001,11362,'pl','Åšrednia ruchoma',0),(409002,11362,'bg','ÐŸÑ€ÐµÐ¼ÐµÑÑ‚Ð²Ð°Ð½Ðµ Ð½Ð° Avg',0),(409003,11362,'ur','Ø§ÙˆØ³Ø· Ø¨Ú‘Ú¾Ø§ Ø±ÛØ§ ÛÛ’ Û”',0),(409004,11362,'sr','ÐŸÑ€ÐµÐ¼ÐµÑˆÑ‚Ð°ÑšÐµ ÐÐ²Ð³',0),(409005,11362,'vi','Di chuyá»ƒn Avg',0),(409006,11362,'af','Bewegende Avg',0),(409007,11362,'ro','Avg Ã®n miÅŸcare',0),(409008,11362,'et','Liikuv Avg',0),(409009,11362,'si','Gibljejo Avg',0),(409010,11362,'ba','Avg bergerak',0),(409011,11362,'nl','Bewegende Avg',0),(409012,11362,'fi','Liikkuvat Avg',0),(409013,11362,'no','Flytte Avg',0),(409014,11362,'da','Flytter Avg',0),(409015,11362,'ko','ì´ë™ í‰ê· ',0),(409016,11362,'he','×ž×ž×•×¦×¢ × ×¢',0),(409017,11362,'el','ÎšÎ¯Î½Î·ÏƒÎ· Avg',0),(409018,11362,'zh','ç§»åŠ¨å¹³å‡\r\n',0),(409019,11362,'sv','Flytta Avg',0),(409020,11362,'it','Avg in movimento',0),(409021,11362,'tl','',0),(409022,11362,'th','à¸¢à¹‰à¸²à¸¢ Avg',0),(409023,11362,'hi','à¤šà¤²à¤¤à¥€ à¤”à¤¸à¤¤',0),(409024,11362,'ms','Avg bergerak',0),(409025,11362,'ar','Ù…ØªÙˆØ³Ø· Ù…ØªØ­Ø±Ùƒ',0),(409026,11362,'fr','Moving Avg',0),(409027,11362,'jp','ç§»å‹•å¹³å‡',0),(409028,11362,'pt','Avg em movimento',0),(409029,11362,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Avg',0),(409030,11362,'es','Promedio Variable',0),(409031,11362,'de','Verschieben von Avg',0),(409032,11362,'en','Moving Avg',0),(409033,11363,'is','',0),(409034,11363,'dr','Ø§Ø¬Ø§Ø±Ù‡ ØµÙ†Ø¹ØªÙŠ',0),(409035,11363,'pr','Ø§Ø¬Ø§Ø±Ù‡ ØµÙ†Ø¹ØªÙŠ',0),(409036,11363,'tr','AR kira',0),(409037,11363,'pl','Wynajem AR',0),(409038,11363,'bg','AR Ð½Ð°ÐµÐ¼',0),(409039,11363,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ú©Ø±Ø§Ø¦Û’',0),(409040,11363,'sr','ÐÐ  ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ñƒ',0),(409041,11363,'vi','AR thuÃª',0),(409042,11363,'af','AR huur',0),(409043,11363,'ro','AR chirie',0),(409044,11363,'et','AR Rent',0),(409045,11363,'si','AR najemnine',0),(409046,11363,'ba','AR Disewa',0),(409047,11363,'nl','AR huur',0),(409048,11363,'fi','AR vuokrattavana',0),(409049,11363,'no','AR leie',0),(409050,11363,'da','AR leje',0),(409051,11363,'ko','ì•„ì¹¸ì†Œ ìž„ëŒ€',0),(409052,11363,'he','AR ×”×©×›×¨×”',0),(409053,11363,'el','AR ÎµÎ½Î¿Î¹ÎºÎ¯Î±ÏƒÎ·',0),(409054,11363,'zh','é“ç§Ÿ\r\n',0),(409055,11363,'sv','AR hyra',0),(409056,11363,'it','Affitto Appartamento AR',0),(409057,11363,'tl','',0),(409058,11363,'th','à¹€à¸Šà¹ˆà¸² AR',0),(409059,11363,'hi','à¤. à¤†à¤°. à¤¬à¤¾à¤‡à¤• à¤•à¤¿à¤°à¤¾à¤',0),(409060,11363,'ms','Sewa AR',0),(409061,11363,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± AR',0),(409062,11363,'fr','Louer AR',0),(409063,11363,'jp','AR å®¶è³ƒ',0),(409064,11363,'pt','Aluguel de AR',0),(409065,11363,'ru','AR Ð°Ñ€ÐµÐ½Ð´Ñƒ',0),(409066,11363,'es','CC Renta',0),(409067,11363,'de','AR mieten',0),(409068,11363,'en','AR Rent',0),(409069,11364,'is','',0),(409070,11364,'dr','Ù…Ù†Ø¨Ø¹ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(409071,11364,'pr','Ù…Ù†Ø¨Ø¹ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(409072,11364,'tr','Bilgi BankasÄ±',0),(409073,11364,'pl','Bazy wiedzy Knowledge Base',0),(409074,11364,'bg','Ð‘Ð°Ð·Ð°Ñ‚Ð° Ð·Ð½Ð°Ð½Ð¸Ñ',0),(409075,11364,'ur','Ø¹Ù„Ù… Ú©Ø§',0),(409076,11364,'sr','Ð‘Ð°Ð·Ðµ Ð·Ð½Ð°ÑšÐ°',0),(409077,11364,'vi','Kiáº¿n thá»©c cÆ¡ sá»Ÿ',0),(409078,11364,'af','Kennisbasis',0),(409079,11364,'ro','Baza de cunoÅŸtinÅ£e',0),(409080,11364,'et','Teadmusbaasi',0),(409081,11364,'si','Zbirke znanja',0),(409082,11364,'ba','Basis pengetahuan',0),(409083,11364,'nl','Knowledge Base',0),(409084,11364,'fi','Knowledge Base',0),(409085,11364,'no','Knowledge Base',0),(409086,11364,'da','Knowledge Base',0),(409087,11364,'ko','ê¸°ìˆ  ìžë£Œ',0),(409088,11364,'he','×ž××’×¨ ×”×™×“×¢ Knowledge Base',0),(409089,11364,'el','Î“Î½Ï‰ÏƒÎ¹Î±ÎºÎ® Î²Î¬ÏƒÎ·',0),(409090,11364,'zh','çŸ¥è¯†åº“\r\n',0),(409091,11364,'sv','Knowledge Base',0),(409092,11364,'it','Knowledge Base',0),(409093,11364,'tl','',0),(409094,11364,'th','à¸à¸²à¸™à¸„à¸§à¸²à¸¡à¸£à¸¹à¹‰',0),(409095,11364,'hi','à¤¨à¥‰à¤²à¥‡à¤œ à¤¬à¥‡à¤¸',0),(409096,11364,'ms','Pangkalan pengetahuan',0),(409097,11364,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ù…Ø¹Ø§Ø±Ù',0),(409098,11364,'fr','Base de connaissances',0),(409099,11364,'jp','ãƒŠãƒ¬ãƒƒã‚¸ ãƒ™ãƒ¼ã‚¹',0),(409100,11364,'pt','Base de conhecimento',0),(409101,11364,'ru','Ð‘Ð°Ð·Ð° Ð·Ð½Ð°Ð½Ð¸Ð¹',0),(409102,11364,'es','Base de  Conocimientos',0),(409103,11364,'de','Wissensdatenbank',0),(409104,11364,'en','Knowledge Base',0),(409105,11365,'is','',0),(409106,11365,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ù…Ø³ØªØ§Ø¬Ø±',0),(409107,11365,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÙŠØ³ØªÙ… Ù…Ø³ØªØ§Ø¬Ø±',0),(409108,11365,'tr','KiracÄ± giriÅŸ',0),(409109,11365,'pl','Najemcy logowania',0),(409110,11365,'bg','Ð’Ñ…Ð¾Ð´ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»Ð¸',0),(409111,11365,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ù„Ø§Ú¯ Ø§Ù†',0),(409112,11365,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð›Ð¾Ð³Ð¸Ð½',0),(409113,11365,'vi','NgÆ°á»i thuÃª nhÃ  Ä‘Äƒng nháº­p',0),(409114,11365,'af','Huurder Aantekening',0),(409115,11365,'ro','ChiriaÅŸ Login',0),(409116,11365,'et','ÃœÃ¼rnik Login',0),(409117,11365,'si','Prijava najemnika',0),(409118,11365,'ba','Penyewa Login',0),(409119,11365,'nl','Huurder Login',0),(409120,11365,'fi','Vuokralainen kirjautuminen',0),(409121,11365,'no','Leietaker logikk',0),(409122,11365,'da','Lejer Login',0),(409123,11365,'ko','í…Œ ë„Œ íŠ¸ ë¡œê·¸ì¸',0),(409124,11365,'he','×›× ×™×¡×ª ×“×™×™×¨',0),(409125,11365,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Ï„Î¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(409126,11365,'zh','ç§Ÿå®¢ç™»å½•\r\n',0),(409127,11365,'sv','HyresgÃ¤sten Login',0),(409128,11365,'it','Inquilino Login',0),(409129,11365,'tl','',0),(409130,11365,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(409131,11365,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤²à¥‰à¤—à¤¿à¤¨',0),(409132,11365,'ms','Log-masuk penyewa',0),(409133,11365,'ar','Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(409134,11365,'fr','Login locataire',0),(409135,11365,'jp','ãƒ†ãƒŠãƒ³ãƒˆ ãƒ­ã‚°ã‚¤ãƒ³',0),(409136,11365,'pt','Login do inquilino',0),(409137,11365,'ru','Ð›Ð¾Ð³Ð¸Ð½ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(409138,11365,'es','Login de Inquilino',0),(409139,11365,'de','Mieter-Login',0),(409140,11365,'en','Tenant Login',0),(409141,11366,'is','',0),(409142,11366,'dr','. Ù„Ø·ÙØ§ Ø±ÙˆÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§ Ù…Ø¬Ù…ÙˆØ¹ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø´Ø±ÙˆØ¹ ÙƒÙ†ÙŠØ¯',0),(409143,11366,'pr','Ø®ÙˆØ´ Ø¢Ù…Ø¯ÙŠØ¯. Ù„Ø·ÙØ§ Ø±ÙˆÙŠ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§Ù„Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯ ØªØ§ Ø´Ø±ÙˆØ¹ ÙƒÙ†ÙŠØ¯',0),(409144,11366,'tr','HoÅŸ geldiniz. Kira baÅŸlamak iÃ§in uygulama Ã¼zerinde yukarÄ±daki tÄ±klayÄ±nÄ±z.',0),(409145,11366,'pl','Zapraszamy. ProszÄ™ kliknÄ…Ä‡ na dzierÅ¼awa aplikacji powyÅ¼ej zaczÄ…Ä‡.',0),(409146,11366,'bg','Ð”Ð¾Ð±Ñ€Ðµ Ð´Ð¾ÑˆÐ»Ð¸. ÐœÐ¾Ð»Ñ, ÐºÐ»Ð¸ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ Ð·Ð° Ð´Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ.',0),(409147,11366,'ur','Ú©Ø§ Ø®ÛŒØ± Ù…Ù‚Ø¯Ù… Ú©Ø±ØªÛ’ ÛÛŒÚº Û” Ù„ÛŒØ² Ø´Ø±ÙˆØ¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ù¾ÛŒÙ„ÛŒ Ú©ÛŒØ´Ù† Ù¾Ø± Ù…Ø°Ú©ÙˆØ±Û Ø¨Ø§Ù„Ø§ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(409148,11366,'sr','Ð”Ð¾Ð±Ñ€Ð¾Ð´Ð¾ÑÐ»Ð¸. ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð¸Ð·Ð½Ð°Ð´ Ð´Ð° Ð¿Ð¾Ñ‡Ð½Ðµ.',0),(409149,11366,'vi','ChÃ o má»«ng. Vui lÃ²ng nháº¥p vÃ o nÃºt á»©ng dá»¥ng á»Ÿ trÃªn Ä‘á»ƒ báº¯t Ä‘áº§u ',0),(409150,11366,'af','Welkom.  Kliek Asseblief op Huurkontrak Aansoek hierbo om te begin.',0),(409151,11366,'ro','bun venit. VÄƒ rugÄƒm sÄƒ faceÅ£i clic pe cerere de leasing de mai sus pentru a Ã®ncepe.',0),(409152,11366,'et','Tere tulemast. KlÃµpsake kÃµigepealt eespool liisingutaotlus.',0),(409153,11366,'si','dobrodoÅ¡li. Prosimo, kliknite na najem uporabe zgoraj za zaÄetek.',0),(409154,11366,'ba','Selamat datang. Silakan klik pada sewa aplikasi di atas untuk memulai.',0),(409155,11366,'nl','Welkom. Klik op Lease toepassing hierboven om te beginnen.',0),(409156,11366,'fi','Tervetuloa. Klikkaa vuokrasopimuksen hakemuksen edellÃ¤ aloittaa.',0),(409157,11366,'no','velkommen. Klikk pÃ¥ Lease program over Ã¥ begynne.',0),(409158,11366,'da','Velkommen. Klik venligst pÃ¥ leasing ansÃ¸gning ovenfor til at begynde.',0),(409159,11366,'ko','ì˜¤ì‹  ê²ƒì„ í™˜ì˜ í•©ë‹ˆë‹¤. ìž„ëŒ€ ì‘ìš© ìœ„ì˜ ì‹œìž‘ì„ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(409160,11366,'he','×‘×¨×•×š ×”×‘×. ×× × ×œ×—×¥ ×¢×œ ×”×‘×§×©×” ×—×›×™×¨×” ×œ×¢×™×œ ×›×“×™ ×œ×”×ª×—×™×œ.',0),(409161,11366,'el','ÎšÎ±Î»ÏŽÏ‚ ÏŒÏÎ¹ÏƒÎµÏ‚. ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÎµÏ†Î±ÏÎ¼Î¿Î³Î® Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ Î¾ÎµÎºÎ¹Î½ÏŽ.',0),(409162,11366,'zh','æ¬¢è¿Žå…‰ä¸´ã€‚è¯·ç‚¹å‡»ä¸Šé¢çš„åº”ç”¨ç§Ÿèµå¼€å§‹ã€‚\r\n',0),(409163,11366,'sv','VÃ¤lkommen. VÃ¤nligen klicka pÃ¥ hyresavtalet ansÃ¶kan ovan att bÃ¶rja.',0),(409164,11366,'it','Benvenuti. Fare clic su applicazione di locazione sopra per iniziare.',0),(409165,11366,'tl','',0),(409166,11366,'th','à¸¢à¸´à¸™à¸”à¸µà¸•à¹‰à¸­à¸™à¸£à¸±à¸š à¸à¸£à¸¸à¸“à¸²à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸ªà¸¡à¸±à¸„à¸£à¹€à¸Šà¹ˆà¸²à¸—à¸µà¹ˆà¸‚à¹‰à¸²à¸‡à¸•à¹‰à¸™à¹€à¸žà¸·à¹ˆà¸­à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(409167,11366,'hi','à¤¸à¥à¤µà¤¾à¤—à¤¤ à¤¹à¥ˆ. à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤†à¤°à¤‚à¤­ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤— à¤ªà¤° à¤‡à¤¸à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚à¥¤',0),(409168,11366,'ms','Selamat datang. Sila klik pada permohonan pajakan di atas untuk memulakan.',0),(409169,11366,'ar','Ø£Ø±Ø­Ø¨. Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„Ù†Ù‚Ø± ÙÙˆÙ‚ \"ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„ØªØ£Ø¬ÙŠØ±\" Ø§Ù„Ù…Ø°ÙƒÙˆØ±Ø© Ø£Ø¹Ù„Ø§Ù‡ Ø§Ù„Ø¨Ø¯Ø¡.',0),(409170,11366,'fr','Bienvenue. S\'il vous plaÃ®t cliquez sur demande de bail ci-dessus pour commencer.',0),(409171,11366,'jp','æ­“è¿Žã—ã¾ã™ã€‚ä¸Šè¨˜ã®ãƒªãƒ¼ã‚¹é©ç”¨ã‚’é–‹å§‹ã™ã‚‹ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦ãã ã•ã„ã€‚',0),(409172,11366,'pt','Bem-vindo. Por favor, clique no aplicativo de locaÃ§Ã£o acima para comeÃ§ar.',0),(409173,11366,'ru','Ð”Ð¾Ð±Ñ€Ð¾ Ð¿Ð¾Ð¶Ð°Ð»Ð¾Ð²Ð°Ñ‚ÑŒ. ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð½Ð°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° Ð°Ñ€ÐµÐ½Ð´Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¹ Ð²Ñ‹ÑˆÐµ Ð½Ð°Ñ‡Ð°Ñ‚ÑŒ.',0),(409174,11366,'es','Bienvenido. Por Favor Hace Click en la Solicitud de Arendamiento Para Comenzar',0),(409175,11366,'de','Herzlich willkommen. Klicken Sie auf Leasing Anwendung oben zu beginnen.',0),(409176,11366,'en','Welcome. Please click on Lease Application above to begin.',0),(409177,11367,'is','',0),(409178,11367,'dr','ÙƒØ§ØºØ° Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(409179,11367,'pr','ÙƒØ§ØºØ° Ø§ÙØ±Ø§ÙŠØ´ Ù‚ÙŠÙ…Øª ÙØ±ÙˆØ´ Ù‚ÙŠÙ…Øª Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(409180,11367,'tr','Mark Up kaÄŸÄ±t stok fiyat',0),(409181,11367,'pl','Znak w gÃ³rze ksiÄ™gi zapasÃ³w cena',0),(409182,11367,'bg','ÐœÐ°Ñ€Ðº Ð½Ð°Ð³Ð¾Ñ€Ðµ Ñ…Ð°Ñ€Ñ‚Ð¸Ñ ÑÐºÐ»Ð°Ð´ Ñ†ÐµÐ½Ð°',0),(409183,11367,'ur','Ù…Ø§Ø±Ú© Ø§Ù¾ Ú©Ø§ØºØ° Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù‚ÛŒÙ…Øª',0),(409184,11367,'sr','ÐœÐ°Ñ€Ðº Ð£Ð¿ Ð¿Ð°Ð¿Ð¸Ñ€ Ð·Ð°Ð»Ð¸Ñ…Ð° Ñ†ÐµÐ½Ð°',0),(409185,11367,'vi','GiÃ¡ hÃ ng hÃ³a cá»™ng thÃªm',0),(409186,11367,'af','Merk op papier voorraad prys',0),(409187,11367,'ro','Mark Up hÃ¢rtie inventar Pret',0),(409188,11367,'et','MÃ¤rgi Ã¼les raamatu lao hind',0),(409189,11367,'si','Mark Up papir popis cen',0),(409190,11367,'ba','Mark Up kertas persediaan harga',0),(409191,11367,'nl','Mark Up papier voorraad prijs',0),(409192,11367,'fi','Mark Up paperi varaston hintaa',0),(409193,11367,'no','Mark Up papir lagerpris',0),(409194,11367,'da','Mark Up papir lager pris',0),(409195,11367,'ko','ë§ˆí¬ ìš©ì§€ ìž¬ê³  ê°€ê²©',0),(409196,11367,'he','×ž×—×™×¨ ×ž×œ××™ × ×™×™×¨ Mark Up',0),(409197,11367,'el','Î¤Î¹Î¼Î® Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ Ï‡Î±ÏÏ„Î¯ Mark Up',0),(409198,11367,'zh','æ ‡è®°æ–‡ä»¶åº“å­˜ä»·æ ¼\r\n',0),(409199,11367,'sv','Mark Up papper lagerpris',0),(409200,11367,'it','Prezzo di Mark Up carta inventario',0),(409201,11367,'tl','',0),(409202,11367,'th','à¸£à¸²à¸„à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸«à¸¡à¸²à¸¢à¸„à¹ˆà¸²à¸à¸£à¸°à¸”à¸²à¸©',0),(409203,11367,'hi','à¤®à¤¾à¤°à¥à¤• à¤…à¤ª à¤•à¤¾à¤—à¤œ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤®à¥‚à¤²à¥à¤¯',0),(409204,11367,'ms','Harga Mark Up kertas inventori',0),(409205,11367,'ar','Ø³Ø¹Ø± Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠ Ù…Ø§Ø±Ùƒ ÙˆØ±Ù‚Ø©',0),(409206,11367,'fr','Prix de l\'inventaire papier de Mark Up',0),(409207,11367,'jp','ãƒžãƒ¼ã‚¯ ã‚¢ãƒƒãƒ— ãƒšãƒ¼ãƒ‘ãƒ¼åœ¨åº«ä¾¡æ ¼',0),(409208,11367,'pt','PreÃ§o de estoque de papel de Mark Up',0),(409209,11367,'ru','ÐœÐ°Ñ€Ðº-Ð²Ð²ÐµÑ€Ñ… Ð‘ÑƒÐ¼Ð°Ð³Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¦ÐµÐ½Ð°',0),(409210,11367,'es','Precio de Inventario de Papel de Encarecimiento',0),(409211,11367,'de','Mark Up Papier bestand Preis',0),(409212,11367,'en','Mark Up Paper Inventory Price',0),(409213,11368,'is','',0),(409214,11368,'dr','Ø¨Ø±Ø±Ø³ÙŠ Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡  Ø¨Ø±Ø±Ø³ÙŠ Ø²Ù…Ø§Ù† Ø±Ø§ Ù…Ù…ÙƒÙ† Ù…ÙŠ Ø³Ø§Ø²Ø¯',0),(409215,11368,'pr','Ø¨Ø±Ø±Ø³ÙŠ Ø§ÙŠÙ† Ú¯Ø²ÙŠÙ†Ù‡  Ø¨Ø±Ø±Ø³ÙŠ Ø²Ù…Ø§Ù† Ø±Ø§ Ù…Ù…ÙƒÙ† Ù…ÙŠ Ø³Ø§Ø²Ø¯',0),(409216,11368,'tr','Bu seÃ§enek, zaman kontrol saÄŸlar',0),(409217,11368,'pl','Zaznaczenie tej opcji umoÅ¼liwia sprawdzanie czasu',0),(409218,11368,'bg','Ð˜Ð·Ð±Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ñ‚Ð°Ð·Ð¸ Ð¾Ð¿Ñ†Ð¸Ñ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÑÐ²Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(409219,11368,'ur','Ø§Ø³ Ø§Ø®ØªÛŒØ§Ø± Ú©Ùˆ Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’ ÙˆÙ‚Øª Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©Û’ Ù‚Ø§Ø¨Ù„ Ø¨Ù†Ø§ØªØ§ ÛÛ’',0),(409220,11368,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° Ð¾Ð²Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð¾Ð¼Ð¾Ð³ÑƒÑ›Ð°Ð²Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(409221,11368,'vi','Kiá»ƒm tra lá»±a chá»n nÃ y cho phÃ©p kiá»ƒm tra thá»i gian',0),(409222,11368,'af','Hierdie opsie kontroleer stel tyd gekontroleer',0),(409223,11368,'ro','Verificarea aceastÄƒ opÅ£iune activeazÄƒ timp de verificare',0),(409224,11368,'et','Kui mÃ¤rgite selle ruudu vÃµimaldab aega kontrollimiseks',0),(409225,11368,'si','Preverjanje te moÅ¾nosti omogoÄa Äas preverjanja',0),(409226,11368,'ba','Memeriksa pilihan ini memungkinkan waktu untuk memeriksa',0),(409227,11368,'nl','Deze optie maakt tijd controleren',0),(409228,11368,'fi','Tarkistaa tÃ¤mÃ¤ vaihtoehto mahdollistaa aikaa tarkistaa',0),(409229,11368,'no','Avmerker denne valgmuligheten gjÃ¸r tid kontrollere',0),(409230,11368,'da','Markering af denne mulighed giver mulighed for kontrol af tid',0),(409231,11368,'ko','ì‹œê°„ í™•ì¸ ìˆ˜ ìžˆë„ë¡ì´ ì˜µì…˜ì„ ì„ íƒ',0),(409232,11368,'he','×‘×“×™×§×ª ××¤×©×¨×•×ª ×–×• ×ž××¤×©×¨×ª ×‘×“×™×§×ª ×–×ž×Ÿ',0),(409233,11368,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ Î±Ï…Ï„Î® Î· ÎµÏ€Î¹Î»Î¿Î³Î® ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÎ¹ Ï„Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Ï„Î¿Ï… Ï‡ÏÏŒÎ½Î¿Ï…',0),(409234,11368,'zh','æ£€æŸ¥æ­¤é€‰é¡¹ä½¿æ—¶é—´æ£€æŸ¥å¼€å§‹å·¥ä½œ\r\n',0),(409235,11368,'sv','Kontrollera detta alternativ mÃ¶jliggÃ¶r kontroll av tid',0),(409236,11368,'it','Spuntando questa opzione consente di tempo controllando',0),(409237,11368,'tl','',0),(409238,11368,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸™à¸µà¹‰à¸Šà¹ˆà¸§à¸¢à¹ƒà¸«à¹‰à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹€à¸§à¸¥à¸²',0),(409239,11368,'hi','à¤‡à¤¸ à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¥‡ à¤¸à¤®à¤¯ à¤•à¥€ à¤œà¤¾à¤à¤š à¤¸à¤•à¥à¤·à¤® à¤¬à¤¨à¤¾à¤¤à¤¾ à¤¹à¥ˆ',0),(409240,11368,'ms','Menyemak opsyen ini membolehkan masa menyemak',0),(409241,11368,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ø®ÙŠØ§Ø± ÙŠØªÙŠØ­ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„ÙˆÙ‚Øª',0),(409242,11368,'fr','Cette option permet de vÃ©rifier de temps',0),(409243,11368,'jp','ã“ã®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’ã‚ªãƒ³æœ‰åŠ¹æ™‚ã®ãƒã‚§ãƒƒã‚¯',0),(409244,11368,'pt','Se assinalar esta opÃ§Ã£o permite a verificaÃ§Ã£o de tempo',0),(409245,11368,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð²ÐºÐ»ÑŽÑ‡Ð°ÐµÑ‚ Ð²Ñ€ÐµÐ¼Ñ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÑƒ',0),(409246,11368,'es','La SelecciÃ³n de Esta OpciÃ³n Se Faculta Checando el Tiempo',0),(409247,11368,'de','Diese Option aktiviert die Zeit-ÃœberprÃ¼fung',0),(409248,11368,'en','Checking This Option Enables Time Checking',0),(409249,11369,'is','',0),(409250,11369,'dr',' Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø«Ø¨Øª Ùˆ Ù†Ù‡ ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± ',0),(409251,11369,'pr',' Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÙŠØ® Ø«Ø¨Øª Ùˆ Ù†Ù‡ ØªØ§Ø±ÙŠØ® ÙØ§ÙƒØªÙˆØ± ',0),(409252,11369,'tr','GiriÅŸ tarihini Kullan olmayan fatura tarihi',0),(409253,11369,'pl','Wykorzystanie wpis daty faktury nie data',0),(409254,11369,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð° Ð½Ðµ Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(409255,11369,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ù†ÛÛŒÚº Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(409256,11369,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµÑ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(409257,11369,'vi','Sá»­ dá»¥ng má»¥c nháº­p ngÃ y khÃ´ng hÃ³a Ä‘Æ¡n ngÃ y',0),(409258,11369,'af','Gebruik inskrywing datum nie faktuur datum',0),(409259,11369,'ro','Data de intrare utilizarea factura nu data',0),(409260,11369,'et','Kasutada kande kuupÃ¤ev arve kuupÃ¤ev',0),(409261,11369,'si','Uporaba vnos datuma zaraÄunal datum',0),(409262,11369,'ba','Penggunaan tanggal entri tidak faktur tanggal',0),(409263,11369,'nl','Gebruik post datum niet factuurdatum',0),(409264,11369,'fi','KÃ¤ytÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ ei laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(409265,11369,'no','Bruk oppfÃ¸ringsdatoen ikke fakturadato',0),(409266,11369,'da','Brug tilmeldningsfrist ikke faktura dato',0),(409267,11369,'ko','ì‚¬ìš© í•­ëª© ë°ì´íŠ¸ í•˜ì§€ ì†¡ìž¥ ë‚ ì§œ',0),(409268,11369,'he','×©×™×ž×•×© ×¢×¨×š ×ª××¨×™×š ×”×—×©×‘×•× ×™×ª ×œ× ×ª××¨×™×š',0),(409269,11369,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ Ï‡ÏÎ®ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´ÎµÎ½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(409270,11369,'zh','æŠ¥åæ—¥æœŸæ²¡æœ‰ä½¿ç”¨å‘ç¥¨æ—¥æœŸ\r\n=',0),(409271,11369,'sv','AnvÃ¤nda bloggpostens datum inte faktura datum',0),(409272,11369,'it','Uso voce Data fattura non data',0),(409273,11369,'tl','',0),(409274,11369,'th','à¹ƒà¸Šà¹‰à¸£à¸²à¸¢à¸à¸²à¸£à¸§à¸±à¸™à¹„à¸¡à¹ˆà¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸§à¸±à¸™',0),(409275,11369,'hi','à¤‰à¤ªà¤¯à¥‹à¤— à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¨à¤¹à¥€à¤‚ à¤šà¤¾à¤²à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(409276,11369,'ms','Tarikh kemasukan penggunaan tidak invois tarikh',0),(409277,11369,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù„Ø§ ØªØ§Ø±ÙŠØ®',0),(409278,11369,'fr','Date d\'entrÃ©e utilisation pas Date de la facture',0),(409279,11369,'jp','ã‚¨ãƒ³ãƒˆãƒªã®æ—¥ä»˜ã‚’ä½¿ç”¨ã—ã¦ã„ãªã„è«‹æ±‚æ›¸æ—¥ä»˜',0),(409280,11369,'pt','Data de entrada do uso nÃ£o fatura data',0),(409281,11369,'ru','Ð”Ð°Ñ‚Ð° Ð²ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð° Ð”Ð°Ñ‚Ð°',0),(409282,11369,'es','Usa Fecha de Entrada No la Fecha Facturada',0),(409283,11369,'de','Eintrag vom Einsatz nicht Rechnungsdatum',0),(409284,11369,'en','Use Entry Date Not Invoice Date',0),(409285,11370,'is','',0),(409286,11370,'dr','Ù…ØªÙ† Ù¾ÙŠØ§Ù…',0),(409287,11370,'pr','Ù…ØªÙ† Ù¾ÙŠØ§Ù…',0),(409288,11370,'tr','VÃ¼cut',0),(409289,11370,'pl','CiaÅ‚o',0),(409290,11370,'bg','Ð¢ÑÐ»Ð¾',0),(409291,11370,'ur','Ø¬Ø³Ù…',0),(409292,11370,'sr','Ð¢ÐµÐ»Ð¾',0),(409293,11370,'vi','CÆ¡ thá»ƒ',0),(409294,11370,'af','Liggaam',0),(409295,11370,'ro','Corpul',0),(409296,11370,'et','Keha',0),(409297,11370,'si','Telo',0),(409298,11370,'ba','Tubuh',0),(409299,11370,'nl','Lichaam',0),(409300,11370,'fi','Kehon',0),(409301,11370,'no','Kroppen',0),(409302,11370,'da','Kroppen',0),(409303,11370,'ko','ë°”ë””',0),(409304,11370,'he','×”×’×•×£',0),(409305,11370,'el','Î£ÏŽÎ¼Î±',0),(409306,11370,'zh','èº«ä½“\r\n',0),(409307,11370,'sv','Kroppen',0),(409308,11370,'it','Corpo',0),(409309,11370,'tl','',0),(409310,11370,'th','à¸£à¹ˆà¸²à¸‡à¸à¸²à¸¢',0),(409311,11370,'hi','à¤¶à¤°à¥€à¤°',0),(409312,11370,'ms','Badan',0),(409313,11370,'ar','Ø§Ù„Ù‡ÙŠØ¦Ø©',0),(409314,11370,'fr','Corps',0),(409315,11370,'jp','ãƒœãƒ‡ã‚£',0),(409316,11370,'pt','Corpo',0),(409317,11370,'ru','Ð¢ÐµÐ»Ð¾',0),(409318,11370,'es','Cuerpo',0),(409319,11370,'de','KÃ¶rper',0),(409320,11370,'en','Body',0),(409321,11371,'is','',0),(409322,11371,'dr','ÙØ¹Ø§Ù„ÙŠØª Ø§ÙŠÙ…ÙŠÙ„',0),(409323,11371,'pr','ÙØ¹Ø§Ù„ÙŠØª Ø§ÙŠÙ…ÙŠÙ„',0),(409324,11371,'tr','E-posta eylem',0),(409325,11371,'pl','DziaÅ‚anie e-mail',0),(409326,11371,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(409327,11371,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø¹Ù…Ù„',0),(409328,11371,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(409329,11371,'vi','TÃ¡c dá»¥ng email',0),(409330,11371,'af','E-pos Aksie',0),(409331,11371,'ro','E-mail de acÅ£iune',0),(409332,11371,'et','E-posti konto',0),(409333,11371,'si','Email dejanje',0),(409334,11371,'ba','Email aksi',0),(409335,11371,'nl','Actie e-mail',0),(409336,11371,'fi','SÃ¤hkÃ¶postin',0),(409337,11371,'no','E-handling',0),(409338,11371,'da','E-mail handling',0),(409339,11371,'ko','ì „ìž ë©”ì¼ ìž‘ì—…',0),(409340,11371,'he','×¤×¢×•×œ×ª ×“×•×\"×œ',0),(409341,11371,'el','Î”ÏÎ¬ÏƒÎ· Ï„Î¿Ï… Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(409342,11371,'zh','ç”µé‚®åŠ¨ä½œ\r\n',0),(409343,11371,'sv','E-Ã¥tgÃ¤rd',0),(409344,11371,'it','Azione di mail',0),(409345,11371,'tl','',0),(409346,11371,'th','à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£',0),(409347,11371,'hi','à¤ˆà¤®à¥‡à¤² à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(409348,11371,'ms','Tindakan e-mel',0),(409349,11371,'ar','Ø¹Ù…Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(409350,11371,'fr','Action du courriel',0),(409351,11371,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(409352,11371,'pt','AÃ§Ã£o de e-mail',0),(409353,11371,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð¿Ð¾ Email',0),(409354,11371,'es','AcciÃ³n de Email',0),(409355,11371,'de','E-Mail-Aktion',0),(409356,11371,'en','Email Action',0),(409357,11372,'is','',0),(409358,11372,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ù‚Ø§Ù„Ø¨ Ù‡Ø§ ',0),(409359,11372,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ù‚Ø§Ù„Ø¨ Ù‡Ø§ ',0),(409360,11372,'tr','E-posta ÅŸablonlarÄ±',0),(409361,11372,'pl','Szablony wiadomoÅ›ci e-mail',0),(409362,11372,'bg','Ð˜Ð¼ÐµÐ¹Ð» ÑˆÐ°Ð±Ð»Ð¾Ð½Ð¸',0),(409363,11372,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Û’',0),(409364,11372,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾ÑˆÑ†Ð¸ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(409365,11372,'vi','CÃ¡c máº«u email',0),(409366,11372,'af','E-pos Sjablone',0),(409367,11372,'ro','Åžabloane de poÅŸtÄƒ electronicÄƒ',0),(409368,11372,'et','E-kirja pÃµhjad',0),(409369,11372,'si','Email Templates',0),(409370,11372,'ba','Email template',0),(409371,11372,'nl','E-mailsjablonen',0),(409372,11372,'fi','SÃ¤hkÃ¶postimallit',0),(409373,11372,'no','E-maler',0),(409374,11372,'da','E-mail-skabeloner',0),(409375,11372,'ko','ì´ë©”ì¼ í…œí”Œë¦¿',0),(409376,11372,'he','×ª×‘× ×™×•×ª ×“×•×\"×œ',0),(409377,11372,'el','Î ÏÏŒÏ„Ï…Ï€Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(409378,11372,'zh','ç”µå­é‚®ä»¶æ¨¡æ¿\r\n',0),(409379,11372,'sv','E-mallar',0),(409380,11372,'it','Modelli email',0),(409381,11372,'tl','',0),(409382,11372,'th','à¹€à¸—à¹‡à¸¡à¹€à¸žà¸¥à¸•à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(409383,11372,'hi','à¤ˆà¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿà¥à¤¸',0),(409384,11372,'ms','Template e-mel',0),(409385,11372,'ar','Ù‚ÙˆØ§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(409386,11372,'fr','ModÃ¨les d\'e-mail',0),(409387,11372,'jp','ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ',0),(409388,11372,'pt','Modelos de e-mail',0),(409389,11372,'ru','Ð¨Ð°Ð±Ð»Ð¾Ð½Ñ‹ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(409390,11372,'es','Plantillas de Email',0),(409391,11372,'de','E-Mail-Vorlagen',0),(409392,11372,'en','Email Templates',0),(409393,11373,'is','',0),(409394,11373,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚Ø§Ù„Ø¨ Ø§ÙŠÙ…ÙŠÙ„ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯  ',0),(409395,11373,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù‚Ø§Ù„Ø¨ Ø§ÙŠÙ…ÙŠÙ„ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯  ',0),(409396,11373,'tr','BaÅŸarÄ±sÄ±zlÄ±k e-posta ÅŸablonu ekleme',0),(409397,11373,'pl','BÅ‚Ä…d dodawania szablon wiadomoÅ›ci Email',0),(409398,11373,'bg','ÐÐµÑƒÑÐ¿ÐµÑ… Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¸Ð¼ÐµÐ¹Ð» ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(409399,11373,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ø§Ø¶Ø§ÙÛ Ø§ÛŒ Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Ø§',0),(409400,11373,'sr','Ð”Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ Ð·Ð° Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ',0),(409401,11373,'vi','ThÃªm máº«u email tháº¥t báº¡i',0),(409402,11373,'af','Faal met die Byvoeging van E-pos Sjablone',0),(409403,11373,'ro','EÅŸecul adÄƒugarea de E-mail ÅŸablon',0),(409404,11373,'et','Rike lisades meilisÃµnumimallid',0),(409405,11373,'si','Neuspeh dodajanje Email predloga',0),(409406,11373,'ba','Kegagalan menambahkan Email Template',0),(409407,11373,'nl','E-mailtemplate toe te voegen mislukking',0),(409408,11373,'fi','EpÃ¤onnistuminen LisÃ¤Ã¤ sÃ¤hkÃ¶postimalli',0),(409409,11373,'no','Feil Ã¥ legge e-mal',0),(409410,11373,'da','Manglende tilfÃ¸jelse af E-mail-skabelon',0),(409411,11373,'ko','ì‹¤íŒ¨ ì¶”ê°€ ì´ë©”ì¼ í…œí”Œë¦¿',0),(409412,11373,'he','×›×©×œ ×”×•×¡×¤×ª ×ª×‘× ×™×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™',0),(409413,11373,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï… Email',0),(409414,11373,'zh','æ·»åŠ ç”µå­é‚®ä»¶æ¨¡æ¿å¤±è´¥\r\n',0),(409415,11373,'sv','UnderlÃ¥tenhet att lÃ¤gga till e-mall',0),(409416,11373,'it','Mancata aggiunta modello E-mail',0),(409417,11373,'tl','',0),(409418,11373,'th','à¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥à¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(409419,11373,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤ˆà¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(409420,11373,'ms','Kegagalan menambah e-mel Template',0),(409421,11373,'ar','ÙØ´Ù„ Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(409422,11373,'fr','ModÃ¨le du Ã©chec d\'E-mail ajout',0),(409423,11373,'jp','å¤±æ•—ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(409424,11373,'pt','Modelo de Email adicionando falha',0),(409425,11373,'ru','Ð¡Ð±Ð¾Ð¹ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑˆÐ°Ð±Ð»Ð¾Ð½Ð° ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(409426,11373,'es','Falla Agregando Plantilla de Email',0),(409427,11373,'de','Fehler HinzufÃ¼gen von E-Mail-Vorlage',0),(409428,11373,'en','Failure Adding Email Template',0),(409429,11374,'is','',0),(409430,11374,'dr','Ù‚Ø§Ù„Ø¨ Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(409431,11374,'pr','Ù‚Ø§Ù„Ø¨ Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(409432,11374,'tr','E-posta ÅŸablonu baÅŸarÄ±yla eklendi',0),(409433,11374,'pl','PomyÅ›lnie dodano szablon wiadomoÅ›ci email',0),(409434,11374,'bg','Ð¨Ð°Ð±Ð»Ð¾Ð½ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð», Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(409435,11374,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ø³Ø§Ù†Ú†Û’ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(409436,11374,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(409437,11374,'vi','ÄÃ£ thÃªm máº«u email thÃ nh cÃ´ng',0),(409438,11374,'af','E-pos Sjablone Suksesvol Bygevoeg ',0),(409439,11374,'ro','E-mail ÅŸablon adÄƒugat cu succes',0),(409440,11374,'et','MeilisÃµnumi malli lisatud',0),(409441,11374,'si','Email predloga uspeÅ¡no dodani',0),(409442,11374,'ba','Template email yang berhasil ditambahkan',0),(409443,11374,'nl','E-mailtemplate toegevoegd',0),(409444,11374,'fi','SÃ¤hkÃ¶postimalli lisÃ¤Ã¤minen onnistui',0),(409445,11374,'no','E-mal lagt',0),(409446,11374,'da','E-mail skabelon tilfÃ¸jet',0),(409447,11374,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì´ë©”ì¼ í…œí”Œë¦¿',0),(409448,11374,'he','×ª×‘× ×™×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(409449,11374,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(409450,11374,'zh','ç”µå­é‚®ä»¶æ¨¡æ¿æ·»åŠ æˆåŠŸ\r\n',0),(409451,11374,'sv','E-mall lagts',0),(409452,11374,'it','Modello e-mail aggiunto con successo',0),(409453,11374,'tl','',0),(409454,11374,'th','à¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(409455,11374,'hi','à¤ˆà¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(409456,11374,'ms','Template e-mel yang berjaya menambah',0),(409457,11374,'ar','Ø£Ø¶ÙŠÙ Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(409458,11374,'fr','ModÃ¨le de message ajoutÃ© avec succÃ¨s',0),(409459,11374,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(409460,11374,'pt','Modelo de email adicionado com sucesso',0),(409461,11374,'ru','Ð¨Ð°Ð±Ð»Ð¾Ð½ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(409462,11374,'es','Plantilla de Email Agegado Exitosamente',0),(409463,11374,'de','E-Mail-Vorlage erfolgreich hinzugefÃ¼gt',0),(409464,11374,'en','Email Template Added Successfully',0),(409465,11375,'is','',0),(409466,11375,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù‚Ø§Ù„Ø¨ Ø§ÙŠÙ…ÙŠÙ„',0),(409467,11375,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù‚Ø§Ù„Ø¨ Ø§ÙŠÙ…ÙŠÙ„',0),(409468,11375,'tr','E-posta ÅŸablonunu silme hatasÄ±',0),(409469,11375,'pl','BÅ‚Ä…d podczas usuwania szablonu wiadomoÅ›ci E-mail',0),(409470,11375,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð»',0),(409471,11375,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ø³Ø§Ù†Ú†Û’ Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(409472,11375,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(409473,11375,'vi','Lá»—i xÃ³a email máº«u',0),(409474,11375,'af','Faal met die Skrapping van E-pos Sjablone',0),(409475,11375,'ro','Eroare la È™tergerea E-mail ÅŸablon',0),(409476,11375,'et','TÃµrge kustutamisel meilisÃµnumimallid',0),(409477,11375,'si','Napaka brisanja Email predloga',0),(409478,11375,'ba','Error menghapus Email Template',0),(409479,11375,'nl','Fout bij het verwijderen van e-mailtemplate',0),(409480,11375,'fi','Virhe poistettaessa sÃ¤hkÃ¶postimalli',0),(409481,11375,'no','Feil ved sletting av e-mal',0),(409482,11375,'da','Fejl ved sletning af E-mail-skabelon',0),(409483,11375,'ko','ì „ìž ë©”ì¼ í…œí”Œë¦¿ì„ ì‚­ì œ ì˜¤ë¥˜',0),(409484,11375,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×ª×‘× ×™×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™',0),(409485,11375,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï„Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(409486,11375,'zh','é”™è¯¯åˆ é™¤ç”µå­é‚®ä»¶æ¨¡æ¿\r\n',0),(409487,11375,'sv','Fel ta bort e-mall',0),(409488,11375,'it','Errore eliminazione modello E-mail',0),(409489,11375,'tl','',0),(409490,11375,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸¥à¸šà¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥',0),(409491,11375,'hi','à¤ˆà¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(409492,11375,'ms','Ralat Menghapuskan Template e-mel',0),(409493,11375,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(409494,11375,'fr','Erreur de suppression de modÃ¨le d\'E-mail',0),(409495,11375,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã®å‰Šé™¤ã‚¨ãƒ©ãƒ¼',0),(409496,11375,'pt','Erro ao excluir o modelo de Email',0),(409497,11375,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ ÑˆÐ°Ð±Ð»Ð¾Ð½Ð° ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(409498,11375,'es','Error Eliminando Plantilla de Email',0),(409499,11375,'de','Fehler beim LÃ¶schen der E-Mail-Vorlage',0),(409500,11375,'en','Error Deleting Email Template',0),(409501,11376,'is','',0),(409502,11376,'dr','Ù‚Ø§Ù„Ø¨ Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(409503,11376,'pr','Ù‚Ø§Ù„Ø¨ Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(409504,11376,'tr','E-posta ÅŸablonu baÅŸarÄ±yla silindi',0),(409505,11376,'pl','Szablon wiadomoÅ›ci e-mail usuniÄ™te pomyÅ›lnie',0),(409506,11376,'bg','Ð¨Ð°Ð±Ð»Ð¾Ð½ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð», Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(409507,11376,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ø³Ø§Ù†Ú†Û’ Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(409508,11376,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(409509,11376,'vi','XÃ³a email máº«u thÃ nh cÃ´ng',0),(409510,11376,'af','E-pos Sjablone Suksesvol Geskrap',0),(409511,11376,'ro','E-mail ÅŸablon ÅŸters cu succes',0),(409512,11376,'et','MeilisÃµnumi malli edukalt kustutatud',0),(409513,11376,'si','Email predloga uspeÅ¡no izbrisana',0),(409514,11376,'ba','Template email yang dihapus berhasil',0),(409515,11376,'nl','E-mailtemplate succesvol verwijderd',0),(409516,11376,'fi','SÃ¤hkÃ¶postimalli poistettu',0),(409517,11376,'no','E-mal slettet',0),(409518,11376,'da','E-mail skabelon slettet',0),(409519,11376,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ëœ ì´ë©”ì¼ í…œí”Œë¦¿',0),(409520,11376,'he','×ª×‘× ×™×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™ ×©× ×ž×—×§×• ×‘×”×¦×œ×—×”',0),(409521,11376,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(409522,11376,'zh','ç”µå­é‚®ä»¶æ¨¡æ¿æˆåŠŸåˆ é™¤\r\n',0),(409523,11376,'sv','E-mall raderades',0),(409524,11376,'it','Modello di email cancellato con successo',0),(409525,11376,'tl','',0),(409526,11376,'th','à¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(409527,11376,'hi','à¤ˆà¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(409528,11376,'ms','Template e-mel yang dihapuskan dengan jayanya',0),(409529,11376,'ar','Ø­Ø°Ù Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(409530,11376,'fr','ModÃ¨le d\'e-mail supprimÃ© avec succÃ¨s',0),(409531,11376,'jp','ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã¯æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(409532,11376,'pt','Modelo de email excluÃ­do com sucesso',0),(409533,11376,'ru','Ð¨Ð°Ð±Ð»Ð¾Ð½ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(409534,11376,'es','Plantilla de Email Eliminado Exitosamente',0),(409535,11376,'de','E-Mail-Vorlage erfolgreich gelÃ¶scht',0),(409536,11376,'en','Email Template Deleted Successfully',0),(409537,11377,'is','',0),(409538,11377,'dr','Ø§Ø² Ø§ÙŠÙ…ÙŠÙ„ ',0),(409539,11377,'pr','Ø§Ø² Ø§ÙŠÙ…ÙŠÙ„ ',0),(409540,11377,'tr','Gelen e-posta',0),(409541,11377,'pl','Od poczta elektroniczna',0),(409542,11377,'bg','ÐžÑ‚ Ð¸Ð¼ÐµÐ¹Ð»',0),(409543,11377,'ur','Ø³Û’ Ø§ÛŒ Ù…ÛŒÙ„',0),(409544,11377,'sr','Ð˜Ð· Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(409545,11377,'vi','tá»« email',0),(409546,11377,'af','Vanaf E-pos',0),(409547,11377,'ro','De E-mail',0),(409548,11377,'et','Kellelt',0),(409549,11377,'si','Iz e-poÅ¡te',0),(409550,11377,'ba','Dari Email',0),(409551,11377,'nl','Van E-mail',0),(409552,11377,'fi','SÃ¤hkÃ¶postista',0),(409553,11377,'no','Fra e-post',0),(409554,11377,'da','Fra E-mail',0),(409555,11377,'ko','ì´ë©”ì¼ì—ì„œ',0),(409556,11377,'he','×ž ×“×•×',0),(409557,11377,'el','Î‘Ï€ÏŒ Ï„Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(409558,11377,'zh','ä»Žç”µé‚®\r\n',0),(409559,11377,'sv','FrÃ¥n e-post',0),(409560,11377,'it','Da Email',0),(409561,11377,'tl','',0),(409562,11377,'th','à¸ˆà¸²à¸à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(409563,11377,'hi','à¤ˆà¤®à¥‡à¤² à¤¸à¥‡',0),(409564,11377,'ms','Daripada e-mel',0),(409565,11377,'ar','Ù…Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(409566,11377,'fr','De courriel',0),(409567,11377,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«ã‹ã‚‰',0),(409568,11377,'pt','De E-mail',0),(409569,11377,'ru','Ð˜Ð· Email',0),(409570,11377,'es','Origin de Email',0),(409571,11377,'de','Von Email',0),(409572,11377,'en','From Email',0),(409573,11378,'is','',0),(409574,11378,'dr','Ù„Ø·ÙØ§ Ø§Ø² Ø§ÙŠÙ…ÙŠÙ„  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(409575,11378,'pr','Ù„Ø·ÙØ§ Ø§Ø² Ø§ÙŠÙ…ÙŠÙ„  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(409576,11378,'tr','LÃ¼tfen e-posta dahil',0),(409577,11378,'pl','ProszÄ™ podaÄ‡ E-mail',0),(409578,11378,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¾Ñ‚ Ð¸Ð¼ÐµÐ¹Ð»',0),(409579,11378,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒ Ù…ÛŒÙ„ Ø³Û’ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(409580,11378,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ ÑƒÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¸Ð· Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(409581,11378,'vi','vui lÃ²ng bao gá»“m tá»« thÆ°',0),(409582,11378,'af','Sluit Asseblief \'n Afsender E-posadres in',0),(409583,11378,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i la E-mail',0),(409584,11378,'et','Palun lisage email',0),(409585,11378,'si','Prosimo, vkljuÄite iz e-poÅ¡te',0),(409586,11378,'ba','Harap sertakan dari Email',0),(409587,11378,'nl','Gelieve te omvatten van E-mail',0),(409588,11378,'fi','Ilmoita sÃ¤hkÃ¶postitse',0),(409589,11378,'no','Ta fra e-post',0),(409590,11378,'da','Inkluder venligst fra E-mail',0),(409591,11378,'ko','ì „ìž ìš°íŽ¸ì—ì„œ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(409592,11378,'he','×× × ×›×œ×•×œ ×ž×“×•×\"×œ',0),(409593,11378,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î±Ï€ÏŒ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(409594,11378,'zh','è¯·åˆ—å…¥ç”µé‚®\r\n',0),(409595,11378,'sv','VÃ¤nligen inkludera frÃ¥n e-post',0),(409596,11378,'it','Si prega di includere da Email',0),(409597,11378,'tl','',0),(409598,11378,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸­à¸µà¹€à¸¡à¸¥à¹Œà¸ˆà¸²à¸',0),(409599,11378,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ˆà¤®à¥‡à¤² à¤¸à¥‡ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(409600,11378,'ms','Sila sertakan dari e-mel',0),(409601,11378,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ù…Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(409602,11378,'fr','S\'il vous plaÃ®t inclure d\'Email',0),(409603,11378,'jp','ãƒ¡ãƒ¼ãƒ«ã‹ã‚‰è¨˜è¼‰ã—ã¦ãã ã•ã„ã€‚',0),(409604,11378,'pt','Por favor inclua de E-mail',0),(409605,11378,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ, Ð¾Ñ‚ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(409606,11378,'es','Por Favor Incluir Origin de Email',0),(409607,11378,'de','Bitte geben Sie E-Mail',0),(409608,11378,'en','Please Include From Email',0),(409609,11379,'is','',0),(409610,11379,'dr','Ù„Ø·ÙØ§ Ø§Ø² Ù†Ø§Ù… Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(409611,11379,'pr','Ù„Ø·ÙØ§ Ø§Ø² Ù†Ø§Ù… Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(409612,11379,'tr','LÃ¼tfen adÄ±nÄ± iÃ§erir',0),(409613,11379,'pl','Prosimy o podanie nazwy',0),(409614,11379,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¾Ñ‚ Ð¸Ð¼Ðµ',0),(409615,11379,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø³Û’ Ù†Ø§Ù… Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(409616,11379,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° ÑÐµ ÑƒÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¸Ð· Ð¸Ð¼Ðµ',0),(409617,11379,'vi','vui lÃ²ng bao gá»“m tá»« tÃªn',0),(409618,11379,'af','Sluit Asseblief die Afsender se Naam in',0),(409619,11379,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i numele',0),(409620,11379,'et','Palun lisada nimi',0),(409621,11379,'si','Prosimo, vkljuÄite iz imena',0),(409622,11379,'ba','Harap sertakan dari nama',0),(409623,11379,'nl','Gelieve te omvatten van naam',0),(409624,11379,'fi','LiitÃ¤ mukaan nimi',0),(409625,11379,'no','Ta med navnet',0),(409626,11379,'da','Inkluder venligst fra navn',0),(409627,11379,'ko','ì´ë¦„ì—ì„œ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(409628,11379,'he','×× × ×›×œ×•×œ ×ž-×©×',0),(409629,11379,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î±Ï€ÏŒ ÏŒÎ½Î¿Î¼Î±',0),(409630,11379,'zh','è¯·åˆ—å…¥åç§°\r\n',0),(409631,11379,'sv','VÃ¤nligen inkludera frÃ¥n namn',0),(409632,11379,'it','Si prega di includere dal nome',0),(409633,11379,'tl','',0),(409634,11379,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸§à¸¡à¸ˆà¸²à¸à¸Šà¸·à¹ˆà¸­',0),(409635,11379,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¨à¤¾à¤® à¤¸à¥‡ à¤¶à¤¾à¤®à¤¿à¤²',0),(409636,11379,'ms','Sila sertakan dari nama',0),(409637,11379,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ù…Ù† Ø§Ù„Ø§Ø³Ù…',0),(409638,11379,'fr','S\'il vous plaÃ®t inclure de nom',0),(409639,11379,'jp','åå‰ã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(409640,11379,'pt','Por favor inclua o nome de',0),(409641,11379,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ, Ð¾Ñ‚ Ð¸Ð¼ÐµÐ½Ð¸',0),(409642,11379,'es','Por Favor Incluir Nombre de Origin',0),(409643,11379,'de','Bitte geben Sie Namen',0),(409644,11379,'en','Please Include From Name',0),(409645,11380,'is','',0),(409646,11380,'dr','Ù„Ø·ÙØ§ Ù…ÙˆØ¶ÙˆØ¹ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(409647,11380,'pr','Ù„Ø·ÙØ§ Ù…ÙˆØ¶ÙˆØ¹ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(409648,11380,'tr','LÃ¼tfen konu ekleyin',0),(409649,11380,'pl','Prosimy o podanie tematu',0),(409650,11380,'bg','ÐœÐ¾Ð»Ñ, Ð¿Ð¾ÑÐ¾Ñ‡ÐµÑ‚Ðµ Ð¾Ð±ÐµÐºÑ‚',0),(409651,11380,'ur','Ø¨Ø±Ø§Û Ú©Ø±Ù… Ù…Ø¶Ù…ÙˆÙ† Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(409652,11380,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ñ‚ÐµÐ¼Ð°',0),(409653,11380,'vi','vui lÃ²ng bao gá»“m chá»§ Ä‘á»',0),(409654,11380,'af','Sluit asseblief Onderwerp in.',0),(409655,11380,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i subiect',0),(409656,11380,'et','Palun lisage teema',0),(409657,11380,'si','Prosimo, da vkljuÄite temo',0),(409658,11380,'ba','Harap sertakan subjek',0),(409659,11380,'nl','Voeg onderwerp',0),(409660,11380,'fi','Kirjoita aihe',0),(409661,11380,'no','Vennligst oppgi emnet',0),(409662,11380,'da','Inkluder venligst emne',0),(409663,11380,'ko','ì£¼ì œë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(409664,11380,'he','×× × ×›×œ×•×œ × ×•×©×',0),(409665,11380,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ Î¸Î­Î¼Î±',0),(409666,11380,'zh','è¯·åˆ—å…¥ä¸»é¢˜\r\n',0),(409667,11380,'sv','VÃ¤nligen inkludera Ã¤mne',0),(409668,11380,'it','Si prega di includere soggetto',0),(409669,11380,'tl','',0),(409670,11380,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸«à¸±à¸§à¹€à¸£à¸·à¹ˆà¸­à¸‡',0),(409671,11380,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤µà¤¿à¤·à¤¯ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(409672,11380,'ms','Sila sertakan perkara',0),(409673,11380,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ¶ÙˆØ¹',0),(409674,11380,'fr','Veuillez indiquer le sujet',0),(409675,11380,'jp','ä»¶åã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(409676,11380,'pt','Por favor inclua o assunto',0),(409677,11380,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ñ‚ÐµÐ¼Ñƒ',0),(409678,11380,'es','Por Favor Incluir Tema',0),(409679,11380,'de','Bitte geben Sie Betreff',0),(409680,11380,'en','Please Include Subject',0),(409681,11381,'is','',0),(409682,11381,'dr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ù‚Ø§Ù„Ø¨ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(409683,11381,'pr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ù‚Ø§Ù„Ø¨ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(409684,11381,'tr','LÃ¼tfen ÅŸablonu adÄ±nÄ± iÃ§erir.',0),(409685,11381,'pl','ProszÄ™ podaÄ‡ nazwÄ™ szablonu',0),(409686,11381,'bg','ÐœÐ¾Ð»Ñ, Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(409687,11381,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù†Ø§Ù… Ø³Ø§Ù†Ú†Ø§ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(409688,11381,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¸Ð¼Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ°',0),(409689,11381,'vi','vui lÃ²ng bao gá»“m máº«u tÃªn',0),(409690,11381,'af','Sluit asseblief Sjabloonnaam in',0),(409691,11381,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i numele ÅŸablonului',0),(409692,11381,'et','Palun lisage malli nimi',0),(409693,11381,'si','Prosimo, vkljuÄite ime predloge',0),(409694,11381,'ba','Harap Sertakan nama Template',0),(409695,11381,'nl','Gelieve te omvatten de naam van sjabloon',0),(409696,11381,'fi','Kirjoita mallin nimi',0),(409697,11381,'no','Ta med malnavn',0),(409698,11381,'da','VedlÃ¦g skabelonnavn',0),(409699,11381,'ko','ì„œì‹ íŒŒì¼ ì´ë¦„ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(409700,11381,'he','×× × ×›×œ×•×œ ×©× ×ª×‘× ×™×ª',0),(409701,11381,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï…',0),(409702,11381,'zh','è¯·åˆ—å…¥æ¨¡æ¿åç§°\r\n',0),(409703,11381,'sv','VÃ¤nligen inkludera Mallnamn',0),(409704,11381,'it','Si prega di includere nome modello',0),(409705,11381,'tl','',0),(409706,11381,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­à¹à¸¡à¹ˆà¹à¸šà¸š',0),(409707,11381,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤® à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(409708,11381,'ms','Sila sertakan nama templat',0),(409709,11381,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† Ø§Ø³Ù… Ù‚Ø§Ù„Ø¨',0),(409710,11381,'fr','Veuillez inclure le nom du modÃ¨le',0),(409711,11381,'jp','ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆåã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(409712,11381,'pt','Por favor, inclua o nome do modelo',0),(409713,11381,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ð¸Ð¼Ñ ÑˆÐ°Ð±Ð»Ð¾Ð½Ð°',0),(409714,11381,'es','Por Favor Incluir Nombre de Plantilla',0),(409715,11381,'de','Bitte geben Sie den Vorlagennamen',0),(409716,11381,'en','Please Include Template Name',0),(409717,11382,'is','',0),(409718,11382,'dr','Ù†Ø§Ù… Ù‚Ø§Ù„Ø¨ ',0),(409719,11382,'pr','Ù†Ø§Ù… Ù‚Ø§Ù„Ø¨ ',0),(409720,11382,'tr','Åžablon adÄ±',0),(409721,11382,'pl','Nazwa szablonu',0),(409722,11382,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(409723,11382,'ur','Ø³Ø§Ù†Ú†Û’ Ú©Ø§ Ù†Ø§Ù…',0),(409724,11382,'sr','Ð˜Ð¼Ðµ Ð¾Ð±Ñ€Ð°ÑÑ†Ð°',0),(409725,11382,'vi','tÃªn template',0),(409726,11382,'af','Sjabloon Naam',0),(409727,11382,'ro','Nume ÅŸablon',0),(409728,11382,'et','Malli nimi',0),(409729,11382,'si','Ime predloge',0),(409730,11382,'ba','Nama template',0),(409731,11382,'nl','Sjabloonnaam',0),(409732,11382,'fi','Mallin nimi',0),(409733,11382,'no','Malnavn',0),(409734,11382,'da','Skabelonnavn',0),(409735,11382,'ko','ì„œì‹ íŒŒì¼ ì´ë¦„',0),(409736,11382,'he','×©× ×ª×‘× ×™×ª',0),(409737,11382,'el','ÎŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï…',0),(409738,11382,'zh','æ¨¡æ¿åç§°\r\n',0),(409739,11382,'sv','Mallnamn',0),(409740,11382,'it','Nome modello',0),(409741,11382,'tl','',0),(409742,11382,'th','à¸Šà¸·à¹ˆà¸­à¸•à¹‰à¸™à¹à¸šà¸š',0),(409743,11382,'hi','à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(409744,11382,'ms','Nama templat',0),(409745,11382,'ar','Ø§Ø³Ù… Ø§Ù„Ù‚Ø§Ù„Ø¨',0),(409746,11382,'fr','Nom du modÃ¨le',0),(409747,11382,'jp','ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆå',0),(409748,11382,'pt','Nome do modelo',0),(409749,11382,'ru','Ð˜Ð¼Ñ ÑˆÐ°Ð±Ð»Ð¾Ð½Ð°',0),(409750,11382,'es','Nombre de Plantilla',0),(409751,11382,'de','Vorlagennamen',0),(409752,11382,'en','Template Name',0),(409753,11383,'is','',0),(409754,11383,'dr','ØªÙ‡ÙˆÙŠÙ‡ Ù‡ÙˆØ§',0),(409755,11383,'pr','ØªÙ‡ÙˆÙŠÙ‡ Ù‡ÙˆØ§',0),(409756,11383,'tr','Klima',0),(409757,11383,'pl','Klimatyzacja',0),(409758,11383,'bg','ÐšÐ»Ð¸Ð¼Ð°Ñ‚Ð¸Ðº',0),(409759,11383,'ur','Ù…Ú©ÛŒÙ',0),(409760,11383,'sr','ÐšÐ»Ð¸Ð¼Ð° ÑƒÑ€ÐµÐ´Ñ˜Ð°Ñ˜',0),(409761,11383,'vi','MÃ¡y láº¡nh',0),(409762,11383,'af','Lugversorging',0),(409763,11383,'ro','Aer conditionat',0),(409764,11383,'et','Konditsioneer',0),(409765,11383,'si','Klimatska naprava',0),(409766,11383,'ba','AC',0),(409767,11383,'nl','Air Conditioning',0),(409768,11383,'fi','Ilmastointi',0),(409769,11383,'no','Klimaanlegg',0),(409770,11383,'da','Aircondition',0),(409771,11383,'ko','ì—ì–´ì»¨',0),(409772,11383,'he','×ž×™×–×•×’ ××•×•×™×¨',0),(409773,11383,'el','ÎšÎ»Î¹Î¼Î±Ï„Î¹ÏƒÎ¼ÏŒÏ‚',0),(409774,11383,'zh','ç©ºè°ƒ\r\n',0),(409775,11383,'sv','Luftkonditionering',0),(409776,11383,'it','Aria condizionata',0),(409777,11383,'tl','',0),(409778,11383,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸›à¸£à¸±à¸šà¸­à¸²à¸à¸²à¸¨',0),(409779,11383,'hi','à¤à¤¯à¤° à¤•à¤‚à¤¡à¥€à¤¶à¤¨à¤¿à¤‚à¤—',0),(409780,11383,'ms','Penyaman udara',0),(409781,11383,'ar','ØªÙƒÙŠÙŠÙ Ø§Ù„Ù‡ÙˆØ§Ø¡',0),(409782,11383,'fr','Air conditionnÃ©',0),(409783,11383,'jp','ã‚¨ã‚¢ã‚³ãƒ³',0),(409784,11383,'pt','Ar condicionado',0),(409785,11383,'ru','ÐšÐ¾Ð½Ð´Ð¸Ñ†Ð¸Ð¾Ð½ÐµÑ€',0),(409786,11383,'es','Aire Acondicianado',0),(409787,11383,'de','Klimaanlage',0),(409788,11383,'en','Air Conditioning',0),(409789,11384,'is','',0),(409790,11384,'dr','Ø§Ø³ØªØ®Ø±Ù‡Ø§',0),(409791,11384,'pr','Ø§Ø³ØªØ®Ø±Ù‡Ø§',0),(409792,11384,'tr','Hamamlar',0),(409793,11384,'pl','Wanny',0),(409794,11384,'bg','Ð’Ð°Ð½Ð¸',0),(409795,11384,'ur','ØºØ³Ù„',0),(409796,11384,'sr','ÐšÑƒÐ¿ÐºÐµ',0),(409797,11384,'vi','PhÃ²ng táº¯m',0),(409798,11384,'af','Baddens',0),(409799,11384,'ro','Bai',0),(409800,11384,'et','Vannid',0),(409801,11384,'si','Kopeli',0),(409802,11384,'ba','Pemandian',0),(409803,11384,'nl','Baden',0),(409804,11384,'fi','KylpylÃ¤',0),(409805,11384,'no','Bad',0),(409806,11384,'da','Bade',0),(409807,11384,'ko','ëª©ìš•',0),(409808,11384,'he','××ž×‘×˜×™×•×ª',0),(409809,11384,'el','Î›Î¿Ï…Ï„ÏÎ¬',0),(409810,11384,'zh','æµ´åœº\r\n',0),(409811,11384,'sv','Bad',0),(409812,11384,'it','Bagni',0),(409813,11384,'tl','',0),(409814,11384,'th','à¸­à¹ˆà¸²à¸‡à¸­à¸²à¸šà¸™à¹‰à¸³',0),(409815,11384,'hi','à¤¸à¥à¤¨à¤¾à¤¨',0),(409816,11384,'ms','Baths',0),(409817,11384,'ar','Ø§Ù„Ø­Ù…Ø§Ù…Ø§Øª',0),(409818,11384,'fr','Bains',0),(409819,11384,'jp','ãŠé¢¨å‘‚',0),(409820,11384,'pt','Banhos',0),(409821,11384,'ru','Ð’Ð°Ð½Ð½Ñ‹',0),(409822,11384,'es','BaÃ±os',0),(409823,11384,'de','BÃ¤der',0),(409824,11384,'en','Baths',0),(409825,11385,'is','',0),(409826,11385,'dr','Beds  Ø¨Ø³ØªØ±',0),(409827,11385,'pr','Beds  Ø¨Ø³ØªØ±',0),(409828,11385,'tr','Yataklar',0),(409829,11385,'pl','ÅÃ³Å¼ka',0),(409830,11385,'bg','Ð›ÐµÐ³Ð»Ð°',0),(409831,11385,'ur','Ø¨Ø³ØªØ±',0),(409832,11385,'sr','ÐšÑ€ÐµÐ²ÐµÑ‚Ð¸',0),(409833,11385,'vi','GiÆ°á»ng',0),(409834,11385,'af','Beddens',0),(409835,11385,'ro','Paturi',0),(409836,11385,'et','Voodid',0),(409837,11385,'si','Postelje',0),(409838,11385,'ba','Tempat tidur',0),(409839,11385,'nl','Bedden',0),(409840,11385,'fi','SÃ¤ngyt',0),(409841,11385,'no','Senger',0),(409842,11385,'da','Senge',0),(409843,11385,'ko','ì¹¨ëŒ€',0),(409844,11385,'he','×ž×™×˜×•×ª',0),(409845,11385,'el','ÎšÏÎµÎ²Î¬Ï„Î¹Î±',0),(409846,11385,'zh','åºŠ\r\n',0),(409847,11385,'sv','SÃ¤ngar',0),(409848,11385,'it','Letti',0),(409849,11385,'tl','',0),(409850,11385,'th','à¹€à¸•à¸µà¸¢à¸‡',0),(409851,11385,'hi','à¤¬à¥‡à¤¡',0),(409852,11385,'ms','Katil-katil',0),(409853,11385,'ar','Ø£Ø³Ø±Ø©',0),(409854,11385,'fr','Lits',0),(409855,11385,'jp','ãƒ™ãƒƒãƒ‰',0),(409856,11385,'pt','Camas',0),(409857,11385,'ru','ÐšÑ€Ð¾Ð²Ð°Ñ‚Ð¸',0),(409858,11385,'es','Camas',0),(409859,11385,'de','Betten',0),(409860,11385,'en','Beds',0),(409861,11386,'is','',0),(409862,11386,'dr','ÙØ±Ø´',0),(409863,11386,'pr','ÙØ±Ø´',0),(409864,11386,'tr','HalÄ±',0),(409865,11386,'pl','Dywan',0),(409866,11386,'bg','ÐšÐ¸Ð»Ð¸Ð¼',0),(409867,11386,'ur','Ù‚Ø§Ù„ÛŒÙ†',0),(409868,11386,'sr','Ð¢ÐµÐ¿Ð¸Ñ…',0),(409869,11386,'vi','Tháº£m',0),(409870,11386,'af','Mat',0),(409871,11386,'ro','Covor',0),(409872,11386,'et','Vaip',0),(409873,11386,'si','Preproga',0),(409874,11386,'ba','Karpet',0),(409875,11386,'nl','Tapijt',0),(409876,11386,'fi','Matto',0),(409877,11386,'no','LÃ¸peren',0),(409878,11386,'da','TÃ¦ppe',0),(409879,11386,'ko','ì¹´íŽ«',0),(409880,11386,'he','×©×˜×™×—',0),(409881,11386,'el','Î§Î±Î»Î¯',0),(409882,11386,'zh','åœ°æ¯¯\r\n',0),(409883,11386,'sv','Matta',0),(409884,11386,'it','Tappeto',0),(409885,11386,'tl','',0),(409886,11386,'th','à¸žà¸£à¸¡',0),(409887,11386,'hi','à¤•à¤¾à¤²à¥€à¤¨',0),(409888,11386,'ms','Permaidani',0),(409889,11386,'ar','Ø§Ù„Ø³Ø¬Ø§Ø¯',0),(409890,11386,'fr','Tapis',0),(409891,11386,'jp','ã‚«ãƒ¼ãƒšãƒƒãƒˆ',0),(409892,11386,'pt','Tapete',0),(409893,11386,'ru','ÐšÐ¾Ð²ÐµÑ€',0),(409894,11386,'es','Tapete',0),(409895,11386,'de','Teppich',0),(409896,11386,'en','Carpet',0),(409897,11387,'is','',0),(409898,11387,'dr','Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(409899,11387,'pr','Ø±Ø¯ ÙƒØ±Ø¯Ù† ',0),(409900,11387,'tr','Den',0),(409901,11387,'pl','Den',0),(409902,11387,'bg','Den',0),(409903,11387,'ur','Ø®Ù„ÙˆØª Ø®Ø§Ù†Û',0),(409904,11387,'sr','ÐˆÐ°Ð·Ð±Ð¸Ð½Ð°',0),(409905,11387,'vi','Den',0),(409906,11387,'af','Den',0),(409907,11387,'ro','Den',0),(409908,11387,'et','Den',0),(409909,11387,'si','Den',0),(409910,11387,'ba','Den',0),(409911,11387,'nl','Den',0),(409912,11387,'fi','Den',0),(409913,11387,'no','Den',0),(409914,11387,'da','Den',0),(409915,11387,'ko','ë´',0),(409916,11387,'he','×’×•×‘',0),(409917,11387,'el','Den',0),(409918,11387,'zh','å·¢ç©´\r\n',0),(409919,11387,'sv','Den',0),(409920,11387,'it','Den',0),(409921,11387,'tl','',0),(409922,11387,'th','à¹€à¸”à¸™',0),(409923,11387,'hi','Den',0),(409924,11387,'ms','Den',0),(409925,11387,'ar','Ø¯Ù†',0),(409926,11387,'fr','Den',0),(409927,11387,'jp','ãƒ‡ãƒ³',0),(409928,11387,'pt','Den',0),(409929,11387,'ru','Ð¤Ðµ,',0),(409930,11387,'es','Estudio',0),(409931,11387,'de','Den',0),(409932,11387,'en','Den',0),(409933,11388,'is','',0),(409934,11388,'dr','(Ù…Ø§Ø´ÙŠÙ† Ø·Ø±ÙØ´ÙˆÙŠÙ‰',0),(409935,11388,'pr','Ú©Ø§Ø±Ú¯Ø± Ø·Ø±ÙØ´Ùˆ(Ù…Ø§Ø´ÙŠÙ† Ø·Ø±ÙØ´ÙˆÙŠÙ‰',0),(409936,11388,'tr','BulaÅŸÄ±k makinesi',0),(409937,11388,'pl','Zmywarka do naczyÅ„',0),(409938,11388,'bg','ÐœÐ¸ÑÐ»Ð½Ð° Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(409939,11388,'ur','ÚˆÙØ´ ÙˆØ§Ø´Ø±',0),(409940,11388,'sr','Ð—Ð° ÑÑƒÐ´Ð¾Ð²Ðµ',0),(409941,11388,'vi','MÃ¡y rá»­a chÃ©n',0),(409942,11388,'af','Skottegoedwasser',0),(409943,11388,'ro','Masina de spalat vase',0),(409944,11388,'et','NÃµudepesumasin',0),(409945,11388,'si','Pomivalni stroj',0),(409946,11388,'ba','Pencuci piring',0),(409947,11388,'nl','Vaatwasser',0),(409948,11388,'fi','Astianpesukone',0),(409949,11388,'no','Oppvaskmaskin',0),(409950,11388,'da','Opvaskemaskine',0),(409951,11388,'ko','ì‹ê¸° ì„¸ì²™ê¸°',0),(409952,11388,'he','×ž×“×™×— ×›×œ×™×',0),(409953,11388,'el','Î Î»Ï…Î½Ï„Î®ÏÎ¹Î¿ Ï€Î¹Î¬Ï„Ï‰Î½',0),(409954,11388,'zh','æ´—ç¢—æœº\r\n',0),(409955,11388,'sv','Diskmaskin',0),(409956,11388,'it','Lavastoviglie',0),(409957,11388,'tl','',0),(409958,11388,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¥à¹‰à¸²à¸‡à¸ˆà¸²à¸™',0),(409959,11388,'hi','Dishwasher',0),(409960,11388,'ms','Mesin basuh pinggan mangkuk',0),(409961,11388,'ar','ØºØ³Ø§Ù„Ø© Ø£Ø·Ø¨Ø§Ù‚',0),(409962,11388,'fr','Lave-vaisselle',0),(409963,11388,'jp','é£Ÿå™¨æ´—ã„æ©Ÿ',0),(409964,11388,'pt','MÃ¡quina de lavar louÃ§a',0),(409965,11388,'ru','ÐŸÐ¾ÑÑƒÐ´Ð¾Ð¼Ð¾ÐµÑ‡Ð½Ð°Ñ Ð¼Ð°ÑˆÐ¸Ð½Ð°',0),(409966,11388,'es','Maquina de Lavaplatos',0),(409967,11388,'de','SpÃ¼lmaschine',0),(409968,11388,'en','Dishwasher',0),(409969,11389,'is','',0),(409970,11389,'dr','( Ø¯Ø± Ø¯Ø³ØªØ±Ø³',0),(409971,11389,'pr','Ù…ØµØ±Ù ( Ø¯Ø± Ø¯Ø³ØªØ±Ø³',0),(409972,11389,'tr','Elden Ã§Ä±karma',0),(409973,11389,'pl','Dyspozycji',0),(409974,11389,'bg','Ð Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(409975,11389,'ur','Ø§Ø®ØªÛŒØ§Ø±',0),(409976,11389,'sr','Ð Ð°ÑÑ…Ð¾Ð´Ð°',0),(409977,11389,'vi','MÃ¡y nghiá»n rÃ¡c',0),(409978,11389,'af','Beskikking',0),(409979,11389,'ro','Eliminarea',0),(409980,11389,'et','KÃµrvaldamine',0),(409981,11389,'si','Odstranjevanje',0),(409982,11389,'ba','Pembuangan',0),(409983,11389,'nl','Verwijdering',0),(409984,11389,'fi','HÃ¤vittÃ¤minen',0),(409985,11389,'no','Disposisjon',0),(409986,11389,'da','Bortskaffelse',0),(409987,11389,'ko','ì²˜ë¦¬',0),(409988,11389,'he','×¡×™×œ×•×§',0),(409989,11389,'el','Î”Î¹Î¬Î¸ÎµÏƒÎ·',0),(409990,11389,'zh','å¤„ç½®\r\n',0),(409991,11389,'sv','FÃ¶rfogande',0),(409992,11389,'it','Smaltimento',0),(409993,11389,'tl','',0),(409994,11389,'th','à¸‚à¸²à¸¢à¸—à¸´à¹‰à¸‡',0),(409995,11389,'hi','à¤¨à¤¿à¤ªà¤Ÿà¤¾à¤¨',0),(409996,11389,'ms','Pelupusan',0),(409997,11389,'ar','Ø§Ù„ØªØ®Ù„Øµ Ù…Ù†Ù‡Ø§',0),(409998,11389,'fr','Ã‰limination',0),(409999,11389,'jp','å‡¦åˆ†',0),(410000,11389,'pt','EliminaÃ§Ã£o',0),(410001,11389,'ru','Ð£Ñ‚Ð¸Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(410002,11389,'es','Triturador de Basura',0),(410003,11389,'de','Entsorgung',0),(410004,11389,'en','Disposal',0),(410005,11390,'is','',0),(410006,11390,'dr','Ø¨Ø§Ù¾Ø§Ø±Ú†Ù‡ Ù…Ø²ÙŠÙ† Ú©Ø±Ø¯Ù†',0),(410007,11390,'pr','Ø¨Ø§Ù¾Ø§Ø±Ú†Ù‡ Ù…Ø²ÙŠÙ† Ú©Ø±Ø¯Ù†',0),(410008,11390,'tr','Perdeler',0),(410009,11390,'pl','ZasÅ‚ony',0),(410010,11390,'bg','Ð—Ð°Ð²ÐµÑÐ¸',0),(410011,11390,'ur','Ù¾Ø±Ø¯Û’',0),(410012,11390,'sr','ÐŸÑƒÐ½Ð¾ Ð¸Ñ… Ñ˜Ðµ Ð¾ÑÑ‚Ð°Ð»Ð¾',0),(410013,11390,'vi','MÃ n cá»­a',0),(410014,11390,'af','Gordyne',0),(410015,11390,'ro','Draperii',0),(410016,11390,'et','Linad',0),(410017,11390,'si','Draperije',0),(410018,11390,'ba','Tirai',0),(410019,11390,'nl','Gordijnen',0),(410020,11390,'fi','Verhot',0),(410021,11390,'no','Gardiner',0),(410022,11390,'da','ForhÃ¦ng',0),(410023,11390,'ko','ì»¤íŠ¼',0),(410024,11390,'he','×•×™×œ×•× ×•×ª',0),(410025,11390,'el','ÎšÎ¿Ï…ÏÏ„Î¯Î½ÎµÏ‚',0),(410026,11390,'zh','çª—å¸˜\r\n',0),(410027,11390,'sv','Draperier',0),(410028,11390,'it','Tende',0),(410029,11390,'tl','',0),(410030,11390,'th','à¸¡à¸´à¸™à¸´',0),(410031,11390,'hi','à¤ªà¤°à¥à¤¦à¥‡',0),(410032,11390,'ms','Labuh',0),(410033,11390,'ar','Ø§Ù„Ø³ØªØ§Ø¦Ø±',0),(410034,11390,'fr','Rideaux',0),(410035,11390,'jp','ã‚«ãƒ¼ãƒ†ãƒ³',0),(410036,11390,'pt','Cortinas',0),(410037,11390,'ru','Ð¨Ñ‚Ð¾Ñ€Ñ‹',0),(410038,11390,'es','Cortinas',0),(410039,11390,'de','VorhÃ¤nge',0),(410040,11390,'en','Drapes',0),(410041,11391,'is','',0),(410042,11391,'dr','Ø®Ø´Ú© Ú©Ù†',0),(410043,11391,'pr','Ø®Ø´Ú© Ú©Ù†',0),(410044,11391,'tr','Kurutma makinesi',0),(410045,11391,'pl','Suszarka',0),(410046,11391,'bg','Ð¡ÑƒÑˆÐ¸Ð»Ð½Ñ',0),(410047,11391,'ur','ÚˆØ±Ø§Ø¦Ø±',0),(410048,11391,'sr','Ð¤ÐµÐ½ Ð·Ð° ÐºÐ¾ÑÑƒ',0),(410049,11391,'vi','MÃ¡y sáº¥y',0),(410050,11391,'af','DroÃ«r',0),(410051,11391,'ro','Uscator',0),(410052,11391,'et','Kuivati',0),(410053,11391,'si','SuÅ¡ilni stroj',0),(410054,11391,'ba','Pengering',0),(410055,11391,'nl','Haardroger',0),(410056,11391,'fi','Kuivausrumpu',0),(410057,11391,'no','TÃ¸rketrommel',0),(410058,11391,'da','HÃ¥rtÃ¸rrer',0),(410059,11391,'ko','ê±´ì¡° ê¸°',0),(410060,11391,'he','×ž×™×™×‘×©',0),(410061,11391,'el','Î£Ï„ÎµÎ³Î½Ï‰Ï„Î®ÏÎ±',0),(410062,11391,'zh','çƒ˜å¹²æœº\r\n',0),(410063,11391,'sv','HÃ¥rtork',0),(410064,11391,'it','Essiccatore',0),(410065,11391,'tl','',0),(410066,11391,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¹€à¸›à¹ˆà¸²',0),(410067,11391,'hi','à¤¸à¥à¤–à¤¾à¤¨à¥‡ à¤•à¥€ à¤®à¤¶à¥€à¤¨',0),(410068,11391,'ms','Hawa',0),(410069,11391,'ar','Ù…Ø¬ÙÙ',0),(410070,11391,'fr','SÃ©choir',0),(410071,11391,'jp','ä¹¾ç‡¥æ©Ÿ',0),(410072,11391,'pt','Secador',0),(410073,11391,'ru','Ð¡ÑƒÑˆÐ¸Ð»ÐºÐ°',0),(410074,11391,'es','Secadora',0),(410075,11391,'de','Trockner',0),(410076,11391,'en','Dryer',0),(410077,11392,'is','',0),(410078,11392,'dr','Ø§Ø¬Ø§Ù‚ ',0),(410079,11392,'pr','Ø§Ø¬Ø§Ù‚ ',0),(410080,11392,'tr','ÅžÃ¶mine',0),(410081,11392,'pl','Kominek',0),(410082,11392,'bg','ÐšÐ°Ð¼Ð¸Ð½Ð°',0),(410083,11392,'ur','Ú†Ù…Ù†ÛŒ',0),(410084,11392,'sr','ÐšÐ°Ð¼Ð¸Ð½',0),(410085,11392,'vi','LÃ² sÆ°á»Ÿi',0),(410086,11392,'af','Kaggel',0),(410087,11392,'ro','Semineu',0),(410088,11392,'et','Kamin',0),(410089,11392,'si','Kamin',0),(410090,11392,'ba','Perapian',0),(410091,11392,'nl','Open haard',0),(410092,11392,'fi','Takka',0),(410093,11392,'no','Peis',0),(410094,11392,'da','Pejs',0),(410095,11392,'ko','ë²½ë‚œë¡œ',0),(410096,11392,'he','××—',0),(410097,11392,'el','Î¤Î¶Î¬ÎºÎ¹',0),(410098,11392,'zh','å£ç‚‰\r\n',0),(410099,11392,'sv','Ã–ppen spis',0),(410100,11392,'it','Camino',0),(410101,11392,'tl','',0),(410102,11392,'th','à¹€à¸•à¸²à¸œà¸´à¸‡',0),(410103,11392,'hi','à¤šà¤¿à¤®à¤¨à¥€',0),(410104,11392,'ms','Tempat perapian',0),(410105,11392,'ar','Ù…ÙˆÙ‚Ø¯',0),(410106,11392,'fr','CheminÃ©e',0),(410107,11392,'jp','æš–ç‚‰',0),(410108,11392,'pt','Lareira',0),(410109,11392,'ru','ÐšÐ°Ð¼Ð¸Ð½',0),(410110,11392,'es','Chimenea',0),(410111,11392,'de','Kamin',0),(410112,11392,'en','Fireplace',0),(410113,11393,'is','',0),(410114,11393,'dr','Ù…Ø¬Ù‡Ø² Ø´Ø¯Ù‡ ',0),(410115,11393,'pr','Ù…Ø¬Ù‡Ø² Ø´Ø¯Ù‡ ',0),(410116,11393,'tr','MobilyalÄ±',0),(410117,11393,'pl','Umeblowane',0),(410118,11393,'bg','ÐžÐ±Ð·Ð°Ð²ÐµÐ´ÐµÐ½Ð¸',0),(410119,11393,'ur','Ø¢Ø±Ø§Ø³ØªÛ',0),(410120,11393,'sr','ÐžÐ¿Ñ€ÐµÐ¼Ð¸Ð¾',0),(410121,11393,'vi','Trang bá»‹',0),(410122,11393,'af','Verstrek word',0),(410123,11393,'ro','Mobilate',0),(410124,11393,'et','Sisustatud',0),(410125,11393,'si','Opremljene',0),(410126,11393,'ba','Dilengkapi',0),(410127,11393,'nl','Ingericht',0),(410128,11393,'fi','Kalustettu',0),(410129,11393,'no','MÃ¸blert',0),(410130,11393,'da','MÃ¸bleret',0),(410131,11393,'ko','ë¹„ì¹˜',0),(410132,11393,'he','×ž×¨×•×”×˜',0),(410133,11393,'el','Î•Ï€Î¹Ï€Î»Ï‰Î¼Î­Î½Î±',0),(410134,11393,'zh','å®¶å…·\r\n',0),(410135,11393,'sv','MÃ¶blerade',0),(410136,11393,'it','Arredato',0),(410137,11393,'tl','',0),(410138,11393,'th','à¸•à¸à¹à¸•à¹ˆà¸‡',0),(410139,11393,'hi','à¤¸à¥‡ à¤¸à¥à¤¸à¤œà¥à¤œà¤¿à¤¤',0),(410140,11393,'ms','Dilengkapi',0),(410141,11393,'ar','Ù…ÙØ±ÙˆØ´Ø©',0),(410142,11393,'fr','MeublÃ©',0),(410143,11393,'jp','å®¶å…·ä»˜ã',0),(410144,11393,'pt','Mobilado',0),(410145,11393,'ru','ÐœÐµÐ±Ð»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð°Ñ',0),(410146,11393,'es','Amueblado',0),(410147,11393,'de','MÃ¶bliert',0),(410148,11393,'en','Furnished',0),(410149,11394,'is','',0),(410150,11394,'dr','ÙŠØ®Ú†Ø§Ù„',0),(410151,11394,'pr','ÙŠØ®Ú†Ø§Ù„',0),(410152,11394,'tr','BuzdolabÄ±',0),(410153,11394,'pl','LodÃ³wka',0),(410154,11394,'bg','Ð¥Ð»Ð°Ð´Ð¸Ð»Ð½Ð¸Ðº',0),(410155,11394,'ur','Ø±ÛŒÙØ±ÛŒØ¬Ø±ÛŒÙ¹Ø±',0),(410156,11394,'sr','Ð¤Ñ€Ð¸Ð¶Ð¸Ð´ÐµÑ€',0),(410157,11394,'vi','Tá»§ láº¡nh',0),(410158,11394,'af','Yskas',0),(410159,11394,'ro','Frigider',0),(410160,11394,'et','KÃ¼lmik',0),(410161,11394,'si','Hladilnik',0),(410162,11394,'ba','Lemari es',0),(410163,11394,'nl','Koelkast',0),(410164,11394,'fi','JÃ¤Ã¤kaappi',0),(410165,11394,'no','KjÃ¸leskap',0),(410166,11394,'da','KÃ¸leskab',0),(410167,11394,'ko','ëƒ‰ìž¥ê³ ',0),(410168,11394,'he','×ž×§×¨×¨',0),(410169,11394,'el','Î¨Ï…Î³ÎµÎ¯Î¿',0),(410170,11394,'zh','å†°ç®±\r\n',0),(410171,11394,'sv','KylskÃ¥p',0),(410172,11394,'it','Frigorifero',0),(410173,11394,'tl','',0),(410174,11394,'th','à¸•à¸¹à¹‰à¹€à¸¢à¹‡à¸™',0),(410175,11394,'hi','à¤°à¥‡à¤«à¥à¤°à¤¿à¤œà¤°à¥‡à¤Ÿà¤°',0),(410176,11394,'ms','Peti sejuk',0),(410177,11394,'ar','Ø«Ù„Ø§Ø¬Ø©',0),(410178,11394,'fr','RÃ©frigÃ©rateur',0),(410179,11394,'jp','å†·è”µåº«',0),(410180,11394,'pt','FrigorÃ­fico',0),(410181,11394,'ru','Ð¥Ð¾Ð»Ð¾Ð´Ð¸Ð»ÑŒÐ½Ð¸Ðº',0),(410182,11394,'es','Refrigerador',0),(410183,11394,'de','KÃ¼hlschrank',0),(410184,11394,'en','Refrigerator',0),(410185,11395,'is','',0),(410186,11395,'dr','(ÙØ±Ø®ÙˆØ±Ø§Ú© Ù¾Ø²Ù‰',0),(410187,11395,'pr','Ø¨Ø®Ø§Ø±ÙŠ(ÙØ±Ø®ÙˆØ±Ø§Ú© Ù¾Ø²Ù‰',0),(410188,11395,'tr','Soba',0),(410189,11395,'pl','Piec',0),(410190,11395,'bg','ÐŸÐµÑ‡ÐºÐ°',0),(410191,11395,'ur','Ú†ÙˆÙ„ÛØ§',0),(410192,11395,'sr','ÐŸÐµÑ›',0),(410193,11395,'vi','Báº¿p Ä‘un',0),(410194,11395,'af','Stoof',0),(410195,11395,'ro','Aragaz',0),(410196,11395,'et','Pliit',0),(410197,11395,'si','Å tedilnik',0),(410198,11395,'ba','Kompor',0),(410199,11395,'nl','Kachel',0),(410200,11395,'fi','Liesi',0),(410201,11395,'no','Komfyr',0),(410202,11395,'da','Komfur',0),(410203,11395,'ko','ë‚œë¡œ',0),(410204,11395,'he','×ª× ×•×¨',0),(410205,11395,'el','Î£ÏŒÎ¼Ï€Î±',0),(410206,11395,'zh','ç‚‰ç¶\r\n',0),(410207,11395,'sv','Spis',0),(410208,11395,'it','Stufa',0),(410209,11395,'tl','',0),(410210,11395,'th','à¹€à¸•à¸²',0),(410211,11395,'hi','à¤¸à¥à¤Ÿà¥‹à¤µ',0),(410212,11395,'ms','Dapur',0),(410213,11395,'ar','Ù…ÙˆÙ‚Ø¯',0),(410214,11395,'fr','PoÃªle',0),(410215,11395,'jp','ã‚¹ãƒˆãƒ¼ãƒ–',0),(410216,11395,'pt','FogÃ£o',0),(410217,11395,'ru','ÐŸÐ»Ð¸Ñ‚Ð°',0),(410218,11395,'es','Estufa',0),(410219,11395,'de','Herd',0),(410220,11395,'en','Stove',0),(410221,11396,'is','',0),(410222,11396,'dr','Ø±Ø®ØªØ´ÙˆÙŠ',0),(410223,11396,'pr','Ø±Ø®ØªØ´ÙˆÙŠ',0),(410224,11396,'tr','Ã‡amaÅŸÄ±r makinesi',0),(410225,11396,'pl','PodkÅ‚adka',0),(410226,11396,'bg','ÐœÐ¸ÐµÐ½Ðµ',0),(410227,11396,'ur','ÙˆØ§Ø´Ø±',0),(410228,11396,'sr','ÐŸÑ€Ð°ÑšÐµ',0),(410229,11396,'vi','MÃ¡y Giáº·t',0),(410230,11396,'af','Waster',0),(410231,11396,'ro','Masina de spalat',0),(410232,11396,'et','Pesur',0),(410233,11396,'si','Pranje',0),(410234,11396,'ba','Mesin cuci',0),(410235,11396,'nl','Wasmachine',0),(410236,11396,'fi','Pesukone',0),(410237,11396,'no','Vaskemaskin',0),(410238,11396,'da','Skive',0),(410239,11396,'ko','ì„¸íƒê¸°',0),(410240,11396,'he','×ž×›×•× ×ª ×›×‘×™×¡×”',0),(410241,11396,'el','Î Î»Ï…Î½Ï„Î®ÏÎ¹Î¿',0),(410242,11396,'zh','æ´—è¡£æœº\r\n',0),(410243,11396,'sv','Bricka',0),(410244,11396,'it','Rondella',0),(410245,11396,'tl','',0),(410246,11396,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸‹à¸±à¸à¸œà¹‰à¸²',0),(410247,11396,'hi','à¤µà¥‰à¤¶à¤°',0),(410248,11396,'ms','Mesin basuh',0),(410249,11396,'ar','ØºØ³Ø§Ù„Ø©',0),(410250,11396,'fr','Machine Ã  laver',0),(410251,11396,'jp','æ´—æ¿¯æ©Ÿ',0),(410252,11396,'pt','MÃ¡quina de lavar',0),(410253,11396,'ru','Ð¨Ð°Ð¹Ð±Ð°',0),(410254,11396,'es','Lavadora',0),(410255,11396,'de','Waschmaschine',0),(410256,11396,'en','Washer',0),(410257,11397,'is','',0),(410258,11397,'dr','/ Ù…Ø§Ø´ÙŠÙ† Ø®Ø´Ú© Ú©Ù†Ù‰',0),(410259,11397,'pr','ØªØ¬Ù…Ø¹ Ø±Ø®ØªØ´ÙˆÙŠ / Ù…Ø§Ø´ÙŠÙ† Ø®Ø´Ú© Ú©Ù†Ù‰',0),(410260,11397,'tr','Ã‡amaÅŸÄ±r makinesi/kurutucu kargaburun',0),(410261,11397,'pl','PodÅ‚Ä…czenie pralki/suszarki',0),(410262,11397,'bg','ÐŸÐµÑ€Ð°Ð»Ð½Ñ/ÑÑƒÑˆÐ¸Ð»Ð½Ñ Ð·Ð°Ñ…Ð²Ð°Ñ‰Ð°Ð½Ðµ',0),(410263,11397,'ur','ÙˆØ§Ø´Ø±/ÚˆØ±Ø§Ø¦Ø± Hookup',0),(410264,11397,'sr','ÐŸÑ€Ð°ÑšÐµ /Ñ„ÐµÐ½ Ð¼ÑƒÐ²Ð°ÑšÐµ',0),(410265,11397,'vi','MÃ¡y giáº·t/mÃ¡y sáº¥y Hookup',0),(410266,11397,'af','Waster/Dryer Hookup',0),(410267,11397,'ro','MaÅŸinÄƒ de spÄƒlat/uscÄƒtor de montaj',0),(410268,11397,'et','Pesumasin/kuivati Hookup',0),(410269,11397,'si','Pralno-suÅ¡ilni stroj Hookup',0),(410270,11397,'ba','Mesin cuci/pengering Hookup',0),(410271,11397,'nl','Wasmachine/droger Hookup',0),(410272,11397,'fi','Tilava kytkennÃ¤t',0),(410273,11397,'no','Vaskemaskin/tÃ¸rketrommel oppkobling',0),(410274,11397,'da','Vaskemaskine/tÃ¸rretumbler Hookup',0),(410275,11397,'ko','ì„¸íƒê¸°/ê±´ì¡° ê¸° ì—°ê²°',0),(410276,11397,'he','×©×™×“×•×¨ ×ž×©×•×ª×£ ×ž×›×•× ×ª ×›×‘×™×¡×” ×•×ž×™×™×‘×©',0),(410277,11397,'el','Î Î»Ï…Î½Ï„Î®ÏÎ¹Î¿/ÏƒÏ„ÎµÎ³Î½Ï‰Ï„Î®ÏÎ¹Î¿ ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(410278,11397,'zh','æ´—è¡£æœº/å¹²è¡£æœºè”æ’­\r\n',0),(410279,11397,'sv','TvÃ¤ttmaskin och torktumlare Hookup',0),(410280,11397,'it','Collegamento di lavatrice/asciugatrice',0),(410281,11397,'tl','',0),(410282,11397,'th','à¸šà¸¸à¹Šà¸„à¸œà¹‰à¸²',0),(410283,11397,'hi','à¤µà¥‰à¤¶à¤°/à¤¡à¥à¤°à¤¾à¤¯à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¤¾ à¤•à¤¾à¤®',0),(410284,11397,'ms','Mesin basuh/pengering Hookup',0),(410285,11397,'ar','ØºØ³Ø§Ù„Ø©/Ù…Ø¬ÙÙ Ù‡ÙˆÙƒÙˆØ¨',0),(410286,11397,'fr','Raccordement de laveuse/sÃ©cheuse',0),(410287,11397,'jp','æ´—æ¿¯æ©Ÿ/ä¹¾ç‡¥æ©Ÿãƒ•ãƒƒã‚¯ã‚¢ãƒƒãƒ—',0),(410288,11397,'pt','ConexÃ£o de mÃ¡quina de lavar e secar roupa',0),(410289,11397,'ru','Ð¡Ñ‚Ð¸Ñ€Ð°Ð»ÑŒÐ½Ð¾Ð¹ Ð¸ ÑÑƒÑˆÐ¸Ð»ÑŒÐ½Ð¾Ð¹',0),(410290,11397,'es','ConexiÃ³n de Lavadora/Secadora',0),(410291,11397,'de','Waschmaschine/Trockner anschlieÃŸen',0),(410292,11397,'en','Washer/Dryer Hookup',0),(410293,11398,'is','',0),(410294,11398,'dr','(Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ) ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(410295,11398,'pr','Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ú¯Ø±ÙŠ (Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ) ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡ ',0),(410296,11398,'tr','OnaylÄ± umudu',0),(410297,11398,'pl','Prospekt zatwierdzony',0),(410298,11398,'bg','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°Ñ‚Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸',0),(410299,11398,'ur','Ø§Ù…Ú©Ø§Ù† Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(410300,11398,'sr','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð° Ñ˜Ðµ Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ð¾',0),(410301,11398,'vi','KhÃ¡ch hÃ ng tiá»m nÄƒng Ä‘Ã£ Ä‘Æ°á»£c phÃª duyá»‡t',0),(410302,11398,'af','Voornemende KliÃ«nt Goedgekeur',0),(410303,11398,'ro','Perspectiva aprobat',0),(410304,11398,'et','Potentsiaalse kliendi heaks',0),(410305,11398,'si','MoÅ¾nost odobrena',0),(410306,11398,'ba','Prospek yang disetujui',0),(410307,11398,'nl','Vooruitzicht goedgekeurd',0),(410308,11398,'fi','Mahdollisuus hyvÃ¤ksyÃ¤',0),(410309,11398,'no','Prospektet godkjent',0),(410310,11398,'da','Udsigten godkendt',0),(410311,11398,'ko','ìŠ¹ì¸ ì „ë§',0),(410312,11398,'he','×¤×¨×•×¡×¤×§×˜ ××•×©×¨×”',0),(410313,11398,'el','Î ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ® ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯',0),(410314,11398,'zh','å±•æœ›æ ¸å‡†\r\n',0),(410315,11398,'sv','Prospekt som godkÃ¤nts',0),(410316,11398,'it','Prospetto approvato',0),(410317,11398,'tl','',0),(410318,11398,'th','à¹‚à¸­à¸à¸²à¸ªà¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(410319,11398,'hi','à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥€',0),(410320,11398,'ms','Prospek yang diluluskan',0),(410321,11398,'ar','Ø§Ø­ØªÙ…Ø§Ù„ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø©',0),(410322,11398,'fr','Perspective approuvÃ©',0),(410323,11398,'jp','æ‰¿èªã•ã‚Œã‚‹è¦‹é€šã—',0),(410324,11398,'pt','Prospecto aprovado',0),(410325,11398,'ru','ÐŸÑ€Ð¾ÑÐ¿ÐµÐºÑ‚ Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ð»',0),(410326,11398,'es','Prospecto Aprobado',0),(410327,11398,'de','Prospekt genehmigt',0),(410328,11398,'en','Prospect Approved',0),(410329,11399,'is','',0),(410330,11399,'dr','(Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ) Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(410331,11399,'pr','Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ú¯Ø±ÙŠ (Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§)(Ù…Ø´ØªØ±ÙŠ Ø§Ø­ØªÙ…Ø§Ù„ÙŠ) Ù¾Ø°ÙŠØ±ÙØªÙ‡ Ù†Ø´Ø¯Ù‡ ',0),(410332,11399,'tr','Umudu engellendi',0),(410333,11399,'pl','Perspektywa odmowa',0),(410334,11399,'bg','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°Ñ‚Ð° Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½',0),(410335,11399,'ur','Ø§Ù…Ú©Ø§Ù† Ø³Û’ Ø§Ù†Ú©Ø§Ø± Ú©ÛŒØ§',0),(410336,11399,'sr','ÐŸÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð° Ñ˜Ðµ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½',0),(410337,11399,'vi','KhÃ¡ch hÃ ng tiá»m nÄƒng tá»« chá»‘i',0),(410338,11399,'af','Voornemende KliÃ«nt Weier',0),(410339,11399,'ro','Perspectiva negat',0),(410340,11399,'et','VÃ¤ljavaade eitada',0),(410341,11399,'si','Zanikal moÅ¾nost',0),(410342,11399,'ba','Prospek yang ditolak',0),(410343,11399,'nl','Vooruitzicht geweigerd',0),(410344,11399,'fi','Mahdollisuus kieltÃ¤Ã¤',0),(410345,11399,'no','Prospektet nektet',0),(410346,11399,'da','Udsigten nÃ¦gtet',0),(410347,11399,'ko','ê±°ë¶€ í•˜ëŠ” ì „ë§',0),(410348,11399,'he','×¤×¨×•×¡×¤×§×˜ × ×“×—×ª×”',0),(410349,11399,'el','Î ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ® Î´ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(410350,11399,'zh','å±•æœ›æ‹’ç»\r\n',0),(410351,11399,'sv','Prospect fÃ¶rnekade',0),(410352,11399,'it','Prospettiva negato',0),(410353,11399,'tl','',0),(410354,11399,'th','à¹‚à¸™à¹‰à¸¡à¸—à¸µà¹ˆà¸›à¸à¸´à¹€à¸ªà¸˜',0),(410355,11399,'hi','à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤¸à¥‡ à¤‡à¤¨à¤•à¤¾à¤°',0),(410356,11399,'ms','Prospek yang dinafikan',0),(410357,11399,'ar','ÙˆÙ†ÙÙ‰ Ø§Ø­ØªÙ…Ø§Ù„',0),(410358,11399,'fr','Perspective refusÃ©e',0),(410359,11399,'jp','è¦‹é€šã—ãŒæ‹’å¦ã•ã‚Œã¾ã—ãŸ',0),(410360,11399,'pt','Perspectiva negada',0),(410361,11399,'ru','ÐŸÑ€Ð¾ÑÐ¿ÐµÐºÑ‚ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð¾',0),(410362,11399,'es','Prospecto Negado',0),(410363,11399,'de','Perspektive verweigert',0),(410364,11399,'en','Prospect Denied',0),(410365,11400,'is','',0),(410366,11400,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ø³ØªØ§Ø¬Ø± Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯ ',0),(410367,11400,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ø³ØªØ§Ø¬Ø± Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯ ',0),(410368,11400,'tr','KiracÄ± uygulama gÃ¶nderildi',0),(410369,11400,'pl','PrzedÅ‚oÅ¼ony wniosek najemcy',0),(410370,11400,'bg','ÐŸÐ¾Ð´Ð°Ð´ÐµÐ½Ð° Ð¼Ð¾Ð»Ð±Ð° Ð·Ð° Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»',0),(410371,11400,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾ÛŒØ´',0),(410372,11400,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ, Ð¿Ð¾Ð´Ð½ÐµÐ»Ð¾',0),(410373,11400,'vi','NgÆ°á»i thuÃª nhÃ  á»©ng dá»¥ng gá»­i',0),(410374,11400,'af','Huurder Aansoekvorm Ingedien',0),(410375,11400,'ro','ChiriaÅŸ cerere depusÄƒ',0),(410376,11400,'et','ÃœÃ¼rnik taotlus',0),(410377,11400,'si','Najemnik, vloÅ¾eni',0),(410378,11400,'ba','Permohonan penyewa',0),(410379,11400,'nl','Huurder aanvraag',0),(410380,11400,'fi','Vuokralainen hakemuksen',0),(410381,11400,'no','Leietaker sÃ¸knaden presentert',0),(410382,11400,'da','Lejer ansÃ¸gningen indgives',0),(410383,11400,'ko','í…Œ ë„Œ íŠ¸ ì• í”Œë¦¬ì¼€ì´ì…˜ ì œì¶œ',0),(410384,11400,'he','×™×™×©×•× ×”×“×™×™×¨ × ××¡×¤×•',0),(410385,11400,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î® Î±Î¯Ï„Î·ÏƒÎ· Ï€Î¿Ï… Ï…Ï€Î¿Î²Î¬Î»Î»ÎµÏ„Î±Î¹',0),(410386,11400,'zh','ç§Ÿå®¢æäº¤ç”³è¯·\r\n',0),(410387,11400,'sv','HyresgÃ¤sten ansÃ¶kan',0),(410388,11400,'it','Inquilino domanda presentata',0),(410389,11400,'tl','',0),(410390,11400,'th','à¸œà¸¹à¹‰à¸ªà¸¡à¸±à¸„à¸£à¸ªà¹ˆà¸‡',0),(410391,11400,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤†à¤µà¥‡à¤¦à¤¨ à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤',0),(410392,11400,'ms','Permohonan penyewa yang dikemukakan',0),(410393,11400,'ar','Ø·Ù„Ø¨ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± Ù…Ù‚Ø¯Ù…',0),(410394,11400,'fr','Locataire demande prÃ©sentÃ©e',0),(410395,11400,'jp','ãƒ†ãƒŠãƒ³ãƒˆã®ç”³è«‹',0),(410396,11400,'pt','Inquilino pedido apresentado',0),(410397,11400,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ð·Ð°ÑÐ²ÐºÐ¸',0),(410398,11400,'es','Solicitude de Inquilino Sometido',0),(410399,11400,'de','Mieter-Antrag',0),(410400,11400,'en','Tenant Application Submitted',0),(410401,11401,'is','',0),(410402,11401,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù…Ø³ØªØ§Ø¬Ø± ÙƒØ§Ù…Ù„ Ø§Ø³Øª ',0),(410403,11401,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù…Ø³ØªØ§Ø¬Ø± ÙƒØ§Ù…Ù„ Ø§Ø³Øª ',0),(410404,11401,'tr','KiracÄ± kira tamamlandÄ±',0),(410405,11401,'pl','Najemca dzierÅ¼awy kompletny',0),(410406,11401,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð¿ÑŠÐ»Ð½Ð°',0),(410407,11401,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ù„ÙÛŒØ² Ù…Ú©Ù…Ù„',0),(410408,11401,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð·Ð°ÐºÑƒÐ¿ ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½',0),(410409,11401,'vi','NgÆ°á»i thuÃª nhÃ  cho thuÃª Ä‘áº§y Ä‘á»§',0),(410410,11401,'af','Huurder Huurkontrak Voltooi',0),(410411,11401,'ro','ChiriaÅŸ leasing complet',0),(410412,11401,'et','Rentnik rendilepingu tÃ¤ielik',0),(410413,11401,'si','Zakupnik zakup celoten',0),(410414,11401,'ba','Penyewa sewa lengkap',0),(410415,11401,'nl','Huurder Lease volledige',0),(410416,11401,'fi','Vuokralainen vuokrasopimuksen tÃ¤ydellinen',0),(410417,11401,'no','Leietaker Lease fullfÃ¸rt',0),(410418,11401,'da','Lejeren lejekontrakten komplet',0),(410419,11401,'ko','ì„¸ ìž…ìž ìž„ëŒ€ ì™„ë£Œ',0),(410420,11401,'he','×”×—×›×™×¨×” ×”×“×™×™×¨ ×ž×œ××”',0),(410421,11401,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î® Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· Ï€Î»Î®ÏÎ·',0),(410422,11401,'zh','ç§Ÿå®¢ç§Ÿèµå®Œæˆ\r\n',0),(410423,11401,'sv','HyresgÃ¤st lÃ¥n komplett',0),(410424,11401,'it','Locazione inquilino completa',0),(410425,11401,'tl','',0),(410426,11401,'th','à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¹€à¸Šà¹ˆà¸²à¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(410427,11401,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¥‚à¤°à¤¾',0),(410428,11401,'ms','Pajakan penyewa lengkap',0),(410429,11401,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± ÙƒØ§Ù…Ù„Ø©',0),(410430,11401,'fr','Locataire bail complet',0),(410431,11401,'jp','å®Œå…¨ãªãƒ†ãƒŠãƒ³ãƒˆ ãƒªãƒ¼ã‚¹',0),(410432,11401,'pt','Inquilino Lease completa',0),(410433,11401,'ru','ÐŸÐ¾Ð»Ð½Ð°Ñ Ð°Ñ€ÐµÐ½Ð´Ð° Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€',0),(410434,11401,'es','Contrato de Arrendamiento de Inquilino Completado',0),(410435,11401,'de','Mieter Mietvertrag abgeschlossen',0),(410436,11401,'en','Tenant Lease Complete',0),(410437,11402,'is','',0),(410438,11402,'dr','Ø«Ø¨Øª Ù†Ø§Ù… Ù…Ø³ØªØ§Ø¬Ø±  ',0),(410439,11402,'pr','Ø«Ø¨Øª Ù†Ø§Ù… Ù…Ø³ØªØ§Ø¬Ø±  ',0),(410440,11402,'tr','KiracÄ± kaydoldum',0),(410441,11402,'pl','Najemcy podpisaÅ‚y',0),(410442,11402,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ»ÑÑ‚ ÑÐµ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð»Ð¸',0),(410443,11402,'ur','Ú©Ø±Ø§ÛŒÛ Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Ø¦Û’',0),(410444,11402,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ ÑÐµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ð¾',0),(410445,11402,'vi','NgÆ°á»i thuÃª nhÃ  Ä‘Äƒng kÃ½',0),(410446,11402,'af','Huurder onderteken',0),(410447,11402,'ro','ChiriaÅŸ Ã®nscris',0),(410448,11402,'et','ÃœÃ¼rnik sisse loginud',0),(410449,11402,'si','Najemnik prijavili',0),(410450,11402,'ba','Penyewa mendaftar',0),(410451,11402,'nl','Huurder aangemeld',0),(410452,11402,'fi','Vuokralainen allekirjoittanut',0),(410453,11402,'no','Leietaker registrerte',0),(410454,11402,'da','Lejer tilmeldt',0),(410455,11402,'ko','ê±°ì£¼ìž ê°€ìž…',0),(410456,11402,'he','×”×“×™×™×¨ ×—×ª×',0),(410457,11402,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î®Ï‚ Î½Î± Ï…Ï€Î¿Î³ÏÎ¬ÏˆÎµÎ¹',0),(410458,11402,'zh','ç§Ÿæˆ·ç­¾çº¦\r\n',0),(410459,11402,'sv','HyresgÃ¤sten undertecknat',0),(410460,11402,'it','Inquilino firmato',0),(410461,11402,'tl','',0),(410462,11402,'th','à¸œà¸¹à¹‰à¸¥à¸‡à¸™à¸²à¸¡',0),(410463,11402,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤¿à¤',0),(410464,11402,'ms','Penyewa yang mendaftar',0),(410465,11402,'ar','ÙˆÙ‚Ø¹Øª Ù„Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(410466,11402,'fr','Locataire souscrit',0),(410467,11402,'jp','ãƒ†ãƒŠãƒ³ãƒˆã«ã‚µã‚¤ãƒ³ã‚¢ãƒƒãƒ—',0),(410468,11402,'pt','Inquilino se inscreveu',0),(410469,11402,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð» Ð²Ð²ÐµÑ€Ñ…',0),(410470,11402,'es','Inquilino Inscrito',0),(410471,11402,'de','Mieter unterschrieben',0),(410472,11402,'en','Tenant Signed Up',0),(410473,11403,'is','',0),(410474,11403,'dr','(ÙˆØ±ÙˆØ¯ÙŠ) Ù…Ø¯ÙŠØ±ÙŠØªÙŠ',0),(410475,11403,'pr','Ù…Ø¯ÙŠØ±ÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù¾Ø±ØªØ§Ù„ (ÙˆØ±ÙˆØ¯ÙŠ) Ù…Ø¯ÙŠØ±ÙŠØªÙŠ',0),(410476,11403,'tr','Emlak YÃ¶netim PortalÄ± Admin',0),(410477,11403,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ zarzÄ…dzaniu admina portalu',0),(410478,11403,'bg','Ð˜Ð¼Ð¾Ñ‚Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€Ñ‚Ð°Ð» Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€',0),(410479,11403,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ Ù¾ÙˆØ±Ù¹Ù„ Ø§ÛŒÚˆÙ…Ù†',0),(410480,11403,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐ° Ð¿Ð¾Ñ€Ñ‚Ð°Ð»Ð° ÐÐ´Ð¼Ð¸Ð½',0),(410481,11403,'vi','Báº¥t Ä‘á»™ng sáº£n quáº£n lÃ½ cá»•ng Admin',0),(410482,11403,'af','Eiendom bestuur Portal Admin',0),(410483,11403,'ro','Proprietatea gestionare Admin Portal',0),(410484,11403,'et','Kinnisvara haldamise portaali Admin',0),(410485,11403,'si','Lastnost upravljanje portala Admin',0),(410486,11403,'ba','Properti Portal Manajemen Admin',0),(410487,11403,'nl','Eigenschap beheer Portal Admin',0),(410488,11403,'fi','Omaisuuden hallinta Portal Admin',0),(410489,11403,'no','Egenskapen Management Portal Admin',0),(410490,11403,'da','Property Management Portal Admin',0),(410491,11403,'ko','ì†ì„± ê´€ë¦¬ í¬í„¸ ê´€ë¦¬ìž',0),(410492,11403,'he','×ž× ×”×œ ×¤×•×¨×˜×œ × ×™×”×•×œ ×¨×›×•×©',0),(410493,11403,'el','Î™Î´Î¹ÏŒÏ„Î·Ï„Î± Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚ Ï€ÏÎ»Î·Ï‚ Admin',0),(410494,11403,'zh','ç‰©ä¸šç®¡ç†é—¨æˆ·ç½‘ç«™ç®¡ç†\r\n',0),(410495,11403,'sv','Property Management Portal Admin',0),(410496,11403,'it','ProprietÃ  Gestione portale Admin',0),(410497,11403,'tl','',0),(410498,11403,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸ˆà¸±à¸”à¸à¸²à¸£ Admin à¸žà¸­à¸£à¹Œà¸—à¸±à¸¥',0),(410499,11403,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤ªà¥‹à¤°à¥à¤Ÿà¤² à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤•',0),(410500,11403,'ms','Admin Portal Pengurusan Harta',0),(410501,11403,'ar','Ø®Ø§ØµÙŠØ© Ø¥Ø¯Ø§Ø±Ø© Ø¨ÙˆØ§Ø¨Ø© Ø§Ù„Ù…Ø´Ø±Ù',0),(410502,11403,'fr','PropriÃ©tÃ© gestion portail Admin',0),(410503,11403,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ç®¡ç†ãƒãƒ¼ã‚¿ãƒ«ç®¡ç†è€…',0),(410504,11403,'pt','Propriedade Management Portal Admin',0),(410505,11403,'ru','Ð¡Ð²Ð¾Ð¹ÑÑ‚Ð²Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ð¾Ñ€Ñ‚Ð°Ð»Ð° Admin',0),(410506,11403,'es','GestiÃ³n de Propiedad Prtal Admin',0),(410507,11403,'de','Eigenschaft Management Portal Admin',0),(410508,11403,'en','Property Management Portal Admin',0),(410509,11404,'is','',0),(410510,11404,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø± ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(410511,11404,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø± ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(410512,11404,'tr','Kredi kartÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(410513,11404,'pl','Karta kredytowa pomyÅ›lnie zaktualizowana',0),(410514,11404,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(410515,11404,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(410516,11404,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(410517,11404,'vi','cáº­p nháº­t tháº» tÃ­n dá»¥ng thÃ nh cÃ´ng',0),(410518,11404,'af','Kredietkaart Suksesvol Opdateer',0),(410519,11404,'ro','Carte de credit actualizatÄƒ cu succes',0),(410520,11404,'et','VÃ¤rskendatud krediitkaardi',0),(410521,11404,'si','Kreditne kartice, ki je uspeÅ¡no posodobljena',0),(410522,11404,'ba','Kartu kredit yang berhasil',0),(410523,11404,'nl','Creditcard bijgewerkt',0),(410524,11404,'fi','PÃ¤ivitetty luottokortti',0),(410525,11404,'no','Kredittkort oppdatert',0),(410526,11404,'da','Kreditkort opdateret',0),(410527,11404,'ko','ì‹ ìš© ì¹´ë“œ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(410528,11404,'he','×›×¨×˜×™×¡ ××©×¨××™ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(410529,11404,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(410530,11404,'zh','ä¿¡ç”¨å¡å·²æˆåŠŸæ›´æ–°\r\n',0),(410531,11404,'sv','Kreditkort uppdaterats',0),(410532,11404,'it','Carta di credito aggiornato con successo',0),(410533,11404,'tl','',0),(410534,11404,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(410535,11404,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(410536,11404,'ms','Kad kredit yang berjaya dikemas kini',0),(410537,11404,'ar','Ø­Ø¯Ù‘Ø«Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¨Ù†Ø¬Ø§Ø­',0),(410538,11404,'fr','Carte de crÃ©dit mis Ã  jour avec succÃ¨s',0),(410539,11404,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰',0),(410540,11404,'pt','CartÃ£o de crÃ©dito atualizado com sucesso',0),(410541,11404,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ ÐšÐ°Ñ€Ñ‚Ð° Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(410542,11404,'es','Tarjeta de CrÃ©dito Actualizado Exitosamente',0),(410543,11404,'de','Kreditkarte erfolgreich aktualisiert',0),(410544,11404,'en','Credit Card Updated Successfully',0),(410545,11405,'is','',0),(410546,11405,'dr','Ø´Ù…Ø§ Ø¨Ù‡ Ø§ÙŠÙ† ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø¯Ø§Ø±ÙŠØ¯',0),(410547,11405,'pr','Ø´Ù…Ø§ Ø¨Ù‡ Ø§ÙŠÙ† ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø¯Ø³ØªØ±Ø³ÙŠ Ù†Ø¯Ø§Ø±ÙŠØ¯',0),(410548,11405,'tr','Bu kredi kartÄ± iÃ§in eriÅŸim yok',0),(410549,11405,'pl','Nie masz dostÄ™pu do tej karty kredytowej',0),(410550,11405,'bg','Ð’Ð¸Ðµ Ð½ÑÐ¼Ð°Ñ‚Ðµ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ñ‚Ð°Ð·Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(410551,11405,'ur','Ø¢Ù¾ Ú©Ùˆ ÛŒÛ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ø­Ø§ØµÙ„ Ù†ÛÛŒÚº',0),(410552,11405,'sr','ÐÐµÐ¼Ð°Ñ‚Ðµ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¾Ð²Ð¾Ð¼ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(410553,11405,'vi','Báº¡n khÃ´ng cÃ³ quyá»n truy cáº­p vÃ o tháº» tÃ­n dá»¥ng nÃ y',0),(410554,11405,'af','U het niet Toegangsregte tot Hierdie Kredietkaart nie',0),(410555,11405,'ro','Nu aveÅ£i acces la aceastÄƒ carte de Credit',0),(410556,11405,'et','Teil pole juurdepÃ¤Ã¤su seda krediitkaarti',0),(410557,11405,'si','Nimate dostopa do te kreditne kartice',0),(410558,11405,'ba','Anda tidak memiliki akses ke kartu kredit',0),(410559,11405,'nl','U hoeft geen toegang tot deze creditcard',0),(410560,11405,'fi','Sinulla ei ole pÃ¤Ã¤syÃ¤ tÃ¤mÃ¤n luottokortin',0),(410561,11405,'no','Du har ikke tilgang til dette kredittkortet',0),(410562,11405,'da','Du har ikke adgang til dette kreditkort',0),(410563,11405,'ko','ì´ ì‹ ìš© ì¹´ë“œì— ëŒ€ í•œ ì•¡ì„¸ìŠ¤ë¥¼ í•˜ì§€ ì•Šì•„ë„',0),(410564,11405,'he','××™×Ÿ ×œ×š ×’×™×©×” ×©×œ ×›×¨×˜×™×¡×™ ××©×¨××™',0),(410565,11405,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Î±Ï…Ï„Î® Î· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(410566,11405,'zh','ä½ æ— æƒè®¿é—®æ­¤ä¿¡ç”¨å¡\r\n',0),(410567,11405,'sv','Du har inte tillgÃ¥ng till detta kreditkort',0),(410568,11405,'it','Non hai accesso a questa carta di credito',0),(410569,11405,'tl','',0),(410570,11405,'th','à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸™à¸µà¹‰',0),(410571,11405,'hi','à¤†à¤ª à¤‡à¤¸ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¹à¥à¤à¤š à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(410572,11405,'ms','Anda tidak mempunyai akses kepada kad kredit ini',0),(410573,11405,'ar','Ù„Ù… ÙŠÙƒÙ† Ù„Ø¯ÙŠÙƒ Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ù‡Ø°Ù‡ Ø§Ù„Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†ÙŠØ©',0),(410574,11405,'fr','Vous n\'avez pas accÃ¨s Ã  cette carte de crÃ©dit',0),(410575,11405,'jp','ã“ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã¸ã®ã‚¢ã‚¯ã‚»ã‚¹ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(410576,11405,'pt','VocÃª nÃ£o tem acesso a este cartÃ£o de crÃ©dito',0),(410577,11405,'ru','Ð£ Ð’Ð°Ñ ÐÐµÑ‚ Ð”Ð¾Ð¿ÑƒÑÐºÐ° Ðš Ð”Ð°Ð½Ð½Ð¾Ð¹ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ðµ',0),(410578,11405,'es','No Tiene Acceso de Esta Tarjeta de CrÃ©dito',0),(410579,11405,'de','Sie keinen Zugriff auf diese Kreditkarte',0),(410580,11405,'en','You Do Not Have Access To This Credit Card',0),(410581,11406,'is','',0),(410582,11406,'dr','Ú†Ø§Ù¾ Ø±Ø³ÙŠØ¯ ',0),(410583,11406,'pr','Ú†Ø§Ù¾ Ø±Ø³ÙŠØ¯ ',0),(410584,11406,'tr','AlÄ±ÅŸ irsaliyesi yazdÄ±r',0),(410585,11406,'pl','WydrukowaÄ‡ Paragon wpÅ‚aty',0),(410586,11406,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ°',0),(410587,11406,'ur','Ø±Ø³ÛŒØ¯ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(410588,11406,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð°',0),(410589,11406,'vi','in phiáº¿u thu',0),(410590,11406,'af','Druk ontvangs',0),(410591,11406,'ro','Primirea de imprimare',0),(410592,11406,'et','Prindib tarne',0),(410593,11406,'si','Natisk recepis',0),(410594,11406,'ba','Cetakan tanda terima',0),(410595,11406,'nl','Ontvangstbewijs afdrukken',0),(410596,11406,'fi','Tulostaa kuitin',0),(410597,11406,'no','Skrive ut kvittering',0),(410598,11406,'da','Print kvitteringen',0),(410599,11406,'ko','ì˜ìˆ˜ì¦ ì¸ì‡„',0),(410600,11406,'he','×”×“×¤×¡ ×§×‘×œ×”',0),(410601,11406,'el','Î Î±ÏÎ±Î»Î±Î²Î® ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(410602,11406,'zh','æ‰“å°æ”¶æ®\r\n',0),(410603,11406,'sv','Skriva ut kvitto',0),(410604,11406,'it','Stampare la ricevuta',0),(410605,11406,'tl','',0),(410606,11406,'th','à¸žà¸´à¸¡à¸žà¹Œà¹€à¸ªà¸£à¹‡à¸ˆ',0),(410607,11406,'hi','à¤°à¤¸à¥€à¤¦ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(410608,11406,'ms','Cetak resit',0),(410609,11406,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(410610,11406,'fr','Imprimer reÃ§u',0),(410611,11406,'jp','é ˜åŽæ›¸ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(410612,11406,'pt','Imprimir recibo',0),(410613,11406,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸',0),(410614,11406,'es','Recibo de ImpresiÃ³n',0),(410615,11406,'de','Beleg drucken',0),(410616,11406,'en','Print Receipt',0),(410617,11407,'is','',0),(410618,11407,'dr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø§ÙŠ Ø¯Ø± Ø§ÙŠÙ† Ù…Ø­Ù„ ',0),(410619,11407,'pr','Ù‡ÙŠÚ† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø§ÙŠ Ø¯Ø± Ø§ÙŠÙ† Ù…Ø­Ù„ ',0),(410620,11407,'tr','Navlun bu konumu Ã¼zerinde hiÃ§bir vergi',0),(410621,11407,'pl','Nie podatku od towarÃ³w tej lokalizacji',0),(410622,11407,'bg','ÐÑÐ¼Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ñ‚Ð¾Ð²Ð°Ñ€ÐµÐ½ Ñ‚Ð¾Ð²Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(410623,11407,'ur','ÙØ±Ø§Ø¦Ù¹ Ø§Ø³ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø± Ú©ÙˆØ¦ÛŒ Ù¹ÛŒÚ©Ø³',0),(410624,11407,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ñ‚ÐµÑ€ÐµÑ‚Ð½Ð¸ Ð¾Ð²Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(410625,11407,'vi','khÃ´ng thuáº¿ trÃªn hÃ ng hÃ³a táº¡i khu vá»±c nÃ y',0),(410626,11407,'af','Geen belasting op die vrag hierdie ligging',0),(410627,11407,'ro','Nici un impozit pe aceastÄƒ poziÅ£ie de marfÄƒ',0),(410628,11407,'et','Mingit maksu veos selles asukohas',0),(410629,11407,'si','Noben davek na tovorni to mesto',0),(410630,11407,'ba','Tidak ada pajak pada barang lokasi ini',0),(410631,11407,'nl','Geen belasting op vracht deze locatie',0),(410632,11407,'fi','Ei veroa tavaraliikenteen tÃ¤hÃ¤n sijaintiin',0),(410633,11407,'no','Ingen skatt pÃ¥ frakt denne plasseringen',0),(410634,11407,'da','Ingen skat pÃ¥ fragt denne placering',0),(410635,11407,'ko','í™”ë¬¼ì´ì´ ìœ„ì¹˜ì— ì„¸ê¸ˆë„ ì—†ê³ ',0),(410636,11407,'he','××™×Ÿ ×ž×¡ ×¢×œ ×”×”×•×‘×œ×” ××ª ×”×ž×™×§×•× ×”×–×”',0),(410637,11407,'el','ÎšÎ±Î½Î­Î½Î±Ï‚ Ï†ÏŒÏÎ¿Ï‚ ÏƒÏ„Î¹Ï‚ ÎµÎ¼Ï€Î¿ÏÎµÏ…Î¼Î±Ï„Î¹ÎºÎ­Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Ï‚ Î±Ï…Ï„Î® Ï„Î·Î½ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(410638,11407,'zh','æ­¤ä½ç½®ä¸Šæ²¡æœ‰è´§ç‰©ç¨Ž\r\n',0),(410639,11407,'sv','Ingen skatt pÃ¥ frakt denna plats',0),(410640,11407,'it','Nessuna tassa sulle merci questa posizione',0),(410641,11407,'tl','',0),(410642,11407,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸ à¸²à¸©à¸µà¸„à¹ˆà¸²à¸‚à¸™à¸ªà¹ˆà¸‡à¸™à¸µà¹‰',0),(410643,11407,'hi','à¤®à¤¾à¤² à¤¢à¥à¤²à¤¾à¤ˆ à¤‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤° à¤•à¥‹à¤ˆ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(410644,11407,'ms','Tiada cukai pada barang lokasi ini',0),(410645,11407,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¶Ø±ÙŠØ¨Ø© Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø­Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(410646,11407,'fr','Aucune taxe sur le fret cet emplacement',0),(410647,11407,'jp','è²¨ç‰©ã“ã®å ´æ‰€ã§ç¨Žé‡‘ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(410648,11407,'pt','NÃ£o hÃ¡ imposto sobre frete neste local',0),(410649,11407,'ru','ÐÐµÑ‚ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° ÐºÐ¾Ð½Ñ‚ÐµÐ¹Ð½ÐµÑ€Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·ÐºÐ¸ ÑÑ‚Ð¾ Ð¼ÐµÑÑ‚Ð¾',0),(410650,11407,'es','No Hay Impuesto de Flete en Este Local',0),(410651,11407,'de','Keine Steuer auf Fracht dieser Lage',0),(410652,11407,'en','No Tax On Freight This Location',0),(410653,11408,'is','',0),(410654,11408,'dr','(Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(410655,11408,'pr','Ù…Ø§Ù„ÙŠØ§Øª ÙƒØ±Ø§ÙŠÙ‡ Ø­Ù…Ù„(Ù…Ø­Ù…ÙˆÙ„Ù‡ ',0),(410656,11408,'tr','Vergi nakliye',0),(410657,11408,'pl','Podatek od towarÃ³w',0),(410658,11408,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð¸',0),(410659,11408,'ur','Ù¹ÛŒÚ©Ø³ ÙØ±Ø§Ø¦Ù¹',0),(410660,11408,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ñ‚ÐµÑ€ÐµÑ‚Ð½Ð¸',0),(410661,11408,'vi','CÆ°á»›c thuáº¿',0),(410662,11408,'af','Belasting vrag',0),(410663,11408,'ro','Taxa transport',0),(410664,11408,'et','Maksustamine kauba',0),(410665,11408,'si','Tovorni davek',0),(410666,11408,'ba','Pajak barang',0),(410667,11408,'nl','Fiscale vracht',0),(410668,11408,'fi','Vero rahti',0),(410669,11408,'no','Skatt frakt',0),(410670,11408,'da','Skat fragt',0),(410671,11408,'ko','ì„¸ê¸ˆ í™”ë¬¼',0),(410672,11408,'he','×”×•×‘×œ×” ×ž×¡',0),(410673,11408,'el','Î¦ÏŒÏÎ¿Ï… ÎµÎ¼Ï€Î¿ÏÎµÏ…Î¼Î±Ï„Î¹ÎºÏŽÎ½ Î¼ÎµÏ„Î±Ï†Î¿ÏÏŽÎ½',0),(410674,11408,'zh','ç¨ŽåŠ¡è´§è¿\r\n',0),(410675,11408,'sv','Skatt frakt',0),(410676,11408,'it','Tassa trasporto',0),(410677,11408,'tl','',0),(410678,11408,'th','à¸„à¹ˆà¸²à¸‚à¸™à¸ªà¹ˆà¸‡à¸ à¸²à¸©à¸µ',0),(410679,11408,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤­à¤¾à¤¡à¤¼à¤¾',0),(410680,11408,'ms','Cukai Perkhidmatan',0),(410681,11408,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø´Ø­Ù†',0),(410682,11408,'fr','Taxe fret',0),(410683,11408,'jp','ç¨Žã®è²¨ç‰©',0),(410684,11408,'pt','Carga tributÃ¡ria',0),(410685,11408,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(410686,11408,'es','Impuesto de Flete',0),(410687,11408,'de','Steuer-Fracht',0),(410688,11408,'en','Tax Freight',0),(410689,11409,'is','',0),(410690,11409,'dr','(Ù…Ø­Ù…ÙˆÙ„Ù‡) Ø§ÙŠÙ† Ù…Ø­Ù„ ',0),(410691,11409,'pr','Ù…Ø§Ù„ÙŠØ§Øª ÙƒØ±Ø§ÙŠÙ‡ Ø­Ù…Ù„(Ù…Ø­Ù…ÙˆÙ„Ù‡) Ø§ÙŠÙ† Ù…Ø­Ù„ ',0),(410692,11409,'tr','Vergi navlun bu konumu',0),(410693,11409,'pl','Podatek od towarÃ³w tej lokalizacji',0),(410694,11409,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð¸ Ñ‚Ð¾Ð²Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(410695,11409,'ur','Ù¹ÛŒÚ©Ø³ ÙØ±Ø§Ø¦Ù¹ Ø§Ø³ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(410696,11409,'sr','Ð¢ÐµÑ€ÐµÑ‚Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¾Ð²Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(410697,11409,'vi','CÆ°á»›c thuáº¿ cho khu vá»±c nÃ y',0),(410698,11409,'af','Belasting vrag hierdie ligging',0),(410699,11409,'ro','Taxa transport aceastÄƒ locaÅ£ie',0),(410700,11409,'et','Maksustamine kauba selles asukohas',0),(410701,11409,'si','Tovorni davek tej lokaciji',0),(410702,11409,'ba','Pajak barang lokasi ini',0),(410703,11409,'nl','Fiscale vracht deze locatie',0),(410704,11409,'fi','Vero tavaraliikenteen tÃ¤hÃ¤n sijaintiin',0),(410705,11409,'no','Skatt frakt denne plasseringen',0),(410706,11409,'da','Skat fragt denne placering',0),(410707,11409,'ko','ì„¸ê¸ˆ í™”ë¬¼ì´ì´ ìœ„ì¹˜',0),(410708,11409,'he','×”×•×‘×œ×” ×ž×¡ ××ª ×”×ž×™×§×•× ×”×–×”',0),(410709,11409,'el','Î¦ÏŒÏÎ¿Ï… ÎµÎ¼Ï€Î¿ÏÎµÏ…Î¼Î±Ï„Î¹ÎºÏŽÎ½ Î±Ï…Ï„Î® Ï„Î·Î½ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(410710,11409,'zh','ç¨ŽåŠ¡è´§è¿æ­¤ä½ç½®\r\n',0),(410711,11409,'sv','Skatt frakt denna plats',0),(410712,11409,'it','Tassa trasporto questa posizione',0),(410713,11409,'tl','',0),(410714,11409,'th','à¸„à¹ˆà¸²à¸‚à¸™à¸ªà¹ˆà¸‡à¸ à¸²à¸©à¸µà¸™à¸µà¹‰',0),(410715,11409,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤­à¤¾à¤¡à¤¼à¤¾ à¤‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨',0),(410716,11409,'ms','Cukai barang lokasi ini',0),(410717,11409,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø´Ø­Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(410718,11409,'fr','Taxe fret cet emplacement',0),(410719,11409,'jp','ç¨Žã®è²¨ç‰©å ´æ‰€',0),(410720,11409,'pt','Carga fiscal neste local',0),(410721,11409,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸ ÑÑ‚Ð¾ Ð¼ÐµÑÑ‚Ð¾',0),(410722,11409,'es','Impuesto Flete de Este Local',0),(410723,11409,'de','MwSt. Fracht dieser Lage',0),(410724,11409,'en','Tax Freight This Location',0),(410725,11410,'is','',0),(410726,11410,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ ',0),(410727,11410,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªÙ†Ø¸ÙŠÙ…Ø§Øª Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ ',0),(410728,11410,'tr','FaturalandÄ±rma ayarÄ± kullanÄ±n',0),(410729,11410,'pl','Ustawienie rozliczeÅ„',0),(410730,11410,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(410731,11410,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø³ÛŒÙ¹Ù†Ú¯ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(410732,11410,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÑƒ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(410733,11410,'vi','Sá»­ dá»¥ng thiáº¿t láº­p thanh toÃ¡n',0),(410734,11410,'af','Fakturering instelling gebruik',0),(410735,11410,'ro','UtilizaÈ›i setarea de facturare',0),(410736,11410,'et','Arved sÃ¤tte',0),(410737,11410,'si','Uporabite nastavitev obraÄuna',0),(410738,11410,'ba','Gunakan pengaturan penagihan',0),(410739,11410,'nl','Facturering instelling gebruiken',0),(410740,11410,'fi','Laskutus kÃ¤yttÃ¶asetuksen',0),(410741,11410,'no','Bruk fakturering innstillingen',0),(410742,11410,'da','Bruge fakturering indstilling',0),(410743,11410,'ko','ê²°ì œ ì„¤ì • ì‚¬ìš©',0),(410744,11410,'he','×”×©×ª×ž×© ×‘×”×’×“×¨×” ×—×™×•×‘',0),(410745,11410,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î· ÏÏÎ¸Î¼Î¹ÏƒÎ· Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(410746,11410,'zh','ä½¿ç”¨æ”¶æ¬¾è®¾ç½®\r\n',0),(410747,11410,'sv','InstÃ¤llningen fÃ¶r fakturering',0),(410748,11410,'it','Utilizzare l\'impostazione di fatturazione',0),(410749,11410,'tl','',0),(410750,11410,'th','à¹ƒà¸Šà¹‰à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(410751,11410,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤— à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(410752,11410,'ms','Gunakan seting bil',0),(410753,11410,'ar','Ø¥Ø³ØªØ®Ø¯Ù… Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(410754,11410,'fr','Utilisez le paramÃ¨tre de facturation',0),(410755,11410,'jp','è«‹æ±‚æ›¸ã®è¨­å®šã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(410756,11410,'pt','Usar configuraÃ§Ã£o do faturamento',0),(410757,11410,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(410758,11410,'es','ConfiguraciÃ³n de Utilizar Cuentas por Cobrar ',0),(410759,11410,'de','Billing-Einstellung verwenden',0),(410760,11410,'en','Use Billing Setting',0),(410761,11411,'is','',0),(410762,11411,'dr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(410763,11411,'pr','Ø³ÙØ§Ø±Ø´ ÙƒØ§Ø± Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(410764,11411,'tr','Ä°ÅŸ emri bulunamadÄ±',0),(410765,11411,'pl','Zlecenia nie znaleziono',0),(410766,11411,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð°',0),(410767,11411,'ur','Ú©Ø§Ù… Ú©Ø§ Ø­Ú©Ù… Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(410768,11411,'sr','Ð Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(410769,11411,'vi','KhÃ´ng tÃ¬m tháº¥y lá»‡nh',0),(410770,11411,'af','Werk orde gevind nie',0),(410771,11411,'ro','Comanda de lucru nu a fost gÄƒsit',0),(410772,11411,'et','TÃ¶Ã¶korraldus ei leitud',0),(410773,11411,'si','Delovnega naloga, ni mogoÄe najti',0),(410774,11411,'ba','Urutan kerja tidak ditemukan',0),(410775,11411,'nl','Work Order niet gevonden',0),(410776,11411,'fi','TyÃ¶tilaus ei lÃ¶ydy',0),(410777,11411,'no','Arbeidsordre ikke funnet',0),(410778,11411,'da','Arbejdsordre blev ikke fundet',0),(410779,11411,'ko','ìž‘ì—… ìˆœì„œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(410780,11411,'he','×”×–×ž× ×ª ×”×¢×‘×•×“×” ×œ× × ×ž×¦×',0),(410781,11411,'el','Î•Î½Ï„Î¿Î»Î® Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(410782,11411,'zh','å·¥ä½œå•æœªæ‰¾åˆ°',0),(410783,11411,'sv','Arbetsorder hittades inte',0),(410784,11411,'it','Ordine di lavoro non trovato',0),(410785,11411,'tl','',0),(410786,11411,'th','à¹„à¸¡à¹ˆà¸žà¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‡à¸²à¸™',0),(410787,11411,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(410788,11411,'ms','Arahan kerja yang tidak dijumpai',0),(410789,11411,'ar','Ø£Ù…Ø± Ø¹Ù…Ù„ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(410790,11411,'fr','Bon de travail introuvable',0),(410791,11411,'jp','ä½œæ¥­æ³¨æ–‡ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(410792,11411,'pt','Ordem de serviÃ§o nÃ£o encontrado',0),(410793,11411,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(410794,11411,'es','No se EncontrÃ³ el Orden de Trabajo',0),(410795,11411,'de','Arbeitsauftrag nicht gefunden',0),(410796,11411,'en','Work Order Not Found',0),(410797,11412,'is','',0),(410798,11412,'dr','( Ø§ØµÙ„Ø§Ø­ ) Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(410799,11412,'pr','ØªØ¹Ø¯ÙŠÙ„ ( Ø§ØµÙ„Ø§Ø­ ) Ø³Ù¾Ø±Ø¯Ù‡ ( Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(410800,11412,'tr','Ã–deme ayarlama',0),(410801,11412,'pl','ZÅ‚oÅ¼enia korekty',0),(410802,11412,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ',0),(410803,11412,'ur','Ø¬Ù…Ø¹ Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(410804,11412,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(410805,11412,'vi','Äiá»u chá»‰nh Ä‘áº·t cá»c',0),(410806,11412,'af','Deposito aanpassing',0),(410807,11412,'ro','Ajustare depozit',0),(410808,11412,'et','Tagatisraha korrigeerimine',0),(410809,11412,'si','Depozit prilagoditev',0),(410810,11412,'ba','Deposit penyesuaian',0),(410811,11412,'nl','Storting aanpassing',0),(410812,11412,'fi','Talletus sÃ¤Ã¤tÃ¶',0),(410813,11412,'no','Innskudd justering',0),(410814,11412,'da','Depositum justering',0),(410815,11412,'ko','ë³´ì¦ê¸ˆ ì¡°ì •',0),(410816,11412,'he','×”×ª××ž×ª ×¤×™×§×“×•×Ÿ',0),(410817,11412,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚',0),(410818,11412,'zh','è°ƒæ•´å­˜æ¬¾\r\n',0),(410819,11412,'sv','InsÃ¤ttning justering',0),(410820,11412,'it','Adeguamento del deposito',0),(410821,11412,'tl','',0),(410822,11412,'th','à¸à¸²à¸à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(410823,11412,'hi','à¤œà¤®à¤¾ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(410824,11412,'ms','Deposit pelarasan',0),(410825,11412,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„ØªÙƒÙŠÙ',0),(410826,11412,'fr','Ajustement de dÃ©pÃ´t',0),(410827,11412,'jp','é é‡‘ã®èª¿æ•´',0),(410828,11412,'pt','Ajuste de depÃ³sito',0),(410829,11412,'ru','Ð ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(410830,11412,'es','Ajuste de DepÃ³sito',0),(410831,11412,'de','Kaution-Anpassung',0),(410832,11412,'en','Deposit Adjustment',0),(410833,11413,'is','',0),(410834,11413,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù„ØºÙˆ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(410835,11413,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù„ØºÙˆ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(410836,11413,'tr','Kira kontratÄ± iptal edildi',0),(410837,11413,'pl','DzierÅ¼awy zostaÅ‚a anulowana',0),(410838,11413,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ðµ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð¾',0),(410839,11413,'ur','Ù„ÛŒØ² Ù…Ù†Ø³ÙˆØ® Ú©Ø±Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(410840,11413,'sr','Ð—Ð°ÐºÑƒÐ¿ Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½.',0),(410841,11413,'vi','há»£p Ä‘á»“ng thuÃª bá»‹ há»§y bá»',0),(410842,11413,'af','Huurkontrak is Gekanseleer',0),(410843,11413,'ro','Contract de leasing a fost anulat',0),(410844,11413,'et','ÃœÃ¼rileping on tÃ¼histatud',0),(410845,11413,'si','Zakup je bil preklican',0),(410846,11413,'ba','Sewa telah dibatalkan',0),(410847,11413,'nl','Lease-overeenkomst is geannuleerd',0),(410848,11413,'fi','Vuokrasopimus on peruutettu',0),(410849,11413,'no','Leieavtalen er avbrutt',0),(410850,11413,'da','LejemÃ¥let er blevet annulleret',0),(410851,11413,'ko','ìž„ëŒ€ ì·¨ì†Œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(410852,11413,'he','×—×•×–×” ×”×©×›×™×¨×•×ª ×‘×•×˜×œ',0),(410853,11413,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î­Ï‡ÎµÎ¹ Î±ÎºÏ…ÏÏ‰Î¸ÎµÎ¯',0),(410854,11413,'zh','ç§Ÿèµå·²è¢«å–æ¶ˆ\r\n',0),(410855,11413,'sv','Hyresavtalet har avbrutits',0),(410856,11413,'it','Contratto di locazione Ã¨ stata annullata',0),(410857,11413,'tl','',0),(410858,11413,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(410859,11413,'hi','à¤²à¥€à¤œ à¤°à¤¦à¥à¤¦ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(410860,11413,'ms','Pajakan telah dibatalkan',0),(410861,11413,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø¥Ù„ØºØ§Ø¡ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(410862,11413,'fr','Bail a Ã©tÃ© annulÃ©e',0),(410863,11413,'jp','ãƒªãƒ¼ã‚¹ã¯å–ã‚Šæ¶ˆã•ã‚Œã¾ã—ãŸ',0),(410864,11413,'pt','LocaÃ§Ã£o foi cancelada',0),(410865,11413,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð±Ñ‹Ð»Ð° Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(410866,11413,'es','Arrendamiento se CancelÃ³',0),(410867,11413,'de','Mietvertrag wurde abgebrochen',0),(410868,11413,'en','Lease Has Been Canceled',0),(410869,11414,'is','',0),(410870,11414,'dr','( Ø±Ø²Ø±Ùˆ',0),(410871,11414,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø°Ø®ÙŠØ±Ù‡( Ø±Ø²Ø±Ùˆ',0),(410872,11414,'tr','Rezervasyon Ã¼creti Transfer',0),(410873,11414,'pl','Rezerwacji opÅ‚ata za przelew',0),(410874,11414,'bg','Ð ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ Ñ‚Ð°ÐºÑÐ° Ð·Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ',0),(410875,11414,'ur','Ø¨Ú©Ù†Ú¯ ÙÛŒØ³ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(410876,11414,'sr','Ð ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ˜Ð° Ð½Ð°ÐºÐ½Ð°Ð´Ð° Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(410877,11414,'vi','chuyá»ƒn phÃ­ Ä‘áº·t trÆ°á»›c',0),(410878,11414,'af','Bespreking fooi oordrag',0),(410879,11414,'ro','Transfer de taxÄƒ de rezervare',0),(410880,11414,'et','Broneeringu tasu eest Ã¼leandmine',0),(410881,11414,'si','Prenos pristojbine rezervacije',0),(410882,11414,'ba','Transfer biaya reservasi',0),(410883,11414,'nl','Reservering vergoeding overdracht',0),(410884,11414,'fi','Varaus maksua siirto',0),(410885,11414,'no','Reservasjon gebyr overfÃ¸ring',0),(410886,11414,'da','Reservation gebyr overfÃ¸rsel',0),(410887,11414,'ko','ì˜ˆì•½ ë‚©ë¶€',0),(410888,11414,'he','×”×–×ž× ×” ×“×ž×™ ×”×¢×‘×¨×”',0),(410889,11414,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ Ï„Î­Î»Î¿Ï‚ ÎºÏÎ¬Ï„Î·ÏƒÎ·Ï‚',0),(410890,11414,'zh','é¢„è®¢è´¹è½¬ç§»\r\n',0),(410891,11414,'sv','Bokning avgift Ã¶verfÃ¶ring',0),(410892,11414,'it','Trasferimento di quota di prenotazione',0),(410893,11414,'tl','',0),(410894,11414,'th','à¹‚à¸­à¸™à¸„à¹ˆà¸²à¸ˆà¸­à¸‡',0),(410895,11414,'hi','à¤†à¤°à¤•à¥à¤·à¤£ à¤¶à¥à¤²à¥à¤• à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£',0),(410896,11414,'ms','Pemindahan bayaran Tempahan',0),(410897,11414,'ar','Ù†Ù‚Ù„ Ø±Ø³ÙˆÙ… Ø§Ù„Ø­Ø¬Ø²',0),(410898,11414,'fr','Transfert de frais de rÃ©servation',0),(410899,11414,'jp','äºˆç´„æ–™æŒ¯è¾¼',0),(410900,11414,'pt','TransferÃªncia de taxa de reserva',0),(410901,11414,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð±Ñ€Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð°',0),(410902,11414,'es','Transferencia de Cuota de ReservaciÃ³n',0),(410903,11414,'de','Reservierung Ã¼berweisen',0),(410904,11414,'en','Reservation Fee Transfer',0),(410905,11415,'is','',0),(410906,11415,'dr','Ú†Ùƒ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(410907,11415,'pr','Ú†Ùƒ Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(410908,11415,'tr','Ã–deme iÃ§in onay',0),(410909,11415,'pl','SprawdÅº, czy pÅ‚atnoÅ›ci',0),(410910,11415,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(410911,11415,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„',0),(410912,11415,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ',0),(410913,11415,'vi','SÃ©c thanh toÃ¡n',0),(410914,11415,'af','Kontroleer vir Betaling',0),(410915,11415,'ro','Check de platÄƒ',0),(410916,11415,'et','Kontrollimine maksmine',0),(410917,11415,'si','ÄŒek zakaj vplaÄilo',0),(410918,11415,'ba','Cek untuk pembayaran',0),(410919,11415,'nl','Selectievakje voor betaling',0),(410920,11415,'fi','Ruudullinen ajaksi lunastus',0),(410921,11415,'no','Sjekk For innbetaling',0),(410922,11415,'da','Check For betaling',0),(410923,11415,'ko','ì§€ë¶ˆì— ëŒ€ í•œ í™•ì¸',0),(410924,11415,'he','×”×¡×™×ž×•×Ÿ ×¢×‘×•×¨ ×ª×©×œ×•×',0),(410925,11415,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ Î³Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î®',0),(410926,11415,'zh','æ£€æŸ¥ä»˜æ¬¾\r\n',0),(410927,11415,'sv','Kontrollen betalningsfÃ¶relÃ¤ggande',0),(410928,11415,'it','Assegno per il pagamento',0),(410929,11415,'tl','',0),(410930,11415,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(410931,11415,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(410932,11415,'ms','Semak pembayaran',0),(410933,11415,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù„Ù„Ø¯ÙØ¹',0),(410934,11415,'fr','ChÃ¨que de paiement',0),(410935,11415,'jp','ãŠæ”¯æ‰•ã„ã®ç¢ºèª',0),(410936,11415,'pt','Cheque para pagamento',0),(410937,11415,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(410938,11415,'es','Cheque Para el Pago',0),(410939,11415,'de','Scheck fÃ¼r Zahlung',0),(410940,11415,'en','Check For Payment',0),(410941,11416,'is','',0),(410942,11416,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(410943,11416,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø§Ø±ÙŠ ',0),(410944,11416,'tr','GeÃ§erli kira',0),(410945,11416,'pl','BieÅ¼Ä…cego czynszu',0),(410946,11416,'bg','Ð¢ÐµÐºÑƒÑ‰ Ð½Ð°ÐµÐ¼',0),(410947,11416,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ú©Ø±Ø§ÛŒÛ',0),(410948,11416,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ñƒ',0),(410949,11416,'vi','Hiá»‡n táº¡i thuÃª',0),(410950,11416,'af','Huidige huur',0),(410951,11416,'ro','Curent inchiriere',0),(410952,11416,'et','Praegune Ã¼Ã¼r',0),(410953,11416,'si','Trenutni najemnine',0),(410954,11416,'ba','Saat ini Disewa',0),(410955,11416,'nl','Huidige huur',0),(410956,11416,'fi','Nykyinen vuokra',0),(410957,11416,'no','Gjeldende leie',0),(410958,11416,'da','NuvÃ¦rende leje',0),(410959,11416,'ko','í˜„ìž¬ ìž„ëŒ€',0),(410960,11416,'he','×©×›×¨ ×”×“×™×¨×” ×”× ×•×›×—×™×ª',0),(410961,11416,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎµÎ½Î¿Î¹ÎºÎ¯Î±ÏƒÎ·',0),(410962,11416,'zh','çŽ°æ—¶ç§Ÿé‡‘\r\n',0),(410963,11416,'sv','Nuvarande hyra',0),(410964,11416,'it','Affitto attuale',0),(410965,11416,'tl','',0),(410966,11416,'th','à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²',0),(410967,11416,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤¿à¤°à¤¾à¤¯à¤¾',0),(410968,11416,'ms','Sewa semasa',0),(410969,11416,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(410970,11416,'fr','Loyer actuel',0),(410971,11416,'jp','ç¾åœ¨ã®å®¶è³ƒ',0),(410972,11416,'pt','Renda atual',0),(410973,11416,'ru','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ Ð°Ñ€ÐµÐ½Ð´Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(410974,11416,'es','Renta Actual',0),(410975,11416,'de','Aktuelle Miete',0),(410976,11416,'en','Current Rent',0),(410977,11417,'is','',0),(410978,11417,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ',0),(410979,11417,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ',0),(410980,11417,'tr','Orijinal kira',0),(410981,11417,'pl','Oryginalny Wynajem',0),(410982,11417,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ Ð½Ð°ÐµÐ¼',0),(410983,11417,'ur','Ø§ØµÙ„ Ú©Ø±Ø§Ø¦Û’',0),(410984,11417,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ñƒ',0),(410985,11417,'vi','Ban Ä‘áº§u cho thuÃª',0),(410986,11417,'af','Oorspronklike huur',0),(410987,11417,'ro','Chirie original',0),(410988,11417,'et','Algne Rent',0),(410989,11417,'si','Original najemnine',0),(410990,11417,'ba','Sewa asli',0),(410991,11417,'nl','Oorspronkelijke huur',0),(410992,11417,'fi','AlkuperÃ¤inen vuokra',0),(410993,11417,'no','Opprinnelige leie',0),(410994,11417,'da','Oprindelige leje',0),(410995,11417,'ko','ì›ëž˜ ìž„ëŒ€',0),(410996,11417,'he','×”×©×›×™×¨×•×ª ×”×ž×§×•×¨×™',0),(410997,11417,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÎµÎ½Î¿Î¹ÎºÎ¯Î±ÏƒÎ·',0),(410998,11417,'zh','åŽŸç§Ÿé‡‘\r\n',0),(410999,11417,'sv','Ursprungliga hyra',0),(411000,11417,'it','Affitto originale',0),(411001,11417,'tl','',0),(411002,11417,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²à¸•à¹‰à¸™à¸‰à¸šà¸±à¸š',0),(411003,11417,'hi','à¤®à¥‚à¤² à¤•à¤¿à¤°à¤¾à¤ à¤ªà¤°',0),(411004,11417,'ms','Tanah asal',0),(411005,11417,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø£ØµÙ„ÙŠ',0),(411006,11417,'fr','Loyer initial',0),(411007,11417,'jp','å…ƒã®å®¶è³ƒ',0),(411008,11417,'pt','Aluguel original',0),(411009,11417,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÐÑ€ÐµÐ½Ð´Ð°',0),(411010,11417,'es','Renta Original',0),(411011,11417,'de','Original mieten',0),(411012,11417,'en','Original Rent',0),(411013,11418,'is','',0),(411014,11418,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø³ÙŠØ§Ø± Ù¾Ø§ÙŠÙŠÙ† Ø§Ø³Øª ',0),(411015,11418,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø³ÙŠØ§Ø± Ù¾Ø§ÙŠÙŠÙ† Ø§Ø³Øª ',0),(411016,11418,'tr','Kira tutarÄ± Ã§ok dÃ¼ÅŸÃ¼k',0),(411017,11418,'pl','Wynajem kwota jest za niska',0),(411018,11418,'bg','Ð¡ÑƒÐ¼Ð°Ñ‚Ð° Ð·Ð° Ð½Ð°ÐµÐ¼Ð° Ðµ Ñ‚Ð²ÑŠÑ€Ð´Ðµ Ð½Ð¸ÑÐºÐ°',0),(411019,11418,'ur','Ú©Ø±Ø§ÛŒÛ Ú©ÛŒ Ø±Ù‚Ù… Ø¨ÛØª Ú©Ù… ÛÛ’ Û”',0),(411020,11418,'sr','ÐÐ°Ñ˜Ð°Ð¼ Ð¸Ð·Ð½Ð¾Ñ Ñ˜Ðµ Ð¿Ñ€ÐµÐ½Ð¸Ð·Ð°Ðº',0),(411021,11418,'vi','Sá»‘ tiá»n thuÃª nhÃ  lÃ  quÃ¡ tháº¥p',0),(411022,11418,'af','Huur bedrag Is te laag',0),(411023,11418,'ro','Valoarea chiriei este prea scÄƒzut',0),(411024,11418,'et','ÃœÃ¼ri suurus on liiga vÃ¤ike',0),(411025,11418,'si','Znesek najemnine je prenizka',0),(411026,11418,'ba','Jumlah sewa terlalu rendah',0),(411027,11418,'nl','Huur bedrag Is te laag',0),(411028,11418,'fi','Vuokrattavana summa on liian alhainen',0),(411029,11418,'no','Leie er for lavt',0),(411030,11418,'da','Leje belÃ¸b er for lav',0),(411031,11418,'ko','ìž„ëŒ€ ê¸ˆì•¡ì€ ë„ˆë¬´ ë‚®ì€',0),(411032,11418,'he','×¡×›×•× ×©×›×¨ ×”×“×™×¨×” ×”×•× × ×ž×•×š ×ž×“×™',0),(411033,11418,'el','Î•Î½Î¿Î¹ÎºÎ¯Î±ÏƒÎ· Ï€Î¿ÏƒÏŒ ÎµÎ¯Î½Î±Î¹ Ï€Î¿Î»Ï Ï‡Î±Î¼Î·Î»Î®',0),(411034,11418,'zh','ç§Ÿé‡‘æ•°é¢å¤ªä½Ž\r\n',0),(411035,11418,'sv','Hyran Ã¤r fÃ¶r lÃ¥g',0),(411036,11418,'it','Affitto quantitÃ  Ã¨ troppo bassa',0),(411037,11418,'tl','',0),(411038,11418,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¹€à¸Šà¹ˆà¸²à¸­à¸¢à¸¹à¹ˆà¸•à¹ˆà¸³à¹€à¸à¸´à¸™à¹„à¸›',0),(411039,11418,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¤¾ à¤°à¤¾à¤¶à¤¿ à¤­à¥€ à¤•à¤® à¤¹à¥ˆ',0),(411040,11418,'ms','Jumlah sewa adalah terlalu rendah',0),(411041,11418,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ù…Ù†Ø®ÙØ¶ Ø¬Ø¯Ø§Ù‹',0),(411042,11418,'fr','Montant du loyer est trop faible',0),(411043,11418,'jp','è³ƒè²¸æ–™ã®é‡ãŒä½Žã™ãŽã¾ã™ã€‚',0),(411044,11418,'pt','Quantidade de aluguel Ã© muito baixa',0),(411045,11418,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð°Ñ€ÐµÐ½Ð´Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÐ»Ð¸ÑˆÐºÐ¾Ð¼ Ð½Ð¸Ð·ÐºÐ°',0),(411046,11418,'es','Monto de Renta Es Demasiado Bajo',0),(411047,11418,'de','Miete Betrag ist zu niedrig',0),(411048,11418,'en','Rent Amount Is Too Low',0),(411049,11419,'is','',0),(411050,11419,'dr','ÙƒØ§Ø±Ø¨Ø± Ø§Ø¬Ø±Ø§ÙŠÙŠ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(411051,11419,'pr','ÙƒØ§Ø±Ø¨Ø± Ø§Ø¬Ø±Ø§ÙŠÙŠ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(411052,11419,'tr','Admin kullanÄ±cÄ± gerektirir',0),(411053,11419,'pl','Wymaga uÅ¼ytkownika Admin',0),(411054,11419,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0);
INSERT INTO `langdef` VALUES (411055,11419,'ur','Ù…Ù†ØªØ¸Ù… ØµØ§Ø±Ù Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(411056,11419,'sr','Ð—Ð°Ñ…Ñ‚Ð¸Ñ˜ÐµÐ²Ð° ÐÐ´Ð¼Ð¸Ð½ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº',0),(411057,11419,'vi','YÃªu cáº§u ngÆ°á»i sá»­ dá»¥ng Admin',0),(411058,11419,'af','Vereis Admin Gebruiker',0),(411059,11419,'ro','Cere Admin User',0),(411060,11419,'et','NÃµuab Admin kasutaja',0),(411061,11419,'si','Zahteva uporabnika Admin',0),(411062,11419,'ba','Memerlukan pengguna Admin',0),(411063,11419,'nl','Admin gebruiker vereist',0),(411064,11419,'fi','EdellyttÃ¤Ã¤ jÃ¤rjestelmÃ¤nvalvojan oikeuksia',0),(411065,11419,'no','Krever administrator',0),(411066,11419,'da','KrÃ¦ver Admin-brugeren',0),(411067,11419,'ko','ì‚¬ìš©ìžê°€ ê´€ë¦¬ í•´ì•¼',0),(411068,11419,'he','×“×•×¨×©×ª ×ž×©×ª×ž×© Admin',0),(411069,11419,'el','Î‘Ï€Î±Î¹Ï„ÎµÎ¯ Î±Ï€ÏŒ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î· Admin',0),(411070,11419,'zh','éœ€è¦ç®¡ç†å‘˜ç”¨æˆ·\r\n',0),(411071,11419,'sv','KrÃ¤ver Admin anvÃ¤ndare',0),(411072,11419,'it','Richiede l\'utente Admin',0),(411073,11419,'tl','',0),(411074,11419,'th','à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰ Admin',0),(411075,11419,'hi','à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(411076,11419,'ms','Memerlukan pengguna Admin',0),(411077,11419,'ar','ÙŠØªØ·Ù„Ø¨ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Admin',0),(411078,11419,'fr','Exige que l\'utilisateur Admin',0),(411079,11419,'jp','ç®¡ç†è€…ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’å¿…è¦ã¨ã—ã¾ã™ã€‚',0),(411080,11419,'pt','Requer que o usuÃ¡rio Admin',0),(411081,11419,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Admin',0),(411082,11419,'es','Se Requiere Usuario Admin',0),(411083,11419,'de','Erfordert Admin-Benutzer',0),(411084,11419,'en','Requires Admin User',0),(411085,11420,'is','',0),(411086,11420,'dr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(411087,11420,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(411088,11420,'tr','Ä°ÅŸlem Ã¶demesi',0),(411089,11420,'pl','Proces pÅ‚atnoÅ›ci',0),(411090,11420,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑÐ° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(411091,11420,'ur','Ø¹Ù…Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(411092,11420,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(411093,11420,'vi','tiáº¿n hÃ nh thanh toÃ¡n',0),(411094,11420,'af','Prosesseer Betaling',0),(411095,11420,'ro','Procesul de platÄƒ',0),(411096,11420,'et','Protsessi makse',0),(411097,11420,'si','Postopek plaÄila',0),(411098,11420,'ba','Proses pembayaran',0),(411099,11420,'nl','Betaling proces',0),(411100,11420,'fi','Prosessin maksaminen',0),(411101,11420,'no','Prosessen betaling',0),(411102,11420,'da','Processen betaling',0),(411103,11420,'ko','í”„ë¡œì„¸ìŠ¤ ì§€ë¶ˆ',0),(411104,11420,'he','×ª×”×œ×™×š ×”×ª×©×œ×•×',0),(411105,11420,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(411106,11420,'zh','å¤„ç†æ”¯ä»˜\r\n',0),(411107,11420,'sv','Processen betalning',0),(411108,11420,'it','Processo di pagamento',0),(411109,11420,'tl','',0),(411110,11420,'th','à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(411111,11420,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(411112,11420,'ms','Proses pembayaran',0),(411113,11420,'ar','Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ø¯ÙØ¹',0),(411114,11420,'fr','Processus de paiement',0),(411115,11420,'jp','æ”¯æ‰•å‡¦ç†',0),(411116,11420,'pt','Processo de pagamento',0),(411117,11420,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(411118,11420,'es','Pago de Proceso',0),(411119,11420,'de','Prozess Zahlung',0),(411120,11420,'en','Process Payment',0),(411121,11421,'is','',0),(411122,11421,'dr','ÙƒØ§Ø±Ù…Ù†Ø¯ â€“ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙˆÙŠÚ˜Ù‡ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø´Ø±ÙƒØª ',0),(411123,11421,'pr','ÙƒØ§Ø±Ù…Ù†Ø¯ â€“ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ ÙˆÙŠÚ˜Ù‡ Ø¯ÙØªØ± ÙƒÙ„ Ø¨Ø±Ø§ÙŠ Ù‡Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø´Ø±ÙƒØª ',0),(411124,11421,'tr','Åžirket vergi harcamalarÄ± iÃ§in Ã§alÄ±ÅŸana Ã¶zgÃ¼ GL hesaplarÄ±',0),(411125,11421,'pl','GL danego pracownika rozlicza koszty podatkowe firmy',0),(411126,11421,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ð¸ GL ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð½Ð° Ð´Ñ€ÑƒÐ¶ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(411127,11421,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ù…Ø®ØµÙˆØµ Ø¬ÛŒØ¬Û’ Ú©Ù…Ù¾Ù†ÛŒ Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(411128,11421,'sr','Ð¡Ð¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ðµ Ð·Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ Ð“Ð› ÐºÐ¾Ð½Ñ‚Ð° Ð·Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(411129,11421,'vi','NhÃ¢n viÃªn- cÃ¡c tÃ i khoáº£n sá»• cÃ¡i Ä‘áº·c biá»‡t cho chi phÃ­ thuáº¿ cá»§a cÃ´ng ty',0),(411130,11421,'af','Werknemer-spesifieke GL rekeninge vir maatskappy belasting uitgawes',0),(411131,11421,'ro','Angajat-specifice GL conturi pentru compania fiscal cheltuielile',0),(411132,11421,'et','TÃ¶Ã¶tajakohane GL moodustab ettevÃµtte hasartmÃ¤ngumaksude kulud',0),(411133,11421,'si','Zaposlenega znaÄilne GL predstavlja za podjetje stroÅ¡ke davÄne',0),(411134,11421,'ba','Karyawan-spesifik GL menyumbang beban pajak perusahaan',0),(411135,11421,'nl','Werknemer-specifieke GL rekeningen voor bedrijf belastingen',0),(411136,11421,'fi','TyÃ¶ntekijÃ¤kohtaisen GL osuus yrityksen ALV-menot',0),(411137,11421,'no','Ansattspesifikke GL stÃ¥r For selskapet skattebelastning',0),(411138,11421,'da','Medarbejderspecifikke GL tegner For firmaet skat udgifter',0),(411139,11421,'ko','ì§ì› ì „ìš© GL íšŒì‚¬ ì„¸ê¸ˆ ë¹„ìš© ê³„ì •',0),(411140,11421,'he','×”×¢×•×‘×“ ×”×¡×¤×¦×™×¤×™ GL ×—×©×‘×•× ×•×ª ×¢×‘×•×¨ ×”×—×‘×¨×” ××™×¡×™×ž ×ª×•××¦×•×”',0),(411141,11421,'el','Î£Ï…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿ GL Î±Î½Î±Î»Î¿Î³ÎµÎ¯ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ­Ï‚ Î´Î±Ï€Î¬Î½ÎµÏ‚',0),(411142,11421,'zh','é›‡å‘˜çš„å…·ä½“æ€»å¸å¸æˆ·ä¸ºå…¬å¸ç¨Žæ”¶è´¹ç”¨\r\n',0),(411143,11421,'sv','Medarbetarspecifika GL stÃ¥r fÃ¶r fÃ¶retaget skattekostnader',0),(411144,11421,'it','Dipendente specifiche GL conti per spese fiscali aziendali',0),(411145,11421,'tl','',0),(411146,11421,'th','GL à¹€à¸‰à¸žà¸²à¸°à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸šà¸±à¸à¸Šà¸µà¸šà¸£à¸´à¸©à¸±à¸—à¸ à¸²à¸©à¸µà¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢',0),(411147,11421,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤–à¤°à¥à¤šà¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€-à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ GL à¤–à¤¾à¤¤à¥‹à¤‚',0),(411148,11421,'ms','GL pekerja khusus akaun bagi perbelanjaan cukai syarikat',0),(411149,11421,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª GL Ø§Ù„Ø®Ø§ØµØ© Ø¨Ø§Ù„Ù…ÙˆØ¸Ù Ù„Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©',0),(411150,11421,'fr','GL propre Ã  un employÃ© responsable de dÃ©penses fiscales de la sociÃ©tÃ©',0),(411151,11421,'jp','å¾“æ¥­å“¡å›ºæœ‰ã® GL ä¼šç¤¾ç¨Žé‡‘è²»ç”¨ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã—ã¾ã™ã€‚',0),(411152,11421,'pt','GL especÃ­ficos do funcionÃ¡rio Ã© responsÃ¡vel por despesas fiscais de empresa',0),(411153,11421,'ru','GL Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ° ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(411154,11421,'es','Las Cuentas LM Especificamente de Empleados Para Gastos de Impuestos de la Empresa',0),(411155,11421,'de','Mitarbeiterspezifischen GL entfallen Firma Steueraufwand',0),(411156,11421,'en','Employee-Specific GL Accounts For Company Tax Expenses',0),(411157,11422,'is','',0),(411158,11422,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(411159,11422,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø¯ÙˆÙ„ØªÙŠ ',0),(411160,11422,'tr','Federal iÅŸsizlik gider',0),(411161,11422,'pl','WydatkÃ³w federalnych bezrobocia',0),(411162,11422,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(411163,11422,'ur','Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ú©ÛŒ Ø´Ø±Ø­ ÙˆÙØ§Ù‚ÛŒ Ø®Ø±Ú†Û’',0),(411164,11422,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚Ð¸ Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð°',0),(411165,11422,'vi','chi phÃ­ tháº¥t nghiá»‡p liÃªn bang',0),(411166,11422,'af','Federale werkloosheid uitgawe',0),(411167,11422,'ro','Cheltuieli de ÅŸomaj federale',0),(411168,11422,'et','FÃ¶deraal tÃ¶Ã¶tuse kulu',0),(411169,11422,'si','Zvezni brezposelnosti stroÅ¡ke',0),(411170,11422,'ba','Biaya pengangguran Federal',0),(411171,11422,'nl','Federale werkloosheid kosten',0),(411172,11422,'fi','Federal tyÃ¶ttÃ¶myys kustannuksella',0),(411173,11422,'no','FÃ¸derale arbeidsledighet bekostning',0),(411174,11422,'da','FÃ¸derale arbejdslÃ¸shed udgift',0),(411175,11422,'ko','ì—°ë°© ì‹¤ì—… ë¹„ìš©',0),(411176,11422,'he','×”×•×¦××•×ª ××‘×˜×œ×” ×¤×“×¨×œ×™',0),(411177,11422,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® Î±Î½ÎµÏÎ³Î¯Î±Ï‚ Î´Î±Ï€Î¬Î½Î·',0),(411178,11422,'zh','è”é‚¦å¤±ä¸šè´¹ç”¨\r\n',0),(411179,11422,'sv','Federala arbetslÃ¶shet bekostnad',0),(411180,11422,'it','Spesa federale disoccupazione',0),(411181,11422,'tl','',0),(411182,11422,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸à¸²à¸£à¸§à¹ˆà¸²à¸‡à¸‡à¸²à¸™à¸‚à¸­à¸‡à¸£à¸±à¸à¸šà¸²à¸¥à¸à¸¥à¸²à¸‡',0),(411183,11422,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤µà¥à¤¯à¤¯',0),(411184,11422,'ms','Perbelanjaan Persekutuan pengangguran',0),(411185,11422,'ar','Ù†ÙÙ‚Ø© Ø§Ù„Ø¨Ø·Ø§Ù„Ø© Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(411186,11422,'fr','DÃ©penses de chÃ´mage fÃ©dÃ©rale',0),(411187,11422,'jp','é€£é‚¦æ”¿åºœã®å¤±æ¥­ã®è²»ç”¨',0),(411188,11422,'pt','Despesa federal desemprego',0),(411189,11422,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ Ð·Ð° ÑÑ‡ÐµÑ‚',0),(411190,11422,'es','Gasto de Desempleo Federal',0),(411191,11422,'de','Bundesrepublik Arbeitslosigkeit Kosten',0),(411192,11422,'en','Federal Unemployment Expense',0),(411193,11423,'is','',0),(411194,11423,'dr','Ø§Ú¯Ø± Ú†ÙŠØ²ÙŠ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ø³ÙŠØ³ØªÙ… Ø§Ø² Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†Ø¯',0),(411195,11423,'pr','Ø§Ú¯Ø± Ú†ÙŠØ²ÙŠ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ø³ÙŠØ³ØªÙ… Ø§Ø² Ù¾ÙŠØ´ ÙØ±Ø¶ Ù‡Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ ÙƒÙ†Ø¯',0),(411196,11423,'tr','HiÃ§biri sistemine girdiÄŸi Will Use varsayÄ±lan kullanÄ±lÄ±r',0),(411197,11423,'pl','JeÅ›li nie wprowadzono System bÄ™dzie UÅ¼yj ustawieÅ„ domyÅ›lnych',0),(411198,11423,'bg','ÐÐºÐ¾ Ð½ÑÐ¼Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð° ÑÐ¸ÑÑ‚ÐµÐ¼Ð° Ñ‰Ðµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(411199,11423,'ur','Ø§Ú¯Ø± Ú©ÙˆØ¦ÛŒ Ø¨Ú¾ÛŒ Ù†Ø¸Ø§Ù… Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ ÛÙˆÚº Ú¯Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø·Û’ Ø´Ø¯Û',0),(411200,11423,'sr','ÐÐºÐ¾ Ð½Ð¸Ñ˜ÐµÐ´Ð°Ð½ ÑƒÐ»Ð°ÑÐºÐ° Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼ Ð²Ð¾Ñ™Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ',0),(411201,11423,'vi','Náº¿u khÃ´ng ai Ä‘Äƒng nháº­p há»‡ thá»‘ng sáº½ sá»­ dá»¥ng máº·c Ä‘á»‹nh',0),(411202,11423,'af','As geen stelsel ingesleutel Defaults sal gebruik',0),(411203,11423,'ro','DacÄƒ nici unul introdus sistemul va utilizare setÄƒri implicite',0),(411204,11423,'et','Kui Ã¼kski sisestanud sÃ¼steemi tahe kasutada vaikimisi',0),(411205,11423,'si','ÄŒe noben sistem bo uporabo privzetih nastavitev',0),(411206,11423,'ba','Jika tidak ada memasuki sistem akan menggunakan default',0),(411207,11423,'nl','Als geen systeem ingevoerd standaard zal gebruik',0),(411208,11423,'fi','Jos mikÃ¤Ã¤n jÃ¤rjestelmÃ¤ tulee KÃ¤ytÃ¤ oletusasetuksia',0),(411209,11423,'no','Hvis ingen angitt System standarder vil bruk',0),(411210,11423,'da','Hvis ingen angivet System standardindstillinger vil brug',0),(411211,11423,'ko','ì‹œìŠ¤í…œ ìž…ë ¥ í•˜ì§€ ì•Šì€ ê²½ìš° ê¸°ë³¸ê°’ ê²ƒ ì‚¬ìš©',0),(411212,11423,'he','×× ××£ ××—×“ ×œ× × ×›× ×¡ ×œ×ž×¢×¨×›×ª ×•×™×œ ×”×©×ª×ž×© ×‘×‘×¨×™×¨×•×ª ×ž×—×“×œ',0),(411213,11423,'el','Î‘Î½ Î´ÎµÎ½ ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯ ÏƒÏÏƒÏ„Î·Î¼Î± Î¸Î± Ï‡ÏÎ®ÏƒÎ· Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(411214,11423,'zh','å¦‚æžœæ²¡æœ‰è¾“å…¥ç³»ç»Ÿå°†ä½¿ç”¨é»˜è®¤å€¼\r\n',0),(411215,11423,'sv','Om ingen anges systemet standardvÃ¤rden kommer AnvÃ¤nd',0),(411216,11423,'it','Se nessuno entrato sistema volontÃ  valori predefiniti',0),(411217,11423,'tl','',0),(411218,11423,'th','à¸–à¹‰à¸²à¹„à¸¡à¹ˆà¹ƒà¸ªà¹ˆà¸£à¸°à¸šà¸š à¸ˆà¸°à¹ƒà¸Šà¹‰à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(411219,11423,'hi','à¤¯à¤¦à¤¿ à¤•à¥‹à¤ˆ à¤­à¥€ à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¤—à¥‡ à¤‰à¤ªà¤¯à¥‹à¤— à¤šà¥‚à¤•',0),(411220,11423,'ms','Jika tidak ada memasuki sistem penggunaan akan lalai',0),(411221,11423,'ar','Ø¥Ø°Ø§ Ù„Ù… ØªØ¯Ø®Ù„ Ù†Ø¸Ø§Ù… Ø¥Ø±Ø§Ø¯Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ§Øª',0),(411222,11423,'fr','Si aucun n\'est entrÃ© dans le systÃ¨me utilisera par dÃ©faut',0),(411223,11423,'jp','æ—¢å®šå€¤ãŒä½¿ç”¨ã‚·ã‚¹ãƒ†ãƒ ã«å…¥ã£ã¦ã„ãªã„å ´åˆ',0),(411224,11423,'pt','Se nenhum introduzido o sistema irÃ¡ usar padrÃµes',0),(411225,11423,'ru','Ð•ÑÐ»Ð¸ Ð½Ð¸ Ð¾Ð´Ð½Ð° ÑÐ¸ÑÑ‚ÐµÐ¼Ð° Ð±ÑƒÐ´ÐµÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(411226,11423,'es','Si No Entra Nada el Sistema Usuara el Predeterminado',0),(411227,11423,'de','Wenn keine System eingegeben wird standardmÃ¤ÃŸig wird verwendet',0),(411228,11423,'en','If None Entered System Will Use Defaults',0),(411229,11424,'is','',0),(411230,11424,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰ Ø´Ø±ÙƒØª ',0),(411231,11424,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©Ù‰ Ø´Ø±ÙƒØª ',0),(411232,11424,'tr','Medicare ÅŸirket gideri',0),(411233,11424,'pl','Koszt firmy Medicare',0),(411234,11424,'bg','Medicare ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(411235,11424,'ur','Ù…ÛŒÚˆÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø®Ø±Ú†Û’',0),(411236,11424,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð°',0),(411237,11424,'vi','chi phÃ­ y tÃª cá»§a cÃ´ng ty',0),(411238,11424,'af','Medicare maatskappy uitgawe',0),(411239,11424,'ro','Medicare compania cheltuieli',0),(411240,11424,'et','Medicare firma kulul',0),(411241,11424,'si','Medicare podjetje stroÅ¡ke',0),(411242,11424,'ba','Biaya Medicare perusahaan',0),(411243,11424,'nl','Medicare bedrijf kosten',0),(411244,11424,'fi','Medicare yrityksen kustannuksella',0),(411245,11424,'no','Medicare selskapet bekostning',0),(411246,11424,'da','Medicare selskabets regning',0),(411247,11424,'ko','ë©”ë””ì¼€ì–´ íšŒì‚¬ ë¹„ìš©',0),(411248,11424,'he','×”×•×¦××•×ª ×ž×“×™×§×™×™×¨',0),(411249,11424,'el','Medicare ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î´Î±Ï€Î¬Î½Î·',0),(411250,11424,'zh','åŒ»ä¿å…¬å¸å‡ºèµ„\r\n',0),(411251,11424,'sv','Medicare fÃ¶retag bekostnad',0),(411252,11424,'it','Medicare azienda spese',0),(411253,11424,'tl','',0),(411254,11424,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢ à¸šà¸£à¸´à¸©à¸±à¸—à¹€à¸¡à¸”à¸´à¹à¸„à¸£à¹Œ',0),(411255,11424,'hi','à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤° à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¥à¤¯à¤¯',0),(411256,11424,'ms','Perbelanjaan Medicare Syarikat',0),(411257,11424,'ar','Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(411258,11424,'fr','Frais de la compagnie d\'assurance-maladie',0),(411259,11424,'jp','ãƒ¡ãƒ‡ã‚£ã‚±ã‚¢ã®ä¼šç¤¾ã®çµŒè²»',0),(411260,11424,'pt','Despesa de empresa de Medicare',0),(411261,11424,'ru','Ð—Ð° ÑÑ‡ÐµÑ‚ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Medicare',0),(411262,11424,'es','Gastos de Empresa de Medicare',0),(411263,11424,'de','Medicare Unternehmen Kosten',0),(411264,11424,'en','Medicare Company Expense',0),(411265,11425,'is','',0),(411266,11425,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§Ø³ØªØ§Ù† ',0),(411267,11425,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø¨ÙŠÙƒØ§Ø±ÙŠ Ø§Ø³ØªØ§Ù† ',0),(411268,11425,'tr','Devlet iÅŸsizlik gider',0),(411269,11425,'pl','Stan bezrobocia kosztem',0),(411270,11425,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(411271,11425,'ur','Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ú©Û’ Ø±ÛŒØ§Ø³ØªÛŒ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(411272,11425,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚Ð¸',0),(411273,11425,'vi','Chi phÃ­ tháº¥t nghiá»‡p cá»§a tiá»ƒu bang',0),(411274,11425,'af','Uitgawe staat werkloosheid',0),(411275,11425,'ro','Cheltuieli de ÅŸomaj de stat',0),(411276,11425,'et','Riikliku tÃ¶Ã¶tuskindlustuse kulu',0),(411277,11425,'si','Stanje brezposelnosti stroÅ¡ke',0),(411278,11425,'ba','Biaya pengangguran negara',0),(411279,11425,'nl','Staat werkloosheid kosten',0),(411280,11425,'fi','Valtion tyÃ¶ttÃ¶myyden kustannuksella',0),(411281,11425,'no','Statlig arbeidsledighet bekostning',0),(411282,11425,'da','Statslige arbejdslÃ¸shed udgift',0),(411283,11425,'ko','ì£¼ ì‹¤ì—… ë¹„ìš©',0),(411284,11425,'he','×”××‘×˜×œ×” ×”×ž×“×™× ×” ×”×•×¦××•×ª',0),(411285,11425,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Î½ÎµÏÎ³Î¯Î±Ï‚ Î´Î±Ï€Î¬Î½Î·',0),(411286,11425,'zh','å›½å®¶å¤±ä¸šè´¹ç”¨\r\n',0),(411287,11425,'sv','Statlig arbetslÃ¶shet bekostnad',0),(411288,11425,'it','Spesa dello stato di disoccupazione',0),(411289,11425,'tl','',0),(411290,11425,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸‡à¸²à¸™à¸£à¸±à¸',0),(411291,11425,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤µà¥à¤¯à¤¯',0),(411292,11425,'ms','Pengangguran Negeri perbelanjaan',0),(411293,11425,'ar','Ù†ÙÙ‚Ø© Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ù„Ø¨Ø·Ø§Ù„Ø©',0),(411294,11425,'fr','Frais de l\'Ã©tat de chÃ´mage',0),(411295,11425,'jp','å·žã®å¤±æ¥­çŽ‡ã®è²»ç”¨',0),(411296,11425,'pt','Estado de desemprego despesa',0),(411297,11425,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ Ð·Ð° ÑÑ‡ÐµÑ‚',0),(411298,11425,'es','Gasto de Desempleo Estatal',0),(411299,11425,'de','Staatliche Arbeitslosigkeit Kosten',0),(411300,11425,'en','State Unemployment Expense',0),(411301,11426,'is','',0),(411302,11426,'dr','Ù…ÙƒØ§Ù†Ù‡Ø§ÙŠ Ù…Ø¬Ø§Ø² ',0),(411303,11426,'pr','Ù…ÙƒØ§Ù†Ù‡Ø§ÙŠ Ù…Ø¬Ø§Ø² ',0),(411304,11426,'tr','Ä°zin verilen yerleri',0),(411305,11426,'pl','Miejscach dozwolone',0),(411306,11426,'bg','ÐœÐµÑÑ‚Ð° Ð¼Ð¾Ð³Ð°Ñ‚',0),(411307,11426,'ur','Ù…Ù‚Ø§Ù…Ø§Øª Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(411308,11426,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(411309,11426,'vi','Vá»‹ trÃ­ Ä‘Æ°á»£c phÃ©p',0),(411310,11426,'af','Plekke toegelaat',0),(411311,11426,'ro','Locatii a permis',0),(411312,11426,'et','Lubatud asukohad',0),(411313,11426,'si','Lokacijah, dovoljeno',0),(411314,11426,'ba','Lokasi yang diperbolehkan',0),(411315,11426,'nl','Locaties toegestaan',0),(411316,11426,'fi','Sijainnit-',0),(411317,11426,'no','Steder tillatt',0),(411318,11426,'da','Steder tilladt',0),(411319,11426,'ko','ìœ„ì¹˜ í—ˆìš©',0),(411320,11426,'he','×‘×ž×§×•×ž×•×ª ×ž×•×¨×©×™×',0),(411321,11426,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚ Ï€Î¿Ï… ÎµÏ€Î¹Ï„ÏÎ­Ï€Î¿Î½Ï„Î±Î¹',0),(411322,11426,'zh','å…è®¸åœ°ç‚¹\r\n',0),(411323,11426,'sv','Platser tillÃ¥ts',0),(411324,11426,'it','Posizioni consentite',0),(411325,11426,'tl','',0),(411326,11426,'th','à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(411327,11426,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(411328,11426,'ms','Lokasi-lokasi yang dibenarkan',0),(411329,11426,'ar','Ø§Ù„Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(411330,11426,'fr','Emplacements autorisÃ©s',0),(411331,11426,'jp','è¨±å¯ã•ã‚Œã¦å ´æ‰€',0),(411332,11426,'pt','Locais permitidos',0),(411333,11426,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð½Ð¾Ðµ ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(411334,11426,'es','Ubicaciones Permitidos',0),(411335,11426,'de','Standorte erlaubt',0),(411336,11426,'en','Locations Allowed',0),(411337,11427,'is','',0),(411338,11427,'dr','(Ù…Ù‚Ø¯Ø§Ø±) Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(411339,11427,'pr','Ø´Ù…Ø§Ø±Ø´(Ù…Ù‚Ø¯Ø§Ø±) Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(411340,11427,'tr','Nakit',0),(411341,11427,'pl','Liczba Å›rodkÃ³w pieniÄ™Å¼nych',0),(411342,11427,'bg','Ð‘Ñ€Ð¾Ð¹ Ð±Ñ€Ð¾Ð¹',0),(411343,11427,'ur','Ù†Ù‚Ø¯ Ú©Ø§ Ø´Ù…Ø§Ø±',0),(411344,11427,'sr','Ð‘Ñ€Ð¾Ñ˜Ð°ÑšÐµ Ð½Ð¾Ð²Ñ†Ð°',0),(411345,11427,'vi','KÃª tiá»n máº·t',0),(411346,11427,'af','Kontantgeld Telling',0),(411347,11427,'ro','NumÄƒrul de numerar',0),(411348,11427,'et','Sularaha kokku',0),(411349,11427,'si','Denarni raÄun',0),(411350,11427,'ba','Jumlah uang tunai',0),(411351,11427,'nl','Contant geld tellen',0),(411352,11427,'fi','KÃ¤teistÃ¤ mÃ¤Ã¤rÃ¤',0),(411353,11427,'no','Kontanter teller',0),(411354,11427,'da','Kontant optÃ¦lling',0),(411355,11427,'ko','í˜„ê¸ˆ ê³„ì‚°',0),(411356,11427,'he','×ž×–×•×ž×Ÿ ×”×¨×•×–×Ÿ',0),(411357,11427,'el','ÎšÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ· Ï„Ï‰Î½ Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½',0),(411358,11427,'zh','çŽ°é‡‘ç›˜ç‚¹\r\n',0),(411359,11427,'sv','Cash rÃ¤kna',0),(411360,11427,'it','Conte di contanti',0),(411361,11427,'tl','',0),(411362,11427,'th','à¸•à¸£à¸§à¸ˆà¸™à¸±à¸šà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(411363,11427,'hi','à¤¨à¤•à¤¦ à¤—à¤¿à¤¨à¤¤à¥€',0),(411364,11427,'ms','Kiraan Wang Tunai',0),(411365,11427,'ar','Ø¹Ø¯ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(411366,11427,'fr','Comte de trÃ©sorerie',0),(411367,11427,'jp','ç¾é‡‘ã‚«ã‚¦ãƒ³ãƒˆ',0),(411368,11427,'pt','Contagem de dinheiro',0),(411369,11427,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(411370,11427,'es','Contado de Efectivo',0),(411371,11427,'de','Bargeld-Count',0),(411372,11427,'en','Cash Count',0),(411373,11428,'is','',0),(411374,11428,'dr','/  ÙŠØ§ Ø®Ø¯Ù…Ø§Øª Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ø§ÙŠÙ† Ù…Ù‚Ø¯Ø§Ø± Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø±Ø§ ØªØ§ÙŠÙŠØ¯ Ù…ÙŠ ÙƒÙ†Ø¯ Ùˆ Ø¨Ø§ ØªÙˆØ§ÙÙ‚ Ø¨ÙŠÙ†  Ø¯Ø§Ø±Ù†Ø¯Ù‡ ÙƒØ§Ø±Øª Ùˆ ØµØ§Ø¯Ø± ÙƒÙ†Ù†Ø¯Ù‡ ÙƒØ§Ø±Øª Ø§Ø¬Ø±Ø§ÙŠ  ØªØ¹Ù‡Ø¯Ø§Øª ',0),(411375,11428,'pr','Ø¯Ø§Ø±Ù†Ø¯Ù‡ ÙƒØ§Ø±Øª Ø±Ø³ÙŠØ¯ ÙƒØ§Ù„Ø§Ù‡Ø§ Ùˆ/  ÙŠØ§ Ø®Ø¯Ù…Ø§Øª Ø¯Ø±Ø¨Ø§Ø±Ù‡ Ø§ÙŠÙ† Ù…Ù‚Ø¯Ø§Ø± Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø±Ø§ ØªØ§ÙŠÙŠØ¯ Ù…ÙŠ ÙƒÙ†Ø¯ Ùˆ Ø¨Ø§ ØªÙˆØ§ÙÙ‚ Ø¨ÙŠÙ†  Ø¯Ø§Ø±Ù†Ø¯Ù‡ ÙƒØ§Ø±Øª Ùˆ ØµØ§Ø¯Ø± ÙƒÙ†Ù†Ø¯Ù‡ ÙƒØ§Ø±Øª Ø§Ø¬Ø±Ø§ÙŠ  ØªØ¹Ù‡Ø¯Ø§Øª ',0),(411376,11428,'tr','Cardmember mal ve/veya hizmetler burada gÃ¶sterilen toplam miktarÄ±nda ve alÄ±ndÄ±ÄŸÄ±nÄ± onaylar ve cardmember\'Ä±n sÃ¶zleÅŸmesi ile veren tarafÄ±ndan belirtilen yÃ¼kÃ¼mlÃ¼lÃ¼klerini yerine kabul eder.',0),(411377,11428,'pl','Cardmember potwierdza odbiÃ³r towarÃ³w lub usÅ‚ug w wysokoÅ›ci Å‚Ä…cznie przedstawione w niniejszym dokumencie i zobowiÄ…zuje siÄ™ do wykonywania obowiÄ…zkÃ³w, okreÅ›lonych przez cardmember umowy z emitentem.',0),(411378,11428,'bg','Cardmember Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´Ð°Ð²Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° ÑÑ‚Ð¾ÐºÐ¸ Ð¸Ð»Ð¸ ÑƒÑÐ»ÑƒÐ³Ð¸ Ð² Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð¾Ð±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°, Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½Ð° Ñ‚ÑƒÐº Ð¸ Ð¿Ñ€Ð¸ÐµÐ¼Ð° Ð´Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÑÐ²Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸ÑÑ‚Ð°, Ð¸Ð·Ð»Ð¾Ð¶ÐµÐ½Ð¸ Ð¾Ñ‚ card',0),(411379,11428,'ur','Ú©Ø¢Ø±Ø¯Ù…ÛŒÙ…Ø¨Ø± Ù…ØµÙ†ÙˆØ¹Ø§Øª Ø§ÙˆØ± Ø®Ø¯Ù…Ø§Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ø³Ø§ØªÚ¾ Ø¯Ú©Ú¾Ø§ÛŒØ§ Ú¯ÛŒØ§ Ú©Ù„ Ø¢Ø³Ù…Ø§Ù† Ú©ÛŒ ÙˆØµÙˆÙ„ÛŒ Ú©Ùˆ ØªØ³Ù„ÛŒÙ… Ú©Ø±ØªÛŒ ÛÛ’ Ø§ÙˆØ± Ø¬Ø§Ø±ÛŒ Ú©Ù†Ù†Ø¯Û Ú©Û’ Ø³Ø§ØªÚ¾ Ú©Ø¢Ø±Ø¯Ù…ÛŒÙ…Ø¨Ø± Ú©Û’ Ù…Ø¹Ø§ÛØ¯Û’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø±Ù',0),(411380,11428,'sr','Ð¦Ð°Ñ€Ð´Ð¼ÐµÐ¼Ð±ÐµÑ€ Ð¿Ð¾Ñ‚Ð²Ñ€Ñ’ÑƒÑ˜Ðµ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼ Ñ€Ð¾Ð±Ðµ Ð¸/Ð¸Ð»Ð¸ ÑƒÑÐ»ÑƒÐ³Ð° Ñƒ Ð¸Ð·Ð½Ð¾ÑÑƒ Ð¾Ð´ ÑƒÐºÑƒÐ¿Ð°Ð½ Ð¸Ð·Ð½Ð¾Ñ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½ Ñƒ Ð¾Ð²Ð¾Ð¼ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñƒ Ð¸ ÑÐ»Ð°Ð¶Ðµ ÑÐµ Ð´Ð° Ð¸Ð·Ð²Ñ€ÑˆÐ¸ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ ÑÑƒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸ Ð',0),(411381,11428,'vi','THáº» thÃ nh viÃªn thá»«a nháº­n nháº­n hÃ ng hoÃ¡ vÃ  / hoáº·c dá»‹ch vá»¥ trong sá»‘ tiá»n trong tÃ i liá»‡u nÃ y Ä‘Æ°á»£c hiá»ƒn thá»‹ tá»•ng sá»‘ vÃ  Ä‘á»“ng Ã½ thá»±c hiá»‡n nghÄ©a vá»¥ Ä‘Æ°á»£c quy Ä‘á»‹nh bá»Ÿi thá»a thuáº­n cá»§a Tháº» thÃ nh vi',0),(411382,11428,'af','Cardmember erken ontvangs van goedere of dienste van die totale hierin getoon en onderneem om die verpligtinge soos uiteengesit deur die cardmember se ooreenkoms met die uitreiker verrig.',0),(411383,11428,'ro','Cardmember recunoaÅŸte primirea de bunuri È™i servicii Ã®n totalul indicat Ã®n prezentul document ÅŸi este de acord sÄƒ Ã®ndeplineascÄƒ obligaÅ£iile stabilite cardmember acord cu emitentul.',0),(411384,11428,'et','Kirja kÃ¤tte ja/vÃµi teenuseid summas kokku programmi siin tunnistab ja nÃµustub selle kirja sÃµlmitud mÃ¤Ã¤ratud kohustusi.',0),(411385,11428,'si','Cardmember potrdi prejem blaga in/ali storitev v viÅ¡ini celotne prikazani tukaj in se strinja, da izpolni obveznosti doloÄi na cardmember sporazuma z izdajateljem.',0),(411386,11428,'ba','Manca negara mengakui penerimaan barang atau jasa dalam jumlah total ditunjukkan di sini dan setuju untuk melaksanakan kewajiban yang ditetapkan oleh pemegang perjanjian dengan penerbit.',0),(411387,11428,'nl','Kaarthouder bevestigt de ontvangst van goederen en/of diensten in het bedrag van de totale hierin weergegeven en stemt in met de verplichtingen uiteengezet door de kaarthouder overeenkomst met de emittent.',0),(411388,11428,'fi','Cardmember vastaanottoilmoituksen tavaroiden tai palvelujen mÃ¤Ã¤rÃ¤n yhteensÃ¤ JavaScript tÃ¤ssÃ¤ ja suostuu tÃ¤yttÃ¤mÃ¤Ã¤n asetetut cardmember\'s suostumuksella liikkeeseenlaskijan velvollisuudet.',0),(411389,11428,'no','Cardmember bekrefter mottak av varer og tjenester i totalen vist her og godtar Ã¥ utfÃ¸re forpliktelser fastsatt av den cardmember avtale med utstederen.',0),(411390,11428,'da','Cardmember anerkender modtagelsen af varer og/eller tjenester i den samlede vist heri og indvilliger i at udfÃ¸re forpligtelser frem af den cardmember aftale med udstederen.',0),(411391,11428,'ko','ì¹´ë“œ íšŒì› ìƒí’ˆ ë° ì„œë¹„ìŠ¤ ì—¬ê¸°ì— í‘œì‹œ ëœ ì´ ê¸ˆì•¡ì˜ ì˜ìˆ˜ì¦ì„ ì¸ì • í•˜ ê³  ë°œê¸‰ìžì™€ ë™ì˜ì„œì— ì •í•œ ì˜ë¬´ë¥¼ ìˆ˜í–‰ í•˜ëŠ” ë° ë™ì˜ í•©ë‹ˆë‹¤.',0),(411392,11428,'he','Cardmember ×ž××©×¨ ×§×‘×œ×ª ×¡×—×•×¨×” ×•/××• ×©×™×¨×•×ª×™× ×©×œ ×”×¡×™×›×•× ×”×ž×•×¦×’ ×‘×ž×¡×ž×š ×–×”, ×ž×¡×›×™× ×œ×‘×™×¦×•×¢ ×”×—×•×‘×•×ª ×©× ×§×‘×¢×• ×‘×”×¡×›× ×©×œ cardmember ×¢× ×”×ž× ×¤×™×§.',0),(411393,11428,'el','Cardmember Î±Î½Î±Î³Î½Ï‰ÏÎ¯Î¶ÎµÎ¹ Ï„Î·Î½ Ï€Î±ÏÎ±Î»Î±Î²Î® Ï„Ï‰Î½ Î±Î³Î±Î¸ÏŽÎ½ Î® ÎºÎ±Î¹ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½ Ï„Î¿Ï… Ï€Î¿ÏƒÎ¿Ï Ï„Î¿Ï… ÏƒÏ…Î½ÏŒÎ»Î¿Ï… Ï€Î¿Ï… Ï†Î±Î¯Î½ÎµÏ„Î±Î¹ ÏƒÏ„Î¿ Ï€Î±ÏÏŒÎ½ ÎºÎ±Î¹ ÏƒÏ…Î¼Ï†Ï‰Î½ÎµÎ¯ Î½Î± ÎµÎºÏ„ÎµÎ»Î­ÏƒÎµÎ¹ Ï„Î¹Ï‚ Ï…Ï€Î¿Ï‡ÏÎ',0),(411394,11428,'zh','å¡ä¼šå‘˜ç¡®è®¤åœ¨æ­¤å¤„æ˜¾ç¤ºçš„æ€»é‡‘é¢çš„å•†å“å’Œ/æˆ–æœåŠ¡æ”¶æ®ï¼Œå¹¶åŒæ„è®¾ç«‹çš„ä¼šå‘˜å±¥è¡Œä¸Žå‘è¡Œäººåè®®è§„å®šçš„ä¹‰åŠ¡t.he\r\n',0),(411395,11428,'sv','Kortmedlem bekrÃ¤ftar mottagandet av varor eller tjÃ¤nster av den totala visas hÃ¤ri och samtycker till att utfÃ¶ra skyldigheter anges av den Kortmedlem avtal med emittenten.',0),(411396,11428,'it','Cardmember riconosce il ricevimento della merce e/o servizi per un importo totale indicato nel presente documento e si impegna ad eseguire gli obblighi stabiliti dall\'accordo di cardmember con l\'emittente.',0),(411397,11428,'tl','',0),(411398,11428,'th','à¹à¸–à¸¥à¸‡à¸¢à¸­à¸¡à¸£à¸±à¸šà¹€à¸à¸µà¹ˆà¸¢à¸§à¸à¸±à¸šà¸à¸²à¸£à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸«à¸£à¸·à¸­à¸šà¸£à¸´à¸à¸²à¸£à¸ˆà¸³à¸™à¸§à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸—à¸µà¹ˆà¹à¸ªà¸”à¸‡à¸­à¸¢à¸¹à¹ˆà¸™à¸µà¹‰ à¹à¸¥à¸°à¸•à¸à¸¥à¸‡à¸—à¸µà¹ˆà¸ˆà¸°à¸”à¸³à¹€à¸™à¸´à¸',0),(411399,11428,'hi','Cardmember à¤®à¤¾à¤² à¤”à¤°/à¤¯à¤¾ à¤¸à¥‡à¤µà¤¾à¤“à¤‚ à¤•à¥€ à¤‡à¤¸ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤¾à¤¥ à¤¦à¤¿à¤–à¤¾à¤¯à¤¾ à¤•à¥à¤² à¤°à¤¾à¤¶à¤¿ à¤•à¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿ à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤”à¤° à¤œà¤¾à¤°à¥€à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡',0),(411400,11428,'ms','Ahli Kad mengakui penerimaan barang-barang dan/atau perkhidmatan jumlah jumlah keseluruhan yang ditunjukkan di sini dan bersetuju untuk melaksanakan tanggungjawab yang ditetapkan oleh Perjanjian Pemegang Kad dengan pengeluar.',0),(411401,11428,'ar','Ø­Ø§Ù…Ù„ ØªØ¹ØªØ±Ù Ø¨Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ø¨Ø¶Ø§Ø¦Ø¹ Ùˆ/Ø£Ùˆ Ø§Ù„Ø®Ø¯Ù…Ø§Øª Ù…Ø¨Ù„Øº Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù‡Ùˆ Ù…ÙˆØ¶Ø­ Ù‡Ù†Ø§ØŒ ÙˆÙŠÙˆØ§ÙÙ‚ Ø¹Ù„Ù‰ ØªÙ†ÙÙŠØ° Ø§Ù„Ø§Ù„ØªØ²Ø§Ù…Ø§Øª Ø§Ù„Ù…Ù†ØµÙˆØµ Ø¹Ù„ÙŠÙ‡Ø§ Ø¨Ø­Ø§Ù…Ù„ Ø§Ù„Ø§ØªÙØ§Ù‚ Ù…Ø¹ Ø§Ù„Ù…ØµØ¯Ø±.',0),(411402,11428,'fr','Titulaire accuse rÃ©ception des produits ou des services d\'un montant total indiquÃ© dans les prÃ©sentes et s\'engage Ã  exÃ©cuter les obligations prÃ©vues par l\'accord du titulaire de la carte auprÃ¨s de l\'Ã©metteur.',0),(411403,11428,'jp','ä¼šå“¡å•†å“åˆã¯ã‚µãƒ¼ãƒ“ã‚¹ã“ã“ã«ç¤ºã•ã‚ŒãŸåˆè¨ˆé‡‘é¡ã®é ˜åŽæ›¸ã‚’èªè­˜ã—ã€ä¼šå“¡ã®ç™ºè¡Œè€…ã¨ã®å¥‘ç´„ã«å®šã‚ã‚‹ç¾©å‹™ã‚’å±¥è¡Œã™ã‚‹ã“ã¨ã«åŒæ„ã—ã¾ã™ã€‚',0),(411404,11428,'pt','Cardmember reconhece o recebimento de mercadorias e/ou serviÃ§os no valor de total mostrado aqui e compromete-se a executar as obrigaÃ§Ãµes estabelecidas pelo acordo da titular com o emitente.',0),(411405,11428,'ru','Ð¡Ð¾Ð²ÐµÑ€ÑˆÐ°ÐµÑ‚ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´Ð°ÐµÑ‚ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ðµ Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð² Ð¸Ð»Ð¸ ÑƒÑÐ»ÑƒÐ³ Ð² Ñ€Ð°Ð·Ð¼ÐµÑ€Ðµ Ð¾Ð±Ñ‰ÐµÐ¹ ÑÑƒÐ¼Ð¼Ñ‹, Ð¿Ñ€Ð¸Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ðµ Ð¸ ÑÐ¾Ð³Ð»Ð°ÑˆÐ°ÐµÑ‚ÑÑ Ð´Ð»Ñ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð², ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð',0),(411406,11428,'es','Tarjetahabiente reconoce recepciÃ³n de bienes y/o Servicios en la Cantidad Total Mostrada Aqui y Esta de Acuerdo Ejecutar las Obligaciones Definidas por el Acuerdo del Tarjetahabiente con El Que Emite la Tarjeta',0),(411407,11428,'de','Mitglieder Eingang von waren und/oder Dienstleistungen in HÃ¶he von insgesamt hierin dargestellt erkennt und verpflichtet sich, die Verpflichtungen der Mitglieder im Einvernehmen mit dem Aussteller fÃ¼hren.',0),(411408,11428,'en','Cardmember acknowledges receipt of goods and/or services in the amount of the total shown herein and agrees to perform obligations set forth by the cardmember\'s agreement with the issuer.',0),(411409,11429,'is','',0),(411410,11429,'dr','ØµÙ†Ø¯ÙˆÙ‚Ø¯Ø§Ø±',0),(411411,11429,'pr','ØµÙ†Ø¯ÙˆÙ‚Ø¯Ø§Ø±',0),(411412,11429,'tr','Kasiyer',0),(411413,11429,'pl','Kasjer',0),(411414,11429,'bg','ÐšÐ°ÑÐ¸ÐµÑ€',0),(411415,11429,'ur','Ø±ÙˆÚ©Ú‘ÛŒØ§',0),(411416,11429,'sr','Ð‘Ð»Ð°Ð³Ð°Ñ˜Ð½Ð¸Ðº',0),(411417,11429,'vi','Thá»§ quá»¹',0),(411418,11429,'af','Kassier',0),(411419,11429,'ro','Casier',0),(411420,11429,'et','Kassapidaja',0),(411421,11429,'si','Blagajna',0),(411422,11429,'ba','Kasir',0),(411423,11429,'nl','Kassa',0),(411424,11429,'fi','Kassa',0),(411425,11429,'no','Kasserer',0),(411426,11429,'da','Kassereren',0),(411427,11429,'ko','ìºì‰¬ì–´',0),(411428,11429,'he','×§×•×¤××™',0),(411429,11429,'el','Î¤Î±Î¼ÎµÎ¯Î¿',0),(411430,11429,'zh','å‡ºçº³å‘˜\r\n',0),(411431,11429,'sv','KassÃ¶ren',0),(411432,11429,'it','Cassiere',0),(411433,11429,'tl','',0),(411434,11429,'th','à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(411435,11429,'hi','à¤–à¤œà¤¾à¤‚à¤šà¥€',0),(411436,11429,'ms','Juruwang',0),(411437,11429,'ar','Ø£Ù…ÙŠÙ† Ø§Ù„ØµÙ†Ø¯ÙˆÙ‚',0),(411438,11429,'fr','Caissier',0),(411439,11429,'jp','ãƒ¬ã‚¸ä¿‚',0),(411440,11429,'pt','Caixa',0),(411441,11429,'ru','ÐšÐ°ÑÑÐ¸Ñ€',0),(411442,11429,'es','Cajero',0),(411443,11429,'de','Kasse',0),(411444,11429,'en','Cashier',0),(411445,11430,'is','',0),(411446,11430,'dr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ø§ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª',0),(411447,11430,'pr','Ù‡ÙŠÚ† Ø´Ù†Ø§Ø³Ù‡ Ø§ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†ÙŠØ³Øª',0),(411448,11430,'tr','Kimlik ayarÄ± yok',0),(411449,11430,'pl','Nie zestaw ID',0),(411450,11430,'bg','ÐÑÐ¼Ð° Ð˜Ð” Ð½Ð° Ð½Ð°Ð±Ð¾Ñ€',0),(411451,11430,'ur','Ú©ÙˆØ¦ÛŒ Ø´Ù†Ø§Ø®Øª Ù…Ù‚Ø±Ø±',0),(411452,11430,'sr','ÐÐµÐ¼Ð° Ð˜Ð” Ð¡ÐµÑ‚',0),(411453,11430,'vi','khÃ´ng táº­p há»£p ID',0),(411454,11430,'af','Geen ID stel',0),(411455,11430,'ro','Nici un Set de ID',0),(411456,11430,'et','Nr komplekti',0),(411457,11430,'si','Ni nastavljenega ID',0),(411458,11430,'ba','No ID Set',0),(411459,11430,'nl','Geen ID-Set',0),(411460,11430,'fi','Ei ID asetettu',0),(411461,11430,'no','Ingen ID-sett',0),(411462,11430,'da','Ingen ID sÃ¦t',0),(411463,11430,'ko','ID ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(411464,11430,'he','×œ× ×”×•×’×“×¨×• ×ž×–×”×”',0),(411465,11430,'el','ÎšÎ±Î½Î­Î½Î± ÏƒÏÎ½Î¿Î»Î¿ ID',0),(411466,11430,'zh','æ²¡æœ‰è®¾ç½®äº†çš„èº«ä»½è¯\r\n',0),(411467,11430,'sv','Ingen ID Set',0),(411468,11430,'it','Nessun Set ID',0),(411469,11430,'tl','',0),(411470,11430,'th','à¸Šà¸¸à¸”à¹„à¸¡à¹ˆà¸¡à¸µ ID',0),(411471,11430,'hi','à¤•à¥‹à¤ˆ ID à¤¸à¥‡à¤Ÿ',0),(411472,11430,'ms','Set ID tiada',0),(411473,11430,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ø¹Ø±Ù',0),(411474,11430,'fr','Aucun ensemble d\'ID',0),(411475,11430,'jp','ID ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(411476,11430,'pt','Nenhum conjunto de ID',0),(411477,11430,'ru','ID ÐÐµ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(411478,11430,'es','No se ConfigurÃ³ el ID',0),(411479,11430,'de','Kein ID-Satz',0),(411480,11430,'en','No ID Set',0),(411481,11431,'is','',0),(411482,11431,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(411483,11431,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(411484,11431,'tr','Ã–deme bulunamadÄ±',0),(411485,11431,'pl','PÅ‚atnoÅ›ci nie znaleziono',0),(411486,11431,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(411487,11431,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(411488,11431,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(411489,11431,'vi','thanh toÃ¡n khÃ´ng tÃ¬m tháº¥y',0),(411490,11431,'af','Betaling Nie Gevind',0),(411491,11431,'ro','Plata nu a fost gÄƒsit',0),(411492,11431,'et','Makse ei leitud',0),(411493,11431,'si','PlaÄila ni mogoÄe najti',0),(411494,11431,'ba','Pembayaran tidak ditemukan',0),(411495,11431,'nl','Betaling niet gevonden',0),(411496,11431,'fi','Maksu ei lÃ¶ydy',0),(411497,11431,'no','Betaling ikke funnet',0),(411498,11431,'da','Betaling ikke fundet',0),(411499,11431,'ko','ì§€ë¶ˆì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(411500,11431,'he','×ª×©×œ×•× ×œ× × ×ž×¦×',0),(411501,11431,'el','Î Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(411502,11431,'zh','ä»˜æ¬¾æœªæ‰¾åˆ°\r\n',0),(411503,11431,'sv','Betalning hittades inte',0),(411504,11431,'it','Pagamento non trovato',0),(411505,11431,'tl','',0),(411506,11431,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(411507,11431,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(411508,11431,'ms','Bayaran yang tidak dijumpai',0),(411509,11431,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø¯ÙØ¹',0),(411510,11431,'fr','Paiement non trouvÃ©',0),(411511,11431,'jp','æ”¯æ‰•ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(411512,11431,'pt','Pagamento nÃ£o encontrado',0),(411513,11431,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(411514,11431,'es','No se EncontrÃ³ el Pago',0),(411515,11431,'de','Zahlung nicht gefunden',0),(411516,11431,'en','Payment Not Found',0),(411517,11432,'is','',0),(411518,11432,'dr','Ø±Ø³ÙŠØ¯ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(411519,11432,'pr','Ø±Ø³ÙŠØ¯ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(411520,11432,'tr','Ã–deme makbuzu',0),(411521,11432,'pl','DowÃ³d wpÅ‚aty',0),(411522,11432,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(411523,11432,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ø³ÛŒØ¯',0),(411524,11432,'sr','ÐŸÑ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ñ†Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(411525,11432,'vi','Phiáº¿u thu thanh toÃ¡n',0),(411526,11432,'af','Betaling Kwitansie',0),(411527,11432,'ro','ChitanÅ£Äƒ platÄƒ',0),(411528,11432,'et','Maksekviitung',0),(411529,11432,'si','Potrdilo o plaÄilih',0),(411530,11432,'ba','Bukti pembayaran',0),(411531,11432,'nl','Betalingsontvangst',0),(411532,11432,'fi','Maksukuitti',0),(411533,11432,'no','Kvittering',0),(411534,11432,'da','Kvittering for betaling',0),(411535,11432,'ko','ì§€ë¶ˆ ì˜ìˆ˜ì¦',0),(411536,11432,'he','×—×©×‘×•× ×™×ª ×ª×©×œ×•×',0),(411537,11432,'el','Î‘Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(411538,11432,'zh','ä»˜æ¬¾æ”¶æ®\r\n',0),(411539,11432,'sv','Kvitto pÃ¥ betalning',0),(411540,11432,'it','Ricevuta di pagamento',0),(411541,11432,'tl','',0),(411542,11432,'th','à¸£à¸±à¸šà¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(411543,11432,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤°à¤¸à¥€à¤¦',0),(411544,11432,'ms','Resit pembayaran',0),(411545,11432,'ar','Ø¥ÙŠØµØ§Ù„ Ø§Ù„Ø¯ÙØ¹',0),(411546,11432,'fr','ReÃ§u de paiement',0),(411547,11432,'jp','æ”¯æ‰•ã„ã®é ˜åŽæ›¸',0),(411548,11432,'pt','Recibo de pagamento',0),(411549,11432,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(411550,11432,'es','Recibo de Pago',0),(411551,11432,'de','Zahlungseingang',0),(411552,11432,'en','Payment Receipt',0),(411553,11433,'is','',0),(411554,11433,'dr','(Ø¯Ø±ÙŠØ§ÙØªÙ‰',0),(411555,11433,'pr','Ø±Ø³ÙŠØ¯(Ø¯Ø±ÙŠØ§ÙØªÙ‰',0),(411556,11433,'tr','AlÄ±ÅŸ irsaliyesi',0),(411557,11433,'pl','Otrzymania',0),(411558,11433,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ°',0),(411559,11433,'ur','Ø±Ø³ÛŒØ¯',0),(411560,11433,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð°',0),(411561,11433,'vi','thu',0),(411562,11433,'af','Kwitansie',0),(411563,11433,'ro','Primirea',0),(411564,11433,'et','Sissetuleku',0),(411565,11433,'si','Prejemu',0),(411566,11433,'ba','Penerimaan',0),(411567,11433,'nl','Ontvangst',0),(411568,11433,'fi','Kuitti',0),(411569,11433,'no','Mottak',0),(411570,11433,'da','Modtagelsen',0),(411571,11433,'ko','ì˜ìˆ˜ì¦',0),(411572,11433,'he','×§×‘×œ×”',0),(411573,11433,'el','Î Î±ÏÎ±Î»Î±Î²Î®',0),(411574,11433,'zh','æ”¶æ®\r\n',0),(411575,11433,'sv','Kvitto',0),(411576,11433,'it','Ricevimento',0),(411577,11433,'tl','',0),(411578,11433,'th','à¸£à¸±à¸š',0),(411579,11433,'hi','à¤°à¤¸à¥€à¤¦',0),(411580,11433,'ms','Resit',0),(411581,11433,'ar','Ø§Ø³ØªÙ„Ø§Ù…',0),(411582,11433,'fr','RÃ©ception',0),(411583,11433,'jp','é ˜åŽæ›¸',0),(411584,11433,'pt','Recibo',0),(411585,11433,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ðµ',0),(411586,11433,'es','Recibo',0),(411587,11433,'de','Eingang',0),(411588,11433,'en','Receipt',0),(411589,11434,'is','',0),(411590,11434,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ù†ÙŠØ³Øª',0),(411591,11434,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ù†ÙŠØ³Øª',0),(411592,11434,'tr','Girilen miktar Ã¶deme tutarÄ± eÅŸleÅŸmiyor',0),(411593,11434,'pl','Wprowadzona kwota odpowiada kwota pÅ‚atnoÅ›ci',0),(411594,11434,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð½Ðµ ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð° Ð½Ð° ÑÑƒÐ¼Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(411595,11434,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±Ø¯Û Ø±Ù‚Ù… Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù‚Ù… Ú©Û’ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº',0),(411596,11434,'sr','Ð˜Ð·Ð½Ð¾Ñ ÐºÐ¾Ñ˜Ð¸ ÑÑ‚Ðµ ÑƒÐ½ÐµÐ»Ð¸ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐµ Ð¸Ð·Ð½Ð¾Ñ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(411597,11434,'vi','Sá»‘ tiá»n nháº­p vÃ o khÃ´ng há»›p vá»›i sá»‘ tiá»n thanh toÃ¡n',0),(411598,11434,'af','Bedrag ingetik het stem nie ooreen met betaling bedrag',0),(411599,11434,'ro','Valoarea introdusÄƒ nu corespunde plata sumei',0),(411600,11434,'et','Kirjendatud summa ei sobi makse summa',0),(411601,11434,'si','Znesek vnesli ne ujema znesek plaÄila',0),(411602,11434,'ba','Jumlah yang dimasukkan tidak sesuai jumlah pembayaran',0),(411603,11434,'nl','Bedrag ingevoerd komt niet overeen met het betalingsbedrag',0),(411604,11434,'fi','Summa ei vastaa maksusumma',0),(411605,11434,'no','BelÃ¸pet angitt ikke samsvarer med betalingsbelÃ¸pet',0),(411606,11434,'da','OpfÃ¸rte belÃ¸b stemmer ikke overens med betalingsbelÃ¸bet',0),(411607,11434,'ko','ìž…ë ¥ ê¸ˆì•¡ ê²°ì œ ê¸ˆì•¡ì„ ì¼ì¹˜ í•˜ì§€ ì•ŠëŠ”',0),(411608,11434,'he','×”×¡×›×•× ×©×”×•×–×Ÿ ××™× ×• ×ª×•×× ×¡×›×•× ×”×ª×©×œ×•×',0),(411609,11434,'el','Î Î¿ÏƒÏŒ ÎµÎ¹ÏƒÎ±Î³Î¬Î³Î±Ï„Îµ Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Î¼Îµ Ï€Î¿ÏƒÏŒ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(411610,11434,'zh','è¾“å…¥é‡‘é¢ä¸Žä»˜æ¬¾é‡‘é¢ä¸åŒ¹é…\r\n',0),(411611,11434,'sv','Belopp som angetts stÃ¤mmer inte Ã¶verens med betalningsbeloppet',0),(411612,11434,'it','Importo inserito non corrisponde l\'importo del pagamento',0),(411613,11434,'tl','',0),(411614,11434,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸›à¹‰à¸­à¸™à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸šà¹€à¸‡à¸´à¸™',0),(411615,11434,'hi','à¤°à¤¾à¤¶à¤¿ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(411616,11434,'ms','Amaun yang dimasukkan tidak padan dengan amaun bayaran',0),(411617,11434,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ Ù„Ø§ ØªØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(411618,11434,'fr','Montant entrÃ© ne correspond pas le montant du paiement',0),(411619,11434,'jp','å…¥åŠ›ã—ãŸé‡‘é¡ãŒãŠæ”¯æ‰•ã„é‡‘é¡ã¨ä¸€è‡´ã—ã¾ã›ã‚“',0),(411620,11434,'pt','Valor introduzido nÃ£o corresponde a quantidade de pagamento',0),(411621,11434,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð» Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÑÑƒÐ¼Ð¼Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(411622,11434,'es','Cantidad Entrada no se Conforme Con el Monto del Pago',0),(411623,11434,'de','Betrag stimmt nicht mit dem Zahlungsbetrag Ã¼berein.',0),(411624,11434,'en','Amount Entered Does Not Match Payment Amount',0),(411625,11435,'is','',0),(411626,11435,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ù†ÙŠØ³Øª',0),(411627,11435,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ù†ÙŠØ³Øª',0),(411628,11435,'tr','Ã–deme bulunamadÄ±',0),(411629,11435,'pl','Nie moÅ¼na odnaleÅºÄ‡ pÅ‚atnoÅ›ci',0),(411630,11435,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(411631,11435,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§',0),(411632,11435,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(411633,11435,'vi','khÃ´ng thá»ƒ tÃ¬m khoáº£n thanh toÃ¡n',0),(411634,11435,'af','Kon betaling vind nie',0),(411635,11435,'ro','Nu am putut gÄƒsi plata',0),(411636,11435,'et','Ei leia makse',0),(411637,11435,'si','PlaÄilo ni bilo mogoÄe najti.',0),(411638,11435,'ba','Tidak dapat menemukan pembayaran',0),(411639,11435,'nl','Konden niet vondst betaling',0),(411640,11435,'fi','Ei lÃ¶ytÃ¤nyt maksu',0),(411641,11435,'no','Finner ikke betaling',0),(411642,11435,'da','Kunne ikke finde betaling',0),(411643,11435,'ko','ì§€ë¶ˆì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(411644,11435,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×”×ª×©×œ×•×',0),(411645,11435,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(411646,11435,'zh','æ‰¾ä¸åˆ°ä»˜æ¬¾\r\n',0),(411647,11435,'sv','Kunde inte hitta betalning',0),(411648,11435,'it','Non poteva trovare il pagamento',0),(411649,11435,'tl','',0),(411650,11435,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(411651,11435,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤² à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(411652,11435,'ms','Tidak dapat mencari pembayaran',0),(411653,11435,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø¯ÙØ¹',0),(411654,11435,'fr','N\'a pas trouvÃ© de paiement',0),(411655,11435,'jp','æ”¯æ‰•ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(411656,11435,'pt','NÃ£o foi possÃ­vel encontrar o pagamento',0),(411657,11435,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ ÐÐ°Ð¹Ñ‚Ð¸ ÐŸÐ»Ð°Ñ‚ÐµÐ¶',0),(411658,11435,'es','No Se PodÃ­a Encontrar el Pago',0),(411659,11435,'de','Zahlung konnte nicht gefunden werden.',0),(411660,11435,'en','Could Not Find Payment',0),(411661,11436,'is','',0),(411662,11436,'dr','ÙƒÙ„ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(411663,11436,'pr','ÙƒÙ„ Ø¯Ø±ÙŠØ§ÙØª Ø´Ø¯Ù‡',0),(411664,11436,'tr','AlÄ±nan toplam',0),(411665,11436,'pl','ÅÄ…cznie otrzymaÅ‚a',0),(411666,11436,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸',0),(411667,11436,'ur','Ú©Ù„ Ù…Ù„Ø§',0),(411668,11436,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾',0),(411669,11436,'vi','Tá»•ng sá»‘ Ä‘Ã£ nháº­n',0),(411670,11436,'af','Totaal ontvang',0),(411671,11436,'ro','Total primite',0),(411672,11436,'et','Kokku vastu vÃµetud',0),(411673,11436,'si','Skupaj prejetih',0),(411674,11436,'ba','Total yang diterima',0),(411675,11436,'nl','Totaal ontvangen',0),(411676,11436,'fi','Vastaanotetun',0),(411677,11436,'no','Totalt mottatt',0),(411678,11436,'da','Modtaget i alt',0),(411679,11436,'ko','ë°›ì€ ì´',0),(411680,11436,'he','×¡×š ×”×›×œ ×”×ª×§×‘×œ',0),(411681,11436,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Ï€Î¿ÏƒÏŒ',0),(411682,11436,'zh','æ€»æŽ¥æ”¶\r\n',0),(411683,11436,'sv','Totalt fick',0),(411684,11436,'it','Totale ricevuto',0),(411685,11436,'tl','',0),(411686,11436,'th','à¸œà¸¥à¸£à¸§à¸¡à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸š',0),(411687,11436,'hi','à¤•à¥à¤² à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(411688,11436,'ms','Jumlah yang diterima',0),(411689,11436,'ar','ØªÙ„Ù‚ÙŠ Ù…Ø§ Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(411690,11436,'fr','Total reÃ§u',0),(411691,11436,'jp','å—ä¿¡æ•°ã®åˆè¨ˆ',0),(411692,11436,'pt','Total recebido',0),(411693,11436,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¾',0),(411694,11436,'es','Total Recibido',0),(411695,11436,'de','Insgesamt empfangen',0),(411696,11436,'en','Total Received',0),(411697,11437,'is','',0),(411698,11437,'dr','(\'Ú¯Ø±Ø¯Ø¢ÙˆØ±ÙŠ)',0),(411699,11437,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙˆØµÙˆÙ„(\'Ú¯Ø±Ø¯Ø¢ÙˆØ±ÙŠ)',0),(411700,11437,'tr','Koleksiyon raporu',0),(411701,11437,'pl','Kolekcja raportu',0),(411702,11437,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð·Ð° ÑÑŠÐ±Ð¸Ñ€Ð°Ð½Ðµ',0),(411703,11437,'ur','Ù…Ø¬Ù…ÙˆØ¹Û Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(411704,11437,'sr','ÐšÐ¾Ð»ÐµÐºÑ†Ð¸Ñ˜Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(411705,11437,'vi','BÃ¡o cÃ¡o thu tiá»n',0),(411706,11437,'af','Versameling verslag',0),(411707,11437,'ro','Raport de colectare',0),(411708,11437,'et','Saidikogumi aruanne',0),(411709,11437,'si','Zbirka poroÄilo',0),(411710,11437,'ba','Koleksi laporan',0),(411711,11437,'nl','Collectie rapport',0),(411712,11437,'fi','Kokoelma raportin',0),(411713,11437,'no','Samling rapport',0),(411714,11437,'da','Samling betÃ¦nkningen',0),(411715,11437,'ko','ì»¬ë ‰ì…˜ ë³´ê³ ì„œ',0),(411716,11437,'he','××•×¡×£ ×—',0),(411717,11437,'el','ÎˆÎºÎ¸ÎµÏƒÎ· ÏƒÏ…Î»Î»Î¿Î³Î®Ï‚',0),(411718,11437,'zh','æ”¶æ¬¾æŠ¥å‘Š\r\n',0),(411719,11437,'sv','Samling rapport',0),(411720,11437,'it','Raccolta Report',0),(411721,11437,'tl','',0),(411722,11437,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(411723,11437,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(411724,11437,'ms','Koleksi Laporan',0),(411725,11437,'ar','ØªÙ‚Ø±ÙŠØ± Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(411726,11437,'fr','Rapport de la collection',0),(411727,11437,'jp','ã‚³ãƒ¬ã‚¯ã‚·ãƒ§ãƒ³ã®ãƒ¬ãƒãƒ¼ãƒˆ',0),(411728,11437,'pt','RelatÃ³rio de coleta',0),(411729,11437,'ru','ÐšÐ¾Ð»Ð»ÐµÐºÑ†Ð¸Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¾Ð²',0),(411730,11437,'es','Informe de ColecciÃ³n',0),(411731,11437,'de','Sammlung Bericht',0),(411732,11437,'en','Collection Report',0),(411733,11438,'is','',0),(411734,11438,'dr','Ø±Ø³ÙŠØ¯ Ø±Ø³Ù…Ù‰ Ø§Ø²',0),(411735,11438,'pr','Ø±Ø³ÙŠØ¯ Ø±Ø³Ù…Ù‰ Ø§Ø²',0),(411736,11438,'tr','Resmi giriÅŸ',0),(411737,11438,'pl','Oficjalne potwierdzenie od',0),(411738,11438,'bg','ÐžÑ„Ð¸Ñ†Ð¸Ð°Ð»Ð½Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð° Ð¾Ñ‚',0),(411739,11438,'ur','Ø³Û’ Ø¨Ø§Ø¶Ø§Ø¨Ø·Û Ø±Ø³ÛŒØ¯',0),(411740,11438,'sr','Ð—Ð²Ð°Ð½Ð¸Ñ‡Ð½Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° Ð¸Ð·',0),(411741,11438,'vi','Thu chÃ­nh thá»©c tá»«',0),(411742,11438,'af','Amptelike ontvangs van',0),(411743,11438,'ro','Primirea oficial de',0),(411744,11438,'et','Ametlik vastuvÃµtmine:',0),(411745,11438,'si','Uradnega prejema iz',0),(411746,11438,'ba','Kwitansi resmi dari',0),(411747,11438,'nl','OfficiÃ«le ontvangst van',0),(411748,11438,'fi','Virallisen kuitin',0),(411749,11438,'no','Offisielle kvittering fra',0),(411750,11438,'da','Officiel modtagelse fra',0),(411751,11438,'ko','ê³µì‹ ì˜ìˆ˜ì¦',0),(411752,11438,'he','××™×©×•×¨ ×¨×©×ž×™ ×©×œ',0),(411753,11438,'el','Î•Ï€Î¯ÏƒÎ·Î¼Î· Ï€Î±ÏÎ±Î»Î±Î²Î® Î±Ï€ÏŒ',0),(411754,11438,'zh','æ­£å¼æ”¶æ®æ¥è‡ª\r\n',0),(411755,11438,'sv','Officiell kvitto frÃ¥n',0),(411756,11438,'it','Ricevimento ufficiale da',0),(411757,11438,'tl','',0),(411758,11438,'th','à¸£à¸±à¸šà¸­à¸¢à¹ˆà¸²à¸‡à¹€à¸›à¹‡à¸™à¸—à¸²à¸‡à¸à¸²à¸£à¸ˆà¸²à¸',0),(411759,11438,'hi','à¤¸à¤°à¤•à¤¾à¤°à¥€ à¤°à¤¸à¥€à¤¦ à¤¸à¥‡',0),(411760,11438,'ms','Resit rasmi dari',0),(411761,11438,'ar','Ø¥ÙŠØµØ§Ù„ Ø±Ø³Ù…ÙŠ Ù…Ù†',0),(411762,11438,'fr','ReÃ§u officiel de',0),(411763,11438,'jp','å…¬å¼ã®é ˜åŽæ›¸',0),(411764,11438,'pt','Recibo oficial do',0),(411765,11438,'ru','ÐžÑ„Ð¸Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð°Ñ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ñ Ð¾Ñ‚',0),(411766,11438,'es','Recibo Oficial De',0),(411767,11438,'de','Offizielle Quittung vom',0),(411768,11438,'en','Official Receipt From',0),(411769,11439,'is','',0),(411770,11439,'dr','Ø±Ø³ÙŠØ¯ Ø±Ø³Ù…Ù‰ Ø¨Ù‡',0),(411771,11439,'pr','Ø±Ø³ÙŠØ¯ Ø±Ø³Ù…Ù‰ Ø¨Ù‡',0),(411772,11439,'tr','Resmi giriÅŸ',0),(411773,11439,'pl','UrzÄ™dowego potwierdzenia',0),(411774,11439,'bg','ÐžÑ„Ð¸Ñ†Ð¸Ð°Ð»ÐµÐ½ Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ°, Ð·Ð° Ð´Ð°',0),(411775,11439,'ur','Ø³Ø±Ú©Ø§Ø±ÛŒ Ø±Ø³ÛŒØ¯ Ú©Ø±Ù†Ø§',0),(411776,11439,'sr','Ð—Ð²Ð°Ð½Ð¸Ñ‡Ð½Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° Ð´Ð°',0),(411777,11439,'vi','Thu chÃ­nh thá»©c Ä‘áº¿n',0),(411778,11439,'af','Amptelike kwitansie te',0),(411779,11439,'ro','Primirea oficial a',0),(411780,11439,'et','Ametliku kÃ¤ttesaamisteatise kÃµige',0),(411781,11439,'si','Uradnem prejemu za',0),(411782,11439,'ba','Kwitansi resmi untuk',0),(411783,11439,'nl','OfficiÃ«le ontvangst te',0),(411784,11439,'fi','Virallinen kuitti',0),(411785,11439,'no','Offisielle kvittering til',0),(411786,11439,'da','Officiel modtagelse til',0),(411787,11439,'ko','ê³µì‹ ì˜ìˆ˜ì¦ì„',0),(411788,11439,'he','×§×‘×œ×” ×¨×©×ž×™×ª',0),(411789,11439,'el','Î•Ï€Î¯ÏƒÎ·Î¼Î· Ï€Î±ÏÎ±Î»Î±Î²Î®, Î½Î±',0),(411790,11439,'zh','æ­£å¼æ”¶æ®æŽ¥æ”¶äºº\r\n',0),(411791,11439,'sv','Officiell kvitto till',0),(411792,11439,'it','Ricevimento ufficiale a',0),(411793,11439,'tl','',0),(411794,11439,'th','à¸£à¸±à¸šà¸­à¸¢à¹ˆà¸²à¸‡à¹€à¸›à¹‡à¸™à¸—à¸²à¸‡à¸à¸²à¸£',0),(411795,11439,'hi','à¤¸à¤°à¤•à¤¾à¤°à¥€ à¤°à¤¸à¥€à¤¦ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(411796,11439,'ms','Resit rasmi kepada',0),(411797,11439,'ar','Ø¥ÙŠØµØ§Ù„ Ø±Ø³Ù…ÙŠ Ø¥Ù„Ù‰',0),(411798,11439,'fr','ReÃ§u officiel pour',0),(411799,11439,'jp','å…¬å¼ã®é ˜åŽæ›¸',0),(411800,11439,'pt','Recibo oficial para',0),(411801,11439,'ru','ÐžÑ„Ð¸Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð°Ñ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ñ Ð´Ð»Ñ',0),(411802,11439,'es','Recibo Oficial A',0),(411803,11439,'de','Offizielle EmpfangsbestÃ¤tigung an',0),(411804,11439,'en','Official Receipt To',0),(411805,11440,'is','',0),(411806,11440,'dr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ ',0),(411807,11440,'pr','Ú†Ø§Ù¾ Ú¯Ø²Ø§Ø±Ø´ ',0),(411808,11440,'tr','Raporu yazdÄ±rma',0),(411809,11440,'pl','Drukuj raport',0),(411810,11440,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(411811,11440,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(411812,11440,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(411813,11440,'vi','in bÃ¡o cÃ¡o',0),(411814,11440,'af','Verslag Uitdruk',0),(411815,11440,'ro','Imprimare raport',0),(411816,11440,'et','Prindi aruanne',0),(411817,11440,'si','Natisni poroÄilo',0),(411818,11440,'ba','Mencetak laporan',0),(411819,11440,'nl','Rapport afdrukken',0),(411820,11440,'fi','Raportin tulostaminen',0),(411821,11440,'no','Skrive ut rapporten',0),(411822,11440,'da','Udskriv rapport',0),(411823,11440,'ko','ë³´ê³ ì„œ ì¸ì‡„',0),(411824,11440,'he','×”×“×¤×¡ ×“×•×—',0),(411825,11440,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(411826,11440,'zh','æ‰“å°æŠ¥å‘Š\r\n',0),(411827,11440,'sv','Skriva ut rapport',0),(411828,11440,'it','Stampare Report',0),(411829,11440,'tl','',0),(411830,11440,'th','à¸žà¸´à¸¡à¸žà¹Œà¸£à¸²à¸¢à¸‡à¸²à¸™',0),(411831,11440,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(411832,11440,'ms','Mencetak Laporan',0),(411833,11440,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(411834,11440,'fr','Imprimer le rapport',0),(411835,11440,'jp','ãƒ¬ãƒãƒ¼ãƒˆã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(411836,11440,'pt','Imprimir relatÃ³rio',0),(411837,11440,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ ÐžÑ‚Ñ‡ÐµÑ‚',0),(411838,11440,'es','Imprime Informe',0),(411839,11440,'de','Bericht drucken',0),(411840,11440,'en','Print Report',0),(411841,11441,'is','',0),(411842,11441,'dr','ØªØ§Ø±ÙŠØ® Ú¯Ø²Ø§Ø±Ø´ ',0),(411843,11441,'pr','ØªØ§Ø±ÙŠØ® Ú¯Ø²Ø§Ø±Ø´ ',0),(411844,11441,'tr','Rapor tarihi',0),(411845,11441,'pl','Data raportu',0),(411846,11441,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(411847,11441,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(411848,11441,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð°',0),(411849,11441,'vi','ngÃ y bÃ¡o cÃ¡o',0),(411850,11441,'af','Verslag Datum',0),(411851,11441,'ro','Data raportului',0),(411852,11441,'et','Aruande kuupÃ¤ev',0),(411853,11441,'si','Datum poroÄila',0),(411854,11441,'ba','Tanggal laporan',0),(411855,11441,'nl','Verslag datum',0),(411856,11441,'fi','Raportin pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(411857,11441,'no','Rapportdatoen',0),(411858,11441,'da','Rapportdatoen',0),(411859,11441,'ko','ë³´ê³ ì„œ ë‚ ì§œ',0),(411860,11441,'he','×ª××¨×™×š ×”×’×™×•×¡',0),(411861,11441,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­ÎºÎ¸ÎµÏƒÎ·',0),(411862,11441,'zh','æŠ¥å‘Šæ—¥æœŸ\r\n',0),(411863,11441,'sv','Rapportdatum',0),(411864,11441,'it','Relazione data',0),(411865,11441,'tl','',0),(411866,11441,'th','à¸§à¸±à¸™à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(411867,11441,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(411868,11441,'ms','Tarikh laporan',0),(411869,11441,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(411870,11441,'fr','Date du rapport',0),(411871,11441,'jp','ãƒ¬ãƒãƒ¼ãƒˆã®æ—¥ä»˜',0),(411872,11441,'pt','Data do relatÃ³rio',0),(411873,11441,'ru','Ð”Ð°Ñ‚Ð° ÐžÑ‚Ñ‡ÐµÑ‚Ð°',0),(411874,11441,'es','Fecha de Informe',0),(411875,11441,'de','Berichtsdatum',0),(411876,11441,'en','Report Date',0),(411877,11442,'is','',0),(411878,11442,'dr','Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(411879,11442,'pr','Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ùˆ Ø®Ø±ÙˆØ¬',0),(411880,11442,'tr','TimeClock',0),(411881,11442,'pl','TimeClock',0),(411882,11442,'bg','TimeClock',0),(411883,11442,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú©',0),(411884,11442,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº',0),(411885,11442,'vi','khÃ³a thá»i gian',0),(411886,11442,'af','Timeclock',0),(411887,11442,'ro','Ceas',0),(411888,11442,'et','TimeClock',0),(411889,11442,'si','TimeClock',0),(411890,11442,'ba','Timeclock',0),(411891,11442,'nl','Klok',0),(411892,11442,'fi','Timeclock',0),(411893,11442,'no','TimeClock',0),(411894,11442,'da','Timeclock',0),(411895,11442,'ko','Timeclock',0),(411896,11442,'he','Timeclock',0),(411897,11442,'el','Timeclock',0),(411898,11442,'zh','æ—¶é’Ÿ\r\n',0),(411899,11442,'sv','Timeclock',0),(411900,11442,'it','Timeclock',0),(411901,11442,'tl','',0),(411902,11442,'th','Timeclock',0),(411903,11442,'hi','Timeclock',0),(411904,11442,'ms','Timeclock',0),(411905,11442,'ar','ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(411906,11442,'fr','Timeclock',0),(411907,11442,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯',0),(411908,11442,'pt','Timeclock',0),(411909,11442,'ru','Ð§Ð°ÑÑ‹',0),(411910,11442,'es','Reloj Checador',0),(411911,11442,'de','Timeclock',0),(411912,11442,'en','Timeclock',0),(411913,11443,'is','',0),(411914,11443,'dr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(411915,11443,'pr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… ',0),(411916,11443,'tr','SipariÅŸ beklemede',0),(411917,11443,'pl','ZamÃ³wienia na luku',0),(411918,11443,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(411919,11443,'ur','ØªØ±ØªÛŒØ¨ ÛÙˆÙ„Úˆ Ù¾Ø± Ø±Ú©Ú¾ Ø±ÛØ§ ÛÛ’ Û”',0),(411920,11443,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(411921,11443,'vi','Ä‘ang táº¡m ngÆ°ng Ä‘Æ¡n hÃ ng',0),(411922,11443,'af','Plasing van die bestelling op hou',0),(411923,11443,'ro','Plasarea comenzi pe \"hold\"',0),(411924,11443,'et','Tellimuse ootel',0),(411925,11443,'si','Dajanje vrstni red na Äakanju',0),(411926,11443,'ba','Menempatkan pesanan ditahan',0),(411927,11443,'nl','Bestelling in de wachtstand',0),(411928,11443,'fi','Tilauksen pitoon',0),(411929,11443,'no','Bestiller pÃ¥ vent',0),(411930,11443,'da','Placere ordre pÃ¥ Hold',0),(411931,11443,'ko','ë³´ë¥˜ ì£¼ë¬¸',0),(411932,11443,'he','×”×¦×‘×ª ×”×¡×“×¨ ×‘×”×ž×ª× ×”',0),(411933,11443,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÎµ Î±Î½Î±Î¼Î¿Î½Î®',0),(411934,11443,'zh','å®‰æŽ’è®¢å•ç­‰å€™\r\n',0),(411935,11443,'sv','BestÃ¤llningen pÃ¥ is',0),(411936,11443,'it','Mettendo ordine in attesa',0),(411937,11443,'tl','',0),(411938,11443,'th','à¸§à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸„à¸‡à¸„à¹‰à¸²à¸‡',0),(411939,11443,'hi','à¤¹à¥‹à¤²à¥à¤¡ à¤ªà¤° à¤°à¤–à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(411940,11443,'ms','Meletakkan perintah penahanan',0),(411941,11443,'ar','ÙˆØ¶Ø¹ Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(411942,11443,'fr','Passer commande en attente',0),(411943,11443,'jp','ä¿ç•™æ³¨æ–‡',0),(411944,11443,'pt','Colocando ordem na espera',0),(411945,11443,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð—Ð°ÐºÐ°Ð·Ð° Ð’ ÐžÐ¶Ð¸Ð´Ð°Ð½Ð¸Ðµ',0),(411946,11443,'es','Poniendo el Orden en Espera',0),(411947,11443,'de','Bestellung auf Eis',0),(411948,11443,'en','Placing Order On Hold',0),(411949,11444,'is','',0),(411950,11444,'dr','(ØªØ¹Ø¯ÙŠÙ„',0),(411951,11444,'pr','Ø§ØµÙ„Ø§Ø­ (ØªØ¹Ø¯ÙŠÙ„',0),(411952,11444,'tr','Ayarlama',0),(411953,11444,'pl','DostosowaÄ‡',0),(411954,11444,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹Ñ‚Ðµ',0),(411955,11444,'ur','Ù…Ø·Ø§Ø¨Ù‚ Ú©Ø±ÛŒÚº',0),(411956,11444,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ð¸Ñ‚Ð¸',0),(411957,11444,'vi','sá»­a Ä‘á»•i',0),(411958,11444,'af','Regstel',0),(411959,11444,'ro','AjustaÅ£i',0),(411960,11444,'et','Reguleerimine',0),(411961,11444,'si','Prilagodite',0),(411962,11444,'ba','Menyesuaikan',0),(411963,11444,'nl','Aanpassen',0),(411964,11444,'fi','SÃ¤Ã¤dÃ¤',0),(411965,11444,'no','Justere',0),(411966,11444,'da','Justere',0),(411967,11444,'ko','ì¡°ì •',0),(411968,11444,'he','×”×ª××',0),(411969,11444,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®',0),(411970,11444,'zh','è°ƒæ•´\r\n',0),(411971,11444,'sv','Justera',0),(411972,11444,'it','Regolare',0),(411973,11444,'tl','',0),(411974,11444,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(411975,11444,'hi','à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(411976,11444,'ms','Laras',0),(411977,11444,'ar','Ø¶Ø¨Ø·',0),(411978,11444,'fr','Ajuster',0),(411979,11444,'jp','èª¿æ•´',0),(411980,11444,'pt','Ajustar',0),(411981,11444,'ru','ÐžÑ‚Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€ÑƒÐ¹Ñ‚Ðµ',0),(411982,11444,'es','Ajustar',0),(411983,11444,'de','Anpassen',0),(411984,11444,'en','Adjust',0),(411985,11445,'is','',0),(411986,11445,'dr','(ÙˆÙŠÚ˜Ù‡',0),(411987,11445,'pr','ÙÙ‚Ø· Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø«Ø§Ø¨Øª(ÙˆÙŠÚ˜Ù‡',0),(411988,11445,'tr','YalnÄ±zca belirli PO',0),(411989,11445,'pl','Tylko konkretne PO',0),(411990,11445,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ñ„Ð¸Ñ‡Ð½Ð¸ PO ÑÐ°Ð¼Ð¾',0),(411991,11445,'ur','ØµØ±Ù Ù…Ø®ØµÙˆØµ Ù¾Ùˆ',0),(411992,11445,'sr','Ð¡Ð°Ð¼Ð¾ Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ðµ ÐŸÐž',0),(411993,11445,'vi','Chá»‰ cÃ³ Ä‘Æ¡n Ä‘áº·t hÃ ng Ä‘áº·c biá»‡t',0),(411994,11445,'af','Slegs spesifieke PO',0),(411995,11445,'ro','PO specifice numai',0),(411996,11445,'et','Ainult konkreetse PO',0),(411997,11445,'si','Posebno PO le',0),(411998,11445,'ba','PO tertentu hanya',0),(411999,11445,'nl','Specifieke PO alleen',0),(412000,11445,'fi','ErityisiÃ¤ PO',0),(412001,11445,'no','Bestemt PO bare',0),(412002,11445,'da','Specifikke PO kun',0),(412003,11445,'ko','íŠ¹ì • í¬ë§Œ',0),(412004,11445,'he','×¤×• ×¡×¤×¦×™×¤×™×™× ×‘×œ×‘×“',0),(412005,11445,'el','Î£Ï…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½ÎµÏ‚ PO Î¼ÏŒÎ½Î¿',0),(412006,11445,'zh','åªæœ‰ç‰¹å®šçš„è®¢å•\r\n',0),(412007,11445,'sv','Specifika PO endast',0),(412008,11445,'it','PO specifica solo',0),(412009,11445,'tl','',0),(412010,11445,'th','PO à¸—à¸µà¹ˆà¹€à¸‰à¸žà¸²à¸°à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(412011,11445,'hi','à¤•à¥‡à¤µà¤² à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤ªà¥‹',0),(412012,11445,'ms','PO tertentu sahaja',0),(412013,11445,'ar','Øµ. Ø¨ Ù…Ø­Ø¯Ø¯Ø© ÙÙ‚Ø·',0),(412014,11445,'fr','SpÃ©cifique PO seulement',0),(412015,11445,'jp','ã®ã¿ç‰¹å®šã® PO',0),(412016,11445,'pt','PO especÃ­fico apenas',0),(412017,11445,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ñ‹Ðµ PO',0),(412018,11445,'es','Solo OC EspecÃ­fico',0),(412019,11445,'de','Nur bestimmte PO',0),(412020,11445,'en','Specific PO Only',0),(412021,11446,'is','',0),(412022,11446,'dr','Ø¢ÙŠØ§ Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ Ø§Ø±Ø³Ø§Ù„ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø§Ø³Øª ØŸ',0),(412023,11446,'pr','Ø¢ÙŠØ§ Ø§ÙŠÙ† Ø¢Ø¯Ø±Ø³ Ø§Ø±Ø³Ø§Ù„ Ù¾ÙŠØ´ ÙØ±Ø¶ Ø§Ø³Øª ØŸ',0),(412024,11446,'tr','Bu varsayÄ±lan sevk yeri adresi mi',0),(412025,11446,'pl','Jest to domyÅ›lny adres dostawy',0),(412026,11446,'bg','Ð¢Ð¾Ð²Ð° Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð°Ð´Ñ€ÐµÑ',0),(412027,11446,'ur','ÛŒÛ Ø·Û’ Ø´Ø¯Û Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Ùˆ Ù¾ØªÛ ÛÛ’',0),(412028,11446,'sr','Ð”Ð° Ð»Ð¸ Ñ˜Ðµ Ð¾Ð²Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ð°Ð´Ñ€ÐµÑÐ° Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(412029,11446,'vi','máº·c Ä‘á»‹nh chuyá»ƒn Ä‘áº¿n Ä‘á»‹a chá»‰',0),(412030,11446,'af','Is dit verstek skip-adres',0),(412031,11446,'ro','Acest lucru este implicit la adresa de livrare',0),(412032,11446,'et','See on vaikimisi saaja aadressi',0),(412033,11446,'si','Je to privzeti naslov',0),(412034,11446,'ba','Ini adalah Default kapal-untuk alamat',0),(412035,11446,'nl','Is dit standaard verzendadres',0),(412036,11446,'fi','Onko tÃ¤mÃ¤ oletus Toimitusasiakkaan osoite',0),(412037,11446,'no','Er dette standard lever til-adressen',0),(412038,11446,'da','Er dette standard leveringsadresse',0),(412039,11446,'ko','ì´ ê¸°ë³¸ ë°°ì†¡ ì£¼ì†ŒëŠ”',0),(412040,11446,'he','? ×”×× ×–×” ×ž×—×“×œ ×›×ª×•×‘×ª ×œ×ž×©×œ×•×—',0),(412041,11446,'el','Î ÏÏŒÎºÎµÎ¹Ï„Î±Î¹ Î³Î¹Î± Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(412042,11446,'zh','è¿™æ˜¯é»˜è®¤çš„æ”¶è´§åœ°å€ï¼Ÿ\r\n',0),(412043,11446,'sv','Ã„r detta standard leveransadress',0),(412044,11446,'it','Ãˆ questo indirizzo predefinito',0),(412045,11446,'tl','',0),(412046,11446,'th','à¸™à¸µà¹ˆà¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸›à¸¥à¸²à¸¢à¸—à¸²à¸‡à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(412047,11446,'hi','à¤‡à¤¸ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤ªà¤¤à¤¾ à¤¹à¥ˆ',0),(412048,11446,'ms','Adakah ini lalai kapal alamat',0),(412049,11446,'ar','Ù‡Ø°Ø§ Ù‡Ùˆ Ø§Ù„Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù„Ø³ÙÙŠÙ†Ø©',0),(412050,11446,'fr','Est-ce par dÃ©faut Adresse destinataire',0),(412051,11446,'jp','æ—¢å®šã®å‡ºè·å…ˆã‚¢ãƒ‰ãƒ¬ã‚¹ã“ã‚Œã¯',0),(412052,11446,'pt','Este Ã© o padrÃ£o envio-a endereÃ§o',0),(412053,11446,'ru','Ð­Ñ‚Ð¾ Ð°Ð´Ñ€ÐµÑ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(412054,11446,'es','Es la DirecciÃ³n de Enviar-A Predefinida',0),(412055,11446,'de','Ist das Standard-Ship-To-Adresse',0),(412056,11446,'en','Is This Default Ship-To Address',0),(412057,11447,'is','',0),(412058,11447,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø§ÙŠÙ† Ù…Ø­Ù„ ',0),(412059,11447,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ø¯Ø±ÙŠØ§ÙØªÙ†ÙŠ Ø¯ÙØªØ± ÙƒÙ„ Ø§ÙŠÙ† Ù…Ø­Ù„ ',0),(412060,11447,'tr','Bu konum faturalandÄ±rma GL',0),(412061,11447,'pl','GL pÅ‚atnoÅ›ci tej lokalizacji',0),(412062,11447,'bg','GL Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ñ‚Ð¾Ð²Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(412063,11447,'ur','Ø§Ø³ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø¨Ù„Ù†Ú¯ Ø¬ÛŒØ¬Û’',0),(412064,11447,'sr','Ð“Ð› Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¾Ð²Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(412065,11447,'vi','sá»• cÃ¡i hÃ³a Ä‘Æ¡n cho vá»‹ trÃ­ nÃ y',0),(412066,11447,'af','GL hierdie ligging fakturering',0),(412067,11447,'ro','GL aceastÄƒ locaÅ£ie de facturare',0),(412068,11447,'et','GL arvelduse selles asukohas',0),(412069,11447,'si','GL zaraÄunavanje to mesto',0),(412070,11447,'ba','GL penagihan lokasi ini',0),(412071,11447,'nl','GL facturering van deze locatie',0),(412072,11447,'fi','GL laskutus tÃ¤hÃ¤n sijaintiin',0),(412073,11447,'no','GL fakturering denne plasseringen',0),(412074,11447,'da','GL fakturering denne placering',0),(412075,11447,'ko','GLì´ì´ ìœ„ì¹˜ë¥¼ ê²°ì œ',0),(412076,11447,'he','GL ×—×™×•×‘ ×‘×ž×™×§×•× ×–×”',0),(412077,11447,'el','GL Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚ Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ Î¸Î­ÏƒÎ·Ï‚',0),(412078,11447,'zh','æ€»å¸æ­¤ä½ç½®åº”æ”¶æ¬¾\r\n',0),(412079,11447,'sv','GL fakturering detta lÃ¤ge',0),(412080,11447,'it','GL questa posizione di fatturazione',0),(412081,11447,'tl','',0),(412082,11447,'th','GL à¸—à¸µà¹ˆà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸™à¸µà¹‰',0),(412083,11447,'hi','à¤¯à¤¹ à¤¸à¥à¤¥à¤¾à¤¨ à¤¬à¤¿à¤²à¤¿à¤‚à¤— GL',0),(412084,11447,'ms','GL bil lokasi ini',0),(412085,11447,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¯ÙŠÙ†ÙŠÙ† Ù…Ù† Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… - Ù„Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(412086,11447,'fr','GL, ce lieu de facturation',0),(412087,11447,'jp','ã“ã®å ´æ‰€ã‚’è«‹æ±‚ GL',0),(412088,11447,'pt','GL faturamento neste local',0),(412089,11447,'ru','GL, Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³ ÑÑ‚Ð¾ Ð¼ÐµÑÑ‚Ð¾',0),(412090,11447,'es','Cuenta LM de CC en Este Local',0),(412091,11447,'de','GL, die Abrechnung dieser Position',0),(412092,11447,'en','GL Billing This Location',0),(412093,11448,'is','',0),(412094,11448,'dr','Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯  Ø§Ú¯Ø± Ø§Ø² Ù…Ø·Ø§Ù„Ø¨Ø§Øª Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ ',0),(412095,11448,'pr','Ø¬Ø§ÙŠ Ø®Ø§Ù„ÙŠ Ø¨Ú¯Ø°Ø§Ø±ÙŠØ¯  Ø§Ú¯Ø± Ø§Ø² Ù…Ø·Ø§Ù„Ø¨Ø§Øª Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ ',0),(412096,11448,'tr','Standart faturalama kullanarak boÅŸ bÄ±rakÄ±n',0),(412097,11448,'pl','Pozostaw je puste, jeÅ›li za pomocÄ… standardowych rozliczeÅ„',0),(412098,11448,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð°ÐºÐ¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(412099,11448,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ø§Ú¯Ø± Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº Û”',0),(412100,11448,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð°ÐºÐ¾ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(412101,11448,'vi','Äá»ƒ trá»‘ng náº¿u sá»­ dá»¥ng máº«u chuáº©n',0),(412102,11448,'af','LeÃ« verlaat as standaard fakturering gebruik',0),(412103,11448,'ro','LÄƒsaÅ£i necompletat dacÄƒ utilizarea Standard de facturare',0),(412104,11448,'et','JÃ¤ta tÃ¼hjaks, kui kasutades Standard arved',0),(412105,11448,'si','Pustite prazno, Äe uporabljate standardne zaraÄunavanje',0),(412106,11448,'ba','Kosongkan jika menggunakan standar penagihan',0),(412107,11448,'nl','Leeg laten als met behulp van standaard facturering',0),(412108,11448,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi jos kÃ¤yttÃ¤en Standard laskutus',0),(412109,11448,'no','La stÃ¥ tomt hvis bruker Standard fakturering',0),(412110,11448,'da','Efterlad Blank hvis bruger Standard fakturering',0),(412111,11448,'ko','í‘œì¤€ ê²°ì œë¥¼ ì‚¬ìš© í•˜ëŠ” ê²½ìš° ë¹ˆì„ ë– ë‚˜',0),(412112,11448,'he','×œ×”×©××™×¨ ×¨×™×§, ×× ×‘××ž×¦×¢×•×ª ×—×™×•×‘ ×¨×’×™×œ',0),(412113,11448,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ ÎµÎ¬Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Ï„Ï…Ï€Î¿Ï€Î¿Î¹Î·Î¼Î­Î½ÎµÏ‚ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(412114,11448,'zh','å¦‚æžœä½¿ç”¨æ ‡å‡†æ”¶æ¬¾ç•™ç™½\r\n',0),(412115,11448,'sv','LÃ¤mna tomt om du anvÃ¤nder Standard fakturering',0),(412116,11448,'it','Lasciare vuoto se si utilizza la fatturazione Standard',0),(412117,11448,'tl','',0),(412118,11448,'th','à¸›à¸¥à¹ˆà¸­à¸¢à¹ƒà¸«à¹‰à¸§à¹ˆà¸²à¸‡à¸–à¹‰à¸²à¹ƒà¸Šà¹‰à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸¡à¸²à¸•à¸£à¸à¸²à¸™',0),(412119,11448,'hi','à¤¯à¤¦à¤¿ à¤®à¤¾à¤¨à¤• à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤•à¥‡ à¤°à¤¿à¤•à¥à¤¤ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚',0),(412120,11448,'ms','Biarkan kosong jika menggunakan Standard bil',0),(412121,11448,'ar','Ø¯Ø¹Ù‡ Ø®Ø§Ù„ÙŠØ§ Ø¥Ù† ÙƒÙ†Øª ØªØ³ØªØ®Ø¯Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¯ÙŠÙ†ÙŠÙ† Ø§Ù„Ù…Ø¹ØªØ§Ø¯',0),(412122,11448,'fr','Laisser en blanc si vous utilisez de facturation Standard',0),(412123,11448,'jp','æ¨™æº–çš„ãªè«‹æ±‚ã‚’ä½¿ç”¨ã—ã¦å ´åˆç©ºç™½ã‚’ã¾ã¾',0),(412124,11448,'pt','Deixe em branco se usando faturamento padrÃ£o',0),(412125,11448,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, ÐµÑÐ»Ð¸ Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð³Ð¾ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(412126,11448,'es','Deja en Blanco Si Esta Usando Cuentas de Cobrar',0),(412127,11448,'de','Lassen Sie leer, wenn Standard-Abrechnung mit',0),(412128,11448,'en','Leave Blank If Using Standard Billing',0),(412129,11449,'is','',0),(412130,11449,'dr','(ÙˆØ¸Ø§ÙŠÙ)Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(412131,11449,'pr','Ø¨Ø§ Ú†Ø§Ù¾ Ø´ØºÙ„ Ù‡Ø§(ÙˆØ¸Ø§ÙŠÙ)Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ ',0),(412132,11449,'tr','YazdÄ±rma iÅŸlerini ile kullanÄ±lmaz',0),(412133,11449,'pl','Nie uÅ¼ywane z zadania drukowania',0),(412134,11449,'bg','ÐÐµ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° ÑÑŠÑ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(412135,11449,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¬Ø§Ø¨ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù†ÛÛŒÚº Ú©ÛŒØ§',0),(412136,11449,'sr','ÐÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÑÐ° Ð·Ð°Ð´Ð°Ñ†Ð¸ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(412137,11449,'vi','khÃ´ng Ä‘Æ°á»£c dÃ¹ng vá»›i viá»‡c in',0),(412138,11449,'af','Nie met druktake gebruik',0),(412139,11449,'ro','Nu folosit cu lucrÄƒrile de imprimare',0),(412140,11449,'et','Ei kasutata prinditÃ¶Ã¶d',0),(412141,11449,'si','Ne uporabljati z tiskalnih poslov',0),(412142,11449,'ba','Tidak digunakan dengan pekerjaan cetak',0),(412143,11449,'nl','Wordt niet gebruikt met afdruktaken',0),(412144,11449,'fi','TulostustÃ¶itÃ¤ ei kÃ¤ytetÃ¤',0),(412145,11449,'no','Ikke brukt med utskriftsjobber',0),(412146,11449,'da','Ikke bruges med udskriftsjob',0),(412147,11449,'ko','ì¸ì‡„ ìž‘ì—…ì„ ì‚¬ìš© í•˜ì§€',0),(412148,11449,'he','××™×Ÿ ×œ×”×©×ª×ž×© ×¢× ×ž×©×™×ž×•×ª ×”×“×¤×¡×”',0),(412149,11449,'el','Î”ÎµÎ½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î¼Îµ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(412150,11449,'zh','ä¸ç”¨äºŽæ‰“å°ä½œä¸š\r\n',0),(412151,11449,'sv','AnvÃ¤nds inte med utskrifter',0),(412152,11449,'it','Non utilizzato con lavori di stampa',0),(412153,11449,'tl','',0),(412154,11449,'th','à¹„à¸¡à¹ˆà¹ƒà¸Šà¹‰à¸à¸±à¸šà¸‡à¸²à¸™à¸žà¸´à¸¡à¸žà¹Œ',0),(412155,11449,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤‰à¤ªà¤¯à¥‹à¤— à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾',0),(412156,11449,'ms','Tidak digunakan dengan kerja cetakan',0),(412157,11449,'ar','Ù„Ø§ ØªØ³ØªØ®Ø¯Ù… Ù…Ø¹ Ù…Ù‡Ø§Ù… Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(412158,11449,'fr','Non utilisÃ© avec les travaux d\'impression',0),(412159,11449,'jp','å°åˆ·ã‚¸ãƒ§ãƒ–ã§ä½¿ç”¨ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(412160,11449,'pt','NÃ£o usado com trabalhos de impressÃ£o',0),(412161,11449,'ru','ÐÐµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ñ Ð·Ð°Ð´Ð°Ð½Ð¸ÑÐ¼Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(412162,11449,'es','No Se Usa Con Trabajos de ImpresiÃ³n',0),(412163,11449,'de','Nicht verwendet mit DruckauftrÃ¤gen',0),(412164,11449,'en','Not Used With Print Jobs',0),(412165,11450,'is','',0),(412166,11450,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¬Ø§Ø±ÙŠ ',0),(412167,11450,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾ Ø¬Ø§Ø±ÙŠ ',0),(412168,11450,'tr','GeÃ§erli sipariÅŸ YazdÄ±r',0),(412169,11450,'pl','Aktualne zlecenia druku',0),(412170,11450,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(412171,11450,'ur','Ø­Ø§Ù„ÛŒÛ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(412172,11450,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(412173,11450,'vi','Hiá»‡n nay Ä‘Æ¡n Ä‘áº·t hÃ ng in',0),(412174,11450,'af','Huidige druk bestellings',0),(412175,11450,'ro','Curent ordine de imprimare',0),(412176,11450,'et','Praegune trÃ¼kitÃ¶Ã¶de tellimused',0),(412177,11450,'si','Trenutna naroÄila tiskanja',0),(412178,11450,'ba','Saat ini order cetak',0),(412179,11450,'nl','Huidige afdrukken bestellingen',0),(412180,11450,'fi','Tulosta tilaus',0),(412181,11450,'no','Gjeldende bestilling',0),(412182,11450,'da','NuvÃ¦rende aftryksbestillinger',0),(412183,11450,'ko','í˜„ìž¬ ì¸ì‡„ ì£¼ë¬¸',0),(412184,11450,'he','×”×“×¤×¡×•×ª ×”× ×•×›×—×™',0),(412185,11450,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎµÏ‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(412186,11450,'zh','å½“å‰æ‰“å°è®¢å•\r\n',0),(412187,11450,'sv','Nuvarande Print Order',0),(412188,11450,'it','Ordini di stampa correnti',0),(412189,11450,'tl','',0),(412190,11450,'th','à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(412191,11450,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶',0),(412192,11450,'ms','Pesanan cetakan semasa',0),(412193,11450,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(412194,11450,'fr','Commandes d\'impression actuelles',0),(412195,11450,'jp','ç¾åœ¨ã®ãƒ—ãƒªãƒ³ãƒˆã®æ³¨æ–‡',0),(412196,11450,'pt','Ordens de impressÃ£o atuais',0),(412197,11450,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(412198,11450,'es','Ordenes de ImpresiÃ³n Actuales',0),(412199,11450,'de','Aktuellen DruckauftrÃ¤ge',0),(412200,11450,'en','Current Print Orders',0),(412201,11451,'is','',0),(412202,11451,'dr','(Ø³ÙˆØ§Ø¨Ù‚)  Ù†ÙŠØ³Øª- Ø§Ø­ØªÙ…Ø§Ù„ ÙƒØ§Ù…Ù„ Ù†Ø¨ÙˆØ¯Ù† Ø¬Ø¯ÙˆÙ„ Ù‡Ø§',0),(412203,11451,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ÙŠØ§ÙØªÙ† Ø«Ø¨ØªÙ‡Ø§(Ø³ÙˆØ§Ø¨Ù‚)  Ù†ÙŠØ³Øª- Ø§Ø­ØªÙ…Ø§Ù„ ÙƒØ§Ù…Ù„ Ù†Ø¨ÙˆØ¯Ù† Ø¬Ø¯ÙˆÙ„ Ù‡Ø§',0),(412204,11451,'tr','KayÄ±tlarÄ± - muhtemelen eksik tablolar bulamÄ±yorum',0),(412205,11451,'pl','Nie mogÄ™ znaleÅºÄ‡ rekordy - prawdopodobnie niekompletne tabele',0),(412206,11451,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ - Ð²ÐµÑ€Ð¾ÑÑ‚Ð½Ð¾ Ð½ÐµÐ¿ÑŠÐ»Ð½Ð¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð¸',0),(412207,11451,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ - Ø´Ø§ÛŒØ¯ Ù†Ø§ Ù…Ú©Ù…Ù„ Ø¬Ø¯Ø§ÙˆÙ„ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©ØªØ§',0),(412208,11451,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð·Ð°Ð¿Ð¸ÑÐµ - Ð²ÐµÑ€Ð¾Ð²Ð°Ñ‚Ð½Ð¾ Ð½ÐµÐ¿Ð¾Ñ‚Ð¿ÑƒÐ½Ðµ Ñ‚Ð°Ð±ÐµÐ»Ðµ',0),(412209,11451,'vi','KhÃ´ng thá»ƒ tÃ¬m tháº¥y há»“ sÆ¡ - báº£ng cÃ³ thá»ƒ khÃ´ng Ä‘áº§y Ä‘á»§',0),(412210,11451,'af','Kan vind rekords - waarskynlik onvoltooide tabelle',0),(412211,11451,'ro','Nu pot gÄƒsi Ã®nregistrÄƒrile - probabil Incomplete tabele',0),(412212,11451,'et','Ei leia kirjet - ilmselt mittetÃ¤ielik tabelid',0),(412213,11451,'si','Zapisov ne morete iskati - verjetno nepopolne tabel',0),(412214,11451,'ba','Tidak dapat menemukan catatan - tabel mungkin tidak lengkap',0),(412215,11451,'nl','Kan Records - waarschijnlijk onvolledig tabellen niet vinden',0),(412216,11451,'fi','LÃ¶ydÃ¤ Records - luultavasti keskenerÃ¤inen taulukot',0),(412217,11451,'no','Finner poster - sannsynligvis ufullstendig tabeller',0),(412218,11451,'da','Kan ikke finde Records - formentlig ufuldstÃ¦ndig tabeller',0),(412219,11451,'ko','ì•„ë§ˆ ë¶ˆì™„ì „ í•œ í…Œì´ë¸” ë ˆì½”ë“œ-ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(412220,11451,'he','×œ× ×ª×•×›×œ ×œ×ž×¦×•× ×¨×©×•×ž×•×ª - ×˜×‘×œ××•×ª ×›× ×¨××” ×œ× ×©×œ×',0),(412221,11451,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î²ÏÏ‰ Î´Î¯ÏƒÎºÎ¿Î¹ - Ï€Î¹Î¸Î±Î½ÏŒÎ½ Î±Ï„ÎµÎ»Î® Ï€Î¯Î½Î±ÎºÎµÏ‚',0),(412222,11451,'zh','æ‰¾ä¸åˆ°è®°å½• -å¯èƒ½ä¸å®Œæ•´è¡¨\r\n',0),(412223,11451,'sv','Kan inte hitta Records - antagligen ofullstÃ¤ndig tabeller',0),(412224,11451,'it','Impossibile trovare il record - tabelle probabilmente Incomplete',0),(412225,11451,'tl','',0),(412226,11451,'th','à¹„à¸¡à¹ˆà¸žà¸šà¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸” - à¸•à¸²à¸£à¸²à¸‡à¸­à¸²à¸ˆà¹„à¸¡à¹ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(412227,11451,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ - à¤¶à¤¾à¤¯à¤¦ à¤…à¤§à¥‚à¤°à¤¾ à¤¤à¤¾à¤²à¤¿à¤•à¤¾à¤à¤ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¤à¤¾',0),(412228,11451,'ms','Tidak dapat mencari rekod - Jadual mungkin tidak lengkap',0),(412229,11451,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø³Ø¬Ù„Ø§Øª-Ø§Ù„Ø¬Ø¯Ø§ÙˆÙ„ Ù†Ø§Ù‚ØµØ© Ø±Ø¨Ù…Ø§',0),(412230,11451,'fr','Impossible de trouver Records - Tables probablement incomplÃ¨tes',0),(412231,11451,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ - ãŠãã‚‰ãä¸å®Œå…¨ãªãƒ†ãƒ¼ãƒ–ãƒ«ã‚’è¦‹ã¤ã‘ã‚‹ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(412232,11451,'pt','NÃ£o consigo encontrar registros - tabelas provavelmente incompletas',0),(412233,11451,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð½Ð°Ð¹Ñ‚Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ - Ð²ÐµÑ€Ð¾ÑÑ‚Ð½Ð¾ Ð½ÐµÐ¿Ð¾Ð»Ð½Ñ‹Ðµ ÑÑ‚Ð¾Ð»Ñ‹',0),(412234,11451,'es','No se Puede Encontar Records - Tablas Probablemente Incompletas',0),(412235,11451,'de','Nicht finden Records â€“ wahrscheinlich unvollstÃ¤ndige Tabellen',0),(412236,11451,'en','Cannot Find Records - Probably Incomplete Tables',0),(412237,11452,'is','',0),(412238,11452,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø®ÙˆØ§Ù†Ø¯Ù† ',0),(412239,11452,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø·ÙŠ Ø®ÙˆØ§Ù†Ø¯Ù† ',0),(412240,11452,'tr','Okuma sÄ±rasÄ±nda bir hata oluÅŸtu',0),(412241,11452,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas odczytu',0),(412242,11452,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ñ‡ÐµÑ‚ÐµÐ½Ðµ',0),(412243,11452,'ur','Ù…Ø·Ø§Ù„Ø¹Û Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ',0),(412244,11452,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ Ñ‡Ð¸Ñ‚Ð°ÑšÐµ',0),(412245,11452,'vi','Lá»—i trong Ä‘á»c',0),(412246,11452,'af','Fout tydens lees',0),(412247,11452,'ro','Eroare de citire',0),(412248,11452,'et','Loe ilmnes tÃµrge',0),(412249,11452,'si','Napaka med branjem',0),(412250,11452,'ba','Error selama membaca',0),(412251,11452,'nl','Fout tijdens lezen',0),(412252,11452,'fi','Virhe lukea',0),(412253,11452,'no','Feil under lesing',0),(412254,11452,'da','Fejl under lÃ¦se',0),(412255,11452,'ko','ì½ê¸° ì¤‘ ì˜¤ë¥˜ ë°œìƒ',0),(412256,11452,'he','×©×’×™××” ×‘×ž×”×œ×š ×”×§×¨×™××”',0),(412257,11452,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬Î³Î½Ï‰ÏƒÎ·',0),(412258,11452,'zh','è¯»æ“ä½œè¿‡ç¨‹ä¸­å‡ºçŽ°é”™è¯¯\r\n',0),(412259,11452,'sv','Fel vid lÃ¤sning',0),(412260,11452,'it','Errore durante la lettura',0),(412261,11452,'tl','',0),(412262,11452,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸­à¹ˆà¸²à¸™',0),(412263,11452,'hi','à¤ªà¤¢à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(412264,11452,'ms','Ralat semasa membaca',0),(412265,11452,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ù‚Ø±Ø§Ø¡Ø©',0),(412266,11452,'fr','Erreur lors de la lecture',0),(412267,11452,'jp','èª­ã¿å–ã‚Šä¸­ã®ã‚¨ãƒ©ãƒ¼',0),(412268,11452,'pt','Erro durante a leitura',0),(412269,11452,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð’Ð¾ Ð’Ñ€ÐµÐ¼Ñ Ð§Ñ‚ÐµÐ½Ð¸Ñ',0),(412270,11452,'es','Error Durante Leer',0),(412271,11452,'de','Fehler beim Lesen',0),(412272,11452,'en','Error During Read',0),(412273,11453,'is','',0),(412274,11453,'dr','Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´ ',0),(412275,11453,'pr','Ù†Ø³Ø®Ù‡ Ù‡Ø§ÙŠ Ø§ØµÙ„ÙŠ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´ ',0),(412276,11453,'tr','Orijinal baskÄ± sipariÅŸi',0),(412277,11453,'pl','OryginaÅ‚y do zlecenia druku',0),(412278,11453,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸Ñ‚Ðµ Ð·Ð° Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(412279,11453,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§ØµÙ„',0),(412280,11453,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(412281,11453,'vi','Báº£n gá»‘c cho Ä‘Æ¡n Ä‘áº·t hÃ ng in',0),(412282,11453,'af','Oorspronklikes vir druk orde',0),(412283,11453,'ro','Originalele pentru comanda de imprimare',0),(412284,11453,'et','Originaalid printimise jÃ¤rjekorras',0),(412285,11453,'si','Originali za vrstni red tiskanja',0),(412286,11453,'ba','Asli untuk pesanan cetakan',0),(412287,11453,'nl','Originelen voor afdrukvolgorde',0),(412288,11453,'fi','AlkuperÃ¤iset tulostusjÃ¤rjestys',0),(412289,11453,'no','Originaler For rekkefÃ¸lge',0),(412290,11453,'da','Originalerne til udskriftsrÃ¦kkefÃ¸lgen',0),(412291,11453,'ko','ì¸ì‡„ ìˆœì„œë¥¼ ìœ„í•œ ì›ë³¸',0),(412292,11453,'he','×”×ž×§×•×¨×™×™× ×¢×‘×•×¨ ×”×–×ž× ×ª ×”×”×“×¤×¡×”',0),(412293,11453,'el','Î ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î± Î³Î¹Î± Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(412294,11453,'zh','åŽŸç¨¿ä¸ºæ‰“å°å‘½ä»¤\r\n',0),(412295,11453,'sv','Originalen fÃ¶r utskriftsordning',0),(412296,11453,'it','Originali per ordine di stampa',0),(412297,11453,'tl','',0),(412298,11453,'th','à¸•à¹‰à¸™à¸‰à¸šà¸±à¸šà¸à¸²à¸£à¸žà¸´à¸¡à¸žà¹Œ',0),(412299,11453,'hi','à¤®à¥‚à¤² à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤',0),(412300,11453,'ms','Asal bagi cetak',0),(412301,11453,'ar','Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø£ØµÙ„ÙŠØ© Ù„Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(412302,11453,'fr','Originaux pour la commande d\'impression',0),(412303,11453,'jp','å°åˆ·é †åºã®åŽŸæœ¬',0),(412304,11453,'pt','Originais para a ordem de impressÃ£o',0),(412305,11453,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¾Ð² Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð·Ð°ÐºÐ°Ð·Ð°',0),(412306,11453,'es','Originales Para Ordenes de ImpresiÃ³n',0),(412307,11453,'de','Originale fÃ¼r Druckreihenfolge',0),(412308,11453,'en','Originals For Print Order',0),(412309,11454,'is','',0),(412310,11454,'dr','_Ø­Ù…Ù„ Ø¨Ù‡ _  Ø¯ÙŠÚ¯Ø± ',0),(412311,11454,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø±Ø­ _Ø­Ù…Ù„ Ø¨Ù‡ _  Ø¯ÙŠÚ¯Ø± ',0),(412312,11454,'tr','Gemi iÃ§in baÅŸka bir hedef ekleme',0),(412313,11454,'pl','DodaÄ‡ innego statku do miejsca przeznaczenia',0),(412314,11454,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(412315,11454,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Ùˆ Ø§ÛŒÚ© Ø§ÙˆØ± Ù…Ù†Ø²Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(412316,11454,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¾ Ð¾Ð´Ñ€ÐµÐ´Ð¸ÑˆÑ‚Ðµ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(412317,11454,'vi','ThÃªm má»™t con tÃ u Ä‘áº¿n Ä‘Ã­ch',0),(412318,11454,'af','Voeg \'n ander skip-na bestemming',0),(412319,11454,'ro','Adauga un alt livrare-la destinaÅ£ie',0),(412320,11454,'et','Lisada laeva teise sihtkohta',0),(412321,11454,'si','Dodaj drugo destinacijo ladje',0),(412322,11454,'ba','Tambahkan lain kapal ke tujuan',0),(412323,11454,'nl','Een ander verzendadres bestemming toevoegen',0),(412324,11454,'fi','LisÃ¤Ã¤ toinen kohde',0),(412325,11454,'no','Legge til en annen leveringsadresse destinasjon',0),(412326,11454,'da','TilfÃ¸je et andet skib-til-Destination',0),(412327,11454,'ko','ë‹¤ë¥¸ ë°°ì†¡ ëŒ€ìƒ ì¶”ê°€',0),(412328,11454,'he','×”×•×¡×£ ×¢×•×“ ×™×¢×“ ×ž×©×œ×•×—',0),(412329,11454,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î¼Î¹Î± Î¬Î»Î»Î· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ Ï€ÏÎ¿Î¿ÏÎ¹ÏƒÎ¼ÏŒ',0),(412330,11454,'zh','å¢žåŠ å¦ä¸€å€‹äº¤è´§ç›®çš„åœ°\r\n',0),(412331,11454,'sv','LÃ¤gga till en annan leveransadress Destination',0),(412332,11454,'it','Aggiungere un\'altra nave a destinazione',0),(412333,11454,'tl','',0),(412334,11454,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹„à¸›à¸›à¸¥à¸²à¸¢à¸—à¸²à¸‡à¸­à¸·à¹ˆà¸™',0),(412335,11454,'hi','à¤œà¤¹à¤¾à¤œ-à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤¸à¥€ à¤…à¤¨à¥à¤¯ à¤—à¤‚à¤¤à¤µà¥à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(412336,11454,'ms','Menambah satu lagi kapal ke destinasi',0),(412337,11454,'ar','Ø¥Ø¶Ø§ÙØ© Ø¢Ø®Ø± Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ¬Ù‡Ø©',0),(412338,11454,'fr','Ajouter un autre navire Ã  Destination',0),(412339,11454,'jp','åˆ¥ã®èˆ¹ã«ç›®çš„åœ°ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(412340,11454,'pt','Adicionar outro destino de envio-a',0),(412341,11454,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐµÑ‰Ðµ Ð¾Ð´Ð¸Ð½ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(412342,11454,'es','Agregar Otro Destino de Enviar-A',0),(412343,11454,'de','FÃ¼gen Sie ein weiteres Schiff-zu-Ziel',0),(412344,11454,'en','Add Another Ship-To Destination',0),(412345,11455,'is','',0),(412346,11455,'dr','_Ø­Ù…Ù„ Ø¨Ù‡ _ Ø¬Ø¯ÙŠØ¯ ',0),(412347,11455,'pr','Ø§ÙØ²ÙˆØ¯Ù† _Ø­Ù…Ù„ Ø¨Ù‡ _ Ø¬Ø¯ÙŠØ¯ ',0),(412348,11455,'tr','Yeni gemi iÃ§in ekleyin',0),(412349,11455,'pl','DodaÄ‡ nowy statek do',0),(412350,11455,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(412351,11455,'ur','Ù†Ø¦Û’ Ø¬ÛØ§Ø² Ù…ÛŒÚº Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(412352,11455,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(412353,11455,'vi','ThÃªm tÃ u Ä‘áº¿n má»›i',0),(412354,11455,'af','Voeg nuwe skip-',0),(412355,11455,'ro','Adauga livrare-la noi',0),(412356,11455,'et','Lisada uus laev-',0),(412357,11455,'si','Dodati novo ladjo-',0),(412358,11455,'ba','Tambahkan kapal ke baru',0),(412359,11455,'nl','Toevoegen nieuwe verzendcode',0),(412360,11455,'fi','LisÃ¤Ã¤ uusi Toimitusasiakkaan',0),(412361,11455,'no','Legg til ny lever til-',0),(412362,11455,'da','TilfÃ¸je nye skib-til',0),(412363,11455,'ko','ìƒˆë¡œìš´ ì„ ë°•ì„ ì¶”ê°€',0),(412364,11455,'he','×”×•×¡×£ ×œ×ž×©×œ×•×— ×—×“×©',0),(412365,11455,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ',0),(412366,11455,'zh','å¢žåŠ æ–°äº¤è´§ç‚¹\r\n',0),(412367,11455,'sv','LÃ¤gg till ny leveransadress',0),(412368,11455,'it','Aggiungi nuova nave-a',0),(412369,11455,'tl','',0),(412370,11455,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹ƒà¸«à¸¡à¹ˆà¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹ƒà¸«à¹‰',0),(412371,11455,'hi','à¤¨à¤¯à¤¾ à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(412372,11455,'ms','Tambah baru kapal-',0),(412373,11455,'ar','Ø¥Ø¶Ø§ÙØ© Ø³ÙÙŠÙ†Ø© Ø¬Ø¯ÙŠØ¯Ø© Ø¥Ù„Ù‰',0),(412374,11455,'fr','Ajouter nouveau navire-Ã ',0),(412375,11455,'jp','æ–°ã—ã„èˆ¹ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(412376,11455,'pt','Adicionar nova envio-a',0),(412377,11455,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð²',0),(412378,11455,'es','Agregar Nuevo Enviar-A',0),(412379,11455,'de','FÃ¼gen Sie neue Schiff hinzu-',0),(412380,11455,'en','Add New Ship-To',0),(412381,11456,'is','',0),(412382,11456,'dr','_Ø­Ù…Ù„ Ø¨Ù‡ _ Ø¬Ø¯ÙŠØ¯',0),(412383,11456,'pr','Ø§ÙØ±ÙˆØ¯Ù† Ø¢Ø¯Ø±Ø³  _Ø­Ù…Ù„ Ø¨Ù‡ _ Ø¬Ø¯ÙŠØ¯',0),(412384,11456,'tr','Yeni sevk yeri adresi ekle',0),(412385,11456,'pl','DodaÄ‡ nowy adres dostawy',0),(412386,11456,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð°Ð´Ñ€ÐµÑ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(412387,11456,'ur','Ø¬ÛØ§Ø² Ú©Ùˆ Ù†Ø¦Û’ Ø¹Ù†ÙˆØ§Ù† Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(412388,11456,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ Ð°Ð´Ñ€ÐµÑÑƒ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(412389,11456,'vi','ThÃªm má»›i tÃ u-Ä‘á»ƒ Ä‘á»‹a chá»‰',0),(412390,11456,'af','Voeg nuwe skip-adres',0),(412391,11456,'ro','Adauga nou livrare-la adresa',0),(412392,11456,'et','Uus saaja-aadressi lisamine',0),(412393,11456,'si','Dodaj nov naslov',0),(412394,11456,'ba','Menambahkan baru kapal-untuk alamat',0),(412395,11456,'nl','Nieuwe verzendcode adres toevoegen',0),(412396,11456,'fi','LisÃ¤Ã¤ uusi osoite',0),(412397,11456,'no','Legge til ny lever til-adresse',0),(412398,11456,'da','TilfÃ¸je nye leveringsadresse',0),(412399,11456,'ko','ìƒˆ ë°°ì†¡ ì£¼ì†Œ ì¶”ê°€',0),(412400,11456,'he','×”×•×¡×£ ×›×ª×•×‘×ª ×œ×ž×©×œ×•×— ×—×“×©',0),(412401,11456,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î±Ï‚ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(412402,11456,'zh','å¢žåŠ æ–°çš„äº¤è´§åœ°å€\r\n',0),(412403,11456,'sv','LÃ¤gg till ny leveransadress',0),(412404,11456,'it','Aggiungi nuovo indirizzo di spedizione',0),(412405,11456,'tl','',0),(412406,11456,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸«à¸¡à¹ˆ',0),(412407,11456,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤¨à¤ à¤ªà¤¤à¥‡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(412408,11456,'ms','Tambah alamat kapal-baru',0),(412409,11456,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù†ÙˆØ§Ù† Ø¬Ø¯ÙŠØ¯ Ø¥Ù„Ù‰ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(412410,11456,'fr','Ajouter la nouvelle adresse d\'expÃ©dition',0),(412411,11456,'jp','æ–°ã—ã„é…é€å…ˆä½æ‰€ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(412412,11456,'pt','Adicione o novo endereÃ§o de envio-a',0),(412413,11456,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð°Ð´Ñ€ÐµÑ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(412414,11456,'es','Agregar Nuevo Enviar-A DirecciÃ³n',0),(412415,11456,'de','Neue Lieferadresse hinzufÃ¼gen',0),(412416,11456,'en','Add New Ship-To Address',0),(412417,11457,'is','',0),(412418,11457,'dr','Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø± ØµÙØ­Ù‡ Ø¨Ø¹Ø¯ ',0),(412419,11457,'pr','Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ø± ØµÙØ­Ù‡ Ø¨Ø¹Ø¯ ',0),(412420,11457,'tr','Sonraki sayfa devam',0),(412421,11457,'pl','Nadal NastÄ™pna strona',0),(412422,11457,'bg','ÐŸÑ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸ ÐºÑŠÐ¼ ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(412423,11457,'ur','Ø§Ú¯Ù„Û’ ØµÙØ­Û Ù¾Ø± Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾ÛŒÚº',0),(412424,11457,'sr','ÐÐ°ÑÑ‚Ð°Ð²Ð¸ Ð½Ð° ÑÐ»ÐµÐ´ÐµÑ›Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(412425,11457,'vi','Tiáº¿p tá»¥c Ä‘á»ƒ trang tiáº¿p theo',0),(412426,11457,'af','Voort na die volgende bladsy',0),(412427,11457,'ro','Continuare la pagina urmÄƒtoare',0),(412428,11457,'et','Edasi jÃ¤rgmisele lehekÃ¼ljele',0),(412429,11457,'si','Nadaljuj na naslednjo stran',0),(412430,11457,'ba','Lanjutkan ke halaman berikutnya',0),(412431,11457,'nl','Ga naar volgende pagina',0),(412432,11457,'fi','Jatka seuraavalle sivulle',0),(412433,11457,'no','Fortsett til neste side',0),(412434,11457,'da','FortsÃ¦tte til nÃ¦ste side',0),(412435,11457,'ko','ë‹¤ìŒ íŽ˜ì´ì§€ì— ê³„ì†',0),(412436,11457,'he','×”×ž×©×š ×œ×“×£ ×”×‘×',0),(412437,11457,'el','Î£Ï…Î½ÎµÏ‡Î¯ÏƒÏ„Îµ ÏƒÏ„Î·Î½ ÎµÏ€ÏŒÎ¼ÎµÎ½Î· ÏƒÎµÎ»Î¯Î´Î±',0),(412438,11457,'zh','ç»­ä¸‹é¡µ\r\n',0),(412439,11457,'sv','FortsÃ¤tt till nÃ¤sta sida',0),(412440,11457,'it','Continua alla pagina successiva',0),(412441,11457,'tl','',0),(412442,11457,'th','à¸•à¹ˆà¸­à¸«à¸™à¹‰à¸²à¸–à¸±à¸”à¹„à¸›',0),(412443,11457,'hi','à¤…à¤—à¤²à¥‡ à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤œà¤¾à¤°à¥€ à¤°à¤–à¥‡à¤‚',0),(412444,11457,'ms','Terus ke Laman seterusnya',0),(412445,11457,'ar','Ø§Ù„Ù…ØªØ§Ø¨Ø¹Ø© Ø¥Ù„Ù‰ Ø§Ù„ØµÙØ­Ø© Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(412446,11457,'fr','Continuer Ã  la Page suivante',0),(412447,11457,'jp','æ¬¡ã®ãƒšãƒ¼ã‚¸ã«ç¶šã‘ã‚‹',0),(412448,11457,'pt','Continuar para a prÃ³xima pÃ¡gina',0),(412449,11457,'ru','Ð—Ð°ÐºÐ¾Ð½Ñ‡Ð¸Ñ‚ÑŒ ÐÐ° Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ¹ Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(412450,11457,'es','Continua a la Proxima PÃ¡gina',0),(412451,11457,'de','Weiter zur nÃ¤chsten Seite',0),(412452,11457,'en','Continue To Next Page',0),(412453,11458,'is','',0),(412454,11458,'dr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ ØªØ­ÙˆÙŠÙ„',0),(412455,11458,'pr','Ú†Ú¯ÙˆÙ†Ú¯ÙŠ ØªØ­ÙˆÙŠÙ„',0),(412456,11458,'tr','Teslimat nasÄ±l',0),(412457,11458,'pl','Dostawy Jak',0),(412458,11458,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÐºÐ°Ðº',0),(412459,11458,'ur','Ø³Ù¾Ø±Ø¯ Ø¯Ø§Ø±ÛŒ Ú©Ø³ Ø·Ø±Ø­',0),(412460,11458,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð° ÐºÐ°ÐºÐ¾',0),(412461,11458,'vi','Giao hÃ ng nhÆ° tháº¿ nÃ o',0),(412462,11458,'af','Aflewering hoe',0),(412463,11458,'ro','Livrare cum',0),(412464,11458,'et','Kohaletoimetamise kuidas',0),(412465,11458,'si','Dostava kako',0),(412466,11458,'ba','Pengiriman bagaimana',0),(412467,11458,'nl','Levering hoe',0),(412468,11458,'fi','Toimitus Miten',0),(412469,11458,'no','Levering hvordan',0),(412470,11458,'da','Levering hvordan',0),(412471,11458,'ko','ë°°ë‹¬ ë°©ë²•',0),(412472,11458,'he','×ž×©×œ×•×—?',0),(412473,11458,'el','Î Î±ÏÎ¬Î´Î¿ÏƒÎ· Ï€ÏŽÏ‚',0),(412474,11458,'zh','å¦‚ä½•äº¤ä»˜\r\n',0),(412475,11458,'sv','Leverans hur',0),(412476,11458,'it','Consegna come',0),(412477,11458,'tl','',0),(412478,11458,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸­à¸¢à¹ˆà¸²à¸‡à¹„à¸£',0),(412479,11458,'hi','à¤ªà¥à¤°à¤¸à¤µ à¤•à¥ˆà¤¸à¥‡',0),(412480,11458,'ms','Penghantaran bagaimana',0),(412481,11458,'ar','Ø§Ù„ØªØ³Ù„ÙŠÙ… ÙƒÙŠÙ',0),(412482,11458,'fr','Livraison comment',0),(412483,11458,'jp','é…ä¿¡æ–¹æ³•',0),(412484,11458,'pt','Entrega como',0),(412485,11458,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÐºÐ°Ðº',0),(412486,11458,'es','Como Entregar',0),(412487,11458,'de','Lieferung wie',0),(412488,11458,'en','Delivery How',0),(412489,11459,'is','',0),(412490,11459,'dr','ØªØ­ÙˆÙŠÙ„ Ø¨Ù‡ Ù†Ø§Ù… ',0),(412491,11459,'pr','ØªØ­ÙˆÙŠÙ„ Ø¨Ù‡ Ù†Ø§Ù… ',0),(412492,11459,'tr','Teslim adÄ±',0),(412493,11459,'pl','Dostawy do nazwy',0),(412494,11459,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð¾ Ð¸Ð¼ÐµÑ‚Ð¾',0),(412495,11459,'ur','Ù†Ø§Ù… ØªØ±Ø³ÛŒÙ„',0),(412496,11459,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð° Ñƒ Ð¸Ð¼Ðµ',0),(412497,11459,'vi','Gá»­i Ä‘áº¿n tÃªn',0),(412498,11459,'af','Aflewering op naam',0),(412499,11459,'ro','Livrare la numele',0),(412500,11459,'et','Tarne nimi',0),(412501,11459,'si','Dostava za ime',0),(412502,11459,'ba','Pengiriman ke nama',0),(412503,11459,'nl','Levering aan naam',0),(412504,11459,'fi','Toimituksen nimi',0),(412505,11459,'no','Levering til navn',0),(412506,11459,'da','Levering til navn',0),(412507,11459,'ko','ì´ë¦„ì— ë°°ë‹¬',0),(412508,11459,'he','×ž×¡×™×¨×ª ×©×',0),(412509,11459,'el','Î Î±ÏÎ¬Î´Î¿ÏƒÎ· ÏƒÎµ ÏŒÎ½Î¿Î¼Î±',0),(412510,11459,'zh','é€è´§åˆ°åç§°\r\n',0),(412511,11459,'sv','Leverans till namn',0),(412512,11459,'it','Consegna a nome',0),(412513,11459,'tl','',0),(412514,11459,'th','à¸ªà¹ˆà¸‡à¸Šà¸·à¹ˆà¸­',0),(412515,11459,'hi','à¤¨à¤¾à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤²à¥€à¤µà¤°à¥€',0),(412516,11459,'ms','Penghantaran untuk nama',0),(412517,11459,'ar','Ø¥ÙŠØµØ§Ù„ Ø¨Ø§Ø³Ù…',0),(412518,11459,'fr','Livraison au nom',0),(412519,11459,'jp','åå‰ã¸ã®é…ä¿¡',0),(412520,11459,'pt','Entrega de nome',0),(412521,11459,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð² Ð¸Ð¼Ñ',0),(412522,11459,'es','Entrgar a Nombre',0),(412523,11459,'de','Belieferung der Name',0),(412524,11459,'en','Delivery To Name',0),(412525,11460,'is','',0),(412526,11460,'dr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(412527,11460,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(412528,11460,'tr','Vade tarihi geÃ§ti zaten',0),(412529,11460,'pl','Powodu juÅ¼ minÄ™Å‚a Data',0),(412530,11460,'bg','ÐŸÐ°Ð´ÐµÐ¶ ÑÑ€Ð¾Ðº Ð²ÐµÑ‡Ðµ Ðµ Ð¼Ð¸Ð½Ð°Ð»',0),(412531,11460,'ur','ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ ØªØ§Ø±ÛŒØ® Ù¾ÛÙ„Û’ ÛÛŒ Ú¯Ø²Ø± Ú†Ú©Ø§',0),(412532,11460,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð²ÐµÑ› Ð¿Ñ€Ð¾ÑˆÐ»Ð¾',0),(412533,11460,'vi','Do ngÃ y Ä‘Ã£ trÃ´i qua',0),(412534,11460,'af','Verskuldigde datum reeds geslaag het nie',0),(412535,11460,'ro','Datorate data a trecut deja',0),(412536,11460,'et','TÃ¤htaeg on juba mÃ¶Ã¶dunud',0),(412537,11460,'si','Zapadlosti datum Å¾e potekel',0),(412538,11460,'ba','Karena tanggal telah melewati',0),(412539,11460,'nl','Due datum reeds is verstreken',0),(412540,11460,'fi','Due Date on jo kulunut',0),(412541,11460,'no','Due Date har allerede passert',0),(412542,11460,'da','Due aldersbestemme har allerede passeret',0),(412543,11460,'ko','ê¸°í•œ ë‚ ì§œ ì´ë¯¸ í†µê³¼ í–ˆë‹¤',0),(412544,11460,'he','×™×¢×“ ×ª××¨×™×š ×›×‘×¨ ×¢×‘×¨',0),(412545,11460,'el','ÎŸÏ†ÎµÎ¹Î»ÏŒÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Ï‡ÎµÎ¹ Î®Î´Î· Ï€ÎµÏÎ¬ÏƒÎµÎ¹',0),(412546,11460,'zh','æˆªæ­¢æ—¥æœŸå·²ç»è¿‡åŽ»\r\n',0),(412547,11460,'sv','Due Date har redan passerat',0),(412548,11460,'it','Scadenza data Ã¨ giÃ  passata',0),(412549,11460,'tl','',0),(412550,11460,'th','à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™à¹„à¸”à¹‰à¸œà¹ˆà¸²à¸™à¹„à¸›à¹à¸¥à¹‰à¸§',0),(412551,11460,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤ªà¤¹à¤²à¥‡ à¤¹à¥€ à¤¬à¥€à¤¤ à¤šà¥à¤•à¤¾ à¤¹à¥ˆ',0),(412552,11460,'ms','Due tarikh sudah berlalu',0),(412553,11460,'ar','Ø§Ù„ÙˆØ§Ø¬Ø¨ Ø§Ù†Ù‚Ø¶Ù‰ ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ¹Ù„',0),(412554,11460,'fr','Due Date est dÃ©jÃ  passÃ©e',0),(412555,11460,'jp','æœŸé™æ—¥ãŒéŽãŽã¦ã„ã¾ã™ã€‚',0),(412556,11460,'pt','Due data jÃ¡ passou.',0),(412557,11460,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾Ðµ Ð”Ð°Ñ‚Ð° ÑƒÐ¶Ðµ Ð¿Ñ€Ð¾ÑˆÐ»Ð°',0),(412558,11460,'es','Fecha de Vencimiento Ya Ha Pasado',0),(412559,11460,'de','Due Date ist bereits verstrichen.',0),(412560,11460,'en','Due Date Has Already Passed',0),(412561,11461,'is','',0),(412562,11461,'dr','Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø³ÙŠØ¯Ù† Ø³ÙˆØ§Ù„ Ù„Ø·ÙØ§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(412563,11461,'pr','Ø¨Ø±Ø§ÙŠ Ù¾Ø±Ø³ÙŠØ¯Ù† Ø³ÙˆØ§Ù„ Ù„Ø·ÙØ§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÙŠØ±ÙŠØ¯ ',0),(412564,11461,'tr','SorularÄ±nÄ±z iÃ§in lÃ¼tfen arayÄ±nÄ±z',0),(412565,11461,'pl','W przypadku pytaÅ„ prosimy o kontakt',0),(412566,11461,'bg','Ð—Ð° Ð²ÑŠÐ¿Ñ€Ð¾ÑÐ¸, Ð¼Ð¾Ð»Ñ Ð¾Ð±Ð°Ð´ÐµÑ‚Ðµ',0),(412567,11461,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø³ÙˆØ§Ù„Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ú©Ø§Ù„ Ú©Ø±ÛŒÚº',0),(412568,11461,'sr','Ð—Ð° Ð¿Ð¸Ñ‚Ð°ÑšÐ° Ð¿Ð¾Ð·Ð¾Ð²Ð¸Ñ‚Ðµ',0),(412569,11461,'vi','Äá»‘i vá»›i cÃ¢u há»i xin vui lÃ²ng gá»i',0),(412570,11461,'af','In geval van enige Navrae Skakel',0),(412571,11461,'ro','Pentru Ã®ntrebÄƒri vÄƒ rugÄƒm sÄƒ sunaÅ£i',0),(412572,11461,'et','KÃ¼simuste puhul Palun helistage',0),(412573,11461,'si','Za vpraÅ¡anja pokliÄite',0),(412574,11461,'ba','Untuk pertanyaan silahkan hubungi',0),(412575,11461,'nl','Voor vragen kunt u bellen',0),(412576,11461,'fi','Soita kysymyksiÃ¤',0),(412577,11461,'no','For spÃ¸rsmÃ¥l vennligst ring',0),(412578,11461,'da','For spÃ¸rgsmÃ¥l ring',0),(412579,11461,'ko','ì§ˆë¬¸ì— ëŒ€ í•œ ì „í™” ì£¼ì„¸ìš”',0),(412580,11461,'he','×©××œ×•×ª × × ×œ×”×ª×§×©×¨',0),(412581,11461,'el','Î“Î¹Î± ÎµÏÏ‰Ï„Î®ÏƒÎµÎ¹Ï‚ Ï€Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎºÎ±Î»Î­ÏƒÏ„Îµ',0),(412582,11461,'zh','å¦‚æœ‰é—®é¢˜è¯·è‡´ç”µ\r\n',0),(412583,11461,'sv','FÃ¶r frÃ¥gor ring',0),(412584,11461,'it','Per le domande si prega di chiamare',0),(412585,11461,'tl','',0),(412586,11461,'th','à¸„à¸³à¸–à¸²à¸¡à¹‚à¸—à¸£',0),(412587,11461,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥ƒà¤ªà¤¯à¤¾ à¤«à¥‹à¤¨',0),(412588,11461,'ms','Untuk pertanyaan sila hubungi',0),(412589,11461,'ar','Ù„Ù„Ø£Ø³Ø¦Ù„Ø© ÙŠØ±Ø¬Ù‰ Ø§Ù„Ø§ØªØµØ§Ù„ Ø¹Ù„Ù‰:',0),(412590,11461,'fr','Pour toute question, veuillez communiquer avec',0),(412591,11461,'jp','è³ªå•ã«é›»è©±ã—ã¦ãã ã•ã„ã€‚',0),(412592,11461,'pt','Para perguntas, por favor ligue',0),(412593,11461,'ru','ÐŸÑ€Ð¸ Ð’Ð¾Ð¿Ñ€Ð¾ÑÐ°Ñ… ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð—Ð²Ð¾Ð½Ð¸Ñ‚Ðµ',0),(412594,11461,'es','Para Preguntas Por Favor Llame',0),(412595,11461,'de','Rufen Sie fÃ¼r Fragen bitte',0),(412596,11461,'en','For Questions Please Call',0),(412597,11462,'is','',0),(412598,11462,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ ',0),(412599,11462,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ ',0),(412600,11462,'tr','Eksik sipariÅŸ miktarÄ±',0),(412601,11462,'pl','BrakujÄ…ce iloÅ›ci zamÃ³wienia',0),(412602,11462,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(412603,11462,'ur','ØºØ§Ø¦Ø¨ Ø¢Ø±ÚˆØ± Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(412604,11462,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(412605,11462,'vi','Sá»‘ lÆ°á»£ng Ä‘áº·t máº¥t tÃ­ch',0),(412606,11462,'af','Vermiste bestel hoeveelheid',0),(412607,11462,'ro','LipsÄƒ pentru cantitatea',0),(412608,11462,'et','Kadunud tellimiskogus',0),(412609,11462,'si','ManjkajoÄo koliÄino naloga',0),(412610,11462,'ba','Hilang kuantitas Order',0),(412611,11462,'nl','Ontbrekende orderaantal',0),(412612,11462,'fi','Puuttuva mÃ¤Ã¤rÃ¤',0),(412613,11462,'no','Mangler antall',0),(412614,11462,'da','Mangler ordrestÃ¸rrelse',0),(412615,11462,'ko','ëˆ„ë½ ëœ ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(412616,11462,'he','×›×ž×•×ª ×”×–×ž× ×” ×—×¡×¨×™×',0),(412617,11462,'el','Î›ÎµÎ¯Ï€Î¿Ï…Î½ Î Î¿Ïƒ',0),(412618,11462,'zh','ç¼ºå°‘è®¢è´­æ•°é‡\r\n',0),(412619,11462,'sv','Saknade orderkvantiteten',0),(412620,11462,'it','QuantitÃ  di ordine mancante',0),(412621,11462,'tl','',0),(412622,11462,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹ƒà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸«à¸²à¸¢à¹„à¸›',0),(412623,11462,'hi','à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§ à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(412624,11462,'ms','Kuantiti pesanan yang hilang',0),(412625,11462,'ar','ÙƒÙ…ÙŠØ© Ø£Ù…Ø± Ù…ÙÙ‚ÙˆØ¯',0),(412626,11462,'fr','QuantitÃ© de commande manquants',0),(412627,11462,'jp','è¡Œæ–¹ä¸æ˜Žã®æ³¨æ–‡æ•°é‡',0),(412628,11462,'pt','Quantidade de ordem ausente',0),(412629,11462,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð—Ð°ÐºÐ°Ð·Ð°',0),(412630,11462,'es','Falta Cantidad de Orden',0),(412631,11462,'de','Fehlende Bestellmenge',0),(412632,11462,'en','Missing Order Quantity',0),(412633,11463,'is','',0),(412634,11463,'dr','(Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡',0),(412635,11463,'pr','ÙˆØ¶Ø¹ÙŠØª Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡ (Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡',0),(412636,11463,'tr','Eksik durumu',0),(412637,11463,'pl','Brak statusu',0),(412638,11463,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(412639,11463,'ur','ØºØ§Ø¦Ø¨ Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(412640,11463,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(412641,11463,'vi','TÃ¬nh tráº¡ng thiáº¿u',0),(412642,11463,'af','Vermiste Status',0),(412643,11463,'ro','Statutul de lipsÄƒ',0),(412644,11463,'et','Teadmata kadunud oleku',0),(412645,11463,'si','Manjka Status',0),(412646,11463,'ba','Status hilang',0),(412647,11463,'nl','Ontbrekende Status',0),(412648,11463,'fi','Puuttuvat tila',0),(412649,11463,'no','Mangler Status',0),(412650,11463,'da','Manglende Status',0),(412651,11463,'ko','ëˆ„ë½ ëœ ìƒíƒœ',0),(412652,11463,'he','×—×¡×¨ ×ž×¦×‘',0),(412653,11463,'el','Î›ÎµÎ¯Ï€ÎµÎ¹ Ï„Î¿ ÎºÎ±Î¸ÎµÏƒÏ„ÏŽÏ‚',0),(412654,11463,'zh','ç¼ºå°‘çŠ¶æ€\r\n',0),(412655,11463,'sv','Saknas Status',0),(412656,11463,'it','Status mancante',0),(412657,11463,'tl','',0),(412658,11463,'th','à¸ªà¸–à¸²à¸™à¸°à¸«à¸²à¸¢à¹„à¸›',0),(412659,11463,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤—à¥à¤®',0),(412660,11463,'ms','Hilang Status',0),(412661,11463,'ar','Ø­Ø§Ù„Ø© Ù…ÙÙ‚ÙˆØ¯',0),(412662,11463,'fr','Manque de statut',0),(412663,11463,'jp','ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(412664,11463,'pt','Faltando Status',0),(412665,11463,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(412666,11463,'es','Falta el Estatus',0),(412667,11463,'de','Fehlende Status',0),(412668,11463,'en','Missing Status',0),(412669,11464,'is','',0),(412670,11464,'dr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ø§ÙˆÙ„ÙŠ Ø«Ø¨Øª Ø´ÙˆØ¯  ',0),(412671,11464,'pr','Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ø§ÙˆÙ„ÙŠ Ø«Ø¨Øª Ø´ÙˆØ¯  ',0),(412672,11464,'tr','Ã–nceki yazdÄ±rma sÄ±rasÄ±nÄ± girmeniz gerekir',0),(412673,11464,'pl','NaleÅ¼y wprowadziÄ‡ przed kolejnoÅ›Ä‡ drukowania',0),(412674,11464,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(412675,11464,'ur','Ø§ÛŒÚ© Ù¾ÛŒØ´Ú¯ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¢Ø±ÚˆØ± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(412676,11464,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð³ÑƒÐ¼Ð°Ð½',0),(412677,11464,'vi','Pháº£i nháº­p má»™t Ä‘áº·t hÃ ng in trÆ°á»›c',0),(412678,11464,'af','\'N vooraf gedrukte orde moet intik',0),(412679,11464,'ro','Trebuie sÄƒ introduceÅ£i o comandÄƒ prealabilÄƒ imprimare',0),(412680,11464,'et','Peate sisestama eelneva printimise jÃ¤rjekorras',0),(412681,11464,'si','Vnesti morate predhodno vrstni red tiskanja',0),(412682,11464,'ba','Harus memasukkan urutan cetak yang sebelumnya',0),(412683,11464,'nl','Een voorafgaande afdrukvolgorde moet invoeren',0),(412684,11464,'fi','Kirjoita ennen tulostusjÃ¤rjestys',0),(412685,11464,'no','MÃ¥ angi en tidligere rekkefÃ¸lge',0),(412686,11464,'da','Skal angive en forudgÃ¥ende udskriftsrÃ¦kkefÃ¸lgen',0),(412687,11464,'ko','ì‚¬ì „ ì¸ì‡„ ìˆœì„œë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(412688,11464,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×”×–×ž× ×” ×ž×•×§×“×ž×ª ×”×“×¤×¡×”',0),(412689,11464,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· ÎµÎ½Ï„Î¿Î»Î® ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(412690,11464,'zh','åœ¨æ­¤ä¹‹å‰å¿…é¡»è¾“å…¥æ‰“å°å‘½ä»¤\r\n',0),(412691,11464,'sv','MÃ¥ste ange en tidigare utskriftsordning',0),(412692,11464,'it','Necessario immettere un ordine di stampa prima',0),(412693,11464,'tl','',0),(412694,11464,'th','à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸žà¸´à¸¡à¸žà¹Œà¸à¹ˆà¸­à¸™',0),(412695,11464,'hi','à¤à¤• à¤ªà¥‚à¤°à¥à¤µ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(412696,11464,'ms','Mesti masukkan cetak terlebih dahulu',0),(412697,11464,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø£Ù…Ø± Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù…Ø³Ø¨Ù‚Ø©',0),(412698,11464,'fr','Devez entrer une commande d\'impression prÃ©alable',0),(412699,11464,'jp','äº‹å‰ã®å°åˆ·é †åºã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(412700,11464,'pt','Deve efectuar uma ordem de impressÃ£o prÃ©via',0),(412701,11464,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ñ€Ð°Ð½ÐµÐµ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(412702,11464,'es','Debe Entrar Un Orden de ImpresiÃ³n Previo',0),(412703,11464,'de','MÃ¼ssen einen vorherigen Druckauftrag eingeben',0),(412704,11464,'en','Must Enter A Prior Print Order',0),(412705,11465,'is','',0),(412706,11465,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ù‚Ø¨Ù„ÙŠ ',0),(412707,11465,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ù‚Ø¨Ù„ÙŠ ',0),(412708,11465,'tr','Ã–nceden sipariÅŸ numarasÄ±',0),(412709,11465,'pl','WczeÅ›niejszego zamÃ³wienia numer',0),(412710,11465,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð¾Ð¼ÐµÑ€',0),(412711,11465,'ur','Ù¾ÛŒØ´Ú¯ÛŒ Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø±',0),(412712,11465,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¸Ñ… Ð½Ð°Ð»Ð¾Ð³Ð°',0),(412713,11465,'vi','Sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng trÆ°á»›c',0),(412714,11465,'af','Vorige Bestellingnommer',0),(412715,11465,'ro','NumÄƒrul de comandÄƒ prealabilÄƒ',0),(412716,11465,'et','Eelneva jÃ¤rjekorranumbri',0),(412717,11465,'si','Å tevilka predhodnega naroÄila',0),(412718,11465,'ba','Nomor pesanan sebelumnya',0),(412719,11465,'nl','Voorafgaande ordernummer',0),(412720,11465,'fi','Ennen tilauksen numero',0),(412721,11465,'no','Tidligere nummer',0),(412722,11465,'da','ForudgÃ¥ende ordrenummer',0),(412723,11465,'ko','ì‚¬ì „ ì£¼ë¬¸ ë²ˆí˜¸',0),(412724,11465,'he','×ž×¡×¤×¨ ×”×–×ž× ×” ×ž×•×§×“×ž×ª',0),(412725,11465,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Ï„Î¬Î¾Î· Î±ÏÎ¹Î¸Î¼Î¿Ï',0),(412726,11465,'zh','åœ¨æ­¤ä¹‹å‰è®¢è´­çš„æ•°é‡\r\n',0),(412727,11465,'sv','Tidigare ordernummer',0),(412728,11465,'it','Numero ordine prima',0),(412729,11465,'tl','',0),(412730,11465,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(412731,11465,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤†à¤¦à¥‡à¤¶ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(412732,11465,'ms','Nombor pesanan terlebih dahulu',0),(412733,11465,'ar','Ø±Ù‚Ù… ØªØ±ØªÙŠØ¨ Ù…Ø³Ø¨Ù‚',0),(412734,11465,'fr','NumÃ©ro de commande prÃ©alable',0),(412735,11465,'jp','äº‹å‰æ³¨æ–‡ç•ªå·',0),(412736,11465,'pt','NÃºmero de pedido prÃ©vio',0),(412737,11465,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(412738,11465,'es','Numero de Orden Anterior',0),(412739,11465,'de','Vorherige Bestell-Nr.',0),(412740,11465,'en','Prior Order Number',0),(412741,11466,'is','',0),(412742,11466,'dr','Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ù‚Ø¨Ù„ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(412743,11466,'pr','Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ù‚Ø¨Ù„ÙŠ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª ',0),(412744,11466,'tr','Ã–nceki baskÄ± sipariÅŸi yok',0),(412745,11466,'pl','WczeÅ›niejsze zlecenia druku nie istnieje',0),(412746,11466,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(412747,11466,'ur','Ù¾ÛŒØ´Ú¯ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¢Ø±ÚˆØ± Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(412748,11466,'sr','Ð˜Ð³ÑƒÐ¼Ð°Ð½ Ð¨Ñ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(412749,11466,'vi','TrÆ°á»›c khi Ä‘áº·t hÃ ng in khÃ´ng tá»“n táº¡i',0),(412750,11466,'af','Vooraf gedrukte orde bestaan nie',0),(412751,11466,'ro','Prealabil imprimare nu exista',0),(412752,11466,'et','Eelnev trÃ¼ki jÃ¤rjekorras pole olemas',0),(412753,11466,'si','Predhodno vrstni red tiskanja ne obstaja',0),(412754,11466,'ba','Pesanan cetakan yang sebelumnya tidak ada',0),(412755,11466,'nl','Voorafgaande afdrukvolgorde bestaat niet',0),(412756,11466,'fi','Edellisen tulostuksen tilausta ei ole',0),(412757,11466,'no','Tidligere rekkefÃ¸lge finnes ikke',0),(412758,11466,'da','ForudgÃ¥ende udskriftsrÃ¦kkefÃ¸lgen findes ikke',0),(412759,11466,'ko','ì‚¬ì „ ì¸ì‡„ ëª…ë ¹ì„ ì¡´ìž¬ í•˜ì§€ ì•ŠëŠ”',0),(412760,11466,'he','×¡×“×¨ ×”×“×¤×¡×” ×ž×•×§×“×ž×ª ××™× ×” ×§×™×™×ž×ª',0),(412761,11466,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÎµÎº Ï„Ï‰Î½ Ï€ÏÎ¿Ï„Î­ÏÏ‰Î½ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(412762,11466,'zh','åœ¨æ­¤ä¹‹å‰æ‰“å°å‘½ä»¤ä¸å­˜åœ¨\r\n',0),(412763,11466,'sv','Tidigare utskriftsordning finns inte',0),(412764,11466,'it','Previo ordine di stampa non esiste',0),(412765,11466,'tl','',0),(412766,11466,'th','à¸ªà¸±à¹ˆà¸‡à¸žà¸´à¸¡à¸žà¹Œà¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(412767,11466,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(412768,11466,'ms','Cetak terlebih dahulu tidak wujud',0),(412769,11466,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù…Ø³Ø¨Ù‚Ø© ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(412770,11466,'fr','L\'ordre d\'impression prÃ©alable n\'existe pas',0),(412771,11466,'jp','äº‹å‰ã®å°åˆ·é †åºãŒå­˜åœ¨ã—ã¾ã›ã‚“ã€‚',0),(412772,11466,'pt','NÃ£o existe ordem de impressÃ£o prÃ©via',0),(412773,11466,'ru','Ð Ð°Ð½ÐµÐµ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(412774,11466,'es','Orden de ImpresiÃ³n Anterior No Existe',0),(412775,11466,'de','Vorherigen Druckauftrag existiert nicht',0),(412776,11466,'en','Prior Print Order Does Not Exist',0),(412777,11467,'is','',0),(412778,11467,'dr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(412779,11467,'pr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(412780,11467,'tr','TarafÄ±ndan gÃ¶nderildi',0),(412781,11467,'pl','Dodano przez',0),(412782,11467,'bg','ÐŸÑ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð¸ Ð¾Ñ‚',0),(412783,11467,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¹Ø±Ø¶ Ú©Ø±Ù†Û’ Ù„Ú¯Û’',0),(412784,11467,'sr','Ð¡ÑƒÐ±Ð¼Ð¸Ñ‚Ñ‚ÐµÐ´ Ð‘y',0),(412785,11467,'vi','Gá»­i bá»Ÿi',0),(412786,11467,'af','VoorgelÃª deur',0),(412787,11467,'ro','Transmise de',0),(412788,11467,'et','Poolt',0),(412789,11467,'si','Vpisali',0),(412790,11467,'ba','Dikirimkan oleh',0),(412791,11467,'nl','Afkomstig van',0),(412792,11467,'fi','LÃ¤hettÃ¤neet',0),(412793,11467,'no','Innsendt av',0),(412794,11467,'da','Indsendt af',0),(412795,11467,'ko','ë‹˜',0),(412796,11467,'he','×”×•×’×© ×¢\"×™',0),(412797,11467,'el','Î¥Ï€Î¿Î²Î»Î®Î¸Î·ÎºÎµ Î±Ï€ÏŒ',0),(412798,11467,'zh','æäº¤\r\n',0),(412799,11467,'sv','Inskickad av',0),(412800,11467,'it','Inserite',0),(412801,11467,'tl','',0),(412802,11467,'th','à¹€à¸‚à¸µà¸¢à¸™à¹‚à¸”à¸¢',0),(412803,11467,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤',0),(412804,11467,'ms','Dikemukakan oleh',0),(412805,11467,'ar','Ù…Ù‚Ø¯Ù…Ø© Ù…Ù†',0),(412806,11467,'fr','Soumis par',0),(412807,11467,'jp','æŠ•ç¨¿',0),(412808,11467,'pt','Enviado por',0),(412809,11467,'ru','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ð¹',0),(412810,11467,'es','Presentado Por',0),(412811,11467,'de','Verfasst von',0),(412812,11467,'en','Submitted By',0),(412813,11468,'is','',0),(412814,11468,'dr','Ø¹Ù†ÙˆØ§Ù† Ø³ÙØ§Ø±Ø´ ',0),(412815,11468,'pr','Ø¹Ù†ÙˆØ§Ù† Ø³ÙØ§Ø±Ø´ ',0),(412816,11468,'tr','SipariÅŸ baÅŸlÄ±ÄŸÄ±',0),(412817,11468,'pl','TytuÅ‚ zlecenia',0),(412818,11468,'bg','Ð—Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ Ð½Ð° Ñ€ÐµÐ´',0),(412819,11468,'ur','Ù†Ø¸Ù… Ú©Ø§ Ø¹Ù†ÙˆØ§Ù†',0),(412820,11468,'sr','ÐÐ°Ð·Ð¸Ð² Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(412821,11468,'vi','TiÃªu Ä‘á» cá»§a Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(412822,11468,'af','Titel van orde',0),(412823,11468,'ro','Titlul de ordine',0),(412824,11468,'et','Tootmistellimuse nimetus',0),(412825,11468,'si','Naslov naloga',0),(412826,11468,'ba','Judul urutan',0),(412827,11468,'nl','Titel van bestelling',0),(412828,11468,'fi','Otsikko jÃ¤rjestyksessÃ¤',0),(412829,11468,'no','Tittelen pÃ¥ bestilling',0),(412830,11468,'da','Titlen pÃ¥ ordre',0),(412831,11468,'ko','ì œëª© ìˆœì„œ',0),(412832,11468,'he','×”×›×•×ª×¨×ª ×©×œ ×¡×“×¨',0),(412833,11468,'el','Î¤Î¯Ï„Î»Î¿Ï‚ Ï„Î·Ï‚ Ï„Î¬Î¾Î·Ï‚',0),(412834,11468,'zh','æ ‡é¢˜ç§©åº\r\n',0),(412835,11468,'sv','Titeln pÃ¥ bestÃ¤llning',0),(412836,11468,'it','Titolo dell\'ordine',0),(412837,11468,'tl','',0),(412838,11468,'th','à¸Šà¸·à¹ˆà¸­à¹€à¸£à¸·à¹ˆà¸­à¸‡à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(412839,11468,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤¶à¥€à¤°à¥à¤·à¤•',0),(412840,11468,'ms','Tajuk pesanan',0),(412841,11468,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ù†Ø¸Ø§Ù…',0),(412842,11468,'fr','Titre de l\'ordre',0),(412843,11468,'jp','é †åºã®ã‚¿ã‚¤ãƒˆãƒ«',0),(412844,11468,'pt','TÃ­tulo da ordem',0),(412845,11468,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¾Ñ€Ð´ÐµÐ½Ð°',0),(412846,11468,'es','Titulo de Orden',0),(412847,11468,'de','Titel des Ordens',0),(412848,11468,'en','Title Of Order',0),(412849,11469,'is','',0),(412850,11469,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´ ',0),(412851,11469,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´ ',0),(412852,11469,'tr','AyrÄ±ntÄ±lar iÃ§in baskÄ± sipariÅŸi',0),(412853,11469,'pl','SzczegÃ³Å‚y dotyczÄ…ce zlecenia druku',0),(412854,11469,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(412855,11469,'ur','ØªÙØµÛŒÙ„Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¢Ø±ÚˆØ±',0),(412856,11469,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(412857,11469,'vi','CÃ¡c chi tiáº¿t Ä‘Æ¡n Ä‘áº·t hÃ ng in',0),(412858,11469,'af','Besonderhede vir druk orde',0),(412859,11469,'ro','Detalii pentru comanda de imprimare',0),(412860,11469,'et','Prindi Tellimuse Ã¼ksikasjad',0),(412861,11469,'si','Podrobnosti za vrstni red tiskanja',0),(412862,11469,'ba','Rincian untuk pesanan cetakan',0),(412863,11469,'nl','Details voor afdrukvolgorde',0),(412864,11469,'fi','LisÃ¤tietoja tulostusjÃ¤rjestys',0),(412865,11469,'no','Detaljer For rekkefÃ¸lge',0),(412866,11469,'da','Detaljer For udskriftsrÃ¦kkefÃ¸lgen',0),(412867,11469,'ko','ì¸ì‡„ ìˆœì„œì— ëŒ€ í•œ ì„¸ë¶€ ì •ë³´',0),(412868,11469,'he','×¤×¨×˜×™× ×¢×‘×•×¨ ×¡×“×¨ ×”×”×“×¤×¡×”',0),(412869,11469,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ ÏƒÎµÎ¹ÏÎ¬ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(412870,11469,'zh','è¯¦ç»†ä¿¡æ¯ï¼šæ‰“å°å‘½ä»¤\r\n',0),(412871,11469,'sv','Detaljer fÃ¶r utskriftsordning',0),(412872,11469,'it','Dettagli per ordine di stampa',0),(412873,11469,'tl','',0),(412874,11469,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸à¸²à¸£à¸žà¸´à¸¡à¸žà¹Œ',0),(412875,11469,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤µà¤°à¤£',0),(412876,11469,'ms','Butir-butir bagi cetak',0),(412877,11469,'ar','ØªÙØ§ØµÙŠÙ„ Ù„Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(412878,11469,'fr','DÃ©tails de la commande d\'impression',0),(412879,11469,'jp','å°åˆ·ã®æ³¨æ–‡ã®è©³ç´°',0),(412880,11469,'pt','Detalhes para a ordem de impressÃ£o',0),(412881,11469,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð´Ð»Ñ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(412882,11469,'es','Detalles Para Orden de ImpresiÃ³n',0),(412883,11469,'de','Details fÃ¼r Druckreihenfolge',0),(412884,11469,'en','Details For Print Order',0),(412885,11470,'is','',0),(412886,11470,'dr','Ù†Ø¸Ø§Ø±Øª ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ø±Ø¨Ø± ',0),(412887,11470,'pr','Ù†Ø¸Ø§Ø±Øª ÙØ¹Ø§Ù„ÙŠØª ÙƒØ§Ø±Ø¨Ø± ',0),(412888,11470,'tr','KullanÄ±cÄ± etkinliÄŸini izleme',0),(412889,11470,'pl','Monitorowanie aktywnoÅ›ci uÅ¼ytkownika',0),(412890,11470,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ ÐœÐ¾Ð½Ð¸Ñ‚Ð¾Ñ€',0),(412891,11470,'ur','ØµØ§Ø±Ù Ø³Ø±Ú¯Ø±Ù…ÛŒ Ù…Ø§Ù†ÛŒÙ¹Ø±',0),(412892,11470,'sr','ÐÐ°Ð´Ð³Ð»ÐµÐ´Ð°ÑšÐµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(412893,11470,'vi','mÃ n hÃ¬nh hoáº¡t Ä‘á»™ng cá»§a ngÆ°á»i dÃ¹ng',0),(412894,11470,'af','Monitor Gebruiker Aktiwiteit ',0),(412895,11470,'ro','Monitor de activitatea utilizatorului',0),(412896,11470,'et','Kasutaja Aktiivsus Monitor',0),(412897,11470,'si','Uporabnik Activity Monitor',0),(412898,11470,'ba','Memantau aktivitas pengguna',0),(412899,11470,'nl','Gebruiker Activiteitenmonitor',0),(412900,11470,'fi','KÃ¤yttÃ¤jÃ¤n jÃ¤rjestelmÃ¤n valvonta',0),(412901,11470,'no','Brukeren Aktivitetsmonitor',0),(412902,11470,'da','Brugeren AktivitetsovervÃ¥gning',0),(412903,11470,'ko','ì‚¬ìš©ìž í™œë™ ëª¨ë‹ˆí„°',0),(412904,11470,'he','×¦×’ ×¤×¢×™×œ×•×ª ×”×ž×©×ª×ž×©',0),(412905,11470,'el','Î Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ· Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚ Ï„Î¿Ï… Ï‡ÏÎ®ÏƒÏ„Î·',0),(412906,11470,'zh','ç”¨æˆ·æ´»åŠ¨ç›‘è§†å™¨\r\n',0),(412907,11470,'sv','AnvÃ¤ndaren Aktivitetskontroll',0),(412908,11470,'it','Monitor attivitÃ  utente',0),(412909,11470,'tl','',0),(412910,11470,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(412911,11470,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤®à¥‰à¤¨à¤¿à¤Ÿà¤°',0),(412912,11470,'ms','Memantau aktiviti pengguna',0),(412913,11470,'ar','Ù…Ø±Ø§Ù‚Ø¨Ø© Ù†Ø´Ø§Ø· Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(412914,11470,'fr','Moniteur d\'activitÃ© de l\'utilisateur',0),(412915,11470,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®åˆ©ç”¨çŠ¶æ³ãƒ¢ãƒ‹ã‚¿ãƒ¼',0),(412916,11470,'pt','Monitor de atividade do usuÃ¡rio',0),(412917,11470,'ru','ÐœÐ¾Ð½Ð¸Ñ‚Ð¾Ñ€ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(412918,11470,'es','Monitor de Actividad de Usurario',0),(412919,11470,'de','User Activity Monitor',0),(412920,11470,'en','User Activity Monitor',0),(412921,11471,'is','',0),(412922,11471,'dr','ØªÙ†Ø¸ÙŠÙ… ÙƒÙ„ÙŠ ',0),(412923,11471,'pr','ØªÙ†Ø¸ÙŠÙ… ÙƒÙ„ÙŠ ',0),(412924,11471,'tr','Genel Kurulum',0),(412925,11471,'pl','Ustawienia ogÃ³lne',0),(412926,11471,'bg','ÐžÐ±Ñ‰Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(412927,11471,'ur','Ø¬Ù†Ø±Ù„ Ø³ÛŒÙ¹ Ø§Ù¾',0),(412928,11471,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð³Ð»Ð°Ð²Ð½Ðµ',0),(412929,11471,'vi','thiáº¿t láº­p chung',0),(412930,11471,'af','Algemene opstelling',0),(412931,11471,'ro','Parametrizare',0),(412932,11471,'et','Ãœldine seadistus',0),(412933,11471,'si','Nastavitev sploÅ¡nega',0),(412934,11471,'ba','Tetapan Umum',0),(412935,11471,'nl','Algemene Setup',0),(412936,11471,'fi','Asennuksen',0),(412937,11471,'no','Generelt oppsett',0),(412938,11471,'da','General Setup',0),(412939,11471,'ko','ì¼ë°˜ ì„¤ì¹˜',0),(412940,11471,'he','×”×’×“×¨×ª ×›×œ×œ×™',0),(412941,11471,'el','Î Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(412942,11471,'zh','ä¸€èˆ¬è®¾ç½®\r\n',0),(412943,11471,'sv','AllmÃ¤n instÃ¤llning',0),(412944,11471,'it','Setup generale',0),(412945,11471,'tl','',0),(412946,11471,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(412947,11471,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(412948,11471,'ms','Persediaan umum',0),(412949,11471,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø¹Ø§Ù…Ø©',0),(412950,11471,'fr','Installation gÃ©nÃ©rale',0),(412951,11471,'jp','ä¸€èˆ¬çš„ãªã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(412952,11471,'pt','General Setup',0),(412953,11471,'ru','ÐžÐ±Ñ‰Ð¸Ðµ Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(412954,11471,'es','ConfiguraciÃ³n General',0),(412955,11471,'de','General Setup',0),(412956,11471,'en','General Setup',0),(412957,11472,'is','',0),(412958,11472,'dr','Ø§Ù†Ø¬Ø§Ù… Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(412959,11472,'pr','Ø§Ù†Ø¬Ø§Ù… Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(412960,11472,'tr','Kredi kartÄ± ile Ã¶deme yapmak',0),(412961,11472,'pl','PÅ‚atnoÅ›ci kartÄ… kredytowÄ…',0),(412962,11472,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²ÐµÑ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(412963,11472,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù¾Ø± Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(412964,11472,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(412965,11472,'vi','lÃ m thay Ä‘á»•i phÆ°Æ¡ng thá»©c thanh toÃ¡n tháº» tÃ­n dá»¥ng',0),(412966,11472,'af','Maak Kredietkaart Betaling',0),(412967,11472,'ro','Face plata prin Card de Credit',0),(412968,11472,'et','Krediitkaardi makse',0),(412969,11472,'si','Kreditno kartico plaÄilo',0),(412970,11472,'ba','Pembayaran kartu kredit',0),(412971,11472,'nl','Controleer Credit Card betaling',0),(412972,11472,'fi','Luottokortilla maksaminen',0),(412973,11472,'no','GjÃ¸re kredittkortbetalingen',0),(412974,11472,'da','Foretage betaling med kreditkort',0),(412975,11472,'ko','ì‹ ìš© ì¹´ë“œ ê²°ì œ í™•ì¸',0),(412976,11472,'he','×ª×©×œ×•× ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(412977,11472,'el','ÎšÎ¬Î½ÎµÏ„Îµ Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î® Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(412978,11472,'zh','ä¿¡ç”¨å¡ä»˜æ¬¾\r\n',0),(412979,11472,'sv','GÃ¶ra betalning med kreditkort',0),(412980,11472,'it','Effettuare il pagamento con carta di credito',0),(412981,11472,'tl','',0),(412982,11472,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(412983,11472,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¥‡à¤‚',0),(412984,11472,'ms','Membuat pembayaran dengan kad kredit',0),(412985,11472,'ar','Ø¬Ø¹Ù„ Ø§Ù„Ø¯ÙØ¹ Ø¨ÙˆØ§Ø³Ø·Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(412986,11472,'fr','Faire le paiement par carte de crÃ©dit',0),(412987,11472,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã§ã®æ”¯æ‰•ã„ã‚’ä½œã‚‹',0),(412988,11472,'pt','Fazer o pagamento com cartÃ£o de crÃ©dito',0),(412989,11472,'ru','Ð¡Ð¾Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ ÐŸÐ»Ð°Ñ‚ÐµÐ¶ ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐšÐ°Ñ€Ñ‚Ð¾Ð¹',0),(412990,11472,'es','Efectuar Pago de Tarjeta de CrÃ©dito',0),(412991,11472,'de','Kreditkartenzahlung vornehmen',0),(412992,11472,'en','Make Credit Card Payment',0),(412993,11473,'is','',0),(412994,11473,'dr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(412995,11473,'pr','Ù¾ÙŠØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(412996,11473,'tr','Kredi kartÄ±yla Ã¶n Ã¶deme',0),(412997,11473,'pl','PrzedpÅ‚ata kartÄ… kredytowÄ…',0),(412998,11473,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(412999,11473,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ù¾Ø±ÛŒÙ¾ÛŒ',0),(413000,11473,'sr','Ð¢ÐµÑ€Ð°Ð½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(413001,11473,'vi','Tráº£ trÆ°á»›c báº±ng tháº» tÃ­n dá»¥ng',0),(413002,11473,'af','Voorafbetaal Per Kredietkaart',0),(413003,11473,'ro','Plata anticipatÄƒ cu carte de Credit',0),(413004,11473,'et','Krediitkaardiga ettemaksu',0),(413005,11473,'si','PredplaÄila s kreditno kartico',0),(413006,11473,'ba','Prabayar menggunakan kartu kredit',0),(413007,11473,'nl','Vooraf betalen per creditcard',0),(413008,11473,'fi','Ennakkomaksu luottokortilla',0),(413009,11473,'no','Forskuddsbetaling med kredittkort',0),(413010,11473,'da','Forudbetaling med kreditkort',0),(413011,11473,'ko','ì‹ ìš© ì¹´ë“œë¡œ ì„ ë¶ˆ',0),(413012,11473,'he','×ª×©×œ×•× ×ž×§×“×ž×” ×‘××ž×¦×¢×•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(413013,11473,'el','Î— Ï€ÏÎ¿Ï€Î»Î·ÏÏ‰Î¼Î® Î¼Î­ÏƒÏ‰ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(413014,11473,'zh','ä»¥ä¿¡ç”¨å¡é¢„ä»˜\r\n',0),(413015,11473,'sv','Betala i fÃ¶rskott med kreditkort',0),(413016,11473,'it','Pagamento anticipato con carta di credito',0),(413017,11473,'tl','',0),(413018,11473,'th','à¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²à¸œà¹ˆà¸²à¸™à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(413019,11473,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥‚à¤°à¥à¤µ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(413020,11473,'ms','Prabayar dengan kad kredit',0),(413021,11473,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹ Ù…Ù‚Ø¯Ù…Ø§ Ø¨ÙˆØ§Ø³Ø·Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(413022,11473,'fr','PrÃ©paiement par carte de crÃ©dit',0),(413023,11473,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã«ã‚ˆã‚‹å‰æ‰•ã„',0),(413024,11473,'pt','Pagamento antecipado por cartÃ£o de crÃ©dito',0),(413025,11473,'ru','ÐŸÑ€ÐµÐ´Ð¾Ð¿Ð»Ð°Ñ‚Ð° Ð¿Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ðµ',0),(413026,11473,'es','Prepagar por Tarjeta de CrÃ©dito',0),(413027,11473,'de','Vorauszahlung per Kreditkarte',0),(413028,11473,'en','Prepay By Credit Card',0),(413029,11474,'is','',0),(413030,11474,'dr','Ø¯Ø± Ø¢Ù…Ø¯ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø®ÙŠØ± ',0),(413031,11474,'pr','Ø¯Ø± Ø¢Ù…Ø¯ ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø®ÙŠØ± ',0),(413032,11474,'tr','GeÃ§ Ã¼cretleri gelir',0),(413033,11474,'pl','PÃ³Åºno opÅ‚aty dochodÃ³w',0),(413034,11474,'bg','ÐšÑŠÑÐ½Ð¾ Ñ‚Ð°ÐºÑÐ¸ Ð´Ð¾Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(413035,11474,'ur','Ù…Ø±Ø­ÙˆÙ… Ú©ÛŒ ÙÛŒØ³ Ø¢Ù…Ø¯Ù†ÛŒ',0),(413036,11474,'sr','ÐšÐ°ÑÐ½Ð¾ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´',0),(413037,11474,'vi','Cuá»‘i phÃ­ thu nháº­p',0),(413038,11474,'af','Laat fooie inkomste',0),(413039,11474,'ro','TÃ¢rziu taxele de venituri',0),(413040,11474,'et','Hilinenud lÃµivude tulu',0),(413041,11474,'si','Pozno pristojbine dohodka',0),(413042,11474,'ba','Akhir biaya pendapatan',0),(413043,11474,'nl','Late vergoedingen inkomen',0),(413044,11474,'fi','Late palkkiot tuloja',0),(413045,11474,'no','Sent avgifter inntekt',0),(413046,11474,'da','Sene gebyrer indkomst',0),(413047,11474,'ko','ëŠ¦ì€ ìˆ˜ìˆ˜ë£Œ ìˆ˜ìž…',0),(413048,11474,'he','×”×›× ×¡×•×ª ×“×ž×™ ×ž××•×—×¨',0),(413049,11474,'el','Î¤Î­Î»Î· Ï„Î­Î»Î· ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(413050,11474,'zh','æ»žçº³é‡‘æ”¶å…¥\r\n',0),(413051,11474,'sv','Sena avgifter inkomst',0),(413052,11474,'it','Tardo reddito tasse',0),(413053,11474,'tl','',0),(413054,11474,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸¥à¹ˆà¸²à¸Šà¹‰à¸²',0),(413055,11474,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤¶à¥à¤²à¥à¤• à¤†à¤¯',0),(413056,11474,'ms','Pendapatan yuran lewat',0),(413057,11474,'ar','Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(413058,11474,'fr','Fin frais revenu',0),(413059,11474,'jp','å¾ŒåŠæ–™åŽå…¥',0),(413060,11474,'pt','Tarde as taxas rendimento',0),(413061,11474,'ru','ÐšÐ¾Ð½ÐµÑ† ÑÐ±Ð¾Ñ€Ð¾Ð² Ð´Ð¾Ñ…Ð¾Ð´',0),(413062,11474,'es','Ingreso por Pagos de Cuotas de Tardanza',0),(413063,11474,'de','SpÃ¤te GebÃ¼hren Einkommen',0),(413064,11474,'en','Late Fees Income',0),(413065,11475,'is','',0),(413066,11475,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§ÙŠÙ† ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ù‡ Ù¾ÙŠØºØ§Ù… Ø®ÙˆØ¯ ØªØ§ Ø¨Ù‡ ØµÙˆØ±Øª Ø§ØªÙˆÙ…Ø§ØªÙŠÙƒ Ù¾Ø± Ø´ÙˆÙ†Ø¯',0),(413067,11475,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§ÙŠÙ† ÙÙŠÙ„Ø¯Ù‡Ø§ Ø¨Ù‡ Ù¾ÙŠØºØ§Ù… Ø®ÙˆØ¯ ØªØ§ Ø¨Ù‡ ØµÙˆØ±Øª Ø§ØªÙˆÙ…Ø§ØªÙŠÙƒ Ù¾Ø± Ø´ÙˆÙ†Ø¯',0),(413068,11475,'tr','Bu alanlar bunlarÄ± dinamik olarak doldurulmuÅŸ olmasÄ±, mesaj Ekle',0),(413069,11475,'pl','Dodaj te pola do wiadomoÅ›ci ich wypeÅ‚nione dynamicznie',0),(413070,11475,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÑ‚Ðµ Ñ‚ÐµÐ·Ð¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° ÐºÑŠÐ¼ Ð²Ð°ÑˆÐµÑ‚Ð¾ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð´Ð° Ð³Ð¸ Ð¿Ð¾Ð¿ÑŠÐ»Ð½Ð¸ Ð´Ð¸Ð½Ð°Ð¼Ð¸Ñ‡Ð½Ð¾',0),(413071,11475,'ur','Ø§Ù† Ú©ÛŒ Ù¾Ø±Ø²ÙˆØ± Ø·ÙˆØ± Ù¾Ø± Ø¨Ú¾Ø±Ø§ ÛÙˆØ§ ÛÛ’ Ù†Û’ Ø§Ù¾Ù†Û’ Ù¾ÛŒØºØ§Ù… Ù…ÛŒÚº Ø§Ù† Ù‚Ø·Ø¹Ø§Øª Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(413072,11475,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¾Ð²Ð¸Ñ… Ð¿Ð¾Ñ™Ð° Ñƒ Ð¿Ð¾Ñ€ÑƒÐºÐµ Ð´Ð° Ð¸Ñ… Ð¿Ð¾Ð¿ÑƒÐ½Ð¸Ð»Ð¸ Ð´Ð¸Ð½Ð°Ð¼Ð¸Ñ‡ÐºÐ¸',0),(413073,11475,'vi','ThÃªm pháº¡m vi nÃ y Ä‘á»ƒ thÃ´ng bÃ¡o cá»§a báº¡n Ä‘áº©y Ä‘á»§ linh Ä‘á»™ng.',0),(413074,11475,'af','Voeg hierdie velde by jou boodskap het hulle dinamies ingevul',0),(413075,11475,'ro','Adauga aceste cÃ¢mpuri la mesajul pentru a le umple mod dinamic',0),(413076,11475,'et','Nende vÃ¤ljade lisamiseks sÃµnumi lasta tÃ¤ita dÃ¼naamiliselt',0),(413077,11475,'si','Dodajte ta polja na vaÅ¡e sporoÄilo, da jih izpolnite dinamiÄno',0),(413078,11475,'ba','Menambahkan kolom ini pesan Anda untuk memiliki mereka diisi secara dinamis',0),(413079,11475,'nl','Deze velden toevoegen aan uw bericht te laten het ophalen dynamisch ingevuld',0),(413080,11475,'fi','LisÃ¤Ã¤ nÃ¤mÃ¤ kentÃ¤t viestin ne toimialueen ohjauskoneesta',0),(413081,11475,'no','Legge til disse feltene i meldingen Ã¥ ha dem fylt ut dynamisk',0),(413082,11475,'da','FÃ¸je disse felter til din besked at fÃ¥ dem fyldt dynamisk',0),(413083,11475,'ko','ë™ì ìœ¼ë¡œ ì±„ìš°ë ¤ëŠ” ë©”ì‹œì§€ì—ì´ í•„ë“œë¥¼ ì¶”ê°€',0),(413084,11475,'he','×”×•×¡×£ ×©×“×•×ª ××œ×” ×œ×”×•×“×¢×” ×©×œ×š ×œ×§×‘×œ ××•×ª× ×œ×¢×ž×•×“×” ×”×ž×ª××™×ž×” ×‘××•×¤×Ÿ ×“×™× ××ž×™',0),(413085,11475,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î±Ï…Ï„Î¬ Ï„Î± Ï€ÎµÎ´Î¯Î± ÏƒÏ„Î¿ Î¼Î®Î½Ï…Î¼Î± ÏƒÎ±Ï‚ Î³Î¹Î± Î½Î± Î­Ï‡Î¿Ï…Î½ Ï„Î¿Ï…Ï‚ Î³ÎµÎ¼Î¯Î¶Î¿Ï…Î½ Î´Ï…Î½Î±Î¼Î¹ÎºÎ¬',0),(413086,11475,'zh','å¢žåŠ è¿™äº›å­—æ®µåˆ°æ‚¨çš„ä¿¡æ¯ä½¿å…¶åŠ¨æ€å¡«å†™\r\n',0),(413087,11475,'sv','LÃ¤gga till dessa fÃ¤lt i ditt meddelande till har dem fyllda dynamiskt',0),(413088,11475,'it','Aggiungere questi campi al messaggio di averli compilati dinamicamente',0),(413089,11475,'tl','',0),(413090,11475,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸‚à¸•à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸‚à¸­à¸‡à¸„à¸¸à¸“à¹€à¸žà¸·à¹ˆà¸­à¹ƒà¸«à¹‰à¸à¸£à¸­à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹à¸šà¸šà¹„à¸”à¸™à¸²à¸¡à¸´à¸',0),(413091,11475,'hi','à¤‡à¤¨ à¤«à¤¼à¥€à¤²à¥à¤¡à¥ à¤¸ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤¨à¥à¤¹à¥‡à¤‚ à¤—à¤¤à¤¿à¤¶à¥€à¤² à¤°à¥‚à¤ª à¤¸à¥‡ à¤­à¤° à¤†à¤ªà¤•à¥‡ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤',0),(413092,11475,'ms','Menambah bidang-bidang ini kepada mesej anda untuk mereka diisi secara dinamik',0),(413093,11475,'ar','Ø¥Ø¶Ø§ÙØ© Ù‡Ø°Ù‡ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ø±Ø³Ø§Ù„Ø© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ ÙŠÙƒÙˆÙ† Ù„Ù‡Ù… Ø´ØºÙ„ Ø´ÙƒÙ„ Ø­ÙŠÙˆÙŠ',0),(413094,11475,'fr','Ajouter ces champs Ã  votre message aux remplir dynamiquement',0),(413095,11475,'jp','ã“ã‚Œã‚‰ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’å‹•çš„ã«å…¥åŠ›ã™ã‚‹ã“ã¨ã‚’ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã«è¿½åŠ ã—ã¾ã™ã€‚',0),(413096,11475,'pt','Adicionar esses campos a sua mensagem para tÃª-los preenchidos dinamicamente',0),(413097,11475,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑ‚Ð¸ Ð¿Ð¾Ð»Ñ Ð² Ð²Ð°ÑˆÐµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾Ð½Ð¸ Ð·Ð°Ð¿Ð¾Ð»Ð½ÑÑŽÑ‚ÑÑ Ð´Ð¸Ð½Ð°Ð¼Ð¸Ñ‡ÐµÑÐºÐ¸',0),(413098,11475,'es','Agregar estos campos a su mensaje para llenarselos dinamicamente',0),(413099,11475,'de','Ihre Nachricht an ihnen dynamisch ausgefÃ¼llt haben fÃ¼gen Sie diese Felder hinzu',0),(413100,11475,'en','Add these fields to your message to have them filled in dynamically',0),(413101,11476,'is','',0),(413102,11476,'dr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯',0),(413103,11476,'pr','ÙÙŠÙ„Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯',0),(413104,11476,'tr','KullanÄ±labilir alanlar',0),(413105,11476,'pl','DostÄ™pne pola',0),(413106,11476,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¸ Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(413107,11476,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ Ù‚Ø·Ø¹Ø§Øª',0),(413108,11476,'sr','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ð¿Ð¾Ñ™Ð°',0),(413109,11476,'vi','Pháº¡m vi cÃ³ sáºµn',0),(413110,11476,'af','Beskikbare Velde',0),(413111,11476,'ro','CÃ¢mpuri disponibile',0),(413112,11476,'et','Saadaolevad vÃ¤ljad',0),(413113,11476,'si','MoÅ¾na polja',0),(413114,11476,'ba','Bidang yang tersedia',0),(413115,11476,'nl','Beschikbare velden',0),(413116,11476,'fi','KÃ¤ytettÃ¤vissÃ¤ olevat kentÃ¤t',0),(413117,11476,'no','Tilgjengelige felt',0),(413118,11476,'da','TilgÃ¦ngelige felter',0),(413119,11476,'ko','ì‚¬ìš© ê°€ëŠ¥í•œ í•„ë“œ',0),(413120,11476,'he','×©×“×•×ª ×–×ž×™× ×™×',0),(413121,11476,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± Ï€ÎµÎ´Î¯Î±',0),(413122,11476,'zh','å¯ç”¨å­—æ®µ\r\n',0),(413123,11476,'sv','TillgÃ¤ngliga fÃ¤lt',0),(413124,11476,'it','Campi disponibili',0),(413125,11476,'tl','',0),(413126,11476,'th','à¹€à¸‚à¸•à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸µà¹ˆà¸¡à¸µ',0),(413127,11476,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸',0),(413128,11476,'ms','Bidang-bidang yang disediakan',0),(413129,11476,'ar','Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(413130,11476,'fr','Champs disponibles',0),(413131,11476,'jp','åˆ©ç”¨å¯èƒ½ãªãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(413132,11476,'pt','Campos disponÃ­veis',0),(413133,11476,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ Ð¿Ð¾Ð»Ñ',0),(413134,11476,'es','Campos Disponibles',0),(413135,11476,'de','VerfÃ¼gbare Felder',0),(413136,11476,'en','Available Fields',0),(413137,11477,'is','',0),(413138,11477,'dr','Ø­Ø°Ù Ø§Ù„Ú¯Ùˆ \r\n Template',0),(413139,11477,'pr','Ø­Ø°Ù Ø§Ù„Ú¯Ùˆ \r\n Template',0),(413140,11477,'tr','Åžablon silme',0),(413141,11477,'pl','UsunÄ…Ä‡ szablon',0),(413142,11477,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(413143,11477,'ur','Ø³Ø§Ù†Ú†Ø§ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(413144,11477,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ°',0),(413145,11477,'vi','XÃ³a máº«u',0),(413146,11477,'af','Skrap sjabloon',0),(413147,11477,'ro','È˜tergeÈ›i È™ablonul',0),(413148,11477,'et','Malli kustutamine',0),(413149,11477,'si','Izbrisati predlogo',0),(413150,11477,'ba','Menghapus Template',0),(413151,11477,'nl','Sjabloon verwijderen',0),(413152,11477,'fi','Mallin poistaminen',0),(413153,11477,'no','Slette malen',0),(413154,11477,'da','Slet skabelon',0),(413155,11477,'ko','ì„œì‹ íŒŒì¼ ì‚­ì œ',0),(413156,11477,'he','×œ×ž×—×•×§ ×ª×‘× ×™×ª',0),(413157,11477,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿',0),(413158,11477,'zh','åˆ é™¤æ¨¡æ¿\r\n',0),(413159,11477,'sv','Ta bort mallen',0),(413160,11477,'it','Eliminare il Template',0),(413161,11477,'tl','',0),(413162,11477,'th','à¸¥à¸šà¹€à¸—à¹‡à¸¡à¹€à¸žà¸¥à¸•',0),(413163,11477,'hi','à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(413164,11477,'ms','Menghapuskan Template',0),(413165,11477,'ar','Ø­Ø°Ù Ù‚Ø§Ù„Ø¨',0),(413166,11477,'fr','Supprimer le modÃ¨le',0),(413167,11477,'jp','ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(413168,11477,'pt','Excluir modelo',0),(413169,11477,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(413170,11477,'es','Eliminar Plantilla',0),(413171,11477,'de','Vorlage lÃ¶schen',0),(413172,11477,'en','Delete Template',0),(413173,11478,'is','',0),(413174,11478,'dr','Ù‡ÙŠÚ† Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(413175,11478,'pr','Ù‡ÙŠÚ† Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯Ù‡ ',0),(413176,11478,'tr','Ã–zellik yok bulundu',0),(413177,11478,'pl','Nie znaleziono wÅ‚aÅ›ciwoÅ›ci',0),(413178,11478,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð¸Ð¼Ð¾Ñ‚Ð¸',0),(413179,11478,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ø®ÙˆØ§Øµ',0),(413180,11478,'sr','ÐÐµÐ¼Ð° ÑÐ²Ð¾Ñ˜ÑÑ‚Ð°Ð²Ð° Ð½Ð°ÑˆÐ»Ð¸',0),(413181,11478,'vi','khÃ´ng tÃ¬m tháº¥y tÃ i sáº£n',0),(413182,11478,'af','Geen eienskappe gevind',0),(413183,11478,'ro','FÄƒrÄƒ proprietÄƒÅ£i gÄƒsit',0),(413184,11478,'et','Mingit kinnisvara leitud',0),(413185,11478,'si','Nima lastnosti najdemo',0),(413186,11478,'ba','Sifat-sifat tidak ditemukan',0),(413187,11478,'nl','Geen woningen gevonden',0),(413188,11478,'fi','Ominaisuuksia ei lÃ¶ydy',0),(413189,11478,'no','Ingen egenskaper',0),(413190,11478,'da','Ingen egenskaber findes',0),(413191,11478,'ko','ì•„ë‹ˆ ì†ì„±',0),(413192,11478,'he','×œ× × ×ž×¦××• × ×›×¡×™×',0),(413193,11478,'el','Î”ÎµÎ½ Ï„Î¹Ï‚ Î¹Î´Î¹ÏŒÏ„Î·Ï„ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ¯ÏƒÎºÎ¿Î½Ï„Î±Î¹',0),(413194,11478,'zh','æ²¡æœ‰æ‰¾åˆ°å±žæ€§\r\n',0),(413195,11478,'sv','Inga egenskaper som finns',0),(413196,11478,'it','Immobili trovati',0),(413197,11478,'tl','',0),(413198,11478,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¹„à¸¡à¹ˆà¸žà¸š',0),(413199,11478,'hi','à¤•à¥‹à¤ˆ à¤—à¥à¤£ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(413200,11478,'ms','Tiada ditemui',0),(413201,11478,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø®ØµØ§Ø¦Øµ Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(413202,11478,'fr','Aucun biens trouvÃ©s',0),(413203,11478,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(413204,11478,'pt','NÃ£o hÃ¡ propriedades encontradas',0),(413205,11478,'ru','Ð¡Ð²Ð¾Ð¹ÑÑ‚Ð²Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(413206,11478,'es','No Se Encuentra Propiedades',0),(413207,11478,'de','Keine Objekte gefunden',0),(413208,11478,'en','No Properties Found',0),(413209,11479,'is','',0),(413210,11479,'dr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(413211,11479,'pr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(413212,11479,'tr','Ã–zelliÄŸi',0),(413213,11479,'pl','WÅ‚aÅ›ciwoÅ›Ä‡',0),(413214,11479,'bg','Ð˜Ð¼Ð¾Ñ‚Ð¸',0),(413215,11479,'ur','Ø®Ø§ØµÛŒØª',0),(413216,11479,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾',0),(413217,11479,'vi','tÃ i sáº£n',0),(413218,11479,'af','Eiendom',0),(413219,11479,'ro','Proprietate',0),(413220,11479,'et','Kinnisvara',0),(413221,11479,'si','Lastnost',0),(413222,11479,'ba','Properti',0),(413223,11479,'nl','Eigenschap',0),(413224,11479,'fi','Ominaisuus',0),(413225,11479,'no','Egenskapen',0),(413226,11479,'da','Ejendom',0),(413227,11479,'ko','ì†ì„±',0),(413228,11479,'he','×¨×›×•×©',0),(413229,11479,'el','Î™Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(413230,11479,'zh','å±žæ€§\r\n',0),(413231,11479,'sv','Egenskapen',0),(413232,11479,'it','ProprietÃ ',0),(413233,11479,'tl','',0),(413234,11479,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(413235,11479,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿',0),(413236,11479,'ms','Harta tanah',0),(413237,11479,'ar','Ø§Ù„Ø®Ø§ØµÙŠØ©',0),(413238,11479,'fr','PropriÃ©tÃ©',0),(413239,11479,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£',0),(413240,11479,'pt','Propriedade',0),(413241,11479,'ru','ÐÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(413242,11479,'es','Propiedad',0),(413243,11479,'de','Eigenschaft',0),(413244,11479,'en','Property',0),(413245,11480,'is','',0),(413246,11480,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(413247,11480,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(413248,11480,'tr','Ã–zellik Ekle',0),(413249,11480,'pl','Dodaj WÅ‚aÅ›ciwoÅ›Ä‡',0),(413250,11480,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(413251,11480,'ur','Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(413252,11480,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð°',0),(413253,11480,'vi','ThÃªm sá»Ÿ  há»¯u',0),(413254,11480,'af','Eiendom Byvoeg',0),(413255,11480,'ro','AdÄƒugaÅ£i proprietatea',0),(413256,11480,'et','Lisa Kuulutus',0),(413257,11480,'si','Dodajte lastnost',0),(413258,11480,'ba','Tambahkan properti',0),(413259,11480,'nl','Eigenschap toevoegen',0),(413260,11480,'fi','LisÃ¤Ã¤ ominaisuus',0),(413261,11480,'no','Legg til egenskap',0),(413262,11480,'da','TilfÃ¸je ejendom',0),(413263,11480,'ko','ì†ì„± ì¶”ê°€',0),(413264,11480,'he','×œ×”×•×¡×™×£ ×ž××¤×™×™× ×™×',0),(413265,11480,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ Î¹Î´Î¹ÏŒÏ„Î·Ï„Î±',0),(413266,11480,'zh','å¢žåŠ å±žæ€§\r\n',0),(413267,11480,'sv','LÃ¤gga till egenskap',0),(413268,11480,'it','Aggiungere la proprietÃ .',0),(413269,11480,'tl','',0),(413270,11480,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(413271,11480,'hi','à¤—à¥à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(413272,11480,'ms','Tambah harta',0),(413273,11480,'ar','Ø¥Ø¶Ø§ÙØ© Ø®Ø§ØµÙŠØ©',0),(413274,11480,'fr','Ajouter propriÃ©tÃ©',0),(413275,11480,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(413276,11480,'pt','Adicionar Propriedade.',0),(413277,11480,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(413278,11480,'es','Agregar Propiedad',0),(413279,11480,'de','Eigenschaft hinzufÃ¼gen',0),(413280,11480,'en','Add Property',0),(413281,11481,'is','',0),(413282,11481,'dr','Ù„Ø·ÙØ§ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø±Ø§  Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯',0),(413283,11481,'pr','Ù„Ø·ÙØ§ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø±Ø§  Ø´Ø§Ù…Ù„ Ø´ÙˆØ¯',0),(413284,11481,'tr','LÃ¼tfen Ã¶zelliÄŸi ekle',0),(413285,11481,'pl','ProszÄ™ podaÄ‡ WÅ‚aÅ›ciwoÅ›Ä‡',0),(413286,11481,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(413287,11481,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(413288,11481,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ ÑƒÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð¾',0),(413289,11481,'vi','vui lÃ²ng bao gá»“m tÃ i sáº£n',0),(413290,11481,'af','Sluit asseblief \'n Eiendom in',0),(413291,11481,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i proprietate',0),(413292,11481,'et','Lisage atribuudi',0),(413293,11481,'si','Prosimo, da vkljuÄite lastnine',0),(413294,11481,'ba','Harap sertakan properti',0),(413295,11481,'nl','Gelieve Include, eigenschap',0),(413296,11481,'fi','LiitÃ¤ ominaisuus',0),(413297,11481,'no','Ta med egenskapen',0),(413298,11481,'da','VedlÃ¦g ejendom',0),(413299,11481,'ko','ì†ì„±ì„ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(413300,11481,'he','×× × ×›×œ×•×œ × ×›×¡',0),(413301,11481,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î·Î½ Î¹Î´Î¹ÏŒÏ„Î·Ï„Î±',0),(413302,11481,'zh','è¯·åˆ—å…¥å±žæ€§\r\n',0),(413303,11481,'sv','VÃ¤nligen inkludera egendom',0),(413304,11481,'it','Si prega di includere proprietÃ .',0),(413305,11481,'tl','',0),(413306,11481,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸§à¸¡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(413307,11481,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(413308,11481,'ms','Sila sertakan harta',0),(413309,11481,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ø®Ø§ØµÙŠØ©',0),(413310,11481,'fr','S\'il vous plaÃ®t inclure propriÃ©tÃ©',0),(413311,11481,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã‚’è¨˜è¼‰ã—ã¦ãã ã•ã„ã€‚',0),(413312,11481,'pt','Por favor, inclua a propriedade',0),(413313,11481,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(413314,11481,'es','Por Favor Incluye la Propiedad',0),(413315,11481,'de','Bitte geben Sie Eigenschaft',0),(413316,11481,'en','Please Include Property',0),(413317,11482,'is','',0),(413318,11482,'dr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ',0),(413319,11482,'pr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§ Ø¨Ø±Ø§ÙŠ ',0),(413320,11482,'tr','Ã–zellikler iÃ§in',0),(413321,11482,'pl','WÅ‚aÅ›ciwoÅ›ci',0),(413322,11482,'bg','Ð¡Ð²Ð¾Ð¹ÑÑ‚Ð²Ð° Ð·Ð°',0),(413323,11482,'ur','Ø®ÙˆØ§Øµ Ú©Û’ Ù„Ø¦Û’',0),(413324,11482,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð° Ð·Ð°',0),(413325,11482,'vi','tÃ i sáº£n cho',0),(413326,11482,'af','Eienskappe vir',0),(413327,11482,'ro','ProprietÄƒÅ£i pentru',0),(413328,11482,'et','Atribuudid',0),(413329,11482,'si','Lastnosti za',0),(413330,11482,'ba','Properti',0),(413331,11482,'nl','Eigenschappen voor',0),(413332,11482,'fi','Ominaisuudet',0),(413333,11482,'no','Egenskaper For',0),(413334,11482,'da','Egenskaber For',0),(413335,11482,'ko','ì— ëŒ€ í•œ ì†ì„±',0),(413336,11482,'he','×ž××¤×™×™× ×™× ×¢×‘×•×¨',0),(413337,11482,'el','Î™Î´Î¹ÏŒÏ„Î·Ï„ÎµÏ‚ Î³Î¹Î±',0),(413338,11482,'zh','å±žæ€§',0),(413339,11482,'sv','Egenskaper fÃ¶r',0),(413340,11482,'it','ProprietÃ  per',0),(413341,11482,'tl','',0),(413342,11482,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸ªà¸³à¸«à¸£à¸±à¸š',0),(413343,11482,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤£',0),(413344,11482,'ms','Hartanah untuk',0),(413345,11482,'ar','Ø®ØµØ§Ø¦Øµ',0),(413346,11482,'fr','PropriÃ©tÃ©s pour',0),(413347,11482,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£',0),(413348,11482,'pt','Propriedades para',0),(413349,11482,'ru','ÐŸÑ€Ð¾Ð´Ð°ÑŽ',0),(413350,11482,'es','Propiedades Para',0),(413351,11482,'de','Eigenschaften fÃ¼r',0),(413352,11482,'en','Properties For',0),(413353,11483,'is','',0),(413354,11483,'dr','(ÙˆØ§Ø¨Ø³ØªÚ¯ÙŠ ) Ø¨Ø§ Ø§ÙŠÙ† Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¯Ø§Ø±Ø¯ ',0),(413355,11483,'pr','Ø§ÙŠÙ† Ù†Ù…Ø§ÙŠÙ†Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙŠÙƒ Ø§Ø±ØªØ¨Ø§Ø·ÙŠ (ÙˆØ§Ø¨Ø³ØªÚ¯ÙŠ ) Ø¨Ø§ Ø§ÙŠÙ† Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¯Ø§Ø±Ø¯ ',0),(413356,11483,'tr','Bu Ajan zaten bir iliÅŸki ile bu Ã¶zelliÄŸi vardÄ±r.',0),(413357,11483,'pl','Åšrodek ten ma juÅ¼ skojarzenie z tym WÅ‚aÅ›ciwoÅ›Ä‡',0),(413358,11483,'bg','Ð¢Ð¾Ð·Ð¸ Ð°Ð³ÐµÐ½Ñ‚ Ð²ÐµÑ‡Ðµ Ð¸Ð¼Ð° Ð²Ñ€ÑŠÐ·ÐºÐ° Ñ Ñ‚Ð¾Ð²Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(413359,11483,'ur','ÛŒÛ Ø§ÛŒØ¬Ù†Ù¹ Ù…ÛŒÚº Ù¾ÛÙ„Û’ ÛÛŒ Ú©Ø³ÛŒ Ø§ÛŒØ³ÙˆØ³ÛŒ Ø§ÛŒØ´Ù† Ú©Û’ Ø³Ø§ØªÚ¾ ÛŒÛ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ ÛÛ’',0),(413360,11483,'sr','ÐžÐ²Ð°Ñ˜ ÐÐ³ÐµÐ½Ñ‚ Ñ˜Ðµ Ð²ÐµÑ› Ð¿Ð¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐ° Ñ Ð¾Ð²Ð¾ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð¾',0),(413361,11483,'vi','Äáº¡i lÃ½ nÃ y Ä‘Ã£ cÃ³ má»™t hiá»‡p Æ°á»›c vá»›i tÃ i sáº£n nÃ y',0),(413362,11483,'af','Hierdie Agent het reeds \'n vereniging met hierdie eiendom',0),(413363,11483,'ro','Acest Agent are deja o asociere cu aceastÄƒ proprietate',0),(413364,11483,'et','See aine on juba Ã¼histu selle vara',0),(413365,11483,'si','Ta Agent Å¾e ima povezavo s to lastnost',0),(413366,11483,'ba','Agen ini sudah memiliki asosiasi dengan ini properti',0),(413367,11483,'nl','Deze Agent heeft een associatie met dit al, eigenschap',0),(413368,11483,'fi','TÃ¤mÃ¤ agentti jo on yhdessÃ¤ omaisuutta',0),(413369,11483,'no','Denne agenten har allerede en tilknytning til denne egenskapen',0),(413370,11483,'da','Denne Agent har allerede en tilknytning til denne ejendom',0),(413371,11483,'ko','ì´ ì—ì´ì „íŠ¸ëŠ” ì´ë¯¸ì´ ì—°ê²° ì†ì„±',0),(413372,11483,'he','×¡×•×›×Ÿ ×–×” ×›×‘×¨ ×™×© ××¡×•×¦×™××¦×™×” ×¢× ×–×” ×ž××¤×™×™×Ÿ',0),(413373,11483,'el','Î‘Ï…Ï„ÏŒÏ‚ Î¿ Ï€ÏÎ¬ÎºÏ„Î¿ÏÎ±Ï‚ Î­Ï‡ÎµÎ¹ Î®Î´Î· ÏƒÏ…Î½Î´Î­ÏƒÎµÏ‰Ï‚ Î¼Îµ Î±Ï…Ï„ÏŒ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(413374,11483,'zh','è¿™ä¸ªä»£ç†å·²ç»ä¸Žæ­¤å±žæ€§å…³è”\r\n',0),(413375,11483,'sv','Denna Agent har redan en Association med denna egenskap',0),(413376,11483,'it','Questo agente ha giÃ  un\'associazione con questa proprietÃ .',0),(413377,11483,'tl','',0),(413378,11483,'th','à¹€à¸­à¹€à¸ˆà¸™à¸•à¹Œà¸™à¸µà¹‰à¹à¸¥à¹‰à¸§à¸„à¸§à¸²à¸¡à¸ªà¸±à¸¡à¸žà¸±à¸™à¸˜à¹Œà¸™à¸µà¹‰à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(413379,11483,'hi','à¤‡à¤¸ à¤à¤œà¥‡à¤‚à¤Ÿ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤¸ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤à¤¸à¥‹à¤¸à¤¿à¤à¤¶à¤¨ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤¹à¥ˆ',0),(413380,11483,'ms','Ejen ini sudah pun mempunyai perkaitan dengan ini harta',0),(413381,11483,'ar','Ù‡Ø°Ø§ Ø§Ù„Ø¹Ø§Ù…Ù„ Ù„Ø¯ÙŠÙ‡Ø§ Ø¨Ø§Ù„ÙØ¹Ù„ Ø§Ù‚ØªØ±Ø§Ù† Ù…Ø¹ Ù‡Ø°Ù‡ Ø§Ù„Ø®Ø§ØµÙŠØ©',0),(413382,11483,'fr','Cet Agent a dÃ©jÃ  une liaison avec cette propriÃ©tÃ©',0),(413383,11483,'jp','ã“ã®ã‚¨ãƒ¼ã‚¸ã‚§ãƒ³ãƒˆã¯æ—¢ã«ã“ã‚Œã¨é–¢é€£ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£',0),(413384,11483,'pt','Este agente jÃ¡ tem uma associaÃ§Ã£o com esta propriedade.',0),(413385,11483,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð°Ð³ÐµÐ½Ñ‚ ÑƒÐ¶Ðµ Ð¸Ð¼ÐµÐµÑ‚ ÑÐ²ÑÐ·ÑŒ Ñ ÑÑ‚Ð¸Ð¼ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(413386,11483,'es','Este Agente Ya Tiene Una AsociaciÃ³n con Esta Propiedad',0),(413387,11483,'de','Dieser Agent verfÃ¼gt bereits Ã¼ber eine Vereinigung mit dieser Eigenschaft',0),(413388,11483,'en','This Agent Already Has An Association With This Property',0),(413389,11484,'is','',0),(413390,11484,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ',0),(413391,11484,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ',0),(413392,11484,'tr','BaÅŸvuru Ã¼creti',0),(413393,11484,'pl','OpÅ‚ata za zÅ‚oÅ¼enie wniosku',0),(413394,11484,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° ÐºÐ°Ð½Ð´Ð¸Ð´Ð°Ñ‚ÑÑ‚Ð²Ð°Ð½Ðµ',0),(413395,11484,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ ÙÛŒØ³',0),(413396,11484,'sr','Ð—Ð° Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²ÑšÐµ',0),(413397,11484,'vi','Lá»‡ phÃ­ ná»™p Ä‘Æ¡n',0),(413398,11484,'af','Aansoek fooi',0),(413399,11484,'ro','Taxa de cerere',0),(413400,11484,'et','Taotluse esitamise lÃµiv',0),(413401,11484,'si','Prijavnina',0),(413402,11484,'ba','Biaya aplikasi',0),(413403,11484,'nl','Aanvraagkosten',0),(413404,11484,'fi','Hakemusmaksu',0),(413405,11484,'no','PÃ¥meldingsavgiften',0),(413406,11484,'da','AnsÃ¸gningsgebyret',0),(413407,11484,'ko','ì „í˜• ë£Œ',0),(413408,11484,'he','×“×ž×™ ×”×¨×©×ž×”',0),(413409,11484,'el','Î¤Î­Î»Î¿Ï‚ Î±Î¯Ï„Î·ÏƒÎ·Ï‚',0),(413410,11484,'zh','åº”ç”¨è´¹\r\n',0),(413411,11484,'sv','AnsÃ¶kningsavgiften',0),(413412,11484,'it','Tassa d\'iscrizione',0),(413413,11484,'tl','',0),(413414,11484,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(413415,11484,'hi','à¤†à¤µà¥‡à¤¦à¤¨ à¤¶à¥à¤²à¥à¤•',0),(413416,11484,'ms','Bayaran permohonan',0),(413417,11484,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø·Ù„Ø¨',0),(413418,11484,'fr','Frais d\'inscription',0),(413419,11484,'jp','å‡ºé¡˜æ–™',0),(413420,11484,'pt','Taxa de inscriÃ§Ã£o',0),(413421,11484,'ru','ÐšÐ¾Ð½ÑÑƒÐ»ÑŒÑÐºÐ¸Ð¹ ÑÐ±Ð¾Ñ€',0),(413422,11484,'es','Cuota de AplicaciÃ³n',0),(413423,11484,'de','AntragsgebÃ¼hr',0),(413424,11484,'en','Application Fee',0),(413425,11485,'is','',0),(413426,11485,'dr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ù‡ Ù…Ù„Ùƒ Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯',0),(413427,11485,'pr','Ù†Ø§Ø­ÙŠÙ‡ Ø¨Ù‡ Ù…Ù„Ùƒ Ø¶Ù…ÙŠÙ…Ù‡ Ø´Ø¯',0),(413428,11485,'tr','Alan Ã¶zellik iÃ§in iliÅŸtirilmiÅŸ',0),(413429,11485,'pl','Powierzchnia do WÅ‚aÅ›ciwoÅ›Ä‡',0),(413430,11485,'bg','ÐžÐ±Ð»Ð°ÑÑ‚, ÑÐ²ÑŠÑ€Ð·Ð°Ð½Ð¸ Ñ Ð¸Ð¼Ð¾Ñ‚Ð°',0),(413431,11485,'ur','Ø¹Ù„Ø§Ù‚Û’ Ú©ÛŒ Ø®ØµÙˆØµÛŒØª Ù…ÛŒÚº Ø³Û’ Ù…Ù†Ø³Ù„Ú©',0),(413432,11485,'sr','ÐžÐ±Ð»Ð°ÑÑ‚ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ðµ',0),(413433,11485,'vi','Khu vá»±c gáº¯n liá»n vá»›i báº¥t Ä‘á»™ng sáº£n',0),(413434,11485,'af','Gebied aan eiendom geheg',0),(413435,11485,'ro','Zona ataÅŸat la proprietate',0),(413436,11485,'et','Seotud kinnisvara alal',0),(413437,11485,'si','ObmoÄju pripadajo lastnine',0),(413438,11485,'ba','Daerah yang melekat pada properti',0),(413439,11485,'nl','Gebied gekoppeld aan eigenschap',0),(413440,11485,'fi','Alue liitetÃ¤Ã¤n ominaisuus',0),(413441,11485,'no','OmrÃ¥det knyttet til egenskapen',0),(413442,11485,'da','OmrÃ¥det knyttet til ejendom',0),(413443,11485,'ko','ì˜ì—­ ì†ì„±ì— ì—°ê²° ëœ',0),(413444,11485,'he','××–×•×¨ ×”×ž×¦×•×¨×¤×ª ×¨×›×•×©',0),(413445,11485,'el','Î ÎµÏÎ¹Î¿Ï‡Î® Ï€Î¿Ï… ÏƒÏ…Î½Î´Î­Î¿Î½Ï„Î±Î¹ Î¼Îµ Ï„Î·Î½ Î¹Î´Î¹ÏŒÏ„Î·Ï„Î±',0),(413446,11485,'zh','ç‰©ä¸šé™„è®¾\r\n',0),(413447,11485,'sv','OmrÃ¥de bifogas egendom',0),(413448,11485,'it','Zona associata alla proprietÃ ',0),(413449,11485,'tl','',0),(413450,11485,'th','à¸•à¸±à¹‰à¸‡à¸à¸±à¸šà¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(413451,11485,'hi','à¤…à¤¨à¥à¤²à¤—à¥à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(413452,11485,'ms','Kawasan yang melekat pada harta',0),(413453,11485,'ar','Ù…Ù†Ø·Ù‚Ø© Ù…Ù„Ø­Ù‚Ø© Ø¨Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(413454,11485,'fr','Domaine attachÃ© Ã  la propriÃ©tÃ©',0),(413455,11485,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã«æŽ¥ç¶šã•ã‚Œã¦ã„ã‚‹å‘¨è¾º',0),(413456,11485,'pt','Ãrea anexada a propriedade.',0),(413457,11485,'ru','Ð Ð°Ð¹Ð¾Ð½, Ð¿Ñ€Ð¸ÑÐ¾ÐµÐ´Ð¸Ð½ÐµÐ½Ð¾ Ðº Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ñƒ',0),(413458,11485,'es','Area Adjunta a la Propiedad',0),(413459,11485,'de','Bereich, die angefÃ¼gte Eigenschaft',0),(413460,11485,'en','Area Attached To Property',0),(413461,11486,'is','',0),(413462,11486,'dr','Ø§Ø² Ø§Ù…Ø¶Ø§ Ù…Ø¹Ø±Ù Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÙŠØ¯',0),(413463,11486,'pr','Ø§Ø² Ø§Ù…Ø¶Ø§ Ù…Ø¹Ø±Ù Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÙŠØ¯',0),(413464,11486,'tr','AssureSign baÄŸlam tanÄ±tÄ±cÄ±sÄ±',0),(413465,11486,'pl','Identyfikator kontekstu AssureSign',0),(413466,11486,'bg','AssureSign ÐºÐ¾Ð½Ñ‚ÐµÐºÑÑ‚ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(413467,11486,'ur','Ø§Ø³Ø³Ø±ÛŒØ³Ú¯Ù† Ø³ÛŒØ§Ù‚ Ùˆ Ø³Ø¨Ø§Ù‚ Ú©Û’ Ø´Ù†Ø§Ø®Øª Ú©Ù†Ù†Ø¯Û',0),(413468,11486,'sr','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÐÑÑÑƒÑ€ÐµÐ¡Ð¸Ð³Ð½ ÐºÐ¾Ð½Ñ‚ÐµÐºÑÑ‚Ñƒ',0),(413469,11486,'vi','XÃ¡c nháº­n ngá»¯ cáº£nh kÃ½ cam Ä‘oan',0),(413470,11486,'af','AssureSign konteks identifiseerder',0),(413471,11486,'ro','AssureSign Context identificator',0),(413472,11486,'et','AssureSign konteksti ID.',0),(413473,11486,'si','Identifikator AssureSign kontekstu',0),(413474,11486,'ba','Pengenal konteks AssureSign',0),(413475,11486,'nl','AssureSign Context-id',0),(413476,11486,'fi','AssureSign yhteydessÃ¤ tunnus',0),(413477,11486,'no','AssureSign sammenheng identifikator',0),(413478,11486,'da','AssureSign kontekst-id',0),(413479,11486,'ko','AssureSign ì»¨í…ìŠ¤íŠ¸ ì‹ë³„ìž',0),(413480,11486,'he','×ž×–×”×” ×”×§×©×¨ AssureSign',0),(413481,11486,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ AssureSign Ï€Î»Î±Î¯ÏƒÎ¹Î¿',0),(413482,11486,'zh','ä¿è¯ä¸Šå†…å®¹è¯†ç¬¦\r\n',0),(413483,11486,'sv','AssureSign sammanhang identifierare',0),(413484,11486,'it','Identificatore di contesto AssureSign',0),(413485,11486,'tl','',0),(413486,11486,'th','à¸£à¸«à¸±à¸ªà¸šà¸£à¸´à¸šà¸— AssureSign',0),(413487,11486,'hi','AssureSign à¤ªà¥à¤°à¤¸à¤‚à¤— à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾',0),(413488,11486,'ms','AssureSign konteks pengenalpastian',0),(413489,11486,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ø³ÙŠØ§Ù‚ Ø£Ø³ÙˆØ±ÙŠØ³ÙŠØ¬Ù†',0),(413490,11486,'fr','Identificateur de contexte de AssureSign',0),(413491,11486,'jp','AssureSign ã‚³ãƒ³ãƒ†ã‚­ã‚¹ãƒˆè­˜åˆ¥å­',0),(413492,11486,'pt','Identificador de contexto de AssureSign',0),(413493,11486,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÐºÐ¾Ð½Ñ‚ÐµÐºÑÑ‚Ð° AssureSign',0),(413494,11486,'es','Identificador de Contexto AssureSign',0),(413495,11486,'de','AssureSign-ID',0),(413496,11486,'en','AssureSign Context Identifier',0),(413497,11487,'is','',0),(413498,11487,'dr','Ø§Ø² ØªÙ†Ø¸ÙŠÙ…Ø§Øª  Ø§Ù…Ø¶Ø§ Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÙŠØ¯',0),(413499,11487,'pr','Ø§Ø² ØªÙ†Ø¸ÙŠÙ…Ø§Øª  Ø§Ù…Ø¶Ø§ Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÙŠØ¯',0),(413500,11487,'tr','AssureSign kurulumu',0),(413501,11487,'pl','AssureSign instalacji',0),(413502,11487,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° AssureSign',0),(413503,11487,'ur','Ø§Ø³Ø³Ø±ÛŒØ³Ú¯Ù† Ø³ÛŒÙ¹ Ø§Ù¾',0),(413504,11487,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÐÑÑÑƒÑ€ÐµÐ¡Ð¸Ð³Ð½',0),(413505,11487,'vi','CÃ i Ä‘áº·t kÃ½ cam Ä‘oan',0),(413506,11487,'af','AssureSign Opstelling',0),(413507,11487,'ro','AssureSign instalare',0),(413508,11487,'et','AssureSign seadistamine',0),(413509,11487,'si','AssureSign nastavitev',0),(413510,11487,'ba','AssureSign Setup',0),(413511,11487,'nl','AssureSign Setup',0),(413512,11487,'fi','AssureSign asetukset',0),(413513,11487,'no','AssureSign oppsett',0),(413514,11487,'da','AssureSign opsÃ¦tning',0),(413515,11487,'ko','AssureSign ì„¤ì¹˜',0),(413516,11487,'he','×”×’×“×¨×ª AssureSign',0),(413517,11487,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ AssureSign',0),(413518,11487,'zh','ä¿è¯è®¾ç½®\r\n',0),(413519,11487,'sv','AssureSign instÃ¤llningar',0),(413520,11487,'it','AssureSign Setup',0),(413521,11487,'tl','',0),(413522,11487,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² AssureSign',0),(413523,11487,'hi','AssureSign à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(413524,11487,'ms','AssureSign persediaan',0),(413525,11487,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø£Ø³ÙˆØ±ÙŠØ³ÙŠØ¬Ù†',0),(413526,11487,'fr','Programme d\'installation AssureSign',0),(413527,11487,'jp','AssureSign ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(413528,11487,'pt','ConfiguraÃ§Ã£o de AssureSign',0),(413529,11487,'ru','AssureSign ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(413530,11487,'es','ConfiguraciÃ³n de AssureSign',0),(413531,11487,'de','AssureSign Setup',0),(413532,11487,'en','AssureSign Setup',0),(413533,11488,'is','',0),(413534,11488,'dr','Ø§Ø² Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø±Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÙŠØ¯',0),(413535,11488,'pr','Ø§Ø² Ø´Ù†Ø§Ø³Ù‡ ÙƒØ§Ø±Ø¨Ø±Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÙŠØ¯',0),(413536,11488,'tr','AssureSign kullanÄ±cÄ± kimliÄŸi',0),(413537,11488,'pl','Nazwa uÅ¼ytkownika AssureSign',0),(413538,11488,'bg','AssureSign Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(413539,11488,'ur','Ø§Ø³Ø³Ø±ÛŒØ³Ú¯Ù† ØµØ§Ø±Ù Ú©ÛŒ Ø¢Ø¦ÛŒ ÚˆÛŒ',0),(413540,11488,'sr','ÐÑÑÑƒÑ€ÐµÐ¡Ð¸Ð³Ð½ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸ Ð˜Ð”',0),(413541,11488,'vi','MÃ£ cam káº¿t cá»§a ngÆ°á»i sá»­ dá»¥ng',0),(413542,11488,'af','AssureSign Gebruiker ID',0),(413543,11488,'ro','ID-ul AssureSign',0),(413544,11488,'et','AssureSign kasutaja ID',0),(413545,11488,'si','ID uporabnika AssureSign',0),(413546,11488,'ba','ID pengguna AssureSign',0),(413547,11488,'nl','AssureSign gebruikersnaam',0),(413548,11488,'fi','AssureSign kÃ¤yttÃ¤jÃ¤tunnus',0),(413549,11488,'no','AssureSign bruker-ID',0),(413550,11488,'da','AssureSign bruger-ID',0),(413551,11488,'ko','AssureSign ì‚¬ìš©ìž ID',0),(413552,11488,'he','×ž×–×”×” ×”×ž×©×ª×ž×© AssureSign',0),(413553,11488,'el','ID Ï‡ÏÎ®ÏƒÏ„Î· AssureSign',0),(413554,11488,'zh','ä¿è¯ç”¨æˆ·ID\r\n',0),(413555,11488,'sv','AssureSign anvÃ¤ndar-ID',0),(413556,11488,'it','ID utente AssureSign',0),(413557,11488,'tl','',0),(413558,11488,'th','à¸£à¸«à¸±à¸ª AssureSign',0),(413559,11488,'hi','AssureSign à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ ID',0),(413560,11488,'ms','ID pengguna AssureSign',0),(413561,11488,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø£Ø³ÙˆØ±ÙŠØ³ÙŠØ¬Ù†',0),(413562,11488,'fr','ID de l\'utilisateur AssureSign',0),(413563,11488,'jp','AssureSign ãƒ¦ãƒ¼ã‚¶ãƒ¼ ID',0),(413564,11488,'pt','ID de usuÃ¡rio AssureSign',0),(413565,11488,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ AssureSign',0),(413566,11488,'es','ID de usuario AssureSign',0),(413567,11488,'de','AssureSign Benutzer-ID',0),(413568,11488,'en','AssureSign User ID',0),(413569,11489,'is','',0),(413570,11489,'dr','ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(413571,11489,'pr','ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(413572,11489,'tr','YapÄ±landÄ±rma baÅŸarÄ±yla gÃ¼ncellendi',0),(413573,11489,'pl','Konfiguracja pomyÅ›lnie zaktualizowana',0),(413574,11489,'bg','ÐšÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ñ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(413575,11489,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ ØªØ´Ú©ÛŒÙ„',0),(413576,11489,'sr','ÐšÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(413577,11489,'vi','Ä‘Ã£ cáº­p nháº­t cáº¥u hÃ¬nh thÃ nh cÃ´ng',0),(413578,11489,'af','Konfigurasie suksesvol bygewerk',0),(413579,11489,'ro','Configurare actualizat cu succes',0),(413580,11489,'et','Konfiguratsiooni vÃ¤rskendamine Ãµnnestus',0),(413581,11489,'si','UspeÃœno posodobljena',0),(413582,11489,'ba','Konfigurasi',0),(413583,11489,'nl','Configuratie bijgewerkt',0),(413584,11489,'fi','Kokoonpano pÃ¤ivitetty',0),(413585,11489,'no','Konfigurasjon oppdatert',0),(413586,11489,'da','Konfiguration succesfuldt opdateret',0),(413587,11489,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ êµ¬ì„±',0),(413588,11489,'he','×ª×¦×•×¨×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(413589,11489,'el','Î”Î¹Î±Î¼ÏŒÏÏ†Ï‰ÏƒÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(413590,11489,'zh','é…ç½®æ›´æ–°æˆåŠŸ\r\n',0),(413591,11489,'sv','Konfigurationen uppdaterades',0),(413592,11489,'it','Configurazione aggiornata correttamente',0),(413593,11489,'tl','',0),(413594,11489,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸„à¸­à¸™à¸Ÿà¸´à¸à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(413595,11489,'hi','à¤•à¥‰à¤¨à¥à¤«à¤¼à¤¿à¤—à¤°à¥‡à¤¶à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(413596,11489,'ms','Konfigurasi berjaya dikemas kini',0),(413597,11489,'ar','Ø§Ù„ØªÙƒÙˆÙŠÙ† Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(413598,11489,'fr','Configuration, mise Ã  jour avec succÃ¨s',0),(413599,11489,'jp','æ§‹æˆãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(413600,11489,'pt','ConfiguraÃ§Ã£o atualizada com sucesso',0),(413601,11489,'ru','ÐšÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(413602,11489,'es','ConfiguraciÃ³n Actualizado Exitosamente',0),(413603,11489,'de','Konfiguration erfolgreich aktualisiert',0),(413604,11489,'en','Configuration Updated Successfully',0),(413605,11490,'is','',0),(413606,11490,'dr','Ø¢Ø®Ø±ÙŠÙ† ØªØ°ÙƒØ± Ù†Ù‡Ø§ÙŠÙŠ ',0),(413607,11490,'pr','Ø¢Ø®Ø±ÙŠÙ† ØªØ°ÙƒØ± Ù†Ù‡Ø§ÙŠÙŠ ',0),(413608,11490,'tr','Son geÃ§ haber',0),(413609,11490,'pl','Ostateczny koniec ogÅ‚oszenia',0),(413610,11490,'bg','ÐšÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° ÐºÑŠÑÐ½Ð¾ Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(413611,11490,'ur','Ù…Ø±Ø­ÙˆÙ… Ú©Û’ Ø­ØªÙ…ÛŒ Ù†ÙˆÙ¹Ø³',0),(413612,11490,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð¸ Ð¿Ð¾Ð¼Ð°Ð»Ð¾ ÐºÐ°ÑÐ½Ð¾',0),(413613,11490,'vi','ghi chÃº cuá»‘i cÃ¹ng ',0),(413614,11490,'af','Finale laat kennisgewing',0),(413615,11490,'ro','Notificare tÃ¢rziu finalÄƒ',0),(413616,11490,'et','LÃµplik hilise teatamisega',0),(413617,11490,'si','KonÄni pozno obvestilo',0),(413618,11490,'ba','Akhir Final Notice',0),(413619,11490,'nl','Laat Final Notice',0),(413620,11490,'fi','Lopullinen myÃ¶hÃ¤Ã¤n Huomautus',0),(413621,11490,'no','Siste sen notis',0),(413622,11490,'da','Endelig sent varsel',0),(413623,11490,'ko','ë§ˆì§€ë§‰ í›„ë°˜ í†µì§€',0),(413624,11490,'he','×”×•×“×¢×” ×ž××•×—×¨×ª ×”×¡×•×¤×™',0),(413625,11490,'el','Î¤ÎµÎ»Î¹ÎºÎ® Î±Î½Î±ÎºÎ¿Î¯Î½Ï‰ÏƒÎ· Î±ÏÎ³Î¬',0),(413626,11490,'zh','æœ€åŽé€šçŸ¥\r\n',0),(413627,11490,'sv','Sista sent varsel',0),(413628,11490,'it','Avviso fine finale',0),(413629,11490,'tl','',0),(413630,11490,'th','à¸ªà¸±à¸‡à¹€à¸à¸•à¸›à¸¥à¸²à¸¢à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(413631,11490,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¦à¥‡à¤° à¤¸à¥‡ à¤¸à¥‚à¤šà¤¨à¤¾',0),(413632,11490,'ms','Notis akhir akhir',0),(413633,11490,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø±Ø§Ø­Ù„ Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ',0),(413634,11490,'fr','Dernier avis tardif',0),(413635,11490,'jp','æœ€çµ‚å¾ŒåŠã«é€šçŸ¥',0),(413636,11490,'pt','Aviso final de tarde',0),(413637,11490,'ru','Ð—Ð°ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð¿Ð¾Ð·Ð´Ð½ÐµÐ³Ð¾ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(413638,11490,'es','NotificaciÃ³n de Retraso Final',0),(413639,11490,'de','Letzte spÃ¤t Mahnung',0),(413640,11490,'en','Final Late Notice',0),(413641,11491,'is','',0),(413642,11491,'dr','Ø§ÙˆÙ„  Ø¢Ø®Ø±ÙŠÙ† Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡',0),(413643,11491,'pr','Ø§ÙˆÙ„  Ø¢Ø®Ø±ÙŠÙ† Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡',0),(413644,11491,'tr','Ä°lk geÃ§ haber',0),(413645,11491,'pl','Pierwszy koniec ogÅ‚oszenia',0),(413646,11491,'bg','ÐŸÑŠÑ€Ð²Ð°Ñ‚Ð° ÐºÑ€Ð°Ñ Ð½Ð° Ð¿Ñ€ÐµÐ´Ð¸Ð·Ð²ÐµÑÑ‚Ð¸ÐµÑ‚Ð¾',0),(413647,11491,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ù…Ø±Ø­ÙˆÙ… Ù†ÙˆÙ¹Ø³',0),(413648,11491,'sr','ÐŸÑ€Ð²Ð¸ Ð¿Ð¾Ð¼Ð°Ð»Ð¾ ÐºÐ°ÑÐ½Ð¾',0),(413649,11491,'vi','ghi chÃº Ä‘áº§u tiÃªn ',0),(413650,11491,'af','Eerste laat kennisgewing',0),(413651,11491,'ro','Primul anunÅ£ tÃ¢rziu',0),(413652,11491,'et','Esimene hilise teatamisega',0),(413653,11491,'si','Prvi pozno obvestilo',0),(413654,11491,'ba','Pemberitahuan terlambat pertama',0),(413655,11491,'nl','Eerste laat mededeling',0),(413656,11491,'fi','EnsimmÃ¤inen myÃ¶hÃ¤Ã¤n Huomautus',0),(413657,11491,'no','FÃ¸rste sen notis',0),(413658,11491,'da','FÃ¸rst sent varsel',0),(413659,11491,'ko','ë¨¼ì € ëŠ¦ê²Œ í†µë³´',0),(413660,11491,'he','×”×•×“×¢×” ×ž××•×—×¨×ª ×”×¨××©×•×Ÿ',0),(413661,11491,'el','ÎšÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ®ÏƒÎµÎ¹Ï‚ ÏƒÏ„Î·Î½ Ï€ÏÏŽÏ„Î· Ï€ÏÎ¿ÎºÎ®ÏÏ…Î¾Î·',0),(413662,11491,'zh','ç¬¬ä¸€é€šçŸ¥\r\n',0),(413663,11491,'sv','FÃ¶rsta sent varsel',0),(413664,11491,'it','Primo avviso fine',0),(413665,11491,'tl','',0),(413666,11491,'th','à¸›à¸£à¸°à¸à¸²à¸¨à¸ªà¸²à¸¢à¹à¸£à¸',0),(413667,11491,'hi','à¤ªà¤¹à¤²à¥€ à¤¦à¥‡à¤° à¤¨à¥‹à¤Ÿà¤¿à¤¸',0),(413668,11491,'ms','Notis akhir pertama',0),(413669,11491,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø±Ø§Ø­Ù„ Ø§Ù„Ø£ÙˆÙ„',0),(413670,11491,'fr','Premier avis tardif',0),(413671,11491,'jp','å¾ŒåŠã®æœ€åˆã®é€šçŸ¥',0),(413672,11491,'pt','Primeira hora',0),(413673,11491,'ru','ÐŸÐµÑ€Ð²Ñ‹Ð¹ Ð¿Ð¾Ð·Ð´Ð½ÐµÐ³Ð¾ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(413674,11491,'es','NotificaciÃ³n Primera de Tardanza',0),(413675,11491,'de','Erste spÃ¤te Mitteilung',0),(413676,11491,'en','First Late Notice',0),(413677,11492,'is','',0),(413678,11492,'dr','Ø¶Ø§Ù…Ù† Ø§Ø·Ù„Ø§Ø¹ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯ ',0),(413679,11492,'pr','Ø¶Ø§Ù…Ù† Ø§Ø·Ù„Ø§Ø¹ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯ ',0),(413680,11492,'tr','GarantÃ¶r haberdar',0),(413681,11492,'pl','Gwarant zgÅ‚oszone',0),(413682,11492,'bg','Ð“Ð°Ñ€Ð°Ð½Ñ‚ Ð½Ð¾Ñ‚Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð¾',0),(413683,11492,'ur','Ø¶Ø§Ù…Ù† Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹ Ø¯ÛŒ Ø¬Ø§Ø¦Û’ Ú¯ÛŒ',0),(413684,11492,'sr','Ð“Ð°Ñ€Ð°Ð½Ñ‚ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÐ½Ð¸',0),(413685,11492,'vi','thÃ´ng bÃ¡o báº£o hÃ nh',0),(413686,11492,'af','Borg in kennis gestel',0),(413687,11492,'ro','Garant notificate',0),(413688,11492,'et','KÃ¤endajale teatanud',0),(413689,11492,'si','Garant notificirano',0),(413690,11492,'ba','Penjamin diberitahu',0),(413691,11492,'nl','Borg kennisgeving',0),(413692,11492,'fi','Takaajan tiedoksi',0),(413693,11492,'no','Garantist varslet',0),(413694,11492,'da','Garant anmeldt',0),(413695,11492,'ko','ë³´ì¦ì¸ í†µë³´',0),(413696,11492,'he','×¢×¨×‘ ×”×•×“×¢×”',0),(413697,11492,'el','Î•Î³Î³Ï…Î·Ï„Î®Ï‚ ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ÏƒÎ±',0),(413698,11492,'zh','æ‹…ä¿äººå…¬å‘Š\r\n',0),(413699,11492,'sv','Garant anmÃ¤lda',0),(413700,11492,'it','Garante notificato',0),(413701,11492,'tl','',0),(413702,11492,'th','à¸œà¸¹à¹‰à¸„à¹‰à¸³à¸›à¸£à¸°à¸à¸±à¸™à¸—à¸£à¸²à¸š',0),(413703,11492,'hi','à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¿à¤¤ à¤—à¤¾à¤°à¤‚à¤Ÿà¤°',0),(413704,11492,'ms','Penjamin yang diberitahu',0),(413705,11492,'ar','Ø¥Ø®Ø·Ø§Ø± Ø§Ù„ÙƒÙÙŠÙ„',0),(413706,11492,'fr','Garant notifiÃ©e',0),(413707,11492,'jp','é€£å¸¯ä¿è¨¼äººé€šçŸ¥',0),(413708,11492,'pt','Fiador notificado',0),(413709,11492,'ru','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð°',0),(413710,11492,'es','Guarantor Notificado',0),(413711,11492,'de','Garant benachrichtigt',0),(413712,11492,'en','Guarantor Notified',0),(413713,11493,'is','',0),(413714,11493,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø®ÙŠØ± Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(413715,11493,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø§Ø®ÙŠØ± Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(413716,11493,'tr','Gecikme bedeli eklendi',0),(413717,11493,'pl','Dodatkowa opÅ‚ata za pÃ³Åºne dodane',0),(413718,11493,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° ÐºÑŠÑÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ñ',0),(413719,11493,'ur','Ù†Û’ Ù…Ø²ÛŒØ¯ Ú©ÛØ§ Ú©Û Ø¯ÛŒØ± ÙÛŒØ³',0),(413720,11493,'sr','ÐžÐ¿Ð¾Ð¼ÐµÐ½Ð° Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð¾',0),(413721,11493,'vi','thÃªm phÃ­ cháº­m',0),(413722,11493,'af','Laat fooi bygevoeg',0),(413723,11493,'ro','TaxÄƒ de Ã®ntÃ¢rziere a adÄƒugat',0),(413724,11493,'et','Lisatakse viivis',0),(413725,11493,'si','Pozno pristojbine, doda',0),(413726,11493,'ba','Keterlambatan ditambahkan',0),(413727,11493,'nl','Te late betaling toegevoegd',0),(413728,11493,'fi','LisÃ¤tÃ¤Ã¤n viivÃ¤styskorko',0),(413729,11493,'no','Forsinkelsesavgift lagt',0),(413730,11493,'da','Sen gebyr tilfÃ¸jet',0),(413731,11493,'ko','ì—°ì²´ ë£Œ ì¶”ê°€',0),(413732,11493,'he','××™×—×•×¨ × ×•×¡×£',0),(413733,11493,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Î±Î¼Î¿Î¹Î²Î® Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯',0),(413734,11493,'zh','æ–°å¢žæ»žçº³é‡‘\r\n',0),(413735,11493,'sv','Avgift fÃ¶r sen lagt till',0),(413736,11493,'it','Canone tardo aggiunto',0),(413737,11493,'tl','',0),(413738,11493,'th','à¸šà¸§à¸à¹€à¸žà¸´à¹ˆà¸¡',0),(413739,11493,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤¶à¥à¤²à¥à¤•',0),(413740,11493,'ms','Yuran lewat yang ditambah',0),(413741,11493,'ar','Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ù…ØªØ£Ø®Ø±Ø© ÙˆØ£Ø¶Ø§Ù',0),(413742,11493,'fr','Frais de retard ajoutÃ©',0),(413743,11493,'jp','ãƒ¬ã‚¤ãƒˆãŒè¿½åŠ ',0),(413744,11493,'pt','Taxa de atraso adicionada',0),(413745,11493,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ð·Ð´Ð½Ð¸Ð¹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ð»',0),(413746,11493,'es','Cuota de Tardanza Agregada',0),(413747,11493,'de','GebÃ¼hr fÃ¼r verspÃ¤tete hinzugefÃ¼gt',0),(413748,11493,'en','Late Fee Added',0),(413749,11494,'is','',0),(413750,11494,'dr','Ø§Ø·Ù„Ø§Ø¹ÙŠÙ‡ Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ',0),(413751,11494,'pr','Ø§Ø·Ù„Ø§Ø¹ÙŠÙ‡ Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯ ',0),(413752,11494,'tr','GeÃ§ bildirimleri baÅŸarÄ±yla gÃ¶nderildi',0),(413753,11494,'pl','Koniec ogÅ‚oszenia wysÅ‚ane pomyÅ›lnie',0),(413754,11494,'bg','ÐšÑŠÑÐ½Ð¾ Ð¾Ð±ÑÐ²Ð»ÐµÐ½Ð¸ÑÑ‚Ð°, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(413755,11494,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ú¾ÛŒØ¬ÛŒ Ù…Ø±Ø­ÙˆÙ… Ù†ÙˆÙ¹Ø³',0),(413756,11494,'sr','ÐžÐ¿Ð¾Ð¼ÐµÐ½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ð¾ÑÐ»Ð°Ñ‚',0),(413757,11494,'vi','chÃº Ã½ muá»™n Ä‘Ã£ gá»­i thÃ nh cÃ´ng',0),(413758,11494,'af','Geen laat kennisgewings gestuur suksesvol',0),(413759,11494,'ro','TÃ¢rziu anunÈ›urile trimise cu succes',0),(413760,11494,'et','Hilja teadete saatmine Ãµnnestus',0),(413761,11494,'si','Poznega obvestila poslan',0),(413762,11494,'ba','Pemberitahuan terlambat berhasil dikirim',0),(413763,11494,'nl','Laat aankondigingen verzonden',0),(413764,11494,'fi','MyÃ¶hÃ¤Ã¤n ilmoitukset lÃ¤hetetty onnistuneesti',0),(413765,11494,'no','Sent varsel sendt',0),(413766,11494,'da','Sent bekendtgÃ¸relser sendt',0),(413767,11494,'ko','ëŠ¦ì€ ê³  ì‹œ ì„±ê³µì ìœ¼ë¡œ ì „ì†¡',0),(413768,11494,'he','×”×•×“×¢×•×ª ××™×—×•×¨ × ×©×œ×—×” ×‘×”×¦×œ×—×”',0),(413769,11494,'el','Î¤Î­Î»Î· Î±Î½Î±ÎºÎ¿Î¹Î½ÏŽÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(413770,11494,'zh','é€¾æœŸé€šçŸ¥å‘é€æˆåŠŸ\r\n',0),(413771,11494,'sv','Sen meddelanden skickats',0),(413772,11494,'it','Tardi avvisi inviati con successo',0),(413773,11494,'tl','',0),(413774,11494,'th','à¸›à¸£à¸°à¸à¸²à¸¨à¸ªà¸²à¸¢à¸ªà¹ˆà¸‡à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(413775,11494,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¨à¥‹à¤Ÿà¤¿à¤¸',0),(413776,11494,'ms','Notis-notis yang lewat dihantar berjaya',0),(413777,11494,'ar','Ø£ÙˆØ§Ø®Ø± Ø§Ù„Ø¥Ø´Ø¹Ø§Ø±Ø§Øª Ø§Ù„Ù…Ø±Ø³Ù„Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(413778,11494,'fr','Avis tardif envoyÃ©s avec succÃ¨s',0),(413779,11494,'jp','æ­£å¸¸ã«é€ä¿¡ã•ã‚ŒãŸå¾ŒåŠã«é€šçŸ¥',0),(413780,11494,'pt','Tarde anÃºncios enviados com sucesso',0),(413781,11494,'ru','ÐšÐ¾Ð½Ñ†Ðµ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(413782,11494,'es','NotificaciÃ³n de Retraso Enviada Exitosamente',0),(413783,11494,'de','SpÃ¤ten Bekanntmachungen erfolgreich',0),(413784,11494,'en','Late Notices Sent Successfully',0),(413785,11495,'is','',0),(413786,11495,'dr','Ø¬Ø²Ø¦ÙŠØ§Øª ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø± Ø§Ø¬Ø§Ø±Ù‡ ',0),(413787,11495,'pr','Ø¬Ø²Ø¦ÙŠØ§Øª ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø®ÙˆØ¯ÙƒØ§Ø± Ø§Ø¬Ø§Ø±Ù‡ ',0),(413788,11495,'tr','Kira otomatik fatura detaylarÄ±',0),(413789,11495,'pl','SzczegÃ³Å‚y pÅ‚atnoÅ›ci Auto leasing',0),(413790,11495,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(413791,11495,'ur','Ù„ÛŒØ² Ø®ÙˆØ¯ Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(413792,11495,'sr','ÐÐ°Ñ˜Ð°Ð¼ ÐÑƒÑ‚Ð¾ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(413793,11495,'vi','chi tiáº¿t hÃ³a Ä‘Æ¡n cho thuÃª tá»± Ä‘á»™ng',0),(413794,11495,'af','Huurkontrak Outo fakturering besonderhede',0),(413795,11495,'ro','Detalii de facturare leasing Auto',0),(413796,11495,'et','Rendi Auto arved andmed',0),(413797,11495,'si','Najem avto zaraÄunavanje podrobnosti',0),(413798,11495,'ba','Sewa mobil penagihan rincian',0),(413799,11495,'nl','Lease Auto facturering Details',0),(413800,11495,'fi','Vuokra Auto laskutuksen tiedot',0),(413801,11495,'no','Leieavtalen Auto faktureringsinformasjon',0),(413802,11495,'da','LejemÃ¥let automatisk fakturering detaljer',0),(413803,11495,'ko','ìž„ëŒ€ ìžë™ ê²°ì œ ì„¸ë¶€ ì •ë³´',0),(413804,11495,'he','×¤×¨×˜×™ ×—×™×•×‘ ××•×˜×•×ž×˜×™ ×—×›×™×¨×”',0),(413805,11495,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Auto Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(413806,11495,'zh','ç§Ÿèµè‡ªåŠ¨ç»“ç®—æ˜Žç»†\r\n',0),(413807,11495,'sv','Hyresavtalet Auto fakturering Detaljer',0),(413808,11495,'it','Dettagli di fatturazione Auto Leasing',0),(413809,11495,'tl','',0),(413810,11495,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹€à¸Šà¹ˆà¸²à¸£à¸–à¸¢à¸™à¸•à¹Œà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(413811,11495,'hi','à¤²à¥€à¤œ à¤‘à¤Ÿà¥‹ à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤µà¤¿à¤µà¤°à¤£',0),(413812,11495,'ms','Butir-butir bil Auto pajakan',0),(413813,11495,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª ØªÙØ§ØµÙŠÙ„ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(413814,11495,'fr','Location Auto facturation dÃ©tails',0),(413815,11495,'jp','ãƒªãƒ¼ã‚¹ã®è‡ªå‹•èª²é‡‘ã®è©³ç´°',0),(413816,11495,'pt','LocaÃ§Ã£o de Auto facturaÃ§Ã£o detalhes',0),(413817,11495,'ru','Ð‘Ð¸Ð»Ð»Ð¸Ð½Ð³ Ð´ÐµÑ‚Ð°Ð»Ð¸ Ð°Ñ€ÐµÐ½Ð´Ñ‹ Ð°Ð²Ñ‚Ð¾',0),(413818,11495,'es','Detalles de Arrendamiento Auto FacturaciÃ³n',0),(413819,11495,'de','Leasing Auto Rechnungsdaten',0),(413820,11495,'en','Lease Auto Billing Details',0),(413821,11496,'is','',0),(413822,11496,'dr','(Ø§Ø®Ø·Ø§Ø±',0),(413823,11496,'pr','Ø¯ÙˆÙ…ÙŠÙ† Ø¢Ø®Ø±ÙŠÙ†  ØªÙˆØ¬Ù‡(Ø§Ø®Ø·Ø§Ø±',0),(413824,11496,'tr','Ä°kinci geÃ§ haber',0),(413825,11496,'pl','Drugi koniec ogÅ‚oszenia',0),(413826,11496,'bg','Ð’Ñ‚Ð¾Ñ€Ð¸ ÐºÑ€Ð°Ñ Ð½Ð° Ð¿Ñ€ÐµÐ´Ð¸Ð·Ð²ÐµÑÑ‚Ð¸ÐµÑ‚Ð¾',0),(413827,11496,'ur','Ø¯ÙˆØ³Ø±Ø§ Ù…Ø±Ø­ÙˆÙ… Ù†ÙˆÙ¹Ø³',0),(413828,11496,'sr','Ð”Ñ€ÑƒÐ³Ð¸ Ð¿Ð¾Ð¼Ð°Ð»Ð¾ ÐºÐ°ÑÐ½Ð¾',0),(413829,11496,'vi','LÆ°u Ã½ trá»… láº§n 2',0),(413830,11496,'af','Tweede laat kennisgewing',0),(413831,11496,'ro','Al doilea anunÅ£ tÃ¢rziu',0),(413832,11496,'et','Teine hilise teatamisega',0),(413833,11496,'si','Drugi pozno obvestilo',0),(413834,11496,'ba','Kedua akhir pemberitahuan',0),(413835,11496,'nl','Tweede laat aankondiging',0),(413836,11496,'fi','Toinen myÃ¶hÃ¤Ã¤n Huomautus',0),(413837,11496,'no','Andre sen notis',0),(413838,11496,'da','Anden sene varsel',0),(413839,11496,'ko','ë‘ ë²ˆì§¸ ëŠ¦ì€ ê³µì§€',0),(413840,11496,'he','×”×•×“×¢×” ×ž××•×—×¨×ª ×”×©× ×™',0),(413841,11496,'el','Î”ÎµÏÏ„ÎµÏÎ· ÎºÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ·Î¼Î­Î½Î·Ï‚ ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚',0),(413842,11496,'zh','ç¬¬äºŒè¿Ÿåˆ°é€šçŸ¥\r\n',0),(413843,11496,'sv','Andra sent varsel',0),(413844,11496,'it','Secondo avviso fine',0),(413845,11496,'tl','',0),(413846,11496,'th','à¸›à¸£à¸°à¸à¸²à¸¨à¸ªà¸­à¸‡à¸ªà¸²à¸¢',0),(413847,11496,'hi','à¤¦à¥‚à¤¸à¤°à¤¾ à¤¦à¥‡à¤° à¤¨à¥‹à¤Ÿà¤¿à¤¸',0),(413848,11496,'ms','Notis akhir yang kedua',0),(413849,11496,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø±Ø§Ø­Ù„ Ø§Ù„Ø«Ø§Ù†ÙŠØ©',0),(413850,11496,'fr','DeuxiÃ¨me avis tardif',0),(413851,11496,'jp','2 ã¤ç›®ä»¥é™ã®é€šçŸ¥',0),(413852,11496,'pt','Segundo aviso final',0),(413853,11496,'ru','Ð’Ñ‚Ð¾Ñ€Ð¾Ð¹ Ð¿Ð¾Ð·Ð´Ð½ÐµÐ³Ð¾ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(413854,11496,'es','Segunda NotificaciÃ³n de Pago Atrasado',0),(413855,11496,'de','Zweiten spÃ¤ten AnkÃ¼ndigung',0),(413856,11496,'en','Second Late Notice',0),(413857,11497,'is','',0),(413858,11497,'dr','Ø­Ø°Ù Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(413859,11497,'pr','Ø­Ø°Ù Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(413860,11497,'tr','Ã–zellik Sil',0),(413861,11497,'pl','UsuÅ„ WÅ‚aÅ›ciwoÅ›Ä‡',0),(413862,11497,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(413863,11497,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(413864,11497,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð°',0),(413865,11497,'vi','XÃ³a tÃ i sáº£n',0),(413866,11497,'af','Skrap eiendom',0),(413867,11497,'ro','ÅžtergeÅ£i proprietatea',0),(413868,11497,'et','Kustuta atribuut',0),(413869,11497,'si','Izbrisati lastnost',0),(413870,11497,'ba','Menghapus properti',0),(413871,11497,'nl','Eigenschap verwijderen',0),(413872,11497,'fi','Ominaisuuden poistaminen',0),(413873,11497,'no','Slette egenskapen',0),(413874,11497,'da','Slet egenskab',0),(413875,11497,'ko','ì†ì„± ì‚­ì œ',0),(413876,11497,'he','×ž××¤×™×™×Ÿ ×ž×—×§',0),(413877,11497,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±ÎºÎ¹Î½Î®Ï„Î¿Ï…',0),(413878,11497,'zh','åˆ é™¤å±žæ€§\r\n',0),(413879,11497,'sv','Ta bort egenskapen',0),(413880,11497,'it','Eliminare la proprietÃ .',0),(413881,11497,'tl','',0),(413882,11497,'th','à¸¥à¸šà¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(413883,11497,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(413884,11497,'ms','Menghapuskan harta',0),(413885,11497,'ar','Ø­Ø°Ù Ø®Ø§ØµÙŠØ©',0),(413886,11497,'fr','Supprimer la propriÃ©tÃ©',0),(413887,11497,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(413888,11497,'pt','Excluir Propriedade',0),(413889,11497,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(413890,11497,'es','Eliminar Propiedad',0),(413891,11497,'de','Eigenschaft lÃ¶schen',0),(413892,11497,'en','Delete Property',0),(413893,11498,'is','',0),(413894,11498,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø³Ù†Ø¯ ØªØ§ Ø§Ù†Ù‚Ø¶Ø§',0),(413895,11498,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø³Ù†Ø¯ ØªØ§ Ø§Ù†Ù‚Ø¶Ø§',0),(413896,11498,'tr','Belge gÃ¼n iÃ§in sÃ¼re sonu',0),(413897,11498,'pl','Dokument dni do wygaÅ›niÄ™cia',0),(413898,11498,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð´Ð½Ð¸ Ð´Ð¾ Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° ÑÑ€Ð¾ÐºÐ°',0),(413899,11498,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Û’ Ø¯Ù† Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(413900,11498,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð´Ð°Ð½Ð° Ð´Ð¾ Ð¸ÑÑ‚ÐµÐºÐ°',0),(413901,11498,'vi','TÃ i liá»‡u ngÃ y Ä‘á»ƒ háº¿t háº¡n',0),(413902,11498,'af','Dokument dae na verstryking',0),(413903,11498,'ro','Documentul de zile de expirare',0),(413904,11498,'et','Dokumendi pÃ¤eva mÃ¶Ã¶dumist',0),(413905,11498,'si','Dokument dni do poteka',0),(413906,11498,'ba','Dokumen hari kadaluarsa',0),(413907,11498,'nl','Document dagen tot aan het vervallen',0),(413908,11498,'fi','Asiakirjan pÃ¤ivÃ¤Ã¤ kulunut',0),(413909,11498,'no','Dokumentet dager utlÃ¸per',0),(413910,11498,'da','Dokument dage til udlÃ¸b',0),(413911,11498,'ko','ë¬¸ì„œ ì¼ ë§Œë£Œ',0),(413912,11498,'he','×”×ž×¡×ž×š ×™×ž×™× ×•×¢×“ ×œ×ª×¤×•×’×”',0),(413913,11498,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Î·Î¼Î­ÏÎµÏ‚ Î¼Î­Ï‡ÏÎ¹ Ï„Î· Î»Î®Î¾Î·',0),(413914,11498,'zh','æ–‡ä»¶åˆ°æœŸæ—¥å‰çš„æ—¶é—´\r\n',0),(413915,11498,'sv','Dokumentet dagar till utgÃ¥ngen',0),(413916,11498,'it','Documento giorni alla scadenza',0),(413917,11498,'tl','',0),(413918,11498,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¹€à¸­à¸à¸ªà¸²à¸£à¸ˆà¸°à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(413919,11498,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤¿à¤¨',0),(413920,11498,'ms','Hari dokumen untuk tamat',0),(413921,11498,'ar','Ø£ÙŠØ§Ù… Ø§Ù„ÙˆØ«ÙŠÙ‚Ø© Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØµÙ„Ø§Ø­ÙŠØ©',0),(413922,11498,'fr','Document jours expiration',0),(413923,11498,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã®æœ‰åŠ¹æœŸé™æ—¥',0),(413924,11498,'pt','Documento dias para expiraÃ§Ã£o',0),(413925,11498,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð´Ð½ÐµÐ¹ Ð´Ð¾ Ð¸ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ñ ÑÑ€Ð¾ÐºÐ° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(413926,11498,'es','DÃ­as Hasta Vencimiento de Documento',0),(413927,11498,'de','Dokument Tage bis zum Ablauf',0),(413928,11498,'en','Document Days To Expiration',0),(413929,11499,'is','',0),(413930,11499,'dr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¢Ø®Ø±ÙŠÙ† ØªØ°ÙƒØ± Ù†Ù‡Ø§ÙŠÙŠ ',0),(413931,11499,'pr','Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¢Ø®Ø±ÙŠÙ† ØªØ°ÙƒØ± Ù†Ù‡Ø§ÙŠÙŠ ',0),(413932,11499,'tr','Son geÃ§ duyuru gÃ¼n',0),(413933,11499,'pl','Ostateczny koniec dni wypowiedzenia',0),(413934,11499,'bg','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»Ð½Ð¾ ÐºÑŠÑÐ½Ð¾ Ð´Ð½Ð¸ Ð¿Ñ€ÐµÐ´Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(413935,11499,'ur','Ø¢Ø®Ø±ÛŒ Ù…Ø±Ø­ÙˆÙ… Ù†ÙˆÙ¹Ø³ Ø§ÛŒØ§Ù…',0),(413936,11499,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð¸ ÐºÑ€Ð°Ñ˜ÐµÐ¼ Ð´Ð°Ð½Ð° Ð½Ð°Ñ˜Ð°Ð²Ðµ',0),(413937,11499,'vi','NgÃ y thÃ´ng bÃ¡o cuá»‘i cÃ¹ng cuá»‘i',0),(413938,11499,'af','Finale laat kennisgewing dae',0),(413939,11499,'ro','Ultimele zile de preaviz tÃ¢rziu',0),(413940,11499,'et','LÃµplik hilinenud teade pÃ¤eva',0),(413941,11499,'si','KonÄno konec dni obvestilo',0),(413942,11499,'ba','Akhir akhir hari pemberitahuan',0),(413943,11499,'nl','Laatste Late aankondiging dagen',0),(413944,11499,'fi','MyÃ¶hÃ¤Ã¤n ilmoituksen voimassaolo',0),(413945,11499,'no','Borgermester sent varsel',0),(413946,11499,'da','Endelig sent varsel dage',0),(413947,11499,'ko','ë§ˆì§€ë§‰ í›„ë°˜ í†µì§€ ì¼',0),(413948,11499,'he','×”×™×ž×™× ×”××—×¨×•× ×™× ×”×•×“×¢×” ×ž××•×—×¨×ª',0),(413949,11499,'el','Î¤ÎµÎ»Î¹ÎºÎ® Ï„Î­Î»Î· ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î·Î¼Î­ÏÎµÏ‚',0),(413950,11499,'zh','æœ€åŽé€šçŸ¥åŽæ™š\r\n',0),(413951,11499,'sv','Sista sent varsel dagar',0),(413952,11499,'it','Giorni di preavviso fine finale',0),(413953,11499,'tl','',0),(413954,11499,'th','à¸§à¸±à¸™à¸›à¸£à¸°à¸à¸²à¸¨à¸›à¸¥à¸²à¸¢à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(413955,11499,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¦à¥‡à¤° à¤¨à¥‹à¤Ÿà¤¿à¤¸ à¤¦à¤¿à¤¨à¥‹à¤‚',0),(413956,11499,'ms','Hari-hari notis akhir yang akhir',0),(413957,11499,'ar','Ø§Ù„Ø£ÙŠØ§Ù… Ø§Ù„Ø£Ø®ÙŠØ±Ø© Ù…Ù† Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø±Ø§Ø­Ù„',0),(413958,11499,'fr','Derniers jours d\'avis tardif',0),(413959,11499,'jp','é…ã„é€šçŸ¥ã®æœ€çµ‚çš„ãªæ—¥',0),(413960,11499,'pt','Ãšltimos dias de aviso final',0),(413961,11499,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð´Ð½Ð¸ Ð¿Ð¾Ð·Ð´Ð½ÐµÐ³Ð¾ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(413962,11499,'es','DÃ­as de NotificaciÃ³n de Retraso Final',0),(413963,11499,'de','Letzten Ende Hinweis-Tage',0),(413964,11499,'en','Final Late Notice Days',0),(413965,11500,'is','',0),(413966,11500,'dr','Ø§ÙˆÙ„ Ø¯ÙˆØ±Ù‡ Ø¢Ø®Ø±ÙŠÙ† Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡',0),(413967,11500,'pr','Ø§ÙˆÙ„ Ø¯ÙˆØ±Ù‡ Ø¢Ø®Ø±ÙŠÙ† Ø§Ø¹Ù„Ø§Ù…ÙŠÙ‡',0),(413968,11500,'tr','Ä°lk geÃ§ duyuru gÃ¼n',0),(413969,11500,'pl','Pierwsze dni koniec ogÅ‚oszenia',0),(413970,11500,'bg','ÐŸÑŠÑ€Ð²Ð¸Ñ‚Ðµ ÐºÑŠÑÐ½Ð¾ Ð´Ð½Ð¸ Ð¿Ñ€ÐµÐ´Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(413971,11500,'ur','Ù¾ÛÙ„Û’ Ù…Ø±Ø­ÙˆÙ… Ù†ÙˆÙ¹Ø³ Ø¯Ù† ØªÚ©',0),(413972,11500,'sr','ÐŸÑ€Ð²Ð¸ ÐºÑ€Ð°Ñ˜ÐµÐ¼ Ð´Ð°Ð½Ð° Ð½Ð°Ñ˜Ð°Ð²Ðµ',0),(413973,11500,'vi','NgÃ y thÃ´ng bÃ¡o Ä‘áº§u tiÃªn cuá»‘i',0),(413974,11500,'af','Eerste laat kennisgewing dae',0),(413975,11500,'ro','Primele zile de preaviz tÃ¢rziu',0),(413976,11500,'et','Esimene hilinenud teade pÃ¤eva',0),(413977,11500,'si','Prvi pozno obvestilo dni',0),(413978,11500,'ba','Hari pemberitahuan terlambat pertama',0),(413979,11500,'nl','Eerste laat aankondiging dagen',0),(413980,11500,'fi','MyÃ¶hÃ¤inen ilmoitus alkupÃ¤ivinÃ¤',0),(413981,11500,'no','FÃ¸rste sent varsel dager',0),(413982,11500,'da','FÃ¸rst sent varsel dage',0),(413983,11500,'ko','ë¨¼ì € ëŠ¦ê²Œ í†µë³´ ì¼',0),(413984,11500,'he','×”×™×ž×™× ×”×¨××©×•× ×™× ×”×•×“×¢×” ×ž××•×—×¨×ª',0),(413985,11500,'el','Î ÏÏŽÏ„Î· Ï„Î­Î»Î· ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î·Î¼Î­ÏÎµÏ‚',0),(413986,11500,'zh','é€šçŸ¥åŽç¬¬ä¸€æ™š\r\n',0),(413987,11500,'sv','FÃ¶rsta sent varsel dagar',0),(413988,11500,'it','Primi giorni di preavviso fine',0),(413989,11500,'tl','',0),(413990,11500,'th','à¸§à¸±à¸™à¸›à¸£à¸°à¸à¸²à¸¨à¸ªà¸²à¸¢à¹à¸£à¸',0),(413991,11500,'hi','à¤ªà¤¹à¤²à¥‡ à¤¦à¥‡à¤° à¤¨à¥‹à¤Ÿà¤¿à¤¸ à¤¦à¤¿à¤¨à¥‹à¤‚',0),(413992,11500,'ms','Hari notis akhir pertama',0),(413993,11500,'ar','Ø£ÙˆÙ„ Ø£ÙŠØ§Ù… Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø±Ø§Ø­Ù„',0),(413994,11500,'fr','Premiers jours d\'avis tardif',0),(413995,11500,'jp','å¾ŒåŠã®æœ€åˆã®é€šçŸ¥æ—¥',0),(413996,11500,'pt','Primeiros dias de aviso final',0),(413997,11500,'ru','ÐŸÐµÑ€Ð²Ñ‹Ðµ Ð´Ð½Ð¸ Ð¿Ð¾Ð·Ð´Ð½ÐµÐ³Ð¾ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(413998,11500,'es','DÃ­as de NotificaciÃ³n Primera de Tardanza',0),(413999,11500,'de','Ersten spÃ¤ten AnkÃ¼ndigung-Tage',0),(414000,11500,'en','First Late Notice Days',0),(414001,11501,'is','',0),(414002,11501,'dr','Ù†Ø§Ù… Ø§Ø³Ù†Ø§Ø¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(414003,11501,'pr','Ù†Ø§Ù… Ø§Ø³Ù†Ø§Ø¯ Ø§Ø¬Ø§Ø±Ù‡ ',0),(414004,11501,'tr','Kira belge adÄ±',0),(414005,11501,'pl','Nazwa dokumentu umowy najmu',0),(414006,11501,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(414007,11501,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ Ù„ÛŒØ² Ú©Ø§ Ù†Ø§Ù…',0),(414008,11501,'sr','Ð˜Ð¼Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð¾ Ð·Ð°ÐºÑƒÐ¿Ñƒ',0),(414009,11501,'vi','Cho thuÃª tÃ i liá»‡u tÃªn',0),(414010,11501,'af','Huurkontrak Dokument Naam',0),(414011,11501,'ro','Numele de Document de leasing',0),(414012,11501,'et','ÃœÃ¼rilepingu dokumendi nimi',0),(414013,11501,'si','Najem ime dokumenta',0),(414014,11501,'ba','Nama dokumen sewa',0),(414015,11501,'nl','De naam van het Document van de lease-overeenkomst',0),(414016,11501,'fi','Vuokrasopimuksen asiakirjan nimi',0),(414017,11501,'no','Navn pÃ¥ lease',0),(414018,11501,'da','Lease dokumentnavnet',0),(414019,11501,'ko','ìž„ëŒ€ ë¬¸ì„œ ì´ë¦„',0),(414020,11501,'he','×©× ×”×ž×¡×ž×š ×—×›×™×¨×”',0),(414021,11501,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· ÏŒÎ½Î¿Î¼Î± ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(414022,11501,'zh','åœŸåœ°å¥‘çº¦æ–‡ä»¶å\r\n',0),(414023,11501,'sv','Hyresavtalet dokumentnamn',0),(414024,11501,'it','Nome del documento di contratto di locazione',0),(414025,11501,'tl','',0),(414026,11501,'th','à¸Šà¸·à¹ˆà¸­à¹€à¸­à¸à¸ªà¸²à¸£à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(414027,11501,'hi','à¤²à¥€à¤œ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤•à¤¾ à¤¨à¤¾à¤®',0),(414028,11501,'ms','Nama dokumen pajakan',0),(414029,11501,'ar','Ø§Ø³Ù… ÙˆØ«ÙŠÙ‚Ø© Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(414030,11501,'fr','Nom du Document bail',0),(414031,11501,'jp','ãƒªãƒ¼ã‚¹ ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆå',0),(414032,11501,'pt','Nome do documento de locaÃ§Ã£o',0),(414033,11501,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¸Ð¼Ñ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(414034,11501,'es','Nombre de Documento de Arrendamiento',0),(414035,11501,'de','Leasing-Dokumentname',0),(414036,11501,'en','Lease Document Name',0),(414037,11502,'is','',0),(414038,11502,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù‚Ø§Ù„Ø¨ Ø§Ø¬Ø§Ø±Ù‡ ',0),(414039,11502,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù‚Ø§Ù„Ø¨ Ø§Ø¬Ø§Ø±Ù‡ ',0),(414040,11502,'tr','Kira ÅŸablonu kimliÄŸi',0),(414041,11502,'pl','DzierÅ¼awa szablonu ID',0),(414042,11502,'bg','Ð˜Ð” Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð·Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(414043,11502,'ur','Ù„ÛŒØ² Ú©Û’ Ø³Ø§Ù†Ú†Û’ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(414044,11502,'sr','Ð˜Ð” Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ° Ð·Ð°ÐºÑƒÐ¿',0),(414045,11502,'vi','Cho thuÃª máº«u ID',0),(414046,11502,'af','Huurkontrak Sjabloon ID',0),(414047,11502,'ro','ID de ÅŸablon leasing',0),(414048,11502,'et','ÃœÃ¼rilepingu malli ID',0),(414049,11502,'si','ID predloge najema',0),(414050,11502,'ba','Sewa Template ID',0),(414051,11502,'nl','Lease sjabloon ID',0),(414052,11502,'fi','Vuokrasopimuksen mallin tunnus',0),(414053,11502,'no','Leieavtalen mal-ID',0),(414054,11502,'da','Lejekontrakt skabelon-ID',0),(414055,11502,'ko','ìž„ëŒ€ í…œí”Œë¦¿ ID',0),(414056,11502,'he','×ž×–×”×” ×ª×‘× ×™×ª ×—×•×–×” ×©×›×™×¨×•×ª',0),(414057,11502,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï… Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(414058,11502,'zh','ç§Ÿèµæ¨¡æ¿èº«ä»½è¯\r\n',0),(414059,11502,'sv','Mall-ID fÃ¶r leasing',0),(414060,11502,'it','ID modello contratto di locazione',0),(414061,11502,'tl','',0),(414062,11502,'th','à¸£à¸«à¸±à¸ªà¹€à¸—à¹‡à¸¡à¹€à¸žà¸¥à¸•à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²',0),(414063,11502,'hi','à¤²à¥€à¤œ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ ID',0),(414064,11502,'ms','Pajakan Template ID',0),(414065,11502,'ar','Ù…Ø¹Ø±Ù Ù‚Ø§Ù„Ø¨ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(414066,11502,'fr','ID de modÃ¨le de bail',0),(414067,11502,'jp','ãƒªãƒ¼ã‚¹ ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ ID',0),(414068,11502,'pt','ID do modelo de contrato de arrendamento',0),(414069,11502,'ru','ÐÑ€ÐµÐ½Ð´Ð° ID ÑˆÐ°Ð±Ð»Ð¾Ð½Ð°',0),(414070,11502,'es','ID de Plantilla de Arrendamiento',0),(414071,11502,'de','Mietvertrag Vorlage ID',0),(414072,11502,'en','Lease Template ID',0),(414073,11503,'is','',0),(414074,11503,'dr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(414075,11503,'pr','Ù„Ø·ÙØ§ Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø±Ø§  Ø§Ø¶Ø§ÙÙ‡ ÙƒÙ†ÙŠØ¯',0),(414076,11503,'tr','LÃ¼tfen Ã¶zellik tÃ¼rÃ¼ ekleyin',0),(414077,11503,'pl','ProszÄ™ podaÄ‡ Typ nieruchomoÅ›ci',0),(414078,11503,'bg','ÐœÐ¾Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿ Ð¸Ð¼Ð¾Ñ‚',0),(414079,11503,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(414080,11503,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ñ‚Ð¸Ð¿ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð°',0),(414081,11503,'vi','Xin vui lÃ²ng bao gá»“m cÃ¡c loáº¡i tÃ i sáº£n',0),(414082,11503,'af','Sluit asseblief \'n Eiendomstipe in',0),(414083,11503,'ro','VÄƒ rugÄƒm sÄƒ includeÅ£i tip de proprietate',0),(414084,11503,'et','Lisage atribuudi tÃ¼Ã¼p',0),(414085,11503,'si','Prosimo, da vkljuÄite Vrsta nepremiÄnine',0),(414086,11503,'ba','Sertakan tipe properti',0),(414087,11503,'nl','Gelieve te omvatten (Type eigenschap)',0),(414088,11503,'fi','Kirjoita ominaisuuden tyyppi',0),(414089,11503,'no','Ta med egenskapstypen',0),(414090,11503,'da','VedlÃ¦g egenskabstype',0),(414091,11503,'ko','ì¢…ë¥˜ë¥¼ í¬í•¨ í•˜ì‹­ì‹œì˜¤',0),(414092,11503,'he','×× × ×›×œ×•×œ ×¡×•×’ × ×›×¡',0),(414093,11503,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Î¤ÏÏ€Î¿Ï‚ Î±ÎºÎ¹Î½Î®Ï„Î¿Ï…',0),(414094,11503,'zh','è¯·åŒ…æ‹¬ç‰©ä¸šç±»åž‹\r\n',0),(414095,11503,'sv','VÃ¤nligen inkludera Bostadstyp',0),(414096,11503,'it','Si prega di includere il tipo di proprietÃ .',0),(414097,11503,'tl','',0),(414098,11503,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸™à¸´à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(414099,11503,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(414100,11503,'ms','Sila sertakan jenis harta',0),(414101,11503,'ar','ÙˆÙŠØ±Ø¬Ù‰ ØªØ¶Ù…ÙŠÙ† Ù†ÙˆØ¹ Ø§Ù„Ø®Ø§ØµÙŠØ©',0),(414102,11503,'fr','Veuillez indiquer le Type de propriÃ©tÃ©',0),(414103,11503,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®ç¨®é¡žã‚’å«ã‚ã¦ãã ã•ã„ã€‚',0),(414104,11503,'pt','Por favor inclua o tipo de propriedade.',0),(414105,11503,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐºÐ°Ð¶Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(414106,11503,'es','Por Favor Incluye el Tipo de la Propiedad',0),(414107,11503,'de','Bitte geben Sie Immobilienart',0),(414108,11503,'en','Please Include Property Type',0),(414109,11504,'is','',0),(414110,11504,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§ ',0),(414111,11504,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§ ',0),(414112,11504,'tr','Ã–zellikler ekleme',0),(414113,11504,'pl','Dodaj wÅ‚aÅ›ciwoÅ›ci',0),(414114,11504,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(414115,11504,'ur','Ø®ÙˆØ§Øµ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(414116,11504,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð°Ð²Ð°',0),(414117,11504,'vi','ThÃªm cÃ¡c thuá»™c tÃ­nh',0),(414118,11504,'af','Voeg eienskappe',0),(414119,11504,'ro','Adauga proprietÄƒÅ£i',0),(414120,11504,'et','Lisada atribuute',0),(414121,11504,'si','Dodajanje lastnosti',0),(414122,11504,'ba','Menambahkan properti',0),(414123,11504,'nl','Eigenschappen toevoegen',0),(414124,11504,'fi','LisÃ¤Ã¤ ominaisuuksia',0),(414125,11504,'no','Legge til egenskaper',0),(414126,11504,'da','TilfÃ¸je egenskaber',0),(414127,11504,'ko','ì†ì„± ì¶”ê°€',0),(414128,11504,'he','×œ×”×•×¡×™×£ ×ž××¤×™×™× ×™×',0),(414129,11504,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¹Î´Î¹Î¿Ï„Î®Ï„Ï‰Î½',0),(414130,11504,'zh','æ·»åŠ å±žæ€§\r\n',0),(414131,11504,'sv','LÃ¤gga till egenskaper',0),(414132,11504,'it','Aggiungere proprietÃ ',0),(414133,11504,'tl','',0),(414134,11504,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(414135,11504,'hi','à¤—à¥à¤£ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(414136,11504,'ms','Tambah hartanah',0),(414137,11504,'ar','Ø¥Ø¶Ø§ÙØ© Ø®ØµØ§Ø¦Øµ',0),(414138,11504,'fr','Ajouter des propriÃ©tÃ©s',0),(414139,11504,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(414140,11504,'pt','Adicionar propriedades',0),(414141,11504,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(414142,11504,'es','Agregar Propiedades',0),(414143,11504,'de','HinzufÃ¼gen von Eigenschaften',0),(414144,11504,'en','Add Properties',0),(414145,11505,'is','',0),(414146,11505,'dr','Ø­Ø°Ù Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§',0),(414147,11505,'pr','Ø­Ø°Ù Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§',0),(414148,11505,'tr','Ã–zellikleri Sil',0),(414149,11505,'pl','Usuwanie wÅ‚aÅ›ciwoÅ›ci',0),(414150,11505,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(414151,11505,'ur','Ø®ÙˆØ§Øµ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(414152,11505,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð°',0),(414153,11505,'vi','XÃ³a thuá»™c tÃ­nh',0),(414154,11505,'af','Skrap eienskappe',0),(414155,11505,'ro','ÅžtergeÅ£i proprietÄƒÅ£i',0),(414156,11505,'et','Kustuta atribuudid',0),(414157,11505,'si','Izbrisati lastnosti',0),(414158,11505,'ba','Menghapus properti',0),(414159,11505,'nl','Eigenschappen verwijderen',0),(414160,11505,'fi','Poista ominaisuudet',0),(414161,11505,'no','Slette egenskaper',0),(414162,11505,'da','Slette egenskaber',0),(414163,11505,'ko','ì†ì„± ì‚­ì œ',0),(414164,11505,'he','×ž×—×™×§×ª × ×›×¡×™×',0),(414165,11505,'el','Î— Î´Î¹Î±Î³ÏÎ±Ï†Î® Ï„Ï‰Î½ Î¹Î´Î¹Î¿Ï„Î®Ï„Ï‰Î½',0),(414166,11505,'zh','ç‰©ä¸šåˆ é™¤\r\n',0),(414167,11505,'sv','Ta bort egenskaper',0),(414168,11505,'it','Eliminare le proprietÃ ',0),(414169,11505,'tl','',0),(414170,11505,'th','à¸¥à¸šà¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(414171,11505,'hi','à¤—à¥à¤£ à¤•à¥‹ à¤¹à¤Ÿà¤¾ à¤¦à¥‡à¤‚',0),(414172,11505,'ms','Menghapuskan sifat-sifat',0),(414173,11505,'ar','Ø­Ø°Ù Ø®ØµØ§Ø¦Øµ',0),(414174,11505,'fr','Supprimer des propriÃ©tÃ©s',0),(414175,11505,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(414176,11505,'pt','Excluir propriedades',0),(414177,11505,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²',0),(414178,11505,'es','Eliminar Propiedades',0),(414179,11505,'de','Eigenschaften lÃ¶schen',0),(414180,11505,'en','Delete Properties',0),(414181,11506,'is','',0),(414182,11506,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§',0),(414183,11506,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù‡Ø§',0),(414184,11506,'tr','GÃ¼ncelleÅŸtirme Ã¶zellikleri',0),(414185,11506,'pl','Aktualizacja wÅ‚aÅ›ciwoÅ›ci',0),(414186,11506,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð¹ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°Ñ‚Ð°',0),(414187,11506,'ur','Ø®ÙˆØ§Øµ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(414188,11506,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð°Ð²Ð°',0),(414189,11506,'vi','Cáº­p Nháº­t thuá»™c tÃ­nh',0),(414190,11506,'af','Bywerking eienskappe',0),(414191,11506,'ro','Actualizare proprietÄƒÈ›i',0),(414192,11506,'et','Atribuutide vÃ¤rskendamine',0),(414193,11506,'si','Posodobitev lastnosti',0),(414194,11506,'ba','Memperbarui properti',0),(414195,11506,'nl','Eigenschappen bijwerken',0),(414196,11506,'fi','Ominaisuuksien pÃ¤ivittÃ¤minen',0),(414197,11506,'no','Oppdatere egenskaper',0),(414198,11506,'da','Opdater egenskaber',0),(414199,11506,'ko','ì—…ë°ì´íŠ¸ ì†ì„±',0),(414200,11506,'he','×¢×“×›×•×Ÿ ×ž××¤×™×™× ×™×',0),(414201,11506,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¹Î´Î¹Î¿Ï„Î®Ï„Ï‰Î½',0),(414202,11506,'zh','\r\næ›´æ–°å±žæ€§\r\n',0),(414203,11506,'sv','Uppdatera egenskaper',0),(414204,11506,'it','Aggiornare le proprietÃ ',0),(414205,11506,'tl','',0),(414206,11506,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(414207,11506,'hi','à¤—à¥à¤£ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(414208,11506,'ms','Sifat-sifat Kemaskini',0),(414209,11506,'ar','ØªØ­Ø¯ÙŠØ« Ø®ØµØ§Ø¦Øµ',0),(414210,11506,'fr','Mettre Ã  jour les propriÃ©tÃ©s',0),(414211,11506,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(414212,11506,'pt','Atualizar propriedades',0),(414213,11506,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²',0),(414214,11506,'es','Actualizar Propiedades',0),(414215,11506,'de','Update-Eigenschaften',0),(414216,11506,'en','Update Properties',0),(414217,11507,'is','',0),(414218,11507,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(414219,11507,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(414220,11507,'tr','BaÅŸarÄ±sÄ±zlÄ±k Ã¶zelliÄŸi ekleme',0),(414221,11507,'pl','BÅ‚Ä…d dodawania WÅ‚aÅ›ciwoÅ›Ä‡',0),(414222,11507,'bg','ÐÐµÑƒÑÐ¿ÐµÑ… Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚',0),(414223,11507,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(414224,11507,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(414225,11507,'vi','Tháº¥t báº¡i thÃªm báº¥t Ä‘á»™ng sáº£n',0),(414226,11507,'af','Mislukking toevoeging van eiendom',0),(414227,11507,'ro','EÅŸecul adÄƒugarea de proprietate',0),(414228,11507,'et','Rike lisades kinnisvara',0),(414229,11507,'si','Neuspeh dodajanje lastnosti',0),(414230,11507,'ba','Kegagalan menambahkan properti',0),(414231,11507,'nl','Mislukking toe te voegen eigenschap',0),(414232,11507,'fi','EpÃ¤onnistuminen lisÃ¤Ã¤mÃ¤llÃ¤ ominaisuus',0),(414233,11507,'no','Feil Ã¥ legge til egenskapen',0),(414234,11507,'da','Manglende tilfÃ¸je ejendom',0),(414235,11507,'ko','ì‹¤íŒ¨ ì¶”ê°€ ì†ì„±',0),(414236,11507,'he','×›×©×œ ×”×•×¡×¤×ª ×ž××¤×™×™×Ÿ',0),(414237,11507,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(414238,11507,'zh','å¤±è´¥æ·»åŠ å±žæ€§\r\n',0),(414239,11507,'sv','UnderlÃ¥tenhet att lÃ¤gga till egenskapen',0),(414240,11507,'it','Mancata aggiunta di proprietÃ .',0),(414241,11507,'tl','',0),(414242,11507,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(414243,11507,'hi','à¤…à¤¸à¤«à¤²à¤¤à¤¾ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(414244,11507,'ms','Kegagalan menambah harta',0),(414245,11507,'ar','ÙØ´Ù„ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø®Ø§ØµÙŠØ©',0),(414246,11507,'fr','Ã‰chec ajout de propriÃ©tÃ©',0),(414247,11507,'jp','éšœå®³ã®è¿½åŠ ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£',0),(414248,11507,'pt','Falha adicionando Propriedade',0),(414249,11507,'ru','Ð¡Ð±Ð¾Ð¹ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(414250,11507,'es','FallÃ³ Agregando Propiedad',0),(414251,11507,'de','Fehler hinzufÃ¼gen-Eigenschaft',0),(414252,11507,'en','Failure Adding Property',0),(414253,11508,'is','',0),(414254,11508,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(414255,11508,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(414256,11508,'tr','Ã–zellik baÅŸarÄ±yla eklendi',0),(414257,11508,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ pomyÅ›lne dodanie',0),(414258,11508,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(414259,11508,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(414260,11508,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(414261,11508,'vi','Báº¥t Ä‘á»™ng sáº£n má»›i nháº¥t Ä‘Æ°á»£c gá»­i thÃ nh cÃ´ng',0),(414262,11508,'af','Eiendom gevoeg suksesvol',0),(414263,11508,'ro','AdÄƒugat cu succes de proprietate',0),(414264,11508,'et','Vara lisandunud edukalt',0),(414265,11508,'si','PremoÅ¾enje dodani uspeÅ¡no',0),(414266,11508,'ba','Properti ditambahkan berhasil',0),(414267,11508,'nl','Eigenschap toegevoegd',0),(414268,11508,'fi','Ominaisuuden lisÃ¤Ã¤minen onnistui',0),(414269,11508,'no','Egenskapen lagt',0),(414270,11508,'da','Ejendom tilfÃ¸jet',0),(414271,11508,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ì†ì„±',0),(414272,11508,'he','×ž××¤×™×™×Ÿ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(414273,11508,'el','Î™Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(414274,11508,'zh','å±žæ€§æ·»åŠ æˆåŠŸ\r\n',0),(414275,11508,'sv','Egenskapen lagts',0),(414276,11508,'it','ProprietÃ  aggiunto con successo',0),(414277,11508,'tl','',0),(414278,11508,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(414279,11508,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(414280,11508,'ms','Harta yang berjaya menambah',0),(414281,11508,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(414282,11508,'fr','PropriÃ©tÃ© ajoutÃ©e avec succÃ¨s',0),(414283,11508,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(414284,11508,'pt','Propriedade adicionada com sucesso',0),(414285,11508,'ru','Ð¡Ð²Ð¾Ð¹ÑÑ‚Ð²Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(414286,11508,'es','Propiedad Agregada Exitosamente',0),(414287,11508,'de','Eigenschaft erfolgreich hinzugefÃ¼gt',0),(414288,11508,'en','Property Added Successfully',0),(414289,11509,'is','',0),(414290,11509,'dr','Ø­Ø°Ù Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(414291,11509,'pr','Ø­Ø°Ù Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯ ',0),(414292,11509,'tr','BaÅŸarÄ±sÄ±z silme Ã¶zelliÄŸi',0),(414293,11509,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ usuwanie awarii',0),(414294,11509,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð¸Ð¼Ð¾Ñ‚',0),(414295,11509,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©ÛŒ Ø®Ø§ØµÛŒØª Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(414296,11509,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð±Ñ€Ð¸ÑÐ°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð°',0),(414297,11509,'vi','Lá»—i xoÃ¡ báº¥t Ä‘á»™ng sáº£n',0),(414298,11509,'af','Mislukking skrap eiendom',0),(414299,11509,'ro','EÅŸecul ÅŸtergerea proprietate',0),(414300,11509,'et','TÃµrge kustutamisel kinnisvara',0),(414301,11509,'si','Neuspeh brisanja nepremiÄnine',0),(414302,11509,'ba','Kegagalan menghapus properti',0),(414303,11509,'nl','Mislukking verwijderen eigenschap',0),(414304,11509,'fi','Virhe poistettaessa ominaisuuden',0),(414305,11509,'no','Feil slette egenskapen',0),(414306,11509,'da','Manglende sletning ejendom',0),(414307,11509,'ko','ì‹¤íŒ¨ ì‚­ì œ ì†ì„±',0),(414308,11509,'he','×”×ž××¤×™×™×Ÿ ×‘×ž×—×™×§×ª ×›×©×œ',0),(414309,11509,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ Î±ÎºÎ¹Î½Î®Ï„Î¿Ï…',0),(414310,11509,'zh','ç‰©ä¸šåˆ é™¤å¤±è´¥\r\n',0),(414311,11509,'sv','Fel ta bort egenskapen',0),(414312,11509,'it','ProprietÃ  eliminazione guasto',0),(414313,11509,'tl','',0),(414314,11509,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸à¸²à¸£à¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(414315,11509,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿',0),(414316,11509,'ms','Kegagalan menghapuskan harta',0),(414317,11509,'ar','ÙØ´Ù„ Ø­Ø°Ù Ø§Ù„Ø®Ø§ØµÙŠØ©',0),(414318,11509,'fr','PropriÃ©tÃ© suppression de dÃ©faillance',0),(414319,11509,'jp','å¤±æ•—ã—ãŸå‰Šé™¤ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£',0),(414320,11509,'pt','Propriedade de exclusÃ£o de falha',0),(414321,11509,'ru','Ð¡Ð±Ð¾Ð¹ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(414322,11509,'es','FallÃ³ Eliminando Propiedad',0),(414323,11509,'de','Fehler lÃ¶schen-Eigenschaft',0),(414324,11509,'en','Failure Deleting Property',0),(414325,11510,'is','',0),(414326,11510,'dr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(414327,11510,'pr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(414328,11510,'tr','Ã–zellik baÅŸarÄ±yla silindi',0),(414329,11510,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ przesâ”‚anie',0),(414330,11510,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(414331,11510,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©ÛŒ Ø®Ø§ØµÛŒØª',0),(414332,11510,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(414333,11510,'vi','Báº¥t Ä‘á»™ng sáº£n Ä‘Ã£ xÃ³a thÃ nh cÃ´ng',0),(414334,11510,'af','Eiendom suksesvol geskrap',0),(414335,11510,'ro','EliminÄƒ cu succes de proprietate',0),(414336,11510,'et','Vara edukalt kustutatud',0),(414337,11510,'si','Lastnost uspeÅ¡no izbrisana',0),(414338,11510,'ba','Properti dihapus berhasil',0),(414339,11510,'nl','Eigenschap Deleted Successfully',0),(414340,11510,'fi','Poistettu ominaisuus',0),(414341,11510,'no','Egenskapen slettet',0),(414342,11510,'da','Egenskaben slettet',0),(414343,11510,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ì†ì„±',0),(414344,11510,'he','×ž××¤×™×™×Ÿ ×ž×—×§ ×‘×”×¦×œ×—×”',0),(414345,11510,'el','Î™Î´Î¹ÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(414346,11510,'zh','ç‰©ä¸šæˆåŠŸåˆ é™¤\r\n',0),(414347,11510,'sv','Egenskapen raderades',0),(414348,11510,'it','ProprietÃ  eliminato con successo',0),(414349,11510,'tl','',0),(414350,11510,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(414351,11510,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¥€ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿',0),(414352,11510,'ms','Harta yang dihapuskan dengan jayanya',0),(414353,11510,'ar','Ø­Ø°Ù Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(414354,11510,'fr','PropriÃ©tÃ© supprimÃ©e avec succÃ¨s',0),(414355,11510,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(414356,11510,'pt','Propriedade apagada com sucesso',0),(414357,11510,'ru','Ð¡Ð²Ð¾Ð¹ÑÑ‚Ð²Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(414358,11510,'es','Propiedad Eliminada Exitosamente',0),(414359,11510,'de','Eigenschaft erfolgreich gelÃ¶scht',0),(414360,11510,'en','Property Deleted Successfully',0),(414361,11511,'is','',0),(414362,11511,'dr','Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414363,11511,'pr','Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414364,11511,'tr','Ã–zellik tÃ¼rÃ¼',0),(414365,11511,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ Type',0),(414366,11511,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚Ð°',0),(414367,11511,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª',0),(414368,11511,'sr','Ð¢Ð¸Ð¿ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð°',0),(414369,11511,'vi','loáº¡i tÃ i sáº£n',0),(414370,11511,'af','Eiendomstipe',0),(414371,11511,'ro','Tip de proprietate',0),(414372,11511,'et','Kinnisvara tÃ¼Ã¼p',0),(414373,11511,'si','Vrsta nepremiÄnine',0),(414374,11511,'ba','Tipe properti',0),(414375,11511,'nl','Eigenschapstype',0),(414376,11511,'fi','KiinteistÃ¶tyyppi',0),(414377,11511,'no','Egenskapstype',0),(414378,11511,'da','Egenskabstype',0),(414379,11511,'ko','ì†ì„± í˜•ì‹',0),(414380,11511,'he','×¡×•×’ ×”× ×›×¡',0),(414381,11511,'el','Î¤ÏÏ€Î¿Ï‚ Î±ÎºÎ¹Î½Î®Ï„Î¿Ï…',0),(414382,11511,'zh','å±žæ€§ç±»åž‹\r\n',0),(414383,11511,'sv','Egenskapstypen',0),(414384,11511,'it','Tipo di proprietÃ .',0),(414385,11511,'tl','',0),(414386,11511,'th','à¸Šà¸™à¸´à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(414387,11511,'hi','à¤¸à¤®à¥à¤ªà¤¤à¥à¤¤à¥€ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(414388,11511,'ms','Jenis harta tanah',0),(414389,11511,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø®Ø§ØµÙŠØ©',0),(414390,11511,'fr','Type de propriÃ©tÃ©',0),(414391,11511,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®åž‹',0),(414392,11511,'pt','Tipo de propriedade.',0),(414393,11511,'ru','Ð¢Ð¸Ð¿ Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚Ð¸',0),(414394,11511,'es','Tipo de Propiedad',0),(414395,11511,'de','Immobilienart',0),(414396,11511,'en','Property Type',0),(414397,11512,'is','',0),(414398,11512,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414399,11512,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414400,11512,'tr','BaÅŸarÄ±sÄ±z gÃ¼ncelleÅŸtirme Ã¶zelliÄŸi',0),(414401,11512,'pl','Brak aktualizacji wÅ‚aÅ›ciwoÅ›ci',0),(414402,11512,'bg','ÐÐµÑƒÑÐ¿ÐµÑ… Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð¼Ð¾Ñ‚',0),(414403,11512,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ',0),(414404,11512,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð°',0),(414405,11512,'vi','Sá»± tháº¥t báº¡i cáº­p nháº­t báº¥t Ä‘á»™ng sáº£n',0),(414406,11512,'af','Faal om Eiendom te Opdateer',0),(414407,11512,'ro','EÅŸecul actualizare proprietate',0),(414408,11512,'et','TÃµrge vÃ¤rskendamisel kinnisvara',0),(414409,11512,'si','Neuspeh posodabljanje lastnosti',0),(414410,11512,'ba','Kegagalan memperbarui properti',0),(414411,11512,'nl','Fout bijwerken eigenschap',0),(414412,11512,'fi','EpÃ¤onnistuminen pÃ¤ivittÃ¤Ã¤ ominaisuuden',0),(414413,11512,'no','Feil oppdatering eiendom',0),(414414,11512,'da','Manglende opdatering ejendom',0),(414415,11512,'ko','ì‹¤íŒ¨ ì—…ë°ì´íŠ¸ ì†ì„±',0),(414416,11512,'he','×”×ž××¤×™×™×Ÿ ×”×ž×¢×“×›× ×ª ×›×©×œ',0),(414417,11512,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î¹Î´Î¹ÏŒÏ„Î·Ï„Î±Ï‚',0),(414418,11512,'zh','ç‰©ä¸šæ›´æ–°å¤±è´¥\r\n',0),(414419,11512,'sv','Misslyckande uppdatera egenskapen',0),(414420,11512,'it','Mancato aggiornamento proprietÃ ',0),(414421,11512,'tl','',0),(414422,11512,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(414423,11512,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤‚à¤ªà¤¦à¤¾',0),(414424,11512,'ms','Kegagalan pengemaskinian harta',0),(414425,11512,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø®Ø§ØµÙŠØ©',0),(414426,11512,'fr','PropriÃ©tÃ© mise Ã  jour de panne',0),(414427,11512,'jp','å¤±æ•—ã—ãŸæ›´æ–°ã®ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£',0),(414428,11512,'pt','Propriedade atualizaÃ§Ã£o falha',0),(414429,11512,'ru','Ð¡Ð±Ð¾Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(414430,11512,'es','FallÃ³ Actualizando Propiedad',0),(414431,11512,'de','Fehler Update-Eigenschaft',0),(414432,11512,'en','Failure Updating Property',0),(414433,11513,'is','',0),(414434,11513,'dr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(414435,11513,'pr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(414436,11513,'tr','Ã–zelliÄŸi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(414437,11513,'pl','PomyÅ›lnie zaktualizowano wÅ‚aÅ›ciwoÅ›Ä‡',0),(414438,11513,'bg','Ð˜Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(414439,11513,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(414440,11513,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(414441,11513,'vi','Báº¥t Ä‘á»™ng sáº£n Cáº­p Nháº­t thÃ nh cÃ´ng',0),(414442,11513,'af','Eiendom Suksesvol Opdateer',0),(414443,11513,'ro','Proprietatea actualizat cu succes',0),(414444,11513,'et','Atribuut vÃ¤rskendatud',0),(414445,11513,'si','Lastnost uspeÅ¡no posodobljena',0),(414446,11513,'ba','Properti yang berhasil',0),(414447,11513,'nl','Eigenschap bijgewerkt',0),(414448,11513,'fi','Ominaisuus on pÃ¤ivitetty',0),(414449,11513,'no','Egenskapen oppdatert',0),(414450,11513,'da','Egenskaben opdateret',0),(414451,11513,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì†ì„±',0),(414452,11513,'he','×”×ž××¤×™×™×Ÿ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(414453,11513,'el','Î™Î´Î¹ÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(414454,11513,'zh','ç‰©ä¸šæˆåŠŸæ›´æ–°\r\n',0),(414455,11513,'sv','Egenskapen uppdaterats',0),(414456,11513,'it','ProprietÃ  aggiornata con successo',0),(414457,11513,'tl','',0),(414458,11513,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(414459,11513,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤‚à¤ªà¤¦à¤¾',0),(414460,11513,'ms','Harta yang berjaya dikemas kini',0),(414461,11513,'ar','Ø­Ø¯Ù‘Ø« Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(414462,11513,'fr','PropriÃ©tÃ© mis Ã  jour avec succÃ¨s',0),(414463,11513,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(414464,11513,'pt','Propriedade atualizada com sucesso',0),(414465,11513,'ru','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(414466,11513,'es','Propiedad Actualizada Exitosamente',0),(414467,11513,'de','Eigenschaft wurde erfolgreich aktualisiert',0),(414468,11513,'en','Property Updated Successfully',0),(414469,11514,'is','',0),(414470,11514,'dr','(Ø§Ø®Ø·Ø§Ø±)( Ø¯Ø± Ø§ÙˆØ§Ø®Ø± Ø±ÙˆØ² Ø¯ÙˆÙ… Ù…Ù‚Ø±Ø±Ø§Øª',0),(414471,11514,'pr','Ø¯ÙˆÙ…ÙŠÙ† Ø±ÙˆØ²Ù‡Ø§ÙŠ Ø¢Ø®Ø±ÙŠÙ† ØªÙˆØ¬Ù‡(Ø§Ø®Ø·Ø§Ø±)( Ø¯Ø± Ø§ÙˆØ§Ø®Ø± Ø±ÙˆØ² Ø¯ÙˆÙ… Ù…Ù‚Ø±Ø±Ø§Øª',0),(414472,11514,'tr','Ä°kinci geÃ§ duyuru gÃ¼n',0),(414473,11514,'pl','Drugi koniec dni wypowiedzenia',0),(414474,11514,'bg','Ð’Ñ‚Ð¾Ñ€Ð¸ ÐºÑŠÑÐ½Ð¾ Ð´Ð½Ð¸ Ð¿Ñ€ÐµÐ´Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(414475,11514,'ur','Ø¯ÙˆØ³Ø±Ø§ Ù…Ø±Ø­ÙˆÙ… Ù†ÙˆÙ¹Ø³ Ø¯Ù†',0),(414476,11514,'sr','Ð”Ñ€ÑƒÐ³Ð¸ ÐºÑ€Ð°Ñ˜ÐµÐ¼ Ð´Ð°Ð½Ð° Ð½Ð°Ñ˜Ð°Ð²Ðµ',0),(414477,11514,'vi','NgÃ y thÃ´ng bÃ¡o cuá»‘i thá»© hai',0),(414478,11514,'af','Tweede laat kennisgewing dae',0),(414479,11514,'ro','Doua zile de preaviz tÃ¢rziu',0),(414480,11514,'et','Teine hilinenud teade pÃ¤eva',0),(414481,11514,'si','Drugi pozno obvestilo dni',0),(414482,11514,'ba','Kedua hari pemberitahuan terlambat',0),(414483,11514,'nl','Tweede laat aankondiging dagen',0),(414484,11514,'fi','Toinen myÃ¶hÃ¤Ã¤n ilmoituksen pÃ¤ivÃ¤Ã¤',0),(414485,11514,'no','Andre sent varsel dager',0),(414486,11514,'da','Anden sene varsel dage',0),(414487,11514,'ko','ë‘ ë²ˆì§¸ ëŠ¦ì€ í†µì§€ ì¼',0),(414488,11514,'he','×©× ×™ ×™×ž×™× ×”×•×“×¢×” ×ž××•×—×¨×ª',0),(414489,11514,'el','Î”ÎµÏÏ„ÎµÏÎ· Ï„Î­Î»Î· ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î·Î¼Î­ÏÎµÏ‚',0),(414490,11514,'zh','ç¬¬äºŒæ™šé€šçŸ¥åŽ\r\n',0),(414491,11514,'sv','Andra sent varsel dagar',0),(414492,11514,'it','Secondo fine giorni di preavviso',0),(414493,11514,'tl','',0),(414494,11514,'th','à¸§à¸±à¸™à¸›à¸£à¸°à¸à¸²à¸¨à¸ªà¸²à¸¢à¸ªà¸­à¸‡',0),(414495,11514,'hi','à¤¦à¥‚à¤¸à¤°à¤¾ à¤¦à¥‡à¤° à¤¨à¥‹à¤Ÿà¤¿à¤¸ à¤¦à¤¿à¤¨à¥‹à¤‚',0),(414496,11514,'ms','Kedua hari notis yang lewat',0),(414497,11514,'ar','Ø«Ø§Ù†ÙŠ Ø£ÙŠØ§Ù… Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø±Ø§Ø­Ù„',0),(414498,11514,'fr','DeuxiÃ¨me jours d\'avis tardif',0),(414499,11514,'jp','2 ç•ªç›®ã®å¾ŒåŠé€šçŸ¥æ—¥',0),(414500,11514,'pt','Segunda tarde dias de aviso prÃ©vio',0),(414501,11514,'ru','Ð’Ñ‚Ð¾Ñ€Ð¾Ð¹ ÐºÐ¾Ð½ÐµÑ† Ð´Ð½ÐµÐ¹ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(414502,11514,'es','DÃ­as de Segunda NotificaciÃ³n de Pago Atrasado',0),(414503,11514,'de','Zweiten spÃ¤ten AnkÃ¼ndigung-Tage',0),(414504,11514,'en','Second Late Notice Days',0),(414505,11515,'is','',0),(414506,11515,'dr','Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414507,11515,'pr','Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414508,11515,'tr','MÃ¼lkiyet',0),(414509,11515,'pl','WÅ‚asnoÅ›ci',0),(414510,11515,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(414511,11515,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª',0),(414512,11515,'sr','Ð’Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð° Ð½Ð°Ð´ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ð¾Ð¼',0),(414513,11515,'vi','Quyá»n sá»Ÿ há»¯u báº¥t Ä‘á»™ng sáº£n',0),(414514,11515,'af','Eienaarskap van eiendom',0),(414515,11515,'ro','Proprietate',0),(414516,11515,'et','Omandi',0),(414517,11515,'si','Lastninska',0),(414518,11515,'ba','Kepemilikan properti',0),(414519,11515,'nl','Eigendom',0),(414520,11515,'fi','Omistusoikeus',0),(414521,11515,'no','Eiendomsretten',0),(414522,11515,'da','Ejendomsretten',0),(414523,11515,'ko','ìž¬ì‚° ì†Œìœ ê¶Œ',0),(414524,11515,'he','×‘×¢×œ×•×ª ×¢×œ × ×›×¡',0),(414525,11515,'el','Î™Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(414526,11515,'zh','è´¢äº§æ‰€æœ‰æƒ\r\n',0),(414527,11515,'sv','Ã„ganderÃ¤tt',0),(414528,11515,'it','ProprietÃ  di immobili',0),(414529,11515,'tl','',0),(414530,11515,'th','à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(414531,11515,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥‡ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ',0),(414532,11515,'ms','Pemilikan hartanah',0),(414533,11515,'ar','Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ø¹Ù‚Ø§Ø±Ø§Øª',0),(414534,11515,'fr','PropriÃ©tÃ©',0),(414535,11515,'jp','è²¡ç”£ã®æ‰€æœ‰æ¨©',0),(414536,11515,'pt','Posse de propriedade.',0),(414537,11515,'ru','Ð’Ð»Ð°Ð´ÐµÐ½Ð¸Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒÑŽ',0),(414538,11515,'es','Pertenencia de Propiedad',0),(414539,11515,'de','Eigentum',0),(414540,11515,'en','Property Ownership',0),(414541,11516,'is','',0),(414542,11516,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414543,11516,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414544,11516,'tr','MÃ¼lkiyet Ekle',0),(414545,11516,'pl','DodaÄ‡ wÅ‚asnoÅ›ci',0),(414546,11516,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(414547,11516,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(414548,11516,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð° Ð½Ð°Ð´ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ð¾Ð¼',0),(414549,11516,'vi','Quyá»n sá»Ÿ há»¯u báº¥t Ä‘á»™ng sáº£n thÃªm',0),(414550,11516,'af','Eienaarskap van eiendom voeg',0),(414551,11516,'ro','Adauga proprietate',0),(414552,11516,'et','Omandi lisamine',0),(414553,11516,'si','Dodaj lastninska',0),(414554,11516,'ba','Tambahkan kepemilikan properti',0),(414555,11516,'nl','Eigendom toevoegen',0),(414556,11516,'fi','Omistusoikeus lisÃ¤Ã¤',0),(414557,11516,'no','Eiendomsretten legge',0),(414558,11516,'da','Ejendomsretlige tilfÃ¸je',0),(414559,11516,'ko','ìž¬ì‚° ì†Œìœ ê¶Œ ì¶”ê°€',0),(414560,11516,'he','×”×§× ×™×Ÿ ×œ×”×•×¡×™×£',0),(414561,11516,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(414562,11516,'zh','è´¢äº§æ‰€æœ‰æƒæ·»åŠ \r\n',0),(414563,11516,'sv','Egendomsordning lÃ¤gga till',0),(414564,11516,'it','Aggiungi proprieta',0),(414565,11516,'tl','',0),(414566,11516,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(414567,11516,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥‡ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(414568,11516,'ms','Menambah pemilikan hartanah',0),(414569,11516,'ar','Ø£Ø¶Ù Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(414570,11516,'fr','Ajouter propriÃ©tÃ©',0),(414571,11516,'jp','è²¡ç”£ã®æ‰€æœ‰æ¨©ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(414572,11516,'pt','Adicionar Propriedade',0),(414573,11516,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(414574,11516,'es','Agregar Pertenencia de Propiedad',0),(414575,11516,'de','Eigentum hinzufÃ¼gen',0),(414576,11516,'en','Property Ownership Add',0),(414577,11517,'is','',0),(414578,11517,'dr','Ø­Ø°Ù Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ             ',0),(414579,11517,'pr','Ø­Ø°Ù Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ             ',0),(414580,11517,'tr','MÃ¼lkiyet sahipliÄŸi Sil',0),(414581,11517,'pl','UsuÅ„ wÅ‚asnoÅ›Ä‡ nieruchomoÅ›ci',0),(414582,11517,'bg','Ð˜Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(414583,11517,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(414584,11517,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ðµ',0),(414585,11517,'vi','XoÃ¡ quyá»n sá»Ÿ há»¯u báº¥t Ä‘á»™ng sáº£n',0),(414586,11517,'af','Eiendom eienaarskap skrap',0),(414587,11517,'ro','Åžtergere de proprietate de proprietate',0),(414588,11517,'et','Vara omandiÃµigus kustutamine',0),(414589,11517,'si','IzbriÅ¡i lastniÅ¡tvo nepremiÄnine',0),(414590,11517,'ba','Hapus kepemilikan properti',0),(414591,11517,'nl','Eigenschap eigendom verwijderen',0),(414592,11517,'fi','KiinteistÃ¶n omistus Poista',0),(414593,11517,'no','Eiendom eierskap Slett',0),(414594,11517,'da','Ejendom ejerskab slet',0),(414595,11517,'ko','ìž¬ì‚° ì†Œìœ ê¶Œ ì‚­ì œ',0),(414596,11517,'he','×‘×¢×œ×•×ª ×ž××¤×™×™×Ÿ ×ž×—×§',0),(414597,11517,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î± Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(414598,11517,'zh','è´¢äº§æ‰€æœ‰æƒåˆ é™¤\r\n',0),(414599,11517,'sv','Ta bort egenskapen Ã¤gande',0),(414600,11517,'it','ProprietÃ  ProprietÃ  Delete',0),(414601,11517,'tl','',0),(414602,11517,'th','à¸¥à¸šà¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(414603,11517,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤¹à¤Ÿà¤¾à¤à¤',0),(414604,11517,'ms','Menghapuskan pemilikan harta',0),(414605,11517,'ar','Ø­Ø°Ù Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(414606,11517,'fr','PropriÃ©tÃ© propriÃ©tÃ© Delete',0),(414607,11517,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®æ‰€æœ‰è€…ã®å‰Šé™¤',0),(414608,11517,'pt','ExclusÃ£o de posse de propriedade.',0),(414609,11517,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(414610,11517,'es','Eliminar Pertenencia de Propiedad',0),(414611,11517,'de','Eigenschaft Besitz lÃ¶schen',0),(414612,11517,'en','Property Ownership Delete',0),(414613,11518,'is','',0),(414614,11518,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(414615,11518,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(414616,11518,'tr','MÃ¼lkiyet sahipliÄŸi gÃ¼ncelleÅŸtirme',0),(414617,11518,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ wÅ‚asnoÅ›ci aktualizacji',0),(414618,11518,'bg','Ð˜Ð¼Ð¾Ñ‚Ð¸ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð¾Ð±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(414619,11518,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(414620,11518,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð°Ð²Ð° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾',0),(414621,11518,'vi','Báº£n Cáº­p Nháº­t quyá»n sá»Ÿ há»¯u báº¥t Ä‘á»™ng sáº£n',0),(414622,11518,'af','Eiendom eienaarskap bywerking',0),(414623,11518,'ro','Actualizare de proprietate de proprietate',0),(414624,11518,'et','Vara omandiÃµigus Update',0),(414625,11518,'si','Posodobitev lastnosti lastniÅ¡tva',0),(414626,11518,'ba','Properti kepemilikan Update',0),(414627,11518,'nl','Eigenschap Ownership Update',0),(414628,11518,'fi','KiinteistÃ¶n omistus pÃ¤ivitys',0),(414629,11518,'no','Eierskap oppdateringen',0),(414630,11518,'da','Ejendom ejerskab opdatering',0),(414631,11518,'ko','ìž¬ì‚° ì†Œìœ ê¶Œ ì—…ë°ì´íŠ¸',0),(414632,11518,'he','×¢×“×›×•×Ÿ ×‘×¢×œ×•×ª ×¢×œ ×¨×›×•×©',0),(414633,11518,'el','Î™Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î± Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(414634,11518,'zh','è´¢äº§æ‰€æœ‰æƒçš„æ›´æ–°\r\n',0),(414635,11518,'sv','Egenskapen Ã¤gande uppdatering',0),(414636,11518,'it','ProprietÃ  ProprietÃ  Update',0),(414637,11518,'tl','',0),(414638,11518,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡',0),(414639,11518,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(414640,11518,'ms','Kemaskini pemilikan harta',0),(414641,11518,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(414642,11518,'fr','PropriÃ©tÃ© propriÃ©tÃ© mise Ã  jour',0),(414643,11518,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®æ‰€æœ‰æ¨©ã®æ›´æ–°',0),(414644,11518,'pt','AtualizaÃ§Ã£o de posse de propriedade.',0),(414645,11518,'ru','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(414646,11518,'es','Actualizar Pertenencia de Propiedad',0),(414647,11518,'de','Eigenschaft Besitz Update',0),(414648,11518,'en','Property Ownership Update',0),(414649,11519,'is','',0),(414650,11519,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(414651,11519,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(414652,11519,'tr','Hata ekleme mÃ¼lkiyet',0),(414653,11519,'pl','BÅ‚Ä…d dodawania wÅ‚asnoÅ›ci',0),(414654,11519,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(414655,11519,'ur','Ù†Ù‚Øµ Ø®Ø§ØµÛŒØª Ù…Ù„Ú©ÛŒØª Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(414656,11519,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð° Ð½Ð°Ð´ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ð¾Ð¼',0),(414657,11519,'vi','Quyá»n sá»Ÿ há»¯u báº¥t Ä‘á»™ng sáº£n thÃªm lá»—i',0),(414658,11519,'af','Fout voeg eiendom besit',0),(414659,11519,'ro','Eroare adÄƒugarea de proprietate',0),(414660,11519,'et','Viga lisades omandi',0),(414661,11519,'si','Napaka pri dodajanju lastninska',0),(414662,11519,'ba','Kesalahan menambahkan kepemilikan properti',0),(414663,11519,'nl','Fout bij toevoegen van eigendom',0),(414664,11519,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ omistusoikeus',0),(414665,11519,'no','Feil Ã¥ legge eiendomsretten',0),(414666,11519,'da','Fejl tilfÃ¸je ejendomsretlige',0),(414667,11519,'ko','ì˜¤ë¥˜ ì¶”ê°€ ìž¬ì‚° ì†Œìœ ê¶Œ',0),(414668,11519,'he','×©×’×™××” ×”×•×¡×¤×ª ×”×§× ×™×Ÿ',0),(414669,11519,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(414670,11519,'zh','é”™è¯¯ï¼šæ–°å¢žè´¢äº§æ‰€æœ‰æƒ\r\n',0),(414671,11519,'sv','Fel att lÃ¤gga till Ã¤ganderÃ¤tt',0),(414672,11519,'it','Errore aggiungendo proprietÃ  immobili',0),(414673,11519,'tl','',0),(414674,11519,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡',0),(414675,11519,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥‡ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ',0),(414676,11519,'ms','Ralat menambah pemilikan hartanah',0),(414677,11519,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…Ù„ÙƒÙŠØ©',0),(414678,11519,'fr','Erreur ajout de propriÃ©tÃ©',0),(414679,11519,'jp','ã‚¨ãƒ©ãƒ¼ã®è¿½åŠ ã®è²¡ç”£ã®æ‰€æœ‰æ¨©',0),(414680,11519,'pt','Erro adicionando Propriedade',0),(414681,11519,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(414682,11519,'es','Error Agregando Pertenencia de Propiedad',0),(414683,11519,'de','Fehler hinzufÃ¼gen-Eigentum',0),(414684,11519,'en','Error Adding Property Ownership',0),(414685,11520,'is','',0),(414686,11520,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(414687,11520,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(414688,11520,'tr','MÃ¼lkiyet baÅŸarÄ±yla eklendi',0),(414689,11520,'pl','WÅ‚asnoÅ›ci dodano pomyÅ›lnie',0),(414690,11520,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(414691,11520,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(414692,11520,'sr','Ð’Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð° Ð½Ð°Ð´ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ð¾Ð¼ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(414693,11520,'vi','Quyá»n sá»Ÿ há»¯u báº¥t Ä‘á»™ng sáº£n má»›i nháº¥t Ä‘Æ°á»£c gá»­i thÃ nh cÃ´ng',0),(414694,11520,'af','Eiendom eienaarskap suksesvol bygevoeg',0),(414695,11520,'ro','Proprietate adÄƒugat cu succes',0),(414696,11520,'et','Lisatud omandi',0),(414697,11520,'si','Lastninska uspeÅ¡no dodani',0),(414698,11520,'ba','Kepemilikan properti ditambahkan berhasil',0),(414699,11520,'nl','Eigendom met succes toegevoegd',0),(414700,11520,'fi','Omistusoikeus lisÃ¤Ã¤minen onnistui',0),(414701,11520,'no','Eiendomsretten lagt',0),(414702,11520,'da','Ejendomsretlige tilfÃ¸jet',0),(414703,11520,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ìž¬ì‚° ì†Œìœ ê¶Œ',0),(414704,11520,'he','×‘×¢×œ×•×ª ×¢×œ × ×›×¡ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(414705,11520,'el','Î™Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(414706,11520,'zh','è´¢äº§æ‰€æœ‰æƒæ·»åŠ æˆåŠŸ\r\n',0),(414707,11520,'sv','Egendomsordning som lagts',0),(414708,11520,'it','ProprietÃ  aggiunto con successo',0),(414709,11520,'tl','',0),(414710,11520,'th','à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸—à¸µà¹ˆà¹€à¸žà¸´à¹ˆà¸¡à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢',0),(414711,11520,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(414712,11520,'ms','Pemilikan hartanah yang berjaya menambah',0),(414713,11520,'ar','Ø£Ø¶ÙŠÙ Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(414714,11520,'fr','PropriÃ©tÃ© ajoutÃ©e avec succÃ¨s',0),(414715,11520,'jp','è²¡ç”£ã®æ‰€æœ‰æ¨©ã¯æ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(414716,11520,'pt','Propriedade adicionada com sucesso',0),(414717,11520,'ru','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(414718,11520,'es','Pertenencia de Propiedad Agregada exitosamente',0),(414719,11520,'de','Eigentum erfolgreich hinzugefÃ¼gt',0),(414720,11520,'en','Property Ownership Added Successfully',0),(414721,11521,'is','',0),(414722,11521,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(414723,11521,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(414724,11521,'tr','BaÅŸarÄ±sÄ±z silme mÃ¼lkiyet',0),(414725,11521,'pl','Usuwanie awarii wÅ‚asnoÅ›ci',0),(414726,11521,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(414727,11521,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ø­Ø°Ù Ú©Ø±Ù†Û’ Ú©ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª',0),(414728,11521,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð±Ñ€Ð¸ÑÐ°ÑšÐ° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð° Ð½Ð°Ð´ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ð¾Ð¼',0),(414729,11521,'vi','Lá»—i xoÃ¡ quyá»n sá»Ÿ há»¯u báº¥t Ä‘á»™ng sáº£n',0),(414730,11521,'af','Mislukking skrap eiendom besit',0),(414731,11521,'ro','EÅŸecul ÅŸtergerea de proprietate',0),(414732,11521,'et','TÃµrge kustutamisel omandi',0),(414733,11521,'si','Neuspeh brisanjem lastninska',0),(414734,11521,'ba','Kegagalan menghapus properti kepemilikan',0),(414735,11521,'nl','Mislukking eigendom verwijderen',0),(414736,11521,'fi','Virhe poistettaessa omistusoikeus',0),(414737,11521,'no','Feil slette eiendomsretten',0),(414738,11521,'da','Manglende sletning ejendomsretlige',0),(414739,11521,'ko','ì‹¤íŒ¨ ì‚­ì œ ìž¬ì‚° ì†Œìœ ê¶Œ',0),(414740,11521,'he','×”×§× ×™×Ÿ ×‘×ž×—×™×§×ª ×›×©×œ',0),(414741,11521,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(414742,11521,'zh','è´¢äº§æ‰€æœ‰æƒåˆ é™¤å¤±è´¥\r\n',0),(414743,11521,'sv','Fel ta bort Ã¤ganderÃ¤tt',0),(414744,11521,'it','ProprietÃ  eliminazione guasto',0),(414745,11521,'tl','',0),(414746,11521,'th','à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(414747,11521,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥‡ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ',0),(414748,11521,'ms','Pemilikan hartanah menghapuskan kegagalan',0),(414749,11521,'ar','ÙØ´Ù„ Ø­Ø°Ù Ø®Ø§ØµÙŠØ© Ù…Ù„ÙƒÙŠØ©',0),(414750,11521,'fr','Ã‰chec de suppression propriÃ©tÃ©',0),(414751,11521,'jp','å¤±æ•—ã—ãŸå‰Šé™¤ã®è²¡ç”£ã®æ‰€æœ‰æ¨©',0),(414752,11521,'pt','Propriedade exclusÃ£o de falha',0),(414753,11521,'ru','Ð¡Ð±Ð¾Ð¹ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(414754,11521,'es','FallÃ³ Eliminando Pertenencia de Propiedad',0),(414755,11521,'de','Fehler lÃ¶schen von Eigentum',0),(414756,11521,'en','Failure Deleting Property Ownership',0),(414757,11522,'is','',0),(414758,11522,'dr','Ø­Ø°Ù  Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(414759,11522,'pr','Ø­Ø°Ù  Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(414760,11522,'tr','MÃ¼lkiyet baÅŸarÄ±yla silindi',0),(414761,11522,'pl','WÅ‚asnoÅ›ci przesâ”‚anie',0),(414762,11522,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚ Ð²ÑŠÑ€Ñ…Ñƒ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(414763,11522,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(414764,11522,'sr','Ð’Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾ Ð½Ð°Ð´ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ð¾Ð¼ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(414765,11522,'vi','Quyá»n sá»Ÿ há»¯u báº¥t Ä‘á»™ng sáº£n Ä‘Ã£ xÃ³a thÃ nh cÃ´ng',0),(414766,11522,'af','Eiendom eienaarskap suksesvol geskrap',0),(414767,11522,'ro','Proprietate eliminÄƒ cu succes',0),(414768,11522,'et','Omandi edukalt kustutatud',0),(414769,11522,'si','Lastninska uspeÅ¡no izbrisana',0),(414770,11522,'ba','Kepemilikan properti dihapus berhasil',0),(414771,11522,'nl','Eigendom met succes verwijderd',0),(414772,11522,'fi','Omistusoikeus poistettu',0),(414773,11522,'no','Eiendomsretten slettet',0),(414774,11522,'da','Ejendomsretlige slettet',0),(414775,11522,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ìž¬ì‚° ì†Œìœ ê¶Œ',0),(414776,11522,'he','×‘×¢×œ×•×ª ×ž××¤×™×™×Ÿ ×ž×—×§ ×‘×”×¦×œ×—×”',0),(414777,11522,'el','Î™Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(414778,11522,'zh','è´¢äº§æ‰€æœ‰æƒæˆåŠŸåˆ é™¤\r\n',0),(414779,11522,'sv','Egendomsordning raderades',0),(414780,11522,'it','ProprietÃ  eliminato con successo',0),(414781,11522,'tl','',0),(414782,11522,'th','à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(414783,11522,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥‡ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(414784,11522,'ms','Pemilikan hartanah yang dihapuskan dengan jayanya',0),(414785,11522,'ar','Ø­Ø°ÙØª Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(414786,11522,'fr','PropriÃ©tÃ© supprimÃ©e avec succÃ¨s',0),(414787,11522,'jp','è²¡ç”£ã®æ‰€æœ‰æ¨©ã¯æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(414788,11522,'pt','Propriedade apagada com sucesso',0),(414789,11522,'ru','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(414790,11522,'es','Pertenencia de Propiedad Eliminada Exitosamente',0),(414791,11522,'de','Eigentum erfolgreich gelÃ¶scht',0),(414792,11522,'en','Property Ownership Deleted Successfully',0),(414793,11523,'is','',0),(414794,11523,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(414795,11523,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(414796,11523,'tr','BaÅŸarÄ±sÄ±z silme mÃ¼lkiyet',0),(414797,11523,'pl','Usuwanie awarii wÅ‚asnoÅ›ci',0),(414798,11523,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(414799,11523,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ø­Ø°Ù Ú©Ø±Ù†Û’ Ú©ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª',0),(414800,11523,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð±Ñ€Ð¸ÑÐ°ÑšÐ° Ð²Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð° Ð½Ð°Ð´ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ð¾Ð¼',0),(414801,11523,'vi','Lá»—i xoÃ¡ quyá»n sá»Ÿ há»¯u báº¥t Ä‘á»™ng sáº£n',0),(414802,11523,'af','Mislukking skrap eiendom besit',0),(414803,11523,'ro','EÅŸecul ÅŸtergerea de proprietate',0),(414804,11523,'et','TÃµrge kustutamisel omandi',0),(414805,11523,'si','Neuspeh brisanjem lastninska',0),(414806,11523,'ba','Kegagalan menghapus properti kepemilikan',0),(414807,11523,'nl','Mislukking eigendom verwijderen',0),(414808,11523,'fi','Virhe poistettaessa omistusoikeus',0),(414809,11523,'no','Feil slette eiendomsretten',0),(414810,11523,'da','Manglende sletning ejendomsretlige',0),(414811,11523,'ko','ì‹¤íŒ¨ ì‚­ì œ ìž¬ì‚° ì†Œìœ ê¶Œ',0),(414812,11523,'he','×”×§× ×™×Ÿ ×‘×ž×—×™×§×ª ×›×©×œ',0),(414813,11523,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(414814,11523,'zh','è´¢äº§æ‰€æœ‰æƒåˆ é™¤å¤±è´¥\r\n',0),(414815,11523,'sv','Fel ta bort Ã¤ganderÃ¤tt',0),(414816,11523,'it','ProprietÃ  eliminazione guasto',0),(414817,11523,'tl','',0),(414818,11523,'th','à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(414819,11523,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥‡ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ',0),(414820,11523,'ms','Pemilikan hartanah menghapuskan kegagalan',0),(414821,11523,'ar','ÙØ´Ù„ Ø­Ø°Ù Ø®Ø§ØµÙŠØ© Ù…Ù„ÙƒÙŠØ©',0),(414822,11523,'fr','Ã‰chec de suppression propriÃ©tÃ©',0),(414823,11523,'jp','å¤±æ•—ã—ãŸå‰Šé™¤ã®è²¡ç”£ã®æ‰€æœ‰æ¨©',0),(414824,11523,'pt','Propriedade exclusÃ£o de falha',0),(414825,11523,'ru','Ð¡Ð±Ð¾Ð¹ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(414826,11523,'es','FallÃ³ Eliminando Pertenencia de Propiedad',0),(414827,11523,'de','Fehler lÃ¶schen von Eigentum',0),(414828,11523,'en','Failure Deleting Property Ownership',0),(414829,11524,'is','',0),(414830,11524,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(414831,11524,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù…Ø§Ù„ÙƒÙŠØª Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(414832,11524,'tr','MÃ¼lkiyet baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(414833,11524,'pl','WÅ‚asnoÅ›ci pomyÅ›lnie zaktualizowana',0),(414834,11524,'bg','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(414835,11524,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù…Ù„Ú©ÛŒØª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(414836,11524,'sr','Ð’Ð»Ð°ÑÐ½Ð¸ÑˆÑ‚Ð²Ð¾ Ð½Ð°Ð´ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ð¾Ð¼ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(414837,11524,'vi','Quyá»n sá»Ÿ há»¯u báº¥t Ä‘á»™ng sáº£n Cáº­p Nháº­t thÃ nh cÃ´ng',0),(414838,11524,'af','Eiendom eienaarskap suksesvol bygewerk',0),(414839,11524,'ro','Proprietate actualizat cu succes',0),(414840,11524,'et','VÃ¤rskendatud omandi',0),(414841,11524,'si','Lastninska uspeÅ¡no posodobljena',0),(414842,11524,'ba','Kepemilikan properti yang berhasil',0),(414843,11524,'nl','Eigendom met succes bijgewerkt',0),(414844,11524,'fi','PÃ¤ivitetty omistusoikeus',0),(414845,11524,'no','Eiendomsretten oppdatert',0),(414846,11524,'da','Ejendomsretlige opdateret',0),(414847,11524,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ìž¬ì‚° ì†Œìœ ê¶Œ',0),(414848,11524,'he','×”×§× ×™×Ÿ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(414849,11524,'el','Î™Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(414850,11524,'zh','è´¢äº§æ‰€æœ‰æƒå·²æˆåŠŸæ›´æ–°\r\n',0),(414851,11524,'sv','Egendomsordning uppdaterats',0),(414852,11524,'it','ProprietÃ  immobili aggiornato con successo',0),(414853,11524,'tl','',0),(414854,11524,'th','à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹€à¸ˆà¹‰à¸²à¸‚à¸­à¸‡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(414855,11524,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥‡ à¤¸à¥à¤µà¤¾à¤®à¤¿à¤¤à¥à¤µ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(414856,11524,'ms','Pemilikan hartanah yang berjaya dikemas kini',0),(414857,11524,'ar','Ø­Ø¯Ù‘Ø«Øª Ù…Ù„ÙƒÙŠØ© Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(414858,11524,'fr','PropriÃ©tÃ© mis Ã  jour avec succÃ¨s',0),(414859,11524,'jp','è²¡ç”£ã®æ‰€æœ‰æ¨©ã¯æ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(414860,11524,'pt','Propriedade atualizada com sucesso',0),(414861,11524,'ru','Ð¡Ð¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(414862,11524,'es','Pertenencia de Propiedad Actualizada Exitosamente',0),(414863,11524,'de','Eigentumsordnung, die erfolgreich aktualisiert',0),(414864,11524,'en','Property Ownership Updated Successfully',0),(414865,11525,'is','',0),(414866,11525,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†ÙˆØ§Ø¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414867,11525,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†ÙˆØ§Ø¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414868,11525,'tr','Ã–zellik tÃ¼rleri ekleme',0),(414869,11525,'pl','Typy nieruchomoÅ›ci Dodaj',0),(414870,11525,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(414871,11525,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(414872,11525,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÑÑ‚Ðµ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ðµ',0),(414873,11525,'vi','Loáº¡i tÃ i sáº£n thÃªm',0),(414874,11525,'af','Eiendomstipes Bygevoeg',0),(414875,11525,'ro','Adauga tipuri de proprietate',0),(414876,11525,'et','Atribuutide liigid lisada',0),(414877,11525,'si','Vrste lastnosti dodajte',0),(414878,11525,'ba','Menambahkan jenis properti',0),(414879,11525,'nl','Eigenschap typen toevoegen',0),(414880,11525,'fi','Alkiotyyppien lisÃ¤Ã¤',0),(414881,11525,'no','Egenskapstyper legge',0),(414882,11525,'da','Egenskabstyper tilfÃ¸je',0),(414883,11525,'ko','ì†ì„± í˜•ì‹ ì¶”ê°€',0),(414884,11525,'he','×œ×”×•×¡×™×£ ×¡×•×’×™ × ×›×¡×™×',0),(414885,11525,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï„ÏÏ€Î¿Ï…Ï‚ Î±ÎºÎ¹Î½Î®Ï„Ï‰Î½',0),(414886,11525,'zh','ç‰©ä¸šç±»åž‹æ·»åŠ \r\n',0),(414887,11525,'sv','Egenskapstyper lÃ¤gga till',0),(414888,11525,'it','Aggiungere i tipi di proprietÃ .',0),(414889,11525,'tl','',0),(414890,11525,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸Šà¸™à¸´à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(414891,11525,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(414892,11525,'ms','Tambah jenis harta tanah',0),(414893,11525,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ù…Ù„ÙƒÙŠØ©',0),(414894,11525,'fr','Ajouter des Types de propriÃ©tÃ©',0),(414895,11525,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®ç¨®é¡žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(414896,11525,'pt','Adicionar tipos de propriedade.',0),(414897,11525,'ru','Ð¢Ð¸Ð¿Ñ‹ ÑÐ²Ð¾Ð¹ÑÑ‚Ð² Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(414898,11525,'es','\r\nAgregar Tipos de Propiedad',0),(414899,11525,'de','Eigenschaftentypen hinzufÃ¼gen',0),(414900,11525,'en','Property Types Add',0),(414901,11526,'is','',0),(414902,11526,'dr','Ø­Ø°Ù Ø§Ù†ÙˆØ§Ø¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414903,11526,'pr','Ø­Ø°Ù Ø§Ù†ÙˆØ§Ø¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(414904,11526,'tr','Ã–zellik tÃ¼rÃ¼ Sil',0),(414905,11526,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ typy Delete',0),(414906,11526,'bg','Ð˜Ð¼Ð¾Ñ‚Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(414907,11526,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(414908,11526,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð²Ñ€ÑÑ‚Ðµ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ðµ',0),(414909,11526,'vi','XÃ³a loáº¡i báº¥t Ä‘á»™ng sáº£n',0),(414910,11526,'af','Eiendomstipes Geskrap',0),(414911,11526,'ro','Åžtergere de tipuri de proprietate',0),(414912,11526,'et','Atribuudi liigid kustutamine',0),(414913,11526,'si','Lastnost vrste IzbriÅ¡i',0),(414914,11526,'ba','Hapus jenis properti',0),(414915,11526,'nl','Eigenschap typen verwijderen',0),(414916,11526,'fi','Ominaisuuden tyypin Poista',0),(414917,11526,'no','Egenskapen typer Slett',0),(414918,11526,'da','Ejendom typer slet',0),(414919,11526,'ko','ì†ì„± í˜•ì‹ ì‚­ì œ',0),(414920,11526,'he','×ž××¤×™×™×Ÿ ×ž×—×§ ×¡×•×’×™',0),(414921,11526,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„ÏÏ€Î¿Î¹ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(414922,11526,'zh','ç‰©ä¸šç±»åž‹åˆ é™¤\r\n',0),(414923,11526,'sv','Ta bort egenskapen typer',0),(414924,11526,'it','Elimina tipi di proprietÃ .',0),(414925,11526,'tl','',0),(414926,11526,'th','à¸¥à¸šà¸Šà¸™à¸´à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(414927,11526,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(414928,11526,'ms','Harta jenis Hapus',0),(414929,11526,'ar','Ø­Ø°Ù Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ù…Ù„ÙƒÙŠØ©',0),(414930,11526,'fr','Suppression de Types de propriÃ©tÃ©',0),(414931,11526,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®ç¨®é¡žã®å‰Šé™¤',0),(414932,11526,'pt','Excluir tipos de propriedade.',0),(414933,11526,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð¾Ð² ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(414934,11526,'es','Eliminar Tipos de Propiedad',0),(414935,11526,'de','Eigenschaft Arten lÃ¶schen',0),(414936,11526,'en','Property Types Delete',0),(414937,11527,'is','',0),(414938,11527,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†ÙˆØ§Ø¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(414939,11527,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø§Ù†ÙˆØ§Ø¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(414940,11527,'tr','Ã–zellik tÃ¼rlerini gÃ¼ncelleÅŸtirme',0),(414941,11527,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ typy aktualizacji',0),(414942,11527,'bg','Ð¢Ð¸Ð¿Ð¾Ð²Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(414943,11527,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù… ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(414944,11527,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð°Ð²Ð° Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸',0),(414945,11527,'vi','Báº¥t Ä‘á»™ng sáº£n cÃ¡c loáº¡i Cáº­p Nháº­t',0),(414946,11527,'af','Eiendomstipes Opdateer',0),(414947,11527,'ro','Actualizare de tipuri de proprietate',0),(414948,11527,'et','Atribuudi liigid Update',0),(414949,11527,'si','Vrste posodobitev lastnosti',0),(414950,11527,'ba','Properti jenis Update',0),(414951,11527,'nl','Eigenschap typen Update',0),(414952,11527,'fi','Ominaisuuden tyypin pÃ¤ivitys',0),(414953,11527,'no','Typer oppdateringen',0),(414954,11527,'da','Ejendom typer opdatering',0),(414955,11527,'ko','ì†ì„± í˜•ì‹ ì—…ë°ì´íŠ¸',0),(414956,11527,'he','×”×ž××¤×™×™×Ÿ ×¡×•×’×™ ×¢×“×›×•×Ÿ',0),(414957,11527,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿Î¹ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(414958,11527,'zh','ç‰©ä¸šç±»åž‹æ›´æ–°\r\n',0),(414959,11527,'sv','Egenskapen typer uppdatering',0),(414960,11527,'it','Aggiornamento tipi di proprietÃ .',0),(414961,11527,'tl','',0),(414962,11527,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸Šà¸™à¸´à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(414963,11527,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(414964,11527,'ms','Kemaskini jenis harta',0),(414965,11527,'ar','ØªØ­Ø¯ÙŠØ« Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ù…Ù„ÙƒÙŠØ©',0),(414966,11527,'fr','Mise Ã  jour des Types de propriÃ©tÃ©s',0),(414967,11527,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®åž‹ã®æ›´æ–°',0),(414968,11527,'pt','AtualizaÃ§Ã£o de tipos de propriedade.',0),(414969,11527,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð¸Ð¿Ð¾Ð² ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(414970,11527,'es','Actualizar Tipos de Propiedad',0),(414971,11527,'de','Eigenschaft Arten Update',0),(414972,11527,'en','Property Types Update',0),(414973,11528,'is','',0),(414974,11528,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(414975,11528,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(414976,11528,'tr','Ã–zellik tÃ¼rÃ¼ baÅŸarÄ±yla eklendi',0),(414977,11528,'pl','Typ nieruchomoÅ›ci dodane pomyÅ›lnie',0),(414978,11528,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(414979,11528,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(414980,11528,'sr','Ð¢Ð¸Ð¿ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(414981,11528,'vi','Loáº¡i tÃ i sáº£n Ä‘Æ°á»£c gá»­i thÃ nh cÃ´ng',0),(414982,11528,'af','Eiendomstipe Suksesvol Bygevoeg',0),(414983,11528,'ro','Tip de proprietate adÄƒugat cu succes',0),(414984,11528,'et','Lisatud atribuuditÃ¼Ã¼p',0),(414985,11528,'si','Vrsta nepremiÄnine uspeÅ¡no dodani',0),(414986,11528,'ba','Jenis properti yang ditambahkan berhasil',0),(414987,11528,'nl','Eigenschapstype toegevoegd',0),(414988,11528,'fi','KiinteistÃ¶tyyppi lisÃ¤Ã¤minen onnistui',0),(414989,11528,'no','Egenskapstypen lagt',0),(414990,11528,'da','Egenskabstype tilfÃ¸jet',0),(414991,11528,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ì†ì„± í˜•ì‹',0),(414992,11528,'he','×¡×•×’ ×ž××¤×™×™×Ÿ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(414993,11528,'el','Î¤ÏÏ€Î¿Ï‚ Î±ÎºÎ¹Î½Î®Ï„Î¿Ï… Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(414994,11528,'zh','ç‰©ä¸šç±»åž‹æ·»åŠ æˆåŠŸ\r\n',0),(414995,11528,'sv','Egenskapstyp som lagts',0),(414996,11528,'it','Tipo di proprietÃ  aggiunto con successo',0),(414997,11528,'tl','',0),(414998,11528,'th','à¸Šà¸™à¸´à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(414999,11528,'hi','à¤—à¥à¤£ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(415000,11528,'ms','Jenis harta yang berjaya menambah',0),(415001,11528,'ar','Ø£Ø¶ÙŠÙ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(415002,11528,'fr','Type de propriÃ©tÃ© ajoutÃ©e avec succÃ¨s',0),(415003,11528,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®åž‹',0),(415004,11528,'pt','Tipo de propriedade adicionado com sucesso',0),(415005,11528,'ru','Ð¢Ð¸Ð¿ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(415006,11528,'es','Tipo de Propiedad Agregado Exitosamente',0),(415007,11528,'de','Immobilienart erfolgreich hinzugefÃ¼gt',0),(415008,11528,'en','Property Type Added Successfully',0),(415009,11529,'is','',0),(415010,11529,'dr','Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ù‡ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù¾ÙŠÙˆØ³Øª Ø´Ø¯',0),(415011,11529,'pr','Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ù‡ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ù¾ÙŠÙˆØ³Øª Ø´Ø¯',0),(415012,11529,'tr','Ã–zellik iÃ§in iliÅŸtirilmiÅŸ Ã¶zellik tÃ¼rÃ¼',0),(415013,11529,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ typ doÅ‚Ä…czone do WÅ‚aÅ›ciwoÅ›Ä‡',0),(415014,11529,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚Ð°, Ð¿Ñ€Ð¸ÐºÑ€ÐµÐ¿ÐµÐ½Ð¸ ÐºÑŠÐ¼ Ð¸Ð¼Ð¾Ñ‚Ð°',0),(415015,11529,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª Ú©ÛŒ Ø®ØµÙˆØµÛŒØª Ù…ÛŒÚº Ø³Û’ Ù…Ù†Ø³Ù„Ú©',0),(415016,11529,'sr','Ð¢Ð¸Ð¿ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð° Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ðµ Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ðµ',0),(415017,11529,'vi','Loáº¡i tÃ i sáº£n gáº¯n liá»n vá»›i báº¥t Ä‘á»™ng sáº£n',0),(415018,11529,'af','Eiendomstipe is Verbind met Eiendom',0),(415019,11529,'ro','Tip de proprietate ataÅŸat la proprietate',0),(415020,11529,'et','Seotud kinnisvara kinnisvara tÃ¼Ã¼p',0),(415021,11529,'si','Vrsta nepremiÄnine pripadajo lastnine',0),(415022,11529,'ba','Jenis properti yang melekat pada properti',0),(415023,11529,'nl','Eigenschap van het Type gekoppeld aan eigenschap',0),(415024,11529,'fi','KiinteistÃ¶tyyppi liittÃ¤Ã¤ ominaisuuteen',0),(415025,11529,'no','Egenskapstypen knyttet til egenskapen',0),(415026,11529,'da','Egenskabstype knyttet til ejendom',0),(415027,11529,'ko','ì†ì„± í˜•ì‹ ì†ì„±ì— ì—°ê²° ëœ',0),(415028,11529,'he','×¡×•×’ ×”× ×›×¡ ×”×ž×•×¦×ž×“ ×”×ž××¤×™×™×Ÿ',0),(415029,11529,'el','Î¤ÏÏ€Î¿Ï‚ Î±ÎºÎ¹Î½Î®Ï„Î¿Ï… Ï€Î¿Ï… ÏƒÏ…Î½Î´Î­Î¿Î½Ï„Î±Î¹ Î¼Îµ Ï„Î·Î½ Î¹Î´Î¹ÏŒÏ„Î·Ï„Î±',0),(415030,11529,'zh','ç‰©ä¸šç±»åž‹ç‰©ä¸šé™„\r\n',0),(415031,11529,'sv','Egenskapstypen bifogas egendom',0),(415032,11529,'it','Tipo di proprietÃ  associata alla proprietÃ ',0),(415033,11529,'tl','',0),(415034,11529,'th','à¸à¸±à¸šà¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸Šà¸™à¸´à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(415035,11529,'hi','à¤—à¥à¤£ à¤ªà¥à¤°à¤•à¤¾à¤° à¤…à¤¨à¥à¤²à¤—à¥à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿',0),(415036,11529,'ms','Jenis harta tanah yang melekat pada harta',0),(415037,11529,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø®Ø§ØµÙŠØ© Ù…Ù„Ø­Ù‚Ø© Ø¨Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(415038,11529,'fr','Type de propriÃ©tÃ© attachÃ©e pour la propriÃ©tÃ©',0),(415039,11529,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã‚’æ·»ä»˜ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®åž‹',0),(415040,11529,'pt','Tipo de Propriedade anexado a propriedade.',0),(415041,11529,'ru','Ð¢Ð¸Ð¿ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°, Ð¿Ñ€Ð¸Ð´Ð°ÐµÑ‚ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(415042,11529,'es','Tipo de Propiedad Anexado a la Propiedad',0),(415043,11529,'de','Immobilienart angefÃ¼gte Eigenschaft',0),(415044,11529,'en','Property Type Attached To Property',0),(415045,11530,'is','',0),(415046,11530,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415047,11530,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415048,11530,'tr','BaÅŸarÄ±sÄ±z silme Ã¶zelliÄŸi tÃ¼rÃ¼',0),(415049,11530,'pl','Usuwanie awarii Typ nieruchomoÅ›ci',0),(415050,11530,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ñ‚Ð¸Ð¿ Ð¸Ð¼Ð¾Ñ‚',0),(415051,11530,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ø­Ø°Ù Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª',0),(415052,11530,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð±Ñ€Ð¸ÑÐ°ÑšÐ° Ñ‚Ð¸Ð¿ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð°',0),(415053,11530,'vi','Loáº¡i tÃ i sáº£n xÃ³a bá» tháº¥t báº¡i',0),(415054,11530,'af','Faal om Eiendomstipe te Skrap',0),(415055,11530,'ro','Tip de proprietate ÅŸtergerea eÅŸec',0),(415056,11530,'et','TÃµrge kustutamisel atribuuditÃ¼Ã¼p',0),(415057,11530,'si','Neuspeh brisanjem Vrsta nepremiÄnine',0),(415058,11530,'ba','Kegagalan menghapus jenis properti',0),(415059,11530,'nl','Mislukking verwijderen eigenschap van het Type',0),(415060,11530,'fi','Virhe poistettaessa ominaisuuden tyyppi',0),(415061,11530,'no','Feil slette egenskapstype',0),(415062,11530,'da','Manglende sletning egenskabstype',0),(415063,11530,'ko','ì‹¤íŒ¨ ì‚­ì œ ì†ì„± ìœ í˜•',0),(415064,11530,'he','×¡×•×’ ×”× ×›×¡ ×‘×ž×—×™×§×ª ×›×©×œ',0),(415065,11530,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ Î¤ÏÏ€Î¿Ï‚ Î±ÎºÎ¹Î½Î®Ï„Î¿Ï…',0),(415066,11530,'zh','ç‰©ä¸šç±»åž‹åˆ é™¤å¤±è´¥\r\n',0),(415067,11530,'sv','Fel ta bort egenskapstyp',0),(415068,11530,'it','Tipo di proprietÃ  eliminazione guasto',0),(415069,11530,'tl','',0),(415070,11530,'th','à¸Šà¸™à¸´à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(415071,11530,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤—à¥à¤£ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(415072,11530,'ms','Jenis harta menghapuskan kegagalan',0),(415073,11530,'ar','ÙØ´Ù„ Ø­Ø°Ù Ø®Ø§ØµÙŠØ© Ù†ÙˆØ¹',0),(415074,11530,'fr','Type de propriÃ©tÃ© suppression Ã©chec',0),(415075,11530,'jp','å¤±æ•—ã—ãŸå‰Šé™¤ã™ã‚‹ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®åž‹',0),(415076,11530,'pt','Tipo de propriedade exclusÃ£o de falha',0),(415077,11530,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð° Ð¢Ð¸Ð¿ ÑÐ±Ð¾Ñ',0),(415078,11530,'es','FallÃ³ Eliminando Tipo de Propiedad',0),(415079,11530,'de','LÃ¶schen von Eigenschaft Fehlertyp.',0),(415080,11530,'en','Failure Deleting Property Type',0),(415081,11531,'is','',0),(415082,11531,'dr','Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(415083,11531,'pr','Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(415084,11531,'tr','Ã–zellik tÃ¼rÃ¼ baÅŸarÄ±yla silindi',0),(415085,11531,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ typ przesâ”‚anie',0),(415086,11531,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚Ð°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(415087,11531,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ø´Ø¯Û Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª',0),(415088,11531,'sr','Ð¢Ð¸Ð¿ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(415089,11531,'vi','Loáº¡i tÃ i sáº£n Ä‘Ã£ xÃ³a thÃ nh cÃ´ng',0),(415090,11531,'af','Eiendomstipe Suksesvol Geskrap',0),(415091,11531,'ro','Tip de proprietate eliminÄƒ cu succes',0),(415092,11531,'et','Atribuudi tÃ¼Ã¼p edukalt kustutatud',0),(415093,11531,'si','Vrsta nepremiÄnine uspeÅ¡no izbrisana',0),(415094,11531,'ba','Jenis properti yang berhasil dihapus',0),(415095,11531,'nl','Eigenschapstype met succes verwijderd',0),(415096,11531,'fi','KiinteistÃ¶tyyppi poistettu',0),(415097,11531,'no','Egenskapstypen slettet',0),(415098,11531,'da','Egenskabstype slettet',0),(415099,11531,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ì¢…ë¥˜',0),(415100,11531,'he','×¡×•×’ ×ž××¤×™×™×Ÿ ×ž×—×§ ×‘×”×¦×œ×—×”',0),(415101,11531,'el','Î¤ÏÏ€Î¿Ï‚ Î±ÎºÎ¹Î½Î®Ï„Î¿Ï… Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(415102,11531,'zh','ç‰©ä¸šç±»åž‹æˆåŠŸåˆ é™¤\r\n',0),(415103,11531,'sv','Egenskapstypen raderades',0),(415104,11531,'it','Tipo di proprietÃ  eliminato con successo',0),(415105,11531,'tl','',0),(415106,11531,'th','à¸Šà¸™à¸´à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(415107,11531,'hi','à¤—à¥à¤£ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(415108,11531,'ms','Jenis harta yang dihapuskan dengan jayanya',0),(415109,11531,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(415110,11531,'fr','Type de propriÃ©tÃ© supprimÃ© avec succÃ¨s',0),(415111,11531,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®åž‹ã¯æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(415112,11531,'pt','Tipo de propriedade apagado com sucesso',0),(415113,11531,'ru','Ð¢Ð¸Ð¿ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(415114,11531,'es','Tipo de Propiedad Eliminado Exitosamente',0),(415115,11531,'de','Immobilienart erfolgreich gelÃ¶scht',0),(415116,11531,'en','Property Type Deleted Successfully',0),(415117,11532,'is','',0),(415118,11532,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415119,11532,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415120,11532,'tr','BaÅŸarÄ±sÄ±zlÄ±k gÃ¼ncelleÅŸtirme Ã¶zelliÄŸi tÃ¼rÃ¼',0),(415121,11532,'pl','Brak aktualizacji wÅ‚aÅ›ciwoÅ›Ä‡ typu',0),(415122,11532,'bg','ÐÐµÑƒÑÐ¿ÐµÑ… Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ñ‚Ð¸Ð¿ Ð¸Ð¼Ð¾Ñ‚',0),(415123,11532,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª',0),(415124,11532,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ñ‚Ð¸Ð¿ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð°',0),(415125,11532,'vi','Loáº¡i tÃ i sáº£n tháº¥t báº¡i Cáº­p Nháº­t',0),(415126,11532,'af','Faal om Eiendomstipe Op te Dateer',0),(415127,11532,'ro','EÅŸecul actualizarea tip de proprietate',0),(415128,11532,'et','TÃµrge vÃ¤rskendamisel atribuuditÃ¼Ã¼p',0),(415129,11532,'si','Neuspeh posodabljanje Vrsta nepremiÄnine',0),(415130,11532,'ba','Jenis properti memperbarui kegagalan',0),(415131,11532,'nl','Type van de eigenschap mislukking bijwerken',0),(415132,11532,'fi','EpÃ¤onnistuminen pÃ¤ivittÃ¤Ã¤ ominaisuuden tyyppi',0),(415133,11532,'no','Feil oppdatering egenskapstype',0),(415134,11532,'da','Manglende opdatering egenskabstype',0),(415135,11532,'ko','ì‹¤íŒ¨ ì—…ë°ì´íŠ¸ ì†ì„± ìœ í˜•',0),(415136,11532,'he','×¡×•×’ ×”× ×›×¡ ×”×ž×¢×“×›× ×ª ×›×©×œ',0),(415137,11532,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Î¤ÏÏ€Î¿Ï‚ Î±ÎºÎ¹Î½Î®Ï„Î¿Ï…',0),(415138,11532,'zh','ç‰©ä¸šç±»åž‹æ›´æ–°å¤±è´¥\r\n',0),(415139,11532,'sv','Misslyckande uppdatera egenskapstyp',0),(415140,11532,'it','Tipo di proprietÃ  aggiornamento errore',0),(415141,11532,'tl','',0),(415142,11532,'th','à¸Šà¸™à¸´à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¹ƒà¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(415143,11532,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤‚à¤ªà¤¦à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(415144,11532,'ms','Kegagalan pengemaskinian harta tanah jenis',0),(415145,11532,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø®Ø§ØµÙŠØ© Ù†ÙˆØ¹',0),(415146,11532,'fr','Type de propriÃ©tÃ© Ã©chec mise Ã  jour',0),(415147,11532,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ ã‚¿ã‚¤ãƒ—ã®æ›´æ–°ã«å¤±æ•—',0),(415148,11532,'pt','Tipo de propriedade atualizaÃ§Ã£o falha',0),(415149,11532,'ru','Ð¢Ð¸Ð¿ ÑÐ±Ð¾Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(415150,11532,'es','FallÃ³ Actualizando Tipo de Propiedad',0),(415151,11532,'de','Aktualisierung-Eigenschaft Fehlertyp.',0),(415152,11532,'en','Failure Updating Property Type',0),(415153,11533,'is','',0),(415154,11533,'dr','Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(415155,11533,'pr','Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯ ',0),(415156,11533,'tr','Ã–zellik tÃ¼rÃ¼ baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(415157,11533,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ typ pomyÅ›lnie zaktualizowana',0),(415158,11533,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(415159,11533,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù†ÙˆØ¹ÛŒØª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(415160,11533,'sr','Ð¢Ð¸Ð¿ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(415161,11533,'vi','Loáº¡i tÃ i sáº£n Cáº­p Nháº­t thÃ nh cÃ´ng',0),(415162,11533,'af','Eiendomstipe Suksesvol Opdateer',0),(415163,11533,'ro','Tip de proprietate actualizat cu succes',0),(415164,11533,'et','Atribuudi tÃ¼Ã¼p vÃ¤rskendamine Ãµnnestus',0),(415165,11533,'si','Vrsta nepremiÄnine uspeÅ¡no posodobljena',0),(415166,11533,'ba','Jenis properti yang berhasil',0),(415167,11533,'nl','Eigenschapstype bijgewerkt',0),(415168,11533,'fi','KiinteistÃ¶tyyppi pÃ¤ivitetty',0),(415169,11533,'no','Egenskapstypen oppdatert',0),(415170,11533,'da','Egenskabstype opdateret',0),(415171,11533,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì†ì„± í˜•ì‹',0),(415172,11533,'he','×¡×•×’ ×”× ×›×¡ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(415173,11533,'el','Î¤ÏÏ€Î¿Ï‚ Î±ÎºÎ¹Î½Î®Ï„Î¿Ï… Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(415174,11533,'zh','ç‰©ä¸šç±»åž‹æˆåŠŸæ›´æ–°\r\n',0),(415175,11533,'sv','Egenskapstypen uppdaterats',0),(415176,11533,'it','Tipo di proprietÃ , aggiornato con successo',0),(415177,11533,'tl','',0),(415178,11533,'th','à¸Šà¸™à¸´à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(415179,11533,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤‚à¤ªà¤¦à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(415180,11533,'ms','Jenis harta yang berjaya dikemas kini',0),(415181,11533,'ar','Ø­Ø¯Ù‘Ø« Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(415182,11533,'fr','Type de propriÃ©tÃ©, mis Ã  jour avec succÃ¨s',0),(415183,11533,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®åž‹',0),(415184,11533,'pt','Tipo de propriedade atualizado com sucesso',0),(415185,11533,'ru','Ð¢Ð¸Ð¿ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(415186,11533,'es','Tipo de Propiedad Actualizado Exitosamente',0),(415187,11533,'de','Immobilienart erfolgreich aktualisiert',0),(415188,11533,'en','Property Type Updated Successfully',0),(415189,11534,'is','',0),(415190,11534,'dr','12Ù…Ø§Ù‡ Ø¬Ø§Ø±ÛŒ',0),(415191,11534,'pr','Ù…ØªÙˆØ³Ø· 12Ù…Ø§Ù‡ Ø¬Ø§Ø±ÛŒ',0),(415192,11534,'tr','12 aylÄ±k Hareketli Ort',0),(415193,11534,'pl','12-miesiÄ™cznego ruchu Avg',0),(415194,11534,'bg','12-Ð¼ÐµÑÐµÑ‡ÐµÐ½ Ð´Ð²Ð¸Ð¶Ð¸ Avg',0),(415195,11534,'ur','12 Ù…Ø§Û Ø³Ø§Ú©Øª Ø§ÙˆØ³Ø·',0),(415196,11534,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚Ð½Ð¸ ÐÐ²Ð³ 12 Ð¼ÐµÑÐµÑ†Ð¸',0),(415197,11534,'vi','Trung bÃ¬nh chuyá»ƒn Ä‘á»™ng 12 thÃ¡ng',0),(415198,11534,'af','12-Maande Bewegende Gemidd.',0),(415199,11534,'ro','12 luni Ã®n miÅŸcare Avg',0),(415200,11534,'et','12 kuu libisev Avg',0),(415201,11534,'si','12-meseÄno drseÄe Avg',0),(415202,11534,'ba','12-Bulan Rata-rata pergerakan',0),(415203,11534,'nl','12-maand bewegende Avg',0),(415204,11534,'fi','12 kuukauden liukuva Avg',0),(415205,11534,'no','12-mÃ¥neders glidende Avg',0),(415206,11534,'da','12-mÃ¥neders flytter Avg',0),(415207,11534,'ko','12 ê°œì›” ì´ë™ í‰ê· ',0),(415208,11534,'he','×ž×ž×•×¦×¢ × ×¢ 12 ×—×•×“×©×™×',0),(415209,11534,'el','12-Î¼Î·Î½Î· ÎºÎ¹Î½ÎµÎ¯Ï„Î±Î¹ Avg',0),(415210,11534,'zh','12ä¸ªæœˆç§»åŠ¨å¹³å‡å€¼\r\n',0),(415211,11534,'sv','12-MÃ¥naders glidande medelvÃ¤rde',0),(415212,11534,'it','Avg mobile di 12 mesi',0),(415213,11534,'tl','',0),(415214,11534,'th','12-à¹€à¸”à¸·à¸­à¸™à¸¢à¹‰à¸²à¸¢ Avg',0),(415215,11534,'hi','12 à¤®à¤¹à¥€à¤¨à¥‡ à¤šà¤²à¤¤à¥€ à¤”à¤¸à¤¤',0),(415216,11534,'ms','12 bulan bergerak Avg',0),(415217,11534,'ar','12-Ø´Ù‡Ø± Ù…ØªÙˆØ³Ø· Ù…ØªØ­Ø±Ùƒ',0),(415218,11534,'fr','Moyenne Mobile sur 12 Mois',0),(415219,11534,'jp','12 ãƒ¶æœˆç§»å‹•å¹³å‡',0),(415220,11534,'pt','Avg em movimento de 12 meses',0),(415221,11534,'ru','12-Ð¼ÐµÑÑÑ‡Ð½Ñ‹Ð¹ Ð´Ð²Ð¸Ð¶ÑƒÑ‰Ð¸Ñ…ÑÑ Avg',0),(415222,11534,'es','Media MÃ³vil de 12 Meses',0),(415223,11534,'de','12 Monate verschieben Avg',0),(415224,11534,'en','12-Month Moving Avg',0),(415225,11535,'is','',0),(415226,11535,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‡Ù…Ù‡ ',0),(415227,11535,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‡Ù…Ù‡ ',0),(415228,11535,'tr','TÃ¼mÃ¼nÃ¼ SeÃ§',0),(415229,11535,'pl','Wybierz wszystkie',0),(415230,11535,'bg','Ð˜Ð·Ð±ÐµÑ€Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸',0),(415231,11535,'ur','ØªÙ…Ø§Ù… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(415232,11535,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸ ÑÐ²Ðµ',0),(415233,11535,'vi','Chá»n táº¥t cáº£',0),(415234,11535,'af','Kies alles',0),(415235,11535,'ro','SelectaÅ£i toate',0),(415236,11535,'et','Vali kÃµik',0),(415237,11535,'si','Izberi vse',0),(415238,11535,'ba','Pilih Semua',0),(415239,11535,'nl','Selecteer alle',0),(415240,11535,'fi','Valitse kaikki',0),(415241,11535,'no','Velg alle',0),(415242,11535,'da','VÃ¦lg alle',0),(415243,11535,'ko','ëª¨ë‘ ì„ íƒ',0),(415244,11535,'he','×‘×—×¨ ×”×›×œ',0),(415245,11535,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÏŒÎ»Ï‰Î½',0),(415246,11535,'zh','å…¨é€‰\r\n',0),(415247,11535,'sv','Markera alla',0),(415248,11535,'it','Seleziona tutto',0),(415249,11535,'tl','',0),(415250,11535,'th','à¹€à¸¥à¸·à¸­à¸à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(415251,11535,'hi','à¤¸à¤­à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(415252,11535,'ms','Pilih semua',0),(415253,11535,'ar','Ø­Ø¯Ø¯ ÙƒØ§ÙØ©',0),(415254,11535,'fr','SÃ©lectionner tout',0),(415255,11535,'jp','ã™ã¹ã¦ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(415256,11535,'pt','Selecionar tudo',0),(415257,11535,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð’ÑÐµ',0),(415258,11535,'es','Selecciona Todo',0),(415259,11535,'de','WÃ¤hlen Sie alle',0),(415260,11535,'en','Select All',0),(415261,11536,'is','',0),(415262,11536,'dr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ  Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„  Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(415263,11536,'pr','Ø¯Ø§Ø±Ø§Ø¦ÙŠ  Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„  Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯ ',0),(415264,11536,'tr','Emlak emlak vergisi eklemek iÃ§in BorÃ§lar',0),(415265,11536,'pl','Podatek od nieruchomoÅ›ci nieruchomoÅ›ci Dodaj do zobowiÄ…zania',0),(415266,11536,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº ÐºÑŠÐ¼ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(415267,11536,'ur','Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ù¹ÛŒÚ©Ø³ Ø³Û’ Ø¬Ù…Ø¹ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(415268,11536,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(415269,11536,'vi','Báº¥t Ä‘á»™ng sáº£n báº¥t Ä‘á»™ng sáº£n thuáº¿ thÃªm vÃ o Payables',0),(415270,11536,'af','Eiendom Eiendomsbelasting Byvoeg By Uitgawes (RB)',0),(415271,11536,'ro','Impozitul pe proprietate adÄƒuga la datorii',0),(415272,11536,'et','Kinnisvara maamaks lisada vÃµlad',0),(415273,11536,'si','Davek na nepremiÄnine dodati obveznosti',0),(415274,11536,'ba','Pajak properti properti menambah hutang',0),(415275,11536,'nl','Eigenschap onroerende voorheffing toevoegen aan schulden',0),(415276,11536,'fi','KiinteistÃ¶ kiinteistÃ¶vero lisÃ¤Ã¤minen ostojen',0),(415277,11536,'no','Egenskapen eiendomsskatt legge til leverandÃ¸rgjeld',0),(415278,11536,'da','Ejendom ejendomsskat tilfÃ¸je til gÃ¦ld',0),(415279,11536,'ko','ë¯¸ì§€ê¸‰ê¸ˆì— ìž¬ì‚°ì„¸ ì†ì„± ì¶”ê°€',0),(415280,11536,'he','×ž×¡ ×¨×›×•×© ×¨×›×•×© ×œ×”×•×¡×™×£ ×–×›××™×',0),(415281,11536,'el','Î¦ÏŒÏÎ¿Ï‚ Î±ÎºÎ¹Î½Î®Ï„Î¿Ï… Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Î±Ï…Î¾Î¬Î½Ï‰ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(415282,11536,'zh','ç‰©ä¸šç‰©ä¸šç¨Žæ–°å¢žåº”ä»˜æ¬¾\r\n',0),(415283,11536,'sv','Egendom fastighetsskatt lÃ¤gga till leverantÃ¶rsskulder',0),(415284,11536,'it','ProprietÃ  ProprietÃ  fiscale aggiungere ai debiti',0),(415285,11536,'tl','',0),(415286,11536,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰',0),(415287,11536,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ Payables',0),(415288,11536,'ms','Cukai harta harta menambah kepada pemiutang',0),(415289,11536,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ Ø§Ù„Ù…Ù„ÙƒÙŠØ© Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(415290,11536,'fr','PropriÃ©tÃ© fonciÃ¨re ajouter aux crÃ©diteurs',0),(415291,11536,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ç¨Žå‚µå‹™ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(415292,11536,'pt','Imposto sobre a propriedade Propriedade adicionar ao contas a pagar',0),(415293,11536,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(415294,11536,'es','Predial de Propiedad Agrgar a Cuentas por Pagar',0),(415295,11536,'de','Grundsteuer-Eigenschaft hinzufÃ¼gen auf Verbindlichkeiten',0),(415296,11536,'en','Property Property Tax Add To Payables',0),(415297,11537,'is','',0),(415298,11537,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(415299,11537,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(415300,11537,'tr','BaÅŸarÄ±sÄ±z ekleme emlak vergisi',0),(415301,11537,'pl','BÅ‚Ä…d dodawania podatku od nieruchomoÅ›ci',0),(415302,11537,'bg','ÐÐµÑƒÑÐ¿ÐµÑ… Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð´Ð°Ð½ÑŠÐº',0),(415303,11537,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(415304,11537,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð½ÐµÑƒÑÐ¿ÐµÑ… Ð´Ð¾Ð´Ð°Ñ˜ÑƒÑ›Ð¸',0),(415305,11537,'vi','thÃªm thuáº¿ tÃ i sáº£n tháº¥t báº¡i',0),(415306,11537,'af','Faal om Eiendomsbelasting By te voeg',0),(415307,11537,'ro','EÅŸecul adÄƒugarea de proprietate fiscale',0),(415308,11537,'et','Rike lisades maamaks',0),(415309,11537,'si','Neuspeh dodajanje davek na nepremiÄnine',0),(415310,11537,'ba','Kegagalan menambahkan properti pajak',0),(415311,11537,'nl','Mislukking toe te voegen onroerende voorheffing',0),(415312,11537,'fi','EpÃ¤onnistuminen lisÃ¤Ã¤mÃ¤llÃ¤ kiinteistÃ¶vero',0),(415313,11537,'no','Feil Ã¥ legge eiendomsskatt',0),(415314,11537,'da','Manglende tilfÃ¸je ejendomsskat',0),(415315,11537,'ko','ì‹¤íŒ¨ ì¶”ê°€ ìž¬ì‚°ì„¸',0),(415316,11537,'he','×›×©×œ ×”×•×¡×¤×ª ×ž×¡ ×¨×›×•×©',0),(415317,11537,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚',0),(415318,11537,'zh','å¤±è´¥æ·»åŠ ç‰©ä¸šç¨Ž\r\n',0),(415319,11537,'sv','UnderlÃ¥tenhet att lÃ¤gga till fastighetsskatt',0),(415320,11537,'it','Mancata aggiunta di tassa di proprietÃ ',0),(415321,11537,'tl','',0),(415322,11537,'th','à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(415323,11537,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤µà¤¿à¤«à¤²à¤¤à¤¾',0),(415324,11537,'ms','Kegagalan menambah cukai harta',0),(415325,11537,'ar','ÙØ´Ù„ Ø¥Ø¶Ø§ÙØ© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ',0),(415326,11537,'fr','Ã‰chec ajoutant la taxe fonciÃ¨re',0),(415327,11537,'jp','éšœå®³ã®è¿½åŠ ã®å›ºå®šè³‡ç”£ç¨Ž',0),(415328,11537,'pt','Falha adicionando imposto sobre a propriedade',0),(415329,11537,'ru','Ð¡Ð±Ð¾Ð¹ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾',0),(415330,11537,'es','FallÃ³ Agregando Predial',0),(415331,11537,'de','Fehler hinzufÃ¼gen-Grundsteuer',0),(415332,11537,'en','Failure Adding Property Tax',0),(415333,11538,'is','',0),(415334,11538,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(415335,11538,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯ ',0),(415336,11538,'tr','Emlak vergisi baÅŸarÄ±yla eklendi',0),(415337,11538,'pl','Podatek od nieruchomoÅ›ci dodane pomyÅ›lnie',0),(415338,11538,'bg','Ð”Ð°Ð½ÑŠÐº Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(415339,11538,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(415340,11538,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ ÐºÐ¾Ñ˜Ð¸ ÑÑƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(415341,11538,'vi','Ä‘Ã£ thÃªm thuáº¿ tÃ i sáº£n thÃ nh cÃ´ng',0),(415342,11538,'af','Eiendomsbelasting Suksesvol Bygevoeg',0),(415343,11538,'ro','Impozitul pe proprietate adÄƒugat cu succes',0),(415344,11538,'et','Lisatud maamaks',0),(415345,11538,'si','Davek na nepremiÄnine uspeÅ¡no dodani',0),(415346,11538,'ba','Pajak properti ditambahkan berhasil',0),(415347,11538,'nl','Onroerende voorheffing toegevoegd',0),(415348,11538,'fi','KiinteistÃ¶vero lisÃ¤Ã¤minen onnistui',0),(415349,11538,'no','Eiendomsskatt lagt',0),(415350,11538,'da','Ejendomsskat tilfÃ¸jet',0),(415351,11538,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ë¶€ë™ì‚° ì„¸ê¸ˆ',0),(415352,11538,'he','×ž×¡ ×¨×›×•×© × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(415353,11538,'el','Î¦ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(415354,11538,'zh','ç‰©ä¸šç¨Žæ·»åŠ æˆåŠŸ\r\n',0),(415355,11538,'sv','Fastighetsskatt som lagts',0),(415356,11538,'it','ProprietÃ  fiscale aggiunto con successo',0),(415357,11538,'tl','',0),(415358,11538,'th','à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(415359,11538,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(415360,11538,'ms','Cukai harta yang berjaya menambah',0),(415361,11538,'ar','Ø£Ø¶ÙŠÙØª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(415362,11538,'fr','ImpÃ´t foncier ajoutÃ© avec succÃ¨s',0),(415363,11538,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸå›ºå®šè³‡ç”£ç¨Ž',0),(415364,11538,'pt','Imposto sobre a propriedade adicionada com sucesso',0),(415365,11538,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(415366,11538,'es','Predial Agregado Exitosamente',0),(415367,11538,'de','Grundsteuer erfolgreich hinzugefÃ¼gt',0),(415368,11538,'en','Property Tax Added Successfully',0),(415369,11539,'is','',0),(415370,11539,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø±Ø§ÙŠ ',0),(415371,11539,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø±Ø§ÙŠ ',0),(415372,11539,'tr','Emlak vergileri',0),(415373,11539,'pl','Podatki od nieruchomoÅ›ci dla',0),(415374,11539,'bg','Ð˜Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²ÐµÐ½Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð·Ð°',0),(415375,11539,'ur','Ú©Û’ Ù„Ø¦Û’ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³',0),(415376,11539,'sr','ÐŸÐ¾Ñ€ÐµÐ·Ðµ Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð·Ð°',0),(415377,11539,'vi','thuáº¿ tÃ i sáº£n cho',0),(415378,11539,'af','Eiendomsbelasting Vir',0),(415379,11539,'ro','Impozitele pe proprietate pentru',0),(415380,11539,'et','Maamaksuga jaoks',0),(415381,11539,'si','Davkov na nepremiÄnine za',0),(415382,11539,'ba','Pajak properti untuk',0),(415383,11539,'nl','Belastingen van het bezit voor',0),(415384,11539,'fi','KiinteistÃ¶veron osalta',0),(415385,11539,'no','Eiendomsskatt For',0),(415386,11539,'da','Ejendomsskatter For',0),(415387,11539,'ko','ì— ëŒ€ í•œ ìž¬ì‚°ì„¸',0),(415388,11539,'he','×”××¨× ×•× ×”',0),(415389,11539,'el','Î¦ÏŒÏÎ¿Î¹ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Î³Î¹Î±',0),(415390,11539,'zh','ç‰©ä¸šç¨Ž\r\n',0),(415391,11539,'sv','Fastighetsskatt fÃ¶r',0),(415392,11539,'it','Tasse di proprietÃ  per',0),(415393,11539,'tl','',0),(415394,11539,'th','à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¹ƒà¸™',0),(415395,11539,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤°à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤',0),(415396,11539,'ms','Cukai harta bagi',0),(415397,11539,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø¹Ù„Ù‰ Ø§Ù„Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(415398,11539,'fr','ImpÃ´ts fonciers pour',0),(415399,11539,'jp','ãŸã‚ã®å›ºå®šè³‡ç”£ç¨Ž',0),(415400,11539,'pt','Impostos de propriedade para',0),(415401,11539,'ru','ÐÐ°Ð»Ð¾Ð³Ð¸ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ð´Ð»Ñ',0),(415402,11539,'es','Predial Para',0),(415403,11539,'de','Grundsteuer fÃ¼r',0),(415404,11539,'en','Property Taxes For',0),(415405,11540,'is','',0),(415406,11540,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ ',0),(415407,11540,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ ',0),(415408,11540,'tr','Emlak vergisi Ekle',0),(415409,11540,'pl','Podatek od nieruchomoÅ›ci Dodaj',0),(415410,11540,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº',0),(415411,11540,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(415412,11540,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ',0),(415413,11540,'vi','thÃªm thuáº¿ tÃ i sáº£n',0),(415414,11540,'af','Eiendomsbelasting Bygevoeg',0),(415415,11540,'ro','Adauga impozitul pe proprietate',0),(415416,11540,'et','Maamaks lisamine',0),(415417,11540,'si','Dodati davek na nepremiÄnine',0),(415418,11540,'ba','Tambahkan properti pajak',0),(415419,11540,'nl','Onroerende voorheffing toevoegen',0),(415420,11540,'fi','KiinteistÃ¶vero lisÃ¤Ã¤',0),(415421,11540,'no','Eiendomsskatt legge',0),(415422,11540,'da','Ejendomsskat tilfÃ¸je',0),(415423,11540,'ko','ë¶€ë™ì‚° ì„¸ê¸ˆ ì¶”ê°€',0),(415424,11540,'he','×œ×”×•×¡×™×£ ×ž×¡ ×¨×›×•×©',0),(415425,11540,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï†ÏŒÏÎ¿ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚',0),(415426,11540,'zh','ç‰©ä¸šç¨Žæ–°å¢ž\r\n',0),(415427,11540,'sv','Fastighetsskatt lÃ¤gga till',0),(415428,11540,'it','Aggiungere la tassa di proprietÃ .',0),(415429,11540,'tl','',0),(415430,11540,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(415431,11540,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(415432,11540,'ms','Tambah cukai harta',0),(415433,11540,'ar','Ø¥Ø¶Ø§ÙØ© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ',0),(415434,11540,'fr','Ajouter de la taxe fonciÃ¨re',0),(415435,11540,'jp','å›ºå®šè³‡ç”£ç¨Žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(415436,11540,'pt','Adicionar o imposto sobre a propriedade',0),(415437,11540,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(415438,11540,'es','Agregar Predial ',0),(415439,11540,'de','Grundsteuer hinzufÃ¼gen',0),(415440,11540,'en','Property Tax Add',0),(415441,11541,'is','',0),(415442,11541,'dr','Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(415443,11541,'pr','Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(415444,11541,'tr','Emlak vergisi Sil',0),(415445,11541,'pl','UsuniÄ™cie podatku od nieruchomoÅ›ci',0),(415446,11541,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐº',0),(415447,11541,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(415448,11541,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð”ÐµÐ»ÐµÑ‚Ðµ',0),(415449,11541,'vi','xÃ³a thuáº¿ tÃ i sáº£n',0),(415450,11541,'af','Eiendomsbelasting Geskrap',0),(415451,11541,'ro','Impozitul pe Delete',0),(415452,11541,'et','Maamaks kustutamine',0),(415453,11541,'si','Davek na nepremiÄnine Delete',0),(415454,11541,'ba','Hapus pajak properti',0),(415455,11541,'nl','Onroerende voorheffing verwijderen',0),(415456,11541,'fi','KiinteistÃ¶vero Poista',0),(415457,11541,'no','Eiendomsskatt Slett',0),(415458,11541,'da','Ejendomsskat slet',0),(415459,11541,'ko','ë¶€ë™ì‚° ì„¸ê¸ˆ ì‚­ì œ',0),(415460,11541,'he','×ž×—×™×§×ª ×ž×¡ ×¨×›×•×©',0),(415461,11541,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï†ÏŒÏÎ¿Ï… Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚',0),(415462,11541,'zh','ç‰©ä¸šç¨Žåˆ é™¤\r\n',0),(415463,11541,'sv','Ta bort fastighetsskatten',0),(415464,11541,'it','Eliminazione della tassa di proprietÃ ',0),(415465,11541,'tl','',0),(415466,11541,'th','à¸¥à¸šà¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(415467,11541,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(415468,11541,'ms','Hapus cukai harta',0),(415469,11541,'ar','Ø­Ø°Ù Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ',0),(415470,11541,'fr','Suppression de la taxe fonciÃ¨re',0),(415471,11541,'jp','å›ºå®šè³‡ç”£ç¨Žã®å‰Šé™¤',0),(415472,11541,'pt','ExclusÃ£o do imposto sobre a propriedade',0),(415473,11541,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Delete',0),(415474,11541,'es','Eliminar Predial',0),(415475,11541,'de','Grundsteuer lÃ¶schen',0),(415476,11541,'en','Property Tax Delete',0),(415477,11542,'is','',0),(415478,11542,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(415479,11542,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(415480,11542,'tr','BaÅŸarÄ±sÄ±z silme emlak vergisi',0),(415481,11542,'pl','BÅ‚Ä…d usuwania podatku od nieruchomoÅ›ci',0),(415482,11542,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð´Ð°Ð½ÑŠÐº',0),(415483,11542,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ø­Ø°Ù Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³',0),(415484,11542,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð±Ñ€Ð¸ÑÐ°ÑšÐ° Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ',0),(415485,11542,'vi','xÃ³a thuáº¿ tÃ i sáº£n tháº¥t báº¡i',0),(415486,11542,'af','Faal om Eiendomsbelasting te Skrap',0),(415487,11542,'ro','EÅŸecul ÅŸtergerea proprietate fiscale',0),(415488,11542,'et','TÃµrge kustutamisel maamaks',0),(415489,11542,'si','Neuspeh brisanjem davek na nepremiÄnine',0),(415490,11542,'ba','Kegagalan menghapus properti pajak',0),(415491,11542,'nl','Mislukking verwijderen onroerende voorheffing',0),(415492,11542,'fi','Virhe poistettaessa kiinteistÃ¶vero',0),(415493,11542,'no','Feil slette eiendomsskatt',0),(415494,11542,'da','Manglende sletning ejendomsskat',0),(415495,11542,'ko','ì‹¤íŒ¨ ì‚­ì œ ìž¬ì‚°ì„¸',0),(415496,11542,'he','×›×©×œ ×‘×ž×—×™×§×ª ×©×•×ž×ª ×ž×¡',0),(415497,11542,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï†ÏŒÏÎ¿Ï… Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(415498,11542,'zh','ç‰©ä¸šç¨Žåˆ é™¤å¤±è´¥\r\n',0),(415499,11542,'sv','Fel ta bort fastighetsskatten',0),(415500,11542,'it','Mancata eliminazione tassa di proprietÃ ',0),(415501,11542,'tl','',0),(415502,11542,'th','à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(415503,11542,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤°',0),(415504,11542,'ms','Kegagalan menghapuskan cukai harta',0),(415505,11542,'ar','ÙØ´Ù„ Ø­Ø°Ù Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ',0),(415506,11542,'fr','Ã‰chec suppression taxe fonciÃ¨re',0),(415507,11542,'jp','å¤±æ•—ã—ãŸå‰Šé™¤ã™ã‚‹å›ºå®šè³‡ç”£ç¨Ž',0),(415508,11542,'pt','Falha excluindo imposto sobre a propriedade',0),(415509,11542,'ru','Ð¡Ð±Ð¾Ð¹ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð½Ð°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾',0),(415510,11542,'es','FallÃ³ Eliminando Predial',0),(415511,11542,'de','Fehler lÃ¶schen von Grundsteuer',0),(415512,11542,'en','Failure Deleting Property Tax',0),(415513,11543,'is','',0),(415514,11543,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(415515,11543,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(415516,11543,'tr','Emlak vergisi baÅŸarÄ±yla silindi',0),(415517,11543,'pl','Podatek od nieruchomoÅ›ci przesâ”‚anie',0),(415518,11543,'bg','Ð”Ð°Ð½ÑŠÐº ÑÐ³Ñ€Ð°Ð´Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(415519,11543,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(415520,11543,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ ÐºÐ¾Ñ˜Ð¸ ÑÑƒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(415521,11543,'vi','xÃ³a thuáº¿ tÃ i sáº£n thÃ nh cÃ´ng',0),(415522,11543,'af','Eiendomsbelasting Suksesvol Geskrap',0),(415523,11543,'ro','Impozitul pe proprietate eliminÄƒ cu succes',0),(415524,11543,'et','Edukalt kustutatud maamaks',0),(415525,11543,'si','Davek na nepremiÄnine uspeÅ¡no izbrisana',0),(415526,11543,'ba','Pajak properti dihapus berhasil',0),(415527,11543,'nl','Onroerende voorheffing met succes verwijderd',0),(415528,11543,'fi','KiinteistÃ¶vero poistettu',0),(415529,11543,'no','Eiendomsskatt slettet',0),(415530,11543,'da','Ejendomsskat slettet',0),(415531,11543,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ë¶€ë™ì‚° ì„¸ê¸ˆ',0),(415532,11543,'he','×ž×¡ ×¨×›×•×© × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(415533,11543,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(415534,11543,'zh','ç‰©ä¸šç¨ŽæˆåŠŸåˆ é™¤\r\n',0),(415535,11543,'sv','Fastighetsskatt raderades',0),(415536,11543,'it','Tassa di proprietÃ  eliminato con successo',0),(415537,11543,'tl','',0),(415538,11543,'th','à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(415539,11543,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(415540,11543,'ms','Cukai harta yang dihapuskan dengan jayanya',0),(415541,11543,'ar','Ø­Ø°ÙØª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(415542,11543,'fr','ImpÃ´t foncier supprimÃ© avec succÃ¨s',0),(415543,11543,'jp','è²¡ç”£ç¨ŽãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(415544,11543,'pt','Imposto sobre a propriedade apagado com sucesso',0),(415545,11543,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(415546,11543,'es','Predial Eliminado Exitosamente',0),(415547,11543,'de','Grundsteuer erfolgreich gelÃ¶scht',0),(415548,11543,'en','Property Tax Deleted Successfully',0),(415549,11544,'is','',0),(415550,11544,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(415551,11544,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(415552,11544,'tr','Emlak vergisi gÃ¼ncelleÅŸtirme',0),(415553,11544,'pl','Podatek od nieruchomoÅ›ci aktualizacji',0),(415554,11544,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð´Ð°Ð½ÑŠÐº',0),(415555,11544,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(415556,11544,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(415557,11544,'vi','cáº­p nháº­t thuáº¿ tÃ i sáº£n',0),(415558,11544,'af','Eiendomsbelasting is Opdateer',0),(415559,11544,'ro','Actualizare proprietate fiscale',0),(415560,11544,'et','Maamaks Update',0),(415561,11544,'si','Davek na nepremiÄnine posodobitev',0),(415562,11544,'ba','Pajak properti Update',0),(415563,11544,'nl','Onroerende voorheffing Update',0),(415564,11544,'fi','KiinteistÃ¶vero pÃ¤ivitys',0),(415565,11544,'no','Eiendomsskatt oppdatering',0),(415566,11544,'da','Ejendomsskat opdatering',0),(415567,11544,'ko','ìž¬ì‚°ì„¸ ì—…ë°ì´íŠ¸',0),(415568,11544,'he','×¢×“×›×•×Ÿ ×ž×¡ ×¨×›×•×©',0),(415569,11544,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Ï†ÏŒÏÎ¿Ï… Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚',0),(415570,11544,'zh','ç‰©ä¸šç¨Žæ›´æ–°\r\n',0),(415571,11544,'sv','Fastighetsskatt uppdatering',0),(415572,11544,'it','Aggiornamento tassa di proprietÃ .',0),(415573,11544,'tl','',0),(415574,11544,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(415575,11544,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(415576,11544,'ms','Kemaskini cukai harta',0),(415577,11544,'ar','ØªØ­Ø¯ÙŠØ« Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ',0),(415578,11544,'fr','Mise Ã  jour de l\'impÃ´t foncier',0),(415579,11544,'jp','å›ºå®šè³‡ç”£ç¨Žã®æ›´æ–°',0),(415580,11544,'pt','AtualizaÃ§Ã£o do imposto sobre a propriedade',0),(415581,11544,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(415582,11544,'es','ActualizaciÃ³n de Predial',0),(415583,11544,'de','Grundsteuer-Update',0),(415584,11544,'en','Property Tax Update',0),(415585,11545,'is','',0),(415586,11545,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ ',0),(415587,11545,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ ',0),(415588,11545,'tr','BaÅŸarÄ±sÄ±z gÃ¼ncelleÅŸtirme emlak vergisi',0),(415589,11545,'pl','Podatek od nieruchomoÅ›ci aktualizacji brak',0),(415590,11545,'bg','ÐÐµÑƒÑÐ¿ÐµÑ… Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð°Ð½ÑŠÐº',0),(415591,11545,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³',0),(415592,11545,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(415593,11545,'vi','cáº­p nháº­t thuáº¿ tÃ i sáº£n tháº¥t báº¡i',0),(415594,11545,'af','Faal om Eiendomsbelasting te Opdateer',0),(415595,11545,'ro','EÅŸecul actualizare proprietate fiscale',0),(415596,11545,'et','Suutmatus ajakohastada maamaks',0),(415597,11545,'si','Neuspeh posodabljanje davka',0),(415598,11545,'ba','Kegagalan memperbarui properti pajak',0),(415599,11545,'nl','Fout bijwerken onroerende voorheffing',0),(415600,11545,'fi','Virhe pÃ¤ivittÃ¤minen kiinteistÃ¶vero',0),(415601,11545,'no','Feil oppdatering eiendomsskatt',0),(415602,11545,'da','Manglende opdatering af ejendomsskat',0),(415603,11545,'ko','ì‹¤íŒ¨ ì—…ë°ì´íŠ¸ ìž¬ì‚°ì„¸',0),(415604,11545,'he','×›×©×œ ×¢×“×›×•×Ÿ ×©×•×ž×ª ×ž×¡',0),(415605,11545,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î¿Ï„Ï…Ï‡Î¯Î±',0),(415606,11545,'zh','ç‰©ä¸šç¨Žæ›´æ–°å¤±è´¥\r\n',0),(415607,11545,'sv','Fel uppdatering fastighetsskatt',0),(415608,11545,'it','Mancato aggiornamento ICI',0),(415609,11545,'tl','',0),(415610,11545,'th','à¸ à¸²à¸©à¸µà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(415611,11545,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤‚à¤ªà¤¦à¤¾ à¤•à¤°',0),(415612,11545,'ms','Cukai harta mengemaskini kegagalan',0),(415613,11545,'ar','ÙØ´Ù„ \"ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø®Ø§ØµÙŠØ©\" Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(415614,11545,'fr','ImpÃ´t Ã©chec mise Ã  jour',0),(415615,11545,'jp','å¤±æ•—ã—ãŸæ›´æ–°ã®è²¡ç”£ç¨Ž',0),(415616,11545,'pt','Imposto sobre a propriedade de atualizaÃ§Ã£o falha',0),(415617,11545,'ru','Ð¡Ð±Ð¾Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(415618,11545,'es','FallÃ³ Actualizando Predial',0),(415619,11545,'de','Fehler aktualisieren Grundsteuer',0),(415620,11545,'en','Failure Updating Property tax',0),(415621,11546,'is','',0),(415622,11546,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(415623,11546,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯',0),(415624,11546,'tr','Emlak vergisi baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(415625,11546,'pl','Podatek od nieruchomoÅ›ci pomyÅ›lnie zaktualizowana',0),(415626,11546,'bg','Ð”Ð°Ð½ÑŠÐºÐ° Ð²ÑŠÑ€Ñ…Ñƒ Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾Ñ‚Ð¾ Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(415627,11546,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(415628,11546,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(415629,11546,'vi','cáº­p nháº­t thuáº¿ tÃ i sáº£n thÃ nh cÃ´ng',0),(415630,11546,'af','Eiendomsbelasting Susesvol Opdateer',0),(415631,11546,'ro','Impozitul pe proprietate actualizat cu succes',0),(415632,11546,'et','VÃ¤rskendatud maamaks',0),(415633,11546,'si','Davek na nepremiÄnine uspeÅ¡no posodobljena',0),(415634,11546,'ba','Pajak Properti yang berhasil',0),(415635,11546,'nl','Onroerende voorheffing bijgewerkt',0),(415636,11546,'fi','PÃ¤ivitetty kiinteistÃ¶vero',0),(415637,11546,'no','Eiendomsskatt oppdatert',0),(415638,11546,'da','Ejendomsskat opdateret',0),(415639,11546,'ko','ìž¬ì‚°ì„¸ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(415640,11546,'he','×ž×¡ ×¨×›×•×© ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(415641,11546,'el','Î•Î½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Î¿ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚',0),(415642,11546,'zh','ç‰©ä¸šç¨Žå·²æˆåŠŸæ›´æ–°\r\n',0),(415643,11546,'sv','Fastighetsskatt uppdaterats',0),(415644,11546,'it','Tassa di proprietÃ , aggiornato con successo',0),(415645,11546,'tl','',0),(415646,11546,'th','à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(415647,11546,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°',0),(415648,11546,'ms','Cukai harta yang berjaya dikemas kini',0),(415649,11546,'ar','Ø­Ø¯Ù‘Ø«Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¹Ù‚Ø§Ø± Ø¨Ù†Ø¬Ø§Ø­',0),(415650,11546,'fr','ImpÃ´t foncier mis Ã  jour avec succÃ¨s',0),(415651,11546,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸå›ºå®šè³‡ç”£ç¨Ž',0),(415652,11546,'pt','Imposto sobre a propriedade atualizado com sucesso',0),(415653,11546,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(415654,11546,'es','Predial Agregado Exitosamente',0),(415655,11546,'de','Grundsteuer, die erfolgreich aktualisiert',0),(415656,11546,'en','Property Tax Updated Successfully',0),(415657,11547,'is','',0),(415658,11547,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø±Ø§ÙŠ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415659,11547,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ø±Ø§ÙŠ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415660,11547,'tr','Ã–zellik iÃ§in emlak vergileri',0),(415661,11547,'pl','Podatki od nieruchomoÅ›ci, nieruchomoÅ›ci',0),(415662,11547,'bg','Ð”Ð°Ð½ÑŠÑ†Ð¸ Ð·Ð° Ð¸Ð¼Ð¾Ñ‚',0),(415663,11547,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³',0),(415664,11547,'sr','ÐŸÐ¾Ñ€ÐµÐ·Ðµ Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð·Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ',0),(415665,11547,'vi','thuáº¿ tÃ i sáº£n cho tÃ i sáº£n',0),(415666,11547,'af','Eiendomsbelasting Vir Eiendom',0),(415667,11547,'ro','Impozitele pe proprietate pentru proprietÄƒÅ£ii',0),(415668,11547,'et','Maamaksuga vara',0),(415669,11547,'si','Davkov na nepremiÄnine za nepremiÄnine',0),(415670,11547,'ba','Pajak properti properti',0),(415671,11547,'nl','Belastingen van het bezit voor eigenschap',0),(415672,11547,'fi','KiinteistÃ¶veron ominaisuuden',0),(415673,11547,'no','Eiendomsskatt For egenskapen',0),(415674,11547,'da','Ejendomsskatter For ejendom',0),(415675,11547,'ko','ì†ì„±ì— ëŒ€ í•œ ìž¬ì‚°ì„¸',0),(415676,11547,'he','×”××¨× ×•× ×” ×¨×›×•×©',0),(415677,11547,'el','Î¦ÏŒÏÏ‰Î½ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Î³Î¹Î± Ï„Î¿ Î±ÎºÎ¯Î½Î·Ï„Î¿',0),(415678,11547,'zh','ç‰©ä¸šç¨Ž\r\n',0),(415679,11547,'sv','Fastighetsskatt fÃ¶r egendom',0),(415680,11547,'it','Tasse di proprietÃ  per proprietÃ .',0),(415681,11547,'tl','',0),(415682,11547,'th','à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(415683,11547,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤°à¥‹à¤‚',0),(415684,11547,'ms','Cukai harta bagi harta',0),(415685,11547,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ© Ù„Ù„Ù…Ù„ÙƒÙŠØ©',0),(415686,11547,'fr','ImpÃ´t foncier pour la propriÃ©tÃ©',0),(415687,11547,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®å›ºå®šè³‡ç”£ç¨Ž',0),(415688,11547,'pt','Impostos de propriedade para propriedade.',0),(415689,11547,'ru','ÐÐ°Ð»Ð¾Ð³Ð¸ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ð´Ð»Ñ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(415690,11547,'es','Predial Para Propiedad',0),(415691,11547,'de','Grundsteuern fÃ¼r Eigenschaft',0),(415692,11547,'en','Property Taxes For Property',0),(415693,11548,'is','',0),(415694,11548,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(415695,11548,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÙŠ',0),(415696,11548,'tr','Emlak vergisi iÃ§in borÃ§ hesaplarÄ± ekleme',0),(415697,11548,'pl','Podatek od nieruchomoÅ›ci Dodaj do zobowiÄ…zania',0),(415698,11548,'bg','Ð”Ð°Ð½ÑŠÐº Ð´Ð¾Ð±Ð°Ð²Ð¸ ÐºÑŠÐ¼ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(415699,11548,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(415700,11548,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(415701,11548,'vi','thÃªm thuáº¿ tÃ i sáº£n Ä‘á»ƒ pháº£i tráº£',0),(415702,11548,'af','Eiendomsbelasting Byvoeg By Uitgawes (RB)',0),(415703,11548,'ro','Impozitul pe proprietate adÄƒuga la datorii',0),(415704,11548,'et','Maamaks lisada vÃµlad',0),(415705,11548,'si','Davek na nepremiÄnine dodati obveznosti',0),(415706,11548,'ba','Pajak properti menambah hutang',0),(415707,11548,'nl','Onroerende voorheffing toevoegen aan schulden',0),(415708,11548,'fi','KiinteistÃ¶vero lisÃ¤Ã¤minen ostojen',0),(415709,11548,'no','Eiendomsskatt legge til leverandÃ¸rgjeld',0),(415710,11548,'da','Ejendomsskat tilfÃ¸je til gÃ¦ld',0),(415711,11548,'ko','ìž¬ì‚°ì„¸ ë¯¸ì§€ê¸‰ê¸ˆì— ì¶”ê°€',0),(415712,11548,'he','×ž×¡ ×¨×›×•×© ×œ×”×•×¡×™×£ ×–×›××™×',0),(415713,11548,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Î±Ï…Î¾Î¬Î½Ï‰ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(415714,11548,'zh','ç‰©ä¸šç¨Žæ–°å¢žåˆ°åº”ä»˜æ¬¾\r\n',0),(415715,11548,'sv','Fastighetsskatt lÃ¤gga till leverantÃ¶rsskulder',0),(415716,11548,'it','ProprietÃ  fiscale aggiungere ai debiti',0),(415717,11548,'tl','',0),(415718,11548,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰',0),(415719,11548,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ Payables',0),(415720,11548,'ms','Tambah cukai harta kepada pemiutang',0),(415721,11548,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ù…ØªÙ„ÙƒØ§Øª Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(415722,11548,'fr','ImpÃ´t foncier ajouter aux crÃ©diteurs',0),(415723,11548,'jp','å›ºå®šè³‡ç”£ç¨Žã®å‚µå‹™ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(415724,11548,'pt','Imposto sobre a propriedade adicionar ao contas a pagar',0),(415725,11548,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(415726,11548,'es','Agregar Predial a Cuentas por Pagar',0),(415727,11548,'de','Grundsteuer hinzufÃ¼gen auf Verbindlichkeiten',0),(415728,11548,'en','Property Tax Add To Payables',0),(415729,11549,'is','',0),(415730,11549,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(415731,11549,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø§Ù…ÙˆØ§Ù„',0),(415732,11549,'tr','Emlak vergisi raporu',0),(415733,11549,'pl','Raport podatku od nieruchomoÅ›ci',0),(415734,11549,'bg','Ð”Ð°Ð½ÑŠÐº Ð´Ð¾ÐºÐ»Ð°Ð´',0),(415735,11549,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³ Ø±Ù¾ÙˆØ±Ù¹',0),(415736,11549,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(415737,11549,'vi','bÃ¡o cÃ¡o thuáº¿ tÃ i sáº£n',0),(415738,11549,'af','Eiendomsbelasting Verslag',0),(415739,11549,'ro','Raport de proprietate fiscale',0),(415740,11549,'et','Maamaks aruanne',0),(415741,11549,'si','Davek na nepremiÄnine poroÄilo',0),(415742,11549,'ba','Laporan pajak properti',0),(415743,11549,'nl','Onroerende voorheffing verslag',0),(415744,11549,'fi','KiinteistÃ¶vero raportti',0),(415745,11549,'no','Eiendomsskatt rapport',0),(415746,11549,'da','Ejendomsskat rapport',0),(415747,11549,'ko','ë¶€ë™ì‚° ì„¸ê¸ˆ ë³´ê³ ì„œ',0),(415748,11549,'he','×“×•×— ×ž×¡ ×¨×›×•×©',0),(415749,11549,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Î­ÎºÎ¸ÎµÏƒÎ·',0),(415750,11549,'zh','ç‰©ä¸šç¨Žçš„æŠ¥å‘Š\r\n',0),(415751,11549,'sv','Fastighetsskatt rapport',0),(415752,11549,'it','Rapporto sugli immobili',0),(415753,11549,'tl','',0),(415754,11549,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™',0),(415755,11549,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤° à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(415756,11549,'ms','Laporan cukai harta',0),(415757,11549,'ar','ØªÙ‚Ø±ÙŠØ± Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ',0),(415758,11549,'fr','Rapport d\'impÃ´t foncier',0),(415759,11549,'jp','å›ºå®šè³‡ç”£ç¨Žãƒ¬ãƒãƒ¼ãƒˆ',0),(415760,11549,'pt','RelatÃ³rio de imposto sobre a propriedade',0),(415761,11549,'ru','Ð˜Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(415762,11549,'es','Informe de Predial',0),(415763,11549,'de','Grundsteuer-Bericht',0),(415764,11549,'en','Property Tax Report',0),(415765,11550,'is','',0),(415766,11550,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ Ù‡Ø§',0),(415767,11550,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ Ù‡Ø§',0),(415768,11550,'tr','E-postalar gÃ¶ndermek',0),(415769,11550,'pl','WysyÅ‚anie e-maili',0),(415770,11550,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð»Ð¸',0),(415771,11550,'ur','Ø§ÛŒ Ù…ÛŒÙ„Ø² Ø¨Ú¾ÛŒØ¬',0),(415772,11550,'sr','Ð¡Ð»Ð°ÑšÐµ Ðµ-Ð¼Ð°Ð¸Ð»Ð¾Ð²Ðµ',0),(415773,11550,'vi','Gá»­i Email',0),(415774,11550,'af','Stuur E-posse',0),(415775,11550,'ro','Trimite email-uri',0),(415776,11550,'et','Saada e-kirju',0),(415777,11550,'si','PoÅ¡lji e-poÅ¡to',0),(415778,11550,'ba','Kirim email',0),(415779,11550,'nl','E-mails versturen',0),(415780,11550,'fi','LÃ¤hetÃ¤ sÃ¤hkÃ¶postia',0),(415781,11550,'no','Sende e-post',0),(415782,11550,'da','Send E-mails',0),(415783,11550,'ko','ì´ë©”ì¼ ë³´ë‚´ê¸°',0),(415784,11550,'he','×©×œ×— ×”×•×“×¢×•×ª ×“×•×\"×œ',0),(415785,11550,'el','Î£Ï„ÎµÎ¯Î»ÎµÏ„Îµ Î¼Î·Î½ÏÎ¼Î±Ï„Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(415786,11550,'zh','å‘é€ç”µå­é‚®ä»¶\r\n',0),(415787,11550,'sv','Skicka e-post',0),(415788,11550,'it','Inviare email',0),(415789,11550,'tl','',0),(415790,11550,'th','à¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(415791,11550,'hi','à¤ˆà¤®à¥‡à¤² à¤­à¥‡à¤œà¥‡à¤‚',0),(415792,11550,'ms','Menghantar e-mel',0),(415793,11550,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(415794,11550,'fr','Envoyer des Emails',0),(415795,11550,'jp','ãƒ¡ãƒ¼ãƒ«ã‚’é€ã‚‹',0),(415796,11550,'pt','Enviar E-mails',0),(415797,11550,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½ÑƒÑŽ Ð¿Ð¾Ñ‡Ñ‚Ñƒ',0),(415798,11550,'es','Envia Emails',0),(415799,11550,'de','Senden Sie E-Mails',0),(415800,11550,'en','Send Emails',0),(415801,11551,'is','',0),(415802,11551,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ù…Ù†ØªØ®Ø¨	',0),(415803,11551,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ø§ÙŠÙ…ÙŠÙ„ Ø¨Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø§Ù† Ù…Ù†ØªØ®Ø¨	',0),(415804,11551,'tr','SeÃ§ili kullanÄ±cÄ±lara e-posta gÃ¶nderme',0),(415805,11551,'pl','WyÅ›lij E-mail do wybranych uÅ¼ytkownikÃ³w',0),(415806,11551,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð» Ð´Ð¾ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(415807,11551,'ur','Ù…Ù†ØªØ®Ø¨ ØµØ§Ø±ÙÛŒÙ† Ú©Ùˆ Ø§ÛŒ Ù…ÛŒÙ„ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(415808,11551,'sr','Ð˜Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸ ÑˆÐ°Ñ™Ñƒ Ðµ-Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(415809,11551,'vi','Gá»­i email Ä‘áº¿n ngÆ°á»i dÃ¹ng Ä‘Ã£ chá»n',0),(415810,11551,'af','Stuur E-pos aan Geselekteerde Gebruikers',0),(415811,11551,'ro','Trimite E-mail pentru utilizatorii selectaÈ›i',0),(415812,11551,'et','Saada valitud kasutajatele e-posti',0),(415813,11551,'si','PoÅ¡ljite e-poÅ¡to izbranim uporabnikom',0),(415814,11551,'ba','Mengirim Email ke pengguna yang dipilih',0),(415815,11551,'nl','E-mail verzenden aan geselecteerde gebruikers',0),(415816,11551,'fi','LÃ¤hetÃ¤ sÃ¤hkÃ¶posti valituille kÃ¤yttÃ¤jille',0),(415817,11551,'no','Send epost til valgte brukere',0),(415818,11551,'da','Send E-mail til udvalgte brugere',0),(415819,11551,'ko','ì„ íƒí•œ ì‚¬ìš©ìžì— ê²Œ ì´ë©”ì¼ì„ ë³´ë‚¼',0),(415820,11551,'he','×©×œ×— ×“×•×\"×œ ×œ×ž×©×ª×ž×©×™× × ×‘×—×¨×™×',0),(415821,11551,'el','Î£Ï„ÎµÎ¯Î»ÎµÏ„Îµ Email ÏƒÎµ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï…Ï‚ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(415822,11551,'zh','å‘é€ç”µå­é‚®ä»¶ç»™é€‰å®šçš„ç”¨æˆ·\r\n',0),(415823,11551,'sv','Skicka e-post till utvalda anvÃ¤ndare',0),(415824,11551,'it','Invia E-mail a utenti selezionati',0),(415825,11551,'tl','',0),(415826,11551,'th','à¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥à¹Œà¹„à¸›à¸¢à¸±à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(415827,11551,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤ˆà¤®à¥‡à¤² à¤­à¥‡à¤œà¥‡à¤‚',0),(415828,11551,'ms','Menghantar e-mel untuk pengguna terpilih',0),(415829,11551,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ù…Ø­Ø¯Ø¯ÙŠÙ†',0),(415830,11551,'fr','Envoyer par courriel aux utilisateurs sÃ©lectionnÃ©s',0),(415831,11551,'jp','é¸æŠžã—ãŸãƒ¦ãƒ¼ã‚¶ãƒ¼ã«é›»å­ãƒ¡ãƒ¼ãƒ«ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(415832,11551,'pt','Enviar Email para usuÃ¡rios selecionados',0),(415833,11551,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Email Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ð¼ ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑÐ¼',0),(415834,11551,'es','Envia Emails a Usuarios Seleccionados',0),(415835,11551,'de','Senden Sie E-Mail an ausgewÃ¤hlte Benutzer',0),(415836,11551,'en','Send Email To Selected Users',0),(415837,11552,'is','',0),(415838,11552,'dr','(Ø­Ø±Ø§Ø¬) Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415839,11552,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ(Ø­Ø±Ø§Ø¬) Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415840,11552,'tr','Emlak satÄ±ÅŸ Ekle',0),(415841,11552,'pl','SprzedaÅ¼y nieruchomoÅ›ci Dodaj',0),(415842,11552,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(415843,11552,'ur','Ø§Ù…Ù„Ø§Ú© Ú©ÛŒ ÙØ±ÙˆØ®Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(415844,11552,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð½ÐµÐ¿Ð¾ÐºÑ€ÐµÑ‚Ð½Ð¾ÑÑ‚Ð¸',0),(415845,11552,'vi','thÃªm tÃ i sáº£n bÃ¡n',0),(415846,11552,'af','Eiendom verkope voeg',0),(415847,11552,'ro','Adauga proprietatea de vÃ¢nzÄƒri',0),(415848,11552,'et','Kinnisvara mÃ¼Ã¼k lisamine',0),(415849,11552,'si','PoveÄati prodajo nepremiÄnin',0),(415850,11552,'ba','Tambahkan penjualan properti',0),(415851,11552,'nl','Verkoop van onroerend goed toevoegen',0),(415852,11552,'fi','Omaisuuden myynti lisÃ¤Ã¤',0),(415853,11552,'no','Eiendomssalg legge',0),(415854,11552,'da','Salg af fast ejendom tilfÃ¸je',0),(415855,11552,'ko','ìž¬ì‚° íŒë§¤ ì¶”ê°€',0),(415856,11552,'he','×œ×”×•×¡×™×£ ×ž××¤×™×™×Ÿ ×ž×›×™×¨×•×ª',0),(415857,11552,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î±ÎºÎ¹Î½Î®Ï„Ï‰Î½',0),(415858,11552,'zh','ç‰©ä¸šé”€å”®å¢žåŠ \r\n',0),(415859,11552,'sv','Egenskapen fÃ¶rsÃ¤ljning lÃ¤gga till',0),(415860,11552,'it','Aggiungi vendite immobiliari',0),(415861,11552,'tl','',0),(415862,11552,'th','à¸‚à¸²à¸¢à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¹€à¸žà¸´à¹ˆà¸¡',0),(415863,11552,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(415864,11552,'ms','Menambah jualan hartanah',0),(415865,11552,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø¹Ù‚Ø§Ø±Ø§Øª',0),(415866,11552,'fr','Ajouter des propriÃ©tÃ©s Ã  vendre',0),(415867,11552,'jp','ç‰¹æ€§ã®è²©å£²ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(415868,11552,'pt','Adicionar as vendas de imÃ³veis',0),(415869,11552,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(415870,11552,'es','Agregar Ventas de Propiedad',0),(415871,11552,'de','Verkauf von Immobilien hinzufÃ¼gen',0),(415872,11552,'en','Property Sales Add',0),(415873,11553,'is','',0),(415874,11553,'dr','(Ø­Ø±Ø§Ø¬) Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415875,11553,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙØ±ÙˆØ´ Ù‡Ø§ÙŠ(Ø­Ø±Ø§Ø¬) Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415876,11553,'tr','MÃ¼lkiyet satÄ±ÅŸ gÃ¼ncelleme',0),(415877,11553,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ sprzedaÅ¼y aktualizacji',0),(415878,11553,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(415879,11553,'ur','Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ ÙØ±ÙˆØ®Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(415880,11553,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð°Ð²Ð°',0),(415881,11553,'vi','cáº­p nháº­t tÃ i sáº£n bÃ¡n',0),(415882,11553,'af','Eiendom verkope opdatering',0),(415883,11553,'ro','Proprietate vÃ¢nzare Update',0),(415884,11553,'et','Vara mÃ¼Ã¼gi uuendamine',0),(415885,11553,'si','Prodaje posodobitev lastnosti',0),(415886,11553,'ba','Properti penjualan Update',0),(415887,11553,'nl','Eigenschap verkoop Update',0),(415888,11553,'fi','Omaisuuden myynti pÃ¤ivitys',0),(415889,11553,'no','Salg oppdateringen',0),(415890,11553,'da','Ejendom salg opdatering',0),(415891,11553,'ko','ì†ì„± íŒë§¤ ì—…ë°ì´íŠ¸',0),(415892,11553,'he','×¢×“×›×•×Ÿ ×ž×›×™×¨×•×ª ×¨×›×•×©',0),(415893,11553,'el','Î™Î´Î¹ÏŒÏ„Î·Ï„Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(415894,11553,'zh','ç‰©ä¸šé”€å”®æ›´æ–°\r\n',0),(415895,11553,'sv','Egenskapen fÃ¶rsÃ¤ljning uppdatering',0),(415896,11553,'it','Aggiornamento vendite di proprietÃ .',0),(415897,11553,'tl','',0),(415898,11553,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸‚à¸²à¸¢',0),(415899,11553,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(415900,11553,'ms','Kemaskini jualan hartanah',0),(415901,11553,'ar','ØªØ­Ø¯ÙŠØ« Ø®Ø§ØµÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(415902,11553,'fr','Mise Ã  jour de ventes de propriÃ©tÃ©s',0),(415903,11553,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£è²©å£²æ›´æ–°',0),(415904,11553,'pt','AtualizaÃ§Ã£o de vendas de propriedade.',0),(415905,11553,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(415906,11553,'es','Actualizar Ventas de Propiedad',0),(415907,11553,'de','Eigenschaft Umsatz Update',0),(415908,11553,'en','Property Sales Update',0),(415909,11554,'is','',0),(415910,11554,'dr','PM Dashboard ØªØ¹Ù…ÙŠØ±Ø§Øª Ù¾ÙŠØ´ Ú¯ÙŠØ±Ø§Ù†Ù‡ ØªØ§Ø¨Ù„Ùˆ Ù…Ø³Ø§Ø¨Ù‚Ø§Øª Ø§Ø³Ø¨ Ø¯ÙˆØ§Ù†ÙŠ',0),(415911,11554,'pr','PM Dashboard ØªØ¹Ù…ÙŠØ±Ø§Øª Ù¾ÙŠØ´ Ú¯ÙŠØ±Ø§Ù†Ù‡ ØªØ§Ø¨Ù„Ùˆ Ù…Ø³Ø§Ø¨Ù‚Ø§Øª Ø§Ø³Ø¨ Ø¯ÙˆØ§Ù†ÙŠ',0),(415912,11554,'tr','PM kontrol paneli',0),(415913,11554,'pl','Panel PM',0),(415914,11554,'bg','PM Ñ‚Ð°Ð±Ð»Ð¾',0),(415915,11554,'ur','Øµ ÚˆÛŒØ´ Ø¨ÙˆØ±Úˆ',0),(415916,11554,'sr','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ð° Ñ‚Ð°Ð±Ð»Ð° ÐŸÐœ',0),(415917,11554,'vi','Báº£ng Ä‘iá»u khiá»ƒn PM',0),(415918,11554,'af','NM paneelbord',0),(415919,11554,'ro','PM tabloul de bord',0),(415920,11554,'et','PM armatuurlaud',0),(415921,11554,'si','PM blatnik',0),(415922,11554,'ba','PM Dashboard',0),(415923,11554,'nl','PM Dashboard',0),(415924,11554,'fi','PM Dashboard',0),(415925,11554,'no','PM Dashboard',0),(415926,11554,'da','PM Dashboard',0),(415927,11554,'ko','ì˜¤í›„ ëŒ€ì‹œë³´ë“œ',0),(415928,11554,'he','×œ×•×— ×”×ž×—×•×•× ×™× PM',0),(415929,11554,'el','Î¤Î±Î¼Ï€Î»ÏŒ Î¼.Î¼.',0),(415930,11554,'zh','ç‰©ä¸šç®¡ç†ä»ªè¡¨æ¿\r\n',0),(415931,11554,'sv','PM Dashboard',0),(415932,11554,'it','PM Dashboard',0),(415933,11554,'tl','',0),(415934,11554,'th','à¹à¸”à¸Šà¸šà¸­à¸£à¹Œà¸” PM',0),(415935,11554,'hi','PM à¤¡à¥ˆà¤¶à¤¬à¥‹à¤°à¥à¤¡',0),(415936,11554,'ms','Papan pemuka PM',0),(415937,11554,'ar','Ù„ÙˆØ­Ø© Ø§Ù„ØªØ­ÙƒÙ… Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ø¨Ø¹Ø¯ Ø§Ù„Ø¸Ù‡Ø±',0),(415938,11554,'fr','Tableau de bord de PM',0),(415939,11554,'jp','åˆå¾Œã®ãƒ€ãƒƒã‚·ãƒ¥ ãƒœãƒ¼ãƒ‰',0),(415940,11554,'pt','Painel de PM',0),(415941,11554,'ru','ÐŸÐ°Ð½ÐµÐ»ÑŒ Ð¿Ð¿',0),(415942,11554,'es','Consola PM',0),(415943,11554,'de','PM-Dashboard',0),(415944,11554,'en','PM Dashboard',0),(415945,11555,'is','',0),(415946,11555,'dr',' Ø§ÙØ²ÙˆØ¯Ù†   Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415947,11555,'pr',' Ø§ÙØ²ÙˆØ¯Ù†   Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(415948,11555,'tr','Ã–zellik Ekle/GÃ¼ncelle',0),(415949,11555,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ Dodaj/Aktualizuj',0),(415950,11555,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(415951,11555,'ur','Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(415952,11555,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð°Ð²Ð°',0),(415953,11555,'vi','Báº¥t Ä‘á»™ng sáº£n ThÃªm/Cáº­p Nháº­t',0),(415954,11555,'af','Eiendom voeg/opdatering',0),(415955,11555,'ro','Proprietatea AdÄƒugaÅ£i/actualizaÅ£i',0),(415956,11555,'et','Atribuudi lisamine/uuendamine',0),(415957,11555,'si','Lastnost Dodaj/posodobi',0),(415958,11555,'ba','Properti Tambahkan/Perbarui',0),(415959,11555,'nl','Eigenschap toevoegen/bijwerken',0),(415960,11555,'fi','Ominaisuus lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(415961,11555,'no','Egenskapen/Oppdater',0),(415962,11555,'da','Egenskaben TilfÃ¸j/opdater',0),(415963,11555,'ko','ì†ì„± ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(415964,11555,'he','×”×ž××¤×™×™×Ÿ ×”×•×¡×£/×¢×“×›×Ÿ',0),(415965,11555,'el','Î™Î´Î¹ÏŒÏ„Î·Ï„Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(415966,11555,'zh','ç‰©ä¸šæ–°å¢ž/æ›´æ–°\r\n',0),(415967,11555,'sv','Egenskapen LÃ¤gg till/uppdatera',0),(415968,11555,'it','ProprietÃ  aggiungere/aggiornare',0),(415969,11555,'tl','',0),(415970,11555,'th','à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(415971,11555,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(415972,11555,'ms','Harta Tambah/Kemaskini',0),(415973,11555,'ar','Ø®Ø§ØµÙŠØ© Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(415974,11555,'fr','PropriÃ©tÃ© ajouter/mettre Ã  jour',0),(415975,11555,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®è¿½åŠ /æ›´æ–°',0),(415976,11555,'pt','Adicionar/atualizar a propriedade.',0),(415977,11555,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(415978,11555,'es','Propiedad Agregar/Actualizar',0),(415979,11555,'de','Eigenschaft hinzufÃ¼gen/aktualisieren',0),(415980,11555,'en','Property Add/Update',0),(415981,11556,'is','',0),(415982,11556,'dr','/ Ø¢Ù¾Ø¯ÛŒØª Ú©Ø±Ø¯Ù†  Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(415983,11556,'pr','Ø§ÙØ²ÙˆØ¯Ù† / Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ  Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§Ø¦ÙŠ',0),(415984,11556,'tr','Ã–zellik tÃ¼rÃ¼ Ekle/GÃ¼ncelle',0),(415985,11556,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ typ Dodaj/Aktualizuj',0),(415986,11556,'bg','Ð¢Ð¸Ð¿ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(415987,11556,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(415988,11556,'sr','Ð¢Ð¸Ð¿ Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð°Ð²Ð°',0),(415989,11556,'vi','Báº¥t Ä‘á»™ng sáº£n loáº¡i ThÃªm/Cáº­p Nháº­t',0),(415990,11556,'af','Eiendomstipe Bygevoeg/Opdateer',0),(415991,11556,'ro','Proprietatea tip AdÄƒugaÅ£i/actualizaÅ£i',0),(415992,11556,'et','Vara liigi lisamine/uuendamine',0),(415993,11556,'si','Lastnost Vrsta Dodaj/posodobi',0),(415994,11556,'ba','Properti jenis Tambahkan/Perbarui',0),(415995,11556,'nl','Eigenschap Type toevoegen/bijwerken',0),(415996,11556,'fi','Ominaisuuden tyyppi lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(415997,11556,'no','Egenskapen Type Legg til/Oppdater',0),(415998,11556,'da','Egenskaben Type TilfÃ¸j/opdater',0),(415999,11556,'ko','ì†ì„± í˜•ì‹ ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(416000,11556,'he','×¡×•×’ ×”×ž××¤×™×™×Ÿ ×”×•×¡×£/×¢×“×›×Ÿ',0),(416001,11556,'el','Î¤ÏÏ€Î¿Ï‚ Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(416002,11556,'zh','ç‰©ä¸šç±»åž‹æ–°å¢ž/æ›´æ–°\r\n',0),(416003,11556,'sv','Egenskapen typ LÃ¤gg till/uppdatera',0),(416004,11556,'it','ProprietÃ  tipo aggiungere/aggiornare',0),(416005,11556,'tl','',0),(416006,11556,'th','à¸Šà¸™à¸´à¸”à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(416007,11556,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(416008,11556,'ms','Harta jenis Tambah/Kemaskini',0),(416009,11556,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø®Ø§ØµÙŠØ© Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ«',0),(416010,11556,'fr','PropriÃ©tÃ© Type ajouter/mettre Ã  jour',0),(416011,11556,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã®åž‹ã‚’è¿½åŠ /æ›´æ–°',0),(416012,11556,'pt','Tipo de propriedade adicionar/atualizar',0),(416013,11556,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°/Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(416014,11556,'es','Tipo de Propiedad Agregar/Actualizar',0),(416015,11556,'de','Eigentum Typ hinzufÃ¼gen/aktualisieren',0),(416016,11556,'en','Property Type Add/Update',0),(416017,11557,'is','',0),(416018,11557,'dr','Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª',0),(416019,11557,'pr','Ù…Ø§Ù„ÙŠØ§Øª Ø³Ø§Ø®ØªÙ…Ø§Ù† Ø§Ù…Ù„Ø§Ú© Ùˆ Ù…Ø³ØªØºÙ„Ø§Øª',0),(416020,11557,'tr','Emlak emlak vergisi',0),(416021,11557,'pl','Podatek od nieruchomoÅ›ci nieruchomoÅ›ci',0),(416022,11557,'bg','ÐÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¸ Ð¸Ð¼Ð¾Ñ‚Ð¸ Ð´Ð°Ð½ÑŠÐº',0),(416023,11557,'ur','Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ù¹ÛŒÚ©Ø³ Ø³Û’ Ø¬Ù…Ø¹',0),(416024,11557,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¸Ð¼Ð¾Ð²Ð¸Ð½Ñƒ Ð½ÐµÐºÑ€ÐµÑ‚Ð½Ð¸Ð½Ðµ',0),(416025,11557,'vi','Thuáº¿ tÃ i sáº£n báº¥t Ä‘á»™ng sáº£n',0),(416026,11557,'af','Vaste Eiendom Belasting op Grond',0),(416027,11557,'ro','Impozitul pe proprietate imobiliarÄƒ',0),(416028,11557,'et','Kinnisvara maamaks',0),(416029,11557,'si','Davek na nepremiÄnine Real Estate',0),(416030,11557,'ba','Pajak properti real estat',0),(416031,11557,'nl','Onroerend goed onroerende voorheffing',0),(416032,11557,'fi','Real Estate kiinteistÃ¶vero',0),(416033,11557,'no','Property Eiendomsskatt',0),(416034,11557,'da','Fast ejendom ejendomsskat',0),(416035,11557,'ko','ë¶€ë™ì‚° ìž¬ì‚°ì„¸',0),(416036,11557,'he','×ž×¡ ×¨×›×•×© × ×“×œ ×Ÿ',0),(416037,11557,'el','Î¦ÏŒÏÎ¿Ï‚ Î±ÎºÎ¯Î½Î·Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¯Î±Ï‚ Î±ÎºÎ¯Î½Î·Ï„Ï‰Î½ Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¹ÏŽÎ½',0),(416038,11557,'zh','ä¸åŠ¨äº§ç¨Ž\r\n',0),(416039,11557,'sv','Fastigheter fastighetsskatt',0),(416040,11557,'it','Tassa di proprietÃ  immobiliare',0),(416041,11557,'tl','',0),(416042,11557,'th','à¸ à¸²à¸©à¸µà¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸­à¸ªà¸±à¸‡à¸«à¸²à¸£à¸´à¸¡à¸—à¸£à¸±à¸žà¸¢à¹Œ',0),(416043,11557,'hi','à¤…à¤šà¤² à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤°',0),(416044,11557,'ms','Cukai harta hartanah',0),(416045,11557,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø£Ù…Ù„Ø§Ùƒ Ø§Ù„Ø¹Ù‚Ø§Ø±ÙŠØ©',0),(416046,11557,'fr','ImpÃ´t foncier immobilier',0),(416047,11557,'jp','ä¸å‹•ç”£è²¡ç”£ç¨Ž',0),(416048,11557,'pt','Imposto sobre a propriedade imobiliÃ¡ria',0),(416049,11557,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð¾ Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(416050,11557,'es','Predial',0),(416051,11557,'de','Immobilien-Grundsteuer',0),(416052,11557,'en','Real Estate Property Tax',0),(416053,11558,'is','',0),(416054,11558,'dr','Ø§Ø³Ù†Ø§Ø¯ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ù…Ø³ØªØ§Ø¬Ø± ',0),(416055,11558,'pr','Ø§Ø³Ù†Ø§Ø¯ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ù…Ø³ØªØ§Ø¬Ø± ',0),(416056,11558,'tr','General kiracÄ± bilgileri belgeleri',0),(416057,11558,'pl','Informacje ogÃ³lne najemcy dokumentÃ³w',0),(416058,11558,'bg','ÐžÐ±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(416059,11558,'ur','Ø¬Ù†Ø±Ù„ Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø³ØªØ§ÙˆÛŒØ²',0),(416060,11558,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÑÑ‚Ð°Ð½Ð°Ñ€ Ð˜Ð½Ñ„Ð¾ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð°',0),(416061,11558,'vi','ThÃ´ng tin chung thuÃª nhÃ  tÃ i liá»‡u',0),(416062,11558,'af','Algemene Huurder Inligtingsdokumente',0),(416063,11558,'ro','General chiriaÅŸ Info documente',0),(416064,11558,'et','ÃœÃ¼rnik Ãœldinfo dokumendid',0),(416065,11558,'si','General najemnik Info dokumentov',0),(416066,11558,'ba','Dokumen umum penyewa Info',0),(416067,11558,'nl','Algemene huurder Info documenten',0),(416068,11558,'fi','Vuokralainen yleistÃ¤ asiakirjat',0),(416069,11558,'no','General leietaker Info dokumenter',0),(416070,11558,'da','General lejer Info dokumenter',0),(416071,11558,'ko','ì¼ë°˜ ê±°ì£¼ìž ì •ë³´ ë¬¸ì„œ',0),(416072,11558,'he','×ž×™×“×¢ ×›×œ×œ×™ ×”×“×™×™×¨ ×ž×¡×ž×›×™×',0),(416073,11558,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î¹ÏƒÎ¸Ï‰Ï„Î® Î­Î³Î³ÏÎ±Ï†Î±',0),(416074,11558,'zh','ä¸€èˆ¬ç§Ÿå®¢è¯¦ç»†çš„æ–‡æ¡£\r\n',0),(416075,11558,'sv','General hyresgÃ¤sten Info dokument',0),(416076,11558,'it','Generale inquilino Info documenti',0),(416077,11558,'tl','',0),(416078,11558,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(416079,11558,'hi','à¤œà¤¨à¤°à¤² à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼',0),(416080,11558,'ms','Dokumen-dokumen maklumat penyewa am',0),(416081,11558,'ar','ÙˆØ«Ø§Ø¦Ù‚ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø© Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(416082,11558,'fr','Infos locataire gÃ©nÃ©rales Documents',0),(416083,11558,'jp','ä¸€èˆ¬çš„ãªãƒ†ãƒŠãƒ³ãƒˆæƒ…å ±ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ',0),(416084,11558,'pt','Documentos gerais inquilino Info',0),(416085,11558,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(416086,11558,'es','Documentos de InormaciÃ³n General de Inquilinos ',0),(416087,11558,'de','General-Mieter-Info-Dokumente',0),(416088,11558,'en','General Tenant Info Documents',0),(416089,11559,'is','',0),(416090,11559,'dr','Ù…Ø¯Ø§Ø±Ùƒ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(416091,11559,'pr','Ù…Ø¯Ø§Ø±Ùƒ Ø¯Ø§Ø±Ø§Ø¦ÙŠ ',0),(416092,11559,'tr','MÃ¼lkiyet belgeleri',0),(416093,11559,'pl','WÅ‚aÅ›ciwoÅ›Ä‡ dokumentÃ³w',0),(416094,11559,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð·Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ÑÑ‚',0),(416095,11559,'ur','Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ú©Û’ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(416096,11559,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(416097,11559,'vi','Báº¥t Ä‘á»™ng sáº£n tÃ i liá»‡u',0),(416098,11559,'af','Eiendom dokumente',0),(416099,11559,'ro','Documente de proprietate',0),(416100,11559,'et','Vara dokumendid',0),(416101,11559,'si','Lastnosti dokumentov',0),(416102,11559,'ba','Properti dokumen',0),(416103,11559,'nl','Eigenschap documenten',0),(416104,11559,'fi','KiinteistÃ¶vÃ¤litys asiakirjat',0),(416105,11559,'no','Egenskapen dokumenter',0),(416106,11559,'da','Egenskaben dokumenter',0),(416107,11559,'ko','ë¬¸ì„œ ì†ì„±',0),(416108,11559,'he','×”×ž××¤×™×™×Ÿ ×ž×¡×ž×›×™×',0),(416109,11559,'el','ÎˆÎ³Î³ÏÎ±Ï†Î± Î¹Î´Î¹Î¿ÎºÏ„Î·ÏƒÎ¯Î±Ï‚',0),(416110,11559,'zh','ç‰©ä¸šæ–‡ä»¶\r\n',0),(416111,11559,'sv','Egenskapen dokument',0),(416112,11559,'it','Documenti di proprietÃ .',0),(416113,11559,'tl','',0),(416114,11559,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¹€à¸­à¸à¸ªà¸²à¸£',0),(416115,11559,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚',0),(416116,11559,'ms','Dokumen-dokumen harta',0),(416117,11559,'ar','ÙˆØ«Ø§Ø¦Ù‚ Ø§Ù„Ù…Ù„ÙƒÙŠØ©',0),(416118,11559,'fr','Documents de propriÃ©tÃ©',0),(416119,11559,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ',0),(416120,11559,'pt','Documentos de propriedade.',0),(416121,11559,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹ Ð½Ð° ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ',0),(416122,11559,'es','Documentos de Propiedad',0),(416123,11559,'de','Eigenschaft Dokumente',0),(416124,11559,'en','Property Documents',0),(416125,11560,'is','',0),(416126,11560,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ù…Ø´ØªØ±ÙŠ ',0),(416127,11560,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ù…Ø´ØªØ±ÙŠ ',0),(416128,11560,'tr','Ä°stemci e-posta',0),(416129,11560,'pl','Klient poczty E-mail',0),(416130,11560,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(416131,11560,'ur','Ú©Ù„Ø§Ø¦Ù†Ù¹ Ú©ÛŒ Ø§ÛŒ Ù…ÛŒÙ„',0),(416132,11560,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(416133,11560,'vi','KhÃ¡ch hÃ ng Email',0),(416134,11560,'af','KliÃ«nt E-pos',0),(416135,11560,'ro','Client de E-mail',0),(416136,11560,'et','Kliendi e-post',0),(416137,11560,'si','Odjemalec e-poÅ¡te',0),(416138,11560,'ba','Klien Email',0),(416139,11560,'nl','Client Email',0),(416140,11560,'fi','Asiakkaan sÃ¤hkÃ¶posti',0),(416141,11560,'no','E-post klient',0),(416142,11560,'da','Klient Email',0),(416143,11560,'ko','í´ë¼ì´ì–¸íŠ¸ ì´ë©”ì¼',0),(416144,11560,'he','×œ×§×•×— ×“×•×',0),(416145,11560,'el','Î ÏÏŒÎ³ÏÎ±Î¼Î¼Î±-Ï€ÎµÎ»Î¬Ï„Î·Ï‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(416146,11560,'zh','å®¢æˆ·çš„ç”µå­é‚®ä»¶\r\n',0),(416147,11560,'sv','Klient e-post',0),(416148,11560,'it','Client Email',0),(416149,11560,'tl','',0),(416150,11560,'th','à¹„à¸„à¸¥à¹€à¸­à¸™à¸•à¹Œà¸­à¸µà¹€à¸¡à¸¥',0),(416151,11560,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ˆà¤®à¥‡à¤²',0),(416152,11560,'ms','E-mel pelanggan',0),(416153,11560,'ar','Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(416154,11560,'fr','Courriel du client',0),(416155,11560,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆã®ãƒ¡ãƒ¼ãƒ«',0),(416156,11560,'pt','E-mail de cliente',0),(416157,11560,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(416158,11560,'es','Email del Cliente',0),(416159,11560,'de','E-Mail Client',0),(416160,11560,'en','Client Email',0),(416161,11561,'is','',0),(416162,11561,'dr','ØªÙ„ÙÙ† Ù…Ø´ØªØ±ÙŠ ',0),(416163,11561,'pr','ØªÙ„ÙÙ† Ù…Ø´ØªØ±ÙŠ ',0),(416164,11561,'tr','MÃ¼ÅŸteri telefon',0),(416165,11561,'pl','Telefon klienta',0),(416166,11561,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(416167,11561,'ur','ÙˆØµÙˆÙ„ Ú©Ø§Ø± ÙÙˆÙ†',0),(416168,11561,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(416169,11561,'vi','KhÃ¡ch hÃ ng Ä‘iá»‡n thoáº¡i',0),(416170,11561,'af','KliÃ«nt Foon',0),(416171,11561,'ro','Client de telefon',0),(416172,11561,'et','Kliendi telefoni',0),(416173,11561,'si','Odjemalec telefon',0),(416174,11561,'ba','Klien telepon',0),(416175,11561,'nl','Client telefoon',0),(416176,11561,'fi','Asiakkaan Puhelin',0),(416177,11561,'no','Klienten telefon',0),(416178,11561,'da','Kunde telefon',0),(416179,11561,'ko','í´ë¼ì´ì–¸íŠ¸ ì „í™”',0),(416180,11561,'he','×œ×§×•×— ×˜×œ×¤×•×Ÿ',0),(416181,11561,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ Ï€ÎµÎ»Î¬Ï„Î·',0),(416182,11561,'zh','å®¢æˆ·ç”µè¯\r\n',0),(416183,11561,'sv','Klienten telefon',0),(416184,11561,'it','Telefono del cliente',0),(416185,11561,'tl','',0),(416186,11561,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œ',0),(416187,11561,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤«à¥‹à¤¨',0),(416188,11561,'ms','Telefon pelanggan',0),(416189,11561,'ar','Ù‡Ø§ØªÙ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(416190,11561,'fr','Client tÃ©lÃ©phone',0),(416191,11561,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆã®æºå¸¯é›»è©±',0),(416192,11561,'pt','Telefone do cliente',0),(416193,11561,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð° ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(416194,11561,'es','TelÃ©fono de Cliente',0),(416195,11561,'de','Client-Telefon',0),(416196,11561,'en','Client Phone',0),(416197,11562,'is','',0),(416198,11562,'dr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ÙØ§ÙƒØªÙˆØ± ',0),(416199,11562,'pr','ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯ ÙØ§ÙƒØªÙˆØ± ',0),(416200,11562,'tr','Fatura vade tarihi',0),(416201,11562,'pl','Faktura odpowiednim terminie',0),(416202,11562,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(416203,11562,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(416204,11562,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(416205,11562,'vi','HoÃ¡ Ä‘Æ¡n do ngÃ y',0),(416206,11562,'af','Faktuur verskuldigde datum',0),(416207,11562,'ro','Factura datoritÄƒ data',0),(416208,11562,'et','Arve tÃ¤htaeg kuupÃ¤ev',0),(416209,11562,'si','RaÄun zaradi datuma',0),(416210,11562,'ba','Faktur Due Date',0),(416211,11562,'nl','Factuur Due datum',0),(416212,11562,'fi','Laskun erÃ¤pÃ¤ivÃ¤ PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(416213,11562,'no','Fakturaen forfallsdato dato',0),(416214,11562,'da','Fakturere Due dato',0),(416215,11562,'ko','ì¸í•´ ì†¡ìž¥ ë‚ ì§œ',0),(416216,11562,'he','×—×©×‘×•× ×™×ª ×™×¢×“ ×ª××¨×™×š',0),(416217,11562,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î»ÏŒÎ³Ï‰ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(416218,11562,'zh','å‘ç¥¨åˆ°æœŸæ—¥æœŸ\r\n',0),(416219,11562,'sv','Fakturera Due Date',0),(416220,11562,'it','Fattura scadenza Data',0),(416221,11562,'tl','',0),(416222,11562,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™',0),(416223,11562,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(416224,11562,'ms','Invois habis tempoh tarikh',0),(416225,11562,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„ÙˆØ§Ø¬Ø¨ ØªØ§Ø±ÙŠØ®',0),(416226,11562,'fr','Facture Due Date',0),(416227,11562,'jp','è«‹æ±‚æ›¸ã®æœŸé™ã®æ—¥ä»˜',0),(416228,11562,'pt','Fatura devida Data',0),(416229,11562,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÐŸÐ¾ Ð”Ð°Ñ‚Ðµ',0),(416230,11562,'es','Fecha de Vencimiento de Factura',0),(416231,11562,'de','Rechnung Due Date',0),(416232,11562,'en','Invoice Due Date',0),(416233,11563,'is','',0),(416234,11563,'dr','Ù…Ø§Ù‡ Ø³Ø±Ø±Ø³ÙŠØ¯ ÙØ§ÙƒØªÙˆØ± ',0),(416235,11563,'pr','Ù…Ø§Ù‡ Ø³Ø±Ø±Ø³ÙŠØ¯ ÙØ§ÙƒØªÙˆØ± ',0),(416236,11563,'tr','Fatura vade ay',0),(416237,11563,'pl','Faktura odpowiednim miesiÄ…cu',0),(416238,11563,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾ Ð¼ÐµÑÐµÑ†',0),(416239,11563,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù…Ù‚Ø±Ø±Û Ù…ÛÛŒÙ†Û’',0),(416240,11563,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð¼ÐµÑÐµÑ†Ð°',0),(416241,11563,'vi','HoÃ¡ Ä‘Æ¡n do thÃ¡ng',0),(416242,11563,'af','Faktuur sperdatum maand',0),(416243,11563,'ro','Factura cuvenit luna',0),(416244,11563,'et','Arve tÃ¤htaeg kuu',0),(416245,11563,'si','RaÄun zaradi mesec',0),(416246,11563,'ba','Faktur karena bulan',0),(416247,11563,'nl','Due factureren maand',0),(416248,11563,'fi','Laskun erÃ¤pÃ¤ivÃ¤n kuukauden',0),(416249,11563,'no','Fakturaen forfallsdato mÃ¥ned',0),(416250,11563,'da','Fakturere Due mÃ¥ned',0),(416251,11563,'ko','ì¸í•´ ì†¡ìž¥ ë‹¬',0),(416252,11563,'he','×—×©×‘×•× ×™×ª ×‘×©×œ ×—×•×“×©',0),(416253,11563,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î¼Î®Î½Î±',0),(416254,11563,'zh','å‘ç¥¨åˆ°æœŸæœˆä»½\r\n',0),(416255,11563,'sv','Fakturera vederbÃ¶rlig mÃ¥nad',0),(416256,11563,'it','Fattura scadenza mese',0),(416257,11563,'tl','',0),(416258,11563,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¹€à¸”à¸·à¸­à¸™',0),(416259,11563,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¦à¥‡à¤¯ à¤®à¤¾à¤¹',0),(416260,11563,'ms','Invois Due bulan',0),(416261,11563,'ar','ÙØ§ØªÙˆØ±Ø© Ø§Ù„ÙˆØ§Ø¬Ø¨Ø© Ø§Ù„Ø´Ù‡Ø±',0),(416262,11563,'fr','Facture Due mois',0),(416263,11563,'jp','è«‹æ±‚æ›¸ã®æœŸé™ 1 ãƒ¶æœˆ',0),(416264,11563,'pt','Fatura devida mÃªs',0),(416265,11563,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÐŸÐ¾ ÐœÐµÑÑÑ†Ñƒ',0),(416266,11563,'es','Mes de Vencimiento de Factura',0),(416267,11563,'de','Rechnung fÃ¤llig Monat',0),(416268,11563,'en','Invoice Due Month',0),(416269,11564,'is','',0),(416270,11564,'dr','Ø³Ø§Ù„ Ø³Ø±Ø±Ø³ÙŠØ¯ ÙØ§ÙƒØªÙˆØ±',0),(416271,11564,'pr','Ø³Ø§Ù„ Ø³Ø±Ø±Ø³ÙŠØ¯ ÙØ§ÙƒØªÙˆØ±',0),(416272,11564,'tr','Fatura vade yÄ±l',0),(416273,11564,'pl','Faktura odpowiednim roku',0),(416274,11564,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(416275,11564,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ù‚Ø±Ø±Û Ø³Ø§Ù„',0),(416276,11564,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(416277,11564,'vi','HoÃ¡ Ä‘Æ¡n do nÄƒm',0),(416278,11564,'af','Faktuur sperdatum jaar',0),(416279,11564,'ro','Factura cuvenit an',0),(416280,11564,'et','Arve tÃ¤htaeg aasta',0),(416281,11564,'si','RaÄun zaradi leto',0),(416282,11564,'ba','Faktur Due tahun',0),(416283,11564,'nl','Vervaldatum factuur jaar',0),(416284,11564,'fi','Laskun erÃ¤pÃ¤ivÃ¤n vuoden',0),(416285,11564,'no','Fakturere grunn Ã¥r',0),(416286,11564,'da','Fakturere Due Ã¥r',0),(416287,11564,'ko','ì¸í•´ ì†¡ìž¥ 1 ë…„',0),(416288,11564,'he','×—×©×‘×•× ×™×ª ×‘×©×œ ×©× ×”',0),(416289,11564,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎµÏÎ¸ÎµÏ„Î¿ Ï‡ÏÏŒÎ½Î¿',0),(416290,11564,'zh','å‘ç¥¨åˆ°æœŸ\r\n',0),(416291,11564,'sv','Fakturera vederbÃ¶rlig Ã¥r',0),(416292,11564,'it','Fattura scadenza anno',0),(416293,11564,'tl','',0),(416294,11564,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸›à¸µ',0),(416295,11564,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¿à¤¯à¤¤ à¤µà¤°à¥à¤·',0),(416296,11564,'ms','Invois akhir tahun',0),(416297,11564,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø¹Ø§Ù…',0),(416298,11564,'fr','Facture Due an',0),(416299,11564,'jp','è«‹æ±‚æ›¸ã®æœŸé™ 1 å¹´',0),(416300,11564,'pt','Fatura devida ano',0),(416301,11564,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÐŸÐ¾ Ð“Ð¾Ð´Ñƒ',0),(416302,11564,'es','AÃ±o de Vencimiento de Factura',0),(416303,11564,'de','Rechnung fÃ¤llig Jahr',0),(416304,11564,'en','Invoice Due Year',0),(416305,11565,'is','',0),(416306,11565,'dr','ÙØ§ÙƒØªÙˆØ± Ø§Ø¹Ù„Ø§Ù… ',0),(416307,11565,'pr','ÙØ§ÙƒØªÙˆØ± Ø§Ø¹Ù„Ø§Ù… ',0),(416308,11565,'tr','Fatura bildirim',0),(416309,11565,'pl','ZgÅ‚oszenie faktury',0),(416310,11565,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° ÑƒÐ²ÐµÐ´Ð¾Ð¼ÑÐ²Ð°Ð½Ðµ',0),(416311,11565,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹',0),(416312,11565,'sr','ÐžÐ±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµ Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(416313,11565,'vi','HoÃ¡ Ä‘Æ¡n thÃ´ng bÃ¡o',0),(416314,11565,'af','Faktuur kennisgewing',0),(416315,11565,'ro','FacturÄƒ notificare',0),(416316,11565,'et','Arve teatamine',0),(416317,11565,'si','RaÄuna obvestila',0),(416318,11565,'ba','Faktur pemberitahuan',0),(416319,11565,'nl','Factuur kennisgeving',0),(416320,11565,'fi','Laskun ilmoitus',0),(416321,11565,'no','Faktura varsling',0),(416322,11565,'da','Faktura anmeldelse',0),(416323,11565,'ko','ì†¡ìž¥ ì•Œë¦¼',0),(416324,11565,'he','×”×•×“×¢×” ×¢×œ ×”×—×©×‘×•× ×™×ª',0),(416325,11565,'el','ÎšÎ¿Î¹Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(416326,11565,'zh','å‘ç¥¨çš„é€šçŸ¥\r\n',0),(416327,11565,'sv','Faktura anmÃ¤lan',0),(416328,11565,'it','Notifica di fattura',0),(416329,11565,'tl','',0),(416330,11565,'th','à¸à¸²à¸£à¹à¸ˆà¹‰à¸‡à¹€à¸•à¸·à¸­à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(416331,11565,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾',0),(416332,11565,'ms','Pemberitahuan invois',0),(416333,11565,'ar','Ø§Ù„Ø¥Ø®Ø·Ø§Ø± Ø¨Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(416334,11565,'fr','Notification de facture',0),(416335,11565,'jp','è«‹æ±‚æ›¸ã®é€šçŸ¥',0),(416336,11565,'pt','NotificaÃ§Ã£o de factura',0),(416337,11565,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(416338,11565,'es','NotificaciÃ³n de Factura',0),(416339,11565,'de','Rechnung-Benachrichtigung',0),(416340,11565,'en','Invoice Notification',0),(416341,11566,'is','',0),(416342,11566,'dr','Ù†Ø§Ù… Ù…Ø³ØªØ§Ø¬Ø± ',0),(416343,11566,'pr','Ù†Ø§Ù… Ù…Ø³ØªØ§Ø¬Ø± ',0),(416344,11566,'tr','KiracÄ± ilk ad',0),(416345,11566,'pl','Najemcy imiÄ™',0),(416346,11566,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ Ð¸Ð¼Ðµ',0),(416347,11566,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Û’ Ù¾ÛÙ„Û’ Ú©Û’ Ù†Ø§Ù…',0),(416348,11566,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð¿Ñ€Ð²Ð¾ Ð¸Ð¼Ðµ',0),(416349,11566,'vi','TÃªn ngÆ°á»i thuÃª nhÃ ',0),(416350,11566,'af','Huurder Voornaam',0),(416351,11566,'ro','ChiriaÅŸ Prenume',0),(416352,11566,'et','ÃœÃ¼rnik eesnimi',0),(416353,11566,'si','Ime najemnika',0),(416354,11566,'ba','Nama pertama penyewa',0),(416355,11566,'nl','Voornaam van de huurder',0),(416356,11566,'fi','Vuokralainen etunimi',0),(416357,11566,'no','Leietaker fornavn',0),(416358,11566,'da','Lejer fornavn',0),(416359,11566,'ko','ìž„ì°¨ì¸ ì´ë¦„',0),(416360,11566,'he','×©× ×¤×¨×˜×™ ×”×©×•×›×¨',0),(416361,11566,'el','ÎŒÎ½Î¿Î¼Î± Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(416362,11566,'zh','ç§Ÿå®¢åå­—\r\n',0),(416363,11566,'sv','HyresgÃ¤sten fÃ¶rnamn',0),(416364,11566,'it','Nome primo inquilino',0),(416365,11566,'tl','',0),(416366,11566,'th','à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(416367,11566,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤®',0),(416368,11566,'ms','Nama pertama penyewa',0),(416369,11566,'ar','Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(416370,11566,'fr','PrÃ©nom locataire',0),(416371,11566,'jp','ãƒ†ãƒŠãƒ³ãƒˆå',0),(416372,11566,'pt','Inquilino primeiro nome',0),(416373,11566,'ru','Ð˜Ð¼Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(416374,11566,'es','Inquilino Nombre',0),(416375,11566,'de','Mieter-Vorname',0),(416376,11566,'en','Tenant First Name',0),(416377,11567,'is','',0),(416378,11567,'dr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ Ù…Ø³ØªØ§Ø¬Ø±',0),(416379,11567,'pr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÙŠ Ù…Ø³ØªØ§Ø¬Ø±',0),(416380,11567,'tr','KiracÄ± soyadÄ±',0),(416381,11567,'pl','Nazwisko najemcy',0),(416382,11567,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(416383,11567,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ø®Ø§Ù†Ø¯Ø§Ù†ÛŒ Ù†Ø§Ù…',0),(416384,11567,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(416385,11567,'vi','NgÆ°á»i thuÃª nhÃ  há»',0),(416386,11567,'af','Huurder Van',0),(416387,11567,'ro','ChiriaÅŸ Prenume',0),(416388,11567,'et','ÃœÃ¼rnik perekonnanimi',0),(416389,11567,'si','Priimek najemnika',0),(416390,11567,'ba','Nama terakhir penyewa',0),(416391,11567,'nl','Huurder achternaam',0),(416392,11567,'fi','Vuokralainen sukunimi',0),(416393,11567,'no','Leietaker etternavn',0),(416394,11567,'da','Lejer efternavn',0),(416395,11567,'ko','ì„¸ ìž…ìž ì„±',0),(416396,11567,'he','×©× ×”×ž×©×¤×—×” ×©×œ ×”×“×™×™×¨',0),(416397,11567,'el','Î•Ï€ÏŽÎ½Ï…Î¼Î¿ Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(416398,11567,'zh','ç§Ÿå®¢å§“\r\n',0),(416399,11567,'sv','HyresgÃ¤sten efternamn',0),(416400,11567,'it','Nome dell\'ultimo inquilino',0),(416401,11567,'tl','',0),(416402,11567,'th','à¸™à¸²à¸¡à¸ªà¸à¸¸à¸¥à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(416403,11567,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤•à¤¾ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤®',0),(416404,11567,'ms','Nama penyewa',0),(416405,11567,'ar','Ø§Ø³Ù… Ø§Ù„Ø¹Ø§Ø¦Ù„Ø© Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(416406,11567,'fr','PrÃ©nom du locataire',0),(416407,11567,'jp','ãƒ†ãƒŠãƒ³ãƒˆå',0),(416408,11567,'pt','Ãšltimo nome do inquilino',0),(416409,11567,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ',0),(416410,11567,'es','Inquilino Apellido',0),(416411,11567,'de','Mieter-Nachname',0),(416412,11567,'en','Tenant Last Name',0),(416413,11568,'is','',0),(416414,11568,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØ¹Ù…ÙŠØ± Ù…Ø³ØªØ§Ø¬Ø± Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯ ',0),(416415,11568,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªØ¹Ù…ÙŠØ± Ù…Ø³ØªØ§Ø¬Ø± Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯ ',0),(416416,11568,'tr','KiracÄ± bakÄ±m istek gÃ¶nderildi',0),(416417,11568,'pl','DzierÅ¼awcy utrzymania wniosku',0),(416418,11568,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ€Ð°Ð½Ð¾Ñ‚Ð¾',0),(416419,11568,'ur','Ø¹Ø±Ø¶ Ú©ÛŒØ§ Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©ÛŒ Ø¨Ø­Ø§Ù„ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(416420,11568,'sr','ÐŸÐ¾Ð´Ð½ÐµÑ‚Ð¾Ð³ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð½Ð°Ñ€',0),(416421,11568,'vi','NgÆ°á»i thuÃª nhÃ  báº£o trÃ¬ yÃªu cáº§u gá»­i',0),(416422,11568,'af','Huurder onderhoud versoek ingedien',0),(416423,11568,'ro','ChiriaÅŸ Ã®ntreÅ£inere cererea Ã®naintatÄƒ',0),(416424,11568,'et','ÃœÃ¼rnik sÃ¤ilitamise taotlus',0),(416425,11568,'si','Najemnik vzdrÅ¾evanje zahtevo',0),(416426,11568,'ba','Penyewa pemeliharaan permohonan',0),(416427,11568,'nl','Huurder onderhoud verzoek',0),(416428,11568,'fi','Vuokralainen huolto pyyntÃ¶',0),(416429,11568,'no','Leietaker vedlikehold forespÃ¸rsel sendt',0),(416430,11568,'da','Lejer vedligeholdelse anmodning',0),(416431,11568,'ko','ìž„ì°¨ì¸ ìœ ì§€ ë³´ìˆ˜ ìš”ì²­ ì œì¶œ',0),(416432,11568,'he','×”×“×™×™×¨ ×ª×—×–×•×§×” ×‘×‘×§×©×” ×©×”×•×’×©×”',0),(416433,11568,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î® ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ· Î±Î¯Ï„Î·Î¼Î± Ï…Ï€Î¿Î²Î»Î®Î¸Î·ÎºÎµ',0),(416434,11568,'zh','ç§Ÿå®¢ç»´æŠ¤è¦æ±‚æäº¤\r\n',0),(416435,11568,'sv','HyresgÃ¤sten underhÃ¥ll begÃ¤ran',0),(416436,11568,'it','Inquilino manutenzione richiesta presentata',0),(416437,11568,'tl','',0),(416438,11568,'th','à¸ªà¹ˆà¸‡à¸„à¸³à¸‚à¸­à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(416439,11568,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤°à¤–à¤°à¤–à¤¾à¤µ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤',0),(416440,11568,'ms','Permintaan penyelenggaraan penyewa yang dikemukakan',0),(416441,11568,'ar','Ø·Ù„Ø¨ ØµÙŠØ§Ù†Ø© Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± Ù…Ù‚Ø¯Ù…',0),(416442,11568,'fr','Locataire demande d\'entretien soumis',0),(416443,11568,'jp','ãƒ†ãƒŠãƒ³ãƒˆä¿å®ˆè¦æ±‚ã®é€ä¿¡',0),(416444,11568,'pt','Pedido de manutenÃ§Ã£o do inquilino apresentado',0),(416445,11568,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸ÑŽ Ð¿Ñ€Ð¾ÑÑŒÐ±Ñƒ',0),(416446,11568,'es','SolicitaciÃ³n de Mantenimiento de Inquilino Sometido',0),(416447,11568,'de','Mieter Wartung Antrag',0),(416448,11568,'en','Tenant Maintenance Request Submitted',0),(416449,11569,'is','',0),(416450,11569,'dr','ÙØ§ÙƒØªÙˆØ±',0),(416451,11569,'pr','ÙØ§ÙƒØªÙˆØ±',0),(416452,11569,'tr','Fatura',0),(416453,11569,'pl','Faktury',0),(416454,11569,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(416455,11569,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³',0),(416456,11569,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(416457,11569,'vi','HoÃ¡ Ä‘Æ¡n',0),(416458,11569,'af','Faktuur',0),(416459,11569,'ro','FacturÄƒ',0),(416460,11569,'et','Arve',0),(416461,11569,'si','RaÄuna',0),(416462,11569,'ba','Faktur',0),(416463,11569,'nl','Factuur',0),(416464,11569,'fi','Laskun',0),(416465,11569,'no','Faktura',0),(416466,11569,'da','Faktura',0),(416467,11569,'ko','ì†¡ìž¥',0),(416468,11569,'he','×—×©×‘×•× ×™×ª',0),(416469,11569,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(416470,11569,'zh','å‘ç¥¨\r\n',0),(416471,11569,'sv','Faktura',0),(416472,11569,'it','Fattura',0),(416473,11569,'tl','',0),(416474,11569,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(416475,11569,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸',0),(416476,11569,'ms','Invois',0),(416477,11569,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(416478,11569,'fr','Facture',0),(416479,11569,'jp','è«‹æ±‚æ›¸',0),(416480,11569,'pt','Fatura',0),(416481,11569,'ru','Ð¡Ñ‡ÐµÑ‚',0),(416482,11569,'es','Factura',0),(416483,11569,'de','Rechnung',0),(416484,11569,'en','Invoice',0),(416485,11570,'is','',0),(416486,11570,'dr','Ø¨Ù‡ Ø·ÙˆØ± Ø§ØªÙˆÙ…Ø§ØªÙŠÙƒ ÙØ§ÙƒØªÙˆØ± Ø±Ø§ Ø¯Ø± ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯  Ø¨Ø¯Ù‡ÙƒØ§Ø± ÙƒÙ†ÙŠØ¯',0),(416487,11570,'pr','Ø¨Ù‡ Ø·ÙˆØ± Ø§ØªÙˆÙ…Ø§ØªÙŠÙƒ ÙØ§ÙƒØªÙˆØ± Ø±Ø§ Ø¯Ø± ØªØ§Ø±ÙŠØ® Ø³Ø±Ø±Ø³ÙŠØ¯  Ø¨Ø¯Ù‡ÙƒØ§Ø± ÙƒÙ†ÙŠØ¯',0),(416488,11570,'tr','Otomatik olarak ÅŸarj faturadaki vade tarihi',0),(416489,11570,'pl','Automatycznie pobieraÄ‡ faktury w odpowiednim terminie',0),(416490,11570,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð·Ð°Ñ€ÐµÐ¶Ð´Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸ Ð´Ð°Ñ‚Ð°',0),(416491,11570,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ù‚Ø±Ø±Û Ù¾Ø± Ø®ÙˆØ¯Ú©Ø§Ø± Ø·ÙˆØ± Ù¾Ø± Ú†Ø§Ø±Ø¬ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(416492,11570,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð½Ð° ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(416493,11570,'vi','Äáº¿n háº¡n náº¡p hÃ³a Ä‘Æ¡n tá»± Ä‘á»™ng',0),(416494,11570,'af','Outomaties hef faktuur op die verskuldigde datum',0),(416495,11570,'ro','Percepe automat factura pe cuvenit data',0),(416496,11570,'et','Automaatselt tasu arve tÃ¤htaeg kuupÃ¤ev',0),(416497,11570,'si','Samodejno polnjenje raÄuna na ustreznem datum',0),(416498,11570,'ba','Menagih tagihan pada Due Date',0),(416499,11570,'nl','Automatisch opladen factuur op Due datum',0),(416500,11570,'fi','Automaattisesti veloittaa laskun erÃ¤pÃ¤ivÃ¤nÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(416501,11570,'no','Automatisk belaste fakturaen pÃ¥ grunn dato',0),(416502,11570,'da','Automatisk opkrÃ¦ve faktura pÃ¥ behÃ¸rig dato',0),(416503,11570,'ko','ìžë™ìœ¼ë¡œ ì¶©ì „ ë•Œë¬¸ì— ì†¡ìž¥ ë‚ ì§œ',0),(416504,11570,'he','××•×˜×•×ž×˜×™ ×œ×—×™×•×‘ ×—×©×‘×•× ×™×ª ×¢×œ ×™×¢×“ ×ª××¨×™×š',0),(416505,11570,'el','Î§ÏÎµÏŽÏƒÎµÎ¹ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÏ„Î· Î´Î­Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(416506,11570,'zh','åˆ°æœŸæ—¥è‡ªåŠ¨æ”¶è´¹å‘ç¥¨\r\n',0),(416507,11570,'sv','Automatiskt ladda faktura pÃ¥ Due Date',0),(416508,11570,'it','Carica automaticamente la fattura su Due Date',0),(416509,11570,'tl','',0),(416510,11570,'th','à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸Šà¸³à¸£à¸°à¹ƒà¸™à¸§à¸±à¸™',0),(416511,11570,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¤¿à¤¯à¤¤ à¤ªà¤° à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤šà¤¾à¤°à¥à¤œ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(416512,11570,'ms','Secara automatik mengenakan bayaran invois pada tarikh',0),(416513,11570,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø´Ø­Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù†Ø­Ùˆ Ø§Ù„ÙˆØ§Ø¬Ø¨ ØªØ§Ø±ÙŠØ®',0),(416514,11570,'fr','Automatiquement en Charge facture sur Due Date',0),(416515,11570,'jp','è‡ªå‹•çš„ã«å……é›»ã®ãŸã‚ã«è«‹æ±‚æ›¸ã®æ—¥ä»˜',0),(416516,11570,'pt','Automaticamente cobrar fatura na Due Date',0),(416517,11570,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð²Ð·Ð¸Ð¼Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð° Ð½Ð° Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð¼ Ð”Ð°Ñ‚Ð°',0),(416518,11570,'es','Automaticamente Cobrar Factura en el DÃ­a de Vencimiento',0),(416519,11570,'de','Automatisch aufladen Rechnung auf Due Date',0),(416520,11570,'en','Automatically Charge Invoice On Due Date',0),(416521,11571,'is','',0),(416522,11571,'dr','Ø§ÙˆÙ„ÙˆÙŠØª Ù‡Ø§ÙŠ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(416523,11571,'pr','Ø§ÙˆÙ„ÙˆÙŠØª Ù‡Ø§ÙŠ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø°Ø®ÙŠØ±Ù‡ Ø´Ø¯ ',0),(416524,11571,'tr','Ã–deme tercihleri baÅŸarÄ±yla kaydedildi',0),(416525,11571,'pl','Preferencje pÅ‚atnoÅ›ci zapisane',0),(416526,11571,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½Ð¸Ñ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(416527,11571,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ±Ø¬ÛŒØ­Ø§Øª',0),(416528,11571,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ð¿Ñ€ÐµÑ„ÐµÑ€ÐµÐ½Ñ†Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(416529,11571,'vi','Ä‘Ã£ lÆ°u tham chiáº¿u thanh toÃ¡n thÃ nh cÃ´ng',0),(416530,11571,'af','Betaling Voorskrifte Suksesvol Gestoor',0),(416531,11571,'ro','PreferinÅ£e de platÄƒ salvat cu succes',0),(416532,11571,'et','Makse eelistused salvestatud',0),(416533,11571,'si','PlaÄilo nastavitve uspeÅ¡no shranjen',0),(416534,11571,'ba','Pembayaran Preferensi disimpan berhasil',0),(416535,11571,'nl','Betalingsvoorkeuren succesvol opgeslagen',0),(416536,11571,'fi','Maksuasetusten tallennettu',0),(416537,11571,'no','Betalingsmetoder lagret',0),(416538,11571,'da','Betaling indstillinger gemt med succes',0),(416539,11571,'ko','ê²°ì œ í™˜ê²½ ì„¤ì •ì„ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(416540,11571,'he','×”×¢×“×¤×•×ª ×”×ª×©×œ×•× ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(416541,11571,'el','Î Î»Î·ÏÏ‰Î¼Î® Î ÏÎ¿Ï„Î¹Î¼Î®ÏƒÎµÎ¹Ï‚ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(416542,11571,'zh','ä»˜æ¬¾ä¹ æƒ¯è®¾å®šå·²æˆåŠŸä¿å­˜\r\n',0),(416543,11571,'sv','Betalning instÃ¤llningar sparats',0),(416544,11571,'it','Preferenze di pagamento salvate correttamente',0),(416545,11571,'tl','',0),(416546,11571,'th','à¸¥à¸±à¸à¸©à¸“à¸°à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(416547,11571,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤°à¥€à¤¯à¤¤à¤¾à¤à¤ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(416548,11571,'ms','Keutamaan pembayaran berjaya disimpan',0),(416549,11571,'ar','ØªÙØ¶ÙŠÙ„Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ø­ÙØ¸Ù‡ Ø¨Ù†Ø¬Ø§Ø­',0),(416550,11571,'fr','PrÃ©fÃ©rences de paiement enregistrÃ©s avec succÃ¨s',0),(416551,11571,'jp','æ”¯æ‰•ã„ã®è¨­å®šãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(416552,11571,'pt','PreferÃªncias de pagamento salvas com sucesso',0),(416553,11571,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚ÐµÐ½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(416554,11571,'es','Preferencias de Pago Guardados Exitosamente',0),(416555,11571,'de','Zahlungseinstellungen erfolgreich gespeichert',0),(416556,11571,'en','Payment Preferences Saved Successfully',0),(416557,11572,'is','',0),(416558,11572,'dr','Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡',0),(416559,11572,'pr','Ù¾Ø±Ø¯Ø§Ø®ØªÙ‡Ø§ÙŠ ØªÙƒØ±Ø§Ø± Ø´ÙˆÙ†Ø¯Ù‡',0),(416560,11572,'tr','DÃ¼zenli Ã¶demeler',0),(416561,11572,'pl','PowtarzajÄ…ce siÄ™ pÅ‚atnoÅ›ci',0),(416562,11572,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(416563,11572,'ur','Ø¨Ø§Ø± Ø¨Ø§Ø± Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(416564,11572,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(416565,11572,'vi','thanh toÃ¡n Ä‘á»‹nh ká»³',0),(416566,11572,'af','Herhalende Betalings',0),(416567,11572,'ro','PlÄƒÅ£ile periodice',0),(416568,11572,'et','Perioodilised maksed',0),(416569,11572,'si','PonavljajoÄa se plaÄila',0),(416570,11572,'ba','Pembayaran berulang',0),(416571,11572,'nl','Terugkerende betalingen',0),(416572,11572,'fi','Toistuvat maksut',0),(416573,11572,'no','Periodiske betalinger',0),(416574,11572,'da','Tilbagevendende betalinger',0),(416575,11572,'ko','í• ë¶€',0),(416576,11572,'he','×ª×©×œ×•×ž×™× ×ª×§×•×¤×ª×™×™× ×§×‘×•×¢×™×',0),(416577,11572,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(416578,11572,'zh','å¾ªçŽ¯ä»˜æ¬¾\r\n',0),(416579,11572,'sv','Ã…terkommande betalningar',0),(416580,11572,'it','Pagamenti ricorrenti',0),(416581,11572,'tl','',0),(416582,11572,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‹à¹‰à¸³',0),(416583,11572,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(416584,11572,'ms','Bayaran yang dibuat berulang',0),(416585,11572,'ar','Ø¯ÙØ¹Ø§Øª Ù…ØªÙƒØ±Ù‘Ø±Ø©',0),(416586,11572,'fr','Paiements rÃ©currents',0),(416587,11572,'jp','å®šæœŸçš„ãªæ”¯æ‰•ã„',0),(416588,11572,'pt','Pagamentos recorrentes',0),(416589,11572,'ru','Ð ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(416590,11572,'es','Pagos Recurrentes',0),(416591,11572,'de','Wiederkehrende Zahlungen',0),(416592,11572,'en','Recurring Payments',0),(416593,11573,'is','',0),(416594,11573,'dr','Ø°Ø®ÙŠØ±Ù‡ Ø§ÙˆÙ„ÙˆÙŠØª Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(416595,11573,'pr','Ø°Ø®ÙŠØ±Ù‡ Ø§ÙˆÙ„ÙˆÙŠØª Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(416596,11573,'tr','Ã–deme tercihleri Kaydet',0),(416597,11573,'pl','Zapisz preferencje pÅ‚atnoÅ›ci',0),(416598,11573,'bg','Ð—Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½Ð¸Ñ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(416599,11573,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ±Ø¬ÛŒØ­Ø§Øª Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(416600,11573,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð¶ÐµÑ™ÐµÐ½Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(416601,11573,'vi','LÆ°u tÃ¹y chá»n thanh toÃ¡n',0),(416602,11573,'af','Stoor Betaling Voorkeure',0),(416603,11573,'ro','SalvaÅ£i preferinÅ£ele de platÄƒ',0),(416604,11573,'et','Salvesta tasumine eelistused',0),(416605,11573,'si','Shraniti nastavitve plaÄilo',0),(416606,11573,'ba','Simpan Preferensi pembayaran',0),(416607,11573,'nl','Betalingsvoorkeuren opslaan',0),(416608,11573,'fi','Tallenna Maksuasetusten',0),(416609,11573,'no','Lagre betalingsmetoder',0),(416610,11573,'da','Gemme indstillinger for betaling',0),(416611,11573,'ko','ì§€ë¶ˆ í™˜ê²½ ì„¤ì • ì €ìž¥',0),(416612,11573,'he','×©×ž×•×¨ ×”×¢×“×¤×•×ª ×ª×©×œ×•×',0),(416613,11573,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï€ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î¿Î¹ Ï„ÏÏŒÏ€Î¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(416614,11573,'zh','ä¿å­˜ä»˜æ¬¾ä¹ æƒ¯è®¾å®š\r\n',0),(416615,11573,'sv','Spara betalningsmetod',0),(416616,11573,'it','Salva preferenze di pagamento',0),(416617,11573,'tl','',0),(416618,11573,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸à¸³à¸«à¸™à¸”',0),(416619,11573,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤¾à¤¥à¤®à¤¿à¤•à¤¤à¤¾à¤à¤‚ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(416620,11573,'ms','Simpan pilihan pembayaran',0),(416621,11573,'ar','Ø­ÙØ¸ ØªÙØ¶ÙŠÙ„Ø§Øª Ø§Ù„Ø¯ÙØ¹',0),(416622,11573,'fr','Enregistrer les prÃ©fÃ©rences de paiement',0),(416623,11573,'jp','æ”¯æ‰•ã„ã®è¨­å®šã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(416624,11573,'pt','Salvar preferÃªncias de pagamento',0),(416625,11573,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(416626,11573,'es','Guardar Preferencias de Pago',0),(416627,11573,'de','Speichern von Zahlungseinstellungen',0),(416628,11573,'en','Save Payment Preferences',0),(416629,11574,'is','',0),(416630,11574,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(416631,11574,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙŠÙƒ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(416632,11574,'tr','Bir Ã¶zellik seÃ§meniz gerekir',0),(416633,11574,'pl','NaleÅ¼y zaznaczyÄ‡ wÅ‚aÅ›ciwoÅ›ci',0),(416634,11574,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(416635,11574,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(416636,11574,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð¾',0),(416637,11574,'vi','Báº¡n Pháº£i Chá»n Má»™t tÃ i sáº£n',0),(416638,11574,'af','U moet \'n Eiendom Kies',0),(416639,11574,'ro','Trebuie sÄƒ selectaÅ£i o proprietate',0),(416640,11574,'et','Te peate valima kinnistu',0),(416641,11574,'si','Izberite nepremiÄnine',0),(416642,11574,'ba','Anda harus memilih properti',0),(416643,11574,'nl','U moet een eigenschap hebt geselecteerd',0),(416644,11574,'fi','Valitse ominaisuus',0),(416645,11574,'no','Du mÃ¥ velge en egenskap',0),(416646,11574,'da','Du skal vÃ¦lge en egenskab',0),(416647,11574,'ko','ì†ì„±ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(416648,11574,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×ž××¤×™×™×Ÿ',0),(416649,11574,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î¼Î¹Î± Î¹Î´Î¹ÏŒÏ„Î·Ï„Î±',0),(416650,11574,'zh','ä½ å¿…é¡»é€‰æ‹©ä¸€ä¸ªå±žæ€§\r\n',0),(416651,11574,'sv','Du mÃ¥ste vÃ¤lja en egenskap',0),(416652,11574,'it','Ãˆ necessario selezionare una proprietÃ ',0),(416653,11574,'tl','',0),(416654,11574,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(416655,11574,'hi','à¤†à¤ª à¤à¤• à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(416656,11574,'ms','Anda mesti memilih hartanah',0),(416657,11574,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ­Ø¯ÙŠØ¯ Ø®Ø§ØµÙŠØ©',0),(416658,11574,'fr','Vous devez sÃ©lectionner une propriÃ©tÃ©',0),(416659,11574,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(416660,11574,'pt','VocÃª deve selecionar uma propriedade',0),(416661,11574,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(416662,11574,'es','Debe Seleccionar una Propiedad',0),(416663,11574,'de','Sie mÃ¼ssen eine Eigenschaft auswÃ¤hlen.',0),(416664,11574,'en','You Must Select A Property',0),(416665,11575,'is','',0),(416666,11575,'dr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¯Ø± Ø®ÙˆØ§Ø³Øª  Ø§Ø¬Ø§Ø±Ù‡  ',0),(416667,11575,'pr','ÙƒØ§Ø±Ù…Ø²Ø¯ Ø¯Ø± Ø®ÙˆØ§Ø³Øª  Ø§Ø¬Ø§Ø±Ù‡  ',0),(416668,11575,'tr','Kira baÅŸvuru Ã¼creti',0),(416669,11575,'pl','Ceny wynajmu aplikacji',0),(416670,11575,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(416671,11575,'ur','Ù¾Ù¹Û’ Ù¾Ø± Ø¯ÛŒÙ†Û’ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ ÙÛŒØ³',0),(416672,11575,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð·Ð° Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²ÑšÐµ',0),(416673,11575,'vi','Cho thuÃª lá»‡ phÃ­ ná»™p Ä‘Æ¡n',0),(416674,11575,'af','Huurkontrak Aansoekfooi',0),(416675,11575,'ro','Taxa de cerere de leasing',0),(416676,11575,'et','Liisingu taotluse esitamise lÃµiv',0),(416677,11575,'si','Najemne pogodbe pristojbino za prijavo',0),(416678,11575,'ba','Biaya aplikasi sewa',0),(416679,11575,'nl','Lease aanvraagkosten',0),(416680,11575,'fi','Vuokrasopimuksen hakemusmaksu',0),(416681,11575,'no','Leieavtalen pÃ¥meldingsavgiften',0),(416682,11575,'da','Lease ansÃ¸gningsgebyr',0),(416683,11575,'ko','ìž„ëŒ€ ì‹ ì²­ë¹„',0),(416684,11575,'he','××’×¨×ª ×”×‘×§×©×” ×—×›×™×¨×”',0),(416685,11575,'el','Î¤Î­Î»Î¿Ï‚ Î±Î¯Ï„Î·ÏƒÎ·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(416686,11575,'zh','ç§Ÿèµç”³è¯·è´¹\r\n',0),(416687,11575,'sv','Hyresavtalet ansÃ¶kningsavgiften',0),(416688,11575,'it','Tassa di locazione',0),(416689,11575,'tl','',0),(416690,11575,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¹€à¸Šà¹ˆà¸²',0),(416691,11575,'hi','à¤†à¤µà¥‡à¤¦à¤¨ à¤¶à¥à¤²à¥à¤• à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(416692,11575,'ms','Bayaran permohonan pajakan',0),(416693,11575,'ar','Ø±Ø³ÙˆÙ… Ø·Ù„Ø¨ Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(416694,11575,'fr','Frais de demande de location',0),(416695,11575,'jp','ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã®ãƒªãƒ¼ã‚¹æ–™',0),(416696,11575,'pt','Taxa de inscriÃ§Ã£o de locaÃ§Ã£o',0),(416697,11575,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(416698,11575,'es','Cuota de AplicaciÃ³n de Arrendamiento',0),(416699,11575,'de','Leasing-AnmeldegebÃ¼hr',0),(416700,11575,'en','Lease Application Fee',0),(416701,11576,'is','',0),(416702,11576,'dr','Ù…ØªÙ‚Ø§Ø¶ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(416703,11576,'pr','Ù…ØªÙ‚Ø§Ø¶ÙŠ Ø¬Ø¯ÙŠØ¯ ',0),(416704,11576,'tr','Yeni baÅŸvuru',0),(416705,11576,'pl','Nowy wnioskodawca',0),(416706,11576,'bg','ÐÐ¾Ð² Ð·Ð°ÑÐ²Ð¸Ñ‚ÐµÐ»',0),(416707,11576,'ur','Ù†Ø¦ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¯ÛÙ†Ø¯Û',0),(416708,11576,'sr','ÐÐ¾Ð²Ð¸ ÐºÐ°Ð½Ð´Ð¸Ð´Ð°Ñ‚',0),(416709,11576,'vi','NgÆ°á»i ná»™p Ä‘Æ¡n má»›i',0),(416710,11576,'af','Nuwe aansoeker',0),(416711,11576,'ro','Solicitant nou',0),(416712,11576,'et','Uus taotleja',0),(416713,11576,'si','Nov vlagatelj',0),(416714,11576,'ba','Pemohon baru',0),(416715,11576,'nl','Nieuwe aanvrager',0),(416716,11576,'fi','Uusi hakija',0),(416717,11576,'no','Ny sÃ¸ker',0),(416718,11576,'da','Ny ansÃ¸ger',0),(416719,11576,'ko','ìƒˆë¡œìš´ ì‹ ì²­ìž',0),(416720,11576,'he','×”×ž×‘×§×© ×—×“×©',0),(416721,11576,'el','ÎÎ­ÎµÏ‚ Ï…Ï€Î¿ÏˆÎ®Ï†Î¹ÎµÏ‚ Ï€ÏÎ¿Ï‚ Î­Î½Ï„Î±Î¾Î·',0),(416722,11576,'zh','æ–°ç”³è¯·äºº\r\n',0),(416723,11576,'sv','Ny sÃ¶kande',0),(416724,11576,'it','Nuovo richiedente',0),(416725,11576,'tl','',0),(416726,11576,'th','à¸ªà¸¡à¸±à¸„à¸£à¹ƒà¸«à¸¡à¹ˆ',0),(416727,11576,'hi','à¤¨à¤ˆ à¤†à¤µà¥‡à¤¦à¤•',0),(416728,11576,'ms','Pemohon baru',0),(416729,11576,'ar','Ø·Ø§Ù„Ø¨ Ø¬Ø¯ÙŠØ¯',0),(416730,11576,'fr','Nouveau dÃ©posant',0),(416731,11576,'jp','æ–°ã—ã„ç”³è«‹è€…',0),(416732,11576,'pt','Novo candidato',0),(416733,11576,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð·Ð°ÑÐ²Ð¸Ñ‚ÐµÐ»ÑŒ',0),(416734,11576,'es','Nuevo Solicitante',0),(416735,11576,'de','Neue Antragsteller',0),(416736,11576,'en','New Applicant',0),(416737,11577,'is','',0),(416738,11577,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ø±Øª ',0),(416739,11577,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙƒØ§Ø±Øª ',0),(416740,11577,'tr','KartÄ±nÄ± seÃ§in',0),(416741,11577,'pl','Wybierz kartÄ™',0),(416742,11577,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ°Ñ€Ñ‚Ð°',0),(416743,11577,'ur','Ú©Ø§Ø±Úˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(416744,11577,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(416745,11577,'vi','Chá»n tháº»',0),(416746,11577,'af','Kies kaart',0),(416747,11577,'ro','SelectaÅ£i cartela',0),(416748,11577,'et','Vali kaart',0),(416749,11577,'si','Izberite kartico',0),(416750,11577,'ba','Pilih kartu',0),(416751,11577,'nl','Selecteer van kaart',0),(416752,11577,'fi','Valitse kortti',0),(416753,11577,'no','Velg kort',0),(416754,11577,'da','VÃ¦lg kortet',0),(416755,11577,'ko','ì¹´ë“œë¥¼ ì„ íƒ',0),(416756,11577,'he','×‘×—×¨ ×›×¨×˜×™×¡',0),(416757,11577,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ ÎºÎ¬ÏÏ„Î±',0),(416758,11577,'zh','é€‰æ‹©å¡\r\n',0),(416759,11577,'sv','VÃ¤lj kort',0),(416760,11577,'it','Selezionare la scheda',0),(416761,11577,'tl','',0),(416762,11577,'th','à¹€à¸¥à¸·à¸­à¸à¸šà¸±à¸•à¸£',0),(416763,11577,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(416764,11577,'ms','Pilih Kad',0),(416765,11577,'ar','Ø­Ø¯Ø¯ Ø¨Ø·Ø§Ù‚Ø©',0),(416766,11577,'fr','SÃ©lectionnez la carte',0),(416767,11577,'jp','ã‚«ãƒ¼ãƒ‰ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(416768,11577,'pt','Selecione o cartÃ£o',0),(416769,11577,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐšÐ°Ñ€Ñ‚Ñƒ',0),(416770,11577,'es','Selecciona Tarjeta',0),(416771,11577,'de','WÃ¤hlen Sie Karte',0),(416772,11577,'en','Select Card',0),(416773,11578,'is','',0),(416774,11578,'dr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø°Ø®ÙŠØ±Ù‡â€Œ Ø´Ø¯Ù‡',0),(416775,11578,'pr','ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ø°Ø®ÙŠØ±Ù‡â€Œ Ø´Ø¯Ù‡',0),(416776,11578,'tr','SaklÄ± kredi kartÄ±',0),(416777,11578,'pl','Przechowywane karty kredytowej',0),(416778,11578,'bg','Ð¡ÑŠÑ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(416779,11578,'ur','Ø°Ø®ÛŒØ±Û Ø´Ø¯Û Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ',0),(416780,11578,'sr','Ð£ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚ÐµÐ½Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(416781,11578,'vi','Tháº» tÃ­n dá»¥ng lÆ° trá»¯',0),(416782,11578,'af','Gestoorde kredietkaart',0),(416783,11578,'ro','Card de Credit stocate',0),(416784,11578,'et','Salvestatud krediitkaardi',0),(416785,11578,'si','Shranjene kreditne kartice',0),(416786,11578,'ba','Kartu kredit disimpan',0),(416787,11578,'nl','Opgeslagen creditcard',0),(416788,11578,'fi','Tallennetun luottokortin',0),(416789,11578,'no','Lagrede kredittkort',0),(416790,11578,'da','Lagrede kreditkort',0),(416791,11578,'ko','ì €ìž¥ ëœ ì‹ ìš© ì¹´ë“œ',0),(416792,11578,'he','×›×¨×˜×™×¡ ××©×¨××™ ×ž××•×—×¡×Ÿ',0),(416793,11578,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏ…Î¼Î­Î½Î· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(416794,11578,'zh','å­˜å‚¨ä¿¡ç”¨å¡\r\n',0),(416795,11578,'sv','Lagrade kreditkort',0),(416796,11578,'it','Carta di credito memorizzato',0),(416797,11578,'tl','',0),(416798,11578,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¹„à¸§à¹‰',0),(416799,11578,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹à¤¿à¤¤ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡',0),(416800,11578,'ms','Kad kredit yang disimpan',0),(416801,11578,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ù…Ø®Ø²Ù†',0),(416802,11578,'fr','Carte de crÃ©dit stockÃ©',0),(416803,11578,'jp','ä¿å­˜æ¸ˆã¿ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰',0),(416804,11578,'pt','CartÃ£o de crÃ©dito armazenado',0),(416805,11578,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ ÐºÐ°Ñ€Ñ‚Ð°',0),(416806,11578,'es','Tarjeta de CrÃ©dito Almacenada',0),(416807,11578,'de','Gespeicherte Kreditkarte',0),(416808,11578,'en','Stored Credit Card',0),(416809,11579,'is','',0),(416810,11579,'dr','( ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ø¨Ø±Ù†Ø§Ù…Ù‡ ÛŒÙˆØ²Ø±Ø¯ÙŠ )',0),(416811,11579,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø¯Ù‰ ØŒØªÙ‚Ø§Ø¶Ø§Ù‰ Ú©Ø§Ø± ÙƒØ§Ù…Ù„ ( ÙƒØ§Ù…Ù„ ÙƒØ±Ø¯Ù† Ø¨Ø±Ù†Ø§Ù…Ù‡ ÙƒØ§Ø±Ø¨Ø±Ø¯ÙŠ )',0),(416812,11579,'tr','Tam uygulama',0),(416813,11579,'pl','Kompletnego wniosku',0),(416814,11579,'bg','ÐŸÑŠÐ»Ð½Ð¾ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(416815,11579,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ú©Ù…Ù„ Ú©Ø±ÛŒÚº',0),(416816,11579,'sr','ÐšÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð° Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(416817,11579,'vi','hoÃ n thÃ nh Ä‘Æ¡n ',0),(416818,11579,'af','Voltooide Aansoek',0),(416819,11579,'ro','Cerere completÄƒ',0),(416820,11579,'et','TÃ¤ieliku taotluse',0),(416821,11579,'si','Popolno vlogo',0),(416822,11579,'ba','Aplikasi lengkap',0),(416823,11579,'nl','Volledige aanvraag',0),(416824,11579,'fi','TÃ¤ydellisen hakemuksen',0),(416825,11579,'no','Komplett program',0),(416826,11579,'da','Komplet program',0),(416827,11579,'ko','ì™„ë²½ í•œ ì‘ìš© í”„ë¡œê·¸ëž¨',0),(416828,11579,'he','×”×™×™×©×•× ×”×ž×œ×',0),(416829,11579,'el','Î Î»Î®ÏÎ· ÎµÏ†Î±ÏÎ¼Î¿Î³Î®',0),(416830,11579,'zh','å®Œæˆç”³è¯·\r\n',0),(416831,11579,'sv','Komplett ansÃ¶kan',0),(416832,11579,'it','Completa applicazione',0),(416833,11579,'tl','',0),(416834,11579,'th','à¸à¸²à¸£à¸ªà¸¡à¸±à¸„à¸£',0),(416835,11579,'hi','à¤ªà¥‚à¤°à¤¾ à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤—',0),(416836,11579,'ms','Permohonan yang lengkap',0),(416837,11579,'ar','Ø§Ø³ØªÙƒÙ…Ø§Ù„ ØªØ·Ø¨ÙŠÙ‚',0),(416838,11579,'fr','Application complÃ¨te',0),(416839,11579,'jp','å®Œå…¨ãªã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(416840,11579,'pt','Aplicativo completo',0),(416841,11579,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(416842,11579,'es','AplicacÃ­on Completa',0),(416843,11579,'de','VollstÃ¤ndige Bewerbung',0),(416844,11579,'en','Complete Application',0),(416845,11580,'is','',0),(416846,11580,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ ',0),(416847,11580,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ ÙˆØ§Ø­Ø¯Ù‡Ø§ÙŠ Ù…ÙˆØ¬ÙˆØ¯ ',0),(416848,11580,'tr','Arama birimleri',0),(416849,11580,'pl','Wyszukiwanie dostÄ™pnych jednostek',0),(416850,11580,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(416851,11580,'ur','ØªÙ„Ø§Ø´ Ø¯Ø³ØªÛŒØ§Ø¨ ÛŒÙˆÙ†Ù¹Ø³',0),(416852,11580,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð³Ðµ ÑÑƒ ÑÐ»Ð¾Ð±Ð¾Ð´Ð½Ð¸',0),(416853,11580,'vi','TÃ¬m Ä‘Æ¡n vá»‹ cÃ³ sáºµn',0),(416854,11580,'af','Soek Beskikbare Eenhede',0),(416855,11580,'ro','CÄƒutaÅ£i disponibile unitÄƒÅ£i',0),(416856,11580,'et','Otsi Saadaolevate mÃµÃµtÃ¼hikute',0),(416857,11580,'si','IÅ¡Äi na voljo enote',0),(416858,11580,'ba','Cari tersedia unit',0),(416859,11580,'nl','Zoek beschikbare eenheden',0),(416860,11580,'fi','Etsi kÃ¤ytettÃ¤vissÃ¤',0),(416861,11580,'no','SÃ¸k etter tilgjengelige enheter',0),(416862,11580,'da','SÃ¸g efter tilgÃ¦ngelige enheder',0),(416863,11580,'ko','ê²€ìƒ‰ ê°€ëŠ¥í•œ ë‹¨ìœ„',0),(416864,11580,'he','×—×™×¤×•×© ×”×™×—×™×“×•×ª ×”×¤× ×•×™×•×ª',0),(416865,11580,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼ÎµÏ‚ Î¼Î¿Î½Î¬Î´ÎµÏ‚',0),(416866,11580,'zh','æœç´¢å¯ç”¨å•ä½\r\n',0),(416867,11580,'sv','SÃ¶k tillgÃ¤ngliga enheter',0),(416868,11580,'it','Ricerca unitÃ  disponibili',0),(416869,11580,'tl','',0),(416870,11580,'th','à¸„à¹‰à¸™à¸«à¸²à¸«à¸™à¹ˆà¸§à¸¢à¸‡à¸²à¸™',0),(416871,11580,'hi','à¤–à¥‹à¤œ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚',0),(416872,11580,'ms','Unit-unit yang tersedia di Cari',0),(416873,11580,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ø¨Ø­Ø« Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(416874,11580,'fr','Recherche d\'unitÃ©s disponibles',0),(416875,11580,'jp','æ¤œç´¢åˆ©ç”¨å¯èƒ½ãªãƒ¦ãƒ‹ãƒƒãƒˆ',0),(416876,11580,'pt','Unidades de pesquisa',0),(416877,11580,'ru','ÐŸÐ¾Ð¸ÑÐº Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ñ… ÐµÐ´Ð¸Ð½Ð¸Ñ†',0),(416878,11580,'es','Buscar Unidades Disponibles',0),(416879,11580,'de','Suche verfÃ¼gbaren Einheiten',0),(416880,11580,'en','Search Available Units',0),(416881,11581,'is','',0),(416882,11581,'dr','Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª Ùˆ ØªØ¨ØµØ±Ù‡ Ù‡Ø§',0),(416883,11581,'pr','Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª Ùˆ ØªØ¨ØµØ±Ù‡ Ù‡Ø§',0),(416884,11581,'tr','Ä°letiÅŸim ve notlar',0),(416885,11581,'pl','Komunikacji i informacji dodatkowej',0),(416886,11581,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(416887,11581,'ur','Ù…ÙˆØ§ØµÙ„Ø§Øª Ø§ÙˆØ± Ù†ÙˆÙ¹',0),(416888,11581,'sr','ÐšÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð¸ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(416889,11581,'vi','sá»± giao tiáº¿p vÃ  ghi chÃº',0),(416890,11581,'af','Kommunikasie en notas',0),(416891,11581,'ro','ComunicaÅ£ii ÅŸi note',0),(416892,11581,'et','Side ja mÃ¤rkmed',0),(416893,11581,'si','Komunikacije in opombe',0),(416894,11581,'ba','Komunikasi dan catatan',0),(416895,11581,'nl','Mededelingen en notities',0),(416896,11581,'fi','ViestinnÃ¤n ja muistiinpanoja',0),(416897,11581,'no','Kommunikasjon og notater',0),(416898,11581,'da','Kommunikation og noter',0),(416899,11581,'ko','í†µì‹  ë° ë©”ëª¨',0),(416900,11581,'he','×ª×§×©×•×¨×ª ×•×”×¢×¨×•×ª',0),(416901,11581,'el','Î•Ï€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÏŽÎ½ ÎºÎ±Î¹ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(416902,11581,'zh','é€šè®¯åŠå¤‡æ³¨\r\n',0),(416903,11581,'sv','Kommunikation och anteckningar',0),(416904,11581,'it','Note e comunicazioni',0),(416905,11581,'tl','',0),(416906,11581,'th','à¸ªà¸·à¹ˆà¸­à¸ªà¸²à¸£à¹à¸¥à¸°à¸šà¸±à¸™à¸—à¸¶à¸',0),(416907,11581,'hi','à¤¸à¤‚à¤šà¤¾à¤° à¤”à¤° à¤¨à¥‹à¤Ÿà¥à¤¸',0),(416908,11581,'ms','Komunikasi dan Nota-Nota',0),(416909,11581,'ar','Ø§Ù„Ø±Ø³Ø§Ø¦Ù„ ÙˆØ§Ù„Ù…Ø°ÙƒØ±Ø§Øª',0),(416910,11581,'fr','Communications et Notes',0),(416911,11581,'jp','é€šä¿¡ãŠã‚ˆã³ãƒŽãƒ¼ãƒˆ',0),(416912,11581,'pt','Notas e comunicaÃ§Ãµes',0),(416913,11581,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ Ð¸ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(416914,11581,'es','Comunicaciones Y Notas',0),(416915,11581,'de','Mitteilungen und Notizen',0),(416916,11581,'en','Communications And Notes',0),(416917,11582,'is','',0),(416918,11582,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª Ùˆ ØªØ¨ØµØ±Ù‡ Ù‡Ø§',0),(416919,11582,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª Ùˆ ØªØ¨ØµØ±Ù‡ Ù‡Ø§',0),(416920,11582,'tr','Ä°letiÅŸim ve notlar yÃ¶nergeleri',0),(416921,11582,'pl','Komunikacji i notatki instrukcje',0),(416922,11582,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(416923,11582,'ur','Ù…ÙˆØ§ØµÙ„Ø§Øª Ø§ÙˆØ± Ù†ÙˆÙ¹ÙˆÚº Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(416924,11582,'sr','ÐšÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð¸ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð·Ð° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(416925,11582,'vi','nhá»¯ng hÆ°á»›ng dáº«n giao tiáº¿p vÃ  ghi chÃº',0),(416926,11582,'af','Kommunikasie en notas instruksies',0),(416927,11582,'ro','ComunicaÅ£ii ÅŸi instrucÅ£iunile de note',0),(416928,11582,'et','Side ja mÃ¤rkmed juhiseid',0),(416929,11582,'si','Komunikacije in navodila opombe',0),(416930,11582,'ba','Komunikasi dan instruksi catatan',0),(416931,11582,'nl','Mededelingen en notities instructies',0),(416932,11582,'fi','ViestinnÃ¤n ja toteaa ohjeet',0),(416933,11582,'no','Kommunikasjon og notater instruksjoner',0),(416934,11582,'da','Kommunikation og noter instruktioner',0),(416935,11582,'ko','í†µì‹  ë° ì •ë³´ ì§€ì¹¨',0),(416936,11582,'he','×ª×§×©×•×¨×ª ×•×”×•×¨××•×ª ×”×¢×¨×•×ª',0),(416937,11582,'el','Î•Ï€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÏŽÎ½ ÎºÎ±Î¹ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(416938,11582,'zh','é€šè®¯åŠå¤‡æ³¨çš„è¯´æ˜Ž\r\n',0),(416939,11582,'sv','Kommunikation och anteckningar instruktioner',0),(416940,11582,'it','Comunicazioni e istruzioni note',0),(416941,11582,'tl','',0),(416942,11582,'th','à¸ªà¸·à¹ˆà¸­à¸ªà¸²à¸£à¹à¸¥à¸°à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸„à¸³à¹à¸™à¸°à¸™à¸³',0),(416943,11582,'hi','à¤¸à¤‚à¤šà¤¾à¤° à¤”à¤° à¤¨à¥‹à¤Ÿà¥à¤¸ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(416944,11582,'ms','Komunikasi dan Nota arahan',0),(416945,11582,'ar','Ø§Ù„Ø§ØªØµØ§Ù„Ø§Øª ÙˆØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(416946,11582,'fr','Communications et Notes Instructions',0),(416947,11582,'jp','é€šä¿¡ãƒ» ãƒŽãƒ¼ãƒˆã®æŒ‡ç¤º',0),(416948,11582,'pt','ComunicaÃ§Ãµes e instruÃ§Ãµes de notas',0),(416949,11582,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ Ð¸ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(416950,11582,'es','Instrucciones de Comunicaciones Y Notas',0),(416951,11582,'de','Mitteilungen und Hinweise Anweisungen',0),(416952,11582,'en','Communications And Notes Instructions',0),(416953,11583,'is','',0),(416954,11583,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª ',0),(416955,11583,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª ',0),(416956,11583,'tr','Arama iletiÅŸim',0),(416957,11583,'pl','Szukaj komunikacji',0),(416958,11583,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° ÐºÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(416959,11583,'ur','ØªÙ„Ø§Ø´ Ù…ÙˆØ§ØµÙ„Ø§Øª',0),(416960,11583,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð³Ð° ÐºÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(416961,11583,'vi','TÃ¬m kiáº¿m Truyá»n thÃ´ng',0),(416962,11583,'af','Soek Kommunikasies',0),(416963,11583,'ro','CÄƒutare de comunicaÅ£ii',0),(416964,11583,'et','Otsi sidet',0),(416965,11583,'si','IÅ¡Äi sporoÄila',0),(416966,11583,'ba','Cari komunikasi',0),(416967,11583,'nl','Zoek communicatie',0),(416968,11583,'fi','Etsi tietoliikenteestÃ¤',0),(416969,11583,'no','SÃ¸k kommunikasjon',0),(416970,11583,'da','SÃ¸g efter meddelelser',0),(416971,11583,'ko','ê²€ìƒ‰ ì»¤ë®¤ë‹ˆì¼€ì´ì…˜',0),(416972,11583,'he','×—×™×¤×•×© ×ª×§×©×•×¨×ª',0),(416973,11583,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÏŽÎ½',0),(416974,11583,'zh','æœç´¢é€šè®¯\r\n',0),(416975,11583,'sv','SÃ¶k kommunikation',0),(416976,11583,'it','Ricerca comunicazioni',0),(416977,11583,'tl','',0),(416978,11583,'th','à¸„à¹‰à¸™à¸«à¸²à¸ªà¸·à¹ˆà¸­à¸ªà¸²à¸£',0),(416979,11583,'hi','à¤¸à¤‚à¤šà¤¾à¤° à¤®à¥‡à¤‚ à¤–à¥‹à¤œà¥‡à¤‚',0),(416980,11583,'ms','Gelintar komunikasi',0),(416981,11583,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø±Ø³Ø§Ø¦Ù„',0),(416982,11583,'fr','Communications de la recherche',0),(416983,11583,'jp','æ¤œç´¢é€šä¿¡',0),(416984,11583,'pt','ComunicaÃ§Ãµes de pesquisa',0),(416985,11583,'ru','ÐŸÐ¾Ð¸ÑÐº ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹',0),(416986,11583,'es','Buscar Comunicaciones',0),(416987,11583,'de','Suche Communications',0),(416988,11583,'en','Search Communications',0),(416989,11584,'is','',0),(416990,11584,'dr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª Ùˆ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(416991,11584,'pr','Ø¬Ø³ØªØ¬ÙˆÙŠ Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª Ùˆ ÙŠØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(416992,11584,'tr','Arama iletiÅŸim ve notlar',0),(416993,11584,'pl','Szukaj komunikacji i notatki',0),(416994,11584,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° ÐºÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ð¸ Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(416995,11584,'ur','ØªÙ„Ø§Ø´ Ù…ÙˆØ§ØµÙ„Ø§Øª Ø§ÙˆØ± Ù†ÙˆÙ¹',0),(416996,11584,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð³Ð° ÐºÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð¸ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(416997,11584,'vi','TÃ¬m kiáº¿m Truyá»n thÃ´ng vÃ  lÆ°u Ã½',0),(416998,11584,'af','Soek Kommunikasies en Notas',0),(416999,11584,'ro','CÄƒutare de comunicaÅ£ii ÅŸi note',0),(417000,11584,'et','Otsi sidet ja mÃ¤rkmed',0),(417001,11584,'si','IÅ¡Äi sporoÄila in opombe',0),(417002,11584,'ba','Cari komunikasi dan catatan',0),(417003,11584,'nl','Zoek mededelingen en notities',0),(417004,11584,'fi','Etsi tietoliikenteestÃ¤ ja muistiinpanoja',0),(417005,11584,'no','SÃ¸k kommunikasjon og notater',0),(417006,11584,'da','SÃ¸g efter meddelelser og noter',0),(417007,11584,'ko','ê²€ìƒ‰ ì»¤ë®¤ë‹ˆì¼€ì´ì…˜ ë° ë©”ëª¨',0),(417008,11584,'he','×—×™×¤×•×© ×ª×§×©×•×¨×ª ×•×”×¢×¨×•×ª',0),(417009,11584,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÏŽÎ½ ÎºÎ±Î¹ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(417010,11584,'zh','æœç´¢é€šè®¯åŠè¯´æ˜Ž\r\n',0),(417011,11584,'sv','SÃ¶k meddelanden och anteckningar',0),(417012,11584,'it','Ricerca comunicazioni e note',0),(417013,11584,'tl','',0),(417014,11584,'th','à¸ªà¸·à¹ˆà¸­à¸ªà¸²à¸£à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²à¹à¸¥à¸°à¸šà¸±à¸™à¸—à¸¶à¸',0),(417015,11584,'hi','à¤¸à¤‚à¤šà¤¾à¤° à¤®à¥‡à¤‚ à¤–à¥‹à¤œà¥‡à¤‚ à¤”à¤° à¤¨à¥‹à¤Ÿà¥à¤¸',0),(417016,11584,'ms','Gelintar komunikasi dan Nota-Nota',0),(417017,11584,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø±Ø³Ø§Ø¦Ù„ ÙˆØ§Ù„Ù…Ø°ÙƒØ±Ø§Øª',0),(417018,11584,'fr','Recherche Communications et Notes',0),(417019,11584,'jp','æ¤œç´¢é€šä¿¡ãŠã‚ˆã³ãƒŽãƒ¼ãƒˆ',0),(417020,11584,'pt','Notas e comunicaÃ§Ãµes de pesquisa',0),(417021,11584,'ru','ÐŸÐ¾Ð¸ÑÐº ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ Ð¸ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(417022,11584,'es','Buscar Comunicaciones y Notas',0),(417023,11584,'de','Suche Mitteilungen und Notizen',0),(417024,11584,'en','Search Communications And Notes',0),(417025,11585,'is','',0),(417026,11585,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(417027,11585,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(417028,11585,'tr','Kira imzaladÄ±',0),(417029,11585,'pl','DzierÅ¼awy podpisana',0),(417030,11585,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°',0),(417031,11585,'ur','Ù„ÛŒØ² Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Ø¦Û’',0),(417032,11585,'sr','Ð£Ð³Ð¾Ð²Ð¾Ñ€ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ð½',0),(417033,11585,'vi','Ä‘Ã£ kÃ½ há»£p Ä‘á»“ng thuÃª',0),(417034,11585,'af','Huurkontrak is Onderteken',0),(417035,11585,'ro','Contract de Ã®nchiriere semnat',0),(417036,11585,'et','ÃœÃ¼rilepingu sÃµlminud',0),(417037,11585,'si','Najemne pogodbe, podpisane',0),(417038,11585,'ba','Sewa ditandatangani',0),(417039,11585,'nl','Lease-overeenkomst ondertekend',0),(417040,11585,'fi','Vuokrasopimus allekirjoitettu',0),(417041,11585,'no','Leieavtale inngÃ¥tt',0),(417042,11585,'da','Lejekontrakt underskrevet',0),(417043,11585,'ko','ì„œëª… ìž„ëŒ€',0),(417044,11585,'he','×—×•×–×” ×”×©×›×™×¨×•×ª ×—×ª×•×',0),(417045,11585,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ Ï€Î¿Ï… Ï…Ï€Î­Î³ÏÎ±ÏˆÎ±Î½',0),(417046,11585,'zh','ç§Ÿèµç­¾è®¢\r\n',0),(417047,11585,'sv','Hyresavtalet undertecknades',0),(417048,11585,'it','Contratto di locazione firmato',0),(417049,11585,'tl','',0),(417050,11585,'th','à¸¥à¸‡à¸™à¸²à¸¡à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(417051,11585,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤¿à¤',0),(417052,11585,'ms','Pajakan yang ditandatangani',0),(417053,11585,'ar','Ø¹Ù‚Ø¯ Ø¥ÙŠØ¬Ø§Ø± ÙˆÙ‚Ø¹',0),(417054,11585,'fr','Bail signÃ©',0),(417055,11585,'jp','ãƒªãƒ¼ã‚¹ç½²å',0),(417056,11585,'pt','Contrato assinado',0),(417057,11585,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð»Ð¸',0),(417058,11585,'es','Arrendamiento Firmado',0),(417059,11585,'de','Mietvertrag unterzeichnet',0),(417060,11585,'en','Lease Signed',0),(417061,11586,'is','',0),(417062,11586,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ ',0),(417063,11586,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø§Ù…Ø¶Ø§Ø¡ Ø´Ø¯Ù‡ ',0),(417064,11586,'tr','Kira imzaladÄ±',0),(417065,11586,'pl','Podpisane umowy najmu',0),(417066,11586,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ Ð·Ð° Ð½Ð°ÐµÐ¼',0),(417067,11586,'ur','Ù„ÛŒØ² Ù¾Ø± Ø¯Ø³ØªØ®Ø·',0),(417068,11586,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ°Ð¾ Ð½Ð°Ñ˜Ð°Ð¼',0),(417069,11586,'vi','bÃªn cho thuÃª kÃ½',0),(417070,11586,'af','Ondertekende Verhuringsooreenkoms',0),(417071,11586,'ro','Semnat de leasing',0),(417072,11586,'et','SÃµlmitud Ã¼Ã¼rilepingu',0),(417073,11586,'si','Podpisali zakup',0),(417074,11586,'ba','Menandatangani kontrak',0),(417075,11586,'nl','Lease-overeenkomst ondertekend',0),(417076,11586,'fi','Allekirjoittanut vuokrasopimuksen',0),(417077,11586,'no','Signert leiekontrakt',0),(417078,11586,'da','Underskrevet lejekontrakten',0),(417079,11586,'ko','ìž„ëŒ€ ê³„ì•½ì„œì— ì„œëª…',0),(417080,11586,'he','×—×ª×ž×” ×¢×œ ×©×›×™×¨×•×ª',0),(417081,11586,'el','Î¥Ï€ÎµÎ³ÏÎ¬Ï†Î· Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(417082,11586,'zh','ç­¾è®¢ç§Ÿèµ\r\n',0),(417083,11586,'sv','Undertecknat hyresavtal',0),(417084,11586,'it','Firmato il contratto di locazione',0),(417085,11586,'tl','',0),(417086,11586,'th','à¹€à¸‹à¹‡à¸™à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(417087,11586,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤¿à¤',0),(417088,11586,'ms','Ditandatangani pajakan',0),(417089,11586,'ar','ÙˆÙ‚Ø¹ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(417090,11586,'fr','SignÃ© le bail',0),(417091,11586,'jp','ãƒªãƒ¼ã‚¹ã«ç½²å',0),(417092,11586,'pt','Assinei contrato',0),(417093,11586,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¾ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(417094,11586,'es','Arrendamiento Firmado',0),(417095,11586,'de','Mietvertrag unterzeichnet',0),(417096,11586,'en','Signed Lease',0),(417097,11587,'is','',0),(417098,11587,'dr','/ Ø§ÙØ²ÙˆØ¯Ù† Ø¨ÛŒØ¬Ú©Ù‡Ø§',0),(417099,11587,'pr','Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡  / Ø§ÙØ²ÙˆØ¯Ù† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§',0),(417100,11587,'tr','Ä°ÅŸareti faturalar kira/Ekle',0),(417101,11587,'pl','Faktury dzierÅ¼awy/Dodaj znak',0),(417102,11587,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³/Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð·Ð½Ð°Ðº',0),(417103,11587,'ur','Ù†Ø´Ø§Ù†ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ù„ÛŒØ²/Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(417104,11587,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð·Ð° Ð·Ð°ÐºÑƒÐ¿/Ð´Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð·Ð½Ð°Ðº',0),(417105,11587,'vi','Ä‘Äƒng kÃ½ cho thuÃª/ thÃªm hÃ³a Ä‘Æ¡n',0),(417106,11587,'af','Onderteken Huurkontrak/Fakture Byvoeg',0),(417107,11587,'ro','Semn de leasing/Adauga facturi',0),(417108,11587,'et','MÃ¤rk rendi/lisada arved',0),(417109,11587,'si','Znak zakup/Add raÄunov',0),(417110,11587,'ba','Tanda sewa/Tambahkan faktur',0),(417111,11587,'nl','Teken Lease/toevoegen facturen',0),(417112,11587,'fi','Merkki vuokrasopimuksen tai lisÃ¤Ã¤ laskuja',0),(417113,11587,'no','Tegn Lease/legge til fakturaer',0),(417114,11587,'da','Tegn leasing/tilfÃ¸je fakturaer',0),(417115,11587,'ko','ì„œëª… ìž„ëŒ€/ì¶”ê°€ ì¸ë³´ì´ìŠ¤',0),(417116,11587,'he','×¡×™×ž×Ÿ ×—×›×™×¨×”/×”×•×¡×£ ×—×©×‘×•× ×™×•×ª',0),(417117,11587,'el','Î£Î·Î¼Î¬Î´Î¹ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·/Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(417118,11587,'zh','ç­¾ç½²ç§Ÿèµ/æ–°å¢žå‘ç¥¨\r\n',0),(417119,11587,'sv','Undertecknar hyresavtalet/lÃ¤gga till fakturor',0),(417120,11587,'it','Segno di locazione/aggiungere fatture',0),(417121,11587,'tl','',0),(417122,11587,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¹€à¸Šà¹ˆà¸²/à¹€à¸žà¸´à¹ˆà¸¡à¸«à¸™à¸µà¹‰',0),(417123,11587,'hi','à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¤Ÿà¥à¤Ÿà¥‡/à¤œà¥‹à¤¡à¤¼',0),(417124,11587,'ms','Daftar pajakan/Tambah invois',0),(417125,11587,'ar','ØªØ³Ø¬ÙŠÙ„ ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±/Ø¥Ø¶Ø§ÙØ©',0),(417126,11587,'fr','Factures de location/ajouter signe',0),(417127,11587,'jp','è¨˜å·ãƒªãƒ¼ã‚¹/è¿½åŠ è«‹æ±‚æ›¸',0),(417128,11587,'pt','Sinal locaÃ§Ã£o/adicionar facturas',0),(417129,11587,'ru','Ð—Ð½Ð°Ðº Ð°Ñ€ÐµÐ½Ð´Ñ‹/Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(417130,11587,'es','Firmar Arrendamiento/Agregar Facturas',0),(417131,11587,'de','Zeichen-Leasing/hinzufÃ¼gen-Rechnungen',0),(417132,11587,'en','Sign Lease/Add Invoices',0),(417133,11588,'is','',0),(417134,11588,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø§Ù…Ø¶Ø§Ø¡ Ù†Ø´Ø¯Ù‡ ',0),(417135,11588,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø§Ù…Ø¶Ø§Ø¡ Ù†Ø´Ø¯Ù‡ ',0),(417136,11588,'tr','Ä°mzasÄ±z kira',0),(417137,11588,'pl','Leasing bez znaku',0),(417138,11588,'bg','ÐÐµÐ¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(417139,11588,'ur','ØºÛŒØ± Ø¯Ø³ØªØ®Ø· Ø´Ø¯Û Ù„ÛŒØ²',0),(417140,11588,'sr','ÐÐµÐ¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð·Ð°ÐºÑƒÐ¿',0),(417141,11588,'vi','Viá»‡c thuÃª mÆ°á»›n khÃ´ng Ä‘Æ°á»£c duyá»‡t',0),(417142,11588,'af','Ongetekende Huurkontrak',0),(417143,11588,'ro','Nesemnate de leasing',0),(417144,11588,'et','Allkirjastamata Ã¼Ã¼rileping',0),(417145,11588,'si','Nepodpisani najema',0),(417146,11588,'ba','Unsigned sewa',0),(417147,11588,'nl','Niet-ondertekende Lease',0),(417148,11588,'fi','Allekirjoittamaton vuokrasopimuksen',0),(417149,11588,'no','Usignert Lease',0),(417150,11588,'da','Usigneret Lease',0),(417151,11588,'ko','ì„œëª… ë˜ì§€ ì•Šì€ ìž„ëŒ€',0),(417152,11588,'he','×—×•×–×” ×”×©×›×™×¨×•×ª ×œ× ×—×ª×•×',0),(417153,11588,'el','Î‘Î½Ï…Ï€ÏŒÎ³ÏÎ±Ï†Î¿ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(417154,11588,'zh','æœªç­¾åçš„ç§Ÿèµ\r\n',0),(417155,11588,'sv','Osignerade Lease',0),(417156,11588,'it','Contratto di locazione senza segno',0),(417157,11588,'tl','',0),(417158,11588,'th','à¹„à¸¡à¹ˆà¹€à¸Šà¹ˆà¸²',0),(417159,11588,'hi','à¤…à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤¿à¤¤ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(417160,11588,'ms','Pajakan yang tidak ditandatangani',0),(417161,11588,'ar','Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± ØºÙŠØ± Ø§Ù„Ù…ÙˆÙ‚Ø¹Ø©',0),(417162,11588,'fr','Bail non signÃ©',0),(417163,11588,'jp','ç¬¦å·ãªã—ã®ãƒªãƒ¼ã‚¹',0),(417164,11588,'pt','LocaÃ§Ã£o sem assinatura',0),(417165,11588,'ru','ÐÐµÐ¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð½Ñ‹Ðµ ÐÑ€ÐµÐ½Ð´Ð°',0),(417166,11588,'es','Arrendamiento no irmado',0),(417167,11588,'de','Leasing',0),(417168,11588,'en','Unsigned Lease',0),(417169,11589,'is','',0),(417170,11589,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø§ÙˆÙ„ÙŠÙ‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(417171,11589,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø§ÙˆÙ„ÙŠÙ‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(417172,11589,'tr','Ä°lk kira Ã¶denen',0),(417173,11589,'pl','PoczÄ…tkowe leasingu zostaÅ‚a wypÅ‚acona',0),(417174,11589,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ðµ Ð±Ð¸Ð»Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð°',0),(417175,11589,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù„ÛŒØ² Ø§Ø¯Ø§ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(417176,11589,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð° Ð·Ð°ÐºÑƒÐ¿Ð½Ð¸Ð½Ð° Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð»Ð°',0),(417177,11589,'vi','Thá»i gian thuÃª ban Ä‘áº§u Ä‘Ã£ Ä‘Æ°á»£c thanh toÃ¡n',0),(417178,11589,'af','Die Aanvanklike Huurkontrak is Betaal',0),(417179,11589,'ro','Contractul de Ã®nchiriere iniÅ£ial a fost achitatÄƒ',0),(417180,11589,'et','Esialgne liisingu makstud',0),(417181,11589,'si','PlaÄana zaÄetna najemne pogodbe',0),(417182,11589,'ba','Sewa awal telah dibayar',0),(417183,11589,'nl','De eerste Lease is betaald',0),(417184,11589,'fi','EnsimmÃ¤inen vuokrasopimus on maksettu',0),(417185,11589,'no','Den fÃ¸rste leieavtalen er innbetalt',0),(417186,11589,'da','Den oprindelige lejekontrakt er blevet betalt',0),(417187,11589,'ko','ì´ˆê¸° ìž„ëŒ€ë¥¼ ì§€ë¶ˆ',0),(417188,11589,'he','×”×”×¡×›× ×”×¨××©×•× ×™ ×›×‘×¨ ×©×•×œ×',0),(417189,11589,'el','Î— Î±ÏÏ‡Î¹ÎºÎ® Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· Ï€Î¿Ï… Î­Ï‡ÎµÎ¹ ÎºÎ±Ï„Î±Î²Î»Î·Î¸ÎµÎ¯',0),(417190,11589,'zh','åˆå§‹ç§Ÿèµå·²ç»æ”¯ä»˜\r\n',0),(417191,11589,'sv','FÃ¶rsta lÃ¥net har betalats',0),(417192,11589,'it','Il contratto di locazione iniziale Ã¨ stata pagata',0),(417193,11589,'tl','',0),(417194,11589,'th','à¸Šà¸³à¸£à¸°à¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹à¸¥à¹‰à¸§',0),(417195,11589,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(417196,11589,'ms','Pajakan asal yang telah dibayar',0),(417197,11589,'ar','ÙˆÙ‚Ø¯ Ø£ÙˆÙ„Ù‰ Ø§Ù„ØªØ£Ø¬ÙŠØ± Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(417198,11589,'fr','Le bail Initial a Ã©tÃ© payÃ©',0),(417199,11589,'jp','åˆæœŸãƒªãƒ¼ã‚¹ãŒæ”¯æ‰•ã‚ã‚Œã¦ã„ã¾ã™ã€‚',0),(417200,11589,'pt','O contrato inicial foi pago',0),(417201,11589,'ru','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ð»Ð¸ Ð¿ÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(417202,11589,'es','El Arrendamiento inicial se Ha Pagado',0),(417203,11589,'de','Der ursprÃ¼ngliche Mietvertrag wurde bezahlt',0),(417204,11589,'en','The Initial Lease Has Been Paid',0),(417205,11590,'is','',0),(417206,11590,'dr','( Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯) Ø§Ø¬Ø§Ø±Ù‡ ',0),(417207,11590,'pr','Ù¾ÙŠØ´ Ù†ÙˆÙŠØ³( Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯) Ø§Ø¬Ø§Ø±Ù‡ ',0),(417208,11590,'tr','Taslak kira',0),(417209,11590,'pl','Projekt umowy najmu',0),(417210,11590,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(417211,11590,'ur','Ù…Ø³ÙˆØ¯Û Ù„ÛŒØ²',0),(417212,11590,'sr','ÐÐ°Ñ†Ñ€Ñ‚ Ð·Ð°ÐºÑƒÐ¿',0),(417213,11590,'vi','Dá»± tháº£o cho thuÃª',0),(417214,11590,'af','Konsep Huurooreenkoms',0),(417215,11590,'ro','Proiect de leasing',0),(417216,11590,'et','EelnÃµu Ã¼Ã¼rileping',0),(417217,11590,'si','Osnutek najema',0),(417218,11590,'ba','Rancangan sewa',0),(417219,11590,'nl','Ontwerp Lease',0),(417220,11590,'fi','Luonnos vuokrasopimuksen',0),(417221,11590,'no','Utkast Lease',0),(417222,11590,'da','Udkast til lejekontrakt',0),(417223,11590,'ko','ì´ˆì•ˆ ìž„ëŒ€',0),(417224,11590,'he','×˜×™×•×˜×ª ×”×—×•×–×”',0),(417225,11590,'el','Î£Ï‡Î­Î´Î¹Î¿ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(417226,11590,'zh','ç§Ÿèµè‰æ¡ˆ\r\n',0),(417227,11590,'sv','Utkast leasing',0),(417228,11590,'it','Bozza contratto di locazione',0),(417229,11590,'tl','',0),(417230,11590,'th','à¸£à¹ˆà¸²à¸‡à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(417231,11590,'hi','à¤®à¤¸à¥Œà¤¦à¥‡ à¤•à¥‡ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(417232,11590,'ms','Pajakan Draf',0),(417233,11590,'ar','Ù…Ø´Ø±ÙˆØ¹ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(417234,11590,'fr','Projet de bail',0),(417235,11590,'jp','ãƒ‰ãƒ©ãƒ•ãƒˆ ãƒªãƒ¼ã‚¹',0),(417236,11590,'pt','LocaÃ§Ã£o de projecto',0),(417237,11590,'ru','ÐŸÑ€Ð¾ÐµÐºÑ‚ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(417238,11590,'es','Redactar El Contrato de Arrendimiento',0),(417239,11590,'de','Entwurf einer Lease',0),(417240,11590,'en','Draft Lease',0),(417241,11591,'is','',0),(417242,11591,'dr','( Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯) Ø§Ø¬Ø§Ø±Ù‡ ',0),(417243,11591,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ù¾ÙŠØ´ Ù†ÙˆÙŠØ³( Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯) Ø§Ø¬Ø§Ø±Ù‡ ',0),(417244,11591,'tr','Taslak kira yÃ¶nergeleri',0),(417245,11591,'pl','Projekt umowy najmu instrukcje',0),(417246,11591,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(417247,11591,'ur','Ù…Ø³ÙˆØ¯Û Ù„ÛŒØ² ÛØ¯Ø§ÛŒØ§Øª',0),(417248,11591,'sr','ÐÐ°Ñ†Ñ€Ñ‚ Ð·Ð°ÐºÑƒÐ¿ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(417249,11591,'vi','Dá»± tháº£o há»£p Ä‘á»“ng thuÃª hÆ°á»›ng dáº«n',0),(417250,11591,'af','Konsep Huurooreenkoms Instruksies',0),(417251,11591,'ro','InstrucÅ£iuni de leasing proiect',0),(417252,11591,'et','EelnÃµu Ã¼Ã¼rilepingu juhiseid',0),(417253,11591,'si','Osnutek navodila za najem',0),(417254,11591,'ba','Rancangan sewa petunjuk',0),(417255,11591,'nl','Ontwerp Lease instructies',0),(417256,11591,'fi','Luonnos vuokrasopimuksen ohjeet',0),(417257,11591,'no','Utkast Lease instruksjoner',0),(417258,11591,'da','Udkast til lejekontrakt instruktioner',0),(417259,11591,'ko','ì´ˆì•ˆ ìž„ëŒ€ ì§€ì¹¨',0),(417260,11591,'he','×˜×™×•×˜×ª ×—×•×–×” ×”×©×›×™×¨×•×ª ×”×•×¨××•×ª',0),(417261,11591,'el','Î£Ï‡Î­Î´Î¹Î¿ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(417262,11591,'zh','ç§Ÿèµè‰æ¡ˆçš„è¯´æ˜Ž\r\n',0),(417263,11591,'sv','FÃ¶rslag till hyresavtalet instruktioner',0),(417264,11591,'it','Bozza locazione istruzioni',0),(417265,11591,'tl','',0),(417266,11591,'th','à¸£à¹ˆà¸²à¸‡à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¸„à¸³à¹à¸™à¸°à¸™à¸³',0),(417267,11591,'hi','à¤®à¤¸à¥Œà¤¦à¤¾ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(417268,11591,'ms','Arahan pajakan Draf',0),(417269,11591,'ar','Ù…Ø´Ø±ÙˆØ¹ ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(417270,11591,'fr','Projet d\'Instructions bail',0),(417271,11591,'jp','ãƒ‰ãƒ©ãƒ•ãƒˆ ãƒªãƒ¼ã‚¹æŒ‡ç¤º',0),(417272,11591,'pt','Projecto locaÃ§Ã£o de instruÃ§Ãµes',0),(417273,11591,'ru','ÐŸÑ€Ð¾ÐµÐºÑ‚ Ð°Ñ€ÐµÐ½Ð´Ñ‹ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(417274,11591,'es','Instrucciones Para Redactar El Contrato de Arrendimiento',0),(417275,11591,'de','Entwurf einer Lease Anweisungen',0),(417276,11591,'en','Draft Lease Instructions',0),(417277,11592,'is','',0),(417278,11592,'dr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(417279,11592,'pr','Ù„Ø·ÙØ§ ÙŠÙƒ Ø¯Ø§Ø±Ø§Ø¦ÙŠ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ ÙƒÙ†ÙŠØ¯',0),(417280,11592,'tr','LÃ¼tfen bir Ã¶zellik seÃ§in',0),(417281,11592,'pl','Wybierz WÅ‚aÅ›ciwoÅ›Ä‡',0),(417282,11592,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(417283,11592,'ur','Ø§ÛŒÚ© Ø®Ø§ØµÛŒØª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(417284,11592,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜ÑÑ‚Ð²Ð¾',0),(417285,11592,'vi','Vui lÃ²ng chá»n má»™t báº¥t Ä‘á»™ng sáº£n',0),(417286,11592,'af','Kies asseblief \'n Eiendom',0),(417287,11592,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i o proprietate',0),(417288,11592,'et','Palun vali atribuut',0),(417289,11592,'si','Izberite nepremiÄnine',0),(417290,11592,'ba','Silakan pilih properti',0),(417291,11592,'nl','Selecteer een eigenschap',0),(417292,11592,'fi','Valitse',0),(417293,11592,'no','Velg en egenskap',0),(417294,11592,'da','VÃ¦lg en egenskab',0),(417295,11592,'ko','ì†ì„±ì„ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(417296,11592,'he','×× × ×‘×—×¨ × ×›×¡',0),(417297,11592,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î¹Î´Î¹ÏŒÏ„Î·Ï„Î±',0),(417298,11592,'zh','è¯·é€‰æ‹©ä¸€ä¸ª\r\n',0),(417299,11592,'sv','VÃ¤lj en egenskap',0),(417300,11592,'it','Si prega di selezionare una proprietÃ ',0),(417301,11592,'tl','',0),(417302,11592,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸¥à¸·à¸­à¸à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´',0),(417303,11592,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤—à¥à¤£ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(417304,11592,'ms','Sila pilih harta',0),(417305,11592,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ø®Ø§ØµÙŠØ©',0),(417306,11592,'fr','Veuillez sÃ©lectionner une propriÃ©tÃ©',0),(417307,11592,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(417308,11592,'pt','Por favor, selecione uma propriedade',0),(417309,11592,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(417310,11592,'es','Por Favor Selecciona una Propiedad',0),(417311,11592,'de','Bitte wÃ¤hlen Sie eine Eigenschaft',0),(417312,11592,'en','Please Select A Property',0),(417313,11593,'is','',0),(417314,11593,'dr','(Ø§Ø¬Ø§Ø±Ù‡ Ø³Ø§ÙƒÙ† Ø´Ø¯Ù†',0),(417315,11593,'pr','Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø§Ø¬Ø§Ø±Ù‡ (Ø§Ø¬Ø§Ø±Ù‡ Ø³Ø§ÙƒÙ† Ø´Ø¯Ù†',0),(417316,11593,'tr','Kira doldurmak',0),(417317,11593,'pl','WypeÅ‚niÄ‡ dzierÅ¼awy',0),(417318,11593,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(417319,11593,'ur','Ù„ÛŒØ² Ø¨Ø³Ø§Ù†Ø§',0),(417320,11593,'sr','ÐŸÐ¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð·Ð°ÐºÑƒÐ¿',0),(417321,11593,'vi','CÆ° cho thuÃª',0),(417322,11593,'af','Bevolk Huurkontrak',0),(417323,11593,'ro','Popula leasing',0),(417324,11593,'et','Asustada Ã¼Ã¼rileping',0),(417325,11593,'si','Zapolnijo najema',0),(417326,11593,'ba','Mengisi sewa',0),(417327,11593,'nl','Vullen van Lease',0),(417328,11593,'fi','TÃ¤ytÃ¤ leasing',0),(417329,11593,'no','Fylle Lease',0),(417330,11593,'da','Udfyld lejekontrakten',0),(417331,11593,'ko','ìž„ëŒ€ë¥¼ ì±„ì›ë‹ˆë‹¤',0),(417332,11593,'he','×œ××›×œ×¡ ××ª ×—×•×–×” ×”×©×›×™×¨×•×ª',0),(417333,11593,'el','Î£Ï…Î¼Ï€Î»Î®ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(417334,11593,'zh','å¡«å……ç§Ÿèµ\r\n',0),(417335,11593,'sv','Fylla Lease',0),(417336,11593,'it','Compilare il contratto di locazione',0),(417337,11593,'tl','',0),(417338,11593,'th','à¹ƒà¸ªà¹ˆà¸„à¹ˆà¸²à¹€à¸Šà¹ˆà¸²',0),(417339,11593,'hi','à¤²à¥€à¤œ à¤†à¤¬à¤¾à¤¦',0),(417340,11593,'ms','Mempopulasikan pajakan',0),(417341,11593,'ar','Ù…Ù„Ø¡ Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(417342,11593,'fr','Remplir le bail',0),(417343,11593,'jp','ãƒªãƒ¼ã‚¹ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(417344,11593,'pt','Preencher o contrato de arrendamento',0),(417345,11593,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(417346,11593,'es','Poblar Arrendamiento',0),(417347,11593,'de','Lease zu fÃ¼llen',0),(417348,11593,'en','Populate Lease',0),(417349,11594,'is','',0),(417350,11594,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ',0),(417351,11594,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ',0),(417352,11594,'tr','Umudu seÃ§in',0),(417353,11594,'pl','Wybierz perspektywa',0),(417354,11594,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(417355,11594,'ur','Ù…Ù†Ø¸Ø± Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(417356,11594,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ð½Ð¾ÑÑ‚',0),(417357,11594,'vi','Chá»n khÃ¡ch hÃ ng tiá»m nÄƒng',0),(417358,11594,'af','Kies Voornemende KliÃ«nt',0),(417359,11594,'ro','SelectaÅ£i perspectivÄƒ',0),(417360,11594,'et','Prospect Vali',0),(417361,11594,'si','Izberite moÅ¾nost',0),(417362,11594,'ba','Pilih prospek',0),(417363,11594,'nl','Selecteer vooruitzicht',0),(417364,11594,'fi','Valitse mahdollisuus',0),(417365,11594,'no','Velg prospektet',0),(417366,11594,'da','VÃ¦lg kundeemne',0),(417367,11594,'ko','ì „ë§ ì„ íƒ',0),(417368,11594,'he','×‘×—×¨ ×¤×¨×•×¡×¤×§×˜',0),(417369,11594,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ®',0),(417370,11594,'zh','é€‰æ‹©å±•æœ›\r\n',0),(417371,11594,'sv','VÃ¤lj utsikter',0),(417372,11594,'it','Selezionare la prospettiva',0),(417373,11594,'tl','',0),(417374,11594,'th','à¹€à¸¥à¸·à¸­à¸à¹‚à¸­à¸à¸²à¸ª',0),(417375,11594,'hi','à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(417376,11594,'ms','Pilih Prospect',0),(417377,11594,'ar','Ø­Ø¯Ø¯ Ø¢ÙØ§Ù‚',0),(417378,11594,'fr','SÃ©lectionnez perspective',0),(417379,11594,'jp','ãƒ—ãƒ­ã‚¹ãƒšã‚¯ãƒˆã‚’é¸æŠžã—ã¾ã™ã€‚',0),(417380,11594,'pt','Selecione a perspectiva',0),(417381,11594,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ñƒ',0),(417382,11594,'es','Selecciona Prospecto',0),(417383,11594,'de','WÃ¤hlen Sie die Aussicht auf',0),(417384,11594,'en','Select Prospect',0),(417385,11595,'is','',0),(417386,11595,'dr','(Ø¢Ø²Ù…Ø§ÙŠØ´',0),(417387,11595,'pr','Ø§Ø±Ø³Ø§Ù„ ØºØ±Ø¨Ø§Ù„ Ú¯Ø±ÙŠ (Ø¢Ø²Ù…Ø§ÙŠØ´',0),(417388,11595,'tr','Tarama gÃ¶nderin',0),(417389,11595,'pl','Przedstawienia badaÅ„ przesiewowych',0),(417390,11595,'bg','ÐŸÐ¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐºÑ€Ð¸Ð½Ð¸Ð½Ð³',0),(417391,11595,'ur','Ø§Ø³Ú©Ø±ÛŒÙ†Ù†Ú¯ Ø¬Ù…Ø¹ Ú©Ø±Ø§Ø¦ÛŒÚº',0),(417392,11595,'sr','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(417393,11595,'vi','TrÃ¬nh chiáº¿u',0),(417394,11595,'af','Keuring Indien',0),(417395,11595,'ro','Prezinte Screening',0),(417396,11595,'et','Esitada sÃµelumine',0),(417397,11595,'si','PredloÅ¾i pregled',0),(417398,11595,'ba','Kirim skrining',0),(417399,11595,'nl','Indienen van Screening',0),(417400,11595,'fi','LÃ¤hetÃ¤ seulonta',0),(417401,11595,'no','Sende Screening',0),(417402,11595,'da','Indsende Screening',0),(417403,11595,'ko','ì‹¬ì‚¬ ì œì¶œ',0),(417404,11595,'he','×©×œ×— ×”×§×¨× ×”',0),(417405,11595,'el','Î¥Ï€Î¿Î²Î¬Î»Î¿Ï…Î½ Î´Î¹Î±Î»Î¿Î³Î®Ï‚',0),(417406,11595,'zh','æäº¤ç­›é€‰\r\n',0),(417407,11595,'sv','Skicka Screening',0),(417408,11595,'it','Sottoporre a Screening',0),(417409,11595,'tl','',0),(417410,11595,'th','à¸ªà¹ˆà¸‡à¸•à¸£à¸§à¸ˆ',0),(417411,11595,'hi','à¤¸à¥à¤•à¥à¤°à¥€à¤¨à¤¿à¤‚à¤— à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(417412,11595,'ms','Borang pemeriksaan',0),(417413,11595,'ar','ÙŠÙ‚Ø¯Ù… Ø§Ù„ÙØ­Øµ',0),(417414,11595,'fr','Soumettre le dÃ©pistage',0),(417415,11595,'jp','ã‚¹ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°ã‚’æå‡ºã—ã¾ã™ã€‚',0),(417416,11595,'pt','Submeter seleÃ§Ã£o',0),(417417,11595,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐºÑ€Ð¸Ð½Ð¸Ð½Ð³',0),(417418,11595,'es','Presenta el Cribado',0),(417419,11595,'de','Screening vorzulegen',0),(417420,11595,'en','Submit Screening',0),(417421,11596,'is','',0),(417422,11596,'dr','( Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯) ÙŠÙƒ Ø§Ø¬Ø§Ø±Ù‡ ',0),(417423,11596,'pr','Ù¾ÙŠØ´ Ù†ÙˆÙŠØ³( Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯) ÙŠÙƒ Ø§Ø¬Ø§Ø±Ù‡ ',0),(417424,11596,'tr','Kira bir taslak',0),(417425,11596,'pl','Projekt umowy najmu',0),(417426,11596,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚ Ð½Ð° Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ Ð·Ð° Ð½Ð°ÐµÐ¼',0),(417427,11596,'ur','Ø§ÛŒÚ© Ù„ÙÛŒØ² Ú©Ø§ Ù…Ø³ÙˆØ¯Û ØªÛŒØ§Ø±',0),(417428,11596,'sr','ÐÐ°Ñ†Ñ€Ñ‚ ÑƒÐ³Ð¾Ð²Ð¾Ñ€',0),(417429,11596,'vi','Dá»± tháº£o má»™t há»£p Ä‘á»“ng thuÃª',0),(417430,11596,'af','Opstel van \'n Huurkontrak',0),(417431,11596,'ro','Proiectul unui contract de leasing',0),(417432,11596,'et','EelnÃµu rent',0),(417433,11596,'si','Osnutek najem',0),(417434,11596,'ba','Draft kontrak',0),(417435,11596,'nl','Ontwerp van een lease-overeenkomst',0),(417436,11596,'fi','Luonnos vuokrasopimuksen',0),(417437,11596,'no','Utarbeide en leieavtale',0),(417438,11596,'da','Udarbejde en lejekontrakt',0),(417439,11596,'ko','ìž„ëŒ€ ì´ˆì•ˆ',0),(417440,11596,'he','×˜×™×•×˜×ª ×—×•×–×” ×©×›×™×¨×•×ª',0),(417441,11596,'el','Î£Ï‡Î­Î´Î¹Î¿ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·',0),(417442,11596,'zh','è‰æ¡ˆç§Ÿèµ\r\n',0),(417443,11596,'sv','Utkast till ett leasingavtal',0),(417444,11596,'it','Redigere un contratto di locazione',0),(417445,11596,'tl','',0),(417446,11596,'th','à¸£à¹ˆà¸²à¸‡à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¹€à¸›à¹‡à¸™',0),(417447,11596,'hi','à¤à¤• à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥‡ à¤®à¤¸à¥Œà¤¦à¥‡',0),(417448,11596,'ms','Draf pajakan',0),(417449,11596,'ar','Ù…Ø´Ø±ÙˆØ¹ Ø¹Ù‚Ø¯ Ø¥ÙŠØ¬Ø§Ø±',0),(417450,11596,'fr','RÃ©diger un contrat de location',0),(417451,11596,'jp','ãƒªãƒ¼ã‚¹ã‚’è‰æ¡ˆã—ã¾ã™ã€‚',0),(417452,11596,'pt','Redigir um contrato de arrendamento',0),(417453,11596,'ru','ÐŸÑ€Ð¾ÐµÐºÑ‚ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(417454,11596,'es','Redactar Un Contrato de Arrendimiento',0),(417455,11596,'de','Entwurf einer Leases',0),(417456,11596,'en','Draft A Lease',0),(417457,11597,'is','',0),(417458,11597,'dr','Ù…Ø³ØªØ§Ø¬Ø± Ø¨Ø¹Ø¯ÙŠ ',0),(417459,11597,'pr','Ù…Ø³ØªØ§Ø¬Ø± Ø¨Ø¹Ø¯ÙŠ ',0),(417460,11597,'tr','Sonraki kiracÄ±',0),(417461,11597,'pl','Kolejny najemca',0),(417462,11597,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»',0),(417463,11597,'ur','Ø§Ú¯Ù„Û’ Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±',0),(417464,11597,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ ÑÑ‚Ð°Ð½Ð°Ñ€',0),(417465,11597,'vi','NgÆ°á»i thuÃª nhÃ  tiáº¿p theo',0),(417466,11597,'af','Volgende Huurder',0),(417467,11597,'ro','Urmatorul chirias',0),(417468,11597,'et','JÃ¤rgmise Ã¼Ã¼rniku',0),(417469,11597,'si','Naslednji najemnik',0),(417470,11597,'ba','Penyewa berikutnya',0),(417471,11597,'nl','Volgende huurder',0),(417472,11597,'fi','Seuraava vuokralainen',0),(417473,11597,'no','Neste leietaker',0),(417474,11597,'da','NÃ¦ste lejer',0),(417475,11597,'ko','ë‹¤ìŒ ì„¸ ìž…ìž',0),(417476,11597,'he','×”×“×™×™×¨ ×”×‘×',0),(417477,11597,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(417478,11597,'zh','ä¸‹ä¸€æ­¥ç§Ÿå®¢\r\n',0),(417479,11597,'sv','NÃ¤sta hyresgÃ¤st',0),(417480,11597,'it','Prossimo inquilino',0),(417481,11597,'tl','',0),(417482,11597,'th','à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¸•à¹ˆà¸­à¹„à¸›',0),(417483,11597,'hi','à¤…à¤—à¤²à¥‡ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°',0),(417484,11597,'ms','Penyewa seterusnya',0),(417485,11597,'ar','Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± Ø§Ù„Ù‚Ø§Ø¯Ù…',0),(417486,11597,'fr','Prochain locataire',0),(417487,11597,'jp','æ¬¡ã®å…¥å±…ãƒ†ãƒŠãƒ³ãƒˆ',0),(417488,11597,'pt','PrÃ³ximo inquilino',0),(417489,11597,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€',0),(417490,11597,'es','Proximo Inquilino',0),(417491,11597,'de','NÃ¤chsten Mieter',0),(417492,11597,'en','Next Tenant',0),(417493,11598,'is','',0),(417494,11598,'dr','( Ø§Ù†ØªØµØ§Ø¨',0),(417495,11598,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÙŠ Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª ( Ø§Ù†ØªØµØ§Ø¨',0),(417496,11598,'tr','Set randevu',0),(417497,11598,'pl','Zestaw mianowania',0),(417498,11598,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ ÑÑ€ÐµÑ‰Ð°',0),(417499,11598,'ur','Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ù…Ù„Ø§Ù‚Ø§Øª',0),(417500,11598,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ ÑÐ°ÑÑ‚Ð°Ð½Ð°Ðº',0),(417501,11598,'vi','Äáº·t cuá»™c háº¹n',0),(417502,11598,'af','Stel aanstelling',0),(417503,11598,'ro','Set numirea',0),(417504,11598,'et','MÃ¤Ã¤ra mÃ¤Ã¤ramine',0),(417505,11598,'si','Nastavitev sestanka',0),(417506,11598,'ba','Mengatur pengangkatan',0),(417507,11598,'nl','Afspraak instellen',0),(417508,11598,'fi','Tapaamisen',0),(417509,11598,'no','Angi avtale',0),(417510,11598,'da','SÃ¦t udnÃ¦vnelse',0),(417511,11598,'ko','ì„¤ì •ëœ ì•½ì†',0),(417512,11598,'he','×§×‘×¢ ×¤×’×™×©×”',0),(417513,11598,'el','ÎšÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î¿ ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(417514,11598,'zh','è®¾å®šé¢„çº¦\r\n',0),(417515,11598,'sv','StÃ¤ll in tid',0),(417516,11598,'it','Appuntamento set',0),(417517,11598,'tl','',0),(417518,11598,'th','à¸à¸³à¸«à¸™à¸”à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(417519,11598,'hi','à¤¨à¤¿à¤¯à¥à¤•à¥à¤¤à¤¿ à¤•à¥‡ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(417520,11598,'ms','Pelantikan yang ditetapkan',0),(417521,11598,'ar','ØªØ¹ÙŠÙŠÙ† Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(417522,11598,'fr','Set de nomination',0),(417523,11598,'jp','ã‚¢ãƒã‚¤ãƒ³ãƒˆãƒ¡ãƒ³ãƒˆã®å–ã‚Šä»˜ã‘',0),(417524,11598,'pt','Conjunto de nomeaÃ§Ã£o',0),(417525,11598,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(417526,11598,'es','Hace Cita',0),(417527,11598,'de','Set-Termin',0),(417528,11598,'en','Set Appointment',0),(417529,11599,'is','',0),(417530,11599,'dr','Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(417531,11599,'pr','Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(417532,11599,'tr','Kira baÅŸarÄ±yla silinen imzalama',0),(417533,11599,'pl','DzierÅ¼awy podpisania usuniÄ™te pomyÅ›lnie',0),(417534,11599,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(417535,11599,'ur','Ù„ÛŒØ² Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ø´Ø¯Û Ø¯Ø³ØªØ®Ø·',0),(417536,11599,'sr','Ð—Ð°ÐºÑƒÐ¿ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(417537,11599,'vi','Ä‘Ã£ xÃ³a kÃ½ há»£p Ä‘á»“ng thuÃª thÃ nh cÃ´ng',0),(417538,11599,'af','Huurkontrak Ondertekening Suksesvol Geskrap',0),(417539,11599,'ro','Leasing semnarea ÅŸtearsÄƒ cu succes',0),(417540,11599,'et','ÃœÃ¼rilepingu allkirjastamist kustutatud edukalt',0),(417541,11599,'si','Najemne pogodbe, podpisu izbrisanih uspeÅ¡no',0),(417542,11599,'ba','Sewa penandatanganan dihapus berhasil',0),(417543,11599,'nl','Lease-overeenkomst ondertekenen met succes verwijderd',0),(417544,11599,'fi','Vuokrasopimuksen allekirjoittamisesta poistettu onnistuneesti',0),(417545,11599,'no','Leieavtale signering slettede vellykket',0),(417546,11599,'da','Lease undertegnelsen slettet med succes',0),(417547,11599,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ëœ ì„œëª… ìž„ëŒ€',0),(417548,11599,'he','×©×›×™×¨×•×ª ×—×ª×™×ž×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(417549,11599,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Ï…Ï€Î¿Î³ÏÎ±Ï†Î® Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(417550,11599,'zh','ç§Ÿèµç­¾çº¦æˆåŠŸåˆ é™¤\r\n',0),(417551,11599,'sv','Hyresavtalet undertecknandet borttagna framgÃ¥ngsrikt',0),(417552,11599,'it','Locazione firma eliminata con successo',0),(417553,11599,'tl','',0),(417554,11599,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²à¹€à¸‹à¹‡à¸™à¸Šà¸·à¹ˆà¸­à¸–à¸¹à¸à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(417555,11599,'hi','à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(417556,11599,'ms','Pajakan yang menandatangani berjaya dipadam',0),(417557,11599,'ar','Ø¥ÙŠØ¬Ø§Ø± ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(417558,11599,'fr','Location signature supprimÃ©e avec succÃ¨s',0),(417559,11599,'jp','ãƒªãƒ¼ã‚¹ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸç½²å',0),(417560,11599,'pt','LocaÃ§Ã£o assinatura excluÃ­do com Ãªxito',0),(417561,11599,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(417562,11599,'es','Firma de Arrendamiento Eliminada Exitosamente',0),(417563,11599,'de','Lease erfolgreich gelÃ¶schte Unterzeichnung',0),(417564,11599,'en','Lease Signing Deleted Successfully',0),(417565,11600,'is','',0),(417566,11600,'dr','Wizard',0),(417567,11600,'pr','Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ Wizard',0),(417568,11600,'tr','Kira imzalama SihirbazÄ±',0),(417569,11600,'pl','Kreator podpisania umowy najmu',0),(417570,11600,'bg','Ð¡ÑŠÐ²ÐµÑ‚Ð½Ð¸ÐºÑŠÑ‚ Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ Ð·Ð° Ð½Ð°ÐµÐ¼',0),(417571,11600,'ur','Ù„ÛŒØ² Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Ø±Ù†Û’ Ú©Û’ Ù…Ø¯Ø¯Ú¯Ø§Ø±',0),(417572,11600,'sr','Ð§Ð°Ñ€Ð¾Ð±ÑšÐ°Ðº Ð·Ð° Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð·Ð°ÐºÑƒÐ¿',0),(417573,11600,'vi','KÃ½ há»£p Ä‘á»“ng thuÃª',0),(417574,11600,'af','Huurkontrak Ondertekening Towenaar',0),(417575,11600,'ro','Leasing semnarea Expertul',0),(417576,11600,'et','ÃœÃ¼rilepingu allkirjastamist viisard',0),(417577,11600,'si','ÄŒarovnik za podpis najemne pogodbe',0),(417578,11600,'ba','Sewa penandatanganan Wizard',0),(417579,11600,'nl','Lease ondertekening Wizard',0),(417580,11600,'fi','Vuokrasopimuksen allekirjoittamisesta Ohjattu',0),(417581,11600,'no','Leieavtale signering veiviseren',0),(417582,11600,'da','Lease signeringsgrÃ¦nse guiden',0),(417583,11600,'ko','ìž„ëŒ€ ì„œëª… ë§ˆë²•ì‚¬',0),(417584,11600,'he','××©×£ ×—×ª×™×ž×ª ×—×•×–×” ×©×›×™×¨×•×ª',0),(417585,11600,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î¿Î´Î·Î³ÏŒÏ‚ Ï…Ï€Î¿Î³ÏÎ±Ï†Î®',0),(417586,11600,'zh','ç§Ÿèµç­¾è®¢å‘å¯¼\r\n',0),(417587,11600,'sv','Hyresavtalet undertecknandet guiden',0),(417588,11600,'it','Locazione firma guidata',0),(417589,11600,'tl','',0),(417590,11600,'th','à¸•à¸±à¸§à¸Šà¹ˆà¸§à¸¢à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¹€à¸‹à¹‡à¸™à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(417591,11600,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤µà¤¿à¤œà¤¼à¤¾à¤°à¥à¤¡',0),(417592,11600,'ms','Pajakan menandatangani Pendeta',0),(417593,11600,'ar','Ù…Ø¹Ø§Ù„Ø¬ Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù„Ù‰ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(417594,11600,'fr','Assistant de signature de bail',0),(417595,11600,'jp','ãƒªãƒ¼ã‚¹ç½²åã‚¦ã‚£ã‚¶ãƒ¼ãƒ‰',0),(417596,11600,'pt','Assistente de assinatura de contrato',0),(417597,11600,'ru','ÐœÐ°ÑÑ‚ÐµÑ€Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(417598,11600,'es','Wizard de Firma de Arrendamiento',0),(417599,11600,'de','Leasing-Unterzeichnung-Assistenten',0),(417600,11600,'en','Lease Signing Wizard',0),(417601,11601,'is','',0),(417602,11601,'dr','Wizard ',0),(417603,11601,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡   Wizard ',0),(417604,11601,'tr','Ä°mzalama SihirbazÄ± yÃ¶nergelerini kira',0),(417605,11601,'pl','DzierÅ¼awy instrukcje kreatora podpisu',0),(417606,11601,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³, Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑŠÐ²ÐµÑ‚Ð½Ð¸ÐºÐ° Ð·Ð° ÑƒÐºÐ°Ð·Ð°Ð½Ð¸Ñ',0),(417607,11601,'ur','Ù„ÛŒØ² Ù…Ø¯Ø¯Ú¯Ø§Ø± ÛØ¯Ø§ÛŒØ§Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø·',0),(417608,11601,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ ÑƒÐ¿ÑƒÑ‚Ðµ Ñ‡Ð°Ñ€Ð¾Ð±ÑšÐ°ÐºÐ° Ð·Ð°',0),(417609,11601,'vi','CÃ¡c hÆ°á»›ng dáº«n kÃ½ há»£p Ä‘á»“ng thuÃª',0),(417610,11601,'af','Huurkontrak Ondertekening Towenaar Instruksies',0),(417611,11601,'ro','Semnarea Expertul instrucÅ£iuni de leasing',0),(417612,11601,'et','ÃœÃ¼rilepingu allkirjastamist viisardi juhiseid',0),(417613,11601,'si','Najemne pogodbe, podpisu navodila Äarovnika',0),(417614,11601,'ba','Sewa penandatanganan Wizard instruksi',0),(417615,11601,'nl','Lease ondertekening instructies van de Wizard',0),(417616,11601,'fi','Vuokrasopimuksen allekirjoittamisesta ohjatun toiminnon ohjeita',0),(417617,11601,'no','Leieavtale signering instruksjonene for',0),(417618,11601,'da','Lease signeringsgrÃ¦nse instruktionerne i guiden',0),(417619,11601,'ko','ë§ˆë²•ì‚¬ì˜ ì§€ì‹œë¥¼ ì„œëª… ìž„ëŒ€',0),(417620,11601,'he','×©×›×™×¨×•×ª ×—×•×ª× ×¢×œ ×”×”×•×¨××•×ª ×©×œ ××©×£',0),(417621,11601,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Ï…Ï€Î¿Î³ÏÎ±Ï†Î® Ï„Î¹Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚ Ï„Î¿Ï… Î¿Î´Î·Î³Î¿Ï',0),(417622,11601,'zh','ç§Ÿèµç­¾è®¢å‘å¯¼çš„è¯´æ˜Ž\r\n',0),(417623,11601,'sv','Hyresavtalet undertecknandet anvisningarna i guiden',0),(417624,11601,'it','Locazione firma le istruzioni della procedura guidata',0),(417625,11601,'tl','',0),(417626,11601,'th','à¹€à¸Šà¹ˆà¸²à¸¥à¸‡à¸™à¸²à¸¡à¸„à¸³à¸ªà¸±à¹ˆà¸‡à¸•à¸±à¸§à¸Šà¹ˆà¸§à¸¢à¸ªà¸£à¹‰à¸²à¸‡',0),(417627,11601,'hi','à¤µà¤¿à¤œà¤¼à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(417628,11601,'ms','Pajakan yang menandatangani arahan Pendeta',0),(417629,11601,'ar','Ø¥ÙŠØ¬Ø§Ø± ØªÙˆÙ‚ÙŠØ¹ ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬',0),(417630,11601,'fr','Bail signer les Instructions de l\'Assistant',0),(417631,11601,'jp','ã‚¦ã‚£ã‚¶ãƒ¼ãƒ‰ã®æŒ‡ç¤ºã«ç½²åãƒªãƒ¼ã‚¹',0),(417632,11601,'pt','InstruÃ§Ãµes do assistente de assinatura de locaÃ§Ã£o',0),(417633,11601,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð¼Ð°ÑÑ‚ÐµÑ€Ð°',0),(417634,11601,'es','Instrucciones de Wizard de Firma de Arrendamiento',0),(417635,11601,'de','Leasing Unterzeichnung Anweisungen des Assistenten',0),(417636,11601,'en','Lease Signing Wizard Instructions',0),(417637,11602,'is','',0),(417638,11602,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(417639,11602,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(417640,11602,'tr','Kira deÄŸiÅŸtirme',0),(417641,11602,'pl','Zmiana umowy najmu',0),(417642,11602,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ',0),(417643,11602,'ur','Ù„ÛŒØ² ØªØ±Ù…ÛŒÙ…',0),(417644,11602,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(417645,11602,'vi','thay Ä‘á»•i há»£p Ä‘á»“ng thuÃª',0),(417646,11602,'af','Huurkontrak Wysiging',0),(417647,11602,'ro','Modificarea de leasing',0),(417648,11602,'et','ÃœÃ¼rilepingu muutmine',0),(417649,11602,'si','Zakup sprememba',0),(417650,11602,'ba','Sewa modifikasi',0),(417651,11602,'nl','Lease wijziging',0),(417652,11602,'fi','Vuokrasopimuksen muutos',0),(417653,11602,'no','Leieavtalen modifikasjon',0),(417654,11602,'da','Lease Ã¦ndring',0),(417655,11602,'ko','ìž„ëŒ€ ìˆ˜ì •',0),(417656,11602,'he','×©×™× ×•×™ ×—×•×–×” ×©×›×™×¨×•×ª',0),(417657,11602,'el','Î¤ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(417658,11602,'zh','å¥‘çº¦ä¿®è®¢\r\n',0),(417659,11602,'sv','LÃ¥n Ã¤ndring',0),(417660,11602,'it','Modifica del contratto di locazione',0),(417661,11602,'tl','',0),(417662,11602,'th','à¹à¸à¹‰à¹„à¸‚à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(417663,11602,'hi','à¤²à¥€à¤œ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨',0),(417664,11602,'ms','Pajakan pengubahsuaian',0),(417665,11602,'ar','ØªØ¹Ø¯ÙŠÙ„ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(417666,11602,'fr','Modification du bail',0),(417667,11602,'jp','ãƒªãƒ¼ã‚¹ã®å¤‰æ›´',0),(417668,11602,'pt','ModificaÃ§Ã£o do contrato',0),(417669,11602,'ru','ÐœÐ¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(417670,11602,'es','ModificaciÃ³n de Arrendamiento',0),(417671,11602,'de','Leasing-Ã„nderung',0),(417672,11602,'en','Lease Modification',0),(417673,11603,'is','',0),(417674,11603,'dr','ØªØºÙŠÙŠØ±Ø§Øª Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(417675,11603,'pr','ØªØºÙŠÙŠØ±Ø§Øª Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯',0),(417676,11603,'tr','Kira deÄŸiÅŸikliÄŸi baÅŸarÄ±yla silindi',0),(417677,11603,'pl','Zmiana umowy najmu usuniÄ™te pomyÅ›lnie',0),(417678,11603,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(417679,11603,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ù„ÛŒØ² ØªØ±Ù…ÛŒÙ…',0),(417680,11603,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(417681,11603,'vi','xÃ³a thay Ä‘á»•i há»£p Ä‘á»“ng thuÃª thÃ nh cÃ´ng',0),(417682,11603,'af','Huurkontrak Wysiging is Suksesvol Geskrap',0),(417683,11603,'ro','Modificarea leasing eliminÄƒ cu succes',0),(417684,11603,'et','ÃœÃ¼rilepingu muutmine edukalt kustutatud',0),(417685,11603,'si','Zakup sprememba uspeÅ¡no izbrisana',0),(417686,11603,'ba','Sewa modifikasi dihapus berhasil',0),(417687,11603,'nl','Lease wijziging met succes verwijderd',0),(417688,11603,'fi','Vuokrasopimuksen muutos poistettu',0),(417689,11603,'no','Leieavtalen modifisering slettet',0),(417690,11603,'da','Lease Ã¦ndring slettet',0),(417691,11603,'ko','ìž„ëŒ€ ìˆ˜ì • ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(417692,11603,'he','×©×™× ×•×™ ×—×•×–×” ×”×©×›×™×¨×•×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(417693,11603,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(417694,11603,'zh','å¥‘çº¦ä¿®è®¢æˆåŠŸåˆ é™¤\r\n',0),(417695,11603,'sv','LÃ¥n Ã¤ndring raderades',0),(417696,11603,'it','Modifica del contratto di locazione eliminato con successo',0),(417697,11603,'tl','',0),(417698,11603,'th','à¹€à¸Šà¹ˆà¸²à¹à¸à¹‰à¹„à¸‚à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(417699,11603,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨',0),(417700,11603,'ms','Pajakan pengubahsuaian dihapuskan dengan jayanya',0),(417701,11603,'ar','ØªØ¹Ø¯ÙŠÙ„ Ø¹Ù‚Ø¯ Ø¥ÙŠØ¬Ø§Ø± Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(417702,11603,'fr','Modification de bail supprimÃ©e avec succÃ¨s',0),(417703,11603,'jp','ãƒªãƒ¼ã‚¹ã®å¤‰æ›´ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(417704,11603,'pt','ModificaÃ§Ã£o de locaÃ§Ã£o apagada com sucesso',0),(417705,11603,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(417706,11603,'es','ModificaciÃ³n de Arrendamiento Eliminada Exitosamente',0),(417707,11603,'de','Leasing-Ã„nderung erfolgreich gelÃ¶scht',0),(417708,11603,'en','Lease Modification Deleted Successfully',0),(417709,11604,'is','',0),(417710,11604,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ØªØºÙŠÙŠØ± Ø§Ø¬Ø§Ø±Ù‡ ',0),(417711,11604,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ ØªØºÙŠÙŠØ± Ø§Ø¬Ø§Ø±Ù‡ ',0),(417712,11604,'tr','Kira deÄŸiÅŸtirme yÃ¶nergeleri',0),(417713,11604,'pl','Instrukcje modyfikacji umowy najmu',0),(417714,11604,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(417715,11604,'ur','Ù„ÛŒØ² ØªØ±Ù…ÛŒÙ… ÛØ¯Ø§ÛŒØ§Øª',0),(417716,11604,'sr','Ð£Ð¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð·Ð° Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°ÐºÑƒÐ¿',0),(417717,11604,'vi','hÆ°á»›ng dáº«n thay Ä‘á»•i há»£p Ä‘á»“ng thuÃª',0),(417718,11604,'af','Huurkontrak Wysigingsinstruksies',0),(417719,11604,'ro','InstrucÅ£iunile de modificare contract de leasing',0),(417720,11604,'et','Rendilepingu muutmise juhised',0),(417721,11604,'si','Zakup sprememba navodila',0),(417722,11604,'ba','Sewa modifikasi petunjuk',0),(417723,11604,'nl','Lease wijziging instructies',0),(417724,11604,'fi','Vuokrasopimuksen muutos ohjeet',0),(417725,11604,'no','Leieavtalen modifisering instruksjoner',0),(417726,11604,'da','Lease Ã¦ndring instruktioner',0),(417727,11604,'ko','ìž„ëŒ€ ìˆ˜ì • ì§€ì¹¨',0),(417728,11604,'he','×”×•×¨××•×ª ×©×™× ×•×™ ×—×•×–×” ×©×›×™×¨×•×ª',0),(417729,11604,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(417730,11604,'zh','ç§Ÿèµä¿®æ”¹æŒ‡ä»¤\r\n',0),(417731,11604,'sv','LÃ¥n Ã¤ndring instruktioner',0),(417732,11604,'it','Istruzioni di modifica del contratto di locazione',0),(417733,11604,'tl','',0),(417734,11604,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¹à¸à¹‰à¹„à¸‚à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(417735,11604,'hi','à¤²à¥€à¤œ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¥‹à¤‚',0),(417736,11604,'ms','Arahan pengubahsuaian pajakan',0),(417737,11604,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª ØªØ¹Ø¯ÙŠÙ„ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(417738,11604,'fr','Instructions de Modification de bail',0),(417739,11604,'jp','ãƒªãƒ¼ã‚¹ã®å¤‰æ›´æ–¹æ³•',0),(417740,11604,'pt','InstruÃ§Ãµes de modificaÃ§Ã£o de locaÃ§Ã£o',0),(417741,11604,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(417742,11604,'es','Instrucciones de ModificaciÃ³n de Arrendamiento',0),(417743,11604,'de','Leasing-Ã„nderung-Anweisungen',0),(417744,11604,'en','Lease Modification Instructions',0),(417745,11605,'is','',0),(417746,11605,'dr','Ø§ØµÙ„Ø§Ø­ Ø¬Ø¯ÙŠØ¯ Ø§Ø¬Ø§Ø±Ù‡',0),(417747,11605,'pr','Ø§ØµÙ„Ø§Ø­ Ø¬Ø¯ÙŠØ¯ Ø§Ø¬Ø§Ø±Ù‡',0),(417748,11605,'tr','Yeni kira deÄŸiÅŸtirme',0),(417749,11605,'pl','Nowa modyfikacja dzierÅ¼awy',0),(417750,11605,'bg','ÐÐ¾Ð²Ð° Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(417751,11605,'ur','Ù†Ø¦ÛŒ Ù„ÛŒØ² ØªØ±Ù…ÛŒÙ…',0),(417752,11605,'sr','ÐÐ¾Ð²Ð¸ Ð·Ð°ÐºÑƒÐ¿ Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(417753,11605,'vi','thay Ä‘á»•i thuÃª má»›i',0),(417754,11605,'af','Nuwe Huurkontrak Aanpassing',0),(417755,11605,'ro','Modificare contract de leasing nou',0),(417756,11605,'et','Uue Ã¼Ã¼rilepingu muutmine',0),(417757,11605,'si','Nova sprememba najema',0),(417758,11605,'ba','Modifikasi sewa baru',0),(417759,11605,'nl','Nieuwe Lease modificatie',0),(417760,11605,'fi','Uusi vuokrasopimuksen muutos',0),(417761,11605,'no','Ny leieavtale modifikasjon',0),(417762,11605,'da','Ny Lease Ã¦ndring',0),(417763,11605,'ko','ìƒˆë¡œìš´ ìž„ëŒ€ ìˆ˜ì •',0),(417764,11605,'he','×©×™× ×•×™ ×—×•×–×” ×©×›×™×¨×•×ª ×—×“×©',0),(417765,11605,'el','ÎÎ­Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(417766,11605,'zh','æ–°çš„å¥‘çº¦ä¿®è®¢\r\n',0),(417767,11605,'sv','Nya lÃ¥n modifiering',0),(417768,11605,'it','Nuova modifica del contratto di locazione',0),(417769,11605,'tl','',0),(417770,11605,'th','à¹à¸à¹‰à¹„à¸‚à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¹ƒà¸«à¸¡à¹ˆ',0),(417771,11605,'hi','à¤¨à¤ˆ à¤²à¥€à¤œ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨',0),(417772,11605,'ms','Baru pajakan pengubahsuaian',0),(417773,11605,'ar','ØªØ¹Ø¯ÙŠÙ„ Ø¹Ù‚Ø¯ Ø¥ÙŠØ¬Ø§Ø± Ø¬Ø¯ÙŠØ¯',0),(417774,11605,'fr','Nouvelle Modification de bail',0),(417775,11605,'jp','æ–°ã—ã„ãƒªãƒ¼ã‚¹ã®ä¿®æ­£',0),(417776,11605,'pt','Nova modificaÃ§Ã£o de locaÃ§Ã£o',0),(417777,11605,'ru','ÐÐ¾Ð²Ð°Ñ Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(417778,11605,'es','Nueva ModificaciÃ³n de Arrendamiento',0),(417779,11605,'de','Neue Leasing-Ã„nderung',0),(417780,11605,'en','New Lease Modification',0),(417781,11606,'is','',0),(417782,11606,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø§ØµÙ„Ø§Ø­ ',0),(417783,11606,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø§ØµÙ„Ø§Ø­ ',0),(417784,11606,'tr','DeÄŸiÅŸiklik seÃ§in',0),(417785,11606,'pl','Wybierz zmiany',0),(417786,11606,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(417787,11606,'ur','ØªØ±Ù…ÛŒÙ… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(417788,11606,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(417789,11606,'vi','Chá»n sá»­a Ä‘á»•i',0),(417790,11606,'af','Kies verandering',0),(417791,11606,'ro','SelectaÅ£i modificarea',0),(417792,11606,'et','Valige muutmine',0),(417793,11606,'si','Izberite spremembe',0),(417794,11606,'ba','Pilih modifikasi',0),(417795,11606,'nl','Selecteer wijziging',0),(417796,11606,'fi','Valitse muutos',0),(417797,11606,'no','Velg endring',0),(417798,11606,'da','VÃ¦lg Ã¦ndring',0),(417799,11606,'ko','ì„ íƒ ìˆ˜ì •',0),(417800,11606,'he','×‘×—×¨ ×©×™× ×•×™',0),(417801,11606,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(417802,11606,'zh','é€‰æ‹©ä¿®æ”¹\r\n',0),(417803,11606,'sv','Markera Ã¤ndringar',0),(417804,11606,'it','Selezionare Modifica',0),(417805,11606,'tl','',0),(417806,11606,'th','à¹€à¸¥à¸·à¸­à¸à¸›à¸£à¸±à¸šà¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™',0),(417807,11606,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(417808,11606,'ms','Pilih pengubahsuaian',0),(417809,11606,'ar','Ø­Ø¯Ø¯ ØªØ¹Ø¯ÙŠÙ„',0),(417810,11606,'fr','SÃ©lectionnez Modification',0),(417811,11606,'jp','å¤‰æ›´ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(417812,11606,'pt','Selecione a modificaÃ§Ã£o',0),(417813,11606,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐœÐ¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸ÑŽ',0),(417814,11606,'es','Selecciona ModificaciÃ³n',0),(417815,11606,'de','WÃ¤hlen Sie die Ã„nderung',0),(417816,11606,'en','Select Modification',0),(417817,11607,'is','',0),(417818,11607,'dr','Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ø¬Ø§Ø±ÙŠ ',0),(417819,11607,'pr','Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ø¬Ø§Ø±ÙŠ ',0),(417820,11607,'tr','GeÃ§erli umudu',0),(417821,11607,'pl','Obecnej perspektywy',0),(417822,11607,'bg','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(417823,11607,'ur','Ø­Ø§Ù„ÛŒÛ Ù…Ù†Ø¸Ø±',0),(417824,11607,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(417825,11607,'vi','KhÃ¡ch hÃ ng tiá»m nÄƒng hiá»‡n táº¡i',0),(417826,11607,'af','Huidige Voornemende KliÃ«nt',0),(417827,11607,'ro','Perspectiva de curent',0),(417828,11607,'et','Praegune potentsiaalne klient',0),(417829,11607,'si','PriÄakovati',0),(417830,11607,'ba','Prospek saat ini',0),(417831,11607,'nl','Huidige vooruitzicht',0),(417832,11607,'fi','Nykyinen mahdollisuus',0),(417833,11607,'no','Gjeldende prospekt',0),(417834,11607,'da','NuvÃ¦rende udsigten',0),(417835,11607,'ko','í˜„ìž¬ ì „ë§',0),(417836,11607,'he','×¤×¨×•×¡×¤×§×˜ ×”× ×•×›×—×™',0),(417837,11607,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ®',0),(417838,11607,'zh','å½“å‰å±•æœ›\r\n',0),(417839,11607,'sv','Aktuella utsikterna',0),(417840,11607,'it','Prospettiva corrente',0),(417841,11607,'tl','',0),(417842,11607,'th','à¹‚à¸™à¹‰à¸¡à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(417843,11607,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾',0),(417844,11607,'ms','Prospek semasa',0),(417845,11607,'ar','Ø§Ø­ØªÙ…Ø§Ù„ Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(417846,11607,'fr','Perspective actuelle',0),(417847,11607,'jp','ç¾åœ¨ã®è¦‹è¾¼ã¿',0),(417848,11607,'pt','Perspectiva atual',0),(417849,11607,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ñ‹',0),(417850,11607,'es','Prospecto Actual',0),(417851,11607,'de','Aktuelle Aussicht',0),(417852,11607,'en','Current Prospect',0),(417853,11608,'is','',0),(417854,11608,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø±Ø­ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ',0),(417855,11608,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø±Ø­ Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ',0),(417856,11608,'tr','Umudu aÃ§Ä±klama seÃ§in',0),(417857,11608,'pl','Wybierz opis perspektywa',0),(417858,11608,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(417859,11608,'ur','ØªØµØ±ÛŒØ­ Ù…Ù†Ø¸Ø± Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(417860,11608,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿Ð¸Ñ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð°',0),(417861,11608,'vi','Chá»n mÃ´ táº£ khÃ¡ch hÃ ng tiá»m nÄƒng',0),(417862,11608,'af','Kies Voornemende KliÃ«nt Beskrywing',0),(417863,11608,'ro','SelectaÅ£i perspectivÄƒ Descriere',0),(417864,11608,'et','Valige vÃ¤ljavaade kirjeldus',0),(417865,11608,'si','Izberite moÅ¾nost opis',0),(417866,11608,'ba','Pilih prospek Deskripsi',0),(417867,11608,'nl','Selecteer vooruitzicht beschrijving',0),(417868,11608,'fi','Valitse mahdollisuus kuvaus',0),(417869,11608,'no','Velg prospektet beskrivelse',0),(417870,11608,'da','VÃ¦lg udsigten beskrivelse',0),(417871,11608,'ko','ì „ë§ ì„¤ëª… ì„ íƒ',0),(417872,11608,'he','×‘×—×¨ ×ª×™××•×¨ ×¤×¨×•×¡×¤×§×˜',0),(417873,11608,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ® Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(417874,11608,'zh','é€‰æ‹©å‰æ™¯æè¿°\r\n',0),(417875,11608,'sv','VÃ¤lj Prospect Beskrivning',0),(417876,11608,'it','Selezionare la prospettiva Descrizione',0),(417877,11608,'tl','',0),(417878,11608,'th','à¹€à¸¥à¸·à¸­à¸à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹‚à¸­à¸à¸²à¸ª',0),(417879,11608,'hi','à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾ à¤µà¤°à¥à¤£à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(417880,11608,'ms','Pilih Perihalan Prospect',0),(417881,11608,'ar','Ø­Ø¯Ø¯ Ø§Ù„ÙˆØµÙ Ø§Ø­ØªÙ…Ø§Ù„',0),(417882,11608,'fr','SÃ©lectionnez perspective Description',0),(417883,11608,'jp','è¦‹é€šã—ã®è¨˜è¿°ã‚’é¸æŠžã—ã¾ã™',0),(417884,11608,'pt','Selecione perspectiva descriÃ§Ã£o',0),(417885,11608,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾ÑÐ¿ÐµÐºÑ‚',0),(417886,11608,'es','Selecciona DescripciÃ³n de Prospecto',0),(417887,11608,'de','WÃ¤hlen Sie Prospekt-Beschreibung',0),(417888,11608,'en','Select Prospect Description',0),(417889,11609,'is','',0),(417890,11609,'dr','Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ù‡Ø§ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(417891,11609,'pr','Ù†Ø¸Ø± Ø³Ù†Ø¬ÙŠ Ù‡Ø§ÙŠ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù‡ ',0),(417892,11609,'tr','TamamlanmÄ±ÅŸ anketler',0),(417893,11609,'pl','WypeÅ‚nione ankiety',0),(417894,11609,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ð¸Ñ',0),(417895,11609,'ur','Ù…Ú©Ù…Ù„ Ø³Ø±ÙˆÛ’',0),(417896,11609,'sr','Ð“Ð¾Ñ‚Ð¾Ð²Ðµ Ð°Ð½ÐºÐµÑ‚Ðµ',0),(417897,11609,'vi','Ä‘Ã£ hoÃ n thÃ nh nghiÃªn cá»©u',0),(417898,11609,'af','Voltooide opnames',0),(417899,11609,'ro','Finalizat anchetele',0),(417900,11609,'et','LÃµpetatud uuringud',0),(417901,11609,'si','Izpolnjene ankete',0),(417902,11609,'ba','Selesai survei',0),(417903,11609,'nl','Voltooide enquÃªtes',0),(417904,11609,'fi','TÃ¤ytetyt kyselyt',0),(417905,11609,'no','FullfÃ¸rte undersÃ¸kelser',0),(417906,11609,'da','Afsluttede undersÃ¸gelser',0),(417907,11609,'ko','ì™„ë£Œ ëœ ì„¤ë¬¸ ì¡°ì‚¬',0),(417908,11609,'he','×¡×§×¨×™× ×©×”×•×©×œ×ž×•',0),(417909,11609,'el','ÎŸÎ»Î¿ÎºÎ»Î·ÏÏ‰Î¼Î­Î½ÎµÏ‚ Î­ÏÎµÏ…Î½ÎµÏ‚',0),(417910,11609,'zh','å®Œæˆè°ƒæŸ¥\r\n',0),(417911,11609,'sv','Ifyllda enkÃ¤ter',0),(417912,11609,'it','Indagini completate',0),(417913,11609,'tl','',0),(417914,11609,'th','à¸ªà¸³à¸£à¸§à¸ˆà¹€à¸ªà¸£à¹‡à¸ˆ',0),(417915,11609,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤•à¤¿à¤ à¤—à¤ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£',0),(417916,11609,'ms','Siap Ukur',0),(417917,11609,'ar','Ø§Ù„Ø¯Ø±Ø§Ø³Ø§Øª Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¦ÙŠØ© Ø§Ù„Ù…Ù†Ø¬Ø²Ø©',0),(417918,11609,'fr','Questionnaires remplis',0),(417919,11609,'jp','ã‚¢ãƒ³ã‚±ãƒ¼ãƒˆç”¨ç´™',0),(417920,11609,'pt','Pesquisas concluÃ­das',0),(417921,11609,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ Ð¾Ð¿Ñ€Ð¾ÑÑ‹',0),(417922,11609,'es','Sondeos Complets',0),(417923,11609,'de','AusgefÃ¼llten Umfragen',0),(417924,11609,'en','Completed Surveys',0),(417925,11610,'is','',0),(417926,11610,'dr','(Ù…Ø´Ø±ÙˆØ·',0),(417927,11610,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù…Ø¹ÙˆÙ‚(Ù…Ø´Ø±ÙˆØ·',0),(417928,11610,'tr','Bekleyen anket istekleri',0),(417929,11610,'pl','Badanie czasu Å¼Ä…dania',0),(417930,11610,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð¸ÑÐºÐ°Ð½Ð¸Ñ',0),(417931,11610,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø³Ø±ÙˆÛ’',0),(417932,11610,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÑƒ Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ',0),(417933,11610,'vi','Ä‘ang treo Ä‘á» nghá»‹ nghiÃªn cá»©u',0),(417934,11610,'af','Hangende opname versoeke',0),(417935,11610,'ro','Cererile de anchetÄƒ Ã®n curs',0),(417936,11610,'et','Ootel uuringu taotlused',0),(417937,11610,'si','ÄŒakajoÄi pregled zahtev',0),(417938,11610,'ba','Permintaan tertunda survei',0),(417939,11610,'nl','In behandeling Survey aanvragen',0),(417940,11610,'fi','Odotetaan kyselyn pyynnÃ¶t',0),(417941,11610,'no','Ventende undersÃ¸kelse forespÃ¸rsler',0),(417942,11610,'da','Ventende undersÃ¸gelse anmodninger',0),(417943,11610,'ko','ë³´ë¥˜ ì¤‘ì¸ ì„¤ë¬¸ ì¡°ì‚¬ ìš”ì²­',0),(417944,11610,'he','×¡×§×¨ ×ž×ž×ª×™× ×™× ×‘×§×©×•×ª',0),(417945,11610,'el','ÎˆÏÎµÏ…Î½Î± ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚',0),(417946,11610,'zh','å¾…åŠžè°ƒæŸ¥è¯·æ±‚\r\n',0),(417947,11610,'sv','PÃ¥gÃ¥ende undersÃ¶kning fÃ¶rfrÃ¥gningar',0),(417948,11610,'it','Richieste di indagine in sospeso',0),(417949,11610,'tl','',0),(417950,11610,'th','à¸ªà¸³à¸£à¸§à¸ˆà¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸žà¸´à¸ˆà¸²à¸£à¸“à¸²à¸„à¸³à¸‚à¸­',0),(417951,11610,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚',0),(417952,11610,'ms','Permintaan Ukur belum selesai',0),(417953,11610,'ar','Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…Ø³Ø­ Ù…Ø¹Ù„Ù‚Ø©',0),(417954,11610,'fr','Demandes en attente de sondage',0),(417955,11610,'jp','ä¿ç•™ä¸­ã®ã‚¢ãƒ³ã‚±ãƒ¼ãƒˆã®ãŠé¡˜ã„',0),(417956,11610,'pt','SolicitaÃ§Ãµes de pesquisa pendentes',0),(417957,11610,'ru','Ð”Ð¾ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÑ‹',0),(417958,11610,'es','Solicitudes de Sondeos Pendientes',0),(417959,11610,'de','Ausstehende Umfrage Anfragen',0),(417960,11610,'en','Pending Survey Requests',0),(417961,11611,'is','',0),(417962,11611,'dr','Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù…Ø³ØªØ§Ø¬Ø± ',0),(417963,11611,'pr','Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù…Ø³ØªØ§Ø¬Ø± ',0),(417964,11611,'tr','KiracÄ± anketler',0),(417965,11611,'pl','Badania najemcy',0),(417966,11611,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ð¸Ñ',0),(417967,11611,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ø³Ø±ÙˆÛ’',0),(417968,11611,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(417969,11611,'vi','Kháº£o sÃ¡t Ã½ kiáº¿n ngÆ°á»i thuÃª nhÃ ',0),(417970,11611,'af','Huurder Opnames',0),(417971,11611,'ro','ChiriaÅŸ sondaje',0),(417972,11611,'et','ÃœÃ¼rnik kÃ¼sitlused',0),(417973,11611,'si','Najemnik raziskovanj',0),(417974,11611,'ba','Survei penyewa',0),(417975,11611,'nl','Huurder enquÃªtes',0),(417976,11611,'fi','Vuokralainen tutkimukset',0),(417977,11611,'no','Leietaker undersÃ¸kelser',0),(417978,11611,'da','Lejer undersÃ¸gelser',0),(417979,11611,'ko','ê±°ì£¼ìž ì„¤ë¬¸ ì¡°ì‚¬',0),(417980,11611,'he','×”×“×™×™×¨ ×¡×§×¨×™×',0),(417981,11611,'el','ÎˆÏÎµÏ…Î½ÎµÏ‚ Ï„Î¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(417982,11611,'zh','ä¸šæƒäººæ„è§è°ƒæŸ¥\r\n',0),(417983,11611,'sv','HyresgÃ¤sten undersÃ¶kningar',0),(417984,11611,'it','Inquilino sondaggi',0),(417985,11611,'tl','',0),(417986,11611,'th','à¸ªà¸³à¸£à¸§à¸ˆà¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(417987,11611,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£',0),(417988,11611,'ms','Ukur penyewa',0),(417989,11611,'ar','Ø§Ù„Ø¯Ø±Ø§Ø³Ø§Øª Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¦ÙŠØ© Ù„Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(417990,11611,'fr','EnquÃªtes de locataire',0),(417991,11611,'jp','ãƒ†ãƒŠãƒ³ãƒˆèª¿æŸ»',0),(417992,11611,'pt','InquÃ©ritos de inquilino',0),(417993,11611,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ð¹',0),(417994,11611,'es','Sondeos de Inquilinos',0),(417995,11611,'de','Mieter Umfragen',0),(417996,11611,'en','Tenant Surveys',0),(417997,11612,'is','',0),(417998,11612,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù…Ø³ØªØ§Ø¬Ø± ',0),(417999,11612,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ù†Ø¸Ø±Ø³Ù†Ø¬ÙŠ Ù…Ø³ØªØ§Ø¬Ø± ',0),(418000,11612,'tr','KiracÄ± Anketi yÃ¶nergeleri',0),(418001,11612,'pl','Najemcy badania instrukcje',0),(418002,11612,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(418003,11612,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ø³Ø±ÙˆÛ’ ÛØ¯Ø§ÛŒØ§Øª',0),(418004,11612,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÑƒ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(418005,11612,'vi','HÆ°á»›ng dáº«n kháº£o sÃ¡t ngÆ°á»i thuÃª nhÃ ',0),(418006,11612,'af','Huurder Opnames Instruksies',0),(418007,11612,'ro','ChiriaÅŸ anchetÄƒ instructiuni',0),(418008,11612,'et','ÃœÃ¼rnik uuring juhendid',0),(418009,11612,'si','Najemnik anketo navodila',0),(418010,11612,'ba','Penyewa survei petunjuk',0),(418011,11612,'nl','Huurder enquÃªte instructies',0),(418012,11612,'fi','Vuokralainen Klubikyselyn ohjeet',0),(418013,11612,'no','Leietaker undersÃ¸kelse instruksjoner',0),(418014,11612,'da','Lejer undersÃ¸gelse vejledning',0),(418015,11612,'ko','ì„¸ ìž…ìž ì¡°ì‚¬ ì§€ì¹¨',0),(418016,11612,'he','×”×“×™×™×¨ ×¡×§×¨ ×”×•×¨××•×ª',0),(418017,11612,'el','ÎŸÎ´Î·Î³Î¯ÎµÏ‚ Î­ÏÎµÏ…Î½Î±Ï‚ Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(418018,11612,'zh','ä¸šæƒäººè°ƒæŸ¥æŒ‡å¼•\r\n',0),(418019,11612,'sv','HyresgÃ¤sten undersÃ¶kning instruktioner',0),(418020,11612,'it','Inquilino sondaggio istruzioni',0),(418021,11612,'tl','',0),(418022,11612,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸ªà¸³à¸£à¸§à¸ˆà¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(418023,11612,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(418024,11612,'ms','Arahan Ukur penyewa',0),(418025,11612,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ù…Ø³Ø­ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(418026,11612,'fr','Locataire Sondage Instructions',0),(418027,11612,'jp','ãƒ†ãƒŠãƒ³ãƒˆèª¿æŸ»ã«é–¢ã™ã‚‹æŒ‡ç¤º',0),(418028,11612,'pt','InstruÃ§Ãµes de pesquisa do inquilino',0),(418029,11612,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(418030,11612,'es','Instrucciones de Sondeos de Inquilinos',0),(418031,11612,'de','Mieter-Umfrage-Anweisungen',0),(418032,11612,'en','Tenant Survey Instructions',0),(418033,11613,'is','',0),(418034,11613,'dr','Ø®Ù„Ø§ØµÙ‡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(418035,11613,'pr','Ø®Ù„Ø§ØµÙ‡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(418036,11613,'tr','Kira Ã–zeti',0),(418037,11613,'pl','Podsumowanie dzierÅ¼awy',0),(418038,11613,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(418039,11613,'ur','Ù„ÛŒØ² Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(418040,11613,'sr','Ð—Ð°ÐºÑƒÐ¿ Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(418041,11613,'vi','Tá»•ng há»£p há»£p Ä‘á»“ng thuÃª',0),(418042,11613,'af','Huurkontrak Opsomming',0),(418043,11613,'ro','Leasing Rezumat',0),(418044,11613,'et','ÃœÃ¼rilepingu KokkuvÃµte',0),(418045,11613,'si','Zakup Povzetek',0),(418046,11613,'ba','Sewa ringkasan',0),(418047,11613,'nl','Samenvatting van de lease-overeenkomst',0),(418048,11613,'fi','Vuokrasopimuksen Yhteenveto',0),(418049,11613,'no','Leieavtalen Sammendrag',0),(418050,11613,'da','Lease ResumÃ©',0),(418051,11613,'ko','ìž„ëŒ€ ìš”ì•½',0),(418052,11613,'he','×¡×™×›×•× ×—×›×™×¨×”',0),(418053,11613,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(418054,11613,'zh','ç§Ÿèµæ‘˜è¦\r\n',0),(418055,11613,'sv','Hyresavtalet Sammanfattning',0),(418056,11613,'it','Sintesi del contratto di locazione',0),(418057,11613,'tl','',0),(418058,11613,'th','à¸ªà¸£à¸¸à¸›à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(418059,11613,'hi','à¤²à¥€à¤œ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(418060,11613,'ms','Ringkasan pajakan',0),(418061,11613,'ar','Ù…Ù„Ø®Øµ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(418062,11613,'fr','RÃ©sumÃ© du contrat de location',0),(418063,11613,'jp','è³ƒè²¸å€Ÿã®æ¦‚æ³',0),(418064,11613,'pt','Resumo de contrato',0),(418065,11613,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(418066,11613,'es','Sumario de Arrendamiento',0),(418067,11613,'de','Leasing-Zusammenfassung',0),(418068,11613,'en','Lease Summary',0),(418069,11614,'is','',0),(418070,11614,'dr',' Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø®Ù„Ø§ØµÙ‡ Ø§Ø¬Ø§Ø±Ù‡  ',0),(418071,11614,'pr',' Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ø®Ù„Ø§ØµÙ‡ Ø§Ø¬Ø§Ø±Ù‡  ',0),(418072,11614,'tr','Kira Ã–zet talimatlarÄ±',0),(418073,11614,'pl','Podsumowanie instrukcje dzierÅ¼awy',0),(418074,11614,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð ÐµÐ·ÑŽÐ¼Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(418075,11614,'ur','Ù„ÛŒØ² Ú©Û’ Ø®Ù„Ø§ØµÛ Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(418076,11614,'sr','Ð—Ð°ÐºÑƒÐ¿ Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ° ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(418077,11614,'vi','HÆ°á»›ng dáº«n tá»•ng há»£p há»£p Ä‘á»“ng thuÃª',0),(418078,11614,'af','Huurkontrak Opsommingsinstruksies',0),(418079,11614,'ro','Leasing Rezumat instrucÅ£iuni',0),(418080,11614,'et','ÃœÃ¼rilepingu kokkuvÃµtlik juhiseid',0),(418081,11614,'si','Zakup Povzetek navodila',0),(418082,11614,'ba','Sewa ringkasan petunjuk',0),(418083,11614,'nl','Lease beknopte instructies',0),(418084,11614,'fi','Vuokrasopimuksen Yhteenveto ohjeet',0),(418085,11614,'no','Leieavtalen Sammendrag instruksjoner',0),(418086,11614,'da','Lease kortfattede instruktioner',0),(418087,11614,'ko','ìž„ëŒ€ ìš”ì•½ ì§€ì¹¨',0),(418088,11614,'he','×”×•×¨××•×ª ×ž×§×•×¦×¨×•×ª ×—×›×™×¨×”',0),(418089,11614,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· ÏƒÏÎ½Î¿ÏˆÎ·Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(418090,11614,'zh','ç§Ÿèµæ‘˜è¦è¯´æ˜Ž\r\n',0),(418091,11614,'sv','Hyresavtalet Sammanfattning instruktioner',0),(418092,11614,'it','Riepilogo istruzioni contratto di locazione',0),(418093,11614,'tl','',0),(418094,11614,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸ªà¸£à¸¸à¸›à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(418095,11614,'hi','à¤²à¥€à¤œ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(418096,11614,'ms','Pajakan ringkasan arahan',0),(418097,11614,'ar','Ø§Ù„Ø¥Ø±Ø´Ø§Ø¯Ø§Øª Ø§Ù„Ù…ÙˆØ¬Ø²Ø© Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(418098,11614,'fr','Instructions sommaires de bail',0),(418099,11614,'jp','ãƒªãƒ¼ã‚¹ã®è¦ç´„æ‰‹é †',0),(418100,11614,'pt','InstruÃ§Ãµes resumidas de locaÃ§Ã£o',0),(418101,11614,'ru','ÐÑ€ÐµÐ½Ð´Ð° ÐºÑ€Ð°Ñ‚ÐºÐ¸Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(418102,11614,'es','Instrucciones de Sumario de Arrendamiento',0),(418103,11614,'de','Leasing-Zusammenfassung-Anweisungen',0),(418104,11614,'en','Lease Summary Instructions',0),(418105,11615,'is','',0),(418106,11615,'dr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø³Ø±Ø´ÙƒÙ† Ø´Ø¯Ù‡ ',0),(418107,11615,'pr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø³Ø±Ø´ÙƒÙ† Ø´Ø¯Ù‡ ',0),(418108,11615,'tr','Hesaplanarak aralÄ±ÄŸÄ±',0),(418109,11615,'pl','Zakres proporcjonalna',0),(418110,11615,'bg','ÐŸÑ€Ð¾Ð¿Ð¾Ñ€Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð° Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(418111,11615,'ur','Ù¾Ø±ÙˆØ±ÛŒÙ¹Ø¯ Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(418112,11615,'sr','ÐŸÑ€Ð¾Ð¿Ð¾Ñ€Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð° Ð¾Ð¿ÑÐµÐ³Ñƒ',0),(418113,11615,'vi','vÃ¹ng tá»· ká»‡',0),(418114,11615,'af','Verdeelde Reeks',0),(418115,11615,'ro','ProporÅ£ie gama',0),(418116,11615,'et','Soetatakse vahemik',0),(418117,11615,'si','Proporcionalni obseg',0),(418118,11615,'ba','Berbagai prorata',0),(418119,11615,'nl','Pro rata bereik',0),(418120,11615,'fi','Jaettu alue',0),(418121,11615,'no','Fordelte utvalg',0),(418122,11615,'da','ForholdsmÃ¦ssig vifte',0),(418123,11615,'ko','í• ë‹¹ëœ ë²”ìœ„',0),(418124,11615,'he','×˜×•×•×— ×ž×¦×˜×‘×¨×•×ª',0),(418125,11615,'el','Î‘Î½Î±Î»Î¿Î³Î¿ÏÏƒÎ± Ï†Î¬ÏƒÎ¼Î±',0),(418126,11615,'zh','æŒ‰æ¯”ä¾‹åˆ†é…çš„èŒƒå›´\r\n',0),(418127,11615,'sv','Proportionellt urval',0),(418128,11615,'it','Gamma rateizzato',0),(418129,11615,'tl','',0),(418130,11615,'th','à¸Šà¹ˆà¸§à¸‡à¸‚à¸­à¸‡à¸ªà¸´à¸™à¸—à¸£à¸±à¸žà¸¢à¹Œà¹à¸šà¹ˆà¸‡à¸•à¸²à¸¡à¸ªà¹ˆà¸§à¸™',0),(418131,11615,'hi','Prorated à¤°à¥‡à¤‚à¤œ',0),(418132,11615,'ms','Pelbagai pro-rata',0),(418133,11615,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„ØªÙ†Ø§Ø³Ø¨ÙŠØ©',0),(418134,11615,'fr','Gamme calculÃ©e au prorata',0),(418135,11615,'jp','æ¯”ä¾‹ç¯„å›²',0),(418136,11615,'pt','Faixa proporcional',0),(418137,11615,'ru','ÐŸÑ€Ð¾Ð¿Ð¾Ñ€Ñ†Ð¸Ð¾Ð½Ð°Ð»ÑŒÐ½Ð¾ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(418138,11615,'es','Rango Prorrateado',0),(418139,11615,'de','Anteilige Range',0),(418140,11615,'en','Prorated Range',0),(418141,11616,'is','',0),(418142,11616,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª',0),(418143,11616,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª',0),(418144,11616,'tr','Ä°letiÅŸim yÃ¶nergeleri',0),(418145,11616,'pl','Instrukcje komunikacji',0),(418146,11616,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° ÐºÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(418147,11616,'ur','Ù…ÙˆØ§ØµÙ„Ø§Øª Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(418148,11616,'sr','Ð£Ð¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð·Ð° ÐºÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(418149,11616,'vi','hÆ°á»›ng dáº«n giao tiáº¿p',0),(418150,11616,'af','Kommunikasie instruksies',0),(418151,11616,'ro','InstrucÅ£iuni de comunicaÅ£ii',0),(418152,11616,'et','Side juhiseid',0),(418153,11616,'si','Komunikacije navodila',0),(418154,11616,'ba','Komunikasi petunjuk',0),(418155,11616,'nl','Communicatie instructies',0),(418156,11616,'fi','ViestinnÃ¤n ohjeet',0),(418157,11616,'no','Kommunikasjon instruksjoner',0),(418158,11616,'da','Kommunikation instruktioner',0),(418159,11616,'ko','í†µì‹  ì§€ì¹¨',0),(418160,11616,'he','×”×•×¨××•×ª ×ª×§×©×•×¨×ª',0),(418161,11616,'el','ÎŸÎ´Î·Î³Î¯ÎµÏ‚ ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÏŽÎ½',0),(418162,11616,'zh','é€šè®¯è¯´æ˜Ž\r\n',0),(418163,11616,'sv','Kommunikation instruktioner',0),(418164,11616,'it','Istruzioni comunicazioni',0),(418165,11616,'tl','',0),(418166,11616,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¹ƒà¸™à¸à¸²à¸£à¸ªà¸·à¹ˆà¸­à¸ªà¸²à¸£',0),(418167,11616,'hi','à¤¸à¤‚à¤šà¤¾à¤° à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(418168,11616,'ms','Arahan komunikasi',0),(418169,11616,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„Ø§Øª',0),(418170,11616,'fr','Instructions de communications',0),(418171,11616,'jp','é€šä¿¡æ‰‹é †',0),(418172,11616,'pt','InstruÃ§Ãµes de comunicaÃ§Ãµes',0),(418173,11616,'ru','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð¿Ð¾ ÑÐ²ÑÐ·Ð¸',0),(418174,11616,'es','Instrucciones de Comunicaciones',0),(418175,11616,'de','Kommunikation-Anweisungen',0),(418176,11616,'en','Communications Instructions',0),(418177,11617,'is','',0),(418178,11617,'dr','Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ ',0),(418179,11617,'pr','Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„ ',0),(418180,11617,'tr','Aktif umutlarÄ±',0),(418181,11617,'pl','Aktywnych perspektywy',0),(418182,11617,'bg','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð¸',0),(418183,11617,'ur','Ø²ÛŒØ± Ø¹Ù…Ù„ Ú©Û’ Ø§Ù…Ú©Ø§Ù†Ø§Øª',0),(418184,11617,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð¸Ð·Ð³Ð»ÐµÐ´Ðµ',0),(418185,11617,'vi','KhÃ¡ch hÃ ng tiá»m nÄƒng hoáº¡t Ä‘á»™ng',0),(418186,11617,'af','Aktiewe Voornemende KliÃ«nt',0),(418187,11617,'ro','Perspectivele de active',0),(418188,11617,'et','Aktiivne vÃ¤ljavaateid',0),(418189,11617,'si','MoÅ¾nosti aktivnega',0),(418190,11617,'ba','Prospek aktif',0),(418191,11617,'nl','Actieve vooruitzichten',0),(418192,11617,'fi','Aktiiviset nÃ¤kymÃ¤t',0),(418193,11617,'no','Aktive prospekter',0),(418194,11617,'da','Aktive perspektiver',0),(418195,11617,'ko','í™œì„±í™” ì „ë§',0),(418196,11617,'he','×¢×ª×™×“ ×”×¤×¢×™×œ',0),(418197,11617,'el','Î•Î½ÎµÏÎ³ÏŒ Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ­Ï‚',0),(418198,11617,'zh','ä¸»åŠ¨æ‰¾æœ‰å¸Œæœ›çš„å®¢æˆ¶\r\n',0),(418199,11617,'sv','Aktiva framtidsutsikter',0),(418200,11617,'it','Prospettive attive',0),(418201,11617,'tl','',0),(418202,11617,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸­à¸¢à¸¹à¹ˆ',0),(418203,11617,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾à¤“à¤‚',0),(418204,11617,'ms','Prospek yang aktif',0),(418205,11617,'ar','Ø¢ÙØ§Ù‚ Ø§Ù„Ù†Ø´Ø·Ø©',0),(418206,11617,'fr','Prospect',0),(418207,11617,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªè¦‹é€šã—',0),(418208,11617,'pt','Perspectivas ativas',0),(418209,11617,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ñ‹',0),(418210,11617,'es','Prospectos Activos',0),(418211,11617,'de','Aktive Interessenten',0),(418212,11617,'en','Active Prospects',0),(418213,11618,'is','',0),(418214,11618,'dr','Ø¹Ø±Ø¨ÙŠ',0),(418215,11618,'pr','Ø¹Ø±Ø¨ÙŠ',0),(418216,11618,'tr','AR',0),(418217,11618,'pl','AR',0),(418218,11618,'bg','AR',0),(418219,11618,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚',0),(418220,11618,'sr','ÐÐ ',0),(418221,11618,'vi','AR',0),(418222,11618,'af','AR',0),(418223,11618,'ro','AR',0),(418224,11618,'et','AR',0),(418225,11618,'si','AR',0),(418226,11618,'ba','AR',0),(418227,11618,'nl','AR',0),(418228,11618,'fi','AR',0),(418229,11618,'no','AR',0),(418230,11618,'da','AR',0),(418231,11618,'ko','ì•„ì¹¸ì†Œ',0),(418232,11618,'he','AR',0),(418233,11618,'el','AR',0),(418234,11618,'zh','é“\r\n',0),(418235,11618,'sv','AR',0),(418236,11618,'it','AR',0),(418237,11618,'tl','',0),(418238,11618,'th','AR',0),(418239,11618,'hi','à¤. à¤†à¤°.',0),(418240,11618,'ms','AR',0),(418241,11618,'ar','AR',0),(418242,11618,'fr','AR',0),(418243,11618,'jp','AR',0),(418244,11618,'pt','AR',0),(418245,11618,'ru','AR',0),(418246,11618,'es','CC',0),(418247,11618,'de','AR',0),(418248,11618,'en','AR',0),(418249,11619,'is','',0),(418250,11619,'dr','ØªØ§Ø²Ù‡ Ø§Ø³Ø¨Ø§Ø¨ Ú©Ø´Ù‰ Ø¬Ø¯ÙŠØ¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(418251,11619,'pr','ØªØ§Ø²Ù‡ Ø§Ø³Ø¨Ø§Ø¨ Ú©Ø´Ù‰ Ø¬Ø¯ÙŠØ¯ÙŠ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯ ',0),(418252,11619,'tr','HiÃ§bir hareket eklentileri bulundu',0),(418253,11619,'pl','Znalezione nie przenieÅ›Ä‡ pluginy',0),(418254,11619,'bg','ÐÑÐ¼Ð° Ñ…Ð¾Ð´ Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(418255,11619,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ù‚Ø¯Ø§Ù… Ù¾Ø§ÛŒØ§ Ø¬Ø§Øª',0),(418256,11619,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ‚ÐµÐ· Ð´Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð½Ð°ÑˆÐ°Ð¾',0),(418257,11619,'vi','KhÃ´ng cÃ³ di chuyá»ƒn-in tÃ¬m tháº¥y',0),(418258,11619,'af','Geen skuif-ins gevind',0),(418259,11619,'ro','Nici o mutare-uri gÄƒsite',0),(418260,11619,'et','Ei liiguta-ins leitud',0),(418261,11619,'si','Premakni-ins naÅ¡el',0),(418262,11619,'ba','Tidak bergerak-ins ditemukan',0),(418263,11619,'nl','Geen beweging-ins gevonden',0),(418264,11619,'fi','MitÃ¤Ã¤n liikkua-laajennuksia ei lÃ¶ytynyt',0),(418265,11619,'no','Ingen trekk-ins funnet',0),(418266,11619,'da','Ingen flytte-ins fundet',0),(418267,11619,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ì´ë™ ê¸°ëŠ¥',0),(418268,11619,'he','×œ× × ×ž×¦××• ×ž×”×œ×š-in',0),(418269,11619,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÎºÎ¯Î½Î·ÏƒÎ·-ins',0),(418270,11619,'zh','æ²¡æœ‰è¡ŒåŠ¨çš„æ’ä»¶å‘çŽ°\r\n',0),(418271,11619,'sv','Inte flytta-ins hittade',0),(418272,11619,'it','No trovato Move-in',0),(418273,11619,'tl','',0),(418274,11619,'th','à¸¢à¹‰à¸²à¸¢à¹„à¸¡à¹ˆà¸­à¸´à¸™à¸žà¸š',0),(418275,11619,'hi','à¤•à¥‹à¤ˆ à¤šà¤¾à¤²-ins à¤ªà¤¾à¤¯à¤¾',0),(418276,11619,'ms','Tiada langkah masuk mendapati',0),(418277,11619,'ar','Ù„Ø§ Ù†Ù‚Ù„ Ø§Ù„ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ© ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(418278,11619,'fr','Pas trouvÃ© de Move-ins',0),(418279,11619,'jp','ãªã„ç§»å‹•ã‚¢ãƒ‰ã‚¤ãƒ³ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(418280,11619,'pt','Nenhum movimento-ins encontrados',0),(418281,11619,'ru','ÐÐµ Ð´Ð²Ð¸Ð³Ð°Ñ‚ÑŒÑÑ ÑÐ¸Ð½ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(418282,11619,'es','No Se Encuentra Move-Ins',0),(418283,11619,'de','Keine Move-ins gefunden',0),(418284,11619,'en','No Move-ins Found',0),(418285,11620,'is','',0),(418286,11620,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ø¨Ø§Ø²',0),(418287,11620,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ø¨Ø§Ø²',0),(418288,11620,'tr','AÃ§Ä±k bakÄ±m istekleri',0),(418289,11620,'pl','Utrzymania otwartych Å¼Ä…daÅ„',0),(418290,11620,'bg','ÐžÑ‚Ð²Ð¾Ñ€Ð¸ Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð¸ÑÐºÐ°Ð½Ð¸ÑÑ‚Ð°',0),(418291,11620,'ur','Ú©Ú¾Ù„Ø§ Ø¯ÛŒÚ©Ú¾ Ø¨Ú¾Ø§Ù„ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(418292,11620,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð¸ Ð·Ð° Ð¾Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐ°',0),(418293,11620,'vi','YÃªu cáº§u má»Ÿ báº£o trÃ¬',0),(418294,11620,'af','Oop onderhoud versoeke',0),(418295,11620,'ro','Cereri deschise de Ã®ntreÅ£inere',0),(418296,11620,'et','Avatud hooldus taotlused',0),(418297,11620,'si','Plan vzdrÅ¾evanja zahteve',0),(418298,11620,'ba','Buka pemeliharaan permintaan',0),(418299,11620,'nl','Open onderhoud aanvragen',0),(418300,11620,'fi','Auki huolto pyynnÃ¶t',0),(418301,11620,'no','Ã…pne vedlikehold-forespÃ¸rsler',0),(418302,11620,'da','Ã…ben vedligeholdelse anmodninger',0),(418303,11620,'ko','ì˜¤í”ˆ ìœ ì§€ ë³´ìˆ˜ ìš”ì²­',0),(418304,11620,'he','×ª×—×–×•×§×” ×¤×ª×•×—×” ×œ×‘×§×©×•×ª',0),(418305,11620,'el','ÎŸÎ¹ Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ Î±Î½Î¿Î¹ÎºÏ„Î® ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ·',0),(418306,11620,'zh','æ‰“å¼€ç»´ä¿®è¦æ±‚\r\n',0),(418307,11620,'sv','Ã–ppna underhÃ¥ll begÃ¤randen',0),(418308,11620,'it','Richieste di manutenzione aperta',0),(418309,11620,'tl','',0),(418310,11620,'th','à¸„à¸³à¸‚à¸­à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²à¹€à¸›à¸´à¸”',0),(418311,11620,'hi','à¤–à¥à¤²à¤¾ à¤°à¤–à¤°à¤–à¤¾à¤µ à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚',0),(418312,11620,'ms','Permohonan terbuka penyelenggaraan',0),(418313,11620,'ar','Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØµÙŠØ§Ù†Ø© Ù…ÙØªÙˆØ­Ø©',0),(418314,11620,'fr','Demandes de Maintenance ouvert',0),(418315,11620,'jp','é–‹ã„ã¦ã„ã‚‹ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹è¦æ±‚',0),(418316,11620,'pt','SolicitaÃ§Ãµes de manutenÃ§Ã£o aberto',0),(418317,11620,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÑ‹',0),(418318,11620,'es','Solicitudes de Mantenimiento Abiertos',0),(418319,11620,'de','Offene Wartung Anforderungen',0),(418320,11620,'en','Open Maintenance Requests',0),(418321,11621,'is','',0),(418322,11621,'dr','Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª Ø¬Ø¯ÙŠØ¯',0),(418323,11621,'pr','Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª Ø¬Ø¯ÙŠØ¯',0),(418324,11621,'tr','Son iletiÅŸim',0),(418325,11621,'pl','Najnowsze komunikaty',0),(418326,11621,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(418327,11621,'ur','Ø­Ø§Ù„ÛŒÛ Ù…ÙˆØ§ØµÙ„Ø§Øª',0),(418328,11621,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ ÐºÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(418329,11621,'vi','Táº¡i truyá»n thÃ´ng',0),(418330,11621,'af','Onlangse kommunikasie',0),(418331,11621,'ro','Recente',0),(418332,11621,'et','Hiljutisi teatisi',0),(418333,11621,'si','Zadnjih komunikacijah.',0),(418334,11621,'ba','Komunikasi hari',0),(418335,11621,'nl','Meest recente communicatie',0),(418336,11621,'fi','ViimeisimmÃ¤ssÃ¤',0),(418337,11621,'no','Siste kommunikasjon',0),(418338,11621,'da','Seneste kommunikationshandlinger',0),(418339,11621,'ko','ìµœê·¼ í†µì‹ ',0),(418340,11621,'he','×ª×§×©×•×¨×ª ×œ××—×¨×•× ×”',0),(418341,11621,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Î±Î½Î±ÎºÎ¿Î¹Î½ÏŽÏƒÎµÎ¹Ï‚',0),(418342,11621,'zh','è¿‘æœŸé€šä¿¡\r\n',0),(418343,11621,'sv','Senaste kommunikation',0),(418344,11621,'it','Comunicazioni recenti',0),(418345,11621,'tl','',0),(418346,11621,'th','à¸à¸²à¸£à¸ªà¸·à¹ˆà¸­à¸ªà¸²à¸£à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(418347,11621,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤¸à¤‚à¤šà¤¾à¤°',0),(418348,11621,'ms','Hari komunikasi',0),(418349,11621,'ar','Ø§Ù„Ø§ØªØµØ§Ù„Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(418350,11621,'fr','Communications rÃ©centes',0),(418351,11621,'jp','æœ€è¿‘é€šä¿¡',0),(418352,11621,'pt','ComunicaÃ§Ãµes recentes',0),(418353,11621,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(418354,11621,'es','Comunicaciones Recientes',0),(418355,11621,'de','JÃ¼ngsten Mitteilungen',0),(418356,11621,'en','Recent Communications',0),(418357,11622,'is','',0),(418358,11622,'dr','Ø§Ø«Ø§Ø«Ù‡ Ùˆ Ù…ÙŠØ²Ø§Ù† ÙƒØ§Ø±Ø¢Ø±Ø§ÙŠÙŠ Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ø²Ø¯ÙŠÙƒ ',0),(418359,11622,'pr','Ø§Ø«Ø§Ø«Ù‡ Ùˆ Ù…ÙŠØ²Ø§Ù† ÙƒØ§Ø±Ø¢Ø±Ø§ÙŠÙŠ Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ø²Ø¯ÙŠÙƒ ',0),(418360,11622,'tr','YaklaÅŸan randevularÄ± & gÃ¶sterimleri',0),(418361,11622,'pl','NadchodzÄ…ce terminy & pokazy',0),(418362,11622,'bg','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸ ÑÑ€ÐµÑ‰Ð¸ & Ð¿Ñ€Ð¾Ð¶ÐµÐºÑ†Ð¸Ð¸',0),(418363,11622,'ur','Ø¢Ø¦Ù†Ø¯Û Ù…Ù„Ø§Ù‚Ø§ØªÙˆÚº & Ø´ÙˆØ²',0),(418364,11622,'sr','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ ÑÐ°ÑÑ‚Ð°Ð½Ñ†Ð¸ & ÐµÐ¼Ð¸Ñ‚Ð¾Ð²Ð°ÑšÐ°',0),(418365,11622,'vi','Sáº¯p tá»›i cuá»™c háº¹n &amp; Showings',0),(418366,11622,'af','Opkomende Afsprake en Skouhuise',0),(418367,11622,'ro','Viitoarele numiri & proiecÅ£ii',0),(418368,11622,'et','Eelseisvad kohtumised & nÃ¤itamise',0),(418369,11622,'si','PrihajajoÄe sestanke & predstavah',0),(418370,11622,'ba','Mendatang janji & pertunjukan',0),(418371,11622,'nl','Aankomende afspraken & voorstellingen',0),(418372,11622,'fi','Tulevat tapaamiset & osoituksia',0),(418373,11622,'no','Kommende avtaler & visninger',0),(418374,11622,'da','Kommende aftaler & fremvisninger',0),(418375,11622,'ko','ì•½ì† & ìƒì˜',0),(418376,11622,'he','×¤×’×™×©×•×ª ×¢×ª×™×“×™×•×ª & ×©×™×“×•×¨×™×',0),(418377,11622,'el','Î•Ï€ÎµÏÏ‡ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÏƒÏ…Î½Î±Î½Ï„Î®ÏƒÎµÎ¹Ï‚ & Ï€ÏÎ¿Î²Î¿Î»Î­Ï‚',0),(418378,11622,'zh','å³å°†åˆ°æ¥çš„çº¦ä¼šå’Œçœ‹æˆ¿\r\n',0),(418379,11622,'sv','Kommande mÃ¶ten & visningar',0),(418380,11622,'it','Appuntamenti imminenti & proiezioni',0),(418381,11622,'tl','',0),(418382,11622,'th','à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¹€à¸à¸´à¸”à¸‚à¸¶à¹‰à¸™ & à¹à¸ªà¸”à¸‡',0),(418383,11622,'hi','à¤†à¤—à¤¾à¤®à¥€ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ & à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨à¤¿à¤¯à¥‹à¤‚',0),(418384,11622,'ms','Temujanji akan datang & Showings',0),(418385,11622,'ar','Ø§Ù„Ù…ÙˆØ§Ø¹ÙŠØ¯ Ø§Ù„Ù‚Ø§Ø¯Ù…Ø© Ø¢Ù†Ø¯ Ø¹Ø±ÙˆØ¶',0),(418386,11622,'fr','Rendez-vous Ã  venir & indices',0),(418387,11622,'jp','ä»Šå¾Œã®äºˆå®š & ä¸Šæ˜ ',0),(418388,11622,'pt','Compromissos futuros & exibiÃ§Ãµes',0),(418389,11622,'ru','ÐŸÑ€Ð¸Ð±Ð»Ð¸Ð¶Ð°ÑŽÑ‰Ð¸ÐµÑÑ Ð’ÑÑ‚Ñ€ÐµÑ‡Ð¸ Ð¸ ÐŸÐ¾ÐºÐ°Ð·Ñ‹',0),(418390,11622,'es','PrÃ³ximas Citas',0),(418391,11622,'de','Bevorstehende Termine & VorfÃ¼hrungen',0),(418392,11622,'en','Upcoming Appointments & Showings',0),(418393,11623,'is','',0),(418394,11623,'dr','Ø§Ù†Ù‚Ø¶Ø§Ù‡Ø§ÙŠ Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ø²Ø¯ÙŠÙƒ ',0),(418395,11623,'pr','Ø§Ù†Ù‚Ø¶Ø§Ù‡Ø§ÙŠ Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ø²Ø¯ÙŠÙƒ ',0),(418396,11623,'tr','YaklaÅŸan sona erme kurallarÄ±',0),(418397,11623,'pl','NadchodzÄ…ce wygasania',0),(418398,11623,'bg','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸ Expirations',0),(418399,11623,'ur','Ø§Ù†Û’ ÙˆØ§Ù„Û’ Ù¾Ø§Ø±Ø§Ù¹Ø§Ù†Ø³',0),(418400,11623,'sr','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ Ð•xÐ¿Ð¸Ñ€Ð°Ñ‚Ð¸Ð¾Ð½Ñ',0),(418401,11623,'vi','Sáº¯p tá»›i háº¿t háº¡n',0),(418402,11623,'af','Opkomende Vervallings',0),(418403,11623,'ro','ExpirÄƒri viitoare',0),(418404,11623,'et','Tulevased Expirations',0),(418405,11623,'si','PrihajajoÄi izteku roka',0),(418406,11623,'ba','Expirations mendatang',0),(418407,11623,'nl','Aanstaande vervaldatums',0),(418408,11623,'fi','Tuleva vanhenemista',0),(418409,11623,'no','Kommende utlÃ¸per',0),(418410,11623,'da','Kommende afvisninger',0),(418411,11623,'ko','ê³§ ë§Œë£Œ',0),(418412,11623,'he','×”×§×¨×•×‘×” ×ª×¤×•×’×•×ª',0),(418413,11623,'el','Î›Î®Î³ÎµÎ¹ Î· ÎµÏ€ÎµÏÏ‡ÏŒÎ¼ÎµÎ½Î·',0),(418414,11623,'zh','å³å°†è¿‡æœŸ\r\n',0),(418415,11623,'sv','Kommande utgÃ¥ngsdatum',0),(418416,11623,'it','Scadenze imminenti',0),(418417,11623,'tl','',0),(418418,11623,'th','à¸à¸³à¸¥à¸±à¸‡à¸ˆà¸°à¸«à¸¡à¸”',0),(418419,11623,'hi','à¤†à¤—à¤¾à¤®à¥€ à¤¨à¤¿à¤¶à¥à¤µà¤¾à¤¸à¤¿à¤¤',0),(418420,11623,'ms','Penutupan akan datang',0),(418421,11623,'ar','Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„Ù…Ù‚Ø¨Ù„',0),(418422,11623,'fr','Expirations Ã  venir',0),(418423,11623,'jp','æœŸé™åˆ‡ã‚ŒãŒé–“è¿‘',0),(418424,11623,'pt','PrÃ³ximas expiraÃ§Ãµes',0),(418425,11623,'ru','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸Ðµ Ð¸ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ðµ ÑÑ€Ð¾ÐºÐ°',0),(418426,11623,'es','PrÃ³ximas Expiraciones',0),(418427,11623,'de','Bevorstehende Ablaufzeiten',0),(418428,11623,'en','Upcoming Expirations',0),(418429,11624,'is','',0),(418430,11624,'dr','(Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ) Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ø²Ø¯ÙŠÙƒ',0),(418431,11624,'pr','ÙˆØ±ÙˆØ¯ÙŠ Ù‡Ø§ÙŠ(Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ) Ø¢ÙŠÙ†Ø¯Ù‡ Ù†Ø²Ø¯ÙŠÙƒ',0),(418432,11624,'tr','YaklaÅŸan hareket Ins',0),(418433,11624,'pl','Ruch nadchodzÄ…cych Ins',0),(418434,11624,'bg','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¾Ñ‚Ð¾ Ð´Ð²Ð¸Ð¶ÐµÐ½Ð¸Ðµ Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(418435,11624,'ur','Ø§Ù†Û’ ÙˆØ§Ù„Û’ Ø§Ù‚Ø¯Ø§Ù… Ø¬Ø§Øª',0),(418436,11624,'sr','Ð”Ð¾Ð´Ð°Ñ†Ð¸ Ð·Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð¿Ð¾Ñ‚ÐµÐ·',0),(418437,11624,'vi','Sáº¯p tá»›i di chuyá»ƒn in',0),(418438,11624,'af','Opkomende In Besit neem',0),(418439,11624,'ro','Viitoarea mutare Ins',0),(418440,11624,'et','Kolimisest Ins',0),(418441,11624,'si','PrihajajoÄi prehod Ins',0),(418442,11624,'ba','Yang akan datang pindah Ins',0),(418443,11624,'nl','Aanstaande verhuizing Ins',0),(418444,11624,'fi','Tuleva liikkua Ins',0),(418445,11624,'no','Kommende flytte moduler',0),(418446,11624,'da','Kommende flytte Ins',0),(418447,11624,'ko','ê³§ ì´ë™ ê¸°ëŠ¥',0),(418448,11624,'he','×ª×•×¡×¤×•×ª ×”×¢×‘×¨ ×”×§×¨×•×‘',0),(418449,11624,'el','Î•Ï€ÎµÏÏ‡ÏŒÎ¼ÎµÎ½Î· ÎºÎ¯Î½Î·ÏƒÎ· Ins',0),(418450,11624,'zh','å³å°†åˆ°æ¥çš„ç§»åŠ¨å®\r\n',0),(418451,11624,'sv','Kommande flytta Ins',0),(418452,11624,'it','Prossima mossa Ins',0),(418453,11624,'tl','',0),(418454,11624,'th','à¸­à¸´à¸™à¸à¸³à¸¥à¸±à¸‡à¸ˆà¸°à¸¢à¹‰à¸²à¸¢',0),(418455,11624,'hi','à¤†à¤—à¤¾à¤®à¥€ à¤•à¤¦à¤® à¤­à¤¾à¤°à¤¤à¥€à¤¯ à¤¨à¥Œà¤¸à¥‡à¤¨à¤¾ à¤ªà¥‹à¤¤',0),(418456,11624,'ms','Ins langkah yang akan datang',0),(418457,11624,'ar','Ins Ø§Ù„Ø®Ø·ÙˆØ© Ø§Ù„Ù‚Ø§Ø¯Ù…Ø©',0),(418458,11624,'fr','DÃ©mÃ©nagement Ã  venir Ins',0),(418459,11624,'jp','ä»Šå¾Œã®å‹•ã Ins',0),(418460,11624,'pt','PrÃ³xima jogada Ins',0),(418461,11624,'ru','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸Ðµ Ð¿ÐµÑ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚ÑŒ Ins',0),(418462,11624,'es','PrÃ³ximos Cambios',0),(418463,11624,'de','Bevorstehende Umzug Ins',0),(418464,11624,'en','Upcoming Move Ins',0),(418465,11625,'is','',0),(418466,11625,'dr','Ù†Ù…Ø§ÙŠØ´ Ù¾ÙŠØ´â€ŒØ¨ÙŠÙ†ÙŠ Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„',0),(418467,11625,'pr','Ù†Ù…Ø§ÙŠØ´ Ù¾ÙŠØ´â€ŒØ¨ÙŠÙ†ÙŠ Ù‡Ø§ÙŠ ÙØ¹Ø§Ù„',0),(418468,11625,'tr','GÃ¶rÃ¼nÃ¼m aktif umutlarÄ±',0),(418469,11625,'pl','Widok aktywnych perspektywy',0),(418470,11625,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð°ÐºÑ‚Ð¸Ð²ÐµÐ½ Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ð¸',0),(418471,11625,'ur','Ù…Ù†Ø¸Ø± Ø²ÛŒØ± Ø¹Ù…Ù„ Ø§Ù…Ú©Ø§Ù†Ø§Øª',0),(418472,11625,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸Ñ… Ð¸Ð·Ð³Ð»ÐµÐ´Ðµ',0),(418473,11625,'vi','Xem hoáº¡t Ä‘á»™ng khÃ¡ch hÃ ng tiá»m nÄƒng',0),(418474,11625,'af','Besigtig Aktiewe Voornemende KliÃ«nte',0),(418475,11625,'ro','Vezi activi de perspectivele',0),(418476,11625,'et','Kuva aktiivne vÃ¤ljavaateid',0),(418477,11625,'si','Aktivni pogled moÅ¾nosti',0),(418478,11625,'ba','Lihat aktif prospek',0),(418479,11625,'nl','Weergave actieve vooruitzichten',0),(418480,11625,'fi','NÃ¤ytÃ¤ aktiivinen prospektit',0),(418481,11625,'no','Vis aktive prospekter',0),(418482,11625,'da','Se aktive perspektiver',0),(418483,11625,'ko','ë³´ê¸° í™œì„±í™” ì „ë§',0),(418484,11625,'he','×”×ª×¦×•×’×” ×”×¤×¢×™×œ×” ×œ×§×•×—×•×ª ×¤×•×˜× ×¦×™××œ×™×™×',0),(418485,11625,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎµÎ½ÎµÏÎ³Î¿Ï Ï€ÏÎ¿Î¿Ï€Ï„Î¹ÎºÎ­Ï‚',0),(418486,11625,'zh','æŸ¥çœ‹æ´»è·ƒçš„å‰æ™¯\r\n',0),(418487,11625,'sv','Visa aktiva framtidsutsikter',0),(418488,11625,'it','Vista attivo prospettive',0),(418489,11625,'tl','',0),(418490,11625,'th','à¸”à¸¹à¹à¸™à¸§à¹‚à¸™à¹‰à¸¡à¸‡à¸²à¸™',0),(418491,11625,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤¸à¤‚à¤­à¤¾à¤µà¤¨à¤¾à¤“à¤‚',0),(418492,11625,'ms','Paparan aktif prospek',0),(418493,11625,'ar','Ø¹Ø±Ø¶ Ø¢ÙØ§Ù‚ Ø§Ù„Ù†Ø´Ø·Ø©',0),(418494,11625,'fr','Vue Active Prospects',0),(418495,11625,'jp','ãƒ“ãƒ¥ãƒ¼ã®ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªè¦‹é€šã—',0),(418496,11625,'pt','Modo de exibiÃ§Ã£o ativo perspectivas',0),(418497,11625,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ñ… Ð¿ÐµÑ€ÑÐ¿ÐµÐºÑ‚Ð¸Ð²Ñ‹',0),(418498,11625,'es','Vea Prospectos Activos',0),(418499,11625,'de','Ansicht aktive Interessenten',0),(418500,11625,'en','View Active Prospects',0),(418501,11626,'is','',0),(418502,11626,'dr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø«Ø§Ø«Ù‡',0),(418503,11626,'pr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø«Ø§Ø«Ù‡',0),(418504,11626,'tr','GÃ¶rÃ¼nÃ¼m randevular',0),(418505,11626,'pl','Zobacz terminy',0),(418506,11626,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÑÑ€ÐµÑ‰Ð¸',0),(418507,11626,'ur','Ù…Ù†Ø¸Ø± ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª',0),(418508,11626,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ð¸Ñ… Ð¾Ð±Ð°Ð²ÐµÐ·Ð°',0),(418509,11626,'vi','Xem cuá»™c háº¹n',0),(418510,11626,'af','Besigtig Afsprake',0),(418511,11626,'ro','Vezi numiri',0),(418512,11626,'et','Vaata kohtumised',0),(418513,11626,'si','Pogled sestanki',0),(418514,11626,'ba','Lihat janji',0),(418515,11626,'nl','Weergave afspraken',0),(418516,11626,'fi','Tapaamisten jÃ¤rjestys',0),(418517,11626,'no','Vis avtaler',0),(418518,11626,'da','Se aftaler',0),(418519,11626,'ko','ë³´ê¸° ì•½ì†',0),(418520,11626,'he','×ª×¦×•×’×ª ×¤×¢×™×œ×•×™×•×ª',0),(418521,11626,'el','Î ÏÎ¿Î²Î¿Î»Î® ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(418522,11626,'zh','æŸ¥çœ‹çº¦ä¼š\r\n',0),(418523,11626,'sv','Visa avtalade tider',0),(418524,11626,'it','Visualizzazione appuntamenti',0),(418525,11626,'tl','',0),(418526,11626,'th','à¸”à¸¹à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(418527,11626,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿà¥à¤¸',0),(418528,11626,'ms','Lihat janji temu',0),(418529,11626,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…ÙˆØ§Ø¹ÙŠØ¯',0),(418530,11626,'fr','Vue nominations',0),(418531,11626,'jp','äºˆå®šã®è¡¨ç¤º',0),(418532,11626,'pt','Vista compromissos',0),(418533,11626,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ð¹',0),(418534,11626,'es','Vea Citas',0),(418535,11626,'de','Anzeigen-Termine',0),(418536,11626,'en','View Appointments',0),(418537,11627,'is','',0),(418538,11627,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…ÙŠØ²Ø§Ù† Ø¯Ø³ØªØ±Ø³Ù‰',0),(418539,11627,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…ÙŠØ²Ø§Ù† Ø¯Ø³ØªØ±Ø³Ù‰',0),(418540,11627,'tr','KullanÄ±labilirliÄŸi GÃ¶rÃ¼ntÃ¼le',0),(418541,11627,'pl','Zobacz dostÄ™pnoÅ›Ä‡',0),(418542,11627,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð·Ð°ÐµÑ‚Ð¾ÑÑ‚Ñ‚Ð°',0),(418543,11627,'ur','Ù…Ù†Ø¸Ø± Ú©ÛŒ Ø¯Ø³ØªÛŒØ§Ø¨ÛŒ',0),(418544,11627,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¾ÑÑ‚Ð¸',0),(418545,11627,'vi','Xem tÃ­nh kháº£ dá»¥ng',0),(418546,11627,'af','Besigtig Beskikbaarheid',0),(418547,11627,'ro','Vezi disponibilitatea',0),(418548,11627,'et','Vaate kÃ¤ttesaadavuse',0),(418549,11627,'si','Pogled razpoloÅ¾ljivosti',0),(418550,11627,'ba','Lihat ketersediaan',0),(418551,11627,'nl','Beschikbaarheid weergeven',0),(418552,11627,'fi','NÃ¤ytÃ¤ kÃ¤ytettÃ¤vyys',0),(418553,11627,'no','Vis tilgjengelighet',0),(418554,11627,'da','Vis tilgÃ¦ngelighed',0),(418555,11627,'ko','ë³´ê¸° ì—¬ë¶€',0),(418556,11627,'he','×”×¦×’×ª ×–×ž×™× ×•×ª',0),(418557,11627,'el','Î ÏÎ¿Î²Î¿Î»Î® Î´Î¹Î±Î¸ÎµÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î±Ï‚',0),(418558,11627,'zh','æŸ¥çœ‹çŠ¶æ€\r\n',0),(418559,11627,'sv','Visa tillgÃ¤nglighet',0),(418560,11627,'it','Visualizza disponibilitÃ ',0),(418561,11627,'tl','',0),(418562,11627,'th','à¸”à¸¹à¸„à¸§à¸²à¸¡à¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(418563,11627,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§à¤¤à¤¾ à¤¦à¥‡à¤–à¥‡à¤‚',0),(418564,11627,'ms','Lihat ketersediaan',0),(418565,11627,'ar','ØªÙˆÙØ± Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¹Ø±Ø¶',0),(418566,11627,'fr','Vue disponibilitÃ©',0),(418567,11627,'jp','ãƒ“ãƒ¥ãƒ¼ã®å¯ç”¨æ€§',0),(418568,11627,'pt','Ver a disponibilidade',0),(418569,11627,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ÑÑ‚Ð¸',0),(418570,11627,'es','Vea Disponibilidad',0),(418571,11627,'de','VerfÃ¼gbarkeit anzeigen',0),(418572,11627,'en','View Availability',0),(418573,11628,'is','',0),(418574,11628,'dr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª ',0),(418575,11628,'pr','Ù†Ù…Ø§ÙŠØ´ Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª ',0),(418576,11628,'tr','GÃ¶rÃ¼nÃ¼m iletiÅŸim',0),(418577,11628,'pl','Widok komunikacji',0),(418578,11628,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(418579,11628,'ur','Ù…Ù†Ø¸Ø± Ù…ÙˆØ§ØµÙ„Ø§Øª',0),(418580,11628,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐºÐ¾Ð¼ÑƒÐ½Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(418581,11628,'vi','Xem thÃ´ng tin liÃªn láº¡c',0),(418582,11628,'af','Besigtig Gesprekke',0),(418583,11628,'ro','Vezi de comunicaÅ£ii',0),(418584,11628,'et','Kuva teatised',0),(418585,11628,'si','Pogled komunikacije',0),(418586,11628,'ba','Lihat komunikasi',0),(418587,11628,'nl','Weergave communicatie',0),(418588,11628,'fi','Katso viestinnÃ¤n',0),(418589,11628,'no','Vis kommunikasjon',0),(418590,11628,'da','Se kommunikation',0),(418591,11628,'ko','ë³´ê¸° í†µì‹ ',0),(418592,11628,'he','× ×•×£ ×”×ª×§×©×•×¨×ª',0),(418593,11628,'el','Î†Ï€Î¿ÏˆÎ· ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÏŽÎ½',0),(418594,11628,'zh','æŸ¥çœ‹é€šä¿¡\r\n',0),(418595,11628,'sv','Visa kommunikation',0),(418596,11628,'it','Vista Communications',0),(418597,11628,'tl','',0),(418598,11628,'th','à¸ªà¸·à¹ˆà¸­à¸ªà¸²à¸£à¸”à¸¹',0),(418599,11628,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¸à¤‚à¤šà¤¾à¤°',0),(418600,11628,'ms','Paparan komunikasi',0),(418601,11628,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø§ØªØµØ§Ù„Ø§Øª',0),(418602,11628,'fr','Vue Communications',0),(418603,11628,'jp','ãƒ“ãƒ¥ãƒ¼ã®é€šä¿¡',0),(418604,11628,'pt','Ver comunicaÃ§Ãµes',0),(418605,11628,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹',0),(418606,11628,'es','Visionar Comunicaciones',0),(418607,11628,'de','Ansicht Communications',0),(418608,11628,'en','View Communications',0),(418609,11629,'is','',0),(418610,11629,'dr','Ù†Ù…Ø§ÙŠØ´ Ø§Ù†Ù‚Ø¶Ø§Ø¡ Ù‡Ø§',0),(418611,11629,'pr','Ù†Ù…Ø§ÙŠØ´ Ø§Ù†Ù‚Ø¶Ø§Ø¡ Ù‡Ø§',0),(418612,11629,'tr','GÃ¶rÃ¼nÃ¼m sona erme kurallarÄ±',0),(418613,11629,'pl','Widok wygasania',0),(418614,11629,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Expirations',0),(418615,11629,'ur','Ù…Ù†Ø¸Ø± Ù¾Ø§Ø±Ø§Ù¹Ø§Ù†Ø³',0),(418616,11629,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð•xÐ¿Ð¸Ñ€Ð°Ñ‚Ð¸Ð¾Ð½Ñ',0),(418617,11629,'vi','Xem háº¿t háº¡n',0),(418618,11629,'af','Besigtig Verstrykings',0),(418619,11629,'ro','Vezi expirÄƒrile',0),(418620,11629,'et','Vaade Expirations',0),(418621,11629,'si','Izteku roka pogled',0),(418622,11629,'ba','Lihat Expirations',0),(418623,11629,'nl','Weergave verloopt',0),(418624,11629,'fi','Katso vanhenemista',0),(418625,11629,'no','Vis utlÃ¸per',0),(418626,11629,'da','Se afvisninger',0),(418627,11629,'ko','ë³´ê¸° ë§Œë£Œ',0),(418628,11629,'he','×ª×¦×•×’×ª ×ª×¤×•×’×•×ª',0),(418629,11629,'el','Î›Î®Î³ÎµÎ¹ Î· Î¬Ï€Î¿ÏˆÎ·',0),(418630,11629,'zh','æŸ¥çœ‹åˆ°æœŸæ—¶é—´\r\n',0),(418631,11629,'sv','Visa fÃ¶rfallodagar',0),(418632,11629,'it','Visualizzazione scadenze',0),(418633,11629,'tl','',0),(418634,11629,'th','à¸”à¸¹à¸«à¸¡à¸”',0),(418635,11629,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¨à¤¿à¤¶à¥à¤µà¤¾à¤¸à¤¿à¤¤',0),(418636,11629,'ms','Penutupan View',0),(418637,11629,'ar','Ø¹Ø±Ø¶ ØªÙˆØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ ØµÙ„Ø§Ø­ÙŠØ©',0),(418638,11629,'fr','Vue Expirations',0),(418639,11629,'jp','ãƒ“ãƒ¥ãƒ¼ã®æœ‰åŠ¹æœŸé™',0),(418640,11629,'pt','ExpiraÃ§Ãµes de exibiÃ§Ã£o',0),(418641,11629,'ru','Ð˜ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ðµ ÑÑ€Ð¾ÐºÐ° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(418642,11629,'es','Visionar Expiractiones',0),(418643,11629,'de','Ansicht Ablaufzeiten',0),(418644,11629,'en','View Expirations',0),(418645,11630,'is','',0),(418646,11630,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ ØªØ¹Ù…ÙŠØ± Ùˆ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ ',0),(418647,11630,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ ØªØ¹Ù…ÙŠØ± Ùˆ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ ',0),(418648,11630,'tr','GÃ¶rÃ¼nÃ¼m bakÄ±m istekleri',0),(418649,11630,'pl','Å»Ä…dania widoku konserwacji',0),(418650,11630,'bg','ÐŸÐ¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð¸ÑÐºÐ°Ð½Ð¸Ñ',0),(418651,11630,'ur','Ù…Ù†Ø¸Ø± Ø¯ÛŒÚ©Ú¾ Ø¨Ú¾Ø§Ù„ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(418652,11630,'sr','ÐŸÐ¾Ð·Ð¸Ð²Ðµ Ð·Ð° Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°',0),(418653,11630,'vi','Xem báº£o trÃ¬ yÃªu cáº§u',0),(418654,11630,'af','Besigtig Instandhoudingsversoeke',0),(418655,11630,'ro','Cereri de Ã®ntreÅ£inere Vezi',0),(418656,11630,'et','Vaade hooldus taotlused',0),(418657,11630,'si','Zahteve za vzdrÅ¾evanje pogled',0),(418658,11630,'ba','Lihat pemeliharaan permintaan',0),(418659,11630,'nl','Bekijk onderhoud verzoeken',0),(418660,11630,'fi','Huolto pyynnÃ¶t',0),(418661,11630,'no','Vis vedlikehold forespÃ¸rsler',0),(418662,11630,'da','Se vedligeholdelse anmodninger',0),(418663,11630,'ko','ë³´ê¸° ìœ ì§€ ë³´ìˆ˜ ìš”ì²­',0),(418664,11630,'he','×‘×§×©×•×ª ×ª×—×–×•×§×” × ×•×£',0),(418665,11630,'el','Î‘Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ·Ï‚ Î¸Î­Î±',0),(418666,11630,'zh','æŸ¥çœ‹ç»´ä¿®è¦æ±‚\r\n',0),(418667,11630,'sv','Visa underhÃ¥ll begÃ¤randen',0),(418668,11630,'it','Vista le richieste di manutenzione',0),(418669,11630,'tl','',0),(418670,11630,'th','à¸”à¸¹à¸„à¸³à¸‚à¸­à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²',0),(418671,11630,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤°à¤–à¤°à¤–à¤¾à¤µ à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚',0),(418672,11630,'ms','Permohonan penyelenggaraan paparan',0),(418673,11630,'ar','Ø¹Ø±Ø¶ Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØµÙŠØ§Ù†Ø©',0),(418674,11630,'fr','Voir les demandes de Maintenance',0),(418675,11630,'jp','ãƒ“ãƒ¥ãƒ¼ã®ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹ ãƒªã‚¯ã‚¨ã‚¹ãƒˆ',0),(418676,11630,'pt','Exibir solicitaÃ§Ãµes de manutenÃ§Ã£o',0),(418677,11630,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð²',0),(418678,11630,'es','Visionar Solicitudes de Mantenimiento',0),(418679,11630,'de','Ansicht-Wartung-Anforderungen',0),(418680,11630,'en','View Maintenance Requests',0),(418681,11631,'is','',0),(418682,11631,'dr','(Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ Ù‡Ø§',0),(418683,11631,'pr','Ù†Ù…Ø§ÙŠØ´ ÙˆØ±ÙˆØ¯ÙŠ Ù‡Ø§(Ø§Ø³Ø¨Ø§Ø¨ ÙƒØ´ÙŠ Ù‡Ø§',0),(418684,11631,'tr','GÃ¶rÃ¼nÃ¼m hareket Ins',0),(418685,11631,'pl','Widok ruch Ins',0),(418686,11631,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ñ…Ð¾Ð´ Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(418687,11631,'ur','Ù…Ù†Ø¸Ø± Ø§Ù‚Ø¯Ø§Ù… Ø¬Ø§Øª',0),(418688,11631,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ð¾Ñ‚ÐµÐ· Ð´Ð¾Ð´Ð°Ñ†Ð¸',0),(418689,11631,'vi','Xem di chuyá»ƒn bá»• sung',0),(418690,11631,'af','Besigtig Intrekke',0),(418691,11631,'ro','Ins de mutare Vezi',0),(418692,11631,'et','Vaade liikuda Ins',0),(418693,11631,'si','Ins Poglej poteza',0),(418694,11631,'ba','Lihat langkah Ins',0),(418695,11631,'nl','Weergave verplaatsen Ins',0),(418696,11631,'fi','Katso liikkua Ins',0),(418697,11631,'no','Vis flytte moduler',0),(418698,11631,'da','Se flytte Ins',0),(418699,11631,'ko','ë³´ê¸° ì´ë™ ê¸°ëŠ¥',0),(418700,11631,'he','×ª×¦×•×’×ª ×ž×”×œ×š ×”×”×’×™×¨×”',0),(418701,11631,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎºÎ¯Î½Î·ÏƒÎ· Ins',0),(418702,11631,'zh','æŸ¥çœ‹ç§»åŠ¨å®\r\n',0),(418703,11631,'sv','Visa flytta Ins',0),(418704,11631,'it','Vista mossa Ins',0),(418705,11631,'tl','',0),(418706,11631,'th','à¸”à¸¹à¸¢à¹‰à¸²à¸¢à¸­à¸´à¸™',0),(418707,11631,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤•à¤¦à¤® à¤­à¤¾à¤°à¤¤à¥€à¤¯ à¤¨à¥Œà¤¸à¥‡à¤¨à¤¾ à¤ªà¥‹à¤¤',0),(418708,11631,'ms','Lihat langkah Masuk',0),(418709,11631,'ar','Ø¹Ø±Ø¶ Ù†Ù‚Ù„ Ø§Ù„ÙˆØ¸Ø§Ø¦Ù',0),(418710,11631,'fr','Avis dÃ©mÃ©nagement Ins',0),(418711,11631,'jp','ãƒ“ãƒ¥ãƒ¼ã®ç§»å‹•ã‚¢ãƒ‰ã‚¤ãƒ³',0),(418712,11631,'pt','Vista mover Ins',0),(418713,11631,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¿ÐµÑ€ÐµÐ¼ÐµÑÑ‚Ð¸Ñ‚ÑŒ Ins',0),(418714,11631,'es','Visionar Mudanzas',0),(418715,11631,'de','Ansicht verschieben Ins',0),(418716,11631,'en','View Move Ins',0),(418717,11632,'is','',0),(418718,11632,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…ÙŠØ²Ø§Ù† Ø¯Ø³ØªØ±Ø³ÙŠ ',0),(418719,11632,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…ÙŠØ²Ø§Ù† Ø¯Ø³ØªØ±Ø³ÙŠ ',0),(418720,11632,'tr','KullanÄ±labilirliÄŸi GÃ¶rÃ¼ntÃ¼le',0),(418721,11632,'pl','Zobacz dostÄ™pnoÅ›Ä‡',0),(418722,11632,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð·Ð°ÐµÑ‚Ð¾ÑÑ‚Ñ‚Ð°',0),(418723,11632,'ur','Ù…Ù†Ø¸Ø± Ú©ÛŒ Ø¯Ø³ØªÛŒØ§Ø¨ÛŒ',0),(418724,11632,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¾ÑÑ‚Ð¸',0),(418725,11632,'vi','Xem tÃ­nh kháº£ dá»¥ng',0),(418726,11632,'af','Besigtig Beskikbaarheid',0),(418727,11632,'ro','Vezi disponibilitatea',0),(418728,11632,'et','Vaate kÃ¤ttesaadavuse',0),(418729,11632,'si','Pogled razpoloÅ¾ljivosti',0),(418730,11632,'ba','Lihat ketersediaan',0),(418731,11632,'nl','Beschikbaarheid weergeven',0),(418732,11632,'fi','NÃ¤ytÃ¤ kÃ¤ytettÃ¤vyys',0),(418733,11632,'no','Vis tilgjengelighet',0),(418734,11632,'da','Vis tilgÃ¦ngelighed',0),(418735,11632,'ko','ë³´ê¸° ì—¬ë¶€',0),(418736,11632,'he','×”×¦×’×ª ×–×ž×™× ×•×ª',0),(418737,11632,'el','Î ÏÎ¿Î²Î¿Î»Î® Î´Î¹Î±Î¸ÎµÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î±Ï‚',0),(418738,11632,'zh','æŸ¥çœ‹çŠ¶æ€\r\n',0),(418739,11632,'sv','Visa tillgÃ¤nglighet',0),(418740,11632,'it','Visualizza disponibilitÃ ',0),(418741,11632,'tl','',0),(418742,11632,'th','à¸”à¸¹à¸„à¸§à¸²à¸¡à¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(418743,11632,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§à¤¤à¤¾ à¤¦à¥‡à¤–à¥‡à¤‚',0),(418744,11632,'ms','Lihat ketersediaan',0),(418745,11632,'ar','ØªÙˆÙØ± Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¹Ø±Ø¶',0),(418746,11632,'fr','Vue disponibilitÃ©',0),(418747,11632,'jp','ãƒ“ãƒ¥ãƒ¼ã®å¯ç”¨æ€§',0),(418748,11632,'pt','Ver a disponibilidade',0),(418749,11632,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ÑÑ‚Ð¸',0),(418750,11632,'es','Visionar Disponibilidad',0),(418751,11632,'de','VerfÃ¼gbarkeit anzeigen',0),(418752,11632,'en','View Availability',0),(418753,11633,'is','',0),(418754,11633,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ùˆ Ø§Ø³Ù†Ø§Ø¯ Ø±ÙˆØ´Ù‡Ø§ ',0),(418755,11633,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙƒÙ„ÙŠ Ùˆ Ø§Ø³Ù†Ø§Ø¯ Ø±ÙˆØ´Ù‡Ø§ ',0),(418756,11633,'tr','Genel bilgi ve yordamlar belgeler',0),(418757,11633,'pl','OgÃ³lne informacje i dokumenty procedur',0),(418758,11633,'bg','ÐžÐ±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸, Ð¿Ñ€Ð¾Ñ†ÐµÐ´ÑƒÑ€Ð¸',0),(418759,11633,'ur','Ø¬Ù†Ø±Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§ÙˆØ± Ø·Ø±ÛŒÙ‚Û ÛØ§Ø¦Û’ Ú©Ø§Ø± Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(418760,11633,'sr','ÐžÐ¿ÑˆÑ‚Ð¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ´ÑƒÑ€Ðµ',0),(418761,11633,'vi','CÃ¡c chá»©ng tá»« chung vÃ  thá»§ tá»¥c',0),(418762,11633,'af','Algemene inligting en prosedures dokumente',0),(418763,11633,'ro','Informatii generale ÅŸi proceduri de documente',0),(418764,11633,'et','Ãœldinfo ja menetlused dokumentide',0),(418765,11633,'si','SploÅ¡ne informacije in dokumente, postopki',0),(418766,11633,'ba','General Info dan prosedur dokumen',0),(418767,11633,'nl','Algemene informatie en Procedures documenten',0),(418768,11633,'fi','YleistÃ¤ ja menettelyt asiakirjojen',0),(418769,11633,'no','Generell informasjon og prosedyrer dokumenter',0),(418770,11633,'da','General Info og procedurer dokumenter',0),(418771,11633,'ko','ì¼ë°˜ ì •ë³´ ë° ì ˆì°¨ ë¬¸ì„œ',0),(418772,11633,'he','×ž×™×“×¢ ×›×œ×œ×™ ×•×ž×¡×ž×›×™× × ×”×œ×™×',0),(418773,11633,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎºÎ±Î¹ Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯ÎµÏ‚ Î­Î³Î³ÏÎ±Ï†Î±',0),(418774,11633,'zh','ä¸€èˆ¬ä¿¡æ¯å’Œç¨‹åºæ–‡ä»¶\r\n',0),(418775,11633,'sv','AllmÃ¤n information och fÃ¶rfaranden dokument',0),(418776,11633,'it','Informazioni generali e documenti procedure',0),(418777,11633,'tl','',0),(418778,11633,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸±à¹ˆà¸§à¹„à¸›à¹à¸¥à¸°à¹€à¸­à¸à¸ªà¸²à¸£à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™',0),(418779,11633,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤”à¤° à¤•à¤¾à¤°à¥à¤¯à¤µà¤¿à¤§à¤¿à¤¯à¤¾à¤ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚',0),(418780,11633,'ms','Maklumat am dan prosedur-prosedur dokumen',0),(418781,11633,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ø§Ù…Ø© ÙˆÙˆØ«Ø§Ø¦Ù‚ Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª',0),(418782,11633,'fr','Infos gÃ©nÃ©rales et Documents de procÃ©dures',0),(418783,11633,'jp','ä¸€èˆ¬çš„ãªæƒ…å ±ã¨æ‰‹é †æ›¸',0),(418784,11633,'pt','InformaÃ§Ãµes gerais e documentos de procedimentos',0),(418785,11633,'ru','ÐžÐ±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹, Ð¿Ñ€Ð¾Ñ†ÐµÐ´ÑƒÑ€Ñ‹',0),(418786,11633,'es','Documentos de InformaciÃ³n y Procedimientos Generales',0),(418787,11633,'de','Allgemeine Infos und Verfahren Dokumente',0),(418788,11633,'en','General Info And Procedures Documents',0),(418789,11634,'is','',0),(418790,11634,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ Ùˆ Ø§Ø³Ù†Ø§Ø¯ ',0),(418791,11634,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù‡Ø§ Ùˆ Ø§Ø³Ù†Ø§Ø¯ ',0),(418792,11634,'tr','KiralarÄ± ve belgeler',0),(418793,11634,'pl','Leasing i dokumentacji',0),(418794,11634,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ',0),(418795,11634,'ur','Ù„ÙÛŒØ²Ø² Ø§ÙˆØ± Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(418796,11634,'sr','Ð£Ð³Ð¾Ð²Ð¾Ñ€Ð¸ Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ˜Ð°',0),(418797,11634,'vi','há»£p Ä‘á»“ng cho thuÃª vÃ  tÃ i liá»‡u ',0),(418798,11634,'af','Huurkontrakte en Dokumentasie',0),(418799,11634,'ro','Contracte de leasing ÅŸi documentaÅ£ia',0),(418800,11634,'et','Kapitalirent ja dokumentatsioon',0),(418801,11634,'si','Najemi in dokumentacijo',0),(418802,11634,'ba','Pajakan dan dokumentasi',0),(418803,11634,'nl','Lease-overeenkomsten en documentatie',0),(418804,11634,'fi','Vuokrasopimukset ja asiakirjat',0),(418805,11634,'no','Leieavtaler og dokumentasjon',0),(418806,11634,'da','LejemÃ¥l og dokumentation',0),(418807,11634,'ko','ìž„ëŒ€ ë° ë¬¸ì„œ',0),(418808,11634,'he','×—×›×™×¨×” ×•×ª×™×¢×•×“',0),(418809,11634,'el','ÎœÎ¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚ ÎºÎ±Î¹ Ï„ÎµÎºÎ¼Î·ÏÎ¯Ï‰ÏƒÎ·',0),(418810,11634,'zh','ç§Ÿèµå’Œæ–‡ä»¶\r\n',0),(418811,11634,'sv','Hyresavtal och dokumentation',0),(418812,11634,'it','Contratti di locazione e documentazione',0),(418813,11634,'tl','',0),(418814,11634,'th','à¹€à¸Šà¹ˆà¸²à¹à¸¥à¸°à¹€à¸­à¸à¸ªà¸²à¸£',0),(418815,11634,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚ à¤”à¤° à¤ªà¥à¤°à¤²à¥‡à¤–à¤¨',0),(418816,11634,'ms','Pajakan dan dokumentasi',0),(418817,11634,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±Ø§Øª ÙˆØ§Ù„ÙˆØ«Ø§Ø¦Ù‚',0),(418818,11634,'fr','Baux et Documentation',0),(418819,11634,'jp','ãƒªãƒ¼ã‚¹ã¨ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ',0),(418820,11634,'pt','LocaÃ§Ãµes e documentaÃ§Ã£o',0),(418821,11634,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ',0),(418822,11634,'es','Arrendamientos y DocumentaciÃ³n',0),(418823,11634,'de','Leases und Dokumentation',0),(418824,11634,'en','Leases And Documentation',0),(418825,11635,'is','',0),(418826,11635,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± ØªØ¹Ù…ÙŠØ± Ùˆ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ',0),(418827,11635,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ø§Ø®ÙŠØ± ØªØ¹Ù…ÙŠØ± Ùˆ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ',0),(418828,11635,'tr','Son bakÄ±m istekleri',0),(418829,11635,'pl','Ostatnie Å¼Ä…dania obsÅ‚ugi',0),(418830,11635,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¸ÑÐºÐ°Ð½Ð¸Ñ Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(418831,11635,'ur','Ø­Ø§Ù„ÛŒÛ Ø¯ÛŒÚ©Ú¾ Ø¨Ú¾Ø§Ù„ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(418832,11635,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ Ð¿Ð¾Ð·Ð¸Ð²Ðµ Ð·Ð° Ð¾Ð´Ñ€Ð¶Ð°Ð²Ð°ÑšÐµ',0),(418833,11635,'vi','Ä‘á» nghá»‹ báº£o dÆ°á»¡ng gáº§n Ä‘Ã¢y',0),(418834,11635,'af','Onlangse onderhoud versoeke',0),(418835,11635,'ro','Ultimele cereri de Ã®ntreÅ£inere',0),(418836,11635,'et','Tehtud hooldus taotlused',0),(418837,11635,'si','Nedavne zahteve za vzdrÅ¾evanje',0),(418838,11635,'ba','Pemeliharaan permintaan',0),(418839,11635,'nl','Recente onderhoud aanvragen',0),(418840,11635,'fi','Viime huolto pyynnÃ¶t',0),(418841,11635,'no','Siste vedlikehold forespÃ¸rsler',0),(418842,11635,'da','Seneste vedligeholdelse anmodninger',0),(418843,11635,'ko','ìµœê·¼ ìœ ì§€ ë³´ìˆ˜ ìš”ì²­',0),(418844,11635,'he','×‘×§×©×•×ª ×ª×—×–×•×§×” ×”××—×¨×•× ×•×ª',0),(418845,11635,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î± Î±Î¹Ï„Î®Î¼Î±Ï„Î± ÏƒÏ…Î½Ï„Î®ÏÎ·ÏƒÎ·',0),(418846,11635,'zh','æœ€è¿‘çš„ç»´ä¿®è¦æ±‚\r\n',0),(418847,11635,'sv','Senaste underhÃ¥ll begÃ¤randen',0),(418848,11635,'it','Recenti richieste di manutenzione',0),(418849,11635,'tl','',0),(418850,11635,'th','à¸„à¸³à¸‚à¸­à¸šà¸³à¸£à¸¸à¸‡à¸£à¸±à¸à¸©à¸²à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(418851,11635,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤°à¤–à¤°à¤–à¤¾à¤µ à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚',0),(418852,11635,'ms','Semalam ajak penyelenggaraan',0),(418853,11635,'ar','Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØµÙŠØ§Ù†Ø© Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(418854,11635,'fr','Ces derniÃ¨res demandes de Maintenance',0),(418855,11635,'jp','æœ€è¿‘ã®ãƒ¡ãƒ³ãƒ†ãƒŠãƒ³ã‚¹ ãƒªã‚¯ã‚¨ã‚¹ãƒˆ',0),(418856,11635,'pt','Ãšltimos pedidos de manutenÃ§Ã£o',0),(418857,11635,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÑ‹ Ð½Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(418858,11635,'es','Solicitaciones de Mantenimiento Reientes',0),(418859,11635,'de','Wartung-Anfragen',0),(418860,11635,'en','Recent Maintenance Requests',0),(418861,11636,'is','',0),(418862,11636,'dr','Ù…Ø³ØªØ§Ø¬Ø± ÙØ¹Ø§Ù„',0),(418863,11636,'pr','Ù…Ø³ØªØ§Ø¬Ø± ÙØ¹Ø§Ù„',0),(418864,11636,'tr','Etkin kiracÄ±',0),(418865,11636,'pl','Aktywne najemcy',0),(418866,11636,'bg','ÐÐºÑ‚Ð¸Ð²ÐµÐ½ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»',0),(418867,11636,'ur','Ø²ÛŒØ± Ø¹Ù…Ù„ Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø±',0),(418868,11636,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ ÑÑ‚Ð°Ð½Ð°Ñ€',0),(418869,11636,'vi','NgÆ°á»i thuÃª nhÃ  hoáº¡t Ä‘á»™ng',0),(418870,11636,'af','Aktiewe Huurder',0),(418871,11636,'ro','Activ chiriaÅŸ',0),(418872,11636,'et','Aktiivne Ã¼Ã¼rnik',0),(418873,11636,'si','Aktivno najemnik',0),(418874,11636,'ba','Aktif penyewa',0),(418875,11636,'nl','Actieve huurder',0),(418876,11636,'fi','Aktiivinen vuokralainen',0),(418877,11636,'no','Aktive leietaker',0),(418878,11636,'da','Aktive lejer',0),(418879,11636,'ko','í™œì„±í™” ê±°ì£¼ìž',0),(418880,11636,'he','×”×“×™×™×¨ ×¤×¢×™×œ',0),(418881,11636,'el','Î•Î½ÎµÏÎ³ÏŒ Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(418882,11636,'zh','æ´»è·ƒçš„é¡§å®¢\r\n',0),(418883,11636,'sv','Aktiva hyresgÃ¤sten',0),(418884,11636,'it','Inquilino attivo',0),(418885,11636,'tl','',0),(418886,11636,'th','à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸­à¸¢à¸¹à¹ˆ',0),(418887,11636,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°',0),(418888,11636,'ms','Penyewa yang aktif',0),(418889,11636,'ar','Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± Ø§Ù„Ù†Ø´Ø·Ø©',0),(418890,11636,'fr','Locataire actif',0),(418891,11636,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªãƒ†ãƒŠãƒ³ãƒˆ',0),(418892,11636,'pt','Inquilino ativo',0),(418893,11636,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð°',0),(418894,11636,'es','Inquilino Activo',0),(418895,11636,'de','Aktive Mieter',0),(418896,11636,'en','Active Tenant',0),(418897,11637,'is','',0),(418898,11637,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(418899,11637,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¬Ø§Ø±Ù‡ ',0),(418900,11637,'tr','Kira bilgisi',0),(418901,11637,'pl','Informacji na temat leasingu',0),(418902,11637,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(418903,11637,'ur','Ù„ÛŒØ² Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(418904,11637,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð˜Ð½Ñ„Ð¾',0),(418905,11637,'vi','Cho thuÃª thÃ´ng tin',0),(418906,11637,'af','Huurkontrak Inligting',0),(418907,11637,'ro','Info leasing',0),(418908,11637,'et','Liisingu Info',0),(418909,11637,'si','Zakup Info',0),(418910,11637,'ba','Sewa Info',0),(418911,11637,'nl','Lease Info',0),(418912,11637,'fi','Vuokrasopimuksen Info',0),(418913,11637,'no','Leieavtalen Info',0),(418914,11637,'da','Lease Info',0),(418915,11637,'ko','ìž„ëŒ€ ì •ë³´',0),(418916,11637,'he','×©×›×™×¨×•×ª ×¤×¨×˜×™',0),(418917,11637,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(418918,11637,'zh','ç§ŸåŠ¡èµ„è®¯\r\n',0),(418919,11637,'sv','Hyresavtalet information',0),(418920,11637,'it','Info contratto di locazione',0),(418921,11637,'tl','',0),(418922,11637,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸²à¸£à¹€à¸Šà¹ˆà¸²',0),(418923,11637,'hi','à¤²à¥€à¤œ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(418924,11637,'ms','Maklumat pajakan',0),(418925,11637,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(418926,11637,'fr','Bail Info',0),(418927,11637,'jp','ãƒªãƒ¼ã‚¹æƒ…å ±',0),(418928,11637,'pt','InformaÃ§Ã£o de locaÃ§Ã£o',0),(418929,11637,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ð± Ð°Ñ€ÐµÐ½Ð´Ðµ',0),(418930,11637,'es','Info de Arrendamiento',0),(418931,11637,'de','Leasing Info',0),(418932,11637,'en','Lease Info',0),(418933,11638,'is','',0),(418934,11638,'dr','Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(418935,11638,'pr','Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(418936,11638,'tr','Kira imzalanmasÄ±',0),(418937,11638,'pl','Podpisanie umowy najmu',0),(418938,11638,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ Ð·Ð° Ð½Ð°ÐµÐ¼',0),(418939,11638,'ur','Ù„ÙÛŒØ² Ù¾Ø± Ø¯Ø³ØªØ®Ø·',0),(418940,11638,'sr','Ð—Ð°ÐºÑƒÐ¿ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ',0),(418941,11638,'vi','KÃ½ káº¿t há»£p Ä‘á»“ng thuÃª',0),(418942,11638,'af','Huurkontrak Ondertekening',0),(418943,11638,'ro','Semnare contract de leasing',0),(418944,11638,'et','Rendilepingu allakirjutamise',0),(418945,11638,'si','Podpis najemne pogodbe',0),(418946,11638,'ba','Penandatanganan kontrak',0),(418947,11638,'nl','Ondertekening van lease',0),(418948,11638,'fi','Vuokrasopimuksen allekirjoittamisesta',0),(418949,11638,'no','Leieavtale signering',0),(418950,11638,'da','Lejekontrakt underskrevet',0),(418951,11638,'ko','ìž„ëŒ€ ì„œëª…',0),(418952,11638,'he','×—×ª×™×ž×” ×¢×œ ×—×•×–×” ×”×©×›×™×¨×•×ª',0),(418953,11638,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Ï…Ï€Î¿Î³ÏÎ±Ï†Î®',0),(418954,11638,'zh','ç§Ÿèµç­¾çº¦\r\n',0),(418955,11638,'sv','Hyresavtalet undertecknande',0),(418956,11638,'it','Firma del contratto di locazione',0),(418957,11638,'tl','',0),(418958,11638,'th','à¸¥à¸‡à¸Šà¸·à¹ˆà¸­à¹ƒà¸™à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(418959,11638,'hi','à¤²à¥€à¤œ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°',0),(418960,11638,'ms','Pajakan menandatangani',0),(418961,11638,'ar','Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù„Ù‰ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(418962,11638,'fr','Signature du bail',0),(418963,11638,'jp','ãƒªãƒ¼ã‚¹ã«ç½²å',0),(418964,11638,'pt','Assinatura de contrato de arrendamento',0),(418965,11638,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(418966,11638,'es','Firma de Arrendamiento',0),(418967,11638,'de','Mietvertrag unterschreiben',0),(418968,11638,'en','Lease Signing',0),(418969,11639,'is','',0),(418970,11639,'dr','Ø§Ø¯Ø§Ø±Ù‡ ÙƒØ±Ø¯Ù† ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(418971,11639,'pr','Ø§Ø¯Ø§Ø±Ù‡ ÙƒØ±Ø¯Ù† ÙƒØ§Ø±Øª Ù‡Ø§ÙŠ Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ ',0),(418972,11639,'tr','Kredi kartlarÄ±nÄ± yÃ¶netin',0),(418973,11639,'pl','ZarzÄ…dzanie kartami kredytowymi',0),(418974,11639,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(418975,11639,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±ÛŒÚº',0),(418976,11639,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°Ð¼Ð°',0),(418977,11639,'vi','Quáº£n lÃ½ tháº» tÃ­n dá»¥ng',0),(418978,11639,'af','Bestuur krediet kaarte',0),(418979,11639,'ro','Administra carduri de Credit',0),(418980,11639,'et','Hallata krediitkaardid',0),(418981,11639,'si','Upravljanje kreditnih kartic',0),(418982,11639,'ba','Mengelola kartu kredit',0),(418983,11639,'nl','Beheren van Credit Cards',0),(418984,11639,'fi','Hallita luottokortit',0),(418985,11639,'no','Behandle kredittkort',0),(418986,11639,'da','Administrere kreditkort',0),(418987,11639,'ko','ì‹ ìš© ì¹´ë“œ ê´€ë¦¬',0),(418988,11639,'he','× ×™×”×•×œ ×›×¨×˜×™×¡×™ ××©×¨××™',0),(418989,11639,'el','Î”Î¹Î±Ï‡ÎµÎ¹ÏÎ¯Î¶ÎµÏƒÏ„Îµ Ï„Î¹Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(418990,11639,'zh','ä¿¡ç”¨å¡ç®¡ç†\r\n',0),(418991,11639,'sv','Hantera kreditkort',0),(418992,11639,'it','Gestire le carte di credito',0),(418993,11639,'tl','',0),(418994,11639,'th','à¸ˆà¸±à¸”à¸à¸²à¸£à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(418995,11639,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¤¾ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨',0),(418996,11639,'ms','Mengurus kad kredit',0),(418997,11639,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(418998,11639,'fr','GÃ©rer les cartes de crÃ©dit',0),(418999,11639,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã‚’ç®¡ç†ã—ã¾ã™ã€‚',0),(419000,11639,'pt','Gerenciar cartÃµes de crÃ©dito',0),(419001,11639,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(419002,11639,'es','Manejar Tarjetas de CrÃ©dito',0),(419003,11639,'de','Kreditkarten verwalten',0),(419004,11639,'en','Manage Credit Cards',0),(419005,11640,'is','',0),(419006,11640,'dr','Ø®Ù„Ø§ØµÙ‡ Ù…Ø³ØªØ§Ø¬Ø± ',0),(419007,11640,'pr','Ø®Ù„Ø§ØµÙ‡ Ù…Ø³ØªØ§Ø¬Ø± ',0),(419008,11640,'tr','KiracÄ± Ã–zeti',0),(419009,11640,'pl','Podsumowanie najemcy',0),(419010,11640,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(419011,11640,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(419012,11640,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(419013,11640,'vi','TÃ³m táº¯t ngÆ°á»i thuÃª nhÃ ',0),(419014,11640,'af','Huurder Opsomming',0),(419015,11640,'ro','ChiriaÅŸ Rezumat',0),(419016,11640,'et','ÃœÃ¼rnik KokkuvÃµte',0),(419017,11640,'si','Najemnik Povzetek',0),(419018,11640,'ba','Ringkasan penyewa',0),(419019,11640,'nl','Huurder samenvatting',0),(419020,11640,'fi','Vuokralainen Yhteenveto',0),(419021,11640,'no','Leietaker Sammendrag',0),(419022,11640,'da','Lejer ResumÃ©',0),(419023,11640,'ko','í…Œ ë„Œ íŠ¸ ìš”ì•½',0),(419024,11640,'he','×”×“×™×™×¨ ×¡×™×›×•×',0),(419025,11640,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Ï„Î¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(419026,11640,'zh','ç§Ÿå®¢æ‘˜è¦\r\n',0),(419027,11640,'sv','HyresgÃ¤sten Sammanfattning',0),(419028,11640,'it','Inquilino Sommario',0),(419029,11640,'tl','',0),(419030,11640,'th','à¸ªà¸£à¸¸à¸›à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(419031,11640,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(419032,11640,'ms','Ringkasan penyewa',0),(419033,11640,'ar','Ù…Ù„Ø®Øµ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(419034,11640,'fr','RÃ©sumÃ© du locataire',0),(419035,11640,'jp','ãƒ†ãƒŠãƒ³ãƒˆæ¦‚è¦',0),(419036,11640,'pt','Resumo de inquilino',0),(419037,11640,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(419038,11640,'es','Sumario de Inquilinos',0),(419039,11640,'de','Mieter-Zusammenfassung',0),(419040,11640,'en','Tenant Summary',0),(419041,11641,'is','',0),(419042,11641,'dr','Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(419043,11641,'pr','Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(419044,11641,'tr','Ãœye Kiralama',0),(419045,11641,'pl','Znak dzierÅ¼awy',0),(419046,11641,'bg','Ð—Ð½Ð°Ðº Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(419047,11641,'ur','Ù†Ø´Ø§Ù†ÛŒ Ù„ÛŒØ²',0),(419048,11641,'sr','Ð—Ð½Ð°Ðº Ð·Ð°ÐºÑƒÐ¿',0),(419049,11641,'vi','ÄÄƒng kÃ½ cho thuÃª',0),(419050,11641,'af','Onderteken Huurkontrak',0),(419051,11641,'ro','Semn Lease',0),(419052,11641,'et','MÃ¤rk Ã¼Ã¼rileping',0),(419053,11641,'si','Znak najema',0),(419054,11641,'ba','Tanda sewa',0),(419055,11641,'nl','Teken Lease',0),(419056,11641,'fi','Merkki vuokrasopimuksen',0),(419057,11641,'no','Tegn Lease',0),(419058,11641,'da','Underskrive lejekontrakt',0),(419059,11641,'ko','ì„œëª… ìž„ëŒ€',0),(419060,11641,'he','×¡×™×ž×Ÿ ×—×›×™×¨×”',0),(419061,11641,'el','Î£Î·Î¼Î¬Î´Î¹ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(419062,11641,'zh','èµ¶å¿«ç§Ÿèµ\r\n',0),(419063,11641,'sv','Undertecknar hyresavtalet',0),(419064,11641,'it','Segno Lease',0),(419065,11641,'tl','',0),(419066,11641,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¹€à¸Šà¹ˆà¸²',0),(419067,11641,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°',0),(419068,11641,'ms','Tanda pajakan',0),(419069,11641,'ar','ØªØ³Ø¬ÙŠÙ„ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(419070,11641,'fr','Bail signe',0),(419071,11641,'jp','è¨˜å·ãƒªãƒ¼ã‚¹',0),(419072,11641,'pt','LocaÃ§Ã£o de sinal',0),(419073,11641,'ru','Ð—Ð½Ð°Ðº Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(419074,11641,'es','Firmar Arrendamiento',0),(419075,11641,'de','Zeichen-Leasing',0),(419076,11641,'en','Sign Lease',0),(419077,11642,'is','',0),(419078,11642,'dr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ',0),(419079,11642,'pr','Ù¾ÙŠØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÙŠ ØµÙØ­Ù‡ Ø§ØµÙ„ÙŠ',0),(419080,11642,'tr','VarsayÄ±lan ana sayfa',0),(419081,11642,'pl','DomyÅ›lna Strona gÅ‚Ã³wna',0),(419082,11642,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(419083,11642,'ur','ÛÙˆÙ… Ù¾ÛŒØ¬ Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û',0),(419084,11642,'sr','ÐÐ° Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸',0),(419085,11642,'vi','Máº·c Ä‘á»‹nh Ä‘á»ƒ trang chá»§',0),(419086,11642,'af','Verstek na tuisblad',0),(419087,11642,'ro','Implicit la pagina de start',0),(419088,11642,'et','Vaikimisi avalehe',0),(419089,11642,'si','Privzeto domaÄo stran',0),(419090,11642,'ba','Default ke halaman rumah',0),(419091,11642,'nl','Standaard naar Home Page',0),(419092,11642,'fi','Oletus kotisivulle',0),(419093,11642,'no','Standard hjemmeside',0),(419094,11642,'da','Standard til startside',0),(419095,11642,'ko','í™ˆ íŽ˜ì´ì§€ë¥¼ ê¸°ë³¸ê°’ìœ¼ë¡œ',0),(419096,11642,'he','×‘×¨×™×¨×ª ×ž×—×“×œ ×œ×“×£ ×”×‘×™×ª',0),(419097,11642,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î±ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î±',0),(419098,11642,'zh','é»˜è®¤ä¸ºé¦–é¡µ\r\n',0),(419099,11642,'sv','Standard till startsidan',0),(419100,11642,'it','Alla Home Page di default',0),(419101,11642,'tl','',0),(419102,11642,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸«à¸™à¹‰à¸²à¸šà¹‰à¸²à¸™',0),(419103,11642,'hi','à¤®à¥à¤– à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(419104,11642,'ms','Lalai ke Laman Utama',0),(419105,11642,'ar','Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(419106,11642,'fr','Par dÃ©faut Ã  la Page d\'accueil',0),(419107,11642,'jp','æ—¢å®šã®ãƒ›ãƒ¼ãƒ  ãƒšãƒ¼ã‚¸ã¸',0),(419108,11642,'pt','PÃ¡gina inicial por omissÃ£o',0),(419109,11642,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ Ð´Ð¾Ð¼Ð°ÑˆÐ½ÐµÐ¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹',0),(419110,11642,'es','Predeterminado A PÃ¡gina Principal',0),(419111,11642,'de','Standard-zur Homepage',0),(419112,11642,'en','Default To Home Page',0),(419113,11643,'is','',0),(419114,11643,'dr','Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(419115,11643,'pr','Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(419116,11643,'tr','HaklarÄ± grubu baÅŸarÄ±yla silindi',0),(419117,11643,'pl','Grupy praw przesâ”‚anie',0),(419118,11643,'bg','ÐŸÑ€Ð°Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(419119,11643,'ur','Ø­Ù‚ÙˆÙ‚ Ú¯Ø±ÙˆÙ¾ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(419120,11643,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð·Ð° Ð¿Ñ€Ð°Ð²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(419121,11643,'vi','Ä‘Ã£ xÃ³a quyá»n cá»§a nhÃ³m hÃ nh cÃ´ng',0),(419122,11643,'af','Regte groep suksesvol geskrap',0),(419123,11643,'ro','Drepturile grupului ÅŸters cu succes',0),(419124,11643,'et','Ã•igustega rÃ¼hm edukalt kustutatud',0),(419125,11643,'si','Skupine za pravice, ki Ärta uspeÅ¡no',0),(419126,11643,'ba','Kelompok hak asasi dihapus berhasil',0),(419127,11643,'nl','Rechtengroep succesvol verwijderd',0),(419128,11643,'fi','Oikeuksien ryhmÃ¤ poistettu',0),(419129,11643,'no','Rettigheter gruppen slettet',0),(419130,11643,'da','Rettigheder gruppe slettet',0),(419131,11643,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ê¶Œí•œ ê·¸ë£¹',0),(419132,11643,'he','×–×›×•×™×•×ª ×§×‘×•×¦×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(419133,11643,'el','Î”Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Î¿Î¼Î¬Î´Î±Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(419134,11643,'zh','æƒåˆ©ç»„æˆåŠŸåˆ é™¤\r\n',0),(419135,11643,'sv','RÃ¤ttigheter grupp raderades',0),(419136,11643,'it','Gruppo diritti cancellati con successo',0),(419137,11643,'tl','',0),(419138,11643,'th','à¸à¸¥à¸¸à¹ˆà¸¡à¸ªà¸´à¸—à¸˜à¸´à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(419139,11643,'hi','à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤®à¥‚à¤¹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(419140,11643,'ms','Hak-hak Kumpulan dihapuskan dengan jayanya',0),(419141,11643,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø­Ù‚ÙˆÙ‚ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(419142,11643,'fr','Droits de groupe supprimÃ© avec succÃ¨s',0),(419143,11643,'jp','æ¨©åˆ©ã‚°ãƒ«ãƒ¼ãƒ—ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(419144,11643,'pt','Grupo de direitos apagado com sucesso',0),(419145,11643,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð¿Ñ€Ð°Ð², ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(419146,11643,'es','Grupo de Derechos Eliminado Exitosamente',0),(419147,11643,'de','Rechte Gruppe erfolgreich gelÃ¶scht',0),(419148,11643,'en','Rights Group Deleted Successfully',0),(419149,11644,'is','',0),(419150,11644,'dr','ØªØ§Ø±ÙŠØ® Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ ',0),(419151,11644,'pr','ØªØ§Ø±ÙŠØ® Ù¾ÙŠØ´ Ø¨ÙŠÙ†ÙŠ ',0),(419152,11644,'tr','Tahmin tarihi',0),(419153,11644,'pl','Prognoza Data',0),(419154,11644,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð³Ð½Ð¾Ð·Ð°',0),(419155,11644,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ù¾ÛŒØ´ Ú¯ÙˆØ¦ÛŒ Ú©ÛŒ',0),(419156,11644,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÐ´Ð²Ð¸Ñ’Ð°ÑšÐ°',0),(419157,11644,'vi','NgÃ y dá»± Ä‘oÃ¡n',0),(419158,11644,'af','Datum voorspelling',0),(419159,11644,'ro','Prognoza data',0),(419160,11644,'et','Prognoosi kuupÃ¤ev',0),(419161,11644,'si','Napoved datum',0),(419162,11644,'ba','Perkiraan tanggal',0),(419163,11644,'nl','Datum voorspelling',0),(419164,11644,'fi','Ennuste pvm',0),(419165,11644,'no','Prognosen dato',0),(419166,11644,'da','ForelÃ¸big dato',0),(419167,11644,'ko','ë‚ ì§œë¥¼ ì˜ˆì¸¡',0),(419168,11644,'he','×ª×—×–×™×ª ×ª××¨×™×š',0),(419169,11644,'el','Î ÏÏŒÎ²Î»ÎµÏˆÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(419170,11644,'zh','é¢„æµ‹æ—¥æœŸ\r\n',0),(419171,11644,'sv','Prognos datum',0),(419172,11644,'it','Previsione data',0),(419173,11644,'tl','',0),(419174,11644,'th','à¸§à¸±à¸™à¸„à¸²à¸”à¸à¸²à¸£à¸“à¹Œ',0),(419175,11644,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤•à¥€ à¤­à¤µà¤¿à¤·à¥à¤¯à¤µà¤¾à¤£à¥€',0),(419176,11644,'ms','Ramalan tarikh',0),(419177,11644,'ar','Ø§Ù„ØªÙ†Ø¨Ø¤ Ø¨ØªØ§Ø±ÙŠØ®',0),(419178,11644,'fr','Date de prÃ©vision',0),(419179,11644,'jp','æ—¥ä»˜ã‚’äºˆæ¸¬ã—ã¾ã™ã€‚',0),(419180,11644,'pt','PrevisÃ£o de data',0),(419181,11644,'ru','ÐŸÑ€Ð¾Ð³Ð½Ð¾Ð· Ð´Ð°Ñ‚Ñ‹',0),(419182,11644,'es','Fecha de PronÃ³stico',0),(419183,11644,'de','Prognose Datum',0),(419184,11644,'en','Forecast Date',0),(419185,11645,'is','',0),(419186,11645,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª ',0),(419187,11645,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ø§ÙŠ Ø§ÙŠÙ† Ø´Ø±ÙƒØª ',0),(419188,11645,'tr','Bu ÅŸirket iÃ§in rapor',0),(419189,11645,'pl','Raport dla tej firmy',0),(419190,11645,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°',0),(419191,11645,'ur','Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø±Ù¾ÙˆØ±Ù¹',0),(419192,11645,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð·Ð° Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(419193,11645,'vi','bÃ¡o cÃ¡o cho cÃ´ng ty nÃ y',0),(419194,11645,'af','Verslag Vir Hierdie Onderneming',0),(419195,11645,'ro','Raport pentru aceasta companie',0),(419196,11645,'et','Aruande selle firma',0),(419197,11645,'si','PoroÄila za to druÅ¾bo',0),(419198,11645,'ba','Laporan untuk perusahaan ini',0),(419199,11645,'nl','Verslag voor dit bedrijf',0),(419200,11645,'fi','MietinnÃ¶ssÃ¤ tÃ¤lle yritykselle',0),(419201,11645,'no','Rapport For dette selskapet',0),(419202,11645,'da','Rapport For dette selskab',0),(419203,11645,'ko','ì´ íšŒì‚¬ì— ëŒ€ í•œ ë³´ê³ ì„œ',0),(419204,11645,'he','×“×• ×— ×¢×‘×•×¨ ×—×‘×¨×” ×–×•',0),(419205,11645,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î®',0),(419206,11645,'zh','æ­¤å…¬å¸çš„æŠ¥å‘Š\r\n',0),(419207,11645,'sv','Rapport fÃ¶r detta fÃ¶retag',0),(419208,11645,'it','Relazione per questa azienda',0),(419209,11645,'tl','',0),(419210,11645,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸£à¸´à¸©à¸±à¸—à¸™à¸µà¹‰',0),(419211,11645,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(419212,11645,'ms','Laporan untuk Syarikat ini',0),(419213,11645,'ar','ØªÙ‚Ø±ÙŠØ± Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(419214,11645,'fr','Rapport pour cette sociÃ©tÃ©',0),(419215,11645,'jp','ã“ã®ä¼šç¤¾ã®ãƒ¬ãƒãƒ¼ãƒˆ',0),(419216,11645,'pt','RelatÃ³rio para a empresa',0),(419217,11645,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð”Ð»Ñ Ð”Ð°Ð½Ð½Ð¾Ð¹ ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(419218,11645,'es','Informe Para Esta Empresa',0),(419219,11645,'de','Bericht fÃ¼r diese Firma',0),(419220,11645,'en','Report For This Company',0),(419221,11646,'is','',0),(419222,11646,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ±Ø¯Ù† Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(419223,11646,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙƒØ±Ø¯Ù† Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(419224,11646,'tr','Hata iÅŸleme isteÄŸi',0),(419225,11646,'pl','BÅ‚Ä…d przetwarzania Å¼Ä…dania',0),(419226,11646,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°Ñ‚Ð° Ð½Ð° Ð¸ÑÐºÐ°Ð½ÐµÑ‚Ð¾',0),(419227,11646,'ur','Ù†Ù‚Øµ Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(419228,11646,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð´Ð¸ Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ð°',0),(419229,11646,'vi','Lá»—i trong quÃ¡ trÃ¬nh Ä‘á» nghá»‹',0),(419230,11646,'af','Fout verwerking versoek',0),(419231,11646,'ro','Cerere de prelucrare eroare',0),(419232,11646,'et','Taotluse tÃ¶Ã¶tlemisel ilmnes tÃµrge',0),(419233,11646,'si','Napaka pri obdelavi zahteve',0),(419234,11646,'ba','Kesalahan pengolahan permintaan',0),(419235,11646,'nl','Fout Processing verzoek',0),(419236,11646,'fi','Virhe kÃ¤siteltÃ¤essÃ¤ pyyntÃ¶Ã¤',0),(419237,11646,'no','Feil under behandling av forespÃ¸rsel',0),(419238,11646,'da','Fejl forarbejdning anmodning',0),(419239,11646,'ko','ì˜¤ë¥˜ ì²˜ë¦¬ ìš”ì²­',0),(419240,11646,'he','×©×’×™××” ×‘×¢×™×‘×•×“ ×”×‘×§×©×”',0),(419241,11646,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î±Î¹Ï„Î®Î¼Î±Ï„Î¿Ï‚',0),(419242,11646,'zh','é”™è¯¯å¤„ç†è¯·æ±‚',0),(419243,11646,'sv','Fel behandlar begÃ¤ran',0),(419244,11646,'it','Errore elaborazione richiesta',0),(419245,11646,'tl','',0),(419246,11646,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¸„à¸³à¸‚à¸­',0),(419247,11646,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(419248,11646,'ms','Ralat memproses permintaan',0),(419249,11646,'ar','Ø®Ø·Ø£ ÙÙŠ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ø·Ù„Ø¨',0),(419250,11646,'fr','Demande de traitement d\'erreur',0),(419251,11646,'jp','è¦æ±‚ã®å‡¦ç†ã‚¨ãƒ©ãƒ¼',0),(419252,11646,'pt','SolicitaÃ§Ã£o de processamento de erro',0),(419253,11646,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(419254,11646,'es','Error Procesando Solicitud',0),(419255,11646,'de','Fehleranforderung Verarbeitung',0),(419256,11646,'en','Error Processing Request',0),(419257,11647,'is','',0),(419258,11647,'dr','Ø®Ø·Ø§ ÙŠ Ø§Ø±Ø§Ø¦Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø³Ù†Ø¯',0),(419259,11647,'pr','Ø®Ø·Ø§ ÙŠ Ø§Ø±Ø§Ø¦Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø³Ù†Ø¯',0),(419260,11647,'tr','Hata gÃ¶nderme belgesi talebi',0),(419261,11647,'pl','BÅ‚Ä…d zÅ‚oÅ¼enia dokumentu wniosek',0),(419262,11647,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(419263,11647,'ur','Ù†Ù‚Øµ Ø¨Ú¾ÛŒØ¬Ù†Û’ Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(419264,11647,'sr','ÐŸÐ¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð·Ð° Ð³Ñ€ÐµÑˆÐºÐµ',0),(419265,11647,'vi','Lá»—i khi trÃ¬nh Ä‘á» nghá»‹',0),(419266,11647,'af','Fout indiening dokument versoek',0),(419267,11647,'ro','Eroare de depunerea documentului cererea',0),(419268,11647,'et','Viga esitada dokumendi taotlus',0),(419269,11647,'si','Napaka predloÅ¾itev dokumenta zahteva',0),(419270,11647,'ba','Kesalahan mengirimkan dokumen permintaan',0),(419271,11647,'nl','Fout indienen van Document verzoek',0),(419272,11647,'fi','Virhe lÃ¤hettÃ¤mÃ¤llÃ¤ asiakirjan pyyntÃ¶Ã¤',0),(419273,11647,'no','Feil sender dokumentforespÃ¸rsel',0),(419274,11647,'da','Fejl indsendelse af dokumentanmodning',0),(419275,11647,'ko','ì˜¤ë¥˜ ì œì¶œ ë¬¸ì„œ ìš”ì²­',0),(419276,11647,'he','×©×’×™××” ×”×’×©×ª ×‘×§×©×” ×œ×ž×¡×ž×š',0),(419277,11647,'el','Î£Ï†Î¬Î»Î¼Î± Ï…Ï€Î¿Î²Î¿Î»Î® Î±Î¯Ï„Î·ÏƒÎ·Ï‚ ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(419278,11647,'zh','é”™è¯¯æäº¤èµ„æ–™è¯·æ±‚\r\n',0),(419279,11647,'sv','Fel att skicka dokumentbegÃ¤ran',0),(419280,11647,'it','Errore invio richiesta di documenti',0),(419281,11647,'tl','',0),(419282,11647,'th','à¸£à¹‰à¸­à¸‡à¸‚à¸­à¹€à¸­à¸à¸ªà¸²à¸£à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(419283,11647,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¤¨à¤¾',0),(419284,11647,'ms','Ralat menghantar dokumen permintaan',0),(419285,11647,'ar','Ø®Ø·Ø£ ÙÙŠ ÙˆØ«ÙŠÙ‚Ø© ØªÙ‚Ø¯ÙŠÙ… Ø·Ù„Ø¨',0),(419286,11647,'fr','Erreur soumettant la demande documents',0),(419287,11647,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã‚’é€ä¿¡ã™ã‚‹è¦æ±‚ã®ã‚¨ãƒ©ãƒ¼',0),(419288,11647,'pt','Erro submeter solicitaÃ§Ã£o de documento',0),(419289,11647,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(419290,11647,'es','Error Sometiendo la Solicitud de Documento',0),(419291,11647,'de','Fehler senden Dokument Anfrage',0),(419292,11647,'en','Error Submitting Document Request',0),(419293,11648,'is','',0),(419294,11648,'dr','Ù‡ÙŠÚ† Ø³Ù†Ø¯ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(419295,11648,'pr','Ù‡ÙŠÚ† Ø³Ù†Ø¯ÙŠ ØªÙ†Ø¸ÙŠÙ… Ù†Ø´Ø¯Ù‡ ',0),(419296,11648,'tr','HiÃ§bir belge kÃ¼mesi',0),(419297,11648,'pl','Nie zestaw dokumentÃ³w',0),(419298,11648,'bg','ÐÑÐ¼Ð° ÐºÐ¾Ð»ÐµÐºÑ‚Ð¸Ð²Ð½Ð° Ð¿Ð°Ð¿ÐºÐ° Ð·Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(419299,11648,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(419300,11648,'sr','ÐÐµÐ¼Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð¡ÐµÑ‚',0),(419301,11648,'vi','khÃ´ng táº­p há»£p chá»©ng tá»«',0),(419302,11648,'af','Geen dokument stel',0),(419303,11648,'ro','Nici un Set de documente',0),(419304,11648,'et','Dokumentide komplekt',0),(419305,11648,'si','Ni komplet dokumentov',0),(419306,11648,'ba','No Set dokumen',0),(419307,11648,'nl','Geen documentenset',0),(419308,11648,'fi','Ei ole tiedostojoukon',0),(419309,11648,'no','Ingen dokumentsett',0),(419310,11648,'da','Ingen dokumentgruppe',0),(419311,11648,'ko','ë¬¸ì„œ ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(419312,11648,'he','×œ× ×”×•×’×“×¨×• ×‘×ž×¡×ž×š',0),(419313,11648,'el','ÎšÎ±Î½Î­Î½Î± Î­Î³Î³ÏÎ±Ï†Î¿ ÏƒÏÎ½Î¿Î»Î¿',0),(419314,11648,'zh','æ²¡æœ‰æ–‡æ¡£é›†\r\n',0),(419315,11648,'sv','Ingen dokumentgruppen',0),(419316,11648,'it','Nessun documento Set',0),(419317,11648,'tl','',0),(419318,11648,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸Šà¸¸à¸”à¹€à¸­à¸à¸ªà¸²à¸£',0),(419319,11648,'hi','à¤•à¥‹à¤ˆ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¸à¥‡à¤Ÿ',0),(419320,11648,'ms','Tiada Set dokumen',0),(419321,11648,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(419322,11648,'fr','Aucun ensemble de documents',0),(419323,11648,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(419324,11648,'pt','Nenhum documento conjunto',0),(419325,11648,'ru','ÐÐµÑ‚ Ð½Ð°Ð±Ð¾Ñ€Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(419326,11648,'es','No Ha configurado un Documento',0),(419327,11648,'de','Keine Dokumentensatz',0),(419328,11648,'en','No Document Set',0),(419329,11649,'is','',0),(419330,11649,'dr','Ù‡ÙŠÚ† Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†Ù†Ø¯Ù‡ Ø§ÙŠ  Ø¨Ø±Ù†Ú¯Ø´Øª ',0),(419331,11649,'pr','Ù‡ÙŠÚ† Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†Ù†Ø¯Ù‡ Ø§ÙŠ  Ø¨Ø±Ù†Ú¯Ø´Øª ',0),(419332,11649,'tr','HiÃ§bir imza dÃ¶ndÃ¼rdÃ¼',0),(419333,11649,'pl','Sygnatariusze nie wrÃ³ciÅ‚',0),(419334,11649,'bg','ÐÑÐ¼Ð° Ñ‡Ð»ÐµÐ½Ð¾Ð²Ðµ Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸',0),(419335,11649,'ur','Ú©ÙˆØ¦ÛŒ Ø¯Ø³ØªØ®Ø· Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† Ù„ÙˆÙ¹ Ø¢Ø¦Û’',0),(419336,11649,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ½Ð¸ÐºÐ° Ñ˜Ðµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾.',0),(419337,11649,'vi','khÃ´ng cÃ³ kÃ½ káº¿t nÃ o tráº£ láº¡i',0),(419338,11649,'af','Geen ondertekenaars teruggekeer',0),(419339,11649,'ro','Semnatari nu s-a Ã®ntors',0),(419340,11649,'et','No Allakirjutanute tagastatud',0),(419341,11649,'si','Ni podpisniki vrnil',0),(419342,11649,'ba','Tidak ada penandatangan yang kembali',0),(419343,11649,'nl','Geen ondertekenaars geretourneerd',0),(419344,11649,'fi','Ei allekirjoittaneet palasi',0),(419345,11649,'no','Ingen underskrifter tilbake',0),(419346,11649,'da','Ingen underskriverne returneres',0),(419347,11649,'ko','ì„œëª…ìžê°€ ì—†ë‹¤ë©´ ë°˜í™˜',0),(419348,11649,'he','. ××™×Ÿ ×—×ª×™×ž×•×ª ×—×–×¨',0),(419349,11649,'el','Î£Ï…Î¼Î²Î±Î»Î»ÏŒÎ¼ÎµÎ½Î± Î¼Î­ÏÎ· Î´ÎµÎ½ ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ',0),(419350,11649,'zh','æ²¡æœ‰è¿”å›žçš„ç­¾ç½²\r\n',0),(419351,11649,'sv','Ingen undertecknare Ã¥tervÃ¤nde',0),(419352,11649,'it','Non restituito firmatari',0),(419353,11649,'tl','',0),(419354,11649,'th','à¸¥à¸‡à¸™à¸²à¸¡à¹„à¸¡à¹ˆà¸ªà¹ˆà¸‡à¸„à¸·à¸™',0),(419355,11649,'hi','à¤•à¥‹à¤ˆ à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤°à¤¨à¥‡ à¤µà¤¾à¤²à¥‹à¤‚ à¤®à¥‡à¤‚ à¤²à¥Œà¤Ÿà¥‡',0),(419356,11649,'ms','Penandatangan tidak dikembalikan',0),(419357,11649,'ar','Ø¹Ø§Ø¯ Ù„Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹ÙŠÙ†',0),(419358,11649,'fr','Aucun signataires retournÃ©s',0),(419359,11649,'jp','è¿”ã•ã‚Œã‚‹ç½²åè€…ãŒã„ã¾ã›ã‚“',0),(419360,11649,'pt','NÃ£o signatÃ¡rios retornado',0),(419361,11649,'ru','ÐÐµ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð²ÑˆÐ¸Ñ… Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ',0),(419362,11649,'es','No DevolviÃ³ Signatorios',0),(419363,11649,'de','Keine Unterzeichner zurÃ¼ckgegeben',0),(419364,11649,'en','No Signatories Returned',0),(419365,11650,'is','',0),(419366,11650,'dr','Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ ',0),(419367,11650,'pr','Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ ',0),(419368,11650,'tr','Belge imzalama',0),(419369,11650,'pl','Podpisanie dokumentu',0),(419370,11650,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(419371,11650,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ù¾Ø± Ø¯Ø³ØªØ®Ø·',0),(419372,11650,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð°',0),(419373,11650,'vi','KÃ½ hiá»‡u chá»©ng tá»«',0),(419374,11650,'af','Dokument onderteken',0),(419375,11650,'ro','Semnarea documentului',0),(419376,11650,'et','Dokumendi allkirjastamine',0),(419377,11650,'si','Podpisovanje dokumenta',0),(419378,11650,'ba','Menandatangani dokumen',0),(419379,11650,'nl','Document ondertekening',0),(419380,11650,'fi','Tiedoston allekirjoitus',0),(419381,11650,'no','Dokument signering',0),(419382,11650,'da','Dokument signering',0),(419383,11650,'ko','ë¬¸ì„œ ì„œëª…',0),(419384,11650,'he','×—×ª×™×ž×” ×¢×œ ×ž×¡×ž×š',0),(419385,11650,'el','Î¥Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(419386,11650,'zh','æ–‡ä»¶çš„ç­¾ç½²\r\n',0),(419387,11650,'sv','Dokument undertecknande',0),(419388,11650,'it','Documento firma',0),(419389,11650,'tl','',0),(419390,11650,'th','à¸à¸²à¸£à¸£à¸±à¸šà¸£à¸­à¸‡à¹€à¸­à¸à¸ªà¸²à¸£',0),(419391,11650,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤°à¤¨à¥‡',0),(419392,11650,'ms','Menandatangani dokumen',0),(419393,11650,'ar','Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù„Ù‰ Ø§Ù„ÙˆØ«ÙŠÙ‚Ø©',0),(419394,11650,'fr','Signature du document',0),(419395,11650,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã®ç½²å',0),(419396,11650,'pt','Assinatura de documento',0),(419397,11650,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(419398,11650,'es','Firmar Documento',0),(419399,11650,'de','Dokumentsignatur',0),(419400,11650,'en','Document Signing',0),(419401,11651,'is','',0),(419402,11651,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ ',0),(419403,11651,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ ',0),(419404,11651,'tr','Belge imzalama yÃ¶nergeleri',0),(419405,11651,'pl','Dokument podpisania instrukcje',0),(419406,11651,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(419407,11651,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ù…ÛŒÚº Ø¯ÛŒ Ú¯Ø¦ÛŒ ÛØ¯Ø§ÛŒØ§Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø·',0),(419408,11651,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(419409,11651,'vi','CÃ¡c chá»‰ dáº«n kÃ½ hiá»‡u chá»©ng tá»«',0),(419410,11651,'af','Dokument meld instruksies',0),(419411,11651,'ro','Documentul semnarea instrucÅ£iuni',0),(419412,11651,'et','Dokumendi allkirjastamine juhiseid',0),(419413,11651,'si','Navodila za podpisovanje dokumenta',0),(419414,11651,'ba','Dokumen penandatanganan petunjuk',0),(419415,11651,'nl','Document ondertekening instructies',0),(419416,11651,'fi','Asiakirjan allekirjoittamisen ohjeet',0),(419417,11651,'no','Dokumentet signering instruksjoner',0),(419418,11651,'da','Dokumentere underskrivelsen instruktioner',0),(419419,11651,'ko','ë¬¸ì„œ ì„œëª… ì§€ì¹¨',0),(419420,11651,'he','×”×ž×¡×ž×š ×—×•×ª× ×¢×œ ×”×”×•×¨××•×ª',0),(419421,11651,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Ï…Ï€Î¿Î³ÏÎ±Ï†Î® Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(419422,11651,'zh','æ–‡ä»¶çš„ç­¾ç½²è¯´æ˜Ž\r\n',0),(419423,11651,'sv','Dokumentet undertecknandet instruktioner',0),(419424,11651,'it','Documento firma istruzioni',0),(419425,11651,'tl','',0),(419426,11651,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸à¸²à¸£à¸¥à¸‡à¸™à¸²à¸¡',0),(419427,11651,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(419428,11651,'ms','Dokumen arahan penandatangan',0),(419429,11651,'ar','ÙˆØ«ÙŠÙ‚Ø© ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(419430,11651,'fr','Document signature Instructions',0),(419431,11651,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã®ç½²åã®æ‰‹é †',0),(419432,11651,'pt','Documento assinatura instruÃ§Ãµes',0),(419433,11651,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°, Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¹',0),(419434,11651,'es','Instrucciones de Firmar Documento',0),(419435,11651,'de','Dokument signieren Anweisungen',0),(419436,11651,'en','Document Signing Instructions',0),(419437,11652,'is','',0),(419438,11652,'dr','Ø³Ù†Ø¯ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(419439,11652,'pr','Ø³Ù†Ø¯ Ù¾ÙŠØ¯Ø§ Ù†Ø´Ø¯',0),(419440,11652,'tr','Belge bulunamadÄ±',0),(419441,11652,'pl','Dokument nie znaleziono',0),(419442,11652,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(419443,11652,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ù†ÛÛŒÚº Ù…Ù„ÛŒ',0),(419444,11652,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(419445,11652,'vi','TÃ i liá»‡u khÃ´ng tÃ¬m tháº¥y',0),(419446,11652,'af','Dokument gevind nie',0),(419447,11652,'ro','Documentul nu a fost gÄƒsit',0),(419448,11652,'et','Dokumenti ei leitud',0),(419449,11652,'si','Dokumenta ni bilo mogoÄe najti',0),(419450,11652,'ba','Dokumen tidak ditemukan',0),(419451,11652,'nl','Document niet gevonden',0),(419452,11652,'fi','Tiedostoa ei lÃ¶ydy',0),(419453,11652,'no','Dokumentet ikke funnet',0),(419454,11652,'da','Dokumentet blev ikke fundet',0),(419455,11652,'ko','ë¬¸ì„œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(419456,11652,'he','×”×ž×¡×ž×š ×œ× × ×ž×¦×',0),(419457,11652,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ Ï„Î¿ Î­Î³Î³ÏÎ±Ï†Î¿',0),(419458,11652,'zh','æ–‡ä»¶æœªæ‰¾åˆ°\r\n',0),(419459,11652,'sv','Dokument hittades inte',0),(419460,11652,'it','Documento non trovato',0),(419461,11652,'tl','',0),(419462,11652,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¹„à¸¡à¹ˆà¸žà¸š',0),(419463,11652,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(419464,11652,'ms','Dokumen yang tidak dijumpai',0),(419465,11652,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(419466,11652,'fr','Document non trouvÃ©',0),(419467,11652,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(419468,11652,'pt','Documento nÃ£o encontrado',0),(419469,11652,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ ÐÐµ ÐÐ°Ð¹Ð´ÐµÐ½',0),(419470,11652,'es','Documento No Se EncontrÃ³',0),(419471,11652,'de','Dokument nicht gefunden',0),(419472,11652,'en','Document Not Found',0),(419473,11653,'is','',0),(419474,11653,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ ',0),(419475,11653,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ ',0),(419476,11653,'tr','Belge gÃ¼ncelleÅŸtirme imzalama',0),(419477,11653,'pl','Podpisanie aktualizacji dokumentu',0),(419478,11653,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚, Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½ÐµÑ‚Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(419479,11653,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ²ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù¾Ø± Ø¯Ø³ØªØ®Ø·',0),(419480,11653,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(419481,11653,'vi','Cáº­p nháº­t kÃ½ hiá»‡u chá»©ng tá»«',0),(419482,11653,'af','Dokument onderteken bywerking',0),(419483,11653,'ro','Update semnare document',0),(419484,11653,'et','Dokumendi allkirjastamine Update',0),(419485,11653,'si','Dokument podpis modernizirati',0),(419486,11653,'ba','Dokumen penandatanganan Update',0),(419487,11653,'nl','Document ondertekening Update',0),(419488,11653,'fi','Asiakirjan allekirjoittamista pÃ¤ivitys',0),(419489,11653,'no','Dokumentet signering oppdatering',0),(419490,11653,'da','Dokumentere underskrivelsen opdateringen',0),(419491,11653,'ko','ë¬¸ì„œ ì„œëª… ì—…ë°ì´íŠ¸',0),(419492,11653,'he','×ž×¡×ž×š ×¢×“×›×•×Ÿ ×—×ª×™×ž×”',0),(419493,11653,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Ï…Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(419494,11653,'zh','æ›´æ–°æ–‡ä»¶çš„ç­¾ç½²\r\n',0),(419495,11653,'sv','Dokumentet undertecknandet uppdatering',0),(419496,11653,'it','Documento firma aggiornamento',0),(419497,11653,'tl','',0),(419498,11653,'th','à¸¥à¸‡à¸™à¸²à¸¡à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(419499,11653,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤°à¤¨à¥‡',0),(419500,11653,'ms','Dokumen yang menandatangani Kemaskini',0),(419501,11653,'ar','ÙˆØ«ÙŠÙ‚Ø© ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(419502,11653,'fr','Mise Ã  jour de signature de document',0),(419503,11653,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã®ç½²åã®æ›´æ–°',0),(419504,11653,'pt','Documento de atualizaÃ§Ã£o de assinatura',0),(419505,11653,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(419506,11653,'es','ActualizaciÃ³n de Firma de Documento',0),(419507,11653,'de','Dokument signieren Update',0),(419508,11653,'en','Document Signing Update',0),(419509,11654,'is','',0),(419510,11654,'dr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(419511,11654,'pr','Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ø´Ø¯ ',0),(419512,11654,'tr','Belge baÅŸarÄ±yla GÃ¼ncellenme ZamanÄ± imzalama',0),(419513,11654,'pl','Dokument podpisania zaktualizowany pomyÅ›lnie',0),(419514,11654,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(419515,11654,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù¾Ø± Ø¯Ø³ØªØ®Ø·',0),(419516,11654,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(419517,11654,'vi','ÄÃ£ cáº­p nháº­t kÃ½ hiá»‡u chá»©ng tá»« thÃ nh cÃ´ng',0),(419518,11654,'af','Dokument onderteken suksesvol bygewerk',0),(419519,11654,'ro','Documentul semnarea actualizat cu succes',0),(419520,11654,'et','Dokumendi allkirjastamine edukalt vÃ¤rskendatud',0),(419521,11654,'si','Dokument podpis modernizirati uspeÅ¡no',0),(419522,11654,'ba','Dokumen penandatanganan diperbarui berhasil',0),(419523,11654,'nl','Document ondertekening met succes bijgewerkt',0),(419524,11654,'fi','Asiakirjan allekirjoittaminen pÃ¤ivitetty onnistuneesti',0),(419525,11654,'no','Dokumentet signering oppdatert vellykket',0),(419526,11654,'da','Dokument undertegnelsen opdateret med succes',0),(419527,11654,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ëœ ì„œëª… ë¬¸ì„œ',0),(419528,11654,'he','×”×ž×¡×ž×š ×—×ª×™×ž×ª ×ž×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(419529,11654,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Ï…Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(419530,11654,'zh','æˆåŠŸæ›´æ–°æ–‡ä»¶çš„ç­¾ç½²\r\n',0),(419531,11654,'sv','Dokumentet undertecknandet uppdaterad framgÃ¥ngsrikt',0),(419532,11654,'it','Documento firma aggiornato con successo',0),(419533,11654,'tl','',0),(419534,11654,'th','à¸¥à¸‡à¸™à¸²à¸¡à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(419535,11654,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¤¨à¥‡',0),(419536,11654,'ms','Dokumen yang menandatangani dikemaskini berjaya',0),(419537,11654,'ar','ÙˆØ«ÙŠÙ‚Ø© ØªÙˆÙ‚ÙŠØ¹ Ù…Ø­Ø¯Ø«Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(419538,11654,'fr','Document signature mise Ã  jour avec succÃ¨s',0),(419539,11654,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸç½²å',0),(419540,11654,'pt','Documento assinatura atualizada com Ãªxito',0),(419541,11654,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°, Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(419542,11654,'es','Firma de Documento Actualizado Exitosamente',0),(419543,11654,'de','Dokument signieren erfolgreich aktualisiert',0),(419544,11654,'en','Document Signing Updated Successfully',0),(419545,11655,'is','',0),(419546,11655,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(419547,11655,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(419548,11655,'tr','Kira isteÄŸi imza ekleme',0),(419549,11655,'pl','DodaÄ‡ Å¼Ä…dania podpisania umowy najmu',0),(419550,11655,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð·Ð°ÑÐ²ÐºÐ°',0),(419551,11655,'ur','Ù„ÛŒØ² Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Ø±Ù†Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(419552,11655,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð°ÐºÑƒÐ¿ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²',0),(419553,11655,'vi','ThÃªm yÃªu cáº§u kÃ½ thuÃª',0),(419554,11655,'af','Huurkontrak Ondertekening Versoek Byvoeg',0),(419555,11655,'ro','Adauga semnarea cererii de leasing',0),(419556,11655,'et','Lisada liisingu taotlus allkiri',0),(419557,11655,'si','Dodaj zakup zahtevo za podpisovanje',0),(419558,11655,'ba','Tambahkan sewa permintaan penandatanganan',0),(419559,11655,'nl','Lease ondertekening verzoek toevoegen',0),(419560,11655,'fi','LisÃ¤Ã¤ vuokrasopimuksen allekirjoituspyyntÃ¶',0),(419561,11655,'no','Legge til leie signeringsforespÃ¸rsel',0),(419562,11655,'da','TilfÃ¸je lejekontrakt underskrevet anmodning',0),(419563,11655,'ko','ìž„ëŒ€ ì„œëª… ìš”ì²­ ì¶”ê°€',0),(419564,11655,'he','×”×•×¡×¤×ª ×—×ª×™×ž×ª ×”×‘×§×©×” ×—×›×™×¨×”',0),(419565,11655,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ (Î±Î¯Ï„Î·ÏƒÎ·)',0),(419566,11655,'zh','å¢žåŠ ç§Ÿèµç­¾åè¯·æ±‚\r\n',0),(419567,11655,'sv','LÃ¤gg till hyresavtalet underteckna begÃ¤ran',0),(419568,11655,'it','Aggiungi firma la richiesta di locazione',0),(419569,11655,'tl','',0),(419570,11655,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸Šà¹ˆà¸²à¸„à¸³à¸‚à¸­à¸£à¸±à¸šà¸£à¸­à¸‡',0),(419571,11655,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤…à¤¨à¥à¤°à¥‹à¤§ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(419572,11655,'ms','Tambah pajakan permintaan menandatangani',0),(419573,11655,'ar','Ø¥Ø¶Ø§ÙØ© ØªÙˆÙ‚ÙŠØ¹ Ø·Ù„Ø¨ Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(419574,11655,'fr','Ajouter bail demande de signature',0),(419575,11655,'jp','ãƒªãƒ¼ã‚¹è¦æ±‚ã®ç½²åã®è¿½åŠ ã—ã¾ã™ã€‚',0),(419576,11655,'pt','Adicionar assinatura pedido de locaÃ§Ã£o',0),(419577,11655,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(419578,11655,'es','Agregar Solicitud de Firmar Contrato de Arrendimiento',0),(419579,11655,'de','FÃ¼gen Zuordnung Signing Request hinzu',0),(419580,11655,'en','Add Lease Signing Request',0),(419581,11656,'is','',0),(419582,11656,'dr','Ø­Ø°Ù Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§ Ø§Ø¬Ø§Ø±Ù‡ ',0),(419583,11656,'pr','Ø­Ø°Ù Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§ Ø§Ø¬Ø§Ø±Ù‡ ',0),(419584,11656,'tr','Delete Lease istek imza',0),(419585,11656,'pl','DELETE Lease Å¼Ä…dania podpisania',0),(419586,11656,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð·Ð°ÑÐ²ÐºÐ°',0),(419587,11656,'ur','Ù„ÛŒØ² Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(419588,11656,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð·Ð°ÐºÑƒÐ¿ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²',0),(419589,11656,'vi','Äá» nghá»‹ xÃ³a bá» há»£p Ä‘á»“ng thuÃª',0),(419590,11656,'af','Skrap Huurkontrak Ondertekeningsversoek',0),(419591,11656,'ro','ÅžtergeÅ£i semnarea cererii de leasing',0),(419592,11656,'et','Kustuta allkiri Ã¼Ã¼rilepingu',0),(419593,11656,'si','Izbrisati zakup zahtevo za podpisovanje',0),(419594,11656,'ba','Menghapus sewa permintaan penandatanganan',0),(419595,11656,'nl','Lease ondertekening verzoek verwijderen',0),(419596,11656,'fi','Delete Lease allekirjoituspyyntÃ¶',0),(419597,11656,'no','Delete Lease signeringsforespÃ¸rsel',0),(419598,11656,'da','Slette lejekontrakt underskrevet anmodning',0),(419599,11656,'ko','ìž„ëŒ€ ì„œëª… ìš”ì²­ ì‚­ì œ',0),(419600,11656,'he','×ž×—×§ ×‘×§×©×” ×œ×—×ª×™×ž×ª ×”×—×•×–×”',0),(419601,11656,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ (Î±Î¯Ï„Î·ÏƒÎ·)',0),(419602,11656,'zh','åˆ é™¤ç§Ÿèµç­¾åè¯·æ±‚\r\n',0),(419603,11656,'sv','Ta bort lÃ¥net underteckna begÃ¤ran',0),(419604,11656,'it','Eliminare la firma richiesta di locazione',0),(419605,11656,'tl','',0),(419606,11656,'th','à¸¥à¸šà¸„à¸³à¸‚à¸­à¸£à¸±à¸šà¸£à¸­à¸‡à¸à¸²à¸£à¹€à¸Šà¹ˆà¸²',0),(419607,11656,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¹à¤Ÿà¤¾ à¤¦à¥‡à¤‚',0),(419608,11656,'ms','Menghapuskan permintaan menandatangani pajakan',0),(419609,11656,'ar','Ø­Ø°Ù Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù„Ù‰ Ø·Ù„Ø¨ Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(419610,11656,'fr','Supprimer la demande de signature de bail',0),(419611,11656,'jp','ãƒªãƒ¼ã‚¹è¦æ±‚ã®ç½²åã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(419612,11656,'pt','Excluir a assinar o pedido de locaÃ§Ã£o',0),(419613,11656,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹ Ð°Ð´Ñ€ÐµÑÐ°, Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(419614,11656,'es','Eliminar Solicitud Para Firmar Contrato de Arrendimiento',0),(419615,11656,'de','Lease Signing Request gelÃ¶scht',0),(419616,11656,'en','Delete Lease Signing Request',0),(419617,11657,'is','',0),(419618,11657,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(419619,11657,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø­Ø°Ù Ø´Ø¯ ',0),(419620,11657,'tr','Belge imzalama isteÄŸi baÅŸarÄ±yla silindi',0),(419621,11657,'pl','UsuniÄ™te pomyÅ›lnie Å¼Ä…dania podpisania dokumentu',0),(419622,11657,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð·Ð°ÑÐ²ÐºÐ° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(419623,11657,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø·',0),(419624,11657,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(419625,11657,'vi','XÃ³a Ä‘á» nghá»‹ kÃ½ hiá»‡u chá»©ng tá»« thÃ nh cÃ´ng',0),(419626,11657,'af','Dokument onderteken versoek suksesvol geskrap',0),(419627,11657,'ro','Documentul semnarea cerere eliminÄƒ cu succes',0),(419628,11657,'et','Dokumendi allkirjastamine edukalt kustutatud taotluse',0),(419629,11657,'si','UspeÅ¡no izbrisana zahtevo za podpisovanje dokumenta',0),(419630,11657,'ba','Dokumen Signing Request yang berhasil dihapus',0),(419631,11657,'nl','Document ondertekening verzoek succesvol verwijderd',0),(419632,11657,'fi','Asiakirjan allekirjoituspyyntÃ¶ poistettu',0),(419633,11657,'no','Dokumentet signeringsforespÃ¸rsel slettet',0),(419634,11657,'da','Dokumentet underskrevet anmodning slettet',0),(419635,11657,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ìš”ì²­ì„ ì„œëª… í•˜ëŠ” ë¬¸ì„œ',0),(419636,11657,'he','×”×ž×¡×ž×š ×—×ª×™×ž×ª ×”×‘×§×©×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(419637,11657,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Î±Î¯Ï„Î·ÏƒÎ·Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚ Ï…Ï€Î¿Î³ÏÎ±Ï†Î®',0),(419638,11657,'zh','æ–‡ä»¶ç­¾ç½²è¯·æ±‚åˆ é™¤æˆåŠŸ\r\n',0),(419639,11657,'sv','Dokumentet underteckna begÃ¤ran raderades',0),(419640,11657,'it','Documento firma richiesta eliminato con successo',0),(419641,11657,'tl','',0),(419642,11657,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¸£à¸±à¸šà¸£à¸­à¸‡à¸‚à¸­à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(419643,11657,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(419644,11657,'ms','Permintaan yang dipadam berjaya menandatangani dokumen',0),(419645,11657,'ar','ÙˆØ«ÙŠÙ‚Ø© ØªÙˆÙ‚ÙŠØ¹ Ø·Ù„Ø¨ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(419646,11657,'fr','Document signature demande supprimÃ©e avec succÃ¨s',0),(419647,11657,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸè¦æ±‚ã¸ã®ç½²å',0),(419648,11657,'pt','Documento assinatura solicitaÃ§Ã£o apagada com sucesso',0),(419649,11657,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°, Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(419650,11657,'es','Solicitud de Firmar Documento Eliminado Exitosamente',0),(419651,11657,'de','Dokument Signing Request erfolgreich gelÃ¶scht',0),(419652,11657,'en','Document Signing Request Deleted Successfully',0),(419653,11658,'is','',0),(419654,11658,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯ ',0),(419655,11658,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯ ',0),(419656,11658,'tr','Belge baÅŸarÄ±yla gÃ¶nderildi istek imza',0),(419657,11658,'pl','Dokument dodano pomyÅ›lnie Å¼Ä…dania podpisania',0),(419658,11658,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¸ÑÐºÐ°Ð½ÐµÑ‚Ð¾, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(419659,11658,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¹Ø±Ø¶ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø·',0),(419660,11658,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ð¾Ð´Ð½ÐµÑ‚Ð¾Ð³ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°',0),(419661,11658,'vi','Äá»‡ trÃ¬nh kÃ½ hiá»‡u chá»©ng tá»« thÃ nh cÃ´ng',0),(419662,11658,'af','Dokument onderteken versoek suksesvol voorgelÃª',0),(419663,11658,'ro','Documentul semnarea cererii primite cu succes',0),(419664,11658,'et','Dokumendi allkirjastamine edukalt taotlust',0),(419665,11658,'si','Zahtevo, poslan za podpisovanje dokumenta',0),(419666,11658,'ba','Dokumen yang menandatangani permohonan berhasil',0),(419667,11658,'nl','Document ondertekening verzoek verzonden',0),(419668,11658,'fi','Asiakirjan allekirjoituspyyntÃ¶ lÃ¤hetys onnistui',0),(419669,11658,'no','Dokumentet signeringsforespÃ¸rsel sendt',0),(419670,11658,'da','Dokument underskrive anmodningen med succes',0),(419671,11658,'ko','ë¬¸ì„œ ì„œëª… ì„±ê³µì ìœ¼ë¡œ ì œì¶œ ìš”ì²­',0),(419672,11658,'he','×”×ž×¡×ž×š ×—×ª×™×ž×ª ×”×‘×§×©×” ×”×•×’×©×” ×‘×”×¦×œ×—×”',0),(419673,11658,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Ï€Î¿Ï… Ï…Ï€Î¿Î³ÏÎ¬Ï†ÎµÎ¹ Ï„Î·Î½ Î±Î¯Ï„Î·ÏƒÎ· Ï€Î¿Ï… Ï…Ï€Î¿Î²Î»Î®Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(419674,11658,'zh','æ–‡ä»¶ç­¾ç½²è¯·æ±‚æäº¤æˆåŠŸ\r\n',0),(419675,11658,'sv','Dokumentet underteckna begÃ¤ran framgÃ¥ngsrikt',0),(419676,11658,'it','Documento firma richiesta presentata con successo',0),(419677,11658,'tl','',0),(419678,11658,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¸„à¸³à¸‚à¸­à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§à¸£à¸±à¸šà¸£à¸­à¸‡',0),(419679,11658,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¬à¤®à¤¿à¤Ÿ',0),(419680,11658,'ms','Permintaan yang dikemukakan berjaya menandatangani dokumen',0),(419681,11658,'ar','ÙˆØ«ÙŠÙ‚Ø© ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ø·Ù„Ø¨ Ø§Ù„Ù…Ù‚Ø¯Ù… Ø¨Ù†Ø¬Ø§Ø­',0),(419682,11658,'fr','Document signature demande prÃ©sentÃ©e avec succÃ¨s',0),(419683,11658,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆãŒæ­£å¸¸ã«é€ä¿¡ã•ã‚ŒãŸè¦æ±‚ã¸ã®ç½²å',0),(419684,11658,'pt','Documento assinatura pedido enviado com sucesso',0),(419685,11658,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½ Ð½Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÑŒ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(419686,11658,'es','Solicitud de Firmar Documento Sometido Exitosamente',0),(419687,11658,'de','Dokument Signing Request erfolgreich',0),(419688,11658,'en','Document Signing Request Submitted Successfully',0),(419689,11659,'is','',0),(419690,11659,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ ',0),(419691,11659,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯ ',0),(419692,11659,'tr','Belge imzalama isteÄŸi silme hatasÄ±',0),(419693,11659,'pl','BÅ‚Ä…d podczas usuwania Å¼Ä…dania podpisania dokumentu',0),(419694,11659,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¸ÑÐºÐ°Ð½ÐµÑ‚Ð¾',0),(419695,11659,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ø­Ø°Ù Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(419696,11659,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²',0),(419697,11659,'vi','Lá»—i khi xÃ³a Ä‘á» nghá»‹ kÃ½ chá»©ng tá»«',0),(419698,11659,'af','Kon dokument onderteken versoek skrap',0),(419699,11659,'ro','Eroare la È™tergerea Document semnarea cererii',0),(419700,11659,'et','TÃµrge kustutamisel dokumendi taotlus allkiri',0),(419701,11659,'si','Napaka izbris zahtevo za podpisovanje dokumenta',0),(419702,11659,'ba','Error menghapus dokumen permintaan penandatanganan',0),(419703,11659,'nl','Fout bij het verwijderen van Document ondertekening verzoek',0),(419704,11659,'fi','Virhe poistettaessa asiakirjan allekirjoituspyyntÃ¶',0),(419705,11659,'no','Feil ved sletting av dokument signeringsforespÃ¸rsel',0),(419706,11659,'da','Fejl ved sletning af dokument underskrevet anmodning',0),(419707,11659,'ko','ë¬¸ì„œ ì„œëª… ìš”ì²­ ì‚­ì œ ì˜¤ë¥˜',0),(419708,11659,'he','×©×’×™××” ×‘×¢×ª ×ž×—×™×§×ª ×ž×¡×ž×š ×‘×§×©×” ×œ×—×ª×™×ž×ª',0),(419709,11659,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Ï‚ Ï„Î¿ Î­Î³Î³ÏÎ±Ï†Î¿ Î±Î¯Ï„Î·ÏƒÎ·Ï‚ Ï…Ï€Î¿Î³ÏÎ±Ï†Î®',0),(419710,11659,'zh','é”™è¯¯åˆ é™¤æ–‡ä»¶çš„ç­¾ç½²è¯·æ±‚\r\n',0),(419711,11659,'sv','Fel ta bort dokument underteckna begÃ¤ran',0),(419712,11659,'it','Errore documento firma la richiesta di eliminazione',0),(419713,11659,'tl','',0),(419714,11659,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸¥à¸šà¹€à¸­à¸à¸ªà¸²à¸£à¸„à¸³à¸‚à¸­à¸£à¸±à¸šà¸£à¸­à¸‡',0),(419715,11659,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(419716,11659,'ms','Ralat Menghapuskan permintaan menandatangani dokumen',0),(419717,11659,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­Ø°Ù Ø§Ù„ÙˆØ«ÙŠÙ‚Ø© ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ø·Ù„Ø¨',0),(419718,11659,'fr','Erreur de suppression de Document demande de signature',0),(419719,11659,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆè¦æ±‚ã®ç½²åã®å‰Šé™¤ã‚¨ãƒ©ãƒ¼',0),(419720,11659,'pt','Erro ao excluir o documento de solicitaÃ§Ã£o de assinatura',0),(419721,11659,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°, Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(419722,11659,'es','Error Eliminando la Solicitud de Firmar el Documento',0),(419723,11659,'de','Fehler beim LÃ¶schen der Document Signing Request',0),(419724,11659,'en','Error Deleting Document Signing Request',0),(419725,11660,'is','',0),(419726,11660,'dr','Ø®Ø·Ø§ ÙŠ Ø§Ø±Ø§Ø¦Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§ÙŠ Ø³Ù†Ø¯',0),(419727,11660,'pr','Ø®Ø·Ø§ ÙŠ Ø§Ø±Ø§Ø¦Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ù…Ø¶Ø§ÙŠ Ø³Ù†Ø¯',0),(419728,11660,'tr','Belge imzalama isteÄŸi gÃ¶nderme hatasÄ±',0),(419729,11660,'pl','BÅ‚Ä…d zÅ‚oÅ¼enia Å¼Ä…dania podpisania dokumentu',0),(419730,11660,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¸ÑÐºÐ°Ð½ÐµÑ‚Ð¾',0),(419731,11660,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ø¯Ø³ØªØ§ÙˆÛŒØ² Ø¨Ú¾ÛŒØ¬Ù†Û’ Ù†Ù‚Øµ',0),(419732,11660,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐ° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²',0),(419733,11660,'vi','Lá»—i khi trÃ¬nh kÃ½ Ä‘á» nghá»‹',0),(419734,11660,'af','Kon dokument onderteken versoek in te dien',0),(419735,11660,'ro','Eroare de depunerea documentului semnarea cererii',0),(419736,11660,'et','TÃµrge dokumendi allkirjastamine taotluse esitamise',0),(419737,11660,'si','Napaka, ki predloÅ¾i zahtevo za podpisovanje dokumenta',0),(419738,11660,'ba','Kesalahan mengirimkan dokumen permintaan penandatanganan',0),(419739,11660,'nl','Fout indienen van Document ondertekening verzoek',0),(419740,11660,'fi','Virhe lÃ¤hettÃ¤mÃ¤llÃ¤ asiakirjan allekirjoituspyyntÃ¶',0),(419741,11660,'no','Feil sender dokumentet signeringsforespÃ¸rsel',0),(419742,11660,'da','Fejl indsendelse dokument underskrevet anmodning',0),(419743,11660,'ko','ì˜¤ë¥˜ ì„œëª… ìš”ì²­ í•˜ëŠ” ë¬¸ì„œë¥¼ ì œì¶œ',0),(419744,11660,'he','×©×’×™××” ×”×’×©×ª ×‘×§×©×” ×œ×—×ª×™×ž×ª ×ž×¡×ž×š',0),(419745,11660,'el','Î£Ï†Î¬Î»Î¼Î± Ï…Ï€Î¿Î²Î¿Î»Î® ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï… Î±Î¯Ï„Î·ÏƒÎ·Ï‚ Ï…Ï€Î¿Î³ÏÎ±Ï†Î®',0),(419746,11660,'zh','é”™è¯¯æäº¤ç”³è¯·æ–‡ä»¶çš„ç­¾ç½²',0),(419747,11660,'sv','Fel att skicka dokumentet underteckna begÃ¤ran',0),(419748,11660,'it','Errore Invio documento firma richiesta',0),(419749,11660,'tl','',0),(419750,11660,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸ªà¹ˆà¸‡à¹€à¸­à¸à¸ªà¸²à¸£à¸„à¸³à¸‚à¸­à¸£à¸±à¸šà¸£à¸­à¸‡',0),(419751,11660,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(419752,11660,'ms','Ralat yang mengemukakan permintaan menandatangani dokumen',0),(419753,11660,'ar','Ø®Ø·Ø£ ÙÙŠ ØªÙ‚Ø¯ÙŠÙ… Ø§Ù„ÙˆØ«ÙŠÙ‚Ø© ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ø·Ù„Ø¨',0),(419754,11660,'fr','Erreur en soumettant la demande de signature de Document',0),(419755,11660,'jp','é€ä¿¡ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã®ç½²åè¦æ±‚ã‚¨ãƒ©ãƒ¼',0),(419756,11660,'pt','ApresentaÃ§Ã£o de documento de solicitaÃ§Ã£o de assinatura de erro',0),(419757,11660,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ð½Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÑŒ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(419758,11660,'es','Error Sometiendo Solicitud de Firma de Documento',0),(419759,11660,'de','Fehler senden Document Signing Request',0),(419760,11660,'en','Error Submitting Document Signing Request',0),(419761,11661,'is','',0),(419762,11661,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙˆØ¶Ø¹ÙŠØª Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯',0),(419763,11661,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† ÙˆØ¶Ø¹ÙŠØª Ø§Ù…Ø¶Ø§ Ø³Ù†Ø¯',0),(419764,11661,'tr','Belge durumu kayÄ±t gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(419765,11661,'pl','BÅ‚Ä…d podczas aktualizowania dokumentu rejestracji stanu',0),(419766,11661,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚, Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ‚Ð°',0),(419767,11661,'ur','Ø­Ø§Ù„Øª Ø¯Ø³ØªØ®Ø· Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(419768,11661,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(419769,11661,'vi','Lá»—i khi cáº­p nháº­t tÃ¬nh tráº¡ng kÃ½ chá»©ng tá»«',0),(419770,11661,'af','Kon dokument onderteken Status bywerk',0),(419771,11661,'ro','Eroare la actualizarea documentului semnarea statutului',0),(419772,11661,'et','Dokumendi allkirjastamine olekut vÃ¤rskendamise tÃµrge',0),(419773,11661,'si','Napaka pri posodabljanju dokumenta podpisu statusom',0),(419774,11661,'ba','Kesalahan memperbarui dokumen penandatanganan Status',0),(419775,11661,'nl','Fout bij het bijwerken van Document ondertekening Status',0),(419776,11661,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ asiakirjan allekirjoittaminen tila',0),(419777,11661,'no','Feil under oppdatering av dokumentet signering Status',0),(419778,11661,'da','Fejl under opdatering af dokumentet undertegnelsen Status',0),(419779,11661,'ko','ë¬¸ì„œ ì„œëª… ìƒíƒœ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(419780,11661,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×”×ž×¡×ž×š ×—×•×ª× ×¢×œ ×”×ž×¦×‘',0),(419781,11661,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…, Ï…Ï€Î¿Î³ÏÎ±Ï†Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(419782,11661,'zh','é”™è¯¯æ›´æ–°æ–‡ä»¶çš„ç­¾ç½²æƒ…å†µ\r\n',0),(419783,11661,'sv','Gick inte att uppdatera dokumentet undertecknandet Status',0),(419784,11661,'it','Errore aggiornamento documento firma Status',0),(419785,11661,'tl','',0),(419786,11661,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸­à¸à¸ªà¸²à¸£à¸£à¸±à¸šà¸£à¸­à¸‡à¸ªà¸–à¸²à¸™à¸°',0),(419787,11661,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(419788,11661,'ms','Ralat dalam mengemas kini dokumen menandatangani Status',0),(419789,11661,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙˆØ«ÙŠÙ‚Ø© ØªÙˆÙ‚ÙŠØ¹ Ù…Ø±ÙƒØ²',0),(419790,11661,'fr','Erreur mise Ã  jour Document signature statut',0),(419791,11661,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã®ç½²åã®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(419792,11661,'pt','Erro ao atualizar o Status de assinatura de documento',0),(419793,11661,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÐŸÑ€Ð¸ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑÐ° ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(419794,11661,'es','Error Actualizando el Estado de la Firma de Documento',0),(419795,11661,'de','Fehler beim Aktualisieren der Dokument signieren Status',0),(419796,11661,'en','Error Updating Document Signing Status',0),(419797,11662,'is','',0),(419798,11662,'dr','ØªØ§Ø±ÙŠØ® Ø§Ù†Ù‚Ø¶Ø§Ø¡ ',0),(419799,11662,'pr','ØªØ§Ø±ÙŠØ® Ø§Ù†Ù‚Ø¶Ø§Ø¡ ',0),(419800,11662,'tr','Son kullanma tarihi',0),(419801,11662,'pl','Data wygaÅ›niÄ™cia',0),(419802,11662,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ð½Ðµ',0),(419803,11662,'ur','Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(419804,11662,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸ÑÑ‚ÐµÐºÐ°',0),(419805,11662,'vi','Káº¿t thÃºc ngÃ y',0),(419806,11662,'af','Vervaldatum',0),(419807,11662,'ro','Data de expirare',0),(419808,11662,'et','AegumiskuupÃ¤ev',0),(419809,11662,'si','Datum poteka',0),(419810,11662,'ba','Tanggal kadaluarsa',0),(419811,11662,'nl','Vervaldatum',0),(419812,11662,'fi','Viimeinen kÃ¤yttÃ¶pÃ¤ivÃ¤',0),(419813,11662,'no','UtlÃ¸psdato',0),(419814,11662,'da','UdlÃ¸bsdato',0),(419815,11662,'ko','ë§Œë£Œ ë‚ ì§œ',0),(419816,11662,'he','×ª××¨×™×š ×ª×¤×•×’×”',0),(419817,11662,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(419818,11662,'zh','å¤±æ•ˆæ—¥æœŸ\r\n',0),(419819,11662,'sv','UtgÃ¥ngsdatum',0),(419820,11662,'it','Data di scadenza',0),(419821,11662,'tl','',0),(419822,11662,'th','à¸§à¸±à¸™à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(419823,11662,'hi','à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(419824,11662,'ms','Tarikh tamat tempoh',0),(419825,11662,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØµÙ„Ø§Ø­ÙŠØ©',0),(419826,11662,'fr','Date d\'expiration',0),(419827,11662,'jp','æœ‰åŠ¹æœŸé™ã®æ—¥ä»˜',0),(419828,11662,'pt','Data de validade',0),(419829,11662,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ ÑÑ€Ð¾ÐºÐ° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(419830,11662,'es','Fecha de Vencimiento',0),(419831,11662,'de','Ablaufdatum',0),(419832,11662,'en','Expiration Date',0),(419833,11663,'is','',0),(419834,11663,'dr','Ø¢Ø®Ø±ÙŠÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ',0),(419835,11663,'pr','Ø¢Ø®Ø±ÙŠÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÙŠ ',0),(419836,11663,'tr','Son GÃ¼ncellenme Tarihi',0),(419837,11663,'pl','Ostatnia aktualizacja',0),(419838,11663,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(419839,11663,'ur','Ø¢Ø®Ø±ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(419840,11663,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(419841,11663,'vi','cáº­p nháº­t cuá»‘i',0),(419842,11663,'af','Laaste opdatering',0),(419843,11663,'ro','Ultima actualizare',0),(419844,11663,'et','Viimane uuendus',0),(419845,11663,'si','Zadnja posodobitev',0),(419846,11663,'ba','Update terakhir',0),(419847,11663,'nl','Laatste Update',0),(419848,11663,'fi','Viimeksi pÃ¤ivitetty',0),(419849,11663,'no','Siste oppdatering',0),(419850,11663,'da','Sidste opdatering',0),(419851,11663,'ko','ë§ˆì§€ë§‰ ì—…ë°ì´íŠ¸',0),(419852,11663,'he','×¢×“×›×•×Ÿ ××—×¨×•×Ÿ',0),(419853,11663,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(419854,11663,'zh','æœ€åŽæ›´æ–°\r\n',0),(419855,11663,'sv','Senaste uppdatering',0),(419856,11663,'it','Ultimo aggiornamento',0),(419857,11663,'tl','',0),(419858,11663,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(419859,11663,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(419860,11663,'ms','Tarikh Kemaskini',0),(419861,11663,'ar','Ø¢Ø®Ø± ØªØ­Ø¯ÙŠØ«',0),(419862,11663,'fr','DerniÃ¨re mise Ã  jour',0),(419863,11663,'jp','æœ€å¾Œã®æ›´æ–°',0),(419864,11663,'pt','Ãšltima atualizaÃ§Ã£o',0),(419865,11663,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(419866,11663,'es','Ultima ActualizaciÃ³n',0),(419867,11663,'de','Letztes Update',0),(419868,11663,'en','Last Update',0),(419869,11664,'is','',0),(419870,11664,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(419871,11664,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø§Ø¬Ø§Ø±Ù‡ ',0),(419872,11664,'tr','Ä°mzalama isteklerini kira',0),(419873,11664,'pl','DzierÅ¼awy podpisywanie wnioski',0),(419874,11664,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð·Ð°ÑÐ²ÐºÐ¸',0),(419875,11664,'ur','Ù„ÛŒØ² Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(419876,11664,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ðµ Ð·Ð° Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ',0),(419877,11664,'vi','Ä‘á» nghá»‹ kÃ½ há»£p Ä‘á»“ng thuÃª',0),(419878,11664,'af','Huurkontrak Ondertekeningsversoeke',0),(419879,11664,'ro','Leasing semnare cereri',0),(419880,11664,'et','Liisi taotluste allkirjastamine',0),(419881,11664,'si','Zakup podpisovanje zahteve',0),(419882,11664,'ba','Sewa permintaan penandatanganan',0),(419883,11664,'nl','Lease ondertekening aanvragen',0),(419884,11664,'fi','Vuokrasopimuksen allekirjoittamisesta pyynnÃ¶t',0),(419885,11664,'no','Lease signeringsforespÃ¸rsler',0),(419886,11664,'da','Lease logge anmodninger',0),(419887,11664,'ko','ì„œëª… ìš”ì²­ ìž„ëŒ€',0),(419888,11664,'he','×©×›×™×¨×•×ª ×œ×—×ª×•× ×¢×œ ×‘×§×©×•×ª',0),(419889,11664,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Ï…Ï€Î¿Î³ÏÎ±Ï†Î® Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚',0),(419890,11664,'zh','ç§Ÿèµç­¾è®¢è¯·æ±‚\r\n',0),(419891,11664,'sv','Leasa underteckna begÃ¤ran',0),(419892,11664,'it','Leasing firma richieste',0),(419893,11664,'tl','',0),(419894,11664,'th','à¹€à¸Šà¹ˆà¸²à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸à¸²à¸£à¸£à¸±à¸šà¸£à¸­à¸‡',0),(419895,11664,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(419896,11664,'ms','Pajakan permintaan menandatangani',0),(419897,11664,'ar','Ø¥ÙŠØ¬Ø§Ø± Ø·Ù„Ø¨Ø§Øª ØªÙˆÙ‚ÙŠØ¹',0),(419898,11664,'fr','Demandes de signature de contrat de location',0),(419899,11664,'jp','ãƒªãƒ¼ã‚¹ç½²åè¦æ±‚',0),(419900,11664,'pt','Assinar pedidos de locaÃ§Ã£o',0),(419901,11664,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð² Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(419902,11664,'es','Solicitudes de Firmas de Arrendamiento',0),(419903,11664,'de','Leasing-Unterzeichnung-Anforderungen',0),(419904,11664,'en','Lease Signing Requests',0),(419905,11665,'is','',0),(419906,11665,'dr','1',0),(419907,11665,'pr','Ø§Ù…Ø¶Ø§Ø¡ Ú©Ù†Ù†Ø¯Ù‡    1',0),(419908,11665,'tr','Ä°mzalayanÄ±n 1',0),(419909,11665,'pl','Osoba podpisujÄ…ca 1',0),(419910,11665,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ 1',0),(419911,11665,'ur','Ø¯Ø³ØªØ®Ø· Ú©Ù†Ù†Ø¯Û 1',0),(419912,11665,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ½Ð¸Ðº 1',0),(419913,11665,'vi','NgÆ°á»i kÃ½ 1',0),(419914,11665,'af','Ondertekenaar 1',0),(419915,11665,'ro','Semnatar 1',0),(419916,11665,'et','Allkirjastaja 1',0),(419917,11665,'si','Podpisnika 1',0),(419918,11665,'ba','Penandatangan 1',0),(419919,11665,'nl','Ondertekenaar 1',0),(419920,11665,'fi','Allekirjoittaja 1',0),(419921,11665,'no','Signataren 1',0),(419922,11665,'da','Underskriveren 1',0),(419923,11665,'ko','ì„œëª…ìž 1',0),(419924,11665,'he','×—×•×ª× 1',0),(419925,11665,'el','Î¥Ï€Î¿Î³ÏÎ¬Ï†Ï‰Î½ 1',0),(419926,11665,'zh','ç­¾åè€…ä¸€\r\n',0),(419927,11665,'sv','Signerat 1',0),(419928,11665,'it','Firmatario 1',0),(419929,11665,'tl','',0),(419930,11665,'th','à¸œà¸¹à¹‰à¸¥à¸‡à¸™à¸²à¸¡ 1',0),(419931,11665,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤•à¤°à¥à¤¤à¤¾ 1',0),(419932,11665,'ms','Penandatangan 1',0),(419933,11665,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ 1',0),(419934,11665,'fr','Signataire 1',0),(419935,11665,'jp','ç½²å 1',0),(419936,11665,'pt','SignatÃ¡rio 1',0),(419937,11665,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð²ÑˆÐµÐ³Ð¾ 1',0),(419938,11665,'es','Firmante 1',0),(419939,11665,'de','Signer 1',0),(419940,11665,'en','Signer 1',0),(419941,11666,'is','',0),(419942,11666,'dr','2',0),(419943,11666,'pr','Ø§Ù…Ø¶Ø§Ø¡ Ú©Ù†Ù†Ø¯Ù‡    2',0),(419944,11666,'tr','Ä°mzalayanÄ±n 2',0),(419945,11666,'pl','Osoba podpisujÄ…ca 2',0),(419946,11666,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ 2',0),(419947,11666,'ur','Ø¯Ø³ØªØ®Ø· Ú©Ù†Ù†Ø¯Û 2',0),(419948,11666,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ½Ð¸Ðº 2',0),(419949,11666,'vi','NgÆ°á»i kÃ½ 2',0),(419950,11666,'af','Ondertekenaar 2',0),(419951,11666,'ro','Semnatar 2',0),(419952,11666,'et','Allkirjastaja 2',0),(419953,11666,'si','Podpisnika 2',0),(419954,11666,'ba','Penandatangan 2',0),(419955,11666,'nl','Ondertekenaar 2',0),(419956,11666,'fi','Allekirjoittaja 2',0),(419957,11666,'no','Signataren 2',0),(419958,11666,'da','Underskriveren 2',0),(419959,11666,'ko','ì„œëª…ìž 2',0),(419960,11666,'he','×”×—×•×ª× 2',0),(419961,11666,'el','Î¥Ï€Î¿Î³ÏÎ¬Ï†Ï‰Î½ 2',0),(419962,11666,'zh','ç­¾åè€…2\r\n',0),(419963,11666,'sv','Signerat 2',0),(419964,11666,'it','Firmatario 2',0),(419965,11666,'tl','',0),(419966,11666,'th','à¸œà¸¹à¹‰à¸¥à¸‡à¸™à¸²à¸¡ 2',0),(419967,11666,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤•à¤°à¥à¤¤à¤¾ 2',0),(419968,11666,'ms','Penandatangan 2',0),(419969,11666,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ 2',0),(419970,11666,'fr','Signataire 2',0),(419971,11666,'jp','ç½²åè€… 2',0),(419972,11666,'pt','SignatÃ¡rio 2',0),(419973,11666,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ¸ 2',0),(419974,11666,'es','Firmante 2',0),(419975,11666,'de','Signer 2',0),(419976,11666,'en','Signer 2',0),(419977,11667,'is','',0),(419978,11667,'dr','Ù„ÙŠÙ†Ùƒ Ø§Ù…Ø¶Ø§Ø¡',0),(419979,11667,'pr','Ù„ÙŠÙ†Ùƒ Ø§Ù…Ø¶Ø§Ø¡',0),(419980,11667,'tr','Link imzalama',0),(419981,11667,'pl','Podpisanie Link',0),(419982,11667,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð²Ñ€ÑŠÐ·ÐºÐ°Ñ‚Ð°',0),(419983,11667,'ur','Ù„Ù†Ú© Ù¾Ø± Ø¯Ø³ØªØ®Ø·',0),(419984,11667,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð²ÐµÐ·Ñƒ',0),(419985,11667,'vi','kÃ½ liÃªn káº¿t',0),(419986,11667,'af','Skakel ondertekening',0),(419987,11667,'ro','Semnarea Link',0),(419988,11667,'et','Allkirjastamine Link',0),(419989,11667,'si','Podpis Link',0),(419990,11667,'ba','Penandatanganan Link',0),(419991,11667,'nl','Ondertekening van de Link',0),(419992,11667,'fi','Allekirjoittaa linkki',0),(419993,11667,'no','Signering Link',0),(419994,11667,'da','Underskrive Link',0),(419995,11667,'ko','ì„œëª… ë§í¬',0),(419996,11667,'he','×—×ª×™×ž×ª ×§×™×©×•×¨',0),(419997,11667,'el','Î¥Ï€Î¿Î³ÏÎ±Ï†Î® ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(419998,11667,'zh','ç­¾åé“¾æŽ¥\r\n',0),(419999,11667,'sv','Undertecknandet lÃ¤nk',0),(420000,11667,'it','Firma Link',0),(420001,11667,'tl','',0),(420002,11667,'th','à¸¥à¸‡à¸¥à¸´à¸‡à¸„à¹Œ',0),(420003,11667,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤‚à¤•',0),(420004,11667,'ms','Menandatangani Link',0),(420005,11667,'ar','Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù„Ù‰ Ø§Ù„Ø±Ø§Ø¨Ø·',0),(420006,11667,'fr','Signature lien',0),(420007,11667,'jp','ç½²åã®ãƒªãƒ³ã‚¯',0),(420008,11667,'pt','Assinatura Link',0),(420009,11667,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑÑÑ‹Ð»ÐºÑƒ',0),(420010,11667,'es','Enlace de Firmar',0),(420011,11667,'de','Unterzeichnung Link',0),(420012,11667,'en','Signing Link',0),(420013,11668,'is','',0),(420014,11668,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙˆØ¶Ø¹ÙŠØª',0),(420015,11668,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙˆØ¶Ø¹ÙŠØª',0),(420016,11668,'tr','GÃ¼ncelleÅŸtirme durumu',0),(420017,11668,'pl','Stan aktualizacji',0),(420018,11668,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾',0),(420019,11668,'ur','Ø­Ø§Ù„Øª ØªØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(420020,11668,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(420021,11668,'vi','Cáº­p nháº­t trÃ¬nh tráº¡ng',0),(420022,11668,'af','Status bywerk',0),(420023,11668,'ro','Actualizare Status',0),(420024,11668,'et','Uuenda olekut',0),(420025,11668,'si','Posodobite stanje',0),(420026,11668,'ba','Memperbarui Status',0),(420027,11668,'nl','Bijwerkstatus',0),(420028,11668,'fi','PÃ¤ivityksen tila',0),(420029,11668,'no','Oppdateringsstatus',0),(420030,11668,'da','Opdater Status',0),(420031,11668,'ko','ì—…ë°ì´íŠ¸ ìƒíƒœ',0),(420032,11668,'he','×¢×“×›×•×Ÿ ×ž×¦×‘',0),(420033,11668,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(420034,11668,'zh','æ›´æ–°çŠ¶æ€\r\n',0),(420035,11668,'sv','Uppdatera Status',0),(420036,11668,'it','Stato di aggiornamento',0),(420037,11668,'tl','',0),(420038,11668,'th','à¸­à¸±à¸žà¹€à¸”à¸•à¸ªà¸–à¸²à¸™à¸°',0),(420039,11668,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(420040,11668,'ms','Kemaskini Status',0),(420041,11668,'ar','Ø­Ø§Ù„Ø© Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(420042,11668,'fr','Mise Ã  jour de statut',0),(420043,11668,'jp','æ›´æ–°ãƒ—ãƒ­ã‚°ãƒ©ãƒ ã®çŠ¶æ…‹',0),(420044,11668,'pt','Status de atualizaÃ§Ã£o',0),(420045,11668,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(420046,11668,'es','Estado de ActualizaciÃ³n',0),(420047,11668,'de','Update-Status',0),(420048,11668,'en','Update Status',0),(420049,11669,'is','',0),(420050,11669,'dr','Ø§ÙŠÙ…ÙŠÙ„ Ù…Ø³ØªØ§Ø¬Ø± Ù…Ø´ØªØ±Ùƒ ',0),(420051,11669,'pr','Ø§ÙŠÙ…ÙŠÙ„ Ù…Ø³ØªØ§Ø¬Ø± Ù…Ø´ØªØ±Ùƒ ',0),(420052,11669,'tr','E-posta ortak kiracÄ±',0),(420053,11669,'pl','WspÃ³Å‚pracy najemca E-mail',0),(420054,11669,'bg','Ð¡ÑŠ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¸Ð¼ÐµÐ¹Ð»',0),(420055,11669,'ur','Ù…Ø®Ù„ÙˆØ· Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ø§ÛŒ Ù…ÛŒÙ„',0),(420056,11669,'sr','ÐšÐ¾Ð»ÐµÐ³Ð° ÑÑ‚Ð°Ð½Ð°Ñ€ Ð•Ð¼Ð°Ð¸Ð»',0),(420057,11669,'vi','thÆ° cá»§a ngÆ°á»i thuÃª nhÃ ',0),(420058,11669,'af','Mede-Huurder E-pos',0),(420059,11669,'ro','Co-chirias E-mail',0),(420060,11669,'et','KoostÃ¶Ã¶ Ã¼Ã¼rnik Email',0),(420061,11669,'si','Co-najemnik Email',0),(420062,11669,'ba','Rekan penyewa Email',0),(420063,11669,'nl','Co huurder E-mail',0),(420064,11669,'fi','YhteistyÃ¶tÃ¤ vuokralainen sÃ¤hkÃ¶posti',0),(420065,11669,'no','Co leietaker Email',0),(420066,11669,'da','Co lejer E-mail',0),(420067,11669,'ko','ê³µë™ ì„¸ ìž…ìž ì´ë©”ì¼',0),(420068,11669,'he','×”×“×™×™×¨ ×©×•×ª×£ ×“×•×',0),(420069,11669,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ ÏƒÏ…Î½-Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(420070,11669,'zh','åˆç§Ÿç”µé‚®\r\n',0),(420071,11669,'sv','Co hyresgÃ¤sten Email',0),(420072,11669,'it','Email co-inquilino',0),(420073,11669,'tl','',0),(420074,11669,'th','à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸œà¸¹à¹‰à¸£à¹ˆà¸§à¸¡',0),(420075,11669,'hi','à¤¸à¤¹ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤ˆà¤®à¥‡à¤²',0),(420076,11669,'ms','Bersama senarai pelanggan e-mel',0),(420077,11669,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¹Ù…ÙŠÙ„ Ù…Ø³ØªØ£Ø¬Ø±',0),(420078,11669,'fr','Colocataire Email',0),(420079,11669,'jp','å…±åŒãƒ†ãƒŠãƒ³ãƒˆ ãƒ¡ãƒ¼ãƒ«',0),(420080,11669,'pt','E-mail inquilino co',0),(420081,11669,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(420082,11669,'es','Email de Co-Inquilino',0),(420083,11669,'de','Co Mieter E-Mail',0),(420084,11669,'en','Co-Tenant Email',0),(420085,11670,'is','',0),(420086,11670,'dr','(Ù…Ø´Ø±ÙˆØ·',0),(420087,11670,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø³Ù†Ø¯ Ù…Ø¹ÙˆÙ‚(Ù…Ø´Ø±ÙˆØ·',0),(420088,11670,'tr','Bekleyen belge imzalama isteÄŸi',0),(420089,11670,'pl','Dokumentu oczekujÄ…cego Å¼Ä…dania podpisania',0),(420090,11670,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð·Ð°ÑÐ²ÐºÐ¸',0),(420091,11670,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÙˆÚº Ù¾Ø± Ø¯Ø³ØªØ®Ø·',0),(420092,11670,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð° Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(420093,11670,'vi','ChÆ°a lÃ m Ä‘á» nghá»‹ kÃ½ chá»©ng tá»« ',0),(420094,11670,'af','Hangende dokument onderteken versoeke',0),(420095,11670,'ro','Cereri semnarea documentului Ã®n curs',0),(420096,11670,'et','Ootel dokumendi allkirjastamine taotlused',0),(420097,11670,'si','Do dokumenta podpisovanje zahteve',0),(420098,11670,'ba','Permintaan penandatanganan tertunda dokumen',0),(420099,11670,'nl','In afwachting van Document ondertekening aanvragen',0),(420100,11670,'fi','Ennen asiakirjan allekirjoittamista pyynnÃ¶t',0),(420101,11670,'no','Dokumenter-signeringsforespÃ¸rsler',0),(420102,11670,'da','Ventende dokument logge anmodninger',0),(420103,11670,'ko','ë³´ë¥˜ ì¤‘ì¸ ë¬¸ì„œ ì„œëª… ìš”ì²­',0),(420104,11670,'he','×‘×§×©×•×ª ×—×ª×™×ž×ª ×ž×¡×ž×š ×ž×ž×ª×™×Ÿ',0),(420105,11670,'el','Î•Î½ Î±Î½Î±Î¼Î¿Î½Î® Î­Î³Î³ÏÎ±Ï†Î¿ Ï…Ï€Î¿Î³ÏÎ±Ï†Î® Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚',0),(420106,11670,'zh','å¾…åŠžæ–‡ä»¶çš„ç­¾ç½²è¦æ±‚\r\n',0),(420107,11670,'sv','PÃ¥gÃ¥ende underteckna begÃ¤ran',0),(420108,11670,'it','Richieste di firma di documenti in sospeso',0),(420109,11670,'tl','',0),(420110,11670,'th','à¸„à¸³à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸£à¸±à¸šà¸£à¸­à¸‡à¹€à¸­à¸à¸ªà¸²à¸£à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(420111,11670,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤²à¤‚à¤¬à¤¿à¤¤ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°',0),(420112,11670,'ms','Permintaan menandatangani dokumen yang belum selesai',0),(420113,11670,'ar','Ø·Ù„Ø¨Ø§Øª ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø§Ù„Ù…Ø¹Ù„Ù‚',0),(420114,11670,'fr','Demandes de signature de documents en attente',0),(420115,11670,'jp','ä¿ç•™ä¸­ã®ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã®ç½²åã®è¦æ±‚',0),(420116,11670,'pt','Pedidos de assinatura de documento pendente',0),(420117,11670,'ru','Ð’ Ð¾Ð¶Ð¸Ð´Ð°Ð½Ð¸Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð²',0),(420118,11670,'es','Solicitudes de Firmas de Documentos Pendientes',0),(420119,11670,'de','Ausstehende Dokument signieren Anfragen',0),(420120,11670,'en','Pending Document Signing Requests',0),(420121,11671,'is','',0),(420122,11671,'dr','(Ø§Ù…Ø¶Ø§Ø¡',0),(420123,11671,'pr','Ø¹Ù„Ø§Ù…Øª (Ø§Ù…Ø¶Ø§Ø¡',0),(420124,11671,'tr','Ä°ÅŸareti',0),(420125,11671,'pl','Znak',0),(420126,11671,'bg','Ð—Ð½Ð°Ðº',0),(420127,11671,'ur','Ù†Ø´Ø§Ù†ÛŒ',0),(420128,11671,'sr','Ð—Ð½Ð°Ðº',0),(420129,11671,'vi','kÃ½',0),(420130,11671,'af','Teken',0),(420131,11671,'ro','Semn',0),(420132,11671,'et','MÃ¤rk',0),(420133,11671,'si','Znak',0),(420134,11671,'ba','Tanda',0),(420135,11671,'nl','Teken',0),(420136,11671,'fi','Merkki',0),(420137,11671,'no','Tegn',0),(420138,11671,'da','Tegn',0),(420139,11671,'ko','ë¡œê·¸ì¸',0),(420140,11671,'he','×¡×™×ž×Ÿ',0),(420141,11671,'el','Î£Î·Î¼Î¬Î´Î¹',0),(420142,11671,'zh','èµ¶å¿«\r\n',0),(420143,11671,'sv','Tecken',0),(420144,11671,'it','Segno',0),(420145,11671,'tl','',0),(420146,11671,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(420147,11671,'hi','à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(420148,11671,'ms','Tanda',0),(420149,11671,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(420150,11671,'fr','Signe',0),(420151,11671,'jp','è¨˜å·',0),(420152,11671,'pt','Sinal',0),(420153,11671,'ru','Ð—Ð½Ð°Ðº',0),(420154,11671,'es','Firmar',0),(420155,11671,'de','Zeichen',0),(420156,11671,'en','Sign',0),(420157,11672,'is','',0),(420158,11672,'dr','1  Ù…Ø³ØªØ§Ø¬Ø±',0),(420159,11672,'pr','Ø§Ù…Ø¶Ø§Ø¡  1  Ù…Ø³ØªØ§Ø¬Ø±',0),(420160,11672,'tr','KiracÄ± 1 iÅŸareti',0),(420161,11672,'pl','Najemcy 1 znak',0),(420162,11672,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» 1 Ð·Ð½Ð°Ðº',0),(420163,11672,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± 1 Ø³Ø§Ø¦Ù† Ø§Ù† Ú©Ø±ÛŒÚº',0),(420164,11672,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ 1 Ð·Ð½Ð°Ðº',0),(420165,11672,'vi','NgÆ°á»i thuÃª nhÃ  thá»© 1 kÃ½',0),(420166,11672,'af','Huurder 1 Handtekening',0),(420167,11672,'ro','ChiriaÅŸ 1 semn',0),(420168,11672,'et','Rentnike 1 mÃ¤rk',0),(420169,11672,'si','Najemnik 1 znak',0),(420170,11672,'ba','Tanda penyewa 1',0),(420171,11672,'nl','Huurder 1 teken',0),(420172,11672,'fi','Vuokralainen 1 merkki',0),(420173,11672,'no','Leietaker 1 tegn',0),(420174,11672,'da','Lejer 1 tegn',0),(420175,11672,'ko','ê±°ì£¼ìž 1 ê¸°í˜¸',0),(420176,11672,'he','×“×™×™×¨ ×¡×™×ž×Ÿ 1',0),(420177,11672,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î® 1 ÏƒÎ·Î¼Î¬Î´Î¹',0),(420178,11672,'zh','ä¸šæƒäºº1ç­¾å\r\n',0),(420179,11672,'sv','HyresgÃ¤st 1 tecken',0),(420180,11672,'it','Inquilino 1 segno',0),(420181,11672,'tl','',0),(420182,11672,'th','à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸² 1 à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡',0),(420183,11672,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° 1 à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(420184,11672,'ms','Tanda penyewa 1',0),(420185,11672,'ar','ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± 1',0),(420186,11672,'fr','Locataire 1 signe',0),(420187,11672,'jp','ãƒ†ãƒŠãƒ³ãƒˆã® 1 è¨˜å·',0),(420188,11672,'pt','Inquilino 1 sinal',0),(420189,11672,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ 1 Ð·Ð½Ð°Ðº',0),(420190,11672,'es','Inquilino 1 Firmar',0),(420191,11672,'de','Mieter 1 Zeichen',0),(420192,11672,'en','Tenant 1 Sign',0),(420193,11673,'is','',0),(420194,11673,'dr','2  Ù…Ø³ØªØ§Ø¬Ø± ',0),(420195,11673,'pr','Ø§Ù…Ø¶Ø§Ø¡ 2  Ù…Ø³ØªØ§Ø¬Ø± ',0),(420196,11673,'tr','KiracÄ± 2 iÅŸareti',0),(420197,11673,'pl','Najemcy 2 znak',0),(420198,11673,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» 2 Ð·Ð½Ð°Ðº',0),(420199,11673,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± 2 Ø³Ø§Ø¦Ù† Ø§Ù† Ú©Ø±ÛŒÚº',0),(420200,11673,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ 2 Ð·Ð½Ð°ÐºÐ°',0),(420201,11673,'vi','NgÆ°á»i thuÃª nhÃ  thá»© 2 kÃ½',0),(420202,11673,'af','Huurder 2 Handtekening',0),(420203,11673,'ro','ChiriaÅŸ 2 semn',0),(420204,11673,'et','ÃœÃ¼rnik 2 mÃ¤rk',0),(420205,11673,'si','Najemnik 2 znak',0),(420206,11673,'ba','Tanda penyewa 2',0),(420207,11673,'nl','Huurder 2 teken',0),(420208,11673,'fi','Vuokralainen 2 merkki',0),(420209,11673,'no','Leietaker 2 tegn',0),(420210,11673,'da','Lejer 2 tegn',0),(420211,11673,'ko','ê±°ì£¼ìž 2 ê¸°í˜¸',0),(420212,11673,'he','×“×™×™×¨ ×¡×™×ž×Ÿ 2',0),(420213,11673,'el','Î£Î·Î¼Î¬Î´Î¹ Î¼Î¹ÏƒÎ¸Ï‰Ï„Î® 2',0),(420214,11673,'zh','ä¸šæƒäºº2ç­¾å\r\n',0),(420215,11673,'sv','HyresgÃ¤sten 2 tecken',0),(420216,11673,'it','Inquilino 2 segno',0),(420217,11673,'tl','',0),(420218,11673,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¹€à¸Šà¹ˆà¸² 2',0),(420219,11673,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° 2 à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(420220,11673,'ms','Penyewa 2 tanda',0),(420221,11673,'ar','ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± 2',0),(420222,11673,'fr','Locataire 2 signe',0),(420223,11673,'jp','ãƒ†ãƒŠãƒ³ãƒˆ 2 è¨˜å·',0),(420224,11673,'pt','Inquilino 2 sinal',0),(420225,11673,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ 2 Ð·Ð½Ð°Ðº',0),(420226,11673,'es','Inquilino 2 Firmar',0),(420227,11673,'de','Mieter 2 Zeichen',0),(420228,11673,'en','Tenant 2 Sign',0),(420229,11674,'is','',0),(420230,11674,'dr','Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ù…Ø­ÙˆØ·Ù‡  Ú†Ù…Ù†',0),(420231,11674,'pr','Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ù…Ø­ÙˆØ·Ù‡  Ú†Ù…Ù†',0),(420232,11674,'tr','Ã‡im bakÄ±mÄ±',0),(420233,11674,'pl','Trawnik',0),(420234,11674,'bg','Ð¢Ñ€ÐµÐ²Ð½Ð¸ Ð¿Ð»Ð¾Ñ‰Ð¸',0),(420235,11674,'ur','Ù„Ø§Ù† Ú©ÛŒ Ø¯ÛŒÚ©Ú¾ Ø¨Ú¾Ø§Ù„',0),(420236,11674,'sr','Ð¢Ñ€Ð°Ð²ÑšÐ°ÐºÐ°',0),(420237,11674,'vi','Lawn Care',0),(420238,11674,'af','Grasperk sorg',0),(420239,11674,'ro','Lawn Ã®ngrijire',0),(420240,11674,'et','Muru hooldus',0),(420241,11674,'si','Nego trate',0),(420242,11674,'ba','Perawatan rumput',0),(420243,11674,'nl','Zorg van het gazon',0),(420244,11674,'fi','Nurmikonhoito',0),(420245,11674,'no','Hagestell',0),(420246,11674,'da','PlÃ¦nepleje',0),(420247,11674,'ko','ìž”ë””ë°­ ë°°ë ¤',0),(420248,11674,'he','×˜×™×¤×•×— ×”×“×©×',0),(420249,11674,'el','Î§Î»Î¿Î¿ÎºÎ¿Ï€Ï„Î¹ÎºÎ­Ï‚ Î¼Î·Ï‡Î±Î½Î­Ï‚',0),(420250,11674,'zh','è‰åªæŠ¤ç†\r\n',0),(420251,11674,'sv','Lawn Care',0),(420252,11674,'it','Cura del prato inglese',0),(420253,11674,'tl','',0),(420254,11674,'th','à¸”à¸¹à¹à¸¥à¸ªà¸™à¸²à¸¡à¸«à¸à¹‰à¸²',0),(420255,11674,'hi','à¤²à¥‰à¤¨ à¤•à¥€ à¤¦à¥‡à¤–à¤­à¤¾à¤²',0),(420256,11674,'ms','Penjagaan rumput',0),(420257,11674,'ar','Ø§Ù„Ø±Ø¹Ø§ÙŠØ© ÙÙŠ Ø§Ù„Ø­Ø¯ÙŠÙ‚Ø©',0),(420258,11674,'fr','Entretien des gazons',0),(420259,11674,'jp','èŠç”Ÿã®å¿ƒé…',0),(420260,11674,'pt','Cuidado do gramado',0),(420261,11674,'ru','Ð£Ñ…Ð¾Ð´ Ð·Ð° Ð³Ð°Ð·Ð¾Ð½Ð¾Ð¼',0),(420262,11674,'es','Mantenimiento de CÃ©sped',0),(420263,11674,'de','Rasenpflege',0),(420264,11674,'en','Lawn Care',0),(420265,11675,'is','',0),(420266,11675,'dr','Ø¶Ù…ÙŠÙ…Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ ',0),(420267,11675,'pr','Ø¶Ù…ÙŠÙ…Ù‡ Ø³Ù¾Ø±Ø¯Ù‡ ',0),(420268,11675,'tr','ACH mevduat',0),(420269,11675,'pl','ACH depozytu',0),(420270,11675,'bg','ACH Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(420271,11675,'ur','Ø§Ú† ÚˆÙ¾Ø§Ø²Ù¹',0),(420272,11675,'sr','ÐÑ… Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(420273,11675,'vi','KÃ½ quá»¹ ACH',0),(420274,11675,'af','ACH deposito',0),(420275,11675,'ro','ACH depozit',0),(420276,11675,'et','ACH tagatisraha',0),(420277,11675,'si','ACH depozit',0),(420278,11675,'ba','ACH Deposit',0),(420279,11675,'nl','ACH storting',0),(420280,11675,'fi','ACH talletus',0),(420281,11675,'no','ACH innskudd',0),(420282,11675,'da','ACH depositum',0),(420283,11675,'ko','ACH ì˜ˆê¸ˆ',0),(420284,11675,'he','ACH ×¤×™×§×“×•×Ÿ',0),(420285,11675,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· ACH',0),(420286,11675,'zh','è‡ªåŠ¨åŒ–äº¤æ˜“æ‰€çš„å­˜æ¬¾\r\n',0),(420287,11675,'sv','ACH insÃ¤ttning',0),(420288,11675,'it','Deposito ACH',0),(420289,11675,'tl','',0),(420290,11675,'th','à¸à¸²à¸ ACH',0),(420291,11675,'hi','ACH à¤œà¤®à¤¾',0),(420292,11675,'ms','Deposit men',0),(420293,11675,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(420294,11675,'fr','DÃ©pot ODC',0),(420295,11675,'jp','ACH ã®æ²ˆæ®¿ç‰©',0),(420296,11675,'pt','DepÃ³sito ACH',0),(420297,11675,'ru','ACH Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(420298,11675,'es','DepÃ³sito ACH',0),(420299,11675,'de','ACH Einzahlung',0),(420300,11675,'en','ACH Deposit',0),(420301,11676,'is','',0),(420302,11676,'dr','Ú†Ùƒ ÙŠØ§ Ø´Ù†Ø§Ø³Ù‡ Ø³Ù¾Ø±Ø¯Ù‡',0),(420303,11676,'pr','Ú†Ùƒ ÙŠØ§ Ø´Ù†Ø§Ø³Ù‡ Ø³Ù¾Ø±Ø¯Ù‡',0),(420304,11676,'tr','Ã‡ek veya para yatÄ±rma kimliÄŸi',0),(420305,11676,'pl','Wyboru lub depozytu ID',0),(420306,11676,'bg','Ð§ÐµÐº Ð¸Ð»Ð¸ Ð˜Ð” Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(420307,11676,'ur','Ú†ÛŒÚ© ÛŒØ§ Ø¬Ù…Ø¹ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(420308,11676,'sr','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð˜Ð” Ð¸Ð»Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(420309,11676,'vi','MÃ£ sÃ©c hoáº·c kÃ½ quá»¹',0),(420310,11676,'af','Tjek of Deposito ID',0),(420311,11676,'ro','CEC sau depunere ID',0),(420312,11676,'et','Kontrolli vÃµi tagatisraha ID',0),(420313,11676,'si','Preverite, ali depozit ID',0),(420314,11676,'ba','Cek atau Deposit ID',0),(420315,11676,'nl','Cheque of storting ID',0),(420316,11676,'fi','Uloskirjautuminen tai kemiallinen tunnus',0),(420317,11676,'no','Sjekk eller innskudd ID',0),(420318,11676,'da','Check eller indbetaling ID',0),(420319,11676,'ko','ìˆ˜ í‘œ ë˜ëŠ” ì˜ˆê¸ˆ ID',0),(420320,11676,'he','×”×¡×™×ž×•×Ÿ ××• ×”×¤×§×“×ª ×ž×–×”×”',0),(420321,11676,'el','Î•Ï€Î¹Ï„Î±Î³Î® Î® ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ID',0),(420322,11676,'zh','æ£€æŸ¥æˆ–æŽ¥å—å­˜æ¬¾çš„èº«ä»½è¯\r\n',0),(420323,11676,'sv','Check eller insÃ¤ttning-ID',0),(420324,11676,'it','Assegno o deposito ID',0),(420325,11676,'tl','',0),(420326,11676,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¸«à¸£à¸·à¸­à¸£à¸«à¸±à¸ªà¹€à¸‡à¸´à¸™à¸à¸²à¸',0),(420327,11676,'hi','à¤šà¥‡à¤• à¤¯à¤¾ à¤œà¤®à¤¾ ID',0),(420328,11676,'ms','Cek atau Deposit ID',0),(420329,11676,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø£Ùˆ Ù…Ø¹Ø±Ù Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(420330,11676,'fr','ChÃ¨que ou dÃ©pÃ´t ID',0),(420331,11676,'jp','ãƒã‚§ãƒƒã‚¯ã¾ãŸã¯å…¥é‡‘ ID',0),(420332,11676,'pt','Cheque ou depÃ³sito ID',0),(420333,11676,'ru','Ð§ÐµÐº Ð¸Ð»Ð¸ ID Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(420334,11676,'es','ID De Cheque o DepÃ³sito',0),(420335,11676,'de','Scheck oder Hinterlegung ID',0),(420336,11676,'en','Check or Deposit ID',0),(420337,11677,'is','',0),(420338,11677,'dr','Ø¯ÙØªØ± ØµØ¯ÙˆØ± Ú†Ú©',0),(420339,11677,'pr','Ø¯ÙØªØ± ØµØ¯ÙˆØ± Ú†Ú©',0),(420340,11677,'tr','KayÄ±t kontrol',0),(420341,11677,'pl','Rejestr wyboru',0),(420342,11677,'bg','Ð ÐµÐ³Ð¸ÑÑ‚ÑŠÑ€ Ð½Ð° Ñ‡ÐµÐºÐ¾Ð²Ð¸ ÐºÐ½Ð¸Ð¶ÐºÐ¸',0),(420343,11677,'ur','Ø±Ø¬Ø³Ù¹Ø± Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(420344,11677,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð´Ð½ÐµÐ²Ð½Ð¸Ðº',0),(420345,11677,'vi','Sá»• Ä‘Äƒng kÃ½ sÃ©c',0),(420346,11677,'af','Kontroleer Register',0),(420347,11677,'ro','VerificaÅ£i inregistrare',0),(420348,11677,'et','Kontrollige Register',0),(420349,11677,'si','Preveri Register',0),(420350,11677,'ba','Periksa daftar',0),(420351,11677,'nl','Register controleren',0),(420352,11677,'fi','Tarkistaa rekisterin',0),(420353,11677,'no','Sjekk Register',0),(420354,11677,'da','Check Register',0),(420355,11677,'ko','ë“±ë¡ í™•ì¸',0),(420356,11677,'he','×‘×“×•×§. ×”×¨×©×ž×”',0),(420357,11677,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î¿ Î¼Î·Ï„ÏÏŽÎ¿',0),(420358,11677,'zh','æ£€æŸ¥ç™»è®°\r\n',0),(420359,11677,'sv','Kontrollera Register',0),(420360,11677,'it','Controllare il registro',0),(420361,11677,'tl','',0),(420362,11677,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸—à¸°à¹€à¸šà¸µà¸¢à¸™',0),(420363,11677,'hi','à¤°à¤œà¤¿à¤¸à¥à¤Ÿà¤° à¤•à¥€ à¤œà¤¾à¤‚à¤š',0),(420364,11677,'ms','Semak Daftar',0),(420365,11677,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø³Ø¬Ù„',0),(420366,11677,'fr','VÃ©rifier le registre',0),(420367,11677,'jp','ãƒã‚§ãƒƒã‚¯ç™»éŒ²',0),(420368,11677,'pt','Verificar registo',0),(420369,11677,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€',0),(420370,11677,'es','Registro de Cheques',0),(420371,11677,'de','ÃœberprÃ¼fen Register',0),(420372,11677,'en','Check Register',0),(420373,11678,'is','',0),(420374,11678,'dr','Ø¯ÙØªØ± ÙƒÙ„ ',0),(420375,11678,'pr','Ø¯ÙØªØ± ÙƒÙ„ ',0),(420376,11678,'tr','GL',0),(420377,11678,'pl','GL',0),(420378,11678,'bg','GL',0),(420379,11678,'ur','Ø¬ÛŒØ¬Û’',0),(420380,11678,'sr','Ð“Ð›',0),(420381,11678,'vi','Sá»• cÃ¡i',0),(420382,11678,'af','AG',0),(420383,11678,'ro','GL',0),(420384,11678,'et','GL',0),(420385,11678,'si','GL',0),(420386,11678,'ba','GL',0),(420387,11678,'nl','GL',0),(420388,11678,'fi','GL',0),(420389,11678,'no','GL',0),(420390,11678,'da','GL',0),(420391,11678,'ko','GL',0),(420392,11678,'he','GL',0),(420393,11678,'el','GL',0),(420394,11678,'zh','æ€»å¸\r\n',0),(420395,11678,'sv','GL',0),(420396,11678,'it','GL',0),(420397,11678,'tl','',0),(420398,11678,'th','GL',0),(420399,11678,'hi','à¤œà¥€à¤à¤²',0),(420400,11678,'ms','GL',0),(420401,11678,'ar','Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(420402,11678,'fr','GL',0),(420403,11678,'jp','GL',0),(420404,11678,'pt','GL',0),(420405,11678,'ru','GL',0),(420406,11678,'es','LM',0),(420407,11678,'de','GL',0),(420408,11678,'en','GL',0),(420409,11679,'is','',0),(420410,11679,'dr','ÙƒÙ… ÙƒØ±Ø¯Ù† ',0),(420411,11679,'pr','ÙƒÙ… ÙƒØ±Ø¯Ù† ',0),(420412,11679,'tr','Ã‡Ä±karma',0),(420413,11679,'pl','Odejmij',0),(420414,11679,'bg','Ð˜Ð·Ð²Ð°Ð¶Ð´Ð°Ð½Ðµ',0),(420415,11679,'ur','Ú¯Ú¾Ù¹Ø§Ù†Ø§',0),(420416,11679,'sr','ÐžÐ´ÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ',0),(420417,11679,'vi','Trá»«',0),(420418,11679,'af','Trek',0),(420419,11679,'ro','Scade',0),(420420,11679,'et','Lahutamine',0),(420421,11679,'si','OdÅ¡tevanje',0),(420422,11679,'ba','Kurangi',0),(420423,11679,'nl','Aftrekken',0),(420424,11679,'fi','VÃ¤hennÃ¤',0),(420425,11679,'no','Trekk fra',0),(420426,11679,'da','Subtrahere',0),(420427,11679,'ko','ë¹¼ê¸°',0),(420428,11679,'he','×—×™×¡×•×¨',0),(420429,11679,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ·',0),(420430,11679,'zh','å‡åŽ»\r\n',0),(420431,11679,'sv','Subtrahera',0),(420432,11679,'it','Sottrarre',0),(420433,11679,'tl','',0),(420434,11679,'th','à¸¥à¸š',0),(420435,11679,'hi','à¤˜à¤Ÿà¤¾à¤¨à¤¾',0),(420436,11679,'ms','Tolak',0),(420437,11679,'ar','Ø·Ø±Ø­',0),(420438,11679,'fr','Soustraire',0),(420439,11679,'jp','æ¸›ç®—',0),(420440,11679,'pt','Subtrair',0),(420441,11679,'ru','Ð’Ñ‹Ñ‡Ð¸Ñ‚Ð°Ð½Ð¸Ðµ',0),(420442,11679,'es','Restar',0),(420443,11679,'de','Subtrahieren',0),(420444,11679,'en','Subtract',0),(420445,11680,'is','',0),(420446,11680,'dr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ù‚Ø¯Ø§Ø±',0),(420447,11680,'pr','Ø§Ø¨Ø·Ø§Ù„ Ù…Ù‚Ø¯Ø§Ø±',0),(420448,11680,'tr','GeÃ§ersiz miktar',0),(420449,11680,'pl','UtratÄ™ kwoty',0),(420450,11680,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð° ÑÑƒÐ¼Ð°',0),(420451,11680,'ur','Ø±Ù‚Ù… ØµÙØ±',0),(420452,11680,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð»Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(420453,11680,'vi','Sá»‘ tiá»n há»§y',0),(420454,11680,'af','Leemte bedrag',0),(420455,11680,'ro','SumÄƒ nulÄƒ',0),(420456,11680,'et','TÃ¼hine summa',0),(420457,11680,'si','Neveljaven znesek',0),(420458,11680,'ba','Jumlah Batal',0),(420459,11680,'nl','Ongeldig bedrag',0),(420460,11680,'fi','MitÃ¤tÃ¶n summa',0),(420461,11680,'no','Ugyldig belÃ¸p',0),(420462,11680,'da','Annulleret belÃ¸b',0),(420463,11680,'ko','Void ê¸ˆì•¡',0),(420464,11680,'he','×›×ž×•×ª void',0),(420465,11680,'el','Î†ÎºÏ…ÏÎ· Ï€Î¿ÏƒÏŒ',0),(420466,11680,'zh','ä½œåºŸæ•°é¢\r\n',0),(420467,11680,'sv','Ogiltigt belopp',0),(420468,11680,'it','Importo nullo',0),(420469,11680,'tl','',0),(420470,11680,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™',0),(420471,11680,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤°à¤¾à¤¶à¤¿',0),(420472,11680,'ms','Jumlah yang tidak sah',0),(420473,11680,'ar','Ù…Ù‚Ø¯Ø§Ø± Ø§Ù„ÙØ±Ø§Øº',0),(420474,11680,'fr','QuantitÃ© nulle',0),(420475,11680,'jp','Void é‡',0),(420476,11680,'pt','Quantidade void',0),(420477,11680,'ru','Void ÑÑƒÐ¼Ð¼Ð°',0),(420478,11680,'es','Cantidad Anulado',0),(420479,11680,'de','Void Betrag',0),(420480,11680,'en','Void Amount',0),(420481,11681,'is','',0),(420482,11681,'dr','Ú¯Ø±ÙˆÙ‡ Ùˆ ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡',0),(420483,11681,'pr','Ú¯Ø±ÙˆÙ‡ Ùˆ ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡',0),(420484,11681,'tr','Kategori ve maliyet kodu',0),(420485,11681,'pl','Kategoria i koszt kodu',0),(420486,11681,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¸ Ñ†ÐµÐ½Ð° ÐºÐ¾Ð´',0),(420487,11681,'ur','Ø²Ù…Ø±Û Ø§ÙˆØ± Ù„Ø§Ú¯Øª Ú©ÙˆÚˆ',0),(420488,11681,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÐºÐ¾Ð´Ð°',0),(420489,11681,'vi','Thá»ƒ loáº¡i vÃ  mÃ£ chi phÃ­',0),(420490,11681,'af','Kategorie en koste kode',0),(420491,11681,'ro','Categorie si cod de Cost',0),(420492,11681,'et','Kategooria ja kulude kood',0),(420493,11681,'si','Kategorije in stroÅ¡kovno kodo',0),(420494,11681,'ba','Kategori dan biaya kode',0),(420495,11681,'nl','Categorie en kosten Code',0),(420496,11681,'fi','Luokka ja kustannuskoodi',0),(420497,11681,'no','Kategori og kostnader kode',0),(420498,11681,'da','Kategori og omkostning kode',0),(420499,11681,'ko','ì¹´í…Œê³ ë¦¬ ë° ë¹„ìš©ëœ ì½”ë“œ',0),(420500,11681,'he','×§×˜×’×•×¨×™×” ×©×œ ×§×•×“ ×¢×œ×•×ª',0),(420501,11681,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎºÎ±Î¹ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ±',0),(420502,11681,'zh','åˆ†ç±»å’Œæˆæœ¬ä»£ç \r\n',0),(420503,11681,'sv','Kategori och kostnad kod',0),(420504,11681,'it','Categoria e codice costo',0),(420505,11681,'tl','',0),(420506,11681,'th','à¸›à¸£à¸°à¹€à¸ à¸—à¹à¸¥à¸°à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(420507,11681,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤”à¤° à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡',0),(420508,11681,'ms','Kos kod dan kategori',0),(420509,11681,'ar','Ø§Ù„ØªØµÙ†ÙŠÙ Ùˆ Ø±Ù…Ø² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(420510,11681,'fr','CatÃ©gorie et Code de coÃ»t',0),(420511,11681,'jp','ã‚«ãƒ†ã‚´ãƒªã¨ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰',0),(420512,11681,'pt','Categoria e cÃ³digo de custo',0),(420513,11681,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¸ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´',0),(420514,11681,'es','CÃ³digo de CategorÃ­a y Costo',0),(420515,11681,'de','Kategorie und Kosten-Code',0),(420516,11681,'en','Category and Cost Code',0),(420517,11682,'is','',0),(420518,11682,'dr','Ù†ÙˆØ³Ø§Ù†Ø§Øª Ù…Ø®Ø§Ø±Ø¬ ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡',0),(420519,11682,'pr','Ù†ÙˆØ³Ø§Ù†Ø§Øª Ù…Ø®Ø§Ø±Ø¬ ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡',0),(420520,11682,'tr','Kabul edilen maliyet sapmasÄ±',0),(420521,11682,'pl','PopeÅ‚nione wariancji kosztÃ³w',0),(420522,11682,'bg','Ð˜Ð·Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ñ€Ð°Ð·Ð»Ð¸ÐºÐ¸ Ð² ÑÐµÐ±ÐµÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(420523,11682,'ur','Ù„Ø§Ú¯Øª ØªØºÛŒØ± Ú©Ø§ Ø§Ø±ØªÚ©Ø§Ø¨ Ú©ÛŒØ§',0),(420524,11682,'sr','ÐŸÐ¾Ñ‡Ð¸Ð½Ð¸Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¾Ð´ÑÑ‚ÑƒÐ¿Ð°ÑšÐ°',0),(420525,11682,'vi','sá»± khÃ¡c nhau vá» chi phÃ­ cam káº¿t',0),(420526,11682,'af','Toegewyde koste variansie',0),(420527,11682,'ro','VariaÅ£ia costurilor angajat',0),(420528,11682,'et','Toime pandi maksumuse erinevus',0),(420529,11682,'si','Zavezana stroÅ¡kovno Variance',0),(420530,11682,'ba','Berkomitmen varians biaya',0),(420531,11682,'nl','Begaan van de afwijking van de kosten',0),(420532,11682,'fi','Sitoutunut arvostusvaihtoehdot',0),(420533,11682,'no','Igangsatt kostnad avvik',0),(420534,11682,'da','BegÃ¥et omkostninger afvigelse',0),(420535,11682,'ko','íˆ¬ìž…ëœ ë¹„ìš©ëœ ì°¨ì´',0),(420536,11682,'he','×¡×˜×™×™×ª ×¢×œ×•×ª ×ž×—×•×™×‘×ª',0),(420537,11682,'el','Î”ÎµÏƒÎ¼ÎµÏ…Ï„ÎµÎ¯ Î´Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ· ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(420538,11682,'zh','æ‰¿è¯ºæˆæœ¬å·®å¼‚\r\n',0),(420539,11682,'sv','UtfÃ¤sta kostnader varians',0),(420540,11682,'it','Commesso la varianza di costo',0),(420541,11682,'tl','',0),(420542,11682,'th','à¸œà¸¥à¸•à¹ˆà¸²à¸‡à¸•à¹‰à¸™à¸—à¸¸à¸™à¸œà¸¹à¸à¸¡à¸±à¸”',0),(420543,11682,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§ à¤²à¤¾à¤—à¤¤ à¤µà¤¿à¤šà¤°à¤£',0),(420544,11682,'ms','Perbezaan kos yang komited',0),(420545,11682,'ar','Ø§Ø±ØªÙƒØ¨Øª ØªØ¨Ø§ÙŠÙ† Ø§Ù„ØªÙƒÙ„ÙØ©',0),(420546,11682,'fr','Variance coÃ»t engagÃ©e',0),(420547,11682,'jp','ã‚³ã‚¹ãƒˆã®å·®ç•°ã‚’ã‚³ãƒŸãƒƒãƒˆ',0),(420548,11682,'pt','VariaÃ§Ã£o de custo comprometida',0),(420549,11682,'ru','Ð¡Ð¾Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ñ‹Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ Ð¾Ñ‚ÐºÐ»Ð¾Ð½ÐµÐ½Ð¸Ð¹',0),(420550,11682,'es','VariaciÃ³n de Costo Comprometido',0),(420551,11682,'de','Foul Cost Variance',0),(420552,11682,'en','Committed Cost Variance',0),(420553,11683,'is','',0),(420554,11683,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ',0),(420555,11683,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø¨Øªâ€Œ Ø´Ø¯Ù‡â€Œ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨â€Œ',0),(420556,11683,'tr','Fatura tutarÄ±',0),(420557,11683,'pl','Kwota rozliczenia',0),(420558,11683,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸ ÑÑƒÐ¼Ð°',0),(420559,11683,'ur','Ø¨Ø§Ù„Ù„Ø§Ø¯ Ù…Ù‚Ø¯Ø§Ø±',0),(420560,11683,'sr','ÐšÑƒÐ¿Ð¾Ð²Ð¸Ð½Ð° Ñ‚ÐµÑ€ÐµÑ‚Ð¸Ñ›Ðµ Ð¸Ð·Ð½Ð¾Ñ',0),(420561,11683,'vi','Sá»‘ tiá»n trÃªn hÃ³a Ä‘Æ¡n',0),(420562,11683,'af','WeerspieÃ«l bedrag',0),(420563,11683,'ro','Sumei facturate',0),(420564,11683,'et','Hinnaliidri',0),(420565,11683,'si','Bremenjene znesek',0),(420566,11683,'ba','Jumlah yang ditagih',0),(420567,11683,'nl','Gefactureerde bedrag',0),(420568,11683,'fi','Laskutettu mÃ¤Ã¤rÃ¤',0),(420569,11683,'no','Fakturerte belÃ¸pet',0),(420570,11683,'da','Faktureret belÃ¸b',0),(420571,11683,'ko','ì²­êµ¬ ê¸ˆì•¡',0),(420572,11683,'he','×¡×›×•× ×©×—×•×™×‘',0),(420573,11683,'el','Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î¿ Ï€Î¿ÏƒÏŒ',0),(420574,11683,'zh','è´¦å•é‡‘é¢\r\n',0),(420575,11683,'sv','Fakturerade beloppet',0),(420576,11683,'it','Importo fatturato',0),(420577,11683,'tl','',0),(420578,11683,'th','à¸¢à¸­à¸”à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(420579,11683,'hi','à¤¬à¤¿à¤² à¤•à¥€ à¤°à¤¾à¤¶à¤¿',0),(420580,11683,'ms','Jumlah yang dibilkan sebanyak',0),(420581,11683,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…ÙÙˆØªØ±',0),(420582,11683,'fr','Montant facturÃ©',0),(420583,11683,'jp','è«‹æ±‚é¡',0),(420584,11683,'pt','Quantidade faturada',0),(420585,11683,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÑÑƒÐ¼Ð¼Ð°',0),(420586,11683,'es','Cantidad Facturada',0),(420587,11683,'de','-Abrechnung Betrag',0),(420588,11683,'en','Billed Amount',0),(420589,11684,'is','',0),(420590,11684,'dr','ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(420591,11684,'pr','ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(420592,11684,'tr','PO stok durumu',0),(420593,11684,'pl','Stan zapasÃ³w PO',0),(420594,11684,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð° PO',0),(420595,11684,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù¾Ùˆ Ø­Ø§Ù„Øª',0),(420596,11684,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð»Ð¸Ñ…Ð° ÐŸÐž',0),(420597,11684,'vi','tÃ¬nh tráº¡ng Ä‘Æ¡n mua hÃ ng',0),(420598,11684,'af','Inventaris PO Status',0),(420599,11684,'ro','Statutul de inventar PO',0),(420600,11684,'et','Varude PO olek',0),(420601,11684,'si','Stanje zaloge PO',0),(420602,11684,'ba','Status persediaan PO',0),(420603,11684,'nl','Voorraadstatus PO',0),(420604,11684,'fi','Varaston PO tilaan',0),(420605,11684,'no','Lagerstatus PO',0),(420606,11684,'da','Lagerstatus PO',0),(420607,11684,'ko','ìž¬ê³  í¬ ìƒíƒœ',0),(420608,11684,'he','×ž×¦×‘ ×”×ž×œ××™ ×¤×•',0),(420609,11684,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ PO',0),(420610,11684,'zh','åº“å­˜è®¢å•çŠ¶å†µ\r\n',0),(420611,11684,'sv','Lagerstatus PO',0),(420612,11684,'it','Stato di inventario PO',0),(420613,11684,'tl','',0),(420614,11684,'th','à¸ªà¸–à¸²à¸™à¸°à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡ PO',0),(420615,11684,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤ªà¥‹ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(420616,11684,'ms','Status inventori PO',0),(420617,11684,'ar','Ø­Ø§Ù„Ø© Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¨Ùˆ',0),(420618,11684,'fr','Statut de l\'inventaire PO',0),(420619,11684,'jp','PO ã®åœ¨åº«çŠ¶æ³',0),(420620,11684,'pt','Status de inventÃ¡rio PO',0),(420621,11684,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð Ð¾ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(420622,11684,'es','Estdo de OC de Inventario',0),(420623,11684,'de','Lagerstatus PO',0),(420624,11684,'en','Inventory PO Status',0),(420625,11685,'is','',0),(420626,11685,'dr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù†',0),(420627,11685,'pr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ§Ù…Ù„ Ø´Ø¯Ù†',0),(420628,11685,'tr','Tam gÃ¶ster',0),(420629,11685,'pl','PokaÅ¼ kompletny',0),(420630,11685,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿ÑŠÐ»Ð½Ð°',0),(420631,11685,'ur','Ù…Ú©Ù…Ù„ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(420632,11685,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½',0),(420633,11685,'vi','Hiá»ƒn  thá»‹ hoÃ n thÃ nh',0),(420634,11685,'af','Wys volledige',0),(420635,11685,'ro','AratÄƒ complet',0),(420636,11685,'et','NÃ¤ita lÃµpetatud',0),(420637,11685,'si','PrikaÅ¾i celoten',0),(420638,11685,'ba','Tampilkan lengkap',0),(420639,11685,'nl','Toon volledige',0),(420640,11685,'fi','NÃ¤ytÃ¤ valmis',0),(420641,11685,'no','Vis komplett',0),(420642,11685,'da','Vis komplet',0),(420643,11685,'ko','ì™„ë£Œ í‘œì‹œ',0),(420644,11685,'he','×”×¦×’ ×ž×œ××”',0),(420645,11685,'el','Î Î»Î®ÏÎ·Ï‚ Ï€ÏÎ¿Î²Î¿Î»Î®',0),(420646,11685,'zh','å®Œæ•´æ˜¾ç¤º\r\n',0),(420647,11685,'sv','Visa komplett',0),(420648,11685,'it','Spettacolo completo',0),(420649,11685,'tl','',0),(420650,11685,'th','à¸”à¸¹à¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(420651,11685,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(420652,11685,'ms','Menunjukkan lengkap',0),(420653,11685,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙƒØ§Ù…Ù„',0),(420654,11685,'fr','Spectacle complet',0),(420655,11685,'jp','å®Œå…¨ã«è¡¨ç¤ºã—ã¾ã™ã€‚',0),(420656,11685,'pt','Show completo',0),(420657,11685,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð½Ð¾Ðµ',0),(420658,11685,'es','Muestra el Completo',0),(420659,11685,'de','Karte komplett',0),(420660,11685,'en','Show Complete',0),(420661,11686,'is','',0),(420662,11686,'dr','2 Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†Ù†Ø¯Ù‡',0),(420663,11686,'pr',' Ù‚Ø§Ù„Ø¨ Ø§Ø¬Ø§Ø±Ù‡  Ø´Ù†Ø§Ø³Ù‡ 2 Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†Ù†Ø¯Ù‡',0),(420664,11686,'tr','Åžablon kimliÄŸi 2 imzalayanlarÄ±n kira',0),(420665,11686,'pl','DzierÅ¼awy szablon ID 2 osoby podpisujÄ…ce',0),(420666,11686,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð˜Ð” Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ 2 Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ñ‰Ð¸',0),(420667,11686,'ur','Ø³Ø§Ù†Ú†Ø§ ID 2 Ú©Ø±Ù†Û’ ÙˆØ§Ù„ÙˆÚº Ú©ÛŒ Ù„ÛŒØ²',0),(420668,11686,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð˜Ð” Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ° 2 Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ½Ð¸ÐºÐ°',0),(420669,11686,'vi','Cho thuÃª ngÆ°á»i kÃ½ máº«u ID 2',0),(420670,11686,'af','Huurkontrak Sjabloon ID 2 Ondertekenaars',0),(420671,11686,'ro','Leasing ÅŸablon ID 2 semnatarii',0),(420672,11686,'et','Liisi malli ID 2 allkirjastajad',0),(420673,11686,'si','Zakup ID predloge 2 podpisniki',0),(420674,11686,'ba','Sewa penandatangan Template ID 2',0),(420675,11686,'nl','Lease sjabloon ID 2 ondertekenaars',0),(420676,11686,'fi','Vuokrata mallin tunnus 2 allekirjoittajia',0),(420677,11686,'no','Lease mal-ID 2 signatarer',0),(420678,11686,'da','Lease skabelon-ID 2 underskrivere',0),(420679,11686,'ko','ì„œì‹ íŒŒì¼ ID 2 ì„œëª…ìžë¥¼ ìž„ëŒ€',0),(420680,11686,'he','×©×›×™×¨×•×ª ×”×—×•×ª×ž×™× ×ª×‘× ×™×ª ×ž×–×”×” 2',0),(420681,11686,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Ï…Ï€Î¿Î³ÏÎ¬Ï†Î¿Î½Ï„ÎµÏ‚ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï… 2',0),(420682,11686,'zh','ç§Ÿèµæ¨¡æ¿èº«ä»½è¯2ç­¾ç½²äºº\r\n',0),(420683,11686,'sv','Leasa mall-ID fÃ¶r 2 undertecknarna',0),(420684,11686,'it','Locazione modello ID 2 firmatari',0),(420685,11686,'tl','',0),(420686,11686,'th','à¹€à¸Šà¹ˆà¸²à¸Šà¸·à¹ˆà¸­à¸£à¸«à¸±à¸ªà¹€à¸—à¹‡à¸¡à¹€à¸žà¸¥à¸• 2',0),(420687,11686,'hi','à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ ID 2 à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤°',0),(420688,11686,'ms','Pajakan penandatangan Template ID 2',0),(420689,11686,'ar','ØªØ£Ø¬ÙŠØ± Ø§Ù„Ù…ÙˆÙ‚Ø¹ÙŠÙ† Ù‚Ø§Ù„Ø¨ Ù…Ø¹Ø±Ù 2',0),(420690,11686,'fr','Location modÃ¨le ID 2 signataires',0),(420691,11686,'jp','ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ ID 2 ã®ç½²åè€…ã‚’ãƒªãƒ¼ã‚¹ã—ã¾ã™ã€‚',0),(420692,11686,'pt','LocaÃ§Ã£o modelo ID 2 signatÃ¡rios',0),(420693,11686,'ru','ÐÑ€ÐµÐ½Ð´Ð° ID ÑˆÐ°Ð±Ð»Ð¾Ð½Ð° 2 Ð¿Ð¾Ð´Ð¿Ð¸ÑÑ‹Ð²Ð°ÑŽÑ‰Ð¸Ñ… Ð»Ð¸Ñ†',0),(420694,11686,'es','ID de Planilla de Arrendamiento Con Dos Firmas',0),(420695,11686,'de','Template ID 2 Unterzeichner leasen',0),(420696,11686,'en','Lease Template ID 2 Signers',0),(420697,11687,'is','',0),(420698,11687,'dr','3  Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†Ù†Ø¯Ù‡',0),(420699,11687,'pr','Ù‚Ø§Ù„Ø¨ Ø§Ø¬Ø§Ø±Ù‡  Ø´Ù†Ø§Ø³Ù‡ 3  Ø§Ù…Ø¶Ø§Ø¡ ÙƒÙ†Ù†Ø¯Ù‡',0),(420700,11687,'tr','Åžablon kimliÄŸi 3 imzalayanlar kira',0),(420701,11687,'pl','DzierÅ¼awy szablon ID 3 osoby podpisujÄ…ce',0),(420702,11687,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð˜Ð” Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ 3 Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ñ‰Ð¸',0),(420703,11687,'ur','Ø³Ø§Ù†Ú†Ø§ ID 3 Ú©Ø±Ù†Û’ ÙˆØ§Ù„ÙˆÚº Ú©ÛŒ Ù„ÛŒØ²',0),(420704,11687,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð˜Ð” Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ° 3 Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ½Ð¸ÐºÐ°',0),(420705,11687,'vi','Cho thuÃª ngÆ°á»i kÃ½ máº«u ID 3',0),(420706,11687,'af','Huurkontrak Sjabloon ID 3 Ondertekenaars',0),(420707,11687,'ro','Leasing ÅŸablon ID 3 semnatarii',0),(420708,11687,'et','Liisi malli ID 3 allkirjastajad',0),(420709,11687,'si','Zakup ID predloge 3 podpisniki',0),(420710,11687,'ba','Sewa penandatangan Template ID 3',0),(420711,11687,'nl','Lease sjabloon ID 3 ondertekenaars',0),(420712,11687,'fi','Vuokrata Mallitunnus 3 allekirjoittajia',0),(420713,11687,'no','Lease mal-ID 3 signatarer',0),(420714,11687,'da','Lease skabelon-ID 3 underskrivere',0),(420715,11687,'ko','ì„œì‹ íŒŒì¼ ID 3 ì„œëª…ìžë¥¼ ìž„ëŒ€',0),(420716,11687,'he','×©×›×™×¨×•×ª ×”×—×•×ª×ž×™× ×ª×‘× ×™×ª ×ž×–×”×” 3',0),(420717,11687,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Ï…Ï€Î¿Î³ÏÎ¬Ï†Î¿Î½Ï„ÎµÏ‚ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï… 3',0),(420718,11687,'zh','ç§Ÿèµæ¨¡æ¿èº«ä»½è¯ä¸‰ç­¾ç½²äºº\r\n',0),(420719,11687,'sv','Leasa mall-ID 3 undertecknarna',0),(420720,11687,'it','Locare i firmatari ID modello 3',0),(420721,11687,'tl','',0),(420722,11687,'th','à¹€à¸Šà¹ˆà¸²à¸Šà¸·à¹ˆà¸­à¸£à¸«à¸±à¸ªà¹€à¸—à¹‡à¸¡à¹€à¸žà¸¥ 3',0),(420723,11687,'hi','à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ ID 3 à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤°',0),(420724,11687,'ms','Pajakan penandatangan Template ID 3',0),(420725,11687,'ar','ØªØ£Ø¬ÙŠØ± Ø§Ù„Ù…ÙˆÙ‚Ø¹ÙŠÙ† Ù‚Ø§Ù„Ø¨ Ù…Ø¹Ø±Ù 3',0),(420726,11687,'fr','Location modÃ¨le ID 3 signataires',0),(420727,11687,'jp','ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ ID 3 ç½²åã‚’ãƒªãƒ¼ã‚¹ã—ã¾ã™ã€‚',0),(420728,11687,'pt','LocaÃ§Ã£o modelo ID 3 signatÃ¡rios',0),(420729,11687,'ru','ÐÑ€ÐµÐ½Ð´Ð° ID ÑˆÐ°Ð±Ð»Ð¾Ð½Ð° 3 Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð²ÑˆÐ¸Ñ…',0),(420730,11687,'es','ID de Planilla de Arrendamiento Con Tres Firmas',0),(420731,11687,'de','Template ID 3 Unterzeichner leasen',0),(420732,11687,'en','Lease Template ID 3 Signers',0),(420733,11688,'is','',0),(420734,11688,'dr','Ø³Ø·Ø± Ø§Ù…Ø¶Ø§ Ø¯ÙˆØªØ§ÙŠÙŠ',0),(420735,11688,'pr','Ø³Ø·Ø± Ø§Ù…Ø¶Ø§ Ø¯ÙˆØªØ§ÙŠÙŠ',0),(420736,11688,'tr','Ã‡ift imza satÄ±rÄ±',0),(420737,11688,'pl','PodwÃ³jna linia na podpis',0),(420738,11688,'bg','Ð”Ð²Ð¾ÐµÐ½ Ñ€ÐµÐ´ Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð¸Ñ',0),(420739,11688,'ur','ÚˆØ¨Ù„ Ø¯Ø³ØªØ®Ø· Ù„Ø§Ø¦Ù†',0),(420740,11688,'sr','Ð”ÑƒÐ¿Ð»Ð¾ Ð·Ð° Ð¿Ð¾Ñ‚Ð¿Ð¸Ñ',0),(420741,11688,'vi','Hai chá»¯ kÃ½ dÃ²ng',0),(420742,11688,'af','Dubbel handtekening lyn',0),(420743,11688,'ro','Dublu linia de semnÄƒturÄƒ',0),(420744,11688,'et','Kahekordne allkirjarida',0),(420745,11688,'si','Dvojna Ärta za podpis',0),(420746,11688,'ba','Double Signature Line',0),(420747,11688,'nl','Dubbele handtekeningregel',0),(420748,11688,'fi','Kaksinkertainen allekirjoitusrivi',0),(420749,11688,'no','Dobbel signaturlinje',0),(420750,11688,'da','Dobbelt signaturlinje',0),(420751,11688,'ko','ë”ë¸” ì„œëª…ëž€',0),(420752,11688,'he','×©×•×¨×ª ×—×ª×™×ž×” ×›×¤×•×œ×”',0),(420753,11688,'el','Î”Î¹Ï€Î»Î® Î³ÏÎ±Î¼Î¼Î® Ï…Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(420754,11688,'zh','åŒç­¾åè¡Œ\r\n',0),(420755,11688,'sv','Dubbla signaturrad',0),(420756,11688,'it','Doppia riga della firma',0),(420757,11688,'tl','',0),(420758,11688,'th','à¸ªà¸­à¸‡à¸šà¸£à¸£à¸—à¸±à¸”à¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™',0),(420759,11688,'hi','à¤¡à¤¬à¤² à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤°à¥‡à¤–à¤¾',0),(420760,11688,'ms','Dua tandatangan talian',0),(420761,11688,'ar','Ø³Ø·Ø± Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ù…Ø²Ø¯ÙˆØ¬Ø©',0),(420762,11688,'fr','Double ligne de Signature',0),(420763,11688,'jp','äºŒé‡ç½²åæ¬„',0),(420764,11688,'pt','Dupla linha de assinatura',0),(420765,11688,'ru','Ð”Ð²Ð¾Ð¹Ð½Ð°Ñ ÑÑ‚Ñ€Ð¾ÐºÐ° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸',0),(420766,11688,'es','Doble Linea de Firma',0),(420767,11688,'de','Doppelzimmer Signaturzeile',0),(420768,11688,'en','Double Signature Line',0),(420769,11689,'is','',0),(420770,11689,'dr','Ú†Ù†Ø¯ Ø³Ø·Ø± Ø¨Ø±Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø±ÙˆÙŠ Ú†Ùƒ ',0),(420771,11689,'pr','Ú†Ù†Ø¯ Ø³Ø·Ø± Ø¨Ø±Ø§ÙŠ Ø§Ù…Ø¶Ø§Ø¡ Ø±ÙˆÙŠ Ú†Ùƒ ',0),(420772,11689,'tr','Onay imzalarÄ± iÃ§in kaÃ§ satÄ±r',0),(420773,11689,'pl','Jak wiele wierszy podpisÃ³w na wyboru',0),(420774,11689,'bg','ÐšÐ¾Ð»ÐºÐ¾ Ð¼Ð½Ð¾Ð³Ð¾ Ñ€ÐµÐ´Ð¾Ð²Ðµ Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(420775,11689,'ur','Ú†ÛŒÚ© Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Û’ Ù„ÛŒÛ’ Ú©ØªÙ†Û’ Ù„Ø§Ø¦Ù†ÛŒÚº',0),(420776,11689,'sr','ÐšÐ¾Ð»Ð¸ÐºÐ¾ Ñ€ÐµÐ´Ð¾Ð²Ð° Ð·Ð° Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐµ Ð½Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(420777,11689,'vi','Bao nhiÃªu dÃ²ng cho chá»¯ kÃ½ trÃªn kiá»ƒm tra',0),(420778,11689,'af','Aantal Lyne vir Tekengemagtiges op Tjek',0),(420779,11689,'ro','CÃ¢t de multe linii pentru semnÄƒturi pe Check',0),(420780,11689,'et','Kui palju ridu allkirjad kontrolli kohta',0),(420781,11689,'si','Koliko prog za podpise na preverjanje',0),(420782,11689,'ba','Berapa banyak baris untuk tanda tangan pada cek',0),(420783,11689,'nl','Hoeveel regels voor handtekeningen op selectievakje',0),(420784,11689,'fi','Montako riviÃ¤ allekirjoitukset tarkistaa',0),(420785,11689,'no','Hvor mange linjer for signaturer pÃ¥ sjekk',0),(420786,11689,'da','Hvor mange linjer for underskrifter pÃ¥ Check',0),(420787,11689,'ko','ì„œëª… í™•ì¸ì— ëŒ€ í•œ ì¤„ ìˆ˜',0),(420788,11689,'he','×›×ž×” ×©×•×¨×•×ª ×¢×‘×•×¨ ×—×ª×™×ž×•×ª ×¢×œ ×¦\'×§',0),(420789,11689,'el','Î ÏŒÏƒÎµÏ‚ Î³ÏÎ±Î¼Î¼Î­Ï‚ Î³Î¹Î± Ï„Î¹Ï‚ Ï…Ï€Î¿Î³ÏÎ±Ï†Î­Ï‚ Î³Î¹Î± Î­Î»ÎµÎ³Ï‡Î¿',0),(420790,11689,'zh','ç”¨äºŽç­¾åçš„æ£€æŸ¥å¤šå°‘è¡Œ\r\n',0),(420791,11689,'sv','Hur mÃ¥nga rader fÃ¶r signaturer pÃ¥ Check',0),(420792,11689,'it','Quante righe per firme sull\'assegno',0),(420793,11689,'tl','',0),(420794,11689,'th','à¸ˆà¸³à¸™à¸§à¸™à¸šà¸£à¸£à¸—à¸±à¸”à¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™à¸šà¸™à¹€à¸Šà¹‡à¸„',0),(420795,11689,'hi','à¤šà¥‡à¤• à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤¤à¤¨à¥‡ à¤°à¥‡à¤–à¤¾à¤à¤',0),(420796,11689,'ms','Berapa banyak baris untuk tandatangan pada Daftar',0),(420797,11689,'ar','ÙƒÙ… Ø¹Ø¯Ø¯ Ø§Ù„Ø£Ø³Ø·Ø± Ù„Ù„ØªÙˆÙ‚ÙŠØ¹Ø§Øª Ø¹Ù„Ù‰ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(420798,11689,'fr','Combien de lignes pour les Signatures sur chÃ¨que',0),(420799,11689,'jp','å°åˆ‡æ‰‹ã«ç½²åã®è¡Œã®æ•°',0),(420800,11689,'pt','Quantas linhas para as assinaturas de cheque',0),(420801,11689,'ru','Ð¡ÐºÐ¾Ð»ÑŒÐºÐ¾ ÑÑ‚Ñ€Ð¾Ðº Ð´Ð»Ñ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸ Ð½Ð° Ñ‡ÐµÐºÐµ',0),(420802,11689,'es','Cuantas Lineas para Firmas en el Cheque',0),(420803,11689,'de','Wie viele Zeilen fÃ¼r Signaturen auf Scheck',0),(420804,11689,'en','How Many Lines for Signatures on Check',0),(420805,11690,'is','',0),(420806,11690,'dr','Ø³Ø·Ø± Ø§Ù…Ø¶Ø§Ø¡ Ù…Ø¬Ø±Ø¯',0),(420807,11690,'pr','Ø³Ø·Ø± Ø§Ù…Ø¶Ø§Ø¡ Ù…Ø¬Ø±Ø¯',0),(420808,11690,'tr','Tek imza satÄ±rÄ±',0),(420809,11690,'pl','Linia na podpis pojedynczy',0),(420810,11690,'bg','Ð ÐµÐ´ Ð·Ð° ÐµÐ´Ð¸Ð½ Ð¿Ð¾Ð´Ð¿Ð¸Ñ',0),(420811,11690,'ur','ÙˆØ§Ø­Ø¯ Ø¯Ø³ØªØ®Ø· Ù„Ø§Ø¦Ù†',0),(420812,11690,'sr','Ð—Ð° Ñ˜ÐµÐ´Ð°Ð½ Ð¿Ð¾Ñ‚Ð¿Ð¸Ñ',0),(420813,11690,'vi','Chá»¯ kÃ½ Ä‘Æ¡n dÃ²ng',0),(420814,11690,'af','Enkele handtekening lyn',0),(420815,11690,'ro','Linia de semnÄƒturÄƒ unicÄƒ',0),(420816,11690,'et','Ãœhe allkirjarida',0),(420817,11690,'si','Enojni podpis vrstice',0),(420818,11690,'ba','Garis tanda tangan tunggal',0),(420819,11690,'nl','Ã‰Ã©n handtekeningregel',0),(420820,11690,'fi','Yhden allekirjoitusrivi',0),(420821,11690,'no','Enkelt signaturlinje',0),(420822,11690,'da','Enkelt signaturlinje',0),(420823,11690,'ko','ë‹¨ì¼ ì„œëª… ì„ ',0),(420824,11690,'he','×©×•×¨×ª ×—×ª×™×ž×” ××—×ª',0),(420825,11690,'el','Î“ÏÎ±Î¼Î¼Î® Ï…Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ ÎµÎ½Î¹Î±Î¯Î±',0),(420826,11690,'zh','å•ç­¾åè¡Œ\r\n',0),(420827,11690,'sv','Enda signaturrad',0),(420828,11690,'it','Firma singola linea',0),(420829,11690,'tl','',0),(420830,11690,'th','à¸šà¸£à¸£à¸—à¸±à¸”à¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™à¹€à¸”à¸µà¸¢à¸§',0),(420831,11690,'hi','à¤à¤•à¤² à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤°à¥‡à¤–à¤¾',0),(420832,11690,'ms','Tandatangan satu baris',0),(420833,11690,'ar','Ø³Ø·Ø± ØªÙˆÙ‚ÙŠØ¹ ÙˆØ§Ø­Ø¯',0),(420834,11690,'fr','Ligne de Signature unique',0),(420835,11690,'jp','1 ã¤ã®ç½²åãƒ©ã‚¤ãƒ³',0),(420836,11690,'pt','Linha de assinatura Ãºnica',0),(420837,11690,'ru','Ð¡Ñ‚Ñ€Ð¾ÐºÐ° Ð¾Ð´Ð½Ð¾Ð¹ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸',0),(420838,11690,'es','Una Linea de Firma',0),(420839,11690,'de','Einzelne Signaturzeile',0),(420840,11690,'en','Single Signature Line',0),(420841,11691,'is','',0),(420842,11691,'dr','ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  ',0),(420843,11691,'pr','ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯  ',0),(420844,11691,'tr','PO durumu',0),(420845,11691,'pl','Stan PO',0),(420846,11691,'bg','PO ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(420847,11691,'ur','Ù¾Ùˆ Ø­Ø§Ù„Øª',0),(420848,11691,'sr','ÐŸÐž ÑÑ‚Ð°Ñ‚ÑƒÑÑƒ',0),(420849,11691,'vi','TÃ¬nh tráº¡ng PO',0),(420850,11691,'af','Posbus Status',0),(420851,11691,'ro','Statutul de PO',0),(420852,11691,'et','PO olek',0),(420853,11691,'si','PO statusu',0),(420854,11691,'ba','PO Status',0),(420855,11691,'nl','PO Status',0),(420856,11691,'fi','PO-tila',0),(420857,11691,'no','PO Status',0),(420858,11691,'da','PO Status',0),(420859,11691,'ko','í¬ ìƒíƒœ',0),(420860,11691,'he','×ž×¦×‘ ×¤×•',0),(420861,11691,'el','PO ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(420862,11691,'zh','è®¢å•çŠ¶æ€\r\n',0),(420863,11691,'sv','PO Status',0),(420864,11691,'it','Status di PO',0),(420865,11691,'tl','',0),(420866,11691,'th','à¸ªà¸–à¸²à¸™à¸° PO',0),(420867,11691,'hi','à¤ªà¥‹ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(420868,11691,'ms','PO Status',0),(420869,11691,'ar','Ù…Ø±ÙƒØ² Ø¨Ùˆ',0),(420870,11691,'fr','Statut de PO',0),(420871,11691,'jp','PO ã®çŠ¶æ…‹',0),(420872,11691,'pt','Status de PO',0),(420873,11691,'ru','Ð Ð¾ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(420874,11691,'es','Estado de OC',0),(420875,11691,'de','PO-Status',0),(420876,11691,'en','PO Status',0),(420877,11692,'is','',0),(420878,11692,'dr','Ú†Ø§Ù¾ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ ',0),(420879,11692,'pr','Ú†Ø§Ù¾ ÙˆØ¶Ø¹ÙŠØª Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÙŠØ¯ ',0),(420880,11692,'tr','SatÄ±nalma sipariÅŸlerinin durumunu YazdÄ±r',0),(420881,11692,'pl','Drukowanie stanu zamÃ³wieÅ„ zakupu',0),(420882,11692,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(420883,11692,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø­Ø§Ù„Øª Ú©Ùˆ Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº',0),(420884,11692,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ›Ð°Ñ˜',0),(420885,11692,'vi','In tÃ¬nh tráº¡ng cá»§a Ä‘Æ¡n Ä‘áº·t hÃ ng mua',0),(420886,11692,'af','Druk Status van aankoop bestellings',0),(420887,11692,'ro','Imprima starea comenzilor de cumpÄƒrare',0),(420888,11692,'et','Prindi ostutellimuste olek',0),(420889,11692,'si','Stanje naroÄilnice tiskanja',0),(420890,11692,'ba','Mencetak Status pesanan pembelian',0),(420891,11692,'nl','Status van inkooporders afdrukken',0),(420892,11692,'fi','Tulostaa ostotilausten tila',0),(420893,11692,'no','Skrive ut Status for bestillinger',0),(420894,11692,'da','Udskrive Status for indkÃ¸bsordrer',0),(420895,11692,'ko','ì¸ì‡„ êµ¬ë§¤ ì£¼ë¬¸ ìƒíƒœ',0),(420896,11692,'he','×”×“×¤×¡ ×ž×¦×‘ ×”×–×ž× ×•×ª ×¨×›×©',0),(420897,11692,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Î±Î³Î¿ÏÏŽÎ½',0),(420898,11692,'zh','æ‰“å°çŠ¶æ€çš„é‡‡è´­è®¢å•\r\n',0),(420899,11692,'sv','Skriv ut Status fÃ¶r inkÃ¶psorder',0),(420900,11692,'it','Stampare lo stato degli ordini di acquisto',0),(420901,11692,'tl','',0),(420902,11692,'th','à¸žà¸´à¸¡à¸žà¹Œà¸ªà¸–à¸²à¸™à¸°à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(420903,11692,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(420904,11692,'ms','Mencetak Status pesanan pembelian',0),(420905,11692,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø­Ø§Ù„Ø© Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(420906,11692,'fr','Imprimer l\'Ã©tat des bons de commande',0),(420907,11692,'jp','ç™ºæ³¨æ›¸ã®ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(420908,11692,'pt','Imprimir o Status das ordens de compra',0),(420909,11692,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(420910,11692,'es','Imprimir el Estado de los Ordenes de Compra',0),(420911,11692,'de','Status von Bestellungen drucken',0),(420912,11692,'en','Print Status of Purchase Orders',0),(420913,11693,'is','',0),(420914,11693,'dr','( Ø§Ø¬Ø§Ø±Ù‡ Ù¾Ø§ÙŠÙŠØ²',0),(420915,11693,'pr','Ø³Ù‚ÙˆØ· Ø§Ø¬Ø§Ø±Ù‡ ( Ø§Ø¬Ø§Ø±Ù‡ Ù¾Ø§ÙŠÙŠØ²',0),(420916,11693,'tr','GÃ¼z kira',0),(420917,11693,'pl','Upadek Wynajem',0),(420918,11693,'bg','Ð•ÑÐµÐ½Ñ‚Ð° Ð¿Ð¾Ð´ Ð½Ð°ÐµÐ¼',0),(420919,11693,'ur','Ø²ÙˆØ§Ù„ Ú©Ø±Ø§Ø¦Û’',0),(420920,11693,'sr','ÐŸÐ°Ð´ ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ñƒ',0),(420921,11693,'vi','giáº£m tiá»n thuÃª',0),(420922,11693,'af','Val huur',0),(420923,11693,'ro','Chirie de toamna',0),(420924,11693,'et','SÃ¼gisel Rent',0),(420925,11693,'si','Padec najemnine',0),(420926,11693,'ba','Sewa jatuh',0),(420927,11693,'nl','Val te huur',0),(420928,11693,'fi','SyksyllÃ¤ vuokrattavana',0),(420929,11693,'no','HÃ¸sten leie',0),(420930,11693,'da','Fall leje',0),(420931,11693,'ko','ê°€ ìž„ëŒ€',0),(420932,11693,'he','×¡×ª×™×• ×”×©×›×¨×”',0),(420933,11693,'el','Î Ï„ÏŽÏƒÎ· ÎµÎ½Î¿Î¹ÎºÎ¯Î±ÏƒÎ·',0),(420934,11693,'zh','ç§‹å­£ç§Ÿ\r\n',0),(420935,11693,'sv','HÃ¶sten hyra',0),(420936,11693,'it','Affitto Appartamento caduta',0),(420937,11693,'tl','',0),(420938,11693,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²à¸­à¸¢à¸¹à¹ˆ',0),(420939,11693,'hi','à¤ªà¤¤à¤¨ à¤¬à¤¾à¤‡à¤• à¤•à¤¿à¤°à¤¾à¤',0),(420940,11693,'ms','Kejatuhan sewa',0),(420941,11693,'ar','Ø³Ù‚ÙˆØ· Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(420942,11693,'fr','Loyer de l\'automne',0),(420943,11693,'jp','ç§‹å®¶è³ƒ',0),(420944,11693,'pt','Aluguel de outono',0),(420945,11693,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¾ÑÐµÐ½ÑŒ',0),(420946,11693,'es','Renta de OtoÃ±o',0),(420947,11693,'de','Herbst-mieten',0),(420948,11693,'en','Fall Rent',0),(420949,11694,'is','',0),(420950,11694,'dr','Ø­Ø³Ø§Ø¨ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ù…Ø­ÙˆØ·Ù‡ Ú†Ù…Ù† ',0),(420951,11694,'pr','Ø­Ø³Ø§Ø¨ Ù†Ú¯Ù‡Ø¯Ø§Ø±ÙŠ Ù…Ø­ÙˆØ·Ù‡ Ú†Ù…Ù† ',0),(420952,11694,'tr','Ã‡im bakÄ±m hesabÄ±',0),(420953,11694,'pl','Konto PielÄ™gnacja trawnika',0),(420954,11694,'bg','Ð¢Ñ€ÐµÐ²Ð°Ñ‚Ð° Ð³Ñ€Ð¸Ð¶Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(420955,11694,'ur','Ù„Ø§Ù† Ú©ÛŒ Ø¯ÛŒÚ©Ú¾ Ø¨Ú¾Ø§Ù„ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(420956,11694,'sr','Ð¢Ñ€Ð°Ð²ÑšÐ°Ðº Ð½ÐµÐ³Ñƒ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(420957,11694,'vi','tÃ i khoáº£n Lawn Care',0),(420958,11694,'af','Grasperk sorg rekening',0),(420959,11694,'ro','Cont de Ã®ngrijire gazon',0),(420960,11694,'et','Muru hooldus konto',0),(420961,11694,'si','RaÄun za nego trate',0),(420962,11694,'ba','Rumput perawatan Account',0),(420963,11694,'nl','Gazon zorg Account',0),(420964,11694,'fi','Nurmikon hoito tili',0),(420965,11694,'no','Plenen bekymre konto',0),(420966,11694,'da','Lawn Care konto',0),(420967,11694,'ko','ìž”ë”” ê´€ë¦¬ ê³„ì •',0),(420968,11694,'he','×—×©×‘×•×Ÿ ×˜×™×¤×•×— ×”×“×©×',0),(420969,11694,'el','Î“ÎºÎ±Î¶ÏŒÎ½ Ï€ÎµÏÎ¯Î¸Î±Î»ÏˆÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(420970,11694,'zh','è‰åªæŠ¤ç†å¸æˆ·\r\n',0),(420971,11694,'sv','Lawn Care konto',0),(420972,11694,'it','Conto di cura del prato inglese',0),(420973,11694,'tl','',0),(420974,11694,'th','à¸šà¸±à¸à¸Šà¸µà¸à¸²à¸£à¸”à¸¹à¹à¸¥à¸ªà¸™à¸²à¸¡à¸«à¸à¹‰à¸²',0),(420975,11694,'hi','à¤²à¥‰à¤¨ à¤•à¥€ à¤¦à¥‡à¤–à¤­à¤¾à¤² à¤–à¤¾à¤¤à¥‡',0),(420976,11694,'ms','Akaun penjagaan rumput',0),(420977,11694,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø±Ø¹Ø§ÙŠØ© ÙÙŠ Ø§Ù„Ø­Ø¯ÙŠÙ‚Ø©',0),(420978,11694,'fr','Compte de soin de pelouse',0),(420979,11694,'jp','èŠç”Ÿã®ã‚±ã‚¢ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(420980,11694,'pt','Gramado cuidado conta',0),(420981,11694,'ru','Ð“Ð°Ð·Ð¾Ð½ ÑƒÑ…Ð¾Ð´ Ð·Ð° ÑÑ‡ÐµÑ‚',0),(420982,11694,'es','Cuenta de Mantenimiento de CÃ©sped',0),(420983,11694,'de','Rasen-Pflege-Konto',0),(420984,11694,'en','Lawn Care Account',0),(420985,11695,'is','',0),(420986,11695,'dr','Pet Ø­Ø³Ø§Ø¨ Ø§Ø¬Ø§Ø±Ù‡ ',0),(420987,11695,'pr','Pet Ø­Ø³Ø§Ø¨ Ø§Ø¬Ø§Ø±Ù‡ ',0),(420988,11695,'tr','Evde beslenen hayvan kira hesabÄ±',0),(420989,11695,'pl','PieÅ›ciÄ‡ wynajem konta',0),(420990,11695,'bg','Ð”Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð»ÑŽÐ±Ð¸Ð¼Ñ†Ð¸ Ð½Ð°ÐµÐ¼ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(420991,11695,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± Ú©Ø±Ø§Ø¦Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(420992,11695,'sr','Ð‰ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ð½Ð°Ñ˜Ð°Ð¼ Ñ€Ð°Ñ‡ÑƒÐ½',0),(420993,11695,'vi','tÃ i khoáº£n thuÃª riÃªng',0),(420994,11695,'af','Troeteldier huur rekening',0),(420995,11695,'ro','Animal de casÄƒ chirie cont',0),(420996,11695,'et','Lemmikloomade Rent konto',0),(420997,11695,'si','Jjeza najem raÄun',0),(420998,11695,'ba','Hewan peliharaan Disewa Account',0),(420999,11695,'nl','Huisdier huur Account',0),(421000,11695,'fi','HellitellÃ¤ vuokra Tilin',0),(421001,11695,'no','Pet husleien kontoen',0),(421002,11695,'da','Pet leje konto',0),(421003,11695,'ko','ì• ì™„ ë™ë¬¼ ì§‘ ì„¸ ê³„ì •',0),(421004,11695,'he','×—×©×‘×•×Ÿ ×©×›×¨ ×”×“×™×¨×” ×œ×—×™×•×ª ×ž×—×ž×“',0),(421005,11695,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï„Î¿ ÎµÎ½Î¿Î¯ÎºÎ¹ÏŒ ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Ï‰Î½ Î¶ÏŽÏ‰Î½',0),(421006,11695,'zh','å® ç‰©ç§Ÿé‡‘å¸æˆ·\r\n',0),(421007,11695,'sv','SÃ¤llskapsdjur hyra konto',0),(421008,11695,'it','Conto dell\'animale domestico in affitto',0),(421009,11695,'tl','',0),(421010,11695,'th','à¸šà¸±à¸à¸Šà¸µà¹€à¸Šà¹ˆà¸²à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(421011,11695,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤•à¤¿à¤°à¤¾à¤¯à¤¾ à¤–à¤¾à¤¤à¤¾',0),(421012,11695,'ms','Akaun sewa haiwan kesayangan',0),(421013,11695,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ©',0),(421014,11695,'fr','Compte de loyer pour animaux de compagnie',0),(421015,11695,'jp','ãƒšãƒƒãƒˆã®å®¶è³ƒã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(421016,11695,'pt','Conta de aluguel de animais',0),(421017,11695,'ru','ÐŸÐ­Ð¢ ÐÑ€ÐµÐ½Ð´Ð° ÑÑ‡ÐµÑ‚Ð°',0),(421018,11695,'es','Cuenta de Renta de Mascota',0),(421019,11695,'de','Haustier mieten-Konto',0),(421020,11695,'en','Pet Rent Account',0),(421021,11696,'is','',0),(421022,11696,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ù‡Ø§ ',0),(421023,11696,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ù‡Ø§ ',0),(421024,11696,'tr','Bahar kira',0),(421025,11696,'pl','Wynajem wiosna',0),(421026,11696,'bg','ÐŸÑ€Ð¾Ð»ÐµÑ‚Ñ‚Ð° Ð¿Ð¾Ð´ Ð½Ð°ÐµÐ¼',0),(421027,11696,'ur','Ù…ÙˆØ³Ù… Ø¨ÛØ§Ø± Ú©Ø±Ø§Ø¦Û’',0),(421028,11696,'sr','ÐŸÑ€Ð¾Ð»ÐµÑ›Ðµ ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ñƒ',0),(421029,11696,'vi','MÃ¹a xuÃ¢n thuÃª',0),(421030,11696,'af','Lente huur',0),(421031,11696,'ro','Chirie de primÄƒvarÄƒ',0),(421032,11696,'et','Kevadel Rent',0),(421033,11696,'si','Spomladi najemnine',0),(421034,11696,'ba','Sewa musim semi',0),(421035,11696,'nl','Lente huur',0),(421036,11696,'fi','KevÃ¤Ã¤n vuokrattavana',0),(421037,11696,'no','VÃ¥ren leie',0),(421038,11696,'da','ForÃ¥ret leje',0),(421039,11696,'ko','ë´„ ìžì „ê±°',0),(421040,11696,'he','×”×©×›×¨×” ×”××‘×™×‘',0),(421041,11696,'el','Î•Î½Î¿Î¹ÎºÎ¯Î±ÏƒÎ· Î¬Î½Î¿Î¹Î¾Î·',0),(421042,11696,'zh','æ˜¥å¤©ç§Ÿ\r\n',0),(421043,11696,'sv','VÃ¥ren hyra',0),(421044,11696,'it','Affitto Appartamento primavera',0),(421045,11696,'tl','',0),(421046,11696,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²à¸¤à¸”à¸¹à¹ƒà¸šà¹„à¸¡à¹‰à¸œà¸¥à¸´',0),(421047,11696,'hi','à¤µà¤¸à¤‚à¤¤ à¤¬à¤¾à¤‡à¤• à¤•à¤¿à¤°à¤¾à¤',0),(421048,11696,'ms','Sewa Spring',0),(421049,11696,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø±Ø¨ÙŠØ¹',0),(421050,11696,'fr','Loyer de printemps',0),(421051,11696,'jp','æ˜¥ã®è³ƒè²¸æ–™',0),(421052,11696,'pt','Aluguel de primavera',0),(421053,11696,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð’ÐµÑÐ½Ð°',0),(421054,11696,'es','Renta de Primavera',0),(421055,11696,'de','FrÃ¼hling-mieten',0),(421056,11696,'en','Spring Rent',0),(421057,11697,'is','',0),(421058,11697,'dr','Ø§ØµÙ„Ø§Ø­ÙŠÙ‡',0),(421059,11697,'pr','Ø§ØµÙ„Ø§Ø­ÙŠÙ‡',0),(421060,11697,'tr','DeÄŸiÅŸiklik',0),(421061,11697,'pl','Poprawka',0),(421062,11697,'bg','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(421063,11697,'ur','ØªØ±Ù…ÛŒÙ…',0),(421064,11697,'sr','ÐÐ¼Ð°Ð½Ð´Ð¼Ð°Ð½',0),(421065,11697,'vi','Äiá»u chá»‰nh',0),(421066,11697,'af','Aanpassing',0),(421067,11697,'ro','Modificare',0),(421068,11697,'et','Muudatus',0),(421069,11697,'si','Sprememba',0),(421070,11697,'ba','Amandemen',0),(421071,11697,'nl','Amendement',0),(421072,11697,'fi','Tarkistus',0),(421073,11697,'no','Endring',0),(421074,11697,'da','Ã†ndringsforslag',0),(421075,11697,'ko','ê°œì •',0),(421076,11697,'he','×ª×™×§×•×Ÿ',0),(421077,11697,'el','Î¤ÏÎ¿Ï€Î¿Î»Î¿Î³Î¯Î±',0),(421078,11697,'zh','ä¿®è®¢\r\n',0),(421079,11697,'sv','Ã„ndringsfÃ¶rslag',0),(421080,11697,'it','Emendamento',0),(421081,11697,'tl','',0),(421082,11697,'th','à¹à¸à¹‰à¹„à¸‚à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(421083,11697,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨',0),(421084,11697,'ms','Pindaan',0),(421085,11697,'ar','Ø§Ù„ØªØ¹Ø¯ÙŠÙ„',0),(421086,11697,'fr','Amendement',0),(421087,11697,'jp','æ”¹æ­£',0),(421088,11697,'pt','AlteraÃ§Ã£o',0),(421089,11697,'ru','ÐŸÐ¾Ð¿Ñ€Ð°Ð²ÐºÐ°',0),(421090,11697,'es','Enmienda',0),(421091,11697,'de','Ã„nderungsantrag',0),(421092,11697,'en','Amendment',0),(421093,11698,'is','',0),(421094,11698,'dr','ØªØ§Ø±ÙŠØ® Ø§ØµÙ„Ø§Ø­ÙŠÙ‡',0),(421095,11698,'pr','ØªØ§Ø±ÙŠØ® Ø§ØµÙ„Ø§Ø­ÙŠÙ‡',0),(421096,11698,'tr','DeÄŸiÅŸiklik tarihi',0),(421097,11698,'pl','Zmiana daty',0),(421098,11698,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(421099,11698,'ur','ØªØ±Ù…ÛŒÙ… Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(421100,11698,'sr','ÐÐ¼Ð°Ð½Ð´Ð¼Ð°Ð½ Ð´Ð°Ñ‚ÑƒÐ¼',0),(421101,11698,'vi','NgÃ y Ä‘iá»u chá»‰nh',0),(421102,11698,'af','Aanpassingsdatum',0),(421103,11698,'ro','Modificare data',0),(421104,11698,'et','Muutmise kuupÃ¤ev',0),(421105,11698,'si','Sprememba datuma',0),(421106,11698,'ba','Perubahan tanggal',0),(421107,11698,'nl','Amendement datum',0),(421108,11698,'fi','Tarkistuksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(421109,11698,'no','Endringsdato',0),(421110,11698,'da','Ã†ndring dato',0),(421111,11698,'ko','ìˆ˜ì • ë‚ ì§œ',0),(421112,11698,'he','×ª×™×§×•×Ÿ ×ª××¨×™×š',0),(421113,11698,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚',0),(421114,11698,'zh','ä¿®è®¢æ—¥æœŸ\r\n',0),(421115,11698,'sv','Ã„ndring datum',0),(421116,11698,'it','Data di modifica',0),(421117,11698,'tl','',0),(421118,11698,'th','à¸§à¸±à¸™à¹à¸à¹‰à¹„à¸‚',0),(421119,11698,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(421120,11698,'ms','Pindaan tarikh',0),(421121,11698,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ¹Ø¯ÙŠÙ„',0),(421122,11698,'fr','Date de modification',0),(421123,11698,'jp','æ”¹æ­£æ—¥',0),(421124,11698,'pt','Data de alteraÃ§Ã£o',0),(421125,11698,'ru','Ð”Ð°Ñ‚Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(421126,11698,'es','Fecha de Enmienda',0),(421127,11698,'de','Ã„nderung Datum',0),(421128,11698,'en','Amendment Date',0),(421129,11699,'is','',0),(421130,11699,'dr','Ø§ØµÙ„Ø§Ø­ Ø§Ø¬Ø§Ø±Ù‡',0),(421131,11699,'pr','Ø§ØµÙ„Ø§Ø­ Ø§Ø¬Ø§Ø±Ù‡',0),(421132,11699,'tr','Kira deÄŸiÅŸtirme',0),(421133,11699,'pl','Zmiana umowy najmu',0),(421134,11699,'bg','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(421135,11699,'ur','Ù„ÛŒØ² Ú©ÛŒ ØªØ±Ù…ÛŒÙ…',0),(421136,11699,'sr','Ð˜Ð·Ð¼ÐµÐ½Ð¸ Ð·Ð°ÐºÑƒÐ¿',0),(421137,11699,'vi','Äiá»u chá»‰nh cho thuÃª',0),(421138,11699,'af','Wysig Huurkontrak',0),(421139,11699,'ro','Modificarea leasing',0),(421140,11699,'et','Muuta Ã¼Ã¼rileping',0),(421141,11699,'si','Spremeniti najem',0),(421142,11699,'ba','Mengubah sewa',0),(421143,11699,'nl','Wijziging van Lease',0),(421144,11699,'fi','Muuttaa vuokrasopimuksen',0),(421145,11699,'no','Endre Lease',0),(421146,11699,'da','Ã†ndre Lease',0),(421147,11699,'ko','ìž„ëŒ€ ê°œì •',0),(421148,11699,'he','×œ×ª×§×Ÿ ××ª ×—×•×–×” ×”×©×›×™×¨×•×ª',0),(421149,11699,'el','Î¤ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(421150,11699,'zh','ä¿®æ”¹ç§Ÿèµ\r\n',0),(421151,11699,'sv','Ã„ndra hyresavtalet',0),(421152,11699,'it','Modificare il contratto di locazione',0),(421153,11699,'tl','',0),(421154,11699,'th','à¹à¸à¹‰à¹„à¸‚à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(421155,11699,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤®à¥‡à¤‚ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨',0),(421156,11699,'ms','Meminda pajakan',0),(421157,11699,'ar','ØªØ¹Ø¯ÙŠÙ„ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(421158,11699,'fr','Modifier le bail',0),(421159,11699,'jp','ãƒªãƒ¼ã‚¹ã‚’ä¿®æ­£ã—ã¾ã™ã€‚',0),(421160,11699,'pt','Alterar locaÃ§Ã£o',0),(421161,11699,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐÑ€ÐµÐ½Ð´Ð°',0),(421162,11699,'es','Enmienda el Arrendamiento',0),(421163,11699,'de','Ã„nderung Mietvertrag',0),(421164,11699,'en','Amend Lease',0),(421165,11700,'is','',0),(421166,11700,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ØµÙ„Ø§Ø­  Ø´Ø¯ ',0),(421167,11700,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§ØµÙ„Ø§Ø­  Ø´Ø¯ ',0),(421168,11700,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde tadil kira',0),(421169,11700,'pl','DzierÅ¼awy pomyÅ›lnie zmieniona',0),(421170,11700,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³, Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(421171,11700,'ur','ØªØ±Ù…ÛŒÙ… Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù„ÛŒØ²',0),(421172,11700,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð´Ð¾Ð¿ÑƒÐ½Ð¸Ð»Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(421173,11700,'vi','Ä‘Ã£ sá»­a há»£p Ä‘á»“ng thuÃª thÃ nh cÃ´ng',0),(421174,11700,'af','Huurkontrak Suksesvol Gewysig.',0),(421175,11700,'ro','Cum a fost modificatÄƒ cu succes de leasing',0),(421176,11700,'et','ÃœÃ¼rilepingu muudetud edukalt',0),(421177,11700,'si','Zakup, spremeniti uspeÅ¡no',0),(421178,11700,'ba','Sewa diamandemen berhasil',0),(421179,11700,'nl','Lease met succes gewijzigd',0),(421180,11700,'fi','Vuokrasopimuksen muutettu onnistuneesti',0),(421181,11700,'no','Leieavtalen endret vellykket',0),(421182,11700,'da','Leasing Ã¦ndret med succes',0),(421183,11700,'ko','ìž„ëŒ€ ì„±ê³µì ìœ¼ë¡œ ê°œì •',0),(421184,11700,'he','×©×›×™×¨×•×ª ×©×ª×•×§×Ÿ ×‘×”×¦×œ×—×”',0),(421185,11700,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(421186,11700,'zh','ç§Ÿèµä¿®æ­£æˆåŠŸ\r\n',0),(421187,11700,'sv','Hyresavtalet Ã¤ndrad framgÃ¥ngsrikt',0),(421188,11700,'it','Locazione modificata con successo',0),(421189,11700,'tl','',0),(421190,11700,'th','à¹€à¸Šà¹ˆà¸²à¸—à¸µà¹ˆà¹à¸à¹‰à¹„à¸‚à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(421191,11700,'hi','à¤²à¥€à¤œ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤®à¥‡à¤‚ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤•à¤¿à¤¯à¤¾',0),(421192,11700,'ms','Pajakan yang dipinda telah berjaya',0),(421193,11700,'ar','Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ù…Ø¹Ø¯Ù„ Ø¨Ù†Ø¬Ø§Ø­',0),(421194,11700,'fr','Bail modifiÃ© avec succÃ¨s',0),(421195,11700,'jp','ãƒªãƒ¼ã‚¹ãŒæ­£å¸¸ã«ä¿®æ­£',0),(421196,11700,'pt','Arrendamento alterado com sucesso',0),(421197,11700,'ru','ÐÑ€ÐµÐ½Ð´Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½',0),(421198,11700,'es','Arrendamiento Enmendado Exitosamente',0),(421199,11700,'de','Lease erfolgreich geÃ¤ndert',0),(421200,11700,'en','Lease Amended Successfully',0),(421201,11701,'is','',0),(421202,11701,'dr','(Ù†Ùˆ Ø³Ø§Ø²ÙŠ ',0),(421203,11701,'pr','ØªØ¬Ø¯ÙŠØ¯ (Ù†Ùˆ Ø³Ø§Ø²ÙŠ ',0),(421204,11701,'tr','Yenileme',0),(421205,11701,'pl','Odnowienie',0),(421206,11701,'bg','ÐŸÐ¾Ð´Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(421207,11701,'ur','Ø§Ø­ÛŒØ§',0),(421208,11701,'sr','ÐžÐ±Ð½Ð¾Ð²Ðµ',0),(421209,11701,'vi','khÃ´i phá»¥c',0),(421210,11701,'af','Hernuwing',0),(421211,11701,'ro','ReÃ®nnoirea',0),(421212,11701,'et','Uuendamine',0),(421213,11701,'si','PodaljÅ¡anje',0),(421214,11701,'ba','Pembaruan',0),(421215,11701,'nl','Vernieuwing',0),(421216,11701,'fi','Uusiminen',0),(421217,11701,'no','Fornyelse',0),(421218,11701,'da','Fornyelse',0),(421219,11701,'ko','ê°±ì‹ ',0),(421220,11701,'he','×—×™×“×•×©',0),(421221,11701,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ·',0),(421222,11701,'zh','æ›´æ–°\r\n',0),(421223,11701,'sv','FÃ¶rnyelse',0),(421224,11701,'it','Rinnovo',0),(421225,11701,'tl','',0),(421226,11701,'th','à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸',0),(421227,11701,'hi','à¤¨à¤µà¥€à¤•à¤°à¤£',0),(421228,11701,'ms','Pembaharuan',0),(421229,11701,'ar','ØªØ¬Ø¯ÙŠØ¯',0),(421230,11701,'fr','Renouvellement',0),(421231,11701,'jp','ãƒªãƒ‹ãƒ¥ãƒ¼ã‚¢ãƒ«',0),(421232,11701,'pt','RenovaÃ§Ã£o',0),(421233,11701,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(421234,11701,'es','RenovaciÃ³n',0),(421235,11701,'de','Erneuerung',0),(421236,11701,'en','Renewal',0),(421237,11702,'is','',0),(421238,11702,'dr','Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø¨Ø§Ø² Ø±Ø§ Ù„ØºÙˆ Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯ Ùˆ ÙŠÙƒ Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†Ø¯',0),(421239,11702,'pr','Ø§ÙŠÙ† ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø¨Ø§Ø² Ø±Ø§ Ù„ØºÙˆ Ø®ÙˆØ§Ù‡Ø¯ ÙƒØ±Ø¯ Ùˆ ÙŠÙƒ Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ø§ÙŠØ¬Ø§Ø¯ Ù…ÙŠ ÙƒÙ†Ø¯',0),(421240,11702,'tr','Bu aÃ§Ä±k Ã¶denmemiÅŸ faturalarÄ±n iptal edin ve yeni bir kira oluÅŸturun',0),(421241,11702,'pl','Spowoduje anulowanie otwarte niezapÅ‚aconych faktur i tworzenie nowej umowy leasingowej',0),(421242,11702,'bg','Ð¢Ð¾Ð²Ð° Ñ‰Ðµ Ð¾Ñ‚Ð¼ÐµÐ½Ð¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð½ÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¸ Ð´Ð° ÑÐµ ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ð½Ð¾Ð² Ð»Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð² Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(421243,11702,'ur','ÛŒÛ Ú©Ú¾Ù„Û’ ÛÙˆØ¦Û’ Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û ÙˆØ¨Ø¬Ù„ÛŒ Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù†Ø¦ÛŒ Ø§Ù…ÛŒØ¯ Ù¾ÛŒØ¯Ø§ ÛÙˆÚº Ú¯ÛŒ',0),(421244,11702,'sr','ÐžÐ²Ð¾ Ñ›Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð½ÐµÐ¿Ð»Ð°Ñ›ÐµÐ½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ ÑƒÐ³Ð¾Ð²Ð¾Ñ€',0),(421245,11702,'vi','Äiá»u nÃ y sáº½ há»§y cÃ¡c hÃ³a Ä‘Æ¡n chÆ°a thanh toÃ¡n vÃ  táº¡o má»™t ngÆ°á»i thuÃª má»›i',0),(421246,11702,'af','Die Oop Onbetaalde Fakture Sal Gekanselleer word en \'n Nuwe Huurkontrak Skep',0),(421247,11702,'ro','Aceasta va anula deschis facturi neplÄƒtite ÅŸi de a crea un nou contract de Ã®nchiriere',0),(421248,11702,'et','See avatud maksmata arved tÃ¼histada ja luua uue rendilepingu',0),(421249,11702,'si','To bo preklicati odprtih neplaÄanih raÄunov in ustvari novo',0),(421250,11702,'ba','Ini akan membatalkan terbuka tagihan yang belum dibayar dan membuat kontrak baru',0),(421251,11702,'nl','Dit zal annuleert Open onbetaalde facturen en maakt u een nieuwe Lease',0),(421252,11702,'fi','TÃ¤mÃ¤ peruuttaa Maksamattomat laskut ja luoda uutta puhtia',0),(421253,11702,'no','Dette vil avbryte Ã¥pne ubetalte fakturaer og opprette en ny leieavtale',0),(421254,11702,'da','Dette vil annullere Ã¥bne ubetalte fakturaer og oprette en ny lejekontrakt',0),(421255,11702,'ko','ì´ê²ƒì€ ì˜¤í”ˆ ë¯¸ë‚©ëœ ì²­êµ¬ì„œë¥¼ ì·¨ì†Œ ë˜ ê³  ìƒˆë¡œìš´ ìž„ëŒ€ë¥¼ ë§Œë“¤',0),(421256,11702,'he','×–×” ×œ×‘×˜×œ ×—×©×‘×•× ×™×•×ª ×©×œ× ×©×•×œ×ž×• ×¤×ª×•×— ×•×œ×™×¦×•×¨ ×—×•×–×” ×—×“×©',0),(421257,11702,'el','Î‘Ï…Ï„ÏŒ Î¸Î± Î±ÎºÏ…ÏÏŽÏƒÎµÎ¹ Ï„Î·Î½ Î±Î½Î¿Î¹ÎºÏ„Î® Î±Ï€Î»Î®ÏÏ‰Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎºÎ±Î¹ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Î¼Î¹Î± Î½Î­Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·',0),(421258,11702,'zh','è¿™å°†å–æ¶ˆæ‰“å¼€æœªä»˜å‘ç¥¨å¹¶åˆ›å»ºæ–°ç§Ÿçº¦\r\n',0),(421259,11702,'sv','Detta kommer att avbryta Ã¶ppna obetalda fakturor och skapa ett nytt hyresavtal',0),(421260,11702,'it','Questo annullerÃ  le fatture non pagate aperte e creare un nuovo contratto di locazione',0),(421261,11702,'tl','',0),(421262,11702,'th','à¸™à¸µà¹‰à¸ˆà¸°à¸¢à¸à¹€à¸¥à¸´à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸¢à¸±à¸‡à¹€à¸›à¸´à¸” à¹à¸¥à¸°à¸ªà¸£à¹‰à¸²à¸‡à¹€à¸Šà¹ˆà¸²à¹ƒà¸«à¸¡à¹ˆ',0),(421263,11702,'hi','à¤‡à¤¸ à¤–à¥à¤²à¥‡ à¤…à¤µà¥ˆà¤¤à¤¨à¤¿à¤• à¤šà¤¾à¤²à¤¾à¤¨ à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤à¤• à¤¨à¤¯à¤¾ à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(421264,11702,'ms','Ini akan membatalkan invois-invois tidak berbayar yang terbuka dan membuat nafas baru',0),(421265,11702,'ar','Ù‡Ø°Ø§ Ø³ÙŠØªÙ… Ø¥Ù„ØºØ§Ø¡ Ø§Ù„ÙÙˆØ§ØªÙŠØ± ØºÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© Ù…ÙØªÙˆØ­Ø© ÙˆØ¥Ù†Ø´Ø§Ø¡ Ø¹Ù‚Ø¯ Ø¥ÙŠØ¬Ø§Ø± Ø¬Ø¯ÙŠØ¯',0),(421266,11702,'fr','Cela invalide ouverte des factures impayÃ©es et crÃ©er un nouveau bail',0),(421267,11702,'jp','ã“ã‚Œã¯ã€é–‹ã„ã¦ã„ã‚‹æœªæ‰•ã„ã®è«‹æ±‚æ›¸ã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã•ã‚Œã€æ–°ã—ã„è³ƒè²¸å€Ÿå¥‘ç´„ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(421268,11702,'pt','Isto irÃ¡ cancelar nÃ£o paga as faturas em aberto e criar uma nova locaÃ§Ã£o',0),(421269,11702,'ru','Ð­Ñ‚Ð¾ Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚ ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ð¹ Ð½ÐµÐ¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¸ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ',0),(421270,11702,'es','Este CancelarÃ¡ Facturas Abiertas No Pagadas y Crear Una Nueva Arrendamiento',0),(421271,11702,'de','Das Stornieren von offenen unbezahlte Rechnungen und erstellen ein neues',0),(421272,11702,'en','This Will Cancel Open Unpaid Invoices and Create a New Lease',0),(421273,11703,'is','',0),(421274,11703,'dr','Ø§ÙŠÙ† Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ± Ø¨Ø§Ø²ÙŠ Ø±Ø§ Ù„ØºÙˆ Ù†Ù…ÙŠ ÙƒÙ†Ø¯',0),(421275,11703,'pr','Ø§ÙŠÙ† Ù‡ÙŠÚ† ÙØ§ÙƒØªÙˆØ± Ø¨Ø§Ø²ÙŠ Ø±Ø§ Ù„ØºÙˆ Ù†Ù…ÙŠ ÙƒÙ†Ø¯',0),(421276,11703,'tr','Bu olacak deÄŸil herhangi bir aÃ§Ä±k faturalarÄ±n iptal',0),(421277,11703,'pl','To bÄ™dzie nie anulujesz OtwÃ³rz faktury',0),(421278,11703,'bg','Ð¢Ð¾Ð²Ð° Ð½ÑÐ¼Ð° Ð´Ð° Ð¾Ñ‚Ð¼ÐµÐ½Ð¸ Ð½Ð¸ÐºÐ°ÐºÐ²Ð¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(421279,11703,'ur','Ø§Ø³ Ø¯Û’ Ú¯Ø§ Ù†Û Ú©ÙˆØ¦ÛŒ Ú©Ú¾Ù„ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ù…Ù†Ø³ÙˆØ®',0),(421280,11703,'sr','ÐžÐ²Ð¾ Ñ›Ðµ Ð½Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ñ‚Ð¸ ÑÐ²Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(421281,11703,'vi','Äiá»u nÃ y sáº½ khÃ´ng há»§y bÃ¢t ká»³ hÃ³a Ä‘Æ¡n má»Ÿ',0),(421282,11703,'af','Hierdie sal nie kanselleer enige oop fakture',0),(421283,11703,'ro','Aceasta nu va anula orice facturilor deschise',0),(421284,11703,'et','Selles nÃ¤idatakse LÃµpeta avatud arved',0),(421285,11703,'si','To hoteti ne preklicati vse odprte raÄune',0),(421286,11703,'ba','Ini tidak akan membatalkan setiap faktur yang terbuka',0),(421287,11703,'nl','Dit zal niet annuleren alle openstaande facturen',0),(421288,11703,'fi','TÃ¤mÃ¤ ei Peruuta avoimet laskut',0),(421289,11703,'no','Dette vil ikke avbryte alle Ã¥pne fakturaer',0),(421290,11703,'da','Dette vil ikke annullere alle Ã¥bne fakturaer',0),(421291,11703,'ko','ì´ í•˜ì§€ ì•Šì„ ê²ƒ ì´ë‹¤ ì–´ë–¤ ì˜¤í”ˆ ì†¡ìž¥ ì·¨ì†Œ',0),(421292,11703,'he','×–×” ×œ× ×œ×‘×˜×œ ××ª ×›×œ ×”×—×©×‘×•× ×™×•×ª ×”×¤×ª×•×—×•×ª',0),(421293,11703,'el','Î‘Ï…Ï„ÏŒ Î´ÎµÎ½ Î¸Î± Î±ÎºÏ…ÏÏŽÏƒÎµÎ¹ Î¿Ï€Î¿Î¹Î±Î´Î®Ï€Î¿Ï„Îµ Î±Î½Î¿Î¹ÎºÏ„Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(421294,11703,'zh','è¿™å¹¶ä¸èƒ½æ¶ˆé™¤ä»»ä½•æ‰“å¼€å‘ç¥¨\r\n',0),(421295,11703,'sv','Detta kommer inte att avbryta alla Ã¶ppna fakturor',0),(421296,11703,'it','Questo non Annulla eventuali fatture aperte',0),(421297,11703,'tl','',0),(421298,11703,'th','à¸™à¸µà¹‰à¸ˆà¸°à¹„à¸¡à¹ˆà¸¢à¸à¹€à¸¥à¸´à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¹€à¸›à¸´à¸”à¹ƒà¸” à¹†',0),(421299,11703,'hi','à¤‡à¤¸ à¤•à¤°à¥‡à¤—à¤¾ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤–à¥à¤²à¤¾ à¤šà¤¾à¤²à¤¾à¤¨ à¤°à¤¦à¥à¤¦',0),(421300,11703,'ms','Ini tidak akan membatalkan sebarang invois yang terbuka',0),(421301,11703,'ar','Ù‡Ø°Ø§ \"ÙˆØ³ÙˆÙ Ù„Ø§\" Ø¥Ù„ØºØ§Ø¡ Ø£ÙŠ \"ÙÙˆØ§ØªÙŠØ± Ù…ÙØªÙˆØ­Ø©\"',0),(421302,11703,'fr','Ce ne sera pas annuler les factures ouvertes',0),(421303,11703,'jp','ã“ã‚Œã¯ãªã„æœªæ±ºæ¸ˆã®è«‹æ±‚æ›¸ã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã—ã¾ã™ã€‚',0),(421304,11703,'pt','Este nÃ£o vai cancelar qualquer as faturas em aberto',0),(421305,11703,'ru','Ð­Ñ‚Ð¾ Ð±ÑƒÐ´ÐµÑ‚ Ð½Ðµ Ð¾Ñ‚Ð¼ÐµÐ½ÑÐµÑ‚ Ð»ÑŽÐ±Ñ‹Ðµ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(421306,11703,'es','Este no CancelarÃ¡ Algunos Facturas Abiertas',0),(421307,11703,'de','Diese wird nicht kÃ¼ndigen alle offenen Rechnungen',0),(421308,11703,'en','This Will NOT Cancel any Open Invoices',0),(421309,11704,'is','',0),(421310,11704,'dr','(Ø§Ù†ØªÙ‚Ø§Ù„',0),(421311,11704,'pr','Ø­ÙˆØ§Ù„Ù‡ (Ø§Ù†ØªÙ‚Ø§Ù„',0),(421312,11704,'tr','Transfer',0),(421313,11704,'pl','Przelew',0),(421314,11704,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ',0),(421315,11704,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(421316,11704,'sr','Ð—Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(421317,11704,'vi','chuyá»ƒn',0),(421318,11704,'af','Oordrag',0),(421319,11704,'ro','Transferul',0),(421320,11704,'et','Ãœleandmine',0),(421321,11704,'si','Prenos',0),(421322,11704,'ba','Transfer',0),(421323,11704,'nl','Overdracht',0),(421324,11704,'fi','Siirto',0),(421325,11704,'no','OverfÃ¸re',0),(421326,11704,'da','OverfÃ¸rsel',0),(421327,11704,'ko','ì „ì†¡',0),(421328,11704,'he','×”×¢×‘×¨×”',0),(421329,11704,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬',0),(421330,11704,'zh','è½¬ç§»\r\n',0),(421331,11704,'sv','Ã–verfÃ¶ring',0),(421332,11704,'it','Trasferimento',0),(421333,11704,'tl','',0),(421334,11704,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(421335,11704,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£',0),(421336,11704,'ms','Pemindahan',0),(421337,11704,'ar','Ù†Ù‚Ù„',0),(421338,11704,'fr','Transfert',0),(421339,11704,'jp','è»¢é€',0),(421340,11704,'pt','TransferÃªncia',0),(421341,11704,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‡Ð°',0),(421342,11704,'es','Transferencia',0),(421343,11704,'de','Transfer',0),(421344,11704,'en','Transfer',0),(421345,11705,'is','',0),(421346,11705,'dr','3 ',0),(421347,11705,'pr','Ú†Ø§Ù¾ Ø§ÙˆÙ„ÙŠÙ‡ Ú¯Ø²ÙŠÙ†Ù‡    3 ',0),(421348,11705,'tr','SeÃ§me hakkÄ± 3 preprint',0),(421349,11705,'pl','Preprint opcja 3',0),(421350,11705,'bg','ÐŸÑ€ÐµÐ´Ð¿ÐµÑ‡Ð°Ñ‚ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ 3',0),(421351,11705,'ur','Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹ Ø§Ø®ØªÛŒØ§Ø± 3',0),(421352,11705,'sr','3 . Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð¿Ñ€ÐµÐ¿Ñ€Ð¸Ð½Ñ‚',0),(421353,11705,'vi','in trÆ°á»›c lá»±a chá»n 3',0),(421354,11705,'af','Preprint opsie 3',0),(421355,11705,'ro','Manuscrise opÅ£iunea 3',0),(421356,11705,'et','Asuvad avaldamiseelsetes variant 3',0),(421357,11705,'si','Preprint moÅ¾nost 3',0),(421358,11705,'ba','Preprint opsi 3',0),(421359,11705,'nl','Preprint optie 3',0),(421360,11705,'fi','PrePrint vaihtoehto 3',0),(421361,11705,'no','Konferansedokument alternativ 3',0),(421362,11705,'da','Preprint mulighed 3',0),(421363,11705,'ko','ë…¼ë¬¸ ì˜µì…˜ 3',0),(421364,11705,'he','Preprint ××¤×©×¨×•×ª 3',0),(421365,11705,'el','Î ÏÎ¿-Î´Î¿ÎºÎ¯Î¼Î¹Î¿ ÎµÏ€Î¹Î»Î¿Î³Î® 3',0),(421366,11705,'zh','é¢„å°æœ¬é€‰é¡¹3\r\n',0),(421367,11705,'sv','Preprint alternativ 3',0),(421368,11705,'it','Opzione prestampa 3',0),(421369,11705,'tl','',0),(421370,11705,'th','à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸à¸²à¸£à¸žà¸´à¸¡à¸žà¹Œà¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸² 3',0),(421371,11705,'hi','Preprint à¤µà¤¿à¤•à¤²à¥à¤ª 3',0),(421372,11705,'ms','Preprint pilihan 3',0),(421373,11705,'ar','ÙˆØ±Ù‚Ø© Ø§Ù„Ø®ÙŠØ§Ø± 3',0),(421374,11705,'fr','Nous inclurons Option 3',0),(421375,11705,'jp','ã‚ªãƒ—ã‚·ãƒ§ãƒ³ 3 ã‚’ãƒ—ãƒ¬ãƒ—ãƒªãƒ³ãƒˆã—ã¾ã™ã€‚',0),(421376,11705,'pt','Preprint opÃ§Ã£o 3',0),(421377,11705,'ru','Ð˜ÐŸÐœ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ 3',0),(421378,11705,'es','Preimprimir OpciÃ³n 3',0),(421379,11705,'de','Preprint Option 3',0),(421380,11705,'en','Preprint Option 3',0),(421381,11706,'is','',0),(421382,11706,'dr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ ÙˆØ§Ø¨Ø³ØªÙ‡ Ø¨Ù‡ Ø´ØºÙ„ ',0),(421383,11706,'pr','ÙÙ‚Ø· Ù†Ù…Ø§ÙŠØ´ Ø«Ø¨Øª Ù‡Ø§ÙŠ ÙˆØ§Ø¨Ø³ØªÙ‡ Ø¨Ù‡ Ø´ØºÙ„ ',0),(421384,11706,'tr','Sadece iÅŸle ilgili giriÅŸleri gÃ¶ster',0),(421385,11706,'pl','PokaÅ¼ tylko wpisy zwiÄ…zane z pracy',0),(421386,11706,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ¸, ÑÐ²ÑŠÑ€Ð·Ð°Ð½Ð¸ Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ñ‚Ð°',0),(421387,11706,'ur','ØµØ±Ù Ù…Ù„Ø§Ø²Ù…Øª Ø³Û’ Ù…ØªØ¹Ù„Ù‚ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(421388,11706,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ð¾ÑÐ»Ð°',0),(421389,11706,'vi','Chá»‰ thá»ƒ hiá»‡n pháº§n nháº­p vÃ o liÃªn quan Ä‘áº¿n cÃ´ng viá»‡c',0),(421390,11706,'af','Wys net werkverwante inskrywings',0),(421391,11706,'ro','AratÄƒ numai intrÄƒrile legate de Job',0),(421392,11706,'et','NÃ¤ita ainult projektiga seotud kanded',0),(421393,11706,'si','PokaÅ¾i le vnose, povezane z delo',0),(421394,11706,'ba','Tampilkan hanya pekerjaan yang terkait entri',0),(421395,11706,'nl','Toon alleen werk-gerelateerde posten',0),(421396,11706,'fi','NÃ¤ytÃ¤ vain projektiin liittyvÃ¤t merkinnÃ¤t',0),(421397,11706,'no','Vis bare prosjektrelaterte poster',0),(421398,11706,'da','Vis kun Job-relaterede poster',0),(421399,11706,'ko','ì§ì—… ê´€ë ¨ í•­ëª©ë§Œ í‘œì‹œ',0),(421400,11706,'he','×”×¦×’ ×¨×§ ×¤×¨×™×˜×™× ×”×§×©×•×¨×•×ª ×‘×¢×‘×•×“×”',0),(421401,11706,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… ÏƒÏ‡ÎµÏ„Î¯Î¶Î¿Î½Ï„Î±Î¹ Î¼Îµ Ï„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(421402,11706,'zh','ä»…æ˜¾ç¤ºå·¥ä½œç›¸å…³çš„æ¡ç›®\r\n',0),(421403,11706,'sv','Visa endast jobb-relaterade poster',0),(421404,11706,'it','Visualizza solo le voci relative al lavoro',0),(421405,11706,'tl','',0),(421406,11706,'th','à¹à¸ªà¸”à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¹€à¸à¸µà¹ˆà¸¢à¸§à¸‚à¹‰à¸­à¸‡à¸à¸±à¸šà¸‡à¸²à¸™à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(421407,11706,'hi','à¤•à¥‡à¤µà¤² à¤•à¤¾à¤°à¥à¤¯-à¤¸à¤‚à¤¬à¤‚à¤§à¤¿à¤¤ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(421408,11706,'ms','Menunjukkan hanya terhadap penyertaan',0),(421409,11706,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø°Ø§Øª Ø§Ù„ØµÙ„Ø© Ø¨Ø§Ù„ÙˆØ¸ÙŠÙØ© ÙÙ‚Ø·',0),(421410,11706,'fr','Afficher uniquement les entrÃ©es liÃ©es Ã  l\'emploi',0),(421411,11706,'jp','ã‚¸ãƒ§ãƒ–é–¢é€£ã‚¨ãƒ³ãƒˆãƒªã®ã¿è¡¨ç¤ºã—ã¾ã™ã€‚',0),(421412,11706,'pt','Mostrar apenas as entradas referentes ao trabalho',0),(421413,11706,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð·Ð°Ð¿Ð¸ÑÐ¸, ÑÐ²ÑÐ·Ð°Ð½Ð½Ñ‹Ðµ Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð¹',0),(421414,11706,'es','Muestra Solo Entradas Relacionadas a Trabajo',0),(421415,11706,'de','Nur berufsbezogene EintrÃ¤ge anzeigen',0),(421416,11706,'en','Show Only Job-Related Entries',0),(421417,11707,'is','',0),(421418,11707,'dr','Ù†Ù…Ø§ÙŠØ´ Ø·Ø¨Ù‚ Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(421419,11707,'pr','Ù†Ù…Ø§ÙŠØ´ Ø·Ø¨Ù‚ Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§ ',0),(421420,11707,'tr','Stok konumuna gÃ¶re gÃ¶rÃ¼ntÃ¼le',0),(421421,11707,'pl','Widok wedÅ‚ug lokalizacji zapasÃ³w',0),(421422,11707,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¾Ñ‚ Ð¼ÑÑÑ‚Ð¾ Ð·Ð° ÑÐºÐ»Ð°Ð´',0),(421423,11707,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù†Ø¸Ø±',0),(421424,11707,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ð¾ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(421425,11707,'vi','Xem theo kho V. trï¿½',0),(421426,11707,'af','Besigtig Per Voorraadligging',0),(421427,11707,'ro','Vezi de inventar locaÅ£ie',0),(421428,11707,'et','Kuva lao asukoha jÃ¤rgi',0),(421429,11707,'si','Glede na lokacijo zaloge',0),(421430,11707,'ba','Lihat melalui inventaris lokasi',0),(421431,11707,'nl','Weergave door voorraadvestiging',0),(421432,11707,'fi','NÃ¤ytÃ¤ varaston sijainti',0),(421433,11707,'no','Vis etter lagerlokasjon',0),(421434,11707,'da','Visning af lagerlokation',0),(421435,11707,'ko','ìž¬ê³  ìœ„ì¹˜ ë³„ë¡œ ë³´ê¸°',0),(421436,11707,'he','×ª×¦×•×’×” ×œ×¤×™ ×ž×™×§×•× ×”×ž×œ××™',0),(421437,11707,'el','Î˜Î­Î± Î±Ï€ÏŒ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(421438,11707,'zh','æŒ‰åº“å­˜åœ°ç‚¹æŸ¥çœ‹\r\n',0),(421439,11707,'sv','Visa efter lagerstÃ¤lle',0),(421440,11707,'it','Vista di Ubicazione di inventario',0),(421441,11707,'tl','',0),(421442,11707,'th','à¸”à¸¹à¸•à¸²à¸¡à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(421443,11707,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(421444,11707,'ms','Paparan Ikut lokasi inventori',0),(421445,11707,'ar','Ø¹Ø±Ø¶ Ø­Ø³Ø¨ Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(421446,11707,'fr','Vue de l\'emplacement de l\'inventaire',0),(421447,11707,'jp','åœ¨åº«å ´æ‰€ã®ãƒ“ãƒ¥ãƒ¼',0),(421448,11707,'pt','Vista pela localizaÃ§Ã£o de inventÃ¡rio',0),(421449,11707,'ru','Ð’Ð¸Ð´ Ð½Ð° ÑÐºÐ»Ð°Ð´Ðµ',0),(421450,11707,'es','Ver por Inventario Ubicación',0),(421451,11707,'de','Nach Lagerort anzeigen',0),(421452,11707,'en','View By Inventory Location',0),(421453,11708,'is','',0),(421454,11708,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(421455,11708,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø§Ù‚ÙŠÙ…Ø§Ù†Ø¯Ù‡ ',0),(421456,11708,'tr','Vergi kalan gÃ¶ster',0),(421457,11708,'pl','PokaÅ¼ pozostaÅ‚e podatku',0),(421458,11708,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¾ÑÑ‚Ð°Ð½Ð°Ð»Ð¸Ñ‚Ðµ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸',0),(421459,11708,'ur','Ù¹ÛŒÚ©Ø³ Ø¨Ø§Ù‚ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(421460,11708,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(421461,11708,'vi','Hiá»ƒn thá»‹ thuáº¿ cÃ²n láº¡i',0),(421462,11708,'af','Wys oorblywende belasting',0),(421463,11708,'ro','AratÄƒ rÄƒmase fiscale',0),(421464,11708,'et','Kuva jÃ¤Ã¤nud maksu',0),(421465,11708,'si','PokaÅ¾i preostale davka',0),(421466,11708,'ba','Menunjukkan sisa pajak',0),(421467,11708,'nl','Toon resterende belasting',0),(421468,11708,'fi','NÃ¤ytÃ¤ jÃ¤ljellÃ¤ oleva vero',0),(421469,11708,'no','Vis gjenvÃ¦rende skatt',0),(421470,11708,'da','Vis resterende skat',0),(421471,11708,'ko','ë‚¨ì€ ì„¸ê¸ˆ í‘œì‹œ',0),(421472,11708,'he','×”×¦×’ × ×•×ª×¨ ×ž×¡',0),(421473,11708,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Î±ÏÎ±Î¼Î­Î½Î¿Ï…Î½ Ï†ÏŒÏÎ¿Ï…',0),(421474,11708,'zh','æ˜¾ç¤ºå‰©ä½™ç¨Ž\r\n',0),(421475,11708,'sv','Visa Ã¥terstÃ¥ende skatt',0),(421476,11708,'it','Visualizza rimanendo fiscale',0),(421477,11708,'tl','',0),(421478,11708,'th','à¹à¸ªà¸”à¸‡à¸ à¸²à¸©à¸µà¸—à¸µà¹ˆà¹€à¸«à¸¥à¸·à¸­à¸­à¸¢à¸¹à¹ˆ',0),(421479,11708,'hi','à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¶à¥‡à¤·',0),(421480,11708,'ms','Menunjukkan baki cukai',0),(421481,11708,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù…ØªØ¨Ù‚ÙŠ Ù…Ù† Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(421482,11708,'fr','Voir l\'Ã©tablissement restant impÃ´t',0),(421483,11708,'jp','æ®‹ã‚Šã®ç¨Žã‚’ç¤ºã™',0),(421484,11708,'pt','Mostrar o restante imposto',0),(421485,11708,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾ÑÑ‚Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð½Ð°Ð»Ð¾Ð³',0),(421486,11708,'es','Muestra Saldos de Impuestos',0),(421487,11708,'de','Zeigen Sie verbleibende Steuer an',0),(421488,11708,'en','Show Remaining Tax',0),(421489,11709,'is','',0),(421490,11709,'dr','Ù…Ø§Ù†Ø¯Ù‡  Ù…Ø§Ù„ÙŠØ§Øª ',0),(421491,11709,'pr','Ù…Ø§Ù†Ø¯Ù‡  Ù…Ø§Ù„ÙŠØ§Øª ',0),(421492,11709,'tr','Vergi bakiyesi',0),(421493,11709,'pl','Saldo podatkowe',0),(421494,11709,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð±Ð°Ð»Ð°Ð½Ñ',0),(421495,11709,'ur','Ù¹ÛŒÚ©Ø³ Ø¨Ù‚Ø§ÛŒØ§',0),(421496,11709,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° ÑÐ°Ð»Ð´Ð¾',0),(421497,11709,'vi','sá»‘ dÆ° thuáº¿',0),(421498,11709,'af','Belasting balans',0),(421499,11709,'ro','BalanÅ£a fiscalÄƒ',0),(421500,11709,'et','KÃ¤ibemaksu saldo',0),(421501,11709,'si','DavÄna bilanca',0),(421502,11709,'ba','Keseimbangan pajak',0),(421503,11709,'nl','Fiscale balans',0),(421504,11709,'fi','Verosaldo',0),(421505,11709,'no','Saldo',0),(421506,11709,'da','Momssaldo',0),(421507,11709,'ko','ì„¸ê¸ˆ ê· í˜•',0),(421508,11709,'he','×ž×¡ ××™×–×•×Ÿ',0),(421509,11709,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±',0),(421510,11709,'zh','ç¨Žä½™é¢\r\n',0),(421511,11709,'sv','Momssaldo',0),(421512,11709,'it','Equilibrio fiscale',0),(421513,11709,'tl','',0),(421514,11709,'th','à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸ à¸²à¸©à¸µ',0),(421515,11709,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¶à¥‡à¤·',0),(421516,11709,'ms','Baki cukai',0),(421517,11709,'ar','Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ',0),(421518,11709,'fr','Solde de l\'impÃ´t',0),(421519,11709,'jp','èª²ç¨Žãƒãƒ©ãƒ³ã‚¹',0),(421520,11709,'pt','EquilÃ­brio fiscal',0),(421521,11709,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð±Ð°Ð»Ð°Ð½Ñ',0),(421522,11709,'es','Balance de Impuesto',0),(421523,11709,'de','Steuer-Balance',0),(421524,11709,'en','Tax Balance',0),(421525,11710,'is','',0),(421526,11710,'dr','Ø§ÙØ²ÙˆØ¯Ù†  Ø¨Ø±Ú†Ø³Ø¨ Ø¬Ø¯ÙŠØ¯ ',0),(421527,11710,'pr','Ø§ÙØ²ÙˆØ¯Ù†  Ø¨Ø±Ú†Ø³Ø¨ Ø¬Ø¯ÙŠØ¯ ',0),(421528,11710,'tr','Yeni etiket ekle',0),(421529,11710,'pl','Dodaj nowÄ… etykietÄ™',0),(421530,11710,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² ÐµÑ‚Ð¸ÐºÐµÑ‚',0),(421531,11710,'ur','Ù†ÛŒØ§ Ù„ÛŒØ¨Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(421532,11710,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ Ð¾Ð·Ð½Ð°ÐºÑƒ',0),(421533,11710,'vi','ThÃªm nhÃ£n má»›i',0),(421534,11710,'af','Nuwe Etikette Byvoeg',0),(421535,11710,'ro','AdaugÄƒ nouÄƒ etichetÄƒ',0),(421536,11710,'et','Lisa uus silt',0),(421537,11710,'si','Dodaj novo oznako',0),(421538,11710,'ba','Menambahkan Label baru',0),(421539,11710,'nl','Nieuwe Label toevoegen',0),(421540,11710,'fi','LisÃ¤Ã¤ uusi selite',0),(421541,11710,'no','Legg til ny etikett',0),(421542,11710,'da','TilfÃ¸j ny etiket',0),(421543,11710,'ko','ìƒˆ ë ˆì´ë¸” ì¶”ê°€',0),(421544,11710,'he','×”×•×¡×£ ×ª×•×•×™×ª ×—×“×©×”',0),(421545,11710,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÎµÏ„Î¹ÎºÎ­Ï„Î±',0),(421546,11710,'zh','å¢žåŠ æ–°æ ‡ç­¾\r\n',0),(421547,11710,'sv','LÃ¤gg till ny etikett',0),(421548,11710,'it','Aggiungi nuova etichetta',0),(421549,11710,'tl','',0),(421550,11710,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­à¹ƒà¸«à¸¡à¹ˆ',0),(421551,11710,'hi','à¤¨à¤¯à¤¾ à¤²à¥‡à¤¬à¤² à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(421552,11710,'ms','Tambah Label baru',0),(421553,11710,'ar','Ø¥Ø¶Ø§ÙØ© ØªØ³Ù…ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(421554,11710,'fr','Ajouter nouveau Label',0),(421555,11710,'jp','æ–°ã—ã„ãƒ©ãƒ™ãƒ«ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(421556,11710,'pt','Adicionar nova etiqueta',0),(421557,11710,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð¼ÐµÑ‚ÐºÑƒ',0),(421558,11710,'es','Agregar Nueva Etiqueta',0),(421559,11710,'de','FÃ¼gen Sie neue Bezeichnung',0),(421560,11710,'en','Add New Label',0),(421561,11711,'is','',0),(421562,11711,'dr','Ù…Ø­Ù„ Ø¨Ø§Ø±ÙƒØ¯ Ø±ÙˆÙŠ Ø¨Ø±Ú†Ø³Ø¨ Ù…Ù†Ø§Ø³Ø¨ Ø§Ø³Øª',0),(421563,11711,'pr','Ù…Ø­Ù„ Ø¨Ø§Ø±ÙƒØ¯ Ø±ÙˆÙŠ Ø¨Ø±Ú†Ø³Ø¨ Ù…Ù†Ø§Ø³Ø¨ Ø§Ø³Øª',0),(421564,11711,'tr','Etiket barkod bulunduÄŸu noktalarÄ±',0),(421565,11711,'pl','Stanowisko kodÃ³w kreskowych na etykiecie w punktach',0),(421566,11711,'bg','Ð‘Ð°Ñ€ÐºÐ¾Ð´ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð° Ð² Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(421567,11711,'ur','Ù„ÛŒØ¨Ù„ Ù¾Ø± Ø¨Ø§Ø±Ú©ÙˆÚˆ Ù¾ÙˆØ²ÛŒØ´Ù† Ù†Ú©Ø§Øª Ù…ÛŒÚº',0),(421568,11711,'sr','Ð‘ÐÐ Ð¦ÐžÐ”Ð• Ð¿Ð¾Ð»Ð¾Ð¶Ð°Ñ˜ Ð½Ð° Ð¾Ð·Ð½Ð°ÐºÑƒ Ñƒ Ñ‚Ð°Ñ‡ÐºÐ°Ð¼Ð°',0),(421569,11711,'vi','Vá»‹ trÃ­ mÃ£ váº¡ch trÃªn nhÃ£n táº¡i cÃ¡c Ä‘iá»ƒm',0),(421570,11711,'af','Strepieskode posisie op etiket In punte',0),(421571,11711,'ro','PoziÅ£ia de coduri de bare pe etichetÄƒ Ã®n puncte',0),(421572,11711,'et','VÃ¶Ã¶tkoodi positsiooni etiketile punktid',0),(421573,11711,'si','PoloÅ¾aj Ärtne kode na etiketi toÄk',0),(421574,11711,'ba','Posisi barcode label dalam poin',0),(421575,11711,'nl','Positie van de streepjescode op Label In punten',0),(421576,11711,'fi','Viivakoodin paikka etiketissÃ¤ pistettÃ¤',0),(421577,11711,'no','Strekkode posisjon pÃ¥ etiketten poeng',0),(421578,11711,'da','Stregkode placering pÃ¥ etiketten i point',0),(421579,11711,'ko','í¬ì¸íŠ¸ì—ì„œ ë¼ë²¨ì— ë°”ì½”ë“œ ìœ„ì¹˜',0),(421580,11711,'he','×¢×ž×“×ª ×‘×¨×§×•×“ ×¢×œ ×ª×•×•×™×ª ×‘× ×§×•×“×•×ª',0),(421581,11711,'el','Barcode Î¸Î­ÏƒÎ· ÏƒÏ„Î·Î½ ÎµÏ„Î¹ÎºÎ­Ï„Î± ÏƒÏ„Î± ÏƒÎ·Î¼ÎµÎ¯Î±',0),(421582,11711,'zh','æ ‡ç­¾ä¸Šçš„æ¡ç ä½ç½®ç‚¹',0),(421583,11711,'sv','Barcode Position pÃ¥ etikett i poÃ¤ng',0),(421584,11711,'it','Codice a barre posizione sull\'etichetta In punti',0),(421585,11711,'tl','',0),(421586,11711,'th','à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”à¸šà¸™à¸‰à¸¥à¸²à¸à¹ƒà¸™à¸ˆà¸¸à¸”',0),(421587,11711,'hi','à¤¬à¤¿à¤‚à¤¦à¥à¤“à¤‚ à¤®à¥‡à¤‚ à¤²à¥‡à¤¬à¤² à¤ªà¤° à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(421588,11711,'ms','Kedudukan barcode Label pada mata',0),(421589,11711,'ar','Ù…ÙˆØ¶Ø¹ Ø§Ù„Ø¨Ø§Ø±ÙƒÙˆØ¯ Ø¹Ù„Ù‰ Ø§Ù„ØªØ³Ù…ÙŠØ© ÙÙŠ Ø§Ù„Ù†Ù‚Ø§Ø·',0),(421590,11711,'fr','Position de code Ã  barres sur l\'Ã©tiquette en Points',0),(421591,11711,'jp','ãƒã‚¤ãƒ³ãƒˆ ãƒ©ãƒ™ãƒ«ã®ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã®ä½ç½®',0),(421592,11711,'pt','PosiÃ§Ã£o do cÃ³digo de barras no rÃ³tulo em pontos',0),(421593,11711,'ru','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ñ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´Ð° Ð½Ð° ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐµ Ð² Ñ‚Ð¾Ñ‡ÐºÐ°Ñ…',0),(421594,11711,'es','PosiciÃ³n de CÃ³digo de Barra en la Etiqueta en Puntos',0),(421595,11711,'de','Barcode Position auf Etikett In Punkten',0),(421596,11711,'en','Barcode Position On Label In Points',0),(421597,11712,'is','',0),(421598,11712,'dr','(Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯) Ù…Ø´ØªØ±ÙŠ',0),(421599,11712,'pr','ÙÙŠÙ„Ø¯(Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯) Ù…Ø´ØªØ±ÙŠ',0),(421600,11712,'tr','Ã–zel alan',0),(421601,11712,'pl','Pole niestandardowe',0),(421602,11712,'bg','ÐŸÐ¾Ð»Ðµ Ð¿Ð¾ Ð¸Ð·Ð±Ð¾Ñ€',0),(421603,11712,'ur','Ù…Ø®ØµÙˆØµ Ù‚Ø·Ø¹Û',0),(421604,11712,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¾ Ð¿Ð¾Ñ™Ðµ',0),(421605,11712,'vi','trÆ°á»ng tá»± táº¡o',0),(421606,11712,'af','Pasgemaakte veld',0),(421607,11712,'ro','CÃ¢mp personalizat',0),(421608,11712,'et','Kohandatud vÃ¤li',0),(421609,11712,'si','Polje po meri',0),(421610,11712,'ba','Bidang kustom',0),(421611,11712,'nl','Aangepast veld',0),(421612,11712,'fi','Mukautettu kenttÃ¤',0),(421613,11712,'no','Egendefinert felt',0),(421614,11712,'da','Brugerdefineret felt',0),(421615,11712,'ko','ì‚¬ìš©ìž ì •ì˜ í•„ë“œ',0),(421616,11712,'he','×©×“×” ×ž×•×ª×× ××™×©×™×ª',0),(421617,11712,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î¿ Ï€ÎµÎ´Î¯Î¿',0),(421618,11712,'zh','è‡ªå®šä¹‰å­—æ®µ\r\n',0),(421619,11712,'sv','Anpassat fÃ¤lt',0),(421620,11712,'it','Campo personalizzato',0),(421621,11712,'tl','',0),(421622,11712,'th','à¸Ÿà¸´à¸¥à¸”à¹Œà¹à¸šà¸šà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡',0),(421623,11712,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤«à¤¼à¥€à¤²à¥à¤¡',0),(421624,11712,'ms','Bidang adat',0),(421625,11712,'ar','Ø­Ù‚Ù„ Ù…Ø®ØµÙ‘Øµ',0),(421626,11712,'fr','Champ personnalisÃ©',0),(421627,11712,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼è¨­å®šãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(421628,11712,'pt','Campo personalizado',0),(421629,11712,'ru','ÐÐ°ÑÑ‚Ñ€Ð°Ð¸Ð²Ð°ÐµÐ¼Ð¾Ðµ Ð¿Ð¾Ð»Ðµ',0),(421630,11712,'es','Campo Personalizado',0),(421631,11712,'de','Benutzerdefiniertes Feld',0),(421632,11712,'en','Custom Field',0),(421633,11713,'is','',0),(421634,11713,'dr','Ù…Ø­Ù„ Ø´Ø±Ø­ Ø±ÙˆÙŠ Ø¨Ø±Ú†Ø³Ø¨ Ù…Ù†Ø§Ø³Ø¨ ',0),(421635,11713,'pr','Ù…Ø­Ù„ Ø´Ø±Ø­ Ø±ÙˆÙŠ Ø¨Ø±Ú†Ø³Ø¨ Ù…Ù†Ø§Ø³Ø¨ ',0),(421636,11713,'tr','Etiket aÃ§Ä±klamasÄ± bulunduÄŸu noktalarÄ±',0),(421637,11713,'pl','Opis pozycji na etykiecie w punktach',0),(421638,11713,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð° Ð² Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(421639,11713,'ur','Ù†Ú©Ø§Øª Ù…ÛŒÚº Ù„ÛŒØ¨Ù„ Ù¾Ø± Ù¾ÙˆØ²ÛŒØ´Ù† Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(421640,11713,'sr','ÐžÐ¿Ð¸Ñ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ˜Ð° Ð½Ð° Ð½Ð°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ð¸ Ñƒ Ñ‚Ð°Ñ‡ÐºÐ°Ð¼Ð°',0),(421641,11713,'vi','diá»…n giáº£i vá»‹ trÃ­ trÃªn nhÃ£n táº¡i cÃ¡c Ä‘iá»ƒm',0),(421642,11713,'af','Beskrywing posisie op etiket In punte',0),(421643,11713,'ro','PoziÅ£ie Descriere pe etichetÄƒ Ã®n puncte',0),(421644,11713,'et','Kirjeldus seisukoht etiketile punktides',0),(421645,11713,'si','Opis poloÅ¾aja na etiketi toÄk',0),(421646,11713,'ba','Deskripsi posisi pada Label dalam poin',0),(421647,11713,'nl','Beschrijving positie op de Label In punten',0),(421648,11713,'fi','Kuvaus kantaa etiketti pistettÃ¤',0),(421649,11713,'no','Beskrivelse posisjon pÃ¥ etiketten poeng',0),(421650,11713,'da','Beskrivelse placering pÃ¥ etiketten i point',0),(421651,11713,'ko','í¬ì¸íŠ¸ì—ì„œ ë¼ë²¨ì— ì„¤ëª… ìœ„ì¹˜',0),(421652,11713,'he','×ª×™××•×¨ ×”×ž×™×§×•× ×‘×ª×•×•×™×ª ×‘× ×§×•×“×•×ª',0),(421653,11713,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î¸Î­ÏƒÎ· ÏƒÏ„Î·Î½ ÎµÏ„Î¹ÎºÎ­Ï„Î± ÏƒÏ„Î± ÏƒÎ·Î¼ÎµÎ¯Î±',0),(421654,11713,'zh','è¯´æ˜Žæ ‡ç­¾ä¸Šçš„ä½ç½®ç‚¹\r\n',0),(421655,11713,'sv','Beskrivning Position pÃ¥ etikett i poÃ¤ng',0),(421656,11713,'it','Descrizione posizione sull\'etichetta In punti',0),(421657,11713,'tl','',0),(421658,11713,'th','à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸šà¸™à¸‰à¸¥à¸²à¸à¹ƒà¸™à¸ˆà¸¸à¸”',0),(421659,11713,'hi','à¤¬à¤¿à¤‚à¤¦à¥à¤“à¤‚ à¤®à¥‡à¤‚ à¤²à¥‡à¤¬à¤² à¤ªà¤° à¤µà¤°à¥à¤£à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(421660,11713,'ms','Keterangan kedudukan pada Label dalam mata',0),(421661,11713,'ar','ÙˆØµÙ Ù…ÙˆÙ‚Ù Ø¨Ø´Ø£Ù† Ø§Ù„ØªØ³Ù…ÙŠØ© ÙÙŠ Ø§Ù„Ù†Ù‚Ø§Ø·',0),(421662,11713,'fr','Description Position sur l\'Ã©tiquette en Points',0),(421663,11713,'jp','ãƒã‚¤ãƒ³ãƒˆ ãƒ©ãƒ™ãƒ«ã«èª¬æ˜Žã®ä½ç½®',0),(421664,11713,'pt','PosiÃ§Ã£o descriÃ§Ã£o no rÃ³tulo em pontos',0),(421665,11713,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ð½Ð° ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐµ Ð² Ð¿ÑƒÐ½ÐºÑ‚Ð°Ñ…',0),(421666,11713,'es','DescripciÃ³n de la Posicion en la Etiqueta en Puntos',0),(421667,11713,'de','Beschreibung Position auf Etikett In Punkten',0),(421668,11713,'en','Description Position On Label In Points',0),(421669,11714,'is','',0),(421670,11714,'dr','Ù…Ø­Ù„ Ù…ØªÙ† Ù…Ø¹ÙŠÙ† Ø´Ø¯Ù‡ Ø±ÙˆÙŠ Ø¨Ø±Ú†Ø³Ø¨ Ù…Ù†Ø§Ø³Ø¨ ',0),(421671,11714,'pr','Ù…Ø­Ù„ Ù…ØªÙ† Ù…Ø¹ÙŠÙ† Ø´Ø¯Ù‡ Ø±ÙˆÙŠ Ø¨Ø±Ú†Ø³Ø¨ Ù…Ù†Ø§Ø³Ø¨ ',0),(421672,11714,'tr','Etiket Ã¼zerindeki sabit metin bulunduÄŸu noktalarÄ±',0),(421673,11714,'pl','StaÅ‚y tekst pozycji na etykiecie w punktach',0),(421674,11714,'bg','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð°Ð½ Ñ‚ÐµÐºÑÑ‚ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð° Ð² Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(421675,11714,'ur','Ø¬Ø§Ù…Ø¯ Ù…ØªÙ† Ù„ÛŒØ¨Ù„ Ù¾Ø± Ù¾ÙˆØ²ÛŒØ´Ù† Ù†Ú©Ø§Øª Ù…ÛŒÚº',0),(421676,11714,'sr','Ð¤Ð¸ÐºÑÐ½Ð¸ Ñ‚ÐµÐºÑÑ‚ Ð¿Ð¾Ð»Ð¾Ð¶Ð°Ñ˜ Ð½Ð° Ð¾Ð·Ð½Ð°ÐºÑƒ Ñƒ Ñ‚Ð°Ñ‡ÐºÐ°Ð¼Ð°',0),(421677,11714,'vi','vá»‹ trÃ­ trÃªn nhÃ£n lÃ  Ä‘iá»ƒm cÃ³ Ä‘á»‹nh',0),(421678,11714,'af','Vaste teks posisie op etiket In punte',0),(421679,11714,'ro','PoziÅ£ia fix Text pe etichetÄƒ Ã®n puncte',0),(421680,11714,'et','PÃ¼siteksti positsiooni etiketile punktid',0),(421681,11714,'si','PoloÅ¾aj stalno besedilo na nalepki v toÄkah',0),(421682,11714,'ba','Posisi tetap teks pada Label dalam poin',0),(421683,11714,'nl','Vaste tekstpositie op de Label In punten',0),(421684,11714,'fi','KiinteÃ¤n tekstin sijainnin etiketissÃ¤ pistettÃ¤',0),(421685,11714,'no','Fast tekst posisjon pÃ¥ etiketten poeng',0),(421686,11714,'da','Fast tekstens placering pÃ¥ etiketten i point',0),(421687,11714,'ko','í¬ì¸íŠ¸ì—ì„œ ë¼ë²¨ì— ê³ ì • ëœ í…ìŠ¤íŠ¸ ìœ„ì¹˜',0),(421688,11714,'he','×ž×™×§×•× ×˜×§×¡×˜ ×§×‘×•×¢ ×¢×œ ×ª×•×•×™×ª ×‘× ×§×•×“×•×ª',0),(421689,11714,'el','Î˜Î­ÏƒÎ· ÏƒÏ„Î±Î¸ÎµÏÏŒ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î·Î½ ÎµÏ„Î¹ÎºÎ­Ï„Î± ÏƒÏ„Î± ÏƒÎ·Î¼ÎµÎ¯Î±',0),(421690,11714,'zh','æ ‡ç­¾ä¸Šçš„å›ºå®šæ–‡æœ¬çš„ä½ç½®ç‚¹\r\n',0),(421691,11714,'sv','Fast Text Position pÃ¥ etikett i poÃ¤ng',0),(421692,11714,'it','Posizione testo fisso sull\'etichetta In punti',0),(421693,11714,'tl','',0),(421694,11714,'th','à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸–à¸²à¸§à¸£à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸šà¸™à¸‰à¸¥à¸²à¸à¹ƒà¸™à¸ˆà¸¸à¸”',0),(421695,11714,'hi','à¤¬à¤¿à¤‚à¤¦à¥à¤“à¤‚ à¤®à¥‡à¤‚ à¤²à¥‡à¤¬à¤² à¤ªà¤° à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤ªà¤¾à¤  à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(421696,11714,'ms','Kedudukan teks tetap pada Label dalam mata',0),(421697,11714,'ar','Ù…ÙˆÙ‚Ù Ø«Ø§Ø¨Øª Ø§Ù„Ù†Øµ ÙÙŠ Ø§Ù„ØªØ³Ù…ÙŠØ© ÙÙŠ Ø§Ù„Ù†Ù‚Ø§Ø·',0),(421698,11714,'fr','Position du texte fixe sur l\'Ã©tiquette en Points',0),(421699,11714,'jp','ãƒã‚¤ãƒ³ãƒˆ ãƒ©ãƒ™ãƒ«ã«å›ºå®šã®ãƒ†ã‚­ã‚¹ãƒˆã®ä½ç½®',0),(421700,11714,'pt','PosiÃ§Ã£o de texto fixo no rÃ³tulo em pontos',0),(421701,11714,'ru','ÐŸÐ¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ñ„Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð¾Ð³Ð¾ Ñ‚ÐµÐºÑÑ‚Ð° Ð½Ð° ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐµ Ð² Ñ‚Ð¾Ñ‡ÐºÐ°Ñ…',0),(421702,11714,'es','PosiciÃ³n de Texto Fijo en la Etiqueta en Puntos',0),(421703,11714,'de','Fester Textposition auf Etikett In Punkten',0),(421704,11714,'en','Fixed Text Position On Label In Points',0),(421705,11715,'is','',0),(421706,11715,'dr','Ù…ØªÙ† Ù…Ø¹ÙŠÙ† Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø±ÙˆÙŠ ØªÙ…Ø§Ù… Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ ',0),(421707,11715,'pr','Ù…ØªÙ† Ù…Ø¹ÙŠÙ† Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÙŠ Ú†Ø§Ù¾ Ø±ÙˆÙŠ ØªÙ…Ø§Ù… Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ ',0),(421708,11715,'tr','TÃ¼m etiketlere yazdÄ±rmak iÃ§in sabit metin',0),(421709,11715,'pl','StaÅ‚y tekst do druku na etykietach wszystkich',0),(421710,11715,'bg','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð°Ð½ Ñ‚ÐµÐºÑÑ‚ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(421711,11715,'ur','ØªÙ…Ø§Ù… Ù„ÛŒØ¨Ù„ÙˆÚº Ù¾Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù‚Ø±Ø±Û Ù…ØªÙ†',0),(421712,11715,'sr','Ð¤Ð¸ÐºÑÐ½Ð¸ Ñ‚ÐµÐºÑÑ‚ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð° ÑÐ²Ðµ Ð¾Ð·Ð½Ð°ÐºÐµ',0),(421713,11715,'vi','in táº¥t cáº£ cÃ¡c nhÃ£n cá»‘ Ä‘á»‹nh',0),(421714,11715,'af','Vaste teks om druk op alle etikette',0),(421715,11715,'ro','Fix Text pentru a imprima pe toate etichetele',0),(421716,11715,'et','Prindi kÃµik etikettidele pÃ¼siteksti',0),(421717,11715,'si','Stalno besedilo tisk na vse oznake',0),(421718,11715,'ba','Tetap teks cetak pada semua label',0),(421719,11715,'nl','Vaste tekst af te drukken op alle etiketten',0),(421720,11715,'fi','Vakioteksti tulostaa kaikki otsikot',0),(421721,11715,'no','Fast tekst til ut pÃ¥ alle etikettene',0),(421722,11715,'da','Fast tekst til Print pÃ¥ alle mÃ¦rker',0),(421723,11715,'ko','ëª¨ë“  ë ˆì´ë¸”ì— ì¸ì‡„ ê³ ì •ëœ í…ìŠ¤íŠ¸',0),(421724,11715,'he','×˜×§×¡×˜ ×§×‘×•×¢ ×¢×œ ×”×“×¤×¡ ×¢×œ ×›×œ ×”×ª×•×•×™×•×ª',0),(421725,11715,'el','Î£Ï„Î±Î¸ÎµÏÏŒ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÎµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÎµÏ„Î¹ÎºÎ­Ï„ÎµÏ‚',0),(421726,11715,'zh','å›ºå®šæ–‡æœ¬ä¸Šæ‰“å°æ‰€æœ‰æ ‡ç­¾\r\n',0),(421727,11715,'sv','Fast Text att skriva ut pÃ¥ alla etiketter',0),(421728,11715,'it','Testo fisso per stampa su tutte le etichette',0),(421729,11715,'tl','',0),(421730,11715,'th','à¸–à¸²à¸§à¸£à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸—à¸µà¹ˆà¸žà¸´à¸¡à¸žà¹Œà¸šà¸™à¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(421731,11715,'hi','à¤¸à¤­à¥€ à¤²à¥‡à¤¬à¤²à¥à¤¸ à¤ªà¤° à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤ªà¤¾à¤ ',0),(421732,11715,'ms','Teks yang tetap untuk cetakan pada label semua',0),(421733,11715,'ar','Ù†Øµ Ø«Ø§Ø¨Øª Ù„Ù„Ø·Ø¨Ø§Ø¹Ø© Ø¹Ù„Ù‰ ÙƒØ§ÙØ© Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø¹Ù†ÙˆÙ†Ø©',0),(421734,11715,'fr','Texte fixe Ã  imprimer sur toutes les Ã©tiquettes',0),(421735,11715,'jp','ã™ã¹ã¦ã®ãƒ©ãƒ™ãƒ«ã«å°åˆ·ã™ã‚‹ã«ã¯å›ºå®šãƒ†ã‚­ã‚¹ãƒˆ',0),(421736,11715,'pt','Texto fixo para impressÃ£o em todos os rÃ³tulos',0),(421737,11715,'ru','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹ Ñ‚ÐµÐºÑÑ‚ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð½Ð° Ð²ÑÐµÑ… ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ°Ñ…',0),(421738,11715,'es','Texto Fijo Para Imprimir en Todas las Etiquetas',0),(421739,11715,'de','Feststehender Text Drucken auf allen Etiketten',0),(421740,11715,'en','Fixed Text To Print On All Labels',0),(421741,11716,'is','',0),(421742,11716,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚Ù„Ù… Ù…Ù†Ø§Ø³Ø¨',0),(421743,11716,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù‚Ù„Ù… Ù…Ù†Ø§Ø³Ø¨',0),(421744,11716,'tr','YazÄ± tipi boyutu Puan',0),(421745,11716,'pl','Rozmiar czcionki w punktach',0),(421746,11716,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° ÑˆÑ€Ð¸Ñ„Ñ‚Ð° Ð² Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(421747,11716,'ur','Ù¾ÙˆØ§Ø¦Ù†Ù¹ Ù…ÛŒÚº ÙØ§Ù†Ù¹ Ø³Ø§Ø¦Ø²',0),(421748,11716,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ñ„Ð¾Ð½Ñ‚Ð° Ñƒ Ñ‚Ð°Ñ‡ÐºÐ°Ð¼Ð°',0),(421749,11716,'vi','KÃ­ch cá»¡ chá»¯ trong cÃ¡c Ä‘iá»ƒm',0),(421750,11716,'af','Font grootte In punte',0),(421751,11716,'ro','Dimensiunea fontului Ã®n puncte',0),(421752,11716,'et','Fondi suuruse punktides',0),(421753,11716,'si','Velikost pisave v toÄkah',0),(421754,11716,'ba','Ukuran font dalam poin',0),(421755,11716,'nl','Tekengrootte In punten',0),(421756,11716,'fi','Fonttikoko pisteinÃ¤',0),(421757,11716,'no','SkriftstÃ¸rrelsen i punkt',0),(421758,11716,'da','SkriftstÃ¸rrelsen i point',0),(421759,11716,'ko','í¬ì¸íŠ¸ì—ì„œ ê¸€ê¼´ í¬ê¸°',0),(421760,11716,'he','×’×•×“×œ ×”×’×•×¤×Ÿ ×‘× ×§×•×“×•×ª',0),(421761,11716,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Î³ÏÎ±Î¼Î¼Î±Ï„Î¿ÏƒÎµÎ¹ÏÎ¬Ï‚ ÏƒÏ„Î± ÏƒÎ·Î¼ÎµÎ¯Î±',0),(421762,11716,'zh','å­—ä½“å¤§å°ç‚¹\r\n',0),(421763,11716,'sv','Teckenstorleken i poÃ¤ng',0),(421764,11716,'it','Dimensione del carattere In punti',0),(421765,11716,'tl','',0),(421766,11716,'th','à¸‚à¸™à¸²à¸”à¹à¸šà¸šà¸­à¸±à¸à¸©à¸£à¹€à¸›à¹‡à¸™à¸žà¸­à¸¢à¸—à¹Œ',0),(421767,11716,'hi','à¤…à¤‚à¤• à¤®à¥‡à¤‚ à¤«à¤¼à¥‰à¤¨à¥à¤Ÿ à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(421768,11716,'ms','Saiz fon dalam mata',0),(421769,11716,'ar','Ø­Ø¬Ù… Ø§Ù„Ø®Ø· Ø¨Ø§Ù„Ù†Ù‚Ø§Ø·',0),(421770,11716,'fr','Taille de la police en Points',0),(421771,11716,'jp','ãƒã‚¤ãƒ³ãƒˆå˜ä½ã®ãƒ•ã‚©ãƒ³ãƒˆ ã‚µã‚¤ã‚º',0),(421772,11716,'pt','Tamanho da fonte em pontos',0),(421773,11716,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ ÑˆÑ€Ð¸Ñ„Ñ‚Ð° Ð² Ð¿ÑƒÐ½ÐºÑ‚Ð°Ñ…',0),(421774,11716,'es','TamaÃ±o de Fuente en Puntos',0),(421775,11716,'de','SchriftgrÃ¶ÃŸe In Punkt',0),(421776,11716,'en','Font Size In Points',0),(421777,11717,'is','',0),(421778,11717,'dr','Ø§Ø² Ø³Ù…Øª Ú†Ù¾ ',0),(421779,11717,'pr','Ø§Ø² Ø³Ù…Øª Ú†Ù¾ ',0),(421780,11717,'tr','Soldan',0),(421781,11717,'pl','Od lewej',0),(421782,11717,'bg','ÐžÑ‚ Ð»ÑÐ²Ð¾',0),(421783,11717,'ur','Ø¨Ø§Ø¦ÛŒÚº Ø³Û’',0),(421784,11717,'sr','Ð¡ Ð»ÐµÐ²Ð°',0),(421785,11717,'vi','tá»« trÃ¡i',0),(421786,11717,'af','Van links',0),(421787,11717,'ro','De la stÃ¢nga',0),(421788,11717,'et','Vasakult',0),(421789,11717,'si','Od leve',0),(421790,11717,'ba','Dari kiri',0),(421791,11717,'nl','Van links',0),(421792,11717,'fi','Vasemmalta',0),(421793,11717,'no','Fra venstre',0),(421794,11717,'da','Fra venstre',0),(421795,11717,'ko','ì™¼ìª½ì—ì„œ',0),(421796,11717,'he','×ž×©×ž××œ',0),(421797,11717,'el','Î‘Ï€ÏŒ Î±ÏÎ¹ÏƒÏ„ÎµÏÎ¬',0),(421798,11717,'zh','å·¦èµ·\r\n',0),(421799,11717,'sv','FrÃ¥n vÃ¤nster',0),(421800,11717,'it','Da sinistra',0),(421801,11717,'tl','',0),(421802,11717,'th','à¸ˆà¸²à¸à¸‹à¹‰à¸²à¸¢',0),(421803,11717,'hi','à¤¬à¤¾à¤à¤ à¤¸à¥‡',0),(421804,11717,'ms','Dari kiri',0),(421805,11717,'ar','Ù…Ù† Ø§Ù„ÙŠØ³Ø§Ø±',0),(421806,11717,'fr','De gauche',0),(421807,11717,'jp','å·¦ã‹ã‚‰',0),(421808,11717,'pt','Da esquerda',0),(421809,11717,'ru','ÐžÑ‚ Ð»ÐµÐ²Ð¾Ð³Ð¾',0),(421810,11717,'es','De la Izquierda',0),(421811,11717,'de','V.l.',0),(421812,11717,'en','From Left',0),(421813,11718,'is','',0),(421814,11718,'dr','Ø§Ø² Ø¨Ø§Ù„Ø§ ',0),(421815,11718,'pr','Ø§Ø² Ø¨Ø§Ù„Ø§ ',0),(421816,11718,'tr','Ãœstten',0),(421817,11718,'pl','Od gÃ³ry',0),(421818,11718,'bg','ÐžÑ‚ Ð³Ð¾Ñ€Ðµ',0),(421819,11718,'ur','Ø§ÙˆÙ¾Ø± Ø³Û’',0),(421820,11718,'sr','ÐžÐ´ Ð²Ñ€Ñ…Ð°',0),(421821,11718,'vi','tá»« trÃªn',0),(421822,11718,'af','Van bo',0),(421823,11718,'ro','De sus',0),(421824,11718,'et','Ãœlevalt',0),(421825,11718,'si','Od vrha',0),(421826,11718,'ba','Dari atas',0),(421827,11718,'nl','Vanaf bovenkant',0),(421828,11718,'fi','YlhÃ¤Ã¤ltÃ¤',0),(421829,11718,'no','Ovenfra',0),(421830,11718,'da','Fra toppen',0),(421831,11718,'ko','ìœ„ì—ì„œ',0),(421832,11718,'he','×ž×œ×ž×¢×œ×”',0),(421833,11718,'el','Î‘Ï€ÏŒ Ï„Î·Î½ ÎºÎ¿ÏÏ…Ï†Î®',0),(421834,11718,'zh','ä»Žé¡¶éƒ¨\r\n',0),(421835,11718,'sv','FrÃ¥n toppen',0),(421836,11718,'it','Dall\'alto',0),(421837,11718,'tl','',0),(421838,11718,'th','à¸ˆà¸²à¸à¸”à¹‰à¸²à¸™à¸šà¸™',0),(421839,11718,'hi','à¤Šà¤ªà¤° à¤¸à¥‡',0),(421840,11718,'ms','Dari atas',0),(421841,11718,'ar','Ù…Ù† Ø£Ø¹Ù„Ù‰',0),(421842,11718,'fr','De retour en haut',0),(421843,11718,'jp','ä¸Šã‹ã‚‰',0),(421844,11718,'pt','De cima',0),(421845,11718,'ru','Ð¡Ð²ÐµÑ€Ñ…Ñƒ',0),(421846,11718,'es','De la Encima',0),(421847,11718,'de','Von oben',0),(421848,11718,'en','From Top',0),(421849,11719,'is','',0),(421850,11719,'dr','Ø±ÙˆÙŠ Ø¨Ø§Ø±ÙƒØ¯ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(421851,11719,'pr','Ø±ÙˆÙŠ Ø¨Ø§Ø±ÙƒØ¯ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(421852,11719,'tr','Barkod dahil',0),(421853,11719,'pl','WÅ‚Ä…czeniu kodÃ³w kreskowych',0),(421854,11719,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð¸ Ð² Ð±Ð°Ñ€ÐºÐ¾Ð´',0),(421855,11719,'ur','Ø¨Ø§Ø±Ú©ÙˆÚˆ Ù¾Ø± Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(421856,11719,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð½Ð° Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð°',0),(421857,11719,'vi','Bao gá»“m barcode',0),(421858,11719,'af','Insluit Op Strepieskode',0),(421859,11719,'ro','Includ pe coduri de bare',0),(421860,11719,'et','Lisada vÃ¶Ã¶tkoodi',0),(421861,11719,'si','VkljuÄujejo na Ärtno kodo',0),(421862,11719,'ba','Termasuk pada Barcode',0),(421863,11719,'nl','Opnemen op Barcode',0),(421864,11719,'fi','MyÃ¶s viivakoodi',0),(421865,11719,'no','Tas med strekkode',0),(421866,11719,'da','Omfatte pÃ¥ stregkode',0),(421867,11719,'ko','ë°”ì½”ë“œì— í¬í•¨',0),(421868,11719,'he','×œ×›×œ×•×œ ×‘×¨×§×•×“',0),(421869,11719,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï„Î·Î½ Barcode',0),(421870,11719,'zh','åŒ…æ‹¬æ¡ç \r\n',0),(421871,11719,'sv','Inkludera pÃ¥ streckkod',0),(421872,11719,'it','Includere il codice a barre',0),(421873,11719,'tl','',0),(421874,11719,'th','à¸£à¸§à¸¡à¹„à¸§à¹‰à¹ƒà¸™à¹‚à¸„à¹‰à¸”',0),(421875,11719,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤ªà¤° à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(421876,11719,'ms','Termasuk pada Kod Bar',0),(421877,11719,'ar','ÙˆØªØ´Ù…Ù„ Ø¹Ù„Ù‰ Ø§Ù„Ø¨Ø§Ø±ÙƒÙˆØ¯',0),(421878,11719,'fr','Inclure le code Ã  barres',0),(421879,11719,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã«å«ã‚ã‚‹',0),(421880,11719,'pt','Incluem-se no cÃ³digo de barras',0),(421881,11719,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð½Ð° ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´',0),(421882,11719,'es','Incluye en el CÃ³digo de Barras',0),(421883,11719,'de','Auf Barcode enthalten',0),(421884,11719,'en','Include On Barcode',0),(421885,11720,'is','',0),(421886,11720,'dr','Ø¨Ø§Ø±ÙƒØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(421887,11720,'pr','Ø¨Ø§Ø±ÙƒØ¯ Ù…ÙˆØ¬ÙˆØ¯ÙŠ ÙƒØ§Ù„Ø§',0),(421888,11720,'tr','Stok barkod',0),(421889,11720,'pl','Spis kodÃ³w kreskowych',0),(421890,11720,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð±Ð°Ñ€ÐºÐ¾Ð´',0),(421891,11720,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¨Ø§Ø±Ú©ÙˆÚˆ',0),(421892,11720,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð°',0),(421893,11720,'vi','HÃ ng tá»“n kho mÃ£ váº¡ch',0),(421894,11720,'af','Inventaris Strepieskode',0),(421895,11720,'ro','Inventar de coduri de bare',0),(421896,11720,'et','Varude vÃ¶Ã¶tkoodi',0),(421897,11720,'si','ÄŒrtne kode popis',0),(421898,11720,'ba','Persediaan Barcode',0),(421899,11720,'nl','Inventaris Barcode',0),(421900,11720,'fi','Varaston viivakoodi',0),(421901,11720,'no','Lager strekkode',0),(421902,11720,'da','Lageret stregkode',0),(421903,11720,'ko','ìž¬ê³  ë°”ì½”ë“œ',0),(421904,11720,'he','×‘×¨×§×•×“ ×ž×œ××™',0),(421905,11720,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î³ÏÎ±Î¼Î¼Î¹ÎºÎ¿Ï ÎºÏŽÎ´Î¹ÎºÎ±',0),(421906,11720,'zh','åº“å­˜æ¡ç \r\n',0),(421907,11720,'sv','Inventering streckkod',0),(421908,11720,'it','Magazzino Barcode',0),(421909,11720,'tl','',0),(421910,11720,'th','à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(421911,11720,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¬à¤¾à¤°à¤•à¥‹à¤¡',0),(421912,11720,'ms','Kod Bar inventori',0),(421913,11720,'ar','Ø§Ù„Ø¨Ø§Ø±ÙƒÙˆØ¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(421914,11720,'fr','L\'inventaire code barre',0),(421915,11720,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®ãƒãƒ¼ã‚³ãƒ¼ãƒ‰',0),(421916,11720,'pt','CÃ³digo de barras do inventÃ¡rio',0),(421917,11720,'ru','Ð¨Ñ‚Ñ€Ð¸Ñ… Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(421918,11720,'es','CÃ³digo de Barras de Inventario',0),(421919,11720,'de','Lager Barcode',0),(421920,11720,'en','Inventory Barcode',0),(421921,11721,'is','',0),(421922,11721,'dr','Ù†Ø§Ù… Ø¨Ø±Ú†Ø³Ø¨ ',0),(421923,11721,'pr','Ù†Ø§Ù… Ø¨Ø±Ú†Ø³Ø¨ ',0),(421924,11721,'tr','Etiket adÄ±',0),(421925,11721,'pl','Etykieta',0),(421926,11721,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð°',0),(421927,11721,'ur','Ù„ÛŒØ¨Ù„ Ù†Ø§Ù…',0),(421928,11721,'sr','Ð˜Ð¼Ðµ Ð¾Ð·Ð½Ð°ÐºÐµ',0),(421929,11721,'vi','tÃªn nhÃ£n',0),(421930,11721,'af','Etiket naam',0),(421931,11721,'ro','Nume de etichetÄƒ',0),(421932,11721,'et','Sildi nimi',0),(421933,11721,'si','Ime nalepke',0),(421934,11721,'ba','Nama label',0),(421935,11721,'nl','Labelnaam',0),(421936,11721,'fi','Otsikon nimi',0),(421937,11721,'no','Etikettnavn',0),(421938,11721,'da','Etiketnavnet',0),(421939,11721,'ko','ë ˆì´ë¸” ì´ë¦„',0),(421940,11721,'he','×©× ×ª×•×•×™×ª',0),(421941,11721,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏ„Î¹ÎºÎµÏ„ÏŽÎ½',0),(421942,11721,'zh','æ ‡ç­¾åç§°\r\n',0),(421943,11721,'sv','Etikettnamn',0),(421944,11721,'it','Nome etichetta',0),(421945,11721,'tl','',0),(421946,11721,'th','à¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­',0),(421947,11721,'hi','à¤²à¥‡à¤¬à¤² à¤•à¤¾ à¤¨à¤¾à¤®',0),(421948,11721,'ms','Label nama',0),(421949,11721,'ar','Ø§Ø³Ù… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø¹Ù†ÙˆÙ†Ø©',0),(421950,11721,'fr','Nom de l\'Ã©tiquette',0),(421951,11721,'jp','ãƒ©ãƒ™ãƒ«å',0),(421952,11721,'pt','Nome da etiqueta',0),(421953,11721,'ru','Ð˜Ð¼Ñ Ð¼ÐµÑ‚ÐºÐ¸',0),(421954,11721,'es','Nombre de Etiqueta',0),(421955,11721,'de','Bezeichnung',0),(421956,11721,'en','Label Name',0),(421957,11722,'is','',0),(421958,11722,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù…Ù†Ø§Ø³Ø¨ Ø¨Ø±Ú†Ø³Ø¨',0),(421959,11722,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù…Ù†Ø§Ø³Ø¨ Ø¨Ø±Ú†Ø³Ø¨',0),(421960,11722,'tr','Etiket boyutu Puan',0),(421961,11722,'pl','Rozmiar etykiety w punktach',0),(421962,11722,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð° Ð² Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(421963,11722,'ur','Ù„ÛŒØ¨Ù„ Ø³Ø§Ø¦Ø² Ù†Ú©Ø§Øª Ù…ÛŒÚº',0),(421964,11722,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð¾Ð·Ð½Ð°ÐºÐµ Ñƒ Ñ‚Ð°Ñ‡ÐºÐ°Ð¼Ð°',0),(421965,11722,'vi','kÃ­ch cá»¡ nhÃ£n trÃªn cÃ¡c Ä‘iá»ƒm',0),(421966,11722,'af','Etiket grootte In punte',0),(421967,11722,'ro','Dimensiune etichetÄƒ Ã®n puncte',0),(421968,11722,'et','Sildi suuruse punktides',0),(421969,11722,'si','Velikost nalepke v toÄkah',0),(421970,11722,'ba','Ukuran label dalam poin',0),(421971,11722,'nl','Labelgrootte In punten',0),(421972,11722,'fi','Tarrakoko pisteinÃ¤',0),(421973,11722,'no','EtikettstÃ¸rrelsen poeng',0),(421974,11722,'da','EtiketstÃ¸rrelse i point',0),(421975,11722,'ko','í¬ì¸íŠ¸ì—ì„œ ë ˆì´ë¸” í¬ê¸°',0),(421976,11722,'he','×’×•×“×œ ×ª×•×•×™×ª ×‘× ×§×•×“×•×ª',0),(421977,11722,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ ÎµÏ„Î¹ÎºÎ­Ï„Î±Ï‚ ÏƒÏ„Î± ÏƒÎ·Î¼ÎµÎ¯Î±',0),(421978,11722,'zh','æ ‡ç­¾ç‚¹å°ºå¯¸\r\n',0),(421979,11722,'sv','Etikettstorlek i poÃ¤ng',0),(421980,11722,'it','Etichetta dimensione In punti',0),(421981,11722,'tl','',0),(421982,11722,'th','à¸‚à¸™à¸²à¸”à¸›à¹‰à¸²à¸¢à¸„à¸°à¹à¸™à¸™',0),(421983,11722,'hi','à¤¬à¤¿à¤‚à¤¦à¥à¤“à¤‚ à¤®à¥‡à¤‚ à¤²à¥‡à¤¬à¤² à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(421984,11722,'ms','Label saiz dalam mata',0),(421985,11722,'ar','Ø­Ø¬Ù… Ø§Ù„ØªØ³Ù…ÙŠØ© ÙÙŠ Ø§Ù„Ù†Ù‚Ø§Ø·',0),(421986,11722,'fr','Ã‰tiquette taille en Points',0),(421987,11722,'jp','ãƒã‚¤ãƒ³ãƒˆ ã‚µã‚¤ã‚ºã®ãƒ©ãƒ™ãƒ«',0),(421988,11722,'pt','Tamanho da etiqueta em pontos',0),(421989,11722,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ Ð¼ÐµÑ‚ÐºÐ¸ Ð² Ñ‚Ð¾Ñ‡ÐºÐ°Ñ…',0),(421990,11722,'es','TamaÃ±o de Etiqueta en Puntos',0),(421991,11722,'de','EtikettengrÃ¶ÃŸe In Punkten',0),(421992,11722,'en','Label Size In Points',0),(421993,11723,'is','',0),(421994,11723,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ø¨Ø±Ú†Ø³Ø¨',0),(421995,11723,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ø¨Ø±Ú†Ø³Ø¨',0),(421996,11723,'tr','Etiket SeÃ§',0),(421997,11723,'pl','Wybierz etykietÄ™',0),(421998,11723,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÑ‚Ð¸ÐºÐµÑ‚',0),(421999,11723,'ur','Ø§ÛŒÚ© Ù„ÛŒØ¨Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(422000,11723,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð·Ð½Ð°ÐºÑƒ',0),(422001,11723,'vi','Chá»n 1 nhÃ£n hiá»‡u',0),(422002,11723,'af','Kies \'n etiket',0),(422003,11723,'ro','SelectaÅ£i o etichetÄƒ',0),(422004,11723,'et','Vali silt',0),(422005,11723,'si','Izberite oznako',0),(422006,11723,'ba','Pilih Label',0),(422007,11723,'nl','Selecteer een Label',0),(422008,11723,'fi','Valitse tarra',0),(422009,11723,'no','Velg en etikett',0),(422010,11723,'da','VÃ¦lg en etiket',0),(422011,11723,'ko','ë ˆì´ë¸”ì„ ì„ íƒí•©ë‹ˆë‹¤',0),(422012,11723,'he','×‘×—×¨ ×ª×•×•×™×ª',0),(422013,11723,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± ÎµÏ„Î¹ÎºÎ­Ï„Î±',0),(422014,11723,'zh','é€‰æ‹©æ ‡ç­¾\r\n',0),(422015,11723,'sv','VÃ¤lj en etikett',0),(422016,11723,'it','Selezionare un\'etichetta',0),(422017,11723,'tl','',0),(422018,11723,'th','à¹€à¸¥à¸·à¸­à¸à¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­',0),(422019,11723,'hi','à¤à¤• à¤²à¥‡à¤¬à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(422020,11723,'ms','Pilih Label',0),(422021,11723,'ar','Ø­Ø¯Ø¯ ØªØ³Ù…ÙŠØ©',0),(422022,11723,'fr','SÃ©lectionnez une Ã©tiquette',0),(422023,11723,'jp','ãƒ©ãƒ™ãƒ«ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(422024,11723,'pt','Selecione um rÃ³tulo',0),(422025,11723,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼ÐµÑ‚ÐºÑƒ',0),(422026,11723,'es','Selecciona Una Etiqueta',0),(422027,11723,'de','WÃ¤hlen Sie ein Label',0),(422028,11723,'en','Select A Label',0),(422029,11724,'is','',0),(422030,11724,'dr','Ù†Ù…Ø§ÙŠØ´ Ø´Ø±Ø­ ÙƒØ§Ù„Ø§ ',0),(422031,11724,'pr','Ù†Ù…Ø§ÙŠØ´ Ø´Ø±Ø­ ÙƒØ§Ù„Ø§ ',0),(422032,11724,'tr','Maddenin aÃ§Ä±klamasÄ±nÄ± gÃ¶ster',0),(422033,11724,'pl','PokaÅ¼ opis przedmiotu',0),(422034,11724,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(422035,11724,'ur','Ø´Û’ Ú©ÛŒ ØªÙØµÛŒÙ„ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(422036,11724,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¾Ð¿Ð¸Ñ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(422037,11724,'vi','Thá»ƒ hiá»‡n diá»…n giáº£i cá»§a máº·t hÃ ng',0),(422038,11724,'af','Beskrywing van Item wys',0),(422039,11724,'ro','Descrierea elementului',0),(422040,11724,'et','Kauba kirjeldus',0),(422041,11724,'si','PrikaÅ¾i opis artikla',0),(422042,11724,'ba','Menunjukkan Deskripsi Item',0),(422043,11724,'nl','Beschrijving van Item weergeven',0),(422044,11724,'fi','NÃ¤ytÃ¤ nimikkeen kuvaus',0),(422045,11724,'no','Vis beskrivelsen av varen',0),(422046,11724,'da','Vis beskrivelsen af varen',0),(422047,11724,'ko','í•­ëª©ì˜ ì„¤ëª… í‘œì‹œ',0),(422048,11724,'he','×”×¦×’ ×ª×™××•×¨ ×©×œ ×¤×¨×™×˜',0),(422049,11724,'el','Î¤Î¿Î½ Î¿ÏÎ¹ÏƒÎ¼ÏŒ Ï„Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(422050,11724,'zh','æ˜¾ç¤ºé¡¹ç›®çš„è¯´æ˜Ž\r\n',0),(422051,11724,'sv','Visa beskrivning av objekt',0),(422052,11724,'it','Visualizza la descrizione dell\'elemento',0),(422053,11724,'tl','',0),(422054,11724,'th','à¹à¸ªà¸”à¸‡à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(422055,11724,'hi','à¤®à¤¦ à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(422056,11724,'ms','Menunjukkan penerangan tentang Item',0),(422057,11724,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙˆØµÙ Ø§Ù„Ø¹Ù†ØµØ±',0),(422058,11724,'fr','Voir la Description du point de',0),(422059,11724,'jp','é …ç›®ã®èª¬æ˜Žã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(422060,11724,'pt','Mostrar a descriÃ§Ã£o do Item',0),(422061,11724,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¢Ð¾Ð²Ð°Ñ€Ð°',0),(422062,11724,'es','Muestra La DescripciÃ³n del Item',0),(422063,11724,'de','Beschreibung des Elements anzeigen',0),(422064,11724,'en','Show Description Of Item',0),(422065,11725,'is','',0),(422066,11725,'dr','Ù†Ù…Ø§ÙŠØ´ Ù†Ø§Ù… ÙÙŠÙ„Ø¯ ',0),(422067,11725,'pr','Ù†Ù…Ø§ÙŠØ´ Ù†Ø§Ù… ÙÙŠÙ„Ø¯ ',0),(422068,11725,'tr','Alan adÄ±nÄ± gÃ¶ster',0),(422069,11725,'pl','PokaÅ¼ pole Nazwa',0),(422070,11725,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ð¿Ð¾Ð»Ðµ',0),(422071,11725,'ur','Ù†Ø§Ù… Ù‚Ø·Ø¹Û Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(422072,11725,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð¼Ðµ Ð¿Ð¾Ñ™Ð°',0),(422073,11725,'vi','Thá»ƒ hiá»‡n tÃªn trÆ°á»ng',0),(422074,11725,'af','Veld naam wys',0),(422075,11725,'ro','AratÄƒ nume cÃ¢mp',0),(422076,11725,'et','NÃ¤ita vÃ¤lja nimi',0),(422077,11725,'si','PrikaÅ¾i ime polja',0),(422078,11725,'ba','Tampilkan nama Field',0),(422079,11725,'nl','Toon veldnaam',0),(422080,11725,'fi','NÃ¤ytÃ¤ kenttÃ¤nimi',0),(422081,11725,'no','Vis navn',0),(422082,11725,'da','Vis feltnavn',0),(422083,11725,'ko','í•„ë“œ ì´ë¦„ í‘œì‹œ',0),(422084,11725,'he','×”×¦×’ ××ª ×©× ×”×©×“×”',0),(422085,11725,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏŒÎ½Î¿Î¼Î± Ï€ÎµÎ´Î¯Î¿Ï…',0),(422086,11725,'zh','æ˜¾ç¤ºå­—æ®µå\r\n',0),(422087,11725,'sv','Visa fÃ¤ltnamn',0),(422088,11725,'it','Visualizza il nome del campo',0),(422089,11725,'tl','',0),(422090,11725,'th','à¹à¸ªà¸”à¸‡à¸Šà¸·à¹ˆà¸­à¹€à¸‚à¸•à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(422091,11725,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤¨à¤¾à¤® à¤¦à¤¿à¤–à¤¾à¤à¤',0),(422092,11725,'ms','Tayang nama bidang',0),(422093,11725,'ar','Ø¹Ø±Ø¶ Ø¥Ø³Ù… Ø§Ù„Ø­Ù‚Ù„',0),(422094,11725,'fr','Afficher le nom du champ',0),(422095,11725,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰åã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(422096,11725,'pt','Mostrar nome do campo',0),(422097,11725,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐŸÐ¾Ð»Ñ',0),(422098,11725,'es','Muestra El Nombre del Campo',0),(422099,11725,'de','Feldnamen anzeigen',0),(422100,11725,'en','Show Field Name',0),(422101,11726,'is','',0),(422102,11726,'dr','Ù†Ù…Ø§ÙŠØ´ Ù†Ø§Ù… Ø³Ø·Ø­',0),(422103,11726,'pr','Ù†Ù…Ø§ÙŠØ´ Ù†Ø§Ù… Ø³Ø·Ø­',0),(422104,11726,'tr','DÃ¼zey adÄ±nÄ± gÃ¶ster',0),(422105,11726,'pl','PokaÅ¼ poziom nazwÄ™',0),(422106,11726,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ð½Ð¸Ð²Ð¾',0),(422107,11726,'ur','Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº Ø³Ø·Ø­ Ù†Ø§Ù…',0),(422108,11726,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð¸Ð²Ð¾ Ð¸Ð¼Ðµ',0),(422109,11726,'vi','Hiá»ƒn thá»‹ tÃªn cáº¥p',0),(422110,11726,'af','Vlak naam wys',0),(422111,11726,'ro','AratÄƒ numele de nivel',0),(422112,11726,'et','NÃ¤ita nimi',0),(422113,11726,'si','PrikaÅ¾i ime ravni',0),(422114,11726,'ba','Menampilkan nama tingkat',0),(422115,11726,'nl','Toon niveaunaam',0),(422116,11726,'fi','NÃ¤ytÃ¤ nimi',0),(422117,11726,'no','Vis navn',0),(422118,11726,'da','Vis niveau navn',0),(422119,11726,'ko','ìˆ˜ì¤€ ì´ë¦„ í‘œì‹œ',0),(422120,11726,'he','×œ×”×¦×™×’ ×©× ×‘×¨×ž×”',0),(422121,11726,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¿Î½ÏŒÎ¼Î±Ï„Î¿Ï‚ ÎµÏ€Î¹Ï€Î­Î´Î¿Ï…',0),(422122,11726,'zh','æ˜¾ç¤ºçº§åˆ«åç§°\r\n',0),(422123,11726,'sv','Visa nivÃ¥namn',0),(422124,11726,'it','Visualizza il nome del livello',0),(422125,11726,'tl','',0),(422126,11726,'th','à¹à¸ªà¸”à¸‡à¸Šà¸·à¹ˆà¸­à¸—à¸µà¹ˆà¸£à¸°à¸”à¸±à¸š',0),(422127,11726,'hi','à¤¤à¤° à¤¨à¤¾à¤® à¤¦à¤¿à¤–à¤¾à¤à¤',0),(422128,11726,'ms','Tayang nama peringkat',0),(422129,11726,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªÙˆÙ‰',0),(422130,11726,'fr','Nom de niveau de spectacle',0),(422131,11726,'jp','ãƒ¬ãƒ™ãƒ«ã®åå‰ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(422132,11726,'pt','Mostrar nome de nÃ­vel de',0),(422133,11726,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð£Ñ€Ð¾Ð²Ð½Ñ',0),(422134,11726,'es','Muestra El Nombre del Nivel',0),(422135,11726,'de','Karte Ebenennamen',0),(422136,11726,'en','Show Level Name',0),(422137,11727,'is','',0),(422138,11727,'dr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ø¨Ø§Ø±ÙƒØ¯',0),(422139,11727,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ø¨Ø§Ø±ÙƒØ¯',0),(422140,11727,'tr','Barkod etiketleri',0),(422141,11727,'pl','Etykiety kodÃ³w kreskowych',0),(422142,11727,'bg','Ð‘Ð°Ñ€ÐºÐ¾Ð´ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(422143,11727,'ur','Ø¨Ø§Ø±Ú©ÙˆÚˆ Ù„ÛŒØ¨Ù„',0),(422144,11727,'sr','Ð‘Ð°Ñ€ ÐºÐ¾Ð´Ð¾Ð²Ð° Ð½Ð°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ð°Ð¼Ð°',0),(422145,11727,'vi','NhÃ£n mÃ£ váº¡ch',0),(422146,11727,'af','Strepieskode Etikette',0),(422147,11727,'ro','Etichete coduri de bare',0),(422148,11727,'et','VÃ¶Ã¶tkoodi etiketid',0),(422149,11727,'si','ÄŒrtne kode nalepk',0),(422150,11727,'ba','Label barcode',0),(422151,11727,'nl','Barcode-etiketten',0),(422152,11727,'fi','Viivakooditarroja',0),(422153,11727,'no','Strekkodeetiketter',0),(422154,11727,'da','Stregkodeetiketter',0),(422155,11727,'ko','ë°”ì½”ë“œ ë¼ë²¨',0),(422156,11727,'he','×ª×•×•×™×•×ª ×‘×¨×§×•×“',0),(422157,11727,'el','ÎŸ Î³ÏÎ±Î¼Î¼Ï‰Ï„ÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(422158,11727,'zh','æ¡ç æ ‡ç­¾\r\n',0),(422159,11727,'sv','Streckkodsetiketter',0),(422160,11727,'it','Etichette codici a barre',0),(422161,11727,'tl','',0),(422162,11727,'th','à¸‰à¸¥à¸²à¸à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”',0),(422163,11727,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤²à¥‡à¤¬à¤²',0),(422164,11727,'ms','Label Kod Bar',0),(422165,11727,'ar','ØªØ³Ù…ÙŠØ§Øª Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠ',0),(422166,11727,'fr','Ã‰tiquettes Ã  code-barres',0),(422167,11727,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ ãƒ©ãƒ™ãƒ«',0),(422168,11727,'pt','Etiquetas de cÃ³digo de barras',0),(422169,11727,'ru','Ð¨Ñ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸',0),(422170,11727,'es','Etiquetas de CÃ³digos de Barras',0),(422171,11727,'de','Barcode-Etiketten',0),(422172,11727,'en','Barcode Labels',0),(422173,11728,'is','',0),(422174,11728,'dr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(422175,11728,'pr','Ø¨Ø±Ø§ÙŠ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ ÙƒÙ„ÙŠÙƒ ÙƒÙ†ÙŠØ¯',0),(422176,11728,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ etiketleri iÃ§in tÄ±klayÄ±n',0),(422177,11728,'pl','Kliknij, aby etykiety widoku',0),(422178,11728,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(422179,11728,'ur','Ù…Ù†Ø¸Ø± Ù„ÛŒØ¨Ù„ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(422180,11728,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð¾Ð·Ð½Ð°ÐºÐµ',0),(422181,11728,'vi','Nháº¥n Ä‘á»ƒ xem NhÃ£n',0),(422182,11728,'af','Kliek om te Etikette te Besigtig',0),(422183,11728,'ro','Click sÄƒ Vezi Etichete',0),(422184,11728,'et','KlÃµpsake nuppu Kuva Sildid',0),(422185,11728,'si','Kliknite za ogled etikete',0),(422186,11728,'ba','Klik untuk lihat label',0),(422187,11728,'nl','Klik op weergave etiketten',0),(422188,11728,'fi','Valitsemalla tÃ¤mÃ¤n voit tarkastella tarroja',0),(422189,11728,'no','Klikk for Ã¥ vise etiketter',0),(422190,11728,'da','Klik for at se etiketter',0),(422191,11728,'ko','ë·° ì´ë¦„í‘œë¥¼ í´ë¦­ í•˜ ì—¬',0),(422192,11728,'he','×œ×—×¥ ×¢×œ ×”×¦×’ ×ª×•×•×™×•×ª',0),(422193,11728,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¹Ï‚ ÎµÏ„Î¹ÎºÎ­Ï„ÎµÏ‚ Ï€ÏÎ¿Î²Î¿Î»Î®',0),(422194,11728,'zh','ç‚¹å‡»æŸ¥çœ‹æ ‡ç­¾\r\n',0),(422195,11728,'sv','Klicka fÃ¶r att visa etiketter',0),(422196,11728,'it','Fare clic su Mostra etichette',0),(422197,11728,'tl','',0),(422198,11728,'th','à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹à¸›à¹‰à¸²à¸¢',0),(422199,11728,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤²à¥‡à¤¬à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(422200,11728,'ms','Klik untuk lihat label',0),(422201,11728,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ø¹Ø±Ø¶ Ø§Ù„ØªØ³Ù…ÙŠØ§Øª',0),(422202,11728,'fr','Cliquer pour voir Ã©tiquettes',0),(422203,11728,'jp','ãƒ©ãƒ™ãƒ«ã‚’è¡¨ç¤ºã™ã‚‹] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(422204,11728,'pt','Clique para ver os rÃ³tulos',0),(422205,11728,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð²Ð¸Ð´ ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸',0),(422206,11728,'es','Hace Clik Para Visionar las Etiquetas',0),(422207,11728,'de','Klicken Sie auf Ansicht-Etiketten',0),(422208,11728,'en','Click To View Labels',0),(422209,11729,'is','',0),(422210,11729,'dr','Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ',0),(422211,11729,'pr','Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø¨Ø²Ø±Ú¯ØªØ± Ø§Ø² ',0),(422212,11729,'tr','Ve daha bÃ¼yÃ¼k sayÄ± girdi',0),(422213,11729,'pl','I wiÄ™ksza liczba',0),(422214,11729,'bg','Ð˜ Ð²ÑŠÐ²ÐµÐ´Ðµ Ð¿Ð¾-Ð³Ð¾Ð»ÑÐ¼Ð° Ð¾Ñ‚ Ð½Ð¾Ð¼ÐµÑ€',0),(422215,11729,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø§Ø®Ù„ ÛÙˆØ§ Û”',0),(422216,11729,'sr','Ð˜ Ð±Ñ€Ð¾Ñ˜ ÑƒÐ½ÐµÑ‚ Ð²ÐµÑ›Ðµ Ð¾Ð´',0),(422217,11729,'vi','ThÃªm sá»‘ Ä‘Äƒng nháº­p lá»›n ho7nn ',0),(422218,11729,'af','En nommer ingetik het groter',0),(422219,11729,'ro','Åži numÄƒr introdus mai mare',0),(422220,11729,'et','Ja Number kantakse Ã¼le',0),(422221,11729,'si','In vnesete Å¡tevilko veÄje od',0),(422222,11729,'ba','Dan nomor masuk lebih besar daripada',0),(422223,11729,'nl','En nummer ingevoerd groter is dan',0),(422224,11729,'fi','Ja numeron suurempi kuin',0),(422225,11729,'no','Og tall stÃ¸rre enn',0),(422226,11729,'da','Og antal indtastede stÃ¸rre end',0),(422227,11729,'ko','ë²ˆí˜¸ ìž…ë ¥ ë³´ë‹¤ í°',0),(422228,11729,'he','×•× ×›× ×¡×• ×ž×¡×¤×¨ ×’×“×•×œ ×ž-',0),(422229,11729,'el','ÎšÎ±Î¹ Î¿ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Î½Î±Î³ÏÎ¬Ï†ÎµÏ„Î±Î¹ Î¼ÎµÎ³Î±Î»ÏÏ„ÎµÏÎ· Î±Ï€ÏŒ',0),(422230,11729,'zh','è¾“å…¥æ•°æ®å¤§äºŽ\r\n',0),(422231,11729,'sv','Och nummer in stÃ¶rre Ã¤n',0),(422232,11729,'it','E numero inserito maggiore',0),(422233,11729,'tl','',0),(422234,11729,'th','à¹à¸¥à¸°à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸—à¸µà¹ˆà¸¡à¸²à¸à¸à¸§à¹ˆà¸²',0),(422235,11729,'hi','à¤”à¤° à¤…à¤§à¤¿à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(422236,11729,'ms','Dan nombor memasuki lebih besar daripada',0),(422237,11729,'ar','ÙˆØ¯Ø®Ù„ Ø¹Ø¯Ø¯ Ø£ÙƒØ¨Ø± Ù…Ù†',0),(422238,11729,'fr','Et le numÃ©ro entrÃ© supÃ©rieure Ã ',0),(422239,11729,'jp','å¤§ãã„ç•ªå·ã‚’å…¥åŠ›ã—ã€',0),(422240,11729,'pt','E entrou em nÃºmero maior que',0),(422241,11729,'ru','Ð˜ Ð½Ð¾Ð¼ÐµÑ€ Ð²Ð²Ð¾Ð´Ð¸Ñ‚ÑŒ Ð±Ð¾Ð»ÑŒÑˆÐµ, Ñ‡ÐµÐ¼',0),(422242,11729,'es','Y El NÃºmero Que Se EntrÃ³ Es MÃ¡s Grande Que',0),(422243,11729,'de','Und Nummer eingegeben grÃ¶ÃŸer als',0),(422244,11729,'en','And Number Entered Greater Than',0),(422245,11730,'is','',0),(422246,11730,'dr','Ø§Ú¯Ø± Ø¬ÙˆØ§Ø¨ ØµØ­ÙŠØ­ Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³Øª ',0),(422247,11730,'pr','Ø§Ú¯Ø± Ø¬ÙˆØ§Ø¨ ØµØ­ÙŠØ­ Ø´Ù…Ø§Ø±Ù‡ Ø§Ø³Øª ',0),(422248,11730,'tr','GeÃ§erli yanÄ±t sayÄ±sÄ± ise',0),(422249,11730,'pl','JeÅ¼eli prawidÅ‚owa odpowiedÅº jest numer',0),(422250,11730,'bg','ÐÐºÐ¾ Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ Ðµ Ð½Ð¾Ð¼ÐµÑ€',0),(422251,11730,'ur','Ø§Ú¯Ø± Ø¯Ø±Ø³Øª Ø¬ÙˆØ§Ø¨ Ú©Ø§ Ù†Ù…Ø¨Ø± ÛÛ’ Û”',0),(422252,11730,'sr','ÐÐºÐ¾ Ñ˜Ðµ Ð¸ÑÐ¿Ñ€Ð°Ð²Ð°Ð½ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€ Ð±Ñ€Ð¾Ñ˜',0),(422253,11730,'vi','Náº¿u tráº£ lá»i hiá»‡u lá»±c lÃ  sá»‘',0),(422254,11730,'af','As geldige antwoord Is nommer',0),(422255,11730,'ro','ÃŽn cazul Ã®n care rÄƒspuns Valid este numÄƒrul',0),(422256,11730,'et','Kui sobiv vastus on arv',0),(422257,11730,'si','ÄŒe je veljaven odgovor Å¡tevilka',0),(422258,11730,'ba','Jika berlaku Balasan adalah nomor',0),(422259,11730,'nl','Als getal is geldig antwoord',0),(422260,11730,'fi','Jos kelvollinen vastaus on luku',0),(422261,11730,'no','Hvis gyldig svar tall',0),(422262,11730,'da','Hvis gyldige svar er antallet',0),(422263,11730,'ko','ìœ íš¨ ì‘ë‹µ ìˆ˜ ê²½ìš°',0),(422264,11730,'he','×× ×ª×’×•×‘×” ×—×•×§×™×ª ×”×•× ×ž×¡×¤×¨',0),(422265,11730,'el','Î•Î¬Î½ Î­Î³ÎºÏ…ÏÎ· Î±Ï€Î¬Î½Ï„Î·ÏƒÎ· ÎµÎ¯Î½Î±Î¹ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(422266,11730,'zh','å¦‚æžœæœ‰æ•ˆç­”å¤æ˜¯æ•°å­—\r\n',0),(422267,11730,'sv','Om giltiga svar Ã¤r antalet',0),(422268,11730,'it','Se Ã¨ valida risposta numero',0),(422269,11730,'tl','',0),(422270,11730,'th','à¸–à¹‰à¸²à¸•à¸­à¸šà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡à¹€à¸›à¹‡à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚',0),(422271,11730,'hi','à¤¯à¤¦à¤¿ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤®à¤¾à¤¨à¥à¤¯ à¤‰à¤¤à¥à¤¤à¤° à¤¹à¥ˆ',0),(422272,11730,'ms','Jika jawapan yang sah adalah nombor',0),(422273,11730,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ø±Ø¯ ØµØ§Ù„Ø­ Ø¹Ø¯Ø¯',0),(422274,11730,'fr','Si la rÃ©ponse valide est nombre',0),(422275,11730,'jp','æœ‰åŠ¹ãªå¿œç­”ãŒæ•°å€¤ã®å ´åˆ',0),(422276,11730,'pt','Se a resposta vÃ¡lida Ã© o nÃºmero',0),(422277,11730,'ru','Ð•ÑÐ»Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð¾Ñ‚Ð²ÐµÑ‚ Ð½Ð¾Ð¼ÐµÑ€',0),(422278,11730,'es','Si la Respuesta VÃ¡lida es NÃºmero',0),(422279,11730,'de','Wenn gÃ¼ltige Antwort Anzahl',0),(422280,11730,'en','If Valid Reply Is Number',0),(422281,11731,'is','',0),(422282,11731,'dr','Ø¶Ø±Ø¨ ÙƒØ±Ø¯Ù† Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø±  ØªÙˆØ³Ø· ',0),(422283,11731,'pr','Ø¶Ø±Ø¨ ÙƒØ±Ø¯Ù† Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø±  ØªÙˆØ³Ø· ',0),(422284,11731,'tr','MiktarÄ± hesaplama tarafÄ±ndan Ã§arpÄ±n',0),(422285,11731,'pl','PomnoÅ¼yÄ‡ iloÅ›Ä‡ obliczeÅ„ przez',0),(422286,11731,'bg','Ð£Ð¼Ð½Ð¾Ð¶ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ Ð¾Ñ‚',0),(422287,11731,'ur','ØªØ¹Ø¯Ø§Ø¯ Ú©Û’ Ø­Ø³Ø§Ø¨ Ø³Û’ Ø¶Ø±Ø¨',0),(422288,11731,'sr','ÐœÐ½Ð¾Ð¶ÐµÑšÐµ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ð¾',0),(422289,11731,'vi','Sá»± tÃ­nh toÃ¡n Ä‘a sá»‘ lÆ°á»£ng bá»Ÿi',0),(422290,11731,'af','Vermenigvuldig die hoeveelheid berekening deur',0),(422291,11731,'ro','Multiplica calcularea cantitÄƒÈ›ii de',0),(422292,11731,'et','Korruta kogus arvutuse jÃ¤rgi',0),(422293,11731,'si','PomnoÅ¾imo koliÄino izraÄun',0),(422294,11731,'ba','Kalikan jumlah perhitungan dengan',0),(422295,11731,'nl','Vermenigvuldigen hoeveelheid berekening door',0),(422296,11731,'fi','Kerro mÃ¤Ã¤rÃ¤ lasketaan lisÃ¤Ã¤mÃ¤llÃ¤',0),(422297,11731,'no','Multiplisere antall beregning av',0),(422298,11731,'da','Multiplicer antallet beregning af',0),(422299,11731,'ko','ê³±í•˜ê¸° ìˆ˜ëŸ‰ ê³„ì‚°',0),(422300,11731,'he','×œ×”×›×¤×™×œ ××ª ×”×›×ž×•×ª ×œ×—×™×©×•×‘ ×¢×œ ×™×“×™',0),(422301,11731,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î¬ÏƒÏ„Îµ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Ï€ÏŒ',0),(422302,11731,'zh','æ•°é‡è®¡ç®—ä¹˜ä»¥\r\n',0),(422303,11731,'sv','Multiplicera kvantiteten berÃ¤kning av',0),(422304,11731,'it','Moltiplicare il calcolo della quantitÃ  di',0),(422305,11731,'tl','',0),(422306,11731,'th','à¸„à¸¹à¸“à¸›à¸£à¸´à¸¡à¸²à¸“à¸„à¸³à¸™à¸§à¸“à¹‚à¸”à¸¢',0),(422307,11731,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤—à¤£à¤¨à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤—à¥à¤£à¤¾',0),(422308,11731,'ms','Membiak pengiraan kuantiti oleh',0),(422309,11731,'ar','Ø§Ø¶Ø±Ø¨ Ø­Ø³Ø§Ø¨ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ',0),(422310,11731,'fr','Multipliez le calcul de la quantitÃ© de',0),(422311,11731,'jp','ä¹—ç®—ã«ã‚ˆã‚‹æ•°é‡è¨ˆç®—',0),(422312,11731,'pt','Multiplicar a cÃ¡lculo de quantidade por',0),(422313,11731,'ru','Ð£Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ð¹',0),(422314,11731,'es','Multiplica el Calculo de Cantidad Por',0),(422315,11731,'de','Mengenberechnung durch Multiplizieren',0),(422316,11731,'en','Multiply Quantity Calculation By',0),(422317,11732,'is','',0),(422318,11732,'dr','Ú†Ø§Ù¾ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ø¨Ø§Ø±ÙƒØ¯Ù‡Ø§ ',0),(422319,11732,'pr','Ú†Ø§Ù¾ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÙŠ Ø¨Ø§Ø±ÙƒØ¯Ù‡Ø§ ',0),(422320,11732,'tr','Barkod etiketlerini yazdÄ±rma',0),(422321,11732,'pl','Drukowanie etykiet i kodÃ³w kreskowych',0),(422322,11732,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð±Ð°Ñ€ÐºÐ¾Ð´ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(422323,11732,'ur','Ø¨Ø§Ø±Ú©ÙˆÚˆ Ù„ÛŒØ¨Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(422324,11732,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ð° Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð°',0),(422325,11732,'vi','in nhÃ£n báº£ng mÃ£',0),(422326,11732,'af','Uitdruk van Strepieskode Ettikette',0),(422327,11732,'ro','ImprimaÅ£i etichete coduri de bare',0),(422328,11732,'et','Saate printida vÃ¶Ã¶tkoodide Sildid',0),(422329,11732,'si','Tiskanje Ärtne kode nalepk',0),(422330,11732,'ba','Cetak label Barcode',0),(422331,11732,'nl','Barcode-etiketten afdrukken',0),(422332,11732,'fi','Tulosta viivakooditarrat',0),(422333,11732,'no','Skrive ut strekkodeetiketter',0),(422334,11732,'da','Udskrive stregkodeetiketter',0),(422335,11732,'ko','ë°”ì½”ë“œ ë¼ë²¨ ì¸ì‡„',0),(422336,11732,'he','×”×“×¤×¡ ×ª×•×•×™×•×ª ×‘×¨×§×•×“',0),(422337,11732,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÏ„Î¹ÎºÎµÏ„ÏŽÎ½ Barcode',0),(422338,11732,'zh','æ‰“å°æ¡ç æ ‡ç­¾\r\n',0),(422339,11732,'sv','Skriva ut streckkodsetiketter',0),(422340,11732,'it','Stampare etichette di codici a barre',0),(422341,11732,'tl','',0),(422342,11732,'th','à¸žà¸´à¸¡à¸žà¹Œà¸‰à¸¥à¸²à¸à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”',0),(422343,11732,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤²à¥‡à¤¬à¤² à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(422344,11732,'ms','Mencetak Label Kod Bar',0),(422345,11732,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù…Ù„ØµÙ‚Ø§Øª Ø§Ù„Ø¨Ø§Ø±ÙƒÙˆØ¯',0),(422346,11732,'fr','Imprimer des Ã©tiquettes de codes Ã  barres',0),(422347,11732,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ ãƒ©ãƒ™ãƒ«ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(422348,11732,'pt','Imprimir etiquetas de cÃ³digo de barras',0),(422349,11732,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸',0),(422350,11732,'es','Imprimir Etiquetas de CÃ³digos de Barras',0),(422351,11732,'de','Drucken von Barcode-Etiketten',0),(422352,11732,'en','Print Barcode Labels',0),(422353,11733,'is','',0),(422354,11733,'dr','Ú†Ø§Ù¾ Ø¨Ø±Ú†Ø³Ø¨ ',0),(422355,11733,'pr','Ú†Ø§Ù¾ Ø¨Ø±Ú†Ø³Ø¨ ',0),(422356,11733,'tr','Etiket YazdÄ±rma',0),(422357,11733,'pl','Drukowanie etykiet',0),(422358,11733,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚',0),(422359,11733,'ur','Ù„ÛŒØ¨Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(422360,11733,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¾Ð·Ð½Ð°ÐºÐ°',0),(422361,11733,'vi','in nhÃ£n',0),(422362,11733,'af','Druk Etiket',0),(422363,11733,'ro','Imprimare eticheta',0),(422364,11733,'et','Prindi silt',0),(422365,11733,'si','Natisniti nalepko',0),(422366,11733,'ba','Cetak Label',0),(422367,11733,'nl','Label afdrukken',0),(422368,11733,'fi','Tulosta etiketti',0),(422369,11733,'no','Skriv ut etikett',0),(422370,11733,'da','Udskrive etiketten',0),(422371,11733,'ko','ë ˆì´ë¸” ì¸ì‡„',0),(422372,11733,'he','×”×“×¤×¡ ×ª×•×•×™×ª',0),(422373,11733,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÏ„Î¹ÎºÎ­Ï„Î±Ï‚',0),(422374,11733,'zh','æ‰“å°æ ‡ç­¾\r\n',0),(422375,11733,'sv','Skriv ut etikett',0),(422376,11733,'it','Stampa etichetta',0),(422377,11733,'tl','',0),(422378,11733,'th','à¸žà¸´à¸¡à¸žà¹Œà¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­',0),(422379,11733,'hi','à¤²à¥‡à¤¬à¤² à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(422380,11733,'ms','Mencetak Label',0),(422381,11733,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªØ³Ù…ÙŠØ©',0),(422382,11733,'fr','Imprimer Ã©tiquette',0),(422383,11733,'jp','ãƒ©ãƒ™ãƒ«ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(422384,11733,'pt','Imprimir etiqueta',0),(422385,11733,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸',0),(422386,11733,'es','Imprimir Etiqueta',0),(422387,11733,'de','Label drucken',0),(422388,11733,'en','Print Label',0),(422389,11734,'is','',0),(422390,11734,'dr','Ú†Ø§Ù¾ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ ',0),(422391,11734,'pr','Ú†Ø§Ù¾ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ ',0),(422392,11734,'tr','BaskÄ± etiket',0),(422393,11734,'pl','Drukowanie etykiet',0),(422394,11734,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(422395,11734,'ur','Ù„ÛŒØ¨Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(422396,11734,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¾Ð·Ð½Ð°ÐºÐ°',0),(422397,11734,'vi','in nhÃ£n',0),(422398,11734,'af','Druk Etikette',0),(422399,11734,'ro','ImprimaÅ£i etichete',0),(422400,11734,'et','Prindi sildid',0),(422401,11734,'si','Tiskanje nalepk',0),(422402,11734,'ba','Cetak label',0),(422403,11734,'nl','Etiketten afdrukken',0),(422404,11734,'fi','Tarrojen tulostaminen',0),(422405,11734,'no','Skrive ut etiketter',0),(422406,11734,'da','Udskrive etiketter',0),(422407,11734,'ko','ì¸ì‡„ ë¼ë²¨',0),(422408,11734,'he','×”×“×¤×¡ ×ª×•×•×™×•×ª',0),(422409,11734,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÏ„Î¹ÎºÎµÏ„ÏŽÎ½',0),(422410,11734,'zh','æ‰“å°æ ‡ç­¾\r\n',0),(422411,11734,'sv','Skriva ut etiketter',0),(422412,11734,'it','Stampare etichette',0),(422413,11734,'tl','',0),(422414,11734,'th','à¸žà¸´à¸¡à¸žà¹Œà¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­',0),(422415,11734,'hi','à¤²à¥‡à¤¬à¤²à¥à¤¸ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(422416,11734,'ms','Mencetak label',0),(422417,11734,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ØªØ³Ù…ÙŠØ§Øª',0),(422418,11734,'fr','Imprimer des Ã©tiquettes',0),(422419,11734,'jp','ãƒ©ãƒ™ãƒ«ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(422420,11734,'pt','Imprimir etiquetas',0),(422421,11734,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð½Ð°ÐºÐ»ÐµÐµÐº',0),(422422,11734,'es','Imprimir Etiquetas',0),(422423,11734,'de','Drucken von Etiketten',0),(422424,11734,'en','Print Labels',0),(422425,11735,'is','',0),(422426,11735,'dr','Ø¨Ø§ÙŠØ¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ÙˆÙŠÚ˜Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆØ¯ ',0),(422427,11735,'pr','Ø¨Ø§ÙŠØ¯ ÙƒØ§Ø±Ù…Ù†Ø¯ ÙˆÙŠÚ˜Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆØ¯ ',0),(422428,11735,'tr','Belirli bir yaÅŸ almak gerekir',0),(422429,11735,'pl','NaleÅ¼y wybraÄ‡ konkretnego pracownika',0),(422430,11735,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚ÐµÐ½ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(422431,11735,'ur','Ù…Ø®ØµÙˆØµ Ù…Ù„Ø§Ø²Ù… Ú†Ù†ÛŒÚº Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(422432,11735,'sr','ÐœÐ¾Ñ€Ð°Ð¼ Ð¾Ð´Ð°Ð±Ñ€Ð°Ñ‚Ð¸ Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(422433,11735,'vi','Pháº£i chá»n Ä‘áº·c tÃ­nh cá»§a nhÃ¢n viÃªn',0),(422434,11735,'af','Spesifieke werknemer moet kies',0),(422435,11735,'ro','Trebuie sÄƒ alegeÅ£i angajatului specifice',0),(422436,11735,'et','Peate valima konkreetse tÃ¶Ã¶taja',0),(422437,11735,'si','Izbrati morate doloÄenega zaposlenega',0),(422438,11735,'ba','Harus memilih karyawan tertentu',0),(422439,11735,'nl','Specifieke medewerker moet kiezen',0),(422440,11735,'fi','Valitse haluamasi tyÃ¶ntekijÃ¤',0),(422441,11735,'no','MÃ¥ velge ansatt',0),(422442,11735,'da','Skal vÃ¦lge specifikke medarbejder',0),(422443,11735,'ko','íŠ¹ì • ì§ì›ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(422444,11735,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×¢×•×‘×“ ×¡×¤×¦×™×¤×™×ª',0),(422445,11735,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿',0),(422446,11735,'zh','å¿…é¡»é€‰æ‹©ç‰¹å®šé›‡å‘˜\r\n',0),(422447,11735,'sv','MÃ¥ste vÃ¤lja medarbetaren',0),(422448,11735,'it','Deve prendere un dipendente specifico',0),(422449,11735,'tl','',0),(422450,11735,'th','à¸•à¹‰à¸­à¸‡à¸£à¸±à¸šà¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(422451,11735,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤²à¥‡à¤¨à¥‡ à¤šà¤¾à¤¹à¤¿à¤',0),(422452,11735,'ms','Mesti memilih pekerja tertentu',0),(422453,11735,'ar','ÙŠØ¬Ø¨ Ø§Ø®ØªÙŠØ§Ø± Ù…ÙˆØ¸Ù Ù…Ø¹ÙŠÙ†',0),(422454,11735,'fr','Devez choisir employÃ© spÃ©cifique',0),(422455,11735,'jp','ç‰¹å®šã®å¾“æ¥­å“¡ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(422456,11735,'pt','Deve escolher o funcionÃ¡rio especÃ­fico',0),(422457,11735,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ð¾Ð³Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(422458,11735,'es','Debe Seleccionar Un Empleado EspecÃ­fico',0),(422459,11735,'de','MÃ¼ssen bestimmten Mitarbeiter auswÃ¤hlen',0),(422460,11735,'en','Must Pick Specific Employee',0),(422461,11736,'is','',0),(422462,11736,'dr','ÙÙ‚Ø· Ù†Ø´Ø§Ù† Ø¨Ø¯Ù‡ÙŠØ¯ Ø§Ú¯Ø± Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø³Ø§Ø¹ØªÙŠ Ø¨ÙŠØ´ Ø§Ø² ',0),(422463,11736,'pr','ÙÙ‚Ø· Ù†Ø´Ø§Ù† Ø¨Ø¯Ù‡ÙŠØ¯ Ø§Ú¯Ø± Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø³Ø§Ø¹ØªÙŠ Ø¨ÙŠØ´ Ø§Ø² ',0),(422464,11736,'tr','Saatlik ortalama aÅŸarsa tek gÃ¶steri',0),(422465,11736,'pl','PokaÅ¼ tylko jeÅ›li cogodzinnych nie przekracza',0),(422466,11736,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð¹ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÑÑ€ÐµÐ´Ð½Ð° Ñ‡Ð°ÑÐ¾Ð²Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð½Ðµ Ð½Ð°Ð´Ð²Ð¸ÑˆÐ°Ð²Ð°',0),(422467,11736,'ur','ÙÛŒ Ú¯Ú¾Ù†Ù¹Û Ú©ÛŒ Ø§ÙˆØ³Ø· Ø³Û’ Ø²ÛŒØ§Ø¯Û ÛÙˆØ¬Ø§ØªØ§ ÛÛ’ ØªÙˆ ØµØ±Ù Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(422468,11736,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¿Ð¾ ÑÐ°Ñ‚Ñƒ Ð¿Ñ€Ð¾ÑÐµÐº Ð¿Ñ€ÐµÐ¼Ð°ÑˆÑƒÑ˜Ðµ',0),(422469,11736,'vi','chá»‰ hiá»‡n thá»‹ náº¿u Ä‘áº¡t Ä‘Æ°á»£c má»©c giá» trung bÃ¬nh',0),(422470,11736,'af','Wys slegs as gemiddelde uurlikse oorskry',0),(422471,11736,'ro','AratÄƒ doar dacÄƒ depÄƒÅŸeÅŸte medie pe orÄƒ',0),(422472,11736,'et','Kuva ainult tunni keskmisena Ã¼letab',0),(422473,11736,'si','PokaÅ¾i samo, Äe presega urno povpreÄje',0),(422474,11736,'ba','Hanya menunjukkan jika melebihi rata-rata per jam',0),(422475,11736,'nl','Alleen weergeven als uurgemiddelde hoger is dan',0),(422476,11736,'fi','NÃ¤ytÃ¤ vain jos tuntikeskiarvona yli',0),(422477,11736,'no','Vis bare hvis timebasert gjennomsnitt overskrider',0),(422478,11736,'da','Vis kun hvis timegennemsnittet overstiger',0),(422479,11736,'ko','ì‹œê°„ë³„ í‰ê·  ì´ˆê³¼ í•˜ëŠ” ê²½ìš° í‘œì‹œ',0),(422480,11736,'he','×”×¦×’ ×¨×§ ×× ×ž×ž×•×¦×¢ ×©×¢×ª×™ ×—×•×¨×’',0),(422481,11736,'el','Î”ÎµÎ¯Ï‡Î½Î¿Ï…Î½ Î¼ÏŒÎ½Î¿ Î±Î½ Ï…Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ Ï„Î¿ Ï‰ÏÎ¹Î±Î¯Î¿ Î¼Î­ÏƒÎ¿',0),(422482,11736,'zh','æ˜¾ç¤ºå¦‚æžœå¹³å‡æ¯å°æ—¶åªæœ‰è¶…è¶Š\r\n',0),(422483,11736,'sv','Visa endast om Ã¶verstiger timmedelvÃ¤rdet',0),(422484,11736,'it','Visualizza solo se la media oraria superiore',0),(422485,11736,'tl','',0),(422486,11736,'th','à¹à¸ªà¸”à¸‡à¸–à¹‰à¸²à¹€à¸à¸´à¸™à¸„à¹ˆà¸²à¹€à¸‰à¸¥à¸µà¹ˆà¸¢à¸£à¸²à¸¢à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡',0),(422487,11736,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤˜à¤‚à¤Ÿà¤¾ à¤”à¤¸à¤¤ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¹à¥ˆ à¤¯à¤¦à¤¿ à¤•à¥‡à¤µà¤² à¤¦à¤¿à¤–à¤¾à¤à¤',0),(422488,11736,'ms','Hanya menunjukkan sekiranya setiap jam purata melebihi',0),(422489,11736,'ar','ØªØ¸Ù‡Ø± ÙÙ‚Ø· Ø¥Ø°Ø§ ØªØ¬Ø§ÙˆØ² Ù…ØªÙˆØ³Ø· ÙƒÙ„ Ø³Ø§Ø¹Ø©',0),(422490,11736,'fr','Afficher uniquement si la moyenne horaire dÃ©passe',0),(422491,11736,'jp','1 æ™‚é–“ã”ã¨ã®å¹³å‡å€¤ã‚’è¶…ãˆã‚‹ã‹ã©ã†ã‹ã®ã¿è¡¨ç¤ºã—ã¾ã™ã€‚',0),(422492,11736,'pt','Apenas mostrar-se a mÃ©dia horÃ¡ria excede',0),(422493,11736,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ ÑÑ€ÐµÐ´Ð½ÐµÑ‡Ð°ÑÐ¾Ð²Ð¾Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð½Ðµ Ð¿Ñ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚',0),(422494,11736,'es','Solo Muestea Si El Promedio Por Hora Excede',0),(422495,11736,'de','Nur zeigen Sie an, wenn Stundenlohn Durchschnitt Ã¼berschreitet',0),(422496,11736,'en','Only Show If Hourly Average Exceeds',0),(422497,11737,'is','',0),(422498,11737,'dr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø¨Ø±Ø§ÙŠ',0),(422499,11737,'pr','Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ø¨Ø±Ø§ÙŠ',0),(422500,11737,'tr','AVG iÃ§in',0),(422501,11737,'pl','AVG dla',0),(422502,11737,'bg','AVG Ð·Ð°',0),(422503,11737,'ur','Ø§ÙˆØ³Ø· Ú©Û’ Ù„Ø¦Û’',0),(422504,11737,'sr','ÐÐ²Ð³ Ð·Ð°',0),(422505,11737,'vi','Trung bÃ¬nh cho',0),(422506,11737,'af','Gemidd. Vir',0),(422507,11737,'ro','AVG pentru',0),(422508,11737,'et','AVG jaoks',0),(422509,11737,'si','AVG za',0),(422510,11737,'ba','AVG untuk',0),(422511,11737,'nl','AVG voor',0),(422512,11737,'fi','AVG ja',0),(422513,11737,'no','AVG For',0),(422514,11737,'da','AVG For',0),(422515,11737,'ko','ì— ëŒ€ í•œ í‰ê· ',0),(422516,11737,'he','Avg ×¢×‘×•×¨',0),(422517,11737,'el','AVG Î³Î¹Î±',0),(422518,11737,'zh','å¹³å‡ä¸º\r\n',0),(422519,11737,'sv','AVG fÃ¶r',0),(422520,11737,'it','AVG per',0),(422521,11737,'tl','',0),(422522,11737,'th','Avg à¸ªà¸³à¸«à¸£à¸±à¸š',0),(422523,11737,'hi','à¤”à¤¸à¤¤ à¤•à¥‡ à¤²à¤¿à¤',0),(422524,11737,'ms','AVG bagi',0),(422525,11737,'ar','Ù…ØªÙˆØ³Ø·',0),(422526,11737,'fr','AVG pour',0),(422527,11737,'jp','Avg',0),(422528,11737,'pt','AVG para',0),(422529,11737,'ru','AVG Ð´Ð»Ñ',0),(422530,11737,'es','Promedio Por',0),(422531,11737,'de','AVG fÃ¼r',0),(422532,11737,'en','Avg For',0),(422533,11738,'is','',0),(422534,11738,'dr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø­Ù…Ù„ Ø¨Ù‡  Ø¯Ø± ÙØ§ÙƒØªÙˆØ± ',0),(422535,11738,'pr','Ù…Ø®ÙÙŠ ÙƒØ±Ø¯Ù† Ø­Ù…Ù„ Ø¨Ù‡  Ø¯Ø± ÙØ§ÙƒØªÙˆØ± ',0),(422536,11738,'tr','Faturadaki gemiye gizle',0),(422537,11738,'pl','Ukryj statku na fakturze',0),(422538,11738,'bg','Ð¡ÐºÑ€Ð¸Ð¹ ÐºÐ¾Ñ€Ð°Ð± Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(422539,11738,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(422540,11738,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð±Ñ€Ð¾Ð´ Ð´Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(422541,11738,'vi','áº¨n con tÃ u Ä‘áº¿n trÃªn hoÃ¡ Ä‘Æ¡n',0),(422542,11738,'af','Verberg Versend Na op Faktuur',0),(422543,11738,'ro','Ascunde navei la facturÄƒ',0),(422544,11738,'et','Peida laeva arvel',0),(422545,11738,'si','Skrij ladje na raÄun',0),(422546,11738,'ba','Sembunyikan kapal di faktur',0),(422547,11738,'nl','Schip op factuur verbergen',0),(422548,11738,'fi','Piilota aluksen laskussa',0),(422549,11738,'no','Skjule skipet til fakturaen',0),(422550,11738,'da','Skjule skibet pÃ¥ fakturaen',0),(422551,11738,'ko','ì†¡ìž¥ì— ë°°ë¥¼ ìˆ¨ê¸°ê¸°',0),(422552,11738,'he','×œ×”×¡×ª×™×¨ ××ª ×”×¡×¤×™× ×” ×›×“×™ ×‘×—×©×‘×•× ×™×ª',0),(422553,11738,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Ï€Î»Î¿Î¯Î¿ Î½Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(422554,11738,'zh','éšè—æ”¶è´§å‘ç¥¨\r\n',0),(422555,11738,'sv','DÃ¶lja fartyget pÃ¥ faktura',0),(422556,11738,'it','Nascondere la nave a fattura',0),(422557,11738,'tl','',0),(422558,11738,'th','à¸‹à¹ˆà¸­à¸™à¹€à¸£à¸·à¸­à¹„à¸›à¸šà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(422559,11738,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¤° à¤›à¥à¤ªà¤¾à¤à¤',0),(422560,11738,'ms','Sembunyi kapal pada invois',0),(422561,11738,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ ÙÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(422562,11738,'fr','Masquer le navire Ã  sur facture',0),(422563,11738,'jp','è«‹æ±‚æ›¸ä¸Šã«èˆ¹ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(422564,11738,'pt','Esconder o navio para na factura',0),(422565,11738,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð½Ð° Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(422566,11738,'es','Esconde EnviarA en la Factura',0),(422567,11738,'de','Ausblenden von Schiff auf Rechnung',0),(422568,11738,'en','Hide Ship To on Invoice',0),(422569,11739,'is','',0),(422570,11739,'dr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø§Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ Ù‚Ø¨Ù„ÙŠ Ø¯Ø± ÙØ§ÙƒØªÙˆØ±',0),(422571,11739,'pr','Ù†Ù…Ø§ÙŠØ´ Ù…Ø§Ù†Ø¯Ù‡ Ù‡Ø§ÙŠ Ù‚Ø¨Ù„ÙŠ Ø¯Ø± ÙØ§ÙƒØªÙˆØ±',0),(422572,11739,'tr','Fatura Ã¼zerinde Ã¶nceki bakiyesini gÃ¶ster',0),(422573,11739,'pl','PokaÅ¼ wczeÅ›niejsze rÃ³wnowagi na fakturze',0),(422574,11739,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ Ð±Ð°Ð»Ð°Ð½Ñ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(422575,11739,'ur','Ù¾ÛŒØ´Ú¯ÛŒ ØªÙˆØ§Ø²Ù† Ú©Û’ Ø¨Ù„ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(422576,11739,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ñƒ ÑÐ°Ð»Ð´Ð¾ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(422577,11739,'vi','Hiá»ƒn thá»‹ khÃ¡ch sáº¡n trÆ°á»›c khi cÃ¢n báº±ng trÃªn hÃ³a Ä‘Æ¡n',0),(422578,11739,'af','Wys vooraf balans op die faktuur',0),(422579,11739,'ro','AratÄƒ prealabilÄƒ echilibru pe facturÄƒ',0),(422580,11739,'et','Kuva eelneva tasakaalu arvel',0),(422581,11739,'si','Prikaz predhodno dobroimetja na raÄunu',0),(422582,11739,'ba','Lihat sebelumnya saldo faktur',0),(422583,11739,'nl','Toon voorafgaande evenwicht op factuur',0),(422584,11739,'fi','NÃ¤ytÃ¤ aiemmat saldo laskussa',0),(422585,11739,'no','Vis tidligere balansen pÃ¥ fakturaen',0),(422586,11739,'da','Vis forudgÃ¥ende Balance pÃ¥ fakturaen',0),(422587,11739,'ko','ì¸ë³´ì´ìŠ¤ì— ì´ì „ ìž”ì•¡ í‘œì‹œ',0),(422588,11739,'he','×œ×”×¨××•×ª ××™×–×•×Ÿ ×ž×•×§×“×ž×ª ×‘×—×©×‘×•× ×™×ª',0),(422589,11739,'el','Î”ÎµÎ¯Ï‡Î½Î¿Ï…Î½ Ï„Î·Î½ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± ÏƒÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(422590,11739,'zh','å‘ç¥¨ä¸Šæ˜¾ç¤ºä»¥å‰çš„å¹³è¡¡\r\n',0),(422591,11739,'sv','Visa tidigare balans pÃ¥ fakturan',0),(422592,11739,'it','Visualizza saldo preventiva sulla fattura',0),(422593,11739,'tl','',0),(422594,11739,'th','à¹à¸ªà¸”à¸‡à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰à¸šà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(422595,11739,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(422596,11739,'ms','Menunjukkan baki terlebih dahulu pada invois',0),(422597,11739,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø±ØµÙŠØ¯ Ù…Ø³Ø¨Ù‚ ÙÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(422598,11739,'fr','Spectacle d\'Ã©quilibre prÃ©alable sur facture',0),(422599,11739,'jp','è«‹æ±‚æ›¸ã«äº‹å‰ã®ãƒãƒ©ãƒ³ã‚¹ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(422600,11739,'pt','Mostrar equilÃ­brio prÃ©vio na factura',0),(422601,11739,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ðµ Ð±Ð°Ð»Ð°Ð½Ñ Ð½Ð° ÑÑ‡ÐµÑ‚Ðµ',0),(422602,11739,'es','Muestra Balance Anterior en la Factura',0),(422603,11739,'de','Vorherige Gleichgewicht auf Rechnung anzeigen',0),(422604,11739,'en','Show Prior Balance on Invoice',0),(422605,11740,'is','',0),(422606,11740,'dr','Ø´Ù…Ø§Ø±Ù‡  Ú†Ùƒ Ø§ Ú¯Ø± Ú†Ùƒ',0),(422607,11740,'pr','Ø´Ù…Ø§Ø±Ù‡  Ú†Ùƒ Ø§ Ú¯Ø± Ú†Ùƒ',0),(422608,11740,'tr','EÄŸer Ã§ek Ã§ek numarasÄ±',0),(422609,11740,'pl','SprawdÅº numer, jeÅ›li SprawdÅº',0),(422610,11740,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð°, Ð°ÐºÐ¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(422611,11740,'ur','Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Ø§Ú¯Ø± Ù†Ù…Ø¨Ø± Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(422612,11740,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ‡ÐµÐºÐ° Ð°ÐºÐ¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð°',0),(422613,11740,'vi','Kiá»ƒm tra sá»‘ náº¿u kiá»ƒm tra',0),(422614,11740,'af','Kontroleer nommer as kontroleer',0),(422615,11740,'ro','VerificaÅ£i numÄƒrul dacÄƒ verificaÅ£i',0),(422616,11740,'et','Kontrollige numbrit kui kontrollimine',0),(422617,11740,'si','Preverite Å¡tevilko, Äe preverite',0),(422618,11740,'ba','Memeriksa nomor jika cek',0),(422619,11740,'nl','Nummer controleren als controleren',0),(422620,11740,'fi','Tarkista numero, jos Tarkista',0),(422621,11740,'no','Sjekknummeret hvis sjekk',0),(422622,11740,'da','Checknummer, hvis Tjek',0),(422623,11740,'ko','ê²½ìš° í™•ì¸ ë²ˆí˜¸ë¥¼ í™•ì¸',0),(422624,11740,'he','×‘×“×•×§ ××ª ×”×ž×¡×¤×¨ ×× ×‘×“×•×§',0),(422625,11740,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î±ÏÎ¹Î¸Î¼ÏŒ ÎµÎ»Î­Î³Î¾Ï„Îµ Î±Î½',0),(422626,11740,'zh','æ”¯ç¥¨å·ç å¦‚æžœæ£€æŸ¥\r\n',0),(422627,11740,'sv','Checknummer om kolla',0),(422628,11740,'it','Controllare il numero se Check',0),(422629,11740,'tl','',0),(422630,11740,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹€à¸Šà¹‡à¸„',0),(422631,11740,'hi','à¤…à¤—à¤° à¤œà¤¾à¤à¤š à¤¨à¤‚à¤¬à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(422632,11740,'ms','Semak nombor jika semak',0),(422633,11740,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø±Ù‚Ù… Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(422634,11740,'fr','VÃ©rifiez le numÃ©ro si Check',0),(422635,11740,'jp','ç¢ºèªç•ªå·ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(422636,11740,'pt','Verifique o nÃºmero, se verificar',0),(422637,11740,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€, ÐµÑÐ»Ð¸',0),(422638,11740,'es','Si es Cheque, NÃºmero de Cheque',0),(422639,11740,'de','Schecknummer, wenn Check',0),(422640,11740,'en','Check Number if Check',0),(422641,11741,'is','',0),(422642,11741,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ ',0),(422643,11741,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÙŠ Ø´ÙˆØ¯ ',0),(422644,11741,'tr','NumarasÄ± zaten kullanÄ±mda',0),(422645,11741,'pl','Numer juÅ¼ w uÅ¼yciu',0),(422646,11741,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð²ÐµÑ‡Ðµ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸ Ð² ÐµÐºÑÐ¿Ð»Ð¾Ð°Ñ‚Ð°Ñ†Ð¸Ñ',0),(422647,11741,'ur','Ù†Ù…Ø¨Ø± Ù¾ÛÙ„Û’ ÛÛŒ Ø²ÛŒØ± Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(422648,11741,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð²ÐµÑ› Ñƒ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸',0),(422649,11741,'vi','Sá»‘ Ä‘Ã£ cÃ³ trong sá»­ dá»¥ng',0),(422650,11741,'af','Nommer reeds in gebruik',0),(422651,11741,'ro','NumÄƒrul deja Ã®n uz',0),(422652,11741,'et','Number juba kasutusel',0),(422653,11741,'si','Å tevilo Å¾e v uporabi',0),(422654,11741,'ba','Nomor sudah di gunakan',0),(422655,11741,'nl','Nummer al in gebruik',0),(422656,11741,'fi','Numero kÃ¤ytÃ¶ssÃ¤',0),(422657,11741,'no','Tallet allerede i bruk',0),(422658,11741,'da','Antal allerede i brug',0),(422659,11741,'ko','ì´ë¯¸ ì‚¬ìš© ì¤‘ì¸ ë²ˆí˜¸',0),(422660,11741,'he','×ž×¡×¤×¨ ×›×‘×¨ ×‘×©×™×ž×•×©',0),(422661,11741,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î®Î´Î· ÏƒÎµ Ï‡ÏÎ®ÏƒÎ·',0),(422662,11741,'zh','æ•°å·²åœ¨ä½¿ç”¨\r\n',0),(422663,11741,'sv','Antal redan i bruk',0),(422664,11741,'it','Numero giÃ  in uso',0),(422665,11741,'tl','',0),(422666,11741,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸—à¸µà¹ˆà¹ƒà¸Šà¹‰',0),(422667,11741,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‰à¤ªà¤¯à¥‹à¤— à¤®à¥‡à¤‚ à¤¹à¥ˆ',0),(422668,11741,'ms','Nombor sudah ada dalam penggunaan',0),(422669,11741,'ar','Ø±Ù‚Ù… Ù‚ÙŠØ¯ Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¨Ø§Ù„ÙØ¹Ù„',0),(422670,11741,'fr','Nombre dÃ©jÃ  en cours d\'utilisation',0),(422671,11741,'jp','æ—¢ã«ä½¿ç”¨ã•ã‚Œã¦ã„ã‚‹ç•ªå·',0),(422672,11741,'pt','NÃºmero jÃ¡ estÃ¡ em uso',0),(422673,11741,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑƒÐ¶Ðµ Ð² ÑÐºÑÐ¿Ð»ÑƒÐ°Ñ‚Ð°Ñ†Ð¸Ð¸',0),(422674,11741,'es','NÃºmero Ya en Uso',0),(422675,11741,'de','Anzahl bereits im Einsatz',0),(422676,11741,'en','Number Already in Use',0),(422677,11742,'is','',0),(422678,11742,'dr','(Ø§Ù‚Ø³Ø§Ø·) Ø«Ø¨Øª Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(422679,11742,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÙŠ(Ø§Ù‚Ø³Ø§Ø·) Ø«Ø¨Øª Ø´Ø¯Ù‡ ØªÙˆØ³Ø·',0),(422680,11742,'tr','TarafÄ±ndan girilen Ã¶demeleri',0),(422681,11742,'pl','PÅ‚atnoÅ›ci wprowadzonego przez',0),(422682,11742,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸ Ð¾Ñ‚',0),(422683,11742,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¯Ø§Ø®Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(422684,11742,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ ÑƒÐ½Ð¾ÑÐ¸',0),(422685,11742,'vi','nháº­p khoáº£n thanh toÃ¡n bá»Ÿi',0),(422686,11742,'af','Betalings Ingevoer Deur',0),(422687,11742,'ro','PlÄƒÅ£i de',0),(422688,11742,'et','Sisestas maksed',0),(422689,11742,'si','PlaÄila, ki jih',0),(422690,11742,'ba','Pembayaran yang dimasukkan oleh',0),(422691,11742,'nl','Betalingen ingevoerd door',0),(422692,11742,'fi','Maksut tuli',0),(422693,11742,'no','Betalinger som',0),(422694,11742,'da','Betalinger, der er angivet af',0),(422695,11742,'ko','ìž…ë ¥ í•œ ì§€ë¶ˆ',0),(422696,11742,'he','×ª×©×œ×•× ×©×”×•×–×Ÿ ×¢×œ-×™×“×™',0),(422697,11742,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… ÎµÎ³Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ',0),(422698,11742,'zh','ä»˜æ¬¾è¾“å…¥è€…\r\n',0),(422699,11742,'sv','Betalningar som angetts av',0),(422700,11742,'it','Pagamenti immessi di',0),(422701,11742,'tl','',0),(422702,11742,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸›à¹‰à¸­à¸™à¸”à¹‰à¸§à¸¢',0),(422703,11742,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(422704,11742,'ms','Bayaran oleh',0),(422705,11742,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ Ø¨ÙˆØ§Ø³Ø·Ø©',0),(422706,11742,'fr','Paiements inscrits par',0),(422707,11742,'jp','å…¥åŠ›ã—ãŸæ”¯æ‰•',0),(422708,11742,'pt','Pagamentos inseridos pelo',0),(422709,11742,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹, Ð²Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ðµ',0),(422710,11742,'es','Pagos Entrados Por',0),(422711,11742,'de','Zahlungen eingetragen',0),(422712,11742,'en','Payments Entered By',0),(422713,11743,'is','',0),(422714,11743,'dr','Ø¨Ø¯Ù‡ÙŠ Ù‚Ø¨Ù„ÙŠ Ø§Ø² ÙØ§ÙƒØªÙˆØ±',0),(422715,11743,'pr','Ø¨Ø¯Ù‡ÙŠ Ù‚Ø¨Ù„ÙŠ Ø§Ø² ÙØ§ÙƒØªÙˆØ±',0),(422716,11743,'tr','Son fatura alacaklar',0),(422717,11743,'pl','Ostatnich naleÅ¼nych od faktury',0),(422718,11743,'bg','ÐœÐ¸Ð½Ð°Ð»Ð¸ Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸ Ð¾Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(422719,11743,'ur','Ù…Ø§Ø¶ÛŒ Ø³Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ÙˆØ¬Û Ø³Û’',0),(422720,11743,'sr','ÐŸÑ€Ð¾Ñ‚ÐµÐºÐ»Ð¸Ñ… Ð´Ð¾ÑÐ¿ÐµÑ›Ð° Ð¸Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(422721,11743,'vi','Trong quÃ¡ khá»© do tá»« hÃ³a Ä‘Æ¡n',0),(422722,11743,'af','Afgelope verskuldig vanaf faktuur',0),(422723,11743,'ro','Trecut datorate de facturÄƒ',0),(422724,11743,'et','Viimase arve tasumisele',0),(422725,11743,'si','Zadnjih zapadlosti iz raÄuna',0),(422726,11743,'ba','Masa lalu karena dari faktur',0),(422727,11743,'nl','Afgelopen verschuldigd factuur',0),(422728,11743,'fi','Viimeisen laskun mÃ¤Ã¤rÃ¤',0),(422729,11743,'no','Siste utestÃ¥ende fakturaen',0),(422730,11743,'da','Seneste Due fra faktura',0),(422731,11743,'ko','ì§€ë‚œ ì†¡ìž¥ì—ì„œ ì˜ˆì •',0),(422732,11743,'he','×‘×¢×‘×¨ ×‘×©×œ ×ž×—×©×‘×•× ×™×ª',0),(422733,11743,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î¿Ï†ÎµÎ¯Î»Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(422734,11743,'zh','é€¾æœŸä»Žå‘ç¥¨\r\n',0),(422735,11743,'sv','Senaste frÃ¥n faktura',0),(422736,11743,'it','Ultimi dovuto dalla fattura',0),(422737,11743,'tl','',0),(422738,11743,'th','à¸œà¹ˆà¸²à¸™à¸¡à¸²à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸Šà¸³à¸£à¸°à¸ˆà¸²à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(422739,11743,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¥‡ à¤¦à¥‡à¤¯',0),(422740,11743,'ms','Lepas daripada invois',0),(422741,11743,'ar','Ø§Ù„Ù…Ø§Ø¶ÙŠØ© Ù…Ø³ØªØ­Ù‚Ø© Ù…Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(422742,11743,'fr','DerniÃ¨re Ã©chÃ©ance de la facture',0),(422743,11743,'jp','éŽåŽ»ã®è«‹æ±‚æ›¸ã‹ã‚‰æœŸé™',0),(422744,11743,'pt','Ãšltimos vencimento da fatura',0),(422745,11743,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¾Ñ‚ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(422746,11743,'es','Vencido De La Factura',0),(422747,11743,'de','Letzten Rechnung gegenÃ¼ber',0),(422748,11743,'en','Past Due from Invoice',0),(422749,11744,'is','',0),(422750,11744,'dr','(Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ)',0),(422751,11744,'pr','Ù…Ù‚Ø¯Ø§Ø± (Ù…Ø§Ù„ÙŠØ§Øª Ø¨Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø¯ÙˆÙ„ØªÙŠ)',0),(422752,11744,'tr','AMT',0),(422753,11744,'pl','Amt',0),(422754,11744,'bg','Amt',0),(422755,11744,'ur','Ø§Ù…Ù¹',0),(422756,11744,'sr','Ð Ð•Ð¤ . Ð’Ð°Ð».',0),(422757,11744,'vi','Sá»‘ tiá»n',0),(422758,11744,'af','Bedrag',0),(422759,11744,'ro','AMT',0),(422760,11744,'et','Amt',0),(422761,11744,'si','Amt',0),(422762,11744,'ba','Amt',0),(422763,11744,'nl','Amt',0),(422764,11744,'fi','AMT',0),(422765,11744,'no','Amt',0),(422766,11744,'da','Amt',0),(422767,11744,'ko','Amt',0),(422768,11744,'he','Amt',0),(422769,11744,'el','AMT',0),(422770,11744,'zh','é‡‘é¢ \r\n',0),(422771,11744,'sv','AMT',0),(422772,11744,'it','AMT',0),(422773,11744,'tl','',0),(422774,11744,'th','Amt',0),(422775,11744,'hi','Amt',0),(422776,11744,'ms','AMT',0),(422777,11744,'ar','Ø§Ù„Ù‚Ø¶Ø§Ø© Ø§Ù„ØªÙˆÙ†Ø³ÙŠÙŠÙ†',0),(422778,11744,'fr','AMT',0),(422779,11744,'jp','Amt',0),(422780,11744,'pt','AMT',0),(422781,11744,'ru','AMT',0),(422782,11744,'es','Monto',0),(422783,11744,'de','Amt',0),(422784,11744,'en','Amt',0),(422785,11745,'is','',0),(422786,11745,'dr','Ø®Ø§Ù„Øµ Ù…ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø±  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ \r\nSB',0),(422787,11745,'pr','Ø®Ø§Ù„Øµ Ù…ØªØ¹Ù‡Ø¯ Ø´Ø¯Ù‡  Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø¨Ø±  ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ \r\nSB',0),(422788,11745,'tr','NET taahhÃ¼t PO/SB',0),(422789,11745,'pl','Netto popeÅ‚nione PO/SB',0),(422790,11745,'bg','ÐÐµÑ‚Ð¾ Ð°Ð½Ð³Ð°Ð¶Ð¸Ñ€Ð° PO/SB',0),(422791,11745,'ur','Ø®Ø§Ù„Øµ Ø¹Ø²Ù… Ù¾Ùˆ/SB',0),(422792,11745,'sr','ÐÐµÑ‚Ð¾ Ð¿Ð¾Ñ‡Ð¸ÑšÐµÐ½Ð¸ ÐŸÐž/Ð¡Ð‘',0),(422793,11745,'vi','Net Committed PO/SB',0),(422794,11745,'af','Netto verbind PO/SB',0),(422795,11745,'ro','Net angajat PO/SB',0),(422796,11745,'et','Kasuliku toime PO/SB',0),(422797,11745,'si','Neto storjeno PO/SB',0),(422798,11745,'ba','Berkomitmen PO bersih/SB',0),(422799,11745,'nl','Netto vastgelegd PO/SB',0),(422800,11745,'fi','NET sitoutunut PO/SB',0),(422801,11745,'no','Netto forpliktet PO/SB',0),(422802,11745,'da','Netto engageret PO/SB',0),(422803,11745,'ko','Net ìµœì„ ì„ ë‹¤í•˜ê³  í¬/SB',0),(422804,11745,'he','× ×˜×• ×ž×—×•×™×‘×ª ×¤×•/SB',0),(422805,11745,'el','ÎšÎ±Î¸Î±ÏÎ® Î´ÎµÏƒÎ¼ÎµÏ…Ï„ÎµÎ¯ PO/SB',0),(422806,11745,'zh','å‡€å§”æ‰˜çš„è®¢å•/æœåŠ¡å…¬å‘Š\r\n',0),(422807,11745,'sv','Net Ã¥tagit sig PO/SB',0),(422808,11745,'it','Netto impegna PO/SB',0),(422809,11745,'tl','',0),(422810,11745,'th','à¸ªà¸¸à¸—à¸˜à¸´à¸¡à¸±à¹ˆà¸™ PO/SB',0),(422811,11745,'hi','à¤¨à¥‡à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§ à¤ªà¥‹/SB',0),(422812,11745,'ms','Bersih komited PO/SB',0),(422813,11745,'ar','Øµ. Ø¨ Ù…Ù„ØªØ²Ù…Ø© ØµØ§ÙÙŠ/Ø¨ÙŠÙ†Ø§Ù„ÙŠ Ø§Ù„Ø´Ø§Ø±Ù‚Ø©',0),(422814,11745,'fr','NET engagÃ© PO/SB',0),(422815,11745,'jp','Net ã‚³ãƒŸãƒƒãƒˆ PO/SB',0),(422816,11745,'pt','LÃ­quida comprometida PO/SB',0),(422817,11745,'ru','NET ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð¾ PO/SB',0),(422818,11745,'es','Neto Comprometido OC/SB',0),(422819,11745,'de','NET Foul PO/SB',0),(422820,11745,'en','Net Committed PO/SB',0),(422821,11746,'is','',0),(422822,11746,'dr','/ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø§ØµÙ„ÙŠ',0),(422823,11746,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ØµÙ„ÙŠ / ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ø§ØµÙ„ÙŠ',0),(422824,11746,'tr','Orijinal PO/SB',0),(422825,11746,'pl','Oryginalny PO/SB',0),(422826,11746,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÐµÐ½ PO/SB',0),(422827,11746,'ur','Ø§ØµÙ„ Ù¾ÙˆØ³Ù¹/SB',0),(422828,11746,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ ÐŸÐž/Ð¡Ð‘',0),(422829,11746,'vi','PO/SB gá»‘c',0),(422830,11746,'af','Oorspronklike PO/SB',0),(422831,11746,'ro','Original PO/SB',0),(422832,11746,'et','Algne PO/SB',0),(422833,11746,'si','Original PO/SB',0),(422834,11746,'ba','PO/SB asli',0),(422835,11746,'nl','Oorspronkelijke PO/SB',0),(422836,11746,'fi','AlkuperÃ¤inen PO/SB',0),(422837,11746,'no','Opprinnelige PO/SB',0),(422838,11746,'da','Oprindelige PO/SB',0),(422839,11746,'ko','ì›ëž˜ í¬/SB',0),(422840,11746,'he','×¤×• ×”×ž×§×•×¨×™/SB',0),(422841,11746,'el','Î‘ÏÏ‡Î¹ÎºÎ® PO/SB',0),(422842,11746,'zh','åŽŸé‡‡è´­è®¢å•/æŸäºº\r\n',0),(422843,11746,'sv','Ursprungliga PO/SB',0),(422844,11746,'it','Originale PO/SB',0),(422845,11746,'tl','',0),(422846,11746,'th','PO à¹€à¸”à¸´à¸¡ SB',0),(422847,11746,'hi','à¤®à¥‚à¤² à¤ªà¥‹/SB',0),(422848,11746,'ms','PO/SB asal',0),(422849,11746,'ar','Øµ. Ø¨/SB Ø§Ù„Ø£ØµÙ„ÙŠ',0),(422850,11746,'fr','Original PO/SB',0),(422851,11746,'jp','å…ƒã® PO/SB',0),(422852,11746,'pt','PO/SB original',0),(422853,11746,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ PO/SB',0),(422854,11746,'es','OC/SB Original',0),(422855,11746,'de','Original PO/SB',0),(422856,11746,'en','Original PO/SB',0),(422857,11747,'is','',0),(422858,11747,'dr','(Ù…Ø¹Ø·Ù„ÙŠ',0),(422859,11747,'pr','Ø¨Ø§ Ù…Ø¹ÙˆÙ‚(Ù…Ø¹Ø·Ù„ÙŠ',0),(422860,11747,'tr','Ä°le bekleyen',0),(422861,11747,'pl','Z czasu',0),(422862,11747,'bg','Ð¡ Ð²Ð¸ÑÑÑ‰Ð¸',0),(422863,11747,'ur','Ú©Û’ Ø³Ø§ØªÚ¾ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(422864,11747,'sr','Ð¡Ð° Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(422865,11747,'vi','vá»›i viá»‡c treo láº¡i',0),(422866,11747,'af','Met hangende',0),(422867,11747,'ro','Cu pÃ¢nÄƒ la',0),(422868,11747,'et','Koos ootel',0),(422869,11747,'si','Z ÄakajoÄih',0),(422870,11747,'ba','Dengan tertunda',0),(422871,11747,'nl','Met in behandeling',0),(422872,11747,'fi','On vireillÃ¤',0),(422873,11747,'no','Med ventende',0),(422874,11747,'da','Med ventende',0),(422875,11747,'ko','ê³¼ ë³´ë¥˜',0),(422876,11747,'he','×¢× ×”×ž×ª× ×”',0),(422877,11747,'el','ÎœÎµ ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚',0),(422878,11747,'zh','ä¸Žå¾…å†³\r\n',0),(422879,11747,'sv','Med pÃ¥gÃ¥ende',0),(422880,11747,'it','Con pendenti',0),(422881,11747,'tl','',0),(422882,11747,'th','à¸¡à¸µà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(422883,11747,'hi','à¤•à¥‡ à¤¸à¤¾à¤¥ à¤²à¤‚à¤¬à¤¿à¤¤',0),(422884,11747,'ms','Dengan belum selesai',0),(422885,11747,'ar','Ù…Ø¹ Ù…Ø¹Ù„Ù‚Ø©',0),(422886,11747,'fr','Avec en attente',0),(422887,11747,'jp','ä¿ç•™ä¸­',0),(422888,11747,'pt','Com pendente',0),(422889,11747,'ru','Ð¡ Ð´Ð¾',0),(422890,11747,'es','Con Pendiente',0),(422891,11747,'de','Mit ausstehenden',0),(422892,11747,'en','With Pending',0),(422893,11748,'is','',0),(422894,11748,'dr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø²ØªØ§Ø±ÙŠØ® ',0),(422895,11748,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ø§Ø²ØªØ§Ø±ÙŠØ® ',0),(422896,11748,'tr','Maliyet olarak',0),(422897,11748,'pl','Koszt jako',0),(422898,11748,'bg','Ð¦ÐµÐ½Ð° ÐºÐ°Ñ‚Ð¾ Ð½Ð°',0),(422899,11748,'ur','Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(422900,11748,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº ÐºÐ°Ð¾',0),(422901,11748,'vi','chi phÃ­ cá»§a',0),(422902,11748,'af','Koste As van',0),(422903,11748,'ro','Costa ca de',0),(422904,11748,'et','Hind alates',0),(422905,11748,'si','StroÅ¡ki kot',0),(422906,11748,'ba','Biaya sebagai',0),(422907,11748,'nl','Kosten als van',0),(422908,11748,'fi','Kustannukset koska',0),(422909,11748,'no','Kostnad som',0),(422910,11748,'da','Koste som af',0),(422911,11748,'ko','ë¹„ìš©',0),(422912,11748,'he','×¢×œ×•×ª ×›',0),(422913,11748,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï‰Ï‚',0),(422914,11748,'zh','æˆæœ¬ä½œä¸º\r\n',0),(422915,11748,'sv','Kostnaden som fÃ¶r',0),(422916,11748,'it','Costo come di',0),(422917,11748,'tl','',0),(422918,11748,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¹€à¸›à¹‡à¸™à¸‚à¸­à¸‡',0),(422919,11748,'hi','à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤•à¥€ à¤²à¤¾à¤—à¤¤',0),(422920,11748,'ms','Kos sebagai',0),(422921,11748,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© ÙƒÙ…Ù†',0),(422922,11748,'fr','CoÃ»t du',0),(422923,11748,'jp','ã‚³ã‚¹ãƒˆã—ã¾ã™ã€‚',0),(422924,11748,'pt','Custam a partir de',0),(422925,11748,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ð¾ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸ÑŽ Ð½Ð°',0),(422926,11748,'es','El Costo A Partir De',0),(422927,11748,'de','Kosten als der',0),(422928,11748,'en','Cost As Of',0),(422929,11749,'is','',0),(422930,11749,'dr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ú¯Ø±ÙˆÙ‡ ',0),(422931,11749,'pr','ÙƒØ¯ Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ú¯Ø±ÙˆÙ‡ ',0),(422932,11749,'tr','Maliyet kodu ve Kategori',0),(422933,11749,'pl','Koszt kodu i kategorii',0),(422934,11749,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÐºÐ¾Ð´ Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(422935,11749,'ur','Ù„Ø§Ú¯Øª Ú©ÙˆÚˆ Ø§ÙˆØ± Ø²Ù…Ø±Û',0),(422936,11749,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÐºÐ¾Ð´Ð° Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(422937,11749,'vi','danh má»¥c vÃ  mÃ£ chi phÃ­',0),(422938,11749,'af','Koste kode en kategorie',0),(422939,11749,'ro','Codul de cost ÅŸi categorie',0),(422940,11749,'et','Kulu kood ja kategooria',0),(422941,11749,'si','StroÅ¡kovno kodo in Kategorija',0),(422942,11749,'ba','Kode biaya dan kategori',0),(422943,11749,'nl','Kosten Code en categorie',0),(422944,11749,'fi','Kustannusten koodi ja luokka',0),(422945,11749,'no','Pris kode og kategori',0),(422946,11749,'da','Pris kode og kategori',0),(422947,11749,'ko','ë¹„ìš©ëœ ì½”ë“œì™€ ì¹´í…Œê³ ë¦¬',0),(422948,11749,'he','×§×•×“ ×¢×œ×•×ª ×•×§×˜×’×•×¨×™×”',0),(422949,11749,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ± ÎºÎ±Î¹ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(422950,11749,'zh','æˆæœ¬ä»£ç å’Œç±»åˆ«\r\n',0),(422951,11749,'sv','Kostnad kod och kategori',0),(422952,11749,'it','Codice di costo e categoria',0),(422953,11749,'tl','',0),(422954,11749,'th','à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™à¹à¸¥à¸°à¸›à¸£à¸°à¹€à¸ à¸—',0),(422955,11749,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤”à¤° à¤¶à¥à¤°à¥‡à¤£à¥€',0),(422956,11749,'ms','Kos kod dan kategori',0),(422957,11749,'ar','ÙƒÙˆØ¯ Ø§Ù„ØªÙƒÙ„ÙØ©ØŒ ÙˆØ§Ù„ÙØ¦Ø©',0),(422958,11749,'fr','Code de coÃ»t et de la catÃ©gorie',0),(422959,11749,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã¨ã‚«ãƒ†ã‚´ãƒª',0),(422960,11749,'pt','CÃ³digo de custo e categoria',0),(422961,11749,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´Ð° Ð¸ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(422962,11749,'es','CÃ³digo de Costo y CategorÃ­a',0),(422963,11749,'de','Kosten Code und Kategorie',0),(422964,11749,'en','Cost Code and Category',0),(422965,11750,'is','',0),(422966,11750,'dr','Ù…Ø¨Ø§Ù„Øº ÙƒÙ„ ØªÙ…Ø§Ù… Ø´ØºÙ„ Ù‡Ø§ ',0),(422967,11750,'pr','Ù…Ø¨Ø§Ù„Øº ÙƒÙ„ ØªÙ…Ø§Ù… Ø´ØºÙ„ Ù‡Ø§ ',0),(422968,11750,'tr','TÃ¼m iÅŸleri Grand toplam',0),(422969,11750,'pl','SumÄ™ koÅ„cowÄ… wszystkie zadania',0),(422970,11750,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¸',0),(422971,11750,'ur','ØªÙ…Ø§Ù… Ù…Ù„Ø§Ø²Ù…ØªÛŒÚº Ú¯Ø±ÛŒÙ†Úˆ Ú©Ù„',0),(422972,11750,'sr','Ð“Ñ€Ð°Ð½Ð´ Ð¢Ð¾Ñ‚Ð°Ð» ÑÐ²Ðµ Ð¿Ð¾ÑÐ»Ð¾Ð²Ðµ',0),(422973,11750,'vi','tá»•ng sá»‘ cho cÃ¡c cÃ´ng viá»‡c',0),(422974,11750,'af','Grand totaal alle Jobs',0),(422975,11750,'ro','Marele Total toate locurile de muncÄƒ',0),(422976,11750,'et','Grand kokku kÃµik TÃ¶Ã¶pakkumised',0),(422977,11750,'si','Skupno vsoto vseh delovnih mest',0),(422978,11750,'ba','Grand Total semua pekerjaan',0),(422979,11750,'nl','Grand totaal alle banen',0),(422980,11750,'fi','YhteensÃ¤ kaikki tyÃ¶t',0),(422981,11750,'no','Totalsum alle jobber',0),(422982,11750,'da','Grand samlede alle job',0),(422983,11750,'ko','ê·¸ëžœë“œ ì´ ëª¨ë“  ìž‘ì—…',0),(422984,11750,'he','×’×¨× ×“ ×¡×š ×›×œ ×”×¢×‘×•×“×•×ª',0),(422985,11750,'el','Î“ÎµÎ½Î¹ÎºÎ¬ Î±Î¸ÏÎ¿Î¯ÏƒÎ¼Î±Ï„Î± ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î¸Î­ÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(422986,11750,'zh','æ€»è®¡æ‰€æœ‰èŒä½\r\n',0),(422987,11750,'sv','Totalsumma alla jobb',0),(422988,11750,'it','Gran totale tutti i lavori',0),(422989,11750,'tl','',0),(422990,11750,'th','à¹à¸à¸£à¸™à¸”à¹Œà¸£à¸§à¸¡à¸‡à¸²à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(422991,11750,'hi','à¤­à¤µà¥à¤¯ à¤•à¥à¤² à¤¸à¤­à¥€ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¤¾à¤‚',0),(422992,11750,'ms','Grand jumlah semua kerja',0),(422993,11750,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙƒÙ„ÙŠ Ø¬Ù…ÙŠØ¹ Ø§Ù„ÙˆØ¸Ø§Ø¦Ù',0),(422994,11750,'fr','Grand Total de tous les emplois',0),(422995,11750,'jp','ç·è¨ˆã®ã™ã¹ã¦ã®ã‚¸ãƒ§ãƒ–',0),(422996,11750,'pt','Total geral de todos os trabalhos',0),(422997,11750,'ru','Ð˜Ñ‚Ð¾Ð³ Ð²ÑÐµÑ… Ð·Ð°Ð´Ð°Ð½Ð¸Ð¹',0),(422998,11750,'es','Gran Total de Todos Trabajos',0),(422999,11750,'de','Grand Total alle Jobs',0),(423000,11750,'en','Grand Total All Jobs',0),(423001,11751,'is','',0),(423002,11751,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´ØºÙ„ ',0),(423003,11751,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´ØºÙ„ ',0),(423004,11751,'tr','Ä°ÅŸi seÃ§in',0),(423005,11751,'pl','Wybierz zadanie',0),(423006,11751,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(423007,11751,'ur','Ø¬Ø§Ø¨ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(423008,11751,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÐ°Ð¾',0),(423009,11751,'vi','Chá»n nghá» nghiá»‡p',0),(423010,11751,'af','Kies werk',0),(423011,11751,'ro','SelectaÅ£i Job',0),(423012,11751,'et','Vali tÃ¶Ã¶',0),(423013,11751,'si','Izberite posel',0),(423014,11751,'ba','Pilih pekerjaan',0),(423015,11751,'nl','Selecteer baan',0),(423016,11751,'fi','Valitse tyÃ¶',0),(423017,11751,'no','Velg jobben',0),(423018,11751,'da','VÃ¦lg Job',0),(423019,11751,'ko','ìž‘ì—… ì„ íƒ',0),(423020,11751,'he','×‘×—×¨ ×¢×‘×•×“×”',0),(423021,11751,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(423022,11751,'zh','é€‰æ‹©ä½œä¸š\r\n',0),(423023,11751,'sv','VÃ¤lj jobb',0),(423024,11751,'it','Seleziona lavoro',0),(423025,11751,'tl','',0),(423026,11751,'th','à¹€à¸¥à¸·à¸­à¸à¸‡à¸²à¸™',0),(423027,11751,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(423028,11751,'ms','Pilih kerja',0),(423029,11751,'ar','Ø­Ø¯Ø¯ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(423030,11751,'fr','SÃ©lectionnez le travail',0),(423031,11751,'jp','ã‚¸ãƒ§ãƒ–ã‚’é¸æŠžã—ã¾ã™',0),(423032,11751,'pt','Selecione trabalho',0),(423033,11751,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(423034,11751,'es','Selecciona el Trabajo',0),(423035,11751,'de','WÃ¤hlen Sie Auftrag',0),(423036,11751,'en','Select Job',0),(423037,11752,'is','',0),(423038,11752,'dr','ØªØºÙŠÙŠØ±Ø§Øª',0),(423039,11752,'pr','ØªØºÙŠÙŠØ±Ø§Øª',0),(423040,11752,'tr','DeÄŸiÅŸiklikler',0),(423041,11752,'pl','Zmiany',0),(423042,11752,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸',0),(423043,11752,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(423044,11752,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ðµ',0),(423045,11752,'vi','Thay Ä‘á»•i',0),(423046,11752,'af','Veranderinge',0),(423047,11752,'ro','ModificÄƒri',0),(423048,11752,'et','Muutused',0),(423049,11752,'si','Spremembe',0),(423050,11752,'ba','Perubahan',0),(423051,11752,'nl','Wijzigingen',0),(423052,11752,'fi','Muutokset',0),(423053,11752,'no','Endringer',0),(423054,11752,'da','Ã†ndringer',0),(423055,11752,'ko','ë³€ê²½',0),(423056,11752,'he','×©×™× ×•×™×™×',0),(423057,11752,'el','Î‘Î»Î»Î±Î³Î­Ï‚',0),(423058,11752,'zh','å˜åŒ–\r\n',0),(423059,11752,'sv','FÃ¶rÃ¤ndringar',0),(423060,11752,'it','Modifiche',0),(423061,11752,'tl','',0),(423062,11752,'th','à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(423063,11752,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(423064,11752,'ms','Perubahan',0),(423065,11752,'ar','Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(423066,11752,'fr','Changements',0),(423067,11752,'jp','å¤‰æ›´',0),(423068,11752,'pt','MudanÃ§as',0),(423069,11752,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(423070,11752,'es','Cambios',0),(423071,11752,'de','Ã„nderungen',0),(423072,11752,'en','Changes',0),(423073,11753,'is','',0),(423074,11753,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ØµÙ„ÙŠ',0),(423075,11753,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÙŠØ¯ Ø§ØµÙ„ÙŠ',0),(423076,11753,'tr','Orijinal PO',0),(423077,11753,'pl','Oryginalny PO',0),(423078,11753,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÐµÐ½ PO',0),(423079,11753,'ur','Ø§ØµÙ„ Ù¾ÙˆØ³Ù¹',0),(423080,11753,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ ÐŸÐž',0),(423081,11753,'vi','Ban Ä‘áº§u PO',0),(423082,11753,'af','Oorspronklike PO',0),(423083,11753,'ro','Original PO',0),(423084,11753,'et','Algne PO',0),(423085,11753,'si','Original PO',0),(423086,11753,'ba','Asli PO',0),(423087,11753,'nl','Oorspronkelijke PO',0),(423088,11753,'fi','AlkuperÃ¤inen PO',0),(423089,11753,'no','Opprinnelige PO',0),(423090,11753,'da','Oprindelige PO',0),(423091,11753,'ko','ì›ëž˜ í¬',0),(423092,11753,'he','×¤×• ×”×ž×§×•×¨×™',0),(423093,11753,'el','Î‘ÏÏ‡Î¹ÎºÎ® PO',0),(423094,11753,'zh','åŽŸå®\r\n',0),(423095,11753,'sv','Ursprungliga PO',0),(423096,11753,'it','PO originale',0),(423097,11753,'tl','',0),(423098,11753,'th','PO à¹€à¸”à¸´à¸¡',0),(423099,11753,'hi','à¤®à¥‚à¤² à¤ªà¥‹',0),(423100,11753,'ms','Asal PO',0),(423101,11753,'ar','Ø¨Ùˆ Ø§Ù„Ø£ØµÙ„ÙŠ',0),(423102,11753,'fr','PO original',0),(423103,11753,'jp','å…ƒã® PO',0),(423104,11753,'pt','PO original',0),(423105,11753,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ PO',0),(423106,11753,'es','OC Original',0),(423107,11753,'de','Original PO',0),(423108,11753,'en','Original PO',0),(423109,11754,'is','',0),(423110,11754,'dr','(ØªØ§ Ø²Ù…Ø§Ù†) ØµØ¯ÙˆØ± Ø¨ÛŒØ¬Ú©',0),(423111,11754,'pr','Ù‡Ù†ÙˆØ² (ØªØ§ Ø²Ù…Ø§Ù†) ØµØ¯ÙˆØ± ÙØ§ÙƒØªÙˆØ±',0),(423112,11754,'tr','HenÃ¼z fatura kesmek',0),(423113,11754,'pl','Jeszcze do faktury',0),(423114,11754,'bg','ÐžÑ‰Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(423115,11754,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ø§Ø¨Ú¾ÛŒ ØªÚ©',0),(423116,11754,'sr','Ð¢ÐµÐº Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(423117,11754,'vi','ÄÆ°á»£c Ä‘á»ƒ hÃ³a Ä‘Æ¡n',0),(423118,11754,'af','Tog om die faktuur',0),(423119,11754,'ro','ÃŽncÄƒ la factura',0),(423120,11754,'et','Veel vÃµivad esitada arveid',0),(423121,11754,'si','Å e za fakturiranje',0),(423122,11754,'ba','Namun untuk faktur',0),(423123,11754,'nl','Nog te factureren',0),(423124,11754,'fi','VielÃ¤ Laskutettava',0),(423125,11754,'no','EnnÃ¥ Ã¥ fakturere',0),(423126,11754,'da','Endnu til faktura',0),(423127,11754,'ko','ì•„ì§ ì†¡ìž¥ì—',0),(423128,11754,'he','×¢×•×“ ×¢×œ ×”×—×©×‘×•× ×™×ª',0),(423129,11754,'el','Î‘ÎºÏŒÎ¼Î± Î½Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ',0),(423130,11754,'zh','ç„¶è€Œï¼Œå¯¹å‘ç¥¨\r\n',0),(423131,11754,'sv','Ã„nnu till faktura',0),(423132,11754,'it','Ancora a fattura',0),(423133,11754,'tl','',0),(423134,11754,'th','à¸¢à¸±à¸‡à¸à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(423135,11754,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤­à¥€ à¤¤à¤•',0),(423136,11754,'ms','Namun untuk invois',0),(423137,11754,'ar','Ø¨Ø¹Ø¯ Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(423138,11754,'fr','Encore Ã  facturer',0),(423139,11754,'jp','è«‹æ±‚æ›¸ã«ã¾ã ',0),(423140,11754,'pt','Ainda a factura',0),(423141,11754,'ru','Ð¢ÐµÐ¼ Ð½Ðµ Ð¼ÐµÐ½ÐµÐµ, Ð´Ð»Ñ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°',0),(423142,11754,'es','Aun para Facturar',0),(423143,11754,'de','Noch auf Rechnung',0),(423144,11754,'en','Yet to Invoice',0),(423145,11755,'is','',0),(423146,11755,'dr','ØªØºÙŠÙŠØ±Ø§Øª ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(423147,11755,'pr','ØªØºÙŠÙŠØ±Ø§Øª ØªØ§ÙŠÙŠØ¯ Ø´Ø¯Ù‡',0),(423148,11755,'tr','Onaylanan deÄŸiÅŸiklikler',0),(423149,11755,'pl','Zatwierdzonych zmian',0),(423150,11755,'bg','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(423151,11755,'ur','Ù…Ù†Ø¸ÙˆØ± Ø´Ø¯Û ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(423152,11755,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(423153,11755,'vi','Thay Ä‘á»•i phÃª duyá»‡t',0),(423154,11755,'af','Goedgekeurde Veranderinge',0),(423155,11755,'ro','Aprobat modificÄƒri',0),(423156,11755,'et','Heakskiidetud muudatused',0),(423157,11755,'si','Odobrenih sprememb',0),(423158,11755,'ba','Perubahan disetujui',0),(423159,11755,'nl','Goedgekeurde wijzigingen',0),(423160,11755,'fi','Muutosten',0),(423161,11755,'no','Godkjente endringer',0),(423162,11755,'da','Godkendte Ã¦ndringer',0),(423163,11755,'ko','ìŠ¹ì¸ ëœ ë³€ê²½',0),(423164,11755,'he','×”×©×™× ×•×™×™× ×©××•×©×¨×•',0),(423165,11755,'el','Î•Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½ÎµÏ‚ Î±Î»Î»Î±Î³Î­Ï‚',0),(423166,11755,'zh','æ‰¹å‡†çš„å˜æ›´\r\n',0),(423167,11755,'sv','GodkÃ¤nda Ã¤ndringar',0),(423168,11755,'it','Modifiche approvate',0),(423169,11755,'tl','',0),(423170,11755,'th','à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(423171,11755,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(423172,11755,'ms','Perubahan yang telah diluluskan',0),(423173,11755,'ar','Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù„Ù…ÙˆØ§ÙÙ‚ Ø¹Ù„ÙŠÙ‡Ø§',0),(423174,11755,'fr','Modifications approuvÃ©es',0),(423175,11755,'jp','æ‰¿èªã•ã‚ŒãŸå¤‰æ›´',0),(423176,11755,'pt','AlteraÃ§Ãµes aprovadas',0),(423177,11755,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(423178,11755,'es','Cambios Aprobados',0),(423179,11755,'de','Genehmigte Ã„nderungen',0),(423180,11755,'en','Approved Changes',0),(423181,11756,'is','',0),(423182,11756,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¬Ø¯ÙŠØ¯ ',0),(423183,11756,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¬Ø¯ÙŠØ¯ ',0),(423184,11756,'tr','Yeni toplam',0),(423185,11756,'pl','Nowy Total',0),(423186,11756,'bg','ÐÐ¾Ð²Ð¾ Ð¾Ð±Ñ‰Ð¾',0),(423187,11756,'ur','Ù†Ø¦Û’ Ú©Ù„',0),(423188,11756,'sr','ÐÐ¾Ð²Ð¸Ñ… ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(423189,11756,'vi','tá»•ng má»›i',0),(423190,11756,'af','Nuwe totaal',0),(423191,11756,'ro','Noi Total',0),(423192,11756,'et','Uus kogusumma',0),(423193,11756,'si','Nova skupno',0),(423194,11756,'ba','Total baru',0),(423195,11756,'nl','Nieuwe totaal',0),(423196,11756,'fi','Uusi',0),(423197,11756,'no','Ny Total',0),(423198,11756,'da','Nye samlede',0),(423199,11756,'ko','ìƒˆ ì´',0),(423200,11756,'he','×¡×” ×› ×—×“×©×”',0),(423201,11756,'el','ÎÎ­Î± ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(423202,11756,'zh','æ–°çš„æ€»é¢\r\n',0),(423203,11756,'sv','Nya totalt',0),(423204,11756,'it','Nuovo totale',0),(423205,11756,'tl','',0),(423206,11756,'th','à¸£à¸§à¸¡à¹ƒà¸«à¸¡à¹ˆ',0),(423207,11756,'hi','à¤¨à¤ˆ à¤•à¥à¤²',0),(423208,11756,'ms','Baru jumlah',0),(423209,11756,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(423210,11756,'fr','Nouveau Total',0),(423211,11756,'jp','æ–°ã—ã„åˆè¨ˆ',0),(423212,11756,'pt','Novo Total',0),(423213,11756,'ru','ÐÐ¾Ð²Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(423214,11756,'es','Nuevo Total',0),(423215,11756,'de','Neue Total',0),(423216,11756,'en','New Total',0),(423217,11757,'is','',0),(423218,11757,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(423219,11757,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø§ÙˆÙ„ÙŠÙ‡ ',0),(423220,11757,'tr','Ã–zgÃ¼n toplam',0),(423221,11757,'pl','Oryginalny Å‚Ä…cznie',0),(423222,11757,'bg','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÐµÐ½ Ð¾Ð±Ñ‰Ð¾',0),(423223,11757,'ur','Ø§ØµÙ„ Ú©Ù„',0),(423224,11757,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(423225,11757,'vi','tá»•ng sá»‘ gá»‘c',0),(423226,11757,'af','Oorspronklike totaal',0),(423227,11757,'ro','Original Total',0),(423228,11757,'et','Algne kokku',0),(423229,11757,'si','Original skupaj',0),(423230,11757,'ba','Total asli',0),(423231,11757,'nl','Oorspronkelijke totaal',0),(423232,11757,'fi','AlkuperÃ¤isestÃ¤ yhteensÃ¤',0),(423233,11757,'no','Opprinnelige totalt',0),(423234,11757,'da','Original Total',0),(423235,11757,'ko','ì›ëž˜ ì´',0),(423236,11757,'he','×”×›×•×œ×œ ×”×ž×§×•×¨×™',0),(423237,11757,'el','Î‘ÏÏ‡Î¹ÎºÏŒ ÏƒÏÎ½Î¿Î»Î¿',0),(423238,11757,'zh','åŽŸä»·åˆè®¡\r\n',0),(423239,11757,'sv','Ursprungliga totalt',0),(423240,11757,'it','Totale originale',0),(423241,11757,'tl','',0),(423242,11757,'th','à¹€à¸”à¸´à¸¡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(423243,11757,'hi','à¤®à¥‚à¤² à¤•à¥à¤²',0),(423244,11757,'ms','Jumlah asal',0),(423245,11757,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø£ØµÙ„ÙŠ',0),(423246,11757,'fr','Total original',0),(423247,11757,'jp','å…ƒã®åˆè¨ˆ',0),(423248,11757,'pt','Total original',0),(423249,11757,'ru','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð²ÑÐµÐ³Ð¾',0),(423250,11757,'es','Total Original',0),(423251,11757,'de','Original Total',0),(423252,11757,'en','Original Total',0),(423253,11758,'is','',0),(423254,11758,'dr','Ø¢Ø¯Ø±Ø³ Ù…Ø³ØªØ§Ø¬Ø± Ø¨Ø§ Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ø±Ø§ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙƒÙ†ÙŠØ¯ ',0),(423255,11758,'pr','Ø¢Ø¯Ø±Ø³ Ù…Ø³ØªØ§Ø¬Ø± Ø¨Ø§ Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ø±Ø§ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ Ù†ÙƒÙ†ÙŠØ¯ ',0),(423256,11758,'tr','Yeni kira ve kiracÄ± adres gÃ¼ncelleme yok',0),(423257,11758,'pl','Nie aktualizowaÄ‡ adres najemcy z nowej umowy leasingowej',0),(423258,11758,'bg','ÐÐµ ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð¹ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð°Ð´Ñ€ÐµÑ Ñ Ð½Ð¾Ð² Ð»Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð² Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(423259,11758,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Û’ Ø¹Ù†ÙˆØ§Ù† Ú©Û’ Ø³Ø§ØªÚ¾ Ù†Ø¦ÛŒ Ù„ÛŒØ² ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…Øª Ú©Ø±ÛŒÚº',0),(423260,11758,'sr','ÐÐµ ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð°Ð´Ñ€ÐµÑÑƒ ÑÑ‚Ð°Ð½Ð°Ñ€ ÑÐ° Ð½Ð¾Ð²Ð¸ Ð·Ð°ÐºÑƒÐ¿',0),(423261,11758,'vi','KhÃ´ng cáº­p nháº­t Ä‘á»‹a chá»‰ ngÆ°á»i thuÃª nhÃ  vá»›i há»£p Ä‘á»“ng thuÃª má»›i',0),(423262,11758,'af','Moenie Huurder Adres met Nuwe Huurooreenkoms Opdateer nie',0),(423263,11758,'ro','Nu ActualizaÅ£i adresa de chiriaÅŸ cu contract de leasing nou',0),(423264,11758,'et','Ã„ra vÃ¤rskenda Ã¼Ã¼rnik aadress uus Ã¼Ã¼rileping',0),(423265,11758,'si','Ne posodobite naslov najemnik z novo najem',0),(423266,11758,'ba','Tidak memperbarui alamat penyewa dengan sewa baru',0),(423267,11758,'nl','Adres van de huurder niet bijwerken met nieuwe Lease',0),(423268,11758,'fi','Ã„lÃ¤ pÃ¤ivitÃ¤ vuokralainen osoite uutta puhtia',0),(423269,11758,'no','Ikke oppdatere leietaker adresse med ny leieavtale',0),(423270,11758,'da','Ikke opdatere lejer adresse med nye lejekontrakt',0),(423271,11758,'ko','ìƒˆë¡œìš´ ìž„ëŒ€ ê±°ì£¼ìž ì£¼ì†Œ ì—…ë°ì´íŠ¸ í•˜ì§€ ë§ˆì‹­ì‹œì˜¤',0),(423272,11758,'he','×œ× ×œ×¢×“×›×Ÿ ×›×ª×•×‘×ª ×”×“×™×™×¨ ×¢× ×—×•×–×” ×©×›×™×¨×•×ª ×—×“×©',0),(423273,11758,'el','Î”ÎµÎ½ ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÎ¹ Ï„Î·Î½ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Ï„Î¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„Î® Î¼Îµ Î½Î­Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·',0),(423274,11758,'zh','ä¸æ›´æ–°ä¸Žæ–°ç§Ÿèµç§Ÿå®¢åœ°å€\r\n',0),(423275,11758,'sv','Uppdatera inte hyresgÃ¤sten adress med nya Hyresavtal',0),(423276,11758,'it','Non aggiornare l\'indirizzo inquilino con nuovo contratto di locazione',0),(423277,11758,'tl','',0),(423278,11758,'th','à¹„à¸¡à¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸¢à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¹ƒà¸«à¸¡à¹ˆ',0),(423279,11758,'hi','à¤¨à¤ˆ à¤²à¥€à¤œ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤ªà¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¨ à¤•à¤°à¥‡à¤‚',0),(423280,11758,'ms','Tidak mengemas kini alamat penyewa dengan nafas baru',0),(423281,11758,'ar','Ù„Ø§ ÙŠØªÙ… ØªØ­Ø¯ÙŠØ« Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± Ø¨Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(423282,11758,'fr','Ne pas mettre Ã  jour locataire adresse avec nouveau bail',0),(423283,11758,'jp','ãƒ†ãƒŠãƒ³ãƒˆ ã‚¢ãƒ‰ãƒ¬ã‚¹æ–°ã—ã„è³ƒè²¸å€Ÿå¥‘ç´„ã‚’æ›´æ–°ã—ã¾ã›ã‚“ã€‚',0),(423284,11758,'pt','NÃ£o atualizar o endereÃ§o do inquilino com nova locaÃ§Ã£o',0),(423285,11758,'ru','ÐÐµ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð°Ð´Ñ€ÐµÑ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð° Ñ Ð½Ð¾Ð²Ð¾Ð¹ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(423286,11758,'es','No Actualiza la DirecciÃ³n de Inquilino con el Nuevo Contrato de Arrendamiento',0),(423287,11758,'de','Nicht mit neues Mieter-Adresse aktualisieren',0),(423288,11758,'en','Don\'t Update Tenant Address with New Lease',0),(423289,11759,'is','',0),(423290,11759,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¯ÙŠÚ¯Ø±',0),(423291,11759,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¯ÙŠÚ¯Ø±',0),(423292,11759,'tr','DiÄŸer kira',0),(423293,11759,'pl','Inne Wynajem',0),(423294,11759,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ð¿Ð¾Ð´ Ð½Ð°ÐµÐ¼',0),(423295,11759,'ur','Ø¯ÛŒÚ¯Ø± Ú©Ø±Ø§Ø¦Û’',0),(423296,11759,'sr','Ð”Ñ€ÑƒÐ³Ðµ ÑÑ‚Ð°Ð½Ð°Ñ€Ð¸Ð½Ñƒ',0),(423297,11759,'vi','thuÃª khÃ¡c',0),(423298,11759,'af','Ander huur',0),(423299,11759,'ro','Alte chirii',0),(423300,11759,'et','Muud Rent',0),(423301,11759,'si','Druge najemnine',0),(423302,11759,'ba','Sewa lainnya',0),(423303,11759,'nl','Andere huur',0),(423304,11759,'fi','Muut vuokrattavana',0),(423305,11759,'no','Andre',0),(423306,11759,'da','Andre leje',0),(423307,11759,'ko','ê¸°íƒ€ ìž„ëŒ€',0),(423308,11759,'he','×”×©×›×¨×” ××—×¨×•×ª',0),(423309,11759,'el','Î†Î»Î»Î± ÎµÎ½Î¿Î¹ÎºÎ¯Î±ÏƒÎ·',0),(423310,11759,'zh','å…¶ä»–ç§Ÿé‡‘\r\n',0),(423311,11759,'sv','Andra hyra',0),(423312,11759,'it','Altro in affitto',0),(423313,11759,'tl','',0),(423314,11759,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²à¸­à¸·à¹ˆà¸™ à¹†',0),(423315,11759,'hi','à¤…à¤¨à¥à¤¯ à¤¬à¤¾à¤‡à¤• à¤•à¤¿à¤°à¤¾à¤',0),(423316,11759,'ms','Sewa lain-lain',0),(423317,11759,'ar','Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ø£Ø®Ø±Ù‰',0),(423318,11759,'fr','Autre Location',0),(423319,11759,'jp','ãã®ä»–ã®è³ƒè²¸æ–™',0),(423320,11759,'pt','Outro aluguel',0),(423321,11759,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ ÐÑ€ÐµÐ½Ð´Ð°',0),(423322,11759,'es','Otro Arrendamiento ',0),(423323,11759,'de','Andere mieten',0),(423324,11759,'en','Other Rent',0),(423325,11760,'is','',0),(423326,11760,'dr','Pet Deposit Ø­Ø³Ø§Ø¨ Ù„ÛŒØ¬Ø±',0),(423327,11760,'pr','Pet Deposit Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± ÙƒÙ„',0),(423328,11760,'tr','Evde beslenen hayvan mevduat GL hesabÄ±',0),(423329,11760,'pl','GL pieÅ›ciÄ‡ wpÅ‚acie na konto:',0),(423330,11760,'bg','Ð”Ð¾Ð¼Ð°ÑˆÐ½Ð¸ GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(423331,11760,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± Ø¬Ù…Ø¹ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(423332,11760,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ð“Ð› Ñ™ÑƒÐ±Ð¸Ð¼Ñ†Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(423333,11760,'vi','sá»• cÃ¡i tÃ i khoáº£n tiá»n gá»­i Ä‘áº·c biá»‡t',0),(423334,11760,'af','Troeteldier GL inbetaal',0),(423335,11760,'ro','Animal de casÄƒ depozit GL cont',0),(423336,11760,'et','Lemmikloomade hoiuse pearaamatukontole',0),(423337,11760,'si','Jjeza depozitni raÄun GL',0),(423338,11760,'ba','Rekening GL hewan peliharaan',0),(423339,11760,'nl','Huisdier depositorekening GL',0),(423340,11760,'fi','LemmikkielÃ¤inten talletus Kirjanpitotilin pÃ¤Ã¤tilin',0),(423341,11760,'no','Pet innskudd GL konto',0),(423342,11760,'da','KÃ¦ledyr depositum GL konto',0),(423343,11760,'ko','ì• ì™„ ë™ë¬¼ ë³´ì¦ê¸ˆ GL ê³„ì •',0),(423344,11760,'he','×”×—×©×‘×•×Ÿ GL ×œ×—×™×•×ª ×ž×—×ž×“',0),(423345,11760,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½',0),(423346,11760,'zh','å® ç‰©å­˜æ¬¾æ€»å¸å¸æˆ·\r\n',0),(423347,11760,'sv','SÃ¤llskapsdjur GL konto',0),(423348,11760,'it','Conto di deposito domestico GL',0),(423349,11760,'tl','',0),(423350,11760,'th','GL à¸à¸²à¸à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(423351,11760,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤œà¤®à¤¾ GL à¤–à¤¾à¤¤à¥‡',0),(423352,11760,'ms','Akaun GL Deposit haiwan kesayangan',0),(423353,11760,'ar','Ø­Ø³Ø§Ø¨ GL Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ©',0),(423354,11760,'fr','Compte courant GL pour animaux de compagnie',0),(423355,11760,'jp','ãƒšãƒƒãƒˆ ãƒ‡ãƒã‚¸ãƒƒãƒˆ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(423356,11760,'pt','Conta de depÃ³sito de animais GL',0),(423357,11760,'ru','Pet Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° GL',0),(423358,11760,'es','Cuenta LM de DepÃ³sito de Mascota',0),(423359,11760,'de','Haustier Guthabenkonto GL',0),(423360,11760,'en','Pet Deposit GL Account',0),(423361,11761,'is','',0),(423362,11761,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† ',0),(423363,11761,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† ',0),(423364,11761,'tr','GÃ¶nder',0),(423365,11761,'pl','WyÅ›lij',0),(423366,11761,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸',0),(423367,11761,'ur','Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(423368,11761,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸',0),(423369,11761,'vi','Gá»­i',0),(423370,11761,'af','Stuur',0),(423371,11761,'ro','Trimite',0),(423372,11761,'et','Saada',0),(423373,11761,'si','PoÅ¡lji',0),(423374,11761,'ba','Kirim',0),(423375,11761,'nl','Verzenden',0),(423376,11761,'fi','LÃ¤hetÃ¤',0),(423377,11761,'no','Sende',0),(423378,11761,'da','Send',0),(423379,11761,'ko','ë³´ë‚´ê¸°',0),(423380,11761,'he','×©×œ×—',0),(423381,11761,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(423382,11761,'zh','å‘é€\r\n',0),(423383,11761,'sv','Skicka',0),(423384,11761,'it','Invia',0),(423385,11761,'tl','',0),(423386,11761,'th','à¸ªà¹ˆà¸‡',0),(423387,11761,'hi','à¤­à¥‡à¤œà¥‡à¤‚',0),(423388,11761,'ms','Menghantar',0),(423389,11761,'ar','Ø¥Ø±Ø³Ø§Ù„',0),(423390,11761,'fr','Envoyer',0),(423391,11761,'jp','é€ä¿¡',0),(423392,11761,'pt','Enviar',0),(423393,11761,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ',0),(423394,11761,'es','Enviar',0),(423395,11761,'de','Senden',0),(423396,11761,'en','Send',0),(423397,11762,'is','',0),(423398,11762,'dr','Pet Deposit',0),(423399,11762,'pr','Ø­Ø³Ø§Ø¨ Pet Deposit',0),(423400,11762,'tr','Evde beslenen hayvan mevduat hesabÄ±',0),(423401,11762,'pl','PieÅ›ciÄ‡ wpÅ‚acie na konto:',0),(423402,11762,'bg','Ð”Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(423403,11762,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± ÚˆÙ¾Ø§Ø²Ù¹ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹',0),(423404,11762,'sr','Ð‰ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ñ€Ð°Ñ‡ÑƒÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(423405,11762,'vi','tÃ i khoáº£n tiá»n gá»­i Ä‘áº·c biá»‡t',0),(423406,11762,'af','Troeteldier inbetaal',0),(423407,11762,'ro','Cont de depozit la animal de casÄƒ',0),(423408,11762,'et','Lemmikloomade hoiuse kontole',0),(423409,11762,'si','Jjeza Å¾iro raÄun',0),(423410,11762,'ba','Hewan peliharaan rekening deposito',0),(423411,11762,'nl','Huisdier depositorekening',0),(423412,11762,'fi','HellitellÃ¤ talletustili',0),(423413,11762,'no','Pet innskudd konto',0),(423414,11762,'da','Pet indlÃ¥nskonto',0),(423415,11762,'ko','ì• ì™„ ë™ë¬¼ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(423416,11762,'he','×—×©×‘×•×Ÿ ×”×¤×§×“×” ×œ×—×™×•×ª ×ž×—×ž×“',0),(423417,11762,'el','ÎšÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ Î¶ÏŽÎ¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½',0),(423418,11762,'zh','å® ç‰©å­˜æ¬¾è´¦æˆ·\r\n',0),(423419,11762,'sv','PET insÃ¤ttning konto',0),(423420,11762,'it','Conto di deposito domestico',0),(423421,11762,'tl','',0),(423422,11762,'th','à¸à¸²à¸à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(423423,11762,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤œà¤®à¤¾ à¤–à¤¾à¤¤à¤¾',0),(423424,11762,'ms','Haiwan peliharaan akaun Deposit',0),(423425,11762,'ar','Ø­Ø³Ø§Ø¨ Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ©',0),(423426,11762,'fr','Compte de dÃ©pÃ´t pour animaux de compagnie',0),(423427,11762,'jp','ãƒšãƒƒãƒˆã®é é‡‘å£åº§',0),(423428,11762,'pt','Conta de depÃ³sito de animais',0),(423429,11762,'ru','ÐŸÐ­Ð¢ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(423430,11762,'es','Cuenta de DepÃ³sito de Mascota',0),(423431,11762,'de','Haustier Depotkonto',0),(423432,11762,'en','Pet Deposit Account',0),(423433,11763,'is','',0),(423434,11763,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(423435,11763,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(423436,11763,'tr','Kira deÄŸiÅŸtirilmiÅŸtir',0),(423437,11763,'pl','Umowy najmu zostaÅ‚y zmienione',0),(423438,11763,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ðµ Ð±Ð¸Ð»Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð°',0),(423439,11763,'ur','Ù„ÛŒØ² Ú©ÛŒ Ø¬Ø§Ú†Ú©ÛŒ ÛÛ’',0),(423440,11763,'sr','Ð—Ð°ÐºÑƒÐ¿ Ñ˜Ðµ Ð¸Ð·Ð¼ÐµÑšÐµÐ½.',0),(423441,11763,'vi','Há»£p Ä‘á»“ng thuÃª Ä‘Ã£ Ä‘Æ°á»£c tu chÃ­nh',0),(423442,11763,'af','Huurkontrak is Gewysig',0),(423443,11763,'ro','Contract de leasing a fost modificatÄƒ',0),(423444,11763,'et','ÃœÃ¼rilepingu muuta',0),(423445,11763,'si','Zakup je bil spremenjen',0),(423446,11763,'ba','Sewa telah diamandemen',0),(423447,11763,'nl','Lease-overeenkomst is gewijzigd',0),(423448,11763,'fi','Vuokrasopimus on muutettu',0),(423449,11763,'no','Leieavtalen er endret',0),(423450,11763,'da','LejemÃ¥let er blevet Ã¦ndret',0),(423451,11763,'ko','ìž„ëŒ€ ê°œì • ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(423452,11763,'he','×©×›×™×¨×•×ª ×ª×•×§×Ÿ',0),(423453,11763,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î­Ï‡ÎµÎ¹ Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯',0),(423454,11763,'zh','ç§Ÿèµå·²è¢«ä¿®æ­£\r\n',0),(423455,11763,'sv','Hyresavtalet har Ã¤ndrats',0),(423456,11763,'it','Contratto di locazione Ã¨ stata modificata',0),(423457,11763,'tl','',0),(423458,11763,'th','à¸¡à¸µà¸à¸²à¸£à¹à¸à¹‰à¹„à¸‚à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(423459,11763,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤®à¥‡à¤‚ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(423460,11763,'ms','Pajakan telah dipinda',0),(423461,11763,'ar','ÙˆÙ‚Ø¯ ØªÙ… ØªØ¹Ø¯ÙŠÙ„ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(423462,11763,'fr','Bail a Ã©tÃ© modifiÃ©',0),(423463,11763,'jp','ãƒªãƒ¼ã‚¹ãŒæ”¹æ­£ã•ã‚Œã¦ã„ã¾ã™',0),(423464,11763,'pt','LocaÃ§Ã£o foi alterada',0),(423465,11763,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð±Ñ‹Ð»Ð° Ð²Ð½ÐµÑÐµÐ½Ð°',0),(423466,11763,'es','Contrato de Arrendamiento Se Enmienda',0),(423467,11763,'de','Leasing ist geÃ¤ndert worden',0),(423468,11763,'en','Lease Has Been Amended',0),(423469,11764,'is','',0),(423470,11764,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(423471,11764,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø¬Ø¯ÙŠØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(423472,11764,'tr','Yenilenen kira',0),(423473,11764,'pl','Umowy najmu zostaÅ‚y odnowione',0),(423474,11764,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð² Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ Ðµ Ð±Ð¸Ð» Ð¿Ð¾Ð´Ð½Ð¾Ð²ÐµÐ½',0),(423475,11764,'ur','Ù„ÛŒØ² Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯ Ú©ÛŒ Ú¯Ø¦ÛŒ ÛÛ’',0),(423476,11764,'sr','Ð—Ð°ÐºÑƒÐ¿ Ñ˜Ðµ Ð¾Ð±Ð½Ð¾Ð²Ñ™ÐµÐ½Ð°',0),(423477,11764,'vi','Há»£p Ä‘á»“ng thuÃª Ä‘Ã£ Ä‘Æ°á»£c gia háº¡n',0),(423478,11764,'af','Huurooreenkoms is Hernu',0),(423479,11764,'ro','Contract de leasing a fost reÃ®nnoit',0),(423480,11764,'et','ÃœÃ¼rilepingu pikendamist',0),(423481,11764,'si','Je bil obnovljen zakup',0),(423482,11764,'ba','Sewa telah diperbarui',0),(423483,11764,'nl','Lease-overeenkomst is vernieuwd',0),(423484,11764,'fi','Leasing on uudistettu',0),(423485,11764,'no','Leieavtalen er fornyet',0),(423486,11764,'da','LejemÃ¥let er blevet fornyet',0),(423487,11764,'ko','ìž„ëŒ€ ê°±ì‹ ',0),(423488,11764,'he','×©×›×™×¨×•×ª ×—×•×“×©×”',0),(423489,11764,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î­Ï‡ÎµÎ¹ Î±Î½Î±Î½ÎµÏ‰Î¸ÎµÎ¯',0),(423490,11764,'zh','ç§Ÿçº¦å·²ç»­æœŸ\r\n',0),(423491,11764,'sv','Hyresavtalet har fÃ¶rnyats',0),(423492,11764,'it','Ãˆ stato rinnovato il contratto di locazione',0),(423493,11764,'tl','',0),(423494,11764,'th','à¸¡à¸µà¸à¸²à¸£à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(423495,11764,'hi','à¤²à¥€à¤œ à¤¨à¤µà¥€à¤•à¤°à¤£ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(423496,11764,'ms','Pajakan telah diperbaharui',0),(423497,11764,'ar','ÙˆÙ‚Ø¯ ØªÙ… ØªØ¬Ø¯ÙŠØ¯ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(423498,11764,'fr','Bail a Ã©tÃ© renouvelÃ©',0),(423499,11764,'jp','ãƒªãƒ¼ã‚¹ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(423500,11764,'pt','LocaÃ§Ã£o foi renovada',0),(423501,11764,'ru','Ð”Ð¾Ð³Ð¾Ð²Ð¾Ñ€ Ð°Ñ€ÐµÐ½Ð´Ñ‹ Ð±Ñ‹Ð» Ð¿Ñ€Ð¾Ð´Ð»ÐµÐ½',0),(423502,11764,'es','Contrato de Arrendamiento se RenovÃ³',0),(423503,11764,'de','Leasing ist erneuert worden',0),(423504,11764,'en','Lease Has Been Renewed',0),(423505,11765,'is','',0),(423506,11765,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ Ø§Ø³Øª ',0),(423507,11765,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù¾Ø§ÙŠØ§Ù† ÙŠØ§ÙØªÙ‡ Ø§Ø³Øª ',0),(423508,11765,'tr','Kira sona erdi',0),(423509,11765,'pl','Umowy najmu zostaÅ‚y zakoÅ„czone',0),(423510,11765,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð² Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ Ðµ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÐµÐ½',0),(423511,11765,'ur','Ù„ÛŒØ² Ø®ØªÙ… Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(423512,11765,'sr','Ð—Ð°ÐºÑƒÐ¿ Ñ˜Ðµ Ð¿Ñ€ÐµÐºÐ¸Ð½ÑƒÑ‚.',0),(423513,11765,'vi','Há»£p Ä‘á»“ng thuÃª Ä‘Ã£ Ä‘Æ°á»£c káº¿t thÃºc',0),(423514,11765,'af','Huurooreenkoms is BeÃ«indig',0),(423515,11765,'ro','Contract de leasing a fost reziliat',0),(423516,11765,'et','ÃœÃ¼rilepingu lÃµpetamise',0),(423517,11765,'si','Zakup je bil prekinjen',0),(423518,11765,'ba','Sewa telah berakhir',0),(423519,11765,'nl','Lease-overeenkomst is beÃ«indigd',0),(423520,11765,'fi','Vuokrasopimus on pÃ¤Ã¤ttynyt',0),(423521,11765,'no','Leieavtalen er avsluttet',0),(423522,11765,'da','LejemÃ¥let er blevet opsagt',0),(423523,11765,'ko','ìž„ëŒ€ ì¢…ë£Œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(423524,11765,'he','×©×›×™×¨×•×ª ×”×•×¤×¡×§×”',0),(423525,11765,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î­Ï‡ÎµÎ¹ Ï„ÎµÏÎ¼Î±Ï„Î¹ÏƒÏ„ÎµÎ¯',0),(423526,11765,'zh','å·²ç»ˆæ­¢ç§Ÿèµ\r\n',0),(423527,11765,'sv','Hyresavtal har upphÃ¶rt',0),(423528,11765,'it','Contratto di locazione Ã¨ stata terminata',0),(423529,11765,'tl','',0),(423530,11765,'th','à¹€à¸Šà¹ˆà¸²à¸–à¸¹à¸à¸¢à¸à¹€à¸¥à¸´à¸',0),(423531,11765,'hi','à¤ªà¤Ÿà¥à¤Ÿà¤¾ à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(423532,11765,'ms','Pajakan telah ditamatkan',0),(423533,11765,'ar','ØªÙ… Ø¥Ù†Ù‡Ø§Ø¡ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(423534,11765,'fr','Bail a Ã©tÃ© rÃ©siliÃ©',0),(423535,11765,'jp','ãƒªãƒ¼ã‚¹ãŒçµ‚äº†ã—ã¾ã—ãŸ',0),(423536,11765,'pt','Contrato tenha sido rescindido.',0),(423537,11765,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‰ÐµÐ½Ð°',0),(423538,11765,'es','Contrato de Arrendamiento se TÃ©rmino',0),(423539,11765,'de','Mietvertrag wurde beendet',0),(423540,11765,'en','Lease Has Been Terminated',0),(423541,11766,'is','',0),(423542,11766,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(423543,11766,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù…Ù†ØªÙ‚Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(423544,11766,'tr','Kira aktarmÄ±ÅŸtÄ±r.',0),(423545,11766,'pl','Umowy najmu zostaÅ‚y przekazane',0),(423546,11766,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ðµ Ð±Ð¸Ð»Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÐµÐ½Ð°',0),(423547,11766,'ur','Ù„ÛŒØ² Ú©Ùˆ Ø³ÙˆÙ†Ù¾ÛŒ Ú¯Ø¦ÛŒ ÛÛ’',0),(423548,11766,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð¿Ñ€ÐµÐ±Ð°Ñ‡ÐµÐ½Ð°',0),(423549,11766,'vi','Há»£p Ä‘á»“ng thuÃª Ä‘Ã£ Ä‘Æ°á»£c chuyá»ƒn giao',0),(423550,11766,'af','Huurooreenkoms is Oorgedra',0),(423551,11766,'ro','Contract de leasing a fost transferat',0),(423552,11766,'et','ÃœÃ¼rilepingu Ã¼le',0),(423553,11766,'si','Zakup je bil prenesen',0),(423554,11766,'ba','Sewa telah ditransfer',0),(423555,11766,'nl','Lease-overeenkomst is overgedragen',0),(423556,11766,'fi','Vuokrasopimus on siirretty',0),(423557,11766,'no','Leieavtalen er overfÃ¸rt',0),(423558,11766,'da','LejemÃ¥let har overfÃ¸rt',0),(423559,11766,'ko','ìž„ëŒ€ ì–‘ë„ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(423560,11766,'he','×©×›×™×¨×•×ª ×”×•×¢×‘×¨',0),(423561,11766,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î­Ï‡ÎµÎ¹ Î¼ÎµÏ„Î±Ï†ÎµÏÎ¸ÎµÎ¯',0),(423562,11766,'zh','ç§Ÿèµå·²è½¬ç§»\r\n',0),(423563,11766,'sv','Hyresavtalet har Ã¶verfÃ¶rts',0),(423564,11766,'it','Contratto di locazione Ã¨ stato trasferito',0),(423565,11766,'tl','',0),(423566,11766,'th','à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¸¡à¸µà¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(423567,11766,'hi','à¤²à¥€à¤œ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(423568,11766,'ms','Pajakan telah dipindahkan',0),(423569,11766,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ù†Ù‚Ù„ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(423570,11766,'fr','Bail a Ã©tÃ© transfÃ©rÃ©',0),(423571,11766,'jp','ãƒªãƒ¼ã‚¹ãŒè»¢é€ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(423572,11766,'pt','LocaÃ§Ã£o foi transferida',0),(423573,11766,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð±Ñ‹Ð»Ð° Ð¿ÐµÑ€ÐµÐ´Ð°Ð½Ð°',0),(423574,11766,'es','Contrato de Arrendamiento se TransferiÃ³',0),(423575,11766,'de','Leasing ist Ã¼bertragen worden',0),(423576,11766,'en','Lease Has Been Transferred',0),(423577,11767,'is','',0),(423578,11767,'dr','Ø¢Ø¯Ø± Ø³ ÙØ¹Ù„ÙŠ ',0),(423579,11767,'pr','Ø¢Ø¯Ø± Ø³ ÙØ¹Ù„ÙŠ ',0),(423580,11767,'tr','GeÃ§erli adresi',0),(423581,11767,'pl','Aktualny adres',0),(423582,11767,'bg','ÐÐ°ÑÑ‚Ð¾ÑÑ‰ Ð°Ð´Ñ€ÐµÑ',0),(423583,11767,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ù¾ØªÛ',0),(423584,11767,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð°Ð´Ñ€ÐµÑÐ°',0),(423585,11767,'vi','Äá»‹a chá»‰ hiá»‡n táº¡i',0),(423586,11767,'af','Huidige Adres',0),(423587,11767,'ro','Adresa curentÄƒ',0),(423588,11767,'et','Praegune aadress',0),(423589,11767,'si','Trenutni naslov',0),(423590,11767,'ba','Alamat sekarang',0),(423591,11767,'nl','Huidige adres',0),(423592,11767,'fi','Nykyinen osoite',0),(423593,11767,'no','Gjeldende adresse',0),(423594,11767,'da','NuvÃ¦rende adresse',0),(423595,11767,'ko','í˜„ìž¬ ì£¼ì†Œ',0),(423596,11767,'he','×›×ª×•×‘×ª × ×•×›×—×™×ª',0),(423597,11767,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(423598,11767,'zh','å½“å‰åœ°å€\r\n',0),(423599,11767,'sv','Nuvarande adress',0),(423600,11767,'it','Indirizzo attuale',0),(423601,11767,'tl','',0),(423602,11767,'th','à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(423603,11767,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ªà¤¤à¤¾',0),(423604,11767,'ms','Alamat semasa',0),(423605,11767,'ar','Ø§Ù„Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(423606,11767,'fr','Adresse actuelle',0),(423607,11767,'jp','ç¾åœ¨ã®ã‚¢ãƒ‰ãƒ¬ã‚¹',0),(423608,11767,'pt','EndereÃ§o atual',0),(423609,11767,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð°Ð´Ñ€ÐµÑ',0),(423610,11767,'es','DirecciÃ³n Actual',0),(423611,11767,'de','Aktuelle Adresse',0),(423612,11767,'en','Current Address',0),(423613,11768,'is','',0),(423614,11768,'dr','Ø¢Ø¯Ø±Ø³ Ø¯Ø§Ø¦Ù… ',0),(423615,11768,'pr','Ø¢Ø¯Ø±Ø³ Ø¯Ø§Ø¦Ù… ',0),(423616,11768,'tr','KalÄ±cÄ± adresi',0),(423617,11768,'pl','StaÅ‚y adres',0),(423618,11768,'bg','ÐŸÐ¾ÑÑ‚Ð¾ÑÐ½ÐµÐ½ Ð°Ð´Ñ€ÐµÑ',0),(423619,11768,'ur','Ù…Ø³ØªÙ‚Ù„ Ù¾ØªÛ',0),(423620,11768,'sr','Ð¡Ñ‚Ð°Ð»Ð½Ð° Ð°Ð´Ñ€ÐµÑÐ°',0),(423621,11768,'vi','VÄ©nh viá»…n Ä‘á»‹a chá»‰',0),(423622,11768,'af','Permanente adres',0),(423623,11768,'ro','Adresa permanentÄƒ',0),(423624,11768,'et','Alaline aadress',0),(423625,11768,'si','Stalni naslov',0),(423626,11768,'ba','Alamat permanen',0),(423627,11768,'nl','Woonplaats',0),(423628,11768,'fi','PysyvÃ¤ osoite',0),(423629,11768,'no','Fast adresse',0),(423630,11768,'da','Permanent adresse',0),(423631,11768,'ko','ì˜êµ¬ ì£¼ì†Œ',0),(423632,11768,'he','×›×ª×•×‘×ª ×§×‘×•×¢×”',0),(423633,11768,'el','ÎœÏŒÎ½Î¹Î¼Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(423634,11768,'zh','æ°¸ä¹…åœ°å€\r\n',0),(423635,11768,'sv','Permanent adress',0),(423636,11768,'it','Indirizzo permanente',0),(423637,11768,'tl','',0),(423638,11768,'th','à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸–à¸²à¸§à¸£',0),(423639,11768,'hi','à¤¸à¥à¤¥à¤¾à¤¯à¥€ à¤ªà¤¤à¤¾',0),(423640,11768,'ms','Alamat tetap',0),(423641,11768,'ar','Ø¹Ù†ÙˆØ§Ù† Ø¯Ø§Ø¦Ù…',0),(423642,11768,'fr','Adresse permanente',0),(423643,11768,'jp','æ’ä¹…ã‚¢ãƒ‰ãƒ¬ã‚¹',0),(423644,11768,'pt','EndereÃ§o permanente',0),(423645,11768,'ru','ÐŸÐ¾ÑÑ‚Ð¾ÑÐ½Ð½Ñ‹Ð¹ Ð°Ð´Ñ€ÐµÑ',0),(423646,11768,'es','DirecciÃ³n Permanente',0),(423647,11768,'de','Permanente Adresse',0),(423648,11768,'en','Permanent Address',0),(423649,11769,'is','',0),(423650,11769,'dr','( Ø¨Ù‡ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø«Ø§Ø¨Øª',0),(423651,11769,'pr','Ù…Ø§Ù†Ù†Ø¯ Ø¯Ø§Ø¦Ù…( Ø¨Ù‡ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ø«Ø§Ø¨Øª',0),(423652,11769,'tr','SÃ¼rekli olarak aynÄ±',0),(423653,11769,'pl','Tak samo jak staÅ‚e',0),(423654,11769,'bg','Ð¡ÑŠÑ‰Ð¾Ñ‚Ð¾ ÐºÐ°Ñ‚Ð¾ Ð¿Ð¾ÑÑ‚Ð¾ÑÐ½Ð½Ð¸',0),(423655,11769,'ur','ÙˆÛÛŒ Ù…Ø³ØªÙ‚Ù„ Ø·ÙˆØ± Ù¾Ø±',0),(423656,11769,'sr','Ð˜ÑÑ‚Ð¾ ÐºÐ°Ð¾ Ð¸ ÑÑ‚Ð°Ð»Ð½Ð¸',0),(423657,11769,'vi','Giá»‘ng nhÆ° thÆ°á»ng trá»±c',0),(423658,11769,'af','Dieselfde as permanente',0),(423659,11769,'ro','Fel ca Permanent',0),(423660,11769,'et','Sama pÃ¼siva',0),(423661,11769,'si','Enako kot trajna',0),(423662,11769,'ba','Sama seperti permanen',0),(423663,11769,'nl','Hetzelfde als Permanent',0),(423664,11769,'fi','Sama kuin pysyvÃ¤',0),(423665,11769,'no','Samme som Permanent',0),(423666,11769,'da','Samme som Permanent',0),(423667,11769,'ko','ì˜êµ¬ì™€ ë™ì¼',0),(423668,11769,'he','×‘×“×™×•×§ ×›×ž×• ×§×‘×•×¢',0),(423669,11769,'el','ÎŠÎ´Î¹Î¿ Î¼Îµ Î¼ÏŒÎ½Î¹Î¼Î¿',0),(423670,11769,'zh','å¸¸é©»ç›¸åŒ\r\n',0),(423671,11769,'sv','Samma som Permanent',0),(423672,11769,'it','Stesso come permanente',0),(423673,11769,'tl','',0),(423674,11769,'th','à¹€à¸«à¸¡à¸·à¸­à¸™à¸–à¸²à¸§à¸£',0),(423675,11769,'hi','à¤¸à¥à¤¥à¤¾à¤¯à¥€ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¹à¥€',0),(423676,11769,'ms','Sama seperti tetap',0),(423677,11769,'ar','Ù†ÙØ³ Ø§Ù„Ø¯Ø§Ø¦Ù…',0),(423678,11769,'fr','MÃªme que Permanent',0),(423679,11769,'jp','æ°¸ä¹…ã¨åŒã˜',0),(423680,11769,'pt','Mesmo como permanente',0),(423681,11769,'ru','Ð¢Ð°Ðº Ð¶Ðµ, ÐºÐ°Ðº Ð¿Ð¾ÑÑ‚Ð¾ÑÐ½Ð½Ð¾Ð³Ð¾',0),(423682,11769,'es','Lo Mismo de Permanente',0),(423683,11769,'de','Gleich bleibende',0),(423684,11769,'en','Same as Permanent',0),(423685,11770,'is','',0),(423686,11770,'dr','/ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª / Ù…Ø¹Ø§Ù Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª ',0),(423687,11770,'pr','Ù…Ø¨Ø§Ù„Øº ÙƒÙ„ ØªÙ…Ø§Ù… Ø­ÙˆØ²Ù‡ Ù‡Ø§ÙŠ Ù…Ø§Ù„ÙŠØ§ØªÙŠ Ù…Ø§Ù„ÙŠØ§Øª/ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÙŠØ§Øª / Ù…Ø¹Ø§Ù Ø§Ø² Ù…Ø§Ù„ÙŠØ§Øª ',0),(423688,11770,'tr','Grand toplam tÃ¼m vergi bÃ¶lgeleri vergi muafiyet / vergiye tabi',0),(423689,11770,'pl','Grand Total All podatku okrÄ™gÃ³w podatkowych podatnika / zwolniony',0),(423690,11770,'bg','Ð“Ñ€Ð°Ð½Ð´ Ð¾Ð±Ñ‰Ð¾ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸ Ð´Ð°Ð½ÑŠÐº / Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð° / Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ñ‚',0),(423691,11770,'ur','Ú¯Ø±ÛŒÙ†Úˆ Ú©Ù„ ØªÙ…Ø§Ù… Ù¹ÛŒÚ©Ø³ Ø§Ø¶Ù„Ø§Ø¹ Ù¹ÛŒÚ©Ø³ Ø¹Ø§Ø¦Ø¯ / Ù…Ø³ØªØ«Ù†ÛŒ',0),(423692,11770,'sr','Ð£Ð±Ð¸Ñ€Ð°Ñ‚Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð·Ð° Ð“Ñ€Ð°Ð½Ð´ ÑƒÐºÑƒÐ¿Ð½Ð¾ ÑÐ²Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ð° / Ð¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸ / Ð¸Ð·ÑƒÐ·ÐµÑ‚Ð¸',0),(423693,11770,'vi','T.ng c.ng t.t c. thu. Thu. huy.n / ch.u thu. / mi.n thu.',0),(423694,11770,'af','Grand totaal alle belasting distrikte belasting belasbare / as vrygestelde',0),(423695,11770,'ro','Grand Total toate fiscale districte fiscal impozabil / scutite',0),(423696,11770,'et','Grand kokku kÃµik maksu linnaosades maksu maksustatava / maksuvaba',0),(423697,11770,'si','Grand Total vse davÄne okraje davka oproÅ¡Äeno / davÄni',0),(423698,11770,'ba','Grand Total semua pajak Kabupaten pajak kena pajak / dibebaskan',0),(423699,11770,'nl','Grand totaal All belasting districten belasting belastbare / vrijgesteld',0),(423700,11770,'fi','Grand yhteensÃ¤ kaikki vero piirit vero / Verolliset / vapauttaa',0),(423701,11770,'no','Grand totalt All skatt distrikter skatt skattepliktig / fritatt',0),(423702,11770,'da','Grand Total alle skat distrikter skatte / afgiftspligtig / undtaget',0),(423703,11770,'ko','ê·¸ëžœë“œ ì´ ëª¨ë“  ì„¸ê¸ˆ ì§€êµ¬ ì„¸ê¸ˆ ê³¼ì„¸ / ë©´ì œ',0),(423704,11770,'he','×’×¨× ×“ ×¡×š ×›×œ ×”×ž×¡ ×ž×—×•×–×•×ª ×ž×¡ / ×—×™×™×‘ ×‘×ž×¡ / ×¤×˜×•×¨',0),(423705,11770,'el','Grand ÏƒÏÎ½Î¿Î»Î¿ ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ Î½Î¿Î¼ÏŽÎ½ Ï†ÏŒÏÎ¿Ï… Ï†ÏŒÏÎ¿Ï‚ / Ï†Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­Î¿ / Î±Ï€Î±Î»Î»Î¬ÏƒÏƒÎ¿Î½Ï„Î±Î¹',0),(423706,11770,'zh','æ€»è®¡æ‰€æœ‰ç¨Žæ”¶åŒºç¨Ž/åº”ç¨Ž/å…ç¨Ž\r\n',0),(423707,11770,'sv','Grand totalt All skatt distrikt skatt / skattepliktiga / undantagna',0),(423708,11770,'it','Grand totale All fiscale distretti fiscali / imponibili / esenti',0),(423709,11770,'tl','',0),(423710,11770,'th','à¹€à¸‚à¸•à¸ à¸²à¸©à¸µà¹‚à¸£à¸‡à¸£à¸§à¸¡à¸—à¸±à¹‰à¸‡à¸ à¸²à¸©à¸µà¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µ / à¸¢à¸à¹€à¸§à¹‰à¸™',0),(423711,11770,'hi','à¤­à¤µà¥à¤¯ à¤•à¥à¤² à¤¸à¤­à¥€ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤œà¤¿à¤²à¥‡ à¤Ÿà¥ˆà¤•à¥à¤¸ / à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯ / à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(423712,11770,'ms','Grand Total semua cukai Daerah cukai / cukai / dikecualikan',0),(423713,11770,'ar','Ø¬Ø±Ø§Ù†Ø¯ Ù…Ø¬Ù…ÙˆØ¹ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…Ù‚Ø§Ø·Ø¹Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©/Ø¥Ø¹ÙØ§Ø¡',0),(423714,11770,'fr','Grand Total toute taxe Districts fiscaux / imposable / exonÃ©rÃ©',0),(423715,11770,'jp','ã‚°ãƒ©ãƒ³ãƒ‰åˆè¨ˆã™ã¹ã¦ã®ç¨Žåœ°åŒºç¨Žèª²ç¨Ž/éžèª²ç¨Ž',0),(423716,11770,'pt','Grand Total todos os distritos de imposto Imposto tributÃ¡vel / isento',0),(423717,11770,'ru','Ð“Ñ€Ð°Ð½Ð´ Ð²ÑÐµÐ³Ð¾ Ð²ÑÐµÑ… Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ñ… Ð¾ÐºÑ€ÑƒÐ³Ð¾Ð² Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼ / Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ñ‹',0),(423718,11770,'es','Total general de todos los impuestos fiscales Distritos / pasivos / exento',0),(423719,11770,'de','Grand Total All Steuer Bezirke Steuer / Steuerpflichtige / befreit',0),(423720,11770,'en','Grand Total All Tax Districts Tax / Taxable / Exempt',0),(423721,11771,'is','',0),(423722,11771,'dr','ÙÙ‚Ø· ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ø¨Ø§ Ù…Ø§Ù„ÙŠØ§Øª ',0),(423723,11771,'pr','ÙÙ‚Ø· ÙØ§ÙƒØªÙˆØ±Ù‡Ø§ Ø¨Ø§ Ù…Ø§Ù„ÙŠØ§Øª ',0),(423724,11771,'tr','Sadece faturalar vergi grubu',0),(423725,11771,'pl','Tylko faktury z podatku',0),(423726,11771,'bg','Ð¡Ð°Ð¼Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ñ Ð´Ð°Ð½ÑŠÐº',0),(423727,11771,'ur','ØµØ±Ù Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø³Ø§ØªÚ¾ ÙˆØ¨Ø¬Ù„ÛŒ',0),(423728,11771,'sr','Ð¡Ð°Ð¼Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÑÐ° ÐŸÐ”Ð’',0),(423729,11771,'vi','Chá»‰ hÃ³a Ä‘Æ¡n cÃ³ thuáº¿',0),(423730,11771,'af','Slegs fakture met belasting',0),(423731,11771,'ro','Numai facturile cu taxa',0),(423732,11771,'et','Ainult arvete kÃ¤ibemaks',0),(423733,11771,'si','Samo raÄune z davÄnimi',0),(423734,11771,'ba','Hanya tagihan dengan pajak',0),(423735,11771,'nl','Alleen facturen met belasting',0),(423736,11771,'fi','Vain laskut verollinen',0),(423737,11771,'no','Bare fakturaer med skatt',0),(423738,11771,'da','Kun fakturaer med skat',0),(423739,11771,'ko','ì„¸ê¸ˆ ì „ìš© ì†¡ìž¥',0),(423740,11771,'he','×¨×§ ×—×©×‘×•× ×™×•×ª ×¢× ×ž×¡',0),(423741,11771,'el','ÎœÏŒÎ½Î¿ Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î¼Îµ Ï†ÏŒÏÎ¿',0),(423742,11771,'zh','åªæœ‰ç¨Žæ”¶å‘ç¥¨\r\n',0),(423743,11771,'sv','Endast fakturor med skatt',0),(423744,11771,'it','Solo le fatture con imposta',0),(423745,11771,'tl','',0),(423746,11771,'th','à¹€à¸‰à¸žà¸²à¸°à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸žà¸£à¹‰à¸­à¸¡à¸ à¸²à¸©à¸µ',0),(423747,11771,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¹à¥€ à¤šà¤¾à¤²à¤¾à¤¨',0),(423748,11771,'ms','Hanya invois dengan cukai',0),(423749,11771,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± ÙÙ‚Ø· Ù…Ø¹ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(423750,11771,'fr','Seules les factures avec taxe',0),(423751,11771,'jp','ç¨Žè«‹æ±‚æ›¸ã®ã¿',0),(423752,11771,'pt','Apenas facturas com imposto',0),(423753,11771,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¡Ñ‡ÐµÑ‚Ð° Ñ ÐÐ°Ð»Ð¾Ð³Ð¾Ð¼',0),(423754,11771,'es','Sólo con facturas fiscales',0),(423755,11771,'de','Nur Rechnungen mit MwSt.',0),(423756,11771,'en','Only Invoices with Tax',0),(423757,11772,'is','',0),(423758,11772,'dr','.... Ùˆ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ ....  Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(423759,11772,'pr','Ø¨Ø§ÙŠØ¯ Ø§Ø².... Ùˆ Ø¨Ù‡ Ø¢Ø¯Ø±Ø³ ....  Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(423760,11772,'tr','Dan ve adreslerine sahip olmalÄ±dÄ±r',0),(423761,11772,'pl','Musi mieÄ‡ od i adresy',0),(423762,11772,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð¾Ñ‚ Ð¸ Ð´Ð¾ Ð°Ð´Ñ€ÐµÑÐ¸Ñ‚Ðµ',0),(423763,11772,'ur','Ø§ÙˆØ± Ù¾ØªÙˆÚº Ø³Û’ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(423764,11772,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð¾Ð´ Ð¸ Ð´Ð¾ Ð°Ð´Ñ€ÐµÑÐµ',0),(423765,11772,'vi','Pháº£i cÃ³ Ä‘á»‹a chá»‰ gá»­i vÃ  nháº­n',0),(423766,11772,'af','Moet hÃª van en na adresse',0),(423767,11772,'ro','Trebuie sÄƒ aibÄƒ la ÅŸi de la adrese',0),(423768,11772,'et','Peab olema ja aadressid',0),(423769,11772,'si','Mora imeti od in naslove',0),(423770,11772,'ba','Harus dari dan ke alamat',0),(423771,11772,'nl','Moet hebben van en naar adressen',0),(423772,11772,'fi','Ja osoitteet',0),(423773,11772,'no','MÃ¥ ha fra og til adresser',0),(423774,11772,'da','Skal Have fra og til-adresser',0),(423775,11772,'ko','ì£¼ì†Œë¥¼ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(423776,11772,'he','×—×™×™×‘ ×œ×”×™×•×ª ×•×ž×”×Ÿ ×›×ª×•×‘×•×ª',0),(423777,11772,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î±Ï€ÏŒ ÎºÎ±Î¹ Ï€ÏÎ¿Ï‚ Ï„Î¹Ï‚ Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚',0),(423778,11772,'zh','å¿…é¡»å‘ä»¶äººå’Œæ”¶ä»¶äººåœ°å€\r\n',0),(423779,11772,'sv','MÃ¥ste ha frÃ¥n och till adresser',0),(423780,11772,'it','Deve avere da e per gli indirizzi',0),(423781,11772,'tl','',0),(423782,11772,'th','à¸•à¹‰à¸­à¸‡à¸ˆà¸²à¸ à¹à¸¥à¸°à¹„à¸› à¸¢à¸±à¸‡à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆ',0),(423783,11772,'hi','à¤ªà¤¤à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤”à¤° à¤¸à¥‡ à¤ªà¤¾à¤¸ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(423784,11772,'ms','Mesti dari dan ke alamat',0),(423785,11772,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ù…Ù† ÙˆØ¥Ù„Ù‰ Ø¹Ù†Ø§ÙˆÙŠÙ†',0),(423786,11772,'fr','Doit avoir d\'et vers des adresses',0),(423787,11772,'jp','ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(423788,11772,'pt','Deve ter de e para endereÃ§os',0),(423789,11772,'ru','Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð¸Ð¼ÐµÑ‚ÑŒ Ð¾Ñ‚ Ð¸ Ð´Ð¾ Ð°Ð´Ñ€ÐµÑÐ°',0),(423790,11772,'es','Debe Tener Direcciones Desde y A',0),(423791,11772,'de','Ab und an Adressen mÃ¼ssen',0),(423792,11772,'en','Must Have From And To Addresses',0),(423793,11773,'is','',0),(423794,11773,'dr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ±Ø²Ù†Ø¯ Ø§Ø² Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§',0),(423795,11773,'pr','Ù…Ø³Ø¯ÙˆØ¯ ÙƒØ±Ø¯Ù† ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ ÙØ±Ø²Ù†Ø¯ Ø§Ø² Ø¬Ø³ØªØ¬ÙˆÙŠ ÙƒØ§Ù„Ø§',0),(423796,11773,'tr','Blok alt Ã¶ÄŸeleri Ã¶ÄŸe arama',0),(423797,11773,'pl','ZablokowaÄ‡ elementy podrzÄ™dnoÅ›Ä‡ z pozycji wyszukiwania',0),(423798,11773,'bg','Ð‘Ð»Ð¾Ðº Ð´ÑŠÑ‰ÐµÑ€Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(423799,11773,'ur','Ø¨Ù„Ø§Ú© Ø¨Ú†Û Ø§Ø´ÛŒØ§Ø¡ Ø´Û’ Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(423800,11773,'sr','Ð‘Ð»Ð¾Ðº Ð¿Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¸Ð· Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(423801,11773,'vi','Cháº·n tráº» em  cÃ¡c háº¡n má»¥c tá»« cÃ´ng cá»¥ dÃ² tÃ¬m',0),(423802,11773,'af','Blok kind Items uit Item opsoek',0),(423803,11773,'ro','Bloc elemente copil din element de cÄƒutare',0),(423804,11773,'et','Blokeerida lapse Ã¼ksused Ã¼ksuse otsing',0),(423805,11773,'si','Blok podrejene elemente iz iskalni element',0),(423806,11773,'ba','Blok anak item dari Item Lookup',0),(423807,11773,'nl','Blok kind Items uit de Item Lookup',0),(423808,11773,'fi','EstÃ¤Ã¤ alikohdetta kohteen haku',0),(423809,11773,'no','Blokkere underordnede elementer fra Vareoppslaget',0),(423810,11773,'da','Blok barn elementer fra Vareopslaget',0),(423811,11773,'ko','í•­ëª© ì¡°íšŒì—ì„œ ìžì‹ í•­ëª©ì„ ì°¨ë‹¨',0),(423812,11773,'he','×œ×—×¡×•× ××ª ×”×™×œ×“ ×¤×¨×™×˜×™× ×ž×ª×•×š ×¤×¨×™×˜ ×—×™×¤×•×©',0),(423813,11773,'el','ÎœÏ€Î»Î¿Îº Î¸Ï…Î³Î±Ï„ÏÎ¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Ï€ÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(423814,11773,'zh','å°é”ä»Žé¡¹ç›®çš„å­é¡¹æŸ¥æ‰¾\r\n',0),(423815,11773,'sv','Blockera barnet objekt frÃ¥n ArtikelsÃ¶kningen',0),(423816,11773,'it','Elementi figlio di blocco da elemento Lookup',0),(423817,11773,'tl','',0),(423818,11773,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸¥à¸¹à¸à¸šà¸¥à¹‡à¸­à¸à¸ˆà¸²à¸à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(423819,11773,'hi','à¤¬à¥à¤²à¥‰à¤• à¤šà¤¾à¤‡à¤²à¥à¤¡ à¤†à¤‡à¤Ÿà¤® à¤†à¤‡à¤Ÿà¤® à¤²à¥à¤•à¤…à¤ª à¤¸à¥‡',0),(423820,11773,'ms','Menyekat barangan kanak-kanak dari Item Lookup',0),(423821,11773,'ar','Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„Ø·ÙÙ„ ÙƒØªÙ„Ø© Ù…Ù† Ø¨Ø­Ø« Ø§Ù„Ø¨Ù†Ø¯',0),(423822,11773,'fr','Bloquer les Ã©lÃ©ments enfants de l\'Ã©lÃ©ment de recherche',0),(423823,11773,'jp','å­é …ç›®ã®é …ç›®å‚ç…§ã‚’ãƒ–ãƒ­ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(423824,11773,'pt','Bloquear itens filho do Item pesquisa',0),(423825,11773,'ru','Ð‘Ð»Ð¾Ðº Ð´Ð¾Ñ‡ÐµÑ€Ð½Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ð¾Ð¸ÑÐºÐ° Ð²',0),(423826,11773,'es','Bloquea Articulos de NiÃ±os de la Busqueda',0),(423827,11773,'de','Block untergeordnete Elemente des Elements Lookup',0),(423828,11773,'en','Block Child Items From Item Lookup',0),(423829,11774,'is','',0),(423830,11774,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(423831,11774,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(423832,11774,'tr','Ä°Ã§in geri Ã¶deme tutarÄ±',0),(423833,11774,'pl','Kwota do zwrotu',0),(423834,11774,'bg','Ð’ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½ÐµÑ‚Ð¾',0),(423835,11774,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©ÛŒ Ø±Ù‚Ù…',0),(423836,11774,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°',0),(423837,11774,'vi','Sá»‘ tiá»n hoÃ n tráº£',0),(423838,11774,'af','Terugbetaling beloop',0),(423839,11774,'ro','Suma de restituire',0),(423840,11774,'et','Toetuse suurus',0),(423841,11774,'si','ZnaÅ¡ajo nadomestila',0),(423842,11774,'ba','Jumlah pengembalian uang',0),(423843,11774,'nl','Oplopen tot restitutie',0),(423844,11774,'fi','Tuen mÃ¤Ã¤rÃ¤',0),(423845,11774,'no','BelÃ¸p til tilbakebetaling',0),(423846,11774,'da','BelÃ¸be sig til restitution',0),(423847,11774,'ko','í™˜ë¶ˆ ê¸ˆì•¡',0),(423848,11774,'he','×¡×›×•× ×”×”×—×–×¨',0),(423849,11774,'el','Î™ÏƒÎ¿Î´Ï…Î½Î±Î¼ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(423850,11774,'zh','é€€è¿˜é‡‘é¢\r\n',0),(423851,11774,'sv','UppgÃ¥ till Ã¥terbetalning',0),(423852,11774,'it','L\'importo di rimborso',0),(423853,11774,'tl','',0),(423854,11774,'th','à¸¢à¸­à¸”à¸à¸²à¸£à¸„à¸·à¸™à¹€à¸‡à¸´à¸™',0),(423855,11774,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¾à¤¶à¤¿',0),(423856,11774,'ms','Jumlah bayaran balik',0),(423857,11774,'ar','Ø¨Ù…Ø«Ø§Ø¨Ø© Ø±Ø¯',0),(423858,11774,'fr','Le montant de remboursement',0),(423859,11774,'jp','æ‰•ã„æˆ»ã—é¡ã—ã¾ã™ã€‚',0),(423860,11774,'pt','Quantidade de reembolso',0),(423861,11774,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð²Ð¾Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ñ',0),(423862,11774,'es','Cantidad para Devolver',0),(423863,11774,'de','Belaufen sich auf Erstattung',0),(423864,11774,'en','Amount To Refund',0),(423865,11775,'is','',0),(423866,11775,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ±Ø§ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ø§Ø³Øª ',0),(423867,11775,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ±Ø§ØªØ± Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø³ØªØ§Ù†ÙƒØ§Ø±ÙŠ Ø§Ø³Øª ',0),(423868,11775,'tr','Geri Ã¶deme iÃ§in kredi miktarÄ± aÅŸÄ±yor',0),(423869,11775,'pl','Kwota zwrotu przekracza kwotÄ™ kredytu',0),(423870,11775,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð°Ð´Ñ…Ð²ÑŠÑ€Ð»Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÑÑƒÐ¼Ð°',0),(423871,11775,'ur','Ø±Ù‚Ù… Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©Û’ Ù„Ø¦Û’ Ú©Ø±ÛŒÚˆÙ¹ Ù…Ù‚Ø¯Ø§Ø± Ø³Û’ ØªØ¬Ø§ÙˆØ² Ú©Ø±ØªÛŒ ÛÛ’ Û”',0),(423872,11775,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð° Ð¿Ñ€ÐµÐ¼Ð°ÑˆÑƒÑ˜Ðµ Ð¸Ð·Ð½Ð¾Ñ Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(423873,11775,'vi','Sá»‘ tiá»n Äá»ƒ HoÃ n VÆ°á»£t Sá»‘ tiá»n tÃ­n dá»¥ng',0),(423874,11775,'af','Terugbetaling bedrag krediet bedrag oorskry',0),(423875,11775,'ro','Suma de rambursare depÄƒÅŸeÅŸte valoarea creditului',0),(423876,11775,'et','Toetuse summa Ã¼letab kreeditsumma',0),(423877,11775,'si','Znesek vraÄila presega znesek kredita',0),(423878,11775,'ba','Jumlah pengembalian melebihi jumlah kredit',0),(423879,11775,'nl','Bedrag aan restitutie hoger is dan creditbedrag',0),(423880,11775,'fi','Tuen mÃ¤Ã¤rÃ¤ ylittÃ¤Ã¤ kredit-summa',0),(423881,11775,'no','BelÃ¸pet til refusjon overskrider kredittbelÃ¸pet',0),(423882,11775,'da','Til tilbagebetaling overstiger kreditbelÃ¸b',0),(423883,11775,'ko','ì‹ ìš© ê¸ˆì•¡ì„ ì´ˆê³¼ í•˜ëŠ” ê¸ˆì•¡ì„ í™˜ë¶ˆ',0),(423884,11775,'he','×¡×›×•× ×”×”×—×–×¨ ×¢×•×œ×” ×¢×œ ×¡×›×•× ×”×–×™×›×•×™',0),(423885,11775,'el','Î ÏÎ¿Ï‚ ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Ï€Î¿ÏƒÏŒ Ï…Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ Ï€Î¿ÏƒÏŒ Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚',0),(423886,11775,'zh','é‡‘é¢é€€è¿˜è¶…å‡ºä¿¡ç”¨é‡‘é¢\r\n',0),(423887,11775,'sv','Att bidraget Ã¶verstiger kreditbelopp',0),(423888,11775,'it','Importo a rimborso supera l\'importo del credito',0),(423889,11775,'tl','',0),(423890,11775,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸„à¸·à¸™à¹€à¸à¸´à¸™à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¹€à¸„à¸£à¸”à¸´à¸•',0),(423891,11775,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¾à¤¶à¤¿ à¤‹à¤£ à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¹à¥ˆ',0),(423892,11775,'ms','Amaun bayaran balik melebihi jumlah kredit',0),(423893,11775,'ar','ØªØ¬Ø§ÙˆØ² Ø§Ù„Ù…Ø¨Ù„Øº Ù„Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ù…Ø¨Ù„Øº Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(423894,11775,'fr','Montant de remboursement dÃ©passe le montant du crÃ©dit',0),(423895,11775,'jp','æ‰•ã„æˆ»ã—é¡ãŒã‚¯ãƒ¬ã‚¸ãƒƒãƒˆé‡‘é¡ã‚’è¶…ãˆã‚‹',0),(423896,11775,'pt','Quantidade de reembolso exceda o montante de crÃ©dito',0),(423897,11775,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð²Ð¾Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ñ Ð¿Ñ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ ÑÑƒÐ¼Ð¼Ñƒ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(423898,11775,'es','Cantidad para Devolver Excede el Monto de CrÃ©dito',0),(423899,11775,'de','Erstattung Ã¼bersteigt Habenbetrag',0),(423900,11775,'en','Amount To Refund Exceeds Credit Amount',0),(423901,11776,'is','',0),(423902,11776,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù…Ø­Ù„',0),(423903,11776,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ÙŠÙƒ Ù…Ø­Ù„',0),(423904,11776,'tr','Bir konum seÃ§in',0),(423905,11776,'pl','Wybierz lokalizacjÄ™',0),(423906,11776,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(423907,11776,'ur','Ø§ÛŒÚ© Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(423908,11776,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(423909,11776,'vi','Chá»n má»™t Ä‘á»‹a Ä‘iá»ƒm',0),(423910,11776,'af','Kies \'n ligging',0),(423911,11776,'ro','SelectaÅ£i o locaÅ£ie',0),(423912,11776,'et','Asukoha valimine',0),(423913,11776,'si','Izberite mesto',0),(423914,11776,'ba','Pilih lokasi',0),(423915,11776,'nl','Selecteer een locatie',0),(423916,11776,'fi','Valitse sijainti',0),(423917,11776,'no','Velg en plassering',0),(423918,11776,'da','VÃ¦lg en placering',0),(423919,11776,'ko','ìœ„ì¹˜ ì„ íƒ',0),(423920,11776,'he','×‘×—×¨ ×ž×™×§×•×',0),(423921,11776,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î¸Î­ÏƒÎ·',0),(423922,11776,'zh','é€‰æ‹©åœ°ç‚¹\r\n',0),(423923,11776,'sv','VÃ¤lj en plats',0),(423924,11776,'it','Selezionare una posizione',0),(423925,11776,'tl','',0),(423926,11776,'th','à¹€à¸¥à¸·à¸­à¸à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡',0),(423927,11776,'hi','à¤•à¤¿à¤¸à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(423928,11776,'ms','Memilih lokasi yang',0),(423929,11776,'ar','Ø­Ø¯Ø¯ Ù…ÙˆÙ‚Ø¹',0),(423930,11776,'fr','SÃ©lectionnez un emplacement',0),(423931,11776,'jp','å ´æ‰€ã‚’é¸æŠžã—ã¾ã™',0),(423932,11776,'pt','Selecione um local',0),(423933,11776,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(423934,11776,'es','Selecciona una UbicaciÃ³n',0),(423935,11776,'de','WÃ¤hlen Sie einen Speicherort',0),(423936,11776,'en','Select A Location',0),(423937,11777,'is','',0),(423938,11777,'dr','(Ù…Ù†ØªØ¸Ø±',0),(423939,11777,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¯Ù„Ø§Ø±Ù‡Ø§ Ø·Ø¨Ù‚ Ù„ÙŠØ³Øª Ø³ÙØ§Ø±Ø´ Ù…Ø¹ÙˆÙ‚(Ù…Ù†ØªØ¸Ø±',0),(423940,11777,'tr','Dolar Ã¼zerinde sipariÅŸ listesini gÃ¶ster.',0),(423941,11777,'pl','PokaÅ¼ dolarÃ³w na oczekiwaniu lista zleceÅ„',0),(423942,11777,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð´Ð¾Ð»Ð°Ñ€Ð° Ð½Ð° Ñ‡Ð°ÐºÐ°Ñ‰Ð¸ ÑÐ¿Ð¸ÑÑŠÐº Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(423943,11777,'ur','ÚˆØ§Ù„Ø± Ø§Ù„ØªÙˆØ§ Ø¢Ø±ÚˆØ± ÙÛØ±Ø³Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(423944,11777,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð´Ð¾Ð»Ð°Ñ€Ð° Ð½Ð° ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ Ð»Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(423945,11777,'vi','Thá»ƒ hiá»‡n tiá»n USD trÃªn danh sÃ¡ch Ä‘Æ¡n hÃ ng cÃ²n treo',0),(423946,11777,'af','Dollars wys op hangende bestellingslys',0),(423947,11777,'ro','AratÄƒ dolari pe Ã®n aÅŸteptare listÄƒ comandÄƒ',0),(423948,11777,'et','Kuva dollarit kuni hooldustellimuste loend',0),(423949,11777,'si','PokaÅ¾i dolarjev na ÄakajoÄe seznam nalogov',0),(423950,11777,'ba','Lihat dolar Pending Order daftar',0),(423951,11777,'nl','Toon Dollars op in afwachting van Orderlijst',0),(423952,11777,'fi','Osoittavat dollaria kunnes luettelo',0),(423953,11777,'no','Vis dollar pÃ¥ ventende rekkefÃ¸lgen',0),(423954,11777,'da','Vis Dollars pÃ¥ ventende Ordreoversigt',0),(423955,11777,'ko','ìˆœì„œ ëª©ë¡ì— ë³´ë¥˜ ì¤‘ì¸ ë‹¬ëŸ¬ í‘œì‹œ',0),(423956,11777,'he','×”×¦×’ ××ª ×“×•×œ×¨×™× ×¢×œ ×ž×ž×ª×™× ×™× ×¨×©×™×ž×ª ×¡×“×¨',0),(423957,11777,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î´Î¿Î»Î¬ÏÎ¹Î± ÏƒÎµ ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î® ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ½Ï„Î¿Î»ÏŽÎ½',0),(423958,11777,'zh','æ˜¾ç¤ºå¾…å®šè®¢å•åˆ—è¡¨ä¸Šçš„ç¾Žå…ƒ\r\n',0),(423959,11777,'sv','Visa dollar pÃ¥ avvaktan orderlista',0),(423960,11777,'it','Visualizza dollari su in attesa della lista ordini',0),(423961,11777,'tl','',0),(423962,11777,'th','à¹à¸ªà¸”à¸‡à¸”à¸­à¸¥à¸¥à¸²à¸£à¹Œà¸šà¸™à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(423963,11777,'hi','à¤¡à¥‰à¤²à¤° à¤²à¤‚à¤¬à¤¿à¤¤ à¤•à¥à¤°à¤® à¤¸à¥‚à¤šà¥€ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(423964,11777,'ms','Tunjuk dolar menunggu senarai pesanan',0),(423965,11777,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø¯ÙˆÙ„Ø§Ø± ÙÙŠ Ø§Ù†ØªØ¸Ø§Ø± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù†Ø¸Ø§Ù…',0),(423966,11777,'fr','Voir l\'Ã©tablissement Dollars sur en attente de la liste des commandes',0),(423967,11777,'jp','ä¿ç•™ä¸­ã®æ³¨æ–‡ãƒªã‚¹ãƒˆã«ãƒ‰ãƒ«ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(423968,11777,'pt','Visualizar dÃ³lares no pendente lista de ordem',0),(423969,11777,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð´Ð¾Ð»Ð»Ð°Ñ€Ð¾Ð² Ð½Ð° Ð¾Ð¶Ð¸Ð´Ð°Ð½Ð¸Ð¸ ÑÐ¿Ð¸ÑÐ¾Ðº Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(423970,11777,'es','Muestra DÃ³lares en la Lista de Ordenes Pendientes',0),(423971,11777,'de','Dollar auf ausstehende Bestellliste anzeigen',0),(423972,11777,'en','Show Dollars On Pending Order List',0),(423973,11778,'is','',0),(423974,11778,'dr','(Ø§Ù‚Ø³Ø§Ø·) Ù‡Ù†ÙˆØ² Ø·Ø¨Ù‚ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†ÙƒÙŠ Ù†ÙŠØ³ØªÙ†Ø¯ ',0),(423975,11778,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§(Ø§Ù‚Ø³Ø§Ø·) Ù‡Ù†ÙˆØ² Ø·Ø¨Ù‚ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†ÙƒÙŠ Ù†ÙŠØ³ØªÙ†Ø¯ ',0),(423976,11778,'tr','HenÃ¼z banka mevduat Ã¶demeleri',0),(423977,11778,'pl','PÅ‚atnoÅ›ci nie zostaÅ‚y jeszcze na przelew',0),(423978,11778,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð²ÑÐµ Ð¾Ñ‰Ðµ Ð¿Ð¾ Ð±Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(423979,11778,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ Ù¾Ø± Ø§Ø¨Ú¾ÛŒ Ù†ÛÛŒÚº',0),(423980,11778,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ð° Ñ˜Ð¾Ñˆ Ð½Ð¸Ñ˜Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(423981,11778,'vi','khoáº£n thanh toÃ¡n trÃªn tÃ i khoáº£n tiá»n gá»­i',0),(423982,11778,'af','Betalings Nog NIe op Bankdeposito',0),(423983,11778,'ro','PlÄƒÅ£ile nu sunt Ã®ncÄƒ pe depozit bancar',0),(423984,11778,'et','Makseid ei ole veel panka hoiule',0),(423985,11778,'si','PlaÄila Å¡e ni na banÄni depozit',0),(423986,11778,'ba','Pembayaran belum deposito Bank',0),(423987,11778,'nl','Betalingen nog niet op bankstorting',0),(423988,11778,'fi','Maksuja ei vielÃ¤ Bank Deposit',0),(423989,11778,'no','Betalinger ikke pÃ¥ bankinnskudd',0),(423990,11778,'da','Betalingerne endnu ikke pÃ¥ bankindbetaling',0),(423991,11778,'ko','ì•„ì§ ì€í–‰ ì˜ˆê¸ˆì— ëŒ€ í•œ ì§€ë¶ˆ',0),(423992,11778,'he','×ª×©×œ×•×ž×™× ×˜×¨× ×‘×¤×§×“×•×Ÿ ×‘×‘× ×§',0),(423993,11778,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Î´ÎµÎ½ Î­Ï‡Î¿Ï…Î½ Î±ÎºÏŒÎ¼Î· ÏƒÏ„Î¹Ï‚ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÎµ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(423994,11778,'zh','å°šæœªä»˜æ¬¾é“¶è¡Œè½¬å¸\r\n',0),(423995,11778,'sv','Betalningar Ã¤nnu inte pÃ¥ bankinsÃ¤ttning',0),(423996,11778,'it','Pagamenti non ancora sul deposito bancario',0),(423997,11778,'tl','',0),(423998,11778,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸˜à¸™à¸²à¸„à¸²à¸£à¸¢à¸±à¸‡à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(423999,11778,'hi','à¤¨à¤¹à¥€à¤‚ à¤…à¤­à¥€ à¤¤à¤• à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤ªà¤° à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(424000,11778,'ms','Bayaran belum lagi atas Bank Deposit',0),(424001,11778,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ù„ÙŠØ³Øª Ø¨Ø¹Ø¯ Ø¹Ù„Ù‰ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(424002,11778,'fr','Paiements non encore sur les dÃ©pÃ´ts bancaires',0),(424003,11778,'jp','ãŠæ”¯æ‰•ã„éŠ€è¡Œé é‡‘ã§ã¯ãªã„ã§ã™ã€‚',0),(424004,11778,'pt','Pagamentos ainda nÃ£o no depÃ³sito bancÃ¡rio',0),(424005,11778,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾ÐºÐ° Ð½Ðµ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(424006,11778,'es','Pagos Que Todavia  no Estan en los DepÃ³sitos Bancarios',0),(424007,11778,'de','Zahlungen noch nicht auf der Bank hinterlegen',0),(424008,11778,'en','Payments Not Yet On Bank Deposit',0),(424009,11779,'is','',0),(424010,11779,'dr','ÙƒØ§Ø±ÙØ±Ù…Ø§',0),(424011,11779,'pr','ÙƒØ§Ø±ÙØ±Ù…Ø§',0),(424012,11779,'tr','Ä°ÅŸveren',0),(424013,11779,'pl','Pracodawca',0),(424014,11779,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»',0),(424015,11779,'ur','Ø¢Ø¬Ø±',0),(424016,11779,'sr','ÐŸÐ¾ÑÐ»Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(424017,11779,'vi','NgÆ°á»i sá»­ dá»¥ng lao Ä‘á»™ng/ cÃ´ng ty',0),(424018,11779,'af','Werkgewer',0),(424019,11779,'ro','Angajator',0),(424020,11779,'et','TÃ¶Ã¶andja',0),(424021,11779,'si','Delodajalec',0),(424022,11779,'ba','Majikan',0),(424023,11779,'nl','Werkgever',0),(424024,11779,'fi','TyÃ¶nantajan',0),(424025,11779,'no','Arbeidsgiver',0),(424026,11779,'da','Arbejdsgiver',0),(424027,11779,'ko','ê³ ìš©ì£¼',0),(424028,11779,'he','×ž×¢×¡×™×§',0),(424029,11779,'el','Î•ÏÎ³Î¿Î´ÏŒÏ„Î·',0),(424030,11779,'zh','é›‡ä¸»\r\n',0),(424031,11779,'sv','Arbetsgivaren',0),(424032,11779,'it','Datore di lavoro',0),(424033,11779,'tl','',0),(424034,11779,'th','à¸™à¸²à¸¢à¸ˆà¹‰à¸²à¸‡',0),(424035,11779,'hi','à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾',0),(424036,11779,'ms','Majikan',0),(424037,11779,'ar','ØµØ§Ø­Ø¨ Ø§Ù„Ø¹Ù…Ù„',0),(424038,11779,'fr','Employeur',0),(424039,11779,'jp','é›‡ç”¨è€…',0),(424040,11779,'pt','Empregador',0),(424041,11779,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»ÑŒ',0),(424042,11779,'es','Patron',0),(424043,11779,'de','Arbeitgeber',0),(424044,11779,'en','Employer',0),(424045,11780,'is','',0),(424046,11780,'dr','NT Ø´Ù…Ø§Ø±Ù‡ Ù…Ø¹Ø§Ø´',0),(424047,11780,'pr','NT Ø´Ù…Ø§Ø±Ù‡ Ø­Ù‚ÙˆÙ‚',0),(424048,11780,'tr','NT Ã¶deme',0),(424049,11780,'pl','NT Pay',0),(424050,11780,'bg','NT Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(424051,11780,'ur','NT ØªÙ†Ø®ÙˆØ§Û',0),(424052,11780,'sr','ÐÐ¢ Ð¿Ð»Ð°Ñ‚Ðµ',0),(424053,11780,'vi','tráº£ NT',0),(424054,11780,'af','NT Besoldiging',0),(424055,11780,'ro','NT plata',0),(424056,11780,'et','NT palga',0),(424057,11780,'si','NT plaÄati',0),(424058,11780,'ba','NT membayar',0),(424059,11780,'nl','NT Pay',0),(424060,11780,'fi','NT maksu',0),(424061,11780,'no','NT lÃ¸nn',0),(424062,11780,'da','NT lÃ¸n',0),(424063,11780,'ko','NT ì§€ë¶ˆ',0),(424064,11780,'he','NT ×œ×©×œ×',0),(424065,11780,'el','NT Pay',0),(424066,11780,'zh','ç½‘ç»œç»ˆç«¯æ”¯ä»˜\r\n',0),(424067,11780,'sv','NT betala',0),(424068,11780,'it','NT paga',0),(424069,11780,'tl','',0),(424070,11780,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡ NT',0),(424071,11780,'hi','NT à¤ªà¥‡',0),(424072,11780,'ms','NT gaji',0),(424073,11780,'ar','Ø§Ù„Ø£Ø¬Ø± NT',0),(424074,11780,'fr','NT paye',0),(424075,11780,'jp','NT æœ‰æ–™',0),(424076,11780,'pt','NT Pay',0),(424077,11780,'ru','ÐŸÐ»Ð°Ñ‚Ð¸Ñ‚ÑŒ NT',0),(424078,11780,'es','Pago NT',0),(424079,11780,'de','NT-Pay',0),(424080,11780,'en','NT Pay',0),(424081,11781,'is','',0),(424082,11781,'dr','Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ ',0),(424083,11781,'pr','Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ ',0),(424084,11781,'tr','DÃ¶nem baÅŸlangÄ±cÄ±',0),(424085,11781,'pl','PoczÄ…tek okresu',0),(424086,11781,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´, Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð°Ñ‰',0),(424087,11781,'ur','Ø¯ÙˆØ± Ø´Ø±ÙˆØ¹',0),(424088,11781,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(424089,11781,'vi','báº¯t Ä‘áº§u thá»i ká»³',0),(424090,11781,'af','Tydperk begin',0),(424091,11781,'ro','PerioadÄƒ Ã®ncepÃ¢nd',0),(424092,11781,'et','Jooksul alates',0),(424093,11781,'si','Obdobje se zaÄne',0),(424094,11781,'ba','Masa awal',0),(424095,11781,'nl','Periode die aanvangt',0),(424096,11781,'fi','Ajanjaksona, joka alkaa',0),(424097,11781,'no','Perioden begynner',0),(424098,11781,'da','Periode begynder',0),(424099,11781,'ko','ê¸°ê°„ ì‹œìž‘',0),(424100,11781,'he','×ª×§×•×¤×ª',0),(424101,11781,'el','Î ÎµÏÎ¯Î¿Î´Î¿Ï‚ Ï€Î¿Ï… Î±ÏÏ‡Î¯Î¶ÎµÎ¹',0),(424102,11781,'zh','æœŸçš„å¼€å§‹\r\n',0),(424103,11781,'sv','Med bÃ¶rjan',0),(424104,11781,'it','Inizio periodo',0),(424105,11781,'tl','',0),(424106,11781,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²',0),(424107,11781,'hi','à¤…à¤µà¤§à¤¿ à¤¶à¥à¤°à¥à¤†à¤¤',0),(424108,11781,'ms','Tempoh bermula',0),(424109,11781,'ar','Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„ÙØªØ±Ø©',0),(424110,11781,'fr','PÃ©riode commenÃ§ant',0),(424111,11781,'jp','æœŸé–“é–‹å§‹',0),(424112,11781,'pt','InÃ­cio do perÃ­odo',0),(424113,11781,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(424114,11781,'es','Comienza del PerÃ­odo',0),(424115,11781,'de','Zeitraum ab',0),(424116,11781,'en','Period Beginning',0),(424117,11782,'is','',0),(424118,11782,'dr','Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ ',0),(424119,11782,'pr','Ù¾Ø§ÙŠØ§Ù† Ø¯ÙˆØ±Ù‡ ',0),(424120,11782,'tr','DÃ¶nem sonu',0),(424121,11782,'pl','KoÅ„czÄ…cy siÄ™ okres',0),(424122,11782,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´, Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‰',0),(424123,11782,'ur','Ù…Ø¯Øª Ø®ØªÙ… ÛÙˆÙ†Û’',0),(424124,11782,'sr','ÐšÑ€Ð°Ñ˜ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(424125,11782,'vi','káº¿t thÃºc thá»i ká»³',0),(424126,11782,'af','Tydperk geÃ«indig',0),(424127,11782,'ro','Perioade care se Ã®ncheie',0),(424128,11782,'et','Perioodi lÃµpp',0),(424129,11782,'si','Obdobje konÄa',0),(424130,11782,'ba','Periode akhir',0),(424131,11782,'nl','Periode die eindigt',0),(424132,11782,'fi','Jakson pÃ¤Ã¤ttyminen',0),(424133,11782,'no','Perioden endte',0),(424134,11782,'da','Perioden slutter',0),(424135,11782,'ko','ê¸°ê°„ ê²°ë§',0),(424136,11782,'he','×¡×•×£ ×ª×§×•×¤×”',0),(424137,11782,'el','Î ÎµÏÎ¹ÏŒÎ´Î¿Ï… Î· Î¿Ï€Î¿Î¯Î± Î»Î®Î³ÎµÎ¹',0),(424138,11782,'zh','ç»ˆäº†\r\n',0),(424139,11782,'sv','Slut',0),(424140,11782,'it','Periodo che termina',0),(424141,11782,'tl','',0),(424142,11782,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²',0),(424143,11782,'hi','à¤…à¤µà¤§à¤¿ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¨à¥‡ à¤•à¥‡',0),(424144,11782,'ms','Tempoh berakhir',0),(424145,11782,'ar','Ø§Ù„ÙØªØ±Ø© Ø§Ù„Ù…Ù†ØªÙ‡ÙŠØ©',0),(424146,11782,'fr','PÃ©riode se terminant',0),(424147,11782,'jp','æœŸ',0),(424148,11782,'pt','PerÃ­odo final',0),(424149,11782,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(424150,11782,'es','TerminaciÃ³n del PerÃ­odo',0),(424151,11782,'de','Zeitraum Ende',0),(424152,11782,'en','Period Ending',0),(424153,11783,'is','',0),(424154,11783,'dr','  Ø´Ù…Ø§Ø±Ù‡ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ ',0),(424155,11783,'pr','  Ø´Ù…Ø§Ø±Ù‡ Ø¨ÙŠÙ…Ù‡ ØªØ§Ù…ÙŠÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ ',0),(424156,11783,'tr','SS numarasÄ±',0),(424157,11783,'pl','Numer SS',0),(424158,11783,'bg','Ð¡Ð¡ Ð½Ð¾Ð¼ÐµÑ€',0),(424159,11783,'ur','Ø§ÛŒØ³ Ø§ÛŒØ³ Ù†Ù…Ø¨Ø±',0),(424160,11783,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¡Ð¡',0),(424161,11783,'vi','Sá»‘ SS',0),(424162,11783,'af','SS nommer',0),(424163,11783,'ro','NumÄƒrul de SS',0),(424164,11783,'et','SS numbri',0),(424165,11783,'si','SS Å¡tevilo',0),(424166,11783,'ba','SS nomor',0),(424167,11783,'nl','SS-nummer',0),(424168,11783,'fi','SS-numero',0),(424169,11783,'no','SS nummer',0),(424170,11783,'da','SS nummer',0),(424171,11783,'ko','SS ë²ˆí˜¸',0),(424172,11783,'he','×ž×¡×¤×¨ ×”××¡. ××¡',0),(424173,11783,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½ SS',0),(424174,11783,'zh','ç¤¾ä¼šä¿éšœå·ç \r\n',0),(424175,11783,'sv','SS nummer',0),(424176,11783,'it','Numero di SS',0),(424177,11783,'tl','',0),(424178,11783,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ SS',0),(424179,11783,'hi','à¤à¤¸ à¤à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(424180,11783,'ms','Nombor SS',0),(424181,11783,'ar','Ø¹Ø¯Ø¯ SS',0),(424182,11783,'fr','Nombre de SS',0),(424183,11783,'jp','SS æ•°',0),(424184,11783,'pt','NÃºmero de SS',0),(424185,11783,'ru','ÐÐ¾Ð¼ÐµÑ€ SS',0),(424186,11783,'es','NÃºmero de Seguro Social',0),(424187,11783,'de','SS-Nummer',0),(424188,11783,'en','SS Number',0),(424189,11784,'is','',0),(424190,11784,'dr','ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ø±Ø³ÙŠ Ø±ÙˆÙŠ Ú†Ùƒ Ù‡Ø§ÙŠ Ø¨Ø§Ù„Ø§ ',0),(424191,11784,'pr','ÙÙ‚Ø· Ø¨Ø±Ø§ÙŠ Ø¨Ø±Ø±Ø³ÙŠ Ø±ÙˆÙŠ Ú†Ùƒ Ù‡Ø§ÙŠ Ø¨Ø§Ù„Ø§ ',0),(424192,11784,'tr','YalnÄ±zca Ã¼st kontroller kontrol iÃ§in',0),(424193,11784,'pl','Tylko do wyboru na gÃ³rÄ™ kontroli',0),(424194,11784,'bg','Ð¡Ð°Ð¼Ð¾ Ð·Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð¢Ð¾Ð¿ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(424195,11784,'ur','Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± Ú†ÛŒÚ© Ù¾Ø± Ù¾Ú‘ØªØ§Ù„ Ú©Û’ Ù„ÛŒÛ’ ØµØ±Ù',0),(424196,11784,'sr','Ð¡Ð°Ð¼Ð¾ Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð½Ð° Ð³Ð¾Ñ€ÑšÐ¾Ñ˜ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(424197,11784,'vi','chá»‰ kiá»ƒm tra nhá»¯ng sÃ©c trÃªn cÃ¹ng',0),(424198,11784,'af','Slegs vir kontrole op Top ondersoeke',0),(424199,11784,'ro','Doar pentru a verifica pe sus controale',0),(424200,11784,'et','Ainult Top kontrolli kontrollimiseks',0),(424201,11784,'si','Samo za preverjanje Top pregledi',0),(424202,11784,'ba','Hanya untuk memeriksa atas cek',0),(424203,11784,'nl','Alleen voor controle op bovenste controles',0),(424204,11784,'fi','Voidaan tarkistaa alkuun tarkastukset',0),(424205,11784,'no','Bare For sjekk pÃ¥ topp sjekker',0),(424206,11784,'da','Kun For Check pÃ¥ Top kontrol',0),(424207,11784,'ko','ìµœê³ ì˜ ê²€ì‚¬ì—ì„œ ê²€ì‚¬ì—ë§Œ',0),(424208,11784,'he','×¨×§ ×‘×©×‘×™×œ ×œ×‘×“×•×§ ×‘×“×™×§×•×ª ×”×ž×•×‘×™×œ×•×ª',0),(424209,11784,'el','ÎœÏŒÎ½Î¿ Î³Î¹Î± Î­Î»ÎµÎ³Ï‡Î¿ ÎºÎ¿ÏÏ…Ï†Î±Î¯Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚',0),(424210,11784,'zh','ä»…ç”¨äºŽé¡¶çº§æ”¯ç¥¨çš„æ£€æŸ¥\r\n',0),(424211,11784,'sv','Endast fÃ¶r kolla pÃ¥ Top kontroller',0),(424212,11784,'it','Solo per il Check di controllo superiore',0),(424213,11784,'tl','',0),(424214,11784,'th','à¸ªà¸³à¸«à¸£à¸±à¸šà¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹€à¸Šà¹‡à¸„à¸”à¹‰à¸²à¸™à¸šà¸™à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(424215,11784,'hi','à¤•à¥‡à¤µà¤² à¤¶à¥€à¤°à¥à¤· à¤•à¥€ à¤œà¤¾à¤à¤š à¤ªà¤° à¤œà¤¾à¤à¤š à¤•à¥‡ à¤²à¤¿à¤',0),(424216,11784,'ms','Hanya untuk menyemak cek atas',0),(424217,11784,'ar','ÙÙ‚Ø· Ù„Ù„Ø§Ø®ØªÙŠØ§Ø± Ø¹Ù„Ù‰ Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø¹Ù„ÙˆÙŠ',0),(424218,11784,'fr','Uniquement pour vÃ©rifier sur le haut de la page contrÃ´les',0),(424219,11784,'jp','ãƒˆãƒƒãƒ— ãƒã‚§ãƒƒã‚¯ ãƒã‚§ãƒƒã‚¯ã®ãŸã‚ã«ã®ã¿',0),(424220,11784,'pt','Apenas para verificaÃ§Ã£o de controlo superior',0),(424221,11784,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð½Ð° Ñ‚Ð¾Ð¿ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(424222,11784,'es','Solo Para el Cheque en los Cheques de Encima',0),(424223,11784,'de','Nur fÃ¼r Check auf Top-PrÃ¼fungen',0),(424224,11784,'en','Only For Check On Top Checks',0),(424225,11785,'is','',0),(424226,11785,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‚Ø§Ù„Ø¨ Ø®Ø§Øµ Ø¨Ø±Ø§ÙŠ Ú†Ùƒ Ù‡Ø§ÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(424227,11785,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‚Ø§Ù„Ø¨ Ø®Ø§Øµ Ø¨Ø±Ø§ÙŠ Ú†Ùƒ Ù‡Ø§ÙŠ Ù„ÙŠØ³Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ ',0),(424228,11785,'tr','Bordro Ã§ek iÃ§in Ã¶zel formatÄ± kullanma',0),(424229,11785,'pl','Za pomocÄ… specjalnego formatu dla kontroli pÅ‚ac',0),(424230,11785,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÑÐ¿ÐµÑ†Ð¸Ð°Ð»ÐµÐ½ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(424231,11785,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø®Ø§Øµ ÙˆØ¶Ø¹ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(424232,11785,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÐµÐ±Ð°Ð½ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð·Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(424233,11785,'vi','Sá»­ dá»¥ng Ä‘á»‹nh dáº¡ng Ä‘áº·c biá»‡t Ä‘á»‘i vá»›i viá»‡c kiá»ƒm tra báº£ng lÆ°Æ¡ng',0),(424234,11785,'af','Gebruik Spesiale Formaat Vir Loonrol Tjeks',0),(424235,11785,'ro','UtilizaÅ£i Special Format pentru controale salarizare',0),(424236,11785,'et','Kasuta eriline vorm palgaarvestuse kontrollimine',0),(424237,11785,'si','Uporabi posebno obliko za preglede na izplaÄane plaÄe',0),(424238,11785,'ba','Menggunakan Format khusus untuk penggajian cek',0),(424239,11785,'nl','Gebruik speciale indeling voor Payroll controles',0),(424240,11785,'fi','Erityinen muoto kÃ¤ytetÃ¤Ã¤n palkkahallinnon tarkastusten',0),(424241,11785,'no','Bruk spesielt Format For lÃ¸nn sjekker',0),(424242,11785,'da','Bruge sÃ¦rlige Format For lÃ¸nningslisten kontrol',0),(424243,11785,'ko','ê¸‰ì—¬ ìˆ˜ í‘œë¥¼ ìœ„í•œ íŠ¹ë³„ í•œ í˜•ì‹ì„ ì‚¬ìš© í•˜ ì—¬',0),(424244,11785,'he','×”×©×ª×ž×© ×‘×ª×‘× ×™×ª ×ž×™×•×—×“×ª ×¢×‘×•×¨ ×”×ž×©×›×•×¨×•×ª',0),(424245,11785,'el','Î§ÏÎ®ÏƒÎ· ÎµÎ¹Î´Î¹ÎºÎ®Ï‚ Î¼Î¿ÏÏ†Î®Ï‚ Î³Î¹Î± ÎµÏ€Î¹Ï„Î±Î³Î­Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(424246,11785,'zh','ä½¿ç”¨ç‰¹æ®Šæ ¼å¼çš„å·¥èµ„å•\r\n',0),(424247,11785,'sv','AnvÃ¤nda speciellt Format fÃ¶r lÃ¶ner kontroller',0),(424248,11785,'it','Utilizzare il formato speciale per i controlli di Payroll',0),(424249,11785,'tl','',0),(424250,11785,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¸žà¸´à¹€à¸¨à¸©à¹ƒà¸Šà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(424251,11785,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤•à¥€ à¤œà¤¾à¤‚à¤š à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤¶à¥‡à¤· à¤¸à¥à¤µà¤°à¥‚à¤ª à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(424252,11785,'ms','Menggunakan Format khas untuk cek gaji',0),(424253,11785,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªÙ†Ø³ÙŠÙ‚ Ø®Ø§Øµ Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(424254,11785,'fr','Utilisez le Format spÃ©cial pour les chÃ¨ques de paie',0),(424255,11785,'jp','çµ¦ä¸Žãƒã‚§ãƒƒã‚¯ã®ãŸã‚ã®ç‰¹åˆ¥ãªå½¢å¼ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(424256,11785,'pt','Use o formato especial para cheques',0),(424257,11785,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð»Ñ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(424258,11785,'es','Usa Formato Especial para Cheques de NÃ³mina',0),(424259,11785,'de','Verwenden Sie spezielles Format fÃ¼r Payroll-PrÃ¼fungen',0),(424260,11785,'en','Use Special Format For Payroll Checks',0),(424261,11786,'is','',0),(424262,11786,'dr','Ø§Ø±Ø³Ø§Ù„ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ',0),(424263,11786,'pr','Ø§Ø±Ø³Ø§Ù„ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ',0),(424264,11786,'tr','Ä°hracat satÄ±cÄ±lar',0),(424265,11786,'pl','EksportowaÄ‡ dostawcÃ³w',0),(424266,11786,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(424267,11786,'ur','Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©Ùˆ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(424268,11786,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(424269,11786,'vi','Káº¿t xuáº¥t cÃ¡c nhÃ  cung cáº¥p',0),(424270,11786,'af','Uitvoer verkopers',0),(424271,11786,'ro','VÃ¢nzÄƒtorii de export',0),(424272,11786,'et','Ekspordi tarnijad',0),(424273,11786,'si','Izvoz prodajalcev',0),(424274,11786,'ba','Ekspor vendor',0),(424275,11786,'nl','Exporteren van leveranciers',0),(424276,11786,'fi','Vie myyjÃ¤t',0),(424277,11786,'no','Eksportere leverandÃ¸rer',0),(424278,11786,'da','Eksport sÃ¦lgere',0),(424279,11786,'ko','ìˆ˜ì¶œ ì—…ì²´',0),(424280,11786,'he','×™×¦× ×¡×¤×§×™×',0),(424281,11786,'el','Î•Î¾Î±Î³Ï‰Î³Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚',0),(424282,11786,'zh','å‡ºå£ä¾›åº”å•†\r\n',0),(424283,11786,'sv','Exportera leverantÃ¶rer',0),(424284,11786,'it','Fornitori di esportazione',0),(424285,11786,'tl','',0),(424286,11786,'th','à¸œà¸¹à¹‰à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(424287,11786,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(424288,11786,'ms','Pembekal eksport',0),(424289,11786,'ar','ØªØµØ¯ÙŠØ± Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ†',0),(424290,11786,'fr','Exporter des vendeurs',0),(424291,11786,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(424292,11786,'pt','Fornecedores de exportaÃ§Ã£o',0),(424293,11786,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(424294,11786,'es','Proveedores de Exportaciones',0),(424295,11786,'de','Export-Anbieter',0),(424296,11786,'en','Export Vendors',0),(424297,11787,'is','',0),(424298,11787,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(424299,11787,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ÙŠ Ù¾Ø±Ø¯Ø§Ø®Øª ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(424300,11787,'tr','Kredi kartÄ± Ã¶deme talimatlarÄ±',0),(424301,11787,'pl','Instrukcje dotyczÄ…ce pÅ‚atnoÅ›ci kartÄ… kredytowÄ…',0),(424302,11787,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(424303,11787,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(424304,11787,'sr','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(424305,11787,'vi','HÆ°á»›ng dáº«n thanh ToÃ¡n Tháº» TÃ­n Dá»¥ng ',0),(424306,11787,'af','Kredietkaart Betalingsinstruksies',0),(424307,11787,'ro','InstrucÅ£iunile de platÄƒ carduri de credit',0),(424308,11787,'et','Krediitkaardi makse juhiseid',0),(424309,11787,'si','Kreditno kartico plaÄilnih navodil',0),(424310,11787,'ba','Instruksi pembayaran kartu kredit',0),(424311,11787,'nl','Creditcard betalingsinstructies',0),(424312,11787,'fi','Luottokortin maksuohjeet',0),(424313,11787,'no','Kredittkort betalingsinstruksjoner',0),(424314,11787,'da','Kreditkort betalingsinstruktioner',0),(424315,11787,'ko','ì‹ ìš© ì¹´ë“œ ì§€ë¶ˆ ë°©ë²•',0),(424316,11787,'he','×”×•×¨××•×ª ×ª×©×œ×•× ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(424317,11787,'el','ÎŸÎ´Î·Î³Î¯ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(424318,11787,'zh','ä¿¡ç”¨å¡ä»˜æ¬¾è¯´æ˜Ž\r\n',0),(424319,11787,'sv','Kreditkort betalningsinstruktioner',0),(424320,11787,'it','Istruzioni di pagamento carta di credito',0),(424321,11787,'tl','',0),(424322,11787,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(424323,11787,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(424324,11787,'ms','Arahan pembayaran kad kredit',0),(424325,11787,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(424326,11787,'fr','Instructions de paiement de carte de crÃ©dit',0),(424327,11787,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ”¯æ‰•ã„æ‰‹é †',0),(424328,11787,'pt','InstruÃ§Ãµes de pagamento de cartÃ£o de crÃ©dito',0),(424329,11787,'ru','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð¿Ð¾ Ð¾Ð¿Ð»Ð°Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(424330,11787,'es','Tarjeta de CrÃ©dito Instrucciones de Pago',0),(424331,11787,'de','Kreditkarte-Zahlungshinweise',0),(424332,11787,'en','Credit Card Payment Instructions',0),(424333,11788,'is','',0),(424334,11788,'dr','Ù…Ø­Ø¯ÙˆØ¯ÙŠØª Ù†ØµÙ Ø§Ø±ØªÙØ§Ø¹ Ø¨Ø±Ø§ÙŠ Ù‡ÙØª ÙƒØ§Ù„Ø§ Ø§Ø³Øª â€“ Ù‡ÙŠÚ† Ø³Ø·Ø±ÙŠ Ø¯ÙŠÚ¯Ø± Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ Ø±Ø§ Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ù…ÙŠ Ú¯ÙŠØ±Ø¯',0),(424335,11788,'pr','Ù…Ø­Ø¯ÙˆØ¯ÙŠØª Ù†ØµÙ Ø§Ø±ØªÙØ§Ø¹ Ø¨Ø±Ø§ÙŠ Ù‡ÙØª ÙƒØ§Ù„Ø§ Ø§Ø³Øª â€“ Ù‡ÙŠÚ† Ø³Ø·Ø±ÙŠ Ø¯ÙŠÚ¯Ø± Ú¯Ø²ÙŠÙ†Ù‡ Ù‡Ø§ÙŠ Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÙŠ Ø±Ø§ Ù†Ø§Ø¯ÙŠØ¯Ù‡ Ù…ÙŠ Ú¯ÙŠØ±Ø¯',0),(424336,11788,'tr','YarÄ±m yÃ¼kseklik sÄ±nÄ±rÄ± 7 bileÅŸen - hiÃ§bir satÄ±r yok sayar, diÄŸer biÃ§imlendirme seÃ§enekleri',0),(424337,11788,'pl','PoÅ‚owÄ™ wysokoÅ›Ä‡ wynosi 7 pozycji - brak linii ignoruje inne opcje formatu',0),(424338,11788,'bg','ÐŸÐ¾Ð»Ð¾Ð²Ð¸Ð½ Ð²Ð¸ÑÐ¾Ñ‡Ð¸Ð½Ð° Ð³Ñ€Ð°Ð½Ð¸Ñ†Ð° Ðµ 7 Ð¾Ð±ÐµÐºÑ‚Ð¸ - Ð»Ð¸Ð½Ð¸Ð¸ Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð° Ð´Ñ€ÑƒÐ³Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸ Ð·Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(424339,11788,'ur','7 Ø§Ø´ÛŒØ§Ø¡ Ø¢Ø¯Ú¾ÛŒ Ø§ÙˆÙ†Ú†Ø§Ø¦ÛŒ Ú©ÛŒ Ø­Ø¯ ÛÛ’ - Ú©ÙˆØ¦ÛŒ Ù„Ø§Ø¦Ù†ÛŒÚº Ø¯ÛŒÚ¯Ø± ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ù†Ø¸Ø±Ø§Ù†Ø¯Ø§Ø² Ú©Ø±ØªØ§ ÛÛ’',0),(424340,11788,'sr','ÐŸÐ¾Ð»Ð° Ð²Ð¸ÑÐ¸Ð½Ðµ Ð›Ð¸Ð¼Ð¸Ñ‚ Ñ˜Ðµ 7 ÑÑ‚Ð°Ð²ÐºÐµ,-Ð½ÐµÐ¼Ð° Ñ€ÐµÐ´Ð¾Ð²Ð° Ð·Ð°Ð½ÐµÐ¼Ð°Ñ€ÑƒÑ˜Ðµ Ð´Ñ€ÑƒÐ³Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¾Ð±Ð»Ð¸ÐºÐ¾Ð²Ð°ÑšÐµ',0),(424341,11788,'vi','giá»›i háº¡n má»™t ná»­a chiá»u cao lÃ  7 má»¥c- khÃ´ng bá» qua cÃ¡ dÃ²ng cÃ³ cÃ¡c lá»±a chá»n khÃ¡c',0),(424342,11788,'af','Halwe hoogte limiet Is 7 Items - geen lyne ignoreer ander formaat opsies',0),(424343,11788,'ro','JumÄƒtate Ã®nÄƒlÅ£imea limitÄƒ este 7 articole - linii nu ignorÄƒ alte opÅ£iuni de Format',0),(424344,11788,'et','Poole kÃµrguse piirang on 7 kaubad - kÃµik ilma ignoreerib muud vormingusuvandid',0),(424345,11788,'si','Pol viÅ¡ine omejitev je 7 artiklov - brez Ärt zanemarja druge oblikovne moÅ¾nosti',0),(424346,11788,'ba','Batas ketinggian setengah 7 item - tidak ada garis mengabaikan pilihan Format lain',0),(424347,11788,'nl','Halve hoogte limiet Is 7 Items - geen lijnen negeert andere opmaakopties',0),(424348,11788,'fi','Puoli korkeus raja on 7 kohteita - viivoja ei oteta huomioon muut muotoiluasetukset',0),(424349,11788,'no','Halv hÃ¸yde grense er 7 elementer - ingen linjer ignorerer andre formateringsalternativer',0),(424350,11788,'da','Halv hÃ¸jde grÃ¦nse er 7 genstande - ingen linjer ignorerer andre formatindstillinger',0),(424351,11788,'ko','ì ˆë°˜ ë†’ì´ ì œí•œ 7 í•­ëª©-ì¤„ ì—†ì´ ë‹¤ë¥¸ ì„œì‹ ì˜µì…˜ì„ ë¬´ì‹œ',0),(424352,11788,'he','×ž×’×‘×œ×ª ×’×•×‘×” ×—×¦×™ 7 ×¤×¨×™×˜×™× - ××™×Ÿ ×§×•×•×™× ×ž×ª×¢×œ× ××¤×©×¨×•×™×•×ª ×ª×‘× ×™×ª × ×•×¡×¤×•×ª',0),(424353,11788,'el','ÎœÎ¹ÏƒÏŒ ÏÏˆÎ¿Ï‚ ÏŒÏÎ¹Î¿ ÎµÎ¯Î½Î±Î¹ Î±Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î± 7 - Î³ÏÎ±Î¼Î¼Î­Ï‚ Î´ÎµÎ½ Î±Î³Î½Î¿ÎµÎ¯ Ï„Î¹Ï‚ Î¬Î»Î»ÎµÏ‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î¼Î¿ÏÏ†Î®',0),(424354,11788,'zh','åŠé«˜æžé™ä¸º7ä¸ªé¡¹ç›®-æ²¡æœ‰è¡Œå¿½ç•¥äº†å…¶ä»–æ ¼å¼é€‰é¡¹\r\n',0),(424355,11788,'sv','Halv hÃ¶jd grÃ¤ns Ã¤r 7 trÃ¤ffar - inga linjer ignorerar andra formateringsalternativ',0),(424356,11788,'it','Mezza altezza limite Ã¨ di 7 elementi - linee non ignora altre opzioni di formato',0),(424357,11788,'tl','',0),(424358,11788,'th','à¸§à¸‡à¹€à¸‡à¸´à¸™à¸ªà¸¹à¸‡à¸„à¸£à¸¶à¹ˆà¸‡à¹€à¸›à¹‡à¸™à¸£à¸²à¸¢à¸à¸²à¸£ 7 - à¸šà¸£à¸£à¸—à¸±à¸”à¹„à¸¡à¹ˆà¸¥à¸°à¹€à¸§à¹‰à¸™à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸£à¸¹à¸›à¹à¸šà¸šà¸­à¸·à¹ˆà¸™ à¹†',0),(424359,11788,'hi','7 à¤†à¤‡à¤Ÿà¤® à¤†à¤§à¥€ à¤Šà¤‚à¤šà¤¾à¤ˆ à¤¸à¥€à¤®à¤¾ à¤¹à¥ˆ - à¤•à¥‹à¤ˆ à¤²à¤¾à¤‡à¤¨à¥‹à¤‚ à¤…à¤¨à¥à¤¯ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤µà¤¿à¤•à¤²à¥à¤ªà¥‹à¤‚ à¤ªà¤° à¤§à¥à¤¯à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤¦à¥‡à¤¤à¤¾',0),(424360,11788,'ms','Setengah had ketinggian 7 item - garisan tidak mengabaikan pilihan Format lain',0),(424361,11788,'ar','Ù†ØµÙ Ø§Ù„Ø§Ø±ØªÙØ§Ø¹ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø¨Ù†ÙˆØ¯ 7--Ù„Ø§ ØªÙˆØ¬Ø¯ Ø®Ø·ÙˆØ· ÙŠØªØ¬Ø§Ù‡Ù„ Ø®ÙŠØ§Ø±Ø§Øª ØªÙ†Ø³ÙŠÙ‚ Ø£Ø®Ø±Ù‰',0),(424362,11788,'fr','Demi hauteur maximale est de 7 Ã©lÃ©ments - aucune ligne ne tient pas compte des autres Options de Format',0),(424363,11788,'jp','åŠåˆ†ã®é«˜ã•ã®åˆ¶é™ã¯ 7 é …ç›® - è¡Œãªã„ãã®ä»–ã®å½¢å¼ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’ç„¡è¦–ã—ã¾ã™',0),(424364,11788,'pt','Meia altura limite Ã© de 7 itens - sem linhas ignora outras opÃ§Ãµes de formato',0),(424365,11788,'ru','ÐŸÐ¾Ð»Ð¾Ð²Ð¸Ð½Ð° Ð²Ñ‹ÑÐ¾Ñ‚Ð½Ð¾ÑÑ‚ÑŒ 7 Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð¾Ð² - ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð½Ðµ Ð¸Ð³Ð½Ð¾Ñ€Ð¸Ñ€ÑƒÐµÑ‚ Ð´Ñ€ÑƒÐ³Ð¸Ðµ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð°',0),(424366,11788,'es','Limite de Altura Media es 7 ArtÃ­culos - Ningunas Lineas Ignoran Opciones de Formato',0),(424367,11788,'de','Halbe HÃ¶he-Limit ist 7 Teile - keine Linien ignoriert andere Formatoptionen',0),(424368,11788,'en','Half Height Limit Is 7 Items - No Lines Ignores Other Format Options',0),(424369,11789,'is','',0),(424370,11789,'dr','Ø¢Ø¯Ø±Ø³ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(424371,11789,'pr','Ø¢Ø¯Ø±Ø³ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(424372,11789,'tr','CC fatura adresi iste',0),(424373,11789,'pl','WymagajÄ… CC adres fakturowania',0),(424374,11789,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð°Ñ‚ CC Ð°Ð´Ñ€ÐµÑ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(424375,11789,'ur','CC Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§ÛŒÚˆØ±ÛŒØ³ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÙˆØªÛŒ ÛÛ’',0),(424376,11789,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°Ñ˜Ñƒ Ð¦Ð¦ Ð°Ð´Ñ€ÐµÑÐ° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(424377,11789,'vi','yÃªu cáº§u CC Ä‘á»‹a chá»‰ nháº­n hÃ³a Ä‘Æ¡n',0),(424378,11789,'af','Vereis CC fakturering adres',0),(424379,11789,'ro','Nevoie de adresa de facturare CC',0),(424380,11789,'et','NÃµuda koopia arve esitamise aadress',0),(424381,11789,'si','Zahtevajo CC naslov',0),(424382,11789,'ba','Memerlukan alamat penagihan CC',0),(424383,11789,'nl','Vereisen CC factuuradres',0),(424384,11789,'fi','Vaadi kopio laskutusosoite',0),(424385,11789,'no','Kreve CC faktureringsadresse',0),(424386,11789,'da','KrÃ¦ve CC faktureringsadresse',0),(424387,11789,'ko','CC ê²°ì œ ì£¼ì†Œ',0),(424388,11789,'he','×“×•×¨×©×™× ××ª ×›×ª×•×‘×ª ×”×—×™×•×‘ CC',0),(424389,11789,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½ CC Î§Î¡Î•Î©Î£Î—Î£',0),(424390,11789,'zh','è¦æ±‚ä¿¡ç”¨å¡å¸å•åœ°å€\r\n',0),(424391,11789,'sv','KrÃ¤ver CC faktureringsadress',0),(424392,11789,'it','Richiedono l\'indirizzo di fatturazione CC',0),(424393,11789,'tl','',0),(424394,11789,'th','à¸•à¹‰à¸­à¸‡ CC à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(424395,11789,'hi','CC à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤ªà¤¤à¥‡ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(424396,11789,'ms','Memerlukan alamat bil CC',0),(424397,11789,'ar','ØªØ·Ù„Ø¨ Ù…Ù†Ùƒ Ø¥Ø¯Ø®Ø§Ù„ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„ÙÙˆØªØ±Ø© CC',0),(424398,11789,'fr','Besoin d\'adresse de facturation de CC',0),(424399,11789,'jp','CC ã®è«‹æ±‚å…ˆä½æ‰€ãŒå¿…è¦ã§ã™ã€‚',0),(424400,11789,'pt','Requerem o endereÃ§o de facturaÃ§Ã£o do CC',0),(424401,11789,'ru','Ð¢Ñ€ÐµÐ±ÑƒÑŽÑ‚ CC Ð°Ð´Ñ€ÐµÑ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°',0),(424402,11789,'es','Requiere DirecciÃ³n de Factura para Tarjeta de CrÃ©dito',0),(424403,11789,'de','CC Billing Adresse erforderlich',0),(424404,11789,'en','Require CC Billing Address',0),(424405,11790,'is','',0),(424406,11790,'dr','ÙƒØ¯ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(424407,11790,'pr','ÙƒØ¯ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ Ù„Ø§Ø²Ù… Ø§Ø³Øª ',0),(424408,11790,'tr','CC kart kodu gerektirir',0),(424409,11790,'pl','WymagajÄ… kodu z karty CC',0),(424410,11790,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° CC ÐºÐ°Ñ€Ñ‚Ð° ÐºÐ¾Ð´',0),(424411,11790,'ur','CC Ú©Ø§Ø±Úˆ Ú©ÙˆÚˆ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÙˆØªÛŒ ÛÛ’',0),(424412,11790,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°Ñ‚Ð¸ Ð¦Ð¦ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ ÐºÃ´Ð´',0),(424413,11790,'vi','yÃªu cáº§u CC mÃ£ tháº»',0),(424414,11790,'af','BK kaart kode vereis',0),(424415,11790,'ro','Nevoie de codul de Card CC',0),(424416,11790,'et','NÃµua krediitkaardi koodi',0),(424417,11790,'si','Zahteva kodo kartice CC',0),(424418,11790,'ba','Memerlukan kode kartu CC',0),(424419,11790,'nl','CC kaart Code nodig',0),(424420,11790,'fi','Vaadi kopio kortin koodi',0),(424421,11790,'no','Kreve CC kort kode',0),(424422,11790,'da','KrÃ¦ve CC kort kode',0),(424423,11790,'ko','CC ì¹´ë“œ ì½”ë“œ í•„ìš”',0),(424424,11790,'he','×“×•×¨×©×™× CC ×›×¨×˜×™×¡ ×§×•×“',0),(424425,11790,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï„Î·Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ CC',0),(424426,11790,'zh','è¦æ±‚ä¿¡ç”¨å¡å¡ä»£ç \r\n',0),(424427,11790,'sv','KrÃ¤ver CC kort kod',0),(424428,11790,'it','Richiedono codice Card CC',0),(424429,11790,'tl','',0),(424430,11790,'th','à¸•à¹‰à¸­à¸‡à¹ƒà¸Šà¹‰à¸£à¸«à¸±à¸ªà¸šà¸±à¸•à¸£ CC',0),(424431,11790,'hi','CC à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‹à¤¡ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥‹à¤¤à¥€ à¤¹à¥ˆ',0),(424432,11790,'ms','Memerlukan kod Kad CC',0),(424433,11790,'ar','ÙŠØªØ·Ù„Ø¨ Ø±Ù…Ø² Ø¨Ø·Ø§Ù‚Ø© CC',0),(424434,11790,'fr','Besoin de Code de carte CC',0),(424435,11790,'jp','CC ã‚«ãƒ¼ãƒ‰ã®ã‚³ãƒ¼ãƒ‰ã‚’å¿…è¦ã¨ã—ã¾ã™ã€‚',0),(424436,11790,'pt','Exigem CC cÃ³digo de cartÃ£o',0),(424437,11790,'ru','Ð¢Ñ€ÐµÐ±ÑƒÑŽÑ‚ ÐºÐ¾Ð´ ÐºÐ°Ñ€Ñ‚Ñ‹ CC',0),(424438,11790,'es','Requiere CÃ³digo de Tarjeta para Tarjeta de CrÃ©dito',0),(424439,11790,'de','CC-Card-Code erforderlich',0),(424440,11790,'en','Require CC Card Code',0),(424441,11791,'is','',0),(424442,11791,'dr','ÙƒØ¯ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(424443,11791,'pr','ÙƒØ¯ ÙƒØ§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÙŠ',0),(424444,11791,'tr','CC kart kodu',0),(424445,11791,'pl','Kod karty CC',0),(424446,11791,'bg','CC ÐºÐ°Ñ€Ñ‚Ð° ÐºÐ¾Ð´',0),(424447,11791,'ur','CC Ú©Ø§Ø±Úˆ Ú©ÙˆÚˆ',0),(424448,11791,'sr','Ð¦Ð¦ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ Ð¨Ð¸Ñ„Ñ€Ð°',0),(424449,11791,'vi','MÃ£ tháº» tÃ­n dá»¥ng',0),(424450,11791,'af','BK kaart kode',0),(424451,11791,'ro','Codul de Card CC',0),(424452,11791,'et','CC kaardi kood',0),(424453,11791,'si','CC kartice kodo',0),(424454,11791,'ba','Kode kartu CC',0),(424455,11791,'nl','CC kaart Code',0),(424456,11791,'fi','Kopio koodi',0),(424457,11791,'no','CC kort kode',0),(424458,11791,'da','CC kort kode',0),(424459,11791,'ko','CC ì¹´ë“œ ì½”ë“œ',0),(424460,11791,'he','CC ×›×¨×˜×™×¡ ×§×•×“',0),(424461,11791,'el','ÎšÏ‰Î´Î¹ÎºÏŒ Ï„Î·Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚ CC',0),(424462,11791,'zh','ä¿¡ç”¨å¡ä»£ç \r\n',0),(424463,11791,'sv','CC kort kod',0),(424464,11791,'it','Codice Card CC',0),(424465,11791,'tl','',0),(424466,11791,'th','à¸£à¸«à¸±à¸ªà¸šà¸±à¸•à¸£ CC',0),(424467,11791,'hi','CC à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‹à¤¡',0),(424468,11791,'ms','Kod Kad CC',0),(424469,11791,'ar','Ø±Ù…Ø² Ø¨Ø·Ø§Ù‚Ø© CC',0),(424470,11791,'fr','Code de carte CC',0),(424471,11791,'jp','CC ã‚«ãƒ¼ãƒ‰ ã‚³ãƒ¼ãƒ‰',0),(424472,11791,'pt','CÃ³digo do cartÃ£o do CC',0),(424473,11791,'ru','ÐšÐ¾Ð´ ÐºÐ°Ñ€Ñ‚Ñ‹ CC',0),(424474,11791,'es','TC CÃ³digo de Tarjeta',0),(424475,11791,'de','CC-Karte Code',0),(424476,11791,'en','CC Card Code',0),(424477,11792,'is','',0),(424478,11792,'dr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(424479,11792,'pr','Ø´Ù…Ø§ Ø¨Ø§ÙŠØ¯ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(424480,11792,'tr','Girmeniz gerekir',0),(424481,11792,'pl','NaleÅ¼y wprowadziÄ‡',0),(424482,11792,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ',0),(424483,11792,'ur','Ø¢Ù¾ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(424484,11792,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ',0),(424485,11792,'vi','Báº¡n pháº£i nháº­p vÃ o',0),(424486,11792,'af','U Moet Invoer',0),(424487,11792,'ro','Trebuie sÄƒ introduceÅ£i',0),(424488,11792,'et','Peate sisestama',0),(424489,11792,'si','Vnesti morate',0),(424490,11792,'ba','Anda harus memasukkan',0),(424491,11792,'nl','U moet invoeren',0),(424492,11792,'fi','Anna',0),(424493,11792,'no','Du mÃ¥ angi',0),(424494,11792,'da','Du skal indtaste',0),(424495,11792,'ko','ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(424496,11792,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ',0),(424497,11792,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ',0),(424498,11792,'zh','ä½ å¿…é¡»è¾“å…¥\r\n',0),(424499,11792,'sv','Du mÃ¥ste ange',0),(424500,11792,'it','Ãˆ necessario immettere',0),(424501,11792,'tl','',0),(424502,11792,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™',0),(424503,11792,'hi','à¤†à¤ªà¤•à¥‹ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(424504,11792,'ms','Anda mesti memasukkan',0),(424505,11792,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„',0),(424506,11792,'fr','Vous devez entrer',0),(424507,11792,'jp','å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(424508,11792,'pt','VocÃª deve digitar',0),(424509,11792,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸',0),(424510,11792,'es','Debe Entrar',0),(424511,11792,'de','Sie mÃ¼ssen eingeben',0),(424512,11792,'en','You Must Enter',0),(424513,11793,'is','',0),(424514,11793,'dr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(424515,11793,'pr','ÙŠØ§Ø¯Ø¯Ø§Ø´Øª ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯ ',0),(424516,11793,'tr','Not yok',0),(424517,11793,'pl','Uwaga nie istnieje',0),(424518,11793,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ°Ñ‚Ð° Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(424519,11793,'ur','Ù†ÙˆÙ¹ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº',0),(424520,11793,'sr','Ð£ Ð¿Ð¾Ñ€ÑƒÑ†Ð¸ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(424521,11793,'vi','LÆ°u Ã½ nÃ y khÃ´ng tá»“n táº¡i',0),(424522,11793,'af','Die nota bestaan nie',0),(424523,11793,'ro','Nota nu exista',0),(424524,11793,'et','MÃ¤rget pole',0),(424525,11793,'si','Opomba ne obstaja',0),(424526,11793,'ba','Catatan tidak ada',0),(424527,11793,'nl','De notitie bestaat niet',0),(424528,11793,'fi','Huomautus ei ole',0),(424529,11793,'no','Notatet finnes ikke',0),(424530,11793,'da','Noden findes ikke',0),(424531,11793,'ko','ì°¸ê³  ì¡´ìž¬ í•˜ì§€ ì•ŠëŠ”',0),(424532,11793,'he','×”×”×¢×¨×” ×œ× ×§×™×™×ž×ª',0),(424533,11793,'el','Î— ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ· Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹',0),(424534,11793,'zh','è¯¥è¯´æ˜Žä¸å­˜åœ¨\r\n',0),(424535,11793,'sv','Anteckningen finns inte',0),(424536,11793,'it','La nota non esiste',0),(424537,11793,'tl','',0),(424538,11793,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¹„à¸¡à¹ˆà¸¡à¸µ',0),(424539,11793,'hi','à¤¨à¥‹à¤Ÿ à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(424540,11793,'ms','Nota tidak wujud',0),(424541,11793,'ar','Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø© ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(424542,11793,'fr','La Note n\'existe pas',0),(424543,11793,'jp','ãƒ¡ãƒ¢ã¯å­˜åœ¨ã—ã¾ã›ã‚“',0),(424544,11793,'pt','A nota nÃ£o existe',0),(424545,11793,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(424546,11793,'es','La Nota no Existe',0),(424547,11793,'de','Der Hinweis ist nicht vorhanden.',0),(424548,11793,'en','The Note Does Not Exist',0),(424549,11794,'is','',0),(424550,11794,'dr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(424551,11794,'pr','Ù†Ù…Ø§ÙŠØ´ ÙƒØ¯ ÙƒØ§Ù„Ø§',0),(424552,11794,'tr','Madde kodu gÃ¶ster',0),(424553,11794,'pl','PokaÅ¼ kod towaru',0),(424554,11794,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð·Ð° ÑˆÐ¾ÑƒÑ‚Ð¾',0),(424555,11794,'ur','Ø´Û’ Ú©ÙˆÚˆ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(424556,11794,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(424557,11794,'vi','Thá»ƒ hiá»‡n code cá»§a máº·t hÃ ng',0),(424558,11794,'af','Wys Item kode',0),(424559,11794,'ro','AratÄƒ cod articol',0),(424560,11794,'et','NÃ¤ita kauba kood',0),(424561,11794,'si','PokaÅ¾i Å ifra artikla',0),(424562,11794,'ba','Tampilkan kode barang',0),(424563,11794,'nl','Object Code weergeven',0),(424564,11794,'fi','NÃ¤ytÃ¤ nimikkeen koodi',0),(424565,11794,'no','Vis Varekode',0),(424566,11794,'da','Vis varekode',0),(424567,11794,'ko','í•­ëª© ì½”ë“œ í‘œì‹œ',0),(424568,11794,'he','×”×¦×’ ×§×•×“ ×¤×¨×™×˜',0),(424569,11794,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎºÏ‰Î´Î¹ÎºÏŒÏ‚',0),(424570,11794,'zh','æ˜¾ç¤ºé¡¹ç›®ä»£ç \r\n',0),(424571,11794,'sv','Visa Artikelkod',0),(424572,11794,'it','Visualizza il codice articolo',0),(424573,11794,'tl','',0),(424574,11794,'th','à¹à¸ªà¸”à¸‡à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²',0),(424575,11794,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(424576,11794,'ms','Menunjukkan kod Item',0),(424577,11794,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù',0),(424578,11794,'fr','Afficher le Code article',0),(424579,11794,'jp','ã‚·ãƒ§ãƒ¼é …ç›®ã‚³ãƒ¼ãƒ‰',0),(424580,11794,'pt','Mostrar cÃ³digo de Item',0),(424581,11794,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(424582,11794,'es','Mostrar Código del artículo',0),(424583,11794,'de','Item-Code anzeigen',0),(424584,11794,'en','Show Item Code',0),(424585,11795,'is','',0),(424586,11795,'dr','Ù…Ø­Ù„ ÙƒØ¯ ÙƒØ§Ù„Ø§ Ø¯Ø± Ø¬Ø§ÙŠ Ù…Ù†Ø§Ø³Ø¨ Ø¨Ø±Ú†Ø³Ø¨',0),(424587,11795,'pr','Ù…Ø­Ù„ ÙƒØ¯ ÙƒØ§Ù„Ø§ Ø¯Ø± Ø¬Ø§ÙŠ Ù…Ù†Ø§Ø³Ø¨ Ø¨Ø±Ú†Ø³Ø¨',0),(424588,11795,'tr','Madde kodu bulunduÄŸu noktalarÄ± etiketi',0),(424589,11795,'pl','PoÅ‚oÅ¼enie elementu kodu na etykiecie w punktach',0),(424590,11795,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» ÐºÐ¾Ð´ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð° Ð² Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(424591,11795,'ur','Ù…ÛŒÚº Ù¾ÙˆØ§Ø¦Ù†Ù¹Ø³ Ù¾Ø± Ù„ÛŒØ¨Ù„ Ø´Û’ Ú©ÙˆÚˆ Ù¾ÙˆØ²ÛŒØ´Ù†',0),(424592,11795,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ»Ð° ÑˆÐ¸Ñ„Ñ€Ñƒ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ˜Ðµ Ð½Ð° Ð½Ð°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ð¸ Ñƒ Ñ‚Ð°Ñ‡ÐºÐ°Ð¼Ð°',0),(424593,11795,'vi','vá»‹ trÃ­ mÃ£ hÃ ng trÃªn nhÃ£n á»Ÿ trÃªn cÃ¡c Ä‘iá»ƒm',0),(424594,11795,'af','Item kode posisie op etiket In punte',0),(424595,11795,'ro','Element cod poziÅ£ia pe etichetÄƒ Ã®n puncte',0),(424596,11795,'et','Kauba koodi positsiooni etiketile punktid',0),(424597,11795,'si','Artikel koda poloÅ¾aj na etiketi toÄk',0),(424598,11795,'ba','Item kode posisi di Label dalam poin',0),(424599,11795,'nl','Object Code positie op de Label In punten',0),(424600,11795,'fi','Nimikkeen koodi kantaa etiketti pistettÃ¤',0),(424601,11795,'no','Element kode posisjon pÃ¥ etiketten poeng',0),(424602,11795,'da','Vare kode placering pÃ¥ etiketten i point',0),(424603,11795,'ko','í¬ì¸íŠ¸ì—ì„œ ë¼ë²¨ í•­ëª© ì½”ë“œ ìœ„ì¹˜',0),(424604,11795,'he','×¢×ž×“×” ×§×•×“ ×¤×¨×™×˜ ×‘×ª×•×•×™×ª ×‘× ×§×•×“×•×ª',0),(424605,11795,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Î¸Î­ÏƒÎ· ÏƒÏ„Î·Î½ ÎµÏ„Î¹ÎºÎ­Ï„Î± ÏƒÏ„Î± ÏƒÎ·Î¼ÎµÎ¯Î±',0),(424606,11795,'zh','æ ‡ç­¾ä¸Šçš„é¡¹ç›®ä»£ç ä½ç½®ç‚¹',0),(424607,11795,'sv','Objektet koden Position pÃ¥ etikett i poÃ¤ng',0),(424608,11795,'it','Posizione di codice articolo sull\'etichetta In punti',0),(424609,11795,'tl','',0),(424610,11795,'th','à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²à¸šà¸™à¸›à¹‰à¸²à¸¢à¹ƒà¸™à¸ˆà¸¸à¸”',0),(424611,11795,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤¬à¤¿à¤‚à¤¦à¥à¤“à¤‚ à¤®à¥‡à¤‚ à¤²à¥‡à¤¬à¤² à¤ªà¤° à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(424612,11795,'ms','Kedudukan kod item pada Label dalam mata',0),(424613,11795,'ar','Ù…ÙˆØ¶Ø¹ Ø±Ù…Ø² Ø§Ù„Ø¨Ù†Ø¯ Ø¹Ù„Ù‰ Ø§Ù„ØªØ³Ù…ÙŠØ© ÙÙŠ Ø§Ù„Ù†Ù‚Ø§Ø·',0),(424614,11795,'fr','Position de l\'Ã©lÃ©ment Code sur l\'Ã©tiquette en Points',0),(424615,11795,'jp','ãƒã‚¤ãƒ³ãƒˆ ãƒ©ãƒ™ãƒ«ã«é …ç›®ã‚³ãƒ¼ãƒ‰ä½ç½®',0),(424616,11795,'pt','PosiÃ§Ã£o do cÃ³digo de item no rÃ³tulo em pontos',0),(424617,11795,'ru','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÐºÐ¾Ð´Ð° Ð½Ð° ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐµ Ð² Ñ‚Ð¾Ñ‡ÐºÐ°Ñ…',0),(424618,11795,'es','Posición del artículo Código En la etiqueta en los puntos',0),(424619,11795,'de','Element Code Position auf Etikett In Punkten',0),(424620,11795,'en','Item Code Position On Label In Points',0),(424621,11796,'is','',0),(424622,11796,'dr','Ù†ÙˆØ¹ Ø¨Ø§Ø±ÙƒØ¯',0),(424623,11796,'pr','Ù†ÙˆØ¹ Ø¨Ø§Ø±ÙƒØ¯',0),(424624,11796,'tr','Barkod tipi',0),(424625,11796,'pl','Typ kodu kreskowego',0),(424626,11796,'bg','Ð‘Ð°Ñ€ÐºÐ¾Ð´ Ñ‚Ð¸Ð¿',0),(424627,11796,'ur','Ø¨Ø§Ø±Ú©ÙˆÚˆ Ù‚Ø³Ù…',0),(424628,11796,'sr','Ð¢Ð¸Ð¿ Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð°',0),(424629,11796,'vi','Loáº¡i mÃ£ váº¡ch',0),(424630,11796,'af','Strepieskode Tipe',0),(424631,11796,'ro','Tipul de coduri de bare',0),(424632,11796,'et','VÃ¶Ã¶tkoodi tÃ¼Ã¼p',0),(424633,11796,'si','Vrsto Ärtne kode',0),(424634,11796,'ba','Jenis barcode',0),(424635,11796,'nl','Barcode Type',0),(424636,11796,'fi','Viivakoodin tyyppi',0),(424637,11796,'no','Strekkodetypen',0),(424638,11796,'da','Stregkode Type',0),(424639,11796,'ko','ë°”ì½”ë“œ í˜•ì‹',0),(424640,11796,'he','×¡×•×’ ×‘×¨×§×•×“',0),(424641,11796,'el','Barcode Ï„ÏÏ€Î¿Ï…',0),(424642,11796,'zh','æ¡ç ç±»åž‹\r\n',0),(424643,11796,'sv','Streckkodstyp',0),(424644,11796,'it','Tipo di codice a barre',0),(424645,11796,'tl','',0),(424646,11796,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”',0),(424647,11796,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(424648,11796,'ms','Jenis Kod Bar',0),(424649,11796,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¨Ø§Ø±ÙƒÙˆØ¯',0),(424650,11796,'fr','Type de code Ã  barres',0),(424651,11796,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã®ç¨®é¡ž',0),(424652,11796,'pt','Tipo de cÃ³digo de barras',0),(424653,11796,'ru','Ð¢Ð¸Ð¿ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´Ð°',0),(424654,11796,'es','Tipo de código de barras',0),(424655,11796,'de','Barcodetyp',0),(424656,11796,'en','Barcode Type',0),(424657,11797,'is','',0),(424658,11797,'dr','ÙˆØ±ÙˆØ¯ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ Ø¢Ø±Ø´ÛŒÙˆ Ø´Ø¯Ù‡',0),(424659,11797,'pr','ÙˆØ±ÙˆØ¯ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ Ø¢Ø±Ø´ÛŒÙˆ Ø´Ø¯Ù‡',0),(424660,11797,'tr','ArÅŸivlenmiÅŸ fatura gÃ¼nlÃ¼ÄŸÃ¼',0),(424661,11797,'pl','Dziennika zarchiwizowanego faktur',0),(424662,11797,'bg','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ñ€ÐµÐ³Ð¸ÑÑ‚ÑŠÑ€',0),(424663,11797,'ur','Ø¬Ù…Ø¹ Ø´Ø¯Û ÙˆØ¨Ø¬Ù„ÛŒ Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº',0),(424664,11797,'sr','Ð•Ð²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ð° Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ð¸Ñ… Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(424665,11797,'vi','ÄÄƒng nháº­p lÆ°u trá»¯ HÃ³a Ä‘Æ¡n',0),(424666,11797,'af','Geargiveerde fakture Log',0),(424667,11797,'ro','Arhivate facturi jurnal',0),(424668,11797,'et','Arhiveeritud arvete Logi',0),(424669,11797,'si','Arhivirane raÄunov dnevnik',0),(424670,11797,'ba','Arsip faktur Log',0),(424671,11797,'nl','Gearchiveerde facturen Log',0),(424672,11797,'fi','Arkistoidut laskujen loki',0),(424673,11797,'no','Arkiverte fakturaer Logg',0),(424674,11797,'da','Arkiverede fakturaer Log',0),(424675,11797,'ko','ë³´ê´€ ëœ ì†¡ìž¥ ë¡œê·¸',0),(424676,11797,'he','×™×•×ž×Ÿ ×”×¨×™×©×•× ×”×ž××•×—×¡×Ÿ ×‘××¨×›×™×•×Ÿ ×—×©×‘×•× ×™×•×ª',0),(424677,11797,'el','Î‘ÏÏ‡ÎµÎ¹Î¿Î¸ÎµÏ„Î·Î¼Î­Î½Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎºÎ±Ï„Î±Î³ÏÎ±Ï†Î®Ï‚',0),(424678,11797,'zh','å‘ç¥¨è®°å½•å­˜æ¡£\r\n',0),(424679,11797,'sv','Arkiverade fakturor Log',0),(424680,11797,'it','Registro fatture archiviate',0),(424681,11797,'tl','',0),(424682,11797,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸–à¸²à¸§à¸£',0),(424683,11797,'hi','à¤†à¤°à¥à¤•à¤¾à¤‡à¤µà¥à¤¡ à¤šà¤¾à¤²à¤¾à¤¨ à¤²à¥‰à¤—',0),(424684,11797,'ms','Log Arkib invois',0),(424685,11797,'ar','Ø³Ø¬Ù„ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø¤Ø±Ø´ÙØ©',0),(424686,11797,'fr','Journal factures archivÃ©es',0),(424687,11797,'jp','è«‹æ±‚æ›¸ã®ã‚¢ãƒ¼ã‚«ã‚¤ãƒ–ã•ã‚ŒãŸãƒ­ã‚°',0),(424688,11797,'pt','Registo de facturas arquivadas',0),(424689,11797,'ru','ÐÑ€Ñ…Ð¸Ð² ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¶ÑƒÑ€Ð½Ð°Ð»',0),(424690,11797,'es','Bitacor de Facturas Archivadas',0),(424691,11797,'de','Archivierte Rechnungen Log',0),(424692,11797,'en','Archived Invoices Log',0),(424693,11798,'is','',0),(424694,11798,'dr','Ø¢Ø±Ø´ÛŒÙˆ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(424695,11798,'pr','Ø¢Ø±Ø´ÛŒÙˆ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(424696,11798,'tr','ArÅŸiv faturalar',0),(424697,11798,'pl','Archiwum faktur',0),(424698,11798,'bg','ÐÑ€Ñ…Ð¸Ð² Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(424699,11798,'ur','Ù…Ø­ÙÙˆØ¸ Ø´Ø¯Û Ø¯Ø³ØªØ§ÙˆÙŠØ²Ø§Øª ÙˆØ¨Ø¬Ù„ÛŒ',0),(424700,11798,'sr','ÐÑ€Ñ…Ð¸Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(424701,11798,'vi','HÃ³a Ä‘Æ¡n luu trá»¯.',0),(424702,11798,'af','Argief fakture',0),(424703,11798,'ro','Arhiva facturi',0),(424704,11798,'et','Arhiiv arved',0),(424705,11798,'si','Arhiv raÄunov',0),(424706,11798,'ba','Arsip faktur',0),(424707,11798,'nl','Archief facturen',0),(424708,11798,'fi','Arkisto laskut',0),(424709,11798,'no','Arkiv fakturaer',0),(424710,11798,'da','Arkiv fakturaer',0),(424711,11798,'ko','ì•„ì¹´ì´ë¸Œ ì²­êµ¬ì„œ',0),(424712,11798,'he','××¨×›×™×•×Ÿ ×—×©×‘×•× ×™×•×ª',0),(424713,11798,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(424714,11798,'zh','å­˜æ¡£å‘ç¥¨\r\n',0),(424715,11798,'sv','Arkiv fakturor',0),(424716,11798,'it','Archivio fatture',0),(424717,11798,'tl','',0),(424718,11798,'th','à¹€à¸à¹‡à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(424719,11798,'hi','à¤ªà¥à¤°à¤¾à¤²à¥‡à¤– à¤•à¥‡ à¤šà¤¾à¤²à¤¾à¤¨',0),(424720,11798,'ms','Arkib invois',0),(424721,11798,'ar','Ø£Ø±Ø´ÙŠÙ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(424722,11798,'fr','Archives de factures',0),(424723,11798,'jp','è«‹æ±‚æ›¸ã®ã‚¢ãƒ¼ã‚«ã‚¤ãƒ–',0),(424724,11798,'pt','Arquivo de facturas',0),(424725,11798,'ru','ÐÑ€Ñ…Ð¸Ð² ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(424726,11798,'es','Facturas Archivadas',0),(424727,11798,'de','Archiv-Rechnungen',0),(424728,11798,'en','Archive Invoices',0),(424729,11799,'is','',0),(424730,11799,'dr','Ø¢Ø±Ø´ÛŒÙˆ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¯Ø±Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÛŒØ® Ø²ÛŒØ± ',0),(424731,11799,'pr','Ø¢Ø±Ø´ÛŒÙˆ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¯Ø±Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÛŒØ® Ø²ÛŒØ± ',0),(424732,11799,'tr','Tarih aralÄ±ÄŸÄ±nda Ã¶denen faturalar ArÅŸiv',0),(424733,11799,'pl','Archiwum zapÅ‚aconej faktury w zakresie daty poniÅ¼ej',0),(424734,11799,'bg','ÐÑ€Ñ…Ð¸Ð² Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð² Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ',0),(424735,11799,'ur','ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…ÛŒÚº Ù†ÛŒÚ†Û’ ØªÙ†Ø®ÙˆØ§Û ÙˆØ¨Ø¬Ù„ÛŒ Ø¢Ø±Ú©Ø§Ø¦ÛŒÙˆ',0),(424736,11799,'sr','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›ÐµÐ½Ð¸Ñ… Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñƒ Ð¾Ð¿ÑÐµÐ³Ñƒ Ð´Ð°Ñ‚ÑƒÐ¼Ð°, ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ð´',0),(424737,11799,'vi','HÃ³a Ä‘Æ¡n Ä‘Ã£ tráº£ tiá»n trong pháº¡m vi ngÃ y dÆ°á»›i Ä‘Ã¢y',0),(424738,11799,'af','Argief betaalde fakture In die datum-reeks hieronder',0),(424739,11799,'ro','Arhiva facturile plÄƒtite Ã®n intervalul de Date de mai jos',0),(424740,11799,'et','Arhiiv makstud arvete kuupÃ¤evade vahemik',0),(424741,11799,'si','Arhiv plaÄanih raÄunov v datumskem obsegu, ki je spodaj',0),(424742,11799,'ba','Arsip membayar tagihan dalam rentang tanggal di bawah ini',0),(424743,11799,'nl','Betaalde facturen In het datumbereik hieronder archiveren',0),(424744,11799,'fi','Arkisto maksettujen laskujen alla pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤alue',0),(424745,11799,'no','Arkiv betalte fakturaer i datointervallet nedenfor',0),(424746,11799,'da','Arkiv betalte fakturaer i datointervallet nedenfor',0),(424747,11799,'ko','ì§€ë¶ˆëœ ì†¡ìž¥ ë‚ ì§œ ë²”ìœ„ ì•„ëž˜ì—ì„œ ë³´ê´€',0),(424748,11799,'he','××¨×›×™×•×Ÿ ×—×©×‘×•× ×™×•×ª ×©×©×•×œ×ž×• ×‘×ª×•×š ×˜×•×•×— ×”×ª××¨×™×›×™× ×©×œ×”×œ×Ÿ',0),(424749,11799,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ ÎµÏ€Î¯ Ï€Î»Î·ÏÏ‰Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½ ÏƒÏ„Î·Î½ Ï€ÎµÏÎ¹Î¿Ï‡Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ¬Ï„Ï‰',0),(424750,11799,'zh','å­˜æ¡£æ—¥æœŸèŒƒå›´ä¸­æ”¯ä»˜ä»¥ä¸‹å‘ç¥¨\r\n',0),(424751,11799,'sv','Arkiv betalda fakturor i intervallet nedan',0),(424752,11799,'it','Archivio fatture pagate nell\'intervallo data qui sotto',0),(424753,11799,'tl','',0),(424754,11799,'th','à¹€à¸à¹‡à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸™à¸Šà¹ˆà¸§à¸‡à¸§à¸±à¸™à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡',0),(424755,11799,'hi','à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤®à¥‡à¤‚ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¥à¤°à¤¾à¤²à¥‡à¤–',0),(424756,11799,'ms','Arkib invois dibayar dalam julat tarikh yang di bawah',0),(424757,11799,'ar','Ø£Ø±Ø´ÙŠÙ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© ÙÙŠ Ù†Ø·Ø§Ù‚ Ø§Ù„ØªØ§Ø±ÙŠØ® Ø£Ø¯Ù†Ø§Ù‡',0),(424758,11799,'fr','Archiver les factures payÃ©es dans la plage de dates ci-dessous',0),(424759,11799,'jp','æ—¥ä»˜ã®ç¯„å›²ã®ä¸‹ã§æ”¯æ‰•ã„æ¸ˆã¿è«‹æ±‚æ›¸ã‚’ã‚¢ãƒ¼ã‚«ã‚¤ãƒ–ã—ã¾ã™ã€‚',0),(424760,11799,'pt','Arquivar facturas pagas em intervalo de datas abaixo',0),(424761,11799,'ru','ÐÑ€Ñ…Ð¸Ð² Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð° Ð² Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ðµ Ð½Ð¸Ð¶Ðµ',0),(424762,11799,'es','Archivar Facturas Pagadas en el Rango de Fechas Abajo',0),(424763,11799,'de','Archiv bezahlte Rechnungen im Bereich Datum',0),(424764,11799,'en','Archive Paid Invoices In The Date Range Below',0),(424765,11800,'is','',0),(424766,11800,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø²ÛŒØ± Ø±Ø§ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ú©Ù†ÛŒØ¯ØŸ',0),(424767,11800,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø²ÛŒØ± Ø±Ø§ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ú©Ù†ÛŒØ¯ØŸ',0),(424768,11800,'tr','FaturalarÄ± aÅŸaÄŸÄ±daki aralÄ±ktaki arÅŸivlemek istediÄŸiniz emin misiniz',0),(424769,11800,'pl','Czy jesteÅ› pewien, Å¼e chcesz do archiwum faktur w zakresie',0),(424770,11800,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð² ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(424771,11800,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…ÛŒÚº ÙˆØ¨Ø¬Ù„ÛŒ Ø°Ø®ÛŒØ±Û Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº',0),(424772,11800,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð·Ð° ÑÐ»ÐµÐ´ÐµÑ›Ð¸ Ð¾Ð¿ÑÐµÐ³',0),(424773,11800,'vi','báº¡n cÃ³ cháº¯c cáº§n lÆ°u trá»¯ hÃ³a Ä‘Æ¡n nÃ y trong pháº¡m vi theo sau Ä‘Ã¢y?',0),(424774,11800,'af','Is jy seker jy wil argiveer fakture in die volgende reeks',0),(424775,11800,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ arhivaÅ£i facturi Ã®n urmÄƒtorul interval',0),(424776,11800,'et','Kas kindlasti jÃ¤rgmisi arvete Arhiiv',0),(424777,11800,'si','Ali ste prepriÄani, da Å¾elite arhivirati raÄunov v tem obsegu',0),(424778,11800,'ba','Apakah Anda yakin Anda ingin mengarsipkan faktur di kisaran berikut',0),(424779,11800,'nl','Weet u zeker dat u wilt archiveren van facturen in het volgende bereik',0),(424780,11800,'fi','Oletko varma, ettÃ¤ haluat arkistoida laskut ovat seuraavalla alueella',0),(424781,11800,'no','Er du sikker du vil arkivere fakturaer i fÃ¸lgende omrÃ¥de',0),(424782,11800,'da','Er du sikker pÃ¥, du vil arkivere fakturaer i fÃ¸lgende',0),(424783,11800,'ko','ë‹¹ì‹ ì€ ë‹¤ìŒê³¼ ê°™ì€ ë²”ìœ„ì—ì„œ ì†¡ìž¥ì„ ë³´ê´€ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ',0),(424784,11800,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ××—×¡×Ÿ ×‘××¨×›×™×•×Ÿ ×—×©×‘×•× ×™×•×ª ×‘×˜×•×•×— ×©×œ×”×œ×Ÿ',0),(424785,11800,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î±ÏÏ‡ÎµÎ¹Î¿Î¸ÎµÏ„Î®ÏƒÎµÏ„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÏƒÏ„Î·Î½ Ï€ÎµÏÎ¹Î¿Ï‡Î® Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰',0),(424786,11800,'zh','ä½ ç¡®å®šåœ¨ä¸‹åˆ—èŒƒå›´å†…è¦å­˜æ¡£å‘ç¥¨\r\n',0),(424787,11800,'sv','Ã„r du sÃ¤ker du vill arkivera fakturor i fÃ¶ljande sortiment',0),(424788,11800,'it','Sei sicuro che si desidera archiviare fatture nell\'intervallo seguente',0),(424789,11800,'tl','',0),(424790,11800,'th','à¸•à¹‰à¸­à¸‡à¹€à¸à¹‡à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸™à¸Šà¹ˆà¸§à¸‡à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(424791,11800,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤¨à¤¿à¤®à¥à¤¨ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤®à¥‡à¤‚ à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤‚à¤—à¥à¤°à¤¹ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(424792,11800,'ms','Adakah anda pasti anda hendak mengarkibkan invois dalam julat berikut',0),(424793,11800,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø£Ø±Ø´ÙØ© Ø§Ù„ÙÙˆØ§ØªÙŠØ± ÙÙŠ Ø§Ù„Ù†Ø·Ø§Ù‚ Ø§Ù„ØªØ§Ù„ÙŠ',0),(424794,11800,'fr','ÃŠtes-vous sÃ»r que vous voulez archiver les factures dans la plage suivante',0),(424795,11800,'jp','æ¬¡ã®ç¯„å›²ã§è«‹æ±‚æ›¸ã®ã‚¢ãƒ¼ã‚«ã‚¤ãƒ–ã‚ˆã‚ã—ã„ã§ã™ã€‚',0),(424796,11800,'pt','Tens a certeza de que vocÃª deseja arquivar faturas no intervalo a seguir',0),(424797,11800,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÐÑ€Ñ…Ð¸Ð² ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€ Ð² ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ¼ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ðµ',0),(424798,11800,'es','Â¿Esta seguro que quiere archivar facturas en el siguiente rango?',0),(424799,11800,'de','Sind Sie sicher, dass Sie Rechnungen im folgenden Bereich archivieren mÃ¶chten',0),(424800,11800,'en','Are you sure you want to archive invoices in the following range',0),(424801,11801,'is','',0),(424802,11801,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(424803,11801,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(424804,11801,'tr','Toplu iÅŸ KÄ±mlÄ±ÄŸÄ±',0),(424805,11801,'pl','Identyfikator partia',0),(424806,11801,'bg','Ð˜Ð” Ð½Ð° Ð¿Ð°Ð¿ÐºÐ°',0),(424807,11801,'ur','Ø¨ÛŒÚ† Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(424808,11801,'sr','Ð˜Ð” Ð³Ñ€ÑƒÐ¿Ðµ',0),(424809,11801,'vi','LÃ´ ID',0),(424810,11801,'af','Bondel ID',0),(424811,11801,'ro','Lot ID',0),(424812,11801,'et','Partii ID',0),(424813,11801,'si','Serija ID',0),(424814,11801,'ba','Batch ID',0),(424815,11801,'nl','Batch ID',0),(424816,11801,'fi','ErÃ¤n tunnus',0),(424817,11801,'no','Parti-ID',0),(424818,11801,'da','Parti-ID',0),(424819,11801,'ko','ì¼ê´„ ì²˜ë¦¬ ID',0),(424820,11801,'he','×ž×–×”×” ×”××¦×•×•×”',0),(424821,11801,'el','ÎœÎ±Î¶Î¹ÎºÎ® ID',0),(424822,11801,'zh','æ‰¹æ¬¡ID\r\n',0),(424823,11801,'sv','Batch-ID',0),(424824,11801,'it','ID batch',0),(424825,11801,'tl','',0),(424826,11801,'th','à¸£à¸«à¸±à¸ªà¸Šà¸¸à¸”à¸‡à¸²à¸™',0),(424827,11801,'hi','à¤¬à¥ˆà¤š ID',0),(424828,11801,'ms','ID Kumpulan',0),(424829,11801,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(424830,11801,'fr','ID du lot',0),(424831,11801,'jp','ãƒãƒƒãƒ ID',0),(424832,11801,'pt','ID do lote',0),(424833,11801,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð¿Ð°ÐºÐµÑ‚Ð°',0),(424834,11801,'es','ID de Batch',0),(424835,11801,'de','Batch-ID',0),(424836,11801,'en','Batch ID',0),(424837,11802,'is','',0),(424838,11802,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø´Ø¯Ù‡',0),(424839,11802,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø´Ø¯Ù‡',0),(424840,11802,'tr','ArÅŸivlenmiÅŸ faturalar',0),(424841,11802,'pl','Faktury archiwalne',0),(424842,11802,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ð¸',0),(424843,11802,'ur','Ù…Ø­ÙÙˆØ¸Û ÙˆØ¨Ø¬Ù„ÛŒ',0),(424844,11802,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ð¾',0),(424845,11802,'vi','ÄÃ£ lÆ°u hÃ³a Ä‘Æ¡n',0),(424846,11802,'af','Fakture geargiveer',0),(424847,11802,'ro','Facturi arhivate',0),(424848,11802,'et','Arhiveeritud arved',0),(424849,11802,'si','RaÄune arhivirati',0),(424850,11802,'ba','Faktur Diarsipkan',0),(424851,11802,'nl','Facturen gearchiveerd',0),(424852,11802,'fi','Laskut arkistoidaan',0),(424853,11802,'no','Fakturaer arkivert',0),(424854,11802,'da','Fakturaer arkiveret',0),(424855,11802,'ko','ì˜ìˆ˜ì¦ ë³´ê´€',0),(424856,11802,'he','×—×©×‘×•× ×™×•×ª ×‘××¨×›×™×•×Ÿ',0),(424857,11802,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… Î±ÏÏ‡ÎµÎ¹Î¿Î¸ÎµÏ„Î¿ÏÎ½Ï„Î±Î¹',0),(424858,11802,'zh','å‘ç¥¨å­˜æ¡£\r\n',0),(424859,11802,'sv','Fakturor arkiverade',0),(424860,11802,'it','Fatture archiviate',0),(424861,11802,'tl','',0),(424862,11802,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸–à¸²à¸§à¸£',0),(424863,11802,'hi','à¤®à¥‡à¤‚ à¤†à¤°à¥à¤•à¤¾à¤‡à¤µà¥à¤¡ à¤šà¤¾à¤²à¤¾à¤¨',0),(424864,11802,'ms','Invois-invois yang diarkibkan',0),(424865,11802,'ar','Ø£Ø±Ø´ÙØ© Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(424866,11802,'fr','Factures archivÃ©es',0),(424867,11802,'jp','è«‹æ±‚æ›¸ã®ã‚¢ãƒ¼ã‚«ã‚¤ãƒ–',0),(424868,11802,'pt','Facturas arquivadas',0),(424869,11802,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð² Ð°Ñ€Ñ…Ð¸Ð²',0),(424870,11802,'es','Facturas Archivadas',0),(424871,11802,'de','Archivierte Rechnungen',0),(424872,11802,'en','Invoices Archived',0),(424873,11803,'is','',0),(424874,11803,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø´Ø¯',0),(424875,11803,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø´Ø¯',0),(424876,11803,'tr','BaÅŸarÄ±yla arÅŸivlenmiÅŸ faturalar',0),(424877,11803,'pl','Faktury zarchiwizowane',0),(424878,11803,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸, Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(424879,11803,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸Û ÙˆØ¨Ø¬Ù„ÛŒ',0),(424880,11803,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ð¾',0),(424881,11803,'vi','ÄÃ£ lÆ°u hÃ³a Ä‘Æ¡n thÃ nh cÃ´ng',0),(424882,11803,'af','Fakture geargiveer suksesvol',0),(424883,11803,'ro','Facturi arhivat cu succes',0),(424884,11803,'et','Arhiveeritud edukalt arved',0),(424885,11803,'si','RaÄune arhivirati uspeÅ¡no',0),(424886,11803,'ba','Faktur Diarsipkan berhasil',0),(424887,11803,'nl','Facturen met succes gearchiveerde',0),(424888,11803,'fi','Laskut arkistoidaan onnistuneesti',0),(424889,11803,'no','Fakturaer arkivert vellykket',0),(424890,11803,'da','Fakturaer arkiveret held',0),(424891,11803,'ko','ì„±ê³µì ìœ¼ë¡œ ë³´ê´€ ëœ ì²­êµ¬ì„œ',0),(424892,11803,'he','×—×©×‘×•× ×™×•×ª ×‘××¨×›×™×•×Ÿ ×‘×”×¦×œ×—×”',0),(424893,11803,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… Î±ÏÏ‡ÎµÎ¹Î¿Î¸ÎµÏ„Î¿ÏÎ½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(424894,11803,'zh','æˆåŠŸå½’æ¡£å‘ç¥¨\r\n',0),(424895,11803,'sv','Fakturor arkiverade framgÃ¥ngsrikt',0),(424896,11803,'it','Fatture archiviate con successo',0),(424897,11803,'tl','',0),(424898,11803,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸–à¸²à¸§à¸£à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(424899,11803,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤°à¥à¤•à¤¾à¤‡à¤µà¥à¤¡',0),(424900,11803,'ms','Invois-invois yang diarkibkan berjaya',0),(424901,11803,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(424902,11803,'fr','Factures archivÃ©es avec succÃ¨s',0),(424903,11803,'jp','è«‹æ±‚æ›¸ãŒæ­£å¸¸ã«ã‚¢ãƒ¼ã‚«ã‚¤ãƒ–',0),(424904,11803,'pt','Facturas arquivadas com sucesso',0),(424905,11803,'ru','ÐÐ°ÐºÐ»Ð°Ð´Ð½Ñ‹Ñ… Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€ÑƒÑŽÑ‚ÑÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(424906,11803,'es','Facturas Archivadas Exitosamente',0),(424907,11803,'de','Rechnungen archiviert erfolgreich',0),(424908,11803,'en','Invoices Archived Successfully',0),(424909,11804,'is','',0),(424910,11804,'dr','Ø®Ù„Ø§ØµÙ‡ Ø«Ø¨Øª Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø¨Ø§',0),(424911,11804,'pr','Ø®Ù„Ø§ØµÙ‡ Ø«Ø¨Øª Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø¨Ø§',0),(424912,11804,'tr','GL girdileri tarafÄ±ndan Ã¶zetlemek',0),(424913,11804,'pl','PodsumowujÄ…c wpisy w GL',0),(424914,11804,'bg','ÐžÐ±Ð¾Ð±Ñ‰Ð¸ GL Ð·Ð°Ð¿Ð¸ÑÐ¸Ñ‚Ðµ Ð¾Ñ‚',0),(424915,11804,'ur','Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø®Ù„Ø§ØµÛ',0),(424916,11804,'sr','Ð ÐµÐ·Ð¸Ð¼Ð¸Ñ€Ð°ÑšÐµ Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ð¾',0),(424917,11804,'vi','Tá»•ng káº¿t Ä‘áº§u vÃ o GL bá»Ÿi',0),(424918,11804,'af','GL inskrywings volgens som',0),(424919,11804,'ro','Rezuma GL Ã®nregistrÄƒri de',0),(424920,11804,'et','KokkuvÃµttes GL VÃµistlustÃ¶id',0),(424921,11804,'si','Povzeti GL vnose, ki jih',0),(424922,11804,'ba','Meringkas GL entri oleh',0),(424923,11804,'nl','GL Entries door samenvatten',0),(424924,11804,'fi','TiivistÃ¤Ã¤ GL merkinnÃ¤t',0),(424925,11804,'no','Oppsummere GL oppfÃ¸ringer av',0),(424926,11804,'da','Opsummere GL poster af',0),(424927,11804,'ko','í•˜ ì—¬ GL í•­ëª© ìš”ì•½',0),(424928,11804,'he','×œ×¡×›× GL ×”×¢×¨×›×™× ×¢×œ ×™×“×™',0),(424929,11804,'el','Î£Ï…Î½Î¿ÏˆÎ¯ÏƒÏ„Îµ Ï„Î¹Ï‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î±Ï€ÏŒ GL',0),(424930,11804,'zh','æ±‡æ€»æ€»å¸æ¡ç›®æ–¹å¼\r\n',0),(424931,11804,'sv','Sammanfatta GL poster av',0),(424932,11804,'it','Riassumere GL voci di',0),(424933,11804,'tl','',0),(424934,11804,'th','à¸ªà¸£à¸¸à¸›à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¹‚à¸”à¸¢',0),(424935,11804,'hi','à¤œà¥€à¤à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤‚à¤•à¥à¤·à¥‡à¤ª à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤ à¤•à¤°à¤¨à¤¾',0),(424936,11804,'ms','Meringkaskan GL penyertaan oleh',0),(424937,11804,'ar','ØªÙ„Ø®ÙŠØµ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª GL Ù‚Ø¨Ù„',0),(424938,11804,'fr','RÃ©sumer GL entrÃ©es par',0),(424939,11804,'jp','ã«ã‚ˆã‚‹ GL ã‚¨ãƒ³ãƒˆãƒªã‚’ã¾ã¨ã‚ã‚‹',0),(424940,11804,'pt','Resumir as entradas GL por',0),(424941,11804,'ru','Ð¡ÑƒÐ¼Ð¼Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ GL Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð²',0),(424942,11804,'es','Sumarizar Entradas de LM Por',0),(424943,11804,'de','GL-EintrÃ¤ge von zusammenfassen',0),(424944,11804,'en','Summarize GL Entries By',0),(424945,11805,'is','',0),(424946,11805,'dr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø±Ø§ Ø¨ÙØ±Ø³ØªÛŒØ¯ Ø²Ù…Ø§Ù†ÛŒ Ú©Ù‡ Ø³ÙØ§Ø±Ø´ Ú©Ø§Ù…Ù„ Ø´Ø¯Ù‡ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯',0),(424947,11805,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø±Ø§ Ø¨ÙØ±Ø³ØªÛŒØ¯ Ø²Ù…Ø§Ù†ÛŒ Ú©Ù‡ Ø³ÙØ§Ø±Ø´ Ú©Ø§Ù…Ù„ Ø´Ø¯Ù‡ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯',0),(424948,11805,'tr','KarÅŸÄ±lama sipariÅŸi oluÅŸturduÄŸunuzda Anketi GÃ¶nder',0),(424949,11805,'pl','WyÅ›lij badania podczas realizacji zamÃ³wienia',0),(424950,11805,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(424951,11805,'ur','Ø¬Ø¨ ØªÚ©Ù…ÛŒÙ„ Ø­Ú©Ù…Ù†Ø§Ù…Û’ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ø³Ø±ÙˆÛ’ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(424952,11805,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð°Ð½ÐºÐµÑ‚Ñƒ ÐºÐ°Ð´Ð° Ñ˜Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ',0),(424953,11805,'vi','Gá»­i kháº£o sÃ¡t khi Ä‘Æ¡n hÃ ng hoÃ n chá»‰nh Ä‘Ã£ Ä‘Æ°á»£c táº¡o',0),(424954,11805,'af','Opname te stuur wanneer vervulling orde geskep',0),(424955,11805,'ro','Trimite anchetÄƒ cÃ¢nd ordinea Ã®mplinirea a creat',0),(424956,11805,'et','Kui plaanitud tellimus loodud saatke uuring',0),(424957,11805,'si','PoÅ¡lji anketo, ko izpolnitev nalog',0),(424958,11805,'ba','Kirim survei ketika menciptakan pemenuhan Order',0),(424959,11805,'nl','Verzenden enquÃªte wanneer vervulling Order gemaakt',0),(424960,11805,'fi','LÃ¤hetÃ¤ kysely tÃ¤yttÃ¶tilaus luotaessa',0),(424961,11805,'no','Sende undersÃ¸kelse nÃ¥r innfrielsesordren opprettet',0),(424962,11805,'da','Send undersÃ¸gelse nÃ¥r opfyldelsesordre lavet',0),(424963,11805,'ko','í–‰ ìˆœì„œë¥¼ ë§Œë“¤ ë•Œ ì„¤ë¬¸ ì¡°ì‚¬ë¥¼ ë³´ë‚´',0),(424964,11805,'he','×©×œ×— ×¡×§×¨ ×‘×¢×ª ×™×¦×™×¨×ª ×¡×“×¨ ×”×’×©×ž×”',0),(424965,11805,'el','Î‘Ï€Î¿ÏƒÏ„ÎµÎ¯Î»Ï„Îµ Ï„Î·Î½ Î­ÏÎµÏ…Î½Î± ÏŒÏ„Î±Î½ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î· ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(424966,11805,'zh','å½“å±¥è¡Œé¡ºåºåˆ›å»ºæ—¶å‘é€è°ƒæŸ¥æ´»åŠ¨\r\n',0),(424967,11805,'sv','Skicka enkÃ¤ten nÃ¤r uppfyllelseorder skapas',0),(424968,11805,'it','Invia sondaggio quando l\'ordine di evasione creato',0),(424969,11805,'tl','',0),(424970,11805,'th','à¸ªà¹ˆà¸‡à¹à¸šà¸šà¸ªà¸³à¸£à¸§à¸ˆà¹€à¸¡à¸·à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(424971,11805,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤œà¤¬ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤­à¥‡à¤œà¥‡à¤‚',0),(424972,11805,'ms','Hantar kajian apabila memenuhi perintah dicipta',0),(424973,11805,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¡ Ø¹Ù†Ø¯ Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ø§Ù„Ø§Ø³ØªÙŠÙØ§Ø¡',0),(424974,11805,'fr','Envoyez l\'enquÃªte lors de la crÃ©ation des ordres de traitement',0),(424975,11805,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼ã®ä½œæˆæ™‚ã«èª¿æŸ»ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(424976,11805,'pt','Enviar InquÃ©rito quando criado em ordem de cumprimento',0),(424977,11805,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ, ÐºÐ¾Ð³Ð´Ð° Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(424978,11805,'es','Mandar Encuesta Cuando Crear Un Orden de Cumplimiento',0),(424979,11805,'de','Umfrage zu senden, bei der Erstellung von AusfÃ¼hrungsauftrag',0),(424980,11805,'en','Send Survey When Fulfillment Order Created',0),(424981,11806,'is','',0),(424982,11806,'dr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø±Ø§ Ø¨ÙØ±Ø³ØªÛŒØ¯ Ø²Ù…Ø§Ù†ÛŒ Ú©Ù‡ ÙØ§Ú©ØªÙˆØ± Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯',0),(424983,11806,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø±Ø§ Ø¨ÙØ±Ø³ØªÛŒØ¯ Ø²Ù…Ø§Ù†ÛŒ Ú©Ù‡ ÙØ§Ú©ØªÙˆØ± Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯',0),(424984,11806,'tr','POS fatura oluÅŸturduÄŸunuz zaman anket gÃ¶ndermek',0),(424985,11806,'pl','WyÅ›lij badania podczas tworzenia faktury POS',0),(424986,11806,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° POS',0),(424987,11806,'ur','Ø¬Ø¨ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¨Ù†Ø§ÛŒØ§ Ø³Ø±ÙˆÛ’ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(424988,11806,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð°Ð½ÐºÐµÑ‚Ñƒ ÐºÐ°Ð´Ð° ÐŸÐžÐ¡ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°',0),(424989,11806,'vi','Gá»­i kháº£o sÃ¡t khi hÃ³a Ä‘Æ¡n POS Ä‘Æ°á»£c táº¡o',0),(424990,11806,'af','Opname te stuur wanneer POS faktuur geskep',0),(424991,11806,'ro','Trimite anchetÄƒ cÃ¢nd POS facturÄƒ creatÄƒ',0),(424992,11806,'et','Saada uuringu POS arve loomisel',0),(424993,11806,'si','PoÅ¡lji anketo, ko POS raÄun ustvarjen',0),(424994,11806,'ba','Mengirim survei ketika POS faktur dibuat',0),(424995,11806,'nl','Verzenden enquÃªte wanneer POS factuur gemaakt',0);
INSERT INTO `langdef` VALUES (424996,11806,'fi','LÃ¤hetÃ¤ kysely POS laskun luomisen',0),(424997,11806,'no','Sende undersÃ¸kelse nÃ¥r POS fakturaen opprettet',0),(424998,11806,'da','Send undersÃ¸gelse nÃ¥r POS fakturaen oprettes',0),(424999,11806,'ko','POS ì¸ë³´ì´ìŠ¤ë¥¼ ë§Œë“¤ ë•Œ ì„¤ë¬¸ ì¡°ì‚¬ë¥¼ ë³´ë‚´',0),(425000,11806,'he','×©×œ×— ×¡×§×¨ ×‘×¢×ª ×™×¦×™×¨×ª ×—×©×‘×•× ×™×•×ª ×§×•×¤×”',0),(425001,11806,'el','Î‘Ï€Î¿ÏƒÏ„ÎµÎ¯Î»Ï„Îµ Ï„Î·Î½ Î­ÏÎµÏ…Î½Î± ÏŒÏ„Î±Î½ POS Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ',0),(425002,11806,'zh','å½“é”€å”®ç‚¹å‘ç¥¨åˆ›å»ºæ—¶å‘é€è°ƒæŸ¥\r\n',0),(425003,11806,'sv','Skicka enkÃ¤ten nÃ¤r POS faktura skapas',0),(425004,11806,'it','Invia sondaggio quando POS fattura creata',0),(425005,11806,'tl','',0),(425006,11806,'th','à¸ªà¹ˆà¸‡à¹à¸šà¸šà¸ªà¸³à¸£à¸§à¸ˆà¹€à¸¡à¸·à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ POS',0),(425007,11806,'hi','à¤œà¤¬ POS à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤­à¥‡à¤œà¥‡à¤‚',0),(425008,11806,'ms','Hantar kajian apabila invois POS dicipta',0),(425009,11806,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¡ Ø¹Ù†Ø¯ Ø¥Ù†Ø´Ø§Ø¡ ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(425010,11806,'fr','Envoyer enquÃªte lors de la crÃ©ation de la facture de POS',0),(425011,11806,'jp','POS ã®è«‹æ±‚æ›¸ã‚’ä½œæˆã™ã‚‹ã¨ãã«èª¿æŸ»ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(425012,11806,'pt','Enviar InquÃ©rito quando POS factura criado',0),(425013,11806,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ ÑÑ‡ÐµÑ‚Ð° POS',0),(425014,11806,'es','Mandar Encuesta Cuando Crear Una Factura de PDV',0),(425015,11806,'de','Umfrage zu senden, wenn POS Rechnung erstellt',0),(425016,11806,'en','Send Survey When POS Invoice Created',0),(425017,11807,'is','',0),(425018,11807,'dr','Ù…Ø­Ù„ Ù‚ÙØ³Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø±ÙˆÛŒ Ø¨Ø±Ú†Ø³Ø¨',0),(425019,11807,'pr','Ù…Ø­Ù„ Ù‚ÙØ³Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø±ÙˆÛŒ Ø¨Ø±Ú†Ø³Ø¨',0),(425020,11807,'tr','Etiket Ã¼zerindeki BIN/raf bulunduÄŸu noktalarÄ±',0),(425021,11807,'pl','Stanowisko bin/pÃ³Å‚ka na etykiecie w punktach',0),(425022,11807,'bg','Ð¡Ðš/ÑÑ‚ÐµÐ»Ð°Ð¶ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð° Ð² Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(425023,11807,'ur','Ù„ÛŒØ¨Ù„ Ù¾Ø± Ø¨Ù†/Ø´ÛŒÙ„Ù Ù¾ÙˆØ²ÛŒØ´Ù† Ù†Ú©Ø§Øª Ù…ÛŒÚº',0),(425024,11807,'sr','Ð‘Ð¸Ð½ /Ð¿Ð¾Ð»Ð¸Ñ†Ð° Ð¿Ð¾Ð»Ð¾Ð¶Ð°Ñ˜ Ð½Ð° Ð¾Ð·Ð½Ð°ÐºÑƒ Ñƒ Ñ‚Ð°Ñ‡ÐºÐ°Ð¼Ð°',0),(425025,11807,'vi','Vá»‹ trÃ­ sá»t rÃ¡c/ ká»‡ sÃ¡ch trÃªn nhÃ£n táº¡i cÃ¡c Ä‘iá»ƒm',0),(425026,11807,'af','Asblik/rak posisie op etiket In punte',0),(425027,11807,'ro','PoziÅ£ia bin/raft pe etichetÄƒ Ã®n puncte',0),(425028,11807,'et','Bin/riiul positsiooni etiketile punktid',0),(425029,11807,'si','Bin/polica poloÅ¾aj na etiketi toÄk',0),(425030,11807,'ba','Posisi bin rak pada Label dalam poin',0),(425031,11807,'nl','Bin/plank positie op de Label In punten',0),(425032,11807,'fi','Bin/hylly kantaa etiketti pistettÃ¤',0),(425033,11807,'no','Bin/sokkel posisjon pÃ¥ etiketten poeng',0),(425034,11807,'da','Bin/hylde placering pÃ¥ etiketten i point',0),(425035,11807,'ko','í¬ì¸íŠ¸ì—ì„œ ë¼ë²¨ì— ë¹ˆ/ì„ ë°˜ ìœ„ì¹˜',0),(425036,11807,'he','×¡×œ ××• ×ž×“×£ ×‘×¢×ž×“×” ×¢×œ ×ª×•×•×™×ª × ×§×•×“×•×ª',0),(425037,11807,'el','Bin/ÏÎ¬Ï†Î¹ Î¸Î­ÏƒÎ· ÏƒÏ„Î·Î½ ÎµÏ„Î¹ÎºÎ­Ï„Î± ÏƒÏ„Î± ÏƒÎ·Î¼ÎµÎ¯Î±',0),(425038,11807,'zh','è£…è®¢/æ ‡ç­¾ä¸Šçš„è´§æž¶ä¸Šçš„ä½ç½®ç‚¹\r\n',0),(425039,11807,'sv','Bin/hylla Position pÃ¥ etikett i poÃ¤ng',0),(425040,11807,'it','Bin/mensola posizione sull\'etichetta In punti',0),(425041,11807,'tl','',0),(425042,11807,'th','à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸Šà¹ˆà¸­à¸‡à¹€à¸à¹‡à¸š/à¸Šà¸±à¹‰à¸™à¸šà¸™à¸›à¹‰à¸²à¸¢à¹ƒà¸™à¸ˆà¸¸à¸”',0),(425043,11807,'hi','à¤¬à¤¿à¤‚à¤¦à¥à¤“à¤‚ à¤®à¥‡à¤‚ à¤²à¥‡à¤¬à¤² à¤ªà¤° à¤¬à¤¿à¤¨/à¤¶à¥‡à¤²à¥à¤« à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(425044,11807,'ms','Kedudukan bin/rak pada Label dalam mata',0),(425045,11807,'ar','Ù…ÙˆÙ‚Ù Ø¨Ù†/Ø§Ù„Ø¬Ø±Ù Ø¹Ù„Ù‰ Ø§Ù„ØªØ³Ù…ÙŠØ© ÙÙŠ Ø§Ù„Ù†Ù‚Ø§Ø·',0),(425046,11807,'fr','Bin/Ã©tagÃ¨re Position sur l\'Ã©tiquette en Points',0),(425047,11807,'jp','ä½ç½®ã‚’ãƒã‚¤ãƒ³ãƒˆå˜ä½ã§ã®ãƒ©ãƒ™ãƒ«ã®ç®±/æ£š',0),(425048,11807,'pt','PosiÃ§Ã£o bin/prateleira no rÃ³tulo em pontos',0),(425049,11807,'ru','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ñ Ð±Ð¸Ð½ Ð½Ð° Ð¿Ð¾Ð»ÐºÑƒ Ð½Ð° ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐµ Ð² Ñ‚Ð¾Ñ‡ÐºÐ°Ñ…',0),(425050,11807,'es','Position de Bin/Shelf En la Etiqueta en Puntos',0),(425051,11807,'de','Bin/Regal Position auf Etikett In Punkten',0),(425052,11807,'en','Bin/Shelf Position On Label In Points',0),(425053,11808,'is','',0),(425054,11808,'dr','ÙÙ‚Ø· ÛŒÚ© Ø¨Ø±Ú†Ø³Ø¨ Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ù‡Ø± Ú©Ø§Ù„Ø§ Ú†Ø§Ù¾ Ú©Ù†ÛŒØ¯',0),(425055,11808,'pr','ÙÙ‚Ø· ÛŒÚ© Ø¨Ø±Ú†Ø³Ø¨ Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ù‡Ø± Ú©Ø§Ù„Ø§ Ú†Ø§Ù¾ Ú©Ù†ÛŒØ¯',0),(425056,11808,'tr','Sadece her Ã¶ÄŸe iÃ§in tek bir etiket yazdÄ±rmak',0),(425057,11808,'pl','WydrukowaÄ‡ tylko jednÄ… etykietÄ™ za sztukÄ™',0),(425058,11808,'bg','ÐŸÐµÑ‡Ð°Ñ‚ ÑÐ°Ð¼Ð¾ ÐµÐ´Ð¸Ð½ ÐµÑ‚Ð¸ÐºÐµÑ‚ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(425059,11808,'ur','ØµØ±Ù Ø§ÛŒÚ© Ù„ÛŒØ¨Ù„ Ø´Û’ ÙÛŒ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(425060,11808,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ñ˜ÐµÐ´Ð½Ñƒ ÐµÑ‚Ð¸ÐºÐµÑ‚Ñƒ Ð¿Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ñƒ',0),(425061,11808,'vi','Chá»‰ in má»™t nhÃ£n cho 1 sáº£n pháº©m',0),(425062,11808,'af','Druk slegs een etiket Per Item',0),(425063,11808,'ro','Imprima numai o singurÄƒ etichetÄƒ pe articol',0),(425064,11808,'et','Saate printida ainult Ã¼he sildi kohta',0),(425065,11808,'si','Samo natisniti eno nalepko za artikel',0),(425066,11808,'ba','Hanya mencetak satu Label Per Item',0),(425067,11808,'nl','Slechts Ã©Ã©n etiket Per Item afdrukken',0),(425068,11808,'fi','Tulosta vain yksi merkintÃ¤ Per tuote',0),(425069,11808,'no','Bare skriv en etikett Per vare',0),(425070,11808,'da','Kun udskrive Ã©n etiket pr. vare',0),(425071,11808,'ko','í•­ëª© ë§ˆë‹¤ í•˜ë‚˜ì˜ ë¼ë²¨ ì¶œë ¥',0),(425072,11808,'he','×¨×§ ×œ×”×“×¤×™×¡ ×ª×•×•×™×ª ××—×ª ×œ×›×œ ×¤×¨×™×˜',0),(425073,11808,'el','ÎœÏŒÎ½Î¿ Î½Î± ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î¼Î¯Î± ÎµÏ„Î¹ÎºÎ­Ï„Î± Î±Î½Î¬ ÎµÎ¯Î´Î¿Ï‚',0),(425074,11808,'zh','æ¯ä¸ªé¡¹ç›®åªæ‰“å°ä¸€ä¸ªæ ‡ç­¾\r\n',0),(425075,11808,'sv','Bara skriva ut en etikett Per artikel',0),(425076,11808,'it','Stampare solo un\'etichetta per ogni elemento',0),(425077,11808,'tl','',0),(425078,11808,'th','à¸žà¸´à¸¡à¸žà¹Œà¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­à¸«à¸™à¸¶à¹ˆà¸‡à¸•à¹ˆà¸­à¸ªà¸´à¸™à¸„à¹‰à¸²à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(425079,11808,'hi','à¤•à¥‡à¤µà¤² à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¤à¤¿ à¤à¤• à¤²à¥‡à¤¬à¤² à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(425080,11808,'ms','Hanya mencetak satu Label setiap perkara',0),(425081,11808,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªØ³Ù…ÙŠØ© ÙˆØ§Ø­Ø¯Ø© Ù„Ù„Ø¨Ù†Ø¯ Ø§Ù„ÙˆØ§Ø­Ø¯ ÙÙ‚Ø·',0),(425082,11808,'fr','Seulement imprimer une seule Ã©tiquette par article',0),(425083,11808,'jp','ã ã‘é …ç›®ã”ã¨ã« 1 ã¤ã®ãƒ©ãƒ™ãƒ«ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(425084,11808,'pt','Apenas imprimir uma etiqueta por Item',0),(425085,11808,'ru','ÐÐ°Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¾Ð´Ð½Ñƒ Ð¼ÐµÑ‚ÐºÑƒ Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(425086,11808,'es','Solo Imprime Una Etiqueta Por Item',0),(425087,11808,'de','Nur ein Etikett pro StÃ¼ck drucken',0),(425088,11808,'en','Only Print One Label Per Item',0),(425089,11809,'is','',0),(425090,11809,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ù† Ø¯Ø± ÙÙ„Ø§Øª Ù‚Ø§Ø±Ù‡',0),(425091,11809,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ù† Ø¯Ø± ÙÙ„Ø§Øª Ù‚Ø§Ø±Ù‡',0),(425092,11809,'tr','GÃ¶steri kutusu/raf',0),(425093,11809,'pl','PokaÅ¼ Bin/pÃ³Å‚ka',0),(425094,11809,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¡Ðš/ÑÑ‚ÐµÐ»Ð°Ð¶',0),(425095,11809,'ur','Ø¨Ù†/Ø´ÛŒÙ„Ù Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(425096,11809,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð‘Ð¸Ð½/Ð¿Ð¾Ð»Ð¸Ñ†Ð°',0),(425097,11809,'vi','Hiá»‡n thá»‹ ngÄƒn/ká»‡',0),(425098,11809,'af','Wys asblik/rak',0),(425099,11809,'ro','AratÄƒ Bin/raft',0),(425100,11809,'et','NÃ¤ita aluse/riiul',0),(425101,11809,'si','PokaÅ¾i Bin/polica',0),(425102,11809,'ba','Menunjukkan Bin rak',0),(425103,11809,'nl','Toon Bin/plank',0),(425104,11809,'fi','NÃ¤ytÃ¤ Bin/hylly',0),(425105,11809,'no','Vis Bin/sokkel',0),(425106,11809,'da','Vis Bin/hylde',0),(425107,11809,'ko','ë³´ê¸° ë¹ˆ/ì„ ë°˜',0),(425108,11809,'he','×”×¦×’ ×¡×œ ××• ×ž×“×£',0),(425109,11809,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Bin/ÏÎ¬Ï†Î¹',0),(425110,11809,'zh','æ˜¾ç¤ºç®±å­/è´§æž¶\r\n',0),(425111,11809,'sv','Visa Bin/hylla',0),(425112,11809,'it','Visualizza Bin/mensola',0),(425113,11809,'tl','',0),(425114,11809,'th','à¹à¸ªà¸”à¸‡à¸Šà¹ˆà¸­à¸‡/à¸Šà¸±à¹‰à¸™',0),(425115,11809,'hi','à¤¬à¤¿à¤¨/à¤¶à¥‡à¤²à¥à¤« à¤¦à¤¿à¤–à¤¾à¤à¤',0),(425116,11809,'ms','Menunjukkan Bin/rak',0),(425117,11809,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø¨Ù†/Ø§Ù„Ø¬Ø±Ù',0),(425118,11809,'fr','Voir la Bin/tablette',0),(425119,11809,'jp','ã‚·ãƒ§ãƒ¼ç®±/æ£š',0),(425120,11809,'pt','Mostrar Bin/prateleira',0),(425121,11809,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Bin/Ð¿Ð¾Ð»ÐºÐ°',0),(425122,11809,'es','Muestra Bin/Shelf',0),(425123,11809,'de','Karte Bin/Regal',0),(425124,11809,'en','Show Bin/Shelf',0),(425125,11810,'is','',0),(425126,11810,'dr','Ø¯Ø±Ø¬ Ú©Ø¯',0),(425127,11810,'pr','Ø¯Ø±Ø¬ Ú©Ø¯',0),(425128,11810,'tr','Kod Ekle',0),(425129,11810,'pl','Wstaw kod',0),(425130,11810,'bg','Ð’Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð´',0),(425131,11810,'ur','Ø¶Ø§Ø¨Ø·Û Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(425132,11810,'sr','Ð£Ð¼ÐµÑ‚Ð°ÑšÐµ ÐºÐ¾Ð´Ð°',0),(425133,11810,'vi','thÃªm mÃ£',0),(425134,11810,'af','Voeg kode',0),(425135,11810,'ro','IntroduceÅ£i codul',0),(425136,11810,'et','Sisesta kood',0),(425137,11810,'si','Vstavite kodo',0),(425138,11810,'ba','Masukkan kode',0),(425139,11810,'nl','Code invoegen',0),(425140,11810,'fi','LisÃ¤Ã¤ koodi',0),(425141,11810,'no','Sette inn kode',0),(425142,11810,'da','IndsÃ¦tte kode',0),(425143,11810,'ko','ì½”ë“œ ì‚½ìž…',0),(425144,11810,'he','×”×›× ×¡ ×§×•×“',0),(425145,11810,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ',0),(425146,11810,'zh','æ’å…¥ä»£ç \r\n',0),(425147,11810,'sv','Infoga kod',0),(425148,11810,'it','Inserire il codice',0),(425149,11810,'tl','',0),(425150,11810,'th','à¹ƒà¸ªà¹ˆà¸£à¸«à¸±à¸ª',0),(425151,11810,'hi','à¤•à¥‹à¤¡ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(425152,11810,'ms','Masukkan kod',0),(425153,11810,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø±Ù…Ø²',0),(425154,11810,'fr','InsÃ©rer le Code',0),(425155,11810,'jp','ã‚³ãƒ¼ãƒ‰ã‚’æŒ¿å…¥ã—ã¾ã™ã€‚',0),(425156,11810,'pt','Inserir cÃ³digo',0),(425157,11810,'ru','Ð’ÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ ÐºÐ¾Ð´',0),(425158,11810,'es','Insertat CÃ³digo',0),(425159,11810,'de','FÃ¼gen Sie Code',0),(425160,11810,'en','Insert Code',0),(425161,11811,'is','',0),(425162,11811,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(425163,11811,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(425164,11811,'tr','BaÅŸarÄ±yla gÃ¶nderilen anket',0),(425165,11811,'pl','Ankieta wysÅ‚ana pomyÅ›lnie',0),(425166,11811,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(425167,11811,'ur','Ø³Ø±ÙˆÛ’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ú¾ÛŒØ¬ÛŒ',0),(425168,11811,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ð¾ÑÐ»Ð°Ñ‚',0),(425169,11811,'vi','Kháº£o sÃ¡t Ä‘Ã£ gá»­i thÃ nh cÃ´ng',0),(425170,11811,'af','Opname suksesvol gestuur',0),(425171,11811,'ro','Sondaj trimis cu succes',0),(425172,11811,'et','Edukalt saadetud kÃ¼sitluse',0),(425173,11811,'si','Raziskava, ki je poslan',0),(425174,11811,'ba','Survei yang berhasil dikirim',0),(425175,11811,'nl','EnquÃªte verzonden',0),(425176,11811,'fi','Kyselyn lÃ¤hettÃ¤minen onnistui',0),(425177,11811,'no','UndersÃ¸kelsen sendt',0),(425178,11811,'da','UndersÃ¸gelsen sendt',0),(425179,11811,'ko','ì„±ê³µì ìœ¼ë¡œ ë³´ë‚¸ ì„¤ë¬¸ ì¡°ì‚¬',0),(425180,11811,'he','×¡×§×¨ × ×©×œ×—×” ×‘×”×¦×œ×—×”',0),(425181,11811,'el','ÎˆÏÎµÏ…Î½Î± Ï€Î¿Ï… Î­ÏƒÏ„ÎµÎ¹Î»Îµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(425182,11811,'zh','è°ƒæŸ¥å‘é€æˆåŠŸ\r\n',0),(425183,11811,'sv','UndersÃ¶kningen skickats',0),(425184,11811,'it','Sondaggio inviato correttamente',0),(425185,11811,'tl','',0),(425186,11811,'th','à¹à¸šà¸šà¸ªà¸³à¸£à¸§à¸ˆà¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(425187,11811,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(425188,11811,'ms','Kaji-selidik yang berjaya dihantar',0),(425189,11811,'ar','Ø§Ù„Ø¯Ø±Ø§Ø³Ø© Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¦ÙŠØ© Ø§Ù„ØªÙŠ Ø£Ø±Ø³Ù„Øª Ø¨Ù†Ø¬Ø§Ø­',0),(425190,11811,'fr','Sondage envoyÃ© avec succÃ¨s',0),(425191,11811,'jp','æ­£å¸¸ã«é€ä¿¡ã•ã‚ŒãŸèª¿æŸ»',0),(425192,11811,'pt','Pesquisa enviada com sucesso',0),(425193,11811,'ru','ÐžÐ±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(425194,11811,'es','Encuesta Se Mando Exitosamente',0),(425195,11811,'de','Umfrage erfolgreich gesendet',0),(425196,11811,'en','Survey Sent Successfully',0),(425197,11812,'is','',0),(425198,11812,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¨Ø·Ø§Ù„',0),(425199,11812,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¨Ø·Ø§Ù„',0),(425200,11812,'tr','Doktor istek rapor',0),(425201,11812,'pl','Lekarz Å¼Ä…dania raportu',0),(425202,11812,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð·Ð° Ð¸ÑÐºÐ°Ð½Ðµ Ð·Ð° Ð´Ð¾ÐºÑ‚Ð¾Ñ€',0),(425203,11812,'ur','ÚˆØ§Ú©Ù¹Ø± Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(425204,11812,'sr','Ð”Ð¾ÐºÑ‚Ð¾Ñ€ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(425205,11812,'vi','Äá» nghá»‹ bÃ¡o cÃ¡o Ä‘iá»u chá»‰nh',0),(425206,11812,'af','Dokter versoek verslag',0),(425207,11812,'ro','Raport de solicitare doctor',0),(425208,11812,'et','Arst taotluse aruanne',0),(425209,11812,'si','Zdravnik zahteva poroÄilo',0),(425210,11812,'ba','Dokter permintaan laporan',0),(425211,11812,'nl','Arts verzoek verslag',0),(425212,11812,'fi','LÃ¤Ã¤kÃ¤ri kokouspyynnÃ¶n raportti',0),(425213,11812,'no','Legen rapport om',0),(425214,11812,'da','LÃ¦ge anmodning rapport',0),(425215,11812,'ko','ì˜ì‚¬ ìš”ì²­ ë³´ê³ ì„œ',0),(425216,11812,'he','×“×•×— ×‘×§×©×ª ×”×¨×•×¤×',0),(425217,11812,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ Ï„Î·Ï‚ Î±Î¯Ï„Î·ÏƒÎ·Ï‚ Î³Î¹Î±Ï„ÏÏŒÏ‚',0),(425218,11812,'zh','åŒ»ç”Ÿè¯·æ±‚æŠ¥å‘Š\r\n',0),(425219,11812,'sv','LÃ¤kare begÃ¤ran rapport',0),(425220,11812,'it','Medico richiesta Report',0),(425221,11812,'tl','',0),(425222,11812,'th','à¹à¸žà¸—à¸¢à¹Œà¸£à¹‰à¸­à¸‡à¸‚à¸­à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(425223,11812,'hi','à¤¡à¥‰à¤•à¥à¤Ÿà¤° à¤…à¤¨à¥à¤°à¥‹à¤§ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(425224,11812,'ms','Laporan permintaan doktor',0),(425225,11812,'ar','ØªÙ‚Ø±ÙŠØ± Ø·Ù„Ø¨ Ø§Ù„Ø·Ø¨ÙŠØ¨',0),(425226,11812,'fr','MÃ©decin demande rapport',0),(425227,11812,'jp','åŒ»è€…è¦æ±‚ãƒ¬ãƒãƒ¼ãƒˆ',0),(425228,11812,'pt','RelatÃ³rio de pedido mÃ©dico',0),(425229,11812,'ru','Ð”Ð¾ÐºÑ‚Ð¾Ñ€ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(425230,11812,'es','Informe de Solicitud para Medico',0),(425231,11812,'de','Arzt-Anforderung-Bericht',0),(425232,11812,'en','Doctor Request Report',0),(425233,11813,'is','',0),(425234,11813,'dr','(Ø§Ø®Ø·Ø§Ø± ) ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯',0),(425235,11813,'pr','Ø§Ø¹Ù„Ø§Ù…(Ø§Ø®Ø·Ø§Ø± ) ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯',0),(425236,11813,'tr','GÃ¶nderilen bildirim',0),(425237,11813,'pl','Powiadomienia wysyÅ‚ane',0),(425238,11813,'bg','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(425239,11813,'ur','Ø§Ø·Ù„Ø§Ø¹ Ù†Ø§Ù…Û Ø¨Ú¾ÛŒØ¬Ø§ Ú¯ÛŒØ§',0),(425240,11813,'sr','ÐžÐ±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµ Ð¿Ð¾ÑÐ»Ð°Ð»Ð¸',0),(425241,11813,'vi','thÃ´ng bÃ¡o Ä‘Ã£ gá»­i',0),(425242,11813,'af','KENNISGEWING gestuur',0),(425243,11813,'ro','Notificare trimis',0),(425244,11813,'et','Teate saatis',0),(425245,11813,'si','Obvestila, poslana',0),(425246,11813,'ba','Pemberitahuan dikirim',0),(425247,11813,'nl','Bericht dat wordt verzonden',0),(425248,11813,'fi','Ilmoitus lÃ¤hetetÃ¤Ã¤n',0),(425249,11813,'no','Varsling sendes',0),(425250,11813,'da','Meddelelser sendt',0),(425251,11813,'ko','ì•Œë¦¼ ì „ì†¡',0),(425252,11813,'he','×”×”×•×“×¢×•×ª ×©× ×©×œ×—×•',0),(425253,11813,'el','ÎšÎ¿Î¹Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î­Î»Î»ÎµÏ„Î±Î¹',0),(425254,11813,'zh','å¯„å‡ºé€šçŸ¥\r\n',0),(425255,11813,'sv','AnmÃ¤lan skickas',0),(425256,11813,'it','Notifica inviata',0),(425257,11813,'tl','',0),(425258,11813,'th','à¸ªà¹ˆà¸‡à¸à¸²à¸£à¹à¸ˆà¹‰à¸‡à¹€à¸•à¸·à¸­à¸™',0),(425259,11813,'hi','à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾ à¤­à¥‡à¤œà¤¾',0),(425260,11813,'ms','Pemberitahuan yang dihantar',0),(425261,11813,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¥Ø´Ø¹Ø§Ø±',0),(425262,11813,'fr','Notification envoyÃ©e',0),(425263,11813,'jp','é€šçŸ¥ã‚’é€ä¿¡',0),(425264,11813,'pt','NotificaÃ§Ã£o enviada',0),(425265,11813,'ru','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ',0),(425266,11813,'es','NotificaciÃ³n Enviada',0),(425267,11813,'de','Benachrichtigung gesendet',0),(425268,11813,'en','Notification Sent',0),(425269,11814,'is','',0),(425270,11814,'dr','ÙØ±Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§',0),(425271,11814,'pr','ÙØ±Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§',0),(425272,11814,'tr','Gelen istekleri',0),(425273,11814,'pl','Wnioski z',0),(425274,11814,'bg','Ð˜ÑÐºÐ°Ð½Ð¸Ñ Ð¾Ñ‚',0),(425275,11814,'ur','Ø¬Ø§Ù†Ø¨ Ø³Û’ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(425276,11814,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð¾Ð´',0),(425277,11814,'vi','máº«u Ä‘á» nghá»‹',0),(425278,11814,'af','Versoeke Vanaf',0),(425279,11814,'ro','Cereri de',0),(425280,11814,'et','Taotlustele',0),(425281,11814,'si','Zahteve iz',0),(425282,11814,'ba','Permintaan dari',0),(425283,11814,'nl','Verzoeken van',0),(425284,11814,'fi','PyynnÃ¶t',0),(425285,11814,'no','ForespÃ¸rsler fra',0),(425286,11814,'da','Anmodninger fra',0),(425287,11814,'ko','ìš”ì²­',0),(425288,11814,'he','×¤× ×™×•×ª',0),(425289,11814,'el','Î‘Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ Î±Ï€ÏŒ',0),(425290,11814,'zh','è¯·æ±‚æ¥è‡ª\r\n',0),(425291,11814,'sv','FÃ¶rfrÃ¥gningar frÃ¥n',0),(425292,11814,'it','Richieste da',0),(425293,11814,'tl','',0),(425294,11814,'th','à¸„à¸³à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸ˆà¸²à¸',0),(425295,11814,'hi','à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚ à¤¸à¥‡',0),(425296,11814,'ms','Permintaan daripada',0),(425297,11814,'ar','Ø·Ù„Ø¨Ø§Øª Ù…Ù†',0),(425298,11814,'fr','Demandes de',0),(425299,11814,'jp','è¦æ±‚',0),(425300,11814,'pt','SolicitaÃ§Ãµes de',0),(425301,11814,'ru','Ð—Ð°Ð¿Ñ€Ð¾ÑÑ‹ Ð¾Ñ‚',0),(425302,11814,'es','PeticiÃ³n De',0),(425303,11814,'de','Anfragen von',0),(425304,11814,'en','Requests From',0),(425305,11815,'is','',0),(425306,11815,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ø°Ø®ÛŒØ±Ù‡ Ú©Ø±Ø¯Ù† Ù†Ø¯Ø§Ø±ÛŒØ¯',0),(425307,11815,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ø°Ø®ÛŒØ±Ù‡ Ú©Ø±Ø¯Ù† Ù†Ø¯Ø§Ø±ÛŒØ¯',0),(425308,11815,'tr','Kaydetmek iÃ§in izniniz yok',0),(425309,11815,'pl','Nie masz uprawnieÅ„, aby zapisaÄ‡',0),(425310,11815,'bg','ÐÑÐ¼Ð°Ñ‚Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ Ð·Ð° Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(425311,11815,'ur','Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº',0),(425312,11815,'sr','ÐÐµÐ¼Ð°Ñ‚Ðµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ñƒ Ð´Ð° ÑÐ°Ñ‡ÑƒÐ²Ð°Ñ‚Ðµ',0),(425313,11815,'vi','KhÃ´ng cho phÃ©p lÆ°u',0),(425314,11815,'af','Nie toestemming het om te stoor',0),(425315,11815,'ro','Nu au permisiunea de a salva',0),(425316,11815,'et','On Ãµigus salvestada',0),(425317,11815,'si','Nimate dovoljenja za shranjevanje',0),(425318,11815,'ba','Tidak memiliki izin untuk menyimpan',0),(425319,11815,'nl','Niet gemachtigd om op te slaan',0),(425320,11815,'fi','Ei ole oikeutta tallentaa',0),(425321,11815,'no','Har ikke tillatelse til Ã¥ lagre',0),(425322,11815,'da','Har ikke tilladelse til at gemme',0),(425323,11815,'ko','ì €ìž¥í•  ìˆ˜ ìžˆëŠ” ê¶Œí•œì´ ì—†ìŠµë‹ˆë‹¤',0),(425324,11815,'he','××™×Ÿ ×œ×š ×”×¨×©××” ×œ×©×ž×™×¨×ª',0),(425325,11815,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Î¬Î´ÎµÎ¹Î± Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ',0),(425326,11815,'zh','æ²¡æœ‰æƒé™ä¿å­˜\r\n',0),(425327,11815,'sv','Har inte behÃ¶righet att spara',0),(425328,11815,'it','Non hai il permesso di salvare',0),(425329,11815,'tl','',0),(425330,11815,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸ªà¸´à¸—à¸˜à¸´à¹Œà¹ƒà¸™à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸',0),(425331,11815,'hi','à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(425332,11815,'ms','Tidak mempunyai kebenaran untuk menyimpan',0),(425333,11815,'ar','Ù„ÙŠØ³ Ù„Ø¯ÙŠÙƒ Ø¥Ø°Ù† Ø­ÙØ¸',0),(425334,11815,'fr','N\'Ãªtes pas autorisÃ© Ã  enregistrer',0),(425335,11815,'jp','ä¿å­˜ã™ã‚‹æ¨©é™ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(425336,11815,'pt','NÃ£o tem permissÃ£o para salvar',0),(425337,11815,'ru','ÐÐµÑ‚ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð½Ð° ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ',0),(425338,11815,'es','No Tiene permiso para Guardar',0),(425339,11815,'de','Haben Sie keine Berechtigung zum Speichern',0),(425340,11815,'en','Do Not Have Permission To Save',0),(425341,11816,'is','',0),(425342,11816,'dr','ØªÙ…Ø§Ù… Ù…Ø±Ø§Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡',0),(425343,11816,'pr','ØªÙ…Ø§Ù… Ù…Ø±Ø§Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡',0),(425344,11816,'tr','TÃ¼m maliyet merkezleri',0),(425345,11816,'pl','Wszystkie centra kosztÃ³w',0),(425346,11816,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ñ†ÐµÐ½Ñ‚Ñ€Ð¾Ð²Ðµ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(425347,11816,'ur','Ù„Ø§Ú¯Øª Ú©Û’ ØªÙ…Ø§Ù… Ù…Ø±Ø§Ú©Ø²',0),(425348,11816,'sr','Ð¡Ð²Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ñ†ÐµÐ½Ñ‚Ñ€Ð¸',0),(425349,11816,'vi','Táº¥t cáº£ cÃ¡c khá»‘i, phÃ²ng',0),(425350,11816,'af','Alle Koste Sentrums',0),(425351,11816,'ro','Toate centrele de Cost',0),(425352,11816,'et','KÃµik kulukeskuste',0),(425353,11816,'si','Vse StroÅ¡kovni centri',0),(425354,11816,'ba','Semua biaya Pusat',0),(425355,11816,'nl','Alle kostenplaatsen',0),(425356,11816,'fi','Kaikkien kustannuspaikkojen',0),(425357,11816,'no','Alle kostsentre',0),(425358,11816,'da','Alle omkostningssteder',0),(425359,11816,'ko','ëª¨ë“  ë¹„ìš© ì„¼í„°',0),(425360,11816,'he','×›×œ ×ž×¨×›×–×™ ×¢×œ×•×ª',0),(425361,11816,'el','ÎŒÎ»Î± Ï„Î± ÎºÎ­Î½Ï„ÏÎ± ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(425362,11816,'zh','æ‰€æœ‰æˆæœ¬ä¸­å¿ƒ\r\n',0),(425363,11816,'sv','Alla kostnadsstÃ¤llen',0),(425364,11816,'it','Tutti i centri di costo',0),(425365,11816,'tl','',0),(425366,11816,'th','à¸¨à¸¹à¸™à¸¢à¹Œà¸•à¹‰à¸™à¸—à¸¸à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(425367,11816,'hi','à¤¸à¤­à¥€ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤¨à¥à¤¦à¥à¤°à¥‹à¤‚',0),(425368,11816,'ms','Semua pusat-pusat kos',0),(425369,11816,'ar','Ø¬Ù…ÙŠØ¹ Ù…Ø±Ø§ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(425370,11816,'fr','Tous les centres de coÃ»ts',0),(425371,11816,'jp','ã™ã¹ã¦ã®åŽŸä¾¡ã‚»ãƒ³ã‚¿ãƒ¼',0),(425372,11816,'pt','Todos os centros de custo',0),(425373,11816,'ru','Ð’ÑÐµ Ñ†ÐµÐ½Ñ‚Ñ€Ñ‹ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(425374,11816,'es','Todos los Centros de Costo',0),(425375,11816,'de','Alle Kostenstellen',0),(425376,11816,'en','All Cost Centers',0),(425377,11817,'is','',0),(425378,11817,'dr','Ú©Ø¯Ø§Ù… Ù…Ø±Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡',0),(425379,11817,'pr','Ú©Ø¯Ø§Ù… Ù…Ø±Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡',0),(425380,11817,'tr','Hangi maliyet merkezi',0),(425381,11817,'pl','Centrum kosztÃ³w',0),(425382,11817,'bg','ÐšÐ¾Ð¸ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(425383,11817,'ur','Ø¬Ø³ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©Ø§ Ù…Ø±Ú©Ø²',0),(425384,11817,'sr','ÐšÐ¾Ñ˜Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(425385,11817,'vi','Chi phÃ­ nÃ o',0),(425386,11817,'af','Watter Kostesentrum',0),(425387,11817,'ro','Centrul de Cost ce',0),(425388,11817,'et','Milliseid Kulukeskus',0),(425389,11817,'si','Kateremu stroÅ¡kovnemu centru',0),(425390,11817,'ba','Yang biaya Pusat',0),(425391,11817,'nl','Welke kosten Center',0),(425392,11817,'fi','MitkÃ¤ kustannuspaikka',0),(425393,11817,'no','Hvilket kostnadssenter',0),(425394,11817,'da','Hvilke omkostninger Center',0),(425395,11817,'ko','í•˜ ë¹„ìš© ì„¼í„°',0),(425396,11817,'he','××™×–×” ×ž×¨×›×– ×¢×œ×•×™×•×ª',0),(425397,11817,'el','Î¤Î¿ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï€Î¿Ï…',0),(425398,11817,'zh','å“ªä¸€ä¸ªæˆæœ¬ä¸­å¿ƒ\r\n',0),(425399,11817,'sv','Vilka kostnadsstÃ¤lle',0),(425400,11817,'it','Quale centro di costo',0),(425401,11817,'tl','',0),(425402,11817,'th','à¸¨à¸¹à¸™à¸¢à¹Œà¸•à¹‰à¸™à¸—à¸¸à¸™à¹ƒà¸”',0),(425403,11817,'hi','à¤œà¥‹ à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(425404,11817,'ms','Pusat kos yang',0),(425405,11817,'ar','Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ø°ÙŠ',0),(425406,11817,'fr','Quel centre de coÃ»t',0),(425407,11817,'jp','ã©ã®ã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼',0),(425408,11817,'pt','Qual centro de custo',0),(425409,11817,'ru','ÐšÐ°ÐºÐ¾Ð¹ Ñ†ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(425410,11817,'es','Cual Centro de Costos',0),(425411,11817,'de','Welche Kostenstelle',0),(425412,11817,'en','Which Cost Center',0),(425413,11818,'is','',0),(425414,11818,'dr','Ù…Ø±Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡ Ø¬Ø¯ÛŒØ¯ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(425415,11818,'pr','Ù…Ø±Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡ Ø¬Ø¯ÛŒØ¯ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(425416,11818,'tr','Yeni bordro maliyet merkezi',0),(425417,11818,'pl','Nowe centrum kosztÃ³w pÅ‚ac',0),(425418,11818,'bg','ÐÐ¾Ð² Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(425419,11818,'ur','Ù†Ø¦Û’ Ù¾Û’ Ø±ÙˆÙ„ Ù„Ø§Ú¯Øª Ø³ÛŒÙ†Ù¹Ø±',0),(425420,11818,'sr','ÐÐ¾Ð²Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ',0),(425421,11818,'vi','Chi phÃ­ lÆ°Æ¡ng má»›i theo mÃ£',0),(425422,11818,'af','Nuwe heeltydse koste Sentrum',0),(425423,11818,'ro','Noul centru de Cost de salarizare',0),(425424,11818,'et','Uute palga kulukeskuse',0),(425425,11818,'si','Nov Payroll stroÅ¡kovno srediÅ¡Äe',0),(425426,11818,'ba','Pusat biaya gaji baru',0),(425427,11818,'nl','Nieuwe Payroll kostenplaats',0),(425428,11818,'fi','Uusi palkanlaskennan kustannuspaikka',0),(425429,11818,'no','Nye lÃ¸nn kostsenter',0),(425430,11818,'da','Ny lÃ¸n omkostninger Center',0),(425431,11818,'ko','ìƒˆë¡œìš´ ê¸‰ì—¬ ë¹„ìš© ì„¼í„°',0),(425432,11818,'he','×ž×¨×›×– ×—×“×© ×©×œ ×¢×œ×•×ª ×©×›×¨',0),(425433,11818,'el','ÎÎ­Î¿ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(425434,11818,'zh','å·¥èµ„æˆæœ¬ä¸­å¿ƒæ·»åŠ \r\n',0),(425435,11818,'sv','Nya lÃ¶ner kostnadsstÃ¤lle',0),(425436,11818,'it','Nuovo centro di costo di Payroll',0),(425437,11818,'tl','',0),(425438,11818,'th','à¸¨à¸¹à¸™à¸¢à¹Œà¸•à¹‰à¸™à¸—à¸¸à¸™à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¹ƒà¸«à¸¡à¹ˆ',0),(425439,11818,'hi','à¤¨à¤ˆ à¤ªà¥‡à¤°à¥‹à¤² à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(425440,11818,'ms','Pusat kos gaji baru',0),(425441,11818,'ar','Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(425442,11818,'fr','Nouveau centre de coÃ»t sur la paie',0),(425443,11818,'jp','æ–°ã—ã„çµ¦ä¸Žã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼',0),(425444,11818,'pt','Novo centro de custo da folha de pagamento',0),(425445,11818,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ†ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(425446,11818,'es','Agregar Centro de Costo de Nominas',0),(425447,11818,'de','Neue Abrechnung-Kostenstelle',0),(425448,11818,'en','New Payroll Cost Center',0),(425449,11819,'is','',0),(425450,11819,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù…Ø±Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(425451,11819,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù…Ø±Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(425452,11819,'tr','DÃ¼zen bordro maliyet merkezi',0),(425453,11819,'pl','Edycja listy pÅ‚ac MPK',0),(425454,11819,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¢Ð Ð— Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(425455,11819,'ur','ØªØ¯ÙˆÛŒÙ† Ù¾Û’ Ø±ÙˆÙ„ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ù…Ø±Ú©Ø²',0),(425456,11819,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ÑÐºÑƒ',0),(425457,11819,'vi','chá»‰nh sá»­a chi phÃ­ lÆ°Æ¡ng theo mÃ£',0),(425458,11819,'af','Redigeer heeltydse koste Sentrum',0),(425459,11819,'ro','Centrul de Cost editare salarizare',0),(425460,11819,'et','Redigeeri palga kulukeskuse',0),(425461,11819,'si','Urejanje Payroll stroÅ¡kovno srediÅ¡Äe',0),(425462,11819,'ba','Edit penggajian biaya Pusat',0),(425463,11819,'nl','Bewerken Payroll kostenplaats',0),(425464,11819,'fi','Muokkaa palkanlaskennan kustannuspaikka',0),(425465,11819,'no','Rediger lÃ¸nn kostsenter',0),(425466,11819,'da','Rediger lÃ¸nningslisten omkostningssted',0),(425467,11819,'ko','íŽ¸ì§‘ ê¸‰ì—¬ ë¹„ìš© ì„¼í„°',0),(425468,11819,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª ×©×›×¨ ×¢×¨×™×›×”',0),(425469,11819,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(425470,11819,'zh','å·¥èµ„æˆæœ¬ä¸­å¿ƒæ›´æ–°\r\n',0),(425471,11819,'sv','Redigera lÃ¶ner kostnadsstÃ¤lle',0),(425472,11819,'it','Centro di costo paghe Edit',0),(425473,11819,'tl','',0),(425474,11819,'th','à¸¨à¸¹à¸™à¸¢à¹Œà¸•à¹‰à¸™à¸—à¸¸à¸™à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¹à¸à¹‰à¹„à¸‚',0),(425475,11819,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤ªà¥‡à¤°à¥‹à¤² à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(425476,11819,'ms','Edit Pusat kos gaji',0),(425477,11819,'ar','ØªØ­Ø±ÙŠØ± ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(425478,11819,'fr','Edit paie Centre de coÃ»t',0),(425479,11819,'jp','ç·¨é›†çµ¦ä¸Žã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼',0),(425480,11819,'pt','Centro de custo de folha de pagamento de editar',0),(425481,11819,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(425482,11819,'es','Actualizar Centro de Costo de Nominas',0),(425483,11819,'de','Edit Payroll-Kostenstelle',0),(425484,11819,'en','Edit Payroll Cost Center',0),(425485,11820,'is','',0),(425486,11820,'dr','Ù…Ø±Ø§Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡',0),(425487,11820,'pr','Ù…Ø±Ø§Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡',0),(425488,11820,'tr','Maliyet merkezleri',0),(425489,11820,'pl','MPK',0),(425490,11820,'bg','Ð¦ÐµÐ½Ñ‚Ñ€Ð¾Ð²Ðµ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(425491,11820,'ur','Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ø§Ú©Ø²',0),(425492,11820,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(425493,11820,'vi','Cost Center',0),(425494,11820,'af','Koste sentrums',0),(425495,11820,'ro','Centre de cost',0),(425496,11820,'et','Kulukeskuste',0),(425497,11820,'si','StroÅ¡kovni centri',0),(425498,11820,'ba','Biaya Pusat',0),(425499,11820,'nl','Kostenplaatsen',0),(425500,11820,'fi','Kustannuspaikat',0),(425501,11820,'no','Kostsentre',0),(425502,11820,'da','Omkostningssteder',0),(425503,11820,'ko','ë¹„ìš© ì„¼í„°',0),(425504,11820,'he','×ž×¨×›×–×™ ×¢×œ×•×ª',0),(425505,11820,'el','ÎšÎ­Î½Ï„ÏÎ± ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(425506,11820,'zh','æˆæœ¬ä¸­å¿ƒ\r\n',0),(425507,11820,'sv','KostnadsstÃ¤llen',0),(425508,11820,'it','Centri di costo',0),(425509,11820,'tl','',0),(425510,11820,'th','à¸¨à¸¹à¸™à¸¢à¹Œà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(425511,11820,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(425512,11820,'ms','Pusat-Pusat kos',0),(425513,11820,'ar','Ù…Ø±Ø§ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(425514,11820,'fr','Centres de coÃ»ts',0),(425515,11820,'jp','ã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼',0),(425516,11820,'pt','Centros de custo',0),(425517,11820,'ru','Ð¦ÐµÐ½Ñ‚Ñ€Ñ‹ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚',0),(425518,11820,'es','Centros de Costo',0),(425519,11820,'de','Kostenstellen',0),(425520,11820,'en','Cost Centers',0),(425521,11821,'is','',0),(425522,11821,'dr','Ø³Ø§Ø¹Ø§Øª Ø±Ø§Ø¯Ø± ÙØ±Ù… Ø¬Ø¯ÙˆÙ„ÛŒ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(425523,11821,'pr','Ø³Ø§Ø¹Ø§Øª Ø±Ø§Ø¯Ø± ÙØ±Ù… Ø¬Ø¯ÙˆÙ„ÛŒ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(425524,11821,'tr','Saat girin tablo',0),(425525,11821,'pl','WprowadÅº godzin w formie tabelarycznej',0),(425526,11821,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ‡Ð°ÑÐ° Ð² Ñ‚Ð°Ð±Ð»Ð¸Ñ‡ÐµÐ½ Ð²Ð¸Ð´',0),(425527,11821,'ur','Ú¯Ú¾Ù†Ù¹ÙˆÚº Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ Ø¬Ø¯ÙˆÙ„ÛŒ ÙØ§Ø±Ù… Ù…ÛŒÚº',0),(425528,11821,'sr','Ð£Ð½Ð¾Ñ ÑÐ°Ñ‚Ð¸ Ñƒ Ñ‚Ð°Ð±ÐµÐ»Ð°Ñ€Ð½Ð¾Ð¼ Ð¾Ð±Ð»Ð¸ÐºÑƒ',0),(425529,11821,'vi','nháº­p sá»‘ giá» vÃ o báº£ng danh sÃ¡ch',0),(425530,11821,'af','Ure tik In Tabular vorm',0),(425531,11821,'ro','IntroduceÅ£i ore sub formÄƒ de tabel',0),(425532,11821,'et','Tundide sisestamine tabelina',0),(425533,11821,'si','Vnesite ur v obliki tabele',0),(425534,11821,'ba','Masukkan jam dalam bentuk Tabular',0),(425535,11821,'nl','Uren invoeren In tabelvorm',0),(425536,11821,'fi','Tuntien taulukkomuodossa',0),(425537,11821,'no','Angi timer i tabellform',0),(425538,11821,'da','Angive timer i tabelform',0),(425539,11821,'ko','ì‹œê°„ ìž…ë ¥ í…Œì´ë¸” í˜•ì‹',0),(425540,11821,'he','×”×–×Ÿ ×©×¢×•×ª ×‘×˜×•×¤×¡ ×˜×‘×œ××™',0),(425541,11821,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ ÏŽÏÎµÏ‚ ÏƒÎµ Î¼Î¿ÏÏ†Î® Ï€Î¯Î½Î±ÎºÎ±',0),(425542,11821,'zh','åœ¨è¡¨æ ¼ä¸­è¾“å…¥æ—¶é—´',0),(425543,11821,'sv','Ange timmar i tabellform',0),(425544,11821,'it','Immettere le ore In forma tabellare',0),(425545,11821,'tl','',0),(425546,11821,'th','à¸›à¹‰à¸­à¸™à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¹ƒà¸™à¹à¸šà¸šà¸•à¸²à¸£à¸²à¸‡',0),(425547,11821,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤°à¥‚à¤ª à¤®à¥‡à¤‚',0),(425548,11821,'ms','Masukkan jam Tabular borang',0),(425549,11821,'ar','Ø£Ø¯Ø®Ù„ Ø³Ø§Ø¹Ø§Øª ÙÙŠ Ù†Ù…ÙˆØ°Ø¬ Ø¬Ø¯ÙˆÙ„ÙŠ',0),(425550,11821,'fr','Entrez les heures sous forme de tableau',0),(425551,11821,'jp','æ™‚é–“ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„è¡¨å½¢å¼ã§',0),(425552,11821,'pt','Horas de entrar em forma Tabular',0),(425553,11821,'ru','Ð’Ð²Ð¾Ð´ Ñ‡Ð°ÑÐ¾Ð² Ð² Ñ‚Ð°Ð±Ð»Ð¸Ñ‡Ð½Ð¾Ð¹ Ñ„Ð¾Ñ€Ð¼Ðµ',0),(425554,11821,'es','Entrar Horas en Forma Tabular',0),(425555,11821,'de','Geben Sie Stunden In tabellarischer Form',0),(425556,11821,'en','Enter Hours In Tabular Form',0),(425557,11822,'is','',0),(425558,11822,'dr','ÙˆØ±ÙˆØ¯ Ø³Ø§Ø¹Øª Ø³Ø§Ø¯Ù‡',0),(425559,11822,'pr','ÙˆØ±ÙˆØ¯ Ø³Ø§Ø¹Øª Ø³Ø§Ø¯Ù‡',0),(425560,11822,'tr','Oturum saat basit',0),(425561,11822,'pl','RejestrowaÄ‡ godziny proste',0),(425562,11822,'bg','Ð’Ð»ÐµÐ·Ñ‚Ðµ Ñ‡Ð°ÑÐ° Ð¿Ñ€Ð¾ÑÑ‚Ð¸',0),(425563,11822,'ur','Ù„Ø§Ú¯ Ø§Ù† Ú¯Ú¾Ù†Ù¹ÙˆÚº Ø³Ø§Ø¯Û',0),(425564,11822,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸ ÑÐ°Ñ‚Ð¸ Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚Ð°Ð²Ð½Ð¾',0),(425565,11822,'vi','giá» cháº¥m cÃ´ng Ä‘Æ¡n giáº£n',0),(425566,11822,'af','Uur teken eenvoudige',0),(425567,11822,'ro','ConectaÅ£i ore simplu',0),(425568,11822,'et','Logi tundi lihtne',0),(425569,11822,'si','Prijavite ur preprosto',0),(425570,11822,'ba','Login jam sederhana',0),(425571,11822,'nl','Meld u uren eenvoudige',0),(425572,11822,'fi','Kirjaudu tuntia yksinkertainen',0),(425573,11822,'no','Logge timer enkel',0),(425574,11822,'da','Log timer enkle',0),(425575,11822,'ko','ë¡œê·¸ ì‹œê°„ ê°„ë‹¨í•œ',0),(425576,11822,'he','×™×•×ž×Ÿ ×©×¢×•×ª ×¤×©×•×˜×”',0),(425577,11822,'el','Î£Ï…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ ÏŽÏÎµÏ‚ Î±Ï€Î»Î­Ï‚',0),(425578,11822,'zh','ç®€å•çš„æ—¥å¿—æ—¶é—´\r\n',0),(425579,11822,'sv','Logga timmar enkel',0),(425580,11822,'it','Registrare ore semplice',0),(425581,11822,'tl','',0),(425582,11822,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¹„à¸”à¹‰',0),(425583,11822,'hi','à¤²à¥‰à¤— à¤‘à¤¨ à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¤°à¤²',0),(425584,11822,'ms','Log masuk jam mudah',0),(425585,11822,'ar','ØªØ³Ø¬ÙŠÙ„ Ø³Ø§Ø¹Ø§Øª Ø¨Ø³ÙŠØ·Ø©',0),(425586,11822,'fr','Ouvrez une session heures simples',0),(425587,11822,'jp','ãƒ­ã‚°æ™‚é–“å˜ç´”ãª',0),(425588,11822,'pt','Horas de log simples',0),(425589,11822,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ñ‡Ð°ÑÐ¾Ð² Ð¿Ñ€Ð¾ÑÑ‚Ð¾Ð¹',0),(425590,11822,'es','Horas Simple de Log',0),(425591,11822,'de','Melden Sie sich Stunden einfache',0),(425592,11822,'en','Log Hours Simple',0),(425593,11823,'is','',0),(425594,11823,'dr','Ù…Ø±Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(425595,11823,'pr','Ù…Ø±Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(425596,11823,'tr','Bordro maliyet merkezi',0),(425597,11823,'pl','Centrum kosztÃ³w pÅ‚ac',0),(425598,11823,'bg','Ð¢Ð Ð— Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(425599,11823,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ù…Ø±Ú©Ø²',0),(425600,11823,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ÑÐºÑƒ',0),(425601,11823,'vi','Chi phÃ­ lÆ°Æ¡ng theo mÃ£',0),(425602,11823,'af','Salarisstelsel koste Sentrum',0),(425603,11823,'ro','Centrul de Cost salarizare',0),(425604,11823,'et','Palga kulukeskuse',0),(425605,11823,'si','IzplaÄane plaÄe stroÅ¡kovno srediÅ¡Äe',0),(425606,11823,'ba','Penggajian biaya Pusat',0),(425607,11823,'nl','Payroll kostenplaats',0),(425608,11823,'fi','Palkanlaskennan kustannuspaikka',0),(425609,11823,'no','LÃ¸nn kostsenter',0),(425610,11823,'da','LÃ¸nningslisten omkostningssted',0),(425611,11823,'ko','ê¸‰ì—¬ ë¹„ìš© ì„¼í„°',0),(425612,11823,'he','×ž×¨×›×– ×¢×œ×•×™×•×ª ×©×›×¨',0),(425613,11823,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(425614,11823,'zh','è–ªé‡‘æˆæœ¬ä¸­å¿ƒ\r\n',0),(425615,11823,'sv','LÃ¶nelistan kostnadsstÃ¤lle',0),(425616,11823,'it','Centro di costo paghe',0),(425617,11823,'tl','',0),(425618,11823,'th','à¸¨à¸¹à¸™à¸¢à¹Œà¸•à¹‰à¸™à¸—à¸¸à¸™à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(425619,11823,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(425620,11823,'ms','Pusat kos gaji',0),(425621,11823,'ar','Ù…Ø±ÙƒØ² ØªÙƒÙ„ÙØ© Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(425622,11823,'fr','Centre de coÃ»t sur la paie',0),(425623,11823,'jp','çµ¦ä¸Žã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼',0),(425624,11823,'pt','Centro de custo da folha de pagamento',0),(425625,11823,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(425626,11823,'es','Centro de Costo de Nominas',0),(425627,11823,'de','Payroll-Kostenstelle',0),(425628,11823,'en','Payroll Cost Center',0),(425629,11824,'is','',0),(425630,11824,'dr','Ù…Ø³Ø¯ÙˆØ¯ Ú©Ø±Ø¯Ù† Ø°Ø®ÛŒØ±Ù‡ Ø³ÙØ§Ø±Ø´ ÙˆÙ…Ø¹Ú©ÙˆØ³ Ú©Ø±Ø¯Ù† Ø§Ø²Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ',0),(425631,11824,'pr','Ù…Ø³Ø¯ÙˆØ¯ Ú©Ø±Ø¯Ù† Ø°Ø®ÛŒØ±Ù‡ Ø³ÙØ§Ø±Ø´ ÙˆÙ…Ø¹Ú©ÙˆØ³ Ú©Ø±Ø¯Ù† Ø§Ø²Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ',0),(425632,11824,'tr','Blok dÃ¼zeni kaydetmek ve alÄ±ntÄ± dÃ¶nÃ¼ÅŸtÃ¼rmek',0),(425633,11824,'pl','Blok aby zapisaÄ‡ i konwersji z cytatem',0),(425634,11824,'bg','Ð‘Ð»Ð¾Ðº Ñ€ÐµÐ´ Ð·Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¸ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð° Ð¾Ñ‚ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(425635,11824,'ur','Ø¨Ù„Ø§Ú© ØªØ±ØªÛŒØ¨ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø§Ù‚ØªØ¨Ø§Ø³ Ø³Û’ Ø¨Ø¯Ù„ÛŒÚº',0),(425636,11824,'sr','Ð‘Ð»Ð¾Ðº Ñ€ÐµÐ´ ÑÐ¿Ð°ÑÐ¸Ñ‚Ð¸ Ð¸ ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ð²Ð°ÑšÐµ Ð¸Ð· Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(425637,11824,'vi','KhÃ³a lá»‡nh lÆ°u vÃ  thay Ä‘á»•i tá»« trÃ­ch dáº«n',0),(425638,11824,'af','Blok orde stoor en van kwotasie omskep',0),(425639,11824,'ro','Bloc comanda Salvare ÅŸi convertizor la citat',0),(425640,11824,'et','Bloki salvestada ja Teisenda tsitaat',0),(425641,11824,'si','Block Order shranite in pretvorbo iz ponudbe',0),(425642,11824,'ba','Blok agar menyimpan dan mengkonversi dari kutipan',0),(425643,11824,'nl','Blok volgorde opslaan en converteren van de offerte',0),(425644,11824,'fi','Block Order tallentaa ja muuntaa lainaus',0),(425645,11824,'no','Blokkere lagre og konvertere fra tilbud',0),(425646,11824,'da','Blok ordre Gem og konverter fra tilbud',0),(425647,11824,'ko','ë¸”ë¡ ìˆœì„œ ì €ìž¥ ë° ê²¬ì ì„ ë³€í™˜',0),(425648,11824,'he','×‘×œ×•×§ ×¡×“×¨ ×œ×©×ž×•×¨ ×•×œ×”×ž×™×¨ ×”×¦×¢×ª ×ž×—×™×¨',0),(425649,11824,'el','ÎœÏ€Î»Î¿Îº Ï€ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ ÎºÎ±Î¹ Î½Î± Î¼ÎµÏ„Î±Ï„ÏÎ±Ï€ÎµÎ¯ Î±Ï€ÏŒ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(425650,11824,'zh','å°é”è®¢å•ä¿å­˜å’Œä»ŽæŠ¥ä»·è½¬æ¢\r\n',0),(425651,11824,'sv','Block fÃ¶r spara och konvertera frÃ¥n offert',0),(425652,11824,'it','Ordine blocco salvare e convertire da citazione',0),(425653,11824,'tl','',0),(425654,11824,'th','à¸ªà¸±à¹ˆà¸‡à¸šà¸¥à¹‡à¸­à¸à¸šà¸±à¸™à¸—à¸¶à¸ à¹à¸¥à¸°à¹à¸›à¸¥à¸‡à¸ˆà¸²à¸à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(425655,11824,'hi','à¤¬à¥à¤²à¥‰à¤• à¤•à¥à¤°à¤® à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤”à¤° à¤¬à¥‹à¤²à¥€ à¤¸à¥‡ à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(425656,11824,'ms','Perintah blok Simpan dan menukar daripada petikan',0),(425657,11824,'ar','ÙƒØªÙ„Ø© Ø£Ù…Ø± Ø­ÙØ¸ ÙˆØªØ­ÙˆÙŠÙ„ Ù…Ù† Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³',0),(425658,11824,'fr','Bloc commande Enregistrer et convertir de citation',0),(425659,11824,'jp','é †åºä¿å­˜ã‚’ãƒ–ãƒ­ãƒƒã‚¯ã—ã€å¼•ç”¨ã‹ã‚‰å¤‰æ›',0),(425660,11824,'pt','Bloco ordem salvar e converter de citaÃ§Ã£o',0),(425661,11824,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð±Ð»Ð¾ÐºÐ° ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¸ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¾Ñ‚ Ð´ÐµÑˆÑ‘Ð²Ñ‹Ñ…',0),(425662,11824,'es','Guardar Orden Block y Convertir de la CotizaciÃ³n',0),(425663,11824,'de','Block Bestellung speichern und Konvertieren von Quote',0),(425664,11824,'en','Block Order Save And Convert From Quote',0),(425665,11825,'is','',0),(425666,11825,'dr','Ø±ÙˆØ² Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡',0),(425667,11825,'pr','Ø±ÙˆØ² Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡',0),(425668,11825,'tr','DÃ¶nem baÅŸlangÄ±Ã§ gÃ¼nÃ¼',0),(425669,11825,'pl','DzieÅ„ rozpoczÄ™cia okresu',0),(425670,11825,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð´ÐµÐ½',0),(425671,11825,'ur','Ø¯Ù† Ø¯ÙˆØ± Ø´Ø±ÙˆØ¹',0),(425672,11825,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð´Ð°Ð½',0),(425673,11825,'vi','ngÃ y báº¯t Ä‘áº§u thá»i ká»³',0),(425674,11825,'af','Tydperk begin dag',0),(425675,11825,'ro','ÃŽnceput perioadÄƒ zi',0),(425676,11825,'et','Perioodi alguspÃ¤ev',0),(425677,11825,'si','ZaÄetek obdobja dan',0),(425678,11825,'ba','Periode memulai hari',0),(425679,11825,'nl','Periode Start dag',0),(425680,11825,'fi','Kauden alku',0),(425681,11825,'no','Periodens startdagen',0),(425682,11825,'da','Periodestart dag',0),(425683,11825,'ko','ê¸°ê°„ ì‹œìž‘ í•˜ë£¨',0),(425684,11825,'he','× ×§×•×“×” ×œ×”×ª×—×™×œ ×”×™×•×',0),(425685,11825,'el','Î—Î¼Î­ÏÎ± Î­Î½Î±ÏÎ¾Î· Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(425686,11825,'zh','å¼€å§‹æ—¥æœŸ\r\n',0),(425687,11825,'sv','Periodstart dag',0),(425688,11825,'it','Giorno di inizio periodo',0),(425689,11825,'tl','',0),(425690,11825,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²',0),(425691,11825,'hi','à¤…à¤µà¤§à¤¿ à¤¦à¤¿à¤µà¤¸ à¤¶à¥à¤°à¥‚',0),(425692,11825,'ms','Tempoh memulakan hari',0),(425693,11825,'ar','Ø§Ù„ÙŠÙˆÙ… Ø¨Ø¯Ø¡ Ø§Ù„ÙØªØ±Ø©',0),(425694,11825,'fr','Date de dÃ©but de pÃ©riode',0),(425695,11825,'jp','æœŸé–“ã®é–‹å§‹æ—¥',0),(425696,11825,'pt','Dia de inÃ­cio do perÃ­odo',0),(425697,11825,'ru','Ð”ÐµÐ½ÑŒ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(425698,11825,'es','DÃ­a de Comienza del PerÃ­odo',0),(425699,11825,'de','Tag fÃ¼r den Zeitraum Beginn',0),(425700,11825,'en','Period Start Day',0),(425701,11826,'is','',0),(425702,11826,'dr','(Ø±ÙˆØ² Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ Ø¯ÙˆÙ…ÛŒÙ† Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(425703,11826,'pr','Ø´Ø±ÙˆØ¹ Ø±ÙˆØ² Ø¯ÙˆÙ… Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª(Ø±ÙˆØ² Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ Ø¯ÙˆÙ…ÛŒÙ† Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(425704,11826,'tr','DÃ¶nem baÅŸlangÄ±Ã§ gÃ¼nÃ¼ ikinci Ã¶deme dÃ¶nemi',0),(425705,11826,'pl','PoczÄ…tek okresu dnia drugiego okresu wypÅ‚aty',0),(425706,11826,'bg','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð´ÐµÐ½ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð²Ñ‚Ð¾Ñ€Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(425707,11826,'ur','Ø¯ÙˆØ± Ø´Ø±ÙˆØ¹ Ø¯Ù† Ú©Ùˆ Ø¯ÙˆØ³Ø±ÛŒ Ù…Ø¯Øª Ú©ÛŒ Ø§Ø¯Ø§ Ú©Ø±ØªÛ’',0),(425708,11826,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð´Ð°Ð½Ð° Ð´Ñ€ÑƒÐ³Ð¾ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(425709,11826,'vi','ngÃ y báº¯t Ä‘áº§u thá»i ká»³ thá»© 2 tráº£ thá»i gian',0),(425710,11826,'af','Tydperk begin dag tweede tydperk betaal',0),(425711,11826,'ro','ÃŽnceput perioadÄƒ zi plÄƒtesc a doua perioadÄƒ',0),(425712,11826,'et','Perioodi algus pÃ¤eva teiseks maksma perioodi',0),(425713,11826,'si','ZaÄetek obdobja dan drugiÄ plaÄilo obdobje',0),(425714,11826,'ba','Periode mulai hari kedua membayar periode',0),(425715,11826,'nl','Periode Start dag betalen tweede periode',0),(425716,11826,'fi','Kauden aloituspÃ¤ivÃ¤n toinen palkanmaksu',0),(425717,11826,'no','Periodens startdagen betale andre periode',0),(425718,11826,'da','Periodestart dag betale anden periode',0),(425719,11826,'ko','ê¸°ê°„ ì‹œìž‘ ë‚  ë‘ ë²ˆì§¸ ì§€ë¶ˆ ê¸°ê°„',0),(425720,11826,'he','×”×™×•× ×”×¨××©×•×Ÿ ×”×ž×—×–×•×¨ ×”×©× ×™ ×œ×©×œ× ×ª×§×•×¤×”',0),(425721,11826,'el','ÎˆÎ½Î±ÏÎ¾Î· Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï… Î·Î¼Î­ÏÎ± Ï€Î»Î·ÏÏŽÏƒÎµÎ¹ Î´ÎµÏÏ„ÎµÏÎ· Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(425722,11826,'zh','ç¬¬äºŒæœŸæ”¯ä»˜æœŸå¼€å§‹æ—¥\r\n',0),(425723,11826,'sv','Periodstart dag betala andra perioden',0),(425724,11826,'it','Inizio periodo giorno pagare secondo periodo',0),(425725,11826,'tl','',0),(425726,11826,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸—à¸µà¹ˆà¸ªà¸­à¸‡à¸ˆà¹ˆà¸²à¸¢à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²',0),(425727,11826,'hi','à¤…à¤µà¤§à¤¿ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¦à¤¿à¤¨ à¤¦à¥‚à¤¸à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿',0),(425728,11826,'ms','Tempoh mula hari kedua membayar tempoh',0),(425729,11826,'ar','Ø§Ù„ÙŠÙˆÙ… Ø¨Ø¯Ø¡ Ø§Ù„ÙØªØ±Ø© Ø§Ù„Ø«Ø§Ù†ÙŠØ© Ø¯ÙØ¹ Ø§Ù„ÙØªØ±Ø©',0),(425730,11826,'fr','Date de dÃ©but de pÃ©riode deuxiÃ¨me pÃ©riode de paye',0),(425731,11826,'jp','æœŸé–“ã®é–‹å§‹æ—¥ã¯ç¬¬äºŒæœŸã‚’æ”¯æ‰•ã†',0),(425732,11826,'pt','InÃ­cio perÃ­odo dia pagar segundo perÃ­odo',0),(425733,11826,'ru','Ð”ÐµÐ½ÑŒ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð²Ñ‚Ð¾Ñ€Ð¾Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(425734,11826,'es','DÃ­a de Comienza del PerÃ­odo, PerÃ­odo de Segundo DÃ­a',0),(425735,11826,'de','Tag fÃ¼r den Zeitraum Beginn zweiter Zahlungsperiode',0),(425736,11826,'en','Period Start Day Second Pay Period',0),(425737,11827,'is','',0),(425738,11827,'dr','ØªØ¹Ø·ÛŒÙ„Ø§Øª Ù…ØªØ¹Ù„Ù‚Ù‡ ',0),(425739,11827,'pr','ØªØ¹Ø·ÛŒÙ„Ø§Øª Ù…ØªØ¹Ù„Ù‚Ù‡ ',0),(425740,11827,'tr','Tahakkuk eden tatil',0),(425741,11827,'pl','Naliczony urlop',0),(425742,11827,'bg','ÐÐ°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ‚Ðµ Ð²Ð°ÐºÐ°Ð½Ñ†Ð¸Ñ',0),(425743,11827,'ur','ØªÙ…Ø§Ù… ÛÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ú†Ú¾Ù¹ÛŒ',0),(425744,11827,'sr','ÐÐ°ÐºÑƒÐ¿Ñ™ÐµÐ½Ð¸ Ð¾Ð´Ð¼Ð¾Ñ€',0),(425745,11827,'vi','Ká»³ lÅ©y káº¿',0),(425746,11827,'af','Jou toeval vakansie',0),(425747,11827,'ro','Acumulate de vacanta',0),(425748,11827,'et','Arvestatud, kuid',0),(425749,11827,'si','ObraÄunane poÄitnice',0),(425750,11827,'ba','Liburan yang masih harus dibayar',0),(425751,11827,'nl','Opgebouwde vakantie',0),(425752,11827,'fi','Jaksotetut loma',0),(425753,11827,'no','PÃ¥lÃ¸pte ferie',0),(425754,11827,'da','Optjente ferie',0),(425755,11827,'ko','ë°œìƒ í•œ íœ´ê°€',0),(425756,11827,'he','×—×•×¤×©×” × ×¦×‘×¨×ª',0),(425757,11827,'el','Î”ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Ï‰Î½ Î´Î¹Î±ÎºÎ¿Ï€Î­Ï‚',0),(425758,11827,'zh','åº”è®¡ä¼‘å‡\r\n',0),(425759,11827,'sv','Upplupna semester',0),(425760,11827,'it','Vacanza maturato',0),(425761,11827,'tl','',0),(425762,11827,'th','à¸§à¸±à¸™à¸«à¸¢à¸¸à¸”à¸ªà¸°à¸ªà¸¡',0),(425763,11827,'hi','à¤‰à¤ªà¤¾à¤°à¥à¤œà¤¿à¤¤ à¤…à¤µà¤•à¤¾à¤¶',0),(425764,11827,'ms','Percutian yang terakru',0),(425765,11827,'ar','Ø§Ù„Ø¥Ø¬Ø§Ø²Ø§Øª Ø§Ù„Ù…ØªØ±Ø§ÙƒÙ…Ø©',0),(425766,11827,'fr','Vacances accumulÃ©es',0),(425767,11827,'jp','æœªæ‰•ä¼‘æš‡',0),(425768,11827,'pt','FÃ©rias acumuladas',0),(425769,11827,'ru','ÐÐµÐ¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹ Ð¾Ñ‚Ð¿ÑƒÑÐº',0),(425770,11827,'es','Vacaciones Acumuladas',0),(425771,11827,'de','Aufgelaufenen Urlaub',0),(425772,11827,'en','Accrued Vacation',0),(425773,11828,'is','',0),(425774,11828,'dr','Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰',0),(425775,11828,'pr','Ù…Ø±Ø®ØµÙ‰ Ø§Ø³ØªØ¹Ù„Ø§Ø¬Ù‰',0),(425776,11828,'tr','HastalÄ±k izni',0),(425777,11828,'pl','Zwolnienie chorobowe',0),(425778,11828,'bg','ÐžÑ‚Ð¿ÑƒÑÐº Ð¿Ð¾ Ð±Ð¾Ð»ÐµÑÑ‚',0),(425779,11828,'ur','Ø¨ÛŒÙ…Ø§Ø± Ú†Ú¾ÙˆÚ‘ÛŒÚº',0),(425780,11828,'sr','Ð‘Ð¾Ð»Ð¾Ð²Ð°ÑšÐµ',0),(425781,11828,'vi','PhÃ©p nghá»‰ bá»‡nh',0),(425782,11828,'af','Siekverlof',0),(425783,11828,'ro','Concediu medical',0),(425784,11828,'et','Haiguspuhkus',0),(425785,11828,'si','BolniÅ¡ka odsotnost',0),(425786,11828,'ba','Cuti',0),(425787,11828,'nl','Ziekteverlof',0),(425788,11828,'fi','Palkallinen vapaa',0),(425789,11828,'no','SykefravÃ¦r',0),(425790,11828,'da','Sygeorlov',0),(425791,11828,'ko','ë³‘ê°€',0),(425792,11828,'he','×“×ž×™ ×ž×—×œ×”',0),(425793,11828,'el','Î‘Î½Î±ÏÏÏ‰Ï„Î¹ÎºÎ® Î¬Î´ÎµÎ¹Î±',0),(425794,11828,'zh','ç—…å‡\r\n',0),(425795,11828,'sv','SjukfrÃ¥nvaro',0),(425796,11828,'it','Assenze per malattia',0),(425797,11828,'tl','',0),(425798,11828,'th','à¸¥à¸²à¸›à¹ˆà¸§à¸¢',0),(425799,11828,'hi','à¤¬à¥€à¤®à¤¾à¤° à¤›à¥‹à¤¡à¤¼',0),(425800,11828,'ms','Cuti sakit',0),(425801,11828,'ar','Ø§Ù„Ø¥Ø¬Ø§Ø²Ø© Ø§Ù„Ù…Ø±Ø¶ÙŠØ©',0),(425802,11828,'fr','CongÃ© de maladie',0),(425803,11828,'jp','ç—…æ¬ ',0),(425804,11828,'pt','LicenÃ§a mÃ©dica',0),(425805,11828,'ru','ÐžÑ‚Ð¿ÑƒÑÐº Ð¿Ð¾ Ð±Ð¾Ð»ÐµÐ·Ð½Ð¸',0),(425806,11828,'es','Vacaciones de Enfermedad',0),(425807,11828,'de','Krankheitstage',0),(425808,11828,'en','Sick Leave',0),(425809,11829,'is','',0),(425810,11829,'dr','(Ú©Ø³Ø± Ú©Ø±Ø¯Ù†)Ø´Ù‡Ø±',0),(425811,11829,'pr','Ø®ÙˆØ¯Ø¯Ø§Ø±ÛŒ Ú©Ø±Ø¯Ù†(Ú©Ø³Ø± Ú©Ø±Ø¯Ù†)Ø´Ù‡Ø±',0),(425812,11829,'tr','Åžehir stopaj',0),(425813,11829,'pl','Miasto u ÅºrÃ³dÅ‚a',0),(425814,11829,'bg','Ð“Ñ€Ð°Ð´ Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(425815,11829,'ur','Ø´ÛØ± Ú©Ùˆ Ø±ÙˆÚ©Ù†Ø§',0),(425816,11829,'sr','Ð“Ñ€Ð°Ð´ Ð¿Ñ€Ð¸ÐºÑ€Ð¸Ð²Ð°ÑšÐ°.',0),(425817,11829,'vi','KHoáº£n giá»¯ láº¡i thÃ nh phá»‘',0),(425818,11829,'af','Stad weerhouding',0),(425819,11829,'ro','OraÅŸul de la sursÄƒ',0),(425820,11829,'et','Linn kinnipeetava',0),(425821,11829,'si','Mesto odtegljaj',0),(425822,11829,'ba','Kota pemotongan',0),(425823,11829,'nl','Stad achterhouden',0),(425824,11829,'fi','Kaupungin ennakonpidÃ¤tys',0),(425825,11829,'no','Byen forskuddstrekk',0),(425826,11829,'da','Byen tilbageholdelse',0),(425827,11829,'ko','ì‹œ ì›ì²œ ì§•ìˆ˜',0),(425828,11829,'he','×”×¢×™×¨ ×”×œ× ×ª',0),(425829,11829,'el','Î ÏŒÎ»Î· Ï€Î±ÏÎ±ÎºÏÎ¬Ï„Î·ÏƒÎ·',0),(425830,11829,'zh','å¸‚æ‰£ç¼´\r\n',0),(425831,11829,'sv','Staden kÃ¤llskatt',0),(425832,11829,'it','CittÃ  ritenuta',0),(425833,11829,'tl','',0),(425834,11829,'th','à¹€à¸¡à¸·à¸­à¸‡à¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(425835,11829,'hi','à¤¶à¤¹à¤° à¤°à¥‹à¤•',0),(425836,11829,'ms','Bandar penangguhan',0),(425837,11829,'ar','Ø­Ø¬Ø¨ Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(425838,11829,'fr','Ville retenue',0),(425839,11829,'jp','éƒ½å¸‚ã®æºæ³‰å¾´åŽ',0),(425840,11829,'pt','Cidade de retenÃ§Ã£o na fonte',0),(425841,11829,'ru','Ð£Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ðµ Ð³Ð¾Ñ€Ð¾Ð´Ð°',0),(425842,11829,'es','Retenciones Locales',0),(425843,11829,'de','Stadt zurÃ¼ckhalten',0),(425844,11829,'en','City Withholding',0),(425845,11830,'is','',0),(425846,11830,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ø§Ø±Ù…Ù†Ø¯',0),(425847,11830,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ø§Ø±Ù…Ù†Ø¯',0),(425848,11830,'tr','Ã‡alÄ±ÅŸan bilgileri',0),(425849,11830,'pl','Pracownik informacji',0),(425850,11830,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(425851,11830,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(425852,11830,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð˜Ð½Ñ„Ð¾',0),(425853,11830,'vi','thÃ´ng tin nhÃ¢n viÃªn',0),(425854,11830,'af','Werknemer inligting',0),(425855,11830,'ro','Angajat Info',0),(425856,11830,'et','TÃ¶Ã¶taja Info',0),(425857,11830,'si','Zaposlenega Info',0),(425858,11830,'ba','Info kepegawaian',0),(425859,11830,'nl','Werknemer Info',0),(425860,11830,'fi','TyÃ¶ntekijÃ¤n tiedot',0),(425861,11830,'no','Ansatte-Info',0),(425862,11830,'da','Medarbejder Info',0),(425863,11830,'ko','ì§ì› ì •ë³´',0),(425864,11830,'he','×¤×¨×˜×™ ×”×¢×•×‘×“',0),(425865,11830,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(425866,11830,'zh','å‘˜å·¥ä¿¡æ¯\r\n',0),(425867,11830,'sv','Medarbetare information',0),(425868,11830,'it','Dipendente Info',0),(425869,11830,'tl','',0),(425870,11830,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(425871,11830,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(425872,11830,'ms','Maklumat pekerja',0),(425873,11830,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ¸Ù',0),(425874,11830,'fr','Informations sur les employÃ©s',0),(425875,11830,'jp','å¾“æ¥­å“¡æƒ…å ±',0),(425876,11830,'pt','InformaÃ§Ã£o do funcionÃ¡rio',0),(425877,11830,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð»Ñ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(425878,11830,'es','Info del Empleado',0),(425879,11830,'de','Mitarbeiter Info',0),(425880,11830,'en','Employee Info',0),(425881,11831,'is','',0),(425882,11831,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(425883,11831,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ù„Ø§ØµÙ‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(425884,11831,'tr','Personel bordro Ã–zet raporu',0),(425885,11831,'pl','Raport podsumowania pÅ‚ac pracownikÃ³w',0),(425886,11831,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¢Ð Ð— Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(425887,11831,'ur','Ù…Ù„Ø§Ø²Ù… Ù¾Û’ Ø±ÙˆÙ„ Ú©ÛŒ Ø®Ù„Ø§ØµÛ Ø±Ù¾ÙˆØ±Ù¹',0),(425888,11831,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÑÐ° Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ¾Ð¼ Ð¿Ð»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(425889,11831,'vi','bÃ¡o cÃ¡o tÃ´ng há»£p lÆ°Æ¡ng nhÃ¢n viÃªn',0),(425890,11831,'af','Werknemer heeltydse opsommende verslag',0),(425891,11831,'ro','Angajat salarizare raport',0),(425892,11831,'et','TÃ¶Ã¶taja palgaarvestuse KokkuvÃµttev aruanne',0),(425893,11831,'si','Zaposlenega Payroll Zbirno poroÄilo',0),(425894,11831,'ba','Laporan ringkasan penggajian karyawan',0),(425895,11831,'nl','Werknemer Payroll samenvattend verslag',0),(425896,11831,'fi','TyÃ¶ntekijÃ¤n palkanlaskennan yhteenvetoraportti',0),(425897,11831,'no','Ansatte lÃ¸nn sammendragsrapport',0),(425898,11831,'da','Medarbejder lÃ¸n sammenfattende rapport',0),(425899,11831,'ko','ì§ì› ê¸‰ì—¬ ìš”ì•½ ë³´ê³ ì„œ',0),(425900,11831,'he','×œ×¢×•×‘×“ ×©×›×¨ ×“×• ×— ×¡×™×›×•×',0),(425901,11831,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿Ï„Î¹ÎºÏŽÎ½ ÎºÎ±Ï„Î±ÏƒÏ„Î¬ÏƒÎµÏ‰Î½ ÏƒÏ…Î½Î¿Ï€Ï„Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ·',0),(425902,11831,'zh','é›‡å‘˜è–ªé‡‘æ€»é¢çš„æ‘˜è¦æŠ¥å‘Š\r\n',0),(425903,11831,'sv','AnstÃ¤lldas lÃ¶n sammanfattande rapport',0),(425904,11831,'it','Report di riepilogo paghe dei dipendenti',0),(425905,11831,'tl','',0),(425906,11831,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸ªà¸£à¸¸à¸›à¹€à¸‡à¸´à¸™à¹€à¸”à¸·à¸­à¸™à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(425907,11831,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤ªà¥‡à¤°à¥‹à¤² à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(425908,11831,'ms','Laporan rumusan gaji pekerja',0),(425909,11831,'ar','ØªÙ‚Ø±ÙŠØ± Ù…ÙˆØ¬Ø² Ø±ÙˆØ§ØªØ¨ Ø§Ù„Ù…ÙˆØ¸Ù',0),(425910,11831,'fr','Rapport sommaire l\'employÃ© paie',0),(425911,11831,'jp','å¾“æ¥­å“¡ã®çµ¦ä¸Žã®æ¦‚è¦ãƒ¬ãƒãƒ¼ãƒˆ',0),(425912,11831,'pt','RelatÃ³rio de Resumo de folha de pagamento de empregado',0),(425913,11831,'ru','Ð¡Ð²Ð¾Ð´Ð½Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ° Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(425914,11831,'es','Informe Sumario de Nomina de los Empleados',0),(425915,11831,'de','Mitarbeiter Payroll-Kurzbericht',0),(425916,11831,'en','Employee Payroll Summary Report',0),(425917,11832,'is','',0),(425918,11832,'dr','Ø­Ù‚ÙˆÙ‚ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª Ø¯ÙˆÙ„ØªÛŒ',0),(425919,11832,'pr','Ø­Ù‚ÙˆÙ‚ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª Ø¯ÙˆÙ„ØªÛŒ',0),(425920,11832,'tr','Federal vergiye tabi Ã¼cretler',0),(425921,11832,'pl','Federalny opodatkowaniu pÅ‚ac',0),(425922,11832,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð° Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(425923,11832,'ur','ÙˆÙØ§Ù‚ÛŒ Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ Ø§Ø¬Ø±Øª',0),(425924,11832,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ',0),(425925,11832,'vi','thu nháº­p thuáº¿ liÃªn bang',0),(425926,11832,'af','Federale belasbare loon',0),(425927,11832,'ro','Federal impozabile salariile',0),(425928,11832,'et','FÃ¶deraalne maksustatava tÃ¶Ã¶tasu',0),(425929,11832,'si','Zvezni davÄni plaÄe',0),(425930,11832,'ba','Upah Pajak Federal',0),(425931,11832,'nl','Federale belastbare loon',0),(425932,11832,'fi','Liittovaltion veron palkat',0),(425933,11832,'no','FÃ¸derale skattepliktig lÃ¸nn',0),(425934,11832,'da','FÃ¸derale skattepligtige lÃ¸n',0),(425935,11832,'ko','ì—°ë°© ê³¼ì„¸ ëŒ€ìƒ ìž„ê¸ˆ',0),(425936,11832,'he','×©×›×¨ ×—×™×™×‘ ×‘×ž×¡ ×¤×“×¨×œ×™',0),(425937,11832,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¬ Ï†Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­Î¿ Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(425938,11832,'zh','è”é‚¦è®¡ç¨Žå·¥èµ„\r\n',0),(425939,11832,'sv','Federala skattepliktiga lÃ¶ner',0),(425940,11832,'it','Salari imponibili federali',0),(425941,11832,'tl','',0),(425942,11832,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µà¸‚à¸­à¸‡à¸£à¸±à¸à¸šà¸²à¸¥à¸à¸¥à¸²à¸‡',0),(425943,11832,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤•à¤° à¤¯à¥‹à¤—à¥ à¤¯ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(425944,11832,'ms','Gaji boleh cukai Persekutuan',0),(425945,11832,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± Ø§Ù„Ø®Ø§Ø¶Ø¹Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(425946,11832,'fr','Salaire imposable fÃ©dÃ©ral',0),(425947,11832,'jp','é€£é‚¦æ”¿åºœã®èª²ç¨Žå¯¾è±¡è³ƒé‡‘',0),(425948,11832,'pt','Federal salÃ¡rios tributÃ¡veis',0),(425949,11832,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹ ÐÐ°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð·Ð°Ñ€Ð¿Ð»Ð°Ñ‚Ð°',0),(425950,11832,'es','Sueldos Federales Imponibles',0),(425951,11832,'de','Bundesrepublik Steuerpflichtige EinkÃ¼nfte',0),(425952,11832,'en','Federal Taxable Wages',0),(425953,11833,'is','',0),(425954,11833,'dr','Ù…Ù†Ø¹ Ø¯ÙˆÙ„ØªÛŒ',0),(425955,11833,'pr','Ù…Ù†Ø¹ Ø¯ÙˆÙ„ØªÛŒ',0),(425956,11833,'tr','Federal stopaj',0),(425957,11833,'pl','Federalne wstrzymanie',0),(425958,11833,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð° Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(425959,11833,'ur','ÙˆÙØ§Ù‚ÛŒ Ø±ÙˆÚ©Ù†Ø§',0),(425960,11833,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¿Ñ€Ð¸ÐºÑ€Ð¸Ð²Ð°ÑšÐ°',0),(425961,11833,'vi','liÃªn bang giá»¯',0),(425962,11833,'af','Federale weerhouding',0),(425963,11833,'ro','FederalÄƒ reÅ£inere la sursÄƒ',0),(425964,11833,'et','FÃ¶deraalne kinnipeetava',0),(425965,11833,'si','Zvezni odtegljaj',0),(425966,11833,'ba','Pemotongan Federal',0),(425967,11833,'nl','Federale achterhouden',0),(425968,11833,'fi','Liittovaltion ennakonpidÃ¤tykseksi',0),(425969,11833,'no','FÃ¸derale forskuddstrekk',0),(425970,11833,'da','FÃ¸derale tilbageholdelse',0),(425971,11833,'ko','ì—°ë°© ì›ì²œ ì§•ìˆ˜',0),(425972,11833,'he','× ×™×›×•×™ ×ž×¡ ×¤×“×¨×œ×™',0),(425973,11833,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® Ï€Î±ÏÎ±ÎºÏÎ¬Ï„Î·ÏƒÎ·',0),(425974,11833,'zh','è”é‚¦é¢„æ‰£ç¨Ž\r\n',0),(425975,11833,'sv','Federal kÃ¤llskatt',0),(425976,11833,'it','Ritenuta federale',0),(425977,11833,'tl','',0),(425978,11833,'th','à¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢à¸‚à¸­à¸‡à¸£à¸±à¸à¸šà¸²à¸¥à¸à¸¥à¸²à¸‡',0),(425979,11833,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤°à¥‹à¤•',0),(425980,11833,'ms','Penangguhan Persekutuan',0),(425981,11833,'ar','Ø­Ø¬Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(425982,11833,'fr','Retrait du processus fÃ©dÃ©ral',0),(425983,11833,'jp','é€£é‚¦æºæ³‰å¾´åŽ',0),(425984,11833,'pt','RetenÃ§Ã£o Federal',0),(425985,11833,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ',0),(425986,11833,'es','Retenciones Federales',0),(425987,11833,'de','RÃ¼ckhaltung',0),(425988,11833,'en','Federal Withholding',0),(425989,11834,'is','',0),(425990,11834,'dr','Ù…Ù†Ø¹ Ù…Ø­Ù„ÛŒ',0),(425991,11834,'pr','Ù…Ù†Ø¹ Ù…Ø­Ù„ÛŒ',0),(425992,11834,'tr','Yerel stopaj',0),(425993,11834,'pl','Lokalne ÅºrÃ³dÅ‚a',0),(425994,11834,'bg','ÐœÐµÑÑ‚Ð½Ð¸ Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(425995,11834,'ur','Ù…Ù‚Ø§Ù…ÛŒ Ø±ÙˆÚ©Ù†Ø§',0),(425996,11834,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¸ Ð¿Ñ€Ð¸ÐºÑ€Ð¸Ð²Ð°ÑšÐ°',0),(425997,11834,'vi','Äá»‹a phÆ°Æ¡ng giá»¯ láº¡i',0),(425998,11834,'af','Plaaslike weerhouding',0),(425999,11834,'ro','ReÅ£inerea locale',0),(426000,11834,'et','Kohaliku maksu kinnipidaja',0),(426001,11834,'si','Lokalno zadrÅ¾anje',0),(426002,11834,'ba','Pemotongan lokal',0),(426003,11834,'nl','Lokale achterhouden',0),(426004,11834,'fi','Paikallinen ennakonpidÃ¤tys',0),(426005,11834,'no','Lokale forskuddstrekk',0),(426006,11834,'da','Lokale tilbageholdelse',0),(426007,11834,'ko','ì§€ì—­ ì§•ìˆ˜',0),(426008,11834,'he','×”×œ× ×ª ×ž×§×•×ž×™',0),(426009,11834,'el','Î¤Î¿Ï€Î¹ÎºÏŒ Ï€Î±ÏÎ±ÎºÏÎ¬Ï„Î·ÏƒÎ·',0),(426010,11834,'zh','æœ¬åœ°æ‰£ç¼´\r\n',0),(426011,11834,'sv','Lokala kÃ¤llskatt',0),(426012,11834,'it','Ritenute alla fonte locale',0),(426013,11834,'tl','',0),(426014,11834,'th','à¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢à¸ à¸²à¸¢à¹ƒà¸™',0),(426015,11834,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤°à¥‹à¤•',0),(426016,11834,'ms','Penangguhan tempatan',0),(426017,11834,'ar','Ø­Ø¬Ø¨ Ø§Ù„Ù…Ø­Ù„ÙŠØ©',0),(426018,11834,'fr','Local de rÃ©tention',0),(426019,11834,'jp','ãƒ­ãƒ¼ã‚«ãƒ«ã®æºæ³‰å¾´åŽ',0),(426020,11834,'pt','Locais de retenÃ§Ã£o',0),(426021,11834,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ðµ ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ',0),(426022,11834,'es','Retenciones Locales',0),(426023,11834,'de','Lokale zurÃ¼ckhalten',0),(426024,11834,'en','Local Withholding',0),(426025,11835,'is','',0),(426026,11835,'dr','Ù…Ù†Ø¹ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©ÛŒ',0),(426027,11835,'pr','Ù…Ù†Ø¹ Ù…Ø±Ø§Ù‚Ø¨Øª Ù¾Ø²Ø´Ú©ÛŒ',0),(426028,11835,'tr','Medicare stopaj',0),(426029,11835,'pl','Medicare wstrzymanie',0),(426030,11835,'bg','Medicare Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(426031,11835,'ur','Ù…ÛŒÚˆÛŒ Ø±ÙˆÚ©Ù†Ø§',0),(426032,11835,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ð¿Ñ€Ð¸ÐºÑ€Ð¸Ð²Ð°ÑšÐ°.',0),(426033,11835,'vi','giá»¯  y táº¿',0),(426034,11835,'af','Medicare weerhouding',0),(426035,11835,'ro','Medicare de la sursÄƒ',0),(426036,11835,'et','Medicare kinnipeetava',0),(426037,11835,'si','Medicare odtegljaj',0),(426038,11835,'ba','Pemotongan Medicare',0),(426039,11835,'nl','Medicare achterhouden',0),(426040,11835,'fi','Medicare ennakonpidÃ¤tys',0),(426041,11835,'no','Medicare forskuddstrekk',0),(426042,11835,'da','Medicare tilbageholdelse',0),(426043,11835,'ko','ë©”ë””ì¼€ì–´ ì›ì²œ ì§•ìˆ˜',0),(426044,11835,'he','Medicare ×”×œ× ×ª',0),(426045,11835,'el','Medicare Ï€Î±ÏÎ±ÎºÏÎ¬Ï„Î·ÏƒÎ·',0),(426046,11835,'zh','åŒ»ä¿æ‰£ç¼´\r\n',0),(426047,11835,'sv','Medicare kÃ¤llskatt',0),(426048,11835,'it','Medicare alla fonte',0),(426049,11835,'tl','',0),(426050,11835,'th','à¹€à¸¡à¸”à¸´à¹à¸„à¸£à¹Œà¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(426051,11835,'hi','à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤° à¤°à¥‹à¤•',0),(426052,11835,'ms','Medicare penangguhan',0),(426053,11835,'ar','Ø­Ø¬Ø¨ Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(426054,11835,'fr','Assurance maladie',0),(426055,11835,'jp','ãƒ¡ãƒ‡ã‚£ã‚±ã‚¢æºæ³‰å¾´åŽ',0),(426056,11835,'pt','RetenÃ§Ã£o de Medicare',0),(426057,11835,'ru','ÐœÐµÐ´Ð¸ÐºÑÑ€ ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ðµ',0),(426058,11835,'es','Retenciones de Medicare',0),(426059,11835,'de','Medicare zurÃ¼ckhalten',0),(426060,11835,'en','Medicare Withholding',0),(426061,11836,'is','',0),(426062,11836,'dr','/Ø§ÙØ²Ø§ÛŒØ´Ø§Øª ',0),(426063,11836,'pr','Ø¯ÛŒÚ¯Ø± Ú©Ø³ÙˆØ±Ø§Øª/Ø§ÙØ²Ø§ÛŒØ´Ø§Øª ',0),(426064,11836,'tr','DiÄŸer kesintiler/Ä°laveler',0),(426065,11836,'pl','Innych odliczeÅ„/Dodatki',0),(426066,11836,'bg','Ð”Ñ€ÑƒÐ³Ð¸ ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸/Ð´Ð¾Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ñ',0),(426067,11836,'ur','Ø¯ÛŒÚ¯Ø± Ú©Ù¹ÙˆØªÛŒ/Ø§Ø¶Ø§ÙÛ',0),(426068,11836,'sr','ÐžÑÑ‚Ð°Ð»Ðµ Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ/Ð´Ð¾Ð´Ð°Ñ†Ð¸',0),(426069,11836,'vi','CÃ¡c khoáº£n giáº£m trá»« khÃ¡c/ thÃªm khÃ¡c',0),(426070,11836,'af','Ander aftrekkings/toevoegings',0),(426071,11836,'ro','Alte deduceri/adÄƒugÄƒri',0),(426072,11836,'et','Muid mahaarvamisi/tÃ¤iendused',0),(426073,11836,'si','Drugih odbitkov/dodatkov',0),(426074,11836,'ba','Penambahan/pengurangan lain',0),(426075,11836,'nl','Andere inhoudingen/aanvullingen',0),(426076,11836,'fi','Muut vÃ¤hennykset lisÃ¤ykset',0),(426077,11836,'no','Andre fradrag/tilfÃ¸yelser',0),(426078,11836,'da','Anden fradrag/tilfÃ¸jelser',0),(426079,11836,'ko','ë‹¤ë¥¸ ê³µì œ/ì¶”ê°€',0),(426080,11836,'he','× ×™×›×•×™×™×/×ª×•×¡×¤×•×ª ××—×¨×•×ª',0),(426081,11836,'el','Î†Î»Î»ÎµÏ‚ ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚/Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎµÏ‚',0),(426082,11836,'zh','å…¶ä»–æ‰£é™¤/å¢žåŠ \r\n',0),(426083,11836,'sv','Andra avdrag/tillÃ¤gg',0),(426084,11836,'it','Aggiunte altre deduzioni',0),(426085,11836,'tl','',0),(426086,11836,'th','à¸­à¸·à¹ˆà¸™ à¹† à¸—à¸µà¹ˆà¸«à¸±à¸à¹€à¸žà¸´à¹ˆà¸¡',0),(426087,11836,'hi','à¤…à¤¨à¥à¤¯ à¤•à¤Ÿà¥Œà¤¤à¥€/à¤ªà¤°à¤¿à¤µà¤°à¥à¤§à¤¨',0),(426088,11836,'ms','Lain-lain potongan/penambahan',0),(426089,11836,'ar','Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª/Ø§Ù„Ø¥Ø¶Ø§ÙØ§Øª Ø§Ù„Ø£Ø®Ø±Ù‰',0),(426090,11836,'fr','Autres dÃ©ductions/ajouts',0),(426091,11836,'jp','ãã®ä»–ã®æŽ§é™¤/è¿½åŠ ',0),(426092,11836,'pt','Outras deduÃ§Ãµes/adiÃ§Ãµes',0),(426093,11836,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ð²Ñ‹Ñ‡ÐµÑ‚Ñ‹/Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(426094,11836,'es','Otros Deducciones/Adiciones',0),(426095,11836,'de','Andere AbzÃ¼ge/ErgÃ¤nzungen',0),(426096,11836,'en','Other Deductions/Additions',0),(426097,11837,'is','',0),(426098,11837,'dr','Ú©Ø³Ø± Ù…Ø§Ù„ÛŒØ§Øª Ø§ÙˆÙ„ÛŒÙ‡',0),(426099,11837,'pr','Ú©Ø³Ø± Ù…Ø§Ù„ÛŒØ§Øª Ø§ÙˆÙ„ÛŒÙ‡',0),(426100,11837,'tr','Vergi Ã¶ncesi indirimi',0),(426101,11837,'pl','Pretax odliczenia',0),(426102,11837,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ´Ð¸ Ð¾Ð±Ð»Ð°Ð³Ð°Ð½Ðµ Ñ Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(426103,11837,'ur','Ù¾Ø±ÛŒÙ¹Ù† Ù†ØªÛŒØ¬Û',0),(426104,11837,'sr','ÐÐ¼Ð¾Ñ€Ñ‚Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ð° Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð°',0),(426105,11837,'vi','trá»« thuáº¿ trÆ°á»›c',0),(426106,11837,'af','Pretax van die aftrekking',0),(426107,11837,'ro','Pretax deducerea',0),(426108,11837,'et','Maksueelne mahaarvamine',0),(426109,11837,'si','Pred obdavÄitvijo odbitek',0),(426110,11837,'ba','Sebelum pajak pemotongan',0),(426111,11837,'nl','Belastingen aftrek',0),(426112,11837,'fi','Pretax on vÃ¤hennetty',0),(426113,11837,'no','FÃ¸r skatt fradrag',0),(426114,11837,'da','Afgiftsfri fradrag',0),(426115,11837,'ko','ì„¸ ì „ ê³µì œ',0),(426116,11837,'he','× ×™×›×•×™ pretax',0),(426117,11837,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Ï€ÏÎ¿ Ï„Î·Ï‚ Ï†Î¿ÏÎ¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(426118,11837,'zh','ç¨Žå‰æ‰£é™¤\r\n',0),(426119,11837,'sv','Pretax avdrag',0),(426120,11837,'it','Deduzione pretassazione',0),(426121,11837,'tl','',0),(426122,11837,'th','à¸«à¸±à¸ pretax',0),(426123,11837,'hi','Pretax à¤•à¤Ÿà¥Œà¤¤à¥€',0),(426124,11837,'ms','Potongan sebelum cukai',0),(426125,11837,'ar','Ø®ØµÙ… Ù‚Ø¨Ù„ Ø®ØµÙ… Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(426126,11837,'fr','DÃ©duction avant impÃ´t',0),(426127,11837,'jp','ç¨ŽæŽ§é™¤',0),(426128,11837,'pt','DeduÃ§Ã£o antes de impostos',0),(426129,11837,'ru','Ð”Ð¾ Ð²Ñ‹Ñ‡ÐµÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ð²Ñ‹Ñ‡ÐµÑ‚Ð°',0),(426130,11837,'es','Deduccion Pretributario',0),(426131,11837,'de','Vorsteuer-Abzug',0),(426132,11837,'en','Pretax Deduction',0),(426133,11838,'is','',0),(426134,11838,'dr','Soc Ø«Ø§Ù†ÛŒÙ‡ Ø®ÙˆØ¯Ø¯Ø§Ø±ÛŒ',0),(426135,11838,'pr','Soc Ø«Ø§Ù†ÛŒÙ‡ Ø®ÙˆØ¯Ø¯Ø§Ø±ÛŒ',0),(426136,11838,'tr','SoC stopaj sn',0),(426137,11838,'pl','SOC s u ÅºrÃ³dÅ‚a',0),(426138,11838,'bg','SOC Sec Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(426139,11838,'ur','Ú© Ø³ÛŒÚ©Ù†Úˆ Ø±ÙˆÚ©Ù†Ø§',0),(426140,11838,'sr','Ð¨Ð¾Ñ› Ð¡ÐµÑ† Ð¿Ñ€Ð¸ÐºÑ€Ð¸Ð²Ð°ÑšÐ°',0),(426141,11838,'vi','SÃ³c Sec Ä‘Æ°á»£c kháº¥u trá»«',0),(426142,11838,'af','-SOC-Sec weerhouding',0),(426143,11838,'ro','Sec de soc de la sursÄƒ',0),(426144,11838,'et','SOC Sec kinnipeetava',0),(426145,11838,'si','SOC Sec odtegljaj',0),(426146,11838,'ba','Sec SOC pemotongan',0),(426147,11838,'nl','Soc Sec achterhouden',0),(426148,11838,'fi','SOC Sec ennakonpidÃ¤tys',0),(426149,11838,'no','SoC sek forskuddstrekk',0),(426150,11838,'da','Soc sek tilbageholdelse',0),(426151,11838,'ko','Soc ì´ˆ ì›ì²œ ì§•ìˆ˜',0),(426152,11838,'he','×©× ×™×” Soc ×”×œ× ×ª',0),(426153,11838,'el','SOC Sec Ï€Î±ÏÎ±ÎºÏÎ¬Ï„Î·ÏƒÎ·',0),(426154,11838,'zh','ç¤¾ä¼šä¿éšœæ‰£ç¼´\r\n',0),(426155,11838,'sv','Soc SEK kÃ¤llskatt',0),(426156,11838,'it','SoC Sec alla fonte',0),(426157,11838,'tl','',0),(426158,11838,'th','Soc à¸§à¸´à¸™à¸²à¸—à¸µà¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(426159,11838,'hi','à¤¸à¤®à¤¾à¤œ Withholding à¤à¤¸à¤ˆà¤¸à¥€',0),(426160,11838,'ms','Merlimau Sec penangguhan',0),(426161,11838,'ar','Ø´Ø±ÙƒØ© Ù†ÙØ· Ø§Ù„Ø¬Ù†ÙˆØ¨ Ø«Ø§Ù†ÙŠØ© Ø­Ø¬Ø¨',0),(426162,11838,'fr','Sec SOC retenue',0),(426163,11838,'jp','æºæ³‰å¾´åŽ Soc ç§’',0),(426164,11838,'pt','SOC Sec retido na fonte',0),(426165,11838,'ru','SoC ÑÐµÐºÑƒÐ½Ð´ ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ',0),(426166,11838,'es','Retenciones por Seguro Social',0),(426167,11838,'de','Soc Sec zurÃ¼ckhalten',0),(426168,11838,'en','Soc Sec Withholding',0),(426169,11839,'is','',0),(426170,11839,'dr','Ø®ÙˆØ¯Ø¯Ø§Ø±ÛŒ Ø¯ÙˆÙ„Øª',0),(426171,11839,'pr','Ø®ÙˆØ¯Ø¯Ø§Ø±ÛŒ Ø¯ÙˆÙ„Øª',0),(426172,11839,'tr','Devlet stopaj',0),(426173,11839,'pl','Stan wstrzymania',0),(426174,11839,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð¸Ð·Ñ‚Ð¾Ñ‡Ð½Ð¸ÐºÐ°',0),(426175,11839,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ø±ÙˆÚ©Ù†Ø§',0),(426176,11839,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ñ€Ð¸ÐºÑ€Ð¸Ð²Ð°ÑšÐ°',0),(426177,11839,'vi','NhÃ  nÆ°á»›c kháº¥u trá»«',0),(426178,11839,'af','Staat weerhouding',0),(426179,11839,'ro','ReÅ£inere la sursÄƒ de stat',0),(426180,11839,'et','Riigi maksu kinnipidaja',0),(426181,11839,'si','Stanju odtegljaj',0),(426182,11839,'ba','Pemotongan negara',0),(426183,11839,'nl','Achterhouden van staat',0),(426184,11839,'fi','Valtion ennakonpidÃ¤tys',0),(426185,11839,'no','Statlige forskuddstrekk',0),(426186,11839,'da','Statslige tilbageholdelse',0),(426187,11839,'ko','ì£¼ ì›ì²œ ì§•ìˆ˜',0),(426188,11839,'he','×”×œ× ×ª ×”×ž×“×™× ×”',0),(426189,11839,'el','ÎšÏÎ±Ï„Î¹ÎºÎ­Ï‚ Ï€Î±ÏÎ±ÎºÏÎ¬Ï„Î·ÏƒÎ·',0),(426190,11839,'zh','å›½å®¶æ‰£ç¼´\r\n',0),(426191,11839,'sv','Statliga kÃ¤llskatt',0),(426192,11839,'it','Ritenute alla fonte statale',0),(426193,11839,'tl','',0),(426194,11839,'th','à¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢à¸£à¸±à¸',0),(426195,11839,'hi','à¤°à¤¾à¤œà¥ à¤¯ à¤°à¥‹à¤•',0),(426196,11839,'ms','Penangguhan Negeri',0),(426197,11839,'ar','Ø­Ø¬Ø¨ Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(426198,11839,'fr','Ã‰tat de retenue',0),(426199,11839,'jp','çŠ¶æ…‹ã®æºæ³‰å¾´åŽ',0),(426200,11839,'pt','Estado de retenÃ§Ã£o',0),(426201,11839,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ð°Ñ Ð½ÐµÑƒÐ¿Ð»Ð°Ñ‚Ñ‹',0),(426202,11839,'es','Retenciones Estatales',0),(426203,11839,'de','Staatliche ZurÃ¼ckhaltung',0),(426204,11839,'en','State Withholding',0),(426205,11840,'is','',0),(426206,11840,'dr','Ø®Ù„Ø§ØµÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ú©Ø§Ø±Ù…Ù†Ø¯ ',0),(426207,11840,'pr','Ø®Ù„Ø§ØµÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ú©Ø§Ø±Ù…Ù†Ø¯ ',0),(426208,11840,'tr','Ã‡alÄ±ÅŸanÄ±n Ã¶deme Ã–zeti',0),(426209,11840,'pl','Podsumowanie wynagrodzenia pracownika',0),(426210,11840,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾ Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(426211,11840,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(426212,11840,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð¿Ð»Ð°Ñ‚Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(426213,11840,'vi','tá»•ng há»£p chi phÃ­ tráº£ nhÃ¢n viÃªn',0),(426214,11840,'af','Werknemer betaal opsomming',0),(426215,11840,'ro','Rezumat de salariu angajat',0),(426216,11840,'et','TÃ¶Ã¶taja tasuleppe KokkuvÃµte',0),(426217,11840,'si','Zaposleni plaÄati Povzetek',0),(426218,11840,'ba','Ringkasan membayar karyawan',0),(426219,11840,'nl','Werknemer Pay samenvatting',0),(426220,11840,'fi','TyÃ¶ntekijÃ¤n maksu Yhteenveto',0),(426221,11840,'no','Ansatte lÃ¸nn Sammendrag',0),(426222,11840,'da','Medarbejder lÃ¸n ResumÃ©',0),(426223,11840,'ko','ì§ì› ê¸‰ì—¬ ìš”ì•½',0),(426224,11840,'he','×¡×™×›×•× ×©×›×¨ ×”×¢×•×‘×“',0),(426225,11840,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î±Î¼Î¿Î¹Î²ÏŽÎ½ Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(426226,11840,'zh','å‘˜å·¥å·¥èµ„æ‘˜è¦\r\n',0),(426227,11840,'sv','Medarbetaren betalar Sammanfattning',0),(426228,11840,'it','Dipendente paga Sommario',0),(426229,11840,'tl','',0),(426230,11840,'th','à¸ªà¸£à¸¸à¸›à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(426231,11840,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥‡à¤¤à¤¨ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(426232,11840,'ms','Ringkasan gaji pekerja',0),(426233,11840,'ar','Ù…Ù„Ø®Øµ Ù…Ø±ØªØ¨ Ø§Ù„Ù…ÙˆØ¸Ù',0),(426234,11840,'fr','EmployÃ© paye RÃ©sumÃ©',0),(426235,11840,'jp','å¾“æ¥­å“¡ã®çµ¦ä¸Žã®æ¦‚è¦',0),(426236,11840,'pt','Resumo de salÃ¡rio do funcionÃ¡rio',0),(426237,11840,'ru','Ð¡Ð²Ð¾Ð´ÐºÐ° Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°Ð¼',0),(426238,11840,'es','Sumario de Pagos al Empleados',0),(426239,11840,'de','Mitarbeiter-Pay-Zusammenfassung',0),(426240,11840,'en','Employee Pay Summary',0),(426241,11841,'is','',0),(426242,11841,'dr','ÙˆØ±ÙˆØ¯ÛŒ ØµÙØ­Ù‡ Ø§ÛŒÙ†ØªØ±Ù†ØªÛŒ ØªØ¬Ø§Ø±Øª Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(426243,11841,'pr','ÙˆØ±ÙˆØ¯ÛŒ ØµÙØ­Ù‡ Ø§ÛŒÙ†ØªØ±Ù†ØªÛŒ ØªØ¬Ø§Ø±Øª Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(426244,11841,'tr','B2B Web portalÄ±',0),(426245,11841,'pl','Portal internetowy B2B',0),(426246,11841,'bg','B2B ÑƒÐµÐ± Ð¿Ð¾Ñ€Ñ‚Ð°Ð»',0),(426247,11841,'ur','B2B ÙˆÛŒØ¨ Ù¾ÙˆØ±Ù¹Ù„',0),(426248,11841,'sr','Ð‘2Ð‘ WÐµÐ± Ð¿Ð¾Ñ€Ñ‚Ð°Ð»Ð°',0),(426249,11841,'vi','B2B Cá»•ng web ',0),(426250,11841,'af','B2B Web Portaal',0),(426251,11841,'ro','B2B Web Portal',0),(426252,11841,'et','B2B portaal',0),(426253,11841,'si','B2B spletni Portal',0),(426254,11841,'ba','B2B Web Portal',0),(426255,11841,'nl','B2B webportal',0),(426256,11841,'fi','B2B Web-portaalin',0),(426257,11841,'no','B2B nettportalen',0),(426258,11841,'da','B2B webportal',0),(426259,11841,'ko','B2B ì›¹ í¬í„¸',0),(426260,11841,'he','×¤×•×¨×˜×œ B2B',0),(426261,11841,'el','Î’2Î’ Î´Î¹ÎºÏ„Ï…Î±ÎºÎ® Ï€ÏÎ»Î·',0),(426262,11841,'zh','å•†ä¸šå¯¹å•†ä¸šçš„é—¨æˆ·ç½‘ç«™\r\n',0),(426263,11841,'sv','B2B webbportal',0),(426264,11841,'it','Portale Web B2B',0),(426265,11841,'tl','',0),(426266,11841,'th','B2B à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ',0),(426267,11841,'hi','B2B à¤µà¥‡à¤¬ à¤ªà¥‹à¤°à¥à¤Ÿà¤²',0),(426268,11841,'ms','B2B Web Portal',0),(426269,11841,'ar','B2B Ø¨ÙˆØ§Ø¨Ø© ÙˆÙŠØ¨',0),(426270,11841,'fr','Portail Web B2B',0),(426271,11841,'jp','B2B Web ãƒãƒ¼ã‚¿ãƒ«',0),(426272,11841,'pt','B2B Web Portal',0),(426273,11841,'ru','B2B Ð¿Ð¾Ñ€Ñ‚Ð°Ð»',0),(426274,11841,'es','N2N Portal del Web',0),(426275,11841,'de','B2B-Web-Portal',0),(426276,11841,'en','B2B Web Portal',0),(426277,11842,'is','',0),(426278,11842,'dr','Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©',0),(426279,11842,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©',0),(426280,11842,'tr','Banka MevduatÄ±',0),(426281,11842,'pl','Lokaty bankowe',0),(426282,11842,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(426283,11842,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ø°Ø®Ø§Ø¦Ø±',0),(426284,11842,'sr','Ð¨Ñ‚ÐµÐ´Ð½Ð¸Ñ… ÑƒÐ»Ð¾Ð³Ð°',0),(426285,11842,'vi','Tiá»n gá»­i ngÃ¢n hÃ ng',0),(426286,11842,'af','Bank Deposito\'s',0),(426287,11842,'ro','Depozite bancare',0),(426288,11842,'et','Panga hoiused',0),(426289,11842,'si','BanÄne depozite',0),(426290,11842,'ba','Deposito bank',0),(426291,11842,'nl','Bank deposito \'s',0),(426292,11842,'fi','Pankkiin',0),(426293,11842,'no','Bankinnskudd',0),(426294,11842,'da','Bankindbetalinger',0),(426295,11842,'ko','ì€í–‰ ì˜ˆê¸ˆ',0),(426296,11842,'he','×”×¤×§×“×•×ª ×‘× ×§××™×•×ª',0),(426297,11842,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ­Ï‚ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚',0),(426298,11842,'zh','é“¶è¡Œå­˜æ¬¾\r\n',0),(426299,11842,'sv','BankinlÃ¥ning',0),(426300,11842,'it','Depositi bancari',0),(426301,11842,'tl','',0),(426302,11842,'th','à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸˜à¸™à¸²à¸„à¸²à¸£',0),(426303,11842,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾',0),(426304,11842,'ms','Deposit Bank',0),(426305,11842,'ar','Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(426306,11842,'fr','DÃ©pÃ´ts bancaires',0),(426307,11842,'jp','éŠ€è¡Œé é‡‘',0),(426308,11842,'pt','DepÃ³sitos bancÃ¡rios',0),(426309,11842,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹',0),(426310,11842,'es','Depositos Bancarios',0),(426311,11842,'de','Bankeinlagen',0),(426312,11842,'en','Bank Deposits',0),(426313,11843,'is','',0),(426314,11843,'dr','ØªÙ…Ø§Ø³Ù‡Ø§',0),(426315,11843,'pr','ØªÙ…Ø§Ø³Ù‡Ø§',0),(426316,11843,'tr','KiÅŸiler',0),(426317,11843,'pl','Kontakty',0),(426318,11843,'bg','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(426319,11843,'ur','Ø±Ø§Ø¨Ø·Û Ø§ÙØ±Ø§Ø¯',0),(426320,11843,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(426321,11843,'vi','nhá»¯ng liÃªn há»‡',0),(426322,11843,'af','Kontakte',0),(426323,11843,'ro','Persoane de contact',0),(426324,11843,'et','Kontaktid',0),(426325,11843,'si','Stiki',0),(426326,11843,'ba','Kontak',0),(426327,11843,'nl','Contactpersonen',0),(426328,11843,'fi','Yhteystiedot',0),(426329,11843,'no','Kontakter',0),(426330,11843,'da','Kontakter',0),(426331,11843,'ko','ì—°ë½ì²˜',0),(426332,11843,'he','×× ×©×™ ×§×©×¨',0),(426333,11843,'el','Î•Ï€Î±Ï†Î­Ï‚',0),(426334,11843,'zh','è”ç³»äºº\r\n',0),(426335,11843,'sv','Kontakter',0),(426336,11843,'it','Contatti',0),(426337,11843,'tl','',0),(426338,11843,'th','à¸•à¸´à¸”à¸•à¹ˆà¸­',0),(426339,11843,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤•',0),(426340,11843,'ms','Orang hubungan',0),(426341,11843,'ar','Ø¬Ù‡Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„',0),(426342,11843,'fr','Contacts',0),(426343,11843,'jp','é€£çµ¡å…ˆ',0),(426344,11843,'pt','Contatos',0),(426345,11843,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñ‹',0),(426346,11843,'es','Contactos',0),(426347,11843,'de','Kontakte',0),(426348,11843,'en','Contacts',0),(426349,11844,'is','',0),(426350,11844,'dr','Ù…Ù†ÙˆÛŒ ØªÙˆØ¶ÛŒØ­ÛŒ ØªÙ…Ø§Ø³Ù‡Ø§',0),(426351,11844,'pr','Ù…Ù†ÙˆÛŒ ØªÙˆØ¶ÛŒØ­ÛŒ ØªÙ…Ø§Ø³Ù‡Ø§',0),(426352,11844,'tr','KiÅŸiler',0),(426353,11844,'pl','Kontakty',0),(426354,11844,'bg','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(426355,11844,'ur','Ø±Ø§Ø¨Ø·Û Ø§ÙØ±Ø§Ø¯',0),(426356,11844,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(426357,11844,'vi','LiÃªn láº¡c',0),(426358,11844,'af','Kontakte',0),(426359,11844,'ro','Persoane de contact',0),(426360,11844,'et','Kontaktid',0),(426361,11844,'si','Stiki',0),(426362,11844,'ba','Kontak',0),(426363,11844,'nl','Contactpersonen',0),(426364,11844,'fi','Yhteystiedot',0),(426365,11844,'no','Kontakter',0),(426366,11844,'da','Kontakter',0),(426367,11844,'ko','ì—°ë½ì²˜',0),(426368,11844,'he','×× ×©×™ ×§×©×¨',0),(426369,11844,'el','Î•Ï€Î±Ï†Î­Ï‚',0),(426370,11844,'zh','è”ç³»äºº\r\n',0),(426371,11844,'sv','Kontakter',0),(426372,11844,'it','Contatti',0),(426373,11844,'tl','',0),(426374,11844,'th','à¸•à¸´à¸”à¸•à¹ˆà¸­',0),(426375,11844,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤•',0),(426376,11844,'ms','Orang hubungan',0),(426377,11844,'ar','Ø¬Ù‡Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„',0),(426378,11844,'fr','Contacts',0),(426379,11844,'jp','é€£çµ¡å…ˆ',0),(426380,11844,'pt','Contatos',0),(426381,11844,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñ‹',0),(426382,11844,'es','Contactos',0),(426383,11844,'de','Kontakte',0),(426384,11844,'en','Contacts',0),(426385,11845,'is','',0),(426386,11845,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(426387,11845,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(426388,11845,'tr','Kredi kartÄ± faturalarÄ±',0),(426389,11845,'pl','Rachunki kart kredytowych',0),(426390,11845,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(426391,11845,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø¨Ù„Ø²',0),(426392,11845,'sr','Ð Ð°Ñ‡ÑƒÐ½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(426393,11845,'vi','hÃ³a Ä‘Æ¡n tháº» tÃ­n dá»¥ng',0),(426394,11845,'af','Kredietkaart Rekeninge',0),(426395,11845,'ro','Facturile de Card de credit',0),(426396,11845,'et','Krediitkaardi arveid',0),(426397,11845,'si','RaÄune kreditnih kartic',0),(426398,11845,'ba','Tagihan kartu kredit',0),(426399,11845,'nl','Credit Card rekeningen',0),(426400,11845,'fi','Luottokortti laskut',0),(426401,11845,'no','Kredittkort regninger',0),(426402,11845,'da','Kreditkort regninger',0),(426403,11845,'ko','ì‹ ìš© ì¹´ë“œ ì²­êµ¬ì„œ',0),(426404,11845,'he','. ×—×©×‘×•× ×•×ª ×›×¨×˜×™×¡ ×”××©×¨××™',0),(426405,11845,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(426406,11845,'zh','ä¿¡ç”¨å¡å¸å•\r\n',0),(426407,11845,'sv','Kreditkort rÃ¤kningar',0),(426408,11845,'it','Fatture della carta di credito',0),(426409,11845,'tl','',0),(426410,11845,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(426411,11845,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¬à¤¿à¤²',0),(426412,11845,'ms','Bil-bil kad kredit',0),(426413,11845,'ar','ÙÙˆØ§ØªÙŠØ± Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(426414,11845,'fr','Factures de carte de crÃ©dit',0),(426415,11845,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è«‹æ±‚æ›¸',0),(426416,11845,'pt','CartÃ£o de crÃ©dito',0),(426417,11845,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(426418,11845,'es','Estados de Cuenta de Tarjetas de CrÃ©dito',0),(426419,11845,'de','Kreditkarten-Rechnungen',0),(426420,11845,'en','Credit Card Bills',0),(426421,11846,'is','',0),(426422,11846,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±',0),(426423,11846,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±',0),(426424,11846,'tr','MÃ¼ÅŸteri hesaplarÄ±',0),(426425,11846,'pl','Konta klientÃ³w',0),(426426,11846,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(426427,11846,'ur','Ú©Ø³Ù¹Ù…Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(426428,11846,'sr','ÐšÐ¾Ð½Ñ‚Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(426429,11846,'vi','cÃ¡c tÃ i khoáº£n khÃ¡ch hÃ ng',0),(426430,11846,'af','Klant/KliÃ«nt Rekeninge',0),(426431,11846,'ro','Conturi de client',0),(426432,11846,'et','Kliendikoodide',0),(426433,11846,'si','Kupcev',0),(426434,11846,'ba','Rekening nasabah',0),(426435,11846,'nl','Klantenaccounts',0),(426436,11846,'fi','Asiakas tili',0),(426437,11846,'no','Kundekontoer',0),(426438,11846,'da','Debitorkonti',0),(426439,11846,'ko','ê³ ê° ê³„ì •',0),(426440,11846,'he','×—×©×‘×•× ×•×ª ×œ×§×•×—×•×ª',0),(426441,11846,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(426442,11846,'zh','å®¢æˆ·å¸æˆ·\r\n',0),(426443,11846,'sv','Kundkonton',0),(426444,11846,'it','Conti dei clienti',0),(426445,11846,'tl','',0),(426446,11846,'th','à¸šà¸±à¸à¸Šà¸µà¸¥à¸¹à¸à¸„à¹‰à¸²',0),(426447,11846,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤–à¤¾à¤¤à¥‹à¤‚',0),(426448,11846,'ms','Akaun pelanggan',0),(426449,11846,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(426450,11846,'fr','Comptes clients',0),(426451,11846,'jp','é¡§å®¢ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(426452,11846,'pt','Contas de clientes',0),(426453,11846,'ru','Ð¡Ñ‡ÐµÑ‚Ð¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(426454,11846,'es','Cuentas de Clientes',0),(426455,11846,'de','Kunden-Accounts',0),(426456,11846,'en','Customer Accounts',0),(426457,11847,'is','',0),(426458,11847,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´',0),(426459,11847,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´',0),(426460,11847,'tr','SatÄ±ÅŸ personeli DÃ¼zenle',0),(426461,11847,'pl','Edytuj sprzedaÅ¼y personelu',0),(426462,11847,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(426463,11847,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø±ÙˆÚº Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(426464,11847,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(426465,11847,'vi','Sá»­a bÃ¡n hÃ ng cÃ¡ nhÃ¢n',0),(426466,11847,'af','Redigeer verkope personeel',0),(426467,11847,'ro','Editare personal de vÃ¢nzÄƒri',0),(426468,11847,'et','Redigeeri mÃ¼Ã¼gipersonalile',0),(426469,11847,'si','Urejanje prodajnega osebja',0),(426470,11847,'ba','Mengedit personil penjualan',0),(426471,11847,'nl','Verkooppersoneel bewerken',0),(426472,11847,'fi','Muokkaa myyjien',0),(426473,11847,'no','Redigere salgspersonale',0),(426474,11847,'da','Redigere salgspersonale',0),(426475,11847,'ko','ì˜ì—… ì¸ë ¥ì„ íŽ¸ì§‘',0),(426476,11847,'he','×¢×¨×•×š ×× ×©×™ ×ž×›×™×¨×•×ª',0),(426477,11847,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(426478,11847,'zh','ä¿®æ”¹é”€å”®äººå‘˜\r\n',0),(426479,11847,'sv','Redigera sÃ¤ljpersonal',0),(426480,11847,'it','Modificare il personale di vendita',0),(426481,11847,'tl','',0),(426482,11847,'th','à¹à¸à¹‰à¹„à¸‚à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢',0),(426483,11847,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(426484,11847,'ms','Edit kakitangan jualan',0),(426485,11847,'ar','ØªØ­Ø±ÙŠØ± Ø£ÙØ±Ø§Ø¯ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(426486,11847,'fr','Edit du Personnel de vente',0),(426487,11847,'jp','å–¶æ¥­æ‹…å½“è€…ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(426488,11847,'pt','Editar o pessoal de vendas',0),(426489,11847,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¾Ñ€Ð³Ð¾Ð²Ð¾Ð³Ð¾ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð°',0),(426490,11847,'es','Editar Vendedores',0),(426491,11847,'de','Bearbeiten von Verkaufspersonal',0),(426492,11847,'en','Edit Sales Personnel',0),(426493,11848,'is','',0),(426494,11848,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù†ÙˆØ¹ Ù…Ø§Ù„ÛŒØ§Øª',0),(426495,11848,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù†ÙˆØ¹ Ù…Ø§Ù„ÛŒØ§Øª',0),(426496,11848,'tr','Vergi tÃ¼rÃ¼ DÃ¼zenle',0),(426497,11848,'pl','EdytowaÄ‡ typ podatku',0),(426498,11848,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿Ð° Ð½Ð° Ð´Ð°Ð½ÑŠÐº',0),(426499,11848,'ur','Ù¹ÛŒÚ©Ø³ Ù‚Ø³Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(426500,11848,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð²Ñ€ÑÑ‚Ð° ÐŸÐ”Ð’-Ð°',0),(426501,11848,'vi','Sá»­a loáº¡i thuáº¿',0),(426502,11848,'af','Redigeer belasting tipe',0),(426503,11848,'ro','Editare tip de impozit',0),(426504,11848,'et','Muuta makse tÃ¼Ã¼p',0),(426505,11848,'si','Uredite vrsto davka',0),(426506,11848,'ba','Mengedit jenis pajak',0),(426507,11848,'nl','Fiscale Type bewerken',0),(426508,11848,'fi','Muokkaa ALV-tyyppi',0),(426509,11848,'no','Redigere skatt Type',0),(426510,11848,'da','Redigere afgiftstype.',0),(426511,11848,'ko','ì„¸ê¸ˆ ìœ í˜• íŽ¸ì§‘',0),(426512,11848,'he','×¢×¨×•×š ×¡×•×’ ×ž×¡',0),(426513,11848,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„ÏÏ€Î¿Ï‚ Î¦Î Î‘',0),(426514,11848,'zh','ç¼–è¾‘ç¨Žç§\r\n',0),(426515,11848,'sv','Redigera typ av skatte',0),(426516,11848,'it','Modificare il tipo di tassa',0),(426517,11848,'tl','',0),(426518,11848,'th','à¹à¸à¹‰à¹„à¸‚à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸ à¸²à¸©à¸µ',0),(426519,11848,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(426520,11848,'ms','Edit jenis cukai',0),(426521,11848,'ar','ØªØ­Ø±ÙŠØ± Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(426522,11848,'fr','Modifier le Type de taxe',0),(426523,11848,'jp','ç¨Žã‚¿ã‚¤ãƒ—ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(426524,11848,'pt','Editar o tipo de imposto',0),(426525,11848,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(426526,11848,'es','Editar Tipo de Impuesto',0),(426527,11848,'de','Steuerart bearbeiten',0),(426528,11848,'en','Edit Tax Type',0),(426529,11849,'is','',0),(426530,11849,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(426531,11849,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(426532,11849,'tr','SatÄ±cÄ± Fatura dÃ¼zenleme',0),(426533,11849,'pl','Edytowanie dostawcy Bill',0),(426534,11849,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(426535,11849,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(426536,11849,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð‘Ð¸Ð»',0),(426537,11849,'vi','Sá»­a hÃ³a Ä‘Æ¡n nhÃ  cung cáº¥p',0),(426538,11849,'af','Redigeer handelaar Wetsontwerp',0),(426539,11849,'ro','Editare furnizor factura',0),(426540,11849,'et','Muuta hankija arve',0),(426541,11849,'si','Urejanje raÄun dobavitelja',0),(426542,11849,'ba','Mengedit Vendor Bill',0),(426543,11849,'nl','Leverancier Bill bewerken',0),(426544,11849,'fi','Muokkaa toimittajan lasku',0),(426545,11849,'no','Redigere leverandÃ¸r',0),(426546,11849,'da','Rediger leverandÃ¸r Bill',0),(426547,11849,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ íŽ¸ì§‘í•˜ì‹œì˜¤',0),(426548,11849,'he','×¢×¨×™×›×ª ×—×©×‘×•×Ÿ ×¡×¤×§',0),(426549,11849,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(426550,11849,'zh','ç¼–è¾‘å–æ–¹å¸å•\r\n',0),(426551,11849,'sv','Redigera leverantÃ¶r Bill',0),(426552,11849,'it','Modificare la fattura fornitore',0),(426553,11849,'tl','',0),(426554,11849,'th','à¹à¸à¹‰à¹„à¸‚à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸•à¸±à¹‹à¸§',0),(426555,11849,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(426556,11849,'ms','Edit penjual Rang undang-undang',0),(426557,11849,'ar','ØªØ­Ø±ÙŠØ± ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…ÙˆØ±Ø¯',0),(426558,11849,'fr','Ã‰diter la facture du vendeur',0),(426559,11849,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(426560,11849,'pt','Editar conta de fornecedor',0),(426561,11849,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð‘Ð¸Ð»Ð»',0),(426562,11849,'es','Editar Recibo del Proveedor',0),(426563,11849,'de','Kreditor Rechnung bearbeiten',0),(426564,11849,'en','Edit Vendor Bill',0),(426565,11850,'is','',0),(426566,11850,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ØµØ§Ø¯Ø±Ø§Øª',0),(426567,11850,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ØµØ§Ø¯Ø±Ø§Øª',0),(426568,11850,'tr','Ä°thalat/ihracat',0),(426569,11850,'pl','Import/eksport',0),(426570,11850,'bg','Ð’Ð½Ð¾Ñ/Ð¸Ð·Ð½Ð¾Ñ',0),(426571,11850,'ur','Ø¯Ø±Ø¢Ù…Ø¯/Ø¨Ø±Ø¢Ù…Ø¯',0),(426572,11850,'sr','Ð£Ð²Ð¾Ð·/Ð¸Ð·Ð²Ð¾Ð·',0),(426573,11850,'vi','Nháº­p kháº©u/xuáº¥t kháº©u',0),(426574,11850,'af','Invoere/uitvoere',0),(426575,11850,'ro','Importuri/exporturi',0),(426576,11850,'et','Import/eksport',0),(426577,11850,'si','Uvoz/izvoz',0),(426578,11850,'ba','Impor/ekspor',0),(426579,11850,'nl','Import/export',0),(426580,11850,'fi','Vienti',0),(426581,11850,'no','Import/eksport',0),(426582,11850,'da','Import/eksport',0),(426583,11850,'ko','ê°€ì ¸ì˜¤ê¸°/ë‚´ë³´ë‚´ê¸°',0),(426584,11850,'he','×™×‘×•×/×™×¦×•×',0),(426585,11850,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î­Ï‚/ÎµÎ¾Î±Î³Ï‰Î³Î­Ï‚',0),(426586,11850,'zh','è¿›å£/å‡ºå£\r\n',0),(426587,11850,'sv','Import/export',0),(426588,11850,'it','Importazioni/esportazioni',0),(426589,11850,'tl','',0),(426590,11850,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²/à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(426591,11850,'hi','à¤†à¤¯à¤¾à¤¤/à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤',0),(426592,11850,'ms','Import/Eksport',0),(426593,11850,'ar','Ø§Ù„ÙˆØ§Ø±Ø¯Ø§Øª/Ø§Ù„ØµØ§Ø¯Ø±Ø§Øª',0),(426594,11850,'fr','Importations/exportations',0),(426595,11850,'jp','è¼¸å…¥/è¼¸å‡º',0),(426596,11850,'pt','ImportaÃ§Ãµes/exportaÃ§Ãµes',0),(426597,11850,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚/ÑÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(426598,11850,'es','Importaciones/Exportaciones',0),(426599,11850,'de','Einfuhren/Ausfuhren',0),(426600,11850,'en','Imports/Exports',0),(426601,11851,'is','',0),(426602,11851,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ÙØ§ÛŒÙ„ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø³Ø±ÛŒØ¹',0),(426603,11851,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ÙØ§ÛŒÙ„ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø³Ø±ÛŒØ¹',0),(426604,11851,'tr','QuickBooks dosyalarÄ±nÄ± iÃ§e aktarma',0),(426605,11851,'pl','Importowanie plikÃ³w programu QuickBooks',0),(426606,11851,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ Ð·Ð° QuickBooks',0),(426607,11851,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ù…Ø³Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(426608,11851,'sr','Ð£Ð²Ð¾Ð· QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(426609,11851,'vi','file nháº­p Quickbooks',0),(426610,11851,'af','QuickBooks lÃªers invoer',0),(426611,11851,'ro','QuickBooks fiÅŸierele de import',0),(426612,11851,'et','QuickBooksi impordifailide',0),(426613,11851,'si','Uvoz datotek QuickBooks',0),(426614,11851,'ba','Mengimpor file QuickBooks',0),(426615,11851,'nl','QuickBooks-bestanden importeren',0),(426616,11851,'fi','QuickBooks tuontitiedostot',0),(426617,11851,'no','Importere QuickBooks-filer',0),(426618,11851,'da','Importere QuickBooks filer',0),(426619,11851,'ko','QuickBooks íŒŒì¼ ê°€ì ¸ì˜¤ê¸°',0),(426620,11851,'he','×™×™×‘×•× ×§×‘×¦×™× QuickBooks',0),(426621,11851,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® QuickBooks Î±ÏÏ‡ÎµÎ¯Î±',0),(426622,11851,'zh','å¯¼å…¥QuickBookè½¯ä»¶çš„æ–‡ä»¶\r\n',0),(426623,11851,'sv','QuickBooks importfiler',0),(426624,11851,'it','Importare file QuickBooks',0),(426625,11851,'tl','',0),(426626,11851,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹„à¸Ÿà¸¥à¹Œ QuickBooks',0),(426627,11851,'hi','QuickBooks à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(426628,11851,'ms','Mengimport fail QuickBooks',0),(426629,11851,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù„ÙØ§Øª Ù‚Ø±Ø§Ø¡',0),(426630,11851,'fr','Importer des fichiers de QuickBooks',0),(426631,11851,'jp','QuickBooks ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(426632,11851,'pt','Importar arquivos de QuickBooks',0),(426633,11851,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ñ„Ð°Ð¹Ð»Ð¾Ð² QuickBooks',0),(426634,11851,'es','Importar Files de Quickbooks',0),(426635,11851,'de','QuickBooks-Dateien importieren',0),(426636,11851,'en','Import QuickBooks Files',0),(426637,11852,'is','',0),(426638,11852,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú©Ø§Ù„Ø§',0),(426639,11852,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ú©Ø§Ù„Ø§',0),(426640,11852,'tr','Madde Fulfillment sipariÅŸler',0),(426641,11852,'pl','Element realizacji zamÃ³wienia',0),(426642,11852,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(426643,11852,'ur','Ø´Û’ Ú©ÛŒ ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(426644,11852,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(426645,11852,'vi','ÄÆ¡n Ä‘áº·t hÃ ng',0),(426646,11852,'af','Item nakoming Orders',0),(426647,11852,'ro','Comenzi de Ã®mplinire element',0),(426648,11852,'et','Kauba plaanitud tellimused',0),(426649,11852,'si','Element izpolnitev naroÄila',0),(426650,11852,'ba','Item pemenuhan order',0),(426651,11852,'nl','Item vervulling Orders',0),(426652,11852,'fi','Nimikkeen tÃ¤yttÃ¤minen tilaukset',0),(426653,11852,'no','Elementet fullfÃ¸ringen bestillinger',0),(426654,11852,'da','Vare opfyldelse ordrer',0),(426655,11852,'ko','í•­ëª© ì²˜ë¦¬ ìˆœì„œ',0),(426656,11852,'he','×¤×¨×™×˜ ×ž×™×ž×•×© ×”×–×ž× ×•×ª',0),(426657,11852,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(426658,11852,'zh','é¡¹ç›®è®¢å•\r\n',0),(426659,11852,'sv','Objektet uppfyllelse order',0),(426660,11852,'it','Elemento evasione ordini',0),(426661,11852,'tl','',0),(426662,11852,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(426663,11852,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶',0),(426664,11852,'ms','Item memenuhi perintah',0),(426665,11852,'ar','Ø§Ù„Ø¨Ù†Ø¯ ÙˆÙØ§Ø¡ Ø£ÙˆØ§Ù…Ø±',0),(426666,11852,'fr','Des ordres de point',0),(426667,11852,'jp','é …ç›®ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ãƒ» ã‚ªãƒ¼ãƒ€ãƒ¼',0),(426668,11852,'pt','Ordens de cumprimento do item',0),(426669,11852,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(426670,11852,'es','Pedidos de Items',0),(426671,11852,'de','Element-Fulfillment-Bestellungen',0),(426672,11852,'en','Item Fulfillment Orders',0),(426673,11853,'is','',0),(426674,11853,'dr','Ø­Ù…Ù„ Ú©Ø§Ù„Ø§',0),(426675,11853,'pr','Ø­Ù…Ù„ Ú©Ø§Ù„Ø§',0),(426676,11853,'tr','Madde sevk irsaliyeleri',0),(426677,11853,'pl','WysyÅ‚ki towaru',0),(426678,11853,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(426679,11853,'ur','Ø´Û’ Ú©ÛŒ ØªØ±Ø³ÛŒÙ„',0),(426680,11853,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(426681,11853,'vi','chuyá»ƒn hÃ ng',0),(426682,11853,'af','Item gestuur',0),(426683,11853,'ro','Element de transporturi',0),(426684,11853,'et','Kauba vedude',0),(426685,11853,'si','Element poÅ¡iljk',0),(426686,11853,'ba','Pengiriman barang',0),(426687,11853,'nl','Item zendingen',0),(426688,11853,'fi','ErÃ¤ lÃ¤hetyksiÃ¤',0),(426689,11853,'no','Elementet forsendelser',0),(426690,11853,'da','Vare forsendelser',0),(426691,11853,'ko','í•­ëª© ì¶œí•˜',0),(426692,11853,'he','×¤×¨×™×˜ ×ž×©×œ×•×—×™×',0),(426693,11853,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(426694,11853,'zh','ç‰©å“å‘è´§\r\n',0),(426695,11853,'sv','Objektet transporter',0),(426696,11853,'it','Elemento spedizioni',0),(426697,11853,'tl','',0),(426698,11853,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(426699,11853,'hi','à¤†à¤‡à¤Ÿà¤® à¤²à¤¦à¤¾à¤¨',0),(426700,11853,'ms','Penghantaran item',0),(426701,11853,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ø´Ø­Ù†Ø§Øª',0),(426702,11853,'fr','ExpÃ©ditions de point',0),(426703,11853,'jp','é …ç›®ã®å‡ºè·å°æ•°',0),(426704,11853,'pt','Carregamentos de item',0),(426705,11853,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(426706,11853,'es','Envios de Items',0),(426707,11853,'de','Element-Sendungen',0),(426708,11853,'en','Item Shipments',0),(426709,11854,'is','',0),(426710,11854,'dr','/Ø§ØµÙ„Ø§Ø­',0),(426711,11854,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(426712,11854,'tr','Yeni/DÃ¼zenle bÃ¼tÃ§e',0),(426713,11854,'pl','Nowy edycja budÅ¼etu',0),(426714,11854,'bg','ÐÐ¾Ð²Ð¸/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(426715,11854,'ur','Ù†Ø¦ÛŒ/ØªØ±Ù…ÛŒÙ… Ø¨Ø¬Ù¹',0),(426716,11854,'sr','ÐÐ¾Ð²Ð¸ Ð£Ñ€ÐµÐ´Ð¸ Ð±ÑƒÑŸÐµÑ‚',0),(426717,11854,'vi','ThÃªm/ sá»­a ngÃ¢n sÃ¡ch',0),(426718,11854,'af','Nuwe/redigeer begroting',0),(426719,11854,'ro','Noi/editare buget',0),(426720,11854,'et','Uus/Muuda eelarve',0),(426721,11854,'si','Nove izdajati/proraÄun',0),(426722,11854,'ba','Anggaran baru/Edit',0),(426723,11854,'nl','Nieuwe/bewerken begroting',0),(426724,11854,'fi','Uusi tai Muokkaa budjetin',0),(426725,11854,'no','Ny/Rediger budsjett',0),(426726,11854,'da','Nyt/Rediger Budget',0),(426727,11854,'ko','ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘ ì˜ˆì‚°',0),(426728,11854,'he','×ª×§×¦×™×‘ ×—×“×©/×¢×¨×™×›×”',0),(426729,11854,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(426730,11854,'zh','æ–°å»º/ç¼–è¾‘çš„è´¢æ”¿é¢„ç®—æ¡ˆ\r\n',0),(426731,11854,'sv','Ny/redigera Budget',0),(426732,11854,'it','Bilancio nuovo/modifica',0),(426733,11854,'tl','',0),(426734,11854,'th','à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“/à¹à¸à¹‰à¹„à¸‚à¹ƒà¸«à¸¡à¹ˆ',0),(426735,11854,'hi','à¤¨à¤ˆ/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤¬à¤œà¤Ÿ',0),(426736,11854,'ms','Bajet baru/Edit',0),(426737,11854,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©/ØªØ­Ø±ÙŠØ±',0),(426738,11854,'fr','Edit/nouveau Budget',0),(426739,11854,'jp','ç·¨é›†/æ–°ã—ã„äºˆç®—',0),(426740,11854,'pt','OrÃ§amento de novo/editar',0),(426741,11854,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(426742,11854,'es','Nuevo/Editar Presupuesto',0),(426743,11854,'de','Budget neu/bearbeiten',0),(426744,11854,'en','New/Edit Budget',0),(426745,11855,'is','',0),(426746,11855,'dr','/ Ø§ØµÙ„Ø§Ø­',0),(426747,11855,'pr','Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÛŒØ¯/ ÙˆÛŒØ±Ø§ÛŒØ´',0),(426748,11855,'tr','Yeni/DÃ¼zenle sipariÅŸ',0),(426749,11855,'pl','Nowy edycja zamâ‰¤wienia',0),(426750,11855,'bg','ÐÐ¾Ð²Ð¸/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(426751,11855,'ur','Ù†Ø¦ÛŒ/ØªØ¯ÙˆÛŒÙ† Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(426752,11855,'sr','ÐÐ¾Ð²Ð¸ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(426753,11855,'vi','ThÃªm/ sá»­a Ä‘Æ¡n hÃ ng',0),(426754,11855,'af','Nuwe/redigeer orde',0),(426755,11855,'ro','Noi/editare comanda',0),(426756,11855,'et','Uus/Muuda jÃ¤rjekorras',0),(426757,11855,'si','Nove izdajati/naroÄilo',0),(426758,11855,'ba','Orde Baru/Edit',0),(426759,11855,'nl','Nieuwe/bewerken volgorde',0),(426760,11855,'fi','Uusi tai Muokkaa tilauksen',0),(426761,11855,'no','Ny/Rediger rekkefÃ¸lge',0),(426762,11855,'da','Nyt/Rediger rÃ¦kkefÃ¸lge',0),(426763,11855,'ko','ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘ ìˆœì„œ',0),(426764,11855,'he','×¡×“×¨ ×—×“×©/×¢×¨×™×›×”',0),(426765,11855,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(426766,11855,'zh','æ–°å»º/ç¼–è¾‘è®¢å•\r\n',0),(426767,11855,'sv','Ny/redigera Order',0),(426768,11855,'it','Nuovo/Modifica ordine',0),(426769,11855,'tl','',0),(426770,11855,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚',0),(426771,11855,'hi','à¤¨à¤ˆ/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶',0),(426772,11855,'ms','Perintah baru/Edit',0),(426773,11855,'ar','Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¬Ø¯ÙŠØ¯/ØªØ­Ø±ÙŠØ±',0),(426774,11855,'fr','Ordre nouveau/modifier',0),(426775,11855,'jp','ç·¨é›†/æ–°ã—ã„é †åº',0),(426776,11855,'pt','Ordem de novo/editar',0),(426777,11855,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ/Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(426778,11855,'es','Nuevo/Editar Pedido',0),(426779,11855,'de','Bestellung neu/bearbeiten',0),(426780,11855,'en','New/Edit Order',0),(426781,11856,'is','',0),(426782,11856,'dr','Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ Ø¬Ø¯ÛŒØ¯',0),(426783,11856,'pr','Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ Ø¬Ø¯ÛŒØ¯',0),(426784,11856,'tr','Yeni satÄ±ÅŸ personeli',0),(426785,11856,'pl','Nowy personel sprzedaÅ¼y',0),(426786,11856,'bg','ÐÐ¾Ð² Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(426787,11856,'ur','Ù†Ø¦ÛŒ ÙØ±ÙˆØ®Øª Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø±',0),(426788,11856,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(426789,11856,'vi','nhÃ¢n viÃªn bÃ¡n hÃ ng má»›i',0),(426790,11856,'af','Nuwe verkope personeel',0),(426791,11856,'ro','Noi personal de vÃ¢nzÄƒri',0),(426792,11856,'et','Uus mÃ¼Ã¼gipersonalile',0),(426793,11856,'si','Novo prodajno osebje',0),(426794,11856,'ba','Personil penjualan baru',0),(426795,11856,'nl','Nieuwe verkooppersoneel',0),(426796,11856,'fi','Uusia myyjiÃ¤',0),(426797,11856,'no','Nye selgere',0),(426798,11856,'da','Ny salgspersonale',0),(426799,11856,'ko','ìƒˆë¡œìš´ íŒë§¤ ì§ì›',0),(426800,11856,'he','×× ×©×™ ×ž×›×™×¨×•×ª ×—×“×©',0),(426801,11856,'el','ÎÎ­Î¿ Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(426802,11856,'zh','æ–°é”€å”®äººå‘˜\r\n',0),(426803,11856,'sv','Nya sÃ¤ljare',0),(426804,11856,'it','Nuovi personale di vendita',0),(426805,11856,'tl','',0),(426806,11856,'th','à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢à¹ƒà¸«à¸¡à¹ˆ',0),(426807,11856,'hi','à¤¨à¤ˆ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚',0),(426808,11856,'ms','Kakitangan jualan baru',0),(426809,11856,'ar','Ù…ÙˆØ¸ÙÙŠ Ù…Ø¨ÙŠØ¹Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(426810,11856,'fr','Nouveau Personnel de vente',0),(426811,11856,'jp','æ–°ã—ã„å–¶æ¥­æ‹…å½“è€…',0),(426812,11856,'pt','Pessoal de vendas novo',0),(426813,11856,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ‚Ð¾Ñ€Ð³Ð¾Ð²Ñ‹Ð¹ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(426814,11856,'es','Nuevos Vendedores',0),(426815,11856,'de','Neue Verkaufspersonal',0),(426816,11856,'en','New Sales Personnel',0),(426817,11857,'is','',0),(426818,11857,'dr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÛŒØ§Øª Ø¬Ø¯ÛŒØ¯',0),(426819,11857,'pr','Ù†ÙˆØ¹ Ù…Ø§Ù„ÛŒØ§Øª Ø¬Ø¯ÛŒØ¯',0),(426820,11857,'tr','Yeni vergi tÃ¼rÃ¼',0),(426821,11857,'pl','Nowy typ podatku',0),(426822,11857,'bg','ÐÐ¾Ð² Ð²Ð¸Ð´ Ð½Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸Ñ‚Ðµ',0),(426823,11857,'ur','Ù†Ø¦Û’ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù‚Ø³Ù…',0),(426824,11857,'sr','ÐÐ¾Ð²Ð° Ð²Ñ€ÑÑ‚Ð° ÐŸÐ”Ð’-Ð°',0),(426825,11857,'vi','loáº¡i thuáº¿ má»›i',0),(426826,11857,'af','Nuwe belasting tipe',0),(426827,11857,'ro','Noul tip de impozit',0),(426828,11857,'et','Uus tulumaksu liik',0),(426829,11857,'si','Nova vrsta davka',0),(426830,11857,'ba','Jenis pajak baru',0),(426831,11857,'nl','Nieuwe fiscale Type',0),(426832,11857,'fi','Uusi ALV-tyyppi',0),(426833,11857,'no','Ny skatt Type',0),(426834,11857,'da','Nye afgiftstype.',0),(426835,11857,'ko','ìƒˆë¡œìš´ ì„¸ê¸ˆ ì¢…ë¥˜',0),(426836,11857,'he','×¡×•×’ ×ž×¡ ×—×“×©',0),(426837,11857,'el','ÎÎ­Î¿ ÎµÎ¯Î´Î¿Ï‚ Ï†ÏŒÏÎ¿Ï…',0),(426838,11857,'zh','æ–°ç¨Žæ”¶ç±»åž‹\r\n',0),(426839,11857,'sv','Ny typ av skatte',0),(426840,11857,'it','Nuovo tipo di tassa',0),(426841,11857,'tl','',0),(426842,11857,'th','à¸Šà¸™à¸´à¸”à¸ à¸²à¸©à¸µà¹ƒà¸«à¸¡à¹ˆ',0),(426843,11857,'hi','à¤¨à¤¯à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(426844,11857,'ms','Jenis cukai baru',0),(426845,11857,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(426846,11857,'fr','Nouveau Type d\'impÃ´t',0),(426847,11857,'jp','æ–°ã—ã„ç¨Žã‚¿ã‚¤ãƒ—',0),(426848,11857,'pt','Novo tipo de imposto',0),(426849,11857,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(426850,11857,'es','Nuevo Tipo de Impuesto',0),(426851,11857,'de','Neue Steuerart',0),(426852,11857,'en','New Tax Type',0),(426853,11858,'is','',0),(426854,11858,'dr','Ú†Ø§Ù¾ Ù„ÛŒØ³Øª Ù‚ÛŒÙ…Øª',0),(426855,11858,'pr','Ú†Ø§Ù¾ Ù„ÛŒØ³Øª Ù‚ÛŒÙ…Øª',0),(426856,11858,'tr','Fiyat listesi yazdÄ±rma',0),(426857,11858,'pl','Cennik druku',0),(426858,11858,'bg','Ð¦ÐµÐ½Ð¾Ñ€Ð°Ð·Ð¿Ð¸Ñ Ð¿ÐµÑ‡Ð°Ñ‚',0),(426859,11858,'ur','Ù¾Ø±Ø§Ú©Ø§Ù„Ø§Ø³Ù¹ Ø·Ø¨Ø§Ø¹Øª',0),(426860,11858,'sr','Ð¦Ñ˜ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(426861,11858,'vi','in danh sÃ¡ch giÃ¡',0),(426862,11858,'af','Pricelist druk',0),(426863,11858,'ro','Lista de preÅ£uri de imprimare',0),(426864,11858,'et','Hinnakiri trÃ¼kkimiseks',0),(426865,11858,'si','Cenik tiskanja',0),(426866,11858,'ba','Percetakan pricelist',0),(426867,11858,'nl','Prijslijst afdrukken',0),(426868,11858,'fi','Hinnasto tulostaminen',0),(426869,11858,'no','Prisliste-utskrift',0),(426870,11858,'da','Prisliste udskrivning',0),(426871,11858,'ko','Pricelist ì¸ì‡„',0),(426872,11858,'he','×ž×—×™×¨×•×Ÿ ×”×“×¤×¡×ª',0),(426873,11858,'el','Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(426874,11858,'zh','ä»·æ ¼è¡¨æ‰“å°\r\n',0),(426875,11858,'sv','Prislista utskrift',0),(426876,11858,'it','Listino prezzi stampa',0),(426877,11858,'tl','',0),(426878,11858,'th','à¸žà¸´à¸¡à¸žà¹Œà¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸²à¸„à¸²',0),(426879,11858,'hi','Pricelist à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥à¤¦à¥à¤°à¤£',0),(426880,11858,'ms','Cetak senarai',0),(426881,11858,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(426882,11858,'fr','Impression de la liste de prix',0),(426883,11858,'jp','ä¾¡æ ¼è¡¨ã®å°åˆ·',0),(426884,11858,'pt','ImpressÃ£o de lista de preÃ§os',0),(426885,11858,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(426886,11858,'es','Imprimiendo Lista de Precios',0),(426887,11858,'de','Preisliste drucken',0),(426888,11858,'en','Pricelist Printing',0),(426889,11859,'is','',0),(426890,11859,'dr','Ù†Ø§Ù… ØªØ¬Ø§Ø±ÛŒ Ø³Ø§ÛŒØª',0),(426891,11859,'pr','Ù†Ø§Ù… ØªØ¬Ø§Ø±ÛŒ Ø³Ø§ÛŒØª',0),(426892,11859,'tr','Site marka',0),(426893,11859,'pl','Strona marki',0),(426894,11859,'bg','Ð¡Ð°Ð¹Ñ‚ Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ° Ð¼Ð°Ñ€ÐºÐ°',0),(426895,11859,'ur','ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ù¾Ø± Ø°Ø§ØªÛŒ Ø¨Ø±Ø§Ù†ÚˆÙ†Ú¯',0),(426896,11859,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð±Ñ€ÐµÐ½Ð´Ð¸Ñ€Ð°ÑšÐµ',0),(426897,11859,'vi','Trang web xÃ¢y dá»±ng thÆ°Æ¡ng hiá»‡u',0),(426898,11859,'af','Terrein Handelsmerk ',0),(426899,11859,'ro','Site-ul de Branding',0),(426900,11859,'et','Saidi Branding',0),(426901,11859,'si','Mesto blagovne znamke',0),(426902,11859,'ba','Situs Branding',0),(426903,11859,'nl','Site Branding',0),(426904,11859,'fi','Sivusto brandingistÃ¤',0),(426905,11859,'no','Nettstedet merkevarebygging',0),(426906,11859,'da','Webstedet Branding',0),(426907,11859,'ko','ì‚¬ì´íŠ¸ ë¸Œëžœë”©',0),(426908,11859,'he','××ª×¨×™× ×ž×™×ª×•×’',0),(426909,11859,'el','Î™ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î± Branding',0),(426910,11859,'zh','ç½‘ç«™å“ç‰Œ\r\n',0),(426911,11859,'sv','Webbplats Branding',0),(426912,11859,'it','Sito Branding',0),(426913,11859,'tl','',0),(426914,11859,'th','à¹„à¸‹à¸•à¹Œà¸•à¸£à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(426915,11859,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤¬à¥à¤°à¤¾à¤‚à¤¡à¤¿à¤‚à¤—',0),(426916,11859,'ms','Penjenamaan Laman web',0),(426917,11859,'ar','Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ©',0),(426918,11859,'fr','Site de marque',0),(426919,11859,'jp','ã‚µã‚¤ãƒˆã®ãƒ–ãƒ©ãƒ³ãƒ‰åŒ–',0),(426920,11859,'pt','Site marca',0),(426921,11859,'ru','Ð‘Ñ€ÐµÐ½Ð´Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÐ°Ð¹Ñ‚Ð°',0),(426922,11859,'es','Promociones del Sitio',0),(426923,11859,'de','Websitebranding',0),(426924,11859,'en','Site Branding',0),(426925,11860,'is','',0),(426926,11860,'dr','...',0),(426927,11860,'pr','Ù…Ø¯ÛŒØ±ÛŒØª Ø§Ø±ØªØ¨Ø§Ø· Ø¨Ø§ Ù…Ø´ØªØ±ÛŒ...',0),(426928,11860,'tr','vtiger CRM',0),(426929,11860,'pl','vtiger CRM',0),(426930,11860,'bg','Vtiger CRM',0),(426931,11860,'ur','ÙˆÙ¹Ø§Ú¯Ø§Ø± Ú©',0),(426932,11860,'sr','Ð²Ñ‚Ð¸Ð³ÐµÑ€ Ð¦Ð Ðœ',0),(426933,11860,'vi','vtiger CRM',0),(426934,11860,'af','vtiger CRM',0),(426935,11860,'ro','Vtiger CRM',0),(426936,11860,'et','Vtiger CRM',0),(426937,11860,'si','Vtiger CRM',0),(426938,11860,'ba','Vtiger CRM',0),(426939,11860,'nl','Vtiger CRM',0),(426940,11860,'fi','vtiger CRM',0),(426941,11860,'no','vtiger CRM',0),(426942,11860,'da','Vtiger CRM',0),(426943,11860,'ko','vtiger CRM',0),(426944,11860,'he','vtiger CRM',0),(426945,11860,'el','Vtiger CRM',0),(426946,11860,'zh','vtiger å®¢æˆ·å…³ç³»ç®¡ç†\r\n',0),(426947,11860,'sv','vtiger CRM',0),(426948,11860,'it','vtiger CRM',0),(426949,11860,'tl','',0),(426950,11860,'th','vtiger CRM',0),(426951,11860,'hi','vtiger CRM',0),(426952,11860,'ms','Vtiger CRM',0),(426953,11860,'ar','vtiger Ø¥Ø¯Ø§Ø±Ø© Ø¹Ù„Ø§Ù‚Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(426954,11860,'fr','vtiger CRM',0),(426955,11860,'jp','vtiger CRM',0),(426956,11860,'pt','vtiger CRM',0),(426957,11860,'ru','Vtiger CRM',0),(426958,11860,'es','vtiger CRM',0),(426959,11860,'de','vTiger CRM',0),(426960,11860,'en','vtiger CRM',0),(426961,11861,'is','',0),(426962,11861,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø®Ø¯Ù…Ø§Øª Ø­Ù…Ù„ Ú©Ù†Ù†Ø¯Ù‡',0),(426963,11861,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø®Ø¯Ù…Ø§Øª Ø­Ù…Ù„ Ú©Ù†Ù†Ø¯Ù‡',0),(426964,11861,'tr','TaÅŸÄ±yÄ±cÄ± hizmet kimliÄŸi',0),(426965,11861,'pl','Identyfikator usÅ‚ugi przewoÅºnika',0),(426966,11861,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ ÑƒÑÐ»ÑƒÐ³Ð° Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(426967,11861,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ø®Ø¯Ù…Øª Ø´Ù†Ø§Ø®Øª',0),(426968,11861,'sr','ÐÐ¾ÑÐ°Ñ‡ ÑƒÑÐ»ÑƒÐ³Ð° Ð˜Ð”',0),(426969,11861,'vi','MÃ£ váº­n chuyá»ƒn/Dá»‹ch vá»¥',0),(426970,11861,'af','Draer diens ID',0),(426971,11861,'ro','ID de serviciul de transport',0),(426972,11861,'et','Vedaja teenuse ID',0),(426973,11861,'si','Nosilec storitve ID',0),(426974,11861,'ba','Operator Layanan ID',0),(426975,11861,'nl','Vervoerder Service-ID',0),(426976,11861,'fi','Rahdinkuljettajan palvelun tunnus',0),(426977,11861,'no','TransportÃ¸r Service-ID',0),(426978,11861,'da','Fragtmands-ID, Service',0),(426979,11861,'ko','ìºë¦¬ì–´ ì„œë¹„ìŠ¤ ID',0),(426980,11861,'he','×ž× ×©× ×©×™×¨×•×ª ×ž×–×”×”',0),(426981,11861,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Î±Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î± ID',0),(426982,11861,'zh','è¿è¥å•†æœåŠ¡çš„ID\r\n',0),(426983,11861,'sv','Carrier tjÃ¤nst-ID',0),(426984,11861,'it','Portante servizio ID',0),(426985,11861,'tl','',0),(426986,11861,'th','à¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸‚à¸™à¸ªà¹ˆà¸‡à¸šà¸£à¸´à¸à¸²à¸£',0),(426987,11861,'hi','à¤µà¤¾à¤¹à¤• à¤¸à¥‡à¤µà¤¾ ID',0),(426988,11861,'ms','ID Perkhidmatan pengangkutan',0),(426989,11861,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ø®Ø¯Ù…Ø© Ø§Ù„Ù†Ø§Ù‚Ù„',0),(426990,11861,'fr','ID Service transporteur',0),(426991,11861,'jp','ã‚­ãƒ£ãƒªã‚¢ ã‚µãƒ¼ãƒ“ã‚¹ ID',0),(426992,11861,'pt','ID de serviÃ§o transportadora',0),(426993,11861,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸ÐºÐ°',0),(426994,11861,'es','ID del Servicio de Transporte',0),(426995,11861,'de','Kennung der Fluggesellschaft-Service',0),(426996,11861,'en','Carrier Service ID',0),(426997,11862,'is','',0),(426998,11862,'dr','Ø¨Ø±Ø§ÛŒ Ù„ÛŒÙ†Ú© Ù‡Ø§',0),(426999,11862,'pr','Ø¨Ø±Ø§ÛŒ Ù„ÛŒÙ†Ú© Ù‡Ø§',0),(427000,11862,'tr','BaÄŸlantÄ±lar iÃ§in',0),(427001,11862,'pl','Linki',0),(427002,11862,'bg','Ð—Ð° Ð²Ñ€ÑŠÐ·ÐºÐ¸',0),(427003,11862,'ur','Ø±ÙˆØ§Ø¨Ø· Ú©Û’ Ù„Ø¦Û’',0),(427004,11862,'sr','Ð—Ð° Ð²ÐµÐ·Ðµ',0),(427005,11862,'vi','cho liÃªn káº¿t',0),(427006,11862,'af','Vir skakels',0),(427007,11862,'ro','Pentru link-uri',0),(427008,11862,'et','Lingid',0),(427009,11862,'si','Za povezave',0),(427010,11862,'ba','Untuk link',0),(427011,11862,'nl','Voor Links',0),(427012,11862,'fi','LinkkejÃ¤',0),(427013,11862,'no','For linker',0),(427014,11862,'da','For Links',0),(427015,11862,'ko','ë§í¬ì— ëŒ€ í•œ',0),(427016,11862,'he','×§×™×©×•×¨×™×',0),(427017,11862,'el','Î“Î¹Î± ÏƒÏ…Î½Î´Î­ÏƒÎµÎ¹Ï‚',0),(427018,11862,'zh','å¯¹äºŽé“¾æŽ¥\r\n',0),(427019,11862,'sv','FÃ¶r lÃ¤nkar',0),(427020,11862,'it','Per i collegamenti',0),(427021,11862,'tl','',0),(427022,11862,'th','à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡',0),(427023,11862,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¿à¤‚à¤•',0),(427024,11862,'ms','Untuk pautan',0),(427025,11862,'ar','Ù„Ù„Ø±ÙˆØ§Ø¨Ø·',0),(427026,11862,'fr','Pour les liens',0),(427027,11862,'jp','ãƒªãƒ³ã‚¯ã«ã¤ã„ã¦',0),(427028,11862,'pt','Para Links',0),(427029,11862,'ru','Ð”Ð»Ñ ÑÑÑ‹Ð»Ð¾Ðº',0),(427030,11862,'es','Para Vinculos',0),(427031,11862,'de','FÃ¼r Links',0),(427032,11862,'en','For Links',0),(427033,11863,'is','',0),(427034,11863,'dr','ØªØ§Ø±ÛŒØ® ØªØ§ÛŒÛŒØ¯',0),(427035,11863,'pr','ØªØ§Ø±ÛŒØ® ØªØ§ÛŒÛŒØ¯',0),(427036,11863,'tr','Tarih onaylamak',0),(427037,11863,'pl','Potwierdzenie daty',0),(427038,11863,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(427039,11863,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(427040,11863,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(427041,11863,'vi','ngÃ y xÃ¡c nháº­n',0),(427042,11863,'af','Datum bevestig',0),(427043,11863,'ro','Confirma data',0),(427044,11863,'et','KuupÃ¤eva kinnitamiseks',0),(427045,11863,'si','Potrditi datum',0),(427046,11863,'ba','Mengkonfirmasi tanggal',0),(427047,11863,'nl','Datum worden bevestigd',0),(427048,11863,'fi','Vahvistetun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n',0),(427049,11863,'no','Bekr',0),(427050,11863,'da','BekrÃ¦fte dato',0),(427051,11863,'ko','ë‚ ì§œ í™•ì¸',0),(427052,11863,'he','×œ××©×¨ ××ª ×”×ª××¨×™×š',0),(427053,11863,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÏ„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(427054,11863,'zh','ç¡®è®¤æ—¥æœŸ\r\n',0),(427055,11863,'sv','BekrÃ¤fta datum',0),(427056,11863,'it','Confermare la data',0),(427057,11863,'tl','',0),(427058,11863,'th','à¸¢à¸·à¸™à¸¢à¸±à¸™à¸§à¸±à¸™',0),(427059,11863,'hi','à¤¤à¤¿à¤¥à¤¿ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(427060,11863,'ms','Mengesahkan tarikh',0),(427061,11863,'ar','ØªØ£ÙƒÙŠØ¯ ØªØ§Ø±ÙŠØ®',0),(427062,11863,'fr','Confirmer la Date',0),(427063,11863,'jp','ç¢ºèªã®æ—¥ä»˜',0),(427064,11863,'pt','Confirmar a data',0),(427065,11863,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Ð´Ð°Ñ‚Ñƒ',0),(427066,11863,'es','Fecha de ConfirmaciÃ³n',0),(427067,11863,'de','Datum zu bestÃ¤tigen',0),(427068,11863,'en','Confirm Date',0),(427069,11864,'is','',0),(427070,11864,'dr','Ø¨Ø¯ÙˆÙ† Ø¬Ø²Ø¦ÛŒØ§Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(427071,11864,'pr','Ø¨Ø¯ÙˆÙ† Ø¬Ø²Ø¦ÛŒØ§Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(427072,11864,'tr','Ne kredi hesabÄ±',0),(427073,11864,'pl','Nie ma Å¼adnej informacji kredytowej',0),(427074,11864,'bg','ÐÑÐ¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸',0),(427075,11864,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(427076,11864,'sr','ÐÐµ Ð·Ð½Ð°Ð¼ Ð´ÐµÑ‚Ð°Ñ™Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ',0),(427077,11864,'vi','khÃ´ng cÃ³ chi tiáº¿t ghi cÃ³',0),(427078,11864,'af','Geen krediet besonderhede',0),(427079,11864,'ro','Nu detalii de Credit',0),(427080,11864,'et','No Credit Ã¼ksikasjad',0),(427081,11864,'si','Brez kreditne podrobnosti',0),(427082,11864,'ba','Tidak ada rincian kredit',0),(427083,11864,'nl','Geen Credit gegevens',0),(427084,11864,'fi','O luoton tiedot',0),(427085,11864,'no','Ingen kredittkort-detaljer',0),(427086,11864,'da','Ingen kreditkort detaljer',0),(427087,11864,'ko','ì‹ ìš© ìƒì„¸',0),(427088,11864,'he','×œ×œ× ×¤×¨×˜×™ ××©×¨××™',0),(427089,11864,'el','Î”ÎµÎ½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® Ï€Î»Î¿Î¯Î¿Ï…',0),(427090,11864,'zh','æ²¡æœ‰ä¿¡ç”¨æ˜Žç»†',0),(427091,11864,'sv','Inga kreditkort Detaljer',0),(427092,11864,'it','Nessun credito dettagli',0),(427093,11864,'tl','',0),(427094,11864,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸‚à¸­à¸‡à¹€à¸„à¸£à¸”à¸´à¸•',0),(427095,11864,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤µà¤¿à¤µà¤°à¤£',0),(427096,11864,'ms','Tiada butiran kredit',0),(427097,11864,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(427098,11864,'fr','Aucun dÃ©tail de crÃ©dit',0),(427099,11864,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã®è©³ç´°æƒ…å ±ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(427100,11864,'pt','Sem detalhes de crÃ©dito',0),(427101,11864,'ru','ÐÐ¸ÐºÐ°ÐºÐ¸Ñ… Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚ÐµÐ¹ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(427102,11864,'es','No Detalles de CrÃ©dito',0),(427103,11864,'de','Keine Kreditkarten-Details',0),(427104,11864,'en','No Credit Details',0),(427105,11865,'is','',0),(427106,11865,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§Ú©ØªÙˆØ± ØµÙ†Ø¹ØªÛŒ Ø¨Ø±Ú¯Ø´Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯',0),(427107,11865,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§Ú©ØªÙˆØ± ØµÙ†Ø¹ØªÛŒ Ø¨Ø±Ú¯Ø´Øª Ø¯Ø§Ø¯Ù‡ Ø´Ø¯',0),(427108,11865,'tr','DÃ¶ndÃ¼rÃ¼len AR fatura Ã¶deme',0),(427109,11865,'pl','PÅ‚atnoÅ›ci faktury AR wrÃ³ciÅ‚',0),(427110,11865,'bg','AR Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾, Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¾',0),(427111,11865,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø±Ù‚Ù… ÙˆØ§Ù¾Ø³',0),(427112,11865,'sr','ÐÐ  Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸Ð·Ð½Ð¾Ñ Ð¸ÑÐ¿Ð»Ð°Ñ‚Ðµ',0),(427113,11865,'vi','tráº£ láº¡i thanh toÃ¡n hÃ³a Ä‘Æ¡n pháº£i thu',0),(427114,11865,'af','AR faktuur betaling teruggekeer',0),(427115,11865,'ro','AR plati facturi returnate',0),(427116,11865,'et','AR arve tasumise tagastatud',0),(427117,11865,'si','PlaÄilo raÄuna AR, vrne',0),(427118,11865,'ba','AR faktur pembayaran kembali',0),(427119,11865,'nl','AR factuur betaling terug',0),(427120,11865,'fi','AR laskun maksu',0),(427121,11865,'no','AR fakturabetalingen returnert',0),(427122,11865,'da','AR fakturabetaling returneres',0),(427123,11865,'ko','AR ì†¡ìž¥ ì§€ë¶ˆ ë°˜í™˜',0),(427124,11865,'he','AR ×—×©×‘×•× ×™×ª ×ª×©×œ×•×, ×”×ž×•×—×–×¨×™×',0),(427125,11865,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… AR ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ',0),(427126,11865,'zh','è¿”å›žå—ä½“å‘ç¥¨ä»˜æ¬¾\r\n',0),(427127,11865,'sv','AR fakturabetalning returneras',0),(427128,11865,'it','AR fattura pagamento restituito',0),(427129,11865,'tl','',0),(427130,11865,'th','à¸ªà¹ˆà¸‡à¸„à¸·à¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ AR',0),(427131,11865,'hi','à¤. à¤†à¤°. à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤²à¥Œà¤Ÿà¥‡',0),(427132,11865,'ms','AR pembayaran invois yang dipulangkan',0),(427133,11865,'ar','Ø¯ÙØ¹ ÙØ§ØªÙˆØ±Ø© AR Ø¹Ø§Ø¯',0),(427134,11865,'fr','AR facture paiement retournÃ©',0),(427135,11865,'jp','è¿”ã•ã‚Œã‚‹ AR è«‹æ±‚æ›¸æ”¯æ‰•',0),(427136,11865,'pt','Pagamento de fatura de AR retornado',0),(427137,11865,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð° AR Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ',0),(427138,11865,'es','CC Pago de Factura Devuelto',0),(427139,11865,'de','AR Rechnung Zahlung zurÃ¼ckgegeben',0),(427140,11865,'en','AR Invoice Payment Returned',0),(427141,11866,'is','',0),(427142,11866,'dr','Ú©Ø§Ù„Ø§ÛŒ Ù…Ø±Ú©Ø¨',0),(427143,11866,'pr','Ú©Ø§Ù„Ø§ÛŒ Ù…Ø±Ú©Ø¨',0),(427144,11866,'tr','Kompozisyon',0),(427145,11866,'pl','SkÅ‚ad',0),(427146,11866,'bg','Ð¡ÑŠÑÑ‚Ð°Ð²',0),(427147,11866,'ur','Ø³Ø§Ø®Øª',0),(427148,11866,'sr','Ð¡Ð°ÑÑ‚Ð°Ð²',0),(427149,11866,'vi','ThÃ nh pháº§n',0),(427150,11866,'af','Samestelling',0),(427151,11866,'ro','CompoziÅ£ia',0),(427152,11866,'et','Koostis',0),(427153,11866,'si','Sestava',0),(427154,11866,'ba','Komposisi',0),(427155,11866,'nl','Samenstelling',0),(427156,11866,'fi','Kokoonpano',0),(427157,11866,'no','Komposisjon',0),(427158,11866,'da','SammensÃ¦tning',0),(427159,11866,'ko','êµ¬ì„±',0),(427160,11866,'he','×§×•×ž×¤×•×–×™×¦×™×”',0),(427161,11866,'el','Î£ÏÎ½Î¸ÎµÏƒÎ·',0),(427162,11866,'zh','ç»„æˆ\r\n',0),(427163,11866,'sv','SammansÃ¤ttning',0),(427164,11866,'it','Composizione',0),(427165,11866,'tl','',0),(427166,11866,'th','à¸­à¸‡à¸„à¹Œà¸›à¸£à¸°à¸à¸­à¸š',0),(427167,11866,'hi','à¤°à¤šà¤¨à¤¾',0),(427168,11866,'ms','Komposisi',0),(427169,11866,'ar','ØªÙƒÙˆÙŠÙ†',0),(427170,11866,'fr','Composition',0),(427171,11866,'jp','çµ„æˆ',0),(427172,11866,'pt','ComposiÃ§Ã£o',0),(427173,11866,'ru','Ð¡Ð¾ÑÑ‚Ð°Ð²',0),(427174,11866,'es','ComposiciÃ³n',0),(427175,11866,'de','Zusammensetzung',0),(427176,11866,'en','Composition',0),(427177,11867,'is','',0),(427178,11867,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø·Ø¨Ù‚ Ù¾ÙˆÙ„ Ø±Ø§ÛŒØ¬ Ù…Ø¨Ù†Ø§ Ù‡Ø³ØªÙ†Ø¯ Ùˆ Ù†Ù‡ Ø·Ø¨Ù‚ Ù¾ÙˆÙ„ Ø±Ø§ÛŒØ¬ ÙØ§Ú©ØªÙˆØ±',0),(427179,11867,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø·Ø¨Ù‚ Ù¾ÙˆÙ„ Ø±Ø§ÛŒØ¬ Ù…Ø¨Ù†Ø§ Ù‡Ø³ØªÙ†Ø¯ Ùˆ Ù†Ù‡ Ø·Ø¨Ù‚ Ù¾ÙˆÙ„ Ø±Ø§ÛŒØ¬ ÙØ§Ú©ØªÙˆØ±',0),(427180,11867,'tr','Maliyeti vardÄ±r baz para biriminde deÄŸil fatura para birimi',0),(427181,11867,'pl','Koszty sÄ… w walucie podstawowej nie faktury waluty',0),(427182,11867,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ ÑÐ° Ð² Ð¾ÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð²Ð°Ð»ÑƒÑ‚Ð° Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ðµ Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(427183,11867,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª ÛÛŒÚº Ù…ÛŒÚº Ø¨ÛŒØ³ Ú©Ø±Ù†Ø³ÛŒ Ù†ÛÛŒÚº Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ú©Ø±Ù†Ø³ÛŒ',0),(427184,11867,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ ÑÑƒ Ñƒ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ñ˜ Ð²Ð°Ð»ÑƒÑ‚Ð¸ Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµÑ‚Ðµ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(427185,11867,'vi','chi phÃ­ cÆ¡ báº£n dá»±a trÃªn tiá»n tá»‡ chá»© khÃ´ng pháº£i loáº¡i tiá»n trÃªn hÃ³a Ä‘Æ¡n',0),(427186,11867,'af','Koste is In basis geldeenheid nie faktuur geldeenheid',0),(427187,11867,'ro','Costurile sunt In moneda de baza nu facturÄƒ valutÄƒ',0),(427188,11867,'et','Kulud on baasvaluutas mitte arve valuuta',0),(427189,11867,'si','StroÅ¡ki so v osnovni valuti zaraÄunal valute',0),(427190,11867,'ba','Biaya adalah dalam mata uang dasar tidak faktur mata uang',0),(427191,11867,'nl','Kosten zijn In de basisvaluta niet factureren valuta',0),(427192,11867,'fi','Kustannukset ovat perusvaluutta ei laskun valuutta',0),(427193,11867,'no','Kostnader er i standardvalutaen ikke fakturerer valuta',0),(427194,11867,'da','Omkostninger er i grundvalutaen ikke fakturere valuta',0),(427195,11867,'ko','ë¹„ìš©ì€ ê¸°ë³¸ í†µí™” í•˜ì§€ ì†¡ìž¥ í†µí™”',0),(427196,11867,'he','×¢×œ×•×™×•×ª ×”×Ÿ ×‘×ž×˜×‘×¢ ×”×‘×¡×™×¡ ×œ× ×—×©×‘×•× ×™×ª ×ž×˜×‘×¢',0),(427197,11867,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎµÎ¯Î½Î±Î¹ ÏƒÏ„Î· Î½Î¿Î¼Î¹ÏƒÎ¼Î±Ï„Î¹ÎºÎ® Î¼Î¿Î½Î¬Î´Î± Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ½ Ï„Î¹Î¼Î¿Î»Î¿Î³ÎµÎ¯ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(427198,11867,'zh','æˆæœ¬æ˜¯ä»¥è´§å¸ä¸ºåŸºç¡€è€Œéžä»¥å‘ç¥¨ä¸ºåŸºç¡€\r\n',0),(427199,11867,'sv','Kostnaderna Ã¤r i basvaluta inte fakturera valuta',0),(427200,11867,'it','Costi sono nella valuta di Base non fattura valuta',0),(427201,11867,'tl','',0),(427202,11867,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™à¸à¸²à¸™à¹„à¸¡à¹ˆà¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™',0),(427203,11867,'hi','à¤²à¤¾à¤—à¤¤ à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤†à¤§à¤¾à¤° à¤®à¥à¤¦à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤šà¤¾à¤²à¤¾à¤¨ à¤®à¥à¤¦à¥à¤°à¤¾',0),(427204,11867,'ms','Bayaran adalah dalam mata wang asas tidak invois Mata Wang',0),(427205,11867,'ar','Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ù‡ÙŠ Ø§Ù„Ø¹Ù…Ù„Ø© Ø§Ù„Ø£Ø³Ø§Ø³ÙŠØ© Ù„Ø§ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¹Ù…Ù„Ø©',0),(427206,11867,'fr','Les coÃ»ts sont en devise de Base pas facturer monnaie',0),(427207,11867,'jp','ã‚³ã‚¹ãƒˆã¯åŸºæœ¬é€šè²¨ã§ãªã„è«‹æ±‚æ›¸ã®é€šè²¨',0),(427208,11867,'pt','Os custos estÃ£o na moeda Base nÃ£o a factura de moeda',0),(427209,11867,'ru','Ð—Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹ Ð½Ð°Ñ…Ð¾Ð´ÑÑ‚ÑÑ Ð² Ð±Ð°Ð·Ð¾Ð²Ð¾Ð¹ Ð²Ð°Ð»ÑŽÑ‚Ðµ ÑÑ‡ÐµÑ‚Ð° Ð²Ð°Ð»ÑŽÑ‚Ñ‹',0),(427210,11867,'es','Costos Estan en la Moneda Base No en La Moneda de Factura',0),(427211,11867,'de','Kosten sind In der BasiswÃ¤hrung nicht ausweisen WÃ¤hrung',0),(427212,11867,'en','Costs Are In Base Currency Not Invoice Currency',0),(427213,11868,'is','',0),(427214,11868,'dr','ÙØ§ÛŒÙ„ Ù‡Ø§',0),(427215,11868,'pr','ÙØ§ÛŒÙ„ Ù‡Ø§',0),(427216,11868,'tr','DosyalarÄ±',0),(427217,11868,'pl','Pliki',0),(427218,11868,'bg','Ð¤Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(427219,11868,'ur','Ù…Ø³Ù„ÛŒÚº',0),(427220,11868,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(427221,11868,'vi','cÃ¡c file',0),(427222,11868,'af','LÃªers',0),(427223,11868,'ro','FiÅŸiere',0),(427224,11868,'et','Failid',0),(427225,11868,'si','Datoteke',0),(427226,11868,'ba','File',0),(427227,11868,'nl','Bestanden',0),(427228,11868,'fi','Tiedostot',0),(427229,11868,'no','Filer',0),(427230,11868,'da','Filer',0),(427231,11868,'ko','íŒŒì¼',0),(427232,11868,'he','×§×‘×¦×™×',0),(427233,11868,'el','Î‘ÏÏ‡ÎµÎ¯Î±',0),(427234,11868,'zh','æ–‡ä»¶\r\n',0),(427235,11868,'sv','Filer',0),(427236,11868,'it','File',0),(427237,11868,'tl','',0),(427238,11868,'th','à¹à¸Ÿà¹‰à¸¡',0),(427239,11868,'hi','à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(427240,11868,'ms','Fail-fail',0),(427241,11868,'ar','Ø§Ù„Ù…Ù„ÙØ§Øª',0),(427242,11868,'fr','Fichiers',0),(427243,11868,'jp','ãƒ•ã‚¡ã‚¤ãƒ«',0),(427244,11868,'pt','Arquivos',0),(427245,11868,'ru','Ð¤Ð°Ð¹Ð»Ñ‹',0),(427246,11868,'es','Archivos',0),(427247,11868,'de','Dateien',0),(427248,11868,'en','Files',0),(427249,11869,'is','',0),(427250,11869,'dr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ú©Ù„ÛŒ',0),(427251,11869,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ú©Ù„ÛŒ',0),(427252,11869,'tr','Genel notlar',0),(427253,11869,'pl','Uwagi:',0),(427254,11869,'bg','ÐžÐ±Ñ‰Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(427255,11869,'ur','Ø¹Ù…ÙˆÙ…ÛŒ Ù†ÙˆÙ¹',0),(427256,11869,'sr','ÐžÐ¿ÑˆÑ‚Ðµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(427257,11869,'vi','ghi chÃº chung',0),(427258,11869,'af','Algemene notas',0),(427259,11869,'ro','General note',0),(427260,11869,'et','Ãœldised mÃ¤rkused',0),(427261,11869,'si','SploÅ¡ne opombe',0),(427262,11869,'ba','Catatan Umum',0),(427263,11869,'nl','Algemene opmerkingen',0),(427264,11869,'fi','Huomautuksia',0),(427265,11869,'no','Generelle notater',0),(427266,11869,'da','Generelle bemÃ¦rkninger',0),(427267,11869,'ko','ì¼ë°˜ ë…¸íŠ¸',0),(427268,11869,'he','×’× ×¨×œ ×”×¢×¨×•×ª',0),(427269,11869,'el','Î“ÎµÎ½Î¹ÎºÎ­Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(427270,11869,'zh','ä¸€èˆ¬äº‹é¡¹\r\n',0),(427271,11869,'sv','AllmÃ¤nna anmÃ¤rkningar',0),(427272,11869,'it','Note generali',0),(427273,11869,'tl','',0),(427274,11869,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(427275,11869,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤¨à¥‹à¤Ÿ',0),(427276,11869,'ms','Nota-Nota Agung',0),(427277,11869,'ar','Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø©',0),(427278,11869,'fr','Notes gÃ©nÃ©rales',0),(427279,11869,'jp','ä¸€èˆ¬çš„ãªæ³¨æ„äº‹é …',0),(427280,11869,'pt','Notas gerais',0),(427281,11869,'ru','ÐžÐ±Ñ‰Ð¸Ðµ Ð·Ð°Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(427282,11869,'es','Notas Generales',0),(427283,11869,'de','Allgemeine Hinweise',0),(427284,11869,'en','General Notes',0),(427285,11870,'is','',0),(427286,11870,'dr','Ø¯Ø±ÛŒØ§ÙØª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ',0),(427287,11870,'pr','Ø¯Ø±ÛŒØ§ÙØª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ',0),(427288,11870,'tr','Destek alÄ±n',0),(427289,11870,'pl','Uzyskaj wsparcie',0),(427290,11870,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(427291,11870,'ur','Ù…Ø¯Ø¯ Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(427292,11870,'sr','Ð”Ð¾Ð±Ð¸Ñ˜Ð°ÑšÐµ Ð¿Ð¾Ð´Ñ€ÑˆÐºÐµ',0),(427293,11870,'vi','thiáº¿t láº­p há»— trá»£',0),(427294,11870,'af','Kry ondersteuning',0),(427295,11870,'ro','ObÅ£ine sprijin',0),(427296,11870,'et','Abi saamine',0),(427297,11870,'si','Dobijo podporo',0),(427298,11870,'ba','Dapatkan dukungan',0),(427299,11870,'nl','Ondersteuning krijgen',0),(427300,11870,'fi','Saada tukea',0),(427301,11870,'no','FÃ¥ stÃ¸tte',0),(427302,11870,'da','FÃ¥ Support',0),(427303,11870,'ko','ì§€ì›ì„ ë°›ì„í•©ë‹ˆë‹¤',0),(427304,11870,'he','×§×‘×œ ×ª×ž×™×›×”',0),(427305,11870,'el','Î›Î¬Î²ÎµÏ„Îµ Ï…Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î·',0),(427306,11870,'zh','å¾—åˆ°æ”¯æŒ\r\n',0),(427307,11870,'sv','FÃ¥ stÃ¶d',0),(427308,11870,'it','Ottenere supporto',0),(427309,11870,'tl','',0),(427310,11870,'th','à¸£à¸±à¸šà¸à¸²à¸£à¸ªà¸™à¸±à¸šà¸ªà¸™à¸¸à¸™',0),(427311,11870,'hi','à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¥‡à¤‚',0),(427312,11870,'ms','Mendapat sokongan',0),(427313,11870,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„Ø¯Ø¹Ù…',0),(427314,11870,'fr','Obtenir de l\'aide',0),(427315,11870,'jp','ã‚µãƒãƒ¼ãƒˆã‚’å¾—ã‚‹',0),(427316,11870,'pt','Obter suporte',0),(427317,11870,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÑƒ',0),(427318,11870,'es','Consigue Apoyo',0),(427319,11870,'de','Holen Sie sich UnterstÃ¼tzung',0),(427320,11870,'en','Get Support',0),(427321,11871,'is','',0),(427322,11871,'dr','Ø§Ú¯Ø± Ù‡ÛŒÚ† Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¯Ø± Ø§ÛŒÙ† Ú©Ø§Ø¯Ø± Ø¸Ø§Ù‡Ø± Ù†Ø´Ø¯ Ùˆ ÙØ±Ù… Ø«Ø¨Øª Ú©Ø§Ù…Ù„ Ù†ÛŒØ³Øª ÛŒØ§ ÛŒÚ© Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§ÛŒØ¬Ø§Ø¯ Ø´ÙˆØ¯',0),(427323,11871,'pr','Ø§Ú¯Ø± Ù‡ÛŒÚ† Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¯Ø± Ø§ÛŒÙ† Ú©Ø§Ø¯Ø± Ø¸Ø§Ù‡Ø± Ù†Ø´Ø¯ Ùˆ ÙØ±Ù… Ø«Ø¨Øª Ú©Ø§Ù…Ù„ Ù†ÛŒØ³Øª ÛŒØ§ ÛŒÚ© Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§ÛŒØ¬Ø§Ø¯ Ø´ÙˆØ¯',0),(427324,11871,'tr','Bir teklif bu kutuda gÃ¶rÃ¼nmezse, sonra giriÅŸ formu eksik veya teklif iÃ§in belirlenen seÃ§enekler Ã¼retilemiyor.',0),(427325,11871,'pl','JeÅ¼eli oferty nie sÄ… wyÅ›wietlane w tym polu, a nastÄ™pnie albo formularz zgÅ‚oszeniowy jest niekompletna, lub oferty nie mogÄ… byÄ‡ generowane dla wybranych opcji.',0),(427326,11871,'bg','ÐÐºÐ¾ Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð° Ð½Ðµ ÑÐµ Ð¿Ð¾ÑÐ²ÑÐ²Ð° Ð² Ñ‚Ð¾Ð²Ð° Ð¿Ð¾Ð»Ðµ, ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð° Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€Ð° Ðµ Ð½ÐµÐ¿ÑŠÐ»Ð½Ð°, Ð¸Ð»Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½ Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ð¸.',0),(427327,11871,'ur','Ø§ÛŒÚ© Ø§Ù‚ØªØ¨Ø§Ø³ Ø¢Ù¾ Ø§Ø³ Ø®Ø§Ù†Û’ Ù…ÛŒÚº Ø¸Ø§ÛØ± Ù†ÛÛŒÚº ÛÙˆØªØ§ ØªÙˆ Ù¾Ú¾Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø´Ú©Ù„ Ù†Ø§Ù…Ú©Ù…Ù„ ÛÛ’ ÛŒØ§ Ø§ÛŒÚ© Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ù…Ù†ØªØ®Ø¨ Ù¾ÛŒØ¯Ø§ ÛÙˆ Ø³Ú©ØªØ§ ÛÛ’ Û”',0),(427328,11871,'sr','ÐÐºÐ¾ Ð¿Ð¾Ð½ÑƒÐ´Ð° Ð½Ðµ Ð¿Ð¾Ñ˜Ð°Ð²Ñ™ÑƒÑ˜Ðµ Ñƒ Ð¾Ð²Ð¾Ñ˜ ÐºÑƒÑ‚Ð¸Ñ˜Ð¸, Ð¾Ð½Ð´Ð° Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð°Ñ€Ñƒ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñƒ Ñ˜Ðµ Ð½ÐµÐ¿Ð¾Ñ‚Ð¿ÑƒÐ½Ð° Ð¸Ð»Ð¸ Ð½Ð¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð³ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ñ‚Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚ Ð·Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ.',0),(427329,11871,'vi','Náº¿u bÃ¡o giÃ¡ khÃ´ng hiá»‡n trong báº£ng, thÃ¬ hoáº·c máº«u ghi sá»• chÆ°a xong hoáº·c bÃ¡o giÃ¡ khÃ´ng thá»ƒ láº¥y cho cÃ¡c sá»± lá»±a chá»n Ä‘Ã£ Ä‘Æ°á»£c chá»n',0),(427330,11871,'af','Indien \'n aanhaling in diÃ© blokkie verskyn nie, dan die inskrywingsvorm is onvolledig, Ã³f \'n kwotasie vir die geselekteerde opsies gegenereer kan word.',0),(427331,11871,'ro','DacÄƒ un citat nu apare Ã®n aceastÄƒ casetÄƒ, apoi formularul de Ã®nscriere este incomplet, sau o ofertÄƒ nu poate fi generat pentru opÅ£iunile selectate.',0),(427332,11871,'et','Kui pakkumine ei ole selles lahtris, siis sisestus vorm on puudulik vÃµi hinnapakkumist ei saa genereerida valitud suvanditega.',0),(427333,11871,'si','ÄŒe v to polje ni citat, nato bodisi prijavnico je nepopoln ali citat, ni mogoÄe ustvariti za izbrane moÅ¾nosti.',0),(427334,11871,'ba','Jika Penawaran tidak muncul di kotak ini, kemudian formulir entri tidak lengkap atau kutipan tidak dihasilkan untuk pilihan yang dipilih.',0),(427335,11871,'nl','Als een offerte niet wordt weergegeven in dit vak, vervolgens het formulier entry is onvolledig, of een offerte kan niet worden gegenereerd voor de geselecteerde opties.',0),(427336,11871,'fi','Jos tarjous ei nÃ¤y tÃ¤ssÃ¤ ruudussa, sitten ilmoittautumislomakkeessa on epÃ¤tÃ¤ydellinen tai tarjous ei voi luoda valitut asetukset.',0),(427337,11871,'no','Hvis en forespÃ¸rsel ikke vises i denne boksen, deretter enten skjemaet er ufullstendig eller et tilbud kan ikke genereres for de valgte alternativene.',0),(427338,11871,'da','Hvis et tilbud ikke vises i denne boks, derefter enten entry form er ufuldstÃ¦ndig, eller et tilbud, kan ikke oprettes for de valgte indstillinger.',0),(427339,11871,'ko','ê²¬ì ì´ì´ ìƒìžì— ë‚˜íƒ€ë‚˜ì§€ ì•Šìœ¼ë©´ ë‹¤ìŒ ìž…ë ¥ í¼ì€ ì™„ì „ í•œ, ë˜ëŠ” ê²¬ì  ì„ íƒí•œ ì˜µì…˜ì— ëŒ€ í•œ ìƒì„± ë  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(427340,11871,'he','×× ×”×¦×¢×ª ×ž×—×™×¨ ××™× ×• ×ž×•×¤×™×¢ ×‘×ª×™×‘×” ×–×•, ×•××– ×˜×•×¤×¡ ×”×–× ×ª ××™× ×• ×©×œ× ××• ××¤×©×¨×•×ª ×œ×”×¤×™×§ ×”×¦×¢×ª ×ž×—×™×¨ ×¢×‘×•×¨ ×”××¤×©×¨×•×™×•×ª ×©× ×‘×—×¨×•.',0),(427341,11871,'el','Î•Î¬Î½ Î­Î½Î± Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î´ÎµÎ½ ÎµÎ¼Ï†Î±Î½Î¯Î¶ÎµÏ„Î±Î¹ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿, ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î± Ï„Î·Î½ Î±Î¯Ï„Î·ÏƒÎ· ÏƒÏ…Î¼Î¼ÎµÏ„Î¿Ï‡Î®Ï‚ ÎµÎ¯Î½Î±Î¹ ÎµÎ»Î»Î¹Ï€ÎµÎ¯Ï‚, ÎµÎ¯Ï„Îµ Î¼Î¹Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î·Î',0),(427342,11871,'zh','å¦‚æžœä¸€ä¸ªæŠ¥ä»·ä¸ä¼šå‡ºçŽ°åœ¨è¯¥æ¡†ä¸­ï¼Œé‚£ä¹ˆä¸æ˜¯æ˜¯æ¡ç›®è¡¨ä¸å®Œæ•´å°±æ˜¯æŠ¥ä»·æ— æ³•ä¸ºé€‰é¡¹ç”Ÿæˆ\r\n',0),(427343,11871,'sv','Om en offert inte visas i rutan, sedan antingen formulÃ¤ret posten Ã¤r ofullstÃ¤ndig eller en offert kan inte genereras fÃ¶r de valda alternativen.',0),(427344,11871,'it','Se una citazione non compare in questa casella, quindi il modulo di iscrizione Ã¨ incompleto, o una citazione non puÃ² essere generata per le opzioni selezionate.',0),(427345,11871,'tl','',0),(427346,11871,'th','à¸–à¹‰à¸²à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸—à¸µà¹ˆà¸›à¸£à¸²à¸à¸à¹ƒà¸™à¸à¸¥à¹ˆà¸­à¸‡à¸™à¸µà¹‰ à¹à¸¥à¹‰à¸§à¸ªà¸¡à¸±à¸„à¸£à¹„à¸¡à¹ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ à¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸ªà¸³à¸«à¸£à¸±à¸šà',0),(427347,11871,'hi','à¤¯à¤¦à¤¿ à¤à¤• à¤¬à¥‹à¤²à¥€ à¤‡à¤¸ à¤¬à¥‰à¤•à¥à¤¸ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤•à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ, à¤¤à¥‹ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤«à¤¾à¤°à¥à¤® à¤…à¤ªà¥‚à¤°à¥à¤£ à¤¹à¥ˆ à¤¯à¤¾ à¤à¤• à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¯à¤¨à¤¿à¤¤ à¤µà¤',0),(427348,11871,'ms','Jika sebut harga tidak muncul dalam kotak ini, kemudian sama ada borang penyertaan yang tidak lengkap, atau sebut harga tidak boleh dijana bagi opsyen yang dipilih.',0),(427349,11871,'ar','Ø¥Ø°Ø§ Ù„Ù… ÙŠØ¸Ù‡Ø± Ø§Ù‚ØªØ¨Ø§Ø³ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù…Ø±Ø¨Ø¹ØŒ Ø«Ù… Ø£Ù…Ø§ Ù†Ù…ÙˆØ°Ø¬ Ø¥Ø¯Ø®Ø§Ù„ ØºÙŠØ± Ù…ÙƒØªÙ…Ù„Ø©ØŒ Ø£Ùˆ Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ù†Ø´Ø§Ø¡ Ø¹Ø±Ø¶ Ø£Ø³Ø¹Ø§Ø± Ù„Ù„Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©.',0),(427350,11871,'fr','Si un devis n\'apparaÃ®t pas dans cette boÃ®te, ensuite le formulaire d\'inscription est incomplet ou un devis ne peut Ãªtre gÃ©nÃ©rÃ© pour les options sÃ©lectionnÃ©es.',0),(427351,11871,'jp','å¼•ç”¨ãŒã“ã®ãƒœãƒƒã‚¯ã‚¹ã«ã¯è¡¨ç¤ºã•ã‚Œãªã„å ´åˆã€ã‹ã¯ã‚¨ãƒ³ãƒˆãƒªãƒ¼ ãƒ•ã‚©ãƒ¼ãƒ ãŒå®Œäº†ã™ã‚‹ã¨ã€ã¾ãŸã¯é¸æŠžã—ãŸã‚ªãƒ—ã‚·ãƒ§ãƒ³ã®è¦‹ç©ã‚‚ã‚Šã‚’ç”Ÿæˆã§ãã¾ã›ã‚“ã€‚',0),(427352,11871,'pt','Se uma citaÃ§Ã£o nÃ£o aparecer nesta caixa, depois o formulÃ¡rio de inscriÃ§Ã£o estÃ¡ incompleto, ou uma citaÃ§Ã£o nÃ£o pode ser gerada para as opÃ§Ãµes selecionadas.',0),(427353,11871,'ru','Ð•ÑÐ»Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° Ð½Ðµ Ð¿Ð¾ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð² ÑÑ‚Ð¾Ð¼ Ð¿Ð¾Ð»Ðµ, Ð»Ð¸Ð±Ð¾ Ð°Ð½ÐºÐµÑ‚Ð° ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð½ÐµÐ¿Ð¾Ð»Ð½Ð¾Ð¹, Ð»Ð¸Ð±Ð¾ ÐµÐ³Ð¾ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° Ð½Ðµ Ð¼Ð¾Ð³ÑƒÑ‚ ÑÐ¾Ð·Ð´Ð°Ð²Ð°Ñ‚ÑŒÑÑ Ð´Ð»Ñ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð².',0),(427354,11871,'es','Si una CotizaciÃ³n no aparece en este cajon, entonces o la forma de entrar es incompleta, o una cotizaciÃ³n no se puede generar para las opciones seleccionadas',0),(427355,11871,'de','Wenn ein Zitat nicht in diesem Feld angezeigt wird, dann entweder das Anmeldeformular ist unvollstÃ¤ndig oder ein Zitat kann fÃ¼r die ausgewÃ¤hlten Optionen nicht erzeugt werden.',0),(427356,11871,'en','If a Quote does not appear in this box, then either the entry form is incomplete, or a quote cannot be generated for the selected options.',0),(427357,11872,'is','',0),(427358,11872,'dr','-Ù„Ø·ÙØ§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯',0),(427359,11872,'pr','Ø§Ú¯Ø± Ø¯Ø± Ù‚Ø³Ù…Øª Ù¾Ø§ÛŒÛŒÙ† Ù…ØªÙˆØ¬Ù‡ Ú†ÛŒØ²ÛŒ Ø§Ø´ØªØ¨Ø§Ù‡ Ø´Ø¯ÛŒØ¯ -Ù„Ø·ÙØ§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯',0),(427360,11872,'tr','HiÃ§bir ÅŸeye dikkat ederseniz yanlÄ±ÅŸ gÃ¶rÃ¼ÅŸler lÃ¼tfen arayÄ±n',0),(427361,11872,'pl','JeÅ›li zauwaÅ¼ysz coÅ› w poniÅ¼ej specyfikacje, ktÃ³re sÄ… nieprawidÅ‚owe, prosimy o kontakt',0),(427362,11872,'bg','ÐÐºÐ¾ Ð·Ð°Ð±ÐµÐ»ÐµÐ¶Ð¸Ñ‚Ðµ Ð½ÐµÑ‰Ð¾ Ð² Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ Ñ…Ð°Ñ€Ð°ÐºÑ‚ÐµÑ€Ð¸ÑÑ‚Ð¸ÐºÐ¸, ÐºÐ¾Ð¸Ñ‚Ð¾ ÑÐ° Ð½ÐµÑ‚Ð¾Ñ‡Ð½Ð¸, Ð¼Ð¾Ð»Ñ, Ð¾Ð±Ð°Ð´ÐµÑ‚Ðµ ÑÐµ',0),(427363,11872,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ù…ÛŒÚº Ú©Ú†Ú¾ Ø¨Ú¾ÛŒ Ù†ÙˆÙ¹Ø³ Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ø´ÛŒØ´Û’ Ú©Û’ Ø¬Ùˆ ØµØ­ÛŒØ­ Ù†ÛÛŒÚº ÛÛ’ØŒ Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÙÙˆÙ† Ú©Ø±ÛŒÚº',0),(427364,11872,'sr','ÐÐºÐ¾ Ð¿Ñ€Ð¸Ð¼ÐµÑ‚Ð¸Ñ‚Ðµ ÑÐ²Ðµ Ð½Ð° Ð¸ Ð¸ÑÐ¿Ð¾Ð´ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ ÐºÐ¾Ñ˜Ðµ ÑÑƒ Ð½ÐµÑ‚Ð°Ñ‡Ð½Ð¸, Ð¼Ð¾Ð»Ð¸Ð¼ Ñ‚Ðµ, Ð·Ð¾Ð²Ð¸',0),(427365,11872,'vi','Náº¿u báº¡n tháº¥y báº¥t cá»© gÃ¬ sai sÃ³t trong báº£ng specs dÆ°á»›i Ä‘Ã¢y, xin vui long gá»i',0),(427366,11872,'af','Indien u enigiets merk in die onderstaande spesifikasies wat verkeerd is, skakel asb.',0),(427367,11872,'ro','DacÄƒ observaÅ£i ceva Ã®n continuare Specificatii care sunt incorecte, vÄƒ rugÄƒm sÄƒ sunaÅ£i',0),(427368,11872,'et','Kui mÃ¤rkate midagi selle alla andmed on valed, siis helistage',0),(427369,11872,'si','ÄŒe opazite karkoli v v nadaljevanju oÄala, ki so nepravilne, pokliÄite',0),(427370,11872,'ba','Jika Anda melihat sesuatu di bawah spesifikasi yang salah, silakan hubungi',0),(427371,11872,'nl','Als u verwittiging iets in de hieronder specs die onjuist zijn, kunt u bellen',0),(427372,11872,'fi','Jos huomaat mitÃ¤Ã¤n alla tiedot, jotka ovat virheellisiÃ¤, soita',0),(427373,11872,'no','Hvis du oppdager noe i den under spesifikasjoner som er feil, ring',0),(427374,11872,'da','Hvis du bemÃ¦rker noget i den nedenstÃ¥ende specs, der er forkert, bedes du ringe',0),(427375,11872,'ko','ì•„ë¬´ê²ƒë„ì—ì„œ í†µì§€ í•˜ëŠ” ê²½ìš°ëŠ” ìž˜ëª» ëœ ì‚¬ì–‘ ì•„ëž˜ ì „í™” ì£¼ì„¸ìš”',0),(427376,11872,'he','×× ××ª×” ×ž×‘×—×™×Ÿ ×›×œ ×“×‘×¨ ×œ×”×œ×Ÿ ×ž×¤×¨×˜ ×–×” ××™× × × ×›×•× ×™×, ×‘×‘×§×©×” ×ª×ª×§×©×¨',0),(427377,11872,'el','Î•Î¬Î½ you ÎµÎ¹Î´Î¿Ï€Î¿Î¹Î·Ï„Î®ÏÎ¹Î¿ Î¿Ï„Î¹Î´Î®Ï€Î¿Ï„Îµ ÏƒÎµ Ï„Î¿ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Ï€ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†ÏŽÎ½ Ï€Î¿Ï… Î½Î± ÎµÎ¯Î½Î±Î¹ Î»Î±Î½Î¸Î±ÏƒÎ¼Î­Î½Î·, ÎºÎ±Î»Î­ÏƒÏ„Îµ',0),(427378,11872,'zh','å¦‚æžœä½ å‘çŽ°åœ¨ä¸‹é¢çš„è§„æ ¼æ˜¯ä¸æ­£ç¡®çš„è¯·è‡´ç”µ\r\n',0),(427379,11872,'sv','Om du mÃ¤rker nÃ¥got i den nedan specar som Ã¤r felaktiga, vÃ¤nligen ring',0),(427380,11872,'it','Se notate qualcosa nella sotto specifiche che non sono corrette, si prega di chiamare',0),(427381,11872,'tl','',0),(427382,11872,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¸ªà¸±à¸‡à¹€à¸à¸•à¸­à¸°à¹„à¸£à¹ƒà¸™à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸—à¸µà¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡ à¸à¸£à¸¸à¸“à¸²',0),(427383,11872,'hi','à¤…à¤—à¤° à¤†à¤ª à¤®à¥‡à¤‚ à¤•à¥à¤› à¤­à¥€ à¤¸à¥‚à¤šà¤¨à¤¾ à¤¨à¥€à¤šà¥‡ à¤šà¤¶à¥à¤®à¤¾ à¤•à¤¿ à¤—à¤²à¤¤ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚, à¤•à¥ƒà¤ªà¤¯à¤¾ à¤«à¥‹à¤¨',0),(427384,11872,'ms','Jika anda mendapati apa-apa di dalam di bawah ciri-ciri komputer yang tidak betul, sila hubungi',0),(427385,11872,'ar','Ø¥Ø°Ø§ Ù„Ø§Ø­Ø¸Øª ÙˆØ¬ÙˆØ¯ Ø£ÙŠ Ø´ÙŠØ¡ ÙÙŠ Ø£Ø¯Ù†Ø§Ù‡ Ø§Ù„Ù…ÙˆØ§ØµÙØ§Øª Ø§Ù„ØªÙŠ ØºÙŠØ± ØµØ­ÙŠØ­Ø©ØŒ ÙŠØ±Ø¬Ù‰ Ø§Ù„Ø§ØªØµØ§Ù„ Ø¹Ù„Ù‰:',0),(427386,11872,'fr','Si vous remarquez quoi que ce soit dans les dessous de spÃ©cifications qui sont incorrectes, veuillez communiquer avec',0),(427387,11872,'jp','ã‚ãªãŸã«ä½•ã‹ã«æ°—ã¥ãå ´åˆã€ä¸‹è¨˜ã®ã‚¹ãƒšãƒƒã‚¯ãŒæ­£ã—ã„ã“ã¨ã€ãŠé›»è©±ãã ã•ã„',0),(427388,11872,'pt','Se vocÃª notar qualquer coisa no abaixo especificaÃ§Ãµes que estÃ£o incorretas, por favor, ligue',0),(427389,11872,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð·Ð°Ð¼ÐµÑ‚Ð¸Ð»Ð¸ Ñ‡Ñ‚Ð¾-Ð½Ð¸Ð±ÑƒÐ´ÑŒ Ð² Ð½Ð¸Ð¶Ðµ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ ÑÐ²Ð»ÑÑŽÑ‚ÑÑ Ð½ÐµÐ²ÐµÑ€Ð½Ñ‹Ð¼Ð¸, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ð¾Ð·Ð²Ð¾Ð½Ð¸Ñ‚Ðµ',0),(427390,11872,'es','Si ve cualquier cosa en las especificaciones mostradas abajo que esta incorrectos, pro favor llama',0),(427391,11872,'de','Wenn Sie bemerken, dass etwas in der folgenden Angaben, die falsch sind, rufen Sie bitte',0),(427392,11872,'en','If you notice anything in the below specs that are incorrect, please call',0),(427393,11873,'is','',0),(427394,11873,'dr','ÙÙˆØ±Ø§ Ùˆ Ø¨Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„ Ø¨Ø§Ù„Ø§ Ù…Ø±Ø§Ø¬Ø¹Ù‡ Ú©Ù†ÛŒØ¯',0),(427395,11873,'pr','ÙÙˆØ±Ø§ Ùˆ Ø¨Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ø´ØºÙ„ Ø¨Ø§Ù„Ø§ Ù…Ø±Ø§Ø¬Ø¹Ù‡ Ú©Ù†ÛŒØ¯',0),(427396,11873,'tr','hemen ve yukarÄ±daki proje numarasÄ±na bakÄ±n',0),(427397,11873,'pl','natychmiast i odnoszÄ… siÄ™ do wyÅ¼ej numer zadania',0),(427398,11873,'bg','Ð½ÐµÐ·Ð°Ð±Ð°Ð²Ð½Ð¾ Ð¸ ÑÐµ Ð¾Ñ‚Ð½Ð°ÑÑ ÐºÑŠÐ¼ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(427399,11873,'ur','ÙÙˆØ±ÛŒ Ø·ÙˆØ± Ù¾Ø± Ø§ÙˆØ± Ø§ÙˆÙ¾Ø± Ù…Ù„Ø§Ø²Ù…Øª Ù†Ù…Ø¨Ø± Ù¾Ø± Ø±Ø¬ÙˆØ¹ Ú©Ø±ÛŒÚº',0),(427400,11873,'sr','Ð¾Ð´Ð¼Ð°Ñ… Ð¸ Ð´Ð° ÑÐµ Ð¾Ð´Ð½Ð¾ÑÐ¸ Ð½Ð° Ð±Ñ€Ð¾Ñ˜ Ð¸Ð·Ð½Ð°Ð´ Ð¿Ð¾ÑÐ°Ð¾',0),(427401,11873,'vi','ngay láº­p tá»©c vÃ  chuyá»ƒn Ä‘áº¿n sá»‘ cÃ´ng viá»‡c á»Ÿ trÃªn',0),(427402,11873,'af','onmiddellik en verwys na die bogenoemde werk nommer',0),(427403,11873,'ro','imediat ÅŸi se referÄƒ la numÄƒrul de job mai sus',0),(427404,11873,'et','kohe ja viidata eespool nimetatud tÃ¶Ã¶ number',0),(427405,11873,'si','takoj in se nanaÅ¡ajo na zgoraj Å¡tevilka projekta',0),(427406,11873,'ba','segera dan merujuk pada jumlah pekerjaan di atas',0),(427407,11873,'nl','onmiddellijk en verwijzen naar het bovenstaande projectnummer',0),(427408,11873,'fi','vÃ¤littÃ¶mÃ¤sti ja viitata edellÃ¤ tyÃ¶numero',0),(427409,11873,'no','umiddelbart og se over prosjektnummeret',0),(427410,11873,'da','straks og henvise til den ovennÃ¦vnte jobnummer',0),(427411,11873,'ko','ë°”ë¡œ ìœ„ì˜ ìž‘ì—… ë²ˆí˜¸ë¥¼ ì°¸ì¡° í•˜ ê³ ',0),(427412,11873,'he','×ž×™×“ ×•×œ×”×¤× ×•×ª ×ž×¡×¤×¨ ×”×ž×©×¨×” ×”×  ×œ',0),(427413,11873,'el','Î±Î¼Î­ÏƒÏ‰Ï‚ ÎºÎ±Î¹ Î±Î½Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹ ÏƒÏ„Î¿Î½ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ Î±ÏÎ¹Î¸Î¼ÏŒ Î¸Î­ÏƒÎµÏ‰Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(427414,11873,'zh','ç«‹å³å‚ç…§ä¸Šè¿°èŒä½ç¼–å·\r\n',0),(427415,11873,'sv','omedelbart och hÃ¤nvisar till ovan projektnumret',0),(427416,11873,'it','immediatamente e consultare il suddetto numero di lavoro',0),(427417,11873,'tl','',0),(427418,11873,'th','à¸—à¸±à¸™à¸—à¸µ à¹à¸¥à¸°à¸­à¹‰à¸²à¸‡à¸–à¸¶à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸‡à¸²à¸™à¸‚à¹‰à¸²à¸‡à¸•à¹‰à¸™',0),(427419,11873,'hi','à¤¤à¥à¤°à¤‚à¤¤ à¤”à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤°à¥‹à¤•à¥à¤¤ à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¤¾ à¤¸à¤‚à¤¦à¤°à¥à¤­ à¤²à¥‡à¤‚',0),(427420,11873,'ms','dengan segera dan rujuk kepada jumlah pekerjaan di atas',0),(427421,11873,'ar','ÙÙˆØ±Ø§ØŒ ÙˆØ§Ù„Ø¥Ø´Ø§Ø±Ø© Ø¥Ù„Ù‰ Ø±Ù‚Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…Ø°ÙƒÙˆØ±Ø© Ø£Ø¹Ù„Ø§Ù‡',0),(427422,11873,'fr','immÃ©diatement et indiquer le numÃ©ro de travail ci-dessus',0),(427423,11873,'jp','ã™ãã«ã€ä¸Šã®ã‚¸ãƒ§ãƒ–ç•ªå·ã‚’å‚ç…§ã—ã¦ãã ã•ã„',0),(427424,11873,'pt','imediatamente e consulte o nÃºmero de trabalho acima',0),(427425,11873,'ru','ÑÑ€Ð°Ð·Ñƒ Ð¶Ðµ Ð¸ Ð¾Ð±Ñ€Ð°Ñ‚Ð¸Ñ‚ÐµÑÑŒ Ðº Ð²Ñ‹ÑˆÐµ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(427426,11873,'es','inmediatamente y refiere al nÃºmero de trabajo arriba',0),(427427,11873,'de','sofort und beziehen sich auf die oben genannten Job-Nummer',0),(427428,11873,'en','immediately and refer to the above job number',0),(427429,11874,'is','',0),(427430,11874,'dr','Ù…Ø±Ú©Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(427431,11874,'pr','Ù…Ø±Ú©Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(427432,11874,'tr','Bilgi BankasÄ±',0),(427433,11874,'pl','Baza wiedzy',0),(427434,11874,'bg','Ð—Ð½Ð°Ð½Ð¸Ñ',0),(427435,11874,'ur','Ú©Ù†ÙˆÙˆÙ„Ø§Ø¯Ú¯ÛŒØ¨Ø§Ø³ÛŒ',0),(427436,11874,'sr','ÐšÐ½Ð¾wÐ»ÐµÐ´Ð³ÐµÐ±Ð°ÑÐµ',0),(427437,11874,'vi','sá»± am hiÃªu',0),(427438,11874,'af','Knowledgebase',0),(427439,11874,'ro','Baza de cunoÅŸtinÅ£e',0),(427440,11874,'et','Teadmiste',0),(427441,11874,'si','Knowledgebase',0),(427442,11874,'ba','Knowledgebase',0),(427443,11874,'nl','Knowledgebase',0),(427444,11874,'fi','Tietopankki',0),(427445,11874,'no','Kunnskapsbasen',0),(427446,11874,'da','Knowledgebase',0),(427447,11874,'ko','ê¸°ìˆ  ìžë£Œ',0),(427448,11874,'he','×ž××’×¨ ×ž×™×“×¢',0),(427449,11874,'el','Î“Î½Ï‰ÏƒÎ¹Î±ÎºÎ® Î²Î¬ÏƒÎ·',0),(427450,11874,'zh','çŸ¥è¯†åº“\r\n',0),(427451,11874,'sv','Knowledgebase',0),(427452,11874,'it','KnowledgeBase',0),(427453,11874,'tl','',0),(427454,11874,'th','à¸à¸²à¸™',0),(427455,11874,'hi','à¤¨à¥‰à¤²à¥‡à¤œà¤¬à¥‡à¤¸',0),(427456,11874,'ms','Pengetahuan',0),(427457,11874,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ù…Ø¹Ø±ÙØ©',0),(427458,11874,'fr','Base de connaissances',0),(427459,11874,'jp','ãƒŠãƒ¬ãƒƒã‚¸ ãƒ™ãƒ¼ã‚¹',0),(427460,11874,'pt','Base de conhecimento',0),(427461,11874,'ru','Ð‘Ð°Ð·Ð° Ð·Ð½Ð°Ð½Ð¸Ð¹',0),(427462,11874,'es','Base de Conocimientos',0),(427463,11874,'de','Knowledgebase',0),(427464,11874,'en','Knowledgebase',0),(427465,11875,'is','',0),(427466,11875,'dr','Ø®Ø±ÙˆØ¬ Ø§Ø² Ø³ÛŒØ³ØªÙ…',0),(427467,11875,'pr','Ø®Ø±ÙˆØ¬ Ø§Ø² Ø³ÛŒØ³ØªÙ…',0),(427468,11875,'tr','Ã‡Ä±kÄ±ÅŸ',0),(427469,11875,'pl','Zaloguj',0),(427470,11875,'bg','Ð˜Ð·Ñ…Ð¾Ð´',0),(427471,11875,'ur','Ù„Ø§Ú¯ Ø¢Ø¤Ù¹',0),(427472,11875,'sr','Ð˜Ð·Ð»Ð¾Ð³ÑƒÑ˜ ÑÐµ',0),(427473,11875,'vi','thoÃ¡t ra',0),(427474,11875,'af','Teken',0),(427475,11875,'ro','Log Out',0),(427476,11875,'et','Logi vÃ¤lja',0),(427477,11875,'si','Poleno jasno',0),(427478,11875,'ba','Log Out',0),(427479,11875,'nl','Uitloggen',0),(427480,11875,'fi','Kirjaudu ulos',0),(427481,11875,'no','Logg',0),(427482,11875,'da','Log ud',0),(427483,11875,'ko','ë¡œê·¸ ì•„ì›ƒ',0),(427484,11875,'he','×”×ª× ×ª×§',0),(427485,11875,'el','Î‘Ï€Î¿ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ',0),(427486,11875,'zh','ç™»å‡º\r\n',0),(427487,11875,'sv','Logga ut',0),(427488,11875,'it','Logout',0),(427489,11875,'tl','',0),(427490,11875,'th','à¸­à¸­à¸à¸ˆà¸²à¸à¸£à¸°à¸šà¸š',0),(427491,11875,'hi','à¤²à¥‰à¤— à¤†à¤‰à¤Ÿ',0),(427492,11875,'ms','Log',0),(427493,11875,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬',0),(427494,11875,'fr','Fermer la session',0),(427495,11875,'jp','ãƒ­ã‚°ã‚¢ã‚¦ãƒˆã—ã¾ã™ã€‚',0),(427496,11875,'pt','Efetuar logout',0),(427497,11875,'ru','Ð’Ñ‹Ð¹Ñ‚Ð¸ Ð¸Ð·',0),(427498,11875,'es','Log Out',0),(427499,11875,'de','Melden Sie sich',0),(427500,11875,'en','Log Out',0),(427501,11876,'is','',0),(427502,11876,'dr','-Ø´Ù…Ø§Ø±Ù‡ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¬Ø¯ÛŒØ¯',0),(427503,11876,'pr','Ø§ÛŒØ¬Ø§Ø¯ ØªØºÛŒÛŒØ±Ø§Øª-Ø´Ù…Ø§Ø±Ù‡ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¬Ø¯ÛŒØ¯',0),(427504,11876,'tr','DeÄŸiÅŸiklik - yeni teklif numarasÄ±',0),(427505,11876,'pl','Zmiany - nowy numer',0),(427506,11876,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ - Ð½Ð¾Ð² Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(427507,11876,'ur','-Ù†ÛŒØ§ Ø§Ù‚ØªØ¨Ø§Ø³ Ù†Ù…Ø¨Ø± Ù…ÛŒÚº ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(427508,11876,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð¼Ñ˜ÐµÐ½Ðµ - Ð½Ð¾Ð²Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(427509,11876,'vi','thay Ä‘á»•i- sá»‘ bÃ¡o giÃ¡ má»›i',0),(427510,11876,'af','Maak veranderinge - nuwe kwotasie nommer',0),(427511,11876,'ro','Face schimbÄƒri - numÄƒr nou citat',0),(427512,11876,'et','Muuta - uue pakkumise numbrit',0),(427513,11876,'si','Spreminjati - novo Å¡tevilko ponudbe',0),(427514,11876,'ba','Membuat perubahan - nomor baru kutipan',0),(427515,11876,'nl','Wijzigingen - nieuwe Quotenummer',0),(427516,11876,'fi','TehdÃ¤ muutoksia - uusi huoltotarjouksen numero',0),(427517,11876,'no','GjÃ¸r endringene - nye tilbudsnummer',0),(427518,11876,'da','Foretage Ã¦ndringer - ny tilbudsnummer',0),(427519,11876,'ko','ë³€ê²½-ìƒˆë¡œìš´ ê²¬ì  ë²ˆí˜¸',0),(427520,11876,'he','×©×™× ×•×™×™× - ×ž×¡×¤×¨ ×”×¦×¢×ª ×”×ž×—×™×¨ ×”×—×“×©',0),(427521,11876,'el','ÎšÎ¬Î½ÎµÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚ - Î½Î­Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(427522,11876,'zh','è¿›è¡Œæ›´æ”¹-æ–°æŠ¥ä»·ç¼–å·\r\n',0),(427523,11876,'sv','GÃ¶ra fÃ¶rÃ¤ndringar - nya offertnummer',0),(427524,11876,'it','Apportare modifiche - nuovo numero di Quote',0),(427525,11876,'tl','',0),(427526,11876,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡ - à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹ƒà¸«à¸¡à¹ˆ',0),(427527,11876,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ - à¤¨à¤¯à¤¾ à¤•à¥‹à¤Ÿ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(427528,11876,'ms','Membuat perubahan - nombor sebut harga baru',0),(427529,11876,'ar','Ø¥Ø¬Ø±Ø§Ø¡ ØªØºÙŠÙŠØ±Ø§Øª--Ø±Ù‚Ù… Ø¹Ø±Ø¶ Ø£Ø³Ø¹Ø§Ø± Ø¬Ø¯ÙŠØ¯',0),(427530,11876,'fr','Apporter des modifications - nouveau numÃ©ro de devis',0),(427531,11876,'jp','å¤‰æ›´ - æ–°ã—ã„è¦‹ç©ã‚‚ã‚Šç•ªå·',0),(427532,11876,'pt','Fazer mudanÃ§as - novo nÃºmero de citaÃ§Ã£o',0),(427533,11876,'ru','Ð’Ð½ÐµÑÑ‚Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ - Ð½Ð¾Ð²Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ ÐºÐ²Ð¾Ñ‚Ñ‹',0),(427534,11876,'es','Hace Cambios - Nuevo NÃºmero de CotizaciÃ³n',0),(427535,11876,'de','Ã„nderungen Sie - neue Angebotsnummer',0),(427536,11876,'en','Make Changes - New Quote Number',0),(427537,11877,'is','',0),(427538,11877,'dr','-Ø´Ù…Ø§Ø±Ù‡ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ù…Ø´Ø§Ø¨Ù‡',0),(427539,11877,'pr','Ø§ÛŒØ¬Ø§Ø¯ ØªØºÛŒÛŒØ±Ø§Øª-Ø´Ù…Ø§Ø±Ù‡ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ù…Ø´Ø§Ø¨Ù‡',0),(427540,11877,'tr','DeÄŸiÅŸiklik - aynÄ± teklif numarasÄ±',0),(427541,11877,'pl','Zmiany - sam numer oferty',0),(427542,11877,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ - ÑÑŠÑ‰Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(427543,11877,'ur','-Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Û’ Ø§ÛŒÚ© ÛÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù…ÛŒÚº ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(427544,11877,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð¼Ñ˜ÐµÐ½Ðµ - Ð¸ÑÑ‚Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(427545,11877,'vi','lÃ m thay Ä‘á»•i- sá»‘ bÃ¡o giÃ¡ giá»‘ng nhau',0),(427546,11877,'af','Maak veranderinge - dieselfde aanhaling nommer',0),(427547,11877,'ro','ModificÄƒri de - acelaÈ™i numÄƒr de citat',0),(427548,11877,'et','Muuta - sama pakkumise numbrit',0),(427549,11877,'si','Spreminjati - isto Å¡tevilko ponudbe',0),(427550,11877,'ba','Membuat perubahan - nomor kutipan yang sama',0),(427551,11877,'nl','Wijzigingen - dezelfde Quotenummer',0),(427552,11877,'fi','Tee muutokset - sama Tarjousnumero',0),(427553,11877,'no','Endre - samme tilbudsnummer',0),(427554,11877,'da','Foretage Ã¦ndringer - samme tilbudsnummer',0),(427555,11877,'ko','ë³€ê²½-ë™ì¼í•œ ê²¬ì  ë²ˆí˜¸',0),(427556,11877,'he','×©×™× ×•×™×™× - ××•×ª×• ×ž×¡×¤×¨ ×”×¦×¢×ª ×ž×—×™×¨',0),(427557,11877,'el','ÎšÎ¬Î½ÎµÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚ - Î¯Î´Î¹Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(427558,11877,'zh','è¿›è¡Œæ›´æ”¹-ç›¸åŒæŠ¥ä»·ç¼–å·\r\n',0),(427559,11877,'sv','GÃ¶ra Ã¤ndringar - samma offertnummer',0),(427560,11877,'it','Apportare modifiche - stesso numero di Quote',0),(427561,11877,'tl','',0),(427562,11877,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡ - à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹€à¸”à¸µà¸¢à¸§à¸à¸±à¸™',0),(427563,11877,'hi','à¤¸à¤®à¤¾à¤¨ à¤•à¥‹à¤Ÿ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ - à¤•à¤°',0),(427564,11877,'ms','Membuat perubahan - bilangan sebut harga yang sama',0),(427565,11877,'ar','Ø¥Ø¬Ø±Ø§Ø¡ ØªØºÙŠÙŠØ±Ø§Øª--Ù†ÙØ³ Ø±Ù‚Ù… Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(427566,11877,'fr','Apporter des modifications - mÃªme nombre de devis',0),(427567,11877,'jp','-å¤‰æ›´ã‚’è¡Œãªã†åŒã˜è¦‹ç©ã‚‚ã‚Šç•ªå·',0),(427568,11877,'pt','Fazer mudanÃ§as - mesmo nÃºmero de citaÃ§Ãµes',0),(427569,11877,'ru','Ð’Ð½ÐµÑÑ‚Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ - Ð¶Ðµ Ð½Ð¾Ð¼ÐµÑ€ ÐºÐ²Ð¾Ñ‚Ñ‹',0),(427570,11877,'es','Hace Cambios - El Mismo NÃºmero de CotizaciÃ³n',0),(427571,11877,'de','Ã„nderungen Sie - gleichen Angebotsnummer',0),(427572,11877,'en','Make Changes - Same Quote Number',0),(427573,11878,'is','',0),(427574,11878,'dr','Ø¨Ø§ÛŒØ¯ ØªÙˆØ¶ÛŒØ­Ø§Øª Ú©ÙˆØªØ§Ù‡ ÛŒØ§ Ù†Ù…Ø§Ø¯Ù‡Ø§ Ø¯Ø± Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø¨Ø§Ø´Ø¯',0),(427575,11878,'pr','Ø¨Ø§ÛŒØ¯ ØªÙˆØ¶ÛŒØ­Ø§Øª Ú©ÙˆØªØ§Ù‡ ÛŒØ§ Ù†Ù…Ø§Ø¯Ù‡Ø§ Ø¯Ø± Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø¨Ø§Ø´Ø¯',0),(427576,11878,'tr','KÄ±sa aÃ§Ä±klama veya simge Kur eÅŸleÅŸmelidir',0),(427577,11878,'pl','Musi odpowiadaÄ‡ KrÃ³tki opis lub Symbol w instalacji',0),(427578,11878,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð° Ñ ÐºÑ€Ð°Ñ‚ÐºÐ¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¸Ð»Ð¸ ÑÐ¸Ð¼Ð²Ð¾Ð» Ð² Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(427579,11878,'ur','Ù…Ø®ØªØµØ± Ø¨ÛŒØ§Ù† ÛŒØ§ Ø³ÛŒÙ¹ Ø§Ù¾ Ù…ÛŒÚº Ø¹Ù„Ø§Ù…Øª Ø³Û’ Ù…Ø´Ø§Ø¨Û ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(427580,11878,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð° ÐºÑ€Ð°Ñ‚Ð°Ðº Ð¾Ð¿Ð¸Ñ Ð¸Ð»Ð¸ ÑÐ¸Ð¼Ð±Ð¾Ð» Ñƒ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐ°',0),(427581,11878,'vi','Pháº£i káº¿t há»£p diá»…n giáº£i ngáº¯n hoáº·c biá»ƒu tÆ°á»£ng trong khi thiáº¿t láº­p',0),(427582,11878,'af','Kort beskrywing of simbool In opstelling moet ooreenstem',0),(427583,11878,'ro','Trebuie sÄƒ se potriveascÄƒ scurtÄƒ descriere sau simbol Ã®n Setup',0),(427584,11878,'et','Tuleb Ã¼hti lÃ¼hikirjeldus vÃµi tÃ¤his, seadistamine',0),(427585,11878,'si','Ujemati kratek opis ali simbol v Setup',0),(427586,11878,'ba','Harus cocok dengan deskripsi singkat atau simbol di Setup',0),(427587,11878,'nl','Moet overeenkomen met korte beschrijving of symbool In Setup',0),(427588,11878,'fi','On vastattava lyhyt kuvaus tai symboli asetukset',0),(427589,11878,'no','Samsvare Sammendrag eller Symbol i oppsettet',0),(427590,11878,'da','Skal svare kort beskrivelse eller Symbol i opsÃ¦tning',0),(427591,11878,'ko','ì§§ì€ ì„¤ëª… ì´ë‚˜ ì„¤ì •ì—ì„œ ê¸°í˜¸ë¥¼ ì¼ì¹˜ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(427592,11878,'he','×—×™×™×‘ ×œ×”×ª××™× ×ª×™××•×¨ ×§×¦×¨ ××• ×¡×ž×œ ×‘×ª×•×›× ×™×ª ×”×”×ª×§× ×”',0),(427593,11878,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î¼Îµ ÏƒÏÎ½Ï„Î¿Î¼Î· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î® ÏƒÏÎ¼Î²Î¿Î»Î¿ Î£Î¤Î—Î£Î™ÎœÎŸ',0),(427594,11878,'zh','å¿…é¡»åœ¨è®¾ç½®ä¸­åŒ¹é…ç®€çŸ­æè¿°æˆ–ç¬¦å·\r\n',0),(427595,11878,'sv','MÃ¥ste matcha kort beskrivning eller Symbol i Setup',0),(427596,11878,'it','Deve corrispondere il simbolo nel Setup o breve descrizione',0),(427597,11878,'tl','',0),(427598,11878,'th','à¸•à¹‰à¸­à¸‡à¸•à¸£à¸‡à¸à¸±à¸šà¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹‚à¸”à¸¢à¸¢à¹ˆà¸­à¸«à¸£à¸·à¸­à¸ªà¸±à¸à¸¥à¸±à¸à¸©à¸“à¹Œà¹ƒà¸™à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²',0),(427599,11878,'hi','à¤²à¤˜à¥ à¤µà¤°à¥à¤£à¤¨ à¤¯à¤¾ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¤à¥€à¤• à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(427600,11878,'ms','Mesti sepadan dengan penerangan ringkas atau simbol dalam persediaan',0),(427601,11878,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ ÙˆØµÙ Ù…Ø®ØªØµØ± Ø£Ùˆ Ø±Ù…Ø² ÙÙŠ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(427602,11878,'fr','Doit correspondre Ã  brÃ¨ve Description ou un symbole dans le programme d\'installation',0),(427603,11878,'jp','çŸ­ã„èª¬æ˜Žã¾ãŸã¯ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—å†…ã®ã‚·ãƒ³ãƒœãƒ«ã«ä¸€è‡´ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(427604,11878,'pt','Devem corresponder a descriÃ§Ã£o curta ou sÃ­mbolo na configuraÃ§Ã£o',0),(427605,11878,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÑ€Ð°Ñ‚ÐºÐ¾Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¸Ð»Ð¸ ÑÐ¸Ð¼Ð²Ð¾Ð» Ð² Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(427606,11878,'es','Debe Igualarse con la DescripciÃ³n Corta o el sÃ­mbolo en la ConfiguraciÃ³n',0),(427607,11878,'de','Kurze Beschreibung oder ein Symbol im Setup Ã¼bereinstimmen',0),(427608,11878,'en','Must Match Short Description Or Symbol In Setup',0),(427609,11879,'is','',0),(427610,11879,'dr','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ú©Ù…Ú©',0),(427611,11879,'pr','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ú©Ù…Ú©',0),(427612,11879,'tr','YardÄ±ma ihtiyacÄ±m var',0),(427613,11879,'pl','Potrzebujesz pomocy',0),(427614,11879,'bg','ÐÑƒÐ¶Ð´Ð° Ð¾Ñ‚ Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(427615,11879,'ur','Ù…Ø¯Ø¯ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(427616,11879,'sr','Ð¢Ñ€ÐµÐ±Ð° Ð¼Ð¸ Ð¿Ð¾Ð¼Ð¾Ñ›',0),(427617,11879,'vi','Cáº§n trá»£ giÃºp',0),(427618,11879,'af','Hulp nodig',0),(427619,11879,'ro','AveÅ£i nevoie de ajutor',0),(427620,11879,'et','Vajan abi',0),(427621,11879,'si','Potrebujejo pomoÄ',0),(427622,11879,'ba','Perlu bantuan',0),(427623,11879,'nl','Hulp nodig',0),(427624,11879,'fi','Tarvitsetko apua',0),(427625,11879,'no','Trenger hjelp',0),(427626,11879,'da','Brug for hjÃ¦lp',0),(427627,11879,'ko','ë„ì›€ì´ í•„ìš”',0),(427628,11879,'he','×¦×¨×™×š ×¢×–×¨×”',0),(427629,11879,'el','Î§ÏÎµÎ¹Î¬Î¶ÎµÏƒÏ„Îµ Î²Î¿Î®Î¸ÎµÎ¹Î±',0),(427630,11879,'zh','éœ€è¦å¸®åŠ©\r\n',0),(427631,11879,'sv','BehÃ¶ver hjÃ¤lp',0),(427632,11879,'it','Hai bisogno di aiuto',0),(427633,11879,'tl','',0),(427634,11879,'th','à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸„à¸§à¸²à¸¡à¸Šà¹ˆà¸§à¸¢à¹€à¸«à¸¥à¸·à¸­',0),(427635,11879,'hi','à¤®à¤¦à¤¦ à¤•à¥€ à¤œà¤¼à¤°à¥‚à¤°à¤¤ à¤¹à¥ˆ',0),(427636,11879,'ms','Perlukan bantuan',0),(427637,11879,'ar','Ø¨Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰ Ù…Ø³Ø§Ø¹Ø¯Ø©',0),(427638,11879,'fr','Besoin d\'aide',0),(427639,11879,'jp','åŠ©ã‘ãŒå¿…è¦',0),(427640,11879,'pt','Preciso de ajuda',0),(427641,11879,'ru','ÐÑƒÐ¶Ð½Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒ',0),(427642,11879,'es','Necesita Ayuda',0),(427643,11879,'de','Brauche Hilfe',0),(427644,11879,'en','Need Help',0),(427645,11880,'is','',0),(427646,11880,'dr','- Ù‡Ù…Ø§Ù† Ø®Ø±ÛŒØ¯Ø§Ø± ',0),(427647,11880,'pr','Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¬Ø¯ÛŒØ¯- Ù‡Ù…Ø§Ù† Ø®Ø±ÛŒØ¯Ø§Ø± ',0),(427648,11880,'tr','Yeni teklif - aynÄ± mÃ¼ÅŸteri',0),(427649,11880,'pl','Nowa oferta - samego klienta',0),(427650,11880,'bg','ÐÐ¾Ð²Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° - Ð·Ð° ÑÑŠÑ‰Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(427651,11880,'ur','Ù†Ø¦Û’ Ø§Ù‚ØªØ¨Ø§Ø³ - Ø§ÛŒÚ© ÛÛŒ Ú¯Ø§ÛÚ©',0),(427652,11880,'sr','ÐÐ¾Ð²Ð° Ð¿Ð¾Ð½ÑƒÐ´Ð° - Ð¸ÑÑ‚Ð¾Ð¼ ÐºÑƒÐ¿Ñ†Ñƒ',0),(427653,11880,'vi','BÃ¡o giÃ¡ má»›i- cÃ¹ng khÃ¡ch hÃ ng',0),(427654,11880,'af','Nuwe kwotasie - dieselfde kliÃ«nt',0),(427655,11880,'ro','Citat nou - acelaÅŸi client',0),(427656,11880,'et','Uus pakkumine - samale kliendile',0),(427657,11880,'si','Nove ponudbe - isto stranko',0),(427658,11880,'ba','Baru kutipan - sama pelanggan',0),(427659,11880,'nl','Nieuwe offerte - dezelfde klant',0),(427660,11880,'fi','Uusi tarjous - saman asiakkaan',0),(427661,11880,'no','Ny forespÃ¸rsel - samme kunde',0),(427662,11880,'da','Nyt tilbud - samme kunde',0),(427663,11880,'ko','ìƒˆ ê²¬ì -ë™ì¼í•œ ê³ ê°',0),(427664,11880,'he','×”×¦×¢×ª ×ž×—×™×¨ ×—×“×©×” - ×ž××•×ª×• ×œ×§×•×—',0),(427665,11880,'el','ÎÎ­Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ - Î¯Î´Î¹Î¿ Ï€ÎµÎ»Î¬Ï„Î·',0),(427666,11880,'zh','æ–°çš„æŠ¥ä»·-ç›¸åŒçš„å®¢æˆ·\r\n',0),(427667,11880,'sv','Ny offert - samma kund',0),(427668,11880,'it','Nuova offerta - stesso cliente',0),(427669,11880,'tl','',0),(427670,11880,'th','à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹ƒà¸«à¸¡à¹ˆ - à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸”à¸µà¸¢à¸§à¸à¸±à¸™',0),(427671,11880,'hi','à¤¨à¤ˆ à¤‰à¤¦à¥à¤§à¤°à¤£ - à¤à¤• à¤¹à¥€ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(427672,11880,'ms','Quote baru - Baca sama',0),(427673,11880,'ar','Ø¹Ø±Ø¶ Ø£Ø³Ø¹Ø§Ø± Ø¬Ø¯ÙŠØ¯-Ù†ÙØ³ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(427674,11880,'fr','Nouveau devis - mÃªme client',0),(427675,11880,'jp','æ–°ã—ã„è¦‹ç©ã‚‚ã‚Š - åŒã˜é¡§å®¢',0),(427676,11880,'pt','Nova citaÃ§Ã£o - mesmo cliente',0),(427677,11880,'ru','ÐÐ¾Ð²Ð°Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° - Ð¶Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(427678,11880,'es','Nueva CotizaciÃ³n - El Mismo Cliente',0),(427679,11880,'de','Neues Angebot - denselben Kunden',0),(427680,11880,'en','New Quote - Same Customer',0),(427681,11881,'is','',0),(427682,11881,'dr','Ù‡ÛŒÚ† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(427683,11881,'pr','Ù‡ÛŒÚ† Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(427684,11881,'tr','SeÃ§ili bir Ã§ek hesabÄ±',0),(427685,11881,'pl','Nie konta bankowego wybranego',0),(427686,11881,'bg','ÐÑÐ¼Ð° Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(427687,11881,'ur','Ú©ÙˆØ¦ÛŒ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ù…Ù†ØªØ®Ø¨',0),(427688,11881,'sr','ÐÐµÐ¼Ð° Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½',0),(427689,11881,'vi','khÃ´ng kiá»ƒm tra tÃ i khoáº£n Ä‘Æ°á»£c chá»n',0),(427690,11881,'af','Geen Kontroleer tans rekening gekies',0),(427691,11881,'ro','Nici o verificare de cont selectate',0),(427692,11881,'et','Ei ole valitud kontot',0),(427693,11881,'si','No preverjanje raÄuna izbrali',0),(427694,11881,'ba','No Rekening Giro dipilih',0),(427695,11881,'nl','Geen betaalrekening geselecteerd',0),(427696,11881,'fi','Ilman tarkkailun huomioon valittu',0),(427697,11881,'no','Ingen brukskonto valgt',0),(427698,11881,'da','Ingen checkkonto, valgt',0),(427699,11881,'ko','ì„ íƒ ì—†ìŒ ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(427700,11881,'he','××™×Ÿ ×—×©×‘×•×Ÿ ×‘× ×§ × ×‘×—×¨',0),(427701,11881,'el','Î”ÎµÎ½ Ï„ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î¿Ï… Î¸Î± ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯',0),(427702,11881,'zh','æ²¡æœ‰å·²é€‰çš„æ£€æŸ¥å¸æˆ·\r\n',0),(427703,11881,'sv','Ingen checkkonto valt',0),(427704,11881,'it','Nessun conto corrente selezionato',0),(427705,11881,'tl','',0),(427706,11881,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸šà¸±à¸à¸Šà¸µà¸à¸£à¸°à¹à¸ªà¸£à¸²à¸¢à¸§à¸±à¸™à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(427707,11881,'hi','à¤•à¥‹à¤ˆ à¤œà¤¾à¤à¤š à¤šà¤¯à¤¨à¤¿à¤¤ à¤–à¤¾à¤¤à¥‡',0),(427708,11881,'ms','Tidak memeriksa akaun yang dipilih',0),(427709,11881,'ar','Ù„Ø§ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(427710,11881,'fr','Aucun compte courant sÃ©lectionnÃ©',0),(427711,11881,'jp','é¸æŠžã›ãšå½“åº§é é‡‘å£åº§',0),(427712,11881,'pt','Nenhuma conta selecionada',0),(427713,11881,'ru','ÐÐµ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(427714,11881,'es','No Seleccionaste Un Cuenta Bancaria',0),(427715,11881,'de','Kein Girokonto ausgewÃ¤hlt',0),(427716,11881,'en','No Checking Account Selected',0),(427717,11882,'is','',0),(427718,11882,'dr','ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡',0),(427719,11882,'pr','ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡',0),(427720,11882,'tr','Ã–deme tarihi',0),(427721,11882,'pl','PÅ‚atnego Data',0),(427722,11882,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(427723,11882,'ur','ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(427724,11882,'sr','ÐŸÐ»Ð°Ñ›ÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(427725,11882,'vi','NgÃ y Ä‘Ã£ tráº£',0),(427726,11882,'af','Betaalde datum',0),(427727,11882,'ro','Data de plÄƒtit',0),(427728,11882,'et','Paide kuupÃ¤ev',0),(427729,11882,'si','Datum plaÄila',0),(427730,11882,'ba','Dibayar tanggal',0),(427731,11882,'nl','Betaalde datum',0),(427732,11882,'fi','Maksettu pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤nÃ¤',0),(427733,11882,'no','Betalt dato',0),(427734,11882,'da','Betalt dato',0),(427735,11882,'ko','ì§€ë¶ˆëœ ë‚ ì§œ',0),(427736,11882,'he','×ª××¨×™×š ×‘×ª×©×œ×•×',0),(427737,11882,'el','Î Î»Î·ÏÏ‰Î¼Î­Î½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(427738,11882,'zh','æ”¯ä»˜æ—¥æœŸ\r\n',0),(427739,11882,'sv','Betald Date',0),(427740,11882,'it','Data di pagamento',0),(427741,11882,'tl','',0),(427742,11882,'th','à¸§à¸±à¸™à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(427743,11882,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿',0),(427744,11882,'ms','Tarikh dibayar',0),(427745,11882,'ar','ØªØ§Ø±ÙŠØ® Ù…Ø¯ÙÙˆØ¹Ø© Ø§Ù„Ø£Ø¬Ø±',0),(427746,11882,'fr','PayÃ© Date',0),(427747,11882,'jp','æ”¯æ‰•ã„æ—¥ä»˜',0),(427748,11882,'pt','Data de pagamento',0),(427749,11882,'ru','ÐŸÐ»Ð°Ñ‚Ð½Ñ‹Ðµ Ð”Ð°Ñ‚Ð°',0),(427750,11882,'es','Fecha Pagada',0),(427751,11882,'de','Bezahlte Datum',0),(427752,11882,'en','Paid Date',0),(427753,11883,'is','',0),(427754,11883,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª ØªÙˆÙ„ÙŠØ¯ \r\n\r\n',0),(427755,11883,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª ØªÙˆÙ„ÙŠØ¯ \r\n\r\n',0),(427756,11883,'tr','PMS numarasÄ±',0),(427757,11883,'pl','Numer PMS',0),(427758,11883,'bg','ÐŸÐœÐ¡ Ð½Ð¾Ð¼ÐµÑ€',0),(427759,11883,'ur','ÙˆØ²Ø±Ø§Ø¦Û’ Ø§Ø¹Ø¸Ù… Ú©Ø§ Ù†Ù…Ø¨Ø±',0),(427760,11883,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐŸÐœÐ¡',0),(427761,11883,'vi','Sá»‘ PMS',0),(427762,11883,'af','PMS nommer',0),(427763,11883,'ro','NumÄƒr de PMS',0),(427764,11883,'et','PMS numbri',0),(427765,11883,'si','PMS Å¡tevilka',0),(427766,11883,'ba','PMS nomor',0),(427767,11883,'nl','PMS nummer',0),(427768,11883,'fi','PMS numero',0),(427769,11883,'no','PMS nummer',0),(427770,11883,'da','PMS antallet',0),(427771,11883,'ko','PMS ìˆ˜',0),(427772,11883,'he','×ž×—×–×•×¨ ×ž×¡×¤×¨',0),(427773,11883,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ PMS',0),(427774,11883,'zh','â€œå½©é€šé…è‰²ç³»ç»Ÿâ€œå¡å·\r\n',0),(427775,11883,'sv','PMS nummer',0),(427776,11883,'it','Numero di PMS',0),(427777,11883,'tl','',0),(427778,11883,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ PMS',0),(427779,11883,'hi','à¤ªà¥€à¤à¤®à¤à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(427780,11883,'ms','Nombor PMS',0),(427781,11883,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¯ÙˆØ±Ø© Ø§Ù„Ø´Ù‡Ø±ÙŠØ©',0),(427782,11883,'fr','Nombre de PMS',0),(427783,11883,'jp','PM ã®æ•°',0),(427784,11883,'pt','NÃºmero de PMS',0),(427785,11883,'ru','PMS Ð½Ð¾Ð¼ÐµÑ€',0),(427786,11883,'es','NÃºmero PMS',0),(427787,11883,'de','PMS-Anzahl',0),(427788,11883,'en','PMS Number',0),(427789,11884,'is','',0),(427790,11884,'dr','Ú†Ø§Ù¾ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¬Ø¯ÛŒØ¯Ø·Ø¨Ù‚ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ  ',0),(427791,11884,'pr','Ú†Ø§Ù¾ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¬Ø¯ÛŒØ¯Ø·Ø¨Ù‚ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ  ',0),(427792,11884,'tr','Teklif dayalÄ± yeni teklif yazdÄ±rma',0),(427793,11884,'pl','Drukowanie nowej oferty w oparciu o ofertÄ™',0),(427794,11884,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð¾Ð²Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(427795,11884,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù¾Ø± Ù…Ø¨Ù†ÛŒ Ù†ÛŒØ§ Ø§Ù‚ØªØ¨Ø§Ø³ Ú†Ú¾Ø§Ù¾ Ø±ÛØ§ ÛÛ’ Û”',0),(427796,11884,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð¾Ð²Ñƒ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(427797,11884,'vi','in bÃ¡o giÃ¡ má»›i Ä‘Æ°á»£c dá»±a trÃªn bÃ¡o giÃ¡',0),(427798,11884,'af','Druk nuwe kwotasie gebaseer op aanhaling',0),(427799,11884,'ro','Imprimarea citat nou bazat pe citat',0),(427800,11884,'et','Uus hinnapakkumise aluseks hinnapakkumise printimine',0),(427801,11884,'si','Tiskanje novo ponudbo, ki temelji na ponudbi',0),(427802,11884,'ba','Kutipan Percetakan baru berdasarkan kutipan',0),(427803,11884,'nl','Nieuwe offerte gebaseerd op offerte afdrukken',0),(427804,11884,'fi','Tarjouksen tulostaminen uusi tarjous',0),(427805,11884,'no','Utskrift nytt tilbud basert pÃ¥ tilbud',0),(427806,11884,'da','Udskrivning af nyt tilbud baseret pÃ¥ tilbud',0),(427807,11884,'ko','ìƒˆ ê²¬ì  ê²¬ì ì— ë”°ë¼ ì¸ì‡„',0),(427808,11884,'he','×”×“×¤×¡×ª ×”×¦×¢×ª ×ž×—×™×¨ ×—×“×©×” ×”×ž×‘×•×¡×¡×ª ×¢×œ ×”×¦×¢×ª ×ž×—×™×¨',0),(427809,11884,'el','ÎÎ­Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(427810,11884,'zh','åŸºäºŽæŠ¥ä»·æ‰“å°æ–°çš„æŠ¥ä»·\r\n',0),(427811,11884,'sv','Skriva ut ny offert baserat pÃ¥ offert',0),(427812,11884,'it','Stampa nuovo preventivo basato su preventivo',0),(427813,11884,'tl','',0),(427814,11884,'th','à¸žà¸´à¸¡à¸žà¹Œà¸•à¸²à¸¡à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹ƒà¸«à¸¡à¹ˆ',0),(427815,11884,'hi','à¤¨à¤¯à¤¾ à¤•à¥‹à¤Ÿ à¤•à¥‹à¤Ÿ à¤ªà¤° à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤®à¥à¤¦à¥à¤°à¤£',0),(427816,11884,'ms','Percetakan baru sebut harga berdasarkan sebut harga',0),(427817,11884,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¹Ø±Ø¶ Ø£Ø³Ø¹Ø§Ø± Ø¬Ø¯ÙŠØ¯ Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³ Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³',0),(427818,11884,'fr','Impression nouveau devis basÃ© sur devis',0),(427819,11884,'jp','è¦‹ç©ã‚‚ã‚Šã«åŸºã¥ã„ã¦æ–°ã—ã„è¦‹ç©ã‚‚ã‚Šã‚’å°åˆ·',0),(427820,11884,'pt','Nova citaÃ§Ã£o, com base na cotaÃ§Ã£o de impressÃ£o',0),(427821,11884,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ð¾Ð¹ ÐºÐ²Ð¾Ñ‚Ñ‹, Ð¾ÑÐ½Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð½Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(427822,11884,'es','Imprimiendo Nueva CotizaciÃ³n Basada Una CotizaciÃ³n',0),(427823,11884,'de','Neues Angebot auf der Grundlage von Angebot drucken',0),(427824,11884,'en','Printing New Quote Based On Quote',0),(427825,11885,'is','',0),(427826,11885,'dr','Ú†Ø§Ù¾ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¨Ø§ Ù…Ø´Ø®ØµØ§Øª ',0),(427827,11885,'pr','Ú†Ø§Ù¾ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¨Ø§ Ù…Ø´Ø®ØµØ§Øª ',0),(427828,11885,'tr','Ã–zellikleri ile baskÄ± fiyat teklifi',0),(427829,11885,'pl','Drukuj ofertÄ™ z specyfikacje',0),(427830,11885,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ñ Ð¾Ñ‡Ð¸Ð»Ð°',0),(427831,11885,'ur','Ú†Ø´Ù…ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù‚ØªØ¨Ø§Ø³ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(427832,11885,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ ÑÐ° ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ð°Ð¼Ð°',0),(427833,11885,'vi','in bÃ¡o giÃ¡',0),(427834,11885,'af','Aanhaling met Specs druk',0),(427835,11885,'ro','Imprimarea citat cu Specificatii',0),(427836,11885,'et','Prindi pakkumine on andmed',0),(427837,11885,'si','Natisniti, citat z oÄala',0),(427838,11885,'ba','Mencetak kutipan dengan spesifikasi',0),(427839,11885,'nl','Offerte met Specs afdrukt',0),(427840,11885,'fi','Tulosta tarjous silmÃ¤lasit',0),(427841,11885,'no','Skrive ut tilbud med spesifikasjoner',0),(427842,11885,'da','Udskrive tilbud med Specs',0),(427843,11885,'ko','ì¸ì‡„ ì‚¬ì–‘ ê²¬ì ',0),(427844,11885,'he','×”×“×¤×¡ ×”×¦×¢×ª ×ž×—×™×¨ ×¢× ×ž×¤×¨×˜',0),(427845,11885,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚ Î¼Îµ Specs',0),(427846,11885,'zh','æ‰“å°æœ‰è§„æ ¼çš„æŠ¥ä»·\r\n',0),(427847,11885,'sv','Skriv ut offert med specifikationer',0),(427848,11885,'it','Stampa preventivo con specifiche',0),(427849,11885,'tl','',0),(427850,11885,'th','à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸žà¸£à¹‰à¸­à¸¡à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”',0),(427851,11885,'hi','à¤šà¤¶à¥à¤®à¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¥‹à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(427852,11885,'ms','Sebut harga cetakan dengan ciri-ciri komputer',0),(427853,11885,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ù…Ø¹ Ø§Ù„Ù…ÙˆØ§ØµÙØ§Øª',0),(427854,11885,'fr','Imprimer le devis avec fiche',0),(427855,11885,'jp','è¦‹ç©ã‚‚ã‚Šã®ã‚¹ãƒšãƒƒã‚¯ã‚’æŒã¤å°åˆ·ã—ã¾ã™ã€‚',0),(427856,11885,'pt','Imprimir cotaÃ§Ã£o com especificaÃ§Ãµes',0),(427857,11885,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° Ñ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(427858,11885,'es','Imprime CotizaciÃ³n Con Especificaciones',0),(427859,11885,'de','Angebot mit Angaben zu drucken',0),(427860,11885,'en','Print Quote With Specs',0),(427861,11886,'is','',0),(427862,11886,'dr','Ù„ÛŒÙ†Ú© Ø³Ø±ÛŒØ¹',0),(427863,11886,'pr','Ù„ÛŒÙ†Ú© Ø³Ø±ÛŒØ¹',0),(427864,11886,'tr','HÄ±zlÄ± baÄŸlantÄ±larÄ±',0),(427865,11886,'pl','Szybkie linki',0),(427866,11886,'bg','Ð‘ÑŠÑ€Ð·Ð¸ Ð²Ñ€ÑŠÐ·ÐºÐ¸',0),(427867,11886,'ur','Ù†ÛŒÙˆ ÛŒÚ¯ÛŒØ´Ù†',0),(427868,11886,'sr','Ð‘Ñ€Ð·Ð¸ Ð»Ð¸Ð½ÐºÐ¾Ð²Ð¸',0),(427869,11886,'vi','Ä‘Æ°á»ng dáº«n nhanh',0),(427870,11886,'af','Vinnige skakels',0),(427871,11886,'ro','LegÄƒturi rapide',0),(427872,11886,'et','Kiirlingid...',0),(427873,11886,'si','Hitre povezave',0),(427874,11886,'ba','Link cepat',0),(427875,11886,'nl','Snelle Links',0),(427876,11886,'fi','Pikalinkit',0),(427877,11886,'no','Hurtigkoblinger',0),(427878,11886,'da','Quick Links',0),(427879,11886,'ko','ë¹ ë¥¸ ë§í¬',0),(427880,11886,'he','×§×™×©×•×¨×™× ×ž×”×™×¨×™×',0),(427881,11886,'el','Î“ÏÎ®Î³Î¿ÏÎµÏ‚ ÏƒÏ…Î½Î´Î­ÏƒÎµÎ¹Ï‚',0),(427882,11886,'zh','å¿«é€Ÿé“¾æŽ¥\r\n',0),(427883,11886,'sv','SnabblÃ¤nkar',0),(427884,11886,'it','Collegamenti rapidi',0),(427885,11886,'tl','',0),(427886,11886,'th','à¸¥à¸´à¸‡à¸„à¹Œà¸”à¹ˆà¸§à¸™',0),(427887,11886,'hi','à¤¤à¥à¤µà¤°à¤¿à¤¤ à¤²à¤¿à¤‚à¤•',0),(427888,11886,'ms','Pautan Pantas',0),(427889,11886,'ar','Ø§Ø±ØªØ¨Ø§Ø·Ø§Øª Ø³Ø±ÙŠØ¹Ø©',0),(427890,11886,'fr','Liens rapides',0),(427891,11886,'jp','ã‚¯ã‚¤ãƒƒã‚¯ ãƒªãƒ³ã‚¯',0),(427892,11886,'pt','Links rÃ¡pidos',0),(427893,11886,'ru','Ð‘Ñ‹ÑÑ‚Ñ€Ñ‹Ðµ ÑÑÑ‹Ð»ÐºÐ¸',0),(427894,11886,'es','Conexiones Rapidas',0),(427895,11886,'de','Quick-Links',0),(427896,11886,'en','Quick Links',0),(427897,11887,'is','',0),(427898,11887,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÛŒØ¯',0),(427899,11887,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÛŒØ¯',0),(427900,11887,'tr','Son sipariÅŸler',0),(427901,11887,'pl','Ostatnie zamÃ³wienia',0),(427902,11887,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(427903,11887,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(427904,11887,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(427905,11887,'vi','cÃ¡c Ä‘Æ¡n hÃ ng gáº§n Ä‘Ã¢y',0),(427906,11887,'af','Onlangse bestellings',0),(427907,11887,'ro','Ultimele comenzi',0),(427908,11887,'et','Tehtud tellimused',0),(427909,11887,'si','Nedavna naroÄila',0),(427910,11887,'ba','Pesanan terakhir',0),(427911,11887,'nl','Recente bestellingen',0),(427912,11887,'fi','Tilauksista',0),(427913,11887,'no','Siste ordrer',0),(427914,11887,'da','De seneste ordrer',0),(427915,11887,'ko','ìµœê·¼ ì£¼ë¬¸',0),(427916,11887,'he','×”×”×•×¨××•×ª ×”××—×¨×•× ×•×ª',0),(427917,11887,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(427918,11887,'zh','æœ€è¿‘çš„è®¢å•\r\n',0),(427919,11887,'sv','Senaste order',0),(427920,11887,'it','Ordini recenti',0),(427921,11887,'tl','',0),(427922,11887,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(427923,11887,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤•à¥‡ à¤‘à¤°à¥à¤¡à¤°',0),(427924,11887,'ms','Perintah-perintah hari',0),(427925,11887,'ar','Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(427926,11887,'fr','Ordonnances rÃ©centes',0),(427927,11887,'jp','æœ€è¿‘ã®å—æ³¨',0),(427928,11887,'pt','Ordens recentes',0),(427929,11887,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(427930,11887,'es','Ordenes Recientes',0),(427931,11887,'de','Letzten Bestellungen',0),(427932,11887,'en','Recent Orders',0),(427933,11888,'is','',0),(427934,11888,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø§Ø®ÛŒØ±',0),(427935,11888,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø§Ø®ÛŒØ±',0),(427936,11888,'tr','Son sevk irsaliyesi',0),(427937,11888,'pl','Ostatnich wydaÅ„',0),(427938,11888,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(427939,11888,'ur','Ø­Ø§Ù„ÛŒÛ ØªØ±Ø³ÛŒÙ„',0),(427940,11888,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(427941,11888,'vi','váº­n chuyá»ƒn gáº§n Ä‘Ã¢y',0),(427942,11888,'af','Onlangse gestuur',0),(427943,11888,'ro','ExpediÅ£iile recente',0),(427944,11888,'et','Tehtud veod',0),(427945,11888,'si','Nedavni poÅ¡iljk',0),(427946,11888,'ba','Hari pengiriman',0),(427947,11888,'nl','Recente zendingen',0),(427948,11888,'fi','Viime lÃ¤hetykset',0),(427949,11888,'no','Siste forsendelser',0),(427950,11888,'da','De senere leverancer',0),(427951,11888,'ko','ìµœê·¼ ì¶œí•˜ ëŸ‰',0),(427952,11888,'he','×”×ž×©×œ×•×—×™× ×”××—×¨×•× ×™×',0),(427953,11888,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(427954,11888,'zh','æœ€è¿‘çš„å‡ºè´§é‡\r\n',0),(427955,11888,'sv','Senaste leveranser',0),(427956,11888,'it','Spedizioni recenti',0),(427957,11888,'tl','',0),(427958,11888,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(427959,11888,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤²à¤¦à¤¾à¤¨',0),(427960,11888,'ms','Hari penghantaran',0),(427961,11888,'ar','Ø§Ù„Ø´Ø­Ù†Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(427962,11888,'fr','ExpÃ©ditions rÃ©centes',0),(427963,11888,'jp','æœ€è¿‘ã®å‡ºè·çŠ¶æ³',0),(427964,11888,'pt','Envios recentes',0),(427965,11888,'ru','Ð‘Ñ€Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð³Ñ€ÑƒÐ·Ð¾Ð²',0),(427966,11888,'es','EnmvÃ­os Recientes',0),(427967,11888,'de','Aktuelle Sendungen',0),(427968,11888,'en','Recent Shipments',0),(427969,11889,'is','',0),(427970,11889,'dr','(Ù‡Ø²ÛŒÙ†Ù‡ ) Ù†Ø§Ú¯Ù‡Ø§Ù†ÛŒ',0),(427971,11889,'pr','Ø´Ø§Ø±Ú˜(Ù‡Ø²ÛŒÙ†Ù‡ ) Ù†Ø§Ú¯Ù‡Ø§Ù†ÛŒ',0),(427972,11889,'tr','Rush ÅŸarj',0),(427973,11889,'pl','PÄ™d za',0),(427974,11889,'bg','Rush Ñ‚Ð°ÐºÑÐ°',0),(427975,11889,'ur','Ø±Ø´ Ú†Ø§Ø±Ø¬',0),(427976,11889,'sr','Ð¥Ð¸Ñ‚Ð½Ð¾ Ð¿ÑƒÑšÐµÑšÐµ',0),(427977,11889,'vi','PhÃ­ vá»™i',0),(427978,11889,'af','Stormloop las',0),(427979,11889,'ro','Taxa de Rush',0),(427980,11889,'et','Rush Tasuta',0),(427981,11889,'si','Rush dajatev',0),(427982,11889,'ba','Biaya Rush',0),(427983,11889,'nl','Rush gratis',0),(427984,11889,'fi','Rush ilmaiseksi',0),(427985,11889,'no','Rush kostnad',0),(427986,11889,'da','Rush afgift',0),(427987,11889,'ko','ëŸ¬ì‰¬ ì „',0),(427988,11889,'he','×”×¢×•×ž×¡ ×ª×©×œ×•×',0),(427989,11889,'el','Î’Î¹Î±ÏƒÏÎ½Î· Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(427990,11889,'zh','å¿™æ—¶è´¹ç”¨\r\n',0),(427991,11889,'sv','Rush avgift',0),(427992,11889,'it','Carica di Rush',0),(427993,11889,'tl','',0),(427994,11889,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹€à¸£à¹ˆà¸‡à¸”à¹ˆà¸§à¸™',0),(427995,11889,'hi','à¤°à¤¶ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(427996,11889,'ms','Caj tergesa-gesa',0),(427997,11889,'ar','ØªÙ‡Ù…Ø© Ø§Ù„Ø§Ù†Ø¯ÙØ§Ø¹',0),(427998,11889,'fr','Charge de Rush',0),(427999,11889,'jp','ãƒ©ãƒƒã‚·ãƒ¥æ–™é‡‘',0),(428000,11889,'pt','Carga de Rush',0),(428001,11889,'ru','Ð Ð°Ñˆ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(428002,11889,'es','Cargos por Entrega Rapida',0),(428003,11889,'de','Rush kostenlos',0),(428004,11889,'en','Rush Charge',0),(428005,11890,'is','',0),(428006,11890,'dr','Ù†Ù…Ø§ÛŒØ´ Ø´Ù†Ø§Ø³Ù‡ Ù‡Ø§ÛŒÛŒ Ú©Ù‡ Ø¨Ù‡ Ø·ÙˆØ±Ø§ØªÙˆÙ…Ø§ØªÛŒÚ© Ù¾Ø± Ù…ÛŒ Ø´ÙˆÙ†Ø¯ ',0),(428007,11890,'pr','Ù†Ù…Ø§ÛŒØ´ Ø´Ù†Ø§Ø³Ù‡ Ù‡Ø§ÛŒÛŒ Ú©Ù‡ Ø¨Ù‡ Ø·ÙˆØ±Ø§ØªÙˆÙ…Ø§ØªÛŒÚ© Ù¾Ø± Ù…ÛŒ Ø´ÙˆÙ†Ø¯ ',0),(428008,11890,'tr','Auto tam kimlikleri gÃ¶ster',0),(428009,11890,'pl','PokaÅ¼ Auto peÅ‚ne identyfikatory',0),(428010,11890,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð°Ð²Ñ‚Ð¾Ð¼Ð¾Ð±Ð¸Ð» Ð¿ÑŠÐ»ÐµÐ½ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð¸',0),(428011,11890,'ur','Ø®ÙˆØ¯ Ù…Ú©Ù…Ù„ Ø´Ù†Ø§Ø®Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(428012,11890,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐÑƒÑ‚Ð¾ Ñ˜Ðµ ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½ Ð˜Ð”-Ð¾Ð²Ð°',0),(428013,11890,'vi','Hiá»ƒn thá»‹ IDS hoÃ n toÃ n tá»± Ä‘á»™ng',0),(428014,11890,'af','Wys Outo voltooi ID\'s',0),(428015,11890,'ro','AratÄƒ Auto complet ID-uri',0),(428016,11890,'et','Kuva Auto tÃ¤ielik ID-d',0),(428017,11890,'si','PrikaÅ¾i popoln ID Auto',0),(428018,11890,'ba','Menunjukkan Auto lengkap id',0),(428019,11890,'nl','Auto volledige-id\'s weergeven',0),(428020,11890,'fi','NÃ¤ytÃ¤ automaattinen tÃ¤ydellinen tunnukset',0),(428021,11890,'no','Vis Auto komplett IDer',0),(428022,11890,'da','Vis Auto komplet-id\'er',0),(428023,11890,'ko','ìžë™ ì™„ì „ í•œ Id í‘œì‹œ',0),(428024,11890,'he','×”×¦×’ ××•×˜×•×ž×˜×™×ª ×ž×œ××” ×ª×¢×•×“×•×ª ×–×”×•×ª',0),(428025,11890,'el','Î”ÎµÎ¯Ï‡Î½Î¿Ï…Î½ Ï€Î»Î®ÏÎ· Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬ Auto',0),(428026,11890,'zh','æ˜¾ç¤ºè‡ªåŠ¨å®Œæˆè¯†åˆ«ç æ¡†\r\n',0),(428027,11890,'sv','Visa Auto komplett ID',0),(428028,11890,'it','Visualizza Auto completa IDs',0),(428029,11890,'tl','',0),(428030,11890,'th','à¹à¸ªà¸”à¸‡à¸£à¸«à¸±à¸ªà¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œà¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(428031,11890,'hi','à¤‘à¤Ÿà¥‹ à¤ªà¥‚à¤°à¤¾ IDs à¤¦à¤¿à¤–à¤¾à¤à¤',0),(428032,11890,'ms','Menunjukkan ID lengkap Auto',0),(428033,11890,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù…Ø¹Ø±ÙØ§Øª Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª ÙƒØ§Ù…Ù„Ø©',0),(428034,11890,'fr','Voir l\'Ã©tablissement Auto ID complet',0),(428035,11890,'jp','è‡ªå‹•å®Œå…¨ãª Id ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(428036,11890,'pt','Mostrar Auto completa IDs',0),(428037,11890,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ð¾Ð»Ð½Ñ‹Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ñ‹ Ð°Ð²Ñ‚Ð¾',0),(428038,11890,'es','Muestar IDs de Auto Completar',0),(428039,11890,'de','Auto-Complete-IDs anzeigen',0),(428040,11890,'en','Show Auto Complete IDs',0),(428041,11891,'is','',0),(428042,11891,'dr','Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(428043,11891,'pr','Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(428044,11891,'tr','Vergiye tabi tutar',0),(428045,11891,'pl','Kwota podlegajÄ…ca opodatkowaniu',0),(428046,11891,'bg','ÐžÐ±Ð»Ð°Ð³Ð°ÐµÐ¼Ð° ÑÑƒÐ¼Ð°',0),(428047,11891,'ur','Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ Ø±Ù‚Ù…',0),(428048,11891,'sr','ÐžÐ¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(428049,11891,'vi','Sá»‘ tiá»n chá»‹u thuáº¿',0),(428050,11891,'af','Belasbare bedrag',0),(428051,11891,'ro','Suma impozabilÄƒ',0),(428052,11891,'et','Maksustatav summa',0),(428053,11891,'si','DavÄna osnova',0),(428054,11891,'ba','Jumlah pajak',0),(428055,11891,'nl','Maatstaf van heffing',0),(428056,11891,'fi','Veron peruste',0),(428057,11891,'no','Avgiftspliktig belÃ¸p',0),(428058,11891,'da','Beskatningsgrundlaget',0),(428059,11891,'ko','ê³¼ì„¸ ëŒ€ìƒ ê¸ˆì•¡',0),(428060,11891,'he','×¡×›×•× ×—×™×™×‘ ×‘×ž×¡',0),(428061,11891,'el','Î’Î¬ÏƒÎ· ÎµÏ€Î¹Î²Î¿Î»Î®Ï‚ Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï…',0),(428062,11891,'zh','åº”çº³ç¨Žé¢\r\n',0),(428063,11891,'sv','Beskattningsunderlaget',0),(428064,11891,'it','Base imponibile',0),(428065,11891,'tl','',0),(428066,11891,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µ',0),(428067,11891,'hi','à¤•à¤° à¤¯à¥‹à¤—à¥ à¤¯ à¤°à¤¾à¤¶à¤¿',0),(428068,11891,'ms','Jumlah yang boleh dikenakan cukai',0),(428069,11891,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(428070,11891,'fr','Montant imposable',0),(428071,11891,'jp','èª²ç¨Žé¡',0),(428072,11891,'pt','Valor tributÃ¡vel',0),(428073,11891,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(428074,11891,'es','Cantidad Imponible',0),(428075,11891,'de','Besteuerungsgrundlage',0),(428076,11891,'en','Taxable Amount',0),(428077,11892,'is','',0),(428078,11892,'dr','  Ø§Ø¯Ø§Ù…Ù‡ ØªÙˆØ¶ÛŒØ­ Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø§Ø³Øª ',0),(428079,11892,'pr','  Ø§Ø¯Ø§Ù…Ù‡ ØªÙˆØ¶ÛŒØ­ Ø³ÙØ§Ø±Ø´ Ø´Ù…Ø§ Ø§Ø³Øª ',0),(428080,11892,'tr','SipariÅŸ aÃ§Ä±klamasÄ± aÅŸaÄŸÄ±dadÄ±r',0),(428081,11892,'pl','PoniÅ¼ej znajduje siÄ™ opis zamÃ³wienia',0),(428082,11892,'bg','ÐŸÐ¾-Ð´Ð¾Ð»Ñƒ Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(428083,11892,'ur','Ø¢Ù¾ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ ØªÙØµÛŒÙ„ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ ÛÛ’',0),(428084,11892,'sr','Ð¡Ð»ÐµÐ´Ð¸ Ð¾Ð¿Ð¸Ñ Ð²Ð°ÑˆÐµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(428085,11892,'vi','sau Ä‘Ã¢y lÃ  mÃ´ táº£ cho Ä‘Æ¡n hÃ ng cá»§a báº¡n',0),(428086,11892,'af','Die volgende Is \'n beskrywing van jou bestelling',0),(428087,11892,'ro','Aceasta este o descriere a comenzii',0),(428088,11892,'et','JÃ¤rgnev on kirjeldus tellimuse',0),(428089,11892,'si','Spodaj je opis vaÅ¡ega naroÄila',0),(428090,11892,'ba','Berikut adalah deskripsi dari pesanan Anda',0),(428091,11892,'nl','Hieronder volgt een beschrijving van uw bestelling',0),(428092,11892,'fi','Seuraavassa on kuvaus tilauksesi',0),(428093,11892,'no','FÃ¸lgende er en beskrivelse av bestillingen',0),(428094,11892,'da','FÃ¸lgende er en beskrivelse af din ordre',0),(428095,11892,'ko','ë‹¤ìŒì€ ê·€í•˜ì˜ ì£¼ë¬¸ì— ëŒ€ í•œ ì„¤ëª…',0),(428096,11892,'he','×œ×¤× ×™×›× ×ª×™××•×¨ ×©×œ ×”×”×–×ž× ×” ×©×œ×š',0),(428097,11892,'el','Î¤Î¿ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ ÎµÎ¯Î½Î±Î¹ Î¼Î¹Î± Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏƒÎ±Ï‚',0),(428098,11892,'zh','ä»¥ä¸‹æ˜¯æ‚¨çš„è®¢å•ä»‹ç»\r\n',0),(428099,11892,'sv','FÃ¶ljande Ã¤r en beskrivning av din bestÃ¤llning',0),(428100,11892,'it','Di seguito Ã¨ una descrizione del tuo ordine',0),(428101,11892,'tl','',0),(428102,11892,'th','à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¹€à¸›à¹‡à¸™à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(428103,11892,'hi','à¤†à¤ªà¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤µà¤°à¥à¤£à¤¨ à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤¹à¥ˆ',0),(428104,11892,'ms','Berikut adalah penerangan tentang pesanan anda',0),(428105,11892,'ar','Ù…Ø§ ÙŠÙ„ÙŠ Ù‡Ùˆ ÙˆØµÙ Ù„Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(428106,11892,'fr','Ce qui suit est une Description de votre commande',0),(428107,11892,'jp','æ¬¡ã«ã€ã‚ãªãŸã®é †åºã®èª¬æ˜Ž',0),(428108,11892,'pt','A seguir estÃ¡ uma descriÃ§Ã£o de sua ordem',0),(428109,11892,'ru','ÐÐ¸Ð¶Ðµ Ð¿Ñ€Ð¸Ð²Ð¾Ð´Ð¸Ñ‚ÑÑ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð²Ð°ÑˆÐµÐ³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(428110,11892,'es','El Siguente Es Una DescripciÃ³n de Su Orden',0),(428111,11892,'de','Im folgenden finden Sie eine Beschreibung Ihres Auftrages',0),(428112,11892,'en','The Following Is A Description Of Your Order',0),(428113,11893,'is','',0),(428114,11893,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙØ±Ø§ÛŒÙ†Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯Ø§Ú¯Ø± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† Ù¾ÙˆÙ„ Ø±Ø§ÛŒØ¬ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ù…ÛŒ Ú©Ù†Ø¯',0),(428115,11893,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ÙØ±Ø§ÛŒÙ†Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯Ø§Ú¯Ø± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† Ù¾ÙˆÙ„ Ø±Ø§ÛŒØ¬ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ù…ÛŒ Ú©Ù†Ø¯',0),(428116,11893,'tr','PO iÅŸlemi kullanÄ±n para birimi kullanarak deÄŸil satÄ±cÄ±',0),(428117,11893,'pl','UÅ¼yj PO procesie, jeÅ›li sprzedawca nie walucie',0),(428118,11893,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ PO Ð¿Ñ€Ð¾Ñ†ÐµÑ, Ð°ÐºÐ¾ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð½Ðµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(428119,11893,'ur','ØªÙˆ Ù¾Ùˆ Ø¹Ù…Ù„ Ø§Ø³ØªØ¹Ù…Ø§Ù„ ÙˆÛŒÙ†ÚˆØ± Ú©Ø±Ù†Ø³ÛŒ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†ÛÛŒÚº',0),(428120,11893,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÐŸÐž Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð°ÐºÐ¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð½Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð²Ð°Ð»ÑƒÑ‚Ñƒ',0),(428121,11893,'vi','Sá»­ dá»¥ng quy trÃ¬nh cá»§a PO náº¿u nhÃ  cung cáº¥p khÃ´ng sá»­ dá»¥ng tiá»n tá»‡',0),(428122,11893,'af','Posbus proses gebruik as handelaar nie geldeenheid gebruik',0),(428123,11893,'ro','UtilizaÅ£i PO procesul dacÄƒ vÃ¢nzÄƒtorul nu folosesc moneda',0),(428124,11893,'et','Kasutage PO protsess, kui mÃ¼Ã¼ja ei kasuta Valuutavahetus',0),(428125,11893,'si','Uporabite PO procesu, Äe prodajalec ne uporabljajo valuto',0),(428126,11893,'ba','Menggunakan proses PO jika Vendor tidak menggunakan mata uang',0),(428127,11893,'nl','PO proces gebruiken als leverancier niet met behulp van valuta',0),(428128,11893,'fi','KÃ¤ytÃ¤ PO prosessi, jos toimittajan eivÃ¤t rahassa',0),(428129,11893,'no','Bruk PO prosessen hvis leverandÃ¸ren ikke bruker valuta',0),(428130,11893,'da','Bruge PO proces, hvis kreditor ikke ved hjÃ¦lp af valuta',0),(428131,11893,'ko','ë§Œì•½ PO í”„ë¡œì„¸ìŠ¤ë¥¼ ì‚¬ìš© í•˜ ì—¬ í†µí™”ë¥¼ ì‚¬ìš© í•˜ì§€ ì•ŠëŠ” ê³µê¸‰ ì—…ì²´',0),(428132,11893,'he','×œ×”×©×ª×ž×© ×‘×ª×”×œ×™×š ×¤×• ×× ×”×¡×¤×§ ×œ× ×‘××ž×¦×¢×•×ª ×ž×˜×‘×¢',0),(428133,11893,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Î½Î¬ Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Î±Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï€Î¿Ï… Î´ÎµÎ½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½ Ï„Î¿ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(428134,11893,'zh','å¦‚æžœå–æ–¹ä¸ä½¿ç”¨è´§å¸ï¼Œä½¿ç”¨è®¢å•è¿‡ç¨‹\r\n',0),(428135,11893,'sv','AnvÃ¤nda PO processen om leverantÃ¶ren inte anvÃ¤nder valuta',0),(428136,11893,'it','Utilizzare il processo di PO se fornitore non utilizza la moneta',0),(428137,11893,'tl','',0),(428138,11893,'th','à¹ƒà¸Šà¹‰à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£ PO à¸–à¹‰à¸²à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¹„à¸”à¹‰à¹ƒà¸Šà¹‰à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™',0),(428139,11893,'hi','à¤ªà¥‹ à¤•à¥€ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚ à¤¯à¤¦à¤¿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤®à¥à¤¦à¥à¤°à¤¾ à¤•à¤¾ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤¨à¤¹à¥€à¤‚',0),(428140,11893,'ms','Menggunakan proses PO jika penjual yang tidak menggunakan Mata Wang',0),(428141,11893,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¹Ù…Ù„ÙŠØ© Ø¨Ùˆ Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ù„Ø§ ØªØ³ØªØ®Ø¯Ù… Ø§Ù„Ø¹Ù…Ù„Ø©',0),(428142,11893,'fr','Utiliser des processus PO si vendeur N\'utilisent pas devise',0),(428143,11893,'jp','å ´åˆã€PO ãƒ—ãƒ­ã‚»ã‚¹ã‚’ä½¿ç”¨ã—ã¦é€šè²¨ã‚’ä½¿ç”¨ã—ã¦ã„ãªã„ãƒ™ãƒ³ãƒ€ãƒ¼',0),(428144,11893,'pt','Use o processo PO se fornecedor nÃ£o usando a moeda',0),(428145,11893,'ru','Ð•ÑÐ»Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ PO Ð¿Ñ€Ð¾Ñ†ÐµÑÑ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°, Ð½Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑ Ð²Ð°Ð»ÑŽÑ‚Ñ‹',0),(428146,11893,'es','Usa OC Proceso Si el Proveedor no Usa la Moneda Actual',0),(428147,11893,'de','PO-Vorgang verwenden, wenn VerkÃ¤ufer nicht mit WÃ¤hrung',0),(428148,11893,'en','Use PO Process If Vendor Not Using Currency',0),(428149,11894,'is','',0),(428150,11894,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØªÙ…Ø§Ù… Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒÛŒ Ù‡Ø§',0),(428151,11894,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØªÙ…Ø§Ù… Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒÛŒ Ù‡Ø§',0),(428152,11894,'tr','TÃ¼m ipuÃ§larÄ±na bakÄ±n',0),(428153,11894,'pl','Zobacz wszystkie porady',0),(428154,11894,'bg','Ð’Ð¸Ð¶Ñ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑÑŠÐ²ÐµÑ‚Ð¸',0),(428155,11894,'ur','Ø³Ø¨ Ù¹ÙˆÙ¹Ú©Û’ Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(428156,11894,'sr','Ð’Ð¸Ð´Ð¸Ð¼ ÑÐ²Ðµ ÑÐ°Ð²Ñ˜ÐµÑ‚Ðµ',0),(428157,11894,'vi','Xem táº¥t cáº£ cÃ¡c lá»i khuyÃªn',0),(428158,11894,'af','Sien Alle Wenke',0),(428159,11894,'ro','Vedea toate sfaturi',0),(428160,11894,'et','Vaata kÃµiki nÃ¤punÃ¤iteid',0),(428161,11894,'si','Oglejte si vse namige',0),(428162,11894,'ba','Lihat semua Tips',0),(428163,11894,'nl','Zie alle Tips',0),(428164,11894,'fi','Katso kaikki vinkit',0),(428165,11894,'no','Se alle Tips',0),(428166,11894,'da','Se alle Tips',0),(428167,11894,'ko','ëª¨ë“  íŒì„ ì°¸ì¡°',0),(428168,11894,'he','×œ×¨××•×ª ××ª ×›×œ ×”×˜×™×¤×™×',0),(428169,11894,'el','Î”ÎµÎ¯Ï„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÏƒÏ…Î¼Î²Î¿Ï…Î»Î­Ï‚',0),(428170,11894,'zh','æŸ¥çœ‹å…¨éƒ¨æç¤º\r\n',0),(428171,11894,'sv','Se alla Tips',0),(428172,11894,'it','Vedi tutti i suggerimenti',0),(428173,11894,'tl','',0),(428174,11894,'th','à¸”à¸¹à¹€à¸„à¸¥à¹‡à¸”à¸¥à¸±à¸šà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(428175,11894,'hi','à¤¸à¤­à¥€ à¤¯à¥à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤ à¤¦à¥‡à¤–à¥‡à¤‚',0),(428176,11894,'ms','Lihat semua Petua',0),(428177,11894,'ar','Ø§Ù†Ø¸Ø± Ù†ØµØ§Ø¦Ø­ Ø¬Ù…ÙŠØ¹',0),(428178,11894,'fr','Voir tous les conseils',0),(428179,11894,'jp','ã™ã¹ã¦ã®ãƒ’ãƒ³ãƒˆã‚’å‚ç…§ã—ã¦ãã ã•ã„ã€‚',0),(428180,11894,'pt','Ver todas as dicas',0),(428181,11894,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð²ÑÐµ ÑÐ¾Ð²ÐµÑ‚Ñ‹',0),(428182,11894,'es','Visionar Todas las Propinas',0),(428183,11894,'de','Alle Tipps zu sehen',0),(428184,11894,'en','See All Tips',0),(428185,11895,'is','',0),(428186,11895,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØªÙ…Ø§Ù… Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¨Ø±Ø§ÛŒ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ú©',0),(428187,11895,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØªÙ…Ø§Ù… Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¨Ø±Ø§ÛŒ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ú©',0),(428188,11895,'tr','Banka mevduat iÃ§in tÃ¼m hareketleri gÃ¶rÃ¼ntÃ¼leyin',0),(428189,11895,'pl','Zobacz wszystkie transakcje banku depozytowego',0),(428190,11895,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð·Ð° Ð±Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(428191,11895,'ur','Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ Ú©Û’ Ù„Ø¦Û’ ØªÙ…Ø§Ù… Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’',0),(428192,11895,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÑÐ²Ð¸Ñ… Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ð·Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(428193,11895,'vi','Xem táº¥t cáº£ cÃ¡c giao dá»‹ch cho tiá»n gá»­i NgÃ¢n hÃ ng ',0),(428194,11895,'af','Besigtig Alle Transaksies vir Bank Deposito',0),(428195,11895,'ro','Vezi toate tranzacÅ£iile pentru depozit bancar',0),(428196,11895,'et','Saate vaadata kÃµiki kandeid pangahoiuste',0),(428197,11895,'si','Poglej si vse transakcije za banÄni depozit',0),(428198,11895,'ba','Lihat semua transaksi untuk deposito Bank',0),(428199,11895,'nl','Alle transacties voor bankstorting weergeven',0),(428200,11895,'fi','Tarkastele kaikkia tapahtumia Bank Deposit',0),(428201,11895,'no','Vis alle transaksjonene for bankinnskudd',0),(428202,11895,'da','Se alle posteringer for Bank depositum',0),(428203,11895,'ko','ì€í–‰ ì˜ˆê¸ˆì— ëŒ€ í•œ ëª¨ë“  íŠ¸ëžœìž­ì…˜ì„ ë³´ë ¤ë©´',0),(428204,11895,'he','×”×¦×’ ××ª ×›×œ ×”×ª× ×•×¢×•×ª ×¢×‘×•×¨ ×¤×™×§×“×•×Ÿ ×”×‘× ×§',0),(428205,11895,'el','Î”ÎµÎ¯Ï„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ Î³Î¹Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÎµ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(428206,11895,'zh','æŸ¥çœ‹æœ‰å…³é“¶è¡Œå­˜æ¬¾çš„æ‰€æœ‰äº¤æ˜“\r\n',0),(428207,11895,'sv','Visa alla transaktioner fÃ¶r bankinsÃ¤ttning',0),(428208,11895,'it','Mostra tutte le transazioni di deposito bancario',0),(428209,11895,'tl','',0),(428210,11895,'th','à¸”à¸¹à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¹€à¸‡à¸´à¸™à¸à¸²à¸à¸˜à¸™à¸²à¸„à¸²à¸£',0),(428211,11895,'hi','à¤¸à¤­à¥€ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¥‡à¤–à¥‡à¤‚',0),(428212,11895,'ms','Lihat semua urus niaga bagi Bank Deposit',0),(428213,11895,'ar','Ø¹Ø±Ø¶ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù„Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(428214,11895,'fr','Afficher toutes les Transactions pour dÃ©pÃ´t bancaire',0),(428215,11895,'jp','éŠ€è¡Œé é‡‘ã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã‚’ã™ã¹ã¦è¡¨ç¤ºã—ã¾ã™ã€‚',0),(428216,11895,'pt','Visualizar todas as transaÃ§Ãµes para depÃ³sito bancÃ¡rio',0),(428217,11895,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð²ÑÐµÑ… Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¹ Ð´Ð»Ñ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ Ð²ÐºÐ»Ð°Ð´Ð°',0),(428218,11895,'es','Visionar Todas Las Transacciones Para DepÃ³sitos Bancarios',0),(428219,11895,'de','Zeigen Sie aller Transaktionen fÃ¼r Ãœberweisungen an',0),(428220,11895,'en','View All Transactions for Bank Deposit',0),(428221,11896,'is','',0),(428222,11896,'dr','Ù…Ø´ØªØ±ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(428223,11896,'pr','Ù…Ø´ØªØ±ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(428224,11896,'tr','GÃ¶rÃ¼nÃ¼m mÃ¼ÅŸteri',0),(428225,11896,'pl','Widok klienta',0),(428226,11896,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(428227,11896,'ur','Ù…Ù†Ø¸Ø± Ú¯Ø§ÛÚ©',0),(428228,11896,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÐºÑƒÐ¿Ñ†Ð°',0),(428229,11896,'vi','Xem khÃ¡ch hÃ ng',0),(428230,11896,'af','Bekyk kliÃ«nt',0),(428231,11896,'ro','Vezi client',0),(428232,11896,'et','Vaata kliendi',0),(428233,11896,'si','Pogled stranke',0),(428234,11896,'ba','Lihat pelanggan',0),(428235,11896,'nl','View Customer',0),(428236,11896,'fi','NÃ¤ytÃ¤ asiakkaan',0),(428237,11896,'no','Vis kunde',0),(428238,11896,'da','Se kunde',0),(428239,11896,'ko','ë³´ê¸° ê³ ê°',0),(428240,11896,'he','×ª×¦×•×’×ª ×”×œ×§×•×—',0),(428241,11896,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(428242,11896,'zh','æŸ¥çœ‹å®¢æˆ·\r\n',0),(428243,11896,'sv','Visa kund',0),(428244,11896,'it','Vista cliente',0),(428245,11896,'tl','',0),(428246,11896,'th','à¸¡à¸¸à¸¡à¸¡à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(428247,11896,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(428248,11896,'ms','Baca pandangan',0),(428249,11896,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(428250,11896,'fr','Avis client',0),(428251,11896,'jp','ãƒ“ãƒ¥ãƒ¼ã®é¡§å®¢',0),(428252,11896,'pt','Cliente de vista',0),(428253,11896,'ru','ÐœÐ½ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(428254,11896,'es','Vista cliente',0),(428255,11896,'de','View Customer',0),(428256,11896,'en','View Customer',0),(428257,11897,'is','',0),(428258,11897,'dr','Ù†Ù…Ø§ÛŒØ´ Ùˆ ÙˆÛŒØ±Ø§ÛŒØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÛŒØ¯Ø§Ø±',0),(428259,11897,'pr','Ù†Ù…Ø§ÛŒØ´ Ùˆ ÙˆÛŒØ±Ø§ÛŒØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÛŒØ¯Ø§Ø±',0),(428260,11897,'tr','GÃ¶rÃ¼nÃ¼m & mÃ¼ÅŸteri bilgilerini dÃ¼zenle',0),(428261,11897,'pl','Widok & edycja informacji o klientach',0),(428262,11897,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ & Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(428263,11897,'ur','Ù…Ù†Ø¸Ø± & ØªØ¯ÙˆÛŒÙ† Ú¯Ø§ÛÚ© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(428264,11897,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¸ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(428265,11897,'vi','Xem Chá»‰nh sá»­a thÃ´ng tin khÃ¡ch hÃ ng',0),(428266,11897,'af','Besigtig & Redigeer KliÃ«nt Inligting',0),(428267,11897,'ro','Vezi & editaÅ£i informaÅ£iile despre clienÅ£i',0),(428268,11897,'et','Vaade & Edit kliendiinfo',0),(428269,11897,'si','Pogled & urejanje podatkov o strankah',0),(428270,11897,'ba','Lihat & Edit informasi pelanggan',0),(428271,11897,'nl','Weergave & klantgegevens bewerken',0),(428272,11897,'fi','View & Muokkaa asiakkaan tiedot',0),(428273,11897,'no','Vis & Rediger kundeinformasjon',0),(428274,11897,'da','Se & Rediger kundeoplysninger',0),(428275,11897,'ko','ë³´ê¸° & ê³ ê° ì •ë³´ íŽ¸ì§‘',0),(428276,11897,'he','×ª×¦×•×’×ª & ×¢×¨×™×›×” ×©×œ ×¤×¨×˜×™ ×”×œ×§×•×—',0),(428277,11897,'el','Î ÏÎ¿Î²Î¿Î»Î® & ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(428278,11897,'zh','æŸ¥çœ‹å®¢æˆ·ä¿¡æ¯\r\n',0),(428279,11897,'sv','Visa & redigera kundinformation',0),(428280,11897,'it','Vista & Modifica informazioni cliente',0),(428281,11897,'tl','',0),(428282,11897,'th','à¸”à¸¹ & à¹à¸à¹‰à¹„à¸‚à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(428283,11897,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ & à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(428284,11897,'ms','Lihat & Edit maklumat pelanggan',0),(428285,11897,'ar','Ø¹Ø±Ø¶ Ø¢Ù†Ø¯ ØªØ­Ø±ÙŠØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(428286,11897,'fr','Vue & Edit Customer Information',0),(428287,11897,'jp','ãƒ“ãƒ¥ãƒ¼ & é¡§å®¢æƒ…å ±ã®ç·¨é›†',0),(428288,11897,'pt','Vista & editar informaÃ§Ãµes do cliente',0),(428289,11897,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ & Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(428290,11897,'es','Visionar y Editar InformaciÃ³n de Cliente',0),(428291,11897,'de','Ansicht & bearbeiten-Kundeninformationen',0),(428292,11897,'en','View & Edit Customer Information',0),(428293,11898,'is','',0),(428294,11898,'dr','Ù†Ù…Ø§ÛŒØ´ Ø³Ù†Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø§ØµÙ„ÛŒ ',0),(428295,11898,'pr','Ù†Ù…Ø§ÛŒØ´ Ø³Ù†Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø§ØµÙ„ÛŒ ',0),(428296,11898,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ orijinal fiÅŸ',0),(428297,11898,'pl','Zobacz oryginalny kupon',0),(428298,11898,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð°Ñ‚Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(428299,11898,'ur','Ù…Ù†Ø¸Ø± Ø§ØµÙ„ ÙˆØ§Ø¤Ú†Ø±',0),(428300,11898,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(428301,11898,'vi','Xem phiáº¿u gá»‘c',0),(428302,11898,'af','Bekyk oorspronklike bewys',0),(428303,11898,'ro','Vezi Original Voucher',0),(428304,11898,'et','Vaate algne kanne',0),(428305,11898,'si','Pogled originalni bona',0),(428306,11898,'ba','View asli Voucher',0),(428307,11898,'nl','Weergave oorspronkelijke Voucher',0),(428308,11898,'fi','NÃ¤ytÃ¤ alkuperÃ¤inen tosite',0),(428309,11898,'no','Vis opprinnelige bilaget',0),(428310,11898,'da','Se originale Voucher',0),(428311,11898,'ko','ë³´ê¸° ì›ëž˜ ë°”ìš°ì²˜',0),(428312,11898,'he','×”×©×•×‘×¨ ×”×ž×§×•×¨×™ ×ª×¦×•×’×”',0),(428313,11898,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(428314,11898,'zh','æŸ¥çœ‹åŽŸå§‹å‡­è¯\r\n',0),(428315,11898,'sv','Visa ursprungliga verifikationen',0),(428316,11898,'it','Voucher originale di vista',0),(428317,11898,'tl','',0),(428318,11898,'th','à¸”à¸¹à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¹€à¸”à¸´à¸¡',0),(428319,11898,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤®à¥‚à¤² à¤µà¤¾à¤‰à¤šà¤°',0),(428320,11898,'ms','Baucar asal View',0),(428321,11898,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø¥ÙŠØµØ§Ù„ Ø§Ù„Ø£ØµÙ„ÙŠ',0),(428322,11898,'fr','Vue Original du bon',0),(428323,11898,'jp','ãƒ“ãƒ¥ãƒ¼ã®å…ƒä¼ç¥¨',0),(428324,11898,'pt','Comprovante Original de exibiÃ§Ã£o',0),(428325,11898,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð» Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(428326,11898,'es','Visionar Voucher Original',0),(428327,11898,'de','View Original Gutschein',0),(428328,11898,'en','View Original Voucher',0),(428329,11899,'is','',0),(428330,11899,'dr','/ Ø§ØµÙ„Ø§Ø­ Ù†Ø±Ø® ØªØ¨Ø¯ÛŒÙ„',0),(428331,11899,'pr','Ù†Ù…Ø§ÛŒØ´/ ÙˆÛŒØ±Ø§ÛŒØ´ Ù†Ø±Ø® ØªØ¨Ø¯ÛŒÙ„',0),(428332,11899,'tr','GÃ¶rÃ¼nÃ¼m/dÃ¶nÃ¼ÅŸÃ¼m oranlarÄ±nÄ± DÃ¼zenle',0),(428333,11899,'pl','WyÅ›wietl/Edytuj przeliczeniowych',0),(428334,11899,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ð°Ð»ÑƒÑ‚Ð½Ð¸Ñ‚Ðµ ÐºÑƒÑ€ÑÐ¾Ð²Ðµ',0),(428335,11899,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ø´Ø±Ø­ Ù…Ù†Ø¸Ø±/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(428336,11899,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ /Ð£Ñ€ÐµÐ´Ð¸ ÑÑ‚Ð¾Ð¿Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ',0),(428337,11899,'vi','Xem/chá»‰nh sá»­a tá»· giÃ¡ chuyá»ƒn Ä‘á»•i ',0),(428338,11899,'af','Bekyk/redigeer omskakeling tariewe',0),(428339,11899,'ro','Vizualizare/Editare ratele de conversie',0),(428340,11899,'et','Vaata/Muuda Ã¼mberarvestuskursid',0),(428341,11899,'si','Ogled/urejanje menjalnih',0),(428342,11899,'ba','Lihat/Edit tingkat konversi',0),(428343,11899,'nl','Bekijken/bewerken omrekeningskoersen',0),(428344,11899,'fi','NÃ¤ytÃ¤/Muokkaa muuntokurssit',0),(428345,11899,'no','Vise/redigere konverteringsfrekvenser',0),(428346,11899,'da','Se/Rediger omregningskurser',0),(428347,11899,'ko','ë³´ê¸°/íŽ¸ì§‘ ì „í™˜ ë¥ ',0),(428348,11899,'he','×”×¦×’/×¢×¨×•×š ×©×™×¢×•×¨×™ ×”×”×ž×¨×”',0),(428349,11899,'el','Î ÏÎ¿Î²Î¿Î»Î®/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¹ÏƒÎ¿Ï„Î¹Î¼Î¯ÎµÏ‚',0),(428350,11899,'zh','æŸ¥çœ‹æˆ–ç¼–è¾‘è½¬æ¢çŽ‡\r\n',0),(428351,11899,'sv','Visa/redigera omrÃ¤kningskurser',0),(428352,11899,'it','Visualizzare/modificare i tassi di conversione',0),(428353,11899,'tl','',0),(428354,11899,'th','à¸”à¸¹à¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚à¸­à¸±à¸•à¸£à¸²à¸à¸²à¸£à¹à¸›à¸¥à¸‡',0),(428355,11899,'hi','à¤¦à¥‡à¤–à¥‡à¤‚/à¤°à¥‚à¤ªà¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¤°à¥‹à¤‚ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(428356,11899,'ms','Pemandangan/Edit kadar penukaran',0),(428357,11899,'ar','Ø¹Ø±Ø¶/ØªØ­Ø±ÙŠØ± Ø£Ø³Ø¹Ø§Ø± Ø§Ù„ØªØ­ÙˆÙŠÙ„',0),(428358,11899,'fr','Afficher/modifier les taux de Conversion',0),(428359,11899,'jp','ã‚³ãƒ³ãƒãƒ¼ã‚¸ãƒ§ãƒ³çŽ‡ã‚’è¡¨ç¤º/ç·¨é›†',0),(428360,11899,'pt','Exibir/editar taxas de conversÃ£o',0),(428361,11899,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÐºÐ¾ÑÑ„Ñ„Ð¸Ñ†Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(428362,11899,'es','Visionar/Editar Tipos de Cambio',0),(428363,11899,'de','Bearbeiten Sie anzeigen/Conversion-Raten',0),(428364,11899,'en','View/Edit Conversion Rates',0),(428365,11900,'is','',0),(428366,11900,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ù…ØªÙ† Ø±Ø§ Ø¨Ø¨ÛŒÙ†ÛŒØ¯',0),(428367,11900,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ù…ØªÙ† Ø±Ø§ Ø¨Ø¨ÛŒÙ†ÛŒØ¯',0),(428368,11900,'tr','Metin yardÄ±m',0),(428369,11900,'pl','Tekst pomocy',0),(428370,11900,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ Ð·Ð° Ñ‚ÐµÐºÑÑ‚',0),(428371,11900,'ur','Ù…Ø¯Ø¯ Ù…ØªÙ†',0),(428372,11900,'sr','Ð¢ÐµÐºÑÑ‚ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸',0),(428373,11900,'vi','vÄƒn báº£n trá»£ giÃºp',0),(428374,11900,'af','Teksgebasseerde Hulp',0),(428375,11900,'ro','Textul ajutor',0),(428376,11900,'et','Teksti spikker',0),(428377,11900,'si','Besedila pomoÄ',0),(428378,11900,'ba','Teks bantuan',0),(428379,11900,'nl','Tekstbestanden Help',0),(428380,11900,'fi','Teksti ohje',0),(428381,11900,'no','Tekst hjelp',0),(428382,11900,'da','HjÃ¦lp til tekst',0),(428383,11900,'ko','í…ìŠ¤íŠ¸ ë„ì›€ë§',0),(428384,11900,'he','×˜×§×¡×˜ ×¢×–×¨×”',0),(428385,11900,'el','Î’Î¿Î®Î¸ÎµÎ¹Î± ÎºÎµÎ¯Î¼ÎµÎ½Î¿',0),(428386,11900,'zh','æ–‡å­—è¯´æ˜Ž\r\n',0),(428387,11900,'sv','Text hjÃ¤lp',0),(428388,11900,'it','Aiuto testo',0),(428389,11900,'tl','',0),(428390,11900,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰',0),(428391,11900,'hi','à¤ªà¤¾à¤  à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾',0),(428392,11900,'ms','Teks bantuan',0),(428393,11900,'ar','Ù†Øµ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(428394,11900,'fr','Texte aide',0),(428395,11900,'jp','ãƒ†ã‚­ã‚¹ãƒˆã®ãƒ˜ãƒ«ãƒ—',0),(428396,11900,'pt','Ajuda de texto',0),(428397,11900,'ru','Ð¢ÐµÐºÑÑ‚ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸',0),(428398,11900,'es','Texto Ayuda',0),(428399,11900,'de','Text-Hilfe',0),(428400,11900,'en','Text Help',0),(428401,11901,'is','',0),(428402,11901,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ ÙˆÛŒØ¯Ø¦ÙˆÛŒÛŒ',0),(428403,11901,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ ÙˆÛŒØ¯Ø¦ÙˆÛŒÛŒ',0),(428404,11901,'tr','Video yardÄ±m',0),(428405,11901,'pl','Plik wideo-Pomoc',0),(428406,11901,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ Ð·Ð° Ð²Ð¸Ð´ÐµÐ¾',0),(428407,11901,'ur','ÙˆÛŒÚˆÛŒÙˆ Ú©ÛŒ Ù…Ø¯Ø¯',0),(428408,11901,'sr','Ð’Ð¸Ð´ÐµÐ¾ Ð¿Ð¾Ð¼Ð¾Ñ›',0),(428409,11901,'vi','Video trá»£ giÃºp',0),(428410,11901,'af','Video Hulp',0),(428411,11901,'ro','Pagina ajutor',0),(428412,11901,'et','Video spikker',0),(428413,11901,'si','Video pomoÄ',0),(428414,11901,'ba','Bantuan video',0),(428415,11901,'nl','Video Help',0),(428416,11901,'fi','Video ohjeet',0),(428417,11901,'no','Video hjelp',0),(428418,11901,'da','Video hjÃ¦lp',0),(428419,11901,'ko','ë¹„ë””ì˜¤ ë„ì›€ë§',0),(428420,11901,'he','×¢×–×¨×” ×•×™×“××•',0),(428421,11901,'el','Î’Î¯Î½Ï„ÎµÎ¿ Î²Î¿Î®Î¸ÎµÎ¹Î±',0),(428422,11901,'zh','è§†é¢‘å¸®åŠ©\r\n',0),(428423,11901,'sv','Video hjÃ¤lp',0),(428424,11901,'it','Aiuto dei',0),(428425,11901,'tl','',0),(428426,11901,'th','à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¸§à¸´à¸”à¸µà¹‚à¸­',0),(428427,11901,'hi','à¤µà¥€à¤¡à¤¿à¤¯à¥‹ à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾',0),(428428,11901,'ms','Video bantuan',0),(428429,11901,'ar','Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø© Ø§Ù„ÙÙŠØ¯ÙŠÙˆ',0),(428430,11901,'fr','Aide vidÃ©o',0),(428431,11901,'jp','ãƒ“ãƒ‡ã‚ª ãƒ˜ãƒ«ãƒ—',0),(428432,11901,'pt','VÃ­deo ajuda',0),(428433,11901,'ru','Ð’Ð¸Ð´ÐµÐ¾ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒ',0),(428434,11901,'es','Video Ayuda',0),(428435,11901,'de','Video-Hilfe',0),(428436,11901,'en','Video Help',0),(428437,11902,'is','',0),(428438,11902,'dr','A',0),(428439,11902,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ù…Ù‚Ø¯Ø§Ø±A\r\n Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(428440,11902,'tr','Bir miktar girmeniz gerekir',0),(428441,11902,'pl','NaleÅ¼y wprowadziÄ‡ iloÅ›Ä‡',0),(428442,11902,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(428443,11902,'ur','Ø¢Ù¾ Ú©ÛŒ Ø§ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(428444,11902,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(428445,11902,'vi','Báº¡n pháº£i nháº­p sá»‘ lÆ°á»£ng',0),(428446,11902,'af','U Moet \'n Hoeveelheid Invoer',0),(428447,11902,'ro','Trebuie sÄƒ introduceÅ£i o cantitate',0),(428448,11902,'et','Sisestage kogus',0),(428449,11902,'si','Vnesite koliÄino',0),(428450,11902,'ba','Anda harus memasukkan kuantitas',0),(428451,11902,'nl','U moet een aantal opgeven',0),(428452,11902,'fi','Anna mÃ¤Ã¤rÃ¤',0),(428453,11902,'no','Du mÃ¥ angi et antall',0),(428454,11902,'da','Du skal angive en mÃ¦ngde',0),(428455,11902,'ko','ìˆ˜ëŸ‰ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(428456,11902,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×›×ž×•×ª',0),(428457,11902,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(428458,11902,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªæ•°é‡\r\n',0),(428459,11902,'sv','Du mÃ¥ste ange en kvantitet',0),(428460,11902,'it','Ãˆ necessario inserire una quantitÃ ',0),(428461,11902,'tl','',0),(428462,11902,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸›à¸£à¸´à¸¡à¸²à¸“',0),(428463,11902,'hi','à¤¤à¥à¤® à¤à¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(428464,11902,'ms','Anda mesti masukkan kuantiti',0),(428465,11902,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ ÙƒÙ…ÙŠØ©',0),(428466,11902,'fr','Vous devez entrer une quantitÃ©',0),(428467,11902,'jp','æ•°é‡ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(428468,11902,'pt','VocÃª deve digitar uma quantidade',0),(428469,11902,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(428470,11902,'es','Debe Entrar Una Cantidad',0),(428471,11902,'de','Sie mÃ¼ssen eine Menge eingeben.',0),(428472,11902,'en','You Must Enter A Quantity',0),(428473,11903,'is','',0),(428474,11903,'dr','ØªØ§Ø¨Ù„Ùˆ Ø±ÙˆÛŒØ¯Ø§Ø¯Ù‡Ø§',0),(428475,11903,'pr','ØªØ§Ø¨Ù„Ùˆ Ø±ÙˆÛŒØ¯Ø§Ø¯Ù‡Ø§',0),(428476,11903,'tr','Kontrol paneli',0),(428477,11903,'pl','Panel',0),(428478,11903,'bg','Ð¢Ð°Ð±Ð»Ð¾',0),(428479,11903,'ur','ÚˆÛŒØ´ Ø¨ÙˆØ±Úˆ',0),(428480,11903,'sr','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ñ‚Ð°Ð±Ð»Ðµ',0),(428481,11903,'vi','Dashboard',0),(428482,11903,'af','Paneelbord',0),(428483,11903,'ro','Tabloul de bord',0),(428484,11903,'et','Armatuurlaud',0),(428485,11903,'si','Nadzorne ploÅ¡Äe',0),(428486,11903,'ba','Dasbor',0),(428487,11903,'nl','Dashboard',0),(428488,11903,'fi','Dashboard',0),(428489,11903,'no','Dashboard',0),(428490,11903,'da','Dashboard',0),(428491,11903,'ko','ëŒ€ì‹œë³´ë“œ',0),(428492,11903,'he','×œ×•×— ×ž×—×•×•× ×™×',0),(428493,11903,'el','Î¤Î±Î¼Ï€Î»ÏŒ',0),(428494,11903,'zh','ä»ªè¡¨ç›˜\r\n',0),(428495,11903,'sv','Instrumentpanel',0),(428496,11903,'it','Cruscotto',0),(428497,11903,'tl','',0),(428498,11903,'th','à¹à¸”à¸Šà¸šà¸­à¸£à¹Œà¸”',0),(428499,11903,'hi','à¤¡à¥ˆà¤¶à¤¬à¥‹à¤°à¥à¤¡',0),(428500,11903,'ms','Papan pemuka',0),(428501,11903,'ar','Ù„ÙˆØ­Ø© Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(428502,11903,'fr','Tableau de bord',0),(428503,11903,'jp','ãƒ€ãƒƒã‚·ãƒ¥ ãƒœãƒ¼ãƒ‰',0),(428504,11903,'pt','Painel de controle',0),(428505,11903,'ru','ÐŸÐ°Ð½ÐµÐ»ÑŒ Ð¼Ð¾Ð½Ð¸Ñ‚Ð¾Ñ€Ð¸Ð½Ð³Ð°',0),(428506,11903,'es','Consola',0),(428507,11903,'de','Dashboard',0),(428508,11903,'en','Dashboard',0),(428509,11904,'is','',0),(428510,11904,'dr','Ù…ÛŒØ§Ù†Ø¨Ø±Ù‡Ø§',0),(428511,11904,'pr','Ù…ÛŒØ§Ù†Ø¨Ø±Ù‡Ø§',0),(428512,11904,'tr','KÄ±sayollarÄ±&#xD;\n',0),(428513,11904,'pl','SkrÃ³ty&#xD;\n',0),(428514,11904,'bg','ÐŸÑ€ÐµÐºÐ¸ Ð¿ÑŠÑ‚Ð¸Ñ‰Ð°&#xD;\n',0),(428515,11904,'ur','ØªÛŒØ² Ø±Ø§ÛÛŒÚº&#xD;\n',0),(428516,11904,'sr','ÐŸÑ€ÐµÑ‡Ð¸Ñ†Ðµ&#xD;\n',0),(428517,11904,'vi','TÃ³m lÆ°á»£c',0),(428518,11904,'af','Kortpaaie&#xD;\n',0),(428519,11904,'ro','Comenzi rapide&#xD;\n',0),(428520,11904,'et','Otseteed&#xD;\n',0),(428521,11904,'si','BliÅ¾njice&#xD;\n',0),(428522,11904,'ba','Cara pintas&#xD;\n',0),(428523,11904,'nl','Snelkoppelingen&#xD;\n',0),(428524,11904,'fi','Pikakuvakkeet&#xD;\n',0),(428525,11904,'no','Snarveier&#xD;\n',0),(428526,11904,'da','Genveje&#xD;\n',0),(428527,11904,'ko','ë°”ë¡œ ê°€ê¸°&#xD;\n',0),(428528,11904,'he','×§×™×¦×•×¨×™ ×“×¨×š&#xD;\n',0),(428529,11904,'el','Î£Ï…Î½Ï„Î¿Î¼ÎµÏÏƒÎµÎ¹Ï‚&#xD;\n',0),(428530,11904,'zh','æ·å¾„\r\n',0),(428531,11904,'sv','GenvÃ¤gar&#xD;\n',0),(428532,11904,'it','Scorciatoie&#xD;\n',0),(428533,11904,'tl','',0),(428534,11904,'th','à¸—à¸²à¸‡à¸¥à¸±à¸”&#xD;\n',0),(428535,11904,'hi','à¤¶à¥‰à¤°à¥à¤Ÿà¤•à¤Ÿà¥à¤¸&#xD;\n',0),(428536,11904,'ms','Pintasan&#xD;\n',0),(428537,11904,'ar','Ø§Ø®ØªØµØ§Ø±Ø§Øª&#xD;\n',0),(428538,11904,'fr','Raccourcis&#xD;\n',0),(428539,11904,'jp','ã‚·ãƒ§ãƒ¼ãƒˆã‚«ãƒƒãƒˆ',0),(428540,11904,'pt','Atalhos&#xD;\n',0),(428541,11904,'ru','Ð¡Ð¾Ñ‡ÐµÑ‚Ð°Ð½Ð¸Ñ ÐºÐ»Ð°Ð²Ð¸Ñˆ&#xD;\n',0),(428542,11904,'es','Medios RÃ¡pidos',0),(428543,11904,'de','VerknÃ¼pfungen&#xD;\n',0),(428544,11904,'en','Shortcuts\r\n',0),(428545,11905,'is','',0),(428546,11905,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ ÙØ±ÙˆØ´ Ù‡Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± Ù†Ø´Ø¯Ù‡',0),(428547,11905,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ ÙØ±ÙˆØ´ Ù‡Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± Ù†Ø´Ø¯Ù‡',0),(428548,11905,'tr','SatÄ±ÅŸ faturalandÄ±rÄ±lmamÄ±ÅŸ DÃ¼zenle',0),(428549,11905,'pl','Edytuj niezafakturowanych sprzedaÅ¼y',0),(428550,11905,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(428551,11905,'ur','ØºÛŒØ± Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ú©ÛŒ ÙØ±ÙˆØ®Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(428552,11905,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð½ÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(428553,11905,'vi','Sá»­a bÃ¡n hÃ ng khÃ´ng hÃ³a Ä‘Æ¡n',0),(428554,11905,'af','Redigeer nie-Invoiced verkope',0),(428555,11905,'ro','Editare Non-facturate de vÃ¢nzÄƒri',0),(428556,11905,'et','Edit-arveldatud mÃ¼Ã¼k',0),(428557,11905,'si','Urejanje niso knjiÅ¾ene prodajne',0),(428558,11905,'ba','Mengedit bebas tagihan penjualan',0),(428559,11905,'nl','Bewerken van niet-gefactureerde verkoop',0),(428560,11905,'fi','Muokkaa laskuttamattomien-myynti',0),(428561,11905,'no','Redigere ikke-fakturerte salg',0),(428562,11905,'da','Rediger ikke-faktureret salg',0),(428563,11905,'ko','íŽ¸ì§‘ ë¹„ ì²­êµ¬ ëœ íŒë§¤',0),(428564,11905,'he','×œ×¢×¨×•×š ×ž×›×™×¨×•×ª ×œ×œ× ×—×©×‘×•× ×™×ª',0),(428565,11905,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼Î· Ï„Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(428566,11905,'zh','ç¼–è¾‘éžå¼€å…·å‘ç¥¨çš„é”€å”®\r\n',0),(428567,11905,'sv','Redigera icke fakturerade fÃ¶rsÃ¤ljning',0),(428568,11905,'it','Modificare le vendite Non fatturate',0),(428569,11905,'tl','',0),(428570,11905,'th','à¹à¸à¹‰à¹„à¸‚à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸à¸²à¸£à¸‚à¸²à¸¢',0),(428571,11905,'hi','à¤—à¥ˆà¤° à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(428572,11905,'ms','Edit-invois jualan',0),(428573,11905,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(428574,11905,'fr','Modifier les ventes Non facturÃ©es',0),(428575,11905,'jp','éžè«‹æ±‚æ¸ˆã¿è²©å£²ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(428576,11905,'pt','Editar vendas nÃ£o faturadas',0),(428577,11905,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ðµ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð°Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(428578,11905,'es','Editar Ventas No Facturadas',0),(428579,11905,'de','Bearbeiten Sie nicht fakturierten Umsatz',0),(428580,11905,'en','Edit Non-Invoiced Sales',0),(428581,11906,'is','',0),(428582,11906,'dr','ÙØ±ÙˆØ´ Ù‡Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± Ù†Ø´Ø¯Ù‡ Ø¬Ø¯ÛŒØ¯',0),(428583,11906,'pr','ÙØ±ÙˆØ´ Ù‡Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± Ù†Ø´Ø¯Ù‡ Ø¬Ø¯ÛŒØ¯',0),(428584,11906,'tr','Yeni faturalandÄ±rÄ±lmamÄ±ÅŸ satÄ±ÅŸ',0),(428585,11906,'pl','SprzedaÅ¼y nowych niezafakturowanych',0),(428586,11906,'bg','ÐÐ¾Ð²Ð¸-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(428587,11906,'ur','Ù†Ø¦ÛŒ ØºÛŒØ± Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(428588,11906,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° Ð½Ð¾Ð²Ð¸Ñ… Ð½ÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð¸',0),(428589,11906,'vi','bÃ¡n hÃ ng khÃ´ng hÃ³a Ä‘Æ¡n má»›i',0),(428590,11906,'af','Nuwe nie-Invoiced verkope',0),(428591,11906,'ro','Noua ne-a facturat vÃ¢nzÄƒri',0),(428592,11906,'et','Uus arveldamata mÃ¼Ã¼k',0),(428593,11906,'si','Nov Non-knjiÅ¾ene prodajne',0),(428594,11906,'ba','Penjualan bebas tagihan baru',0),(428595,11906,'nl','Nieuwe niet-gefactureerde verkoop',0),(428596,11906,'fi','Uusi laskuttamattomien-myynti',0),(428597,11906,'no','Nye ikke-fakturerte salg',0),(428598,11906,'da','Nye ikke-faktureret salg',0),(428599,11906,'ko','ìƒˆë¡œìš´ ë¹„ ì²­êµ¬ ëœ íŒë§¤',0),(428600,11906,'he','×ž×›×™×¨×•×ª ×—×“×©×™× ×œ×œ× ×—×©×‘×•× ×™×ª',0),(428601,11906,'el','ÎÎ­Î± Î¼Î· Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(428602,11906,'zh','æ–°éžå¼€å…·å‘ç¥¨çš„é”€å”®\r\n',0),(428603,11906,'sv','Nya icke fakturerade fÃ¶rsÃ¤ljning',0),(428604,11906,'it','Nuove vendite Non fatturate',0),(428605,11906,'tl','',0),(428606,11906,'th','à¸‚à¸²à¸¢à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸«à¸¡à¹ˆ',0),(428607,11906,'hi','à¤¨à¤ˆ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤—à¥ˆà¤° à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(428608,11906,'ms','Invois jualan baru',0),(428609,11906,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ØºÙŠØ± Ø§Ù„Ù…ÙÙˆØªØ±Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(428610,11906,'fr','Nouvelles ventes Non facturÃ©es',0),(428611,11906,'jp','æ–°ã—ã„éžè«‹æ±‚æ¸ˆã¿è²©å£²',0),(428612,11906,'pt','Vendas novas nÃ£o faturadas',0),(428613,11906,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð° ÑÑ‡ÐµÑ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(428614,11906,'es','Nuevas Ventas No Facturadas',0),(428615,11906,'de','Neue nicht fakturierten Umsatz',0),(428616,11906,'en','New Non-Invoiced Sales',0),(428617,11907,'is','',0),(428618,11907,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø®Ø¯Ù…Ø§Øª Ø¨Ø§Ù†Ú©',0),(428619,11907,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø®Ø¯Ù…Ø§Øª Ø¨Ø§Ù†Ú©',0),(428620,11907,'tr','Banka servis Ã¼cretleri',0),(428621,11907,'pl','OpÅ‚aty za usÅ‚ugi bankowe',0),(428622,11907,'bg','Ð¢Ð°ÐºÑÐ¸ Ð·Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(428623,11907,'ur','Ø¨ÛŒÙ†Ú© Ø³Ø±ÙˆØ³ Ú†Ø§Ø±Ø¬Ø²',0),(428624,11907,'sr','Ð‘Ð°Ð½ÐºÐ° Ð½Ð°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(428625,11907,'vi','PhÃ­ ngÃ¢n hÃ ng',0),(428626,11907,'af','Bankkoste diens',0),(428627,11907,'ro','Taxele de servicii bancare',0),(428628,11907,'et','Panga teenustasud',0),(428629,11907,'si','StroÅ¡ki storitev banke',0),(428630,11907,'ba','Biaya layanan Bank',0),(428631,11907,'nl','Service bankkosten',0),(428632,11907,'fi','Pankkien palvelumaksut',0),(428633,11907,'no','Bankgebyrer',0),(428634,11907,'da','Bankgebyrer',0),(428635,11907,'ko','ì€í–‰ ì„œë¹„ìŠ¤ ìš”ê¸ˆ',0),(428636,11907,'he','×ª×¢×¨×™×¤×™ ×©×™×¨×•×ª×™ ×‘× ×§',0),(428637,11907,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¬ Î­Î¾Î¿Î´Î± Ï…Ï€Î·ÏÎµÏƒÎ¯Î±',0),(428638,11907,'zh','é“¶è¡ŒæœåŠ¡è´¹\r\n',0),(428639,11907,'sv','Bankens serviceavgifter',0),(428640,11907,'it','Spese di servizio banca',0),(428641,11907,'tl','',0),(428642,11907,'th','à¸„à¹ˆà¸²à¸šà¸£à¸´à¸à¸²à¸£à¸‚à¸­à¸‡à¸˜à¸™à¸²à¸„à¸²à¸£',0),(428643,11907,'hi','à¤¬à¥ˆà¤‚à¤• à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(428644,11907,'ms','Caj perkhidmatan Bank',0),(428645,11907,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø®Ø¯Ù…Ø§Øª Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(428646,11907,'fr','Frais de services bancaires',0),(428647,11907,'jp','éŠ€è¡Œæ‰‹æ•°æ–™',0),(428648,11907,'pt','Taxas de serviÃ§o do banco',0),(428649,11907,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° ÑƒÑÐ»ÑƒÐ³Ð¸ Ð±Ð°Ð½ÐºÐ°',0),(428650,11907,'es','Cargos Bancarios de Servicios',0),(428651,11907,'de','Bank-Service-GebÃ¼hren',0),(428652,11907,'en','Bank Service Charges',0),(428653,11908,'is','',0),(428654,11908,'dr','Ù…Ø¨Ù„Øº ÙØ±ÙˆØ´',0),(428655,11908,'pr','Ù…Ø¨Ù„Øº ÙØ±ÙˆØ´',0),(428656,11908,'tr','SatÄ±ÅŸ tutarÄ±',0),(428657,11908,'pl','Kwota sprzedaÅ¼y',0),(428658,11908,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(428659,11908,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(428660,11908,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(428661,11908,'vi','Sá»‘ tiá»n bÃ¡n hÃ ng',0),(428662,11908,'af','Verkope Bedrag',0),(428663,11908,'ro','SumÄƒ vÃ¢nzÄƒri',0),(428664,11908,'et','Summa mÃ¼Ã¼gi',0),(428665,11908,'si','Znesek prodaje',0),(428666,11908,'ba','Jumlah penjualan',0),(428667,11908,'nl','Bedrag verkoop',0),(428668,11908,'fi','Summa, myynti',0),(428669,11908,'no','BelÃ¸pet salg',0),(428670,11908,'da','MÃ¦ngde salg',0),(428671,11908,'ko','ê¸ˆì•¡ íŒë§¤',0),(428672,11908,'he','×›×ž×•×ª ×ž×›×™×¨×•×ª',0),(428673,11908,'el','Î Î¿ÏƒÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(428674,11908,'zh','é”€å”®é‡‘é¢\r\n',0),(428675,11908,'sv','Summa fÃ¶rsÃ¤ljning',0),(428676,11908,'it','Importo vendite',0),(428677,11908,'tl','',0),(428678,11908,'th','à¸¢à¸­à¸”à¸‚à¸²à¸¢',0),(428679,11908,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(428680,11908,'ms','Jumlah jualan',0),(428681,11908,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(428682,11908,'fr','Ventes de quantitÃ©',0),(428683,11908,'jp','è²©å£²é‡‘é¡',0),(428684,11908,'pt','Vendas de quantidade',0),(428685,11908,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(428686,11908,'es','Monto de Ventas',0),(428687,11908,'de','Menge Umsatz',0),(428688,11908,'en','Amount Sales',0),(428689,11909,'is','',0),(428690,11909,'dr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ø³Ù¾Ø±Ø¯Ù‡',0),(428691,11909,'pr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ø³Ù¾Ø±Ø¯Ù‡',0),(428692,11909,'tr','Mevduat aÃ§Ä±klamasÄ±',0),(428693,11909,'pl','Opis wpÅ‚aty',0),(428694,11909,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(428695,11909,'ur','Ø¬Ù…Ø¹ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(428696,11909,'sr','ÐžÐ¿Ð¸Ñ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(428697,11909,'vi','MÃ´ táº£ Ä‘áº·t cá»c',0),(428698,11909,'af','Deposito Beskrywing',0),(428699,11909,'ro','Depozit Descriere',0),(428700,11909,'et','Tagatisraha kirjeldus',0),(428701,11909,'si','Opis depozita',0),(428702,11909,'ba','Deskripsi deposit',0),(428703,11909,'nl','Beschrijving van de storting',0),(428704,11909,'fi','Kemiallinen kuvaus',0),(428705,11909,'no','Innskudd beskrivelse',0),(428706,11909,'da','Depositum beskrivelse',0),(428707,11909,'ko','ë³´ì¦ê¸ˆ ì„¤ëª…',0),(428708,11909,'he','×ª×™××•×¨ ×™×‘×©',0),(428709,11909,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(428710,11909,'zh','å­˜æ¬¾è¯´æ˜Ž\r\n',0),(428711,11909,'sv','InsÃ¤ttning Beskrivning',0),(428712,11909,'it','Descrizione del deposito',0),(428713,11909,'tl','',0),(428714,11909,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹€à¸à¸µà¹ˆà¸¢à¸§à¸à¸±à¸šà¹€à¸‡à¸´à¸™à¸à¸²à¸',0),(428715,11909,'hi','à¤œà¤®à¤¾ à¤µà¤°à¥à¤£à¤¨',0),(428716,11909,'ms','Keterangan Deposit',0),(428717,11909,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„ÙˆØµÙ',0),(428718,11909,'fr','Description de dÃ©pÃ´t',0),(428719,11909,'jp','æ²ˆæ®¿ç‰©ã®èª¬æ˜Ž',0),(428720,11909,'pt','DescriÃ§Ã£o do depÃ³sito',0),(428721,11909,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð²ÐºÐ»Ð°Ð´Ð¾Ð²',0),(428722,11909,'es','DescripciÃ³n de DepÃ³sito',0),(428723,11909,'de','Einzahlung Beschreibung',0),(428724,11909,'en','Deposit Description',0),(428725,11910,'is','',0),(428726,11910,'dr','Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÛŒ Ø¶Ù…ÛŒÙ…Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(428727,11910,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÛŒ Ø¶Ù…ÛŒÙ…Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(428728,11910,'tr','ACH mevduat ekstresi',0),(428729,11910,'pl','ACH depozytÃ³w na oÅ›wiadczenie',0),(428730,11910,'bg','ACH Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸ Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(428731,11910,'ur','Ø§Ú† Ø°Ø®Ø§Ø¦Ø± Ù¾Ø± Ø¨ÛŒØ§Ù†',0),(428732,11910,'sr','ÐÑ… Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ðµ Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(428733,11910,'vi','ACH bÃ¡o cÃ¡o kÃ½ quá»¹, Ä‘áº·t cá»c',0),(428734,11910,'af','ACH deposito\'s op stelling',0),(428735,11910,'ro','ACH depozite pe declaraÅ£ie',0),(428736,11910,'et','ACH hoiuste vÃ¤ljavÃµttel',0),(428737,11910,'si','ACH depozitov na izjavo',0),(428738,11910,'ba','ACH deposito pada pernyataan',0),(428739,11910,'nl','ACH deposito\'s over de verklaring van',0),(428740,11910,'fi','Lausunto talletusten ACH',0),(428741,11910,'no','ACH innskudd pÃ¥ uttalelse',0),(428742,11910,'da','ACH indskud pÃ¥ kontoudtog',0),(428743,11910,'ko','ACH ì˜ˆê¸ˆ ëª…ì„¸ì„œì—',0),(428744,11910,'he','ACH ×”×¤×§×“×•×ª ×¢×œ ×”×”×¦×”×¨×”',0),(428745,11910,'el','ACH ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚ ÏƒÎµ Î´Î®Î»Ï‰ÏƒÎ·',0),(428746,11910,'zh','è‡ªåŠ¨åŒ–äº¤æ˜“æ‰€çš„å£°æ˜Žå­˜æ¬¾',0),(428747,11910,'sv','ACH insÃ¤ttningar pÃ¥ kontoutdrag',0),(428748,11910,'it','Depositi ACH su istruzione',0),(428749,11910,'tl','',0),(428750,11910,'th','à¸à¸²à¸ ACH à¹ƒà¸™à¸‡à¸š',0),(428751,11910,'hi','à¤¬à¤¯à¤¾à¤¨ à¤ªà¤° ACH à¤œà¤®à¤¾',0),(428752,11910,'ms','MEN Deposit pada penyata',0),(428753,11910,'ar','ÙˆØ¯Ø§Ø¦Ø¹ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ ÙÙŠ Ø¨ÙŠØ§Ù†',0),(428754,11910,'fr','ACH dÃ©pÃ´ts sur dÃ©claration',0),(428755,11910,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã® ACH ã®æ²ˆæ®¿ç‰©',0),(428756,11910,'pt','DepÃ³sitos ACH na declaraÃ§Ã£o',0),(428757,11910,'ru','ACH Ð¾Ñ‚Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(428758,11910,'es','DepÃ³sitos de ACH en el Estado de Cuenta',0),(428759,11910,'de','ACH Ablagerungen auf Anweisung',0),(428760,11910,'en','ACH Deposits on Statement',0),(428761,11911,'is','',0),(428762,11911,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÙˆØ±ÙˆØ¯ÛŒ Ø¬Ø¯ÛŒØ¯',0),(428763,11911,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÙˆØ±ÙˆØ¯ÛŒ Ø¬Ø¯ÛŒØ¯',0),(428764,11911,'tr','Yeni giriÅŸ Ekle',0),(428765,11911,'pl','Dodaj nowy wpis',0),(428766,11911,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð² Ð·Ð°Ð¿Ð¸Ñ',0),(428767,11911,'ur','Ù†ÛŒØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(428768,11911,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ ÑƒÐ¿Ð¸Ñ',0),(428769,11911,'vi','ThÃªm cá»•ng má»›i',0),(428770,11911,'af','Voeg nuwe inskrywing',0),(428771,11911,'ro','Adauga noua intrare',0),(428772,11911,'et','Lisa uus kirje',0),(428773,11911,'si','Dodaj nov vnos',0),(428774,11911,'ba','Menambah entri baru',0),(428775,11911,'nl','Nieuwe vermelding toevoegen',0),(428776,11911,'fi','LisÃ¤Ã¤ uusi merkintÃ¤',0),(428777,11911,'no','Legge til ny oppfÃ¸ring',0),(428778,11911,'da','TilfÃ¸j ny post',0),(428779,11911,'ko','ìƒˆ í•­ëª© ì¶”ê°€',0),(428780,11911,'he','×”×•×¡×£ ×¢×¨×š ×—×“×©',0),(428781,11911,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î±Ï‚ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚',0),(428782,11911,'zh','å¢žåŠ æ–°åˆ†å½•',0),(428783,11911,'sv','LÃ¤gg till ny post',0),(428784,11911,'it','Aggiungi nuova voce',0),(428785,11911,'tl','',0),(428786,11911,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸«à¸¡à¹ˆ',0),(428787,11911,'hi','à¤¨à¤ˆ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(428788,11911,'ms','Tambah entri baru',0),(428789,11911,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø¯Ø®Ø§Ù„ Ø¬Ø¯ÙŠØ¯',0),(428790,11911,'fr','Ajoutez la nouvelle entrÃ©e',0),(428791,11911,'jp','æ–°ã—ã„ã‚¨ãƒ³ãƒˆãƒªã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(428792,11911,'pt','Adicionar nova entrada',0),(428793,11911,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(428794,11911,'es','Agregar una Nueva Entrada',0),(428795,11911,'de','Neuen Eintrag hinzufÃ¼gen',0),(428796,11911,'en','Add New Entry',0),(428797,11912,'is','',0),(428798,11912,'dr','Ú†Ú© Ù‡Ø§ Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø¶Ù…ÛŒÙ…Ù‡ Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(428799,11912,'pr','Ú†Ú© Ù‡Ø§ Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø¶Ù…ÛŒÙ…Ù‡ Ø´Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(428800,11912,'tr','Ã‡ekler ve ACH Ã¶demeler ekstresi',0),(428801,11912,'pl','Kontrole i pÅ‚atnoÅ›ci ACH na oÅ›wiadczenie',0),(428802,11912,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¸ ACH Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ ÐºÑŠÐ¼ Ð½ÐµÐ³Ð¾',0),(428803,11912,'ur','Ú†ÛŒÚ© Ø§ÙˆØ± Ø§Ú† Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù¾Ø± Ø¨ÛŒØ§Ù†',0),(428804,11912,'sr','Ð§ÐµÐºÐ¾Ð²Ðµ Ð¸ ÐÑ… Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(428805,11912,'vi','BÃ¡o cÃ¡o sÃ©c vÃ  thanh toÃ¡n ACH',0),(428806,11912,'af','Ondersoeke en ACH betalings op stelling',0),(428807,11912,'ro','Controale ÅŸi plÄƒÅ£i ACH declaraÅ£ie',0),(428808,11912,'et','Kontrolli ja ACH maksete kalkulatsiooni',0),(428809,11912,'si','Pregledi in ACH plaÄila na izjavo',0),(428810,11912,'ba','Cek dan ACH pembayaran pada pernyataan',0),(428811,11912,'nl','Controles en ACH-betalingen over de verklaring van',0),(428812,11912,'fi','Tarkastukset ja ACH maksujen tiliotteessa',0),(428813,11912,'no','Sjekker og ACH betalinger pÃ¥ uttalelse',0),(428814,11912,'da','Kontrol og ACH betalinger pÃ¥ kontoudtog',0),(428815,11912,'ko','ê²€ì‚¬ ë° ACH ì§€ë¶ˆ ëª…ì„¸ì„œì—',0),(428816,11912,'he','×‘×“×™×§×•×ª, ACH ×ª×©×œ×•×ž×™× ×¢×œ ×”×”×¦×”×¨×”',0),(428817,11912,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Î¹ ÎºÎ±Î¹ ACH Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î³Î¹Î± Î´Î®Î»Ï‰ÏƒÎ·',0),(428818,11912,'zh','æ”¯ç¥¨å’Œè‡ªåŠ¨äº¤æ¢æ‰€æ”¯ä»˜çš„å£°æ˜Ž\r\n',0),(428819,11912,'sv','Kontroller och ACH-betalningar pÃ¥ kontoutdrag',0),(428820,11912,'it','Controlli e ACH pagamenti su istruzione',0),(428821,11912,'tl','',0),(428822,11912,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹à¸¥à¸°à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ ACH à¹ƒà¸™à¸‡à¸š',0),(428823,11912,'hi','à¤šà¥‡à¤• à¤”à¤° à¤¬à¤¯à¤¾à¤¨ à¤ªà¤° ACH à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(428824,11912,'ms','Semakan dan pembayaran men penyata',0),(428825,11912,'ar','Ø§Ù„Ø´ÙŠÙƒØ§Øª ÙˆØ§Ù„Ø¯ÙØ¹ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ ÙÙŠ Ø¨ÙŠØ§Ù†',0),(428826,11912,'fr','ChÃ¨ques et paiements ACH sur dÃ©claration',0),(428827,11912,'jp','ãƒã‚§ãƒƒã‚¯ã¨ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã® ACH ã®æ”¯æ‰•',0),(428828,11912,'pt','Cheques e pagamentos de ACH na declaraÃ§Ã£o',0),(428829,11912,'ru','Ð§ÐµÐºÐ¸ Ð¸ ACH Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(428830,11912,'es','Cheques y Pagos ACH en el Estado de Cuenta',0),(428831,11912,'de','Kontrollen und ACH-Zahlungen auf Anweisung',0),(428832,11912,'en','Checks and ACH Payments on Statement',0),(428833,11913,'is','',0),(428834,11913,'dr','Ø³Ù¾Ø±Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(428835,11913,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(428836,11913,'tr','Mevduat ekstresi',0),(428837,11913,'pl','Depozyty na oÅ›wiadczenie',0),(428838,11913,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸ Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(428839,11913,'ur','Ø°Ø®Ø§Ø¦Ø± Ù¾Ø± Ø¨ÛŒØ§Ù†',0),(428840,11913,'sr','ÐÐ°ÑÐ»Ð°Ð³Ðµ Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(428841,11913,'vi','BÃ¡o cÃ¡o gá»­i tiá»n',0),(428842,11913,'af','Deposito\'s op stelling',0),(428843,11913,'ro','Depozite pe declaraÅ£ie',0),(428844,11913,'et','Aruande hoiuste',0),(428845,11913,'si','Vloge na izjavo',0),(428846,11913,'ba','Deposito pada pernyataan',0),(428847,11913,'nl','Deposito\'s over de verklaring van',0),(428848,11913,'fi','Lausunto talletusten',0),(428849,11913,'no','Innskudd pÃ¥ uttalelse',0),(428850,11913,'da','Indskud pÃ¥ kontoudtog',0),(428851,11913,'ko','ë¬¸ì— ì˜ˆê¸ˆ',0),(428852,11913,'he','×”×¤×§×“×•×ª ×¢×œ ×”×”×¦×”×¨×”',0),(428853,11913,'el','ÎšÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚ ÏƒÎµ Î´Î®Î»Ï‰ÏƒÎ·',0),(428854,11913,'zh','è¯´æ˜Žå­˜æ¬¾\r\n',0),(428855,11913,'sv','InsÃ¤ttningar pÃ¥ kontoutdrag',0),(428856,11913,'it','Depositi su istruzione',0),(428857,11913,'tl','',0),(428858,11913,'th','à¹€à¸‡à¸´à¸™à¸à¸²à¸à¹ƒà¸™à¸‡à¸š',0),(428859,11913,'hi','à¤¬à¤¯à¤¾à¤¨ à¤ªà¤° à¤œà¤®à¤¾',0),(428860,11913,'ms','Deposit pada penyata',0),(428861,11913,'ar','Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ ÙÙŠ Ø¨ÙŠØ§Ù†',0),(428862,11913,'fr','DÃ©pÃ´ts sur dÃ©claration',0),(428863,11913,'jp','é é‡‘æ˜Žç´°',0),(428864,11913,'pt','DepÃ³sitos na declaraÃ§Ã£o',0),(428865,11913,'ru','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹ Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(428866,11913,'es','DepÃ³sitos en Estado de Cuenta',0),(428867,11913,'de','Einlagen auf Anweisung',0),(428868,11913,'en','Deposits On Statement',0),(428869,11914,'is','',0),(428870,11914,'dr','Ù‡Ø¯Ø§ÛŒØª Ø«Ø¨Øª Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯ÙØªØ± Ú©Ù„ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(428871,11914,'pr','Ù‡Ø¯Ø§ÛŒØª Ø«Ø¨Øª Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯ÙØªØ± Ú©Ù„ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(428872,11914,'tr','DoÄŸrudan GL Ã¶deme giriÅŸlerinin ekstresi',0),(428873,11914,'pl','Wpisy pÅ‚atnoÅ›ci bezpoÅ›rednie GL na oÅ›wiadczenie',0),(428874,11914,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ GL Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(428875,11914,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬ÛŒØ¬Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(428876,11914,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(428877,11914,'vi','Ghi sá»• cÃ¡i thanh toÃ¡n kÃ¨m báº£ng kÃª',0),(428878,11914,'af','Direkte GL betaling inskrywings op stelling',0),(428879,11914,'ro','IntrÄƒrile de plata GL directe pe declaraÅ£ie',0),(428880,11914,'et','Otsene GL maksekannete aruanne',0),(428881,11914,'si','Neposredno GL plaÄilo postavk na izpisku',0),(428882,11914,'ba','Pembayaran langsung GL entri pada pernyataan',0),(428883,11914,'nl','Directe GL betalingsposten over de verklaring van',0),(428884,11914,'fi','Suoraa GL maksun tiliotteessa',0),(428885,11914,'no','Direkte GL betalingspostene i setningen',0),(428886,11914,'da','Direkte GL betalingsposter redegÃ¸relse',0),(428887,11914,'ko','ë¬¸ì— ì§ì ‘ GL ì§€ë¶ˆ í•­ëª©',0),(428888,11914,'he','GL ×™×©×™×¨×” ×”×–× ×•×ª ×ª×©×œ×•× ×¢×œ ×”×”×¦×”×¨×”',0),(428889,11914,'el','GL Î¬Î¼ÎµÏƒÎ· Ï€Î»Î·ÏÏ‰Î¼Î® ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ ÏƒÏ„Î· Î´Î®Î»Ï‰ÏƒÎ·',0),(428890,11914,'zh','ç›´æŽ¥æ€»å¸ä»˜æ¬¾æ¡ç›®åœ¨è¯´æ˜Žä¸Š',0),(428891,11914,'sv','Direkt GL betalningsposter uttalande',0),(428892,11914,'it','Voci di pagamento diretto GL su istruzione',0),(428893,11914,'tl','',0),(428894,11914,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ GL à¹‚à¸”à¸¢à¸•à¸£à¸‡à¹ƒà¸™à¸‡à¸š',0),(428895,11914,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· GL à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¯à¤¾à¤¨ à¤ªà¤°',0),(428896,11914,'ms','GL terus pembayaran penyertaan pada penyata',0),(428897,11914,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± GL ÙÙŠ Ø¨ÙŠØ§Ù†',0),(428898,11914,'fr','EntrÃ©es de paiement direct GL sur dÃ©claration',0),(428899,11914,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã®ç›´æŽ¥ GL æ”¯æ‰•ã‚¨ãƒ³ãƒˆãƒª',0),(428900,11914,'pt','Entradas de pagamento directo GL na declaraÃ§Ã£o',0),(428901,11914,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ GL Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(428902,11914,'es','Entradas de Pagos Directos en el Estado de Cuenta',0),(428903,11914,'de','Direkte GL Zahlungsposten auf Anweisung',0),(428904,11914,'en','Direct GL Payment Entries On Statement',0),(428905,11915,'is','',0),(428906,11915,'dr','Ø¹Ø¯Ù… Ù‡Ø¯Ø§ÛŒØª Ø±Ø³ÛŒØ¯Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª ',0),(428907,11915,'pr','Ø¹Ø¯Ù… Ù‡Ø¯Ø§ÛŒØª Ø±Ø³ÛŒØ¯Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª ',0),(428908,11915,'tr','Deyim deÄŸil doÄŸrudan GL bilgisi',0),(428909,11915,'pl','WpÅ‚ywy bezpoÅ›rednie GL nie na oÅ›wiadczenie',0),(428910,11915,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ GL Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(428911,11915,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬ÛŒØ¬Û’ Ø±Ø³ÛŒØ¯ÛŒÚº Ø¨ÛŒØ§Ù† Ù¾Ø± Ù†ÛÛŒÚº',0),(428912,11915,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ Ð½Ð¸Ñ˜Ðµ Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(428913,11915,'vi','Sá»• cÃ¡i thu tiá»n khÃ´ng kÃ¨m báº£ng kÃª',0),(428914,11915,'af','Direkte GL kwitansies nie op staat',0),(428915,11915,'ro','Veniturile directe GL nu pe declaraÅ£ie',0),(428916,11915,'et','Otsene GL teatised pole nende avaldus',0),(428917,11915,'si','Neposredno GL prejemki ne na izjavo',0),(428918,11915,'ba','Penerimaan langsung GL bukan pada pernyataan',0),(428919,11915,'nl','Directe GL ontvangsten niet over de verklaring van',0),(428920,11915,'fi','Suora GL vastaanottoja ei julkilausumasta',0),(428921,11915,'no','Direkte GL mottak ikke pÃ¥ uttalelse',0),(428922,11915,'da','Direkte GL kvitteringer ikke pÃ¥ kontoudtog',0),(428923,11915,'ko','ê³„ì‚° ì„œì— ì§ì ‘ GL ì˜ìˆ˜ì¦',0),(428924,11915,'he','××™×©×•×¨×™ GL ×™×©×™×¨×” ×œ× ×”×¦×”×¨×”',0),(428925,11915,'el','Î†Î¼ÎµÏƒÎ· GL Ï€Î±ÏÎ±Î»Î±Î²Î­Ï‚ Î´ÎµÎ½ ÏƒÎµ Î´Î®Î»Ï‰ÏƒÎ·',0),(428926,11915,'zh','ç›´æŽ¥æ€»å¸ç¥¨æ®ä¸åœ¨è¯´æ˜Žä¸Š\r\n',0),(428927,11915,'sv','Direkt GL kvitton inte pÃ¥ uttalande',0),(428928,11915,'it','Incassi diretti GL non su istruzione',0),(428929,11915,'tl','',0),(428930,11915,'th','GL à¹‚à¸”à¸¢à¸•à¸£à¸‡à¸£à¸±à¸šà¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸‡à¸š',0),(428931,11915,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· GL à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¯à¤¾à¤¨ à¤ªà¤° à¤¨à¤¹à¥€à¤‚',0),(428932,11915,'ms','Resit GL langsung tidak pada penyata',0),(428933,11915,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª GL Ù…Ø¨Ø§Ø´Ø±Ø© Ù„Ø§ ÙÙŠ Ø§Ù„Ø¨ÙŠØ§Ù†',0),(428934,11915,'fr','GL directs reÃ§us pas sur la dÃ©claration',0),(428935,11915,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã§ã¯ãªãç›´æŽ¥ GL é ˜åŽæ›¸',0),(428936,11915,'pt','Recibos GL direto nÃ£o na instruÃ§Ã£o',0),(428937,11915,'ru','ÐŸÑ€ÑÐ¼Ð¾Ð¹ GL ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð½Ðµ Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(428938,11915,'es','Recibos Directos de LM no Estan en el Estado de Cuenta',0),(428939,11915,'de','Direkte GL Einnahmen nicht auf Anweisung',0),(428940,11915,'en','Direct GL Receipts Not On Statement',0),(428941,11916,'is','',0),(428942,11916,'dr','Ù‡Ø¯Ø§ÛŒØª Ø±Ø³ÛŒØ¯Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(428943,11916,'pr','Ù‡Ø¯Ø§ÛŒØª Ø±Ø³ÛŒØ¯Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø¯Ø± ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(428944,11916,'tr','DoÄŸrudan GL makbuzlar ekstresi',0),(428945,11916,'pl','GL bezpoÅ›rednich wpÅ‚ywÃ³w na oÅ›wiadczenie',0),(428946,11916,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¾ GL Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(428947,11916,'ur','Ø¬ÛŒØ¬Û’ Ø±Ø³ÛŒØ¯ÛŒÚº Ø¨ÛŒØ§Ù† Ù¾Ø± Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª',0),(428948,11916,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(428949,11916,'vi','Sá»• cÃ¡i báº£ng kÃª thu tiá»n ',0),(428950,11916,'af','Direkte GL inkomstes op die staat',0),(428951,11916,'ro','ÃŽncasÄƒri GL directe pe declaraÅ£ie',0),(428952,11916,'et','Otsene GL laekumiste aruanne',0),(428953,11916,'si','Neposredno GL prejemki na izjavo',0),(428954,11916,'ba','Penerimaan langsung GL pada pernyataan',0),(428955,11916,'nl','Directe GL ontvangsten over de verklaring van',0),(428956,11916,'fi','Suora GL vastaanotot tiliotteessa',0),(428957,11916,'no','Direkte GL kvitteringer pÃ¥ uttalelse',0),(428958,11916,'da','Direkte GL kvitteringer pÃ¥ kontoudtog',0),(428959,11916,'ko','ë¬¸ì— ì§ì ‘ GL ì˜ìˆ˜ì¦',0),(428960,11916,'he','GL ×™×©×™×¨×” ×§×‘×œ×•×ª ×¢×œ ×”×”×¦×”×¨×”',0),(428961,11916,'el','Î†Î¼ÎµÏƒÎ· GL Ï€Î±ÏÎ±Î»Î±Î²Î­Ï‚ ÏƒÎµ Î´Î®Î»Ï‰ÏƒÎ·',0),(428962,11916,'zh','ç›´æŽ¥æ€»å¸ç¥¨æ®åœ¨è¯´æ˜Žä¸Š\r\n',0),(428963,11916,'sv','Direkt GL kvitton pÃ¥ uttalande',0),(428964,11916,'it','Incassi diretti GL su istruzione',0),(428965,11916,'tl','',0),(428966,11916,'th','GL à¹‚à¸”à¸¢à¸•à¸£à¸‡à¸£à¸±à¸šà¸‡à¸š',0),(428967,11916,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· GL à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¯à¤¾à¤¨ à¤ªà¤°',0),(428968,11916,'ms','GL terus resit penyata',0),(428969,11916,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª GL Ù…Ø¨Ø§Ø´Ø±Ø© Ø¹Ù„Ù‰ Ø¨ÙŠØ§Ù†',0),(428970,11916,'fr','GL directs reÃ§us sur dÃ©claration',0),(428971,11916,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã®ç›´æŽ¥ GL é ˜åŽæ›¸',0),(428972,11916,'pt','GL direto recibos na declaraÃ§Ã£o',0),(428973,11916,'ru','ÐŸÑ€ÑÐ¼Ñ‹Ðµ Ð¿Ð¾ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ GL Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(428974,11916,'es','Recibos Directos de LM Estan en el Estado de Cuenta',0),(428975,11916,'de','Direkte GL Einnahmen auf Anweisung',0),(428976,11916,'en','Direct GL Receipts On Statement',0),(428977,11917,'is','',0),(428978,11917,'dr','Ù‡Ø¯Ø§ÛŒØª Ø«Ø¨Øª Ø±Ø³ÛŒØ¯ Ø¯ÙØªØ± Ú©Ù„ ',0),(428979,11917,'pr','Ù‡Ø¯Ø§ÛŒØª Ø«Ø¨Øª Ø±Ø³ÛŒØ¯ Ø¯ÙØªØ± Ú©Ù„ ',0),(428980,11917,'tr','DoÄŸrudan GL makbuz giriÅŸleri',0),(428981,11917,'pl','BezpoÅ›rednie GL otrzymania wpisÃ³w',0),(428982,11917,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¾ Ð½Ð° Ð²Ð¿Ð¸ÑÐ²Ð°Ð½Ð¸ÑÑ‚Ð° GL Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ°',0),(428983,11917,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬ÛŒØ¬Û’ Ø±Ø³ÛŒØ¯ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(428984,11917,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° ÑÑ‚Ð°Ð²ÐºÐµ',0),(428985,11917,'vi','Ghi sá»• cÃ¡i trá»±c tiáº¿p cÃ¡c khoáº£n thu ',0),(428986,11917,'af','Direkte GL ontvangs inskrywings',0),(428987,11917,'ro','IntrÄƒrile de primirea directe GL',0),(428988,11917,'et','Otsene GL sissetuleku kanded',0),(428989,11917,'si','Prejemu postavke neposredno GL',0),(428990,11917,'ba','GL langsung menerima entri',0),(428991,11917,'nl','Directe GL ontvangst posten',0),(428992,11917,'fi','Suoraa GL kuitti',0),(428993,11917,'no','Direkte GL mottak oppfÃ¸ringer',0),(428994,11917,'da','Direkte GL modtagelsen poster',0),(428995,11917,'ko','ì§ì ‘ GL ì˜ìˆ˜ì¦ í•­ëª©',0),(428996,11917,'he','×¢×¨×›×™ ×§×‘×œ×” ×™×©×™×¨×” GL',0),(428997,11917,'el','GL Î¬Î¼ÎµÏƒÎ· Ï€Î±ÏÎ±Î»Î±Î²Î® ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(428998,11917,'zh','ç›´æŽ¥æ€»å¸ç¥¨æ®æ¡ç›®',0),(428999,11917,'sv','Direkt GL kvitto poster',0),(429000,11917,'it','Voci di ricevimento diretto GL',0),(429001,11917,'tl','',0),(429002,11917,'th','GL à¹‚à¸”à¸¢à¸•à¸£à¸‡à¸£à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£',0),(429003,11917,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· GL à¤°à¤¸à¥€à¤¦ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(429004,11917,'ms','GL terus resit penyertaan',0),(429005,11917,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ø³ØªÙ„Ø§Ù… GL Ù…Ø¨Ø§Ø´Ø±Ø©',0),(429006,11917,'fr','EntrÃ©es de rÃ©ception directe GL',0),(429007,11917,'jp','GL ã®é ˜åŽæ›¸ã®ã‚¨ãƒ³ãƒˆãƒªã‚’ç›´æŽ¥ã—ã¾ã™ã€‚',0),(429008,11917,'pt','Entradas de recepÃ§Ã£o directa GL',0),(429009,11917,'ru','ÐŸÑ€ÑÐ¼Ð¾Ðµ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ GL',0),(429010,11917,'es','Entradas de Recibos Directos de LM',0),(429011,11917,'de','Direkte GL Eingang EintrÃ¤ge',0),(429012,11917,'en','Direct GL Receipt Entries',0),(429013,11918,'is','',0),(429014,11918,'dr','Ø«Ø¨Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø¶Ø§Ø¶Ù‡ Ø´Ø¯',0),(429015,11918,'pr','Ø«Ø¨Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø¶Ø§Ø¶Ù‡ Ø´Ø¯',0),(429016,11918,'tr','Girdi baÅŸarÄ±yla eklendi',0),(429017,11918,'pl','Wpis dodany pomyÅ›lnie',0),(429018,11918,'bg','Ð’Ð»Ð¸Ð·Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(429019,11918,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(429020,11918,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(429021,11918,'vi','ÄÃ£ thÃªm vÃ o thÃ nh cÃ´ng',0),(429022,11918,'af','Inskrywing suksesvol bygevoeg',0),(429023,11918,'ro','Intrare adÄƒugat cu succes',0),(429024,11918,'et','Kirje lisamist edukalt',0),(429025,11918,'si','Vnos, dodan uspeÅ¡no',0),(429026,11918,'ba','Entri ditambahkan berhasil',0),(429027,11918,'nl','Item toegevoegd',0),(429028,11918,'fi','MerkinnÃ¤n lisÃ¤Ã¤minen onnistui',0),(429029,11918,'no','OppfÃ¸ringen ble lagt til',0),(429030,11918,'da','Post tilfÃ¸jet',0),(429031,11918,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ëœ í•­ëª©',0),(429032,11918,'he','×¢×¨×š × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(429033,11918,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(429034,11918,'zh','æˆåŠŸæ·»åŠ æ¡ç›®\r\n',0),(429035,11918,'sv','Post som lagts',0),(429036,11918,'it','Voce aggiunta con successo',0),(429037,11918,'tl','',0),(429038,11918,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸–à¸¹à¸à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(429039,11918,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(429040,11918,'ms','Penyertaan yang berjaya menambah',0),(429041,11918,'ar','Ø¯Ø®ÙˆÙ„ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(429042,11918,'fr','EntrÃ©e ajoutÃ©e avec succÃ¨s',0),(429043,11918,'jp','ã‚¨ãƒ³ãƒˆãƒªãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(429044,11918,'pt','Entrada adicionada com sucesso',0),(429045,11918,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(429046,11918,'es','Entrada Agregada Exitosamente',0),(429047,11918,'de','Eintrag erfolgreich hinzugefÃ¼gt',0),(429048,11918,'en','Entry Added Successfully',0),(429049,11919,'is','',0),(429050,11919,'dr','Ø¨Ù‡Ø±Ù‡ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(429051,11919,'pr','Ø¨Ù‡Ø±Ù‡ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(429052,11919,'tr','KazanÄ±lan faiz',0),(429053,11919,'pl','Odsetki',0),(429054,11919,'bg','Ð›Ð¸Ñ…Ð²Ð¸',0),(429055,11919,'ur','Ø³ÙˆØ¯ Ú©ÛŒ Ú©Ù…Ø§Ø¦ÛŒ',0),(429056,11919,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ð° Ñ˜Ðµ Ð·Ð°Ñ€Ð°Ð´Ð¸Ð¾',0),(429057,11919,'vi','lÃ£i suáº¥t kiáº¿m Ä‘Æ°á»£c',0),(429058,11919,'af','Rente',0),(429059,11919,'ro','Interes a cÃ¢ÅŸtigat',0),(429060,11919,'et','Teenitud intressid',0),(429061,11919,'si','ZasluÅ¾ene obresti',0),(429062,11919,'ba','Bunga yang diperoleh',0),(429063,11919,'nl','Rente',0),(429064,11919,'fi','Korkotuotot',0),(429065,11919,'no','Opptjente renter',0),(429066,11919,'da','Renter optjent',0),(429067,11919,'ko','ì¶©ë‹¹',0),(429068,11919,'he','×¨×™×‘×™×ª ×©× ×¦×‘×¨×”',0),(429069,11919,'el','Î”ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Î¿Î¹ Ï„ÏŒÎºÎ¿Î¹',0),(429070,11919,'zh','åˆ©æ¯ä¿éšœ\r\n',0),(429071,11919,'sv','RÃ¤nta',0),(429072,11919,'it','Interessi maturati',0),(429073,11919,'tl','',0),(429074,11919,'th','à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸š',0),(429075,11919,'hi','à¤…à¤°à¥à¤œà¤¿à¤¤ à¤¬à¥à¤¯à¤¾à¤œ',0),(429076,11919,'ms','Faedah yang diperolehi',0),(429077,11919,'ar','Ø§Ù„ÙØ§Ø¦Ø¯Ø© Ø§Ù„Ù…ÙƒØªØ³Ø¨Ø©',0),(429078,11919,'fr','IntÃ©rÃªts gagnÃ©s',0),(429079,11919,'jp','åˆ©æ¯',0),(429080,11919,'pt','Juros',0),(429081,11919,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(429082,11919,'es','Intereses Ganados',0),(429083,11919,'de','Die ZinsertrÃ¤ge',0),(429084,11919,'en','Interest Earned',0),(429085,11920,'is','',0),(429086,11920,'dr','Ø«Ø¨Øª Ø¯ÙØªØ± Ú©Ù„ Ø¬Ø¯ÛŒØ¯',0),(429087,11920,'pr','Ø«Ø¨Øª Ø¯ÙØªØ± Ú©Ù„ Ø¬Ø¯ÛŒØ¯',0),(429088,11920,'tr','Yeni GL giriÅŸ',0),(429089,11920,'pl','Nowy wpis w GL',0),(429090,11920,'bg','ÐÐ¾Ð² Ð·Ð°Ð¿Ð¸Ñ Ð² GL',0),(429091,11920,'ur','Ù†ÛŒØ§ Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(429092,11920,'sr','ÐÐ¾Ð²Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð“Ð›',0),(429093,11920,'vi','bÃºt toÃ¡n sá»• cÃ¡i má»›i',0),(429094,11920,'af','Nuwe GL inskrywing',0),(429095,11920,'ro','Noua intrare GL',0),(429096,11920,'et','GL sisestatuga',0),(429097,11920,'si','Nov vnos v GL',0),(429098,11920,'ba','Entri baru GL',0),(429099,11920,'nl','Nieuwkomer GL',0),(429100,11920,'fi','Uusi GL merkintÃ¤',0),(429101,11920,'no','Ny GL oppfÃ¸ring',0),(429102,11920,'da','Nye GL post',0),(429103,11920,'ko','ìƒˆë¡œìš´ GL í•­ëª©',0),(429104,11920,'he','×¢×¨×š ×—×“×© GL',0),(429105,11920,'el','ÎÎ­Î± ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· GL',0),(429106,11920,'zh','æ–°çš„æ€»å¸æ¡ç›®\r\n',0),(429107,11920,'sv','Ny GL post',0),(429108,11920,'it','Nuova voce GL',0),(429109,11920,'tl','',0),(429110,11920,'th','à¸£à¸²à¸¢à¸à¸²à¸£ GL',0),(429111,11920,'hi','à¤¨à¤ˆ GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(429112,11920,'ms','Entri GL baru',0),(429113,11920,'ar','Ø¥Ø¯Ø®Ø§Ù„ GL Ø¬Ø¯ÙŠØ¯',0),(429114,11920,'fr','Nouvelle entrÃ©e de GL',0),(429115,11920,'jp','æ–°ã—ã„ GL ã‚¨ãƒ³ãƒˆãƒª',0),(429116,11920,'pt','Nova entrada GL',0),(429117,11920,'ru','ÐÐ¾Ð²Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ GL',0),(429118,11920,'es','Nueva Entrada de LM',0),(429119,11920,'de','Neuen GL-Eintrag',0),(429120,11920,'en','New GL Entry',0),(429121,11921,'is','',0),(429122,11921,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(429123,11921,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(429124,11921,'tr','LÃ¼tfen bir hesap girin',0),(429125,11921,'pl','WprowadÅº konto',0),(429126,11921,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(429127,11921,'ur','Ø§ÛŒÚ© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(429128,11921,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð½ÐµÐºÐ¸ Ð½Ð°Ð»Ð¾Ð³',0),(429129,11921,'vi','vui lÃ²ng nháº­p tÃ i khoáº£n',0),(429130,11921,'af','Tik asseblief \'n rekening',0),(429131,11921,'ro','IntroduceÈ›i un cont',0),(429132,11921,'et','Sisestage konto',0),(429133,11921,'si','Vnesite raÄun',0),(429134,11921,'ba','Masukkan Account',0),(429135,11921,'nl','Voer een Account',0),(429136,11921,'fi','Kirjoita tilin',0),(429137,11921,'no','Angi en konto',0),(429138,11921,'da','Angiv en konto',0),(429139,11921,'ko','ê³„ì •ì„ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(429140,11921,'he','×× × ×”×–×Ÿ ×—×©×‘×•×Ÿ',0),(429141,11921,'el','Î Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÏ„Îµ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(429142,11921,'zh','è¯·è¾“å…¥ä¸€ä¸ªå¸æˆ·\r\n',0),(429143,11921,'sv','Ange ett konto',0),(429144,11921,'it','Si prega di inserire un Account',0),(429145,11921,'tl','',0),(429146,11921,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸šà¸±à¸à¸Šà¸µ',0),(429147,11921,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤–à¤¾à¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(429148,11921,'ms','Sila masukkan akaun',0),(429149,11921,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø­Ø³Ø§Ø¨',0),(429150,11921,'fr','Veuillez entrer un compte',0),(429151,11921,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(429152,11921,'pt','Por favor, digite uma conta',0),(429153,11921,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(429154,11921,'es','Por Favor Entra Una Cuenta',0),(429155,11921,'de','Bitte geben Sie ein Konto',0),(429156,11921,'en','Please Enter an Account',0),(429157,11922,'is','',0),(429158,11922,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ÙˆØ§Ø±Ø¯Ú©Ù†ÛŒØ¯ ',0),(429159,11922,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ÙˆØ§Ø±Ø¯Ú©Ù†ÛŒØ¯ ',0),(429160,11922,'tr','LÃ¼tfen bir miktar girin',0),(429161,11922,'pl','Podaj kwotÄ™',0),(429162,11922,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÑƒÐ¼Ð°',0),(429163,11922,'ur','Ø±Ù‚Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(429164,11922,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð·Ð½Ð¾Ñ',0),(429165,11922,'vi','vui lÃ²ng nháº­p sá»‘ tiá»n',0),(429166,11922,'af','Tik asseblief \'n bedrag',0),(429167,11922,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i o sumÄƒ',0),(429168,11922,'et','Sisestage summa',0),(429169,11922,'si','Vnesite znesek',0),(429170,11922,'ba','Masukkan jumlah',0),(429171,11922,'nl','Voer een bedrag',0),(429172,11922,'fi','SyÃ¶tÃ¤ summa',0),(429173,11922,'no','Skriv inn et belÃ¸p',0),(429174,11922,'da','Angiv et belÃ¸b',0),(429175,11922,'ko','ê¸ˆì•¡ì„ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(429176,11922,'he','× × ×œ×”×–×™×Ÿ ×¡×›×•×',0),(429177,11922,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ Ï€Î¿ÏƒÏŒ',0),(429178,11922,'zh','è¯·è¾“å…¥é‡‘é¢\r\n',0),(429179,11922,'sv','VÃ¤nligen ange ett belopp',0),(429180,11922,'it','Si prega di inserire un importo',0),(429181,11922,'tl','',0),(429182,11922,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸°à¸šà¸¸à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™',0),(429183,11922,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤°à¤¾à¤¶à¤¿ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(429184,11922,'ms','Sila masukkan jumlah',0),(429185,11922,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø¨Ù„Øº',0),(429186,11922,'fr','Veuillez entrer un montant',0),(429187,11922,'jp','é‡‘é¡ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(429188,11922,'pt','Por favor insira uma quantidade',0),(429189,11922,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÑƒÐ¼Ð¼Ñƒ',0),(429190,11922,'es','Por Favor Entra Una Cantidad',0),(429191,11922,'de','Bitte geben Sie einen Betrag',0),(429192,11922,'en','Please Enter an Amount',0),(429193,11923,'is','',0),(429194,11923,'dr',' Ù„Ø·ÙØ§ ÛŒÚ© ØªØ§Ø±ÛŒØ® Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(429195,11923,'pr',' Ù„Ø·ÙØ§ ÛŒÚ© ØªØ§Ø±ÛŒØ® Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(429196,11923,'tr','LÃ¼tfen bir tarih girin',0),(429197,11923,'pl','ProszÄ™ podaÄ‡ datÄ™',0),(429198,11923,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð°',0),(429199,11923,'ur','ØªØ§Ø±ÛŒØ® Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(429200,11923,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(429201,11923,'vi','vui lÃ²ng nháº­p má»™t ngÃ y',0),(429202,11923,'af','Tik asseblief \'n datum',0),(429203,11923,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i o datÄƒ',0),(429204,11923,'et','Sisesta kuupÃ¤ev',0),(429205,11923,'si','Vnesite datum',0),(429206,11923,'ba','Harap masukkan tanggal',0),(429207,11923,'nl','Voer een datum',0),(429208,11923,'fi','Kirjoita pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(429209,11923,'no','Angi en dato',0),(429210,11923,'da','Angiv en dato',0),(429211,11923,'ko','ë‚ ì§œë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(429212,11923,'he','× × ×”×–×Ÿ ×ª××¨×™×š',0),(429213,11923,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(429214,11923,'zh','è¯·è¾“å…¥æ—¥æœŸ\r\n',0),(429215,11923,'sv','Ange ett datum',0),(429216,11923,'it','Inserisci una data',0),(429217,11923,'tl','',0),(429218,11923,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸°à¸šà¸¸à¸§à¸±à¸™',0),(429219,11923,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(429220,11923,'ms','Sila masukkan tarikh',0),(429221,11923,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ®',0),(429222,11923,'fr','Veuillez entrer une Date',0),(429223,11923,'jp','æ—¥ä»˜ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(429224,11923,'pt','Por favor introduza uma data',0),(429225,11923,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ñƒ',0),(429226,11923,'es','Por Favor Entra Una Fecha',0),(429227,11923,'de','Bitte geben Sie ein Datum',0),(429228,11923,'en','Please Enter a Date',0),(429229,11924,'is','',0),(429230,11924,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ù¾ÛŒØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø®Ø¯Ù…Ø§Øª Ùˆ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(429231,11924,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ù¾ÛŒØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø®Ø¯Ù…Ø§Øª Ùˆ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(429232,11924,'tr','VarsayÄ±lan hesap servis Ã¼cretleri giriniz',0),(429233,11924,'pl','ProszÄ™ wprowadziÄ‡ domyÅ›lne konto opÅ‚aty za usÅ‚ugi',0),(429234,11924,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° ÑƒÑÐ»ÑƒÐ³Ð¸',0),(429235,11924,'ur','Ø§ÛŒÚ© Ø·Û’ Ø´Ø¯Û Ø¨ÛŒÙ†Ú© Ø³Ø±ÙˆØ³ Ú†Ø§Ø±Ø¬Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(429236,11924,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð±Ð°Ð½ÐºÐ¾Ð²Ð½Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(429237,11924,'vi','vui lÃ²ng nháº­p tÃ i khoáº£n máº·c Ä‘á»‹nh tráº£ phÃ­ ngÃ¢n hÃ ng',0),(429238,11924,'af','Tik asseblief \'n verstek diensgeld bankrekening',0),(429239,11924,'ro','IntroduceÈ›i un cont de serviciu taxe implicit bancar',0),(429240,11924,'et','Keskmine hinne: vaike panga teenustasu konto',0),(429241,11924,'si','Vnesite privzeto banÄni raÄun stroÅ¡kov storitev',0),(429242,11924,'ba','Masukkan biaya layanan rekening Default Bank',0),(429243,11924,'nl','Voer een standaard bankrekening servicekosten',0),(429244,11924,'fi','Kirjoita palvelumaksut oletuspankkitili',0),(429245,11924,'no','Angi en standard gebyrer bankkonto',0),(429246,11924,'da','Angiv en standard gebyrer bankkonto',0),(429247,11924,'ko','ê¸°ë³¸ ê³„ì¢Œ ì„œë¹„ìŠ¤ ìš”ê¸ˆì„ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(429248,11924,'he','×”×–×™× ×• ××ª ×—×©×‘×•×Ÿ ×©×™×¨×•×ª ×—×™×•×‘×™× ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×‘× ×§',0),(429249,11924,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼Î¹Î± Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï‡ÏÎµÏŽÏƒÎµÏ‰Î½',0),(429250,11924,'zh','è¯·è¾“å…¥ä¸€ä¸ªé»˜è®¤é“¶è¡ŒæœåŠ¡æ”¶è´¹å¸å·\r\n',0),(429251,11924,'sv','Ange en standard bankkonto serviceavgifter',0),(429252,11924,'it','Immettere un Account di servizio spese banca predefinita',0),(429253,11924,'tl','',0),(429254,11924,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸šà¸±à¸à¸Šà¸µ à¸˜à¸™à¸²à¸„à¸²à¸£à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸„à¹ˆà¸²à¸šà¸£à¸´à¸à¸²à¸£',0),(429255,11924,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¬à¥ˆà¤‚à¤• à¤¸à¥‡à¤µà¤¾ à¤¶à¥à¤²à¥à¤• à¤–à¤¾à¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(429256,11924,'ms','Sila masukkan akaun caj perkhidmatan Bank lalai',0),(429257,11924,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø­Ø³Ø§Ø¨ Ø±Ø³ÙˆÙ… Ø®Ø¯Ù…Ø© Ø§Ù„Ø¨Ù†Ùƒ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(429258,11924,'fr','Veuillez entrer un compte de frais de Service de banque par dÃ©faut',0),(429259,11924,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã®éŠ€è¡Œã®æ‰‹æ•°æ–™ã®å‹˜å®šç§‘ç›®ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(429260,11924,'pt','Por favor, digite uma conta padrÃ£o taxas de serviÃ§o',0),(429261,11924,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ð»Ð°Ñ‚Ð° Ð·Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(429262,11924,'es','Por Favor Entra Una Cuenta Por Defecto de Cargos de Servicios Bancarios',0),(429263,11924,'de','Bitte geben Sie ein Standard-Service-GebÃ¼hren Bankkonto',0),(429264,11924,'en','Please Enter a Default Bank Service Charges Account',0),(429265,11925,'is','',0),(429266,11925,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ù¾ÛŒØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯ Ø¨Ù‡Ø±Ù‡ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(429267,11925,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ù¾ÛŒØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯ Ø¨Ù‡Ø±Ù‡ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(429268,11925,'tr','LÃ¼tfen varsayÄ±lan faiz gelir hesabÄ± girin',0),(429269,11925,'pl','Podaj konto domyÅ›lne odsetek dochodÃ³w',0),(429270,11925,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð»Ð¸Ñ…Ð²ÐµÐ½ Ð´Ð¾Ñ…Ð¾Ð´',0),(429271,11925,'ur','Ø§ÛŒÚ© Ø·Û’ Ø´Ø¯Û Ø³ÙˆØ¯ Ø¢Ù…Ø¯Ù†ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(429272,11925,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÐºÐ°Ð¼Ð°Ñ‚Ð½Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ðµ',0),(429273,11925,'vi','vui lÃ²ng nháº­p tÃ i khoáº£n thu tiá»n lÃ£i máº·c Ä‘á»‹nh',0),(429274,11925,'af','Tik asseblief \'n verstek rente inkomste rekening',0),(429275,11925,'ro','IntroduceÈ›i un cont de venituri de interes implicit',0),(429276,11925,'et','Keskmine hinne: huvi tulu konto',0),(429277,11925,'si','Vnesite privzeti raÄun obresti dohodek',0),(429278,11925,'ba','Masukkan rekening pendapatan bunga Default',0),(429279,11925,'nl','Voer een standaard belang WenV-rekening',0),(429280,11925,'fi','Anna oletustili edun tulot',0),(429281,11925,'no','Angi en standardkonto for interesse inntekt',0),(429282,11925,'da','Angiv en standard interesse resultatopgÃ¸relseskontoen',0),(429283,11925,'ko','ê¸°ë³¸ ì´ìž ìˆ˜ìµ ê³„ì • ìž…ë ¥',0),(429284,11925,'he','×× × ×”×–×Ÿ ×—×©×‘×•×Ÿ ×”×›× ×¡×•×ª ×¨×™×‘×™×ª ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(429285,11925,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î´Î¹Î±Î½Î¿Î¼Î®Ï‚ ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½',0),(429286,11925,'zh','è¯·è¾“å…¥ä¸€ä¸ªé»˜è®¤çš„åˆ©æ¯æ”¶ç›Šå¸å·\r\n',0),(429287,11925,'sv','Ange en standardkonto intresse inkomst',0),(429288,11925,'it','Si prega di inserire un Account predefinito del reddito di interesse',0),(429289,11925,'tl','',0),(429290,11925,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸šà¸±à¸à¸Šà¸µà¸£à¸²à¸¢à¹„à¸”à¹‰à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(429291,11925,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¬à¥à¤¯à¤¾à¤œ à¤†à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(429292,11925,'ms','Sila masukkan akaun pendapatan faedah yang lalai',0),(429293,11925,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø­Ø³Ø§Ø¨ Ø¯Ø®Ù„ Ø§Ù‡ØªÙ…Ø§Ù… Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(429294,11925,'fr','Veuillez entrer un compte de revenu d\'intÃ©rÃªt par dÃ©faut',0),(429295,11925,'jp','æ—¢å®šåˆ©å­æ‰€å¾—ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(429296,11925,'pt','Por favor, digite uma conta de rendimento de juros padrÃ£o',0),(429297,11925,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ñ‹Ðµ Ð´Ð¾Ñ…Ð¾Ð´Ñ‹',0),(429298,11925,'es','Por Favor Entra Una Cuenta Por Defecto de Ingresos Por InterÃ©ses',0),(429299,11925,'de','Bitte geben Sie ein Standardkonto Interesse Einkommen',0),(429300,11925,'en','Please Enter a Default Interest Income Account',0),(429301,11926,'is','',0),(429302,11926,'dr','Ù„Ø·ÙØ§ ÛŒÚ© ØªÙˆØ¶ÛŒØ­ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(429303,11926,'pr','Ù„Ø·ÙØ§ ÛŒÚ© ØªÙˆØ¶ÛŒØ­ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(429304,11926,'tr','LÃ¼tfen bir aÃ§Ä±klama girin',0),(429305,11926,'pl','WprowadÅº opis',0),(429306,11926,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(429307,11926,'ur','ØªØµØ±ÛŒØ­ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(429308,11926,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¾Ð¿Ð¸Ñ',0),(429309,11926,'vi','vui lÃ²ng nháº­p mÃ´ táº£',0),(429310,11926,'af','Sleutel asseblief \'n beskrywing',0),(429311,11926,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i o descriere',0),(429312,11926,'et','Sisestage kirjeldus',0),(429313,11926,'si','Vnesite opis',0),(429314,11926,'ba','Silakan masukkan keterangan',0),(429315,11926,'nl','Voer een beschrijving in',0),(429316,11926,'fi','Kirjoita kuvaus',0),(429317,11926,'no','Skriv inn en beskrivelse',0),(429318,11926,'da','Angiv en beskrivelse',0),(429319,11926,'ko','ëŒ€ í•œ ì„¤ëª… ìž…ë ¥',0),(429320,11926,'he','×× × ×”×–×Ÿ ×ª×™××•×¨',0),(429321,11926,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼Î¹Î± Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(429322,11926,'zh','è¯·è¾“å…¥è¯´æ˜Ž\r\n',0),(429323,11926,'sv','Ange en beskrivning',0),(429324,11926,'it','Inserisci una descrizione',0),(429325,11926,'tl','',0),(429326,11926,'th','à¸à¸£à¸¸à¸“à¸²à¸›à¹‰à¸­à¸™à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢',0),(429327,11926,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤µà¤°à¥à¤£à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(429328,11926,'ms','Sila masukkan Perihalan',0),(429329,11926,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ ÙˆØµÙØ§Ù‹',0),(429330,11926,'fr','Veuillez entrer une Description',0),(429331,11926,'jp','èª¬æ˜Žã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(429332,11926,'pt','Por favor, digite uma descriÃ§Ã£o',0),(429333,11926,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(429334,11926,'es','Por Favor Entra Una DescripciÃ³n',0),(429335,11926,'de','Bitte geben Sie eine Beschreibung',0),(429336,11926,'en','Please Enter a Description',0),(429337,11927,'is','',0),(429338,11927,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø®Ø¯Ù…Ø§Øª',0),(429339,11927,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø®Ø¯Ù…Ø§Øª',0),(429340,11927,'tr','Servis Ã¼cretleri',0),(429341,11927,'pl','OpÅ‚aty za usÅ‚ugi',0),(429342,11927,'bg','Ð¢Ð°ÐºÑÐ¸ Ð·Ð° ÑƒÑÐ»ÑƒÐ³Ð¸',0),(429343,11927,'ur','Ø³Ø±ÙˆØ³ Ú†Ø§Ø±Ø¬Ø²',0),(429344,11927,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(429345,11927,'vi','PhÃ­ Dá»‹ch vá»¥',0),(429346,11927,'af','Diensgeld',0),(429347,11927,'ro','Serviciul de taxe',0),(429348,11927,'et','Teenustasud',0),(429349,11927,'si','StroÅ¡ki storitev',0),(429350,11927,'ba','Biaya layanan',0),(429351,11927,'nl','Servicekosten',0),(429352,11927,'fi','Palvelumaksut',0),(429353,11927,'no','Avgifter',0),(429354,11927,'da','Gebyrer',0),(429355,11927,'ko','ì„œë¹„ìŠ¤ ìš”ê¸ˆ',0),(429356,11927,'he','×©×™×¨×•×ª ×—×™×•×‘×™×',0),(429357,11927,'el','Î§ÏÎµÏŽÏƒÎµÎ¹Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½',0),(429358,11927,'zh','æœåŠ¡æ”¶è´¹\r\n',0),(429359,11927,'sv','Serviceavgifter',0),(429360,11927,'it','Spese di servizio',0),(429361,11927,'tl','',0),(429362,11927,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸šà¸£à¸´à¸à¸²à¸£',0),(429363,11927,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(429364,11927,'ms','Caj Perkhidmatan',0),(429365,11927,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø®Ø¯Ù…Ø©',0),(429366,11927,'fr','Frais de service',0),(429367,11927,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ–™',0),(429368,11927,'pt','Taxas de serviÃ§o',0),(429369,11927,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(429370,11927,'es','Cargos de Servicios',0),(429371,11927,'de','Service-GebÃ¼hren',0),(429372,11927,'en','Service Charges',0),(429373,11928,'is','',0),(429374,11928,'dr',' Ù…Ø¯ÛŒØ±ÛŒØª Ø­Ø³Ø§Ø¨ Ù…ÛŒØ²Ø¨Ø§Ù†ÛŒ ',0),(429375,11928,'pr',' Ù…Ø¯ÛŒØ±ÛŒØª Ø­Ø³Ø§Ø¨ Ù…ÛŒØ²Ø¨Ø§Ù†ÛŒ ',0),(429376,11928,'tr','BarÄ±ndÄ±rÄ±lan hesabÄ± YÃ¶net',0),(429377,11928,'pl','ZarzÄ…dzanie akademik konta',0),(429378,11928,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð´Ð¾Ð¼Ð°ÐºÐ¸Ð½ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(429379,11928,'ur','Ù…ÛŒØ²Ø¨Ø§Ù† Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±ÛŒÚº',0),(429380,11928,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ñ˜Ð°Ð²Ð½Ð¸Ñ… Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(429381,11928,'vi','TÃ i khoáº£n quáº£n lÃ½',0),(429382,11928,'af','Bestuur gehuisves rekening',0),(429383,11928,'ro','Gestiona contul gÄƒzduit',0),(429384,11928,'et','Hosted konto haldamine',0),(429385,11928,'si','Upravljaj raÄun, gostila',0),(429386,11928,'ba','Mengelola Account host',0),(429387,11928,'nl','Gehoste Account beheren',0),(429388,11928,'fi','IsÃ¤nnÃ¶i tilin hallinta',0),(429389,11928,'no','Administrere Hosted konto',0),(429390,11928,'da','Administrere Hosted konto',0),(429391,11928,'ko','í˜¸ìŠ¤íŒ…ëœ ê³„ì • ê´€ë¦¬',0),(429392,11928,'he','×œ× ×”×œ ××ª ×”×—×©×‘×•×Ÿ ×ž×ª××¨×—',0),(429393,11928,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Ï†Î¹Î»Î¿Î¾ÎµÎ½Î®ÏƒÎµÎ¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(429394,11928,'zh','åŽå°ç®¡ç†æ‰˜ç®¡å¸æˆ·\r\n',0),(429395,11928,'sv','Hantera vÃ¤rd konto',0),(429396,11928,'it','Gestire Account di hosting',0),(429397,11928,'tl','',0),(429398,11928,'th','à¸ˆà¸±à¸”à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹‚à¸®à¸ªà¸•à¹Œ',0),(429399,11928,'hi','à¤¹à¥‹à¤¸à¥à¤Ÿà¥‡à¤¡ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(429400,11928,'ms','Menguruskan akaun dihos',0),(429401,11928,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ØŒ Ø§Ø³ØªØ¶Ø§ÙØª',0),(429402,11928,'fr','GÃ©rer le compte hÃ©bergÃ©',0),(429403,11928,'jp','ãƒ›ã‚¹ãƒˆã•ã‚Œã¦ã„ã‚‹ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ç®¡ç†ã—ã¾ã™ã€‚',0),(429404,11928,'pt','Gerenciar conta hospedada',0),(429405,11928,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð½Ð¾Ð¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(429406,11928,'es','Administrar Una Cuenta Hospedada',0),(429407,11928,'de','Gehostetes Konto verwalten',0),(429408,11928,'en','Manage Hosted Account',0),(429409,11929,'is','',0),(429410,11929,'dr','2',0),(429411,11929,'pr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† 2',0),(429412,11929,'tr','EtkinleÅŸtirme',0),(429413,11929,'pl','AktywowaÄ‡',0),(429414,11929,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ',0),(429415,11929,'ur','Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(429416,11929,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°ÑšÐµ',0),(429417,11929,'vi','KÃ­ch hoáº¡t',0),(429418,11929,'af','Aktiveer',0),(429419,11929,'ro','Activa',0),(429420,11929,'et','Aktiveerimine',0),(429421,11929,'si','Aktiviranje',0),(429422,11929,'ba','Aktifkan',0),(429423,11929,'nl','Activeren',0),(429424,11929,'fi','Aktivoi',0),(429425,11929,'no','Aktivere',0),(429426,11929,'da','Aktivere',0),(429427,11929,'ko','í™œì„±í™”',0),(429428,11929,'he','×œ×”×¤×¢×™×œ',0),(429429,11929,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(429430,11929,'zh','æ¿€æ´»',0),(429431,11929,'sv','Aktivera',0),(429432,11929,'it','Attivare',0),(429433,11929,'tl','',0),(429434,11929,'th','à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(429435,11929,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(429436,11929,'ms','Aktifkan',0),(429437,11929,'ar','ØªÙ†Ø´ÙŠØ·',0),(429438,11929,'fr','Activer',0),(429439,11929,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã«ã—ã¾ã™ã€‚',0),(429440,11929,'pt','Ativar',0),(429441,11929,'ru','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(429442,11929,'es','Activar',0),(429443,11929,'de','Aktivieren',0),(429444,11929,'en','Activate',0),(429445,11930,'is','',0),(429446,11930,'dr','Ú¯Ø±ÙØªÙ† ÙØ§Ú©ØªÙˆØ±',0),(429447,11930,'pr','Ú¯Ø±ÙØªÙ† ÙØ§Ú©ØªÙˆØ±',0),(429448,11930,'tr','FaturalarÄ± getir',0),(429449,11930,'pl','UzyskaÄ‡ faktury',0),(429450,11930,'bg','Ð’Ð·ÐµÐ¼Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(429451,11930,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(429452,11930,'sr','ÐŸÐ¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð°',0),(429453,11930,'vi','Nháº­n Ä‘Æ°á»£c hÃ³a Ä‘Æ¡n',0),(429454,11930,'af','Fakture te kry',0),(429455,11930,'ro','Primi facturi',0),(429456,11930,'et','Saad arvetele',0),(429457,11930,'si','ZasluÅ¾iti raÄunov',0),(429458,11930,'ba','Mendapatkan faktur',0),(429459,11930,'nl','Facturen krijgen',0),(429460,11930,'fi','Saada laskut',0),(429461,11930,'no','FÃ¥ fakturaer',0),(429462,11930,'da','FÃ¥ fakturaer',0),(429463,11930,'ko','ì¸ë³´ì´ìŠ¤ë¥¼ ì–»ì„',0),(429464,11930,'he','×ž×§×‘×œ ×—×©×‘×•× ×™×•×ª',0),(429465,11930,'el','Î Î¬ÏÎµÏ„Îµ Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(429466,11930,'zh','å¾—åˆ°å‘ç¥¨',0),(429467,11930,'sv','FÃ¥ fakturor',0),(429468,11930,'it','Ottenere le fatture',0),(429469,11930,'tl','',0),(429470,11930,'th','à¹„à¸”à¹‰à¸£à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(429471,11930,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(429472,11930,'ms','Mendapatkan invois',0),(429473,11930,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(429474,11930,'fr','Obtenez des factures',0),(429475,11930,'jp','è«‹æ±‚æ›¸ã‚’å–å¾—ã—ã¾ã™ã€‚',0),(429476,11930,'pt','Obter faturas',0),(429477,11930,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(429478,11930,'es','Obtener facturas',0),(429479,11930,'de','Rechnungen zu erhalten',0),(429480,11930,'en','Get Invoices',0),(429481,11931,'is','',0),(429482,11931,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù¾ÙˆÙ„ Ø±Ø§ÛŒØ¬ Ú©Ù‡ Ø´Ù…Ø§ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø¨Ù‡ Ù†Ù…Ø§ÛŒØ´ Ø¯Ø± ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø²ÛŒØ± Ù„ÛŒØ³Øª',0),(429483,11931,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù¾ÙˆÙ„ Ø±Ø§ÛŒØ¬ Ú©Ù‡ Ø´Ù…Ø§ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø¨Ù‡ Ù†Ù…Ø§ÛŒØ´ Ø¯Ø± ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø²ÛŒØ± Ù„ÛŒØ³Øª',0),(429484,11931,'tr','Para birimini gÃ¶stermek istiyorum faturalarÄ± seÃ§mek aÅŸaÄŸÄ±daki listeden',0),(429485,11931,'pl','WybraÄ‡ jakiej walucie faktury moÅ¼esz chcesz pokazaÄ‡ w poniÅ¼ej listy',0),(429486,11931,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ñ Ð²Ð°Ð»ÑƒÑ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸, Ð²Ð¸Ðµ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚ Ð² Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ ÑÐ¿Ð¸ÑÑŠÐº',0),(429487,11931,'ur','Ø¬Ùˆ Ú©Ø±Ù†Ø³ÛŒ Ø¢Ù¾ Ú†Ø§ÛØªÛ’ ÛÛŒÚº Ú©Ùˆ Ø´Ùˆ Ù…ÛŒÚº ÙˆØ¨Ø¬Ù„ÛŒ Ú†Ù†ÛŒÚº Ù†ÛŒÚ†Û’ ÙÛØ±Ø³Øª',0),(429488,11931,'sr','ÐŸÐ¾ ÐºÐ¾Ñ˜Ð¾Ñ˜ Ð²Ð°Ð»ÑƒÑ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ñ‚Ðµ Ð¶ÐµÐ»Ð¸Ð¼ Ð´Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ðµ Ñƒ Ð¸ Ð¸ÑÐ¿Ð¾Ð´ Ð»Ð¸ÑÑ‚Ðµ',0),(429489,11931,'vi','Chá»n thu mÃ  hÃ³a Ä‘Æ¡n báº¡n muá»‘n hiá»ƒn thá»‹ trong cÃ¡c bÃªn dÆ°á»›i danh sÃ¡ch',0),(429490,11931,'af','Kies watter geldeenheid fakturering jy wil om te wys In die onderstaande lys',0),(429491,11931,'ro','Alege moneda care factureazÄƒ vÄƒ doresc sÄƒ AratÄƒ Ã®n lista de mai jos',0),(429492,11931,'et','Vali valuuta arved tahavad nÃ¤idata selle loendi all',0),(429493,11931,'si','Izbrati, kateri valuti raÄuni vam Å¾elim pokazati v je pod seznamom',0),(429494,11931,'ba','Memilih mata uang tagihan Anda ingin Tampilkan di bawah daftar',0),(429495,11931,'nl','Kies welke valuta facturen u wilt weergeven In de onderstaande lijst',0),(429496,11931,'fi','Valitse, mitÃ¤ valuuttaa laskut haluat osoittaa alla',0),(429497,11931,'no','Velg hvilken valuta fakturaer du vil vise i den listen nedenfor',0),(429498,11931,'da','VÃ¦lge, hvilken valuta fakturaer du Ã¸nsker at vise i den nedenstÃ¥ende liste',0),(429499,11931,'ko','ì–´ë–¤ í†µí™” ì²­êµ¬ì„œ ë‹¹ì‹ ì— í‘œì‹œ í•˜ ê³  ì„ íƒ ëœ ëª©ë¡',0),(429500,11931,'he','×œ×‘×—×•×¨ ××™×–×” ×ž×˜×‘×¢ ×—×©×‘×•× ×™×•×ª ××ª×” ×¨×•×¦×” ×”×¦×’ ×ž×ª×—×ª ×œ×¨×©×™×ž×ª',0),(429501,11931,'el','Î•Ï€Î¹Î»Î­Î¾ÎµÏ„Îµ Ï€Î¿Î¹Î¿ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î± ÏƒÎ±Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³ÎµÎ¯ Î¸Î­Î»Î¿Ï…Î½ Î½Î± Î´ÎµÎ¯Ï‡Î½Î¿Ï…Î½ ÏƒÏ„Î·Î½ Ï„Î·Î½ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î»Î¯ÏƒÏ„Î±',0),(429502,11931,'zh','é€‰æ‹©å“ªäº›è´§å¸å‘ç¥¨è¦åœ¨ä¸‹åˆ—æ˜¾ç¤ºåˆ—è¡¨\r\n',0),(429503,11931,'sv','VÃ¤lj vilken valuta fakturor du vill visa i den listan nedan',0),(429504,11931,'it','Scegliere quale valuta fatture si vuole Show nel seguente elenco',0),(429505,11931,'tl','',0),(429506,11931,'th','à¹€à¸¥à¸·à¸­à¸à¸§à¹ˆà¸²à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹à¸ªà¸”à¸‡à¹ƒà¸™à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£',0),(429507,11931,'hi','à¤•à¤¿à¤¸ à¤®à¥à¤¦à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤†à¤ª à¤šà¤¾à¤²à¤¾à¤¨ à¤²à¥‡à¤¨à¥‡ à¤¨à¥€à¤šà¥‡ à¤¸à¥‚à¤šà¥€',0),(429508,11931,'ms','Pilih invois Mata Wang yang anda mahu Papar di dalam di bawah senarai',0),(429509,11931,'ar','Ø§Ø®ØªÙŠØ§Ø± ÙÙˆØ§ØªÙŠØ± Ù„Ùƒ Ø§Ù„Ø¹Ù…Ù„Ø© Ø§Ù„ØªÙŠ ØªØ±ÙŠØ¯ Ø£Ù† ØªØ¸Ù‡Ø± ÙÙŠ Ø£Ø³ÙÙ„ Ù‚Ø§Ø¦Ù…Ø©',0),(429510,11931,'fr','Choisir quelle monnaie factures vous voulez afficher dans la liste ci-dessous',0),(429511,11931,'jp','ã©ã®é€šè²¨ã§è¡¨ç¤ºã—ãŸã„ã‚’è«‹æ±‚ã‚’é¸æŠžã€ãƒªã‚¹ãƒˆã®ä¸‹',0),(429512,11931,'pt','Escolher qual moeda faturas vocÃª quer mostrar na lista abaixo',0),(429513,11931,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ, ÐºÐ°ÐºÐ¾Ð¹ Ð²Ð°Ð»ÑŽÑ‚Ðµ ÑÑ‡ÐµÑ‚Ð° Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð² ÑÐ¿Ð¸ÑÐºÐµ',0),(429514,11931,'es','Elegir quÃ© moneda facturas desea mostrar en la lista abajo',0),(429515,11931,'de','WÃ¤hlen Sie welche WÃ¤hrung Sie wollen anzeigen In Rechnungen die Liste',0),(429516,11931,'en','Pick Which Currency Invoices You Want To Show In the Below List',0),(429517,11932,'is','',0),(429518,11932,'dr','Ù‡Ù…Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ù…Ø±Ø§Ù‡ Ø¨Ø§ Ø§Ø¹ØªØ¨Ø§Ø±Ø§Øª Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(429519,11932,'pr','Ù‡Ù…Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ù…Ø±Ø§Ù‡ Ø¨Ø§ Ø§Ø¹ØªØ¨Ø§Ø±Ø§Øª Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(429520,11932,'tr','TÃ¼m Ã¶demeler ile birlikte verilen tarih aralÄ±ÄŸÄ±nda uygulanan kredi',0),(429521,11932,'pl','Wszystkie pÅ‚atnoÅ›ci z kredytÃ³w w danym zakres dat.',0),(429522,11932,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð·Ð°ÐµÐ´Ð½Ð¾ Ñ Ð¿Ñ€ÐµÐ¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð² Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(429523,11932,'ur','ØªÙ…Ø§Ù… Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ø¯ÛŒ Ú¯Ø¦ÛŒ ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…ÛŒÚº Ø§Ø·Ù„Ø§Ù‚ Ú©Û’ Ø³Ø§ØªÚ¾ Ø³Ø§ØªÚ¾',0),(429524,11932,'sr','Ð¡Ð²Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð·Ð°Ñ˜ÐµÐ´Ð½Ð¾ ÑÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸Ð¼Ð° Ð¿Ñ€Ð¸Ð¼ÐµÑšÐµÐ½Ð° Ñƒ Ð´Ð°Ñ‚Ð¾Ð¼ Ð¾Ð¿ÑÐµÐ³Ñƒ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(429525,11932,'vi','Táº¥t cáº£ cÃ¡c khoáº£n thanh toÃ¡n cÃ¹ng vá»›i Ã¡p dá»¥ng trong pháº¡m vi ngÃ y cho trÆ°á»›c cÃ¡c khoáº£n tÃ­n dá»¥ng',0),(429526,11932,'af','Alle betalings saam met erkennings In die gegewe datum reeks toegepas',0),(429527,11932,'ro','Toate plÄƒÅ£ile cu credite aplicate Ã®n intervalul de Date dat',0),(429528,11932,'et','KÃµik maksed koos krediiti antud kuupÃ¤evavahemikku rakendatakse',0),(429529,11932,'si','Vsa plaÄila, skupaj s krediti, ki se uporabljajo v danem datumskem obsegu',0),(429530,11932,'ba','Semua pembayaran dengan kredit yang diterapkan dalam rentang tanggal tertentu',0),(429531,11932,'nl','Alle betalingen samen met Credits toegepast In het opgegeven datumbereik',0),(429532,11932,'fi','Kaikki maksut ja hyvitykset tietyllÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤vÃ¤lillÃ¤',0),(429533,11932,'no','Alle betalinger med kreditt brukes i det angitte datoomrÃ¥det',0),(429534,11932,'da','Alle betalinger sammen med kreditter anvendes i det angivne datointerval',0),(429535,11932,'ko','íŠ¹ì •ëœ ë‚ ì§œ ë²”ìœ„ì— ì ìš© í•˜ëŠ” í¬ë ˆë”§ê³¼ í•¨ê»˜ ëª¨ë“  ê²°ì œ',0),(429536,11932,'he','×›×œ ×”×ª×©×œ×•×ž×™× ×™×—×“ ×¢× ×§×¨×“×™×˜×™× ×œ×™×™×©× ××ª ×˜×•×•×— ×”×ª××¨×™×›×™× × ×ª×•×Ÿ',0),(429537,11932,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î¼Î±Î¶Î¯ Î¼Îµ Ï€Î¹ÏƒÏ„ÏŽÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… ÎµÏ†Î±ÏÎ¼ÏŒÎ¶Î¿Î½Ï„Î±Î¹ ÏƒÎµ Î´ÎµÎ´Î¿Î¼Î­Î½Î· Ï‡ÏÎ¿Î½Î¹ÎºÎ®',0),(429538,11932,'zh','æ‰€æœ‰ä»˜æ¬¾ä¸ŽèµŠæ¬¾åœ¨ç»™å®šçš„æ—¥æœŸèŒƒå›´åº”ç”¨\r\n',0),(429539,11932,'sv','Alla betalningar med krediter tillÃ¤mpas i viss datumintervall',0),(429540,11932,'it','Tutti i pagamenti con crediti applicati In un determinato intervallo di Date',0),(429541,11932,'tl','',0),(429542,11932,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸žà¸£à¹‰à¸­à¸¡à¸à¸±à¸šà¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸µà¹ˆà¹ƒà¸Šà¹‰à¹ƒà¸™à¸Šà¹ˆà¸§à¸‡à¸§à¸±à¸™à¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”',0),(429543,11932,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿà¥à¤¸ à¤®à¥‡à¤‚ à¤¦à¤¿à¤ à¤—à¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤ªà¤° à¤²à¤¾à¤—à¥‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤¾à¤¥ à¤¸à¤­à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(429544,11932,'ms','Semua pembayaran bersama-sama dengan kredit digunakan dalam julat tarikh yang diberikan',0),(429545,11932,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¬Ù†Ø¨Ø§ Ø¥Ù„Ù‰ Ø¬Ù†Ø¨ Ù…Ø¹ Ø¯Ø§Ø¦Ù†Ø© ÙÙŠ Ù†Ø·Ø§Ù‚ ØªØ§Ø±ÙŠØ® Ù…Ø¹ÙŠÙ†',0),(429546,11932,'fr','Tous les paiements ainsi que de crÃ©dits appliquÃ©s dans la plage de dates donnÃ©e',0),(429547,11932,'jp','æŒ‡å®šã—ãŸæ—¥ä»˜ç¯„å›²ã«é©ç”¨ã•ã‚Œã‚‹ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã¨ä¸€ç·’ã«ã™ã¹ã¦ã®æ”¯æ‰•ã„',0),(429548,11932,'pt','Todos os pagamentos junto com crÃ©ditos aplicados na faixa determinada data',0),(429549,11932,'ru','Ð’ÑÐµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð²Ð¼ÐµÑÑ‚Ðµ Ñ Ð·Ð°Ñ‡Ñ‚ÐµÐ½Ð½Ñ‹Ðµ Ð² Ð·Ð°Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚',0),(429550,11932,'es','Todos los pagos junto con crÃ©ditos aplicados en el intervalo de fechas determinado',0),(429551,11932,'de','Alle Zahlungen zusammen mit Credits, die In dem angegebenen Datumsbereich angewendet',0),(429552,11932,'en','All Payments Along With Credits Applied In The Given Date Range',0),(429553,11933,'is','',0),(429554,11933,'dr','Ù‡Ù…Ù‡ Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø± ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ùˆ Ø§Ø¹ØªØ¨Ø§Ø±Ø§Øª Ø¨Ø§ ÙØ§Ú©ØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ù†Ù…Ø§ÛŒØ´ Ø¯Ø§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(429555,11933,'pr','Ù‡Ù…Ù‡ Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø± ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ùˆ Ø§Ø¹ØªØ¨Ø§Ø±Ø§Øª Ø¨Ø§ ÙØ§Ú©ØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ù†Ù…Ø§ÛŒØ´ Ø¯Ø§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(429556,11933,'tr','TÃ¼m bekleyen faturalarÄ± ve kredi verilen tarih aralÄ±ÄŸÄ±nda Ã¶denen faturalar ile birlikte gÃ¶rÃ¼ntÃ¼lenir.',0),(429557,11933,'pl','Wszystkie faktury i kredytÃ³w sÄ… wyÅ›wietlane razem z faktur zapÅ‚acone w danym zakres dat.',0),(429558,11933,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ñ‡Ð°ÐºÐ°Ñ‰Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸ ÑÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚ Ð·Ð°ÐµÐ´Ð½Ð¾ Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸, Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð¿Ñ€ÐµÐ· Ð´Ð°Ð´ÐµÐ½ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(429559,11933,'ur','ØªÙ…Ø§Ù… ÙˆØ¨Ø¬Ù„ÛŒ Ø§ÙˆØ± Ú©Ø±ÛŒÚˆÙ¹ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§ Ø¯ÛŒ Ú¯Ø¦ÛŒ ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…ÛŒÚº Ø§Ø¯Ø§ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø³Ø§ØªÚ¾ Ø¯Ú©Ú¾Ø§Ø¦Û’ Ø¬Ø§ØªÛ’ ÛÛŒÚº',0),(429560,11933,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð°Ð½Ðµ ÑÑƒ ÑÐ²Ðµ Ð½ÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸Ñ… Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸ ÑˆÐ¿Ð¸Ñ†Ð° Ð·Ð°Ñ˜ÐµÐ´Ð½Ð¾ ÑÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð° Ð¿Ð»Ð°Ñ‚Ð¸Ð¾ Ð´Ð°Ñ‚Ð¾Ð¼ Ð¾Ð¿ÑÐµÐ³Ñƒ',0),(429561,11933,'vi','Táº¥t cáº£ Ä‘ang chá» xá»­ lÃ½ hoÃ¡ Ä‘Æ¡n vÃ  cÃ¡c khoáº£n tÃ­n dá»¥ng Ä‘Æ°á»£c hiá»ƒn thá»‹ cÃ¹ng vá»›i hÃ³a Ä‘Æ¡n thanh toÃ¡n trong pháº¡m vi ngÃ y cho trÆ°á»›c',0),(429562,11933,'af','Al hangende fakture en erkennings word vertoon saam met fakture betaal In die gegewe datum reeks',0),(429563,11933,'ro','Tot Ã®n aÅŸteptarea facturi ÅŸi credite sunt afiÅŸate Ã®mpreunÄƒ cu facturi achitate Ã®n intervalul de Date dat',0),(429564,11933,'et','KÃµik arved ja krediiti kuni kuvatakse koos makstud antud kuupÃ¤evavahemikku arved',0),(429565,11933,'si','Vseh nereÅ¡enih raÄunov in krediti so prikazani skupaj z raÄuni plaÄani v danem datumskem obsegu',0),(429566,11933,'ba','Semua tertunda faktur dan kredit ditampilkan bersama dengan faktur dibayar dalam rentang tanggal tertentu',0),(429567,11933,'nl','Alle uitstaande facturen en Credits worden samen met facturen betaald In het opgegeven datumbereik weergegeven',0),(429568,11933,'fi','Kaikki laskut ja hyvitykset nÃ¤kyvÃ¤t laskut maksetaan tietyllÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤vÃ¤lillÃ¤',0),(429569,11933,'no','Alle ventende fakturaer og kreditter vises sammen med fakturaer som betales i det angitte datoomrÃ¥det',0),(429570,11933,'da','Alle ventende fakturaer og kreditter vises sammen med fakturaer betalt i det angivne datointerval',0),(429571,11933,'ko','ëª¨ë“  ì²­êµ¬ì„œ ë° í•™ì  ë³´ë¥˜ ì¤‘ì¸ ì§€ì • ëœ ë‚ ì§œ ë²”ìœ„ì—ì„œ ì§€ê¸‰ ì²­êµ¬ì„œì™€ í•¨ê»˜ í‘œì‹œ ë©ë‹ˆë‹¤.',0),(429572,11933,'he','×›×œ ×ž×ž×ª×™× ×™× ×—×©×‘×•× ×™×•×ª ×•×©×ž×•×ª ×™×•×¦×¨×™× ×ž×•×¦×’×™× ×™×—×“ ×¢× ×—×©×‘×•× ×™×•×ª ×©×•×œ×ž×• ×‘×ª×•×š ×˜×•×•×— ×”×ª××¨×™×›×™× × ×ª×•×Ÿ',0),(429573,11933,'el','ÎŒÎ»Ï‰Î½ Ï„Ï‰Î½ ÎµÎºÎºÏÎµÎ¼ÏŽÎ½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½ ÎºÎ±Î¹ Ï€Î¹ÏƒÏ„ÏŽÏƒÎµÎ¹Ï‚ ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ Î¼Î±Î¶Î¯ Î¼Îµ Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¬ Ï„Î·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï‡Î®Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(429574,11933,'zh','æ‰€æœ‰å¾…åŠžå‘ç¥¨å’Œæ¬¾é¡¹ä¸Žåœ¨åˆ¶æŒ‡å®šèŒƒå›´å†…ä»˜æ¬¾çš„å‘ç¥¨ä¸€åŒæ˜¾ç¤º\r\n',0),(429575,11933,'sv','Alla pÃ¥gÃ¥ende fakturor och krediter visas med fakturor betalas i det angivna datumintervallet',0),(429576,11933,'it','Tutti in attesa di fatture e crediti vengono visualizzati insieme a fatture pagate In un determinato intervallo di Date',0),(429577,11933,'tl','',0),(429578,11933,'th','à¸£à¸­à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹à¸¥à¸°à¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸ˆà¸°à¸›à¸£à¸²à¸à¸à¸žà¸£à¹‰à¸­à¸¡à¸à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸™à¸Šà¹ˆà¸§à¸‡à¸§à¸±à¸™à¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”',0),(429579,11933,'hi','à¤¸à¤­à¥€ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤”à¤° à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤²à¤‚à¤¬à¤¿à¤¤ à¤¦à¤¿à¤ à¤—à¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤®à¥‡à¤‚ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤¹à¥‹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(429580,11933,'ms','Semua menunggu invois dan kredit dipaparkan bersama-sama dengan invois dibayar dalam julat tarikh yang diberikan',0),(429581,11933,'ar','ÙŠØªÙ… Ø¹Ø±Ø¶ ÙƒØ§ÙØ© Ø§Ù†ØªØ¸Ø§Ø±Ø§ Ù„Ù„ÙÙˆØ§ØªÙŠØ± ÙˆØ§Ø¦ØªÙ…Ø§Ù†Ø§Øª Ø¬Ù†Ø¨Ø§ Ø¥Ù„Ù‰ Ø¬Ù†Ø¨ Ù…Ø¹ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© ÙÙŠ Ù†Ø·Ø§Ù‚ ØªØ§Ø±ÙŠØ® Ù…Ø¹ÙŠÙ†',0),(429582,11933,'fr','Toutes les factures et les crÃ©dits en attente sont affichÃ©es ainsi que des factures payÃ©es dans la plage de dates donnÃ©e',0),(429583,11933,'jp','ã™ã¹ã¦ã®ä¿ç•™ä¸­ã®è«‹æ±‚æ›¸ã‚„ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã¯ã€ç‰¹å®šã®æ—¥ä»˜ç¯„å›²ã§æ”¯æ‰•ã‚ã‚Œã‚‹è«‹æ±‚æ›¸ã¨å…±ã«è¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(429584,11933,'pt','Todos pendentes facturas e crÃ©ditos sÃ£o exibidos juntamente com as faturas pagas na faixa determinada data',0),(429585,11933,'ru','Ð’ÑÐµ Ð¾Ð¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ð² Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°ÑŽÑ‚ÑÑ Ð²Ð¼ÐµÑÑ‚Ðµ Ñ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ð» Ð² Ð·Ð°Ð´Ð°Ð½Ð½Ð¾Ð¼ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ðµ Ð”Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(429586,11933,'es','Todas las facturas y crÃ©ditos pendientes se muestran junto con las facturas pagadas en el intervalo de fechas determinado',0),(429587,11933,'de','Alle ausstehenden Rechnungen und Gutschriften werden zusammen mit Rechnungen bezahlt In dem angegebenen Datumsbereich angezeigt.',0),(429588,11933,'en','All Pending Invoices And Credits Are Displayed Along With Invoices Paid In The Given Date Range',0),(429589,11934,'is','',0),(429590,11934,'dr','ÛŒØ§ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(429591,11934,'pr','ÛŒØ§ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(429592,11934,'tr','Ya da Ã¼cretli',0),(429593,11934,'pl','Lub pÅ‚atne',0),(429594,11934,'bg','Ð˜Ð»Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(429595,11934,'ur','ÛŒØ§ ØªÙ†Ø®ÙˆØ§Û',0),(429596,11934,'sr','Ð˜Ð»Ð¸ Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(429597,11934,'vi','Hoáº·c tráº£ tiá»n',0),(429598,11934,'af','Of betaal',0),(429599,11934,'ro','Sau de plÄƒtit',0),(429600,11934,'et','VÃµi makstud',0),(429601,11934,'si','Ali ga je plaÄal',0),(429602,11934,'ba','Atau dibayar',0),(429603,11934,'nl','Of betaalde',0),(429604,11934,'fi','Tai maksettu',0),(429605,11934,'no','Eller betalt',0),(429606,11934,'da','Eller betalt',0),(429607,11934,'ko','ë˜ëŠ” ìœ ë£Œ',0),(429608,11934,'he','××• ×‘×ª×©×œ×•×',0),(429609,11934,'el','Î‰ ÎºÎ±Ï„Î±Î²Î»Î·Î¸Î­Î½Ï„Î±',0),(429610,11934,'zh','æˆ–æ”¯ä»˜\r\n',0),(429611,11934,'sv','Eller betalas',0),(429612,11934,'it','O a pagamento',0),(429613,11934,'tl','',0),(429614,11934,'th','à¸«à¸£à¸·à¸­à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(429615,11934,'hi','à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(429616,11934,'ms','Atau dibayar',0),(429617,11934,'ar','Ø£Ùˆ Ù…Ø¯ÙÙˆØ¹Ø© Ø§Ù„Ø£Ø¬Ø±',0),(429618,11934,'fr','Ou payant',0),(429619,11934,'jp','ã¾ãŸã¯æœ‰æ–™',0),(429620,11934,'pt','Ou pago',0),(429621,11934,'ru','Ð˜Ð»Ð¸ Ð¿Ð»Ð°Ñ‚Ð½Ñ‹Ðµ',0),(429622,11934,'es','O pagado',0),(429623,11934,'de','Oder gegen Entgelt',0),(429624,11934,'en','Or Paid',0),(429625,11935,'is','',0),(429626,11935,'dr','Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡',0),(429627,11935,'pr','Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡',0),(429628,11935,'tr','AralÄ±kta',0),(429629,11935,'pl','W zakresie',0),(429630,11935,'bg','Ð’ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð°',0),(429631,11935,'ur','Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…ÛŒÚº',0),(429632,11935,'sr','Ð£ Ð¾Ð¿ÑÐµÐ³Ñƒ',0),(429633,11935,'vi','Trong pháº¡m vi',0),(429634,11935,'af','In die reeks',0),(429635,11935,'ro','ÃŽn intervalul',0),(429636,11935,'et','Vahemikus',0),(429637,11935,'si','V obmoÄju',0),(429638,11935,'ba','Dalam kisaran',0),(429639,11935,'nl','In het bereik',0),(429640,11935,'fi','VÃ¤lillÃ¤',0),(429641,11935,'no','I omrÃ¥det',0),(429642,11935,'da','I intervallet',0),(429643,11935,'ko','ë²”ìœ„ì—ì„œ',0),(429644,11935,'he','×‘×˜×•×•×—',0),(429645,11935,'el','Î£Ï„Î·Î½ Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(429646,11935,'zh','åœ¨èŒƒå›´\r\n',0),(429647,11935,'sv','I intervallet',0),(429648,11935,'it','Nella gamma',0),(429649,11935,'tl','',0),(429650,11935,'th','à¹ƒà¸™à¸Šà¹ˆà¸§à¸‡',0),(429651,11935,'hi','à¤°à¥‡à¤‚à¤œ à¤®à¥‡à¤‚',0),(429652,11935,'ms','Dalam julat',0),(429653,11935,'ar','ÙÙŠ Ù†Ø·Ø§Ù‚',0),(429654,11935,'fr','Dans la gamme',0),(429655,11935,'jp','ç¯„å›²å†…',0),(429656,11935,'pt','Na faixa de',0),(429657,11935,'ru','Ð’ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ðµ',0),(429658,11935,'es','En la gama',0),(429659,11935,'de','Im Bereich',0),(429660,11935,'en','In The Range',0),(429661,11936,'is','',0),(429662,11936,'dr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø­Ø°Ù Ø§ÛŒÙ† Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(429663,11936,'pr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø­Ø°Ù Ø§ÛŒÙ† Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(429664,11936,'tr','Bu dosyayÄ± kaldÄ±rmak iÃ§in burayÄ± tÄ±klatÄ±n',0),(429665,11936,'pl','Kliknij tutaj, aby usunÄ…Ä‡ ten plik',0),(429666,11936,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½ÐµÑ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ñ„Ð°Ð¹Ð»',0),(429667,11936,'ur','Ø§Ø³ Ù…Ø³Ù„ Ú©Ùˆ ÛÙ¹Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(429668,11936,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÐºÐ»Ð¾Ð½Ð¸Ð»Ð¸ Ð¾Ð²Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(429669,11936,'vi','Click vÃ o Ä‘Ã¢y Ä‘á»ƒ loáº¡i bá» tá»‡p nÃ y',0),(429670,11936,'af','Klik hier om hierdie lÃªer te verwyder',0),(429671,11936,'ro','Click aici pentru a elimina acest fiÅŸier',0),(429672,11936,'et','Vajuta siia, et eemaldada selle faili',0),(429673,11936,'si','Kliknite tukaj, Äe Å¾elite odstraniti to datoteko',0),(429674,11936,'ba','Klik di sini untuk menghapus File ini',0),(429675,11936,'nl','Klik hier om dit bestand te verwijderen',0),(429676,11936,'fi','Klikkaa tÃ¤stÃ¤ Poista tÃ¤mÃ¤ tiedosto',0),(429677,11936,'no','Klikk her for Ã¥ fjerne denne filen',0),(429678,11936,'da','Klik her for at fjerne denne fil',0),(429679,11936,'ko','ì´ íŒŒì¼ì„ ì œê±° í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(429680,11936,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×¡×™×¨ ×§×•×‘×¥ ×–×”',0),(429681,11936,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ, Î³Î¹Î± Î½Î± ÎºÎ±Ï„Î±ÏÎ³Î®ÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(429682,11936,'zh','ç‚¹å‡»è¿™é‡Œåˆ é™¤æ­¤æ–‡ä»¶\r\n',0),(429683,11936,'sv','Klicka hÃ¤r fÃ¶r att ta bort denna fil',0),(429684,11936,'it','Clicca qui per rimuovere questo File',0),(429685,11936,'tl','',0),(429686,11936,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¹€à¸­à¸²à¹à¸Ÿà¹‰à¸¡à¸™à¸µà¹‰à¸­à¸­à¸',0),(429687,11936,'hi','à¤‡à¤¸ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤¨à¤¿à¤•à¤¾à¤²à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(429688,11936,'ms','Klik di sini untuk mengalih keluar fail ini',0),(429689,11936,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¥Ø²Ø§Ù„Ø© Ù‡Ø°Ø§ Ø§Ù„Ù…Ù„Ù',0),(429690,11936,'fr','Cliquez ici pour supprimer ce fichier',0),(429691,11936,'jp','ã“ã®ãƒ•ã‚¡ã‚¤ãƒ«ã‚’å‰Šé™¤ã™ã‚‹ã«ã¯ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(429692,11936,'pt','Clique aqui para remover este arquivo',0),(429693,11936,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ñ„Ð°Ð¹Ð»',0),(429694,11936,'es','Haga clic aquÃ­ para quitar este archivo',0),(429695,11936,'de','Klicken Sie hier, um diese Datei zu entfernen',0),(429696,11936,'en','Click Here To Remove This File',0),(429697,11937,'is','',0),(429698,11937,'dr','Ø±Ú©ÙˆØ±Ø¯ ÙØ§ÛŒÙ„ Ø¨Ø±Ø§ÛŒ Ø­Ø°Ù Ø±Ø§ Ù¾ÛŒØ¯Ø§ Ú©Ù†Ø¯',0),(429699,11937,'pr','Ø±Ú©ÙˆØ±Ø¯ ÙØ§ÛŒÙ„ Ø¨Ø±Ø§ÛŒ Ø­Ø°Ù Ø±Ø§ Ù¾ÛŒØ¯Ø§ Ú©Ù†Ø¯',0),(429700,11937,'tr','DosyayÄ± silmek iÃ§in kayÄ±t bulunamadÄ±',0),(429701,11937,'pl','Nie moÅ¼na zlokalizowaÄ‡ zapis pliku do usuniÄ™cia',0),(429702,11937,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ñ„Ð°Ð¹Ð» Ð·Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(429703,11937,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø³Ù„ ØªÙ„Ø§Ø´ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(429704,11937,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÐ»Ð¾ ÐŸÑ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ Ð·Ð°Ð¿Ð¸ÑÐ° Ð·Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð»Ð¸',0),(429705,11937,'vi','KhÃ´ng thá»ƒ Ä‘á»‹nh vá»‹ ká»· lá»¥c cho cÃ¡c táº­p tin Ä‘á»ƒ xÃ³a',0),(429706,11937,'af','Kon vind nie rekord vir lÃªer te skrap',0),(429707,11937,'ro','Nu a putut localiza Record pentru dosar a ÅŸterge',0),(429708,11937,'et','Ei leidnud kirje faili kustutamine',0),(429709,11937,'si','Ni bilo mogoÄe najti zapis datoteke izbrisati',0),(429710,11937,'ba','Tak bisa menemukan catatan untuk File untuk menghapus',0),(429711,11937,'nl','Could Not Locate Record voor bestand om te verwijderen',0),(429712,11937,'fi','Ei lÃ¶ytÃ¤nyt tietueen poistettava tiedosto',0),(429713,11937,'no','Finner ikke posten For filen som skal slettes',0),(429714,11937,'da','Kunne ikke finde post i fil til slet',0),(429715,11937,'ko','ì‚­ì œí•  íŒŒì¼ì— ëŒ€ í•œ ë ˆì½”ë“œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(429716,11937,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ××ª×¨ ××ª ×”×¨×©×•×ž×” ×¢×‘×•×¨ ×§×•×‘×¥ ×œ×ž×—×•×§',0),(429717,11937,'el','Î”ÎµÎ½ Î®Ï„Î±Î½ Î´Ï…Î½Î±Ï„ÏŒÏ‚ Î¿ ÎµÎ½Ï„Î¿Ï€Î¹ÏƒÎ¼ÏŒÏ‚ ÏÎµÎºÏŒÏ Î³Î¹Î± Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(429718,11937,'zh','æ— æ³•æ‰¾åˆ°è¦åˆ é™¤çš„æ–‡ä»¶è®°å½•\r\n',0),(429719,11937,'sv','Kunde inte hitta en post fÃ¶r filen fÃ¶r att ta bort',0),(429720,11937,'it','Potrebbe non individuare il Record per il File da eliminare',0),(429721,11937,'tl','',0),(429722,11937,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¸„à¹‰à¸™à¸«à¸²à¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”à¹ƒà¸™à¹„à¸Ÿà¸¥à¹Œà¸à¸²à¸£à¸¥à¸š',0),(429723,11937,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤•à¤¾ à¤ªà¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤²à¤—à¤¾ à¤¸à¤•à¤¾',0),(429724,11937,'ms','Tidak dapat mengesan rekod untuk fail untuk menghapuskan',0),(429725,11937,'ar','ØªØ¹Ø°Ø± ØªØ­Ø¯ÙŠØ¯ Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø³Ø¬Ù„ Ù„Ù„Ù…Ù„Ù Ø§Ù„Ù…Ø·Ù„ÙˆØ¨ Ø­Ø°ÙÙ‡',0),(429726,11937,'fr','N\'a pas trouvÃ© de dossier pour les fichiers Ã  supprimer',0),(429727,11937,'jp','å‰Šé™¤ã™ã‚‹ãƒ•ã‚¡ã‚¤ãƒ«ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(429728,11937,'pt','NÃ£o foi possÃ­vel localizar o registro para o arquivo excluir',0),(429729,11937,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð´Ð»Ñ Ñ„Ð°Ð¹Ð»Ð° Ð´Ð»Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ',0),(429730,11937,'es','No se pudo ubicar rÃ©cord de archivo eliminar',0),(429731,11937,'de','Rekord fÃ¼r Datei lÃ¶schen konnte nicht gefunden werden.',0),(429732,11937,'en','Could Not Locate Record For File To Delete',0),(429733,11938,'is','',0),(429734,11938,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(429735,11938,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(429736,11938,'tr','Hata dosya kaldÄ±rma',0),(429737,11938,'pl','BÅ‚Ä…d usuwania pliku',0),(429738,11938,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(429739,11938,'ur','Ù†Ù‚Øµ Ù…Ø³Ù„ ÛÙ¹Ø§ Ø±ÛØ§ ÛÛ’',0),(429740,11938,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐºÐ»Ð°ÑšÐ°ÑšÑƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(429741,11938,'vi','Lá»—i xÃ³a tá»‡p',0),(429742,11938,'af','Foutboodskap met verwydering van lÃªer',0),(429743,11938,'ro','Eroare eliminarea fiÅŸier',0),(429744,11938,'et','Viga kÃµrvaldada faili',0),(429745,11938,'si','Napaka pri odstranjevanju datoteke',0),(429746,11938,'ba','Error menghapus File',0),(429747,11938,'nl','Fout bij het verwijderen van bestand',0),(429748,11938,'fi','Virhe poistamalla tiedosto',0),(429749,11938,'no','Fjerne feilfilen',0),(429750,11938,'da','Fejl at fjerne fil',0),(429751,11938,'ko','ì˜¤ë¥˜ ì œê±° íŒŒì¼',0),(429752,11938,'he','×©×’×™××” ×”×¡×¨×ª ×§×•×‘×¥',0),(429753,11938,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ· Î±ÏÏ‡ÎµÎ¯Î¿ ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½',0),(429754,11938,'zh','é”™è¯¯åˆ é™¤æ–‡ä»¶\r\n',0),(429755,11938,'sv','Fel att ta bort filen',0),(429756,11938,'it','Errore rimuovendo File',0),(429757,11938,'tl','',0),(429758,11938,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸¥à¸šà¹à¸Ÿà¹‰à¸¡',0),(429759,11938,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(429760,11938,'ms','Ralat mengalih keluar fail',0),(429761,11938,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø²Ø§Ù„Ø© Ø§Ù„Ù…Ù„Ù',0),(429762,11938,'fr','Erreur suppression fichier',0),(429763,11938,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®å‰Šé™¤ã‚¨ãƒ©ãƒ¼',0),(429764,11938,'pt','Erro ao remover arquivo',0),(429765,11938,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ñ„Ð°Ð¹Ð»Ð°',0),(429766,11938,'es','Error al eliminar el archivo',0),(429767,11938,'de','Fehler beim Entfernen der Datei',0),(429768,11938,'en','Error Removing File',0),(429769,11939,'is','',0),(429770,11939,'dr','Ø®Ø·Ø§ÛŒ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ù†Ø§Ù… ÙØ§ÛŒÙ„ Ø¨Ø±Ø§ÛŒ Ø­Ø°Ù',0),(429771,11939,'pr','Ø®Ø·Ø§ÛŒ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ù†Ø§Ù… ÙØ§ÛŒÙ„ Ø¨Ø±Ø§ÛŒ Ø­Ø°Ù',0),(429772,11939,'tr','Silme iÅŸlemi iÃ§in dosya adÄ± alÄ±nÄ±rken hata oluÅŸtu',0),(429773,11939,'pl','BÅ‚Ä…d podczas pobierania nazwy pliku do usuniÄ™cia',0),(429774,11939,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° Ð¸Ð¼Ðµ Ð·Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(429775,11939,'ur','Ø­Ø°Ù Ú©Û’ Ù„ÛŒÛ’ Ù†Ø§Ù… Ù…Ø³Ù„ Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(429776,11939,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ð¸Ð¼Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ð±Ñ€Ð¸ÑÐ°ÑšÐµ',0),(429777,11939,'vi','Lá»—i láº¥y tÃªn táº­p tin Ä‘á»ƒ xÃ³a',0),(429778,11939,'af','Fout herwinning lÃªernaam vir skrapping',0),(429779,11939,'ro','Eroare de regÄƒsire nume de fiÅŸier pentru ÅŸtergere',0),(429780,11939,'et','TÃµrge allalaadimisel faili nime kustutamiseks',0),(429781,11939,'si','Napaka pri pridobivanju datoteke ime za brisanje',0),(429782,11939,'ba','Kesalahan yang mengambil nama File untuk penghapusan',0),(429783,11939,'nl','Fout bij het ophalen van bestandsnaam voor verwijdering',0),(429784,11939,'fi','Virhe haettaessa tiedostonimen poistettavaksi',0),(429785,11939,'no','Feil under henting av filnavnet for sletting',0),(429786,11939,'da','Fejl under hentning af filen navn til sletning',0),(429787,11939,'ko','ì˜¤ë¥˜ ì‚­ì œ íŒŒì¼ ì´ë¦„ ê²€ìƒ‰',0),(429788,11939,'he','×©×’×™××” ×‘××—×–×•×¨ ×©× ×”×§×•×‘×¥ ×œ×ž×—×™×§×”',0),(429789,11939,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Î±ÏÏ‡ÎµÎ¯Î¿ ÏŒÎ½Î¿Î¼Î± Î³Î¹Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(429790,11939,'zh','ä»¥å–æ¶ˆé”™è¯¯æ£€ç´¢æ–‡ä»¶åç§°\r\n',0),(429791,11939,'sv','Fel vid hÃ¤mtning av filnamn fÃ¶r borttagning',0),(429792,11939,'it','Errore nel nome del File per l\'eliminazione di recupero',0),(429793,11939,'tl','',0),(429794,11939,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¸Šà¸·à¹ˆà¸­à¹„à¸Ÿà¸¥à¹Œà¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸¥à¸š',0),(429795,11939,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤¨à¤¾à¤® à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(429796,11939,'ms','Ralat mendapatkan nama fail untuk penghapusan',0),(429797,11939,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ø³Ù… Ø§Ù„Ù…Ù„Ù Ù„Ù„Ø­Ø°Ù',0),(429798,11939,'fr','Erreur de rÃ©cupÃ©ration de nom de fichier pour la suppression',0),(429799,11939,'jp','å‰Šé™¤å¯¾è±¡ã®ãƒ•ã‚¡ã‚¤ãƒ«åã‚’å–å¾—ä¸­ã®ã‚¨ãƒ©ãƒ¼',0),(429800,11939,'pt','Erro ao recuperar o nome do arquivo para exclusÃ£o',0),(429801,11939,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ð¸Ð¼ÐµÐ½Ð¸ Ñ„Ð°Ð¹Ð»Ð° Ð´Ð»Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ',0),(429802,11939,'es','Error al recuperar el nombre del archivo para su eliminaciÃ³n',0),(429803,11939,'de','Fehler beim Abrufen des Dateinamens fÃ¼r die LÃ¶schung',0),(429804,11939,'en','Error Retrieving File Name for Deletion',0),(429805,11940,'is','',0),(429806,11940,'dr','Ø®Ø·Ø§ÛŒ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø§Ø³Ù†Ø§Ø¯ Ø¢Ù¾Ù„ÙˆØ¯',0),(429807,11940,'pr','Ø®Ø·Ø§ÛŒ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø§Ø³Ù†Ø§Ø¯ Ø¢Ù¾Ù„ÙˆØ¯',0),(429808,11940,'tr','KarÅŸÄ±ya yÃ¼klenen belgeler alÄ±nÄ±rken hata oluÅŸtu',0),(429809,11940,'pl','BÅ‚Ä…d podczas pobierania przesÅ‚ane dokumenty',0),(429810,11940,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‡ÐµÐ½Ð¸Ñ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(429811,11940,'ur','Ø§Ù¾ Ù„ÙˆÚˆ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(429812,11940,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð°',0),(429813,11940,'vi','Lá»—i truy xuáº¥t tÃ i liá»‡u Ä‘Æ°á»£c táº£i lÃªn',0),(429814,11940,'af','Fout herwinning opgelaaide dokumente',0),(429815,11940,'ro','Eroare recuperare Ã®ncÄƒrcat documente',0),(429816,11940,'et','Ãœles laetud dokumente allalaadimisel tÃµrge',0),(429817,11940,'si','Napaka pri pridobivanju Uploaded dokumenti',0),(429818,11940,'ba','Kesalahan mengambil dokumen upload',0),(429819,11940,'nl','Fout bij het ophalen van geÃ¼ploade documenten',0),(429820,11940,'fi','Virhe haettaessa siirretyille asiakirjoille',0),(429821,11940,'no','Feil under henting av opplastede dokumenter',0),(429822,11940,'da','Fejl under hentning af uploadede dokumenter',0),(429823,11940,'ko','ì—…ë¡œë“œ ëœ ë¬¸ì„œë¥¼ ê²€ìƒ‰ í•˜ëŠ” ì˜¤ë¥˜',0),(429824,11940,'he','×©×’×™××” ×‘××—×–×•×¨ ×ž×¡×ž×›×™× × ×˜×¢×Ÿ',0),(429825,11940,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï†Î¿ÏÏ„Ï‰Î¼Î­Î½Î± Î­Î³Î³ÏÎ±Ï†Î¬',0),(429826,11940,'zh','é”™è¯¯æ£€ç´¢ä¸Šè½½çš„æ–‡ä»¶\r\n',0),(429827,11940,'sv','Fel vid hÃ¤mtning av uppladdade dokument',0),(429828,11940,'it','Errore nel recupero documenti caricati',0),(429829,11940,'tl','',0),(429830,11940,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¸—à¸µà¹ˆà¹€à¸£à¸µà¸¢à¸à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¹€à¸­à¸à¸ªà¸²à¸£',0),(429831,11940,'hi','à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¥€ à¤—à¤ˆ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(429832,11940,'ms','Ralat mendapatkan semula dokumen yang dimuat naik',0),(429833,11940,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª Ø§Ù„Ø°ÙŠ ØªÙ… ØªØ­Ù…ÙŠÙ„Ù‡',0),(429834,11940,'fr','Erreur de rÃ©cupÃ©ration des Documents tÃ©lÃ©chargÃ©s',0),(429835,11940,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã•ã‚ŒãŸãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã‚’å–å¾—ä¸­ã®ã‚¨ãƒ©ãƒ¼',0),(429836,11940,'pt','Erro ao recuperar documentos enviados',0),(429837,11940,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ð·Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ð½Ñ‹Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(429838,11940,'es','Error al recuperar documentos cargados',0),(429839,11940,'de','Fehler beim Abrufen der hochgeladenen Dokumente',0),(429840,11940,'en','Error Retrieving Uploaded Documents',0),(429841,11941,'is','',0),(429842,11941,'dr','Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(429843,11941,'pr','Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(429844,11941,'tr','Dosya baÅŸarÄ±yla eklendi',0),(429845,11941,'pl','Plik Dodano pomyÅ›lnie',0),(429846,11941,'bg','Ð¤Ð°Ð¹Ð», Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(429847,11941,'ur','Ù…Ø³Ù„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(429848,11941,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(429849,11941,'vi','Táº­p tin Ä‘Æ°á»£c gá»­i thÃ nh cÃ´ng',0),(429850,11941,'af','LÃªer gevoeg suksesvol',0),(429851,11941,'ro','FiÅŸier adÄƒugat cu succes',0),(429852,11941,'et','Lisatud fail',0),(429853,11941,'si','Datoteke uspeÅ¡no dodane',0),(429854,11941,'ba','File ditambahkan berhasil',0),(429855,11941,'nl','Bestand toegevoegd',0),(429856,11941,'fi','Tiedoston lisÃ¤Ã¤minen onnistui',0),(429857,11941,'no','Filen ble lagt til',0),(429858,11941,'da','Fil tilfÃ¸jet',0),(429859,11941,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ëœ íŒŒì¼',0),(429860,11941,'he','×§×•×‘×¥ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(429861,11941,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(429862,11941,'zh','æ–‡ä»¶æ·»åŠ æˆåŠŸ\r\n',0),(429863,11941,'sv','Fil lagts',0),(429864,11941,'it','File aggiunto con successo',0),(429865,11941,'tl','',0),(429866,11941,'th','à¹à¸Ÿà¹‰à¸¡à¸–à¸¹à¸à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(429867,11941,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(429868,11941,'ms','Fail yang berjaya menambah',0),(429869,11941,'ar','Ù…Ù„Ù Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(429870,11941,'fr','Fichier ajoutÃ© avec succÃ¨s',0),(429871,11941,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(429872,11941,'pt','Arquivo adicionado com sucesso',0),(429873,11941,'ru','Ð¤Ð°Ð¹Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(429874,11941,'es','Archivo agregado con Ã©xito',0),(429875,11941,'de','Datei wurde erfolgreich hinzugefÃ¼gt',0),(429876,11941,'en','File Added Successfully',0),(429877,11942,'is','',0),(429878,11942,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¯Ø±Ø¬ Ø±Ú©ÙˆØ±Ø¯ Ø¬Ø¯ÛŒØ¯ Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(429879,11942,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¯Ø±Ø¬ Ø±Ú©ÙˆØ±Ø¯ Ø¬Ø¯ÛŒØ¯ Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(429880,11942,'tr','Yeni dosya kayÄ±t eklenemiyor',0),(429881,11942,'pl','Nie moÅ¼na wstawiÄ‡ nowy rekord pliku',0),(429882,11942,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð²Ð¼ÑŠÐºÐ½ÐµÑ‚Ðµ Ð½Ð¾Ð² Ð·Ð°Ð¿Ð¸Ñ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(429883,11942,'ur','Ù†Ø¦ÛŒ Ù…Ø³Ù„ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø¯Ø§Ø®Ù„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(429884,11942,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÑƒÐ¼ÐµÑ‚Ð½ÑƒÑ‚Ð¸ Ð½Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸',0),(429885,11942,'vi','KhÃ´ng thá»ƒ chÃ¨n báº£n ghi táº­p tin má»›i',0),(429886,11942,'af','Kon nie nuwe lÃªer rekord sit',0),(429887,11942,'ro','Imposibilitatea de a introduce noul fiÅŸier Record',0),(429888,11942,'et','Ei saa lisada uus kirje',0),(429889,11942,'si','Ni mogoÄe vstaviti novo datoteko zapis',0),(429890,11942,'ba','Tidak dapat menyisipkan catatan File baru',0),(429891,11942,'nl','Kunnen nieuwe bestand Record invoegen',0),(429892,11942,'fi','Ei voi lisÃ¤tÃ¤ uusi tietue',0),(429893,11942,'no','Kan ikke sette inn nye filpost',0),(429894,11942,'da','Stand til at indsÃ¦tte nye filpost',0),(429895,11942,'ko','ìƒˆ íŒŒì¼ ë ˆì½”ë“œë¥¼ ì‚½ìž…í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(429896,11942,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×•×¡×™×£ ××ª ×”×§×•×‘×¥ ×©×™× ×—×“×©',0),(429897,11942,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î½Î­Î±Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ Î±ÏÏ‡ÎµÎ¯Ï‰Î½',0),(429898,11942,'zh','æ— æ³•æ’å…¥æ–°çš„æ–‡ä»¶è®°å½•\r\n',0),(429899,11942,'sv','Det gÃ¥r inte att infoga ny fil post',0),(429900,11942,'it','Impossibile inserire il nuovo Record di file.',0),(429901,11942,'tl','',0),(429902,11942,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹à¸—à¸£à¸à¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¹à¸Ÿà¹‰à¸¡à¹ƒà¸«à¸¡à¹ˆ',0),(429903,11942,'hi','à¤¨à¤ˆ à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(429904,11942,'ms','Dapat memasukkan rekod fail baru',0),(429905,11942,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¥Ø¯Ø±Ø§Ø¬ Ø³Ø¬Ù„ Ø¬Ø¯ÙŠØ¯ ÙÙŠ Ù…Ù„Ù',0),(429906,11942,'fr','Impossible d\'insÃ©rer un nouvel enregistrement de fichier',0),(429907,11942,'jp','æ–°ã—ã„ãƒ•ã‚¡ã‚¤ãƒ«ã®ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’æŒ¿å…¥ã§ãã¾ã›ã‚“ã€‚',0),(429908,11942,'pt','NÃ£o Ã© possÃ­vel inserir o novo registro de arquivo',0),(429909,11942,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð²ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð² Ñ„Ð°Ð¹Ð»',0),(429910,11942,'es','Puede insertar el nuevo registro de archivo',0),(429911,11942,'de','Neue Datei-Eintrag konnte nicht eingefÃ¼gt',0),(429912,11942,'en','Unable To Insert New File Record',0),(429913,11943,'is','',0),(429914,11943,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÙØ§ÛŒÙ„ Ø¨Ø±Ø§ÛŒ Ø¢Ù¾Ù„ÙˆØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(429915,11943,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÙØ§ÛŒÙ„ Ø¨Ø±Ø§ÛŒ Ø¢Ù¾Ù„ÙˆØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(429916,11943,'tr','KarÅŸÄ±ya yÃ¼klenecek dosyayÄ± seÃ§meniz gerekir',0),(429917,11943,'pl','NaleÅ¼y wybraÄ‡ plik do wysÅ‚ania',0),(429918,11943,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð» Ð·Ð° ÐºÐ°Ñ‡Ð²Ð°Ð½Ðµ',0),(429919,11943,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(429920,11943,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ð°ÑšÐµ',0),(429921,11943,'vi','Báº¡n pháº£i chá»n má»™t tá»‡p Ä‘á»ƒ táº£i lÃªn',0),(429922,11943,'af','Jy moet kies \'n lÃªer om op te laai',0),(429923,11943,'ro','Trebuie sÄƒ selectaÅ£i un fiÅŸier pentru a Ã®ncÄƒrca',0),(429924,11943,'et','Valige faili Ã¼les laadida',0),(429925,11943,'si','Izberite datoteko za prenos',0),(429926,11943,'ba','Anda harus memilih File untuk di Upload',0),(429927,11943,'nl','U moet Selecteer een bestand om te uploaden',0),(429928,11943,'fi','Valitse ladattava tiedosto',0),(429929,11943,'no','Du mÃ¥ velge en fil laste opp',0),(429930,11943,'da','Du skal vÃ¦lge en fil til Upload',0),(429931,11943,'ko','ì—…ë¡œë“œí•  íŒŒì¼ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(429932,11943,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×§×•×‘×¥ ×œ×”×¢×œ××”',0),(429933,11943,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿ Î³Î¹Î± Î½Î± Ï†Î¿ÏÏ„ÏŽÏƒÎµÏ„Îµ',0),(429934,11943,'zh','æ‚¨å¿…é¡»é€‰æ‹©è¦ä¸Šä¼ çš„æ–‡ä»¶\r\n',0),(429935,11943,'sv','Du mÃ¥ste vÃ¤lja en fil att ladda upp',0),(429936,11943,'it','Ãˆ necessario selezionare un File da caricare',0),(429937,11943,'tl','',0),(429938,11943,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¹à¸Ÿà¹‰à¸¡à¸—à¸µà¹ˆà¸ˆà¸°à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”',0),(429939,11943,'hi','à¤†à¤ª à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(429940,11943,'ms','Anda mesti pilih satu fail untuk muat naik',0),(429941,11943,'ar','ÙŠØ¬Ø¨ ØªØ­Ø¯ÙŠØ¯ Ù…Ù„Ù Ù„ØªØ­Ù…ÙŠÙ„Ù‡',0),(429942,11943,'fr','Vous devez sÃ©lectionner un fichier Ã  tÃ©lÃ©charger',0),(429943,11943,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã™ã‚‹ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(429944,11943,'pt','VocÃª deve selecionar um arquivo para carregar',0),(429945,11943,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» Ð´Ð»Ñ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(429946,11943,'es','Debe seleccionar un archivo para cargarlo',0),(429947,11943,'de','Sie mÃ¼ssen eine Datei zum Hochladen auswÃ¤hlen.',0),(429948,11943,'en','You Must Select A File To Upload',0),(429949,11944,'is','',0),(429950,11944,'dr','ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹Ù„Ù‚ Ùˆ ÙØ¹Ø§Ù„ Ù‡Ù…Ø±Ø§Ù‡ Ø¨Ø§ Ø¯Ø³ØªÙˆØ±Ø§Øª Ù†Ù‡Ø§ÛŒÛŒ Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ù†Ù…Ø§ÛŒØ´ Ø¯Ø§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(429951,11944,'pr','ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹Ù„Ù‚ Ùˆ ÙØ¹Ø§Ù„ Ù‡Ù…Ø±Ø§Ù‡ Ø¨Ø§ Ø¯Ø³ØªÙˆØ±Ø§Øª Ù†Ù‡Ø§ÛŒÛŒ Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ù†Ù…Ø§ÛŒØ´ Ø¯Ø§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(429952,11944,'tr','TÃ¼m bekleyen ve etkin sipariÅŸleri ile birlikte verilen tarih aralÄ±ÄŸÄ±nda kesinleÅŸmiÅŸ sipariÅŸleri gÃ¶rÃ¼ntÃ¼lenir',0),(429953,11944,'pl','Wszystkie zlecenia oczekujÄ…ce i aktywne sÄ… wyÅ›wietlane razem z zamÃ³wienia sfinalizowana w danym zakres dat',0),(429954,11944,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ñ‡Ð°ÐºÐ°Ñ‰Ð¸ Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚ Ð·Ð°ÐµÐ´Ð½Ð¾ Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½ Ð² Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(429955,11944,'ur','ØªÙ…Ø§Ù… Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø§ÙˆØ± ÙØ¹Ø§Ù„ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¯ÛŒØ¦Û’ Ú¯Ø¦Û’ ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…ÛŒÚº Ù…Ù†Ù¹Ø³ Ú©Û’ Ø³Ø§ØªÚ¾ Ø³Ø§ØªÚ¾ Ø¯Ú©Ú¾Ø§Ø¦Û’ Ø¬Ø§ØªÛ’ ÛÛŒÚº',0),(429956,11944,'sr','Ð¡Ð²Ðµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾Ð³ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÑÑƒ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½Ðµ Ð·Ð°Ñ˜ÐµÐ´Ð½Ð¾ ÑÐ° Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð° Ð·Ð°Ð²Ñ€ÑˆÐµÐ½ Ð´Ð°Ñ‚Ð¾Ð¼ Ð¾Ð¿ÑÐµÐ³Ñƒ',0),(429957,11944,'vi','Táº¥t cáº£ cÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng chá» giáº£i quyáº¿t vÃ  hoáº¡t Ä‘á»™ng Ä‘Æ°á»£c hiá»ƒn thá»‹ cÃ¹ng vá»›i cÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng hoÃ n thÃ nh trong pháº¡m vi ngÃ y cho trÆ°á»›c',0),(429958,11944,'af','Alle hangende en aktiewe bestellings is vertoon saam met bestellings In die gegewe datum reeks gefinaliseer',0),(429959,11944,'ro','Toate comenzile Active ÅŸi Ã®n aÅŸteptare sunt afiÅŸate Ã®mpreunÄƒ cu comenzi finalizate Ã®n intervalul de Date dat',0),(429960,11944,'et','KÃµik ootel ja aktiivse tellimused kuvatakse koos antud kuupÃ¤evavahemikku lÃµpetatud tellimused',0),(429961,11944,'si','Vse ÄakajoÄe in aktivne nalogov so prikazani skupaj z nalogi zakljuÄeni v danem datumskem obsegu',0),(429962,11944,'ba','Semua pesanan yang tertunda dan aktif ditampilkan bersama dengan perintah yang diselesaikan dalam rentang tanggal tertentu',0),(429963,11944,'nl','Alle in behandeling en actieve Orders worden weergegeven samen met Orders gefinaliseerd In het opgegeven datumbereik',0),(429964,11944,'fi','Kaikki odottavat ja aktiiviset tilaukset nÃ¤kyvÃ¤t tilaukset valmiiksi tietyllÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤vÃ¤lillÃ¤',0),(429965,11944,'no','Alle ventende og aktive ordrer vises sammen med ordrer sluttfÃ¸rt i det angitte datoomrÃ¥det',0),(429966,11944,'da','Alle ventende og aktive ordrer vises sammen med ordrer i det angivne datointerval',0),(429967,11944,'ko','ëª¨ë“  ë³´ë¥˜ ì¤‘ì¸ ë° í™œì„± ì£¼ë¬¸ ìˆœì„œ ì§€ì • ëœ ë‚ ì§œ ë²”ìœ„ì—ì„œ ì™„ë£Œì™€ í•¨ê»˜ í‘œì‹œ ë©ë‹ˆë‹¤.',0),(429968,11944,'he','×›×œ ×”×–×ž× ×•×ª ×ž×ž×ª×™× ×•×ª ×•×¤×¢×™×œ ×ž×•×¦×’×™× ×œ×¦×“ ×”×–×ž× ×•×ª ×¡×•×¤×™×ª ×‘×˜×•×•×— ×ª××¨×™×š × ×ª×•×Ÿ',0),(429969,11944,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± ÎºÎ±Î¹ ÎµÎ½ÎµÏÎ³ÏŒ ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ Î¼Î±Î¶Î¯ Î¼Îµ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ ÏƒÎµ Î´ÎµÎ´Î¿Î¼Î­Î½Î· Ï‡ÏÎ¿Î½Î¹ÎºÎ®',0),(429970,11944,'zh','æ‰€æœ‰å¾…åŠžçš„å’Œæ´»è·ƒçš„è®¢å•ä¸Žåœ¨æŒ‡å®šæ—¥æœŸèŒƒå›´å†…é¢„è´­çš„è®¢å•ä¸€åŒæ˜¾ç¤º\r\n',0),(429971,11944,'sv','Alla vÃ¤ntande och aktiva order visas med order slutfÃ¶rdes i det angivna datumintervallet',0),(429972,11944,'it','Tutti gli ordini in sospeso e attivi vengono visualizzati insieme a ordini finalizzati In un determinato intervallo di Date',0),(429973,11944,'tl','',0),(429974,11944,'th','à¹à¸ªà¸”à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ à¹à¸¥à¸°à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸­à¸¢à¸¹à¹ˆà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸žà¸£à¹‰à¸­à¸¡à¸à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‚à¸±à¹‰à¸™à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢à¹ƒà¸™à¸Šà¹ˆà¸§à¸‡à¸§à¸±à¸™à¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”',0),(429975,11944,'hi','à¤¸à¤­à¥€ à¤²à¤‚à¤¬à¤¿à¤¤ à¤”à¤° à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤ à¤—à¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤®à¥‡à¤‚ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤¹à¥‹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(429976,11944,'ms','Semua perintah yang belum selesai dan aktif akan dipaparkan bersama dengan perintah-perintah yang dimuktamadkan dalam julat tarikh yang diberikan',0),(429977,11944,'ar','ÙŠØªÙ… Ø¹Ø±Ø¶ ÙƒØ§ÙØ© Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…Ø¹Ù„Ù‚Ø© ÙˆÙ†Ø´Ø· Ø¬Ù†Ø¨Ø§ Ø¥Ù„Ù‰ Ø¬Ù†Ø¨ Ù…Ø¹ Ø£ÙˆØ§Ù…Ø± ÙˆØ¶Ø¹ Ø§Ù„Ù„Ù…Ø³Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø© ÙÙŠ Ù†Ø·Ø§Ù‚ ØªØ§Ø±ÙŠØ® Ù…Ø¹ÙŠÙ†',0),(429978,11944,'fr','Toutes les commandes en attente et Active sont affichent avec commandes finalisÃ©es dans la plage de dates donnÃ©e',0),(429979,11944,'jp','ç‰¹å®šã®æ—¥ä»˜ç¯„å›²ã‚’ç¢ºå®šæ³¨æ–‡ã¨å…±ã«ã™ã¹ã¦ã®ä¿ç•™ä¸­ã€ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªæ³¨æ–‡ãŒè¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(429980,11944,'pt','Todas as encomendas pendentes e ativas sÃ£o exibidas juntamente com ordens finalizadas na determinado intervalo de datas',0),(429981,11944,'ru','Ð’Ð¼ÐµÑÑ‚Ðµ Ñ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð° Ð² Ð·Ð°Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°ÑŽÑ‚ÑÑ Ð²ÑÐµ Ð¾Ð¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(429982,11944,'es','Todos los pedidos pendientes y activos se muestran junto con las Ã³rdenes en el intervalo de fechas determinado',0),(429983,11944,'de','Alle ausstehenden und aktive AuftrÃ¤ge werden zusammen mit Bestellungen im angegebenen Datumsbereich abgeschlossen angezeigt.',0),(429984,11944,'en','All Pending And Active Orders Are Displayed Along With Orders Finalized In The Given Date Range',0),(429985,11945,'is','',0),(429986,11945,'dr','Ø¯Ø±ÛŒØ§ÙØª Ø³ÙØ§Ø±Ø´Ø§Øª',0),(429987,11945,'pr','Ø¯Ø±ÛŒØ§ÙØª Ø³ÙØ§Ø±Ø´Ø§Øª',0),(429988,11945,'tr','Emir almak',0),(429989,11945,'pl','Uzyskania zamÃ³wienia',0),(429990,11945,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(429991,11945,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(429992,11945,'sr','ÐŸÐ¾ Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð°',0),(429993,11945,'vi','Ä‘áº·t Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(429994,11945,'af','Bestellings kry',0),(429995,11945,'ro','Lua comenzi',0),(429996,11945,'et','Saada tellimusi',0),(429997,11945,'si','Dobili naroÄila',0),(429998,11945,'ba','Mendapatkan pesanan',0),(429999,11945,'nl','Orders krijgen',0),(430000,11945,'fi','Saada tilauksia',0),(430001,11945,'no','FÃ¥ bestillinger',0),(430002,11945,'da','FÃ¥ ordrer',0),(430003,11945,'ko','ì£¼ë¬¸ì„ ë°›ì„í•©ë‹ˆë‹¤',0),(430004,11945,'he','×ž×§×‘×œ ×”×•×¨××•×ª',0),(430005,11945,'el','Î Î¬ÏÏ„Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(430006,11945,'zh','å¾—åˆ°ä»¤\r\n',0),(430007,11945,'sv','FÃ¥ order',0),(430008,11945,'it','Ottenere ordini',0),(430009,11945,'tl','',0),(430010,11945,'th','à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(430011,11945,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(430012,11945,'ms','Mendapatkan perintah',0),(430013,11945,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø±',0),(430014,11945,'fr','Obtenir des commandes',0),(430015,11945,'jp','æ³¨æ–‡ã‚’å¾—ã‚‹',0),(430016,11945,'pt','Recebe ordens',0),(430017,11945,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(430018,11945,'es','Consigue Pedidos',0),(430019,11945,'de','AuftrÃ¤ge zu erhalten',0),(430020,11945,'en','Get Orders',0),(430021,11946,'is','',0),(430022,11946,'dr','ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´/Ø¯ÛŒØ¯Ù†/Ø±ÙˆÙ†ÙˆØ´Øª',0),(430023,11946,'pr','ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´/Ø¯ÛŒØ¯Ù†/Ø±ÙˆÙ†ÙˆØ´Øª',0),(430024,11946,'tr','SipariÅŸ/gÃ¶rÃ¼nÃ¼m/kopyaya dÃ¶nÃ¼ÅŸtÃ¼rÃ¼n',0),(430025,11946,'pl','Konwersja do porzÄ…dku, widok, kopiowanie',0),(430026,11946,'bg','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð² Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°/Ð¸Ð·Ð³Ð»ÐµÐ´/ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ',0),(430027,11946,'ur','Ø¢Ø±ÚˆØ±/Ù‚ÙˆÙ„/Ù†Ù‚Ù„ Ø¨Ø¯Ù„ÛŒÚº',0),(430028,11946,'sr','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚ÑƒÑ˜ Ñƒ Ñ€ÐµÐ´/Ð¿Ñ€Ð¸ÐºÐ°Ð·/ÐºÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ',0),(430029,11946,'vi','Chuyá»ƒn Ä‘á»•i Ä‘á»ƒ Ä‘áº·t hÃ ng/xem/Copy',0),(430030,11946,'af','Omskep tot orde/View/afskrif',0),(430031,11946,'ro','Conversia la comanda/Vezi/copie',0),(430032,11946,'et','Convert/View/koopia',0),(430033,11946,'si','Spremeniti v pogled/red/izvod',0),(430034,11946,'ba','Mengkonversi ke Order/pemandangan/Copy',0),(430035,11946,'nl','Converteren naar Order/weergave/kopiÃ«ren',0),(430036,11946,'fi','Muuntaa/View/kopio',0),(430037,11946,'no','Konvertere til/vise/kopi',0),(430038,11946,'da','Konvertere til ordre/View/kopi',0),(430039,11946,'ko','ì£¼ë¬¸/ë³´ê¸°/ë³µì‚¬ë¡œ ë³€í™˜',0),(430040,11946,'he','×œ×”×ž×™×¨ ×¦×•/×ª×¦×•×’×”/×”×¢×ª×§×”',0),(430041,11946,'el','ÎœÎµÏ„Î±Ï„ÏÎ¿Ï€Î® ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±/Ï€ÏÎ¿Î²Î¿Î»Î®/Î±Î½Ï„Î¹Î³ÏÎ±Ï†Î®',0),(430042,11946,'zh','è½¬æ¢å¯¹ç§©åºè§‚å¤åˆ¶\r\n',0),(430043,11946,'sv','Konvertera till Order/Visa/kopiera',0),(430044,11946,'it','Convertire in ordine/View/copia',0),(430045,11946,'tl','',0),(430046,11946,'th','à¹à¸›à¸¥à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡/à¸¡à¸¸à¸¡à¸¡à¸­à¸‡/à¸ªà¸³à¹€à¸™à¸²',0),(430047,11946,'hi','à¤†à¤¦à¥‡à¤¶/à¤¦à¥‡à¤–à¥‡à¤‚/à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(430048,11946,'ms','Menukar kepada perintah/View/salinan',0),(430049,11946,'ar','ØªØ­ÙˆÙŠÙ„ Ø¥Ù„Ù‰ ØªØ±ØªÙŠØ¨/Ø¹Ø±Ø¶/Ù†Ø³Ø®',0),(430050,11946,'fr','Convertir en ordre/View/copie',0),(430051,11946,'jp','æ³¨æ–‡/ãƒ“ãƒ¥ãƒ¼/ã‚³ãƒ”ãƒ¼ã«å¤‰æ›ã—ã¾ã™ã€‚',0),(430052,11946,'pt','Converter a ordem/View/cÃ³pia',0),(430053,11946,'ru','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ Ð² Ð·Ð°ÐºÐ°Ð·/ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(430054,11946,'es','Convertir en orden/ver/copiar',0),(430055,11946,'de','Konvertieren Sie in Ordnung/Ansicht/kopieren',0),(430056,11946,'en','Convert To Order/View/Copy',0),(430057,11947,'is','',0),(430058,11947,'dr','ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± ÙØ§Ú©ØªÙˆØ± ÙØ¹Ù„ÛŒ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§/Ø±Ø§',0),(430059,11947,'pr','ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± ÙØ§Ú©ØªÙˆØ± ÙØ¹Ù„ÛŒ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§/Ø±Ø§',0),(430060,11947,'tr','GeÃ§erli fatura/Ã¶deme/fatura Tarih',0),(430061,11947,'pl','BieÅ¼Ä…cej faktury/do historii pÅ‚atnoÅ›ci/faktury',0),(430062,11947,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸/Ð¿Ñ€Ð°Ð²ÑÑ‚ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ/Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(430063,11947,'ur','Ø­Ø§Ù„ÛŒÛ ÙˆØ¨Ø¬Ù„ÛŒ/Ø¨Ù†Ø§Ù†Û’ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ/Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(430064,11947,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°/Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ/Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(430065,11947,'vi','Hiá»‡n táº¡i hÃ³a Ä‘Æ¡n/lÃ m cho thanh toÃ¡n/hoÃ¡ Ä‘Æ¡n lá»‹ch sá»­',0),(430066,11947,'af','Huidige fakture/maak betalings/faktuur geskiedenis',0),(430067,11947,'ro','Curent facturi/face plÄƒÅ£i/facturÄƒ istorie',0),(430068,11947,'et','Praeguse arvete/Make maksed/arvete ajalugu',0),(430069,11947,'si','Trenutni raÄuni/Make plaÄila raÄuna/zgodovina',0),(430070,11947,'ba','Riwayat pembayaran faktur faktur/membuat Current',0),(430071,11947,'nl','Huidige facturen/Make betalingen/factuur geschiedenis',0),(430072,11947,'fi','Nykyinen laskut/tehdÃ¤ maksuja tai laskun historiaa',0),(430073,11947,'no','Gjeldende fakturaer/gjÃ¸re betalinger/faktura historien',0),(430074,11947,'da','NuvÃ¦rende fakturaer/gÃ¸re betalinger/faktura historie',0),(430075,11947,'ko','í˜„ìž¬ ì²­êµ¬ì„œ/ë§Œë“ ë‹¤ ì§€ë¶ˆ/ì†¡ìž¥ ì—­ì‚¬',0),(430076,11947,'he','×”× ×•×›×—×™ ×—×©×‘×•× ×™×•×ª/×œ×¢×©×•×ª ×”×™×¡×˜×•×¨×™×” ×ª×©×œ×•×ž×™×/×—×©×‘×•× ×™×ª',0),(430077,11947,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±/ÎºÎ¬Î½Î¿Ï…Î½ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚/Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(430078,11947,'zh','å½“å‰å‘ç¥¨/ä»˜æ¬¾/å‘ç¥¨åŽ†å²\r\n',0),(430079,11947,'sv','Nuvarande fakturor/gÃ¶ra betalningar/faktura historia',0),(430080,11947,'it','Storia di pagamenti o fattura fatture/rendere attuale',0),(430081,11947,'tl','',0),(430082,11947,'th','à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™/à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰/à¸—à¸³à¹ƒà¸«à¹‰à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(430083,11947,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤šà¤¾à¤²à¤¾à¤¨/à¤¬à¤¨à¤¾à¤¨à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚/à¤šà¤¾à¤²à¤¾à¤¨ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(430084,11947,'ms','Semasa invois/membuat pembayaran/invois sejarah',0),(430085,11947,'ar','ØªØ§Ø±ÙŠØ® ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª/Ø§Ù„ÙÙˆØ§ØªÙŠØ±/Ø¬Ø¹Ù„ Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(430086,11947,'fr','Histoire de paiements/factures factures/Make actuelle',0),(430087,11947,'jp','ç¾åœ¨ã®è«‹æ±‚æ›¸/æ”¯æ‰•ã„/è«‹æ±‚æ›¸æ­´å²',0),(430088,11947,'pt','HistÃ³rico de pagamentos/fatura atual facturas/fazer',0),(430089,11947,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹/ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸/ÑÑ‡ÐµÑ‚Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(430090,11947,'es','Actual facturas/pagos/factura historia',0),(430091,11947,'de','Aktuelle Rechnungen/Zahlungen/Rechnung Geschichte',0),(430092,11947,'en','Current Invoices/Make Payments/Invoice History',0),(430093,11948,'is','',0),(430094,11948,'dr','Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´ ÙØ¹Ù„ÛŒ',0),(430095,11948,'pr','Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´ ÙØ¹Ù„ÛŒ',0),(430096,11948,'tr','GeÃ§erli sipariÅŸ listesi',0),(430097,11948,'pl','Aktualna lista kolejnoÅ›ci',0),(430098,11948,'bg','Ð¢ÐµÐºÑƒÑ‰ ÑÐ¿Ð¸ÑÑŠÐº Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(430099,11948,'ur','Ù…ÙˆØ¬ÙˆØ¯Û ØªØ±ØªÛŒØ¨ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(430100,11948,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð»Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(430101,11948,'vi','Danh sÃ¡ch thá»© tá»± hiá»‡n táº¡i',0),(430102,11948,'af','Huidige orde lys',0),(430103,11948,'ro','Lista curentÄƒ de ordine',0),(430104,11948,'et','Praegune loend',0),(430105,11948,'si','Trenutni seznam nalogov',0),(430106,11948,'ba','Daftar Order sekarang',0),(430107,11948,'nl','Huidige lijst',0),(430108,11948,'fi','Nykyinen luettelo',0),(430109,11948,'no','Gjeldende listen',0),(430110,11948,'da','NuvÃ¦rende Ordreoversigt',0),(430111,11948,'ko','í˜„ìž¬ ì£¼ë¬¸ ëª©ë¡',0),(430112,11948,'he','×¡×“×¨ ×”×¨×©×™×ž×” ×”× ×•×›×—×™×ª',0),(430113,11948,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î»Î¯ÏƒÏ„Î± ÏƒÎµÎ¹ÏÎ¬',0),(430114,11948,'zh','å½“å‰çš„è®¢å•åˆ—è¡¨\r\n',0),(430115,11948,'sv','Nuvarande ordning lista',0),(430116,11948,'it','Elenco ordine corrente',0),(430117,11948,'tl','',0),(430118,11948,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(430119,11948,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¥à¤°à¤® à¤¸à¥‚à¤šà¥€',0),(430120,11948,'ms','Senarai pesanan semasa',0),(430121,11948,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„ØªØ±ØªÙŠØ¨ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(430122,11948,'fr','Liste actuelle de commande',0),(430123,11948,'jp','ç¾åœ¨ã®æ³¨æ–‡ãƒªã‚¹ãƒˆ',0),(430124,11948,'pt','Lista atual de ordem',0),(430125,11948,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(430126,11948,'es','Lista actual de la orden',0),(430127,11948,'de','Aktuelle Bestellliste',0),(430128,11948,'en','Current Order List',0),(430129,11949,'is','',0),(430130,11949,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(430131,11949,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(430132,11949,'tr','Emir girin',0),(430133,11949,'pl','Wprowadzania zleceÅ„',0),(430134,11949,'bg','Ð’ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(430135,11949,'ur','Ø­Ú©Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(430136,11949,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(430137,11949,'vi','Nháº­p Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(430138,11949,'af','Voer bestellings',0),(430139,11949,'ro','IntroduceÅ£i comenzi',0),(430140,11949,'et','Sisestage tellimuste',0),(430141,11949,'si','Vnesite naroÄila',0),(430142,11949,'ba','Masukkan perintah',0),(430143,11949,'nl','Orders invoeren',0),(430144,11949,'fi','Kirjoita tilaukset',0),(430145,11949,'no','Angi ordrer',0),(430146,11949,'da','Angiv ordrer',0),(430147,11949,'ko','ì£¼ë¬¸ ìž…ë ¥',0),(430148,11949,'he','×”×–× ×ª ×”×–×ž× ×•×ª',0),(430149,11949,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(430150,11949,'zh','è¾“å…¥è®¢å•\r\n',0),(430151,11949,'sv','Ange order',0),(430152,11949,'it','Immettere ordini',0),(430153,11949,'tl','',0),(430154,11949,'th','à¸›à¹‰à¸­à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(430155,11949,'hi','à¤†à¤¦à¥‡à¤¶ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(430156,11949,'ms','Masukkan pesanan',0),(430157,11949,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø£ÙˆØ§Ù…Ø±',0),(430158,11949,'fr','Entrer les commandes',0),(430159,11949,'jp','æ³¨æ–‡ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(430160,11949,'pt','Introduza ordens',0),(430161,11949,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(430162,11949,'es','Ingrese Ã³rdenes',0),(430163,11949,'de','Eingabe von AuftrÃ¤gen',0),(430164,11949,'en','Enter Orders',0),(430165,11950,'is','',0),(430166,11950,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾',0),(430167,11950,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾',0),(430168,11950,'tr','SipariÅŸ YazdÄ±r girin',0),(430169,11950,'pl','WprowadÅº druku zamÃ³wienia',0),(430170,11950,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(430171,11950,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(430172,11950,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(430173,11950,'vi','Nháº­p Ä‘Æ¡n Ä‘áº·t hÃ ng in',0),(430174,11950,'af','Sleutel druk bestellings',0),(430175,11950,'ro','IntroduceÅ£i comenzi de imprimare',0),(430176,11950,'et','Sisestage trÃ¼kitÃ¶Ã¶de tellimused',0),(430177,11950,'si','Vnesite tiskanje nalogov',0),(430178,11950,'ba','Masukkan perintah cetak',0),(430179,11950,'nl','Afdrukken Orders invoeren',0),(430180,11950,'fi','Kirjoita tulosta tilaukset',0),(430181,11950,'no','Skriver ut ordrer',0),(430182,11950,'da','Angiv aftryksbestillinger',0),(430183,11950,'ko','ì¸ì‡„ ì£¼ë¬¸ ìž…ë ¥',0),(430184,11950,'he','×”×–×Ÿ ×”×“×¤×¡×•×ª',0),(430185,11950,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ ÎµÎ½Ï„Î¿Î»Î­Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(430186,11950,'zh','è¾“å…¥æ‰“å°è®¢å•\r\n',0),(430187,11950,'sv','Ange Print Order',0),(430188,11950,'it','Immettere gli ordini di stampa',0),(430189,11950,'tl','',0),(430190,11950,'th','à¸›à¹‰à¸­à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸žà¸´à¸¡à¸žà¹Œ',0),(430191,11950,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(430192,11950,'ms','Masukkan cetakan arahan',0),(430193,11950,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(430194,11950,'fr','Entrer les commandes',0),(430195,11950,'jp','ãƒ—ãƒªãƒ³ãƒˆã®æ³¨æ–‡ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(430196,11950,'pt','Introduza ordens de impressÃ£o',0),(430197,11950,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(430198,11950,'es','Ingrese Ã³rdenes de impresiÃ³n',0),(430199,11950,'de','Geben Sie DruckauftrÃ¤ge',0),(430200,11950,'en','Enter Print Orders',0),(430201,11951,'is','',0),(430202,11951,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(430203,11951,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(430204,11951,'tr','Teklif yazdÄ±rma sÄ±rasÄ±nÄ± girin',0),(430205,11951,'pl','Cytat wprowadziÄ‡ kolejnoÅ›Ä‡ drukowania',0),(430206,11951,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(430207,11951,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: Ú©Û’ Ù„ÛŒÛ’ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¢Ø±ÚˆØ± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(430208,11951,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(430209,11951,'vi','Nháº­p bÃ¡o cho Ä‘Æ¡n Ä‘áº·t hÃ ng in',0),(430210,11951,'af','Tik aanhaling vir druk orde',0),(430211,11951,'ro','IntroduceÅ£i citat pentru comanda de imprimare',0),(430212,11951,'et','Sisestage Quote printimise jÃ¤rjekorras',0),(430213,11951,'si','Vnesite narekovaj za vrstni red tiskanja',0),(430214,11951,'ba','Masukkan kutipan untuk pesanan cetakan',0),(430215,11951,'nl','Voer citaat voor afdrukvolgorde',0),(430216,11951,'fi','Kirjoita lainaus tulostusjÃ¤rjestys',0),(430217,11951,'no','Angi tilbud For rekkefÃ¸lge',0),(430218,11951,'da','Angiv citat til udskriftsrÃ¦kkefÃ¸lgen',0),(430219,11951,'ko','ì¸ì‡„ ìˆœì„œë¥¼ ìœ„í•œ ê²¬ì  ìž…ë ¥',0),(430220,11951,'he','×”×–×Ÿ ×”×¦×¢×ª ×ž×—×™×¨ ×¢×‘×•×¨ ×¡×“×¨ ×”×”×“×¤×¡×”',0),(430221,11951,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î³Î¹Î± Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(430222,11951,'zh','ENTER QUOTE FOR PRINT ORDER',0),(430223,11951,'sv','Ange offert fÃ¶r utskriftsordning',0),(430224,11951,'it','Inserisci citazione per ordine di stampa',0),(430225,11951,'tl','',0),(430226,11951,'th','à¸›à¹‰à¸­à¸™à¸à¸²à¸£à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(430227,11951,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(430228,11951,'ms','Masukkan Quote untuk cetak',0),(430229,11951,'ar','Ø£Ø¯Ø®Ù„ Ø¹Ù„Ø§Ù…Ø© Ø§Ù‚ØªØ¨Ø§Ø³ Ù„Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(430230,11951,'fr','Entrez citation Ã  l\'ordre d\'impression',0),(430231,11951,'jp','å°åˆ·é †åºã®è¦‹ç©ã‚‚ã‚Šã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(430232,11951,'pt','Inserir citaÃ§Ã£o para a ordem de impressÃ£o',0),(430233,11951,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñƒ Ð´Ð»Ñ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(430234,11951,'es','Introduzca cotizaciÃ³n de orden de impresiÃ³n',0),(430235,11951,'de','Geben Sie AnfÃ¼hrungszeichen fÃ¼r Druckreihenfolge',0),(430236,11951,'en','Enter Quote For Print Order',0),(430237,11952,'is','',0),(430238,11952,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(430239,11952,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(430240,11952,'tr','Teklif bilgi girin',0),(430241,11952,'pl','Cytat wprowadziÄ‡ informacji',0),(430242,11952,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(430243,11952,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(430244,11952,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð° Ð˜Ð½Ñ„Ð¾',0),(430245,11952,'vi','BÃ¡o nháº­p thÃ´ng tin',0),(430246,11952,'af','Tik aanhaling Info',0),(430247,11952,'ro','IntroduceÅ£i citat Info',0),(430248,11952,'et','Sisesta pakkumine ja Info',0),(430249,11952,'si','Vnesite narekovaj Info',0),(430250,11952,'ba','Masukkan kutipan Info',0),(430251,11952,'nl','Voer citaat Info',0),(430252,11952,'fi','Anna lainaus Info',0),(430253,11952,'no','Angi sitat Info',0),(430254,11952,'da','Indtast tilbud Info',0),(430255,11952,'ko','ê²¬ì  ì •ë³´ë¥¼ ìž…ë ¥',0),(430256,11952,'he','×”×–×™× ×• ×¦×™×˜×•×˜ ×¤×¨×˜×™',0),(430257,11952,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(430258,11952,'zh','ENTER QUOTE INFO',0),(430259,11952,'sv','Ange citat information',0),(430260,11952,'it','Inserisci citazione Info',0),(430261,11952,'tl','',0),(430262,11952,'th','à¸›à¹‰à¸­à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸­à¹‰à¸²à¸‡à¸­à¸´à¸‡',0),(430263,11952,'hi','à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(430264,11952,'ms','Masukkan petikan maklumat',0),(430265,11952,'ar','Ø£Ø¯Ø®Ù„ Ø¹Ù„Ø§Ù…Ø© Ø§Ù‚ØªØ¨Ø§Ø³ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(430266,11952,'fr','Entrez devis infos',0),(430267,11952,'jp','å¼•ç”¨æƒ…å ±ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(430268,11952,'pt','Inserir CitaÃ§Ã£o informaÃ§Ã£o',0),(430269,11952,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñƒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(430270,11952,'es','Introduzca cotizaciÃ³n Info',0),(430271,11952,'de','Zitat Info eintragen',0),(430272,11952,'en','Enter Quote Info',0),(430273,11953,'is','',0),(430274,11953,'dr','Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(430275,11953,'pr','Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(430276,11953,'tr','Yeniden sÄ±ralama',0),(430277,11953,'pl','KolejnoÅ›Ä‡',0),(430278,11953,'bg','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(430279,11953,'ur','Ø±ÛŒÚ©Ø§Ø±ÚˆØ±',0),(430280,11953,'sr','ÐŸÐ¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(430281,11953,'vi','Ä‘áº·t hÃ ng láº¡i',0),(430282,11953,'af','Herrangskik',0),(430283,11953,'ro','ReordonaÅ£i',0),(430284,11953,'et','Muuda jÃ¤rjestust',0),(430285,11953,'si','NaroÄanja',0),(430286,11953,'ba','Menyusun ulang',0),(430287,11953,'nl','Opnieuw ordenen',0),(430288,11953,'fi','JÃ¤rjestÃ¤ uudelleen',0),(430289,11953,'no','Ordne',0),(430290,11953,'da','Ordn igen',0),(430291,11953,'ko','ìˆœì„œ ë³€ê²½',0),(430292,11953,'he','×œ×¡×“×¨ ×ž×—×“×©',0),(430293,11953,'el','Î‘Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(430294,11953,'zh','é‡æ–°æŽ’åº\r\n',0),(430295,11953,'sv','Ã„ndra ordning',0),(430296,11953,'it','Riordinare',0),(430297,11953,'tl','',0),(430298,11953,'th','à¸à¸²à¸£à¸ˆà¸±à¸”à¸¥à¸³à¸”à¸±à¸šà¹ƒà¸«à¸¡à¹ˆ',0),(430299,11953,'hi','à¤ªà¥à¤¨à¤ƒ à¤…à¤¨à¥à¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(430300,11953,'ms','Susun semula',0),(430301,11953,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªØ±ØªÙŠØ¨',0),(430302,11953,'fr','RÃ©organiser',0),(430303,11953,'jp','é †åºã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(430304,11953,'pt','Reordenar',0),(430305,11953,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°',0),(430306,11953,'es','Reordenar',0),(430307,11953,'de','Neu anordnen',0),(430308,11953,'en','Reorder',0),(430309,11954,'is','',0),(430310,11954,'dr','Ú©Ù¾ÛŒ/Ú†Ø§Ù¾/Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(430311,11954,'pr','Ú©Ù¾ÛŒ/Ú†Ø§Ù¾/Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(430312,11954,'tr','SipariÅŸleri kopyala/yeniden basmak/gÃ¶rÃ¼nÃ¼m',0),(430313,11954,'pl','Przedruk, zobacz Kopiowanie zleceÅ„',0),(430314,11954,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ/Ð¸Ð·Ð³Ð»ÐµÐ´/ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ',0),(430315,11954,'ur','Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹/Ù‚ÙˆÙ„/Ù†Ù‚Ù„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(430316,11954,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜/Ð¿Ñ€Ð¸ÐºÐ°Ð·/ÐºÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(430317,11954,'vi','Xem/in láº¡i báº£n sao Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(430318,11954,'af','Herdruk/View/afskrif bestellings',0),(430319,11954,'ro','Comenzi de retipÄƒrire/Vezi/copie',0),(430320,11954,'et','KordustrÃ¼kk/View/Kopeeri tellimused',0),(430321,11954,'si','Ponatis/View/kopijo naroÄila',0),(430322,11954,'ba','Order cetak ulang/pemandangan/Copy',0),(430323,11954,'nl','Herdruk/weergave/kopiÃ«ren Orders',0),(430324,11954,'fi','Uusintapainos, nÃ¤kymÃ¤, Kopioi tilauksia',0),(430325,11954,'no','Opptrykk/View/Kopier ordrer',0),(430326,11954,'da','Genoptryk/View/kopi ordrer',0),(430327,11954,'ko','ë¬´ë‹¨ ì „ìž¬/ë³´ê¸°/ë³µì‚¬ ìˆœì„œ',0),(430328,11954,'he','×”×“×¤×¡×” ×ž×—×“×©/×ª×¦×•×’×”/×œ×”×¢×ª×™×§ ×¤×§×•×“×•×ª',0),(430329,11954,'el','Î‘Î½Î¬Ï„Ï…Ï€Î¿/Ï€ÏÎ¿Î²Î¿Î»Î®/Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(430330,11954,'zh','è½¬è½½/æŸ¥çœ‹/å¤åˆ¶è®¢å•\r\n',0),(430331,11954,'sv','Reprint/Visa/kopiera order',0),(430332,11954,'it','Ristampa/View/copia ordini',0),(430333,11954,'tl','',0),(430334,11954,'th','à¸žà¸´à¸¡à¸žà¹Œ/à¸”à¸¹/à¸„à¸±à¸”à¸¥à¸­à¸à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(430335,11954,'hi','à¤ªà¥à¤¨à¤°à¥à¤®à¥à¤¦à¥à¤°à¤£/à¤¦à¥‡à¤–à¥‡à¤‚/à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤†à¤¦à¥‡à¤¶',0),(430336,11954,'ms','Pencetakan semula/View/salinan pesanan',0),(430337,11954,'ar','Ø£ÙˆØ§Ù…Ø± Ø·Ø¨Ø¹/Ø¹Ø±Ø¶/Ù†Ø³Ø®',0),(430338,11954,'fr','Ordres de rÃ©impression/View/copie',0),(430339,11954,'jp','å¾©åˆ»ç‰ˆ/ãƒ“ãƒ¥ãƒ¼/ã‚³ãƒ”ãƒ¼æ³¨æ–‡',0),(430340,11954,'pt','Pedidos de reimpressÃ£o/View/cÃ³pia',0),(430341,11954,'ru','ÐŸÐµÑ€ÐµÐ¿ÐµÑ‡Ð°Ñ‚ÐºÐ°/ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/ÐºÐ¾Ð¿Ð¸Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð¾Ð²',0),(430342,11954,'es','Pedidos de reimpresiÃ³n/ver/copiar',0),(430343,11954,'de','Nachdruck/View/Copy-Bestellungen',0),(430344,11954,'en','Reprint/View/Copy Orders',0),(430345,11955,'is','',0),(430346,11955,'dr','ØªÙ…Ø§Ø³ RequestService',0),(430347,11955,'pr','ØªÙ…Ø§Ø³ RequestService',0),(430348,11955,'tr','RequestService Ã§aÄŸrÄ±',0),(430349,11955,'pl','WywoÅ‚anie RequestService',0),(430350,11955,'bg','RequestService Ð¿Ð¾Ð²Ð¸ÐºÐ²Ð°Ð½Ðµ',0),(430351,11955,'ur','Ø±ÛŒÙ‚ÛŒØ³Ù¹Ø³Ø±ÙˆØ§Ø³ÛŒ Ú©Ø§Ù„',0),(430352,11955,'sr','Ð ÐµqÑƒÐµÑÑ‚Ð¡ÐµÑ€Ð²Ð¸Ñ†Ðµ Ð¿Ð¾Ð·Ð¸Ð²',0),(430353,11955,'vi','RequestService cuá»™c gá»i',0),(430354,11955,'af','RequestService oproep',0),(430355,11955,'ro','RequestService apel',0),(430356,11955,'et','RequestService kÃµne',0),(430357,11955,'si','Klic RequestService',0),(430358,11955,'ba','RequestService panggilan',0),(430359,11955,'nl','RequestService oproep',0),(430360,11955,'fi','RequestService soittaa',0),(430361,11955,'no','RequestService samtale',0),(430362,11955,'da','RequestService opkald',0),(430363,11955,'ko','RequestService ì „í™”',0),(430364,11955,'he','RequestService ×§×¨×™××”',0),(430365,11955,'el','RequestService ÎºÎ»Î®ÏƒÎ·',0),(430366,11955,'zh','æœåŠ¡å‘¼å«è¯·æ±‚\r\n',0),(430367,11955,'sv','RequestService samtal',0),(430368,11955,'it','RequestService chiamata',0),(430369,11955,'tl','',0),(430370,11955,'th','à¹‚à¸—à¸£ RequestService',0),(430371,11955,'hi','RequestService à¤•à¥‰à¤²',0),(430372,11955,'ms','RequestService Call',0),(430373,11955,'ar','Ø¯Ø¹ÙˆØ© Ø±ÙŠÙƒÙˆÙŠØ³ØªØ³ÙŠØ±ÙÙŠØ³ÙŠ',0),(430374,11955,'fr','RequestService appel',0),(430375,11955,'jp','RequestService ã‚³ãƒ¼ãƒ«',0),(430376,11955,'pt','RequestService chamada',0),(430377,11955,'ru','RequestService Ð²Ñ‹Ð·Ð¾Ð²',0),(430378,11955,'es','Llamada RequestService',0),(430379,11955,'de','RequestService-Aufruf',0),(430380,11955,'en','RequestService Call',0),(430381,11956,'is','',0),(430382,11956,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø³ØªØ¬Ùˆ',0),(430383,11956,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø³ØªØ¬Ùˆ',0),(430384,11956,'tr','Arama emirleri',0),(430385,11956,'pl','Szukaj zleceÅ„',0),(430386,11956,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(430387,11956,'ur','ØªÙ„Ø§Ø´ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(430388,11956,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(430389,11956,'vi','TÃ¬m Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(430390,11956,'af','Soek bestellings',0),(430391,11956,'ro','Comenzi de cÄƒutare',0),(430392,11956,'et','Otsi tellimusi',0),(430393,11956,'si','Nalogi',0),(430394,11956,'ba','Perintah pencarian',0),(430395,11956,'nl','Huiszoekingsbevel',0),(430396,11956,'fi','Etsi tilauksia',0),(430397,11956,'no','SÃ¸k etter ordrer',0),(430398,11956,'da','UndersÃ¸gelseskendelser',0),(430399,11956,'ko','ê²€ìƒ‰ ìˆœì„œ',0),(430400,11956,'he','×¦×•×•×™ ×—×™×¤×•×©',0),(430401,11956,'el','Î•Î½Ï„Î¬Î»Î¼Î±Ï„Î± Î­ÏÎµÏ…Î½Î±Ï‚',0),(430402,11956,'zh','æœç´¢è®¢å•\r\n',0),(430403,11956,'sv','Husrannsakan',0),(430404,11956,'it','Ricerca ordini',0),(430405,11956,'tl','',0),(430406,11956,'th','à¸„à¹‰à¸™à¸«à¸²à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(430407,11956,'hi','à¤–à¥‹à¤œ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(430408,11956,'ms','Carian pesanan',0),(430409,11956,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ø­Ø«',0),(430410,11956,'fr','Mandats de perquisition',0),(430411,11956,'jp','æ³¨æ–‡ã‚’æ¤œç´¢',0),(430412,11956,'pt','Mandados de busca',0),(430413,11956,'ru','ÐŸÐ¾Ð¸ÑÐº Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(430414,11956,'es','Ã“rdenes de bÃºsqueda',0),(430415,11956,'de','SuchauftrÃ¤ge',0),(430416,11956,'en','Search Orders',0),(430417,11957,'is','',0),(430418,11957,'dr','Ø¨Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ù‡ÛŒØ¯ØŒ Ù„Ø·ÙØ§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯',0),(430419,11957,'pr','Ø¨Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ù‡ÛŒØ¯ØŒ Ù„Ø·ÙØ§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯',0),(430420,11957,'tr','Varolan sipariÅŸlerde deÄŸiÅŸiklik iÃ§in lÃ¼tfen arayÄ±n',0),(430421,11957,'pl','Aby zmieniÄ‡ istniejÄ…ce zamÃ³wienia, prosimy o kontakt',0),(430422,11957,'bg','Ð—Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð¼Ð¾Ð»Ñ, Ð¾Ð±Ð°Ð´ÐµÑ‚Ðµ ÑÐµ',0),(430423,11957,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÙÙˆÙ†',0),(430424,11957,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð»Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ, Ð¼Ð¾Ð»Ð¸Ð¼ Ñ‚Ðµ, Ð·Ð¾Ð²Ð¸',0),(430425,11957,'vi','Äá»ƒ thay Ä‘á»•i Ä‘Æ¡n Ä‘áº·t hÃ ng hiá»‡n cÃ³, xin vui lÃ²ng gá»i',0),(430426,11957,'af','Verander bestaande bestellings, skakel asseblief',0),(430427,11957,'ro','Pentru a schimba comenzile existente, va rugam sa sunati',0),(430428,11957,'et','Olemasolevate tellimuste muutmiseks palume helistada',0),(430429,11957,'si','ÄŒe Å¾elite spremeniti obstojeÄi nalogi, pokliÄite',0),(430430,11957,'ba','Untuk mengubah perintah yang ada, silahkan hubungi',0),(430431,11957,'nl','Als u wilt wijzigen bestaande Orders, bel',0),(430432,11957,'fi','Jos haluat muuttaa olemassa olevia tilauksia, soita',0),(430433,11957,'no','Hvis du vil endre eksisterende bestillinger, ring',0),(430434,11957,'da','Hvis du vil Ã¦ndre eksisterende ordrer, ring venligst',0),(430435,11957,'ko','ê¸°ì¡´ ìˆœì„œë¥¼ ë³€ê²½ í•˜ë ¤ë©´ ì „í™” ì£¼ì„¸ìš”',0),(430436,11957,'he','×›×“×™ ×œ×©× ×•×ª ××ª ×”×•×¨××•×ª×™×•, ×‘×‘×§×©×” ×ª×ª×§×©×¨',0),(430437,11957,'el','Î“Î¹Î± Î½Î± Î±Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î¹Ï‚ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎµÏ‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚, Ï€Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎºÎ±Î»Î­ÏƒÏ„Îµ',0),(430438,11957,'zh','æ”¹å˜çŽ°æœ‰çš„è®¢å•ï¼Œè¯·è‡´ç”µ\r\n',0),(430439,11957,'sv','Om du vill Ã¤ndra befintliga bestÃ¤llningar, vÃ¤nligen ring',0),(430440,11957,'it','Per modificare gli ordini esistenti, si prega di chiamare',0),(430441,11957,'tl','',0),(430442,11957,'th','à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§ à¸à¸£à¸¸à¸“à¸²',0),(430443,11957,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‹ à¤¬à¤¦à¤²à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤•à¥ƒà¤ªà¤¯à¤¾ à¤«à¥‹à¤¨',0),(430444,11957,'ms','Untuk mengubah perintah-perintah sedia ada, sila hubungi',0),(430445,11957,'ar','Ù„ØªØºÙŠÙŠØ± Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©ØŒ ÙŠØ±Ø¬Ù‰ Ø§Ù„Ø§ØªØµØ§Ù„ Ø¹Ù„Ù‰:',0),(430446,11957,'fr','Pour modifier des ordres existants, veuillez composer le',0),(430447,11957,'jp','æ—¢å­˜ã®æ³¨æ–‡ã‚’å¤‰æ›´ã™ã‚‹ã«ã¯ãŠé›»è©±ãã ã•ã„ã€‚',0),(430448,11957,'pt','Para alterar as ordens existentes, por favor, ligue',0),(430449,11957,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ð¾Ð·Ð²Ð¾Ð½Ð¸Ñ‚Ðµ',0),(430450,11957,'es','Para cambiar el orden existente, por favor llame al',0),(430451,11957,'de','Um vorhandene Bestellungen zu Ã¤ndern, rufen Sie bitte',0),(430452,11957,'en','To Change Existing Orders, Please Call',0),(430453,11958,'is','',0),(430454,11958,'dr','Ø¨Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ù‡ÛŒØ¯ØŒ Ù„Ø·ÙØ§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯',0),(430455,11958,'pr','Ø¨Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ù‡ÛŒØ¯ØŒ Ù„Ø·ÙØ§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯',0),(430456,11958,'tr','Varolan istekleri deÄŸiÅŸtirmek iÃ§in lÃ¼tfen arayÄ±n',0),(430457,11958,'pl','Aby zmieniÄ‡ istniejÄ…cych Å¼Ä…daÅ„, prosimy o kontakt',0),(430458,11958,'bg','Ð—Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ð·Ð°ÑÐ²ÐºÐ¸, Ð¼Ð¾Ð»Ñ, Ð¾Ð±Ð°Ð´ÐµÑ‚Ðµ ÑÐµ',0),(430459,11958,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø¯Ø±Ø®ÙˆØ§Ø³ØªÙˆÚº Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÙÙˆÙ†',0),(430460,11958,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð»Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ðµ, Ð¼Ð¾Ð»Ð¸Ð¼ Ñ‚Ðµ, Ð·Ð¾Ð²Ð¸',0),(430461,11958,'vi','Äá»ƒ thay Ä‘á»•i hiá»‡n táº¡i yÃªu cáº§u, xin vui lÃ²ng gá»i',0),(430462,11958,'af','Verander bestaande versoeke, skakel asseblief',0),(430463,11958,'ro','Pentru a modifica existente cereri, vÄƒ rugÄƒm sÄƒ sunaÅ£i',0),(430464,11958,'et','Olemasolevaid taotluste muutmiseks palume helistada',0),(430465,11958,'si','ÄŒe Å¾elite spremeniti obstojeÄe zahteve, prosimo, pokliÄite',0),(430466,11958,'ba','Untuk mengubah permintaan yang ada, silahkan hubungi',0),(430467,11958,'nl','Als u wilt wijzigen de bestaande aanvragen, neem contact op',0),(430468,11958,'fi','Jos haluat muuttaa olemassa olevia pyyntÃ¶jÃ¤, soita',0),(430469,11958,'no','Hvis du vil endre eksisterende forespÃ¸rsler, vennligst ring',0),(430470,11958,'da','Hvis du vil Ã¦ndre eksisterende anmodninger, ring venligst',0),(430471,11958,'ko','ê¸°ì¡´ ìš”ì²­ì„ ë³€ê²½ í•˜ë ¤ë©´ ì „í™” ì£¼ì„¸ìš”',0),(430472,11958,'he','×›×“×™ ×œ×©× ×•×ª ×‘×§×©×•×ª ×”×§×™×™×ž×•×ª, ×‘×‘×§×©×” ×ª×ª×§×©×¨',0),(430473,11958,'el','Î“Î¹Î± Î½Î± Î±Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î¹Ï‚ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎµÏ‚ Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚, Ï€Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎºÎ±Î»Î­ÏƒÏ„Îµ',0),(430474,11958,'zh','æ”¹å˜çŽ°æœ‰çš„è¦æ±‚ï¼Œè¯·è‡´ç”µ\r\n',0),(430475,11958,'sv','Om du vill Ã¤ndra befintliga fÃ¶rfrÃ¥gningar, vÃ¤nligen ring',0),(430476,11958,'it','Per modificare le attuali richieste, si prega di chiamare',0),(430477,11958,'tl','',0),(430478,11958,'th','à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸„à¸³à¸‚à¸­à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§ à¸à¸£à¸¸à¸“à¸²',0),(430479,11958,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚ à¤•à¥‹ à¤¬à¤¦à¤²à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤•à¥ƒà¤ªà¤¯à¤¾ à¤«à¥‹à¤¨',0),(430480,11958,'ms','Untuk menukar permintaan yang sedia ada, sila hubungi',0),(430481,11958,'ar','Ù„ØªØºÙŠÙŠØ± Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ø­Ø§Ù„ÙŠØ©ØŒ ÙŠØ±Ø¬Ù‰ Ø§Ù„Ø§ØªØµØ§Ù„ Ø¹Ù„Ù‰:',0),(430482,11958,'fr','Pour modifier les demandes existantes, s\'il vous plaÃ®t appelez',0),(430483,11958,'jp','æ—¢å­˜ã®è¦æ±‚ã‚’å¤‰æ›´ã™ã‚‹ã«ã¯ãŠé›»è©±ãã ã•ã„ã€‚',0),(430484,11958,'pt','Para alterar as solicitaÃ§Ãµes existentes, por favor, ligue',0),(430485,11958,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÑ‹, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ð¾Ð·Ð²Ð¾Ð½Ð¸Ñ‚Ðµ',0),(430486,11958,'es','Para cambiar las solicitudes existentes, por favor llame al',0),(430487,11958,'de','Um vorhandene Anforderungen zu Ã¤ndern, rufen Sie bitte',0),(430488,11958,'en','To Change Existing Requests, Please Call',0),(430489,11959,'is','',0),(430490,11959,'dr','Ø¨Ù‡ ØªØ±ØªÛŒØ¨ Ø§Ø² Ù†Ù‚Ù„ Ù‚ÙˆÙ„, Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¬Ø³ØªØ¬Ùˆ Ø§Ø² ØµÙØ­Ù‡ ÙˆØ¶Ø¹ÛŒØª Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(430491,11959,'pr','Ø¨Ù‡ ØªØ±ØªÛŒØ¨ Ø§Ø² Ù†Ù‚Ù„ Ù‚ÙˆÙ„, Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¬Ø³ØªØ¬Ùˆ Ø§Ø² ØµÙØ­Ù‡ ÙˆØ¶Ø¹ÛŒØª Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(430492,11959,'tr','Bir sipariÅŸten yapmak iÃ§in bir teklif, kullanÄ±mÄ± arama durum sayfasÄ±ndan alÄ±ntÄ±',0),(430493,11959,'pl','Aby zamÃ³wiÄ‡ oferty, wykorzystanie cytat Szukaj Status strony',0),(430494,11959,'bg','Ð”Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ Ð¾Ñ„ÐµÑ€Ñ‚Ð°, ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð¾Ñ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(430495,11959,'ur','Ø­Ú©Ù… Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ø± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ø§Ù‚ØªØ¨Ø§Ø³ØŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ ØªÙ„Ø§Ø´ Ø­Ø§Ù„Øª ØµÙØ­Û Ø³Û’ Ø§Ù‚ØªØ¨Ø§Ø³',0),(430496,11959,'sr','Ð”Ð° ÑÐµ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐµ Ð¾Ð´ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ, ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¿Ð¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ ÑÐ° Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(430497,11959,'vi','Äá»ƒ lÃ m cho má»™t Ä‘Æ¡n Ä‘áº·t hÃ ng tá»« má»™t bÃ¡o giÃ¡, sá»­ dá»¥ng bÃ¡o giÃ¡ TÃ¬m tá»« tráº¡ng thÃ¡i trang',0),(430498,11959,'af','Om \'n bestelling uit \'n aanhaling, gebruik kwotasie soek van Status bladsy',0),(430499,11959,'ro','Pentru a face o comandÄƒ la un citat, utilizarea citat CÄƒutaÅ£i din pagina de stare',0),(430500,11959,'et','Osta alates pakkumise, kasutamise tsitaat otsingu oleku lehelt',0),(430501,11959,'si','Da bi iz ponudbo, uporabo citiram IÅ¡Äi Status stran',0),(430502,11959,'ba','Membuat perintah dari kutipan, menggunakan kutipan Cari dari halaman Status',0),(430503,11959,'nl','Te maken van een bevel van citaat Zoek een citaat, gebruik uit statuspagina',0),(430504,11959,'fi','TehdÃ¤ tilauksen tarjoukseen, kÃ¤ytÃ¤ lainata Etsi tilasivu',0),(430505,11959,'no','For Ã¥ gjÃ¸re en ordre fra sitere et tilbud, bruk sÃ¸k fra statussiden',0),(430506,11959,'da','For at gÃ¸re en ordre fra citerer et tilbud, brug sÃ¸gning fra statusside',0),(430507,11959,'ko','ì£¼ë¬¸ì„ í•˜ëŠ” ê²¬ì , ì‚¬ìš© ê²€ìƒ‰ íŽ˜ì´ì§€ì—ì„œ ì¸ìš© ìƒíƒœ',0),(430508,11959,'he','×œ×‘×¦×¢ ×”×–×ž× ×” ×ž ×”×¦×¢×ª ×ž×—×™×¨, ×©×™×ž×•×© ×¦×™×˜×•×˜ ×—×™×¤×•×© ×“×£ ×ž×¦×‘',0),(430509,11959,'el','ÎÎ± ÎºÎ¬Î½ÎµÏ„Îµ Î¼Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Ï€ÏŒ Î­Î½Î± Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±, Ï‡ÏÎ®ÏƒÎ· Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î±Ï€ÏŒ Ï„Î· ÏƒÎµÎ»Î¯Î´Î± \"ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·\"',0),(430510,11959,'zh','ä¸ºäº†ä»Žä¸€ä¸ªæŠ¥ä»·è®¢å•ï¼Œè¯·ä½¿ç”¨çŠ¶æ€é¡µæŠ¥ä»·æœç´¢\r\n',0),(430511,11959,'sv','FÃ¶r att gÃ¶ra en Order frÃ¥n citat en offert, anvÃ¤nda SÃ¶k frÃ¥n statussida',0),(430512,11959,'it','Per fare un ordine da un preventivo, l\'uso citare ricerca dalla pagina di stato',0),(430513,11959,'tl','',0),(430514,11959,'th','à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ˆà¸²à¸ à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸² à¹ƒà¸Šà¹‰à¸­à¹‰à¸²à¸‡à¸­à¸´à¸‡à¸„à¹‰à¸™à¸«à¸²à¸ˆà¸²à¸à¸«à¸™à¹‰à¸²à¸ªà¸–à¸²à¸™à¸°',0),(430515,11959,'hi','à¤¸à¥‡ à¤à¤• à¤†à¤¦à¥‡à¤¶ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤¬à¥‹à¤²à¥€, à¤‰à¤ªà¤¯à¥‹à¤— à¤–à¥‹à¤œ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤ªà¥ƒà¤·à¥à¤  à¤¸à¥‡ à¤¬à¥‹à¤²à¥€',0),(430516,11959,'ms','Untuk membuat pesanan dari Quote, penggunaan Quote Cari dari laman Status',0),(430517,11959,'ar','Ø¬Ø¹Ù„ Ø£Ù…Ø± Ù…Ù† Ø§Ù‚ØªØ¨Ø³ Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³ØŒ ÙˆØ§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¨Ø­Ø« Ù…Ù† ØµÙØ­Ø© Ø­Ø§Ù„Ø©',0),(430518,11959,'fr','Pour passer une commande d\'un guillemet, utilisation cite recherche Page d\'Ã‰tat',0),(430519,11959,'jp','å‘½ä»¤ã‚’ã™ã‚‹ã«ã¯ã€å¼•ç”¨ã€ä½¿ç”¨ã™ã‚‹æ¤œç´¢ãƒšãƒ¼ã‚¸ã‹ã‚‰å¼•ç”¨çŠ¶æ…‹',0),(430520,11959,'pt','Para fazer uma ordem de uma citaÃ§Ã£o, usar citar pesquisa da pÃ¡gina de Status',0),(430521,11959,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð· Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð¾Ð¹, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÐŸÐ¾Ð¸ÑÐº ÑÐ¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ñ',0),(430522,11959,'es','Para hacer un pedido de un presupuesto, uso citar bÃºsqueda de pÃ¡gina de estado',0),(430523,11959,'de','Zum Bestellen von Zitat ein Zitat, Verwendung Suche aus der Status-Seite',0),(430524,11959,'en','To Make An Order From A Quote, Use Quote Search From Status Page',0),(430525,11960,'is','',0),(430526,11960,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø±Ø²Ø±Ùˆ ÙØ¹Ù„ÛŒ',0),(430527,11960,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø±Ø²Ø±Ùˆ ÙØ¹Ù„ÛŒ',0),(430528,11960,'tr','GeÃ§erli rezervasyonlarÄ± kontrol',0),(430529,11960,'pl','SprawdÅº aktualne rezerwacje',0),(430530,11960,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ñ€ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ð¸',0),(430531,11960,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø±ÛŒØ²Ø±ÙˆÛŒØ´Ù† Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(430532,11960,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ñ€ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ˜Ðµ',0),(430533,11960,'vi','Kiá»ƒm tra Äáº·t phÃ²ng hiá»‡n táº¡i',0),(430534,11960,'af','Kontroleer die huidige besprekings',0),(430535,11960,'ro','Verifica rezervÄƒrile curent',0),(430536,11960,'et','Vaata praegust broneeringud',0),(430537,11960,'si','Preverite trenutne rezervacije',0),(430538,11960,'ba','Cek reservasi saat ini',0),(430539,11960,'nl','Selectievakje huidige reserveringen',0),(430540,11960,'fi','Tarkista nykyiset varaukset',0),(430541,11960,'no','NÃ¥r gjeldende reservasjoner',0),(430542,11960,'da','Tjek aktuelle forbehold',0),(430543,11960,'ko','í˜„ìž¬ ì˜ˆì•½ í™•ì¸',0),(430544,11960,'he','×‘×“×•×§ ×”×–×ž× ×•×ª ×”× ×•×›×—×™',0),(430545,11960,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎºÏÎ±Ï„Î®ÏƒÎµÎ¹Ï‚',0),(430546,11960,'zh','æ£€æŸ¥çŽ°æœ‰çš„ä¿ç•™æ¡æ–‡\r\n',0),(430547,11960,'sv','Kontrollera aktuella bokningar',0),(430548,11960,'it','Controllare le prenotazioni attuali',0),(430549,11960,'tl','',0),(430550,11960,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸²à¸£à¸ˆà¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(430551,11960,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤†à¤°à¤•à¥à¤·à¤£ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(430552,11960,'ms','Semak tempahan semasa',0),(430553,11960,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„ØªØ­ÙØ¸Ø§Øª Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(430554,11960,'fr','VÃ©rifier les rÃ©servations actuelles',0),(430555,11960,'jp','ç¾åœ¨ã®äºˆç´„ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(430556,11960,'pt','Verificar reservas atuais',0),(430557,11960,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ‚ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð¾Ð³Ð¾Ð²Ð¾Ñ€ÐºÐ¸',0),(430558,11960,'es','Compruebe las reservas actuales',0),(430559,11960,'de','ÃœberprÃ¼fen Sie die aktuelle Reservierungen',0),(430560,11960,'en','Check Current Reservations',0),(430561,11961,'is','',0),(430562,11961,'dr','ÙˆØ¶Ø¹ÛŒØª Ø³ÙØ§Ø±Ø´Ø§Øª',0),(430563,11961,'pr','ÙˆØ¶Ø¹ÛŒØª Ø³ÙØ§Ø±Ø´Ø§Øª',0),(430564,11961,'tr','SipariÅŸlerin mevcut durumu',0),(430565,11961,'pl','Aktualny stan swojego zamÃ³wienia',0),(430566,11961,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¾Ñ‚Ð¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(430567,11961,'ur','Ø¢Ù¾ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ Ù…ÙˆØ¬ÙˆØ¯Û Ø­Ø§Ù„Øª',0),(430568,11961,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(430569,11961,'vi','CÃ¡c tráº¡ng thÃ¡i hiá»‡n táº¡i cá»§a Ä‘Æ¡n Ä‘áº·t hÃ ng cá»§a báº¡n',0),(430570,11961,'af','Huidige Status van jou bestellings',0),(430571,11961,'ro','Starea curentÄƒ a comenzilor dvs',0),(430572,11961,'et','Tellimuste seis',0),(430573,11961,'si','Trenutno stanje vaÅ¡ega naroÄila',0),(430574,11961,'ba','Status saat ini pesanan Anda',0),(430575,11961,'nl','Huidige Status van uw bestellingen',0),(430576,11961,'fi','Tilauksen nykyinen tila',0),(430577,11961,'no','Gjeldende Status for bestillinger',0),(430578,11961,'da','Aktuelle Status for dine bestillinger',0),(430579,11961,'ko','ê·€í•˜ì˜ ì£¼ë¬¸ í˜„ìž¬ ìƒíƒœ',0),(430580,11961,'he','×”×ž×¦×‘ ×”× ×•×›×—×™ ×©×œ ×”×¤×§×•×“×•×ª ×©×œ×š',0),(430581,11961,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ ÏƒÎ±Ï‚',0),(430582,11961,'zh','æ‚¨çš„è®¢å•çŽ°çŠ¶\r\n',0),(430583,11961,'sv','Aktuell Status fÃ¶r din order',0),(430584,11961,'it','Attuale stato dei tuoi ordini',0),(430585,11961,'tl','',0),(430586,11961,'th','à¸ªà¸–à¸²à¸™à¸°à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(430587,11961,'hi','à¤…à¤ªà¤¨à¥‡ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥€ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(430588,11961,'ms','Status semasa pesanan anda',0),(430589,11961,'ar','Ø§Ù„ÙˆØ¶Ø¹ Ø§Ù„Ø­Ø§Ù„ÙŠ Ù„Ø£ÙˆØ§Ù…Ø±Ùƒ',0),(430590,11961,'fr','Ã‰tat d\'avancement de vos commandes',0),(430591,11961,'jp','ã”æ³¨æ–‡ã®ç¾åœ¨ã®ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(430592,11961,'pt','Status atual de suas ordens',0),(430593,11961,'ru','Ð¢ÐµÐºÑƒÑ‰ÐµÐµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð²Ð°ÑˆÐ¸Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(430594,11961,'es','Estado actual de sus pedidos',0),(430595,11961,'de','Aktuellen Status Ihrer AuftrÃ¤ge',0),(430596,11961,'en','Current Status of Your Orders',0),(430597,11962,'is','',0),(430598,11962,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø¬Ø²Ø¦ÛŒØ§Øª Ù…Ø®Ø§Ø·Ø¨ Ø®ÙˆØ¯ Ø±Ø§',0),(430599,11962,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø¬Ø²Ø¦ÛŒØ§Øª Ù…Ø®Ø§Ø·Ø¨ Ø®ÙˆØ¯ Ø±Ø§',0),(430600,11962,'tr','Ä°letiÅŸim bilgilerinizi dÃ¼zenleyin',0),(430601,11962,'pl','EdytowaÄ‡ swoje dane kontaktowe',0),(430602,11962,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(430603,11962,'ur','Ø§Ù¾Ù†Û’ Ø±Ø§Ø¨Ø·Û ØªÙØµÛŒÙ„Ø§Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(430604,11962,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÑÐ²Ð¾Ñ˜Ñƒ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð°Ð´Ñ€ÐµÑÑƒ',0),(430605,11962,'vi','Chá»‰nh sá»­a thÃ´ng tin liÃªn láº¡c',0),(430606,11962,'af','Redigeer jou kontakbesonderhede',0),(430607,11962,'ro','EditaÅ£i datele de Contact',0),(430608,11962,'et','Oma kontaktandmete muutmine',0),(430609,11962,'si','Uredite svoje kontaktne podatke',0),(430610,11962,'ba','Mengedit rincian kontak Anda',0),(430611,11962,'nl','Uw contactgegevens bewerken',0),(430612,11962,'fi','Muokkaa yhteystietosi',0),(430613,11962,'no','Redigere dine kontaktdetaljer',0),(430614,11962,'da','Redigere dine kontaktoplysninger',0),(430615,11962,'ko','ê·€í•˜ì˜ ì—°ë½ì²˜ ì •ë³´ íŽ¸ì§‘',0),(430616,11962,'he','×¢×¨×•×š ××ª ×¤×¨×˜×™ ×”×§×©×¨ ×©×œ×š',0),(430617,11962,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚ ÏƒÎ±Ï‚',0),(430618,11962,'zh','ç¼–è¾‘æ‚¨çš„è”ç³»æ–¹å¼\r\n',0),(430619,11962,'sv','Redigera dina kontaktuppgifter',0),(430620,11962,'it','Modificare i vostri dati di contatto',0),(430621,11962,'tl','',0),(430622,11962,'th','à¹à¸à¹‰à¹„à¸‚à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(430623,11962,'hi','à¤…à¤ªà¤¨à¥‡ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¥‡ à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(430624,11962,'ms','Edit maklumat peribadi anda',0),(430625,11962,'ar','ØªØ­Ø±ÙŠØ± ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø§ØªØµØ§Ù„ Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(430626,11962,'fr','Modifier vos coordonnÃ©es',0),(430627,11962,'jp','ã‚ãªãŸã®é€£çµ¡å…ˆã®è©³ç´°ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(430628,11962,'pt','Editar seus detalhes de contato',0),(430629,11962,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²Ð°ÑˆÐ¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ñ‹Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(430630,11962,'es','Editar sus datos de contacto',0),(430631,11962,'de','Bearbeiten Sie Ihre Kontaktdaten',0),(430632,11962,'en','Edit Your Contact Details',0),(430633,11963,'is','',0),(430634,11963,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù†Ø§Ù… Ø´Ù…Ø§ØŒ Ø¢Ø¯Ø±Ø³ Ø§ÛŒÙ…ÛŒÙ„ØŒ Ùˆ ØºÛŒØ±Ù‡',0),(430635,11963,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù†Ø§Ù… Ø´Ù…Ø§ØŒ Ø¢Ø¯Ø±Ø³ Ø§ÛŒÙ…ÛŒÙ„ØŒ Ùˆ ØºÛŒØ±Ù‡',0),(430636,11963,'tr','Sizin adÄ±nÄ±z, adresiniz, e-posta, vb dÃ¼zenlemek',0),(430637,11963,'pl','EdytowaÄ‡ Twoje imiÄ™, adres, E-mail, itp',0),(430638,11963,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ð°ÑˆÐµÑ‚Ð¾ Ð¸Ð¼Ðµ, Ð°Ð´Ñ€ÐµÑ, Ð¸Ð¼ÐµÐ¹Ð», Ð¸ Ñ‚.Ð½.',0),(430639,11963,'ur','Ø§Ù¾Ù†Ø§ Ù†Ø§Ù…ØŒ Ù¾ØªÛØŒ Ø§ÛŒ Ù…ÛŒÙ„ØŒ ÙˆØºÛŒØ±Û ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(430640,11963,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð²Ð°ÑˆÐµ Ð¸Ð¼Ðµ, Ð°Ð´Ñ€ÐµÑÑƒ, Ðµ-Ð¿Ð¾ÑˆÑ‚Ð°',0),(430641,11963,'vi','Chá»‰nh sá»­a tÃªn cá»§a báº¡n, Ä‘á»‹a chá»‰, Email, vv',0),(430642,11963,'af','Redigeer jou naam, adres, e-pos, ens',0),(430643,11963,'ro','EditaÅ£i numele tau, adresa, Email, etc',0),(430644,11963,'et','Muuda oma nime, aadressi, e-posti jne',0),(430645,11963,'si','Urejanje vaÅ¡e ime, naslov, e-poÅ¡te, itd',0),(430646,11963,'ba','Mengedit nama Anda, alamat, Email, dll',0),(430647,11963,'nl','Bewerken van uw naam, adres, E-mail, enz',0),(430648,11963,'fi','Muokkaa nimi, osoite, sÃ¤hkÃ¶posti',0),(430649,11963,'no','Redigere ditt navn, adresse, epost, etc',0),(430650,11963,'da','Redigere dit navn, adresse, E-mail, osv',0),(430651,11963,'ko','íŽ¸ì§‘ ê·€í•˜ì˜ ì´ë¦„, ì£¼ì†Œ, ì´ë©”ì¼, ë“±',0),(430652,11963,'he','×¢×¨×•×š ××ª ×©×ž×š, ×›×ª×•×‘×ª, ×“×•× ×œ, ×•×›×• \'',0),(430653,11963,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î¬ ÏƒÎ±Ï‚, Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·, Email, ÎºÎ»Ï€',0),(430654,11963,'zh','ç¼–è¾‘æ‚¨çš„å§“ååœ°å€ç”µå­é‚®ä»¶ç­‰\r\n',0),(430655,11963,'sv','Redigera ditt namn, adress, e-post, etc',0),(430656,11963,'it','Modificare il vostro nome, indirizzo, Email, ecc',0),(430657,11963,'tl','',0),(430658,11963,'th','à¹à¸à¹‰à¹„à¸‚ à¸Šà¸·à¹ˆà¸­à¸‚à¸­à¸‡à¸„à¸¸à¸“ à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆ à¸­à¸µà¹€à¸¡à¸¥à¹Œ à¸¯à¸¥à¸¯',0),(430659,11963,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤†à¤ªà¤•à¤¾ à¤¨à¤¾à¤®, à¤ªà¤¤à¤¾, à¤ˆà¤®à¥‡à¤², à¤†à¤¦à¤¿',0),(430660,11963,'ms','Mengedit nama anda, alamat, e-mel, dan lain-lain',0),(430661,11963,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø§Ø³Ù…ØŒ Ø§Ù„Ø¹Ù†ÙˆØ§Ù†ØŒ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠØŒ Ø¥Ù„Ø®',0),(430662,11963,'fr','Modifier votre nom, adresse, Email, etc.',0),(430663,11963,'jp','ã‚ãªãŸã®ãŠåå‰ã€ä½æ‰€ã€é›»å­ãƒ¡ãƒ¼ãƒ«ã€ç­‰ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(430664,11963,'pt','Editar o seu nome, endereÃ§o, E-mail, etc.',0),(430665,11963,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ð°ÑˆÐµ Ð¸Ð¼Ñ, Ð°Ð´Ñ€ÐµÑ, ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð°Ñ Ð¿Ð¾Ñ‡Ñ‚Ð°, Ð¸ Ñ‚.Ð´.',0),(430666,11963,'es','Editar tu nombre, direcciÃ³n, correo electrÃ³nico, etc.',0),(430667,11963,'de','Bearbeiten Sie, Ihr Name, Adresse, E-Mail, etc.',0),(430668,11963,'en','Edit Your Name, Address, Email, etc',0),(430669,11964,'is','',0),(430670,11964,'dr','Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(430671,11964,'pr','Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(430672,11964,'tr','YazdÄ±rma sÄ±rasÄ±nÄ± girin',0),(430673,11964,'pl','Podaj kolejnoÅ›Ä‡ drukowania',0),(430674,11964,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(430675,11964,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(430676,11964,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(430677,11964,'vi','Nháº­p in Ä‘áº·t hÃ ng',0),(430678,11964,'af','Sleutel druk orde',0),(430679,11964,'ro','IntroduceÅ£i comanda imprimare',0),(430680,11964,'et','Saate sisestada printimise jÃ¤rjekorras',0),(430681,11964,'si','VpiÅ¡ite vrstni red tiskanja',0),(430682,11964,'ba','Masukkan pesanan cetakan',0),(430683,11964,'nl','Voer afdrukvolgorde',0),(430684,11964,'fi','Kirjoita tulostusjÃ¤rjestys',0),(430685,11964,'no','Angi utskriftsrekkefÃ¸lge',0),(430686,11964,'da','Angiv udskriftsrÃ¦kkefÃ¸lgen',0),(430687,11964,'ko','ì¸ì‡„ ì£¼ë¬¸ì„ ìž…ë ¥í•©ë‹ˆë‹¤',0),(430688,11964,'he','×”×–×Ÿ ××ª ×¡×“×¨ ×”×”×“×¤×¡×”',0),(430689,11964,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(430690,11964,'zh','è¾“å…¥æ‰“å°è®¢å•\r\n',0),(430691,11964,'sv','Ange utskriftsordning',0),(430692,11964,'it','Immettere l\'ordine di stampa',0),(430693,11964,'tl','',0),(430694,11964,'th','à¸›à¹‰à¸­à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸žà¸´à¸¡à¸žà¹Œ',0),(430695,11964,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(430696,11964,'ms','Masukkan cetakan arahan',0),(430697,11964,'ar','Ø£Ø¯Ø®Ù„ Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(430698,11964,'fr','Entrer dans l\'ordre d\'impression',0),(430699,11964,'jp','å°åˆ·é †åºã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(430700,11964,'pt','Entrar ordem de impressÃ£o',0),(430701,11964,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(430702,11964,'es','Entrar en la orden de impresiÃ³n',0),(430703,11964,'de','Geben Sie die Druckreihenfolge',0),(430704,11964,'en','Enter Print Order',0),(430705,11965,'is','',0),(430706,11965,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ Ø¨Ù‡ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø±Ø¬Ø³ØªÙ‡',0),(430707,11965,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ Ø¨Ù‡ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø±Ø¬Ø³ØªÙ‡',0),(430708,11965,'tr','Ã–denmemiÅŸ faturalar iÃ§in Ã¶deme yapmak',0),(430709,11965,'pl','Dokonywanie pÅ‚atnoÅ›ci zalegÅ‚ych faktur',0),(430710,11965,'bg','Ð˜Ð·Ð²ÑŠÑ€ÑˆÐ²Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð·Ð° Ð½ÐµÐ¸Ð·Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(430711,11965,'ur','Ø¨Ù‚Ø§ÛŒØ§ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø±ØªÛ’',0),(430712,11965,'sr','ÐžÑ‚Ð¿Ð»Ð°Ñ‚Ðµ Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(430713,11965,'vi','Thá»±c hiá»‡n thanh toÃ¡n cho hÃ³a Ä‘Æ¡n xuáº¥t sáº¯c',0),(430714,11965,'af','Maak betalings aan uitstaande fakture',0),(430715,11965,'ro','Efectua plÄƒÅ£i pentru facturile restante',0),(430716,11965,'et','Tasumata arvete maksmisel',0),(430717,11965,'si','PlaÄevanje neplaÄanih raÄunov',0),(430718,11965,'ba','Membuat pembayaran tagihan yang beredar',0),(430719,11965,'nl','Aflost aan openstaande facturen',0),(430720,11965,'fi','Maksaminen laskut',0),(430721,11965,'no','Foreta innbetalinger til utestÃ¥ende fakturaer',0),(430722,11965,'da','Foretage betalinger til udestÃ¥ende fakturaer',0),(430723,11965,'ko','ë›°ì–´ë‚œ ì²­êµ¬ì„œë¥¼ ì§€ë¶ˆ í•˜ ê²Œ',0),(430724,11965,'he','×œ×‘×¦×¢ ×ª×©×œ×•×ž×™× ×”×—×©×‘×•× ×™×•×ª ×ž×¦×˜×™×™× ×™×',0),(430725,11965,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î±Ï€Î»Î®ÏÏ‰Ï„Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(430726,11965,'zh','è®©ä¼˜ç§€å‘ç¥¨ä»˜æ¬¾\r\n',0),(430727,11965,'sv','Utbetalningar till utstÃ¥ende fakturor',0),(430728,11965,'it','Effettuare pagamenti di fatture inevase',0),(430729,11965,'tl','',0),(430730,11965,'th','à¸—à¸³à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸Šà¸³à¸£à¸°',0),(430731,11965,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚ à¤•à¥‹ à¤¬à¤•à¤¾à¤¯à¤¾ à¤šà¤¾à¤²à¤¾à¤¨ à¤¬à¤¨à¤¾à¤¨à¤¾',0),(430732,11965,'ms','Membuat bayaran kepada invois belum jelas.',0),(430733,11965,'ar','ØªØ³Ø¯ÙŠØ¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø©',0),(430734,11965,'fr','Effectuer des paiements de factures en souffrance',0),(430735,11965,'jp','æœªæ‰•ã„ã®è«‹æ±‚æ›¸ã‚’æ”¯æ‰•ã‚’ä½œã‚‹',0),(430736,11965,'pt','Fazer pagamentos de faturas pendentes',0),(430737,11965,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð´Ð»Ñ Ð½ÐµÐ¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(430738,11965,'es','Realizar pagos a facturas pendientes',0),(430739,11965,'de','Zahlungen zu leisten, um ausstehende Rechnungen',0),(430740,11965,'en','Make Payments To Outstanding Invoices',0),(430741,11966,'is','',0),(430742,11966,'dr','Ù¾Ø§Ø±Ú©ÛŒÙ†Ú¯ Ø±Ø²Ø±Ùˆ',0),(430743,11966,'pr','Ù¾Ø§Ø±Ú©ÛŒÙ†Ú¯ Ø±Ø²Ø±Ùˆ',0),(430744,11966,'tr','Park rezervasyonlarÄ±',0),(430745,11966,'pl','Miejsc parkingowych',0),(430746,11966,'bg','ÐŸÐ°Ñ€ÐºÐ¸Ð½Ð³ Ñ€ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ð¸',0),(430747,11966,'ur','Ù¾Ø§Ø±Ú©Ù†Ú¯ Ú©Û’ ØªØ­ÙØ¸Ø§Øª',0),(430748,11966,'sr','Ð ÐµÐ·ÐµÑ€Ð²Ð°Ñ†Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ð°Ñ€ÐºÐ¸Ñ€Ð°ÑšÐµ',0),(430749,11966,'vi','BÃ£i Ä‘áº­u xe Äáº·t phÃ²ng',0),(430750,11966,'af','Parkering besprekings',0),(430751,11966,'ro','RezervÄƒrile de parcare',0),(430752,11966,'et','Parkimiskoht',0),(430753,11966,'si','Parkiranje rezervacije',0),(430754,11966,'ba','Pemesanan parkir',0),(430755,11966,'nl','Parkeren reserveringen',0),(430756,11966,'fi','PysÃ¤kÃ¶intivaraukset',0),(430757,11966,'no','Parkeringstillatelser',0),(430758,11966,'da','Parkering forbehold',0),(430759,11966,'ko','ì£¼ì°¨ ì˜ˆì•½',0),(430760,11966,'he','×ž×§×•×ž×•×ª ×—× ×™×”',0),(430761,11966,'el','ÎšÏÎ±Ï„Î®ÏƒÎµÎ¹Ï‚ ÏƒÏ„Î¬Î¸Î¼ÎµÏ…ÏƒÎ·Ï‚',0),(430762,11966,'zh','åœè½¦åœºé¢„è®¢\r\n',0),(430763,11966,'sv','Parkering reservationer',0),(430764,11966,'it','Prenotazioni parcheggio',0),(430765,11966,'tl','',0),(430766,11966,'th','à¸ˆà¸­à¸‡à¸—à¸µà¹ˆà¸ˆà¸­à¸”à¸£à¸–',0),(430767,11966,'hi','à¤ªà¤¾à¤°à¥à¤•à¤¿à¤‚à¤— à¤•à¤¾ à¤†à¤°à¤•à¥à¤·à¤£',0),(430768,11966,'ms','Tempahan kenderaan',0),(430769,11966,'ar','ÙˆÙ‚ÙˆÙ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ø§Ù„ØªØ­ÙØ¸Ø§Øª',0),(430770,11966,'fr','RÃ©servations de stationnement',0),(430771,11966,'jp','é§è»Šå ´ã®äºˆç´„',0),(430772,11966,'pt','Reservas de estacionamento',0),(430773,11966,'ru','ÐŸÐ°Ñ€ÐºÐ¾Ð²ÐºÐ° Ð±Ñ€Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(430774,11966,'es','Reservas de aparcamiento',0),(430775,11966,'de','Parkplatz-Reservierung',0),(430776,11966,'en','Parking Reservations',0),(430777,11967,'is','',0),(430778,11967,'dr','Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÛŒØ¯',0),(430779,11967,'pr','Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÛŒØ¯',0),(430780,11967,'tr','Yeni sipariÅŸ',0),(430781,11967,'pl','Nowe zamÃ³wienia',0),(430782,11967,'bg','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(430783,11967,'ur','Ù†Ø¦Û’ Ø­Ú©Ù… Ú©ÛŒ Ø¬Ú¯Û',0),(430784,11967,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(430785,11967,'vi','Äáº·t hÃ ng má»›i',0),(430786,11967,'af','Nuwe bestelling plaas',0),(430787,11967,'ro','Locul noua ordine',0),(430788,11967,'et','Tehke uus tellimus',0),(430789,11967,'si','Se novo naroÄilo',0),(430790,11967,'ba','Tempatkan orde baru',0),(430791,11967,'nl','Nieuwe bestelling plaatsen',0),(430792,11967,'fi','Uusi tilaus',0),(430793,11967,'no','Nye bestiller',0),(430794,11967,'da','Placere nye ordre',0),(430795,11967,'ko','ìƒˆë¡œìš´ ì£¼ë¬¸',0),(430796,11967,'he','×”×–×ž× ×” ×—×“×©×”',0),(430797,11967,'el','ÎÎ­Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(430798,11967,'zh','åœ°ç‚¹æ–°ç§©åº\r\n',0),(430799,11967,'sv','Ny bestÃ¤llning',0),(430800,11967,'it','Posizionare il nuovo ordine',0),(430801,11967,'tl','',0),(430802,11967,'th','à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¹ƒà¸«à¸¡à¹ˆ',0),(430803,11967,'hi','à¤¨à¤ à¤†à¤¦à¥‡à¤¶ à¤œà¤—à¤¹',0),(430804,11967,'ms','Membuat pesanan baru',0),(430805,11967,'ar','ÙˆØ¶Ø¹ Ù†Ø¸Ø§Ù… Ø¬Ø¯ÙŠØ¯',0),(430806,11967,'fr','Passer une nouvelle commande',0),(430807,11967,'jp','æ–°è¦æ³¨æ–‡ã—ã¾ã™ã€‚',0),(430808,11967,'pt','Fazer novo pedido',0),(430809,11967,'ru','Ð Ð°Ð·Ð¼ÐµÑÑ‚Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð·',0),(430810,11967,'es','Lugar nuevo orden',0),(430811,11967,'de','Neue Bestellung aufgeben',0),(430812,11967,'en','Place New Order',0),(430813,11968,'is','',0),(430814,11968,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø³Ø§Ø¨Ù‚Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ù…Ø§',0),(430815,11968,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø³Ø§Ø¨Ù‚Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ù…Ø§',0),(430816,11968,'tr','Ã–deme geÃ§miÅŸini incele',0),(430817,11968,'pl','PrzeglÄ…d historii pÅ‚atnoÅ›ci',0),(430818,11968,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ð¹Ñ‚Ðµ Ñ…Ñ€Ð¾Ð½Ð¾Ð»Ð¾Ð³Ð¸ÑÑ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(430819,11968,'ur','Ø¢Ù¾ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(430820,11968,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(430821,11968,'vi','Xem láº¡i lá»‹ch sá»­ thanh toÃ¡n cá»§a báº¡n',0),(430822,11968,'af','Hersien jou betaling geskiedenis',0),(430823,11968,'ro','Revizui Istoricul de plata',0),(430824,11968,'et','Vaadata oma maksete ajalugu',0),(430825,11968,'si','Preglejte vaÅ¡e plaÄilo zgodovino',0),(430826,11968,'ba','Meninjau Riwayat pembayaran Anda',0),(430827,11968,'nl','Uw betalingsgeschiedenis bekijken',0),(430828,11968,'fi','Tarkistaa Maksuhistoria',0),(430829,11968,'no','Se din betaling historie',0),(430830,11968,'da','Anmeld din betalingsoversigt',0),(430831,11968,'ko','ê·€í•˜ì˜ ì§€ë¶ˆ ë‚´ì—­ì„ ê²€í† ',0),(430832,11968,'he','×¡×§×•×¨ ××ª ×”×™×¡×˜×•×¨×™×™×ª ×”×ª×©×œ×•× ×©×œ×š',0),(430833,11968,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· ÏƒÎ±Ï‚ Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(430834,11968,'zh','æŸ¥çœ‹æ‚¨çš„ä»˜æ¬¾åŽ†å²\r\n',0),(430835,11968,'sv','Granska din betalning historia',0),(430836,11968,'it','Rivedere la vostra storia di pagamento',0),(430837,11968,'tl','',0),(430838,11968,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(430839,11968,'hi','à¤†à¤ªà¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(430840,11968,'ms','Mengkaji sejarah bayaran anda',0),(430841,11968,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(430842,11968,'fr','Consultez votre historique de paiement',0),(430843,11968,'jp','ãŠæ”¯æ‰•ã„ã®å±¥æ­´ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(430844,11968,'pt','Revise seu histÃ³rico de pagamentos',0),(430845,11968,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð°Ñ‚Ñ€Ð¸Ð²Ð°Ñ‚ÑŒ Ð¸ÑÑ‚Ð¾Ñ€Ð¸ÑŽ ÑÐ²Ð¾Ð¸Ñ… Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(430846,11968,'es','Revise su historial de pago',0),(430847,11968,'de','ÃœberprÃ¼fen Sie Ihr Zahlungsverhalten',0),(430848,11968,'en','Review Your Payment History',0),(430849,11969,'is','',0),(430850,11969,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø³Ø§Ø¨Ù‚Ù‡ Ø®Ø±ÛŒØ¯',0),(430851,11969,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø³Ø§Ø¨Ù‚Ù‡ Ø®Ø±ÛŒØ¯',0),(430852,11969,'tr','SatÄ±n alma geÃ§miÅŸini incele',0),(430853,11969,'pl','Opisz swojÄ… historiÄ™ zakupu',0),(430854,11969,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ð¹Ñ‚Ðµ Ñ…Ñ€Ð¾Ð½Ð¾Ð»Ð¾Ð³Ð¸ÑÑ‚Ð° Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(430855,11969,'ur','Ø¢Ù¾ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(430856,11969,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(430857,11969,'vi','Xem láº¡i lá»‹ch sá»­ mua hÃ ng cá»§a báº¡n',0),(430858,11969,'af','Hersien jou aankoopgeskiedenis',0),(430859,11969,'ro','Revizui Istoricul de cumpÄƒrare',0),(430860,11969,'et','Vaadake oma ostuajalugu',0),(430861,11969,'si','Pregled vaÅ¡i zgodovini nakupov',0),(430862,11969,'ba','Meninjau Riwayat Pembelian',0),(430863,11969,'nl','Bekijk uw transactieoverzicht',0),(430864,11969,'fi','Arvostelu ostohistoriaa',0),(430865,11969,'no','Se kjÃ¸pshistorikk',0),(430866,11969,'da','Anmeld din kÃ¸bsoversigt',0),(430867,11969,'ko','êµ¬ìž… ë‚´ì—­ ê²€í† ',0),(430868,11969,'he','×¡×§×™×¨×ª ×”×”×™×¡×˜×•×¨×™×” ×”×¨×›×™×©×”',0),(430869,11969,'el','Î•Ï€Î±Î½ÎµÎ¾ÎµÏ„Î¬ÏƒÎµÎ¹ Ï„Î¿ Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Î±Î³Î¿ÏÏŽÎ½ ÏƒÎ±Ï‚',0),(430870,11969,'zh','å›žé¡¾æ‚¨çš„è´­ä¹°è®°å½•\r\n',0),(430871,11969,'sv','Granska din inkÃ¶pshistorik',0),(430872,11969,'it','Rivedere la cronologia dei tuoi acquisti',0),(430873,11969,'tl','',0),(430874,11969,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸à¸²à¸£à¸‹à¸·à¹‰à¸­à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(430875,11969,'hi','à¤†à¤ªà¤•à¥‡ à¤–à¤°à¥€à¤¦à¤¾à¤°à¥€ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(430876,11969,'ms','Meneliti sejarah pembelian anda',0),(430877,11969,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ù…Ø­ÙÙˆØ¸Ø§Øª Ø§Ù„Ø´Ø±Ø§Ø¡ Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(430878,11969,'fr','Examiner l\'historique de vos achats',0),(430879,11969,'jp','è³¼å…¥å±¥æ­´ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(430880,11969,'pt','Revise seu histÃ³rico de compras',0),(430881,11969,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð¸Ñ‚Ðµ ÑÐ²Ð¾ÑŽ Ð¸ÑÑ‚Ð¾Ñ€Ð¸ÑŽ Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº',0),(430882,11969,'es','Revise su historial de compras',0),(430883,11969,'de','ÃœberprÃ¼fen Sie Ihre Einkaufsstatistik',0),(430884,11969,'en','Review Your Purchase History',0),(430885,11970,'is','',0),(430886,11970,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÛŒ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(430887,11970,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÛŒ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(430888,11970,'tr','GÃ¼ncelleÅŸtirme PO nakliye',0),(430889,11970,'pl','WysyÅ‚ka PO aktualizacji',0),(430890,11970,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(430891,11970,'ur','Ù¾Ùˆ Ø´Ù¾Ù†Ú¯ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(430892,11970,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÐŸÐž Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ†Ð¸',0),(430893,11970,'vi','Cáº­p Nháº­t PO váº­n chuyá»ƒn',0),(430894,11970,'af','Bywerking PO gestuur',0),(430895,11970,'ro','Transport de PO actualizare',0),(430896,11970,'et','Update PO laevandus',0),(430897,11970,'si','Dostava PO posodobitvi',0),(430898,11970,'ba','Memperbarui PO pengiriman',0),(430899,11970,'nl','Update PO verzending',0),(430900,11970,'fi','PÃ¤ivitÃ¤ PO toimitus',0),(430901,11970,'no','Oppdatere PO frakt',0),(430902,11970,'da','Opdatering PO Shipping',0),(430903,11970,'ko','ì—…ë°ì´íŠ¸ í¬ ë°°ì†¡',0),(430904,11970,'he','×¢×“×›×•×Ÿ ×¤×• ×ž×©×œ×•×—',0),(430905,11970,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î± PO ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(430906,11970,'zh','æ›´æ–°èˆ¹èˆ¶è®¢å•\r\n',0),(430907,11970,'sv','Uppdatera PO frakt',0),(430908,11970,'it','Aggiornamento PO spedizione',0),(430909,11970,'tl','',0),(430910,11970,'th','à¸­à¸±à¸žà¹€à¸”à¸•à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ PO',0),(430911,11970,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥‹ à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(430912,11970,'ms','Kemaskini Terakhir penghantaran PO',0),(430913,11970,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ Ø¨Ùˆ',0),(430914,11970,'fr','Mise Ã  jour PO expÃ©dition',0),(430915,11970,'jp','æ›´æ–°ã® PO ã®å‡ºè·',0),(430916,11970,'pt','AtualizaÃ§Ã£o PO frete',0),(430917,11970,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ PO Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(430918,11970,'es','ActualizaciÃ³n PO envÃ­o',0),(430919,11970,'de','Update PO Versand',0),(430920,11970,'en','Update PO Shipping',0),(430921,11971,'is','',0),(430922,11971,'dr','Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(430923,11971,'pr','Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(430924,11971,'tr','Nakliye bilgileri PO Ã¼zerinde gÃ¼ncelleme',0),(430925,11971,'pl','Aktualizacja, wysyÅ‚ka na temat PO',0),(430926,11971,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð° PO',0),(430927,11971,'ur','Ø´Ù¾Ù†Ú¯ Ù¾Ùˆ Ù¾Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(430928,11971,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð½Ð° Ð¿Ð¾-Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(430929,11971,'vi','Cáº­p nháº­t thÃ´ng tin vá» PO váº­n chuyá»ƒn',0),(430930,11971,'af','Dateer inligting op PO gestuur',0),(430931,11971,'ro','Actualizare informaÅ£ii pe PO de transport maritim',0),(430932,11971,'et','Uuenda, Shipping Info PO',0),(430933,11971,'si','Posodobite Shipping Info na PO',0),(430934,11971,'ba','Memperbarui Info pada PO pengiriman',0),(430935,11971,'nl','Update verzending Info over PO',0),(430936,11971,'fi','PÃ¤ivitÃ¤ toimitustiedot PO',0),(430937,11971,'no','Oppdatere Shipping Info pÃ¥ PO',0),(430938,11971,'da','Opdatere Shipping Info pÃ¥ PO',0),(430939,11971,'ko','ë°°ì†¡ í¬ì— ëŒ€ í•œ ì •ë³´ ì—…ë°ì´íŠ¸',0),(430940,11971,'he','×¢×“×›×•×Ÿ ×‘× ×•×’×¢ ×œ×ž×©×œ×•×—×™×-×¤×•',0),(430941,11971,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î½Î±Ï…Ï„Î¹Î»Î¹Î±ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± PO',0),(430942,11971,'zh','æ›´æ–°å®èˆªè¿ä¿¡æ¯\r\n',0),(430943,11971,'sv','Uppdatera frakt information om PO',0),(430944,11971,'it','Aggiornare informazioni su PO di spedizione',0),(430945,11971,'tl','',0),(430946,11971,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸šà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(430947,11971,'hi','à¤ªà¥‹à¤¤ à¤ªà¤°à¤¿à¤µà¤¹à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤ªà¥‹ à¤ªà¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(430948,11971,'ms','Kemaskini Terakhir penghantaran maklumat pada PO',0),(430949,11971,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¹Ù„Ù‰ Øµ. Ø¨.',0),(430950,11971,'fr','Mise Ã  jour d\'informations sur PO d\'expÃ©dition',0),(430951,11971,'jp','å‡ºè·æ³¨æ–‡ã«é–¢ã™ã‚‹æƒ…å ±ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(430952,11971,'pt','Atualizar informaÃ§Ã£o sobre PO de envio',0),(430953,11971,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð Ð¾',0),(430954,11971,'es','Actualizar envÃ­o Info po',0),(430955,11971,'de','Versandinfo am PO zu aktualisieren',0),(430956,11971,'en','Update Shipping Info On PO',0),(430957,11972,'is','',0),(430958,11972,'dr','Ø§Ù†ÙˆØ§Ø¹ Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(430959,11972,'pr','Ø§Ù†ÙˆØ§Ø¹ Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(430960,11972,'tr','CC satÄ±nalma tÃ¼rleri',0),(430961,11972,'pl','Rodzaj zakupu CC',0),(430962,11972,'bg','CC Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(430963,11972,'ur','CC Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(430964,11972,'sr','Ð¦Ð¦ Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸',0),(430965,11972,'vi','loáº¡i mua CC',0),(430966,11972,'af','BK aankoop tipes',0),(430967,11972,'ro','Tipuri de cumpÄƒrare CC',0),(430968,11972,'et','CC ostu tÃ¼Ã¼bid',0),(430969,11972,'si','CC nakup vrste',0),(430970,11972,'ba','CC pembelian jenis',0),(430971,11972,'nl','CC aankoop typen',0),(430972,11972,'fi','CC osto tyypit',0),(430973,11972,'no','CC KjÃ¸p typer',0),(430974,11972,'da','CC indkÃ¸bstyper',0),(430975,11972,'ko','CC êµ¬ë§¤ ìœ í˜•',0),(430976,11972,'he','×¡×•×’×™ ×¨×›×© ×¡×ž ×§',0),(430977,11972,'el','Î¤ÏÏ€Î¿Î¹ Î±Î³Î¿ÏÎ¬ CC',0),(430978,11972,'zh','ä¿¡ç”¨å¡è´­ä¹°ç±»åž‹\r\n',0),(430979,11972,'sv','CC kÃ¶p typer',0),(430980,11972,'it','Tipi di acquisto CC',0),(430981,11972,'tl','',0),(430982,11972,'th','à¸Šà¸™à¸´à¸”à¸‹à¸·à¹‰à¸­ CC',0),(430983,11972,'hi','CC à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(430984,11972,'ms','Jenis-jenis pembelian CC',0),(430985,11972,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø´Ø±Ø§Ø¡ CC',0),(430986,11972,'fr','Types d\'achat CC',0),(430987,11972,'jp','CC è³¼å…¥ã‚¿ã‚¤ãƒ—',0),(430988,11972,'pt','Tipos de compra CC',0),(430989,11972,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ CC',0),(430990,11972,'es','CC Tipos de Compras',0),(430991,11972,'de','CC-Kauf-Typen',0),(430992,11972,'en','CC Purchase Types',0),(430993,11973,'is','',0),(430994,11973,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(430995,11973,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(430996,11973,'tr','SatÄ±nalma sipariÅŸi gir',0),(430997,11973,'pl','Edycja zamÃ³wienia zakupu',0),(430998,11973,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(430999,11973,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(431000,11973,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ',0),(431001,11973,'vi','Sá»­a Ä‘á» nghá»‹ mua hÃ ng',0),(431002,11973,'af','Redigeer aankoop orde',0),(431003,11973,'ro','EditaÅ£i comanda de cumpÄƒrare',0),(431004,11973,'et','Redigeeri Ostutellimus',0),(431005,11973,'si','Urejanje nabavni nalog',0),(431006,11973,'ba','Mengedit pesanan pembelian',0),(431007,11973,'nl','Inkooporder bewerken',0),(431008,11973,'fi','Muokkaa ostotilausta',0),(431009,11973,'no','Redigere bestilling',0),(431010,11973,'da','Redigere indkÃ¸bsordre',0),(431011,11973,'ko','ì£¼ë¬¸ì„œ íŽ¸ì§‘',0),(431012,11973,'he','×œ×¢×¨×•×š ×”×–×ž× ×ª ×”×¨×›×©',0),(431013,11973,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(431014,11973,'zh','ç¼–è¾‘é‡‡è´­è®¢å•\r\n',0),(431015,11973,'sv','Redigera inkÃ¶psorder',0),(431016,11973,'it','Modificare l\'ordine di acquisto',0),(431017,11973,'tl','',0),(431018,11973,'th','à¹à¸à¹‰à¹„à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(431019,11973,'hi','à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(431020,11973,'ms','Edit pesanan belian',0),(431021,11973,'ar','ØªØ­Ø±ÙŠØ± Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(431022,11973,'fr','Modifier l\'ordre d\'achat',0),(431023,11973,'jp','æ³¨æ–‡æ›¸ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(431024,11973,'pt','Editar a ordem de compra',0),(431025,11973,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(431026,11973,'es','Editar Orden de Compra',0),(431027,11973,'de','Bestellung bearbeiten',0),(431028,11973,'en','Edit Purchase Order',0),(431029,11974,'is','',0),(431030,11974,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø¬Ø¯ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(431031,11974,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø¬Ø¯ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(431032,11974,'tr','Vergi tablo DÃ¼zenle',0),(431033,11974,'pl','Edycja tabeli podatku od',0),(431034,11974,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ',0),(431035,11974,'ur','Ù¹ÛŒÚ©Ø³ Ø¬Ø¯ÙˆÙ„ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(431036,11974,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ‚Ð°Ð±ÐµÐ»Ñƒ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(431037,11974,'vi','Sá»­a báº£ng thuáº¿',0),(431038,11974,'af','Redigeer belastingtabel',0),(431039,11974,'ro','Editare tabel fiscale',0),(431040,11974,'et','Redigeeri maksude tabel',0),(431041,11974,'si','Urejanje tabele davka',0),(431042,11974,'ba','Mengedit tabel pajak',0),(431043,11974,'nl','BTW-tabel bewerken',0),(431044,11974,'fi','Muokkaa veroasteikon taulukossa',0),(431045,11974,'no','Rediger skatt tabell',0),(431046,11974,'da','Redigere skat tabel',0),(431047,11974,'ko','ì„¸ê¸ˆ í…Œì´ë¸” íŽ¸ì§‘',0),(431048,11974,'he','×¢×¨×™×›×ª ×˜×‘×œ×” ×ž×¡',0),(431049,11974,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î¯Î½Î±ÎºÎ± Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½',0),(431050,11974,'zh','ç¼–è¾‘ç¨ŽçŽ‡è¡¨\r\n',0),(431051,11974,'sv','Redigera skatt tabell',0),(431052,11974,'it','Modifica tabella fiscale',0),(431053,11974,'tl','',0),(431054,11974,'th','à¹à¸à¹‰à¹„à¸‚à¸•à¸²à¸£à¸²à¸‡à¸ à¸²à¸©à¸µ',0),(431055,11974,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(431056,11974,'ms','Edit Jadual cukai',0),(431057,11974,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ',0),(431058,11974,'fr','Modifier la Table d\'impÃ´t',0),(431059,11974,'jp','ç¨ŽçŽ‡è¡¨ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(431060,11974,'pt','Editar a tabela de imposto',0),(431061,11974,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ñ…',0),(431062,11974,'es','Editar Tabla de Impuestos',0),(431063,11974,'de','Steuertabelle bearbeiten',0),(431064,11974,'en','Edit Tax Table',0),(431065,11975,'is','',0),(431066,11975,'dr','Ø¬Ø¯ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª Ø¬Ø¯ÛŒØ¯',0),(431067,11975,'pr','Ø¬Ø¯ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª Ø¬Ø¯ÛŒØ¯',0),(431068,11975,'tr','Yeni vergi tablosu',0),(431069,11975,'pl','Nowej tabeli podatku od',0),(431070,11975,'bg','ÐÐ¾Ð²Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(431071,11975,'ur','Ù†ÛŒØ§ Ù¹ÛŒÚ©Ø³ Ø¬Ø¯ÙˆÙ„',0),(431072,11975,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° ÑÑ‚Ð¾Ð»Ñƒ',0),(431073,11975,'vi','báº£ng thuáº¿ má»›i',0),(431074,11975,'af','Nuwe belasting tabel',0),(431075,11975,'ro','Tabel nou impozit',0),(431076,11975,'et','Uue maksu tabelis',0),(431077,11975,'si','Novega davka na mizo',0),(431078,11975,'ba','Tabel pajak baru',0),(431079,11975,'nl','Nieuwe BTW-tabel',0),(431080,11975,'fi','Uusi vero taulukko',0),(431081,11975,'no','Ny skatt tabell',0),(431082,11975,'da','Ny skat tabel',0),(431083,11975,'ko','ìƒˆë¡œìš´ ì„¸ê¸ˆ í…Œì´ë¸”',0),(431084,11975,'he','×˜×‘×œ×” ×ž×¡ ×—×“×©×”',0),(431085,11975,'el','ÎÎ­Î¿ Ï€Î¯Î½Î±ÎºÎ± Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½',0),(431086,11975,'zh','æ–°ç¨ŽçŽ‡è¡¨\r\n',0),(431087,11975,'sv','Ny skatt tabell',0),(431088,11975,'it','Nuova tabella fiscale',0),(431089,11975,'tl','',0),(431090,11975,'th','à¸•à¸²à¸£à¸²à¸‡à¸ à¸²à¸©à¸µà¹ƒà¸«à¸¡à¹ˆ',0),(431091,11975,'hi','à¤¨à¤¯à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(431092,11975,'ms','Jadual cukai baru',0),(431093,11975,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(431094,11975,'fr','Nouvelle Table d\'impÃ´t',0),(431095,11975,'jp','æ–°ã—ã„ç¨ŽçŽ‡è¡¨',0),(431096,11975,'pt','Nova tabela de imposto',0),(431097,11975,'ru','ÐÐ¾Ð²Ð°Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð°Ñ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(431098,11975,'es','Nuevo Tabla de Impuestos',0),(431099,11975,'de','Neue Steuertabelle',0),(431100,11975,'en','New Tax Table',0),(431101,11976,'is','',0),(431102,11976,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„',0),(431103,11976,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„',0),(431104,11976,'tr','GL hesabÄ± DÃ¼zenle',0),(431105,11976,'pl','Edytuj konto GL',0),(431106,11976,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(431107,11976,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(431108,11976,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð›',0),(431109,11976,'vi','thÃªm tÃ i khoáº£n sá»• cÃ¡i',0),(431110,11976,'af','Redigeer GL rekening',0),(431111,11976,'ro','Edita GL cont',0),(431112,11976,'et','GL konto redigeerimine',0),(431113,11976,'si','Urejanje GL raÄun',0),(431114,11976,'ba','Mengedit GL Account',0),(431115,11976,'nl','GL Account bewerken',0),(431116,11976,'fi','Muokkaa Kirjanpitotilin pÃ¤Ã¤tilin',0),(431117,11976,'no','Redigere gi-konto',0),(431118,11976,'da','Redigere GL konto',0),(431119,11976,'ko','GL ê³„ì • íŽ¸ì§‘',0),(431120,11976,'he','×¢×¨×™×›×ª ×—×©×‘×•×Ÿ GL',0),(431121,11976,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(431122,11976,'zh','ç¼–è¾‘æ€»å¸ä¼šè®¡\r\n',0),(431123,11976,'sv','Redigera GL konto',0),(431124,11976,'it','Modificare Account GL',0),(431125,11976,'tl','',0),(431126,11976,'th','à¹à¸à¹‰à¹„à¸‚à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(431127,11976,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(431128,11976,'ms','Edit akaun GL',0),(431129,11976,'ar','ØªØ­Ø±ÙŠØ± Ø­Ø³Ø§Ø¨ GL',0),(431130,11976,'fr','Modifier compte GL',0),(431131,11976,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(431132,11976,'pt','Editar conta GL',0),(431133,11976,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ GL',0),(431134,11976,'es','Editar Cuenta de LM',0),(431135,11976,'de','GL Account bearbeiten',0),(431136,11976,'en','Edit GL Account',0),(431137,11977,'is','',0),(431138,11977,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(431139,11977,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(431140,11977,'tr','Stok kategorilerini iÃ§e aktarmak',0),(431141,11977,'pl','Importowanie zapasÃ³w Kategorie',0),(431142,11977,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(431143,11977,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø²Ù…Ø±Û Ø¬Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(431144,11977,'sr','Ð£Ð²Ð¾Ð· Ð·Ð°Ð»Ð¸Ñ…Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(431145,11977,'vi','Nháº­p cÃ¡c thá»ƒ loáº¡i hÃ ng hÃ³a',0),(431146,11977,'af','Voer voorraad kategorieÃ«',0),(431147,11977,'ro','Categorii de inventar de import',0),(431148,11977,'et','Impordi varude Kategooriad',0),(431149,11977,'si','Uvoz zaloge kategorije',0),(431150,11977,'ba','Impor persediaan Kategori',0),(431151,11977,'nl','Inventaris CategorieÃ«n importeren',0),(431152,11977,'fi','Tuo varaston Luokat',0),(431153,11977,'no','Importere lager kategorier',0),(431154,11977,'da','Import lageret kategorier',0),(431155,11977,'ko','ê°€ì ¸ì˜¤ê¸° ì¸ë²¤í† ë¦¬ ì¹´í…Œê³ ë¦¬',0),(431156,11977,'he','×™×™×‘×•× ×¨×©×™×ž×ª ×ž×œ××™ ×§×˜×’×•×¨×™×•×ª',0),(431157,11977,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(431158,11977,'zh','å¯¼å…¥å­˜è´§åˆ†ç±»\r\n',0),(431159,11977,'sv','Importera lager kategorier',0),(431160,11977,'it','Importare le categorie di inventario',0),(431161,11977,'tl','',0),(431162,11977,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸›à¸£à¸°à¹€à¸ à¸—à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(431163,11977,'hi','à¤†à¤¯à¤¾à¤¤ à¤¸à¥‚à¤šà¥€ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚',0),(431164,11977,'ms','Import inventori kategori',0),(431165,11977,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙØ¦Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(431166,11977,'fr','Importer des catÃ©gories de l\'inventaire',0),(431167,11977,'jp','åœ¨åº«ã‚«ãƒ†ã‚´ãƒªã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(431168,11977,'pt','Importar categorias do inventÃ¡rio',0),(431169,11977,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(431170,11977,'es','Importar CategorÃ­as de Inventario',0),(431171,11977,'de','Import-Lager-Kategorien',0),(431172,11977,'en','Import Inventory Categories',0),(431173,11978,'is','',0),(431174,11978,'dr','ÙÛŒÙ„ØªØ± Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´',0),(431175,11978,'pr','ÙÛŒÙ„ØªØ± Ú¯Ø±ÙˆÙ‡ ÙØ±ÙˆØ´',0),(431176,11978,'tr','SatÄ±ÅŸ kategori filtresi',0),(431177,11978,'pl','Filtr Kategoria sprzedaÅ¼y',0),(431178,11978,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ñ„Ð¸Ð»Ñ‚ÑŠÑ€',0),(431179,11978,'ur','Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û ÙÙ„Ù¹Ø±',0),(431180,11978,'sr','Ð¤Ð¸Ð»Ñ‚ÐµÑ€ Ð·Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(431181,11978,'vi','SÃ n lá»c thá»ƒ loáº¡i bÃ¡n hÃ ng',0),(431182,11978,'af','Verkope kategorie Filter',0),(431183,11978,'ro','VÃ¢nzÄƒri Categorie filtru',0),(431184,11978,'et','MÃ¼Ã¼k kategooria Filter',0),(431185,11978,'si','Filter prodajnega Kategorija',0),(431186,11978,'ba','Filter kategori penjualan',0),(431187,11978,'nl','Verkoop categorie Filter',0),(431188,11978,'fi','Myynnin luokkasuodatin',0),(431189,11978,'no','Salg kategorifilteret',0),(431190,11978,'da','Salg Kategorifilter',0),(431191,11978,'ko','íŒë§¤ ì¹´í…Œê³ ë¦¬ í•„í„°',0),(431192,11978,'he','×¡×™× ×•×Ÿ ×‘×§×˜×’×•×¨×™×” ×ž×›×™×¨×•×ª',0),(431193,11978,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï†Î¯Î»Ï„ÏÎ¿',0),(431194,11978,'zh','é”€å”®ç±»åˆ«è¿‡æ»¤å™¨\r\n',0),(431195,11978,'sv','FÃ¶rsÃ¤ljningskategori Filter',0),(431196,11978,'it','Filtro categoria Sales',0),(431197,11978,'tl','',0),(431198,11978,'th','à¸•à¸±à¸§à¸à¸£à¸­à¸‡à¸›à¸£à¸°à¹€à¸ à¸—à¸à¸²à¸£à¸‚à¸²à¸¢',0),(431199,11978,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤«à¤¿à¤²à¥à¤Ÿà¤°',0),(431200,11978,'ms','Kategori jualan penapis',0),(431201,11978,'ar','ØªØµÙÙŠØ© ÙØ¦Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(431202,11978,'fr','Filtre de catÃ©gorie de ventes',0),(431203,11978,'jp','è²©å£²ã‚«ãƒ†ã‚´ãƒª ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼',0),(431204,11978,'pt','Filtro de categorias de vendas',0),(431205,11978,'ru','Ð¤Ð¸Ð»ÑŒÑ‚Ñ€ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(431206,11978,'es','Ventas Filtro de CategorÃ­a',0),(431207,11978,'de','Vertrieb Kategoriefilter',0),(431208,11978,'en','Sales Category Filter',0),(431209,11979,'is','',0),(431210,11979,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ØªÙ…Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ ÙØ±ÙˆØ´ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(431211,11979,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ØªÙ…Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ ÙØ±ÙˆØ´ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(431212,11979,'tr','TÃ¼m satÄ±ÅŸ kategorisi girmelisiniz',0),(431213,11979,'pl','NaleÅ¼y wprowadziÄ‡ wszystkie kategorie sprzedaÅ¼y',0),(431214,11979,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(431215,11979,'ur','Ø¢Ù¾ ØªÙ…Ø§Ù… Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û Ø¬Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(431216,11979,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑÐ²Ðµ ÑƒÐ»Ð°Ð·Ð½Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(431217,11979,'vi','Báº¡n Pháº£i Nháº­p Táº¥t cáº£ danh má»¥c bÃ¡n hÃ ng',0),(431218,11979,'af','U Moet Alle Verkoopskategorie Invoer',0),(431219,11979,'ro','IntroduceÅ£i toate categoriile vanzare',0),(431220,11979,'et','Peate sisestama kÃµik mÃ¼Ã¼gi Kategooriad',0),(431221,11979,'si','Vnesti morate vse prodaje kategorije',0),(431222,11979,'ba','Anda harus memasukkan semua kategori penjualan',0),(431223,11979,'nl','U moet alle verkoop categorieÃ«n invoeren',0),(431224,11979,'fi','Anna kaikki myynti Kategoriat',0),(431225,11979,'no','Du mÃ¥ angi alle salg kategorier',0),(431226,11979,'da','Du skal angive alle salg kategorier',0),(431227,11979,'ko','ëª¨ë“  íŒë§¤ ë²”ì£¼ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(431228,11979,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×‘×›×œ ×”×§×˜×’×•×¨×™×•×ª ×ž×›×™×¨×•×ª',0),(431229,11979,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(431230,11979,'zh','æ‚¨å¿…é¡»è¾“å…¥æ‰€æœ‰é”€å”®ç±»åˆ«\r\n',0),(431231,11979,'sv','Du mÃ¥ste ange alla fÃ¶rsÃ¤ljningskategori',0),(431232,11979,'it','Ãˆ necessario inserire tutte le categorie di vendita',0),(431233,11979,'tl','',0),(431234,11979,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸‚à¸²à¸¢à¸—à¸¸à¸à¸›à¸£à¸°à¹€à¸ à¸—',0),(431235,11979,'hi','à¤†à¤ª à¤¸à¤­à¥€ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(431236,11979,'ms','Anda mesti masukkan semua kategori jualan',0),(431237,11979,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ Ø¬Ù…ÙŠØ¹ ÙØ¦Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(431238,11979,'fr','Vous devez entrer toutes les catÃ©gories de vente',0),(431239,11979,'jp','è²©å£²ã®ã™ã¹ã¦ã®ã‚«ãƒ†ã‚´ãƒªã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(431240,11979,'pt','VocÃª deve digitar todas as categorias de vendas',0),(431241,11979,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð²ÑÐµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(431242,11979,'es','Debe Entrar Todas Las CategorÃ­as De Ventas',0),(431243,11979,'de','Sie mÃ¼ssen alle VerkÃ¤ufe Kategorien eingeben.',0),(431244,11979,'en','You Must Enter All Sales Categories',0),(431245,11980,'is','',0),(431246,11980,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø¬Ù‡Øª Ø§Ù†Ø¬Ø§Ù…',0),(431247,11980,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø¬Ù‡Øª Ø§Ù†Ø¬Ø§Ù…',0),(431248,11980,'tr','Kurulum iÃ§in yapÄ±lacak',0),(431249,11980,'pl','Ustawienie do zrobienia',0),(431250,11980,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð° ÑƒÐ¿ÑŠÑ‚Ð²Ð°Ð½ÐµÑ‚Ð¾',0),(431251,11980,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Û’ Ù„ÛŒÛ’ ÙÙ‡Ø±Ø³Øª',0),(431252,11980,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ð·Ð°Ð´ÑƒÐ¶ÐµÑšÐ°',0),(431253,11980,'vi','Thiáº¿t láº­p Ä‘á»ƒ lÃ m',0),(431254,11980,'af','Opstel om moets',0),(431255,11980,'ro','De configurare pentru a',0),(431256,11980,'et','Setup kÃ¤sud',0),(431257,11980,'si','Setup zapovedi',0),(431258,11980,'ba','Setup untuk do \'s',0),(431259,11980,'nl','Setup-taken',0),(431260,11980,'fi','MÃ¤Ã¤ritÃ¤ tehtÃ¤vÃ¤t',0),(431261,11980,'no','Sette opp Ã¥ gjÃ¸re',0),(431262,11980,'da','Setup til do \'s',0),(431263,11980,'ko','ë§ˆë¥¼ ì„¤ì¹˜',0),(431264,11980,'he','×”×”×ª×§× ×” ×¢×©×”',0),(431265,11980,'el','Setup Î³Î¹Î± Î½Î± ÎºÎ¬Î½Î¿Ï…Î¼Îµ',0),(431266,11980,'zh','å®‰è£…å¿…é¡»åšçš„\r\n',0),(431267,11980,'sv','Setup att gÃ¶ra',0),(431268,11980,'it','Installazione a cosa fare',0),(431269,11980,'tl','',0),(431270,11980,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸´à¹ˆà¸‡à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¸›à¸à¸´à¸šà¸±à¸•à¸´',0),(431271,11980,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤¯à¤¾ à¤¹à¥ˆ',0),(431272,11980,'ms','Persediaan untuk dilarang',0),(431273,11980,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ù„Ù…Ø§ ÙŠÙØ¹Ù„',0),(431274,11980,'fr','Installation Ã  faire',0),(431275,11980,'jp','Do ã‚’ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(431276,11980,'pt','Para fazer a instalaÃ§Ã£o',0),(431277,11980,'ru','Setup Ð´Ð»Ñ Ð´ÐµÐ»Ð°Ñ‚ÑŒ',0),(431278,11980,'es','Config Tareas Que Hacer',0),(431279,11980,'de','Setup-Aufgaben',0),(431280,11980,'en','Setup To Do\'s',0),(431281,11981,'is','',0),(431282,11981,'dr','Ú©Ø§Ù„Ø§Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(431283,11981,'pr','Ú©Ø§Ù„Ø§Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(431284,11981,'tr','Stok maddeleri',0),(431285,11981,'pl','ZapasÃ³w',0),(431286,11981,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(431287,11981,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡',0),(431288,11981,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(431289,11981,'vi','danh má»¥c hÃ ng hÃ³a',0),(431290,11981,'af','Voorraad Items',0),(431291,11981,'ro','Obiecte de inventar',0),(431292,11981,'et','Varudes olevate kaupade',0),(431293,11981,'si','Elemente zaloge',0),(431294,11981,'ba','Persediaan barang',0),(431295,11981,'nl','Voorraadartikelen',0),(431296,11981,'fi','Varastonimikkeiden',0),(431297,11981,'no','Lagervarer',0),(431298,11981,'da','Lagervarer',0),(431299,11981,'ko','ìž¬ê³  ëª©ë¡ í’ˆëª©',0),(431300,11981,'he','×¤×¨×™×˜×™ ×ž×œ××™',0),(431301,11981,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(431302,11981,'zh','åº“å­˜ç‰©å“\r\n',0),(431303,11981,'sv','Lagerartiklar',0),(431304,11981,'it','Articoli di magazzino',0),(431305,11981,'tl','',0),(431306,11981,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(431307,11981,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤®',0),(431308,11981,'ms','Item-item inventori',0),(431309,11981,'ar','Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(431310,11981,'fr','Articles en stock',0),(431311,11981,'jp','åœ¨åº«ã‚¢ã‚¤ãƒ†ãƒ ',0),(431312,11981,'pt','Itens de inventÃ¡rio',0),(431313,11981,'ru','Ð¢Ð¾Ð²Ð°Ñ€Ð½Ð¾-Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ñ… Ñ†ÐµÐ½Ð½Ð¾ÑÑ‚ÐµÐ¹',0),(431314,11981,'es','Items de Inventario',0),(431315,11981,'de','Lagerartikel',0),(431316,11981,'en','Inventory Items',0),(431317,11982,'is','',0),(431318,11982,'dr','Ø¯ÙØ¹Ø§Øª ØªØ§Ø²Ù‡ Ø³Ø§Ø²ÛŒ ØµÙØ­Ù‡ Ø§ÙˆÙ„ÛŒÙ‡  ',0),(431319,11982,'pr','Ø¯ÙØ¹Ø§Øª ØªØ§Ø²Ù‡ Ø³Ø§Ø²ÛŒ ØµÙØ­Ù‡ Ø§ÙˆÙ„ÛŒÙ‡  ',0),(431320,11982,'tr','Ana sayfa yenileme kez',0),(431321,11982,'pl','OdÅ›wieÅ¼ stronÄ™ domowÄ… razy',0),(431322,11982,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¾Ð¿Ñ€ÐµÑÐ½ÑÐ²Ð°Ð½Ðµ Ð¿ÑŠÑ‚Ð¸',0),(431323,11982,'ur','Ù…Ø±Ú©Ø²ÛŒ ØµÙØ­Û ØªØ§Ø²Û Ú©Ø±ÛŒÚº Ù¹Ø§Ø¦Ù…Ø²',0),(431324,11982,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐžÑÐ²ÐµÐ¶Ð¸ Ð¿ÑƒÑ‚Ð°',0),(431325,11982,'vi','thá»i gian lÃ m má»›i trang chá»§',0),(431326,11982,'af','Tuisblad Verfris tye',0),(431327,11982,'ro','Pagina de pornire reÃ®mprospÄƒtare ori',0),(431328,11982,'et','KodulehekÃ¼lg vÎ´rskendamise aega',0),(431329,11982,'si','DomaÄo stran OsveÅ¾i krat',0),(431330,11982,'ba','Homepage Refresh kali',0),(431331,11982,'nl','Homepage vernieuwen keer',0),(431332,11982,'fi','Kotisivu pÃ¤ivittÃ¤Ã¤ kertaa',0),(431333,11982,'no','Hjemmesiden Oppdater ganger',0),(431334,11982,'da','Hjemmeside Refresh gange',0),(431335,11982,'ko','í™ˆíŽ˜ì´ì§€ ìƒˆë¡œ ê³ ì¹¨ ì‹œê°„',0),(431336,11982,'he','×¨×¢× ×•×Ÿ ×“×£ ×”×‘×™×ª ×¤×¢×ž×™×',0),(431337,11982,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î± Î±Î½Î±Î½Î­Ï‰ÏƒÎ·Ï‚ Ï†Î¿ÏÎ­Ï‚',0),(431338,11982,'zh','é¦–é¡µåˆ·æ–°æ—¶é—´\r\n',0),(431339,11982,'sv','Hemsida uppdatera gÃ¥nger',0),(431340,11982,'it','Aggiornamento homepage volte',0),(431341,11982,'tl','',0),(431342,11982,'th','à¹€à¸§à¸¥à¸²à¸£à¸µà¹€à¸Ÿà¸£à¸Šà¸«à¸™à¹‰à¸²à¹à¸£à¸',0),(431343,11982,'hi','à¤®à¥à¤–à¤ªà¥ƒà¤·à¥à¤  à¤¤à¤¾à¤œà¤¼à¤¾ à¤Ÿà¤¾à¤‡à¤®à¥à¤¸',0),(431344,11982,'ms','Refresh Laman Utama Times',0),(431345,11982,'ar','Ù…Ø±Ø§Øª ØªØ­Ø¯ÙŠØ« Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(431346,11982,'fr','Temps de rafraÃ®chissement de la page d\'accueil',0),(431347,11982,'jp','ãƒ›ãƒ¼ãƒ ãƒšãƒ¼ã‚¸æ›´æ–°æ™‚é–“',0),(431348,11982,'pt','AtualizaÃ§Ã£o de homepage vezes',0),(431349,11982,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ñ€Ð°Ð·',0),(431350,11982,'es','PÃ¡gina Hogar Tiempos de Refrescar',0),(431351,11982,'de','Homepage Aktualisierungszeiten',0),(431352,11982,'en','Homepage Refresh Times',0),(431353,11983,'is','',0),(431354,11983,'dr','Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ Ø¬Ø¯ÛŒØ¯',0),(431355,11983,'pr','Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´ Ø¬Ø¯ÛŒØ¯',0),(431356,11983,'tr','Yeni satÄ±ÅŸ personeli',0),(431357,11983,'pl','Nowy personel sprzedaÅ¼y',0),(431358,11983,'bg','ÐÐ¾Ð² Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(431359,11983,'ur','Ù†Ø¦ÛŒ ÙØ±ÙˆØ®Øª Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø±',0),(431360,11983,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(431361,11983,'vi','NhÃ¢n viÃªn Kinh doanh má»›i',0),(431362,11983,'af','Nuwe verkope personeel',0),(431363,11983,'ro','Noi personal de vÃ¢nzÄƒri',0),(431364,11983,'et','Uus mÃ¼Ã¼gipersonalile',0),(431365,11983,'si','Novo prodajno osebje',0),(431366,11983,'ba','Personil penjualan baru',0),(431367,11983,'nl','Nieuwe verkooppersoneel',0),(431368,11983,'fi','Uusia myyjiÃ¤',0),(431369,11983,'no','Nye selgere',0),(431370,11983,'da','Ny salgspersonale',0),(431371,11983,'ko','ìƒˆë¡œìš´ íŒë§¤ ì§ì›',0),(431372,11983,'he','×× ×©×™ ×ž×›×™×¨×•×ª ×—×“×©',0),(431373,11983,'el','ÎÎ­Î¿ Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(431374,11983,'zh','å¢žåŠ æ–°é”€å”®äººå‘˜',0),(431375,11983,'sv','Nya sÃ¤ljare',0),(431376,11983,'it','Nuovi personale di vendita',0),(431377,11983,'tl','',0),(431378,11983,'th','à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢à¹ƒà¸«à¸¡à¹ˆ',0),(431379,11983,'hi','à¤¨à¤ˆ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚',0),(431380,11983,'ms','Kakitangan jualan baru',0),(431381,11983,'ar','Ù…ÙˆØ¸ÙÙŠ Ù…Ø¨ÙŠØ¹Ø§Øª Ø¬Ø¯ÙŠØ¯Ø©',0),(431382,11983,'fr','Nouveau Personnel de vente',0),(431383,11983,'jp','æ–°ã—ã„å–¶æ¥­æ‹…å½“è€…',0),(431384,11983,'pt','Pessoal de vendas novo',0),(431385,11983,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ‚Ð¾Ñ€Ð³Ð¾Ð²Ñ‹Ð¹ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(431386,11983,'es','Nueva Personal de Ventas',0),(431387,11983,'de','Neue Verkaufspersonal',0),(431388,11983,'en','New Sales Personnel',0),(431389,11984,'is','',0),(431390,11984,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ø¬Ø¯ÛŒØ¯',0),(431391,11984,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ø¬Ø¯ÛŒØ¯',0),(431392,11984,'tr','Yeni miktar iÃ§in hesaplanan toplam',0),(431393,11984,'pl','Obliczone Å‚Ä…cznie na iloÅ›Ä‡ nowych',0),(431394,11984,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐµÐ¼Ð°Ñ‚Ð° Ð¾Ð±Ñ‰Ð° ÑÑƒÐ¼Ð° Ð·Ð° Ð½Ð¾Ð²Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(431395,11984,'ur','Ù…Ø­Ø³ÙˆØ¨ Ù…ÛŒØ²Ø§Ù† Ù†Ø¦Û’ Ù…Ù‚Ø¯Ø§Ø± Ú©Û’ Ù„ÛŒÛ’',0),(431396,11984,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚Ð¸ Ð·Ð±Ð¸Ñ€ Ð·Ð° Ð½Ð¾Ð²Ñƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(431397,11984,'vi','TÃ­nh tá»•ng cho khá»‘i lÆ°á»£ng má»›i',0),(431398,11984,'af','Bereken die totaal vir nuwe hoeveelheid',0),(431399,11984,'ro','Total calculat pentru noua cantitate',0),(431400,11984,'et','Arvutatud kogusumma uus kogus',0),(431401,11984,'si','IzraÄunane vsote za novo koliÄino',0),(431402,11984,'ba','Total dihitung untuk kuantitas baru',0),(431403,11984,'nl','Berekende totaal voor nieuwe hoeveelheid',0),(431404,11984,'fi','Lasketun summan mÃ¤Ã¤rÃ¤',0),(431405,11984,'no','Beregnede totalen for nye antall',0),(431406,11984,'da','Beregnede samlede for nye mÃ¦ngde',0),(431407,11984,'ko','ìƒˆë¡œìš´ ìˆ˜ëŸ‰ ê³„ì‚°ëœ í•©ê³„',0),(431408,11984,'he','×”×¡×™×›×•× ×©×—×•×©×‘ ×¢×‘×•×¨ ×›×ž×•×ª ×—×“×©',0),(431409,11984,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÏ„Î±Î¹ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬ Î³Î¹Î± Î½Î­Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(431410,11984,'zh','æ–°çš„æ•°é‡è®¡ç®—æ€»è®¡\r\n',0),(431411,11984,'sv','BerÃ¤knad Total fÃ¶r nya kvantitet',0),(431412,11984,'it','Totale calcolato per la nuova quantitÃ ',0),(431413,11984,'tl','',0),(431414,11984,'th','à¸„à¸³à¸™à¸§à¸“à¸¢à¸­à¸”à¸£à¸§à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸£à¸´à¸¡à¸²à¸“à¹ƒà¸«à¸¡à¹ˆ',0),(431415,11984,'hi','à¤¨à¤ˆ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤•à¤²à¤¿à¤¤ à¤¯à¥‹à¤—',0),(431416,11984,'ms','Jumlah keseluruhan dikira bagi kuantiti yang baru',0),(431417,11984,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø­Ø³ÙˆØ¨ Ù„ÙƒÙ…ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(431418,11984,'fr','Total calculÃ© pour la nouvelle quantitÃ©',0),(431419,11984,'jp','æ–°ã—ã„æ•°é‡ã®åˆè¨ˆã‚’è¨ˆç®—',0),(431420,11984,'pt','Total calculado para a quantidade de novo',0),(431421,11984,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾Ð²Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, Ð½Ð¾Ð²Ñ‹Ñ…',0),(431422,11984,'es','CÃ¡lculo Total Para Una Nueva Cantidad',0),(431423,11984,'de','Berechnete Summe fÃ¼r neue Menge',0),(431424,11984,'en','Calculated Total for New Quantity',0),(431425,11985,'is','',0),(431426,11985,'dr','Ø´Ù‡Ø±ÙˆØ¶Ø¹ÛŒØª ØªØ§Ù‡Ù„ ',0),(431427,11985,'pr','Ø´Ù‡Ø±ÙˆØ¶Ø¹ÛŒØª ØªØ§Ù‡Ù„ ',0),(431428,11985,'tr','Åžehir medeni durum',0),(431429,11985,'pl','Miasta stanu cywilnego',0),(431430,11985,'bg','Ð“Ñ€Ð°Ð´ ÑÐµÐ¼ÐµÐ¹Ð½Ð¾ Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(431431,11985,'ur','Ø´ÛØ± Ø§Ø²Ø¯ÙˆØ§Ø¬ÛŒ Ø­ÛŒØ«ÛŒØª',0),(431432,11985,'sr','Ð“Ñ€Ð°Ð´ Ð‘Ñ€Ð°Ñ‡Ð½Ð¾ ÑÑ‚Ð°ÑšÐµ',0),(431433,11985,'vi','TÃ¬nht ráº¡ng HÃ´n nhÃ¢n ThÃ nh Phá»‘',0),(431434,11985,'af','Stad huwelikstatus',0),(431435,11985,'ro','City starea civilÄƒ',0),(431436,11985,'et','Linn Perekonnaseis',0),(431437,11985,'si','Mesto zakonski stan',0),(431438,11985,'ba','Status perkawinan City',0),(431439,11985,'nl','Huwelijkse staat stad',0),(431440,11985,'fi','Kaupungin siviilisÃ¤Ã¤ty',0),(431441,11985,'no','Byen sivilstand',0),(431442,11985,'da','Byen civilstand',0),(431443,11985,'ko','ì‹œ í˜¼ ì¸ ìƒíƒœ',0),(431444,11985,'he','×ž×¦×‘ ×ž×©×¤×—×ª×™ ×©×œ ×”×¢×™×¨',0),(431445,11985,'el','Î ÏŒÎ»Î·Ï‚ Î¿Î¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(431446,11985,'zh','å¸‚å©šå§»çŠ¶å†µ\r\n',0),(431447,11985,'sv','Staden civilstÃ¥nd',0),(431448,11985,'it','Stato civile della cittÃ ',0),(431449,11985,'tl','',0),(431450,11985,'th','à¸ªà¸–à¸²à¸™à¸ à¸²à¸žà¸à¸²à¸£à¹€à¸¡à¸·à¸­à¸‡',0),(431451,11985,'hi','à¤¶à¤¹à¤° à¤µà¥ˆà¤µà¤¾à¤¹à¤¿à¤• à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(431452,11985,'ms','Status perkahwinan bandar',0),(431453,11985,'ar','Ù…Ø¯ÙŠÙ†Ø© Ø§Ù„Ø²ÙˆØ§Ø¬ÙŠØ©',0),(431454,11985,'fr','Ville Ã©tat matrimonial',0),(431455,11985,'jp','å¸‚çµå©šæ­´',0),(431456,11985,'pt','Cidade estado civil',0),(431457,11985,'ru','Ð¡ÐµÐ¼ÐµÐ¹Ð½Ð¾Ðµ Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð³Ð¾Ñ€Ð¾Ð´Ð°',0),(431458,11985,'es','Ciudad Estado Matrimonial',0),(431459,11985,'de','Stadt Familienstand',0),(431460,11985,'en','City Marital Status',0),(431461,11986,'is','',0),(431462,11986,'dr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ ØªÙˆØ¶ÛŒØ­Ø§Øª Ø¨Ø§Ù†Ú© Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(431463,11986,'pr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ ØªÙˆØ¶ÛŒØ­Ø§Øª Ø¨Ø§Ù†Ú© Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(431464,11986,'tr','Ä°Ã§in tÄ±klayÄ±nÄ±z<br>VeritabanÄ± aÃ§Ä±klama',0),(431465,11986,'pl','Kliknij tutaj, aby<br>WyjaÅ›nienie bazy danych',0),(431466,11986,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð°<br>ÐžÐ±ÑÑÐ½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(431467,11986,'ur','Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”<br>ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(431468,11986,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð·Ð°<br>ÐžÐ±Ñ˜Ð°ÑˆÑšÐµÑšÐµ Ð·Ð° Ð±Ð°Ð·Ñƒ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(431469,11986,'vi','Nháº¥n vÃ o Ä‘Ã¢y dá»ƒgiáº£i thÃ­ch dá»¯ liá»‡u cÆ¡ sá»Ÿ',0),(431470,11986,'af','Klik hier vir<br>Databasis verduideliking',0),(431471,11986,'ro','Click aici pentru<br>Baza de date explicaÅ£ie',0),(431472,11986,'et','Kliki siia<br>Andmebaasi selgitus',0),(431473,11986,'si','Kliknite tukaj za<br>Razlaga zbirke podatkov',0),(431474,11986,'ba','Klik di sini untuk<br>Penjelasan database',0),(431475,11986,'nl','Klik hier voor<br>Database uitleg',0),(431476,11986,'fi','Klikkaa tÃ¤stÃ¤<br>Tietokannan kuvaus',0),(431477,11986,'no','Klikk her for<br>Databasen forklaring',0),(431478,11986,'da','Klik her for<br>Database forklaring',0),(431479,11986,'ko','ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì„¸ìš”<br>ë°ì´í„°ë² ì´ìŠ¤ ì„¤ëª…',0),(431480,11986,'he','×œ×—×¦×• ×›××Ÿ<br>×”×¡×‘×¨ ×ž×¡×“ × ×ª×•× ×™×',0),(431481,11986,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î±<br>Î•Î¾Î®Î³Î·ÏƒÎ· Ï„Î·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(431482,11986,'zh','ç‚¹å‡»è¿™é‡Œå¯¹äºŽæ•°æ®åº“è§£é‡Š\r\n',0),(431483,11986,'sv','Klicka hÃ¤r fÃ¶r<br>Databasen fÃ¶rklaring',0),(431484,11986,'it','Clicca qui per<br>Spiegazione del database',0),(431485,11986,'tl','',0),(431486,11986,'th','à¸„à¸¥à¸´à¹Šà¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆ<br>à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¸­à¸‡à¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(431487,11986,'hi','à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚<br>à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤µà¤¿à¤µà¤°à¤£',0),(431488,11986,'ms','Klik di sini untuk<br>Penjelasan pangkalan data',0),(431489,11986,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¹Ø±Ø¶ØªÙˆØ¶ÙŠØ­ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠÙ†Ø§Øª',0),(431490,11986,'fr','Cliquez ici pour voir<br>Explication de la base de donnÃ©es',0),(431491,11986,'jp','ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™ã€‚<br>ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã®èª¬æ˜Ž',0),(431492,11986,'pt','Clique aqui para<br>ExplicaÃ§Ã£o de banco de dados',0),(431493,11986,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ Ð´Ð»Ñ<br>ÐžÐ±ÑŠÑÑÐ½ÐµÐ½Ð¸Ðµ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(431494,11986,'es','Hace Clik Aqui Para InformaciÃ³n de Base de Datos',0),(431495,11986,'de','Klicken Sie hier fÃ¼r<br>Datenbank-ErklÃ¤rung',0),(431496,11986,'en','Click Here for<br>Database Explanation',0),(431497,11987,'is','',0),(431498,11987,'dr','Ø´Ø±Ú©Øª Ø¬Ø¯ÛŒØ¯',0),(431499,11987,'pr','Ø´Ø±Ú©Øª Ø¬Ø¯ÛŒØ¯',0),(431500,11987,'tr','Yeni ÅŸirket',0),(431501,11987,'pl','Nowa firma',0),(431502,11987,'bg','ÐÐ¾Ð²Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(431503,11987,'ur','Ù†Ø¦ÛŒ Ú©Ù…Ù¾Ù†ÛŒ',0),(431504,11987,'sr','ÐÐ¾Ð²Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(431505,11987,'vi','cÃ´ng ty má»›i',0),(431506,11987,'af','Nuwe maatskappy',0),(431507,11987,'ro','Noua companie',0),(431508,11987,'et','Uus ettevÃµte',0),(431509,11987,'si','Novo podjetje',0),(431510,11987,'ba','Perusahaan baru',0),(431511,11987,'nl','Nieuw bedrijf',0),(431512,11987,'fi','Uusi yritys',0),(431513,11987,'no','Plateselskap',0),(431514,11987,'da','Nyt selskab',0),(431515,11987,'ko','ìƒˆë¡œìš´ íšŒì‚¬',0),(431516,11987,'he','×—×‘×¨×” ×—×“×©×”',0),(431517,11987,'el','ÎÎ­Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(431518,11987,'zh','æ–°å…¬å¸\r\n',0),(431519,11987,'sv','Nytt fÃ¶retag',0),(431520,11987,'it','Nuova societÃ ',0),(431521,11987,'tl','',0),(431522,11987,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¹ƒà¸«à¸¡à¹ˆ',0),(431523,11987,'hi','à¤¨à¤ˆ à¤•à¤‚à¤ªà¤¨à¥€',0),(431524,11987,'ms','Syarikat baru',0),(431525,11987,'ar','Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(431526,11987,'fr','Nouvelle sociÃ©tÃ©',0),(431527,11987,'jp','æ–°ä¼šç¤¾',0),(431528,11987,'pt','Nova empresa',0),(431529,11987,'ru','ÐÐ¾Ð²Ð°Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(431530,11987,'es','Nueva Empresa',0),(431531,11987,'de','Neue Unternehmen',0),(431532,11987,'en','New Company',0),(431533,11988,'is','',0),(431534,11988,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø§Ù†ÙˆØ§Ø¹ Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(431535,11988,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø§Ù†ÙˆØ§Ø¹ Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(431536,11988,'tr','Kredi kartÄ± satÄ±n alma tÃ¼rÃ¼nÃ¼ DÃ¼zenle',0),(431537,11988,'pl','Edytowanie typu zakup karty kredytowej',0),(431538,11988,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(431539,11988,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(431540,11988,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ñ‚Ð¸Ð¿ Ð½Ð°Ð±Ð°Ð²ÐºÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(431541,11988,'vi','ThÃªm tháº» mua hÃ ng ghi cÃ³',0),(431542,11988,'af','Redigeer kredietkaart aankoop tipe',0),(431543,11988,'ro','Editare tip de cumpÄƒrare Card de Credit',0),(431544,11988,'et','Redigeeri krediitkaardi ostu tÃ¼Ã¼p',0),(431545,11988,'si','Uredite vrsto nakup kreditni kartici',0),(431546,11988,'ba','Mengedit jenis pembelian kartu kredit',0),(431547,11988,'nl','Creditcard Type inkoop bewerken',0),(431548,11988,'fi','Muokkaa luottokortilla oston tyyppi',0),(431549,11988,'no','Redigere kredittkort bestillingstype',0),(431550,11988,'da','Redigere kreditkort KÃ¸b Type',0),(431551,11988,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ í˜•ì‹ íŽ¸ì§‘',0),(431552,11988,'he','×¢×¨×•×š ×¡×•×’ ×”×¨×›×™×©×” ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(431553,11988,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½ Î±Î³Î¿ÏÎ¬ Ï„ÏÏ€Î¿Ï…',0),(431554,11988,'zh','ç¼–è¾‘ä¿¡ç”¨å¡è´­ä¹°ç±»åž‹\r\n',0),(431555,11988,'sv','Redigera kÃ¶p kreditkortstyp',0),(431556,11988,'it','Modificare il tipo di acquisto di carta di credito',0),(431557,11988,'tl','',0),(431558,11988,'th','à¹à¸à¹‰à¹„à¸‚à¸Šà¸™à¸´à¸”à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸‹à¸·à¹‰à¸­',0),(431559,11988,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(431560,11988,'ms','Edit jenis pembelian kad kredit',0),(431561,11988,'ar','ØªØ­Ø±ÙŠØ± Ù†ÙˆØ¹ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(431562,11988,'fr','Modifier le Type d\'achat de carte de crÃ©dit',0),(431563,11988,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰è³¼å…¥ã®ç¨®é¡žã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(431564,11988,'pt','Editar tipo de compra de cartÃ£o de crÃ©dito',0),(431565,11988,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(431566,11988,'es','Editar Tipo de Compras de Tarjets de CrÃ©dito',0),(431567,11988,'de','Kreditkarte kaufen Typ bearbeiten',0),(431568,11988,'en','Edit Credit Card Purchase Type',0),(431569,11989,'is','',0),(431570,11989,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø´Ø±Ú©Øª',0),(431571,11989,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø´Ø±Ú©Øª',0),(431572,11989,'tr','DÃ¼zen ÅŸirket',0),(431573,11989,'pl','Edycja firmy',0),(431574,11989,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(431575,11989,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Ù…Ù¾Ù†ÛŒ',0),(431576,11989,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(431577,11989,'vi','ThÃªm cÃ´ng ty',0),(431578,11989,'af','Redigeer maatskappy',0),(431579,11989,'ro','Companie de editare',0),(431580,11989,'et','Muuda ettevÃµtte',0),(431581,11989,'si','Podjetje za urejanje',0),(431582,11989,'ba','Edit perusahaan',0),(431583,11989,'nl','Bewerken bedrijf',0),(431584,11989,'fi','Muokkaa yrityksen',0),(431585,11989,'no','Rediger selskap',0),(431586,11989,'da','Rediger selskab',0),(431587,11989,'ko','íŽ¸ì§‘ íšŒì‚¬',0),(431588,11989,'he','×”×—×‘×¨×” ×”×¢×¨×™×›×”',0),(431589,11989,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(431590,11989,'zh','ç¼–è¾‘å…¬å¸\r\n',0),(431591,11989,'sv','Redigera fÃ¶retag',0),(431592,11989,'it','Modifica azienda',0),(431593,11989,'tl','',0),(431594,11989,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¹à¸à¹‰à¹„à¸‚',0),(431595,11989,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤‚à¤ªà¤¨à¥€',0),(431596,11989,'ms','Syarikat Edit',0),(431597,11989,'ar','Ø´Ø±ÙƒØ© ØªØ­Ø±ÙŠØ±',0),(431598,11989,'fr','Ã‰dition entreprise',0),(431599,11989,'jp','ç·¨é›†ä¼šç¤¾',0),(431600,11989,'pt','Empresa de ediÃ§Ã£o',0),(431601,11989,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(431602,11989,'es','Editar Empresa',0),(431603,11989,'de','Bearbeiten Firma',0),(431604,11989,'en','Edit Company',0),(431605,11990,'is','',0),(431606,11990,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(431607,11990,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(431608,11990,'tr','Kredi kartÄ± dÃ¼zenleme',0),(431609,11990,'pl','Edycja karty kredytowej',0),(431610,11990,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(431611,11990,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(431612,11990,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(431613,11990,'vi','thÃªm tháº» ghi cÃ³',0),(431614,11990,'af','Redigeer kredietkaart',0),(431615,11990,'ro','Editare carte de Credit',0),(431616,11990,'et','Muuda kaardi',0),(431617,11990,'si','Urejanje kreditne kartice',0),(431618,11990,'ba','Mengedit kartu kredit',0),(431619,11990,'nl','Creditcard bewerken',0),(431620,11990,'fi','Muokkaa luottokortti',0),(431621,11990,'no','Redigere kredittkort',0),(431622,11990,'da','Redigere kreditkort',0),(431623,11990,'ko','ì‹ ìš© ì¹´ë“œ íŽ¸ì§‘',0),(431624,11990,'he','×¢×¨×™×›×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(431625,11990,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(431626,11990,'zh','ä¿®æ”¹ä¿¡ç”¨å¡\r\n',0),(431627,11990,'sv','Redigera kreditkort',0),(431628,11990,'it','Modificare la carta di credito',0),(431629,11990,'tl','',0),(431630,11990,'th','à¹à¸à¹‰à¹„à¸‚à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(431631,11990,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(431632,11990,'ms','Edit kad kredit',0),(431633,11990,'ar','ØªØ­Ø±ÙŠØ± Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(431634,11990,'fr','Modifier la carte de crÃ©dit',0),(431635,11990,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(431636,11990,'pt','Editar o cartÃ£o de crÃ©dito',0),(431637,11990,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(431638,11990,'es','Editar Tarjeta de CrÃ©dito',0),(431639,11990,'de','Bearbeiten von Kreditkarte',0),(431640,11990,'en','Edit Credit Card',0),(431641,11991,'is','',0),(431642,11991,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(431643,11991,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(431644,11991,'tr','Kredi kartÄ± satÄ±n alma dÃ¼zenleme',0),(431645,11991,'pl','Edytuj zakup kartÄ… kredytowÄ…',0),(431646,11991,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(431647,11991,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(431648,11991,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(431649,11991,'vi','ThÃªm tháº» mua hÃ ng ghi cÃ³',0),(431650,11991,'af','Redigeer kredietkaart aankoop',0),(431651,11991,'ro','Editare carte de Credit cumpÄƒrare',0),(431652,11991,'et','Redigeeri krediitkaardiga ost',0),(431653,11991,'si','Uredi nakup kreditni kartici',0),(431654,11991,'ba','Mengedit kartu kredit pembelian',0),(431655,11991,'nl','Creditcard aankoop bewerken',0),(431656,11991,'fi','Muokkaa luottokortin hankinta',0),(431657,11991,'no','Redigere kredittkort kjÃ¸p',0),(431658,11991,'da','Redigere kreditkort kÃ¸b',0),(431659,11991,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ë¥¼ íŽ¸ì§‘',0),(431660,11991,'he','×¢×¨×™×›×ª ×¨×›×™×©×” ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(431661,11991,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Î³Î¿ÏÎ¬ Î¼Î­ÏƒÏ‰ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(431662,11991,'zh','ç¼–è¾‘ä¿¡ç”¨å¡è´­ä¹°\r\n',0),(431663,11991,'sv','Redigera kreditkort kÃ¶p',0),(431664,11991,'it','Modificare la carta di credito di acquisto',0),(431665,11991,'tl','',0),(431666,11991,'th','à¹à¸à¹‰à¹„à¸‚à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸‹à¸·à¹‰à¸­',0),(431667,11991,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤–à¤°à¥€à¤¦ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(431668,11991,'ms','Edit kad kredit pembelian',0),(431669,11991,'ar','ØªØ­Ø±ÙŠØ± Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(431670,11991,'fr','Modifier l\'achat par carte de crÃ©dit',0),(431671,11991,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã§è³¼å…¥ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(431672,11991,'pt','Editar a compra de cartÃ£o de crÃ©dito',0),(431673,11991,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐµ',0),(431674,11991,'es','Editar Compra por Tarjeta de CrÃ©dito',0),(431675,11991,'de','Kreditkartenkauf bearbeiten',0),(431676,11991,'en','Edit Credit Card Purchase',0),(431677,11992,'is','',0),(431678,11992,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ú¯Ø±ÙˆÙ‡ Ù¾ÛŒØºØ§Ù…',0),(431679,11992,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ú¯Ø±ÙˆÙ‡ Ù¾ÛŒØºØ§Ù…',0),(431680,11992,'tr','Ä°leti kategorisini DÃ¼zenle',0),(431681,11992,'pl','Edytuj wiadomoÅ›Ä‡ Kategoria',0),(431682,11992,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð² ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(431683,11992,'ur','Ù¾ÛŒØºØ§Ù… Ú©ÛŒ Ø²Ù…Ø±Û ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(431684,11992,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(431685,11992,'vi','Sá»­a loáº¡i tin nháº¯n',0),(431686,11992,'af','Redigeer boodskap kategorie',0),(431687,11992,'ro','Editare categorie mesaj',0),(431688,11992,'et','Redigeerige sÃµnumi kategooria',0),(431689,11992,'si','Uredite sporoÄilo Kategorija',0),(431690,11992,'ba','Mengedit pesan Kategori',0),(431691,11992,'nl','Categorie bericht bewerken',0),(431692,11992,'fi','Muokkaa viestin luokka',0),(431693,11992,'no','Redigere meldingskategorien',0),(431694,11992,'da','Redigere meddelelsen kategori',0),(431695,11992,'ko','ë©”ì‹œì§€ ë²”ì£¼ íŽ¸ì§‘',0),(431696,11992,'he','×¢×¨×•×š ×”×•×“×¢×ª ×§×˜×’×•×¨×™×”',0),(431697,11992,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚ Î¼Î®Î½Ï…Î¼Î±',0),(431698,11992,'zh','ç¼–è¾‘æ¶ˆæ¯ç±»åˆ«\r\n',0),(431699,11992,'sv','Redigera meddelandekategori',0),(431700,11992,'it','Modificare la categoria del messaggio',0),(431701,11992,'tl','',0),(431702,11992,'th','à¹à¸à¹‰à¹„à¸‚à¸›à¸£à¸°à¹€à¸ à¸—à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡',0),(431703,11992,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(431704,11992,'ms','Mengedit kategori mesej',0),(431705,11992,'ar','ØªØ­Ø±ÙŠØ± ÙØ¦Ø© Ø§Ù„Ø±Ø³Ø§Ù„Ø©',0),(431706,11992,'fr','Modifier la catÃ©gorie de Message',0),(431707,11992,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®ã‚«ãƒ†ã‚´ãƒªã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(431708,11992,'pt','Editar categoria de mensagem',0),(431709,11992,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(431710,11992,'es','Editar CategorÃ­a de Mensaje',0),(431711,11992,'de','Nachrichtenkategorie bearbeiten',0),(431712,11992,'en','Edit Message Category',0),(431713,11993,'is','',0),(431714,11993,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ú¯Ø±Ø§ÙÛŒÚ© Ù¾ÛŒØºØ§Ù…',0),(431715,11993,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ú¯Ø±Ø§ÙÛŒÚ© Ù¾ÛŒØºØ§Ù…',0),(431716,11993,'tr','Ä°leti grafiÄŸi dÃ¼zenleme',0),(431717,11993,'pl','Edycja wiadomoÅ›ci graficzne',0),(431718,11993,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(431719,11993,'ur','Ù¾ÛŒØºØ§Ù… Ú¯Ø±Ø§ÙÚ© ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(431720,11993,'sr','Ð£Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑƒÐºÑƒ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(431721,11993,'vi','Sá»­a biá»ƒu tÆ°á»£ng tin nháº¯n',0),(431722,11993,'af','Redigeer boodskap grafiese',0),(431723,11993,'ro','Editare mesaj grafic',0),(431724,11993,'et','Redigeerige sÃµnumi pilt',0),(431725,11993,'si','Uredite grafiÄni element sporoÄilo',0),(431726,11993,'ba','Mengedit pesan grafis',0),(431727,11993,'nl','Bericht afbeelding bewerken',0),(431728,11993,'fi','Muokkaa viesti graafinen',0),(431729,11993,'no','Redigere melding grafiske',0),(431730,11993,'da','Redigere meddelelsen grafik',0),(431731,11993,'ko','ë©”ì‹œì§€ ê·¸ëž˜í”½ íŽ¸ì§‘',0),(431732,11993,'he','×¢×¨×•×š ×”×•×“×¢×ª ×’×¨×¤×™×§×”',0),(431733,11993,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î³ÏÎ±Ï†Î¹ÎºÎ¿Ï Î¼Î®Î½Ï…Î¼Î±',0),(431734,11993,'zh','ç¼–è¾‘æ¶ˆæ¯å›¾ç¤º\r\n',0),(431735,11993,'sv','Redigera meddelandet grafik',0),(431736,11993,'it','Modifica messaggio grafico',0),(431737,11993,'tl','',0),(431738,11993,'th','à¹à¸à¹‰à¹„à¸‚à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸à¸£à¸²à¸Ÿà¸´à¸',0),(431739,11993,'hi','à¤¸à¤‚à¤¦à¥‡à¤¶ à¤—à¥à¤°à¤¾à¤«à¤¼à¤¿à¤• à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(431740,11993,'ms','Mengedit grafik mesej',0),(431741,11993,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø±Ø³Ù… Ø±Ø³Ø§Ù„Ø©',0),(431742,11993,'fr','Modifier Message graphique',0),(431743,11993,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(431744,11993,'pt','Editar mensagem grÃ¡fica',0),(431745,11993,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ñ… ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹',0),(431746,11993,'es','Editar GrÃ¡fico de Mensaje',0),(431747,11993,'de','Bearbeiten Sie Message-Grafik',0),(431748,11993,'en','Edit Message Graphic',0),(431749,11994,'is','',0),(431750,11994,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ú¯Ø±ÙˆÙ‡ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª',0),(431751,11994,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ú¯Ø±ÙˆÙ‡ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª',0),(431752,11994,'tr','Not Kategori DÃ¼zenle',0),(431753,11994,'pl','Edycja kategorii Uwaga',0),(431754,11994,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð² Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(431755,11994,'ur','Ù†ÙˆÙ¹ Ø²Ù…Ø±Û ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(431756,11994,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(431757,11994,'vi','Sá»­a loáº¡i ghi chÃº',0),(431758,11994,'af','Redigeer Nota kategorie',0),(431759,11994,'ro','Editare notÄƒ categorie',0),(431760,11994,'et','MÃ¤rkus kategooria redigeerimine',0),(431761,11994,'si','Urejanje kategorije Opomba',0),(431762,11994,'ba','Mengedit kategori catatan',0),(431763,11994,'nl','Opmerking rubriek bewerken',0),(431764,11994,'fi','Muokkaa Huomautus luokka',0),(431765,11994,'no','Redigere Merk kategori',0),(431766,11994,'da','Redigere BemÃ¦rk kategori',0),(431767,11994,'ko','ì°¸ê³  ë²”ì£¼ íŽ¸ì§‘',0),(431768,11994,'he','×¢×¨×•×š ×”×¢×¨×” ×§×˜×’×•×¨×™×”',0),(431769,11994,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚',0),(431770,11994,'zh','ä¿®æ”¹å¤‡æ³¨ç±»åˆ«\r\n',0),(431771,11994,'sv','Redigera anteckning kategori',0),(431772,11994,'it','Modifica nota categoria',0),(431773,11994,'tl','',0),(431774,11994,'th','à¹à¸à¹‰à¹„à¸‚à¸›à¸£à¸°à¹€à¸ à¸—à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸',0),(431775,11994,'hi','à¤¨à¥‹à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(431776,11994,'ms','Mengedit kategori Nota',0),(431777,11994,'ar','ØªØ­Ø±ÙŠØ± Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„ÙØ¦Ø©',0),(431778,11994,'fr','Modifier Note catÃ©gorie',0),(431779,11994,'jp','æ³¨ã‚«ãƒ†ã‚´ãƒªã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(431780,11994,'pt','Editar Categoria nota',0),(431781,11994,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(431782,11994,'es','Editar CategorÃ­a de Notas',0),(431783,11994,'de','Hinweis-Kategorie bearbeiten',0),(431784,11994,'en','Edit Note Category',0),(431785,11995,'is','',0),(431786,11995,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ú©Ø§Ø±Ø¨Ø±',0),(431787,11995,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ú©Ø§Ø±Ø¨Ø±',0),(431788,11995,'tr','KullanÄ±cÄ± dÃ¼zenleme',0),(431789,11995,'pl','Edytuj uÅ¼ytkownika',0),(431790,11995,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(431791,11995,'ur','ØµØ§Ø±Ù ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(431792,11995,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(431793,11995,'vi','Sá»­a ngÆ°á»i sá»­ dá»¥ng',0),(431794,11995,'af','Redigeer gebruiker',0),(431795,11995,'ro','Editare utilizator',0),(431796,11995,'et','Muuda kasutajat',0),(431797,11995,'si','Urejanje uporabnik',0),(431798,11995,'ba','Mengedit pengguna',0),(431799,11995,'nl','Bewerken gebruiker',0),(431800,11995,'fi','Muokkaa kÃ¤yttÃ¤jÃ¤Ã¤',0),(431801,11995,'no','Rediger bruker',0),(431802,11995,'da','Rediger bruger',0),(431803,11995,'ko','ì‚¬ìš©ìž íŽ¸ì§‘',0),(431804,11995,'he','×¢×¨×•×š ×ž×©×ª×ž×©',0),(431805,11995,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(431806,11995,'zh','ç¼–è¾‘ç”¨æˆ·\r\n',0),(431807,11995,'sv','Redigera anvÃ¤ndare',0),(431808,11995,'it','Modifica utente',0),(431809,11995,'tl','',0),(431810,11995,'th','à¹à¸à¹‰à¹„à¸‚à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(431811,11995,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(431812,11995,'ms','Edit pengguna',0),(431813,11995,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(431814,11995,'fr','Modifier utilisateur',0),(431815,11995,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(431816,11995,'pt','Editar usuÃ¡rio',0),(431817,11995,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(431818,11995,'es','Editar Usuario',0),(431819,11995,'de','Benutzer bearbeiten',0),(431820,11995,'en','Edit User',0),(431821,11996,'is','',0),(431822,11996,'dr','Ø¯ÙØ¹Ø§Øª ØªØ§Ø²Ù‡ Ø³Ø§Ø²ÛŒ ØµÙØ­Ù‡ Ø§ÙˆÙ„ÛŒÙ‡  ',0),(431823,11996,'pr','Ø¯ÙØ¹Ø§Øª ØªØ§Ø²Ù‡ Ø³Ø§Ø²ÛŒ ØµÙØ­Ù‡ Ø§ÙˆÙ„ÛŒÙ‡  ',0),(431824,11996,'tr','Ana sayfa yenileme kez',0),(431825,11996,'pl','OdÅ›wieÅ¼ stronÄ™ domowÄ… razy',0),(431826,11996,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¾Ð¿Ñ€ÐµÑÐ½ÑÐ²Ð°Ð½Ðµ Ð¿ÑŠÑ‚Ð¸',0),(431827,11996,'ur','Ù…Ø±Ú©Ø²ÛŒ ØµÙØ­Û ØªØ§Ø²Û Ú©Ø±ÛŒÚº Ù¹Ø§Ø¦Ù…Ø²',0),(431828,11996,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÐžÑÐ²ÐµÐ¶Ð¸ Ð¿ÑƒÑ‚Ð°',0),(431829,11996,'vi','thá»i gian lÃ m má»›i trang chá»§',0),(431830,11996,'af','Tuisblad Verfris tye',0),(431831,11996,'ro','Pagina de pornire reÃ®mprospÄƒtare ori',0),(431832,11996,'et','KodulehekÃ¼lg vÎ´rskendamise aega',0),(431833,11996,'si','DomaÄo stran OsveÅ¾i krat',0),(431834,11996,'ba','Homepage Refresh kali',0),(431835,11996,'nl','Homepage vernieuwen keer',0),(431836,11996,'fi','Kotisivu pÃ¤ivittÃ¤Ã¤ kertaa',0),(431837,11996,'no','Hjemmesiden Oppdater ganger',0),(431838,11996,'da','Hjemmeside Refresh gange',0),(431839,11996,'ko','í™ˆíŽ˜ì´ì§€ ìƒˆë¡œ ê³ ì¹¨ ì‹œê°„',0),(431840,11996,'he','×¨×¢× ×•×Ÿ ×“×£ ×”×‘×™×ª ×¤×¢×ž×™×',0),(431841,11996,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÏƒÎµÎ»Î¯Î´Î± Î±Î½Î±Î½Î­Ï‰ÏƒÎ·Ï‚ Ï†Î¿ÏÎ­Ï‚',0),(431842,11996,'zh','é¦–é¡µåˆ·æ–°\r\n',0),(431843,11996,'sv','Hemsida uppdatera gÃ¥nger',0),(431844,11996,'it','Aggiornamento homepage volte',0),(431845,11996,'tl','',0),(431846,11996,'th','à¹€à¸§à¸¥à¸²à¸£à¸µà¹€à¸Ÿà¸£à¸Šà¸«à¸™à¹‰à¸²à¹à¸£à¸',0),(431847,11996,'hi','à¤®à¥à¤–à¤ªà¥ƒà¤·à¥à¤  à¤¤à¤¾à¤œà¤¼à¤¾ à¤Ÿà¤¾à¤‡à¤®à¥à¤¸',0),(431848,11996,'ms','Refresh Laman Utama Times',0),(431849,11996,'ar','Ù…Ø±Ø§Øª ØªØ­Ø¯ÙŠØ« Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(431850,11996,'fr','Temps de rafraÃ®chissement de la page d\'accueil',0),(431851,11996,'jp','ãƒ›ãƒ¼ãƒ ãƒšãƒ¼ã‚¸æ›´æ–°æ™‚é–“',0),(431852,11996,'pt','AtualizaÃ§Ã£o de homepage vezes',0),(431853,11996,'ru','Ð“Ð»Ð°Ð²Ð½Ð°Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ñ€Ð°Ð·',0),(431854,11996,'es','PÃ¡gina Hogar Tiempos de Refrescar',0),(431855,11996,'de','Homepage Aktualisierungszeiten',0),(431856,11996,'en','Homepage Refresh Times',0),(431857,11997,'is','',0),(431858,11997,'dr','ÙˆØ¶Ø¹ÛŒØª ØªØ§Ù‡Ù„ Ù…Ø­Ù„ÛŒ',0),(431859,11997,'pr','ÙˆØ¶Ø¹ÛŒØª ØªØ§Ù‡Ù„ Ù…Ø­Ù„ÛŒ',0),(431860,11997,'tr','Yerel medeni durum',0),(431861,11997,'pl','Lokalny stan cywilny',0),(431862,11997,'bg','ÐœÐµÑÑ‚Ð½Ð¸ ÑÐµÐ¼ÐµÐ¹Ð½Ð¾ Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(431863,11997,'ur','Ù…Ù‚Ø§Ù…ÛŒ Ø§Ø²Ø¯ÙˆØ§Ø¬ÛŒ Ø­ÛŒØ«ÛŒØª',0),(431864,11997,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¸ Ð‘Ñ€Ð°Ñ‡Ð½Ð¾ ÑÑ‚Ð°ÑšÐµ',0),(431865,11997,'vi','tÃ¬nh tráº¡ng hÃ´n nhÃ¢n táº¡i Ä‘á»‹a phÆ°Æ¡ng',0),(431866,11997,'af','Plaaslike huwelikstatus',0),(431867,11997,'ro','Starea civila locale',0),(431868,11997,'et','Kohaliku Perekonnaseis',0),(431869,11997,'si','Lokalni zakonski stan',0),(431870,11997,'ba','Status perkawinan lokal',0),(431871,11997,'nl','Lokale huwelijkse',0),(431872,11997,'fi','Paikallinen siviilisÃ¤Ã¤ty',0),(431873,11997,'no','Lokale sivilstand',0),(431874,11997,'da','Lokalt Ã¦gteskabelig Status',0),(431875,11997,'ko','í˜„ì§€ í˜¼ ì¸ ìƒíƒœ',0),(431876,11997,'he','×ž×¦×‘ ×ž×©×¤×—×ª×™ ×ž×§×•×ž×™',0),(431877,11997,'el','Î¤Î¿Ï€Î¹ÎºÎ® Î¿Î¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(431878,11997,'zh','å½“åœ°å©šå§»çŠ¶å†µ\r\n',0),(431879,11997,'sv','Lokala civilstÃ¥nd',0),(431880,11997,'it','Stato civile locale',0),(431881,11997,'tl','',0),(431882,11997,'th','à¸ªà¸–à¸²à¸™à¸ à¸²à¸žà¸–à¸´à¹ˆà¸™',0),(431883,11997,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤µà¥ˆà¤µà¤¾à¤¹à¤¿à¤• à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(431884,11997,'ms','Status perkahwinan tempatan',0),(431885,11997,'ar','Ø§Ù„Ø­Ø§Ù„Ø© Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠØ© Ø§Ù„Ù…Ø­Ù„ÙŠØ©',0),(431886,11997,'fr','Ã‰tat civil local',0),(431887,11997,'jp','ãƒ­ãƒ¼ã‚«ãƒ«é…å¶',0),(431888,11997,'pt','Estado civil local',0),(431889,11997,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ðµ ÑÐµÐ¼ÐµÐ¹Ð½Ð¾Ðµ Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(431890,11997,'es','Estado Matrimonial Local',0),(431891,11997,'de','Lokale Familienstand',0),(431892,11997,'en','Local Marital Status',0),(431893,11998,'is','',0),(431894,11998,'dr','Ù…Ø§Ù„ÛŒØ§Øª Ø§Ø¶Ø§ÙÛŒ Ø¨Ø± ÙˆØ¶Ø¹ÛŒØª ØªØ§Ù‡Ù„ ',0),(431895,11998,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ø§Ø¶Ø§ÙÛŒ Ø¨Ø± ÙˆØ¶Ø¹ÛŒØª ØªØ§Ù‡Ù„ ',0),(431896,11998,'tr','Medeni durum ek vergi',0),(431897,11998,'pl','Dodatkowe zobowiÄ…zanie podatkowe w stan cywilny',0),(431898,11998,'bg','Ð¡ÐµÐ¼ÐµÐ¹Ð½Ð¾ Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº',0),(431899,11998,'ur','Ø§Ø²Ø¯ÙˆØ§Ø¬ÛŒ Ø­ÛŒØ«ÛŒØª Ø§Ø¶Ø§ÙÛŒ Ù¹ÛŒÚ©Ø³',0),(431900,11998,'sr','Ð‘Ñ€Ð°Ñ‡Ð½Ð¾ ÑÑ‚Ð°ÑšÐµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(431901,11998,'vi','thuáº¿ tÃ¬nh tráº¡ng hÃ´n nhÃ¢n ',0),(431902,11998,'af','HUWELIKSTATUS bykomende belasting',0),(431903,11998,'ro','Starea civilÄƒ taxe suplimentare',0),(431904,11998,'et','Perekonnaseis TÃ¤iendav maks',0),(431905,11998,'si','Zakonski stan dodaten davek',0),(431906,11998,'ba','Status perkawinan pajak tambahan',0),(431907,11998,'nl','Huwelijkse extra belasting',0),(431908,11998,'fi','SiviilisÃ¤Ã¤ty lisÃ¤vero',0),(431909,11998,'no','Sivilstand tilleggsavgift',0),(431910,11998,'da','Civilstand ekstra skat',0),(431911,11998,'ko','ê²°í˜¼ ì—¬ë¶€ ì¶”ê°€ ì„¸ê¸ˆ',0),(431912,11998,'he','×ž×¦×‘ ×ž×©×¤×—×ª×™ ×ž×¡ × ×•×¡×£',0),(431913,11998,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î¿Ï‚ Ï†ÏŒÏÎ¿Ï‚ Î¿Î¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(431914,11998,'zh','å©šå§»çŠ¶æ€çš„å…¶ä»–ç¨Ž\r\n',0),(431915,11998,'sv','CivilstÃ¥nd extra skatt',0),(431916,11998,'it','Tassa addizionale di stato civile',0),(431917,11998,'tl','',0),(431918,11998,'th','à¸ à¸²à¸©à¸µà¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸ªà¸–à¸²à¸™à¸ à¸²à¸ž',0),(431919,11998,'hi','à¤µà¥ˆà¤µà¤¾à¤¹à¤¿à¤• à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(431920,11998,'ms','Cukai tambahan Status perkahwinan',0),(431921,11998,'ar','Ø§Ù„Ø­Ø§Ù„Ø© Ø§Ù„Ø²ÙˆØ¬ÙŠØ© Ø¶Ø±ÙŠØ¨Ø© Ø¥Ø¶Ø§ÙÙŠØ©',0),(431922,11998,'fr','ImpÃ´t supplÃ©mentaire Ã  l\'Ã©tat civil',0),(431923,11998,'jp','å©šå§»çŠ¶æ³åŠ ç®—ç¨Ž',0),(431924,11998,'pt','Imposto adicional de estado civil',0),(431925,11998,'ru','Ð¡ÐµÐ¼ÐµÐ¹Ð½Ð¾Ðµ Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(431926,11998,'es','Impuesto Adicional por el Estado Matrimonial',0),(431927,11998,'de','Familienstand zusÃ¤tzliche Steuer',0),(431928,11998,'en','Marital Status Additional Tax',0),(431929,11999,'is','',0),(431930,11999,'dr','Ù…ØªØ§Ù‡Ù„',0),(431931,11999,'pr','Ù…ØªØ§Ù‡Ù„',0),(431932,11999,'tr','Evli',0),(431933,11999,'pl','Å»ona',0),(431934,11999,'bg','Ð–ÐµÐ½ÐµÐ½',0),(431935,11999,'ur','Ø´Ø§Ø¯ÛŒ Ø´Ø¯Û',0),(431936,11999,'sr','Ð£ Ð±Ñ€Ð°ÐºÑƒ',0),(431937,11999,'vi','Ä‘Ã£ káº¿t hÃ´n',0),(431938,11999,'af','Getroud',0),(431939,11999,'ro','CÄƒsÄƒtorit cu',0),(431940,11999,'et','Abielus',0),(431941,11999,'si','PoroÄen',0),(431942,11999,'ba','Menikah',0),(431943,11999,'nl','Gehuwd met',0),(431944,11999,'fi','Naimisissa',0),(431945,11999,'no','Gift',0),(431946,11999,'da','Gift',0),(431947,11999,'ko','ê²°í˜¼',0),(431948,11999,'he','× ×©×•×™',0),(431949,11999,'el','Î Î±Î½Ï„ÏÎµÎ¼Î­Î½Î¿Ï‚',0),(431950,11999,'zh','å·²å©š\r\n',0),(431951,11999,'sv','Gift',0),(431952,11999,'it','Sposato',0),(431953,11999,'tl','',0),(431954,11999,'th','à¹à¸•à¹ˆà¸‡à¸‡à¸²à¸™',0),(431955,11999,'hi','à¤¶à¤¾à¤¦à¥€ à¤•à¥€',0),(431956,11999,'ms','Berkahwin dengan',0),(431957,11999,'ar','Ù…ØªØ²ÙˆØ¬',0),(431958,11999,'fr','MariÃ©',0),(431959,11999,'jp','çµå©š',0),(431960,11999,'pt','Casou-se com',0),(431961,11999,'ru','Ð–ÐµÐ½Ð¸Ð»ÑÑ',0),(431962,11999,'es','Casado',0),(431963,11999,'de','Verheiratet',0),(431964,11999,'en','Married',0),(431965,12000,'is','',0),(431966,12000,'dr','Ù†ÙˆØ¹ Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(431967,12000,'pr','Ù†ÙˆØ¹ Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(431968,12000,'tr','Yeni kredi kartÄ± satÄ±n alma tÃ¼rÃ¼',0),(431969,12000,'pl','Nowy rodzaj zakupu karty kredytowej',0),(431970,12000,'bg','ÐÐ¾Ð²Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ñ‚Ð¸Ð¿ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(431971,12000,'ur','Ù†Ø¦Û’ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(431972,12000,'sr','ÐÐ¾Ð²Ð¸ Ñ‚Ð¸Ð¿ Ð½Ð°Ð±Ð°Ð²ÐºÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(431973,12000,'vi','Loáº¡i tháº» tÃ­n dá»¥ng mua hÃ ng má»›i',0),(431974,12000,'af','Nuwe Kredietkaart Aankope Tipe',0),(431975,12000,'ro','Noul tip de Card de Credit cumpÄƒrare',0),(431976,12000,'et','Uue krediitkaardi ostu tÃ¼Ã¼p',0),(431977,12000,'si','Nova vrsta nakup kreditne kartice',0),(431978,12000,'ba','Jenis pembelian kartu kredit baru',0),(431979,12000,'nl','Nieuwe Type van de aankoop van de creditcard',0),(431980,12000,'fi','Uusi luottokortti oston tyyppi',0),(431981,12000,'no','KjÃ¸p nye kredittkorttype',0),(431982,12000,'da','Nye kreditkort KÃ¸b Type',0),(431983,12000,'ko','ìƒˆë¡œìš´ ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ ìœ í˜•',0),(431984,12000,'he','×¡×•×’ ×—×“×© ×©×œ ×¨×›×™×©×” ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(431985,12000,'el','ÎÎ­Î¿Ï‚ Ï„ÏÏ€Î¿Ï‚ Î±Î³Î¿ÏÎ¬ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(431986,12000,'zh','æ–°çš„ä¿¡ç”¨å¡å•†å“ç±»åž‹\r\n',0),(431987,12000,'sv','Nya kÃ¶p kreditkortstyp',0),(431988,12000,'it','Nuovo tipo di acquisto di carta di credito',0),(431989,12000,'tl','',0),(431990,12000,'th','à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸‹à¸·à¹‰à¸­à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¹ƒà¸«à¸¡à¹ˆ',0),(431991,12000,'hi','à¤¨à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(431992,12000,'ms','Jenis pembelian kad kredit baru',0),(431993,12000,'ar','Ù†ÙˆØ¹ Ø¬Ø¯ÙŠØ¯ Ù…Ù† Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(431994,12000,'fr','Nouveau Type d\'achat de carte de crÃ©dit',0),(431995,12000,'jp','æ–°ã—ã„ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰è³¼å…¥ã®ç¨®é¡ž',0),(431996,12000,'pt','Novo tipo de compra de cartÃ£o de crÃ©dito',0),(431997,12000,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ‚Ð¸Ð¿ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(431998,12000,'es','Nuevo Tipo de Comprar de Tarjeta de CrÃ©dito',0),(431999,12000,'de','Neuartige Kreditkarte kaufen',0),(432000,12000,'en','New Credit Card Purchase Type',0),(432001,12001,'is','',0),(432002,12001,'dr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(432003,12001,'pr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(432004,12001,'tr','Yeni kredi kartÄ±',0),(432005,12001,'pl','Nowa karta kredytowa',0),(432006,12001,'bg','ÐÐ¾Ð²Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(432007,12001,'ur','Ù†Ø¦Û’ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ',0),(432008,12001,'sr','ÐÐ¾Ð²Ñƒ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(432009,12001,'vi','Tháº» tÃ­n dá»¥ng má»›i',0),(432010,12001,'af','Nuwe Kredietkaart',0),(432011,12001,'ro','Nou Card de Credit',0),(432012,12001,'et','Uue kaardi',0),(432013,12001,'si','Nove kreditne kartice',0),(432014,12001,'ba','Kartu kredit yang baru',0),(432015,12001,'nl','Nieuwe creditcard',0),(432016,12001,'fi','Uusi luottokortti',0),(432017,12001,'no','Nye kredittkort',0),(432018,12001,'da','Nyt kreditkort',0),(432019,12001,'ko','ìƒˆë¡œìš´ ì‹ ìš© ì¹´ë“œ',0),(432020,12001,'he','×›×¨×˜×™×¡ ××©×¨××™ ×—×“×©',0),(432021,12001,'el','ÎÎ­Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(432022,12001,'zh','æ–°çš„ä¿¡ç”¨å¡\r\n',0),(432023,12001,'sv','Nytt kreditkort',0),(432024,12001,'it','Nuova carta di credito',0),(432025,12001,'tl','',0),(432026,12001,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¹ƒà¸«à¸¡à¹ˆ',0),(432027,12001,'hi','à¤¨à¤¯à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡',0),(432028,12001,'ms','Baru kad kredit',0),(432029,12001,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù† Ø¬Ø¯ÙŠØ¯Ø©',0),(432030,12001,'fr','Nouvelle carte de crÃ©dit',0),(432031,12001,'jp','æ–°ã—ã„ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰',0),(432032,12001,'pt','Novo cartÃ£o de crÃ©dito',0),(432033,12001,'ru','ÐÐ¾Ð²Ð°Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ ÐºÐ°Ñ€Ñ‚Ð°',0),(432034,12001,'es','Nueva Tarjeta de CrÃ©dito',0),(432035,12001,'de','Neue Kreditkarte',0),(432036,12001,'en','New Credit Card',0),(432037,12002,'is','',0),(432038,12002,'dr','Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(432039,12002,'pr','Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(432040,12002,'tr','Yeni kredi kartÄ± satÄ±n',0),(432041,12002,'pl','Nowy zakup kartÄ… kredytowÄ…',0),(432042,12002,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(432043,12002,'ur','Ù†Ø¦Û’ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(432044,12002,'sr','ÐÐ¾Ð²Ñƒ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(432045,12002,'vi','tháº» tÃ­n dá»¥ng mua hÃ ng má»›i',0),(432046,12002,'af','Nuwe Kredietkaart Aankope',0),(432047,12002,'ro','Noul Card de Credit cumpÄƒrare',0),(432048,12002,'et','Uue krediitkaardi ostu',0),(432049,12002,'si','Nov nakup kreditni kartici',0),(432050,12002,'ba','Pembelian kartu kredit baru',0),(432051,12002,'nl','Nieuwe creditcard aankoop',0),(432052,12002,'fi','Uuden luottokortin hankinta',0),(432053,12002,'no','Nye kredittkort kjÃ¸p',0),(432054,12002,'da','Nye kreditkort kÃ¸b',0),(432055,12002,'ko','ìƒˆë¡œìš´ ì‹ ìš© ì¹´ë“œ êµ¬ìž…',0),(432056,12002,'he','×¨×›×™×©×ª ×›×¨×˜×™×¡ ××©×¨××™ ×—×“×©',0),(432057,12002,'el','ÎÎ­Î± Î±Î³Î¿ÏÎ¬ Î¼Î­ÏƒÏ‰ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(432058,12002,'zh','æ–°çš„ä¿¡ç”¨å¡é‡‡è´­\r\n',0),(432059,12002,'sv','Nya kreditkort kÃ¶p',0),(432060,12002,'it','Nuovo acquisto di carta di credito',0),(432061,12002,'tl','',0),(432062,12002,'th','à¸‹à¸·à¹‰à¸­à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¹ƒà¸«à¸¡à¹ˆ',0),(432063,12002,'hi','à¤¨à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦',0),(432064,12002,'ms','Baru kad kredit pembelian',0),(432065,12002,'ar','Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù† Ø¬Ø¯ÙŠØ¯Ø©',0),(432066,12002,'fr','Nouvel achat de carte de crÃ©dit',0),(432067,12002,'jp','æ–°ã—ã„ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã§è³¼å…¥',0),(432068,12002,'pt','Nova compra de cartÃ£o de crÃ©dito',0),(432069,12002,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÑƒ Ð½Ð¾Ð²Ñ‹Ñ… ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(432070,12002,'es','Nueva Compra de Tarjeta de CrÃ©dito',0),(432071,12002,'de','Neue Kreditkarte kaufen',0),(432072,12002,'en','New Credit Card Purchase',0),(432073,12003,'is','',0),(432074,12003,'dr','(Ù…Ø±Ø­Ù„Ù‡ )Ø§ØµÙ„Ø§Ø­ Ø¬Ø¯ÛŒØ¯',0),(432075,12003,'pr','Ø§Ø³ØªØ§Ù†Ù‡Ø§(Ù…Ø±Ø­Ù„Ù‡ )ÙˆÛŒØ±Ø§ÛŒØ´ Ø¬Ø¯ÛŒØ¯',0),(432076,12003,'tr','BirleÅŸik',0),(432077,12003,'pl','PaÅ„stwa',0),(432078,12003,'bg','Ð§Ð»ÐµÐ½ÐºÐ¸',0),(432079,12003,'ur','ÛØ§Ø¦Û’',0),(432080,12003,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð°',0),(432081,12003,'vi','nhÃ  nÆ°á»›c',0),(432082,12003,'af','State',0),(432083,12003,'ro','Statele',0),(432084,12003,'et','Riikide',0),(432085,12003,'si','DrÅ¾ave',0),(432086,12003,'ba','Serikat',0),(432087,12003,'nl','Staten',0),(432088,12003,'fi','Valtioiden',0),(432089,12003,'no','Stater',0),(432090,12003,'da','Stater',0),(432091,12003,'ko','ìƒíƒœ',0),(432092,12003,'he','×”×‘×¨×™×ª',0),(432093,12003,'el','ÎœÎ­Î»Î·',0),(432094,12003,'zh','æ–°å»º/ç¼–è¾‘çŠ¶æ€\r\n',0),(432095,12003,'sv','Staterna',0),(432096,12003,'it','Stati',0),(432097,12003,'tl','',0),(432098,12003,'th','à¸­à¹€à¸¡à¸£à¸´à¸à¸²',0),(432099,12003,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾',0),(432100,12003,'ms','Negeri-Negeri',0),(432101,12003,'ar','Ø§Ù„Ø¯ÙˆÙ„',0),(432102,12003,'fr','Ã‰tats',0),(432103,12003,'jp','çŠ¶æ…‹',0),(432104,12003,'pt','Estados-Membros',0),(432105,12003,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð°',0),(432106,12003,'es','Estados',0),(432107,12003,'de','Staaten',0),(432108,12003,'en','States',0),(432109,12004,'is','',0),(432110,12004,'dr','/ Ø¢Ù¾Ø¯ÛŒØª ÙˆÙ„Ø§ÛŒØª Ù‡Ø§- Ù…Ù†Ø§Ø·Ù‚ Ù…Ø­Ù„ÛŒ',0),(432111,12004,'pr','Ø§ÙØ²ÙˆØ¯Ù†/ Ø¢Ù¾Ø¯ÛŒØª Ø§Ø³ØªØ§Ù†Ù‡Ø§- Ù…Ù†Ø§Ø·Ù‚ Ù…Ø­Ù„ÛŒ',0),(432112,12004,'tr','Ekleme/GÃ¼ncelleme BirleÅŸik, iller, yerel alanlar',0),(432113,12004,'pl','Dodaj/Aktualizuj PaÅ„stwa, prowincji, lokalnych obszarÃ³w',0),(432114,12004,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ, Ñ‰Ð°Ñ‚Ð¸, Ð¿Ñ€Ð¾Ð²Ð¸Ð½Ñ†Ð¸Ð¸, Ð¼ÐµÑÑ‚Ð½Ð¸ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(432115,12004,'ur','Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº Ø§Ù…Ø±ÛŒÚ©ÛØŒ ØµÙˆØ¨ÙˆÚºØŒ Ù…Ù‚Ø§Ù…ÛŒ Ø¹Ù„Ø§Ù‚Û Ø¬Ø§Øª',0),(432116,12004,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ñ€Ð¶Ð°Ð²Ðµ, Ð¿Ñ€Ð¾Ð²Ð¸Ð½Ñ†Ð¸Ñ˜Ðµ, Ð»Ð¾ÐºÐ°Ð»Ð½Ðµ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(432117,12004,'vi','thÃªm/ cáº­p nháº­t nÆ°á»›c , tá»‰nh, huyá»‡n vÃ¹ng',0),(432118,12004,'af','Voeg/Update state, provinsies, plaaslike gebiede',0),(432119,12004,'ro','AdÄƒugaÅ£i/actualizaÅ£i Statele, provincii, zonele locale',0),(432120,12004,'et','Lisa/vÃ¤rskenda riikides, provintsid, kohalikke',0),(432121,12004,'si','Dodaj/posodobi drÅ¾ave, pokrajin, obÄin',0),(432122,12004,'ba','Tambahkan/Perbarui Serikat, propinsi, daerah',0),(432123,12004,'nl','Staten, provincies, lokale gebieden toevoegen/bijwerken',0),(432124,12004,'fi','LisÃ¤Ã¤/pÃ¤ivitÃ¤ valtioiden, maakuntien, paikallisten alueiden',0),(432125,12004,'no','Legg til/Oppdater stater, provinser, lokale omrÃ¥der',0),(432126,12004,'da','TilfÃ¸j/opdater stater, provinser, lokale omrÃ¥der',0),(432127,12004,'ko','ì¶”ê°€/ì—…ë°ì´íŠ¸ ìƒíƒœ, ì§€ë°©, ì§€ì—­',0),(432128,12004,'he','×”×•×¡×£/×¢×“×›×Ÿ ×ž×“×™× ×•×ª, ×ž×—×•×–×•×ª, ××–×•×¨×™× ×ž×§×•×ž×™×™×',0),(432129,12004,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼ÎµÎ»ÏŽÎ½, ÎµÏ€Î±ÏÏ‡Î¯ÎµÏ‚, Ï„Î¿Ï€Î¹ÎºÎ­Ï‚ Ï€ÎµÏÎ¹Î¿Ï‡Î­Ï‚',0),(432130,12004,'zh','å¢žåŠ /æ›´æ–°å·žï¼Œçœï¼Œåœ°åŒº\r\n',0),(432131,12004,'sv','LÃ¤gg till/uppdatera staterna, provinser, lokala omrÃ¥den',0),(432132,12004,'it','Aggiungere o aggiornare gli Stati, province, aree locali',0),(432133,12004,'tl','',0),(432134,12004,'th','à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸–à¸²à¸™à¸° à¸ˆà¸±à¸‡à¸«à¸§à¸±à¸” à¸—à¹‰à¸­à¸‡à¸–à¸´à¹ˆà¸™',0),(432135,12004,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤°à¤¾à¤œà¥à¤¯à¥‹à¤‚, à¤ªà¥à¤°à¤¾à¤‚à¤¤à¥‹à¤‚, à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤•à¥à¤·à¥‡à¤¤à¥à¤°à¥‹à¤‚',0),(432136,12004,'ms','Tambah/Kemaskini Negeri, Wilayah, kawasan-kawasan tempatan',0),(432137,12004,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¯ÙˆÙ„ ÙˆØ§Ù„Ù…Ù‚Ø§Ø·Ø¹Ø§Øª ÙˆØ§Ù„Ù…Ù†Ø§Ø·Ù‚ Ø§Ù„Ù…Ø­Ù„ÙŠØ©',0),(432138,12004,'fr','Ajouter/mettre Ã  jour les Ã‰tats, les Provinces, les zones locales',0),(432139,12004,'jp','å·žã€åœ°æ–¹ã€ãƒ­ãƒ¼ã‚«ãƒ« ã‚¨ãƒªã‚¢ã‚’è¿½åŠ /æ›´æ–°',0),(432140,12004,'pt','Adicionar/atualizar Estados, provÃ­ncias, Ã¡reas locais',0),(432141,12004,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¨Ñ‚Ð°Ñ‚Ð¾Ð², Ð¿Ñ€Ð¾Ð²Ð¸Ð½Ñ†Ð¸Ð¹, Ð¼ÐµÑÑ‚Ð½Ñ‹Ñ… Ñ€Ð°Ð¹Ð¾Ð½Ð¾Ð²',0),(432142,12004,'es','Agregar/Actualizar Estados, Provincias, Ãreas Locales',0),(432143,12004,'de','HinzufÃ¼gen/Aktualisieren Sie Staaten, Provinzen, Regionen',0),(432144,12004,'en','Add/Update States, Provinces, Local Areas',0),(432145,12005,'is','',0),(432146,12005,'dr','Ú¯Ø±ÙˆÙ‡ Ù¾ÛŒØºØ§Ù… Ø¬Ø¯ÛŒØ¯',0),(432147,12005,'pr','Ú¯Ø±ÙˆÙ‡ Ù¾ÛŒØºØ§Ù… Ø¬Ø¯ÛŒØ¯',0),(432148,12005,'tr','Yeni ileti kategorisi',0),(432149,12005,'pl','Nowa kategoria wiadomoÅ›ci',0),(432150,12005,'bg','ÐÐ¾Ð²Ð¾ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(432151,12005,'ur','Ù†Ø¦Û’ Ù¾ÛŒØºØ§Ù… Ú©ÛŒ Ø²Ù…Ø±Û',0),(432152,12005,'sr','ÐÐ¾Ð²Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(432153,12005,'vi','danh má»¥c tin nháº¯n má»›i',0),(432154,12005,'af','Nuwe boodskap kategorie',0),(432155,12005,'ro','Noua categorie mesaj',0),(432156,12005,'et','Uue sÃµnumi kategooria',0),(432157,12005,'si','Novo sporoÄilo kategorijo',0),(432158,12005,'ba','Kategori pesan baru',0),(432159,12005,'nl','Nieuwe categorie van het bericht',0),(432160,12005,'fi','Uuden viestin luokan',0),(432161,12005,'no','Ny meldingskategori',0),(432162,12005,'da','Ny besked kategori',0),(432163,12005,'ko','ìƒˆ ë©”ì‹œì§€ ë²”ì£¼',0),(432164,12005,'he','×§×˜×’×•×¨×™×” ×”×•×“×¢×” ×—×“×©×”',0),(432165,12005,'el','ÎÎ­Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î¼Î®Î½Ï…Î¼Î±',0),(432166,12005,'zh','æœ€æ–°æ¶ˆæ¯ç±»åˆ«\r\n',0),(432167,12005,'sv','Ny meddelandekategori',0),(432168,12005,'it','Nuova categoria di messaggio',0),(432169,12005,'tl','',0),(432170,12005,'th','à¸›à¸£à¸°à¹€à¸ à¸—à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¹ƒà¸«à¸¡à¹ˆ',0),(432171,12005,'hi','à¤¨à¤ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(432172,12005,'ms','Kategori mesej baru',0),(432173,12005,'ar','ÙØ¦Ø© Ø±Ø³Ø§Ù„Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(432174,12005,'fr','Nouvelle catÃ©gorie de Message',0),(432175,12005,'jp','æ–°ã—ã„ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®ã‚«ãƒ†ã‚´ãƒª',0),(432176,12005,'pt','Nova categoria de mensagem',0),(432177,12005,'ru','ÐÐ¾Ð²Ð°Ñ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹',0),(432178,12005,'es','Nueva CategorÃ­a de Mensaje',0),(432179,12005,'de','Neue Nachrichtenkategorie',0),(432180,12005,'en','New Message Category',0),(432181,12006,'is','',0),(432182,12006,'dr','Ú¯Ø±Ø§ÙÛŒÚ© Ù¾ÛŒØºØ§Ù… Ø¬Ø¯ÛŒØ¯',0),(432183,12006,'pr','Ú¯Ø±Ø§ÙÛŒÚ© Ù¾ÛŒØºØ§Ù… Ø¬Ø¯ÛŒØ¯',0),(432184,12006,'tr','Yeni ileti grafiÄŸi',0),(432185,12006,'pl','Nowe wiadomoÅ›ci graficzne',0),(432186,12006,'bg','ÐÐ¾Ð²Ð¾ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð³Ñ€Ð°Ñ„Ð¸ÐºÐ°',0),(432187,12006,'ur','Ù†ÛŒØ§ Ù¾ÛŒØºØ§Ù… Ú¯Ø±Ø§ÙÛŒ',0),(432188,12006,'sr','ÐÐ¾Ð²Ð° Ð¿Ð¾Ñ€ÑƒÐºÐ° Ð³Ñ€Ð°Ñ„Ð¸ÐºÐµ',0),(432189,12006,'vi','Ä‘á»“ thá»‹ tin nháº¯n má»›i',0),(432190,12006,'af','Nuwe boodskap grafiese',0),(432191,12006,'ro','Grafic de mesaj nou',0),(432192,12006,'et','Uue sÃµnumi pilt',0),(432193,12006,'si','Novo sporoÄilo grafiko',0),(432194,12006,'ba','Grafis pesan baru',0),(432195,12006,'nl','Nieuwe bericht afbeelding',0),(432196,12006,'fi','Uusi viesti graafinen',0),(432197,12006,'no','Ny melding-grafisk',0),(432198,12006,'da','Ny besked grafisk',0),(432199,12006,'ko','ìƒˆ ë©”ì‹œì§€ ê·¸ëž˜í”½',0),(432200,12006,'he','×’×¨×¤×™×§×ª ×”×•×“×¢×” ×—×“×©×”',0),(432201,12006,'el','ÎÎ­Î¿ Î¼Î®Î½Ï…Î¼Î± Î³ÏÎ±Ï†Î¹ÎºÏŒ',0),(432202,12006,'zh','æ–°é‚®ä»¶å›¾å½¢\r\n',0),(432203,12006,'sv','Ny meddelande grafisk',0),(432204,12006,'it','Nuovo messaggio grafico',0),(432205,12006,'tl','',0),(432206,12006,'th','à¸£à¸¹à¸›à¸ à¸²à¸žà¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¹ƒà¸«à¸¡à¹ˆ',0),(432207,12006,'hi','à¤¨à¤¯à¤¾ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤—à¥à¤°à¤¾à¤«à¤¿à¤•',0),(432208,12006,'ms','Baru mesej grafik',0),(432209,12006,'ar','Ø§Ù„Ø±Ø³Ù… Ø±Ø³Ø§Ù„Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(432210,12006,'fr','Nouveau Message graphique',0),(432211,12006,'jp','æ–°ã—ã„ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯',0),(432212,12006,'pt','Novo grÃ¡fico de mensagem',0),(432213,12006,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð³Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(432214,12006,'es','Nueva Mensaje GrÃ¡fica ',0),(432215,12006,'de','Neue Nachricht-Grafik',0),(432216,12006,'en','New Message Graphic',0),(432217,12007,'is','',0),(432218,12007,'dr','Ú¯Ø±ÙˆÙ‡ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ø¬Ø¯ÛŒØ¯',0),(432219,12007,'pr','Ú¯Ø±ÙˆÙ‡ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ø¬Ø¯ÛŒØ¯',0),(432220,12007,'tr','Yeni Not Kategori',0),(432221,12007,'pl','Nowa kategoria Uwaga',0),(432222,12007,'bg','ÐÐ¾Ð²Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(432223,12007,'ur','Ù†ÙˆÙ¹ Ú©Û’ Ù†ÛŒØ§ Ø²Ù…Ø±Û',0),(432224,12007,'sr','ÐÐ¾Ð²Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(432225,12007,'vi','danh má»¥c ghi chÃº má»›i',0),(432226,12007,'af','Nuwe Nota kategorie',0),(432227,12007,'ro','Categorie nouÄƒ notÄƒ',0),(432228,12007,'et','Uus mÃ¤rkus kategooria',0),(432229,12007,'si','Nova Opomba Kategorija',0),(432230,12007,'ba','Kategori catatan baru',0),(432231,12007,'nl','Nieuwe opmerking categorie',0),(432232,12007,'fi','Uusi Huomautus luokka',0),(432233,12007,'no','Ny merknad-kategori',0),(432234,12007,'da','Ny Note kategori',0),(432235,12007,'ko','ìƒˆë¡œìš´ ì°¸ê³  ì¹´í…Œê³ ë¦¬',0),(432236,12007,'he','×§×˜×’×•×¨×™×” ×”×¢×¨×” ×—×“×©×”',0),(432237,12007,'el','ÎÎ­Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(432238,12007,'zh','æ–°æ³¨ç±»åˆ«\r\n',0),(432239,12007,'sv','Nya Obs kategorin',0),(432240,12007,'it','Nuova categoria nota',0),(432241,12007,'tl','',0),(432242,12007,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸›à¸£à¸°à¹€à¸ à¸—à¹ƒà¸«à¸¡à¹ˆ',0),(432243,12007,'hi','à¤¨à¤¯à¤¾ à¤¨à¥‹à¤Ÿ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(432244,12007,'ms','Kategori nota baru',0),(432245,12007,'ar','ÙØ¦Ø© Ù…Ù„Ø§Ø­Ø¸Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(432246,12007,'fr','Nouvelle catÃ©gorie de Note',0),(432247,12007,'jp','æ–°ã—ã„ãƒ¡ãƒ¢ã®ã‚«ãƒ†ã‚´ãƒª',0),(432248,12007,'pt','Nova categoria de nota',0),(432249,12007,'ru','ÐÐ¾Ð²Ð°Ñ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(432250,12007,'es','Nueva CategorÃ­a de Notas',0),(432251,12007,'de','Neue Note-Kategorie',0),(432252,12007,'en','New Note Category',0),(432253,12008,'is','',0),(432254,12008,'dr','Ø§Ø³ØªØ§Ù† Ø¬Ø¯ÛŒØ¯',0),(432255,12008,'pr','Ø§Ø³ØªØ§Ù† Ø¬Ø¯ÛŒØ¯',0),(432256,12008,'tr','Yeni devlet',0),(432257,12008,'pl','Nowe PaÅ„stwo',0),(432258,12008,'bg','ÐÐ¾Ð²Ð°Ñ‚Ð° Ð´ÑŠÑ€Ð¶Ð°Ð²Ð°',0),(432259,12008,'ur','Ù†Ø¦ÛŒ Ø±ÛŒØ§Ø³Øª',0),(432260,12008,'sr','ÐÐ¾Ð²Ðµ Ð´Ñ€Ð¶Ð°Ð²Ðµ',0),(432261,12008,'vi','tráº¡ng thÃ¡i má»›i',0),(432262,12008,'af','Nuwe staat',0),(432263,12008,'ro','Noul stat',0),(432264,12008,'et','Uus riik',0),(432265,12008,'si','Nova drÅ¾ava',0),(432266,12008,'ba','Negara baru',0),(432267,12008,'nl','Nieuwe staat',0),(432268,12008,'fi','Uusi valtio',0),(432269,12008,'no','Ny tilstand',0),(432270,12008,'da','Ny stat',0),(432271,12008,'ko','ìƒˆë¡œìš´ ìƒíƒœ',0),(432272,12008,'he','×”×ž×“×™× ×” ×”×—×“×©×”',0),(432273,12008,'el','ÎÎ­Î¿ Î¼Î­Î»Î¿Ï‚',0),(432274,12008,'zh','æ–°çŠ¶æ€\r\n',0),(432275,12008,'sv','Ny stat',0),(432276,12008,'it','Nuovo stato',0),(432277,12008,'tl','',0),(432278,12008,'th','à¸ªà¸–à¸²à¸™à¸°à¹ƒà¸«à¸¡à¹ˆ',0),(432279,12008,'hi','à¤¨à¤ à¤°à¤¾à¤œà¥à¤¯',0),(432280,12008,'ms','Negeri yang baru',0),(432281,12008,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(432282,12008,'fr','Nouvel Ã‰tat',0),(432283,12008,'jp','æ–°ã—ã„çŠ¶æ…‹',0),(432284,12008,'pt','Estado novo',0),(432285,12008,'ru','ÐÐ¾Ð²Ð¾Ðµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(432286,12008,'es','Nuevo Estado',0),(432287,12008,'de','Neuzustand',0),(432288,12008,'en','New State',0),(432289,12009,'is','',0),(432290,12009,'dr','Ú©Ø§Ø±Ø¨Ø± Ø¬Ø¯ÛŒØ¯',0),(432291,12009,'pr','Ú©Ø§Ø±Ø¨Ø± Ø¬Ø¯ÛŒØ¯',0),(432292,12009,'tr','Yeni kullanÄ±cÄ±',0),(432293,12009,'pl','Nowy uÅ¼ytkownik',0),(432294,12009,'bg','ÐÐ¾Ð² Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(432295,12009,'ur','Ù†ÛŒØ§ ØµØ§Ø±Ù',0),(432296,12009,'sr','ÐÐ¾Ð²Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº',0),(432297,12009,'vi','ngÆ°á»i sá»­ dá»¥ng má»›i',0),(432298,12009,'af','Nuwe gebruiker',0),(432299,12009,'ro','Utilizator nou',0),(432300,12009,'et','Uus kasutaja',0),(432301,12009,'si','Novega uporabnika',0),(432302,12009,'ba','Pengguna baru',0),(432303,12009,'nl','Nieuwe gebruiker',0),(432304,12009,'fi','Uusi kÃ¤yttÃ¤jÃ¤',0),(432305,12009,'no','Ny bruker',0),(432306,12009,'da','Ny bruger',0),(432307,12009,'ko','ìƒˆ ì‚¬ìš©ìž',0),(432308,12009,'he','×ž×©×ª×ž×© ×—×“×©',0),(432309,12009,'el','ÎÎ­Î¿Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚',0),(432310,12009,'zh','æ–°ç”¨æˆ·\r\n',0),(432311,12009,'sv','Ny anvÃ¤ndare',0),(432312,12009,'it','Nuovo utente',0),(432313,12009,'tl','',0),(432314,12009,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹ƒà¸«à¸¡à¹ˆ',0),(432315,12009,'hi','à¤¨à¤¯à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(432316,12009,'ms','Pengguna baru',0),(432317,12009,'ar','Ù…Ø³ØªØ®Ø¯Ù… Ø¬Ø¯ÙŠØ¯',0),(432318,12009,'fr','Nouvel utilisateur',0),(432319,12009,'jp','æ–°ã—ã„ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(432320,12009,'pt','Novo usuÃ¡rio',0),(432321,12009,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ',0),(432322,12009,'es','Nuevo Usuario',0),(432323,12009,'de','Neuer Benutzer',0),(432324,12009,'en','New User',0),(432325,12010,'is','',0),(432326,12010,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø®Ø±ÛŒØ¯',0),(432327,12010,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø®Ø±ÛŒØ¯',0),(432328,12010,'tr','SatÄ±nalma toplam',0),(432329,12010,'pl','Zakupu Å‚Ä…cznie',0),(432330,12010,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ¸ Ð¾Ð±Ñ‰Ð¾',0),(432331,12010,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ú©Ù„',0),(432332,12010,'sr','Ð£ÐºÑƒÐ¿Ð½Ðµ Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(432333,12010,'vi','tá»•ng mua',0),(432334,12010,'af','Aankoop totaal',0),(432335,12010,'ro','CumpÄƒrare Total',0),(432336,12010,'et','Ostud kokku',0),(432337,12010,'si','Nakup skupno',0),(432338,12010,'ba','Total pembelian',0),(432339,12010,'nl','Aankoop totaal',0),(432340,12010,'fi','Hankinta yhteensÃ¤',0),(432341,12010,'no','KjÃ¸p totalt',0),(432342,12010,'da','KÃ¸b alt',0),(432343,12010,'ko','êµ¬ë§¤ ì´',0),(432344,12010,'he','×¡×š ×”×ª×ž×•×¨×”',0),(432345,12010,'el','Î‘Î³Î¿ÏÎ¬ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(432346,12010,'zh','è´­ä¹°æ€»é¢\r\n',0),(432347,12010,'sv','KÃ¶p totalt',0),(432348,12010,'it','Acquisto totale',0),(432349,12010,'tl','',0),(432350,12010,'th','à¸‹à¸·à¹‰à¸­à¸£à¸§à¸¡',0),(432351,12010,'hi','à¤•à¥à¤² à¤–à¤°à¥€à¤¦',0),(432352,12010,'ms','Jumlah keseluruhan pembelian',0),(432353,12010,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(432354,12010,'fr','Total de l\'achat',0),(432355,12010,'jp','è³¼å…¥åˆè¨ˆ',0),(432356,12010,'pt','Total da compra',0),(432357,12010,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð²ÑÐµÐ³Ð¾',0),(432358,12010,'es','Compra Total',0),(432359,12010,'de','Bestellwert',0),(432360,12010,'en','Purchase Total',0),(432361,12011,'is','',0),(432362,12011,'dr','Ø·ÙˆÙ„ Ø¨Ø§Ø±Ú¯Ø²Ø§Ø±ÛŒ',0),(432363,12011,'pr','Ø·ÙˆÙ„ Ø¨Ø§Ø±Ú¯Ø²Ø§Ø±ÛŒ',0),(432364,12011,'tr','Uzunluk Yenile',0),(432365,12011,'pl','OdÅ›wieÅ¼ dÅ‚ugoÅ›ci',0),(432366,12011,'bg','ÐžÐ±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´ÑŠÐ»Ð¶Ð¸Ð½Ð°',0),(432367,12011,'ur','Ú©ÛŒ Ù„Ù…Ø¨Ø§Ø¦ÛŒ Ú©Ùˆ ØªØ§Ø²Û Ú©Ø±ÛŒÚº',0),(432368,12011,'sr','ÐžÑÐ²ÐµÐ¶Ð¸Ñ‚Ðµ Ð´ÑƒÐ¶Ð¸Ð½Ð°',0),(432369,12011,'vi','refresh Ä‘á»™ dÃ i',0),(432370,12011,'af','Verfris lengte',0),(432371,12011,'ro','ReÃ®mprospÄƒtare lungime',0),(432372,12011,'et','VÃ¤rskenda pikkus',0),(432373,12011,'si','OsveÅ¾i dolÅ¾ina',0),(432374,12011,'ba','Me-refresh panjang',0),(432375,12011,'nl','Lengte vernieuwen',0),(432376,12011,'fi','PÃ¤ivitÃ¤ pituus',0),(432377,12011,'no','Oppdatere lengde',0),(432378,12011,'da','Opdater lÃ¦ngde',0),(432379,12011,'ko','ê¸¸ì´ ìƒˆë¡œ ê³ ì¹¨',0),(432380,12011,'he','×¨×¢× ×•×Ÿ ××•×¨×š',0),(432381,12011,'el','Î‘Î½Î±Î½ÎµÏŽÏƒÎµÏ„Îµ Ï„Î¿ Î¼Î®ÎºÎ¿Ï‚',0),(432382,12011,'zh','åˆ·æ–°é•¿åº¦\r\n',0),(432383,12011,'sv','Uppdatera lÃ¤ngd',0),(432384,12011,'it','Aggiornare la lunghezza',0),(432385,12011,'tl','',0),(432386,12011,'th','à¸Ÿà¸·à¹‰à¸™à¸Ÿà¸¹à¸„à¸§à¸²à¸¡à¸¢à¸²à¸§',0),(432387,12011,'hi','à¤²à¤‚à¤¬à¤¾à¤ˆ à¤•à¥‹ à¤¤à¤¾à¤œà¤¼à¤¾ à¤•à¤°à¥‡à¤‚',0),(432388,12011,'ms','Refresh panjang',0),(432389,12011,'ar','ØªØ­Ø¯ÙŠØ« Ø¹Ù„Ù‰ Ø·ÙˆÙ„',0),(432390,12011,'fr','Actualiser la longueur',0),(432391,12011,'jp','é•·ã•ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(432392,12011,'pt','Atualizar o comprimento',0),(432393,12011,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð´Ð»Ð¸Ð½Ð°',0),(432394,12011,'es','Largo de Refrescar',0),(432395,12011,'de','LÃ¤nge zu aktualisieren',0),(432396,12011,'en','Refresh Length',0),(432397,12012,'is','',0),(432398,12012,'dr',' Ø¯ÙØ¹Ø§Øª Ø¨Ø§Ø±Ú¯Ø°Ø§Ø±ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø´Ø¯',0),(432399,12012,'pr',' Ø¯ÙØ¹Ø§Øª Ø¨Ø§Ø±Ú¯Ø°Ø§Ø±ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø´Ø¯',0),(432400,12012,'tr','BaÅŸarÄ±yla gÃ¼ncelleÅŸtirildi kere yenileyin',0),(432401,12012,'pl','OdÅ›wieÅ¼ razy pomyÅ›lnie zaktualizowana',0),(432402,12012,'bg','ÐžÐ±Ð½Ð¾Ð²Ð¸ Ð¿ÑŠÑ‚Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(432403,12012,'ur','Ù…Ø±ØªØ¨Û Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(432404,12012,'sr','ÐžÑÐ²ÐµÐ¶Ð¸Ñ‚Ðµ Ð¿ÑƒÑ‚Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(432405,12012,'vi','cáº­p nháº­t refresh thá»i gian thÃ nh cÃ´ng',0),(432406,12012,'af','Verfris keer suksesvol bygewerk',0),(432407,12012,'ro','ReÃ®mprospÄƒtare ori actualizat cu succes',0),(432408,12012,'et','VÃ¤rskendama vÃ¤rskendatud korda',0),(432409,12012,'si','OsveÅ¾i krat uspeÅ¡no posodobljena',0),(432410,12012,'ba','Me-refresh kali berhasil',0),(432411,12012,'nl','Vernieuwen keer bijgewerkt',0),(432412,12012,'fi','PÃ¤ivitÃ¤ kerran pÃ¤ivitetty',0),(432413,12012,'no','Oppdatere ganger oppdatert',0),(432414,12012,'da','Opdater gange opdateret',0),(432415,12012,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì‹œê°„ì„ ìƒˆë¡œ ê³ ì¹¨',0),(432416,12012,'he','×¨×¢× ×•×Ÿ ×¤×¢×ž×™× ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(432417,12012,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ· Ï†Î¿ÏÎ­Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(432418,12012,'zh','åˆ·æ–°æ—¶é—´æ›´æ–°æˆåŠŸ\r\n',0),(432419,12012,'sv','Uppdatera gÃ¥nger uppdaterats',0),(432420,12012,'it','Aggiorna volte aggiornati con successo',0),(432421,12012,'tl','',0),(432422,12012,'th','à¸Ÿà¸·à¹‰à¸™à¸Ÿà¸¹à¸„à¸£à¸±à¹‰à¸‡à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(432423,12012,'hi','à¤¬à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥‹ à¤¤à¤¾à¤œà¤¼à¤¾ à¤•à¤°à¥‡à¤‚',0),(432424,12012,'ms','Refresh Times berjaya dikemas kini',0),(432425,12012,'ar','Ù‚Ù… Ø¨ØªØ­Ø¯ÙŠØ« Ø£ÙˆÙ‚Ø§Øª ØªØ­Ø¯ÙŠØ«Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(432426,12012,'fr','RÃ©gÃ©nÃ©rez fois mis Ã  jour avec succÃ¨s',0),(432427,12012,'jp','æ›´æ–°ãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸæ™‚é–“',0),(432428,12012,'pt','Atualizar vezes atualizados com sucesso',0),(432429,12012,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ñ€Ð°Ð· ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(432430,12012,'es','Tiempos de Refrescar Actualizados Exitosamente',0),(432431,12012,'de','Aktualisieren Sie mal erfolgreich aktualisiert',0),(432432,12012,'en','Refresh Times Updated Successfully',0),(432433,12013,'is','',0),(432434,12013,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ´',0),(432435,12013,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ´',0),(432436,12013,'tr','SatÄ±ÅŸ toplam',0),(432437,12013,'pl','SprzedaÅ¼y ogÃ³Å‚em',0),(432438,12013,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(432439,12013,'ur','Ø³ÛŒÙ„Ø² Ú©Ù„',0),(432440,12013,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(432441,12013,'vi','Tá»•ng doanh sá»‘',0),(432442,12013,'af','Totale verkope',0),(432443,12013,'ro','Total vÃ¢nzÄƒri',0),(432444,12013,'et','MÃ¼Ã¼k kokku',0),(432445,12013,'si','Skupna prodaja',0),(432446,12013,'ba','Total penjualan',0),(432447,12013,'nl','Verkoop totaal',0),(432448,12013,'fi','Myynti yhteensÃ¤',0),(432449,12013,'no','Salgssum',0),(432450,12013,'da','Salg Total',0),(432451,12013,'ko','íŒë§¤ ì´',0),(432452,12013,'he','×¡×š ×ž×›×™×¨×•×ª',0),(432453,12013,'el','Î£ÏÎ½Î¿Î»Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(432454,12013,'zh','é”€å”®æ€»é¢\r\n',0),(432455,12013,'sv','FÃ¶rsÃ¤ljning totalt',0),(432456,12013,'it','Totale vendite',0),(432457,12013,'tl','',0),(432458,12013,'th','à¸£à¸§à¸¡à¸‚à¸²à¸¢',0),(432459,12013,'hi','à¤•à¥à¤² à¤¬à¤¿à¤•à¥à¤°à¥€',0),(432460,12013,'ms','Jumlah jualan',0),(432461,12013,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(432462,12013,'fr','Total vente',0),(432463,12013,'jp','å£²ä¸Šåˆè¨ˆ',0),(432464,12013,'pt','Total de vendas',0),(432465,12013,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(432466,12013,'es','Ventas Totales',0),(432467,12013,'de','Umsatz gesamt',0),(432468,12013,'en','Sales Total',0),(432469,12014,'is','',0),(432470,12014,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡',0),(432471,12014,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡',0),(432472,12014,'tr','Toplam sattÄ±',0),(432473,12014,'pl','Sprzedane w Å‚Ä…cznej',0),(432474,12014,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(432475,12014,'ur','Ú©Ù„ ÙØ±ÙˆØ®Øª',0),(432476,12014,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ñ˜Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¾.',0),(432477,12014,'vi','Tá»•ng sá»‘ Ä‘Ã£ bÃ¡n',0),(432478,12014,'af','Verkoop totaal',0),(432479,12014,'ro','VÃ¢ndut totalÄƒ',0),(432480,12014,'et','MÃ¼Ã¼dud kokku',0),(432481,12014,'si','Prodaja celotnega',0),(432482,12014,'ba','Dijual Total',0),(432483,12014,'nl','Totaal verkocht',0),(432484,12014,'fi','MyydÃ¤Ã¤n yhteensÃ¤',0),(432485,12014,'no','Solgt totalt',0),(432486,12014,'da','SÃ¦lges samlet',0),(432487,12014,'ko','ì´ íŒë§¤',0),(432488,12014,'he','× ×ž×›×¨ ×¡×”',0),(432489,12014,'el','Î Ï‰Î»Î¿ÏÎ½Ï„Î±Î¹ ÏƒÏ…Î½Î¿Î»Î¹ÎºÏŒ',0),(432490,12014,'zh','å·²å”®æ€»\r\n',0),(432491,12014,'sv','SÃ¥lde totalt',0),(432492,12014,'it','Venduto totale',0),(432493,12014,'tl','',0),(432494,12014,'th','à¸‚à¸²à¸¢à¸£à¸§à¸¡',0),(432495,12014,'hi','à¤•à¥à¤² à¤¬à¥‡à¤š à¤¦à¤¿à¤¯à¤¾',0),(432496,12014,'ms','Dijual jumlah',0),(432497,12014,'ar','Ø¨Ø§Ø¹Øª Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(432498,12014,'fr','Vendu Total',0),(432499,12014,'jp','è²©å£²åˆè¨ˆ',0),(432500,12014,'pt','Vendida Total',0),(432501,12014,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð½Ð¾ Ð²ÑÐµÐ³Ð¾',0),(432502,12014,'es','Total Vendido',0),(432503,12014,'de','Total verkauft',0),(432504,12014,'en','Sold Total',0),(432505,12015,'is','',0),(432506,12015,'dr','Ú©Ù„ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø¨Ø§ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙˆÛŒÚ˜Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(432507,12015,'pr','Ú©Ù„ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø¨Ø§ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙˆÛŒÚ˜Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(432508,12015,'tr','Hesaplanan toplam kullanÄ±lan Ã¶zel fiyatlandÄ±rma',0),(432509,12015,'pl','Specjalne ceny uÅ¼ywanych obliczone Å‚Ä…cznie',0),(432510,12015,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ñ†ÐµÐ½Ð¸ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¾Ñ‚Ð¾ Ð¾Ð±Ñ‰Ð¾',0),(432511,12015,'ur','Ù…Ø­Ø³ÙˆØ¨ Ù…ÛŒØ²Ø§Ù† Ø®ØµÙˆØµÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©Ø±ØªÛ’ ØªÚ¾Û’',0),(432512,12015,'sr','ÐŸÐ¾ÑÐµÐ±Ð½Ðµ Ñ†ÐµÐ½Ðµ, ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ð¾ Ñ˜Ðµ Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚Ð¸ Ð·Ð±Ð¸Ñ€',0),(432513,12015,'vi','Tá»•ng giÃ¡ Ä‘áº·c biá»‡t sá»­ dá»¥ng Ä‘Æ°á»£c tÃ­nh',0),(432514,12015,'af','Spesiale pryse bereken totale gebruik',0),(432515,12015,'ro','PreÅ£uri speciale utilizate Total calculat',0),(432516,12015,'et','Erilisi hinnakujundust kasutatakse arvutatud kogusumma',0),(432517,12015,'si','Posebne cene uporablja izraÄunane vsote',0),(432518,12015,'ba','Harga khusus digunakan dihitung Total',0),(432519,12015,'nl','Speciale prijzen gebruikt berekende totaal',0),(432520,12015,'fi','Erikoishintaan kÃ¤yttÃ¤Ã¤ lasketun summan',0),(432521,12015,'no','Spesialpriser brukes beregnede totalen',0),(432522,12015,'da','SÃ¦rlige priser anvendes beregnede samlede',0),(432523,12015,'ko','ê³„ì‚° ëœ ì´ ì‚¬ìš© íŠ¹ë³„ ê°€ê²©',0),(432524,12015,'he','×ª×ž×—×•×¨ ×ž×™×•×—×“ ×”×ž×©×ž×© ×”×¡×™×›×•× ×©×—×•×©×‘',0),(432525,12015,'el','Î•Î¹Î´Î¹ÎºÎ­Ï‚ Ï„Î¹Î¼Î­Ï‚ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÏ„Î±Î¹ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(432526,12015,'zh','ç‰¹æ®Šä»·æ ¼è®¡ç®—çš„æ€»\r\n',0),(432527,12015,'sv','SÃ¤rskild prissÃ¤ttning anvÃ¤nds berÃ¤knade totala',0),(432528,12015,'it','Prezzi speciali utilizzati totale calcolato',0),(432529,12015,'tl','',0),(432530,12015,'th','à¸£à¸²à¸„à¸²à¸žà¸´à¹€à¸¨à¸©à¹ƒà¸Šà¹‰à¸„à¸³à¸™à¸§à¸“à¸œà¸¥à¸£à¸§à¸¡',0),(432531,12015,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤ªà¤°à¤¿à¤•à¤²à¤¿à¤¤ à¤¯à¥‹à¤—',0),(432532,12015,'ms','Harga Khas digunakan dikira jumlah',0),(432533,12015,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø­Ø³ÙˆØ¨ Ø§Ù„Ø®Ø§Øµ Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(432534,12015,'fr','Une tarification spÃ©ciale utilisÃ© Total calculÃ©',0),(432535,12015,'jp','é›†è¨ˆã‚’ä½¿ç”¨ã™ã‚‹ç‰¹åˆ¥ãªä¾¡æ ¼è¨­å®š',0),(432536,12015,'pt','PreÃ§os especiais usadas Total calculado',0),(432537,12015,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ñ†ÐµÐ½Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð¸Ñ‚Ð¾Ð³Ð¾Ð²Ð¾Ðµ',0),(432538,12015,'es','Precios Especiales Usaron  Total Calculado',0),(432539,12015,'de','Sonderpreise verwendet berechnete Summe',0),(432540,12015,'en','Special Pricing Used Calculated Total',0),(432541,12016,'is','',0),(432542,12016,'dr','Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙˆÛŒÚ˜Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ù…Ù‚Ø¯Ø§Ø± ',0),(432543,12016,'pr','Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙˆÛŒÚ˜Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ù…Ù‚Ø¯Ø§Ø± ',0),(432544,12016,'tr','Miktar iÃ§in kullanÄ±lan Ã¶zel fiyatlandÄ±rma',0),(432545,12016,'pl','Specjalne ceny stosowane dla iloÅ›ci',0),(432546,12016,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ñ†ÐµÐ½Ð¸ Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(432547,12016,'ur','Ø®Ø§Øµ Ù…Ù‚Ø¯Ø§Ø± Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(432548,12016,'sr','ÐŸÐ¾ÑÐµÐ±Ð½Ðµ Ñ†ÐµÐ½Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(432549,12016,'vi','GiÃ¡ Ä‘áº·c biá»‡t Ä‘Æ°á»£c sá»­ dá»¥ng cho sá»‘ lÆ°á»£ng',0),(432550,12016,'af','Spesiale pryse vir hoeveelheid gebruik',0),(432551,12016,'ro','PreÅ£uri speciale folosite pentru cantitatea',0),(432552,12016,'et','Erilisi hinnakujundust kasutatakse kogus',0),(432553,12016,'si','Posebne cene za koliÄino',0),(432554,12016,'ba','Harga khusus digunakan untuk kuantitas',0),(432555,12016,'nl','Speciale prijzen voor hoeveelheid gebruikt',0),(432556,12016,'fi','Erikoishintaan mÃ¤Ã¤rÃ¤Ã¤',0),(432557,12016,'no','Spesialpriser brukt For',0),(432558,12016,'da','SÃ¦rlige priser anvendes til antal',0),(432559,12016,'ko','ì‚¬ìš© ìˆ˜ëŸ‰ì— ëŒ€ í•œ íŠ¹ë³„ ê°€ê²©',0),(432560,12016,'he','×ª×ž×—×•×¨ ×ž×™×•×—×“ ×”×ž×©×ž×© ×¢×‘×•×¨ ×›×ž×•×ª',0),(432561,12016,'el','Î•Î¹Î´Î¹ÎºÎ­Ï‚ Ï„Î¹Î¼Î­Ï‚ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(432562,12016,'zh','æ•°é‡çš„ç‰¹åˆ«å®šä»·\r\n',0),(432563,12016,'sv','SÃ¤rskild prissÃ¤ttning fÃ¶r kvantitet',0),(432564,12016,'it','Prezzi speciali utilizzati per quantitÃ ',0),(432565,12016,'tl','',0),(432566,12016,'th','à¸£à¸²à¸„à¸²à¸žà¸´à¹€à¸¨à¸©à¹ƒà¸Šà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸£à¸´à¸¡à¸²à¸“',0),(432567,12016,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¯à¥‹à¤—',0),(432568,12016,'ms','Harga Khas digunakan untuk kuantiti',0),(432569,12016,'ar','Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø§Ù„Ø®Ø§ØµØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„Ù„ÙƒÙ…ÙŠØ©',0),(432570,12016,'fr','Un tarif spÃ©cial utilisÃ© pour quantitÃ©',0),(432571,12016,'jp','ç‰¹åˆ¥ä¾¡æ ¼ã®é‡ã®ä½¿ç”¨',0),(432572,12016,'pt','PreÃ§os especiais utilizados para a quantidade',0),(432573,12016,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ñ†ÐµÐ½Ñ‹ Ð´Ð»Ñ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(432574,12016,'es','Precios Especiales Usados Para la Cantidad',0),(432575,12016,'de','Sonderpreise fÃ¼r Menge verwendet',0),(432576,12016,'en','Special Pricing Used For Quantity',0),(432577,12017,'is','',0),(432578,12017,'dr','Ø§Ø¹Ù„Ø§Ù… ÙˆØ¶Ø¹ÛŒØª ØªØ§Ù‡Ù„',0),(432579,12017,'pr','Ø§Ø¹Ù„Ø§Ù… ÙˆØ¶Ø¹ÛŒØª ØªØ§Ù‡Ù„',0),(432580,12017,'tr','Devlet medeni durum',0),(432581,12017,'pl','PaÅ„stwa stan cywilny',0),(432582,12017,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ ÑÐµÐ¼ÐµÐ¹Ð½Ð¾ Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(432583,12017,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ø§Ø²Ø¯ÙˆØ§Ø¬ÛŒ Ø­ÛŒØ«ÛŒØª',0),(432584,12017,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð‘Ñ€Ð°Ñ‡Ð½Ð¾ ÑÑ‚Ð°ÑšÐµ',0),(432585,12017,'vi','TÃ¬nh tráº¡ng hÃ´n nhÃ¢n cá»§a má»™t Ä‘áº¥t nÆ°á»›c',0),(432586,12017,'af','Staat huwelikstatus',0),(432587,12017,'ro','Stat de stare civila',0),(432588,12017,'et','Riigi Perekonnaseis',0),(432589,12017,'si','DrÅ¾avna zakonski stan',0),(432590,12017,'ba','Status perkawinan negara',0),(432591,12017,'nl','Huwelijkse staat',0),(432592,12017,'fi','Valtion siviilisÃ¤Ã¤ty',0),(432593,12017,'no','Statlige sivilstand',0),(432594,12017,'da','Statslige civilstand',0),(432595,12017,'ko','ì£¼ ê²°í˜¼ ìƒíƒœ',0),(432596,12017,'he','×ž×¦×‘ ×ž×©×¤×—×ª×™ ×ž×¦×‘',0),(432597,12017,'el','ÎšÏÎ±Ï„Î¹ÎºÎ­Ï‚ Î¿Î¹ÎºÎ¿Î³ÎµÎ½ÎµÎ¹Î±ÎºÎ® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(432598,12017,'zh','å›½å®¶å©šå§»çŠ¶å†µ\r\n',0),(432599,12017,'sv','Statliga civilstÃ¥nd',0),(432600,12017,'it','Stato civile dello stato',0),(432601,12017,'tl','',0),(432602,12017,'th','à¸ªà¸–à¸²à¸™à¸ à¸²à¸žà¸ªà¸–à¸²à¸™à¸°',0),(432603,12017,'hi','à¤°à¤¾à¤œà¥ à¤¯ à¤µà¥ˆà¤µà¤¾à¤¹à¤¿à¤• à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(432604,12017,'ms','Status perkahwinan Negeri',0),(432605,12017,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ù„Ø­Ø§Ù„Ø© Ø§Ù„Ø²ÙˆØ§Ø¬ÙŠØ©',0),(432606,12017,'fr','Ã‰tat matrimonial',0),(432607,12017,'jp','å·žã®å©šå§»çŠ¶æ³',0),(432608,12017,'pt','Estado Marital Status',0),(432609,12017,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ð¾Ðµ ÑÐµÐ¼ÐµÐ¹Ð½Ð¾Ðµ Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(432610,12017,'es','Estado Matrimonia Estatal',0),(432611,12017,'de','Staatliche Familienstand',0),(432612,12017,'en','State Marital Status',0),(432613,12018,'is','',0),(432614,12018,'dr','(Ù‡Ø²ÛŒÙ†Ù‡',0),(432615,12018,'pr','Ù…Ø¬ÙˆØ¹ Ø´Ø§Ø±Ú˜(Ù‡Ø²ÛŒÙ†Ù‡',0),(432616,12018,'tr','Toplam Ã¼cret',0),(432617,12018,'pl','CaÅ‚kowity Å‚adunek',0),(432618,12018,'bg','ÐžÐ±Ñ‰ Ð·Ð°Ñ€ÑÐ´',0),(432619,12018,'ur','Ú©Ù„ Ú†Ø§Ø±Ø¬',0),(432620,12018,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(432621,12018,'vi','Tá»•ng sá»‘ phÃ­ ',0),(432622,12018,'af','Totale lading',0),(432623,12018,'ro','Taxa totalÄƒ',0),(432624,12018,'et','Koguhulk',0),(432625,12018,'si','Celotni naboj',0),(432626,12018,'ba','Total biaya',0),(432627,12018,'nl','Totale kosten',0),(432628,12018,'fi','Kokonaiskustannukset',0),(432629,12018,'no','Totale kostnader',0),(432630,12018,'da','Samlede byrde',0),(432631,12018,'ko','ì´ ìš”ê¸ˆ',0),(432632,12018,'he','×¡×” ×› ×ª×©×œ×•×',0),(432633,12018,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® ÎµÏ€Î¹Î²Î¬ÏÏ…Î½ÏƒÎ·',0),(432634,12018,'zh','æ€»æ”¶è´¹\r\n',0),(432635,12018,'sv','Total kostnad',0),(432636,12018,'it','Carica totale',0),(432637,12018,'tl','',0),(432638,12018,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸£à¸§à¸¡',0),(432639,12018,'hi','à¤•à¥à¤² à¤ªà¥à¤°à¤­à¤¾à¤°',0),(432640,12018,'ms','Jumlah caj',0),(432641,12018,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø±Ø³ÙˆÙ…',0),(432642,12018,'fr','Charge totale',0),(432643,12018,'jp','åˆè¨ˆã®æ–™é‡‘',0),(432644,12018,'pt','Carga total',0),(432645,12018,'ru','ÐŸÐ¾Ð»Ð½Ð¾Ð³Ð¾ Ð·Ð°Ñ€ÑÐ´Ð°',0),(432646,12018,'es','Cargo Total',0),(432647,12018,'de','Gesamtrechnungsbetrages',0),(432648,12018,'en','Total Charge',0),(432649,12019,'is','',0),(432650,12019,'dr','/Ø§ØµÙ„Ø§Ø­',0),(432651,12019,'pr','Ú©Ø§Ø±Ø¨Ø± Ø¬Ø¯ÛŒØ¯ /ÙˆÛŒØ±Ø§ÛŒØ´',0),(432652,12019,'tr','KullanÄ±cÄ± yeni/DÃ¼zenle',0),(432653,12019,'pl','Nowy uÅ¼ytkownik/edycja',0),(432654,12019,'bg','ÐÐ¾Ð² Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(432655,12019,'ur','Ù†ÛŒØ§ ØµØ§Ø±Ù/ØªØ¯ÙˆÛŒÙ†',0),(432656,12019,'sr','ÐÐ¾Ð²Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(432657,12019,'vi','ngÆ°á»i dÃ¹ng má»›i/ chá»‰nh sá»­a',0),(432658,12019,'af','Nuwe gebruiker/redigeer',0),(432659,12019,'ro','Utilizator nou/editare',0),(432660,12019,'et','Uus kasutaja/Edit',0),(432661,12019,'si','Nov uporabnik/Uredi',0),(432662,12019,'ba','Pengguna baru/Edit',0),(432663,12019,'nl','Nieuwe gebruiker/bewerken',0),(432664,12019,'fi','Uusi kÃ¤yttÃ¤jÃ¤/muokata',0),(432665,12019,'no','Bruker ny/Rediger',0),(432666,12019,'da','Bruger ny/Rediger',0),(432667,12019,'ko','ì‚¬ìš©ìž ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘',0),(432668,12019,'he','×ž×©×ª×ž×© ×—×“×©/×¢×¨×™×›×”',0),(432669,12019,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï‡ÏÎ®ÏƒÏ„Î·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(432670,12019,'zh','ç”¨æˆ·æ–°å»º/ç¼–è¾‘\r\n',0),(432671,12019,'sv','Ny anvÃ¤ndare/redigera',0),(432672,12019,'it','Utente nuovo/modifica',0),(432673,12019,'tl','',0),(432674,12019,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚',0),(432675,12019,'hi','à¤¨à¤¯à¤¾ à¤ªà¥à¤°à¤¯à¥‹à¤•à¥à¤¤à¤¾/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(432676,12019,'ms','Pengguna baru/Edit',0),(432677,12019,'ar','Ù…Ø³ØªØ®Ø¯Ù… Ø¬Ø¯ÙŠØ¯/ØªØ­Ø±ÙŠØ±',0),(432678,12019,'fr','Nouvel utilisateur/modifier',0),(432679,12019,'jp','æ–°ã—ã„ ï¼ ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®ç·¨é›†',0),(432680,12019,'pt','Novo usuÃ¡rio/editar',0),(432681,12019,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(432682,12019,'es','Usuario Nuevo/Editar',0),(432683,12019,'de','Benutzer neu/bearbeiten',0),(432684,12019,'en','User New/Edit',0),(432685,12020,'is','',0),(432686,12020,'dr','/ Ø§ØµÙ„Ø§Ø­ ÛŒÙˆØ²Ø±',0),(432687,12020,'pr','Ù†Ù…Ø§ÛŒØ´/ ÙˆÛŒØ±Ø§ÛŒØ´ Ú©Ø§Ø±Ø¨Ø±',0),(432688,12020,'tr','GÃ¶rÃ¼ntÃ¼le/DÃ¼zenle mÃ¼ÅŸteri',0),(432689,12020,'pl','WyÅ›wietl/Edytuj klienta',0),(432690,12020,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(432691,12020,'ur','Ú©Ø³Ù¹Ù…Ø± Ù…Ù†Ø¸Ø±/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(432692,12020,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ /Ð£Ñ€ÐµÐ´Ð¸ ÐºÑƒÐ¿Ñ†Ð°',0),(432693,12020,'vi','ÄÃ¡nh giÃ¡/ sá»­a khÃ¡ch hÃ ng',0),(432694,12020,'af','Bekyk/redigeer kliÃ«nt',0),(432695,12020,'ro','Vizualizare/Editare client',0),(432696,12020,'et','Vaata/Muuda kliendi',0),(432697,12020,'si','Ogled/urejanje kupca',0),(432698,12020,'ba','Lihat/Edit pelanggan',0),(432699,12020,'nl','Bekijken/bewerken klant',0),(432700,12020,'fi','NÃ¤ytÃ¤/Muokkaa asiakkaan',0),(432701,12020,'no','Vise/redigere kunde',0),(432702,12020,'da','Se/Rediger kunde',0),(432703,12020,'ko','ë³´ê¸°/íŽ¸ì§‘ ê³ ê°',0),(432704,12020,'he','×”×¦×’/×¢×¨×•×š ×”×œ×§×•×—',0),(432705,12020,'el','Î ÏÎ¿Î²Î¿Î»Î®/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(432706,12020,'zh','ç¼–è¾‘/æŸ¥çœ‹å®¢æˆ·\r\n',0),(432707,12020,'sv','Visa/redigera kund',0),(432708,12020,'it','Visualizza/modifica cliente',0),(432709,12020,'tl','',0),(432710,12020,'th','à¸”à¸¹à¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(432711,12020,'hi','à¤¦à¥‡à¤–à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(432712,12020,'ms','Baca pandangan/Edit',0),(432713,12020,'ar','Ø¹Ø±Ø¶/ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(432714,12020,'fr','Afficher/modifier client',0),(432715,12020,'jp','é¡§å®¢ã®è¡¨ç¤º/ç·¨é›†',0),(432716,12020,'pt','Exibir/editar cliente',0),(432717,12020,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(432718,12020,'es','Visionar/Editar Cliente',0),(432719,12020,'de','Bearbeiten Sie anzeigen/Kunde',0),(432720,12020,'en','View/Edit Customer',0),(432721,12021,'is','',0),(432722,12021,'dr','-Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§Ø¨Ø· ØªÚ© ÙØ±Ù…ÛŒ-Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ ',0),(432723,12021,'pr','Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„ Ø¨Ø±Ø§ÛŒ-Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§Ø¨Ø· ØªÚ© ÙØ±Ù…ÛŒ-Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ ',0),(432724,12021,'tr','SDI Ã¶denecek GL hesabÄ±',0),(432725,12021,'pl','GL konto pÅ‚atne SDI',0),(432726,12021,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° SDI Ð¿Ð»Ð°Ñ‚Ð¸Ð¼Ð¸',0),(432727,12021,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ SDI Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’',0),(432728,12021,'sr','Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¡Ð”Ð› Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(432729,12021,'vi','TK sá»• cÃ¡i cho pháº£i tráº£ SDI',0),(432730,12021,'af','GL rekening vir SDI betaalbaar',0),(432731,12021,'ro','GL cont pentru SDI datorate',0),(432732,12021,'et','Pearaamatukontole SDI tasuma',0),(432733,12021,'si','GL raÄun za plaÄljive SDI',0),(432734,12021,'ba','GL Account untuk dibayarkan SDI',0),(432735,12021,'nl','GL Account voor SDI te betalen',0),(432736,12021,'fi','Kirjanpitotilin pÃ¤Ã¤tilin SDI maksettavan',0),(432737,12021,'no','GI-konto For SDI betales',0),(432738,12021,'da','GL konto til SDI betales',0),(432739,12021,'ko','SDI ì§€ê¸‰ì— ëŒ€ í•œ GL ê³„ì •',0),(432740,12021,'he','GL ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×–×›××™× SDI',0),(432741,12021,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± SDI Ï€Î»Î·ÏÏ‰Ï„Î­Î¿Î¹',0),(432742,12021,'zh','åº”ä»˜æ€»åˆ†ç±»å¸çš„å›½å®¶ä¼¤æ®‹ä¿é™©\r\n',0),(432743,12021,'sv','GL konto fÃ¶r SDI betalas',0),(432744,12021,'it','GL Account per SDI pagabile',0),(432745,12021,'tl','',0),(432746,12021,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸ªà¸³à¸«à¸£à¸±à¸šà¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰à¸ à¸²à¸žà¸¢à¸™à¸•à¸£à¹Œ',0),(432747,12021,'hi','GL à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ SDI à¤¦à¥‡à¤¯',0),(432748,12021,'ms','GL akaun untuk pembayaran SDI',0),(432749,12021,'ar','Ø­Ø³Ø§Ø¨ GL Ù„Ù„Ø¯ÙØ¹ SDI',0),(432750,12021,'fr','Compte GL pour SDI Payable',0),(432751,12021,'jp','SDI ã®æ”¯æ‰•ã®ãŸã‚ã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(432752,12021,'pt','GL conta para pagar SDI',0),(432753,12021,'ru','Ð¡Ñ‡ÐµÑ‚ GL Ð´Ð»Ñ SDI Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ',0),(432754,12021,'es','Cuenta LM Para SDI Pagable',0),(432755,12021,'de','Sako fÃ¼r SDI zahlbar',0),(432756,12021,'en','GL Account For SDI Payable',0),(432757,12022,'is','',0),(432758,12022,'dr','Ø¨Ø±Ø±ÙˆÛŒ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³Ø§Ù„Ø§Ù†Ù‡ Ø¨ÛŒØ´ Ø§Ø²',0),(432759,12022,'pr','Ø¨Ø±Ø±ÙˆÛŒ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³Ø§Ù„Ø§Ù†Ù‡ Ø¨ÛŒØ´ Ø§Ø²',0),(432760,12022,'tr','On yÄ±llÄ±k Ã¼cret',0),(432761,12022,'pl','Na roczne zarobki ponad',0),(432762,12022,'bg','ÐÐ° Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð°Ð´',0),(432763,12022,'ur','Ù¾Ø± Ø³Ø§Ù„Ø§Ù†Û Ø§Ø¬Ø±Øª Ù¾Ø±',0),(432764,12022,'sr','Ð“Ð¾Ð´Ð¸ÑˆÑšÐ° Ð¿Ð»Ð°Ñ‚Ð° Ð¿Ñ€ÐµÐºÐ¾',0),(432765,12022,'vi','Cao lÆ°Æ¡ng thÃ´ng thÆ°á»ng',0),(432766,12022,'af','Op die jaarlikse lone oor',0),(432767,12022,'ro','Salariu anual peste',0),(432768,12022,'et','Aasta palkade Ã¼le linna',0),(432769,12022,'si','Letne plaÄe nad',0),(432770,12022,'ba','Tahunan upah atas',0),(432771,12022,'nl','Op de jaarlijkse lonen Over',0),(432772,12022,'fi','Vuotuinen palkkojen',0),(432773,12022,'no','PÃ¥ Ã¥rlig lÃ¸nn Over',0),(432774,12022,'da','PÃ¥ Ã¥rlige lÃ¸n Over',0),(432775,12022,'ko','ì´ìƒì˜ ì—°ê°„ ìž„ê¸ˆ',0),(432776,12022,'he','×¢×œ ×”×©×›×¨ ×”×©× ×ª×™ ×ž×¢×œ',0),(432777,12022,'el','Î•Ï€Î¯ Ï„Ï‰Î½ ÎµÏ„Î®ÏƒÎ¹Ï‰Î½ Î¼Î¹ÏƒÎ¸ÏŽÎ½ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ',0),(432778,12022,'zh','è¶…è¿‡æ¯å¹´å·¥èµ„\r\n',0),(432779,12022,'sv','PÃ¥ Ã¥rliga lÃ¶ner Ã¶ver',0),(432780,12022,'it','Stipendio annuo sopra',0),(432781,12022,'tl','',0),(432782,12022,'th','à¸šà¸™à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸›à¸£à¸°à¸ˆà¸³à¸›à¸µà¸¡à¸²à¸à¸à¸§à¹ˆà¸²',0),(432783,12022,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤µà¤¾à¤°à¥à¤·à¤¿à¤• à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤ªà¤°',0),(432784,12022,'ms','Pada upah Tahunan ke atas',0),(432785,12022,'ar','ÙÙŠ Ø§Ù„Ø£Ø¬ÙˆØ± Ø§Ù„Ø³Ù†ÙˆÙŠØ© Ø¹Ù„Ù‰ Ù…Ø¯Ù‰',0),(432786,12022,'fr','Sur les salaires annuels sur',0),(432787,12022,'jp','å¹´é–“è³ƒé‡‘ã®ä¸Šã§',0),(432788,12022,'pt','Sobre os salÃ¡rios anuais sobre',0),(432789,12022,'ru','ÐÐ° Ð³Ð¾Ð´Ð¾Ð²Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð·Ð°',0),(432790,12022,'es','Sobre Sueldos Anuales MÃ¡s Que',0),(432791,12022,'de','Auf die jÃ¤hrlichen LÃ¶hne Ã¼ber',0),(432792,12022,'en','On Annual Wages Over',0),(432793,12023,'is','',0),(432794,12023,'dr','..SDI Amount.',0),(432795,12023,'pr','Ù…Ù‚Ø¯Ø§Ø±..SDI Amount.',0),(432796,12023,'tr','SDI tutar',0),(432797,12023,'pl','Kwota SDI',0),(432798,12023,'bg','SDI ÑÑƒÐ¼Ð°',0),(432799,12023,'ur','SDI Ø±Ù‚Ù…',0),(432800,12023,'sr','Ð¡Ð”Ð› Ð¸Ð·Ð½Ð¾Ñ',0),(432801,12023,'vi','Sá»‘ tiá»n SDI',0),(432802,12023,'af','SDI bedrag',0),(432803,12023,'ro','SDI suma',0),(432804,12023,'et','SDI summa',0),(432805,12023,'si','SDI znesek',0),(432806,12023,'ba','SDI jumlah',0),(432807,12023,'nl','SDI bedrag',0),(432808,12023,'fi','SDI mÃ¤Ã¤rÃ¤',0),(432809,12023,'no','SDI belÃ¸p',0),(432810,12023,'da','SDI belÃ¸b',0),(432811,12023,'ko','SDI ê¸ˆì•¡',0),(432812,12023,'he','×›×ž×•×ª SDI',0),(432813,12023,'el','SDI Ï€Î¿ÏƒÏŒ',0),(432814,12023,'zh','å›½å®¶ä¼¤æ®‹ä¿é™©é‡‘é¢\r\n',0),(432815,12023,'sv','SDI belopp',0),(432816,12023,'it','Importo SDI',0),(432817,12023,'tl','',0),(432818,12023,'th','à¸¢à¸­à¸”à¸ à¸²à¸žà¸¢à¸™à¸•à¸£à¹Œ',0),(432819,12023,'hi','SDI à¤°à¤¾à¤¶à¤¿',0),(432820,12023,'ms','Jumlah SDI',0),(432821,12023,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙƒØ§Ù†ÙŠØ©',0),(432822,12023,'fr','Montant de la SDI',0),(432823,12023,'jp','SDI é‡',0),(432824,12023,'pt','Quantidade de SDI',0),(432825,12023,'ru','Ð¡ÑƒÐ¼Ð¼Ð° SDI',0),(432826,12023,'es','Cantidad de SDI',0),(432827,12023,'de','SDI-Betrag',0),(432828,12023,'en','SDI Amount',0),(432829,12024,'is','',0),(432830,12024,'dr','SDI',0),(432831,12024,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø«Ø§Ø¨Øª Ø³Ø§Ù„Ø§Ù†Ù‡ SDI',0),(432832,12024,'tr','SDI sabit yÄ±llÄ±k tutar',0),(432833,12024,'pl','Roczna kwota SDI z pÅ‚askim',0),(432834,12024,'bg','SDI Ñ„Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ð° Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð° ÑÑƒÐ¼Ð°',0),(432835,12024,'ur','SDI ÙÙ„ÛŒÙ¹ Ø³Ø§Ù„Ø§Ù†Û Ø±Ù‚Ù…',0),(432836,12024,'sr','Ð¡Ð”Ð› ÑÑ‚Ð°Ð½ Ð³Ð¾Ð´Ð¸ÑˆÑšÐ¸ Ð¸Ð·Ð½Ð¾Ñ',0),(432837,12024,'vi','Sá»‘ tiá»n SDI hÃ ng nÄƒm',0),(432838,12024,'af','SDI plat jaarlikse bedrag',0),(432839,12024,'ro','Suma anualÄƒ SDI plat',0),(432840,12024,'et','SDI kindla aastasumma',0),(432841,12024,'si','SDI pavÅ¡alni letni znesek',0),(432842,12024,'ba','Jumlah tahunan SDI datar',0),(432843,12024,'nl','SDI Flat jaarlijks bedrag',0),(432844,12024,'fi','SDI kiinteÃ¤ vuosittainen summa',0),(432845,12024,'no','SDI Flat Ã¥rlig belÃ¸p',0),(432846,12024,'da','SDI faste Ã¥rlige belÃ¸b',0),(432847,12024,'ko','SDI í‰ë©´ ì—°ê°„ ê¸ˆì•¡',0),(432848,12024,'he','×”×›×ž×•×ª ×”×©× ×ª×™×ª SDI ×©×˜×•×—',0),(432849,12024,'el','Î•Ï„Î®ÏƒÎ¹Î¿ Ï€Î¿ÏƒÏŒ SDI ÎµÏ€Î¯Ï€ÎµÎ´Î·Ï‚',0),(432850,12024,'zh','å›½å®¶ä¼¤æ®‹ä¿é™©å›ºå®šå¹´åº¦é‡‘é¢\r\n',0),(432851,12024,'sv','SDI platt Ã¥rligt belopp',0),(432852,12024,'it','Importo annuo SDI piatto',0),(432853,12024,'tl','',0),(432854,12024,'th','à¹à¸šà¸™à¸ à¸²à¸žà¸¢à¸™à¸•à¸£à¹Œà¸ªà¸±à¸à¸à¸²',0),(432855,12024,'hi','SDI à¤«à¥à¤²à¥ˆà¤Ÿ à¤µà¤¾à¤°à¥à¤·à¤¿à¤• à¤°à¤¾à¤¶à¤¿',0),(432856,12024,'ms','Jumlah Tahunan SDI rata',0),(432857,12024,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ø³Ù†ÙˆÙŠ SDI Ù…Ø³Ø·Ø­Ø©',0),(432858,12024,'fr','SDI plat montant annuel',0),(432859,12024,'jp','SDI ãƒ•ãƒ©ãƒƒãƒˆå¹´é¡',0),(432860,12024,'pt','Montante anual Flat SDI',0),(432861,12024,'ru','Ð“Ð¾Ð´Ð¾Ð²Ð°Ñ ÑÑƒÐ¼Ð¼Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ñƒ SDI',0),(432862,12024,'es','SDI Cantidad Anual Fija',0),(432863,12024,'de','SDI Flat Jahresbetrag',0),(432864,12024,'en','SDI Flat Annual Amount',0),(432865,12025,'is','',0),(432866,12025,'dr','Ø¯Ø±ØµØ¯\r\nSDI',0),(432867,12025,'pr','Ø¯Ø±ØµØ¯\r\nSDI',0),(432868,12025,'tr','SDI yÃ¼zde',0),(432869,12025,'pl','Procent SDI',0),(432870,12025,'bg','SDI Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(432871,12025,'ur','SDI ÙÛŒØµØ¯',0),(432872,12025,'sr','Ð¡Ð”Ð› Ð¿Ð¾ÑÑ‚Ð¾',0),(432873,12025,'vi','Pháº§n trÄƒm SDI',0),(432874,12025,'af','SDI persent',0),(432875,12025,'ro','SDI la sutÄƒ',0),(432876,12025,'et','SDI protsenti',0),(432877,12025,'si','SDI odstotkov',0),(432878,12025,'ba','SDI persen',0),(432879,12025,'nl','SDI procent',0),(432880,12025,'fi','SDI prosenttia',0),(432881,12025,'no','SDI prosent',0),(432882,12025,'da','SDI procent',0),(432883,12025,'ko','SDI %',0),(432884,12025,'he','××—×•×– SDI',0),(432885,12025,'el','SDI Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(432886,12025,'zh','å›½å®¶ä¼¤æ®‹ä¿é™©ç™¾åˆ†æ¯”\r\n',0),(432887,12025,'sv','SDI procent',0),(432888,12025,'it','Per cento SDI',0),(432889,12025,'tl','',0),(432890,12025,'th','à¸ à¸²à¸žà¸¢à¸™à¸•à¸£à¹Œà¸£à¹‰à¸­à¸¢à¸¥à¸°',0),(432891,12025,'hi','SDI à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(432892,12025,'ms','SDI peratus',0),(432893,12025,'ar','SDI Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(432894,12025,'fr','SDI pour cent',0),(432895,12025,'jp','SDI %',0),(432896,12025,'pt','Por cento de SDI',0),(432897,12025,'ru','SDI %',0),(432898,12025,'es','SDI Porcentaje',0),(432899,12025,'de','SDI-Prozent',0),(432900,12025,'en','SDI Percent',0),(432901,12026,'is','',0),(432902,12026,'dr','Ø§ÛŒÙ† Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÛŒØ§Øª ÙØ¯Ø±Ø§Ù„ Ø§Ø³Øª',0),(432903,12026,'pr','Ø§ÛŒÙ† Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÛŒØ§Øª ÙØ¯Ø±Ø§Ù„ Ø§Ø³Øª',0),(432904,12026,'tr','Vergi bu Federal vergi yÃ¼zdesidir.',0),(432905,12026,'pl','Podatek jest to procent podatku federalnego',0),(432906,12026,'bg','Ð”Ð°Ð½ÑŠÐº Ðµ Ñ‚Ð¾Ð·Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð½Ð° Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸Ñ Ð´Ð°Ð½ÑŠÐº',0),(432907,12026,'ur','Ù¹ÛŒÚ©Ø³ ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ ÛŒÛ ØªÙ†Ø§Ø³Ø¨ ÛÛ’ Û”',0),(432908,12026,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ñ˜Ðµ Ð¾Ð²Ð°Ñ˜ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ ÑÐ°Ð²ÐµÐ·Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(432909,12026,'vi','Thuáº¿ lÃ  Tá»· lá»‡ pháº§n trÄƒm thuáº¿ liÃªn bang',0),(432910,12026,'af','Belasting Is hierdie persentasie van federale belasting',0),(432911,12026,'ro','Taxa este acest procent din impozitul Federal',0),(432912,12026,'et','Maks on fÃ¶deraalse tulumaksu protsent',0),(432913,12026,'si','Davka je ta odstotek davka na zveznem',0),(432914,12026,'ba','Pajak adalah persentase ini dari Pajak Federal',0),(432915,12026,'nl','Belasting Is dit Percentage van federale belasting',0),(432916,12026,'fi','Vero on liittovaltion veroja prosenttiluku',0),(432917,12026,'no','Er denne prosentandelen av fÃ¸deral skatt',0),(432918,12026,'da','Skat er denne procentdel af Federal Tax',0),(432919,12026,'ko','ì„¸ê¸ˆì€ ì—°ë°© ì„¸ê¸ˆì˜ì´ ë¹„ìœ¨',0),(432920,12026,'he','×”×ž×¡ ×”×•× ×–×” ××—×•×– ×ž×¡ ×¤×“×¨×œ×™',0),(432921,12026,'el','ÎŸ Ï†ÏŒÏÎ¿Ï‚ ÎµÎ¯Î½Î±Î¹ Ï„Î¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï„Î¿Ï… Î¿Î¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï…',0),(432922,12026,'zh','ç¨Žæ”¶ä¸ºè”é‚¦ç¨Žæ”¶æ­¤ç™¾åˆ†æ¯”\r\n',0),(432923,12026,'sv','Skatt Ã¤r denna andel av Federal skatt',0),(432924,12026,'it','Fiscale Ã¨ questa percentuale dell\'imposta federale',0),(432925,12026,'tl','',0),(432926,12026,'th','à¸ à¸²à¸©à¸µà¸ˆà¸°à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µà¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸™à¸µà¹‰',0),(432927,12026,'hi','à¤¯à¤¹ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¸à¤‚à¤˜à¥€à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¤¾ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(432928,12026,'ms','Cukai adalah peratusan cukai Persekutuan',0),(432929,12026,'ar','Ù‡Ùˆ Ø¶Ø±ÙŠØ¨Ø© Ù‡Ø°Ù‡ Ø§Ù„Ù†Ø³Ø¨Ø© Ù…Ù† Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(432930,12026,'fr','La taxe est ce pourcentage de l\'impÃ´t fÃ©dÃ©ral',0),(432931,12026,'jp','ç¨Žã¯é€£é‚¦ç¨Žã®ã“ã®å‰²åˆã§ã™ã€‚',0),(432932,12026,'pt','Imposto Ã© esse percentual de imposto Federal',0),(432933,12026,'ru','ÐÐ°Ð»Ð¾Ð³ â€” ÑÑ‚Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(432934,12026,'es','Impuesto es Este Porcentaje del Impuesto Federal',0),(432935,12026,'de','Steuer ist dieser Prozentsatz der EidgenÃ¶ssischen Steuerverwaltung',0),(432936,12026,'en','Tax Is This Percentage of Federal Tax',0),(432937,12027,'is','',0),(432938,12027,'dr','Ù…Ø¨Ù„Øº Ú©Ø§Ù…Ù„ Ø´Ø¯Ù‡',0),(432939,12027,'pr','Ù…Ø¨Ù„Øº Ú©Ø§Ù…Ù„ Ø´Ø¯Ù‡',0),(432940,12027,'tr','Tamamlanan Miktar',0),(432941,12027,'pl','IloÅ›Ä‡ ukoÅ„czona',0),(432942,12027,'bg','Ð¡ÑƒÐ¼Ð°Ñ‚Ð° Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð¸',0),(432943,12027,'ur','Ù…Ú©Ù…Ù„ Ø±Ù‚Ù…',0),(432944,12027,'sr','Ð˜Ð·Ð½Ð¾Ñ Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð°',0),(432945,12027,'vi','Sá»‘ tiá»n hoÃ n thÃ nh',0),(432946,12027,'af','Bedrag voltooi',0),(432947,12027,'ro','Suma completat',0),(432948,12027,'et','LÃµpetatud kogus',0),(432949,12027,'si','Znesek konÄan',0),(432950,12027,'ba','Jumlah selesai',0),(432951,12027,'nl','Bedrag voltooid',0),(432952,12027,'fi','Suoritettu summa',0),(432953,12027,'no','Mengden fullfÃ¸rt',0),(432954,12027,'da','BelÃ¸b afsluttet',0),(432955,12027,'ko','ì™„ë£Œ ê¸ˆì•¡',0),(432956,12027,'he','×›×ž×•×ª ×”×•×©×œ×ž×”',0),(432957,12027,'el','Î Î¿ÏƒÏŒ Ï€Î¿Ï… Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ¸Î·ÎºÎµ',0),(432958,12027,'zh','å®Œæˆé¢\r\n',0),(432959,12027,'sv','Belopp som avslutat',0),(432960,12027,'it','QuantitÃ  completata',0),(432961,12027,'tl','',0),(432962,12027,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(432963,12027,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤°à¤¾à¤¶à¤¿',0),(432964,12027,'ms','Amaun yang telah siap',0),(432965,12027,'ar','Ø¥ÙƒÙ…Ø§Ù„ Ø§Ù„Ù…Ø¨Ù„Øº',0),(432966,12027,'fr','Pourcentage terminÃ©',0),(432967,12027,'jp','å®Œæˆå“ã®é‡',0),(432968,12027,'pt','Quantidade concluÃ­da',0),(432969,12027,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°',0),(432970,12027,'es','Monto Completado',0),(432971,12027,'de','HÃ¶he abgeschlossen',0),(432972,12027,'en','Amount Completed',0),(432973,12028,'is','',0),(432974,12028,'dr','Ù…Ø¨Ù„Øº ÙØ§Ú©ØªÙˆØ± Ø´Ø¯Ù‡ ',0),(432975,12028,'pr','Ù…Ø¨Ù„Øº ÙØ§Ú©ØªÙˆØ± Ø´Ø¯Ù‡ ',0),(432976,12028,'tr','Faturalanan tutar',0),(432977,12028,'pl','Kwota zafakturowana',0),(432978,12028,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(432979,12028,'ur','Ø±Ù‚Ù… Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯',0),(432980,12028,'sr','Ð˜Ð·Ð½Ð¾Ñ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½',0),(432981,12028,'vi','Sá»‘ tiá»n Ä‘Æ°á»£c láº­p hÃ³a Ä‘Æ¡n',0),(432982,12028,'af','Bedrag Invoiced',0),(432983,12028,'ro','Suma facturatÄƒ',0),(432984,12028,'et','Kaubaarve kogusumma',0),(432985,12028,'si','Vrednost fakture',0),(432986,12028,'ba','Jumlah tagihan',0),(432987,12028,'nl','Gefactureerde bedrag',0),(432988,12028,'fi','Laskutettu mÃ¤Ã¤rÃ¤',0),(432989,12028,'no','Fakturerte belÃ¸pet',0),(432990,12028,'da','Fakturerede belÃ¸b',0),(432991,12028,'ko','ì²­êµ¬ ê¸ˆì•¡',0),(432992,12028,'he','×›×ž×•×ª ×©×—×•×™×‘×”',0),(432993,12028,'el','Î Î¿ÏƒÏŒ Ï€Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î®Î¸Î·ÎºÎµ',0),(432994,12028,'zh','å‘ç¥¨é‡‘é¢\r\n',0),(432995,12028,'sv','Belopp som fakturerats',0),(432996,12028,'it','Importo fatturato',0),(432997,12028,'tl','',0),(432998,12028,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(432999,12028,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿',0),(433000,12028,'ms','Amaun diinvois',0),(433001,12028,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…ÙÙˆØªØ±',0),(433002,12028,'fr','Montant facturÃ©',0),(433003,12028,'jp','è«‹æ±‚é‡‘é¡',0),(433004,12028,'pt','Montante facturado',0),(433005,12028,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÑ‡ÐµÑ‚Ð°',0),(433006,12028,'es','Monto Facturado',0),(433007,12028,'de','In Rechnung gestellte Betrag',0),(433008,12028,'en','Amount Invoiced',0),(433009,12029,'is','',0),(433010,12029,'dr','Ø­Ø°Ù Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³',0),(433011,12029,'pr','Ø­Ø°Ù Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³',0),(433012,12029,'tr','Bu adresi Sil',0),(433013,12029,'pl','UsuÅ„ ten adres',0),(433014,12029,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð°Ð´Ñ€ÐµÑ',0),(433015,12029,'ur','Ø§Ø³ Ø¹Ù†ÙˆØ§Ù† Ú©Ùˆ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(433016,12029,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ Ð°Ð´Ñ€ÐµÑÑƒ',0),(433017,12029,'vi','XÃ³a Ä‘á»‹a chá»‰ nÃ y',0),(433018,12029,'af','Skrap hierdie adres',0),(433019,12029,'ro','ÅžtergeÅ£i aceastÄƒ adresÄƒ',0),(433020,12029,'et','Kustuta aadress',0),(433021,12029,'si','IzbriÅ¡ite ta naslov',0),(433022,12029,'ba','Menghapus alamat ini',0),(433023,12029,'nl','Dit adres verwijderen',0),(433024,12029,'fi','Poista tÃ¤mÃ¤ osoite',0),(433025,12029,'no','Slette denne adressen',0),(433026,12029,'da','Slet denne adresse',0),(433027,12029,'ko','ì´ ì£¼ì†Œ ì‚­ì œ',0),(433028,12029,'he','×œ×ž×—×•×§ ××ª ×”×›×ª×•×‘×ª ×”×–×•',0),(433029,12029,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î® Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(433030,12029,'zh','åˆ é™¤æ­¤åœ°å€\r\n',0),(433031,12029,'sv','Ta bort denna adress',0),(433032,12029,'it','Eliminare questo indirizzo',0),(433033,12029,'tl','',0),(433034,12029,'th','à¸¥à¸šà¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸™à¸µà¹‰',0),(433035,12029,'hi','à¤‡à¤¸ à¤ªà¤¤à¥‡ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(433036,12029,'ms','Menghapuskan alamat ini',0),(433037,12029,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(433038,12029,'fr','Supprimer cette adresse',0),(433039,12029,'jp','ã“ã®ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(433040,12029,'pt','Excluir este endereÃ§o',0),(433041,12029,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð°Ð´Ñ€ÐµÑ',0),(433042,12029,'es','Eliminar Esta DirecciÃ³n',0),(433043,12029,'de','Diese Adresse zu lÃ¶schen',0),(433044,12029,'en','Delete This Address',0),(433045,12030,'is','',0),(433046,12030,'dr','Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ† Ø¨Ø±Ø§ÛŒ Ø¨Ø¹Ø¯',0),(433047,12030,'pr','Ù†Ú¯Ù‡ Ø¯Ø§Ø´ØªÙ† Ø¨Ø±Ø§ÛŒ Ø¨Ø¹Ø¯',0),(433048,12030,'tr','Daha sonra iÃ§in basÄ±lÄ± tutun',0),(433049,12030,'pl','TrzymaÄ‡ na pÃ³Åºniej',0),(433050,12030,'bg','Ð—Ð°Ð´Ñ€ÑŠÐ¶Ñ‚Ðµ Ð·Ð° Ð¿Ð¾-ÐºÑŠÑÐ½Ð¾',0),(433051,12030,'ur','Ø¨Ø¹Ø¯ Ø§Ø²Ø§Úº Ú©Û’ Ù„Ø¦Û’ Ù¾Ú©Ú‘',0),(433052,12030,'sr','Ð”Ñ€Ð¶Ð¸Ñ‚Ðµ Ð·Ð° ÐºÐ°ÑÐ½Ð¸Ñ˜Ðµ',0),(433053,12030,'vi','Giá»¯ Ä‘á»ƒ sau',0),(433054,12030,'af','Hou vir Later',0),(433055,12030,'ro','Å¢ineÅ£i apÄƒsat pentru mai tÃ¢rziu',0),(433056,12030,'et','Hoidke hiljem',0),(433057,12030,'si','DrÅ¾ite za kasneje',0),(433058,12030,'ba','Tahan untuk nanti',0),(433059,12030,'nl','Houden voor Later',0),(433060,12030,'fi','PidÃ¤ myÃ¶hemmin',0),(433061,12030,'no','Hold i senere',0),(433062,12030,'da','Hold til senere',0),(433063,12030,'ko','ë‚˜ì¤‘ì— ë³´ë¥˜',0),(433064,12030,'he','. ×× ×™ ××—×–×™×§ ×ž××•×—×¨ ×™×•×ª×¨',0),(433065,12030,'el','Î‘Î½Î±Î¼Î¿Î½Î® Î³Î¹Î± Î±ÏÎ³ÏŒÏ„ÎµÏÎ±',0),(433066,12030,'zh','ä¿æŒè¿Ÿä¸€äº›\r\n',0),(433067,12030,'sv','HÃ¥ll under senare',0),(433068,12030,'it','Tenere premuto per piÃ¹ tardi',0),(433069,12030,'tl','',0),(433070,12030,'th','à¸„à¹‰à¸²à¸‡à¹„à¸§à¹‰à¹ƒà¸™à¸ à¸²à¸¢à¸«à¸¥à¸±à¸‡',0),(433071,12030,'hi','à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚ à¤§à¤¾à¤°à¤£',0),(433072,12030,'ms','Tahan untuk kemudian',0),(433073,12030,'ar','Ø¹Ù‚Ø¯ ÙÙŠ ÙˆÙ‚Øª Ù„Ø§Ø­Ù‚',0),(433074,12030,'fr','Attente pour plus tard',0),(433075,12030,'jp','å¾Œã§ãƒ›ãƒ¼ãƒ«ãƒ‰',0),(433076,12030,'pt','Aguarde mais tarde',0),(433077,12030,'ru','ÐžÑ‚Ð»Ð¾Ð¶ÐµÐ½Ð¾ Ð½Ð° Ð±Ð¾Ð»ÐµÐµ Ð¿Ð¾Ð·Ð´Ð½Ð¸Ð¹ ÑÑ€Ð¾Ðº',0),(433078,12030,'es','Guarda para mÃ¡s tarde',0),(433079,12030,'de','Halten Sie fÃ¼r spÃ¤ter',0),(433080,12030,'en','Hold For Later',0),(433081,12031,'is','',0),(433082,12031,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ùˆ Ù…Ù‚Ø¯Ø§Ø± Ø§Ø±Ø³Ø§Ù„ Ø¨Ø§ÛŒØ¯ ÛŒÚ©ÛŒ Ø§Ø´Ø¯Ø¨ ',0),(433083,12031,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ùˆ Ù…Ù‚Ø¯Ø§Ø± Ø§Ø±Ø³Ø§Ù„ Ø¨Ø§ÛŒØ¯ ÛŒÚ©ÛŒ Ø§Ø´Ø¯Ø¨ ',0),(433084,12031,'tr','SipariÅŸ miktarÄ± ve sevk miktarÄ± eÅŸit olmalÄ±dÄ±r',0),(433085,12031,'pl','WielkoÅ›Ä‡ zamÃ³wienia i iloÅ›Ä‡ statku musi byÄ‡ rÃ³wna',0),(433086,12031,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ñ€Ð°Ð²Ð½Ð¾',0),(433087,12031,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ø§ÙˆØ± Ø¬ÛØ§Ø² Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©Û’ Ø¨Ø±Ø§Ø¨Ø± Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(433088,12031,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð¸ Ð±Ñ€Ð¾Ð´ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ñ˜ÐµÐ´Ð½Ð°Ðº',0),(433089,12031,'vi','Sá»‘ lÆ°á»£ng Ä‘áº·t hÃ ng vÃ  sá»‘ lÆ°á»£ng váº­n chuyá»ƒn pháº£i báº±ng nhau',0),(433090,12031,'af','Bestel hoeveelheid en skip hoeveelheid gelyk moet wees aan',0),(433091,12031,'ro','Cantitate comandÄƒ ÅŸi cantitatea de navÄƒ trebuie sÄƒ egal',0),(433092,12031,'et','Tellimuse kogus ja lÃ¤hetatav kogus peab vÃµrduma',0),(433093,12031,'si','KoliÄina naloga in ladji koliÄina mora biti enaka',0),(433094,12031,'ba','Urutan kuantitas dan kuantitas kapal harus sama',0),(433095,12031,'nl','Bestelhoeveelheid en schip hoeveelheid moeten gelijk zijn aan',0),(433096,12031,'fi','MÃ¤Ã¤rÃ¤ ja LÃ¤hetysmÃ¤Ã¤rÃ¤ on oltava',0),(433097,12031,'no','Bestillingsantall og forsendelsesantallet mÃ¥ vÃ¦re lik',0),(433098,12031,'da','SKAL vÃ¦re lig med ordreantallet og afsendelsesantal',0),(433099,12031,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰ ë° ë°° ìˆ˜ëŸ‰ì„ ë™ì¼ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(433100,12031,'he','×›×ž×•×ª ×”×–×ž× ×” ×•×›×ž×•×ª ×”×¡×¤×™× ×” ×©×•×•×” ×œ-',0),(433101,12031,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¹ÏƒÎ¿ÏÏ„Î±Î¹ Ï€ÏÎ¿Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎºÎ±Î¹ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î»Î¿Î¯Î¿',0),(433102,12031,'zh','è®¢è´§é‡å’Œå‘è´§æ•°é‡å¿…é¡»ç­‰äºŽ\r\n',0),(433103,12031,'sv','Orderkvantiteten och skeppningskvantitet mÃ¥ste vara lika',0),(433104,12031,'it','QuantitÃ  di ordine e nave deve essere uguale',0),(433105,12031,'tl','',0),(433106,12031,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¹à¸¥à¸°à¸›à¸£à¸´à¸¡à¸²à¸“à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸•à¹‰à¸­à¸‡à¹€à¸—à¹ˆà¸²à¸à¸±à¸š',0),(433107,12031,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤”à¤° à¤œà¤¹à¤¾à¤œ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤¬à¤°à¤¾à¤¬à¤° à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(433108,12031,'ms','Kuantiti order dan kuantiti kapal mesti sama',0),(433109,12031,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØ³Ø§ÙˆÙŠ ÙƒÙ…ÙŠØ© Ø£Ù…Ø± Ø§Ù„ØªÙˆØ±ÙŠØ¯ ÙˆÙƒÙ…ÙŠØ© Ø§Ù„Ø´Ø­Ù†',0),(433110,12031,'fr','DOIVENT Ãªtre Ã©gale Ã  la quantitÃ© d\'ordre et de la quantitÃ© de navire',0),(433111,12031,'jp','æ³¨æ–‡æ•°é‡ã€ãŠã‚ˆã³å‡ºè·æ•°é‡ã¨ç­‰ã—ããªã‘ã‚Œã°ãªã‚Šã¾ã›ã‚“',0),(433112,12031,'pt','DEVEM ser igual a quantidade da ordem e quantidade de navio',0),(433113,12031,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÑƒÐ´Ð¾Ð² Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð²Ð½Ð¾',0),(433114,12031,'es','Cantidad de Orden y Cantidad de EnvÃ­o DEBE SER Igual',0),(433115,12031,'de','Bestellmenge und Liefermenge mÃ¼ssen gleich sein.',0),(433116,12031,'en','Order Quantity And Ship Quantity MUST Equal',0),(433117,12032,'is','',0),(433118,12032,'dr','(ÙˆØ¶Ø¹ÛŒØª',0),(433119,12032,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø§Ù„ÛŒØ§Øª Ø§Ø³ØªØ§Ù†(ÙˆØ¶Ø¹ÛŒØª',0),(433120,12032,'tr','Alma durumu vergi veri',0),(433121,12032,'pl','Stan importu danych',0),(433122,12032,'bg','Ð”Ð°Ð½Ð½Ð¸Ñ‚Ðµ Ð·Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð²Ð½Ð¾ÑÐ° Ð´Ð°Ð½ÑŠÐº',0),(433123,12032,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø±ÛŒØ§Ø³ØªÛŒ Ù¹ÛŒÚ©Ø³ ÚˆÛŒÙ¹Ø§',0),(433124,12032,'sr','Ð£Ð²Ð¾Ð· Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(433125,12032,'vi','Nháº­p dá»¯ liá»‡u thuáº¿ chÃ­nh phá»§',0),(433126,12032,'af','Invoer staat belasting Data',0),(433127,12032,'ro','Import statul impozit date',0),(433128,12032,'et','Impordi kÃ¤ibemaksu olekuandmed',0),(433129,12032,'si','Podatke o stanju uvozni davek',0),(433130,12032,'ba','Negara impor pajak Data',0),(433131,12032,'nl','Importeren staat belasting gegevens',0),(433132,12032,'fi','Tuo tilatiedot vero',0),(433133,12032,'no','Import skatt dataene',0),(433134,12032,'da','Import skat Tilstandsdataene',0),(433135,12032,'ko','ê°€ì ¸ì˜¤ê¸° ìƒíƒœ ì„¸ê¸ˆ ë°ì´í„°',0),(433136,12032,'he','× ×ª×•× ×™ ×ž×¡ ×™×™×‘×•× ×ž×¦×‘',0),(433137,12032,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(433138,12032,'zh','å¯¼å…¥å›½å®¶ç¨ŽåŠ¡èµ„æ–™\r\n',0),(433139,12032,'sv','Importera staten skattedata',0),(433140,12032,'it','Dati fiscali dello stato di importazione',0),(433141,12032,'tl','',0),(433142,12032,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ à¸²à¸©à¸µà¸™à¸³à¹€à¸‚à¹‰à¸²à¸£à¸±à¸',0),(433143,12032,'hi','à¤†à¤¯à¤¾à¤¤ à¤°à¤¾à¤œà¥à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¡à¥‡à¤Ÿà¤¾',0),(433144,12032,'ms','Data cukai import Negeri',0),(433145,12032,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©',0),(433146,12032,'fr','Ã‰tat de l\'importation des donnÃ©es fiscales',0),(433147,12032,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆçŠ¶æ…‹ç¨Žãƒ‡ãƒ¼ã‚¿',0),(433148,12032,'pt','Dados do estado de importaÃ§Ã£o do imposto',0),(433149,12032,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(433150,12032,'es','Importar Datos de Impuestos Estatales',0),(433151,12032,'de','Import Steuer Zustandsdaten',0),(433152,12032,'en','Import State Tax Data',0),(433153,12033,'is','',0),(433154,12033,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙˆØ§Ø±Ø¯ Ø´Ø¯',0),(433155,12033,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙˆØ§Ø±Ø¯ Ø´Ø¯',0),(433156,12033,'tr','Alma baÅŸarÄ±lÄ±',0),(433157,12033,'pl','PrzywÃ³z sukces',0),(433158,12033,'bg','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(433159,12033,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(433160,12033,'sr','Ð£Ð²Ð¾Ð· ÑƒÑÐ¿ÐµÑˆÐ°Ð½',0),(433161,12033,'vi','Nháº­p thÃ nh cÃ´ng',0),(433162,12033,'af','Invoer is suksesvol',0),(433163,12033,'ro','Import de succes',0),(433164,12033,'et','Importimine Ãµnnestus',0),(433165,12033,'si','UspeÅ¡en uvoz',0),(433166,12033,'ba','Impor sukses',0),(433167,12033,'nl','Import succesvolle',0),(433168,12033,'fi','Tuonti onnistui',0),(433169,12033,'no','Vellykket import',0),(433170,12033,'da','Import vellykket',0),(433171,12033,'ko','ê°€ì ¸ì˜¤ê¸° ì„±ê³µ',0),(433172,12033,'he','×™×™×‘×•× ×ž×•×¦×œ×—',0),(433173,12033,'el','Î•Ï€Î¹Ï„Ï…Ï‡Î®Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(433174,12033,'zh','å¯¼å…¥æˆåŠŸ\r\n',0),(433175,12033,'sv','Importen har slutforts',0),(433176,12033,'it','Importazione di successo',0),(433177,12033,'tl','',0),(433178,12033,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(433179,12033,'hi','à¤†à¤¯à¤¾à¤¤ à¤¸à¤«à¤²',0),(433180,12033,'ms','Import berjaya',0),(433181,12033,'ar','ØªÙ… Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(433182,12033,'fr','Importation rÃ©ussie',0),(433183,12033,'jp','æ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã¾ã—ãŸ',0),(433184,12033,'pt','ImportaÃ§Ã£o bem sucedida',0),(433185,12033,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(433186,12033,'es','ImportaciÃ³n Exitosa',0),(433187,12033,'de','Import erfolgreich',0),(433188,12033,'en','Import Successful',0),(433189,12034,'is','',0),(433190,12034,'dr','SDI ',0),(433191,12034,'pr','SDI ',0),(433192,12034,'tr','SDI',0),(433193,12034,'pl','SDI',0),(433194,12034,'bg','SDI',0),(433195,12034,'ur','SDI',0),(433196,12034,'sr','Ð¡Ð”Ð›',0),(433197,12034,'vi','SDI',0),(433198,12034,'af','SDI',0),(433199,12034,'ro','SDI',0),(433200,12034,'et','SDI',0),(433201,12034,'si','SDI',0),(433202,12034,'ba','SDI',0),(433203,12034,'nl','SDI',0),(433204,12034,'fi','SDI',0),(433205,12034,'no','SDI',0),(433206,12034,'da','SDI',0),(433207,12034,'ko','SDI',0),(433208,12034,'he','SDI',0),(433209,12034,'el','SDI',0),(433210,12034,'zh','å›½å®¶ä¼¤æ®‹ä¿é™©\r\n',0),(433211,12034,'sv','SDI',0),(433212,12034,'it','SDI',0),(433213,12034,'tl','',0),(433214,12034,'th','à¸ à¸²à¸žà¸¢à¸™à¸•à¸£à¹Œ',0),(433215,12034,'hi','SDI',0),(433216,12034,'ms','SDI',0),(433217,12034,'ar','Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙƒØ§Ù†ÙŠØ©',0),(433218,12034,'fr','SDI',0),(433219,12034,'jp','SDI',0),(433220,12034,'pt','SDI',0),(433221,12034,'ru','SDI',0),(433222,12034,'es','SDI',0),(433223,12034,'de','SDI',0),(433224,12034,'en','SDI',0),(433225,12035,'is','',0),(433226,12035,'dr','.. ',0),(433227,12035,'pr','Ø§Ø¹Ù„Ø§Ù….. ',0),(433228,12035,'tr','Devlet SDI',0),(433229,12035,'pl','PaÅ„stwa SDI',0),(433230,12035,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ SDI',0),(433231,12035,'ur','Ø±ÛŒØ§Ø³ØªÛŒ SDI',0),(433232,12035,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¡Ð”Ð›',0),(433233,12035,'vi','Tiá»ƒu bang SDI',0),(433234,12035,'af','Staat SDI',0),(433235,12035,'ro','Stat SDI',0),(433236,12035,'et','Riigi SDI',0),(433237,12035,'si','DrÅ¾avna SDI',0),(433238,12035,'ba','SDI negara',0),(433239,12035,'nl','Staat SDI',0),(433240,12035,'fi','Valtion SDI',0),(433241,12035,'no','Statlige SDI',0),(433242,12035,'da','Statslige SDI',0),(433243,12035,'ko','ì£¼ SDI',0),(433244,12035,'he','×ž×¡×™ ×”×ž×“×™× ×”',0),(433245,12035,'el','ÎšÏÎ±Ï„Î¹ÎºÎ­Ï‚ SDI',0),(433246,12035,'zh','å›½å®¶ä¿¡æ¯é€‰æ‹©ä¼ å¸ƒ',0),(433247,12035,'sv','Statliga SDI',0),(433248,12035,'it','Stato SDI',0),(433249,12035,'tl','',0),(433250,12035,'th','à¸ à¸²à¸žà¸¢à¸™à¸•à¸£à¹Œà¸£à¸±à¸',0),(433251,12035,'hi','à¤°à¤¾à¤œà¥ à¤¯ SDI',0),(433252,12035,'ms','SDI Negeri',0),(433253,12035,'ar','SDI Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(433254,12035,'fr','SDI Ã‰tat',0),(433255,12035,'jp','çŠ¶æ…‹ã® SDI',0),(433256,12035,'pt','Estado SDI',0),(433257,12035,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ SDI',0),(433258,12035,'es','SDI de Estado',0),(433259,12035,'de','Staatliche SDI',0),(433260,12035,'en','State SDI',0),(433261,12036,'is','',0),(433262,12036,'dr','Ù…Ø¨Ù„Øº Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(433263,12036,'pr','Ù…Ø¨Ù„Øº Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(433264,12036,'tr','Birim baÅŸÄ±na tutar',0),(433265,12036,'pl','Kwota na jednostkÄ™',0),(433266,12036,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(433267,12036,'ur','ÙÛŒ ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ø±Ù‚Ù…',0),(433268,12036,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(433269,12036,'vi','Sá»‘ tiá»n má»—i Ä‘Æ¡n vá»‹',0),(433270,12036,'af','Bedrag per eenheid',0),(433271,12036,'ro','SumÄƒ pe unitate',0),(433272,12036,'et','Arvutamismeetod summa Ã¼hiku kohta',0),(433273,12036,'si','Znesek na enoto',0),(433274,12036,'ba','Jumlah per Unit',0),(433275,12036,'nl','Bedrag per eenheid',0),(433276,12036,'fi','Summa per yksikkÃ¶',0),(433277,12036,'no','BelÃ¸p per enhet',0),(433278,12036,'da','BelÃ¸b pr. enhed',0),(433279,12036,'ko','ë‹¨ìœ„ë‹¹ ê¸ˆì•¡',0),(433280,12036,'he','×›×ž×•×ª ×œ×™×—×™×“×”',0),(433281,12036,'el','Î Î¿ÏƒÏŒ Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î±',0),(433282,12036,'zh','æ¯å•ä½é‡‘é¢\r\n',0),(433283,12036,'sv','Belopp per enhet',0),(433284,12036,'it','Importo unitario',0),(433285,12036,'tl','',0),(433286,12036,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸•à¹ˆà¸­à¸«à¸™à¹ˆà¸§à¸¢',0),(433287,12036,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤•à¤¾à¤ˆ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(433288,12036,'ms','Jumlah seunit',0),(433289,12036,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù„ÙƒÙ„ ÙˆØ­Ø¯Ø©',0),(433290,12036,'fr','QuantitÃ© par unitÃ©',0),(433291,12036,'jp','å˜ä½ã‚ãŸã‚Šã®é‡‘é¡',0),(433292,12036,'pt','Quantidade por unidade',0),(433293,12036,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð·Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(433294,12036,'es','Monto por Unidad',0),(433295,12036,'de','Betrag pro Einheit',0),(433296,12036,'en','Amount per Unit',0),(433297,12037,'is','',0),(433298,12037,'dr','Ú©Ø§Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(433299,12037,'pr','Ú©Ø§Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(433300,12037,'tr','Ä°ÅŸ girilen',0),(433301,12037,'pl','Zadanie wpisane',0),(433302,12037,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð°, Ð²Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð²',0),(433303,12037,'ur','Ø¬Ø§Ø¨ Ø¯Ø§Ø®Ù„ ÛÙˆØ§',0),(433304,12037,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ ÑƒÐ½ÐµÑ‚ Ñƒ',0),(433305,12037,'vi','VÃ o cÃ´ng viá»‡c',0),(433306,12037,'af','Werk ingeskryf',0),(433307,12037,'ro','A intrat la Job',0),(433308,12037,'et','TÃ¶Ã¶ kantud',0),(433309,12037,'si','Delo, vpisana',0),(433310,12037,'ba','Pekerjaan yang dimasukkan pada',0),(433311,12037,'nl','Baan ingevoerd op',0),(433312,12037,'fi','TyÃ¶ tuli',0),(433313,12037,'no','Jobb gikk inn',0),(433314,12037,'da','Job angivet pÃ¥',0),(433315,12037,'ko','ìž‘ì—… ìž…ë ¥',0),(433316,12037,'he','×”×¢×‘×•×“×” ×©×”×•×–× ×•',0),(433317,12037,'el','Î”Î¿Ï…Î»ÎµÎ¹Î¬, Î¬ÏÏ‡Î¹ÏƒÎµ Ï„Î·Î½',0),(433318,12037,'zh','è¿›å…¥æ‹›è˜\r\n',0),(433319,12037,'sv','Jobbet som angetts',0),(433320,12037,'it','Lavoro immesso',0),(433321,12037,'tl','',0),(433322,12037,'th','à¸›à¹‰à¸­à¸™à¸‡à¸²à¸™',0),(433323,12037,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¤° à¤¦à¤°à¥à¤œ',0),(433324,12037,'ms','Kerja yang dimasukkan pada',0),(433325,12037,'ar','Ø¯Ø®Ù„Øª Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(433326,12037,'fr','Job est entrÃ© le',0),(433327,12037,'jp','ä»•äº‹å…¥åŠ›',0),(433328,12037,'pt','Trabalho entrou em',0),(433329,12037,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»Ð°',0),(433330,12037,'es','Entrado el trabajo',0),(433331,12037,'de','Stelle getreten',0),(433332,12037,'en','Job Entered On',0),(433333,12038,'is','',0),(433334,12038,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(433335,12038,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(433336,12038,'tr','KullanÄ±lan maliyet',0),(433337,12038,'pl','Poniesiony koszt',0),(433338,12038,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²ÐµÐ½Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(433339,12038,'ur','Ø®Ø±Ú† Ú©Ø±ØªÛ’ ØªÚ¾Û’',0),(433340,12038,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº ÐºÐ¾Ñ˜Ð¸ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(433341,12038,'vi','chi phÃ­ Ä‘Æ°á»£c sá»­ dá»¥ng',0),(433342,12038,'af','Koste gebruik',0),(433343,12038,'ro','Costul utilizate',0),(433344,12038,'et','Kasutatud maksumus',0),(433345,12038,'si','StroÅ¡ki, ki se uporablja',0),(433346,12038,'ba','Biaya yang digunakan',0),(433347,12038,'nl','Kosten gebruikt',0),(433348,12038,'fi','KÃ¤ytetyt kustannukset',0),(433349,12038,'no','Kostnadene brukt',0),(433350,12038,'da','Omkostninger bruges',0),(433351,12038,'ko','ì‚¬ìš© ë¹„ìš©',0),(433352,12038,'he','×¢×œ×•×ª ×©×™×ž×•×©',0),(433353,12038,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®Î¸Î·ÎºÎµ',0),(433354,12038,'zh','ä½¿ç”¨æˆæœ¬\r\n',0),(433355,12038,'sv','Kostnaden anvÃ¤nds',0),(433356,12038,'it','Costo usato',0),(433357,12038,'tl','',0),(433358,12038,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸—à¸µà¹ˆà¹ƒà¸Šà¹‰',0),(433359,12038,'hi','à¤ªà¥à¤°à¤¯à¥à¤•à¥à¤¤ à¤²à¤¾à¤—à¤¤',0),(433360,12038,'ms','Kos yang digunakan',0),(433361,12038,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(433362,12038,'fr','CoÃ»t utilisÃ©',0),(433363,12038,'jp','ä½¿ç”¨ã‚³ã‚¹ãƒˆ',0),(433364,12038,'pt','Custo usado',0),(433365,12038,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(433366,12038,'es','Costo Usado',0),(433367,12038,'de','Kosten verwendet',0),(433368,12038,'en','Cost Used',0),(433369,12039,'is','',0),(433370,12039,'dr','Ù…Ø¨Ù„Øº Ø¯Ø± Ù‡Ø²Ø§Ø±Ø§Ù†',0),(433371,12039,'pr','Ù…Ø¨Ù„Øº Ø¯Ø± Ù‡Ø²Ø§Ø±Ø§Ù†',0),(433372,12039,'tr','Binlerce tutarlarÄ±',0),(433373,12039,'pl','Kwoty w tysiÄ…cach',0),(433374,12039,'bg','Ð¡ÑƒÐ¼Ð¸Ñ‚Ðµ Ð² Ñ…Ð¸Ð»ÑÐ´Ð¸',0),(433375,12039,'ur','Ù…Ù‚Ø¯Ø§Ø± ÛØ²Ø§Ø±ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù…ÛŒÚº',0),(433376,12039,'sr','Ð˜Ð·Ð½Ð¾ÑÐµ Ñƒ Ñ…Ð¸Ñ™Ð°Ð´Ð°Ð¼Ð°',0),(433377,12039,'vi','Sá»‘ tiá»n trong hÃ ng ngÃ n',0),(433378,12039,'af','Bedrae In duisende',0),(433379,12039,'ro','Sumele Ã®n mii',0),(433380,12039,'et','Summad tuhandetes',0),(433381,12039,'si','Zneski v tisoÄih',0),(433382,12039,'ba','Jumlah ribuan',0),(433383,12039,'nl','Bedragen In duizenden',0),(433384,12039,'fi','Summat tuhansina',0),(433385,12039,'no','BelÃ¸pene i tusenvis',0),(433386,12039,'da','BelÃ¸bene i tusindvis',0),(433387,12039,'ko','ì²œ ë‹¨ìœ„ ê¸ˆì•¡',0),(433388,12039,'he','×›×ž×•×™×•×ª ×‘××œ×¤×™×',0),(433389,12039,'el','Î Î¿ÏƒÎ¬ ÏƒÎµ Ï‡Î¹Î»Î¹Î¬Î´ÎµÏ‚',0),(433390,12039,'zh','é‡‘é¢å•ä½ï¼šåƒ\r\n',0),(433391,12039,'sv','Belopp i tusental',0),(433392,12039,'it','Importi In migliaia',0),(433393,12039,'tl','',0),(433394,12039,'th','à¸ˆà¸³à¸™à¸§à¸™à¹ƒà¸™à¸«à¸¥à¸±à¸à¸žà¸±à¸™',0),(433395,12039,'hi','à¤¹à¤œà¤¾à¤°à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤®à¥‡à¤‚ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(433396,12039,'ms','Jumlah dalam beribu-ribu',0),(433397,12039,'ar','Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø¨Ø¢Ù„Ø§Ù',0),(433398,12039,'fr','Montants en milliers',0),(433399,12039,'jp','ä½•åƒã‚‚ã®é‡‘é¡',0),(433400,12039,'pt','Montantes expressos em milhares',0),(433401,12039,'ru','Ð¡ÑƒÐ¼Ð¼Ñ‹ Ð² Ñ‚Ñ‹ÑÑÑ‡Ð°Ñ…',0),(433402,12039,'es','Monto en Miles',0),(433403,12039,'de','BetrÃ¤ge In Tsd.',0),(433404,12039,'en','Amounts In Thousands',0),(433405,12040,'is','',0),(433406,12040,'dr','Ù‡ÛŒÚ† Ù¾ÛŒØºØ§Ù…ÛŒ',0),(433407,12040,'pr','Ù‡ÛŒÚ† Ù¾ÛŒØºØ§Ù…ÛŒ',0),(433408,12040,'tr','Mesaj yok',0),(433409,12040,'pl','Brak wiadomoÅ›ci',0),(433410,12040,'bg','ÐÑÐ¼Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(433411,12040,'ur','Ú©ÙˆØ¦ÛŒ Ù¾ÛŒØºØ§Ù… Ù†ÛÛŒÚº',0),(433412,12040,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ€ÑƒÐºÐ°',0),(433413,12040,'vi','khÃ´ng tin nháº¯n',0),(433414,12040,'af','Geen boodskappe nie',0),(433415,12040,'ro','Nu existÄƒ mesaje',0),(433416,12040,'et','Ãœhtegi sÃµnumit',0),(433417,12040,'si','Å t sporoÄil',0),(433418,12040,'ba','Tidak ada pesan',0),(433419,12040,'nl','Geen berichten',0),(433420,12040,'fi','Ei viestejÃ¤',0),(433421,12040,'no','Ingen meldinger',0),(433422,12040,'da','Ingen meddelelser',0),(433423,12040,'ko','ë©”ì‹œì§€ ì—†ìŒ',0),(433424,12040,'he','××™×Ÿ ×”×•×“×¢×•×ª',0),(433425,12040,'el','Î§Ï‰ÏÎ¯Ï‚ Î¼Î·Î½ÏÎ¼Î±Ï„Î±',0),(433426,12040,'zh','æ²¡æœ‰æ¶ˆæ¯\r\n',0),(433427,12040,'sv','Inga meddelanden',0),(433428,12040,'it','Nessun messaggio',0),(433429,12040,'tl','',0),(433430,12040,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¹„à¸¡à¹ˆ',0),(433431,12040,'hi','à¤•à¥‹à¤ˆ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤¨à¤¹à¥€à¤‚',0),(433432,12040,'ms','Tiada mesej-mesej',0),(433433,12040,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø±Ø³Ø§Ø¦Ù„',0),(433434,12040,'fr','Pas de Messages',0),(433435,12040,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(433436,12040,'pt','NÃ£o hÃ¡ mensagens',0),(433437,12040,'ru','ÐÐµÑ‚ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹',0),(433438,12040,'es','No Hay Mensajes',0),(433439,12040,'de','Keine Nachrichten',0),(433440,12040,'en','No Messages',0),(433441,12041,'is','',0),(433442,12041,'dr','<b>Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ù‡Ø§ÛŒ</b> ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ø§Ø®ØªÛŒØ§Ø±ÛŒ Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø§Ø±Ø§Ø¦Ù‡ Ù‚Ø§Ø¨Ù„ÛŒØª Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ Ø±Ø§ ÙØ¹Ø§Ù„ Ø¯Ø§Ø±Ø¯.<p>ÙØ±Ø§ÛŒÙ†Ø¯ ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒ Ø¨Ø³ÛŒØ§Ø± Ø³Ø§Ø¯Ù‡ Ø§Ø³Øª:<ul>&#xD;\n	<li>Ø®Ø±ÛŒØ¯ Ø±Ø§ Ú©Ù„',0),(433443,12041,'pr','<b>Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ù‡Ø§ÛŒ</b> ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ø§Ø®ØªÛŒØ§Ø±ÛŒ Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø§Ø±Ø§Ø¦Ù‡ Ù‚Ø§Ø¨Ù„ÛŒØª Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ Ø±Ø§ ÙØ¹Ø§Ù„ Ø¯Ø§Ø±Ø¯.<p>ÙØ±Ø§ÛŒÙ†Ø¯ ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒ Ø¨Ø³ÛŒØ§Ø± Ø³Ø§Ø¯Ù‡ Ø§Ø³Øª:<ul>&#xD;\n	<li>Ø®Ø±ÛŒØ¯ Ø±Ø§ Ú©Ù„',0),(433444,12041,'tr','<b>Eklentileri</b> vardÄ±r isteÄŸe baÄŸlÄ± Ã¶zellikleri ekstra yetenekleri saÄŸlamak iÃ§in etkinleÅŸtirebilirsiniz.<p>Harekete geÃ§irmek, Ã§ok basit bir iÅŸlemdir:<ul>&#xD;\n	<li>Eklemek-on/fiÅŸi-ilgilendiÄŸiniz in iÃ§in satÄ±n alma dÃ¼ÄŸmesini tÄ±klatÄ±n.',0),(433445,12041,'pl','<b>Dodatki</b> sÄ… opcjonalne funkcje, ktÃ³re moÅ¼na aktywowaÄ‡, aby zapewniÄ‡ dodatkowe moÅ¼liwoÅ›ci.<p>Proces aktywacji jest bardzo proste:<ul>&#xD;\n	<li>Kliknij przycisk Kup dla Add-on-na/plug-w ktÃ³rym jesteÅ› zainteresowany.</li>&#xD;\n	<li>Po zakupie',0),(433446,12041,'bg','<b>Ð”Ð¾Ð±Ð°Ð²ÐºÐ¸Ñ‚Ðµ</b> ÑÐ° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸, Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð¸ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð²ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð¾ÑÑ‚Ð¸.<p>ÐŸÑ€Ð¾Ñ†ÐµÑÑŠÑ‚ Ð½Ð° Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ðµ Ð¼Ð½Ð¾Ð³Ð¾ Ð¿Ñ€Ð¾ÑÑ‚',0),(433447,12041,'ur','<b>Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª</b> Ø¢Ù¾ Ø§Ø¶Ø§ÙÛŒ ØµÙ„Ø§Ø­ÛŒØªÙˆÚº Ú©Ùˆ ÙØ±Ø§ÛÙ… Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…ØªØ­Ø±Ú© Ú©Ø± Ø§Ø®ØªÛŒØ§Ø±ÛŒ Ø®ØµÙˆØµÛŒØ§Øª ÛÛŒÚº.<p>Ù…ØªØ­Ø±Ú© Ú©Ø§Ø±ÛŒ Ø¹Ù…Ù„ Ø¨ÛØª Ø³Ø§Ø¯Û ÛÛ’:<ul>&#xD;\n	<li>Ú©Û’ Ù„Ø¦Û’ add-on/Ù¾Ù„ÙˆÚ¯-Ø¢Ù¾ Ù…Û',0),(433448,12041,'sr','<b>Ð”Ð¾Ð´Ð°Ñ†Ð¸</b> ÑÑƒ Ð¾Ð¿Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¿Ñ€ÑƒÐ¶Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ð½Ð¾ÑÑ‚Ð¸.<p>ÐŸÑ€Ð¾Ñ†ÐµÑ Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ñ˜Ðµ Ñ˜Ðµ Ð²Ñ€Ð»Ð¾ Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚Ð°Ð²Ð°Ð½:<ul>&#xD;\n	<li>ÐšÐ»Ð¸ÐºÐ½Ð¸',0),(433449,12041,'vi','<b>Tiá»‡n Ã­ch</b> lÃ  tÃ­nh nÄƒng tÃ¹y chá»n báº¡n cÃ³ thá»ƒ kÃ­ch hoáº¡t Ä‘á»ƒ cung cáº¥p kháº£ nÄƒng phá»¥.<p>QuÃ¡ trÃ¬nh kÃ­ch hoáº¡t lÃ  ráº¥t Ä‘Æ¡n giáº£n:<ul>&#xD;\n	<li>Nháº¥p vÃ o nÃºt mua cho add-on/plug-in-trong quÃ½ vá»‹ muá»‘n cÃ³.</li>&#xD;\n',0),(433450,12041,'af','<b>Byvoegings</b> is opsionele kenmerke jy verskaf ekstra vermoÃ«ns kan aktiveer.<p>Die aktivering proses is baie eenvoudig:<ul>&#xD;\n	<li>Klik die knoppie van aankoop vir die add-on/plug-in jy in belangstel.</li>&#xD;\n	<li>Na die funksie te koop jy</li><',0),(433451,12041,'ro','<b>Suplimente</b> sunt caracteristici opÅ£ional puteÅ£i activa pentru a furniza capabilitÄƒÅ£i suplimentare.<p>Procesul de activare este foarte simplu:<ul>&#xD;\n	<li>FaceÅ£i clic pe butonul de cumpÄƒrare pentru add-on-la/plug-in-in vÄƒ intereseazÄƒ.</li>&',0),(433452,12041,'et','<b>Lisandmoodulid</b> on lisafunktsioon saate aktiveerida osutamise eest vÃµimeid.<p>Aktiveerimise protsess on vÃ¤ga lihtne:<ul>&#xD;\n	<li>Jaoks on add-teisel/plug-in-all-in olete huvitatud ostmist-nuppu.</li>&#xD;\n	<li>PÃ¤rast ostu funktsioon teil</li></',0),(433453,12041,'si','<b>Dodatki</b> so neobvezne funkcije, lahko aktivirate zagotoviti dodatne zmogljivosti.<p>Postopek aktiviranja je zelo preprosta:<ul>&#xD;\n	<li>Kliknite gumb nakup za v poveÄati-na/plug-in-v vas zanima.</li>&#xD;\n	<li>Po nakupu zunanja oblika ste</li></u',0),(433454,12041,'ba','<b>Pengaya</b> yang fitur opsional yang dapat Anda Aktifkan untuk memberikan kemampuan tambahan.<p>Proses aktivasi ini sangat sederhana:<ul>&#xD;\n	<li>Klik tombol pembelian untuk add-pada/plug-in-in Anda tertarik.</li>&#xD;\n	<li>Setelah membeli fitur Anda',0),(433455,12041,'nl','<b>Add-Ons</b> zijn facultatieve voorzieningen die u kunt activeren om te bieden extra mogelijkheden.<p>Het activeringsproces is heel eenvoudig:<ul>&#xD;\n	<li>Klik op de button aankoop voor de invoegtoepassing-op/plug-in-in die u in geinteresseerd bent.</',0),(433456,12041,'fi','<b>LisÃ¤osat</b> ovat valinnaisia ominaisuuksia voit aktivoida tarjoamaan lisÃ¤ominaisuuksia.<p>Aktivointi on hyvin yksinkertainen:<ul>&#xD;\n	<li>Valitse Osta-painiketta varten add-on-alusten/plug-in-kotona olet kiinnostunut.</li>&#xD;\n	<li>Kun ostaa omin',0),(433457,12041,'no','<b>Tillegg</b> er valgfrie funksjoner du kan aktivere for Ã¥ gi ekstra evnene.<p>Aktiveringsprosessen er svÃ¦rt enkel:<ul>&#xD;\n	<li>Klikk KjÃ¸p for add-on-pÃ¥/plug-in-i du er interessert i.</li>&#xD;\n	<li>Etter Ã¥ kjÃ¸pe funksjonen du</li></ul>',0),(433458,12041,'da','<b>TilfÃ¸jelser</b> er valgfrie funktioner du kan aktivere for at give ekstra kapacitet.<p>Aktiveringsprocessen er meget enkel:<ul>&#xD;\n	<li>Klik pÃ¥ knappen KÃ¸b for de add-on-on/plug-in-i du er interesseret i.</li>&#xD;\n	<li>Efter at have kÃ¸bt funktio',0),(433459,12041,'ko','<b>ì¶”ê°€ ê¸°ëŠ¥</b> ì˜µì…˜ ê¸°ëŠ¥ì„ ì œê³µ í•˜ëŠ” ì¶”ê°€ ê¸°ëŠ¥ì„ í™œì„±í™”í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p>ì •í’ˆ ì¸ì¦ ê³¼ì •ì€ ë§¤ìš° ê°„ë‹¨:<ul>&#xD;\n	<li>ì— ì¶”ê°€-ì—/í”ŒëŸ¬ê·¸ ì¸ì— ê´€ì‹¬ì´ ìžˆë‹¤ë©´ì— ëŒ€ í•œ êµ¬ë§¤ ë²„íŠ¼ì„ í´ë¦­ í•©ë‹ˆë‹¤.</l',0),(433460,12041,'he','<b>×”×¨×—×‘×•×ª</b> ×”×Ÿ ×ª×›×•× ×•×ª ××•×¤×¦×™×•× ×œ×™×•×ª ×©×‘××¤×©×¨×•×ª×š ×œ×”×¤×¢×™×œ ×›×“×™ ×œ×¡×¤×§ ×™×›×•×œ×•×ª × ×•×¡×¤×•×ª.<p>×ª×”×œ×™×š ×”×”×¤×¢×œ×” ×¤×©×•×˜×” ×ž××•×“:<ul>&#xD;\n	<li>×œ×—×¥ ×¢×œ ×œ×—×¦×Ÿ ×¨×›×™×©×” ×¢×‘×•×¨ add-×¢×œ/×©×§×¢-i',0),(433461,12041,'el','<b>Î ÏÏŒÏƒÎ¸ÎµÏ„Î±</b> ÎµÎ¯Î½Î±Î¹ Ï€ÏÎ¿Î±Î¹ÏÎµÏ„Î¹ÎºÎ­Ï‚ Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„ÎµÏ‚ Ï€Î¿Ï… Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î³Î¹Î± Î½Î± Ï€Î±ÏÎ­Ï‡ÎµÎ¹ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„ÎµÏ‚.<p>The Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î´Î¹Î±Î´Î',0),(433462,12041,'zh','æä¾›å…¶ä»–åŠŸèƒ½çš„å¯é€‰æ‹©æ¿€æ´»é¡¹ã€‚\r\næ¿€æ´»ç¨‹åºååˆ†ç®€å•ï¼šç‚¹å‡»â€œè´­ä¹°â€é”®æ’å…¥ä½ æ‰€æ„Ÿå…´è¶£çš„æ’ä»¶ã€‚è´­ä¹°è¯¥åŠŸèƒ½åŽ',0),(433463,12041,'sv','<b>TillÃ¤gg</b> Ã¤r valfria funktioner som du kan aktivera fÃ¶r att ge extra kapacitet.<p>Aktiveringsprocessen Ã¤r mycket enkel:<ul>&#xD;\n	<li>Klicka pÃ¥ knappen kÃ¶p fÃ¶r i tillÃ¤gg-pÃ¥/plug-in-i du Ã¤r intresserad.</li>&#xD;\n	<li>Efter att ha kÃ¶pt funk',0),(433464,12041,'it','<b>Componenti aggiuntivi</b> sono caratteristiche opzionali che Ã¨ possibile attivare per fornire funzionalitÃ  aggiuntive.<p>Il processo di attivazione Ã¨ molto semplice:<ul>&#xD;\n	<li>Clicca sul pulsante di acquisto per l\'add-on/plug-in che si Ã¨ intere',0),(433465,12041,'tl','',0),(433466,12041,'th','<b>Add-on</b>à¸„à¸·à¸­à¸„à¸¸à¸“à¸¥à¸±à¸à¸©à¸“à¸°à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸„à¸¸à¸“à¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¹€à¸žà¸·à¹ˆà¸­à¹ƒà¸«à¹‰à¸¡à¸µà¸„à¸§à¸²à¸¡à¸ªà¸²à¸¡à¸²à¸£à¸–à¸žà¸´à¹€à¸¨à¸©<p>à¸à¸²à¸£à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¹„à¸',0),(433467,12041,'hi','<b>à¤à¤¡-à¤‘à¤¨à¥à¤¸</b> à¤µà¥ˆà¤•à¤²à¥à¤ªà¤¿à¤• à¤¸à¥à¤µà¤¿à¤§à¤¾à¤“à¤‚ à¤†à¤ª à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤•à¥à¤·à¤®à¤¤à¤¾à¤“à¤‚ à¤ªà¥à¤°à¤¦à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤<p>à¤¸à¤•à¥à¤°à¤¿à¤¯',0),(433468,12041,'ms','<b>Tambahan</b> adalah ciri-ciri pilihan yang boleh anda aktifkan untuk menyediakan keupayaan tambahan.<p>Proses pengaktifan adalah sangat mudah:<ul>&#xD;\n	<li>Klik butang pembelian untuk di add-atas/plug-dalam anda berminat.</li>&#xD;\n	<li>Selepas membel',0),(433469,12041,'ar','<b>Ø§Ù„ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©</b> Ù‡ÙŠ Ù…ÙŠØ²Ø§Øª Ø§Ø®ØªÙŠØ§Ø±ÙŠØ© ÙŠÙ…ÙƒÙ†Ùƒ ØªÙ†Ø´ÙŠØ· Ù„ØªÙˆÙÙŠØ± Ù‚Ø¯Ø±Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ©.<p>Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ØªÙ†Ø´ÙŠØ· Ø¨Ø³ÙŠØ· Ø¬Ø¯Ø§Ù‹:<ul>&#xD;\n	<li>Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„Ø²Ø± Ø´Ø±Ø§Ø¡ Ù„Ø¥Ø¶Ø§ÙØ© Ø¹Ù„Ù‰/ØªÙˆØµÙŠ',0),(433470,12041,'fr','<b>Modules</b> sont des fonctionnalitÃ©s facultatives, vous pouvez activer pour fournir des capacitÃ©s supplÃ©mentaires.<p>Le processus d\'activation est trÃ¨s simple :<ul>&#xD;\n	<li>Cliquez sur le bouton acheter pour l\'add-on/plug-in que vous intÃ©resse.<',0),(433471,12041,'jp','<b>ã‚¢ãƒ‰ã‚ªãƒ³</b>ã¯ã€ä½™åˆ†ãªæ©Ÿèƒ½ã‚’æä¾›ã™ã‚‹ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã«ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã®æ©Ÿèƒ½ã§ã™ã€‚<p>ãƒ©ã‚¤ã‚»ãƒ³ã‚¹èªè¨¼ãƒ—ãƒ­ã‚»ã‚¹ã¯éžå¸¸ã«ç°¡å˜ã§ã™ï¼š<ul>&#xD;\n	<li>è¿½åŠ -ä¸Šã®ãƒ—ãƒ©ã‚°ã‚¤ãƒ³ ãƒ»ã«èˆˆå‘³ãŒ',0),(433472,12041,'pt','<b>Complementos</b> sÃ£o recursos opcionais que vocÃª pode ativar para fornecer recursos extras.<p>O processo de ativaÃ§Ã£o Ã© muito simples:<ul>&#xD;\n	<li>Clique no botÃ£o de compra para o add-on/plug-in que lhe interessam.</li>&#xD;\n	<li>Depois de compr',0),(433473,12041,'ru','<b>Ð”Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ</b> ÑÐ²Ð»ÑÑŽÑ‚ÑÑ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ÑÑ‚Ð¸, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð¼Ð¾Ð¶Ð½Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ð»Ñ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ÑÑ‚ÐµÐ¹.<p>ÐŸÑ€Ð¾Ñ†ÐµÑÑ',0),(433474,12041,'es','<b>Add-ons</b> son opcionales, se puede activar para proporcionar funcionalidades adicionales.<p>El proceso de activaciÃ³n es muy sencillo:<ul>&#xD;\n	<li>Haga clic en el botÃ³n comprar para el add-on/plug-in que te interesa.</li>&#xD;\n	<li>DespuÃ©s de com',0),(433475,12041,'de','<b>Add-ons</b> sind optionale Features, die Sie aktivieren kÃ¶nnen, um zusÃ¤tzliche Funktionen bereitzustellen.<p>Der Aktivierungsprozess ist ganz einfach:<ul>&#xD;\n	<li>Klicken Sie auf kaufen, fÃ¼r das add-on/plug-in, die Sie sich interessieren.</li>&#xD',0),(433476,12041,'en','<b>Add-Ons</b> are optional features you can activate to provide extra capabilities.<p>  \r\nThe activation process is very simple:\r\n	<ul>\r\n	<li>Click the purchase button for the add-on/plug-in you are interested in.</li>\r\n	<li>After buying the feature you ',0),(433477,12042,'is','',0),(433478,12042,'dr','Soc Ø«Ø§Ù†ÛŒÙ‡ / Ø§Ø®Ø±Ø§Ø¬ Ø´Ù†Ø§Ø³Ù‡ #',0),(433479,12042,'pr','Soc Ø«Ø§Ù†ÛŒÙ‡ / Ø§Ø®Ø±Ø§Ø¬ Ø´Ù†Ø§Ø³Ù‡ #',0),(433480,12042,'tr','SoC sn / Govt kimlik #',0),(433481,12042,'pl','SOC s / Govt ID #',0),(433482,12042,'bg','SOC Sec / Ð»ÐµÐ²Ð¾Ð²Ð¸ ID #',0),(433483,12042,'ur','Ú© Ø³ÛŒÚ©Ù†Úˆ / Ø­Ú©ÙˆÙ…Øª Ø´Ù†Ø§Ø®Øª Ù†Ù…Ø¨Ø±',0),(433484,12042,'sr','Ð¨Ð¾Ñ› Ð¡ÐµÑ† / Ð“Ð¾Ð²Ñ‚ Ð˜Ð” #',0),(433485,12042,'vi','Soc Sec / Govt ID #',0),(433486,12042,'af','-SOC-Art / Govt ID #',0),(433487,12042,'ro','Soc Sec / guvern ID #',0),(433488,12042,'et','SOC Sec / Govt ID #',0),(433489,12042,'si','SOC Sec / Govt ID #',0),(433490,12042,'ba','SOC Sec / pemerintah ID #',0),(433491,12042,'nl','Soc Sec / Govt ID #',0),(433492,12042,'fi','SOC Sec / Govt ID #',0),(433493,12042,'no','SoC sek / Govt ID #',0),(433494,12042,'da','Soc sek / Govt ID #',0),(433495,12042,'ko','Soc ì´ˆ / ì •ë¶€ ID #',0),(433496,12042,'he','×©× ×™×” Soc / Govt ×ž×–×”×” #',0),(433497,12042,'el','SOC Sec / Govt ID #',0),(433498,12042,'zh','Soc Sec / æ”¿åºœ ID #',0),(433499,12042,'sv','Soc SEK / prop ID #',0),(433500,12042,'it','SoC Sec / Govt ID #',0),(433501,12042,'tl','',0),(433502,12042,'th','Soc à¸§à¸´à¸™à¸²à¸—à¸µ / Govt à¸£à¸«à¸±à¸ª#',0),(433503,12042,'hi','à¤¸à¤®à¤¾à¤œ à¤à¤¸à¤ˆà¤¸à¥€ / à¤¸à¤°à¤•à¤¾à¤° à¤†à¤ˆà¤¡à¥€ #',0),(433504,12042,'ms','Sec Merlimau / k\'jaan ID #',0),(433505,12042,'ar','Ø´Ø±ÙƒØ© Ù†ÙØ· Ø§Ù„Ø¬Ù†ÙˆØ¨ Ø«Ø§Ù†ÙŠØ©/ØªÙ…Ø«ÙŠÙ„ Ù…Ø¹Ø±Ù #',0),(433506,12042,'fr','SOC s / Govt ID #',0),(433507,12042,'jp','Soc ç§’/Govt ID #',0),(433508,12042,'pt','SOC Sec / Govt ID #',0),(433509,12042,'ru','SoC ÑÐµÐº / Ð“Ð¾Ð²Ñ‚ ID #',0),(433510,12042,'es','Soc Sec / Govt ID #',0),(433511,12042,'de','Soc Sec / Govt ID #',0),(433512,12042,'en','Soc Sec / Govt ID #',0),(433513,12043,'is','',0),(433514,12043,'dr','Ù‚Ø¨Ù„Ø§ Ø§ÙØ²ÙˆØ¯Ù‡ Ø´Ø¯Ù‡',0),(433515,12043,'pr','Ù‚Ø¨Ù„Ø§ Ø§ÙØ²ÙˆØ¯Ù‡ Ø´Ø¯Ù‡',0),(433516,12043,'tr','Zaten eklendi',0),(433517,12043,'pl','JuÅ¼ dodane',0),(433518,12043,'bg','Ð’ÐµÑ‡Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸',0),(433519,12043,'ur','Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ø´Ø§Ù…Ù„ Ú©ÛŒØ§',0),(433520,12043,'sr','Ð’ÐµÑ› Ð´Ð¾Ð´Ð°Ð»Ð¸',0),(433521,12043,'vi','Sáºµn sÃ ng thÃªm vÃ o',0),(433522,12043,'af','Reeds bygevoeg',0),(433523,12043,'ro','AdÄƒugat deja',0),(433524,12043,'et','Juba lisatud',0),(433525,12043,'si','Å½e dodan',0),(433526,12043,'ba','Sudah ditambahkan',0),(433527,12043,'nl','Al toegevoegd',0),(433528,12043,'fi','Jo lisÃ¤tty',0),(433529,12043,'no','Allerede lagt',0),(433530,12043,'da','Allerede tilfÃ¸jet',0),(433531,12043,'ko','ì´ë¯¸ ì¶”ê°€',0),(433532,12043,'he','×”×•×¡×¤×ª ×›×‘×¨',0),(433533,12043,'el','Î‰Î´Î· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹',0),(433534,12043,'zh','å·²ç»æ·»åŠ ',0),(433535,12043,'sv','Redan lagt till',0),(433536,12043,'it','GiÃ  aggiunto',0),(433537,12043,'tl','',0),(433538,12043,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹à¸¥à¹‰à¸§',0),(433539,12043,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(433540,12043,'ms','Telah ditambah',0),(433541,12043,'ar','Ø¨Ø§Ù„ÙØ¹Ù„ Ø¨Ø¥Ø¶Ø§ÙØ©',0),(433542,12043,'fr','DÃ©jÃ  ajoutÃ©',0),(433543,12043,'jp','æ—¢ã«è¿½åŠ ',0),(433544,12043,'pt','JÃ¡ adicionado',0),(433545,12043,'ru','Ð£Ð¶Ðµ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(433546,12043,'es','Ya Agregado',0),(433547,12043,'de','Bereits hinzugefÃ¼gt',0),(433548,12043,'en','Already Added',0),(433549,12044,'is','',0),(433550,12044,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø±Ú©ÙˆØ±Ø¯ Ù¾ÛŒØºØ§ Ù…Ù‡Ø§ÛŒ Ø´Ø®ØµÛŒ Ù†ÛŒØ³Øª',0),(433551,12044,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø±Ú©ÙˆØ±Ø¯ Ù¾ÛŒØºØ§ Ù…Ù‡Ø§ÛŒ Ø´Ø®ØµÛŒ Ù†ÛŒØ³Øª',0),(433552,12044,'tr','KiÅŸisel ileti kayÄ±tlarÄ± alÄ±namadÄ±',0),(433553,12044,'pl','Nie moÅ¼na pobraÄ‡ wiadomoÅ›Ä‡ Records',0),(433554,12044,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ Ð»Ð¸Ñ‡Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(433555,12044,'ur','Ø°Ø§ØªÛŒ Ù¾ÛŒØºØ§Ù… Ø±ÛŒÚ©Ø§Ø±Úˆ Ø¯ÙˆØ¨Ø§Ø±Û Ø­Ø§ØµÙ„ Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(433556,12044,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ Ð»Ð¸Ñ‡Ð½Ñƒ Ð¿Ð¾Ñ€ÑƒÐºÑƒ Ð·Ð°Ð¿Ð¸ÑÐµ',0),(433557,12044,'vi','KhÃ´ng thá»ƒ Ä‘á»ƒ láº¥y há»“ sÆ¡ tin nháº¯n cÃ¡ nhÃ¢n',0),(433558,12044,'af','Nie herwin persoonlike boodskap rekords nie',0),(433559,12044,'ro','Imposibilitatea de a regÄƒsi Ã®nregistrÄƒri mesaj Personal',0),(433560,12044,'et','Ei saa tuua erasÃµnumi kirjed',0),(433561,12044,'si','Ni mogoÄe pridobiti osebno sporoÄilo zapisov',0),(433562,12044,'ba','Mampu mengambil catatan pesan pribadi',0),(433563,12044,'nl','Unable To Retrieve persoonlijk bericht Records',0),(433564,12044,'fi','Ei voi noutaa henkilÃ¶kohtaisen viestin tiedot',0),(433565,12044,'no','Kan ikke hente personlig meldingsposter',0),(433566,12044,'da','Stand til at hente poster, personlig meddelelse',0),(433567,12044,'ko','ê°œì¸ ë©”ì‹œì§€ ë ˆì½”ë“œë¥¼ ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(433568,12044,'he','×œ× × ×™×ª×Ÿ ×œ××—×–×¨ ××ª ×”×”×•×“×¢×” ×”××™×©×™×ª ×¨×©×•×ž×•×ª',0),(433569,12044,'el','Î£Îµ Î¸Î­ÏƒÎ· Î½Î± Î±Î½Î±ÎºÏ„Î®ÏƒÎµÏ„Îµ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÏŒ Î¼Î®Î½Ï…Î¼Î±',0),(433570,12044,'zh','æ— æ³•æ£€ç´¢ç§äººæ¶ˆæ¯è®°å½•',0),(433571,12044,'sv','Det gick inte att hÃ¤mta personliga meddelande poster',0),(433572,12044,'it','Impossibile recuperare il messaggio personale record',0),(433573,12044,'tl','',0),(433574,12044,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸£à¸µà¸¢à¸à¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸—à¸µà¹ˆà¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸ªà¹ˆà¸§à¸™à¸•à¸±à¸§',0),(433575,12044,'hi','à¤µà¥à¤¯à¤•à¥à¤¤à¤¿à¤—à¤¤ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤ªà¥à¤¨à¤ƒ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(433576,12044,'ms','Tidak dapat mendapatkan semula mesej peribadi rekod',0),(433577,12044,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ø±Ø³Ø§Ù„Ø© Ø´Ø®ØµÙŠØ©',0),(433578,12044,'fr','Impossible de rÃ©cupÃ©rer les enregistrements de Message personnel',0),(433579,12044,'jp','å€‹äººçš„ãªãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’å–å¾—ã™ã‚‹ã«ã¯ã€ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(433580,12044,'pt','NÃ£o Ã© possÃ­vel recuperar registros de mensagem pessoal',0),(433581,12044,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð»Ð¸Ñ‡Ð½Ð¾Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(433582,12044,'es','No se Puede Recoger los Records de Mensajes Personales',0),(433583,12044,'de','Keine persÃ¶nliche Nachricht DatensÃ¤tze abrufen',0),(433584,12044,'en','Unable To Retrieve Personal Message Records',0),(433585,12045,'is','',0),(433586,12045,'dr','Ù‡ÛŒÚ† Ù‚ÛŒÙ…Øª Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ ÛŒØ§ Ø´ØºÙ„ÛŒ ÛŒØ§ÙØª Ù†Ø´Ø¯',0),(433587,12045,'pr','Ù‡ÛŒÚ† Ù‚ÛŒÙ…Øª Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ ÛŒØ§ Ø´ØºÙ„ÛŒ ÛŒØ§ÙØª Ù†Ø´Ø¯',0),(433588,12045,'tr','HiÃ§bir eÅŸleÅŸen teklifleri veya iÅŸ buldum',0),(433589,12045,'pl','Nie Cytaty lub miejsc pracy, znalazÅ‚',0),(433590,12045,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‰Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸ Ð¸Ð»Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(433591,12045,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û ÙˆØ§ÙˆÛŒÙ† ÛŒØ§ Ø±ÙˆØ²Ú¯Ø§Ø± Ù…Ù„Û’',0),(433592,12045,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð¸Ð»Ð¸ Ð¿Ð¾ÑÐ»Ð¾Ð²Ðµ Ð½Ð°ÑˆÐ»Ð¸',0),(433593,12045,'vi','khÃ´ng tÃ¬m tháº¥y liÃªn káº¿t cá»§a bÃ¡o giÃ¡ vÃ  cÃ´ng viá»‡c',0),(433594,12045,'af','Geen passende aanhalings of poste gevind',0),(433595,12045,'ro','Nicio potrivire citate sau gÄƒsit de locuri de muncÄƒ',0),(433596,12045,'et','Ole vastavaid hinnapakkumisi vÃµi tÃ¶Ã¶d leida',0),(433597,12045,'si','Brez ujemanja ponudbe ali delovna mesta, najti',0),(433598,12045,'ba','Tanda kutip tidak cocok atau pekerjaan yang ditemukan',0),(433599,12045,'nl','Geen overeenkomende citaten of banen gevonden',0),(433600,12045,'fi','Ei vastaavia lainauksia tai tyÃ¶paikkoja lÃ¶ytyy',0),(433601,12045,'no','Ingen samsvarende sitater eller jobber funnet',0),(433602,12045,'da','Ingen matchende citater eller job fundet',0),(433603,12045,'ko','ì•„ë‹ˆ ì¼ì¹˜ ë”°ì˜´í‘œ ë˜ëŠ” ìž‘ì—… ë°œê²¬',0),(433604,12045,'he','××™×Ÿ ×¦×™×˜×•×˜×™× ×ª×•××ž×•×ª ××• ×ž×©×¨×•×ª ×©× ×ž×¦××•',0),(433605,12045,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬ Î® Î¸Î­ÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(433606,12045,'zh','æ²¡æœ‰æ‰¾åˆ°åŒ¹é…çš„æŠ¥ä»·æˆ–å·¥ä½œ',0),(433607,12045,'sv','Inga matchande citationstecken eller jobb hittade',0),(433608,12045,'it','Nessuna corrispondenza citazioni o lavori trovati',0),(433609,12045,'tl','',0),(433610,12045,'th','à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸™à¸«à¸£à¸·à¸­à¸‡à¸²à¸™à¸—à¸µà¹ˆà¸žà¸š',0),(433611,12045,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤¯à¤¾ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(433612,12045,'ms','Sebut harga tidak sepadan atau kerja-kerja yang ditemui',0),(433613,12045,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ø·Ø§Ø¨Ù‚Ø© Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³ Ø£Ùˆ ÙˆØ¸ÙŠÙØ© ØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„ÙŠÙ‡Ø§',0),(433614,12045,'fr','Aucun devis ou les offres d\'emploi trouvÃ©es correspondant',0),(433615,12045,'jp','ãªã„ä¸€è‡´ã™ã‚‹å¼•ç”¨ç¬¦ã¾ãŸã¯ã‚¸ãƒ§ãƒ–ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(433616,12045,'pt','Nenhuma correspondÃªncia citaÃ§Ãµes ou trabalhos encontrados',0),(433617,12045,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… Ñ†Ð¸Ñ‚Ð°Ñ‚ Ð¸Ð»Ð¸ Ð²Ð°ÐºÐ°Ð½ÑÐ¸Ð¸ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(433618,12045,'es','No se Encuentra Ni Cotizaciones Pareados Ni Trabajos',0),(433619,12045,'de','Keine passenden Angebote oder Gefundene Stellenanzeigen',0),(433620,12045,'en','No Matching Quotes Or Jobs Found',0),(433621,12046,'is','',0),(433622,12046,'dr','Ø±ÙˆÛŒ Ø´Ù†Ø§Ø³Ù‡ Ø´ØºÙ„ Ø¨Ø±Ø§ÛŒ ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(433623,12046,'pr','Ø±ÙˆÛŒ Ø´Ù†Ø§Ø³Ù‡ Ø´ØºÙ„ Ø¨Ø±Ø§ÛŒ ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(433624,12046,'tr','Ä°ÅŸ kimliÄŸi Ã¼zerinde sipariÅŸ onaylamak iÃ§in tÄ±klayÄ±n',0),(433625,12046,'pl','Kliknij zadanie identyfikator potwierdzenia zamÃ³wienia',0),(433626,12046,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð·Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(433627,12046,'ur','Ø¬Ø§Ø¨ Ø´Ù†Ø§Ø®Øª Ù¾Ø± Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(433628,12046,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð˜Ð” Ð¿Ð¾ÑÐ»Ð° Ð´Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(433629,12046,'vi','Nháº¥n trÃªn mÃ£ cÃ´ng viá»‡c Ä‘á»ƒ xÃ¡c nháº­n lá»‡nh',0),(433630,12046,'af','Klik op werk ID bevestig bestelling',0),(433631,12046,'ro','FaceÅ£i clic pe ID de Job pentru a confirma comanda',0),(433632,12046,'et','TÃ¶Ã¶ ID tellimuse kinnitamiseks vajuta',0),(433633,12046,'si','Kliknite na ID posla potrdi naroÄilo',0),(433634,12046,'ba','Klik pada pekerjaan ID untuk mengkonfirmasi pesanan',0),(433635,12046,'nl','Klik op vacature-ID ter bevestiging van bestelling',0),(433636,12046,'fi','Valitse tyÃ¶n tunnus vahvista tilaus',0),(433637,12046,'no','Klikk pÃ¥ jobb-ID for Ã¥ bekrefte ordre',0),(433638,12046,'da','Klik pÃ¥ Job-ID for at bekrÃ¦fte ordren',0),(433639,12046,'ko','ìˆœì„œë¥¼ í™•ì¸ í•˜ë ¤ë©´ ìž‘ì—… IDë¥¼ í´ë¦­',0),(433640,12046,'he','×œ×—×¥ ×¢×œ ×ž×–×”×” ×ž×©×™×ž×” ×›×“×™ ×œ××©×¨ ×”×¡×“×¨',0),(433641,12046,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î³Î¹Î± Î½Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(433642,12046,'zh','åœ¨å·¥ä½œèº«ä»½ä¸Šç‚¹å‡»ä»¥ç¡®è®¤è®¢å•',0),(433643,12046,'sv','Klicka pÃ¥ jobb-ID fÃ¶r att bekrÃ¤fta Order',0),(433644,12046,'it','Fare clic su ID lavoro per confermare l\'ordine',0),(433645,12046,'tl','',0),(433646,12046,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸‡à¸²à¸™ ID à¹€à¸žà¸·à¹ˆà¸­à¸¢à¸·à¸™à¸¢à¸±à¸™à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(433647,12046,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ ID à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(433648,12046,'ms','Klik pada kerja ID untuk mengesahkan pesanan',0),(433649,12046,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ù‡Ù…Ø© Ù„ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø£Ù…Ø±',0),(433650,12046,'fr','Cliquez sur l\'ID du travail de confirmer commande',0),(433651,12046,'jp','ã‚¸ãƒ§ãƒ– ID ã®æ³¨æ–‡ã‚’ç¢ºèªã™ã‚‹ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(433652,12046,'pt','Clique no ID do trabalho para confirmar a ordem',0),(433653,12046,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ Ð´Ð»Ñ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(433654,12046,'es','Hace Clik en ID de Trabajo Para Confirmar el Orden',0),(433655,12046,'de','Klicken Sie auf Job-ID Bestellung bestÃ¤tigen',0),(433656,12046,'en','Click On Job ID To Confirm Order',0),(433657,12047,'is','',0),(433658,12047,'dr','Ù‡ÛŒÚ† Ú©Ø§Ù„Ø§ÛŒ ØªØ§ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡ Ø§ÛŒ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(433659,12047,'pr','Ù‡ÛŒÚ† Ú©Ø§Ù„Ø§ÛŒ ØªØ§ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡ Ø§ÛŒ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(433660,12047,'tr','DoÄŸrulanmamÄ±ÅŸ Ã¶ÄŸe bulunamadÄ±',0),(433661,12047,'pl','Nie niepotwierdzone przedmiotÃ³w znalezionych',0),(433662,12047,'bg','ÐÐµ ÑÐ° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð½ÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(433663,12047,'ur','Ú©ÙˆØ¦ÛŒ ØºÛŒØ± Ù…ØµØ¯Ù‚Û Ø¢Ø¦Ù¹Ù… Ù†ÛÙŠÚº Ù…Ù„Ø§',0),(433664,12047,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° Ð½Ð¸Ñ˜ÐµÐ´Ð½Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð¾ ÑÑ‚Ð°Ð²ÐºÐ°',0),(433665,12047,'vi','khÃ´ng tÃ¬m tháº¥y má»¥c chÆ°a xÃ¡c nháº­n ',0),(433666,12047,'af','Geen onbevestigde Items gevind',0),(433667,12047,'ro','Neconfirmate articole gÄƒsite',0),(433668,12047,'et','Kinnitamata Ã¼ksusi ei leidu',0),(433669,12047,'si','Ni najdenih elementov nepotrjenih',0),(433670,12047,'ba','Tidak ada item yang belum dikonfirmasi ditemukan',0),(433671,12047,'nl','Geen onbevestigde Items gevonden',0),(433672,12047,'fi','Vahvistamattomien kohteita ei lÃ¶ydy',0),(433673,12047,'no','Ingen ubekreftet elementer funnet',0),(433674,12047,'da','Ingen ubekrÃ¦ftede varer fundet',0),(433675,12047,'ko','ì•„ë‹ˆ í™•ì¸ ë˜ì§€ ì•Šì€ í•­ëª©ì„ ì°¾ì„',0),(433676,12047,'he','×œ× × ×ž×¦××• ×¤×¨×™×˜×™× ×©×œ× ××•×©×¨×•',0),(433677,12047,'el','Î”ÎµÎ½ Î±Î½ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰Ï„ÎµÏ‚ Î±Î½Ï„Î¹ÎºÎµÎ¹Î¼Î­Î½Ï‰Î½ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(433678,12047,'zh','æ²¡æœ‰æ‰¾åˆ°æœªç¡®è®¤çš„é¡¹ç›®',0),(433679,12047,'sv','Ingen obekrÃ¤ftade objekt hittades',0),(433680,12047,'it','No non confermati articoli trovati',0),(433681,12047,'tl','',0),(433682,12047,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¸¢à¸±à¸‡à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸¢à¸·à¸™à¸¢à¸±à¸™',0),(433683,12047,'hi','à¤•à¥‹à¤ˆ à¤…à¤ªà¥à¤·à¥à¤Ÿ à¤†à¤‡à¤Ÿà¤® à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(433684,12047,'ms','Tiada item belum disahkan yang ditemui',0),(433685,12047,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¹Ù†Ø§ØµØ± ØºÙŠØ± Ù…Ø¤ÙƒØ¯Ø©',0),(433686,12047,'fr','Aucun Ã©lÃ©ment non confirmÃ©es trouvÃ©',0),(433687,12047,'jp','æœªç¢ºèªé …ç›®ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(433688,12047,'pt','NÃ£o hÃ¡ itens nÃ£o confirmados encontrados',0),(433689,12047,'ru','ÐÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(433690,12047,'es','No se Encuentra Items No Confirmados',0),(433691,12047,'de','Keine unbestÃ¤tigten EintrÃ¤ge gefunden',0),(433692,12047,'en','No Unconfirmed Items Found',0),(433693,12048,'is','',0),(433694,12048,'dr','ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒ Ù…ÙˆÙÙ‚',0),(433695,12048,'pr','ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒ Ù…ÙˆÙÙ‚',0),(433696,12048,'tr','EtkinleÅŸtirme baÅŸarÄ±lÄ±',0),(433697,12048,'pl','Aktywacja pomyÅ›lny',0),(433698,12048,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(433699,12048,'ur','Ù…ØªØ­Ø±Ú© Ú©Ø§Ø±ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨',0),(433700,12048,'sr','ÐÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ñ˜Ð° ÑƒÑÐ¿ÐµÑˆÐ°Ð½',0),(433701,12048,'vi','kÃ­ch hoáº¡t thÃ nh cÃ´ng',0),(433702,12048,'af','Aktivering Suksesvol',0),(433703,12048,'ro','Activare de succes',0),(433704,12048,'et','Aktiveerimine edukas',0),(433705,12048,'si','Activation uspeÅ¡en',0),(433706,12048,'ba','Aktivasi sukses',0),(433707,12048,'nl','Succesvolle activering',0),(433708,12048,'fi','Aktivointi onnistui',0),(433709,12048,'no','Aktivering lykkes',0),(433710,12048,'da','Aktivering vellykket',0),(433711,12048,'ko','ì •í’ˆ ì¸ì¦ ì„±ê³µ',0),(433712,12048,'he','×”×¤×¢×œ×” ×ž×•×¦×œ×—×ª',0),(433713,12048,'el','Î•Ï€Î¹Ï„Ï…Ï‡Î·Î¼Î­Î½Î· Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(433714,12048,'zh','æ¿€æ´»æˆåŠŸ',0),(433715,12048,'sv','Aktiveringen framgÃ¥ngsrik',0),(433716,12048,'it','Attivazione di successo',0),(433717,12048,'tl','',0),(433718,12048,'th','à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(433719,12048,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯à¤£ à¤¸à¤«à¤²',0),(433720,12048,'ms','Pengaktifan berjaya',0),(433721,12048,'ar','Ù†Ø¬Ø§Ø­ Ø§Ù„ØªÙ†Ø´ÙŠØ·',0),(433722,12048,'fr','Activation rÃ©ussie',0),(433723,12048,'jp','æ­£å¸¸ã«ã‚¢ã‚¯ãƒ†ã‚£ãƒ–åŒ–',0),(433724,12048,'pt','AtivaÃ§Ã£o bem-sucedida',0),(433725,12048,'ru','ÐÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(433726,12048,'es','ActivaciÃ³n Exitosa',0),(433727,12048,'de','Aktivierung erfolgreich',0),(433728,12048,'en','Activation Successful',0),(433729,12049,'is','',0),(433730,12049,'dr','Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(433731,12049,'pr','Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(433732,12049,'tr','Eklenti',0),(433733,12049,'pl','Dodatek',0),(433734,12049,'bg','Ð”Ð¾Ð±Ð°Ð²ÐºÐ°',0),(433735,12049,'ur','Ø¨Ø±-Ø§ Ø¶Ø§ÙÛ',0),(433736,12049,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð°Ðº',0),(433737,12049,'vi','Add on',0),(433738,12049,'af','Byvoegsel',0),(433739,12049,'ro','Supliment',0),(433740,12049,'et','Lisandmoodul',0),(433741,12049,'si','Dodatek',0),(433742,12049,'ba','Add-On',0),(433743,12049,'nl','Add-On',0),(433744,12049,'fi','Add-On',0),(433745,12049,'no','Tillegg',0),(433746,12049,'da','TilfÃ¸jelse',0),(433747,12049,'ko','ë¶€ê°€ ê¸°ëŠ¥',0),(433748,12049,'he','×”×”×¨×—×‘×”',0),(433749,12049,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î¿',0),(433750,12049,'zh','é™„åŠ ',0),(433751,12049,'sv','TillÃ¤gg',0),(433752,12049,'it','Componente aggiuntivo',0),(433753,12049,'tl','',0),(433754,12049,'th','Add-On',0),(433755,12049,'hi','à¤à¤¡-à¤‘à¤¨',0),(433756,12049,'ms','Tambahan',0),(433757,12049,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(433758,12049,'fr','Module',0),(433759,12049,'jp','ã‚¢ãƒ‰ã‚ªãƒ³',0),(433760,12049,'pt','Add-on',0),(433761,12049,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ',0),(433762,12049,'es','Dispos. de AumentaciÃ³n',0),(433763,12049,'de','Add-ons anzeigen',0),(433764,12049,'en','Add-On',0),(433765,12050,'is','',0),(433766,12050,'dr','Ø®Ø±ÛŒØ¯Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(433767,12050,'pr','Ø®Ø±ÛŒØ¯Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(433768,12050,'tr','Åžu anda mevcut satÄ±n deÄŸil eklenti',0),(433769,12050,'pl','O dodatku zakupu nie dostÄ™pne w tej chwili',0),(433770,12050,'bg','Ð”Ð¾Ð±Ð°Ð²ÐºÐ°Ñ‚Ð° Ð½Ðµ Ð·Ð°ÐºÑƒÐ¿ÑƒÐ²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð² Ñ‚Ð¾Ð·Ð¸ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚',0),(433771,12050,'ur','Ø¨Ø±-Ø§ Ø¶Ø§ÙÛ Ø§Ø³ ÙˆÙ‚Øª Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(433772,12050,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð°Ðº Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ Ð½Ð¸ÑÑƒ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸ Ñƒ Ð¾Ð²Ð¾Ð¼ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚ÐºÑƒ',0),(433773,12050,'vi','Add on mua hÃ ng khÃ´ng cÃ³ sáºµn táº¡i thá»i Ä‘iá»ƒm nÃ y.',0),(433774,12050,'af','Byvoegsel aankoop nie beskikbaar op hierdie tydstip',0),(433775,12050,'ro','Supliment de cumpÄƒrare nu disponibile Ã®n acest moment',0),(433776,12050,'et','Lisandmooduli ostmine pole praegu saadaval',0),(433777,12050,'si','Dodatek nakupa ni na voljo v tem trenutku',0),(433778,12050,'ba','Add-On pembelian tidak tersedia saat ini',0),(433779,12050,'nl','Add-On aankoop niet beschikbaar op dit moment',0),(433780,12050,'fi','LisÃ¤osan ostaa ei saatavilla tÃ¤llÃ¤ hetkellÃ¤',0),(433781,12050,'no','Tillegg kjÃ¸per ikke tilgjengelige pÃ¥ dette tidspunktet',0),(433782,12050,'da','TilfÃ¸jelse kÃ¸ber ikke tilgÃ¦ngelig pÃ¥ dette tidspunkt',0),(433783,12050,'ko','ì´ ì‹œê°„ì— ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” êµ¬ë§¤ ë¶€ê°€ ê¸°ëŠ¥',0),(433784,12050,'he','×”×¨×—×‘×” ×¨×›×© ×œ× ×–×ž×™×Ÿ ×›×¨×’×¢',0),(433785,12050,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î¿ Î´ÎµÎ½ Î±Î³Î¿ÏÎ¬ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Î±Ï…Ï„Î® Ï„Î· ÏƒÏ„Î¹Î³Î¼Î®',0),(433786,12050,'zh','é™„åŠ çš„è´­ä¹°åœ¨æ­¤æ—¶ä¸å¯ç”¨',0),(433787,12050,'sv','TillÃ¤gg kÃ¶per inte tillgÃ¤ngliga vid denna tid',0),(433788,12050,'it','Componente aggiuntivo di acquisto non disponibile in questo momento',0),(433789,12050,'tl','',0),(433790,12050,'th','Add-On à¸—à¸µà¹ˆà¸‹à¸·à¹‰à¸­à¹„à¸¡à¹ˆà¸§à¹ˆà¸²à¸‡à¹ƒà¸™à¸‚à¸“à¸°à¸™à¸µà¹‰',0),(433791,12050,'hi','à¤à¤¡-à¤‘à¤¨ à¤–à¤°à¥€à¤¦ à¤‡à¤¸ à¤¸à¤®à¤¯ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚',0),(433792,12050,'ms','Tambahan pembelian tidak tersedia buat masa ini',0),(433793,12050,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ© Ø´Ø±Ø§Ø¡ ØºÙŠØ± Ù…ØªÙˆÙØ±Ø© ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„ÙˆÙ‚Øª',0),(433794,12050,'fr','Module N\'achats pas disponible en ce moment',0),(433795,12050,'jp','è³¼å…¥ã¯ã“ã®æ™‚ç‚¹ã§åˆ©ç”¨å¯èƒ½ãªã‚¢ãƒ‰ã‚ªãƒ³',0),(433796,12050,'pt','Complemento de compra nÃ£o disponÃ­vel neste momento',0),(433797,12050,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ, Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð½Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ð² Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚',0),(433798,12050,'es','Compras de Dispositivos de AumentaciÃ³n no estan disponibles en Este Momento',0),(433799,12050,'de','Add-on Einkauf zu dieser Zeit nicht verfÃ¼gbar',0),(433800,12050,'en','Add-On Purchasing Not Available At This Time',0),(433801,12051,'is','',0),(433802,12051,'dr','Ú©Ø´ÙˆØ± ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(433803,12051,'pr','Ú©Ø´ÙˆØ± ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(433804,12051,'tr','Fatura Ã¼lke',0),(433805,12051,'pl','Kraj rozliczenia',0),(433806,12051,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ, ÑÑ‚Ñ€Ð°Ð½Ð°',0),(433807,12051,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…Ù„Ú©',0),(433808,12051,'sr','Ð—ÐµÐ¼Ñ™Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(433809,12051,'vi','Quá»‘c gia gá»­i hÃ³a Ä‘Æ¡n',0),(433810,12051,'af','Fakturering land',0),(433811,12051,'ro','Å¢ara de facturare',0),(433812,12051,'et','Arveldusaadressi riik',0),(433813,12051,'si','Naslov plaÄnika â€“ drÅ¾ava',0),(433814,12051,'ba','Penagihan negara',0),(433815,12051,'nl','Facturatie land',0),(433816,12051,'fi','Laskutusosoitteen maa',0),(433817,12051,'no','Fakturering land',0),(433818,12051,'da','Fakturering land',0),(433819,12051,'ko','ê²°ì œ êµ­ê°€',0),(433820,12051,'he','×—×™×•×‘ ×”×ž×“×™× ×”',0),(433821,12051,'el','Î§ÏŽÏÎ± Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(433822,12051,'zh','å¸å•å›½å®¶',0),(433823,12051,'sv','Fakturering land',0),(433824,12051,'it','Paese di fatturazione',0),(433825,12051,'tl','',0),(433826,12051,'th','à¸›à¸£à¸°à¹€à¸—à¸¨à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(433827,12051,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤¦à¥‡à¤¶',0),(433828,12051,'ms','Bil negara',0),(433829,12051,'ar','Ø¨Ù„Ø¯ Ø§Ù„ÙÙˆØªØ±Ø©',0),(433830,12051,'fr','Pays de facturation',0),(433831,12051,'jp','è«‹æ±‚å›½',0),(433832,12051,'pt','PaÃ­s de facturaÃ§Ã£o',0),(433833,12051,'ru','ÐŸÐ¾ÐºÑƒÐ¿Ð°Ñ‚ÐµÐ»ÑŒ ÑÑ‚Ñ€Ð°Ð½Ð°',0),(433834,12051,'es','PaÃ­s de FacturaciÃ³n',0),(433835,12051,'de','Abrechnung-Land',0),(433836,12051,'en','Billing Country',0),(433837,12052,'is','',0),(433838,12052,'dr','Ø´Ù…Ø§Ø±Ù‡ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(433839,12052,'pr','Ø´Ù…Ø§Ø±Ù‡ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(433840,12052,'tr','Kredi kartÄ± numarasÄ±',0),(433841,12052,'pl','Numer karty kredytowej',0),(433842,12052,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(433843,12052,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù†Ù…Ø¨Ø±',0),(433844,12052,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(433845,12052,'vi','Sá»“ tháº» tÃ­n dá»¥ng',0),(433846,12052,'af','Kredietkaart Nommer',0),(433847,12052,'ro','NumÄƒrul cardului de credit',0),(433848,12052,'et','Krediitkaardi Number',0),(433849,12052,'si','Å tevilka kreditne kartice',0),(433850,12052,'ba','Nomor kartu kredit',0),(433851,12052,'nl','Credit cardnummer',0),(433852,12052,'fi','Luottokorttinumero',0),(433853,12052,'no','Kredittkortnummer',0),(433854,12052,'da','Kreditkortnummer',0),(433855,12052,'ko','ì‹ ìš© ì¹´ë“œ ë²ˆí˜¸',0),(433856,12052,'he','×ž×¡×¤×¨ ×›×¨×˜×™×¡ ×”××©×¨××™',0),(433857,12052,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(433858,12052,'zh','ä¿¡ç”¨å¡å·',0),(433859,12052,'sv','Kreditkortsnummer',0),(433860,12052,'it','Numero di carta di credito',0),(433861,12052,'tl','',0),(433862,12052,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(433863,12052,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¨à¤‚à¤¬à¤°',0),(433864,12052,'ms','Nombor kad kredit',0),(433865,12052,'ar','Ø±Ù‚Ù… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(433866,12052,'fr','NumÃ©ro de carte de crÃ©dit',0),(433867,12052,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ç•ªå·',0),(433868,12052,'pt','NÃºmero de cartÃ£o de crÃ©dito',0),(433869,12052,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(433870,12052,'es','NÃºmero de Tarjeta de CrÃ©dito',0),(433871,12052,'de','Kreditkartennummer',0),(433872,12052,'en','Credit Card Number',0),(433873,12053,'is','',0),(433874,12053,'dr','Ø´Ù…Ø§Ø±Ù‡ ØªØ§ÛŒÛŒØ¯',0),(433875,12053,'pr','Ø´Ù…Ø§Ø±Ù‡ ØªØ§ÛŒÛŒØ¯',0),(433876,12053,'tr','Onay numarasÄ±',0),(433877,12053,'pl','Numer potwierdzenia',0),(433878,12053,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(433879,12053,'ur','ØªØµØ¯ÛŒÙ‚ Ù†Ù…Ø¨Ø±',0),(433880,12053,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð±Ñ€Ð¾Ñ˜',0),(433881,12053,'vi','XÃ¡c nháº­n sá»‘',0),(433882,12053,'af','Bevestiging nommer',0),(433883,12053,'ro','NumÄƒrul de confirmare',0),(433884,12053,'et','Kinnituse Number',0),(433885,12053,'si','Å tevilka potrdila',0),(433886,12053,'ba','Nomor konfirmasi',0),(433887,12053,'nl','Bevestigingsnummer',0),(433888,12053,'fi','Vahvistusnumero',0),(433889,12053,'no','Bekreftelsesnummeret',0),(433890,12053,'da','BekrÃ¦ftelsesnummer',0),(433891,12053,'ko','í™•ì¸ ë²ˆí˜¸',0),(433892,12053,'he','×ž×¡×¤×¨ ××™×©×•×¨',0),(433893,12053,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·Ï‚',0),(433894,12053,'zh','ç¡®è®¤å·ç ',0),(433895,12053,'sv','Bokningsnummer',0),(433896,12053,'it','Numero di conferma',0),(433897,12053,'tl','',0),(433898,12053,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡',0),(433899,12053,'hi','à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(433900,12053,'ms','Nombor pengesahan',0),(433901,12053,'ar','Ø±Ù‚Ù… Ø§Ù„ØªØ£ÙƒÙŠØ¯',0),(433902,12053,'fr','NumÃ©ro de confirmation',0),(433903,12053,'jp','ç¢ºèªç•ªå·',0),(433904,12053,'pt','NÃºmero de confirmaÃ§Ã£o',0),(433905,12053,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(433906,12053,'es','NÃºmero de ConfirmaciÃ³n',0),(433907,12053,'de','BestÃ¤tigungsnummer',0),(433908,12053,'en','Confirmation Number',0),(433909,12054,'is','',0),(433910,12054,'dr','ØªØ§ÛŒÛŒØ¯ Ø®Ø±ÛŒØ¯',0),(433911,12054,'pr','ØªØ§ÛŒÛŒØ¯ Ø®Ø±ÛŒØ¯',0),(433912,12054,'tr','SatÄ±n onaylamak',0),(433913,12054,'pl','Potwierdzenie zakupu',0),(433914,12054,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°Ñ‚Ð°',0),(433915,12054,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(433916,12054,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ðµ',0),(433917,12054,'vi','xÃ¡c nháº­n mua hÃ ng',0),(433918,12054,'af','Bevestig aankoop',0),(433919,12054,'ro','Confirma cumpÄƒrarea',0),(433920,12054,'et','Ostu kinnitamine',0),(433921,12054,'si','Potrditev nakupa',0),(433922,12054,'ba','Konfirmasi pembelian',0),(433923,12054,'nl','Aankoop bevestigen',0),(433924,12054,'fi','Vahvista osto',0),(433925,12054,'no','Bekreft kjÃ¸p',0),(433926,12054,'da','BekrÃ¦ft kÃ¸b',0),(433927,12054,'ko','êµ¬ë§¤ í™•ì¸',0),(433928,12054,'he','×œ××©×¨ ×¨×›×™×©×”',0),(433929,12054,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ Î±Î³Î¿ÏÎ¬',0),(433930,12054,'zh','ç¡®è®¤è´­ä¹°',0),(433931,12054,'sv','BekrÃ¤fta kÃ¶p',0),(433932,12054,'it','Conferma acquisto',0),(433933,12054,'tl','',0),(433934,12054,'th','à¸¢à¸·à¸™à¸¢à¸±à¸™à¸à¸²à¸£à¸‹à¸·à¹‰à¸­',0),(433935,12054,'hi','à¤–à¤°à¥€à¤¦ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿',0),(433936,12054,'ms','Mengesahkan pembelian',0),(433937,12054,'ar','ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(433938,12054,'fr','Confirmer l\'achat',0),(433939,12054,'jp','è³¼å…¥ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(433940,12054,'pt','Confirmar a compra',0),(433941,12054,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(433942,12054,'es','Confirmar Compra',0),(433943,12054,'de','Kauf bestÃ¤tigen',0),(433944,12054,'en','Confirm Purchase',0),(433945,12055,'is','',0),(433946,12055,'dr','Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ØªØ¬Ø§Ø±Øª Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(433947,12055,'pr','Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ØªØ¬Ø§Ø±Øª Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(433948,12055,'tr','e-ticaret uygulamalarÄ±',0),(433949,12055,'pl','e-commerce, aplikacje',0),(433950,12055,'bg','ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²Ð¸Ñ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(433951,12055,'ur','eCommerce Ø§Ø·Ù„Ø§Ù‚Ø§Øª',0),(433952,12055,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð½Ð¸Ñ†Ð° ÐÐ¿Ð¿Ñ',0),(433953,12055,'vi','thÆ°Æ¡ng máº¡i apps',0),(433954,12055,'af','besigheidsamestelling toepassings',0),(433955,12055,'ro','eCommerce Apps',0),(433956,12055,'et','Pood Apps',0),(433957,12055,'si','e-Commerce aplikacije',0),(433958,12055,'ba','e-commerce aplikasi',0),(433959,12055,'nl','e-commerce Apps',0),(433960,12055,'fi','Verkkokaupan sovellukset',0),(433961,12055,'no','e-handel programmer',0),(433962,12055,'da','eCommerce Apps',0),(433963,12055,'ko','ì „ìž ìƒê±°ëž˜ ì• í”Œ ë¦¬ ì¼€ì´ ì…˜',0),(433964,12055,'he','×ž×¡×—×¨ ××œ×§×˜×¨×•× ×™ Apps',0),(433965,12055,'el','Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ ÎµÎ¼Ï€ÏŒÏÎ¹Î¿ Apps',0),(433966,12055,'zh','ç½‘ç»œå•†ä¸šåº”ç”¨ç¨‹åº',0),(433967,12055,'sv','e-handel Apps',0),(433968,12055,'it','eCommerce Apps',0),(433969,12055,'tl','',0),(433970,12055,'th','à¸­à¸µà¸„à¸­à¸¡à¹€à¸¡à¸´à¸£à¹Œà¸‹à¸›à¸žà¸¥à¸´à¹€à¸„à¸Šà¸±à¸™',0),(433971,12055,'hi','eCommerce Apps',0),(433972,12055,'ms','e-dagang aplikasi',0),(433973,12055,'ar','ØªØ·Ø¨ÙŠÙ‚Ø§Øª Ø§Ù„ØªØ¬Ø§Ø±Ø© Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠØ©',0),(433974,12055,'fr','eCommerce Apps',0),(433975,12055,'jp','e ã‚³ãƒžãƒ¼ã‚¹ã®ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(433976,12055,'pt','eCommerce Apps',0),(433977,12055,'ru','ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ ÐºÐ¾Ð¼Ð¼ÐµÑ€Ñ†Ð¸Ð¸ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¹',0),(433978,12055,'es','Aplicaciones de E-comercio',0),(433979,12055,'de','e-Commerce Anwendungen',0),(433980,12055,'en','eCommerce Apps',0),(433981,12056,'is','',0),(433982,12056,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(433983,12056,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(433984,12056,'tr','FiyatlandÄ±rma alÄ±nÄ±rken hata oluÅŸtu',0),(433985,12056,'pl','BÅ‚Ä…d podczas pobierania cen',0),(433986,12056,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(433987,12056,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(433988,12056,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(433989,12056,'vi','Lá»—i khi khÃ´i phá»¥c',0),(433990,12056,'af','Fout herwinning pryse',0),(433991,12056,'ro','Eroare recuperare de stabilire a preÅ£urilor',0),(433992,12056,'et','Toomisel hinnakujunduse tÃµrge',0),(433993,12056,'si','Napaka pri pridobivanju cen',0),(433994,12056,'ba','Kesalahan mengambil harga',0),(433995,12056,'nl','Error Retrieving prijzen',0),(433996,12056,'fi','Virhe haettaessa hinnoittelu',0),(433997,12056,'no','Feil under henting av priser',0),(433998,12056,'da','Fejl under hentning af prissÃ¦tning',0),(433999,12056,'ko','ê°€ê²© ê²€ìƒ‰ ì˜¤ë¥˜',0),(434000,12056,'he','×©×’×™××” ×‘××—×–×•×¨ ×ª×ž×—×•×¨',0),(434001,12056,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(434002,12056,'zh','é”™è¯¯æ£€ç´¢ä»·æ ¼',0),(434003,12056,'sv','Fel vid hÃ¤mtning av prissÃ¤ttning',0),(434004,12056,'it','Errore nel recupero dei prezzi',0),(434005,12056,'tl','',0),(434006,12056,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸”à¸¶à¸‡à¸£à¸²à¸„à¸²',0),(434007,12056,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(434008,12056,'ms','Ralat mendapatkan semula harga',0),(434009,12056,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(434010,12056,'fr','Erreur rÃ©cupÃ©rer prix',0),(434011,12056,'jp','ä¾¡æ ¼è¨­å®šã®å–å¾—ã‚¨ãƒ©ãƒ¼',0),(434012,12056,'pt','Erro ao recuperar preÃ§os',0),(434013,12056,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(434014,12056,'es','Error Recuperando Precios',0),(434015,12056,'de','Fehler beim Abrufen der Preise',0),(434016,12056,'en','Error Retrieving Pricing',0),(434017,12057,'is','',0),(434018,12057,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† ØªØ§ÛŒÛŒØ¯ Ø®Ø±ÛŒØ¯',0),(434019,12057,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÙŠØ§Ø¨ÙŠ ÙƒØ±Ø¯Ù† ØªØ§ÛŒÛŒØ¯ Ø®Ø±ÛŒØ¯',0),(434020,12057,'tr','Hata alma satÄ±n alma onay',0),(434021,12057,'pl','BÅ‚Ä…d pobierania potwierdzenie zakupu',0),(434022,12057,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(434023,12057,'ur','Ù†Ù‚Øµ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ ØªØµØ¯ÛŒÙ‚ Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(434024,12057,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐ° Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð³Ñ€ÐµÑˆÐºÐµ',0),(434025,12057,'vi','Lá»—i khi khÃ´i phá»¥c xÃ¡c nháº­n mua hÃ ng',0),(434026,12057,'af','Fout herwinning aankoop bevestiging',0),(434027,12057,'ro','Eroare recuperare cumpÄƒrare de confirmare',0),(434028,12057,'et','TÃµrge allalaadimisel ostu kinnitus',0),(434029,12057,'si','Napaka pri pridobivanju potrditev nabavnega',0),(434030,12057,'ba','Konfirmasi pembelian mengambil kesalahan',0),(434031,12057,'nl','Fout ophalen aankoop bevestiging',0),(434032,12057,'fi','Virhe noudettaessa ostaa vahvistusta',0),(434033,12057,'no','Feil under henting av bestillingsbekreftelse',0),(434034,12057,'da','Fejl under hentning af kÃ¸b bekrÃ¦ftelse',0),(434035,12057,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ êµ¬ë§¤ í™•ì¸',0),(434036,12057,'he','×©×’×™××” ×‘××—×–×•×¨ ××™×©×•×¨ ×”×¨×›×™×©×”',0),(434037,12057,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·Ï‚ Î±Î³Î¿ÏÎ¬Ï‚',0),(434038,12057,'zh','é”™è¯¯æ£€ç´¢é‡‡è´­ç¡®è®¤',0),(434039,12057,'sv','Fel hÃ¤mtar kÃ¶p bekrÃ¤ftelse',0),(434040,12057,'it','Conferma di acquisto recupero di errore',0),(434041,12057,'tl','',0),(434042,12057,'th','à¸¢à¸·à¸™à¸¢à¸±à¸™à¸‹à¸·à¹‰à¸­à¹€à¸£à¸µà¸¢à¸à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(434043,12057,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ à¤–à¤°à¥€à¤¦ à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£',0),(434044,12057,'ms','Ralat mendapatkan pengesahan pembelian',0),(434045,12057,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(434046,12057,'fr','Confirmation d\'achat de rÃ©cupÃ©ration erreur',0),(434047,12057,'jp','ã‚¨ãƒ©ãƒ¼ã‚’å–å¾—ã™ã‚‹è³¼å…¥ç¢ºèª',0),(434048,12057,'pt','ConfirmaÃ§Ã£o de compra de recuperaÃ§Ã£o de erro',0),(434049,12057,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(434050,12057,'es','Error Recuperando InformaciÃ³n de Compra',0),(434051,12057,'de','Fehler beim Abrufen der KaufbestÃ¤tigung',0),(434052,12057,'en','Error Retrieving Purchase Confirmation',0),(434053,12058,'is','',0),(434054,12058,'dr','Ø®Ø·Ø§ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ú©Ø§Ø±Øª',0),(434055,12058,'pr','Ø®Ø·Ø§ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ú©Ø§Ø±Øª',0),(434056,12058,'tr','Kart kaydedilirken hata oluÅŸtu',0),(434057,12058,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania kart',0),(434058,12058,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(434059,12058,'ur','Ú©Ø§Ø±Úˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(434060,12058,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ¿Ñ€ÐµÐ¼Ð°ÑšÐ° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(434061,12058,'vi','Lá»—i khi lÆ°u tháº»',0),(434062,12058,'af','Fout met die stoor van kaart',0),(434063,12058,'ro','Eroare la salvarea Card',0),(434064,12058,'et','Kaardi salvestamisel ilmnes tÃµrge',0),(434065,12058,'si','Napaka pri shranjevanju kartice',0),(434066,12058,'ba','Kesalahan menyimpan kartu',0),(434067,12058,'nl','Fout bij het opslaan van kaart',0),(434068,12058,'fi','Virhe tallennettaessa kortti',0),(434069,12058,'no','Feil under lagring av kort',0),(434070,12058,'da','Fejl under lagring af kort',0),(434071,12058,'ko','ì¹´ë“œ ì €ìž¥ ì˜¤ë¥˜',0),(434072,12058,'he','×©×’×™××” ×‘×¢×ª ×©×ž×™×¨×ª ×›×¨×˜×™×¡',0),(434073,12058,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· ÎºÎ¬ÏÏ„Î±',0),(434074,12058,'zh','é”™è¯¯ä¿å­˜å¡',0),(434075,12058,'sv','Fel vid sparande av kort',0),(434076,12058,'it','Errore durante il salvataggio di carta',0),(434077,12058,'tl','',0),(434078,12058,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸à¸šà¸±à¸•à¸£',0),(434079,12058,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(434080,12058,'ms','Ralat Menyimpan Kad',0),(434081,12058,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸ Ø¨Ø·Ø§Ù‚Ø©',0),(434082,12058,'fr','Erreur d\'enregistrement de carte',0),(434083,12058,'jp','ã‚«ãƒ¼ãƒ‰ã®ä¿å­˜ã‚¨ãƒ©ãƒ¼',0),(434084,12058,'pt','Erro ao salvar o cartÃ£o',0),(434085,12058,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ ÐºÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(434086,12058,'es','Error Guardando Tarjeta',0),(434087,12058,'de','Fehler beim Speichern der Karte',0),(434088,12058,'en','Error Saving Card',0),(434089,12059,'is','',0),(434090,12059,'dr','Ù…Ø¬Ø§Ù†ÛŒ',0),(434091,12059,'pr','Ù…Ø¬Ø§Ù†ÛŒ',0),(434092,12059,'tr','Freebies',0),(434093,12059,'pl','Gratisy',0),(434094,12059,'bg','Freebies',0),(434095,12059,'ur','Freebies',0),(434096,12059,'sr','Ð—Ð° ÑŸÐ°Ð±Ð°ÐºÐ°',0),(434097,12059,'vi','QuÃ  táº·ng',0),(434098,12059,'af','Freebies',0),(434099,12059,'ro','Freebies',0),(434100,12059,'et','Freebies',0),(434101,12059,'si','Freebies',0),(434102,12059,'ba','Gratis',0),(434103,12059,'nl','Freebies',0),(434104,12059,'fi','Freebies',0),(434105,12059,'no','Freebies',0),(434106,12059,'da','Freebies',0),(434107,12059,'ko','ê³µì§œ',0),(434108,12059,'he','×“×‘×¨×™× ×‘×—×™× ×',0),(434109,12059,'el','Freebies',0),(434110,12059,'zh','å…è´¹èµ å“',0),(434111,12059,'sv','Freebies',0),(434112,12059,'it','Freebies',0),(434113,12059,'tl','',0),(434114,12059,'th','à¸Ÿà¸£à¸µ',0),(434115,12059,'hi','à¤®à¥à¤«à¥à¤¤',0),(434116,12059,'ms','Hadiah percuma',0),(434117,12059,'ar','Ù…Ø¬Ø§Ù†Ø§Ù‹',0),(434118,12059,'fr','Freebies',0),(434119,12059,'jp','æ™¯å“',0),(434120,12059,'pt','Freebies',0),(434121,12059,'ru','Ð¥Ð°Ð»ÑÐ²Ð°',0),(434122,12059,'es','Cosas GrÃ¡tis',0),(434123,12059,'de','Werbegeschenke',0),(434124,12059,'en','Freebies',0),(434125,12060,'is','',0),(434126,12060,'dr','Ø¯Ø±ÛŒØ§ÙØª Ù‚Ø§Ø¨Ù„ÛŒØª Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(434127,12060,'pr','Ø¯Ø±ÛŒØ§ÙØª Ù‚Ø§Ø¨Ù„ÛŒØª Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(434128,12060,'tr','Eklentileri olsun',0),(434129,12060,'pl','Pobierz Dodatki',0),(434130,12060,'bg','ÐÐ°Ð¼ÐµÑ€ÐµÑ‚Ðµ Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(434131,12060,'ur','Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(434132,12060,'sr','ÐŸÐ¾ Ð´Ð¾Ð´Ð°Ñ†Ð¸Ð¼Ð°',0),(434133,12060,'vi','láº¥y thÃªm',0),(434134,12060,'af','Kry byvoegsels',0),(434135,12060,'ro','Ia suplimente',0),(434136,12060,'et','Saad lisandmoodulid',0),(434137,12060,'si','Dobite dodatke',0),(434138,12060,'ba','Dapatkan Pengaya',0),(434139,12060,'nl','Get Add-Ons',0),(434140,12060,'fi','Etsi lisÃ¤osia',0),(434141,12060,'no','FÃ¥ tillegg',0),(434142,12060,'da','FÃ¥ tilfÃ¸jelser',0),(434143,12060,'ko','ì¶”ê°€ ê¸°ëŠ¥ì„ ì–»ì„',0),(434144,12060,'he','×”×•×¨×“ ×”×¨×—×‘×•×ª',0),(434145,12060,'el','ÎÎ± Ï€Î¬ÏÎµÏ„Îµ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î±',0),(434146,12060,'zh','èŽ·å¾—æ·»åŠ ',0),(434147,12060,'sv','FÃ¥ tillÃ¤gg',0),(434148,12060,'it','Ottenere componenti aggiuntivi',0),(434149,12060,'tl','',0),(434150,12060,'th','à¸£à¸±à¸šà¹‚à¸›à¸£à¹à¸à¸£à¸¡ Add-on',0),(434151,12060,'hi','à¤à¤¡-à¤‘à¤¨ à¤®à¤¿à¤²',0),(434152,12060,'ms','Mendapatkan tambahan',0),(434153,12060,'ar','ØªØ«Ø¨ÙŠØª Ø§Ù„Ø¥Ø¶Ø§ÙØ§Øª',0),(434154,12060,'fr','Get Add-ons',0),(434155,12060,'jp','ã‚¢ãƒ‰ã‚ªãƒ³ã‚’å…¥æ‰‹ã—ã¾ã™ã€‚',0),(434156,12060,'pt','Buscar Complementos',0),(434157,12060,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(434158,12060,'es','Consigue Add-Ons',0),(434159,12060,'de','Add-ons zu bekommen',0),(434160,12060,'en','Get Add-Ons',0),(434161,12061,'is','',0),(434162,12061,'dr','Ø¨Ø³ØªÙ‡ Ù‡Ø§ÛŒ Ø²Ø¨Ø§Ù†',0),(434163,12061,'pr','Ø¨Ø³ØªÙ‡ Ù‡Ø§ÛŒ Ø²Ø¨Ø§Ù†',0),(434164,12061,'tr','Dil paketleri',0),(434165,12061,'pl','Pakiety jÄ™zykowe',0),(434166,12061,'bg','Ð•Ð·Ð¸ÐºÐ¾Ð²Ð¸ Ð¿Ð°ÐºÐµÑ‚Ð¸',0),(434167,12061,'ur','Ø²Ø¨Ø§Ù† Ù¾ÛŒÚ©',0),(434168,12061,'sr','ÐˆÐµÐ·Ð¸Ñ‡ÐºÐ¸ Ð¿Ð°ÐºÐµÑ‚Ð¸',0),(434169,12061,'vi','gÃ³i ngÃ´n ngá»¯',0),(434170,12061,'af','Taalpakke',0),(434171,12061,'ro','Pachete de limbÄƒ',0),(434172,12061,'et','Keelepaketid',0),(434173,12061,'si','Jezikovni paketi',0),(434174,12061,'ba','Paket bahasa',0),(434175,12061,'nl','Taalpakketten',0),(434176,12061,'fi','KielenkÃ¤yttÃ¶ ahtaa',0),(434177,12061,'no','SprÃ¥kpakker',0),(434178,12061,'da','Sprog emballere',0),(434179,12061,'ko','ì–¸ì–´ íŒ©',0),(434180,12061,'he','×¢×¨×›×•×ª ×©×¤×”',0),(434181,12061,'el','Î Î±ÎºÎ­Ï„Î± Î³Î»Ï‰ÏƒÏƒÏŽÎ½',0),(434182,12061,'zh','è¯­è¨€åŒ…',0),(434183,12061,'sv','SprÃ¥kpaket',0),(434184,12061,'it','Language Pack',0),(434185,12061,'tl','',0),(434186,12061,'th','à¸Šà¸¸à¸”à¸ à¸²à¸©à¸²',0),(434187,12061,'hi','à¤­à¤¾à¤·à¤¾ à¤ªà¥ˆà¤•',0),(434188,12061,'ms','Pek bahasa',0),(434189,12061,'ar','Ø­Ø²Ù… Ø§Ù„Ù„ØºØ§Øª',0),(434190,12061,'fr','Packs de langues',0),(434191,12061,'jp','è¨€èªžãƒ‘ãƒƒã‚¯',0),(434192,12061,'pt','Pacotes de idiomas',0),(434193,12061,'ru','Ð¯Ð·Ñ‹ÐºÐ¾Ð²Ñ‹Ðµ Ð¿Ð°ÐºÐµÑ‚Ñ‹',0),(434194,12061,'es','Paquetes de Idiomas',0),(434195,12061,'de','Sprachpakete',0),(434196,12061,'en','Language Packs',0),(434197,12062,'is','',0),(434198,12062,'dr','Ù„Ø·ÙØ§ Ø§ÛŒÙ† ØµÙØ­Ù‡ Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø«Ø¨Øª Ø³Ø§Ø¨Ù‚Ù‡ Ø¨Ø±Ø§ÛŒ Ø®ÙˆØ¯ Ú†Ø§Ù¾ Ú©Ù†ÛŒØ¯  ',0),(434199,12062,'pr','Ù„Ø·ÙØ§ Ø§ÛŒÙ† ØµÙØ­Ù‡ Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø«Ø¨Øª Ø³Ø§Ø¨Ù‚Ù‡ Ø¨Ø±Ø§ÛŒ Ø®ÙˆØ¯ Ú†Ø§Ù¾ Ú©Ù†ÛŒØ¯  ',0),(434200,12062,'tr','LÃ¼tfen kayÄ±tlarÄ±nÄ±z iÃ§in bu sayfayÄ± yazdÄ±rÄ±n',0),(434201,12062,'pl','Wydrukuj tÄ™ stronÄ™ dla rekordÃ³w',0),(434202,12062,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(434203,12062,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§Ù¾Ù†Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛ ØµÙØ­Û Ù¾Ø±Ù†Ù¹ Ú©Ø±ÛŒÚº',0),(434204,12062,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜Ñ‚Ðµ Ð¾Ð²Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð·Ð° ÑÐ²Ð¾Ñ˜Ñƒ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ñƒ',0),(434205,12062,'vi','vui lÃ²ng in trang nÃ y Ä‘á»ƒ báº¡n ghi sá»•',0),(434206,12062,'af','Druk asseblief hierdie bladsy vir jou rekords',0),(434207,12062,'ro','VÄƒ rugÄƒm sÄƒ imprimaÅ£i aceastÄƒ paginÄƒ pentru Ã®nregistrÄƒri',0),(434208,12062,'et','Palun printige see leht oma kirjehalduse jaoks',0),(434209,12062,'si','Natisnite to stran za svojo evidenco',0),(434210,12062,'ba','Cetaklah Halaman ini untuk catatan Anda',0),(434211,12062,'nl','Gelieve deze pagina voor uw administratie afdrukken',0),(434212,12062,'fi','Tulosta tÃ¤mÃ¤ sivu itsellesi',0),(434213,12062,'no','Skriv ut denne siden For oppfÃ¸ringene',0),(434214,12062,'da','Venligst Print denne side til din registreringer',0),(434215,12062,'ko','ë‹¹ì‹ ì˜ ê¸°ë¡ ìœ„í•œì´ íŽ˜ì´ì§€ë¥¼ ì¸ì‡„ í•˜ì‹­ì‹œì˜¤',0),(434216,12062,'he','× × ×œ×”×“×¤×™×¡ ×“×£ ×–×” ×¢×‘×•×¨ ×”×¨×©×•×ž×•×ª ×©×œ×š',0),(434217,12062,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï„Ï…Ï€ÏŽÏƒÏ„Îµ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ»Î¯Î´Î± Î³Î¹Î± Ï„Î¿ Î‘Î¡Î§Î•Î™ÎŸ Î£Î‘Î£',0),(434218,12062,'zh','è¯·æ‰“å°æ‚¨çš„è®°å½•é¡µé¢',0),(434219,12062,'sv','VÃ¤nligen skriv ut denna sida fÃ¶r din bokfÃ¶ring',0),(434220,12062,'it','Si prega di stampare questa pagina per le vostre annotazioni',0),(434221,12062,'tl','',0),(434222,12062,'th','à¹‚à¸›à¸£à¸”à¸žà¸´à¸¡à¸žà¹Œà¸«à¸™à¹‰à¸²à¸™à¸µà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(434223,12062,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤ªà¤¨à¥‡ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‹ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(434224,12062,'ms','Sila cetak halaman ini untuk rujukan anda',0),(434225,12062,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø·Ø¨Ø§Ø¹Ø© Ù‡Ø°Ù‡ Ø§Ù„ØµÙØ­Ø© Ù„Ù„Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(434226,12062,'fr','Veuillez imprimer cette Page pour vos dossiers',0),(434227,12062,'jp','ã“ã®ãƒšãƒ¼ã‚¸ã¯è¨˜éŒ²ã¨ã—ã¦å°åˆ·ã—ã¦ãã ã•ã„ã€‚',0),(434228,12062,'pt','Por favor, imprima esta pÃ¡gina para seus registros',0),(434229,12062,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ñ€Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ ÑÑ‚Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð´Ð»Ñ Ð²Ð°ÑˆÐ¸Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(434230,12062,'es','Por Favor Imprime Esta PÃ¡gina Para Sus Archivos',0),(434231,12062,'de','Bitte drucken Sie diese Seite fÃ¼r Ihre Unterlagen',0),(434232,12062,'en','Please Print This Page For Your Records',0),(434233,12063,'is','',0),(434234,12063,'dr','...',0),(434235,12063,'pr','Ù¾Ù„Ø§Ú¯ÛŒÙ†...',0),(434236,12063,'tr','Plug-Ins',0),(434237,12063,'pl','Szpunt Ins',0),(434238,12063,'bg','Ð”Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(434239,12063,'ur','Ù¾Ù„Ú¯ Ø§Ù†',0),(434240,12063,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ðµ',0),(434241,12063,'vi','cá»™ng',0),(434242,12063,'af','Invoegtoepassings',0),(434243,12063,'ro','Plug-in-uri',0),(434244,12063,'et','Plug-Ins',0),(434245,12063,'si','Plug-Ins',0),(434246,12063,'ba','Plug-in',0),(434247,12063,'nl','Plug-Ins',0),(434248,12063,'fi','Plug-Ins',0),(434249,12063,'no','Plug-Ins',0),(434250,12063,'da','Plug-Ins',0),(434251,12063,'ko','í”ŒëŸ¬ê·¸ ì¸',0),(434252,12063,'he','×™×™×©×•×ž×™ plug-In',0),(434253,12063,'el','Plug-Ins',0),(434254,12063,'zh','æ’ä»¶',0),(434255,12063,'sv','Plug-Ins',0),(434256,12063,'it','Plug-in',0),(434257,12063,'tl','',0),(434258,12063,'th','à¸›à¸¥à¸±à¹Šà¸à¸­à¸´à¸™',0),(434259,12063,'hi','à¤ªà¥à¤²à¤—-à¤‡à¤¨',0),(434260,12063,'ms','Pasang Masuk',0),(434261,12063,'ar','Ø§Ù„Ù…ÙƒÙˆÙ†Ø§Øª Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(434262,12063,'fr','Plug-Ins',0),(434263,12063,'jp','ãƒ—ãƒ©ã‚°ã‚¤ãƒ³',0),(434264,12063,'pt','Plug-Ins',0),(434265,12063,'ru','ÐŸÐ¾Ð´ÐºÐ»ÑŽÑ‡Ð°ÐµÐ¼Ñ‹Ðµ Ð¼Ð¾Ð´ÑƒÐ»Ð¸',0),(434266,12063,'es','Plug-Ins',0),(434267,12063,'de','Plug-Ins',0),(434268,12063,'en','Plug-Ins',0),(434269,12064,'is','',0),(434270,12064,'dr','Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ Ø®Ø§Ø±Ø¬ Ø§Ø² ØªØ§Ø±ÛŒØ® Ø§Ø³Øª',0),(434271,12064,'pr','Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ Ø®Ø§Ø±Ø¬ Ø§Ø² ØªØ§Ø±ÛŒØ® Ø§Ø³Øª',0),(434272,12064,'tr','FiyatlandÄ±rma gÃ¼ncel deÄŸil',0),(434273,12064,'pl','Ustalanie cen jest nieaktualny',0),(434274,12064,'bg','Ð¦ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½ÐµÑ‚Ð¾ Ðµ Ð¾ÑÑ‚Ð°Ñ€ÑÐ»',0),(434275,12064,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø§Ù†ÛŒ ÛÛ’',0),(434276,12064,'sr','Ð¦ÐµÐ½Ð° Ñ˜Ðµ Ð¸ÑÑ‚ÐµÐºÐ°Ð¾ Ñ€Ð¾Ðº Ñ‚Ñ€Ð°Ñ˜Ð°ÑšÐ°',0),(434277,12064,'vi','háº¿t giÃ¡',0),(434278,12064,'af','Pryse Is verouderd',0),(434279,12064,'ro','De stabilire a preÅ£urilor este neactualizat',0),(434280,12064,'et','Hinnakujundus on aegunud',0),(434281,12064,'si','Cenitev je zastarel',0),(434282,12064,'ba','Harga sudah usang',0),(434283,12064,'nl','Prijsstelling Is verouderd',0),(434284,12064,'fi','Hinnoittelu on vanhentunut',0),(434285,12064,'no','Priser er utdatert',0),(434286,12064,'da','PrissÃ¦tning er forÃ¦ldet',0),(434287,12064,'ko','ìµœì‹ ì€ ê°€ê²©',0),(434288,12064,'he','×”×ª×ž×—×•×¨ ××™× ×• ×ž×¢×•×“×›×Ÿ',0),(434289,12064,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÎµÎ¯Î½Î±Î¹ Î¾ÎµÏ€ÎµÏÎ±ÏƒÎ¼Î­Î½Î¿',0),(434290,12064,'zh','ä»·æ ¼é€¾æœŸ',0),(434291,12064,'sv','PrissÃ¤ttning Ã¤r fÃ¶rÃ¥ldrad',0),(434292,12064,'it','Prezzi Ã¨ scaduto',0),(434293,12064,'tl','',0),(434294,12064,'th','à¸£à¸²à¸„à¸²à¹„à¸¡à¹ˆà¹€à¸›à¹‡à¸™à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(434295,12064,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤¹à¥ˆ',0),(434296,12064,'ms','Harga sudah lapuk',0),(434297,12064,'ar','Ø§Ù„ØªØ³Ø¹ÙŠØ± Ù‚Ø¯ÙŠÙ…Ø§',0),(434298,12064,'fr','La tarification est obsolÃ¨te',0),(434299,12064,'jp','ä¾¡æ ¼ã¯æœŸé™åˆ‡ã‚Œã§ã™ã€‚',0),(434300,12064,'pt','O preÃ§o Ã© fora da data',0),(434301,12064,'ru','Ð¦ÐµÐ½Ñ‹ ÑƒÑÑ‚Ð°Ñ€ÐµÐ»Ð¸',0),(434302,12064,'es','Precios Son Caducados',0),(434303,12064,'de','Preisgestaltung ist veraltet',0),(434304,12064,'en','Pricing Is Out Of Date',0),(434305,12065,'is','',0),(434306,12065,'dr','Ø®Ø±ÛŒØ¯ Ù‚Ø§Ø¨Ù„ÛŒØª Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(434307,12065,'pr','Ø®Ø±ÛŒØ¯ Ù‚Ø§Ø¨Ù„ÛŒØª Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(434308,12065,'tr','Eklentiler satÄ±n',0),(434309,12065,'pl','Zakup Dodatki',0),(434310,12065,'bg','ÐšÑƒÐ¿ÑƒÐ²Ð°Ñ‚ Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(434311,12065,'ur','Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(434312,12065,'sr','Ð”Ð¾Ð´Ð°Ñ†Ð¸ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(434313,12065,'vi','mua thÃªm',0),(434314,12065,'af','Koop byvoegsels',0),(434315,12065,'ro','Cumpara Suplimente',0),(434316,12065,'et','Osta lisandmoodulid',0),(434317,12065,'si','Nakup dodatkov',0),(434318,12065,'ba','Pembelian Pengaya',0),(434319,12065,'nl','Aankoop Add-Ons',0),(434320,12065,'fi','Ostaa lisÃ¤osia',0),(434321,12065,'no','KjÃ¸pe tilleggsprogrammer',0),(434322,12065,'da','KÃ¸b tilfÃ¸jelser',0),(434323,12065,'ko','ì¶”ê°€ êµ¬ë§¤',0),(434324,12065,'he','×œ×¨×›×•×© ×ª×•×¡×¤×•×ª',0),(434325,12065,'el','Î‘Î³Î¿ÏÎ¬ÏƒÎ¿Ï…Î½ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î±',0),(434326,12065,'zh','é‡‡è´­åŠ è½½é¡¹',0),(434327,12065,'sv','KÃ¶pa Add-Ons',0),(434328,12065,'it','Acquistare componenti aggiuntivi',0),(434329,12065,'tl','',0),(434330,12065,'th','à¸‹à¸·à¹‰à¸­à¹‚à¸›à¸£à¹à¸à¸£à¸¡ Add-on',0),(434331,12065,'hi','à¤à¤¡-à¤‘à¤¨ à¤•à¥€ à¤–à¤°à¥€à¤¦',0),(434332,12065,'ms','Pembelian tambahan',0),(434333,12065,'ar','Ø´Ø±Ø§Ø¡ Ø§Ù„Ø¥Ø¶Ø§ÙØ§Øª',0),(434334,12065,'fr','Acheter des modules',0),(434335,12065,'jp','ã‚¢ãƒ‰ã‚ªãƒ³ã‚’è³¼å…¥ã—ã¾ã™ã€‚',0),(434336,12065,'pt','Complementos de compra',0),(434337,12065,'ru','ÐŸÑ€Ð¸Ð¾Ð±Ñ€ÐµÑÑ‚Ð¸ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(434338,12065,'es','Compras - Add-Ons',0),(434339,12065,'de','Add-ons zu kaufen',0),(434340,12065,'en','Purchase Add-Ons',0),(434341,12066,'is','',0),(434342,12066,'dr','Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ù‡Ø§ÛŒ Ø®Ø±ÛŒØ¯',0),(434343,12066,'pr','Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ù‡Ø§ÛŒ Ø®Ø±ÛŒØ¯',0),(434344,12066,'tr','Eklentiler satÄ±n',0),(434345,12066,'pl','Zakup Dodatki',0),(434346,12066,'bg','ÐšÑƒÐ¿ÑƒÐ²Ð°Ñ‚ Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(434347,12066,'ur','Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(434348,12066,'sr','Ð”Ð¾Ð´Ð°Ñ†Ð¸ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(434349,12066,'vi','Mua Tiá»‡n Ã­ch',0),(434350,12066,'af','Koop byvoegsels',0),(434351,12066,'ro','Cumpara Suplimente',0),(434352,12066,'et','Osta lisandmoodulid',0),(434353,12066,'si','Nakup dodatkov',0),(434354,12066,'ba','Pembelian Pengaya',0),(434355,12066,'nl','Aankoop Add-Ons',0),(434356,12066,'fi','Ostaa lisÃ¤osia',0),(434357,12066,'no','KjÃ¸pe tilleggsprogrammer',0),(434358,12066,'da','KÃ¸b tilfÃ¸jelser',0),(434359,12066,'ko','ì¶”ê°€ êµ¬ë§¤',0),(434360,12066,'he','×œ×¨×›×•×© ×ª×•×¡×¤×•×ª',0),(434361,12066,'el','Î‘Î³Î¿ÏÎ¬ÏƒÎ¿Ï…Î½ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î±',0),(434362,12066,'zh','è´­ä¹°åŠ è½½é¡¹',0),(434363,12066,'sv','KÃ¶pa Add-Ons',0),(434364,12066,'it','Acquistare componenti aggiuntivi',0),(434365,12066,'tl','',0),(434366,12066,'th','à¸‹à¸·à¹‰à¸­à¹‚à¸›à¸£à¹à¸à¸£à¸¡ Add-on',0),(434367,12066,'hi','à¤à¤¡-à¤‘à¤¨ à¤•à¥€ à¤–à¤°à¥€à¤¦',0),(434368,12066,'ms','Pembelian tambahan',0),(434369,12066,'ar','Ø´Ø±Ø§Ø¡ Ø§Ù„Ø¥Ø¶Ø§ÙØ§Øª',0),(434370,12066,'fr','Acheter des modules',0),(434371,12066,'jp','ã‚¢ãƒ‰ã‚ªãƒ³ã‚’è³¼å…¥ã—ã¾ã™ã€‚',0),(434372,12066,'pt','Complementos de compra',0),(434373,12066,'ru','ÐŸÑ€Ð¸Ð¾Ð±Ñ€ÐµÑÑ‚Ð¸ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(434374,12066,'es','Adquirir complementos',0),(434375,12066,'de','Add-ons zu kaufen',0),(434376,12066,'en','Purchase Add-Ons',0),(434377,12067,'is','',0),(434378,12067,'dr','ØªØ§ÛŒÛŒØ¯ Ø®Ø±ÛŒØ¯ Ø®Ø§Ø±Ø¬ Ø§Ø² ØªØ§Ø±ÛŒØ® Ø§Ø³Øª',0),(434379,12067,'pr','ØªØ§ÛŒÛŒØ¯ Ø®Ø±ÛŒØ¯ Ø®Ø§Ø±Ø¬ Ø§Ø² ØªØ§Ø±ÛŒØ® Ø§Ø³Øª',0),(434380,12067,'tr','SatÄ±n alma onay tarihi',0),(434381,12067,'pl','Potwierdzenie zakupu jest nieaktualny',0),(434382,12067,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ðµ Ð¾ÑÑ‚Ð°Ñ€ÑÐ»Ð°',0),(434383,12067,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø§Ù†ÛŒ ÛÛ’',0),(434384,12067,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ñ˜Ðµ Ð¸ÑÑ‚ÐµÐºÐ°Ð¾ Ñ€Ð¾Ðº Ñ‚Ñ€Ð°Ñ˜Ð°ÑšÐ°',0),(434385,12067,'vi','Ä‘Ã£ quÃ¡ ngÃ y xÃ¡c nháº­n mua hÃ ng ',0),(434386,12067,'af','Aankoop bevestiging Is verouderd',0),(434387,12067,'ro','CumpÄƒrare de confirmare este de actualitate',0),(434388,12067,'et','Ostu kinnitamine on aegunud',0),(434389,12067,'si','Potrditev nabavnega zastarela',0),(434390,12067,'ba','Konfirmasi pembelian sudah usang',0),(434391,12067,'nl','Aankoop bevestiging Is verouderd',0),(434392,12067,'fi','Ostotilauksen vahvistus vanhentumisesta',0),(434393,12067,'no','Bestillingsbekreftelse er utdatert',0),(434394,12067,'da','KÃ¸b bekrÃ¦ftelse er forÃ¦ldet',0),(434395,12067,'ko','êµ¬ë§¤ í™•ì¸ì´ ìµœì‹ ',0),(434396,12067,'he','×”×ª×•×›× ×” ××™× ×” ×ž×¢×•×“×›× ×ª',0),(434397,12067,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·Ï‚ Î±Î³Î¿ÏÎ¬Ï‚ ÎµÎ¯Î½Î±Î¹ Î¾ÎµÏ€ÎµÏÎ±ÏƒÎ¼Î­Î½Î¿',0),(434398,12067,'zh','è´­ä¹°ç¡®è®¤å·²ç»è¿‡æœŸ',0),(434399,12067,'sv','KÃ¶p bekrÃ¤ftelse Ã¤r fÃ¶rÃ¥ldrad',0),(434400,12067,'it','Conferma di acquisto Ã¨ scaduto',0),(434401,12067,'tl','',0),(434402,12067,'th','à¸¢à¸·à¸™à¸¢à¸±à¸™à¸‹à¸·à¹‰à¸­à¸ˆà¸°à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(434403,12067,'hi','à¤–à¤°à¥€à¤¦ à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤¹à¥ˆ',0),(434404,12067,'ms','Pengesahan pembelian sudah lapuk',0),(434405,12067,'ar','ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø´Ø±Ø§Ø¡ Ù‚Ø¯ÙŠÙ…Ø§',0),(434406,12067,'fr','Confirmation de l\'achat est pÃ©rimÃ©e',0),(434407,12067,'jp','è³¼å…¥ç¢ºèªã®æœŸé™ãŒåˆ‡ã‚Œã¦',0),(434408,12067,'pt','ConfirmaÃ§Ã£o de compra estÃ¡ desatualizada',0),(434409,12067,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÑÐ²Ð»ÑÐµÑ‚ÑÑ ÑƒÑÑ‚Ð°Ñ€ÐµÐ²ÑˆÐ¸Ð¼',0),(434410,12067,'es','ConfirmaciÃ³n de Compras es Caducada',0),(434411,12067,'de','KaufbestÃ¤tigung ist veraltet',0),(434412,12067,'en','Purchase Confirmation Is Out Of Date',0),(434413,12068,'is','',0),(434414,12068,'dr','Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§Ø¬Ù‡Øª Ø³ÙØ§Ø±Ø´ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ÛŒØ§Ø¬Ù‡Øª Ø¯ÛŒØ¯Ù† ØªÙˆØ¶ÛŒØ­ Ø²ÛŒØ±Ø±ÙˆÛŒ Ù†Ø§Ù… Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ ',0),(434415,12068,'pr','Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§Ø¬Ù‡Øª Ø³ÙØ§Ø±Ø´ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ÛŒØ§Ø¬Ù‡Øª Ø¯ÛŒØ¯Ù† ØªÙˆØ¶ÛŒØ­ Ø²ÛŒØ±Ø±ÙˆÛŒ Ù†Ø§Ù… Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ ',0),(434416,12068,'tr','SipariÅŸe Eklentiler\'i seÃ§in veya aÅŸaÄŸÄ±daki aÃ§Ä±klamayÄ± gÃ¶rmek iÃ§in tÄ±klatÄ±n',0),(434417,12068,'pl','Wybierz Dodatki na zamÃ³wienie lub kliknij nazwÄ™, aby zobaczyÄ‡ opis poniÅ¼ej',0),(434418,12068,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸, Ð·Ð° Ð´Ð° Ñ€ÐµÐ´ Ð¸Ð»Ð¸ Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð¸Ð¼Ðµ, Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸ÐµÑ‚Ð¾ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ',0),(434419,12068,'ur','Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº ÛŒØ§ Ù†ÛŒÚ†Û’ ØªØµØ±ÛŒØ­ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†Ø§Ù… Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(434420,12068,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ Ð¸Ð»Ð¸ ÐºÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð¸Ð¼Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð²Ð¸Ð´ÐµÐ»Ð¸ Ð¾Ð¿Ð¸Ñ Ð¸ÑÐ¿Ð¾Ð´',0),(434421,12068,'vi','Chá»n Add-ons Ä‘á»ƒ Ä‘áº·t hoáº·c nháº¥p vÃ o tÃªn Ä‘á»ƒ xem diá»…n giáº£i bÃªn dÆ°á»›i',0),(434422,12068,'af','Kies byvoegings tot orde of naam sien Beskrywing hieronder klik',0),(434423,12068,'ro','SelectaÅ£i suplimente la comandÄƒ sau faceÅ£i clic pe numele pentru a vedea Descrierea de mai jos',0),(434424,12068,'et','Valige lisandmoodulid tellimuse vÃµi klÃµpsake, et nÃ¤ha allpool kirjeldus',0),(434425,12068,'si','Izberite dodatke v vrstnem redu ali kliknite ime, da vidite opis spodaj',0),(434426,12068,'ba','Pilih Pengaya untuk memesan atau klik nama untuk melihat keterangan di bawah ini',0),(434427,12068,'nl','Selecteer Add-Ons om te bestellen of klik op naam om beschrijving hieronder te zien',0),(434428,12068,'fi','Valitse lisÃ¤osat jÃ¤rjestyksessÃ¤ tai saat kuvaus alla',0),(434429,12068,'no','Velg Tilleggsprogrammer pÃ¥ bestilling eller klikk for Ã¥ se beskrivelse nedenfor',0),(434430,12068,'da','VÃ¦lg TilfÃ¸jelser til ordre eller klik pÃ¥ navn for at se beskrivelsen nedenfor',0),(434431,12068,'ko','ì£¼ë¬¸ ì¶”ê°€ ê¸°ëŠ¥ì„ ì„ íƒ í•˜ê±°ë‚˜ ì•„ëž˜ ì„¤ëª… ì°¸ì¡° ì´ë¦„ì„ í´ë¦­í•©ë‹ˆë‹¤',0),(434432,12068,'he','×‘×—×¨ ×ª×•×¡×¤×•×ª ×œ×¤×™ ×”×–×ž× ×” ××• ×œ×—×¥ ×¢×œ ×©× ×›×“×™ ×œ×¨××•×ª ××ª ×ª×™××•×¨ ×œ×”×œ×Ÿ',0),(434433,12068,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î± ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î· Î® ÎºÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÏŒÎ½Î¿Î¼Î± Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰',0),(434434,12068,'zh','é€‰æ‹©é™„åŠ é¡¹ä»¥è´­ä¹°æˆ–è€…ç‚¹å‡»åç§°æŸ¥çœ‹ä¸‹é¢çš„æè¿°',0),(434435,12068,'sv','VÃ¤lj tillÃ¤gg pÃ¥ bestÃ¤llning eller klicka pÃ¥ namn fÃ¶r att se beskrivning nedan',0),(434436,12068,'it','Seleziona componenti aggiuntivi all\'ordine o fare clic sul nome per vedere la descrizione qui sotto',0),(434437,12068,'tl','',0),(434438,12068,'th','à¹€à¸¥à¸·à¸­à¸à¹‚à¸›à¸£à¹à¸à¸£à¸¡ Add-on à¹€à¸žà¸·à¹ˆà¸­à¸ªà¸±à¹ˆà¸‡ à¸«à¸£à¸·à¸­à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸Šà¸·à¹ˆà¸­à¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡',0),(434439,12068,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤¡-à¤‘à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¾à¤® à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(434440,12068,'ms','Pilih tambahan untuk pesanan atau klik nama untuk lihat penerangan di bawah',0),(434441,12068,'ar','Ø§Ø®ØªØ± Ø§Ù„Ø¥Ø¶Ø§ÙØ§Øª Ù„Ø´Ø±Ø§Ø¦Ù‡Ø§ Ø£Ùˆ Ø§Ù†Ù‚Ø± Ø§Ø³Ù…Ù‡Ø§ Ù„ØªØ­ØµÙ„ Ø¹Ù„Ù‰ ÙˆØµÙÙ‡Ø§ Ø¨Ø§Ù„Ø£Ø³ÙÙ„',0),(434442,12068,'fr','SÃ©lectionnez modules commande ou cliquez sur nom pour voir la description ci-dessous',0),(434443,12068,'jp','æ³¨æ–‡ã™ã‚‹ã‚¢ãƒ‰ã‚ªãƒ³ã‚’é¸æŠžã—ã¾ã™ã¾ãŸã¯ä¸‹ã®èª¬æ˜Žã‚’å‚ç…§ã™ã‚‹åå‰ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(434444,12068,'pt','Selecione Complementos Ã  ordem ou clique no nome para ver a descriÃ§Ã£o abaixo',0),(434445,12068,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ðº Ð¿Ð¾Ñ€ÑÐ´ÐºÑƒ Ð¸Ð»Ð¸ Ð½Ð°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐºÐ½Ð¾Ð¿ÐºÑƒ Ð¸Ð¼Ñ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑƒÐ²Ð¸Ð´ÐµÑ‚ÑŒ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð¸Ð¶Ðµ',0),(434446,12068,'es','Selecciona Add-Ons para Comprar o Clik el Nombre para Ver la DescripciÃ³n Abajo',0),(434447,12068,'de','WÃ¤hlen Sie Add-ons zu bestellen oder klicken Sie auf Name, Beschreibung weiter unten zu sehen',0),(434448,12068,'en','Select Add-Ons to order or click name to see description below',0),(434449,12069,'is','',0),(434450,12069,'dr','Ú©Ø§Ø±Øª Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡',0),(434451,12069,'pr','Ú©Ø§Ø±Øª Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡',0),(434452,12069,'tr','SaklÄ± kartÄ±',0),(434453,12069,'pl','Przechowywane karty',0),(434454,12069,'bg','Ð¡ÑŠÑ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ‚Ðµ ÐºÐ°Ñ€Ñ‚Ð°',0),(434455,12069,'ur','Ø°Ø®ÛŒØ±Û Ø´Ø¯Û Ú©Ø§Ø±Úˆ',0),(434456,12069,'sr','Ð£ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚ÐµÐ½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(434457,12069,'vi','Tháº» lÆ°u trá»¯',0),(434458,12069,'af','Gestoorde kaart',0),(434459,12069,'ro','Stocate Card',0),(434460,12069,'et','Salvestatud kaardi',0),(434461,12069,'si','Shranjena kartica',0),(434462,12069,'ba','Kartu disimpan',0),(434463,12069,'nl','Opgeslagen kaart',0),(434464,12069,'fi','Tallennetut kortin',0),(434465,12069,'no','Lagrede kort',0),(434466,12069,'da','Gemte kort',0),(434467,12069,'ko','ì €ìž¥ëœ ì¹´ë“œ',0),(434468,12069,'he','×›×¨×˜×™×¡ ×ž××•×—×¡× ×ª',0),(434469,12069,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏ…Î¼Î­Î½Î· ÎºÎ¬ÏÏ„Î±',0),(434470,12069,'zh','å­˜å‚¨å¡',0),(434471,12069,'sv','Lagrade kort',0),(434472,12069,'it','Carta memorizzato',0),(434473,12069,'tl','',0),(434474,12069,'th','à¸šà¸±à¸•à¸£à¹€à¸à¹‡à¸šà¹„à¸§à¹‰',0),(434475,12069,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹à¤¿à¤¤ à¤•à¤¾à¤°à¥à¤¡',0),(434476,12069,'ms','Kad disimpan',0),(434477,12069,'ar','Ø¨Ø·Ø§Ù‚Ø© Ù…Ø®Ø²Ù†',0),(434478,12069,'fr','Carte stockÃ©e',0),(434479,12069,'jp','ã‚¹ãƒˆã‚¢ãƒ‰ã®ã‚«ãƒ¼ãƒ‰',0),(434480,12069,'pt','CartÃ£o armazenado',0),(434481,12069,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(434482,12069,'es','Tarjeta Almecenada',0),(434483,12069,'de','Gespeicherte Karte',0),(434484,12069,'en','Stored Card',0),(434485,12070,'is','',0),(434486,12070,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú©Ø§Ø±Øª Ø¯ÛŒÚ¯Ø±',0),(434487,12070,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú©Ø§Ø±Øª Ø¯ÛŒÚ¯Ø±',0),(434488,12070,'tr','DiÄŸer kart kullan',0),(434489,12070,'pl','UÅ¼yj inne karty',0),(434490,12070,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(434491,12070,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø¯ÛŒÚ¯Ø± Ú©Ø§Ø±Úˆ',0),(434492,12070,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð´Ñ€ÑƒÐ³Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(434493,12070,'vi','Sá»­ dá»¥ng tháº» khÃ¡c',0),(434494,12070,'af','Gebruik ander kaart',0),(434495,12070,'ro','Utilizarea alt Card',0),(434496,12070,'et','Kasutamine teiste kaart',0),(434497,12070,'si','Uporabo druge kartice',0),(434498,12070,'ba','Penggunaan kartu lain',0),(434499,12070,'nl','Gebruik andere kaart',0),(434500,12070,'fi','KÃ¤yttÃ¤Ã¤ muita kortin',0),(434501,12070,'no','Bruk andre kort',0),(434502,12070,'da','Brug andre kort',0),(434503,12070,'ko','ë‹¤ë¥¸ ì¹´ë“œì— ì‚¬ìš©',0),(434504,12070,'he','×©×™×ž×•×© ×§×œ×£ ××—×¨',0),(434505,12070,'el','Î§ÏÎ®ÏƒÎ· Î¬Î»Î»Î· ÎºÎ¬ÏÏ„Î±',0),(434506,12070,'zh','ä½¿ç”¨å…¶ä»–å¡',0),(434507,12070,'sv','AnvÃ¤nda andra kort',0),(434508,12070,'it','Uso altre Card',0),(434509,12070,'tl','',0),(434510,12070,'th','à¹ƒà¸Šà¹‰à¸šà¸±à¸•à¸£à¸­à¸·à¹ˆà¸™',0),(434511,12070,'hi','à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¥‡ à¤…à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¡',0),(434512,12070,'ms','Penggunaan Kad',0),(434513,12070,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¨Ø·Ø§Ù‚Ø© Ø£Ø®Ø±Ù‰',0),(434514,12070,'fr','Utiliser une autre carte',0),(434515,12070,'jp','ãã®ä»–ã‚«ãƒ¼ãƒ‰ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(434516,12070,'pt','Usar outro cartÃ£o',0),(434517,12070,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(434518,12070,'es','Usa Otra Tarjeta',0),(434519,12070,'de','Verwendung andere Karte',0),(434520,12070,'en','Use Other Card',0),(434521,12071,'is','',0),(434522,12071,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡ ',0),(434523,12071,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡ ',0),(434524,12071,'tr','SaklÄ± kredi kartÄ± kullanÄ±n',0),(434525,12071,'pl','UÅ¼yj karty kredytowej przechowywane',0),(434526,12071,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÑÑŠÑ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(434527,12071,'ur','Ø°Ø®ÛŒØ±Û Ø´Ø¯Û Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(434528,12071,'sr','Ð£ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚ÐµÐ½Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(434529,12071,'vi','Sá»­ dá»¥ng tháº» tÃ­n dá»¥ng lÆ°u trá»¯',0),(434530,12071,'af','Gestoorde kredietkaart gebruik',0),(434531,12071,'ro','Utilizarea stocate Card de Credit',0),(434532,12071,'et','Kasuta salvestatud krediitkaardi',0),(434533,12071,'si','Uporabite shranjena kreditne kartice',0),(434534,12071,'ba','Gunakan kartu kredit disimpan',0),(434535,12071,'nl','Opgeslagen creditcard gebruiken',0),(434536,12071,'fi','KÃ¤yttÃ¤Ã¤ tallennetun luottokortin',0),(434537,12071,'no','Bruk lagret kredittkort',0),(434538,12071,'da','Bruge lagrede kreditkort',0),(434539,12071,'ko','ì €ìž¥ ëœ ì‹ ìš© ì¹´ë“œë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(434540,12071,'he','×©×™×ž×•×© ×”×ž××•×—×¡× ×™× ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(434541,12071,'el','Î§ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸Î·ÎºÎµÏÎ¿Î½Ï„Î±Î¹ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(434542,12071,'zh','ä½¿ç”¨åº“å­˜çš„ä¿¡ç”¨å¡',0),(434543,12071,'sv','AnvÃ¤nda lagrade kreditkort',0),(434544,12071,'it','Utilizzare la carta di credito memorizzato',0),(434545,12071,'tl','',0),(434546,12071,'th','à¹ƒà¸Šà¹‰à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¹„à¸§à¹‰',0),(434547,12071,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹à¤¿à¤¤ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(434548,12071,'ms','Menggunakan kad kredit yang disimpan',0),(434549,12071,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… ØªØ®Ø²ÙŠÙ† Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(434550,12071,'fr','Utilisez la carte de crÃ©dit stockÃ©',0),(434551,12071,'jp','ä¿å­˜æ¸ˆã¿ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(434552,12071,'pt','Usar cartÃ£o de crÃ©dito armazenado',0),(434553,12071,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(434554,12071,'es','Usa Tarjeta de CrÃ©dito Almacenada',0),(434555,12071,'de','Gespeicherte Kreditkarte benutzen',0),(434556,12071,'en','Use Stored Credit Card',0),(434557,12072,'is','',0),(434558,12072,'dr','Ú©Ø§Ø±Øª Ø´Ù…Ø§ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª Ø±Ø§ÛŒÚ¯Ø§Ù† Ø´Ø§Ø±Ú˜ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(434559,12072,'pr','Ú©Ø§Ø±Øª Ø´Ù…Ø§ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª Ø±Ø§ÛŒÚ¯Ø§Ù† Ø´Ø§Ø±Ú˜ Ù†Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(434560,12072,'tr','KartÄ±nÄ±zÄ± SipariÅŸler Ãœcretsiz Ã¼cret alÄ±nmayacaktÄ±r',0),(434561,12072,'pl','Twoja karta nie zostanie obciÄ…Å¼ona za darmo zamÃ³wienia',0),(434562,12072,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð½ÑÐ¼Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸ Ð·Ð° ÑÐ²Ð¾Ð±Ð¾Ð´Ð½Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(434563,12072,'ur','Ø¢Ù¾ Ú©Ø§ Ú©Ø§Ø±Úˆ Ù…ÙØª Ú©Û’ Ù„Ø¦Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú†Ø§Ø±Ø¬ Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§ Ù†ÛÛŒÚº',0),(434564,12072,'sr','Ð¢Ð²Ð¾Ñ˜Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° ÑÐµ Ð½ÐµÑ›Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(434565,12072,'vi','Tháº» cá»§a báº¡n sáº½ khÃ´ng pháº£i tráº£ Äá»‘i vá»›i cÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng miá»…n phÃ­',0),(434566,12072,'af','Jou kaart sal nie gehef word vir gratis bestellings',0),(434567,12072,'ro','Cardul va percepe gratuit pentru comenzi',0),(434568,12072,'et','Teie kaart ei vÃµeta tasuta tellimused',0),(434569,12072,'si','Kartica ne bo bremenjena brezplaÄno naroÄila',0),(434570,12072,'ba','Kartu Anda tidak akan dikenakan gratis pesanan',0),(434571,12072,'nl','De creditcard zal niet worden afgeschreven kostenloos Orders',0),(434572,12072,'fi','Kortti ei veloiteta ilmaiseksi tilaukset',0),(434573,12072,'no','Kortet blir ikke belastet gratis ordrer',0),(434574,12072,'da','Dit kort opkrÃ¦vet ikke gratis ordrer',0),(434575,12072,'ko','ê·€í•˜ì˜ ì¹´ë“œëŠ” ë¶€ê³¼ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤ ë¬´ë£Œ ì£¼ë¬¸',0),(434576,12072,'he','×”×›×¨×˜×™×¡ ×©×œ×š ×œ× ×™×—×•×™×‘ ×”×–×ž× ×•×ª ×—×™× ×',0),(434577,12072,'el','Î£Î±Ï‚ ÎºÎ¬ÏÏ„Î± Î´ÎµÎ½ Î¸Î± Ï‡ÏÎµÏ‰Î¸ÎµÎ¯ Î´Ï‰ÏÎµÎ¬Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(434578,12072,'zh','æ‚¨çš„å¡ä¸éœ€ä¸ºå…è´¹è®¢å•ä»˜è´¹',0),(434579,12072,'sv','Ditt kort debiteras inte gratis order',0),(434580,12072,'it','La carta non sarÃ  addebitata gratis ordini',0),(434581,12072,'tl','',0),(434582,12072,'th','à¸šà¸±à¸•à¸£à¸‚à¸­à¸‡à¸„à¸¸à¸“à¸ˆà¸°à¹„à¸¡à¹ˆà¸„à¸´à¸”à¸„à¹ˆà¸²à¸šà¸£à¸´à¸à¸²à¸£à¸Ÿà¸£à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(434583,12072,'hi','à¤†à¤ªà¤•à¤¾ à¤•à¤¾à¤°à¥à¤¡ à¤®à¥à¤•à¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤¨à¤¹à¥€à¤‚ à¤²à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾',0),(434584,12072,'ms','Kad anda tidak akan dicaj secara percuma pesanan',0),(434585,12072,'ar','Ø§Ù„Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ Ù„Ø§ ÙŠØªÙ… Ø§Ø­ØªØ³Ø§Ø¨ Ù…Ø¬Ø§Ù†Ø§Ù‹ Ø£ÙˆØ§Ù…Ø±',0),(434586,12072,'fr','Votre carte ne sera pas dÃ©bitÃ©e gratuite arrÃªtÃ©s',0),(434587,12072,'jp','ã‚ãªãŸã®ã‚«ãƒ¼ãƒ‰ãŒãªã„èª²é‡‘ç„¡æ–™æ³¨æ–‡',0),(434588,12072,'pt','Seu cartÃ£o nÃ£o serÃ¡ cobrado gratuitamente as ordens',0),(434589,12072,'ru','Ð’Ð°ÑˆÐ° ÐºÐ°Ñ€Ñ‚Ð° Ð½Ðµ Ð±ÑƒÐ´ÐµÑ‚ Ð²Ð·Ð¸Ð¼Ð°Ñ‚ÑŒÑÑ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(434590,12072,'es','Su Tarjeta se CargarÃ¡ Para Ordenes GrÃ¡tis',0),(434591,12072,'de','Ihre Karte wird nicht kostenlos AuftrÃ¤ge belastet',0),(434592,12072,'en','Your Card Will Not Be Charged For Free Orders',0),(434593,12073,'is','',0),(434594,12073,'dr','Ø§Ø² Ù…Ø§Ù‡',0),(434595,12073,'pr','Ø§Ø² Ù…Ø§Ù‡',0),(434596,12073,'tr','Aydan itibaren',0),(434597,12073,'pl','Od miesiÄ…ca',0),(434598,12073,'bg','ÐžÑ‚ Ð¼ÐµÑÐµÑ†',0),(434599,12073,'ur','Ù…Ø§Û Ø³Û’',0),(434600,12073,'sr','ÐžÐ´ Ð¼ÐµÑÐµÑ†Ð°',0),(434601,12073,'vi','tá»« thÃ¡ng',0),(434602,12073,'af','Van die maand',0),(434603,12073,'ro','Din luna',0),(434604,12073,'et','Kuust',0),(434605,12073,'si','Od meseca',0),(434606,12073,'ba','Dari bulan',0),(434607,12073,'nl','Van maand',0),(434608,12073,'fi','Kuukauden',0),(434609,12073,'no','Fra mÃ¥ned',0),(434610,12073,'da','Fra mÃ¥ned',0),(434611,12073,'ko','ë‹¬ì—ì„œ',0),(434612,12073,'he','×ž×”×—×•×“×©',0),(434613,12073,'el','Î‘Ï€ÏŒ Ï„Î¿Î½ Î¼Î®Î½Î±',0),(434614,12073,'zh','ä»Žæœˆ',0),(434615,12073,'sv','FrÃ¥n mÃ¥nad',0),(434616,12073,'it','Dal mese',0),(434617,12073,'tl','',0),(434618,12073,'th','à¸ˆà¸²à¸à¹€à¸”à¸·à¸­à¸™',0),(434619,12073,'hi','à¤®à¤¹à¥€à¤¨à¤¾ à¤¸à¥‡',0),(434620,12073,'ms','Dari bulan',0),(434621,12073,'ar','Ù…Ù† Ø§Ù„Ø´Ù‡Ø±',0),(434622,12073,'fr','Du mois',0),(434623,12073,'jp','1 ãƒ¶æœˆã‹ã‚‰',0),(434624,12073,'pt','Do mÃªs',0),(434625,12073,'ru','ÐžÑ‚ Ð¼ÐµÑÑÑ†Ð°',0),(434626,12073,'es','Del Mes',0),(434627,12073,'de','Ab Monat',0),(434628,12073,'en','From Month',0),(434629,12074,'is','',0),(434630,12074,'dr','ØªØ§ Ù…Ø§Ù‡',0),(434631,12074,'pr','ØªØ§ Ù…Ø§Ù‡',0),(434632,12074,'tr','Ay iÃ§in',0),(434633,12074,'pl','Do miesiÄ…ca',0),(434634,12074,'bg','Ð”Ð¾ Ð¼ÐµÑÐµÑ†',0),(434635,12074,'ur','Ù…Ø§Û ØªÚ©',0),(434636,12074,'sr','Ð—Ð° Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(434637,12074,'vi','Äáº¿n thÃ¡ng',0),(434638,12074,'af','Na maand',0),(434639,12074,'ro','La lunÄƒ',0),(434640,12074,'et','Kuule',0),(434641,12074,'si','Mesec',0),(434642,12074,'ba','Bulan',0),(434643,12074,'nl','Naar maand',0),(434644,12074,'fi','Kuukausi',0),(434645,12074,'no','MÃ¥ned',0),(434646,12074,'da','Til mÃ¥ned',0),(434647,12074,'ko','ë‹¬',0),(434648,12074,'he','×—×•×“×©',0),(434649,12074,'el','ÎÎ± Ï„Î¿ Î¼Î®Î½Î±',0),(434650,12074,'zh','æœˆ',0),(434651,12074,'sv','Till mÃ¥nad',0),(434652,12074,'it','Al mese',0),(434653,12074,'tl','',0),(434654,12074,'th','à¹€à¸”à¸·à¸­à¸™',0),(434655,12074,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(434656,12074,'ms','Ke bulan',0),(434657,12074,'ar','Ù„Ù„Ø´Ù‡Ø±',0),(434658,12074,'fr','Au mois',0),(434659,12074,'jp','1 ãƒ¶æœˆã«',0),(434660,12074,'pt','Para o mÃªs',0),(434661,12074,'ru','Ð’ Ð¼ÐµÑÑÑ†',0),(434662,12074,'es','Al Mes',0),(434663,12074,'de','Zum Monat',0),(434664,12074,'en','To Month',0),(434665,12075,'is','',0),(434666,12075,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø§ÛŒÙ† Ú©Ø§Ø¯Ø± Ø¨Ø§Ø¹Ø« Ù…ÛŒ Ø´ÙˆØ¯ÙˆØ±ÙˆØ¯ÛŒ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø¨Ø±Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ Ø«Ø¨Øª Ù†Ø´ÙˆØ¯ ',0),(434667,12075,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø§ÛŒÙ† Ú©Ø§Ø¯Ø± Ø¨Ø§Ø¹Ø« Ù…ÛŒ Ø´ÙˆØ¯ÙˆØ±ÙˆØ¯ÛŒ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø¨Ø±Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ Ø«Ø¨Øª Ù†Ø´ÙˆØ¯ ',0),(434668,12075,'tr','Bu kutu Will neden stok iÃ§in kaydedilecek hiÃ§bir genel muhasebe giriÅŸleri denetleniyor',0),(434669,12075,'pl','Sprawdzanie to pole bÄ™dzie przyczynÄ… nie zapisy ksiÄ™gi gÅ‚Ã³wnej majÄ… byÄ‡ rejestrowane dla zapasÃ³w',0),(434670,12075,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ‚Ð°Ð·Ð¸ ÐºÑƒÑ‚Ð¸Ñ Ñ‰Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð° Ð½ÑÐ¼Ð° Ð¾Ð±Ñ‰Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð° ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ²Ð° Ð·Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(434671,12075,'ur','ÛŒÛ Ø®Ø§Ù†Û Ù…Ø±Ø¶ÛŒ Ú©Û’ Ø³Ø¨Ø¨ Ú©ÙˆØ¦ÛŒ Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø±Ù†Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(434672,12075,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° Ð¾Ð²Ñƒ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ Ð²Ð¾Ñ™Ñƒ Ñ˜ÐµÑ€ Ð½ÐµÐ¼Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ð³Ð»Ð°Ð²Ð½Ðµ ÐºÑšÐ¸Ð³Ðµ Ð´Ð° ÑÐµ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ€Ð°Ñ˜Ñƒ Ð·Ð° Ð·Ð°Ð»Ð¸Ñ…Ðµ',0),(434673,12075,'vi','Kiá»ƒn tra thÃ´ng bÃ¡o nÃ y sáº½ lÃ  nguyÃªn nhÃ¢n  khÃ´ng cÃ³ Ä‘á»‹nh khoáº£n tá»•ng há»£p ghi nháº­n cho hÃ ng tá»“n kho',0),(434674,12075,'af','Kontroleer hierdie boks sal veroorsaak geen algemene grootboek inskrywings te word vir inventaris aangeteken',0),(434675,12075,'ro','Verificarea acest caseta va provoca nici intrÄƒrile din registrul General se Ã®nregistreazÄƒ pentru inventarul',0),(434676,12075,'et','Kontrollimise sellepÃ¤rast kasti tahe puudub pearaamatu kanded registreeritakse lao',0),(434677,12075,'si','Preverjanje ta Å¡katla hoteti vzrok ne postavke glavne knjige evidentirajo za zalogo',0),(434678,12075,'ba','Memeriksa kotak akan menyebabkan ini ada General Ledger entri untuk dicatatkan pada persediaan',0),(434679,12075,'nl','De oorzaak van dit vak zal controleren geen grootboekposten worden geregistreerd voor voorraad',0),(434680,12075,'fi','Tarkistaa tÃ¤mÃ¤ laatikko tulee syy ei ole PÃ¤Ã¤kirjanpidon tapahtumat kirjataan varastoon',0),(434681,12075,'no','Sjekke denne boksen vil fÃ¸re ingen finansposter skal registreres For lager',0),(434682,12075,'da','Kontrollere denne boks vil forÃ¥rsage nogen finansposter skal registreres For lageret',0),(434683,12075,'ko','ê²€ì‚¬ì´ ìƒìžëŠ” ì›ì¸ ì—†ëŠ” ì¼ë°˜ ë ˆì € í•­ëª© ìž¬ê³ ì— ëŒ€ í•œ ê¸°ë¡',0),(434684,12075,'he','×‘×“×™×§×ª ×©×ž×¢×‘×¨× ×•×•×™×œ ×ª×™×‘×ª ××™×Ÿ ×¤×§×•×“×•×ª ×™×•×ž×Ÿ ×›×œ×œ×™ ×©×™×™×¨×©×ž×• ×œ×¡×¤×™×¨×ª ×ž×œ××™',0),(434685,12075,'el','Î¤Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Î±Ï…Ï„ÏŒ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ Î¸Î± Î±Î¹Ï„Î¯Î± Î´ÎµÎ½ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ Î³ÎµÎ½Î¹ÎºÎ®Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚, Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎºÎ±Ï„Î±Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹ Î³Î¹Î± \"Î±Ï€ÏŒÎ¸ÎµÎ¼Î±\"',0),(434686,12075,'zh','æ£€æŸ¥æ­¤æ¡†ä¸ä¼šé€ æˆæ€»å¸æ¡ç›®è®°å½•åº“å­˜',0),(434687,12075,'sv','Kontrollera denna rutan kommer att orsaka nÃ¥gra redovisningstransaktioner registreras fÃ¶r inventering',0),(434688,12075,'it','Non controllando questa casella sarÃ  causa nessun generale movimenti da registrare per inventario',0),(434689,12075,'tl','',0),(434690,12075,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸ªà¸²à¹€à¸«à¸•à¸¸à¸ˆà¸°à¸à¸¥à¹ˆà¸­à¸‡à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(434691,12075,'hi','à¤‡à¤¸ à¤¬à¥‰à¤•à¥à¤¸ à¤œà¤¾à¤à¤—à¤¾ à¤•à¤¾à¤°à¤£ à¤•à¥‹à¤ˆ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤œà¤¾à¤à¤',0),(434692,12075,'ms','Semakan ini Peti akan menyebabkan masukan Lejar Am yang dicatatkan bagi inventori',0),(434693,12075,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† ÙˆØ¬ÙˆØ¯ Ù‡Ø°Ø§ Ø§Ù„Ø³Ø¨Ø¨ Ø³ÙˆÙ Ù…Ø±Ø¨Ø¹ Ù„Ø§ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ø¨ØªØ³Ø¬ÙŠÙ„Ù‡Ø§ Ù„Ù„Ù…Ø®Ø²ÙˆÙ†',0),(434694,12075,'fr','Ne cochant cette case Will Cause aucune Ã©critures comptables Ã  enregistrer pour l\'inventaire',0),(434695,12075,'jp','ã“ã®ãƒœãƒƒã‚¯ã‚¹ã¯åŽŸå› åœ¨åº«ã®è¨˜éŒ²ã«ãªã„ä¸€èˆ¬çš„ãªå…ƒå¸³ã®ã‚¨ãƒ³ãƒˆãƒªã®ãƒã‚§ãƒƒã‚¯',0),(434696,12075,'pt','Verificando esta caixa vontade causa sem General Ledger entradas para ser gravada para inventÃ¡rio',0),(434697,12075,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÑ‚Ð¾Ñ‚ ÑÑ‰Ð¸Ðº Ð±ÑƒÐ´ÐµÑ‚ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð¾Ð¹ Ð½Ðµ ÑƒÑ‡Ñ‚ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ð±Ñ‰ÐµÐ³Ð¾ Ð´Ð»Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð»Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(434698,12075,'es','Tachando esta Caja no CausarÃ¡ Ningunos Entradas de Libro Mayor ser Registrado Para El Inventario',0),(434699,12075,'de','ÃœberprÃ¼fung dieser Box Willen Ursache keine Sachposten fÃ¼r die Inventur festzuhalten',0),(434700,12075,'en','Checking This Box Will Cause NO General Ledger Entries To Be Recorded For Inventory',0),(434701,12076,'is','',0),(434702,12076,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø§ÛŒÙ† Ú©Ø§Ø¯Ø±  ÛŒÚ©  Ø¬Ø§ÛŒ Ø®Ø§Ù„ÛŒ  Ø«Ø¨Øª Ø¯ÙØªØ± Ú©Ù„ Ø±Ø§ Ø¯Ø±Ù…ØºØ§ÛŒØ±Øª Ø¨Ø§ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ Ø§ÛŒØ¬Ø§Ø¯ Ù…ÛŒ Ú©Ù†Ø¯ Ú©Ù‡ Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø§ØµÙ„Ø§Ø­ Ø¯Ø§Ø±Ø¯ ',0),(434703,12076,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø§ÛŒÙ† Ú©Ø§Ø¯Ø±  ÛŒÚ©  Ø¬Ø§ÛŒ Ø®Ø§Ù„ÛŒ  Ø«Ø¨Øª Ø¯ÙØªØ± Ú©Ù„ Ø±Ø§ Ø¯Ø±Ù…ØºØ§ÛŒØ±Øª Ø¨Ø§ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ Ø§ÛŒØ¬Ø§Ø¯ Ù…ÛŒ Ú©Ù†Ø¯ Ú©Ù‡ Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø§ØµÙ„Ø§Ø­ Ø¯Ø§Ø±Ø¯ ',0),(434704,12076,'tr','Bu kutu Will Leave A genel defter giriÅŸinin ayarlanmasÄ± gereken stok sapmasÄ± denetleme',0),(434705,12076,'pl','Sprawdzanie tej ksiÄ™gi ogÃ³lne woli zostaw pole w wariancji zapasÃ³w, ktÃ³re muszÄ… byÄ‡ dostosowane',0),(434706,12076,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ‚Ð°Ð·Ð¸ ÐºÑƒÑ‚Ð¸Ñ Ñ‰Ðµ Ð½Ð°Ð¿ÑƒÑÐºÐ°Ð¼ A Ð¾Ð±Ñ‰ Ð·Ð°Ð¿Ð¸Ñ Ð² ÑÐºÐ»Ð°Ð´Ð° Ð²Ð°Ñ€Ð¸Ð°Ñ†Ð¸Ð¸, ÐºÐ¾Ð¸Ñ‚Ð¾ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð½Ð°Ð»Ð¾Ð¶Ð¸ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ ÐºÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ð¸',0),(434707,12076,'ur','ÛŒÛ Ø®Ø§Ù†Û Ù…Ø±Ø¶ÛŒ Ú†Ú¾ÙˆÚ‘ A Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø§ÛŒÚˆØ¬Ø³Ù¹ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ ØªØ§Ú©Û Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ ØªØºÛŒØ± Ù…ÛŒÚº Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(434708,12076,'sr','ÐžÐ²Ð¾Ñ˜ ÑÑ‚Ð°Ð²Ñ†Ð¸ ÐºÑšÐ¸Ð³Ðµ Ð¾Ð´ÑÑƒÑÑ‚Ð²Ð¾ Ð²Ð¾Ñ™Ðµ Ð Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™ÑƒÑ˜Ðµ Ð¾Ð´ÑÑ‚ÑƒÐ¿Ð°ÑšÐ° Ð·Ð°Ð»Ð¸Ñ…Ð° ÐºÐ¾Ñ˜Ðµ Ð¼Ð¾Ð¶Ð´Ð° Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ð¸Ñ‚Ð¸',0),(434709,12076,'vi','Kiá»ƒm tra thÃ´ng bÃ¡o nÃ y sáº½ nháº­p bÃºt toÃ¡n tá»•ng há»£p cÃ¡c biáº¿n Ä‘á»™ng hÃ ng tá»“n kho cÃ³ thá»ƒ cáº§n Ä‘Æ°á»£c Ä‘iá»u chá»‰nh',0),(434710,12076,'af','Kontroleer hierdie boks sal laat \'n algemene grootboek inskrywing In voorraad variansie wat dalk moet aangepas word',0),(434711,12076,'ro','Verificarea aceastÄƒ intrare Ã®n registrul General caseta va lÄƒsa o variaÅ£ie de inventar, care poate fi necesar sÄƒ fie modificate',0),(434712,12076,'et','Kontrollida selle kasti tahtmist puhkusele A Ã¼ldine andmikukande varude erinevuse, mis vÃµib tekkida vajadus kohandada',0),(434713,12076,'si','Preverjanje to polje bo dopust A sploÅ¡no postavko v zaloge Variance, ki je morda treba prilagoditi',0),(434714,12076,'ba','Memeriksa akan meninggalkan A General Ledger Catatan ini kotak varians persediaan yang mungkin perlu disesuaikan',0),(434715,12076,'nl','Dit vak zal Leave A grootboekpost inchecken inventaris variantie die mogelijk moeten worden bijgesteld',0),(434716,12076,'fi','TÃ¤hÃ¤n ruutuun tulee viedÃ¤ pÃ¤Ã¤kirjanpidon tapahtumaan lÃ¤htÃ¶selvityksen varaston varianssin, joka voi joutua sÃ¤Ã¤tÃ¤mÃ¤Ã¤n',0),(434717,12076,'no','Denne boksen vil la en General post innsjekking lager avvik som mÃ¥ justeres',0),(434718,12076,'da','Kontrollere denne boks vil Leave A General post i lageret varians, der muligvis skal tilpasses',0),(434719,12076,'ko','ìž¬ê³  íŽ¸ì°¨ ì¡°ì • í•´ì•¼ í•  ìˆ˜ë„ ìžˆìŠµë‹ˆë‹¤ì—ì´ ìƒìžëŠ” ë‘ê³  A ì¼ë°˜ ë ˆì € í•­ëª© í™•ì¸',0),(434720,12076,'he','×‘×“×™×§×ª ×¢×¨×š ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™ ×–×” ×ª×™×‘×ª ×”×¨×¦×•×Ÿ ×œ×”×©××™×¨ A ×‘×•×¨×™×× ×¡ ×”×ž×œ××™ ×©×™×© ×¦×•×¨×š ×œ×”×ª××™×ž×',0),(434721,12076,'el','Î¤Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Î±Ï…Ï„ÏŒ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ Î¸Î± Î‘Ï†Î®ÏƒÏ„Îµ Î­Î½Î± Î³ÎµÎ½Î¹ÎºÎ¿Ï ÎºÎ±Î¸Î¿Î»Î¹ÎºÎ¿Ï ÏƒÏ„Î· Î´Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ· Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Ï€Î¿Ï… Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï‡ÏÎµÎ¹Î±ÏƒÏ„ÎµÎ¯ Î½Î± Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÏ„ÎµÎ¯',0),(434722,12076,'zh','æ£€æŸ¥æ­¤æ¡†ä¼šç•™ä¸‹å¯èƒ½éœ€è¦å˜æ›´çš„åº“å­˜æ€»å¸æ¡ç›®',0),(434723,12076,'sv','Kontrollera den rutan kommer att lÃ¤mna en allmÃ¤n artikeltransaktionen inventering varians som kan behÃ¶va justeras',0),(434724,12076,'it','Controllando questa voce Box Will Leave A General Ledger In inventario varianza che puÃ² essere necessario',0),(434725,12076,'tl','',0),(434726,12076,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¹ƒà¸Šà¹‰à¸à¸¥à¹ˆà¸­à¸‡à¸ˆà¸°à¸›à¸¥à¹ˆà¸­à¸¢ A à¸™à¸µà¹‰à¸œà¸¥à¸•à¹ˆà¸²à¸‡à¸„à¸‡à¸—à¸µà¹ˆà¸­à¸²à¸ˆà¸ˆà¸³à¹€à¸›à¹‡à¸™à¸•à¹‰à¸­à¸‡à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(434727,12076,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤µà¤¿à¤šà¤°à¤£ à¤®à¥‡à¤‚ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥‹ à¤¸à¤•à¤¤à¥€ à¤¹à¥ˆ à¤•à¤¿ à¤‡à¤¸ à¤¬à¥‰à¤•à¥à¤¸ à¤¹à¥‹à¤—à¤¾ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‹ à¤à¤• à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥',0),(434728,12076,'ms','Menyemak Peti akan cuti A Ketua Lejar entri ini dalam inventori varians yang mungkin perlu diselaraskan',0),(434729,12076,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø¥Ø¯Ø®Ø§Ù„ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… Ø¥Ø±Ø§Ø¯Ø© Ø¥Ø¬Ø§Ø²Ø© A Ù…Ø±Ø¨Ø¹ Ù‡Ø°Ø§ ÙÙŠ Ø§Ù„ÙØ±Ù‚ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„ØªÙŠ Ù‚Ø¯ ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ ØªØ¹Ø¯ÙŠÙ„',0),(434730,12076,'fr','Cochant cette boÃ®te congÃ© A de la volontÃ© gÃ©nÃ©rale Ecriture dans la Variance de l\'inventaire qui peut devoir Ãªtre ajustÃ©e',0),(434731,12076,'jp','ã“ã®ãƒœãƒƒã‚¯ã‚¹ãŒã‚³ãƒ¡ãƒ³ãƒˆã‚’æ®‹ã™ä¸€èˆ¬çš„ãªå…ƒå¸³ã®ã‚¨ãƒ³ãƒˆãƒªã‚’èª¿æ•´ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™åœ¨åº«é‡å¤‰å‹•ã®ãƒã‚§ãƒƒã‚¯',0),(434732,12076,'pt','Verificando esta caixa vai deixar um General Ledger entrada no variÃ¢ncia de inventÃ¡rio que talvez precise ser ajustado',0),(434733,12076,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð­Ñ‚Ð° ÐºÐ¾Ñ€Ð¾Ð±ÐºÐ° Ð±ÑƒÐ´ÐµÑ‚ Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹ ÑƒÑ‡Ñ‚ÐµÐ½Ð½Ð¾Ð¹ Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð´Ð¸ÑÐ¿ÐµÑ€ÑÐ¸ÑŽ, ÐºÐ¾Ñ‚Ð¾Ñ€Ð°Ñ Ð¼Ð¾Ð¶ÐµÑ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ñ‚ÑŒÑÑ ÑÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(434734,12076,'es','Tachando esta Caja DejarÃ¡ Una Entrada de Libro Mayor en Una VariaciÃ³n de Inventario que Puede Necesitar un Ajuste',0),(434735,12076,'de','Einchecken dieser Box Will Leave A General Ledger Eintrag Lagerbestand Varianz, die mÃ¶glicherweise angepasst werden',0),(434736,12076,'en','Checking This Box Will Leave A General Ledger Entry In Inventory Variance That May Need To Be Adjusted',0),(434737,12077,'is','',0),(434738,12077,'dr','Ù‡ÛŒÚ† Ø§Ø±Ø³Ø§Ù„ÛŒ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§ Ø§ØªÙØ§Ù‚ Ù†Ù…ÛŒ Ø§ÙØªØ¯',0),(434739,12077,'pr','Ù‡ÛŒÚ† Ø§Ø±Ø³Ø§Ù„ÛŒ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§ Ø§ØªÙØ§Ù‚ Ù†Ù…ÛŒ Ø§ÙØªØ¯',0),(434740,12077,'tr','BorÃ§lar iÃ§in nakil yer alacak',0),(434741,12077,'pl','Nie delegowania dla zobowiÄ…zaÅ„ odbÄ™dzie siÄ™',0),(434742,12077,'bg','ÐÑÐ¼Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð·Ð° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ Ñ‰Ðµ ÑÐµ Ð¿Ñ€Ð¾Ð²ÐµÐ´Ðµ',0),(434743,12077,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ù¾ÙˆØ³Ù¹Ù†Ú¯ Ù…ÛŒÚº Ù…Ù†Ø¹Ù‚Ø¯ ÛÙˆ Ú¯ÛŒ',0),(434744,12077,'sr','Ð‘ÐµÐ· ÐºÑšÐ¸Ð¶ÐµÑšÐ° Ð·Ð° Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð¾Ð´Ñ€Ð¶Ð°Ñ›Ðµ ÑÐµ',0),(434745,12077,'vi','khÃ´ng vÃ o sá»• cÃ¡i cÃ¡c khoáº£n pháº£i tráº£ sáº½ láº¥y á»Ÿ Ä‘Ã¢y',0),(434746,12077,'af','Geen pos vir Waardedalingstoetse sal plaasvind',0),(434747,12077,'ro','Nici o Ã®nregistrare pentru datorii va avea loc',0),(434748,12077,'et','Sisestamise vÃµlad toimub',0),(434749,12077,'si','Ne objavljate za obveznosti bo potekala',0),(434750,12077,'ba','Tidak ada Posting untuk hutang akan berlangsung',0),(434751,12077,'nl','Geen het posten voor schulden zal plaatsvinden',0),(434752,12077,'fi','Ei lÃ¤hettÃ¤mistÃ¤ velat jÃ¤rjestetÃ¤Ã¤n',0),(434753,12077,'no','Ingen postering For leverandÃ¸rgjeld vil foregÃ¥',0),(434754,12077,'da','Ingen bogfÃ¸ring For gÃ¦ld vil finde sted',0),(434755,12077,'ko','ë¯¸ì§€ê¸‰ê¸ˆì— ëŒ€ í•œ ì—†ìŒ ê²Œì‹œê°€ ì—´ë¦°ë‹¤',0),(434756,12077,'he','××™×Ÿ ×¨×™×©×•× ×¢×‘×•×¨ ×–×›××™× ×™×ª×§×™×™×',0),(434757,12077,'el','ÎšÎ±Î¼Î¯Î± Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ· Î³Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î¸Î± Ï€ÏÎ±Î³Î¼Î±Ï„Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯',0),(434758,12077,'zh','ä¸ä¼šäº§ç”Ÿå¯æ”¯ä»˜çš„é‚®å¯„',0),(434759,12077,'sv','Ingen bokfÃ¶ring fÃ¶r leverantÃ¶rsskulder kommer att Ã¤ga rum',0),(434760,12077,'it','Nessuna registrazione per debiti si svolgerÃ ',0),(434761,12077,'tl','',0),(434762,12077,'th','à¹„à¸¡à¹ˆà¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸±à¸à¸Šà¸µà¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰à¸ˆà¸°à¹€à¸à¸´à¸”à¸‚à¸¶à¹‰à¸™',0),(434763,12077,'hi','à¤•à¥‹à¤ˆ à¤ªà¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤— Payables à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤—à¤¹ à¤¨à¤¹à¥€à¤‚ à¤²à¥‡ à¤œà¤¾à¤à¤—à¤¾',0),(434764,12077,'ms','Tiada Posting bagi pemiutang akan mengambil tempat',0),(434765,12077,'ar','Ø³ÙˆÙ ØªØ¬Ø±ÙŠ Ø£ÙŠ ØªØ±Ø­ÙŠÙ„ Ù„Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(434766,12077,'fr','Aucune annonce pour des comptes fournisseurs n\'aura lieu',0),(434767,12077,'jp','è²·æŽ›é‡‘ã®è»¢è¨˜ã¯è¡Œã‚ã‚Œã¾ã›ã‚“',0),(434768,12077,'pt','Nenhuma postagem para contas a pagar, terÃ¡ lugar',0),(434769,12077,'ru','ÐÐµÑ‚ Ñ€Ð°Ð·Ð½Ð¾ÑÐºÐ¸ Ð´Ð»Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð±ÑƒÐ´ÐµÑ‚ Ð¿Ñ€Ð¾Ñ…Ð¾Ð´Ð¸Ñ‚ÑŒ',0),(434770,12077,'es','No se OcurrirÃ¡ el Asiento para Cuentas Por Pagar',0),(434771,12077,'de','Kein Posten fÃ¼r Verbindlichkeiten statt findet',0),(434772,12077,'en','No Posting For Payables Will Take Place',0),(434773,12078,'is','',0),(434774,12078,'dr','Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ø² Ú©Ø±Ø¯Ù† Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(434775,12078,'pr','Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ø² Ú©Ø±Ø¯Ù† Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(434776,12078,'tr','Ä°Ã§in AÃ§\'Ä± tÄ±klatÄ±n',0),(434777,12078,'pl','Kliknij, aby otworzyÄ‡',0),(434778,12078,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸',0),(434779,12078,'ur','Ú©Ùˆ Ø§ÙˆÙ¾Ù† Ú©Ø±ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(434780,12078,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾',0),(434781,12078,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ má»Ÿ',0),(434782,12078,'af','Klik om oop te',0),(434783,12078,'ro','FaceÅ£i clic pentru a deschide',0),(434784,12078,'et','KlÃµpsake nuppu Open',0),(434785,12078,'si','Kliknite Open',0),(434786,12078,'ba','Klik untuk membuka',0),(434787,12078,'nl','Klik om te openen',0),(434788,12078,'fi','Klikkaa auki',0),(434789,12078,'no','Klikk for Ã¥ Ã¥pne',0),(434790,12078,'da','Klik for at Ã¥bne',0),(434791,12078,'ko','ì—´ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(434792,12078,'he','×œ×—×¥ ×›×“×™ ×œ×¤×ª×•×—',0),(434793,12078,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î±Î½Î¿Î¯Î¾ÎµÎ¹',0),(434794,12078,'zh','å•å‡»ä»¥æ‰“å¼€',0),(434795,12078,'sv','Klicka fÃ¶r att Ã¶ppna',0),(434796,12078,'it','Fare clic su Apri',0),(434797,12078,'tl','',0),(434798,12078,'th','à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­à¹€à¸›à¸´à¸”',0),(434799,12078,'hi','à¤–à¥‹à¤²à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(434800,12078,'ms','Klik untuk terbuka',0),(434801,12078,'ar','Ø§Ù†Ù‚Ø± Ù„ÙØªØ­',0),(434802,12078,'fr','Cliquez sur Ouvrir',0),(434803,12078,'jp','é–‹ãã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(434804,12078,'pt','Clique para abrir',0),(434805,12078,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚ÑŒ',0),(434806,12078,'es','Haga clic en Open',0),(434807,12078,'de','Klicken Sie auf Ã–ffnen',0),(434808,12078,'en','Click To Open',0),(434809,12079,'is','',0),(434810,12079,'dr','ØªØºÛŒÛŒØ±Ø§Øª Ù„ØºÙˆ Ø´Ø¯',0),(434811,12079,'pr','ØªØºÛŒÛŒØ±Ø§Øª Ù„ØºÙˆ Ø´Ø¯',0),(434812,12079,'tr','DeÄŸiÅŸiklik iptal edildi',0),(434813,12079,'pl','Zmiany anulowane',0),(434814,12079,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(434815,12079,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(434816,12079,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð¾',0),(434817,12079,'vi','Thay Ä‘á»•i há»§y bá»',0),(434818,12079,'af','Veranderinge gekanselleer',0),(434819,12079,'ro','ModificÄƒri anulat',0),(434820,12079,'et','Muutused tÃ¼histatud',0),(434821,12079,'si','Spremembe preklicane',0),(434822,12079,'ba','Perubahan yang dibatalkan',0),(434823,12079,'nl','Wijzigingen geannuleerd',0),(434824,12079,'fi','Muutokset peruutetaan',0),(434825,12079,'no','Endringer avbrutt',0),(434826,12079,'da','Ã†ndringer annulleret',0),(434827,12079,'ko','ë³€ê²½ ì·¨ì†Œ',0),(434828,12079,'he','×©×™× ×•×™×™× ×‘×•×˜×œ',0),(434829,12079,'el','Î‘Î»Î»Î±Î³Î­Ï‚ Ï€Î¿Ï… Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ',0),(434830,12079,'zh','å˜æ›´å–æ¶ˆ',0),(434831,12079,'sv','FÃ¶rÃ¤ndringar som avbrutit',0),(434832,12079,'it','Modifiche annullate',0),(434833,12079,'tl','',0),(434834,12079,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(434835,12079,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¥‹à¤‚ à¤•à¥‹ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(434836,12079,'ms','Perubahan yang dibatalkan',0),(434837,12079,'ar','Ø¥Ù„ØºØ§Ø¡ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(434838,12079,'fr','Changements annulÃ©es',0),(434839,12079,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«å¤‰æ›´',0),(434840,12079,'pt','AlteraÃ§Ãµes canceladas',0),(434841,12079,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(434842,12079,'es','Cambios Cancelados',0),(434843,12079,'de','Ã„nderungen abgebrochen',0),(434844,12079,'en','Changes Canceled',0),(434845,12080,'is','',0),(434846,12080,'dr','Ù‚Ø§Ø¨Ù„ÛŒØªÙ‡Ø§ÛŒ Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(434847,12080,'pr','Ù‚Ø§Ø¨Ù„ÛŒØªÙ‡Ø§ÛŒ Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(434848,12080,'tr','Eklentiler',0),(434849,12080,'pl','Dodatki',0),(434850,12080,'bg','Ð”Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(434851,12080,'ur','Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª',0),(434852,12080,'sr','ÐŸÑ€Ð¾Ð³Ñ€Ð°Ð¼ÑÐºÐ¸ Ð´Ð¾Ð´Ð°Ñ†Ð¸',0),(434853,12080,'vi','Add -ons',0),(434854,12080,'af','Byvoegsels',0),(434855,12080,'ro','Suplimente',0),(434856,12080,'et','Lisandmoodulid',0),(434857,12080,'si','Dodatkov',0),(434858,12080,'ba','Pengaya',0),(434859,12080,'nl','Add-Ons',0),(434860,12080,'fi','LisÃ¤osat',0),(434861,12080,'no','Tillegg',0),(434862,12080,'da','TilfÃ¸jelser',0),(434863,12080,'ko','ì¶”ê°€ ê¸°ëŠ¥',0),(434864,12080,'he','×ª×•×¡×¤×•×ª',0),(434865,12080,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î±',0),(434866,12080,'zh','é™„åŠ ',0),(434867,12080,'sv','TillÃ¤gg',0),(434868,12080,'it','Componenti aggiuntivi',0),(434869,12080,'tl','',0),(434870,12080,'th','à¹‚à¸›à¸£à¹à¸à¸£à¸¡ Add-on',0),(434871,12080,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚-ons',0),(434872,12080,'ms','Tambahan',0),(434873,12080,'ar','Ø§Ù„Ø¥Ø¶Ø§ÙØ§Øª',0),(434874,12080,'fr','Add-ons',0),(434875,12080,'jp','ã‚¢ãƒ‰ã‚ªãƒ³',0),(434876,12080,'pt','Add-ons',0),(434877,12080,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(434878,12080,'es','Dispos. de AumentaciÃ³n',0),(434879,12080,'de','Add-ons',0),(434880,12080,'en','Add-Ons',0),(434881,12081,'is','',0),(434882,12081,'dr','Ø¨Ø¯ÙˆÙ† ØªØ§Ø±ÛŒØ® ÙØ§Ú©ØªÙˆØ±',0),(434883,12081,'pr','Ø¨Ø¯ÙˆÙ† ØªØ§Ø±ÛŒØ® ÙØ§Ú©ØªÙˆØ±',0),(434884,12081,'tr','Fatura tarihi',0),(434885,12081,'pl','Nie data faktury',0),(434886,12081,'bg','ÐÐµ Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(434887,12081,'ur','Ù†Û Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(434888,12081,'sr','ÐÐµ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(434889,12081,'vi','khÃ´ng ngÃ y hÃ³a Ä‘Æ¡n',0),(434890,12081,'af','Nie faktuur datum',0),(434891,12081,'ro','Nu Data facturii',0),(434892,12081,'et','Arve kuupÃ¤ev',0),(434893,12081,'si','Ne datum raÄuna',0),(434894,12081,'ba','Tidak tanggal faktur',0),(434895,12081,'nl','Niet factuurdatum',0),(434896,12081,'fi','LaskutuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(434897,12081,'no','Ikke fakturadatoen',0),(434898,12081,'da','Ikke fakturadato',0),(434899,12081,'ko','ì•„ë‹ˆë¼ ì†¡ìž¥ ë‚ ì§œ',0),(434900,12081,'he','×œ× ×ª××¨×™×š ×—×©×‘×•× ×™×ª',0),(434901,12081,'el','Î”ÎµÎ½ Î—Î¼/Î½Î¯Î± Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(434902,12081,'zh','éžå‘ç¥¨æ—¥æœŸ',0),(434903,12081,'sv','Inte fakturadatum',0),(434904,12081,'it','Non data fattura',0),(434905,12081,'tl','',0),(434906,12081,'th','à¹„à¸¡à¹ˆà¸§à¸±à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(434907,12081,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¨à¤¹à¥€à¤‚',0),(434908,12081,'ms','Bukan tarikh invois',0),(434909,12081,'ar','Ù„Ø§ ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(434910,12081,'fr','Date de la facture non',0),(434911,12081,'jp','ãªã„è«‹æ±‚æ›¸ã®æ—¥ä»˜',0),(434912,12081,'pt','NÃ£o data de fatura',0),(434913,12081,'ru','ÐÐµ Ð´Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð°',0),(434914,12081,'es','No es la Fecha de Factura',0),(434915,12081,'de','Nicht Rechnungsdatum',0),(434916,12081,'en','Not Invoice Date',0),(434917,12082,'is','',0),(434918,12082,'dr','(Ø«Ø¨Øª',0),(434919,12082,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÛŒØ® ÙˆØ±ÙˆØ¯ÛŒ(Ø«Ø¨Øª',0),(434920,12082,'tr','GiriÅŸ tarihini kullan',0),(434921,12082,'pl','UÅ¼yj daty wejÅ›cia',0),(434922,12082,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð°',0),(434923,12082,'ur','ØªØ§Ø±ÛŒØ® Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(434924,12082,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð°',0),(434925,12082,'vi','Sá»­ dá»¥ng ngÃ y nháº­p',0),(434926,12082,'af','Datum van inskrywing gebruik',0),(434927,12082,'ro','UtilizaÅ£i data intrÄƒrii',0),(434928,12082,'et','Kasutada kande kuupÃ¤ev',0),(434929,12082,'si','Uporaba vnos datuma',0),(434930,12082,'ba','Menggunakan tanggal entri',0),(434931,12082,'nl','Gebruik post datum',0),(434932,12082,'fi','KÃ¤ytÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(434933,12082,'no','Bruk oppfÃ¸ringsdatoen',0),(434934,12082,'da','Bruge tilmeldningsfrist',0),(434935,12082,'ko','ìž…êµ­ ë‚ ì§œë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(434936,12082,'he','×”×©×ª×ž×© ×ª××¨×™×š ×›× ×™×¡×”',0),(434937,12082,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ Ï‡ÏÎ®ÏƒÎ·',0),(434938,12082,'zh','ä½¿ç”¨æ¡ç›®',0),(434939,12082,'sv','AnvÃ¤nda bloggpostens datum',0),(434940,12082,'it','Utilizzare Data Entry',0),(434941,12082,'tl','',0),(434942,12082,'th','à¹ƒà¸Šà¹‰à¸£à¸²à¸¢à¸à¸²à¸£à¸§à¸±à¸™',0),(434943,12082,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(434944,12082,'ms','Gunakan tarikh kemasukan',0),(434945,12082,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(434946,12082,'fr','Utiliser la Date d\'entrÃ©e',0),(434947,12082,'jp','ã‚¨ãƒ³ãƒˆãƒªã®æ—¥ä»˜ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(434948,12082,'pt','Data de entrada do uso',0),(434949,12082,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð”Ð°Ñ‚Ð° Ð²ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ',0),(434950,12082,'es','Usa Fecha de Entrada',0),(434951,12082,'de','Eintrag vom verwenden',0),(434952,12082,'en','Use Entry Date',0),(434953,12083,'is','',0),(434954,12083,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§ÛŒÙ† Ø³ÙØ§Ø±Ø´ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯ØŸ',0),(434955,12083,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§ÛŒÙ† Ø³ÙØ§Ø±Ø´ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯ØŸ',0),(434956,12083,'tr','Bu sÄ±rada silmek istediÄŸinizden emin misiniz',0),(434957,12083,'pl','Czy na pewno chcesz usunÄ…Ä‡ ten porzÄ…dek',0),(434958,12083,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(434959,12083,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº',0),(434960,12083,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð±Ñ€Ð¸ÑˆÐµÑ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³',0),(434961,12083,'vi','XÃ³a lá»‡nh nÃ y?',0),(434962,12083,'af','Is jy seker jy wil hierdie bevel',0),(434963,12083,'ro','Sigur È™tergeÈ›i aceastÄƒ comandÄƒ',0),(434964,12083,'et','Kas kindlasti kustutada selle',0),(434965,12083,'si','Ali ste prepriÄani, da Å¾elite izbrisati ta nalog',0),(434966,12083,'ba','Apakah Anda yakin Anda ingin menghapus pesanan ini',0),(434967,12083,'nl','Weet u zeker dat u wilt verwijderen van deze bestelling',0),(434968,12083,'fi','Oletko varma, ettÃ¤ haluat poistaa tÃ¤mÃ¤n tilauksen',0),(434969,12083,'no','Er du sikker pÃ¥ at du vil slette denne rekkefÃ¸lgen',0),(434970,12083,'da','Er du sikker pÃ¥ du vil slette denne rÃ¦kkefÃ¸lge',0),(434971,12083,'ko','ë‹¹ì‹ ì€ì´ ìˆœì„œë¥¼ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ',0),(434972,12083,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ×”×–×ž× ×” ×–×•',0),(434973,12083,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬',0),(434974,12083,'zh','ä½ ç¡®å®šä»¥è¦åˆ é™¤æ­¤è®¢å•å—ï¼Ÿ',0),(434975,12083,'sv','Ã„r du sÃ¤ker du vill ta bort denna ordning',0),(434976,12083,'it','Sei sicuro di che voler eliminare questo ordine',0),(434977,12083,'tl','',0),(434978,12083,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸¥à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸™à¸µà¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(434979,12083,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(434980,12083,'ms','Adakah anda pasti anda mahu menghapuskan Perintah ini',0),(434981,12083,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(434982,12083,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer cet ordre',0),(434983,12083,'jp','ã“ã®é †åºã‚’å‰Šé™¤ã™ã‚‹ã‚ˆã‚ã—ã„ã§ã™ã€‚',0),(434984,12083,'pt','Tem certeza que deseja excluir esta ordem',0),(434985,12083,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(434986,12083,'es','Esta seguro que quiere eliminar este orden',0),(434987,12083,'de','Bist du sicher, dass Sie diese Bestellung lÃ¶schen mÃ¶chten',0),(434988,12083,'en','Are you sure you want to delete this order',0),(434989,12084,'is','',0),(434990,12084,'dr','ØªØ§Ø±ÛŒØ® ØªÙˆÙ„Ø¯ Ø¨Ø¹Ø¯ Ø§Ø² Ø§Ù…Ø±ÙˆØ² Ø§Ø³Øª',0),(434991,12084,'pr','ØªØ§Ø±ÛŒØ® ØªÙˆÙ„Ø¯ Ø¨Ø¹Ø¯ Ø§Ø² Ø§Ù…Ø±ÙˆØ² Ø§Ø³Øª',0),(434992,12084,'tr','BugÃ¼nden sonra doÄŸum gÃ¼nÃ¼ olduÄŸunu',0),(434993,12084,'pl','Data urodzenia jest po dziÅ›',0),(434994,12084,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ðµ ÑÐ»ÐµÐ´ Ð´Ð½ÐµÑ',0),(434995,12084,'ur','ØªØ§Ø±ÛŒØ®Ù Ù¾ÛŒØ¯Ø§Ø¦Ø´ Ú©Û’ Ø¨Ø¹Ø¯ Ø¢Ø¬ ÛÛ’ Û”',0),(434996,12084,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ€Ð¾Ñ’ÐµÑšÐ° Ñ˜Ðµ Ð½Ð°ÐºÐ¾Ð½ Ð¾Ð²Ð¾Ð³Ð° Ð´Ð°Ð½Ð°Ñ',0),(434997,12084,'vi','ngÃ y sinh sau hÃ´m nay',0),(434998,12084,'af','Geboorte datum is na vandag',0),(434999,12084,'ro','Data naÅŸterii este dupÄƒ azi',0),(435000,12084,'et','SÃ¼nnikuupÃ¤ev on pÃ¤rast tÃ¤nast',0),(435001,12084,'si','Datum rojstva je po danaÅ¡njem',0),(435002,12084,'ba','Tanggal lahir adalah setelah hari ini',0),(435003,12084,'nl','Geboortedatum is na vandaag',0),(435004,12084,'fi','SyntymÃ¤pÃ¤ivÃ¤ on tÃ¤nÃ¤Ã¤n',0),(435005,12084,'no','FÃ¸dselsdato er etter dag',0),(435006,12084,'da','FÃ¸dselsdato er efter i dag',0),(435007,12084,'ko','ìƒë…„ì›”ì¼ì€ ì˜¤ëŠ˜ ì´í›„',0),(435008,12084,'he','×ª××¨×™×š ×”×œ×™×“×” ×”×•× ××—×¨×™ ×”×™×•×',0),(435009,12084,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î³Î­Î½Î½Î·ÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹ Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ ÏƒÎ®Î¼ÎµÏÎ±',0),(435010,12084,'zh','å‡ºç”Ÿæ—¥æœŸåœ¨ä»Šå¤©åŽ',0),(435011,12084,'sv','FÃ¶delsedatum Ã¤r efter dagens',0),(435012,12084,'it','Data di nascita Ã¨ dopo oggi',0),(435013,12084,'tl','',0),(435014,12084,'th','à¸§à¸±à¸™à¸™à¸µà¹‰à¸„à¸·à¸­à¸§à¸±à¸™à¹€à¸à¸´à¸”',0),(435015,12084,'hi','à¤œà¤¨à¥à¤® à¤¤à¤¿à¤¥à¤¿ à¤¹à¥ˆ à¤†à¤œ à¤•à¥‡ à¤¬à¤¾à¤¦',0),(435016,12084,'ms','Tarikh lahir adalah selepas hari',0),(435017,12084,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ÙŠÙ„Ø§Ø¯ Ø¨Ø¹Ø¯ Ø§Ù„ÙŠÙˆÙ…',0),(435018,12084,'fr','Date de naissance est postÃ©rieure Ã  aujourd\'hui',0),(435019,12084,'jp','ç”Ÿå¹´æœˆæ—¥ã¯ä»Šæ—¥ã®å¾Œ',0),(435020,12084,'pt','Data de nascimento Ã© depois de hoje',0),(435021,12084,'ru','Ð”Ð°Ñ‚Ð° Ñ€Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ â€” Ð¿Ð¾ÑÐ»Ðµ ÑÐµÐ³Ð¾Ð´Ð½Ñ',0),(435022,12084,'es','Fecha de Nacimiento es DespuÃ©s de Hoy',0),(435023,12084,'de','Geburtsdatum ist nach dem heutigen Tag',0),(435024,12084,'en','Birth date is after today',0),(435025,12085,'is','',0),(435026,12085,'dr','ØªØ§Ø±ÛŒØ® ØªÙˆÙ„Ø¯Ø¨Ø¹Ø¯ Ø§Ø²ØªØ§Ø±ÛŒØ® Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ø³Øª',0),(435027,12085,'pr','ØªØ§Ø±ÛŒØ® ØªÙˆÙ„Ø¯Ø¨Ø¹Ø¯ Ø§Ø²ØªØ§Ø±ÛŒØ® Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ø³Øª',0),(435028,12085,'tr','DoÄŸum gÃ¼nÃ¼ KiralÄ±k tarihinden sonradÄ±r',0),(435029,12085,'pl','Data urodzenia jest wynajem daty',0),(435030,12085,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ðµ ÑÐ»ÐµÐ´ Ð´Ð°Ñ‚Ð°Ñ‚Ð°',0),(435031,12085,'ur','ØªØ§Ø±ÛŒØ®Ù Ù¾ÛŒØ¯Ø§Ø¦Ø´ Ú©Û’ Ø¨Ø¹Ø¯ Ù…Ø²Ø¯ÙˆØ±ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® ÛÛ’ Û”',0),(435032,12085,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ€Ð¾Ñ’ÐµÑšÐ° Ñ˜Ðµ Ð½Ð°ÐºÐ¾Ð½ Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð¿Ð¾ÑˆÑ™Ð°Ð²Ð°ÑšÐ°',0),(435033,12085,'vi','ngÃ y sinh lÃ  ngÃ y sau khi thuÃª',0),(435034,12085,'af','Geboorte datum is na huur datum',0),(435035,12085,'ro','Data naÅŸterii este data de inchiriat',0),(435036,12085,'et','SÃ¼nnikuupÃ¤ev on pÃ¤rast rendi kuupÃ¤ev',0),(435037,12085,'si','Datum rojstva je po datum zaposlitve',0),(435038,12085,'ba','Tanggal lahir adalah setelah tanggal Penyewaan',0),(435039,12085,'nl','Geboortedatum is na de datum van indiensttreding',0),(435040,12085,'fi','SyntymÃ¤aika on jÃ¤lkeen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n, jolloin',0),(435041,12085,'no','FÃ¸dselsdato er etter ansettelsesdato',0),(435042,12085,'da','FÃ¸dselsdato er efter ansÃ¦ttelsesdatoen',0),(435043,12085,'ko','ì¶œìƒ ë‚ ì§œëŠ” ê³ ìš© ë‚ ì§œ í›„',0),(435044,12085,'he','×ª××¨×™×š ×”×œ×™×“×” ×”×•× ×œ××—×¨ ×ª××¨×™×š ×ª×—×™×œ×ª',0),(435045,12085,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î³Î­Î½Î½Î·ÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹ Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€ÏÏŒÏƒÎ»Î·ÏˆÎ®Ï‚',0),(435046,12085,'zh','å‡ºç”Ÿæ—¥æœŸåœ¨è˜ç”¨æ—¥æœŸåŽ',0),(435047,12085,'sv','FÃ¶delsedatum Ã¤r efter anstÃ¤llningsdatumet',0),(435048,12085,'it','Data di nascita Ã¨ dopo la data di assunzione',0),(435049,12085,'tl','',0),(435050,12085,'th','à¸§à¸±à¸™à¹€à¸à¸´à¸”à¸„à¸·à¸­à¸§à¸±à¸™à¸ˆà¹‰à¸²à¸‡à¸‡à¸²à¸™',0),(435051,12085,'hi','à¤œà¤¨à¥à¤® à¤¤à¤¿à¤¥à¤¿ à¤•à¤¿à¤°à¤¾à¤¯à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¹à¥ˆ',0),(435052,12085,'ms','Tarikh lahir adalah selepas tarikh Penyewaan',0),(435053,12085,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ÙŠÙ„Ø§Ø¯ Ø¨Ø¹Ø¯ ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙˆØ¸ÙŠÙ',0),(435054,12085,'fr','Date de naissance est aprÃ¨s la date d\'embauche',0),(435055,12085,'jp','ç”Ÿå¹´æœˆæ—¥ã¯å…¥ç¤¾æ—¥å¾Œ',0),(435056,12085,'pt','Data de nascimento Ã© apÃ³s a data de contrataÃ§Ã£o',0),(435057,12085,'ru','Ð”Ð°Ñ‚Ð° Ñ€Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ â€” Ð¿Ð¾ÑÐ»Ðµ Ð´Ð°Ñ‚Ñ‹ Ð½Ð°Ð¹Ð¼Ð°',0),(435058,12085,'es','Fecha de Nacimiento es DespuÃ©s de la fecha de empleo',0),(435059,12085,'de','Geburtsdatum ist nach Einstellungsdatum',0),(435060,12085,'en','Birth date is after hire date',0),(435061,12086,'is','',0),(435062,12086,'dr','/ Ø¨Ø³ØªÙ‡ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(435063,12086,'pr','Ø¨Ø±Ø§ÛŒ ØªØºÛŒÛŒØ± ÙˆØ¶Ø¹ÛŒØª Ø¨ÛŒÙ† Ø¨Ø§Ø²/ Ø¨Ø³ØªÙ‡ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(435064,12086,'tr','AÃ§/kapat geÃ§iÅŸ yapmak iÃ§in tÄ±klatÄ±n',0),(435065,12086,'pl','Kliknij, aby przeÅ‚Ä…czyÄ‡ otwierania/zamykania',0),(435066,12086,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¿Ñ€ÐµÐ²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚Ðµ Ð¾Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ/Ð·Ð°Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ',0),(435067,12086,'ur','Ø¯Ø¨Ø§Ø¦ÛŒÚº Ú©Ú¾ÙˆÙ„ÛŒÚº/Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(435068,12086,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑÐµ Ð¿Ñ€ÐµÐ±Ð°Ñ†Ð¸Ð²Ð°Ð»Ð¸ Ð¾Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ/Ð·Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ',0),(435069,12086,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ chuyá»ƒn Ä‘á»•i Má»Ÿ / ÄÃ³ng',0),(435070,12086,'af','Klik om te wissel Open/sluit',0),(435071,12086,'ro','FaceÅ£i clic pentru a comuta deschidere/Ã®nchidere',0),(435072,12086,'et','KlÃµpsake lÃ¼litab avamise/sulgemise',0),(435073,12086,'si','Kliknite Preklopi odpiranje/zapiranje',0),(435074,12086,'ba','Klik untuk beralih buka/tutup',0),(435075,12086,'nl','Klik om te openen/sluiten in-/ uitschakelen',0),(435076,12086,'fi','Vaihda Avaa/sulje',0),(435077,12086,'no','Klikk for Ã¥ skifte plateskuffen',0),(435078,12086,'da','Klik for at skifte mellem Ã¥bne/lukke',0),(435079,12086,'ko','ì—´ê¸°/ë‹«ê¸°ë¥¼ í´ë¦­ í•©ë‹ˆë‹¤',0),(435080,12086,'he','×œ×—×¥ ×›×“×™ ×œ×¢×‘×•×¨ ×¤×ª×™×—×”/×¡×’×™×¨×”',0),(435081,12086,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î¿ Î¬Î½Î¿Î¹Î³Î¼Î±/ÎºÎ»ÎµÎ¯ÏƒÎ¹Î¼Î¿',0),(435082,12086,'zh','ç‚¹å‡»è§¦å‘å¼€å…³',0),(435083,12086,'sv','Klicka fÃ¶r att vÃ¤xla mellan Ã¶ppna/stÃ¤ng',0),(435084,12086,'it','Clicca per aprire e chiudere',0),(435085,12086,'tl','',0),(435086,12086,'th','à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­à¸ªà¸¥à¸±à¸šà¹€à¸›à¸´à¸”/à¸›à¸´à¸”',0),(435087,12086,'hi','à¤–à¥à¤²à¤¾/à¤¬à¤‚à¤¦ à¤Ÿà¥‰à¤—à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(435088,12086,'ms','Klik untuk Togol buka/tutup',0),(435089,12086,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ ØªØ¨Ø¯ÙŠÙ„ ÙØªØ­/Ø¥ØºÙ„Ø§Ù‚',0),(435090,12086,'fr','Cliquez pour modifier l\'ouverture/fermeture',0),(435091,12086,'jp','ã‚¯ãƒªãƒƒã‚¯ã—ã¦é–‹ã/é–‰ã˜ã‚‹ã‚’åˆ‡ã‚Šæ›¿ãˆã¾ã™',0),(435092,12086,'pt','Clique para alternar entre abrir/fechar',0),(435093,12086,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð´Ð»Ñ Ð¿ÐµÑ€ÐµÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚ÑŒ/Ð·Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ',0),(435094,12086,'es','Hace Clik para Hacer Abre/Cierre',0),(435095,12086,'de','Klicken Sie auf das Ã–ffnen/SchlieÃŸen umschalten',0),(435096,12086,'en','Click To Toggle Open/Close',0),(435097,12087,'is','',0),(435098,12087,'dr','ÙˆÙ‚ØªÛŒ Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÛŒ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯ Ø§Ø¬Ø±Ø§ Ù†Ø´ÙˆØ¯',0),(435099,12087,'pr','ÙˆÙ‚ØªÛŒ Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÛŒ Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯ Ø§Ø¬Ø±Ø§ Ù†Ø´ÙˆØ¯',0),(435100,12087,'tr','Ã–zel Ã¶deme dÃ¶neminin hesaplamalarÄ± iÃ§in kullanÄ±lan uygulamayÄ±n',0),(435101,12087,'pl','Nie stosuje siÄ™ podczas okresu rozliczeniowego specjalne wykorzystywane do obliczeÅ„',0),(435102,12087,'bg','ÐÐµ ÑÐµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°Ñ‚, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ ÑÐ¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð·Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ÑÑ‚Ð°',0),(435103,12087,'ur','Ø®ØµÙˆØµÛŒ ØªÙ†Ø®ÙˆØ§Û Ø¯ÙˆØ± Ø­Ø³Ø§Ø¨ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ Ø¬Ø¨ Ú©Ø§ Ø§Ø·Ù„Ø§Ù‚ Ù†ÛÛŒÚº ÛÙˆØªØ§',0),(435104,12087,'sr','ÐÐµ Ð¿Ñ€Ð¸Ð¼ÐµÑšÑƒÑ˜Ñƒ ÑÐµ ÐºÐ°Ð´Ð° ÑÐ¿ÐµÑ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° ÐºÐ¾Ñ˜Ð¸ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð·Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð°ÑšÐµ',0),(435105,12087,'vi','khÃ´ng Ã¡p dá»¥ng khi ká»³ háº¡n thanh toÃ¡n Ä‘áº·c biá»‡t Ä‘Æ°á»£c sá»­ dá»¥ng trong tÃ­nh toÃ¡n',0),(435106,12087,'af','Moet nie toedien wanneer spesiale betaal tydperk vir berekeninge gebruik',0),(435107,12087,'ro','Nu se aplicÄƒ atunci cÃ¢nd perioada de platÄƒ speciale utilizate pentru calcule',0),(435108,12087,'et','Ei kohaldata, kui eriline makseperioodi kasutatud arvutuste puhul',0),(435109,12087,'si','Ne tretirati v posebno plaÄi, ki se uporabi za izraÄune',0),(435110,12087,'ba','Tidak berlaku ketika periode membayar khusus digunakan untuk perhitungan',0),(435111,12087,'nl','Niet van toepassing wanneer speciale betalen periode voor berekeningen gebruikt',0),(435112,12087,'fi','Ei sovelleta, kun laskennassa kÃ¤ytetyn erityistÃ¤ maksukauden',0),(435113,12087,'no','Gjelde ikke ved spesielle lÃ¸nnsperioden brukes til beregninger',0),(435114,12087,'da','Ikke anvendelse, nÃ¥r sÃ¦rlige lÃ¸nperiode bruges til beregninger',0),(435115,12087,'ko','íŠ¹ë³„ í•œ ì§€ë¶ˆ ê¸°ê°„ ê³„ì‚°ì— ì‚¬ìš© í•˜ëŠ” ê²½ìš°ëŠ” ì ìš© ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(435116,12087,'he','××™× ×Ÿ ×—×œ×•×ª ×‘×¢×ª ×ª×§×•×¤×ª ×ª×©×œ×•× ×ž×™×•×—×“ ×©×ž×©×ž×© ×œ×—×™×©×•×‘×™×',0),(435117,12087,'el','Î”ÎµÎ½ Î¹ÏƒÏ‡ÏÎ¿Ï…Î½ ÏŒÏ„Î±Î½ ÎµÎ¹Î´Î¹ÎºÎ­Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿Ï„Î¹ÎºÎ®Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï… Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(435118,12087,'zh','å½“ç‰¹æ®Šä»˜æ¬¾æ—¶æœŸç”¨ä½œè®¡ç®—æ—¶ä¸è¦åº”ç”¨',0),(435119,12087,'sv','GÃ¤ller inte nÃ¤r sÃ¤rskilda lÃ¶neperiod anvÃ¤nds fÃ¶r berÃ¤kningar',0),(435120,12087,'it','Non si applicano quando il periodo retributivo speciale utilizzato per i calcoli',0),(435121,12087,'tl','',0),(435122,12087,'th','à¹ƒà¸Šà¹‰à¹€à¸¡à¸·à¹ˆà¸­à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸Šà¸³à¸£à¸°à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸žà¸´à¹€à¸¨à¸©à¸—à¸µà¹ˆà¹ƒà¸Šà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸„à¸³à¸™à¸§à¸“',0),(435123,12087,'hi','à¤œà¤¬ à¤µà¤¿à¤¶à¥‡à¤· à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤…à¤µà¤§à¤¿ à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤ªà¤° à¤²à¤¾à¤—à¥‚ à¤¨à¤¹à¥€à¤‚',0),(435124,12087,'ms','Tidak digunakan apabila tempoh pembayaran gaji Khas digunakan bagi pengiraan',0),(435125,12087,'ar','Ù„Ø§ ØªÙ†Ø·Ø¨Ù‚ Ø¹Ù†Ø¯Ù…Ø§ ØªØ³ØªØ®Ø¯Ù… ÙØªØ±Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø®Ø§ØµØ© Ù„Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ÙŠØ©',0),(435126,12087,'fr','Ne s\'appliquent pas lorsque la pÃ©riode de paie spÃ©cial utilisÃ© pour les calculs',0),(435127,12087,'jp','ç‰¹åˆ¥ãªæ”¯æ‰•æœŸé–“ã®è¨ˆç®—ã«ä½¿ç”¨ã™ã‚‹å ´åˆã¯é©ç”¨ã•ã‚Œã¾ã›ã‚“ã€‚',0),(435128,12087,'pt','NÃ£o se aplicam quando o perÃ­odo de pagamento especial usado para cÃ¡lculos',0),(435129,12087,'ru','ÐÐµ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÑÑŽÑ‚ÑÑ, ÐºÐ¾Ð³Ð´Ð° Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑŽÑ‚ÑÑ Ð´Ð»Ñ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(435130,12087,'es','No se solicita cuando perÃ­odo especial de pago esta usado para los cÃ¡lculos',0),(435131,12087,'de','Gelten Sie nicht, wenn spezielle Zahlungsperiode fÃ¼r die Berechnungen verwendet',0),(435132,12087,'en','Do not apply when special pay period used for calculations',0),(435133,12088,'is','',0),(435134,12088,'dr','Ù†ÙˆØ¹ ØªØµÙˆÛŒØ± Ù…Ø¹ØªØ¨Ø±Ù†ÛŒØ³Øª',0),(435135,12088,'pr','Ù†ÙˆØ¹ ØªØµÙˆÛŒØ± Ù…Ø¹ØªØ¨Ø±Ù†ÛŒØ³Øª',0),(435136,12088,'tr','GeÃ§ersiz resim tÃ¼rÃ¼',0),(435137,12088,'pl','Typ nieprawidÅ‚owy obraz',0),(435138,12088,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð¾Ð±Ñ€Ð°Ð· Ñ‚Ð¸Ð¿',0),(435139,12088,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² ØªØµÙˆÛŒØ± Ú©ÛŒ Ù‚Ø³Ù…',0),(435140,12088,'sr','Ð¢Ð¸Ð¿ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ðµ ÑÐ»Ð¸ÐºÐµ',0),(435141,12088,'vi','Loáº¡i áº£nh vÃ´ hiá»‡u',0),(435142,12088,'af','Ongeldige beeld tipe',0),(435143,12088,'ro','Tipul de imagine nevalid',0),(435144,12088,'et','Sobimatu pildi tÃ¼Ã¼p',0),(435145,12088,'si','Neveljavna slikovna tipa',0),(435146,12088,'ba','Jenis foto tidak valid',0),(435147,12088,'nl','Ongeldige afbeeldingstype',0),(435148,12088,'fi','Virheellinen kuvalaji',0),(435149,12088,'no','Ugyldig bildetype',0),(435150,12088,'da','Ugyldig Billedtype',0),(435151,12088,'ko','ìž˜ëª» ëœ ì´ë¯¸ì§€ í˜•ì‹',0),(435152,12088,'he','×¡×•×’ ×ª×ž×•× ×” ×œ× ×—×•×§×™',0),(435153,12088,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· ÎµÎ¹ÎºÏŒÎ½Î± Ï„ÏÏ€Î¿Ï…',0),(435154,12088,'zh','æ— æ•ˆå›¾ç‰‡ç±»åž‹',0),(435155,12088,'sv','Ogiltig Bildtyp',0),(435156,12088,'it','Tipo di immagine non valido',0),(435157,12088,'tl','',0),(435158,12088,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸£à¸¹à¸›à¸ à¸²à¸žà¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(435159,12088,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤›à¤µà¤¿ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(435160,12088,'ms','Jenis imej tidak sah',0),(435161,12088,'ar','Ù†ÙˆØ¹ ØµÙˆØ±Ø© ØºÙŠØ± ØµØ§Ù„Ø­',0),(435162,12088,'fr','Type d\'Image non valide',0),(435163,12088,'jp','ç„¡åŠ¹ãªã‚¤ãƒ¡ãƒ¼ã‚¸ ã‚¿ã‚¤ãƒ—',0),(435164,12088,'pt','Tipo de imagem invÃ¡lido',0),(435165,12088,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ Ñ‚Ð¸Ð¿',0),(435166,12088,'es','Tipo de Imagen Invalido',0),(435167,12088,'de','UngÃ¼ltiger Bildtyp',0),(435168,12088,'en','Invalid Image Type',0),(435169,12089,'is','',0),(435170,12089,'dr','1    ',0),(435171,12089,'pr','Ø¨Ø§ÛŒØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡1    \r\nØ§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆØ¯',0),(435172,12089,'tr','Bir satÄ±cÄ± seÃ§mek gerekir',0),(435173,12089,'pl','NaleÅ¼y wybraÄ‡ dostawcÄ™',0),(435174,12089,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(435175,12089,'ur','Ø§ÛŒÚ© Ø®ÙˆØ§Ù†Ú†Û ÙØ±ÙˆØ´ Ø®Ø§ØªÙˆÙ† Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(435176,12089,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(435177,12089,'vi','Pháº£i chá»n nhÃ  cung cáº¥p A',0),(435178,12089,'af','\'N ondernemer moet kies',0),(435179,12089,'ro','Trebuie sÄƒ selectaÅ£i un furnizor',0),(435180,12089,'et','Tuleb valida hankija',0),(435181,12089,'si','Prodajalec mora izbrati',0),(435182,12089,'ba','Harus memilih Vendor',0),(435183,12089,'nl','Een leverancier moet selecteren',0),(435184,12089,'fi','Valitse toimittaja',0),(435185,12089,'no','MÃ¥ velge en leverandÃ¸r',0),(435186,12089,'da','Skal vÃ¦lge en leverandÃ¸r',0),(435187,12089,'ko','ê³µê¸‰ ì—…ì²´ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(435188,12089,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×¡×¤×§',0),(435189,12089,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î±Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(435190,12089,'zh','å¿…é¡»é€‰æ‹©ä¸€ä¸ªä¾›åº”å•†',0),(435191,12089,'sv','MÃ¥ste vÃ¤lja en leverantÃ¶r',0),(435192,12089,'it','Deve selezionare un fornitore',0),(435193,12089,'tl','',0),(435194,12089,'th','à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(435195,12089,'hi','à¤à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(435196,12089,'ms','Mesti memilih Vendor',0),(435197,12089,'ar','ÙŠØ¬Ø¨ ØªØ­Ø¯ÙŠØ¯ Ù…ÙˆØ±Ø¯',0),(435198,12089,'fr','Devez sÃ©lectionner un vendeur',0),(435199,12089,'jp','ä»•å…¥å…ˆã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(435200,12089,'pt','Deve selecionar um fornecedor',0),(435201,12089,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(435202,12089,'es','Debe Seleccionar un Proveedor',0),(435203,12089,'de','MÃ¼ssen einen Lieferanten auswÃ¤hlen',0),(435204,12089,'en','Must Select A Vendor',0),(435205,12090,'is','',0),(435206,12090,'dr','-Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÛŒ Ú©Ù†ÛŒØ¯',0),(435207,12090,'pr','Ù‡ÛŒÚ† Ø³ÙØ§Ø±Ø´ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª-Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÛŒ Ú©Ù†ÛŒØ¯',0),(435208,12090,'tr','SeÃ§ili - hiÃ§bir sipariÅŸ denemek bir daha',0),(435209,12090,'pl','Nie zamÃ³wienia wybranych - sprÃ³buj ponownie',0),(435210,12090,'bg','ÐÐ¸ÐºÐ°ÐºÑŠÐ² Ñ€ÐµÐ´ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ - Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(435211,12090,'ur','Ú©ÙˆØ¦ÛŒ ØªØ±ØªÛŒØ¨ Ù…Ù†ØªØ®Ø¨ - Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº',0),(435212,12090,'sr','ÐÐµÐ¼Ð° Ñ€ÐµÐ´Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸ - Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(435213,12090,'vi','khÃ´ng cÃ³ Ä‘Æ¡n hÃ ng Ä‘Æ°á»£c chá»n- thá»­ láº¡i',0),(435214,12090,'af','Geen bestelling gekies - probeer weer',0),(435215,12090,'ro','Nici o ordine selectat - Ã®ncercaÅ£i din nou',0),(435216,12090,'et','Valitud - tellimuse proovige uuesti',0),(435217,12090,'si','Nobenih nalog izbran - poskusite znova',0),(435218,12090,'ba','Tanpa urutan yang dipilih - coba lagi',0),(435219,12090,'nl','Geen volgorde geselecteerd - probeer het opnieuw',0),(435220,12090,'fi','MissÃ¤Ã¤n jÃ¤rjestyksessÃ¤ valittu - yritÃ¤ uudelleen',0),(435221,12090,'no','Ingen rekkefÃ¸lge valgt - prÃ¸v igjen',0),(435222,12090,'da','Ingen Ã¸nskede rÃ¦kkefÃ¸lge - prÃ¸v igen',0),(435223,12090,'ko','ì„ ì • ëœ-ìˆœì„œ ì—†ì´ ë‹¤ì‹œ ì‹œë„',0),(435224,12090,'he','××™×Ÿ ×¡×“×¨ ×©× ×‘×—×¨×• -. × ×¡×” ×©×•×‘',0),(435225,12090,'el','ÎšÎ±Î¼Î¯Î± Î´Î¹Î±Ï„Î±Î³Î® ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ - Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(435226,12090,'zh','æ²¡æœ‰å·²é€‰çš„è®¢å•-å†è¯•ä¸€æ¬¡',0),(435227,12090,'sv','Ingen ordning vald - fÃ¶rsÃ¶k igen',0),(435228,12090,'it','Nessun ordine selezionato - riprovare',0),(435229,12090,'tl','',0),(435230,12090,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸ - à¸¥à¸­à¸‡',0),(435231,12090,'hi','à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤šà¤¯à¤¨à¤¿à¤¤ - à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚',0),(435232,12090,'ms','Tiada perintah yang dipilih - cuba lagi',0),(435233,12090,'ar','Ù„Ø§ Ø£Ù…Ø± Ø§Ù„Ù…Ø­Ø¯Ø¯-Ø­Ø§ÙˆÙ„ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(435234,12090,'fr','Aucun ordre sÃ©lectionnÃ©s - n\'essayez Ã  nouveau',0),(435235,12090,'jp','é¸æŠžã®é †åºãªã„ã‚‚ã†ä¸€åº¦ã‚„ã‚Šç›´ã—ã¦ãã ã•ã„ã€‚',0),(435236,12090,'pt','Nenhuma ordem selecionada - tente novamente',0),(435237,12090,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð¾ - Ð¿Ð¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÐµÑ‰Ðµ Ñ€Ð°Ð·',0),(435238,12090,'es','No se SeleccionÃ³ un Orden - intenta Otra Vez',0),(435239,12090,'de','Keine Reihenfolge ausgewÃ¤hlt - versuchen Sie es erneut',0),(435240,12090,'en','No Order Selected - Try Again',0),(435241,12091,'is','',0),(435242,12091,'dr','Ù‡ÛŒÚ† Ú©Ø§Ø±ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø¯ÙˆØ±Ù‡ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(435243,12091,'pr','Ù‡ÛŒÚ† Ú©Ø§Ø±ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø¯ÙˆØ±Ù‡ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(435244,12091,'tr','Herhangi bir Ã§alÄ±ÅŸma dÃ¶nemi iÃ§in bulundu',0),(435245,12091,'pl','Nie ma pracy dla okresu',0),(435246,12091,'bg','Ð‘ÐµÐ· Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(435247,12091,'ur','Ù¾ÛŒØ±ÛŒÚˆ Ú©Û’ Ù„Ø¦Û’ Ú©ÙˆØ¦ÛŒ Ú©Ø§Ù…',0),(435248,12091,'sr','Ð‘ÐµÐ· Ð¿Ð¾ÑÐ»Ð° Ð¸ Ð½Ð°ÑˆÐ°Ð¾ Ð·Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(435249,12091,'vi','khÃ´ng tÃ¬m tháº¥y cÃ´ng viá»‡c trong thá»i gian nÃ y',0),(435250,12091,'af','Geen werk vir tydperk gevind',0),(435251,12091,'ro','Nici o lucrare pentru perioada',0),(435252,12091,'et','Aja jooksul leida tÃ¶Ã¶d',0),(435253,12091,'si','Brez dela za obdobje',0),(435254,12091,'ba','Tidak ada pekerjaan ditemukan untuk periode',0),(435255,12091,'nl','Geen werk gevonden voor periode',0),(435256,12091,'fi','Ei tyÃ¶tÃ¤ lÃ¶ydy ajan',0),(435257,12091,'no','Ingen arbeid funnet For perioden',0),(435258,12091,'da','Intet arbejde fandt For perioden',0),(435259,12091,'ko','ì—†ìŒ ìž‘ì—… ê¸°ê°„ì— ëŒ€ í•œ ë°œê²¬',0),(435260,12091,'he','××™×Ÿ ×¢×‘×•×“×” ×ž×¦× ×œ×ª×§×•×¤×”',0),(435261,12091,'el','ÎšÎ±Î¼Î¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î³Î¹Î± Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(435262,12091,'zh','æœŸå†…æ²¡æœ‰æ‰¾åˆ°å·¥ä½œ',0),(435263,12091,'sv','Inget arbete fÃ¶r perioden',0),(435264,12091,'it','Nessun lavoro trovato per periodo',0),(435265,12091,'tl','',0),(435266,12091,'th','à¸‡à¸²à¸™à¹„à¸¡à¹ˆà¸žà¸šà¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²',0),(435267,12091,'hi','à¤•à¥‹à¤ˆ à¤•à¤¾à¤® à¤•à¥€ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(435268,12091,'ms','Tiada kerja yang ditemui bagi tempoh',0),(435269,12091,'ar','Ø£ÙŠ Ø¹Ù…Ù„ ÙˆØ¬Ø¯Øª Ù„ÙØªØ±Ø©',0),(435270,12091,'fr','Pas trouvÃ© pour la pÃ©riode de travail',0),(435271,12091,'jp','æœŸé–“ã®ãŸã‚ã®ä»•äº‹ç„¡ã—',0),(435272,12091,'pt','Nenhum trabalho encontrou para perÃ­odo',0),(435273,12091,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð° Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(435274,12091,'es','No se Encuentra Trabajo Por Este PerÃ­odo',0),(435275,12091,'de','Keine Arbeit gefunden fÃ¼r Zeitraum',0),(435276,12091,'en','No Work Found For Period',0),(435277,12092,'is','',0),(435278,12092,'dr','Ù†Ù…Ø§ÛŒØ´ Ø³ØªÙˆÙ† Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´',0),(435279,12092,'pr','Ù†Ù…Ø§ÛŒØ´ Ø³ØªÙˆÙ† Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´',0),(435280,12092,'tr','Raporda sÃ¼tun gÃ¶ster',0),(435281,12092,'pl','PokaÅ¼ kolumny w raporcie',0),(435282,12092,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ð»Ð¾Ð½Ð° Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(435283,12092,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ù¾Ø± Ú©Ø§Ù„Ù… Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(435284,12092,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ð»Ð¾Ð½Ñƒ Ð½Ð° Ñ€Ð°Ð¿Ð¾Ñ€Ñ‚',0),(435285,12092,'vi','Hiá»ƒn thá»‹ cá»™t trÃªn bÃ¡o cÃ¡o',0),(435286,12092,'af','Kolom op verslag wys',0),(435287,12092,'ro','ColoanÄƒ AratÄƒ raport',0),(435288,12092,'et','NÃ¤ita veergu aruanne',0),(435289,12092,'si','PrikaÅ¾i stolpec na poroÄilo',0),(435290,12092,'ba','Lihat kolom laporan',0),(435291,12092,'nl','Kolom weergeven op verslag',0),(435292,12092,'fi','NÃ¤yttÃ¤Ã¤ sarakkeen mietinnÃ¶stÃ¤',0),(435293,12092,'no','Vis kolonne rapporten',0),(435294,12092,'da','Vis kolonne pÃ¥ rapport',0),(435295,12092,'ko','ë³´ê³ ì„œì— ìžˆëŠ” í‘œì‹œ ì—´',0),(435296,12092,'he','×”×¦×’ ×¢×ž×•×“×•×ª ×‘×“×•×—',0),(435297,12092,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÏ„Î®Î»Î·Ï‚ \"ÏƒÎµ Î­ÎºÎ¸ÎµÏƒÎ·',0),(435298,12092,'zh','æ˜¾ç¤ºæŠ¥å‘Šä¸Šçš„æ ',0),(435299,12092,'sv','Visa kolumnen rapporten',0),(435300,12092,'it','Visualizza la colonna sulla relazione',0),(435301,12092,'tl','',0),(435302,12092,'th','à¹à¸ªà¸”à¸‡à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œà¸šà¸™à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(435303,12092,'hi','à¤¸à¥à¤¤à¤‚à¤­ à¤ªà¤° à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(435304,12092,'ms','Tunjukkan kolum terakhir Laporan',0),(435305,12092,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø¹Ù…ÙˆØ¯ ÙÙŠ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(435306,12092,'fr','Voir la colonne rapport',0),(435307,12092,'jp','ãƒ¬ãƒãƒ¼ãƒˆã«åˆ—ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(435308,12092,'pt','Mostrar coluna no relatÃ³rio',0),(435309,12092,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ð»Ð±ÐµÑ† Ð½Ð° Ð´Ð¾ÐºÐ»Ð°Ð´',0),(435310,12092,'es','Muestra Columna en el kInforme',0),(435311,12092,'de','Spalte auf Bericht anzeigen',0),(435312,12092,'en','Show Column On Report',0),(435313,12093,'is','',0),(435314,12093,'dr','Ù†Ù…Ø§ÛŒØ´ ØºÛŒØ± ÙØ¹Ø§Ù„',0),(435315,12093,'pr','Ù†Ù…Ø§ÛŒØ´ ØºÛŒØ± ÙØ¹Ø§Ù„',0),(435316,12093,'tr','Etkin olmayan gÃ¶ster',0),(435317,12093,'pl','PokaÅ¼ nieaktywne',0),(435318,12093,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸Ñ‚Ðµ',0),(435319,12093,'ur','ØºÛŒØ± ÙØ¹Ø§Ù„ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(435320,12093,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð°',0),(435321,12093,'vi','Thá»ƒ hiá»‡n khÃ´ng hoáº¡t Ä‘á»™ng',0),(435322,12093,'af','Onaktiewe wys',0),(435323,12093,'ro','AratÄƒ inactiv',0),(435324,12093,'et','NÃ¤ita passiivseid',0),(435325,12093,'si','PokaÅ¾i neaktivni',0),(435326,12093,'ba','Tampilkan tidak aktif',0),(435327,12093,'nl','Toon inactieve',0),(435328,12093,'fi','NÃ¤ytÃ¤ passiiviset',0),(435329,12093,'no','Vis inaktiv',0),(435330,12093,'da','Vis inaktive',0),(435331,12093,'ko','ë¹„í™œì„± í‘œì‹œ',0),(435332,12093,'he','×”×¦×’ ××™× ×• ×¤×¢×™×œ',0),(435333,12093,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î±Î½ÎµÎ½ÎµÏÎ³ÏŒ',0),(435334,12093,'zh','æ˜¾ç¤ºä¸æ´»è·ƒè€…',0),(435335,12093,'sv','Visa inaktiva',0),(435336,12093,'it','Visualizza inattivo',0),(435337,12093,'tl','',0),(435338,12093,'th','à¹à¸ªà¸”à¸‡à¸‡à¸²à¸™',0),(435339,12093,'hi','à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(435340,12093,'ms','Menunjukkan tidak aktif',0),(435341,12093,'ar','Ø¥Ø¸Ù‡Ø§Ø± ØºÙŠØ± Ù†Ø´Ø·',0),(435342,12093,'fr','Voir la Inactive',0),(435343,12093,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã§ãªã„è¡¨ç¤ºã—ã¾ã™ã€‚',0),(435344,12093,'pt','Mostrar inativos',0),(435345,12093,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ',0),(435346,12093,'es','Muestra Inactivo',0),(435347,12093,'de','Karte inaktiv',0),(435348,12093,'en','Show Inactive',0),(435349,12094,'is','',0),(435350,12094,'dr','Ø§ÛŒÙ† Ù†ÙˆØ¹ Ø¹Ú©Ø³ Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ù†Ù…ÛŒ Ø´ÙˆØ¯',0),(435351,12094,'pr','Ø§ÛŒÙ† Ù†ÙˆØ¹ Ø¹Ú©Ø³ Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ù†Ù…ÛŒ Ø´ÙˆØ¯',0),(435352,12094,'tr','Bu resim tÃ¼rÃ¼ desteklenmiyor',0),(435353,12094,'pl','Ten typ obrazu nie jest obsÅ‚ugiwana',0),(435354,12094,'bg','Ð¢Ð°Ð·Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸Ð½Ð° Ñ‚Ð¸Ð¿ Ð½Ðµ ÑÐµ Ð¿Ð¾Ð´Ð´ÑŠÑ€Ð¶Ð°',0),(435355,12094,'ur','Ø§Ø³ ØªØµÙˆÛŒØ± Ú©ÛŒ Ù‚Ø³Ù… Ú©ÛŒ Ù…Ø¹Ø§ÙˆÙ†Øª Ù†ÛÛŒÚº',0),(435356,12094,'sr','ÐžÐ²Ð°Ñ˜ Ñ‚Ð¸Ð¿ ÑÐ° ÑÐ»Ð¸ÐºÐµ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾Ð´Ñ€Ð¶Ð°Ð½',0),(435357,12094,'vi','Loáº¡i hÃ¬nh nÃ y thÃ¬ khÃ´ng Ä‘Æ°á»£c há»— trá»£',0),(435358,12094,'af','Die prenttipe Is nie ondersteun nie',0),(435359,12094,'ro','Acest tip de poze pentru nu este acceptatÄƒ',0),(435360,12094,'et','Pildi tÃ¼Ã¼p pole toetatud',0),(435361,12094,'si','Ta tip slik ni podprt',0),(435362,12094,'ba','Jenis gambar ini tidak didukung',0),(435363,12094,'nl','Dit afbeeldingstype wordt niet ondersteund',0),(435364,12094,'fi','TÃ¤mÃ¤ kuva ei tueta',0),(435365,12094,'no','Dette bildet stÃ¸ttes ikke',0),(435366,12094,'da','Denne billedtype understÃ¸ttes ikke',0),(435367,12094,'ko','ì´ì™€ ê°™ì€ ê·¸ë¦¼ì€ ì§€ì› ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(435368,12094,'he','×¡×•×’ ×ª×ž×•× ×” ×–×• ××™× ×” × ×ª×ž×›×ª',0),(435369,12094,'el','Î‘Ï…Ï„ÏŒÏ‚ Î¿ Ï„ÏÏ€Î¿Ï‚ ÎµÎ¹ÎºÏŒÎ½Î±Ï‚ Î´ÎµÎ½ Ï…Ï€Î¿ÏƒÏ„Î·ÏÎ¯Î¶ÎµÏ„Î±Î¹',0),(435370,12094,'zh','ä¸æ”¯æŒæ­¤å›¾ç‰‡ç±»åž‹',0),(435371,12094,'sv','Denna Bildtyp stÃ¶ds inte',0),(435372,12094,'it','Questo tipo di foto non Ã¨ supportato',0),(435373,12094,'tl','',0),(435374,12094,'th','à¹„à¸¡à¹ˆà¸ªà¸™à¸±à¸šà¸ªà¸™à¸¸à¸™à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸£à¸¹à¸›à¸ à¸²à¸žà¸™à¸µà¹‰',0),(435375,12094,'hi','à¤‡à¤¸ à¤šà¤¿à¤¤à¥à¤° à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¤®à¤°à¥à¤¥à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(435376,12094,'ms','Jenis gambar ini tidak disokong',0),(435377,12094,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù†ÙˆØ¹ Ù…Ù† Ø§Ù„ØµÙˆØ±Ø© ØºÙŠØ± Ù…Ø¹ØªÙ…Ø¯',0),(435378,12094,'fr','Ce Type de photo n\'est pas pris en charge',0),(435379,12094,'jp','ã“ã®ç”»åƒã®ç¨®é¡žã¯ã‚µãƒãƒ¼ãƒˆã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(435380,12094,'pt','Este tipo de imagens nÃ£o Ã© suportado',0),(435381,12094,'ru','Ð­Ñ‚Ð¾Ñ‚ Ñ‚Ð¸Ð¿ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ Ð½Ðµ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶Ð¸Ð²Ð°ÐµÑ‚ÑÑ',0),(435382,12094,'es','Este Tipo de Cuadro No esta Soportado',0),(435383,12094,'de','Dieser Bildtyp wird nicht unterstÃ¼tzt.',0),(435384,12094,'en','This Picture Type Is Not Supported',0),(435385,12095,'is','',0),(435386,12095,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ø± Ø§Ø³Ø§Ø³ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÛŒ ÙØ±ÙˆØ´',0),(435387,12095,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ø± Ø§Ø³Ø§Ø³ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÛŒ ÙØ±ÙˆØ´',0),(435388,12095,'tr','SatÄ±ÅŸ kategoriye gÃ¶re gÃ¶rÃ¼ntÃ¼le',0),(435389,12095,'pl','Zobacz w kategorii sprzedaÅ¼y',0),(435390,12095,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(435391,12095,'ur','Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù†Ø¸Ø±',0),(435392,12095,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°Ð¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(435393,12095,'vi','Xem theo thá»ƒ loáº¡i bÃ¡n hÃ ng',0),(435394,12095,'af','Besigtig per Verkoopskategorie',0),(435395,12095,'ro','Vezi de categoria vanzari',0),(435396,12095,'et','Vaata mÃ¼Ã¼k kategooria jÃ¤rgi',0),(435397,12095,'si','Pogled po kategorijah prodaje',0),(435398,12095,'ba','Lihat kategori penjualan',0),(435399,12095,'nl','Mening door verkoop categorie',0),(435400,12095,'fi','Katso myyntiluokittain',0),(435401,12095,'no','Vis etter salg kategori',0),(435402,12095,'da','Vis efter salgskategori',0),(435403,12095,'ko','íŒë§¤ ì¹´í…Œê³ ë¦¬ ë³´ê¸°',0),(435404,12095,'he','×ª×¦×•×’×” ×œ×¤×™ ×§×˜×’×•×¨×™×” ×ž×›×™×¨×•×ª',0),(435405,12095,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Î½Î¬ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(435406,12095,'zh','æŒ‰é”€å”®ç±»åˆ«å¯Ÿçœ‹',0),(435407,12095,'sv','Visa efter fÃ¶rsÃ¤ljningskategori',0),(435408,12095,'it','Visualizzazione per categoria vendita',0),(435409,12095,'tl','',0),(435410,12095,'th','à¸”à¸¹à¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸—à¸à¸²à¸£à¸‚à¸²à¸¢',0),(435411,12095,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤…à¤¨à¥à¤¸à¤¾à¤° à¤¦à¥‡à¤–à¥‡à¤‚',0),(435412,12095,'ms','Lihat mengikut kategori jualan',0),(435413,12095,'ar','Ø¹Ø±Ø¶ Ø­Ø³Ø¨ ÙØ¦Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(435414,12095,'fr','Affichage par catÃ©gorie de ventes',0),(435415,12095,'jp','è²©å£²ã‚«ãƒ†ã‚´ãƒªåˆ¥è¡¨ç¤º',0),(435416,12095,'pt','Modo de exibiÃ§Ã£o por categoria vendas',0),(435417,12095,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°Ð¼ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(435418,12095,'es','Visionar Por CategorÃ­a de Venta',0),(435419,12095,'de','Nach Verkauf Kategorie anzeigen',0),(435420,12095,'en','View By Sales Category',0),(435421,12096,'is','',0),(435422,12096,'dr','Ø¨Ù‡ Ø·ÙˆØ± Ø§ØªÙˆÙ…Ø§ØªÛŒÚ© Ù¾Ø± Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ø§Ú¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(435423,12096,'pr','Ø¨Ù‡ Ø·ÙˆØ± Ø§ØªÙˆÙ…Ø§ØªÛŒÚ© Ù¾Ø± Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ø§Ú¯Ø± Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(435424,12096,'tr','Otomatik dolgu olacaktÄ±r stok',0),(435425,12096,'pl','BÄ™dzie Auto-Fill, jeÅ›li zapasy',0),(435426,12096,'bg','Ð©Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¿Ð¾Ð¿ÑŠÐ»Ð²Ð°Ð½Ðµ, Ð°ÐºÐ¾ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(435427,12096,'ur','Ø§Ú¯Ø± Ø®ÙˆØ¯ Ø¨Ú¾Ø±ÛŒÚº Ú¯Û’ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(435428,12096,'sr','Ð‹Ðµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð°ÐºÐ¾ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(435429,12096,'vi','Tá»± Ä‘á»™ng Ä‘iá»n vÃ o náº¿u lÃ  hÃ ng tá»•n kho',0),(435430,12096,'af','Sal Outo-vul as voorraad',0),(435431,12096,'ro','Va Auto-Fill dacÄƒ inventarul',0),(435432,12096,'et','On Auto-tÃ¤itke kui varude',0),(435433,12096,'si','ÄŒe bo samodejno zapolni zaloge',0),(435434,12096,'ba','Akan otomatis mengisi jika persediaan',0),(435435,12096,'nl','Auto-Fill zal als voorraad',0),(435436,12096,'fi','On automaattinen tÃ¤yttÃ¶, jos varaston',0),(435437,12096,'no','Vil automatisk fylle Hvis lageret',0),(435438,12096,'da','Vil Auto-Fill, hvis Inventory',0),(435439,12096,'ko','ê²½ìš° ìžë™ ì±„ìš°ê¸° ê²ƒ ìž¬ê³ ',0),(435440,12096,'he','×ª×•×›×œ×• ×œ×ž×œ× ××•×˜×•×ž×˜×™×ª ×× ×”×ž×œ××™',0),(435441,12096,'el','Î˜Î± Auto-ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÏƒÏ„Îµ Î±Î½ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(435442,12096,'zh','å¦‚æžœåº“å­˜ï¼Œå°†è‡ªåŠ¨å¡«å†™',0),(435443,12096,'sv','Kommer att fylla om inventering',0),(435444,12096,'it','Si Auto-Fill se inventario',0),(435445,12096,'tl','',0),(435446,12096,'th','à¸ˆà¸°à¹€à¸•à¸´à¸¡à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¸–à¹‰à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(435447,12096,'hi','à¤…à¤—à¤° à¤‘à¤Ÿà¥‹-à¤­à¤°à¤£ à¤•à¤°à¥‡à¤—à¤¾ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€',0),(435448,12096,'ms','Akan mengisi jika inventori',0),(435449,12096,'ar','Ø³ÙŠØªÙ… ØªØ¹Ø¨Ø¦Ø© Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(435450,12096,'fr','Se remplir automatiquement si l\'inventaire',0),(435451,12096,'jp','è‡ªå‹•å¡—ã‚Šã¤ã¶ã—ãŒã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒª',0),(435452,12096,'pt','IrÃ¡ preencher automaticamente se inventÃ¡rio',0),(435453,12096,'ru','Ð‘ÑƒÐ´ÐµÑ‚ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð·Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ ÐµÑÐ»Ð¸ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(435454,12096,'es','Auto CompletarÃ¡ Si Es Inventario',0),(435455,12096,'de','Auto-ausfÃ¼llen wird, wenn Warenbestand',0),(435456,12096,'en','Will Auto-Fill If Inventory',0),(435457,12097,'is','',0),(435458,12097,'dr','Ø¨Ø§Ø±Ú¯Ø²Ø§Ø±ÛŒ',0),(435459,12097,'pr','Ø¨Ø§Ø±Ú¯Ø²Ø§Ø±ÛŒ',0),(435460,12097,'tr','Yenileme',0),(435461,12097,'pl','OdÅ›wieÅ¼',0),(435462,12097,'bg','ÐžÐ±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(435463,12097,'ur','ØªØ§Ø²Û Ú©Ø±ÛŒÚº',0),(435464,12097,'sr','ÐžÑÐ²Ñ˜ÐµÐ¶Ð¸',0),(435465,12097,'vi','Refresh',0),(435466,12097,'af','Verfris',0),(435467,12097,'ro','ReÃ®mprospÄƒtare',0),(435468,12097,'et','VÃ¤rskenda',0),(435469,12097,'si','OsveÅ¾i',0),(435470,12097,'ba','Refresh',0),(435471,12097,'nl','Vernieuwen',0),(435472,12097,'fi','PÃ¤ivitÃ¤',0),(435473,12097,'no','Oppdater',0),(435474,12097,'da','Opdater',0),(435475,12097,'ko','ìƒˆë¡œ ê³ ì¹¨',0),(435476,12097,'he','×¨×¢× ×•×Ÿ',0),(435477,12097,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ·',0),(435478,12097,'zh','åˆ·æ–°',0),(435479,12097,'sv','Uppdatera',0),(435480,12097,'it','Aggiornamento',0),(435481,12097,'tl','',0),(435482,12097,'th','à¸£à¸µà¹€à¸Ÿà¸£à¸Š',0),(435483,12097,'hi','à¤¤à¤¾à¤œà¤¼à¤¾ à¤•à¤°à¥‡à¤‚',0),(435484,12097,'ms','Muat semula',0),(435485,12097,'ar','Ù‚Ù… Ø¨ØªØ­Ø¯ÙŠØ«',0),(435486,12097,'fr','Actualisation',0),(435487,12097,'jp','æ›´æ–°',0),(435488,12097,'pt','AtualizaÃ§Ã£o',0),(435489,12097,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(435490,12097,'es','Refrescar',0),(435491,12097,'de','Aktualisieren',0),(435492,12097,'en','Refresh',0),(435493,12098,'is','',0),(435494,12098,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø¯ØºØ§Ù… Ø´Ø¯',0),(435495,12098,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø¯ØºØ§Ù… Ø´Ø¯',0),(435496,12098,'tr','BirleÅŸtirme baÅŸarÄ±lÄ±',0),(435497,12098,'pl','PoÅ‚Ä…czyÄ‡ sukces',0),(435498,12098,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð°',0),(435499,12098,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ø¶Ù… Ú©Ø±ÛŒÚº',0),(435500,12098,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð° Ð¾Ð±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐ°',0),(435501,12098,'vi','Trá»™n thÃ nh cÃ´ng',0),(435502,12098,'af','Suksesvolle saamvoeg',0),(435503,12098,'ro','ÃŽmbinare de succes',0),(435504,12098,'et','Edukad mestida',0),(435505,12098,'si','Spajanje uspeÅ¡no',0),(435506,12098,'ba','Menggabungkan sukses',0),(435507,12098,'nl','Succesvolle samenvoegen',0),(435508,12098,'fi','YhdistÃ¤minen onnistui',0),(435509,12098,'no','Flette vellykket',0),(435510,12098,'da','Flette vellykket',0),(435511,12098,'ko','ë³‘í•© ì„±ê³µì ',0),(435512,12098,'he','×ž×™×–×•×’ ×ž×•×¦×œ×—',0),(435513,12098,'el','Î•Ï€Î¹Ï„Ï…Ï‡Î®Ï‚ ÏƒÏ…Î³Ï‡ÏŽÎ½ÎµÏ…ÏƒÎ·',0),(435514,12098,'zh','åˆå¹¶æˆåŠŸ',0),(435515,12098,'sv','Sammanfoga framgÃ¥ngsrika',0),(435516,12098,'it','Unire il successo',0),(435517,12098,'tl','',0),(435518,12098,'th','à¸£à¸§à¸¡à¸›à¸£à¸°à¸ªà¸šà¸„à¸§à¸²à¸¡à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(435519,12098,'hi','à¤¸à¤«à¤² à¤®à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(435520,12098,'ms','Gabungan yang berjaya',0),(435521,12098,'ar','Ø¯Ù…Ø¬ Ø§Ù„Ù†Ø§Ø¬Ø­',0),(435522,12098,'fr','Fusion rÃ©ussie',0),(435523,12098,'jp','ãƒžãƒ¼ã‚¸æˆåŠŸ',0),(435524,12098,'pt','Mesclar bem sucedida',0),(435525,12098,'ru','Ð¡Ð»Ð¸ÑÐ½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(435526,12098,'es','IntegraciÃ³n Exitosa',0),(435527,12098,'de','Erfolgreiche zusammenfÃ¼hren',0),(435528,12098,'en','Merge successful',0),(435529,12099,'is','',0),(435530,12099,'dr','Ø®Ø·Ø§ÛŒ - Ù†ÙˆØ¹ ÙØ§ÛŒÙ„ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ Ø§Ø¬Ø§Ø²Ù‡ Ø¯Ø§Ø¯Ù‡ Ù†Ù…ÛŒ Ø´ÙˆØ¯',0),(435531,12099,'pr','Ø®Ø·Ø§ÛŒ - Ù†ÙˆØ¹ ÙØ§ÛŒÙ„ Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯Ù‡ Ø§Ø¬Ø§Ø²Ù‡ Ø¯Ø§Ø¯Ù‡ Ù†Ù…ÛŒ Ø´ÙˆØ¯',0),(435532,12099,'tr','Hata - karÅŸÄ±ya dosya tÃ¼rÃ¼ne izin verilmiyor.',0),(435533,12099,'pl','BÅ‚Ä…d - typ pliku wgrany jest niedozwolone',0),(435534,12099,'bg','Ð“Ñ€ÐµÑˆÐºÐ° - Ñ‚Ð¸Ð¿ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° ÐºÐ°Ñ‡ÐµÐ½Ð¸, Ð½Ðµ Ðµ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(435535,12099,'ur','Ù†Ù‚Øµ - Ù‚Ø³Ù… Ù…Ø³Ù„ Ø§Ù¾ Ù„ÙˆÚˆ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº ÛÛ’',0),(435536,12099,'sr','Ð“Ñ€ÐµÑˆÐºÐ° - Ñ‚Ð¸Ð¿ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ðµ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð°',0),(435537,12099,'vi','Lá»—i - loáº¡i tá»‡p Ä‘Ã£ táº£i lÃªn khÃ´ng Ä‘Æ°á»£c phÃ©p',0),(435538,12099,'af','Fout - lÃªertipe opgelaai word nie toegelaat nie',0),(435539,12099,'ro','Eroare - tip de fiÅŸier Ã®ncÄƒrcat nu este permis',0),(435540,12099,'et','Viga - laadinud failitÃ¼Ã¼p pole lubatud',0),(435541,12099,'si','Napaka â€“ vrste datoteke naloÅ¾ili ni dovoljeno',0),(435542,12099,'ba','Kesalahan - jenis File upload tidak diperbolehkan',0),(435543,12099,'nl','Fout - bestandstype geÃ¼pload is niet toegestaan',0),(435544,12099,'fi','Virhe - ladattu tiedostotyyppiÃ¤ ei sallita',0),(435545,12099,'no','Feil - filtypen lastet opp er ikke tillatt',0),(435546,12099,'da','Fejl - filtype uploadet er ikke tilladt',0),(435547,12099,'ko','ì˜¤ë¥˜-íŒŒì¼ í˜•ì‹ì€ ì—…ë¡œë“œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(435548,12099,'he','×©×’×™××” - ×¡×•×’ ×”×§×•×‘×¥ × ×˜×¢×Ÿ ××™× ×” ×ž×•×ª×¨×ª',0),(435549,12099,'el','Î£Ï†Î¬Î»Î¼Î± - Ï„ÏÏ€Î¿ Î±ÏÏ‡ÎµÎ¯Î¿Ï… Ï€Î¿Ï… Ï†Î¿ÏÏ„ÏŽÎ¸Î·ÎºÎµ Î´ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(435550,12099,'zh','é”™è¯¯-ä¸å…è®¸ä¸Šè½½çš„æ–‡ä»¶ç±»åž‹',0),(435551,12099,'sv','Fel - filtyp som du laddat upp Ã¤r inte tillÃ¥tet',0),(435552,12099,'it','Errore - tipo di File caricato non Ã¨ consentito',0),(435553,12099,'tl','',0),(435554,12099,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸” - à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹ƒà¸Šà¹‰à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¹à¸Ÿà¹‰à¸¡à¸—à¸µà¹ˆà¸­à¸±à¸›à¹‚à¸«à¸¥à¸”',0),(435555,12099,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ - à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(435556,12099,'ms','Ralat - jenis fail yang dimuat naik tidak dibenarkan',0),(435557,12099,'ar','Ø®Ø·Ø£--Ù„Ø§ ÙŠØ³Ù…Ø­ Ø¨Ù†ÙˆØ¹ Ø§Ù„Ù…Ù„Ù Ø§Ù„ØªÙŠ ØªÙ… ØªØ­Ù…ÙŠÙ„Ù‡Ø§',0),(435558,12099,'fr','Erreur - type du fichier tÃ©lÃ©chargÃ© n\'est pas autorisÃ©',0),(435559,12099,'jp','ã‚¨ãƒ©ãƒ¼ - ãƒ•ã‚¡ã‚¤ãƒ«ã®ç¨®é¡žã®ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã¯è¨±å¯ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(435560,12099,'pt','Erro - tipo de arquivo carregado nÃ£o Ã© permitido',0),(435561,12099,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° - Ñ‚Ð¸Ð¿ Ñ„Ð°Ð¹Ð»Ð¾Ð², ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð·Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ñ‹ Ð½Ðµ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(435562,12099,'es','Error - no se permite el tipo de archivo subido',0),(435563,12099,'de','Fehler - Dateityp, der hochgeladen ist nicht mÃ¶glich.',0),(435564,12099,'en','Error - File type uploaded is not allowed',0),(435565,12100,'is','',0),(435566,12100,'dr','ÙˆØ¨ Ø³Ø§ÛŒØª Ø´Ø±Ú©Øª',0),(435567,12100,'pr','ÙˆØ¨ Ø³Ø§ÛŒØª Ø´Ø±Ú©Øª',0),(435568,12100,'tr','Åžirketin web sitesi',0),(435569,12100,'pl','Strona internetowa firmy',0),(435570,12100,'bg','Ð¤Ð¸Ñ€Ð¼ÐµÐ½ ÑƒÐµÐ±ÑÐ°Ð¹Ñ‚',0),(435571,12100,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹',0),(435572,12100,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚ Ð¿Ñ€ÐµÐ·ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ˜Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(435573,12100,'vi','Trang web cÃ´ng ty',0),(435574,12100,'af','Maatskappy webwerf',0),(435575,12100,'ro','Site-ul companiei',0),(435576,12100,'et','Firma Koduleht',0),(435577,12100,'si','Spletna stran podjetja',0),(435578,12100,'ba','Website perusahaan',0),(435579,12100,'nl','Bedrijfswebsite',0),(435580,12100,'fi','Yritys Website',0),(435581,12100,'no','Selskapets hjemmeside',0),(435582,12100,'da','Firma hjemmeside',0),(435583,12100,'ko','íšŒì‚¬ ì›¹ì‚¬ì´íŠ¸',0),(435584,12100,'he','×‘××ª×¨ ×”×—×‘×¨×”',0),(435585,12100,'el','Î™ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(435586,12100,'zh','å…¬å¸ç½‘ç«™',0),(435587,12100,'sv','FÃ¶retagets webbplats',0),(435588,12100,'it','Sito Web azienda',0),(435589,12100,'tl','',0),(435590,12100,'th','à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¸šà¸£à¸´à¸©à¸±à¸—',0),(435591,12100,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥€ à¤µà¥‡à¤¬à¤¸à¤¾à¤‡à¤Ÿ',0),(435592,12100,'ms','Laman web Syarikat',0),(435593,12100,'ar','Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø´Ø±ÙƒØ© Ø¹Ù„Ù‰ Ø´Ø¨ÙƒØ© Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª.',0),(435594,12100,'fr','Site Web de compagnie',0),(435595,12100,'jp','ä¼šç¤¾ã®ã‚¦ã‚§ãƒ–ã‚µã‚¤ãƒˆ',0),(435596,12100,'pt','Site da empresa',0),(435597,12100,'ru','Ð’ÐµÐ±-ÑÐ°Ð¹Ñ‚ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(435598,12100,'es','Sitio web de la empresa',0),(435599,12100,'de','Unternehmens-Website',0),(435600,12100,'en','Company Website',0),(435601,12101,'is','',0),(435602,12101,'dr','Ù…Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø±ÙƒØª',0),(435603,12101,'pr','Ù…Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø±ÙƒØª',0),(435604,12101,'tr','Benim firma bilgileri',0),(435605,12101,'pl','Moja firma Info',0),(435606,12101,'bg','ÐœÐ¾ÑÑ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð°',0),(435607,12101,'ur','Ù…ÛŒØ±ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(435608,12101,'sr','ÐœÐ¾Ñ˜Ð¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(435609,12101,'vi','ThÃ´ng tin cÃ´ng ty cá»§a tÃ´i',0),(435610,12101,'af','My maatskappy inligting',0),(435611,12101,'ro','Info meu de companie',0),(435612,12101,'et','Minu Firmast',0),(435613,12101,'si','Moje podjetje Info',0),(435614,12101,'ba','Info Perusahaan saya',0),(435615,12101,'nl','Mijn Bedrijfsinfo',0),(435616,12101,'fi','Yritysinfo',0),(435617,12101,'no','Min firmainformasjon',0),(435618,12101,'da','Mit firma Info',0),(435619,12101,'ko','ë‚´ íšŒì‚¬ ì •ë³´',0),(435620,12101,'he','×¤×¨×˜×™ ×”×—×‘×¨×” ×©×œ×™',0),(435621,12101,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎ¯Î± Î¼Î¿Ï…',0),(435622,12101,'zh','æˆ‘å…¬å¸çš„ä¿¡æ¯',0),(435623,12101,'sv','Mitt fÃ¶retag information',0),(435624,12101,'it','Mia azienda Info',0),(435625,12101,'tl','',0),(435626,12101,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸šà¸£à¸´à¸©à¸±à¸—à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(435627,12101,'hi','à¤®à¥‡à¤°à¥€ à¤•à¤‚à¤ªà¤¨à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(435628,12101,'ms','Maklumat syarikat saya',0),(435629,12101,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ© Ø¨Ù„Ø¯ÙŠ',0),(435630,12101,'fr','Mes infos sociÃ©tÃ©',0),(435631,12101,'jp','ç§ã®ä¼šç¤¾ã®æƒ…å ±',0),(435632,12101,'pt','Minha informaÃ§Ã£o de companhia',0),(435633,12101,'ru','ÐœÐ¾Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(435634,12101,'es','InformaciÃ³n de mi empresa',0),(435635,12101,'de','Meine Firma-Info',0),(435636,12101,'en','My Company Info',0),(435637,12102,'is','',0),(435638,12102,'dr','Ø§ÛŒÙ…ÛŒÙ„ Ù…Ù†',0),(435639,12102,'pr','Ø§ÛŒÙ…ÛŒÙ„ Ù…Ù†',0),(435640,12102,'tr','E-posta',0),(435641,12102,'pl','MÃ³j poczta elektroniczna',0),(435642,12102,'bg','ÐœÐ¾Ñ Ð¸Ð¼ÐµÐ¹Ð»',0),(435643,12102,'ur','Ù…ÛŒØ±Û’ Ø§ÛŒ Ù…ÛŒÙ„',0),(435644,12102,'sr','ÐœÐ¾Ñ˜ Ð•Ð¼Ð°Ð¸Ð»',0),(435645,12102,'vi','Email cá»§a tÃ´i',0),(435646,12102,'af','My e-pos',0),(435647,12102,'ro','Meu poÅŸtÄƒ electronicÄƒ',0),(435648,12102,'et','Minu e-posti',0),(435649,12102,'si','Svoj Email',0),(435650,12102,'ba','Email saya',0),(435651,12102,'nl','Mijn E-mail',0),(435652,12102,'fi','Minun Email',0),(435653,12102,'no','Meg Email',0),(435654,12102,'da','Mig Email',0),(435655,12102,'ko','ë‚´ ì´ë©”ì¼',0),(435656,12102,'he','×”×“×•× ×œ ×©×œ×™',0),(435657,12102,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Î¼Î¿Ï…',0),(435658,12102,'zh','æˆ‘çš„ç”µå­é‚®ä»¶',0),(435659,12102,'sv','Min e-post',0),(435660,12102,'it','La mia Email',0),(435661,12102,'tl','',0),(435662,12102,'th','à¸­à¸µà¹€à¸¡à¸¥à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(435663,12102,'hi','à¤®à¥‡à¤°à¤¾ à¤ˆà¤®à¥‡à¤²',0),(435664,12102,'ms','E-mel saya',0),(435665,12102,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨ÙŠ',0),(435666,12102,'fr','Mon Email',0),(435667,12102,'jp','ç§ã®é›»å­ãƒ¡ãƒ¼ãƒ«',0),(435668,12102,'pt','Meu Email',0),(435669,12102,'ru','ÐœÐ¾Ð¹ Ð°Ð´Ñ€ÐµÑ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(435670,12102,'es','Mi correo electrÃ³nico',0),(435671,12102,'de','Meine E-Mail',0),(435672,12102,'en','My Email',0),(435673,12103,'is','',0),(435674,12103,'dr','Ù†Ø§Ù… Ù…Ù†',0),(435675,12103,'pr','Ù†Ø§Ù… Ù…Ù†',0),(435676,12103,'tr','Ä°lk adÄ±m',0),(435677,12103,'pl','Moje imiÄ™',0),(435678,12103,'bg','ÐœÐ¾ÐµÑ‚Ð¾ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾ Ð¸Ð¼Ðµ',0),(435679,12103,'ur','Ù…ÛŒØ±Ø§ Ù†Ø§Ù…',0),(435680,12103,'sr','ÐœÐ¾Ñ˜Ðµ Ð¿Ñ€Ð²Ð¾ Ð¸Ð¼Ðµ',0),(435681,12103,'vi','TÃªn Ä‘áº§u tiÃªn cá»§a tÃ´i',0),(435682,12103,'af','My eerste naam',0),(435683,12103,'ro','Primul meu nume',0),(435684,12103,'et','Minu eesnimi',0),(435685,12103,'si','Moje ime',0),(435686,12103,'ba','Nama pertama saya',0),(435687,12103,'nl','Mijn voornaam',0),(435688,12103,'fi','EnsimmÃ¤inen nimi',0),(435689,12103,'no','Mitt fornavn',0),(435690,12103,'da','Mit fornavn',0),(435691,12103,'ko','ë‚´ ì´ë¦„',0),(435692,12103,'he','×”×©× ×”×¤×¨×˜×™ ×©×œ×™',0),(435693,12103,'el','Î¤Î¿ ÎŸÎÎŸÎœÎ‘ Î¼Î¿Ï…',0),(435694,12103,'zh','æˆ‘çš„åå­—',0),(435695,12103,'sv','Mitt fÃ¶rnamn',0),(435696,12103,'it','Mio primo nome',0),(435697,12103,'tl','',0),(435698,12103,'th','à¸Šà¸·à¹ˆà¸­à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(435699,12103,'hi','à¤®à¥‡à¤°à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¨à¤¾à¤®',0),(435700,12103,'ms','Nama saya',0),(435701,12103,'ar','Ø§Ø³Ù…ÙŠ Ø§Ù„Ø£ÙˆÙ„',0),(435702,12103,'fr','Mon prÃ©nom',0),(435703,12103,'jp','ç§ã®æœ€åˆã®åå‰',0),(435704,12103,'pt','Meu primeiro nome',0),(435705,12103,'ru','ÐœÐ¾Ðµ Ð¸Ð¼Ñ',0),(435706,12103,'es','Mi nombre de pila',0),(435707,12103,'de','Mein Vorname',0),(435708,12103,'en','My First Name',0),(435709,12104,'is','',0),(435710,12104,'dr','Ù…Ù† Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(435711,12104,'pr','Ù…Ù† Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(435712,12104,'tr','Benim soyadÄ±',0),(435713,12104,'pl','Moje nazwisko',0),(435714,12104,'bg','ÐœÐ¾ÑÑ‚Ð° Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ',0),(435715,12104,'ur','Ù…ÛŒØ±ÛŒ Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù…',0),(435716,12104,'sr','ÐœÐ¾Ñ˜Ðµ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(435717,12104,'vi','TÃªn cuá»‘i cÃ¹ng cá»§a tÃ´i',0),(435718,12104,'af','My laaste naam',0),(435719,12104,'ro','Numele meu trecut',0),(435720,12104,'et','Minu Viimane nimi',0),(435721,12104,'si','Moj priimek',0),(435722,12104,'ba','Nama terakhir saya',0),(435723,12104,'nl','Mijn achternaam',0),(435724,12104,'fi','Viimeinen nimi',0),(435725,12104,'no','Mitt etternavn',0),(435726,12104,'da','Mit efternavn',0),(435727,12104,'ko','ë‚´ ë§ˆì§€ë§‰ ì´ë¦„',0),(435728,12104,'he','×©× ×”×ž×©×¤×—×” ×©×œ×™',0),(435729,12104,'el','Î•Ï€Î¯Î¸ÎµÏ„ÏŒ Î¼Î¿Ï…',0),(435730,12104,'zh','æˆ‘çš„å§“',0),(435731,12104,'sv','Mitt efternamn',0),(435732,12104,'it','Il mio cognome',0),(435733,12104,'tl','',0),(435734,12104,'th','à¸Šà¸·à¹ˆà¸­à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(435735,12104,'hi','à¤®à¥‡à¤°à¥€ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤®',0),(435736,12104,'ms','Nama saya',0),(435737,12104,'ar','Ø§Ø³Ù…ÙŠ Ø§Ù„Ø£Ø®ÙŠØ±',0),(435738,12104,'fr','Mon nom de famille',0),(435739,12104,'jp','ç§ã®æœ€å¾Œã®åå‰',0),(435740,12104,'pt','Meu sobrenome',0),(435741,12104,'ru','ÐœÐ¾Ñ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ',0),(435742,12104,'es','Mi apellido',0),(435743,12104,'de','Mein Nachname',0),(435744,12104,'en','My Last Name',0),(435745,12105,'is','',0),(435746,12105,'dr','Ù†Ø§Ù… ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… Ù…Ù†',0),(435747,12105,'pr','Ù†Ø§Ù… ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… Ù…Ù†',0),(435748,12105,'tr','Benim mantÄ±k ad',0),(435749,12105,'pl','MÃ³j login',0),(435750,12105,'bg','ÐœÐ¾ÑÑ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ',0),(435751,12105,'ur','Ù…ÛŒØ±Û’ Ù„Ø§Ú¯ Ø§Ù† Ù†Ø§Ù…',0),(435752,12105,'sr','ÐœÐ¾Ñ˜Ðµ Ð¸Ð¼Ðµ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ',0),(435753,12105,'vi','TÃªn Ä‘Äƒng nháº­p cá»§a tÃ´i',0),(435754,12105,'af','My inteken naam',0),(435755,12105,'ro','Numele meu de Login',0),(435756,12105,'et','Mu kasutajanimi',0),(435757,12105,'si','Moje uporabniÅ¡ko ime',0),(435758,12105,'ba','Nama Login saya',0),(435759,12105,'nl','Mijn loginnaam',0),(435760,12105,'fi','Minun johdonmukaisuus maine',0),(435761,12105,'no','Mitt brukernavn',0),(435762,12105,'da','Mit loginnavn',0),(435763,12105,'ko','ë‚´ ë¡œê·¸ì¸ ì´ë¦„',0),(435764,12105,'he','×©× ×”×ž×©×ª×ž×© ×©×œ×™',0),(435765,12105,'el','Î¤Î¿ ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· Î¼Î¿Ï…',0),(435766,12105,'zh','æˆ‘çš„ç™»å½•å',0),(435767,12105,'sv','Mitt anvÃ¤ndarnamn',0),(435768,12105,'it','Il mio nome Login',0),(435769,12105,'tl','',0),(435770,12105,'th','à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(435771,12105,'hi','à¤®à¥‡à¤°à¤¾ à¤²à¥‰à¤—à¤¿à¤¨ à¤¨à¤¾à¤®',0),(435772,12105,'ms','Nama saya',0),(435773,12105,'ar','Ø§Ø³Ù… ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø®Ø§Øµ Ø¨ÙŠ',0),(435774,12105,'fr','Mon nom d\'utilisateur',0),(435775,12105,'jp','ç§ã®ãƒ­ã‚°ã‚¤ãƒ³å',0),(435776,12105,'pt','Meu nome de Login',0),(435777,12105,'ru','ÐœÐ¾Ð¹ Ð»Ð¾Ð³Ð¸Ð½',0),(435778,12105,'es','Mi nombre de usuario',0),(435779,12105,'de','Mein Login-Name',0),(435780,12105,'en','My Login Name',0),(435781,12106,'is','',0),(435782,12106,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø®ØµÛŒ Ù…Ù†',0),(435783,12106,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø®ØµÛŒ Ù…Ù†',0),(435784,12106,'tr','KiÅŸisel bilgilerim',0),(435785,12106,'pl','Moje dane osobowe',0),(435786,12106,'bg','ÐœÐ¾ÑÑ‚Ð° Ð»Ð¸Ñ‡Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(435787,12106,'ur','Ù…ÛŒØ±ÛŒ Ø°Ø§ØªÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(435788,12106,'sr','ÐœÐ¾Ñ˜Ðµ Ð»Ð¸Ñ‡Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(435789,12106,'vi','ThÃ´ng tin cÃ¡ nhÃ¢n cá»§a tÃ´i',0),(435790,12106,'af','My persoonlike inligting',0),(435791,12106,'ro','Informatiile mele personale',0),(435792,12106,'et','Minu isiklik Info',0),(435793,12106,'si','Moje osebne informacije',0),(435794,12106,'ba','Saya pribadi Info',0),(435795,12106,'nl','Mijn persoonlijke Info',0),(435796,12106,'fi','Omat tiedot',0),(435797,12106,'no','Min personlige informasjon',0),(435798,12106,'da','Min personlige Info',0),(435799,12106,'ko','ë‚´ ê°œì¸ ì •ë³´',0),(435800,12106,'he','×ž×™×“×¢ ××™×©×™ ×©×œ×™',0),(435801,12106,'el','Î ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ­Ï‚ Î¼Î¿Ï… Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(435802,12106,'zh','æˆ‘çš„ä¸ªäººä¿¡æ¯',0),(435803,12106,'sv','Min personliga information',0),(435804,12106,'it','Mie Info personali',0),(435805,12106,'tl','',0),(435806,12106,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¹ˆà¸§à¸™à¸šà¸¸à¸„à¸„à¸¥à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(435807,12106,'hi','à¤®à¥‡à¤°à¤¾ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿à¤—à¤¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(435808,12106,'ms','Maklumat peribadi saya',0),(435809,12106,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø´Ø®ØµÙŠØ©',0),(435810,12106,'fr','Mes infos personnelles',0),(435811,12106,'jp','è‡ªåˆ†ã®å€‹äººæƒ…å ±',0),(435812,12106,'pt','Minha informaÃ§Ã£o pessoal',0),(435813,12106,'ru','ÐœÐ¾Ñ Ð»Ð¸Ñ‡Ð½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(435814,12106,'es','Mi informaciÃ³n Personal',0),(435815,12106,'de','Meine persÃ¶nliche Info',0),(435816,12106,'en','My Personal Info',0),(435817,12107,'is','',0),(435818,12107,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ÛŒÚ© Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¬Ø¯ÛŒØ¯ Ø§ÛŒØ¬Ø§Ø¯Ú©Ù†ÛŒØ¯ØŸ',0),(435819,12107,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ÛŒÚ© Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø¬Ø¯ÛŒØ¯ Ø§ÛŒØ¬Ø§Ø¯Ú©Ù†ÛŒØ¯ØŸ',0),(435820,12107,'tr','Sana yeni bir teklif oluÅŸturmak istiyor musunuz?',0),(435821,12107,'pl','Czy na pewno chcesz utworzyÄ‡ nowÄ… ofertÄ™?',0),(435822,12107,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°?',0),(435823,12107,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§ÛŒÚ© Ù†ÛŒØ§ Ø§Ù‚ØªØ¨Ø§Ø³ Ø¨Ù†Ø§Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(435824,12107,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ?',0),(435825,12107,'vi','Táº¡o trÃ­ch dáº«n má»›i ?',0),(435826,12107,'af','Is jy seker jy wil \'n nuwe kwotasie skep?',0),(435827,12107,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ creaÅ£i un nou citat?',0),(435828,12107,'et','Kas kindlasti uue pakkumise loomiseks?',0),(435829,12107,'si','Ali ste prepriÄani, da Å¾elite ustvariti novo ponudbo?',0),(435830,12107,'ba','Apakah Anda yakin Anda ingin membuat baru kutipan?',0),(435831,12107,'nl','Weet u zeker dat u wilt maken van een nieuwe offerte?',0),(435832,12107,'fi','Oletko varma, ettÃ¤ haluat luoda uuden tarjouksen?',0),(435833,12107,'no','Er du sikker pÃ¥ at du vil opprette en ny forespÃ¸rsel?',0),(435834,12107,'da','Er du sikker pÃ¥, du vil oprette et nyt tilbud?',0),(435835,12107,'ko','ë‹¹ì‹ ì€ ìƒˆë¡œìš´ ê²¬ì ì„ ìƒì„± í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(435836,12107,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×™×¦×•×¨ ×”×¦×¢×ª ×ž×—×™×¨ ×—×“×©×”?',0),(435837,12107,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î¼Î¹Î± Î½Î­Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬;',0),(435838,12107,'zh','ä½ ç¡®å®šä½ æƒ³è¦åˆ›å»ºä¸€ä¸ªæ–°çš„æŠ¥ä»·ï¼Ÿ',0),(435839,12107,'sv','Ã„r du sÃ¤ker pÃ¥ att du vill skapa en ny offert?',0),(435840,12107,'it','Sei sicuro di che voler creare un nuovo preventivo?',0),(435841,12107,'tl','',0),(435842,12107,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹ƒà¸«à¸¡à¹ˆà¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(435843,12107,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤à¤• à¤¨à¤ˆ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(435844,12107,'ms','Adakah anda pasti anda mahu mencipta Quote baru?',0),(435845,12107,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¥Ù†Ø´Ø§Ø¡ Ø¹Ø±Ø¶ Ø£Ø³Ø¹Ø§Ø± Ø¬Ø¯ÙŠØ¯ØŸ',0),(435846,12107,'fr','ÃŠtes-vous certain de que vouloir crÃ©er un nouveau devis ?',0),(435847,12107,'jp','æ–°ã—ã„è¦‹ç©ã‚‚ã‚Šã‚’ä½œæˆã™ã‚‹ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(435848,12107,'pt','Tens a certeza de que vocÃª deseja criar uma nova citaÃ§Ã£o?',0),(435849,12107,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ ÐºÐ²Ð¾Ñ‚Ñƒ?',0),(435850,12107,'es','Â¿Esta seguro que quiere crear una nueva cotizaciÃ³n',0),(435851,12107,'de','Sind Sie sicher, dass Sie ein neues Angebot erstellen mÃ¶chten?',0),(435852,12107,'en','Are you sure you want to create a new Quote?',0),(435853,12108,'is','',0),(435854,12108,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø³ØªÙ‡ Ù‡Ø§ÛŒ',0),(435855,12108,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø³ØªÙ‡ Ù‡Ø§ÛŒ',0),(435856,12108,'tr','Paket sayÄ±sÄ±',0),(435857,12108,'pl','Liczba pakietÃ³w',0),(435858,12108,'bg','Ð‘Ñ€Ð¾Ð¹ Ð¾Ð¿Ð°ÐºÐ¾Ð²ÐºÐ¸',0),(435859,12108,'ur','Ù¾ÛŒÚ©ÛŒØ¬ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(435860,12108,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ð°ÐºÐµÑ‚Ð°',0),(435861,12108,'vi','Sá»‘ gÃ³i',0),(435862,12108,'af','Aantal pakkette',0),(435863,12108,'ro','NumÄƒrul de pachete',0),(435864,12108,'et','Pakendite arv',0),(435865,12108,'si','Å tevilo paketov',0),(435866,12108,'ba','Jumlah paket',0),(435867,12108,'nl','Aantal pakketten',0),(435868,12108,'fi','Pakkausten lukumÃ¤Ã¤rÃ¤',0),(435869,12108,'no','Antall pakker',0),(435870,12108,'da','Antallet af pakker',0),(435871,12108,'ko','íŒ¨í‚¤ì§€ ìˆ˜',0),(435872,12108,'he','×ž×¡×¤×¨ ×—×‘×™×œ×•×ª',0),(435873,12108,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÏƒÏ…ÏƒÎºÎµÏ…Î±ÏƒÎ¹ÏŽÎ½',0),(435874,12108,'zh','åŒ…è£…ä»¶æ•°',0),(435875,12108,'sv','Antal paket',0),(435876,12108,'it','Numero di pacchetti',0),(435877,12108,'tl','',0),(435878,12108,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸‚à¸­à¸‡à¹à¸žà¸„à¹€à¸à¸ˆ',0),(435879,12108,'hi','à¤¸à¤‚à¤•à¥à¤² à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(435880,12108,'ms','Beberapa pakej',0),(435881,12108,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø·Ø±ÙˆØ¯',0),(435882,12108,'fr','Nombre de paquets',0),(435883,12108,'jp','ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸ã®æ•°',0),(435884,12108,'pt','NÃºmero de pacotes',0),(435885,12108,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑƒÐ¿Ð°ÐºÐ¾Ð²Ð¾Ðº',0),(435886,12108,'es','NÃºmero de paquetes',0),(435887,12108,'de','Anzahl der Pakete',0),(435888,12108,'en','Number of Packages',0),(435889,12109,'is','',0),(435890,12109,'dr','ÛŒÙˆ Ù¾ÛŒ Ø§Ø³ 2 Ø±ÙˆØ² Ø¢Ø¨ÛŒ',0),(435891,12109,'pr','ÛŒÙˆ Ù¾ÛŒ Ø§Ø³ 2 Ø±ÙˆØ² Ø¢Ø¨ÛŒ',0),(435892,12109,'tr','UPS 2 gÃ¼n mavi',0),(435893,12109,'pl','UPS 2 dzieÅ„ niebieski',0),(435894,12109,'bg','ÐŸÐ ÐžÐ—ÐžÐ Ð¦Ð˜, 2-Ñ€Ð¸ Ð´ÐµÐ½ ÑÐ¸Ð½ÑŒÐ¾',0),(435895,12109,'ur','UPS 2 Ø¯Ù† Ù†ÛŒÙ„Ø§',0),(435896,12109,'sr','ÐÐ¿Ñ 2 Ð´Ð°Ð½Ð° Ð¿Ð»Ð°Ð²Ð¾',0),(435897,12109,'vi','UP 2 ngÃ y Blue',0),(435898,12109,'af','Onderbrekinglose KRAGTOEVOER 2de dag blou',0),(435899,12109,'ro','UPS 2a zi albastru',0),(435900,12109,'et','2. pÃ¤ev sinine UPS',0),(435901,12109,'si','UPS, 2. dan modra',0),(435902,12109,'ba','UPS 2 hari biru',0),(435903,12109,'nl','UPS 2nd Day Blue',0),(435904,12109,'fi','UPS toinen pÃ¤ivÃ¤ Blue',0),(435905,12109,'no','UPS 2 dag blÃ¥',0),(435906,12109,'da','UPS 2nd dagen blÃ¥',0),(435907,12109,'ko','UPSëŠ” 2 ì¼ ë¸”ë£¨',0),(435908,12109,'he','×¢×œ×™×•×ª ×›×—×•×œ ×™×•× 2',0),(435909,12109,'el','UPS 2Î· Î·Î¼Î­ÏÎ± Î¼Ï€Î»Îµ',0),(435910,12109,'zh','UPS ç¬¬äºŒå¤©è“',0),(435911,12109,'sv','UPS-2: a dagen blÃ¥',0),(435912,12109,'it','2 Â° giorno blu dell\'UPS',0),(435913,12109,'tl','',0),(435914,12109,'th','UPS 2 à¸§à¸±à¸™à¸ªà¸µà¸™à¹‰à¸³à¹€à¸‡à¸´à¸™',0),(435915,12109,'hi','à¤‰à¤¤à¤¾à¤° à¤•à¥‡ 2 à¤¦à¤¿à¤¨ à¤¨à¥€à¤²à¥‡ à¤°à¤‚à¤—',0),(435916,12109,'ms','UPS 2 hari biru',0),(435917,12109,'ar','Ø´ÙƒØ§ 2nd Ø§Ù„ÙŠÙˆÙ… Ø§Ù„Ø£Ø²Ø±Ù‚',0),(435918,12109,'fr','UPS 2nd Day bleu',0),(435919,12109,'jp','ç¬¬ 2 å›žæ—¥é’ã® UPS',0),(435920,12109,'pt','UPS 2Âº dia azul',0),(435921,12109,'ru','UPS 2-Ð¹ Ð´ÐµÐ½ÑŒ Ð³Ð¾Ð»ÑƒÐ±Ð¾Ð¹',0),(435922,12109,'es','UPS 2nd dÃ­a azul',0),(435923,12109,'de','USV-2. Tag-blau',0),(435924,12109,'en','UPS 2nd Day Blue',0),(435925,12110,'is','',0),(435926,12110,'dr','ÛŒÙˆ Ù¾ÛŒ Ø§Ø³ 3 Ø±ÙˆØ² Ù†Ø§Ø±Ù†Ø¬ÛŒ',0),(435927,12110,'pr','ÛŒÙˆ Ù¾ÛŒ Ø§Ø³ 3 Ø±ÙˆØ² Ù†Ø§Ø±Ù†Ø¬ÛŒ',0),(435928,12110,'tr','UPS 3 gÃ¼n turuncu',0),(435929,12110,'pl','UPS 3 dzieÅ„ Orange',0),(435930,12110,'bg','ÐŸÐ ÐžÐ—ÐžÐ Ð¦Ð˜ 3-Ñ‚Ð¸ Ð´ÐµÐ½ Ð¾Ñ€Ð°Ð½Ð¶ÐµÐ²Ð¾',0),(435931,12110,'ur','UPS 3 Ø¯Ù† Ø§ÙˆØ±Ù†Ø¬',0),(435932,12110,'sr','ÐÐ¿Ñ 3 Ð´Ð°Ð½Ð° ÐžÑ€Ð°Ð½Ð³Ðµ',0),(435933,12110,'vi','UP 3 ngÃ y cam',0),(435934,12110,'af','Onderbrekinglose KRAGTOEVOER 3de dag oranje',0),(435935,12110,'ro','Up treia zi Orange',0),(435936,12110,'et','3. pÃ¤ev Orange UPS',0),(435937,12110,'si','UPS 3. dan Orange',0),(435938,12110,'ba','UPS 3 hari Orange',0),(435939,12110,'nl','UPS 3e dag oranje',0),(435940,12110,'fi','UPS kolmas pÃ¤ivÃ¤ oranssi',0),(435941,12110,'no','UPS tredje dag oransje',0),(435942,12110,'da','UPS 3rd dagen Orange',0),(435943,12110,'ko','UPSëŠ” 3 ì¼ ì˜¤ë Œì§€',0),(435944,12110,'he','×¢×œ×™×•×ª ×”×©×œ×™×©×™×ª ×™×•× ×›×ª×•×',0),(435945,12110,'el','UPS 3Î· Î·Î¼Î­ÏÎ± Ï€Î¿ÏÏ„Î¿ÎºÎ±Î»Î¯',0),(435946,12110,'zh','UPS ç¬¬ä¸‰å¤©æ©™è‰²',0),(435947,12110,'sv','UPS-3: e dag Orange',0),(435948,12110,'it','3 Â° giorno arancione dell\'UPS',0),(435949,12110,'tl','',0),(435950,12110,'th','UPS 3 à¸§à¸±à¸™à¸ªà¹‰à¸¡',0),(435951,12110,'hi','à¤‰à¤¤à¤¾à¤° à¤•à¥‡ 3 à¤¦à¤¿à¤¨ à¤‘à¤°à¥‡à¤‚à¤œ',0),(435952,12110,'ms','UPS 3 hari Orange',0),(435953,12110,'ar','Ø´ÙƒØ§ 3rd Ø§Ù„ÙŠÙˆÙ… Ø§Ù„Ø¨Ø±ØªÙ‚Ø§Ù„ÙŠ',0),(435954,12110,'fr','UPS 3Ã¨me jour Orange',0),(435955,12110,'jp','UPS ã® 3 æ—¥é–“ã‚ªãƒ¬ãƒ³ã‚¸',0),(435956,12110,'pt','3Âº dia laranja-UPS',0),(435957,12110,'ru','Ð˜Ð‘ÐŸ 3-Ð¹ Ð´ÐµÐ½ÑŒ Ð¾Ñ€Ð°Ð½Ð¶ÐµÐ²Ñ‹Ð¹',0),(435958,12110,'es','UPS 3er dÃ­a naranja',0),(435959,12110,'de','USV-3. Tag-Orange',0),(435960,12110,'en','UPS 3rd Day Orange',0),(435961,12111,'is','',0),(435962,12111,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‚Ø±Ù…Ø² Ø±ÙˆØ² Ø¨Ø¹Ø¯ÛŒ',0),(435963,12111,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‚Ø±Ù…Ø² Ø±ÙˆØ² Ø¨Ø¹Ø¯ÛŒ',0),(435964,12111,'tr','Ertesi gÃ¼n kÄ±rmÄ±zÄ± kullanÄ±n',0),(435965,12111,'pl','UÅ¼yj nastÄ™pnego dnia czerwony',0),(435966,12111,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ Ð´ÐµÐ½ Ñ‡ÐµÑ€Ð²ÐµÐ½Ð¾',0),(435967,12111,'ur','Ø§Ú¯Ù„Û’ Ø¯Ù† Ø³Ø±Ø® Ø±Ù†Ú¯ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(435968,12111,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÐ»ÐµÐ´ÐµÑ›Ð¸ Ð´Ð°Ð½ Ñ†Ñ€Ð²ÐµÐ½Ð¾',0),(435969,12111,'vi','Sá»­ dá»¥ng tiáº¿p theo ngÃ y Ä‘á»',0),(435970,12111,'af','Volgende dag rooi gebruik',0),(435971,12111,'ro','UtilizaÅ£i urmÄƒtoarea zi Red',0),(435972,12111,'et','Kasutage jÃ¤rgmisel pÃ¤eval punane',0),(435973,12111,'si','Uporabite naslednji dan rdeÄa',0),(435974,12111,'ba','Gunakan merah hari berikutnya',0),(435975,12111,'nl','Gebruik volgende dag Red',0),(435976,12111,'fi','KÃ¤yttÃ¤Ã¤ seuraavan pÃ¤ivÃ¤n punaista',0),(435977,12111,'no','Bruke neste dag rÃ¸dt',0),(435978,12111,'da','Bruge nÃ¦ste dag rÃ¸d',0),(435979,12111,'ko','ë‹¤ìŒ ë‚  ë ˆë“œë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(435980,12111,'he','×”×©×ª×ž×© ×”××“×•× ×‘×™×•× ×”×‘×',0),(435981,12111,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î·Î½ ÎµÏ€ÏŒÎ¼ÎµÎ½Î· Î·Î¼Î­ÏÎ± ÎºÏŒÎºÎºÎ¹Î½Î¿',0),(435982,12111,'zh','ä½¿ç”¨ä¸‹ä¸€å¤©çº¢',0),(435983,12111,'sv','AnvÃ¤nda nÃ¤sta dag Red',0),(435984,12111,'it','Utilizzare il prossimo giorno rosso',0),(435985,12111,'tl','',0),(435986,12111,'th','à¹ƒà¸Šà¹‰à¸ªà¸µà¹à¸”à¸‡à¸‚à¸­à¸‡à¸§à¸±à¸™à¸–à¸±à¸”à¹„à¸›',0),(435987,12111,'hi','à¤…à¤—à¤²à¥‡ à¤¦à¤¿à¤¨ à¤²à¤¾à¤² à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(435988,12111,'ms','Gunakan tempoh hari merah',0),(435989,12111,'ar','Ø§Ø³ØªØ®Ø¯Ù… Ø§Ù„ØªØ§Ù„ÙŠ ÙŠÙˆÙ… Ø§Ù„Ø£Ø­Ù…Ø±',0),(435990,12111,'fr','Utilisez le prochain jour rouge',0),(435991,12111,'jp','æ¬¡ã®æ—¥èµ¤ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(435992,12111,'pt','Use o seguinte dia vermelho',0),(435993,12111,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð´ÐµÐ½ÑŒ ÐºÑ€Ð°ÑÐ½Ñ‹Ð¹',0),(435994,12111,'es','Utilice el siguiente dÃ­a rojo',0),(435995,12111,'de','Verwenden Sie nÃ¤chsten Tag rot',0),(435996,12111,'en','Use Next Day Red',0),(435997,12112,'is','',0),(435998,12112,'dr',': Ø¬Ù‡Øª 1 ',0),(435999,12112,'pr','Ø¬ÙˆÙ‡Ø± : Ø¬Ù‡Øª 1 ',0),(436000,12112,'tr','MÃ¼rekkep yÃ¼zÃ¼ 1',0),(436001,12112,'pl','Atrament Strona 1',0),(436002,12112,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð° 1',0),(436003,12112,'ur','Ø§Ù†Ú© Ø·Ø±Ù 1',0),(436004,12112,'sr','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð° 1',0),(436005,12112,'vi','Má»±c khay 1',0),(436006,12112,'af','Ink kant 1',0),(436007,12112,'ro','CernealÄƒ partea 1',0),(436008,12112,'et','Tindi pool 1',0),(436009,12112,'si','ÄŒrnilo stran 1',0),(436010,12112,'ba','Tinta sisi 1',0),(436011,12112,'nl','Inkt kant 1',0),(436012,12112,'fi','Muste Side 1',0),(436013,12112,'no','Blekk Side 1',0),(436014,12112,'da','BlÃ¦k Side 1',0),(436015,12112,'ko','ìž‰í¬ ì¸¡ë©´ 1',0),(436016,12112,'he','×“×™×• ×¦×“ 1',0),(436017,12112,'el','ÎœÎµÎ»Î¬Î½Î¹ Ï€Î»ÎµÏ…ÏÎ¬ 1',0),(436018,12112,'zh','æ²¹å¢¨ä¾§é¢1',0),(436019,12112,'sv','BlÃ¤ck sida 1',0),(436020,12112,'it','Inchiostro lato 1',0),(436021,12112,'tl','',0),(436022,12112,'th','à¸«à¸¡à¸¶à¸à¸”à¹‰à¸²à¸™ 1',0),(436023,12112,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¥€ à¤“à¤° 1',0),(436024,12112,'ms','Dakwat Bahagian 1',0),(436025,12112,'ar','Ø­Ø¨Ø± Ø§Ù„Ø¬Ø§Ù†Ø¨ 1',0),(436026,12112,'fr','CÃ´tÃ© encre 1',0),(436027,12112,'jp','ã‚¤ãƒ³ã‚¯ ã‚µã‚¤ãƒ‰ 1',0),(436028,12112,'pt','Lado de tinta 1',0),(436029,12112,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð° ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð° 1',0),(436030,12112,'es','Tinta Lado 1',0),(436031,12112,'de','Tinte-Seite 1',0),(436032,12112,'en','Ink Side 1',0),(436033,12113,'is','',0),(436034,12113,'dr',': Ø¬Ù‡Øª 2 ',0),(436035,12113,'pr','Ø¬ÙˆÙ‡Ø± : Ø¬Ù‡Øª 2 ',0),(436036,12113,'tr','MÃ¼rekkep yÃ¼z 2',0),(436037,12113,'pl','Atrament Strona 2',0),(436038,12113,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð° 2',0),(436039,12113,'ur','Ø§Ù†Ú© Ø·Ø±Ù 2',0),(436040,12113,'sr','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð° 2',0),(436041,12113,'vi','má»±c khay 2',0),(436042,12113,'af','Ink kant 2',0),(436043,12113,'ro','CernealÄƒ partea 2',0),(436044,12113,'et','Tindi-ja tagakÃ¼lje',0),(436045,12113,'si','ÄŒrnilo stran 2',0),(436046,12113,'ba','Tinta sisi 2',0),(436047,12113,'nl','Inkt kant 2',0),(436048,12113,'fi','Muste, 2-puoli',0),(436049,12113,'no','Blekk Side 2',0),(436050,12113,'da','BlÃ¦k Side 2',0),(436051,12113,'ko','ìž‰í¬ ì¸¡ë©´ 2',0),(436052,12113,'he','×“×™×• ×¦×“ 2',0),(436053,12113,'el','ÎœÎµÎ»Î¬Î½Î¹ Ï€Î»ÎµÏ…ÏÎ¬ 2',0),(436054,12113,'zh','æ²¹å¢¨ä¾§é¢2',0),(436055,12113,'sv','BlÃ¤ck sida 2',0),(436056,12113,'it','Inchiostro lato 2',0),(436057,12113,'tl','',0),(436058,12113,'th','à¸”à¹‰à¸²à¸™à¸«à¸¡à¸¶à¸ 2',0),(436059,12113,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¥€ à¤“à¤° 2',0),(436060,12113,'ms','Dakwat Bahagian 2',0),(436061,12113,'ar','Ø­Ø¨Ø± Ø§Ù„Ø¬Ø§Ù†Ø¨ 2',0),(436062,12113,'fr','Encre face 2',0),(436063,12113,'jp','ã‚¤ãƒ³ã‚¯å´ 2',0),(436064,12113,'pt','Tinta lado 2',0),(436065,12113,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð° ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð° 2',0),(436066,12113,'es','Tinta Lado 2',0),(436067,12113,'de','Tinte-Seite 2',0),(436068,12113,'en','Ink Side 2',0),(436069,12114,'is','',0),(436070,12114,'dr','PMS Num',0),(436071,12114,'pr','PMS Num',0),(436072,12114,'tr','PMS Num',0),(436073,12114,'pl','PMS Num',0),(436074,12114,'bg','PMS Num',0),(436075,12114,'ur','ÙˆØ²Ø±Ø§Ø¦Û’ Ø§Ø¹Ø¸Ù… Ú©Ø§ Num',0),(436076,12114,'sr','ÐŸÐœÐ¡ ÐÑƒÐ¼',0),(436077,12114,'vi','PMS Num',0),(436078,12114,'af','PMS Num',0),(436079,12114,'ro','PMS Num',0),(436080,12114,'et','PMS Num',0),(436081,12114,'si','PMS Num',0),(436082,12114,'ba','PMS Num',0),(436083,12114,'nl','PMS Num',0),(436084,12114,'fi','PMS Num',0),(436085,12114,'no','PMS Num',0),(436086,12114,'da','PMS Num',0),(436087,12114,'ko','PMS Num',0),(436088,12114,'he','×ª×¡×ž×•× ×ª ×§×“× ×•×¡×ª×™×ª Num',0),(436089,12114,'el','PMS Num',0),(436090,12114,'zh','ç»å‰ç»¼åˆç—‡ Num',0),(436091,12114,'sv','PMS Num',0),(436092,12114,'it','PMS Num',0),(436093,12114,'tl','',0),(436094,12114,'th','PMS Num',0),(436095,12114,'hi','à¤ªà¥€à¤à¤®à¤à¤¸ Num',0),(436096,12114,'ms','PMS Num',0),(436097,12114,'ar','Num Ø§Ù„Ø¯ÙˆØ±Ø© Ø§Ù„Ø´Ù‡Ø±ÙŠØ©',0),(436098,12114,'fr','PMS Num',0),(436099,12114,'jp','PMS Num',0),(436100,12114,'pt','PMS Num',0),(436101,12114,'ru','PMS Num',0),(436102,12114,'es','PMS Num',0),(436103,12114,'de','PMS Num',0),(436104,12114,'en','PMS Num',0),(436105,12115,'is','',0),(436106,12115,'dr','Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÛŒØ¯ Ù…Ø¨ØªÙ†ÛŒ Ø¨Ø± Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(436107,12115,'pr','Ú†Ø§Ù¾ Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÛŒØ¯ Ù…Ø¨ØªÙ†ÛŒ Ø¨Ø± Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(436108,12115,'tr','Teklif dayalÄ± yeni sipariÅŸi yazdÄ±rma',0),(436109,12115,'pl','Drukowanie nowego porzÄ…dku w oparciu o ofertÄ™',0),(436110,12115,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(436111,12115,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù¾Ø± Ù…Ø¨Ù†ÛŒ Ù†Ø¦ÛŒ ØªØ±ØªÛŒØ¨ Ø·Ø¨Ø§Ø¹Øª',0),(436112,12115,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº Ð·Ð°ÑÐ½Ð¾Ð²Ð°Ð½ Ð½Ð° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(436113,12115,'vi','In tráº­t tá»± má»›i dá»±a trÃªn bÃ¡o',0),(436114,12115,'af','Druk nuwe orde gebaseer op die aanhaling',0),(436115,12115,'ro','Noua ordine de imprimare bazat pe citat',0),(436116,12115,'et','Printimise viitemÃ¤rgi pÃµhinevad pakkumine',0),(436117,12115,'si','Tiskanje novega reda, ki temelji na ponudbi',0),(436118,12115,'ba','Percetakan Orde Baru Berdasarkan kutipan',0),(436119,12115,'nl','Afdrukken van de nieuwe orde gebaseerd op offerte',0),(436120,12115,'fi','Tulostaminen uusi jÃ¤rjestys perustuu lainaus',0),(436121,12115,'no','Skrive ut ny ordre basert pÃ¥ tilbud',0),(436122,12115,'da','Udskrivning ny rÃ¦kkefÃ¸lge baseret pÃ¥ tilbud',0),(436123,12115,'ko','ê²¬ì ì„ ê¸°ë°˜ìœ¼ë¡œ ìƒˆë¡œìš´ ì§ˆì„œë¥¼ ì¸ì‡„',0),(436124,12115,'he','×”×“×¤×¡×” ×¡×“×¨ ×—×“×© ×”×ž×‘×•×¡×¡ ×¢×œ ×”×¦×¢×ª ×ž×—×™×¨',0),(436125,12115,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î½Î­Î± Ï„Î¬Î¾Î· Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(436126,12115,'zh','å°åˆ·æ–°ç§©åºçš„åŸºç¡€æŠ¥ä»·',0),(436127,12115,'sv','Skriva ut nya ordningen bygger pÃ¥ citat',0),(436128,12115,'it','Nuovo ordine di stampa basato su preventivo',0),(436129,12115,'tl','',0),(436130,12115,'th','à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹ƒà¸«à¸¡à¹ˆà¸•à¸²à¸¡à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(436131,12115,'hi','à¤¨à¤ à¤†à¤¦à¥‡à¤¶ à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥‹à¤Ÿ à¤ªà¤° à¤†à¤§à¤¾à¤°à¤¿à¤¤',0),(436132,12115,'ms','Percetakan perintah baru berdasarkan petikan',0),(436133,12115,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¬Ø¯ÙŠØ¯ Ø§Ø³ØªÙ†Ø§Ø¯Ø§Ù‹ Ø¥Ù„Ù‰ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(436134,12115,'fr','Nouvel ordre d\'impression basÃ© sur devis',0),(436135,12115,'jp','å¼•ç”¨ã«åŸºã¥ãæ–°ã—ã„é †åºã®å°åˆ·',0),(436136,12115,'pt','Nova ordem de impressÃ£o com base em citaÃ§Ã£o',0),(436137,12115,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(436138,12115,'es','Nueva orden de impresiÃ³n basado en citar',0),(436139,12115,'de','Drucken neuen Auftrag auf der Grundlage von Zitat',0),(436140,12115,'en','Printing new Order based on Quote',0),(436141,12116,'is','',0),(436142,12116,'dr','Ø´Ø¯Ù‡ Ø§Ø³Øª ØªØ§ÛŒÛŒØ¯ Ú©Ø±Ø¯ - ØªÙ…Ø§Ø³ Ø¨Ø§ Ø®Ø¯Ù…Ø§Øª Ø¨Ù‡ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø­Ø°Ù',0),(436143,12116,'pr','Ø´Ø¯Ù‡ Ø§Ø³Øª ØªØ§ÛŒÛŒØ¯ Ú©Ø±Ø¯ - ØªÙ…Ø§Ø³ Ø¨Ø§ Ø®Ø¯Ù…Ø§Øª Ø¨Ù‡ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø­Ø°Ù',0),(436144,12116,'tr','oldu doÄŸruladÄ± - silmek iÃ§in mÃ¼ÅŸteri hizmetleri Ã§aÄŸrÄ±',0),(436145,12116,'pl','zostaÅ‚o potwierdzone - zadzwoÅ„ obsÅ‚ugi klienta do usuniÄ™cia',0),(436146,12116,'bg','Ðµ Ð±Ð¸Ð»Ð¾ Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¾ - Ð¿Ð¾ÐºÐ°Ð½Ð° Ð·Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð²Ð°Ð½Ðµ Ð·Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(436147,12116,'ur','Ø±ÛØ§ ÛÛ’ Ø§Ø³ Ø¨Ø§Øª Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ - Ú©Ø³Ù¹Ù…Ø± Ø³Ø±ÙˆØ³ Ø®Ø§Ø±Ø¬ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú©Ø§Ù„ Ú©Ø±ÛŒÚº',0),(436148,12116,'sr','Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð¾ - Ð¿Ð¾Ð·Ð²Ð°Ñ‚Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸ ÑÐµÑ€Ð²Ð¸Ñ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð»Ð¸',0),(436149,12116,'vi','Ä‘Ã£ xÃ¡c nháº­n - gá»i Dá»‹ch vá»¥ khÃ¡ch hÃ ng Ä‘á»ƒ xÃ³a',0),(436150,12116,'af','is bevestig - bel kliÃ«ntediens te skrap',0),(436151,12116,'ro','a fost confirmat - sunaÅ£i Customer Service pentru a ÅŸterge',0),(436152,12116,'et','on kinnitanud - helistage klienditeeninduse kustutamine',0),(436153,12116,'si','je bila potrjena - pokliÄite sluÅ¾bo za brisanje',0),(436154,12116,'ba','telah dikonfirmasi - menghubungi Customer Service untuk menghapus',0),(436155,12116,'nl','is bevestigd - Bel Customer Service verwijderen',0),(436156,12116,'fi','on vahvistettu - soittaa asiakaspalveluun poistaminen',0),(436157,12116,'no','blitt bekreftet - ringe kundeservice slette',0),(436158,12116,'da','har vÃ¦ret bekrÃ¦ftet - ringe til kundeservice for at slette',0),(436159,12116,'ko','ê³„ì† ì‚­ì œ í•˜ë ¤ë©´ ê³ ê° ì„œë¹„ìŠ¤ ì „í™” í™•ì¸-',0),(436160,12116,'he','×›×‘×¨ ××™×©×¨ - ×œ×”×ª×§×©×¨ ×œ×©×™×¨×•×ª ×”×œ×§×•×—×•×ª ×›×“×™ ×œ×ž×—×•×§',0),(436161,12116,'el','Î­Ï‡ÎµÎ¹ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯ - ÎºÎ±Î»ÏŽ ÎµÎ¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ·Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ',0),(436162,12116,'zh','å·²è¯å®ž-è°ƒç”¨å®¢æˆ·æœåŠ¡æ¥åˆ é™¤',0),(436163,12116,'sv','har bekrÃ¤ftat - ringa kundtjÃ¤nst fÃ¶r att ta bort',0),(436164,12116,'it','Ã¨ stato confermato - chiamare il servizio clienti per eliminare',0),(436165,12116,'tl','',0),(436166,12116,'th','à¹„à¸”à¹‰à¸£à¸±à¸šà¸à¸²à¸£à¸¢à¸·à¸™à¸¢à¸±à¸™ - à¹€à¸£à¸µà¸¢à¸à¸à¸²à¸£à¸¥à¸šà¸šà¸£à¸´à¸à¸²à¸£à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(436167,12116,'hi','à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¥€ - à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡à¤µà¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‰à¤²',0),(436168,12116,'ms','telah disahkan - hubungi perkhidmatan pelanggan untuk menghapuskan',0),(436169,12116,'ar','ÙˆÙ‚Ø¯ ØªÙ… ØªØ£ÙƒÙŠØ¯-Ø§Ù„Ø§ØªØµØ§Ù„ \"Ø®Ø¯Ù…Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡\" Ø­Ø°Ù',0),(436170,12116,'fr','a Ã©tÃ© confirmÃ©e - appeler le Service clientÃ¨le de supprimer',0),(436171,12116,'jp','ã•ã‚Œã¦ã„ã‚‹å‰Šé™¤ã™ã‚‹é¡§å®¢ã‚µãƒ¼ãƒ“ã‚¹ã‚’å‘¼ã³å‡ºã™ã“ã¨ã‚’ç¢ºèªã—ãŸ -',0),(436172,12116,'pt','tem sido confirmada - chame a assistÃªncia tÃ©cnica para excluir',0),(436173,12116,'ru','Ð±Ñ‹Ð»Ð¾ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¾ - Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ñƒ Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð´Ð»Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ',0),(436174,12116,'es','ha sido confirmado - llame a servicio al cliente para eliminar',0),(436175,12116,'de','wurde bestÃ¤tigt - rufen Sie Customer Service lÃ¶schen',0),(436176,12116,'en','has been confirmed - call Customer Service to delete',0),(436177,12117,'is','',0),(436178,12117,'dr','Ø¯Ø± ÛŒÚ© ÙØ±Ù…',0),(436179,12117,'pr','Ø¯Ø± ÛŒÚ© ÙØ±Ù…',0),(436180,12117,'tr','Form Num',0),(436181,12117,'pl','Formularz Num',0),(436182,12117,'bg','Num Ñ„Ð¾Ñ€Ð¼Ð°',0),(436183,12117,'ur','ÙØ§Ø±Ù… Num',0),(436184,12117,'sr','ÐÑƒÐ¼ Ð¾Ð±Ñ€Ð°ÑÑ†Ð°',0),(436185,12117,'vi','Dáº¡ng sá»‘',0),(436186,12117,'af','Vorm Num',0),(436187,12117,'ro','Forma Num',0),(436188,12117,'et','Vormi Num',0),(436189,12117,'si','Obliki Num',0),(436190,12117,'ba','Bentuk Num',0),(436191,12117,'nl','Formulier Num',0),(436192,12117,'fi','Lomakkeen Num',0),(436193,12117,'no','Skjemaet Num',0),(436194,12117,'da','Form Num',0),(436195,12117,'ko','ì–‘ì‹ Num',0),(436196,12117,'he','×˜×•×¤×¡ Num',0),(436197,12117,'el','Num Î¼Î¿ÏÏ†Î®',0),(436198,12117,'zh','çª—ä½“æ°‘',0),(436199,12117,'sv','FormulÃ¤ret Num',0),(436200,12117,'it','Modulo Num',0),(436201,12117,'tl','',0),(436202,12117,'th','à¹à¸šà¸šà¸Ÿà¸­à¸£à¹Œà¸¡ Num',0),(436203,12117,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤° Num',0),(436204,12117,'ms','Num borang',0),(436205,12117,'ar','Num Ø§Ù„Ù†Ù…ÙˆØ°Ø¬',0),(436206,12117,'fr','Forme Num',0),(436207,12117,'jp','ãƒ•ã‚©ãƒ¼ãƒ  Num',0),(436208,12117,'pt','Num formulÃ¡rio',0),(436209,12117,'ru','Ð¤Ð¾Ñ€Ð¼Ñ‹ Num',0),(436210,12117,'es','Forma Num',0),(436211,12117,'de','Formular Num',0),(436212,12117,'en','Form Num',0),(436213,12118,'is','',0),(436214,12118,'dr','Ø´Ø±Ø­ Ø³ÙØ§Ø±Ø´ Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ù‡ Ø´Ø±Ø­ Ø²ÛŒØ± Ø§Ø³Øª',0),(436215,12118,'pr','Ø´Ø±Ø­ Ø³ÙØ§Ø±Ø´ Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ù‡ Ø´Ø±Ø­ Ø²ÛŒØ± Ø§Ø³Øª',0),(436216,12118,'tr','SipariÅŸ aÃ§Ä±klamasÄ± aÅŸaÄŸÄ±dadÄ±r',0),(436217,12118,'pl','PoniÅ¼ej znajduje siÄ™ opis zamÃ³wienia',0),(436218,12118,'bg','ÐŸÐ¾-Ð´Ð¾Ð»Ñƒ Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(436219,12118,'ur','Ø¢Ù¾ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ ØªÙØµÛŒÙ„ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ ÛÛ’',0),(436220,12118,'sr','Ð¡Ð»ÐµÐ´Ð¸ Ð¾Ð¿Ð¸Ñ Ð²Ð°ÑˆÐµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(436221,12118,'vi','Sau Ä‘Ã¢y lÃ  má»™t mÃ´ táº£ cá»§a Ä‘áº·t hÃ ng cá»§a báº¡n',0),(436222,12118,'af','Die volgende is \'n beskrywing van jou bestelling',0),(436223,12118,'ro','Aceasta este o descriere a comenzii',0),(436224,12118,'et','JÃ¤rgnev on kirjeldus tellimuse',0),(436225,12118,'si','Spodaj je opis vaÅ¡ega naroÄila',0),(436226,12118,'ba','Berikut adalah deskripsi dari pesanan Anda',0),(436227,12118,'nl','Hieronder volgt een beschrijving van uw bestelling',0),(436228,12118,'fi','Seuraavassa on kuvaus tilauksesi',0),(436229,12118,'no','FÃ¸lgende er en beskrivelse av bestillingen',0),(436230,12118,'da','FÃ¸lgende er en beskrivelse af din ordre',0),(436231,12118,'ko','ë‹¤ìŒì€ ê·€í•˜ì˜ ì£¼ë¬¸ì— ëŒ€ í•œ ì„¤ëª…',0),(436232,12118,'he','×œ×¤× ×™×›× ×ª×™××•×¨ ×©×œ ×”×”×–×ž× ×” ×©×œ×š',0),(436233,12118,'el','Î¤Î¿ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ ÎµÎ¯Î½Î±Î¹ Î¼Î¹Î± Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏƒÎ±Ï‚',0),(436234,12118,'zh','ä¸‹é¢æ˜¯è®¢å•çš„ä¸€ä¸ªæè¿°æ‚¨',0),(436235,12118,'sv','FÃ¶ljande Ã¤r en beskrivning av din bestÃ¤llning',0),(436236,12118,'it','Di seguito Ã¨ una descrizione del tuo ordine',0),(436237,12118,'tl','',0),(436238,12118,'th','à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¹€à¸›à¹‡à¸™à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(436239,12118,'hi','à¤†à¤ªà¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤µà¤°à¥à¤£à¤¨ à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤¹à¥ˆ',0),(436240,12118,'ms','Berikut adalah penerangan tentang pesanan anda',0),(436241,12118,'ar','Ù…Ø§ ÙŠÙ„ÙŠ ÙˆØµÙ Ù„Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(436242,12118,'fr','Ce qui suit est une description de votre commande',0),(436243,12118,'jp','æ¬¡ã«ã€ã‚ãªãŸã®é †åºã®èª¬æ˜Ž',0),(436244,12118,'pt','A seguir estÃ¡ uma descriÃ§Ã£o de sua ordem',0),(436245,12118,'ru','ÐÐ¸Ð¶Ðµ Ð¿Ñ€Ð¸Ð²Ð¾Ð´Ð¸Ñ‚ÑÑ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð²Ð°ÑˆÐµÐ³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(436246,12118,'es','El siguente es una descripciÃ³n de su Pedido',0),(436247,12118,'de','Im folgenden finden Sie eine Beschreibung Ihres Auftrages',0),(436248,12118,'en','The following is a description of your Order',0),(436249,12119,'is','',0),(436250,12119,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ø´ØªØ±ÛŒ B2B',0),(436251,12119,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ø´ØªØ±ÛŒ B2B',0),(436252,12119,'tr','B2B mÃ¼ÅŸteri isteÄŸi',0),(436253,12119,'pl','Å»yczenie klienta B2B',0),(436254,12119,'bg','B2B ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð·Ð°ÑÐ²ÐºÐ°',0),(436255,12119,'ur','B2B Ú¯Ø§ÛÚ© Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(436256,12119,'sr','Ð‘2Ð‘ Ð·Ð°Ñ…Ñ‚ÐµÐ² ÐºÑƒÐ¿Ñ†Ð°',0),(436257,12119,'vi','B2B khÃ¡ch hÃ ng yÃªu cáº§u',0),(436258,12119,'af','B2B kliÃ«nt versoek',0),(436259,12119,'ro','Cerere de clienÅ£i B2B',0),(436260,12119,'et','B2B kliendi nÃµudmisel',0),(436261,12119,'si','B2B naroÄilu',0),(436262,12119,'ba','Permintaan pelanggan B2B',0),(436263,12119,'nl','Verzoek van de klant van de B2B',0),(436264,12119,'fi','B2B asiakkaan pyynnÃ¶stÃ¤',0),(436265,12119,'no','B2B kundeforespÃ¸rsel',0),(436266,12119,'da','B2B kundeforespÃ¸rgsel',0),(436267,12119,'ko','B2B ê³ ê° ìš”ì²­',0),(436268,12119,'he','×‘×§×©×ª ×”×œ×§×•×— B2B',0),(436269,12119,'el','B2B Î±Î¯Ï„Î·Î¼Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(436270,12119,'zh','B2B å®¢æˆ·è¦æ±‚',0),(436271,12119,'sv','B2B kundkrav',0),(436272,12119,'it','Richiesta di cliente B2B',0),(436273,12119,'tl','',0),(436274,12119,'th','à¸„à¸³à¸‚à¸­à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸² B2B',0),(436275,12119,'hi','B2B à¤—à¥à¤°à¤¾à¤¹à¤• à¤…à¤¨à¥à¤°à¥‹à¤§',0),(436276,12119,'ms','Permintaan pelanggan B2B',0),(436277,12119,'ar','Ø·Ù„Ø¨ Ø§Ù„Ø¹Ù…ÙŠÙ„ B2B',0),(436278,12119,'fr','Demande de client B2B',0),(436279,12119,'jp','B2B ã®é¡§å®¢ã®è¦æ±‚',0),(436280,12119,'pt','Pedido de cliente B2B',0),(436281,12119,'ru','B2B Ð·Ð°ÐºÐ°Ð·Ñ‡Ð¸ÐºÐ°',0),(436282,12119,'es','PeticiÃ³n del cliente B2B',0),(436283,12119,'de','Kundenwunsch B2B',0),(436284,12119,'en','B2B Customer Request',0),(436285,12120,'is','',0),(436286,12120,'dr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¯ÛŒØ¯Ù† Ø¬Ø²Ø¦ÛŒØ§Øª Ø¨ÛŒØ´ØªØ± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ù†Ø¸ÙˆØ±',0),(436287,12120,'pr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¯ÛŒØ¯Ù† Ø¬Ø²Ø¦ÛŒØ§Øª Ø¨ÛŒØ´ØªØ± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ù†Ø¸ÙˆØ±',0),(436288,12120,'tr','Bu sipariÅŸ iÃ§in daha fazla ayrÄ±ntÄ± gÃ¶rmek iÃ§in buraya tÄ±klayÄ±n',0),(436289,12120,'pl','Kliknij tutaj, aby wyÅ›wietliÄ‡ wiÄ™cej szczegÃ³Å‚Ã³w dla tego zamÃ³wienia',0),(436290,12120,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(436291,12120,'ur','Ù…Ø²ÛŒØ¯ ØªÙØµÛŒÙ„Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(436292,12120,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð²Ð¸ÑˆÐµ Ð´ÐµÑ‚Ð°Ñ™Ð° Ð·Ð° Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(436293,12120,'vi','Click vÃ o Ä‘Ã¢y Ä‘á»ƒ xem thÃªm chi tiáº¿t cho bá»™ nÃ y',0),(436294,12120,'af','Klik hier om meer besonderhede vir hierdie orde',0),(436295,12120,'ro','Click aici pentru a vedea mai multe detalii pentru aceastÄƒ comandÄƒ',0),(436296,12120,'et','Tellimuse Ã¼ksikasjade vaatamiseks klÃµpsake siin',0),(436297,12120,'si','Kliknite tukaj, Äe si Å¾elite ogledati veÄ podrobnosti za ta nalog',0),(436298,12120,'ba','Klik di sini untuk melihat rincian lebih lanjut untuk pesanan ini',0),(436299,12120,'nl','Klik hier voor meer Details voor deze Order',0),(436300,12120,'fi','Klikkaa tÃ¤stÃ¤ nÃ¤hdÃ¤ksesi lisÃ¤tietoja tÃ¤mÃ¤n tilauksen',0),(436301,12120,'no','Klikk her for Ã¥ vise flere detaljer for denne bestillingen',0),(436302,12120,'da','Klik her for at se flere detaljer om denne kendelse',0),(436303,12120,'ko','ì´ ìˆœì„œì— ëŒ€ í•œ ìžì„¸í•œ ë‚´ìš©ì„ ë³´ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(436304,12120,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×¦×™×’ ×¤×¨×˜×™× × ×•×¡×¤×™× ×¢×‘×•×¨ ×”×–×ž× ×” ×–×•',0),(436305,12120,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬',0),(436306,12120,'zh','å•å‡»æ­¤å¤„ä»¥æŸ¥çœ‹æ›´å¤šè¯¦ç»†ä¿¡æ¯ï¼Œæ­¤è®¢å•',0),(436307,12120,'sv','Klicka hÃ¤r fÃ¶r att se fler Detaljer fÃ¶r den hÃ¤r ordern',0),(436308,12120,'it','Clicca qui per visualizzare maggiori dettagli per questo ordine',0),(436309,12120,'tl','',0),(436310,12120,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸™à¸µà¹‰',0),(436311,12120,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤”à¤° à¤…à¤§à¤¿à¤• à¤µà¤¿à¤µà¤°à¤£ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(436312,12120,'ms','Klik di sini untuk melihat maklumat lanjut untuk pesanan ini',0),(436313,12120,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø²ÙŠØ¯ Ù…Ù† Ø§Ù„ØªÙØ§ØµÙŠÙ„ Ø¹Ù† Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(436314,12120,'fr','Cliquez ici pour voir plus de dÃ©tails pour cette commande',0),(436315,12120,'jp','ã“ã®æ³¨æ–‡ã®è©³ç´°ã‚’è¡¨ç¤ºã™ã‚‹ã«ã¯ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(436316,12120,'pt','Clique aqui para ver mais detalhes para esta ordem',0),(436317,12120,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð±Ð¾Ð»ÐµÐµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ñ‹Ðµ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ñ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(436318,12120,'es','Haga clic aquÃ­ para ver mÃ¡s detalles de esta orden',0),(436319,12120,'de','Klicken Sie hier, um weitere Details fÃ¼r diese Bestellung anzeigen',0),(436320,12120,'en','Click here to view more Details for this Order',0),(436321,12121,'is','',0),(436322,12121,'dr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¯ÛŒØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ± Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ù†Ø¸ÙˆØ±',0),(436323,12121,'pr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¯ÛŒØ¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ± Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ù†Ø¸ÙˆØ±',0),(436324,12121,'tr','Bu sipariÅŸ iÃ§in sevkiyat bilgi iÃ§in tÄ±klayÄ±nÄ±z',0),(436325,12121,'pl','Kliknij tutaj, aby wyÅ›wietliÄ‡ wiÄ™cej informacji Å¼eglugi dla tego zamÃ³wienia',0),(436326,12121,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(436327,12121,'ur','Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ Ø´Ù¾Ù†Ú¯ Ù…Ø²ÛŒØ¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(436328,12121,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð´ÐµÑ‚Ð°Ñ™Ð½Ð¸Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð·Ð° Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(436329,12121,'vi','Click vÃ o Ä‘Ã¢y Ä‘á»ƒ xem thÃªm thÃ´ng tin váº­n chuyá»ƒn cho Ä‘Æ¡n Ä‘áº·t hÃ ng nÃ y',0),(436330,12121,'af','Klik hier om meer gestuur Info vir hierdie orde',0),(436331,12121,'ro','FaceÅ£i clic aici pentru mai multe informaÅ£ii de transport maritim pentru aceastÄƒ comandÄƒ',0),(436332,12121,'et','Selle tellimuse saatmise Lisainfo vaatamiseks klÃµpsake siin',0),(436333,12121,'si','Kliknite tukaj za ogled veÄ ladijskega informacij za ta nalog',0),(436334,12121,'ba','Klik disini untuk melihat Info pengiriman untuk pesanan ini',0),(436335,12121,'nl','Klik hier voor meer Info verzendkosten voor deze Order',0),(436336,12121,'fi','Klikkaa tÃ¤stÃ¤ nÃ¤hdÃ¤ksesi tÃ¤mÃ¤n tilauksen toimitus lisÃ¤tietoja',0),(436337,12121,'no','Klikk her for Ã¥ vise mer Shipping informasjon for denne bestillingen',0),(436338,12121,'da','Klik her for at se flere Shipping Info for denne ordre',0),(436339,12121,'ko','ì´ ìˆœì„œì— ëŒ€ í•œ ìžì„¸í•œ ë°°ì†¡ ì •ë³´ë¥¼ ë³´ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(436340,12121,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×¦×™×’ ×ž×™×“×¢ × ×•×¡×£ ×ž×©×œ×•×— ×¢×‘×•×¨ ×”×–×ž× ×” ×–×•',0),(436341,12121,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î½Î±Ï…Ï„Î¹Î»Î¯Î±Ï‚ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬',0),(436342,12121,'zh','å•å‡»æ­¤å¤„ä»¥æŸ¥çœ‹æ›´å¤šçš„èˆªè¿ä¿¡æ¯æ­¤è®¢å•',0),(436343,12121,'sv','Klicka hÃ¤r fÃ¶r att visa mer frakt information fÃ¶r den hÃ¤r ordern',0),(436344,12121,'it','Clicca qui per visualizzare piÃ¹ informazioni di spedizione per questo ordine',0),(436345,12121,'tl','',0),(436346,12121,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸—à¸µà¹ˆà¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸™à¸µà¹‰',0),(436347,12121,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤”à¤° à¤…à¤§à¤¿à¤• à¤¨à¥Œà¤µà¤¹à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(436348,12121,'ms','Klik di sini untuk melihat lebih banyak maklumat penghantaran untuk pesanan ini',0),(436349,12121,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø²ÙŠØ¯ \"Ù…Ù† Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø­Ù†\" Ù„Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(436350,12121,'fr','Cliquez ici pour afficher les dÃ©tails d\'expÃ©dition pour cette commande',0),(436351,12121,'jp','ã“ã®æ³¨æ–‡ã®é…é€ã®è©³ç´°æƒ…å ±ã‚’è¡¨ç¤ºã™ã‚‹ã«ã¯ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(436352,12121,'pt','Clique aqui para ver mais informaÃ§Ã£o de frete para este pedido',0),(436353,12121,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½ÐµÐµ Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑÑ‚Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(436354,12121,'es','Haga clic aquÃ­ para ver mÃ¡s informaciÃ³n de envÃ­o para este pedido',0),(436355,12121,'de','Klicken Sie hier fÃ¼r mehr Versand-Info fÃ¼r diese Bestellung',0),(436356,12121,'en','Click here to view more Shipping Info for this Order',0),(436357,12122,'is','',0),(436358,12122,'dr','ÛŒØ§ Ø§ÛŒÙ…ÛŒÙ„',0),(436359,12122,'pr','ÛŒØ§ Ø§ÛŒÙ…ÛŒÙ„',0),(436360,12122,'tr','veya e-posta',0),(436361,12122,'pl','lub E-mail',0),(436362,12122,'bg','Ð¸Ð»Ð¸ Ð¿Ð¾ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ð¿Ð¾Ñ‰Ð°',0),(436363,12122,'ur','ÛŒØ§ Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(436364,12122,'sr','Ðµ-Ð¼Ð°Ð¸Ð»Ð¾Ð¼',0),(436365,12122,'vi','hoáº·c gá»­i Email',0),(436366,12122,'af','of e-pos',0),(436367,12122,'ro','sau E-mail',0),(436368,12122,'et','vÃµi e-posti',0),(436369,12122,'si','ali Email',0),(436370,12122,'ba','atau Email',0),(436371,12122,'nl','of E-mail',0),(436372,12122,'fi','tai sÃ¤hkÃ¶postitse',0),(436373,12122,'no','eller e-post',0),(436374,12122,'da','eller E-mail',0),(436375,12122,'ko','ë˜ëŠ” ì´ë©”ì¼',0),(436376,12122,'he','××• ×‘×“×•×',0),(436377,12122,'el','Î® Email',0),(436378,12122,'zh','æˆ–å‘é€ç”µå­é‚®ä»¶',0),(436379,12122,'sv','eller e-post',0),(436380,12122,'it','o E-mail',0),(436381,12122,'tl','',0),(436382,12122,'th','à¸«à¸£à¸·à¸­à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(436383,12122,'hi','à¤¯à¤¾ à¤ˆà¤®à¥‡à¤²',0),(436384,12122,'ms','atau e-mel',0),(436385,12122,'ar','Ø£Ùˆ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(436386,12122,'fr','ou par courriel',0),(436387,12122,'jp','ã¾ãŸã¯ãƒ¡ãƒ¼ãƒ«',0),(436388,12122,'pt','ou E-mail',0),(436389,12122,'ru','Ð¸Ð»Ð¸ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(436390,12122,'es','o por correo electrÃ³nico',0),(436391,12122,'de','oder per E-Mail',0),(436392,12122,'en','or Email',0),(436393,12123,'is','',0),(436394,12123,'dr','1 &amp; 2 Sided',0),(436395,12123,'pr','1 &amp; 2 Sided',0),(436396,12123,'tr','1 & 2 taraflÄ±',0),(436397,12123,'pl','1 & 2 dwustronne',0),(436398,12123,'bg','1 & 2 Sided',0),(436399,12123,'ur','1 & 2 Ø³Ø§ÚˆÛŒØ¯',0),(436400,12123,'sr','1 Ð¸ 2 Ð¡Ð¸Ð´ÐµÐ´',0),(436401,12123,'vi','1 &amp; 2 Sided',0),(436402,12123,'af','1 & 2 Sided',0),(436403,12123,'ro','1 & 2 Sided',0),(436404,12123,'et','1 & 2 Sided',0),(436405,12123,'si','1 & 2 Sided',0),(436406,12123,'ba','1 & 2 sisi',0),(436407,12123,'nl','1 & 2 dubbelzijdig',0),(436408,12123,'fi','1 & 2 kaksipuoleisen',0),(436409,12123,'no','1 & 2 Sided',0),(436410,12123,'da','1 & 2 dobbeltsidet',0),(436411,12123,'ko','1 & 2 ë©´',0),(436412,12123,'he','1 & 2 ×“×•-×¦×“×“×™×ª',0),(436413,12123,'el','1 & 2 ÏŒÏˆÎ·Ï‚',0),(436414,12123,'zh','ä¸€è¾¹å’Œä¸¤è¾¹çš„',0),(436415,12123,'sv','1 & 2 dubbelsidig',0),(436416,12123,'it','1 & 2 lati',0),(436417,12123,'tl','',0),(436418,12123,'th','1 & 2 Sided',0),(436419,12123,'hi','1 & 2 à¤ªà¤•à¥à¤·à¥€à¤¯',0),(436420,12123,'ms','1 & 2 Sided',0),(436421,12123,'ar','Ø¹Ù„Ù‰ Ø§Ù„ÙˆØ¬Ù‡ÙŠÙ† 1 Ø¢Ù†Ø¯ 2',0),(436422,12123,'fr','1 & 2 Sided',0),(436423,12123,'jp','1 & 2 ä¸¡é¢',0),(436424,12123,'pt','1 & 2 lados',0),(436425,12123,'ru','1 & 2 ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð½ÑÑ',0),(436426,12123,'es','1 &amp; 2 caras',0),(436427,12123,'de','1 & 2 beidseitiger',0),(436428,12123,'en','1 & 2 Sided',0),(436429,12124,'is','',0),(436430,12124,'dr','1 Sided',0),(436431,12124,'pr','1 Sided',0),(436432,12124,'tr','1 Sided',0),(436433,12124,'pl','1 dwustronne',0),(436434,12124,'bg','1 Sided',0),(436435,12124,'ur','1 Ø³Ø§ÚˆÛŒØ¯',0),(436436,12124,'sr','1 Ð¡Ð¸Ð´ÐµÐ´',0),(436437,12124,'vi','1 Sided',0),(436438,12124,'af','1 Sided',0),(436439,12124,'ro','1 Sided',0),(436440,12124,'et','1 Sided',0),(436441,12124,'si','1 Sided',0),(436442,12124,'ba','1 sisi',0),(436443,12124,'nl','1 dubbelzijdig',0),(436444,12124,'fi','1 kaksipuoleisen',0),(436445,12124,'no','1 dobbeltsidig',0),(436446,12124,'da','1 dobbeltsidet',0),(436447,12124,'ko','1 ë©´',0),(436448,12124,'he','1 ×“×•-×¦×“×“×™×ª',0),(436449,12124,'el','1 ÏŒÏˆÎ·Ï‚',0),(436450,12124,'zh','ä¸€è¾¹çš„',0),(436451,12124,'sv','1 dubbelsidig',0),(436452,12124,'it','1 lato',0),(436453,12124,'tl','',0),(436454,12124,'th','1 Sided',0),(436455,12124,'hi','1 à¤ªà¤•à¥à¤·à¥€à¤¯',0),(436456,12124,'ms','1 Sided',0),(436457,12124,'ar','1 Ø¹Ù„Ù‰ Ø§Ù„ÙˆØ¬Ù‡ÙŠÙ†',0),(436458,12124,'fr','1 verso',0),(436459,12124,'jp','1 ä¸¡é¢',0),(436460,12124,'pt','1 face',0),(436461,12124,'ru','1 ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð½ÑÑ',0),(436462,12124,'es','1 cara',0),(436463,12124,'de','1 beidseitiger',0),(436464,12124,'en','1 Sided',0),(436465,12125,'is','',0),(436466,12125,'dr','2 Sided',0),(436467,12125,'pr','2 Sided',0),(436468,12125,'tr','2 taraflÄ±',0),(436469,12125,'pl','2 dwustronne',0),(436470,12125,'bg','2 Sided',0),(436471,12125,'ur','2 Ø³Ø§ÚˆÛŒØ¯',0),(436472,12125,'sr','2 Ð¡Ð¸Ð´ÐµÐ´',0),(436473,12125,'vi','2 Sided',0),(436474,12125,'af','2 Sided',0),(436475,12125,'ro','2 Sided',0),(436476,12125,'et','2 Sided',0),(436477,12125,'si','2 Sided',0),(436478,12125,'ba','2 sisi',0),(436479,12125,'nl','2 dubbelzijdig',0),(436480,12125,'fi','Kaksipuo',0),(436481,12125,'no','2 Sided',0),(436482,12125,'da','2 dobbeltsidet',0),(436483,12125,'ko','2 ë©´',0),(436484,12125,'he','2 ×“×•-×¦×“×“×™×ª',0),(436485,12125,'el','2 ÏŒÏˆÎ·Ï‚',0),(436486,12125,'zh','ä¸¤è¾¹çš„',0),(436487,12125,'sv','2 dubbelsidig',0),(436488,12125,'it','2 lati',0),(436489,12125,'tl','',0),(436490,12125,'th','2 Sided',0),(436491,12125,'hi','2 à¤ªà¤•à¥à¤·à¥€à¤¯',0),(436492,12125,'ms','2 Sided',0),(436493,12125,'ar','2 Ø¹Ù„Ù‰ Ø§Ù„ÙˆØ¬Ù‡ÙŠÙ†',0),(436494,12125,'fr','2 Sided',0),(436495,12125,'jp','2 ä¸¡é¢',0),(436496,12125,'pt','2 lados',0),(436497,12125,'ru','2 ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð½ÑÑ',0),(436498,12125,'es','2 caras',0),(436499,12125,'de','2 beidseitiger',0),(436500,12125,'en','2 Sided',0),(436501,12126,'is','',0),(436502,12126,'dr','Ø³ÛŒØ§Ù‡ Ø³ÙÛŒØ¯ &amp;',0),(436503,12126,'pr','Ø³ÛŒØ§Ù‡ Ø³ÙÛŒØ¯ &amp;',0),(436504,12126,'tr','Siyah & beyaz',0),(436505,12126,'pl','Czarny & biaÅ‚y',0),(436506,12126,'bg','Ð§ÐµÑ€Ð½Ð¾ & Ð±ÑÐ»Ð¾',0),(436507,12126,'ur','Ø³ÛŒØ§Û Ø³ÙÛŒØ¯ &',0),(436508,12126,'sr','Ð¦Ñ€Ð½Ð¾ Ð¸ Ð±ÐµÐ»Ð¾',0),(436509,12126,'vi','MÃ u Ä‘en &amp; tráº¯ng',0),(436510,12126,'af','Swart en wit',0),(436511,12126,'ro','& Negru',0),(436512,12126,'et','Black & valge',0),(436513,12126,'si','ÄŒrno belo &',0),(436514,12126,'ba','Hitam & putih',0),(436515,12126,'nl','Zwart & wit',0),(436516,12126,'fi','Musta & valkoinen',0),(436517,12126,'no','Svart & hvitt',0),(436518,12126,'da','Sort & hvid',0),(436519,12126,'ko','ê²€ì • & í™”ì´íŠ¸',0),(436520,12126,'he','×©×—×•×¨ ×œ×‘×Ÿ &',0),(436521,12126,'el','& Î›ÎµÏ…ÎºÏŒ Î¼Î±ÏÏÎ¿',0),(436522,12126,'zh','é»‘ &amp; ç™½',0),(436523,12126,'sv','Svart & vit',0),(436524,12126,'it','& Nero',0),(436525,12126,'tl','',0),(436526,12126,'th','à¸ªà¸µà¸”à¸³ & à¸ªà¸µà¸‚à¸²à¸§',0),(436527,12126,'hi','à¤¬à¥à¤²à¥ˆà¤• & à¤µà¥à¤¹à¤¾à¤‡à¤Ÿ',0),(436528,12126,'ms','Hitam & putih',0),(436529,12126,'ar','Ø£Ø³ÙˆØ¯ Ø¢Ù†Ø¯',0),(436530,12126,'fr','Noir & blanc',0),(436531,12126,'jp','ç™½é»’ &',0),(436532,12126,'pt','Preto branco &',0),(436533,12126,'ru','Ð§ÐµÑ€Ð½Ñ‹Ð¹ & Ð±ÐµÐ»Ñ‹Ð¹',0),(436534,12126,'es','&amp; Negro',0),(436535,12126,'de','& Schwarz-weiÃŸ',0),(436536,12126,'en','Black & White',0),(436537,12127,'is','',0),(436538,12127,'dr','Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø²ÛŒØ± Ø¨Ø±Ø§ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾',0),(436539,12127,'pr','Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø²ÛŒØ± Ø¨Ø±Ø§ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾',0),(436540,12127,'tr','BaskÄ± sipariÅŸ kaydetmek iÃ§in tÄ±klayÄ±nÄ±z',0),(436541,12127,'pl','Kliknij poniÅ¼ej, aby uratowaÄ‡ druk zamÃ³wienia',0),(436542,12127,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ, Ð·Ð° Ð´Ð° Ð·Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(436543,12127,'ur','Ø¢Ù¾ Ú©ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†ÛŒÚ†Û’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(436544,12127,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð»Ð¸ Ð½Ð°Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ ÐŸÑ€Ð¸Ð½Ñ‚',0),(436545,12127,'vi','Nháº¥p vÃ o bÃªn dÆ°á»›i Ä‘á»ƒ tiáº¿t kiá»‡m Ä‘áº·t hÃ ng in cá»§a báº¡n',0),(436546,12127,'af','Klik hieronder om te stoor jou druk bestelling',0),(436547,12127,'ro','Click mai jos pentru a salva comanda Print',0),(436548,12127,'et','Tellimuse printimine salvestamiseks Vajuta',0),(436549,12127,'si','Kliknite spodaj, da shranite vaÅ¡e Print naroÄilo',0),(436550,12127,'ba','Klik di bawah untuk menyimpan pesanan cetak',0),(436551,12127,'nl','Klik hieronder om te slaan uw bestelling afdrukken',0),(436552,12127,'fi','Valitse Tallenna tilauksesi tulosta',0),(436553,12127,'no','Klikk nedenfor for Ã¥ lagre bestillingen Print',0),(436554,12127,'da','Klik nedenfor for at gemme bestillingen Print',0),(436555,12127,'ko','ì¸ì‡„ ìˆœì„œë¥¼ ì €ìž¥ í•˜ë ¤ë©´ ì•„ëž˜ë¥¼ í´ë¦­',0),(436556,12127,'he','×œ×—×¥ ×œ×”×œ×Ÿ ×›×“×™ ×œ×”×¦×™×œ ××ª ×¡×“×¨ ×”×”×“×¤×¡×” ×©×œ×š',0),(436557,12127,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î³Î¹Î± Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÎ¹ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÎ±Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(436558,12127,'zh','ç‚¹å‡»ä¸‹é¢çš„ä¿å­˜æ‚¨çš„æ‰“å°è®¢å•',0),(436559,12127,'sv','Klicka nedan fÃ¶r att spara din utskrift bestÃ¤llning',0),(436560,12127,'it','Clicca qui sotto per salvare il tuo ordine di stampa',0),(436561,12127,'tl','',0),(436562,12127,'th','à¸„à¸¥à¸´à¸à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡à¹€à¸žà¸·à¹ˆà¸­à¸šà¸±à¸™à¸—à¸¶à¸à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸žà¸´à¸¡à¸žà¹Œ',0),(436563,12127,'hi','à¤…à¤ªà¤¨à¥‡ à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(436564,12127,'ms','Klik di bawah untuk menyimpan pesanan cetakan anda',0),(436565,12127,'ar','Ø§Ù†Ù‚Ø± Ø£Ø¯Ù†Ø§Ù‡ Ù„Ø­ÙØ¸ \"ØªØ±ØªÙŠØ¨ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©\" Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(436566,12127,'fr','Cliquez ci-dessous pour enregistrer votre commande d\'impression',0),(436567,12127,'jp','å°åˆ·é †åºã‚’ä¿å­˜ã™ã‚‹ã«ã¯ä¸‹ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(436568,12127,'pt','Clique abaixo para salvar a sua ordem de impressÃ£o',0),(436569,12127,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð¸Ð¶Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð²Ð°Ñˆ Ð·Ð°ÐºÐ°Ð· Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(436570,12127,'es','Haga clic a continuaciÃ³n para salvar a su orden de impresiÃ³n',0),(436571,12127,'de','Hier kÃ¶nnen Sie Ihren Druckauftrag speichern',0),(436572,12127,'en','Click below to Save your Print Order',0),(436573,12128,'is','',0),(436574,12128,'dr','Ø±Ù†Ú¯ &amp; b/w',0),(436575,12128,'pr','Ø±Ù†Ú¯ &amp; b/w',0),(436576,12128,'tr','Renk & s/b',0),(436577,12128,'pl','B / & kolor',0),(436578,12128,'bg','Ð¦Ð²ÑÑ‚ & b/w',0),(436579,12128,'ur','Ø±Ù†Ú¯ & B/W',0),(436580,12128,'sr','Ð‘Ð¾Ñ˜Ð° & Ñ‚ÐµÑ€Ð¼Ð¾ÑÑ‚Ð°Ð±Ð¸Ð»Ð°Ð½',0),(436581,12128,'vi','MÃ u &amp; b/w',0),(436582,12128,'af','Kleur & B/W',0),(436583,12128,'ro','Culoare & / n',0),(436584,12128,'et','VÃ¤rvi & m/v',0),(436585,12128,'si','Barva & b/w',0),(436586,12128,'ba','Warna & b/w',0),(436587,12128,'nl','Kleur & b/w',0),(436588,12128,'fi','VÃ¤ri & MV',0),(436589,12128,'no','Farge & svart',0),(436590,12128,'da','Farve & sort/hvid',0),(436591,12128,'ko','ìƒ‰ìƒ & b/w',0),(436592,12128,'he','×¦×‘×¢ ×©×—×•×¨ ×œ×‘×Ÿ &',0),(436593,12128,'el','Î§ÏÏŽÎ¼Î± & Î±/Î¼',0),(436594,12128,'zh','é¢œè‰² &amp; é»‘ç™½',0),(436595,12128,'sv','FÃ¤rg & svartvit',0),(436596,12128,'it','Colore & b/n',0),(436597,12128,'tl','',0),(436598,12128,'th','à¸ªà¸µ & b/w',0),(436599,12128,'hi','à¤°à¤‚à¤— & à¤¬à¥€/à¤¡à¤¬à¥à¤²à¥à¤¯à¥‚',0),(436600,12128,'ms','Warna & B/W',0),(436601,12128,'ar','Ù„ÙˆÙ† Ø¢Ù†Ø¯ Ø£Ø¨ÙŠØ¶/Ø£Ø³ÙˆØ¯',0),(436602,12128,'fr','Couleur et n/b &',0),(436603,12128,'jp','ã‚«ãƒ©ãƒ¼ & B/W',0),(436604,12128,'pt','Cor & preto e branco',0),(436605,12128,'ru','Ð¦Ð²ÐµÑ‚ & Ñ‡/Ð±',0),(436606,12128,'es','Color &amp; blanco y negro',0),(436607,12128,'de','Farbe & s/w',0),(436608,12128,'en','Color & B/W',0),(436609,12129,'is','',0),(436610,12129,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù†Ù‡Ø§ÛŒÛŒ Ù‚Ø·Ø¹Ù‡',0),(436611,12129,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ù†Ù‡Ø§ÛŒÛŒ Ù‚Ø·Ø¹Ù‡',0),(436612,12129,'tr','BitmiÅŸ parÃ§a boyutu',0),(436613,12129,'pl','Rozmiar fragmentu',0),(436614,12129,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð°Ñ€Ñ‡Ðµ',0),(436615,12129,'ur','Ù…Ú©Ù…Ù„ Ø³Ø§Ø¦Ø² Ú©Ø§ Ù¹Ú©Ú‘Ø§',0),(436616,12129,'sr','ÐŸÑ€ÐµÐ´Ð²Ð¸Ñ’ÐµÐ½Ñƒ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ ÐºÐ¾Ð¼Ð°Ð´Ð°',0),(436617,12129,'vi','HoÃ n thÃ nh kÃ­ch thÆ°á»›c cá»§a máº£nh',0),(436618,12129,'af','Voltooide grootte van stuk',0),(436619,12129,'ro','Terminat dimensiunea piesei',0),(436620,12129,'et','LÃµpetanud suurus',0),(436621,12129,'si','KonÄni velikosti kosa',0),(436622,12129,'ba','Selesai ukuran sepotong',0),(436623,12129,'nl','Voltooide grootte van stuk',0),(436624,12129,'fi','Valmis pinta pala',0),(436625,12129,'no','Ferdig stÃ¸rrelse pÃ¥ stykke',0),(436626,12129,'da','FÃ¦rdig stÃ¸rrelse stykke',0),(436627,12129,'ko','ìž‘í’ˆì˜ ì™„ì„±ëœ í¬ê¸°',0),(436628,12129,'he','×”×’×•×“×œ ×”×¡×•×¤×™ ×©×œ ×™×¦×™×¨×”',0),(436629,12129,'el','Î¤ÎµÎ»Î¹ÎºÏŒ Î¼Î­Î³ÎµÎ¸Î¿Ï‚ ÎºÎ¿Î¼Î¼Î±Ï„Î¹Î¿Ï',0),(436630,12129,'zh','æˆå“çš„å°ºå¯¸çš„å—',0),(436631,12129,'sv','FÃ¤rdiga storleken av bit',0),(436632,12129,'it','Dimensioni finite del pezzo',0),(436633,12129,'tl','',0),(436634,12129,'th','à¸‚à¸™à¸²à¸”à¸‚à¸­à¸‡à¸Šà¸´à¹‰à¸™à¸ªà¹ˆà¸§à¸™à¸ªà¸³à¹€à¸£à¹‡à¸ˆà¸£à¸¹à¸›',0),(436635,12129,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤Ÿà¥à¤•à¤¡à¤¼à¤¾ à¤•à¥‡ à¤†à¤•à¤¾à¤°',0),(436636,12129,'ms','Siap saiz kepingan',0),(436637,12129,'ar','Ø§Ù„Ø­Ø¬Ù… Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ Ù„Ù„Ù‚Ø·Ø¹Ø©',0),(436638,12129,'fr','Taille finale de l\'ouvrage',0),(436639,12129,'jp','ä½œå“ã®ä»•ä¸ŠãŒã‚Šã‚µã‚¤ã‚º',0),(436640,12129,'pt','Tamanho final da peÃ§a',0),(436641,12129,'ru','Ð“Ð¾Ñ‚Ð¾Ð²Ñ‹Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ€ ÐºÑƒÑÐºÐ°',0),(436642,12129,'es','TamaÃ±o acabado de la pieza',0),(436643,12129,'de','Fertige GrÃ¶ÃŸe StÃ¼ck',0),(436644,12129,'en','Finished Size of Piece',0),(436645,12130,'is','',0),(436646,12130,'dr','Ø±Ù†Ú¯ Ú©Ø§Ù…Ù„',0),(436647,12130,'pr','Ø±Ù†Ú¯ Ú©Ø§Ù…Ù„',0),(436648,12130,'tr','Tam renkli',0),(436649,12130,'pl','PeÅ‚ny kolor',0),(436650,12130,'bg','ÐŸÑŠÐ»ÐµÐ½ Ñ†Ð²ÑÑ‚',0),(436651,12130,'ur','Ø³Ø§Ø±Ø§ Ø±Ù†Ú¯',0),(436652,12130,'sr','ÐŸÑƒÐ½Ð° Ð±Ð¾Ñ˜Ð°',0),(436653,12130,'vi','Äáº§y mÃ u sáº¯c',0),(436654,12130,'af','Vol kleur',0),(436655,12130,'ro','Plin de culoare',0),(436656,12130,'et','TÃ¤ielik vÃ¤rvi',0),(436657,12130,'si','Polne barve',0),(436658,12130,'ba','Penuh warna',0),(436659,12130,'nl','Full Color',0),(436660,12130,'fi','VÃ¤rillisenÃ¤',0),(436661,12130,'no','Farger',0),(436662,12130,'da','Fuld farve',0),(436663,12130,'ko','í’€ ì»¬ëŸ¬',0),(436664,12130,'he','×¦×‘×¢ ×ž×œ×',0),(436665,12130,'el','Î Î»Î®ÏÎµÏ‚ Ï‡ÏÏŽÎ¼Î±',0),(436666,12130,'zh','å…¨å½©',0),(436667,12130,'sv','FyrfÃ¤rg',0),(436668,12130,'it','Colore completo',0),(436669,12130,'tl','',0),(436670,12130,'th','à¸ªà¸µà¹€à¸•à¹‡à¸¡',0),(436671,12130,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤°à¤‚à¤—',0),(436672,12130,'ms','Warna penuh',0),(436673,12130,'ar','Ù„ÙˆÙ† ÙƒØ§Ù…Ù„',0),(436674,12130,'fr','Polychrome',0),(436675,12130,'jp','ãƒ•ãƒ«ã‚«ãƒ©ãƒ¼',0),(436676,12130,'pt','Cor cheia',0),(436677,12130,'ru','ÐŸÐ¾Ð»Ð½Ñ‹Ð¹ Ñ†Ð²ÐµÑ‚',0),(436678,12130,'es','A todo Color',0),(436679,12130,'de','Full Color',0),(436680,12130,'en','Full Color',0),(436681,12131,'is','',0),(436682,12131,'dr','Ù…Ø´Ø§ØºÙ„ Ø·Ø±Ø§Ø­ÛŒ Ú¯Ø±Ø§ÙÛŒÚ© (ÛŒØ¹Ù†ÛŒ Ù¾ÙˆØ³ØªØ±) 5 Ø±ÙˆØ² ÛŒØ§ Ø¨ÛŒØ´ØªØ± Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø±Ø§',0),(436683,12131,'pr','Ù…Ø´Ø§ØºÙ„ Ø·Ø±Ø§Ø­ÛŒ Ú¯Ø±Ø§ÙÛŒÚ© (ÛŒØ¹Ù†ÛŒ Ù¾ÙˆØ³ØªØ±) 5 Ø±ÙˆØ² ÛŒØ§ Ø¨ÛŒØ´ØªØ± Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø±Ø§',0),(436684,12131,'tr','Grafik tasarÄ±m iÅŸleri (yani posterler) 5 gÃ¼n veya daha uzun sÃ¼rebilir',0),(436685,12131,'pl','Praca projekt graficzny (czyli plakaty) moÅ¼e trwaÄ‡ 5 dni lub dÅ‚uÅ¼ej',0),(436686,12131,'bg','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÐ½ Ð´Ð¸Ð·Ð°Ð¹Ð½ Ñ€Ð°Ð±Ð¾Ñ‚Ð° (Ñ‚.Ðµ. Ð¿Ð»Ð°ÐºÐ°Ñ‚Ð¸) Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ñ‚Ð½ÐµÐ¼Ðµ 5 Ð´Ð½Ð¸ Ð¸Ð»Ð¸ Ð¿Ð¾-Ð´ÑŠÐ»Ð³Ð¾',0),(436687,12131,'ur','Ú¯Ø±Ø§ÙÚ© ÚˆÛŒØ²Ø§Ø¦Ù† Ø±ÙˆØ²Ú¯Ø§Ø± (ÛŒØ¹Ù†ÛŒ Ù¾ÙˆØ³Ù¹Ø±) 5 Ø¯Ù† ÛŒØ§ Ø²ÛŒØ§Ø¯Û Ø¹Ø±ØµÛ Ù„Ú¯ Ø³Ú©ØªÛ’',0),(436688,12131,'sr','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐºÐ¸ Ð´Ð¸Ð·Ð°Ñ˜Ð½ Ð¿Ð¾ÑÐ»Ð¾Ð²Ð° (Ð¸Ðµ Ð¿Ð¾ÑÑ‚ÐµÑ€Ðµ) Ð¼Ð¾Ð³Ð°Ð¾ Ð´Ð° Ð´Ð¾Ð±Ð¸Ñ˜Ðµ 5 Ð´Ð°Ð½Ð° Ð¸Ð»Ð¸ Ð²Ð¸ÑˆÐµ',0),(436689,12131,'vi','CÃ¡c cÃ´ng viá»‡c thiáº¿t káº¿ Ä‘á»“ há»a (tá»©c lÃ  Ã¡p phÃ­ch) cÃ³ thá»ƒ máº¥t 5 ngÃ y hoáº·c lÃ¢u hÆ¡n',0),(436690,12131,'af','Grafiese ontwerp poste (dws plakkate) kon 5 dae of langer neem',0),(436691,12131,'ro','Locuri de muncÄƒ design grafic (adicÄƒ postere) ar putea lua 5 zile sau mai',0),(436692,12131,'et','Graafiline disain tÃ¶Ã¶kohta (st plakatid) vÃµiks vÃµtta 5 pÃ¤eva vÃµi kauem',0),(436693,12131,'si','GrafiÄno oblikovanje delovnih mest (tj. plakatov) lahko traja 5 dni ali veÄ',0),(436694,12131,'ba','Pekerjaan desain grafis (yaitu poster) bisa memakan waktu 5 hari atau lebih lama',0),(436695,12131,'nl','Grafische ontwerp banen (dwz posters) kunnen 5 dagen of langer',0),(436696,12131,'fi','Graafinen suunnittelu tyÃ¶paikkoja (eli julisteita) voi kestÃ¤Ã¤ 5 pÃ¤ivÃ¤Ã¤ tai kauemmin',0),(436697,12131,'no','Grafisk design jobber (dvs plakater) kunne ta 5 dager eller lenger',0),(436698,12131,'da','Grafisk design job (dvs plakater) kunne tage 5 dage eller lÃ¦ngere',0),(436699,12131,'ko','ê·¸ëž˜í”½ ë””ìžì¸ ìž‘ì—… (ì˜ˆ: í¬ìŠ¤í„°) ì´ìƒ ì¼ 5 ê±¸ë¦´ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(436700,12131,'he','×¢×‘×•×“×•×ª ×¢×™×¦×•×‘ ×’×¨×¤×™ (×›×œ×•×ž×¨ ×¤×•×¡×˜×¨×™×) ×™×›×•×œ ×œ×§×—×ª 5 ×™×ž×™× ××• ×™×•×ª×¨',0),(436701,12131,'el','Î“ÏÎ±Ï†Î¹ÏƒÏ„Î¹ÎºÎ® Î¸Î­ÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ (Î´Î·Î»Î±Î´Î® Î±Ï†Î¯ÏƒÎµÏ‚) Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î»Î¬Î²ÎµÎ¹ 5 Î·Î¼Î­ÏÎµÏ‚ Î® Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ¿',0),(436702,12131,'zh','å¹³é¢é€ åž‹è®¾è®¡å·¥ä½œ ï¼ˆå³æµ·æŠ¥ï¼‰ å¯èƒ½éœ€è¦ 5 å¤©æˆ–æ›´é•¿',0),(436703,12131,'sv','Grafisk design jobb (dvs affischer) kunde ta 5 dagar eller lÃ¤ngre',0),(436704,12131,'it','Lavori di progettazione grafica (cioÃ¨ manifesti) potrebbero prendere 5 giorni o piÃ¹',0),(436705,12131,'tl','',0),(436706,12131,'th','à¸‡à¸²à¸™à¸­à¸­à¸à¹à¸šà¸šà¸à¸£à¸²à¸Ÿà¸´à¸ (ie à¹‚à¸›à¸ªà¹€à¸•à¸­à¸£à¹Œ) à¸­à¸²à¸ˆà¹ƒà¸Šà¹‰à¹€à¸§à¸¥à¸² 5 à¸§à¸±à¸™ à¸«à¸£à¸·à¸­à¸™à¸²à¸™à¸à¸§à¹ˆà¸²',0),(436707,12131,'hi','à¤—à¥à¤°à¤¾à¤«à¤¿à¤• à¤¡à¤¿à¤œà¤¾à¤‡à¤¨ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¥‹à¤‚ (à¤¯à¤¾à¤¨à¥€ à¤ªà¥‹à¤¸à¥à¤Ÿà¤°) 5 à¤¦à¤¿à¤¨ à¤¯à¤¾ à¤‰à¤¸à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¸à¤®à¤¯ à¤²à¥‡ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(436708,12131,'ms','Kerja-kerja Reka bentuk grafik (iaitu poster) boleh mengambil 5 hari atau lebih',0),(436709,12131,'ar','ØªØµÙ…ÙŠÙ… Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ø¨ÙŠØ§Ù†ÙŠØ© ÙˆØ¸Ø§Ø¦Ù (Ø£ÙŠ Ù…Ù† Ø§Ù„Ù…Ù„ØµÙ‚Ø§Øª) ÙŠÙ…ÙƒÙ† Ø£Ù† ØªØ£Ø®Ø° 5 Ø£ÙŠØ§Ù… Ø£Ùˆ Ø£Ø·ÙˆÙ„',0),(436710,12131,'fr','Emplois de conception graphique (c\'est Ã  dire les affiches) pourraient prendre 5 jours ou plus',0),(436711,12131,'jp','ã‚°ãƒ©ãƒ•ã‚£ãƒƒã‚¯ ãƒ‡ã‚¶ã‚¤ãƒ³ã®ä»•äº‹ (ã™ãªã‚ã¡ãƒã‚¹ã‚¿ãƒ¼) æ—¥ä»¥ä¸Š 5 ã‚’å–ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(436712,12131,'pt','Trabalhos de design grÃ¡fico (ou seja, cartazes) podem levar 5 dias ou mais',0),(436713,12131,'ru','Ð“Ñ€Ð°Ñ„Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð´Ð¸Ð·Ð°Ð¹Ð½ Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ñ… Ð¼ÐµÑÑ‚ (Ñ‚Ð¾ ÐµÑÑ‚ÑŒ Ð¿Ð»Ð°ÐºÐ°Ñ‚Ñ‹) Ð¼Ð¾Ð¶ÐµÑ‚ Ð¿Ñ€Ð¸Ð½Ð¸Ð¼Ð°Ñ‚ÑŒ 5 Ð´Ð½ÐµÐ¹ Ð¸Ð»Ð¸ Ð´Ð¾Ð»ÑŒÑˆÐµ',0),(436714,12131,'es','Trabajos de diseÃ±o grÃ¡fico (es decir carteles) podrÃ­an tomar 5 dÃ­as o mÃ¡s',0),(436715,12131,'de','Grafikdesign Jobs (zB Plakate) dauert 5 Tage oder mehr',0),(436716,12131,'en','Graphic design jobs (ie posters) could take 5 days or longer',0),(436717,12132,'is','',0),(436718,12132,'dr','Ø§Ú¯Ø± Ù…Ø·Ù…Ø¦Ù† Ù†ÛŒØ³ØªÛŒØ¯ Ú©Ù‡ Ú†Ù‡ Ú†ÛŒØ²ÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(436719,12132,'pr','Ø§Ú¯Ø± Ù…Ø·Ù…Ø¦Ù† Ù†ÛŒØ³ØªÛŒØ¯ Ú©Ù‡ Ú†Ù‡ Ú†ÛŒØ²ÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(436720,12132,'tr','Emin deÄŸilseniz ne seÃ§mek',0),(436721,12132,'pl','JeÅ›li nie wiesz co wybraÄ‡',0),(436722,12132,'bg','ÐÐºÐ¾ Ð½Ðµ ÑÑ‚Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ ÐºÐ°ÐºÐ²Ð¾ Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ',0),(436723,12132,'ur','Ø§Ú¯Ø± Ø¨Ø§Øª Ú©Ø§ ÛŒÙ‚ÛŒÙ† Ù†ÛÛŒÚº Ú©ÛŒØ§ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(436724,12132,'sr','ÐÐºÐ¾ Ð½Ð¸ÑÑ‚Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ ÐºÐ°ÐºÐ¾ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ',0),(436725,12132,'vi','Náº¿u báº¡n khÃ´ng cháº¯c cháº¯n nhá»¯ng gÃ¬ Ä‘á»ƒ chá»n',0),(436726,12132,'af','Indien nie seker wat om te kies',0),(436727,12132,'ro','DacÄƒ nu sunteÅ£i sigur ce sÄƒ selectaÅ£i',0),(436728,12132,'et','Kui ei ole kindel, millist valida',0),(436729,12132,'si','ÄŒe niste prepriÄani, kaj Å¾elite izbrati',0),(436730,12132,'ba','Jika tidak yakin apa yang harus pilih',0),(436731,12132,'nl','Als niet zeker wat u moet selecteren',0),(436732,12132,'fi','Jos et ole varma mitÃ¤ Valitse',0),(436733,12132,'no','Hvis ikke sikker pÃ¥ hva du skal velge',0),(436734,12132,'da','Hvis ikke sikker pÃ¥ hvad du skal vÃ¦lge',0),(436735,12132,'ko','í™•ì‹¤ í•˜ì§€ ì•Šì€ ê²½ìš° ì„ íƒ í•´ì•¼í• ì§€',0),(436736,12132,'he','×× ×œ× ×‘×˜×•×— ×ž×” ×œ×‘×—×•×¨',0),(436737,12132,'el','Î‘Î½ Î´ÎµÎ½ ÎµÎ¯ÏƒÏ„Îµ ÏƒÎ¯Î³Î¿Ï…ÏÎ¿Î¹ Ï„Î¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ',0),(436738,12132,'zh','å¦‚æžœä¸ç¡®å®šè¦é€‰æ‹©ä»€ä¹ˆ',0),(436739,12132,'sv','Om inte sÃ¤ker pÃ¥ vad att vÃ¤lja',0),(436740,12132,'it','Se non sai cosa scegliere',0),(436741,12132,'tl','',0),(436742,12132,'th','à¸–à¹‰à¸²à¹„à¸¡à¹ˆà¹à¸™à¹ˆà¹ƒà¸ˆà¸§à¹ˆà¸²à¸ˆà¸°à¹€à¸¥à¸·à¸­à¸à¸­à¸°à¹„à¸£',0),(436743,12132,'hi','à¤…à¤—à¤° à¤¨à¤¹à¥€à¤‚ à¤¯à¤•à¥€à¤¨ à¤¹à¥ˆ à¤•à¤¿ à¤•à¥à¤¯à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(436744,12132,'ms','Jika tidak pasti apa untuk memilih',0),(436745,12132,'ar','Ø¥Ø°Ø§ Ù„Ù… ØªÙƒÙ† Ù…ØªØ£ÙƒØ¯Ø§Ù‹ Ù…Ù† Ù…Ø§ Ù„ØªØ­Ø¯ÙŠØ¯',0),(436746,12132,'fr','Si ne savez pas ce qu\'il faut choisir',0),(436747,12132,'jp','ç¢ºã‹ã§ãªã„ãªã‚‰ä½•ã‚’é¸æŠžã™ã‚‹ã«ã¯',0),(436748,12132,'pt','Se nÃ£o tem certeza o que selecionar',0),(436749,12132,'ru','Ð•ÑÐ»Ð¸ Ð½Ðµ Ð·Ð½Ð°ÐµÑ‚Ðµ Ñ‡Ñ‚Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ',0),(436750,12132,'es','Si no estÃ¡ seguro quÃ© seleccionar',0),(436751,12132,'de','Wenn nicht sicher was auswÃ¤hlen',0),(436752,12132,'en','If not sure what to select',0),(436753,12133,'is','',0),(436754,12133,'dr','Ø§Ú¯Ø± ÙˆØ¶Ø¹ÛŒØª Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÛŒØ¯ ÛŒØ§ Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡ Ø§Ø³ØªØŒ ÛŒÚ© Ù„ÛŒÙ†Ú© Ø¯Ø± ØµÙØ­Ù‡ Ø¨Ø¹Ø¯ÛŒ Ø¸Ø§Ù‡Ø± Ù…ÛŒ Ø´ÙˆØ¯',0),(436755,12133,'pr','Ø§Ú¯Ø± ÙˆØ¶Ø¹ÛŒØª Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÛŒØ¯ ÛŒØ§ Ø§ØµÙ„Ø§Ø­ Ø´Ø¯Ù‡ Ø§Ø³ØªØŒ ÛŒÚ© Ù„ÛŒÙ†Ú© Ø¯Ø± ØµÙØ­Ù‡ Ø¨Ø¹Ø¯ÛŒ Ø¸Ø§Ù‡Ø± Ù…ÛŒ Ø´ÙˆØ¯',0),(436756,12133,'tr','SipariÅŸ durumu, yeni veya gÃ¶zden geÃ§irilmiÅŸ ise, sonraki sayfada bir baÄŸlantÄ± gÃ¶rÃ¼nÃ¼r',0),(436757,12133,'pl','JeÅ›li stan zamÃ³wienia jest nowe lub zmienione, na nastÄ™pnej stronie pojawi siÄ™ link',0),(436758,12133,'bg','ÐÐºÐ¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ðµ Ð½Ð¾Ð²Ð¸ Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÑ€Ð°Ð·Ð³Ð»ÐµÐ´Ð°Ð½Ð¸, Ð²Ñ€ÑŠÐ·ÐºÐ° Ñ‰Ðµ ÑÐµ Ð¿Ð¾ÑÐ²Ð¸ Ð½Ð° ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(436759,12133,'ur','Ù†Ø¦ÛŒ ÛŒØ§ ØªØ¨Ø¯ÛŒÙ„ Ø´Ø¯Û Ø­Ø§Ù„Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨ ÛÛ’ ØªÙˆØŒ Ù„Ù†Ú© Ø§Ú¯Ù„Û’ ØµÙØ­Û’ Ù¾Ø± Ø¸Ø§ÛØ± ÛÙˆ Ú¯Ø§',0),(436760,12133,'sr','ÐÐºÐ¾ Ñ˜Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐ¿Ñ€Ð°Ð²Ñ™ÐµÐ½Ðµ, Ð²ÐµÐ·Ð° Ñ›Ðµ ÑÐµ Ð¿Ð¾Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸ Ð½Ð° ÑÐ»ÐµÐ´ÐµÑ›Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(436761,12133,'vi','Náº¿u tÃ¬nh tráº¡ng Ä‘Æ¡n hÃ ng má»›i hoáº·c sá»­a Ä‘á»•i, má»™t liÃªn káº¿t sáº½ xuáº¥t hiá»‡n trÃªn trang tiáº¿p theo',0),(436762,12133,'af','As die volgorde status is nuwe of hersiene, \'n skakel sal verskyn op die volgende bladsy',0),(436763,12133,'ro','ÃŽn cazul Ã®n care starea comenzii este noi sau revizuite, un link va apÄƒrea pe pagina urmÄƒtoare',0),(436764,12133,'et','Kui tellimuse olek on uue vÃµi parandatud, ilmub link jÃ¤rgmisel lehekÃ¼ljel',0),(436765,12133,'si','ÄŒe je stanje naloga novih ali revidiranih, povezava se prikaÅ¾e na naslednji strani',0),(436766,12133,'ba','Jika Order status baru atau yang direvisi, link akan muncul di halaman berikutnya',0),(436767,12133,'nl','Als de status van de nieuwe of herziene is, verschijnt een link op de volgende pagina',0),(436768,12133,'fi','Jos tilauksen tila on uusi tai muokattu, linkki nÃ¤kyy seuraavalla sivulla',0),(436769,12133,'no','Hvis ordrestatusen er nye eller endrede, vises en kobling pÃ¥ neste side',0),(436770,12133,'da','Hvis ordrestatus er nye eller reviderede, vises der et link pÃ¥ nÃ¦ste side',0),(436771,12133,'ko','ë§í¬ë¥¼ ë‹¤ìŒ íŽ˜ì´ì§€ì— í‘œì‹œ ë©ë‹ˆë‹¤ ì£¼ë¬¸ ìƒíƒœ ìƒˆë¡œìš´ ë˜ëŠ” ìˆ˜ì • ëœ ê²½ìš°',0),(436772,12133,'he','×× ×ž×¦×‘ ×”×”×–×ž× ×” ×”×—×“×©×” ××• ×”×ž×ª×•×§× ×ª, ×”×§×™×©×•×¨ ×™×•×¤×™×¢ ×‘×¢×ž×•×“ ×”×‘×',0),(436773,12133,'el','Î•Î¬Î½ Î· ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï„Î·Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚ ÎµÎ¯Î½Î±Î¹ Î½Î­Î¿ Î® Î±Î½Î±Î¸ÎµÏ‰ÏÎ·Î¼Î­Î½Î¿, Î¼Î¹Î± ÏƒÏÎ½Î´ÎµÏƒÎ· Î¸Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ ÏƒÏ„Î·Î½ ÎµÏ€ÏŒÎ¼ÎµÎ½Î· ÏƒÎµÎ»Î¯Î´Î±',0),(436774,12133,'zh','å¦‚æžœè®¢å•çš„çŠ¶æ€æ˜¯æ–°çš„æˆ–è®¢æ­£ï¼Œé“¾æŽ¥å°†å‡ºçŽ°åœ¨ä¸‹ä¸€ä¸ªé¡µé¢',0),(436775,12133,'sv','Om orderstatus Ã¤r nya eller reviderade, att en lÃ¤nk visas pÃ¥ nÃ¤sta sida',0),(436776,12133,'it','Se lo stato dell\'ordine Ã¨ nuovi o rivisti, un link apparirÃ  sulla pagina successiva',0),(436777,12133,'tl','',0),(436778,12133,'th','à¸–à¹‰à¸²à¸ªà¸–à¸²à¸™à¸°à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹ƒà¸«à¸¡à¹ˆ à¸«à¸£à¸·à¸­à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡ à¸à¸²à¸£à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡à¸ˆà¸°à¸›à¸£à¸²à¸à¸à¸šà¸™à¸«à¸™à¹‰à¸²à¸–à¸±à¸”à¹„à¸›',0),(436779,12133,'hi','à¤¨à¤ à¤¯à¤¾ à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¹à¥ˆ, à¤¤à¥‹ à¤…à¤—à¤²à¥‡ à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤à¤• à¤²à¤¿à¤‚à¤• à¤¦à¤¿à¤–à¤¾à¤ˆ à¤¦à¥‡à¤—à¤¾',0),(436780,12133,'ms','Jika status pesanan baru atau yang disemak, suatu pautan akan muncul pada halaman seterusnya',0),(436781,12133,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù†Øª Ø­Ø§Ù„Ø© Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø£Ùˆ Ø§Ù„Ù…Ù†Ù‚Ø­Ø©ØŒ Ø³ÙˆÙ ØªØ¸Ù‡Ø± ÙˆØµÙ„Ø© Ø¹Ù„Ù‰ Ø§Ù„ØµÙØ­Ø© Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(436782,12133,'fr','Si l\'Ã©tat de la commande est nouvelles ou rÃ©visÃ©es, un lien apparaÃ®t sur la page suivante',0),(436783,12133,'jp','æ³¨æ–‡ã®ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ãŒæ–°è¦ã¾ãŸã¯æ”¹è¨‚ã•ã‚ŒãŸã€ãƒªãƒ³ã‚¯ã€æ¬¡ã®ãƒšãƒ¼ã‚¸ã«è¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(436784,12133,'pt','Se o status do pedido Ã© novo ou revisado, um link aparecerÃ¡ na prÃ³xima pÃ¡gina',0),(436785,12133,'ru','Ð•ÑÐ»Ð¸ ÑÑ‚Ð°Ñ‚ÑƒÑ Ð·Ð°ÐºÐ°Ð·Ð° Ð½Ð¾Ð²Ñ‹Ñ… Ð¸Ð»Ð¸ Ð¿ÐµÑ€ÐµÑÐ¼Ð¾Ñ‚Ñ€ÐµÐ½Ð½Ñ‹Ñ…, Ð½Ð° ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð¿Ð¾ÑÐ²Ð¸Ñ‚ÑÑ ÑÑÑ‹Ð»ÐºÐ°',0),(436786,12133,'es','Si el estado del pedido es nueva o revisada, aparecerÃ¡ un enlace en la pÃ¡gina siguiente',0),(436787,12133,'de','Wenn der Status der Bestellung neuer oder Ã¼berarbeiteter ist, wird ein Link auf der nÃ¤chsten Seite angezeigt.',0),(436788,12133,'en','If the Order status is new or revised, a link will appear on the next page',0),(436789,12134,'is','',0),(436790,12134,'dr','ÛŒÚ© Ø±Ù†Ú¯',0),(436791,12134,'pr','ÛŒÚ© Ø±Ù†Ú¯',0),(436792,12134,'tr','Tek renk',0),(436793,12134,'pl','Jeden kolor',0),(436794,12134,'bg','Ð•Ð´Ð¸Ð½ Ñ†Ð²ÑÑ‚',0),(436795,12134,'ur','Ø§ÛŒÚ© Ø±Ù†Ú¯',0),(436796,12134,'sr','ÐˆÐµÐ´Ð½Ð° Ð±Ð¾Ñ˜Ð°',0),(436797,12134,'vi','Má»™t mÃ u',0),(436798,12134,'af','Een kleur',0),(436799,12134,'ro','O singurÄƒ culoare',0),(436800,12134,'et','Ãœks vÃ¤rv',0),(436801,12134,'si','Ene barve',0),(436802,12134,'ba','Satu warna',0),(436803,12134,'nl','Ã‰Ã©n kleur',0),(436804,12134,'fi','Yksi vÃ¤ri',0),(436805,12134,'no','Ensfarget',0),(436806,12134,'da','Ã‰n farve',0),(436807,12134,'ko','í•œ ê°€ì§€ ìƒ‰',0),(436808,12134,'he','×¦×‘×¢ ××—×“',0),(436809,12134,'el','ÎˆÎ½Î± Ï‡ÏÏŽÎ¼Î±',0),(436810,12134,'zh','ä¸€ç§é¢œè‰²',0),(436811,12134,'sv','En fÃ¤rg',0),(436812,12134,'it','Un unico colore',0),(436813,12134,'tl','',0),(436814,12134,'th','à¸ªà¸µà¹€à¸”à¸µà¸¢à¸§',0),(436815,12134,'hi','à¤à¤• à¤°à¤‚à¤—',0),(436816,12134,'ms','Satu warna',0),(436817,12134,'ar','Ù„ÙˆÙ† ÙˆØ§Ø­Ø¯',0),(436818,12134,'fr','Une seule couleur',0),(436819,12134,'jp','1 ã¤ã®è‰²',0),(436820,12134,'pt','Uma cor',0),(436821,12134,'ru','ÐžÐ´Ð¸Ð½ Ñ†Ð²ÐµÑ‚',0),(436822,12134,'es','Un Color',0),(436823,12134,'de','Einfarbig',0),(436824,12134,'en','One Color',0),(436825,12135,'is','',0),(436826,12135,'dr','Ù…Ù‚Ø§Ù„Ù‡ Ø´Ù…Ø§Ø±Ù‡',0),(436827,12135,'pr','Ù…Ù‚Ø§Ù„Ù‡ Ø´Ù…Ø§Ø±Ù‡',0),(436828,12135,'tr','KaÄŸÄ±t numarasÄ±',0),(436829,12135,'pl','Numer ksiÄ™gi',0),(436830,12135,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ñ…Ð°Ñ€Ñ‚Ð¸Ñ',0),(436831,12135,'ur','Ú©Ø§ØºØ° Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(436832,12135,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½Ð¾Ð²Ð¸Ð½Ð°',0),(436833,12135,'vi','Giáº¥y sá»‘',0),(436834,12135,'af','Papier nommer',0),(436835,12135,'ro','NumÄƒrul de hÃ¢rtie',0),(436836,12135,'et','Raamat Number',0),(436837,12135,'si','Papir Å¡tevilka',0),(436838,12135,'ba','Kertas nomor',0),(436839,12135,'nl','Papier nummer',0),(436840,12135,'fi','Paperin mÃ¤Ã¤rÃ¤',0),(436841,12135,'no','Papir nummer',0),(436842,12135,'da','Papir antallet',0),(436843,12135,'ko','ì¢…ì´ ìˆ˜',0),(436844,12135,'he','×ž×¡×¤×¨ × ×™×™×¨',0),(436845,12135,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(436846,12135,'zh','è®ºæ–‡æ•°é‡',0),(436847,12135,'sv','Papper nummer',0),(436848,12135,'it','Numero di carta',0),(436849,12135,'tl','',0),(436850,12135,'th','à¸ˆà¸³à¸™à¸§à¸™à¸à¸£à¸°à¸”à¸²à¸©',0),(436851,12135,'hi','à¤ªà¤¤à¥à¤° à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(436852,12135,'ms','Nombor kertas',0),(436853,12135,'ar','Ø¹Ø¯Ø¯ Ø§Ù„ÙˆØ±Ù‚',0),(436854,12135,'fr','NumÃ©ro de document',0),(436855,12135,'jp','è«–æ–‡æ•°',0),(436856,12135,'pt','NÃºmero de papel',0),(436857,12135,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð½Ð¾Ð¼ÐµÑ€',0),(436858,12135,'es','NÃºmero de documento',0),(436859,12135,'de','Papier-Nummer',0),(436860,12135,'en','Paper Number',0),(436861,12136,'is','',0),(436862,12136,'dr','Ø¨Ø§Ø²Ú¯Ø´Øª Ø¨Ù‡ ØµÙØ­Ù‡ Ù‚Ø¨Ù„',0),(436863,12136,'pr','Ø¨Ø§Ø²Ú¯Ø´Øª Ø¨Ù‡ ØµÙØ­Ù‡ Ù‚Ø¨Ù„',0),(436864,12136,'tr','Ã–nceki sayfaya dÃ¶n',0),(436865,12136,'pl','PowrÃ³t do poprzedniej strony',0),(436866,12136,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð¿Ñ€ÐµÐ´Ð¸ÑˆÐ½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(436867,12136,'ur','Ù¾Ú†Ú¾Ù„Û’ ØµÙØ­Û Ù¾Ø± ÙˆØ§Ù¾Ø³ Ø¬Ø§Ø¦ÛŒÚº',0),(436868,12136,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ð½Ð° Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(436869,12136,'vi','Trá»Ÿ vá» trang trÆ°á»›c',0),(436870,12136,'af','Terug na vorige bladsy',0),(436871,12136,'ro','A reveni la pagina anterioarÄƒ',0),(436872,12136,'et','Tagasi eelmisele lehele',0),(436873,12136,'si','Vrnitev na prejÅ¡njo stran',0),(436874,12136,'ba','Kembali ke halaman sebelumnya',0),(436875,12136,'nl','Terug naar vorige pagina',0),(436876,12136,'fi','Palaa edelliselle sivulle',0),(436877,12136,'no','GÃ¥ tilbake til forrige side',0),(436878,12136,'da','Vende tilbage til forrige side',0),(436879,12136,'ko','ì´ì „ íŽ˜ì´ì§€ë¡œ ëŒì•„ê°€ê¸°',0),(436880,12136,'he','×œ×—×–×•×¨ ×œ×“×£ ×”×§×•×“×',0),(436881,12136,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÏƒÏ„Î·Î½ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· ÏƒÎµÎ»Î¯Î´Î±',0),(436882,12136,'zh','è¿”å›žåˆ°å‰ä¸€é¡µ',0),(436883,12136,'sv','Tillbaka till fÃ¶regÃ¥ende sida',0),(436884,12136,'it','Tornare alla pagina precedente',0),(436885,12136,'tl','',0),(436886,12136,'th','à¸à¸¥à¸±à¸šà¹„à¸›à¸«à¸™à¹‰à¸²à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²',0),(436887,12136,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤µà¤¾à¤ªà¤¸ à¤²à¥Œà¤Ÿà¥‡à¤‚',0),(436888,12136,'ms','Kembali ke Laman sebelumnya',0),(436889,12136,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(436890,12136,'fr','Retour Ã  la Page prÃ©cÃ©dente',0),(436891,12136,'jp','å‰ã®ãƒšãƒ¼ã‚¸ã«æˆ»ã‚‹',0),(436892,12136,'pt','Retornar Ã  pÃ¡gina anterior',0),(436893,12136,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ð½Ð° Ð¿Ñ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰ÑƒÑŽ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(436894,12136,'es','Volver a la pÃ¡gina anterior',0),(436895,12136,'de','ZurÃ¼ck zur vorherigen Seite',0),(436896,12136,'en','Return to Previous Page',0),(436897,12137,'is','',0),(436898,12137,'dr','Ø°Ø®ÛŒØ±Ù‡ ØªØ±ØªÛŒØ¨ Ú†Ø§Ù¾',0),(436899,12137,'pr','Ø°Ø®ÛŒØ±Ù‡ ØªØ±ØªÛŒØ¨ Ú†Ø§Ù¾',0),(436900,12137,'tr','YazdÄ±rma sÄ±rasÄ±nÄ± kaydedin',0),(436901,12137,'pl','Zapisz kolejnoÅ›Ä‡ drukowania',0),(436902,12137,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ñ€ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(436903,12137,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ ØªØ±ØªÛŒØ¨ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(436904,12137,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑˆÑ‚Ð°Ð¼Ð¿Ðµ',0),(436905,12137,'vi','Tiáº¿t kiá»‡m in Ä‘áº·t hÃ ng',0),(436906,12137,'af','Stoor druk orde',0),(436907,12137,'ro','SalvaÅ£i ordine imprimare',0),(436908,12137,'et','Salvesta printimise jÃ¤rjestus',0),(436909,12137,'si','Shrani vrstni red tiskanja',0),(436910,12137,'ba','Simpan pesanan cetakan',0),(436911,12137,'nl','Opslaan van afdrukvolgorde',0),(436912,12137,'fi','Tallenna tulostusjÃ¤rjestys',0),(436913,12137,'no','Lagre rekkefÃ¸lge',0),(436914,12137,'da','Gemme udskriftsrÃ¦kkefÃ¸lgen',0),(436915,12137,'ko','ì¸ì‡„ ìˆœì„œ ì €ìž¥',0),(436916,12137,'he','×œ×”×¦×™×œ ××ª ×¡×“×¨ ×”×”×“×¤×¡×”',0),(436917,12137,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(436918,12137,'zh','ä¿å­˜æ‰“å°é¡ºåº',0),(436919,12137,'sv','Spara utskriftsordning',0),(436920,12137,'it','Salvare l\'ordine di stampa',0),(436921,12137,'tl','',0),(436922,12137,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸žà¸´à¸¡à¸žà¹Œ',0),(436923,12137,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(436924,12137,'ms','Simpan cetak',0),(436925,12137,'ar','Ø­ÙØ¸ ØªØ±ØªÙŠØ¨ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(436926,12137,'fr','Enregistrez la commande d\'impression',0),(436927,12137,'jp','å°åˆ·é †åºã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(436928,12137,'pt','Salvar a ordem de impressÃ£o',0),(436929,12137,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(436930,12137,'es','Guardar la orden de impresiÃ³n',0),(436931,12137,'de','Drucken Auftrag speichern',0),(436932,12137,'en','Save Print Order',0),(436933,12138,'is','',0),(436934,12138,'dr','Ú©Ø³ÛŒ Ú©Ù‡ Ø´Ù…Ø§ Ø±Ø§ Ø¯Ø± Ø¹Ø±Ø¶ 24 Ø³Ø§Ø¹Øª ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯',0),(436935,12138,'pr','Ú©Ø³ÛŒ Ú©Ù‡ Ø´Ù…Ø§ Ø±Ø§ Ø¯Ø± Ø¹Ø±Ø¶ 24 Ø³Ø§Ø¹Øª ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯',0),(436936,12138,'tr','Biri 24 saat iÃ§inde sizinle irtibata geÃ§ecektir',0),(436937,12138,'pl','KtoÅ› skontaktuje siÄ™ z TobÄ… w ciÄ…gu 24 godzin',0),(436938,12138,'bg','ÐÑÐºÐ¾Ð¹ Ñ‰Ðµ ÑÐµ ÑÐ²ÑŠÑ€Ð¶ÐµÐ¼ Ñ Ð²Ð°Ñ Ð´Ð¾ 24 Ñ‡Ð°ÑÐ°',0),(436939,12138,'ur','Ú©Ø³ÛŒ Ù†Û’ Ø¢Ù¾ 24 Ú¯Ú¾Ù†Ù¹Û’ Ú©Û’ Ø§Ù†Ø¯Ø± Ø§Ù†Ø¯Ø± Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº Ú¯Û’',0),(436940,12138,'sr','ÐÐµÐºÐ¾ Ñ›Ðµ Ð²Ð°Ñ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ð¸ Ñƒ Ñ€Ð¾ÐºÑƒ Ð¾Ð´ 24 ÑÐ°Ñ‚Ð°',0),(436941,12138,'vi','Ai Ä‘Ã³ sáº½ liÃªn láº¡c vá»›i báº¡n trong vÃ²ng 24 giá»',0),(436942,12138,'af','Iemand sal jou kontak binne 24 uur',0),(436943,12138,'ro','Cineva va va contacta Ã®n 24 de ore',0),(436944,12138,'et','Keegi teiega 24 tunni jooksul',0),(436945,12138,'si','Nekdo bo stik z vami v 24 urah',0),(436946,12138,'ba','Seseorang akan menghubungi Anda dalam waktu 24 jam',0),(436947,12138,'nl','Iemand stuurt u binnen 24 uur',0),(436948,12138,'fi','Joku ottaa sinuun yhteyttÃ¤ 24 tunnin kuluessa',0),(436949,12138,'no','Noen vil kontakte deg innen 24 timer',0),(436950,12138,'da','Nogen vil kontakte dig inden for 24 timer',0),(436951,12138,'ko','ëˆ„êµ°ê°€ê°€ 24 ì‹œê°„ ì´ë‚´ì— ì—°ë½ì„',0),(436952,12138,'he','. ×ž×™×©×”×• ×™×™×¦×•×¨ ××™×ª×š ×§×©×¨ ×ª×•×š 24 ×©×¢×•×ª',0),(436953,12138,'el','ÎšÎ¬Ï€Î¿Î¹Î¿Ï‚ Î¸Î± ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î®ÏƒÎ¿Ï…Î¼Îµ Î¼Î±Î¶Î¯ ÏƒÎ±Ï‚ ÎµÎ½Ï„ÏŒÏ‚ 24 Ï‰ÏÏŽÎ½',0),(436954,12138,'zh','æœ‰äººä¼šåœ¨ 24 å°æ—¶å†…ä¸Žæ‚¨è”ç³»',0),(436955,12138,'sv','NÃ¥gon kommer att kontakta dig inom 24 timmar',0),(436956,12138,'it','Qualcuno vi contatterÃ  entro 24 ore',0),(436957,12138,'tl','',0),(436958,12138,'th','à¹ƒà¸„à¸£à¸ˆà¸°à¸•à¸´à¸”à¸•à¹ˆà¸­à¸„à¸¸à¸“à¸ à¸²à¸¢à¹ƒà¸™ 24 à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡',0),(436959,12138,'hi','à¤•à¤¿à¤¸à¥€ à¤¨à¥‡ à¤†à¤ª 24 à¤˜à¤‚à¤Ÿà¥‡ à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚à¤—à¥‡',0),(436960,12138,'ms','Seseorang akan menghubungi anda dalam masa 24 jam',0),(436961,12138,'ar','Ø´Ø®Øµ Ù…Ø§ Ø³ÙˆÙ Ù†ØªØµÙ„ Ø¨Ùƒ Ø®Ù„Ø§Ù„ 24 Ø³Ø§Ø¹Ø©',0),(436962,12138,'fr','Quelqu\'un vous contactera dans les 24 heures',0),(436963,12138,'jp','èª°ã‹ãŒ 24 æ™‚é–“ä»¥å†…ã«ã”é€£çµ¡ã„ãŸã—ã¾ã™',0),(436964,12138,'pt','AlguÃ©m entrarÃ¡ em contato dentro de 24 horas',0),(436965,12138,'ru','ÐšÑ‚Ð¾-Ñ‚Ð¾ ÑÐ²ÑÐ¶ÐµÑ‚ÑÑ Ñ Ð²Ð°Ð¼Ð¸ Ð² Ñ‚ÐµÑ‡ÐµÐ½Ð¸Ðµ 24 Ñ‡Ð°ÑÐ¾Ð²',0),(436966,12138,'es','Alguien se comunicarÃ¡ con usted dentro de 24 horas',0),(436967,12138,'de','Jemand wird Sie innerhalb von 24 Stunden kontaktieren.',0),(436968,12138,'en','Someone will contact you within 24 hours',0),(436969,12139,'is','',0),(436970,12139,'dr','Ø¨Ù†Ø§Ø¨Ø±Ø§ÛŒÙ† Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ coversheet Ø¨Ù‡ Ù‡Ù…Ø±Ø§Ù‡ Ø§ØµÙ„ Ú†Ø§Ù¾',0),(436971,12139,'pr','Ø¨Ù†Ø§Ø¨Ø±Ø§ÛŒÙ† Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ coversheet Ø¨Ù‡ Ù‡Ù…Ø±Ø§Ù‡ Ø§ØµÙ„ Ú†Ø§Ù¾',0),(436972,12139,'tr','Bu yÃ¼zden orijinal eÅŸlik edecek bir kapak sayfasÄ± yazdÄ±rabilirsiniz',0),(436973,12139,'pl','tak moÅ¼na wydrukowaÄ‡ otwarciem towarzyszyÄ‡ oryginaÅ‚y',0),(436974,12139,'bg','Ñ‚Ð°ÐºÐ° Ñ‡Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚Ðµ Ð¿Ð¾ÑÐ¾Ñ‡ÐµÐ½ Ð·Ð°Ð³Ð»Ð°Ð²Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð´Ð° Ð¿Ñ€Ð¸Ð´Ñ€ÑƒÐ¶Ð°Ð²Ð° Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸Ñ‚Ðµ',0),(436975,12139,'ur','Ù„ÛØ°Ø§ Ø¢Ù¾ Ú©Û’ Ú©Ø§ØºØ°Ø§Øª Ø§ÛŒÚ© Ú©ÙˆÙˆØ±Ø´ÛŒÙ¹ Ú†Ú¾Ø§Ù¾ Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(436976,12139,'sr','Ð¢Ð°ÐºÐ¾ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ‚Ðµ Ð½Ð° ÐÐ°ÑÐ»Ð¾Ð²Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð° Ð´Ð° Ð¸Ð´ÐµÐ¼ ÑÐ° Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸Ð¼Ð°',0),(436977,12139,'vi','VÃ¬ váº­y báº¡n cÃ³ thá»ƒ in má»™t coversheet Ä‘á»ƒ Ä‘i cÃ¹ng vá»›i báº£n gá»‘c',0),(436978,12139,'af','so kan jy \'n coversheet vir die begeleiding van die oorspronklikes druk',0),(436979,12139,'ro','Deci se poate imprima o coversheet pentru a Ã®nsoÅ£i originale',0),(436980,12139,'et','nii saate printida coversheet kaasas olema originaalid',0),(436981,12139,'si','tako lahko natisnete zaÅ¡Äitna Ponjava, ki spremljajo izvirnikov',0),(436982,12139,'ba','Jadi Anda dapat mencetak coversheet untuk menemani aslinya',0),(436983,12139,'nl','Zo kunt u het afdrukken van een coversheet ter begeleiding van de originelen',0),(436984,12139,'fi','Voit tulostaa kansilehdelle mukana alkuperÃ¤iset',0),(436985,12139,'no','sÃ¥ du kan skrive ut en forsiden Ã¥ fÃ¸lge originalene',0),(436986,12139,'da','sÃ¥ du kan udskrive en forsiden til at ledsage originalerne',0),(436987,12139,'ko','ê·¸ëž˜ì„œ ì›ë³¸ì„ ë™ë°˜ í•˜ëŠ” coversheetë¥¼ ì¸ì‡„í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(436988,12139,'he','××– ××ª×” ×™×›×•×œ ×œ×”×“×¤×™×¡ ×¢×œ ×¢×ž×•×“ ×©×¢×¨ ×©×œ ×œ×œ×•×•×ª ××ª ×”×ž×§×•×¨×™×™×',0),(436989,12139,'el','ÎˆÏ„ÏƒÎ¹, Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î¼Î¹Î± ÏƒÏ…Î½Î¿Î´ÎµÏ…Ï„Î¹ÎºÎ®Ï‚ ÏƒÎµÎ»Î¯Î´Î±Ï‚ Î³Î¹Î± Î½Î± ÏƒÏ…Î½Î¿Î´ÎµÏÏƒÎµÎ¹ Ï„Î± Ï€ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î±',0),(436990,12139,'zh','å› æ­¤ï¼Œæ‚¨å¯ä»¥æ‰“å°å°é¢é™ªåŽŸä»¶',0),(436991,12139,'sv','sÃ¥ kan du skriva ut en fÃ¶rsÃ¤ttsbladet skall Ã¥tfÃ¶lja originalen',0),(436992,12139,'it','cosÃ¬ Ã¨ possibile stampare una copertina per accompagnare gli originali',0),(436993,12139,'tl','',0),(436994,12139,'th','à¸”à¸±à¸‡à¸™à¸±à¹‰à¸™ à¸„à¸¸à¸“à¸ªà¸²à¸¡à¸²à¸£à¸–à¸žà¸´à¸¡à¸žà¹Œ coversheet à¹„à¸›à¸à¸±à¸šà¸•à¹‰à¸™à¸‰à¸šà¸±à¸š',0),(436995,12139,'hi','à¤¤à¥‹ à¤†à¤ª à¤®à¥‚à¤² à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• coversheet à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(436996,12139,'ms','Jadi anda boleh mencetak coversheet untuk mengiringi asal sepenuhnya',0),(436997,12139,'ar','Ù„Ø°Ø§ ÙŠÙ…ÙƒÙ†Ùƒ Ø·Ø¨Ø§Ø¹Ø© coversheet Ù„Ù…Ø±Ø§ÙÙ‚Ø© Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø£ØµÙ„ÙŠØ©',0),(436998,12139,'fr','Si vous pouvez imprimer une page de garde pour accompagner les originaux',0),(436999,12139,'jp','ã‚ªãƒªã‚¸ãƒŠãƒ«ã«åŒè¡Œã™ã‚‹é€ä»˜çŠ¶ã‚’å°åˆ·ã™ã‚‹ã®ã§',0),(437000,12139,'pt','EntÃ£o vocÃª pode imprimir uma folha de rosto para acompanhar os originais',0),(437001,12139,'ru','Ð¢Ð°ÐºÐ¸Ð¼ Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð¼ Ð²Ñ‹ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð½Ð°Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ coversheet ÑÐ¾Ð¿Ñ€Ð¾Ð²Ð¾Ð¶Ð´Ð°Ñ‚ÑŒ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ñ‹',0),(437002,12139,'es','AsÃ­ que usted puede imprimir una portada para acompaÃ±ar a los originales',0),(437003,12139,'de','So kÃ¶nnen Sie ein Deckblatt, begleiten die originale drucken.',0),(437004,12139,'en','so you can print a coversheet to accompany the originals',0),(437005,12140,'is','',0),(437006,12140,'dr','ÙØ§ÛŒÙ„ Ù‡Ø§ÛŒ Ù¾ÛŒÙˆØ³Øª Ø´Ø¯Ù‡',0),(437007,12140,'pr','ÙØ§ÛŒÙ„ Ù‡Ø§ÛŒ Ù¾ÛŒÙˆØ³Øª Ø´Ø¯Ù‡',0),(437008,12140,'tr','Ekli dosyalar',0),(437009,12140,'pl','DoÅ‚Ä…czonych plikÃ³w',0),(437010,12140,'bg','ÐŸÑ€Ð¸ÐºÐ°Ñ‡ÐµÐ½Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(437011,12140,'ur','Ù…Ù†Ø³Ù„Ú© Ù…Ø³Ù„ÛŒÚº',0),(437012,12140,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(437013,12140,'vi','Táº­p tin Ä‘Ã­nh kÃ¨m',0),(437014,12140,'af','Aangehegte lÃªers',0),(437015,12140,'ro','FiÅŸiere ataÅŸate',0),(437016,12140,'et','Manustatud failid',0),(437017,12140,'si','PriloÅ¾ene datoteke',0),(437018,12140,'ba','File terlampir',0),(437019,12140,'nl','Bijgevoegde bestanden',0),(437020,12140,'fi','Liitetyt tiedostot',0),(437021,12140,'no','Vedlagte filer',0),(437022,12140,'da','VedhÃ¦ftede filer',0),(437023,12140,'ko','ì²¨ë¶€ íŒŒì¼',0),(437024,12140,'he','×§×‘×¦×™× ×ž×¦×•×¨×¤×™×',0),(437025,12140,'el','Î£Ï…Î½Î·Î¼Î¼Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î±',0),(437026,12140,'zh','é™„åŠ çš„æ–‡ä»¶',0),(437027,12140,'sv','Bifogade filer',0),(437028,12140,'it','File allegati',0),(437029,12140,'tl','',0),(437030,12140,'th','à¹„à¸Ÿà¸¥à¹Œà¸—à¸µà¹ˆà¹à¸™à¸š',0),(437031,12140,'hi','à¤…à¤¨à¥à¤²à¤—à¥à¤¨ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(437032,12140,'ms','Fail yang dilampirkan',0),(437033,12140,'ar','Ø§Ù„Ù…Ù„ÙØ§Øª Ø§Ù„Ù…Ø±ÙÙ‚Ø©',0),(437034,12140,'fr','Fichiers joints',0),(437035,12140,'jp','æ·»ä»˜ãƒ•ã‚¡ã‚¤ãƒ«',0),(437036,12140,'pt','Arquivos anexados',0),(437037,12140,'ru','Ð’Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ðµ Ñ„Ð°Ð¹Ð»Ñ‹',0),(437038,12140,'es','Archivos adjuntos',0),(437039,12140,'de','AngehÃ¤ngte Dateien',0),(437040,12140,'en','Attached Files',0),(437041,12141,'is','',0),(437042,12141,'dr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ coversheet Ø¨Ø±Ø§ÛŒ Ø§ØµÙ„ Ø®ÙˆØ¯ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(437043,12141,'pr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ coversheet Ø¨Ø±Ø§ÛŒ Ø§ØµÙ„ Ø®ÙˆØ¯ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(437044,12141,'tr','AsÄ±llarÄ± iÃ§in bir kapak sayfasÄ± yapmak iÃ§in tÄ±klayÄ±n',0),(437045,12141,'pl','Kliknij tutaj aby Strona tytuÅ‚owa do oryginaÅ‚Ã³w',0),(437046,12141,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ Ð¿Ð¾ÑÐ¾Ñ‡ÐµÐ½ Ð·Ð°Ð³Ð»Ð°Ð²Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸',0),(437047,12141,'ur','Ø§Ù¾Ù†ÛŒ Ø§ØµÙ„ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ú©ÙˆÙˆØ±Ø´ÛŒÙ¹ Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(437048,12141,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ñ˜Ðµ Ð½Ð°ÑÐ»Ð¾Ð²Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð° Ð·Ð° Ñ‚Ð²Ð¾Ñ˜ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ðµ',0),(437049,12141,'vi','Click vÃ o Ä‘Ã¢y Ä‘á»ƒ thá»±c hiá»‡n má»™t coversheet cho báº£n gá»‘c cá»§a báº¡n',0),(437050,12141,'af','Klik hier om \'n coversheet vir jou oorspronklikes',0),(437051,12141,'ro','Click aici pentru a face o coversheet pentru originalele',0),(437052,12141,'et','Kliki siia teha oma originaalid coversheet',0),(437053,12141,'si','Kliknite tukaj, da zaÅ¡Äitna ponjava za vaÅ¡o originalov',0),(437054,12141,'ba','Klik di sini untuk membuat coversheet untuk aslinya Anda',0),(437055,12141,'nl','Klik hier om een coversheet voor uw originelen',0),(437056,12141,'fi','Klikkaa tÃ¤stÃ¤ ja anna kansilehdelle alkuperÃ¤iset',0),(437057,12141,'no','Klikk her for Ã¥ gjÃ¸re en forsiden for originalene',0),(437058,12141,'da','Klik her for at gÃ¸re en forsiden for dine originaler',0),(437059,12141,'ko','ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ ì—¬ ì›ë³¸ì— ëŒ€ í•œ coversheetì„',0),(437060,12141,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×¤×•×š ×¢×ž×•×“ ×©×¢×¨ ×©×œ ×”×ž×§×•×¨×™×™× ×©×œ×š',0),(437061,12141,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± ÎºÎ¬Î½ÎµÎ¹ Î¼Î¹Î± ÏƒÏ…Î½Î¿Î´ÎµÏ…Ï„Î¹ÎºÎ®Ï‚ ÏƒÎµÎ»Î¯Î´Î±Ï‚ Î³Î¹Î± ÏƒÎ±Ï‚ Ï€ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î±',0),(437062,12141,'zh','è¯·ç‚¹å‡»è¿™é‡Œè¿›è¡Œå°é¢ä¸ºä½ çš„åŽŸå§‹å›¾ç‰‡',0),(437063,12141,'sv','Klicka hÃ¤r fÃ¶r att gÃ¶ra en fÃ¶rsÃ¤ttsbladet fÃ¶r originalen',0),(437064,12141,'it','Clicca qui per fare una copertina per gli originali',0),(437065,12141,'tl','',0),(437066,12141,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸—à¸³ coversheet à¸ªà¸³à¸«à¸£à¸±à¸šà¸•à¹‰à¸™à¸‰à¸šà¸±à¸šà¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(437067,12141,'hi','à¤…à¤ªà¤¨à¥‡ à¤®à¥‚à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• coversheet à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(437068,12141,'ms','Klik di sini untuk membuat coversheet bagi asal anda',0),(437069,12141,'ar','Ø§Ø¶ØºØ· Ù‡Ù†Ø§ Ù„Ø¬Ø¹Ù„ coversheet Ù„Ù„Ù†Ø³Ø® Ø§Ù„Ø£ØµÙ„ÙŠØ©',0),(437070,12141,'fr','Cliquez ici pour faire une page de couverture pour vos originaux',0),(437071,12141,'jp','ã‚ãªãŸã®ã‚ªãƒªã‚¸ãƒŠãƒ«ã®é€ä»˜çŠ¶ã‚’ä½œæˆã™ã‚‹ã«ã¯ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(437072,12141,'pt','Clique aqui para fazer uma folha de rosto para os originais',0),(437073,12141,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ coversheet Ð´Ð»Ñ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¾Ð²',0),(437074,12141,'es','Haga clic aquÃ­ para hacer una portada para los originales',0),(437075,12141,'de','Klicken Sie hier fÃ¼r ein Deckblatt fÃ¼r Ihre originale',0),(437076,12141,'en','Click here to make a coversheet for your originals',0),(437077,12142,'is','',0),(437078,12142,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ù„ÛŒØ· Ø´Ù…Ø§Ø±Ù‡ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(437079,12142,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ù„ÛŒØ· Ø´Ù…Ø§Ø±Ù‡ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(437080,12142,'tr','SipariÅŸ bilet numarasÄ±nÄ± girin',0),(437081,12142,'pl','Wpisz numer zamÃ³wienia biletu',0),(437082,12142,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð±Ð¸Ð»ÐµÑ‚ Ð½Ð¾Ð¼ÐµÑ€',0),(437083,12142,'ur','ØªØ±ØªÛŒØ¨ Ù¹Ú©Ù¹ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(437084,12142,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° ÐºÐ°Ñ€Ñ‚Ñƒ',0),(437085,12142,'vi','Nháº­p sá»‘ thá»© tá»± lo vÃ©',0),(437086,12142,'af','Orde kaartjie nommer insleutel',0),(437087,12142,'ro','IntroduceÅ£i numÄƒrul de comandÄƒ de bilet',0),(437088,12142,'et','Sisestage tellimuse Piletite arv',0),(437089,12142,'si','Vnesite Å¡tevilko naloga vozovnice',0),(437090,12142,'ba','Masukkan nomor tiket pesanan',0),(437091,12142,'nl','Volgorde Ticket nummer',0),(437092,12142,'fi','SyÃ¶tÃ¤ lipun numero',0),(437093,12142,'no','Angi billett nummer',0),(437094,12142,'da','Indtast ordrenummer billet',0),(437095,12142,'ko','ì£¼ë¬¸ í‹°ì¼“ ë²ˆí˜¸ë¥¼ ìž…ë ¥',0),(437096,12142,'he','×”×–×Ÿ ×ž×¡×¤×¨ ×›×¨×˜×™×¡ ×”×–×ž× ×”',0),(437097,12142,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿ Î‘ÏÎ¾Ï‰Î½Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(437098,12142,'zh','è¾“å…¥è®¢å•æœºç¥¨ç¼–å·',0),(437099,12142,'sv','Ange ordernummer biljett',0),(437100,12142,'it','Inserisci il numero di biglietto di ordine',0),(437101,12142,'tl','',0),(437102,12142,'th','à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸•à¸±à¹‹à¸§',0),(437103,12142,'hi','à¤†à¤¦à¥‡à¤¶ à¤Ÿà¤¿à¤•à¤Ÿ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(437104,12142,'ms','Masukkan nombor Tiket pesanan',0),(437105,12142,'ar','Ø£Ø¯Ø®Ù„ Ø¹Ø¯Ø¯ Ø§Ù„ØªØ°Ø§ÙƒØ± Ø£Ù…Ø±',0),(437106,12142,'fr','Entrez le numÃ©ro de Ticket de commande',0),(437107,12142,'jp','ãƒã‚±ãƒƒãƒˆã®æ³¨æ–‡ç•ªå·ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(437108,12142,'pt','Digite o nÃºmero do bilhete de ordem',0),(437109,12142,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð° Ð±Ð¸Ð»ÐµÑ‚Ð°',0),(437110,12142,'es','Ingrese nÃºmero de boleto de pedido',0),(437111,12142,'de','Geben Sie die Ticketnummer',0),(437112,12142,'en','Enter Order Ticket Number',0),(437113,12143,'is','',0),(437114,12143,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø±Ù†Ú¯',0),(437115,12143,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø±Ù†Ú¯',0),(437116,12143,'tr','Renk sayÄ±sÄ±',0),(437117,12143,'pl','Liczba kolorÃ³w',0),(437118,12143,'bg','Ð‘Ñ€Ð¾Ð¹ Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(437119,12143,'ur','Ø±Ù†Ú¯ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(437120,12143,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð±Ð¾Ñ˜Ð°',0),(437121,12143,'vi','Sá»‘ mÃ u sáº¯c',0),(437122,12143,'af','Aantal kleure',0),(437123,12143,'ro','NumÄƒrul de culori',0),(437124,12143,'et','VÃ¤rvide arvu',0),(437125,12143,'si','Å tevilo barv',0),(437126,12143,'ba','Jumlah warna',0),(437127,12143,'nl','Aantal kleuren',0),(437128,12143,'fi','VÃ¤rien mÃ¤Ã¤rÃ¤',0),(437129,12143,'no','Antall farger',0),(437130,12143,'da','Antallet af farver',0),(437131,12143,'ko','ìƒ‰ìƒ ìˆ˜',0),(437132,12143,'he','×ž×¡×¤×¨ ×”×¦×‘×¢×™×',0),(437133,12143,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï‡ÏÏ‰Î¼Î¬Ï„Ï‰Î½',0),(437134,12143,'zh','é¢œè‰²æ•°ç›®',0),(437135,12143,'sv','Antalet fÃ¤rger',0),(437136,12143,'it','Numero di colori',0),(437137,12143,'tl','',0),(437138,12143,'th','à¸ˆà¸³à¸™à¸§à¸™à¸ªà¸µ',0),(437139,12143,'hi','à¤°à¤‚à¤—à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(437140,12143,'ms','Jumlah warna',0),(437141,12143,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø£Ù„ÙˆØ§Ù†',0),(437142,12143,'fr','Nombre de couleurs',0),(437143,12143,'jp','è‰²ã®æ•°',0),(437144,12143,'pt','NÃºmero de cores',0),(437145,12143,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ†Ð²ÐµÑ‚Ð¾Ð²',0),(437146,12143,'es','NÃºmero de colores',0),(437147,12143,'de','Anzahl der Farben',0),(437148,12143,'en','Number of Colors',0),(437149,12144,'is','',0),(437150,12144,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(437151,12144,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(437152,12144,'tr','SipariÅŸ numarasÄ±',0),(437153,12144,'pl','Numer zamÃ³wienia',0),(437154,12144,'bg','ÐŸÐ¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(437155,12144,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø±',0),(437156,12144,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(437157,12144,'vi','Sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(437158,12144,'af','Orde nommer',0),(437159,12144,'ro','NumÄƒrul de ordine',0),(437160,12144,'et','Tellimuse kood',0),(437161,12144,'si','Å tevilka naloga',0),(437162,12144,'ba','Nomor pesanan',0),(437163,12144,'nl','Bestelnummer',0),(437164,12144,'fi','Tilausnumero',0),(437165,12144,'no','Ordrenummer',0),(437166,12144,'da','Ordrenummer',0),(437167,12144,'ko','ì£¼ë¬¸ ë²ˆí˜¸',0),(437168,12144,'he','×ž×¡×¤×¨ ×”×–×ž× ×”',0),(437169,12144,'el','Î‘ÏÎ¾Ï‰Î½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(437170,12144,'zh','è®¢å•ç¼–å·',0),(437171,12144,'sv','Ordernummer',0),(437172,12144,'it','Numero d\'ordine',0),(437173,12144,'tl','',0),(437174,12144,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(437175,12144,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(437176,12144,'ms','Nombor pesanan',0),(437177,12144,'ar','Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨',0),(437178,12144,'fr','NumÃ©ro de commande',0),(437179,12144,'jp','æ³¨æ–‡ç•ªå·',0),(437180,12144,'pt','NÃºmero de ordem',0),(437181,12144,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(437182,12144,'es','NÃºmero de pedido',0),(437183,12144,'de','Bestell-Nr.',0),(437184,12144,'en','Order Number',0),(437185,12145,'is','',0),(437186,12145,'dr','Ø§ØªØ§Ù‚',0),(437187,12145,'pr','Ø§ØªØ§Ù‚',0),(437188,12145,'tr','Oda',0),(437189,12145,'pl','PokÃ³j',0),(437190,12145,'bg','Ð¡Ñ‚Ð°Ñ',0),(437191,12145,'ur','Ú©Ù…Ø±Û',0),(437192,12145,'sr','Ð¡Ð¾Ð±Ð°',0),(437193,12145,'vi','PhÃ²ng',0),(437194,12145,'af','Kamer',0),(437195,12145,'ro','CamerÄƒ',0),(437196,12145,'et','Tuba',0),(437197,12145,'si','Soba',0),(437198,12145,'ba','Kamar',0),(437199,12145,'nl','Kamer',0),(437200,12145,'fi','Huone',0),(437201,12145,'no','Rom',0),(437202,12145,'da','VÃ¦relse',0),(437203,12145,'ko','ë£¸',0),(437204,12145,'he','×—×“×¨',0),(437205,12145,'el','Î”Ï‰Î¼Î¬Ï„Î¹Î¿',0),(437206,12145,'zh','æˆ¿é—´',0),(437207,12145,'sv','Rum',0),(437208,12145,'it','Camera',0),(437209,12145,'tl','',0),(437210,12145,'th','à¸«à¹‰à¸­à¸‡à¸žà¸±à¸',0),(437211,12145,'hi','à¤•à¤®à¤°à¤¾',0),(437212,12145,'ms','Bilik',0),(437213,12145,'ar','Ø§Ù„ØºØ±ÙØ©',0),(437214,12145,'fr','Chambre',0),(437215,12145,'jp','ãƒ«ãƒ¼ãƒ ',0),(437216,12145,'pt','Quarto',0),(437217,12145,'ru','ÐÐ¾Ð¼ÐµÑ€',0),(437218,12145,'es','HabitaciÃ³n',0),(437219,12145,'de','Zimmer',0),(437220,12145,'en','Room',0),(437221,12146,'is','',0),(437222,12146,'dr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¯ÛŒØ¯Ù† Ø¬Ø²Ø¦ÛŒØ§Øª Ø¨ÛŒØ´ØªØ± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ù†Ø¸ÙˆØ±',0),(437223,12146,'pr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¯ÛŒØ¯Ù† Ø¬Ø²Ø¦ÛŒØ§Øª Ø¨ÛŒØ´ØªØ± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ù†Ø¸ÙˆØ±',0),(437224,12146,'tr','Bu sipariÅŸ iÃ§in daha fazla ayrÄ±ntÄ± gÃ¶rmek iÃ§in buraya tÄ±klayÄ±n',0),(437225,12146,'pl','Kliknij tutaj, aby wyÅ›wietliÄ‡ wiÄ™cej szczegÃ³Å‚Ã³w dla tego zamÃ³wienia',0),(437226,12146,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(437227,12146,'ur','Ù…Ø²ÛŒØ¯ ØªÙØµÛŒÙ„Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(437228,12146,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð²Ð¸ÑˆÐµ Ð´ÐµÑ‚Ð°Ñ™Ð° Ð·Ð° Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(437229,12146,'vi','Click vÃ o Ä‘Ã¢y Ä‘á»ƒ xem thÃªm chi tiáº¿t cho bá»™ nÃ y',0),(437230,12146,'af','Klik hier om meer besonderhede vir hierdie orde',0),(437231,12146,'ro','Click aici pentru a vedea mai multe detalii pentru aceastÄƒ comandÄƒ',0),(437232,12146,'et','Tellimuse Ã¼ksikasjade vaatamiseks klÃµpsake siin',0),(437233,12146,'si','Kliknite tukaj, Äe si Å¾elite ogledati veÄ podrobnosti za ta nalog',0),(437234,12146,'ba','Klik di sini untuk melihat rincian lebih lanjut untuk pesanan ini',0),(437235,12146,'nl','Klik hier voor meer Details voor deze Order',0),(437236,12146,'fi','Klikkaa tÃ¤stÃ¤ nÃ¤hdÃ¤ksesi lisÃ¤tietoja tÃ¤mÃ¤n tilauksen',0),(437237,12146,'no','Klikk her for Ã¥ vise flere detaljer for denne bestillingen',0),(437238,12146,'da','Klik her for at se flere detaljer om denne kendelse',0),(437239,12146,'ko','ì´ ìˆœì„œì— ëŒ€ í•œ ìžì„¸í•œ ë‚´ìš©ì„ ë³´ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(437240,12146,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×¦×™×’ ×¤×¨×˜×™× × ×•×¡×¤×™× ×¢×‘×•×¨ ×”×–×ž× ×” ×–×•',0),(437241,12146,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬',0),(437242,12146,'zh','å•å‡»æ­¤å¤„ä»¥æŸ¥çœ‹æ›´å¤šè¯¦ç»†ä¿¡æ¯ï¼Œæ­¤è®¢å•',0),(437243,12146,'sv','Klicka hÃ¤r fÃ¶r att se fler Detaljer fÃ¶r den hÃ¤r ordern',0),(437244,12146,'it','Clicca qui per visualizzare maggiori dettagli per questo ordine',0),(437245,12146,'tl','',0),(437246,12146,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸™à¸µà¹‰',0),(437247,12146,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤”à¤° à¤…à¤§à¤¿à¤• à¤µà¤¿à¤µà¤°à¤£ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(437248,12146,'ms','Klik di sini untuk melihat maklumat lanjut untuk pesanan ini',0),(437249,12146,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø²ÙŠØ¯ Ù…Ù† Ø§Ù„ØªÙØ§ØµÙŠÙ„ Ø¹Ù† Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(437250,12146,'fr','Cliquez ici pour voir plus de dÃ©tails pour cette commande',0),(437251,12146,'jp','ã“ã®æ³¨æ–‡ã®è©³ç´°ã‚’è¡¨ç¤ºã™ã‚‹ã«ã¯ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(437252,12146,'pt','Clique aqui para ver mais detalhes para esta ordem',0),(437253,12146,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð±Ð¾Ð»ÐµÐµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ñ‹Ðµ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ñ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(437254,12146,'es','Haga clic aquÃ­ para ver mÃ¡s detalles de esta orden',0),(437255,12146,'de','Klicken Sie hier, um weitere Details fÃ¼r diese Bestellung anzeigen',0),(437256,12146,'en','Click here to view more Details for this Order',0),(437257,12147,'is','',0),(437258,12147,'dr','ÙØ±Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ø´ØªØ±ÛŒ',0),(437259,12147,'pr','ÙØ±Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…Ø´ØªØ±ÛŒ',0),(437260,12147,'tr','MÃ¼ÅŸteri talep formu',0),(437261,12147,'pl','Formularz Å¼Ä…dania klienta',0),(437262,12147,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€Ð° Ð·Ð° Ð·Ð°ÑÐ²ÐºÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(437263,12147,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙØ§Ø±Ù…',0),(437264,12147,'sr','ÐžÐ±Ñ€Ð°Ð·Ð°Ñ† Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(437265,12147,'vi','Máº«u yÃªu cáº§u khÃ¡ch hÃ ng',0),(437266,12147,'af','KliÃ«nt versoek vorm',0),(437267,12147,'ro','Formular de cerere clientului',0),(437268,12147,'et','Kliendi taotluse vorm',0),(437269,12147,'si','Obrazec zahteve kupca',0),(437270,12147,'ba','Pelanggan meminta formulir',0),(437271,12147,'nl','Klant aanvraagformulier',0),(437272,12147,'fi','Asiakkaan pyynnÃ¶stÃ¤ lomakkeella',0),(437273,12147,'no','Kundeskjema',0),(437274,12147,'da','Kundens anmodning Form',0),(437275,12147,'ko','ê³ ê° ìš”ì²­ ì–‘ì‹',0),(437276,12147,'he','×˜×•×¤×¡ ×‘×§×©×ª ×”×œ×§×•×—',0),(437277,12147,'el','Î¦ÏŒÏÎ¼Î± Î±Î¯Ï„Î·ÏƒÎ·Ï‚ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(437278,12147,'zh','å®¢æˆ·è¯·æ±‚çª—ä½“',0),(437279,12147,'sv','KundformulÃ¤r',0),(437280,12147,'it','Modulo di richiesta del cliente',0),(437281,12147,'tl','',0),(437282,12147,'th','à¹à¸šà¸šà¸Ÿà¸­à¸£à¹Œà¸¡à¸„à¸³à¸‚à¸­à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(437283,12147,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤…à¤¨à¥à¤°à¥‹à¤§ à¤«à¥‰à¤°à¥à¤®',0),(437284,12147,'ms','Borang permintaan pelanggan',0),(437285,12147,'ar','Ù†Ù…ÙˆØ°Ø¬ Ø·Ù„Ø¨ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(437286,12147,'fr','Formulaire de demande de client',0),(437287,12147,'jp','ãŠå®¢æ§˜ã®ãƒªã‚¯ã‚¨ã‚¹ãƒˆ ãƒ•ã‚©ãƒ¼ãƒ ',0),(437288,12147,'pt','FormulÃ¡rio de pedido do cliente',0),(437289,12147,'ru','Ð¤Ð¾Ñ€Ð¼Ð° Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(437290,12147,'es','Formulario de solicitud de cliente',0),(437291,12147,'de','Kunden-Anfrageformular',0),(437292,12147,'en','Customer Request Form',0),(437293,12148,'is','',0),(437294,12148,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø§Ø®ÛŒØ±',0),(437295,12148,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´ Ø§Ø®ÛŒØ±',0),(437296,12148,'tr','Son sipariÅŸ bilgileri alÄ±nÄ±rken hata oluÅŸtu',0),(437297,12148,'pl','BÅ‚Ä…d podczas pobierania najnowsze informacje o zamawianiu',0),(437298,12148,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÐ½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(437299,12148,'ur','Ø­Ø§Ù„ÛŒÛ Ø¢Ø±ÚˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(437300,12148,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ð½ÐµÐ´Ð°Ð²Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð¸',0),(437301,12148,'vi','Lá»—i láº¥y táº¡i thá»© tá»± thÃ´ng tin',0),(437302,12148,'af','Fout herwinning van onlangse bestel info',0),(437303,12148,'ro','Eroare regÄƒsirea recente Ordinul info',0),(437304,12148,'et','TÃµrge allalaadimisel tehtud ostu info',0),(437305,12148,'si','Napaka pri pridobivanju zadnjih Order info',0),(437306,12148,'ba','Kesalahan yang mengambil hari info pesanan',0),(437307,12148,'nl','Fout bij het ophalen van recente Order info',0),(437308,12148,'fi','Virhe haettaessa hotelliin Tilaustiedot',0),(437309,12148,'no','Feil under henting av siste ordre informasjon',0),(437310,12148,'da','Fejl under hentning af seneste ordre info',0),(437311,12148,'ko','ìµœê·¼ ì£¼ë¬¸ ì •ë³´ ê²€ìƒ‰ ì˜¤ë¥˜',0),(437312,12148,'he','×©×’×™××” ×‘××—×–×•×¨ ×”××—×¨×•× ×•×ª ×œ×”×–×ž× ×•×ª',0),(437313,12148,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï€ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î±',0),(437314,12148,'zh','æ£€ç´¢æœ€è¿‘è®¢å•ä¿¡æ¯æ—¶å‡ºé”™',0),(437315,12148,'sv','Fel vid hÃ¤mtning av de senaste bestÃ¤lla information',0),(437316,12148,'it','Errore nel recupero di informazioni recenti di ordine',0),(437317,12148,'tl','',0),(437318,12148,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸”à¸¶à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(437319,12148,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤ªà¥à¤¨à¤ƒà¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(437320,12148,'ms','Ralat mendapatkan hari pesanan maklumat',0),(437321,12148,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù… Ù…Ø¤Ø®Ø±Ø§',0),(437322,12148,'fr','Erreur rÃ©cupÃ©rer ces derniÃ¨res infos d\'ordre',0),(437323,12148,'jp','æœ€è¿‘ã®æ³¨æ–‡æƒ…å ±ã‚’å–å¾—ä¸­ã®ã‚¨ãƒ©ãƒ¼',0),(437324,12148,'pt','Erro ao recuperar informaÃ§Ãµes recentes de ordem',0),(437325,12148,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ… Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð·Ð°ÐºÐ°Ð·Ðµ',0),(437326,12148,'es','Error al recuperar la informaciÃ³n reciente de orden',0),(437327,12148,'de','Fehler beim Abrufen der aktuellen Bestell-info',0),(437328,12148,'en','Error retrieving recent Order info',0),(437329,12149,'is','',0),(437330,12149,'dr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ coversheet Ø¨Ø±Ø§ÛŒ Ø§ØµÙ„ Ø®ÙˆØ¯ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(437331,12149,'pr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ coversheet Ø¨Ø±Ø§ÛŒ Ø§ØµÙ„ Ø®ÙˆØ¯ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(437332,12149,'tr','AsÄ±llarÄ± iÃ§in bir kapak sayfasÄ± yapmak iÃ§in tÄ±klayÄ±n',0),(437333,12149,'pl','Kliknij tutaj aby Strona tytuÅ‚owa do oryginaÅ‚Ã³w',0),(437334,12149,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ Ð¿Ð¾ÑÐ¾Ñ‡ÐµÐ½ Ð·Ð°Ð³Ð»Ð°Ð²Ð½Ð°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¸',0),(437335,12149,'ur','Ø§Ù¾Ù†ÛŒ Ø§ØµÙ„ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ú©ÙˆÙˆØ±Ø´ÛŒÙ¹ Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(437336,12149,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ñ˜Ðµ Ð½Ð°ÑÐ»Ð¾Ð²Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð° Ð·Ð° Ñ‚Ð²Ð¾Ñ˜ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ðµ',0),(437337,12149,'vi','Click vÃ o Ä‘Ã¢y Ä‘á»ƒ thá»±c hiá»‡n má»™t coversheet cho báº£n gá»‘c cá»§a báº¡n',0),(437338,12149,'af','Klik hier om \'n coversheet vir jou oorspronklikes',0),(437339,12149,'ro','Click aici pentru a face o coversheet pentru originalele',0),(437340,12149,'et','Kliki siia teha oma originaalid coversheet',0),(437341,12149,'si','Kliknite tukaj, da zaÅ¡Äitna ponjava za vaÅ¡o originalov',0),(437342,12149,'ba','Klik di sini untuk membuat coversheet untuk aslinya Anda',0),(437343,12149,'nl','Klik hier om een coversheet voor uw originelen',0),(437344,12149,'fi','Klikkaa tÃ¤stÃ¤ ja anna kansilehdelle alkuperÃ¤iset',0),(437345,12149,'no','Klikk her for Ã¥ gjÃ¸re en forsiden for originalene',0),(437346,12149,'da','Klik her for at gÃ¸re en forsiden for dine originaler',0),(437347,12149,'ko','ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ ì—¬ ì›ë³¸ì— ëŒ€ í•œ coversheetì„',0),(437348,12149,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×¤×•×š ×¢×ž×•×“ ×©×¢×¨ ×©×œ ×”×ž×§×•×¨×™×™× ×©×œ×š',0),(437349,12149,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± ÎºÎ¬Î½ÎµÎ¹ Î¼Î¹Î± ÏƒÏ…Î½Î¿Î´ÎµÏ…Ï„Î¹ÎºÎ®Ï‚ ÏƒÎµÎ»Î¯Î´Î±Ï‚ Î³Î¹Î± ÏƒÎ±Ï‚ Ï€ÏÏ‰Ï„ÏŒÏ„Ï…Ï€Î±',0),(437350,12149,'zh','è¯·ç‚¹å‡»è¿™é‡Œè¿›è¡Œå°é¢ä¸ºä½ çš„åŽŸå§‹å›¾ç‰‡',0),(437351,12149,'sv','Klicka hÃ¤r fÃ¶r att gÃ¶ra en fÃ¶rsÃ¤ttsbladet fÃ¶r originalen',0),(437352,12149,'it','Clicca qui per fare una copertina per gli originali',0),(437353,12149,'tl','',0),(437354,12149,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸—à¸³ coversheet à¸ªà¸³à¸«à¸£à¸±à¸šà¸•à¹‰à¸™à¸‰à¸šà¸±à¸šà¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(437355,12149,'hi','à¤…à¤ªà¤¨à¥‡ à¤®à¥‚à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• coversheet à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(437356,12149,'ms','Klik di sini untuk membuat coversheet bagi asal anda',0),(437357,12149,'ar','Ø§Ø¶ØºØ· Ù‡Ù†Ø§ Ù„Ø¬Ø¹Ù„ coversheet Ù„Ù„Ù†Ø³Ø® Ø§Ù„Ø£ØµÙ„ÙŠØ©',0),(437358,12149,'fr','Cliquez ici pour faire une page de couverture pour vos originaux',0),(437359,12149,'jp','ã‚ãªãŸã®ã‚ªãƒªã‚¸ãƒŠãƒ«ã®é€ä»˜çŠ¶ã‚’ä½œæˆã™ã‚‹ã«ã¯ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(437360,12149,'pt','Clique aqui para fazer uma folha de rosto para os originais',0),(437361,12149,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ coversheet Ð´Ð»Ñ Ð¾Ñ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð¾Ð²',0),(437362,12149,'es','Haga clic aquÃ­ para hacer una portada para los originales',0),(437363,12149,'de','Klicken Sie hier fÃ¼r ein Deckblatt fÃ¼r Ihre originale',0),(437364,12149,'en','Click here to make a coversheet for your originals',0),(437365,12150,'is','',0),(437366,12150,'dr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§',0),(437367,12150,'pr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§',0),(437368,12150,'tr','Bize ulaÅŸÄ±n',0),(437369,12150,'pl','Skontaktuj siÄ™ z nami',0),(437370,12150,'bg','Ð¡Ð²ÑŠÑ€Ð¶ÐµÑ‚Ðµ ÑÐµ Ñ Ð½Ð°Ñ',0),(437371,12150,'ur','ÛÙ… Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº',0),(437372,12150,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð°Ñ',0),(437373,12150,'vi','LiÃªn há»‡ vá»›i chÃºng tÃ´i',0),(437374,12150,'af','Kontakt Ons',0),(437375,12150,'ro','Contactati-ne',0),(437376,12150,'et','VÃµtke meiega Ã¼hendust',0),(437377,12150,'si','PiÅ¡ite nam',0),(437378,12150,'ba','Hubungi kami',0),(437379,12150,'nl','Neem contact op met ons',0),(437380,12150,'fi','Ota yhteyttÃ¤',0),(437381,12150,'no','Kontakt oss',0),(437382,12150,'da','Kontakt os',0),(437383,12150,'ko','ì €í¬ì— ê²Œ ì—°ë½',0),(437384,12150,'he','×¦×•×¨ ×§×©×¨',0),(437385,12150,'el','Î•Ï€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î®ÏƒÏ„Îµ Î¼Î±Î¶Î¯ Î¼Î±Ï‚',0),(437386,12150,'zh','è”ç³»æˆ‘ä»¬',0),(437387,12150,'sv','Kontakta oss',0),(437388,12150,'it','Contattaci',0),(437389,12150,'tl','',0),(437390,12150,'th','à¸•à¸´à¸”à¸•à¹ˆà¸­à¹€à¸£à¸²',0),(437391,12150,'hi','à¤¹à¤®à¤¸à¥‡ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚',0),(437392,12150,'ms','Hubungi kami',0),(437393,12150,'ar','Ø§ØªØµÙ„ Ø¨Ù†Ø§',0),(437394,12150,'fr','Contactez-nous',0),(437395,12150,'jp','ãŠå•ã„åˆã‚ã›',0),(437396,12150,'pt','Contate-nos',0),(437397,12150,'ru','Ð¡Ð²ÑÐ¶Ð¸Ñ‚ÐµÑÑŒ Ñ Ð½Ð°Ð¼Ð¸',0),(437398,12150,'es','Contacte con nosotros',0),(437399,12150,'de','Kontaktieren Sie uns',0),(437400,12150,'en','Contact Us',0),(437401,12151,'is','',0),(437402,12151,'dr','Ø§Ø³Ú©Ù†Ø§Ø³ &amp; Ù¾Ø±Ø¯Ø§Ø®Øª',0),(437403,12151,'pr','Ø§Ø³Ú©Ù†Ø§Ø³ &amp; Ù¾Ø±Ø¯Ø§Ø®Øª',0),(437404,12151,'tr','FaturalarÄ± & Ã¶demeleri',0),(437405,12151,'pl','Rachunki & pÅ‚atnoÅ›ci',0),(437406,12151,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ & Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(437407,12151,'ur','Ø¨Ù„ & Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(437408,12151,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ Ð¸ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(437409,12151,'vi','Thanh toÃ¡n hÃ³a Ä‘Æ¡n &amp;',0),(437410,12151,'af','Rekeninge en betalings',0),(437411,12151,'ro','Facturile & plÄƒÅ£i',0),(437412,12151,'et','Arved & maksed',0),(437413,12151,'si','& PlaÄila menice',0),(437414,12151,'ba','Pembayaran tagihan &',0),(437415,12151,'nl','Rekeningen & betalingen',0),(437416,12151,'fi','Laskut & maksut',0),(437417,12151,'no','Regninger & betalinger',0),(437418,12151,'da','Regninger & betalinger',0),(437419,12151,'ko','ì§€í & ì§€ë¶ˆ',0),(437420,12151,'he','×ª×©×œ×•×ž×™ ×”×—×©×‘×•× ×•×ª &',0),(437421,12151,'el','& Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(437422,12151,'zh','æ³•æ¡ˆ &amp; ä»˜æ¬¾',0),(437423,12151,'sv','RÃ¤kningar & betalningar',0),(437424,12151,'it','Pagamenti di bollette &',0),(437425,12151,'tl','',0),(437426,12151,'th','à¸ªà¸¹à¸•à¸£à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ &',0),(437427,12151,'hi','à¤¬à¤¿à¤² & à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(437428,12151,'ms','Pembayaran bil-bil &',0),(437429,12151,'ar','Ù…Ø¯ÙÙˆØ¹Ø§Øª ÙÙˆØ§ØªÙŠØ± Ø¢Ù†Ø¯',0),(437430,12151,'fr','Paiements de factures &',0),(437431,12151,'jp','æ‰‹å½¢ & æ”¯æ‰•ã„',0),(437432,12151,'pt','Pagamentos de contas &',0),(437433,12151,'ru','Ð—Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ñ‹ & Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(437434,12151,'es','Facturas y Recivos',0),(437435,12151,'de','Rechnungen & Zahlungen',0),(437436,12151,'en','Bills & Payments',0),(437437,12152,'is','',0),(437438,12152,'dr','Ø¨ÛŒÙ„ &amp; Ø³Ø§Ø¨Ù‚Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(437439,12152,'pr','Ø¨ÛŒÙ„ &amp; Ø³Ø§Ø¨Ù‚Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(437440,12152,'tr','Bill & Ã¶deme tarihi',0),(437441,12152,'pl','Bill & historia pÅ‚atnoÅ›ci',0),(437442,12152,'bg','Ð‘Ð¸Ð» & Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(437443,12152,'ur','Ø¨Ù„ & Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(437444,12152,'sr','Ð‘Ð¸Ð» & Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(437445,12152,'vi','Bill &amp; lá»‹ch sá»­ thanh toÃ¡n',0),(437446,12152,'af','Wetsontwerp & betaling geskiedenis',0),(437447,12152,'ro','Bill & istoricul plÄƒÅ£ilor',0),(437448,12152,'et','Bill & maksete ajalugu',0),(437449,12152,'si','Bill & plaÄilo zgodovino',0),(437450,12152,'ba','Bill & Riwayat pembayaran',0),(437451,12152,'nl','Bill & betalingsgeschiedenis',0),(437452,12152,'fi','Bill & Maksuhistoria',0),(437453,12152,'no','Bill & betaling historie',0),(437454,12152,'da','Bill & betalingshistorik',0),(437455,12152,'ko','ë¹Œ & ì§€ë¶ˆ ë‚´ì—­',0),(437456,12152,'he','×‘×™×œ & ×”×™×¡×˜×•×¨×™×” ×©×œ ×ª×©×œ×•×',0),(437457,12152,'el','Bill & Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(437458,12152,'zh','æ¡ä¾‹è‰æ¡ˆ &amp; ä»˜æ¬¾åŽ†å²è®°å½•',0),(437459,12152,'sv','Bill & betalning historia',0),(437460,12152,'it','Bill & storia di pagamento',0),(437461,12152,'tl','',0),(437462,12152,'th','à¸•à¸±à¹‹à¸§ & à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(437463,12152,'hi','à¤¬à¤¿à¤² & à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(437464,12152,'ms','Rang undang-undang & \"Payment History\"',0),(437465,12152,'ar','Ø¨ÙŠÙ„ Ø¢Ù†Ø¯ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹',0),(437466,12152,'fr','Bill & historique de paiement',0),(437467,12152,'jp','æ³•æ¡ˆ & ãŠæ”¯æ‰•ã„å±¥æ­´',0),(437468,12152,'pt','Bill & histÃ³rico de pagamentos',0),(437469,12152,'ru','Ð‘Ð¸Ð»Ð» & Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(437470,12152,'es','Bill &amp; historial de pago',0),(437471,12152,'de','Bill & Zahlungsverhalten',0),(437472,12152,'en','Bill & Payment History',0),(437473,12153,'is','',0),(437474,12153,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯',0),(437475,12153,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯',0),(437476,12153,'tr','Son fatura',0),(437477,12153,'pl','Ostatnie rachunki',0),(437478,12153,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(437479,12153,'ur','Ø­Ø§Ù„ÛŒÛ Ø¨Ù„',0),(437480,12153,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(437481,12153,'vi','nhá»¯ng hÃ³a Ä‘Æ¡n gáº§n Ä‘Ã¢y',0),(437482,12153,'af','Onlangse Wetsontwerpe',0),(437483,12153,'ro','Recente facturile',0),(437484,12153,'et','Tehtud arveid',0),(437485,12153,'si','Nedavni raÄuni',0),(437486,12153,'ba','Tagihan terbaru',0),(437487,12153,'nl','Recente facturen',0),(437488,12153,'fi','Hotelliin laskut',0),(437489,12153,'no','Siste regninger',0),(437490,12153,'da','Seneste regninger',0),(437491,12153,'ko','ìµœê·¼ ì²­êµ¬ì„œ',0),(437492,12153,'he','×—×©×‘×•× ×•×ª ××—×¨×•× ×™×',0),(437493,12153,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(437494,12153,'zh','æœ€è¿‘çš„æ³•æ¡ˆ',0),(437495,12153,'sv','Senaste rÃ¤kningar',0),(437496,12153,'it','Fatture recenti',0),(437497,12153,'tl','',0),(437498,12153,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(437499,12153,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤•à¥‡ à¤¬à¤¿à¤²',0),(437500,12153,'ms','Bil hari',0),(437501,12153,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(437502,12153,'fr','Factures rÃ©centes',0),(437503,12153,'jp','æœ€è¿‘ã®æ‰‹å½¢',0),(437504,12153,'pt','Notas recentes',0),(437505,12153,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(437506,12153,'es','Facturas Recientes',0),(437507,12153,'de','Den letzten Rechnungen',0),(437508,12153,'en','Recent Bills',0),(437509,12154,'is','',0),(437510,12154,'dr','Ù‡Ù…Ù‡ Ø¨Ø§Ø² Ø¨Ø§Ø´Ø¯',0),(437511,12154,'pr','Ù‡Ù…Ù‡ Ø¨Ø§Ø² Ø¨Ø§Ø´Ø¯',0),(437512,12154,'tr','TÃ¼m aÃ§',0),(437513,12154,'pl','Wszystkie otwarte',0),(437514,12154,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸',0),(437515,12154,'ur','ØªÙ…Ø§Ù… Ú©Ú¾Ù„ÛŒ',0),(437516,12154,'sr','Ð¡Ð²Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾',0),(437517,12154,'vi','Má»Ÿ táº¥t cáº£',0),(437518,12154,'af','Alle oop',0),(437519,12154,'ro','Toate Open',0),(437520,12154,'et','KÃµik avatud',0),(437521,12154,'si','Vse odprto',0),(437522,12154,'ba','Semua terbuka',0),(437523,12154,'nl','Alle Open',0),(437524,12154,'fi','Kaikk',0),(437525,12154,'no','Alle Ã¥pne',0),(437526,12154,'da','Alle Ã¥bne',0),(437527,12154,'ko','ëª¨ë“  ì˜¤í”ˆ',0),(437528,12154,'he','×›×•×œ× ×• × ×¤×ª×—.',0),(437529,12154,'el','ÎŒÎ»Î± Open',0),(437530,12154,'zh','æ‰€æœ‰å…¬å¼€',0),(437531,12154,'sv','Alla Ã¶ppna',0),(437532,12154,'it','Aperto tutti i',0),(437533,12154,'tl','',0),(437534,12154,'th','à¹€à¸›à¸´à¸”à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(437535,12154,'hi','à¤¸à¤­à¥€ à¤–à¥à¤²à¥‡',0),(437536,12154,'ms','Terbuka semua',0),(437537,12154,'ar','ÙØªØ­ Ø¬Ù…ÙŠØ¹',0),(437538,12154,'fr','Ouvert tous les',0),(437539,12154,'jp','ã™ã¹ã¦ã®ã‚ªãƒ¼ãƒ—ãƒ³çŠ¶æ…‹',0),(437540,12154,'pt','Todas abertas',0),(437541,12154,'ru','Ð’ÑÐµ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ',0),(437542,12154,'es','Todo Abierto',0),(437543,12154,'de','Alle offenen',0),(437544,12154,'en','All Open',0),(437545,12155,'is','',0),(437546,12155,'dr','Ø·Ø¨Ù‚ Ú¯Ø±ÙˆÙ‡ Ø¨Ù‡ Ø¬Ø§ÛŒ Ø·Ø¨Ù‚ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(437547,12155,'pr','Ø·Ø¨Ù‚ Ú¯Ø±ÙˆÙ‡ Ø¨Ù‡ Ø¬Ø§ÛŒ Ø·Ø¨Ù‚ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(437548,12155,'tr','Daha sonra satÄ±cÄ± tarafÄ±ndan tarafÄ±ndan Kategori',0),(437549,12155,'pl','WedÅ‚ug kategorii, nastÄ™pnie przez sprzedawca',0),(437550,12155,'bg','ÐŸÐ¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð° Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡',0),(437551,12155,'ur','Ø¨Ù…Ø·Ø§Ø¨Ù‚ Ø²Ù…Ø±Û Ù¾Ú¾Ø± Ø¨Ù†Ø§Ú©Ø± Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(437552,12155,'sr','ÐŸÐ¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸, Ð·Ð°Ñ‚Ð¸Ð¼ Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ†',0),(437553,12155,'vi','Theo phÃ¢n loáº¡i sau Ä‘Ã³ theo ngÆ°á»i bÃ¡n',0),(437554,12155,'af','Volgens kategorie dan deur verkoopsman',0),(437555,12155,'ro','De categoria de vanzator',0),(437556,12155,'et','Kategooria JÃ¤rgmine alus mÃ¼Ã¼gimees',0),(437557,12155,'si','Po kategoriji, nato jih prodajalec',0),(437558,12155,'ba','Berdasarkan Kategori kemudian oleh Salesman',0),(437559,12155,'nl','Per categorie vervolgens per verkoper',0),(437560,12155,'fi','Luokittain sitten myyjÃ¤',0),(437561,12155,'no','Etter kategori deretter etter selger',0),(437562,12155,'da','Kategori derefter sÃ¦lger',0),(437563,12155,'ko','ì„¸ì¼ì¦ˆ ë§¨ì— ì˜í•´ ë‹¤ìŒ ë²”ì£¼ë³„',0),(437564,12155,'he','×œ×¤×™ ×§×˜×’×•×¨×™×” ××– ×¢×œ ×™×“×™ ×¡×•×›×Ÿ ×ž×›×™×¨×•×ª',0),(437565,12155,'el','Î‘Ï€ÏŒ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï„ÏŒÏ„Îµ Î±Ï€ÏŒ Ï€Ï‰Î»Î·Ï„Î®Ï‚',0),(437566,12155,'zh','ç”±ç›®å½•ç„¶åŽç”±é”€å”®å‘˜',0),(437567,12155,'sv','Av kategorin sedan av sÃ¤ljare',0),(437568,12155,'it','Per la categoria poi dal venditore',0),(437569,12155,'tl','',0),(437570,12155,'th','à¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸—à¹à¸¥à¹‰à¸§à¹‚à¸”à¸¢à¸‚à¸²à¸¢',0),(437571,12155,'hi','à¤¸à¥‡à¤²à¥à¤¸à¤®à¥‡à¤¨ à¤¨à¥‡ à¤¤à¤¬ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(437572,12155,'ms','Mengikut kategori dengan jurujual',0),(437573,12155,'ar','Ø­Ø³Ø¨ Ø§Ù„ÙØ¦Ø© Ø«Ù… Ø¨Ø¨Ø§Ø¦Ø¹',0),(437574,12155,'fr','Par catÃ©gorie puis par vendeur',0),(437575,12155,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³ã«ã‚ˆã£ã¦ãã‚Œã‹ã‚‰ã‚«ãƒ†ã‚´ãƒªãƒ¼',0),(437576,12155,'pt','Por categoria em seguida pelo vendedor',0),(437577,12155,'ru','ÐŸÐ¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÐ¼, Ð·Ð°Ñ‚ÐµÐ¼, Ð¿Ñ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(437578,12155,'es','Por Categoria Entonces Por Vendedor',0),(437579,12155,'de','Nach Kategorie dann durch VerkÃ¤ufer',0),(437580,12155,'en','By Category then by Salesman',0),(437581,12156,'is','',0),(437582,12156,'dr','Ø¨Ø§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(437583,12156,'pr','Ø¨Ø§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(437584,12156,'tr','SatÄ±cÄ± tarafÄ±ndan',0),(437585,12156,'pl','Przez sprzedawca',0),(437586,12156,'bg','ÐžÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡',0),(437587,12156,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¨Ù†Ø§Ú©Ø±',0),(437588,12156,'sr','ÐŸÐ¾ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ñƒ',0),(437589,12156,'vi','Theo nhÃ¢n viÃªn kinh doanh',0),(437590,12156,'af','Per Verkoopsman',0),(437591,12156,'ro','De vanzator',0),(437592,12156,'et','Poolt mÃ¼Ã¼gimees',0),(437593,12156,'si','Ki ga prodajalec',0),(437594,12156,'ba','Oleh Salesman',0),(437595,12156,'nl','Door verkoper',0),(437596,12156,'fi','Jonka myyjÃ¤',0),(437597,12156,'no','Av selger',0),(437598,12156,'da','Af sÃ¦lger',0),(437599,12156,'ko','ì„¸ì¼ì¦ˆ ë§¨ì— ì˜í•´',0),(437600,12156,'he','×¢×œ ×™×“×™ ××™×© ×ž×›×™×¨×•×ª',0),(437601,12156,'el','Î‘Ï€ÏŒ Ï€Ï‰Î»Î·Ï„Î®Ï‚',0),(437602,12156,'zh','æŒ‰é”€å”®å‘˜',0),(437603,12156,'sv','Av fÃ¶rsÃ¤ljare',0),(437604,12156,'it','Dal venditore',0),(437605,12156,'tl','',0),(437606,12156,'th','à¹‚à¸”à¸¢à¸‚à¸²à¸¢',0),(437607,12156,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(437608,12156,'ms','Oleh jurujual',0),(437609,12156,'ar','Ø¨Ø¨Ø§Ø¦Ø¹',0),(437610,12156,'fr','Par vendeur',0),(437611,12156,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³ã«ã‚ˆã£ã¦',0),(437612,12156,'pt','Pelo vendedor',0),(437613,12156,'ru','ÐžÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(437614,12156,'es','Por Vendedor',0),(437615,12156,'de','Durch VerkÃ¤ufer',0),(437616,12156,'en','By Salesman',0),(437617,12157,'is','',0),(437618,12157,'dr','Ø²ÛŒØ± Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø§ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÛŒØ¯',0),(437619,12157,'pr','Ø²ÛŒØ± Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø§ Ø±Ø§ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡ÛŒØ¯',0),(437620,12157,'tr','Alt toplamlarÄ± gÃ¶sterme',0),(437621,12157,'pl','Nie pokazuj sum czÄ™Å›ciowych',0),(437622,12157,'bg','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð¼ÐµÐ¶Ð´Ð¸Ð½Ð½Ð¸ ÑÑƒÐ¼Ð¸',0),(437623,12157,'ur','Ø°ÛŒÙ„ÛŒ Ù…ÛŒØ²Ø§Ù† Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ù†Û Ú©Ø±ÛŒÚº',0),(437624,12157,'sr','ÐÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜ Ð¼ÐµÑ’ÑƒÐ²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(437625,12157,'vi','khÃ´ng hiá»‡n tá»•ng sá»‘',0),(437626,12157,'af','Subtotals wys nie',0),(437627,12157,'ro','Nu aratÄƒ subtotaluri',0),(437628,12157,'et','Ã„ra kuva vahekokkuvÃµtteid',0),(437629,12157,'si','Ne pokaÅ¾i delnih vsot',0),(437630,12157,'ba','Tidak menunjukkan subtotals',0),(437631,12157,'nl','Subtotalen niet weergeven',0),(437632,12157,'fi','Ã„lÃ¤ NÃ¤ytÃ¤ vÃ¤lisummat',0),(437633,12157,'no','Ikke Vis delsammendrag',0),(437634,12157,'da','Vis ikke subtotaler',0),(437635,12157,'ko','ë¶€ë¶„í•© í‘œì‹œ ì•ˆ í•¨',0),(437636,12157,'he','××œ ×ª×¦×™×’ ×¡×›×•×ž×™ ×‘×™× ×™×™×',0),(437637,12157,'el','Î”ÎµÎ½ ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ Ï„Î± Î¼ÎµÏÎ¹ÎºÎ¬ Î±Î¸ÏÎ¿Î¯ÏƒÎ¼Î±Ï„Î±',0),(437638,12157,'zh','ä¸æ˜¾ç¤ºå°è®¡',0),(437639,12157,'sv','Visa inte delsummor',0),(437640,12157,'it','Non mostrare i subtotali',0),(437641,12157,'tl','',0),(437642,12157,'th','à¹à¸ªà¸”à¸‡à¸œà¸¥à¸£à¸§à¸¡à¸¢à¹ˆà¸­à¸¢',0),(437643,12157,'hi','à¤‰à¤ª-à¤¯à¥‹à¤— à¤¨ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(437644,12157,'ms','Jangan tunjuk subtotals',0),(437645,12157,'ar','Ø¹Ø¯Ù… Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù„ÙØ±Ø¹ÙŠØ©',0),(437646,12157,'fr','Ne pas afficher les sous-totaux',0),(437647,12157,'jp','å°è¨ˆã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(437648,12157,'pt','NÃ£o mostrar subtotais',0),(437649,12157,'ru','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð¼ÐµÐ¶ÑƒÑ‚Ð¾Ñ‡Ð½Ñ‹Ðµ ÑÑƒÐ¼Ð¼Ñ‹',0),(437650,12157,'es','No muestra subtotales',0),(437651,12157,'de','Teilergebnisse nicht anzeigen',0),(437652,12157,'en','Do not show subtotals',0),(437653,12158,'is','',0),(437654,12158,'dr','Ø®Ù„Ø§ØµÙ‡ Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø²',0),(437655,12158,'pr','Ø®Ù„Ø§ØµÙ‡ Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø²',0),(437656,12158,'tr','AÃ§Ä±k sipariÅŸ Ã–zeti',0),(437657,12158,'pl','Podsumowanie zlecenia otwarte',0),(437658,12158,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(437659,12158,'ur','Ú©Ú¾Ù„ÛŒ Ù†Ø¸Ù… Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(437660,12158,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(437661,12158,'vi','Má»Ÿ hÃ ng tÃ³m táº¯t',0),(437662,12158,'af','Oop einde opsomming',0),(437663,12158,'ro','Ordin deschis Rezumat',0),(437664,12158,'et','Avatud tellimuste koond',0),(437665,12158,'si','Odprto naroÄilo Povzetek',0),(437666,12158,'ba','Open posisi ringkasan',0),(437667,12158,'nl','Overzicht van open bestelling',0),(437668,12158,'fi','Avoimen tilauksen Yhteenveto',0),(437669,12158,'no','Ã…pne Bestill.oversikt',0),(437670,12158,'da','Ã…ben ordre ResumÃ©',0),(437671,12158,'ko','ì˜¤í”ˆ ìˆœì„œ ìš”ì•½',0),(437672,12158,'he','×”×–×ž× ×” ×¤×ª×•×—×” ×¡×™×›×•×',0),(437673,12158,'el','Î†Î½Î¿Î¹Î³Î¼Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(437674,12158,'zh','æœªç»“è®¢å•æ‘˜è¦',0),(437675,12158,'sv','Ã–ppna ordern Sammanfattning',0),(437676,12158,'it','Riepilogo ordine aperto',0),(437677,12158,'tl','',0),(437678,12158,'th','à¸ªà¸£à¸¸à¸›à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¹€à¸›à¸´à¸”',0),(437679,12158,'hi','à¤–à¥à¤²à¤¾ à¤†à¤¦à¥‡à¤¶ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(437680,12158,'ms','Perintah terbuka ringkasan',0),(437681,12158,'ar','Ù…Ù„Ø®Øµ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ù…ÙØªÙˆØ­',0),(437682,12158,'fr','RÃ©sumÃ© de la commande en cours',0),(437683,12158,'jp','ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡ã®æ¦‚è¦',0),(437684,12158,'pt','Resumo de pedidos em aberto',0),(437685,12158,'ru','Ð¡Ð²Ð¾Ð´ÐºÐ° Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(437686,12158,'es','Resumen de pedido abierto',0),(437687,12158,'de','Offener Auftrag Zusammenfassung',0),(437688,12158,'en','Open Order Summary',0),(437689,12159,'is','',0),(437690,12159,'dr','Ù†Ù…Ø§ÛŒØ´ Ø®Ø· Ø¬Ø²Ø¦ÛŒØ§Øª Ú©Ø§Ù„Ø§',0),(437691,12159,'pr','Ù†Ù…Ø§ÛŒØ´ Ø®Ø· Ø¬Ø²Ø¦ÛŒØ§Øª Ú©Ø§Ù„Ø§',0),(437692,12159,'tr','SatÄ±r Ã¶ÄŸesi ayrÄ±ntÄ±larÄ± gÃ¶ster',0),(437693,12159,'pl','PokaÅ¼ szczegÃ³Å‚y elementu wiersza',0),(437694,12159,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(437695,12159,'ur','Ù„Ø§Ø¦Ù† Ø´Û’ Ú©ÛŒ ØªÙØµÛŒÙ„ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(437696,12159,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð° Ð´ÐµÑ‚Ð°Ñ™Ð°',0),(437697,12159,'vi','Hiá»ƒn thá»‹ chi tiáº¿t dÃ²ng tá»«ng máº·t hÃ ng',0),(437698,12159,'af','Wys lynitem Detail',0),(437699,12159,'ro','AratÄƒ detalii linie element',0),(437700,12159,'et','ReaÃ¼ksuse detailsed',0),(437701,12159,'si','PokaÅ¾i podrobnosti vrstiÄne postavke',0),(437702,12159,'ba','Menunjukkan Detail Item baris',0),(437703,12159,'nl','Line Item Detail weergeven',0),(437704,12159,'fi','NÃ¤ytÃ¤ nimikkeen tiedot',0),(437705,12159,'no','Vise linjeelementet detaljer',0),(437706,12159,'da','Vis post detaljer',0),(437707,12159,'ko','í–‰ í•­ëª© ìžì„¸ížˆ ë³´ê¸°',0),(437708,12159,'he','×”×¦×’ ×©×•×¨×ª ×¤×¨×˜',0),(437709,12159,'el','Î•Î¼Ï†Î±Î½Î¯Î¶Î¿Ï…Î½ Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(437710,12159,'zh','æ˜¾ç¤ºè¡Œé¡¹ç›®è¯¦æƒ…',0),(437711,12159,'sv','Detaljrika radartikel',0),(437712,12159,'it','Visualizza dettaglio articolo',0),(437713,12159,'tl','',0),(437714,12159,'th','à¹à¸ªà¸”à¸‡à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸£à¸²à¸¢à¸à¸²à¸£',0),(437715,12159,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(437716,12159,'ms','Menunjukkan butiran Item talian',0),(437717,12159,'ar','Ø¥Ø¸Ù‡Ø§Ø± ØªÙØ§ØµÙŠÙ„ Ø¨Ù†Ø¯',0),(437718,12159,'fr','Afficher les dÃ©tails de l\'article',0),(437719,12159,'jp','å“ç›®ã®è©³ç´°ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(437720,12159,'pt','Mostrar detalhes de Item de linha',0),(437721,12159,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð´ÐµÑ‚Ð°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(437722,12159,'es','Muestra Detalle de Linea de item',0),(437723,12159,'de','Einzelposten-Details anzeigen',0),(437724,12159,'en','Show Line Item Detail',0),(437725,12160,'is','',0),(437726,12160,'dr','Ú©Ù„ Ø¨Ø±Ø§ÛŒ Ú¯Ø±ÙˆÙ‡',0),(437727,12160,'pr','Ú©Ù„ Ø¨Ø±Ø§ÛŒ Ú¯Ø±ÙˆÙ‡',0),(437728,12160,'tr','Kategori iÃ§in toplam',0),(437729,12160,'pl','ÅÄ…cznie dla kategorii',0),(437730,12160,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð·Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(437731,12160,'ur','Ø²Ù…Ø±Û Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„',0),(437732,12160,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(437733,12160,'vi','Tá»•ng cá»™ng cho máº·t hÃ ng',0),(437734,12160,'af','Totaal vir kategorie',0),(437735,12160,'ro','Total pentru categoria',0),(437736,12160,'et','Kokku kategoorias',0),(437737,12160,'si','Skupaj za kategorijo',0),(437738,12160,'ba','Total untuk kategori',0),(437739,12160,'nl','Totaal voor de categorie',0),(437740,12160,'fi','Luokka yhteensÃ¤',0),(437741,12160,'no','Totalt for Kategori',0),(437742,12160,'da','Totalen for kategorien',0),(437743,12160,'ko','ë²”ì£¼ì— ëŒ€ í•œ ì´',0),(437744,12160,'he','×¡×” ×¢×‘×•×¨ ×§×˜×’×•×¨×™×”',0),(437745,12160,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î³Î¹Î± Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(437746,12160,'zh','æ€»è®¡æ‰€æœ‰åˆ†ç±»',0),(437747,12160,'sv','Totalt fÃ¶r kategori',0),(437748,12160,'it','Totale per categoria',0),(437749,12160,'tl','',0),(437750,12160,'th','à¸œà¸¥à¸£à¸§à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸£à¸°à¹€à¸ à¸—',0),(437751,12160,'hi','à¤•à¥à¤² à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(437752,12160,'ms','Jumlah keseluruhan bagi kategori',0),(437753,12160,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù„Ù„ÙØ¦Ø©',0),(437754,12160,'fr','Total de catÃ©gorie',0),(437755,12160,'jp','ã‚«ãƒ†ã‚´ãƒªã®åˆè¨ˆ',0),(437756,12160,'pt','Total por categoria',0),(437757,12160,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(437758,12160,'es','Total por CategorÃ­a',0),(437759,12160,'de','Insgesamt fÃ¼r Kategorie',0),(437760,12160,'en','Total for Category',0),(437761,12161,'is','',0),(437762,12161,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(437763,12161,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(437764,12161,'tr','SatÄ±cÄ± iÃ§in toplam',0),(437765,12161,'pl','ÅÄ…cznie dla sprzedawcy',0),(437766,12161,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð·Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(437767,12161,'ur','Ú©Ù„ Ø¨Ù†Ø§Ú©Ø±',0),(437768,12161,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð° Ñ‚Ñ€Ð³Ð¾Ð²Ñ†Ð°',0),(437769,12161,'vi','Tá»•ng cá»™ng cho ngÆ°á»i bÃ¡n hÃ ng',0),(437770,12161,'af','Totaal vir verkoopspersoon',0),(437771,12161,'ro','Total pentru vanzator',0),(437772,12161,'et','MÃ¼Ã¼gimees, kokku',0),(437773,12161,'si','Vsota, prodajalec',0),(437774,12161,'ba','Total untuk Penjual',0),(437775,12161,'nl','Totaal voor verkoper',0),(437776,12161,'fi','YhteensÃ¤ myyjittÃ¤in',0),(437777,12161,'no','Totalt for selger',0),(437778,12161,'da','Totalen for sÃ¦lger',0),(437779,12161,'ko','ì„¸ì¼ì¦ˆ ë§¨ì— ëŒ€ í•œ ì´',0),(437780,12161,'he','×¡×” ×¢×‘×•×¨ ×ž×›×™×¨×•×ª',0),(437781,12161,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬, Î³Î¹Î± Ï„Î·Î½ Ï€Ï‰Î»Î·Ï„Î®',0),(437782,12161,'zh','æ€»è®¡é”€å”®äººå‘˜',0),(437783,12161,'sv','Totalt fÃ¶r sÃ¤ljare',0),(437784,12161,'it','Totale per il venditore',0),(437785,12161,'tl','',0),(437786,12161,'th','à¸¢à¸­à¸”à¸£à¸§à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸‚à¸²à¸¢',0),(437787,12161,'hi','à¤¸à¥‡à¤²à¥à¤¸à¤®à¥‡à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²',0),(437788,12161,'ms','Jumlah keseluruhan bagi jurujual',0),(437789,12161,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ù„Ø¨Ø§Ø¦Ø¹',0),(437790,12161,'fr','Total pour le vendeur',0),(437791,12161,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³ã®åˆè¨ˆ',0),(437792,12161,'pt','Total para vendedor',0),(437793,12161,'ru','Ð’ÑÐµÐ³Ð¾ Ð´Ð»Ñ ÐºÐ¾Ð¼Ð¼Ð¸Ð²Ð¾ÑÐ¶ÐµÑ€Ð°',0),(437794,12161,'es','Total por Vendedor',0),(437795,12161,'de','Insgesamt fÃ¼r VerkÃ¤ufer',0),(437796,12161,'en','Total for Salesman',0),(437797,12162,'is','',0),(437798,12162,'dr','Ú©Ø¯Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª',0),(437799,12162,'pr','Ú©Ø¯Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª',0),(437800,12162,'tr','Hangi emirleri',0),(437801,12162,'pl','ZamÃ³wienia',0),(437802,12162,'bg','ÐšÐ¾Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(437803,12162,'ur','Ø¬Ø³ Ú©Ø§ Ø­Ú©Ù… Ø¯Û’ Ø¯ÛŒØ§',0),(437804,12162,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(437805,12162,'vi','Ä‘Æ¡n hÃ ng nÃ o',0),(437806,12162,'af','Watter Bestellings',0),(437807,12162,'ro','Ce comenzi',0),(437808,12162,'et','Kes tellib',0),(437809,12162,'si','Izdane odloÄbe',0),(437810,12162,'ba','Perintah yang',0),(437811,12162,'nl','Welke Orders',0),(437812,12162,'fi','Toimeksiannot',0),(437813,12162,'no','Hvilke ordrer',0),(437814,12162,'da','Hvilke ordrer',0),(437815,12162,'ko','ì–´ë–¤ ì£¼ë¬¸',0),(437816,12162,'he','××™×œ×• ×”×–×ž× ×•×ª',0),(437817,12162,'el','ÎŸÏ€Î¿Î¯Î¿ Î¿Î¹ Î´Î¿Î¸ÎµÎ¯ÏƒÎµÏ‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(437818,12162,'zh','å“ªä¸€ä¸ªè®¢å•ï¼Ÿ',0),(437819,12162,'sv','Vilka order',0),(437820,12162,'it','Quali ordini',0),(437821,12162,'tl','',0),(437822,12162,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹ƒà¸”',0),(437823,12162,'hi','à¤œà¥‹ à¤†à¤¦à¥‡à¤¶',0),(437824,12162,'ms','Perintah-perintah yang',0),(437825,12162,'ar','Ø£ÙŠ Ø£ÙˆØ§Ù…Ø±',0),(437826,12162,'fr','Quelles commandes',0),(437827,12162,'jp','ã“ã‚Œã‚’å—æ³¨',0),(437828,12162,'pt','Que ordens',0),(437829,12162,'ru','ÐšÐ°ÐºÐ¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(437830,12162,'es','Cuales Ordenes',0),(437831,12162,'de','Welche AuftrÃ¤ge',0),(437832,12162,'en','Which Orders',0),(437833,12163,'is','',0),(437834,12163,'dr','- Ø®Ù„Ø§ØµÙ‡',0),(437835,12163,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø²- Ø®Ù„Ø§ØµÙ‡',0),(437836,12163,'tr','Open - sipariÅŸ Ã–zeti',0),(437837,12163,'pl','Nakazuje Open - podsumowanie',0),(437838,12163,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Open - Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(437839,12163,'ur','Ú©Ú¾ÙˆÙ„ÛŒÚº - Ø®Ù„Ø§ØµÛ Ú©Ø§ Ø­Ú©Ù… Ø¯Û’ Ø¯ÛŒØ§ Û”',0),(437840,12163,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸ - Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(437841,12163,'vi','CÃ¡c Ä‘Æ¡n máº·t hÃ ng má»Ÿ- tÃ³m lÆ°á»£t',0),(437842,12163,'af','Dat oop - opsomming',0),(437843,12163,'ro','Ordinele deschise - Scurta descriere',0),(437844,12163,'et','JÃ¤tta Open - KokkuvÃµte',0),(437845,12163,'si','NaroÄila Open - Povzetek',0),(437846,12163,'ba','Pesanan Open - ringkasan',0),(437847,12163,'nl','Bestellingen Open - samenvatting',0),(437848,12163,'fi','Tilaukset Open - Yhteenveto',0),(437849,12163,'no','Bestillinger Ã¥pen - Sammendrag',0),(437850,12163,'da','Ordrer Open - ResumÃ©',0),(437851,12163,'ko','ì£¼ë¬¸ ì˜¤í”ˆ-ìš”ì•½',0),(437852,12163,'he','×”×–×ž× ×•×ª ×”×¤×ª×•×—×” - ×ª×§×¦×™×¨',0),(437853,12163,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Open - Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(437854,12163,'zh','è®¢å•æ‰“å¼€-æ‘˜è¦',0),(437855,12163,'sv','BestÃ¤llningar Ã¶ppna - Sammanfattning',0),(437856,12163,'it','Ordina Open - Sommario',0),(437857,12163,'tl','',0),(437858,12163,'th','à¸ªà¸±à¹ˆà¸‡à¹€à¸›à¸´à¸” - à¸ªà¸£à¸¸à¸›',0),(437859,12163,'hi','à¤“à¤ªà¤¨ - à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(437860,12163,'ms','Perintah terbuka - ringkasan',0),(437861,12163,'ar','Ø£ÙˆØ§Ù…Ø± ÙØªØ­-Ù…Ù„Ø®Øµ',0),(437862,12163,'fr','Commandes ouvertes - RÃ©sumÃ©',0),(437863,12163,'jp','æ³¨æ–‡ã®ã‚ªãƒ¼ãƒ—ãƒ³ - æ¦‚è¦',0),(437864,12163,'pt','Ordens Open - Resumo',0),(437865,12163,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Open - Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(437866,12163,'es','Ordenes Abiertas - Sumario',0),(437867,12163,'de','Bestellungen von Open - Zusammenfassung',0),(437868,12163,'en','Orders Open - Summary',0),(437869,12164,'is','',0),(437870,12164,'dr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(437871,12164,'pr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(437872,12164,'tr','GÃ¶nderilen',0),(437873,12164,'pl','WysÅ‚ane',0),(437874,12164,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(437875,12164,'ur','Ø¨Ú¾ÛŒØ¬Ø§',0),(437876,12164,'sr','ÐŸÐ¾ÑÐ»Ð°Ð¾',0),(437877,12164,'vi','ÄÃ£ gá»­i',0),(437878,12164,'af','Gestuur',0),(437879,12164,'ro','Trimis',0),(437880,12164,'et','Saadetud',0),(437881,12164,'si','Poslal',0),(437882,12164,'ba','Dikirim',0),(437883,12164,'nl','Verzonden',0),(437884,12164,'fi','LÃ¤hetti',0),(437885,12164,'no','Sendt',0),(437886,12164,'da','Sendt',0),(437887,12164,'ko','ì „ì†¡',0),(437888,12164,'he','×©×œ×—',0),(437889,12164,'el','ÎˆÏƒÏ„ÎµÎ¹Î»Îµ',0),(437890,12164,'zh','å‘é€',0),(437891,12164,'sv','Skickas',0),(437892,12164,'it','Inviato',0),(437893,12164,'tl','',0),(437894,12164,'th','à¸ªà¹ˆà¸‡',0),(437895,12164,'hi','à¤­à¥‡à¤œà¥‡ à¤—à¤',0),(437896,12164,'ms','Dihantar',0),(437897,12164,'ar','Ø£Ø±Ø³Ù„Øª',0),(437898,12164,'fr','EnvoyÃ©',0),(437899,12164,'jp','é€ä¿¡',0),(437900,12164,'pt','Enviado',0),(437901,12164,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(437902,12164,'es','Enviado',0),(437903,12164,'de','Gesendet',0),(437904,12164,'en','Sent',0),(437905,12165,'is','',0),(437906,12165,'dr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(437907,12165,'pr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª',0),(437908,12165,'tr','YapÄ± sipariÅŸi tanÄ±mlarÄ±',0),(437909,12165,'pl','Tworzenie definicji zamÃ³wienia',0),(437910,12165,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð´Ð¸Ð¼ Ñ€ÐµÐ´ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ð¸',0),(437911,12165,'ur','Ø­Ú©Ù… Ú©ÛŒ ØªØ¹Ø±ÛŒÙ Ú©ÛŒ ØªØ¹Ù…ÛŒØ±',0),(437912,12165,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ðµ',0),(437913,12165,'vi','Äá»‹nh nghÄ©a Ä‘Æ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(437914,12165,'af','Bou orde definisies',0),(437915,12165,'ro','Construi ordine definiÅ£ii',0),(437916,12165,'et','Ehitada tellimuse mÃµisted',0),(437917,12165,'si','Graditi opredelitve nalog',0),(437918,12165,'ba','Membangun urutan definisi',0),(437919,12165,'nl','Bouwen volgorde definities',0),(437920,12165,'fi','Rakentaa jÃ¤rjestyksessÃ¤ mÃ¤Ã¤ritelmÃ¤t',0),(437921,12165,'no','Bygge ordre definisjoner',0),(437922,12165,'da','Bygge rÃ¦kkefÃ¸lge definitioner',0),(437923,12165,'ko','ë¹Œë“œ ìˆœì„œ ì •ì˜',0),(437924,12165,'he','×œ×‘× ×•×ª ×¡×“×¨ ×”×’×“×¨×•×ª',0),(437925,12165,'el','ÎŸÎ¹ÎºÎ¿Î´Î¿Î¼Î®ÏƒÎ¿Ï…Î¼Îµ ÏƒÎµÎ¹ÏÎ¬ Î¿ÏÎ¹ÏƒÎ¼ÏŽÎ½',0),(437926,12165,'zh','æž„å»ºé¡ºåºå®šä¹‰',0),(437927,12165,'sv','Bygga ordning definitioner',0),(437928,12165,'it','Ordine definizioni di compilazione',0),(437929,12165,'tl','',0),(437930,12165,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸‚à¹‰à¸­à¸à¸³à¸«à¸™à¸”à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(437931,12165,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(437932,12165,'ms','Membina definisi perintah',0),(437933,12165,'ar','ØªØ¹Ø±ÙŠÙØ§Øª Ù†Ø¸Ø§Ù… Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(437934,12165,'fr','GÃ©nÃ©rer des dÃ©finitions de commande',0),(437935,12165,'jp','ãƒ“ãƒ«ãƒ‰é †åºã®å®šç¾©',0),(437936,12165,'pt','Criar definiÃ§Ãµes de ordem',0),(437937,12165,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(437938,12165,'es','Definiciones de Ordenes de ConstrucciÃ³n',0),(437939,12165,'de','Builddefinitionen bestellen',0),(437940,12165,'en','Build Order Definitions',0),(437941,12166,'is','',0),(437942,12166,'dr','Ù„ÛŒØ³Øª ØªØ§Ø±ÛŒØ® ØªÙˆÙ„Ø¯ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(437943,12166,'pr','Ù„ÛŒØ³Øª ØªØ§Ø±ÛŒØ® ØªÙˆÙ„Ø¯ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(437944,12166,'tr','Ã‡alÄ±ÅŸan doÄŸum listesi',0),(437945,12166,'pl','Lista pracownikÃ³w urodziny',0),(437946,12166,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ñ€Ð¾Ð¶Ð´ÐµÐ½ Ð´ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº',0),(437947,12166,'ur','Ù…Ù„Ø§Ø²Ù… Ø³Ø§Ù„Ú¯Ø±Û Ú©ÛŒ ÙÛØ±Ø³Øª',0),(437948,12166,'sr','Ð›Ð¸ÑÑ‚Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ñ€Ð¾Ñ’ÐµÐ½Ð´Ð°Ð½',0),(437949,12166,'vi','danh sÃ¡ch ngÃ y sinh nhÃ¢n viÃªn',0),(437950,12166,'af','Werknemer verjaarsdag lys',0),(437951,12166,'ro','Lista de ziua de nastere angajat',0),(437952,12166,'et','TÃ¶Ã¶taja sÃ¼nnipÃ¤ev nimekiri',0),(437953,12166,'si','Seznam zaposlenih rojstni dan',0),(437954,12166,'ba','Karyawan ulang daftar',0),(437955,12166,'nl','Lijst van de verjaardag van de werknemer',0),(437956,12166,'fi','SyntymÃ¤pÃ¤ivÃ¤ tyÃ¶ntekijÃ¤luettelo',0),(437957,12166,'no','Bursdag ListeOverAnsatte',0),(437958,12166,'da','Medarbejder fÃ¸dselsdag liste',0),(437959,12166,'ko','ì§ì› ìƒì¼ ëª©ë¡',0),(437960,12166,'he','×¨×©×™×ž×ª ×¢×•×‘×“×™× ×™×•× ×”×•×œ×“×ª',0),(437961,12166,'el','Î“ÎµÎ½Î­Î¸Î»Î¹Î± ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Ï‰Î½',0),(437962,12166,'zh','å‘˜å·¥ç”Ÿæ—¥æ¸…å•',0),(437963,12166,'sv','Personallista fÃ¶delsedag',0),(437964,12166,'it','Elenco di compleanno dei dipendenti',0),(437965,12166,'tl','',0),(437966,12166,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸§à¸±à¸™à¹€à¸à¸´à¸”à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(437967,12166,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤œà¤¨à¥à¤®à¤¦à¤¿à¤¨ à¤¸à¥‚à¤šà¥€',0),(437968,12166,'ms','Senarai hari lahir pekerja',0),(437969,12166,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ¸Ù Ø¹ÙŠØ¯ Ù…ÙŠÙ„Ø§Ø¯',0),(437970,12166,'fr','Liste des employÃ©s anniversaire',0),(437971,12166,'jp','å¾“æ¥­å“¡ã®èª•ç”Ÿæ—¥ä¸€è¦§',0),(437972,12166,'pt','Lista de aniversÃ¡rio de empregados',0),(437973,12166,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² Ð´ÐµÐ½ÑŒ Ñ€Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(437974,12166,'es','Lista de CumpleaÃ±os de Empleados',0),(437975,12166,'de','Geburtstag-Mitarbeiterliste',0),(437976,12166,'en','Employee Birthday List',0),(437977,12167,'is','',0),(437978,12167,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ù„ÛŒ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(437979,12167,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ù„ÛŒ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(437980,12167,'tr','Ã‡alÄ±ÅŸan genel bilgi',0),(437981,12167,'pl','Informacje ogÃ³lne pracownik',0),(437982,12167,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»-Ð¾Ð±Ñ‰Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(437983,12167,'ur','Ù…Ù„Ø§Ø²Ù… Ø¬Ù†Ø±Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(437984,12167,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð˜Ð½Ñ„Ð¾',0),(437985,12167,'vi','thÃ´ng tin chung nhÃ¢n viÃªn',0),(437986,12167,'af','Werknemer-algemene inligting',0),(437987,12167,'ro','Angajat General Info',0),(437988,12167,'et','TÃ¶Ã¶taja Ãœldinfo',0),(437989,12167,'si','Zaposlenega sploÅ¡ne informacije',0),(437990,12167,'ba','Info Umum karyawan',0),(437991,12167,'nl','Werknemer Algemene Info',0),(437992,12167,'fi','TyÃ¶ntekijÃ¤n yleiset tiedot',0),(437993,12167,'no','Ansatt General Info',0),(437994,12167,'da','Medarbejder General Info',0),(437995,12167,'ko','ì§ì› ì¼ë°˜ ì •ë³´',0),(437996,12167,'he','×ž×™×“×¢ ×›×œ×œ×™ ×”×¢×•×‘×“',0),(437997,12167,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î³ÎµÎ½Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(437998,12167,'zh','å‘˜å·¥æ€»ä¿¡æ¯',0),(437999,12167,'sv','AnstÃ¤lld allmÃ¤n Info',0),(438000,12167,'it','Dipendente General Info',0),(438001,12167,'tl','',0),(438002,12167,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸±à¹ˆà¸§à¹„à¸›à¸‚à¸­à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(438003,12167,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(438004,12167,'ms','Maklumat am pekerja',0),(438005,12167,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆØ¸Ù Ø§Ù„Ø¹Ø§Ù…Ø©',0),(438006,12167,'fr','Infos gÃ©nÃ©rales de l\'employÃ©',0),(438007,12167,'jp','å¾“æ¥­å“¡ã®ä¸€èˆ¬çš„ãªæƒ…å ±',0),(438008,12167,'pt','InformaÃ§Ã£o geral de empregado',0),(438009,12167,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ° Ð¾Ð±Ñ‰Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(438010,12167,'es','Info General de Empleado',0),(438011,12167,'de','Mitarbeiter-allgemeine Infos',0),(438012,12167,'en','Employee General Info',0),(438013,12168,'is','',0),(438014,12168,'dr','Ø§Ù‚Ù„Ø§Ù… Ø¯Ø±ÛŒØ§ÙØªÛŒ',0),(438015,12168,'pr','Ø§Ù‚Ù„Ø§Ù… Ø¯Ø±ÛŒØ§ÙØªÛŒ',0),(438016,12168,'tr','AlÄ±nan Ã¶ÄŸeler',0),(438017,12168,'pl','Pozycje',0),(438018,12168,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(438019,12168,'ur','Ø§Ø´ÛŒØ§ Ù…Ù„ÛŒ',0),(438020,12168,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ»Ðµ ÐºÐ¾Ñ˜Ð¸ ÑÑƒ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð¸',0),(438021,12168,'vi','cÃ¡c máº·t hÃ ng Ä‘Ã£ nháº­n',0),(438022,12168,'af','Items ontvang',0),(438023,12168,'ro','Articole primite',0),(438024,12168,'et','Tarnitud kaupade',0),(438025,12168,'si','Artiklih',0),(438026,12168,'ba','Item yang diterima',0),(438027,12168,'nl','Artikelen ontvangen',0),(438028,12168,'fi','Vastaanotettujen nimikkeiden',0),(438029,12168,'no','Varer mottatt',0),(438030,12168,'da','Varer, der modtages',0),(438031,12168,'ko','í•­ëª©ì„ ë°›ì€',0),(438032,12168,'he','×¤×¨×™×˜×™× ×©×”×ª×§×‘×œ×•',0),(438033,12168,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Î­Î»Î±Î²Îµ',0),(438034,12168,'zh','æŽ¥æ”¶é¡¹ç›®',0),(438035,12168,'sv','Inlevererade artiklarna',0),(438036,12168,'it','Articoli ricevuti',0),(438037,12168,'tl','',0),(438038,12168,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸š',0),(438039,12168,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(438040,12168,'ms','Barang-barang yang diterima',0),(438041,12168,'ar','Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„ÙˆØ§Ø±Ø¯Ø©',0),(438042,12168,'fr','Articles reÃ§us',0),(438043,12168,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã‚’å—ä¿¡ã—ã¾ã—ãŸã€‚',0),(438044,12168,'pt','Itens recebidos',0),(438045,12168,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ñ‹',0),(438046,12168,'es','Items Recibidos',0),(438047,12168,'de','Elemente empfangen',0),(438048,12168,'en','Items Received',0),(438049,12169,'is','',0),(438050,12169,'dr','Ø³ÙˆØ¯Ø¢ÙˆØ±ÛŒ Ùˆ Ø³ÙˆØ¯ ÙØ±ÙˆØ´',0),(438051,12169,'pr','Ø³ÙˆØ¯Ø¢ÙˆØ±ÛŒ Ùˆ Ø³ÙˆØ¯ ÙØ±ÙˆØ´',0),(438052,12169,'tr','SatÄ±ÅŸ karlÄ±lÄ±ÄŸÄ±',0),(438053,12169,'pl','RentownoÅ›Ä‡ sprzedaÅ¼y',0),(438054,12169,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ñ€ÐµÐ½Ñ‚Ð°Ð±Ð¸Ð»Ð½Ð¾ÑÑ‚',0),(438055,12169,'ur','ÙØ±ÙˆØ®Øª Ù…Ù†Ø§ÙØ¹',0),(438056,12169,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð°Ð±Ð¸Ð»Ð½Ð¾ÑÑ‚',0),(438057,12169,'vi','lá»£i nhuáº­n bÃ¡n hÃ ng',0),(438058,12169,'af','Verkope winsgewendheid',0),(438059,12169,'ro','Rentabilitatea vÃ¢nzÄƒrilor',0),(438060,12169,'et','MÃ¼Ã¼gi tasuvus',0),(438061,12169,'si','Donosnost prodaje',0),(438062,12169,'ba','Keuntungan penjualan',0),(438063,12169,'nl','Verkoop winstgevendheid',0),(438064,12169,'fi','Myynnin kannattavuus',0),(438065,12169,'no','Salg lÃ¸nnsomhet',0),(438066,12169,'da','Salg rentabilitet',0),(438067,12169,'ko','ì˜ì—… ìˆ˜ìµì„±',0),(438068,12169,'he','×ž×›×™×¨×•×ª ×¨×•×•×—×™×•×ª',0),(438069,12169,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î±Ï€Î¿Î´Î¿Ï„Î¹ÎºÏŒÏ„Î·Ï„Î±',0),(438070,12169,'zh','é”€å”®æ”¶ç›Šæ€§',0),(438071,12169,'sv','FÃ¶rsÃ¤ljning lÃ¶nsamhet',0),(438072,12169,'it','RedditivitÃ  vendite',0),(438073,12169,'tl','',0),(438074,12169,'th','à¸à¸³à¹„à¸£à¸ˆà¸²à¸à¸à¸²à¸£à¸‚à¸²à¸¢',0),(438075,12169,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤²à¤¾à¤­à¤ªà¥à¤°à¤¦à¤¤à¤¾',0),(438076,12169,'ms','Keuntungan jualan',0),(438077,12169,'ar','Ø±Ø¨Ø­ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(438078,12169,'fr','RentabilitÃ© de ventes',0),(438079,12169,'jp','å–¶æ¥­åŽç›Š',0),(438080,12169,'pt','Rentabilidade das vendas',0),(438081,12169,'ru','Ð ÐµÐ½Ñ‚Ð°Ð±ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚ÑŒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(438082,12169,'es','Ventas Rentabilidad',0),(438083,12169,'de','Umsatz-RentabilitÃ¤t',0),(438084,12169,'en','Sales Profitability',0),(438085,12170,'is','',0),(438086,12170,'dr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø­Ø§Ù…Ù„',0),(438087,12170,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø­Ø§Ù…Ù„',0),(438088,12170,'tr','Nakliye gemisi Kur',0),(438089,12170,'pl','WysyÅ‚ka noÅ›nik instalacyjny',0),(438090,12170,'bg','ÐœÐ¾Ñ€ÑÐºÐ¸ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(438091,12170,'ur','Ø´Ù¾Ù†Ú¯ Ú©ÛŒØ±ÛŒØ¦Ø± Ø³ÛŒÙ¹ Ø§Ù¾',0),(438092,12170,'sr','ÐÐ¾ÑÐ°Ñ‡ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(438093,12170,'vi','Váº­n chuyá»ƒn tÃ u sÃ¢n bay thiáº¿t láº­p',0),(438094,12170,'af','Draer opstelling gestuur',0),(438095,12170,'ro','Setup de transport maritim',0),(438096,12170,'et','Laevanduse vedaja seadistamine',0),(438097,12170,'si','Ladijskega prevoznika Setup',0),(438098,12170,'ba','Pengiriman pembawa Setup',0),(438099,12170,'nl','Verzending vervoerder Setup',0),(438100,12170,'fi','Toimituksen rahdinkuljettajan mÃ¤Ã¤ritys',0),(438101,12170,'no','Frakt Carrier oppsett',0),(438102,12170,'da','Shipping transportvirksomhed Setup',0),(438103,12170,'ko','ìºë¦¬ì–´ ì„¤ì¹˜ ë°°ì†¡',0),(438104,12170,'he','×”×’×“×¨×ª × ×•×©× ×ž×©×œ×•×—',0),(438105,12170,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î± ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï„Î¿Ï… Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(438106,12170,'zh','è£…è¿æ‰¿è¿äººè®¾ç½®',0),(438107,12170,'sv','Frakt bÃ¤rare Setup',0),(438108,12170,'it','Installazione di vettore di spedizione',0),(438109,12170,'tl','',0),(438110,12170,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸œà¸¹à¹‰à¹ƒà¸«à¹‰à¸šà¸£à¸´à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(438111,12170,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¾à¤¹à¤• à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(438112,12170,'ms','Persediaan pengangkutan perkapalan',0),(438113,12170,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø´Ø±ÙƒØ© Ø§Ù„Ø´Ø­Ù†',0),(438114,12170,'fr','Livraison transporteur Setup',0),(438115,12170,'jp','é…å¸ƒã®ã‚­ãƒ£ãƒªã‚¢è¨­å®š',0),(438116,12170,'pt','Frete transportadora Setup',0),(438117,12170,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Carrier',0),(438118,12170,'es','ConfiguraciÃ³n de portador de envÃ­o',0),(438119,12170,'de','Versand-Carrier-Setup',0),(438120,12170,'en','Shipping Carrier Setup',0),(438121,12171,'is','',0),(438122,12171,'dr','ÙˆØ¶Ø¹ÛŒØª Ú©Ø§Ø±Ú©Ù†Ø§Ù†',0),(438123,12171,'pr','ÙˆØ¶Ø¹ÛŒØª Ú©Ø§Ø±Ú©Ù†Ø§Ù†',0),(438124,12171,'tr','Ã‡alÄ±ÅŸanÄ±n durumuna',0),(438125,12171,'pl','Status pracownika',0),(438126,12171,'bg','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ‚ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸',0),(438127,12171,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(438128,12171,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(438129,12171,'vi','TÃ¬nh tráº¡ng cá»§a nhÃ¢n viÃªn',0),(438130,12171,'af','Werknemer Status',0),(438131,12171,'ro','Angajatul statutul',0),(438132,12171,'et','TÃ¶Ã¶taja seisund',0),(438133,12171,'si','Status delavca',0),(438134,12171,'ba','Status karyawan',0),(438135,12171,'nl','Status van de werknemer',0),(438136,12171,'fi','TyÃ¶ntekijÃ¤n tilan',0),(438137,12171,'no','Ansattstatus',0),(438138,12171,'da','Medarbejderstatus',0),(438139,12171,'ko','ì§ì› ìƒíƒœ',0),(438140,12171,'he','×ž×¦×‘ ×”×¢×•×‘×“',0),(438141,12171,'el','ÎšÎ±Î¸ÎµÏƒÏ„ÏŽÏ‚',0),(438142,12171,'zh','å°±ä¸šçŠ¶å†µ',0),(438143,12171,'sv','Medarbetarstatus',0),(438144,12171,'it','Stato dipendente',0),(438145,12171,'tl','',0),(438146,12171,'th','à¸ªà¸–à¸²à¸™à¸°à¸‚à¸­à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(438147,12171,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(438148,12171,'ms','Status pekerja',0),(438149,12171,'ar','Ø­Ø§Ù„Ø© Ø§Ù„Ù…ÙˆØ¸Ù',0),(438150,12171,'fr','Statut d\'employÃ©',0),(438151,12171,'jp','å¾“æ¥­å“¡ã®çŠ¶æ…‹',0),(438152,12171,'pt','Status do funcionÃ¡rio',0),(438153,12171,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(438154,12171,'es','Estado de Empleado',0),(438155,12171,'de','Mitarbeiterstatus',0),(438156,12171,'en','Employee Status',0),(438157,12172,'is','',0),(438158,12172,'dr','Ø­Ù…Ù„ Ú©Ù†Ù†Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(438159,12172,'pr','Ø­Ù…Ù„ Ú©Ù†Ù†Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(438160,12172,'tr','Nakliye gemileri',0),(438161,12172,'pl','PrzewoÅºnikÃ³w',0),(438162,12172,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡Ð¸Ñ‚Ðµ',0),(438163,12172,'ur','Ú©ÛŒØ±ÛŒØ¦Ø±Ø² Ø´Ù¾Ù†Ú¯',0),(438164,12172,'sr','ÐÐ¾ÑÐ¸Ð¾Ñ†Ð¸ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(438165,12172,'vi','Nhá»¯ng nhÃ  cung cáº¥p váº­n chuyá»ƒn',0),(438166,12172,'af','Draers gestuur',0),(438167,12172,'ro','Operatorii de transport maritim',0),(438168,12172,'et','Laevanduse vedajad',0),(438169,12172,'si','Dostavne',0),(438170,12172,'ba','Pelayaran',0),(438171,12172,'nl','Vervoerders',0),(438172,12172,'fi','LÃ¤hetyksen rahdinkuljettajien',0),(438173,12172,'no','TransportÃ¸rer',0),(438174,12172,'da','FragtmÃ¦nd',0),(438175,12172,'ko','ìš´ì†¡ ì‚¬ì—…ìž',0),(438176,12172,'he','×ž×©×œ×•×— × ×©××™×',0),(438177,12172,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Ï‚',0),(438178,12172,'zh','èˆªè¿æ‰¿è¿å•†',0),(438179,12172,'sv','TransportfÃ¶retag',0),(438180,12172,'it','Vettori di spedizione',0),(438181,12172,'tl','',0),(438182,12172,'th','à¸œà¸¹à¹‰à¸‚à¸™à¸ªà¹ˆà¸‡',0),(438183,12172,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¥ˆà¤°à¤¿à¤¯à¤°',0),(438184,12172,'ms','Penghantaran kapal',0),(438185,12172,'ar','Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø´Ø­Ù†',0),(438186,12172,'fr','Transporteurs maritimes',0),(438187,12172,'jp','é…é€ä¼šç¤¾',0),(438188,12172,'pt','Operadoras de transporte',0),(438189,12172,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸ÐºÐ°Ð¼Ð¸',0),(438190,12172,'es','Transportador de EnvÃ­os',0),(438191,12172,'de','Versand-TrÃ¤ger',0),(438192,12172,'en','Shipping Carriers',0),(438193,12173,'is','',0),(438194,12173,'dr','Ø±ÙˆØ´ Ø­Ù…Ù„ Ùˆ Ø§Ø±Ø³Ø§Ù„ Ø¬Ø¯ÛŒØ¯',0),(438195,12173,'pr','Ø±ÙˆØ´ Ø­Ù…Ù„ Ùˆ Ø§Ø±Ø³Ø§Ù„ Ø¬Ø¯ÛŒØ¯',0),(438196,12173,'tr','Yeni sevkiyat yÃ¶ntemi',0),(438197,12173,'pl','Nowe metody wysyÅ‚ki',0),(438198,12173,'bg','ÐÐ¾Ð² Ð½Ð°Ñ‡Ð¸Ð½ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(438199,12173,'ur','Ù†Ø¦Û’ Ø´Ù¾Ù†Ú¯ Ø·Ø±ÛŒÙ‚Û',0),(438200,12173,'sr','ÐÐ¾Ð²Ð¸ Ð½Ð°Ñ‡Ð¸Ð½ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(438201,12173,'vi','phÆ°Æ¡ng thá»©c váº­n chuyá»ƒn má»›i',0),(438202,12173,'af','Nuwe metode gestuur',0),(438203,12173,'ro','Noua metoda de transport maritim',0),(438204,12173,'et','Uus tarneviis',0),(438205,12173,'si','Nov naÄin poÅ¡iljanja',0),(438206,12173,'ba','Metode pengiriman baru',0),(438207,12173,'nl','Nieuwe verzendmethode',0),(438208,12173,'fi','Uusi toimitustapa',0),(438209,12173,'no','Nye forsendelsesmÃ¥te',0),(438210,12173,'da','Ny forsendelsesmetode',0),(438211,12173,'ko','ìƒˆë¡œìš´ ë°°ì†¡ ë°©ë²•',0),(438212,12173,'he','×©×™×˜×ª ×”×ž×©×œ×•×— ×”×—×“×©',0),(438213,12173,'el','ÎÎ­Î± Î¼Î­Î¸Î¿Î´Î¿Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(438214,12173,'zh','æ–°çš„è¿é€æ–¹å¼',0),(438215,12173,'sv','Nya leveranssÃ¤tt',0),(438216,12173,'it','Nuovo metodo di spedizione',0),(438217,12173,'tl','',0),(438218,12173,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹ƒà¸«à¸¡à¹ˆ',0),(438219,12173,'hi','à¤¨à¤ˆ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¿à¤§à¤¿',0),(438220,12173,'ms','Kaedah penghantaran baru',0),(438221,12173,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(438222,12173,'fr','Nouveau mode de livraison',0),(438223,12173,'jp','æ–°ã—ã„é€ä»˜æ–¹æ³•',0),(438224,12173,'pt','Novo mÃ©todo de envio',0),(438225,12173,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÑÐ¿Ð¾ÑÐ¾Ð± Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(438226,12173,'es','Nuevo MÃ©todo de EnvÃ­o',0),(438227,12173,'de','Neue Versandart',0),(438228,12173,'en','New Shipping Method',0),(438229,12174,'is','',0),(438230,12174,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ú© Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(438231,12174,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ú© Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(438232,12174,'tr','VeritabanÄ± bilgisi',0),(438233,12174,'pl','Baza danych informacji',0),(438234,12174,'bg','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(438235,12174,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(438236,12174,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð±Ð°Ð·Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(438237,12174,'vi','Dá»¯ liá»‡u khÃ´ng chÃ­nh xÃ¡c',0),(438238,12174,'af','Databasis Inliging',0),(438239,12174,'ro','InformaÅ£ii bazÄƒ de date',0),(438240,12174,'et','Andmebaasi Info',0),(438241,12174,'si','Info baze podatkov',0),(438242,12174,'ba','Database Info',0),(438243,12174,'nl','Database-Info',0),(438244,12174,'fi','Tietokannan tiedot',0),(438245,12174,'no','Databasen Info',0),(438246,12174,'da','Database Info',0),(438247,12174,'ko','ë°ì´í„°ë² ì´ìŠ¤ ì •ë³´',0),(438248,12174,'he','×ž×™×“×¢ ×¢×œ ×ž×¡×“ ×”× ×ª×•× ×™×',0),(438249,12174,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(438250,12174,'zh','æ•°æ®åº“ä¿¡æ¯',0),(438251,12174,'sv','Databas information',0),(438252,12174,'it','Database Info',0),(438253,12174,'tl','',0),(438254,12174,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(438255,12174,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(438256,12174,'ms','Maklumat pangkalan data',0),(438257,12174,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(438258,12174,'fr','Base de donnÃ©es Info',0),(438259,12174,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹æƒ…å ±',0),(438260,12174,'pt','InformaÃ§Ã£o do banco de dados',0),(438261,12174,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(438262,12174,'es','Info de Base de Datos',0),(438263,12174,'de','Datenbank Infos',0),(438264,12174,'en','Database Info',0),(438265,12175,'is','',0),(438266,12175,'dr','Ø³ÛŒØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÛŒ ',0),(438267,12175,'pr','Ø³ÛŒØ³ØªÙ… Ø¹Ø§Ù…Ù„ ØªØ¬Ø§Ø±ÛŒ ',0),(438268,12175,'tr','osCommerce',0),(438269,12175,'pl','osCommerce',0),(438270,12175,'bg','osCommerce',0),(438271,12175,'ur','Ø¹Ø«Ú©ÙˆÙ…Ù…Ø±Ø³ÛŒ',0),(438272,12175,'sr','Ð¾ÑÐ¦Ð¾Ð¼Ð¼ÐµÑ€Ñ†Ðµ',0),(438273,12175,'vi','osCommerce',0),(438274,12175,'af','OSHandel ',0),(438275,12175,'ro','osCommerce',0),(438276,12175,'et','osCommerce',0),(438277,12175,'si','osCommerce',0),(438278,12175,'ba','osCommerce',0),(438279,12175,'nl','osCommerce',0),(438280,12175,'fi','osCommerce',0),(438281,12175,'no','osCommerce',0),(438282,12175,'da','osCommerce',0),(438283,12175,'ko','osCommerce',0),(438284,12175,'he','osCommerce',0),(438285,12175,'el','osCommerce',0),(438286,12175,'zh','è´­ç‰©è½¦ç³»ç»Ÿ',0),(438287,12175,'sv','osCommerce',0),(438288,12175,'it','osCommerce',0),(438289,12175,'tl','',0),(438290,12175,'th','osCommerce',0),(438291,12175,'hi','osCommerce',0),(438292,12175,'ms','osCommerce',0),(438293,12175,'ar','Ø¨ÙˆØ±ØµØ© Ù…ØµØ±',0),(438294,12175,'fr','osCommerce',0),(438295,12175,'jp','osCommerce',0),(438296,12175,'pt','osCommerce',0),(438297,12175,'ru','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚-Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð°',0),(438298,12175,'es','Comercio OS',0),(438299,12175,'de','osCommerce',0),(438300,12175,'en','osCommerce',0),(438301,12176,'is','',0),(438302,12176,'dr','-Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¬Ù†Ø³',0),(438303,12176,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ-Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(438304,12176,'tr','Kurulum - stok',0),(438305,12176,'pl','Instalator - spis',0),(438306,12176,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ð·Ð°Ð¿Ð°ÑÐ¸',0),(438307,12176,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ - Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(438308,12176,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - Ð·Ð°Ð»Ð¸Ñ…Ðµ',0),(438309,12176,'vi','thiáº¿t láº­p- kho',0),(438310,12176,'af','Opstelling - voorraad',0);
INSERT INTO `langdef` VALUES (438311,12176,'ro','Configurare - inventar',0),(438312,12176,'et','Seadistus - varud',0),(438313,12176,'si','Setup - zaloge',0),(438314,12176,'ba','Pengaturan - persediaan',0),(438315,12176,'nl','Setup - inventaris',0),(438316,12176,'fi','Asetukset - varasto',0),(438317,12176,'no','Oppsett - lager',0),(438318,12176,'da','Setup - lager',0),(438319,12176,'ko','ì„¤ì •-ìž¬ê³ ',0),(438320,12176,'he','×”×’×“×¨×•×ª - ×ž×œ××™',0),(438321,12176,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· - Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(438322,12176,'zh','è®¾ç½®-åº“å­˜',0),(438323,12176,'sv','Setup - inventering',0),(438324,12176,'it','Installazione - inventario',0),(438325,12176,'tl','',0),(438326,12176,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² - à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(438327,12176,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€',0),(438328,12176,'ms','Persediaan - inventori',0),(438329,12176,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯--Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø¬Ø±Ø¯',0),(438330,12176,'fr','Installation - l\'inventaire',0),(438331,12176,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— - ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒª',0),(438332,12176,'pt','InstalaÃ§Ã£o - inventÃ¡rio',0),(438333,12176,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° - Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(438334,12176,'es','inventario de configuración general',0),(438335,12176,'de','Setup - Inventar',0),(438336,12176,'en','Setup - Inventory',0),(438337,12177,'is','',0),(438338,12177,'dr','- ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(438339,12177,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ - ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(438340,12177,'tr','Kurulum - fatura',0),(438341,12177,'pl','Ustawienie - rozliczeniowe',0),(438342,12177,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(438343,12177,'ur','-Ø³ÛŒÙ¹ Ø§Ù¾ Ø­Ø³Ø§Ø¨ Ú©Ø±Ù†Ø§',0),(438344,12177,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° - Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(438345,12177,'vi','thiáº¿t láº­p- hÃ³a Ä‘Æ¡n',0),(438346,12177,'af','Opstel - fakturering',0),(438347,12177,'ro','Configurare - facturare',0),(438348,12177,'et','Setup - arved',0),(438349,12177,'si','Setup - zaraÄunavanje',0),(438350,12177,'ba','Setup - penagihan',0),(438351,12177,'nl','Setup - facturering',0),(438352,12177,'fi','Setup - laskutus',0),(438353,12177,'no','Oppsett - fakturering',0),(438354,12177,'da','Setup - fakturering',0),(438355,12177,'ko','ì„¤ì¹˜-ê²°ì œ',0),(438356,12177,'he','×”×ª×§× ×” - ×—×™×•×‘',0),(438357,12177,'el','ÎŸÏÎ³Î¬Î½Ï‰ÏƒÎ· - Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(438358,12177,'zh','è®¾ç½®-è®¡è´¹',0),(438359,12177,'sv','Setup - fakturering',0),(438360,12177,'it','Installazione - fatturazione',0),(438361,12177,'tl','',0),(438362,12177,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² - à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(438363,12177,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - à¤¬à¤¿à¤²à¤¿à¤‚à¤—',0),(438364,12177,'ms','Persediaan - bil',0),(438365,12177,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯--Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(438366,12177,'fr','Installation - facturation',0),(438367,12177,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— - è«‹æ±‚',0),(438368,12177,'pt','Setup - faturamento',0),(438369,12177,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° - Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³',0),(438370,12177,'es','Configuración general AR',0),(438371,12177,'de','Setup - Abrechnung',0),(438372,12177,'en','Setup - Billing',0),(438373,12178,'is','',0),(438374,12178,'dr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡ ',0),(438375,12178,'pr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡ ',0),(438376,12178,'tr','Eklentileri etkinleÅŸtirin',0),(438377,12178,'pl','AktywowaÄ‡ Dodatki',0),(438378,12178,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(438379,12178,'ur','Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(438380,12178,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(438381,12178,'vi','thÃªm kÃ­ch hoáº¡t',0),(438382,12178,'af','Aktiveer Byvoegings',0),(438383,12178,'ro','Activa Suplimente',0),(438384,12178,'et','Aktiveeri lisandmoodulid',0),(438385,12178,'si','Aktiviranje dodatkov',0),(438386,12178,'ba','Aktifkan Pengaya',0),(438387,12178,'nl','Activeren van Add-Ons',0),(438388,12178,'fi','Aktivoi lisÃ¤osat',0),(438389,12178,'no','Aktivere tillegg',0),(438390,12178,'da','Aktivere tilfÃ¸jelser',0),(438391,12178,'ko','ì¶”ê°€ ê¸°ëŠ¥ í™œì„±í™”',0),(438392,12178,'he','×”×¤×¢×œ×ª ×ª×•×¡×¤×•×ª',0),(438393,12178,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î±',0),(438394,12178,'zh','æ¿€æ´»æ·»åŠ ',0),(438395,12178,'sv','Aktivera tillÃ¤gg',0),(438396,12178,'it','Attivare i componenti aggiuntivi',0),(438397,12178,'tl','',0),(438398,12178,'th','à¹€à¸£à¸µà¸¢à¸à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¹‚à¸›à¸£à¹à¸à¸£à¸¡ Add-on',0),(438399,12178,'hi','à¤à¤¡-à¤‘à¤¨à¥à¤¸ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(438400,12178,'ms','Aktifkan tambahan',0),(438401,12178,'ar','ØªÙ†Ø´ÙŠØ· Ø§Ù„Ø¥Ø¶Ø§ÙØ§Øª',0),(438402,12178,'fr','Activer les modules',0),(438403,12178,'jp','ã‚¢ãƒ‰ã‚ªãƒ³ã‚’æœ‰åŠ¹ã«ã—ã¾ã™ã€‚',0),(438404,12178,'pt','Ativar Add-ons',0),(438405,12178,'ru','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(438406,12178,'es','Activar Dispositivos de AumentaciÃ³n',0),(438407,12178,'de','Add-ons aktivieren',0),(438408,12178,'en','Activate Add-Ons',0),(438409,12179,'is','',0),(438410,12179,'dr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø² ÛŒÚ© Ø´Ø±Ú©Øª ÙØ¹Ø§Ù„ Ú©Ù¾ÛŒ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(438411,12179,'pr','Ø­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø² ÛŒÚ© Ø´Ø±Ú©Øª ÙØ¹Ø§Ù„ Ú©Ù¾ÛŒ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(438412,12179,'tr','GL oluÅŸturulan hesaplarÄ± etkin ÅŸirket kopyalanÄ±r',0),(438413,12179,'pl','GL kont utworzonych zostanie skopiowany z firmy aktywne',0),(438414,12179,'bg','GL Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð¸ Ñ‰Ðµ Ð±ÑŠÐ´Ðµ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ð° Ð¾Ñ‚ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð°Ñ‚Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(438415,12179,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ ØªØ®Ù„ÛŒÙ‚ Ú©Ø±Ø¯Û ÙØ¹Ø§Ù„ Ú©Ù…Ù¾Ù†ÛŒ Ø³Û’ Ù†Ù‚Ù„ Ú©ÛŒ Ø¬Ø§Ø¦ÛŒÚº Ú¯ÛŒ',0),(438416,12179,'sr','Ð“Ð› Ð½Ð°Ð»Ð¾Ð³Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ðµ Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ ÐºÐ¾Ð¿Ð¸Ñ€Ð°Ð½ Ð¸Ð· Ð°ÐºÑ‚Ð¸Ð²Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(438417,12179,'vi','cÃ¡c sá»• cÃ¡i tÃ i khoáº£n sáº½ Ä‘Æ°á»£c táº¡o giá»‘ng cÃ´ng ty Ä‘ang hoáº¡t Ä‘á»™ng',0),(438418,12179,'af','GL rekeninge geskep sal uit aktiewe maatskappy gekopieer word',0),(438419,12179,'ro','GL conturile create vor fi copiate la activ company',0),(438420,12179,'et','GL kontosid loonud kopeeritud tegutsevale ettevÃµttele',0),(438421,12179,'si','GL raÄuni ustvaril kopirajo iz aktivne druÅ¾be',0),(438422,12179,'ba','GL akun dibuat akan disalin dari perusahaan aktif',0),(438423,12179,'nl','GL Accounts die zijn gemaakt zal van actieve bedrijf worden gekopieerd',0),(438424,12179,'fi','GL luotujen tilien kopioidaan aktiivisen yrityksen',0),(438425,12179,'no','GL-kontoer som er opprettet vil bli kopiert fra aktive firmaet',0),(438426,12179,'da','GL konti oprettet vil blive kopieret fra aktiv virksomhed',0),(438427,12179,'ko','GL ê³„ì • ë§Œë“  í™œì„± íšŒì‚¬ì—ì„œ ë³µì‚¬ ë©ë‹ˆë‹¤.',0),(438428,12179,'he','×—×©×‘×•× ×•×ª GL ×©× ×•×¦×¨×• ×™×•×¢×ª×§×• ×ž×—×‘×¨×ª ×¤×¢×™×œ',0),(438429,12179,'el','GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î¸Î± Î±Î½Ï„Î¹Î³ÏÎ±Ï†Î¿ÏÎ½ Î±Ï€ÏŒ ÎµÏ€Î¹Ï‡ÎµÎ¯ÏÎ·ÏƒÎ·Ï‚.',0),(438430,12179,'zh','æ–°å»ºçš„æ€»å¸å¸æˆ·å°†ä¼šä»Žæ´»è·ƒçš„å…¬å¸ä¸­å¤‡ä»½',0),(438431,12179,'sv','GL-konton som skapas kommer att kopieras frÃ¥n aktiva fÃ¶retag',0),(438432,12179,'it','GL account creati verranno copiati dall\'azienda attiva',0),(438433,12179,'tl','',0),(438434,12179,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸«à¸±à¸ªà¸šà¸±à¸à¸Šà¸µà¸ˆà¸°à¸–à¸¹à¸à¸„à¸±à¸”à¸¥à¸­à¸à¸ˆà¸²à¸à¸à¸²à¸£à¹ƒà¸Šà¹‰',0),(438435,12179,'hi','GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥‡ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¹à¥‹ à¤œà¤¾à¤à¤à¤—à¥‡',0),(438436,12179,'ms','Akaun-akaun GL yang dicipta akan disalin daripada syarikat yang aktif',0),(438437,12179,'ar','Ø³ÙŠØªÙ… Ù†Ø³Ø® Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª GL ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ù…Ù† Ø´Ø±ÙƒØ© Ù†Ø´Ø·Ø©',0),(438438,12179,'fr','GL comptes crÃ©Ã©s sont copiÃ©s Ã  partir de la sociÃ©tÃ© active',0),(438439,12179,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ä½œæˆãŒã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªä¼šç¤¾ã‹ã‚‰ã‚³ãƒ”ãƒ¼ã•ã‚Œã¾ã™ã€‚',0),(438440,12179,'pt','GL contas criadas serÃ£o copiadas do ativa empresa',0),(438441,12179,'ru','GL Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ñ‹ Ð±ÑƒÐ´ÑƒÑ‚ ÑÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹ Ð¸Ð· Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(438442,12179,'es','Cuentas LM creado serÃ¡n copiadas de la empresa actÃ­va',0),(438443,12179,'de','GL-Konten erstellt wird aus tÃ¤tiges Unternehmen Ã¼bernommen',0),(438444,12179,'en','GL Accounts created will be copied from active company',0),(438445,12180,'is','',0),(438446,12180,'dr','Ø§Ø±Ø²Ø´ Ú¯Ø°Ø§Ø±ÛŒ Ú©Ø§Ù„Ø§',0),(438447,12180,'pr','Ø§Ø±Ø²Ø´ Ú¯Ø°Ø§Ø±ÛŒ Ú©Ø§Ù„Ø§',0),(438448,12180,'tr','Maddenin deÄŸerleme',0),(438449,12180,'pl','Przedmiot wyceny',0),(438450,12180,'bg','ÐžÑ†ÐµÐ½ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(438451,12180,'ur','Ø´Û’ Ú©Ø§ Ù…ÙˆÙ„',0),(438452,12180,'sr','ÐžÐ±Ñ€Ð°Ñ‡ÑƒÐ½ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(438453,12180,'vi','Ä‘á»‹nh giÃ¡ hÃ ng',0),(438454,12180,'af','Item waardasie',0),(438455,12180,'ro','Elementul evaluare',0),(438456,12180,'et','Ãœksuse hindamine',0),(438457,12180,'si','Element vrednotenja',0),(438458,12180,'ba','Item penilaian',0),(438459,12180,'nl','Item waardering',0),(438460,12180,'fi','Nimikkeen arvostus',0),(438461,12180,'no','Elementet verdivurdering',0),(438462,12180,'da','Vare vÃ¦rdiansÃ¦ttelse',0),(438463,12180,'ko','í•­ëª© í‰ê°€',0),(438464,12180,'he','×”×¢×¨×›×ª ×©×•×•×™ ×”×¤×¨×™×˜',0),(438465,12180,'el','Î‘Ï€Î¿Ï„Î¯Î¼Î·ÏƒÎ·Ï‚',0),(438466,12180,'zh','é¡¹ç›®è¯„ä¼°',0),(438467,12180,'sv','Objektet vÃ¤rdering',0),(438468,12180,'it','Elemento di valutazione',0),(438469,12180,'tl','',0),(438470,12180,'th','à¸¡à¸¹à¸¥à¸„à¹ˆà¸²à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(438471,12180,'hi','à¤®à¤¦ à¤•à¥‡ à¤®à¥‚à¤²à¥à¤¯à¤¾à¤‚à¤•à¤¨',0),(438472,12180,'ms','Item penilaian',0),(438473,12180,'ar','Ø¹Ù†ØµØ± Ø§Ù„ØªÙ‚ÙŠÙŠÙ…',0),(438474,12180,'fr','Ã‰valuation de l\'Ã©lÃ©ment',0),(438475,12180,'jp','é …ç›®ã®è©•ä¾¡',0),(438476,12180,'pt','Item de avaliaÃ§Ã£o',0),(438477,12180,'ru','ÐžÑ†ÐµÐ½ÐºÐ° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(438478,12180,'es','Item ValuaciÃ³n',0),(438479,12180,'de','Artikel Bewertung',0),(438480,12180,'en','Item Valuation',0),(438481,12181,'is','',0),(438482,12181,'dr','Ø¨Ù‡',0),(438483,12181,'pr','Ø¨Ù‡',0),(438484,12181,'tr','Hedef',0),(438485,12181,'pl','Do',0),(438486,12181,'bg','Ð”Ð°',0),(438487,12181,'ur','Ú©Ø±Ù†Ø§',0),(438488,12181,'sr','Ð”Ð°',0),(438489,12181,'vi','Tá»›i',0),(438490,12181,'af','Om te',0),(438491,12181,'ro','Pentru a',0),(438492,12181,'et','Et',0),(438493,12181,'si','Za',0),(438494,12181,'ba','Untuk',0),(438495,12181,'nl','Aan',0),(438496,12181,'fi','Jotta',0),(438497,12181,'no','Til',0),(438498,12181,'da','Til',0),(438499,12181,'ko','ë°›ëŠ” ì‚¬ëžŒ',0),(438500,12181,'he','×›×“×™',0),(438501,12181,'el','ÎÎ±',0),(438502,12181,'zh','ä¸Šé™',0),(438503,12181,'sv','Till',0),(438504,12181,'it','A',0),(438505,12181,'tl','',0),(438506,12181,'th','à¸–à¸¶à¸‡',0),(438507,12181,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(438508,12181,'ms','Untuk',0),(438509,12181,'ar','Ø¥Ù„Ù‰',0),(438510,12181,'fr','Ã€',0),(438511,12181,'jp','å®›å…ˆ',0),(438512,12181,'pt','Para',0),(438513,12181,'ru','ÐšÐ¾Ð¼Ñƒ',0),(438514,12181,'es','Tapar',0),(438515,12181,'de','An',0),(438516,12181,'en','To',0),(438517,12182,'is','',0),(438518,12182,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©',0),(438519,12182,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©',0),(438520,12182,'tr','Banka hesabÄ± ekleme',0),(438521,12182,'pl','DodaÄ‡ konto bankowe',0),(438522,12182,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(438523,12182,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(438524,12182,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(438525,12182,'vi','ThÃªm TÃ i Khoáº£n ngÃ¢n hÃ ng',0),(438526,12182,'af','Bankrekening Byvoeg',0),(438527,12182,'ro','AdÄƒugaÅ£i contul bancar',0),(438528,12182,'et','Panga konto lisamine',0),(438529,12182,'si','Dodati banÄni raÄun',0),(438530,12182,'ba','Menambahkan rekening Bank',0),(438531,12182,'nl','Bank Account toevoegen',0),(438532,12182,'fi','LisÃ¤Ã¤ pankkitili',0),(438533,12182,'no','Legge til bankkonto',0),(438534,12182,'da','TilfÃ¸je bankkonto',0),(438535,12182,'ko','ì€í–‰ ê³„ì¢Œë¥¼ ì¶”ê°€',0),(438536,12182,'he','×”×•×¡×£ ××ª ×—×©×‘×•×Ÿ ×”×‘× ×§',0),(438537,12182,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(438538,12182,'zh','å¢žåŠ é“¶è¡Œè´¦æˆ·',0),(438539,12182,'sv','LÃ¤gga till bankkonto',0),(438540,12182,'it','Aggiungi conto bancario',0),(438541,12182,'tl','',0),(438542,12182,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£',0),(438543,12182,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(438544,12182,'ms','Tambah akaun Bank',0),(438545,12182,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ',0),(438546,12182,'fr','Ajouter un compte de banque',0),(438547,12182,'jp','éŠ€è¡Œå£åº§ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(438548,12182,'pt','Adicionar a conta bancÃ¡ria',0),(438549,12182,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(438550,12182,'es','Agregar Cuenta Bancaria',0),(438551,12182,'de','Bank-Konto hinzufÃ¼gen',0),(438552,12182,'en','Add Bank Account',0),(438553,12183,'is','',0),(438554,12183,'dr','Ø´Ú©Ù„ Ø¯Ø§Ø¯Ù† Ø¨Ù‡ Ø§Ù†ÙˆØ§Ø¹ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(438555,12183,'pr','Ø´Ú©Ù„ Ø¯Ø§Ø¯Ù† Ø¨Ù‡ Ø§Ù†ÙˆØ§Ø¹ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(438556,12183,'tr','Bordro vergi tÃ¼rleri yapÄ±landÄ±rÄ±n',0),(438557,12183,'pl','SkonfigurowaÄ‡ rodzaj podatku od pÅ‚ac',0),(438558,12183,'bg','ÐšÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð´Ð°Ð½ÑŠÐº Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(438559,12183,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù¹ÛŒÚ©Ø³ Ø§Ù‚Ø³Ø§Ù… Ú©ÛŒ ØªØ´Ú©ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(438560,12183,'sr','ÐšÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð¸ÑÐ°ÑšÐµ Ñ‚Ð¸Ð¿Ð° Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ',0),(438561,12183,'vi','cÃ¡c loáº¡i thuáº¿ lÆ°Æ¡ng',0),(438562,12183,'af','Konfigureer heeltydse belasting tipes',0),(438563,12183,'ro','Configurare tipuri de impozit salarii',0),(438564,12183,'et','Palgafondi maksu konfigureerida',0),(438565,12183,'si','Nastavite vrste davka na izplaÄane plaÄe',0),(438566,12183,'ba','Mengkonfigurasi penggajian pajak jenis',0),(438567,12183,'nl','Payroll belastingen typen configureren',0),(438568,12183,'fi','MÃ¤Ã¤ritÃ¤ Palkanlaskenta verolajit',0),(438569,12183,'no','Konfigurere lÃ¸nn skatt typer',0),(438570,12183,'da','Konfigurere Payroll Tax typer',0),(438571,12183,'ko','ê¸‰ì—¬ ì„¸ê¸ˆ ì¢…ë¥˜ êµ¬ì„±',0),(438572,12183,'he','×§×‘×™×¢×ª ×ª×¦×•×¨×” ×©×œ ×¡×•×’×™ ×ž×¡ ×©×›×¨',0),(438573,12183,'el','Î¡Ï…Î¸Î¼Î¯ÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Î¼Î¿ÏÏ†Î­Ï‚ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¯Î±Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(438574,12183,'zh','é…ç½®å·¥è–ªè¡¨ç¨Žæ”¶ç±»åž‹',0),(438575,12183,'sv','Konfigurera lÃ¶nelistan momstyper',0),(438576,12183,'it','Configurare i tipi di tasse sui salari',0),(438577,12183,'tl','',0),(438578,12183,'th','à¸à¸³à¸«à¸™à¸”à¸Šà¸™à¸´à¸”à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸ à¸²à¸©à¸µ',0),(438579,12183,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‹ à¤•à¥‰à¤¨à¥à¤«à¤¼à¤¿à¤—à¤° à¤•à¤°à¥‡à¤‚',0),(438580,12183,'ms','Konfigurasi jenis cukai gaji',0),(438581,12183,'ar','ØªÙƒÙˆÙŠÙ† Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø¹Ù„Ù‰ Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(438582,12183,'fr','Configurer les Types de taxe sur la paie',0),(438583,12183,'jp','çµ¦ä¸Žç¨Žã®ç¨®é¡žã‚’æ§‹æˆã—ã¾ã™ã€‚',0),(438584,12183,'pt','Configurar tipos de imposto de folha de pagamento',0),(438585,12183,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(438586,12183,'es','Configurar Tipos de Impuestos Para La Nomina',0),(438587,12183,'de','Payroll-Tax-Typen zu konfigurieren',0),(438588,12183,'en','Configure Payroll Tax Types',0),(438589,12184,'is','',0),(438590,12184,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(438591,12184,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(438592,12184,'tr','Fatura GL Accts ayarla',0),(438593,12184,'pl','Konfigurowanie fakturowania Accts GL',0),(438594,12184,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ GL Accts',0),(438595,12184,'ur','Ø¬ÛŒØ¬Û’ Ø¨Ù„Ù†Ú¯ Ø§Ú©Ú©ØªØ³ Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(438596,12184,'sr','ÐŸÐ¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ ÐÑ†Ñ†Ñ‚Ñ Ð“Ð›',0),(438597,12184,'vi','Thiáº¿t láº­p cÃ¡c tÃ i khoáº£n thanh toÃ¡n',0),(438598,12184,'af','Fakturering GL Accts opstel',0),(438599,12184,'ro','ÃŽnfiinÅ£at de facturare GL Accts',0),(438600,12184,'et','Saate seadistada arvete GL Accts',0),(438601,12184,'si','Nastavite zaraÄunavanje GL Accts',0),(438602,12184,'ba','Mengatur penagihan GL Accts',0),(438603,12184,'nl','Billing GL Accts instellen',0),(438604,12184,'fi','MÃ¤Ã¤ritÃ¤ laskutus GL Accts',0),(438605,12184,'no','Definere fakturering GL Accts',0),(438606,12184,'da','Konfigurere fakturering GL Accts',0),(438607,12184,'ko','GL Accts ê²°ì œ ì„¤ì •',0),(438608,12184,'he','×œ×”×’×“×™×¨ ×—×™×•×‘ GL Accts',0),(438609,12184,'el','ÎˆÏ‡ÎµÎ¹ ÏƒÏ…ÏƒÏ„Î±Î¸ÎµÎ¯ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚ GL Accts',0),(438610,12184,'zh','è®¾ç½®å…¥è´¦æ€»å¸å¸æˆ·',0),(438611,12184,'sv','StÃ¤ll in fakturering GL Accts',0),(438612,12184,'it','Impostare fatturazione Accts GL',0),(438613,12184,'tl','',0),(438614,12184,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™ GL Accts',0),(438615,12184,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— GL Accts à¤Šà¤ªà¤° à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(438616,12184,'ms','Sediakan bil GL Accts',0),(438617,12184,'ar','Ù‚Ù… Ø¨Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Accts GL',0),(438618,12184,'fr','Mettre en place la facturation GL Accts',0),(438619,12184,'jp','è«‹æ±‚ GL Accts ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(438620,12184,'pt','Configurar faturamento GL Accts',0),(438621,12184,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³Ð° GL Accts',0),(438622,12184,'es','Configurar Cuentas LM de FacturaciÃ³n',0),(438623,12184,'de','Billing GL Accts einrichten',0),(438624,12184,'en','Set up Billing GL Accts',0),(438625,12185,'is','',0),(438626,12185,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ø­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(438627,12185,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ø­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(438628,12185,'tr','BorÃ§lar GL Accts ayarla',0),(438629,12185,'pl','UmieszczaÃ¦ w gÃ³rze zobowiÄ…zania GL Accts',0),(438630,12185,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ñ‚ Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ GL Accts',0),(438631,12185,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø¬ÛŒØ¬Û’ Ø§Ú©Ú©ØªØ³ Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(438632,12185,'sr','ÐŸÐ¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð“Ð› ÐÑ†Ñ†Ñ‚Ñ',0),(438633,12185,'vi','Thiáº¿t láº­p cÃ¡c tÃ i khoáº£n pháº£i tráº£',0),(438634,12185,'af','Waardedalingstoetse GL Accts opstel',0),(438635,12185,'ro','ÃŽnfiinÅ£at datorii GL Accts',0),(438636,12185,'et','Saate seadistada vÃµlad GL Accts',0),(438637,12185,'si','Nastavite obveznosti GL Accts',0),(438638,12185,'ba','Mengatur hutang GL Accts',0),(438639,12185,'nl','Schulden GL Accts instellen',0),(438640,12185,'fi','MÃ¤Ã¤ritÃ¤ ostojen GL Accts',0),(438641,12185,'no','Definere leverandÃ¸rgjeld GL Accts',0),(438642,12185,'da','OpsÃ¦tning af Kreditorstyring GL Accts',0),(438643,12185,'ko','ë¯¸ì§€ê¸‰ê¸ˆ GL Accts ì„¤ì •',0),(438644,12185,'he','×œ×”×’×“×™×¨ ×–×›××™× GL Accts',0),(438645,12185,'el','ÎˆÏ‡ÎµÎ¹ ÏƒÏ…ÏƒÏ„Î±Î¸ÎµÎ¯ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ GL Accts',0),(438646,12185,'zh','è®¾ç½®åº”ä»˜æ€»å¸å¸æˆ·',0),(438647,12185,'sv','StÃ¤ll in leverantÃ¶rsskulder GL Accts',0),(438648,12185,'it','Impostare i debiti GL Accts',0),(438649,12185,'tl','',0),(438650,12185,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸› Accts',0),(438651,12185,'hi','à¤¸à¥‡à¤Ÿ à¤…à¤ª Payables GL Accts',0),(438652,12185,'ms','Sediakan Accts GL pemiutang',0),(438653,12185,'ar','Ù‚Ù… Ø¨Ø¥Ø¹Ø¯Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹ GL Accts',0),(438654,12185,'fr','Mettre en place des comptes fournisseurs GL Accts',0),(438655,12185,'jp','è²·æŽ›é‡‘ GL Accts ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(438656,12185,'pt','Configurar contas a pagar GL Accts',0),(438657,12185,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÑÑ‡ÐµÑ‚Ð¾Ð² ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ GL',0),(438658,12185,'es','Configurar Cuentas LM de Pagables',0),(438659,12185,'de','Verbindlichkeiten GL Accts einrichten',0),(438660,12185,'en','Set up Payables GL Accts',0),(438661,12186,'is','',0),(438662,12186,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ÛŒ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(438663,12186,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ÛŒ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(438664,12186,'tr','Stok GL Accts ayarla',0),(438665,12186,'pl','Konfigurowanie magazynu GL Accts',0),(438666,12186,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚Ðµ ÑÐºÐ»Ð°Ð´Ð° GL Accts',0),(438667,12186,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ú©ØªØ³ Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(438668,12186,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð“Ð› ÐÑ†Ñ†Ñ‚Ñ',0),(438669,12186,'vi','Thiáº¿t láº­p cÃ¡c tÃ i khoáº£n hÃ ng tá»“n kho',0),(438670,12186,'af','Inventaris GL Accts opstel',0),(438671,12186,'ro','ÃŽnfiinÅ£at inventar GL Accts',0),(438672,12186,'et','Saate seadistada lao GL Accts',0),(438673,12186,'si','Vzpostaviti popis GL Accts',0),(438674,12186,'ba','Mengatur persediaan GL Accts',0),(438675,12186,'nl','Inventaris GL Accts instellen',0),(438676,12186,'fi','MÃ¤Ã¤ritÃ¤ varaston GL Accts',0),(438677,12186,'no','Definere lageret GL Accts',0),(438678,12186,'da','OpsÃ¦tning af lagerbeholdning GL Accts',0),(438679,12186,'ko','ìž¬ê³  GL Accts ì„¤ì •',0),(438680,12186,'he','×”×’×“×¨×ª ×ž×œ××™ GL Accts',0),(438681,12186,'el','ÎˆÏ‡ÎµÎ¹ ÏƒÏ…ÏƒÏ„Î±Î¸ÎµÎ¯ Î±Ï€Î¿Î³ÏÎ±Ï†Î® GL Accts',0),(438682,12186,'zh','è®¾ç½®åº“å­˜æ€»å¸è´¦ç›®',0),(438683,12186,'sv','StÃ¤ll in lagret GL Accts',0),(438684,12186,'it','Impostare inventario GL Accts',0),(438685,12186,'tl','',0),(438686,12186,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡ GL Accts',0),(438687,12186,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ GL Accts à¤Šà¤ªà¤° à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(438688,12186,'ms','Sediakan inventori GL Accts',0),(438689,12186,'ar','Ù‚Ù… Ø¨Ø¥Ø¹Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø¬Ø±Ø¯ GL Accts',0),(438690,12186,'fr','Mettre en place l\'inventaire GL Accts',0),(438691,12186,'jp','åœ¨åº« GL Accts ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(438692,12186,'pt','Configurar inventÃ¡rio GL Accts',0),(438693,12186,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ ÑÑ‡ÐµÑ‚Ð¾Ð² GL',0),(438694,12186,'es','Configurar Cuentas LM de Inventario',0),(438695,12186,'de','Inventar GL Accts einrichten',0),(438696,12186,'en','Set up Inventory GL Accts',0),(438697,12187,'is','',0),(438698,12187,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(438699,12187,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(438700,12187,'tr','Bordro GL Accts ayarla',0),(438701,12187,'pl','Konfigurowanie pÅ‚ac GL Accts',0),(438702,12187,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚Ðµ Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ñ‚Ð° GL Accts',0),(438703,12187,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ø¬ÛŒØ¬Û’ Ø§Ú©Ú©ØªØ³ Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(438704,12187,'sr','ÐŸÐ¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð“Ð› ÐÑ†Ñ†Ñ‚Ñ',0),(438705,12187,'vi','Thiáº¿t láº­p cÃ¡c tÃ i khoáº£n lÆ°Æ¡ng',0),(438706,12187,'af','Salarisstelsel GL Accts opstel',0),(438707,12187,'ro','ÃŽnfiinÅ£at de salarizare GL Accts',0),(438708,12187,'et','Saate seadistada palgaarvestuse GL Accts',0),(438709,12187,'si','Nastavite Payroll GL Accts',0),(438710,12187,'ba','Mengatur penggajian GL Accts',0),(438711,12187,'nl','Payroll GL Accts instellen',0),(438712,12187,'fi','MÃ¤Ã¤ritÃ¤ Palkanlaskenta GL Accts',0),(438713,12187,'no','Definer lÃ¸nn GL Accts',0),(438714,12187,'da','Oprette lÃ¸nningslisten GL Accts',0),(438715,12187,'ko','ê¸‰ì—¬ GL Accts ì„¤ì •',0),(438716,12187,'he','×”×’×“×¨×ª ×©×›×¨ GL Accts',0),(438717,12187,'el','ÎˆÏ‡ÎµÎ¹ ÏƒÏ…ÏƒÏ„Î±Î¸ÎµÎ¯ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ GL Accts',0),(438718,12187,'zh','è®¾ç½®è–ªé…¬æ€»å¸è´¦ç›®',0),(438719,12187,'sv','StÃ¤ll in lÃ¶nelistan GL Accts',0),(438720,12187,'it','Impostare Payroll GL Accts',0),(438721,12187,'tl','',0),(438722,12187,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡ GL Accts',0),(438723,12187,'hi','à¤¸à¥‡à¤Ÿ à¤…à¤ª à¤ªà¥‡à¤°à¥‹à¤² GL Accts',0),(438724,12187,'ms','Menyediakan senarai gaji GL Accts',0),(438725,12187,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª GL Accts',0),(438726,12187,'fr','Mis en place sur la paie GL Accts',0),(438727,12187,'jp','çµ¦ä¸Ž GL Accts ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(438728,12187,'pt','Configurar a folha de pagamento GL Accts',0),(438729,12187,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÑÑ‡ÐµÑ‚Ð¾Ð² Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ GL',0),(438730,12187,'es','Configurar la NÃ³mina y Las Cuentas de LM',0),(438731,12187,'de','Personalabrechnung GL Accts einrichten',0),(438732,12187,'en','Set up Payroll GL Accts',0),(438733,12188,'is','',0),(438734,12188,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(438735,12188,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(438736,12188,'tr','Yeni kullanÄ±cÄ± grubu ekleme',0),(438737,12188,'pl','Dodaj nowe grupy uÅ¼ytkownikÃ³w',0),(438738,12188,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(438739,12188,'ur','Ù†ÛŒØ§ ØµØ§Ø±Ù Ú¯Ø±ÙˆÙ¾ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(438740,12188,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð³Ñ€ÑƒÐ¿Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(438741,12188,'vi','ThÃªm nhÃ³m ngÆ°á»i sá»­ dá»¥ng má»›i',0),(438742,12188,'af','Voeg nuwe gebruiker groep',0),(438743,12188,'ro','Adauga grup nou de utilizator',0),(438744,12188,'et','Lisa uus grupp',0),(438745,12188,'si','Dodajte nove skupine uporabnikov',0),(438746,12188,'ba','Menambahkan grup pengguna baru',0),(438747,12188,'nl','Toevoegen van nieuwe gebruiker groep',0),(438748,12188,'fi','LisÃ¤Ã¤ uusi kÃ¤yttÃ¤jÃ¤ryhmÃ¤',0),(438749,12188,'no','Legg til ny gruppe',0),(438750,12188,'da','TilfÃ¸je nye brugergruppe',0),(438751,12188,'ko','ìƒˆ ì‚¬ìš©ìž ê·¸ë£¹ì„ ì¶”ê°€',0),(438752,12188,'he','×”×•×¡×£ ×§×‘×•×¦×ª ×ž×©×ª×ž×©×™× ×—×“×©×™×',0),(438753,12188,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î¿Î¼Î¬Î´Î± Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½',0),(438754,12188,'zh','å¢žåŠ æ–°ç”¨æˆ·ç»„',0),(438755,12188,'sv','LÃ¤gg till ny anvÃ¤ndare grupp',0),(438756,12188,'it','Aggiungi nuovo gruppo utente',0),(438757,12188,'tl','',0),(438758,12188,'th','à¹€à¸žà¸´à¹ˆà¸¡ à¸à¸¥à¸¸à¹ˆà¸¡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹ƒà¸«à¸¡à¹ˆ',0),(438759,12188,'hi','à¤¨à¤ˆ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¤®à¥‚à¤¹ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(438760,12188,'ms','Tambah kumpulan pengguna baru',0),(438761,12188,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¬Ø¯ÙŠØ¯Ø© Ù…Ù† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(438762,12188,'fr','Ajouter le nouveau groupe d\'utilisateurs',0),(438763,12188,'jp','æ–°ã—ã„ãƒ¦ãƒ¼ã‚¶ãƒ¼ ã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(438764,12188,'pt','Adicionar novo grupo de usuÃ¡rios',0),(438765,12188,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð³Ñ€ÑƒÐ¿Ð¿Ñƒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(438766,12188,'es','Agregar un Nuevo Grupo de Usuarios',0),(438767,12188,'de','Neue Benutzergruppe hinzufÃ¼gen',0),(438768,12188,'en','Add New User Group',0),(438769,12189,'is','',0),(438770,12189,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(438771,12189,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(438772,12189,'tr','Yeni kullanÄ±cÄ± haklarÄ± grubu ekleme',0),(438773,12189,'pl','Dodaj nowe grupy praw uÅ¼ytkownika',0),(438774,12189,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ñ€Ð°Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(438775,12189,'ur','Ù†ÛŒØ§ ØµØ§Ø±Ù Ø­Ù‚ÙˆÙ‚ Ú¯Ø±ÙˆÙ¾ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(438776,12189,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð³Ñ€ÑƒÐ¿Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¿Ñ€Ð°Ð²Ð°',0),(438777,12189,'vi','PhÃ¢m quyá»n nhÃ³m',0),(438778,12189,'af','Voeg nuwe gebruiker regte groep',0),(438779,12189,'ro','Adauga grup nou de drepturi de utilizator',0),(438780,12189,'et','Uue kasutaja Ãµiguste rÃ¼hma lisamine',0),(438781,12189,'si','Dodajte nove uporabniÅ¡ke pravice skupine',0),(438782,12189,'ba','Menambahkan grup hak pengguna baru',0),(438783,12189,'nl','Nieuwe gebruiker rechten groep toevoegen',0),(438784,12189,'fi','LisÃ¤Ã¤ uuden kÃ¤yttÃ¤jÃ¤ryhmÃ¤n oikeudet',0),(438785,12189,'no','Legg til ny rettigheter gruppe',0),(438786,12189,'da','TilfÃ¸j ny bruger rettigheder gruppe',0),(438787,12189,'ko','ìƒˆ ì‚¬ìš©ìž ê¶Œí•œ ê·¸ë£¹ì„ ì¶”ê°€',0),(438788,12189,'he','×”×•×¡×£ ×§×‘×•×¦×” ×—×“×©×” ×©×œ ×–×›×•×™×•×ª ×ž×©×ª×ž×©',0),(438789,12189,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î¿Î¼Î¬Î´Î± Î´Î¹ÎºÎ±Î¹Ï‰Î¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÏ„Î·',0),(438790,12189,'zh','å¢žåŠ æ–°ç”¨æˆ·æƒé™ç»„',0),(438791,12189,'sv','LÃ¤gg till ny anvÃ¤ndare rÃ¤ttigheter grupp',0),(438792,12189,'it','Aggiungi nuovo gruppo per i diritti dell\'utente',0),(438793,12189,'tl','',0),(438794,12189,'th','à¹€à¸žà¸´à¹ˆà¸¡ à¸à¸¥à¸¸à¹ˆà¸¡à¸ªà¸´à¸—à¸˜à¸´à¹Œà¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹ƒà¸«à¸¡à¹ˆ',0),(438795,12189,'hi','à¤¨à¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤®à¥‚à¤¹ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(438796,12189,'ms','Tambah Kumpulan hak pengguna baru',0),(438797,12189,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¬Ø¯ÙŠØ¯Ø© Ù…Ù† Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(438798,12189,'fr','Ajouter le nouveau groupe de droits de l\'utilisateur',0),(438799,12189,'jp','æ–°ã—ã„ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©é™ã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(438800,12189,'pt','Adicionar novo grupo de direitos de usuÃ¡rio',0),(438801,12189,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð³Ñ€ÑƒÐ¿Ð¿Ñƒ Ð¿Ñ€Ð°Ð² Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(438802,12189,'es','Agregar un Nuevo Grupo de Derechos de Usuarios',0),(438803,12189,'de','Neue Benutzer Rechte Gruppe hinzufÃ¼gen',0),(438804,12189,'en','Add New User Rights Group',0),(438805,12190,'is','',0),(438806,12190,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø­Ø°Ù Ù…Ø¯ÛŒØ± Ù†ÛŒØ³Øª',0),(438807,12190,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø­Ø°Ù Ù…Ø¯ÛŒØ± Ù†ÛŒØ³Øª',0),(438808,12190,'tr','Admin silemezsiniz',0),(438809,12190,'pl','Nie moÅ¼na usunÄ…Ä‡ Admin',0),(438810,12190,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ðµ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€',0),(438811,12190,'ur','Ø§ÛŒÚˆÙ…Ù† Ø­Ø°Ù Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(438812,12190,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ ÐÐ´Ð¼Ð¸Ð½',0),(438813,12190,'vi','KhÃ´ng thá»ƒ xÃ³a quáº£n lÃ½',0),(438814,12190,'af','Kan nie skrap Admin',0),(438815,12190,'ro','Imposibil de È™ters Admin',0),(438816,12190,'et','Ei saa kustutada Admin',0),(438817,12190,'si','Ne morete izbrisati Admin',0),(438818,12190,'ba','Tidak dapat menghapus Admin',0),(438819,12190,'nl','Admin verwijderen niet',0),(438820,12190,'fi','Poistaa Admin',0),(438821,12190,'no','Kan ikke slette Admin',0),(438822,12190,'da','Kan ikke slette Admin',0),(438823,12190,'ko','ê´€ë¦¬ìžë¥¼ ì‚­ì œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(438824,12190,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×ž×—×•×§ Admin',0),(438825,12190,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÎ¹ Ï„Î¿ Admin',0),(438826,12190,'zh','ä¸èƒ½åˆ é™¤ç®¡ç†',0),(438827,12190,'sv','Kan inte ta bort Admin',0),(438828,12190,'it','Non Ã¨ possibile eliminare l\'Admin',0),(438829,12190,'tl','',0),(438830,12190,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸¥à¸š Admin',0),(438831,12190,'hi','à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¹à¤Ÿà¤¾à¤¤à¥‡ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(438832,12190,'ms','Tidak dapat menghapuskan Admin',0),(438833,12190,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø­Ø°Ù Ø§Ù„Ù…Ø´Ø±Ù',0),(438834,12190,'fr','Impossible de supprimer Admin',0),(438835,12190,'jp','ç®¡ç†è€…ã‚’å‰Šé™¤ã§ãã¾ã›ã‚“ã€‚',0),(438836,12190,'pt','NÃ£o Ã© possÃ­vel excluir Admin',0),(438837,12190,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð°',0),(438838,12190,'es','No se Puede Eliminar Admin',0),(438839,12190,'de','Admin kann nicht gelÃ¶scht werden.',0),(438840,12190,'en','Cannot Delete Admin',0),(438841,12191,'is','',0),(438842,12191,'dr','-Ø¨Ø±Ø§ÛŒ Ù¾Ø±ÛŒÙ†Øª Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(438843,12191,'pr','Ú†Ú© Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª-Ø¨Ø±Ø§ÛŒ Ù¾Ø±ÛŒÙ†Øª Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(438844,12191,'tr','OluÅŸturulan - onay yazdÄ±rmak iÃ§in tÄ±klayÄ±n',0),(438845,12191,'pl','Wyboru generowany - kliknij, aby wydrukowaÄ‡',0),(438846,12191,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸ - Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(438847,12191,'ur','Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº Ù¾Ø±Ù†Ù¹ Ú©Ø±Ù†Û’ Ø¨Ù†Ø§Ø¦ÛŒ-',0),(438848,12191,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð³ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ð½Ðµ - ÐºÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(438849,12191,'vi','SÃ©c Ä‘Ã£ táº¡o  vÃ  nháº¥n Ä‘á»ƒ in',0),(438850,12191,'af','Kontroleer Gegenereerde - Klik om te Druk',0),(438851,12191,'ro','Selectare generat - faceÅ£i clic pe Print',0),(438852,12191,'et','Sisse tekkinud - nuppu Prindi',0),(438853,12191,'si','Preverite ustvarjene - kliknite Print',0),(438854,12191,'ba','Check dihasilkan - klik untuk cetak',0),(438855,12191,'nl','Selectievakje gegenereerd - Klik om af te drukken',0),(438856,12191,'fi','Uloskirjautuminen syntyy - napsauttamalla Tulosta',0),(438857,12191,'no','Sjekk generert - Klikk for Ã¥ skrive ut',0),(438858,12191,'da','Check genereret - Klik for at udskrive',0),(438859,12191,'ko','í™•ì¸ ìƒì„±-í´ë¦­ í•˜ ì—¬ ì¸ì‡„',0),(438860,12191,'he','×”×¡×™×ž×•×Ÿ ×©× ×•×¦×¨ - ×œ×—×¥ ×¢×œ ×”×“×¤×¡',0),(438861,12191,'el','Î•Î»Î­Î³Ï‡Î¿Ï… Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½Ï„Î±Î¹ - ÎºÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(438862,12191,'zh','æ£€æŸ¥äº§ç”Ÿ-ç‚¹å‡»æ‰“å°',0),(438863,12191,'sv','Kontrollera genereras - Klicka fÃ¶r att skriva ut',0),(438864,12191,'it','Controllo generato - Clicca per la stampa',0),(438865,12191,'tl','',0),(438866,12191,'th','à¸à¸²à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¸ªà¸£à¹‰à¸²à¸‡ - à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­à¸žà¸´à¸¡à¸žà¹Œ',0),(438867,12191,'hi','à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ - à¤šà¥‡à¤• à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤¹à¥‡à¤¤à¥ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(438868,12191,'ms','Semak dihasilkan - klik untuk cetak',0),(438869,12191,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ÙˆÙ„Ø¯Øª--Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(438870,12191,'fr','Enregistrement produit - Cliquez ici pour imprimer',0),(438871,12191,'jp','ç”Ÿæˆ - ãƒã‚§ãƒƒã‚¯ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦å°åˆ·ã™ã‚‹',0),(438872,12191,'pt','Cheque gerado - clique para imprimir',0),(438873,12191,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÐ¾Ð·Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ - Ð½Ð°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(438874,12191,'es','Cheque Generado - Hace Clik Par Imprimir',0),(438875,12191,'de','KontrollkÃ¤stchen erzeugt - klicken Sie auf Drucken',0),(438876,12191,'en','Check Generated - Click to Print',0),(438877,12192,'is','',0),(438878,12192,'dr','Ø­Ø§Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ÙˆÛŒØ±Ø§ÛŒØ´',0),(438879,12192,'pr','Ø­Ø§Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ÙˆÛŒØ±Ø§ÛŒØ´',0),(438880,12192,'tr','Nakliye gemisi DÃ¼zenle',0),(438881,12192,'pl','Edytuj, przewoÅºnik',0),(438882,12192,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(438883,12192,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ø´Ù¾Ù†Ú¯ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(438884,12192,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð½Ð¾ÑÐ°Ñ‡ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(438885,12192,'vi','Chá»‰nh sá»­a váº­n chuyá»ƒn tÃ u sÃ¢n bay',0),(438886,12192,'af','Redigeer draer gestuur',0),(438887,12192,'ro','Editare de transport maritim de transport',0),(438888,12192,'et','Redigeeri Shipping vedaja',0),(438889,12192,'si','Urejanje ladijskega prevoznika',0),(438890,12192,'ba','Mengedit pengiriman Carrier',0),(438891,12192,'nl','Bewerken verzending van vervoerder',0),(438892,12192,'fi','Muokkaa lÃ¤hetyksen rahdinkuljettaja',0),(438893,12192,'no','Redigere frakt Carrier',0),(438894,12192,'da','Redigere Shipping transportvirksomhed',0),(438895,12192,'ko','ìºë¦¬ì–´ ë°°ì†¡ íŽ¸ì§‘',0),(438896,12192,'he','×¢×¨×™×›×ª ×”×ž×©×œ×•×— × ×•×©××ª',0),(438897,12192,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î½Î±Ï…Ï„Î¹Î»Î¯Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(438898,12192,'zh','ç¼–è¾‘è£…è¿æ‰¿è¿äºº',0),(438899,12192,'sv','Redigera frakt bÃ¤rare',0),(438900,12192,'it','Modificare il vettore di spedizione',0),(438901,12192,'tl','',0),(438902,12192,'th','à¹à¸à¹‰à¹„à¸‚à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸šà¸£à¸´à¸©à¸±à¸—à¸‚à¸™à¸ªà¹ˆà¸‡',0),(438903,12192,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¥ˆà¤°à¤¿à¤¯à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(438904,12192,'ms','Edit penghantaran pembawa',0),(438905,12192,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù†Ø§Ù‚Ù„',0),(438906,12192,'fr','Modifier la livraison transporteur',0),(438907,12192,'jp','ã‚­ãƒ£ãƒªã‚¢ã®é€æ–™ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(438908,12192,'pt','Editar transporte transportadora',0),(438909,12192,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸ÐºÐ¾Ð¼',0),(438910,12192,'es','Editar portador de envÃ­o',0),(438911,12192,'de','Bearbeiten, Versand',0),(438912,12192,'en','Edit Shipping Carrier',0),(438913,12193,'is','',0),(438914,12193,'dr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø¯ÙˆØ±Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§ØªÛŒ Ù†Ø¯Ø§Ø±Ø¯',0),(438915,12193,'pr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø¯ÙˆØ±Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§ØªÛŒ Ù†Ø¯Ø§Ø±Ø¯',0),(438916,12193,'tr','Ã‡alÄ±ÅŸan, bu dÃ¶nem iÃ§in veri yok.',0),(438917,12193,'pl','Pracownik ma brak danych dla tego okresu',0),(438918,12193,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¸Ð¼Ð° Ð½ÑÐ¼Ð° Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(438919,12193,'ur','Ù…Ù„Ø§Ø²Ù… Ø§Ø³ Ù…Ø¯Øª Ú©Û’ Ù„Ø¦Û’ Ú©ÙˆØ¦ÛŒ ÚˆÛŒÙ¹Ø§ ÛÛ’ Û”',0),(438920,12193,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¸Ð¼Ð° Ð½ÐµÐ¼Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(438921,12193,'vi','thá»i ká»³ nÃ y nhÃ¢n viÃªn khÃ´ng cÃ³ sá»‘ liá»‡u',0),(438922,12193,'af','Werknemer het geen data vir hierdie tydperk',0),(438923,12193,'ro','Angajatul nu are date pentru aceastÄƒ perioadÄƒ',0),(438924,12193,'et','TÃ¶Ã¶taja ei ole andmeid selle perioodi jaoks',0),(438925,12193,'si','Ima delavec ni podatkov za to obdobje',0),(438926,12193,'ba','Karyawan memiliki tidak ada data untuk periode ini',0),(438927,12193,'nl','Werknemer heeft geen gegevens voor deze periode',0),(438928,12193,'fi','TyÃ¶ntekijÃ¤ ei ole tietoja tÃ¤lle kaudelle',0),(438929,12193,'no','Ansatte har ingen data for denne perioden',0),(438930,12193,'da','Medarbejderen har ingen data for denne periode',0),(438931,12193,'ko','ì§ì›ì´ì´ ê¸°ê°„ì— ëŒ€ í•œ ë°ì´í„°ëŠ”',0),(438932,12193,'he','×œ×¢×•×‘×“ ×™×© × ×ª×•× ×™× ×¢×‘×•×¨ ×ª×§×•×¤×” ×–×•',0),(438933,12193,'el','Î•ÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚ Î­Ï‡ÎµÎ¹ ÎºÎ±Î½Î­Î½Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³Î¹Î± Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(438934,12193,'zh','å‘˜å·¥åœ¨è¿™æ®µæ—¶é—´æ— æ•°æ®',0),(438935,12193,'sv','Medarbetare har inga data fÃ¶r denna period',0),(438936,12193,'it','Dipendente non ha dati per questo periodo',0),(438937,12193,'tl','',0),(438938,12193,'th','à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¹„à¸¡à¹ˆà¸¡à¸µà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸™à¸µà¹‰',0),(438939,12193,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤‡à¤¸ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(438940,12193,'ms','Pekerja mempunyai tiada data bagi tempoh ini',0),(438941,12193,'ar','Ù…ÙˆØ¸Ù Ù„Ø¯ÙŠÙ‡ Ø£ÙŠØ© Ø¨ÙŠØ§Ù†Ø§Øª Ù„Ù‡Ø°Ù‡ Ø§Ù„ÙØªØ±Ø©',0),(438942,12193,'fr','EmployÃ© ne comporte aucune donnÃ©e pour cette pÃ©riode',0),(438943,12193,'jp','å¾“æ¥­å“¡ã¯ã“ã®æœŸé–“ã®é–“ã®ãƒ‡ãƒ¼ã‚¿ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(438944,12193,'pt','Empregado nÃ£o possui dados para este perÃ­odo',0),(438945,12193,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº Ð½Ðµ Ð¸Ð¼ÐµÐµÑ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð·Ð° ÑÑ‚Ð¾Ñ‚ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(438946,12193,'es','El empleado no tiene Datos por este perÃ­odo',0),(438947,12193,'de','Mitarbeiter hat keine Daten fÃ¼r diesen Zeitraum',0),(438948,12193,'en','Employee has no data for this period',0),(438949,12194,'is','',0),(438950,12194,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø·Ø±Ø­',0),(438951,12194,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø·Ø±Ø­',0),(438952,12194,'tr','Plan ekleme hatasÄ±',0),(438953,12194,'pl','BÅ‚Ä…d wstawiania Plan',0),(438954,12194,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½',0),(438955,12194,'ur','Ù…Ù†ØµÙˆØ¨Û Ø¯Ø§Ø®Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(438956,12194,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑƒÐ¼ÐµÑ‚Ð°ÑšÑƒ ÐŸÐ»Ð°Ð½',0),(438957,12194,'vi','Lá»—i khi thÃªm bá»™ pháº­n',0),(438958,12194,'af','Fout invoeging van Plan',0),(438959,12194,'ro','Eroare inserarea Plan',0),(438960,12194,'et','Viga paigaldamisel plaan',0),(438961,12194,'si','Pri vstavljanju naÄrt',0),(438962,12194,'ba','Kesalahan memasukkan rencana',0),(438963,12194,'nl','Error invoegen Plan',0),(438964,12194,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ suunnitelma',0),(438965,12194,'no','Feil under innsetting Plan',0),(438966,12194,'da','Fejl indsÃ¦tte planen',0),(438967,12194,'ko','ê³„íš ì‚½ìž… ì˜¤ë¥˜',0),(438968,12194,'he','×©×’×™××” ×‘×”×•×¡×¤×ª ×ª×•×›× ×™×ª',0),(438969,12194,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏ‡ÎµÎ´Î¯Î¿Ï…',0),(438970,12194,'zh','é”™è¯¯æ’å…¥è®¡åˆ’',0),(438971,12194,'sv','Fel att infoga Plan',0),(438972,12194,'it','Errore inserimento piano',0),(438973,12194,'tl','',0),(438974,12194,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¹à¸—à¸£à¸à¹à¸œà¸™',0),(438975,12194,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾',0),(438976,12194,'ms','Kesilapan memasukkan pelan',0),(438977,12194,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¯Ø±Ø§Ø¬ Ø®Ø·Ø©',0),(438978,12194,'fr','Erreur insertion Plan',0),(438979,12194,'jp','è¨ˆç”»ã®æŒ¿å…¥ã‚¨ãƒ©ãƒ¼',0),(438980,12194,'pt','Erro de inserÃ§Ã£o de plano',0),(438981,12194,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ð»Ð°Ð½',0),(438982,12194,'es','Error Insertando el Plan',0),(438983,12194,'de','Fehler einfÃ¼gen Plan',0),(438984,12194,'en','Error inserting Plan',0),(438985,12195,'is','',0),(438986,12195,'dr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(438987,12195,'pr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(438988,12195,'tr','Ä°ÅŸÃ§i alma baÅŸarÄ±lÄ±',0),(438989,12195,'pl','Pracownik Import sukces',0),(438990,12195,'bg','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(438991,12195,'ur','Ù…Ù„Ø§Ø²Ù… Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø§Ù…ÛŒØ§Ø¨',0),(438992,12195,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ ÑƒÐ²Ð¾Ð·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð°',0),(438993,12195,'vi','Nháº­p nhÃ¢n viÃªn thÃ nh cÃ´ng',0),(438994,12195,'af','Werknemer voer suksesvolle',0),(438995,12195,'ro','Import de angajat de succes',0),(438996,12195,'et','TÃ¶Ã¶taja importimine Ãµnnestus',0),(438997,12195,'si','UspeÅ¡en uvoz zaposlenega',0),(438998,12195,'ba','Karyawan impor sukses',0),(438999,12195,'nl','Werknemer importeren succesvolle',0),(439000,12195,'fi','TyÃ¶ntekijÃ¤n tuonti onnistui',0),(439001,12195,'no','Vellykket Import for ansatte',0),(439002,12195,'da','Medarbejder Import vellykket',0),(439003,12195,'ko','ì§ì› ê°€ì ¸ì˜¤ê¸° ì„±ê³µ',0),(439004,12195,'he','×”×¢×•×‘×“ ×™×™×‘×•× ×ž×•×¦×œ×—',0),(439005,12195,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ ÎµÏ€Î¹Ï„Ï…Ï‡Î®Ï‚',0),(439006,12195,'zh','èŒå·¥å¯¼å…¥æˆåŠŸ',0),(439007,12195,'sv','AnstÃ¤lld importen har slutforts',0),(439008,12195,'it','Importazione dipendente successo',0),(439009,12195,'tl','',0),(439010,12195,'th','à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(439011,12195,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤†à¤¯à¤¾à¤¤ à¤¸à¤«à¤²',0),(439012,12195,'ms','Import pekerja berjaya',0),(439013,12195,'ar','Ø§Ù„Ù…ÙˆØ¸Ù ØªÙ… Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(439014,12195,'fr','EmployÃ© Import rÃ©ussi',0),(439015,12195,'jp','å¾“æ¥­å“¡ãŒæ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã¾ã—ãŸ',0),(439016,12195,'pt','Empregado importaÃ§Ã£o bem sucedida',0),(439017,12195,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸Ðº Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(439018,12195,'es','ImportaciÃ³n de Empleado Exitosa',0),(439019,12195,'de','Mitarbeiter-Import erfolgreich',0),(439020,12195,'en','Employee Import successful',0),(439021,12196,'is','',0),(439022,12196,'dr','Ù„ÛŒØ³Øª Ø±Ø³ÛŒØ¯Ù‡Ø§',0),(439023,12196,'pr','Ù„ÛŒØ³Øª Ø±Ø³ÛŒØ¯Ù‡Ø§',0),(439024,12196,'tr','Liste bilgileri',0),(439025,12196,'pl','Lista wpÅ‚ywÃ³w',0),(439026,12196,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð·Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(439027,12196,'ur','ÙÛØ±Ø³Øª Ú©ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº',0),(439028,12196,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ',0),(439029,12196,'vi','Danh sÃ¡ch thu',0),(439030,12196,'af','Lys kwitansies',0),(439031,12196,'ro','Lista Ã®ncasÄƒri',0),(439032,12196,'et','Saabunud kaupade nimekiri',0),(439033,12196,'si','Seznam prejemki',0),(439034,12196,'ba','Daftar penerimaan',0),(439035,12196,'nl','Lijst ontvangsten',0),(439036,12196,'fi','Luettelo vastaanotot',0),(439037,12196,'no','Listen mottak',0),(439038,12196,'da','Listen kvitteringer',0),(439039,12196,'ko','ëª©ë¡ í™•ì¸',0),(439040,12196,'he','×¨×©×™×ž×ª ×§×‘×œ×•×ª',0),(439041,12196,'el','Î‘Ï€Î±ÏÎ¯Î¸Î¼Î·ÏƒÎ· Ï„Ï‰Î½ ÎµÎ¹ÏƒÏ€ÏÎ±Î¾Î®Ï„Ï‰Î½',0),(439042,12196,'zh','åˆ—å‡ºç¥¨æ®',0),(439043,12196,'sv','Lista kvitton',0),(439044,12196,'it','Elenco ricevute',0),(439045,12196,'tl','',0),(439046,12196,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²',0),(439047,12196,'hi','à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¤¾à¤‚',0),(439048,12196,'ms','Senarai resit',0),(439049,12196,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ù‚Ø¨ÙˆØ¶Ø§Øª',0),(439050,12196,'fr','Liste recettes',0),(439051,12196,'jp','é ˜åŽæ›¸ã®ãƒªã‚¹ãƒˆ',0),(439052,12196,'pt','Lista de receitas',0),(439053,12196,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ð¹',0),(439054,12196,'es','Listar Recibos',0),(439055,12196,'de','Liste Quittungen',0),(439056,12196,'en','List Receipts',0),(439057,12197,'is','',0),(439058,12197,'dr','Ø¨Ø§ÛŒØ¯ Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª ÙˆÚ©Ù„Ø§Ø³Ù‡Ø§ Ù‚Ø¨Ù„ Ø§Ø² ÙˆØ±ÙˆØ¯ Ù†Ø±Ø® Ù‡Ø§ ÙˆØ§Ø±Ø¯ Ø´ÙˆØ¯',0),(439059,12197,'pr','Ø¨Ø§ÛŒØ¯ Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª ÙˆÚ©Ù„Ø§Ø³Ù‡Ø§ Ù‚Ø¨Ù„ Ø§Ø² ÙˆØ±ÙˆØ¯ Ù†Ø±Ø® Ù‡Ø§ ÙˆØ§Ø±Ø¯ Ø´ÙˆØ¯',0),(439060,12197,'tr','Hizmet tÃ¼rleri ve sÄ±nÄ±flar oranlarÄ± girmeden Ã¶nce girmeniz gerekir',0),(439061,12197,'pl','WprowadziÄ‡ przed wejÅ›ciem cena usÅ‚ugi typÃ³w i klas',0),(439062,12197,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð¸Ð´Ð¾Ð²ÐµÑ‚Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸ Ð¸ ÐºÐ»Ð°ÑÐ¾Ð²Ðµ Ð¿Ñ€ÐµÐ´Ð¸ Ð²ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¸',0),(439063,12197,'ur','Ø®Ø¯Ù…Ø§Øª Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù… Ø§ÙˆØ± Ú©Ù„Ø§Ø³ÙˆÚº Ú©ÛŒ Ø´Ø±Ø­ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ ÛÙˆÙ†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(439064,12197,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑÐµÑ€Ð²Ð¸ÑÐ° Ð²Ñ€ÑÑ‚Ðµ Ð¸ ÐºÐ»Ð°ÑÐµ Ð¿Ñ€Ðµ ÑƒÐ»Ð°ÑÐºÐ° Ñƒ ÑÑ‚Ð¾Ð¿Ðµ',0),(439065,12197,'vi','pháº£i thÃªm loáº¡i dá»‹ch vá»¥ vÃ  háº¡ng dá»‹ch vá»¥ trÆ°á»›c khi ghi tá»· lá»‡',0),(439066,12197,'af','Moet intik diens tipes en klasse aangaan tariewe',0),(439067,12197,'ro','Trebuie sÄƒ introduceÅ£i imagini tipuri ÅŸi clase Ã®nainte de a intra ratele',0),(439068,12197,'et','Saate sisestada teenuse tÃ¼Ã¼bid ja klassid, enne sisenemist mÃ¤Ã¤rad',0),(439069,12197,'si','Vnesti morate vrste storitev in razrede pred vstopom stopnje',0),(439070,12197,'ba','Harus memasukkan tipe layanan dan kelas sebelum masuk suku',0),(439071,12197,'nl','Servicetypen en klassen moet invoeren alvorens tarieven',0),(439072,12197,'fi','Kirjoita palvelutyypit ja tunteja ennen kuin tulevat hinnat',0),(439073,12197,'no','MÃ¥ angi typer tjenester og klasser fÃ¸r priser',0),(439074,12197,'da','Skal indtaste servicetyper og klasser fÃ¸r indtastning priser',0),(439075,12197,'ko','ì„œë¹„ìŠ¤ ì¢…ë¥˜ ë° í´ëž˜ìŠ¤ ìš”ê¸ˆì„ ìž…ë ¥ í•˜ê¸° ì „ì— ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(439076,12197,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×¡×•×’×™ ×”×©×™×¨×•×ª×™× ×•×©×™×¢×•×¨×™ ×œ×¤× ×™ ×”×›× ×™×¡×” ×”×ž×—×™×¨×™×',0),(439077,12197,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„ÏÏ€Î¿Ï…Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½ ÎºÎ±Î¹ Ï„Î¬Î¾ÎµÎ¹Ï‚ Ï€ÏÎ¹Î½ Ï„Î·Î½ ÎµÎ¯ÏƒÎ¿Î´Î¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„Î¬',0),(439078,12197,'zh','å¿…é¡»åœ¨è¾“å…¥æ¯”çŽ‡å‰è¾“å…¥æœåŠ¡ç±»åž‹å’Œçº§åˆ«',0),(439079,12197,'sv','MÃ¥ste ange tjÃ¤nsttyp och klasser innan priser',0),(439080,12197,'it','Necessario immettere classi e tipi di servizio prima di entrare in tariffe',0),(439081,12197,'tl','',0),(439082,12197,'th','à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸šà¸£à¸´à¸à¸²à¸£à¹à¸¥à¸°à¹€à¸£à¸µà¸¢à¸™à¸à¹ˆà¸­à¸™à¸—à¸µà¹ˆà¸ˆà¸°à¹ƒà¸ªà¹ˆà¸£à¸²à¸„à¸²à¸žà¸´à¹€à¸¨à¸©',0),(439083,12197,'hi','à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°à¥‹à¤‚ à¤”à¤° à¤µà¤°à¥à¤—à¥‹à¤‚ à¤¦à¤°à¥‹à¤‚ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(439084,12197,'ms','Mesti masukkan jenis-jenis perkhidmatan dan kelas sebelum memasuki kadar',0),(439085,12197,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø®Ø¯Ù…Ø© ÙˆØ§Ù„Ø·Ø¨Ù‚Ø§Øª Ù‚Ø¨Ù„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø¥Ù„Ù‰ Ù…Ø¹Ø¯Ù„Ø§Øª',0),(439086,12197,'fr','Devez entrer Classes et Types de services avant d\'entrer dans les tarifs',0),(439087,12197,'jp','ãƒ¬ãƒ¼ãƒˆã‚’å…¥åŠ›ã™ã‚‹å‰ã«ã‚µãƒ¼ãƒ“ã‚¹ã®ç¨®é¡žã¨ã‚¯ãƒ©ã‚¹ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(439088,12197,'pt','Deve inserir Classes e tipos de serviÃ§o antes de entrar em taxas',0),(439089,12197,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ñ‚Ð¸Ð¿Ñ‹ ÑÐ»ÑƒÐ¶Ð± Ð¸ ÐºÐ»Ð°ÑÑÑ‹ Ð¿ÐµÑ€ÐµÐ´ Ð²Ñ…Ð¾Ð´Ð¾Ð¼ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(439090,12197,'es','Debe entrar Tipos de Servicio y Clases antes que entrar las Tarifas',0),(439091,12197,'de','Service-Typen und Klassen mâ¿ssen vor dem Betreten der Preise',0),(439092,12197,'en','Must enter Service Types and Classes before entering Rates',0),(439093,12198,'is','',0),(439094,12198,'dr','Ø¨Ø§ÛŒØ¯ Ø³Ø§Ø¹ØªÙ‡Ø§ Ù‚Ø¨Ù„ Ø§Ø² Ø§ÛŒØ¬Ø§Ø¯ ØªØºÛŒÛŒØ±Ø§Øª ÙˆØ§Ø±Ø¯ Ø³ÛŒØ³ØªÙ… Ø´ÙˆÛŒØ¯ ',0),(439095,12198,'pr','Ø¨Ø§ÛŒØ¯ Ø³Ø§Ø¹ØªÙ‡Ø§ Ù‚Ø¨Ù„ Ø§Ø² Ø§ÛŒØ¬Ø§Ø¯ ØªØºÛŒÛŒØ±Ø§Øª ÙˆØ§Ø±Ø¯ Ø³ÛŒØ³ØªÙ… Ø´ÙˆÛŒØ¯ ',0),(439096,12198,'tr','DeÄŸiÅŸiklik yapmadan Ã¶nce saat oturum aÃ§malÄ±sÄ±nÄ±z',0),(439097,12198,'pl','NaleÅ¼y rejestrowaÄ‡ godziny przed dokonaniem zmiany',0),(439098,12198,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²Ð»ÐµÐ·ÐµÑ‚Ðµ Ñ‡Ð°ÑÐ° Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(439099,12198,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ú©Ø±Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ø§ÙˆÙ‚Ø§Øª Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº',0),(439100,12198,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ ÑÐµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸ ÑÐ°Ñ‚Ð¸ Ð¿Ñ€Ðµ Ð²Ñ€ÑˆÐµÑšÐ° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(439101,12198,'vi','Pháº£i cÃ³ giá» vÃ o trÆ°á»›c khi táº¡o thay Ä‘á»•i',0),(439102,12198,'af','Ure voor die veranderinge moet aanteken',0),(439103,12198,'ro','Trebuie sÄƒ conectaÅ£i ore Ã®nainte de a face modificÄƒri',0),(439104,12198,'et','Tundi enne muudatuste tegemist peate sisse logima',0),(439105,12198,'si','Morate prijaviti ur pred spremembami',0),(439106,12198,'ba','Harus log jam sebelum membuat perubahan',0),(439107,12198,'nl','Moet zich aanmelden uur voordat u wijzigingen aanbrengt',0),(439108,12198,'fi','On kirjauduttava tuntia ennen muutosten',0),(439109,12198,'no','MÃ¥ logge timer fÃ¸r du gjÃ¸r endringer',0),(439110,12198,'da','Skal logge timer fÃ¸r du foretager Ã¦ndringer',0),(439111,12198,'ko','ë³€ê²½ í•˜ê¸° ì „ì— ì‹œê°„ì„ ë¡œê·¸ì¸ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(439112,12198,'he','×¢×œ×™×š ×œ×”×™×›× ×¡ ×©×¢×•×ª ×œ×¤× ×™ ×‘×™×¦×•×¢ ×©×™× ×•×™×™×',0),(439113,12198,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ ÏŽÏÎµÏ‚ Ï€ÏÎ¹Î½ ÎºÎ¬Î½ÎµÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚',0),(439114,12198,'zh','å¿…é¡»åœ¨è¿›è¡Œå˜æ›´å‰ç™»è®°æ—¶æ•°',0),(439115,12198,'sv','MÃ¥ste logga timmar innan du gÃ¶r Ã¤ndringar',0),(439116,12198,'it','Necessario accedere ore prima di apportare modifiche',0),(439117,12198,'tl','',0),(439118,12198,'th','à¸•à¹‰à¸­à¸‡à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¸à¹ˆà¸­à¸™à¸—à¸³à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(439119,12198,'hi','à¤˜à¤‚à¤Ÿà¥‹à¤‚ à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤²à¥‰à¤— à¤‡à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(439120,12198,'ms','Mestilah log jam sebelum membuat perubahan',0),(439121,12198,'ar','ÙŠØ¬Ø¨ ØªØ³Ø¬ÙŠÙ„ Ø³Ø§Ø¹Ø§Øª Ù‚Ø¨Ù„ Ø¥Ø¬Ø±Ø§Ø¡ Ø£ÙŠØ© ØªØºÙŠÙŠØ±Ø§Øª',0),(439122,12198,'fr','Devez ouvrir une session heures avant d\'effectuer les changements',0),(439123,12198,'jp','å¤‰æ›´ã‚’åŠ ãˆã‚‹å‰ã«æ™‚é–“ã‚’è¨˜éŒ²ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(439124,12198,'pt','Identifique-se horas antes de fazer alteraÃ§Ãµes',0),(439125,12198,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð¾Ð¹Ñ‚Ð¸ Ð² Ñ‡Ð°ÑÑ‹ Ð¿ÐµÑ€ÐµÐ´ Ð²Ð½ÐµÑÐµÐ½Ð¸ÐµÐ¼ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(439126,12198,'es','Debe meter en el sistema por horas antes que hacer cambios',0),(439127,12198,'de','Stunden bevor Ã„nderungen melden',0),(439128,12198,'en','Must log hours before making changes',0),(439129,12199,'is','',0),(439130,12199,'dr','Ù‡ÛŒÚ† Ú©Ø¯ Ú©Ø§Ù„Ø§ÛŒÛŒ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(439131,12199,'pr','Ù‡ÛŒÚ† Ú©Ø¯ Ú©Ø§Ù„Ø§ÛŒÛŒ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(439132,12199,'tr','Girilen hiÃ§bir madde kodu',0),(439133,12199,'pl','Nie wprowadzony kod towaru',0),(439134,12199,'bg','ÐÑÐ¼Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÐ½ ÐºÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(439135,12199,'ur','Ú©ÙˆØ¦ÛŒ Ø´Û’ Ú©ÙˆÚˆ Ø¯Ø§Ø®Ù„',0),(439136,12199,'sr','ÐÐµÐ¼Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° ÑˆÐ¸Ñ„Ñ€Ð° ÑƒÐ½ÐµÑ‚Ð°',0),(439137,12199,'vi','khÃ´ng cÃ³ mÃ£ hÃ ng Ä‘á»ƒ nháº­p',0),(439138,12199,'af','Geen Item kode ingesleutel',0),(439139,12199,'ro','Nici un cod articol a intrat',0),(439140,12199,'et','Kauba koodi sisestada',0),(439141,12199,'si','Ni Å ifra artikla, vstopil',0),(439142,12199,'ba','Tidak ada kode barang yang masuk',0),(439143,12199,'nl','Geen Item Code ingevoerd',0),(439144,12199,'fi','Nimikkeen koodi puuttuu',0),(439145,12199,'no','Ingen Varekode angitt',0),(439146,12199,'da','Ingen varekode angivet',0),(439147,12199,'ko','ìž…ë ¥ í•­ëª© ì½”ë“œ ì—†ìŒ',0),(439148,12199,'he','××™×Ÿ ×§×•×“ ×¤×¨×™×˜ ×©×”×•×–×Ÿ',0),(439149,12199,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î´ÎµÎ½ Ï„Î­Î¸Î·ÎºÎµ',0),(439150,12199,'zh','æ²¡æœ‰è¾“å…¥çš„é¡¹ç›®ä»£ç ',0),(439151,12199,'sv','Ingen artikelkod som anges',0),(439152,12199,'it','Nessun codice articolo inserito',0),(439153,12199,'tl','',0),(439154,12199,'th','à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²à¸›à¹‰à¸­à¸™',0),(439155,12199,'hi','à¤•à¥‹à¤ˆ à¤†à¤‡à¤Ÿà¤® à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤•à¥‹à¤¡',0),(439156,12199,'ms','Tiada kod Item yang dimasukkan',0),(439157,12199,'ar','ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù Ù„Ø§ Ø¯Ø®Ù„',0),(439158,12199,'fr','Aucun point de Code entrÃ©',0),(439159,12199,'jp','å…¥åŠ›ãªã—ã‚¢ã‚¤ãƒ†ãƒ  ã‚³ãƒ¼ãƒ‰',0),(439160,12199,'pt','Nenhum cÃ³digo de Item inserido',0),(439161,12199,'ru','ÐÐµ Ð²Ð²ÐµÐ´ÐµÐ½ ÐºÐ¾Ð´ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(439162,12199,'es','No Entraste Un CÃ³digo de Item',0),(439163,12199,'de','Kein Item-Code eingegeben',0),(439164,12199,'en','No Item Code Entered',0),(439165,12200,'is','',0),(439166,12200,'dr','Ù‡ÛŒÚ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¯ÙˆÙ† ÙØ§Ú©ØªÙˆØ±ÛŒ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(439167,12200,'pr','Ù‡ÛŒÚ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¯ÙˆÙ† ÙØ§Ú©ØªÙˆØ±ÛŒ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(439168,12200,'tr','Bulundu-fatura Ã¶deme yok',0),(439169,12200,'pl','Å»adne pÅ‚atnoÅ›ci faktury nie znaleziono',0),(439170,12200,'bg','ÐÐµ-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(439171,12200,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ ØºÛŒØ± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(439172,12200,'sr','ÐÐµÐ¼Ð° Ð½Ð¾Ð½-ÐºÑšÐ¸Ð³Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(439173,12200,'vi','khÃ´ng tÃ¬m tháº¥y thanh toÃ¡n khÃ´ng hÃ³a Ä‘Æ¡n',0),(439174,12200,'af','Geen nie-faktuur betalings gevind',0),(439175,12200,'ro','Nici o platÄƒ de non-factura gÄƒsit',0),(439176,12200,'et','Arve vÃ¤ljamakseid leitud',0),(439177,12200,'si','Brez plaÄila brez raÄuna, najdemo',0),(439178,12200,'ba','Tidak ada non-faktur pembayaran yang ditemukan',0),(439179,12200,'nl','Geen niet-factuur betalingen gevonden',0),(439180,12200,'fi','-Lasku maksuja ei lÃ¶ytynyt',0),(439181,12200,'no','Ingen ikke-faktura betalinger funnet',0),(439182,12200,'da','Ingen ikke-faktura betalinger fundet',0),(439183,12200,'ko','ì•„ë‹ˆ ë¹„ ì²­êµ¬ì„œ ì§€ë¶ˆ ë°œê²¬',0),(439184,12200,'he','×œ×œ× ×ª×©×œ×•×ž×™× ×œ×œ× ×—×©×‘×•× ×™×ª × ×ž×¦××•',0),(439185,12200,'el','ÎšÎ±Î¼Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î® Î¼Î·-Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(439186,12200,'zh','æ²¡æœ‰æ‰¾åˆ°æ— å¼€å…·å‘ç¥¨çš„ä»˜æ¬¾',0),(439187,12200,'sv','Inga icke-faktura betalningar hittade',0),(439188,12200,'it','Nessun pagamento di fattura non trovato',0),(439189,12200,'tl','',0),(439190,12200,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆà¹„à¸¡à¹ˆà¸žà¸š',0),(439191,12200,'hi','à¤•à¥‹à¤ˆ à¤—à¥ˆà¤°-à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¾à¤¯à¤¾',0),(439192,12200,'ms','Tiada pembayaran invois yang ditemui',0),(439193,12200,'ar','Ø£ÙŠØ© Ù…Ø¯ÙÙˆØ¹Ø§Øª ØºÙŠØ± Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙˆØ¬Ø¯Øª',0),(439194,12200,'fr','Aucun paiement de facture non trouvÃ©',0),(439195,12200,'jp','ãªã„éž-è«‹æ±‚æ›¸ã®æ”¯æ‰•ã„ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(439196,12200,'pt','Sem pagamentos de fatura-nÃ£o encontrados',0),(439197,12200,'ru','ÐÐµÑ‚ Ð½Ð¾Ð¼ÐµÑ€Ð° ÑÑ‡ÐµÑ‚Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(439198,12200,'es','No se Encuentra Pagos No Facturados',0),(439199,12200,'de','Keine nicht-Rechnung Zahlungen gefunden',0),(439200,12200,'en','No non-invoice payments found',0),(439201,12201,'is','',0),(439202,12201,'dr','-Ø¯Ú©Ù…Ù‡ Ø§ÙØ²ÙˆØ¯Ù† Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø§ÛŒØ¬Ø§Ø¯ ÛŒÚ© ÛŒÙˆØ²Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(439203,12201,'pr','Ù‡ÛŒÚ† Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø´Ø±Ú©Øª Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª-Ø¯Ú©Ù…Ù‡ Ø§ÙØ²ÙˆØ¯Ù† Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø§ÛŒØ¬Ø§Ø¯ ÛŒÚ© Ú©Ø§Ø±Ø¨Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(439204,12201,'tr','Bu ÅŸirket iÃ§in - bir tane oluÅŸturmak iÃ§in Ekle\'yi seÃ§in hiÃ§ kullanÄ±cÄ± yok',0),(439205,12201,'pl','Å»aden z uÅ¼ytkownikÃ³w nie istnieje dla tej firmy - wybierz Dodaj, aby utworzyÄ‡ jeden',0),(439206,12201,'bg','ÐÐµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‚ Ð·Ð° Ñ‚Ð°Ð·Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ - Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð”Ð¾Ð±Ð°Ð²Ð¸, Ð·Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ ÐµÐ´Ð½Ð°',0),(439207,12201,'ur','Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„Ø¦Û’ - Ø§ÛŒÚ© Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº Ø§Ø¶Ø§ÙÛ Ù†Û ØµØ§Ø±ÙÙˆÚº Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(439208,12201,'sr','ÐÐµÐ¼Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð·Ð° Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ - Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð”Ð¾Ð´Ð°Ñ˜ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð»Ð¸ Ñ˜ÐµÐ´Ð½Ñƒ',0),(439209,12201,'vi','khÃ´ng cÃ³ ngÆ°á»i sá»­ dá»¥ng hiá»‡n cÃ³ nÃ o cho cÃ´ng ty- lá»±a chá»n thÃªm Ä‘á»ƒ táº¡o má»›i',0),(439210,12201,'af','Geen gebruikers bestaan vir hierdie maatskappy - kies byvoeg om een te skep',0),(439211,12201,'ro','Utilizatorii nu existÄƒ pentru aceasta companie - selectaÅ£i Add pentru a crea unul',0),(439212,12201,'et','Ãœkski kasutaja olemas selle firma - valige Lisa, et luua Ã¼ks',0),(439213,12201,'si','Noben uporabnik obstaja za to podjetje - izberite Dodaj tvoriti nedoloÄni zaimek',0),(439214,12201,'ba','Tidak ada pengguna yang ada untuk perusahaan ini - pilih Tambah untuk membuat satu',0),(439215,12201,'nl','Geen gebruikers bestaan voor dit bedrijf - Selecteer Add om Ã©Ã©n te creÃ«ren',0),(439216,12201,'fi','KetÃ¤Ã¤n ei ole yritys - Valitse LisÃ¤Ã¤ luoda yksi',0),(439217,12201,'no','Ingen brukere finnes for dette selskapet - Velg Legg til Ã¥ opprette en',0),(439218,12201,'da','Ingen brugere findes for dette selskab - VÃ¦lg TilfÃ¸j til at oprette en',0),(439219,12201,'ko','ì‚¬ìš©ìžê°€ì´ íšŒì‚¬-ë§Œë“œëŠ” ê²ƒì„ ì„ íƒ ì¶”ê°€ ëŒ€ í•œ ì¡´ìž¬',0),(439220,12201,'he','××™×Ÿ ×ž×©×ª×ž×©×™× ×§×™×™×ž×™× ×¢×‘×•×¨ ×”×—×‘×¨×” ×”×–××ª - ×‘×—×¨ ×”×•×¡×£ ×›×“×™ ×œ×™×¦×•×¨ ××—×“',0),(439221,12201,'el','ÎŸÎ¹ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î® - ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î³Î¹Î± Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î­Î½Î±',0),(439222,12201,'zh','æ­¤å…¬å¸æ²¡æœ‰ç”¨æˆ·å­˜åœ¨-é€‰æ‹©æ·»åŠ ä»¥åˆ›å»º',0),(439223,12201,'sv','Inga anvÃ¤ndare finns fÃ¶r detta fÃ¶retag - VÃ¤lj LÃ¤gg till att skapa en',0),(439224,12201,'it','Nessun utente esistono per questa azienda - selezionare Aggiungi per creare uno',0),(439225,12201,'tl','',0),(439226,12201,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹„à¸¡à¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸£à¸´à¸©à¸±à¸—à¸™à¸µà¹‰ - à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸¥à¸·à¸­à¸à¸ªà¸£à¹‰à¸²à¸‡',0),(439227,12201,'hi','à¤•à¥‹à¤ˆ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤®à¥Œà¤œà¥‚à¤¦ à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ - à¤à¤• à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤šà¥à¤¨à¥‡à¤‚',0),(439228,12201,'ms','Tiada pengguna wujud untuk Syarikat ini - pilih Tambah untuk mencipta satu',0),(439229,12201,'ar','ØªÙˆØ¬Ø¯ Ù„Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©--Ø­Ø¯Ø¯ Ø¥Ø¶Ø§ÙØ© Ø¥Ù†Ø´Ø§Ø¡ ÙˆØ§Ø­Ø¯Ø©',0),(439230,12201,'fr','Aucun usager n\'existe pour cette compagnie - sÃ©lectionnez Ajouter pour crÃ©er un',0),(439231,12201,'jp','ã“ã®ä¼šç¤¾ã® 1 ã¤ã‚’ä½œæˆã™ã‚‹é¸æŠžã‚’è¿½åŠ ã«ãƒ¦ãƒ¼ã‚¶ã¯å­˜åœ¨ã—ã¾ã›ã‚“',0),(439232,12201,'pt','NÃ£o hÃ¡ usuÃ¡rios existem para esta empresa - selecione Adicionar para criar um',0),(439233,12201,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ - Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¾Ð´Ð¸Ð½',0),(439234,12201,'es','No existe usuarios para esta Empresa - selecciona Agregar para crear una',0),(439235,12201,'de','Keine Benutzer vorhanden fÃ¼r diese Firma - select hinzufÃ¼gen zu erstellen',0),(439236,12201,'en','No users exist for this Company - select Add to create one',0),(439237,12202,'is','',0),(439238,12202,'dr','(Ø·Ø±Ø­) Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(439239,12202,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ (Ø·Ø±Ø­) Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(439240,12202,'tr','PlanÄ± baÅŸarÄ±yla eklendi',0),(439241,12202,'pl','Plan pomyÅ›lne dodanie',0),(439242,12202,'bg','ÐŸÐ»Ð°Ð½, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(439243,12202,'ur','Ù¾Ù„Ø§Ù† Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(439244,12202,'sr','ÐŸÐ»Ð°Ð½ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(439245,12202,'vi','Ä‘Ã£ thÃªm káº¿ hoáº¡ch thÃ nh cÃ´ng',0),(439246,12202,'af','Plan suksesvol bygevoeg',0),(439247,12202,'ro','Planul adÄƒugat cu succes',0),(439248,12202,'et','Lisatud plaan',0),(439249,12202,'si','NaÄrt, ki uspeÅ¡no dodani',0),(439250,12202,'ba','Rencana berhasil ditambahkan',0),(439251,12202,'nl','Plan met succes toegevoegd',0),(439252,12202,'fi','Suunnitelma lisÃ¤Ã¤minen onnistui',0),(439253,12202,'no','Planen ble lagt til',0),(439254,12202,'da','Planen tilfÃ¸jet',0),(439255,12202,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ëœ ê³„íš',0),(439256,12202,'he','×ª×•×›× ×™×ª × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(439257,12202,'el','Î£Ï‡Î­Î´Î¹Î¿ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(439258,12202,'zh','è®¡åˆ’æ·»åŠ æˆåŠŸ',0),(439259,12202,'sv','Plan lagts',0),(439260,12202,'it','Piano aggiunto con successo',0),(439261,12202,'tl','',0),(439262,12202,'th','à¸§à¸²à¸‡à¹à¸œà¸™à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(439263,12202,'hi','à¤¯à¥‹à¤œà¤¨à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(439264,12202,'ms','Pelan yang berjaya menambah',0),(439265,12202,'ar','Ø§Ù„Ø®Ø·Ø© Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(439266,12202,'fr','Plan ajoutÃ© avec succÃ¨s',0),(439267,12202,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚Œã‚‹ãƒ—ãƒ©ãƒ³',0),(439268,12202,'pt','Plano adicionado com sucesso',0),(439269,12202,'ru','ÐŸÐ»Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(439270,12202,'es','Plan Agregado Exitosamente',0),(439271,12202,'de','Plan erfolgreich hinzugefÃ¼gt',0),(439272,12202,'en','Plan added successfully',0),(439273,12203,'is','',0),(439274,12203,'dr','(Ø·Ø±Ø­) Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø´Ø¯',0),(439275,12203,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ (Ø·Ø±Ø­) Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø´Ø¯',0),(439276,12203,'tr','PlanÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(439277,12203,'pl','Zaktualizowany plan',0),(439278,12203,'bg','ÐŸÐ»Ð°Ð½, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(439279,12203,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ',0),(439280,12203,'sr','ÐŸÐ»Ð°Ð½ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(439281,12203,'vi','Ä‘Ã£ cáº­p nháº­t káº¿ hoáº¡ch thÃ nh cÃ´ng',0),(439282,12203,'af','Plan suksesvol bygewerk',0),(439283,12203,'ro','Planul actualizat cu succes',0),(439284,12203,'et','VÃ¤rskendatud kava',0),(439285,12203,'si','NaÄrt, ki uspeÅ¡no posodobljena',0),(439286,12203,'ba','Rencana diperbarui berhasil',0),(439287,12203,'nl','Plan bijgewerkt',0),(439288,12203,'fi','Suunnitelman pÃ¤ivittÃ¤minen onnistui',0),(439289,12203,'no','Planen oppdatert',0),(439290,12203,'da','Planen opdateret',0),(439291,12203,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ê³„íš',0),(439292,12203,'he','×ª×•×›× ×™×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(439293,12203,'el','Î£Ï‡Î­Î´Î¹Î¿ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(439294,12203,'zh','è®¡åˆ’æ›´æ–°æˆåŠŸ',0),(439295,12203,'sv','Planen uppdaterades',0),(439296,12203,'it','Piano aggiornato con successo',0),(439297,12203,'tl','',0),(439298,12203,'th','à¸§à¸²à¸‡à¹à¸œà¸™à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(439299,12203,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤¯à¥‹à¤œà¤¨à¤¾',0),(439300,12203,'ms','Pelan yang berjaya dikemas kini',0),(439301,12203,'ar','Ø®Ø·Ø© ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(439302,12203,'fr','Plan Ã  jour avec succÃ¨s',0),(439303,12203,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸè¨ˆç”»',0),(439304,12203,'pt','Plano atualizado com sucesso',0),(439305,12203,'ru','ÐŸÐ»Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(439306,12203,'es','Plan Actuelizado Exitosamente',0),(439307,12203,'de','Plan erfolgreich aktualisiert',0),(439308,12203,'en','Plan updated successfully',0),(439309,12204,'is','',0),(439310,12204,'dr','... ',0),(439311,12204,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø± Ù‡Ø±Ø§ØµÙ„ÛŒ... ',0),(439312,12204,'tr','Miktar baÅŸÄ±na Master',0),(439313,12204,'pl','IloÅ›Ä‡ na mistrza',0),(439314,12204,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° Ð¼Ð°Ð¹ÑÑ‚Ð¾Ñ€',0),(439315,12204,'ur','Ù…Ø§Ø³Ù¹Ø± ÙÛŒ Ù‚ÛŒ',0),(439316,12204,'sr','ÐšÐ¾Ð» Ð¿Ð¾ ÐœÐ°ÑÑ‚ÐµÑ€',0),(439317,12204,'vi','sá»‘ lÆ°á»£ng chÃ­nh',0),(439318,12204,'af','Qty per Meester',0),(439319,12204,'ro','Cantitate per Master',0),(439320,12204,'et','Kogus inimese kohta Master',0),(439321,12204,'si','KoliÄina na Master',0),(439322,12204,'ba','Qty per Master',0),(439323,12204,'nl','Aantal per model',0),(439324,12204,'fi','MÃ¤Ã¤rÃ¤ per Master',0),(439325,12204,'no','Antall per Master',0),(439326,12204,'da','Antal pr. Master',0),(439327,12204,'ko','ë§ˆìŠ¤í„° ë‹¹ ìˆ˜ëŸ‰',0),(439328,12204,'he','×›×ž×•×ª ×œ×›×œ ×ž××¡×˜×¨',0),(439329,12204,'el','Qty Î±Î½Î¬ Master',0),(439330,12204,'zh','æ¯ç®¡ç†æ•°é‡',0),(439331,12204,'sv','Antal per Master',0),(439332,12204,'it','Qty per ogni Master',0),(439333,12204,'tl','',0),(439334,12204,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸•à¹ˆà¸­à¸•à¹‰à¸™',0),(439335,12204,'hi','à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤ªà¥à¤°à¤¤à¤¿ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(439336,12204,'ms','Qty setiap induk',0),(439337,12204,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ÙˆØ§Ø­Ø¯Ø© ÙˆÙ…Ø§Ø¬Ø³ØªÙŠØ±',0),(439338,12204,'fr','QtÃ© par Master',0),(439339,12204,'jp','ãƒžã‚¹ã‚¿ãƒ¼ã”ã¨ã®æ•°é‡',0),(439340,12204,'pt','Qtd. por Mestre',0),(439341,12204,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð² Ð¼Ð°ÑÑ‚ÐµÑ€',0),(439342,12204,'es','Cantidad por Maestro',0),(439343,12204,'de','Menge pro Master',0),(439344,12204,'en','Qty per Master',0),(439345,12205,'is','',0),(439346,12205,'dr','Ù…Ø¯ÛŒØ±ÛŒØª Ø§Ø´ØªØ±Ø§Ú© Ø¯Ø± Ø§ÛŒÙ† Ø²Ù…Ø§Ù† Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(439347,12205,'pr','Ù…Ø¯ÛŒØ±ÛŒØª Ø§Ø´ØªØ±Ø§Ú© Ø¯Ø± Ø§ÛŒÙ† Ø²Ù…Ø§Ù† Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(439348,12205,'tr','Alt Ã¶ÄŸe kodu',0),(439349,12205,'pl','Sub-pozycja kod',0),(439350,12205,'bg','ÐŸÐ¾Ð´Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ ÐºÐ¾Ð´',0),(439351,12205,'ur','Ø°ÛŒÙ„ÛŒ Ø´Û’ Ú©ÙˆÚˆ',0),(439352,12205,'sr','ÐŸÐ¾Ð´ÑÑ‚Ð°Ð²ÐºÑƒ Ð¨Ð¸Ñ„Ñ€Ð°',0),(439353,12205,'vi','MÃ£ máº·t hÃ ng phá»¥',0),(439354,12205,'af','Subitem kode',0),(439355,12205,'ro','Subelementul cod',0),(439356,12205,'et','Kirje kood',0),(439357,12205,'si','PodtoÄka kodo',0),(439358,12205,'ba','Kode barang sub',0),(439359,12205,'nl','Deelpost Code',0),(439360,12205,'fi','Alamomentin koodi',0),(439361,12205,'no','Sub Varekode',0),(439362,12205,'da','Underkonto kode',0),(439363,12205,'ko','í•˜ìœ„ í•­ëª© ì½”ë“œ',0),(439364,12205,'he','×§×•×“ ×¤×¨×™×˜ ×ž×©× ×”',0),(439365,12205,'el','Î¥Ï€Î¿Î´Î¹Î±Î¯ÏÎµÏƒÎ· ÎºÏŽÎ´Î¹ÎºÎ±',0),(439366,12205,'zh','å­é¡¹ä»£ç ',0),(439367,12205,'sv','Sub Artikelkod',0),(439368,12205,'it','Codice sub-articolo',0),(439369,12205,'tl','',0),(439370,12205,'th','à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²à¸¢à¹ˆà¸­à¸¢',0),(439371,12205,'hi','à¤‰à¤ª à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡',0),(439372,12205,'ms','Kod Item sub',0),(439373,12205,'ar','ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù Ø§Ù„ÙØ±Ø¹ÙŠ',0),(439374,12205,'fr','Le point de Code',0),(439375,12205,'jp','ã‚µãƒ–é …ç›®ã‚³ãƒ¼ãƒ‰',0),(439376,12205,'pt','CÃ³digo de subitem',0),(439377,12205,'ru','ÐŸÐ¾Ð´Ð¿ÑƒÐ½ÐºÑ‚ ÐºÐ¾Ð´Ð°',0),(439378,12205,'es','CÃ³digo de Sub-Item',0),(439379,12205,'de','Unterpunkt Code',0),(439380,12205,'en','Sub-Item Code',0),(439381,12206,'is','',0),(439382,12206,'dr','(Ù†Ø§Ù… Ø²ÛŒØ± Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§',0),(439383,12206,'pr','Ù†Ø§Ù… Ø²ÛŒØ± Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ú©Ø§Ù„Ø§(Ù†Ø§Ù… Ø²ÛŒØ± Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§',0),(439384,12206,'tr','Alt Ã¶ÄŸe adÄ±',0),(439385,12206,'pl','Nazwa sub-elementu',0),(439386,12206,'bg','ÐŸÐ¾Ð´Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ Ð¸Ð¼Ðµ',0),(439387,12206,'ur','Ø°ÛŒÙ„ÛŒ Ø´Û’ Ú©Ø§ Ù†Ø§Ù…',0),(439388,12206,'sr','ÐŸÐ¾Ð´ÑÑ‚Ð°Ð²ÐºÑƒ Ð¸Ð¼Ðµ',0),(439389,12206,'vi','TÃªn máº·t hÃ ng phá»¥',0),(439390,12206,'af','Subitem naam',0),(439391,12206,'ro','Nume sub-articol',0),(439392,12206,'et','Kirje nimi',0),(439393,12206,'si','PodtoÄka ime',0),(439394,12206,'ba','Nama sub Item',0),(439395,12206,'nl','Deelpost naam',0),(439396,12206,'fi','ErÃ¤n nimi',0),(439397,12206,'no','Navn pÃ¥ sub',0),(439398,12206,'da','Sub elementnavn',0),(439399,12206,'ko','í•˜ìœ„ í•­ëª© ì´ë¦„',0),(439400,12206,'he','×©× ×¤×¨×™×˜ ×ž×©× ×”',0),(439401,12206,'el','Î¥Ï€Î¿Î´Î¹Î±Î¯ÏÎµÏƒÎ· ÏŒÎ½Î¿Î¼Î±',0),(439402,12206,'zh','å­é¡¹åç§°',0),(439403,12206,'sv','Underpunkt namn',0),(439404,12206,'it','Nome elemento secondario',0),(439405,12206,'tl','',0),(439406,12206,'th','à¸Šà¸·à¹ˆà¸­à¸ªà¸´à¸™à¸„à¹‰à¸²à¸¢à¹ˆà¸­à¸¢',0),(439407,12206,'hi','à¤‰à¤ª à¤†à¤‡à¤Ÿà¤® à¤¨à¤¾à¤®',0),(439408,12206,'ms','Nama Item sub',0),(439409,12206,'ar','Ø§Ø³Ù… Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(439410,12206,'fr','Nom du point',0),(439411,12206,'jp','ã‚µãƒ–é …ç›®å',0),(439412,12206,'pt','Nome do subitem',0),(439413,12206,'ru','ÐŸÐ¾Ð´Ð¿ÑƒÐ½ÐºÑ‚ Ð¸Ð¼Ñ',0),(439414,12206,'es','Nombre de Sub-Item',0),(439415,12206,'de','Unterpunkt Name',0),(439416,12206,'en','Sub-Item Name',0),(439417,12207,'is','',0),(439418,12207,'dr','Ù…Ø´Ø®Øµ Ú©Ù†Ù†Ø¯Ù‡ Ù…Ø­Ø¯ÙˆØ¯ÛŒØª Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ú©Ø§Ø±Ø§Ú©ØªØ± Ø·ÙˆÙ„Ø§Ù†ÛŒ ØªØ± Ø¨Ø§Ø´Ø¯',0),(439419,12207,'pr','Ù…Ø´Ø®Øµ Ú©Ù†Ù†Ø¯Ù‡ Ù…Ø­Ø¯ÙˆØ¯ÛŒØª Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ú©Ø§Ø±Ø§Ú©ØªØ± Ø·ÙˆÙ„Ø§Ù†ÛŒ ØªØ± Ø¨Ø§Ø´Ø¯',0),(439420,12207,'tr','SÄ±nÄ±rlayÄ±cÄ± 1 karakter uzunluÄŸunda olmalÄ±dÄ±r',0),(439421,12207,'pl','Ogranicznik powinien byÄ‡ 1 znak',0),(439422,12207,'bg','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ 1 Ñ…Ð°Ñ€Ð°ÐºÑ‚ÐµÑ€ Ð´ÑŠÐ»ÑŠÐ³',0),(439423,12207,'ur','ØªØ­Ø¯ÛŒØ¯ Ú©Ø§Ø± 1 Ú©Ø±ÛŒÚ©Ù¹Ø± Ø·ÙˆÛŒÙ„ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(439424,12207,'sr','Ð—Ð½Ð°Ðº Ñ€Ð°Ð·Ð³Ñ€Ð°Ð½Ð¸Ñ‡Ð°Ð²Ð°ÑšÐ° Ñ‚Ñ€ÐµÐ±Ð°Ð»Ð¾ Ð±Ð¸ Ð´ÑƒÐ³Ð¾ 1 Ð·Ð½Ð°Ðº',0),(439425,12207,'vi','Dáº¥u phÃ¢n cÃ¡ch nÃªn lÃ  1 kÃ½ tá»± dÃ i',0),(439426,12207,'af','Die delimiter behoort 1 karakter lang',0),(439427,12207,'ro','Delimitatorul ar trebui sÄƒ fie de un caracter lung',0),(439428,12207,'et','Eraldaja peaks olema 1 mÃ¤rgi pikkused',0),(439429,12207,'si','LoÄilo, mora biti dolga 1 znaÄaj',0),(439430,12207,'ba','Pembatas yng harus 1 karakter lama',0),(439431,12207,'nl','Het scheidingsteken moet 1 teken lange',0),(439432,12207,'fi','Erotin pitÃ¤isi olla yksi merkki',0),(439433,12207,'no','Skilletegnet skal vÃ¦re 1 tegn',0),(439434,12207,'da','AfgrÃ¦nseren, der skal vÃ¦re Ã©t tegn lange',0),(439435,12207,'ko','êµ¬ë¶„ ê¸°í˜¸ 1 ë¬¸ìž ì˜¤ëž˜ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(439436,12207,'he','×‘×ž×¤×¨×™×“ ××ž×•×¨ ×ª×• ××—×“ ××¨×•×š',0),(439437,12207,'el','ÎŸ Î¿ÏÎ¹Î¿Î¸Î­Ï„Î·Ï‚ Î¸Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ 1 Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÎ± Ï€Î¿Î»Ï',0),(439438,12207,'zh','å®šä¹‰ç¬¦åº”åœ¨1ä¸ªå­—ç¬¦é•¿åº¦',0),(439439,12207,'sv','AvgrÃ¤nsaren ska vara 1 tecken lÃ¥ng',0),(439440,12207,'it','Il delimitatore dovrebbe essere lunga 1 carattere',0),(439441,12207,'tl','',0),(439442,12207,'th','à¸•à¸±à¸§à¸„à¸±à¹ˆà¸™à¸„à¸§à¸£à¸ˆà¸°à¸¢à¸²à¸§ 1 à¸•à¸±à¸§à¸­à¸±à¸à¸‚à¸£à¸°',0),(439443,12207,'hi','à¤¸à¥€à¤®à¤¾à¤‚à¤•à¤• 1 à¤µà¤°à¥à¤£ à¤²à¤‚à¤¬à¤¾ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(439444,12207,'ms','Delimiter yang sepatutnya 1 watak lama',0),(439445,12207,'ar','ÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ÙŠÙƒÙˆÙ† Ø§Ù„Ù…Ø­Ø¯Ø¯ 1 Ø­Ø±Ù Ø·ÙˆÙŠÙ„',0),(439446,12207,'fr','Le dÃ©limiteur doit Ãªtre longue de 1 caractÃ¨re',0),(439447,12207,'jp','åŒºåˆ‡ã‚Šæ–‡å­—ã¯ 1 æ–‡å­—ã®é•·ã•ã‚’ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(439448,12207,'pt','O delimitador deve ser longa 1 caractere',0),(439449,12207,'ru','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑŒ Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ 1 ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¾Ð² Ð´Ð»Ð¸Ð½Ð¾Ð¹',0),(439450,12207,'es','El Delimitador Debe Ser Un Caracter de Largo',0),(439451,12207,'de','Das Trennzeichen sollte 1 Zeichen lang sein.',0),(439452,12207,'en','The delimiter should be 1 character long',0),(439453,12208,'is','',0),(439454,12208,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ø¯ÙˆÙ„ØªÛŒ Ø¨Ø±Ø§ÛŒ Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(439455,12208,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ø¯ÙˆÙ„ØªÛŒ Ø¨Ø±Ø§ÛŒ Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(439456,12208,'tr','SeÃ§ilen yÄ±l iÃ§in devlet vergi tablolarÄ±nÄ± GÃ¼ncelleÅŸtir',0),(439457,12208,'pl','Aktualizacja stanu podatku tabel dla roku wybrany',0),(439458,12208,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð¸ Ð·Ð° Ð´Ð°Ð½ÑŠÐº Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½',0),(439459,12208,'ur','Ø§Ù¾ ÚˆÛŒÙ¹ Ø±ÛŒØ§Ø³ØªÛŒ Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù…ÛŒØ²ÛŒÚº Ù…Ù†ØªØ®Ø¨ Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’',0),(439460,12208,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° ÑÑ‚Ð¾Ð»Ð¾Ð²Ðµ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(439461,12208,'vi','Cáº­p nháº­t báº£ng thuáº¿ nÄƒm Ä‘Ã£ chá»n',0),(439462,12208,'af','Bywerking staat belastingtabelle vir jaar gekies',0),(439463,12208,'ro','Actualizare stat impozitul tabele pentru anul selectate',0),(439464,12208,'et','Update riigile tulumaksu tabelid valitud aasta',0),(439465,12208,'si','Posodobitev tabel drÅ¾ava davka za leto izbrali',0),(439466,12208,'ba','Pajak negara update tabel untuk tahun yang dipilih',0),(439467,12208,'nl','Update staat belasting tafels voor jaar geselecteerd',0),(439468,12208,'fi','PÃ¤ivitÃ¤ valitun vuoden valtion verotaulut',0),(439469,12208,'no','Oppdateringen staten skattetabeller Ã¥r valgt',0),(439470,12208,'da','Opdatering stat momstabeller for Ã¥r valgt',0),(439471,12208,'ko','ì˜¬í•´ ì„ ì •ì— ëŒ€ í•œ ì—…ë°ì´íŠ¸ ìƒíƒœ ì„¸ê¸ˆ í…Œì´ë¸”',0),(439472,12208,'he','×¢×“×›×•×Ÿ ×ž×¦×‘ ×˜×‘×œ××•×ª ×ž×¡ ×©× ×” × ×‘×—×¨',0),(439473,12208,'el','Î Î¯Î½Î±ÎºÎµÏ‚ Ï†ÏŒÏÎ¿Ï… ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î¾Î±Ï„Îµ',0),(439474,12208,'zh','æ›´æ–°å›½å®¶ç¨Žè¡¨é€‰ä¸­çš„å¹´ä»½',0),(439475,12208,'sv','Uppdatering staten skatt tabeller fÃ¶r Ã¥r valt',0),(439476,12208,'it','Aggiornamento tabelle fiscale di stato per l\'anno selezionato',0),(439477,12208,'tl','',0),(439478,12208,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸•à¸²à¸£à¸²à¸‡à¸ à¸²à¸©à¸µà¸ªà¸–à¸²à¸™à¸°à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸µà¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(439479,12208,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤°à¤¾à¤œà¥à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¤à¤¾à¤²à¤¿à¤•à¤¾à¤à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤',0),(439480,12208,'ms','Kemaskini Jadual cukai Negeri bagi tahun yang dipilih',0),(439481,12208,'ar','ØªØ­Ø¯ÙŠØ« \"Ø¬Ø¯Ø§ÙˆÙ„ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¯ÙˆÙ„Ø©\" Ù„Ø³Ù†ÙˆØ§Øª Ù…Ø®ØªØ§Ø±Ø©',0),(439482,12208,'fr','Tables d\'impÃ´t Ã©tat de mise Ã  jour pour l\'annÃ©e sÃ©lectionnÃ©e',0),(439483,12208,'jp','é¸æŠžã—ãŸå¹´ã®æ›´æ–°çŠ¶æ…‹ç¨Žãƒ†ãƒ¼ãƒ–ãƒ«',0),(439484,12208,'pt','AtualizaÃ§Ã£o tabelas de imposto de estado para o ano selecionado',0),(439485,12208,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ð¾Ð¹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ð½ Ð³Ð¾Ð´',0),(439486,12208,'es','Actualizar las Tables de Impuestos Estatales por el aÃ±o seleccionado',0),(439487,12208,'de','Update Status-Steuertabellen fÃ¼r Jahr ausgewÃ¤hlt',0),(439488,12208,'en','Update State Tax Tables for year selected',0),(439489,12209,'is','',0),(439490,12209,'dr','Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ÛŒ Ú©Ø§Ø±Ø¨Ø±',0),(439491,12209,'pr','Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ÛŒ Ú©Ø§Ø±Ø¨Ø±',0),(439492,12209,'tr','KullanÄ±cÄ± haklarÄ± grubu',0),(439493,12209,'pl','Grupy praw uÅ¼ytkownika',0),(439494,12209,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ñ€Ð°Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(439495,12209,'ur','ØµØ§Ø±Ù Ú©Û’ Ø­Ù‚ÙˆÙ‚ Ú©Û’ Ú¯Ø±ÙˆÙ¾',0),(439496,12209,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð·Ð° Ð¿Ñ€Ð°Ð²Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(439497,12209,'vi','NhÃ³m cÃ¡c quyá»n cá»§a ngÆ°á»i sá»­ dá»¥ng',0),(439498,12209,'af','Gebruikerregte Groep',0),(439499,12209,'ro','Grup de drepturi de utilizator',0),(439500,12209,'et','Kasutajagrupi Ãµigused',0),(439501,12209,'si','UporabniÅ¡ke pravice skupine',0),(439502,12209,'ba','Kelompok hak pengguna',0),(439503,12209,'nl','Rechten van de gebruikersgroep',0),(439504,12209,'fi','KÃ¤yttÃ¤jÃ¤ryhmÃ¤n oikeudet',0),(439505,12209,'no','Rettigheter gruppen',0),(439506,12209,'da','Bruger rettigheder gruppe',0),(439507,12209,'ko','ì‚¬ìš©ìž ê¶Œí•œ ê·¸ë£¹',0),(439508,12209,'he','×ž×©×ª×ž×© ×–×›×•×™×•×ª ×§×‘×•×¦×”',0),(439509,12209,'el','ÎŸÎ¼Î¬Î´Î± Î´Î¹ÎºÎ±Î¹Ï‰Î¼Î¬Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÏ„Î·',0),(439510,12209,'zh','ç”¨æˆ·æƒé™ç»„',0),(439511,12209,'sv','AnvÃ¤ndare rÃ¤ttigheter grupp',0),(439512,12209,'it','Gruppo per i diritti dell\'utente',0),(439513,12209,'tl','',0),(439514,12209,'th','à¸à¸¥à¸¸à¹ˆà¸¡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸ªà¸´à¸—à¸˜à¸´',0),(439515,12209,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤®à¥‚à¤¹',0),(439516,12209,'ms','Kumpulan-kumpulan hak-hak pengguna',0),(439517,12209,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(439518,12209,'fr','Groupe de droits d\'utilisateurs',0),(439519,12209,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©é™ã‚°ãƒ«ãƒ¼ãƒ—',0),(439520,12209,'pt','Grupo de direitos de usuÃ¡rio',0),(439521,12209,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° Ð¿Ñ€Ð°Ð² Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(439522,12209,'es','Grupo de Derechos de Usuarios',0),(439523,12209,'de','User Rights Group',0),(439524,12209,'en','User Rights Group',0),(439525,12210,'is','',0),(439526,12210,'dr','Ø­ÙØ¸ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(439527,12210,'pr','Ø­ÙØ¸ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(439528,12210,'tr','SatÄ±cÄ± tutun',0),(439529,12210,'pl','Sprzedawca trzymaÄ‡',0),(439530,12210,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(439531,12210,'ur','ÙˆÛŒÙ†ÚˆØ± ÛÙˆÙ„Úˆ',0),(439532,12210,'sr','Ð§ÐµÐºÐ°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(439533,12210,'vi','nhÃ  cung cáº¥p Ä‘Æ°á»£c giá»¯ láº¡i',0),(439534,12210,'af','Verkoper hou',0),(439535,12210,'ro','Furnizorul deÅ£ine',0),(439536,12210,'et','Hankija ootel',0),(439537,12210,'si','DrÅ¾ite dobavitelja',0),(439538,12210,'ba','Penjual terus',0),(439539,12210,'nl','Leverancier Hold',0),(439540,12210,'fi','Toimittajan pito',0),(439541,12210,'no','LeverandÃ¸ren Hold',0),(439542,12210,'da','KreditorspÃ¦rringen',0),(439543,12210,'ko','ê³µê¸‰ ì—…ì²´ ë³´ìœ ',0),(439544,12210,'he','×¡×¤×§ ×”×—×–×§',0),(439545,12210,'el','ÎšÏÎ±Ï„Î®ÏƒÏ„Îµ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(439546,12210,'zh','ä¿æŒä¾›åº”å•†',0),(439547,12210,'sv','LeverantÃ¶r hÃ¥ll',0),(439548,12210,'it','Fornitore Hold',0),(439549,12210,'tl','',0),(439550,12210,'th','à¸£à¸°à¸‡à¸±à¸šà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(439551,12210,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¹à¥‹à¤²à¥à¤¡',0),(439552,12210,'ms','Penjual memegang',0),(439553,12210,'ar','Ø¹Ù‚Ø¯ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(439554,12210,'fr','Attente du vendeur',0),(439555,12210,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®ãƒ›ãƒ¼ãƒ«ãƒ‰',0),(439556,12210,'pt','PreensÃ£o do fornecedor',0),(439557,12210,'ru','Ð£Ð´ÐµÑ€Ð¶Ð¸Ð²Ð°Ð¹Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(439558,12210,'es','Proveedor Retiene',0),(439559,12210,'de','Lieferanten halten',0),(439560,12210,'en','Vendor Hold',0),(439561,12211,'is','',0),(439562,12211,'dr','Ø´Ù…Ø§ Ù†Ø¨Ø§ÛŒØ¯ Ø§Ø²Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ ÛŒØ§ Ø­Ø±ÙˆÙ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø´Ø§Ø®Øµ Ù…Ø­Ø¯ÙˆØ¯ÛŒØª Ù‡Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯  ',0),(439563,12211,'pr','Ø´Ù…Ø§ Ù†Ø¨Ø§ÛŒØ¯ Ø§Ø²Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ ÛŒØ§ Ø­Ø±ÙˆÙ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø´Ø§Ø®Øµ Ù…Ø­Ø¯ÙˆØ¯ÛŒØª Ù‡Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯  ',0),(439564,12211,'tr','Harf veya sayÄ±lar bir sÄ±nÄ±rlayÄ±cÄ± karakter olarak kullanamazsÄ±nÄ±z',0),(439565,12211,'pl','Nie moÅ¼na uÅ¼ywaÄ‡ cyfr lub liter jako znak ogranicznika',0),(439566,12211,'bg','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ñ‡Ð¸ÑÐ»Ð° Ð¸Ð»Ð¸ Ð±ÑƒÐºÐ²Ð¸ ÐºÐ°Ñ‚Ð¾ Ð·Ð½Ð°Ðº Ð·Ð° Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»',0),(439567,12211,'ur','Ø¢Ù¾ Ø®Ø· ÛŒØ§ ØªØ¹Ø¯Ø§Ø¯ ØªØ­Ø¯ÛŒØ¯ Ú©Ø§Ø± Ú©Ø±ÛŒÚ©Ù¹Ø± Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(439568,12211,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ðµ Ð¸Ð»Ð¸ ÑÐ»Ð¾Ð²Ð° ÐºÐ°Ð¾ Ð·Ð½Ð°Ðº Ñ€Ð°Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐ°',0),(439569,12211,'vi','Báº¡n khÃ´ng thá»ƒ sá»­ dá»¥ng sá»‘ hoáº·c chá»¯ nhÆ° lÃ  má»™t kÃ½ tá»± phÃ¢n cÃ¡ch',0),(439570,12211,'af','Jy getalle of letters kan gebruik as \'n delimiter karakter',0),(439571,12211,'ro','Se poate utiliza numerele sau literele ca un caracter separator',0),(439572,12211,'et','Te ei saa kasutada numbreid vÃµi tÃ¤hti eraldusmÃ¤rki',0),(439573,12211,'si','Ne morete uporabiti Å¡tevilke ali Ärke kot znak loÄila',0),(439574,12211,'ba','Anda tidak dapat menggunakan nomor atau surat sebagai pembatas karakter',0),(439575,12211,'nl','U kunt getallen of letters als een scheidingsteken',0),(439576,12211,'fi','Et voi kÃ¤yttÃ¤Ã¤ numeroita tai kirjaimia erotinmerkki',0),(439577,12211,'no','Du kan bruke tall eller bokstaver som et skilletegn',0),(439578,12211,'da','Du kan ikke bruge tal eller bogstaver som et afgrÃ¦nsningstegn',0),(439579,12211,'ko','êµ¬ë¶„ ê¸°í˜¸ ë¬¸ìžë¡œ ìˆ«ìž ë˜ëŠ” ë¬¸ìžë¥¼ ì‚¬ìš©í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(439580,12211,'he','×œ× × ×™×ª×Ÿ ×œ×”×©×ª×ž×© ×ž×¡×¤×¨×™× ××• ××•×ª×™×•×ª ×›×ª×• ×”×ž×¤×¨×™×“',0),(439581,12211,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±ÏÎ¹Î¸Î¼Î¿ÏÏ‚ Î® Î³ÏÎ¬Î¼Î¼Î±Ï„Î± Ï‰Ï‚ Î¿ÏÎ¹Î¿Î¸Î­Ï„Î· Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÎ±Ï‚',0),(439582,12211,'zh','ä½ ä¸èƒ½ä½¿ç”¨æ•°å­—æˆ–å­—æ¯ä½œä¸ºåˆ†éš”ç¬¦',0),(439583,12211,'sv','Du kan inte anvÃ¤nda siffror eller bokstÃ¤ver som ett avgrÃ¤nsartecken',0),(439584,12211,'it','Impossibile utilizzare numeri o lettere come un carattere di delimitazione',0),(439585,12211,'tl','',0),(439586,12211,'th','à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹ƒà¸Šà¹‰à¸•à¸±à¸§à¹€à¸¥à¸‚à¸«à¸£à¸·à¸­à¸•à¸±à¸§à¸­à¸±à¸à¸©à¸£à¹€à¸›à¹‡à¸™à¸•à¸±à¸§à¸„à¸±à¹ˆà¸™',0),(439587,12211,'hi','à¤†à¤ªà¤•à¥‹ à¤à¤• à¤¸à¥€à¤®à¤¾à¤‚à¤•à¤• à¤µà¤°à¥à¤£ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¤‚à¤–à¥à¤¯à¤¾à¤“à¤‚ à¤…à¤¥à¤µà¤¾ à¤…à¤•à¥à¤·à¤°à¥‹à¤‚ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(439588,12211,'ms','Anda tidak boleh menggunakan nombor atau huruf sebagai watak delimiter',0),(439589,12211,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ†Ùƒ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø£Ø±Ù‚Ø§Ù… Ø£Ùˆ Ø§Ù„Ø­Ø±ÙˆÙ ÙƒØ­Ø±Ù Ù…Ø­Ø¯Ø¯',0),(439590,12211,'fr','Vous ne pouvez utiliser des chiffres ou des lettres comme un caractÃ¨re dÃ©limiteur',0),(439591,12211,'jp','ç•ªå·ã¾ãŸã¯æ–‡å­—ã‚’åŒºåˆ‡ã‚Šæ–‡å­—ã¨ã—ã¦ä½¿ç”¨ã§ãã¾ã›ã‚“ã€‚',0),(439592,12211,'pt','VocÃª nÃ£o pode usar nÃºmeros ou letras como um caractere delimitador',0),(439593,12211,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ñ†Ð¸Ñ„Ñ€Ñ‹ Ð¸Ð»Ð¸ Ð±ÑƒÐºÐ²Ñ‹ ÐºÐ°Ðº ÑÐ¸Ð¼Ð²Ð¾Ð»Ð°-Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»Ñ',0),(439594,12211,'es','No puede usar nÃºmeros o letras como carÃ¡cter de delimitaciÃ³n',0),(439595,12211,'de','Sie kÃ¶nnen nicht zahlen oder Buchstaben als ein Trennzeichen verwenden.',0),(439596,12211,'en','You cannot use numbers or letters as a delimiter character',0),(439597,12212,'is','',0),(439598,12212,'dr','- Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§',0),(439599,12212,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ- Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§',0),(439600,12212,'tr','Kurulum - BorÃ§lar',0),(439601,12212,'pl','Instalator - zobowiÄ…zania',0),(439602,12212,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ',0),(439603,12212,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ - Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³',0),(439604,12212,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(439605,12212,'vi','thiáº¿t láº­p -thanh toÃ¡n',0),(439606,12212,'af','Opstelling - Waardedalingstoetse',0),(439607,12212,'ro','Configurare - datorii',0),(439608,12212,'et','Setup - vÃµlad',0),(439609,12212,'si','Setup - obveznosti',0),(439610,12212,'ba','Pengaturan - hutang',0),(439611,12212,'nl','Setup - schulden',0),(439612,12212,'fi','Setup - Ostovelat',0),(439613,12212,'no','Oppsett - leverandÃ¸rgjeld',0),(439614,12212,'da','Setup - gÃ¦ld',0),(439615,12212,'ko','ì„¤ì •-ë¯¸ì§€ê¸‰ê¸ˆ',0),(439616,12212,'he','×”×’×“×¨×•×ª - ×–×›××™×',0),(439617,12212,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· - Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½',0),(439618,12212,'zh','è®¾ç½®-åº”ä»˜æ¬¾',0),(439619,12212,'sv','Setup - leverantÃ¶rsskulder',0),(439620,12212,'it','Installazione - debiti',0),(439621,12212,'tl','',0),(439622,12212,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² - à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰',0),(439623,12212,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - Payables',0),(439624,12212,'ms','Persediaan - pemiutang',0),(439625,12212,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(439626,12212,'fr','Configuration - comptes fournisseurs',0),(439627,12212,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— - è²·æŽ›é‡‘',0),(439628,12212,'pt','ConfiguraÃ§Ã£o - pagamentos',0),(439629,12212,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° - ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(439630,12212,'es','ConfiguraciÃ³n - Pagables',0),(439631,12212,'de','Setup - Verbindlichkeiten',0),(439632,12212,'en','Setup - Payables',0),(439633,12213,'is','',0),(439634,12213,'dr','- Ù…Ø¹Ø§Ø´ Ùˆ Ø­Ù‚ Ø§Ù„Ø²Ø­Ù…Ù‡',0),(439635,12213,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ- Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(439636,12213,'tr','Kurulum - bordro',0),(439637,12213,'pl','Instalator - listy pÅ‚ac',0),(439638,12213,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ð¢Ð Ð—',0),(439639,12213,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ - Ù¾Û’ Ø±ÙˆÙ„',0),(439640,12213,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - Ð¿Ð»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº',0),(439641,12213,'vi','thiÃªt láº­p- lÆ°Æ¡ng',0),(439642,12213,'af','Opstelling - heeltydse',0),(439643,12213,'ro','Configurare - salarizare',0),(439644,12213,'et','Setup - Palgaarvestus',0),(439645,12213,'si','Setup - izplaÄane plaÄe',0),(439646,12213,'ba','Pengaturan - penggajian',0),(439647,12213,'nl','Setup - Payroll',0),(439648,12213,'fi','Setup - Palkanlaskenta',0),(439649,12213,'no','Oppsett - lÃ¸nn',0),(439650,12213,'da','Setup - lÃ¸n',0),(439651,12213,'ko','ì„¤ì •-ê¸‰ì—¬',0),(439652,12213,'he','×”×’×“×¨×•×ª - ×ž×©×›×•×¨×•×ª',0),(439653,12213,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· - Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(439654,12213,'zh','è®¾ç½®-è–ªé…¬',0),(439655,12213,'sv','Setup - lÃ¶n',0),(439656,12213,'it','Installazione - Payroll',0),(439657,12213,'tl','',0),(439658,12213,'th','à¸•à¸´à¸”à¸•à¸±à¹‰à¸‡ - à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(439659,12213,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - à¤ªà¥‡à¤°à¥‹à¤²',0),(439660,12213,'ms','Persediaan - gaji',0),(439661,12213,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯--ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(439662,12213,'fr','Installation - paie',0),(439663,12213,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— - çµ¦ä¸Ž',0),(439664,12213,'pt','InstalaÃ§Ã£o - folha de pagamento',0),(439665,12213,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° - Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(439666,12213,'es','ConfiguraciÃ³n - NÃ³mina',0),(439667,12213,'de','Setup - Abrechnung',0),(439668,12213,'en','Setup - Payroll',0),(439669,12214,'is','',0),(439670,12214,'dr','Ù…Ø´Ø®ØµØ§Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(439671,12214,'pr','Ù…Ø´Ø®ØµØ§Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(439672,12214,'tr','Stok Ã¶zellikleri',0),(439673,12214,'pl','WÅ‚aÅ›ciwoÅ›ci zapasÃ³w',0),(439674,12214,'bg','Ð¡Ð²Ð¾Ð¹ÑÑ‚Ð²Ð° Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(439675,12214,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø®ÙˆØ§Øµ',0),(439676,12214,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(439677,12214,'vi','giÃ¡ trá»‹ hÃ ng hÃ³a',0),(439678,12214,'af','Inventaris eienskappe',0),(439679,12214,'ro','ProprietÄƒÅ£i de inventar',0),(439680,12214,'et','Varude atribuudid',0),(439681,12214,'si','Popis lastnosti',0),(439682,12214,'ba','Persediaan Properties',0),(439683,12214,'nl','Inventaris eigenschappen',0),(439684,12214,'fi','Varaston ominaisuudet',0),(439685,12214,'no','Lager egenskaper',0),(439686,12214,'da','Oversigt egenskaber',0),(439687,12214,'ko','ìž¬ê³  ì†ì„±',0),(439688,12214,'he','×ž××¤×™×™× ×™ ×ž×œ××™',0),(439689,12214,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î¹Î´Î¹ÏŒÏ„Î·Ï„ÎµÏ‚',0),(439690,12214,'zh','åº“å­˜å±žæ€§',0),(439691,12214,'sv','Egenskaper fÃ¶r lager',0),(439692,12214,'it','ProprietÃ  inventario',0),(439693,12214,'tl','',0),(439694,12214,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸‚à¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(439695,12214,'hi','à¤¸à¥‚à¤šà¥€ à¤—à¥à¤£',0),(439696,12214,'ms','Harta inventori',0),(439697,12214,'ar','Ø®ØµØ§Ø¦Øµ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(439698,12214,'fr','PropriÃ©tÃ©s de l\'inventaire',0),(439699,12214,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£',0),(439700,12214,'pt','Propriedades de inventÃ¡rio',0),(439701,12214,'ru','Ð¡Ð²Ð¾Ð¹ÑÑ‚Ð²Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(439702,12214,'es','Propiedades de Inventario',0),(439703,12214,'de','Inventareigenschaften',0),(439704,12214,'en','Inventory Properties',0),(439705,12215,'is','',0),(439706,12215,'dr','(Ø¬Ù†Ø³) Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ ÙØ±Ù…Ø§ÛŒØ´',0),(439707,12215,'pr','Ù…ÙˆØ§Ø±Ø¯ (Ú©Ø§Ù„Ø§) Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø³ÙØ§Ø±Ø´',0),(439708,12215,'tr','SipariÅŸi bekleyen Ã¶ÄŸeler iÃ§in',0),(439709,12215,'pl','PowrÃ³t zamawianych dla',0),(439710,12215,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð½ÐµÐ¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð° Ð·Ð°',0),(439711,12215,'ur','Ø§Ø´ÛŒØ§Ø¡ ÙˆØ§Ù¾Ø³ Ú©Û’ Ù„Ø¦Û’ Ø­Ú©Ù… Ø¯ÛŒØ§ Û”',0),(439712,12215,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ Ð¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸ Ð·Ð°',0),(439713,12215,'vi','cÃ¡c máº·t hÃ ng chÆ°a thá»±c hiá»‡n cho',0),(439714,12215,'af','Items bestel terug vir',0),(439715,12215,'ro','Elemente comandat Ã®napoi pentru',0),(439716,12215,'et','Tagasi tellitud kaubad',0),(439717,12215,'si','Elemente zaostala naroÄila za',0),(439718,12215,'ba','Item kembali memerintahkan untuk',0),(439719,12215,'nl','Artikelen besteld terug voor',0),(439720,12215,'fi','Takaisin tilatut nimikkeet',0),(439721,12215,'no','Elementer restordre for',0),(439722,12215,'da','Varer i restordre for',0),(439723,12215,'ko','í•­ëª© ë‹¤ì‹œ ì£¼ë¬¸',0),(439724,12215,'he','×¤×¨×™×˜×™× ×©×”×•×–×ž× ×• ×—×–×¨×” ×¢×‘×•×¨',0),(439725,12215,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„Î·Ï‚ Î³Î¹Î±',0),(439726,12215,'zh','é¡¹ç›®å¾…è¡¥',0),(439727,12215,'sv','BestÃ¤llda tillbaka fÃ¶r',0),(439728,12215,'it','Articoli ordinati indietro per',0),(439729,12215,'tl','',0),(439730,12215,'th','à¸à¸¥à¸±à¸šà¸ªà¸±à¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¸³à¸«à¸£à¸±à¸š',0),(439731,12215,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤ªà¤¸ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾',0),(439732,12215,'ms','Item-item yang kembali diperintahkan untuk',0),(439733,12215,'ar','Ø£Ù…Ø± ÙŠØ¹ÙˆØ¯ Ù„Ù„Ø¹Ù†Ø§ØµØ±',0),(439734,12215,'fr','Ã‰lÃ©ments pour livraison diffÃ©rÃ©es',0),(439735,12215,'jp','ãƒãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼',0),(439736,12215,'pt','Itens encomendados volta para',0),(439737,12215,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð½Ð°Ð·Ð°Ð´ Ð·Ð°ÐºÐ°Ð·Ð°Ð» Ð´Ð»Ñ',0),(439738,12215,'es','Items Previamente Ordenados para',0),(439739,12215,'de','Wieder fÃ¼r die bestellten Artikel',0),(439740,12215,'en','Items Back Ordered for',0),(439741,12216,'is','',0),(439742,12216,'dr','ØªØ§Ø±ÛŒØ®Ú†Ù‡ Ø³ÙØ§Ø±Ø´ Ú©Ø§Ù„Ø§ Ø¨Ø±Ø§ÛŒ',0),(439743,12216,'pr','ØªØ§Ø±ÛŒØ®Ú†Ù‡ Ø³ÙØ§Ø±Ø´ Ú©Ø§Ù„Ø§ Ø¨Ø±Ø§ÛŒ',0),(439744,12216,'tr','Madde iÃ§in sipariÅŸ geÃ§miÅŸi',0),(439745,12216,'pl','Element historii zamÃ³wieÅ„ dla',0),(439746,12216,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ Ñ…Ñ€Ð¾Ð½Ð¾Ð»Ð¾Ð³Ð¸ÑÑ‚Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð°',0),(439747,12216,'ur','Ø´Û’ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(439748,12216,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(439749,12216,'vi','Lá»‹ch sá»­ Ä‘áº·t hÃ ng cho',0),(439750,12216,'af','Item bestel geskiedenis vir',0),(439751,12216,'ro','Istoric comandÄƒ element pentru',0),(439752,12216,'et','Kauba tellimuste ajalugu',0),(439753,12216,'si','Element zgodovine naroÄil za',0),(439754,12216,'ba','Sejarah Orde item untuk',0),(439755,12216,'nl','Item bestellingshistorie voor',0),(439756,12216,'fi','Nimikkeen tilauksen historia',0),(439757,12216,'no','Elementet ordrehistorikk for',0),(439758,12216,'da','Vare ordrehistorik for',0),(439759,12216,'ko','í•­ëª©ì— ëŒ€ í•œ ì£¼ë¬¸ ë‚´ì—­',0),(439760,12216,'he','×”×™×¡×˜×•×¨×™×™×ª ×”×”×–×ž× ×•×ª ×¤×¨×™×˜ ×¢×‘×•×¨',0),(439761,12216,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ ÏƒÎµÎ¹ÏÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î³Î¹Î±',0),(439762,12216,'zh','é¡¹ç›®è®¢å•åŽ†å²è®°å½•',0),(439763,12216,'sv','Objektet orderhistorik fÃ¶r',0),(439764,12216,'it','Cronologia ordine elemento per',0),(439765,12216,'tl','',0),(439766,12216,'th','à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(439767,12216,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(439768,12216,'ms','Sejarah perintah item bagi',0),(439769,12216,'ar','Ø§Ù„Ø¨Ù†Ø¯ ØªØ±ØªÙŠØ¨ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(439770,12216,'fr','Point historique des commandes pour',0),(439771,12216,'jp','é …ç›®ã®æ³¨æ–‡å±¥æ­´',0),(439772,12216,'pt','HistÃ³rico de ordem do item para',0),(439773,12216,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð´Ð»Ñ',0),(439774,12216,'es','Item Historia de Orden para',0),(439775,12216,'de','Element-Bestellhistorie fÃ¼r',0),(439776,12216,'en','Item Order History for',0),(439777,12217,'is','',0),(439778,12217,'dr','Ø­Ù…Ù„ Ú©Ø§Ù„Ø§ Ø¨Ø±Ø§ÛŒ',0),(439779,12217,'pr','Ø­Ù…Ù„ Ú©Ø§Ù„Ø§ Ø¨Ø±Ø§ÛŒ',0),(439780,12217,'tr','Madde sevk irsaliyeleri iÃ§in',0),(439781,12217,'pl','WysyÅ‚ki towaru do',0),(439782,12217,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð°',0),(439783,12217,'ur','Ø´Û’ Ú©ÛŒ ØªØ±Ø³ÛŒÙ„ Ú©Û’ Ù„ÛŒÛ’',0),(439784,12217,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð·Ð°',0),(439785,12217,'vi','chuyá»ƒn hÃ ng cho',0),(439786,12217,'af','Item gestuur vir',0),(439787,12217,'ro','Transporturile de element pentru',0),(439788,12217,'et','Kauba veo eest',0),(439789,12217,'si','Element poÅ¡iljke za',0),(439790,12217,'ba','Pengiriman barang untuk',0),(439791,12217,'nl','Item verzendingen voor',0),(439792,12217,'fi','Nimikkeen koontilaskuja',0),(439793,12217,'no','Elementet forsendelser for',0),(439794,12217,'da','Vare leverancer for',0),(439795,12217,'ko','í•­ëª©ì— ëŒ€ í•œ ì¶œí•˜ ëŸ‰',0),(439796,12217,'he','×¤×¨×™×˜ ×œ×ž×©×œ×•×—×™×',0),(439797,12217,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³Î¹Î±',0),(439798,12217,'zh','é¡¹ç›®å‘è´§',0),(439799,12217,'sv','Objektet transporter fÃ¶r',0),(439800,12217,'it','Elemento spedizioni per',0),(439801,12217,'tl','',0),(439802,12217,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¸³à¸«à¸£à¸±à¸š',0),(439803,12217,'hi','à¤†à¤‡à¤Ÿà¤® à¤²à¤¦à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤',0),(439804,12217,'ms','Penghantaran item bagi',0),(439805,12217,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ø´Ø­Ù†Ø§Øª',0),(439806,12217,'fr','Arrivages de point',0),(439807,12217,'jp','é …ç›®ã®å‡ºè·',0),(439808,12217,'pt','Item transferÃªncias para',0),(439809,12217,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð´Ð»Ñ',0),(439810,12217,'es','Item EnvÃ­os para',0),(439811,12217,'de','Element Sendungen fÃ¼r',0),(439812,12217,'en','Item Shipments for',0),(439813,12218,'is','',0),(439814,12218,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù…Ù‚ÛŒØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÛŒ',0),(439815,12218,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù…Ù‚ÛŒØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÛŒ',0),(439816,12218,'tr','Derecelendirme Ã¶lÃ§eÄŸi ekleme',0),(439817,12218,'pl','Ocena skali dodaÄ‡',0),(439818,12218,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³Ð¾Ð²Ð° ÑÐºÐ°Ð»Ð°',0),(439819,12218,'ur','Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ù¾ÛŒÙ…Ø§Ù†Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(439820,12218,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÐºÐ°Ð»Ðµ',0),(439821,12218,'vi','Quy mÃ´ Ä‘Ã¡nh giÃ¡ thÃªm',0),(439822,12218,'af','Takseringskaal voeg',0),(439823,12218,'ro','Scala de evaluare Adauga',0),(439824,12218,'et','Skaala lisada',0),(439825,12218,'si','Dodaj rating lestvico',0),(439826,12218,'ba','Tambahkan skala rating',0),(439827,12218,'nl','Beoordelingsschaal toevoegen',0),(439828,12218,'fi','Arviointiasteikko lisÃ¤Ã¤',0),(439829,12218,'no','Vurderingsskala legge',0),(439830,12218,'da','BedÃ¸mmelsesskala tilfÃ¸je',0),(439831,12218,'ko','í‰ê°€ ì²™ë„ ì¶”ê°€',0),(439832,12218,'he','×¡×•×œ× ×“×™×¨×•×’ ×œ×”×•×¡×™×£',0),(439833,12218,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎºÎ»Î¯Î¼Î±ÎºÎ± Î´Î¹Î±Î²Î¬Î¸Î¼Î¹ÏƒÎ·Ï‚',0),(439834,12218,'zh','è¯„å®šé‡è¡¨æ·»åŠ ',0),(439835,12218,'sv','Skattningsskala lÃ¤gga till',0),(439836,12218,'it','Aggiungi scala di valutazione',0),(439837,12218,'tl','',0),(439838,12218,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸¡à¸²à¸•à¸£à¸²à¸ˆà¸±à¸”à¸­à¸±à¸™à¸”à¸±à¸š',0),(439839,12218,'hi','à¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¸à¥à¤•à¥‡à¤² à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(439840,12218,'ms','Tambah skala penilaian',0),(439841,12218,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù‚ÙŠØ§Ø³ Ø§Ù„ØªØµÙ†ÙŠÙ',0),(439842,12218,'fr','Ã‰chelle de cotation ajouter',0),(439843,12218,'jp','è©•ä¾¡å°ºåº¦ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(439844,12218,'pt','Escala de classificaÃ§Ã£o adicionar',0),(439845,12218,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ€ÐµÐ¹Ñ‚Ð¸Ð½Ð³Ð¾Ð²Ð°Ñ ÑˆÐºÐ°Ð»Ð°',0),(439846,12218,'es','Escala de calificaciÃ³n de aÃ±adir',0),(439847,12218,'de','Rating-Skala hinzufÃ¼gen',0),(439848,12218,'en','Rating Scale Add',0),(439849,12219,'is','',0),(439850,12219,'dr','Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù…Ù‚ÛŒØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÛŒ',0),(439851,12219,'pr','Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù…Ù‚ÛŒØ§Ø³ Ø¯Ø±Ø¬Ù‡ Ø¨Ù†Ø¯ÛŒ',0),(439852,12219,'tr','Derecelendirme Ã¶lÃ§eÄŸi gÃ¼ncelleÅŸtirme',0),(439853,12219,'pl','Ocena skali aktualizacji',0),(439854,12219,'bg','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³ Ð¼Ð°Ñ‰Ð°Ð± Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(439855,12219,'ur','Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ Ù¾ÛŒÙ…Ø§Ù†Û’ Ù¾Ø± ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(439856,12219,'sr','Ð ÐµÑ˜Ñ‚Ð¸Ð½Ð³ ÑÐºÐ°Ð»Ð° Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(439857,12219,'vi','ÄÃ¡nh giÃ¡ quy mÃ´ Cáº­p Nháº­t',0),(439858,12219,'af','Gradering skaal bywerking',0),(439859,12219,'ro','Rating scarÄƒ Update',0),(439860,12219,'et','Reitingu skaala Update',0),(439861,12219,'si','Ocena obsega posodobitev',0),(439862,12219,'ba','Peringkat skala Update',0),(439863,12219,'nl','Rating schaal Update',0),(439864,12219,'fi','Rating Scale pÃ¤ivitys',0),(439865,12219,'no','Vurdering skala oppdatering',0),(439866,12219,'da','BedÃ¸mmelse skala opdatering',0),(439867,12219,'ko','ë“±ê¸‰ ê·œëª¨ ì—…ë°ì´íŠ¸',0),(439868,12219,'he','×¢×“×›×•×Ÿ ×¡×•×œ× ×“×™×¨×•×’',0),(439869,12219,'el','Î’Î±Î¸Î¼Î¿Î»Î¿Î³Î¯Î± ÎºÎ»Î¯Î¼Î±ÎºÎ± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(439870,12219,'zh','è¯„çº§è§„æ¨¡æ›´æ–°',0),(439871,12219,'sv','Rating Scale uppdatering',0),(439872,12219,'it','Aggiornamento di scala di valutazione',0),(439873,12219,'tl','',0),(439874,12219,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸°à¸”à¸±à¸šà¸„à¸°à¹à¸™à¸™',0),(439875,12219,'hi','à¤¦à¤°à¥à¤œà¤¼à¤¾ à¤ªà¥ˆà¤®à¤¾à¤¨à¥‡ à¤ªà¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(439876,12219,'ms','Kemaskini skala penilaian',0),(439877,12219,'ar','ØªØ­Ø¯ÙŠØ« Ø¬Ø¯ÙˆÙ„ Ø§Ù„ØªØ±ØªÙŠØ¨',0),(439878,12219,'fr','Mise Ã  jour Ã©chelle de notation',0),(439879,12219,'jp','è©•ä¾¡ã‚¹ã‚±ãƒ¼ãƒ«æ›´æ–°',0),(439880,12219,'pt','AtualizaÃ§Ã£o da escala de classificaÃ§Ã£o',0),(439881,12219,'ru','Ð ÐµÐ¹Ñ‚Ð¸Ð½Ð³ ÑˆÐºÐ°Ð»Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(439882,12219,'es','ActualizaciÃ³n de la escala de calificaciÃ³n',0),(439883,12219,'de','Rating-Skala-Update',0),(439884,12219,'en','Rating Scale Update',0),(439885,12220,'is','',0),(439886,12220,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(439887,12220,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø¬Ù… Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª',0),(439888,12220,'tr','Servis sipariÅŸ birimi raporu',0),(439889,12220,'pl','UsÅ‚ugi zamÃ³wienia raportu',0),(439890,12220,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¾Ð±ÐµÐ¼ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(439891,12220,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨ ØµÙˆØª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(439892,12220,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(439893,12220,'vi','BÃ¡o cÃ¡o khá»‘i lÆ°á»£ng dá»‹ch vá»¥',0),(439894,12220,'af','Diens bestel Volume verslag',0),(439895,12220,'ro','Serviciu comanda volum raport',0),(439896,12220,'et','Teenuse tellimuse mahu aruande',0),(439897,12220,'si','PoroÄilo o obseg naroÄil storitev',0),(439898,12220,'ba','Layanan urutan Volume laporan',0),(439899,12220,'nl','Rapport Service Order Volume',0),(439900,12220,'fi','Huoltotilauksen mÃ¤Ã¤rÃ¤-raportti',0),(439901,12220,'no','Tjenesten Volume rapport',0),(439902,12220,'da','Tjenesten Order volumen rapport',0),(439903,12220,'ko','ì„œë¹„ìŠ¤ ì˜¤ë” ëŸ‰ ë³´ê³ ì„œ',0),(439904,12220,'he','×©×™×¨×•×ª ×”×–×ž× ×ª ×›×¨×š ×—',0),(439905,12220,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î¿ ÏŒÎ³ÎºÎ¿Ï‚ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ·',0),(439906,12220,'zh','æœåŠ¡è®¢å•é‡æŠ¥å‘Š',0),(439907,12220,'sv','TjÃ¤nsten BestÃ¤ll rapporten volym',0),(439908,12220,'it','Rapporto Volume servizio ordine',0),(439909,12220,'tl','',0),(439910,12220,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸›à¸£à¸´à¸¡à¸²à¸“à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸šà¸£à¸´à¸à¸²à¸£',0),(439911,12220,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤µà¥‰à¤²à¥à¤¯à¥‚à¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(439912,12220,'ms','Laporan jumlah pesanan Perkhidmatan',0),(439913,12220,'ar','ØªÙ‚Ø±ÙŠØ± Ø­Ø¬Ù… Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(439914,12220,'fr','Service commande Volume rapport',0),(439915,12220,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã®ãƒœãƒªãƒ¥ãƒ¼ãƒ  ãƒ¬ãƒãƒ¼ãƒˆ',0),(439916,12220,'pt','RelatÃ³rio de Volume de ordem de serviÃ§o',0),(439917,12220,'ru','Ð¡Ð»ÑƒÐ¶Ð±Ð° Ð·Ð°ÐºÐ°Ð·Ð° Ð¾Ð±ÑŠÐµÐ¼ Ð´Ð¾ÐºÐ»Ð°Ð´Ð°',0),(439918,12220,'es','Informe de Volumen de Orden de Servicios',0),(439919,12220,'de','Bestellung Band Servicebericht',0),(439920,12220,'en','Service Order Volume Report',0),(439921,12221,'is','',0),(439922,12221,'dr','Ù…Ø¬Ù…ÙˆØ¹ ØªØ¹Ù‡Ø¯',0),(439923,12221,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªØ¹Ù‡Ø¯',0),(439924,12221,'tr','Ä°ÅŸlenen Toplam',0),(439925,12221,'pl','Suma popeÅ‚nionych',0),(439926,12221,'bg','ÐžÐ±Ñ‰Ð¾ Ð¸Ð·Ð²ÑŠÑ€ÑˆÐµÐ½Ð¸',0),(439927,12221,'ur','Ú©Ù„ Ú©Ø§ Ø§Ø±ØªÚ©Ø§Ø¨ Ú©ÛŒØ§',0),(439928,12221,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¿Ð¾Ñ‡Ð¸Ð½Ð¸Ð»Ð¸',0),(439929,12221,'vi','Tá»•ng sá»‘ cam káº¿t',0),(439930,12221,'af','Totaal gepleeg',0),(439931,12221,'ro','Total angajat',0),(439932,12221,'et','Toime kokku',0),(439933,12221,'si','Skupno storila',0),(439934,12221,'ba','Total berkomitmen',0),(439935,12221,'nl','Totaal vastgelegd',0),(439936,12221,'fi','YhteensÃ¤ sitoutunut',0),(439937,12221,'no','Totalt forpliktet',0),(439938,12221,'da','Total begÃ¥et',0),(439939,12221,'ko','ì´ íˆ¬ìž…',0),(439940,12221,'he','×¡×” ×› ×‘×™×¦×¢',0),(439941,12221,'el','Î£ÏÎ½Î¿Î»Î¿ Ï„Î¿ Î´Î¹Î±Ï€ÏÎ¬Î¾ÎµÎ¹',0),(439942,12221,'zh','æ€»ä½£é‡‘',0),(439943,12221,'sv','Totalt begÃ¥tt',0),(439944,12221,'it','Totale impegnato',0),(439945,12221,'tl','',0),(439946,12221,'th','à¸œà¸¥à¸£à¸§à¸¡à¸—à¸µà¹ˆà¸¡à¸¸à¹ˆà¸‡à¸¡à¸±à¹ˆà¸™',0),(439947,12221,'hi','à¤•à¥à¤² à¤ªà¥à¤°à¤¤à¤¿à¤¬à¤¦à¥à¤§',0),(439948,12221,'ms','Jumlah yang komited',0),(439949,12221,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ø±ØªÙƒØ¨Øª',0),(439950,12221,'fr','Commis au total',0),(439951,12221,'jp','ã‚³ãƒŸãƒƒãƒˆåˆè¨ˆ',0),(439952,12221,'pt','Total comprometido',0),(439953,12221,'ru','Ð’ÑÐµÐ³Ð¾ ÑÐ¾Ð²ÐµÑ€ÑˆÐ¸Ð»',0),(439954,12221,'es','Total Comprometido',0),(439955,12221,'de','Insgesamt begangen',0),(439956,12221,'en','Total Committed',0),(439957,12222,'is','',0),(439958,12222,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯Ù‡Ù… \"Ø§Ø²\" Ùˆ Ù‡Ù… \"Ø¨Ù‡\"  Ø±Ø§ Ø¨Ø±Ø§ÛŒ ÛŒÚ© Ø¬Ù†Ø³ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒÙ…',0),(439959,12222,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯Ù‡Ù… \"Ø§Ø²\" Ùˆ Ù‡Ù… \"Ø¨Ù‡\"  Ø±Ø§ Ø¨Ø±Ø§ÛŒ ÛŒÚ© Ú©Ø§Ù„Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒÙ…',0),(439960,12222,'tr','Her ikisi de girmeniz gerekir ve bir \"e\" Ã¼rÃ¼n (ler) iÃ§in bir \"Kimden\"',0),(439961,12222,'pl','Musi podaÄ‡ zarÃ³wno w \"z\" i \"do\" dla elementÃ³w',0),(439962,12222,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸ Ð´Ð²ÐµÑ‚Ðµ \"Ð¾Ñ‚\" Ð¸ \"Ð´Ð°\" Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(439963,12222,'ur','Ø¢Ù¾ Ø¯ÙˆÙ†ÙˆÚº Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’ Ø§ÛŒÚ© \"Ø³Û’\" Ø§ÙˆØ± \"Ú©Ùˆ\" Ø§Ø´ÛŒØ§ Ú©Û’ Ù„ÛŒÛ’',0),(439964,12222,'sr','ÐžÐ±Ð¾Ñ˜Ðµ Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ ÑƒÐ½ÐµÑ‚Ð¸ \"Ð¾Ð´\" Ð¸ \"Ð´Ð¾\" Ð·Ð° ÑÑ‚Ð°Ð²ÐºÐµ',0),(439965,12222,'vi','Báº¡n pháº£i nháº­p cáº£ 2 \" tá»«\"....\"Ä‘áº¿n\"',0),(439966,12222,'af','U moet beide \"vanaf\" en \'n \"na\" invoer vir item(e)',0),(439967,12222,'ro','Trebuie sÄƒ introduceÅ£i atÃ¢t un \"de\" ÅŸi un \"la\" pentru elementul sau elementele',0),(439968,12222,'et','Peate sisestama nii \"alates\" ja \"-\" Ã¼ksuste jaoks',0),(439969,12222,'si','Vnesti morate tako \"iz\" in \"da\" za elemente',0),(439970,12222,'ba','Anda harus memasukkan kedua \"dari\" dan sebuah \"untuk\" untuk item',0),(439971,12222,'nl','U moet zowel een \'van\' en een \'aan\' voor object(en)',0),(439972,12222,'fi','Anna molemmat \"alkaen\" ja \"to\" nimikkeelle',0),(439973,12222,'no','Du mÃ¥ angi bÃ¥de \"fra\" og \"til\" for element(er)',0),(439974,12222,'da','Du skal angive bÃ¥de en \"fra\" og en \"til\" for element(er)',0),(439975,12222,'ko','ëª¨ë‘ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤ \"ì—ì„œ\"ì™€ \"to\" í•­ëª©ì— ëŒ€ í•œ',0),(439976,12222,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×©× ×™×”× \"×ž×ª×•×š\" ×•×’× \"××œ\" ×¢×‘×•×¨ ×¤×¨×™×˜×™×',0),(439977,12222,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ Î´ÏÎ¿ \"Î±Ï€ÏŒ\" ÎºÎ±Î¹ \"ÏƒÎµ\" Î³Î¹Î± Ï„Î¿ Ï€ÏÎ¿ÏŠÏŒÎ½ (Ï„Î±)',0),(439978,12222,'zh','ä½ å¿…é¡»è¾“å…¥é¡¹ç›®çš„å‘ä»¶äººä¸Žæ”¶ä»¶äºº',0),(439979,12222,'sv','Du mÃ¥ste ange bÃ¥de en \"frÃ¥n\" och en \"till\" fÃ¶r objekt',0),(439980,12222,'it','Ãˆ necessario inserire sia un \"da\" e \"a\" per voce',0),(439981,12222,'tl','',0),(439982,12222,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸—à¸±à¹‰à¸‡ à¸—à¸µà¹ˆ \"à¸ˆà¸²à¸\" à¹à¸¥à¸° \"à¸–à¸¶à¸‡\" à¹ƒà¸™à¸£à¸²à¸¢à¸à¸²à¸£',0),(439983,12222,'hi','à¤†à¤ª à¤¦à¥‹à¤¨à¥‹à¤‚ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾ à¤à¤• \"à¤¸à¥‡\" à¤”à¤° \"to\" à¤®à¤¦ (s) à¤•à¥‡ à¤²à¤¿à¤',0),(439984,12222,'ms','Anda mesti masukkan kedua-dua \"dari\" dan \"ke\" bagi item',0),(439985,12222,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ Ø¹Ù„Ù‰ Ø­Ø¯ Ø³ÙˆØ§Ø¡ ÙÙŠ \"Ù…Ù†\" Ùˆ \"Ø¥Ù„Ù‰\" Ù„Ù„Ø¹Ù†ØµØ± (Ø§Ù„Ø¹Ù†Ø§ØµØ±)',0),(439986,12222,'fr','Vous devez entrer tous les deux un Â« de Â» et un Â« Ã  Â» pour l\'article (s)',0),(439987,12222,'jp','ä¸¡æ–¹ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™\"from\"ã¨\"to\"ã®é …ç›®ã®',0),(439988,12222,'pt','VocÃª deve digitar os dois \"de\" e um \"a\" para o item (ns)',0),(439989,12222,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¾Ð±Ð° Â«Ð¾Ñ‚Â» Ð¸ Â«Ð²Â» Ð´Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(439990,12222,'es','Debe entrar tanto un \"De\" como un \"A\" para item(s)',0),(439991,12222,'de','Sie mâ¿ssen beide ein \"von\" und \"zu\" Item(s)',0),(439992,12222,'en','You must enter both a \"from\" and a \"to\" for item(s)',0),(439993,12223,'is','',0),(439994,12223,'dr','-Ø¬Ø²ÛŒÛŒØ§Øª(Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(439995,12223,'pr','Ø¯ÙˆØ¨Ø§Ø±Ù‡-Ø¬Ø²ÛŒÛŒØ§Øª(Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(439996,12223,'tr','YaÅŸlanma - detaylar (BorÃ§lar)',0),(439997,12223,'pl','Starzenie siÄ™ - szczegÃ³Å‚y (zobowiÄ…zania)',0),(439998,12223,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ - Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ (Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ)',0),(439999,12223,'ur','Ø®Ø³ØªÛ - ØªÙØµÛŒÙ„Ø§Øª (Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³)',0),(440000,12223,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ - Ð´ÐµÑ‚Ð°Ñ™Ð¸ (Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°)',0),(440001,12223,'vi','Chi tiáº¿t cÃ´ng ná»£ (pháº£i tráº£)',0),(440002,12223,'af','Veroudering - besonderhede (Waardedalingstoetse)',0),(440003,12223,'ro','ÃŽmbÄƒtrÃ¢nirea - detalii (cumpÄƒrÄƒri ÅŸi datorii)',0),(440004,12223,'et','Vananemine - Details (vÃµlad)',0),(440005,12223,'si','Staranje - podrobnosti (obveznosti)',0),(440006,12223,'ba','Penuaan - rincian (kewajiban)',0),(440007,12223,'nl','Veroudering - Details (inkoop)',0),(440008,12223,'fi','IkÃ¤Ã¤ntyminen - tiedot (velat)',0),(440009,12223,'no','Aldring - detaljer (leverandÃ¸rgjeld)',0),(440010,12223,'da','Aldring - detaljer (gÃ¦ld)',0),(440011,12223,'ko','ë…¸í™”-ì„¸ë¶€ (ë¯¸ì§€ê¸‰ê¸ˆ)',0),(440012,12223,'he','×”×–×“×§× ×•×ª - ×¤×¨×˜×™× (×–×›××™×)',0),(440013,12223,'el','Î“Î®ÏÎ±Î½ÏƒÎ· - Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ (Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚)',0),(440014,12223,'zh','æ¬ æ•°åˆ†æž-ç»†èŠ‚ï¼ˆåº”ä»˜ï¼‰',0),(440015,12223,'sv','Ã…ldrande - Detaljer (leverantÃ¶rsskulder)',0),(440016,12223,'it','Invecchiamento - dettagli (debiti)',0),(440017,12223,'tl','',0),(440018,12223,'th','à¸­à¸²à¸¢à¸¸ - à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸” (à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰)',0),(440019,12223,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ - à¤µà¤¿à¤µà¤°à¤£ (Payables)',0),(440020,12223,'ms','Butir-butir penuaan - (pemiutang)',0),(440021,12223,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©-ØªÙØ§ØµÙŠÙ„ (Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹)',0),(440022,12223,'fr','Vieillissement - dÃ©tails (comptes fournisseurs)',0),(440023,12223,'jp','é«˜é½¢åŒ– - è©³ç´° ï¼ˆè²·æŽ›é‡‘ï¼‰',0),(440024,12223,'pt','Envelhecimento - detalhes (contas a pagar)',0),(440025,12223,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ - Ð´ÐµÑ‚Ð°Ð»Ð¸ (ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ)',0),(440026,12223,'es','Envejecimiento - Detalles (Cuentas por Pagar)',0),(440027,12223,'de','Aging - Details (Kreditoren)',0),(440028,12223,'en','Aging - Details (Payables)',0),(440029,12224,'is','',0),(440030,12224,'dr','Ù…Ø¯Ø§Ø±Ú© ØµÙˆØ±Øª Ù…ØºØ§ÛŒØ±Øª Ø¨Ø§Ù†Ú©',0),(440031,12224,'pr','Ù…Ø¯Ø§Ø±Ú© ØµÙˆØ±Øª Ù…ØºØ§ÛŒØ±Øª Ø¨Ø§Ù†Ú©',0),(440032,12224,'tr','Banka mutabakatÄ± belgeler',0),(440033,12224,'pl','Bank pojednania dokumentÃ³w',0),(440034,12224,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð° ÑÑŠÐ¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(440035,12224,'ur','Ø¨ÛŒÙ†Ú© Ù…ÙØ§ÛÙ…ØªÛŒ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(440036,12224,'sr','Ð‘Ð°Ð½ÐºÐ° Ð¿Ð¾Ð¼Ð¸Ñ€ÐµÑšÐµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ð°Ñ‚Ð°',0),(440037,12224,'vi','Chá»©ng tá»« Ä‘á»‘i chiáº¿u ngÃ¢n hÃ ng',0),(440038,12224,'af','Bank Rekonsiliasie Dokumente',0),(440039,12224,'ro','Documente de reconciliere bancÄƒ',0),(440040,12224,'et','Panga vastavusseviimise dokumendid',0),(440041,12224,'si','BanÄnega usklajevanja dokumentov',0),(440042,12224,'ba','Dokumen-dokumen rekonsiliasi Bank',0),(440043,12224,'nl','Bank verzoening documenten',0),(440044,12224,'fi','Sovinnon pankkitositteiden',0),(440045,12224,'no','Bank avstemming dokumenter',0),(440046,12224,'da','Bank forsoning dokumenter',0),(440047,12224,'ko','ì€í–‰ ì¡°ì • ë¬¸ì„œ',0),(440048,12224,'he','×ž×¡×ž×›×™× ×‘× ×§××™×™× ×¤×™×•×¡',0),(440049,12224,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÏƒÏ…Î¼Ï†Î¹Î»Î¯Ï‰ÏƒÎ· Î­Î³Î³ÏÎ±Ï†Î±',0),(440050,12224,'zh','é“¶è¡Œå¯¹å¸æ–‡ä»¶',0),(440051,12224,'sv','FÃ¶rsoning bankdokument',0),(440052,12224,'it','Documenti di riconciliazione banca',0),(440053,12224,'tl','',0),(440054,12224,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¸à¸²à¸£à¸à¸£à¸°à¸—à¸šà¸¢à¸­à¸”à¸˜à¸™à¸²à¸„à¸²à¸£',0),(440055,12224,'hi','à¤¬à¥ˆà¤‚à¤• à¤¸à¥à¤²à¤¹ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚',0),(440056,12224,'ms','Dokumen-dokumen Penyata penyesuaian Bank',0),(440057,12224,'ar','ÙˆØ«Ø§Ø¦Ù‚ Ù…ØµØ±ÙÙŠØ© Ø§Ù„Ù…ØµØ§Ù„Ø­Ø©',0),(440058,12224,'fr','Documents de rapprochement bancaire',0),(440059,12224,'jp','éŠ€è¡Œå’Œè§£æ–‡æ›¸',0),(440060,12224,'pt','Documentos de reconciliaÃ§Ã£o bancÃ¡ria',0),(440061,12224,'ru','Ð‘Ð°Ð½Ðº Ð¿Ñ€Ð¸Ð¼Ð¸Ñ€ÐµÐ½Ð¸ÑŽ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(440062,12224,'es','Documentos de ReconciliaciÃ³n Bancaria',0),(440063,12224,'de','VersÃ¶hnung Bankunterlagen',0),(440064,12224,'en','Bank Reconciliation Documents',0),(440065,12225,'is','',0),(440066,12225,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª Ø´Ø±Ø§ÛŒØ· Ù„Ø§Ø²Ù… Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(440067,12225,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª Ø´Ø±Ø§ÛŒØ· Ù„Ø§Ø²Ù… Ù¾ÙˆÙ„ Ù†Ù‚Ø¯',0),(440068,12225,'tr','Nakit gereksinim ayrÄ±ntÄ±larÄ±',0),(440069,12225,'pl','GotÃ³wki wymÃ³g szczegÃ³Å‚y',0),(440070,12225,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ Ð¸Ð·Ð¸ÑÐºÐ²Ð°Ð½Ðµ Ð·Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(440071,12225,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(440072,12225,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¾ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ð¸ ÑƒÑÐ»Ð¾Ð²',0),(440073,12225,'vi','Chi tiáº¿t YÃªu cáº§u tiá»n máº·t',0),(440074,12225,'af','Kontant Behoefte Besonderhede',0),(440075,12225,'ro','Detalii de cerinÅ£a de numerar',0),(440076,12225,'et','Raha nÃµude Ã¼ksikasjad',0),(440077,12225,'si','Denar zahteva podrobnosti',0),(440078,12225,'ba','Rincian kebutuhan uang tunai',0),(440079,12225,'nl','Contant geld vereiste Details',0),(440080,12225,'fi','Cash tiedot',0),(440081,12225,'no','Detaljer for signaturkrav for kontanter',0),(440082,12225,'da','Kontante krav detaljer',0),(440083,12225,'ko','í˜„ê¸ˆ ìš”êµ¬ ì„¸ë¶€ ì‚¬í•­',0),(440084,12225,'he','×ž×–×•×ž× ×™× ×“×¨×™×©×ª ×¤×¨×˜×™×',0),(440085,12225,'el','ÎœÎµÏ„ÏÎ·Ï„Î¬ Î±Ï€Î±Î¯Ï„Î·ÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(440086,12225,'zh','çŽ°é‡‘éœ€æ±‚ç»†èŠ‚',0),(440087,12225,'sv','Kontanter krav Detaljer',0),(440088,12225,'it','Contanti requisito dettagli',0),(440089,12225,'tl','',0),(440090,12225,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹€à¸‡à¸´à¸™à¸ªà¸”',0),(440091,12225,'hi','à¤¨à¤•à¤¦ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(440092,12225,'ms','Butir-butir keperluan Wang Tunai',0),(440093,12225,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…ØªØ·Ù„Ø¨Ø§Øª Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(440094,12225,'fr','TrÃ©sorerie exigence dÃ©tails',0),(440095,12225,'jp','ç¾é‡‘ã®è¦ä»¶ã®è©³ç´°',0),(440096,12225,'pt','Detalhes de exigÃªncia de dinheiro',0),(440097,12225,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸Ñ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(440098,12225,'es','Detalles de Requerimiento de Efectivo',0),(440099,12225,'de','Bargeld-Anforderung-Details',0),(440100,12225,'en','Cash Requirement Details',0),(440101,12226,'is','',0),(440102,12226,'dr','ÙØ±Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¯Ú©ØªØ±',0),(440103,12226,'pr','ÙØ±Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¯Ú©ØªØ±',0),(440104,12226,'tr','Doktor istek formu',0),(440105,12226,'pl','Formularz wniosku lekarz',0),(440106,12226,'bg','Ð¤Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€ Ð·Ð° Ð¸ÑÐºÐ°Ð½Ðµ Ð½Ð° Ð»ÐµÐºÐ°Ñ€',0),(440107,12226,'ur','ÚˆØ§Ú©Ù¹Ø± Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙØ§Ø±Ù…',0),(440108,12226,'sr','ÐžÐ±Ñ€Ð°Ð·Ð°Ñ† Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° Ð´Ð¾ÐºÑ‚Ð¾Ñ€Ðµ',0),(440109,12226,'vi','Máº«u yÃªu cáº§u bÃ¡c sÄ©',0),(440110,12226,'af','Dokter versoek vorm',0),(440111,12226,'ro','Formular de cerere de doctor',0),(440112,12226,'et','Arst taotlusvorm',0),(440113,12226,'si','Zdravnik obrazec',0),(440114,12226,'ba','Formulir permintaan dokter',0),(440115,12226,'nl','Arts-aanvraagformulier',0),(440116,12226,'fi','LÃ¤Ã¤kÃ¤ri lomake',0),(440117,12226,'no','Legen skjema',0),(440118,12226,'da','LÃ¦ge anmodning Form',0),(440119,12226,'ko','ì˜ì‚¬ ìš”ì²­ ì–‘ì‹',0),(440120,12226,'he','×˜×•×¤×¡ ×‘×§×©×ª ×”×¨×•×¤×',0),(440121,12226,'el','Î¦ÏŒÏÎ¼Î± Î±Î¯Ï„Î·ÏƒÎ·Ï‚ Î³Î¹Î±Ï„ÏÏŒÏ‚',0),(440122,12226,'zh','åŒ»ç”Ÿè¯·æ±‚è¡¨æ ¼',0),(440123,12226,'sv','LÃ¤kare formulÃ¤r',0),(440124,12226,'it','Modulo di richiesta del medico',0),(440125,12226,'tl','',0),(440126,12226,'th','à¹à¸šà¸šà¸Ÿà¸­à¸£à¹Œà¸¡à¸„à¸³à¸‚à¸­à¸‚à¸­à¸‡à¹à¸žà¸—à¸¢à¹Œ',0),(440127,12226,'hi','à¤¡à¥‰à¤•à¥à¤Ÿà¤° à¤…à¤¨à¥à¤°à¥‹à¤§ à¤«à¥‰à¤°à¥à¤®',0),(440128,12226,'ms','Borang permohonan doktor',0),(440129,12226,'ar','Ù†Ù…ÙˆØ°Ø¬ Ø·Ù„Ø¨ Ø§Ù„Ø·Ø¨ÙŠØ¨',0),(440130,12226,'fr','Formulaire de demande de mÃ©decin',0),(440131,12226,'jp','åŒ»è€…ã®è¦æ±‚ãƒ•ã‚©ãƒ¼ãƒ ',0),(440132,12226,'pt','FormulÃ¡rio de pedido mÃ©dico',0),(440133,12226,'ru','Ð”Ð¾ÐºÑ‚Ð¾Ñ€ Ñ„Ð¾Ñ€Ð¼Ð° Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(440134,12226,'es','Forma de Pedido Para Medico',0),(440135,12226,'de','Arzt-Anfrageformular',0),(440136,12226,'en','Doctor Request Form',0),(440137,12227,'is','',0),(440138,12227,'dr','Ù„ÛŒØ³Øª Ø®Ø±ÛŒØ¯Ù‡Ø§ÛŒ Ú©Ø§Ø± Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(440139,12227,'pr','Ù„ÛŒØ³Øª Ø®Ø±ÛŒØ¯Ù‡Ø§ÛŒ Ú©Ø§Ø± Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(440140,12227,'tr','Kredi kartÄ± SatÄ±nalmalar listesi',0),(440141,12227,'pl','Lista zakupÃ³w kartÄ… kredytowÄ…',0),(440142,12227,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(440143,12227,'ur','ÙÛØ±Ø³Øª Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(440144,12227,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ðµ',0),(440145,12227,'vi','Danh sÃ¡ch mua qua tháº» tÃ­n dá»¥ng ',0),(440146,12227,'af','Lys kredietkaart aankope',0),(440147,12227,'ro','Lista de Card de Credit cumpÄƒrÄƒri',0),(440148,12227,'et','Nimekiri krediitkaardiga ostude',0),(440149,12227,'si','Seznam nakup s kreditno kartico',0),(440150,12227,'ba','Daftar kartu kredit pembelian',0),(440151,12227,'nl','Lijst Credit Card aankopen',0),(440152,12227,'fi','Luettelo luottokorttiostoissa',0),(440153,12227,'no','Listen kredittkortkjÃ¸p',0),(440154,12227,'da','Liste kreditkort kÃ¸b',0),(440155,12227,'ko','ëª©ë¡ ì‹ ìš© ì¹´ë“œ êµ¬ë§¤',0),(440156,12227,'he','×¨×›×™×©×•×ª ×‘×›×¨×˜×™×¡×™ ××©×¨××™ ×¨×©×™×ž×”',0),(440157,12227,'el','Î›Î¯ÏƒÏ„Î± Î±Î³Î¿ÏÎ­Ï‚ Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(440158,12227,'zh','ä¿¡ç”¨å¡é‡‡è´­åˆ—è¡¨',0),(440159,12227,'sv','Lista kreditkortskÃ¶p',0),(440160,12227,'it','Elenco acquisti di carta di credito',0),(440161,12227,'tl','',0),(440162,12227,'th','à¸‹à¸·à¹‰à¸­à¸£à¸²à¸¢à¸Šà¸·à¹ˆà¸­à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(440163,12227,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤¸à¥‚à¤šà¥€',0),(440164,12227,'ms','Senarai kad kredit pembelian',0),(440165,12227,'ar','Ù‚Ø§Ø¦Ù…Ø© Ù…Ø´ØªØ±ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(440166,12227,'fr','Liste des achats par carte de crÃ©dit',0),(440167,12227,'jp','ä¸€è¦§ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è³¼å…¥',0),(440168,12227,'pt','Lista compras com cartÃ£o de crÃ©dito',0),(440169,12227,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(440170,12227,'es','Listar compras por Tarjetas de CrÃ©dito',0),(440171,12227,'de','Liste KreditkartenkÃ¤ufe',0),(440172,12227,'en','List Credit Card Purchases',0),(440173,12228,'is','',0),(440174,12228,'dr','-Ø¬Ø²Ø¦ÛŒØ§Øª(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§',0),(440175,12228,'pr','Ø¯ÙˆØ¨Ø§Ø±Ù‡-Ø¬Ø²Ø¦ÛŒØ§Øª(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§',0),(440176,12228,'tr','YaÅŸlanma - detaylar (BorÃ§lar)',0),(440177,12228,'pl','Starzenie siÄ™ - szczegÃ³Å‚y (zobowiÄ…zania)',0),(440178,12228,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ - Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ (Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ)',0),(440179,12228,'ur','Ø®Ø³ØªÛ - ØªÙØµÛŒÙ„Ø§Øª (Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³)',0),(440180,12228,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ - Ð´ÐµÑ‚Ð°Ñ™Ð¸ (Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°)',0),(440181,12228,'vi','Aging- chi tiáº¿t ( pháº£i tráº£)',0),(440182,12228,'af','Veroudering - besonderhede (Waardedalingstoetse)',0),(440183,12228,'ro','ÃŽmbÄƒtrÃ¢nirea - detalii (cumpÄƒrÄƒri ÅŸi datorii)',0),(440184,12228,'et','Vananemine - Details (vÃµlad)',0),(440185,12228,'si','Staranje - podrobnosti (obveznosti)',0),(440186,12228,'ba','Penuaan - rincian (kewajiban)',0),(440187,12228,'nl','Veroudering - Details (inkoop)',0),(440188,12228,'fi','IkÃ¤Ã¤ntyminen - tiedot (velat)',0),(440189,12228,'no','Aldring - detaljer (leverandÃ¸rgjeld)',0),(440190,12228,'da','Aldring - detaljer (gÃ¦ld)',0),(440191,12228,'ko','ë…¸í™”-ì„¸ë¶€ (ë¯¸ì§€ê¸‰ê¸ˆ)',0),(440192,12228,'he','×”×–×“×§× ×•×ª - ×¤×¨×˜×™× (×–×›××™×)',0),(440193,12228,'el','Î“Î®ÏÎ±Î½ÏƒÎ· - Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ (Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚)',0),(440194,12228,'zh','æ¬ æ•°-æ˜Žç»†ï¼ˆåº”ä»˜æ¬¾ï¼‰',0),(440195,12228,'sv','Ã…ldrande - Detaljer (leverantÃ¶rsskulder)',0),(440196,12228,'it','Invecchiamento - dettagli (debiti)',0),(440197,12228,'tl','',0),(440198,12228,'th','à¸­à¸²à¸¢à¸¸ - à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸” (à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰)',0),(440199,12228,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ - à¤µà¤¿à¤µà¤°à¤£ (Payables)',0),(440200,12228,'ms','Butir-butir penuaan - (pemiutang)',0),(440201,12228,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©-ØªÙØ§ØµÙŠÙ„ (Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹)',0),(440202,12228,'fr','Vieillissement - dÃ©tails (comptes fournisseurs)',0),(440203,12228,'jp','é«˜é½¢åŒ– - è©³ç´° ï¼ˆè²·æŽ›é‡‘ï¼‰',0),(440204,12228,'pt','Envelhecimento - detalhes (contas a pagar)',0),(440205,12228,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ - Ð´ÐµÑ‚Ð°Ð»Ð¸ (ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ)',0),(440206,12228,'es','Envejecimiento - Detalles (Pagables)',0),(440207,12228,'de','Aging - Details (Kreditoren)',0),(440208,12228,'en','Aging - Details (Payables)',0),(440209,12229,'is','',0),(440210,12229,'dr','-Ø®Ù„Ø§ØµÙ‡(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§',0),(440211,12229,'pr','Ø¯ÙˆØ¨Ø§Ø±Ù‡-Ø®Ù„Ø§ØµÙ‡(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§',0),(440212,12229,'tr','YaÅŸlanma - Ã–zet (BorÃ§lar)',0),(440213,12229,'pl','Starzenie siÄ™ - podsumowanie (zobowiÄ…zania)',0),(440214,12229,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ - Ð ÐµÐ·ÑŽÐ¼Ðµ (Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ)',0),(440215,12229,'ur','Ø®Ø³ØªÛ - Ø®Ù„Ø§ØµÛ (Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³)',0),(440216,12229,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ - Ñ€ÐµÐ·Ð¸Ð¼Ðµ (Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°)',0),(440217,12229,'vi','Aging- tá»•ng há»£p ( pháº£i tráº£)',0),(440218,12229,'af','Veroudering - opsomming (Waardedalingstoetse)',0),(440219,12229,'ro','ÃŽmbÄƒtrÃ¢nirea - Rezumat (cumpÄƒrÄƒri ÅŸi datorii)',0),(440220,12229,'et','Vananemine - kokkuvÃµte (vÃµlad)',0),(440221,12229,'si','Staranje - Povzetek (obveznosti)',0),(440222,12229,'ba','Penuaan - ringkasan (kewajiban)',0),(440223,12229,'nl','Veroudering - samenvatting (inkoop)',0),(440224,12229,'fi','IkÃ¤Ã¤ntyminen - Yhteenveto (velat)',0),(440225,12229,'no','Aldring - Sammendrag (leverandÃ¸rgjeld)',0),(440226,12229,'da','Aldring - ResumÃ© (gÃ¦ld)',0),(440227,12229,'ko','ë…¸í™”-ìš”ì•½ (ë¯¸ì§€ê¸‰ê¸ˆ)',0),(440228,12229,'he','×”×–×“×§× ×•×ª - ×¡×™×›×•× (×–×›××™×)',0),(440229,12229,'el','Î“Î®ÏÎ±Î½ÏƒÎ· - Î ÎµÏÎ¯Î»Î·ÏˆÎ· (Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚)',0),(440230,12229,'zh','æ¬ æ•°-æ‘˜è¦ï¼ˆåº”ä»˜æ¬¾ï¼‰',0),(440231,12229,'sv','Ã…ldrande - Sammanfattning (leverantÃ¶rsskulder)',0),(440232,12229,'it','Invecchiamento - Riassunto (debiti)',0),(440233,12229,'tl','',0),(440234,12229,'th','à¸­à¸²à¸¢à¸¸ - à¸ªà¸£à¸¸à¸› (à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰)',0),(440235,12229,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ - à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ (Payables)',0),(440236,12229,'ms','Penuaan - ringkasan (pemiutang)',0),(440237,12229,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©-Ù…Ù„Ø®Øµ (Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹)',0),(440238,12229,'fr','Vieillissement - RÃ©sumÃ© (comptes fournisseurs)',0),(440239,12229,'jp','é«˜é½¢åŒ– - æ¦‚è¦ ï¼ˆè²·æŽ›é‡‘ï¼‰',0),(440240,12229,'pt','Envelhecimento - Resumo (contas a pagar)',0),(440241,12229,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ - Ñ€ÐµÐ·ÑŽÐ¼Ðµ (ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ)',0),(440242,12229,'es','Envejecimiento - Sumario (Pagables)',0),(440243,12229,'de','Aging - Zusammenfassung (Kreditoren)',0),(440244,12229,'en','Aging - Summary (Payables)',0),(440245,12230,'is','',0),(440246,12230,'dr','-ØªØ®ÙÛŒÙ(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§',0),(440247,12230,'pr','Ø¯ÙˆØ¨Ø§Ø±Ù‡-ØªØ®ÙÛŒÙ(Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§',0),(440248,12230,'tr','YaÅŸlanma - indirim (BorÃ§lar)',0),(440249,12230,'pl','Starzenie siÄ™ - rabat (zobowiÄ…zania)',0),(440250,12230,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ - Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ° (Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ)',0),(440251,12230,'ur','Ø®Ø³ØªÛ - Ø±Ø¹Ø§ÛŒØª (Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³)',0),(440252,12230,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐµ - Ð¿Ð¾Ð¿ÑƒÑÑ‚ (Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°)',0),(440253,12230,'vi','Aging- giáº£m giÃ¡ ( pháº£i tráº£)',0),(440254,12230,'af','Veroudering - afslag (Waardedalingstoetse)',0),(440255,12230,'ro','ÃŽmbÄƒtrÃ¢nirea - Discount (cumpÄƒrÄƒri ÅŸi datorii)',0),(440256,12230,'et','Vananemine - Soodus (vÃµlad)',0),(440257,12230,'si','Staranje - popust (obveznosti)',0),(440258,12230,'ba','Penuaan - diskon (kewajiban)',0),(440259,12230,'nl','Veroudering - korting (inkoop)',0),(440260,12230,'fi','IkÃ¤Ã¤ntyminen - alennus (velat)',0),(440261,12230,'no','Aldring - rabatt (leverandÃ¸rgjeld)',0),(440262,12230,'da','Aldring - rabat (gÃ¦ld)',0),(440263,12230,'ko','ë…¸í™”-í• ì¸ (ë¯¸ì§€ê¸‰ê¸ˆ)',0),(440264,12230,'he','×”×–×“×§× ×•×ª - ×”× ×—×” (×–×›××™×)',0),(440265,12230,'el','Î“Î®ÏÎ±Î½ÏƒÎ· - Î­ÎºÏ€Ï„Ï‰ÏƒÎ· (Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚)',0),(440266,12230,'zh','æ¬ æ•°-æŠ˜æ‰£ï¼ˆåº”ä»˜ï¼‰',0),(440267,12230,'sv','Ã…ldrande - rabatt (leverantÃ¶rsskulder)',0),(440268,12230,'it','Invecchiamento - sconto (debiti)',0),(440269,12230,'tl','',0),(440270,12230,'th','à¸£à¸´à¹‰à¸§à¸£à¸­à¸¢ - à¸¥à¸” (à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰)',0),(440271,12230,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡ - à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ (Payables)',0),(440272,12230,'ms','Penuaan - diskaun (pemiutang)',0),(440273,12230,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©-Ø§Ù„Ø®ØµÙ… (Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹)',0),(440274,12230,'fr','Vieillissement - Discount (comptes fournisseurs)',0),(440275,12230,'jp','é«˜é½¢åŒ– - å‰²å¼• ï¼ˆè²·æŽ›é‡‘ï¼‰',0),(440276,12230,'pt','Envelhecimento - desconto (contas a pagar)',0),(440277,12230,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ - ÑÐºÐ¸Ð´ÐºÐ° (ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ)',0),(440278,12230,'es','Envejecimiento - Descuento (Pagables)',0),(440279,12230,'de','Aging - Rabatt (Kreditoren)',0),(440280,12230,'en','Aging - Discount (Payables)',0),(440281,12231,'is','',0),(440282,12231,'dr','Ù„Ø·ÙØ§ Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÛŒØ¯ Ø§Ú¯Ø± Ø¯Ø± Ø´Ø¨Ú©Ù‡ Ø¯Ø§Ø®Ù„ÛŒ Ø§Ù…Ù†ÛŒØª Ø¯Ø§Ø±ÛŒØ¯ ',0),(440283,12231,'pr','Ù„Ø·ÙØ§ Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÛŒØ¯ Ø§Ú¯Ø± Ø¯Ø± Ø´Ø¨Ú©Ù‡ Ø¯Ø§Ø®Ù„ÛŒ Ø§Ù…Ù†ÛŒØª Ø¯Ø§Ø±ÛŒØ¯ ',0),(440284,12231,'tr','Ancak <b>gÃ¼venli</b> bir iÃ§ aÄŸ Ã¼zerinde iseniz, lÃ¼tfen devam edin',0),(440285,12231,'pl','Wykonaj tylko wtedy, gdy jesteÅ› na <b>bezpieczne</b> sieci wewnÄ™trznej',0),(440286,12231,'bg','ÐœÐ¾Ð»Ñ Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶ÐµÑ‚Ðµ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð²Ð¸Ðµ ÑÑ‚Ðµ Ð½Ð° <b>ÑÐ¸Ð³ÑƒÑ€Ð½Ð°</b> Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð° Ð¼Ñ€ÐµÐ¶Ð°',0),(440287,12231,'ur','Ø§Ú¯Ø± Ø¢Ù¾ ØµØ±Ù Ø§ÛŒÚ© <b>Ù…Ø­ÙÙˆØ¸</b> Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ù†ÛŒÙ¹ ÙˆØ±Ú© Ù¾Ø± ÛÛŒÚº ØªÙˆ Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¢Ú¯Û’ Ø¨Ú‘Ú¾Ù†Ø§',0),(440288,12231,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ, Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÑÑ‚Ðµ Ð½Ð° <b>ÑÐ¸Ð³ÑƒÑ€Ð½Ñƒ</b> Ð¸Ð½Ñ‚ÐµÑ€Ð½Ðµ Ð¼Ñ€ÐµÐ¶Ðµ',0),(440289,12231,'vi','vui lÃ²ng thá»±c hiá»‡n náº¿u báº¡n á»Ÿ <b>cháº¯c cháº¯n</b> máº¡ng ná»™i bá»™',0),(440290,12231,'af','Asseblief voort net as jy op \'n <b>veilige</b> interne netwerk',0),(440291,12231,'ro','VÄƒ rugÄƒm sÄƒ continuaÅ£i numai dacÄƒ sunt pe o reÅ£ea <b>securizatÄƒ</b> interne',0),(440292,12231,'et','Palun Tutvu ainult siis, kui olete <b>turvalist</b> sisevÃµrgus',0),(440293,12231,'si','Nadaljujte le, Äe ste na <b>varnih</b> notranjega omreÅ¾ja',0),(440294,12231,'ba','Lanjutkan hanya jika Anda berada di jaringan internal yang <b>aman</b>',0),(440295,12231,'nl','Ga alleen als u op een <b>beveiligd</b> intern netwerk bent',0),(440296,12231,'fi','Jatka vain, jos olet <b>suojatun</b> sisÃ¤isen verkon',0),(440297,12231,'no','Fortsett bare hvis du er pÃ¥ en <b>sikker</b> interne nettverket',0),(440298,12231,'da','FortsÃ¦t kun hvis du er pÃ¥ et <b>sikkert</b> indre netvÃ¦rk',0),(440299,12231,'ko','<b>ì•ˆì „í•œ</b> ë‚´ë¶€ ë„¤íŠ¸ì›Œí¬ì— ìžˆëŠ” ê²½ìš°ì— ì§„í–‰ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(440300,12231,'he','. ×× × ×”×ž×©×š ×¨×§ ×× ××ª×” × ×ž×¦× ×‘×¨×©×ª ×¤× ×™×ž×™×ª <b>×ž××•×‘×˜×—×ª</b>',0),(440301,12231,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï€ÏÎ¿Ï‡Ï‰ÏÎ®ÏƒÏ„Îµ Î¼ÏŒÎ½Î¿ Î±Î½ ÎµÎ¯ÏƒÏ„Îµ ÏƒÎµ Î­Î½Î± <b>Î±ÏƒÏ†Î±Î»Î­Ï‚</b> Î´Î¯ÎºÏ„Ï…Î¿ ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ®Ï‚',0),(440302,12231,'zh','åªæœ‰å½“æ‚¨åœ¨å®‰å…¨çš„å†…éƒ¨ç½‘ç»œä¸­æ—¶è¯·å¤„ç†',0),(440303,12231,'sv','FortsÃ¤tt bara om du Ã¤r i ett <b>sÃ¤kert</b> interna nÃ¤tverk',0),(440304,12231,'it','Si prega di procedere solo se siete su una rete interna <b>sicura</b>',0),(440305,12231,'tl','',0),(440306,12231,'th','à¸à¸£à¸¸à¸“à¸²à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™à¸–à¹‰à¸²à¸„à¸¸à¸“à¸­à¸¢à¸¹à¹ˆà¸šà¸™à¹€à¸„à¸£à¸·à¸­à¸‚à¹ˆà¸²à¸¢à¸ à¸²à¸¢à¹ƒà¸™<b>à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢</b>',0),(440307,12231,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤†à¤—à¥‡ à¤¬à¤¢à¤¼à¤¨à¤¾ à¤¹à¥€ à¤…à¤—à¤° à¤¤à¥à¤® à¤à¤• <b>à¤¸à¥à¤°à¤•à¥à¤·à¤¿à¤¤</b> à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¨à¥‡à¤Ÿà¤µà¤°à¥à¤• à¤ªà¤°',0),(440308,12231,'ms','Sila teruskan hanya jika anda berada dalam rangkaian dalaman yang <b>selamat</b>',0),(440309,12231,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„Ù…ØªØ§Ø¨Ø¹Ø© ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒÙ†Øª ØªØ¹Ù…Ù„ Ø¹Ù„Ù‰ Ø´Ø¨ÙƒØ© Ø¯Ø§Ø®Ù„ÙŠØ© <b>Ø¢Ù…Ù†Ø©</b>',0),(440310,12231,'fr','Veuillez procÃ©der uniquement si vous Ãªtes sur un rÃ©seau interne <b>sÃ©curisÃ©</b>',0),(440311,12231,'jp','<b>ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£ã§ä¿è­·ã•ã‚ŒãŸ</b>å†…éƒ¨ãƒãƒƒãƒˆãƒ¯ãƒ¼ã‚¯ä¸Šã«ã‚ã‚‹å ´åˆã«ã®ã¿é€²ã‚“ã§ãã ã•ã„ã€‚',0),(440312,12231,'pt','Por favor, prossiga apenas se vocÃª estiver em uma rede interna <b>segura</b>',0),(440313,12231,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²ÑƒÐ¹Ñ‚Ðµ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð²Ñ‹ Ð½Ð°Ñ…Ð¾Ð´Ð¸Ñ‚ÐµÑÑŒ Ð² <b>Ð±ÐµÐ·Ð¾Ð¿Ð°ÑÐ½Ð¾Ð¹</b> Ð²Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÐµÐ¹ ÑÐµÑ‚Ð¸',0),(440314,12231,'es','Por Favor procede solo si esta en un red internal <b>seguro</b>',0),(440315,12231,'de','Bitte gehen Sie nur, wenn Sie in einem <b>sicheren</b> internen Netzwerk befinden',0),(440316,12231,'en','Please proceed only if you are on a <b>secure</b> internal network',0),(440317,12232,'is','',0),(440318,12232,'dr','..Ù†Ø±Ø® Ø¯Ø³ØªØ±Ø³ÛŒ Ú†Ú© Ù‡Ø§ÛŒ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ú¯Ø±ÙˆÙ‡ ',0),(440319,12232,'pr','Ú†Ø§Ù¾ ..Ù†Ø±Ø® Ø¯Ø³ØªØ±Ø³ÛŒ Ú†Ú© Ù‡Ø§ÛŒ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ú¯Ø±ÙˆÙ‡ ',0),(440320,12232,'tr','YazdÄ±rma AR iadesi grubunda kontrol eder.',0),(440321,12232,'pl','Zwrot AR wydruku sprawdza w grupie',0),(440322,12232,'bg','ÐŸÐµÑ‡Ð°Ñ‚ AR Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð² Ð³Ñ€ÑƒÐ¿Ð°',0),(440323,12232,'ur','Ú¯Ø±ÙˆÙ¾ Ù…ÛŒÚº Ù¾Ø±Ù†Ù¹ Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’',0),(440324,12232,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ ÐÐ  Ñ€ÐµÑ„ÑƒÐ½Ð´Ð°Ñ†Ð¸Ñ˜Ñƒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð° Ñƒ Ð³Ñ€ÑƒÐ¿Ð¸',0),(440325,12232,'vi','in hÃ ng bÃ¡n tráº£ láº¡i kiá»ƒm tra trong nhÃ³m',0),(440326,12232,'af','Druk AR terugbetaling kontroleer in groep',0),(440327,12232,'ro','Imprimare AR restituire controale Ã®n grup',0),(440328,12232,'et','Prindi AR toetuse kontrollib rÃ¼hma',0),(440329,12232,'si','Natisni AR nadomestila preveri v skupini',0),(440330,12232,'ba','Pengembalian AR cetak cek dalam kelompok',0),(440331,12232,'nl','Afdrukken AR restitutie controles in groep',0),(440332,12232,'fi','Tulosta AR hyvitys tarkistaa ryhmÃ¤ssÃ¤',0),(440333,12232,'no','Skriv ut AR refusjon sjekker i gruppen',0),(440334,12232,'da','Udskriv AR restitution kontrollerer i gruppen',0),(440335,12232,'ko','ê·¸ë£¹ì—ì„œ ì¸ì‡„ ì•„ì¹¸ì†Œ í™˜ë¶ˆ í™•ì¸',0),(440336,12232,'he','×©×™×§×™× ×©×œ ×”×“×¤×¡×” AR ×”×—×–×¨ ×‘×§×‘×•×¦×”',0),(440337,12232,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· AR ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚ ÎµÎ»Î­Î³Ï‡ÎµÎ¹ ÏƒÏ„Î·Î½ Î¿Î¼Î¬Î´Î±',0),(440338,12232,'zh','æ‰“å°åº”æ”¶è´¦æ¬¾æ”¯ç¥¨ç»„',0),(440339,12232,'sv','Skriv ut AR Ã¥terbetalning kontroller i grupp',0),(440340,12232,'it','Rimborso stampa AR controlla in gruppo',0),(440341,12232,'tl','',0),(440342,12232,'th','à¸žà¸´à¸¡à¸žà¹Œ AR à¸„à¸·à¸™à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹ƒà¸™à¸à¸¥à¸¸à¹ˆà¸¡',0),(440343,12232,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤à¤†à¤° à¤µà¤¾à¤ªà¤¸à¥€ à¤®à¥‡à¤‚ à¤¸à¤®à¥‚à¤¹ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(440344,12232,'ms','Bayaran balik AR cetak menyemak dalam Kumpulan',0),(440345,12232,'ar','Ø±Ø¯ Ø¹ Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª ÙÙŠ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(440346,12232,'fr','Les chÃ¨ques de remboursement de l\'imprimÃ© AR en groupe',0),(440347,12232,'jp','ã‚°ãƒ«ãƒ¼ãƒ—å†…ãƒã‚§ãƒƒã‚¯å°åˆ· AR æ‰•ã„æˆ»ã—',0),(440348,12232,'pt','RestituiÃ§Ã£o de impressÃ£o AR verifica em grupo',0),(440349,12232,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ AR Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚ Ð² Ð³Ñ€ÑƒÐ¿Ð¿Ðµ',0),(440350,12232,'es','Imprime CC cheques de devoluciÃ³n en un grupo',0),(440351,12232,'de','Drucken AR Erstattung prÃ¼ft in Gruppe',0),(440352,12232,'en','Print AR refund checks in group',0),(440353,12233,'is','',0),(440354,12233,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª Ø³ÙˆØ¯ Ùˆ Ø²ÛŒØ§Ù†',0),(440355,12233,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª Ø³ÙˆØ¯ Ùˆ Ø²ÛŒØ§Ù†',0),(440356,12233,'tr','Kar & kaybÄ± - deyim',0),(440357,12233,'pl','Zysk & straty - instrukcja',0),(440358,12233,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð° & Ð·Ð°Ð³ÑƒÐ±Ð° - Ð´ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ',0),(440359,12233,'ur','Ù…Ù†Ø§ÙØ¹ & Ù†Ù‚ØµØ§Ù† - Ø¨ÛŒØ§Ù†',0),(440360,12233,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð°Ðº Ð¸ Ð³ÑƒÐ±Ð¸Ñ‚Ð°Ðº - Ð¸Ð·Ñ˜Ð°Ð²Ð°',0),(440361,12233,'vi','bÃ¡o cÃ¡o lá»— lÃ£i',0),(440362,12233,'af','Wins & Verlies - Staat',0),(440363,12233,'ro','Profitul & pierdere - declaraÅ£ie',0),(440364,12233,'et','Kasum & kadu - avaldus',0),(440365,12233,'si','DobiÄek & izgubo - izjava',0),(440366,12233,'ba','Keuntungan & kerugian - pernyataan',0),(440367,12233,'nl','Winst & verlies - verklaring',0),(440368,12233,'fi','Voitto & tappio - ilmoitus',0),(440369,12233,'no','Fortjeneste & tap - setning',0),(440370,12233,'da','Profit & tab - erklÃ¦ring',0),(440371,12233,'ko','ì´ìµ & ì†ì‹¤-ë¬¸',0),(440372,12233,'he','×¨×•×•×— & ××•×‘×“×Ÿ - ×”×¦×”×¨×”',0),(440373,12233,'el','ÎšÎ­ÏÎ´Î¿Ï‚ & Î±Ï€ÏŽÎ»ÎµÎ¹Î± - Î´Î®Î»Ï‰ÏƒÎ·',0),(440374,12233,'zh','æŸç›Šè¡¨',0),(440375,12233,'sv','Vinst & fÃ¶rlust - uttalande',0),(440376,12233,'it','Profitto & perdita - istruzione',0),(440377,12233,'tl','',0),(440378,12233,'th','à¸à¸³à¹„à¸£ & à¸‚à¸²à¸”à¸—à¸¸à¸™ - à¸‡à¸š',0),(440379,12233,'hi','à¤²à¤¾à¤­ & à¤¹à¤¾à¤¨à¤¿ - à¤µà¤•à¥à¤¤à¤µà¥à¤¯',0),(440380,12233,'ms','Keuntungan & kerugian - penyata',0),(440381,12233,'ar','Ø§Ù„Ø±Ø¨Ø­ Ø¢Ù†Ø¯ Ø§Ù„Ø®Ø³Ø§Ø±Ø©-Ø§Ù„Ø¨ÙŠØ§Ù†',0),(440382,12233,'fr','Profit & perte - dÃ©claration',0),(440383,12233,'jp','åˆ©ç›Š & æå¤± - ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆ',0),(440384,12233,'pt','Lucro & perda - instruÃ§Ã£o',0),(440385,12233,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ & Ð¿Ð¾Ñ‚ÐµÑ€Ð¸ - Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(440386,12233,'es','Estado de Resultados - DeclaraciÃ³n',0),(440387,12233,'de','Gewinn & Loss - Anweisung',0),(440388,12233,'en','Profit & Loss - Statement',0),(440389,12234,'is','',0),(440390,12234,'dr','  Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø³Ù†ÛŒ Ù…Ø·Ø§Ù„Ø¨Ø§Øª ',0),(440391,12234,'pr','  Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø³Ù†ÛŒ Ù…Ø·Ø§Ù„Ø¨Ø§Øª ',0),(440392,12234,'tr','YaÅŸlanma alacaklar',0),(440393,12234,'pl','NaleÅ¼noÅ›ci starzenia siÄ™',0),(440394,12234,'bg','Ð’Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ',0),(440395,12234,'ur','Ø®Ø³ØªÛ Ø±ÛŒÚ©ÛŒÙˆØ§Ø¨Ù„Ø§Ø³',0),(440396,12234,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° ÑÑ‚Ð°Ñ€ÐµÑšÐ°',0),(440397,12234,'vi','pháº£i thu chung',0),(440398,12234,'af','Bedrae ontvangbaar veroudering',0),(440399,12234,'ro','CreanÅ£e de imbatranire',0),(440400,12234,'et','NÃµuded vananemist',0),(440401,12234,'si','StarajoÄe se terjatve',0),(440402,12234,'ba','Piutang penuaan',0),(440403,12234,'nl','Vorderingen veroudering',0),(440404,12234,'fi','Vanhenevat saatavat',0),(440405,12234,'no','Ihendehavender',0),(440406,12234,'da','Tilgodehavender, aldersfordelte',0),(440407,12234,'ko','ë¯¸ìˆ˜ê¸ˆ ì—ì´ì§•',0),(440408,12234,'he','×’×™×•×œ ×—×©×‘×•× ×•×ª ×œ×§×‘×œ',0),(440409,12234,'el','Î•Î½Î·Î»Î¹ÎºÎ¯Ï‰ÏƒÎ· Ï…Ï€Î¿Î»Î¿Î¯Ï€Ï‰Î½',0),(440410,12234,'zh','åº”æ”¶è´¦æ¬¾è´¦é¾„',0),(440411,12234,'sv','Fordringar Ã¥ldrande',0),(440412,12234,'it','Crediti di invecchiamento',0),(440413,12234,'tl','',0),(440414,12234,'th','à¸­à¸²à¸¢à¸¸à¸¥à¸¹à¸à¸«à¸™à¸µà¹‰',0),(440415,12234,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¥‹à¤‚ à¤à¤œà¤¿à¤‚à¤—',0),(440416,12234,'ms','Penghutang penuaan',0),(440417,12234,'ar','ØªÙ‚Ø§Ø¯Ù… Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(440418,12234,'fr','CrÃ©ances de vieillissement',0),(440419,12234,'jp','å…¥é‡‘äºˆå®š',0),(440420,12234,'pt','RecebÃ­veis de envelhecimento',0),(440421,12234,'ru','Ð”ÐµÐ±Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸',0),(440422,12234,'es','Envejecimiento de Pagables',0),(440423,12234,'de','Forderungen, die Alterung',0),(440424,12234,'en','Receivables Aging',0),(440425,12235,'is','',0),(440426,12235,'dr','Ø¬Ø²ÛŒØ¦Ø§Øª Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø³Ù†ÛŒ Ù…Ø·Ø§Ù„Ø¨Ø§Øª',0),(440427,12235,'pr','Ø¬Ø²ÛŒØ¦Ø§Øª Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø³Ù†ÛŒ Ù…Ø·Ø§Ù„Ø¨Ø§Øª',0),(440428,12235,'tr','AyrÄ±ntÄ±lar yaÅŸlanma alacaklar',0),(440429,12235,'pl','NaleÅ¼noÅ›ci starzenia siÄ™ szczegÃ³Å‚y',0),(440430,12235,'bg','Ð’Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ, ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(440431,12235,'ur','ØªÙØµÛŒÙ„Ø§Øª Ø®Ø³ØªÛ Ø±ÛŒÚ©ÛŒÙˆØ§Ø¨Ù„Ø§Ø³',0),(440432,12235,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° ÑÑ‚Ð°Ñ€ÐµÑšÐ° Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(440433,12235,'vi','Chi tiáº¿t pháº£i thu chung',0),(440434,12235,'af','Bedrae ontvangbaar veroudering besonderhede',0),(440435,12235,'ro','CreanÅ£e imbatranire detalii',0),(440436,12235,'et','NÃµuded vananemist Ã¼ksikasjad',0),(440437,12235,'si','Podrobnosti starajoÄe se terjatve',0),(440438,12235,'ba','Piutang penuaan rincian',0),(440439,12235,'nl','Vorderingen veroudering Details',0),(440440,12235,'fi','Vanhenevat saatavat tiedot',0),(440441,12235,'no','Detaljer for ihendehavender',0),(440442,12235,'da','Tilgodehavender, aldersfordelte detaljer',0),(440443,12235,'ko','ë¯¸ìˆ˜ê¸ˆ ì—ì´ì§• ì„¸ë¶€ ì •ë³´',0),(440444,12235,'he','×¤×¨×˜×™× ×’×™×•×œ ×—×©×‘×•× ×•×ª ×œ×§×‘×œ',0),(440445,12235,'el','Î•Î½Î·Î»Î¹ÎºÎ¯Ï‰ÏƒÎ· Ï…Ï€Î¿Î»Î¿Î¯Ï€Ï‰Î½ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(440446,12235,'zh','åº”æ”¶è´¦æ¬¾è´¦é¾„æ˜Žç»†',0),(440447,12235,'sv','Fordringar Ã¥ldrande Detaljer',0),(440448,12235,'it','Crediti invecchiamento dettagli',0),(440449,12235,'tl','',0),(440450,12235,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸à¸²à¸£à¸„à¸³à¸™à¸§à¸“à¸­à¸²à¸¢à¸¸à¸šà¸±à¸à¸Šà¸µà¸¥à¸¹à¸à¸«à¸™à¸µà¹‰',0),(440451,12235,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿à¤¯à¥‹à¤‚ à¤µà¤¿à¤µà¤°à¤£ à¤à¤œà¤¿à¤‚à¤—',0),(440452,12235,'ms','Penghutang penuaan butir-butir',0),(440453,12235,'ar','Ù…Ø³ØªØ­Ù‚Ø§Øª Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(440454,12235,'fr','CrÃ©ances vieillissement dÃ©tails',0),(440455,12235,'jp','å…¥é‡‘äºˆå®šè©³ç´°',0),(440456,12235,'pt','Contas a receber detalhes do envelhecimento',0),(440457,12235,'ru','Ð”ÐµÐ±Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½ÐµÐµ',0),(440458,12235,'es','Detalles de Envejecimiento de Pagables',0),(440459,12235,'de','Forderungen, die Alterung Details',0),(440460,12235,'en','Receivables Aging Details',0),(440461,12236,'is','',0),(440462,12236,'dr','\r\nÙ…Ù‚Ø§Ø¯ÛŒØ± \"Ø§Ø²\" Ùˆ \"Ø¨Ù‡\" Ø¨Ø§ÛŒØ¯ ØªØ·Ø¨ÛŒÙ‚ Ú©Ù†Ø¯',0),(440463,12236,'pr','\r\nÙ…Ù‚Ø§Ø¯ÛŒØ± \"Ø§Ø²\" Ùˆ \"Ø¨Ù‡\" Ø¨Ø§ÛŒØ¯ ØªØ·Ø¨ÛŒÙ‚ Ú©Ù†Ø¯',0),(440464,12236,'tr','\"Ä°lk\" ve \"son\" miktarlarÄ± aynÄ± olmalÄ±dÄ±r',0),(440465,12236,'pl','\"Z\" i \"do\" iloÅ›ci muszÄ… odpowiadaÄ‡',0),(440466,12236,'bg','\"ÐžÑ‚\" Ð¸ \"Ð´Ð¾\" ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð°Ñ‚',0),(440467,12236,'ur','\"Ø³Û’\" Ø§ÙˆØ± \"Ú©Ùˆ\" Ù…Ù‚Ø¯Ø§Ø± Ø³Û’ Ù…Ø´Ø§Ø¨Û ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(440468,12236,'sr','ÐÐ° \"Ð¾Ð´\" Ð¸ \"Ð´Ð¾\" ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ Ð¼Ð¾Ñ€Ð°Ñ˜Ñƒ Ð´Ð° ÑÐµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ',0),(440469,12236,'vi','Sá»‘ lÆ°á»£ng \" tá»«\" vÃ  \"Ä‘áº¿n\" pháº£i khá»›p',0),(440470,12236,'af','Die \"van\" en \"na\" hoeveelhede moet ooreenstem',0),(440471,12236,'ro','\"La\" ÅŸi \"la\" cantitÄƒÅ£ile trebuie sÄƒ corespundÄƒ',0),(440472,12236,'et','Selle \"alates\" ja \"kuni\" kogused tuleb Ã¼hti',0),(440473,12236,'si','Na \"iz\" in \"da\" koliÄine ujemati',0),(440474,12236,'ba','\"Dari\" dan \"untuk\" jumlah harus cocok',0),(440475,12236,'nl','Het \"van\" en \"naar\" hoeveelheden moet overeenkomen met',0),(440476,12236,'fi','\"Alkaen\" ja \"to\" mÃ¤Ã¤rien on vastattava',0),(440477,12236,'no','Den \"fra\" og \"til\" antall mÃ¥ samsvare',0),(440478,12236,'da','Den \"fra\" og \"til\" mÃ¦ngder skal stemme overens',0),(440479,12236,'ko','\"\"ì™€ \"\"ì„ ìˆ˜ëŸ‰ ì¼ì¹˜ í•´ì•¼ í•©ë‹ˆë‹¤',0),(440480,12236,'he','\"×ž\" \"×œ\" ×›×ž×•×™×•×ª ×œ×”×ª××™×',0),(440481,12236,'el','Î¤Î¿ \"Î±Ï€ÏŒ\" ÎºÎ±Î¹ \"Î½Î±\" Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½',0),(440482,12236,'zh','å‘é€æ–¹ä¸ŽæŽ¥æ”¶æ–¹æ•°é‡å¿…é¡»åŒ¹é…',0),(440483,12236,'sv','Den \"frÃ¥n\" och \"till\" kvantiteter mÃ¥ste matcha',0),(440484,12236,'it','Il \"da\" e \"a\" quantitÃ  deve corrispondere',0),(440485,12236,'tl','',0),(440486,12236,'th','\"à¸ˆà¸²à¸\" à¹à¸¥à¸° \"à¸à¸±à¸š\" à¸›à¸£à¸´à¸¡à¸²à¸“à¸•à¹‰à¸­à¸‡à¸•à¸£à¸‡à¸à¸±à¸š',0),(440487,12236,'hi','\"à¤¸à¥‡\" à¤”à¤° \"à¤•à¥‹\" à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(440488,12236,'ms','Dalam \"dari\" dan \"ke\" kuantiti mesti sepadan dengan',0),(440489,12236,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ \"Ù…Ù†\" Ùˆ \"Ø¥Ù„Ù‰\" ÙƒÙ…ÙŠØ§Øª',0),(440490,12236,'fr','Le Â« from Â» et Â« Ã  Â» quantitÃ©s doivent correspondre',0),(440491,12236,'jp','\"From\"ã¨\"to\"ã®æ•°é‡ã«ä¸€è‡´ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™',0),(440492,12236,'pt','O \"de\" e \"para\" quantidades deve corresponder',0),(440493,12236,'ru','Â«ÐžÑ‚Â» Ð¸ Â«ÐºÂ» ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°Ñ… Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐ¾Ð²Ð¿Ð°Ð´Ð°Ñ‚ÑŒ',0),(440494,12236,'es','Las Cantidades \"Desde\" y \"A\" debe ser Igual',0),(440495,12236,'de','Das \"von\" und \"bis\" Mengen mÃ¼ssen Ã¼bereinstimmen',0),(440496,12236,'en','The \"from\" and \"to\" quantities must match',0),(440497,12237,'is','',0),(440498,12237,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø·Ù„ Ú©Ø±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù†ÛŒØ³Øª ',0),(440499,12237,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø·Ù„ Ú©Ø±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù†ÛŒØ³Øª ',0),(440500,12237,'tr','Ä°ptal kredi kartÄ± ile Ã¶deme yapÄ±lamÄ±yor',0),(440501,12237,'pl','Stanie niewaÅ¼ne kartÄ… kredytowÄ…',0),(440502,12237,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½ÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(440503,12237,'ur','Ø®Ø§Ù„ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(440504,12237,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ñƒ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(440505,12237,'vi','KhÃ´ng thá»ƒ lÃ m máº¥t hiá»‡u lá»±c thanh toÃ¡n tháº» tÃ­n dá»¥ng',0),(440506,12237,'af','Leemte kredietkaart betaling nie',0),(440507,12237,'ro','Imposibil de plata prin card de credit anulate',0),(440508,12237,'et','Suuda tÃ¼hine krediitkaardi makse',0),(440509,12237,'si','More niÄna kreditno kartico',0),(440510,12237,'ba','Mampu pembayaran Batal kartu kredit',0),(440511,12237,'nl','Kan niet nietig credit card betaling',0),(440512,12237,'fi','Ei mitÃ¤tÃ¶n luottokortilla maksaminen',0),(440513,12237,'no','Ikke ugyldige kredittkortbetaling',0),(440514,12237,'da','AfskÃ¥ret fra ugyldige kreditkortbetaling',0),(440515,12237,'ko','ë¬´íš¨ í•œ ì‹ ìš© ì¹´ë“œ ì§€ë¶ˆ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(440516,12237,'he','××™×Ÿ ××¤×©×¨×•×ª ×ª×©×œ×•× ×‘××ž×¦×¢×•×ª ×›×¨×˜×™×¡ ××©×¨××™ ×‘×˜×œ ×•×ž×‘×•×˜×œ',0),(440517,12237,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î¬ÎºÏ…ÏÎ· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(440518,12237,'zh','æ— æ³•ä½œåºŸä¿¡ç”¨å¡ä»˜æ¬¾',0),(440519,12237,'sv','Det gÃ¥r inte att betalning med ogiltiga kreditkort',0),(440520,12237,'it','Incapace di pagamento con carta di credito nullo',0),(440521,12237,'tl','',0),(440522,12237,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸¢à¸à¹€à¸¥à¸´à¸à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(440523,12237,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(440524,12237,'ms','Tidak dapat untuk pembayaran dengan kad kredit yang tidak sah',0),(440525,12237,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø§Ù„Ø¯ÙØ¹ Ø¨ÙˆØ§Ø³Ø·Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¨Ø§Ø·Ù„Ø©',0),(440526,12237,'fr','Incapable de paiement par carte de crÃ©dit Sub',0),(440527,12237,'jp','Void ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã§ã®æ”¯æ‰•ã„ã‚’ã§ãã¾ã›ã‚“ã€‚',0),(440528,12237,'pt','Incapaz de pagamento com cartÃ£o de crÃ©dito sem efeito',0),(440529,12237,'ru','ÐÐµ Ð½ÐµÐ´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð¹ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(440530,12237,'es','No se Puede Nular el Pago por Tarjeta de CrÃ©dito',0),(440531,12237,'de','Void Kreditkartenzahlung nicht',0),(440532,12237,'en','Unable to void credit card payment',0),(440533,12238,'is','',0),(440534,12238,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(440535,12238,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(440536,12238,'tr','KDV vergi raporu',0),(440537,12238,'pl','Raport podatku VAT',0),(440538,12238,'bg','Ð”Ð°Ð½ÑŠÐº Ð”Ð”Ð¡ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(440539,12238,'ur','ÙˆØ§Ù¹ Ù¹ÛŒÚ©Ø³ Ø±Ù¾ÙˆØ±Ù¹',0),(440540,12238,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÐŸÐ”Ð’ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(440541,12238,'vi','BÃ¡o cÃ¡o thuáº¿ GTGT',0),(440542,12238,'af','BTW Belasting Verslag',0),(440543,12238,'ro','Raport de TVA',0),(440544,12238,'et','KÃ¤ibemaks kÃ¤ibemaksu aruanne',0),(440545,12238,'si','PoroÄilo DDV davÄna',0),(440546,12238,'ba','Laporan PPN',0),(440547,12238,'nl','BTW-heffing verslag',0),(440548,12238,'fi','ALV raportti',0),(440549,12238,'no','Mva-rapport',0),(440550,12238,'da','MOMS momsrapport',0),(440551,12238,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸ ì„¸ê¸ˆ ë³´ê³ ì„œ',0),(440552,12238,'he','×“×•×— ×ž×¢ ×ž ×ž×¡',0),(440553,12238,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î¿Ï… Î¦Î Î‘',0),(440554,12238,'zh','å¢žå€¼ç¨ŽæŠ¥è¡¨',0),(440555,12238,'sv','Moms rapport',0),(440556,12238,'it','Report IVA',0),(440557,12238,'tl','',0),(440558,12238,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸ à¸²à¸©à¸µ VAT',0),(440559,12238,'hi','à¤µà¥ˆà¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(440560,12238,'ms','Laporan cukai VAT',0),(440561,12238,'ar','ØªÙ‚Ø±ÙŠØ± Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©',0),(440562,12238,'fr','DÃ©claration de TVA',0),(440563,12238,'jp','ä»˜åŠ ä¾¡å€¤ç¨Žãƒ¬ãƒãƒ¼ãƒˆ',0),(440564,12238,'pt','RelatÃ³rio de IVA',0),(440565,12238,'ru','ÐÐ”Ð¡ ÐžÑ‚Ñ‡ÐµÑ‚',0),(440566,12238,'es','Informe de IVA',0),(440567,12238,'de','MwSt.-Bericht',0),(440568,12238,'en','VAT Tax Report',0),(440569,12239,'is','',0),(440570,12239,'dr','Ù…Ø§ Ø¬Ø¯Ø§ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ù…ÛŒ Ú©Ù†ÛŒÙ… Ú©Ù‡ Ø´Ù…Ø§ Ø§Ø±ØªØ¨Ø§Ø· Ø®ÙˆØ¯ Ø±Ø§Ø§Ø±ØªÙ‚Ø§ Ø¨Ø¨Ø®Ø´ÛŒØ¯ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²\r\n  SSÙŽL/HTTPS',0),(440571,12239,'pr','Ù…Ø§ Ø¬Ø¯Ø§ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ù…ÛŒ Ú©Ù†ÛŒÙ… Ú©Ù‡ Ø´Ù…Ø§ Ø§Ø±ØªØ¨Ø§Ø· Ø®ÙˆØ¯ Ø±Ø§Ø§Ø±ØªÙ‚Ø§ Ø¨Ø¨Ø®Ø´ÛŒØ¯ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø²\r\n  SSÙŽL/HTTPS',0),(440572,12239,'tr','SSL/HTTPS kullanmak Ã¼zere baÄŸlantÄ±nÄ±z yÃ¼kseltmeniz Ã¶nerilir',0),(440573,12239,'pl','Zdecydowanie zaleca siÄ™ uaktualnienie twÃ³j poÅ‚Ä…czenie SSL/HTTPS',0),(440574,12239,'bg','ÐÐ¸Ðµ ÑÐ¸Ð»Ð½Ð¾ Ð¿Ñ€ÐµÐ¿Ð¾Ñ€ÑŠÑ‡Ð²Ð°Ð¼Ðµ Ð´Ð° Ð½Ð°Ð´ÑÑ‚Ñ€Ð¾Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð²Ñ€ÑŠÐ·ÐºÐ° Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° SSL/HTTPS',0),(440575,12239,'ur','ÛÙ… Ú©Ùˆ Ø²ÙˆØ± ØªØ¬ÙˆÛŒØ² ÛÛ’ Ú©Û Ø¢Ù¾ SSL/HTTPS Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø¢Ù¾ Ú©Ø§ Ú©Ù†Ú©Ø´Ù† Ø§Ù¾ Ú¯Ø±ÛŒÚˆ',0),(440576,12239,'sr','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑƒÑ‡ÑƒÑ˜ÐµÐ¼Ð¾ Ð²Ð°Ð¼ Ð´Ð° Ð½Ð°Ð´Ð¾Ð³Ñ€Ð°Ð´Ð¸Ñ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð¡Ð¡Ð›/Ð¥Ð¢Ð¢ÐŸÐ¡ Ð²ÐµÐ·Ñƒ',0),(440577,12239,'vi','ChÃºng tÃ´i khuyÃªn báº¡n nÃªn nÃ¢ng cáº¥p káº¿t ná»‘i cá»§a báº¡n Ä‘á»ƒ sá»­ dá»¥ng',0),(440578,12239,'af','Ons beveel sterk aan dat jy jou verbinding gebruik SSL/HTTPS opgradeer',0),(440579,12239,'ro','Va recomandam sa faceti upgrade conexiunea pentru a utiliza SSL/HTTPS',0),(440580,12239,'et','Soovitame uuendada oma Ã¼hendust kasutada SSL/HTTPS',0),(440581,12239,'si','PriporoÄamo, da nadgradite vaÅ¡ povezave za uporabo SSL/HTTPS',0),(440582,12239,'ba','Kami sangat menyarankan Anda meng-upgrade koneksi Anda menggunakan SSL/HTTPS',0),(440583,12239,'nl','Wij raden dat u een upgrade uitvoert voor uw verbinding voor het gebruik van SSL/HTTPS',0),(440584,12239,'fi','Microsoft suosittelee, ettÃ¤ pÃ¤ivitÃ¤t yhteyden kÃ¤yttÃ¤mÃ¤Ã¤n SSL/HTTPS',0),(440585,12239,'no','Vi anbefaler at du oppgraderer din tilkobling til Ã¥ bruke SSL/HTTPS',0),(440586,12239,'da','Vi anbefaler at du opgraderer din forbindelse til at bruge SSL/HTTPS',0),(440587,12239,'ko','SSL/HTTPSë¥¼ ì‚¬ìš© í•˜ ì—¬ ì—°ê²°ì„ ì—…ê·¸ë ˆì´ë“œ í•˜ëŠ” ê²ƒì´ ì¢‹ìŠµë‹ˆë‹¤.',0),(440588,12239,'he','×× ×• ×ž×ž×œ×™×¦×™× ×œ×©×“×¨×’ ××ª ×”×—×™×‘×•×¨ ×©×œ×š ×›×“×™ ×œ×”×©×ª×ž×© ×‘- SSL/HTTPS',0),(440589,12239,'el','Î£Î±Ï‚ ÏƒÏ…Î½Î¹ÏƒÏ„Î¿ÏÎ¼Îµ Î½Î± ÎºÎ¬Î½ÎµÏ„Îµ Î±Î½Î±Î²Î¬Î¸Î¼Î¹ÏƒÎ· ÏƒÎ±Ï‚ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯ SSL/HTTPS ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(440590,12239,'zh','æˆ‘ä»¬å¼ºçƒˆæŽ¨èæ‚¨æ›´æ–°æ‚¨çš„é“¾æŽ¥ä»¥ä½¿ç”¨SSL/HTTPS',0),(440591,12239,'sv','Vi rekommenderar starkt att du uppgraderar din anslutning fÃ¶r att anvÃ¤nda SSL/HTTPS',0),(440592,12239,'it','Si consiglia vivamente di effettuare l\'aggiornamento la connessione per utilizzare SSL/HTTPS',0),(440593,12239,'tl','',0),(440594,12239,'th','à¹€à¸£à¸²à¸‚à¸­à¹à¸™à¸°à¸™à¸³à¹ƒà¸«à¹‰ à¸„à¸¸à¸“à¸›à¸£à¸±à¸šà¸£à¸¸à¹ˆà¸™à¸à¸²à¸£à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¸à¸²à¸£à¹ƒà¸Šà¹‰ SSL/HTTPS',0),(440595,12239,'hi','à¤¹à¤® à¤¦à¥ƒà¤¢à¤¼à¤¤à¤¾ à¤¸à¥‡ à¤…à¤¨à¥à¤¶à¤‚à¤¸à¤¾ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤•à¤¿ à¤†à¤ª SSL/HTTPS à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤ªà¤¨à¥‡ à¤•à¤¨à¥‡à¤•à¥à¤¶à¤¨ à¤•à¤¾ à¤‰à¤¨à¥à¤¨à¤¯à¤¨',0),(440596,12239,'ms','Kami amat mengesyorkan bahawa anda menaik taraf sambungan anda menggunakan SSL/HTTPS',0),(440597,12239,'ar','Ø£Ù†Ù†Ø§ Ù†ÙˆØµÙŠ Ø¨Ø´Ø¯Ø© Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨ØªØ±Ù‚ÙŠØ© Ø§Ù„Ø§ØªØµØ§Ù„ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø§Ø³ØªØ®Ø¯Ø§Ù… SSL/HTTPS',0),(440598,12239,'fr','Il est vivement recommandÃ© que vous mettez Ã  niveau votre connexion pour utiliser SSL/HTTPS',0),(440599,12239,'jp','SSL/HTTPS ã‚’ä½¿ç”¨ã—ã¦æŽ¥ç¶šã‚’ã‚¢ãƒƒãƒ—ã‚°ãƒ¬ãƒ¼ãƒ‰ã™ã‚‹ã“ã¨ã‚’å¼·ããŠå‹§ã‚ã—ã¾ã™',0),(440600,12239,'pt','Recomendamos fortemente que vocÃª atualize sua conexÃ£o para usar SSL/HTTPS',0),(440601,12239,'ru','ÐœÑ‹ Ð½Ð°ÑÑ‚Ð¾ÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ Ñ€ÐµÐºÐ¾Ð¼ÐµÐ½Ð´ÑƒÐµÐ¼ Ð²Ð°Ð¼ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ SSL/HTTPS',0),(440602,12239,'es','Fuertamente recomendamos que actualiza su conexiÃ³n para usar SSL/HTTPS',0),(440603,12239,'de','Wir empfehlen, dass Sie Ihre Verbindung zur Verwendung von SSL/HTTPS aktualisieren',0),(440604,12239,'en','We strongly recommend that you upgrade your connection to use SSL/HTTPS',0),(440605,12240,'is','',0),(440606,12240,'dr','Ø§Ø±ØªØ¨Ø§Ø· Ø§Ø®ÛŒØ± Ø´Ù…Ø§ Ø§Ø² Ø§ÛŒÙ† Ù¾Ø±ØªÚ©Ù„ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ù…ÛŒ Ú©Ù†Ø¯\r\n SSL/HTTPS',0),(440607,12240,'pr','Ø§Ø±ØªØ¨Ø§Ø· Ø§Ø®ÛŒØ± Ø´Ù…Ø§ Ø§Ø² Ø§ÛŒÙ† Ù¾Ø±ØªÚ©Ù„ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ù…ÛŒ Ú©Ù†Ø¯\r\n SSL/HTTPS',0),(440608,12240,'tr','GeÃ§erli baÄŸlantÄ±nÄ±n SSL/HTTPS kullanmayan',0),(440609,12240,'pl','BieÅ¼Ä…ce poÅ‚Ä…czenie nie korzysta z protokoÅ‚u SSL/HTTPS',0),(440610,12240,'bg','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð²Ð¸ Ð²Ñ€ÑŠÐ·ÐºÐ° Ð½Ðµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° SSL/HTTPS',0),(440611,12240,'ur','Ø¢Ù¾ Ú©Ø§ Ø­Ø§Ù„ÛŒÛ Ú©Ù†Ú©Ø´Ù† SSL/HTTPS Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù†ÛÛŒÚº Ú©Ø±ØªØ§ Û”',0),(440612,12240,'sr','Ð’Ð°ÑˆÐ° Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð²ÐµÐ·Ð° Ð½Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¡Ð¡Ð›/Ð¥Ð¢Ð¢ÐŸÐ¡',0),(440613,12240,'vi','Káº¿t ná»‘i hiá»‡n táº¡i cá»§a báº¡n khÃ´ng sá»­ dá»¥ng SSL / HTTPS',0),(440614,12240,'af','Jou huidige verbinding SSL/HTTPS gebruik nie',0),(440615,12240,'ro','Conexiunea la curent nu utilizeazÄƒ SSL/HTTPS',0),(440616,12240,'et','Teie praeguse Ã¼henduse kasutada SSL/HTTPS',0),(440617,12240,'si','Trenutna povezava ne uporablja SSL/HTTPS',0),(440618,12240,'ba','Koneksi Anda saat ini tidak menggunakan SSL/HTTPS',0),(440619,12240,'nl','Uw huidige verbinding maakt geen gebruik van SSL/HTTPS',0),(440620,12240,'fi','Nykyinen yhteys ei kÃ¤ytÃ¤ SSL/HTTPS',0),(440621,12240,'no','Gjeldende tilkobling bruker ikke SSL/HTTPS',0),(440622,12240,'da','Den aktuelle forbindelse bruger ikke SSL/HTTPS',0),(440623,12240,'ko','í˜„ìž¬ ì—°ê²°ì´ SSL/HTTPSë¥¼ ì‚¬ìš© í•˜ì§€ ì•ŠëŠ”',0),(440624,12240,'he','×”×—×™×‘×•×¨ ×”× ×•×›×—×™ ×©×œ×š ××™× ×• ×ž×©×ª×ž×© ×‘- SSL/HTTPS',0),(440625,12240,'el','Î”Î¹ÎºÏŒ ÏƒÎ¿Ï… Ï„ÏÎ­Ï‡Ï‰Î½ ÏƒÏÎ½Î´ÎµÏƒÎ· Î´ÎµÎ½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯ SSL/HTTPS',0),(440626,12240,'zh','æ‚¨ç›®å‰çš„é“¾æŽ¥æ— æ³•ä½¿ç”¨SSL/HTTPS',0),(440627,12240,'sv','Den aktuella anslutningen anvÃ¤nder inte SSL/HTTPS',0),(440628,12240,'it','La connessione corrente non utilizza SSL/HTTPS',0),(440629,12240,'tl','',0),(440630,12240,'th','à¸à¸²à¸£à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¹ƒà¸Šà¹‰ SSL/HTTPS',0),(440631,12240,'hi','à¤†à¤ªà¤•à¥‡ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤¨à¥‡à¤•à¥à¤¶à¤¨ SSL/HTTPS à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(440632,12240,'ms','Sambungan semasa anda tidak menggunakan SSL/HTTPS',0),(440633,12240,'ar','Ø§Ù„Ø§ØªØµØ§Ù„ Ø§Ù„Ø­Ø§Ù„ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù„Ø§ ÙŠØ³ØªØ®Ø¯Ù… SSL/HTTPS',0),(440634,12240,'fr','Votre connexion actuelle n\'utilise pas SSL/HTTPS',0),(440635,12240,'jp','ç¾åœ¨ã®æŽ¥ç¶šãŒ SSL/HTTPS ã‚’ä½¿ç”¨ã—ã¾ã›ã‚“',0),(440636,12240,'pt','Sua conexÃ£o atual nÃ£o usa SSL/HTTPS',0),(440637,12240,'ru','Ð’Ð°ÑˆÐµ Ñ‚ÐµÐºÑƒÑ‰ÐµÐµ ÑÐ¾ÐµÐ´Ð¸Ð½ÐµÐ½Ð¸Ðµ Ð½Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ SSL/HTTPS',0),(440638,12240,'es','So conexiÃ³n actual no usa SSL/HTTPS',0),(440639,12240,'de','Die aktuelle Verbindung verwendet keine SSL/HTTPS',0),(440640,12240,'en','Your current connection does not use SSL/HTTPS',0),(440641,12241,'is','',0),(440642,12241,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(440643,12241,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(440644,12241,'tr','Stok kategorileri oluÅŸturma',0),(440645,12241,'pl','Tworzenie kategorii zapasÃ³w',0),(440646,12241,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(440647,12241,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø²Ù…Ø±Û Ø¬Ø§Øª Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(440648,12241,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(440649,12241,'vi','táº¡o danh má»¥c hÃ ng tá»“n kho',0),(440650,12241,'af','Voorraad kategorieÃ« skep',0),(440651,12241,'ro','Crea categorii de inventar',0),(440652,12241,'et','Loo varude Kategooriad',0),(440653,12241,'si','Ustvarjanje zaloge kategorije',0),(440654,12241,'ba','Buat kategori persediaan',0),(440655,12241,'nl','Inventaris categorieÃ«n maken',0),(440656,12241,'fi','Luo varaston',0),(440657,12241,'no','Opprett lager kategorier',0),(440658,12241,'da','Oprette lager kategorier',0),(440659,12241,'ko','ìž¬ê³  ëª©ë¡ ë²”ì£¼ ë§Œë“¤ê¸°',0),(440660,12241,'he','×¦×•×¨ ×§×˜×’×•×¨×™×•×ª ×ž×œ××™',0),(440661,12241,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(440662,12241,'zh','åˆ›å»ºåº“å­˜ç›®å½•',0),(440663,12241,'sv','Skapa inventering kategorier',0),(440664,12241,'it','Creare categorie di inventario',0),(440665,12241,'tl','',0),(440666,12241,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸›à¸£à¸°à¹€à¸ à¸—à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(440667,12241,'hi','à¤¸à¥‚à¤šà¥€ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤¬à¤¨à¤¾à¤à¤',0),(440668,12241,'ms','Mewujudkan inventori kategori',0),(440669,12241,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙØ¦Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(440670,12241,'fr','CrÃ©ez des catÃ©gories de l\'inventaire',0),(440671,12241,'jp','åœ¨åº«ã‚«ãƒ†ã‚´ãƒªã‚’ä½œæˆã—ã¾ã™ã€‚',0),(440672,12241,'pt','Criar categorias de inventÃ¡rio',0),(440673,12241,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(440674,12241,'es','Crear CategorÃ­as de Inventario',0),(440675,12241,'de','Inventar-Kategorien erstellen',0),(440676,12241,'en','Create Inventory Categories',0),(440677,12242,'is','',0),(440678,12242,'dr','&nbsp;',0),(440679,12242,'pr','&nbsp;',0),(440680,12242,'tr','&nbsp;',0),(440681,12242,'pl','&nbsp;',0),(440682,12242,'bg','&nbsp;',0),(440683,12242,'ur','&nbsp;',0),(440684,12242,'sr','&nbsp;',0),(440685,12242,'vi','&nbsp;',0),(440686,12242,'af','&nbsp;',0),(440687,12242,'ro','&nbsp;',0),(440688,12242,'et','&nbsp;',0),(440689,12242,'si','&nbsp;',0),(440690,12242,'ba','&nbsp;',0),(440691,12242,'nl','&nbsp;',0),(440692,12242,'fi','&nbsp;',0),(440693,12242,'no','&nbsp;',0),(440694,12242,'da','&nbsp;',0),(440695,12242,'ko','&nbsp;',0),(440696,12242,'he','&nbsp;',0),(440697,12242,'el','&nbsp;',0),(440698,12242,'zh','&nbsp;',0),(440699,12242,'sv','&nbsp;',0),(440700,12242,'it','&nbsp;',0),(440701,12242,'tl','',0),(440702,12242,'th','&nbsp;',0),(440703,12242,'hi','&nbsp;',0),(440704,12242,'ms','&nbsp;',0),(440705,12242,'ar','&nbsp;',0),(440706,12242,'fr','&nbsp;',0),(440707,12242,'jp','&nbsp;',0),(440708,12242,'pt','&nbsp;',0),(440709,12242,'ru','&nbsp;',0),(440710,12242,'es','&amp;nbsp;',0),(440711,12242,'de','&nbsp;',0),(440712,12242,'en','&nbsp;',0),(440713,12243,'is','',0),(440714,12243,'dr',':Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ù…Ø¯ÛŒØ±ÛŒØª-ÛŒÙˆØ²Ø±Ø¬Ø¯ÛŒØ¯/ Ø§ØµÙ„Ø§Ø­',0),(440715,12243,'pr','Ø¨Ø±Ø§ÛŒ ØªÙ†Ø¸ÛŒÙ… Ø­Ù‚ÙˆÙ‚ Ø¯Ø³ØªØ±Ø³ÛŒ Ú©Ø§Ø±Ø¨Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯:Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ù…Ø¯ÛŒØ±ÛŒØª-Ú©Ø§Ø±Ø¨Ø±Ø¬Ø¯ÛŒØ¯/ ÙˆÛŒØ±Ø§ÛŒØ´\r\nØ§Ù†ØªØ®Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø±ÙˆÙˆÛŒØ±Ø§ÛŒØ´ Ø­Ù‚ÙˆÙ‚ Ø¯Ø± Ù‚Ø³Ù…Øª Ø¯Ø³ØªØ±Ø³ÛŒ Ù…Ø§Ú˜ÙˆÙ„-Ù…ÛŒØ®ÙˆØ§Ù‡ÛŒØ¯ Ø¯ï',0),(440716,12243,'tr','KullanÄ±cÄ± eriÅŸim haklarÄ± seÃ§in ayarlamak iÃ§in:<p><b>Admin Admin kurulumu kullanÄ±cÄ± yeni/DÃ¼zenle->-></b><p>KullanÄ±cÄ± seÃ§im ve haklarÄ± modÃ¼lÃ¼ eriÅŸimi bÃ¶lÃ¼mÃ¼nde dÃ¼zenleyin.<p>Sayfaya Ã¶zel eriÅŸim atamak istediÄŸiniz? <i>GeliÅŸmiÅŸ kullan',0),(440717,12243,'pl','Aby ustawiÄ‡ prawa dostÄ™pu uÅ¼ytkownika wybierz:<p><b>Admin-> konfiguracji Admin-> nowego uÅ¼ytkownika/edycja</b><p>Wybierz uÅ¼ytkownika i prawa w sekcji moduÅ‚ dostÄ™pu do edycji.<p>Chcesz ustawiÄ‡ dostÄ™pu specyficzne dla strony? Dodatek <i>Zaawansowan',0),(440718,12243,'bg','Ð—Ð° Ð´Ð° Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð¸Ð·Ð±Ð¾Ñ€:<p><b>Admin-> Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-> Ð½Ð¾Ð² Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ</b><p>Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð',0),(440719,12243,'ur','Ø­Ù‚ÙˆÙ‚ Ø±Ø³Ø§Ø¦ÛŒ ØµØ§Ø±Ù Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Ø³ÛŒÙ¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’:<p><b>Ø§ÛŒÚˆÙ…Ù† Admin Ø³ÛŒÙ¹ Ø§Ù¾ Ù†ÛŒØ§ ØµØ§Ø±Ù/ØªØ±Ù…ÛŒÙ…->-></b><p>ØµØ§Ø±Ù Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø­Ù‚ÙˆÙ‚ ÙƒØ§ Ù…ÙˆÚˆÛŒÙˆÙ„ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ú©Û’ Ø³ÛŒÚ©Ø´Ù† Ù…ÛŒ',0),(440720,12243,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸ Ð¿Ñ€Ð°Ð²Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ ÐÐ´Ð¼Ð¸Ð½ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ð¸ Ð½Ð¾Ð²Ð¸Ñ… ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ</b><p>ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¸ Ñ',0),(440721,12243,'vi','ThiÃªt láº­p quyá»n sá»­ dá»¥ng chá»n:Quáº£n lÃ½-> cÃ i quáº£n lÃ½-> sá»­a/thÃªm má»›i ngÆ°á»i sá»­ dá»¥ng->chá»n ngÆ°á»i sá»­ dá»¥ng vÃ  thÃªm quyá»n truy cáº­p. Muá»‘n thiáº¿t láº­p quyá»n truy cáº­p vÃ o trang quy Ä‘á»‹nh thÃ¬ vÃ o : quyá»n nÃ¢',0),(440722,12243,'af','Stel die gebruiker toegangsregte kies:<p><b>Admin-> Admin opstelling-> nuwe gebruiker/redigeer</b><p>Die gebruiker kies en regte in die Module toegang artikel te redigeer.<p>Wil stel bladsy-spesifieke toegang? Die <i>Gevorderde gebruikersregte</i> byvoegs',0),(440723,12243,'ro','Pentru a seta drepturile de acces utilizator selectaÅ£i:<p><b>Admin->-Admin Setup-> utilizator nou/editare</b><p>SelectaÅ£i utilizatorul ÅŸi edita drepturile Ã®n secÅ£iunea modul de acces.<p>DoriÅ£i sÄƒ setaÅ£i specifice pagina de acces? <i>Drepturile de ',0),(440724,12243,'et','Seada kasutaja juurdepÃ¤Ã¤suÃµigused valimine:<p><b>Admin-> Admin seadistamine kasutaja uus/Muuda-></b><p>Valige kasutaja ja Redigeeri Ãµigusi moodul juurdepÃ¤Ã¤su osas.<p>Soovite lehekÃ¼ljele omaseid juurdepÃ¤Ã¤su? <i>TÃ¤psemad kasutajaÃµiguste</i> lisan',0),(440725,12243,'si','Nastavljanje uporabniÅ¡ke pravice za dostop izberite:<p><b>Admin-> Admin Setup-> nov uporabnik/Uredi</b><p>Izbrati uporabnika in urejanje pravic v razdelku dostop modula.<p>Å½elite nastaviti posebne strani dostop? <i>Napredne uporabniÅ¡ke pravice</i> doda',0),(440726,12243,'ba','Untuk mengatur hak akses pengguna pilih:<p><b>Admin-> Admin Setup-> pengguna baru/Edit</b><p>Memilih pengguna dan mengedit hak di bagian modul akses.<p>Ingin mengatur akses khusus Halaman? <i>Advanced pengguna hak</i> add-on memungkinkan hanya itu.',0),(440727,12243,'nl','Selecteer toegangsrechten gebruiker instellen<p><b>Admin-> Admin Setup-> / nieuwe gebruiker bewerken</b><p>Kies de gebruiker en rechten in de sectie Module toegang bewerken.<p>Wilt u instellen van pagina-specifieke toegang? De invoegtoepassing <i>Geavance',0),(440728,12243,'fi','Voit mÃ¤Ã¤rittÃ¤Ã¤ kÃ¤yttÃ¤jÃ¤n kÃ¤yttÃ¶oikeudet Valitse:<p><b>Admin Admin asetukset-> kÃ¤yttÃ¤jÃ¤n uusi tai Muokkaa-></b><p>Valitse kÃ¤yttÃ¤jÃ¤ ja Muokkaa oikeuksia moduuli kÃ¤yttÃ¶oikeudet-osiossa.<p>Haluatko mÃ¤Ã¤rittÃ¤Ã¤ sivukohtaisia? <i>Advanced Use',0),(440729,12243,'no','Angi tilgang Velg:<p><b>Admin-> Admin Setup-> bruker ny/Rediger</b><p>Velg brukeren og Rediger rettigheter i delen modulen tilgang.<p>Vil du angi bestemte? <i>Avansert brukerrettigheter</i> tillegget lar akkurat.',0),(440730,12243,'da','SÃ¥dan indstilles brugeradgangsrettigheder VÃ¦lg:<p><b>Admin-> Admin Setup-> bruger ny/Rediger</b><p>VÃ¦lg brugeren og redigeringsrettigheder i afsnittet modul adgang.<p>Vil angive sidespecifikke adgang? TilfÃ¸jelsesprogrammet <i>Avanceret brugerrettighed',0),(440731,12243,'ko','ì„¤ì • í•˜ë ¤ë©´ ì‚¬ìš©ìž ì•¡ì„¸ìŠ¤ ê¶Œí•œ ì„ íƒ:<p><b>ê´€ë¦¬ìž ì„¤ì¹˜ ì‚¬ìš©ìž ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘->-> ê´€ë¦¬ìž</b><p>ì‚¬ìš©ìžë¥¼ ì„ íƒ í•˜ ê³  ëª¨ë“ˆ ì•¡ì„¸ìŠ¤ ì„¹ì…˜ì— ëŒ€ í•œ ê¶Œë¦¬ë¥¼ íŽ¸ì§‘ í•©ë‹ˆë‹¤.<p>íŽ˜ì´ì§€ì˜ íŠ¹ì • ì•¡ì„¸ìŠ¤ë¥¼ ì',0),(440732,12243,'he','×›×“×™ ×œ×”×’×“×™×¨ ×”×¨×©××•×ª ×’×™×©×” ×‘×—×¨:<p><b>Admin-> ×ž× ×”×œ ×”×”×ª×§× ×”-> ×ž×©×ª×ž×© ×—×“×©/×¢×¨×™×›×”</b><p>×œ×‘×—×•×¨ ××ª ×”×ž×©×ª×ž×©, ×¢×¨×™×›×ª ×–×›×•×™×•×ª ×‘××–×•×¨ \' \' ×ž×•×“×•×œ ×’×™×©×”.<p>×¨×•×¦×” ×œ×”×’×“×™×¨ ×’×™×©×” ×™×™×—×•×“',0),(440733,12243,'el','Î“Î¹Î± Î½Î± Î¿ÏÎ¯ÏƒÎµÏ„Îµ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï‡ÏÎ®ÏƒÏ„Î· ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ:<p><b>Admin-> Admin Setup-> Ï‡ÏÎ®ÏƒÏ„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±</b><p>Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î· ÎºÎ±Î¹ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î´',0),(440734,12243,'zh','è®¾ç½®ç”¨æˆ·è®¿é—®æƒé™é€‰æ‹©ï¼šç®¡ç†->ç®¡ç†è®¾ç½®->ç”¨æˆ·æ–°/ç¼–è¾‘</b><p>é€‰æ‹©ç”¨æˆ·å¹¶ç¼–è¾‘æ¨¡å—è®¿é—®éƒ¨åˆ†çš„æƒé™ã€‚<p>æƒ³è®¾ç½®ç‰¹å®šé¡µé¢è®¿é—®ï¼Ÿé«˜çº§ç”¨æˆ·æƒé™æ·»åŠ å…è®¸æ­¤ã€‚',0),(440735,12243,'sv','StÃ¤lla in anvÃ¤ndaren behÃ¶righet VÃ¤lj:<p><b>Admin-> Admin instÃ¤llning-> den nya anvÃ¤ndaren/redigera</b><p>VÃ¤lj anvÃ¤ndaren och redigera rÃ¤ttigheter i avsnittet modul Ã¥tkomst.<p>Vill du ange sidspecifika tillgÃ¥ng? TillÃ¤gget <i>Avancerad anvÃ¤ndar',0),(440736,12243,'it','Per impostare i diritti di accesso utente selezionare:<p><b>Admin-> Admin Setup-> utente nuovo/modifica</b><p>Scegliere l\'utente e modificare i diritti nella sezione modulo di accesso.<p>Desidera impostare specifici della pagina di accesso? Il componente ',0),(440737,12243,'tl','',0),(440738,12243,'th','à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸ªà¸´à¸—à¸˜à¸´à¹Œà¹€à¸¥à¸·à¸­à¸à¸•à¸±à¹‰à¸‡:<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² Admin->à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚</b><p>à¹€à¸¥à¸·à¸­à¸à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰ à¹à¸¥à¸°à¸ªà¸´à¸—à¸˜à¸´à¹Œà¹ƒ',0),(440739,12243,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤ªà¤¹à¥à¤à¤š à¤…à¤§à¤¿à¤•à¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à',0),(440740,12243,'ms','Untuk menetapkan hak capaian pengguna Pilih:<p><b>Admin-> Admin persediaan-> pengguna baru/Edit</b><p>Pilih pengguna dan edit hak dalam seksyen modul akses.<p>Hendak menyediakan akses Laman khusus? <i>Hak pengguna lanjutan</i> tambahan yang membolehkan ha',0),(440741,12243,'ar','Ù„ØªØ¹ÙŠÙŠÙ† \"Ø­Ù‚ÙˆÙ‚ ÙˆØµÙˆÙ„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…\" Ø­Ø¯Ø¯:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø´Ø±Ù-> Ù…Ø³ØªØ®Ø¯Ù… Ø¬Ø¯ÙŠØ¯/ØªØ­Ø±ÙŠØ±</b><p>Ø§Ø®ØªØ± Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… ÙˆØªØ­Ø±ÙŠØ± Ø§Ù„Ø­Ù‚ÙˆÙ‚ ÙÙŠ Ù…Ù‚Ø·Ø¹ \"Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ­Ø¯Ø© Ø§Ù„Ù†Ù…Ø·ÙŠ',0),(440742,12243,'fr','Pour dÃ©finir les droits d\'accÃ¨s utilisateur SÃ©lectionnez :<p><b>Admin-> Admin Setup-> nouvel utilisateur/modifier</b><p>Choisissez l\'utilisateur et modifier les droits dans la section accÃ¨s au Module.<p>Vous souhaitez dÃ©finir un accÃ¨s spÃ©cifique Ã ',0),(440743,12243,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®ã‚¢ã‚¯ã‚»ã‚¹æ¨©ã®é¸æŠžã‚’è¨­å®š: ã™ã‚‹<p><b>ç®¡ç†è€…ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ï¼ ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®ç·¨é›†æ–°ã—ã„->-></b><p>ãƒ¦ãƒ¼ã‚¶ã‚’é¸æŠžãŠã‚ˆã³ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ« ã‚¢ã‚¯ã‚»ã‚¹] ã‚»ã‚¯ã‚·ãƒ§ãƒ³ã§ã®æ¨©é™ã‚’ç·¨é›†ã—ã¾ã™ã€‚<p>ç‰¹',0),(440744,12243,'pt','Para definir direitos de acesso de usuÃ¡rio selecione:<p><b>Admin-> Admin Setup-> novo usuÃ¡rio/editar</b><p>Escolha o usuÃ¡rio e editar direitos na seÃ§Ã£o acesso do mÃ³dulo.<p>Deseja definir acesso pÃ¡gina especÃ­fica? O complemento de <i>Direitos de us',0),(440745,12243,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð·Ð°Ð´Ð°Ñ‚ÑŒ Ð¿Ñ€Ð°Ð²Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸-> Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ/Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ</b>',0),(440746,12243,'es','Para Configurar Derechos de Acceso de Usuario selecciona:<p> Admin ConfiguraciÃ³n -> Usuario Nuevo/Editar</b><p>Escoge el usuario y los derechos de editar en la secciÃ³n de Acceso de MÃ³dulo. <p>Â¿Quiere configurar acceso especÃ­fico a unapÃ¡gina? Los Der',0),(440747,12243,'de','Benutzer-Zugriffsrechte Select festgelegt:<p><b>Admin-> Admin Setup-> Benutzer neu/bearbeiten</b><p>WÃ¤hlen Sie den Benutzer und bearbeiten Sie Rechte im Abschnitt Modul Access.<p>Seitenspezifische Zugriff festlegen mÃ¶chten? Das <i>Erweiterte Benutzerrec',0),(440748,12243,'en','To set User Access Rights select:<p><b>Admin -> Admin Setup -> User New/Edit</b><p>Choose the user and edit rights in the Module Access section. <p>Want to set page-specific access? The <i>Advanced User Rights</i> add-on allows just that.',0),(440749,12244,'is','',0),(440750,12244,'dr','',0),(440751,12244,'pr','',0),(440752,12244,'tr','',0),(440753,12244,'pl','',0),(440754,12244,'bg','',0),(440755,12244,'ur','',0),(440756,12244,'sr','',0),(440757,12244,'vi','',0),(440758,12244,'af','',0),(440759,12244,'ro','',0),(440760,12244,'et','',0),(440761,12244,'si','',0),(440762,12244,'ba','',0),(440763,12244,'nl','',0),(440764,12244,'fi','',0),(440765,12244,'no','',0),(440766,12244,'da','',0),(440767,12244,'ko','',0),(440768,12244,'he','',0),(440769,12244,'el','',0),(440770,12244,'zh','',0),(440771,12244,'sv','',0),(440772,12244,'it','',0),(440773,12244,'tl','',0),(440774,12244,'th','',0),(440775,12244,'hi','',0),(440776,12244,'ms','',0),(440777,12244,'ar','',0),(440778,12244,'fr','',0),(440779,12244,'jp','',0),(440780,12244,'pt','',0),(440781,12244,'ru','',0),(440782,12244,'es','',0),(440783,12244,'de','',0),(440784,12244,'en','',0),(440785,12245,'is','',0),(440786,12245,'dr','',0),(440787,12245,'pr','',0),(440788,12245,'tr','',0),(440789,12245,'pl','',0),(440790,12245,'bg','',0),(440791,12245,'ur','',0),(440792,12245,'sr','',0),(440793,12245,'vi','',0),(440794,12245,'af','',0),(440795,12245,'ro','',0),(440796,12245,'et','',0),(440797,12245,'si','',0),(440798,12245,'ba','',0),(440799,12245,'nl','',0),(440800,12245,'fi','',0),(440801,12245,'no','',0),(440802,12245,'da','',0),(440803,12245,'ko','',0),(440804,12245,'he','',0),(440805,12245,'el','',0),(440806,12245,'zh','',0),(440807,12245,'sv','',0),(440808,12245,'it','',0),(440809,12245,'tl','',0),(440810,12245,'th','',0),(440811,12245,'hi','',0),(440812,12245,'ms','',0),(440813,12245,'ar','',0),(440814,12245,'fr','',0),(440815,12245,'jp','',0),(440816,12245,'pt','',0),(440817,12245,'ru','',0),(440818,12245,'es','',0),(440819,12245,'de','',0),(440820,12245,'en','',0),(440821,12246,'is','',0),(440822,12246,'dr','',0),(440823,12246,'pr','',0),(440824,12246,'tr','',0),(440825,12246,'pl','',0),(440826,12246,'bg','',0),(440827,12246,'ur','',0),(440828,12246,'sr','',0),(440829,12246,'vi','',0),(440830,12246,'af','',0),(440831,12246,'ro','',0),(440832,12246,'et','',0),(440833,12246,'si','',0),(440834,12246,'ba','',0),(440835,12246,'nl','',0),(440836,12246,'fi','',0),(440837,12246,'no','',0),(440838,12246,'da','',0),(440839,12246,'ko','',0),(440840,12246,'he','',0),(440841,12246,'el','',0),(440842,12246,'zh','',0),(440843,12246,'sv','',0),(440844,12246,'it','',0),(440845,12246,'tl','',0),(440846,12246,'th','',0),(440847,12246,'hi','',0),(440848,12246,'ms','',0),(440849,12246,'ar','',0),(440850,12246,'fr','',0),(440851,12246,'jp','',0),(440852,12246,'pt','',0),(440853,12246,'ru','',0),(440854,12246,'es','',0),(440855,12246,'de','',0),(440856,12246,'en','',0),(440857,12247,'is','',0),(440858,12247,'dr','Ø§Ø·Ù…ÛŒÙ†Ø§Ù† Ø­Ø§ØµÙ„ Ú©Ù†ÛŒØ¯Ø²Ù…Ø§Ù† Ú†Ø§Ù¾ \"Ù‡ÛŒÚ†\" Ø¨Ø±Ø§ÛŒ \"Ù…Ù‚ÛŒØ§Ø³ Ú¯Ø°Ø§Ø±ÛŒ ØµÙØ­Ù‡\" ÙˆØªÛŒÚ© \"Ú†Ø±Ø®Ø´ Ø§ØªÙˆÙ…Ø§ØªÛŒÚ© Ùˆ Ù…Ø±Ú©Ø²\" Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.Ø§ÛŒÙ† Ø¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ú†Ø§Ù¾Ú¯Ø± Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯Ø²Ù…Ø§Ù†ÛŒ Ú©Ù‡ Ú†Ø§',0),(440859,12247,'pr','Ø§Ø·Ù…ÛŒÙ†Ø§Ù† Ø­Ø§ØµÙ„ Ú©Ù†ÛŒØ¯Ø²Ù…Ø§Ù† Ú†Ø§Ù¾ \"Ù‡ÛŒÚ†\" Ø¨Ø±Ø§ÛŒ \"Ù…Ù‚ÛŒØ§Ø³ Ú¯Ø°Ø§Ø±ÛŒ ØµÙØ­Ù‡\" ÙˆØªÛŒÚ© \"Ú†Ø±Ø®Ø´ Ø§ØªÙˆÙ…Ø§ØªÛŒÚ© Ùˆ Ù…Ø±Ú©Ø²\" Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.Ø§ÛŒÙ† Ø¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ú†Ø§Ù¾Ú¯Ø± Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯Ø²Ù…Ø§Ù†ÛŒ Ú©Ù‡ Ú†Ø§',0),(440860,12247,'tr','\"Yok\" \"Sayfa Ã–lÃ§ekleme\" ve BM-onay iÃ§in \"Otomatik DÃ¶ndÃ¼r ve Merkezi\" seÃ§mek iÃ§in yazdÄ±rma sÄ±rasÄ±nda olduÄŸundan emin olun. Bunlar aslÄ±nda PDF yazdÄ±rma yazÄ±cÄ± seÃ§imi Ã¼zerinde gÃ¶rÃ¼nÃ¼r.',0),(440861,12247,'pl','Upewnij siÄ™, Å¼e podczas drukowania wybierz \"nie\" dla \"Skalowanie strony\" i usuÅ„ zaznaczenie \"auto obrÃ³t i centrum\". Te pojawiajÄ… siÄ™ na wybÃ³r drukarki, gdy faktycznie druk w formacie PDF.',0),(440862,12247,'bg','Ð£Ð²ÐµÑ€ÐµÑ‚Ðµ ÑÐµ, Ñ‡Ðµ Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ \"Ð½ÑÐ¼Ð°\" Ð·Ð° \"ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¼Ð°Ñ‰Ð°Ð±Ð¸Ñ€Ð°Ð½Ðµ\" Ð¸ Ð¼Ð°Ñ…Ð½ÐµÑ‚Ðµ Ð¾Ñ‚Ð¼ÐµÑ‚ÐºÐ°Ñ‚Ð° \"Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð·Ð°Ð²ÑŠÑ€Ñ‚Ð°Ð½Ðµ Ð¸ Ñ†ÐµÐ½Ñ‚ÑŠÑ€\". Ð¢Ðµ ÑÐµ Ð¿Ð¾ÑÐ²ÑÐ²Ð°Ñ‚ Ð½Ð° Ð¸Ð',0),(440863,12247,'ur','\"Ú©ÙˆØ¦ÛŒ Ù†ÛÛŒÚº\" \"ØµÙØ­Û Ú©Ùˆ Ù¾ÛŒÙ…Ø§Ù†Û Ú©Ø§Ø±ÛŒ\" Ø§ÙˆØ± Ø§Ù‚ÙˆØ§Ù…Ù Ù…ØªØ­Ø¯Û-Ú†ÛŒÚ© Ú©Û’ Ù„Ø¦Û’ \"Ø¢Ù¹Ùˆ Ú¯Ú¾Ù…Ø§Ø¦ÛŒÚº Ø§ÙˆØ± Ù…Ø±Ú©Ø²\" Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ ÛŒÙ‚ÛŒÙ†ÛŒ Ø¨Ù†Ø§Ø¦ÛŒÚº Û” ÛŒÛ Ø¯Ø±Ø§ØµÙ„ Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ Ú©',0),(440864,12247,'sr','ÐŸÐ¾ÑÑ‚Ð°Ñ€Ð°Ñ˜Ñ‚Ðµ ÑÐµ Ð´Ð° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ° Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€\"ÐÐ¸Ñ˜ÐµÐ´Ð°Ð½\" Ð·Ð° \"ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ\" Ð¸ ÑƒÐ½-Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ \"ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ñ€Ð¾Ñ‚Ð¸Ñ€Ð°ÑšÐµ Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€\". ÐŸÐ¾Ñ˜Ð°Ð²Ñ™ÑƒÑ˜',0),(440865,12247,'vi','hÃ£y cháº¯c cháº¯n ráº±ng khi in chá»n \"khÃ´ng\" cho viá»‡c má»Ÿ rá»™ng quy mÃ´ trang vÃ  khÃ´ng kiá»ƒm tra tá»± Ä‘á»™ng xoay mÃ n hÃ¬nh vÃ  trung tÃ¢m. Nhá»¯ng cÃ¡i nÃ y xuáº¥t hiá»‡n trong sá»± chá»n lá»±a trÃªn mÃ¡y in khi chá»n in PDF',0),(440866,12247,'af','Maak seker wanneer die druk om te kies \"niks\" vir \"bladsy skalering\" en VN-kontroleer die \"auto-roteer en sentrum\". Dit verskyn op die drukker seleksie wanneer eintlik druk die PDF.',0),(440867,12247,'ro','AsiguraÅ£i-vÄƒ cÄƒ la imprimare pentru a selecta \"nici unul\" de \"pagina de scalare\" ÅŸi debifaÅ£i \"rotire automatÄƒ ÅŸi centru\". Acestea apar pe selecÅ£ia imprimantei cÃ¢nd de fapt tipÄƒrirea PDF-ului.',0),(440868,12247,'et','Veenduge, et valida \"none\" \"lehele tagi\" ja un-check \"auto PÃ¶Ã¶ra ja tsentreeri\" printimisel. Need kuvatakse printer valik tegelikult printimiseks PDF-faili.',0),(440869,12247,'si','Poskrbite, da pri tiskanju izberite \"none\" za \"stran luÅ¡Äenje\" in un-preverjanje \"auto-vrtenje in center\". Ti pojavijo na Izbira tiskalnika, ko dejansko tiskanje PDF.',0),(440870,12247,'ba','Pastikan ketika Percetakan untuk memilih \"tidak\" untuk \"scaling halaman\" dan Hapus centang \"auto-rotate dan pusat\". Ini muncul pada seleksi printer ketika benar-benar mencetak PDF.',0),(440871,12247,'nl','Zorg ervoor dat bij het afdrukken om te selecteren \"none\" voor \"pagina schalen\" en verwijder het vinkje \"automatisch roteren en centreren\". Deze worden weergegeven op de printerselectie wanneer daadwerkelijk afdrukken van de PDF.',0),(440872,12247,'fi','Varmista, ettÃ¤ tulostettaessa Valitse \"ei mitÃ¤Ã¤n\" \"sivun skaalaus\" ja un-Tarkista \"auto-rotate and center\". NÃ¤mÃ¤ nÃ¤kyy tulostimen valinta kun tulostaa PDF.',0),(440873,12247,'no','Kontroller at ved utskrift for Ã¥ velge \"ingen\" for \"Sideskalering\" og un-sjekk \"auto-Roter og Midtstill\". Disse vises pÃ¥ Skrivervalg ved faktisk utskrift PDF.',0),(440874,12247,'da','SÃ¸rg for, nÃ¥r udskrivning for at vÃ¦lge \"ingen\" for \"side bestiger\" og un-tjekke \"auto-rotere og center\". Disse vises pÃ¥ valget printer, nÃ¥r faktisk udskrivning af PDF-filen.',0),(440875,12247,'ko','ì¸ì‡„ëŠ” \"ìžë™ íšŒì „ ë° ê°€ìš´ë°\" \"íŽ˜ì´ì§€ ìŠ¤ì¼€ì¼ë§\"ì™€ ìœ ì—”-ê²€ì‚¬ì— ëŒ€ í•œ \"ì—†ìŒ\"ì„ ì„ íƒ í•˜ëŠ” ê²½ìš° ìžˆëŠ”ì§€ í™•ì¸ í•˜ì‹­ì‹œì˜¤. ì´ëŸ¬í•œ ì‹¤ì œë¡œ PDFë¥¼ ì¸ì‡„í•  ë•Œ í”„ë¦°í„° ì„ íƒ ì˜ì—­ì— ë‚˜íƒ€ë‚©ë‹ˆë‹¤.',0),(440876,12247,'he','×•×“× ×›×™ ×‘×¢×ª ×”×“×¤×¡×” ×›×“×™ ×œ×‘×—×•×¨ \"×œ×œ×\" ×¢×‘×•×¨ \'×©×™× ×•×™ ×’×•×“×œ ×¢×ž×•×“\', × ×˜×¨×œ×• ××ª \"×œ×¡×™×‘×•×‘ ××•×˜×•×ž×˜×™, ×ž×¨×›×–\". ××œ×” ×ž×•×¤×™×¢×™× ×¢×œ ×”×‘×—×™×¨×” ×”×ž×“×¤×¡×ª ×‘×¢×ª ×”×“×¤×¡×” PDF.',0),(440877,12247,'el','Î’ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÎµ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ \"ÎºÎ±Î½Î­Î½Î±\" Î³Î¹Î± Ï„Î·Î½ \"ÎºÎ»Î¹Î¼Î¬ÎºÏ‰ÏƒÎ· ÏƒÎµÎ»Î¯Î´Î±Ï‚\" ÎºÎ±Î¹ Î±Ï€Î¿ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ \"Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· Ï€ÎµÏÎ¹ÏƒÏ„ÏÎ¿Ï†Î® ÎºÎ±Î¹ ÎºÎ­Î½Ï„ÏÎ¿\". Î‘Ï…Ï„Î',0),(440878,12247,'zh','ç¡®ä¿å°åˆ·æ—¶ä¸ºâ€œé¡µé¢ç¼©æ”¾â€é€‰æ‹©â€œæ²¡æœ‰â€é”®å¹¶ä¸å‹¾â€œè‡ªåŠ¨æ—‹è½¬å’Œä¸­å¿ƒâ€æ¡†ã€‚å½“å®žé™…æ‰“å°PDFæ–‡ä»¶æ—¶ï¼Œè¿™äº›ä¼šå‡ºçŽ°åœ¨æ‰“å°æœºé€‰é¡¹ä¸­ã€‚',0),(440879,12247,'sv','Se till att nÃ¤r du skriver ut fÃ¶r att vÃ¤lja \"ingen\" fÃ¶r \"sidskalning\" och avmarkera \"Autorotera och centrera\". Visas pÃ¥ skrivare nÃ¤r faktiskt skriva ut PDF-filen.',0),(440880,12247,'it','Assicurarsi che quando si stampa per selezionare \"nessuno\" per \"ridimensionamento pagina\" e deseleziona \"ruota automaticamente e il centro\". Questi appaiono nella selezione della stampante quando si stampa in realtÃ  il PDF.',0),(440881,12247,'tl','',0),(440882,12247,'th','à¹ƒà¸«à¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸§à¹ˆà¸²à¹€à¸¡à¸·à¹ˆà¸­à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸«à¹‰à¹€à¸¥à¸·à¸­à¸ \"à¹„à¸¡à¹ˆà¸¡à¸µ\" \"à¸«à¸™à¹‰à¸²à¸›à¸£à¸±à¸š\" à¹à¸¥à¸°à¸¢à¸à¹€à¸¥à¸´à¸à¸à¸²à¸£ \"à¸«à¸¡à¸¸à¸™à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´ à¹à¸¥à¸°à¸¨à¸¹à¸™à¸¢à¹Œ\" à¹€à¸«à¸¥à¹ˆà¸²à¸™',0),(440883,12247,'hi','à¤¯à¤•à¥€à¤¨ à¤¹à¥ˆ à¤•à¤¿ \"à¤•à¥‹à¤ˆ à¤¨à¤¹à¥€à¤‚\" \"à¤ªà¥ƒà¤·à¥à¤  à¤¸à¥à¤•à¥‡à¤²à¤¿à¤‚à¤—\" à¤”à¤° à¤¸à¤‚à¤¯à¥à¤•à¥à¤¤ à¤°à¤¾à¤·à¥à¤Ÿà¥à¤°-à¤šà¥‡à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤šà¥à¤¨à¥‡à¤‚ \"à¤‘à¤Ÿà¥‹ à¤˜à¥à¤®à¤¾à¤à¤—à¥€ à¤”à¤° à¤•à¥‡à¤‚à¤¦à¥à¤°\" à¤•à¤°',0),(440884,12247,'ms','Pastikan apabila percetakan untuk pilih \"Tiada\" bagi \"cuci Laman\" dan PBB-semak \"Putar auto dan Pusat\". Ini muncul pada pemilihan pencetak apabila benar-benar percetakan PDF.',0),(440885,12247,'ar','ØªØ£ÙƒØ¯ Ø¹Ù†Ø¯ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ù„ØªØ­Ø¯ÙŠØ¯ \"Ø¨Ù„Ø§\" Ù„ \"ØµÙØ­Ø© Ø§Ù„Ù‚ÙŠØ§Ø³\" ÙˆØ§Ù„Ø£Ù…Ù… Ø§Ù„Ù…ØªØ­Ø¯Ø©--Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± \"ØªØ¯ÙˆÙŠØ± Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª ÙˆÙ…Ø±ÙƒØ²\". ØªØ¸Ù‡Ø± Ù‡Ø°Ù‡ Ø¹Ù„Ù‰ ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø·Ø§Ø¨Ø¹Ø© Ø¹Ù†Ø¯ ÙØ¹Ù„ÙŠØ§Ù‹ Ø·Ø¨Ø§Ø¹Ø© Ù…Ù„Ù ',0),(440886,12247,'fr','Assurez-vous que lors de l\'impression pour sÃ©lectionner Â« aucun Â» pour Â« page scaling Â» et dÃ©sactivez le Â« auto-rotate and center Â». Elles apparaissent sur la sÃ©lection de l\'imprimante lors de l\'impression en fait le fichier PDF.',0),(440887,12247,'jp','ç¢ºèªå°åˆ·ã€Œè‡ªå‹•å›žè»¢ã—ã€ä¸­å¤®ã€ã€Œãƒšãƒ¼ã‚¸ ã‚¹ã‚±ãƒ¼ãƒ«ã€ã¨å›½é€£ãƒã‚§ãƒƒã‚¯\"none\"ã‚’é¸æŠžã™ã‚‹ã¨ãã€‚ãƒ—ãƒªãƒ³ã‚¿ãƒ¼ã®é¸æŠžå®Ÿéš›ã« pdf ãƒ•ã‚¡ã‚¤ãƒ«ã‚’å°åˆ·ã™ã‚‹ã¨ãè¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(440888,12247,'pt','Certifique-se que ao imprimir para selecionar \"nenhum\" para \"dimensionamento de pÃ¡gina\" e desmarque o \"girar automaticamente e centralizar\". Estes aparecem sobre a seleÃ§Ã£o de impressora, quando na verdade a impressÃ£o do PDF.',0),(440889,12247,'ru','Ð£Ð±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾ Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Â«Ð½ÐµÑ‚Â» Ð´Ð»Ñ Â«Ð¼Ð°ÑÑˆÑ‚Ð°Ð± ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹Â» Ð¸ ÑÐ½Ð¸Ð¼Ð¸Ñ‚Ðµ Ñ„Ð»Ð°Ð¶Ð¾Ðº Â«ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð¿Ð¾Ð²Ð¾Ñ€Ð¾Ñ‚ Ð¸ Ñ†ÐµÐ½Ñ‚Ñ€Â». ÐžÐ½Ð¸ Ð¿Ð¾ÑÐ²Ð»ÑÑŽÑ‚ÑÑ Ð½Ð° Ð²Ñ‹Ð±Ð¾Ñ€ Ð',0),(440890,12247,'es','Hace seguro cuando imprime seleccionar \"ninguno\" para \"medidas de PÃ¡gina\" y no tachar \"autovoltear y centrar\". Ellos apraecen en la seleccion de impresora cuando esta actualmente imprimiendo el documento PDF\r\n',0),(440891,12247,'de','Achten Sie bei Drucken, wÃ¤hlen Sie \"none\" fÃ¼r \"Page scaling\" und deaktivieren Sie \"automatisch drehen und zentrieren\". Diese werden auf die Druckerauswahl angezeigt, beim eigentlich die PDF-Datei drucken.',0),(440892,12247,'en','Make sure when printing to select \"none\" for \"page scaling\" and un-check the \"auto-rotate and center\". These appear on the printer selection when actually printing the PDF.',0),(440893,12248,'is','',0),(440894,12248,'dr','',0),(440895,12248,'pr','',0),(440896,12248,'tr','',0),(440897,12248,'pl','',0),(440898,12248,'bg','',0),(440899,12248,'ur','',0),(440900,12248,'sr','',0),(440901,12248,'vi','',0),(440902,12248,'af','',0),(440903,12248,'ro','',0),(440904,12248,'et','',0),(440905,12248,'si','',0),(440906,12248,'ba','',0),(440907,12248,'nl','',0),(440908,12248,'fi','',0),(440909,12248,'no','',0),(440910,12248,'da','',0),(440911,12248,'ko','',0),(440912,12248,'he','',0),(440913,12248,'el','',0),(440914,12248,'zh','',0),(440915,12248,'sv','',0),(440916,12248,'it','',0),(440917,12248,'tl','',0),(440918,12248,'th','',0),(440919,12248,'hi','',0),(440920,12248,'ms','',0),(440921,12248,'ar','',0),(440922,12248,'fr','',0),(440923,12248,'jp','',0),(440924,12248,'pt','',0),(440925,12248,'ru','',0),(440926,12248,'es','',0),(440927,12248,'de','',0),(440928,12248,'en','',0),(440929,12249,'is','',0),(440930,12249,'dr','',0),(440931,12249,'pr','',0),(440932,12249,'tr','',0),(440933,12249,'pl','',0),(440934,12249,'bg','',0),(440935,12249,'ur','',0),(440936,12249,'sr','',0),(440937,12249,'vi','',0),(440938,12249,'af','',0),(440939,12249,'ro','',0),(440940,12249,'et','',0),(440941,12249,'si','',0),(440942,12249,'ba','',0),(440943,12249,'nl','',0),(440944,12249,'fi','',0),(440945,12249,'no','',0),(440946,12249,'da','',0),(440947,12249,'ko','',0),(440948,12249,'he','',0),(440949,12249,'el','',0),(440950,12249,'zh','',0),(440951,12249,'sv','',0),(440952,12249,'it','',0),(440953,12249,'tl','',0),(440954,12249,'th','',0),(440955,12249,'hi','',0),(440956,12249,'ms','',0),(440957,12249,'ar','',0),(440958,12249,'fr','',0),(440959,12249,'jp','',0),(440960,12249,'pt','',0),(440961,12249,'ru','',0),(440962,12249,'es','',0),(440963,12249,'de','',0),(440964,12249,'en','',0),(440965,12250,'is','',0),(440966,12250,'dr','',0),(440967,12250,'pr','',0),(440968,12250,'tr','',0),(440969,12250,'pl','',0),(440970,12250,'bg','',0),(440971,12250,'ur','',0),(440972,12250,'sr','',0),(440973,12250,'vi','',0),(440974,12250,'af','',0),(440975,12250,'ro','',0),(440976,12250,'et','',0),(440977,12250,'si','',0),(440978,12250,'ba','',0),(440979,12250,'nl','',0),(440980,12250,'fi','',0),(440981,12250,'no','',0),(440982,12250,'da','',0),(440983,12250,'ko','',0),(440984,12250,'he','',0),(440985,12250,'el','',0),(440986,12250,'zh','',0),(440987,12250,'sv','',0),(440988,12250,'it','',0),(440989,12250,'tl','',0),(440990,12250,'th','',0),(440991,12250,'hi','',0),(440992,12250,'ms','',0),(440993,12250,'ar','',0),(440994,12250,'fr','',0),(440995,12250,'jp','',0),(440996,12250,'pt','',0),(440997,12250,'ru','',0),(440998,12250,'es','',0),(440999,12250,'de','',0),(441000,12250,'en','',0),(441001,12251,'is','',0),(441002,12251,'dr','',0),(441003,12251,'pr','',0),(441004,12251,'tr','',0),(441005,12251,'pl','',0),(441006,12251,'bg','',0),(441007,12251,'ur','',0),(441008,12251,'sr','',0),(441009,12251,'vi','',0),(441010,12251,'af','',0),(441011,12251,'ro','',0),(441012,12251,'et','',0),(441013,12251,'si','',0),(441014,12251,'ba','',0),(441015,12251,'nl','',0),(441016,12251,'fi','',0),(441017,12251,'no','',0),(441018,12251,'da','',0),(441019,12251,'ko','',0),(441020,12251,'he','',0),(441021,12251,'el','',0),(441022,12251,'zh','',0),(441023,12251,'sv','',0),(441024,12251,'it','',0),(441025,12251,'tl','',0),(441026,12251,'th','',0),(441027,12251,'hi','',0),(441028,12251,'ms','',0),(441029,12251,'ar','',0),(441030,12251,'fr','',0),(441031,12251,'jp','',0),(441032,12251,'pt','',0),(441033,12251,'ru','',0),(441034,12251,'es','',0),(441035,12251,'de','',0),(441036,12251,'en','',0),(441037,12252,'is','',0),(441038,12252,'dr','',0),(441039,12252,'pr','',0),(441040,12252,'tr','',0),(441041,12252,'pl','',0),(441042,12252,'bg','',0),(441043,12252,'ur','',0),(441044,12252,'sr','',0),(441045,12252,'vi','',0),(441046,12252,'af','',0),(441047,12252,'ro','',0),(441048,12252,'et','',0),(441049,12252,'si','',0),(441050,12252,'ba','',0),(441051,12252,'nl','',0),(441052,12252,'fi','',0),(441053,12252,'no','',0),(441054,12252,'da','',0),(441055,12252,'ko','',0),(441056,12252,'he','',0),(441057,12252,'el','',0),(441058,12252,'zh','',0),(441059,12252,'sv','',0),(441060,12252,'it','',0),(441061,12252,'tl','',0),(441062,12252,'th','',0),(441063,12252,'hi','',0),(441064,12252,'ms','',0),(441065,12252,'ar','',0),(441066,12252,'fr','',0),(441067,12252,'jp','',0),(441068,12252,'pt','',0),(441069,12252,'ru','',0),(441070,12252,'es','',0),(441071,12252,'de','',0),(441072,12252,'en','',0),(441073,12253,'is','',0),(441074,12253,'dr','',0),(441075,12253,'pr','',0),(441076,12253,'tr','',0),(441077,12253,'pl','',0),(441078,12253,'bg','',0),(441079,12253,'ur','',0),(441080,12253,'sr','',0),(441081,12253,'vi','',0),(441082,12253,'af','',0),(441083,12253,'ro','',0),(441084,12253,'et','',0),(441085,12253,'si','',0),(441086,12253,'ba','',0),(441087,12253,'nl','',0),(441088,12253,'fi','',0),(441089,12253,'no','',0),(441090,12253,'da','',0),(441091,12253,'ko','',0),(441092,12253,'he','',0),(441093,12253,'el','',0),(441094,12253,'zh','',0),(441095,12253,'sv','',0),(441096,12253,'it','',0),(441097,12253,'tl','',0),(441098,12253,'th','',0),(441099,12253,'hi','',0),(441100,12253,'ms','',0),(441101,12253,'ar','',0),(441102,12253,'fr','',0),(441103,12253,'jp','',0),(441104,12253,'pt','',0),(441105,12253,'ru','',0),(441106,12253,'es','',0),(441107,12253,'de','',0),(441108,12253,'en','',0),(441109,12254,'is','',0),(441110,12254,'dr',':Ù…Ø¯ÛŒØ±ÛŒØª-Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù…Ø¯ÛŒØ±ÛŒØª-ÛŒÙˆØ²Ø± Ø¬Ø¯ÛŒØ¯ /Ø§ØµÙ„Ø§Ø­',0),(441111,12254,'pr','Ø¨Ø±Ø§ÛŒ ØªØºÛŒÛŒØ± Ù†Ø§Ù… ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… Ùˆ Ù¾Ø³ÙˆØ±Ø¯Ø§ÛŒÙ† Ø¬Ø§ Ø±Ø§ Ø¨Ø¨ÛŒÙ†ÛŒØ¯:Ù…Ø¯ÛŒØ±ÛŒØª-Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù…Ø¯ÛŒØ±ÛŒØª-Ú©Ø§Ø±Ø¨Ø± Ø¬Ø¯ÛŒØ¯ /ÙˆÛŒØ±Ø§ÛŒØ´',0),(441112,12254,'tr','Bir oturum aÃ§ma adÄ± ve parola ziyaret deÄŸiÅŸtirmek iÃ§in:<p><b>Admin Admin kurulumu kullanÄ±cÄ± yeni/DÃ¼zenle->-></b>',0),(441113,12254,'pl','Aby zmieniÄ‡ identyfikator logowania nazwy uÅ¼ytkownika i hasÅ‚a OdwiedÅº:<p><b>Admin-> konfiguracji Admin-> nowego uÅ¼ytkownika/edycja</b>',0),(441114,12254,'bg','Ð—Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð¸Ð¼Ðµ Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð¿Ð¾ÑÐµÑ‰ÐµÐ½Ð¸Ðµ:<p><b>Admin-> Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-> Ð½Ð¾Ð² Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ</b>',0),(441115,12254,'ur','Ù„Ø§Ú¯ Ø§Ù† Ù†Ø§Ù… Ø§ÙˆØ± Ù¾Ø§Ø³ ÙˆØ±Úˆ Ú©Û’ Ø¯ÙˆØ±Û’ Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’:<p><b>Ø§ÛŒÚˆÙ…Ù† Admin Ø³ÛŒÙ¹ Ø§Ù¾ Ù†ÛŒØ§ ØµØ§Ø±Ù/ØªØ±Ù…ÛŒÙ…->-></b>',0),(441116,12254,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð»Ð¸ Ð¿Ð¾ÑÑ˜ÐµÑ‚Ñƒ Ð»Ð¾Ð³Ð¸Ð½ Ð¸Ð¼Ðµ Ð¸ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ ÐÐ´Ð¼Ð¸Ð½ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ð¸ Ð½Ð¾Ð²Ð¸Ñ… ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ</b>',0),(441117,12254,'vi','Äá»ƒ thay Ä‘á»•i tÃªn vÃ  máº­t kháº©u Ä‘Äƒng nháº­p thÃ¬ vÃ o: Quáº£n lÃ½-> cÃ i Ä‘áº·t quáº£n lÃ½-> thÃªm má»›i/sá»­a ngÆ°á»i sá»­ dá»¥ng',0),(441118,12254,'af','Verander \'n aantekening naam en wagwoord, besoek:<p><b>Admin-> Admin opstelling-> nuwe gebruiker/redigeer</b>',0),(441119,12254,'ro','Pentru a schimba un login nume ÅŸi password vizitaÅ£i:<p><b>Admin->-Admin Setup-> utilizator nou/editare</b>',0),(441120,12254,'et','Muuta login ja parool kÃ¼lastada:<p><b>Admin-> Admin seadistamine kasutaja uus/Muuda-></b>',0),(441121,12254,'si','Spremeniti a prepriÄevalnost ime ter parola obiÅ¡Äite:<p><b>Admin-> Admin Setup-> nov uporabnik/Uredi</b>',0),(441122,12254,'ba','Untuk mengubah nama dan password login Kunjungan:<p><b>Admin-> Admin Setup-> pengguna baru/Edit</b>',0),(441123,12254,'nl','Om te veranderen van een login naam en wachtwoord bezoek:<p><b>Admin-> Admin Setup-> / nieuwe gebruiker bewerken</b>',0),(441124,12254,'fi','Voit muuttaa kÃ¤yttÃ¤jÃ¤tunnuksen nimi ja salasana kÃ¤y:<p><b>Admin Admin asetukset-> kÃ¤yttÃ¤jÃ¤n uusi tai Muokkaa-></b>',0),(441125,12254,'no','Endre en login og passord gÃ¥:<p><b>Admin-> Admin Setup-> bruker ny/Rediger</b>',0),(441126,12254,'da','Ã†ndre et login og adgangskode besÃ¸g:<p><b>Admin-> Admin Setup-> bruger ny/Rediger</b>',0),(441127,12254,'ko','ë³€ê²½ í•˜ë ¤ë©´ ë¡œê·¸ì¸ ì´ë¦„ ë° ì•”í˜¸ ë°©ë¬¸:<p><b>ê´€ë¦¬ìž ì„¤ì¹˜ ì‚¬ìš©ìž ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘->-> ê´€ë¦¬ìž</b>',0),(441128,12254,'he','×›×“×™ ×œ×©× ×•×ª ××ª ×‘×™×§×•×¨ ×›× ×™×¡×” ×•×¡×™×¡×ž×”:<p><b>Admin-> ×ž× ×”×œ ×”×”×ª×§× ×”-> ×ž×©×ª×ž×© ×—×“×©/×¢×¨×™×›×”</b>',0),(441129,12254,'el','Î“Î¹Î± Î½Î± Î±Î»Î»Î¬Î¾ÎµÏ„Îµ Î¼Î¹Î± ÏƒÏÎ½Î´ÎµÏƒÎ· ÏŒÎ½Î¿Î¼Î± ÎºÎ±Î¹ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÎµÏ€Î¹ÏƒÎºÎµÏ†Î¸ÎµÎ¯Ï„Îµ:<p><b>Admin-> Admin Setup-> Ï‡ÏÎ®ÏƒÏ„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±</b>',0),(441130,12254,'zh','è¦æ›´æ”¹ä¸€ä¸ªç™»å½•åå’Œå¯†ç æŸ¥çœ‹ï¼šç®¡ç†->ç®¡ç†è®¾ç½®->ç”¨æˆ·æ–°/ç¼–è¾‘',0),(441131,12254,'sv','Ã„ndra ett login och lÃ¶senord besÃ¶k:<p><b>Admin-> Admin instÃ¤llning-> den nya anvÃ¤ndaren/redigera</b>',0),(441132,12254,'it','Per modificare una visita di nome e password di login:<p><b>Admin-> Admin Setup-> utente nuovo/modifica</b>',0),(441133,12254,'tl','',0),(441134,12254,'th','à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¸Šà¸·à¹ˆà¸­à¹à¸¥à¸°à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¹€à¸‚à¹‰à¸²:<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² Admin->à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚</b>',0),(441135,12254,'hi','à¤à¤• à¤²à¥‰à¤—à¤¿à¤¨ à¤¨à¤¾à¤® à¤”à¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¯à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‹ à¤¬à¤¦à¤²à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤/à¤¸à¤‚à¤ªà¤¾',0),(441136,12254,'ms','Untuk menukar log masuk nama dan kata laluan sila layari:<p><b>Admin-> Admin persediaan-> pengguna baru/Edit</b>',0),(441137,12254,'ar','Ù„ØªØºÙŠÙŠØ± Ø²ÙŠØ§Ø±Ø© Ø§Ø³Ù… ÙˆÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± ØªØ³Ø¬ÙŠÙ„ Ø¯Ø®ÙˆÙ„:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø´Ø±Ù-> Ù…Ø³ØªØ®Ø¯Ù… Ø¬Ø¯ÙŠØ¯/ØªØ­Ø±ÙŠØ±</b>',0),(441138,12254,'fr','Pour modifier une visite de nom et mot de passe de connexion :<p><b>Admin-> Admin Setup-> nouvel utilisateur/modifier</b>',0),(441139,12254,'jp','ãƒ­ã‚°ã‚¤ãƒ³åã¨ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®è¨ªå•ã‚’å¤‰æ›´: ã™ã‚‹<p><b>ç®¡ç†è€…ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ï¼ ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®ç·¨é›†æ–°ã—ã„->-></b>',0),(441140,12254,'pt','Para alterar uma visita de nome e senha de login:<p><b>Admin-> Admin Setup-> novo usuÃ¡rio/editar</b>',0),(441141,12254,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð»Ð¾Ð³Ð¸Ð½ Ð¸Ð¼Ñ Ð¸ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ, Ð¿Ð¾ÑÐµÑ‚Ð¸Ñ‚Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸-> Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ/Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ</b>',0),(441142,12254,'es','Para Cambiar un nombre y Password de Log-In visita:<p><b>Admin ->Admin ConfiguraciÃ³n -> Usuario Nuevo/Editar</b>',0),(441143,12254,'de','So Ã¤ndern Sie einen Login-Namen und das Kennwort-Besuch:<p><b>Admin-> Admin Setup-> Benutzer neu/bearbeiten</b>',0),(441144,12254,'en','To change a login name and password visit:<p><b>Admin -> Admin Setup -> User New/Edit</b>',0),(441145,12255,'is','',0),(441146,12255,'dr','',0),(441147,12255,'pr','',0),(441148,12255,'tr','',0),(441149,12255,'pl','',0),(441150,12255,'bg','',0),(441151,12255,'ur','',0),(441152,12255,'sr','',0),(441153,12255,'vi','',0),(441154,12255,'af','',0),(441155,12255,'ro','',0),(441156,12255,'et','',0),(441157,12255,'si','',0),(441158,12255,'ba','',0),(441159,12255,'nl','',0),(441160,12255,'fi','',0),(441161,12255,'no','',0),(441162,12255,'da','',0),(441163,12255,'ko','',0),(441164,12255,'he','',0),(441165,12255,'el','',0),(441166,12255,'zh','',0),(441167,12255,'sv','',0),(441168,12255,'it','',0),(441169,12255,'tl','',0),(441170,12255,'th','',0),(441171,12255,'hi','',0),(441172,12255,'ms','',0),(441173,12255,'ar','',0),(441174,12255,'fr','',0),(441175,12255,'jp','',0),(441176,12255,'pt','',0),(441177,12255,'ru','',0),(441178,12255,'es','',0),(441179,12255,'de','',0),(441180,12255,'en','',0),(441181,12256,'is','',0),(441182,12256,'dr','',0),(441183,12256,'pr','',0),(441184,12256,'tr','',0),(441185,12256,'pl','',0),(441186,12256,'bg','',0),(441187,12256,'ur','',0),(441188,12256,'sr','',0),(441189,12256,'vi','',0),(441190,12256,'af','',0),(441191,12256,'ro','',0),(441192,12256,'et','',0),(441193,12256,'si','',0),(441194,12256,'ba','',0),(441195,12256,'nl','',0),(441196,12256,'fi','',0),(441197,12256,'no','',0),(441198,12256,'da','',0),(441199,12256,'ko','',0),(441200,12256,'he','',0),(441201,12256,'el','',0),(441202,12256,'zh','',0),(441203,12256,'sv','',0),(441204,12256,'it','',0),(441205,12256,'tl','',0),(441206,12256,'th','',0),(441207,12256,'hi','',0),(441208,12256,'ms','',0),(441209,12256,'ar','',0),(441210,12256,'fr','',0),(441211,12256,'jp','',0),(441212,12256,'pt','',0),(441213,12256,'ru','',0),(441214,12256,'es','',0),(441215,12256,'de','',0),(441216,12256,'en','',0),(441217,12257,'is','',0),(441218,12257,'dr','',0),(441219,12257,'pr','',0),(441220,12257,'tr','',0),(441221,12257,'pl','',0),(441222,12257,'bg','',0),(441223,12257,'ur','',0),(441224,12257,'sr','',0),(441225,12257,'vi','',0),(441226,12257,'af','',0),(441227,12257,'ro','',0),(441228,12257,'et','',0),(441229,12257,'si','',0),(441230,12257,'ba','',0),(441231,12257,'nl','',0),(441232,12257,'fi','',0),(441233,12257,'no','',0),(441234,12257,'da','',0),(441235,12257,'ko','',0),(441236,12257,'he','',0),(441237,12257,'el','',0),(441238,12257,'zh','',0),(441239,12257,'sv','',0),(441240,12257,'it','',0),(441241,12257,'tl','',0),(441242,12257,'th','',0),(441243,12257,'hi','',0),(441244,12257,'ms','',0),(441245,12257,'ar','',0),(441246,12257,'fr','',0),(441247,12257,'jp','',0),(441248,12257,'pt','',0),(441249,12257,'ru','',0),(441250,12257,'es','',0),(441251,12257,'de','',0),(441252,12257,'en','',0),(441253,12258,'is','',0),(441254,12258,'dr','',0),(441255,12258,'pr','',0),(441256,12258,'tr','',0),(441257,12258,'pl','',0),(441258,12258,'bg','',0),(441259,12258,'ur','',0),(441260,12258,'sr','',0),(441261,12258,'vi','',0),(441262,12258,'af','',0),(441263,12258,'ro','',0),(441264,12258,'et','',0),(441265,12258,'si','',0),(441266,12258,'ba','',0),(441267,12258,'nl','',0),(441268,12258,'fi','',0),(441269,12258,'no','',0),(441270,12258,'da','',0),(441271,12258,'ko','',0),(441272,12258,'he','',0),(441273,12258,'el','',0),(441274,12258,'zh','',0),(441275,12258,'sv','',0),(441276,12258,'it','',0),(441277,12258,'tl','',0),(441278,12258,'th','',0),(441279,12258,'hi','',0),(441280,12258,'ms','',0),(441281,12258,'ar','',0),(441282,12258,'fr','',0),(441283,12258,'jp','',0),(441284,12258,'pt','',0),(441285,12258,'ru','',0),(441286,12258,'es','',0),(441287,12258,'de','',0),(441288,12258,'en','',0),(441289,12259,'is','',0),(441290,12259,'dr','. Ù„ÛŒØ¬Ø±-Ù„ÛŒØ³Øª Ø­Ø³Ø§Ø¨Ù‡Ø§-Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÛŒØ¯ Ù„ÛŒØ¬Ø±',0),(441291,12259,'pr','Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± Ø±Ø¯ÛŒØ§Ø¨ÛŒ Ø¯Ø§Ø±Ø§Ø¦ÛŒ Ù‡Ø§ÛŒ Ø«Ø§Ø¨Øª Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ÛŒÚ© Ø­Ø³Ø§Ø¨ Ø¯Ø§Ø±Ø§Ø¦ÛŒ Ø«Ø§Ø¨Øª Ø¯Ø± Ø¯ÙØªØ± Ú©Ù„ Ø§ÛŒØ¬Ø§Ø¯ Ú©Ù†ÛŒØ¯. Ø¯ÙØªØ± Ú©Ù„-Ù„ÛŒØ³Øª Ø­Ø³Ø§Ø¨Ù‡Ø§-Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÛŒØ¯ Ø¯ÙØªØ± Ú©Ù„\r\nØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒ',0),(441292,12259,'tr','Bir sabit kÄ±ymetin izlemek Ã¼zere bir varlÄ±k GL hesap oluÅŸturabilirsiniz:<p><b>Genel muhasebe hesap planÄ± yeni GL hesap->->.</b><p>Not hesap tipleri sabittir.',0),(441293,12259,'pl','Åšledzenie Å›rodkÃ³w trwaÅ‚ych moÅ¼na utworzyÄ‡ skÅ‚adnika aktywÃ³w GL konta:<p><b>KsiÄ™gi-> kont-> nowe konto GL.</b><p>NaleÅ¼y pamiÄ™taÄ‡, Å¼e konta sÄ… staÅ‚e.',0),(441294,12259,'bg','Ð—Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð´ÐµÐ½ Ð´ÑŠÐ»Ð³Ð¾Ñ‚Ñ€Ð°ÐµÐ½ Ð°ÐºÑ‚Ð¸Ð² Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ Ð°ÐºÑ‚Ð¸Ð² GL Ð°ÐºÐ°ÑƒÐ½Ñ‚:<p><b>ÐšÐ½Ð¸Ð³Ð° Ð·Ð°-> ÑÐ¼ÐµÑ‚ÐºÐ¾Ð¿Ð»Ð°Ð½-> Ð½Ð¾Ð² GL Ð°ÐºÐ°ÑƒÐ½Ñ‚.</b><p>Ð˜Ð¼Ð°Ð¹Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð²Ð¸Ð´, Ñ‡Ðµ Ð²',0),(441295,12259,'ur','Ø§ÛŒÚ© ÙÚ©Ø³Úˆ Ø§Ø«Ø§Ø«Û Ø³Ø±Ø§Øº Ø±Ø§Û Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ø§Ø«Ø§Ø«Û Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚ Ú©Ø±Ø³Ú©ØªÛ’ ÛÛŒÚº:<p><b>Ù†ÛŒØ§ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹-> Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ú†Ø§Ø±Ù¹-> Ú©Ú¾Ø§ØªØ§ ÛÛ’ Û”</b><p>Ù†ÙˆÙ¹ Ú©Ø±ÛŒÚº Ú©Û Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(441296,12259,'sr','ÐŸÑ€Ð°Ñ›ÐµÑšÐµ Ð¾ÑÐ½Ð¾Ð²Ð½Ð¸Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð° Ð¼Ð¾Ð¶ÐµÑ‚Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð½Ð¸Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð° Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°:<p><b>ÐšÑšÐ¸Ð³Ðµ Ð¸ ÐºÐ¾Ð½Ñ‚Ð½Ð¸ Ð¿Ð»Ð°Ð½ Ð¸ Ð½Ð¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð“Ð›.</b><p>Ð˜Ð¼Ð°Ñ˜Ñ‚Ðµ Ñƒ Ð²Ð¸Ð´Ñƒ Ð´Ð° Ñ‚Ð¸Ð',0),(441297,12259,'vi','Äá»ƒ theo dÃµi tÃ i sáº£n cá»‘ Ä‘á»‹nh, báº¡n táº¡o tÃ i khoáº£n tÃ i sáº£n GL: Ledger-> danh má»¥c tÃ i khoáº£n-> TK GL má»›i. LÆ°u Ã½ ráº±ng cÃ¡c loáº¡i tk nÃ y Ä‘Æ°á»£c cá»‘ Ä‘á»‹nh',0),(441298,12259,'af','Om op te spoor van \'n vaste bate kan jy \'n bate GL rekening skep:<p><b>Grootboek-> tabel van rekeninge-> nuwe GL rekening.</b><p>Let daarop dat rekening tipes vasgestel is.',0),(441299,12259,'ro','Pentru a urmÄƒri un mijloc fix se poate crea un activ GL cont:<p><b>Reg.-> planul de conturi-> cont nou GL.</b><p>ReÅ£ineÅ£i cÄƒ, tipuri de conturi sunt fixe.',0),(441300,12259,'et','PÃµhivara jÃ¤lgimiseks saate luua vara GL konto:<p><b>Pearaamatu kontoplaani-> uus pearaamatukontole->.</b><p>Pange tÃ¤hele, et tÃ¼Ã¼bid on fikseeritud.',0),(441301,12259,'si','Za sledenje osnovno sredstvo lahko ustvarite sredstvo GL raÄun:<p><b>Knjigo-> Kontni naÄrt-> nov raÄun GL.</b><p>UpoÅ¡tevajte, da so doloÄene vrste raÄunov.',0),(441302,12259,'ba','Untuk melacak Aktiva tetap, Anda dapat membuat sebuah aset GL akun:<p><b>Ledger-> bagan akun-> akun baru GL.</b><p>Perhatikan bahwa jenis rekening yang tetap.',0),(441303,12259,'nl','U kunt een actief GL account maken voor het bijhouden van een vast activum:<p><b>VA-> rekeningschema-> nieuwe GL Account.</b><p>Merk op dat rekeningsoorten worden opgelost.',0),(441304,12259,'fi','Voit seurata kÃ¤yttÃ¶omaisuuserÃ¤n luomalla omaisuuserÃ¤n Kirjanpitotilin pÃ¤Ã¤tilin:<p><b>Kirjanpidon tilikartan-> uuden Kirjanpitotilin pÃ¤Ã¤tilin->.</b><p>Huomaa, ettÃ¤ tyypit ovat kiinteitÃ¤.',0),(441305,12259,'no','Du kan opprette et anleggsmiddel gi-konto for Ã¥ spore aktiva:<p><b>Finans-> kontoplanen-> ny GL konto.</b><p>Merk at kontotyper er lÃ¸st.',0),(441306,12259,'da','For at spore et anlÃ¦gsaktiv kan du oprette et aktiv GL konto:<p><b>Finans-> kontoplanen-> nye GL konto.</b><p>BemÃ¦rk, at kontotyper er faste.',0),(441307,12259,'ko','ê³ ì •ëœ ìžì‚°ì„ ì¶”ì  í•˜ëŠ” ìžì‚° GL ê³„ì • ë§Œë“¤ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p><b>ë ˆì € ìƒˆë¡œìš´ GL ê³„ì •-> ê³„ì • ì°¨íŠ¸->.</b><p>ì°¸ê³  ê³„ì • ìœ í˜• ê³ ì • ë©ë‹ˆë‹¤.',0),(441308,12259,'he','×›×“×™ ×œ×¢×§×•×‘ ××—×¨ ×¨×›×•×© ×§×‘×•×¢ × ×™×ª×Ÿ ×œ×™×¦×•×¨ × ×›×¡ GL ×—×©×‘×•×Ÿ:<p><b>×¨××©×™-> ×ª×¨×©×™× ×ª×™×§×™ ×œ×§×•×—×•×ª-> ×—×©×‘×•×Ÿ GL ×—×“×©.</b><p>×”×¢×¨×” ×¡×•×’×™ ×—×©×‘×•× ×•×ª ×”×ž×ª×•×§× ×™×.',0),(441309,12259,'el','ÎÎ± Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿Ï…Î¸ÎµÎ¯Ï„Îµ Î­Î½Î± Ï€Î¬Î³Î¹Î¿, Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î­Î½Î± Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¹Î±ÎºÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»:<p><b>Î›Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®-> Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ‡Î­Î´Î¹Î¿-> Î½Î­Î± Î»Î¿Î³Î±Ï',0),(441310,12259,'zh','è¦è·Ÿè¸ªä¸€æ‰¹å›ºå®šçš„èµ„äº§ï¼Œä½ å¯ä»¥åˆ›å»ºä¸€ä¸ªèµ„äº§æ€»å¸',0),(441311,12259,'sv','Om du vill spÃ¥ra en anlÃ¤ggningstillgÃ¥ng kan du skapa en tillgÃ¥ng GL konto:<p><b>Redovisning-> kontoplanen-> nya GL konto.</b><p>Observera att kontotyper Ã¤r fasta.',0),(441312,12259,'it','Per tenere traccia di un cespite Ã¨ possibile creare un bene conto GL:<p><b>ContabilitÃ -> piano dei conti-> nuovo Account GL.</b><p>Si noti che i tipi di account sono fissi.',0),(441313,12259,'tl','',0),(441314,12259,'th','à¸à¸²à¸£à¸•à¸´à¸”à¸•à¸²à¸¡à¸ªà¸´à¸™à¸—à¸£à¸±à¸žà¸¢à¹Œà¸–à¸²à¸§à¸£ à¸„à¸¸à¸“à¸ªà¸²à¸¡à¸²à¸£à¸–à¸ªà¸£à¹‰à¸²à¸‡à¸ªà¸´à¸™à¸—à¸£à¸±à¸žà¸¢à¹Œà¸šà¸±à¸à¸Šà¸µ GL:<p><b>à¸šà¸±à¸à¸Šà¸µ->à¸šà¸±à¸à¸Šà¸µ->à¸šà¸±à¸à¸Šà¸µ GL à¹ƒà¸«à¸¡à¹ˆ.</b><p>à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•',0),(441315,12259,'hi','à¤à¤• à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤•à¥‹ à¤Ÿà¥à¤°à¥ˆà¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤ª à¤à¤• à¤ªà¤°à¤¿à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ GL à¤–à¤¾à¤¤à¤¾ à¤¬à¤¨à¤¾ à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚:<p><b>à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤¨à¤ˆ GL à¤–à¤¾à¤¤à¥‡-> à¤–',0),(441316,12259,'ms','Untuk mengesan aset tetap, anda boleh mencipta aset akaun GL:<p><b>Lejar-> Carta akaun-> akaun GL baru.</b><p>Ambil perhatian bahawa jenis-jenis akaun ditetapkan.',0),(441317,12259,'ar','ÙŠÙ…ÙƒÙ†Ùƒ Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙˆØ¬ÙˆØ¯Ø§Øª Ø­Ø³Ø§Ø¨ GL Ù„ØªØ¹Ù‚Ø¨ Ø£ØµÙˆÙ„ Ø«Ø§Ø¨ØªØ©:<p><b>Ø§Ù„Ø£Ø³ØªØ§Ø°-> Ù…Ø®Ø·Ø· Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª-> Ø­Ø³Ø§Ø¨ GL Ø¬Ø¯ÙŠØ¯.</b><p>Ø¹Ù„Ù…Ø§ Ø¨Ø£Ù† Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø­Ø³Ø§Ø¨ ÙŠØªÙ… Ø¥ØµÙ„Ø§Ø­Ù‡Ø§.',0),(441318,12259,'fr','Pour suivre une immobilisation, vous pouvez crÃ©er un atout compte GL :<p><b>Livre-> plan comptable-> nouveau compte GL.</b><p>Notez que les types de comptes sont fixes.',0),(441319,12259,'jp','å›ºå®šè³‡ç”£ã‚’è¿½è·¡ã™ã‚‹ã«ã¯ã€è³‡ç”£ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½œæˆã§ãã¾ã™ã€‚<p><b>æ–°ã—ã„ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ-> ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ã‚°ãƒ©ãƒ•-> å…ƒå¸³</b>ã€‚<p>ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ç¨®é¡žãŒå›ºå®šã•ã‚Œã‚‹ã“ã¨ã«æ³¨æ„ã—ã¦ãã ã•ã„ã€‚',0),(441320,12259,'pt','Para rastrear um ativo fixo, vocÃª pode criar um ativo conta GL:<p><b>Livro-> plano de contas-> nova conta GL.</b><p>Observe que os tipos de conta sÃ£o fixos.',0),(441321,12259,'ru','Ð”Ð»Ñ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð¾ÑÐ½Ð¾Ð²Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð² Ð¼Ð¾Ð¶Ð½Ð¾ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ð°ÐºÑ‚Ð¸Ð² GL ÑÑ‡ÐµÑ‚Ð°:<p><b>Ð“Ðš-> ÑÑ‡ÐµÑ‚Ð¾Ð²-> Ð½Ð¾Ð²Ñ‹Ð¹ Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚ GL.</b><p>ÐžÐ±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ, Ñ‡Ñ‚Ð¾ Ñ‚Ð¸Ð¿Ñ‹ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ñ… Ð·Ð°Ð¿Ð¸Ñ',0),(441322,12259,'es','Para seguir un activo fijo puede crear una cuenta LM de activo:<p><b>LibroMayor -> CatÃ¡logo de Cuentas -> Nueva Cuenta LM. </b> <p> Not que los tipos de cuenta son fijos.',0),(441323,12259,'de','Um eine Anlage zu verfolgen kÃ¶nnen Sie VermÃ¶genswert GL-Konto erstellen:<p><b>Ledger-> Kontenplan-> Kundenkonto GL.</b><p>Beachten Sie, dass Kontotypen behoben werden.',0),(441324,12259,'en','To track a fixed asset you can create an asset GL account:<p><b>Ledger -> Chart of Accounts -> New GL Account. </b> <p> Note that account types are fixed.',0),(441325,12260,'is','',0),(441326,12260,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ Ø¨Ø§Ù†Ú© Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø´Ù…Ø§Ø¯Ø± Ù‚Ø³Ù…Øª \"Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø®Ø¯Ù…Ø§Øª \"Ùˆ Ø¯Ø± ØµÙØ­Ù‡ ØµÙˆØ±Øª Ù…ØºØ§ÛŒØ±Øª Ø¨Ø§Ù†Ú©ÛŒ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯.Ù‡Ø²ÛŒÙ†Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø´Ù…Ø§ Ùˆ ',0),(441327,12260,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ Ø¨Ø§Ù†Ú© Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø´Ù…Ø§Ø¯Ø± Ù‚Ø³Ù…Øª \"Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø®Ø¯Ù…Ø§Øª \"Ùˆ Ø¯Ø± ØµÙØ­Ù‡ ØµÙˆØ±Øª Ù…ØºØ§ÛŒØ±Øª Ø¨Ø§Ù†Ú©ÛŒ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯.Ù‡Ø²ÛŒÙ†Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø´Ù…Ø§ Ùˆ ',0),(441328,12260,'tr','Ek banka Ã¼cretleri aylÄ±k, beyanÄ± \"Servis Ã¼cretleri\" bÃ¶lÃ¼mÃ¼nde banka mutabakatÄ± ekranda girilir.<p>Kredi kartÄ± iÅŸlem Ã¼creti veya diÄŸer ek masraf \'<i>Yeni giriÅŸ Ekle</i>\' simgesini tÄ±klatarak girilebilir.',0),(441329,12260,'pl','Dodatkowej opÅ‚aty na swoje miesiÄ™czne sÄ… wpisane w sekcji \"OpÅ‚aty\" na ekranie pojednania banku.<p>Karty kredytowej przetwarzania opÅ‚at lub inne dodatkowe opÅ‚aty mogÄ… byÄ‡ wprowadzone przez klikniÄ™cie na ikonÄ™ \"<i>Dodaj nowy wpis</i>\".',0),(441330,12260,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ Ñ‚Ð°ÐºÑÐ¸ Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ Ð¼ÐµÑÐµÑ‡ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚ ÑÐ° Ð²Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð² Ñ€Ð°Ð·Ð´ÐµÐ» \"Ð¢Ð°ÐºÑÐ¸ Ð·Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð²Ð°Ð½Ðµ\" Ð½Ð° ÐµÐºÑ€Ð°Ð½Ð° Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð°Ñ‚Ð° ÑÑŠÐ¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ°.<p>Ð’Ð°ÑˆÐ°Ñ‚Ð° ÐºÑ€ÐµÐ´',0),(441331,12260,'ur','Ø§Ø¶Ø§ÙÛŒ Ø¨ÛŒÙ†Ú© Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ú©Û’ ØªØ­Øª Ø¢Ù¾ Ù…Ø§ÛØ§Ù†Û Ø¨ÛŒØ§Ù† Ú©Ùˆ \"Ø±ÙØªÛ\" Ø³ÛŒÚ©Ø´Ù† Ù…ÛŒÚº Ø¨ÛŒÙ†Ú© Ù…ÙØ§ÛÙ…Øª Ú©ÛŒ Ø§Ø³Ú©Ø±ÛŒÙ† Ù¾Ø± Ø¯Ø§Ø®Ù„ ÛÙˆØ¦Û’ ÛÛŒÚº Û”<p>Ø§Ù¾Ù†Û’ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ ÙÛŒØ³ ÛŒØ§ Ø¯ÛŒÚ¯Ø± Ø§Ø¶Ø§ÙÛŒ Ú',0),(441332,12260,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð±Ð°Ð½ÐºÐµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ Ð½Ð° Ð¼ÐµÑÐµÑ‡Ð½Ð¾Ð¼ Ð¸Ð·Ð²Ð¾Ð´Ñƒ ÑÐµ ÑƒÐ½Ð¾ÑÐµ Ñƒ Ð¾Ð´ÐµÑ™ÐºÑƒ \"ÐÐ°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ\" Ð½Ð° ÐµÐºÑ€Ð°Ð½Ñƒ ÑÑ€Ð°Ð²ÑšÐµÑšÐ° Ð±Ð°Ð½ÐºÐµ.<p>ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼ Ð¾Ð±Ñ€Ð°Ð´Ð° Ð½Ð°ÐºÐ½Ð°Ð´Ñƒ',0),(441333,12260,'vi','PhÃ­ NH bá»• sung trÃªn bÃ¡o cÃ¡o hÃ ng thÃ¡ng cá»§a báº¡n Ä‘Æ°á»£c nháº­p vÃ o phi dá»‹ch vá»¥ trong pháº§n Ä‘á»‘i chiáº¿u ngÃ¢n hÃ ng.PhÃ­ tháº» tÃ­n dá»¥ng vÃ  phÃ­ bá»• sung khÃ¡c Ä‘Æ°á»£c nháº­p báº±ng cÃ¡ch nháº¥p vÃ o biá»ƒu tÆ°á»£ng \"thÃªm má»›i\" ',0),(441334,12260,'af','Addisionele bankkoste op u maandelikse staat ingeskryf in die artikel \"Diensgeld\" op die bank rekonsiliasie skerm.<p>Jou krediet kaart verwerking fooi of ander bykomende koste kan ingesleutel word deur op die \'<i>Voeg nuwe inskrywing</i>\' ikoon te klik.',0),(441335,12260,'ro','Taxe bancare suplimentare pe declaraÅ£ia dumneavoastrÄƒ lunare sunt Ã®nscrise Ã®n secÅ£iunea \"Serviciu taxe\" pe ecranul de reconciliere bancÄƒ.<p>Cardul de credit de prelucrare comision sau alte taxe suplimentare pot fi introduse fÄƒcÃ¢nd clic pe pictogra',0),(441336,12260,'et','Oma kuuaruande veel panga teenustasud kantakse punktis \"Tasud\" Panga vastavusseviimise ekraani.<p>Teie krediitkaardi tÃ¶Ã¶tlemise tasu vÃµi muu tÃ¤iendava tasu saab sisestada klÃµpsates \"<i>Lisada uus kirje</i>\" ikoonil.',0),(441337,12260,'si','Dodatne banÄne stroÅ¡ke na vaÅ¡e meseÄno poroÄilo so vpisani v razdelku \"StroÅ¡ki storitev\" na zaslonu banÄnega usklajevanja.<p>VaÅ¡e kreditne kartice za obdelavo pristojbine ali drugih dodatnih dajatev lahko vnesete s klikom na \'<i>Dodaj nov vnos</i>',0),(441338,12260,'ba','Biaya bank tambahan pada laporan bulanan Anda dimasukkan dalam bagian \"Biaya\" pada layar rekonsiliasi bank.<p>Kartu kredit pengolahan biaya atau biaya tambahan lainnya dapat dimasukkan dengan mengklik ikon \'<i>Menambahkan entri baru</i>\'.',0),(441339,12260,'nl','Extra bankkosten op uw maandelijkse afschriften staat worden ingevoerd in de \"Kosten\"-sectie op de bank verzoening scherm.<p>Uw credit card verwerking vergoeding of andere extra kosten kunnen worden ingevoerd door te klikken op het pictogram \'<i>Nieuw ite',0),(441340,12260,'fi','LisÃ¤tietoja pankkikulut kuukausittaisen tiliotteen syÃ¶tetÃ¤Ã¤n \"Palvelumaksut\"-osan pankki sovinnon nÃ¤ytÃ¶n.<p>Luottokortin kÃ¤sittely maksu sekÃ¤ muut lisÃ¤maksut voidaan syÃ¶ttÃ¤Ã¤ napsauttamalla<i>LisÃ¤Ã¤ uusi merkintÃ¤</i>-kuvaketta.',0),(441341,12260,'no','Ekstra kostnader mÃ¥nedlige kontoutskriften er angitt i delen \"Avgifter\" pÃ¥ skjermbildet bank avstemming.<p>Kredittkortet behandling gebyr eller andre tilleggskostnader kan angis ved Ã¥ klikke ikonet \"<i>Legg til ny oppfÃ¸ring</i>\".',0),(441342,12260,'da','Yderligere bankgebyrer om din mÃ¥nedsopgÃ¸relse er angivet i afsnittet \"Gebyrer\" pÃ¥ skÃ¦rmbilledet bank forsoning.<p>Dit kreditkort forarbejdning gebyr eller andre ekstra afgifter kan angives ved at klikke pÃ¥ ikonet \'<i>TilfÃ¸j ny post</i>\'.',0),(441343,12260,'ko','ì›”ë³„ ëª…ì„¸ì„œì— ì¶”ê°€ë¡œ ì€í–‰ ìˆ˜ìˆ˜ë£ŒëŠ” ì€í–‰ ì¡°ì • í™”ë©´ì— \"ì„œë¹„ìŠ¤ ìš”ê¸ˆ\" ì„¹ì…˜ì— ìž…ë ¥ ë©ë‹ˆë‹¤.<p>ê·€í•˜ì˜ ì‹ ìš© ì¹´ë“œ ì²˜ë¦¬ ìš”ê¸ˆ ë˜ëŠ” ë‹¤ë¥¸ ì¶”ê°€ ìš”ê¸ˆì´ \'<i>ìƒˆ í•­ëª© ì¶”ê°€</i>\' ì•„ì´ì½˜ì„ í´ë¦­ í•˜ ì—¬ ìž…ë ¥í•',0),(441344,12260,'he','×‘× ×§ × ×•×¡×¤×™× ×”×—×™×•×‘ ×¢×œ ×”×”×¦×”×¨×” ×”×—×•×“×©×™ ×©×œ×š ×ž×•×–× ×•×ª ×‘×¡×¢×™×£ \"×©×™×¨×•×ª ×—×™×•×‘×™×\" ×¢×œ ×”×ž×¡×š ×¤×™×•×¡ ×”×‘× ×§.<p>×›×¨×˜×™×¡ ×”××©×¨××™ ×©×œ×›× ×¢×™×‘×•×“ ×‘×ª×©×œ×•× ××• ×—×™×•×‘×™× × ×•×¡×¤×™× ××—×¨×™× × ',0),(441345,12260,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¬ Î­Î¾Î¿Î´Î± ÏƒÏ„Î¿Î½ Î¼Î·Î½Î¹Î±Î¯Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÎ±Ï‚ ÎµÎ³Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î·Î½ ÎµÎ½ÏŒÏ„Î·Ï„Î± Â«Î§ÏÎµÏŽÏƒÎµÎ¹Ï‚ Ï„Î·Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Â» ÏƒÏ„Î·Î½ Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÏƒÏ…Î¼Ï†Î¹Î»Î¯Ï‰ÏƒÎ· Î¿Î¸ÏŒÎ½Î·.<p>Î£Î±Ï',0),(441346,12260,'zh','åœ¨æ‚¨æ¯æœˆå£°æ˜Žä¸Šçš„é™„åŠ çš„é“¶è¡Œæ”¶è´¹è¾“å…¥åœ¨é“¶è¡Œå¯¹è´¦é¡µé¢çš„â€œæœåŠ¡æ”¶è´¹â€é¡¹ä¸­ã€‚ç‚¹å‡»â€œæ–°å»ºæ¡ç›®â€å›¾æ ‡ï¼Œæ‚¨å¯ä»¥è¾“å…¥æ‚¨çš„ä¿¡ç”¨å¡å¤„ç†è´¹æˆ–å…¶ä»–é™„åŠ è´¹ç”¨ã€‚',0),(441347,12260,'sv','Ytterligare bankavgifter pÃ¥ ditt mÃ¥natliga kontoutdrag anges i avsnittet \"Serviceavgifter\" pÃ¥ skÃ¤rmen bank fÃ¶rsoning.<p>Din kreditkort bearbetning avgift eller andra extra kostnader kan matas in genom att klicka pÃ¥ ikonen \"<i>LÃ¤gg till ny post</i>\"',0),(441348,12260,'it','Spese bancarie aggiuntive sul tuo estratto conto mensile sono entrati nella sezione \"Spese di servizio\" nella schermata di riconciliazione di banca.<p>Carta di credito, elaborazione tassa o altri costi aggiuntivi possono essere inserito cliccando sull\'ico',0),(441349,12260,'tl','',0),(441350,12260,'th','à¸›à¹‰à¸­à¸™à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸˜à¸™à¸²à¸„à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¹ƒà¸™à¸‡à¸šà¸›à¸£à¸°à¸ˆà¸³à¹€à¸”à¸·à¸­à¸™à¸‚à¸­à¸‡à¸„à¸¸à¸“à¹ƒà¸™à¸ªà¹ˆà¸§à¸™ \"à¸„à¹ˆà¸²à¸šà¸£à¸´à¸à¸²à¸£\" à¸šà¸™à¸«à¸™à¹‰à¸²à¸ˆà¸­à¸à¸²à¸£à¸à¸£à¸°à¸—à¸šà¸¢à¸',0),(441351,12260,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¬à¥ˆà¤‚à¤• à¤¶à¥à¤²à¥à¤• à¤†à¤ªà¤•à¥‡ à¤®à¤¾à¤¸à¤¿à¤• à¤¬à¤¯à¤¾à¤¨ à¤ªà¤° à¤¬à¥ˆà¤‚à¤• à¤¸à¥à¤²à¤¹ à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤ªà¤° \'à¤¸à¥‡à¤µà¤¾ à¤¶à¥à¤²à¥à¤•\' à¤–à¤‚à¤¡ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚à',0),(441352,12260,'ms','Caj tambahan bank pada penyata bulanan anda akan dimasukkan dalam bahagian \"Caj Perkhidmatan\" pada skrin Penyata penyesuaian bank.<p>Kad kredit yang memproses bayaran atau caj-caj tambahan yang lain boleh dimasukkan dengan klik ikon \'<i>Tambah entri baru<',0),(441353,12260,'ar','ÙŠØªÙ… Ø¥Ø¯Ø®Ø§Ù„ Ø±Ø³ÙˆÙ… Ù…ØµØ±ÙÙŠØ© Ø¥Ø¶Ø§ÙÙŠØ© ÙÙŠ Ø§Ù„Ø¨ÙŠØ§Ù† Ø§Ù„Ø´Ù‡Ø±ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ ÙÙŠ Ø§Ù„Ù…Ù‚Ø·Ø¹ \"Ø±Ø³ÙˆÙ… Ø§Ù„Ø®Ø¯Ù…Ø©\" Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø§Ø´Ø© Ø§Ù„Ù…ØµØ§Ù„Ø­Ø© Ø§Ù„Ø¨Ù†Ùƒ.<p>ÙŠÙ…ÙƒÙ† Ø¥Ø¯Ø®Ø§Ù„ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ØªØ¬Ù‡ÙŠØ² Ø§Ù',0),(441354,12260,'fr','Commissions bancaires supplÃ©mentaires sur votre relevÃ© de compte mensuel sont entrÃ©es dans la section Â« Frais de Service Â» sur l\'Ã©cran de rapprochement bancaire.<p>Votre carte de crÃ©dit traitement des honoraires ou autres frais supplÃ©mentaires peu',0),(441355,12260,'jp','æ¯Žæœˆã®æ˜Žç´°æ›¸ä¸Šã®è¿½åŠ ã®éŠ€è¡Œæ‰‹æ•°æ–™ã¯éŠ€è¡Œå’Œè§£ç”»é¢ã«ã€Œã‚µãƒ¼ãƒ“ã‚¹æ–™é‡‘ã€ã®ã‚»ã‚¯ã‚·ãƒ§ãƒ³ã§å…¥åŠ›ã—ã¾ã™ã€‚<p>\'<i>æ–°ã—ã„ã‚¨ãƒ³ãƒˆãƒªã®è¿½åŠ </i>\' ã‚¢ã‚¤ã‚³ãƒ³ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦ã€ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰å‡¦ç†æ‰‹æ•°æ–™ã',0),(441356,12260,'pt','As cargas de banco adicional no seu extracto mensal sÃ£o inseridas na seÃ§Ã£o de \"Taxas de serviÃ§o\" na tela de reconciliaÃ§Ã£o bancÃ¡ria.<p>Seu cartÃ£o de crÃ©dito processamento honorÃ¡rios ou outros encargos adicionais podem ser inserido clicando no Ã­c',0),(441357,12260,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ ÑÐ±Ð¾Ñ€Ñ‹ Ð½Ð° Ð²Ñ‹Ð¿Ð¸ÑÐºÐµ ÐµÐ¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ð¾ Ð²Ð²Ð¾Ð´ÑÑ‚ÑÑ Ð² Ñ€Ð°Ð·Ð´ÐµÐ»Ðµ Â«ÐžÐ±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸ÐµÂ» Ð½Ð° ÑÐºÑ€Ð°Ð½Ðµ Ð¿Ñ€Ð¸Ð¼Ð¸Ñ€ÐµÐ½Ð¸Ñ Ð±Ð°Ð½Ðº.<p>ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð¾Ð±Ñ€Ð°',0),(441358,12260,'es','Cargos Bancarios Adicionales en su estado de cuenta mensual se entran en la secciÃ³n \"Cargos de Servicios\" en la pantalla de renonciliaciÃ³n de cuentas bancarias. <p> Su tarifa de proceso de la Tarjeta de CrÃ©dito o otros cargos adicionales se puede entra',0),(441359,12260,'de','ZusÃ¤tzliche BankgebÃ¼hren auf Ihrer monatlichen Kreditkartenabrechnung werden im Abschnitt \"GebÃ¼hren\" auf dem Bank-VersÃ¶hnung-Bildschirm eingegeben.<p>Ihre Kreditkarte Verarbeitung GebÃ¼hr oder sonstige zusÃ¤tzlichen GebÃ¼hren kÃ¶nnen eingegeben werden',0),(441360,12260,'en','Additional bank charges on your monthly statement are entered in the \"Service Charges\" section on the bank reconciliation screen. <p> Your credit card processing fee or other additional charges can be entered by clicking the \'<i>Add New Entry</i>\' icon.',0),(441361,12261,'is','',0),(441362,12261,'dr','',0),(441363,12261,'pr','',0),(441364,12261,'tr','',0),(441365,12261,'pl','',0),(441366,12261,'bg','',0),(441367,12261,'ur','',0),(441368,12261,'sr','',0),(441369,12261,'vi','',0),(441370,12261,'af','',0),(441371,12261,'ro','',0),(441372,12261,'et','',0),(441373,12261,'si','',0),(441374,12261,'ba','',0),(441375,12261,'nl','',0),(441376,12261,'fi','',0),(441377,12261,'no','',0),(441378,12261,'da','',0),(441379,12261,'ko','',0),(441380,12261,'he','',0),(441381,12261,'el','',0),(441382,12261,'zh','',0),(441383,12261,'sv','',0),(441384,12261,'it','',0),(441385,12261,'tl','',0),(441386,12261,'th','',0),(441387,12261,'hi','',0),(441388,12261,'ms','',0),(441389,12261,'ar','',0),(441390,12261,'fr','',0),(441391,12261,'jp','',0),(441392,12261,'pt','',0),(441393,12261,'ru','',0),(441394,12261,'es','',0),(441395,12261,'de','',0),(441396,12261,'en','',0),(441397,12262,'is','',0),(441398,12262,'dr','',0),(441399,12262,'pr','',0),(441400,12262,'tr','',0),(441401,12262,'pl','',0),(441402,12262,'bg','',0),(441403,12262,'ur','',0),(441404,12262,'sr','',0),(441405,12262,'vi','',0),(441406,12262,'af','',0),(441407,12262,'ro','',0),(441408,12262,'et','',0),(441409,12262,'si','',0),(441410,12262,'ba','',0),(441411,12262,'nl','',0),(441412,12262,'fi','',0),(441413,12262,'no','',0),(441414,12262,'da','',0),(441415,12262,'ko','',0),(441416,12262,'he','',0),(441417,12262,'el','',0),(441418,12262,'zh','',0),(441419,12262,'sv','',0),(441420,12262,'it','',0),(441421,12262,'tl','',0),(441422,12262,'th','',0),(441423,12262,'hi','',0),(441424,12262,'ms','',0),(441425,12262,'ar','',0),(441426,12262,'fr','',0),(441427,12262,'jp','',0),(441428,12262,'pt','',0),(441429,12262,'ru','',0),(441430,12262,'es','',0),(441431,12262,'de','',0),(441432,12262,'en','',0),(441433,12263,'is','',0),(441434,12263,'dr','',0),(441435,12263,'pr','',0),(441436,12263,'tr','',0),(441437,12263,'pl','',0),(441438,12263,'bg','',0),(441439,12263,'ur','',0),(441440,12263,'sr','',0),(441441,12263,'vi','',0),(441442,12263,'af','',0),(441443,12263,'ro','',0),(441444,12263,'et','',0),(441445,12263,'si','',0),(441446,12263,'ba','',0),(441447,12263,'nl','',0),(441448,12263,'fi','',0),(441449,12263,'no','',0),(441450,12263,'da','',0),(441451,12263,'ko','',0),(441452,12263,'he','',0),(441453,12263,'el','',0),(441454,12263,'zh','',0),(441455,12263,'sv','',0),(441456,12263,'it','',0),(441457,12263,'tl','',0),(441458,12263,'th','',0),(441459,12263,'hi','',0),(441460,12263,'ms','',0),(441461,12263,'ar','',0),(441462,12263,'fr','',0),(441463,12263,'jp','',0),(441464,12263,'pt','',0),(441465,12263,'ru','',0),(441466,12263,'es','',0),(441467,12263,'de','',0),(441468,12263,'en','',0),(441469,12264,'is','',0),(441470,12264,'dr','',0),(441471,12264,'pr','',0),(441472,12264,'tr','',0),(441473,12264,'pl','',0),(441474,12264,'bg','',0),(441475,12264,'ur','',0),(441476,12264,'sr','',0),(441477,12264,'vi','',0),(441478,12264,'af','',0),(441479,12264,'ro','',0),(441480,12264,'et','',0),(441481,12264,'si','',0),(441482,12264,'ba','',0),(441483,12264,'nl','',0),(441484,12264,'fi','',0),(441485,12264,'no','',0),(441486,12264,'da','',0),(441487,12264,'ko','',0),(441488,12264,'he','',0),(441489,12264,'el','',0),(441490,12264,'zh','',0),(441491,12264,'sv','',0),(441492,12264,'it','',0),(441493,12264,'tl','',0),(441494,12264,'th','',0),(441495,12264,'hi','',0),(441496,12264,'ms','',0),(441497,12264,'ar','',0),(441498,12264,'fr','',0),(441499,12264,'jp','',0),(441500,12264,'pt','',0),(441501,12264,'ru','',0),(441502,12264,'es','',0),(441503,12264,'de','',0),(441504,12264,'en','',0),(441505,12265,'is','',0),(441506,12265,'dr','',0),(441507,12265,'pr','',0),(441508,12265,'tr','',0),(441509,12265,'pl','',0),(441510,12265,'bg','',0),(441511,12265,'ur','',0),(441512,12265,'sr','',0),(441513,12265,'vi','',0),(441514,12265,'af','',0),(441515,12265,'ro','',0),(441516,12265,'et','',0),(441517,12265,'si','',0),(441518,12265,'ba','',0),(441519,12265,'nl','',0),(441520,12265,'fi','',0),(441521,12265,'no','',0),(441522,12265,'da','',0),(441523,12265,'ko','',0),(441524,12265,'he','',0),(441525,12265,'el','',0),(441526,12265,'zh','',0),(441527,12265,'sv','',0),(441528,12265,'it','',0),(441529,12265,'tl','',0),(441530,12265,'th','',0),(441531,12265,'hi','',0),(441532,12265,'ms','',0),(441533,12265,'ar','',0),(441534,12265,'fr','',0),(441535,12265,'jp','',0),(441536,12265,'pt','',0),(441537,12265,'ru','',0),(441538,12265,'es','',0),(441539,12265,'de','',0),(441540,12265,'en','',0),(441541,12266,'is','',0),(441542,12266,'dr','',0),(441543,12266,'pr','',0),(441544,12266,'tr','',0),(441545,12266,'pl','',0),(441546,12266,'bg','',0),(441547,12266,'ur','',0),(441548,12266,'sr','',0),(441549,12266,'vi','',0),(441550,12266,'af','',0),(441551,12266,'ro','',0),(441552,12266,'et','',0),(441553,12266,'si','',0),(441554,12266,'ba','',0),(441555,12266,'nl','',0),(441556,12266,'fi','',0),(441557,12266,'no','',0),(441558,12266,'da','',0),(441559,12266,'ko','',0),(441560,12266,'he','',0),(441561,12266,'el','',0),(441562,12266,'zh','',0),(441563,12266,'sv','',0),(441564,12266,'it','',0),(441565,12266,'tl','',0),(441566,12266,'th','',0),(441567,12266,'hi','',0),(441568,12266,'ms','',0),(441569,12266,'ar','',0),(441570,12266,'fr','',0),(441571,12266,'jp','',0),(441572,12266,'pt','',0),(441573,12266,'ru','',0),(441574,12266,'es','',0),(441575,12266,'de','',0),(441576,12266,'en','',0),(441577,12267,'is','',0),(441578,12267,'dr','.Ø­Ø³Ø§Ø¨ Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Ú©Ù† Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ÙˆØ­Ø³Ø§Ø¨ÛŒ Ú©Ù‡ Ø¨Ø§ Ø¢Ù† Ø´Ù…Ø§Ø±Ù‡ ØªØ·Ø¨ÛŒÙ‚ Ø¯Ø§Ø±Ø¯ Ø¨Ø±Ø§ÛŒ ',0),(441579,12267,'pr','Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ø²Ú¯Ø±Ø¯Ø§Ù†ÛŒ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„ Ø­Ø³Ø§Ø¨ Ø±Ø§ Ø¨Ø§ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø´Ø§Ø¨Ù‡ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯.Ø­Ø³Ø§Ø¨ Ø­Ø°Ù Ø´Ø¯Ù‡ Ø§Ø³Ú©Ù† Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ÙˆØ­Ø³Ø§Ø¨ÛŒ Ú©Ù‡ Ø¨Ø§ Ø¢Ù† Ø´Ù…Ø§Ø±Ù‡ ØªØ·Ø¨ÛŒÙ‚ Ø¯Ø§Ø±Ø¯ Ø¨Ø±Ø§ÛŒ ï',0),(441580,12267,'tr','Undelete GL hesap iÃ§in hesap aynÄ± hesap numarasÄ± ile yeniden ekleyin. Silinen hesaplar taranÄ±r ve ÅŸirket iÃ§in bu sayÄ± eÅŸleme hesabÄ±-ecek var olmak restored. ',0),(441581,12267,'pl','Aby przywrÃ³ciÄ‡ konto GL, Dodaj konto ponownie z tym samym numerem konta. Konta usuniÄ™te zostanÄ… zeskanowane i rachunku dopasowywania liczba firmy zostanie przywrÃ³cony. ',0),(441582,12267,'bg','Ð”Ð° ÑÐµ Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸ Ð½Ð° GL Ð°ÐºÐ°ÑƒÐ½Ñ‚, Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾ ÑÑŠÑ ÑÑŠÑ‰Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°. Ð˜Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸ Ñ‰Ðµ Ð±ÑŠÐ´Ð°Ñ‚ ÑÐºÐ°Ð½Ð¸Ñ€Ð°Ð½Ð¸ Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ ',0),(441583,12267,'ur','Ø§ÛŒÚ© Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø­Ø°Ù Ø®ØªÙ… Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ØŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯ÙˆØ¨Ø§Ø±Û Ø§Ø³ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ú©Û’ Ø³Ø§ØªÚ¾ Ø´Ø§Ù…Ù„ ÛÛŒÚº Û” Ù…Ù¹Ø§Ø¦Û’ Ú¯Ø¦Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ÛŒÚº Ú©ÛŒ Ø¬Ø§ Ø³Ú©ÛŒÙ† Ú©Ø±ÛŒÚº Ú¯Û’ Ø§ÙˆØ± Ø§Ø³ ØªØ¹Ø¯Ø§Ø¯ Ù…ÛŒÚº Ú©Ù',0),(441584,12267,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¾Ð¿Ð¾Ð·Ð²Ð°Ð»Ð¸ ÐºÐ¾Ð½Ñ‚Ð¾ Ð“Ðš, Ñ€Ð°Ñ‡ÑƒÐ½ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð´Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð¸ÑÑ‚Ð¸ Ð±Ñ€Ð¾Ñ˜ ÐºÐ¾Ð½Ñ‚Ð°. Ð˜Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸ Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ ÑÐºÐµÐ½Ð¸Ñ€Ð°Ð½Ðµ Ð¸ ÐºÐ¾Ð½Ñ‚Ð¾ ÐºÐ¾Ñ˜Ð¸ Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð° Ñ‚Ð°Ñ˜ Ð±Ñ€Ð¾Ñ˜ Ð·Ð° Ð¿Ñ€ÐµÐ´Ñƒ',0),(441585,12267,'vi','Äá»ƒ láº¥y láº¡i má»™t TK GL, thÃªm TK láº§n ná»¯a vá»›i cÃ¹ng sá»‘ TK. CÃ¡c TK Ä‘Ã£ bá»‹ xÃ³a sáº½ Ä‘Æ°á»£c quÃ©t vÃ  TK phÃ¹ há»£p sáº½ Ä‘Æ°á»£c phá»¥c há»“i',0),(441586,12267,'af','Ontskrap moet word, \'n GL-rekening, voeg die rekening weer met dieselfde rekening nommer. Die geskrapte rekeninge sal geskandeer word en die rekening van passende daardie nommer vir die maatskappy sal nie teruggelaai word nie. ',0),(441587,12267,'ro','Pentru a anula ÅŸtergerea unui cont GL, adÄƒugaÅ£i contul din nou cu acelaÅŸi numÄƒr de cont. Conturile ÅŸterse vor fi scanate ÅŸi seama cÄƒ numÄƒrul de potrivire pentru compania va fi restaurat. ',0),(441588,12267,'et','SÃµnumite kustutamise GL konto, lisada konto uuesti sama numbriga. Kustutatud kontod skaneeritakse ja sobitamine mÃ¤Ã¤ratud ettevÃµtte konto taastatakse. ',0),(441589,12267,'si','V neodloÅ¾en GL raÄun, raÄun znova dodajte z isto Å¡tevilko konta. Izbrisani raÄuni bodo skenirane in obnovljeni raÄun ujemanje to Å¡tevilko za podjetje. ',0),(441590,12267,'ba','Untuk membatalkan penghapusan rekening GL, menambahkan account lagi dengan nomor akun yang sama. Akun dihapus akan di scan dan account nomor itu cocok untuk perusahaan akan dipulihkan. ',0),(441591,12267,'nl','Voeg de account als u wilt undelete een GL-account, nogmaals met hetzelfde rekeningnummer. De verwijderde accounts wordt gescand en de account overeenkomen met dat aantal voor het bedrijf zal worden hersteld. ',0),(441592,12267,'fi','Undelete kÃ¤ytetÃ¤Ã¤nkÃ¶ KP-tiliÃ¤, lisÃ¤Ã¤ tili uudelleen sama numero. Poistetut tilit tarkistetaan ja vastaavat mÃ¤Ã¤rÃ¤Ã¤ yrityksen tili palautetaan. ',0),(441593,12267,'no','Hvis du vil angre en gi-konto, legge til kontoen igjen med samme kontonummer. Slettede kontoer vil bli skannet og kontoen som svarer det nummeret for selskapet vil bli gjenopprettet. ',0),(441594,12267,'da','For at genopretter en GL-konto, skal du fÃ¸je kontoen igen med det samme kontonummer. De slettede konti vil blive scannet og kontoen matcher tal for virksomheden vil vÃ¦re genskabt. ',0),(441595,12267,'ko','GL ê³„ì • ì‚­ì œë¥¼ ì·¨ì†Œ í•˜ë ¤ë©´ ë™ì¼í•œ ê³„ì • ë²ˆí˜¸ì™€ ê³„ì •ì„ ë‹¤ì‹œ ì¶”ê°€ í•©ë‹ˆë‹¤. ì‚­ì œ ëœ ê³„ì • ìŠ¤ìº” ë˜ ê³  íšŒì‚¬ì— ëŒ€ í•œ ë²ˆí˜¸ë¥¼ ì¼ì¹˜ í•˜ëŠ” ê³„ì • ë³µì› ë©ë‹ˆë‹¤. ',0),(441596,12267,'he','×›×“×™ ×œ×‘×˜×œ ××ª ×”×ž×—×™×§×” ×©×œ ×—×©×‘×•×Ÿ GL, ×œ×”×•×¡×™×£ ××ª ×”×—×©×‘×•×Ÿ ×©×•×‘ ×¢× ××•×ª×• ×ž×¡×¤×¨ ×—×©×‘×•×Ÿ. ×—×©×‘×•× ×•×ª × ×ž×—×§×• ×™×™×¡×¨×§×•, ×”×—×©×‘×•×Ÿ ×ª×•××ž×™× ××ª ×”×ž×¡×¤×¨ ×¢×‘×•×¨ ×”×—×‘×¨×” ×™×©×•×—×–×¨×•. ',0),(441597,12267,'el','Î“Î¹Î± Î½Î± Î¾ÎµÎ´Î¹Î±Î³ÏÎ¬ÏˆÎµÎ¹ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î», Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎºÎ±Î¹ Ï€Î¬Î»Î¹ Î¼Îµ Ï„Î¿Î½ Î¯Î´Î¹Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï. Î”Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Ï‰Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Î¸Î± ÏƒÎ±ÏÏ‰Î¸Î',0),(441598,12267,'zh','è¦å–æ¶ˆåˆ é™¤ä¸€ä¸ªæ€»å¸æ¡ç›®ï¼Œå†ä¸€æ¬¡å¢žåŠ ä¸€ä¸ªæœ‰ç›¸åŒå¸æˆ·å·ç çš„å¸æˆ·ã€‚è¢«åˆ é™¤çš„å¸æˆ·ä¼šè¢«æ‰«æï¼Œå…·æœ‰å…¬å¸è¯¥ç¼–å·çš„å¸æˆ·å°†è¢«å¤åŽŸã€‚',0),(441599,12267,'sv','Om du vill Ã¥terstÃ¤lla ett GL konto, lÃ¤gga till kontot igen med samma kontonummer. De borttagna kontona kommer att skannas och kontot pÃ¥ detta nummer fÃ¶r fÃ¶retaget kommer att Ã¥terstÃ¤llas. ',0),(441600,12267,'it','Per annullare l\'eliminazione di un account GL, aggiungere nuovamente l\'account con lo stesso numero di conto. Verranno analizzati gli account eliminati e verrÃ  ripristinato il conto che il numero di corrispondenza per l\'azienda. ',0),(441601,12267,'tl','',0),(441602,12267,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¸à¸²à¸£à¸¥à¸šà¸šà¸±à¸à¸Šà¸µ GL à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸±à¸à¸Šà¸µà¸­à¸µà¸à¸„à¸£à¸±à¹‰à¸‡à¸à¸±à¸šà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µà¹€à¸”à¸µà¸¢à¸§à¸à¸±à¸™ à¸šà¸±à¸à¸Šà¸µà¸–à¸¹à¸à¸¥à¸šà¸ˆà¸°à¸–à¸¹à¸à¸ªà¹à¸à¸™ à¹à¸¥à¸°à¸šà¸±à¸à¸Š',0),(441603,12267,'hi','à¤à¤• GL à¤–à¤¾à¤¤à¤¾ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤°à¤¦à¥à¤¦ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤–à¤¾à¤¤à¤¾ à¤à¤• à¤¹à¥€ à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤«à¤¿à¤° à¤¸à¥‡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚à¥¤ à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤–à¤¾à¤¤à¥‡ à¤¸à¥à¤•à¥ˆà¤¨ à¤•à¤¿à¤',0),(441604,12267,'ms','Untuk membatalkan penghapusan akaun GL, menambah akaun lagi dengan nombor akaun yang sama. Akaun-akaun yang dipadamkan akan diimbas dan akaun yang padan dengan nombor itu Syarikat akan diambil semula. ',0),(441605,12267,'ar','Ù„Ù„Ø­Ø°Ù Ø¹Ù„Ù‰ Ø­Ø³Ø§Ø¨ GLØŒ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø­Ø³Ø§Ø¨ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ Ù…Ø¹ Ù†ÙØ³ Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨. Ø³ÙŠØªÙ… ÙØ­Øµ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© ÙˆØ³ÙŠØªÙ… Ø§Ø³ØªØ¹Ø§Ø¯Ø© Ø§Ù„Ø­Ø³Ø§Ø¨ Ù…Ø·Ø§Ø¨Ù‚Ø© Ù‡Ø°Ø§ Ø§Ù„Ø¹Ø¯Ø¯ Ù„Ù„Ø´Ø±ÙƒØ©. ',0),(441606,12267,'fr','Pour restaurer un compte GL, ajoutez le compte encore une fois avec le mÃªme numÃ©ro de compte. Les comptes supprimÃ©s seront analysÃ©s et le compte correspondant Ã  ce numÃ©ro pour la compagnie est restaurÃ©. ',0),(441607,12267,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å…ƒã«æˆ»ã™ã™ã‚‹ã«ã¯ã€ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å†åº¦è¿½åŠ åŒã˜å‹˜å®šç•ªå·ã‚’æŒã¤ã€‚å‰Šé™¤ã•ã‚ŒãŸã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒã‚¹ã‚­ãƒ£ãƒ³ã•ã‚Œã€ä¼šç¤¾ã®æ•°ã¨ä¸€è‡´ã™ã‚‹ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒå¾©å…ƒã•ã‚Œã¾ã™ã€‚',0),(441608,12267,'pt','Para restaurar uma conta GL, adicione a conta novamente com o mesmo nÃºmero de conta. As contas excluÃ­das serÃ£o digitalizadas e a conta que o nÃºmero de correspondÃªncia para a empresa serÃ¡ restaurada. ',0),(441609,12267,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð²Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL, ÑÐ½Ð¾Ð²Ð° Ð´Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ñ Ñ‚ÐµÐ¼ Ð¶Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð¾Ð¼ ÑÑ‡ÐµÑ‚Ð°. Ð£Ð´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ñ‹ Ð±ÑƒÐ´ÑƒÑ‚ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÑ‚ÑŒÑÑ Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð',0),(441610,12267,'es','Para restaurar una cuenta LM, agrega la cuenta otra vez con el mismo nÃºmero de cuenta. Las cuentas eliminadas se escanearÃ¡n y la cuenta pareado con este nÃºmero para la empresa se restaurarÃ¡',0),(441611,12267,'de','Um ein GL-Konto wiederherzustellen, fÃ¼gen Sie das Konto wieder mit der gleichen Kontonummer. Die gelÃ¶schten Konten werden gescannt und das Konto diese Zahl fÃ¼r das Unternehmen passende wiederhergestellt wird. ',0),(441612,12267,'en','To undelete a GL account, add the account again with the same account number. The deleted accounts will be scanned and the account matching that number for the company will be restored. ',0),(441613,12268,'is','',0),(441614,12268,'dr','',0),(441615,12268,'pr','',0),(441616,12268,'tr','',0),(441617,12268,'pl','',0),(441618,12268,'bg','',0),(441619,12268,'ur','',0),(441620,12268,'sr','',0),(441621,12268,'vi','',0),(441622,12268,'af','',0),(441623,12268,'ro','',0),(441624,12268,'et','',0),(441625,12268,'si','',0),(441626,12268,'ba','',0),(441627,12268,'nl','',0),(441628,12268,'fi','',0),(441629,12268,'no','',0),(441630,12268,'da','',0),(441631,12268,'ko','',0),(441632,12268,'he','',0),(441633,12268,'el','',0),(441634,12268,'zh','',0),(441635,12268,'sv','',0),(441636,12268,'it','',0),(441637,12268,'tl','',0),(441638,12268,'th','',0),(441639,12268,'hi','',0),(441640,12268,'ms','',0),(441641,12268,'ar','',0),(441642,12268,'fr','',0),(441643,12268,'jp','',0),(441644,12268,'pt','',0),(441645,12268,'ru','',0),(441646,12268,'es','',0),(441647,12268,'de','',0),(441648,12268,'en','',0),(441649,12269,'is','',0),(441650,12269,'dr','',0),(441651,12269,'pr','',0),(441652,12269,'tr','',0),(441653,12269,'pl','',0),(441654,12269,'bg','',0),(441655,12269,'ur','',0),(441656,12269,'sr','',0),(441657,12269,'vi','',0),(441658,12269,'af','',0),(441659,12269,'ro','',0),(441660,12269,'et','',0),(441661,12269,'si','',0),(441662,12269,'ba','',0),(441663,12269,'nl','',0),(441664,12269,'fi','',0),(441665,12269,'no','',0),(441666,12269,'da','',0),(441667,12269,'ko','',0),(441668,12269,'he','',0),(441669,12269,'el','',0),(441670,12269,'zh','',0),(441671,12269,'sv','',0),(441672,12269,'it','',0),(441673,12269,'tl','',0),(441674,12269,'th','',0),(441675,12269,'hi','',0),(441676,12269,'ms','',0),(441677,12269,'ar','',0),(441678,12269,'fr','',0),(441679,12269,'jp','',0),(441680,12269,'pt','',0),(441681,12269,'ru','',0),(441682,12269,'es','',0),(441683,12269,'de','',0),(441684,12269,'en','',0),(441685,12270,'is','',0),(441686,12270,'dr','',0),(441687,12270,'pr','',0),(441688,12270,'tr','',0),(441689,12270,'pl','',0),(441690,12270,'bg','',0),(441691,12270,'ur','',0),(441692,12270,'sr','',0),(441693,12270,'vi','',0),(441694,12270,'af','',0),(441695,12270,'ro','',0),(441696,12270,'et','',0),(441697,12270,'si','',0),(441698,12270,'ba','',0),(441699,12270,'nl','',0),(441700,12270,'fi','',0),(441701,12270,'no','',0),(441702,12270,'da','',0),(441703,12270,'ko','',0),(441704,12270,'he','',0),(441705,12270,'el','',0),(441706,12270,'zh','',0),(441707,12270,'sv','',0),(441708,12270,'it','',0),(441709,12270,'tl','',0),(441710,12270,'th','',0),(441711,12270,'hi','',0),(441712,12270,'ms','',0),(441713,12270,'ar','',0),(441714,12270,'fr','',0),(441715,12270,'jp','',0),(441716,12270,'pt','',0),(441717,12270,'ru','',0),(441718,12270,'es','',0),(441719,12270,'de','',0),(441720,12270,'en','',0),(441721,12271,'is','',0),(441722,12271,'dr','',0),(441723,12271,'pr','',0),(441724,12271,'tr','',0),(441725,12271,'pl','',0),(441726,12271,'bg','',0),(441727,12271,'ur','',0),(441728,12271,'sr','',0),(441729,12271,'vi','',0),(441730,12271,'af','',0),(441731,12271,'ro','',0),(441732,12271,'et','',0),(441733,12271,'si','',0),(441734,12271,'ba','',0),(441735,12271,'nl','',0),(441736,12271,'fi','',0),(441737,12271,'no','',0),(441738,12271,'da','',0),(441739,12271,'ko','',0),(441740,12271,'he','',0),(441741,12271,'el','',0),(441742,12271,'zh','',0),(441743,12271,'sv','',0),(441744,12271,'it','',0),(441745,12271,'tl','',0),(441746,12271,'th','',0),(441747,12271,'hi','',0),(441748,12271,'ms','',0),(441749,12271,'ar','',0),(441750,12271,'fr','',0),(441751,12271,'jp','',0),(441752,12271,'pt','',0),(441753,12271,'ru','',0),(441754,12271,'es','',0),(441755,12271,'de','',0),(441756,12271,'en','',0),(441757,12272,'is','',0),(441758,12272,'dr','',0),(441759,12272,'pr','',0),(441760,12272,'tr','',0),(441761,12272,'pl','',0),(441762,12272,'bg','',0),(441763,12272,'ur','',0),(441764,12272,'sr','',0),(441765,12272,'vi','',0),(441766,12272,'af','',0),(441767,12272,'ro','',0),(441768,12272,'et','',0),(441769,12272,'si','',0),(441770,12272,'ba','',0),(441771,12272,'nl','',0),(441772,12272,'fi','',0),(441773,12272,'no','',0),(441774,12272,'da','',0),(441775,12272,'ko','',0),(441776,12272,'he','',0),(441777,12272,'el','',0),(441778,12272,'zh','',0),(441779,12272,'sv','',0),(441780,12272,'it','',0),(441781,12272,'tl','',0),(441782,12272,'th','',0),(441783,12272,'hi','',0),(441784,12272,'ms','',0),(441785,12272,'ar','',0),(441786,12272,'fr','',0),(441787,12272,'jp','',0),(441788,12272,'pt','',0),(441789,12272,'ru','',0),(441790,12272,'es','',0),(441791,12272,'de','',0),(441792,12272,'en','',0),(441793,12273,'is','',0),(441794,12273,'dr','',0),(441795,12273,'pr','',0),(441796,12273,'tr','',0),(441797,12273,'pl','',0),(441798,12273,'bg','',0),(441799,12273,'ur','',0),(441800,12273,'sr','',0),(441801,12273,'vi','',0),(441802,12273,'af','',0),(441803,12273,'ro','',0),(441804,12273,'et','',0),(441805,12273,'si','',0),(441806,12273,'ba','',0),(441807,12273,'nl','',0),(441808,12273,'fi','',0),(441809,12273,'no','',0),(441810,12273,'da','',0),(441811,12273,'ko','',0),(441812,12273,'he','',0),(441813,12273,'el','',0),(441814,12273,'zh','',0),(441815,12273,'sv','',0),(441816,12273,'it','',0),(441817,12273,'tl','',0),(441818,12273,'th','',0),(441819,12273,'hi','',0),(441820,12273,'ms','',0),(441821,12273,'ar','',0),(441822,12273,'fr','',0),(441823,12273,'jp','',0),(441824,12273,'pt','',0),(441825,12273,'ru','',0),(441826,12273,'es','',0),(441827,12273,'de','',0),(441828,12273,'en','',0),(441829,12274,'is','',0),(441830,12274,'dr','',0),(441831,12274,'pr','',0),(441832,12274,'tr','',0),(441833,12274,'pl','',0),(441834,12274,'bg','',0),(441835,12274,'ur','',0),(441836,12274,'sr','',0),(441837,12274,'vi','',0),(441838,12274,'af','',0),(441839,12274,'ro','',0),(441840,12274,'et','',0),(441841,12274,'si','',0),(441842,12274,'ba','',0),(441843,12274,'nl','',0),(441844,12274,'fi','',0),(441845,12274,'no','',0),(441846,12274,'da','',0),(441847,12274,'ko','',0),(441848,12274,'he','',0),(441849,12274,'el','',0),(441850,12274,'zh','',0),(441851,12274,'sv','',0),(441852,12274,'it','',0),(441853,12274,'tl','',0),(441854,12274,'th','',0),(441855,12274,'hi','',0),(441856,12274,'ms','',0),(441857,12274,'ar','',0),(441858,12274,'fr','',0),(441859,12274,'jp','',0),(441860,12274,'pt','',0),(441861,12274,'ru','',0),(441862,12274,'es','',0),(441863,12274,'de','',0),(441864,12274,'en','',0),(441865,12275,'is','',0),(441866,12275,'dr','',0),(441867,12275,'pr','',0),(441868,12275,'tr','',0),(441869,12275,'pl','',0),(441870,12275,'bg','',0),(441871,12275,'ur','',0),(441872,12275,'sr','',0),(441873,12275,'vi','',0),(441874,12275,'af','',0),(441875,12275,'ro','',0),(441876,12275,'et','',0),(441877,12275,'si','',0),(441878,12275,'ba','',0),(441879,12275,'nl','',0),(441880,12275,'fi','',0),(441881,12275,'no','',0),(441882,12275,'da','',0),(441883,12275,'ko','',0),(441884,12275,'he','',0),(441885,12275,'el','',0),(441886,12275,'zh','',0),(441887,12275,'sv','',0),(441888,12275,'it','',0),(441889,12275,'tl','',0),(441890,12275,'th','',0),(441891,12275,'hi','',0),(441892,12275,'ms','',0),(441893,12275,'ar','',0),(441894,12275,'fr','',0),(441895,12275,'jp','',0),(441896,12275,'pt','',0),(441897,12275,'ru','',0),(441898,12275,'es','',0),(441899,12275,'de','',0),(441900,12275,'en','',0),(441901,12276,'is','',0),(441902,12276,'dr','.Ø¨Ø±Ø§ÛŒ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÛŒØ§ Ø§ØµÙ„Ø§Ø­ ÛŒÚ© ÛŒÙˆØ²Ø± Ù…Ø³ÛŒØ± Ø²ÛŒØ± Ø±Ø§ Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÛŒØ¯.Ù…Ø¯ÛŒØ±ÛŒØª-Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù…Ø¯ÛŒØ±ÛŒØª- ÛŒÙˆØ²Ø± Ø¬Ø¯ÛŒØ¯/Ùˆ',0),(441903,12276,'pr','Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø¨Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ù†Ø§Ù…Ø­Ø¯ÙˆØ¯Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯.Ø¨Ø±Ø§ÛŒ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÛŒØ§ ÙˆÛŒØ±Ø§ÛŒØ´ ÛŒÚ© Ú©Ø§Ø±Ø¨Ø± Ù…Ø³ÛŒØ± Ø²ÛŒØ± Ø±Ø§ Ø§Ø¯Ø§Ù…Ù‡ Ø¯Ù‡ÛŒØ¯.Ù…Ø¯ÛŒØ±ÛŒØª-Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù…Ø¯ÛŒØ±ÛŒØª- Ú©Ø§Ø±Ø¨Ø± Ø¬Ø¯ÛŒØ¯/Ùˆ',0),(441904,12276,'tr','NolaPro sÄ±nÄ±rsÄ±z kullanÄ±cÄ±lar saÄŸlar!<p>Bir kullanÄ±cÄ± eklemek veya dÃ¼zenlemek iÃ§in gidin:<p><b>Admin Admin kurulumu kullanÄ±cÄ± yeni/DÃ¼zenle->-></b>',0),(441905,12276,'pl','NolaPro umoÅ¼liwia uÅ¼ytkownikom nieograniczony!<p>Aby dodaÄ‡ lub edytowaÄ‡ uÅ¼ytkownika przejdÅº do:<p><b>Admin-> konfiguracji Admin-> nowego uÅ¼ytkownika/edycja</b>',0),(441906,12276,'bg','NolaPro Ð¿Ð¾Ð·Ð²Ð¾Ð»ÑÐ²Ð° Ð½ÐµÐ¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸!<p>Ð—Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð¸Ð»Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð¾Ñ‚Ð¸Ð²Ð°Ð¼ ÐºÑŠÐ¼:<p><b>Admin-> Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-> Ð½Ð¾Ð² Ð¿Ð¾Ñ‚Ñ€ÐµÐ±',0),(441907,12276,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ù„Ø§ Ù…Ø­Ø¯ÙˆØ¯ ØµØ§Ø±ÙÛŒÙ† Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒØªØ§ ÛÛ’!<p>Ø§Ø¶Ø§ÙÛ ÛŒØ§ ØªØ±Ù…ÛŒÙ… Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© ØµØ§Ø±Ù Ù¾Ø± Ø¬Ø§Ø¦ÛŒÚº:<p><b>Ø§ÛŒÚˆÙ…Ù† Admin Ø³ÛŒÙ¹ Ø§Ù¾ Ù†ÛŒØ§ ØµØ§Ø±Ù/ØªØ±Ù…ÛŒÙ…->-></b>',0),(441908,12276,'sr','ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð¾Ð¼Ð¾Ð³ÑƒÑ›Ð°Ð²Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸Ð¼Ð° Ð½ÐµÐ¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½!<p>Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð¸Ð»Ð¸ ÑƒÑ€ÐµÐ´Ð¸Ð»Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð¿Ð¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ ÐÐ´Ð¼Ð¸Ð½ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ð¸ Ð½Ð¾Ð²Ð¸Ñ… ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ð',0),(441909,12276,'vi','NaloPro khÃ´ng giá»›i háº¡n ngÆ°á»i dÃ¹ng. Äá»ƒ thÃªm má»›i hoáº·c chá»‰nh sá»­a 1 ngÆ°á»i dÃ¹ng thÃ¬ vÃ o: Quáº£n lÃ½- thiáº¿t láº­p quáº£n lÃ½-> ThÃªm má»›i/sá»­a ngÆ°á»i dá»­ dá»¥ng.',0),(441910,12276,'af','NolaPro onbeperkte gebruikers toelaat!<p>Om te redigeer of voeg \'n gebruiker gaan na:<p><b>Admin-> Admin opstelling-> nuwe gebruiker/redigeer</b>',0),(441911,12276,'ro','NolaPro permite nelimitat utilizatori!<p>Pentru a adÄƒuga sau edita un utilizator du-te la:<p><b>Admin->-Admin Setup-> utilizator nou/editare</b>',0),(441912,12276,'et','NolaPro vÃµimaldab piiramatult kasutajaid!<p>Lisada vÃµi redigeerida kasutaja minna:<p><b>Admin-> Admin seadistamine kasutaja uus/Muuda-></b>',0),(441913,12276,'si','NolaPro omogoÄa neomejen uporabnik!<p>Dodajanje ali urejanje uporabnik iti:<p><b>Admin-> Admin Setup-> nov uporabnik/Uredi</b>',0),(441914,12276,'ba','NolaPro memungkinkan pengguna terbatas!<p>Untuk menambah atau mengedit pengguna pergi ke:<p><b>Admin-> Admin Setup-> pengguna baru/Edit</b>',0),(441915,12276,'nl','NolaPro gebruikers onbeperkte!<p>Toevoegen of bewerken een gebruiker ga naar:<p><b>Admin-> Admin Setup-> / nieuwe gebruiker bewerken</b>',0),(441916,12276,'fi','NolaPro rajoittamaton kÃ¤yttÃ¤jÃ¤t!<p>Voit lisÃ¤tÃ¤ tai muokata kÃ¤yttÃ¤jÃ¤n Siirry:<p><b>Admin Admin asetukset-> kÃ¤yttÃ¤jÃ¤n uusi tai Muokkaa-></b>',0),(441917,12276,'no','NolaPro tillater ubegrenset!<p>Legge til eller redigere en bruker gÃ¥ til:<p><b>Admin-> Admin Setup-> bruker ny/Rediger</b>',0),(441918,12276,'da','NolaPro giver mulighed for ubegrÃ¦nset brugere!<p>TilfÃ¸je eller redigere en bruger gÃ¥ til:<p><b>Admin-> Admin Setup-> bruger ny/Rediger</b>',0),(441919,12276,'ko','NolaPro ë¬´ì œí•œ ì‚¬ìš©ìž ìˆ˜ ìžˆìŠµë‹ˆë‹¤!<p>ì¶”ê°€ í•˜ê±°ë‚˜ íŽ¸ì§‘í•  ì‚¬ìš©ìžë¡œ ì´ë™:<p><b>ê´€ë¦¬ìž ì„¤ì¹˜ ì‚¬ìš©ìž ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘->-> ê´€ë¦¬ìž</b>',0),(441920,12276,'he','NolaPro ×ž××¤×©×¨ ×œ×ž×©×ª×ž×©×™× ×œ×œ× ×”×’×‘×œ×”!<p>×›×“×™ ×œ×”×•×¡×™×£ ××• ×œ×¢×¨×•×š ×ž×©×ª×ž×© ×¢×‘×•×¨ ××œ:<p><b>Admin-> ×ž× ×”×œ ×”×”×ª×§× ×”-> ×ž×©×ª×ž×© ×—×“×©/×¢×¨×™×›×”</b>',0),(441921,12276,'el','NolaPro ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÎ¹ ÏƒÏ„Î¿Ï…Ï‚ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Î³Î¹Î± Î±Ï€ÎµÏÎ¹ÏŒÏÎ¹ÏƒÏ„Î·!<p>Î“Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î® Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î­Î½Î± Ï‡ÏÎ®ÏƒÏ„Î· Î¼ÎµÏ„Î±Î²ÎµÎ¯Ï„Îµ:<p><b>Admin-> Admin Setup-> Ï‡ÏÎ®ÏƒÏ„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î',0),(441922,12276,'zh','NolaProå…è®¸æœªé™åˆ¶ç”¨æˆ·ï¼æ–°å¢žæˆ–ç¼–è¾‘ä¸€ä¸ªç”¨æˆ·è¦åˆ°ï¼šç®¡ç†->ç®¡ç†è®¾ç½®->ç”¨æˆ·æ–°å¢ž/ç¼–è¾‘',0),(441923,12276,'sv','NolaPro tillÃ¥ter obegrÃ¤nsat anvÃ¤ndare!<p>LÃ¤gga till eller redigera en anvÃ¤ndare gÃ¥ till:<p><b>Admin-> Admin instÃ¤llning-> den nya anvÃ¤ndaren/redigera</b>',0),(441924,12276,'it','NolaPro permette agli utenti illimitati!<p>Per aggiungere o modificare un utente vanno:<p><b>Admin-> Admin Setup-> utente nuovo/modifica</b>',0),(441925,12276,'tl','',0),(441926,12276,'th','NolaPro à¸Šà¹ˆà¸§à¸¢à¹ƒà¸«à¹‰à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹„à¸¡à¹ˆà¸ˆà¸³à¸à¸±à¸”<p>à¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡ à¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚ à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹„à¸›à¸—à¸µà¹ˆ:<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² Admin->à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à',0),(441927,12276,'hi','NolaPro à¤…à¤¸à¥€à¤®à¤¿à¤¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤¤à¤¾ à¤¹à¥ˆ!<p>à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤¯à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤ªà¤° à¤œà¤¾à¤à¤ à¤•à¤°',0),(441928,12276,'ms','NolaPro membolehkan pengguna yang tidak terhad!<p>Untuk menambah atau menyunting pengguna pergi ke:<p><b>Admin-> Admin persediaan-> pengguna baru/Edit</b>',0),(441929,12276,'ar','Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ ÙŠØ³Ù…Ø­ Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† ØºÙŠØ± Ù…Ø­Ø¯ÙˆØ¯!<p>Ù„Ø¥Ø¶Ø§ÙØ© Ø£Ùˆ ØªØ­Ø±ÙŠØ± Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø´Ø±Ù-> Ù…Ø³ØªØ®Ø¯Ù… Ø¬Ø¯ÙŠØ¯/ØªØ­Ø±ÙŠØ±</b>',0),(441930,12276,'fr','NolaPro permet aux utilisateurs illimitÃ©s !<p>Pour ajouter ou modifier un utilisateur aller Ã  :<p><b>Admin-> Admin Setup-> nouvel utilisateur/modifier</b>',0),(441931,12276,'jp','NolaPro ç„¡åˆ¶é™ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã“ã¨ãŒã§ãã¾ã™ ï¼<p>è¿½åŠ ã¾ãŸã¯ç·¨é›†ã™ã‚‹ã«ã¯ã€ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«ç§»å‹•ã—ã¾ã™ã€‚<p><b>ç®¡ç†è€…ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ï¼ ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®ç·¨é›†æ–°ã—ã„->-></b>',0),(441932,12276,'pt','NolaPro permite que usuÃ¡rios ilimitados!<p>Para adicionar ou editar um usuÃ¡rio acesse:<p><b>Admin-> Admin Setup-> novo usuÃ¡rio/editar</b>',0),(441933,12276,'ru','NolaPro Ð¿Ð¾Ð·Ð²Ð¾Ð»ÑÐµÑ‚ Ð½ÐµÐ¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹!<p>Ð”Ð»Ñ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¸Ð»Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð¿ÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ðº:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚',0),(441934,12276,'es','NolaPro permite sin nÃºmero de  usuarios!<p>Para agregar o editar un usuario va a:<p><b>Admin -> Admin ConfiguraciÃ³n-> Usuario Nuevo/Editar</b>',0),(441935,12276,'de','Artikel kann beliebig viele Benutzer!<p>HinzufÃ¼gen oder bearbeiten ein Benutzers gehen Sie zu:<p><b>Admin-> Admin Setup-> Benutzer neu/bearbeiten</b>',0),(441936,12276,'en','NolaPro allows unlimited users!<p>To add or edit a user go to:<p><b>Admin -> Admin Setup-> User New/Edit</b>',0),(441937,12277,'is','',0),(441938,12277,'dr','',0),(441939,12277,'pr','',0),(441940,12277,'tr','',0),(441941,12277,'pl','',0),(441942,12277,'bg','',0),(441943,12277,'ur','',0),(441944,12277,'sr','',0),(441945,12277,'vi','',0),(441946,12277,'af','',0),(441947,12277,'ro','',0),(441948,12277,'et','',0),(441949,12277,'si','',0),(441950,12277,'ba','',0),(441951,12277,'nl','',0),(441952,12277,'fi','',0),(441953,12277,'no','',0),(441954,12277,'da','',0),(441955,12277,'ko','',0),(441956,12277,'he','',0),(441957,12277,'el','',0),(441958,12277,'zh','',0),(441959,12277,'sv','',0),(441960,12277,'it','',0),(441961,12277,'tl','',0),(441962,12277,'th','',0),(441963,12277,'hi','',0),(441964,12277,'ms','',0),(441965,12277,'ar','',0),(441966,12277,'fr','',0),(441967,12277,'jp','',0),(441968,12277,'pt','',0),(441969,12277,'ru','',0),(441970,12277,'es','',0),(441971,12277,'de','',0),(441972,12277,'en','',0),(441973,12278,'is','',0),(441974,12278,'dr','',0),(441975,12278,'pr','',0),(441976,12278,'tr','',0),(441977,12278,'pl','',0),(441978,12278,'bg','',0),(441979,12278,'ur','',0),(441980,12278,'sr','',0),(441981,12278,'vi','',0),(441982,12278,'af','',0),(441983,12278,'ro','',0),(441984,12278,'et','',0),(441985,12278,'si','',0),(441986,12278,'ba','',0),(441987,12278,'nl','',0),(441988,12278,'fi','',0),(441989,12278,'no','',0),(441990,12278,'da','',0),(441991,12278,'ko','',0),(441992,12278,'he','',0),(441993,12278,'el','',0),(441994,12278,'zh','',0),(441995,12278,'sv','',0),(441996,12278,'it','',0),(441997,12278,'tl','',0),(441998,12278,'th','',0),(441999,12278,'hi','',0),(442000,12278,'ms','',0),(442001,12278,'ar','',0),(442002,12278,'fr','',0),(442003,12278,'jp','',0),(442004,12278,'pt','',0),(442005,12278,'ru','',0),(442006,12278,'es','',0),(442007,12278,'de','',0),(442008,12278,'en','',0),(442009,12279,'is','',0),(442010,12279,'dr','',0),(442011,12279,'pr','',0),(442012,12279,'tr','',0),(442013,12279,'pl','',0),(442014,12279,'bg','',0),(442015,12279,'ur','',0),(442016,12279,'sr','',0),(442017,12279,'vi','',0),(442018,12279,'af','',0),(442019,12279,'ro','',0),(442020,12279,'et','',0),(442021,12279,'si','',0),(442022,12279,'ba','',0),(442023,12279,'nl','',0),(442024,12279,'fi','',0),(442025,12279,'no','',0),(442026,12279,'da','',0),(442027,12279,'ko','',0),(442028,12279,'he','',0),(442029,12279,'el','',0),(442030,12279,'zh','',0),(442031,12279,'sv','',0),(442032,12279,'it','',0),(442033,12279,'tl','',0),(442034,12279,'th','',0),(442035,12279,'hi','',0),(442036,12279,'ms','',0),(442037,12279,'ar','',0),(442038,12279,'fr','',0),(442039,12279,'jp','',0),(442040,12279,'pt','',0),(442041,12279,'ru','',0),(442042,12279,'es','',0),(442043,12279,'de','',0),(442044,12279,'en','',0),(442045,12280,'is','',0),(442046,12280,'dr','',0),(442047,12280,'pr','',0),(442048,12280,'tr','',0),(442049,12280,'pl','',0),(442050,12280,'bg','',0),(442051,12280,'ur','',0),(442052,12280,'sr','',0),(442053,12280,'vi','',0),(442054,12280,'af','',0),(442055,12280,'ro','',0),(442056,12280,'et','',0),(442057,12280,'si','',0),(442058,12280,'ba','',0),(442059,12280,'nl','',0),(442060,12280,'fi','',0),(442061,12280,'no','',0),(442062,12280,'da','',0),(442063,12280,'ko','',0),(442064,12280,'he','',0),(442065,12280,'el','',0),(442066,12280,'zh','',0),(442067,12280,'sv','',0),(442068,12280,'it','',0),(442069,12280,'tl','',0),(442070,12280,'th','',0),(442071,12280,'hi','',0),(442072,12280,'ms','',0),(442073,12280,'ar','',0),(442074,12280,'fr','',0),(442075,12280,'jp','',0),(442076,12280,'pt','',0),(442077,12280,'ru','',0),(442078,12280,'es','',0),(442079,12280,'de','',0),(442080,12280,'en','',0),(442081,12281,'is','',0),(442082,12281,'dr','. Ù‡Ù…Ú†Ù†ÛŒÙ† Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ù‡ Ø·ÙˆØ± Ù…ÙˆÙ‚Øª Ù‡Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¶Ø¯ ÙˆÛŒØ±ÙˆØ³ / ÙØ§ÛŒØ±ÙˆØ§Ù„',0),(442083,12281,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø§ØªØµØ§Ù„ Ø¨Ù‡ Ø§ÛŒÙ†ØªØ±Ù†Øª Ø¨Ø±Ø§ÛŒ ØªÚ©Ù…ÛŒÙ„ ÙØ±Ø§ÛŒÙ†Ø¯ ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒ Ø­Ø³Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯. Ù‡Ù…Ú†Ù†ÛŒÙ† Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ù‡ Ø·ÙˆØ± Ù…ÙˆÙ‚Øª Ù‡Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¶Ø¯ ÙˆÛŒØ±ÙˆØ³ / ÙØ§ÛŒØ±ÙˆØ§Ù„',0),(442084,12281,'tr','EtkinleÅŸtirme iÅŸlemini tamamlamak iÃ§in Internet baÄŸlantÄ±nÄ±zÄ±n olmasÄ± gerekir. AyrÄ±ca herhangi bir anti-virÃ¼s programlarÄ±/harekete geÃ§irmek engelliyor olabilir gÃ¼venlik duvarlarÄ± geÃ§ici olarak devre dÄ±ÅŸÄ± bÄ±rakmanÄ±z gerekebilir.',0),(442085,12281,'pl','Musisz mieÄ‡ poÅ‚Ä…czenie z Internetem, aby zakoÅ„czyÄ‡ proces aktywacji. RÃ³wnieÅ¼ moÅ¼e musisz tymczasowo wyÅ‚Ä…czyÄ‡ kaÅ¼dy anty-wirus programy/zapory, ktÃ³re mogÄ… blokowaÄ‡ aktywacja.',0),(442086,12281,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð°Ñ‚Ðµ Ð²Ñ€ÑŠÐ·ÐºÐ° Ñ Ð¸Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚, Ð·Ð° Ð´Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð½Ð° Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ. Ð¡ÑŠÑ‰Ð¾ Ñ‚Ð°ÐºÐ° Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð½Ð°Ð»Ð¾Ð¶Ð¸ Ð´Ð° Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð°Ð½Ñ‚Ð¸Ð²Ð¸Ñ€ÑƒÑ',0),(442087,12281,'ur','Ø¢Ù¾ Ú©Ùˆ Ù…ØªØ­Ø±Ú© Ú©Ø§Ø±ÛŒ Ø¹Ù…Ù„ Ù…Ú©Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ø§Ù†Ù¹Ø±Ù†ÛŒÙ¹ Ú©Ù†Ú©Ø´Ù† ÛÙˆÙ†Ø§ Ø¶Ø±ÙˆØ±ÛŒ ÛÛ’ Û” Ø¢Ù¾ Ø¨Ú¾ÛŒ Ø¹Ø§Ø±Ø¶ÛŒ Ø·ÙˆØ± Ù¾Ø± Ú©Ø³ÛŒ Ø¨Ú¾ÛŒ Ø§ÛŒÙ†Ù¹ÛŒ ÙˆØ§Ø¦Ø±Ø³ Ù¾Ø±ÙˆÚ¯Ø±Ø§Ù…/Ø¬Ùˆ Ù…ØªØ­Ø±Ú© Ú©Ø§Ø±ÛŒ Ø¨Ù„Ø§Ú© Ú©Ø± Ø±',0),(442088,12281,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð¼Ð°Ñ‚Ð¸ Ð¸Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚ Ð²ÐµÐ·Ñƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐ¸Ð»Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ñ˜Ðµ. Ð‹ÐµÑ‚Ðµ Ð¼Ð¾Ð¶Ð´Ð° Ð¼Ð¾Ñ€Ð°Ñ‚Ð¸ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¾ Ð¾Ð½ÐµÐ¼Ð¾Ð³ÑƒÑ›Ð¸Ð»Ð¸ Ð±Ð¸Ð»Ð¾ ÐºÐ¾Ñ˜Ð¸ Ð°Ð½Ñ‚Ð¸Ð²Ð¸Ñ€ÑƒÑ Ð¿Ñ€Ð¾Ð',0),(442089,12281,'vi','báº¡n pháº£i cÃ³ má»™t káº¿t ná»‘i internet Ä‘á»ƒ hoÃ n táº¥t quÃ¡ trÃ¬nh kÃ­ch hoáº¡t. Báº¡n cÅ©ng cÃ³ thá»ƒ cáº§n pháº£i táº¡m thá»i vÃ´ hiá»‡u hÃ³a báº¥t ká»³ chÆ°Æ¡ng trÃ¬nh chá»‘ng virus / tÆ°á»ng lá»­a cÃ³ thá»ƒ Ä‘Æ°á»£c ngÄƒn cháº·n kÃ­ch hoáº¡t.',0),(442090,12281,'af','Jy moet \'n internetverbinding om die aktivering proses voltooi het. Jy kan ook moet enige anti-virus programme/brandmure wat kon aktivering blokkeer word tydelik versper.',0),(442091,12281,'ro','Trebuie sÄƒ aveÅ£i o conexiune la internet pentru a finaliza procesul de activare. De asemenea, trebuie sÄƒ dezactivaÅ£i temporar orice programe anti-virus/firewall care ar putea fi blocarea de activare.',0),(442092,12281,'et','Peab teil olema Interneti-Ã¼hendus aktiveerimisprotsessi lÃµpuleviimiseks. Peate ajutiselt keelama kÃµik viirusetÃµrje programmid/tulemÃ¼Ã¼rid mis vÃµib blokeerida aktiveerimine.',0),(442093,12281,'si','Morate imeti internetno povezavo v celoten activation proces. Morda boste morali zaÄasno onemogoÄiti poljuben smeÅ¡en-kaÄji strup programs/poÅ¾arnih pregrad, ki blokira activation.',0),(442094,12281,'ba','Anda harus memiliki koneksi internet untuk menyelesaikan proses aktivasi. Anda mungkin juga perlu untuk sementara menonaktifkan anti virus program/firewall yang bisa menghalangi aktivasi.',0),(442095,12281,'nl','U moet een internet-verbinding om het activeringsproces te voltooien. U moet mogelijk ook tijdelijk uitschakelen een anti-virus programma\'s / firewalls die activering kan worden geblokkeerd.',0),(442096,12281,'fi','Sinulla on internet-yhteys lopettaa aktivoiminen jalostaa. Tarvitset voi myÃ¶s tilapÃ¤isesti kÃ¤ytÃ¶stÃ¤ anti-virus ohjelmat/palomuureja joka saattaa estÃ¤Ã¤ aktivoinnin.',0),(442097,12281,'no','Du mÃ¥ ha en Internett-tilkobling for Ã¥ fullfÃ¸re aktiveringsprosessen. Du mÃ¥ ogsÃ¥ midlertidig deaktivere anti-virus programmer/brannmurer som kan blokkere aktivisering.',0),(442098,12281,'da','Du skal have en internetforbindelse for at fuldfÃ¸re aktiveringsprocessen. Du kan ogsÃ¥ skal midlertidigt deaktivere enhver anti-virus programmer/firewalls, der kunne blokere for aktivering.',0),(442099,12281,'ko','ì •í’ˆ ì¸ì¦ í”„ë¡œì„¸ìŠ¤ë¥¼ ì™„ë£Œ í•˜ë ¤ë©´ ì¸í„°ë„· ì—°ê²°ì´ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤. ë˜í•œ ì¼ì‹œì ìœ¼ë¡œ í™œì„±í™”ë¥¼ ì°¨ë‹¨ í•˜ ê³  ìžˆì„ ìˆ˜ ìžˆëŠ” ëª¨ë“  ë°”ì´ëŸ¬ìŠ¤ ë°±ì‹  í”„ë¡œê·¸ëž¨/ë°©í™”ë²½ì„ ì‚¬ìš© í•˜ì§€ ì•Šë„ë¡ í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(442100,12281,'he','×“×¨×•×© ×œ×š ×—×™×‘×•×¨ ×œ××™× ×˜×¨× ×˜ ×›×“×™ ×œ×”×©×œ×™× ××ª ×ª×”×œ×™×š ×”×”×¤×¢×œ×”. ×™×™×ª×›×Ÿ ×’× ×¢×œ×™×š ×œ×‘×˜×œ ×‘××•×¤×Ÿ ×–×ž× ×™ ××ª ×›×œ ×× ×˜×™ ×•×™×¨×•×¡ ×ª×•×›× ×™×•×ª/×—×•×ž×•×ª ××© ×›×™ ×™×›×•×œ ×œ×”×™×•×ª ×—×¡×™×ž×ª ×”×¤×¢×œ×”.',0),(442101,12281,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î¼Î¹Î± ÏƒÏÎ½Î´ÎµÏƒÎ· ÏƒÏ„Î¿ internet Î³Î¹Î± Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ½Ï‰ the Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±. Î•Ï€Î¯ÏƒÎ·Ï‚, Î¯ÏƒÏ‰Ï‚ Ï‡ÏÎµÎ¹Î±ÏƒÏ„ÎµÎ¯ Î½Î± Î±Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï€ÏÎ¿ÏƒÏ‰ÏÎ¹Î½Î¬',0),(442102,12281,'zh','ä½ å¿…é¡»æœ‰ä¸€ä¸ªç½‘ç»œè¿žæŽ¥ä»¥å®Œæˆæ¿€æ´»è¿‡ç¨‹ã€‚ä½ ä¹Ÿè®¸è¿˜éœ€è¦æš‚æ—¶åœæ­¢ä»»ä½•ä¼šå¦¨ç¢æ¿€æ´»è¿‡ç¨‹çš„æ€æ¯’ç¨‹åº/é˜²ç«å¢™ã€‚',0),(442103,12281,'sv','Du mÃ¥ste ha en internet-anslutning till komplett aktiveringen fÃ¶rlopp. Du kan ocksÃ¥ behÃ¶va tillfÃ¤lligt inaktivera nÃ¥gon anti-virus program/brandvÃ¤ggar som kanske blockerar aktiveringen.',0),(442104,12281,'it','Ãˆ necessario disporre di una connessione a internet per completare il processo di attivazione. Potrebbe anche essere necessario disattivare temporaneamente i programmi antivirus/firewall che potrebbe bloccare attivazione.',0),(442105,12281,'tl','',0),(442106,12281,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¸­à¸´à¸™à¹€à¸—à¸­à¸£à¹Œà¹€à¸™à¹‡à¸•à¸à¸²à¸£à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™ à¸„à¸¸à¸“à¸­à¸²à¸ˆà¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¹ƒà¸” à¹† à¹à¸­à¸™à¸•à¸µà¹‰à¹„à¸§à¸£à¸±à¸ªà¹‚à¸›à¸£à¹à¸à¸£à¸¡',0),(442107,12281,'hi','à¤†à¤ª à¤¸à¤•à¥à¤°à¤¿à¤¯à¤•à¤°à¤£ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‹ à¤ªà¥‚à¤°à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤‡à¤‚à¤Ÿà¤°à¤¨à¥‡à¤Ÿ à¤•à¤¨à¥‡à¤•à¥à¤¶à¤¨ à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤ à¤†à¤ª à¤­à¥€ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤à¤‚à¤Ÿà¥€-à¤',0),(442108,12281,'ms','Anda mesti mempunyai sambungan internet untuk melengkapkan proses pengaktifan. Anda juga mungkin perlu untuk sementara mematikan mana-mana atur cara anti-virus/firewall yang boleh menyekat pengaktifan.',0),(442109,12281,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ø§ØªØµØ§Ù„ Ø¨Ø¥Ù†ØªØ±Ù†Øª Ù„Ø¥ÙƒÙ…Ø§Ù„ Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ØªÙ†Ø´ÙŠØ·. Ù‚Ø¯ ØªØ­ØªØ§Ø¬ Ø£ÙŠØ¶Ø§ ØªØ¹Ø·ÙŠÙ„ Ø£ÙŠ Ù…ÙƒØ§ÙØ­Ø© Ø§Ù„ÙÙŠØ±ÙˆØ³Ø§Øª Ø¨Ø±Ø§Ù…Ø¬/Ø¬Ø¯Ø±Ø§Ù† Ø§Ù„Ø­Ù…Ø§ÙŠØ© Ø§Ù„ØªÙŠ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªØ³Ø¯ Ø§Ù„ØªÙ†Ø´ÙŠØ· Ø¨Ø´',0),(442110,12281,'fr','Vous devez avoir une connexion internet pour complÃ©ter le processus d\'activation. Vous devrez peut-Ãªtre aussi dÃ©sactiver temporairement les programmes anti-virus/pare-feu qui pourrait bloquer activation.',0),(442111,12281,'jp','ãƒ©ã‚¤ã‚»ãƒ³ã‚¹èªè¨¼ãƒ—ãƒ­ã‚»ã‚¹ã‚’å®Œäº†ã™ã‚‹ã«ã¯ã€ã‚¤ãƒ³ã‚¿ãƒ¼ãƒãƒƒãƒˆæŽ¥ç¶šãŒå¿…è¦ã§ã™ã€‚ã¾ãŸã€ä¸€æ™‚çš„ã«æ´»æ€§åŒ–ã‚’ãƒ–ãƒ­ãƒƒã‚¯ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ãƒ•ã‚¡ã‚¤ã‚¢ã‚¦ã‚©ãƒ¼ãƒ«/ã‚¦ã‚¤ãƒ«ã‚¹å¯¾ç­–ãƒ—ãƒ­ã‚°ãƒ©ãƒ ã‚’ç„¡åŠ¹ã«ã™ã‚‹å¿…è¦',0),(442112,12281,'pt','VocÃª deve ter uma conexÃ£o Ã  internet para concluir o processo de ativaÃ§Ã£o. VocÃª tambÃ©m pode precisar desativar temporariamente qualquer programas antivÃ­rus/firewalls que poderia estar bloqueando a ativaÃ§Ã£o.',0),(442113,12281,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¸Ð¼ÐµÑ‚ÑŒ Ð¿Ð¾Ð´ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ Ðº Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚Ñƒ Ð´Ð»Ñ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ° Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ð¸. Ð¢Ð°ÐºÐ¶Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ñ‚ÑŒÑÑ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾ Ð¾Ñ‚ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð±Ñ€Ð°Ð½Ð´Ð¼Ð°ÑƒÑÑ€Ñ‹ Ð',0),(442114,12281,'es','Debe tener una conexiÃ³n al internet para completar el proceso de activaciÃ³n. TambiÃ©n posible tiene que desactivar temporalmente cualquieres programas/cortafuegos  de anti-virus que podrÃ­an bloquear la activaciÃ³n',0),(442115,12281,'de','Sie mÃ¼ssen eine Internet-Verbindung, um die Aktivierung abzuschlieÃŸen. Sie mÃ¼ssen auch deaktivieren Sie vorÃ¼bergehend alle Anti-Virus Programme/Firewalls, die Aktivierung blockiert werden kÃ¶nnte.',0),(442116,12281,'en','You must have an internet connection to complete the activation process. You may also need to temporarily disable any anti-virus programs/firewalls that could be blocking activation.',0),(442117,12282,'is','',0),(442118,12282,'dr','',0),(442119,12282,'pr','',0),(442120,12282,'tr','',0),(442121,12282,'pl','',0),(442122,12282,'bg','',0),(442123,12282,'ur','',0),(442124,12282,'sr','',0),(442125,12282,'vi','',0),(442126,12282,'af','',0),(442127,12282,'ro','',0),(442128,12282,'et','',0),(442129,12282,'si','',0),(442130,12282,'ba','',0),(442131,12282,'nl','',0),(442132,12282,'fi','',0),(442133,12282,'no','',0),(442134,12282,'da','',0),(442135,12282,'ko','',0),(442136,12282,'he','',0),(442137,12282,'el','',0),(442138,12282,'zh','',0),(442139,12282,'sv','',0),(442140,12282,'it','',0),(442141,12282,'tl','',0),(442142,12282,'th','',0),(442143,12282,'hi','',0),(442144,12282,'ms','',0),(442145,12282,'ar','',0),(442146,12282,'fr','',0),(442147,12282,'jp','',0),(442148,12282,'pt','',0),(442149,12282,'ru','',0),(442150,12282,'es','',0),(442151,12282,'de','',0),(442152,12282,'en','',0),(442153,12283,'is','',0),(442154,12283,'dr','',0),(442155,12283,'pr','',0),(442156,12283,'tr','',0),(442157,12283,'pl','',0),(442158,12283,'bg','',0),(442159,12283,'ur','',0),(442160,12283,'sr','',0),(442161,12283,'vi','',0),(442162,12283,'af','',0),(442163,12283,'ro','',0),(442164,12283,'et','',0),(442165,12283,'si','',0),(442166,12283,'ba','',0),(442167,12283,'nl','',0),(442168,12283,'fi','',0),(442169,12283,'no','',0),(442170,12283,'da','',0),(442171,12283,'ko','',0),(442172,12283,'he','',0),(442173,12283,'el','',0),(442174,12283,'zh','',0),(442175,12283,'sv','',0),(442176,12283,'it','',0),(442177,12283,'tl','',0),(442178,12283,'th','',0),(442179,12283,'hi','',0),(442180,12283,'ms','',0),(442181,12283,'ar','',0),(442182,12283,'fr','',0),(442183,12283,'jp','',0),(442184,12283,'pt','',0),(442185,12283,'ru','',0),(442186,12283,'es','',0),(442187,12283,'de','',0),(442188,12283,'en','',0),(442189,12284,'is','',0),(442190,12284,'dr','',0),(442191,12284,'pr','',0),(442192,12284,'tr','',0),(442193,12284,'pl','',0),(442194,12284,'bg','',0),(442195,12284,'ur','',0),(442196,12284,'sr','',0),(442197,12284,'vi','',0),(442198,12284,'af','',0),(442199,12284,'ro','',0),(442200,12284,'et','',0),(442201,12284,'si','',0),(442202,12284,'ba','',0),(442203,12284,'nl','',0),(442204,12284,'fi','',0),(442205,12284,'no','',0),(442206,12284,'da','',0),(442207,12284,'ko','',0),(442208,12284,'he','',0),(442209,12284,'el','',0),(442210,12284,'zh','',0),(442211,12284,'sv','',0),(442212,12284,'it','',0),(442213,12284,'tl','',0),(442214,12284,'th','',0),(442215,12284,'hi','',0),(442216,12284,'ms','',0),(442217,12284,'ar','',0),(442218,12284,'fr','',0),(442219,12284,'jp','',0),(442220,12284,'pt','',0),(442221,12284,'ru','',0),(442222,12284,'es','',0),(442223,12284,'de','',0),(442224,12284,'en','',0),(442225,12285,'is','',0),(442226,12285,'dr','',0),(442227,12285,'pr','',0),(442228,12285,'tr','',0),(442229,12285,'pl','',0),(442230,12285,'bg','',0),(442231,12285,'ur','',0),(442232,12285,'sr','',0),(442233,12285,'vi','',0),(442234,12285,'af','',0),(442235,12285,'ro','',0),(442236,12285,'et','',0),(442237,12285,'si','',0),(442238,12285,'ba','',0),(442239,12285,'nl','',0),(442240,12285,'fi','',0),(442241,12285,'no','',0),(442242,12285,'da','',0),(442243,12285,'ko','',0),(442244,12285,'he','',0),(442245,12285,'el','',0),(442246,12285,'zh','',0),(442247,12285,'sv','',0),(442248,12285,'it','',0),(442249,12285,'tl','',0),(442250,12285,'th','',0),(442251,12285,'hi','',0),(442252,12285,'ms','',0),(442253,12285,'ar','',0),(442254,12285,'fr','',0),(442255,12285,'jp','',0),(442256,12285,'pt','',0),(442257,12285,'ru','',0),(442258,12285,'es','',0),(442259,12285,'de','',0),(442260,12285,'en','',0),(442261,12286,'is','',0),(442262,12286,'dr','',0),(442263,12286,'pr','',0),(442264,12286,'tr','',0),(442265,12286,'pl','',0),(442266,12286,'bg','',0),(442267,12286,'ur','',0),(442268,12286,'sr','',0),(442269,12286,'vi','',0),(442270,12286,'af','',0),(442271,12286,'ro','',0),(442272,12286,'et','',0),(442273,12286,'si','',0),(442274,12286,'ba','',0),(442275,12286,'nl','',0),(442276,12286,'fi','',0),(442277,12286,'no','',0),(442278,12286,'da','',0),(442279,12286,'ko','',0),(442280,12286,'he','',0),(442281,12286,'el','',0),(442282,12286,'zh','',0),(442283,12286,'sv','',0),(442284,12286,'it','',0),(442285,12286,'tl','',0),(442286,12286,'th','',0),(442287,12286,'hi','',0),(442288,12286,'ms','',0),(442289,12286,'ar','',0),(442290,12286,'fr','',0),(442291,12286,'jp','',0),(442292,12286,'pt','',0),(442293,12286,'ru','',0),(442294,12286,'es','',0),(442295,12286,'de','',0),(442296,12286,'en','',0),(442297,12287,'is','',0),(442298,12287,'dr','Ø±Ø§Ø¨Ø·Ù‡ Ø¨ÛŒÙ† Ú©Ø§Ø±Ø¨Ø± Ùˆ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ø¯Ø§ÛŒÙ†Ø§Ù…ÛŒÚ©  Ø·Ø±Ø§Ø­ÛŒ Ø´Ø¯Ù‡ Ø§Ø³Øª  ',0),(442299,12287,'pr','Ø±Ø§Ø¨Ø·Ù‡ Ø¨ÛŒÙ† Ú©Ø§Ø±Ø¨Ø± Ùˆ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ø¯Ø§ÛŒÙ†Ø§Ù…ÛŒÚ©  Ø·Ø±Ø§Ø­ÛŒ Ø´Ø¯Ù‡ Ø§Ø³Øª  ',0),(442300,12287,'tr','KullanÄ±cÄ± bir satÄ±ÅŸÃ§Ä± Tie POS/dinamik sipariÅŸ iÃ§in sadece tasarlanmÄ±ÅŸtÄ±r.',0),(442301,12287,'pl','WiÄ…zana do uÅ¼ytkownika sprzedawca zostaÅ‚ zaprojektowany na zamÃ³wienie POS/dynamiczny tylko.',0),(442302,12287,'bg','ÐœÐµÑÑ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»-Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ† Ðµ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¸Ñ€Ð°Ð½ Ð·Ð° POS/Ð´Ð¸Ð½Ð°Ð¼Ð¸Ñ‡ÐµÐ½ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑÐ°Ð¼Ð¾.',0),(442303,12287,'ur','ØµØ§Ø±Ù-Ù¾Ø±Ø³Ù† Ú©Û’ Ù„Ø¦Û’ tie-in Ú©ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù†/Ù…ØªØ­Ø±Ú© ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ ØµØ±Ù ÚˆÛŒØ²Ø§Ø¦Ù† Ú©ÛŒØ§ Ú¯ÛŒØ§ ØªÚ¾Ø§ Û”',0),(442304,12287,'sr','ÐŸÐ¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐµ Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº-Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ† Ñ˜Ðµ Ð´Ð¸Ð·Ð°Ñ˜Ð½Ð¸Ñ€Ð°Ð½Ð° Ð·Ð° ÐŸÐžÐ¡/Ð´Ð¸Ð½Ð°Ð¼Ð¸ÐºÐ° Ð½Ð°Ð»Ð¾Ð³ ÑÐ°Ð¼Ð¾.',0),(442305,12287,'vi','ÄÆ°á»ng dáº«n tá»« ngÆ°á»i dÃ¹ng Ä‘áº¿n viÃªn bÃ¡n hÃ ng ngÆ°á»i dÃ¹ng Ä‘Æ°á»£c thiáº¿t káº¿ cho cÃ¡c POS',0),(442306,12287,'af','Die tie-in aan die gebruiker-verkoopsman is ontwerp vir die POS/dinamiese orde slegs.',0),(442307,12287,'ro','CravatÄƒ user-agent de vÃ¢nzÄƒri a fost proiectat pentru POS/Dynamic comanda numai.',0),(442308,12287,'et','Tie-in kasutaja mÃ¼Ã¼giisikule oli mÃµeldud ainult POS/dÃ¼naamiline jÃ¤rjekorras.',0),(442309,12287,'si','Tie-in uporabnik prodajalcu je bil zasnovan za POS/dinamiÄno nalog samo.',0),(442310,12287,'ba','The tie-in ke pengguna-Penjual dirancang untuk urutan POS dinamis hanya.',0),(442311,12287,'nl','De tie-in aan de gebruiker-verkoper is ontworpen voor de POS/dynamische volgorde alleen.',0),(442312,12287,'fi','KÃ¤yttÃ¤jÃ¤n myyjÃ¤lle tie-in suunniteltiin POS/dynaaminen tilauksen vain.',0),(442313,12287,'no','Oppkobling til brukeren-selgeren ble designet for POS/dynamiske ordre bare.',0),(442314,12287,'da','Tie-in til bruger-sÃ¦lger var designet for POS/dynamisk ordren kun.',0),(442315,12287,'ko','ì‚¬ìš©ìž íŒë§¤ì›ì— ë„¥íƒ€ì´ POS/ë™ì  ìˆœì„œì— ëŒ€ í•œ ì„¤ê³„ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(442316,12287,'he','×—×™×–×•×§ ×”×—×™×‘×•×¨ ×©×œ ×ž×˜×¤×™ ×œ××™×© ×”×ž×›×™×¨×•×ª-×”×ž×©×ª×ž×© ×ª×•×›× ×Ÿ ×¢×‘×•×¨ ×”×–×ž× ×ª POS/×“×™× ××ž×™ ×‘×œ×‘×“.',0),(442317,12287,'el','Î— ÏƒÏ‡Î­ÏƒÎ· Î¼Îµ Ï„Î¿Î½ Ï‡ÏÎ®ÏƒÏ„Î·-Ï€Ï‰Î»Î·Ï„Î® ÏƒÏ‡ÎµÎ´Î¹Î¬ÏƒÏ„Î·ÎºÎµ Î³Î¹Î± Ï„Î· ÏƒÎµÎ¹ÏÎ¬ POS/Î´Ï…Î½Î±Î¼Î¹ÎºÎ® Î¼ÏŒÎ½Î¿.',0),(442318,12287,'zh','ç»™ç”¨æˆ·-é”€å”®äººå‘˜çš„æ†ç»‘åŠŸèƒ½ä»…ä¸“ä¸ºé”€å”®ç‚¹/æ´»è·ƒè®¢å•ã€‚',0),(442319,12287,'sv','Tie-in till anvÃ¤ndaren-sÃ¤ljaren var avsedd fÃ¶r POS/dynamisk bestÃ¤lla bara.',0),(442320,12287,'it','Il tie-in per l\'utente-venditore Ã¨ stato progettato per l\'ordine di POS/dinamico solo.',0),(442321,12287,'tl','',0),(442322,12287,'th','Tie-in à¹ƒà¸«à¹‰à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸–à¸¹à¸à¸­à¸­à¸à¹à¸šà¸šà¸¡à¸²à¸ªà¸³à¸«à¸£à¸±à¸š POS/à¹„à¸”à¸™à¸²à¸¡à¸´à¸ à¸ªà¸±à¹ˆà¸‡à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(442323,12287,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾-salesperson à¤®à¥‡à¤‚ à¤—à¤ à¤¬à¤‚à¤§à¤¨ à¤•à¥‡à¤µà¤² POS/à¤—à¤¤à¤¿à¤¶à¥€à¤² à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¥à¤¾à¥¤',0),(442324,12287,'ms','Kili kepada pengguna-jurujual direka untuk pesanan POS/dinamik sahaja.',0),(442325,12287,'ar','ØµÙ…Ù… Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ÙˆØµÙ„ Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù…--Ù…Ù†Ø¯ÙˆØ¨ Ù…Ø¨ÙŠØ¹Ø§Øª \"ØªØ±ØªÙŠØ¨\" Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹/Ø§Ù„Ø­ÙŠÙˆÙŠ ÙÙ‚Ø·.',0),(442326,12287,'fr','Le raccordement Ã  l\'utilisateur-agent a Ã©tÃ© conÃ§u pour la commande de POS/dynamique seulement.',0),(442327,12287,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼-å–¶æ¥­æ‹…å½“è€…ã«æŠ±ãåˆã‚ã›è²©å£² POS/å‹•çš„é †åºã®ã¿ãŸã‚ã«è¨­è¨ˆã•ã‚Œã¾ã—ãŸã€‚',0),(442328,12287,'pt','O tie-in para o usuÃ¡rio-vendedor foi projetado para a ordem de POS/dinÃ¢mico sÃ³.',0),(442329,12287,'ru','Ð’Ñ€ÐµÐ·ÐºÐ¸ Ð´Ð»Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð²ÐµÑ† Ð±Ñ‹Ð» Ñ€Ð°Ð·Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½ Ð´Ð»Ñ POS/Ð´Ð¸Ð½Ð°Ð¼Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ñ‚Ð¾Ð»ÑŒÐºÐ¾.',0),(442330,12287,'es','La conexiÃ³n al vendedor-usuario se diseÃ±Ã³ por el PDV/Dinamico Orden solamente',0),(442331,12287,'de','Tie des Benutzer-VerkÃ¤ufers wurde fÃ¼r den POS/dynamische Auftrag nur entworfen.',0),(442332,12287,'en','The tie-in to the user-salesperson was designed for the POS/Dynamic Order only.',0),(442333,12288,'is','',0),(442334,12288,'dr','',0),(442335,12288,'pr','',0),(442336,12288,'tr','',0),(442337,12288,'pl','',0),(442338,12288,'bg','',0),(442339,12288,'ur','',0),(442340,12288,'sr','',0),(442341,12288,'vi','',0),(442342,12288,'af','',0),(442343,12288,'ro','',0),(442344,12288,'et','',0),(442345,12288,'si','',0),(442346,12288,'ba','',0),(442347,12288,'nl','',0),(442348,12288,'fi','',0),(442349,12288,'no','',0),(442350,12288,'da','',0),(442351,12288,'ko','',0),(442352,12288,'he','',0),(442353,12288,'el','',0),(442354,12288,'zh','',0),(442355,12288,'sv','',0),(442356,12288,'it','',0),(442357,12288,'tl','',0),(442358,12288,'th','',0),(442359,12288,'hi','',0),(442360,12288,'ms','',0),(442361,12288,'ar','',0),(442362,12288,'fr','',0),(442363,12288,'jp','',0),(442364,12288,'pt','',0),(442365,12288,'ru','',0),(442366,12288,'es','',0),(442367,12288,'de','',0),(442368,12288,'en','',0),(442369,12289,'is','',0),(442370,12289,'dr','',0),(442371,12289,'pr','',0),(442372,12289,'tr','',0),(442373,12289,'pl','',0),(442374,12289,'bg','',0),(442375,12289,'ur','',0),(442376,12289,'sr','',0),(442377,12289,'vi','',0),(442378,12289,'af','',0),(442379,12289,'ro','',0),(442380,12289,'et','',0),(442381,12289,'si','',0),(442382,12289,'ba','',0),(442383,12289,'nl','',0),(442384,12289,'fi','',0),(442385,12289,'no','',0),(442386,12289,'da','',0),(442387,12289,'ko','',0),(442388,12289,'he','',0),(442389,12289,'el','',0),(442390,12289,'zh','',0),(442391,12289,'sv','',0),(442392,12289,'it','',0),(442393,12289,'tl','',0),(442394,12289,'th','',0),(442395,12289,'hi','',0),(442396,12289,'ms','',0),(442397,12289,'ar','',0),(442398,12289,'fr','',0),(442399,12289,'jp','',0),(442400,12289,'pt','',0),(442401,12289,'ru','',0),(442402,12289,'es','',0),(442403,12289,'de','',0),(442404,12289,'en','',0),(442405,12290,'is','',0),(442406,12290,'dr','',0),(442407,12290,'pr','',0),(442408,12290,'tr','',0),(442409,12290,'pl','',0),(442410,12290,'bg','',0),(442411,12290,'ur','',0),(442412,12290,'sr','',0),(442413,12290,'vi','',0),(442414,12290,'af','',0),(442415,12290,'ro','',0),(442416,12290,'et','',0),(442417,12290,'si','',0),(442418,12290,'ba','',0),(442419,12290,'nl','',0),(442420,12290,'fi','',0),(442421,12290,'no','',0),(442422,12290,'da','',0),(442423,12290,'ko','',0),(442424,12290,'he','',0),(442425,12290,'el','',0),(442426,12290,'zh','',0),(442427,12290,'sv','',0),(442428,12290,'it','',0),(442429,12290,'tl','',0),(442430,12290,'th','',0),(442431,12290,'hi','',0),(442432,12290,'ms','',0),(442433,12290,'ar','',0),(442434,12290,'fr','',0),(442435,12290,'jp','',0),(442436,12290,'pt','',0),(442437,12290,'ru','',0),(442438,12290,'es','',0),(442439,12290,'de','',0),(442440,12290,'en','',0),(442441,12291,'is','',0),(442442,12291,'dr','',0),(442443,12291,'pr','',0),(442444,12291,'tr','',0),(442445,12291,'pl','',0),(442446,12291,'bg','',0),(442447,12291,'ur','',0),(442448,12291,'sr','',0),(442449,12291,'vi','',0),(442450,12291,'af','',0),(442451,12291,'ro','',0),(442452,12291,'et','',0),(442453,12291,'si','',0),(442454,12291,'ba','',0),(442455,12291,'nl','',0),(442456,12291,'fi','',0),(442457,12291,'no','',0),(442458,12291,'da','',0),(442459,12291,'ko','',0),(442460,12291,'he','',0),(442461,12291,'el','',0),(442462,12291,'zh','',0),(442463,12291,'sv','',0),(442464,12291,'it','',0),(442465,12291,'tl','',0),(442466,12291,'th','',0),(442467,12291,'hi','',0),(442468,12291,'ms','',0),(442469,12291,'ar','',0),(442470,12291,'fr','',0),(442471,12291,'jp','',0),(442472,12291,'pt','',0),(442473,12291,'ru','',0),(442474,12291,'es','',0),(442475,12291,'de','',0),(442476,12291,'en','',0),(442477,12292,'is','',0),(442478,12292,'dr','',0),(442479,12292,'pr','',0),(442480,12292,'tr','',0),(442481,12292,'pl','',0),(442482,12292,'bg','',0),(442483,12292,'ur','',0),(442484,12292,'sr','',0),(442485,12292,'vi','',0),(442486,12292,'af','',0),(442487,12292,'ro','',0),(442488,12292,'et','',0),(442489,12292,'si','',0),(442490,12292,'ba','',0),(442491,12292,'nl','',0),(442492,12292,'fi','',0),(442493,12292,'no','',0),(442494,12292,'da','',0),(442495,12292,'ko','',0),(442496,12292,'he','',0),(442497,12292,'el','',0),(442498,12292,'zh','',0),(442499,12292,'sv','',0),(442500,12292,'it','',0),(442501,12292,'tl','',0),(442502,12292,'th','',0),(442503,12292,'hi','',0),(442504,12292,'ms','',0),(442505,12292,'ar','',0),(442506,12292,'fr','',0),(442507,12292,'jp','',0),(442508,12292,'pt','',0),(442509,12292,'ru','',0),(442510,12292,'es','',0),(442511,12292,'de','',0),(442512,12292,'en','',0),(442513,12293,'is','',0),(442514,12293,'dr','',0),(442515,12293,'pr','',0),(442516,12293,'tr','',0),(442517,12293,'pl','',0),(442518,12293,'bg','',0),(442519,12293,'ur','',0),(442520,12293,'sr','',0),(442521,12293,'vi','',0),(442522,12293,'af','',0),(442523,12293,'ro','',0),(442524,12293,'et','',0),(442525,12293,'si','',0),(442526,12293,'ba','',0),(442527,12293,'nl','',0),(442528,12293,'fi','',0),(442529,12293,'no','',0),(442530,12293,'da','',0),(442531,12293,'ko','',0),(442532,12293,'he','',0),(442533,12293,'el','',0),(442534,12293,'zh','',0),(442535,12293,'sv','',0),(442536,12293,'it','',0),(442537,12293,'tl','',0),(442538,12293,'th','',0),(442539,12293,'hi','',0),(442540,12293,'ms','',0),(442541,12293,'ar','',0),(442542,12293,'fr','',0),(442543,12293,'jp','',0),(442544,12293,'pt','',0),(442545,12293,'ru','',0),(442546,12293,'es','',0),(442547,12293,'de','',0),(442548,12293,'en','',0),(442549,12294,'is','',0),(442550,12294,'dr','',0),(442551,12294,'pr','',0),(442552,12294,'tr','',0),(442553,12294,'pl','',0),(442554,12294,'bg','',0),(442555,12294,'ur','',0),(442556,12294,'sr','',0),(442557,12294,'vi','',0),(442558,12294,'af','',0),(442559,12294,'ro','',0),(442560,12294,'et','',0),(442561,12294,'si','',0),(442562,12294,'ba','',0),(442563,12294,'nl','',0),(442564,12294,'fi','',0),(442565,12294,'no','',0),(442566,12294,'da','',0),(442567,12294,'ko','',0),(442568,12294,'he','',0),(442569,12294,'el','',0),(442570,12294,'zh','',0),(442571,12294,'sv','',0),(442572,12294,'it','',0),(442573,12294,'tl','',0),(442574,12294,'th','',0),(442575,12294,'hi','',0),(442576,12294,'ms','',0),(442577,12294,'ar','',0),(442578,12294,'fr','',0),(442579,12294,'jp','',0),(442580,12294,'pt','',0),(442581,12294,'ru','',0),(442582,12294,'es','',0),(442583,12294,'de','',0),(442584,12294,'en','',0),(442585,12295,'is','',0),(442586,12295,'dr','',0),(442587,12295,'pr','',0),(442588,12295,'tr','',0),(442589,12295,'pl','',0),(442590,12295,'bg','',0),(442591,12295,'ur','',0),(442592,12295,'sr','',0),(442593,12295,'vi','',0),(442594,12295,'af','',0),(442595,12295,'ro','',0),(442596,12295,'et','',0),(442597,12295,'si','',0),(442598,12295,'ba','',0),(442599,12295,'nl','',0),(442600,12295,'fi','',0),(442601,12295,'no','',0),(442602,12295,'da','',0),(442603,12295,'ko','',0),(442604,12295,'he','',0),(442605,12295,'el','',0),(442606,12295,'zh','',0),(442607,12295,'sv','',0),(442608,12295,'it','',0),(442609,12295,'tl','',0),(442610,12295,'th','',0),(442611,12295,'hi','',0),(442612,12295,'ms','',0),(442613,12295,'ar','',0),(442614,12295,'fr','',0),(442615,12295,'jp','',0),(442616,12295,'pt','',0),(442617,12295,'ru','',0),(442618,12295,'es','',0),(442619,12295,'de','',0),(442620,12295,'en','',0),(442621,12296,'is','',0),(442622,12296,'dr','',0),(442623,12296,'pr','',0),(442624,12296,'tr','',0),(442625,12296,'pl','',0),(442626,12296,'bg','',0),(442627,12296,'ur','',0),(442628,12296,'sr','',0),(442629,12296,'vi','',0),(442630,12296,'af','',0),(442631,12296,'ro','',0),(442632,12296,'et','',0),(442633,12296,'si','',0),(442634,12296,'ba','',0),(442635,12296,'nl','',0),(442636,12296,'fi','',0),(442637,12296,'no','',0),(442638,12296,'da','',0),(442639,12296,'ko','',0),(442640,12296,'he','',0),(442641,12296,'el','',0),(442642,12296,'zh','',0),(442643,12296,'sv','',0),(442644,12296,'it','',0),(442645,12296,'tl','',0),(442646,12296,'th','',0),(442647,12296,'hi','',0),(442648,12296,'ms','',0),(442649,12296,'ar','',0),(442650,12296,'fr','',0),(442651,12296,'jp','',0),(442652,12296,'pt','',0),(442653,12296,'ru','',0),(442654,12296,'es','',0),(442655,12296,'de','',0),(442656,12296,'en','',0),(442657,12297,'is','',0),(442658,12297,'dr','',0),(442659,12297,'pr','',0),(442660,12297,'tr','',0),(442661,12297,'pl','',0),(442662,12297,'bg','',0),(442663,12297,'ur','',0),(442664,12297,'sr','',0),(442665,12297,'vi','',0),(442666,12297,'af','',0),(442667,12297,'ro','',0),(442668,12297,'et','',0),(442669,12297,'si','',0),(442670,12297,'ba','',0),(442671,12297,'nl','',0),(442672,12297,'fi','',0),(442673,12297,'no','',0),(442674,12297,'da','',0),(442675,12297,'ko','',0),(442676,12297,'he','',0),(442677,12297,'el','',0),(442678,12297,'zh','',0),(442679,12297,'sv','',0),(442680,12297,'it','',0),(442681,12297,'tl','',0),(442682,12297,'th','',0),(442683,12297,'hi','',0),(442684,12297,'ms','',0),(442685,12297,'ar','',0),(442686,12297,'fr','',0),(442687,12297,'jp','',0),(442688,12297,'pt','',0),(442689,12297,'ru','',0),(442690,12297,'es','',0),(442691,12297,'de','',0),(442692,12297,'en','',0),(442693,12298,'is','',0),(442694,12298,'dr','.Ú¯Ø²Ø§Ø±Ø´Ø§Øª-ØªÙ…Ø§Ø³Ù‡Ø§-Ù„ÛŒØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†/ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§',0),(442695,12298,'pr','ÛŒÚ© Ù„ÛŒØ³Øª Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ø§ Ø¯Ù†Ø¨Ø§Ù„ Ú©Ø±Ø¯Ù† Ù…Ø³ÛŒØ± Ø²ÛŒØ± Ù‚Ø§Ø¨Ù„ Ù†Ù…Ø§ÛŒØ´ Ø§Ø³Øª.Ú¯Ø²Ø§Ø±Ø´Ø§Øª-ØªÙ…Ø§Ø³Ù‡Ø§-Ù„ÛŒØ³Øª ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†/ Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§',0),(442696,12298,'tr','SatÄ±cÄ±larÄ±n listesini giderek gÃ¶rÃ¼ntÃ¼lenebilir:<p><b>Ä°lgili kiÅŸileri satÄ±cÄ± listeler/etiketleri->-> raporlar</b>',0),(442697,12298,'pl','Wykaz dostawcÃ³w mogÄ… byÄ‡ wyÅ›wietlane przy zamierzaÃ¦:<p><b>Raporty-> kontakty-> dostawcy list/etykiety</b>',0),(442698,12298,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚ ÐºÐ°Ñ‚Ð¾ Ð¾Ñ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð°:<p><b>Ð”Ð¾ÐºÐ»Ð°Ð´Ð¸-> ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸-> Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ¿Ð¸ÑÑŠÑ†Ð¸/ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸</b>',0),(442699,12298,'ur','Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©ÛŒ ÙÛØ±Ø³Øª Ú©ÛŒ Ø·Ø±Ù Ø¬Ø§ØªÛ’ ÛÙˆØ¦Û’ Ù†ÛÛŒÚº Ø¯Ú©Ú¾Ø§ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ ÛÛ’:<p><b>Ø±ÙˆØ§Ø¨Ø· ÙˆÛŒÙ†ÚˆØ± ÙÛØ±Ø³ØªÛŒÚº/Ù„ÛŒØ¨Ù„->-> Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹</b>',0),(442700,12298,'sr','Ð›Ð¸ÑÑ‚Ñƒ ÑÐ²Ð¸Ñ… Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ñ‚Ð°ÐºÐ¾ ÑˆÑ‚Ð¾ Ñ›ÐµÑ‚Ðµ Ð¿Ð¾ÑÐµÑ‚Ð¸Ñ‚Ð¸:<p><b>Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸ Ð¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸ Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð»Ð¸ÑÑ‚Ðµ/Ð¾Ð·Ð½Ð°ÐºÐµ</b>',0),(442701,12298,'vi','1 danh sÃ¡ch cÃ¡c nhÃ  cung cáº¥p cÃ³ thá»ƒ Ä‘Æ°á»£c thá»ƒ hiá»‡n báº±ng cÃ¡ch: bÃ¡o cÃ¡o-> Ä‘áº¡i chá»‰ liÃªn láº¡c->danh sÃ¡ch mÃ  cung cáº¥p',0),(442702,12298,'af','\'N lys van verskaffers kan deur gaan vertoon word:<p><b>Verslae-> kontakte-> verkoper lyste/etikette</b>',0),(442703,12298,'ro','O listÄƒ de furnizori pot fi afiÅŸate de cÄƒtre mergi la:<p><b>Rapoarte-> contacte-> furnizor liste/Etichete</b>',0),(442704,12298,'et','Hankijate loendi kuvamiseks lÃ¤heb:<p><b>Aruannete-> kontakte-> hankija loendid/Sildid</b>',0),(442705,12298,'si','Jo boÅ¡ lahko prikaÅ¾e seznam prodajalcev:<p><b>PoroÄila-> stiki-> prodajalec sezname/nalepke</b>',0),(442706,12298,'ba','Daftar vendor dapat ditampilkan dengan pergi ke:<p><b>Laporan-> kontak-> Penjual daftar/label</b>',0),(442707,12298,'nl','Een lijst met leveranciers kan worden weergegeven door te gaan naar:<p><b>Rapporten-> contacten-> leverancier lijsten/etiketten</b>',0),(442708,12298,'fi','Toimittajien luettelo voidaan nÃ¤yttÃ¤Ã¤ menemÃ¤llÃ¤:<p><b>Raporttien-> yhteystiedot-> toimittajan luettelot ja merkinnÃ¤t</b>',0),(442709,12298,'no','En liste over leverandÃ¸rer kan vises ved Ã¥ gÃ¥ til:<p><b>Rapporter-> kontakter-> leverandÃ¸ren lister/etiketter</b>',0),(442710,12298,'da','En liste over kreditorer kan blive vist ved at gÃ¥ til:<p><b>Rapporter-> kontakter-> kreditor lister/etiketter</b>',0),(442711,12298,'ko','ê³µê¸‰ ì—…ì²´ì˜ ëª©ë¡ì€ ì´ë™ í•˜ ì—¬ í‘œì‹œí•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p><b>ì—°ë½ì²˜ ê³µê¸‰ ì—…ì²´ ëª©ë¡/ë ˆì´ë¸”->-> ë³´ê³ ì„œ</b>',0),(442712,12298,'he','× ×™×ª×Ÿ ×œ×”×¦×™×’ ×¨×©×™×ž×” ×©×œ ×¡×¤×§×™ ×©×™×¨×•×ª×™× ×¢×œ ×™×“×™ ×”×•×œ×š:<p><b>×“×•×—×•×ª-> ×× ×©×™ ×§×©×¨-> ×¡×¤×§ ×¨×©×™×ž×•×ª/×ª×•×•×™×•×ª</b>',0),(442713,12298,'el','ÎœÎ¹Î± Î»Î¯ÏƒÏ„Î± Ï€Ï‰Î»Î·Ï„Î­Ï‚ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„Î¿ÏÎ½ Î¼Îµ Ï„Î· Î¼ÎµÏ„Î¬Î²Î±ÏƒÎ·:<p><b>Î•ÎºÎ¸Î­ÏƒÎµÎ¹Ï‚-> ÎµÏ€Î±Ï†Î­Ï‚-> Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î»Î¯ÏƒÏ„ÎµÏ‚/Î•Ï„Î¹ÎºÎ­Ï„ÎµÏ‚</b>',0),(442714,12298,'zh','ä¸€ä¸ªä¾›åº”å•†åˆ—è¡¨å¯ä»¥é€šè¿‡ä»¥ä¸‹æ–¹å¼æ˜¾ç¤ºï¼šæŠ¥å‘Š->è”ç³»->ä¾›åº”å•†åˆ—è¡¨/æ ‡ç­¾',0),(442715,12298,'sv','En lista Ã¶ver leverantÃ¶rer kan visas genom att gÃ¥ till:<p><b>Rapporter-> kontakter-> leverantÃ¶r listor/etiketter</b>',0),(442716,12298,'it','PuÃ² essere visualizzato un elenco di fornitori andando su:<p><b>Rapporti-> contatti-> Vendor List/etichette</b>',0),(442717,12298,'tl','',0),(442718,12298,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¹à¸ªà¸”à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹„à¸›à¸¢à¸±à¸‡:<p><b>à¸£à¸²à¸¢à¸‡à¸²à¸™->à¸•à¸´à¸”à¸•à¹ˆà¸­->à¸£à¸²à¸¢à¸à¸²à¸£à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢/à¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­</b>',0),(442719,12298,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥€ à¤à¤• à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾ à¤°à¤¹à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾:<p><b>à¤¸à¤‚à¤ªà¤°à¥à¤• à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤/à¤²à¥‡à¤¬à¤² à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤',0),(442720,12298,'ms','Senarai vendor boleh dipaparkan dengan pergi ke:<p><b>Laporan-> kenalan-> penjual senarai/label</b>',0),(442721,12298,'ar','ÙŠÙ…ÙƒÙ† Ø¹Ø±Ø¶ Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ† Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ø§Ù„Ø°Ù‡Ø§Ø¨ Ø¥Ù„Ù‰:<p><b>ØªÙ‚Ø§Ø±ÙŠØ±-> Ø§Ù„Ø§ØªØµØ§Ù„Ø§Øª-> Ø¨Ø§Ø¦Ø¹ Ù‚ÙˆØ§Ø¦Ù…/ØªØ³Ù…ÙŠØ§Øª</b>',0),(442722,12298,'fr','Liste des fournisseurs peut Ãªtre affichÃ©e en allant sur :<p><b>Rapports-> Contacts-> vendeur listes/Ã©tiquettes</b>',0),(442723,12298,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®ãƒªã‚¹ãƒˆã«è¡Œãã“ã¨ã«ã‚ˆã£ã¦è¡¨ç¤ºã§ãã¾ã™ã€‚<p><b>ãƒ™ãƒ³ãƒ€ãƒ¼ ãƒªã‚¹ãƒˆ/ãƒ©ãƒ™ãƒ«-> é€£çµ¡å…ˆ-> ãƒ¬ãƒãƒ¼ãƒˆ</b>',0),(442724,12298,'pt','Uma lista de fornecedores pode ser exibida por que:<p><b>RelatÃ³rios-> contatos-> fornecedor listas/rÃ³tulos</b>',0),(442725,12298,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ñ‹, Ð¿ÐµÑ€ÐµÐ¹Ð´Ñ Ð²:<p><b>Ð”Ð¾ÐºÐ»Ð°Ð´Ñ‹-> ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñ‹-> Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² ÑÐ¿Ð¸ÑÐºÐ¾Ð²/ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ¸</b>',0),(442726,12298,'es','Una lista de Proveedor se puede desplegar por ir a:<p><b>Informes -> Contactos -> Listas/Etiquetas de Proveedores</b>',0),(442727,12298,'de','Eine Liste von Anbietern kann angezeigt werden, indem Sie auf:<p><b>Berichte-> Kontakte-> Hersteller Listen/Etiketten</b>',0),(442728,12298,'en','A list of vendors can be displayed by going to:<p><b>Reports -> Contacts -> Vendor Lists/Labels</b>',0),(442729,12299,'is','',0),(442730,12299,'dr','',0),(442731,12299,'pr','',0),(442732,12299,'tr','',0),(442733,12299,'pl','',0),(442734,12299,'bg','',0),(442735,12299,'ur','',0),(442736,12299,'sr','',0),(442737,12299,'vi','',0),(442738,12299,'af','',0),(442739,12299,'ro','',0),(442740,12299,'et','',0),(442741,12299,'si','',0),(442742,12299,'ba','',0),(442743,12299,'nl','',0),(442744,12299,'fi','',0),(442745,12299,'no','',0),(442746,12299,'da','',0),(442747,12299,'ko','',0),(442748,12299,'he','',0),(442749,12299,'el','',0),(442750,12299,'zh','',0),(442751,12299,'sv','',0),(442752,12299,'it','',0),(442753,12299,'tl','',0),(442754,12299,'th','',0),(442755,12299,'hi','',0),(442756,12299,'ms','',0),(442757,12299,'ar','',0),(442758,12299,'fr','',0),(442759,12299,'jp','',0),(442760,12299,'pt','',0),(442761,12299,'ru','',0),(442762,12299,'es','',0),(442763,12299,'de','',0),(442764,12299,'en','',0),(442765,12300,'is','',0),(442766,12300,'dr','',0),(442767,12300,'pr','',0),(442768,12300,'tr','',0),(442769,12300,'pl','',0),(442770,12300,'bg','',0),(442771,12300,'ur','',0),(442772,12300,'sr','',0),(442773,12300,'vi','',0),(442774,12300,'af','',0),(442775,12300,'ro','',0),(442776,12300,'et','',0),(442777,12300,'si','',0),(442778,12300,'ba','',0),(442779,12300,'nl','',0),(442780,12300,'fi','',0),(442781,12300,'no','',0),(442782,12300,'da','',0),(442783,12300,'ko','',0),(442784,12300,'he','',0),(442785,12300,'el','',0),(442786,12300,'zh','',0),(442787,12300,'sv','',0),(442788,12300,'it','',0),(442789,12300,'tl','',0),(442790,12300,'th','',0),(442791,12300,'hi','',0),(442792,12300,'ms','',0),(442793,12300,'ar','',0),(442794,12300,'fr','',0),(442795,12300,'jp','',0),(442796,12300,'pt','',0),(442797,12300,'ru','',0),(442798,12300,'es','',0),(442799,12300,'de','',0),(442800,12300,'en','',0),(442801,12301,'is','',0),(442802,12301,'dr','',0),(442803,12301,'pr','',0),(442804,12301,'tr','',0),(442805,12301,'pl','',0),(442806,12301,'bg','',0),(442807,12301,'ur','',0),(442808,12301,'sr','',0),(442809,12301,'vi','',0),(442810,12301,'af','',0),(442811,12301,'ro','',0),(442812,12301,'et','',0),(442813,12301,'si','',0),(442814,12301,'ba','',0),(442815,12301,'nl','',0),(442816,12301,'fi','',0),(442817,12301,'no','',0),(442818,12301,'da','',0),(442819,12301,'ko','',0),(442820,12301,'he','',0),(442821,12301,'el','',0),(442822,12301,'zh','',0),(442823,12301,'sv','',0),(442824,12301,'it','',0),(442825,12301,'tl','',0),(442826,12301,'th','',0),(442827,12301,'hi','',0),(442828,12301,'ms','',0),(442829,12301,'ar','',0),(442830,12301,'fr','',0),(442831,12301,'jp','',0),(442832,12301,'pt','',0),(442833,12301,'ru','',0),(442834,12301,'es','',0),(442835,12301,'de','',0),(442836,12301,'en','',0),(442837,12302,'is','',0),(442838,12302,'dr','',0),(442839,12302,'pr','',0),(442840,12302,'tr','',0),(442841,12302,'pl','',0),(442842,12302,'bg','',0),(442843,12302,'ur','',0),(442844,12302,'sr','',0),(442845,12302,'vi','',0),(442846,12302,'af','',0),(442847,12302,'ro','',0),(442848,12302,'et','',0),(442849,12302,'si','',0),(442850,12302,'ba','',0),(442851,12302,'nl','',0),(442852,12302,'fi','',0),(442853,12302,'no','',0),(442854,12302,'da','',0),(442855,12302,'ko','',0),(442856,12302,'he','',0),(442857,12302,'el','',0),(442858,12302,'zh','',0),(442859,12302,'sv','',0),(442860,12302,'it','',0),(442861,12302,'tl','',0),(442862,12302,'th','',0),(442863,12302,'hi','',0),(442864,12302,'ms','',0),(442865,12302,'ar','',0),(442866,12302,'fr','',0),(442867,12302,'jp','',0),(442868,12302,'pt','',0),(442869,12302,'ru','',0),(442870,12302,'es','',0),(442871,12302,'de','',0),(442872,12302,'en','',0),(442873,12303,'is','',0),(442874,12303,'dr','',0),(442875,12303,'pr','',0),(442876,12303,'tr','',0),(442877,12303,'pl','',0),(442878,12303,'bg','',0),(442879,12303,'ur','',0),(442880,12303,'sr','',0),(442881,12303,'vi','',0),(442882,12303,'af','',0),(442883,12303,'ro','',0),(442884,12303,'et','',0),(442885,12303,'si','',0),(442886,12303,'ba','',0),(442887,12303,'nl','',0),(442888,12303,'fi','',0),(442889,12303,'no','',0),(442890,12303,'da','',0),(442891,12303,'ko','',0),(442892,12303,'he','',0),(442893,12303,'el','',0),(442894,12303,'zh','',0),(442895,12303,'sv','',0),(442896,12303,'it','',0),(442897,12303,'tl','',0),(442898,12303,'th','',0),(442899,12303,'hi','',0),(442900,12303,'ms','',0),(442901,12303,'ar','',0),(442902,12303,'fr','',0),(442903,12303,'jp','',0),(442904,12303,'pt','',0),(442905,12303,'ru','',0),(442906,12303,'es','',0),(442907,12303,'de','',0),(442908,12303,'en','',0),(442909,12304,'is','',0),(442910,12304,'dr','',0),(442911,12304,'pr','',0),(442912,12304,'tr','',0),(442913,12304,'pl','',0),(442914,12304,'bg','',0),(442915,12304,'ur','',0),(442916,12304,'sr','',0),(442917,12304,'vi','',0),(442918,12304,'af','',0),(442919,12304,'ro','',0),(442920,12304,'et','',0),(442921,12304,'si','',0),(442922,12304,'ba','',0),(442923,12304,'nl','',0),(442924,12304,'fi','',0),(442925,12304,'no','',0),(442926,12304,'da','',0),(442927,12304,'ko','',0),(442928,12304,'he','',0),(442929,12304,'el','',0),(442930,12304,'zh','',0),(442931,12304,'sv','',0),(442932,12304,'it','',0),(442933,12304,'tl','',0),(442934,12304,'th','',0),(442935,12304,'hi','',0),(442936,12304,'ms','',0),(442937,12304,'ar','',0),(442938,12304,'fr','',0),(442939,12304,'jp','',0),(442940,12304,'pt','',0),(442941,12304,'ru','',0),(442942,12304,'es','',0),(442943,12304,'de','',0),(442944,12304,'en','',0),(442945,12305,'is','',0),(442946,12305,'dr','',0),(442947,12305,'pr','',0),(442948,12305,'tr','',0),(442949,12305,'pl','',0),(442950,12305,'bg','',0),(442951,12305,'ur','',0),(442952,12305,'sr','',0),(442953,12305,'vi','',0),(442954,12305,'af','',0),(442955,12305,'ro','',0),(442956,12305,'et','',0),(442957,12305,'si','',0),(442958,12305,'ba','',0),(442959,12305,'nl','',0),(442960,12305,'fi','',0),(442961,12305,'no','',0),(442962,12305,'da','',0),(442963,12305,'ko','',0),(442964,12305,'he','',0),(442965,12305,'el','',0),(442966,12305,'zh','',0),(442967,12305,'sv','',0),(442968,12305,'it','',0),(442969,12305,'tl','',0),(442970,12305,'th','',0),(442971,12305,'hi','',0),(442972,12305,'ms','',0),(442973,12305,'ar','',0),(442974,12305,'fr','',0),(442975,12305,'jp','',0),(442976,12305,'pt','',0),(442977,12305,'ru','',0),(442978,12305,'es','',0),(442979,12305,'de','',0),(442980,12305,'en','',0),(442981,12306,'is','',0),(442982,12306,'dr','',0),(442983,12306,'pr','',0),(442984,12306,'tr','',0),(442985,12306,'pl','',0),(442986,12306,'bg','',0),(442987,12306,'ur','',0),(442988,12306,'sr','',0),(442989,12306,'vi','',0),(442990,12306,'af','',0),(442991,12306,'ro','',0),(442992,12306,'et','',0),(442993,12306,'si','',0),(442994,12306,'ba','',0),(442995,12306,'nl','',0),(442996,12306,'fi','',0),(442997,12306,'no','',0),(442998,12306,'da','',0),(442999,12306,'ko','',0),(443000,12306,'he','',0),(443001,12306,'el','',0),(443002,12306,'zh','',0),(443003,12306,'sv','',0),(443004,12306,'it','',0),(443005,12306,'tl','',0),(443006,12306,'th','',0),(443007,12306,'hi','',0),(443008,12306,'ms','',0),(443009,12306,'ar','',0),(443010,12306,'fr','',0),(443011,12306,'jp','',0),(443012,12306,'pt','',0),(443013,12306,'ru','',0),(443014,12306,'es','',0),(443015,12306,'de','',0),(443016,12306,'en','',0),(443017,12307,'is','',0),(443018,12307,'dr','',0),(443019,12307,'pr','',0),(443020,12307,'tr','',0),(443021,12307,'pl','',0),(443022,12307,'bg','',0),(443023,12307,'ur','',0),(443024,12307,'sr','',0),(443025,12307,'vi','',0),(443026,12307,'af','',0),(443027,12307,'ro','',0),(443028,12307,'et','',0),(443029,12307,'si','',0),(443030,12307,'ba','',0),(443031,12307,'nl','',0),(443032,12307,'fi','',0),(443033,12307,'no','',0),(443034,12307,'da','',0),(443035,12307,'ko','',0),(443036,12307,'he','',0),(443037,12307,'el','',0),(443038,12307,'zh','',0),(443039,12307,'sv','',0),(443040,12307,'it','',0),(443041,12307,'tl','',0),(443042,12307,'th','',0),(443043,12307,'hi','',0),(443044,12307,'ms','',0),(443045,12307,'ar','',0),(443046,12307,'fr','',0),(443047,12307,'jp','',0),(443048,12307,'pt','',0),(443049,12307,'ru','',0),(443050,12307,'es','',0),(443051,12307,'de','',0),(443052,12307,'en','',0),(443053,12308,'is','',0),(443054,12308,'dr','',0),(443055,12308,'pr','',0),(443056,12308,'tr','',0),(443057,12308,'pl','',0),(443058,12308,'bg','',0),(443059,12308,'ur','',0),(443060,12308,'sr','',0),(443061,12308,'vi','',0),(443062,12308,'af','',0),(443063,12308,'ro','',0),(443064,12308,'et','',0),(443065,12308,'si','',0),(443066,12308,'ba','',0),(443067,12308,'nl','',0),(443068,12308,'fi','',0),(443069,12308,'no','',0),(443070,12308,'da','',0),(443071,12308,'ko','',0),(443072,12308,'he','',0),(443073,12308,'el','',0),(443074,12308,'zh','',0),(443075,12308,'sv','',0),(443076,12308,'it','',0),(443077,12308,'tl','',0),(443078,12308,'th','',0),(443079,12308,'hi','',0),(443080,12308,'ms','',0),(443081,12308,'ar','',0),(443082,12308,'fr','',0),(443083,12308,'jp','',0),(443084,12308,'pt','',0),(443085,12308,'ru','',0),(443086,12308,'es','',0),(443087,12308,'de','',0),(443088,12308,'en','',0),(443089,12309,'is','',0),(443090,12309,'dr','',0),(443091,12309,'pr','',0),(443092,12309,'tr','',0),(443093,12309,'pl','',0),(443094,12309,'bg','',0),(443095,12309,'ur','',0),(443096,12309,'sr','',0),(443097,12309,'vi','',0),(443098,12309,'af','',0),(443099,12309,'ro','',0),(443100,12309,'et','',0),(443101,12309,'si','',0),(443102,12309,'ba','',0),(443103,12309,'nl','',0),(443104,12309,'fi','',0),(443105,12309,'no','',0),(443106,12309,'da','',0),(443107,12309,'ko','',0),(443108,12309,'he','',0),(443109,12309,'el','',0),(443110,12309,'zh','',0),(443111,12309,'sv','',0),(443112,12309,'it','',0),(443113,12309,'tl','',0),(443114,12309,'th','',0),(443115,12309,'hi','',0),(443116,12309,'ms','',0),(443117,12309,'ar','',0),(443118,12309,'fr','',0),(443119,12309,'jp','',0),(443120,12309,'pt','',0),(443121,12309,'ru','',0),(443122,12309,'es','',0),(443123,12309,'de','',0),(443124,12309,'en','',0),(443125,12310,'is','',0),(443126,12310,'dr','',0),(443127,12310,'pr','',0),(443128,12310,'tr','',0),(443129,12310,'pl','',0),(443130,12310,'bg','',0),(443131,12310,'ur','',0),(443132,12310,'sr','',0),(443133,12310,'vi','',0),(443134,12310,'af','',0),(443135,12310,'ro','',0),(443136,12310,'et','',0),(443137,12310,'si','',0),(443138,12310,'ba','',0),(443139,12310,'nl','',0),(443140,12310,'fi','',0),(443141,12310,'no','',0),(443142,12310,'da','',0),(443143,12310,'ko','',0),(443144,12310,'he','',0),(443145,12310,'el','',0),(443146,12310,'zh','',0),(443147,12310,'sv','',0),(443148,12310,'it','',0),(443149,12310,'tl','',0),(443150,12310,'th','',0),(443151,12310,'hi','',0),(443152,12310,'ms','',0),(443153,12310,'ar','',0),(443154,12310,'fr','',0),(443155,12310,'jp','',0),(443156,12310,'pt','',0),(443157,12310,'ru','',0),(443158,12310,'es','',0),(443159,12310,'de','',0),(443160,12310,'en','',0),(443161,12311,'is','',0),(443162,12311,'dr','',0),(443163,12311,'pr','',0),(443164,12311,'tr','',0),(443165,12311,'pl','',0),(443166,12311,'bg','',0),(443167,12311,'ur','',0),(443168,12311,'sr','',0),(443169,12311,'vi','',0),(443170,12311,'af','',0),(443171,12311,'ro','',0),(443172,12311,'et','',0),(443173,12311,'si','',0),(443174,12311,'ba','',0),(443175,12311,'nl','',0),(443176,12311,'fi','',0),(443177,12311,'no','',0),(443178,12311,'da','',0),(443179,12311,'ko','',0),(443180,12311,'he','',0),(443181,12311,'el','',0),(443182,12311,'zh','',0),(443183,12311,'sv','',0),(443184,12311,'it','',0),(443185,12311,'tl','',0),(443186,12311,'th','',0),(443187,12311,'hi','',0),(443188,12311,'ms','',0),(443189,12311,'ar','',0),(443190,12311,'fr','',0),(443191,12311,'jp','',0),(443192,12311,'pt','',0),(443193,12311,'ru','',0),(443194,12311,'es','',0),(443195,12311,'de','',0),(443196,12311,'en','',0),(443197,12312,'is','',0),(443198,12312,'dr','',0),(443199,12312,'pr','',0),(443200,12312,'tr','',0),(443201,12312,'pl','',0),(443202,12312,'bg','',0),(443203,12312,'ur','',0),(443204,12312,'sr','',0),(443205,12312,'vi','',0),(443206,12312,'af','',0),(443207,12312,'ro','',0),(443208,12312,'et','',0),(443209,12312,'si','',0),(443210,12312,'ba','',0),(443211,12312,'nl','',0),(443212,12312,'fi','',0),(443213,12312,'no','',0),(443214,12312,'da','',0),(443215,12312,'ko','',0),(443216,12312,'he','',0),(443217,12312,'el','',0),(443218,12312,'zh','',0),(443219,12312,'sv','',0),(443220,12312,'it','',0),(443221,12312,'tl','',0),(443222,12312,'th','',0),(443223,12312,'hi','',0),(443224,12312,'ms','',0),(443225,12312,'ar','',0),(443226,12312,'fr','',0),(443227,12312,'jp','',0),(443228,12312,'pt','',0),(443229,12312,'ru','',0),(443230,12312,'es','',0),(443231,12312,'de','',0),(443232,12312,'en','',0),(443233,12313,'is','',0),(443234,12313,'dr','',0),(443235,12313,'pr','',0),(443236,12313,'tr','',0),(443237,12313,'pl','',0),(443238,12313,'bg','',0),(443239,12313,'ur','',0),(443240,12313,'sr','',0),(443241,12313,'vi','',0),(443242,12313,'af','',0),(443243,12313,'ro','',0),(443244,12313,'et','',0),(443245,12313,'si','',0),(443246,12313,'ba','',0),(443247,12313,'nl','',0),(443248,12313,'fi','',0),(443249,12313,'no','',0),(443250,12313,'da','',0),(443251,12313,'ko','',0),(443252,12313,'he','',0),(443253,12313,'el','',0),(443254,12313,'zh','',0),(443255,12313,'sv','',0),(443256,12313,'it','',0),(443257,12313,'tl','',0),(443258,12313,'th','',0),(443259,12313,'hi','',0),(443260,12313,'ms','',0),(443261,12313,'ar','',0),(443262,12313,'fr','',0),(443263,12313,'jp','',0),(443264,12313,'pt','',0),(443265,12313,'ru','',0),(443266,12313,'es','',0),(443267,12313,'de','',0),(443268,12313,'en','',0),(443269,12314,'is','',0),(443270,12314,'dr','Ø¨Ø±Ø§ÛŒ ÛŒØ§Ø¯Ú¯ÛŒØ±ÛŒ Ù†Ø­ÙˆÙ‡ ÛŒ Ø¨Ù‡ Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±Ø§Ø² Ù…Ú©Ø§Ù† Ù‡Ø§ÛŒ Ù…Ø®ØªÙ„ÙØŒ Ø§ÛŒÙ† Ù„ÛŒÙ†Ú© Ø±Ø§ Ø¯Ù†Ø¨Ø§Ù„ Ú©Ù†ÛŒØ¯',0),(443271,12314,'pr','Ø¨Ø±Ø§ÛŒ ÛŒØ§Ø¯Ú¯ÛŒØ±ÛŒ Ù†Ø­ÙˆÙ‡ ÛŒ Ø¨Ù‡ Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±Ø§Ø² Ù…Ú©Ø§Ù† Ù‡Ø§ÛŒ Ù…Ø®ØªÙ„ÙØŒ Ø§ÛŒÙ† Ù„ÛŒÙ†Ú© Ø±Ø§ Ø¯Ù†Ø¨Ø§Ù„ Ú©Ù†ÛŒØ¯',0),(443272,12314,'tr','Senin NolaPro Ã§eÅŸitli konumlardan eriÅŸmek nasÄ±l Ã¶ÄŸrenmek iÃ§in bu baÄŸlantÄ±yÄ± izleyin.',0),(443273,12314,'pl','NauczyÄ‡ siÄ™ jak wobec dostÃªp twÃ³j NolaPro z rÃ³Å¼nych miejsc, nastÄ™powaÄ‡ po ten ogniwo.',0),(443274,12314,'bg','Ð—Ð° Ð´Ð° Ð½Ð°ÑƒÑ‡Ð¸Ñ‚Ðµ ÐºÐ°Ðº Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ð²Ð°ÑˆÐ°Ñ‚Ð° NolaPro Ð¾Ñ‚ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð¸ Ð¼ÐµÑÑ‚Ð°, ÑÐ»ÐµÐ´Ð²Ð°Ð¹Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð²Ñ€ÑŠÐ·ÐºÐ°.',0),(443275,12314,'ur','Ø¢Ù¾ Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ù…Ø®ØªÙ„Ù Ù…Ù‚Ø§Ù…Ø§Øª Ø³Û’ Ø±Ø³Ø§Ø¦ÛŒ Ú©Ø±Ù†Û’ Ú©Ø§ Ø·Ø±ÛŒÙ‚Û Ø³ÛŒÚ©Ú¾Ù†Û’ Ú©ÛŒÙ„Ø¦Û’ ÛŒÛ Ø±Ø¨Ø· Ú©ÛŒ Ù¾ÛŒØ±ÙˆÛŒ Ú©Ø±ÛŒÚº Û”',0),(443276,12314,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ ÑÐ°Ð·Ð½Ð°Ð»Ð¸ ÐºÐ°ÐºÐ¾ Ð´Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð¸Ð¼ Ñ‚Ð²Ð¾Ñ˜Ðµ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ ÑÐ° Ñ€Ð°Ð·Ð½Ð¸Ñ… Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°, Ð¿Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ Ð²ÐµÐ·Ñƒ.',0),(443277,12314,'vi','Äá»ƒ há»c cÃ¡ch truy cáº­p vÃ o Nalopro tá»« má»™t Ä‘á»‹a chá»‰ khÃ¡c, theo Ä‘Æ°á»ng dáº«n nÃ y',0),(443278,12314,'af','Om te leer hoe om toegang tot jou NolaPro uit verskeie plekke, volg hierdie skakel.',0),(443279,12314,'ro','Pentru a afla cum la spre accent al tÄƒu NolaPro la diferite locaÅ£ii, urmaÅ£i acest link.',0),(443280,12314,'et','Ã•ppida, kuidas pÃ¤Ã¤seda oma NolaPro erinevatest kohtadest, jÃ¤rgige seda linki.',0),(443281,12314,'si','ÄŒe Å¾elite izvedeti kako v postranski vaÅ¡ NolaPro iz razliÄnih lokacij, sledite tej povezavi.',0),(443282,12314,'ba','Untuk mempelajari cara untuk mengakses NolaPro Anda dari berbagai lokasi, ikuti link ini.',0),(443283,12314,'nl','Volg deze link om te leren hoe uw NolaPro toegang vanaf verschillende locaties.',0),(443284,12314,'fi','LisÃ¤tietoja kÃ¤yttÃ¤Ã¤ oman NolaPro eri paikoissa, seuraa tÃ¤tÃ¤ linkkiÃ¤.',0),(443285,12314,'no','For Ã¥ lÃ¦re Ã¥ fÃ¥ tilgang til din NolaPro fra forskjellige steder, FÃ¸lg denne linken.',0),(443286,12314,'da','For at lÃ¦re at fÃ¥ adgang til din NolaPro fra forskellige steder, FÃ¸lg dette link.',0),(443287,12314,'ko','ë‹¤ì–‘ í•œ ìœ„ì¹˜ì—ì„œ ë‹¹ì‹ ì˜ NolaPro ì•¡ì„¸ìŠ¤ í•˜ëŠ” ë°©ë²•ì„ ë°°ìš°ë ¤ë©´,ì´ ë§í¬ë¥¼ ë”°ë¥´ì‹­ì‹œì˜¤.',0),(443288,12314,'he','×›×“×™ ×œ×œ×ž×•×“ ×›×™×¦×“ ×œ×’×©×ª NolaPro ×©×œ×š ×ž×ž×§×•×ž×•×ª ×©×•× ×™×, ×‘×§×™×©×•×¨ ×–×”.',0),(443289,12314,'el','Î“Î¹Î± Î½Î± Î¼Î¬Î¸ÎµÏ„Îµ Ï€ÏŽÏ‚ Î½Î± Î±Ï€Î¿ÎºÏ„Î®ÏƒÎµÏ„Îµ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎ±Ï‚ NolaPro Î±Ï€ÏŒ Î´Î¹Î¬Ï†Î¿ÏÎµÏ‚ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚, Î±ÎºÎ¿Î»Î¿Ï…Î¸Î®ÏƒÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏÎ½Î´ÎµÏƒÎ¼Î¿.',0),(443290,12314,'zh','ä»Žå¤šä¸ªåœ°æ–¹å­¦ä¹ å¦‚ä½•è¿›å…¥æ‚¨çš„NolaProï¼Œè·Ÿéšhttp://www.nolapro.com/np_windows_internet.pdf\" target=\"_blankè¿™ä¸ªé“¾æŽ¥',0),(443291,12314,'sv','Om du vill veta hur till tilltrÃ¤de din NolaPro frÃ¥n olika platser, fÃ¶lj denna lÃ¤nk.',0),(443292,12314,'it','Per informazioni su come accedere a tuo NolaPro da varie localitÃ , seguire questo link.',0),(443293,12314,'tl','',0),(443294,12314,'th','à¹€à¸£à¸µà¸¢à¸™à¸£à¸¹à¹‰à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¸‚à¸­à¸‡à¸„à¸¸à¸“ NolaPro à¸ˆà¸²à¸à¸ªà¸–à¸²à¸™à¸•à¹ˆà¸²à¸‡ à¹† à¸•à¸²à¸¡à¸¥à¸´à¸‡à¸„à¹Œà¸™à¸µà¹‰',0),(443295,12314,'hi','à¤µà¤¿à¤­à¤¿à¤¨à¥à¤¨ à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤¸à¥‡ à¤…à¤ªà¤¨à¥‡ NolaPro à¤¤à¤• à¤ªà¤¹à¥à¤à¤šà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥ˆà¤¸à¥‡ à¤œà¤¾à¤¨à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤‡à¤¸ à¤²à¤¿à¤‚à¤• à¤•à¤¾ à¤…à¤¨à¥à¤¸à¤°à¤£ à¤•à¤°à¥‡à¤‚à¥¤',0),(443296,12314,'ms','Untuk mengetahui cara untuk mencapai NolaPro anda dari pelbagai lokasi, ikuti pautan ini.',0),(443297,12314,'ar','Ù„Ù…Ø¹Ø±ÙØ© ÙƒÙŠÙÙŠØ© Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù…Ù† Ù…ÙˆØ§Ù‚Ø¹ Ù…Ø®ØªÙ„ÙØ©ØŒ Ø§ØªØ¨Ø¹ Ù‡Ø°Ø§ Ø§Ù„Ø±Ø§Ø¨Ø·.',0),(443298,12314,'fr','Pour savoir comment accÃ©der Ã  votre NolaPro Ã  divers endroits, suivez ce lien.',0),(443299,12314,'jp','ã•ã¾ã–ã¾ãªå ´æ‰€ã‹ã‚‰ã‚ãªãŸã® NolaPro ã«ã‚¢ã‚¯ã‚»ã‚¹ã™ã‚‹æ–¹æ³•ã«ã¤ã„ã¦ã¯ã€ã“ã®ãƒªãƒ³ã‚¯ã«å¾“ã£ã¦ãã ã•ã„ã€‚',0),(443300,12314,'pt','Para saber como acessar seu NolaPro de vÃ¡rios locais, siga este link.',0),(443301,12314,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ ÑƒÐ·Ð½Ð°Ñ‚ÑŒ, ÐºÐ°Ðº Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð´Ð¾ÑÑ‚ÑƒÐ¿ Ðº Ð²Ð°ÑˆÐµÐ¹ NolaPro Ð¸Ð· Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ñ‹Ñ… Ð¼ÐµÑÑ‚, Ð¿Ð¾ ÑÑ‚Ð¾Ð¹ ÑÑÑ‹Ð»ÐºÐµ.',0),(443302,12314,'es','Para aprender como accesar su NolaPro de varias colocaciones, sigue este enlace.',0),(443303,12314,'de','Folgen Sie diesem Link, um weitere Informationen zum Zugriff auf Ihre Artikel aus verschiedenen Orten.',0),(443304,12314,'en','To learn how to access your NolaPro from various locations, follow this link.',0),(443305,12315,'is','',0),(443306,12315,'dr','',0),(443307,12315,'pr','',0),(443308,12315,'tr','',0),(443309,12315,'pl','',0),(443310,12315,'bg','',0),(443311,12315,'ur','',0),(443312,12315,'sr','',0),(443313,12315,'vi','',0),(443314,12315,'af','',0),(443315,12315,'ro','',0),(443316,12315,'et','',0),(443317,12315,'si','',0),(443318,12315,'ba','',0),(443319,12315,'nl','',0),(443320,12315,'fi','',0),(443321,12315,'no','',0),(443322,12315,'da','',0),(443323,12315,'ko','',0),(443324,12315,'he','',0),(443325,12315,'el','',0),(443326,12315,'zh','',0),(443327,12315,'sv','',0),(443328,12315,'it','',0),(443329,12315,'tl','',0),(443330,12315,'th','',0),(443331,12315,'hi','',0),(443332,12315,'ms','',0),(443333,12315,'ar','',0),(443334,12315,'fr','',0),(443335,12315,'jp','',0),(443336,12315,'pt','',0),(443337,12315,'ru','',0),(443338,12315,'es','',0),(443339,12315,'de','',0),(443340,12315,'en','',0),(443341,12316,'is','',0),(443342,12316,'dr','',0),(443343,12316,'pr','',0),(443344,12316,'tr','',0),(443345,12316,'pl','',0),(443346,12316,'bg','',0),(443347,12316,'ur','',0),(443348,12316,'sr','',0),(443349,12316,'vi','',0),(443350,12316,'af','',0),(443351,12316,'ro','',0),(443352,12316,'et','',0),(443353,12316,'si','',0),(443354,12316,'ba','',0),(443355,12316,'nl','',0),(443356,12316,'fi','',0),(443357,12316,'no','',0),(443358,12316,'da','',0),(443359,12316,'ko','',0),(443360,12316,'he','',0),(443361,12316,'el','',0),(443362,12316,'zh','',0),(443363,12316,'sv','',0),(443364,12316,'it','',0),(443365,12316,'tl','',0),(443366,12316,'th','',0),(443367,12316,'hi','',0),(443368,12316,'ms','',0),(443369,12316,'ar','',0),(443370,12316,'fr','',0),(443371,12316,'jp','',0),(443372,12316,'pt','',0),(443373,12316,'ru','',0),(443374,12316,'es','',0),(443375,12316,'de','',0),(443376,12316,'en','',0),(443377,12317,'is','',0),(443378,12317,'dr','',0),(443379,12317,'pr','',0),(443380,12317,'tr','',0),(443381,12317,'pl','',0),(443382,12317,'bg','',0),(443383,12317,'ur','',0),(443384,12317,'sr','',0),(443385,12317,'vi','',0),(443386,12317,'af','',0),(443387,12317,'ro','',0),(443388,12317,'et','',0),(443389,12317,'si','',0),(443390,12317,'ba','',0),(443391,12317,'nl','',0),(443392,12317,'fi','',0),(443393,12317,'no','',0),(443394,12317,'da','',0),(443395,12317,'ko','',0),(443396,12317,'he','',0),(443397,12317,'el','',0),(443398,12317,'zh','',0),(443399,12317,'sv','',0),(443400,12317,'it','',0),(443401,12317,'tl','',0),(443402,12317,'th','',0),(443403,12317,'hi','',0),(443404,12317,'ms','',0),(443405,12317,'ar','',0),(443406,12317,'fr','',0),(443407,12317,'jp','',0),(443408,12317,'pt','',0),(443409,12317,'ru','',0),(443410,12317,'es','',0),(443411,12317,'de','',0),(443412,12317,'en','',0),(443413,12318,'is','',0),(443414,12318,'dr','',0),(443415,12318,'pr','',0),(443416,12318,'tr','',0),(443417,12318,'pl','',0),(443418,12318,'bg','',0),(443419,12318,'ur','',0),(443420,12318,'sr','',0),(443421,12318,'vi','',0),(443422,12318,'af','',0),(443423,12318,'ro','',0),(443424,12318,'et','',0),(443425,12318,'si','',0),(443426,12318,'ba','',0),(443427,12318,'nl','',0),(443428,12318,'fi','',0),(443429,12318,'no','',0),(443430,12318,'da','',0),(443431,12318,'ko','',0),(443432,12318,'he','',0),(443433,12318,'el','',0),(443434,12318,'zh','',0),(443435,12318,'sv','',0),(443436,12318,'it','',0),(443437,12318,'tl','',0),(443438,12318,'th','',0),(443439,12318,'hi','',0),(443440,12318,'ms','',0),(443441,12318,'ar','',0),(443442,12318,'fr','',0),(443443,12318,'jp','',0),(443444,12318,'pt','',0),(443445,12318,'ru','',0),(443446,12318,'es','',0),(443447,12318,'de','',0),(443448,12318,'en','',0),(443449,12319,'is','',0),(443450,12319,'dr','',0),(443451,12319,'pr','',0),(443452,12319,'tr','',0),(443453,12319,'pl','',0),(443454,12319,'bg','',0),(443455,12319,'ur','',0),(443456,12319,'sr','',0),(443457,12319,'vi','',0),(443458,12319,'af','',0),(443459,12319,'ro','',0),(443460,12319,'et','',0),(443461,12319,'si','',0),(443462,12319,'ba','',0),(443463,12319,'nl','',0),(443464,12319,'fi','',0),(443465,12319,'no','',0),(443466,12319,'da','',0),(443467,12319,'ko','',0),(443468,12319,'he','',0),(443469,12319,'el','',0),(443470,12319,'zh','',0),(443471,12319,'sv','',0),(443472,12319,'it','',0),(443473,12319,'tl','',0),(443474,12319,'th','',0),(443475,12319,'hi','',0),(443476,12319,'ms','',0),(443477,12319,'ar','',0),(443478,12319,'fr','',0),(443479,12319,'jp','',0),(443480,12319,'pt','',0),(443481,12319,'ru','',0),(443482,12319,'es','',0),(443483,12319,'de','',0),(443484,12319,'en','',0),(443485,12320,'is','',0),(443486,12320,'dr','',0),(443487,12320,'pr','',0),(443488,12320,'tr','',0),(443489,12320,'pl','',0),(443490,12320,'bg','',0),(443491,12320,'ur','',0),(443492,12320,'sr','',0),(443493,12320,'vi','',0),(443494,12320,'af','',0),(443495,12320,'ro','',0),(443496,12320,'et','',0),(443497,12320,'si','',0),(443498,12320,'ba','',0),(443499,12320,'nl','',0),(443500,12320,'fi','',0),(443501,12320,'no','',0),(443502,12320,'da','',0),(443503,12320,'ko','',0),(443504,12320,'he','',0),(443505,12320,'el','',0),(443506,12320,'zh','',0),(443507,12320,'sv','',0),(443508,12320,'it','',0),(443509,12320,'tl','',0),(443510,12320,'th','',0),(443511,12320,'hi','',0),(443512,12320,'ms','',0),(443513,12320,'ar','',0),(443514,12320,'fr','',0),(443515,12320,'jp','',0),(443516,12320,'pt','',0),(443517,12320,'ru','',0),(443518,12320,'es','',0),(443519,12320,'de','',0),(443520,12320,'en','',0),(443521,12321,'is','',0),(443522,12321,'dr','',0),(443523,12321,'pr','',0),(443524,12321,'tr','',0),(443525,12321,'pl','',0),(443526,12321,'bg','',0),(443527,12321,'ur','',0),(443528,12321,'sr','',0),(443529,12321,'vi','',0),(443530,12321,'af','',0),(443531,12321,'ro','',0),(443532,12321,'et','',0),(443533,12321,'si','',0),(443534,12321,'ba','',0),(443535,12321,'nl','',0),(443536,12321,'fi','',0),(443537,12321,'no','',0),(443538,12321,'da','',0),(443539,12321,'ko','',0),(443540,12321,'he','',0),(443541,12321,'el','',0),(443542,12321,'zh','',0),(443543,12321,'sv','',0),(443544,12321,'it','',0),(443545,12321,'tl','',0),(443546,12321,'th','',0),(443547,12321,'hi','',0),(443548,12321,'ms','',0),(443549,12321,'ar','',0),(443550,12321,'fr','',0),(443551,12321,'jp','',0),(443552,12321,'pt','',0),(443553,12321,'ru','',0),(443554,12321,'es','',0),(443555,12321,'de','',0),(443556,12321,'en','',0),(443557,12322,'is','',0),(443558,12322,'dr','',0),(443559,12322,'pr','',0),(443560,12322,'tr','',0),(443561,12322,'pl','',0),(443562,12322,'bg','',0),(443563,12322,'ur','',0),(443564,12322,'sr','',0),(443565,12322,'vi','',0),(443566,12322,'af','',0),(443567,12322,'ro','',0),(443568,12322,'et','',0),(443569,12322,'si','',0),(443570,12322,'ba','',0),(443571,12322,'nl','',0),(443572,12322,'fi','',0),(443573,12322,'no','',0),(443574,12322,'da','',0),(443575,12322,'ko','',0),(443576,12322,'he','',0),(443577,12322,'el','',0),(443578,12322,'zh','',0),(443579,12322,'sv','',0),(443580,12322,'it','',0),(443581,12322,'tl','',0),(443582,12322,'th','',0),(443583,12322,'hi','',0),(443584,12322,'ms','',0),(443585,12322,'ar','',0),(443586,12322,'fr','',0),(443587,12322,'jp','',0),(443588,12322,'pt','',0),(443589,12322,'ru','',0),(443590,12322,'es','',0),(443591,12322,'de','',0),(443592,12322,'en','',0),(443593,12323,'is','',0),(443594,12323,'dr','',0),(443595,12323,'pr','',0),(443596,12323,'tr','',0),(443597,12323,'pl','',0),(443598,12323,'bg','',0),(443599,12323,'ur','',0),(443600,12323,'sr','',0),(443601,12323,'vi','',0),(443602,12323,'af','',0),(443603,12323,'ro','',0),(443604,12323,'et','',0),(443605,12323,'si','',0),(443606,12323,'ba','',0),(443607,12323,'nl','',0),(443608,12323,'fi','',0),(443609,12323,'no','',0),(443610,12323,'da','',0),(443611,12323,'ko','',0),(443612,12323,'he','',0),(443613,12323,'el','',0),(443614,12323,'zh','',0),(443615,12323,'sv','',0),(443616,12323,'it','',0),(443617,12323,'tl','',0),(443618,12323,'th','',0),(443619,12323,'hi','',0),(443620,12323,'ms','',0),(443621,12323,'ar','',0),(443622,12323,'fr','',0),(443623,12323,'jp','',0),(443624,12323,'pt','',0),(443625,12323,'ru','',0),(443626,12323,'es','',0),(443627,12323,'de','',0),(443628,12323,'en','',0),(443629,12324,'is','',0),(443630,12324,'dr','',0),(443631,12324,'pr','',0),(443632,12324,'tr','',0),(443633,12324,'pl','',0),(443634,12324,'bg','',0),(443635,12324,'ur','',0),(443636,12324,'sr','',0),(443637,12324,'vi','',0),(443638,12324,'af','',0),(443639,12324,'ro','',0),(443640,12324,'et','',0),(443641,12324,'si','',0),(443642,12324,'ba','',0),(443643,12324,'nl','',0),(443644,12324,'fi','',0),(443645,12324,'no','',0),(443646,12324,'da','',0),(443647,12324,'ko','',0),(443648,12324,'he','',0),(443649,12324,'el','',0),(443650,12324,'zh','',0),(443651,12324,'sv','',0),(443652,12324,'it','',0),(443653,12324,'tl','',0),(443654,12324,'th','',0),(443655,12324,'hi','',0),(443656,12324,'ms','',0),(443657,12324,'ar','',0),(443658,12324,'fr','',0),(443659,12324,'jp','',0),(443660,12324,'pt','',0),(443661,12324,'ru','',0),(443662,12324,'es','',0),(443663,12324,'de','',0),(443664,12324,'en','',0),(443665,12325,'is','',0),(443666,12325,'dr','',0),(443667,12325,'pr','',0),(443668,12325,'tr','',0),(443669,12325,'pl','',0),(443670,12325,'bg','',0),(443671,12325,'ur','',0),(443672,12325,'sr','',0),(443673,12325,'vi','',0),(443674,12325,'af','',0),(443675,12325,'ro','',0),(443676,12325,'et','',0),(443677,12325,'si','',0),(443678,12325,'ba','',0),(443679,12325,'nl','',0),(443680,12325,'fi','',0),(443681,12325,'no','',0),(443682,12325,'da','',0),(443683,12325,'ko','',0),(443684,12325,'he','',0),(443685,12325,'el','',0),(443686,12325,'zh','',0),(443687,12325,'sv','',0),(443688,12325,'it','',0),(443689,12325,'tl','',0),(443690,12325,'th','',0),(443691,12325,'hi','',0),(443692,12325,'ms','',0),(443693,12325,'ar','',0),(443694,12325,'fr','',0),(443695,12325,'jp','',0),(443696,12325,'pt','',0),(443697,12325,'ru','',0),(443698,12325,'es','',0),(443699,12325,'de','',0),(443700,12325,'en','',0),(443701,12326,'is','',0),(443702,12326,'dr','',0),(443703,12326,'pr','',0),(443704,12326,'tr','',0),(443705,12326,'pl','',0),(443706,12326,'bg','',0),(443707,12326,'ur','',0),(443708,12326,'sr','',0),(443709,12326,'vi','',0),(443710,12326,'af','',0),(443711,12326,'ro','',0),(443712,12326,'et','',0),(443713,12326,'si','',0),(443714,12326,'ba','',0),(443715,12326,'nl','',0),(443716,12326,'fi','',0),(443717,12326,'no','',0),(443718,12326,'da','',0),(443719,12326,'ko','',0),(443720,12326,'he','',0),(443721,12326,'el','',0),(443722,12326,'zh','',0),(443723,12326,'sv','',0),(443724,12326,'it','',0),(443725,12326,'tl','',0),(443726,12326,'th','',0),(443727,12326,'hi','',0),(443728,12326,'ms','',0),(443729,12326,'ar','',0),(443730,12326,'fr','',0),(443731,12326,'jp','',0),(443732,12326,'pt','',0),(443733,12326,'ru','',0),(443734,12326,'es','',0),(443735,12326,'de','',0),(443736,12326,'en','',0),(443737,12327,'is','',0),(443738,12327,'dr','',0),(443739,12327,'pr','',0),(443740,12327,'tr','',0),(443741,12327,'pl','',0),(443742,12327,'bg','',0),(443743,12327,'ur','',0),(443744,12327,'sr','',0),(443745,12327,'vi','',0),(443746,12327,'af','',0),(443747,12327,'ro','',0),(443748,12327,'et','',0),(443749,12327,'si','',0),(443750,12327,'ba','',0),(443751,12327,'nl','',0),(443752,12327,'fi','',0),(443753,12327,'no','',0),(443754,12327,'da','',0),(443755,12327,'ko','',0),(443756,12327,'he','',0),(443757,12327,'el','',0),(443758,12327,'zh','',0),(443759,12327,'sv','',0),(443760,12327,'it','',0),(443761,12327,'tl','',0),(443762,12327,'th','',0),(443763,12327,'hi','',0),(443764,12327,'ms','',0),(443765,12327,'ar','',0),(443766,12327,'fr','',0),(443767,12327,'jp','',0),(443768,12327,'pt','',0),(443769,12327,'ru','',0),(443770,12327,'es','',0),(443771,12327,'de','',0),(443772,12327,'en','',0),(443773,12328,'is','',0),(443774,12328,'dr','',0),(443775,12328,'pr','',0),(443776,12328,'tr','',0),(443777,12328,'pl','',0),(443778,12328,'bg','',0),(443779,12328,'ur','',0),(443780,12328,'sr','',0),(443781,12328,'vi','',0),(443782,12328,'af','',0),(443783,12328,'ro','',0),(443784,12328,'et','',0),(443785,12328,'si','',0),(443786,12328,'ba','',0),(443787,12328,'nl','',0),(443788,12328,'fi','',0),(443789,12328,'no','',0),(443790,12328,'da','',0),(443791,12328,'ko','',0),(443792,12328,'he','',0),(443793,12328,'el','',0),(443794,12328,'zh','',0),(443795,12328,'sv','',0),(443796,12328,'it','',0),(443797,12328,'tl','',0),(443798,12328,'th','',0),(443799,12328,'hi','',0),(443800,12328,'ms','',0),(443801,12328,'ar','',0),(443802,12328,'fr','',0),(443803,12328,'jp','',0),(443804,12328,'pt','',0),(443805,12328,'ru','',0),(443806,12328,'es','',0),(443807,12328,'de','',0),(443808,12328,'en','',0),(443809,12329,'is','',0),(443810,12329,'dr','',0),(443811,12329,'pr','',0),(443812,12329,'tr','',0),(443813,12329,'pl','',0),(443814,12329,'bg','',0),(443815,12329,'ur','',0),(443816,12329,'sr','',0),(443817,12329,'vi','',0),(443818,12329,'af','',0),(443819,12329,'ro','',0),(443820,12329,'et','',0),(443821,12329,'si','',0),(443822,12329,'ba','',0),(443823,12329,'nl','',0),(443824,12329,'fi','',0),(443825,12329,'no','',0),(443826,12329,'da','',0),(443827,12329,'ko','',0),(443828,12329,'he','',0),(443829,12329,'el','',0),(443830,12329,'zh','',0),(443831,12329,'sv','',0),(443832,12329,'it','',0),(443833,12329,'tl','',0),(443834,12329,'th','',0),(443835,12329,'hi','',0),(443836,12329,'ms','',0),(443837,12329,'ar','',0),(443838,12329,'fr','',0),(443839,12329,'jp','',0),(443840,12329,'pt','',0),(443841,12329,'ru','',0),(443842,12329,'es','',0),(443843,12329,'de','',0),(443844,12329,'en','',0),(443845,12330,'is','',0),(443846,12330,'dr','',0),(443847,12330,'pr','',0),(443848,12330,'tr','',0),(443849,12330,'pl','',0),(443850,12330,'bg','',0),(443851,12330,'ur','',0),(443852,12330,'sr','',0),(443853,12330,'vi','',0),(443854,12330,'af','',0),(443855,12330,'ro','',0),(443856,12330,'et','',0),(443857,12330,'si','',0),(443858,12330,'ba','',0),(443859,12330,'nl','',0),(443860,12330,'fi','',0),(443861,12330,'no','',0),(443862,12330,'da','',0),(443863,12330,'ko','',0),(443864,12330,'he','',0),(443865,12330,'el','',0),(443866,12330,'zh','',0),(443867,12330,'sv','',0),(443868,12330,'it','',0),(443869,12330,'tl','',0),(443870,12330,'th','',0),(443871,12330,'hi','',0),(443872,12330,'ms','',0),(443873,12330,'ar','',0),(443874,12330,'fr','',0),(443875,12330,'jp','',0),(443876,12330,'pt','',0),(443877,12330,'ru','',0),(443878,12330,'es','',0),(443879,12330,'de','',0),(443880,12330,'en','',0),(443881,12331,'is','',0),(443882,12331,'dr','',0),(443883,12331,'pr','',0),(443884,12331,'tr','',0),(443885,12331,'pl','',0),(443886,12331,'bg','',0),(443887,12331,'ur','',0),(443888,12331,'sr','',0),(443889,12331,'vi','',0),(443890,12331,'af','',0),(443891,12331,'ro','',0),(443892,12331,'et','',0),(443893,12331,'si','',0),(443894,12331,'ba','',0),(443895,12331,'nl','',0),(443896,12331,'fi','',0),(443897,12331,'no','',0),(443898,12331,'da','',0),(443899,12331,'ko','',0),(443900,12331,'he','',0),(443901,12331,'el','',0),(443902,12331,'zh','',0),(443903,12331,'sv','',0),(443904,12331,'it','',0),(443905,12331,'tl','',0),(443906,12331,'th','',0),(443907,12331,'hi','',0),(443908,12331,'ms','',0),(443909,12331,'ar','',0),(443910,12331,'fr','',0),(443911,12331,'jp','',0),(443912,12331,'pt','',0),(443913,12331,'ru','',0),(443914,12331,'es','',0),(443915,12331,'de','',0),(443916,12331,'en','',0),(443917,12332,'is','',0),(443918,12332,'dr','',0),(443919,12332,'pr','',0),(443920,12332,'tr','',0),(443921,12332,'pl','',0),(443922,12332,'bg','',0),(443923,12332,'ur','',0),(443924,12332,'sr','',0),(443925,12332,'vi','',0),(443926,12332,'af','',0),(443927,12332,'ro','',0),(443928,12332,'et','',0),(443929,12332,'si','',0),(443930,12332,'ba','',0),(443931,12332,'nl','',0),(443932,12332,'fi','',0),(443933,12332,'no','',0),(443934,12332,'da','',0),(443935,12332,'ko','',0),(443936,12332,'he','',0),(443937,12332,'el','',0),(443938,12332,'zh','',0),(443939,12332,'sv','',0),(443940,12332,'it','',0),(443941,12332,'tl','',0),(443942,12332,'th','',0),(443943,12332,'hi','',0),(443944,12332,'ms','',0),(443945,12332,'ar','',0),(443946,12332,'fr','',0),(443947,12332,'jp','',0),(443948,12332,'pt','',0),(443949,12332,'ru','',0),(443950,12332,'es','',0),(443951,12332,'de','',0),(443952,12332,'en','',0),(443953,12333,'is','',0),(443954,12333,'dr','',0),(443955,12333,'pr','',0),(443956,12333,'tr','',0),(443957,12333,'pl','',0),(443958,12333,'bg','',0),(443959,12333,'ur','',0),(443960,12333,'sr','',0),(443961,12333,'vi','',0),(443962,12333,'af','',0),(443963,12333,'ro','',0),(443964,12333,'et','',0),(443965,12333,'si','',0),(443966,12333,'ba','',0),(443967,12333,'nl','',0),(443968,12333,'fi','',0),(443969,12333,'no','',0),(443970,12333,'da','',0),(443971,12333,'ko','',0),(443972,12333,'he','',0),(443973,12333,'el','',0),(443974,12333,'zh','',0),(443975,12333,'sv','',0),(443976,12333,'it','',0),(443977,12333,'tl','',0),(443978,12333,'th','',0),(443979,12333,'hi','',0),(443980,12333,'ms','',0),(443981,12333,'ar','',0),(443982,12333,'fr','',0),(443983,12333,'jp','',0),(443984,12333,'pt','',0),(443985,12333,'ru','',0),(443986,12333,'es','',0),(443987,12333,'de','',0),(443988,12333,'en','',0),(443989,12334,'is','',0),(443990,12334,'dr','',0),(443991,12334,'pr','',0),(443992,12334,'tr','',0),(443993,12334,'pl','',0),(443994,12334,'bg','',0),(443995,12334,'ur','',0),(443996,12334,'sr','',0),(443997,12334,'vi','',0),(443998,12334,'af','',0),(443999,12334,'ro','',0),(444000,12334,'et','',0),(444001,12334,'si','',0),(444002,12334,'ba','',0),(444003,12334,'nl','',0),(444004,12334,'fi','',0),(444005,12334,'no','',0),(444006,12334,'da','',0),(444007,12334,'ko','',0),(444008,12334,'he','',0),(444009,12334,'el','',0),(444010,12334,'zh','',0),(444011,12334,'sv','',0),(444012,12334,'it','',0),(444013,12334,'tl','',0),(444014,12334,'th','',0),(444015,12334,'hi','',0),(444016,12334,'ms','',0),(444017,12334,'ar','',0),(444018,12334,'fr','',0),(444019,12334,'jp','',0),(444020,12334,'pt','',0),(444021,12334,'ru','',0),(444022,12334,'es','',0),(444023,12334,'de','',0),(444024,12334,'en','',0),(444025,12335,'is','',0),(444026,12335,'dr','',0),(444027,12335,'pr','',0),(444028,12335,'tr','',0),(444029,12335,'pl','',0),(444030,12335,'bg','',0),(444031,12335,'ur','',0),(444032,12335,'sr','',0),(444033,12335,'vi','',0),(444034,12335,'af','',0),(444035,12335,'ro','',0),(444036,12335,'et','',0),(444037,12335,'si','',0),(444038,12335,'ba','',0),(444039,12335,'nl','',0),(444040,12335,'fi','',0),(444041,12335,'no','',0),(444042,12335,'da','',0),(444043,12335,'ko','',0),(444044,12335,'he','',0),(444045,12335,'el','',0),(444046,12335,'zh','',0),(444047,12335,'sv','',0),(444048,12335,'it','',0),(444049,12335,'tl','',0),(444050,12335,'th','',0),(444051,12335,'hi','',0),(444052,12335,'ms','',0),(444053,12335,'ar','',0),(444054,12335,'fr','',0),(444055,12335,'jp','',0),(444056,12335,'pt','',0),(444057,12335,'ru','',0),(444058,12335,'es','',0),(444059,12335,'de','',0),(444060,12335,'en','',0),(444061,12336,'is','',0),(444062,12336,'dr',': 1Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ù‡Ù…Ù‡ Ø§Ù‚Ù„Ø§Ù… Ø¯Ø± ÙØ±Ù…Ø§ÛŒØ´ / Ø¨ÛŒØ¬Ú© Ùˆ ÛŒØ§2ØµÙˆØ±Øª Ø¬Ø¯Ø§Ú¯Ø§Ù†Ù‡ Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ù‡Ø± ÛŒÚ© Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ø¯Ø± Ø¨ÛŒØ¬Ú©/ ÙØ±Ù…Ø§ÛŒØ´ .Ù…Ø¯ÛŒØ±ÛŒØª -> Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ ->  ',0),(444063,12336,'pr','Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯: 1Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ù‡Ù…Ù‡ Ø§Ù‚Ù„Ø§Ù… Ø¯Ø± Ø³ÙØ§Ø±Ø´ / ÙØ§Ú©ØªÙˆØ± Ùˆ ÛŒØ§2ØµÙˆØ±Øª Ø¬Ø¯Ø§Ú¯Ø§Ù†Ù‡ Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ù‡Ø± ÛŒÚ© Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ø¯Ø± ÙØ§Ú©ØªÙˆØ±/ Ø³ÙØ§Ø±Ø´ .Ù…Ø¯ÛŒØ±ÛŒØª -> Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ ->  ',0),(444064,12336,'tr','ÅžunlarÄ± yapabilirsiniz:<p>(1) vergi dÃ¼zeni/fatura Ã¼zerinde tÃ¼m Ã¶ÄŸeleri veya<p>(2) ayrÄ± ayrÄ± her satÄ±r Ã¶ÄŸesi sipariÅŸ/fatura Ã¼zerinde vergi.<p><b>YÃ¶netici Kurulumu-Ã¶deme satÄ±ÅŸ vergilerinin genel satÄ±ÅŸ vergisi bilgi->->->.</b><p>BakÄ±n ve',0),(444065,12336,'pl','MoÅ¼na:<p>(1) podatku wszystkich elementÃ³w zamÃ³wienia/faktury lub<p>(2) indywidualnie podatku od kaÅ¼dej pozycji zamÃ³wienia/faktury.<p><b>Admin-> instalacji Billing-> podatku-> informacji na temat podatku od sprzedaÅ¼y.</b><p>Zaznacz lub usuÅ„ zaznacze',0),(444066,12336,'bg','ÐœÐ¾Ð¶ÐµÑˆ:<p>(1) Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð² ÐµÐ´Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°/Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð»Ð¸<p>(2) Ð¸Ð½Ð´Ð¸Ð²Ð¸Ð´ÑƒÐ°Ð»Ð½Ð¾ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð²ÑÐµÐºÐ¸ Ñ€ÐµÐ´ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°/Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°.<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ',0),(444067,12336,'ur','ØªÙ… Ú©Ø± Ø³Ú©ØªÛ’ ÛÙˆ:<p>(1) Ø§ÛŒÚ© ØªØ±ØªÛŒØ¨/Ø§Ù†ÙˆØ§Ø¦Ø³ Ù¾Ø± ØªÙ…Ø§Ù… Ø§Ø´ÛŒØ§ Ù¹ÛŒÚ©Ø³ ÛŒØ§<p>(2) Ø§Ù†ÙØ±Ø§Ø¯ÛŒ Ø·ÙˆØ± Ù¾Ø± ÛØ± Ù„Ø§Ø¦Ù† Ø´Û’ Ø§ÛŒÚ© ØªØ±ØªÛŒØ¨/Ø§Ù†ÙˆØ§Ø¦Ø³ Ù¾Ø± Ù¹ÛŒÚ©Ø³ Û”<p><b>Ø§ÛŒÚˆÙ…Ù† Ø³ÛŒÙ¹ Ø§Ù¾-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø³Û',0),(444068,12336,'sr','Ð¼Ð¾Ð¶ÐµÑˆ:<p>(1 ) Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° ÑÐ²Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸/Ð½Ð°Ð»Ð¾Ð³Ð° Ð¸Ð»Ð¸<p>(2 ) Ð¿Ð¾Ñ˜ÐµÐ´Ð¸Ð½Ð°Ñ‡Ð½Ð¾ Ð¿Ð¾Ñ€ÐµÐ·Ð° ÑÐ²Ð°ÐºÑƒ ÑÑ‚Ð°Ð²ÐºÑƒ Ñƒ Ð½Ð°Ð»Ð¾Ð³Ð°/Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ.<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ-Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¸',0),(444069,12336,'vi','báº¡n cÃ³ thá»ƒ : thuáº¿ táº¥t cáº£ cÃ¡c má»¥c hÃ ng trÃªn hÃ³a Ä‘Æ¡n/ Ä‘Æ¡n hÃ ng.Thuáº¿ cÃ¡ nhÃ¢n cho má»—i máº·t hÃ ng trÃªn tá»«ng hdon.Quáº£n lÃ½-thiáº¿t láº­p thanh toÃ¡n- thuáº¿ bÃ¡n hÃ ng-thÃ´ng tin thuáº¿ bÃ¡n hÃ ng. Kiá»ƒm tra hoáº·c khÃ´ng kiï¿',0),(444070,12336,'af','Jy kan:<p>(1) belasting alle items op \'n bestelling/faktuur of<p>(2) belasting individueel elke lyn-item op \'n bestelling/faktuur.<p><b>Admin-> opstel-fakturering-> verkope belastings-> algemene verkoopsbelasting Info.</b><p>Kontroleer of deseleketeer \'Ki',0),(444071,12336,'ro','poÅ£i:<p>(1) toate elementele de pe o comandÄƒ/FacturÄƒ fiscalÄƒ sau<p>(2) individual fiscale fiecare element de linie de pe facturÄƒ de ordine.<p><b>Admin-> Setup-facturare-> vÃ¢nzÄƒri impozitele-> taxei pe vÃ¢nzÄƒri generale Info.</b><p>BifaÅ£i sau debi',0),(444072,12336,'et','Sa saad:<p>(1) maksu kÃµigi kaupade tellimuse/arve vÃµi<p>(2) iseseisvalt tulumaks iga rea kauba tellimuse/arve.<p><b>Admin-> seadistuse-arved kÃ¤ibemaksu-> Ã¼ldist kÃ¤ibemaksu Info->.</b><p>MÃ¤rkige vÃµi tÃ¼histage \"Valige mis makse kohaldada kuni iga Ã¼',0),(444073,12336,'si','ti lahko:<p>(1) davÄni vse elemente na naroÄilo/raÄun ali<p>(2) individualno davÄno vsako postavko na naroÄilo/raÄun.<p><b>Admin-> Setup-zaraÄunavanje-> prometnega davka-> Info sploÅ¡ni prometni davek.</b><p>Potrdite ali poÄistite \"Izberite kateri',0),(444074,12336,'ba','Kamu bisa:<p>(1) pajak semua item pada faktur pesanan/atau<p>(2) secara individual pajak setiap item baris pada faktur pesanan /.<p><b>Admin-> Setup-penagihan-> pajak penjualan-> Info Umum pajak penjualan.</b><p>Centang atau Hapus \'Pilih yang pajak berlak',0),(444075,12336,'nl','U kunt:<p>(1) fiscale alle items op een Order of factuur of<p>(2) afzonderlijk belasting van elke orderregel op een Order of factuur.<p><b>Admin-> Setup-Billing-> belastingen op de verkoop-> algemene Sales Tax Info.</b><p>Controleren of schakel \'Die belas',0),(444076,12336,'fi','Voit:<p>(1) verotuksen kaikki nimikkeet tilauksen/laskun tai<p>(2) erikseen vero nimikerivien tilauksen/laskun.<p><b>Admin-> mÃ¤Ã¤ritettÃ¤vÃ¤ laskutus-> arvonlisÃ¤verot-> yleinen Info.</b><p>Valitse tai poista valinnat \"Valitse joka verot sovelletaan jott',0),(444077,12336,'no','du kan:<p>(1) skatt alle elementer pÃ¥ en bestilling/faktura eller<p>(2) individuelt skatt hvert linjeelement for en bestilling/faktura.<p><b>Admin-> Setup-fakturering-> merverdiavgift-> generell mva-informasjon.</b><p>Merke eller fjerne merkingen \'Velg s',0),(444078,12336,'da','Du kan:<p>(1) beskatte alle varer pÃ¥ en ordre eller faktura eller<p>(2) individuelt skat hvert linjeelement pÃ¥ en ordre eller faktura.<p><b>Admin-> Setup-fakturering-> moms-> generelle moms Info.</b><p>MarkÃ©r eller AfmarkÃ©r \'VÃ¦lg som skat anvender ti',0),(444079,12336,'ko','ë‹¹ì‹ ì€ í•  ìˆ˜ ìžˆì–´ìš”:<p>(1) ì„¸ê¸ˆ ì£¼ë¬¸ ë˜ëŠ” ì†¡ìž¥ì— ìžˆëŠ” ëª¨ë“  í•­ëª© ë˜ëŠ”<p>(2) ê°œë³„ì ìœ¼ë¡œ ì£¼ë¬¸/ì¸ë³´ì´ìŠ¤ì— ê° í’ˆëª© ì„¸ê¸ˆ.<p><b>ê´€ë¦¬ìž ì„¤ì¹˜-ê²°ì œ íŒë§¤ ì„¸ê¸ˆ ì¼ë°˜ íŒë§¤ ì„¸ê¸ˆ ì •ë³´->->->.</b><p>ì„ íƒ í•˜ê±°',0),(444080,12336,'he','××ª×” ×™×›×•×œ:<p>(1) ×›×œ ×”×¤×¨×™×˜×™× ×¢×œ ×”×–×ž× ×”/×—×©×‘×•× ×™×ª ×ž×¡ ××•<p>(2) ×‘× ×¤×¨×“ ×ž×¡ ×‘×›×œ ×¤×¨×™×˜ ×©×•×¨×” ×‘×—×©×‘×•× ×™×ª/×”×¡×“×¨.<p><b>Admin-> ×”×”×ª×§× ×”-×—×™×•×‘-> ×ž×¢ ×ž-> ×ž×™×“×¢ ×›×œ×œ×™ ×ž×¢ ×ž.</b><p>××• ×‘×˜×œ \'×‘×—',0),(444081,12336,'el','ÎœÏ€Î¿ÏÎµÎ¯Ï‚:<p>(1) Ï†ÏŒÏÎ¿Ï‚ ÏŒÎ»Î± Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏ„Î· ÏƒÎµÎ¹ÏÎ¬/Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î®<p>(2) Î±Ï„Î¿Î¼Î¹ÎºÎ¬ Ï†ÏŒÏÎ¿Ï… ÎºÎ¬Î¸Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÎµ Î¼Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±/Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿.<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬Ïƒ',0),(444082,12336,'zh','ä½ å¯ä»¥ï¼šï¼ˆ1ï¼‰å¯¹ä¸€ä¸ªè®¢å•/å‘ç¥¨ä¸Šçš„æ‰€æœ‰é¡¹ç›®å¾ç¨Žï¼›æˆ–è€…ï¼ˆ2ï¼‰å¯¹ä¸€ä¸ªè®¢å•/å‘ç¥¨ä¸Šçš„æ¯ä¸€è¡Œé¡¹ç›®ä¸ªåˆ«å¾ç¨Žã€‚ç®¡ç†->è®¾ç½®å…¥è´¦->é”€å”®ç¨Ž->æ™®é€šé”€å”®ç¨Žä¿¡æ¯ã€‚åœ¨â€œé€‰æ‹©å“ªä¸€ç§ç¨Žæ”¶åº”ç”¨åˆ°æ¯ä¸€è¡Œâ€ä¸Šæ‰“å‹¾æˆ',0),(444083,12336,'sv','Du kan:<p>(1) skatt alla artiklar pÃ¥ en Order/faktura eller<p>(2) individuellt skatt varje radelement pÃ¥ en Order/faktura.<p><b>Admin-> Setup-fakturering-> moms-> allmÃ¤nna moms information.</b><p>Markera eller avmarkera \"Markera som skatter gÃ¤ller att',0),(444084,12336,'it','Si puÃ²:<p>(1) imposta tutti gli elementi su un ordine o fattura o<p>(2) fiscale singolarmente ogni voce su un\'ordine o fattura.<p><b>Admin->-> IVA-> IVA generale Info Setup-fatturazione.</b><p>Selezionare o deselezionare \'Selezionare che le tasse si appl',0),(444085,12336,'tl','',0),(444086,12336,'th','à¸„à¸¸à¸“à¸ªà¸²à¸¡à¸²à¸£à¸–:<p>(1) à¸ à¸²à¸©à¸µà¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸šà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡/à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ à¸«à¸£à¸·à¸­<p>(2) à¹à¸•à¹ˆà¸¥à¸°à¸ à¸²à¸©à¸µà¹à¸•à¹ˆà¸¥à¸°à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡/à¹ƒà¸šà¹',0),(444087,12336,'hi','à¤¤à¥à¤®à¤¸à¥‡ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ:<p>(1) à¤¸à¤­à¥€ à¤†à¤‡à¤Ÿà¤® à¤à¤• à¤†à¤¦à¥‡à¤¶/à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¤° à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¯à¤¾<p>(2) à¤…à¤²à¤—-à¤…à¤²à¤— à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤•à¥à¤°à¤®/à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà',0),(444088,12336,'ms','awak boleh:<p>(1) cukai semua item pada invois/tempahan atau<p>(2) secara individu cukai setiap baris butiran pada invois/tempahan.<p><b>Admin-> persediaan-bil-> cukai jualan-> maklumat am cukai jualan.</b><p>Semak atau Buang tanda \'Pilih yang cukai diken',0),(444089,12336,'ar','ÙŠÙ…ÙƒÙ†Ùƒ:<p>(1) Ø¶Ø±ÙŠØ¨Ø© Ø¹Ù„Ù‰ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„Ù…Ø¯Ø±Ø¬Ø© Ø¹Ù„Ù‰ ÙØ§ØªÙˆØ±Ø© Ø£Ù…Ø± Ø£Ùˆ<p>(2) Ø¹Ù„Ù‰ Ø­Ø¯Ø© Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ ÙƒÙ„ Ø¨Ù†Ø¯ ÙÙŠ ÙØ§ØªÙˆØ±Ø© Ù†Ø¸Ø§Ù….<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø¨ÙŠ',0),(444090,12336,'fr','Vous pouvez:<p>(1) tous les Ã©lÃ©ments sur une commande ou une facture d\'impÃ´t ou<p>(2) l\'impÃ´t individuellement chaque Ã©lÃ©ment de ligne sur une commande/facture.<p><b>Admin-> Setup-facturation->-> Info gÃ©nÃ©ral taxe de vente, les Taxes de vente.</b>',0),(444091,12336,'jp','ã§ãã¾ã™ï¼š<p>1ï¼‰ æ³¨æ–‡/è«‹æ±‚æ›¸ã®ã™ã¹ã¦ã®é …ç›®ã®ç¨Žã¾ãŸã¯<p>(2) å€‹åˆ¥ã«å„æ³¨æ–‡/è«‹æ±‚æ›¸ã®å“ç›®ç¨Žã—ã¾ã™ã€‚<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è«‹æ±‚å£²ä¸Šç¨Žä¸€èˆ¬çš„ãªå£²ä¸Šç¨Žæƒ…å ±->->->.</b><p>ãƒã‚§ãƒƒã‚¯ã¾ãŸã¯ \'ãŒç¨Žé‡‘',0),(444092,12336,'pt','Ã‰ possÃ­vel:<p>(1) imposto sobre todos os itens em uma ordem/fatura ou<p>(2) impostos individualmente cada item de linha em uma ordem/fatura.<p><b>Admin-> Setup-faturamento-> impostos sobre vendas-> informaÃ§Ã£o geral imposto sobre vendas.</b><p>Marque o',0),(444093,12336,'ru','Ð’Ñ‹ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ:<p>(1) Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð²ÑÐµ Ð¿ÑƒÐ½ÐºÑ‚Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð°/ÑÑ‡ÐµÑ‚Ð° Ð¸Ð»Ð¸<p>(2) Ð¸Ð½Ð´Ð¸Ð²Ð¸Ð´ÑƒÐ°Ð»ÑŒÐ½Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð° ÐºÐ°Ð¶Ð´Ð¾Ð¹ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð°/ÑÑ‡ÐµÑ‚Ð°.<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²',0),(444094,12336,'es','Tu puedes:<p>(1) impone impuestos en todos los items en un Orden/Factura o <p>(2) individualmente imponer impuestos en cada linea item en un Orden/Factura.<p><b>Admin -> Configurar facturaciÃ³n -> Impuestos  Sobre Ventas -> Info Impuestos Sobre Ventas Gen',0),(444095,12336,'de','Sie kÃ¶nnen:<p>(1) steuern Sie alle Elemente auf einer Bestellung/Rechnung oder<p>(2) steuern Sie individuell jedes Zeilenelement auf einer Bestellung/Rechnung.<p><b>Admin-> Setup-Billing-> Mehrwertsteuer-> allgemeine Umsatzsteuer-Info.</b><p>Aktivieren S',0),(444096,12336,'en','You can:<p>(1) tax all items on an Order/Invoice or <p>(2) individually tax each line item on an Order/Invoice.<p><b>Admin -> Setup-Billing -> Sales Taxes -> General Sales Tax Info.</b><p> Check or uncheck \'Select Which Taxes Apply To Each Item\'.',0),(444097,12337,'is','',0),(444098,12337,'dr','',0),(444099,12337,'pr','',0),(444100,12337,'tr','',0),(444101,12337,'pl','',0),(444102,12337,'bg','',0),(444103,12337,'ur','',0),(444104,12337,'sr','',0),(444105,12337,'vi','',0),(444106,12337,'af','',0),(444107,12337,'ro','',0),(444108,12337,'et','',0),(444109,12337,'si','',0),(444110,12337,'ba','',0),(444111,12337,'nl','',0),(444112,12337,'fi','',0),(444113,12337,'no','',0),(444114,12337,'da','',0),(444115,12337,'ko','',0),(444116,12337,'he','',0),(444117,12337,'el','',0),(444118,12337,'zh','',0),(444119,12337,'sv','',0),(444120,12337,'it','',0),(444121,12337,'tl','',0),(444122,12337,'th','',0),(444123,12337,'hi','',0),(444124,12337,'ms','',0),(444125,12337,'ar','',0),(444126,12337,'fr','',0),(444127,12337,'jp','',0),(444128,12337,'pt','',0),(444129,12337,'ru','',0),(444130,12337,'es','',0),(444131,12337,'de','',0),(444132,12337,'en','',0),(444133,12338,'is','',0),(444134,12338,'dr','',0),(444135,12338,'pr','',0),(444136,12338,'tr','',0),(444137,12338,'pl','',0),(444138,12338,'bg','',0),(444139,12338,'ur','',0),(444140,12338,'sr','',0),(444141,12338,'vi','',0),(444142,12338,'af','',0),(444143,12338,'ro','',0),(444144,12338,'et','',0),(444145,12338,'si','',0),(444146,12338,'ba','',0),(444147,12338,'nl','',0),(444148,12338,'fi','',0),(444149,12338,'no','',0),(444150,12338,'da','',0),(444151,12338,'ko','',0),(444152,12338,'he','',0),(444153,12338,'el','',0),(444154,12338,'zh','',0),(444155,12338,'sv','',0),(444156,12338,'it','',0),(444157,12338,'tl','',0),(444158,12338,'th','',0),(444159,12338,'hi','',0),(444160,12338,'ms','',0),(444161,12338,'ar','',0),(444162,12338,'fr','',0),(444163,12338,'jp','',0),(444164,12338,'pt','',0),(444165,12338,'ru','',0),(444166,12338,'es','',0),(444167,12338,'de','',0),(444168,12338,'en','',0),(444169,12339,'is','',0),(444170,12339,'dr','',0),(444171,12339,'pr','',0),(444172,12339,'tr','',0),(444173,12339,'pl','',0),(444174,12339,'bg','',0),(444175,12339,'ur','',0),(444176,12339,'sr','',0),(444177,12339,'vi','',0),(444178,12339,'af','',0),(444179,12339,'ro','',0),(444180,12339,'et','',0),(444181,12339,'si','',0),(444182,12339,'ba','',0),(444183,12339,'nl','',0),(444184,12339,'fi','',0),(444185,12339,'no','',0),(444186,12339,'da','',0),(444187,12339,'ko','',0),(444188,12339,'he','',0),(444189,12339,'el','',0),(444190,12339,'zh','',0),(444191,12339,'sv','',0),(444192,12339,'it','',0),(444193,12339,'tl','',0),(444194,12339,'th','',0),(444195,12339,'hi','',0),(444196,12339,'ms','',0),(444197,12339,'ar','',0),(444198,12339,'fr','',0),(444199,12339,'jp','',0),(444200,12339,'pt','',0),(444201,12339,'ru','',0),(444202,12339,'es','',0),(444203,12339,'de','',0),(444204,12339,'en','',0),(444205,12340,'is','',0),(444206,12340,'dr','',0),(444207,12340,'pr','',0),(444208,12340,'tr','',0),(444209,12340,'pl','',0),(444210,12340,'bg','',0),(444211,12340,'ur','',0),(444212,12340,'sr','',0),(444213,12340,'vi','',0),(444214,12340,'af','',0),(444215,12340,'ro','',0),(444216,12340,'et','',0),(444217,12340,'si','',0),(444218,12340,'ba','',0),(444219,12340,'nl','',0),(444220,12340,'fi','',0),(444221,12340,'no','',0),(444222,12340,'da','',0),(444223,12340,'ko','',0),(444224,12340,'he','',0),(444225,12340,'el','',0),(444226,12340,'zh','',0),(444227,12340,'sv','',0),(444228,12340,'it','',0),(444229,12340,'tl','',0),(444230,12340,'th','',0),(444231,12340,'hi','',0),(444232,12340,'ms','',0),(444233,12340,'ar','',0),(444234,12340,'fr','',0),(444235,12340,'jp','',0),(444236,12340,'pt','',0),(444237,12340,'ru','',0),(444238,12340,'es','',0),(444239,12340,'de','',0),(444240,12340,'en','',0),(444241,12341,'is','',0),(444242,12341,'dr','',0),(444243,12341,'pr','',0),(444244,12341,'tr','',0),(444245,12341,'pl','',0),(444246,12341,'bg','',0),(444247,12341,'ur','',0),(444248,12341,'sr','',0),(444249,12341,'vi','',0),(444250,12341,'af','',0),(444251,12341,'ro','',0),(444252,12341,'et','',0),(444253,12341,'si','',0),(444254,12341,'ba','',0),(444255,12341,'nl','',0),(444256,12341,'fi','',0),(444257,12341,'no','',0),(444258,12341,'da','',0),(444259,12341,'ko','',0),(444260,12341,'he','',0),(444261,12341,'el','',0),(444262,12341,'zh','',0),(444263,12341,'sv','',0),(444264,12341,'it','',0),(444265,12341,'tl','',0),(444266,12341,'th','',0),(444267,12341,'hi','',0),(444268,12341,'ms','',0),(444269,12341,'ar','',0),(444270,12341,'fr','',0),(444271,12341,'jp','',0),(444272,12341,'pt','',0),(444273,12341,'ru','',0),(444274,12341,'es','',0),(444275,12341,'de','',0),(444276,12341,'en','',0),(444277,12342,'is','',0),(444278,12342,'dr','',0),(444279,12342,'pr','',0),(444280,12342,'tr','',0),(444281,12342,'pl','',0),(444282,12342,'bg','',0),(444283,12342,'ur','',0),(444284,12342,'sr','',0),(444285,12342,'vi','',0),(444286,12342,'af','',0),(444287,12342,'ro','',0),(444288,12342,'et','',0),(444289,12342,'si','',0),(444290,12342,'ba','',0),(444291,12342,'nl','',0),(444292,12342,'fi','',0),(444293,12342,'no','',0),(444294,12342,'da','',0),(444295,12342,'ko','',0),(444296,12342,'he','',0),(444297,12342,'el','',0),(444298,12342,'zh','',0),(444299,12342,'sv','',0),(444300,12342,'it','',0),(444301,12342,'tl','',0),(444302,12342,'th','',0),(444303,12342,'hi','',0),(444304,12342,'ms','',0),(444305,12342,'ar','',0),(444306,12342,'fr','',0),(444307,12342,'jp','',0),(444308,12342,'pt','',0),(444309,12342,'ru','',0),(444310,12342,'es','',0),(444311,12342,'de','',0),(444312,12342,'en','',0),(444313,12343,'is','',0),(444314,12343,'dr','',0),(444315,12343,'pr','',0),(444316,12343,'tr','',0),(444317,12343,'pl','',0),(444318,12343,'bg','',0),(444319,12343,'ur','',0),(444320,12343,'sr','',0),(444321,12343,'vi','',0),(444322,12343,'af','',0),(444323,12343,'ro','',0),(444324,12343,'et','',0),(444325,12343,'si','',0),(444326,12343,'ba','',0),(444327,12343,'nl','',0),(444328,12343,'fi','',0),(444329,12343,'no','',0),(444330,12343,'da','',0),(444331,12343,'ko','',0),(444332,12343,'he','',0),(444333,12343,'el','',0),(444334,12343,'zh','',0),(444335,12343,'sv','',0),(444336,12343,'it','',0),(444337,12343,'tl','',0),(444338,12343,'th','',0),(444339,12343,'hi','',0),(444340,12343,'ms','',0),(444341,12343,'ar','',0),(444342,12343,'fr','',0),(444343,12343,'jp','',0),(444344,12343,'pt','',0),(444345,12343,'ru','',0),(444346,12343,'es','',0),(444347,12343,'de','',0),(444348,12343,'en','',0),(444349,12344,'is','',0),(444350,12344,'dr','',0),(444351,12344,'pr','',0),(444352,12344,'tr','',0),(444353,12344,'pl','',0),(444354,12344,'bg','',0),(444355,12344,'ur','',0),(444356,12344,'sr','',0),(444357,12344,'vi','',0),(444358,12344,'af','',0),(444359,12344,'ro','',0),(444360,12344,'et','',0),(444361,12344,'si','',0),(444362,12344,'ba','',0),(444363,12344,'nl','',0),(444364,12344,'fi','',0),(444365,12344,'no','',0),(444366,12344,'da','',0),(444367,12344,'ko','',0),(444368,12344,'he','',0),(444369,12344,'el','',0),(444370,12344,'zh','',0),(444371,12344,'sv','',0),(444372,12344,'it','',0),(444373,12344,'tl','',0),(444374,12344,'th','',0),(444375,12344,'hi','',0),(444376,12344,'ms','',0),(444377,12344,'ar','',0),(444378,12344,'fr','',0),(444379,12344,'jp','',0),(444380,12344,'pt','',0),(444381,12344,'ru','',0),(444382,12344,'es','',0),(444383,12344,'de','',0),(444384,12344,'en','',0),(444385,12345,'is','',0),(444386,12345,'dr','',0),(444387,12345,'pr','',0),(444388,12345,'tr','',0),(444389,12345,'pl','',0),(444390,12345,'bg','',0),(444391,12345,'ur','',0),(444392,12345,'sr','',0),(444393,12345,'vi','',0),(444394,12345,'af','',0),(444395,12345,'ro','',0),(444396,12345,'et','',0),(444397,12345,'si','',0),(444398,12345,'ba','',0),(444399,12345,'nl','',0),(444400,12345,'fi','',0),(444401,12345,'no','',0),(444402,12345,'da','',0),(444403,12345,'ko','',0),(444404,12345,'he','',0),(444405,12345,'el','',0),(444406,12345,'zh','',0),(444407,12345,'sv','',0),(444408,12345,'it','',0),(444409,12345,'tl','',0),(444410,12345,'th','',0),(444411,12345,'hi','',0),(444412,12345,'ms','',0),(444413,12345,'ar','',0),(444414,12345,'fr','',0),(444415,12345,'jp','',0),(444416,12345,'pt','',0),(444417,12345,'ru','',0),(444418,12345,'es','',0),(444419,12345,'de','',0),(444420,12345,'en','',0),(444421,12346,'is','',0),(444422,12346,'dr','',0),(444423,12346,'pr','',0),(444424,12346,'tr','',0),(444425,12346,'pl','',0),(444426,12346,'bg','',0),(444427,12346,'ur','',0),(444428,12346,'sr','',0),(444429,12346,'vi','',0),(444430,12346,'af','',0),(444431,12346,'ro','',0),(444432,12346,'et','',0),(444433,12346,'si','',0),(444434,12346,'ba','',0),(444435,12346,'nl','',0),(444436,12346,'fi','',0),(444437,12346,'no','',0),(444438,12346,'da','',0),(444439,12346,'ko','',0),(444440,12346,'he','',0),(444441,12346,'el','',0),(444442,12346,'zh','',0),(444443,12346,'sv','',0),(444444,12346,'it','',0),(444445,12346,'tl','',0),(444446,12346,'th','',0),(444447,12346,'hi','',0),(444448,12346,'ms','',0),(444449,12346,'ar','',0),(444450,12346,'fr','',0),(444451,12346,'jp','',0),(444452,12346,'pt','',0),(444453,12346,'ru','',0),(444454,12346,'es','',0),(444455,12346,'de','',0),(444456,12346,'en','',0),(444457,12347,'is','',0),(444458,12347,'dr','',0),(444459,12347,'pr','',0),(444460,12347,'tr','',0),(444461,12347,'pl','',0),(444462,12347,'bg','',0),(444463,12347,'ur','',0),(444464,12347,'sr','',0),(444465,12347,'vi','',0),(444466,12347,'af','',0),(444467,12347,'ro','',0),(444468,12347,'et','',0),(444469,12347,'si','',0),(444470,12347,'ba','',0),(444471,12347,'nl','',0),(444472,12347,'fi','',0),(444473,12347,'no','',0),(444474,12347,'da','',0),(444475,12347,'ko','',0),(444476,12347,'he','',0),(444477,12347,'el','',0),(444478,12347,'zh','',0),(444479,12347,'sv','',0),(444480,12347,'it','',0),(444481,12347,'tl','',0),(444482,12347,'th','',0),(444483,12347,'hi','',0),(444484,12347,'ms','',0),(444485,12347,'ar','',0),(444486,12347,'fr','',0),(444487,12347,'jp','',0),(444488,12347,'pt','',0),(444489,12347,'ru','',0),(444490,12347,'es','',0),(444491,12347,'de','',0),(444492,12347,'en','',0),(444493,12348,'is','',0),(444494,12348,'dr','',0),(444495,12348,'pr','',0),(444496,12348,'tr','',0),(444497,12348,'pl','',0),(444498,12348,'bg','',0),(444499,12348,'ur','',0),(444500,12348,'sr','',0),(444501,12348,'vi','',0),(444502,12348,'af','',0),(444503,12348,'ro','',0),(444504,12348,'et','',0),(444505,12348,'si','',0),(444506,12348,'ba','',0),(444507,12348,'nl','',0),(444508,12348,'fi','',0),(444509,12348,'no','',0),(444510,12348,'da','',0),(444511,12348,'ko','',0),(444512,12348,'he','',0),(444513,12348,'el','',0),(444514,12348,'zh','',0),(444515,12348,'sv','',0),(444516,12348,'it','',0),(444517,12348,'tl','',0),(444518,12348,'th','',0),(444519,12348,'hi','',0),(444520,12348,'ms','',0),(444521,12348,'ar','',0),(444522,12348,'fr','',0),(444523,12348,'jp','',0),(444524,12348,'pt','',0),(444525,12348,'ru','',0),(444526,12348,'es','',0),(444527,12348,'de','',0),(444528,12348,'en','',0),(444529,12349,'is','',0),(444530,12349,'dr','',0),(444531,12349,'pr','',0),(444532,12349,'tr','',0),(444533,12349,'pl','',0),(444534,12349,'bg','',0),(444535,12349,'ur','',0),(444536,12349,'sr','',0),(444537,12349,'vi','',0),(444538,12349,'af','',0),(444539,12349,'ro','',0),(444540,12349,'et','',0),(444541,12349,'si','',0),(444542,12349,'ba','',0),(444543,12349,'nl','',0),(444544,12349,'fi','',0),(444545,12349,'no','',0),(444546,12349,'da','',0),(444547,12349,'ko','',0),(444548,12349,'he','',0),(444549,12349,'el','',0),(444550,12349,'zh','',0),(444551,12349,'sv','',0),(444552,12349,'it','',0),(444553,12349,'tl','',0),(444554,12349,'th','',0),(444555,12349,'hi','',0),(444556,12349,'ms','',0),(444557,12349,'ar','',0),(444558,12349,'fr','',0),(444559,12349,'jp','',0),(444560,12349,'pt','',0),(444561,12349,'ru','',0),(444562,12349,'es','',0),(444563,12349,'de','',0),(444564,12349,'en','',0),(444565,12350,'is','',0),(444566,12350,'dr','',0),(444567,12350,'pr','',0),(444568,12350,'tr','',0),(444569,12350,'pl','',0),(444570,12350,'bg','',0),(444571,12350,'ur','',0),(444572,12350,'sr','',0),(444573,12350,'vi','',0),(444574,12350,'af','',0),(444575,12350,'ro','',0),(444576,12350,'et','',0),(444577,12350,'si','',0),(444578,12350,'ba','',0),(444579,12350,'nl','',0),(444580,12350,'fi','',0),(444581,12350,'no','',0),(444582,12350,'da','',0),(444583,12350,'ko','',0),(444584,12350,'he','',0),(444585,12350,'el','',0),(444586,12350,'zh','',0),(444587,12350,'sv','',0),(444588,12350,'it','',0),(444589,12350,'tl','',0),(444590,12350,'th','',0),(444591,12350,'hi','',0),(444592,12350,'ms','',0),(444593,12350,'ar','',0),(444594,12350,'fr','',0),(444595,12350,'jp','',0),(444596,12350,'pt','',0),(444597,12350,'ru','',0),(444598,12350,'es','',0),(444599,12350,'de','',0),(444600,12350,'en','',0),(444601,12351,'is','',0),(444602,12351,'dr','',0),(444603,12351,'pr','',0),(444604,12351,'tr','',0),(444605,12351,'pl','',0),(444606,12351,'bg','',0),(444607,12351,'ur','',0),(444608,12351,'sr','',0),(444609,12351,'vi','',0),(444610,12351,'af','',0),(444611,12351,'ro','',0),(444612,12351,'et','',0),(444613,12351,'si','',0),(444614,12351,'ba','',0),(444615,12351,'nl','',0),(444616,12351,'fi','',0),(444617,12351,'no','',0),(444618,12351,'da','',0),(444619,12351,'ko','',0),(444620,12351,'he','',0),(444621,12351,'el','',0),(444622,12351,'zh','',0),(444623,12351,'sv','',0),(444624,12351,'it','',0),(444625,12351,'tl','',0),(444626,12351,'th','',0),(444627,12351,'hi','',0),(444628,12351,'ms','',0),(444629,12351,'ar','',0),(444630,12351,'fr','',0),(444631,12351,'jp','',0),(444632,12351,'pt','',0),(444633,12351,'ru','',0),(444634,12351,'es','',0),(444635,12351,'de','',0),(444636,12351,'en','',0),(444637,12352,'is','',0),(444638,12352,'dr','',0),(444639,12352,'pr','',0),(444640,12352,'tr','',0),(444641,12352,'pl','',0),(444642,12352,'bg','',0),(444643,12352,'ur','',0),(444644,12352,'sr','',0),(444645,12352,'vi','',0),(444646,12352,'af','',0),(444647,12352,'ro','',0),(444648,12352,'et','',0),(444649,12352,'si','',0),(444650,12352,'ba','',0),(444651,12352,'nl','',0),(444652,12352,'fi','',0),(444653,12352,'no','',0),(444654,12352,'da','',0),(444655,12352,'ko','',0),(444656,12352,'he','',0),(444657,12352,'el','',0),(444658,12352,'zh','',0),(444659,12352,'sv','',0),(444660,12352,'it','',0),(444661,12352,'tl','',0),(444662,12352,'th','',0),(444663,12352,'hi','',0),(444664,12352,'ms','',0),(444665,12352,'ar','',0),(444666,12352,'fr','',0),(444667,12352,'jp','',0),(444668,12352,'pt','',0),(444669,12352,'ru','',0),(444670,12352,'es','',0),(444671,12352,'de','',0),(444672,12352,'en','',0),(444673,12353,'is','',0),(444674,12353,'dr','Ø§Ú¯Ø± Ø´Ù…Ø§Ø¹Ø¨Ø§Ø±Øª \"Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ± Ø¨Ø§ Ù‡Ù… Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ù†Ø¯\" Ø±Ø§ Ø²Ù…Ø§Ù† Ø°Ø®ÛŒØ±Ù‡ ÛŒÚ© ÛŒÙˆØ²Ø± Ø¯Ø±ÛŒØ§ÙØª Ú©Ù†ÛŒØ¯ØŒ Ù…Ø±ÙˆØ±Ú¯Ø± Ø´Ù…Ø§ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ±Ø±Ø§ Ø®ÙˆØ¯Ú©Ø§Ø± Ø°Ø®ÛŒØ±Ù‡ Ú©Ù†Ø¯ØŒØ²Ù…Ø§Ù†ÛŒ Ú©Ù‡ ÛŒÚ©',0),(444675,12353,'pr','Ø§Ú¯Ø± Ø´Ù…Ø§Ø¹Ø¨Ø§Ø±Øª \"Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ± Ø¨Ø§ Ù‡Ù… Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ù†Ø¯\" Ø±Ø§ Ø²Ù…Ø§Ù† Ø°Ø®ÛŒØ±Ù‡ ÛŒÚ© Ú©Ø§Ø±Ø¨Ø± Ø¯Ø±ÛŒØ§ÙØª Ú©Ù†ÛŒØ¯ØŒ Ù…Ø±ÙˆØ±Ú¯Ø± Ø´Ù…Ø§ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ±Ø±Ø§ Ø®ÙˆØ¯Ú©Ø§Ø± Ø°Ø®ÛŒØ±Ù‡ Ú©Ù†Ø¯ØŒØ²Ù…Ø§Ù†ÛŒ Ú©Ù‡ ÛŒÚ©',0),(444676,12353,'tr','\"Parolalar eÅŸleÅŸmiyor\" alÄ±rsanÄ±z bir mÃ¼ÅŸteri kaydederken, tarayÄ±cÄ±nÄ±z otomatik kaydetme ÅŸifre olabilir.<p>DÃ¼zenlerken bir mÃ¼ÅŸteri parola alanlarÄ± temizleyin. Bu iletiyi ortadan kaldÄ±rmak gerekir.',0),(444677,12353,'pl','JeÅ›li otrzymasz \"HasÅ‚a nie pasujÄ…\" podczas zapisywania klienta, przeglÄ…darka moÅ¼e byÄ‡ automatyczne zapisywanie haseÅ‚.<p>Podczas edytowania klienta wyczyÅ›Ä‡ pola hasÅ‚o. To powinno wyeliminowaÄ‡ komunikat.',0),(444678,12353,'bg','ÐÐºÐ¾ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ \"ÐŸÐ°Ñ€Ð¾Ð»Ð¸Ñ‚Ðµ Ð½Ðµ ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‚\" Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚, Ð²Ð°ÑˆÐ¸ÑÑ‚ Ð±Ñ€Ð°ÑƒÐ·ÑŠÑ€ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð¸.<p>ÐšÐ¾Ð³Ð°Ñ‚Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ ÐºÐ»Ð¸Ðµ',0),(444679,12353,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ú©Ùˆ \"Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù†ÛÛŒÚº Ù…Ø´Ø§Ø¨Û\" Ù…ÙˆØµÙˆÙ„ Ø¬Ø¨ Ø§ÛŒÚ© Ú¯Ø§ÛÚ© Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø± Ø±ÛØ§ ÛÛ’ØŒ ØªÙˆ Ø¢Ù¾ Ú©Û’ Ø¨Ø±Ø§Ø¤Ø²Ø± Ø®ÙˆØ¯ Ù…Ø­ÙÙˆØ¸ Ù¾Ø§Ø³ ÙˆØ±Úˆ ÛÙˆ Û”<p>Ø¬Ø¨ Ø¢Ù¾ ØªØ¯ÙˆÛŒÙ† Ø§ÛŒÚ© Ú¯Ø§ÛÚ© Ú©Ùˆ ØµØ§Ù Ú©Ø±ÛŒÚº Ù¾Ø§Ø³ ',0),(444680,12353,'sr','ÐÐºÐ¾ Ð´Ð¾Ð±Ð¸Ñ˜ÐµÑ‚Ðµ \"Ð›Ð¾Ð·Ð¸Ð½ÐºÐµ ÑÐµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ\" Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ñ‡ÑƒÐ²Ð°ÑšÐ° ÐºÑƒÐ¿Ñ†Ð°, Ð²Ð°Ñˆ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‡ Ð¼Ð¾Ð¶Ð´Ð° Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ñ‡ÑƒÐ²Ð°ÑšÐµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ.<p>ÐšÐ°Ð´Ð° ÑƒÑ€ÐµÑ’ÑƒÑ˜ÐµÑ‚Ðµ ÐºÑƒÐ¿Ñ†Ð° Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð',0),(444681,12353,'vi','Náº¿u báº¡n nháº­n Ä‘Æ°á»£c\"máº­t kháº©u khÃ´ng khá»›p\" khi lÆ°u 1 khÃ¡ch hÃ ng. TrÃ¬nh duyá»‡t cá»§a báº¡n cÃ³ thá»ƒ tá»± Ä‘á»™ng lÆ°u máº­t kháº©u. Khi báº¡n sá»§a máº­t kháº©u 1 khÃ¡ch hÃ ng. Äiá»u nÃ y sáº½ loáº¡i bá» tin nháº¯n',0),(444682,12353,'af','As jy ontvang \"Wagwoorde stem nie ooreen nie\" wanneer stoor \'n kliÃ«nt, jou blaaier Outo-stoor wagwoorde kan wees.<p>Wanneer jy Redigeer \'n kliÃ«nt duidelik die wagwoord velde. Dit behoort die boodskap te elimineer.',0),(444683,12353,'ro','DacÄƒ primiÅ£i \"Parolele nu se potrivesc\" la salvarea unui client, browser-ul poate fi auto-salvarea parolelor.<p>CÃ¢nd editaÅ£i un client clar parolelor. Acest lucru ar trebui sÄƒ elimine mesajul.',0),(444684,12353,'et','Kui kuvatakse \"Paroolid ei kattu\" klient salvestamisel teie brauser vÃµib automaatne salvestamine paroole.<p>Kui redigeerite kliendile selge parool vÃ¤ljad. See tuleks kaotada sÃµnum.',0),(444685,12353,'si','ÄŒe prejmete \"Gesli se ne ujemata\" pri shranjevanju kupec, vaÅ¡ brskalnik lahko avto varÄevanja gesla.<p>Ko urejate kupcu poÄistite polji geslo. To mora odpraviti sporoÄilo.',0),(444686,12353,'ba','Jika Anda menerima \"Password tidak cocok\" ketika menyimpan pelanggan, peramban mungkin auto hemat password.<p>Ketika Anda mengedit pelanggan jelas bidang sandi. Ini harus menghilangkan pesan.',0),(444687,12353,'nl','Als het foutbericht \'Wachtwoorden komen niet overeen\' bij het opslaan van een klant, uw browser auto-besparing wachtwoorden kan worden.<p>Wanneer u een klant duidelijk de wachtwoordvelden bewerken. Dit moet een einde maken aan het bericht.',0),(444688,12353,'fi','Jos saat \"Edellinen\" Kun tallennat asiakas, selaimesi voi olla automaattinen tallennus salasanoja.<p>Kun muokkaat asiakkaaksi poistamalla salasana-kenttiin. TÃ¤mÃ¤n pitÃ¤isi poistaa viestin.',0),(444689,12353,'no','Hvis du fÃ¥r \"Passordene samsvarer ikke\" nÃ¥r du lagrer en kunde, nettleseren kan vÃ¦re automatisk lagrer passord.<p>NÃ¥r du redigerer en kunde fjerner feltene passord. Dette bÃ¸r fjerne meldingen.',0),(444690,12353,'da','Hvis fejlmeddelelsen \"Adgangskoderne er ikke ens\" nÃ¥r du gemmer en kunde, er din browser muligvis auto-gemmer adgangskoder.<p>NÃ¥r du redigerer en kunde rydde felterne adgangskode. Dette skulle fjerne beskeden.',0),(444691,12353,'ko','\"ì•”í˜¸\"ëŠ” ì¼ì¹˜ í•˜ì§€ ì•ŠëŠ” ê²½ìš° ê³ ê°ì„ ì €ìž¥í•  ë•Œ ë¸Œë¼ìš°ì € ìžë™ ì €ìž¥ ì•”í˜¸ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p>íŽ¸ì§‘ í•˜ë©´ ê³ ê°ì´ ì•”í˜¸ í•„ë“œ ì„ íƒì„ ì·¨ì†Œ í•©ë‹ˆë‹¤. ì´ ë©”ì‹œì§€ë¥¼ ì œê±° í•´ì•¼ í•©ë‹ˆë‹¤.',0),(444692,12353,'he','×× ××ª×” ×ž×§×‘×œ \"×”×¡×™×¡×ž××•×ª ××™× ×Ÿ ×ª×•××ž×•×ª\" ×‘×¢×ª ×©×ž×™×¨×ª ×œ×§×•×—, ×”×“×¤×“×¤×Ÿ ×©×œ×š ×¢×©×•×™ ×œ×”×™×•×ª ×¡×™×¡×ž××•×ª ××•×˜×•×ž×˜×™ ×œ×—×™×¡×›×•×Ÿ.<p>×‘×¢×ª ×¢×¨×™×›×ª ×œ×§×•×— × ×§×” ××ª ×©×“×•×ª ×¡×™×¡×ž×”. ×–×” ××ž×•×¨ ×œ×',0),(444693,12353,'el','Î•Î¬Î½ Î»Î¬Î²ÎµÏ„Îµ \"ÎšÏ‰Î´Î¹ÎºÎ¿Î¯ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½\" ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· ÎµÎ½ÏŒÏ‚ Ï€ÎµÎ»Î¬Ï„Î·, Ï„Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Ï€ÎµÏÎ¹Î®Î³Î·ÏƒÎ®Ï‚ ÏƒÎ±Ï‚ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Î±Ï€Î¿Î¸Î®ÎºÎ',0),(444694,12353,'zh','å¦‚æžœåœ¨ä¿å­˜ä¸€ä¸ªå®¢æˆ·æ—¶ï¼Œæ‚¨æ”¶åˆ°â€œå¯†ç ä¸åŒ¹é…â€æ¶ˆæ¯ï¼Œæ‚¨çš„æµè§ˆå™¨å¯èƒ½è‡ªåŠ¨ä¿å­˜äº†å¯†ç ã€‚å½“æ‚¨ç¼–è¾‘ä¸€ä¸ªå®¢æˆ·æ—¶ï¼Œè¯·æ¸…é™¤å¯†ç å­—æ®µã€‚è¿™ä¼šæ¶ˆé™¤è¯¥æ¶ˆæ¯ã€‚',0),(444695,12353,'sv','Om du fÃ¥r \"LÃ¶senorden matchar inte\" nÃ¤r du sparar en kund, din webblÃ¤sare kan vara auto-spara lÃ¶senord.<p>NÃ¤r du redigerar en tydlig kund lÃ¶senord fÃ¤lten. Detta bÃ¶r eliminera meddelandet.',0),(444696,12353,'it','Se viene visualizzato \"Le password non corrispondono\" durante il salvataggio di un cliente, il browser puÃ² essere il salvataggio automatico password.<p>Quando si modifica un cliente cancellare i campi password. Questo dovrebbe eliminare il messaggio.',0),(444697,12353,'tl','',0),(444698,12353,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¹„à¸”à¹‰à¸£à¸±à¸š \"à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸™\" à¹€à¸¡à¸·à¹ˆà¸­à¸šà¸±à¸™à¸—à¸¶à¸à¸¥à¸¹à¸à¸„à¹‰à¸² à¹€à¸šà¸£à¸²à¸§à¹Œà¹€à¸‹à¸­à¸£à¹Œà¸­à¸²à¸ˆà¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¸šà¸±à¸™à¸—à¸¶à¸à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à',0),(444699,12353,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ \"à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡à¥à¤¸ à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€à¤‚\" à¤†à¤ªà¤•à¥‡ à¤¬à¥à¤°à¤¾à¤‰à¤œà¤¼à¤° à¤‘à¤Ÿà¥‹-à¤¬à¤šà¤¤ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ à¤œà¤¬ à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥€ à¤¬à¤šà¤¤,',0),(444700,12353,'ms','Jika anda menerima \"Kata laluan tidak padan\" apabila simpanan pelanggan, pelayar web anda boleh auto menyelamatkan kata laluan.<p>Apabila anda mengedit pelanggan Kosongkan medan kata laluan. Ini harus menghapuskan mesej.',0),(444701,12353,'ar','Ø¥Ø°Ø§ ÙƒÙ†Øª ØªØªÙ„Ù‚Ù‰ \"Ù„Ø§ ØªØªØ·Ø§Ø¨Ù‚ ÙƒÙ„Ù…Ø§Øª Ø§Ù„Ù…Ø±ÙˆØ±\" Ø¹Ù†Ø¯ Ø­ÙØ¸ Ø£Ø­Ø¯ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ØŒ Ø§Ù„Ù…Ø³ØªØ¹Ø±Ø¶ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù‚Ø¯ ØªÙƒÙˆÙ† ÙƒÙ„Ù…Ø§Øª Ù…Ø±ÙˆØ± Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ø§Ù„Ù…Ù†Ù‚Ø°Ø©.<p>Ø¹Ù†Ø¯Ù…Ø§ ØªÙ‚ÙˆÙ… Ø¨ØªØ­Ø±ÙŠØ± Ø¹Ù…ÙŠÙ„ Ù…Ø³',0),(444702,12353,'fr','Si vous recevez des Â« Mots de passe ne correspondent pas Â» lors de l\'enregistrement d\'un client, votre navigateur peut Ãªtre des mots de passe de sauvegarde automatique.<p>Lorsque vous modifiez un client clairement les champs de mot de passe. Cela devra',0),(444703,12353,'jp','ã€Œãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ãŒä¸€è‡´ã—ã¾ã›ã‚“ã€ãŒè¡¨ç¤ºã•ã‚ŒãŸå ´åˆã€ãƒ–ãƒ©ã‚¦ã‚¶ãƒ¼ãŒè‡ªå‹•ä¿å­˜ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚ã‚Šã¾ã™é¡§å®¢ã‚’ä¿å­˜ã™ã‚‹ã¨ãã€‚<p>ç·¨é›†ã™ã‚‹ã¨ãã€é¡§å®¢ã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’ã‚¯ãƒªã‚¢ã—ã¾ã™ã€‚ã“ã‚Œã¯ã€',0),(444704,12353,'pt','Se vocÃª receber \"As senhas nÃ£o coincidem\" ao salvar um cliente, seu navegador pode ser senhas de salvamento automÃ¡tico.<p>Quando vocÃª edita um cliente limpar os campos de senha. Isso deve eliminar a mensagem.',0),(444705,12353,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡Ð°ÐµÑ‚Ðµ Â«ÐŸÐ°Ñ€Ð¾Ð»Ð¸ Ð½Ðµ ÑÐ¾Ð²Ð¿Ð°Ð´Ð°ÑŽÑ‚Â» Ð¿Ñ€Ð¸ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°, Ð²Ð°Ñˆ Ð±Ñ€Ð°ÑƒÐ·ÐµÑ€ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ ÐÐ²Ñ‚Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð¿Ð°Ñ€Ð¾Ð»ÐµÐ¹.<p>ÐŸÑ€Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¾Ñ‡Ð¸',0),(444706,12353,'es','Si recibe \"ContraseÃ±as no se emparejan\" cuando guarda un cliente su browser puede estar auto-guardando las contraseÃ±as. <p>Cuando edita un cliente limpia los campos de contraseÃ±as. Esta acciÃ³n debe eliminar el mensaje',0),(444707,12353,'de','Wenn Sie \"PasswÃ¶rter stimmen nicht Ã¼berein\" erhalten Ihr Browser mÃ¶glicherweise beim Kunden speichern, Auto-speichern KennwÃ¶rter.<p>Beim Bearbeiten ein Kunden deaktivieren Sie die Passwortfelder. Dies sollte die Meldung beseitigen.',0),(444708,12353,'en','If you receive \"Passwords do not match\" when saving a customer, your browser may be auto-saving passwords. <p>When you edit a customer clear the password fields. This should eliminate the message.',0),(444709,12354,'is','',0),(444710,12354,'dr',': Ù…Ø¯ÛŒØ±ÛŒØª-Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¬Ù†Ø³-Ø³Ø·ÙˆØ­ Ù‚ÛŒÙ…Øª ',0),(444711,12354,'pr','Ø¨Ø±Ø§ÛŒ Ø§ÛŒØ¬Ø§Ø¯ Ø³Ø·ÙˆØ­ Ù…Ø®ØªÙ„Ù Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ Ø¨Ø±Ø§ÛŒ Ø³Ù‡Ø§Ù… Ø®ÙˆØ¯Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯: Ù…Ø¯ÛŒØ±ÛŒØª-Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§-Ø³Ø·ÙˆØ­ Ù‚ÛŒÙ…Øª ',0),(444712,12354,'tr','FarklÄ± fiyatlandÄ±rma oluÅŸturmak iÃ§in senin stok dÃ¼zeylerini seÃ§in:<p><b>YÃ¶netici Kurulumu stok fiyat seviyeleri->-></b>',0),(444713,12354,'pl','Do tworzenia rÃ³Å¼nych poziomÃ³w cenowych twÃ³j czas SELECT:<p><b>Admin-> instalacji magazynowych-> poziomy cen</b>',0),(444714,12354,'bg','Ð—Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ð½Ð¸Ð²Ð° Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ ÑÐºÐ»Ð°Ð´ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÑÐºÐ»Ð°Ð´-> Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ð½Ð¸Ð²Ð°</b>',0),(444715,12354,'ur','Ù…Ø®ØªÙ„Ù Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¢Ù¾ Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ù„Ø¦Û’ Ú©ÛŒ Ø³Ø·Ø­ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº:<p><b>Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­->-> Ø§ÛŒÚˆÙ…Ù†</b>',0),(444716,12354,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð»Ð¸ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð¸Ñ‚Ðµ Ð½Ð¸Ð²Ð¾Ðµ Ð¾Ð´Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐ° Ñ†ÐµÐ½Ð° Ð·Ð° Ñ‚Ð²Ð¾Ñ˜Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¸ Ð½Ð¸Ð²Ð¾Ð¸Ð¼Ð° Ñ†ÐµÐ½Ð°</b>',0),(444717,12354,'vi','Äá»ƒ táº¡o ra cÃ¡c má»©c giÃ¡ khÃ¡c nhau cho hÃ ng tá»“n kho cá»§a báº¡n thÃ¬ chá»n : Quáº£n lÃ½-> Thiáº¿t láº­p hÃ ng tá»“n kho->giÃ¡',0),(444718,12354,'af','Kies om te skep verskillende pryse vir jou voorraad vlakke:<p><b>Admin-> opstelling voorraad-> prys vlakke</b>',0),(444719,12354,'ro','Pentru a crea preÅ£uri diferite niveluri pentru stocul de dumneavoastrÄƒ selectaÅ£i:<p><b>Admin-> Parametrizare stocuri-> nivelurile de preÅ£</b>',0),(444720,12354,'et','Luua erinevaid hinnakujunduse taset oma varude Select:<p><b>Admin-> Setup lao-> hinnatase</b>',0),(444721,12354,'si','ÄŒe Å¾elite ustvariti razliÄne cenovne stopnje za vaÅ¡ stock izberite:<p><b>Admin-> nastavitev zaloge-> ravni cen</b>',0),(444722,12354,'ba','Untuk membuat harga yang berbeda tingkat untuk saham Anda pilih:<p><b>Admin-> Setup persediaan-> tingkat harga</b>',0),(444723,12354,'nl','U maakt verschillende prijzen niveaus voor uw voorraad te selecteren:<p><b>Admin-> Setup voorraad-> prijsniveaus</b>',0),(444724,12354,'fi','Luoda eri hinnoittelu varastossa Valitse:<p><b>Admin-> asetukset varaston-> hintataso</b>',0),(444725,12354,'no','NivÃ¥er for din lager Velg for Ã¥ opprette forskjellige priser:<p><b>Admin-> installasjonsprogrammet lager-> prisnivÃ¥</b>',0),(444726,12354,'da','Til at oprette forskellige prisniveau for din stock VÃ¦lg:<p><b>Admin-> Setup lager-> prisniveau</b>',0),(444727,12354,'ko','ë‹¤ë¥¸ ê°€ê²© ìž¬ê³ ì— ëŒ€ í•œ ìˆ˜ì¤€ ì„ íƒ:<p><b>ê´€ë¦¬ìž ì„¤ì¹˜ ìž¬ê³  ê°€ê²© ìˆ˜ì¤€->-></b>',0),(444728,12354,'he','×›×“×™ ×œ×™×¦×•×¨ ×¨×ž×•×ª ×ª×ž×—×•×¨ ×©×•× ×•×ª ×¢×‘×•×¨ ×‘×—×™×¨×ª ×”×ž× ×™×•×ª ×©×œ×š:<p><b>Admin-> ×”×’×“×¨×ª ×ž×œ××™-> ×¨×ž×•×ª ×ž×—×™×¨</b>',0),(444729,12354,'el','Î“Î¹Î± Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÎ¬ ÎµÏ€Î¯Ï€ÎµÎ´Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Î³Î¹Î± ÏƒÎ±Ï‚ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ:<p><b>Admin-> Ï€Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚-> ÎµÏ€Î¯Ï€ÎµÎ´Î± Ï„Î¹Î¼ÏŽÎ½</b>',0),(444730,12354,'zh','è¦åˆ›å»ºä¸Žæ‚¨åº“å­˜ä¸åŒçš„å®šä»·æ°´å¹³ï¼Œé€‰æ‹©ï¼šç®¡ç†->è®¾ç½®åº“å­˜->å®šä»·æ°´å¹³',0),(444731,12354,'sv','Om du vill skapa olika prissÃ¤ttning fÃ¶r ditt lager vÃ¤ljer du:<p><b>Admin-> Setup inventering-> prisnivÃ¥er</b>',0),(444732,12354,'it','Per creare diversi livelli dei prezzi per il tuo magazzino prescelto:<p><b>Admin-> Inventory Setup-> livelli di prezzo</b>',0),(444733,12354,'tl','',0),(444734,12354,'th','à¹€à¸žà¸·à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸°à¸”à¸±à¸šà¸£à¸²à¸„à¸²à¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸à¸±à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¹€à¸¥à¸·à¸­à¸à¸«à¸¸à¹‰à¸™:<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡->à¸£à¸°à¸”à¸±à¸šà¸£à¸²à¸„à¸²</b>',0),(444735,12354,'hi','à¤…à¤²à¤— à¤…à¤²à¤— à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤ªà¤¨à¥‡ à¤¶à¥‡à¤¯à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¤à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¸à¥‚à¤šà¥€ à¤®à¥‚à¤²',0),(444736,12354,'ms','Untuk membuat penentuan harga berbeza tahap untuk saham anda pilih:<p><b>Admin-> persediaan inventori-> paras harga</b>',0),(444737,12354,'ar','Ù„Ø¥Ù†Ø´Ø§Ø¡ Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„ØªØ³Ø¹ÙŠØ± Ù…Ø®ØªÙ„ÙØ© Ù„ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-> Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ø£Ø³Ø¹Ø§Ø±</b>',0),(444738,12354,'fr','Pour crÃ©er des niveaux de prix diffÃ©rents pour votre stock choisi :<p><b>Admin-> Setup inventaire-> des niveaux de prix</b>',0),(444739,12354,'jp','ç•°ãªã‚‹ä¾¡æ ¼è¨­å®šã‚’ä½œæˆã™ã‚‹ã«ã¯ã€ã‚ãªãŸã®åœ¨åº«ã®ãƒ¬ãƒ™ãƒ«ã‚’é¸æŠžã—ã¾ã™ã€‚<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—åœ¨åº«ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«->-></b>',0),(444740,12354,'pt','Para criar os nÃ­veis de preÃ§os diferentes para seu seleto estoque:<p><b>Admin-> Setup inventÃ¡rio-> nÃ­veis de preÃ§os</b>',0),(444741,12354,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ñ€Ð°Ð·Ð½Ñ‹Ðµ Ñ†ÐµÐ½Ñ‹ Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑƒÑ€Ð¾Ð²Ð½Ð¸ Ð´Ð»Ñ Ð²Ð°ÑˆÐ¸Ñ… Ð°ÐºÑ†Ð¸Ð¹:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ-> ÑƒÑ€Ð¾Ð²Ð½Ð¸ Ñ†ÐµÐ½</b>',0),(444742,12354,'es','Para crear diferente niveles de precios para su inventario selecciona:<p><b>Admin -> ConfiguarciÃ³n Inventario -> Niveles de Precios</b>',0),(444743,12354,'de','Um verschiedene Preise erstellen wÃ¤hlen Sie die Ebenen fÃ¼r Ihr Lager:<p><b>Admin-> Lager Einrichtung-> Preisniveau</b>',0),(444744,12354,'en','To create different pricing levels for your stock select:<p><b>Admin -> Setup Inventory -> Price Levels</b>',0),(444745,12355,'is','',0),(444746,12355,'dr','',0),(444747,12355,'pr','',0),(444748,12355,'tr','',0),(444749,12355,'pl','',0),(444750,12355,'bg','',0),(444751,12355,'ur','',0),(444752,12355,'sr','',0),(444753,12355,'vi','',0),(444754,12355,'af','',0),(444755,12355,'ro','',0),(444756,12355,'et','',0),(444757,12355,'si','',0),(444758,12355,'ba','',0),(444759,12355,'nl','',0),(444760,12355,'fi','',0),(444761,12355,'no','',0),(444762,12355,'da','',0),(444763,12355,'ko','',0),(444764,12355,'he','',0),(444765,12355,'el','',0),(444766,12355,'zh','',0),(444767,12355,'sv','',0),(444768,12355,'it','',0),(444769,12355,'tl','',0),(444770,12355,'th','',0),(444771,12355,'hi','',0),(444772,12355,'ms','',0),(444773,12355,'ar','',0),(444774,12355,'fr','',0),(444775,12355,'jp','',0),(444776,12355,'pt','',0),(444777,12355,'ru','',0),(444778,12355,'es','',0),(444779,12355,'de','',0),(444780,12355,'en','',0),(444781,12356,'is','',0),(444782,12356,'dr','',0),(444783,12356,'pr','',0),(444784,12356,'tr','',0),(444785,12356,'pl','',0),(444786,12356,'bg','',0),(444787,12356,'ur','',0),(444788,12356,'sr','',0),(444789,12356,'vi','',0),(444790,12356,'af','',0),(444791,12356,'ro','',0),(444792,12356,'et','',0),(444793,12356,'si','',0),(444794,12356,'ba','',0),(444795,12356,'nl','',0),(444796,12356,'fi','',0),(444797,12356,'no','',0),(444798,12356,'da','',0),(444799,12356,'ko','',0),(444800,12356,'he','',0),(444801,12356,'el','',0),(444802,12356,'zh','',0),(444803,12356,'sv','',0),(444804,12356,'it','',0),(444805,12356,'tl','',0),(444806,12356,'th','',0),(444807,12356,'hi','',0),(444808,12356,'ms','',0),(444809,12356,'ar','',0),(444810,12356,'fr','',0),(444811,12356,'jp','',0),(444812,12356,'pt','',0),(444813,12356,'ru','',0),(444814,12356,'es','',0),(444815,12356,'de','',0),(444816,12356,'en','',0),(444817,12357,'is','',0),(444818,12357,'dr','',0),(444819,12357,'pr','',0),(444820,12357,'tr','',0),(444821,12357,'pl','',0),(444822,12357,'bg','',0),(444823,12357,'ur','',0),(444824,12357,'sr','',0),(444825,12357,'vi','',0),(444826,12357,'af','',0),(444827,12357,'ro','',0),(444828,12357,'et','',0),(444829,12357,'si','',0),(444830,12357,'ba','',0),(444831,12357,'nl','',0),(444832,12357,'fi','',0),(444833,12357,'no','',0),(444834,12357,'da','',0),(444835,12357,'ko','',0),(444836,12357,'he','',0),(444837,12357,'el','',0),(444838,12357,'zh','',0),(444839,12357,'sv','',0),(444840,12357,'it','',0),(444841,12357,'tl','',0),(444842,12357,'th','',0),(444843,12357,'hi','',0),(444844,12357,'ms','',0),(444845,12357,'ar','',0),(444846,12357,'fr','',0),(444847,12357,'jp','',0),(444848,12357,'pt','',0),(444849,12357,'ru','',0),(444850,12357,'es','',0),(444851,12357,'de','',0),(444852,12357,'en','',0),(444853,12358,'is','',0),(444854,12358,'dr','',0),(444855,12358,'pr','',0),(444856,12358,'tr','',0),(444857,12358,'pl','',0),(444858,12358,'bg','',0),(444859,12358,'ur','',0),(444860,12358,'sr','',0),(444861,12358,'vi','',0),(444862,12358,'af','',0),(444863,12358,'ro','',0),(444864,12358,'et','',0),(444865,12358,'si','',0),(444866,12358,'ba','',0),(444867,12358,'nl','',0),(444868,12358,'fi','',0),(444869,12358,'no','',0),(444870,12358,'da','',0),(444871,12358,'ko','',0),(444872,12358,'he','',0),(444873,12358,'el','',0),(444874,12358,'zh','',0),(444875,12358,'sv','',0),(444876,12358,'it','',0),(444877,12358,'tl','',0),(444878,12358,'th','',0),(444879,12358,'hi','',0),(444880,12358,'ms','',0),(444881,12358,'ar','',0),(444882,12358,'fr','',0),(444883,12358,'jp','',0),(444884,12358,'pt','',0),(444885,12358,'ru','',0),(444886,12358,'es','',0),(444887,12358,'de','',0),(444888,12358,'en','',0),(444889,12359,'is','',0),(444890,12359,'dr','',0),(444891,12359,'pr','',0),(444892,12359,'tr','',0),(444893,12359,'pl','',0),(444894,12359,'bg','',0),(444895,12359,'ur','',0),(444896,12359,'sr','',0),(444897,12359,'vi','',0),(444898,12359,'af','',0),(444899,12359,'ro','',0),(444900,12359,'et','',0),(444901,12359,'si','',0),(444902,12359,'ba','',0),(444903,12359,'nl','',0),(444904,12359,'fi','',0),(444905,12359,'no','',0),(444906,12359,'da','',0),(444907,12359,'ko','',0),(444908,12359,'he','',0),(444909,12359,'el','',0),(444910,12359,'zh','',0),(444911,12359,'sv','',0),(444912,12359,'it','',0),(444913,12359,'tl','',0),(444914,12359,'th','',0),(444915,12359,'hi','',0),(444916,12359,'ms','',0),(444917,12359,'ar','',0),(444918,12359,'fr','',0),(444919,12359,'jp','',0),(444920,12359,'pt','',0),(444921,12359,'ru','',0),(444922,12359,'es','',0),(444923,12359,'de','',0),(444924,12359,'en','',0),(444925,12360,'is','',0),(444926,12360,'dr','',0),(444927,12360,'pr','',0),(444928,12360,'tr','',0),(444929,12360,'pl','',0),(444930,12360,'bg','',0),(444931,12360,'ur','',0),(444932,12360,'sr','',0),(444933,12360,'vi','',0),(444934,12360,'af','',0),(444935,12360,'ro','',0),(444936,12360,'et','',0),(444937,12360,'si','',0),(444938,12360,'ba','',0),(444939,12360,'nl','',0),(444940,12360,'fi','',0),(444941,12360,'no','',0),(444942,12360,'da','',0),(444943,12360,'ko','',0),(444944,12360,'he','',0),(444945,12360,'el','',0),(444946,12360,'zh','',0),(444947,12360,'sv','',0),(444948,12360,'it','',0),(444949,12360,'tl','',0),(444950,12360,'th','',0),(444951,12360,'hi','',0),(444952,12360,'ms','',0),(444953,12360,'ar','',0),(444954,12360,'fr','',0),(444955,12360,'jp','',0),(444956,12360,'pt','',0),(444957,12360,'ru','',0),(444958,12360,'es','',0),(444959,12360,'de','',0),(444960,12360,'en','',0),(444961,12361,'is','',0),(444962,12361,'dr','',0),(444963,12361,'pr','',0),(444964,12361,'tr','',0),(444965,12361,'pl','',0),(444966,12361,'bg','',0),(444967,12361,'ur','',0),(444968,12361,'sr','',0),(444969,12361,'vi','',0),(444970,12361,'af','',0),(444971,12361,'ro','',0),(444972,12361,'et','',0),(444973,12361,'si','',0),(444974,12361,'ba','',0),(444975,12361,'nl','',0),(444976,12361,'fi','',0),(444977,12361,'no','',0),(444978,12361,'da','',0),(444979,12361,'ko','',0),(444980,12361,'he','',0),(444981,12361,'el','',0),(444982,12361,'zh','',0),(444983,12361,'sv','',0),(444984,12361,'it','',0),(444985,12361,'tl','',0),(444986,12361,'th','',0),(444987,12361,'hi','',0),(444988,12361,'ms','',0),(444989,12361,'ar','',0),(444990,12361,'fr','',0),(444991,12361,'jp','',0),(444992,12361,'pt','',0),(444993,12361,'ru','',0),(444994,12361,'es','',0),(444995,12361,'de','',0),(444996,12361,'en','',0),(444997,12362,'is','',0),(444998,12362,'dr','',0),(444999,12362,'pr','',0),(445000,12362,'tr','',0),(445001,12362,'pl','',0),(445002,12362,'bg','',0),(445003,12362,'ur','',0),(445004,12362,'sr','',0),(445005,12362,'vi','',0),(445006,12362,'af','',0),(445007,12362,'ro','',0),(445008,12362,'et','',0),(445009,12362,'si','',0),(445010,12362,'ba','',0),(445011,12362,'nl','',0),(445012,12362,'fi','',0),(445013,12362,'no','',0),(445014,12362,'da','',0),(445015,12362,'ko','',0),(445016,12362,'he','',0),(445017,12362,'el','',0),(445018,12362,'zh','',0),(445019,12362,'sv','',0),(445020,12362,'it','',0),(445021,12362,'tl','',0),(445022,12362,'th','',0),(445023,12362,'hi','',0),(445024,12362,'ms','',0),(445025,12362,'ar','',0),(445026,12362,'fr','',0),(445027,12362,'jp','',0),(445028,12362,'pt','',0),(445029,12362,'ru','',0),(445030,12362,'es','',0),(445031,12362,'de','',0),(445032,12362,'en','',0),(445033,12363,'is','',0),(445034,12363,'dr','',0),(445035,12363,'pr','',0),(445036,12363,'tr','',0),(445037,12363,'pl','',0),(445038,12363,'bg','',0),(445039,12363,'ur','',0),(445040,12363,'sr','',0),(445041,12363,'vi','',0),(445042,12363,'af','',0),(445043,12363,'ro','',0),(445044,12363,'et','',0),(445045,12363,'si','',0),(445046,12363,'ba','',0),(445047,12363,'nl','',0),(445048,12363,'fi','',0),(445049,12363,'no','',0),(445050,12363,'da','',0),(445051,12363,'ko','',0),(445052,12363,'he','',0),(445053,12363,'el','',0),(445054,12363,'zh','',0),(445055,12363,'sv','',0),(445056,12363,'it','',0),(445057,12363,'tl','',0),(445058,12363,'th','',0),(445059,12363,'hi','',0),(445060,12363,'ms','',0),(445061,12363,'ar','',0),(445062,12363,'fr','',0),(445063,12363,'jp','',0),(445064,12363,'pt','',0),(445065,12363,'ru','',0),(445066,12363,'es','',0),(445067,12363,'de','',0),(445068,12363,'en','',0),(445069,12364,'is','',0),(445070,12364,'dr','',0),(445071,12364,'pr','',0),(445072,12364,'tr','',0),(445073,12364,'pl','',0),(445074,12364,'bg','',0),(445075,12364,'ur','',0),(445076,12364,'sr','',0),(445077,12364,'vi','',0),(445078,12364,'af','',0),(445079,12364,'ro','',0),(445080,12364,'et','',0),(445081,12364,'si','',0),(445082,12364,'ba','',0),(445083,12364,'nl','',0),(445084,12364,'fi','',0),(445085,12364,'no','',0),(445086,12364,'da','',0),(445087,12364,'ko','',0),(445088,12364,'he','',0),(445089,12364,'el','',0),(445090,12364,'zh','',0),(445091,12364,'sv','',0),(445092,12364,'it','',0),(445093,12364,'tl','',0),(445094,12364,'th','',0),(445095,12364,'hi','',0),(445096,12364,'ms','',0),(445097,12364,'ar','',0),(445098,12364,'fr','',0),(445099,12364,'jp','',0),(445100,12364,'pt','',0),(445101,12364,'ru','',0),(445102,12364,'es','',0),(445103,12364,'de','',0),(445104,12364,'en','',0),(445105,12365,'is','',0),(445106,12365,'dr','',0),(445107,12365,'pr','',0),(445108,12365,'tr','',0),(445109,12365,'pl','',0),(445110,12365,'bg','',0),(445111,12365,'ur','',0),(445112,12365,'sr','',0),(445113,12365,'vi','',0),(445114,12365,'af','',0),(445115,12365,'ro','',0),(445116,12365,'et','',0),(445117,12365,'si','',0),(445118,12365,'ba','',0),(445119,12365,'nl','',0),(445120,12365,'fi','',0),(445121,12365,'no','',0),(445122,12365,'da','',0),(445123,12365,'ko','',0),(445124,12365,'he','',0),(445125,12365,'el','',0),(445126,12365,'zh','',0),(445127,12365,'sv','',0),(445128,12365,'it','',0),(445129,12365,'tl','',0),(445130,12365,'th','',0),(445131,12365,'hi','',0),(445132,12365,'ms','',0),(445133,12365,'ar','',0),(445134,12365,'fr','',0),(445135,12365,'jp','',0),(445136,12365,'pt','',0),(445137,12365,'ru','',0),(445138,12365,'es','',0),(445139,12365,'de','',0),(445140,12365,'en','',0),(445141,12366,'is','',0),(445142,12366,'dr','',0),(445143,12366,'pr','',0),(445144,12366,'tr','',0),(445145,12366,'pl','',0),(445146,12366,'bg','',0),(445147,12366,'ur','',0),(445148,12366,'sr','',0),(445149,12366,'vi','',0),(445150,12366,'af','',0),(445151,12366,'ro','',0),(445152,12366,'et','',0),(445153,12366,'si','',0),(445154,12366,'ba','',0),(445155,12366,'nl','',0),(445156,12366,'fi','',0),(445157,12366,'no','',0),(445158,12366,'da','',0),(445159,12366,'ko','',0),(445160,12366,'he','',0),(445161,12366,'el','',0),(445162,12366,'zh','',0),(445163,12366,'sv','',0),(445164,12366,'it','',0),(445165,12366,'tl','',0),(445166,12366,'th','',0),(445167,12366,'hi','',0),(445168,12366,'ms','',0),(445169,12366,'ar','',0),(445170,12366,'fr','',0),(445171,12366,'jp','',0),(445172,12366,'pt','',0),(445173,12366,'ru','',0),(445174,12366,'es','',0),(445175,12366,'de','',0),(445176,12366,'en','',0),(445177,12367,'is','',0),(445178,12367,'dr','',0),(445179,12367,'pr','',0),(445180,12367,'tr','',0),(445181,12367,'pl','',0),(445182,12367,'bg','',0),(445183,12367,'ur','',0),(445184,12367,'sr','',0),(445185,12367,'vi','',0),(445186,12367,'af','',0),(445187,12367,'ro','',0),(445188,12367,'et','',0),(445189,12367,'si','',0),(445190,12367,'ba','',0),(445191,12367,'nl','',0),(445192,12367,'fi','',0),(445193,12367,'no','',0),(445194,12367,'da','',0),(445195,12367,'ko','',0),(445196,12367,'he','',0),(445197,12367,'el','',0),(445198,12367,'zh','',0),(445199,12367,'sv','',0),(445200,12367,'it','',0),(445201,12367,'tl','',0),(445202,12367,'th','',0),(445203,12367,'hi','',0),(445204,12367,'ms','',0),(445205,12367,'ar','',0),(445206,12367,'fr','',0),(445207,12367,'jp','',0),(445208,12367,'pt','',0),(445209,12367,'ru','',0),(445210,12367,'es','',0),(445211,12367,'de','',0),(445212,12367,'en','',0),(445213,12368,'is','',0),(445214,12368,'dr','.ÙÙ‚Ø· Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯: ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø±Ø§Ú©Ø§',0),(445215,12368,'pr','Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… Ø§ÛŒØ¬Ø§Ø¯ ÛŒÚ© ØªØ±Ø§Ø² Ø§ÙØªØªØ§Ø­ÛŒÙ‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø§Ø² Ø´Ù…Ø§ Ø®ÙˆØ§Ø³ØªÙ‡ Ø´ÙˆØ¯ Ú©Ù‡ ÛŒÚ© Ú©Ø¯ Ø¯ÙØªØ± Ú©Ù„ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.ÙÙ‚Ø· Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯: ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø±Ø§Ú©Ø§',0),(445216,12368,'tr','Bir aÃ§Ä±lÄ±ÅŸ satÄ±cÄ± bakiyeleri NolaPro iÃ§ine oluÅŸtururken bir GL kodunu girmeniz istenebilir.<p>Bu isteÄŸe baÄŸlÄ± - burada hiÃ§bir ÅŸey girmek iÃ§in gerekli deÄŸildir.  \'<i>Tam Bill</i>\' tÄ±klamanÄ±z yeterlidir.',0),(445217,12368,'pl','Podczas tworzenia dostawcÃ³w otwarcia salda do NolaPro moÅ¼e zostaÄ‡ poproszony aby wprowadziÄ‡ kod GL.<p>Jest to opcjonalne - nie sÄ… wymagane do niczego tutaj.  Po prostu kliknij \"<i>PeÅ‚ne Bill</i>\".',0),(445218,12368,'bg','ÐšÐ¾Ð³Ð°Ñ‚Ð¾ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ñ‚Ðµ Ð¾Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ°Ð»Ð´Ð° Ð² NolaPro Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ð¾Ð¸ÑÐºÐ°Ð½Ð¾ Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ð´ Ð½Ð° GL.<p>Ð¢Ð¾Ð²Ð° Ðµ Ð¿Ð¾ Ð¸Ð·Ð±Ð¾Ñ€ - Ð½Ðµ Ðµ Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ',0),(445219,12368,'ur','Ø¨ÛŒÙ„Ù†Ø³ Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ù…ÛŒÚº Ø§ÛŒÚ© Ø§ÙØªØªØ§Ø­ÛŒ ÙˆÛŒÙ†ÚˆØ± Ø¨Ù†Ø§ØªÛ’ ÙˆÙ‚Øª Ø¢Ù¾ Ø§ÛŒÚ© Ø¬ÛŒØ¬Û’ Ú©ÙˆÚˆ Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ ÛÙˆ Ø³Ú©ØªØ§ ÛÛ’ Û”<p>ÛŒÛ Ø§Ø®ØªÛŒØ§Ø±ÛŒ ÛÛ’ - Ø¢Ù¾ ÛŒÛØ§Úº Ú©Ú†Ú¾ Ø¨Ú¾ÛŒ Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Û’ Ú©Û',0),(445220,12368,'sr','ÐŸÑ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐ° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¾Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ ÑÐ°Ð»Ð´Ð° Ñƒ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð“Ð›.<p>ÐžÐ²Ð¾ Ñ˜Ðµ Ð¾Ð¿Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð¾ - Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ð',0),(445221,12368,'vi','Khi táº¡o sá»‘ dÆ° Ä‘áº§u ká»³ cá»§a nhÃ  cung cáº¥p vÃ o Nalopro, báº¡n cÃ³ thá»ƒ Ä‘Æ°á»£c yÃªu cáº§u nháº­p mÃ£ GL. ÄÃ¢y lÃ  tÃ¹y chá»n, báº¡n khÃ´ng cáº§n nháº­p gÃ¬ cáº£. Chá»‰ cáº§n nháº¥p\" hoÃ n thÃ nh bill\"',0),(445222,12368,'af','Wanneer \'n opening handelaar saldo\'s in NolaPro skep jy versoek word om voer van \'n GL-kode.<p>Dit is opsioneel - jy nie nodig om enigiets hier tik.  Klik net op \'<i>Voltooi Wetsontwerp</i>\'.',0),(445223,12368,'ro','Atunci cÃ¢nd creaÅ£i un furnizor de deschidere soldurile Ã®n NolaPro vÄƒ pot solicita sÄƒ introduceÅ£i un cod GL.<p>Acest lucru este opÅ£ional - nu sunt necesare pentru a introduce nimic aici.  Doar faceÅ£i clic pe \"<i>Complet de lege</i>\".',0),(445224,12368,'et','Loomisel avamine hankija saldod arvesse NolaPro vÃµib taotleda GL kood.<p>See on valikuline - ei ole vaja sisestada midagi siin.  KlÃµpsake lihtsalt<i>TÃ¤ielik arve</i>.',0),(445225,12368,'si','Pri ustvarjanju odpiranje dobavitelja bilance v NolaPro lahko zahteva, da vnesete Å¡ifro GL.<p>To je neobvezno - vam ni treba vnaÅ¡ati niÄesar.  Preprosto kliknite \"<i>Popolnega zakona</i>\".',0),(445226,12368,'ba','Ketika membuat Penjual pembukaan saldo ke NolaPro Anda mungkin diminta untuk memasukkan kode GL.<p>Ini opsional - Anda tidak diharuskan untuk memasukkan apa pun di sini.  Klik \'<i>Lengkap Bill</i>\'.',0),(445227,12368,'nl','Bij het maken van een opening leverancier saldi in NolaPro kan u worden verzocht een GL-code in te voeren.<p>Dit is optioneel - u zijn niet verplicht hier niets in te voeren.  Klik enkel op \'<i>Complete Bill</i>\'.',0),(445228,12368,'fi','Kun luot avaaminen toimittajan saldoa NolaPro voi pyytÃ¤Ã¤ GL koodi.<p>TÃ¤mÃ¤ on vapaaehtoinen - ei tarvitse syÃ¶ttÃ¤Ã¤ mitÃ¤Ã¤n.  Valitse<i>TÃ¤ydellinen Bill</i>.',0),(445229,12368,'no','NÃ¥r du oppretter en Ã¥pning leverandÃ¸r saldoer i NolaPro kan du bli bedt om Ã¥ angi en GL-kode.<p>Dette er valgfritt - du er ikke nÃ¸dvendig Ã¥ angi noe her.  Bare klikk \"<i>Komplett Bill</i>\".',0),(445230,12368,'da','NÃ¥r du opretter en Ã¥bning kreditor saldi i NolaPro kan du blive bedt om at indtaste en kode for GL.<p>Dette er valgfrit - du er ikke forpligtet til at skrive noget her.  Bare Klik pÃ¥ \'<i>Komplet Bill</i>\'.',0),(445231,12368,'ko','ì—¬ ê³µê¸‰ ì—…ì²´ë¥¼ NolaProë¡œ ê· í˜•ì„ ë§Œë“¤ ë•Œ GL ì½”ë“œ ìž…ë ¥ì„ ì‹ ì²­í•˜ì‹¤ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p>ì´ê²ƒì€ ì„ íƒì  ì´ë‹¤-ì—¬ê¸°ì— ì•„ë¬´ê²ƒë„ ìž…ë ¥ í•˜ëŠ” ë° í•„ìš”í•œ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.  \'<i>ì™„ì „ í•œ ë²•ì•ˆ</i>\'ì„ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(445232,12368,'he','×‘×¢×ª ×™×¦×™×¨×ª ×¡×¤×§ ×”×¤×ª×™×—×” ×©×œ ×™×ª×¨×•×ª ×œ×ª×•×š NolaPro ×™×™×ª×›×Ÿ ×©×ª×ª×‘×§×© ×œ×”×–×™×Ÿ ×§×•×“ GL.<p>×¤×¢×•×œ×” ×–×• ×”×™× ××•×¤×¦×™×•× ×œ×™×ª - ×œ× ×ª×™×“×¨×© ×œ×”×–×™×Ÿ ×›××Ÿ ×ž×©×”×•.  ×¤×©×•×˜ ×œ×—×¥ ×¢×œ \'<i>×”×©×œ× ×‘×™×œ</i>\'',0),(445233,12368,'el','ÎšÎ±Ï„Î¬ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÎ½ÏŒÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î¬Î½Î¿Î¹Î³Î¼Î± Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯ÎµÏ‚ ÏƒÎµ NolaPro Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÏƒÎ±Ï‚ Î¶Î·Ï„Î·Î¸ÎµÎ¯ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ ÎºÏ‰Î´Î¹ÎºÏŒ GL.<p>Î‘Ï…Ï„ÏŒ ÎµÎ¯Î½Î±Î¹ Ï€ÏÎ¿Î±Î¹ÏÎµÏ„Î¹ÎºÏŒ - Î´',0),(445234,12368,'zh','å½“åˆ›å»ºä¸€ä¸ªå¼€æ”¾çš„ä¾›åº”å•†ç»“ä½™è´¦ç›®åˆ°NolaProæ—¶ï¼Œæ‚¨å°†è¢«è¦æ±‚è¾“å…¥ä¸€ä¸ªæ€»å¸ä»£ç ã€‚è¿™ä¸æ˜¯å¿…é¡»çš„ï¼Œä¸è¦æ±‚æ‚¨åœ¨è¿™é‡Œè¾“å…¥ä»»ä½•ä¸œè¥¿ã€‚åªæ˜¯ç‚¹å‡»â€œå®Œæˆå…¥è´¦â€ã€‚',0),(445235,12368,'sv','NÃ¤r du skapar en Ã¶ppning sÃ¤ljaren saldon i NolaPro kan du ombes ange en GL kod.<p>Detta Ã¤r frivilligt - du Ã¤r inte skyldig att skriva nÃ¥gonting hÃ¤r.  Klicka bara pÃ¥ \"<i>Komplett Bill</i>\".',0),(445236,12368,'it','Quando si crea un fornitore apertura saldi in NolaPro puÃ² essere richiesta per inserire un codice GL.<p>Questo Ã¨ facoltativo - si non sono tenuti a inserire nulla qui.  Fai clic su \'<i>Completa Bill</i>\'.',0),(445237,12368,'tl','',0),(445238,12368,'th','à¹€à¸¡à¸·à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¹€à¸›à¸´à¸”à¸”à¸¸à¸¥à¹€à¸›à¹‡à¸™ NolaPro à¸„à¸¸à¸“à¸­à¸²à¸ˆà¸ˆà¸°à¸‚à¸­à¹ƒà¸«à¹‰à¸›à¹‰à¸­à¸™à¸£à¸«à¸±à¸ª GL<p>à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸ˆà¸³à¹€à¸›à¹‡à¸™ - à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸ªà¸´à¹ˆà¸‡à¹ƒ',0),(445239,12368,'hi','à¤à¤• à¤‰à¤¦à¥à¤˜à¤¾à¤Ÿà¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ NolaPro à¤®à¥‡à¤‚ à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤¬à¤¨à¤¾à¤¤à¥‡ à¤¸à¤®à¤¯ à¤†à¤ªà¤•à¥‹ à¤à¤• GL à¤•à¥‹à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾à¥¤<p>à¤¯à¤',0),(445240,12368,'ms','Apabila mewujudkan penjual pembukaan untuk baki ke dalam NolaPro anda boleh diminta untuk masukkan kod GL.<p>Ini adalah pilihan - anda tidak perlu memasukkan apa-apa di sini.  Klik \'<i>Selesai Rang undang-undang</i>\'.',0),(445241,12368,'ar','Ø¹Ù†Ø¯ Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙˆØ±Ø¯ ÙØªØ­ Ø£Ø±ØµØ¯Ø© ÙÙŠ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ ÙƒÙ†Øª Ù‚Ø¯ Ø·Ù„Ø¨Øª Ø¥Ù„Ù‰ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù…Ø² GL.<p>Ù‡Ø°Ø§ Ø§Ø®ØªÙŠØ§Ø±ÙŠ--Ù„Ø§ ÙŠØªÙ… Ù…Ø·Ø§Ù„Ø¨ØªÙƒ Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø£ÙŠ Ø´ÙŠØ¡ Ù‡Ù†Ø§.  ÙÙ‚Ø· Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ \'<i>Ø¨ÙŠÙ„ ÙƒØ§Ù…Ù„Ø©</i>\'.',0),(445242,12368,'fr','Lorsque vous crÃ©ez un fournisseur d\'ouverture soldes dans NolaPro vous pouvez Ãªtre invitÃ© Ã  entrer un code GL.<p>Cette Ã©tape est facultative - vous n\'Ãªtes pas tenu d\'entrer quelque chose ici.  Cliquez simplement sur Â«<i>Projet de loi complet</i>Â».',0),(445243,12368,'jp','ã‚ªãƒ¼ãƒ—ãƒ‹ãƒ³ã‚° ãƒ™ãƒ³ãƒ€ãƒ¼ NolaPro ã«æ®‹é«˜ã‚’ä½œæˆã™ã‚‹ã¨ãã€GL ã‚³ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚<p>ã“ã‚Œã¯ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã§ã™ - ä½•ã‚‚ã“ã“ã§å…¥åŠ›ã™ã‚‹å¿…è¦ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚\'<i>å®Œå…¨ãªæ³•æ¡ˆ</i>\' ã‚’ã‚¯ãƒªãƒƒã‚¯ã',0),(445244,12368,'pt','Ao criar um fornecedor de abertura de saldos em NolaPro vocÃª pode ser solicitado a inserir um cÃ³digo GL.<p>Isto Ã© opcional - vocÃª nÃ£o Ã© obrigado a digitar qualquer coisa aqui.  Basta clicar em \'<i>Bill completa</i>\'.',0),(445245,12368,'ru','ÐŸÑ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ð¸Ñ Ð¾ÑÑ‚Ð°Ñ‚ÐºÐ¾Ð² Ð² NolaPro Ð²Ð°Ð¼ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ ÐºÐ¾Ð´ GL.<p>Ð­Ñ‚Ð¾ Ð½Ðµ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð¾Ð±ÑÐ·Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼ - Ð²Ñ‹ Ð½Ðµ Ð¾Ð±ÑÐ·Ð°Ð½Ñ‹ Ð½Ð¸Ñ‡ÐµÐ³',0),(445246,12368,'es','Cuando esta creando saldos iniciales de Proveedores en NolaPro se puede pedir entra un cÃ³digo LM. <p>Este es opcional - no se requiere entra nada aqui. Nada mÃ¡s hace clik \'<i>Completar Factura</i>.',0),(445247,12368,'de','Wenn einen Anbieter ErÃ¶ffnung Salden in Artikel erstellen werden Sie mÃ¶glicherweise aufgefordert, einen GL-Code einzugeben.<p>Dieser Schritt ist optional - Sie sind nicht verpflichtet, alles hier eintragen.  Klicken Sie einfach auf \"<i>VollstÃ¤ndige Bil',0),(445248,12368,'en','When creating an opening vendor balances into NolaPro you may be requested to enter a GL code.<p>This is optional - you aren\'t required to enter anything here.  Just click \'<i>Complete Bill</i>\'.',0),(445249,12369,'is','',0),(445250,12369,'dr','',0),(445251,12369,'pr','',0),(445252,12369,'tr','',0),(445253,12369,'pl','',0),(445254,12369,'bg','',0),(445255,12369,'ur','',0),(445256,12369,'sr','',0),(445257,12369,'vi','',0),(445258,12369,'af','',0),(445259,12369,'ro','',0),(445260,12369,'et','',0),(445261,12369,'si','',0),(445262,12369,'ba','',0),(445263,12369,'nl','',0),(445264,12369,'fi','',0),(445265,12369,'no','',0),(445266,12369,'da','',0),(445267,12369,'ko','',0),(445268,12369,'he','',0),(445269,12369,'el','',0),(445270,12369,'zh','',0),(445271,12369,'sv','',0),(445272,12369,'it','',0),(445273,12369,'tl','',0),(445274,12369,'th','',0),(445275,12369,'hi','',0),(445276,12369,'ms','',0),(445277,12369,'ar','',0),(445278,12369,'fr','',0),(445279,12369,'jp','',0),(445280,12369,'pt','',0),(445281,12369,'ru','',0),(445282,12369,'es','',0),(445283,12369,'de','',0),(445284,12369,'en','',0),(445285,12370,'is','',0),(445286,12370,'dr','',0),(445287,12370,'pr','',0),(445288,12370,'tr','',0),(445289,12370,'pl','',0),(445290,12370,'bg','',0),(445291,12370,'ur','',0),(445292,12370,'sr','',0),(445293,12370,'vi','',0),(445294,12370,'af','',0),(445295,12370,'ro','',0),(445296,12370,'et','',0),(445297,12370,'si','',0),(445298,12370,'ba','',0),(445299,12370,'nl','',0),(445300,12370,'fi','',0),(445301,12370,'no','',0),(445302,12370,'da','',0),(445303,12370,'ko','',0),(445304,12370,'he','',0),(445305,12370,'el','',0),(445306,12370,'zh','',0),(445307,12370,'sv','',0),(445308,12370,'it','',0),(445309,12370,'tl','',0),(445310,12370,'th','',0),(445311,12370,'hi','',0),(445312,12370,'ms','',0),(445313,12370,'ar','',0),(445314,12370,'fr','',0),(445315,12370,'jp','',0),(445316,12370,'pt','',0),(445317,12370,'ru','',0),(445318,12370,'es','',0),(445319,12370,'de','',0),(445320,12370,'en','',0),(445321,12371,'is','',0),(445322,12371,'dr','',0),(445323,12371,'pr','',0),(445324,12371,'tr','',0),(445325,12371,'pl','',0),(445326,12371,'bg','',0),(445327,12371,'ur','',0),(445328,12371,'sr','',0),(445329,12371,'vi','',0),(445330,12371,'af','',0),(445331,12371,'ro','',0),(445332,12371,'et','',0),(445333,12371,'si','',0),(445334,12371,'ba','',0),(445335,12371,'nl','',0),(445336,12371,'fi','',0),(445337,12371,'no','',0),(445338,12371,'da','',0),(445339,12371,'ko','',0),(445340,12371,'he','',0),(445341,12371,'el','',0),(445342,12371,'zh','',0),(445343,12371,'sv','',0),(445344,12371,'it','',0),(445345,12371,'tl','',0),(445346,12371,'th','',0),(445347,12371,'hi','',0),(445348,12371,'ms','',0),(445349,12371,'ar','',0),(445350,12371,'fr','',0),(445351,12371,'jp','',0),(445352,12371,'pt','',0),(445353,12371,'ru','',0),(445354,12371,'es','',0),(445355,12371,'de','',0),(445356,12371,'en','',0),(445357,12372,'is','',0),(445358,12372,'dr','',0),(445359,12372,'pr','',0),(445360,12372,'tr','',0),(445361,12372,'pl','',0),(445362,12372,'bg','',0),(445363,12372,'ur','',0),(445364,12372,'sr','',0),(445365,12372,'vi','',0),(445366,12372,'af','',0),(445367,12372,'ro','',0),(445368,12372,'et','',0),(445369,12372,'si','',0),(445370,12372,'ba','',0),(445371,12372,'nl','',0),(445372,12372,'fi','',0),(445373,12372,'no','',0),(445374,12372,'da','',0),(445375,12372,'ko','',0),(445376,12372,'he','',0),(445377,12372,'el','',0),(445378,12372,'zh','',0),(445379,12372,'sv','',0),(445380,12372,'it','',0),(445381,12372,'tl','',0),(445382,12372,'th','',0),(445383,12372,'hi','',0),(445384,12372,'ms','',0),(445385,12372,'ar','',0),(445386,12372,'fr','',0),(445387,12372,'jp','',0),(445388,12372,'pt','',0),(445389,12372,'ru','',0),(445390,12372,'es','',0),(445391,12372,'de','',0),(445392,12372,'en','',0),(445393,12373,'is','',0),(445394,12373,'dr','',0),(445395,12373,'pr','',0),(445396,12373,'tr','',0),(445397,12373,'pl','',0),(445398,12373,'bg','',0),(445399,12373,'ur','',0),(445400,12373,'sr','',0),(445401,12373,'vi','',0),(445402,12373,'af','',0),(445403,12373,'ro','',0),(445404,12373,'et','',0),(445405,12373,'si','',0),(445406,12373,'ba','',0),(445407,12373,'nl','',0),(445408,12373,'fi','',0),(445409,12373,'no','',0),(445410,12373,'da','',0),(445411,12373,'ko','',0),(445412,12373,'he','',0),(445413,12373,'el','',0),(445414,12373,'zh','',0),(445415,12373,'sv','',0),(445416,12373,'it','',0),(445417,12373,'tl','',0),(445418,12373,'th','',0),(445419,12373,'hi','',0),(445420,12373,'ms','',0),(445421,12373,'ar','',0),(445422,12373,'fr','',0),(445423,12373,'jp','',0),(445424,12373,'pt','',0),(445425,12373,'ru','',0),(445426,12373,'es','',0),(445427,12373,'de','',0),(445428,12373,'en','',0),(445429,12374,'is','',0),(445430,12374,'dr','',0),(445431,12374,'pr','',0),(445432,12374,'tr','',0),(445433,12374,'pl','',0),(445434,12374,'bg','',0),(445435,12374,'ur','',0),(445436,12374,'sr','',0),(445437,12374,'vi','',0),(445438,12374,'af','',0),(445439,12374,'ro','',0),(445440,12374,'et','',0),(445441,12374,'si','',0),(445442,12374,'ba','',0),(445443,12374,'nl','',0),(445444,12374,'fi','',0),(445445,12374,'no','',0),(445446,12374,'da','',0),(445447,12374,'ko','',0),(445448,12374,'he','',0),(445449,12374,'el','',0),(445450,12374,'zh','',0),(445451,12374,'sv','',0),(445452,12374,'it','',0),(445453,12374,'tl','',0),(445454,12374,'th','',0),(445455,12374,'hi','',0),(445456,12374,'ms','',0),(445457,12374,'ar','',0),(445458,12374,'fr','',0),(445459,12374,'jp','',0),(445460,12374,'pt','',0),(445461,12374,'ru','',0),(445462,12374,'es','',0),(445463,12374,'de','',0),(445464,12374,'en','',0),(445465,12375,'is','',0),(445466,12375,'dr','',0),(445467,12375,'pr','',0),(445468,12375,'tr','',0),(445469,12375,'pl','',0),(445470,12375,'bg','',0),(445471,12375,'ur','',0),(445472,12375,'sr','',0),(445473,12375,'vi','',0),(445474,12375,'af','',0),(445475,12375,'ro','',0),(445476,12375,'et','',0),(445477,12375,'si','',0),(445478,12375,'ba','',0),(445479,12375,'nl','',0),(445480,12375,'fi','',0),(445481,12375,'no','',0),(445482,12375,'da','',0),(445483,12375,'ko','',0),(445484,12375,'he','',0),(445485,12375,'el','',0),(445486,12375,'zh','',0),(445487,12375,'sv','',0),(445488,12375,'it','',0),(445489,12375,'tl','',0),(445490,12375,'th','',0),(445491,12375,'hi','',0),(445492,12375,'ms','',0),(445493,12375,'ar','',0),(445494,12375,'fr','',0),(445495,12375,'jp','',0),(445496,12375,'pt','',0),(445497,12375,'ru','',0),(445498,12375,'es','',0),(445499,12375,'de','',0),(445500,12375,'en','',0),(445501,12376,'is','',0),(445502,12376,'dr','.Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ',0),(445503,12376,'pr','Ù…Ø¯Ù„ Ø§Ø®ØªÛŒØ§Ø±ÛŒ ØªØ¬Ø§Ø±Øª Ø§ÛŒÙ†ØªØ±Ù†ØªÛŒ Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø¨Ù‡ Ù…Ø´ØªØ±ÛŒØ§Ù† ØªØ¬Ø§Ø±ÛŒ Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ ØªØ§ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ù†Ø¬Ø§Ù…  Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª Ø­Ø³Ø§Ø¨ Ø®ÙˆØ¯ Ø±Ø§ Ø§Ù†Ø¬Ø§Ù… Ø¯Ù‡Ù†Ø¯.Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ',0),(445504,12376,'tr','NolaPro\'nÄ±n isteÄŸe baÄŸlÄ± B2B modÃ¼lÃ¼nÃ¼ iÅŸ istemciler, sipariÅŸ, Ã¶deme yapmak ve onlarÄ±n hesabÄ±nÄ± yÃ¶netmek saÄŸlar. Ä°stemci kullanÄ±cÄ±larÄ± ayarlayÄ±n:<p><b>Ä°lgili kiÅŸileri mÃ¼ÅŸteriler B2B kullanÄ±cÄ±->-></b>',0),(445505,12376,'pl','NolaPro jest opcjonalny moduÅ‚ B2B pozwala biznesowych klientÃ³w do skÅ‚adania zamÃ³wieÅ„, pÅ‚atnoÅ›ci i zarzÄ…dzaÄ‡ ich konta. Konfigurowanie uÅ¼ytkownikÃ³w klienta na:<p><b>Kontakty-> klienci-> B2B uÅ¼ytkownikÃ³w</b>',0),(445506,12376,'bg','ÐÐ° NolaPro Ð² B2B Ð¼Ð¾Ð´ÑƒÐ» Ð¿Ð¾ Ð¸Ð·Ð±Ð¾Ñ€ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÑÐ²Ð° Ð±Ð¸Ð·Ð½ÐµÑ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð´Ð° Ð¿Ñ€Ð°Ð²ÑÑ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð¸ Ð´Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÑÐ²Ð°Ñ‚ ÑÐ¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ ÑÐ¸. ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ',0),(445507,12376,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ú©ÛŒ Ø§Ø®ØªÛŒØ§Ø±ÛŒ B2B Ù…Ø§ÚˆÛŒÙˆÙ„ Ú©Ø§Ø±ÙˆØ¨Ø§Ø± Ú©Ù„Ø§Ø¦Ù†Ù¹ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ø¬Ú¯ÛØŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø±ØªÛ’ Ø§ÙˆØ± Ø§Ù† Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±Ù†Û’ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒØªØ§ ÛÛ’ Û” ÙˆØµÙˆÙ„ Ú©Ø§Ø± ØµØ§Ø±ÙÛŒÙ',0),(445508,12376,'sr','ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ñ˜Ðµ Ð¾Ð¿Ñ†Ð¸Ð¾Ð½Ð°Ð»Ð½Ð° Ð‘2Ð‘ Ð¼Ð¾Ð´ÑƒÐ» Ð¾Ð¼Ð¾Ð³ÑƒÑ›ÑƒÑ˜Ðµ Ð‘Ð¸Ð·Ð½Ð¸Ñ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸ Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ, Ñ€Ð°Ñ‚Ð°Ð¼Ð° Ð¸ Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°Ñ˜Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ð¸Ð¼ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼. ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð° ÐºÐ¾',0),(445509,12376,'vi','MÃ´ Ä‘un B2B cá»§a Nalopro cho phÃ©p khÃ¡ch hÃ ng kinh doanh Ä‘áº·t hÃ ng, thanh toÃ¡n vÃ  quáº£n lÃ½ TK cá»§a há».Thiáº¿t láº­p ngÆ°á»i sá»­ dá»¥ng khÃ¡ch hÃ ng thÃ¬ vÃ o: liÃªn láº¡c-khÃ¡ch hang-ngÆ°á»i dÃ¹ng B2B',0),(445510,12376,'af','NolaPro se opsionele B2B module laat besigheids kliÃ«nte bestellings plaas, betalings en bestuur hul rekening. Stel kliÃ«nt gebruikers by:<p><b>Kontakte-> kliÃ«nte-> B2B gebruikers</b>',0),(445511,12376,'ro','NolaPro pe Modulul opÅ£ional B2B permite clientii de afaceri pentru a plasa comenzi, plÄƒÅ£i ÅŸi de a gestiona contul lor. Configura clientul utilizatori la:<p><b>Contacte-> clienÅ£ii-> B2B utilizatori</b>',0),(445512,12376,'et','NolaPro\'s vabatahtlik B2B moodul vÃµimaldab ettevÃµtte klientide tellimusi, teha makseid ja hallata oma kontot. Kliendi kasutajate seadistamine<p><b>-> Hotelli-> B2B kasutajate kontakte</b>',0),(445513,12376,'si','NolaPro\'s neobvezno B2B modul omogoÄa poslovne stranke naroÄajo, da plaÄila in jahalna Å¡ola svoj raÄun. Nastavite odjemalca uporabnikov na:<p><b>Stiki-> stranke-> B2B uporabnike</b>',0),(445514,12376,'ba','NolaPro\'s B2B modul opsional memungkinkan klien bisnis untuk menempatkan pesanan, melakukan pembayaran dan mengelola account mereka. Mengatur klien pengguna pada:<p><b>Kontak-> pelanggan-> B2B pengguna</b>',0),(445515,12376,'nl','NolaPro de optionele B2B module kunt zakelijke klanten te plaatsen bestellingen, betalingen en hun account beheren. Clientgebruikers op instellen:<p><b>Contacten-> klanten-> B2B gebruikers</b>',0),(445516,12376,'fi','NolaPro on valinnainen B2B-moduulin avulla yritysasiakkaat-tilaukset, tee maksut ja hallita tilin. MÃ¤Ã¤rittÃ¤Ã¤ asiakkaan kÃ¤yttÃ¤jille:<p><b>Yhteystiedot-> asiakkaat-> B2B kÃ¤yttÃ¤jÃ¤t</b>',0),(445517,12376,'no','Nolapros valgfrie B2B modulen lar forretningskunder plassere bestillinger, betalinger og administrere deres konto. Definere client-brukere pÃ¥:<p><b>Kontakter-> kunder-> B2B brukere</b>',0),(445518,12376,'da','Nolapros valgfri B2B modul tillader erhvervskunder at placere ordrer, foretage betalinger og administrere deres konto. Konfigurere klientbrugere pÃ¥:<p><b>Kontakter-> gÃ¦ster-> B2B brugere</b>',0),(445519,12376,'ko','NolaProì˜ ì„ íƒì  B2B ëª¨ë“ˆ ê¸°ì—… ê³ ê°ì„ ì£¼ë¬¸, ì§€ë¶ˆ í•˜ ê³  ìžì‹ ì˜ ê³„ì •ì„ ê´€ë¦¬í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤. í´ë¼ì´ì–¸íŠ¸ì—ì„œ ì‚¬ìš©ìžê°€ ì„¤ì • í•©ë‹ˆë‹¤.<p><b>ê³ ê° B2B ì‚¬ìš©ìž->-> ì—°ë½ì²˜</b>',0),(445520,12376,'he','×ž×•×“×•×œ ××•×¤×¦×™×•× ×œ×™ ×©×œ NolaPro B2B ×ž××¤×©×¨×ª ×œ×œ×§×•×—×•×ª ×¢×¡×§×™×™× ×œ×‘×¦×¢ ×”×–×ž× ×•×ª, ×ª×©×œ×•×ž×™× ×•×œ× ×”×œ ××ª ×”×—×©×‘×•×Ÿ ×©×œ×”×. ×œ×”×’×“×™×¨ ×œ×§×•×— ×ž×©×ª×ž×©×™× ×‘:<p><b>×× ×©×™ ×§×©×¨-> ×”×œ×§×•×—×•×ª-> ×ž×©×ª×ž×',0),(445521,12376,'el','Î ÏÎ¿Î±Î¹ÏÎµÏ„Î¹ÎºÎ® Î¼Î¿Î½Î¬Î´Î± B2B Ï„Î¿Ï… NolaPro ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÎ¹ ÎµÏ€Î¹Ï‡ÎµÎ¹ÏÎ·ÏƒÎ¹Î±ÎºÎ¿ÏÏ‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚, Î½Î± ÎºÎ¬Î½Î¿Ï…Î½ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ ÎºÎ±Î¹ Î½Î± Î´Î¹Î±Ï‡ÎµÎ¹ÏÎ¹ÏƒÏ„ÎµÎ¯ Ï„Î¿Î½ Î±Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Ï„Î¿Ï…',0),(445522,12376,'zh','NolaProçš„å¯é€‰å•†ä¸šå¯¹å•†ä¸šæ¨¡å—å…è®¸å•†ä¸šå®¢æˆ·æ”¾ç½®è®¢å•ï¼Œè¿›è¡Œä»˜æ¬¾å’Œç®¡ç†ä»–ä»¬çš„å¸æˆ·ã€‚è®¾ç½®å®¢æˆ·ç”¨æˆ·åœ¨ï¼šè”ç³»->å®¢æˆ·->å•†ä¸šå¯¹å•†ä¸šç”¨æˆ·',0),(445523,12376,'sv','Nolapros valfri B2B modul kan fÃ¶retagskunder att gÃ¶ra bestÃ¤llningar, betalningar och hantera deras konto. StÃ¤lla in klientanvÃ¤ndare pÃ¥:<p><b>Kontakter-> kunder-> B2B anvÃ¤ndare</b>',0),(445524,12376,'it','Modulo opzionale di B2B di NolaPro permette i clienti business effettuare ordini, effettuare pagamenti e gestire il loro account. Impostare gli utenti client presso:<p><b>Contatti-> clienti-> utenti B2B</b>',0),(445525,12376,'tl','',0),(445526,12376,'th','à¸‚à¸­à¸‡ NolaPro à¹‚à¸¡à¸”à¸¹à¸¥ B2B à¹€à¸ªà¸£à¸´à¸¡à¸˜à¸¸à¸£à¸à¸´à¸ˆà¸¥à¸¹à¸à¸„à¹‰à¸²à¸§à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ à¹à¸¥à¸°à¸ˆà¸±à¸”à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸‚à¸­à¸‡à¸•à¸™à¹„à¸”à¹‰ à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸‚à¸­à',0),(445527,12376,'hi','NolaPro à¤•à¥€ à¤µà¥ˆà¤•à¤²à¥à¤ªà¤¿à¤• B2B à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤° à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤†à¤¦à¥‡à¤¶ à¤œà¤—à¤¹, à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤”à¤° à¤…à¤ªà¤¨à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¥‹ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à',0),(445528,12376,'ms','NolaPro di pilihan B2B modul membolehkan perniagaan pelanggan untuk membuat pesanan, membuat pembayaran dan menguruskan akaun mereka. Sediakan pengguna pelanggan pada:<p><b>Kenalan-> pelanggan-> pengguna B2B</b>',0),(445529,12376,'ar','ÙÙŠ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±ÙŠ B2B ÙˆØ­Ø¯Ø© ÙŠØ³Ù…Ø­ Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø£Ø¹Ù…Ø§Ù„ Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ© ÙˆØ¶Ø¹ Ø§Ù„Ø£ÙˆØ§Ù…Ø± ÙˆØ¬Ø¹Ù„ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª ÙˆØ¥Ø¯Ø§Ø±Ø© Ø­Ø³Ø§Ø¨Ø§ØªÙ‡Ù…. Ù‚Ù… Ø¨Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ø¹Ù…ÙŠÙ„ ÙÙŠ:<p><b>Ø¬Ù‡Ø§Ø',0),(445530,12376,'fr','Module optionnel de B2B de NolaPro permet aux clients d\'affaires passer des commandes, d\'effectuer des paiements et de gÃ©rer leur compte. Configurer des utilisateurs de client Ã  :<p><b>Contacts-> clients-> utilisateurs B2B</b>',0),(445531,12376,'jp','NolaPro ã®çœç•¥å¯èƒ½ãª B2B ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã¯ãƒ“ã‚¸ãƒã‚¹é¡§å®¢ã®æ³¨æ–‡ã€æ”¯æ‰•ã„ã‚’è¡Œã†ã—ã€è‡ªåˆ†ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ç®¡ç†ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’è¨­å®šã—ã¾ã™ã€‚<p><b>B2B ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼-> ã®é¡§å',0),(445532,12376,'pt','MÃ³dulo opcional de B2B do NolaPro permite que clientes empresariais para encomendas, fazer pagamentos e gerenciar sua conta. Configure os usuÃ¡rios do cliente em:<p><b>Contatos-> clientes-> usuÃ¡rios B2B</b>',0),(445533,12376,'ru','NolaPro Ð² Ð¾Ð¿Ñ†Ð¸Ð¾Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¼Ð¾Ð´ÑƒÐ»ÑŒ B2B Ð¿Ð¾Ð·Ð²Ð¾Ð»ÑÐµÑ‚ Ð±Ð¸Ð·Ð½ÐµÑ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°Ð¼ Ñ€Ð°Ð·Ð¼ÐµÑ‰Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹, Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ ÑÐ²Ð¾Ð¸Ð¼ ÑÑ‡ÐµÑ‚Ð¾Ð¼. ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(445534,12376,'es','El mÃ³dulo opcional de N2N de NolaPro permite clientes de negocios hacer ordenes, hacer pagos y manejar sus cuentas. Configurar clientes usuarios a:<p><b>Contactos -> Clientes -> Usuarios N2N</b>',0),(445535,12376,'de','Artikel von B2B-Wahlmodul ermÃ¶glicht GeschÃ¤ftskunden zu Bestellungen, Zahlungen und ihren Account verwalten. Richten Sie Client-Benutzer an:<p><b>Kontakte-> Kunden-> B2B-Benutzer</b>',0),(445536,12376,'en','NolaPro\'s optional B2B module allows business clients to place orders, make payments and manage their account. Set up client users at:<p><b>Contacts -> Customers -> B2B Users</b>',0),(445537,12377,'is','',0),(445538,12377,'dr','',0),(445539,12377,'pr','',0),(445540,12377,'tr','',0),(445541,12377,'pl','',0),(445542,12377,'bg','',0),(445543,12377,'ur','',0),(445544,12377,'sr','',0),(445545,12377,'vi','',0),(445546,12377,'af','',0),(445547,12377,'ro','',0),(445548,12377,'et','',0),(445549,12377,'si','',0),(445550,12377,'ba','',0),(445551,12377,'nl','',0),(445552,12377,'fi','',0),(445553,12377,'no','',0),(445554,12377,'da','',0),(445555,12377,'ko','',0),(445556,12377,'he','',0),(445557,12377,'el','',0),(445558,12377,'zh','',0),(445559,12377,'sv','',0),(445560,12377,'it','',0),(445561,12377,'tl','',0),(445562,12377,'th','',0),(445563,12377,'hi','',0),(445564,12377,'ms','',0),(445565,12377,'ar','',0),(445566,12377,'fr','',0),(445567,12377,'jp','',0),(445568,12377,'pt','',0),(445569,12377,'ru','',0),(445570,12377,'es','',0),(445571,12377,'de','',0),(445572,12377,'en','',0),(445573,12378,'is','',0),(445574,12378,'dr','',0),(445575,12378,'pr','',0),(445576,12378,'tr','',0),(445577,12378,'pl','',0),(445578,12378,'bg','',0),(445579,12378,'ur','',0),(445580,12378,'sr','',0),(445581,12378,'vi','',0),(445582,12378,'af','',0),(445583,12378,'ro','',0),(445584,12378,'et','',0),(445585,12378,'si','',0),(445586,12378,'ba','',0),(445587,12378,'nl','',0),(445588,12378,'fi','',0),(445589,12378,'no','',0),(445590,12378,'da','',0),(445591,12378,'ko','',0),(445592,12378,'he','',0),(445593,12378,'el','',0),(445594,12378,'zh','',0),(445595,12378,'sv','',0),(445596,12378,'it','',0),(445597,12378,'tl','',0),(445598,12378,'th','',0),(445599,12378,'hi','',0),(445600,12378,'ms','',0),(445601,12378,'ar','',0),(445602,12378,'fr','',0),(445603,12378,'jp','',0),(445604,12378,'pt','',0),(445605,12378,'ru','',0),(445606,12378,'es','',0),(445607,12378,'de','',0),(445608,12378,'en','',0),(445609,12379,'is','',0),(445610,12379,'dr','',0),(445611,12379,'pr','',0),(445612,12379,'tr','',0),(445613,12379,'pl','',0),(445614,12379,'bg','',0),(445615,12379,'ur','',0),(445616,12379,'sr','',0),(445617,12379,'vi','',0),(445618,12379,'af','',0),(445619,12379,'ro','',0),(445620,12379,'et','',0),(445621,12379,'si','',0),(445622,12379,'ba','',0),(445623,12379,'nl','',0),(445624,12379,'fi','',0),(445625,12379,'no','',0),(445626,12379,'da','',0),(445627,12379,'ko','',0),(445628,12379,'he','',0),(445629,12379,'el','',0),(445630,12379,'zh','',0),(445631,12379,'sv','',0),(445632,12379,'it','',0),(445633,12379,'tl','',0),(445634,12379,'th','',0),(445635,12379,'hi','',0),(445636,12379,'ms','',0),(445637,12379,'ar','',0),(445638,12379,'fr','',0),(445639,12379,'jp','',0),(445640,12379,'pt','',0),(445641,12379,'ru','',0),(445642,12379,'es','',0),(445643,12379,'de','',0),(445644,12379,'en','',0),(445645,12380,'is','',0),(445646,12380,'dr','',0),(445647,12380,'pr','',0),(445648,12380,'tr','',0),(445649,12380,'pl','',0),(445650,12380,'bg','',0),(445651,12380,'ur','',0),(445652,12380,'sr','',0),(445653,12380,'vi','',0),(445654,12380,'af','',0),(445655,12380,'ro','',0),(445656,12380,'et','',0),(445657,12380,'si','',0),(445658,12380,'ba','',0),(445659,12380,'nl','',0),(445660,12380,'fi','',0),(445661,12380,'no','',0),(445662,12380,'da','',0),(445663,12380,'ko','',0),(445664,12380,'he','',0),(445665,12380,'el','',0),(445666,12380,'zh','',0),(445667,12380,'sv','',0),(445668,12380,'it','',0),(445669,12380,'tl','',0),(445670,12380,'th','',0),(445671,12380,'hi','',0),(445672,12380,'ms','',0),(445673,12380,'ar','',0),(445674,12380,'fr','',0),(445675,12380,'jp','',0),(445676,12380,'pt','',0),(445677,12380,'ru','',0),(445678,12380,'es','',0),(445679,12380,'de','',0),(445680,12380,'en','',0),(445681,12381,'is','',0),(445682,12381,'dr','',0),(445683,12381,'pr','',0),(445684,12381,'tr','',0),(445685,12381,'pl','',0),(445686,12381,'bg','',0),(445687,12381,'ur','',0),(445688,12381,'sr','',0),(445689,12381,'vi','',0),(445690,12381,'af','',0),(445691,12381,'ro','',0),(445692,12381,'et','',0),(445693,12381,'si','',0),(445694,12381,'ba','',0),(445695,12381,'nl','',0),(445696,12381,'fi','',0),(445697,12381,'no','',0),(445698,12381,'da','',0),(445699,12381,'ko','',0),(445700,12381,'he','',0),(445701,12381,'el','',0),(445702,12381,'zh','',0),(445703,12381,'sv','',0),(445704,12381,'it','',0),(445705,12381,'tl','',0),(445706,12381,'th','',0),(445707,12381,'hi','',0),(445708,12381,'ms','',0),(445709,12381,'ar','',0),(445710,12381,'fr','',0),(445711,12381,'jp','',0),(445712,12381,'pt','',0),(445713,12381,'ru','',0),(445714,12381,'es','',0),(445715,12381,'de','',0),(445716,12381,'en','',0),(445717,12382,'is','',0),(445718,12382,'dr','',0),(445719,12382,'pr','',0),(445720,12382,'tr','',0),(445721,12382,'pl','',0),(445722,12382,'bg','',0),(445723,12382,'ur','',0),(445724,12382,'sr','',0),(445725,12382,'vi','',0),(445726,12382,'af','',0),(445727,12382,'ro','',0),(445728,12382,'et','',0),(445729,12382,'si','',0),(445730,12382,'ba','',0),(445731,12382,'nl','',0),(445732,12382,'fi','',0),(445733,12382,'no','',0),(445734,12382,'da','',0),(445735,12382,'ko','',0),(445736,12382,'he','',0),(445737,12382,'el','',0),(445738,12382,'zh','',0),(445739,12382,'sv','',0),(445740,12382,'it','',0),(445741,12382,'tl','',0),(445742,12382,'th','',0),(445743,12382,'hi','',0),(445744,12382,'ms','',0),(445745,12382,'ar','',0),(445746,12382,'fr','',0),(445747,12382,'jp','',0),(445748,12382,'pt','',0),(445749,12382,'ru','',0),(445750,12382,'es','',0),(445751,12382,'de','',0),(445752,12382,'en','',0),(445753,12383,'is','',0),(445754,12383,'dr','',0),(445755,12383,'pr','',0),(445756,12383,'tr','',0),(445757,12383,'pl','',0),(445758,12383,'bg','',0),(445759,12383,'ur','',0),(445760,12383,'sr','',0),(445761,12383,'vi','',0),(445762,12383,'af','',0),(445763,12383,'ro','',0),(445764,12383,'et','',0),(445765,12383,'si','',0),(445766,12383,'ba','',0),(445767,12383,'nl','',0),(445768,12383,'fi','',0),(445769,12383,'no','',0),(445770,12383,'da','',0),(445771,12383,'ko','',0),(445772,12383,'he','',0),(445773,12383,'el','',0),(445774,12383,'zh','',0),(445775,12383,'sv','',0),(445776,12383,'it','',0),(445777,12383,'tl','',0),(445778,12383,'th','',0),(445779,12383,'hi','',0),(445780,12383,'ms','',0),(445781,12383,'ar','',0),(445782,12383,'fr','',0),(445783,12383,'jp','',0),(445784,12383,'pt','',0),(445785,12383,'ru','',0),(445786,12383,'es','',0),(445787,12383,'de','',0),(445788,12383,'en','',0),(445789,12384,'is','',0),(445790,12384,'dr','',0),(445791,12384,'pr','',0),(445792,12384,'tr','',0),(445793,12384,'pl','',0),(445794,12384,'bg','',0),(445795,12384,'ur','',0),(445796,12384,'sr','',0),(445797,12384,'vi','',0),(445798,12384,'af','',0),(445799,12384,'ro','',0),(445800,12384,'et','',0),(445801,12384,'si','',0),(445802,12384,'ba','',0),(445803,12384,'nl','',0),(445804,12384,'fi','',0),(445805,12384,'no','',0),(445806,12384,'da','',0),(445807,12384,'ko','',0),(445808,12384,'he','',0),(445809,12384,'el','',0),(445810,12384,'zh','',0),(445811,12384,'sv','',0),(445812,12384,'it','',0),(445813,12384,'tl','',0),(445814,12384,'th','',0),(445815,12384,'hi','',0),(445816,12384,'ms','',0),(445817,12384,'ar','',0),(445818,12384,'fr','',0),(445819,12384,'jp','',0),(445820,12384,'pt','',0),(445821,12384,'ru','',0),(445822,12384,'es','',0),(445823,12384,'de','',0),(445824,12384,'en','',0),(445825,12385,'is','',0),(445826,12385,'dr','',0),(445827,12385,'pr','',0),(445828,12385,'tr','',0),(445829,12385,'pl','',0),(445830,12385,'bg','',0),(445831,12385,'ur','',0),(445832,12385,'sr','',0),(445833,12385,'vi','',0),(445834,12385,'af','',0),(445835,12385,'ro','',0),(445836,12385,'et','',0),(445837,12385,'si','',0),(445838,12385,'ba','',0),(445839,12385,'nl','',0),(445840,12385,'fi','',0),(445841,12385,'no','',0),(445842,12385,'da','',0),(445843,12385,'ko','',0),(445844,12385,'he','',0),(445845,12385,'el','',0),(445846,12385,'zh','',0),(445847,12385,'sv','',0),(445848,12385,'it','',0),(445849,12385,'tl','',0),(445850,12385,'th','',0),(445851,12385,'hi','',0),(445852,12385,'ms','',0),(445853,12385,'ar','',0),(445854,12385,'fr','',0),(445855,12385,'jp','',0),(445856,12385,'pt','',0),(445857,12385,'ru','',0),(445858,12385,'es','',0),(445859,12385,'de','',0),(445860,12385,'en','',0),(445861,12386,'is','',0),(445862,12386,'dr','',0),(445863,12386,'pr','',0),(445864,12386,'tr','',0),(445865,12386,'pl','',0),(445866,12386,'bg','',0),(445867,12386,'ur','',0),(445868,12386,'sr','',0),(445869,12386,'vi','',0),(445870,12386,'af','',0),(445871,12386,'ro','',0),(445872,12386,'et','',0),(445873,12386,'si','',0),(445874,12386,'ba','',0),(445875,12386,'nl','',0),(445876,12386,'fi','',0),(445877,12386,'no','',0),(445878,12386,'da','',0),(445879,12386,'ko','',0),(445880,12386,'he','',0),(445881,12386,'el','',0),(445882,12386,'zh','',0),(445883,12386,'sv','',0),(445884,12386,'it','',0),(445885,12386,'tl','',0),(445886,12386,'th','',0),(445887,12386,'hi','',0),(445888,12386,'ms','',0),(445889,12386,'ar','',0),(445890,12386,'fr','',0),(445891,12386,'jp','',0),(445892,12386,'pt','',0),(445893,12386,'ru','',0),(445894,12386,'es','',0),(445895,12386,'de','',0),(445896,12386,'en','',0),(445897,12387,'is','',0),(445898,12387,'dr','Ù‚ÛŒÙ…Øª Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§ÛŒØ¬Ø§Ø¯ Ø´ÙˆØ¯ Ø§Ø² Ø·Ø±ÛŒÙ‚ Ù…Ø³ÛŒØ±: Ø³ÙØ§Ø±Ø´Ø§Øª-Ø³ÙØ§Ø±Ø´Ø§Øª Ú©Ø§Ù„Ø§-ÙˆÛŒØ±Ø§ÛŒØ´/ Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÛŒØ¯',0),(445899,12387,'pr','Ù‚ÛŒÙ…Øª Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§ÛŒØ¬Ø§Ø¯ Ø´ÙˆØ¯ Ø§Ø² Ø·Ø±ÛŒÙ‚ Ù…Ø³ÛŒØ±: Ø³ÙØ§Ø±Ø´Ø§Øª-Ø³ÙØ§Ø±Ø´Ø§Øª Ú©Ø§Ù„Ø§-ÙˆÛŒØ±Ø§ÛŒØ´/ Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÛŒØ¯',0),(445900,12387,'tr','TÄ±rnak iÅŸaretleri giderek oluÅŸturulabilir:<p><b>SipariÅŸleri madde sipariÅŸleri yeni/DÃ¼zenle sipariÅŸ->-></b><p>KarÅŸÄ±lama sipariÅŸi modunda sipariÅŸ bilgilerinizi girin ve ekranÄ±n altÄ±ndaki \"AlÄ±ntÄ± olarak kaydet\" dÃ¼ÄŸmesini tÄ±klatÄ±n.',0),(445901,12387,'pl','Cytaty mogÄ… byÄ‡ tworzone, przechodzÄ…c do:<p><b>ZamÃ³wienia-> przedmiotu zamÃ³wienia-> nowy edycja zamâ‰¤wienia</b><p>WprowadÅº informacje o trybie realizacji zamÃ³wienia i kliknij przycisk \"Zapisz jako cytat\" na dole ekranu.',0),(445902,12387,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð¸Ñ‚Ðµ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð¸ ÐºÐ°Ñ‚Ð¾ Ð¾Ñ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð°:<p><b>ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸-> ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸-> Ð½Ð¾Ð²Ð¸/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°</b><p>Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¸Ð½Ñ',0),(445903,12387,'ur','ÙˆØ§ÙˆÛŒÙ† Ú©ÛŒ Ø·Ø±Ù Ø¬Ø§ØªÛ’ ÛÙˆØ¦Û’ Ø¨Ù†Ø§Ø¦Û’ Ø¬Ø§ Ø³Ú©ØªÛ’ ÛÛŒÚº:<p><b>Ù†Ø¦ÛŒ/ØªØ¯ÙˆÛŒÙ† Ú©ÛŒ ØªØ±ØªÛŒØ¨-> Ø´Û’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª-> Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª</b><p>Ø¢Ø±ÚˆØ± ØªÚ©Ù…ÛŒÙ„ Ù…ÙˆÚˆ Ù…ÛŒÚº Ø¢Ù¾ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø±Ø¬ Ú©Ø±ÛŒÚº ',0),(445904,12387,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ðµ ÑÐµ Ð¼Ð¾Ð³Ñƒ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ Ñ‚Ð°ÐºÐ¾ ÑˆÑ‚Ð¾ Ñ›ÐµÑ‚Ðµ Ð¿Ð¾ÑÐµÑ‚Ð¸Ñ‚Ð¸:<p><b>ÐÐ°Ð»Ð¾Ð³Ðµ Ð¸ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¸ Ð½Ð¾Ð²Ð¸Ñ…/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°</b><p>Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ñƒ Ñ€ÐµÐ¶Ð¸',0),(445905,12387,'vi','BÃ¡o giÃ¡ cÃ³ thá»ƒ Ä‘Æ°á»£c táº¡o báº±ng cÃ¡ch:Ä‘Æ¡n Ä‘áº·t hÃ ng-danh má»¥c Ä‘Æ¡n Ä‘áº·t hÃ ng-thÃªm/sá»­a Ä‘Æ¡n Ä‘áº·t hÃ ng.Nháº­p thÃ´ng tin Ä‘áº·t hÃ ng vÃ o cháº¿ Ä‘á»™ Ä‘áº·t hÃ ng hoÃ n táº¥t vÃ  báº¥m vÃ o nÃºt lÆ°u bÃªn dÆ°á»›i cá»§a mÃ n hÃ¬nh',0),(445906,12387,'af','Aanhalings kan geskep word deur te gaan na:<p><b>Bestellings-> Item bestellings-> nuwe/redigeer orde</b><p>Tik jou bestelling inligting in die vervulling orde modus en klik die \"Stoor as haal\"-knoppie aan die onderkant van die skerm.',0),(445907,12387,'ro','Citate pot fi create de gÃ¢nd sÄƒ:<p><b>Comenzi-> element comenzi-> nouÄƒ/editare comanda</b><p>IntroduceÅ£i informaÅ£iile de ordine Ã®n modul de Ã®mplinire ordine ÅŸi faceÅ£i clic pe butonul \"Salvare ca citez\" Ã®n partea de jos a ecranului.',0),(445908,12387,'et','Pakkumisi saab luua minnes:<p><b>Tellimused-> kauba tellimuste-> uus/Muuda jÃ¤rjekorras</b><p>Sisestage tellimuse andmed reÅ¾iimis plaanitud tellimus ja klÃµpsake \"Salvesta kui tsiteerida\" ekraani allservas nuppu.',0),(445909,12387,'si','Ponudbe lahko ustvaril boÅ¡:<p><b>NaroÄila-> element naroÄila-> nove izdajati/naroÄilo</b><p>Vnesite informacije o naroÄilu v naÄinu izpolnitve nalog in kliknite gumb \"Shrani kot citat\" na dnu zaslona.',0),(445910,12387,'ba','Harga dapat dibuat dengan pergi ke:<p><b>Perintah-> Item Pesanan-> Order Baru/Edit</b><p>Masukkan informasi permintaan Anda dalam modus pemenuhan Order dan klik tombol \"Simpan sebagai Penawaran\" di bagian bawah layar.',0),(445911,12387,'nl','Citaten kunnen worden gemaakt door te gaan naar:<p><b>Bestellingen-> Item Orders-> nieuwe/bewerken volgorde</b><p>Voer uw bestelinformatie in de volgorde van vervulling-modus en klik op de \"Opslaan als Quote\" knop aan de onderkant van het scherm.',0),(445912,12387,'fi','Lainaa voidaan luoda menemÃ¤llÃ¤:<p><b>Tilaukset-> kohteen tilauksia-> uusi tai Muokkaa tilauksen</b><p>Anna tilauksen tiedot suunnitellun tilauksen tila ja valitse \"Tallenna kuin Quote\" napittaa aikaa nojautua-lta irtoseinÃ¤.',0),(445913,12387,'no','Tilbud kan opprettes ved Ã¥ gÃ¥ til:<p><b>Bestillinger-> element ordrer-> ny/Rediger rekkefÃ¸lge</b><p>Angi ordreinformasjonen i innfrielsesordren modus og klikk pÃ¥ \"Lagre som Quote\" knappen nederst pÃ¥ skjermen.',0),(445914,12387,'da','Citater kan oprettes ved at gÃ¥ til:<p><b>Ordrer-> vare ordrer-> ny/Rediger rÃ¦kkefÃ¸lge</b><p>Indtast dine ordreoplysninger i opfyldningsordren tilstand og klik pÃ¥ knappen \"Gem som citat\" nederst pÃ¥ skÃ¦rmen.',0),(445915,12387,'ko','ë”°ì˜´í‘œëŠ” ì´ë™ í•˜ ì—¬ ë§Œë“¤ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p><b>ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘ ìˆœì„œ-> í•­ëª© ìˆœì„œ-> ì£¼ë¬¸</b><p>í–‰ ìˆœì„œ ëª¨ë“œì—ì„œ ì£¼ë¬¸ ì •ë³´ë¥¼ ìž…ë ¥ í•˜ ê³  í™”ë©´ í•˜ë‹¨ì— ìžˆëŠ” \"ê²¬ì ìœ¼ë¡œ ì €ìž¥\" ë²„íŠ¼ì„ í´ë¦­ í•©ë‹ˆë‹¤.',0),(445916,12387,'he','×”×¦×¢×•×ª ×ž×—×™×¨ × ×™×ª×Ÿ ×œ×™×¦×•×¨ ×¢×œ ×™×“×™ ×”×•×œ×š:<p><b>×”×–×ž× ×•×ª-> ×¤×¨×™×˜ ×¤×§×•×“×•×ª-> ×—×“×©×”/×¢×¨×™×›×ª ×”×¡×“×¨</b><p>×”×–×Ÿ ××ª ×¤×¨×˜×™×š ×¡×“×¨ ×‘×ž×¦×‘ ×”×’×©×ž×” ×¡×“×¨ ×•×œ×—×¥ ×¢×œ ×œ×—×¦×Ÿ \"×©×ž×•×¨ ×›×ž×• ×”×¦×¢×ª ×ž×—×™×¨',0),(445917,12387,'el','Î‘Ï€Î¿ÏƒÏ€Î¬ÏƒÎ¼Î±Ï„Î± Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸Î¿ÏÎ½ Î¼Îµ Ï„Î· Î¼ÎµÏ„Î¬Î²Î±ÏƒÎ·:<p><b>Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚-> ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚-> Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±</b><p>Î•Î¹ÏƒÎ¬Î³ÎµÏ„',0),(445918,12387,'zh','åˆ›å»ºæŠ¥ä»·å¯åˆ°ï¼šè®¢å•->é¡¹ç›®è®¢å•->æ–°å»º/ç¼–è¾‘è®¢å•ã€‚åœ¨å±¥è¡Œè®¢å•æ¨¡å¼ä¸­è¾“å…¥æ‚¨çš„è®¢å•ä¿¡æ¯å¹¶ç‚¹å‡»é¡µé¢åº•éƒ¨çš„â€œä½œä¸ºæŠ¥ä»·ä¿å­˜â€é”®ã€‚',0),(445919,12387,'sv','Citat kan skapas genom att gÃ¥ till:<p><b>Order-> post order-> ny/redigera Order</b><p>Ange din orderinformation i uppfyllelseordern lÃ¤ge och klicka pÃ¥ knappen \"Spara som citat\" lÃ¤ngst ned pÃ¥ skÃ¤rmen.',0),(445920,12387,'it','Citazioni possono essere creati selezionando:<p><b>Ordini-> voce ordini-> nuova/modifica ordine</b><p>Inserisci le tue informazioni di ordine nella modalitÃ  di adempimento di ordine e clicca sul pulsante \"Salva come citazione\" nella parte inferiore dello',0),(445921,12387,'tl','',0),(445922,12387,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹„à¸›à¸¢à¸±à¸‡:<p><b>à¸ªà¸±à¹ˆà¸‡->à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²->à¸ªà¸±à¹ˆà¸‡à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚</b><p>à¸›à¹‰à¸­à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‚à¸­à¸‡à¸„',0),(445923,12387,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾ à¤°à¤¹à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ:<p><b>à¤†à¤‡à¤Ÿà¤® à¤¨à¤/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶-> à¤†à¤¦à¥‡à¤¶-> à¤†à¤¦à¥‡à¤¶</b><p>à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤',0),(445924,12387,'ms','Sebut harga boleh dibuat dengan pergi ke:<p><b>Perintah-> Item pesanan-> perintah baru/Edit</b><p>Masukkan maklumat pesanan anda dalam mod memenuhi perintah dan klik butang \"Simpan sebagai Quote\" di bahagian bawah skrin.',0),(445925,12387,'ar','ÙŠÙ…ÙƒÙ† Ø¥Ù†Ø´Ø§Ø¡ Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ø§Ù„Ø°Ù‡Ø§Ø¨ Ø¥Ù„Ù‰:<p><b>Ø£ÙˆØ§Ù…Ø±-> Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø¯-> Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¬Ø¯ÙŠØ¯/ØªØ­Ø±ÙŠØ±</b><p>Ø£Ø¯Ø®Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ ÙÙŠ ÙˆØ¶Ø¹ \"Ø£Ù…Ø± Ø§Ù„Ø§Ø³ØªÙŠÙØ§Ø¡',0),(445926,12387,'fr','Citations peuvent Ãªtre crÃ©Ã©es en allant sur :<p><b>Commandes-> commandes point-> ordre nouveau/modifier</b><p>Entrez les informations de votre commande dans le mode de l\'ordre de traitement, puis cliquez sur le bouton Â« Enregistrer comme soumission Â»',0),(445927,12387,'jp','å¼•ç”¨ç¬¦ã«è¡Œãã“ã¨ã«ã‚ˆã£ã¦ä½œæˆã§ãã¾ã™ã€‚<p><b>ç·¨é›†/æ–°ã—ã„é †åº-> é …ç›®æ³¨æ–‡-> æ³¨æ–‡</b><p>ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼ ãƒ¢ãƒ¼ãƒ‰ã§æ³¨æ–‡æƒ…å ±ã‚’å…¥åŠ›ã—ã€ç”»é¢ã®ä¸‹éƒ¨ã«ã€Œå¼•ç”¨ã¨ã—ã¦ä¿å­˜ã€ãƒœã‚¿ãƒ³ã‚’ã‚¯ãƒ',0),(445928,12387,'pt','CotaÃ§Ãµes podem ser criadas por que:<p><b>Ordens-> Item ordens-> novo/editar ordem</b><p>Digite suas informaÃ§Ãµes de ordem no modo de cumprimento de ordem e clique no botÃ£o \"Salvar como citar\" na parte inferior da tela.',0),(445929,12387,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ñ‹ Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ ÑÐ¾Ð·Ð´Ð°Ð½Ñ‹ Ð¿ÑƒÑ‚ÐµÐ¼ Ð¸Ð´Ñ‚Ð¸ Ðº:<p><b>Ð—Ð°ÐºÐ°Ð·Ñ‹-> Ð¿ÑƒÐ½ÐºÑ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²-> Ð½Ð¾Ð²Ñ‹Ðµ Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·</b><p>Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð¾ Ð²Ð°ÑˆÐµÐ¼ Ð·Ð°ÐºÐ°Ð·Ðµ Ð² Ñ€ÐµÐ¶Ð¸Ð¼Ð',0),(445930,12387,'es','Se crea cotizaciones por ir a: <p><b>Ordenes -> Ordenes de Items -> Nuevo/Editar Orden</b><p>\r\nEntra su informaciÃ³n de orden en el modo de Orden de Cumplimiiento y hace clik en el botÃ³n \"Guardar como CotizaciÃ³n\" en bajo de la pantalla.',0),(445931,12387,'de','Zitate kÃ¶nnen erstellt werden, indem Sie auf:<p><b>Bestellungen-> Element Bestellungen-> Reihenfolge neu/bearbeiten</b><p>Geben Sie Ihre Bestellinformationen im AusfÃ¼hrungsauftrag-Modus, und klicken Sie auf \"Speichern als Zitat\" am unteren Rand des Bild',0),(445932,12387,'en','Quotes can be created by going to:<p><b>Orders -> Item Orders -> New/Edit Order</b><p>\r\nEnter your order information in the Fulfillment Order mode and click the \"Save as Quote\" button at the bottom of the screen.',0),(445933,12388,'is','',0),(445934,12388,'dr','',0),(445935,12388,'pr','',0),(445936,12388,'tr','',0),(445937,12388,'pl','',0),(445938,12388,'bg','',0),(445939,12388,'ur','',0),(445940,12388,'sr','',0),(445941,12388,'vi','',0),(445942,12388,'af','',0),(445943,12388,'ro','',0),(445944,12388,'et','',0),(445945,12388,'si','',0),(445946,12388,'ba','',0),(445947,12388,'nl','',0),(445948,12388,'fi','',0),(445949,12388,'no','',0),(445950,12388,'da','',0),(445951,12388,'ko','',0),(445952,12388,'he','',0),(445953,12388,'el','',0),(445954,12388,'zh','',0),(445955,12388,'sv','',0),(445956,12388,'it','',0),(445957,12388,'tl','',0),(445958,12388,'th','',0),(445959,12388,'hi','',0),(445960,12388,'ms','',0),(445961,12388,'ar','',0),(445962,12388,'fr','',0),(445963,12388,'jp','',0),(445964,12388,'pt','',0),(445965,12388,'ru','',0),(445966,12388,'es','',0),(445967,12388,'de','',0),(445968,12388,'en','',0),(445969,12389,'is','',0),(445970,12389,'dr','',0),(445971,12389,'pr','',0),(445972,12389,'tr','',0),(445973,12389,'pl','',0),(445974,12389,'bg','',0),(445975,12389,'ur','',0),(445976,12389,'sr','',0),(445977,12389,'vi','',0),(445978,12389,'af','',0),(445979,12389,'ro','',0),(445980,12389,'et','',0),(445981,12389,'si','',0),(445982,12389,'ba','',0),(445983,12389,'nl','',0),(445984,12389,'fi','',0),(445985,12389,'no','',0),(445986,12389,'da','',0),(445987,12389,'ko','',0),(445988,12389,'he','',0),(445989,12389,'el','',0),(445990,12389,'zh','',0),(445991,12389,'sv','',0),(445992,12389,'it','',0),(445993,12389,'tl','',0),(445994,12389,'th','',0),(445995,12389,'hi','',0),(445996,12389,'ms','',0),(445997,12389,'ar','',0),(445998,12389,'fr','',0),(445999,12389,'jp','',0),(446000,12389,'pt','',0),(446001,12389,'ru','',0),(446002,12389,'es','',0),(446003,12389,'de','',0),(446004,12389,'en','',0),(446005,12390,'is','',0),(446006,12390,'dr','',0),(446007,12390,'pr','',0),(446008,12390,'tr','',0),(446009,12390,'pl','',0),(446010,12390,'bg','',0),(446011,12390,'ur','',0),(446012,12390,'sr','',0),(446013,12390,'vi','',0),(446014,12390,'af','',0),(446015,12390,'ro','',0),(446016,12390,'et','',0),(446017,12390,'si','',0),(446018,12390,'ba','',0),(446019,12390,'nl','',0),(446020,12390,'fi','',0),(446021,12390,'no','',0),(446022,12390,'da','',0),(446023,12390,'ko','',0),(446024,12390,'he','',0),(446025,12390,'el','',0),(446026,12390,'zh','',0),(446027,12390,'sv','',0),(446028,12390,'it','',0),(446029,12390,'tl','',0),(446030,12390,'th','',0),(446031,12390,'hi','',0),(446032,12390,'ms','',0),(446033,12390,'ar','',0),(446034,12390,'fr','',0),(446035,12390,'jp','',0),(446036,12390,'pt','',0),(446037,12390,'ru','',0),(446038,12390,'es','',0),(446039,12390,'de','',0),(446040,12390,'en','',0),(446041,12391,'is','',0),(446042,12391,'dr','',0),(446043,12391,'pr','',0),(446044,12391,'tr','',0),(446045,12391,'pl','',0),(446046,12391,'bg','',0),(446047,12391,'ur','',0),(446048,12391,'sr','',0),(446049,12391,'vi','',0),(446050,12391,'af','',0),(446051,12391,'ro','',0),(446052,12391,'et','',0),(446053,12391,'si','',0),(446054,12391,'ba','',0),(446055,12391,'nl','',0),(446056,12391,'fi','',0),(446057,12391,'no','',0),(446058,12391,'da','',0),(446059,12391,'ko','',0),(446060,12391,'he','',0),(446061,12391,'el','',0),(446062,12391,'zh','',0),(446063,12391,'sv','',0),(446064,12391,'it','',0),(446065,12391,'tl','',0),(446066,12391,'th','',0),(446067,12391,'hi','',0),(446068,12391,'ms','',0),(446069,12391,'ar','',0),(446070,12391,'fr','',0),(446071,12391,'jp','',0),(446072,12391,'pt','',0),(446073,12391,'ru','',0),(446074,12391,'es','',0),(446075,12391,'de','',0),(446076,12391,'en','',0),(446077,12392,'is','',0),(446078,12392,'dr','',0),(446079,12392,'pr','',0),(446080,12392,'tr','',0),(446081,12392,'pl','',0),(446082,12392,'bg','',0),(446083,12392,'ur','',0),(446084,12392,'sr','',0),(446085,12392,'vi','',0),(446086,12392,'af','',0),(446087,12392,'ro','',0),(446088,12392,'et','',0),(446089,12392,'si','',0),(446090,12392,'ba','',0),(446091,12392,'nl','',0),(446092,12392,'fi','',0),(446093,12392,'no','',0),(446094,12392,'da','',0),(446095,12392,'ko','',0),(446096,12392,'he','',0),(446097,12392,'el','',0),(446098,12392,'zh','',0),(446099,12392,'sv','',0),(446100,12392,'it','',0),(446101,12392,'tl','',0),(446102,12392,'th','',0),(446103,12392,'hi','',0),(446104,12392,'ms','',0),(446105,12392,'ar','',0),(446106,12392,'fr','',0),(446107,12392,'jp','',0),(446108,12392,'pt','',0),(446109,12392,'ru','',0),(446110,12392,'es','',0),(446111,12392,'de','',0),(446112,12392,'en','',0),(446113,12393,'is','',0),(446114,12393,'dr','',0),(446115,12393,'pr','',0),(446116,12393,'tr','',0),(446117,12393,'pl','',0),(446118,12393,'bg','',0),(446119,12393,'ur','',0),(446120,12393,'sr','',0),(446121,12393,'vi','',0),(446122,12393,'af','',0),(446123,12393,'ro','',0),(446124,12393,'et','',0),(446125,12393,'si','',0),(446126,12393,'ba','',0),(446127,12393,'nl','',0),(446128,12393,'fi','',0),(446129,12393,'no','',0),(446130,12393,'da','',0),(446131,12393,'ko','',0),(446132,12393,'he','',0),(446133,12393,'el','',0),(446134,12393,'zh','',0),(446135,12393,'sv','',0),(446136,12393,'it','',0),(446137,12393,'tl','',0),(446138,12393,'th','',0),(446139,12393,'hi','',0),(446140,12393,'ms','',0),(446141,12393,'ar','',0),(446142,12393,'fr','',0),(446143,12393,'jp','',0),(446144,12393,'pt','',0),(446145,12393,'ru','',0),(446146,12393,'es','',0),(446147,12393,'de','',0),(446148,12393,'en','',0),(446149,12394,'is','',0),(446150,12394,'dr','',0),(446151,12394,'pr','',0),(446152,12394,'tr','',0),(446153,12394,'pl','',0),(446154,12394,'bg','',0),(446155,12394,'ur','',0),(446156,12394,'sr','',0),(446157,12394,'vi','',0),(446158,12394,'af','',0),(446159,12394,'ro','',0),(446160,12394,'et','',0),(446161,12394,'si','',0),(446162,12394,'ba','',0),(446163,12394,'nl','',0),(446164,12394,'fi','',0),(446165,12394,'no','',0),(446166,12394,'da','',0),(446167,12394,'ko','',0),(446168,12394,'he','',0),(446169,12394,'el','',0),(446170,12394,'zh','',0),(446171,12394,'sv','',0),(446172,12394,'it','',0),(446173,12394,'tl','',0),(446174,12394,'th','',0),(446175,12394,'hi','',0),(446176,12394,'ms','',0),(446177,12394,'ar','',0),(446178,12394,'fr','',0),(446179,12394,'jp','',0),(446180,12394,'pt','',0),(446181,12394,'ru','',0),(446182,12394,'es','',0),(446183,12394,'de','',0),(446184,12394,'en','',0),(446185,12395,'is','',0),(446186,12395,'dr','',0),(446187,12395,'pr','',0),(446188,12395,'tr','',0),(446189,12395,'pl','',0),(446190,12395,'bg','',0),(446191,12395,'ur','',0),(446192,12395,'sr','',0),(446193,12395,'vi','',0),(446194,12395,'af','',0),(446195,12395,'ro','',0),(446196,12395,'et','',0),(446197,12395,'si','',0),(446198,12395,'ba','',0),(446199,12395,'nl','',0),(446200,12395,'fi','',0),(446201,12395,'no','',0),(446202,12395,'da','',0),(446203,12395,'ko','',0),(446204,12395,'he','',0),(446205,12395,'el','',0),(446206,12395,'zh','',0),(446207,12395,'sv','',0),(446208,12395,'it','',0),(446209,12395,'tl','',0),(446210,12395,'th','',0),(446211,12395,'hi','',0),(446212,12395,'ms','',0),(446213,12395,'ar','',0),(446214,12395,'fr','',0),(446215,12395,'jp','',0),(446216,12395,'pt','',0),(446217,12395,'ru','',0),(446218,12395,'es','',0),(446219,12395,'de','',0),(446220,12395,'en','',0),(446221,12396,'is','',0),(446222,12396,'dr','',0),(446223,12396,'pr','',0),(446224,12396,'tr','',0),(446225,12396,'pl','',0),(446226,12396,'bg','',0),(446227,12396,'ur','',0),(446228,12396,'sr','',0),(446229,12396,'vi','',0),(446230,12396,'af','',0),(446231,12396,'ro','',0),(446232,12396,'et','',0),(446233,12396,'si','',0),(446234,12396,'ba','',0),(446235,12396,'nl','',0),(446236,12396,'fi','',0),(446237,12396,'no','',0),(446238,12396,'da','',0),(446239,12396,'ko','',0),(446240,12396,'he','',0),(446241,12396,'el','',0),(446242,12396,'zh','',0),(446243,12396,'sv','',0),(446244,12396,'it','',0),(446245,12396,'tl','',0),(446246,12396,'th','',0),(446247,12396,'hi','',0),(446248,12396,'ms','',0),(446249,12396,'ar','',0),(446250,12396,'fr','',0),(446251,12396,'jp','',0),(446252,12396,'pt','',0),(446253,12396,'ru','',0),(446254,12396,'es','',0),(446255,12396,'de','',0),(446256,12396,'en','',0),(446257,12397,'is','',0),(446258,12397,'dr','',0),(446259,12397,'pr','',0),(446260,12397,'tr','',0),(446261,12397,'pl','',0),(446262,12397,'bg','',0),(446263,12397,'ur','',0),(446264,12397,'sr','',0),(446265,12397,'vi','',0),(446266,12397,'af','',0),(446267,12397,'ro','',0),(446268,12397,'et','',0),(446269,12397,'si','',0),(446270,12397,'ba','',0),(446271,12397,'nl','',0),(446272,12397,'fi','',0),(446273,12397,'no','',0),(446274,12397,'da','',0),(446275,12397,'ko','',0),(446276,12397,'he','',0),(446277,12397,'el','',0),(446278,12397,'zh','',0),(446279,12397,'sv','',0),(446280,12397,'it','',0),(446281,12397,'tl','',0),(446282,12397,'th','',0),(446283,12397,'hi','',0),(446284,12397,'ms','',0),(446285,12397,'ar','',0),(446286,12397,'fr','',0),(446287,12397,'jp','',0),(446288,12397,'pt','',0),(446289,12397,'ru','',0),(446290,12397,'es','',0),(446291,12397,'de','',0),(446292,12397,'en','',0),(446293,12398,'is','',0),(446294,12398,'dr','Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² ØªØ§Ø±ÛŒØ® Ø¨Ù‡ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§:Ù…Ø¯ÛŒØ±ÛŒØª -Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø´Ø±Ú©Øª\r\nØ¨Ø±Ùˆ Ø¨Ù‡ ØªØ¨ Ø§Ø¬Ø±Ø§(ØªÚ©Ù…ÛŒÙ„)Ùˆ Ø®Ø¯Ù…Ø§Øª Ø³ÙØ§Ø±Ø´.ÙØ§Ú©ØªÙˆØ± Ø±Ø§Ø¨Ù‡ Ø¬Ø§ÛŒ ØªØ§Ø±Û',0),(446295,12398,'pr','Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² ØªØ§Ø±ÛŒØ® Ø¨Ù‡ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§:Ù…Ø¯ÛŒØ±ÛŒØª -Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø´Ø±Ú©Øª\r\nØ¨Ø±Ùˆ Ø¨Ù‡ ØªØ¨ Ø§Ø¬Ø±Ø§(ØªÚ©Ù…ÛŒÙ„)Ùˆ Ø®Ø¯Ù…Ø§Øª Ø³ÙØ§Ø±Ø´.ÙØ§Ú©ØªÙˆØ± Ø±Ø§Ø¨Ù‡ Ø¬Ø§ÛŒ ØªØ§Ø±Û',0),(446296,12398,'tr','Ã–n sipariÅŸleri faturalar iÃ§in bugÃ¼ne kadar:<p><b>YÃ¶netici Kurulumu-fatura ÅŸirket seÃ§enekleri->->.</b><p>Yerine getirilmesi ve servis sipariÅŸleri sekmesine gidin.<p>\'Fatura geÃ§erli tarihi yerine sipariÅŸ tarihini kullanarak\' kontrol edin.',0),(446297,12398,'pl','Aby przed datÄ… zamÃ³wienia faktury:<p><b>Admin->-> firmy opcje konfiguracji rozliczeÅ„.</b><p>PrzejdÅº na zakÅ‚adkÄ™ speÅ‚nienie i zleceÅ„ serwisowych.<p>SprawdÅº \"faktury za pomocÄ… Data zamÃ³wienia, a nie Data bieÅ¼Ä…ca\".',0),(446298,12398,'bg','Ð”Ð° Ð¿Ñ€ÐµÐ´ÑˆÐµÑÑ‚Ð²Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÐºÑŠÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¾Ð¿Ñ†Ð¸Ð¸.</b><p>ÐžÑ‚Ð¸Ð´ÐµÑ‚Ðµ Ð² Ñ€Ð°Ð·Ð´ÐµÐ»Ð° Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(446299,12398,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù‚Ø¨Ù„ Ø§Ø² ØªØ§Ø±ÛŒØ® Ú©Û’ Ù„ÛŒÛ’:<p><b>Ø§ÛŒÚˆÙ…Ù† Ø³ÛŒÙ¹ Ø§Ù¾-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª->-> Û”</b><p>ØªÚ©Ù…ÛŒÙ„ Ø§ÙˆØ± Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø¯ÙˆÙ„ Ù¾Ø± Ø¬Ø§Ø¦ÛŒÚº Û”<p>\'Ø§Ù†ÙˆØ§Ø',0),(446300,12398,'sr','Ð”Ð° ÑƒÐ½Ð°Ð¿Ñ€ÐµÐ´ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ° Ð´Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ-Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ.</b><p>Ð˜Ð´Ð¸Ñ‚Ðµ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð¸ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ.<p>ÐŸ',0),(446301,12398,'vi','Äá»ƒ ngÃ y Ä‘Æ¡n Ä‘áº·t hÃ ng trÆ°á»›c hÃ³a Ä‘Æ¡n: Quáº£n lÃ½-thiáº¿t láº­p thanh toÃ¡n-tÃ¹y chá»n cÃ´ng ty. VÃ o tab Ä‘Æ¡n Ä‘áº·t hÃ ng hoÃ n táº¥t vÃ  kiá»ƒm tra\"ngÃ y hÃ³a Ä‘Æ¡n trÆ°á»›c ngÃ y hiá»‡n hÃ nh\"',0),(446302,12398,'af','Tot op datum vooraf bestellings om fakture:<p><b>Admin-> opstel-fakturering-> maatskappy opsies.</b><p>Gaan na die vervulling en diens bestellings-oortjie.<p>Kontroleer die \'faktuur datum orde eerder as huidige datum gebruik\'.',0),(446303,12398,'ro','La pre-data de comenzi pentru facturi:<p><b>Admin-> Setup-facturare-> opÅ£iuni de companie.</b><p>Du-te la fila Ã®mplinire ÅŸi comenzile de Service.<p>Verifica factura utilizÃ¢nd comanda data, mai degrabÄƒ decÃ¢t data curentÄƒ.',0),(446304,12398,'et','Eelnevalt praeguseks tellimuste arvetele:<p><b>Admin-> Setup-arved-> ettevÃµtte vÃµimalusi.</b><p>Minge vahekaardile eneseteostus ja hooldustellimusi.<p>Kontrollige \"Arve tellimuse kuupÃ¤ev, mitte tÃ¤nane kuupÃ¤ev\".',0),(446305,12398,'si','V pre-rok naroÄila za raÄune:<p><b>Admin-> Setup-zaraÄunavanje-> podjetje moÅ¾nosti.</b><p>Pojdite na zavihek izpolnitev in servisnih nalogov.<p>Preverite \"RaÄun uporabi datum naloga kot trenutni datum\".',0),(446306,12398,'ba','Untuk pra-tanggal perintah untuk faktur:<p><b>Admin-> Setup-penagihan-> perusahaan pilihan.</b><p>Pergi ke tab pemenuhan dan layanan pesanan.<p>Periksa \'faktur menggunakan tanggal Order daripada tanggal saat ini\'.',0),(446307,12398,'nl','Tot op heden vooraf Orders naar facturen:<p><b>Admin-> Setup-Billing-> bedrijf opties.</b><p>Ga naar het tabblad vervulling en serviceorders.<p>Controleer de \'factureren met behulp van Orderdatum in plaats van huidige datum\'.',0),(446308,12398,'fi','Jotta edellinen-ajoittaa tilaukset laskuihin:<p><b>Admin asetukset-laskutus-> yhtiÃ¶lle vaihtoehtoja->.</b><p>Siirry tÃ¤yttÃ¤minen ja huoltotilausten vÃ¤lilehti.<p>Tarkista \'Laskuttaa tilauksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ kuin nykyinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤\'.',0),(446309,12398,'no','Hittil pre ordrer til fakturaer:<p><b>Admin-> Setup-fakturering-> selskapet alternativer.</b><p>GÃ¥ til kategorien oppfyllelse og serviceordrer.<p>Sjekk \'faktura med dato i stedet for gjeldende dato.',0),(446310,12398,'da','Til forud for ordrer til fakturaer:<p><b>Admin-> Setup-fakturering-> selskab muligheder.</b><p>GÃ¥ til fanen opfyldelse og serviceordrer.<p>Indskrive den \"faktura ved hjÃ¦lp af Ordredato i stedet for dags dato\'.',0),(446311,12398,'ko','ë¯¸ë¦¬ ì£¼ë¬¸ ì†¡ìž¥ ë‚ ì§œ:<p><b>ê´€ë¦¬ìž ì„¤ì •-ê²°ì œ íšŒì‚¬ ì˜µì…˜->->ìž…ë‹ˆë‹¤.</b><p>ì´ í–‰ ë° ì„œë¹„ìŠ¤ ì£¼ë¬¸ íƒ­ìœ¼ë¡œ ì´ë™ í•©ë‹ˆë‹¤.<p>\'ì†¡ìž¥ ì£¼ë¬¸ ë‚ ì§œ ëŒ€ì‹  í˜„ìž¬ ë‚ ì§œë¥¼ ì‚¬ìš© í•˜ ì—¬\' í™•ì¸ í•˜ì‹­ì‹œì˜¤.',0),(446312,12398,'he','×œ×¦××ª ×ž×¨××© ×”×–×ž× ×•×ª ×œ×—×©×‘×•× ×™×•×ª:<p><b>Admin-> ×”×”×ª×§× ×”-×—×™×•×‘-> ××¤×©×¨×•×™×•×ª ×”×—×‘×¨×”.</b><p>×¢×‘×•×¨ ××œ ×”×›×¨×˜×™×¡×™×” ×”×’×©×ž×” ×©×œ ×”×–×ž× ×•×ª ×©×™×¨×•×ª.<p>×‘×“×•×§ ××ª \'×—×©×‘×•× ×™×ª ×ž×©×ª×ž×© ×ª××¨×™×š ×”×–×ž',0),(446313,12398,'el','ÎÎ± Ï€ÏÎ¿Î·Î³Î·Î¸ÎµÎ¯ Ï‡ÏÎ¿Î½Î¹ÎºÏŽÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î¼Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±:<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚-> ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚.</b><p>ÎœÎµÏ„Î±Î²ÎµÎ¯Ï„Îµ ÏƒÏ„Î·Î½ ÎºÎ±ÏÏ„Î­Î»Î± ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· ÎºÎ±Î¹ ÎµÎ',0),(446314,12398,'zh','æå‰å‘ç¥¨åˆ°è®¢å•ï¼šç®¡ç†->è®¾ç½®å…¥è´¦->å…¬å¸é€‰é¡¹ã€‚åˆ°å±¥è¡Œå’ŒæœåŠ¡è®¢å•æ ‡ç­¾ã€‚é€‰ä¸­â€œå‘ç¥¨ä½¿ç”¨è®¢å•æ—¥æœŸè€ŒéžçŽ°åœ¨æ—¥æœŸâ€ã€‚',0),(446315,12398,'sv','Hitintills pre order att fakturor:<p><b>Admin-> Setup-fakturering-> fÃ¶retag alternativ.</b><p>GÃ¥ till fliken uppfyllelse och serviceorder.<p>Kontrollera den \"fakturera med Orderdatum i stÃ¤llet fÃ¶r aktuellt datum\".',0),(446316,12398,'it','Fino ad pre-oggi ordini alle fatture:<p><b>Admin->-> azienda opzioni Setup-fatturazione.</b><p>Vai alla scheda adempimento e ordini di servizio.<p>Controllare la \'fattura utilizzando Data ordine piuttosto che la data corrente\'.',0),(446317,12398,'tl','',0),(446318,12398,'th','à¸à¹ˆà¸­à¸™à¸§à¸±à¸™à¸—à¸µà¹ˆà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰:<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™->à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸šà¸£à¸´à¸©à¸±à¸—</b><p>à¹„à¸›à¹à¸—à¹‡à¸šà¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¹à',0),(446319,12398,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤†à¤¦à¥‡à¤¶ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¤¿à¤¥à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª-à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¤¿à¤•à¤²à¥à¤ª->->à¥¤</b><p>à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤”à¤° à',0),(446320,12398,'ms','Setakat pra pesanan untuk invois:<p><b>Admin-> persediaan-bil-> Opsyen Syarikat.</b><p>Pergi ke tab memenuhi dan arahan Perkhidmatan.<p>Semak di \'invois menggunakan tarikh perintah dan bukannya tarikh semasa\'.',0),(446321,12398,'ar','ÙˆØ­ØªÙ‰ Ø§Ù„Ø¢Ù† Ù…Ø§ Ù‚Ø¨Ù„ Ø£ÙˆØ§Ù…Ø± Ù„Ù„ÙÙˆØ§ØªÙŠØ±:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ©.</b><p>Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰ Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¨ÙˆÙŠØ¨ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© ÙˆØ§Ù„ÙˆÙØ§Ø¡.<p>ØªØ­Ù‚Ù‚ Ù…Ù† \'ÙØ§ØªÙˆ',0),(446322,12398,'fr','Aux commandes de factures datent d\'avant :<p><b>Admin-> Setup-facturation-> Options de la sociÃ©tÃ©.</b><p>Allez dans l\'onglet exÃ©cution et des commandes de Service.<p>VÃ©rifier la Date de commande plutÃ´t que la Date actuelle Â« facture Â».',0),(446323,12398,'jp','æ³¨æ–‡ã®è«‹æ±‚æ›¸ã«ã‚‚å‰ã®æ—¥ä»˜: ã«<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è«‹æ±‚ä¼šç¤¾ã‚ªãƒ—ã‚·ãƒ§ãƒ³->->.</b><p>ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆã€ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã®ã‚¿ãƒ–ã«ç§»å‹•ã—ã¾ã™ã€‚<p>\'è«‹æ±‚æ›¸ã®ç¾åœ¨ã®æ—¥ä»˜ã§ã¯ãªãã€å—æ³¨æ—¥ã‚’ä½¿ç”¨ã—',0),(446324,12398,'pt','AtÃ© Ã  pre-data ordens para faturas:<p><b>Admin-> Setup-faturamento-> opÃ§Ãµes de companhia.</b><p>VÃ¡ para a guia de atendimento e ordens de serviÃ§o.<p>Verifica a \'fatura usando a data do pedido, ao invÃ©s de data atual\'.',0),(446325,12398,'ru','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ Ð¿Ð¾ÐºÐ° Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³-> ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚Ñ‹.</b><p>ÐŸÐµÑ€ÐµÐ¹Ð´Ð¸Ñ‚Ðµ Ð½Ð° Ð²ÐºÐ»Ð°Ð´ÐºÑƒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ',0),(446326,12398,'es','Para pre-fechar Ordenes a Facturas:<p><b>Admin -> Configurar Facturas -> Opciones de Empresa.</b><p>\r\nVa a tab de Ordenes de Cumplimiento y Servicio.<p> Chequea la \'Fecha de  Uso de Factura del Orden en Lugar de Fecha Actual ',0),(446327,12398,'de','Bestellungen, Rechnungen bereits bisher:<p><b>Admin-> Setup-Billing-> Firma Optionen.</b><p>Wechseln Sie zur Registerkarte Fulfillment und ServiceauftrÃ¤ge.<p>ÃœberprÃ¼fen Sie die \"Rechnung mit Bestelldatum statt Tagesdatum\'.',0),(446328,12398,'en','To pre-date Orders to Invoices:<p><b>Admin -> Setup-Billing -> Company Options.</b><p>\r\nGo to the Fulfillment and Service Orders tab.<p> Check the \'Invoice Using Order Date Rather Than Current Date\'.',0),(446329,12399,'is','',0),(446330,12399,'dr','',0),(446331,12399,'pr','',0),(446332,12399,'tr','',0),(446333,12399,'pl','',0),(446334,12399,'bg','',0),(446335,12399,'ur','',0),(446336,12399,'sr','',0),(446337,12399,'vi','',0),(446338,12399,'af','',0),(446339,12399,'ro','',0),(446340,12399,'et','',0),(446341,12399,'si','',0),(446342,12399,'ba','',0),(446343,12399,'nl','',0),(446344,12399,'fi','',0),(446345,12399,'no','',0),(446346,12399,'da','',0),(446347,12399,'ko','',0),(446348,12399,'he','',0),(446349,12399,'el','',0),(446350,12399,'zh','',0),(446351,12399,'sv','',0),(446352,12399,'it','',0),(446353,12399,'tl','',0),(446354,12399,'th','',0),(446355,12399,'hi','',0),(446356,12399,'ms','',0),(446357,12399,'ar','',0),(446358,12399,'fr','',0),(446359,12399,'jp','',0),(446360,12399,'pt','',0),(446361,12399,'ru','',0),(446362,12399,'es','',0),(446363,12399,'de','',0),(446364,12399,'en','',0),(446365,12400,'is','',0),(446366,12400,'dr','',0),(446367,12400,'pr','',0),(446368,12400,'tr','',0),(446369,12400,'pl','',0),(446370,12400,'bg','',0),(446371,12400,'ur','',0),(446372,12400,'sr','',0),(446373,12400,'vi','',0),(446374,12400,'af','',0),(446375,12400,'ro','',0),(446376,12400,'et','',0),(446377,12400,'si','',0),(446378,12400,'ba','',0),(446379,12400,'nl','',0),(446380,12400,'fi','',0),(446381,12400,'no','',0),(446382,12400,'da','',0),(446383,12400,'ko','',0),(446384,12400,'he','',0),(446385,12400,'el','',0),(446386,12400,'zh','',0),(446387,12400,'sv','',0),(446388,12400,'it','',0),(446389,12400,'tl','',0),(446390,12400,'th','',0),(446391,12400,'hi','',0),(446392,12400,'ms','',0),(446393,12400,'ar','',0),(446394,12400,'fr','',0),(446395,12400,'jp','',0),(446396,12400,'pt','',0),(446397,12400,'ru','',0),(446398,12400,'es','',0),(446399,12400,'de','',0),(446400,12400,'en','',0),(446401,12401,'is','',0),(446402,12401,'dr','',0),(446403,12401,'pr','',0),(446404,12401,'tr','',0),(446405,12401,'pl','',0),(446406,12401,'bg','',0),(446407,12401,'ur','',0),(446408,12401,'sr','',0),(446409,12401,'vi','',0),(446410,12401,'af','',0),(446411,12401,'ro','',0),(446412,12401,'et','',0),(446413,12401,'si','',0),(446414,12401,'ba','',0),(446415,12401,'nl','',0),(446416,12401,'fi','',0),(446417,12401,'no','',0),(446418,12401,'da','',0),(446419,12401,'ko','',0),(446420,12401,'he','',0),(446421,12401,'el','',0),(446422,12401,'zh','',0),(446423,12401,'sv','',0),(446424,12401,'it','',0),(446425,12401,'tl','',0),(446426,12401,'th','',0),(446427,12401,'hi','',0),(446428,12401,'ms','',0),(446429,12401,'ar','',0),(446430,12401,'fr','',0),(446431,12401,'jp','',0),(446432,12401,'pt','',0),(446433,12401,'ru','',0),(446434,12401,'es','',0),(446435,12401,'de','',0),(446436,12401,'en','',0),(446437,12402,'is','',0),(446438,12402,'dr','',0),(446439,12402,'pr','',0),(446440,12402,'tr','',0),(446441,12402,'pl','',0),(446442,12402,'bg','',0),(446443,12402,'ur','',0),(446444,12402,'sr','',0),(446445,12402,'vi','',0),(446446,12402,'af','',0),(446447,12402,'ro','',0),(446448,12402,'et','',0),(446449,12402,'si','',0),(446450,12402,'ba','',0),(446451,12402,'nl','',0),(446452,12402,'fi','',0),(446453,12402,'no','',0),(446454,12402,'da','',0),(446455,12402,'ko','',0),(446456,12402,'he','',0),(446457,12402,'el','',0),(446458,12402,'zh','',0),(446459,12402,'sv','',0),(446460,12402,'it','',0),(446461,12402,'tl','',0),(446462,12402,'th','',0),(446463,12402,'hi','',0),(446464,12402,'ms','',0),(446465,12402,'ar','',0),(446466,12402,'fr','',0),(446467,12402,'jp','',0),(446468,12402,'pt','',0),(446469,12402,'ru','',0),(446470,12402,'es','',0),(446471,12402,'de','',0),(446472,12402,'en','',0),(446473,12403,'is','',0),(446474,12403,'dr','.Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÛŒØ®Ú†Ù‡ ÙØ±Ù…Ø§ÛŒØ´ Ø¬Ù†Ø³ ÙÙ‚Ø· Ø¢',0),(446475,12403,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÛŒØ§ÙØªÛŒ Ø´Ø§Ù…Ù„ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø³Øª Ø¬Ø§ÛŒÛŒ Ú©Ù‡ Ú©Ø§Ù„Ø§Ù‡Ø§ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ù†Ø¯Ù…Ø«Ù„ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø¨Ø§ Ø²Ù…Ø§Ù† Ú©Ø§Ø±.Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÛŒØ®Ú†Ù‡ Ø³ÙØ§Ø±Ø´ Ú©Ø§Ù„Ø§ ÙÙ‚Ø· Ø¢Ù',0),(446476,12403,'tr','AlÄ±nan sipariÅŸler raporu nerede Ã¶ÄŸeleri, Ã§alÄ±ÅŸma sÃ¼resi ile servis sipariÅŸleri gibi kullanÄ±lmÄ±ÅŸ olabilir deÄŸil sipariÅŸlerini iÃ§erir.<p>Madde sipariÅŸ GeÃ§miÅŸi raporu yalnÄ±zca listeler bir stok maddesi nerede kullanÄ±ldÄ±.',0),(446477,12403,'pl','OtrzymaÅ‚ zamÃ³wienia raportu zawiera zamÃ³wieÅ„, gdzie elementy mogÄ… nie zostaÅ‚y wykorzystane, takich jak zlecenia serwisowe z czasu pracy.<p>Element zamÃ³wienia historia raportu wyÅ›wietla tylko te gdzie towar byÅ‚ uÅ¼ywany.',0),(446478,12403,'bg','Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ ÑÑŠÐ´ÑŠÑ€Ð¶Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, ÐºÑŠÐ´ÐµÑ‚Ð¾ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ðµ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸, ÐºÐ°Ñ‚Ð¾ Ð½Ð°Ð¿Ñ€Ð¸Ð¼ÐµÑ€ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð· Ñ Ñ‚Ñ€ÑƒÐ´ Ð²Ñ€ÐµÐ¼Ðµ.<p>Ð•Ð',0),(446479,12403,'ur','Ø­Ú©Ù… Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Ø±Ù¾ÙˆØ±Ù¹ Ø¬ÛØ§Úº Ø§Ø´ÛŒØ§ØŒ Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…Ø´Ù‚Øª ÙˆÙ‚Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ø³Ø§ØªÚ¾ Ø¬ÛŒØ³Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ ØªØ§Ú©Û Ù†Û Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ø§ Ø­Ø§Ù…Ù„ ÛÛ’ Û”<p>Ø´Û’ ØªØ±ØªÛŒØ¨ ØªØ§Ø±ÛŒØ® Ø±Ù¾ÙˆØ',0),(446480,12403,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÑÐ°Ð´Ñ€Ð¶Ð¸ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð³Ð´Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¼Ð¾Ð¶Ð´Ð° Ð½Ð¸Ñ˜Ðµ Ð¸ÑÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ð¾, ÐºÐ°Ð¾ ÑˆÑ‚Ð¾ ÑÑƒ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ ÑÐ° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¾Ð¼ Ñ€Ð°Ð´Ð°.<p>Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð°',0),(446481,12403,'vi','ÄÆ¡n Ä‘áº·t hÃ ng nháº­n Ä‘Æ°á»£c,bÃ¡o cÃ¡o chá»©a Ä‘á»±ng nhá»¯ng Ä‘Æ¡n hÃ ng nÆ¡i mÃ  cÃ³ nhá»¯ng máº·t hÃ ng khÃ´ng Ä‘Æ°á»£c sá»­ dá»¥ng, nhÆ° lÃ  Ä‘Æ¡n hÃ ng DV vá»›i thá»i gian lÃ m viÃªc. bÃ¡ocÃ¡o chá»‰ liá»‡t kÃª nhá»¯ng máº·t hÃ ng Ä‘Æ°á»£c sdá»',0),(446482,12403,'af','Die bestellings ontvang verslag bevat bestellings waar items mag nie gewoond is, soos diens bestellings met arbeid tyd.<p>Die Item bestel geskiedenis verslag slegs diÃ© lyste waar \'n inventaris item gebruik is.',0),(446483,12403,'ro','Comenzile primite Raportul conÅ£ine comenzi Ã®n cazul Ã®n care elementele pot nu au fost utilizate, cum ar fi comenzi de service cu timp de muncÄƒ.<p>Raportul istoric de comandÄƒ element listele numai cele Ã®n cazul Ã®n care a fost folosit un element de i',0),(446484,12403,'et','Tellimused saadud aruanne sisaldab korraldusi, kus kaupu vÃµib ei kasutatud, nÃ¤iteks hooldustellimused, mille tÃ¶Ã¶ aeg.<p>Kauba tellimuste ajalugu aruandes loetletakse ainult need laokauba publikatsioonilehel.',0),(446485,12403,'si','NaroÄila prejeli poroÄilo vsebuje naloge, kjer elementi morda ni uporabljal, kot so servisni nalogi z labor Äas.<p>Element zgodovine naroÄil poroÄilo prikazuje samo tiste, kjer je bila uporabljena artikla zaloge.',0),(446486,12403,'ba','Menerima pesanan Laporan berisi perintah yang mana item mungkin tidak telah digunakan, seperti layanan pesanan dengan waktu kerja.<p>Laporan sejarah Orde Item daftar hanya mereka mana item persediaan digunakan.',0),(446487,12403,'nl','Het verslag Orders ontvangen bevat bestellingen waar items kunnen niet zijn gebruikt, zoals serviceorders met arbeid tijd.<p>Het Item bestellingshistorie rapport bevat alleen die waar een voorraadartikel werd gebruikt.',0),(446488,12403,'fi','Saadut tilaukset mietinnÃ¶ssÃ¤ tilaukset jossa nimikkeitÃ¤ voi ei on kÃ¤ytetty, kuten huoltotilauksista tyÃ¶ aikaa.<p>Nimikkeen tilaushistoria-raportissa luetellaan vain ne, jossa nimikettÃ¤ on kÃ¤ytetty.',0),(446489,12403,'no','Ordrer mottatt rapporten inneholder ordrer der varer ikke kan har blitt brukt og serviceordrer med arbeidstiden.<p>Elementet ordrehistorikk rapporten viser bare de der en lagervare ble brukt.',0),(446490,12403,'da','Ordrer modtaget rapporten indeholder ordrer, hvor elementer ikke kan har vÃ¦ret anvendt, sÃ¥som serviceordrer med arbejdskraft tid.<p>Rapporten vare ordreoversigten vises kun de hvor en lagervare blev brugt.',0),(446491,12403,'ko','ì£¼ë¬¸ ë°›ì€ ë³´ê³ ì„œ ì–´ë”” í•­ëª© ìˆ˜ëŠ” ì‚¬ìš© ë˜ì§€, ë…¸ë™ ì‹œê°„ ì„œë¹„ìŠ¤ ì£¼ë¬¸ ë“± ì£¼ë¬¸ì„ í¬í•¨ ë˜ì–´ ìžˆìŠµë‹ˆë‹¤.<p>í•­ëª© ìˆœì„œ ê¸°ë¡ ë³´ê³ ì„œ ëª©ë¡ ë“¤ë§Œ ìž¬ê³  í•­ëª© ì‚¬ìš© ë˜ì—ˆë‹¤.',0),(446492,12403,'he','×”×“×•×— ×”×–×ž× ×•×ª ×©×”×ª×§×‘×œ×• ×ž×›×™×œ ×”×•×¨××•×ª ×”×™×›×Ÿ ×¤×¨×™×˜×™× ×œ× ×©×™×ž×©, ×›×’×•×Ÿ ×”×–×ž× ×•×ª ×©×™×¨×•×ª ×¢× ×–×ž×Ÿ ×”×¢×‘×•×“×”.<p>×”×“×•×— ×”×™×¡×˜×•×¨×™×™×ª ×”×”×–×ž× ×•×ª ×¤×¨×™×˜ ×ž×¤×¨×˜ ×¨×§ ××œ×” ×©×‘×• ×©×™×ž×© ×¤×¨×™×˜ ',0),(446493,12403,'el','Î— Î­ÎºÎ¸ÎµÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€Î¿Ï… ÎµÎ»Î®Ï†Î¸Î·ÏƒÎ±Î½ Ï€ÎµÏÎ¹Î­Ï‡ÎµÎ¹ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ ÏŒÏ€Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î¼Î·Î½ Î­Ï‡Î¿Ï…Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯, ÏŒÏ€Ï‰Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï… Î¼Îµ Ï„Î¿ Ï‡ÏÏŒÎ½Î¿ ÎµÏÎ³Î±ÏƒÎ',0),(446494,12403,'zh','æ‰€æ”¶è®¢å•æŠ¥è¡¨åŒ…æ‹¬é¡¹ç›®æœªè¢«ä½¿ç”¨çš„è®¢å•ï¼Œå¦‚æœ‰åŠ³åŠ¨æ—¶é—´çš„æœåŠ¡è®¢å•ã€‚é¡¹ç›®è®¢å•åŽ†å²æŠ¥è¡¨ä»…åˆ—å‡ºåº“å­˜é¡¹ç›®å·²è¢«ä½¿ç”¨çš„è®¢å•ã€‚',0),(446495,12403,'sv','BestÃ¤llningar mottagna rapporten innehÃ¥ller order dÃ¤r objekt inte kan ha anvÃ¤nts, till exempel serviceorder med labor tid.<p>I artikeln orderhistorik rapporten visas endast de som en lagerartikel har anvÃ¤nts.',0),(446496,12403,'it','La relazione con gli ordini ricevuti contiene ordini dove elementi potrebbero non sono stati utilizzati, come gli ordini di servizio con il tempo di lavoro.<p>Il rapporto cronologia ordine elemento elenca solo quelli cui Ã¨ stato utilizzato un articolo di',0),(446497,12403,'tl','',0),(446498,12403,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸²à¸£à¹„à¸”à¹‰à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸›à¸£à¸°à¸à¸­à¸šà¸”à¹‰à¸§à¸¢à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸­à¸²à¸ˆà¹„à¸¡à¹ˆà¸¡à¸µà¸à¸²à¸£à¹ƒà¸Šà¹‰à¸ªà¸´à¸™à¸„à¹‰à¸² à¹€à¸Šà¹ˆà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸šà¸£à¸´à¸à¸²à¸£à¸à¸±à¸šà¹à¸£à¸‡à¸‡à¸²à¸',0),(446499,12403,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¿à¤²à¥‡ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤†à¤¦à¥‡à¤¶ à¤•à¤¹à¤¾à¤ à¤†à¤‡à¤Ÿà¤®, à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¶à¥à¤°à¤® à¤¸à¤®à¤¯ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤œà¥ˆà¤¸à¥‡ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥‹ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¤à¤¾à¥¤<p>à¤',0),(446500,12403,'ms','Laporan pesanan diterima mengandungi perintah-perintah yang di mana barang-barang mungkin tidak digunakan, seperti perkhidmatan pesanan dengan masa buruh.<p>Laporan sejarah perintah Item senarai hanya orang-orang di mana item inventori yang digunakan.',0),(446501,12403,'ar','ÙˆÙŠØªØ¶Ù…Ù† Ø§Ù„ØªÙ‚Ø±ÙŠØ± \"ØªÙ„Ù‚ÙŠ Ø£ÙˆØ§Ù…Ø±\" Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¹Ù†Ø§ØµØ± Ù‚Ø¯ Ù„Ø§ ÙŠÙƒÙˆÙ† Ù‚Ø¯ Ø§Ø³ØªØ®Ø¯Ù… ÙÙŠÙ‡Ø§ØŒ Ù…Ø«Ù„ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© Ù…Ø¹ ÙˆÙ‚Øª Ø§Ù„Ø¹Ù…Ù„.<p>ÙŠØ³Ø±Ø¯ Ø§Ù„ØªÙ‚Ø±ÙŠØ± \"ØªØ§Ø±ÙŠØ® ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù†ØµØ±\" ÙÙ‚Ø· ØªÙ„Ùƒ',0),(446502,12403,'fr','Les commandes reÃ§ues y trouvera des ordres oÃ¹ les Ã©lÃ©ments ne peuvent pas ont Ã©tÃ© utilisÃ©s, tels que les ordres de service avec le temps de travail.<p>Le rapport d\'historique de commandes point rÃ©pertorie seulement ceux oÃ¹ un inventaire a Ã©tÃ© u',0),(446503,12403,'jp','å—æ³¨ãƒ¬ãƒãƒ¼ãƒˆã«ã¯ã©ã“ã®é …ç›®ãŒä½¿ç”¨ã•ã‚Œã¦ã„ãªã„å ´åˆã€åŠ´åƒæ™‚é–“ã¨ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ãªã©ã®æ³¨æ–‡ãŒå«ã¾ã‚Œã¾ã™ã€‚<p>é …ç›®æ³¨æ–‡å±¥æ­´ãƒ¬ãƒãƒ¼ãƒˆä¸€è¦§ã®ã¿ãŒè¡¨ç¤ºã•ã‚Œã¾ã™ã€åœ¨åº«å“ç›®ãŒä½¿ç”¨ã•ã‚Œã¾ã™ã€‚',0),(446504,12403,'pt','O relatÃ³rio de ordens recebidas contÃ©m ordens onde itens podem nÃ£o ter sido utilizados, tais como ordens de serviÃ§o, com o tempo de trabalho.<p>O relatÃ³rio de histÃ³rico de pedidos Item lista apenas aqueles onde utilizou-se um item de inventÃ¡rio.',0),(446505,12403,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚ ÑÐ¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ Ð·Ð°ÐºÐ°Ð·Ñ‹, Ð³Ð´Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¼Ð¾Ð³ÑƒÑ‚ Ð½Ðµ Ð±Ñ‹Ð»Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ñ‹, Ð½Ð°Ð¿Ñ€Ð¸Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ Ñ Ñ€Ð°Ð±Ð¾Ñ‡ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ.<p>Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ð¸',0),(446506,12403,'es','El Informe de Los Ordenes Recibidos contiene ordenes en donde items posible no estaban usados, como ordenes de servicio con tiempo laboral. <p> El informe de Historia de Ordenes del Item lista solo ellos en donde estaba usado el item de inventario.',0),(446507,12403,'de','Der Auftragseingang Bericht enthÃ¤lt Bestellungen wo Elemente nicht, z. B. Service-AuftrÃ¤ge mit Arbeitszeit verwendet wurden kÃ¶nnen.<p>Der Element-Bestellhistorie-Bericht listet nur die wo ein Lagerartikel verwendet wurde.',0),(446508,12403,'en','The Orders Received report contains orders where items may not have been used, such as service orders with labor time. <p> The Item Order History report lists only those where an inventory item was used.',0),(446509,12404,'is','',0),(446510,12404,'dr','',0),(446511,12404,'pr','',0),(446512,12404,'tr','',0),(446513,12404,'pl','',0),(446514,12404,'bg','',0),(446515,12404,'ur','',0),(446516,12404,'sr','',0),(446517,12404,'vi','',0),(446518,12404,'af','',0),(446519,12404,'ro','',0),(446520,12404,'et','',0),(446521,12404,'si','',0),(446522,12404,'ba','',0),(446523,12404,'nl','',0),(446524,12404,'fi','',0),(446525,12404,'no','',0),(446526,12404,'da','',0),(446527,12404,'ko','',0),(446528,12404,'he','',0),(446529,12404,'el','',0),(446530,12404,'zh','',0),(446531,12404,'sv','',0),(446532,12404,'it','',0),(446533,12404,'tl','',0),(446534,12404,'th','',0),(446535,12404,'hi','',0),(446536,12404,'ms','',0),(446537,12404,'ar','',0),(446538,12404,'fr','',0),(446539,12404,'jp','',0),(446540,12404,'pt','',0),(446541,12404,'ru','',0),(446542,12404,'es','',0),(446543,12404,'de','',0),(446544,12404,'en','',0),(446545,12405,'is','',0),(446546,12405,'dr','',0),(446547,12405,'pr','',0),(446548,12405,'tr','',0),(446549,12405,'pl','',0),(446550,12405,'bg','',0),(446551,12405,'ur','',0),(446552,12405,'sr','',0),(446553,12405,'vi','',0),(446554,12405,'af','',0),(446555,12405,'ro','',0),(446556,12405,'et','',0),(446557,12405,'si','',0),(446558,12405,'ba','',0),(446559,12405,'nl','',0),(446560,12405,'fi','',0),(446561,12405,'no','',0),(446562,12405,'da','',0),(446563,12405,'ko','',0),(446564,12405,'he','',0),(446565,12405,'el','',0),(446566,12405,'zh','',0),(446567,12405,'sv','',0),(446568,12405,'it','',0),(446569,12405,'tl','',0),(446570,12405,'th','',0),(446571,12405,'hi','',0),(446572,12405,'ms','',0),(446573,12405,'ar','',0),(446574,12405,'fr','',0),(446575,12405,'jp','',0),(446576,12405,'pt','',0),(446577,12405,'ru','',0),(446578,12405,'es','',0),(446579,12405,'de','',0),(446580,12405,'en','',0),(446581,12406,'is','',0),(446582,12406,'dr','',0),(446583,12406,'pr','',0),(446584,12406,'tr','',0),(446585,12406,'pl','',0),(446586,12406,'bg','',0),(446587,12406,'ur','',0),(446588,12406,'sr','',0),(446589,12406,'vi','',0),(446590,12406,'af','',0),(446591,12406,'ro','',0),(446592,12406,'et','',0),(446593,12406,'si','',0),(446594,12406,'ba','',0),(446595,12406,'nl','',0),(446596,12406,'fi','',0),(446597,12406,'no','',0),(446598,12406,'da','',0),(446599,12406,'ko','',0),(446600,12406,'he','',0),(446601,12406,'el','',0),(446602,12406,'zh','',0),(446603,12406,'sv','',0),(446604,12406,'it','',0),(446605,12406,'tl','',0),(446606,12406,'th','',0),(446607,12406,'hi','',0),(446608,12406,'ms','',0),(446609,12406,'ar','',0),(446610,12406,'fr','',0),(446611,12406,'jp','',0),(446612,12406,'pt','',0),(446613,12406,'ru','',0),(446614,12406,'es','',0),(446615,12406,'de','',0),(446616,12406,'en','',0),(446617,12407,'is','',0),(446618,12407,'dr','',0),(446619,12407,'pr','',0),(446620,12407,'tr','',0),(446621,12407,'pl','',0),(446622,12407,'bg','',0),(446623,12407,'ur','',0),(446624,12407,'sr','',0),(446625,12407,'vi','',0),(446626,12407,'af','',0),(446627,12407,'ro','',0),(446628,12407,'et','',0),(446629,12407,'si','',0),(446630,12407,'ba','',0),(446631,12407,'nl','',0),(446632,12407,'fi','',0),(446633,12407,'no','',0),(446634,12407,'da','',0),(446635,12407,'ko','',0),(446636,12407,'he','',0),(446637,12407,'el','',0),(446638,12407,'zh','',0),(446639,12407,'sv','',0),(446640,12407,'it','',0),(446641,12407,'tl','',0),(446642,12407,'th','',0),(446643,12407,'hi','',0),(446644,12407,'ms','',0),(446645,12407,'ar','',0),(446646,12407,'fr','',0),(446647,12407,'jp','',0),(446648,12407,'pt','',0),(446649,12407,'ru','',0),(446650,12407,'es','',0),(446651,12407,'de','',0),(446652,12407,'en','',0),(446653,12408,'is','',0),(446654,12408,'dr','',0),(446655,12408,'pr','',0),(446656,12408,'tr','',0),(446657,12408,'pl','',0),(446658,12408,'bg','',0),(446659,12408,'ur','',0),(446660,12408,'sr','',0),(446661,12408,'vi','',0),(446662,12408,'af','',0),(446663,12408,'ro','',0),(446664,12408,'et','',0),(446665,12408,'si','',0),(446666,12408,'ba','',0),(446667,12408,'nl','',0),(446668,12408,'fi','',0),(446669,12408,'no','',0),(446670,12408,'da','',0),(446671,12408,'ko','',0),(446672,12408,'he','',0),(446673,12408,'el','',0),(446674,12408,'zh','',0),(446675,12408,'sv','',0),(446676,12408,'it','',0),(446677,12408,'tl','',0),(446678,12408,'th','',0),(446679,12408,'hi','',0),(446680,12408,'ms','',0),(446681,12408,'ar','',0),(446682,12408,'fr','',0),(446683,12408,'jp','',0),(446684,12408,'pt','',0),(446685,12408,'ru','',0),(446686,12408,'es','',0),(446687,12408,'de','',0),(446688,12408,'en','',0),(446689,12409,'is','',0),(446690,12409,'dr','',0),(446691,12409,'pr','',0),(446692,12409,'tr','',0),(446693,12409,'pl','',0),(446694,12409,'bg','',0),(446695,12409,'ur','',0),(446696,12409,'sr','',0),(446697,12409,'vi','',0),(446698,12409,'af','',0),(446699,12409,'ro','',0),(446700,12409,'et','',0),(446701,12409,'si','',0),(446702,12409,'ba','',0),(446703,12409,'nl','',0),(446704,12409,'fi','',0),(446705,12409,'no','',0),(446706,12409,'da','',0),(446707,12409,'ko','',0),(446708,12409,'he','',0),(446709,12409,'el','',0),(446710,12409,'zh','',0),(446711,12409,'sv','',0),(446712,12409,'it','',0),(446713,12409,'tl','',0),(446714,12409,'th','',0),(446715,12409,'hi','',0),(446716,12409,'ms','',0),(446717,12409,'ar','',0),(446718,12409,'fr','',0),(446719,12409,'jp','',0),(446720,12409,'pt','',0),(446721,12409,'ru','',0),(446722,12409,'es','',0),(446723,12409,'de','',0),(446724,12409,'en','',0),(446725,12410,'is','',0),(446726,12410,'dr','',0),(446727,12410,'pr','',0),(446728,12410,'tr','',0),(446729,12410,'pl','',0),(446730,12410,'bg','',0),(446731,12410,'ur','',0),(446732,12410,'sr','',0),(446733,12410,'vi','',0),(446734,12410,'af','',0),(446735,12410,'ro','',0),(446736,12410,'et','',0),(446737,12410,'si','',0),(446738,12410,'ba','',0),(446739,12410,'nl','',0),(446740,12410,'fi','',0),(446741,12410,'no','',0),(446742,12410,'da','',0),(446743,12410,'ko','',0),(446744,12410,'he','',0),(446745,12410,'el','',0),(446746,12410,'zh','',0),(446747,12410,'sv','',0),(446748,12410,'it','',0),(446749,12410,'tl','',0),(446750,12410,'th','',0),(446751,12410,'hi','',0),(446752,12410,'ms','',0),(446753,12410,'ar','',0),(446754,12410,'fr','',0),(446755,12410,'jp','',0),(446756,12410,'pt','',0),(446757,12410,'ru','',0),(446758,12410,'es','',0),(446759,12410,'de','',0),(446760,12410,'en','',0),(446761,12411,'is','',0),(446762,12411,'dr','',0),(446763,12411,'pr','',0),(446764,12411,'tr','',0),(446765,12411,'pl','',0),(446766,12411,'bg','',0),(446767,12411,'ur','',0),(446768,12411,'sr','',0),(446769,12411,'vi','',0),(446770,12411,'af','',0),(446771,12411,'ro','',0),(446772,12411,'et','',0),(446773,12411,'si','',0),(446774,12411,'ba','',0),(446775,12411,'nl','',0),(446776,12411,'fi','',0),(446777,12411,'no','',0),(446778,12411,'da','',0),(446779,12411,'ko','',0),(446780,12411,'he','',0),(446781,12411,'el','',0),(446782,12411,'zh','',0),(446783,12411,'sv','',0),(446784,12411,'it','',0),(446785,12411,'tl','',0),(446786,12411,'th','',0),(446787,12411,'hi','',0),(446788,12411,'ms','',0),(446789,12411,'ar','',0),(446790,12411,'fr','',0),(446791,12411,'jp','',0),(446792,12411,'pt','',0),(446793,12411,'ru','',0),(446794,12411,'es','',0),(446795,12411,'de','',0),(446796,12411,'en','',0),(446797,12412,'is','',0),(446798,12412,'dr','',0),(446799,12412,'pr','',0),(446800,12412,'tr','',0),(446801,12412,'pl','',0),(446802,12412,'bg','',0),(446803,12412,'ur','',0),(446804,12412,'sr','',0),(446805,12412,'vi','',0),(446806,12412,'af','',0),(446807,12412,'ro','',0),(446808,12412,'et','',0),(446809,12412,'si','',0),(446810,12412,'ba','',0),(446811,12412,'nl','',0),(446812,12412,'fi','',0),(446813,12412,'no','',0),(446814,12412,'da','',0),(446815,12412,'ko','',0),(446816,12412,'he','',0),(446817,12412,'el','',0),(446818,12412,'zh','',0),(446819,12412,'sv','',0),(446820,12412,'it','',0),(446821,12412,'tl','',0),(446822,12412,'th','',0),(446823,12412,'hi','',0),(446824,12412,'ms','',0),(446825,12412,'ar','',0),(446826,12412,'fr','',0),(446827,12412,'jp','',0),(446828,12412,'pt','',0),(446829,12412,'ru','',0),(446830,12412,'es','',0),(446831,12412,'de','',0),(446832,12412,'en','',0),(446833,12413,'is','',0),(446834,12413,'dr','',0),(446835,12413,'pr','',0),(446836,12413,'tr','',0),(446837,12413,'pl','',0),(446838,12413,'bg','',0),(446839,12413,'ur','',0),(446840,12413,'sr','',0),(446841,12413,'vi','',0),(446842,12413,'af','',0),(446843,12413,'ro','',0),(446844,12413,'et','',0),(446845,12413,'si','',0),(446846,12413,'ba','',0),(446847,12413,'nl','',0),(446848,12413,'fi','',0),(446849,12413,'no','',0),(446850,12413,'da','',0),(446851,12413,'ko','',0),(446852,12413,'he','',0),(446853,12413,'el','',0),(446854,12413,'zh','',0),(446855,12413,'sv','',0),(446856,12413,'it','',0),(446857,12413,'tl','',0),(446858,12413,'th','',0),(446859,12413,'hi','',0),(446860,12413,'ms','',0),(446861,12413,'ar','',0),(446862,12413,'fr','',0),(446863,12413,'jp','',0),(446864,12413,'pt','',0),(446865,12413,'ru','',0),(446866,12413,'es','',0),(446867,12413,'de','',0),(446868,12413,'en','',0),(446869,12414,'is','',0),(446870,12414,'dr','',0),(446871,12414,'pr','',0),(446872,12414,'tr','',0),(446873,12414,'pl','',0),(446874,12414,'bg','',0),(446875,12414,'ur','',0),(446876,12414,'sr','',0),(446877,12414,'vi','',0),(446878,12414,'af','',0),(446879,12414,'ro','',0),(446880,12414,'et','',0),(446881,12414,'si','',0),(446882,12414,'ba','',0),(446883,12414,'nl','',0),(446884,12414,'fi','',0),(446885,12414,'no','',0),(446886,12414,'da','',0),(446887,12414,'ko','',0),(446888,12414,'he','',0),(446889,12414,'el','',0),(446890,12414,'zh','',0),(446891,12414,'sv','',0),(446892,12414,'it','',0),(446893,12414,'tl','',0),(446894,12414,'th','',0),(446895,12414,'hi','',0),(446896,12414,'ms','',0),(446897,12414,'ar','',0),(446898,12414,'fr','',0),(446899,12414,'jp','',0),(446900,12414,'pt','',0),(446901,12414,'ru','',0),(446902,12414,'es','',0),(446903,12414,'de','',0),(446904,12414,'en','',0),(446905,12415,'is','',0),(446906,12415,'dr','',0),(446907,12415,'pr','',0),(446908,12415,'tr','',0),(446909,12415,'pl','',0),(446910,12415,'bg','',0),(446911,12415,'ur','',0),(446912,12415,'sr','',0),(446913,12415,'vi','',0),(446914,12415,'af','',0),(446915,12415,'ro','',0),(446916,12415,'et','',0),(446917,12415,'si','',0),(446918,12415,'ba','',0),(446919,12415,'nl','',0),(446920,12415,'fi','',0),(446921,12415,'no','',0),(446922,12415,'da','',0),(446923,12415,'ko','',0),(446924,12415,'he','',0),(446925,12415,'el','',0),(446926,12415,'zh','',0),(446927,12415,'sv','',0),(446928,12415,'it','',0),(446929,12415,'tl','',0),(446930,12415,'th','',0),(446931,12415,'hi','',0),(446932,12415,'ms','',0),(446933,12415,'ar','',0),(446934,12415,'fr','',0),(446935,12415,'jp','',0),(446936,12415,'pt','',0),(446937,12415,'ru','',0),(446938,12415,'es','',0),(446939,12415,'de','',0),(446940,12415,'en','',0),(446941,12416,'is','',0),(446942,12416,'dr','',0),(446943,12416,'pr','',0),(446944,12416,'tr','',0),(446945,12416,'pl','',0),(446946,12416,'bg','',0),(446947,12416,'ur','',0),(446948,12416,'sr','',0),(446949,12416,'vi','',0),(446950,12416,'af','',0),(446951,12416,'ro','',0),(446952,12416,'et','',0),(446953,12416,'si','',0),(446954,12416,'ba','',0),(446955,12416,'nl','',0),(446956,12416,'fi','',0),(446957,12416,'no','',0),(446958,12416,'da','',0),(446959,12416,'ko','',0),(446960,12416,'he','',0),(446961,12416,'el','',0),(446962,12416,'zh','',0),(446963,12416,'sv','',0),(446964,12416,'it','',0),(446965,12416,'tl','',0),(446966,12416,'th','',0),(446967,12416,'hi','',0),(446968,12416,'ms','',0),(446969,12416,'ar','',0),(446970,12416,'fr','',0),(446971,12416,'jp','',0),(446972,12416,'pt','',0),(446973,12416,'ru','',0),(446974,12416,'es','',0),(446975,12416,'de','',0),(446976,12416,'en','',0),(446977,12417,'is','',0),(446978,12417,'dr','',0),(446979,12417,'pr','',0),(446980,12417,'tr','',0),(446981,12417,'pl','',0),(446982,12417,'bg','',0),(446983,12417,'ur','',0),(446984,12417,'sr','',0),(446985,12417,'vi','',0),(446986,12417,'af','',0),(446987,12417,'ro','',0),(446988,12417,'et','',0),(446989,12417,'si','',0),(446990,12417,'ba','',0),(446991,12417,'nl','',0),(446992,12417,'fi','',0),(446993,12417,'no','',0),(446994,12417,'da','',0),(446995,12417,'ko','',0),(446996,12417,'he','',0),(446997,12417,'el','',0),(446998,12417,'zh','',0),(446999,12417,'sv','',0),(447000,12417,'it','',0),(447001,12417,'tl','',0),(447002,12417,'th','',0),(447003,12417,'hi','',0),(447004,12417,'ms','',0),(447005,12417,'ar','',0),(447006,12417,'fr','',0),(447007,12417,'jp','',0),(447008,12417,'pt','',0),(447009,12417,'ru','',0),(447010,12417,'es','',0),(447011,12417,'de','',0),(447012,12417,'en','',0),(447013,12418,'is','',0),(447014,12418,'dr','',0),(447015,12418,'pr','',0),(447016,12418,'tr','',0),(447017,12418,'pl','',0),(447018,12418,'bg','',0),(447019,12418,'ur','',0),(447020,12418,'sr','',0),(447021,12418,'vi','',0),(447022,12418,'af','',0),(447023,12418,'ro','',0),(447024,12418,'et','',0),(447025,12418,'si','',0),(447026,12418,'ba','',0),(447027,12418,'nl','',0),(447028,12418,'fi','',0),(447029,12418,'no','',0),(447030,12418,'da','',0),(447031,12418,'ko','',0),(447032,12418,'he','',0),(447033,12418,'el','',0),(447034,12418,'zh','',0),(447035,12418,'sv','',0),(447036,12418,'it','',0),(447037,12418,'tl','',0),(447038,12418,'th','',0),(447039,12418,'hi','',0),(447040,12418,'ms','',0),(447041,12418,'ar','',0),(447042,12418,'fr','',0),(447043,12418,'jp','',0),(447044,12418,'pt','',0),(447045,12418,'ru','',0),(447046,12418,'es','',0),(447047,12418,'de','',0),(447048,12418,'en','',0),(447049,12419,'is','',0),(447050,12419,'dr','',0),(447051,12419,'pr','',0),(447052,12419,'tr','',0),(447053,12419,'pl','',0),(447054,12419,'bg','',0),(447055,12419,'ur','',0),(447056,12419,'sr','',0),(447057,12419,'vi','',0),(447058,12419,'af','',0),(447059,12419,'ro','',0),(447060,12419,'et','',0),(447061,12419,'si','',0),(447062,12419,'ba','',0),(447063,12419,'nl','',0),(447064,12419,'fi','',0),(447065,12419,'no','',0),(447066,12419,'da','',0),(447067,12419,'ko','',0),(447068,12419,'he','',0),(447069,12419,'el','',0),(447070,12419,'zh','',0),(447071,12419,'sv','',0),(447072,12419,'it','',0),(447073,12419,'tl','',0),(447074,12419,'th','',0),(447075,12419,'hi','',0),(447076,12419,'ms','',0),(447077,12419,'ar','',0),(447078,12419,'fr','',0),(447079,12419,'jp','',0),(447080,12419,'pt','',0),(447081,12419,'ru','',0),(447082,12419,'es','',0),(447083,12419,'de','',0),(447084,12419,'en','',0),(447085,12420,'is','',0),(447086,12420,'dr','Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆÙ†ÛŒØ¯ Ø¨Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø­Ù…Ù„ Ú†Ù†Ø¯ÛŒÙ† Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.Ø§Ø·Ù…ÛŒÙ†Ø§Ù† Ø­Ø§ØµÙ„ Ú©Ù†ÛŒØ¯Ú©Ù‡ Ú©Ø§Ø¯Ø± \"ÙØ±Ù…Ø§ÛŒØ´ Ú©Ø§Ù…Ù„ Ø§Ø³Øª\" Ø±Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ù†Ú©Ù†ÛŒØ¯. ÙˆÙ‚ØªÛŒ Ø´Ù…Ø§ Ø¢Ù…Ø§Ø¯Ù‡ Ø­Ù…Ù„',0),(447087,12420,'pr','Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆÙ†ÛŒØ¯ Ø¨Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ù‚Ø¯Ø§Ø± Ø¬Ù‡Øª Ø­Ù…Ù„ Ú†Ù†Ø¯ÛŒÙ† Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.Ø§Ø·Ù…ÛŒÙ†Ø§Ù† Ø­Ø§ØµÙ„ Ú©Ù†ÛŒØ¯Ú©Ù‡ Ú©Ø§Ø¯Ø± \"Ø³ÙØ§Ø±Ø´ Ú©Ø§Ù…Ù„ Ø§Ø³Øª\" Ø±Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ù†Ú©Ù†ÛŒØ¯. ÙˆÙ‚ØªÛŒ Ø´Ù…Ø§ Ø¢Ù…Ø§Ø¯Ù‡ Ø­Ù…Ù„ Ø',0),(447088,12420,'tr','Birden Ã§ok sevk irsaliyeleri, sevk etmek istediÄŸiniz miktarÄ± seÃ§erek yapabilirsiniz. \"Tam sÄ±rasÄ±dÄ±r\" kutuyu iÅŸaretlemeyin emin olun.<p>Kalan sevk etmeye hazÄ±r olduÄŸunuzda Ã¶ÄŸeleri gidin<p><b>Emir-> Fulfillment sipariÅŸler gemi sipariÅŸi->.</b>',0),(447089,12420,'pl','Wielu przesyÅ‚ek moÅ¼na dokonaÄ‡ wybierajÄ…c iloÅ›Ä‡, ktÃ³rÄ… chcesz wysÅ‚aÄ‡. Upewnij siÄ™, Å¼e nie odznaczysz pola \"zamÃ³wienie jest juÅ¼ gotowe\".<p>Gdy jesteÅ› gotowy do wysyÅ‚ki, pozostaÅ‚e przedmioty przejdÅº do<p><b>ZamÃ³wienia-> realizacji zamÃ³wie',0),(447090,12420,'bg','ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Ð¿Ñ€Ð°Ñ‚ÐºÐ¸ ÐºÐ°Ñ‚Ð¾ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾, ÐºÐ¾ÐµÑ‚Ð¾ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ñ‚Ðµ. Ð£Ð²ÐµÑ€ÐµÑ‚Ðµ ÑÐµ, Ñ‡Ðµ Ð½Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð»ÐµÑ‚Ð¾ \"Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ðµ',0),(447091,12420,'ur','Ø¬ÛØ§Ø² Ú©Û’ Ù„ÛŒÛ’ Ø­Ø³Ø¨ Ø®ÙˆØ§ÛØ´ Ù…Ù‚Ø¯Ø§Ø± Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±Ú©Û’ Ø§ÛŒÚ© Ø³Û’ Ø²ÛŒØ§Ø¯Û ØªØ±Ø³ÛŒÙ„ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº Û” Ø§Ø³ Ø¨Ø§Øª Ú©Ø§ ÛŒÙ‚ÛŒÙ† Ú©Ø± Ù„ÛŒÚº Ú©Û Ø¢Ù¾ Ú©Ùˆ \"ØªØ±ØªÛŒØ¨ Ù…Ú©Ù…Ù„ ÛÛ’\" Ø®Ø§Ù†Û Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ù…Øª Ú©Ø±ÛŒÚº.<',0),(447092,12420,'sr','Ð’Ð¸ÑˆÐµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ ÑƒÑ‡Ð¸Ð½Ð¸Ñ‚Ð¸ Ñ‚Ð°ÐºÐ¾ ÑˆÑ‚Ð¾ Ñ›ÐµÑ‚Ðµ Ð¾Ð´Ð°Ð±Ñ€Ð°Ñ‚Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ ÐºÐ¾Ñ˜Ñƒ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚Ðµ. ÐŸÐ¾Ð±Ñ€Ð¸Ð½Ð¸ ÑÐµ Ð´Ð° Ñ‚Ð¸ Ð½Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð°Ñ˜ Ð¾ÐºÐ²Ð¸Ñ€ \"Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° Ñ˜Ðµ Ð',0),(447093,12420,'vi','Báº¡n cÃ³ thá»ƒ lÃ m nhiá»u lÃ´ hÃ ng báº±ng cÃ¡ch chá»n sá»‘ lÆ°á»£ng mÃ  báº¡n muá»‘n xuáº¥t. Äáº£m báº£o ráº±ng báº¡n khÃ´ng chá»n vÃ o Ã´ \" lá»‡nh Ä‘Ã£ hoÃ n thÃ nh\". Khi báº¡n Ä‘Ã£ sáºµn sÃ ng Ä‘á»ƒ xuáº¥t nhá»¯ng máº·t hÃ ng cÃ²n láº¡i thÃ¬ vÃ o',0),(447094,12420,'af','Jy kan meervoudige gestuur deur die hoeveelheid wat jy wil skip die keuse maak. Maak seker dat jy nie die \"orde is voltooi\" boks kyk.<p>Wanneer jy gereed is om die skip die oorblywende items gaan<p><b>Bestellings-> vervulling bestellings skip orde->.</b>',0),(447095,12420,'ro','PuteÅ£i face mai multe transporturi prin alegerea de cantitatea pe care doriÅ£i pentru a navei. AsiguraÅ£i-vÄƒ cÄƒ nu se verifica caseta \"ordinea este completÄƒ\".<p>CÃ¢nd sunteÅ£i gata pentru a navei rÄƒmase elementele du-te la<p><b>Comenzi-> ordinele de ',0),(447096,12420,'et','Mitme veo teha valides laeva kogust. Veenduge, sa ei mÃ¤rgi \"tellimus on lÃµplik\" kasti.<p>Kui olete valmis laeva Ã¼lejÃ¤Ã¤nud kirjed minna<p><b>Tellimused plaanitud tellimused->-> laevatellimuselt.</b>',0),(447097,12420,'si','Naredite lahko veÄ poÅ¡iljk z izbiro koliÄina, ki jo Å¾elite ladjo. Poskrbite, da ne preverite polje \"da je popoln\".<p>Ko ste pripravljeni za dobavo preostale elemente iti<p><b>Naloge-> izpolnitev naroÄila-> dobave naloga.</b>',0),(447098,12420,'ba','Anda dapat membuat beberapa pengiriman dengan memilih jumlah yang Anda inginkan untuk kapal. Pastikan Anda tidak mencentang kotak \"urutan lengkap\".<p>Ketika Anda siap untuk kapal sisa barang-barang pergi ke<p><b>Pesanan-> pemenuhan order-> rangka kapal.</',0),(447099,12420,'nl','U kunt meerdere zendingen maken door te kiezen voor het aantal dat u wilt verzenden. Zorg ervoor dat u niet de \"bestelling is compleet\" selectievakje inschakelt.<p>Wanneer u bent klaar om te verzenden de resterende gaan items om te<p><b>Bestellingen-> ver',0),(447100,12420,'fi','Voit tehdÃ¤ useista lÃ¤hetyksistÃ¤ valitsemalla mÃ¤Ã¤rÃ¤, jonka haluat lÃ¤hettÃ¤Ã¤. Varmista, ettÃ¤ \"tilaus on valmis\"-ruutua ei valita.<p>Kun olet valmis alusta, loput kohteita mennÃ¤<p><b>Tilaukset-> tÃ¤yttÃ¤minen tilaukset-> aluksen tilausmÃ¤Ã¤rÃ¤stÃ¤.',0),(447101,12420,'no','Du kan gjÃ¸re flere forsendelser ved Ã¥ velge antallet som du vil sende. Kontroller at du ikke merker boksen \"bestillingen er fullfÃ¸rt\".<p>NÃ¥r du er klar til Ã¥ sendes de resterende gÃ¥ elementene til<p><b>Ordrer-> fullfÃ¸ringen bestillinger-> skip ordr',0),(447102,12420,'da','Du kan gÃ¸re flere overfÃ¸rsler ved at vÃ¦lge det antal, du vil afsende. Kontroller, at du ikke markere boksen \"ordren er fÃ¦rdig\".<p>NÃ¥r du er klar til at skibet de resterende gÃ¥ varer til<p><b>Ordrer-> opfyldelse ordrer-> skib rÃ¦kkefÃ¸lge.</b>',0),(447103,12420,'ko','ë°œì†¡ í•˜ê³ ìž í•˜ëŠ” ìˆ˜ëŸ‰ì„ ì„ íƒ í•˜ ì—¬ ì—¬ëŸ¬ ì„ ì ì„ ë§Œë“¤ ìˆ˜ ìžˆìŠµë‹ˆë‹¤. \"ì£¼ë¬¸ì´ ì™„ë£Œ ë˜ ë©´\" í™•ì¸ëž€ì„ ì„ íƒ í•˜ì§€ ì•ŠëŠ” ë‹¤ëŠ” ê²ƒì„ í™•ì¸ í•˜ì‹­ì‹œì˜¤.<p>ìž”ì—¬ ë°œì†¡ í•˜ ê²Œ ì¤€ë¹„ ë˜ì–´ ìžˆì„ ë•Œ í•­ëª© ì´ë™<p><b>',0),(447104,12420,'he','× ×™×ª×Ÿ ×œ×‘×¦×¢ ×ž×©×œ×•×—×™× ×ž×¨×•×‘×™× ×¢×œ-×™×“×™ ×‘×—×™×¨×ª ×”×›×ž×•×ª ×©×‘×¨×¦×•× ×š ×œ×©×œ×•×—. ×”×§×¤×“ ×©×œ× ×œ×‘×“×•×§ ×‘×ª×™×‘×ª \"×¡×“×¨ ×ª×•×©×œ×\".<p>×›××©×¨ ×ª×”×™×” ×ž×•×›×Ÿ ×œ×©×œ×•×— ××ª ×©××¨ ×”×¤×¨×™×˜×™× ×œ×œ×›×ª<p><b>×”×–×ž× ',0),(447105,12420,'el','ÎœÏ€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± ÎºÎ¬Î½ÎµÏ„Îµ Ï€Î¿Î»Î»Î­Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚, ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Ï‚ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î¼ÎµÏ„Î±Ï†Î­ÏÎµÎ¹. Î’ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ Î´ÎµÎ½ Î­Ï‡ÎµÏ„Îµ ÎµÎ»Î­Î³Î¾ÎµÎ¹ Ï„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ \"Ï€Î±ÏÎ±Î³Î',0),(447106,12420,'zh','é€‰æ‹©æ‚¨æ‰€æƒ³è£…è¿çš„æ•°é‡ï¼Œæ‚¨å¯ä»¥è¿›è¡Œå¤šæ¬¡è£…è¿ã€‚ç¡®è®¤æ‚¨æ²¡æœ‰é€‰ä¸­â€œè®¢å•å®Œæˆâ€é€‰é¡¹æ¡†ã€‚å½“æ‚¨å‡†å¤‡å¥½è£…è¿å‰©ä¸‹çš„é¡¹ç›®æ—¶ï¼Œåˆ°ï¼šè®¢å•->å±¥è¡Œè®¢å•->è£…è¿è®¢å•ã€‚',0),(447107,12420,'sv','Du kan gÃ¶ra flera leveranser genom att vÃ¤lja det antal som du vill leverera. Kontrollera att du inte markerar rutan \"bestÃ¤llningen Ã¤r klar\".<p>NÃ¤r du Ã¤r redo att leverera de Ã¥terstÃ¥ende gÃ¥r objekt till<p><b>Order-> uppfyllelse order-> fartyget Or',0),(447108,12420,'it','Ãˆ possibile effettuare spedizioni multiple scegliendo la quantitÃ  che vuoi spedire. Assicuratevi di che non controllare la casella \"ordine Ã¨ completo\".<p>Quando siete pronti per la spedizione i rimanenti oggetti vanno a<p><b>Ordini-> evasione ordini-> ',0),(447109,12420,'tl','',0),(447110,12420,'th','à¸„à¸¸à¸“à¸ªà¸²à¸¡à¸²à¸£à¸–à¸—à¸³à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸«à¸¥à¸²à¸¢à¸”à¹‰à¸§à¸¢à¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸µà¹ˆà¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹ƒà¸«à¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸§à¹ˆà¸² à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¹€à¸¥à¸·à¸­à',0),(447111,12420,'hi','à¤†à¤ª à¤à¤•à¤¾à¤§à¤¿à¤• à¤²à¤¦à¤¾à¤¨ à¤•à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤¿ à¤¤à¥à¤® à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤šà¥à¤¨à¤¨à¥‡ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤ à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à',0),(447112,12420,'ms','Anda boleh membuat penghantaran berbilang dengan memilih kuantiti yang anda mahu untuk kapal. Pastikan anda tidak menanda kotak \"pesanan selesai\".<p>Apabila anda bersedia untuk menghantar baki barang-barang ke<p><b>Arahan-> memenuhi perintah-> perintah ka',0),(447113,12420,'ar','ÙŠÙ…ÙƒÙ†Ùƒ Ø¬Ø¹Ù„ Ø´Ø­Ù†Ø§Øª Ù…ØªØ¹Ø¯Ø¯Ø© Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ ØªØ±ÙŠØ¯ Ø´Ø­Ù†. ØªØ£ÙƒØ¯ Ù…Ù† Ø¹Ø¯Ù… ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ù…Ø±Ø¨Ø¹ \"Ø§ÙƒØªÙ…Ø§Ù„ Ø§Ù„Ù†Ø¸Ø§Ù…\".<p>Ø¹Ù†Ø¯Ù…Ø§ ÙƒÙ†Øª Ø¹Ù„Ù‰ Ø§Ø³ØªØ¹Ø¯Ø§Ø¯ Ù„Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(447114,12420,'fr','Vous pouvez faire plusieurs envois en choisissant la quantitÃ© que vous souhaitez expÃ©dier. Assurez-vous que vous ne cochez pas la case Â« commande est terminÃ©e Â».<p>Lorsque vous Ãªtes prÃªt Ã  expÃ©dier les autres Ã©lÃ©ments allez<p><b>-> De commandes',0),(447115,12420,'jp','è¤‡æ•°ã®å‡ºè·å°æ•°ã‚’å‡ºè·ã™ã‚‹æ•°é‡ã‚’é¸æŠžã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚ã€Œæ³¨æ–‡ãŒå®Œäº†ã€ãƒœãƒƒã‚¯ã‚¹ã‚’ãƒã‚§ãƒƒã‚¯ã—ãªã„ã“ã¨ã‚’ç¢ºèªã—ã¾ã™ã€‚<p>ã‚¢ã‚¤ãƒ†ãƒ ã®æ®‹ã‚Šã‚’å‡ºè·ã™ã‚‹æº–å‚™ãŒã§ããŸã‚‰ã«ç§»å‹•ã—ã¾ã™ã€‚<p><b>ã‚ª',0),(447116,12420,'pt','VocÃª pode fazer vÃ¡rias remessas, escolhendo a quantidade que vocÃª deseja remeter. Certifique-se que vocÃª nÃ£o marcar a caixa \"ordem Ã© completa\".<p>Quando vocÃª estÃ¡ pronto para enviar os restantes itens ir para<p><b>Ordens-> cumprimento de ordens-> ',0),(447117,12420,'ru','Ð’Ñ‹ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð¿Ð°Ñ€Ñ‚Ð¸Ð¹, Ð²Ñ‹Ð±Ñ€Ð°Ð² ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, ÐºÐ¾Ñ‚Ð¾Ñ€Ð¾Ðµ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ. Ð£Ð±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ð½Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÑ‚ÑŒ Ð¿Ð¾Ð»Ðµ Â«Ð·Ð°ÐºÐ°Ð·Â».<p>ÐšÐ¾Ð³Ð´Ð° Ð²Ñ‹ Ð±',0),(447118,12420,'es','Puede hacer envÃ­os multiples por escoger la cantidad que quiere enviar. Hace seguro que no tacha la caja \"orden es completo\" <p>\r\nCuando Esta listo enviar el resto de los items va a <p> <b> Ordenes ->Ordenes de Cumplimiento -> Envia Orden. </b>',0),(447119,12420,'de','Sie kÃ¶nnen mehrere Sendungen machen, wÃ¤hlen Sie die Menge, die Sie versenden mÃ¶chten. Stellen Sie sicher, dass Sie nicht das Feld \"Auftrag ist abgeschlossen\" aktivieren.<p>Wenn Sie bereit sind, die restlichen Schiff gehen Elemente zu<p><b>Bestellungen-',0),(447120,12420,'en','You can make multiple shipments by choosing the quantity that you want to ship. Make sure you do NOT check the \"order is complete\" box. <p> When you are ready to ship the remaining items go to <p> <b> Orders -> Fulfillment Orders -> Ship Order. </b>',0),(447121,12421,'is','',0),(447122,12421,'dr','(Ø§Ø±Ø³Ø§Ù„) Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯ Ø¯ÛŒÚ¯Ø± Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´ ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø¨Ø§Ø² Ø¯ÛŒØ¯Ù‡ Ù†Ù…ÛŒ Ø´ÙˆØ¯.Ø¨Ø§Ù‚ÛŒØ¨ÛŒÙ„Ø§Ù†Ø³ Ø§Ø¬Ù†Ø§Ø³ Ø¯Ø±ÙØ±Ù…Ø§ÛŒØ´Ø§Øª ØªØ§Ø®ÛŒØ± ',0),(447123,12421,'pr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ù…Ù‚Ø¯Ø§Ø±ÛŒ Ø§Ø² Ú©Ø§Ù„Ø§Ù‡Ø§ Ø±Ø§ Ø¯Ø± ØªÚ©Ù…ÛŒÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®ÙˆØ¯Ø­Ù…Ù„(Ø§Ø±Ø³Ø§Ù„) Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯ Ø¯ÛŒÚ¯Ø± Ø¯Ø± Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§Ø² Ø¯ÛŒØ¯Ù‡ Ù†Ù…ÛŒ Ø´ÙˆØ¯.Ø¨Ø§Ù‚ÛŒÙ…Ø§Ù†Ø¯Ù‡ Ú©Ø§Ù„Ø§Ù‡Ø§ Ø¯Ø±Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§Ø®ÛŒØ± Ø',0),(447124,12421,'tr','BazÄ± Ã¶ÄŸeleri karÅŸÄ±lama sipariÅŸinde sevk, artÄ±k aÃ§Ä±k sipariÅŸler raporda gÃ¶rÃ¼nmez.<p>Kalan maddeler sipariÅŸ bakiyesi olarak kabul edilir ve rapor Ã¼zerinde gÃ¶rÃ¼ntÃ¼lenebilir:<p><b>SipariÅŸleri raporlarÄ± Ã¶ÄŸeleri arka Ordere->-></b>',0),(447125,12421,'pl','JeÅ›li wydaÅ‚eÅ› niektÃ³re elementy na zamÃ³wienie speÅ‚nienie juÅ¼ pojawiÄ… siÄ™ w raporcie otwartych zamÃ³wieÅ„.<p>PozostaÅ‚e pozycje sÄ… uwaÅ¼ane za zamÃ³wiony i zamiast tego mogÄ… byÄ‡ przeglÄ…dane w raporcie na:<p><b>ZamÃ³wienia-> sprawozdania-> powr',0),(447126,12421,'bg','ÐÐºÐ¾ ÑÑ‚Ðµ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð»Ð¸ Ð½ÑÐºÐ¾Ð¸ Ð¾Ñ‚ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° ÑÐ¸ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ, Ñ‚Ñ Ð²ÐµÑ‡Ðµ Ñ‰Ðµ ÑÐµ Ð¿Ð¾ÑÐ²Ð¸ Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð´Ð¾ÐºÐ»Ð°Ð´.<p>ÐžÑÑ‚Ð°Ð½Ð°Ð»Ð¸Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ ÑÐµ',0),(447127,12421,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ø§Ù† Ø§Ø´ÛŒØ§Ø¡ Ù…ÛŒÚº Ø³Û’ Ú©Ú†Ú¾ Ø¢Ù¾ ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø­Ú©Ù… Ù¾Ø± Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ ÛÛ’ Ø§Ø³Û’ Ø§Ø¨ Ú©ÙˆØ¦ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ú©Ú¾Ù„Û’ Ø¢Ø±ÚˆØ±Ø² Ù¾Ø± Ø¸Ø§ÛØ± ÛÙˆ Ú¯Ø§ Û”<p>Ø¨Ø§Ù‚ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ø¨Ø§Ú©ÙˆØ±ÚˆØ± Ù¾Ø± ØªØµÙˆØ± Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Ø§Ù',0),(447128,12421,'sr','ÐÐºÐ¾ ÑÑ‚Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð»Ð¸ Ð½ÐµÐºÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ð¾ Ð½Ð°Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ñ‚Ð¾ Ð²Ð¸ÑˆÐµ Ð½ÐµÑ›Ðµ Ð¿Ð¾Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°Ñ‚Ð¸ Ñƒ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ñƒ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ.<p>ÐŸÑ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸ ÑÐ¼Ð°Ñ‚Ñ€Ð°Ñ˜Ñƒ ÑÐµ ',0),(447129,12421,'vi','Náº¿u báº¡n Ä‘Ã£ xuáº¥t má»™t sá»‘ máº·t hÃ ng trong cÃ¡i Ä‘Æ¡n hÃ ng Ä‘áº§y Ä‘á»§ cá»§a báº¡n, thÃ¬ nÃ³ sáº½ khÃ´ng xuáº¥t hiá»‡n trong bÃ¡o cÃ¡o Ä‘Æ¡n hÃ ng cá»§a báº¡n ná»¯a. Nhá»¯ng máº·t hÃ ng cÃ²n láº¡i sáº½ Ä‘Æ°á»£c xem xÃ©t trong Ä‘Æ¡n hÃ ng tá»“n',0),(447130,12421,'af','As jy sommige van die items op jou vervulling orde het shipped dit sal nie meer verskyn nie op die oop bestellings verslag.<p>Die oorblywende items op backorder oorweeg is en eerder op die verslag by beskou kan word:<p><b>Bestellings-> verslae-> Items ter',0),(447131,12421,'ro','DacÄƒ aveÅ£i unele elemente au livrate pe comanda Ã®mplinire nu mai va apÄƒrea Ã®n raportul de ordinele deschise.<p>Elementele rÄƒmase sunt considerate pe backorder ÅŸi pot fi vizualizate Ã®n schimb Ã®n raport la:<p><b>Comenzi-> rapoarte-> elemente Ordere',0),(447132,12421,'et','Kui on veetud kaupu tellimuse tÃ¤itmine tundub enam avatud tellimused aruandesse.<p>ÃœlejÃ¤Ã¤nud kaupade peetakse jÃ¤reltellimuselrea ja saab vaadata hoopis aru:<p><b>Tellimused-> aruannete-> Ã¼ksused tagasi Ordere</b>',0),(447133,12421,'si','ÄŒe ste dobavili nekateri elementi na izpolnitev naroÄila bo preneha pojavljati na odprte naloge poroÄilo.<p>Ostalih elementov se Å¡tejejo v obratnem vrstnem redu in namesto tega si lahko ogledate na poroÄilo na:<p><b>NaroÄila-> poroÄila-> elementov ',0),(447134,12421,'ba','Jika Anda telah dikirim beberapa item pada pemenuhan pesanan tidak akan muncul pada laporan perintah yang terbuka.<p>Sisa barang dianggap pada backorder dan sebaliknya dapat dilihat pada laporan di:<p><b>Perintah-> laporan-> item kembali Ordere</b>',0),(447135,12421,'nl','Als u hebt verzonden sommige van de items op uw bestelling vervulling zal het niet langer weergegeven in de Open Orders rapport.<p>De overige items worden beschouwd als op nabestelling en in plaats daarvan kunnen worden bekeken in over het verslag:<p><b>B',0),(447136,12421,'fi','Jos olet toimittanut joitakin kohteita suunnitellun tilauksen nÃ¤yttÃ¤Ã¤ enÃ¤Ã¤ avoimia tilauksia mietinnÃ¶stÃ¤.<p>Loput erÃ¤t ovat backorder ja voi sen sijaan tarkastella mietinnÃ¶ssÃ¤:<p><b>Tilaukset-> raportit-> kohteet takaisin Ordere</b>',0),(447137,12421,'no','Hvis du har sendt noen av elementene pÃ¥ din innfrielsesordren vises ikke lenger i rapporten Ã¥pne ordrer.<p>De gjenvÃ¦rende elementene anses i restordre og kan i stedet vises i rapporten pÃ¥:<p><b>Bestillinger-> rapporter-> elementer tilbake Ordere</b>',0),(447138,12421,'da','Hvis du har leveret nogle af punkterne pÃ¥ din opfyldelsesordre vil det ikke lÃ¦ngere vises i rapporten Ã¥bne ordrer.<p>De resterende varer betragtes i restordre og kan i stedet ses i rapporten pÃ¥:<p><b>Ordrer-> rapporter-> elementer tilbage Ordere</b>',0),(447139,12421,'ko','ë§Œì•½ ë‹¹ì‹ ì´ ì˜¤í”ˆ ì£¼ë¬¸ ë³´ê³ ì„œì— ë” ì´ìƒ í‘œì‹œ ë©ë‹ˆë‹¤ í–‰ ìˆœì„œì— ì¼ë¶€ì˜ í•­ëª©ì„ ë°œì†¡ í–ˆìŠµë‹ˆë‹¤.<p>ë‚˜ë¨¸ì§€ í•­ëª© backorderì— ê°„ì£¼ í•˜ ê³  ëŒ€ì‹ ì— ë³´ê³ ì„œì—ì„œ ë³¼ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p><b>ë³´ê³ ì„œ í•­ëª© ë‹¤ì‹œ Orde',0),(447140,12421,'he','×× ×œ×š ×”×™×” ×ž×¢×‘×™×¨ ×”×¤×¨×™×˜×™× ×ž×¡×•×™×ž×™× ×¢×œ ×”×–×ž× ×ª×š ×”×’×©×ž×” ×”×•× ×›×‘×¨ ×œ× ×™×•×¤×™×¢ ×‘×“×•×— ×”×–×ž× ×•×ª ×¤×ª×•×—×•×ª.<p>×”×¤×¨×™×˜×™× ×”× ×•×ª×¨×™× × ×—×©×‘×™× ××–×œ×• ×ž×”×ž×œ××™, ×‘×ž×§×•× ×–××ª, × ×™×ª×Ÿ ×œ×¦×¤',0),(447141,12421,'el','Î‘Î½ Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿ÏƒÏ„ÎµÎ¯Î»Î±Ï„Îµ Î¼ÎµÏÎ¹ÎºÎ¬ Î±Ï€ÏŒ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· ÏƒÎ±Ï‚ Î´ÎµÎ½ Î¸Î± ÎµÎ¼Ï†Î±Î½Î¯Î¶ÎµÏ„Î±Î¹ Ï€Î»Î­Î¿Î½ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î·Î½ Î­ÎºÎ¸ÎµÏƒÎ· Î‘Î½ÎµÎºÏ„Î­Î»',0),(447142,12421,'zh','å¦‚æžœæ‚¨å·²ç»è£…è¿äº†æ‚¨å±¥è¡Œè®¢å•ä¸Šçš„ä¸€äº›é¡¹ç›®ï¼Œå®ƒä¸ä¼šå†æ˜¾ç¤ºåœ¨å…¬å¼€è®¢å•æŠ¥è¡¨ã€‚å‰©ä¸‹çš„é¡¹ç›®ä¼šåœ¨ç¼ºè´§é€šçŸ¥ä¸Šï¼Œä»£ä¹‹ï¼Œæ‚¨å¯ä»¥åœ¨æŠ¥è¡¨ä¸ŠæŸ¥çœ‹ï¼šè®¢å•->æŠ¥è¡¨->é¡¹ç›®ç¼ºè´§é€šçŸ¥',0),(447143,12421,'sv','Om du har levererat nÃ¥gra av punkter pÃ¥ din uppfyllelseordern visas den inte lÃ¤ngre i rapporten Ã¶ppna order.<p>Ã…terstÃ¥ende objekt betraktas pÃ¥ restorder och istÃ¤llet kan ses pÃ¥ rapporten:<p><b>Order-> rapporter-> objekt tillbaka Ordere</b>',0),(447144,12421,'it','Se hanno spedito alcuni degli articoli sul tuo ordine di evasione che non verrÃ  piÃ¹ visualizzato nel report ordini aperti.<p>Gli elementi restanti sono considerati in arretrato e invece possono essere visualizzati in relazione a:<p><b>Ordini-> rapporti-',0),(447145,12421,'tl','',0),(447146,12421,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¹„à¸”à¹‰à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸šà¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸‚à¸­à¸‡à¸„à¸¸à¸“à¸ˆà¸°à¹„à¸¡à¹ˆà¸›à¸£à¸²à¸à¸à¹ƒà¸™à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¹€à¸›à¸´à¸”<p>à¸£à¸²à¸¢à¸à¸²',0),(447147,12421,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤•à¥à¤› à¤…à¤ªà¤¨à¥‡ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤¹à¥ˆ à¤‡à¤¸à¥‡ à¤…à¤¬ à¤–à¥à¤²à¤¾ à¤†à¤¦à¥‡à¤¶ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤ˆ à¤¦à¥‡à¤—à¤¾à¥¤<p>à¤¶à¥‡à¤· à¤®à¤¦à¥‹à',0),(447148,12421,'ms','Jika anda telah dihantar beberapa item-item pada pesanan memenuhi anda ia tidak akan kelihatan lagi pada Laporan pesanan terbuka.<p>Item-item yang lain akan dipertimbangkan pada backorder dan sebaliknya boleh dilihat pada Laporan di:<p><b>Perintah-> lapor',0),(447149,12421,'ar','Ø¥Ø°Ø§ ÙƒÙ†Øª Ù‚Ø¯ Ø´Ø­Ù†Øª Ø¨Ø¹Ø¶ Ø§Ù„Ø¨Ù†ÙˆØ¯ ÙÙŠ Ø£Ù…Ø± Ø§Ø³ØªÙŠÙØ§Ø¡ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ ÙØ¥Ù†Ù‡ Ù„Ù† ØªØ¸Ù‡Ø± ÙÙŠ Ø§Ù„ØªÙ‚Ø±ÙŠØ± \"Ø£ÙˆØ§Ù…Ø± Ù…ÙØªÙˆØ­Ø©\".<p>Ø§Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ© ØªØ¹ØªØ¨Ø± ÙÙŠ Ø§Ù„Ù…Ø¤Ø¬Ù„ØŒ ÙˆØ¨Ø¯Ù„Ø§Ù‹ Ù…Ù† Ø°Ù„Ùƒ ÙŠÙ…Ùƒ',0),(447150,12421,'fr','Si vous avez envoyÃ© certains Ã©lÃ©ments sur votre ordre de traitement, qu\'il n\'apparaÃ®tra plus sur le rapport de commandes en cours.<p>Les Ã©lÃ©ments restants sont considÃ©rÃ©s comme en souffrance et est consultable Ã  la place sur le rapport Ã  :<p><b>',0),(447151,12421,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼ã«ã‚¢ã‚¤ãƒ†ãƒ ã®ä¸€éƒ¨ã‚’åŒæ¢±ã•ã‚Œã¦ã„ã‚‹ã¯ã€ã‚ªãƒ¼ãƒ—ãƒ³æ³¨æ–‡ãƒ¬ãƒãƒ¼ãƒˆã«è¡¨ç¤ºã•ã‚Œãªãã€‚<p>æ®‹ã‚Šã®ã‚¢ã‚¤ãƒ†ãƒ ã¯å…¥è·å¾…ã¡ã¨è¦‹ãªã•ã‚Œã¾ã™ã§ãƒ¬ãƒãƒ¼ãƒˆã®ä»£ã‚ã‚Šã«è¡¨ç¤ºã™ã‚‹ã“ã¨ã',0),(447152,12421,'pt','Se vocÃª tem alguns dos itens enviados na sua ordem de cumprimento nÃ£o mais aparecerÃ¡ sobre o relatÃ³rio de pedidos abertos.<p>Os itens restantes sÃ£o considerados em backorder e em vez disso podem ser vistos no relatÃ³rio em:<p><b>Ordens-> de relatÃ³ri',0),(447153,12421,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð¸ Ð½ÐµÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð½Ð° Ð²Ð°ÑˆÐµÐ¼ Ð·Ð°ÐºÐ°Ð·Ðµ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¾Ð½ Ð±Ð¾Ð»ÑŒÑˆÐµ Ð½Ðµ Ð¿Ð¾ÑÐ²Ð¸Ñ‚ÑÑ Ð½Ð° Ð´Ð¾ÐºÐ»Ð°Ð´ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð¾Ñ€Ð´ÐµÑ€Ð°.<p>ÐžÑÑ‚Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð¿ÑƒÐ½ÐºÑ‚Ñ‹ Ñ€Ð°ÑÑÐ¼Ð°Ñ',0),(447154,12421,'es','Si ha enviado unos de los items en su orden d cumplimiento no mÃ¡s aparece en el informe de ordenes abiertos. <p> El resto de los items se consideran en pedido en espera y puede revisar en el informe a:<p><b>Ordenes -> Informes -> Items en Pedidos de Espe',0),(447155,12421,'de','Wenn Sie einige Elemente der AusfÃ¼hrungsauftrag gesendet haben erscheint es nicht mehr auf den offenen Orders-Bericht.<p>Die Ã¼brigen Elemente gelten im RÃ¼ckstand und kÃ¶nnen stattdessen auf den Bericht bei betrachtet werden:<p><b>Bestellungen-> Bericht',0),(447156,12421,'en','If you have shipped some of the items on your fulfillment order it will no longer appear on the Open Orders report. <p> The remaining items are considered on backorder and can instead be viewed on the report at:<p><b>Orders -> Reports -> Items Back Ordere',0),(447157,12422,'is','',0),(447158,12422,'dr','',0),(447159,12422,'pr','',0),(447160,12422,'tr','',0),(447161,12422,'pl','',0),(447162,12422,'bg','',0),(447163,12422,'ur','',0),(447164,12422,'sr','',0),(447165,12422,'vi','',0),(447166,12422,'af','',0),(447167,12422,'ro','',0),(447168,12422,'et','',0),(447169,12422,'si','',0),(447170,12422,'ba','',0),(447171,12422,'nl','',0),(447172,12422,'fi','',0),(447173,12422,'no','',0),(447174,12422,'da','',0),(447175,12422,'ko','',0),(447176,12422,'he','',0),(447177,12422,'el','',0),(447178,12422,'zh','',0),(447179,12422,'sv','',0),(447180,12422,'it','',0),(447181,12422,'tl','',0),(447182,12422,'th','',0),(447183,12422,'hi','',0),(447184,12422,'ms','',0),(447185,12422,'ar','',0),(447186,12422,'fr','',0),(447187,12422,'jp','',0),(447188,12422,'pt','',0),(447189,12422,'ru','',0),(447190,12422,'es','',0),(447191,12422,'de','',0),(447192,12422,'en','',0),(447193,12423,'is','',0),(447194,12423,'dr','',0),(447195,12423,'pr','',0),(447196,12423,'tr','',0),(447197,12423,'pl','',0),(447198,12423,'bg','',0),(447199,12423,'ur','',0),(447200,12423,'sr','',0),(447201,12423,'vi','',0),(447202,12423,'af','',0),(447203,12423,'ro','',0),(447204,12423,'et','',0),(447205,12423,'si','',0),(447206,12423,'ba','',0),(447207,12423,'nl','',0),(447208,12423,'fi','',0),(447209,12423,'no','',0),(447210,12423,'da','',0),(447211,12423,'ko','',0),(447212,12423,'he','',0),(447213,12423,'el','',0),(447214,12423,'zh','',0),(447215,12423,'sv','',0),(447216,12423,'it','',0),(447217,12423,'tl','',0),(447218,12423,'th','',0),(447219,12423,'hi','',0),(447220,12423,'ms','',0),(447221,12423,'ar','',0),(447222,12423,'fr','',0),(447223,12423,'jp','',0),(447224,12423,'pt','',0),(447225,12423,'ru','',0),(447226,12423,'es','',0),(447227,12423,'de','',0),(447228,12423,'en','',0),(447229,12424,'is','',0),(447230,12424,'dr','',0),(447231,12424,'pr','',0),(447232,12424,'tr','',0),(447233,12424,'pl','',0),(447234,12424,'bg','',0),(447235,12424,'ur','',0),(447236,12424,'sr','',0),(447237,12424,'vi','',0),(447238,12424,'af','',0),(447239,12424,'ro','',0),(447240,12424,'et','',0),(447241,12424,'si','',0),(447242,12424,'ba','',0),(447243,12424,'nl','',0),(447244,12424,'fi','',0),(447245,12424,'no','',0),(447246,12424,'da','',0),(447247,12424,'ko','',0),(447248,12424,'he','',0),(447249,12424,'el','',0),(447250,12424,'zh','',0),(447251,12424,'sv','',0),(447252,12424,'it','',0),(447253,12424,'tl','',0),(447254,12424,'th','',0),(447255,12424,'hi','',0),(447256,12424,'ms','',0),(447257,12424,'ar','',0),(447258,12424,'fr','',0),(447259,12424,'jp','',0),(447260,12424,'pt','',0),(447261,12424,'ru','',0),(447262,12424,'es','',0),(447263,12424,'de','',0),(447264,12424,'en','',0),(447265,12425,'is','',0),(447266,12425,'dr','',0),(447267,12425,'pr','',0),(447268,12425,'tr','',0),(447269,12425,'pl','',0),(447270,12425,'bg','',0),(447271,12425,'ur','',0),(447272,12425,'sr','',0),(447273,12425,'vi','',0),(447274,12425,'af','',0),(447275,12425,'ro','',0),(447276,12425,'et','',0),(447277,12425,'si','',0),(447278,12425,'ba','',0),(447279,12425,'nl','',0),(447280,12425,'fi','',0),(447281,12425,'no','',0),(447282,12425,'da','',0),(447283,12425,'ko','',0),(447284,12425,'he','',0),(447285,12425,'el','',0),(447286,12425,'zh','',0),(447287,12425,'sv','',0),(447288,12425,'it','',0),(447289,12425,'tl','',0),(447290,12425,'th','',0),(447291,12425,'hi','',0),(447292,12425,'ms','',0),(447293,12425,'ar','',0),(447294,12425,'fr','',0),(447295,12425,'jp','',0),(447296,12425,'pt','',0),(447297,12425,'ru','',0),(447298,12425,'es','',0),(447299,12425,'de','',0),(447300,12425,'en','',0),(447301,12426,'is','',0),(447302,12426,'dr','',0),(447303,12426,'pr','',0),(447304,12426,'tr','',0),(447305,12426,'pl','',0),(447306,12426,'bg','',0),(447307,12426,'ur','',0),(447308,12426,'sr','',0),(447309,12426,'vi','',0),(447310,12426,'af','',0),(447311,12426,'ro','',0),(447312,12426,'et','',0),(447313,12426,'si','',0),(447314,12426,'ba','',0),(447315,12426,'nl','',0),(447316,12426,'fi','',0),(447317,12426,'no','',0),(447318,12426,'da','',0),(447319,12426,'ko','',0),(447320,12426,'he','',0),(447321,12426,'el','',0),(447322,12426,'zh','',0),(447323,12426,'sv','',0),(447324,12426,'it','',0),(447325,12426,'tl','',0),(447326,12426,'th','',0),(447327,12426,'hi','',0),(447328,12426,'ms','',0),(447329,12426,'ar','',0),(447330,12426,'fr','',0),(447331,12426,'jp','',0),(447332,12426,'pt','',0),(447333,12426,'ru','',0),(447334,12426,'es','',0),(447335,12426,'de','',0),(447336,12426,'en','',0),(447337,12427,'is','',0),(447338,12427,'dr','',0),(447339,12427,'pr','',0),(447340,12427,'tr','',0),(447341,12427,'pl','',0),(447342,12427,'bg','',0),(447343,12427,'ur','',0),(447344,12427,'sr','',0),(447345,12427,'vi','',0),(447346,12427,'af','',0),(447347,12427,'ro','',0),(447348,12427,'et','',0),(447349,12427,'si','',0),(447350,12427,'ba','',0),(447351,12427,'nl','',0),(447352,12427,'fi','',0),(447353,12427,'no','',0),(447354,12427,'da','',0),(447355,12427,'ko','',0),(447356,12427,'he','',0),(447357,12427,'el','',0),(447358,12427,'zh','',0),(447359,12427,'sv','',0),(447360,12427,'it','',0),(447361,12427,'tl','',0),(447362,12427,'th','',0),(447363,12427,'hi','',0),(447364,12427,'ms','',0),(447365,12427,'ar','',0),(447366,12427,'fr','',0),(447367,12427,'jp','',0),(447368,12427,'pt','',0),(447369,12427,'ru','',0),(447370,12427,'es','',0),(447371,12427,'de','',0),(447372,12427,'en','',0),(447373,12428,'is','',0),(447374,12428,'dr','',0),(447375,12428,'pr','',0),(447376,12428,'tr','',0),(447377,12428,'pl','',0),(447378,12428,'bg','',0),(447379,12428,'ur','',0),(447380,12428,'sr','',0),(447381,12428,'vi','',0),(447382,12428,'af','',0),(447383,12428,'ro','',0),(447384,12428,'et','',0),(447385,12428,'si','',0),(447386,12428,'ba','',0),(447387,12428,'nl','',0),(447388,12428,'fi','',0),(447389,12428,'no','',0),(447390,12428,'da','',0),(447391,12428,'ko','',0),(447392,12428,'he','',0),(447393,12428,'el','',0),(447394,12428,'zh','',0),(447395,12428,'sv','',0),(447396,12428,'it','',0),(447397,12428,'tl','',0),(447398,12428,'th','',0),(447399,12428,'hi','',0),(447400,12428,'ms','',0),(447401,12428,'ar','',0),(447402,12428,'fr','',0),(447403,12428,'jp','',0),(447404,12428,'pt','',0),(447405,12428,'ru','',0),(447406,12428,'es','',0),(447407,12428,'de','',0),(447408,12428,'en','',0),(447409,12429,'is','',0),(447410,12429,'dr','',0),(447411,12429,'pr','',0),(447412,12429,'tr','',0),(447413,12429,'pl','',0),(447414,12429,'bg','',0),(447415,12429,'ur','',0),(447416,12429,'sr','',0),(447417,12429,'vi','',0),(447418,12429,'af','',0),(447419,12429,'ro','',0),(447420,12429,'et','',0),(447421,12429,'si','',0),(447422,12429,'ba','',0),(447423,12429,'nl','',0),(447424,12429,'fi','',0),(447425,12429,'no','',0),(447426,12429,'da','',0),(447427,12429,'ko','',0),(447428,12429,'he','',0),(447429,12429,'el','',0),(447430,12429,'zh','',0),(447431,12429,'sv','',0),(447432,12429,'it','',0),(447433,12429,'tl','',0),(447434,12429,'th','',0),(447435,12429,'hi','',0),(447436,12429,'ms','',0),(447437,12429,'ar','',0),(447438,12429,'fr','',0),(447439,12429,'jp','',0),(447440,12429,'pt','',0),(447441,12429,'ru','',0),(447442,12429,'es','',0),(447443,12429,'de','',0),(447444,12429,'en','',0),(447445,12430,'is','',0),(447446,12430,'dr','',0),(447447,12430,'pr','',0),(447448,12430,'tr','',0),(447449,12430,'pl','',0),(447450,12430,'bg','',0),(447451,12430,'ur','',0),(447452,12430,'sr','',0),(447453,12430,'vi','',0),(447454,12430,'af','',0),(447455,12430,'ro','',0),(447456,12430,'et','',0),(447457,12430,'si','',0),(447458,12430,'ba','',0),(447459,12430,'nl','',0),(447460,12430,'fi','',0),(447461,12430,'no','',0),(447462,12430,'da','',0),(447463,12430,'ko','',0),(447464,12430,'he','',0),(447465,12430,'el','',0),(447466,12430,'zh','',0),(447467,12430,'sv','',0),(447468,12430,'it','',0),(447469,12430,'tl','',0),(447470,12430,'th','',0),(447471,12430,'hi','',0),(447472,12430,'ms','',0),(447473,12430,'ar','',0),(447474,12430,'fr','',0),(447475,12430,'jp','',0),(447476,12430,'pt','',0),(447477,12430,'ru','',0),(447478,12430,'es','',0),(447479,12430,'de','',0),(447480,12430,'en','',0),(447481,12431,'is','',0),(447482,12431,'dr',':Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¬Ù†Ø³-Ù…Ø­Ù„ Ú©Ø§Ø±Ø®Ø§Ù†Ù‡',0),(447483,12431,'pr','Ø¨Ø±Ø§ÛŒ Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†Ø¨Ø§Ø±Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ Ø§Ø² Ø·ÛŒÙ‚ Ù…Ø³ÛŒØ±Ø²ÛŒØ± Ø§Ù‚Ø¯Ø§Ù… Ú©Ù†ÛŒØ¯:Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§-Ù…Ø­Ù„ Ú©Ø§Ø±Ø®Ø§Ù†Ù‡',0),(447484,12431,'tr','Ek depo eklemek iÃ§in gidin:<p><b>YÃ¶netici Kurulumu stok bitki Mekanlar->-></b>',0),(447485,12431,'pl','Aby dodaÄ‡ dodatkowe skÅ‚ady, przejdÅº do:<p><b>Admin-> instalacji magazynowych-> lokalizacje produkcji</b>',0),(447486,12431,'bg','Ð—Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ ÑÐºÐ»Ð°Ð´Ð¾Ð²Ðµ, Ð¿Ð¾ÑÐµÑ‚ÐµÑ‚Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÑÐºÐ»Ð°Ð´-> Ñ€Ð°ÑÑ‚Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¼ÐµÑÑ‚Ð°</b>',0),(447487,12431,'ur','Ø§Ø¶Ø§ÙÛŒ Ú¯ÙˆØ¯Ø§Ù…ÙˆÚº Ú©Û’ Ø§Ø¶Ø§ÙÛ’ Ú©Û’ Ù„ÛŒÛ’ Ø¬Ø§Ù†Ø§:<p><b>Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù¾Ù„Ø§Ù†Ù¹ Ù…Ù‚Ø§Ù…Ø§Øª->-> Ø§ÛŒÚˆÙ…Ù†</b>',0),(447488,12431,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ðµ, Ð¿Ð¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¸ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð° Ð±Ð¸Ñ™ÐºÑƒ</b>',0),(447489,12431,'vi','Äá»ƒ thÃªm cÃ¡c kho bá»• sung, hÃ£y vÃ o: Quáº£n lÃ½-> thiáº¿t láº­p hÃ ng tá»“n kho-> Ä‘á»‹a Ä‘iá»ƒm nhÃ  mÃ¡y',0),(447490,12431,'af','Om by te voeg bykomende pakhuise, gaan na:<p><b>Admin-> opstelling voorraad-> Plant liggings</b>',0),(447491,12431,'ro','Pentru a adÄƒuga suplimentare depozite, du-te la:<p><b>Admin-> Setup inventar-> plante locatii</b>',0),(447492,12431,'et','TÃ¤iendav ladude lisamiseks Mine:<p><b>Admin-> Setup lao-> taimede asukohad</b>',0),(447493,12431,'si','ÄŒe Å¾elite dodati dodatna skladiÅ¡Äa, pojdite na:<p><b>Admin-> nastavitev zaloge-> rastlin lokacijah</b>',0),(447494,12431,'ba','Untuk menambahkan tambahan gudang, go to:<p><b>Admin-> Setup persediaan-> lokasi pabrik</b>',0),(447495,12431,'nl','Om toe te voegen extra magazijnen, ga naar:<p><b>Admin-> Setup voorraad-> Plant locaties</b>',0),(447496,12431,'fi','Jos haluat lisÃ¤tÃ¤ muita varastoja, Siirry:<p><b>Admin asetukset varaston-> kasvi sijainnit-></b>',0),(447497,12431,'no','For Ã¥ legge til flere lagre, kan du gÃ¥ til:<p><b>Admin-> installasjonsprogrammet lager-> plante steder</b>',0),(447498,12431,'da','For at tilfÃ¸je flere lagersteder, gÃ¥ til:<p><b>Admin-> Setup lager-> plante steder</b>',0),(447499,12431,'ko','ì¶”ê°€ ì°½ì— ì¶”ê°€ í•˜ë ¤ë©´ ë‹¤ìŒìœ¼ë¡œ ì´ë™:<p><b>ê´€ë¦¬ìž ì„¤ì • ìž¬ê³  ê³µìž¥ ìœ„ì¹˜->-></b>',0),(447500,12431,'he','×›×“×™ ×œ×”×•×¡×™×£ ×ž×—×¡× ×™× × ×•×¡×¤×™×, ×¢×‘×•×¨ ××œ:<p><b>Admin-> ×”×’×“×¨×ª ×ž×œ××™-> ×¦×ž×— ×ž×™×§×•×ž×™×</b>',0),(447501,12431,'el','Î“Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ‚, Ï€Î·Î³Î±Î¯Î½ÎµÏ„Îµ ÏƒÏ„Î¿:<p><b>Admin-> Ï€Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚-> Î¸Î­ÏƒÎµÎ¹Ï‚ Ï†Ï…Ï„ÏŽÎ½</b>',0),(447502,12431,'zh','è¦æ–°å¢žé™„åŠ ä»“åº“ï¼Œåˆ°ï¼šç®¡ç†->è®¾ç½®åº“å­˜->å·¥åŽ‚ä½ç½®',0),(447503,12431,'sv','FÃ¶r att lÃ¤gga till ytterligare lager, gÃ¥ till:<p><b>Admin-> Setup inventering-> vÃ¤xt platser</b>',0),(447504,12431,'it','Per aggiungere ulteriori magazzini, andare a:<p><b>Admin-> Inventory Setup-> pianta posizioni</b>',0),(447505,12431,'tl','',0),(447506,12431,'th','à¹€à¸¡à¸·à¹ˆà¸­à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸¥à¸±à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡ à¹„à¸›à¸—à¸µà¹ˆ:<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡->à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡à¹‚à¸£à¸‡à¸‡à¸²à¸™</b>',0),(447507,12431,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤—à¥‹à¤¦à¤¾à¤®à¥‹à¤‚ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤¨à¤¾:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¤‚à¤¯à¤‚à¤¤à¥à¤° à¤¸à¥à¤¥à¤¾à¤¨à¥‹',0),(447508,12431,'ms','Untuk menambah gudang tambahan, sila pergi ke:<p><b>Admin-> persediaan inventori-> lokasi loji</b>',0),(447509,12431,'ar','Ù„Ø¥Ø¶Ø§ÙØ© Ù…Ø³ØªÙˆØ¯Ø¹Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ©ØŒ Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-> Ù…ÙˆØ§Ù‚Ø¹ Ù…ØµÙ†Ø¹</b>',0),(447510,12431,'fr','Ajouter entrepÃ´ts supplÃ©mentaires, allez dans :<p><b>Admin-> Setup inventaire-> lieux d\'usine</b>',0),(447511,12431,'jp','è¿½åŠ ã®å€‰åº«ã‚’è¿½åŠ ã™ã‚‹ã«ç§»å‹•ã—ã¾ã™ã€‚<p><b>ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—å·¥å ´å ´æ‰€-> åœ¨åº«-> ç®¡ç†è€…</b>',0),(447512,12431,'pt','Para adicionar armazÃ©ns adicionais, vÃ¡ para:<p><b>Admin-> Setup inventÃ¡rio-> planta locais</b>',0),(447513,12431,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÐºÐ»Ð°Ð´Ñ‹, Ð¿ÐµÑ€ÐµÐ¹Ð´Ð¸Ñ‚Ðµ Ðº:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ-> Ð·Ð°Ð²Ð¾Ð´ Ð¼ÐµÑÑ‚Ð°</b>',0),(447514,12431,'es','Para agregar items adicionales, va a:<p><b>Admin -> Configurar Inventario -> Colocaciones de Fabricas</b>',0),(447515,12431,'de','Um zusÃ¤tzliche LagerhÃ¤user hinzuzufÃ¼gen, gehen Sie zu:<p><b>Admin-> Lager Einrichtung-> Pflanze Locations</b>',0),(447516,12431,'en','To add additional warehouses, go to:<p><b>Admin -> Setup Inventory -> Plant Locations</b>',0),(447517,12432,'is','',0),(447518,12432,'dr','',0),(447519,12432,'pr','',0),(447520,12432,'tr','',0),(447521,12432,'pl','',0),(447522,12432,'bg','',0),(447523,12432,'ur','',0),(447524,12432,'sr','',0),(447525,12432,'vi','',0),(447526,12432,'af','',0),(447527,12432,'ro','',0),(447528,12432,'et','',0),(447529,12432,'si','',0),(447530,12432,'ba','',0),(447531,12432,'nl','',0),(447532,12432,'fi','',0),(447533,12432,'no','',0),(447534,12432,'da','',0),(447535,12432,'ko','',0),(447536,12432,'he','',0),(447537,12432,'el','',0),(447538,12432,'zh','',0),(447539,12432,'sv','',0),(447540,12432,'it','',0),(447541,12432,'tl','',0),(447542,12432,'th','',0),(447543,12432,'hi','',0),(447544,12432,'ms','',0),(447545,12432,'ar','',0),(447546,12432,'fr','',0),(447547,12432,'jp','',0),(447548,12432,'pt','',0),(447549,12432,'ru','',0),(447550,12432,'es','',0),(447551,12432,'de','',0),(447552,12432,'en','',0),(447553,12433,'is','',0),(447554,12433,'dr','',0),(447555,12433,'pr','',0),(447556,12433,'tr','',0),(447557,12433,'pl','',0),(447558,12433,'bg','',0),(447559,12433,'ur','',0),(447560,12433,'sr','',0),(447561,12433,'vi','',0),(447562,12433,'af','',0),(447563,12433,'ro','',0),(447564,12433,'et','',0),(447565,12433,'si','',0),(447566,12433,'ba','',0),(447567,12433,'nl','',0),(447568,12433,'fi','',0),(447569,12433,'no','',0),(447570,12433,'da','',0),(447571,12433,'ko','',0),(447572,12433,'he','',0),(447573,12433,'el','',0),(447574,12433,'zh','',0),(447575,12433,'sv','',0),(447576,12433,'it','',0),(447577,12433,'tl','',0),(447578,12433,'th','',0),(447579,12433,'hi','',0),(447580,12433,'ms','',0),(447581,12433,'ar','',0),(447582,12433,'fr','',0),(447583,12433,'jp','',0),(447584,12433,'pt','',0),(447585,12433,'ru','',0),(447586,12433,'es','',0),(447587,12433,'de','',0),(447588,12433,'en','',0),(447589,12434,'is','',0),(447590,12434,'dr','',0),(447591,12434,'pr','',0),(447592,12434,'tr','',0),(447593,12434,'pl','',0),(447594,12434,'bg','',0),(447595,12434,'ur','',0),(447596,12434,'sr','',0),(447597,12434,'vi','',0),(447598,12434,'af','',0),(447599,12434,'ro','',0),(447600,12434,'et','',0),(447601,12434,'si','',0),(447602,12434,'ba','',0),(447603,12434,'nl','',0),(447604,12434,'fi','',0),(447605,12434,'no','',0),(447606,12434,'da','',0),(447607,12434,'ko','',0),(447608,12434,'he','',0),(447609,12434,'el','',0),(447610,12434,'zh','',0),(447611,12434,'sv','',0),(447612,12434,'it','',0),(447613,12434,'tl','',0),(447614,12434,'th','',0),(447615,12434,'hi','',0),(447616,12434,'ms','',0),(447617,12434,'ar','',0),(447618,12434,'fr','',0),(447619,12434,'jp','',0),(447620,12434,'pt','',0),(447621,12434,'ru','',0),(447622,12434,'es','',0),(447623,12434,'de','',0),(447624,12434,'en','',0),(447625,12435,'is','',0),(447626,12435,'dr','',0),(447627,12435,'pr','',0),(447628,12435,'tr','',0),(447629,12435,'pl','',0),(447630,12435,'bg','',0),(447631,12435,'ur','',0),(447632,12435,'sr','',0),(447633,12435,'vi','',0),(447634,12435,'af','',0),(447635,12435,'ro','',0),(447636,12435,'et','',0),(447637,12435,'si','',0),(447638,12435,'ba','',0),(447639,12435,'nl','',0),(447640,12435,'fi','',0),(447641,12435,'no','',0),(447642,12435,'da','',0),(447643,12435,'ko','',0),(447644,12435,'he','',0),(447645,12435,'el','',0),(447646,12435,'zh','',0),(447647,12435,'sv','',0),(447648,12435,'it','',0),(447649,12435,'tl','',0),(447650,12435,'th','',0),(447651,12435,'hi','',0),(447652,12435,'ms','',0),(447653,12435,'ar','',0),(447654,12435,'fr','',0),(447655,12435,'jp','',0),(447656,12435,'pt','',0),(447657,12435,'ru','',0),(447658,12435,'es','',0),(447659,12435,'de','',0),(447660,12435,'en','',0),(447661,12436,'is','',0),(447662,12436,'dr','',0),(447663,12436,'pr','',0),(447664,12436,'tr','',0),(447665,12436,'pl','',0),(447666,12436,'bg','',0),(447667,12436,'ur','',0),(447668,12436,'sr','',0),(447669,12436,'vi','',0),(447670,12436,'af','',0),(447671,12436,'ro','',0),(447672,12436,'et','',0),(447673,12436,'si','',0),(447674,12436,'ba','',0),(447675,12436,'nl','',0),(447676,12436,'fi','',0),(447677,12436,'no','',0),(447678,12436,'da','',0),(447679,12436,'ko','',0),(447680,12436,'he','',0),(447681,12436,'el','',0),(447682,12436,'zh','',0),(447683,12436,'sv','',0),(447684,12436,'it','',0),(447685,12436,'tl','',0),(447686,12436,'th','',0),(447687,12436,'hi','',0),(447688,12436,'ms','',0),(447689,12436,'ar','',0),(447690,12436,'fr','',0),(447691,12436,'jp','',0),(447692,12436,'pt','',0),(447693,12436,'ru','',0),(447694,12436,'es','',0),(447695,12436,'de','',0),(447696,12436,'en','',0),(447697,12437,'is','',0),(447698,12437,'dr','',0),(447699,12437,'pr','',0),(447700,12437,'tr','',0),(447701,12437,'pl','',0),(447702,12437,'bg','',0),(447703,12437,'ur','',0),(447704,12437,'sr','',0),(447705,12437,'vi','',0),(447706,12437,'af','',0),(447707,12437,'ro','',0),(447708,12437,'et','',0),(447709,12437,'si','',0),(447710,12437,'ba','',0),(447711,12437,'nl','',0),(447712,12437,'fi','',0),(447713,12437,'no','',0),(447714,12437,'da','',0),(447715,12437,'ko','',0),(447716,12437,'he','',0),(447717,12437,'el','',0),(447718,12437,'zh','',0),(447719,12437,'sv','',0),(447720,12437,'it','',0),(447721,12437,'tl','',0),(447722,12437,'th','',0),(447723,12437,'hi','',0),(447724,12437,'ms','',0),(447725,12437,'ar','',0),(447726,12437,'fr','',0),(447727,12437,'jp','',0),(447728,12437,'pt','',0),(447729,12437,'ru','',0),(447730,12437,'es','',0),(447731,12437,'de','',0),(447732,12437,'en','',0),(447733,12438,'is','',0),(447734,12438,'dr','',0),(447735,12438,'pr','',0),(447736,12438,'tr','',0),(447737,12438,'pl','',0),(447738,12438,'bg','',0),(447739,12438,'ur','',0),(447740,12438,'sr','',0),(447741,12438,'vi','',0),(447742,12438,'af','',0),(447743,12438,'ro','',0),(447744,12438,'et','',0),(447745,12438,'si','',0),(447746,12438,'ba','',0),(447747,12438,'nl','',0),(447748,12438,'fi','',0),(447749,12438,'no','',0),(447750,12438,'da','',0),(447751,12438,'ko','',0),(447752,12438,'he','',0),(447753,12438,'el','',0),(447754,12438,'zh','',0),(447755,12438,'sv','',0),(447756,12438,'it','',0),(447757,12438,'tl','',0),(447758,12438,'th','',0),(447759,12438,'hi','',0),(447760,12438,'ms','',0),(447761,12438,'ar','',0),(447762,12438,'fr','',0),(447763,12438,'jp','',0),(447764,12438,'pt','',0),(447765,12438,'ru','',0),(447766,12438,'es','',0),(447767,12438,'de','',0),(447768,12438,'en','',0),(447769,12439,'is','',0),(447770,12439,'dr','',0),(447771,12439,'pr','',0),(447772,12439,'tr','',0),(447773,12439,'pl','',0),(447774,12439,'bg','',0),(447775,12439,'ur','',0),(447776,12439,'sr','',0),(447777,12439,'vi','',0),(447778,12439,'af','',0),(447779,12439,'ro','',0),(447780,12439,'et','',0),(447781,12439,'si','',0),(447782,12439,'ba','',0),(447783,12439,'nl','',0),(447784,12439,'fi','',0),(447785,12439,'no','',0),(447786,12439,'da','',0),(447787,12439,'ko','',0),(447788,12439,'he','',0),(447789,12439,'el','',0),(447790,12439,'zh','',0),(447791,12439,'sv','',0),(447792,12439,'it','',0),(447793,12439,'tl','',0),(447794,12439,'th','',0),(447795,12439,'hi','',0),(447796,12439,'ms','',0),(447797,12439,'ar','',0),(447798,12439,'fr','',0),(447799,12439,'jp','',0),(447800,12439,'pt','',0),(447801,12439,'ru','',0),(447802,12439,'es','',0),(447803,12439,'de','',0),(447804,12439,'en','',0),(447805,12440,'is','',0),(447806,12440,'dr','',0),(447807,12440,'pr','',0),(447808,12440,'tr','',0),(447809,12440,'pl','',0),(447810,12440,'bg','',0),(447811,12440,'ur','',0),(447812,12440,'sr','',0),(447813,12440,'vi','',0),(447814,12440,'af','',0),(447815,12440,'ro','',0),(447816,12440,'et','',0),(447817,12440,'si','',0),(447818,12440,'ba','',0),(447819,12440,'nl','',0),(447820,12440,'fi','',0),(447821,12440,'no','',0),(447822,12440,'da','',0),(447823,12440,'ko','',0),(447824,12440,'he','',0),(447825,12440,'el','',0),(447826,12440,'zh','',0),(447827,12440,'sv','',0),(447828,12440,'it','',0),(447829,12440,'tl','',0),(447830,12440,'th','',0),(447831,12440,'hi','',0),(447832,12440,'ms','',0),(447833,12440,'ar','',0),(447834,12440,'fr','',0),(447835,12440,'jp','',0),(447836,12440,'pt','',0),(447837,12440,'ru','',0),(447838,12440,'es','',0),(447839,12440,'de','',0),(447840,12440,'en','',0),(447841,12441,'is','',0),(447842,12441,'dr','',0),(447843,12441,'pr','',0),(447844,12441,'tr','',0),(447845,12441,'pl','',0),(447846,12441,'bg','',0),(447847,12441,'ur','',0),(447848,12441,'sr','',0),(447849,12441,'vi','',0),(447850,12441,'af','',0),(447851,12441,'ro','',0),(447852,12441,'et','',0),(447853,12441,'si','',0),(447854,12441,'ba','',0),(447855,12441,'nl','',0),(447856,12441,'fi','',0),(447857,12441,'no','',0),(447858,12441,'da','',0),(447859,12441,'ko','',0),(447860,12441,'he','',0),(447861,12441,'el','',0),(447862,12441,'zh','',0),(447863,12441,'sv','',0),(447864,12441,'it','',0),(447865,12441,'tl','',0),(447866,12441,'th','',0),(447867,12441,'hi','',0),(447868,12441,'ms','',0),(447869,12441,'ar','',0),(447870,12441,'fr','',0),(447871,12441,'jp','',0),(447872,12441,'pt','',0),(447873,12441,'ru','',0),(447874,12441,'es','',0),(447875,12441,'de','',0),(447876,12441,'en','',0),(447877,12442,'is','',0),(447878,12442,'dr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø§Ù„ÛŒØ§Øª Ø±Ø§ Ù…ÛŒ ØªÙˆØ§Ù† Ù¾ÛŒÚ©Ø±Ø¨Ù†Ø¯ÛŒ:<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ùˆ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ù…Ø§Ù„ÛŒØ§Øª-></b><p>Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¹Ù…ÙˆÙ…ÛŒ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.  Ø§Ú¯Ø± Ù…Ø§Ù„ÛŒØ§Øª ØªÙˆ',0),(447879,12442,'pr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø§Ù„ÛŒØ§Øª Ø±Ø§ Ù…ÛŒ ØªÙˆØ§Ù† Ù¾ÛŒÚ©Ø±Ø¨Ù†Ø¯ÛŒ:<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ùˆ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ù…Ø§Ù„ÛŒØ§Øª-></b><p>Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¹Ù…ÙˆÙ…ÛŒ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.  Ø§Ú¯Ø± Ù…Ø§Ù„ÛŒØ§Øª ØªÙˆ',0),(447880,12442,'tr','AR vergi burada yapÄ±landÄ±rÄ±labilir:<p><b>YÃ¶netici Kurulumu-fatura satÄ±ÅŸ vergileri->-></b><p>Genel satÄ±ÅŸ vergisi bilgilerini seÃ§in.  EÄŸer tarafÄ±ndan <i>Sevk</i> adresi vergi vergi Walk-Ins bÃ¶lÃ¼m iÃ§in satÄ±ÅŸ vergisi ilÃ§e seÃ§meniz gerekir.',0),(447881,12442,'pl','AR podatki mogÄ… byÄ‡ skonfigurowane tutaj:<p><b>Admin-> instalacji Billing-> podatek</b><p>Wybierz opcjÄ™ Informacje o podatku od sprzedaÅ¼y.  JeÅ›li opodatkowania przez <i>Statek</i> adres trzeba bÄ™dzie wybraÄ‡ podatku w podatku od sprzedaÅ¼y dla walk-',0),(447882,12442,'bg','AR Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ñ‚ÑƒÐº:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ</b><p>Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð',0),(447883,12442,'ur','ÛŒÛØ§Úº Ø§Ù„Ø±Ø­ÛŒÙ‚ Ù¹ÛŒÚ©Ø³ ØªØ´Ú©ÛŒÙ„ Ø¯ÛŒØ§ Ø¬Ø§Ø³Ú©ØªØ§ ÛÛ’:<p><b>Ø§ÛŒÚˆÙ…Ù† Ø³ÛŒÙ¹ Ø§Ù¾-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³->-></b><p>Ø¬Ù†Ø±Ù„ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Û”  Ø§Ú¯Ø± <i>Ø¬ÛØ§Ø² Ú©Û’</i> Ø¹',0),(447884,12442,'sr','ÐžÐ²Ð´Ðµ ÑÐµ Ð¼Ð¾Ð³Ñƒ ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ ÐÐ  Ð¿Ð¾Ñ€ÐµÐ·:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ-Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð¿Ð¾Ñ€ÐµÐ·</b><p>Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿ÑˆÑ‚Ðµ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð˜Ð½Ñ„Ð¾.  ÐÐºÐ¾ Ð½Ð°Ð¿Ð¾Ñ€Ð½Ð¾ Ð¿Ð¾',0),(447885,12442,'vi','thuáº¿ AR cÃ³ thá»ƒ Ä‘Æ°á»£c cáº¥u hÃ¬nh táº¡i Ä‘Ã¢y: Quáº£n lÃ½-> Thiáº¿t láº­p thanh toÃ¡n-> thuáº¿ bÃ¡n hÃ ng-> chá»n thÃ´ng tin thuáº¿ bÃ¡n bÃ ng tá»•ng quÃ¡t.Náº¿u Ä‘Ã¡nh thuáº¿ bá»Ÿi Ä‘á»‹a chá»‰ xuÃ¢t hÃ ng, báº¡n sáº½ cáº§n pháº£i chá»n thuáº¿ ï',0),(447886,12442,'af','AR belastings kan hier gekonfigureer word:<p><b>Admin-> opstel-fakturering-> verkope belastings</b><p>Kies algemene verkoopsbelasting Info.  Indien inskrywing deur die <i>Skip</i> adres sal jy moet kies die belasting in die distrik van verkope belasting v',0),(447887,12442,'ro','AR impozitele pot fi configurate aici:<p><b>Admin-> Setup-facturare-> taxa la vÃ¢nzÄƒri</b><p>SelectaÅ£i Info TVA generale.  ÃŽn cazul Ã®n care impozitarea de <i>Livrare la</i> adresa va trebui sÄƒ selectaÅ£i fiscal din impozit pe vÃ¢nzÄƒri pentru Walk-in',0),(447888,12442,'et','Siin saab seadistada AR maksud:<p><b>Admin-> seadistuse-arved kÃ¤ibemaksu-></b><p>Valige Ãœldine kÃ¤ibemaksu Info.  Kui <i>Saaja</i> aadressi maksustada peate valige maksu Walk-Ins jagu kÃ¤ibemaks linnaosas.',0),(447889,12442,'si','AR davke tukaj mogoÄe konfigurirati:<p><b>Admin-> Setup-zaraÄunavanje-> prodaji davkov</b><p>Izberite sploÅ¡ni prometni davek Info.  ÄŒe obdavÄitev po naslovu <i>Dobava</i> boste morali izbrati davka v okroÅ¾ju prometnega davka za sprehod-ins oddelek.',0),(447890,12442,'ba','AR pajak dapat dikonfigurasi di sini:<p><b>Admin-> Setup-penagihan-> pajak penjualan</b><p>Pilih Info Umum pajak penjualan.  Jika pajak oleh <i>Kapal ke</i> alamat Anda akan perlu memilih pajak di distrik pajak penjualan untuk Walk In bagian.',0),(447891,12442,'nl','AR belastingen kunnen hier worden geconfigureerd:<p><b>Admin-> Setup-Billing-> belastingen op de verkoop</b><p>Selecteer algemene Sales Tax Info.  Als belasten door het <i>Schip naar</i> -adres moet u de belasting in de Sales Tax District voor Walk-Ins se',0),(447892,12442,'fi','AR veroja voidaan mÃ¤Ã¤rittÃ¤Ã¤:<p><b>Admin-> mÃ¤Ã¤ritettÃ¤vÃ¤ laskutus-> arvonlisÃ¤verot</b><p>Valitse yleinen Info.  Jos verottaa <i>toimitusosoite</i> sinun valita veron arvonlisÃ¤veron alueella Walk-Ins osan.',0),(447893,12442,'no','AR avgifter kan konfigureres her:<p><b>Admin-> Setup-fakturering-> merverdiavgift</b><p>Velg generell mva Info.  Hvis beskatte av <i>Lever til</i> -adressen mÃ¥ velge skatt i bydelen mva for Walk-Ins delen.',0),(447894,12442,'da','AR skatter kan konfigureres her:<p><b>Admin-> Setup-fakturering-> moms</b><p>VÃ¦lg generel omsÃ¦tningsafgift Info.  Hvis beskatning af <i>Skib til</i> -adresse skal du vÃ¦lge afgiften i bydelen Sales Tax for Walk-Ins sektion.',0),(447895,12442,'ko','ì•„ì¹¸ì†Œ ì„¸ê¸ˆ ì—¬ê¸°ì—ì„œ êµ¬ì„±í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p><b>ì„¤ì¹˜-ê²°ì œ íŒë§¤ ì„¸ê¸ˆ->-> ê´€ë¦¬ìž</b><p>ì¼ë°˜ íŒë§¤ ì„¸ê¸ˆ ì •ë³´ë¥¼ ì„ íƒ í•©ë‹ˆë‹¤.  <i>ë°°ì†¡ì§€</i> ì£¼ì†Œì— ì˜í•´ ë¶€ë‹´ í•˜ëŠ” ê²½ìš° ë‚´ë°© ì„¹ì…˜ì— ëŒ€ í•œ íŒë§¤ ì„¸ê¸ˆ ',0),(447896,12442,'he','×›××Ÿ × ×™×ª×Ÿ ×œ×”×’×“×™×¨ AR ×ž×™×¡×™×:<p><b>Admin-> ×”×”×ª×§× ×”-×—×™×•×‘-> ×ž×¢ ×ž</b><p>×‘×—×¨ ×ž×™×“×¢ ×›×œ×œ×™ ×ž×¢ ×ž.  ×× ×ž×™×¡×•×™ ×¢×œ ×™×“×™ ×›×ª×•×‘×ª <i>×œ×ž×©×œ×•×—</i> ×™×”×™×” ×¢×œ×™×š ×œ×‘×—×•×¨ ××ª ×”×ž×¡ ×©×œ ×¨×•×‘×¢ ×ž×¢ ×ž ×¢×',0),(447897,12442,'el','AR Ï†ÏŒÏÎ¿Ï…Ï‚ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÏÏ…Î¸Î¼Î¹ÏƒÏ„ÎµÎ¯ ÎµÎ´ÏŽ:<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚-> Ï†ÏŒÏÎ¿Î¹ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½</b><p>Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³ÎµÎ½Î¹ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï… Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½.  Î',0),(447898,12442,'zh','åº”æ”¶è´¦æ¬¾ç¨Žæ”¶å¯ä»¥åœ¨è¿™é‡Œé…ç½®ï¼šç®¡ç†->è®¾ç½®å…¥è´¦->é”€å”®ç¨Žæ”¶\r\né€‰æ‹©æ™®é€šé”€å”®ç¨Žä¿¡æ¯ã€‚å¦‚æžœç”±æ”¶è´§åœ°å€å¾ç¨Žï¼Œæ‚¨éœ€è¦ä¸ºä¸´æ—¶éƒ¨åˆ†é€‰æ‹©é”€å”®ç¨ŽåŒºçš„ç¨Žæ”¶ã€‚',0),(447899,12442,'sv','AR skatter kan konfigureras hÃ¤r:<p><b>Admin-> Setup-fakturering-> moms</b><p>VÃ¤lj allmÃ¤n omsÃ¤ttningsskatt information.  Om beskattning av <i>leveransadressen</i> kommer att du behÃ¶va vÃ¤lja skatten i distriktet moms fÃ¶r Walk-Ins avsnitt.',0),(447900,12442,'it','Tasse di AR possono essere configurate qui:<p><b>Admin-> Setup-fatturazione-> le imposte sulle vendite</b><p>Selezionare Info generali IVA.  Se tassare dall\'indirizzo <i>Spedire</i> devi selezionare imposta nel quartiere di IVA per sezione di Walk-in.',0),(447901,12442,'tl','',0),(447902,12442,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¸–à¸¹à¸à¸à¸³à¸«à¸™à¸”à¸„à¹ˆà¸² AR à¸ à¸²à¸©à¸µ: à¸—à¸µà¹ˆà¸™à¸µà¹ˆ<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™->à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢</b><p>à¹€à¸¥à¸·à¸­à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢à¸—à¸±à¹ˆà¸',0),(447903,12442,'hi','à¤. à¤†à¤°. à¤•à¤°à¥‹à¤‚ à¤¯à¤¹à¤¾à¤ à¤•à¥‰à¤¨à¥à¤«à¤¼à¤¿à¤—à¤° à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª-à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥‹à¤‚->-></b><p>à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•',0),(447904,12442,'ms','AR cukai boleh dikonfigurasikan di sini:<p><b>Admin-> persediaan-bil-> cukai jualan</b><p>Pilih maklumat am cukai jualan.  Jika sukar oleh <i>Kapal ke</i> alamat yang anda perlu pilih cukai di Daerah cukai jualan bagi Seksyen Walk-Ins.',0),(447905,12442,'ar','ÙŠÙ…ÙƒÙ† ØªÙƒÙˆÙŠÙ† Ø¹ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ù‡Ù†Ø§:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª</b><p>Ø­Ø¯Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø©.  Ø¥Ø°Ø§ ÙØ±Ø¶ Ø¶Ø±Ø§Ø¦Ø¨ Ø¹Ù„Ù‰ Ø¬Ø§Ù†Ø¨ <i>Ø§Ù„Ø³ÙÙŠÙ†',0),(447906,12442,'fr','Taxes AR peuvent Ãªtre configurÃ©s ici :<p><b>Admin-> Setup-facturation-> des Taxes de vente</b><p>SÃ©lectionnez informations de taxe de vente gÃ©nÃ©rale.  En supposant par l\'adresse <i>d\'ExpÃ©dition</i> , vous devrez sÃ©lectionner la taxe dans le quartie',0),(447907,12442,'jp','AR ç¨Žé‡‘ã¯ã“ã“ã§æ§‹æˆã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è«‹æ±‚ç¨Žé‡‘ã‚’è²©å£²->-></b><p>ä¸€èˆ¬çš„ãªå£²ä¸Šç¨Žæƒ…å ±ã‚’é¸æŠžã—ã¾ã™ã€‚å ´åˆã¯ã€<i>å‡ºè·å…ˆ</i>ã‚¢ãƒ‰ãƒ¬ã‚¹ã«ã‚ˆã£ã¦èª²ç¨Žã©ã‚“ã¡ã‚ƒã‚“é¨’ãŽã‚»ã‚¯',0),(447908,12442,'pt','Impostos de AR podem ser configurados aqui:<p><b>Admin-> Setup-faturamento-> impostos sobre vendas</b><p>Selecione informaÃ§Ã£o imposto geral sobre vendas.  Se tributar pelo endereÃ§o de <i>Envio a</i> vocÃª precisarÃ¡ selecionar o imposto no distrito de ',0),(447909,12442,'ru','AR Ð½Ð°Ð»Ð¾Ð³Ð¸ Ð¼Ð¾Ð¶Ð½Ð¾ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð·Ð´ÐµÑÑŒ:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³-> Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶</b><p>Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿ÑƒÐ½ÐºÑ‚ Ð¾Ð±Ñ‰Ð¸Ð¹ Ð½Ð°Ð»Ð¾Ð³ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶.  Ð•ÑÐ»Ð¸ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð',0),(447910,12442,'es','Impuestos de CC se puede configurar aqui:<p><b>Admin -> Configurar Facturas -> Info de Impuestos Sobre Ventas. Si impone impuestos por la direcciÃ³n de >i>Enviar A</i> necesita seleccionar el impuesto en la secciÃ³n para los que entran de la calle del Dis',0),(447911,12442,'de','AR steuern kÃ¶nnen hier konfiguriert werden:<p><b>Admin-> Setup-Billing-> Umsatzsteuer</b><p>WÃ¤hlen Sie allgemeine Umsatzsteuer-Info.  Wenn Besteuerung durch die <i>EmpfÃ¤nger</i> -Adresse mÃ¼ssen Sie die Steuer im Umkreis Umsatzsteuer fÃ¼r Walk-Ins Absc',0),(447912,12442,'en','AR taxes can be configured here:<p><b>Admin -> Setup-Billing -> Sales Taxes</b><p> Select General Sales Tax Info.  If taxing by the <i>Ship To</i> address you will need to select the tax in the Sales Tax District for Walk-Ins section.',0),(447913,12443,'is','',0),(447914,12443,'dr','',0),(447915,12443,'pr','',0),(447916,12443,'tr','',0),(447917,12443,'pl','',0),(447918,12443,'bg','',0),(447919,12443,'ur','',0),(447920,12443,'sr','',0),(447921,12443,'vi','',0),(447922,12443,'af','',0),(447923,12443,'ro','',0),(447924,12443,'et','',0),(447925,12443,'si','',0),(447926,12443,'ba','',0),(447927,12443,'nl','',0),(447928,12443,'fi','',0),(447929,12443,'no','',0),(447930,12443,'da','',0),(447931,12443,'ko','',0),(447932,12443,'he','',0),(447933,12443,'el','',0),(447934,12443,'zh','',0),(447935,12443,'sv','',0),(447936,12443,'it','',0),(447937,12443,'tl','',0),(447938,12443,'th','',0),(447939,12443,'hi','',0),(447940,12443,'ms','',0),(447941,12443,'ar','',0),(447942,12443,'fr','',0),(447943,12443,'jp','',0),(447944,12443,'pt','',0),(447945,12443,'ru','',0),(447946,12443,'es','',0),(447947,12443,'de','',0),(447948,12443,'en','',0),(447949,12444,'is','',0),(447950,12444,'dr','',0),(447951,12444,'pr','',0),(447952,12444,'tr','',0),(447953,12444,'pl','',0),(447954,12444,'bg','',0),(447955,12444,'ur','',0),(447956,12444,'sr','',0),(447957,12444,'vi','',0),(447958,12444,'af','',0),(447959,12444,'ro','',0),(447960,12444,'et','',0),(447961,12444,'si','',0),(447962,12444,'ba','',0),(447963,12444,'nl','',0),(447964,12444,'fi','',0),(447965,12444,'no','',0),(447966,12444,'da','',0),(447967,12444,'ko','',0),(447968,12444,'he','',0),(447969,12444,'el','',0),(447970,12444,'zh','',0),(447971,12444,'sv','',0),(447972,12444,'it','',0),(447973,12444,'tl','',0),(447974,12444,'th','',0),(447975,12444,'hi','',0),(447976,12444,'ms','',0),(447977,12444,'ar','',0),(447978,12444,'fr','',0),(447979,12444,'jp','',0),(447980,12444,'pt','',0),(447981,12444,'ru','',0),(447982,12444,'es','',0),(447983,12444,'de','',0),(447984,12444,'en','',0),(447985,12445,'is','',0),(447986,12445,'dr','',0),(447987,12445,'pr','',0),(447988,12445,'tr','',0),(447989,12445,'pl','',0),(447990,12445,'bg','',0),(447991,12445,'ur','',0),(447992,12445,'sr','',0),(447993,12445,'vi','',0),(447994,12445,'af','',0),(447995,12445,'ro','',0),(447996,12445,'et','',0),(447997,12445,'si','',0),(447998,12445,'ba','',0),(447999,12445,'nl','',0),(448000,12445,'fi','',0),(448001,12445,'no','',0),(448002,12445,'da','',0),(448003,12445,'ko','',0),(448004,12445,'he','',0),(448005,12445,'el','',0),(448006,12445,'zh','',0),(448007,12445,'sv','',0),(448008,12445,'it','',0),(448009,12445,'tl','',0),(448010,12445,'th','',0),(448011,12445,'hi','',0),(448012,12445,'ms','',0),(448013,12445,'ar','',0),(448014,12445,'fr','',0),(448015,12445,'jp','',0),(448016,12445,'pt','',0),(448017,12445,'ru','',0),(448018,12445,'es','',0),(448019,12445,'de','',0),(448020,12445,'en','',0),(448021,12446,'is','',0),(448022,12446,'dr','',0),(448023,12446,'pr','',0),(448024,12446,'tr','',0),(448025,12446,'pl','',0),(448026,12446,'bg','',0),(448027,12446,'ur','',0),(448028,12446,'sr','',0),(448029,12446,'vi','',0),(448030,12446,'af','',0),(448031,12446,'ro','',0),(448032,12446,'et','',0),(448033,12446,'si','',0),(448034,12446,'ba','',0),(448035,12446,'nl','',0),(448036,12446,'fi','',0),(448037,12446,'no','',0),(448038,12446,'da','',0),(448039,12446,'ko','',0),(448040,12446,'he','',0),(448041,12446,'el','',0),(448042,12446,'zh','',0),(448043,12446,'sv','',0),(448044,12446,'it','',0),(448045,12446,'tl','',0),(448046,12446,'th','',0),(448047,12446,'hi','',0),(448048,12446,'ms','',0),(448049,12446,'ar','',0),(448050,12446,'fr','',0),(448051,12446,'jp','',0),(448052,12446,'pt','',0),(448053,12446,'ru','',0),(448054,12446,'es','',0),(448055,12446,'de','',0),(448056,12446,'en','',0),(448057,12447,'is','',0),(448058,12447,'dr','',0),(448059,12447,'pr','',0),(448060,12447,'tr','',0),(448061,12447,'pl','',0),(448062,12447,'bg','',0),(448063,12447,'ur','',0),(448064,12447,'sr','',0),(448065,12447,'vi','',0),(448066,12447,'af','',0),(448067,12447,'ro','',0),(448068,12447,'et','',0),(448069,12447,'si','',0),(448070,12447,'ba','',0),(448071,12447,'nl','',0),(448072,12447,'fi','',0),(448073,12447,'no','',0),(448074,12447,'da','',0),(448075,12447,'ko','',0),(448076,12447,'he','',0),(448077,12447,'el','',0),(448078,12447,'zh','',0),(448079,12447,'sv','',0),(448080,12447,'it','',0),(448081,12447,'tl','',0),(448082,12447,'th','',0),(448083,12447,'hi','',0),(448084,12447,'ms','',0),(448085,12447,'ar','',0),(448086,12447,'fr','',0),(448087,12447,'jp','',0),(448088,12447,'pt','',0),(448089,12447,'ru','',0),(448090,12447,'es','',0),(448091,12447,'de','',0),(448092,12447,'en','',0),(448093,12448,'is','',0),(448094,12448,'dr','',0),(448095,12448,'pr','',0),(448096,12448,'tr','',0),(448097,12448,'pl','',0),(448098,12448,'bg','',0),(448099,12448,'ur','',0),(448100,12448,'sr','',0),(448101,12448,'vi','',0),(448102,12448,'af','',0),(448103,12448,'ro','',0),(448104,12448,'et','',0),(448105,12448,'si','',0),(448106,12448,'ba','',0),(448107,12448,'nl','',0),(448108,12448,'fi','',0),(448109,12448,'no','',0),(448110,12448,'da','',0),(448111,12448,'ko','',0),(448112,12448,'he','',0),(448113,12448,'el','',0),(448114,12448,'zh','',0),(448115,12448,'sv','',0),(448116,12448,'it','',0),(448117,12448,'tl','',0),(448118,12448,'th','',0),(448119,12448,'hi','',0),(448120,12448,'ms','',0),(448121,12448,'ar','',0),(448122,12448,'fr','',0),(448123,12448,'jp','',0),(448124,12448,'pt','',0),(448125,12448,'ru','',0),(448126,12448,'es','',0),(448127,12448,'de','',0),(448128,12448,'en','',0),(448129,12449,'is','',0),(448130,12449,'dr','',0),(448131,12449,'pr','',0),(448132,12449,'tr','',0),(448133,12449,'pl','',0),(448134,12449,'bg','',0),(448135,12449,'ur','',0),(448136,12449,'sr','',0),(448137,12449,'vi','',0),(448138,12449,'af','',0),(448139,12449,'ro','',0),(448140,12449,'et','',0),(448141,12449,'si','',0),(448142,12449,'ba','',0),(448143,12449,'nl','',0),(448144,12449,'fi','',0),(448145,12449,'no','',0),(448146,12449,'da','',0),(448147,12449,'ko','',0),(448148,12449,'he','',0),(448149,12449,'el','',0),(448150,12449,'zh','',0),(448151,12449,'sv','',0),(448152,12449,'it','',0),(448153,12449,'tl','',0),(448154,12449,'th','',0),(448155,12449,'hi','',0),(448156,12449,'ms','',0),(448157,12449,'ar','',0),(448158,12449,'fr','',0),(448159,12449,'jp','',0),(448160,12449,'pt','',0),(448161,12449,'ru','',0),(448162,12449,'es','',0),(448163,12449,'de','',0),(448164,12449,'en','',0),(448165,12450,'is','',0),(448166,12450,'dr','',0),(448167,12450,'pr','',0),(448168,12450,'tr','',0),(448169,12450,'pl','',0),(448170,12450,'bg','',0),(448171,12450,'ur','',0),(448172,12450,'sr','',0),(448173,12450,'vi','',0),(448174,12450,'af','',0),(448175,12450,'ro','',0),(448176,12450,'et','',0),(448177,12450,'si','',0),(448178,12450,'ba','',0),(448179,12450,'nl','',0),(448180,12450,'fi','',0),(448181,12450,'no','',0),(448182,12450,'da','',0),(448183,12450,'ko','',0),(448184,12450,'he','',0),(448185,12450,'el','',0),(448186,12450,'zh','',0),(448187,12450,'sv','',0),(448188,12450,'it','',0),(448189,12450,'tl','',0),(448190,12450,'th','',0),(448191,12450,'hi','',0),(448192,12450,'ms','',0),(448193,12450,'ar','',0),(448194,12450,'fr','',0),(448195,12450,'jp','',0),(448196,12450,'pt','',0),(448197,12450,'ru','',0),(448198,12450,'es','',0),(448199,12450,'de','',0),(448200,12450,'en','',0),(448201,12451,'is','',0),(448202,12451,'dr','. Ø§ÛŒØ³ØªÚ¯Ø§Ù‡ ÙØ±ÙˆØ´ Ù‡ÛŒÚ†Ú¯Ø§Ù‡ ÛŒÚ© ÙØ±Ù…Ø§ÛŒØ´ Ø§ÛŒØ¬Ø§Ø¯ Ù†Ù…ÛŒ Ú©Ù†Ø¯ Ùˆ ØªÙ†Ù‡Ø§ Ø¨ÛŒØ¬Ú© Ø§ÛŒØ¬Ø§Ø¯ Ù†Ù…ÛŒ Ú©Ù†Ø¯ Ø¨Ù†Ø§Ø¨Ø±Ø§ÛŒÙ† Ù†Ù‚Ø·',0),(448203,12451,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…ØµØ±Ù Ú©Ø§Ù„Ø§ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ù„Ø§Ù‡Ø§ÛŒ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ Ø§Ø² Ø·Ø±ÛŒÙ‚ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø³Øª. Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ Ù‡ÛŒÚ†Ú¯Ø§Ù‡ ÛŒÚ© Ø³ÙØ§Ø±Ø´ Ø§ÛŒØ¬Ø§Ø¯ Ù†Ù…ÛŒ Ú©Ù†Ø¯ Ùˆ ØªÙ†Ù‡Ø§ ÙØ§Ú©ØªÙˆØ± Ø§ÛŒØ¬Ø§Ø¯ Ù†Ù…ÛŒ Ú©Ù†Ø¯ Ø¨Ù†Ø§Ø¨Ø±Ø§ÛŒÙ† Ù†Ù‚Ø·',0),(448204,12451,'tr','SipariÅŸ aracÄ±lÄ±ÄŸÄ±yla satÄ±lan maddeler iÃ§in madde kullanÄ±mÄ± raporudur.  POS (satÄ±ÅŸ noktasÄ±) asla yapar sadece bir fatura, sipariÅŸ, POS Ã¶ÄŸeleri bu rapora dahil edilmez.',0),(448205,12451,'pl','Raport uÅ¼ycie elementu jest dla przedmiotÃ³w sprzedanych za poÅ›rednictwem zamÃ³wienia.  POS (punkt sprzedaÅ¼y) nigdy nie czyni nakazu, tylko fakturÄ™, wiÄ™c POS ksiÄ…Å¼ki nie sÄ… zawarte w tym raporcie.',0),(448206,12451,'bg','Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ°Ñ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ñ‡Ñ€ÐµÐ· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸.  POS (Ð¼ÑÑÑ‚Ð¾ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°) Ð½Ð¸ÐºÐ¾Ð³Ð° Ð½Ðµ Ð¿Ñ€Ð°Ð²Ð¸ Ð·Ð°Ð¿Ð¾Ð²ÐµÐ´, Ð° ÑÐ°Ð¼Ð¾ ÐµÐ´Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ñ‚Ð°ÐºÐ° Ñ‡Ðµ POS Ð¿Ñ€Ð¾Ð´ÑƒÐº',0),(448207,12451,'ur','Ø´Û’ Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ Ø§Ø´ÛŒØ§ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ø°Ø±ÛŒØ¹Û’ ÙØ±ÙˆØ®Øª Ú©Û’ Ù„Ø¦Û’ ÛÛ’ Û”  Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø§Ø´ÛŒØ§ Ø§Ø³ Ø±Ù¾ÙˆØ±Ù¹ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ Ù†ÛÛŒÚº ÛÛŒÚº Ù„ÛØ°Ø§ Ù¾ÙˆØ²ÛŒØ´Ù† Ù…ØªØ­Ø¯Û (Ù…Ø®ØªÙ„',0),(448208,12451,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ñ˜Ðµ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ‚Ðµ Ð¿ÑƒÑ‚ÐµÐ¼ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ.  ÐŸÐžÐ¡ (ÐŸÐžÐ¡) Ð½Ð¸ÐºÐ°Ð´Ð° Ð½Ðµ Ð¿Ñ€Ð°Ð²Ð¸ Ð½Ð°Ñ€ÐµÐ´Ð±Ð°, ÑÐ°Ð¼Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ, Ñ‚Ð°ÐºÐ¾ Ð´Ð° ÐŸÐžÐ¡ ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð¸ÑÑƒ ÑƒÐºÑ™ÑƒÑ',0),(448209,12451,'vi','BÃ¡o cÃ¡o sá»­ dá»¥ng máº·t hÃ ng lÃ  cho nhá»¯ng máº·t hÃ ng Ä‘Ã£ Ä‘Æ°á»£c bÃ¡n thÃ´ng qua cÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng. POS khÃ´ng bao giá» lÃ m má»™t Ä‘Æ¡n Ä‘áº·t hÃ ng vÃ  chá»‰ lÃ  má»™t hÃ³a Ä‘Æ¡n. VÃ¬ tháº¿ cÃ¡c máº·t hÃ ng cá»§a POS khÃ´ng náº±m trong',0),(448210,12451,'af','Die Item gebruik verslag is vir items verkoop deur bestellings.  POS (Point-of-Sale) maak nooit \'n bevel, net \'n faktuur, so POS items is nie by hierdie verslag ingesluit is.',0),(448211,12451,'ro','Raport de element utilizare este pentru articole vÃ¢ndute prin comenzi.  POS (punctul) face niciodatÄƒ un ordin, doar o facturÄƒ, astfel Ã®ncÃ¢t POS elemente nu sunt incluse Ã®n acest raport.',0),(448212,12451,'et','Kauba kasutusaruanne on mÃ¼Ã¼dud kaudu tellimusi.  POS (mÃ¼Ã¼gikoha) kunagi teeb tellimuse, vaid arve, et POS kaubad ei kuulu kÃ¤esoleva aruande.',0),(448213,12451,'si','Element navada referat je za artikle, ki se prodajajo preko naroÄila.  POS (ocenjene) nikoli ne naredi nalog, samo faktura, tako POS elementi niso vkljuÄeni v to poroÄilo.',0),(448214,12451,'ba','Laporan penggunaan Item ini untuk barang-barang yang dijual melalui perintah.  POS (Point-of-Sale) tidak pernah membuat pesanan, hanya faktur, jadi item POS tidak disertakan dalam laporan ini.',0),(448215,12451,'nl','Het Item gebruiksrapport is voor objecten die via Orders verkocht.  POS (verkooppunt) maakt nooit een bestelling, gewoon een factuur, zodat POS items niet in dit verslag opgenomen worden.',0),(448216,12451,'fi','Nimikkeen kÃ¤yttÃ¶raportti on tuotteet myydÃ¤Ã¤n tilaukset.  POS (myyntipisteen) tekee tilauksen vain laskun koskaan, joten POS tuotteet eivÃ¤t sisÃ¤lly tÃ¤hÃ¤n raporttiin.',0),(448217,12451,'no','Elementet bruksrapport er for varer selges gjennom bestillinger.  POS (Point-of-Sale) gjÃ¸r aldri en ordre, bare en faktura slik POS elementer ikke er inkludert i denne rapporten.',0),(448218,12451,'da','Rapporten vareforbrug er for varer solgt via ordrer.  POS (Point-of-Sale) gÃ¸r aldrig en ordre, en faktura, sÃ¥ POS elementer ikke er medtaget i denne betÃ¦nkning.',0),(448219,12451,'ko','í•­ëª© ì‚¬ìš© ë³´ê³ ì„œ ì£¼ë¬¸ì„ í†µí•´ íŒë§¤ í•˜ëŠ” ìƒí’ˆìž…ë‹ˆë‹¤.  POS (íŒë§¤ ì´‰ì§„ í˜•) ê²°ì½” ë§Œë“¤ì§€ ì•ŠëŠ”ë‹¤ ìˆœì„œ, ê·¸ëƒ¥ ì²­êµ¬ì„œ, ê·¸ëž˜ì„œ POS í•­ëª©ì´ì´ ë³´ê³ ì„œì— í¬í•¨ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(448220,12451,'he','×”×“×•×— ×¤×¨×™×˜ ×”×©×™×ž×•×© ×”×•× ×¢×‘×•×¨ ×¤×¨×™×˜×™× × ×ž×›×¨×™× ×‘××ž×¦×¢×•×ª ×”×–×ž× ×•×ª.  POS (×”×ž×›×™×¨×”) ××£ ×¤×¢× ×œ× ×¢×•×©×” ×¡×“×¨, ×¨×§ ×—×©×‘×•× ×™×ª, ×›×š POS ×¤×¨×™×˜×™× ××™× × ×›×œ×•×œ×™× ×‘×“×•×— ×–×”.',0),(448221,12451,'el','Î— Î­ÎºÎ¸ÎµÏƒÎ· Ï€ÏÎ¿Î²Î»Î­Ï€ÎµÎ¹ Ï‡ÏÎ®ÏƒÎ· ÎµÎ¯Î½Î±Î¹ Î³Î¹Î± Ï„Î± ÎµÎ¯Î´Î· Ï€Î¿Ï… Ï€Î¿Ï…Î»Î®Î¸Î·ÎºÎ±Î½ Î¼Î­ÏƒÏ‰ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½.  POS (ÏƒÎ·Î¼ÎµÎ¯Î¿ Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚) Ï€Î¿Ï„Î­ Î´ÎµÎ½ ÎºÎ¬Î½ÎµÎ¹ Î¼Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±, Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±ÎºÏ',0),(448222,12451,'zh','é¡¹ç›®ä½¿ç”¨æŠ¥è¡¨æ˜¯ä¸ºäº†é€šè¿‡è®¢å•é”€å”®çš„é¡¹ç›®ã€‚é”€å”®ç‚¹ä»Žä¸ä¸‹è®¢å•ï¼Œåªæ˜¯å¼€å…·å‘ç¥¨ï¼Œæ‰€ä»¥é”€å”®ç‚¹é¡¹ç›®ä¸åŒ…æ‹¬åœ¨æ­¤æŠ¥è¡¨ä¸­ã€‚',0),(448223,12451,'sv','ArtikelfÃ¶rbrukning betÃ¤nkandet Ã¤r fÃ¶r artiklar som sÃ¤ljs via order.  POS (Point of Sale) gÃ¶r aldrig en order, bara en faktura, sÃ¥ POS objekt inte ingÃ¥r i denna rapport.',0),(448224,12451,'it','Il report di utilizzo di Item Ã¨ per gli articoli venduti attraverso gli ordini.  POS (Point of sale) non fa mai un ordine, basta una fattura, quindi POS non sono compresi in questa relazione.',0),(448225,12451,'tl','',0),(448226,12451,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸‚à¸²à¸¢à¸œà¹ˆà¸²à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹„à¸”à¹‰  POS (à¸«à¸™à¹‰à¸²à¸£à¹‰à¸²à¸™) à¸—à¸³à¹ƒà¸«à¹‰à¸ªà¸±à¹ˆà¸‡ à¹€à¸žà¸µà¸¢à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ à',0),(448227,12451,'hi','à¤†à¤‡à¤Ÿà¤® à¤‰à¤ªà¤¯à¥‹à¤— à¤°à¤¿à¤°à¥à¤ªà¥‹à¤Ÿ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤¬à¥‡à¤šà¤¾ à¤®à¤¦à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¥ˆà¥¤  POS (à¤¬à¤¿à¤¨à¥à¤¦à¥-à¤¬à¤¿à¤•à¥à¤°à¥€) à¤•à¤­à¥€ à¤¨à¤¹à¥€à¤‚ à¤à¤• à¤†à¤¦à¥‡à¤¶, à¤¬à¤¸ à¤',0),(448228,12451,'ms','Laporan penggunaan Item adalah untuk barang-barang yang dijual melalui pesanan.  POS (Point-of-Sale) tidak pernah membuat suatu perintah, hanya invois, jadi barang-barang POS tidak termasuk dalam laporan ini.',0),(448229,12451,'ar','ØªÙ‚Ø±ÙŠØ± \"Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¨Ù†Ø¯\" Ù„Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø¨Ø§Ø¹Ø© Ù…Ù† Ø®Ù„Ø§Ù„ Ø£ÙˆØ§Ù…Ø±.  Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ (Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹) ÙŠØ¬Ø¹Ù„ Ø§Ø¨Ø¯Ø£ Ø£Ù…Ø±Ø§ØŒ Ù…Ø¬Ø±Ø¯ ÙØ§ØªÙˆØ±Ø©ØŒ Ø­ÙŠØ« Ø§Ù„Ø¹Ù†Ø§ØµØ± Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ ØºÙŠØ± Ù…Ø¯Ø±Ø¬Ø© ÙÙŠ',0),(448230,12451,'fr','Le rapport sur l\'utilisation de l\'Ã©lÃ©ment est pour les articles vendus par le biais de commandes.  POS (point de vente) a jamais donne un ordre, juste une facture, Ã©lÃ©ments du POS ne sont pas inclus dans le prÃ©sent rapport.',0),(448231,12451,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®ä½¿ç”¨çŠ¶æ³ãƒ¬ãƒãƒ¼ãƒˆã¯æ³¨æ–‡ã‚’ä»‹ã—ã¦è²©å£²ã•ã‚Œã‚‹é …ç›®ã§ã™ã€‚æœ¬å ±å‘Šã§ã¯ POS ã‚¢ã‚¤ãƒ†ãƒ ã¯å«ã¾ã‚Œã¾ã›ã‚“ (POS) æ±ºã—ã¦æ³¨æ–‡ã€è«‹æ±‚æ›¸ã ã‘ã«ãªã‚Šã¾ã™ã€‚',0),(448232,12451,'pt','O relatÃ³rio de uso do Item Ã© para itens vendidos atravÃ©s de encomendas.  POS (ponto de venda) nunca faz uma ordem, apenas uma fatura, entÃ£o POS itens nÃ£o estÃ£o incluÃ­dos neste relatÃ³rio.',0),(448233,12451,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾Ð± Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ð¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ñ€ÐµÐ´Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½ Ð´Ð»Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð², Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°ÐµÐ¼Ñ‹Ñ… Ñ‡ÐµÑ€ÐµÐ· Ð·Ð°ÐºÐ°Ð·Ñ‹.  POS (ÐºÐ°ÑÑÐ¾Ð²Ñ‹Ðµ) Ð½Ð¸ÐºÐ¾Ð³Ð´Ð° Ð½Ðµ Ð´ÐµÐ»Ð°ÐµÑ‚ Ð·Ð°ÐºÐ°Ð·, Ð¿Ñ€Ð¾ÑÑ‚Ð¾ ÑÑ‡ÐµÑ‚, Ð¿Ð¾ÑÑ‚Ð',0),(448234,12451,'es','Este informe de uso de item es para items vendidos por Ordenes. PDV (Punto de Venta) nunca hace un orden, solo una factura, entonces items de PDV no estan incluidos en el informe.',0),(448235,12451,'de','Der Artikel Usage-Bericht ist fÃ¼r Elemente, die durch Bestellungen verkauft.  POS (Point of Sale) macht nie einen Auftrag, nur eine Rechnung, so dass POS Artikel in diesem Bericht nicht berÃ¼cksichtigt werden.',0),(448236,12451,'en','The Item Usage report is for items sold through Orders.  POS (Point-of-Sale) never makes an order, just an invoice, so POS items are not included in this report.',0),(448237,12452,'is','',0),(448238,12452,'dr','',0),(448239,12452,'pr','',0),(448240,12452,'tr','',0),(448241,12452,'pl','',0),(448242,12452,'bg','',0),(448243,12452,'ur','',0),(448244,12452,'sr','',0),(448245,12452,'vi','',0),(448246,12452,'af','',0),(448247,12452,'ro','',0),(448248,12452,'et','',0),(448249,12452,'si','',0),(448250,12452,'ba','',0),(448251,12452,'nl','',0),(448252,12452,'fi','',0),(448253,12452,'no','',0),(448254,12452,'da','',0),(448255,12452,'ko','',0),(448256,12452,'he','',0),(448257,12452,'el','',0),(448258,12452,'zh','',0),(448259,12452,'sv','',0),(448260,12452,'it','',0),(448261,12452,'tl','',0),(448262,12452,'th','',0),(448263,12452,'hi','',0),(448264,12452,'ms','',0),(448265,12452,'ar','',0),(448266,12452,'fr','',0),(448267,12452,'jp','',0),(448268,12452,'pt','',0),(448269,12452,'ru','',0),(448270,12452,'es','',0),(448271,12452,'de','',0),(448272,12452,'en','',0),(448273,12453,'is','',0),(448274,12453,'dr',':Ù…Ø¯ÛŒØ±ÛŒØª-Ù…Ø§Ù„ÛŒØ§Øª Ù‡Ø§ÛŒ ÙØ±ÙˆØ´-',0),(448275,12453,'pr','Ù…Ø§Ù„ÛŒØ§Øª ÙØ±ÙˆØ´ Ù‡Ø§ Ø§Ø±Ø³Ø§Ù„ Ù…ÛŒ Ø´ÙˆØ¯ Ø¨Ù‡ Ù‡Ø± Ø¬Ø§ÛŒÛŒ Ú©Ù‡ Ø´Ù…Ø§ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯ Ø¯Ø± Ù…Ø³ÛŒØ±:Ù…Ø¯ÛŒØ±ÛŒØª-Ù…Ø§Ù„ÛŒØ§Øª Ù‡Ø§ÛŒ ÙØ±ÙˆØ´-',0),(448276,12453,'tr','SatÄ±ÅŸ vergisi ne olursa olsun iÃ§inde ayarladÄ±ÄŸÄ±nÄ±z deftere nakleder:<p><b>YÃ¶netici Kurulumu-fatura satÄ±ÅŸ vergileri->-></b>',0),(448277,12453,'pl','Podatek od sprzedaÅ¼y posty co mam ustawiÄ‡:<p><b>Admin-> instalacji Billing-> podatek</b>',0),(448278,12453,'bg','Ð”Ð°Ð½ÑŠÐº Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð¼Ð½ÐµÐ½Ð¸Ñ Ð·Ð° ÐºÐ°ÐºÐ²Ð¾Ñ‚Ð¾ ÑÑ‚Ðµ Ð·Ð°Ð´Ð°Ð»Ð¸:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ</b>',0),(448279,12453,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©Ùˆ Ø¬Ùˆ Ú©Ú†Ú¾ Ø¨Ú¾ÛŒ ØªÙ… Ù…ÛŒÚº Ù‚Ø§Ø¦Ù… ÛÛ’ Ø§Ø´Ø§Ø¹ØªÛŒÚº:<p><b>Ø§ÛŒÚˆÙ…Ù† Ø³ÛŒÙ¹ Ø§Ù¾-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³->-></b>',0),(448280,12453,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ ÐºÑšÐ¸Ð¶Ð¸ Ð½Ð° ÑˆÑ‚Ð° Ð³Ð¾Ð´ ÑÑ‚Ðµ Ð¿Ð¾Ð´ÐµÑÐ¸Ð»Ð¸:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ-Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð¿Ð¾Ñ€ÐµÐ·</b>',0),(448281,12453,'vi','CÃ¡c thÃ´ng tin báº¥t ká»³ vá» thuáº¿ bÃ¡n hÃ ng báº¡n Ä‘Ã£ thiáº¿t láº­p trong : Quáº£n lÃ½-> thiáº¿t láº­p thanh toÃ¡n-> thuáº¿ bÃ¡n hÃ ng',0),(448282,12453,'af','Verkope belasting wat jy het om op te stel poste:<p><b>Admin-> opstel-fakturering-> verkope belastings</b>',0),(448283,12453,'ro','Impozit pe vÃ¢nzÄƒri de posturi pentru tot ce aÅ£i parametrizat:<p><b>Admin-> Setup-facturare-> taxa la vÃ¢nzÄƒri</b>',0),(448284,12453,'et','KÃ¤ibemaksu konteerib iganes olete seadistanud:<p><b>Admin-> seadistuse-arved kÃ¤ibemaksu-></b>',0),(448285,12453,'si','Prometni davek objav karkoli ste jih nastavili:<p><b>Admin-> Setup-zaraÄunavanje-> prodaji davkov</b>',0),(448286,12453,'ba','Pajak penjualan posting untuk apa pun yang Anda telah mengatur:<p><b>Admin-> Setup-penagihan-> pajak penjualan</b>',0),(448287,12453,'nl','Sales tax posten aan wat u hebt ingesteld:<p><b>Admin-> Setup-Billing-> belastingen op de verkoop</b>',0),(448288,12453,'fi','ArvonlisÃ¤veron virkaa mitÃ¤ olet mÃ¤Ã¤rittÃ¤nyt:<p><b>Admin-> mÃ¤Ã¤ritettÃ¤vÃ¤ laskutus-> arvonlisÃ¤verot</b>',0),(448289,12453,'no','Mva innlegg til hva du har angitt i:<p><b>Admin-> Setup-fakturering-> merverdiavgift</b>',0),(448290,12453,'da','Sales tax stillinger at uanset hvad du har sat:<p><b>Admin-> Setup-fakturering-> moms</b>',0),(448291,12453,'ko','íŒë§¤ ì„¸ê¸ˆ ì–´ë–¤ ì„¤ì • ê²Œì‹œë¬¼:<p><b>ì„¤ì¹˜-ê²°ì œ íŒë§¤ ì„¸ê¸ˆ->-> ê´€ë¦¬ìž</b>',0),(448292,12453,'he','×ž×¢ ×ž ×”×¦×‘×•×ª ×›×“×™ ×ž×” ×©×”×’×“×¨×ª:<p><b>Admin-> ×”×”×ª×§× ×”-×—×™×•×‘-> ×ž×¢ ×ž</b>',0),(448293,12453,'el','Î¦ÏŒÏÎ¿Ï‚ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î¸Î­ÏƒÎµÎ¹Ï‚ ÏƒÎµ ÏŒ, Ï„Î¹ Î­Ï‡ÎµÏ„Îµ Î¿ÏÎ¯ÏƒÎµÎ¹:<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚-> Ï†ÏŒÏÎ¿Î¹ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½</b>',0),(448294,12453,'zh','é”€å”®ç¨Žå‘å¸ƒåˆ°æ‚¨è®¾ç½®çš„æ‰€æœ‰é¡¹ç›®ï¼šç®¡ç†->è®¾ç½®å…¥è´¦->é”€å”®ç¨Ž',0),(448295,12453,'sv','Moms inlÃ¤gg till vad du har stÃ¤llt in:<p><b>Admin-> Setup-fakturering-> moms</b>',0),(448296,12453,'it','IVA articoli per qualunque cosa sono definite in:<p><b>Admin-> Setup-fatturazione-> le imposte sulle vendite</b>',0),(448297,12453,'tl','',0),(448298,12453,'th','à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢à¸—à¸µà¹ˆà¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸žà¸·à¹ˆà¸­à¸ªà¸´à¹ˆà¸‡à¸—à¸µà¹ˆà¸„à¸¸à¸“à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™:<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™->à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢</b>',0),(448299,12453,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤œà¥‹ à¤•à¥à¤› à¤­à¥€ à¤¤à¥à¤® à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤¹à¥ˆ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿ:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª-à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥‹à¤‚->-></b>',0),(448300,12453,'ms','Cukai jualan jawatan untuk apa sahaja anda telah menyediakan:<p><b>Admin-> persediaan-bil-> cukai jualan</b>',0),(448301,12453,'ar','ÙˆØ¸ÙŠÙØ© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„ÙƒÙ„ Ù…Ø§ ØªÙ… Ø¥Ø¹Ø¯Ø§Ø¯Ù‡:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª</b>',0),(448302,12453,'fr','Messages de taxe de vente Ã  tout ce que vous avez configurÃ© :<p><b>Admin-> Setup-facturation-> des Taxes de vente</b>',0),(448303,12453,'jp','å£²ä¸Šç¨Žã®ã§è¨­å®šã—ãŸã‚‚ã®ã‚’æŠ•ç¨¿ï¼š<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è«‹æ±‚ç¨Žé‡‘ã‚’è²©å£²->-></b>',0),(448304,12453,'pt','Imposto sobre vendas remete para tudo o que vocÃª configurou:<p><b>Admin-> Setup-faturamento-> impostos sobre vendas</b>',0),(448305,12453,'ru','ÐÐ°Ð»Ð¾Ð³ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð¾Ð»Ð¶Ð½Ð¾ÑÑ‚ÐµÐ¹ Ð²ÑÐµ, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ ÑÐ¾Ð·Ð´Ð°Ð»Ð¸:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³-> Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶</b>',0),(448306,12453,'es','Impuesto sobre ventas se asenta a donde esta configurado en:<p><b>Admin -> Configurar FacturaciÃ³n - Impuestos Sobre Ventas</b>',0),(448307,12453,'de','Umsatzsteuer stellen, was auch immer Sie in eingerichtet haben:<p><b>Admin-> Setup-Billing-> Umsatzsteuer</b>',0),(448308,12453,'en','Sales tax posts to whatever you have set up in:<p><b>Admin -> Setup-Billing -> Sales Taxes</b>',0),(448309,12454,'is','',0),(448310,12454,'dr','',0),(448311,12454,'pr','',0),(448312,12454,'tr','',0),(448313,12454,'pl','',0),(448314,12454,'bg','',0),(448315,12454,'ur','',0),(448316,12454,'sr','',0),(448317,12454,'vi','',0),(448318,12454,'af','',0),(448319,12454,'ro','',0),(448320,12454,'et','',0),(448321,12454,'si','',0),(448322,12454,'ba','',0),(448323,12454,'nl','',0),(448324,12454,'fi','',0),(448325,12454,'no','',0),(448326,12454,'da','',0),(448327,12454,'ko','',0),(448328,12454,'he','',0),(448329,12454,'el','',0),(448330,12454,'zh','',0),(448331,12454,'sv','',0),(448332,12454,'it','',0),(448333,12454,'tl','',0),(448334,12454,'th','',0),(448335,12454,'hi','',0),(448336,12454,'ms','',0),(448337,12454,'ar','',0),(448338,12454,'fr','',0),(448339,12454,'jp','',0),(448340,12454,'pt','',0),(448341,12454,'ru','',0),(448342,12454,'es','',0),(448343,12454,'de','',0),(448344,12454,'en','',0),(448345,12455,'is','',0),(448346,12455,'dr','',0),(448347,12455,'pr','',0),(448348,12455,'tr','',0),(448349,12455,'pl','',0),(448350,12455,'bg','',0),(448351,12455,'ur','',0),(448352,12455,'sr','',0),(448353,12455,'vi','',0),(448354,12455,'af','',0),(448355,12455,'ro','',0),(448356,12455,'et','',0),(448357,12455,'si','',0),(448358,12455,'ba','',0),(448359,12455,'nl','',0),(448360,12455,'fi','',0),(448361,12455,'no','',0),(448362,12455,'da','',0),(448363,12455,'ko','',0),(448364,12455,'he','',0),(448365,12455,'el','',0),(448366,12455,'zh','',0),(448367,12455,'sv','',0),(448368,12455,'it','',0),(448369,12455,'tl','',0),(448370,12455,'th','',0),(448371,12455,'hi','',0),(448372,12455,'ms','',0),(448373,12455,'ar','',0),(448374,12455,'fr','',0),(448375,12455,'jp','',0),(448376,12455,'pt','',0),(448377,12455,'ru','',0),(448378,12455,'es','',0),(448379,12455,'de','',0),(448380,12455,'en','',0),(448381,12456,'is','',0),(448382,12456,'dr','',0),(448383,12456,'pr','',0),(448384,12456,'tr','',0),(448385,12456,'pl','',0),(448386,12456,'bg','',0),(448387,12456,'ur','',0),(448388,12456,'sr','',0),(448389,12456,'vi','',0),(448390,12456,'af','',0),(448391,12456,'ro','',0),(448392,12456,'et','',0),(448393,12456,'si','',0),(448394,12456,'ba','',0),(448395,12456,'nl','',0),(448396,12456,'fi','',0),(448397,12456,'no','',0),(448398,12456,'da','',0),(448399,12456,'ko','',0),(448400,12456,'he','',0),(448401,12456,'el','',0),(448402,12456,'zh','',0),(448403,12456,'sv','',0),(448404,12456,'it','',0),(448405,12456,'tl','',0),(448406,12456,'th','',0),(448407,12456,'hi','',0),(448408,12456,'ms','',0),(448409,12456,'ar','',0),(448410,12456,'fr','',0),(448411,12456,'jp','',0),(448412,12456,'pt','',0),(448413,12456,'ru','',0),(448414,12456,'es','',0),(448415,12456,'de','',0),(448416,12456,'en','',0),(448417,12457,'is','',0),(448418,12457,'dr','',0),(448419,12457,'pr','',0),(448420,12457,'tr','',0),(448421,12457,'pl','',0),(448422,12457,'bg','',0),(448423,12457,'ur','',0),(448424,12457,'sr','',0),(448425,12457,'vi','',0),(448426,12457,'af','',0),(448427,12457,'ro','',0),(448428,12457,'et','',0),(448429,12457,'si','',0),(448430,12457,'ba','',0),(448431,12457,'nl','',0),(448432,12457,'fi','',0),(448433,12457,'no','',0),(448434,12457,'da','',0),(448435,12457,'ko','',0),(448436,12457,'he','',0),(448437,12457,'el','',0),(448438,12457,'zh','',0),(448439,12457,'sv','',0),(448440,12457,'it','',0),(448441,12457,'tl','',0),(448442,12457,'th','',0),(448443,12457,'hi','',0),(448444,12457,'ms','',0),(448445,12457,'ar','',0),(448446,12457,'fr','',0),(448447,12457,'jp','',0),(448448,12457,'pt','',0),(448449,12457,'ru','',0),(448450,12457,'es','',0),(448451,12457,'de','',0),(448452,12457,'en','',0),(448453,12458,'is','',0),(448454,12458,'dr','',0),(448455,12458,'pr','',0),(448456,12458,'tr','',0),(448457,12458,'pl','',0),(448458,12458,'bg','',0),(448459,12458,'ur','',0),(448460,12458,'sr','',0),(448461,12458,'vi','',0),(448462,12458,'af','',0),(448463,12458,'ro','',0),(448464,12458,'et','',0),(448465,12458,'si','',0),(448466,12458,'ba','',0),(448467,12458,'nl','',0),(448468,12458,'fi','',0),(448469,12458,'no','',0),(448470,12458,'da','',0),(448471,12458,'ko','',0),(448472,12458,'he','',0),(448473,12458,'el','',0),(448474,12458,'zh','',0),(448475,12458,'sv','',0),(448476,12458,'it','',0),(448477,12458,'tl','',0),(448478,12458,'th','',0),(448479,12458,'hi','',0),(448480,12458,'ms','',0),(448481,12458,'ar','',0),(448482,12458,'fr','',0),(448483,12458,'jp','',0),(448484,12458,'pt','',0),(448485,12458,'ru','',0),(448486,12458,'es','',0),(448487,12458,'de','',0),(448488,12458,'en','',0),(448489,12459,'is','',0),(448490,12459,'dr','',0),(448491,12459,'pr','',0),(448492,12459,'tr','',0),(448493,12459,'pl','',0),(448494,12459,'bg','',0),(448495,12459,'ur','',0),(448496,12459,'sr','',0),(448497,12459,'vi','',0),(448498,12459,'af','',0),(448499,12459,'ro','',0),(448500,12459,'et','',0),(448501,12459,'si','',0),(448502,12459,'ba','',0),(448503,12459,'nl','',0),(448504,12459,'fi','',0),(448505,12459,'no','',0),(448506,12459,'da','',0),(448507,12459,'ko','',0),(448508,12459,'he','',0),(448509,12459,'el','',0),(448510,12459,'zh','',0),(448511,12459,'sv','',0),(448512,12459,'it','',0),(448513,12459,'tl','',0),(448514,12459,'th','',0),(448515,12459,'hi','',0),(448516,12459,'ms','',0),(448517,12459,'ar','',0),(448518,12459,'fr','',0),(448519,12459,'jp','',0),(448520,12459,'pt','',0),(448521,12459,'ru','',0),(448522,12459,'es','',0),(448523,12459,'de','',0),(448524,12459,'en','',0),(448525,12460,'is','',0),(448526,12460,'dr',':ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-Ø¨ÛŒØ¬Ú©Ù‡Ø§-Ù„ØºÙˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§.Ø¬Ù‡Øª Ù„ØºÙˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ÙˆØ³ÛŒØ³ØªÙ… Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø±Ø¨Ø§ ÛŒÚ©ÛŒ Ø§Ø²Ø¯Ø±ÙˆØ§Ø²',0),(448527,12460,'pr','Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø§Ø¹ØªØ¨Ø§Ø± Ø¨Ù‡ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ:ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-ÙØ§Ú©ØªÙˆØ±Ù‡Ø§-Ù„ØºÙˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§.Ø¬Ù‡Øª Ù„ØºÙˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ÙˆØ³ÛŒØ³ØªÙ… Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø±Ø¨Ø§ ÛŒÚ©ÛŒ Ø§Ø²Ø¯Ø±ÙˆØ§Ø²Ù',0),(448528,12460,'tr','Ä°ÅŸlem kredi-kredi kartÄ±:<p><b>Fatura fatura Ã¶demeleri Void->-></b><p>Bir kredi kartÄ± ile Ã¶deme ve sistem geÃ§ersiz kÄ±lmak iÃ§in tÄ±klayÄ±n otomatik olarak Authorize.net (veya baÅŸka bir Ã¶deme aÄŸ geÃ§idi NolaPro ayarlanmÄ±ÅŸ) baÅŸvurun ve geÃ§ersi',0),(448529,12460,'pl','Proces kart kredytowych do kredytu:<p><b>PÅ‚atnoÅ›ci-> faktury-> niewaÅ¼ne pÅ‚atnoÅ›ci</b><p>Kliknij, aby uniewaÅ¼niÄ‡ pÅ‚atnoÅ›ci kartÄ… kredytowÄ… i system bÄ™dzie automatycznie kontakt Authorize.net (lub innej bramy pÅ‚atnoÅ›ci w NolaPro) i sprÃ³bowaÄ‡',0),(448530,12460,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°:<p><b>Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸-> Ð½ÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ</b><p>Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¸ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(448531,12460,'ur','Ø¹Ù…Ù„ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ùˆ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ:<p><b>Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ø§Ø·Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ->-></b><p>Ø§ÛŒÚ© Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§ÙˆØ± Ù†Ø¸Ø§Ù… ØµÙØ± Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº Ú¯Ø§ Ø®ÙˆØ¯ Ú©Ø§Ø± Ø·Ø±ÛŒÙ‚Û’ Ø³Û',0),(448532,12460,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ Ð·Ð°ÑÐ»ÑƒÐ³Ðµ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ:<p><b>Ð—Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð° Ð¸ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ</b><p>ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð»Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ',0),(448533,12460,'vi','QuÃ¡ trÃ¬nh tháº» tÃ­n dá»¥ng Ä‘áº¿n tháº» tÃ­n dá»¥ng: thanh toÃ¡n-> hÃ³a Ä‘Æ¡n-> vÃ´ hiá»‡u hÃ³a cÃ¡c khoáº£n thanh toÃ¡n. Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ lÃ m máº¥t hiá»‡u lá»±c thanh toÃ¡n tháº» tÃ­n dá»¥ng vÃ  há»‡ thá»‘ng sáº½ tá»± Ä‘á»™ng liÃªn há»‡ vá»›i ',0),(448534,12460,'af','Proses krediet aan kredietkaart:<p><b>Fakturering-> fakture-> leemte betalings</b><p>Klik om die void \'n kredietkaart betaling en die stelsel sal outomaties kontak Authorize.net (of \'n ander betaling deurgang in NolaPro opstel) en probeer om \'n leemte of ',0),(448535,12460,'ro','Card de Credit la Credit procesul:<p><b>Facturare-> facturi-> nul plÄƒÅ£i</b><p>FaceÅ£i clic pentru a anula o plata prin card de credit ÅŸi sistemul automat va contacta Authorize.net (sau un alt gateway de platÄƒ Ã®n NolaPro) ÅŸi sÄƒ Ã®ncerce sÄƒ anula sa',0),(448536,12460,'et','Krediit krediit kaart:<p><b>-> Arvete-> tÃ¼hine maksete arved</b><p>Kliki tÃ¼histada krediitkaardi makse ja sÃ¼steem automaatselt Ã¼hendust Authorize.net (vÃµi teine makse gateway NolaPro seadistamine) ja proovida muuta kehtetuks vÃµi krediidi eest.',0),(448537,12460,'si','Proces kreditne za kreditno kartico:<p><b>ZaraÄunavanje-> raÄuni-> niÄna plaÄila</b><p>Kliknite, Äe Å¾elite razveljaviti plaÄilno kreditno kartico in sistem bo samodejno stik Authorize.net (ali drugo plaÄilo za prehod v NolaPro) in poskusite niÄna',0),(448538,12460,'ba','Kartu kredit untuk kredit proses:<p><b>Penagihan-> faktur-> Batal pembayaran</b><p>Klik untuk membatalkan pembayaran dengan kartu kredit dan sistem secara otomatis akan menghubungi Authorize.net (atau gateway pembayaran lain yang didirikan di NolaPro) dan',0),(448539,12460,'nl','Proces krediet aan Credit Card:<p><b>Facturering-> facturen-> vervallen betalingen</b><p>Klik om te vernietigen een credit card betaling en het systeem zal automatisch contact Authorize.net (of een andere betalingsgateway ingesteld in NolaPro) en probeer ',0),(448540,12460,'fi','Luotto luotto kortti:<p><b>Laskutus-> laskujen-> mitÃ¤tÃ¶n maksut</b><p>Napsauta mitÃ¤tÃ¶idÃ¤ luottokortilla maksaminen ja jÃ¤rjestelmÃ¤ automaattisesti ota Authorize.net (tai toinen maksu yhdyskÃ¤ytÃ¤vÃ¤ NolaPro perustaa) ja yrittÃ¤Ã¤ mitÃ¤tÃ¶idÃ¤ tai lu',0),(448541,12460,'no','Prosessen kreditt pÃ¥ kredittkortet:<p><b>Fakturering-> fakturaer-> annullert betaling</b><p>Klikk for Ã¥ annullere kredittkortbetaling og systemet vil automatisk kontakte Authorize.net (eller en betaling gateway i NolaPro) og prÃ¸v Ã¥ annullere eller kre',0),(448542,12460,'da','Processen kredit til kreditkort:<p><b>Fakturering-> fakturaer-> Void betalinger</b><p>Klik for at annullere en betaling med kreditkort, og systemet vil automatisk kontakte Authorize.net (eller en anden betalingsgateway oprettet i NolaPro) og forsÃ¸ge at a',0),(448543,12460,'ko','í”„ë¡œì„¸ìŠ¤ ì‹ ìš© ì‹ ìš© ì¹´ë“œ:<p><b>ì†¡ìž¥ Void ì§€ë¶ˆ->-> ê²°ì œ</b><p>Authorize.net (ë˜ëŠ” ë‹¤ë¥¸ ì§€ë¶ˆ ê²Œì´íŠ¸ì›¨ì´ NolaPro ì„¤ì •)ì„ ì‹ ìš© ì¹´ë“œ ê²°ì œ ë° ì‹œìŠ¤í…œì´ ë¬´íš¨ í´ë¦­ ìžë™ìœ¼ë¡œ ì—°ë½ì„ ë¬´íš¨ ë˜ëŠ” ì‹ ìš© ì§€ë¶ˆ í•˜ë ',0),(448544,12460,'he','×›×¨×˜×™×¡ ××©×¨××™ ×›×“×™ ××©×¨××™ ×ª×”×œ×™×š:<p><b>×—×™×•×‘-> ×—×©×‘×•× ×™×•×ª-> ×ª×©×œ×•×ž×™× Void</b><p>×œ×—×¥ ×¢×œ ×›×“×™ ×œ×‘×˜×œ ×ª×©×œ×•× ×›×¨×˜×™×¡ ×”××©×¨××™ ×œ×‘×™×Ÿ ×”×ž×¢×¨×›×ª ×™×¦×•×¨ ×§×©×¨ ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™ Authorize.net (',0),(448545,12460,'el','Î£Ï„Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ¬ ÎºÎ¬ÏÏ„Î± Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±Ï‚:<p><b>Î§ÏÎ­Ï‰ÏƒÎ·Ï‚-> Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±-> Î¬ÎºÏ…ÏÎ± Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚</b><p>ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î±ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Î¼Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î® Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÎºÎ±Î¹ Ï„',0),(448546,12460,'zh','å¤„ç†ä¿¡ç”¨åˆ°ä¿¡ç”¨å¡ï¼šå…¥è´¦->å‘ç¥¨->æ— æ•ˆä»˜æ¬¾ã€‚ç‚¹å‡»ä»¥åºŸé™¤ä¸€ä¸ªä¿¡ç”¨å¡ä»˜æ¬¾ï¼Œå¹¶ä¸”ç³»ç»Ÿä¼šè‡ªåŠ¨è”ç³»Authorize.netï¼ˆæˆ–è€…å¦ä¸€ä¸ªNolaProä¸­çš„ä»˜æ¬¾é€šé“è®¾ç½®ï¼‰å¹¶å°è¯•åºŸé™¤æˆ–æŠµå…ä»˜æ¬¾ã€‚',0),(448547,12460,'sv','Processen kredit till kreditkort:<p><b>Fakturering-> fakturor-> ogiltiga betalningar</b><p>Klicka fÃ¶r att annullera en betalning med kreditkort och systemet kommer automatiskt att kontakta Authorize.net (eller en annan betalning gateway i NolaPro) och fÃ',0),(448548,12460,'it','Carta di credito a credito di processo:<p><b>Fatturazione-> fatture-> Void pagamenti</b><p>Fare clic per annullare un pagamento con carta di credito e il sistema automaticamente contatterÃ  Authorize.net (o un altro gateway di pagamento istituito in NolaP',0),(448549,12460,'tl','',0),(448550,12460,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£:<p><b>->à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰->à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸¢à¸à¹€à¸¥à¸´à¸à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™</b><p>à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­',0),(448551,12460,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡:<p><b>à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤šà¤¾à¤²à¤¾à¤¨ à¤¶à¥‚à¤¨à¥à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨->-></b><p>à¤à¤• à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¥‡ à¤­à¥à¤—à¤¤',0),(448552,12460,'ms','Kad kredit-kredit proses:<p><b>Bil-> invois-> pembayaran tidak sah</b><p>Klik untuk membatalkan pembayaran kad kredit dan sistem secara automatik akan menghubungi Authorize.net (atau satu lagi gerbang pembayaran yang ditubuhkan pada NolaPro) dan cuba untu',0),(448553,12460,'ar','Ø¹Ù…Ù„ÙŠØ© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¹Ù„Ù‰ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†:<p><b>Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> ÙÙˆØ§ØªÙŠØ±-> Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¨Ø§Ø·Ù„Ø©</b><p>Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø¥ÙØ±Ø§Øº Ø¯ÙØ¹ Ø¨ÙˆØ§Ø³Ø·Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ÙˆØ§Ù„Ù†Ø¸Ø§Ù… Ø³ØªØªØµÙ„ ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù',0),(448554,12460,'fr','Carte de crÃ©dit au crÃ©dit de processus :<p><b>Facturation-> factures-> paiements Sub</b><p>Cliquez ici pour annuler un paiement par carte bancaire et le systÃ¨me contactera automatiquement Authorize.net (ou une autre passerelle de paiement mis en place ',0),(448555,12460,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã‚’ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰:<p><b>->-> Void æ”¯æ‰•ã„è«‹æ±‚æ›¸è«‹æ±‚</b><p>ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ±ºæ¸ˆã¨ã‚·ã‚¹ãƒ†ãƒ ã‚’ç„¡åŠ¹ã«ã™ã‚‹] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™ã¯ã€Authorize.net (ã¾ãŸã¯åˆ¥ã®æ”¯æ‰•ã„ã‚²ãƒ¼ãƒˆã‚¦ã‚§ã‚¤ NolaPro ã§è¨',0),(448556,12460,'pt','CartÃ£o de crÃ©dito para crÃ©dito de processo:<p><b>Faturamento-> facturas-> Void pagamentos</b><p>Clique para cancelar um pagamento com cartÃ£o de crÃ©dito e o sistema automaticamente entrarÃ¡ em contato com Authorize.net (ou outro gateway de pagamento c',0),(448557,12460,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹:<p><b>Ð‘Ð¸Ð»Ð»Ð¸Ð½Ð³-> ÑÑ‡ÐµÑ‚Ð¾Ð²-> Void Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸</b><p>ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð¸ ÑÐ¸ÑÑ‚ÐµÐ¼Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ',0),(448558,12460,'es','Procesa crÃ©dito a la Tarjeta de CrÃ©dito:<p><b>FacturaciÃ³n->Factiras->Pagos Nulos</b><b> Hace clik para nular unpago por tarjeta de CrÃ©dito y el sistema contactarÃ¡ inmediatamente a Authorize.net (o otro puerto de pago configurado en NolaPro y intentar',0),(448559,12460,'de','Prozess-Kredit, Kredit-Karte:<p><b>Abrechnung-> Rechnungen-> Void Zahlungen</b><p>Hier klicken, um eine Zahlung per Kreditkarte und das System void wird automatisch Authorize.net (oder eine andere Zahlungs-Gateway einrichten in Artikel) kontaktieren und v',0),(448560,12460,'en','Process Credit to Credit Card:<p><b>Billing->Invoices->Void Payments</b><p> Click to void a credit card payment and the system will automatically contact Authorize.net (or another payment gateway set up in NolaPro) and try to void or credit the payment.',0),(448561,12461,'is','',0),(448562,12461,'dr',':ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-Ø¨ÛŒØ¬Ú©Ù‡Ø§-Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¹ØªØ¨Ø§Ø±  ',0),(448563,12461,'pr','Ø§Ú¯Ø± Ø­Ø³Ø§Ø¨ ÛŒÚ© Ù…Ø´ØªØ±ÛŒ ØªØ¹Ø§Ø¯Ù„ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¯Ø§Ø±Ø¯ Ø´Ù…Ø§ Ù…Ù…Ú©Ù† Ø§Ø³Øª ÛŒÚ© Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ ØµØ§Ø¯Ø± Ú©Ù†ÛŒØ¯:ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-ÙØ§Ú©ØªÙˆØ±Ù‡Ø§-Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¹ØªØ¨Ø§Ø±  ',0),(448564,12461,'tr','MÃ¼ÅŸteri hesabÄ±nÄ±n alacak bakiyesi olan bir geri vermek isteyebilirsiniz:<p><b>Fatura faturalarÄ± iade kredi->-></b>',0),(448565,12461,'pl','JeÅ›li konto uÅ¼ytkownika ma saldo kredytowe mogÄ… chcieÄ‡ wydania zwrotu:<p><b>PÅ‚atnoÅ›ci-> faktury-> zwrotu kredytu</b>',0),(448566,12461,'bg','ÐÐºÐ¾ ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ ÑÐ°Ð»Ð´Ð¾, Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð´Ð°Ð²Ð°Ñ‚ Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ:<p><b>Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸-> Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚</b>',0),(448567,12461,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ú©Ùˆ Ø§ÛŒÚ© ÙˆØ§Ù¾Ø³ÛŒ Ø¬Ø§Ø±ÛŒ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº ØªØ§Ú©Û Ø§ÛŒÚ© Ú©Ø±ÛŒÚˆÙ¹ ØªÙˆØ§Ø²Ù† Ø§ÛŒÚ© Ú©Ø³Ù¹Ù…Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹ ÛÛ’ Û”<p><b>Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©Ø±ÛŒÚˆÙ¹->-></b>',0),(448568,12461,'sr','ÐÐºÐ¾ Ñ€Ð°Ñ‡ÑƒÐ½ ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð¼Ð° ÑÐ°Ð»Ð´Ð¾ ÑÐ° Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµÐ¼ Ð¼Ð¾Ð¶Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð´Ð°Ñ‚Ðµ Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°:<p><b>Ð—Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð° Ð¸ Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°</b>',0),(448569,12461,'vi','Náº¿u tÃ i khoáº£n cá»§a 1 khÃ¡ch hÃ ng cÃ³ sá»‘ dÆ° cÃ³ báº¡n muá»‘n lÃ m 1 khoáº£n hoÃ n láº¡i: Thanh toÃ¡n-> hÃ³a Ä‘Æ¡n-> hoÃ n tráº£ tÃ­n dá»¥ng',0),(448570,12461,'af','Indien die rekening van \'n kliÃ«nt het \'n kredietsaldo wat jy kan wens om \'n terugbetaling uitreik:<p><b>Fakturering-> fakture-> terugbetaling krediet</b>',0),(448571,12461,'ro','ÃŽn cazul Ã®n care un cont de client are un sold creditor, aÅ£i putea dori sÄƒ emitÄƒ o restituire:<p><b>-> Facturi-> rambursare Credit de facturare</b>',0),(448572,12461,'et','Kui kliendi konto on kreeditsaldo, vÃµiksite anda toetust:<p><b>Arved arved-> toetuse krediidi-></b>',0),(448573,12461,'si','ÄŒe raÄun kupca ima salda Å¾elite izdala nadomestilo:<p><b>ZaraÄunavanje-> raÄuni-> vraÄilo kredita</b>',0),(448574,12461,'ba','Jika akun pelanggan memiliki saldo kredit Anda mungkin ingin mengeluarkan pengembalian dana:<p><b>Penagihan-> faktur-> pengembalian kredit</b>',0),(448575,12461,'nl','Als een account van de klant een creditsaldo heeft wil u misschien afgifte van een restitutie:<p><b>Facturering-> facturen-> restitutie krediet</b>',0),(448576,12461,'fi','Jos kÃ¤yttÃ¤jÃ¤tili on maksettavien saldo voit antaa tuki:<p><b>Laskutus-> laskujen-> tuen luotto</b>',0),(448577,12461,'no','Hvis en kundekonto har en kreditsaldo kan du vil utstede en tilbakebetaling:<p><b>Fakturering-> fakturaer-> tilbakebetaling kreditt</b>',0),(448578,12461,'da','Hvis en kundekonto har en kreditsaldo, du mÃ¥tte Ã¸nske at udstede en refundering:<p><b>Fakturering-> fakturaer-> restitution kredit</b>',0),(448579,12461,'ko','ê³ ê° ê³„ì •ì— ì‹ ìš© ìž”ì•¡ ê²½ìš°ì— í™˜ë¶ˆì„ ë°œí–‰í•  ìˆ˜ë„ ìžˆìŠµë‹ˆë‹¤.<p><b>ê²°ì œ ì²­êµ¬ì„œ í™˜ë¶ˆ ì‹ ìš©->-></b>',0),(448580,12461,'he','×× ×—×©×‘×•×Ÿ ×”×œ×§×•×— ×›×•×œ×œ ××™×–×•×Ÿ ××©×¨××™ ×©×¦×¨×™×š ×œ×¨×¦×•×ª ×œ×”× ×¤×§×ª ×”×—×–×¨ ×›×¡×¤×™:<p><b>×—×™×•×‘-> ×—×©×‘×•× ×™×•×ª-> ×”×—×–×¨ ×”××©×¨××™</b>',0),(448581,12461,'el','Î•Î¬Î½ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€ÎµÎ»Î¬Ï„Î· Î­Ï‡ÎµÎ¹ Î­Î½Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿, Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± ÎµÏ€Î¹Î¸Ï…Î¼Î®ÏƒÎµÏ„Îµ Î½Î± Ï„Î·Î½ Î­ÎºÎ´Î¿ÏƒÎ· Ï„Î·Ï‚ ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚ Ï‡ÏÎ·Î¼Î¬Ï„Ï‰Î½:<p><b>Î§ÏÎ­Ï‰ÏƒÎ·Ï‚-> Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹',0),(448582,12461,'zh','å¦‚æžœä¸€ä¸ªå®¢æˆ·å¸æˆ·æœ‰ä¸€ä¸ªè´·æ¬¾ç»“ä½™ï¼Œæ‚¨ä¼šå¸Œæœ›å‘å¸ƒé€€æ¬¾ï¼šå…¥è´¦->å‘ç¥¨->é€€æ¬¾',0),(448583,12461,'sv','Om en kund har ett saldo kan du utfÃ¤rda en Ã¥terbetalning:<p><b>Fakturering-> fakturor-> Ã¥terbetalning kredit</b>',0),(448584,12461,'it','Se un cliente ha un saldo attivo si desidera emettere un rimborso:<p><b>Fatturazione-> fatture-> rimborso credito</b>',0),(448585,12461,'tl','',0),(448586,12461,'th','à¸–à¹‰à¸²à¸¥à¸¹à¸à¸„à¹‰à¸²à¸¡à¸µà¸”à¸¸à¸¥à¹€à¸„à¸£à¸”à¸´à¸•à¸„à¸¸à¸“à¸­à¸²à¸ˆà¸•à¹‰à¸­à¸‡à¸­à¸­à¸à¹€à¸‡à¸´à¸™à¸„à¸·à¸™:<p><b>->à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰->à¹€à¸„à¸£à¸”à¸´à¸•à¸„à¸·à¸™à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™</b>',0),(448587,12461,'hi','à¤…à¤—à¤° à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤–à¤¾à¤¤à¥‡ à¤à¤• à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤†à¤ª à¤à¤• à¤µà¤¾à¤ªà¤¸à¥€ à¤œà¤¾à¤°à¥€ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ:<p><b>à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤šà¤¾à¤²à¤¾à¤¨ à¤µà¤¾à¤ªà¤¸à¥',0),(448588,12461,'ms','Jika akaun yang mempunyai baki kredit yang anda mungkin ingin mengeluarkan bayaran balik:<p><b>Bil-> invois-> bayaran balik kredit</b>',0),(448589,12461,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø­Ø³Ø§Ø¨ Ø¹Ù…ÙŠÙ„ Ù„Ø¯ÙŠÙ‡ Ø±ØµÙŠØ¯ Ù‚Ø¯ ØªØ±ØºØ¨ ÙÙŠ Ø¥ØµØ¯Ø§Ø± Ø§Ù„Ù†Ù‚ÙˆØ¯:<p><b>Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> ÙÙˆØ§ØªÙŠØ±-> Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†</b>',0),(448590,12461,'fr','Si un compte a un solde crÃ©diteur vous pouvez Ã©mettre un remboursement :<p><b>-> Factures-> remboursement crÃ©dit de facturation</b>',0),(448591,12461,'jp','é¡§å®¢ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã«ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆæ®‹é«˜ãŒã‚ã‚‹å ´åˆã€æ‰•ã„æˆ»ã—ã‚’ç™ºè¡Œã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚<p><b>->-> æ‰•ã„æˆ»ã—ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆè«‹æ±‚æ›¸è«‹æ±‚</b>',0),(448592,12461,'pt','Se uma conta de cliente tiver um saldo de crÃ©dito, que vocÃª pode desejar emitir um reembolso:<p><b>Faturamento-> facturas-> restituiÃ§Ã£o de crÃ©dito</b>',0),(448593,12461,'ru','Ð•ÑÐ»Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð¼ÐµÐµÑ‚ Ð±Ð°Ð»Ð°Ð½Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð° Ð²Ñ‹ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¾Ñ„Ð¾Ñ€Ð¼Ð¸Ñ‚ÑŒ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚:<p><b>Ð‘Ð¸Ð»Ð»Ð¸Ð½Ð³-> ÑÑ‡ÐµÑ‚Ð¾Ð²-> Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°</b>',0),(448594,12461,'es','Si una cuenta de cliente tiene un saldo de crÃ©dito posible desea emitir una devoluciÃ³n:<p><b>FacturaciÃ³n -> Facturas -> CrÃ©dito de DevoluciÃ³n</b>',0),(448595,12461,'de','Wenn ein Kundenkonto eine Guthaben hat, mÃ¶chten Sie vielleicht eine Erstattung ausstellen:<p><b>Abrechnung-> Rechnungen-> Erstattung Credit</b>',0),(448596,12461,'en','If a customer account has a credit balance you may wish to issue a refund:<p><b>Billing -> Invoices -> Refund Credit</b>',0),(448597,12462,'is','',0),(448598,12462,'dr','',0),(448599,12462,'pr','',0),(448600,12462,'tr','',0),(448601,12462,'pl','',0),(448602,12462,'bg','',0),(448603,12462,'ur','',0),(448604,12462,'sr','',0),(448605,12462,'vi','',0),(448606,12462,'af','',0),(448607,12462,'ro','',0),(448608,12462,'et','',0),(448609,12462,'si','',0),(448610,12462,'ba','',0),(448611,12462,'nl','',0),(448612,12462,'fi','',0),(448613,12462,'no','',0),(448614,12462,'da','',0),(448615,12462,'ko','',0),(448616,12462,'he','',0),(448617,12462,'el','',0),(448618,12462,'zh','',0),(448619,12462,'sv','',0),(448620,12462,'it','',0),(448621,12462,'tl','',0),(448622,12462,'th','',0),(448623,12462,'hi','',0),(448624,12462,'ms','',0),(448625,12462,'ar','',0),(448626,12462,'fr','',0),(448627,12462,'jp','',0),(448628,12462,'pt','',0),(448629,12462,'ru','',0),(448630,12462,'es','',0),(448631,12462,'de','',0),(448632,12462,'en','',0),(448633,12463,'is','',0),(448634,12463,'dr','',0),(448635,12463,'pr','',0),(448636,12463,'tr','',0),(448637,12463,'pl','',0),(448638,12463,'bg','',0),(448639,12463,'ur','',0),(448640,12463,'sr','',0),(448641,12463,'vi','',0),(448642,12463,'af','',0),(448643,12463,'ro','',0),(448644,12463,'et','',0),(448645,12463,'si','',0),(448646,12463,'ba','',0),(448647,12463,'nl','',0),(448648,12463,'fi','',0),(448649,12463,'no','',0),(448650,12463,'da','',0),(448651,12463,'ko','',0),(448652,12463,'he','',0),(448653,12463,'el','',0),(448654,12463,'zh','',0),(448655,12463,'sv','',0),(448656,12463,'it','',0),(448657,12463,'tl','',0),(448658,12463,'th','',0),(448659,12463,'hi','',0),(448660,12463,'ms','',0),(448661,12463,'ar','',0),(448662,12463,'fr','',0),(448663,12463,'jp','',0),(448664,12463,'pt','',0),(448665,12463,'ru','',0),(448666,12463,'es','',0),(448667,12463,'de','',0),(448668,12463,'en','',0),(448669,12464,'is','',0),(448670,12464,'dr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ø§ÛŒÙ† Ø¹Ø¨Ø§Ø±Øª Ú©Ù‡\" Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ØµØ­ÛŒØ­ Ù†ÛŒØ³Øª\" Ø±Ø§ Ø²Ù…Ø§Ù† Ø°Ø®ÛŒØ±Ù‡ Ø®Ø±ÛŒØ¯Ø§Ø± Ø¯Ø±ÛŒØ§ÙØª Ú©Ø±Ø¯ÛŒØ¯ Ù…Ø±ÙˆØ±Ú¯Ø± Ø´Ù…Ø§ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø¨Ù‡ Ø·ÙˆØ±Ø®ÙˆØ¯Ú©Ø§Ø± Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø±Ø§ Ø°Ø®ÛŒØ±Ù‡ Ú©Ø±Ø¯Ù‡ Ø¨Ø§Ø´Ø¯.Ø²Ù…Ø§Ù†ÛŒ',0),(448671,12464,'pr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ø§ÛŒÙ† Ø¹Ø¨Ø§Ø±Øª Ú©Ù‡\" Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± ØµØ­ÛŒØ­ Ù†ÛŒØ³Øª\" Ø±Ø§ Ø²Ù…Ø§Ù† Ø°Ø®ÛŒØ±Ù‡ Ø®Ø±ÛŒØ¯Ø§Ø± Ø¯Ø±ÛŒØ§ÙØª Ú©Ø±Ø¯ÛŒØ¯ Ù…Ø±ÙˆØ±Ú¯Ø± Ø´Ù…Ø§ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø¨Ù‡ Ø·ÙˆØ±Ø®ÙˆØ¯Ú©Ø§Ø± Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø±Ø§ Ø°Ø®ÛŒØ±Ù‡ Ú©Ø±Ø¯Ù‡ Ø¨Ø§Ø´Ø¯.Ø²Ù…Ø§Ù†ÛŒ',0),(448672,12464,'tr','\"Parolalar eÅŸleÅŸmiyor\" alÄ±rsanÄ±z bir mÃ¼ÅŸteri kaydederken, tarayÄ±cÄ±nÄ±z otomatik kaydetme ÅŸifre olabilir.<p>DÃ¼zenlerken bir mÃ¼ÅŸteri parola alanlarÄ± temizleyin. Bu iletiyi ortadan kaldÄ±rmak gerekir.',0),(448673,12464,'pl','JeÅ›li otrzymasz \"HasÅ‚a nie pasujÄ…\" podczas zapisywania klienta, przeglÄ…darka moÅ¼e byÄ‡ automatyczne zapisywanie haseÅ‚.<p>Podczas edytowania klienta wyczyÅ›Ä‡ pola hasÅ‚o. To powinno wyeliminowaÄ‡ komunikat.',0),(448674,12464,'bg','ÐÐºÐ¾ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ \"ÐŸÐ°Ñ€Ð¾Ð»Ð¸Ñ‚Ðµ Ð½Ðµ ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‚\" Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚, Ð²Ð°ÑˆÐ¸ÑÑ‚ Ð±Ñ€Ð°ÑƒÐ·ÑŠÑ€ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð¸.<p>ÐšÐ¾Ð³Ð°Ñ‚Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ ÐºÐ»Ð¸Ðµ',0),(448675,12464,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ú©Ùˆ \"Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù†ÛÛŒÚº Ù…Ø´Ø§Ø¨Û\" Ù…ÙˆØµÙˆÙ„ Ø¬Ø¨ Ø§ÛŒÚ© Ú¯Ø§ÛÚ© Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø± Ø±ÛØ§ ÛÛ’ØŒ ØªÙˆ Ø¢Ù¾ Ú©Û’ Ø¨Ø±Ø§Ø¤Ø²Ø± Ø®ÙˆØ¯ Ù…Ø­ÙÙˆØ¸ Ù¾Ø§Ø³ ÙˆØ±Úˆ ÛÙˆ Û”<p>Ø¬Ø¨ Ø¢Ù¾ ØªØ¯ÙˆÛŒÙ† Ø§ÛŒÚ© Ú¯Ø§ÛÚ© Ú©Ùˆ ØµØ§Ù Ú©Ø±ÛŒÚº Ù¾Ø§Ø³ ',0),(448676,12464,'sr','ÐÐºÐ¾ Ð´Ð¾Ð±Ð¸Ñ˜ÐµÑ‚Ðµ \"Ð›Ð¾Ð·Ð¸Ð½ÐºÐµ ÑÐµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ\" Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ñ‡ÑƒÐ²Ð°ÑšÐ° ÐºÑƒÐ¿Ñ†Ð°, Ð²Ð°Ñˆ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‡ Ð¼Ð¾Ð¶Ð´Ð° Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ñ‡ÑƒÐ²Ð°ÑšÐµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ.<p>ÐšÐ°Ð´Ð° ÑƒÑ€ÐµÑ’ÑƒÑ˜ÐµÑ‚Ðµ ÐºÑƒÐ¿Ñ†Ð° Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð',0),(448677,12464,'vi','Náº¿u báº¡n nháº­n Ä‘Æ°á»£c \" máº­t kháº©u khÃ´ng khá»›p\" khi lÆ°u 1 khÃ¡ch hÃ ng, trÃ¬nh duyá»‡t cá»§a báº¡n cÃ³ thá»ƒ lÃ  lÆ°u tá»± Ä‘á»™ng. Khi báº¡n sá»­a 1 khÃ¡ch hÃ ng vá» máº­t kháº©u. Äiá»u nÃ y sáº½ loáº¡i bá» tin nháº¯n',0),(448678,12464,'af','As jy ontvang \"Wagwoorde stem nie ooreen nie\" wanneer stoor \'n kliÃ«nt, jou blaaier Outo-stoor wagwoorde kan wees.<p>Wanneer jy Redigeer \'n kliÃ«nt duidelik die wagwoord velde. Dit behoort die boodskap te elimineer.',0),(448679,12464,'ro','DacÄƒ primiÅ£i \"Parolele nu se potrivesc\" la salvarea unui client, browser-ul poate fi auto-salvarea parolelor.<p>CÃ¢nd editaÅ£i un client clar parolelor. Acest lucru ar trebui sÄƒ elimine mesajul.',0),(448680,12464,'et','Kui kuvatakse \"Paroolid ei kattu\" klient salvestamisel teie brauser vÃµib automaatne salvestamine paroole.<p>Kui redigeerite kliendile selge parool vÃ¤ljad. See tuleks kaotada sÃµnum.',0),(448681,12464,'si','ÄŒe prejmete \"Gesli se ne ujemata\" pri shranjevanju kupec, vaÅ¡ brskalnik lahko avto varÄevanja gesla.<p>Ko urejate kupcu poÄistite polji geslo. To mora odpraviti sporoÄilo.',0),(448682,12464,'ba','Jika Anda menerima \"Password tidak cocok\" ketika menyimpan pelanggan, peramban mungkin auto hemat password.<p>Ketika Anda mengedit pelanggan jelas bidang sandi. Ini harus menghilangkan pesan.',0),(448683,12464,'nl','Als het foutbericht \'Wachtwoorden komen niet overeen\' bij het opslaan van een klant, uw browser auto-besparing wachtwoorden kan worden.<p>Wanneer u een klant duidelijk de wachtwoordvelden bewerken. Dit moet een einde maken aan het bericht.',0),(448684,12464,'fi','Jos saat \"Edellinen\" Kun tallennat asiakas, selaimesi voi olla automaattinen tallennus salasanoja.<p>Kun muokkaat asiakkaaksi poistamalla salasana-kenttiin. TÃ¤mÃ¤n pitÃ¤isi poistaa viestin.',0),(448685,12464,'no','Hvis du fÃ¥r \"Passordene samsvarer ikke\" nÃ¥r du lagrer en kunde, nettleseren kan vÃ¦re automatisk lagrer passord.<p>NÃ¥r du redigerer en kunde fjerner feltene passord. Dette bÃ¸r fjerne meldingen.',0),(448686,12464,'da','Hvis fejlmeddelelsen \"Adgangskoderne er ikke ens\" nÃ¥r du gemmer en kunde, er din browser muligvis auto-gemmer adgangskoder.<p>NÃ¥r du redigerer en kunde rydde felterne adgangskode. Dette skulle fjerne beskeden.',0),(448687,12464,'ko','\"ì•”í˜¸\"ëŠ” ì¼ì¹˜ í•˜ì§€ ì•ŠëŠ” ê²½ìš° ê³ ê°ì„ ì €ìž¥í•  ë•Œ ë¸Œë¼ìš°ì € ìžë™ ì €ìž¥ ì•”í˜¸ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p>íŽ¸ì§‘ í•˜ë©´ ê³ ê°ì´ ì•”í˜¸ í•„ë“œ ì„ íƒì„ ì·¨ì†Œ í•©ë‹ˆë‹¤. ì´ ë©”ì‹œì§€ë¥¼ ì œê±° í•´ì•¼ í•©ë‹ˆë‹¤.',0),(448688,12464,'he','×× ××ª×” ×ž×§×‘×œ \"×”×¡×™×¡×ž××•×ª ××™× ×Ÿ ×ª×•××ž×•×ª\" ×‘×¢×ª ×©×ž×™×¨×ª ×œ×§×•×—, ×”×“×¤×“×¤×Ÿ ×©×œ×š ×¢×©×•×™ ×œ×”×™×•×ª ×¡×™×¡×ž××•×ª ××•×˜×•×ž×˜×™ ×œ×—×™×¡×›×•×Ÿ.<p>×‘×¢×ª ×¢×¨×™×›×ª ×œ×§×•×— × ×§×” ××ª ×©×“×•×ª ×¡×™×¡×ž×”. ×–×” ××ž×•×¨ ×œ×',0),(448689,12464,'el','Î•Î¬Î½ Î»Î¬Î²ÎµÏ„Îµ \"ÎšÏ‰Î´Î¹ÎºÎ¿Î¯ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½\" ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· ÎµÎ½ÏŒÏ‚ Ï€ÎµÎ»Î¬Ï„Î·, Ï„Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Ï€ÎµÏÎ¹Î®Î³Î·ÏƒÎ®Ï‚ ÏƒÎ±Ï‚ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Î±Ï€Î¿Î¸Î®ÎºÎ',0),(448690,12464,'zh','å½“ä¿å­˜ä¸€ä¸ªå®¢æˆ·æ—¶ï¼Œå¦‚æžœæ‚¨æ”¶åˆ°â€œå¯†ç ä¸åŒ¹é…â€æ¶ˆæ¯ï¼Œæ‚¨çš„æµè§ˆå™¨ä¹Ÿè®¸æ˜¯è‡ªåŠ¨ä¿å­˜å¯†ç ã€‚å½“æ‚¨ç¼–è¾‘ä¸€ä¸ªå®¢æˆ·æ—¶ï¼Œè¯·æ¸…é™¤å¯†ç å­—æ®µã€‚è¿™å¯ä»¥æ¶ˆé™¤æ¶ˆæ¯ã€‚',0),(448691,12464,'sv','Om du fÃ¥r \"LÃ¶senorden matchar inte\" nÃ¤r du sparar en kund, din webblÃ¤sare kan vara auto-spara lÃ¶senord.<p>NÃ¤r du redigerar en tydlig kund lÃ¶senord fÃ¤lten. Detta bÃ¶r eliminera meddelandet.',0),(448692,12464,'it','Se viene visualizzato \"Le password non corrispondono\" durante il salvataggio di un cliente, il browser puÃ² essere il salvataggio automatico password.<p>Quando si modifica un cliente cancellare i campi password. Questo dovrebbe eliminare il messaggio.',0),(448693,12464,'tl','',0),(448694,12464,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¹„à¸”à¹‰à¸£à¸±à¸š \"à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸™\" à¹€à¸¡à¸·à¹ˆà¸­à¸šà¸±à¸™à¸—à¸¶à¸à¸¥à¸¹à¸à¸„à¹‰à¸² à¹€à¸šà¸£à¸²à¸§à¹Œà¹€à¸‹à¸­à¸£à¹Œà¸­à¸²à¸ˆà¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¸šà¸±à¸™à¸—à¸¶à¸à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à',0),(448695,12464,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ \"à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡à¥à¤¸ à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€à¤‚\" à¤†à¤ªà¤•à¥‡ à¤¬à¥à¤°à¤¾à¤‰à¤œà¤¼à¤° à¤‘à¤Ÿà¥‹-à¤¬à¤šà¤¤ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ à¤œà¤¬ à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥€ à¤¬à¤šà¤¤,',0),(448696,12464,'ms','Jika anda menerima \"Kata laluan tidak padan\" apabila simpanan pelanggan, pelayar web anda boleh auto menyelamatkan kata laluan.<p>Apabila anda mengedit pelanggan Kosongkan medan kata laluan. Ini harus menghapuskan mesej.',0),(448697,12464,'ar','Ø¥Ø°Ø§ ÙƒÙ†Øª ØªØªÙ„Ù‚Ù‰ \"Ù„Ø§ ØªØªØ·Ø§Ø¨Ù‚ ÙƒÙ„Ù…Ø§Øª Ø§Ù„Ù…Ø±ÙˆØ±\" Ø¹Ù†Ø¯ Ø­ÙØ¸ Ø£Ø­Ø¯ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ØŒ Ø§Ù„Ù…Ø³ØªØ¹Ø±Ø¶ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù‚Ø¯ ØªÙƒÙˆÙ† ÙƒÙ„Ù…Ø§Øª Ù…Ø±ÙˆØ± Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ø§Ù„Ù…Ù†Ù‚Ø°Ø©.<p>Ø¹Ù†Ø¯Ù…Ø§ ØªÙ‚ÙˆÙ… Ø¨ØªØ­Ø±ÙŠØ± Ø¹Ù…ÙŠÙ„ Ù…Ø³',0),(448698,12464,'fr','Si vous recevez des Â« Mots de passe ne correspondent pas Â» lors de l\'enregistrement d\'un client, votre navigateur peut Ãªtre des mots de passe de sauvegarde automatique.<p>Lorsque vous modifiez un client clairement les champs de mot de passe. Cela devra',0),(448699,12464,'jp','ã€Œãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ãŒä¸€è‡´ã—ã¾ã›ã‚“ã€ãŒè¡¨ç¤ºã•ã‚ŒãŸå ´åˆã€ãƒ–ãƒ©ã‚¦ã‚¶ãƒ¼ãŒè‡ªå‹•ä¿å­˜ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚ã‚Šã¾ã™é¡§å®¢ã‚’ä¿å­˜ã™ã‚‹ã¨ãã€‚<p>ç·¨é›†ã™ã‚‹ã¨ãã€é¡§å®¢ã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’ã‚¯ãƒªã‚¢ã—ã¾ã™ã€‚ã“ã‚Œã¯ã€',0),(448700,12464,'pt','Se vocÃª receber \"As senhas nÃ£o coincidem\" ao salvar um cliente, seu navegador pode ser senhas de salvamento automÃ¡tico.<p>Quando vocÃª edita um cliente limpar os campos de senha. Isso deve eliminar a mensagem.',0),(448701,12464,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡Ð°ÐµÑ‚Ðµ Â«ÐŸÐ°Ñ€Ð¾Ð»Ð¸ Ð½Ðµ ÑÐ¾Ð²Ð¿Ð°Ð´Ð°ÑŽÑ‚Â» Ð¿Ñ€Ð¸ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°, Ð²Ð°Ñˆ Ð±Ñ€Ð°ÑƒÐ·ÐµÑ€ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ ÐÐ²Ñ‚Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð¿Ð°Ñ€Ð¾Ð»ÐµÐ¹.<p>ÐŸÑ€Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¾Ñ‡Ð¸',0),(448702,12464,'es','Si recibe \"ContraseÃ±as no emparejan\" cuando guarda un cliente, su browser puede estar auto-guardando las contraseÃ±as. <p>Cuando edita un cliente limpia los campos de contraseÃ±as. Este acciÃ³n debe eliminar el mensaje',0),(448703,12464,'de','Wenn Sie \"PasswÃ¶rter stimmen nicht Ã¼berein\" erhalten Ihr Browser mÃ¶glicherweise beim Kunden speichern, Auto-speichern KennwÃ¶rter.<p>Beim Bearbeiten ein Kunden deaktivieren Sie die Passwortfelder. Dies sollte die Meldung beseitigen.',0),(448704,12464,'en','If you receive \"Passwords do not match\" when saving a customer, your browser may be auto-saving passwords. <p>When you edit a customer clear the password fields. This should eliminate the message.',0),(448705,12465,'is','',0),(448706,12465,'dr','(Ø§Ø¬Ø±Ø§)ÛŒØ§ ÛŒÚ© ÙØ±Ù…Ø§ÛŒØ´ Ø§ÛŒØ³ØªÚ¯Ø§Ù‡ ÙØ±ÙˆØ´ Ø§ÛŒØ¬Ø§Ø¯ Ú©Ù†ÛŒØ¯ Ø¯Ø±:ÙØ±Ù…Ø§ÛŒØ´Ø§Øª-ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø¬Ù†Ø³- Ø§ØµÙ„Ø§Ø­/ ÙØ±Ù…Ø§ÛŒØ´ Ø¬Ø¯ÛŒØ¯ ',0),(448707,12465,'pr','Ø¨Ø±Ø§ÛŒ ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ØªØ®ÙÛŒÙ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒÚ© Ø³ÙØ§Ø±Ø´ ØªÚ©Ù…ÛŒÙ„(Ø§Ø¬Ø±Ø§)ÛŒØ§ ÛŒÚ© Ø³ÙØ§Ø±Ø´ Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ Ø§ÛŒØ¬Ø§Ø¯ Ú©Ù†ÛŒØ¯ Ø¯Ø±:Ø³ÙØ§Ø±Ø´Ø§Øª-Ø³ÙØ§Ø±Ø´Ø§Øª Ú©Ø§Ù„Ø§- ÙˆÛŒØ±Ø§ÛŒØ´/ Ø³ÙØ§Ø±Ø´ Ø¬Ø¯ÛŒØ¯ ',0),(448708,12465,'tr','Bir mÃ¼ÅŸteri iskonto girmek iÃ§in sipariÅŸ oluÅŸturmak yerine getirilmesi veya POS sÄ±rayla:<p><b>SipariÅŸleri madde sipariÅŸleri yeni/DÃ¼zenle sipariÅŸ->-></b>',0),(448709,12465,'pl','Aby wprowadziÄ‡ zniÅ¼ki na klienta zamÃ³wienie utworzyÄ‡ speÅ‚nienie lub zamÃ³wienie POS w:<p><b>ZamÃ³wienia-> przedmiotu zamÃ³wienia-> nowy edycja zamâ‰¤wienia</b>',0),(448710,12465,'bg','Ð—Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¸Ð»Ð¸ POS Ñ€ÐµÐ´ Ð²:<p><b>ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸-> ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸-> Ð½Ð¾Ð²Ð¸/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°</b>',0),(448711,12465,'ur','Ø§ÛŒÚ© Ú¯Ø§ÛÚ© Ú©Ùˆ Ø±Ø¹Ø§ÛŒØª Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ØªØ±ØªÛŒØ¨ ØªØ®Ù„ÛŒÙ‚ Ø§ÛŒÚ© Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ ÛŒØ§ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ù…ÛŒÚº:<p><b>Ù†Ø¦ÛŒ/ØªØ¯ÙˆÛŒÙ† Ú©ÛŒ ØªØ±ØªÛŒØ¨-> Ø´Û’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª-> ',0),(448712,12465,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÐ½ÐµÐ»Ð¸ Ð¿Ð¾Ð¿ÑƒÑÑ‚ Ð½Ð° ÐºÑƒÐ¿Ñ†Ð° Ð½Ð°Ð»Ð¾Ð³Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð¸Ð»Ð¸ ÐŸÐžÐ¡ Ñ€ÐµÐ´ Ñƒ:<p><b>ÐÐ°Ð»Ð¾Ð³Ðµ Ð¸ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¸ Ð½Ð¾Ð²Ð¸Ñ…/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°</b>',0),(448713,12465,'vi','Äá»ƒ nháº­p khoáº£n chiáº¿t kháº¥u vÃ o má»™t Ä‘Æ¡n Ä‘áº·t hÃ ng cá»§a khÃ¡ch hÃ ng thÃ¬ pháº£i táº¡o ra má»™t PO hoÃ n chá»‰nh hoáº·c Ä‘Æ¡n hÃ ng POS: Ä‘Æ¡n Ä‘áº·t hÃ ng-> táº¡o má»›i/sá»­a',0),(448714,12465,'af','Te voer \'n afslag op \'n kliÃ«nt orde skep \'n vervulling of POS volgorde in:<p><b>Bestellings-> Item bestellings-> nuwe/redigeer orde</b>',0),(448715,12465,'ro','Pentru a introduce un discount pe un client comanda creeazÄƒ o Ã®mplinire sau POS ordinea Ã®n:<p><b>Comenzi-> element comenzi-> nouÄƒ/editare comanda</b>',0),(448716,12465,'et','Sisestada hinnaalandeid kliendi tellimuse luua eneseteostus vÃµi POS jÃ¤rjekorras:<p><b>Tellimused-> kauba tellimuste-> uus/Muuda jÃ¤rjekorras</b>',0),(448717,12465,'si','Vnesite popust na kupca nalog ustvarite izpolnitev ali POS nalog v:<p><b>NaroÄila-> element naroÄila-> nove izdajati/naroÄilo</b>',0),(448718,12465,'ba','Untuk memasukkan diskon pada pelanggan pesanan membuat pemenuhan atau urutan POS:<p><b>Perintah-> Item Pesanan-> Order Baru/Edit</b>',0),(448719,12465,'nl','Voer een korting op een klant maken volgorde een vervulling of POS bestellen:<p><b>Bestellingen-> Item Orders-> nieuwe/bewerken volgorde</b>',0),(448720,12465,'fi','SyÃ¶tÃ¤ alennuksen asiakkaan jÃ¤rjestyksessÃ¤ luomalla tÃ¤yttÃ¤minen tai POS tilata:<p><b>Tilaukset-> kohteen tilauksia-> uusi tai Muokkaa tilauksen</b>',0),(448721,12465,'no','Hvis du vil angi en rabatt pÃ¥ en kunde rekkefÃ¸lge oppretter en oppfyllelse eller POS rekkefÃ¸lgen:<p><b>Bestillinger-> element ordrer-> ny/Rediger rekkefÃ¸lge</b>',0),(448722,12465,'da','For at indtaste en rabat pÃ¥ en kunde ordre opretter en opfyldelse eller POS ordre i:<p><b>Ordrer-> vare ordrer-> ny/Rediger rÃ¦kkefÃ¸lge</b>',0),(448723,12465,'ko','ê³ ê° í• ì¸ ìž…ë ¥ ìˆœì„œ í–‰ ë˜ëŠ” POS ìˆœì„œë¥¼ ë§Œë“­ë‹ˆë‹¤.<p><b>ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘ ìˆœì„œ-> í•­ëª© ìˆœì„œ-> ì£¼ë¬¸</b>',0),(448724,12465,'he','×›×“×™ ×œ×”×–×™×Ÿ ×”× ×—×” ×¢×œ ×œ×§×•×— ×¡×“×¨ ×œ×™×¦×•×¨ ×”×’×©×ž×” ××• ×§×•×¤×” ×”×¡×“×¨:<p><b>×”×–×ž× ×•×ª-> ×¤×¨×™×˜ ×¤×§×•×“×•×ª-> ×—×“×©×”/×¢×¨×™×›×ª ×”×¡×“×¨</b>',0),(448725,12465,'el','Î“Î¹Î± Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ· ÏƒÎµ Î­Î½Î±Î½ Ï€ÎµÎ»Î¬Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Î® ÏƒÎµÎ¹ÏÎ¬ POS Î¼Îµ:<p><b>Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚-> ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚-> Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€Î',0),(448726,12465,'zh','åœ¨å®¢æˆ·è®¢å•ä¸Šè¾“å…¥ä¸€ä¸ªæŠ˜æ‰£ï¼Œåˆ›å»ºä¸€ä¸ªå±¥è¡Œè®¢å•æˆ–é”€å”®ç‚¹è®¢å•åœ¨ï¼šè®¢å•->é¡¹ç›®è®¢å•->æ–°å¢žç¼–è¾‘è®¢å•',0),(448727,12465,'sv','Om du vill ange en rabatt pÃ¥ en kund skapa ordning en uppfyllelse eller POS bestÃ¤lla:<p><b>Order-> post order-> ny/redigera Order</b>',0),(448728,12465,'it','Per inserire uno sconto su un cliente ordine creare un adempimento o ordine di POS in:<p><b>Ordini-> voce ordini-> nuova/modifica ordine</b>',0),(448729,12465,'tl','',0),(448730,12465,'th','à¸›à¹‰à¸­à¸™à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¸à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²à¸ªà¸±à¹ˆà¸‡à¸à¸²à¸£à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸«à¸£à¸·à¸­à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ POS:<p><b>à¸ªà¸±à¹ˆà¸‡->à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²->à¸ªà¸±à¹ˆà¸‡à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚</b',0),(448731,12465,'hi','à¤à¤• à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤ªà¤° à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‘à¤°à¥à¤¡à¤° à¤¬à¤¨à¤¾à¤à¤ à¤à¤• à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤¯à¤¾ POS à¤•à¥à¤°à¤® à¤®à¥‡à¤‚:<p><b>à¤†à¤‡à¤Ÿà¤® à¤¨à¤/à¤¸à¤‚à¤ªà',0),(448732,12465,'ms','Untuk masukkan diskaun pada pelanggan perintah mencipta dalam memenuhi atau kiriman POS di:<p><b>Perintah-> Item pesanan-> perintah baru/Edit</b>',0),(448733,12465,'ar','Ù„Ø¥Ø¯Ø®Ø§Ù„ Ø®ØµÙ… Ø¹Ù„Ù‰ Ø¹Ù…ÙŠÙ„ Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ø§Ù„ÙˆÙØ§Ø¡ Ø£Ùˆ ØªØ±ØªÙŠØ¨ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ ÙÙŠ:<p><b>Ø£ÙˆØ§Ù…Ø±-> Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø¯-> Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¬Ø¯ÙŠØ¯/ØªØ­Ø±ÙŠØ±</b>',0),(448734,12465,'fr','Pour entrer un rabais sur un client commande crÃ©er un accomplissement ou POS aux :<p><b>Commandes-> commandes point-> ordre nouveau/modifier</b>',0),(448735,12465,'jp','é¡§å®¢ã«å‰²å¼•ã‚’å…¥åŠ›ã™ã‚‹ã«ã¯ã€é †åºã¯å±¥è¡Œã¾ãŸã¯ POS é †åºã‚’ä½œæˆã—ã¾ã™ã€‚<p><b>ç·¨é›†/æ–°ã—ã„é †åº-> é …ç›®æ³¨æ–‡-> æ³¨æ–‡</b>',0),(448736,12465,'pt','Para inserir um desconto em um cliente ordem criar um cumprimento ou POS ordem no:<p><b>Ordens-> Item ordens-> novo/editar ordem</b>',0),(448737,12465,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ ÑÐºÐ¸Ð´ÐºÑƒ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð·Ð°ÐºÐ°Ð· ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¸Ð»Ð¸ POS Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ð²:<p><b>Ð—Ð°ÐºÐ°Ð·Ñ‹-> Ð¿ÑƒÐ½ÐºÑ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²-> Ð½Ð¾Ð²Ñ‹Ðµ Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·</b>',0),(448738,12465,'es','Para entrar un descuento para un orden de cliente crea un Orden de Cumplimiento o PDV en: <p><b>Ordenes -> Odenes de Items -> Nuevo/Editar</b>',0),(448739,12465,'de','Um einen Rabatt auf einen Kunden geben Ordnung zu schaffen eine ErfÃ¼llung oder POS bestellen:<p><b>Bestellungen-> Element Bestellungen-> Reihenfolge neu/bearbeiten</b>',0),(448740,12465,'en','To enter a discount on a customer order create a Fulfillment or POS Order in:  <p><b>Orders -> Item Orders -> New/Edit Order</b>',0),(448741,12466,'is','',0),(448742,12466,'dr','',0),(448743,12466,'pr','',0),(448744,12466,'tr','',0),(448745,12466,'pl','',0),(448746,12466,'bg','',0),(448747,12466,'ur','',0),(448748,12466,'sr','',0),(448749,12466,'vi','',0),(448750,12466,'af','',0),(448751,12466,'ro','',0),(448752,12466,'et','',0),(448753,12466,'si','',0),(448754,12466,'ba','',0),(448755,12466,'nl','',0),(448756,12466,'fi','',0),(448757,12466,'no','',0),(448758,12466,'da','',0),(448759,12466,'ko','',0),(448760,12466,'he','',0),(448761,12466,'el','',0),(448762,12466,'zh','',0),(448763,12466,'sv','',0),(448764,12466,'it','',0),(448765,12466,'tl','',0),(448766,12466,'th','',0),(448767,12466,'hi','',0),(448768,12466,'ms','',0),(448769,12466,'ar','',0),(448770,12466,'fr','',0),(448771,12466,'jp','',0),(448772,12466,'pt','',0),(448773,12466,'ru','',0),(448774,12466,'es','',0),(448775,12466,'de','',0),(448776,12466,'en','',0),(448777,12467,'is','',0),(448778,12467,'dr','',0),(448779,12467,'pr','',0),(448780,12467,'tr','',0),(448781,12467,'pl','',0),(448782,12467,'bg','',0),(448783,12467,'ur','',0),(448784,12467,'sr','',0),(448785,12467,'vi','',0),(448786,12467,'af','',0),(448787,12467,'ro','',0),(448788,12467,'et','',0),(448789,12467,'si','',0),(448790,12467,'ba','',0),(448791,12467,'nl','',0),(448792,12467,'fi','',0),(448793,12467,'no','',0),(448794,12467,'da','',0),(448795,12467,'ko','',0),(448796,12467,'he','',0),(448797,12467,'el','',0),(448798,12467,'zh','',0),(448799,12467,'sv','',0),(448800,12467,'it','',0),(448801,12467,'tl','',0),(448802,12467,'th','',0),(448803,12467,'hi','',0),(448804,12467,'ms','',0),(448805,12467,'ar','',0),(448806,12467,'fr','',0),(448807,12467,'jp','',0),(448808,12467,'pt','',0),(448809,12467,'ru','',0),(448810,12467,'es','',0),(448811,12467,'de','',0),(448812,12467,'en','',0),(448813,12468,'is','',0),(448814,12468,'dr','',0),(448815,12468,'pr','',0),(448816,12468,'tr','',0),(448817,12468,'pl','',0),(448818,12468,'bg','',0),(448819,12468,'ur','',0),(448820,12468,'sr','',0),(448821,12468,'vi','',0),(448822,12468,'af','',0),(448823,12468,'ro','',0),(448824,12468,'et','',0),(448825,12468,'si','',0),(448826,12468,'ba','',0),(448827,12468,'nl','',0),(448828,12468,'fi','',0),(448829,12468,'no','',0),(448830,12468,'da','',0),(448831,12468,'ko','',0),(448832,12468,'he','',0),(448833,12468,'el','',0),(448834,12468,'zh','',0),(448835,12468,'sv','',0),(448836,12468,'it','',0),(448837,12468,'tl','',0),(448838,12468,'th','',0),(448839,12468,'hi','',0),(448840,12468,'ms','',0),(448841,12468,'ar','',0),(448842,12468,'fr','',0),(448843,12468,'jp','',0),(448844,12468,'pt','',0),(448845,12468,'ru','',0),(448846,12468,'es','',0),(448847,12468,'de','',0),(448848,12468,'en','',0),(448849,12469,'is','',0),(448850,12469,'dr','',0),(448851,12469,'pr','',0),(448852,12469,'tr','',0),(448853,12469,'pl','',0),(448854,12469,'bg','',0),(448855,12469,'ur','',0),(448856,12469,'sr','',0),(448857,12469,'vi','',0),(448858,12469,'af','',0),(448859,12469,'ro','',0),(448860,12469,'et','',0),(448861,12469,'si','',0),(448862,12469,'ba','',0),(448863,12469,'nl','',0),(448864,12469,'fi','',0),(448865,12469,'no','',0),(448866,12469,'da','',0),(448867,12469,'ko','',0),(448868,12469,'he','',0),(448869,12469,'el','',0),(448870,12469,'zh','',0),(448871,12469,'sv','',0),(448872,12469,'it','',0),(448873,12469,'tl','',0),(448874,12469,'th','',0),(448875,12469,'hi','',0),(448876,12469,'ms','',0),(448877,12469,'ar','',0),(448878,12469,'fr','',0),(448879,12469,'jp','',0),(448880,12469,'pt','',0),(448881,12469,'ru','',0),(448882,12469,'es','',0),(448883,12469,'de','',0),(448884,12469,'en','',0),(448885,12470,'is','',0),(448886,12470,'dr','',0),(448887,12470,'pr','',0),(448888,12470,'tr','',0),(448889,12470,'pl','',0),(448890,12470,'bg','',0),(448891,12470,'ur','',0),(448892,12470,'sr','',0),(448893,12470,'vi','',0),(448894,12470,'af','',0),(448895,12470,'ro','',0),(448896,12470,'et','',0),(448897,12470,'si','',0),(448898,12470,'ba','',0),(448899,12470,'nl','',0),(448900,12470,'fi','',0),(448901,12470,'no','',0),(448902,12470,'da','',0),(448903,12470,'ko','',0),(448904,12470,'he','',0),(448905,12470,'el','',0),(448906,12470,'zh','',0),(448907,12470,'sv','',0),(448908,12470,'it','',0),(448909,12470,'tl','',0),(448910,12470,'th','',0),(448911,12470,'hi','',0),(448912,12470,'ms','',0),(448913,12470,'ar','',0),(448914,12470,'fr','',0),(448915,12470,'jp','',0),(448916,12470,'pt','',0),(448917,12470,'ru','',0),(448918,12470,'es','',0),(448919,12470,'de','',0),(448920,12470,'en','',0),(448921,12471,'is','',0),(448922,12471,'dr','',0),(448923,12471,'pr','',0),(448924,12471,'tr','',0),(448925,12471,'pl','',0),(448926,12471,'bg','',0),(448927,12471,'ur','',0),(448928,12471,'sr','',0),(448929,12471,'vi','',0),(448930,12471,'af','',0),(448931,12471,'ro','',0),(448932,12471,'et','',0),(448933,12471,'si','',0),(448934,12471,'ba','',0),(448935,12471,'nl','',0),(448936,12471,'fi','',0),(448937,12471,'no','',0),(448938,12471,'da','',0),(448939,12471,'ko','',0),(448940,12471,'he','',0),(448941,12471,'el','',0),(448942,12471,'zh','',0),(448943,12471,'sv','',0),(448944,12471,'it','',0),(448945,12471,'tl','',0),(448946,12471,'th','',0),(448947,12471,'hi','',0),(448948,12471,'ms','',0),(448949,12471,'ar','',0),(448950,12471,'fr','',0),(448951,12471,'jp','',0),(448952,12471,'pt','',0),(448953,12471,'ru','',0),(448954,12471,'es','',0),(448955,12471,'de','',0),(448956,12471,'en','',0),(448957,12472,'is','',0),(448958,12472,'dr','',0),(448959,12472,'pr','',0),(448960,12472,'tr','',0),(448961,12472,'pl','',0),(448962,12472,'bg','',0),(448963,12472,'ur','',0),(448964,12472,'sr','',0),(448965,12472,'vi','',0),(448966,12472,'af','',0),(448967,12472,'ro','',0),(448968,12472,'et','',0),(448969,12472,'si','',0),(448970,12472,'ba','',0),(448971,12472,'nl','',0),(448972,12472,'fi','',0),(448973,12472,'no','',0),(448974,12472,'da','',0),(448975,12472,'ko','',0),(448976,12472,'he','',0),(448977,12472,'el','',0),(448978,12472,'zh','',0),(448979,12472,'sv','',0),(448980,12472,'it','',0),(448981,12472,'tl','',0),(448982,12472,'th','',0),(448983,12472,'hi','',0),(448984,12472,'ms','',0),(448985,12472,'ar','',0),(448986,12472,'fr','',0),(448987,12472,'jp','',0),(448988,12472,'pt','',0),(448989,12472,'ru','',0),(448990,12472,'es','',0),(448991,12472,'de','',0),(448992,12472,'en','',0),(448993,12473,'is','',0),(448994,12473,'dr','.Ù…Ø³ÛŒØ± Ø²ÛŒØ±Ø±Ø§Ø¨Ø±ÙˆÛŒØ¯:Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ… ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø´Ø±Ú©Øª.Ú¯Ø²ÛŒÙ†Ù‡ Ø®ÙˆØ¯ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÛŒ Ø¨ÛŒØ¬Ú©. ',0),(448995,12473,'pr','Ø¨Ø±Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø³Ø¨Ú© Ù‡Ø§ÛŒ Ù…Ø®ØªÙ„Ù ÙØ§Ú©ØªÙˆØ±.Ù…Ø³ÛŒØ± Ø²ÛŒØ±Ø±Ø§Ø¨Ø±ÙˆÛŒØ¯:Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ… ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø´Ø±Ú©Øª.Ú¯Ø²ÛŒÙ†Ù‡ Ø®ÙˆØ¯ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÛŒ ÙØ§Ú©ØªÙˆØ±. ',0),(448996,12473,'tr','FarklÄ± fatura stiller arasÄ±ndan seÃ§mek iÃ§in gidin<p><b>YÃ¶netici Kurulumu-fatura ÅŸirket seÃ§enekleri->-></b><p>\'<i>Fatura biÃ§imlendirmeyi</i>.\' yanÄ±nda seÃ§iminizi yapÄ±n',0),(448997,12473,'pl','Wybierz z rÃ³Å¼nych stylÃ³w faktury, przejdÅº do<p><b>Admin->-> firmy opcje konfiguracji rozliczeÅ„</b><p>WybÃ³r obok \"<i>Formatowanie faktury</i>.\"',0),(448998,12473,'bg','Ð—Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¾Ñ‚ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð¸ ÑÑ‚Ð¸Ð»Ð¾Ð²Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð¾Ñ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð°<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¾Ð¿Ñ†Ð¸Ð¸</b><p>Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ²Ð¾Ñ Ð¸Ð·Ð±Ð¾Ñ€ Ð',0),(448999,12473,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù„ÛØ¬Û’ Ø³Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¬Ø§Ù†Ø§<p><b>Ø§ÛŒÚˆÙ…Ù† Ø³ÛŒÙ¹ Ø§Ù¾-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª->-></b><p>\'<i>Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ÙˆØ¶Ø¹ Ú©Ø§Ø±ÛŒ</i>.\' Ú©Û’ Ù¾Ø§Ø³ Ø§Ù¾Ù†ÛŒ Ù¾Ø³Ù†Ø¯ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(449000,12473,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸ Ð¸Ð· Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð¸Ñ‚Ð¸Ñ… ÑÑ‚Ð¸Ð»Ð¾Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ, Ð¸Ð´Ð¸Ñ‚Ðµ Ð½Ð°<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ-Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ</b><p>Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð’Ð°Ñˆ Ð¸Ð·Ð±Ð¾Ñ€ Ð¿Ð¾Ñ€ÐµÐ´<i>ÐžÐ',0),(449001,12473,'vi','Äá»ƒ chá»n nhá»¯ng kiá»ƒu hÃ³a Ä‘Æ¡n khÃ¡c nhau, thÃ¬ vÃ o : quáº£n lÃ½-> thiáº¿t láº­p thanh toÃ¡n-> Ä‘iá»u khoáº£n cÃ´ng ty-> chá»n lá»±a chá»n bÃªn cáº¡nh Ä‘á»‹nh dáº¡ng hÃ³a Ä‘Æ¡n',0),(449002,12473,'af','Om te kies uit verskillende style van die faktuur, gaan na<p><b>Admin-> opstel-fakturering-> maatskappy opsies</b><p>Kies jou keuse langs die \'<i>Faktuur formatering</i>.\'',0),(449003,12473,'ro','Pentru a selecta din diferite stiluri de facturÄƒ, du-te la<p><b>Admin-> Setup-facturare-> opÅ£iuni de companie</b><p>SelectaÅ£i alegere alÄƒturi de \"<i>FacturÄƒ formatare</i>.\"',0),(449004,12473,'et','Saate valida erinevaid arve stiile, Mine<p><b>Admin-> Setup-arved-> firma Valikud</b><p>Valige oma valiku kÃµrval \"<i>Arve vormingu</i>.\"',0),(449005,12473,'si','Izberite iz razliÄnih stilov raÄun, pojdite na<p><b>Admin-> Setup-zaraÄunavanje-> podjetje moÅ¾nosti</b><p>Izberite vaÅ¡ izbira zraven \"<i>Oblikovanje raÄuna</i>.\"',0),(449006,12473,'ba','Untuk memilih dari berbagai gaya faktur, pergi ke<p><b>Admin-> Setup-penagihan-> pilihan perusahaan</b><p>Pilih pilihan Anda selain \'<i>Format faktur</i>.\'',0),(449007,12473,'nl','Om te selecteren uit verschillende stijlen van de factuur, ga naar<p><b>Admin-> Setup-Billing-> bedrijf opties</b><p>Maak uw keuze naast \'<i>Factuur opmaak</i>.\'',0),(449008,12473,'fi','Jos haluat valita eri laskun tyylejÃ¤, siirry<p><b>Admin asetukset-laskutus-> yhtiÃ¶lle vaihtoehtoja-></b><p>Valitse valintasi vieressÃ¤ \"<i>Laskun muotoilut</i>.\"',0),(449009,12473,'no','For Ã¥ velge fra ulike faktura stiler, gÃ¥ til<p><b>Admin-> Setup-fakturering-> selskapet alternativer</b><p>Velg ved \'<i>Faktura formatering</i>.',0),(449010,12473,'da','For at vÃ¦lge fra forskellige faktura stilarter, gÃ¥ til<p><b>Admin-> Setup-fakturering-> selskab indstillinger</b><p>VÃ¦lg dit valg ved siden af Â«<i>Faktura formatering</i>.Â»',0),(449011,12473,'ko','ë‹¤ë¥¸ ì†¡ìž¥ ìŠ¤íƒ€ì¼ì„ ì„ íƒ.<p><b>ê´€ë¦¬ìž ì„¤ì •-ê²°ì œ íšŒì‚¬ ì˜µì…˜->-></b><p><i>ì†¡ìž¥ ì„œì‹</i>.\' ì˜†ì— ë‹¹ì‹ ì˜ ì„ íƒ',0),(449012,12473,'he','×›×“×™ ×œ×‘×—×•×¨ ×ž×ª×•×š ×¡×’× ×•× ×•×ª ×©×•× ×™× ×©×œ ×—×©×‘×•× ×™×ª, ×œ×œ×›×ª<p><b>Admin-> ×”×”×ª×§× ×”-×—×™×•×‘-> ××¤×©×¨×•×™×•×ª ×”×—×‘×¨×”</b><p>×‘×—×¨ ××ª ×”×‘×—×™×¨×” ×©×œ×š ×œ×¦×“ \'<i>×¢×™×¦×•×‘ ×—×©×‘×•× ×™×ª</i>\'.',0),(449013,12473,'el','Î“Î¹Î± Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î±Ï€ÏŒ Ï„Î¹Ï‚ Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÎ­Ï‚ Î¼Î¿ÏÏ†Î­Ï‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…, Ï€Î¿Ï… Ï€Î¬ÎµÎ¹ Î½Î±<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚-> ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚</b><p>Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ ÎµÏ€Î',0),(449014,12473,'zh','è¦ä»Žä¸åŒå‘ç¥¨é£Žæ ¼ä¸­é€‰æ‹©ï¼Œåˆ°ï¼šç®¡ç†->è®¾ç½®å…¥è´¦->å…¬å¸é€‰é¡¹\r\nåœ¨â€œå‘ç¥¨æ ¼å¼åŒ–â€æ—é€‰æ‹©æ‚¨çš„æ”¯ç¥¨',0),(449015,12473,'sv','Om du vill vÃ¤lja olika faktura stilar, gÃ¥ till<p><b>Admin-> Setup-fakturering-> fÃ¶retag alternativ</b><p>Markera ditt val bredvid \"<i>Faktura formatering</i>.\"',0),(449016,12473,'it','Per selezionare da stili diversi di fattura, andare a<p><b>Admin->-> azienda opzioni Setup-fatturazione</b><p>Seleziona la tua scelta al lato \'<i>Fattura formattazione</i>\'.',0),(449017,12473,'tl','',0),(449018,12473,'th','à¹€à¸¥à¸·à¸­à¸ à¸£à¸¹à¸›à¹à¸šà¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸à¸±à¸™à¹„à¸›<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™->à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸šà¸£à¸´à¸©à¸±à¸—</b><p>à¹€à¸¥à¸·à¸­à¸à¸•à¸±à¸§à¹€à¸¥à',0),(449019,12473,'hi','à¤¸à¥‡ à¤…à¤²à¤— à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¶à¥ˆà¤²à¤¿à¤¯à¥‹à¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤œà¤¾à¤¨à¥‡<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª-à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¤¿à¤•à¤²à¥à¤ª->-></b><p>à¤¬à¤—à¤² à¤®à¥‡à¤‚ ',0),(449020,12473,'ms','Untuk memilih dari gaya invois yang berbeza, pergi ke<p><b>Admin-> persediaan-bil-> Opsyen Syarikat</b><p>Pilih pilihan anda di sebelah \'<i>Invois pemformatan</i>.\'',0),(449021,12473,'ar','Ù„ØªØ­Ø¯ÙŠØ¯ Ù…Ù† Ø£Ù†Ù…Ø§Ø· Ù…Ø®ØªÙ„ÙØ© Ù…Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø©ØŒ Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ©</b><p>Ø­Ø¯Ø¯ Ø§Ø®ØªÙŠØ§Ø±Ùƒ Ø¨Ø¬ÙˆØ§Ø± \'<i>ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„ÙØ§ØªÙˆØ±Ø©</i>\'.',0),(449022,12473,'fr','Pour sÃ©lectionner parmi les diffÃ©rents styles de facture, aller Ã <p><b>Admin-> Setup-facturation-> Options de la sociÃ©tÃ©</b><p>SÃ©lectionnez votre choix Ã  cÃ´tÃ© de Â«<i>Facture de mise en forme</i>. Â»',0),(449023,12473,'jp','è«‹æ±‚æ›¸ã®ç•°ãªã‚‹ã‚¹ã‚¿ã‚¤ãƒ«ã‹ã‚‰é¸æŠžã™ã‚‹ã«è¡Œã<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è«‹æ±‚ä¼šç¤¾ã‚ªãƒ—ã‚·ãƒ§ãƒ³->-></b><p>\'<i>è«‹æ±‚æ›¸æ›¸å¼</i>\' ã®æ¨ªã«ã‚ã‚‹ã‚’é¸æŠžã—ã¾ã™',0),(449024,12473,'pt','Para selecionar diferentes estilos de factura, ir para<p><b>Admin-> Setup-faturamento-> opÃ§Ãµes de empresa</b><p>Seleccione a sua escolha ao lado de \'<i>Factura de formataÃ§Ã£o</i>\'.',0),(449025,12473,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¸Ð· Ñ€Ð°Ð·Ð½Ñ‹Ñ… ÑÑ‚Ð¸Ð»ÐµÐ¹, Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹, Ð¿ÐµÑ€ÐµÐ¹Ð´Ð¸Ñ‚Ðµ Ðº<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³-> ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚Ñ‹</b><p>Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð²Ð°Ñˆ Ð²Ñ‹Ð±Ð¾Ñ€ Ñ€ÑÐ´Ð¾Ð¼ Ñ ',0),(449026,12473,'es','Para seleccionar de estilos diferentes de facturas, va a: FacturaciÃ³n -> Opciones de la Empresa</b><p>Hace su selecciÃ³nal lado de \'<i>Formato de Facturas</i>.\'',0),(449027,12473,'de','Rechnung-Stilen auswÃ¤hlen, gehen Sie zu<p><b>Admin-> Setup-Billing-> Firma Optionen</b><p>WÃ¤hlen Sie Ihre Wahl neben \"<i>Formatierung Rechnung</i>.\"',0),(449028,12473,'en','To select from different Invoice styles, go to<p><b>Admin -> Setup-Billing -> Company Options</b><p>Select your choice beside \'<i>Invoice Formatting</i>.\'',0),(449029,12474,'is','',0),(449030,12474,'dr','.Ø¨Ø±Ø§ÛŒ Ú©Ø³Ø¨ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ±Ø¯Ø± Ù…ÙˆØ±Ø¯ ØªÙØ§ÙˆØª Ø¨ÛŒÙ† Ø±ÙˆØ´Ù‡Ø§ÛŒ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ù†Ù‚Ø¯ÛŒ Ùˆ ØªØ¹Ù‡Ø¯ÛŒ Ø§ÛŒÙ† ØªØ§Ù¾ÛŒÚ© Ø±Ø§Ù‡Ù†Ù…Ø§ Ø±',0),(449031,12474,'pr','Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ÛŒÚ© Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¨Ø±Ø§ Ø§Ø³Ø§Ø³ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ ØªØ¹Ù‡Ø¯ÛŒ Ø§Ø³Øª .Ø¨Ø±Ø§ÛŒ Ú©Ø³Ø¨ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ±Ø¯Ø± Ù…ÙˆØ±Ø¯ ØªÙØ§ÙˆØª Ø¨ÛŒÙ† Ø±ÙˆØ´Ù‡Ø§ÛŒ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ù†Ù‚Ø¯ÛŒ Ùˆ ØªØ¹Ù‡Ø¯ÛŒ Ø§ÛŒÙ† ØªØ§Ù¾ÛŒÚ© Ø±Ø§Ù‡Ù†Ù…Ø§ Ø±Ø',0),(449032,12474,'tr','NolaPro gÃ¶re <b>tahakkuk</b> muhasebesi olduÄŸunu.<p>Nakit ve tahakkuk muhasebesi yÃ¶ntemleri arasÄ±ndaki fark hakkÄ±nda daha fazla bilgi iÃ§in bu YardÄ±m konusunda ziyaret edin.',0),(449033,12474,'pl','NolaPro jest <b>memoriaÅ‚owej</b> oparty.<p>Aby uzyskaÄ‡ wiÄ™cej informacji na temat rÃ³Å¼nicy miÄ™dzy gotÃ³wki i metody rachunkowoÅ›ci memoriaÅ‚owej OdwiedÅº w tym temacie pomocy.',0),(449034,12474,'bg','NolaPro Ðµ <b>Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½ÐµÑ‚Ð¾</b> Ð½Ð° Ð±Ð°Ð·Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾.<p>Ð—Ð° Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ñ‚Ð½Ð¾ÑÐ½Ð¾ Ñ€Ð°Ð·Ð»Ð¸ÐºÐ°Ñ‚Ð° Ð¼ÐµÐ¶Ð´Ñƒ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ Ð¸ Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´Ð½Ð¸Ñ‚Ðµ Ð¼ÐµÑ‚Ð¾Ð´Ð¸ ',0),(449035,12474,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ <b>Ø§Ú©Ú©Ø±ÙˆØ§Ù„</b> Ù¾Ø± Ù…Ø¨Ù†ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹Ù†Ú¯ ÛÛ’ Û”<p>Ù†Ù‚Ø¯ Ø§ÙˆØ± Ø§Ú©Ú©Ø±ÙˆØ§Ù„ Ø§Ú©Ø§Ø¤Ù†Ù¹Ù†Ú¯ Ø·Ø±ÛŒÙ‚ÙˆÚº Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† ÙØ±Ù‚ Ú©Û’ Ø¨Ø§Ø±Û’ Ù…ÛŒÚº Ù…Ø²ÛŒØ¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ù„Ø¦Û’ØŒ Ø§Ø³ Ù…Ø¯Ø¯ Ù…ÙˆØ¶ÙˆØ¹ Ø¯ÛŒÚ©Ú¾ÛŒÚ',0),(449036,12474,'sr','ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ñ˜Ðµ <b>Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°ÑšÐ°</b> Ð·Ð°ÑÐ½Ð¾Ð²Ð°Ð½ Ñ€Ð°Ñ‡ÑƒÐ½Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð°.<p>Ð—Ð° Ð²Ð¸ÑˆÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ Ñ‚Ð¾Ñ˜ Ñ€Ð°Ð·Ð»Ð¸Ñ†Ð¸ Ð¸Ð·Ð¼ÐµÑ’Ñƒ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ðµ Ð¸ Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°ÑšÐ° Ñ€Ð°Ñ‡ÑƒÐ½Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²ÐµÐ½Ðµ Ð¼ÐµÑ‚Ð¾Ð',0),(449037,12474,'vi','Nalo pro dá»±a vÃ o káº¿ toÃ¡n. Äá»ƒ biáº¿t thÃªm thÃ´ng tin vá» sá»± khÃ¡c biá»‡t giá»¯a tiá»n máº·t vÃ  phÆ°Æ¡ng phÃ¡p káº¿ toÃ¡n dá»“n tÃ­ch, hÃ£y truy cáº­p vÃ o chá»§ Ä‘á» trá»£ giÃºp nÃ y.',0),(449038,12474,'af','NolaPro is <b>aangroeiende</b> gebasseerde rekeningkunde.<p> Vir meer inligting omtrent die verskil tussen kontant en **** rekenkundige metodes, besoek hierdie hulp onderwerp.',0),(449039,12474,'ro','NolaPro este contabilitatea de <b>angajamente</b> baza.<p>Pentru mai multe informaÅ£ii despre diferenÅ£a dintre numerar ÅŸi metode de contabilitate angajamente, vizitaÅ£i acest subiect de ajutor.',0),(449040,12474,'et','NolaPro on <b>tekkepÃµhised</b> aluseks.<p>Lisateavet vahelt kassa- ja tekkepÃµhise raamatupidamisarvestuse meetodid kÃ¼lastada selle spikriteema.',0),(449041,12474,'si','NolaPro je obraÄunskem <b>odmerna</b> osnova.<p>ÄŒe Å¾elite veÄ informacij o razliki med denar in nastanka raÄunovodske metode, obiÅ¡Äite to temo pomoÄi.',0),(449042,12474,'ba','NolaPro adalah akuntansi <b>akrual</b> berbasis.<p>Untuk informasi lebih lanjut tentang perbedaan antara uang tunai dan metode akuntansi akrual, kunjungi topik bantuan ini.',0),(449043,12474,'nl','NolaPro is <b>Kostentoename</b> gebaseerd boekhouding.<p>Voor meer informatie over het verschil tussen contant geld en accrual accounting methoden, gaat u naar dit help-onderwerp.',0),(449044,12474,'fi','NolaPro on perustuu <b>suoriteperusteiseen</b> kirjanpitoon.<p>Ero rahaa ja suoriteperusteisen kirjanpidon menetelmÃ¤t, kÃ¤y tÃ¤ssÃ¤ ohjeaiheessa.',0),(449045,12474,'no','NolaPro er <b>kostnadsbelastning</b> basert regnskap.<p>For mer informasjon om forskjellen mellom penger og Periodisering Regnskap metoder, besÃ¸k dette hjelpeemnet.',0),(449046,12474,'da','NolaPro er <b>periodisering</b> baseret regnskab.<p>For mere information om forskellen mellem kontante og periodiserede regnskabsmetoder, besÃ¸g dette HjÃ¦lp-emne.',0),(449047,12474,'ko','NolaPro <b>ê³„ì‚°</b> ê¸°ë°˜ ê³„ì •ìž…ë‹ˆë‹¤.<p>í˜„ê¸ˆ ì ë¦½ íšŒê³„ ë°©ë²•ì˜ ì°¨ì´ì—ì´ ë„ì›€ë§ í•­ëª©ì„ ë°©ë¬¸.',0),(449048,12474,'he','NolaPro ×”×•× <b>×”×ª×©×œ×•×</b> ×ž×‘×•×¡×¡×ª ×—×©×‘×•× ××•×ª.<p>×œ×§×‘×œ×ª ×ž×™×“×¢ × ×•×¡×£ ××•×“×•×ª ×”×”×‘×“×œ ×‘×™×Ÿ ×©×™×˜×•×ª ×—×©×‘×•× ××™×•×ª ×”×ª×©×œ×•× ×‘×ž×–×•×ž×Ÿ, ×‘×§×¨ ×‘× ×•×©× ×¢×–×¨×” ×–×”.',0),(449049,12474,'el','NolaPro ÎµÎ¯Î½Î±Î¹ <b>Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚ ÏƒÎµ Î´ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Î·</b> Î²Î¬ÏƒÎ·.<p>Î“Î¹Î± Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î· Î´Î¹Î±Ï†Î¿ÏÎ¬ Î¼ÎµÏ„Î±Î¾Ï Î¼ÎµÏ„ÏÎ·Ï„Î¬ ÎºÎ±Î¹ Ï„Î¹Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ­Ï‚ Î¼ÎµÎ¸ÏŒ',0),(449050,12474,'zh','NolaProæ˜¯åº”ç´¯è®¡æ•°ç›®ä¸ºåŸºç¡€çš„ä¼šè®¡è½¯ä»¶ï¼Œæ›´å¤šçŽ°é‡‘ä¸Žåº”ç´¯è®¡æŠ€æœ¯ä¼šè®¡æ–¹å¼çš„ä¸åŒï¼Œè¯·æŸ¥çœ‹http://help.nolapro.com/help.php?op=showt&topic_id=326\" target=\"_blank',0),(449051,12474,'sv','NolaPro Ã¤r <b>periodiserad</b> baserad redovisning.<p>FÃ¶r mer information om skillnaden mellan kontant och periodiserad redovisningsmetoder, besÃ¶k hÃ¤r hjÃ¤lpavsnittet.',0),(449052,12474,'it','NolaPro Ã¨ contabilitÃ  <b>per competenza</b> basato.<p>Per ulteriori informazioni sulla differenza tra cash e metodi di contabilitÃ  per competenza, visita questo argomento della guida.',0),(449053,12474,'tl','',0),(449054,12474,'th','NolaPro à¹€à¸›à¹‡à¸™à¸šà¸±à¸à¸Šà¸µ<b>à¸„à¹‰à¸²à¸‡à¸£à¸±à¸šà¸„à¹‰à¸²à¸‡à¸ˆà¹ˆà¸²à¸¢</b>à¸•à¸²à¸¡<p>à¸ªà¸³à¸«à¸£à¸±à¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¹€à¸à¸µà¹ˆà¸¢à¸§à¸à¸±à¸šà¸„à¸§à¸²à¸¡à¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¹€à¸‡à¸´à¸™',0),(449055,12474,'hi','NolaPro <b>à¤ªà¥à¤°à¥‹à¤¦à¥à¤­à¤µà¤¨</b> à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤²à¥‡à¤–à¤¾à¤‚à¤•à¤¨ à¤¹à¥ˆà¥¤<p>à¤¨à¤•à¤¦ à¤”à¤° à¤ªà¥à¤°à¥‹à¤¦à¥à¤­à¤µà¤¨ à¤²à¥‡à¤–à¤¾ à¤µà¤¿à¤§à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¬à¥€à¤š à¤…à¤‚à¤¤à¤° à¤ªà¤° à¤…à¤§à¤¿à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ ',0),(449056,12474,'ms','NolaPro ialah perakaunan berasaskan <b>akruan</b> .<p>Untuk maklumat lanjut tentang perbezaan di antara kaedah-kaedah perakaunan akruan dan tunai, lawati topik bantuan ini.',0),(449057,12474,'ar','Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ù‡Ùˆ Ø§Ù„Ù…Ø­Ø§Ø³Ø¨Ø© Ø¹Ù„Ù‰ <b>Ø£Ø³Ø§Ø³ Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚</b> Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³.<p>Ù„Ù…Ø²ÙŠØ¯ Ù…Ù† Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø­ÙˆÙ„ Ø§Ù„ÙØ±Ù‚ Ø¨ÙŠÙ† Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© ÙˆØ£Ø³Ø§Ù„ÙŠØ¨ Ø§Ù„Ù…Ø­Ø§Ø³Ø¨Ø© Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³ Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ØŒ Ø¨Ø²ÙŠØ§Ø±Ø© ',0),(449058,12474,'fr','NolaPro est la <b>comptabilitÃ© d\'exercice</b> basÃ© de la comptabilitÃ©.<p>Pour plus d\'informations sur la diffÃ©rence entre la trÃ©sorerie et des mÃ©thodes de comptabilitÃ© d\'exercice, consultez cette rubrique d\'aide.',0),(449059,12474,'jp','NolaPro ã¯<b>ç™ºç”Ÿä¸»ç¾©</b>ãƒ™ãƒ¼ã‚¹ã®ä¼šè¨ˆã§ã™ã€‚<p>ç¾é‡‘ã¨ç™ºç”Ÿä¸»ç¾©ä¼šè¨ˆæ‰‹æ³•ã®é•ã„ã®è©³ç´°ã«ã¤ã„ã¦ã¯ã€ã“ã®ãƒ˜ãƒ«ãƒ— ãƒˆãƒ”ãƒƒã‚¯ã‚’å‚ç…§ã—ã¦ãã ã•ã„ã€‚',0),(449060,12474,'pt','NolaPro Ã© a contabilidade de <b>exercÃ­cio</b> baseado.<p>Para obter mais informaÃ§Ãµes sobre a diferenÃ§a entre dinheiro e mÃ©todos de contabilidade de exercÃ­cio, visite este tÃ³pico da ajuda.',0),(449061,12474,'ru','NolaPro ÑÐ²Ð»ÑÐµÑ‚ÑÑ ÑƒÑ‡ÐµÑ‚ <b>Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ð¹</b> Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ.<p>Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾ Ñ€Ð°Ð·Ð½Ð¸Ñ†Ðµ Ð¼ÐµÐ¶Ð´Ñƒ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ñ‹Ð¼Ð¸ Ð¸ Ð¼ÐµÑ‚Ð¾Ð´Ñ‹ ÑƒÑ‡ÐµÑ‚Ð° Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð¿Ð¾ÑÐµÑ‚Ð¸Ñ‚Ðµ ÑÑ‚Ð¾Ñ‚ Ñ€Ð°',0),(449062,12474,'es','NolaPro es <b>contabilidad de valores devengados.<p> Para mÃ¡s informaciÃ³n sobre la diferencia entre los mÃ©todos de Contabilidad devengada y de efectivo, visita este topico de ayuda.',0),(449063,12474,'de','Artikel ist <b>Accrual</b> Basis Rechnungswesen.<p>Weitere Informationen Ã¼ber den Unterschied zwischen Geld und Accrual Accounting-Methoden finden Sie in diesem Hilfethema.',0),(449064,12474,'en','NolaPro is <b>accrual</b> based accounting.<p> For more information on the difference between cash and accrual accounting methods, visit this help topic.',0),(449065,12475,'is','',0),(449066,12475,'dr',': ',0),(449067,12475,'pr','Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ ÛŒÚ© Ø³ÙØ§Ø±Ø´ Ø¨Ø§Ø² Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø²Ù…Ø§Ù†ÛŒ Ú©Ù‡ Ø¯Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ø¯ Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÛŒØ¯Ú©Ù‡ Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ú©Ø§Ù…Ù„ Ø¨Ø§ Ø¢Ø®Ø±ÛŒÙ† Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¹Ù„Ø§Ù…Øª Ø®ÙˆØ±Ø¯Ù‡ Ø¨Ø§Ø´Ø¯: ',0),(449068,12475,'tr','Ne zaman sipariÅŸ gÃ¶sterildiÄŸi gibi ne zaman aÃ§Ä±k fatura edilmiÅŸtir, sipariÅŸ \'TamamlandÄ±\' son sevk irsaliyesi ile kutlandÄ± emin olun:<p><b>SipariÅŸ Ã¶ÄŸe sipariÅŸler gemi sipariÅŸ->-> git</b><p>SipariÅŸ tamamlandÄ± olarak iÅŸaretlenen bir kez o-ec',0),(449069,12475,'pl','Kiedy zamÃ³wienie jest pokazane, jak otworzyÄ‡ kiedy zostaÅ‚y rozliczone, upewnij siÄ™, Å¼e zamÃ³wienia zostaÅ‚ oznaczony jako \"Complete\" z ostatniej dostawy:<p><b>PrzejdÅº do zamÃ³wienia-> przedmiotu zamÃ³wienia-> statek zamÃ³wienia</b><p>Gdy zamÃ³wienie',0),(449070,12475,'bg','ÐšÐ¾Ð³Ð°Ñ‚Ð¾ ÐµÐ´Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ðµ Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½ ÐºÐ°Ñ‚Ð¾ Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ñ‚Ñ Ðµ Ð±Ð¸Ð»Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð°, ÑÐµ ÑƒÐ²ÐµÑ€ÐµÑ‚Ðµ, Ñ‡Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ðµ Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ð¾ ÐºÐ°Ñ‚Ð¾ \"ÐŸÑŠÐ»Ð½Ð°\" Ñ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÐµÐºÑ',0),(449071,12475,'ur','Ø¬Ø¨ Ø§ÛŒÚ© Ø­Ú©Ù… ÛÛ’ Ø¯Ú©Ú¾Ø§ÛŒØ§ Ú¯ÛŒØ§ Ø¬Ø¨ Ú©Ú¾ÙˆÙ„Ù†Û’ Ù¾Ø± Ø¨Ø§Ù„Ù„Ø§Ø¯ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ØŒ ØªØ±ØªÛŒØ¨ ØªÚ¾Ø§ Ø§Ø³Ú©Ùˆ \'Ù…Ú©Ù…Ù„ Ø·ÙˆØ± Ù¾Ø±\' Ú©Û’ Ø³Ø§ØªÚ¾ Ø¢Ø®Ø±ÛŒ Ú©Ú¾ÛŒÙ¾ ÛŒÙ‚ÛŒÙ†ÛŒ Ø¨Ù†Ø§Ø¦ÛŒÚº:<p><b>Ø¬ÛØ§Ø² Ú©Û’ Ø­Ú©Ù…-> Ø´Û’ Ú©Û’ Ø§Ø­Ú©Ø§Ù',0),(449072,12475,'sr','ÐšÐ°Ð´Ð° Ñ˜Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½ ÐºÐ°Ð¾ ÐºÐ°Ð´Ð° Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ð° Ñ‚Ð¾ Ñ˜Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ð°, Ð¿Ð¾ÑÑ‚Ð°Ñ€Ð°Ñ˜ ÑÐµ Ð´Ð° Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ Ð±Ð¸Ð¾ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½ ÐºÐ°Ð¾\'Ð”Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾\' ÑÐ° Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐ° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°:<p><b>Ð£ Ñ€Ðµ',0),(449073,12475,'vi','Khi thá»© tá»± Ä‘Æ°á»£c hiá»ƒn thá»‹ nhÆ° má»Ÿ khi Ä‘Æ°á»£c ÄÆ°á»£c quáº£ng cÃ¡o, Ä‘áº£m báº£o thá»© tá»± Ä‘Æ°á»£c Ä‘Ã¡nh dáº¥u lÃ  \'hoÃ n thÃ nh\' vá»›i cÃ¡c lÃ´ hÃ ng cuá»‘i cÃ¹ng. ÄÆ¡n Ä‘áº·t hÃ ng-> Ä‘Æ¡n Ä‘áº·t hÃ ng sáº£n pháº©m-> xuáº¥t Ä‘Æ¡n hÃ n',0),(449074,12475,'af','Wanneer \'n bestelling is getoon as oop wanneer dit het weerspieÃ«l is, maak seker dat die bestelling was gemerk as \'Voltooi\' met die laaste verskeping:<p><b>Gaan na orde-> Item bestellings-> skip orde</b><p>Sodra die bevel het gemerk is as voltooi sal dit',0),(449075,12475,'ro','CÃ¢nd o comandÄƒ este indicat ca deschide atunci cÃ¢nd acesta a fost taxat, asiguraÅ£i-vÄƒ cÄƒ ordinul a fost marcat ca \"Complete\" cu ultima de expediere:<p><b>Du-te la ordinea-> element comenzi-> navÄƒ ordine</b><p>OdatÄƒ ce comanda a fost marcatÄƒ ca fi',0),(449076,12475,'et','Kuna tellimus on programmi avamisel kui seda arveldatud tellimus, veenduge, et tellimus oli mÃ¤rgitud \"Complete\" Viimane saadetis:<p><b>Mine tellimuse-> kauba tellimuste-> laevatellimuselt</b><p>Kui tellimus on mÃ¤rgitud lÃµpuleviiduks nÃ¤idatakse mingit ',0),(449077,12475,'si','Ko nalog je prikazan kot odprt, ko je bil zaraÄunani, preverite, ali vrstni red je bil oznaÄen kot \"Celoten\" s zadnji poÅ¡iljki:<p><b>Iti za-> element naroÄila-> dobave naloga</b><p>Ko vrstni red je bil oznaÄen kot zakljuÄen bo ne veÄ pokazati kot o',0),(449078,12475,'ba','Kapan pesanan ditampilkan sebagai terbuka ketika itu telah ditagih, pastikan urutan ditandai sebagai \'Complete\' dengan pengiriman terakhir:<p><b>Pergi ke urutan-> Item pesanan-> rangka kapal</b><p>Setelah pesanan telah ditandai sebagai selesai akan tidak ',0),(449079,12475,'nl','Wanneer een Order wordt getoond aangezien geopend wanneer het is gefactureerd, zorg ervoor dat de volgorde was gemarkeerd als \'Voltooid\' met de laatste verzending:<p><b>Ga naar de bestel-> Item Orders-> schip volgorde</b><p>Zodra de order is gemarkeerd al',0),(449080,12475,'fi','Kun tilaus nÃ¤kyy auki, kun se on laskutettu, varmista, ettÃ¤ tilaus oli merkitty valmiiksi\"Viimeinen lÃ¤hetys:<p><b>Siirry jÃ¤rjestyksessÃ¤-> kohteen tilauksia-> aluksen tilausmÃ¤Ã¤rÃ¤stÃ¤</b><p>Kun tilaus on merkitty valmiiksi se ei enÃ¤Ã¤ NÃ¤ytÃ¤ avoim',0),(449081,12475,'no','NÃ¥r en ordre er vist som Ã¥pen nÃ¥r det er fakturert, kontrollerer du at ordren ble markert som \'FullfÃ¸rt\' med den siste forsendelsen:<p><b>GÃ¥ til ordre-> element ordrer-> skip ordre</b><p>NÃ¥r ordren er merket som fullfÃ¸rt det vil ikke lenger vise so',0),(449082,12475,'da','NÃ¥r en ordre er vist som Ã¥bne nÃ¥r den er blevet faktureret, SÃ¸rg for, at ordren var markeret som \'Complete\' med den sidste leverance:<p><b>GÃ¥ til ordre-> vare ordrer-> skib rÃ¦kkefÃ¸lge</b><p>NÃ¥r ordren er blevet markeret som fuldfÃ¸rt det vil ikke ',0),(449083,12475,'ko','ì£¼ë¬¸ ë•Œ ì—´ë¡œ í‘œì‹œ í•˜ë©´ ì²­êµ¬ ë˜ì–´, ìˆœì„œëŠ” ë§ˆì§€ë§‰ ì„ ì  \'ì™„ë£Œ\'ë¡œ í‘œì‹œ ëœ ã„´ ë‹¤ëŠ” ê²ƒì„ í™•ì¸:<p><b>ë°° ìˆœì„œ-> í•­ëª© ìˆœì„œ-> ìˆœì„œì—ê°€ ì„œ</b><p>ì¼ë‹¨ ì£¼ë¬¸ ì™„ë£Œ ëœ ê²ƒìœ¼ë¡œ í‘œì‹œ ë˜ì—ˆìŠµë‹ˆë‹¤ ì˜¤í”ˆìœ¼ë¡œ ë” ',0),(449084,12475,'he','×›××©×¨ ×ž×•×¦×’ ×¤×§×•×“×” ×™×¤×ª×—×• ×ž×ª×™ ×–×” ×‘×¢×‘×•×¨×” ×—×™×•×‘, ×•×“× ×›×™ ×”×¦×• ×”×™×” ×ž×¡×•×ž×Ÿ ×‘×ª×•×¨ \'×”×©×œ×ž×”\' ×¢× ×”×ž×©×œ×•×— ×”××—×¨×•×Ÿ:<p><b>×‘×‘×§×©×”, ××œ-> ×¤×¨×™×˜ ×¤×§×•×“×•×ª-> ×¡×“×¨ ×”×¡×¤×™× ×”</b><p>×œ××—×¨ ×”×¦×•',0),(449085,12475,'el','ÎŒÏ„Î±Î½ ÎµÎ¼Ï†Î±Î½Î¯Î¶ÎµÏ„Î±Î¹ Î¼Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏŒÏ€Ï‰Ï‚ Î±Î½Î¿Î¯Î³ÎµÎ¹ ÏŒÏ„Î±Î½ Î­Ï‡ÎµÎ¹ Ï‡ÏÎµÏ‰Î¸ÎµÎ¯, Î²ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Ï‡Î±ÏÎ±ÎºÏ„Î·ÏÎ¯ÏƒÏ„Î·ÎºÎµ Ï‰Ï‚ Â«Î Î»Î®ÏÎ·Ï‚Â» Î¼Îµ Ï„Î·Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î',0),(449086,12475,'zh','å½“ä¸€ä¸ªè®¢å•æ˜¾ç¤ºä¸ºå…¬å¼€æ—¶ï¼Œå½“å…¶å·²å…¥è´¦ï¼Œç¡®ä¿è®¢å•å·²è¢«æ ‡è®°ä¸ºæœ‰æœ€åŽè£…è¿çš„â€œå®Œæˆâ€ã€‚åˆ°ï¼šè®¢å•->é¡¹ç›®è®¢å•->è£…è¿è®¢å•\r\nä¸€æ—¦è®¢å•è¢«æ ‡è®°ä¸ºå®Œæˆï¼Œå®ƒå°†ä¸å†æ˜¾ç¤ºä¸ºå…¬å¼€ã€‚',0),(449087,12475,'sv','NÃ¤r en Order visas som Ã¶ppnar nÃ¤r det har debiterats, se till att ordningen var markerad som \"Komplett\" med senaste leveransen:<p><b>GÃ¥r att bestÃ¤lla-> post order-> fartyget Order</b><p>NÃ¤r ordern har markerats som slutfÃ¶rd kommer det ingen lÃ¤ngre',0),(449088,12475,'it','Quando un ordine viene mostrato come aprire quando si Ã¨ stato fatturato, assicurarsi che l\'ordine Ã¨ stato contrassegnato come \'Completo\' con l\'ultima spedizione:<p><b>Vai all\'ordine-> gli ordini di voce-> ordine nave</b><p>Una volta che l\'ordine Ã¨ stat',0),(449089,12475,'tl','',0),(449090,12475,'th','à¹€à¸¡à¸·à¹ˆà¸­à¹à¸ªà¸”à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸›à¸´à¸”à¹€à¸¡à¸·à¹ˆà¸­à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¹„à¸”à¹‰ à¹ƒà¸«à¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸§à¹ˆà¸² à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸–à¸¹à¸à¸—à¸³à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸›à¹‡à¸™ \'à¸ªà¸¡à¸šà¸¹à¸£à¸“à¹',0),(449091,12475,'hi','à¤œà¤¬ à¤à¤• à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤–à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ à¤œà¤¬ à¤–à¥‹à¤²à¤¨à¥‡ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¯à¤¹ à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ, à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤¦à¥‡à¤¶ à¤…à¤‚à¤¤à¤¿à¤® à¤ªà¥‹à¤¤ à¤²à¤¦à',0),(449092,12475,'ms','Bilakah suatu perintah yang ditunjukkan sambil membuka apabila telah dibilkan, pastikan pesanan yang ditanda sebagai \'Complete\' dengan penghantaran terakhir:<p><b>Pergi ke perintah-> Item pesanan-> perintah kapal</b><p>Sebaik sahaja perintah yang telah di',0),(449093,12475,'ar','Ø¹Ù†Ø¯Ù…Ø§ ÙŠØªÙ… Ø¹Ø±Ø¶ Ø£Ù…Ø± ÙƒÙ…Ø§ ÙØªØ­ Ø¹Ù†Ø¯Ù…Ø§ ØªÙ…Øª ÙÙˆØªØ±ØªÙ‡ØŒ ØªØ£ÙƒØ¯ Ù…Ù† Ø§Ù„ØªØ±ØªÙŠØ¨ ØªÙ…ÙŠØ²Øª Ùƒ \'Ø§ÙƒØªÙ…Ø§Ù„\' Ù…Ø¹ Ø¢Ø®Ø± Ø´Ø­Ù†Ø©:<p><b>Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰ Ø§Ù„Ù†Ø¸Ø§Ù…-> Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø¯-> Ø£Ù…Ø± Ø§Ù„Ø³ÙÙŠÙ†Ø©</b><p>Ø¨Ù…Ø¬',0),(449094,12475,'fr','Lorsqu\'une ordonnance est dÃ©montrÃ©e comme ouvrir quand elle a Ã©tÃ© facturÃ©e, assurez-vous que l\'ordre a Ã©tÃ© marquÃ© comme Â« TerminÃ© Â» avec le dernier envoi :<p><b>Passez Ã  commande-> ordres point-> commande livraison</b><p>Une fois que l\'ordre a',0),(449095,12475,'jp','æ³¨æ–‡è¡¨ç¤ºã•ã‚Œã‚‹å ´åˆãŒé–‹ãã¨ãã«è«‹æ±‚ã•ã‚Œã¦ã€é †åº \'å®Œäº†\' ã¨ã—ã¦æœ€å¾Œã®å‡ºè·ãŒä»˜ã„ã¦ã„ãŸã“ã¨ã‚’ç¢ºèªã—ã¾ã™ã€‚<p><b>èˆ¹ã®é †åº-> é …ç›®æ³¨æ–‡-> ã‚ªãƒ¼ãƒ€ãƒ¼ã¸</b><p>é †åºã¯å®Œäº†ã¨ã—ã¦ãƒžãƒ¼ã‚¯ã•ã‚Œã¦ã„ã‚‹ä',0),(449096,12475,'pt','Quando uma ordem Ã© mostrada como aberto quando ele tem sido faturado, certifique-se que a ordem foi marcada como \'Complete\' com a Ãºltima remessa:<p><b>Ir para a ordem-> Item ordens-> ordem de navio</b><p>Uma vez que a ordem foi marcada como concluÃ­da n',0),(449097,12475,'ru','ÐšÐ¾Ð³Ð´Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½Ð¾, ÐºÐ°Ðº Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚ÑŒ, ÐºÐ¾Ð³Ð´Ð° Ð¾Ð½ Ð±Ñ‹Ð» Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½, ÑƒÐ±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾ Ð·Ð°ÐºÐ°Ð· Ð±Ñ‹Ð» Ð¿Ð¾Ð¼ÐµÑ‡ÐµÐ½ ÐºÐ°Ðº Â«ÐŸÐ¾Ð»Ð½Ð°ÑÂ» Ñ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ¹ Ð¿Ð°Ñ€Ñ‚Ð¸Ð¸:<p><b>ÐŸÐµÑ€ÐµÐ¹Ð´Ð¸Ñ‚Ðµ Ðº ',0),(449098,12475,'es','Cuando un orden se muestra como Abierto cuando estÃ¡ facturado, asegura que el Orden se marcÃ³ como \'completo\' con el ultimo envÃ­o:<p><b>Va a Orden -> Ordenes de Item -> Orden de EnvÃ­o</b><p>Una vez que el orden esta marcado como completo nunca mÃ¡s apa',0),(449099,12475,'de','Wenn eine Bestellung gezeigt wird, wie beim Ã–ffnen es hat in Rechnung gestellt wurden, stellen Sie sicher, dass die Reihenfolge wurde mit der letzten Lieferung als \'Complete\' markiert:<p><b>Gehen Sie auf Bestellung-> Element Bestellungen-> Schiff bestell',0),(449100,12475,'en','When an Order is shown as Open when it has been Billed, make sure the Order was marked as \'Complete\' with the last shipment:<p><b>Go to Order->Item Orders->Ship Order</b><p>Once the order has been marked as completed it will no longer show as Open.',0),(449101,12476,'is','',0),(449102,12476,'dr','/ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡ / Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ù…ØµØ±Ù: -> Ù…Ø¯ÛŒØ±ÛŒØª Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ - <P> Ø¨Ù‡ ADMIN <P> <B> Ø¨Ø±Ùˆ> Ø´Ø±Ú©Øª Ø¬Ø¯ÛŒØ¯ / Ø§ØµÙ„Ø§Ø­ Ø¨Ø±Ø±Ø³ÛŒ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡ Ùˆ...Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù…Ø§',0),(449103,12476,'pr','/ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡ / Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ù…ØµØ±Ù: -> Ù…Ø¯ÛŒØ±ÛŒØª Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ - <P> Ø¨Ù‡ ADMIN <P> <B> Ø¨Ø±Ùˆ> Ø´Ø±Ú©Øª Ø¬Ø¯ÛŒØ¯ / ÙˆÛŒØ±Ø§ÛŒØ´ Ø¨Ø±Ø±Ø³ÛŒ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡ Ùˆ...Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù…Ø§Ù',0),(449104,12476,'tr','GST-KDV-tÃ¼ketim vergileri:<p>Git<p><b>Admin-> Admin kurulumu-> ÅŸirket yeni/DÃ¼zenle</b><p>Check \'Set vergiler iÃ§in KDV/GST\'.<p>Vergileri ayarlayÄ±n:<p><b>YÃ¶netici Kurulumu-fatura satÄ±ÅŸ vergileri->-></b><p>\'TÃ¼ketim KDV vergisi gruplarÄ± Ekle/GÃ¼ncel',0),(449105,12476,'pl','Podatki VAT i GST/konsumpcji:<p>PrzejdÅº do<p><b>Admin-> konfiguracji Admin-> firmy nowy/edycja</b><p>SprawdÅº \"zestaw podatki VAT/GST\".<p>Konfigurowanie podatkÃ³w:<p><b>Admin-> instalacji Billing-> podatek</b><p>Kliknij \"Dodaj/zaktualizuj grupy pobÃ³r po',0),(449106,12476,'bg','Ð”Ð”Ð¡/GST/Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð»ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð´Ð°Ð½ÑŠÑ†Ð¸:<p>ÐžÑ‚Ð¸Ð´Ð¸ Ð½Ð°<p><b>Admin-> Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-> Ð½Ð¾Ð²Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ</b><p>ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ \"Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð·Ð° Ð”Ð”Ð¡/GST\".<p',0),(449107,12476,'ur','ÙˆØ§Ù¹/GST/Ú©Ú¾Ù¾Øª Ù¹ÛŒÚ©Ø³:<p>Ø¬Ø§Ø¤<p><b>Ø§ÛŒÚˆÙ…Ù† Admin Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Ù…Ù¾Ù†ÛŒ Ù†Ø¦ÛŒ/ØªØ±Ù…ÛŒÙ…->-></b><p>Ú†ÛŒÚ© \'Ø³ÛŒÙ¹ Ù¹ÛŒÚ©Ø³ ÙˆØ§Ù¹/GST Ú©Û’ Ù„ÛŒÛ’\' Û”<p>Ù¹ÛŒÚ©Ø³ Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº:<p><b>Ø§ÛŒÚˆÙ…Ù† Ø³ÛŒÙ¹ Ø§Ù¾-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø³ÛŒÙ„',0),(449108,12476,'sr','ÐŸÐ”Ð’ /Ð“Ð¡Ð¢ /Ð¿Ð¾Ñ‚Ñ€Ð¾ÑˆÑšÑƒ Ð¿Ð¾Ñ€ÐµÐ·:<p>Ð¿Ð¾Ñ’Ð¸ Ð´Ð¾<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ ÐÐ´Ð¼Ð¸Ð½ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ð¸ Ð½Ð¾Ð²Ð¸Ñ… ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ</b><p>ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ \'Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð·Ð° ÐŸÐ”Ð’/Ð“Ð¡Ð¢\'.<p>ÐŸÐ¾Ð´ÐµÑÐ¸Ñ‚Ðµ',0),(449109,12476,'vi','Thuáº¿ GTGT/GST/Thuáº¿ tiÃªu dÃ¹ng: quáº£n lÃ½-> thiáº¿t láº­p quáº£n lÃ½-> cÃ´ng ty má»›i/sá»­a, nháº¥p vÃ o thiáº¿t láº­p thuáº¿ GTGT/GST. Thiáº¿t láº­p thuáº¿:quáº£n lÃ½-thiáº¿t láº­p thanh toÃ¡n-thuáº¿ bÃ¡n hÃ ng. Nháº¥p vÃ o thÃªm/cáº­p nháº­t thuáº¿',0),(449110,12476,'af','BTW/Verkoopsbelasting/verbruik belasting:<p>Gaan na<p><b>Admin-> Admin opstelling-> nuwe maatskappy/redigeer</b><p>Kontroleer \'stel belastings vir BTW/Verkoopsbelasting\'.<p>Stel belasting:<p><b>Admin-> opstel-fakturering-> verkope belastings</b><p>Klik \'V',0),(449111,12476,'ro','Taxe de TVA/GST/consum:<p>du-te la<p><b>Admin->-Admin Setup-> noua companie/editare</b><p>Check \"impozitele stabilite pentru TVA/GST\".<p>Creat impozite:<p><b>Admin-> Setup-facturare-> taxa la vÃ¢nzÄƒri</b><p>FaceÅ£i clic pe \'Consumul TVA grupuri AdÄƒugaÅ£',0),(449112,12476,'et','KÃ¤ibemaks/GST/tarbimismaksudest:<p>Mine<p><b>Admin-> Admin seadistamine firma uus/Muuda-></b><p>Sisse \'kindlaksmÃ¤Ã¤ratud maksude mahaarvamist km\".<p>Maksude seadistamine<p><b>Admin-> seadistuse-arved kÃ¤ibemaksu-></b><p>KlÃµpsake kÃ¤ibemaksuga maksustam',0),(449113,12476,'si','GST/DDV/poraba davkov:<p>pojdi k<p><b>Admin-> Admin Setup-> podjetje novo/Uredi</b><p>ÄŒek \"nastavite davkov za DDV/GST\".<p>Nastavite davkov:<p><b>Admin-> Setup-zaraÄunavanje-> prodaji davkov</b><p>Kliknite \"Porabe DDV davka zdruÅ¾i Dodaj/posodobi\" Dodaj',0),(449114,12476,'ba','Pajak PPN/GST/konsumsi:<p>Pergi ke<p><b>Admin-> Admin Setup-> perusahaan baru/Edit</b><p>Check \'menetapkan pajak untuk PPN GST\'.<p>Mengatur pajak:<p><b>Admin-> Setup-penagihan-> pajak penjualan</b><p>Klik \'Konsumsi PPN kelompok menambahkan Update\' untuk m',0),(449115,12476,'nl','BTW/GST/verbruiksbelastingen:<p>Ga naar<p><b>Admin-> Admin Setup-> bedrijf nieuwe/bewerken</b><p>Selectievakje \'instellen belastingen voor btw/GST\'.<p>Belastingen instellen:<p><b>Admin-> Setup-Billing-> belastingen op de verkoop</b><p>Klik om de \'Consumpt',0),(449116,12476,'fi','ALV, GST, kulutus verot:<p>MennÃ¤<p><b>Admin Admin asetukset-> yrityksen uusi tai Muokkaa-></b><p>Uloskirjautuminen \"Aseta veroja ALV-tai GST\".<p>Verojen mÃ¤Ã¤rittÃ¤minen:<p><b>Admin-> mÃ¤Ã¤ritettÃ¤vÃ¤ laskutus-> arvonlisÃ¤verot</b><p>Klikkaa ALV kulutusv',0),(449117,12476,'no','MVA/GST/forbruk skatter:<p>gÃ¥ til<p><b>Admin-> Admin Setup-> selskapet ny/Rediger</b><p>Sjekk \"Angi skatt for mva/GST\".<p>Definere avgifter:<p><b>Admin-> Setup-fakturering-> merverdiavgift</b><p>Klikk \'Forbruk mva grupper Legg til/Oppdater\' for Ã¥ legge ',0),(449118,12476,'da','MOMS/GST/forbrugsafgifter:<p>GÃ¥ til<p><b>Admin-> Admin Setup-> selskab ny/Rediger</b><p>Check \'Set skatter for moms/GST\'.<p>OpsÃ¦tning af moms:<p><b>Admin-> Setup-fakturering-> moms</b><p>Klik pÃ¥ \'Forbrug moms Tax Groups TilfÃ¸j/opdater\' for at tilfÃ¸je',0),(449119,12476,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸/GST/ì†Œë¹„ ì„¸:<p>ë¡œ ê°€ë‹¤<p><b>ê´€ë¦¬ìž ì„¤ì¹˜ íšŒì‚¬ ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘->-> ê´€ë¦¬ìž</b><p>ì²´í¬ \' ì„¤ì •ëœ ì„¸ê¸ˆ ë¶€ê°€ ê°€ì¹˜ì„¸/gstê°€ ëŒ€ í•œ \'.<p>ì„¸ê¸ˆì„ ì„¤ì • í•©ë‹ˆë‹¤.<p><b>ì„¤ì¹˜-ê²°ì œ íŒë§¤ ì„¸ê¸ˆ->-> ê´€ë¦¬ìž',0),(449120,12476,'he','×ž×¢ ×ž/GST/×¦×¨×™×›×ª ×ž×™×¡×™×:<p>×œ×œ×›×ª ×œ<p><b>Admin-> ×ž× ×”×œ ×”×”×ª×§× ×”-> ×—×‘×¨×” ×—×“×©×”/×¢×¨×™×›×”</b><p>×”×¡×™×ž×•×Ÿ \'×§×‘×¢ ×ž×™×¡×™× ×¢×‘×•×¨ ×ž×¢ ×ž\'.<p>×”×’×“×¨×ª ×ž×™×¡×™×:<p><b>Admin-> ×”×”×ª×§× ×”-×—×™×•×‘-> ×ž×¢ ×ž</b><p>×œ×—×¥ ',0),(449121,12476,'el','Î¦Î Î‘/GST/ÎºÎ±Ï„Î±Î½Î¬Î»Ï‰ÏƒÎ· Ï†ÏŒÏÎ¿Ï…Ï‚:<p>Î Î®Î³Î±Î¹Î½Îµ ÏƒÏ„Î¿<p><b>Admin-> Admin Setup-> ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±</b><p>Î•Î»Î­Î³Ï‡Î¿Ï… Â«ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ Ï†ÏŒÏÎ¿Ï…Ï‚ Î¦Î Î‘/GSTÂ».<p>ÎŸÏÎ¯ÏƒÎµÏ„Îµ Ï„Î¿Ï…Ï‚ Ï†ÏŒÏ',0),(449122,12476,'zh','å¢žå€¼ç¨Ž/å•†å“æœåŠ¡ç¨Ž/æ¶ˆè´¹ç¨Žï¼šåˆ°ï¼šç®¡ç†->ç®¡ç†è®¾ç½®->å…¬å¸æ–°å¢ž/ç¼–è¾‘ã€‚é€‰ä¸­â€œè®¾ç½®ç¨Žæ”¶ä¸ºå¢žå€¼ç¨Žä¸ŽGSTâ€ã€‚è®¾ç½®ç¨Žæ”¶ï¼šç®¡ç†->è®¾ç½®å…¥è´¦->é”€å”®ç¨Ž\r\né€‰ä¸­â€œæ¶ˆè´¹å¢žå€¼ç¨Žç»„æ–°å¢ž/æ›´æ–°â€ä»¥æ–°å¢ž/ç¼–è¾‘ã€‚',0),(449123,12476,'sv','MOMS/GST/konsumtion skatter:<p>GÃ¥ till<p><b>Admin-> Admin instÃ¤llning-> fÃ¶retaget ny/redigera</b><p>Kryssrutan \"StÃ¤ll in skatter fÃ¶r moms/GST\".<p>StÃ¤lla in moms:<p><b>Admin-> Setup-fakturering-> moms</b><p>Klicka \"Konsumtion moms grupper LÃ¤gg till/',0),(449124,12476,'it','Tasse di IVA/GST/consumo:<p>Vai a<p><b>Admin-> Admin Setup-> azienda nuovo/modifica</b><p>Controllo \'tasse imposta per IVA/GST\'.<p>Impostare le imposte:<p><b>Admin-> Setup-fatturazione-> le imposte sulle vendite</b><p>Fare clic su \'Imposta di consumo IVA ',0),(449125,12476,'tl','',0),(449126,12476,'th','à¸ à¸²à¸©à¸µ VAT/GST/à¸›à¸£à¸´à¸¡à¸²à¸“ à¸à¸²à¸£à¹ƒà¸Šà¹‰:<p>à¸¥à¸¸à¸¢à¹€à¸¥à¸¢<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² Admin->à¸šà¸£à¸´à¸©à¸±à¸—à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚</b><p>à¸à¸²à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢ \'à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà',0),(449127,12476,'hi','VAT/GST/à¤–à¤ªà¤¤ à¤•à¤°à¥‹à¤‚:<p>à¤¯à¤¹à¤¾à¤ à¤œà¤¾à¤“<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¨à¤ˆ à¤•à¤‚à¤ªà¤¨à¥€/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨->-></b><p>à¤šà¥‡à¤• \'à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤¿à¤¤ à¤•à¤°à¥‹à¤‚ à¤•à¥‡ à¤²à',0),(449128,12476,'ms','Cukai VAT/GST/penggunaan:<p>pergi ke<p><b>Admin-> Admin persediaan-> syarikat baru/Edit</b><p>Semak \'Set cukai bagi VAT/GST\'.<p>Menyediakan cukai:<p><b>Admin-> persediaan-bil-> cukai jualan</b><p>Klik \'Cukai VAT penggunaan Kumpulan Tambah/Kemaskini\' untuk',0),(449129,12476,'ar','Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©/Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø³Ù„Ø¹ ÙˆØ§Ù„Ø®Ø¯Ù…Ø§Øª/Ø§Ù„Ø§Ø³ØªÙ‡Ù„Ø§Ùƒ:<p>Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ø¥Ù„Ù‰<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø´Ø±Ù-> Ø´Ø±ÙƒØ© Ø¬Ø¯ÙŠØ¯Ø©/ØªØ­Ø±ÙŠØ±</b><p>Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± \'Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø­Ø¯Ø¯Ø© ',0),(449130,12476,'fr','Taxes Ã  la TVA/TPS/consommation :<p>Atteindre<p><b>Admin-> Admin Setup-> sociÃ©tÃ© nouvelle/modifier</b><p>Cocher Â« Set impÃ´ts pour la TVA/TPS Â».<p>Mettre en place des taxes :<p><b>Admin-> Setup-facturation-> des Taxes de vente</b><p>Cliquez sur \' Ajo',0),(449131,12476,'jp','ä»˜åŠ ä¾¡å€¤ç¨Ž/GST/æ¶ˆè²»ç¨Ž:<p>è¡Œãã¾ã™<p><b>ç®¡ç†è€…ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ä¼šç¤¾ã€æ–°ã—ã„ç·¨é›†/->-></b><p>ãƒã‚§ãƒƒã‚¯ \' Set ç¨Žä»˜åŠ ä¾¡å€¤ç¨Ž/GST ã®ãŸã‚ \'ã€‚<p>ç¨Žé‡‘ã‚’è¨­å®šã—ã¾ã™ã€‚<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è«‹æ±‚ç¨Žé‡‘ã',0),(449132,12476,'pt','Taxas de IVA/GST/consumo:<p>Ir para<p><b>Admin-> Admin Setup-> nova empresa/editar</b><p>Â«Impostos conjunto de seleÃ§Ã£o de VAT/GSTÂ».<p>Configure os impostos:<p><b>Admin-> Setup-faturamento-> impostos sobre vendas</b><p>Clique em \' Adicionar/atualizar g',0),(449133,12476,'ru','ÐÐ°Ð»Ð¾Ð³Ð¸ ÐÐ”Ð¡/GST/Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð»ÐµÐ½Ð¸Ñ:<p>ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ðº<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸-> ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ/Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ</b><p>ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Â«ÑƒÑÑ‚Ð°Ð½Ð',0),(449134,12476,'es','VAT/IVA/Impuestos de ConsunciÃ³n: Va a<p><b>Admin -> Admin ConfiguraciÃ³n -> CofiguraciÃ³n FacturaciÃ³n ->Impuestos Sobre Ventas</b><p>Clik \'ConsunciÃ³n VAT Grupos de Impuestos Agregar/Actualizar\' a Agregar/Editar.',0),(449135,12476,'de','VAT/GST/Verbrauch Steuern:<p>Gehe zu<p><b>Admin-> Admin Setup-> Firma neu/bearbeiten</b><p>KontrollkÃ¤stchen \"Set Steuern fÃ¼r VAT/GST.\"<p>Richten Sie steuern:<p><b>Admin-> Setup-Billing-> Umsatzsteuer</b><p>Klicken Sie auf \"Verbrauch MwSt. Gruppen hinzuf',0),(449136,12476,'en','VAT/GST/Consumption Taxes:<p>Go to<p><b>Admin -> Admin Setup -> Company New/Edit</b><p>Check \'Set Taxes for VAT/GST\'.<p>Set up taxes:<p><b>Admin -> Setup-Billing -> Sales Taxes</b><p>Click \'Consumption VAT Tax Groups Add/Update\' to Add/Edit.',0),(449137,12477,'is','',0),(449138,12477,'dr','',0),(449139,12477,'pr','',0),(449140,12477,'tr','',0),(449141,12477,'pl','',0),(449142,12477,'bg','',0),(449143,12477,'ur','',0),(449144,12477,'sr','',0),(449145,12477,'vi','',0),(449146,12477,'af','',0),(449147,12477,'ro','',0),(449148,12477,'et','',0),(449149,12477,'si','',0),(449150,12477,'ba','',0),(449151,12477,'nl','',0),(449152,12477,'fi','',0),(449153,12477,'no','',0),(449154,12477,'da','',0),(449155,12477,'ko','',0),(449156,12477,'he','',0),(449157,12477,'el','',0),(449158,12477,'zh','',0),(449159,12477,'sv','',0),(449160,12477,'it','',0),(449161,12477,'tl','',0),(449162,12477,'th','',0),(449163,12477,'hi','',0),(449164,12477,'ms','',0),(449165,12477,'ar','',0),(449166,12477,'fr','',0),(449167,12477,'jp','',0),(449168,12477,'pt','',0),(449169,12477,'ru','',0),(449170,12477,'es','',0),(449171,12477,'de','',0),(449172,12477,'en','',0),(449173,12478,'is','',0),(449174,12478,'dr','',0),(449175,12478,'pr','',0),(449176,12478,'tr','',0),(449177,12478,'pl','',0),(449178,12478,'bg','',0),(449179,12478,'ur','',0),(449180,12478,'sr','',0),(449181,12478,'vi','',0),(449182,12478,'af','',0),(449183,12478,'ro','',0),(449184,12478,'et','',0),(449185,12478,'si','',0),(449186,12478,'ba','',0),(449187,12478,'nl','',0),(449188,12478,'fi','',0),(449189,12478,'no','',0),(449190,12478,'da','',0),(449191,12478,'ko','',0),(449192,12478,'he','',0),(449193,12478,'el','',0),(449194,12478,'zh','',0),(449195,12478,'sv','',0),(449196,12478,'it','',0),(449197,12478,'tl','',0),(449198,12478,'th','',0),(449199,12478,'hi','',0),(449200,12478,'ms','',0),(449201,12478,'ar','',0),(449202,12478,'fr','',0),(449203,12478,'jp','',0),(449204,12478,'pt','',0),(449205,12478,'ru','',0),(449206,12478,'es','',0),(449207,12478,'de','',0),(449208,12478,'en','',0),(449209,12479,'is','',0),(449210,12479,'dr','.Ø§Ø² ØªØ§Ø±ÛŒØ® Ø³Ø±Ø±Ø³ÛŒØ¯ Ú¯Ø°Ø´ØªÙ‡ Ù‡Ø§Ø¯Ø± ÙØ±Ù…Ø§ÛŒØ´ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÛŒØ® Ø³Ø±Ø±Ø³ÛŒØ¯ ÛŒØ§ ØªØ§Ø±ÛŒØ® Ø¨ÛŒØ¬Ú© ØªØ¹ÛŒÛŒÙ† Ù…ÛŒ Ø´',0),(449211,12479,'pr','Ú¯Ø²Ø§Ø±Ø´ ØªØ¬Ø²ÛŒÙ‡ Ø³Ù†ÛŒ Ø§Ø² ØªØ§Ø±ÛŒØ® Ø³Ø±Ø±Ø³ÛŒØ¯ ÙØ§Ú©ØªÙˆØ± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ú©Ù†Ø¯.Ø§Ø² ØªØ§Ø±ÛŒØ® Ø³Ø±Ø±Ø³ÛŒØ¯ Ú¯Ø°Ø´ØªÙ‡ Ù‡Ø§Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÛŒØ® Ø³Ø±Ø±Ø³ÛŒØ¯ ÛŒØ§ ØªØ§Ø±ÛŒØ® ÙØ§Ú©ØªÙˆØ± ØªØ¹ÛŒÛŒÙ† Ù…ÛŒ Ø´Ù',0),(449212,12479,'tr','YaÅŸlandÄ±rma raporu fatura kullanan son tarih. GecikmiÅŸ sipariÅŸ vade veya fatura tarihinden sonra bu tarihi geÃ§en gÃ¼n sayÄ±sÄ±nÄ± belirler.<p>Bu altÄ±nda deÄŸiÅŸtirebilirsiniz:<p><b>YÃ¶netici Kurulumu-fatura ÅŸirket seÃ§enekleri->-></b>',0),(449213,12479,'pl','Aging sprawozdanie uÅ¼ywa fakturze terminie. ZalegÅ‚e zamÃ³wienia jest okreÅ›lana przez wymagalnoÅ›ci lub z datÄ… wystawienia faktury, to liczba dni ostatnich tego dnia.<p>MoÅ¼na zmieniÄ‡ to na podstawie:<p><b>Admin->-> firmy opcje konfiguracji rozliczeÅ„',0),(449214,12479,'bg','Ð—Ð°ÑÑ‚Ð°Ñ€ÑÐ²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð½Ð°ÑÐµÐ»ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð´Ð¾ÐºÐ»Ð°Ð´ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶. ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° ÑÐµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»Ñ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶ Ð¸Ð»Ð¸ Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ñ',0),(449215,12479,'ur','Ø®Ø³ØªÛ Ø±Ù¾ÙˆØ±Ù¹ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªØ§ ÛÛ’ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ ØªØ§Ø±ÛŒØ® ÛÛ’ Û” Ù…ÙˆØ®Ø± Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ù¾Ø± ÛŒØ§ ØªÙˆ ÙˆØ§Ø¬Ø¨ ØªØ§Ø±ÛŒØ® ÛŒØ§ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®ØŒ Ù¾Ú¾Ø± Ø§Ø³ ØªØ§Ø±ÛŒØ® Ù…Ø§Ø¶ÛŒ Ú©Û’ Ø¯Ù†ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(449216,12479,'sr','Ð”Ð¾ÑÐ¿ÐµÐ²Ð°ÑšÐ° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº. Ð”Ð¾ÑÐ¿ÐµÐ»Ðµ Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ñƒ Ð¾Ð´Ñ€ÐµÑ’ÑƒÑ˜Ðµ Ð¸Ð»Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº Ð¸Ð»Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ, Ð° Ð·Ð°Ñ‚Ð¸Ð¼ Ð±Ñ€Ð¾Ñ˜ Ð´Ð°Ð½Ð° Ð¿Ð¾ÑÐ»Ðµ Ñ‚Ð¾Ð³ Ð´Ð°Ñ‚Ñ',0),(449217,12479,'vi','bÃ¡o cÃ¡o sá»­ dá»¥ng ngÃ y Ä‘Ã¡o háº¡n cá»§a hÃ³a Ä‘Æ¡n. Pháº§n quÃ¡ háº¡n sáº½ Ä‘Æ°á»£c xÃ¡c Ä‘á»‹nh bá»Ÿi ngÃ y Ä‘Ã¡o háº¡n hoáº·c ngÃ y hÃ³a Ä‘Æ¡n, sau Ä‘Ã³ lÃ  sá»‘ ngÃ y Ä‘Ã£ quÃ¡ háº¡n. Báº¡n cÃ³ thá»ƒ thay Ä‘á»•i Ä‘iá»u nÃ y: quáº£n lÃ½-thiáº¿t l',0),(449218,12479,'af','Die veroudering verslag gebruik die faktuur sperdatum. Die uitstaande op die volgorde is bepaal deur Ã³f die sperdatum of die faktuur datum, dan die aantal dae verby daardie datum.<p>Jy kan dit onder verander:<p><b>Admin-> opstel-fakturering-> maatskappy ',0),(449219,12479,'ro','Raportul Aging utilizeazÄƒ facturii data scadenÅ£ei. Restante pe ordinea este determinatÄƒ de data scadenÅ£ei sau la data facturii apoi numÄƒrul de zile trecut data.<p>PuteÅ£i schimba acest lucru Ã®n conformitate cu:<p><b>Admin-> Setup-facturare-> opÅ£iun',0),(449220,12479,'et','Aging aruanne kasutab arve tÃ¤htaeg. TÃ¤htaja Ã¼letanud tellimusel mÃ¤Ã¤ratakse kindlaks tÃ¤htpÃ¤evaks vÃµi arve kuupÃ¤eva siis seda kuupÃ¤eva mÃ¶Ã¶dunud pÃ¤evade arvu.<p>Saate muuta selle all:<p><b>Admin-> Setup-arved-> firma Valikud</b>',0),(449221,12479,'si','Aging poroÄilo uporablja raÄun datum zapadlosti. Zdavnaj na vrstni red doloÄi datum zapadlosti ali datuma raÄuna, potem Å¡tevilo dni zamude navedenega datuma.<p>Spremenite to pod:<p><b>Admin-> Setup-zaraÄunavanje-> podjetje moÅ¾nosti</b>',0),(449222,12479,'ba','Penuaan laporan menggunakan faktur tanggal jatuh tempo. Tertunda urutan ditentukan oleh tanggal jatuh tempo atau tanggal faktur, maka jumlah hari melewati tanggal tersebut.<p>Anda dapat mengubah ini di bawah:<p><b>Admin-> Setup-penagihan-> pilihan perusah',0),(449223,12479,'nl','Het verouderen rapport gebruikt de factuur vervaldag. De achterstallige op de volgorde wordt bepaald door de vervaldatum of de factuurdatum, dan het aantal dagen na die datum.<p>U kunt dit onder wijzigen:<p><b>Admin-> Setup-Billing-> bedrijf opties</b>',0),(449224,12479,'fi','Vanheneminen kertomus kÃ¤yttÃ¤Ã¤ laskun erÃ¤pÃ¤ivÃ¤. MyÃ¶hÃ¤ssÃ¤ tilauksessa mÃ¤Ã¤ritetÃ¤Ã¤n erÃ¤pÃ¤ivÃ¤ tai laskutuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ niin monta pÃ¤ivÃ¤Ã¤ kyseisenÃ¤.<p>Voit muuttaa tÃ¤mÃ¤n nojalla:<p><b>Admin asetukset-laskutus-> yhtiÃ¶lle vaihtoehtoja-><',0),(449225,12479,'no','Aldring rapporten bruker fakturaen forfallsdato. Den forfalte pÃ¥ rekkefÃ¸lgen bestemmes av enten forfallsdatoen eller fakturadatoen, og antall dager etter at dato.<p>Du kan endre dette under:<p><b>Admin-> Setup-fakturering-> selskapet alternativer</b>',0),(449226,12479,'da','Aging rapport bruger fakturaen forfaldsdato. Den forfaldne pÃ¥ rÃ¦kkefÃ¸lgen bestemmes af enten forfaldsdatoen eller fakturadatoen, sÃ¥ antallet af dage forbi denne dato.<p>Du kan Ã¦ndre dette under:<p><b>Admin-> Setup-fakturering-> selskab indstillinger<',0),(449227,12479,'ko','ì—ì´ì§• ë³´ê³ ì„œ ì‚¬ìš© í•˜ ì—¬ ì†¡ìž¥ ë§Œê¸°ì¼. ìˆœì„œì— ì—°ì²´ ê¸°í•œ ë˜ëŠ” ì†¡ìž¥ ë‚ ì§œ, ë‹¤ìŒ ë‚ ì§œ ì§€ë‚œ ì¼ ìˆ˜ì— ì˜í•´ ê²°ì • ë©ë‹ˆë‹¤.<p>ì•„ëž˜ì—ì„œì´ ë³€ê²½í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p><b>ê´€ë¦¬ìž ì„¤ì •-ê²°ì œ íšŒì‚¬ ì˜µì…˜->-></b>',0),(449228,12479,'he','×”×–×“×§× ×•×ª ×”×“×•×— ×ž×©×ª×ž×© ×”×—×©×‘×•× ×™×ª ×ª××¨×™×š ×™×¢×“. ××™×—×•×¨ ×¢×œ ×”×¡×“×¨ × ×§×‘×¢ ×œ×¤×™ ××• ×ª××¨×™×š ×”×™×¢×“ ××• ×ª××¨×™×š ×”×—×©×‘×•× ×™×ª, ×•×œ××—×¨ ×ž×›×Ÿ ××ª ×ž×¡×¤×¨ ×”×™×ž×™× ××—×¨×™ ×ª××¨×™×š ×–×”.<p>×‘××¤×©×¨×•×',0),(449229,12479,'el','Î— Î³Î®ÏÎ±Î½ÏƒÎ· Î­ÎºÎ¸ÎµÏƒÎ· Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î—Î¼/Î½Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚. Î‰Î´Î· Ï…Ï€ÎµÏÎ²Î¿Î»Î¹ÎºÎ¬ ÎºÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ·Î¼Î­Î½Ï‰Î½ ÏƒÏ„Î·Î½ ÎµÎ½Ï„Î¿Î»Î® ÎºÎ±Î¸Î¿ÏÎ¯Î¶ÎµÏ„Î±Î¹ Î±Ï€ÏŒ ÎµÎ¯Ï„Îµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯',0),(449230,12479,'zh','è¿‡æœŸæŠ¥è¡¨ä½¿ç”¨å‘ç¥¨è¿‡æœŸã€‚è®¢å•ä¸Šçš„è¿‡æœŸç”±æˆªæ­¢æ—¥æœŸæˆ–å‘ç¥¨æ—¥æœŸå†³å®šï¼Œç„¶åŽè¿‡æœŸåŽå¤©æ•°ã€‚æ‚¨å¯ä»¥æ”¹å˜æ­¤åœ¨ï¼šç®¡ç†->è®¾ç½®å…¥è´¦->å…¬å¸é€‰é¡¹',0),(449231,12479,'sv','Den Ã¥ldrande rapport anvÃ¤nder fakturan fÃ¶rfallodatum. Den fÃ¶rsenade pÃ¥ ordning bestÃ¤ms av antingen fÃ¶rfallodatum eller fakturadatum, sedan antalen dagar efter detta datum.<p>Du kan Ã¤ndra detta under:<p><b>Admin-> Setup-fakturering-> fÃ¶retag alter',0),(449232,12479,'it','Il rapporto Aging utilizza la fattura data di scadenza. Il ritardo dell\'ordine Ã¨ determinata dalla sia la data di scadenza o la data della fattura, quindi il numero di giorni oltre tale data.<p>Ãˆ possibile modificare questo sotto:<p><b>Admin->-> azienda',0),(449233,12479,'tl','',0),(449234,12479,'th','à¹€à¸‡à¸´à¸™à¹ƒà¸Šà¹‰à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸§à¸±à¸™à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸” à¸žà¹‰à¸™à¸à¸³à¸«à¸™à¸”à¸Šà¸³à¸£à¸°à¸•à¸²à¸¡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ˆà¸°à¸–à¸¹à¸à¸à¸³à¸«à¸™à¸” à¹‚à¸”à¸¢à¸—à¸±à¹‰à¸‡à¸§à¸±à¸™à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸” à¸«à¸£à¸·à¸­à¸§à¸±à¸™',0),(449235,12479,'hi','à¤à¤œà¤¿à¤‚à¤— à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•à¥¤ à¤…à¤¤à¤¿à¤¦à¥‡à¤¯ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤¯à¤¾ à¤¤à¥‹ à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¿à¤¥à¤¿ à¤¯à¤¾ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥',0),(449236,12479,'ms','Laporan penuaan menggunakan invois tarikh matang. Lampau tempoh pada perintah yang ditentukan oleh tarikh akhir atau tarikh inbois dikeluarkan, maka bilangan hari lepas tarikh tersebut.<p>Anda boleh mengubah ini di bawah:<p><b>Admin-> persediaan-bil-> Ops',0),(449237,12479,'ar','ÙŠØ³ØªØ®Ø¯Ù… \"Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©\" Ø§Ù„ÙØ§ØªÙˆØ±Ø© ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚. ØªØ£Ø®Ø± ÙÙŠ Ø§Ù„ØªØ±ØªÙŠØ¨ ÙŠØªØ­Ø¯Ø¯ Ø­Ø³Ø¨ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø£Ùˆ ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©ØŒ Ø«Ù… Ø¹Ø¯Ø¯ Ø§Ù„Ø£ÙŠØ§Ù… Ø§Ù„Ù…Ø§Ø¶ÙŠØ© Ø°Ù„Ùƒ Ø',0),(449238,12479,'fr','Le rapport d\'antÃ©rioritÃ© utilise la facture date d\'Ã©chÃ©ance. L\'en retard sur l\'ordre est dÃ©terminÃ© par soit la date d\'Ã©chÃ©ance ou la date de la facture, alors que le nombre de jours aprÃ¨s cette date.<p>Vous pouvez modifier cela en vertu :<p><b>Ad',0),(449239,12479,'jp','é«˜é½¢åŒ–ãƒ¬ãƒãƒ¼ãƒˆã‚’ä½¿ç”¨ã—ã¦è«‹æ±‚æ›¸æœŸæ—¥ã€‚æ³¨æ–‡ã®æœŸé™åˆ‡ã‚ŒæœŸæ—¥ã¾ãŸã¯è«‹æ±‚æ›¸ã®æ—¥ä»˜ã‚’éŽåŽ»ã®æ—¥ä»˜ã®æ—¥æ•°ã«ã‚ˆã£ã¦æ±ºå®šã•ã‚Œã¾ã™ã€‚<p>ä¸‹ã§ã“ã‚Œã‚’å¤‰æ›´ã§ãã¾ã™ã€‚<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è«‹æ±‚ä¼šç¤¾ã‚ª',0),(449240,12479,'pt','O envelhecimento relatÃ³rio usa a factura data de vencimento. O atraso na ordem Ã© determinado pela data de vencimento ou da data da fatura, entÃ£o o nÃºmero de dias apÃ³s essa data.<p>VocÃª pode mudar isso em:<p><b>Admin-> Setup-faturamento-> opÃ§Ãµes de',0),(449241,12479,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ ÑÑ‡ÐµÑ‚ ÑÑ€Ð¾ÐºÐ°. ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð½Ð° Ð·Ð°ÐºÐ°Ð· Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÑÐµÑ‚ÑÑ Ð»Ð¸Ð±Ð¾ Ð´Ð°Ñ‚Ñ‹ Ð¸Ð»Ð¸ Ð´Ð°Ñ‚Ñ‹ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°, Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð½ÐµÐ¹ Ñ ÑÑ‚Ð¾Ð¹ Ð´Ð',0),(449242,12479,'es','Informe de envejecimiento usa la fecha de cumplir de la factura. Se determina la fecha que es mÃ¡s alla que la fecha de pagar por o la fecha de pagar o la fecha de la factura, luego el nÃºmero de dÃ­as que pasa esta fecha. <p>\r\nSe puede cambiar el cÃ¡lcul',0),(449243,12479,'de','Der alternde Bericht verwendet die Rechnung fÃ¤llig am. Die Ã¼berfÃ¤llige im Auftrag richtet sich nach dem FÃ¤lligkeitsdatum oder Rechnungsdatum, dann die Anzahl der Tage nach diesem Zeitpunkt.<p>Sie kÃ¶nnen dies unter Ã¤ndern:<p><b>Admin-> Setup-Billing-',0),(449244,12479,'en','The Aging Report uses the Invoice due date. The overdue on the order is determined by either the due date or the invoice date, then the number of days past that date. <p> You can change this under:<p><b>Admin -> Setup-Billing -> Company Options</b>',0),(449245,12480,'is','',0),(449246,12480,'dr','',0),(449247,12480,'pr','',0),(449248,12480,'tr','',0),(449249,12480,'pl','',0),(449250,12480,'bg','',0),(449251,12480,'ur','',0),(449252,12480,'sr','',0),(449253,12480,'vi','',0),(449254,12480,'af','',0),(449255,12480,'ro','',0),(449256,12480,'et','',0),(449257,12480,'si','',0),(449258,12480,'ba','',0),(449259,12480,'nl','',0),(449260,12480,'fi','',0),(449261,12480,'no','',0),(449262,12480,'da','',0),(449263,12480,'ko','',0),(449264,12480,'he','',0),(449265,12480,'el','',0),(449266,12480,'zh','',0),(449267,12480,'sv','',0),(449268,12480,'it','',0),(449269,12480,'tl','',0),(449270,12480,'th','',0),(449271,12480,'hi','',0),(449272,12480,'ms','',0),(449273,12480,'ar','',0),(449274,12480,'fr','',0),(449275,12480,'jp','',0),(449276,12480,'pt','',0),(449277,12480,'ru','',0),(449278,12480,'es','',0),(449279,12480,'de','',0),(449280,12480,'en','',0),(449281,12481,'is','',0),(449282,12481,'dr','',0),(449283,12481,'pr','',0),(449284,12481,'tr','',0),(449285,12481,'pl','',0),(449286,12481,'bg','',0),(449287,12481,'ur','',0),(449288,12481,'sr','',0),(449289,12481,'vi','',0),(449290,12481,'af','',0),(449291,12481,'ro','',0),(449292,12481,'et','',0),(449293,12481,'si','',0),(449294,12481,'ba','',0),(449295,12481,'nl','',0),(449296,12481,'fi','',0),(449297,12481,'no','',0),(449298,12481,'da','',0),(449299,12481,'ko','',0),(449300,12481,'he','',0),(449301,12481,'el','',0),(449302,12481,'zh','',0),(449303,12481,'sv','',0),(449304,12481,'it','',0),(449305,12481,'tl','',0),(449306,12481,'th','',0),(449307,12481,'hi','',0),(449308,12481,'ms','',0),(449309,12481,'ar','',0),(449310,12481,'fr','',0),(449311,12481,'jp','',0),(449312,12481,'pt','',0),(449313,12481,'ru','',0),(449314,12481,'es','',0),(449315,12481,'de','',0),(449316,12481,'en','',0),(449317,12482,'is','',0),(449318,12482,'dr','',0),(449319,12482,'pr','',0),(449320,12482,'tr','',0),(449321,12482,'pl','',0),(449322,12482,'bg','',0),(449323,12482,'ur','',0),(449324,12482,'sr','',0),(449325,12482,'vi','',0),(449326,12482,'af','',0),(449327,12482,'ro','',0),(449328,12482,'et','',0),(449329,12482,'si','',0),(449330,12482,'ba','',0),(449331,12482,'nl','',0),(449332,12482,'fi','',0),(449333,12482,'no','',0),(449334,12482,'da','',0),(449335,12482,'ko','',0),(449336,12482,'he','',0),(449337,12482,'el','',0),(449338,12482,'zh','',0),(449339,12482,'sv','',0),(449340,12482,'it','',0),(449341,12482,'tl','',0),(449342,12482,'th','',0),(449343,12482,'hi','',0),(449344,12482,'ms','',0),(449345,12482,'ar','',0),(449346,12482,'fr','',0),(449347,12482,'jp','',0),(449348,12482,'pt','',0),(449349,12482,'ru','',0),(449350,12482,'es','',0),(449351,12482,'de','',0),(449352,12482,'en','',0),(449353,12483,'is','',0),(449354,12483,'dr','Ú©Ù…ÛŒØ³ÛŒÙˆÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ù‡ ØµÙˆØ±Øª Ø¯Ø³ØªÛŒ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª.Ø¨Ø¨ÛŒÙ†ÛŒØ¯:Ú¯Ø²Ø§Ø±Ø´Ø§Øª-ØµØ¯ÙˆØ±ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-Ø®Ù„Ø§ØµÙ‡ Ø¨ÛŒØ¬Ú©Ù‡Ø§.ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø±Ø§ Ø§Ø² \"ÙØ±Ù…Ø§ÛŒØ´ ØªÙˆØ³Ø·\" Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.Ø§ÛŒÙ† Ú©Ø§Ø± ØªÙ…Ø§Ù… Ù',0),(449355,12483,'pr','Ú©Ù…ÛŒØ³ÛŒÙˆÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ù‡ ØµÙˆØ±Øª Ø¯Ø³ØªÛŒ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª.Ø¨Ø¨ÛŒÙ†ÛŒØ¯:Ú¯Ø²Ø§Ø±Ø´Ø§Øª-ØµØ¯ÙˆØ±ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-Ø®Ù„Ø§ØµÙ‡ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§.ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø±Ø§ Ø§Ø² \"Ø³ÙØ§Ø±Ø´ ØªÙˆØ³Ø·\" Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.Ø§ÛŒÙ† Ú©Ø§Ø± ØªÙ…Ø§Ù… Ù',0),(449356,12483,'tr','SatÄ±ÅŸ temsilcisi komisyon el ile hesaplanÄ±r. Ziyaret edin:<p><b>FaturalandÄ±rma Ã–zeti fatura->-> raporlar</b><p>SatÄ±ÅŸ elemanÄ± \'Order By\'Ä± seÃ§in. Bu satÄ±ÅŸ listesi ve satÄ±ÅŸÃ§Ä±lar iÃ§in kar ve sonra elle hesaplamak commission(s).',0),(449357,12483,'pl','Sprzedawca prowizja obliczana jest rÄ™cznie. Wizyty:<p><b>Raporty-> rozliczeÅ„-> Podsumowanie faktury</b><p>Wybierz osobÄ™ sprzedaÅ¼y z \"Zlecenie\". To lista caÅ‚kowita sprzedaÅ¼ i zysk dla sprzedawcÃ³w i nastÄ™pnie rÄ™cznie obliczyÄ‡ commission(s).',0),(449358,12483,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÐµÑ† ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ðµ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½ Ñ€ÑŠÑ‡Ð½Ð¾. ÐŸÐ¾ÑÐµÑ‚ÐµÑ‚Ðµ:<p><b>Ð”Ð¾ÐºÐ»Ð°Ð´Ð¸-> Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ-> Ð¾Ð±Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸</b><p>Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð»Ð¸Ñ†Ðµ Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð½Ð°\"Ð¾Ñ‚\". Ð¢Ð¾Ð²',0),(449359,12483,'ur','Ù¾Ø±Ø³Ù† Ú©Ù…ÛŒØ´Ù† Ú©Ùˆ Ø¯Ø³ØªÛŒ Ø·ÙˆØ± Ù¾Ø± Ø­Ø³Ø§Ø¨ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û” Ù…Ù„Ø§Ø­Ø¸Û Ú©Ø±ÛŒÚº:<p><b>Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Ø§ Ø®Ù„Ø§ØµÛ->-> Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹</b><p>\'ØªØ±ØªÛŒØ¨\' Ø³Û’ Ø³ÛŒÙ„Ø² Ø´Ø®Øµ Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Û” Ø§Ø³ Ú',0),(449360,12483,'sr','ÐŸÑ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð° Ñ€ÑƒÑ‡Ð½Ð¾ Ñ€Ð°Ñ‡ÑƒÐ½Ð°. ÐŸÐ¾ÑÑ˜ÐµÑ‚Ð¸Ñ‚Ðµ:<p><b>Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸ Ð¸ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ</b><p>ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¾ÑÐ¾Ð±Ð° Ð¸Ð· \'ÐžÑ€Ð´ÐµÑ€ Ð‘y\'. ÐžÐ²Ð¾ Ñ›Ðµ Ð»Ð¸ÑÑ‚Ð° ÑƒÐº',0),(449361,12483,'vi','Hoa há»“ng cá»§a NV bÃ¡n hÃ ng Ä‘Æ°á»£c tÃ­nh thá»§ cÃ´ng.BCao-thanh toÃ¡n-tÃ³m táº¯t hÃ³a Ä‘Æ¡n-chá»n ngÆ°á»i bÃ¡n hÃ ng báº±ng \"Ä‘áº·t hÃ ng bá»Ÿi\". Äiá»u nÃ y sáº½ liá»‡t kÃª tá»“ng dthu vÃ  lá»£i nhuáº­n cá»§a NV bÃ¡n hÃ ng,->tá»± tÃ­nh hoa há»“ng',0),(449362,12483,'af','Verkoopspersoon Kommissie is handmatig bereken. Besoek:<p><b>Verslae-> fakturering-> opsomming van fakture</b><p>Kies verkope persoon uit die \'orde deur\'. Dit sal lys totale verkope en wins vir salespersons en dan handmatig bereken commission(s).',0),(449363,12483,'ro','Agent de vÃ¢nzÄƒri Comisia se calculeazÄƒ manual. VizitaÅ£i:<p><b>Rapoarte-> facturare-> Rezumat de facturi</b><p>SelectaÅ£i persoanÄƒ de vÃ¢nzÄƒri din \"Ordinul\". Aceasta va lista totalul vÃ¢nzÄƒrilor ÅŸi profitului pentru agenÅ£ii de vÃ¢nzÄƒri ÅŸi apoi s',0),(449364,12483,'et','MÃ¼Ã¼ja komisjonitasu arvutatakse kÃ¤sitsi. KÃ¼lasta:<p><b>Aruannete-> arved arved KokkuvÃµte-></b><p>Valige mÃ¼Ã¼giisik tellimuse jÃ¤rgi. See nimekiri kogumÃ¼Ã¼gist ja kasum mÃ¼Ã¼giesindajatele ja seejÃ¤rel arvutatakse commission(s).',0),(449365,12483,'si','Provizija prodajalca roÄno izraÄunamo. ObiÅ¡Äite:<p><b>PoroÄila-> zaraÄunavanje-> Povzetek raÄunov</b><p>RazvrÅ¡Äanje po izbirate pultom. To bo seznam celotne prodaje in dobiÄek za prodajalce in nato roÄno izraÄunamo commission(s).',0),(449366,12483,'ba','Penjual komisi secara manual dihitung. Kunjungi:<p><b>Laporan-> penagihan-> ringkasan tagihan</b><p>Memilih orang penjualan \'Order By\'. Ini akan daftar total penjualan dan keuntungan untuk pramuniaga dan kemudian secara manual menghitung commission(s).',0),(449367,12483,'nl','Verkoper Commissie wordt handmatig berekend. Ga naar:<p><b>Rapporten-> facturering-> samenvatting van facturen</b><p>Kies verkoop persoon uit de \'orde door\'. Dit zal een lijst van totale verkoop en winst voor verkopers en vervolgens handmatig berekenen co',0),(449368,12483,'fi','MyyjÃ¤n provisio lasketaan manuaalisesti. KÃ¤ynti:<p><b>Raporttien-> laskutus-> laskujen Yhteenveto</b><p>Valitse myyjÃ¤ Order By. TÃ¤mÃ¤ luettelo kokonaismyynnistÃ¤ ja voitto myyjÃ¤t ja laskea sitten manuaalisesti commission(s).',0),(449369,12483,'no','Selger provisjon beregnes manuelt. BesÃ¸k:<p><b>Rapporter-> fakturering-> Sammendrag av fakturaer</b><p>Velg selger \"Sorter etter\". Dette viser totalt salg og fortjeneste for selgere og deretter manuelt beregne commission(s).',0),(449370,12483,'da','SÃ¦lger Kommissionen beregnes manuelt. BesÃ¸g:<p><b>Rapporter-> fakturering-> ResumÃ© af fakturaer</b><p>VÃ¦lg salg Person fra Order By. Dette vil liste samlede salg og overskud for sÃ¦lgere og derefter manuelt at beregne commission(s).',0),(449371,12483,'ko','íŒë§¤ì› ìœ„ì›íšŒ ìˆ˜ë™ìœ¼ë¡œ ê³„ì‚° í•©ë‹ˆë‹¤. ë°©ë¬¸:<p><b>ê²°ì œ ì²­êµ¬ì„œì˜ ìš”ì•½->-> ë³´ê³ ì„œ</b><p>ì— ì˜í•´ \'ìˆœì„œ\'ì—ì„œ ì˜ì—… ì§ì›ì„ ì„ íƒ í•˜ì‹­ì‹œì˜¤. ì´ ì´ íŒë§¤ì•¡ì„ ë‚˜ì—´ í•˜ ê³  ì˜ì—…ì— ëŒ€ í•œ ì´ìµì„ commission(s)ë¥¼',0),(449372,12483,'he','××™×© ×ž×›×™×¨×•×ª ×”×¢×ž×œ×” ×ž×—×•×©×‘×ª ×‘××•×¤×Ÿ ×™×“× ×™. ×‘×§×¨:<p><b>×“×•×—×•×ª-> ×—×™×•×‘-> ×¡×™×›×•× ×©×œ ×—×©×‘×•× ×™×•×ª</b><p>×‘×—×¨ \' ××™×© ×ž×›×™×¨×•×ª \'×”×–×ž× ×”\'. ×–×” ×¤×¨×˜ ××ª ×¡×š ×›×œ ×”×ž×›×™×¨×•×ª, ×¨×•×•×— ×©×œ ×× ×©×™ ×ž×›×',0),(449373,12483,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Ï€Ï‰Î»Î·Ï„Î® Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÏ„Î±Î¹ Î¼Îµ Î¼Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î¿ Ï„ÏÏŒÏ€Î¿. Î•Ï€Î¯ÏƒÎºÎµÏˆÎ·:<p><b>Î•ÎºÎ¸Î­ÏƒÎµÎ¹Ï‚-> Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚-> Î ÎµÏÎ¯Î»Î·ÏˆÎ· Ï„Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½</b><p>Î”Î¹Î±Î»Î­Î¾ÎµÏ„Îµ Â«Î¤Î¬Î¾Î· Î±Ï€ÏŒÂ» Ï€ÏÏŒÏƒÏ‰Ï€',0),(449374,12483,'zh','é”€å”®äººå‘˜ä½£é‡‘æ‰‹åŠ¨è®¡ç®—ã€‚æŸ¥çœ‹ï¼šæŠ¥è¡¨->å…¥è´¦->å‘ç¥¨æ‘˜è¦\r\nä»Žâ€œæŽ’åºæ–¹å¼â€ä¸­é€‰æ‹©é”€å”®äººå‘˜ã€‚è¿™ä¼šåˆ—å‡ºé”€å”®äººå‘˜çš„æ€»é”€å”®å’Œåˆ©æ¶¦ï¼Œç„¶åŽæ‰‹åŠ¨è®¡ç®—ä½£é‡‘ã€‚',0),(449375,12483,'sv','SÃ¤ljare kommissionen berÃ¤knas manuellt. BesÃ¶k:<p><b>Rapporter-> fakturering-> Sammanfattning av fakturor</b><p>VÃ¤lj sÃ¤ljare \"Ordern\". Detta kommer att lista totala fÃ¶rsÃ¤ljning och vinst fÃ¶r sÃ¤ljare och sedan manuellt berÃ¤kna provisionerna.',0),(449376,12483,'it','Commissione del venditore viene calcolato manualmente. Visita:<p><b>Rapporti-> fatturazione-> riassunto delle fatture</b><p>Scegliere vendite persona \'Order By\'. Questo elenco totale delle vendite e profitto per venditori e poi calcolare manualmente commi',0),(449377,12483,'tl','',0),(449378,12483,'th','à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™à¸‚à¸­à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢à¸¡à¸µà¸„à¸³à¸™à¸§à¸“à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡ à¹€à¸‚à¹‰à¸²à¸Šà¸¡:<p><b>à¸£à¸²à¸¢à¸‡à¸²à¸™->à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™->à¸ªà¸£à¸¸à¸›à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰</b',0),(449379,12483,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯à¤•à¤°à¥à¤¤à¤¾ à¤†à¤¯à¥‹à¤— à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤°à¥‚à¤ª à¤¸à¥‡ à¤—à¤£à¤¨à¤¾ à¤•à¥€ à¤¹à¥ˆà¥¤ à¤ªà¤° à¤œà¤¾à¤à¤:<p><b>à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶->-> à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ</b><p>à¤¬à¤¿à¤•à¥à¤°à¥',0),(449380,12483,'ms','Komisyen jurujual dikira secara manual. Sila layari:<p><b>Laporan-> bil-> ringkasan invois</b><p>Memilih orang jualan dari \'Perintah oleh\'. Ini akan menyenaraikan jumlah jualan dan keuntungan bagi tenaga dan kemudian secara manual pengiraan commission(s).',0),(449381,12483,'ar','ÙˆÙŠØ­Ø³Ø¨ ÙŠØ¯ÙˆÙŠØ§Ù‹ Ø§Ù„Ù„Ø¬Ù†Ø© \"Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª\". Ù‚Ù… Ø¨Ø²ÙŠØ§Ø±Ø©:<p><b>ØªÙ‚Ø§Ø±ÙŠØ±-> Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ù…Ù„Ø®Øµ Ø§Ù„ÙÙˆØ§ØªÙŠØ±</b><p>Ø§Ø®ØªØ± Ø§Ù„Ø´Ø®Øµ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù…Ù† \'Ø§Ù„ØªØ±ØªÙŠØ¨ Ø­Ø³Ø¨\'. Ù‡Ø°Ø§ ÙˆØ³ÙˆÙ Ù‚Ø§Ø¦Ù…Ø© Ø¥Ø',0),(449382,12483,'fr','Commission du vendeur est calculÃ©e manuellement. Visite :<p><b>Rapports-> facturation-> RÃ©sumÃ© des factures</b><p>Choisissez Sales Person dans la Â« Order By Â». Ceci liste des ventes totales et profitent des vendeurs et ensuite manuellement au calcul ',0),(449383,12483,'jp','è²©å£²å“¡å§”å“¡ä¼šã¯æ‰‹å‹•ã§è¨ˆç®—ã•ã‚Œã¾ã™ã€‚å‚ç…§ã—ã¦ãã ã•ã„ã€‚<p><b>è«‹æ±‚æ›¸ã®è«‹æ±‚æ›¸ã®æ¦‚è¦->-> ãƒ¬ãƒãƒ¼ãƒˆ</b><p>\'Order By\' ã‹ã‚‰å–¶æ¥­æ‹…å½“è€…ã‚’é¸æŠžã—ã¾ã™ã€‚ã“ã‚Œã¯ãŠã‚ˆã³è²©å£²å“¡ã®åˆ©ç›Šã—ã€commission(s) ã‚’æ‰‹å‹',0),(449384,12483,'pt','ComissÃ£o do vendedor Ã© calculada manualmente. Visite:<p><b>RelatÃ³rios-> faturamento-> Resumo das faturas</b><p>Escolha a \'Order By\' pessoa de vendas. Isto irÃ¡ listar o total de vendas e lucro para os vendedores e entÃ£o manualmente calcular commission',0),(449385,12483,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð° Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ñ‹Ð²Ð°ÐµÑ‚ÑÑ Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ. ÐŸÐ¾ÑÐµÑ‚Ð¸Ñ‚Ðµ:<p><b>Ð”Ð¾ÐºÐ»Ð°Ð´Ñ‹-> ÑÑ‡ÐµÑ‚Ð¾Ð²-> Ñ€ÐµÐ·ÑŽÐ¼Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€</b><p>Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼ÐµÐ½ÐµÐ´Ð¶ÐµÑ€Ð° Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°Ð¼ Â«Order ByÂ». Ð­Ñ‚',0),(449386,12483,'es','Comisiones de vendedores se calcula manualmente. Visita:<p><b>Informes -> FacturaciÃ³n ->Sumario de Facturas</b><p>Selecciona Vendedores de \'Ordena Por\'. Esta acciÃ³n listarÃ¡ ventas totales y renta para los vendedores y calcula manualmente las comisiones',0),(449387,12483,'de','VerkÃ¤ufer-Kommission wird manuell berechnet. Besuchen Sie:<p><b>Berichte-> Billing-> Zusammenfassung der Rechnungen</b><p>WÃ¤hlen Sie die \'Order By\' Vertriebsmitarbeiter. Dies listet Gesamtumsatz und fÃ¼r Vertriebsmitarbeiter profitieren und dann manuell',0),(449388,12483,'en','Salesperson commission is manually calculated. Visit:<p><b>Reports->Billing->Summary of Invoices</b><p>Choose Sales Person from the \'Order By\'. This will list total sales and profit for salespersons and then manually calculate commission(s).',0),(449389,12484,'is','',0),(449390,12484,'dr','.Ø§ÛŒÙ† Ø¨Ø±Ø§ÛŒ ÛŒÚ© Ø¹Ù…Ø¯Ù‡ ÙØ±ÙˆØ´ ÛŒØ¹Ù†ÛŒ Ú©Ø³ÛŒ Ú©',0),(449391,12484,'pr','Ø¨Ø®Ø´ Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ù‡Ø§ Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ù…ÙˆØ±Ø¯ Ø®Ø§Øµ Ø§Ø³Øª Ø¬Ø§ÛŒÛŒ Ú©Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´ Ø§Ø² Ø·Ø±ÛŒÙ‚ ÙØ§ÛŒÙ„ Ø§Ø³Ú©ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ§Ø±Ø¯ Ø´ÙˆØ¯.Ø§ÛŒÙ† Ø¨Ø±Ø§ÛŒ ÛŒÚ© Ø¹Ù…Ø¯Ù‡ ÙØ±ÙˆØ´ ÛŒØ¹Ù†ÛŒ Ú©Ø³ÛŒ Ú©',0),(449392,12484,'tr','SatÄ±ÅŸ bilgileri bir .csv dosyasÄ± nerede ithal Ã¶zel bir durum iÃ§in BorÃ§lar komisyonlarÄ± bÃ¶lÃ¼mÃ¼nde bulunur. Bu daha sonra satmak iÃ§in daÄŸÄ±tÄ±m satan bir toptancÄ± iÃ§indir.',0),(449393,12484,'pl','Sekcji prowizji w zobowiÄ…zania jest szczegÃ³lnym przypadkiem gdzie sprzedaÅ¼y informacji jest importowane za pomocÄ… pliku CSV. To hurtownia, ktÃ³ra sprzedaje do dystrybutorÃ³w, ktÃ³rzy nastÄ™pnie odsprzedaÅ¼y.',0),(449394,12484,'bg','Ð¡ÐµÐºÑ†Ð¸ÑÑ‚Ð° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸ Ð² Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ Ðµ Ð·Ð° ÑÐ¿ÐµÑ†Ð¸Ð°Ð»ÐµÐ½ ÑÐ»ÑƒÑ‡Ð°Ð¹, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÑÐµ Ð²Ð½Ð°ÑÑ Ñ‡Ñ€ÐµÐ· .csv Ñ„Ð°Ð¹Ð». Ð¢Ð¾Ð²Ð° Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ð½Ð° ÐµÐ´Ñ€Ð¾, ÐºÐ¾Ð¸Ñ‚',0),(449395,12484,'ur','Ú©Û’ Ú©Ù…ÛŒØ´Ù†ÙˆÚº Ú©Û’ Ø³ÛŒÚ©Ø´Ù† Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ù…ÛŒÚº Ø¬ÛØ§Úº ÙØ±ÙˆØ®Øª Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ø°Ø±ÛŒØ¹Û’. csv ÙØ§Ø¦Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±Ø¯ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Ú©Ø³ÛŒ Ø®Ø§Øµ Ù…Ù‚Ø¯Ù…Û’ Ú©Û’ Ù„Ø¦Û’ ÛÛ’ Û” ÛŒÛ Ø§ÛŒÚ© ÙˆÛÙˆÙ„ÛŒØ³Ø§Ù„Ø± ÛÛ’ Ø¬Ùˆ ØªÙˆ Ø±Û',0),(449396,12484,'sr','Ð£ Ð¾Ð´ÐµÑ™ÐºÑƒ Ð¿Ñ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ðµ Ñƒ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ñ˜Ðµ Ð·Ð° Ð¿Ð¾ÑÐµÐ±Ð°Ð½ ÑÐ»ÑƒÑ‡Ð°Ñ˜ Ð³Ð´Ðµ ÑÐµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¸Ð½Ñ„Ð¾ ÑƒÐ²Ð¾Ð·Ð¸ Ð¿Ñ€ÐµÐºÐ¾ Ñƒ.Ñ†ÑÐ² Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ. ÐžÐ²Ð¾ Ñ˜Ðµ Ð·Ð° Ð´Ð¸Ð»ÐµÑ€ ÐºÐ¾Ñ˜Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð',0),(449397,12484,'vi','Pháº§n hoa há»“ng pháº£i tráº£ lÃ  má»™t trÆ°á»ng há»£p Ä‘áº·c biá»‡t nÆ¡i mÃ  thÃ´ng tin Ä‘Æ°á»£c nháº­p vÃ o táº­p tin CSV. Äiá»u nÃ y Ã¡p dá»¥ng cho toÃ n bÃ´ NV bÃ¡n hÃ ng mÃ  bÃ¡n cho cÃ¡c Ä‘áº¡i lÃ½',0),(449398,12484,'af','Die kommissies artikel in Waardedalingstoetse word vir \'n spesiale geval waar verkope inligting via \'n .csv lÃªer ingevoer is. Dit is vir \'n Wholesaler wat verkoop aan verspreiders wat dan herverkoop.',0),(449399,12484,'ro','SecÅ£iunea de comisioane Ã®n datorii este pentru un caz special, Ã®n cazul Ã®n care vÃ¢nzÄƒrile info este importat printr-un fiÅŸier .csv. Acest lucru este pentru un angrosist care vinde cÄƒtre distribuitori care revinde apoi.',0),(449400,12484,'et','Komisjonitasud osa vÃµlad on eriline juhtum, kus mÃ¼Ã¼giinfo imporditakse kaudu CSV-faili. See on hulgimÃ¼Ã¼ja, kes mÃ¼Ã¼b turustajatele, kes siis edasi.',0),(449401,12484,'si','Razdelku provizije v obveznosti je za poseben primer, ko prodajnih info uvaÅ¾a prek datoteko .csv. To je trgovec, ki prodaja distributerjem, ki nato prodati.',0),(449402,12484,'ba','Bagian komisi di hutang adalah kasus khusus dimana penjualan info diimpor melalui .csv file. Ini adalah untuk grosir yang menjual untuk distributor yang menjual kembali kemudian.',0),(449403,12484,'nl','De sectie van de commissies in schulden is voor een speciaal geval waar verkoop info via een CSV-bestand is geÃ¯mporteerd. Dit is voor een groothandelaar die verkoopt aan distributeurs die vervolgens doorverkopen.',0),(449404,12484,'fi','Ostovelkojen palkkiot-osio on erikoistapaus myynti info tuotaessa .csv-tiedoston. TÃ¤mÃ¤ on tukkuliike, joka myy jÃ¤lleenmyyjille, jotka sitten myydÃ¤.',0),(449405,12484,'no','Delen provisjoner i gjeld er et spesialtilfelle der salg info importeres via en CSV-fil. Dette er en grossist som selger til distributÃ¸rer som deretter videreselge.',0),(449406,12484,'da','Afsnittet provisioner i gÃ¦ld er for et sÃ¦rtilfÃ¦lde, hvor salget info er importeret via en .csv-fil. Dette er en grossist, der sÃ¦lger til distributÃ¸rer, der derefter videresÃ¦lge.',0),(449407,12484,'ko','ë¯¸ì§€ê¸‰ê¸ˆì˜ ìˆ˜ìˆ˜ë£Œ ì„¹ì…˜ì€ íŠ¹ë³„ í•œ ê²½ìš° íŒë§¤ ì •ë³´.csv íŒŒì¼ì„ í†µí•´ ê°€ì ¸ì˜¤ê²Œ ë©ë‹ˆë‹¤. ì´ê²ƒì€ ë‹¤ìŒ ìž¬íŒë§¤ í•˜ëŠ” ìœ í†µ ì—…ì²´ì— íŒë§¤ í•˜ëŠ” ë„ë§¤ ìƒìž…ë‹ˆë‹¤.',0),(449408,12484,'he','×”×ž×§×˜×¢ ×¢×ž×œ×•×ª ×‘×–×›××™× ×”×™× ×ž×§×¨×” ×ž×™×•×—×“ ×©×‘×• ×¤×¨×˜×™ ×ž×›×™×¨×•×ª ×ž×™×•×‘× ×‘××ž×¦×¢×•×ª ×§×•×‘×¥ csv. ×–×” ×‘×©×‘×™×œ ×‘×™×‘×•× ×•×‘×©×™×•×•×§ ×©×œ ×ž×™ ×©×ž×•×›×¨ ×œ×ž×¤×™×¦×™× ×ž×™ ×•××– ×œ×ž×›×•×¨.',0),(449409,12484,'el','Î•Î½ÏŒÏ„Î·Ï„Î± Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚ ÏƒÎµ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ ÎµÎ¯Î½Î±Î¹ Î³Î¹Î± Î¼Î¹Î± ÎµÎ¹Î´Î¹ÎºÎ® Ï€ÎµÏÎ¯Ï€Ï„Ï‰ÏƒÎ· ÏŒÏ€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î¼Î­ÏƒÏ‰ ÎµÎ½ÏŒÏ‚ Î±ÏÏ‡ÎµÎ¯Î¿Ï… .csv. Î ÏÏŒÎºÎµÎ¹Ï„Î±Î¹ Î³Î¹Î± Î­Î½Î',0),(449410,12484,'zh','åº”ä»˜è´¦æ¬¾ä¸­çš„ä½£é‡‘éƒ¨åˆ†æ˜¯é”€å”®ä¿¡æ¯é€šè¿‡CSVæ–‡ä»¶å¯¼å…¥çš„ç‰¹æ®Šæƒ…å†µã€‚è¿™æ˜¯ç»™æ‰¹å‘å•†çš„ï¼Œæ‰¹å‘å•†å–ç»™ç»é”€å•†ï¼Œå†è½¬é”€ã€‚',0),(449411,12484,'sv','Avsnittet provisioner i leverantÃ¶rsskulder Ã¤r fÃ¶r ett specialfall dÃ¤r fÃ¶rsÃ¤ljning information importeras via en CSV-fil. Detta Ã¤r en grossist som sÃ¤ljer till distributÃ¶rer som sedan sÃ¤ljer.',0),(449412,12484,'it','La sezione commissioni debiti Ã¨ per un caso speciale dove informazioni vendite viene importato tramite un file CSV. Questo Ã¨ per un grossista che vende ai distributori che poi rivendono.',0),(449413,12484,'tl','',0),(449414,12484,'th','à¸ªà¹ˆà¸§à¸™à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™à¹ƒà¸™à¸šà¸±à¸à¸Šà¸µà¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰à¹ƒà¸™à¸à¸£à¸“à¸µà¸žà¸´à¹€à¸¨à¸©à¸—à¸µà¹ˆà¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸²à¸£à¸‚à¸²à¸¢à¸œà¹ˆà¸²à¸™à¹à¸Ÿà¹‰à¸¡.csv à¹„à¸”à¹‰ à¸™à¸µà¹ˆà¸„à¸·à¸­',0),(449415,12484,'hi','à¤†à¤¯à¥‹à¤—à¥‹à¤‚ à¤§à¤¾à¤°à¤¾ payables à¤®à¥‡à¤‚ à¤à¤• à¤µà¤¿à¤¶à¥‡à¤· à¤®à¤¾à¤®à¤²à¤¾ à¤¹à¥ˆ à¤œà¤¹à¤¾à¤ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤à¤•. csv à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¹à',0),(449416,12484,'ms','Bahagian komisen dalam pemiutang adalah untuk kes khas di mana maklumat jualan diimport melalui fail .csv. Ini adalah untuk pemborong yang menjual kepada Pengedar yang kemudian menjual semula.',0),(449417,12484,'ar','Ù‚Ø³Ù… Ø§Ù„Ù„Ø¬Ø§Ù† ÙÙŠ Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹ Ù„Ø­Ø§Ù„Ø© Ø®Ø§ØµØ© Ø­ÙŠØ« ÙŠØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ù…Ù„Ù.csv. ÙˆÙ‡Ø°Ø§ Ù„ØªØ§Ø¬Ø± Ø¬Ù…Ù„Ø© Ø§Ù„Ø°ÙŠ ÙŠØ¨ÙŠØ¹ Ø¥Ù„Ù‰ Ø§Ù„Ù…ÙˆØ²Ø¹ÙŠÙ† Ø§Ù„Ø°ÙŠÙ',0),(449418,12484,'fr','La section des commissions dans des comptes fournisseurs est pour un cas particulier oÃ¹ les vente info est importÃ© via un fichier .csv. Il s\'agit d\'un grossiste qui vend Ã  des distributeurs qui revendent ensuite.',0),(449419,12484,'jp','å‚µå‹™ã®æ‰‹æ•°æ–™ã‚»ã‚¯ã‚·ãƒ§ãƒ³ã¯è²©å£²æƒ…å ±ã¯ .csv ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ä»‹ã—ã¦ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã‚‹ç‰¹æ®Šãªã‚±ãƒ¼ã‚¹ã§ã™ã€‚ã“ã‚Œã¯ã€å¸å£²æ¥­è€…ã€å†è²©æ¥­è€…ã«è²©å£²ã—ã¦ã„ã‚‹ãŸã‚ã§ã™ã€‚',0),(449420,12484,'pt','A seÃ§Ã£o de comissÃµes em contas a pagar Ã© para um caso especial onde a informaÃ§Ã£o das vendas Ã© importada atravÃ©s de um arquivo CSV. Isto Ã© para um atacadista que vende aos distribuidores que revendem em seguida.',0),(449421,12484,'ru','Ð Ð°Ð·Ð´ÐµÐ» ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¹ Ð² ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ñ€ÐµÐ´Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½ Ð´Ð»Ñ Ð¾ÑÐ¾Ð±Ð¾Ð³Ð¾ ÑÐ»ÑƒÑ‡Ð°Ñ, ÐºÐ¾Ð³Ð´Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐµÑ‚ÑÑ Ñ‡ÐµÑ€ÐµÐ· CSV-Ñ„Ð°Ð¹Ð». Ð­Ñ‚Ð¾ Ð´Ð»Ñ',0),(449422,12484,'es','La secciÃ³n de comisiones en pagables es para un caso especial en donde la info de las ventas esta importada via un file de .csv. Esta acciÃ³n es para un mayorista que vende a Distrbuidores quienes luego revende.',0),(449423,12484,'de','Abschnitt Kommissionen bei den Verbindlichkeiten ist ein Sonderfall, wo Verkauf Info Ã¼ber eine CSV-Datei importiert wird. Dies ist ein GroÃŸhÃ¤ndler, der HÃ¤ndler verkauft, die dann verkaufen.',0),(449424,12484,'en','The commissions section in payables is for a special case where sales info is imported via a .csv file. This is for a Wholesaler who sells to Distributors who then resell.',0),(449425,12485,'is','',0),(449426,12485,'dr','',0),(449427,12485,'pr','',0),(449428,12485,'tr','',0),(449429,12485,'pl','',0),(449430,12485,'bg','',0),(449431,12485,'ur','',0),(449432,12485,'sr','',0),(449433,12485,'vi','',0),(449434,12485,'af','',0),(449435,12485,'ro','',0),(449436,12485,'et','',0),(449437,12485,'si','',0),(449438,12485,'ba','',0),(449439,12485,'nl','',0),(449440,12485,'fi','',0),(449441,12485,'no','',0),(449442,12485,'da','',0),(449443,12485,'ko','',0),(449444,12485,'he','',0),(449445,12485,'el','',0),(449446,12485,'zh','',0),(449447,12485,'sv','',0),(449448,12485,'it','',0),(449449,12485,'tl','',0),(449450,12485,'th','',0),(449451,12485,'hi','',0),(449452,12485,'ms','',0),(449453,12485,'ar','',0),(449454,12485,'fr','',0),(449455,12485,'jp','',0),(449456,12485,'pt','',0),(449457,12485,'ru','',0),(449458,12485,'es','',0),(449459,12485,'de','',0),(449460,12485,'en','',0),(449461,12486,'is','',0),(449462,12486,'dr','',0),(449463,12486,'pr','',0),(449464,12486,'tr','',0),(449465,12486,'pl','',0),(449466,12486,'bg','',0),(449467,12486,'ur','',0),(449468,12486,'sr','',0),(449469,12486,'vi','',0),(449470,12486,'af','',0),(449471,12486,'ro','',0),(449472,12486,'et','',0),(449473,12486,'si','',0),(449474,12486,'ba','',0),(449475,12486,'nl','',0),(449476,12486,'fi','',0),(449477,12486,'no','',0),(449478,12486,'da','',0),(449479,12486,'ko','',0),(449480,12486,'he','',0),(449481,12486,'el','',0),(449482,12486,'zh','',0),(449483,12486,'sv','',0),(449484,12486,'it','',0),(449485,12486,'tl','',0),(449486,12486,'th','',0),(449487,12486,'hi','',0),(449488,12486,'ms','',0),(449489,12486,'ar','',0),(449490,12486,'fr','',0),(449491,12486,'jp','',0),(449492,12486,'pt','',0),(449493,12486,'ru','',0),(449494,12486,'es','',0),(449495,12486,'de','',0),(449496,12486,'en','',0),(449497,12487,'is','',0),(449498,12487,'dr','',0),(449499,12487,'pr','',0),(449500,12487,'tr','',0),(449501,12487,'pl','',0),(449502,12487,'bg','',0),(449503,12487,'ur','',0),(449504,12487,'sr','',0),(449505,12487,'vi','',0),(449506,12487,'af','',0),(449507,12487,'ro','',0),(449508,12487,'et','',0),(449509,12487,'si','',0),(449510,12487,'ba','',0),(449511,12487,'nl','',0),(449512,12487,'fi','',0),(449513,12487,'no','',0),(449514,12487,'da','',0),(449515,12487,'ko','',0),(449516,12487,'he','',0),(449517,12487,'el','',0),(449518,12487,'zh','',0),(449519,12487,'sv','',0),(449520,12487,'it','',0),(449521,12487,'tl','',0),(449522,12487,'th','',0),(449523,12487,'hi','',0),(449524,12487,'ms','',0),(449525,12487,'ar','',0),(449526,12487,'fr','',0),(449527,12487,'jp','',0),(449528,12487,'pt','',0),(449529,12487,'ru','',0),(449530,12487,'es','',0),(449531,12487,'de','',0),(449532,12487,'en','',0),(449533,12488,'is','',0),(449534,12488,'dr','.Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÛŒØ®Ú†Ù‡ Ø¬Ù†Ø³ ÙØ±Ù…Ø§ÛŒØ´ÛŒ ÙÙ‚Ø· Ø¢Ù†Ù‡Ø§',0),(449535,12488,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø±ÛŒØ§ÙØªÛŒ Ø´Ø§Ù…Ù„ Ø³ÙØ§Ø±Ø´Ø§ØªÛŒ Ø§Ø³Øª Ú©Ù‡ Ú©Ø§Ù„Ø§Ù‡Ø§ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ù†Ø¯ Ù…Ø«Ù„ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª Ø¨Ø§ Ø²Ù…Ø§Ù† Ú©Ø§Ø±.Ú¯Ø²Ø§Ø±Ø´ ØªØ§Ø±ÛŒØ®Ú†Ù‡ Ú©Ø§Ù„Ø§ÛŒ Ø³ÙØ§Ø±Ø´ÛŒ ÙÙ‚Ø· Ø¢Ù†Ù‡Ø§Û',0),(449536,12488,'tr','AlÄ±nan sipariÅŸler raporu nerede Ã¶ÄŸeleri, Ã§alÄ±ÅŸma sÃ¼resi ile servis sipariÅŸleri gibi kullanÄ±lmÄ±ÅŸ olabilir deÄŸil sipariÅŸlerini iÃ§erir.<p>Madde sipariÅŸ GeÃ§miÅŸi raporu yalnÄ±zca listeler bir stok maddesi nerede kullanÄ±ldÄ±.',0),(449537,12488,'pl','OtrzymaÅ‚ zamÃ³wienia raportu zawiera zamÃ³wieÅ„, gdzie elementy mogÄ… nie zostaÅ‚y wykorzystane, takich jak zlecenia serwisowe z czasu pracy.<p>Element zamÃ³wienia historia raportu wyÅ›wietla tylko te gdzie towar byÅ‚ uÅ¼ywany.',0),(449538,12488,'bg','Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ ÑÑŠÐ´ÑŠÑ€Ð¶Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, ÐºÑŠÐ´ÐµÑ‚Ð¾ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ðµ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸, ÐºÐ°Ñ‚Ð¾ Ð½Ð°Ð¿Ñ€Ð¸Ð¼ÐµÑ€ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð· Ñ Ñ‚Ñ€ÑƒÐ´ Ð²Ñ€ÐµÐ¼Ðµ.<p>Ð•Ð',0),(449539,12488,'ur','Ø­Ú©Ù… Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Ø±Ù¾ÙˆØ±Ù¹ Ø¬ÛØ§Úº Ø§Ø´ÛŒØ§ØŒ Ø³Ø±ÙˆØ³ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…Ø´Ù‚Øª ÙˆÙ‚Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ø³Ø§ØªÚ¾ Ø¬ÛŒØ³Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ ØªØ§Ú©Û Ù†Û Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ø§ Ø­Ø§Ù…Ù„ ÛÛ’ Û”<p>Ø´Û’ ØªØ±ØªÛŒØ¨ ØªØ§Ø±ÛŒØ® Ø±Ù¾ÙˆØ',0),(449540,12488,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÑÐ°Ð´Ñ€Ð¶Ð¸ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð³Ð´Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¼Ð¾Ð¶Ð´Ð° Ð½Ð¸Ñ˜Ðµ Ð¸ÑÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ð¾, ÐºÐ°Ð¾ ÑˆÑ‚Ð¾ ÑÑƒ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ ÑÐ° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¾Ð¼ Ñ€Ð°Ð´Ð°.<p>Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð°',0),(449541,12488,'vi','CÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng Ä‘Ã£ nháº­n Ä‘Æ°á»£c, bÃ¡o cÃ¡o chá»©a Ä‘á»±ng cÃ¡c Ä‘Æ¡n hÃ ng nÃ y nÆ¡i mÃ  cÃ¡c máº·t hÃ ng khÃ´ng Ä‘Æ°á»£c sá»­ dá»¥ng nhÆ° lÃ  Ä‘Æ¡n hÃ ng dá»‹ch vá»¥ vá»›i thá»i gian lao Ä‘á»™ng',0),(449542,12488,'af','Die bestellings ontvang verslag bevat bestellings waar items mag nie gewoond is, soos diens bestellings met arbeid tyd.<p>Die Item bestel geskiedenis verslag slegs diÃ© lyste waar \'n inventaris item gebruik is.',0),(449543,12488,'ro','Comenzile primite Raportul conÅ£ine comenzi Ã®n cazul Ã®n care elementele pot nu au fost utilizate, cum ar fi comenzi de service cu timp de muncÄƒ.<p>Raportul istoric de comandÄƒ element listele numai cele Ã®n cazul Ã®n care a fost folosit un element de i',0),(449544,12488,'et','Tellimused saadud aruanne sisaldab korraldusi, kus kaupu vÃµib ei kasutatud, nÃ¤iteks hooldustellimused, mille tÃ¶Ã¶ aeg.<p>Kauba tellimuste ajalugu aruandes loetletakse ainult need laokauba publikatsioonilehel.',0),(449545,12488,'si','NaroÄila prejeli poroÄilo vsebuje naloge, kjer elementi morda ni uporabljal, kot so servisni nalogi z labor Äas.<p>Element zgodovine naroÄil poroÄilo prikazuje samo tiste, kjer je bila uporabljena artikla zaloge.',0),(449546,12488,'ba','Menerima pesanan Laporan berisi perintah yang mana item mungkin tidak telah digunakan, seperti layanan pesanan dengan waktu kerja.<p>Laporan sejarah Orde Item daftar hanya mereka mana item persediaan digunakan.',0),(449547,12488,'nl','Het verslag Orders ontvangen bevat bestellingen waar items kunnen niet zijn gebruikt, zoals serviceorders met arbeid tijd.<p>Het Item bestellingshistorie rapport bevat alleen die waar een voorraadartikel werd gebruikt.',0),(449548,12488,'fi','Saadut tilaukset mietinnÃ¶ssÃ¤ tilaukset jossa nimikkeitÃ¤ voi ei on kÃ¤ytetty, kuten huoltotilauksista tyÃ¶ aikaa.<p>Nimikkeen tilaushistoria-raportissa luetellaan vain ne, jossa nimikettÃ¤ on kÃ¤ytetty.',0),(449549,12488,'no','Ordrer mottatt rapporten inneholder ordrer der varer ikke kan har blitt brukt og serviceordrer med arbeidstiden.<p>Elementet ordrehistorikk rapporten viser bare de der en lagervare ble brukt.',0),(449550,12488,'da','Ordrer modtaget rapporten indeholder ordrer, hvor elementer ikke kan har vÃ¦ret anvendt, sÃ¥som serviceordrer med arbejdskraft tid.<p>Rapporten vare ordreoversigten vises kun de hvor en lagervare blev brugt.',0),(449551,12488,'ko','ì£¼ë¬¸ ë°›ì€ ë³´ê³ ì„œ ì–´ë”” í•­ëª© ìˆ˜ëŠ” ì‚¬ìš© ë˜ì§€, ë…¸ë™ ì‹œê°„ ì„œë¹„ìŠ¤ ì£¼ë¬¸ ë“± ì£¼ë¬¸ì„ í¬í•¨ ë˜ì–´ ìžˆìŠµë‹ˆë‹¤.<p>í•­ëª© ìˆœì„œ ê¸°ë¡ ë³´ê³ ì„œ ëª©ë¡ ë“¤ë§Œ ìž¬ê³  í•­ëª© ì‚¬ìš© ë˜ì—ˆë‹¤.',0),(449552,12488,'he','×”×“×•×— ×”×–×ž× ×•×ª ×©×”×ª×§×‘×œ×• ×ž×›×™×œ ×”×•×¨××•×ª ×”×™×›×Ÿ ×¤×¨×™×˜×™× ×œ× ×©×™×ž×©, ×›×’×•×Ÿ ×”×–×ž× ×•×ª ×©×™×¨×•×ª ×¢× ×–×ž×Ÿ ×”×¢×‘×•×“×”.<p>×”×“×•×— ×”×™×¡×˜×•×¨×™×™×ª ×”×”×–×ž× ×•×ª ×¤×¨×™×˜ ×ž×¤×¨×˜ ×¨×§ ××œ×” ×©×‘×• ×©×™×ž×© ×¤×¨×™×˜ ',0),(449553,12488,'el','Î— Î­ÎºÎ¸ÎµÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€Î¿Ï… ÎµÎ»Î®Ï†Î¸Î·ÏƒÎ±Î½ Ï€ÎµÏÎ¹Î­Ï‡ÎµÎ¹ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ ÏŒÏ€Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î¼Î·Î½ Î­Ï‡Î¿Ï…Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯, ÏŒÏ€Ï‰Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Ï„ / Ï… Î¼Îµ Ï„Î¿ Ï‡ÏÏŒÎ½Î¿ ÎµÏÎ³Î±ÏƒÎ',0),(449554,12488,'zh','æ­¤æ‰€æ”¶è®¢å•çš„æŠ¥å‘ŠåŒ…å«é¡¹ç›®æœªè¢«ä½¿ç”¨çš„è®¢å•ï¼Œå¦‚æœ‰åŠ³åŠ¨æ—¶é—´çš„æœåŠ¡è®¢å•ã€‚é¡¹ç›®è®¢å•åŽ†å²æŠ¥è¡¨ä»…åˆ—å‡ºåº“å­˜é¡¹ç›®è¢«ä½¿ç”¨çš„è®¢å•ã€‚',0),(449555,12488,'sv','BestÃ¤llningar mottagna rapporten innehÃ¥ller order dÃ¤r objekt inte kan ha anvÃ¤nts, till exempel serviceorder med labor tid.<p>I artikeln orderhistorik rapporten visas endast de som en lagerartikel har anvÃ¤nts.',0),(449556,12488,'it','La relazione con gli ordini ricevuti contiene ordini dove elementi potrebbero non sono stati utilizzati, come gli ordini di servizio con il tempo di lavoro.<p>Il rapporto cronologia ordine elemento elenca solo quelli cui Ã¨ stato utilizzato un articolo di',0),(449557,12488,'tl','',0),(449558,12488,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸²à¸£à¹„à¸”à¹‰à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸›à¸£à¸°à¸à¸­à¸šà¸”à¹‰à¸§à¸¢à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸­à¸²à¸ˆà¹„à¸¡à¹ˆà¸¡à¸µà¸à¸²à¸£à¹ƒà¸Šà¹‰à¸ªà¸´à¸™à¸„à¹‰à¸² à¹€à¸Šà¹ˆà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸šà¸£à¸´à¸à¸²à¸£à¸à¸±à¸šà¹à¸£à¸‡à¸‡à¸²à¸',0),(449559,12488,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¿à¤²à¥‡ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤†à¤¦à¥‡à¤¶ à¤•à¤¹à¤¾à¤ à¤†à¤‡à¤Ÿà¤®, à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¶à¥à¤°à¤® à¤¸à¤®à¤¯ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤œà¥ˆà¤¸à¥‡ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥‹ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¤à¤¾à¥¤<p>à¤',0),(449560,12488,'ms','Laporan pesanan diterima mengandungi perintah-perintah yang di mana barang-barang mungkin tidak digunakan, seperti perkhidmatan pesanan dengan masa buruh.<p>Laporan sejarah perintah Item senarai hanya orang-orang di mana item inventori yang digunakan.',0),(449561,12488,'ar','ÙˆÙŠØªØ¶Ù…Ù† Ø§Ù„ØªÙ‚Ø±ÙŠØ± \"ØªÙ„Ù‚ÙŠ Ø£ÙˆØ§Ù…Ø±\" Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¹Ù†Ø§ØµØ± Ù‚Ø¯ Ù„Ø§ ÙŠÙƒÙˆÙ† Ù‚Ø¯ Ø§Ø³ØªØ®Ø¯Ù… ÙÙŠÙ‡Ø§ØŒ Ù…Ø«Ù„ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© Ù…Ø¹ ÙˆÙ‚Øª Ø§Ù„Ø¹Ù…Ù„.<p>ÙŠØ³Ø±Ø¯ Ø§Ù„ØªÙ‚Ø±ÙŠØ± \"ØªØ§Ø±ÙŠØ® ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù†ØµØ±\" ÙÙ‚Ø· ØªÙ„Ùƒ',0),(449562,12488,'fr','Les commandes reÃ§ues y trouvera des ordres oÃ¹ les Ã©lÃ©ments ne peuvent pas ont Ã©tÃ© utilisÃ©s, tels que les ordres de service avec le temps de travail.<p>Le rapport d\'historique de commandes point rÃ©pertorie seulement ceux oÃ¹ un inventaire a Ã©tÃ© u',0),(449563,12488,'jp','å—æ³¨ãƒ¬ãƒãƒ¼ãƒˆã«ã¯ã©ã“ã®é …ç›®ãŒä½¿ç”¨ã•ã‚Œã¦ã„ãªã„å ´åˆã€åŠ´åƒæ™‚é–“ã¨ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ãªã©ã®æ³¨æ–‡ãŒå«ã¾ã‚Œã¾ã™ã€‚<p>é …ç›®æ³¨æ–‡å±¥æ­´ãƒ¬ãƒãƒ¼ãƒˆä¸€è¦§ã®ã¿ãŒè¡¨ç¤ºã•ã‚Œã¾ã™ã€åœ¨åº«å“ç›®ãŒä½¿ç”¨ã•ã‚Œã¾ã™ã€‚',0),(449564,12488,'pt','O relatÃ³rio de ordens recebidas contÃ©m ordens onde itens podem nÃ£o ter sido utilizados, tais como ordens de serviÃ§o, com o tempo de trabalho.<p>O relatÃ³rio de histÃ³rico de pedidos Item lista apenas aqueles onde utilizou-se um item de inventÃ¡rio.',0),(449565,12488,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚ ÑÐ¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ Ð·Ð°ÐºÐ°Ð·Ñ‹, Ð³Ð´Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¼Ð¾Ð³ÑƒÑ‚ Ð½Ðµ Ð±Ñ‹Ð»Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ñ‹, Ð½Ð°Ð¿Ñ€Ð¸Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð° Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ Ñ Ñ€Ð°Ð±Ð¾Ñ‡ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ.<p>Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ð¸',0),(449566,12488,'es','El informe de Ordenes Recibidos contiene ordenes en donde items posible no habian usados, como ordnes de servicios con tiempo de labor. <p> La historia de ordenes de items solo lista ellos en donde un item de inventario se usaba.',0),(449567,12488,'de','Der Auftragseingang Bericht enthÃ¤lt Bestellungen wo Elemente nicht, z. B. Service-AuftrÃ¤ge mit Arbeitszeit verwendet wurden kÃ¶nnen.<p>Der Element-Bestellhistorie-Bericht listet nur die wo ein Lagerartikel verwendet wurde.',0),(449568,12488,'en','The Orders Received report contains orders where items may not have been used, such as service orders with labor time. <p> The Item Order History report lists only those where an inventory item was used.',0),(449569,12489,'is','',0),(449570,12489,'dr','',0),(449571,12489,'pr','',0),(449572,12489,'tr','',0),(449573,12489,'pl','',0),(449574,12489,'bg','',0),(449575,12489,'ur','',0),(449576,12489,'sr','',0),(449577,12489,'vi','',0),(449578,12489,'af','',0),(449579,12489,'ro','',0),(449580,12489,'et','',0),(449581,12489,'si','',0),(449582,12489,'ba','',0),(449583,12489,'nl','',0),(449584,12489,'fi','',0),(449585,12489,'no','',0),(449586,12489,'da','',0),(449587,12489,'ko','',0),(449588,12489,'he','',0),(449589,12489,'el','',0),(449590,12489,'zh','',0),(449591,12489,'sv','',0),(449592,12489,'it','',0),(449593,12489,'tl','',0),(449594,12489,'th','',0),(449595,12489,'hi','',0),(449596,12489,'ms','',0),(449597,12489,'ar','',0),(449598,12489,'fr','',0),(449599,12489,'jp','',0),(449600,12489,'pt','',0),(449601,12489,'ru','',0),(449602,12489,'es','',0),(449603,12489,'de','',0),(449604,12489,'en','',0),(449605,12490,'is','',0),(449606,12490,'dr','',0),(449607,12490,'pr','',0),(449608,12490,'tr','',0),(449609,12490,'pl','',0),(449610,12490,'bg','',0),(449611,12490,'ur','',0),(449612,12490,'sr','',0),(449613,12490,'vi','',0),(449614,12490,'af','',0),(449615,12490,'ro','',0),(449616,12490,'et','',0),(449617,12490,'si','',0),(449618,12490,'ba','',0),(449619,12490,'nl','',0),(449620,12490,'fi','',0),(449621,12490,'no','',0),(449622,12490,'da','',0),(449623,12490,'ko','',0),(449624,12490,'he','',0),(449625,12490,'el','',0),(449626,12490,'zh','',0),(449627,12490,'sv','',0),(449628,12490,'it','',0),(449629,12490,'tl','',0),(449630,12490,'th','',0),(449631,12490,'hi','',0),(449632,12490,'ms','',0),(449633,12490,'ar','',0),(449634,12490,'fr','',0),(449635,12490,'jp','',0),(449636,12490,'pt','',0),(449637,12490,'ru','',0),(449638,12490,'es','',0),(449639,12490,'de','',0),(449640,12490,'en','',0),(449641,12491,'is','',0),(449642,12491,'dr','',0),(449643,12491,'pr','',0),(449644,12491,'tr','',0),(449645,12491,'pl','',0),(449646,12491,'bg','',0),(449647,12491,'ur','',0),(449648,12491,'sr','',0),(449649,12491,'vi','',0),(449650,12491,'af','',0),(449651,12491,'ro','',0),(449652,12491,'et','',0),(449653,12491,'si','',0),(449654,12491,'ba','',0),(449655,12491,'nl','',0),(449656,12491,'fi','',0),(449657,12491,'no','',0),(449658,12491,'da','',0),(449659,12491,'ko','',0),(449660,12491,'he','',0),(449661,12491,'el','',0),(449662,12491,'zh','',0),(449663,12491,'sv','',0),(449664,12491,'it','',0),(449665,12491,'tl','',0),(449666,12491,'th','',0),(449667,12491,'hi','',0),(449668,12491,'ms','',0),(449669,12491,'ar','',0),(449670,12491,'fr','',0),(449671,12491,'jp','',0),(449672,12491,'pt','',0),(449673,12491,'ru','',0),(449674,12491,'es','',0),(449675,12491,'de','',0),(449676,12491,'en','',0),(449677,12492,'is','',0),(449678,12492,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ú©Ù„ Ú©Ø§Ø±Ù…Ù†Ø¯ Ø®ÙˆØ¯ Ø±Ø§ Ø§Ø² Ø§Ø¨ØªØ¯Ø§ÛŒ Ø³Ø§Ù„ ØªØ§ Ø¨Ù‡ Ø­Ø§Ù„ Ø±ÙØªÙ† Ø¨Ù‡ Ø§Ú¯Ø± Ø´Ù…Ø§ Ø¨Ù‡ ØªØ§Ø²Ú¯ÛŒ Ø´Ø±ÙˆØ¹ Ø¨Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² NolaPro Ùˆ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯:<p><b>Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯-> Ù…Ø­Ø§Ø',0),(449679,12492,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ú©Ù„ Ú©Ø§Ø±Ù…Ù†Ø¯ Ø®ÙˆØ¯ Ø±Ø§ Ø§Ø² Ø§Ø¨ØªØ¯Ø§ÛŒ Ø³Ø§Ù„ ØªØ§ Ø¨Ù‡ Ø­Ø§Ù„ Ø±ÙØªÙ† Ø¨Ù‡ Ø§Ú¯Ø± Ø´Ù…Ø§ Ø¨Ù‡ ØªØ§Ø²Ú¯ÛŒ Ø´Ø±ÙˆØ¹ Ø¨Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² NolaPro Ùˆ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯:<p><b>Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯-> Ù…Ø­Ø§Ø',0),(449680,12492,'tr','Son zamanlarda NolaPro kullanmaya baÅŸladÄ±m ve girmek istiyorsanÄ±z, Ã§alÄ±ÅŸanÄ±n toplam Ã¼cret ÅŸimdiye kadar yÄ±lÄ±n baÅŸÄ±ndan itibaren gidin:<p><b>Bordro hesaplamak ve Ã§ekleri Ã§alÄ±ÅŸanÄ±n Ã¶deme/Ded->-></b>',0),(449681,12492,'pl','JeÅ›li niedawno zaczÄ…Å‚ uÅ¼ywaÄ‡ NolaPro i potrzeba wobec wchodziÄ‡ twÃ³j pracownik caÅ‚kowitego wynagrodzenia od poczÄ…tku roku aÅ¼ do teraz przejdÅº do:<p><b>PÅ‚ac-> Oblicz i kontroli-> pracownika wynagrodzenia/Ded</b>',0),(449682,12492,'bg','ÐÐºÐ¾ Ð½Ð°ÑÐºÐ¾Ñ€Ð¾ Ð·Ð°Ð¿Ð¾Ñ‡Ð½Ð° Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° NolaPro Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð½Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð´Ð¾ ÑÐµÐ³Ð° Ð¾Ñ‚Ð¸Ð²Ð°Ð¼ ÐºÑŠÐ¼:<p><b>Ð¢Ð Ð—-> Ð¸Ð·Ñ',0),(449683,12492,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ù†Û’ Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Ø§ Ø´Ø±ÙˆØ¹ Ú©Ø±Ø¯ÛŒØ§ Ø§ÙˆØ± Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº ØªÙˆ Ø¢Ù¾ Ú©Ø§ Ù…Ù„Ø§Ø²Ù… ØªØµÙˆØ± Ú©ÛŒ Ú©Ù„ Ù…Ø²Ø¯ÙˆØ±ÛŒ Ø³Û’ Ø§Ø¨ ØªÚ© Ø§Ø³ Ø³Ø§Ù„ Ú©Û’ Ø¢ØºØ§Ø² Ú©Û’ Ù„ÛŒÛ’ Ø¬Ø§Ø¦',0),(449684,12492,'sr','ÐÐºÐ¾ ÑÑ‚Ðµ Ð½ÐµÐ´Ð°Ð²Ð½Ð¾ Ð¿Ð¾Ñ‡ÐµÐ»Ð° Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð¸ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑÐ²Ð¾Ñ˜Ðµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ ÑƒÐºÑƒÐ¿Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð° Ð¾Ð´ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¾Ð²Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð´Ð¾ ÑÐ°Ð´Ð° Ð¿Ð¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ:<p><b>ÐŸÐ»Ð',0),(449685,12492,'vi','Náº¿u gáº§n Ä‘Ã¢y báº¡n báº¯t Ä‘áº§u sá»­ dá»¥ng Nalo pro vÃ  muá»‘n nháº­p toÃ n bá»™ lÆ°Æ¡ng NV tá»« Ä‘áº§u nÄƒm Ä‘áº¿n bÃ¢y giá» thÃ¬ vÃ o: LÆ°Æ¡ng->tÃ­nh toÃ¡n vÃ  kiá»ƒm tra->tráº£ lÆ°Æ¡ng NV',0),(449686,12492,'af','As jy onlangs begin met NolaPro en tik jou werknemer se totale lone vanaf die begin van die jaar tot nou gaan na:<p><b>Heeltydse-> bereken en kontrole-> werknemer betaal/m.a. â€</b>',0),(449687,12492,'ro','DacÄƒ recent a Ã®nceput utilizarea NolaPro ÅŸi doriÅ£i sÄƒ introduceÅ£i dumneavoastrÄƒ angajat total salarii de la Ã®nceputul anului pÃ¢nÄƒ acum du-te la:<p><b>Salarizare-> se calculeazÄƒ ÅŸi controale-> angajat plata/Ded</b>',0),(449688,12492,'et','Kui olete hiljuti alustanud kasutades NolaPro ja soovivad siseneda oma tÃ¶Ã¶taja kokku tÃ¶Ã¶tasu seni aasta algusest minna:<p><b>Arvuta ja kontrolli-> tÃ¶Ã¶taja tÃ¶Ã¶tasu/Ded-> palk</b>',0),(449689,12492,'si','ÄŒe ste pred kratkim zaÄela z uporabo NolaPro in Å¾elijo vstopiti vaÅ¡ zaposleni celotne plaÄe od zaÄetka leta do sedaj pojdite na:<p><b>IzplaÄane plaÄe-> izraÄunamo in pregledi-> zaposleni plaÄati/zmletimi</b>',0),(449690,12492,'ba','Jika Anda baru saja mulai menggunakan NolaPro dan ingin memasukkan upah total karyawan Anda dari awal tahun sampai sekarang pergi ke:<p><b>Penggajian-> menghitung dan memeriksa-> karyawan gaji/Ded</b>',0),(449691,12492,'nl','Als u onlangs begonnen met behulp van NolaPro en wilt invoeren ga van uw werknemer totale lonen vanaf het begin van het jaar tot nu toe naar:<p><b>Payroll-> berekenen en controles-> werknemer Pay/Ded</b>',0),(449692,12492,'fi','Jos olet Ã¤skettÃ¤in alkanut kÃ¤yttÃ¤Ã¤ NolaPro ja haluat kirjoittaa oman tyÃ¶ntekijÃ¤n palkkojen kokonaismÃ¤Ã¤rÃ¤ alusta vuoden asti Siirry:<p><b>Palkanlaskennan-> laskeminen ja tarkastusten-> tyÃ¶ntekijÃ¤n maksu/Ded</b>',0),(449693,12492,'no','Hvis du nylig begynte Ã¥ bruke NolaPro og vil angi gÃ¥ dine ansattes samlet lÃ¸nn fra begynnelsen av Ã¥ret fÃ¸r nÃ¥ til:<p><b>LÃ¸nn-> beregning og kontrollerer-> ansatte lÃ¸nn/Ded</b>',0),(449694,12492,'da','Hvis du for nylig begyndte at bruge NolaPro og Ã¸nsker at indtaste gÃ¥ din medarbejders samlede lÃ¸n fra begyndelsen af Ã¥r indtil nu til:<p><b>LÃ¸n-> Beregn og kontrol-> medarbejder lÃ¸n/Ded</b>',0),(449695,12492,'ko','ìµœê·¼ NolaProë¥¼ ì‚¬ìš© í•˜ ì—¬ ì‹œìž‘ì„ ìž…ë ¥ í•˜ë ¤ë©´ ì§€ê¸ˆê¹Œì§€ ì˜¬í•´ì˜ ì‹œìž‘ ë¶€ë¶„ì—ì„œ ì§ì›ì˜ ì´ ìž„ê¸ˆì—ê°€ ë¼:<p><b>ê¸‰ì—¬ ê³„ì‚° ë° ê²€ì‚¬ ì§ì› ê¸‰ì—¬/Ded->-></b>',0),(449696,12492,'he','×× ×œ××—×¨×•× ×” ×”×—×œ×• ×œ×”×©×ª×ž×© NolaPro ×•×‘×¨×¦×•× ×š ×œ×”×™×›× ×¡ ×”×©×›×¨ ×”×›×•×œ×œ ×©×œ ×”×¢×•×‘×“ ×©×œ×š ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×¢×›×©×™×• ×œ×œ×›×ª:<p><b>×©×›×¨-> ×—×™×©×•×‘ ×•×ž×›× ×™×¡-> ×”×¢×•×‘×“ ×œ×©×œ×/Ded</b>',0),(449697,12492,'el','Î•Î¬Î½ ÏƒÎ±Ï‚ Ï€ÏÏŒÏƒÏ†Î±Ï„Î± Î¬ÏÏ‡Î¹ÏƒÎµ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯ NolaPro ÎºÎ±Î¹ Î¸Î­Î»Î¿Ï…Î½ Î½Î± ÎµÎ¹ÏƒÎ­Î»Î¸Î¿Ï…Î½ ÏƒÏÎ½Î¿Î»Î¿ Ï„Ï‰Î½ Î¼Î¹ÏƒÎ¸ÏŽÎ½ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ ÏƒÎ±Ï‚ Î±Ï€ÏŒ Ï„Î·Î½ Î±ÏÏ‡Î® Ï„Î¿Ï… Î­Ï„Î¿Ï…Ï‚ Î¼Î­Ï‡ÏÎ¹ Ï„ÏŽÏÎ',0),(449698,12492,'zh','å¦‚æžœæ‚¨æœ€è¿‘å¼€å§‹ä½¿ç”¨NolaProï¼Œå¹¶ä¸”æƒ³è¾“å…¥æ‚¨å‘˜å·¥ä¸€å¹´åˆ°ä»Šçš„å·¥èµ„ï¼Œåˆ°ï¼šè–ªé…¬->è®¡ç®—å’Œæ£€æŸ¥->å‘˜å·¥å·¥èµ„/æ‰£é™¤',0),(449699,12492,'sv','Om du nyligen bÃ¶rjat anvÃ¤nda NolaPro och vill komma in gÃ¥ dina anstÃ¤lldas totala lÃ¶n frÃ¥n bÃ¶rjan av Ã¥ret fram till nu till:<p><b>LÃ¶n-> berÃ¤kna och kontroller-> medarbetare lÃ¶n/Ded</b>',0),(449700,12492,'it','Se hai recentemente iniziato ad usare NolaPro e vuoi entrare salari totali del vostro dipendente dall\'inizio dell\'anno fino ad ora andare a:<p><b>Libro paga-> calcola e controlli-> dipendente paga/Ded</b>',0),(449701,12492,'tl','',0),(449702,12492,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¹€à¸žà¸´à¹ˆà¸‡à¹€à¸£à¸´à¹ˆà¸¡à¹ƒà¸Šà¹‰ NolaPro à¹à¸¥à¸°à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™ à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸£à¸§à¸¡à¸‚à¸­à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸•à¸±à¹‰à¸‡à¹à¸•à¹ˆà¸•à¹‰à¸™à¸›à¸µà¸ˆà¸™à¸–à¸¶à¸‡à¸‚à¸“à¸°à¸™à¸µà¹‰à¹„à¸›:<p><b>à¸„à¹ˆà¸²à¸ˆà',0),(449703,12492,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ NolaPro à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤¶à¥à¤°à¥‚ à¤•à¤¿à¤¯à¤¾ à¤”à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤†à¤ªà¤•à¥‡ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤…à¤¬ à¤¤à¤• à¤‡à¤¸ à¤¸à¤¾à¤² à¤•à¥€ à¤¶à¥à¤°à¥à¤†à¤¤ ',0),(449704,12492,'ms','Jika anda Tempahan mula menggunakan NolaPro dan mahu masuk upah jumlah pekerja anda dari awal tahun sampai sekarang pergi ke:<p><b>Gaji-> kira dan cek-> pekerja gaji/Anugerah</b>',0),(449705,12492,'ar','Ø¥Ø°Ø§ Ù‚Ù…Øª Ù…Ø¤Ø®Ø±Ø§ Ø¨Ø¯Ø£Øª Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ ÙˆØ£Ø±ÙŠØ¯ Ø£Ù† Ø£Ø¯Ø®Ù„ Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø£Ø¬ÙˆØ± Ø§Ù„Ù…ÙˆØ¸Ù Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù…Ù† Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø© ÙˆØ­ØªÙ‰ Ø§Ù„Ø¢Ù† Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰:<p><b>ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª-> Ø­Ø³Ø§Ø¨ ÙˆØ§Ù',0),(449706,12492,'fr','Si vous a rÃ©cemment commencÃ© Ã  utiliser NolaPro et veulent entrer dans le salaire total de votre employÃ© dÃ¨s le dÃ©but de l\'annÃ©e jusqu\'Ã  maintenant aller Ã  :<p><b>Paie-> calculer et contrÃ´les-> employÃ© paye/Ded</b>',0),(449707,12492,'jp','æœ€è¿‘ NolaPro ã®ä½¿ç”¨ã‚’é–‹å§‹ã—ã¦å ´åˆã‚’å…¥åŠ›ã—ãŸã„ä»Šã¾ã§ä»Šå¹´ã®åˆã‚ã‹ã‚‰ã‚ãªãŸã®å¾“æ¥­å“¡ã®åˆè¨ˆè³ƒé‡‘è¡Œããªã•ã„ã€‚<p><b>çµ¦ä¸Žè¨ˆç®—ã¨å¾“æ¥­å“¡çµ¦ä¸Ž/Ded-> ãƒã‚§ãƒƒã‚¯-></b>',0),(449708,12492,'pt','Se vocÃª recentemente comecei a usar o NolaPro e quero entrar os salÃ¡rios totais do seu empregado, desde o inÃ­cio do ano atÃ© agora acesse:<p><b>-> VerificaÃ§Ãµes-> empregado salÃ¡rio/Ded e calcular folha de pagamento</b>',0),(449709,12492,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð½ÐµÐ´Ð°Ð²Ð½Ð¾ Ð½Ð°Ñ‡Ð°Ð»Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ NolaPro Ð¸ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð²Ð²ÐµÑÑ‚Ð¸ Ð²ÑÐµÐ³Ð¾ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð²Ð°ÑˆÐ¸Ñ… ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð° Ð´Ð¾ ÑÐ¸Ñ… Ð¿Ð¾Ñ€ Ð¿ÐµÑ€ÐµÐ¹Ð´Ð¸Ñ‚Ðµ Ðº:<p><b>',0),(449710,12492,'es','Si recientemente comenzo usando NolaPro y quiere entrar los sueldos totales de sus empleados de la comienza del aÃ±o hasta ahora va a:<p><b>Nomina -> CÃ¡lculo y Cheques -> Pagos/Deducciones de Empleados</b>',0),(449711,12492,'de','Wenn Sie vor kurzem angefangen mit Artikel und geben mÃ¶chten verwahrlosen des Mitarbeiters Lohnsumme von Anfang des Jahres bis jetzt:<p><b>Lohn-und Gehaltsabrechnung-> berechnen und Kontrollen-> Mitarbeiter Lohn/Ded</b>',0),(449712,12492,'en','If you recently started using NolaPro and want to enter your employee\'s total wages from the beginning of the year until now go to:<p><b>Payroll -> Calculate and Checks -> Employee Pay/Ded</b>',0),(449713,12493,'is','',0),(449714,12493,'dr','',0),(449715,12493,'pr','',0),(449716,12493,'tr','',0),(449717,12493,'pl','',0),(449718,12493,'bg','',0),(449719,12493,'ur','',0),(449720,12493,'sr','',0),(449721,12493,'vi','',0),(449722,12493,'af','',0),(449723,12493,'ro','',0),(449724,12493,'et','',0),(449725,12493,'si','',0),(449726,12493,'ba','',0),(449727,12493,'nl','',0),(449728,12493,'fi','',0),(449729,12493,'no','',0),(449730,12493,'da','',0),(449731,12493,'ko','',0),(449732,12493,'he','',0),(449733,12493,'el','',0),(449734,12493,'zh','',0),(449735,12493,'sv','',0),(449736,12493,'it','',0),(449737,12493,'tl','',0),(449738,12493,'th','',0),(449739,12493,'hi','',0),(449740,12493,'ms','',0),(449741,12493,'ar','',0),(449742,12493,'fr','',0),(449743,12493,'jp','',0),(449744,12493,'pt','',0),(449745,12493,'ru','',0),(449746,12493,'es','',0),(449747,12493,'de','',0),(449748,12493,'en','',0),(449749,12494,'is','',0),(449750,12494,'dr','',0),(449751,12494,'pr','',0),(449752,12494,'tr','',0),(449753,12494,'pl','',0),(449754,12494,'bg','',0),(449755,12494,'ur','',0),(449756,12494,'sr','',0),(449757,12494,'vi','',0),(449758,12494,'af','',0),(449759,12494,'ro','',0),(449760,12494,'et','',0),(449761,12494,'si','',0),(449762,12494,'ba','',0),(449763,12494,'nl','',0),(449764,12494,'fi','',0),(449765,12494,'no','',0),(449766,12494,'da','',0),(449767,12494,'ko','',0),(449768,12494,'he','',0),(449769,12494,'el','',0),(449770,12494,'zh','',0),(449771,12494,'sv','',0),(449772,12494,'it','',0),(449773,12494,'tl','',0),(449774,12494,'th','',0),(449775,12494,'hi','',0),(449776,12494,'ms','',0),(449777,12494,'ar','',0),(449778,12494,'fr','',0),(449779,12494,'jp','',0),(449780,12494,'pt','',0),(449781,12494,'ru','',0),(449782,12494,'es','',0),(449783,12494,'de','',0),(449784,12494,'en','',0),(449785,12495,'is','',0),(449786,12495,'dr','',0),(449787,12495,'pr','',0),(449788,12495,'tr','',0),(449789,12495,'pl','',0),(449790,12495,'bg','',0),(449791,12495,'ur','',0),(449792,12495,'sr','',0),(449793,12495,'vi','',0),(449794,12495,'af','',0),(449795,12495,'ro','',0),(449796,12495,'et','',0),(449797,12495,'si','',0),(449798,12495,'ba','',0),(449799,12495,'nl','',0),(449800,12495,'fi','',0),(449801,12495,'no','',0),(449802,12495,'da','',0),(449803,12495,'ko','',0),(449804,12495,'he','',0),(449805,12495,'el','',0),(449806,12495,'zh','',0),(449807,12495,'sv','',0),(449808,12495,'it','',0),(449809,12495,'tl','',0),(449810,12495,'th','',0),(449811,12495,'hi','',0),(449812,12495,'ms','',0),(449813,12495,'ar','',0),(449814,12495,'fr','',0),(449815,12495,'jp','',0),(449816,12495,'pt','',0),(449817,12495,'ru','',0),(449818,12495,'es','',0),(449819,12495,'de','',0),(449820,12495,'en','',0),(449821,12496,'is','',0),(449822,12496,'dr','',0),(449823,12496,'pr','',0),(449824,12496,'tr','',0),(449825,12496,'pl','',0),(449826,12496,'bg','',0),(449827,12496,'ur','',0),(449828,12496,'sr','',0),(449829,12496,'vi','',0),(449830,12496,'af','',0),(449831,12496,'ro','',0),(449832,12496,'et','',0),(449833,12496,'si','',0),(449834,12496,'ba','',0),(449835,12496,'nl','',0),(449836,12496,'fi','',0),(449837,12496,'no','',0),(449838,12496,'da','',0),(449839,12496,'ko','',0),(449840,12496,'he','',0),(449841,12496,'el','',0),(449842,12496,'zh','',0),(449843,12496,'sv','',0),(449844,12496,'it','',0),(449845,12496,'tl','',0),(449846,12496,'th','',0),(449847,12496,'hi','',0),(449848,12496,'ms','',0),(449849,12496,'ar','',0),(449850,12496,'fr','',0),(449851,12496,'jp','',0),(449852,12496,'pt','',0),(449853,12496,'ru','',0),(449854,12496,'es','',0),(449855,12496,'de','',0),(449856,12496,'en','',0),(449857,12497,'is','',0),(449858,12497,'dr','',0),(449859,12497,'pr','',0),(449860,12497,'tr','',0),(449861,12497,'pl','',0),(449862,12497,'bg','',0),(449863,12497,'ur','',0),(449864,12497,'sr','',0),(449865,12497,'vi','',0),(449866,12497,'af','',0),(449867,12497,'ro','',0),(449868,12497,'et','',0),(449869,12497,'si','',0),(449870,12497,'ba','',0),(449871,12497,'nl','',0),(449872,12497,'fi','',0),(449873,12497,'no','',0),(449874,12497,'da','',0),(449875,12497,'ko','',0),(449876,12497,'he','',0),(449877,12497,'el','',0),(449878,12497,'zh','',0),(449879,12497,'sv','',0),(449880,12497,'it','',0),(449881,12497,'tl','',0),(449882,12497,'th','',0),(449883,12497,'hi','',0),(449884,12497,'ms','',0),(449885,12497,'ar','',0),(449886,12497,'fr','',0),(449887,12497,'jp','',0),(449888,12497,'pt','',0),(449889,12497,'ru','',0),(449890,12497,'es','',0),(449891,12497,'de','',0),(449892,12497,'en','',0),(449893,12498,'is','',0),(449894,12498,'dr','Ø®Ø¯Ù…Ø§Øª Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø³Ø±ÙˆÛŒØ³ Ø±Ø§ Ø§ÛŒØ¬Ø§Ø¯ Ú©Ù†ÛŒØ¯.<p>Ø¯Ø± Ù¾Ø§ÛŒÛŒÙ† Ø¯Ú©Ù…Ù‡ \"Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø²Ù…Ø§Ù† Ø¯Ø³ØªÙˆØ± Ø¯Ø§Ø¯ Ø¨Ù‡ Ù†Ø¸Ù…\" ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯.',0),(449895,12498,'pr','Ø®Ø¯Ù…Ø§Øª Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´ Ø³Ø±ÙˆÛŒØ³ Ø±Ø§ Ø§ÛŒØ¬Ø§Ø¯ Ú©Ù†ÛŒØ¯.<p>Ø¯Ø± Ù¾Ø§ÛŒÛŒÙ† Ø¯Ú©Ù…Ù‡ \"Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø²Ù…Ø§Ù† Ø¯Ø³ØªÙˆØ± Ø¯Ø§Ø¯ Ø¨Ù‡ Ù†Ø¸Ù…\" ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯.',0),(449896,12498,'tr','Ã–n Ã¶demeli hizmetler iÃ§in servis sipariÅŸi oluÅŸturma.<p>AltÄ±ndaki \"Eklemek zaman sipariÅŸ iÃ§in sipariÅŸ\" dÃ¼ÄŸmesi vardÄ±r.',0),(449897,12498,'pl','Dla usÅ‚ug pre-paid utworzyÄ‡ zlecenia serwisowego.<p>Na dole znajduje siÄ™ przycisk \"Dodaj czas zamÃ³wiÄ‡ do zamÃ³wienia\".',0),(449898,12498,'bg','Ð—Ð° Ð¿Ñ€ÐµÐ´Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ ÑƒÑÐ»ÑƒÐ³Ð¸ ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·.<p>Ð’ Ð´ÑŠÐ½Ð¾Ñ‚Ð¾ Ð¸Ð¼Ð° Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð°Ñ€ÐµÐ¶Ð´Ð° Ð´Ð° Ð±ÑƒÑ‚Ð¾Ð½ \"ÐŸÐ¾Ñ€ÑŠÑ‡Ð²Ð°Ð¼\".',0),(449899,12498,'ur','Ù¾Ø±ÛŒ Ù¾ÛŒÚˆ Ú©ÛŒ Ø®Ø¯Ù…Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ø³Ø±ÙˆØ³ ØªØ±ØªÛŒØ¨ Ø¨Ù†Ø§Ø¦ÛŒÚº Û”<p>Ø³Ø¨ Ø³Û’ Ù†ÛŒÚ†Û’ Ø¨Ù¹Ù† \"Ú©Ø§ Ø§Ø¶Ø§ÙÛ ÙˆÙ‚Øª Ú©Ø§ Ø­Ú©Ù… Ú©ÛŒ Ù†Ø¸Ù…\" ÛÛ’ Û”',0),(449900,12498,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¸Ð¿ÐµÑ˜Ð´ ÑƒÑÐ»ÑƒÐ³Ðµ.<p>ÐÐ° Ð´Ð½Ñƒ Ð¸Ð¼Ð° \"Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾ Ð´Ð° Ñ€ÐµÐ´\" Ð´ÑƒÐ³Ð¼Ðµ.',0),(449901,12498,'vi','Äá»‘i vá»›i dá»‹ch vá»¥ tráº£ trÆ°á»›c, táº¡o ra má»™t lá»‡nh dá»‹ch vá»¥. PhÃ­a dÆ°á»›i sáº½ cÃ³ nÃºt \" thÃªm thá»i gian Ä‘áº·t hÃ ng Ä‘á»ƒ Ä‘áº·t hÃ ng\"',0),(449902,12498,'af','Vir pre-paid dienste skep \'n diens bestel.<p>Aan die onderkant is daar \'n \"Voeg tyd bestel om te bestel\" knoppie.',0),(449903,12498,'ro','Pentru pre-plÄƒtit servicii a crea o comandÄƒ de Service.<p>ÃŽn partea de jos, existÄƒ un buton de \"Adauga timp comandat la comandÄƒ\".',0),(449904,12498,'et','Hooldustellimuse loomine ettemakstud teenuste puhul.<p>Allosas on \"Lisada aeg tellitud et tellimus\" nupule.',0),(449905,12498,'si','Vnaprej plaÄane storitve ustvarite servisni nalog.<p>Na dnu je gumb \"Dodaj Äasa odredil za naroÄilo\".',0),(449906,12498,'ba','Untuk layanan pra-bayar membuat pelayanan.<p>Di bawah ada tombol \"Tambahkan waktu memerintahkan untuk Order\".',0),(449907,12498,'nl','Voor vooraf betaalde diensten een serviceorder maken.<p>Aan de onderkant is er een \"Toevoegen tijd besteld To Order\"-knop.',0),(449908,12498,'fi','Ennalta maksetut palvelut Luo huoltotilaus.<p>Alareunassa on \"LisÃ¤Ã¤ aikaa tilata jotta tilaus\" painiketta.',0),(449909,12498,'no','Opprette en serviceordre for forhÃ¥ndsbetalte tjenester.<p>I bunnen er det en \"Legge tid bestilt til bestilling\" knapp.',0),(449910,12498,'da','Opret en serviceordre for forudbetalte tjenester.<p>Nederst er der en \"TilfÃ¸je tid bestilt til ordre\"-knap.',0),(449911,12498,'ko','ì„ ë¶ˆëœ ì„œë¹„ìŠ¤ì— ëŒ€ í•œ ì„œë¹„ìŠ¤ ìˆœì„œë¥¼ ë§Œë“­ë‹ˆë‹¤.<p>í•˜ë‹¨ì— \"ì¶”ê°€ ì£¼ë¬¸ì— ì˜ ì‹œê°„\" ë²„íŠ¼ì´ìž…ë‹ˆë‹¤.',0),(449912,12498,'he','×¢×‘×•×¨ ×©×™×¨×•×ª×™×-×©×©×•×œ×-×ž×¨××© ×œ×™×¦×•×¨ ×”×–×ž× ×ª ×©×™×¨×•×ª.<p>×œ×ž×˜×” ×™×© ×›×¤×ª×•×¨ \"×”×•×¡×£ ×–×ž×Ÿ ×”×•×¨×” ×œ×¤×™ ×”×–×ž× ×”\".',0),(449913,12498,'el','Î“Î¹Î± Ï€ÏÎ¿-Ï€Î»Î·ÏÏ‰Î¼Î­Î½ÎµÏ‚ Ï…Ï€Î·ÏÎµÏƒÎ¯ÎµÏ‚ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î¼Î¹Î± ÎµÎ½Ï„Î¿Î»Î® Ï„ / Ï….<p>Î£Ï„Î¿ ÎºÎ¬Ï„Ï‰ Î¼Î­ÏÎ¿Ï‚ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î­Î½Î± ÎºÎ¿Ï…Î¼Ï€Î¯ Â«Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï‡ÏÏŒÎ½Î¿ Î´Î¹Î­Ï„Î±Î¾Îµ Î½Î± Ï„Î¬Î¾Î·Â».',0),(449914,12498,'zh','ä¸ºé¢„ä»˜æ¬¾æœåŠ¡åˆ›å»ºä¸€ä¸ªæœåŠ¡è®¢å•ã€‚åœ¨åº•éƒ¨æœ‰ä¸€ä¸ªâ€œæ·»åŠ æ—¶é—´é¡ºåºåˆ°è®¢å•â€é”®ã€‚',0),(449915,12498,'sv','Skapa en serviceorder fÃ¶r fÃ¶rbetalda tjÃ¤nster.<p>LÃ¤ngst ner finns det en \"LÃ¤gg till tid bestÃ¤llt till Order\"-knapp.',0),(449916,12498,'it','Servizi pre-pagati di creare un ordine di servizio.<p>In fondo c\'Ã¨ un pulsante \"Aggiungi ordinato per ordine di tempo\".',0),(449917,12498,'tl','',0),(449918,12498,'th','à¸šà¸£à¸´à¸à¸²à¸£à¹€à¸•à¸´à¸¡à¹€à¸‡à¸´à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸šà¸£à¸´à¸à¸²à¸£<p>à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡ à¸¡à¸µà¸›à¸¸à¹ˆà¸¡ \"à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸§à¸¥à¸²à¸ªà¸±à¹ˆà¸‡à¹ƒà¸«à¹‰à¸ªà¸±à¹ˆà¸‡\"',0),(449919,12498,'hi','à¤ªà¥à¤°à¥€-à¤ªà¥‡à¤¡ à¤¸à¥‡à¤µà¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤¸à¥‡à¤µà¤¾ à¤•à¥à¤°à¤® à¤¬à¤¨à¤¾à¤à¤à¥¤<p>à¤¤à¤² à¤ªà¤° à¤µà¤¹à¤¾à¤ à¤à¤• \"à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤¸à¤®à¤¯ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥',0),(449920,12498,'ms','Perkhidmatan pra-bayar mencipta pesanan Perkhidmatan.<p>Di bahagian bawah terdapat butang \"Tambah masa diperintahkan untuk perintah\".',0),(449921,12498,'ar','Ù„Ù„Ø®Ø¯Ù…Ø§Øª Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© Ù…Ø³Ø¨Ù‚Ø§Ù‹ Ø¥Ù†Ø´Ø§Ø¡ \"Ø£Ù…Ø± Ø®Ø¯Ù…Ø©\".<p>ÙÙŠ Ø§Ù„Ø£Ø³ÙÙ„ ÙŠÙˆØ¬Ø¯ Ø²Ø± \"Ø¥Ø¶Ø§ÙØ© Ø§Ù„ÙˆÙ‚Øª Ø£Ù…Ø± Ù„Ø£Ù…Ø±\".',0),(449922,12498,'fr','Pour les services prÃ©payÃ©s crÃ©e un ordre de Service.<p>Au fond, il y a un ajouter temps commandÃ© Ã  bouton Â« Commander Â».',0),(449923,12498,'jp','ãƒ—ãƒªãƒšã‚¤ãƒ‰ ã‚µãƒ¼ãƒ“ã‚¹ã®ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã‚’ä½œæˆã—ã¾ã™ã€‚<p>ä¸‹éƒ¨ã«ã¯ã€\"è¿½åŠ æ™‚é–“ã‚’å‘½ã˜ãŸ\"æ³¨æ–‡ã™ã‚‹ãƒœã‚¿ãƒ³ã§ã™ã€‚',0),(449924,12498,'pt','Para serviÃ§os prÃ©-pagos criar uma ordem de serviÃ§o.<p>Na parte inferior hÃ¡ um botÃ£o \"Adicionar tempo ordenou a ordem\".',0),(449925,12498,'ru','Ð”Ð»Ñ Ð¿Ñ€ÐµÐ´Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ñ… ÑƒÑÐ»ÑƒÐ³ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ ÑÐµÑ€Ð²Ð¸ÑÐ½Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°.<p>Ð’Ð½Ð¸Ð·Ñƒ ÐµÑÑ‚ÑŒ ÐºÐ½Ð¾Ð¿ÐºÐ° Â«Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð» Ð² Ð¿Ð¾Ñ€ÑÐ´Ð¾ÐºÂ».',0),(449926,12498,'es','Para servicios pre-pagados crea un Orden de Servicio.<p> Al bajo hay un botÃ³n \"Aumento Tiempo de Ordenar para Ordenar\".',0),(449927,12498,'de','Legen Sie einen Serviceauftrag fÃ¼r Pre-paid Services.<p>Unten befindet sich ein hinzufÃ¼gen Zeit bestellt, Button \"Bestellen\".',0),(449928,12498,'en','For pre-paid services create a Service Order.<p> At the bottom there is a \"Add Time Ordered To Order\" button. ',0),(449929,12499,'is','',0),(449930,12499,'dr','',0),(449931,12499,'pr','',0),(449932,12499,'tr','',0),(449933,12499,'pl','',0),(449934,12499,'bg','',0),(449935,12499,'ur','',0),(449936,12499,'sr','',0),(449937,12499,'vi','',0),(449938,12499,'af','',0),(449939,12499,'ro','',0),(449940,12499,'et','',0),(449941,12499,'si','',0),(449942,12499,'ba','',0),(449943,12499,'nl','',0),(449944,12499,'fi','',0),(449945,12499,'no','',0),(449946,12499,'da','',0),(449947,12499,'ko','',0),(449948,12499,'he','',0),(449949,12499,'el','',0),(449950,12499,'zh','',0),(449951,12499,'sv','',0),(449952,12499,'it','',0),(449953,12499,'tl','',0),(449954,12499,'th','',0),(449955,12499,'hi','',0),(449956,12499,'ms','',0),(449957,12499,'ar','',0),(449958,12499,'fr','',0),(449959,12499,'jp','',0),(449960,12499,'pt','',0),(449961,12499,'ru','',0),(449962,12499,'es','',0),(449963,12499,'de','',0),(449964,12499,'en','',0),(449965,12500,'is','',0),(449966,12500,'dr','',0),(449967,12500,'pr','',0),(449968,12500,'tr','',0),(449969,12500,'pl','',0),(449970,12500,'bg','',0),(449971,12500,'ur','',0),(449972,12500,'sr','',0),(449973,12500,'vi','',0),(449974,12500,'af','',0),(449975,12500,'ro','',0),(449976,12500,'et','',0),(449977,12500,'si','',0),(449978,12500,'ba','',0),(449979,12500,'nl','',0),(449980,12500,'fi','',0),(449981,12500,'no','',0),(449982,12500,'da','',0),(449983,12500,'ko','',0),(449984,12500,'he','',0),(449985,12500,'el','',0),(449986,12500,'zh','',0),(449987,12500,'sv','',0),(449988,12500,'it','',0),(449989,12500,'tl','',0),(449990,12500,'th','',0),(449991,12500,'hi','',0),(449992,12500,'ms','',0),(449993,12500,'ar','',0),(449994,12500,'fr','',0),(449995,12500,'jp','',0),(449996,12500,'pt','',0),(449997,12500,'ru','',0),(449998,12500,'es','',0),(449999,12500,'de','',0),(450000,12500,'en','',0),(450001,12501,'is','',0),(450002,12501,'dr','',0),(450003,12501,'pr','',0),(450004,12501,'tr','',0),(450005,12501,'pl','',0),(450006,12501,'bg','',0),(450007,12501,'ur','',0),(450008,12501,'sr','',0),(450009,12501,'vi','',0),(450010,12501,'af','',0),(450011,12501,'ro','',0),(450012,12501,'et','',0),(450013,12501,'si','',0),(450014,12501,'ba','',0),(450015,12501,'nl','',0),(450016,12501,'fi','',0),(450017,12501,'no','',0),(450018,12501,'da','',0),(450019,12501,'ko','',0),(450020,12501,'he','',0),(450021,12501,'el','',0),(450022,12501,'zh','',0),(450023,12501,'sv','',0),(450024,12501,'it','',0),(450025,12501,'tl','',0),(450026,12501,'th','',0),(450027,12501,'hi','',0),(450028,12501,'ms','',0),(450029,12501,'ar','',0),(450030,12501,'fr','',0),(450031,12501,'jp','',0),(450032,12501,'pt','',0),(450033,12501,'ru','',0),(450034,12501,'es','',0),(450035,12501,'de','',0),(450036,12501,'en','',0),(450037,12502,'is','',0),(450038,12502,'dr','',0),(450039,12502,'pr','',0),(450040,12502,'tr','',0),(450041,12502,'pl','',0),(450042,12502,'bg','',0),(450043,12502,'ur','',0),(450044,12502,'sr','',0),(450045,12502,'vi','',0),(450046,12502,'af','',0),(450047,12502,'ro','',0),(450048,12502,'et','',0),(450049,12502,'si','',0),(450050,12502,'ba','',0),(450051,12502,'nl','',0),(450052,12502,'fi','',0),(450053,12502,'no','',0),(450054,12502,'da','',0),(450055,12502,'ko','',0),(450056,12502,'he','',0),(450057,12502,'el','',0),(450058,12502,'zh','',0),(450059,12502,'sv','',0),(450060,12502,'it','',0),(450061,12502,'tl','',0),(450062,12502,'th','',0),(450063,12502,'hi','',0),(450064,12502,'ms','',0),(450065,12502,'ar','',0),(450066,12502,'fr','',0),(450067,12502,'jp','',0),(450068,12502,'pt','',0),(450069,12502,'ru','',0),(450070,12502,'es','',0),(450071,12502,'de','',0),(450072,12502,'en','',0),(450073,12503,'is','',0),(450074,12503,'dr','',0),(450075,12503,'pr','',0),(450076,12503,'tr','',0),(450077,12503,'pl','',0),(450078,12503,'bg','',0),(450079,12503,'ur','',0),(450080,12503,'sr','',0),(450081,12503,'vi','',0),(450082,12503,'af','',0),(450083,12503,'ro','',0),(450084,12503,'et','',0),(450085,12503,'si','',0),(450086,12503,'ba','',0),(450087,12503,'nl','',0),(450088,12503,'fi','',0),(450089,12503,'no','',0),(450090,12503,'da','',0),(450091,12503,'ko','',0),(450092,12503,'he','',0),(450093,12503,'el','',0),(450094,12503,'zh','',0),(450095,12503,'sv','',0),(450096,12503,'it','',0),(450097,12503,'tl','',0),(450098,12503,'th','',0),(450099,12503,'hi','',0),(450100,12503,'ms','',0),(450101,12503,'ar','',0),(450102,12503,'fr','',0),(450103,12503,'jp','',0),(450104,12503,'pt','',0),(450105,12503,'ru','',0),(450106,12503,'es','',0),(450107,12503,'de','',0),(450108,12503,'en','',0),(450109,12504,'is','',0),(450110,12504,'dr','',0),(450111,12504,'pr','',0),(450112,12504,'tr','',0),(450113,12504,'pl','',0),(450114,12504,'bg','',0),(450115,12504,'ur','',0),(450116,12504,'sr','',0),(450117,12504,'vi','',0),(450118,12504,'af','',0),(450119,12504,'ro','',0),(450120,12504,'et','',0),(450121,12504,'si','',0),(450122,12504,'ba','',0),(450123,12504,'nl','',0),(450124,12504,'fi','',0),(450125,12504,'no','',0),(450126,12504,'da','',0),(450127,12504,'ko','',0),(450128,12504,'he','',0),(450129,12504,'el','',0),(450130,12504,'zh','',0),(450131,12504,'sv','',0),(450132,12504,'it','',0),(450133,12504,'tl','',0),(450134,12504,'th','',0),(450135,12504,'hi','',0),(450136,12504,'ms','',0),(450137,12504,'ar','',0),(450138,12504,'fr','',0),(450139,12504,'jp','',0),(450140,12504,'pt','',0),(450141,12504,'ru','',0),(450142,12504,'es','',0),(450143,12504,'de','',0),(450144,12504,'en','',0),(450145,12505,'is','',0),(450146,12505,'dr','Ø¯Ø± Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ ÙØ±ÙˆØ´ GL Ø­Ø³Ø§Ø¨ Ø­Ø³Ø§Ø¨ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯.<p>Ø§Ú¯Ø± Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø¨Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø¯Ø± ØµÙØ­Ù‡ ÙˆÛŒØ±Ø§ÛŒØ´ Ù…ÙˆØ±Ø¯ Ø±ÙØªÙ† Ø¨Ù‡:<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ù…',0),(450147,12505,'pr','Ø¯Ø± Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ ÙØ±ÙˆØ´ GL Ø­Ø³Ø§Ø¨ Ø­Ø³Ø§Ø¨ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯.<p>Ø§Ú¯Ø± Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø¨Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø¯Ø± ØµÙØ­Ù‡ ÙˆÛŒØ±Ø§ÛŒØ´ Ù…ÙˆØ±Ø¯ Ø±ÙØªÙ† Ø¨Ù‡:<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ù…',0),(450148,12505,'tr','POS GL satÄ±ÅŸ hesabÄ± varsayÄ±lan hesap kullanabilir.<p>Ã–ÄŸe DÃ¼zenle ekranda belirtilen satÄ±ÅŸ hesabÄ± kullanmak istiyorsanÄ±z gidin:<p><b>YÃ¶netici Kurulumu stok Genel Kurulum->->.</b><p>KullanÄ±m madde satÄ±ÅŸ hesabÄ± (deÄŸil mÃ¼ÅŸteri) seÃ§eneÄŸini',0),(450149,12505,'pl','W POS GL sprzedaÅ¼y kont moÅ¼e uÅ¼yÄ‡ domyÅ›lnego konta.<p>JeÅ›li chcesz korzystaÄ‡ z konta sprzedaÅ¼y okreÅ›lona na ekranie Edytuj element przejdÅº do:<p><b>Admin-> zapasÃ³w ustawienia-> ustawienia ogÃ³lne.</b><p>Zaznacz opcjÄ™ wykorzystania przedmiotu s',0),(450150,12505,'bg','Ð’ POS GL Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ.<p>ÐÐºÐ¾ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚ÑŠÑ‚, Ð·Ð°Ð´Ð°Ð´ÐµÐ½ Ð² ÐµÐºÑ€Ð°Ð½Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½',0),(450151,12505,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ù…ÛŒÚº Ø¬ÛŒØ¬Û’ ÙØ±ÙˆØ®Øª Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ùˆ Ø·Û’ Ø´Ø¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº Û”<p>Ø§Ú¯Ø± Ø¢Ù¾ Ú©ÛŒ Ø´Û’ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ø§Ø³Ú©Ø±ÛŒÙ† Ù¾Ø± Ù…Ø®ØµÙˆØµ Ú©Ø±Ø¯Û Ø³ÛŒÙ„Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø³ØªØ¹',0),(450152,12505,'sr','Ð£ ÐŸÐžÐ¡ Ð“Ð› Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð¼Ð¾Ð³Ñƒ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ ÐºÐ°Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³.<p>ÐÐºÐ¾ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ ÐºÐ¾Ð½Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð½Ð°Ð²ÐµÐ´ÐµÐ½ Ð½Ð° Ð·Ð°ÑÐ»Ð¾Ð½Ñƒ Ð£Ñ€ÐµÐ´Ð¸ ÑÑ‚Ð°Ð²ÐºÑ',0),(450153,12505,'vi','Trong POS, tÃ i khoáº£n bÃ¡n hÃ ng cÃ³ thá»ƒ sá»­ dá»¥ng tÃ i khoáº£n máº·c Ä‘á»‹nh. Náº¿u báº¡n muá»‘n sá»­ dá»¥ng TK quy Ä‘á»‹nh thÃ¬ vÃ o : quÃ n lÃ½-thiáº¿t láº­p hÃ ng tá»“n kho-cÃ i Ä‘áº·t.Kiá»ƒm tra viá»‡c sá»­ dá»¥ng cÃ¡c TK bÃ¡n hÃ ng',0),(450154,12505,'af','In POS die GL verkope kan rekening die verstekrekening gebruik.<p>As jy wil gebruik die verkope rekening vermeld op die Item redigeer skerm gaan na:<p><b>Admin-> opstelling voorraad-> algemene opstelling.</b><p>Kontroleer die gebruik Item verkope rekening',0),(450155,12505,'ro','ÃŽn POS GL de vÃ¢nzÄƒri cont poate utiliza contul implicit.<p>DacÄƒ doriÅ£i sÄƒ utilizaÅ£i Ã®n contul de vÃ¢nzÄƒri specificat pe ecranul Editare element du-te la:<p><b>Admin-> Parametrizare stocuri-> Parametrizare.</b><p>BifaÅ£i opÅ£iunea utilizare elemen',0),(450156,12505,'et','POS GL mÃ¼Ã¼k kontot vÃµib kasutada vaikekonto.<p>Kui soovite kasutada mÃ¤Ã¤ratud Ã¼ksust redigeerida aknas mÃ¼Ã¼gi kontole minna:<p><b>Admin-> Setup varude Ã¼ldine seadistus->.</b><p>Saate kasutada kauba mÃ¼Ã¼k konto (mitte klient) vÃµimalus.',0),(450157,12505,'si','V POS GL prodaja raÄun lahko uporabite privzeti raÄun.<p>ÄŒe Å¾elite uporabiti Konto prodaje, ki je doloÄen na zaslonu Uredi element iti:<p><b>Admin-> nastavitev zaloge-> Nastavitev sploÅ¡nega.</b><p>Preverite moÅ¾nost uporabe artikla prodaje raÄun (n',0),(450158,12505,'ba','Dalam POS penjualan GL akun dapat menggunakan default account.<p>Jika Anda ingin menggunakan account penjualan yang ditentukan pada layar Item Edit pergi ke:<p><b>Admin-> Setup persediaan-> tetapan umum.</b><p>Periksa pilihan penggunaan Item penjualan Acc',0),(450159,12505,'nl','In POS de GL verkoop mag rekening de standaardaccount gebruiken.<p>Als u wilt gebruiken de Sales account die is opgegeven op het scherm Item bewerken gaat u naar:<p><b>Admin-> Setup voorraad-> algemene Setup.</b><p>Vink de optie gebruik artikelrekening ve',0),(450160,12505,'fi','POS GL myynti tili voi kÃ¤yttÃ¤Ã¤ oletustiliÃ¤.<p>Jos haluat kÃ¤yttÃ¤Ã¤ myynnin tilin mÃ¤Ã¤ritetty kohteen Muokkaa-nÃ¤ytÃ¶ssÃ¤ Siirry:<p><b>Admin asetukset varaston-> asennuksen->.</b><p>Valitse KÃ¤ytÃ¤ nimikkeen myynnin tili (ei asiakas).',0),(450161,12505,'no','I POS GL salg kan konto bruke standardkontoen.<p>Hvis du vil bruke mva-kontoen som er angitt pÃ¥ skjermbildet Rediger element gÃ¥ til:<p><b>Admin-> installasjonsprogrammet lager-> generelt oppsett.</b><p>Alternativet Bruk varekonto salg (ikke kunden).',0),(450162,12505,'da','I POS GL salg kan konto bruge standardkontoen.<p>Hvis du vil bruge den Salgskonto, angivet pÃ¥ skÃ¦rmbilledet vare redigere gÃ¥ til:<p><b>Admin-> Setup lager-> General Setup.</b><p>Kontroller indstillingen Brug vare Salgskonto (ikke kunde).',0),(450163,12505,'ko','POS GL íŒë§¤ì—ì„œì—ì„œ ê³„ì • ê¸°ë³¸ ê³„ì •ì„ ì‚¬ìš©í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p>í•­ëª© íŽ¸ì§‘ í™”ë©´ì— ì§€ì • ëœ íŒë§¤ ê³„ì •ì„ ì‚¬ìš© í•˜ë ¤ëŠ” ê²½ìš°ì— ë¼:<p><b>ì¼ë°˜ ì„¤ì¹˜-> ì„¤ì¹˜ ìž¬ê³ -> ê´€ë¦¬ìžìž…ë‹ˆë‹¤.</b><p>ì‚¬ìš© í•­ëª© íŒë§¤ ê³„ì • ',0),(450164,12505,'he','×‘- POS ×”×ž×›×™×¨×•×ª GL ×—×©×‘×•×Ÿ ×™×›×•×œ ×œ×”×©×ª×ž×© ×‘×—×©×‘×•×Ÿ ×‘×¨×™×¨×ª ×”×ž×—×“×œ.<p>×× ×‘×¨×¦×•× ×š ×œ×”×©×ª×ž×© ×‘×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª ×©×¦×•×™× ×” ×¢×œ-×’×‘×™ ×”×ž×¡×š ×œ×¢×¨×•×š ×¤×¨×™×˜ ×œ×œ×›×ª:<p><b>Admin-> ×”×’×“×¨×ª ×ž×œ××™-> ×›',0),(450165,12505,'el','Î£Îµ POS Ï„Î¹Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹ Ï„Î¿Î½ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ.<p>Î‘Î½ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ ÏƒÏ„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Ï‰Î»Î®Ï',0),(450166,12505,'zh','åœ¨é”€å”®ç‚¹ï¼Œæ€»å¸é”€å”®å¸æˆ·ä¼šä½¿ç”¨é»˜è®¤å¸æˆ·ã€‚å¦‚æžœä½ æƒ³ä½¿ç”¨é¡¹ç›®ç¼–è¾‘é¡µé¢ä¸Šçš„ç‰¹å®šé”€å”®å¸æˆ·ï¼Œåˆ°ï¼šç®¡ç†->è®¾ç½®åº“å­˜->æ™®é€šè®¾ç½®ã€‚\r\næ£€æŸ¥é¡¹ç›®é”€å”®å¸æˆ·ï¼ˆéžé¡¾å®¢ï¼‰é€‰é¡¹çš„ä½¿ç”¨ã€‚',0),(450167,12505,'sv','I POS GL fÃ¶rsÃ¤ljning kan konto anvÃ¤nda standardkontot.<p>Om du vill anvÃ¤nda det fÃ¶rsÃ¤ljning konto som anges pÃ¥ skÃ¤rmen objektet redigera gÃ¥ till:<p><b>Admin-> Setup inventering-> allmÃ¤n instÃ¤llning.</b><p>Markera alternativet AnvÃ¤nd punkt fÃ¶r',0),(450168,12505,'it','Nel POS le vendite GL account puÃ² utilizzare l\'account predefinito.<p>Se si desidera utilizzare l\'account di vendite specificato nella schermata Modifica elemento Vai a:<p><b>Admin-> Inventory Setup-> Setup generale.</b><p>Selezionare l\'opzione usare Ite',0),(450169,12505,'tl','',0),(450170,12505,'th','à¹ƒà¸™ POS à¸‚à¸²à¸¢ GL à¸šà¸±à¸à¸Šà¸µà¸­à¸²à¸ˆà¹ƒà¸Šà¹‰à¸šà¸±à¸à¸Šà¸µà¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™<p>à¸–à¹‰à¸²à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸šà¸±à¸à¸Šà¸µà¸à¸²à¸£à¸‚à¸²à¸¢à¸—à¸µà¹ˆà¸£à¸°à¸šà¸¸à¸šà¸™à¸«à¸™à¹‰à¸²à¸ˆà¸­à¸£à¸²à¸¢à¸à¸²à¸£à¹à¸à¹‰à¹„',0),(450171,12505,'hi','POS GL à¤¬à¤¿à¤•à¥à¤°à¥€ à¤®à¥‡à¤‚ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤–à¤¾à¤¤à¤¾ à¤–à¤¾à¤¤à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤<p>à¤¯à¤¦à¤¿ à¤†à¤ª à¤¬à¤¿à¤•à¥à¤°à¥€ à¤†à¤‡à¤Ÿà¤® à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤ªà¤° à¤¨à',0),(450172,12505,'ms','Dalam POS jualan GL akaun boleh menggunakan akaun lalai.<p>Jika anda ingin menggunakan akaun jualan yang ditetapkan pada skrin Edit butiran ke:<p><b>Admin-> persediaan inventori-> persediaan umum.</b><p>Semak opsyen penggunaan Item jualan akaun (tidak Bac',0),(450173,12505,'ar','ÙÙŠ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª GL Ø­Ø³Ø§Ø¨ ÙŠØ¬ÙˆØ² Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ.<p>Ø¥Ø°Ø§ ÙƒÙ†Øª ØªØ±ÙŠØ¯ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ù…Ø­Ø¯Ø¯ Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø§Ø´Ø© \"ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¨Ù†Ø¯\" Ø§Ù„Ø°Ù‡Ø§Ø¨ Ø¥Ù„Ù‰:<',0),(450174,12505,'fr','En POS les ventes GL compte peut utiliser le compte par dÃ©faut.<p>Si vous souhaitez utiliser le compte de ventes spÃ©cifiÃ© sur l\'Ã©cran modifier le point aller Ã  :<p><b>Admin-> Setup inventaire-> installation gÃ©nÃ©rale.</b><p>Cochez l\'option utiliser ',0),(450175,12505,'jp','POS GL è²©å£²ã§ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã€æ—¢å®šã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½¿ç”¨å¯èƒ½æ€§ãŒã‚ã‚Šã¾ã™ã€‚<p>é …ç›®ã®ç·¨é›†] ç”»é¢ã§æŒ‡å®šã•ã‚ŒãŸè²©å£²ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½¿ç”¨ã™ã‚‹å ´åˆã«è¡Œãï¼š<p><b>ä¸€èˆ¬çš„ãªã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—-> ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—åœ¨åº«',0),(450176,12505,'pt','No POS vendas GL conta pode usar a conta padrÃ£o.<p>Se vocÃª quiser usar a conta de vendas especificada na tela Editar Item vÃ¡ para:<p><b>Admin-> inventÃ¡rio de configuraÃ§Ã£o-> configuraÃ§Ã£o geral.</b><p>Marque a opÃ§Ã£o usar Item vendas conta (nÃ£o cl',0),(450177,12505,'ru','Ð’ POS GL Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¼Ð¾Ð¶ÐµÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ.<p>Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð° ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸, ÑƒÐºÐ°Ð·Ð°Ð½Ð½Ð¾Ð',0),(450178,12505,'es','En las cuentas  de PDV y Ventas puede usal la cunta por defecto.<p>Si quiere usar la cuenta de vneta especificada en la pantalla de Editar Items va a:<p><b>Admin->Configurar Inventario->ConfiguraciÃ³n General.</b><p> Chequea la opciÃ³n de la cuenta del it',0),(450179,12505,'de','POS die GL-VerkÃ¤ufe kÃ¶nnen Konto das Standardkonto verwenden.<p>Wenn Sie die Sales-Account angegeben auf dem Bildschirm Element bearbeiten verwenden mÃ¶chten gehen Sie zu:<p><b>Admin-> Lager Einrichtung-> General Setup.</b><p>KÃ¤stchen Sie Verwendung El',0),(450180,12505,'en','In POS the GL Sales account may use the default account.<p>If you want to use the Sales account specified on the Item Edit screen go to:<p><b>Admin->Setup Inventory->General Setup.</b><p> Check the Use Item Sales Account (not Customer) option.',0),(450181,12506,'is','',0),(450182,12506,'dr','',0),(450183,12506,'pr','',0),(450184,12506,'tr','',0),(450185,12506,'pl','',0),(450186,12506,'bg','',0),(450187,12506,'ur','',0),(450188,12506,'sr','',0),(450189,12506,'vi','',0),(450190,12506,'af','',0),(450191,12506,'ro','',0),(450192,12506,'et','',0),(450193,12506,'si','',0),(450194,12506,'ba','',0),(450195,12506,'nl','',0),(450196,12506,'fi','',0),(450197,12506,'no','',0),(450198,12506,'da','',0),(450199,12506,'ko','',0),(450200,12506,'he','',0),(450201,12506,'el','',0),(450202,12506,'zh','',0),(450203,12506,'sv','',0),(450204,12506,'it','',0),(450205,12506,'tl','',0),(450206,12506,'th','',0),(450207,12506,'hi','',0),(450208,12506,'ms','',0),(450209,12506,'ar','',0),(450210,12506,'fr','',0),(450211,12506,'jp','',0),(450212,12506,'pt','',0),(450213,12506,'ru','',0),(450214,12506,'es','',0),(450215,12506,'de','',0),(450216,12506,'en','',0),(450217,12507,'is','',0),(450218,12507,'dr','Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù† Ù¾ÙˆÙ„ Ø´Ø±Ú©Øª Ù¾ÛŒØ´ Ø§Ø² Ø§Ø±Ø§Ø¦Ù‡ Ø®Ø¯Ù…Ø§Øª Ùˆ ÛŒØ§ Ù…Ø­ØµÙˆÙ„Ø§Øª Ø¯Ø±ÛŒØ§ÙØª Ù†Ù…Ø§ÛŒÙ†Ø¯Ú¯ÛŒ.<p>Ø§ÛŒÙ† Ø§Ø³Øª Ú©Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¨Ø¯Ù‡ÛŒ Ù‡Ø§ÛŒ Ø¬Ø§Ø±ÛŒ Ø¯Ø± ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÛŒ Ø´Ø¯Ù‡.<p>Ø¯Ù„ÛŒ',0),(450219,12507,'pr','Ø³Ù¾Ø±Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù† Ù¾ÙˆÙ„ Ø´Ø±Ú©Øª Ù¾ÛŒØ´ Ø§Ø² Ø§Ø±Ø§Ø¦Ù‡ Ø®Ø¯Ù…Ø§Øª Ùˆ ÛŒØ§ Ù…Ø­ØµÙˆÙ„Ø§Øª Ø¯Ø±ÛŒØ§ÙØª Ù†Ù…Ø§ÛŒÙ†Ø¯Ú¯ÛŒ.<p>Ø§ÛŒÙ† Ø§Ø³Øª Ú©Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¨Ø¯Ù‡ÛŒ Ù‡Ø§ÛŒ Ø¬Ø§Ø±ÛŒ Ø¯Ø± ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÛŒ Ø´Ø¯Ù‡.<p>Ø¯Ù„ÛŒ',0),(450220,12507,'tr','MÃ¼ÅŸteri mevduat para bir hizmet veya Ã¼rÃ¼n saÄŸlayan Ã¶ncesinde alÄ±nan ÅŸirket temsil eder.<p>Bunlar bilanÃ§oda geÃ§erli bir sorumluluk olarak sÄ±nÄ±flandÄ±rÄ±lÄ±r.<p>BorÃ§lu ÅŸirket hala hizmet veya Ã¼rÃ¼n bir sorumluluk iÃ§indir.',0),(450221,12507,'pl','Depozyty klientÃ³w stanowiÄ… pieniÄ…dze firma otrzymaÅ‚a przed Å›wiadczÄ…cy usÅ‚ugi lub produktu.<p>SÄ… one sklasyfikowane jako bieÅ¼Ä…cego zobowiÄ…zania na dzieÅ„ bilansowy.<p>To zobowiÄ…zanie, poniewaÅ¼ firma nadal zawdziÄ™cza usÅ‚ugi lub produktu.',0),(450222,12507,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÑÐ²Ð°Ñ‚ Ð¿Ð°Ñ€Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð·Ð° Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð° Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚.<p>Ð¢Ðµ ÑÐ° ÐºÐ»Ð°ÑÐ¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð¸ ÐºÐ°Ñ‚Ð¾ Ñ‚ÐµÐºÑƒÑ‰Ð¸ Ð·Ð°Ð´Ñ',0),(450223,12507,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ø°Ø®Ø§Ø¦Ø± Ø±Ù‚Ù… ÙˆØµÙˆÙ„ Ú©ÛŒ Ø§ÛŒÚ© Ø³Ø±ÙˆØ³ ÛŒØ§ Ù…ØµÙ†ÙˆØ¹Ø§Øª ÙØ±Ø§ÛÙ… Ú©Ø±Ù†Û’ Ø³Û’ Ù¾ÛÙ„Û’ Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ù†Ù…Ø§Ø¦Ù†Ø¯Ú¯ÛŒ Ú©Ø±ØªÛ’ ÛÛŒÚº Û”<p>ÛŒÛ Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ Ù¾Ø± Ø§ÛŒÚ© Ù…ÙˆØ¬ÙˆØ¯Û Ø°Ù…Û Ø¯Ø§Ø±ÛŒ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø¯',0),(450224,12507,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ñ™Ð°Ñ˜Ñƒ Ð½Ð¾Ð²Ñ†Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð´Ð¾Ð±Ð¸Ð»Ð° Ð¿Ñ€Ðµ Ð¿Ñ€ÑƒÐ¶Ð°ÑšÐµ ÑƒÑÐ»ÑƒÐ³Ð° Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°.<p>ÐžÐ²Ð¾ ÑÑƒ ÐºÐ»Ð°ÑÐ¸Ñ„Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¸ ÐºÐ°Ð¾ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð¿Ñ€ÐµÐ¿Ñ€ÐµÐºÐ° Ð½Ð° Ð±Ð¸Ð»Ð°Ð½',0),(450225,12507,'vi','KhÃ¡ch hÃ ng á»©ng trÆ°á»›c tiá»n, cÃ´ng ty nháº­n tiá»n trÆ°á»›c khi cung cáº¥p dá»‹ch vá»¥ hoáº·c sáº£n pháº©m. Äiá»u nÃ y Ä‘Æ°á»£c phÃ¢n loáº¡i nhÆ° khoáº£n ná»£ hiá»‡n hÃ nh trÃªn báº£ng CDKT, NÃ³ lÃ  má»™t khoáº£n ná»£ bá»Ÿi vÃ¬ cty váº«n cÃ²n nï',0),(450226,12507,'af','Klantedeposito\'s verteenwoordig geld die maatskappy opmars van die verskaffing van \'n diens of produk ontvang.<p>Dit word geklassifiseer as \'n huidige aanspreeklikheid op die balansstaat.<p>Dit is \'n aanspreeklikheid omdat die maatskappy steeds skuld die ',0),(450227,12507,'ro','Depozitele clienÅ£ilor reprezintÄƒ banii companiei primit Ã®naintea oferirea unui serviciu sau produs.<p>Acestea sunt clasificate ca un curent de rÄƒspundere Ã®n balanÅ£Äƒ.<p>Este un pasiv, deoarece compania Ã®ncÄƒ datoreazÄƒ produs sau serviciu.',0),(450228,12507,'et','Klientide hoiuste maht moodustab raha sai enne teenuse vÃµi toote firma.<p>Need liigitatakse lÃ¼hiajaliseks bilansis.<p>Siis pole kohustise firma vÃµlgneb endiselt teenusele vÃµi tootele.',0),(450229,12507,'si','Depoziti strank predstavljajo denar druÅ¾ba prejela pred zagotavljanjem storitev ali izdelek.<p>Ti so razvrÅ¡Äeni kot trenutni obveznost v bilanci stanja.<p>To je obveznost, ker druÅ¾ba Å¡e vedno dolguje storitev ali izdelek.',0),(450230,12507,'ba','Simpanan nasabah mewakili uang perusahaan menerima sebelum memberikan layanan atau produk.<p>Ini diklasifikasikan sebagai kewajiban saat ini pada neraca.<p>Ini adalah tanggung jawab karena perusahaan ini masih berutang layanan atau produk.',0),(450231,12507,'nl','Klant deposito\'s vertegenwoordigen geld het bedrijf ontvangen voorafgaand aan die een dienst of product.<p>Deze zijn ingedeeld als een huidige verplichting op de balans.<p>Het is een verplichting, omdat het bedrijf nog steeds de dienst of product dankt.',0),(450232,12507,'fi','Asiakkaan talletuksiin edustavat rahaa yritys sai ennen tarjota palvelua tai tuotetta.<p>NÃ¤mÃ¤ luokitellaan taseessa lyhytaikaiseksi.<p>Siksi vastuu yhtiÃ¶n vielÃ¤ velkaa palvelu tai tuote.',0),(450233,12507,'no','Kunde innskudd representerer penger selskapet mottatt fÃ¸r gir en tjeneste eller produkt.<p>Dette er klassifisert som kortsiktig gjeld i balansen.<p>Det er en forpliktelse fordi selskapet fortsatt skylder tjenesten eller produktet.',0),(450234,12507,'da','Kunde indskud reprÃ¦senterer penge selskabet modtaget forud for at levere en service eller et produkt.<p>Disse er klassificeret som en aktuel forpligtelse i balancen.<p>Det er et ansvar, fordi selskabet stadig skylder service eller produkt.',0),(450235,12507,'ko','ê³ ê° ì˜ˆê¸ˆ ëˆì„ ì‚¬ì „ì— ì„œë¹„ìŠ¤ ë˜ëŠ” ì œí’ˆì„ ì œê³µ ë°›ì€ íšŒì‚¬ ëŒ€í‘œ.<p>ì´ ëŒ€ì°¨ ëŒ€ì¡°í‘œì— í˜„ìž¬ ì±…ìž„ìœ¼ë¡œ ë¶„ë¥˜ ë©ë‹ˆë‹¤.<p>ì±…ìž„ ì´ë¯€ë¡œ íšŒì‚¬ ì•„ì§ë„ ë¹šì´ ì„œë¹„ìŠ¤ ë˜ëŠ” ì œí’ˆ.',0),(450236,12507,'he','×¤×§×“×•× ×•×ª ×œ×§×•×—×•×ª ×ž×™×™×¦×’×™× ×›×¡×£ ×”×—×‘×¨×” ×”×ª×§×‘×œ ×œ×¤× ×™ ×ž×ª×Ÿ ×©×™×¨×•×ª ××• ×ž×•×¦×¨.<p>××œ×” ×ž×¡×•×•×’×™× ×› × ×˜×œ ×”× ×•×›×—×™ ×¢×œ ×”×ž××–×Ÿ.<p>×–×” × ×˜×œ ×›×™ ×”×—×‘×¨×” ×¢×“×™×™×Ÿ ×—×™×™×‘ ××ª ×”×©×™×¨×•×ª ××• ×”×ž',0),(450237,12507,'el','ÎšÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î±Î½Ï„Î¹Ï€ÏÎ¿ÏƒÏ‰Ï€ÎµÏÎ¿Ï…Î½ Ï‡ÏÎ®Î¼Î±Ï„Î± Î· ÎµÏ€Î¹Ï‡ÎµÎ¯ÏÎ·ÏƒÎ· Î­Î»Î±Î²Îµ ÎµÎº Ï„Ï‰Î½ Ï€ÏÎ¿Ï„Î­ÏÏ‰Î½ Ï€Î±ÏÎ­Ï‡ÎµÎ¹ Î¼Î¹Î± Ï…Ï€Î·ÏÎµÏƒÎ¯Î± Î® Ï€ÏÎ¿ÏŠÏŒÎ½.<p>Î‘Ï…Ï„Î­Ï‚ Ï‡Î±ÏÎ±ÎºÏ„Î·ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹ Ï‰Ï‚ Ï„Ï',0),(450238,12507,'zh','é¡¾å®¢å­˜æ¬¾ä»£è¡¨å…¬å¸æ‰€æ”¶çš„æ¬¾é¡¹æå‰æä¾›ä¸€ä¸ªæœåŠ¡æˆ–äº§å“ã€‚è¿™äº›æ˜¯ä½œä¸ºèµ„äº§è´Ÿå€ºè¡¨ä¸Šçš„æµåŠ¨è´Ÿå€ºã€‚è¿™æ˜¯ä¸€ç§å€ºåŠ¡å› ä¸ºå…¬å¸ä»ç„¶æ¬ æœåŠ¡æˆ–äº§å“ã€‚',0),(450239,12507,'sv','Kund inlÃ¥ning representerar pengar fick fÃ¶re som tillhandahÃ¥ller en tjÃ¤nst eller produkt fÃ¶retaget.<p>Dessa klassificeras som en kortfristig skuld i balansrÃ¤kningen.<p>Det Ã¤r en skuld eftersom fÃ¶retaget fortfarande skyldig den tjÃ¤nst eller produk',0),(450240,12507,'it','Depositi dei clienti rappresentano denaro la societÃ  ha ricevuto in anticipo di fornire un servizio o prodotto.<p>Questi sono classificati come passivitÃ  correnti nel bilancio.<p>Ãˆ una responsabilitÃ  perchÃ© l\'azienda deve ancora il prodotto o servizi',0),(450241,12507,'tl','',0),(450242,12507,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸«à¸¡à¸²à¸¢à¸–à¸¶à¸‡à¹€à¸‡à¸´à¸™à¸£à¸±à¸šà¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²à¸à¸²à¸£à¹ƒà¸«à¹‰à¸šà¸£à¸´à¸à¸²à¸£à¸«à¸£à¸·à¸­à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¸‚à¸­à¸‡à¸šà¸£à¸´à¸©à¸±à¸—<p>à¹€à¸«à¸¥à¹ˆà¸²à¸™à¸µà¹‰à¸ˆà¸°à¸ˆà¸±à¸”à¸›à¸£',0),(450243,12507,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤®à¤¾ à¤ªà¥ˆà¤¸à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤à¤• à¤¸à¥‡à¤µà¤¾ à¤¯à¤¾ à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤•à¤°à¤¾à¤¨à¥‡ à¤•à¥‡ à¤…à¤—à¥à¤°à¤¿à¤® à¤®à¥‡à¤‚ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿à¤¤à¥à¤µ à¤•à¤°à¤¤à¥‡ à',0),(450244,12507,'ms','Deposit pelanggan mewakili wang Syarikat yang diterima terlebih dahulu sebelum menyediakan sesuatu perkhidmatan atau produk.<p>Ini dikelaskan sebagai liabiliti semasa di dalam lembaran imbangan.<p>Ia adalah liabiliti kerana Syarikat masih berhutang Perkhi',0),(450245,12507,'ar','ÙˆØªÙ…Ø«Ù„ ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ù…Ø§Ù„ Ø§Ù„Ø´Ø±ÙƒØ© ØªÙ„Ù‚Øª Ù‚Ø¨Ù„ ØªÙ‚Ø¯ÙŠÙ… Ø®Ø¯Ù…Ø© Ø£Ùˆ Ù…Ù†ØªØ¬.<p>ÙˆØªØµÙ†Ù Ù‡Ø°Ù‡ Ø®ØµÙˆÙ… Ø§Ù„Ø­Ø§Ù„ÙŠØ© ÙÙŠ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¹Ù…ÙˆÙ…ÙŠØ©.<p>Ø£Ù†Ù‡Ø§ Ù…Ø³Ø¤ÙˆÙ„ÙŠØ© Ù„Ù…Ø¯ÙŠÙ† Ø§Ù„Ø´Ø±ÙƒØ© Ù„Ø§ ÙŠ',0),(450246,12507,'fr','DÃ©pÃ´ts de la clientÃ¨le reprÃ©sentent la sociÃ©tÃ© reÃ§ue avant de fournir un service ou un produit d\'argent.<p>Ces derniers sont classÃ©s comme un passif Ã  court terme au bilan.<p>C\'est une responsabilitÃ©, parce que la sociÃ©tÃ© lui doit encore le se',0),(450247,12507,'jp','é¡§å®¢ã®é é‡‘ã¯ã€ã‚µãƒ¼ãƒ“ã‚¹ã‚„è£½å“ã‚’æä¾›ã™ã‚‹å‰ã«å—ä¿¡ã—ãŸä¼šç¤¾ã®ãŠé‡‘ã‚’è¡¨ã—ã¦ã„ã¾ã™ã€‚<p>ã“ã‚Œã‚‰ã¯ã€è²¸å€Ÿå¯¾ç…§è¡¨ä¸Šã®è² å‚µã¨ã—ã¦åˆ†é¡žã•ã‚Œã¾ã™ã€‚<p>ä¼šç¤¾ã¯ã¾ã ã‚µãƒ¼ãƒ“ã‚¹ã¾ãŸã¯è£½å“ã‚’è² ã†è²¬ä»»ã§ã™',0),(450248,12507,'pt','DepÃ³sitos de clientes representam dinheiro a empresa recebida com antecedÃªncia presta um serviÃ§o ou produto.<p>Estes sÃ£o classificados como um passivo atual no balanÃ§o.<p>Ã‰ uma responsabilidade, porque a empresa ainda deve o serviÃ§o ou produto.',0),(450249,12507,'ru','Ð’ÐºÐ»Ð°Ð´Ñ‹ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÑÑŽÑ‚ ÑÐ¾Ð±Ð¾Ð¹ Ð´ÐµÐ½ÑŒÐ³Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»Ð° Ð·Ð°Ð±Ð»Ð°Ð³Ð¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾ Ð´Ð¾ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑƒÑÐ»ÑƒÐ³Ð¸ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°.<p>ÐžÐ½Ð¸ ÐºÐ»Ð°ÑÑÐ¸Ñ„Ð¸Ñ†Ð¸Ñ€ÑƒÑŽÑ‚ÑÑ ÐºÐ°Ðº Ñ‚ÐµÐºÑ',0),(450250,12507,'es','DepÃ³sitos de clientes representa dinero que recibiÃ³ en adelante de proporcionar un servicio o producto. <p>Estos son clasificados como un pasivo circulante en la hoja de balance.<p>Es un pasivo porque la empresa todavÃ­a debe el servicio o producto.',0),(450251,12507,'de','Kundeneinlagen reprÃ¤sentieren Geld das Unternehmen erhalten im Vorfeld eine Dienstleistung oder ein Produkt bereitstellen.<p>Diese werden als aktuelle Verbindlichkeit in der Bilanz ausgewiesen.<p>Es ist eine Belastung, weil die Firma noch die Dienstleist',0),(450252,12507,'en','Customer Deposits represent money the company received in advance of providing a service or product.<p>These are classified as a current liability on the balance sheet.<p>It is a liability because the company still owes the service or product.',0),(450253,12508,'is','',0),(450254,12508,'dr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø¢Ø²Ù…Ø§ÛŒØ´ÛŒ Ø§Ø³Øª ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¢Ù† <i>Ú©Ù‡ Ø§Ú¯Ø±</i> ØªÙ…Ø§Ù… Ù…Ø¬Ù„Ø§Øª Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø¨ÙˆØ¯ Ø¨Ù‡ Ù†Ø¸Ø± Ù…ÛŒ Ø±Ø³Ø¯.<p>Ù¾ÛŒØ´ Ø§Ø² Ø§ÛŒÙ† Ø¨Ø±Ø±Ø³ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ú©Ù…Ú© Ø¨Ù‡ Ø´Ù…Ø§ Ù†Ù‚Ø·Ù‡ Ø§Ø´ØªØ¨Ø§Ù‡Ø',0),(450255,12508,'pr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø¢Ø²Ù…Ø§ÛŒØ´ÛŒ Ø§Ø³Øª ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¢Ù† <i>Ú©Ù‡ Ø§Ú¯Ø±</i> ØªÙ…Ø§Ù… Ù…Ø¬Ù„Ø§Øª Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø¨ÙˆØ¯ Ø¨Ù‡ Ù†Ø¸Ø± Ù…ÛŒ Ø±Ø³Ø¯.<p>Ù¾ÛŒØ´ Ø§Ø² Ø§ÛŒÙ† Ø¨Ø±Ø±Ø³ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ú©Ù…Ú© Ø¨Ù‡ Ø´Ù…Ø§ Ù†Ù‚Ø·Ù‡ Ø§Ø´ØªØ¨Ø§Ù‡Ø',0),(450256,12508,'tr','TÃ¼m gÃ¼nlÃ¼klere yayÄ±nlanmÄ±ÅŸtÄ±r vardÄ± <i>sanki</i> gÃ¶rÃ¼neceÄŸi bir mizan bir bilanÃ§o olduÄŸunu.<p>Bu Ã¶n onay aslÄ±nda deftere nakletmeden Ã¶nce hatalarÄ± spot yardÄ±mcÄ± olabilir.',0),(450257,12508,'pl','Bilans prÃ³bny jest bilans, jak wydaje siÄ™, <i>jakby</i> co napisali wszystkie arkusze.<p>Tego wstÄ™pnego wyboru moÅ¼e pomÃ³c dostrzec bÅ‚Ä™dy przed rzeczywiÅ›cie ksiÄ™gowanie.',0),(450258,12508,'bg','ÐžÐ±Ð¾Ñ€Ð¾Ñ‚Ð½Ð° Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚ Ðµ Ð±Ð°Ð»Ð°Ð½Ñ, Ñ‚ÑŠÐ¹ ÐºÐ°Ñ‚Ð¾ Ñ‚Ñ Ñ‰Ðµ Ð¸Ð·Ð³Ð»ÐµÐ¶Ð´Ð°, <i>ÑÑÐºÐ°Ñˆ</i> Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ð½ÐµÐ²Ð½Ð¸Ñ†Ð¸ ÑÐ° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸.<p>Ð¢Ð°Ð·Ð¸ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð²Ð¸ Ð¿Ð¾Ð¼Ð',0),(450259,12508,'ur','Ø§ÛŒÚ© Ù…Ù‚Ø¯Ù…Û’ Ú©ÛŒ Ø³Ù…Ø§Ø¹Øª ØªÙˆØ§Ø²Ù† Ú©Ø§ Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ ÛÛ’ ÛŒÛ Ø³Ø¨ Ø¬Ø±Ù†Ù„ Ù¾ÙˆØ³Ù¹ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ØªÚ¾Ø§ <i>Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ú¯Ø±</i> Ø¸Ø§ÛØ± ÛÙˆ Ø¬Ø§Ø¦Û’ Ú¯Ø§ Û”<p>Ø§Ø³ Ø³Û’ Ù¾ÛÙ„Û’ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº Ø¢Ù¾ Ú©Û’ Ù†Ù‚Ø§Ø¦Øµ Ø§Ø³Ù¾Ø§',0),(450260,12508,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð±Ð¸Ð»Ð°Ð½Ñ Ñ˜Ðµ Ð±Ð¸Ð»Ð°Ð½Ñ, ÐºÐ°Ð¾ Ð¸ Ð¸Ð·Ð³Ð»ÐµÐ´Ð° <i>ÐºÐ°Ð¾ Ð´Ð°</i> Ñ˜Ðµ Ð¸Ð¼Ð°Ð¾ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸ ÑÐ²Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸.<p>ÐžÐ²Ð° Ð¿Ñ€ÐµÐ»Ð¸Ð¼Ð¸Ð½Ð°Ñ€Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð° Ð¼Ð¾Ð¶Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸ Ð´Ð° Ð¿Ñ€Ð¸Ð¼ÐµÑ‚Ð¸ Ð³Ñ€ÐµÑˆÐºÐµ Ð¿Ñ€Ðµ Ñ',0),(450261,12508,'vi','Má»™t sá»± cÃ¢n báº±ng thá»­ nghiá»‡m lÃ  má»™t Báº£ng cÃ¢n Ä‘á»‘i káº¿ toÃ¡n vÃ¬ nÃ³ sáº½ xuáº¥t hiá»‡n nhÆ° táº¥t cáº£ cÃ¡c nháº­t kÃ½ Ä‘Ã£ Ä‘Äƒng',0),(450262,12508,'af','\'N proefbalans is \'n balansstaat soos dit wil voorkom <i>asof</i> alle joernale het gepos is.<p>Hierdie pre-kontrole kan help plek foute voor eintlik plaas.',0),(450263,12508,'ro','O balanÅ£Äƒ de verificare este un bilanÅ£ ca s-ar pÄƒrea <i>ca ÅŸi cum</i> toate revistele au fost postate.<p>AceastÄƒ pre-verificare vÄƒ poate ajuta sÄƒ faÅ£a locului erori Ã®nainte de a posta efectiv.',0),(450264,12508,'et','Proovibilanss on bilansis kajastatud tundub <i>justkui</i> kÃµik ajakirjad olid lÃ¤hetatud.<p>See eelnev kontroll aitab teil spot vigu enne tegelikult.',0),(450265,12508,'si','Bruto bilanca je bilanca stanja, kot se zdi, <i>kot da</i> vse revije je bil objavljen.<p>To predhodno preverjanje lahko bi vam pomagal spot napak pred dejansko objavljate.',0),(450266,12508,'ba','Trial balance adalah neraca seperti itu akan muncul <i>seolah-olah</i> semua jurnal telah diposting.<p>Pra-cek ini dapat membantu Anda menemukan kesalahan sebelum benar-benar posting.',0),(450267,12508,'nl','Een proefbalans is een balans als het lijkt <i>alsof</i> die alle tijdschriften had geboekt.<p>Deze voorafgaande controle kunt u ter plaatse fouten voordat u boekt.',0),(450268,12508,'fi','Alustava saldo on taseen nÃ¤yttÃ¤Ã¤ <i>ikÃ¤Ã¤n kuin</i> kaikki kirjauskansiot oli kirjattu.<p>LisÃ¤osalla tarkistetaan avulla voit havaita virheet ennen kirjauksen.',0),(450269,12508,'no','En rÃ¥balanse er en balanse som det synes <i>som om</i> alle journaler hadde blitt bokfÃ¸rt.<p>Denne fÃ¸r kontrollen kan hjelpe deg med Ã¥ oppdage feil fÃ¸r du faktisk bokfÃ¸rer.',0),(450270,12508,'da','En rÃ¥balance er en balance, som det ser ud <i>som om</i> alle kladder havde bogfÃ¸rt.<p>Denne forudgÃ¥ende kontrol kan hjÃ¦lpe du stedet fejl fÃ¸r du faktisk bogfÃ¸rer.',0),(450271,12508,'ko','ì‹œì‚°í‘œëŠ” ëŒ€ì°¨ ëŒ€ì¡°í‘œ <i>ì²˜ëŸ¼</i> ëª¨ë“  ì €ë„ì„ ê²Œì‹œ í–ˆë‹¤ í‘œì‹œ ë˜ëŠ”.<p>ì´ ì‚¬ì „ ê²€ì‚¬ëŠ” ì‹¤ì œë¡œ ê²Œì‹œ í•˜ê¸° ì „ì— ì˜¤ë¥˜ë¥¼ ìžë¦¬ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(450272,12508,'he','××™×–×•×Ÿ ×”×ž×©×¤×˜ ×”×•× ×”×ž××–×Ÿ ×›×¤×™ ×©×™×•×¤×™×¢ <i>×›××™×œ×•</i> ×©×•×›×œ ×”×™×•×ž× ×™× ×”×•×¦×‘.<p>×‘×“×™×§×” ×˜×¨×•× ×–×• ×™×›×•×œ×” ×œ×¡×™×™×¢ ×œ×š ×œ×–×”×•×ª ×©×’×™××•×ª ×œ×¤× ×™ ×œ×ž×¢×©×” ×¨×™×©×•×.',0),(450273,12508,'el','Î™ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Ï„Î¿Ï… ÎºÎ±Î¸Î¿Î»Î¹ÎºÎ¿Ï ÎµÎ¯Î½Î±Î¹ Î­Î½Î± Î¹ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ, ÏŒÏ€Ï‰Ï‚ Ï†Î±Î¯Î½ÎµÏ„Î±Î¹ <i>ÏƒÎ±Î½</i> ÏŒÎ»Î± Ï„Î± Ï€ÎµÏÎ¹Î¿Î´Î¹ÎºÎ¬ Ï€Î¿Ï… ÎµÎ¯Ï‡Îµ Î±Î½Î±ÏÏ„Î·Î¸ÎµÎ¯.<p>ÎŸ Ï€ÏÎ¿-Î­Î»ÎµÎ³Ï‡Î¿Ï‚ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÏƒÎ±Ï‚ Î²Î¿Î·Î',0),(450274,12508,'zh','ä¸€ä»½è¯•ç®—è¡¨æ˜¯ä¸€ä»½èµ„äº§è´Ÿå€ºè¡¨ï¼Œå› ä¸ºå®ƒä¼šæ˜¾ç¤ºæ‰€æœ‰è¢«å‘å¸ƒçš„æ—¥å¿—ã€‚æ­¤é¢„æ£€èƒ½å¸®åŠ©æ‚¨åœ¨å®žé™…å‘å¸ƒå‰å‘çŽ°é”™è¯¯ã€‚',0),(450275,12508,'sv','En rÃ¥balans Ã¤r en balansrÃ¤kning som det verkar <i>som om</i> alla journaler hade bokfÃ¶rts.<p>FÃ¶re kontrollen kan hjÃ¤lpa dig upptÃ¤cka fel innan faktiskt.',0),(450276,12508,'it','Un equilibrio di prova Ã¨ un bilancio come apparirebbe <i>come se</i> tutte le riviste erano stati inviati.<p>Questo pre-controllo puÃ² aiutare a individuare errori prima di postare in realtÃ .',0),(450277,12508,'tl','',0),(450278,12508,'th','à¸—à¸”à¸¥à¸­à¸‡à¹€à¸›à¹‡à¸™à¸”à¸¸à¸¥à¹€à¸›à¹‡à¸™à¸à¹‡à¸›à¸£à¸²à¸à¸<i>à¸§à¹ˆà¸²</i>à¸¡à¸µà¸à¸²à¸£à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”<p>à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸™à¸µà¹‰à¸à¹ˆà¸­à¸™à¸ˆà¸°à¸Šà¹ˆà¸§à¸¢à¹',0),(450279,12508,'hi','à¤à¤• à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤à¤• à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¯à¤¹ à¤¸à¤­à¥€ à¤ªà¤¤à¥à¤°à¤¿à¤•à¤¾à¤“à¤‚ à¤®à¥‡à¤‚ à¤¨à¤¿à¤¯à¥à¤•à¥à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¥à¤¾ <i>à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¯à¤¦à',0),(450280,12508,'ms','Imbangan duga adalah kunci kira-kira kerana ia akan kelihatan <i>seolah-olah</i> semua jurnal telah telah dimasukkan.<p>Semakan pra ini boleh membantu anda mengesan ralat sebelum benar-benar mencatat.',0),(450281,12508,'ar','ØªÙˆØ§Ø²Ù† Ø§Ù„Ù…Ø­Ø§ÙƒÙ…Ø© Ù‡Ùˆ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø¹Ù…ÙˆÙ…ÙŠØ© ÙƒÙ…Ø§ Ø£Ù†Ù‡ ÙŠØ¨Ø¯Ùˆ <i>ÙƒÙ…Ø§ Ù„Ùˆ ÙƒØ§Ù†</i> Ù‚Ø¯ ØªÙ… ØªØ±Ø­ÙŠÙ„ ÙƒØ§ÙØ© Ø¯ÙØ§ØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©.<p>Ù‡Ø°Ø§ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù…Ø³Ø¨Ù‚ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªØ³Ø§Ø¹Ø¯Ùƒ Ø¹Ù„Ù‰ Ø§ÙƒØªØ´Ø§Ù',0),(450282,12508,'fr','Une balance de vÃ©rification est un bilan financier tel qu\'il apparaÃ®tra <i>comme si</i> tous les journaux avaient Ã©tÃ© validÃ©es.<p>Ce contrÃ´le prÃ©alable peut vous aider Ã  repÃ©rer les erreurs avant de poster en fait.',0),(450283,12508,'jp','æ®‹é«˜è©¦ç®—è¡¨ã¯ãƒãƒ©ãƒ³ã‚¹ ã‚·ãƒ¼ãƒˆãã‚ŒãŒè¡¨ç¤ºã•ã‚Œã‚‹<i>å ´åˆã¨åŒæ§˜</i>ã™ã¹ã¦ã®ä»•è¨³å¸³ãŒæŽ²ç¤ºã•ã‚Œã¦ã„ã¾ã—ãŸã€‚<p>ã“ã®äº‹å‰ãƒã‚§ãƒƒã‚¯ã§ã¯ã€å®Ÿéš›ã«æŠ•ç¨¿ã™ã‚‹å‰ã«ã‚¨ãƒ©ãƒ¼ã‚’è¦‹ã¤ã‘ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(450284,12508,'pt','Um balancete Ã© um balanÃ§o como ela apareceria <i>como se</i> que tinham sido postadas todas as revistas.<p>Esta prÃ©-verificaÃ§Ã£o pode ajudÃ¡-lo a detectar erros antes de realmente postar.',0),(450285,12508,'ru','ÐŸÑ€Ð¾Ð±Ð½Ñ‹Ð¹ Ð±Ð°Ð»Ð°Ð½Ñ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð±Ð°Ð»Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚, ÐºÐ°Ðº Ð¾Ð½ Ð±ÑƒÐ´ÐµÑ‚ Ð²Ñ‹Ð³Ð»ÑÐ´ÐµÑ‚ÑŒ <i>ÐºÐ°Ðº Ð±ÑƒÐ´Ñ‚Ð¾</i> Ð²ÑÐµ Ð¶ÑƒÑ€Ð½Ð°Ð»Ñ‹ Ð±Ñ‹Ð»Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ñ‹.<p>Ð­Ñ‚Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¼',0),(450286,12508,'es','Un balance de comprobaciÃ³n es un balance como aparecerÃ­a <i>si fuera</i> todos los diarios habia asentados.<p>Este pre-chequea puede ayudarse avistar errores antes que actualmente asentar.',0),(450287,12508,'de','Eine Rohbilanz ist eine Bilanz, wie <i>als ob</i> alle Zeitschriften hatten gebucht worden.<p>Diese Pre-Check hilft Ihnen Fehler zu erkennen, bevor Sie tatsÃ¤chlich buchen.',0),(450288,12508,'en','A trial balance is a Balance Sheet as it would appear <i>as if</i> all journals had been posted.<p>This pre-check can help you spot errors before actually posting.',0),(450289,12509,'is','',0),(450290,12509,'dr','',0),(450291,12509,'pr','',0),(450292,12509,'tr','',0),(450293,12509,'pl','',0),(450294,12509,'bg','',0),(450295,12509,'ur','',0),(450296,12509,'sr','',0),(450297,12509,'vi','',0),(450298,12509,'af','',0),(450299,12509,'ro','',0),(450300,12509,'et','',0),(450301,12509,'si','',0),(450302,12509,'ba','',0),(450303,12509,'nl','',0),(450304,12509,'fi','',0),(450305,12509,'no','',0),(450306,12509,'da','',0),(450307,12509,'ko','',0),(450308,12509,'he','',0),(450309,12509,'el','',0),(450310,12509,'zh','',0),(450311,12509,'sv','',0),(450312,12509,'it','',0),(450313,12509,'tl','',0),(450314,12509,'th','',0),(450315,12509,'hi','',0),(450316,12509,'ms','',0),(450317,12509,'ar','',0),(450318,12509,'fr','',0),(450319,12509,'jp','',0),(450320,12509,'pt','',0),(450321,12509,'ru','',0),(450322,12509,'es','',0),(450323,12509,'de','',0),(450324,12509,'en','',0),(450325,12510,'is','',0),(450326,12510,'dr','',0),(450327,12510,'pr','',0),(450328,12510,'tr','',0),(450329,12510,'pl','',0),(450330,12510,'bg','',0),(450331,12510,'ur','',0),(450332,12510,'sr','',0),(450333,12510,'vi','',0),(450334,12510,'af','',0),(450335,12510,'ro','',0),(450336,12510,'et','',0),(450337,12510,'si','',0),(450338,12510,'ba','',0),(450339,12510,'nl','',0),(450340,12510,'fi','',0),(450341,12510,'no','',0),(450342,12510,'da','',0),(450343,12510,'ko','',0),(450344,12510,'he','',0),(450345,12510,'el','',0),(450346,12510,'zh','',0),(450347,12510,'sv','',0),(450348,12510,'it','',0),(450349,12510,'tl','',0),(450350,12510,'th','',0),(450351,12510,'hi','',0),(450352,12510,'ms','',0),(450353,12510,'ar','',0),(450354,12510,'fr','',0),(450355,12510,'jp','',0),(450356,12510,'pt','',0),(450357,12510,'ru','',0),(450358,12510,'es','',0),(450359,12510,'de','',0),(450360,12510,'en','',0),(450361,12511,'is','',0),(450362,12511,'dr','',0),(450363,12511,'pr','',0),(450364,12511,'tr','',0),(450365,12511,'pl','',0),(450366,12511,'bg','',0),(450367,12511,'ur','',0),(450368,12511,'sr','',0),(450369,12511,'vi','',0),(450370,12511,'af','',0),(450371,12511,'ro','',0),(450372,12511,'et','',0),(450373,12511,'si','',0),(450374,12511,'ba','',0),(450375,12511,'nl','',0),(450376,12511,'fi','',0),(450377,12511,'no','',0),(450378,12511,'da','',0),(450379,12511,'ko','',0),(450380,12511,'he','',0),(450381,12511,'el','',0),(450382,12511,'zh','',0),(450383,12511,'sv','',0),(450384,12511,'it','',0),(450385,12511,'tl','',0),(450386,12511,'th','',0),(450387,12511,'hi','',0),(450388,12511,'ms','',0),(450389,12511,'ar','',0),(450390,12511,'fr','',0),(450391,12511,'jp','',0),(450392,12511,'pt','',0),(450393,12511,'ru','',0),(450394,12511,'es','',0),(450395,12511,'de','',0),(450396,12511,'en','',0),(450397,12512,'is','',0),(450398,12512,'dr','',0),(450399,12512,'pr','',0),(450400,12512,'tr','',0),(450401,12512,'pl','',0),(450402,12512,'bg','',0),(450403,12512,'ur','',0),(450404,12512,'sr','',0),(450405,12512,'vi','',0),(450406,12512,'af','',0),(450407,12512,'ro','',0),(450408,12512,'et','',0),(450409,12512,'si','',0),(450410,12512,'ba','',0),(450411,12512,'nl','',0),(450412,12512,'fi','',0),(450413,12512,'no','',0),(450414,12512,'da','',0),(450415,12512,'ko','',0),(450416,12512,'he','',0),(450417,12512,'el','',0),(450418,12512,'zh','',0),(450419,12512,'sv','',0),(450420,12512,'it','',0),(450421,12512,'tl','',0),(450422,12512,'th','',0),(450423,12512,'hi','',0),(450424,12512,'ms','',0),(450425,12512,'ar','',0),(450426,12512,'fr','',0),(450427,12512,'jp','',0),(450428,12512,'pt','',0),(450429,12512,'ru','',0),(450430,12512,'es','',0),(450431,12512,'de','',0),(450432,12512,'en','',0),(450433,12513,'is','',0),(450434,12513,'dr','',0),(450435,12513,'pr','',0),(450436,12513,'tr','',0),(450437,12513,'pl','',0),(450438,12513,'bg','',0),(450439,12513,'ur','',0),(450440,12513,'sr','',0),(450441,12513,'vi','',0),(450442,12513,'af','',0),(450443,12513,'ro','',0),(450444,12513,'et','',0),(450445,12513,'si','',0),(450446,12513,'ba','',0),(450447,12513,'nl','',0),(450448,12513,'fi','',0),(450449,12513,'no','',0),(450450,12513,'da','',0),(450451,12513,'ko','',0),(450452,12513,'he','',0),(450453,12513,'el','',0),(450454,12513,'zh','',0),(450455,12513,'sv','',0),(450456,12513,'it','',0),(450457,12513,'tl','',0),(450458,12513,'th','',0),(450459,12513,'hi','',0),(450460,12513,'ms','',0),(450461,12513,'ar','',0),(450462,12513,'fr','',0),(450463,12513,'jp','',0),(450464,12513,'pt','',0),(450465,12513,'ru','',0),(450466,12513,'es','',0),(450467,12513,'de','',0),(450468,12513,'en','',0),(450469,12514,'is','',0),(450470,12514,'dr','',0),(450471,12514,'pr','',0),(450472,12514,'tr','',0),(450473,12514,'pl','',0),(450474,12514,'bg','',0),(450475,12514,'ur','',0),(450476,12514,'sr','',0),(450477,12514,'vi','',0),(450478,12514,'af','',0),(450479,12514,'ro','',0),(450480,12514,'et','',0),(450481,12514,'si','',0),(450482,12514,'ba','',0),(450483,12514,'nl','',0),(450484,12514,'fi','',0),(450485,12514,'no','',0),(450486,12514,'da','',0),(450487,12514,'ko','',0),(450488,12514,'he','',0),(450489,12514,'el','',0),(450490,12514,'zh','',0),(450491,12514,'sv','',0),(450492,12514,'it','',0),(450493,12514,'tl','',0),(450494,12514,'th','',0),(450495,12514,'hi','',0),(450496,12514,'ms','',0),(450497,12514,'ar','',0),(450498,12514,'fr','',0),(450499,12514,'jp','',0),(450500,12514,'pt','',0),(450501,12514,'ru','',0),(450502,12514,'es','',0),(450503,12514,'de','',0),(450504,12514,'en','',0),(450505,12515,'is','',0),(450506,12515,'dr','',0),(450507,12515,'pr','',0),(450508,12515,'tr','',0),(450509,12515,'pl','',0),(450510,12515,'bg','',0),(450511,12515,'ur','',0),(450512,12515,'sr','',0),(450513,12515,'vi','',0),(450514,12515,'af','',0),(450515,12515,'ro','',0),(450516,12515,'et','',0),(450517,12515,'si','',0),(450518,12515,'ba','',0),(450519,12515,'nl','',0),(450520,12515,'fi','',0),(450521,12515,'no','',0),(450522,12515,'da','',0),(450523,12515,'ko','',0),(450524,12515,'he','',0),(450525,12515,'el','',0),(450526,12515,'zh','',0),(450527,12515,'sv','',0),(450528,12515,'it','',0),(450529,12515,'tl','',0),(450530,12515,'th','',0),(450531,12515,'hi','',0),(450532,12515,'ms','',0),(450533,12515,'ar','',0),(450534,12515,'fr','',0),(450535,12515,'jp','',0),(450536,12515,'pt','',0),(450537,12515,'ru','',0),(450538,12515,'es','',0),(450539,12515,'de','',0),(450540,12515,'en','',0),(450541,12516,'is','',0),(450542,12516,'dr','',0),(450543,12516,'pr','',0),(450544,12516,'tr','',0),(450545,12516,'pl','',0),(450546,12516,'bg','',0),(450547,12516,'ur','',0),(450548,12516,'sr','',0),(450549,12516,'vi','',0),(450550,12516,'af','',0),(450551,12516,'ro','',0),(450552,12516,'et','',0),(450553,12516,'si','',0),(450554,12516,'ba','',0),(450555,12516,'nl','',0),(450556,12516,'fi','',0),(450557,12516,'no','',0),(450558,12516,'da','',0),(450559,12516,'ko','',0),(450560,12516,'he','',0),(450561,12516,'el','',0),(450562,12516,'zh','',0),(450563,12516,'sv','',0),(450564,12516,'it','',0),(450565,12516,'tl','',0),(450566,12516,'th','',0),(450567,12516,'hi','',0),(450568,12516,'ms','',0),(450569,12516,'ar','',0),(450570,12516,'fr','',0),(450571,12516,'jp','',0),(450572,12516,'pt','',0),(450573,12516,'ru','',0),(450574,12516,'es','',0),(450575,12516,'de','',0),(450576,12516,'en','',0),(450577,12517,'is','',0),(450578,12517,'dr','',0),(450579,12517,'pr','',0),(450580,12517,'tr','',0),(450581,12517,'pl','',0),(450582,12517,'bg','',0),(450583,12517,'ur','',0),(450584,12517,'sr','',0),(450585,12517,'vi','',0),(450586,12517,'af','',0),(450587,12517,'ro','',0),(450588,12517,'et','',0),(450589,12517,'si','',0),(450590,12517,'ba','',0),(450591,12517,'nl','',0),(450592,12517,'fi','',0),(450593,12517,'no','',0),(450594,12517,'da','',0),(450595,12517,'ko','',0),(450596,12517,'he','',0),(450597,12517,'el','',0),(450598,12517,'zh','',0),(450599,12517,'sv','',0),(450600,12517,'it','',0),(450601,12517,'tl','',0),(450602,12517,'th','',0),(450603,12517,'hi','',0),(450604,12517,'ms','',0),(450605,12517,'ar','',0),(450606,12517,'fr','',0),(450607,12517,'jp','',0),(450608,12517,'pt','',0),(450609,12517,'ru','',0),(450610,12517,'es','',0),(450611,12517,'de','',0),(450612,12517,'en','',0),(450613,12518,'is','',0),(450614,12518,'dr','',0),(450615,12518,'pr','',0),(450616,12518,'tr','',0),(450617,12518,'pl','',0),(450618,12518,'bg','',0),(450619,12518,'ur','',0),(450620,12518,'sr','',0),(450621,12518,'vi','',0),(450622,12518,'af','',0),(450623,12518,'ro','',0),(450624,12518,'et','',0),(450625,12518,'si','',0),(450626,12518,'ba','',0),(450627,12518,'nl','',0),(450628,12518,'fi','',0),(450629,12518,'no','',0),(450630,12518,'da','',0),(450631,12518,'ko','',0),(450632,12518,'he','',0),(450633,12518,'el','',0),(450634,12518,'zh','',0),(450635,12518,'sv','',0),(450636,12518,'it','',0),(450637,12518,'tl','',0),(450638,12518,'th','',0),(450639,12518,'hi','',0),(450640,12518,'ms','',0),(450641,12518,'ar','',0),(450642,12518,'fr','',0),(450643,12518,'jp','',0),(450644,12518,'pt','',0),(450645,12518,'ru','',0),(450646,12518,'es','',0),(450647,12518,'de','',0),(450648,12518,'en','',0),(450649,12519,'is','',0),(450650,12519,'dr','',0),(450651,12519,'pr','',0),(450652,12519,'tr','',0),(450653,12519,'pl','',0),(450654,12519,'bg','',0),(450655,12519,'ur','',0),(450656,12519,'sr','',0),(450657,12519,'vi','',0),(450658,12519,'af','',0),(450659,12519,'ro','',0),(450660,12519,'et','',0),(450661,12519,'si','',0),(450662,12519,'ba','',0),(450663,12519,'nl','',0),(450664,12519,'fi','',0),(450665,12519,'no','',0),(450666,12519,'da','',0),(450667,12519,'ko','',0),(450668,12519,'he','',0),(450669,12519,'el','',0),(450670,12519,'zh','',0),(450671,12519,'sv','',0),(450672,12519,'it','',0),(450673,12519,'tl','',0),(450674,12519,'th','',0),(450675,12519,'hi','',0),(450676,12519,'ms','',0),(450677,12519,'ar','',0),(450678,12519,'fr','',0),(450679,12519,'jp','',0),(450680,12519,'pt','',0),(450681,12519,'ru','',0),(450682,12519,'es','',0),(450683,12519,'de','',0),(450684,12519,'en','',0),(450685,12520,'is','',0),(450686,12520,'dr','',0),(450687,12520,'pr','',0),(450688,12520,'tr','',0),(450689,12520,'pl','',0),(450690,12520,'bg','',0),(450691,12520,'ur','',0),(450692,12520,'sr','',0),(450693,12520,'vi','',0),(450694,12520,'af','',0),(450695,12520,'ro','',0),(450696,12520,'et','',0),(450697,12520,'si','',0),(450698,12520,'ba','',0),(450699,12520,'nl','',0),(450700,12520,'fi','',0),(450701,12520,'no','',0),(450702,12520,'da','',0),(450703,12520,'ko','',0),(450704,12520,'he','',0),(450705,12520,'el','',0),(450706,12520,'zh','',0),(450707,12520,'sv','',0),(450708,12520,'it','',0),(450709,12520,'tl','',0),(450710,12520,'th','',0),(450711,12520,'hi','',0),(450712,12520,'ms','',0),(450713,12520,'ar','',0),(450714,12520,'fr','',0),(450715,12520,'jp','',0),(450716,12520,'pt','',0),(450717,12520,'ru','',0),(450718,12520,'es','',0),(450719,12520,'de','',0),(450720,12520,'en','',0),(450721,12521,'is','',0),(450722,12521,'dr','',0),(450723,12521,'pr','',0),(450724,12521,'tr','',0),(450725,12521,'pl','',0),(450726,12521,'bg','',0),(450727,12521,'ur','',0),(450728,12521,'sr','',0),(450729,12521,'vi','',0),(450730,12521,'af','',0),(450731,12521,'ro','',0),(450732,12521,'et','',0),(450733,12521,'si','',0),(450734,12521,'ba','',0),(450735,12521,'nl','',0),(450736,12521,'fi','',0),(450737,12521,'no','',0),(450738,12521,'da','',0),(450739,12521,'ko','',0),(450740,12521,'he','',0),(450741,12521,'el','',0),(450742,12521,'zh','',0),(450743,12521,'sv','',0),(450744,12521,'it','',0),(450745,12521,'tl','',0),(450746,12521,'th','',0),(450747,12521,'hi','',0),(450748,12521,'ms','',0),(450749,12521,'ar','',0),(450750,12521,'fr','',0),(450751,12521,'jp','',0),(450752,12521,'pt','',0),(450753,12521,'ru','',0),(450754,12521,'es','',0),(450755,12521,'de','',0),(450756,12521,'en','',0),(450757,12522,'is','',0),(450758,12522,'dr','',0),(450759,12522,'pr','',0),(450760,12522,'tr','',0),(450761,12522,'pl','',0),(450762,12522,'bg','',0),(450763,12522,'ur','',0),(450764,12522,'sr','',0),(450765,12522,'vi','',0),(450766,12522,'af','',0),(450767,12522,'ro','',0),(450768,12522,'et','',0),(450769,12522,'si','',0),(450770,12522,'ba','',0),(450771,12522,'nl','',0),(450772,12522,'fi','',0),(450773,12522,'no','',0),(450774,12522,'da','',0),(450775,12522,'ko','',0),(450776,12522,'he','',0),(450777,12522,'el','',0),(450778,12522,'zh','',0),(450779,12522,'sv','',0),(450780,12522,'it','',0),(450781,12522,'tl','',0),(450782,12522,'th','',0),(450783,12522,'hi','',0),(450784,12522,'ms','',0),(450785,12522,'ar','',0),(450786,12522,'fr','',0),(450787,12522,'jp','',0),(450788,12522,'pt','',0),(450789,12522,'ru','',0),(450790,12522,'es','',0),(450791,12522,'de','',0),(450792,12522,'en','',0),(450793,12523,'is','',0),(450794,12523,'dr','',0),(450795,12523,'pr','',0),(450796,12523,'tr','',0),(450797,12523,'pl','',0),(450798,12523,'bg','',0),(450799,12523,'ur','',0),(450800,12523,'sr','',0),(450801,12523,'vi','',0),(450802,12523,'af','',0),(450803,12523,'ro','',0),(450804,12523,'et','',0),(450805,12523,'si','',0),(450806,12523,'ba','',0),(450807,12523,'nl','',0),(450808,12523,'fi','',0),(450809,12523,'no','',0),(450810,12523,'da','',0),(450811,12523,'ko','',0),(450812,12523,'he','',0),(450813,12523,'el','',0),(450814,12523,'zh','',0),(450815,12523,'sv','',0),(450816,12523,'it','',0),(450817,12523,'tl','',0),(450818,12523,'th','',0),(450819,12523,'hi','',0),(450820,12523,'ms','',0),(450821,12523,'ar','',0),(450822,12523,'fr','',0),(450823,12523,'jp','',0),(450824,12523,'pt','',0),(450825,12523,'ru','',0),(450826,12523,'es','',0),(450827,12523,'de','',0),(450828,12523,'en','',0),(450829,12524,'is','',0),(450830,12524,'dr','',0),(450831,12524,'pr','',0),(450832,12524,'tr','',0),(450833,12524,'pl','',0),(450834,12524,'bg','',0),(450835,12524,'ur','',0),(450836,12524,'sr','',0),(450837,12524,'vi','',0),(450838,12524,'af','',0),(450839,12524,'ro','',0),(450840,12524,'et','',0),(450841,12524,'si','',0),(450842,12524,'ba','',0),(450843,12524,'nl','',0),(450844,12524,'fi','',0),(450845,12524,'no','',0),(450846,12524,'da','',0),(450847,12524,'ko','',0),(450848,12524,'he','',0),(450849,12524,'el','',0),(450850,12524,'zh','',0),(450851,12524,'sv','',0),(450852,12524,'it','',0),(450853,12524,'tl','',0),(450854,12524,'th','',0),(450855,12524,'hi','',0),(450856,12524,'ms','',0),(450857,12524,'ar','',0),(450858,12524,'fr','',0),(450859,12524,'jp','',0),(450860,12524,'pt','',0),(450861,12524,'ru','',0),(450862,12524,'es','',0),(450863,12524,'de','',0),(450864,12524,'en','',0),(450865,12525,'is','',0),(450866,12525,'dr','',0),(450867,12525,'pr','',0),(450868,12525,'tr','',0),(450869,12525,'pl','',0),(450870,12525,'bg','',0),(450871,12525,'ur','',0),(450872,12525,'sr','',0),(450873,12525,'vi','',0),(450874,12525,'af','',0),(450875,12525,'ro','',0),(450876,12525,'et','',0),(450877,12525,'si','',0),(450878,12525,'ba','',0),(450879,12525,'nl','',0),(450880,12525,'fi','',0),(450881,12525,'no','',0),(450882,12525,'da','',0),(450883,12525,'ko','',0),(450884,12525,'he','',0),(450885,12525,'el','',0),(450886,12525,'zh','',0),(450887,12525,'sv','',0),(450888,12525,'it','',0),(450889,12525,'tl','',0),(450890,12525,'th','',0),(450891,12525,'hi','',0),(450892,12525,'ms','',0),(450893,12525,'ar','',0),(450894,12525,'fr','',0),(450895,12525,'jp','',0),(450896,12525,'pt','',0),(450897,12525,'ru','',0),(450898,12525,'es','',0),(450899,12525,'de','',0),(450900,12525,'en','',0),(450901,12526,'is','',0),(450902,12526,'dr','',0),(450903,12526,'pr','',0),(450904,12526,'tr','',0),(450905,12526,'pl','',0),(450906,12526,'bg','',0),(450907,12526,'ur','',0),(450908,12526,'sr','',0),(450909,12526,'vi','',0),(450910,12526,'af','',0),(450911,12526,'ro','',0),(450912,12526,'et','',0),(450913,12526,'si','',0),(450914,12526,'ba','',0),(450915,12526,'nl','',0),(450916,12526,'fi','',0),(450917,12526,'no','',0),(450918,12526,'da','',0),(450919,12526,'ko','',0),(450920,12526,'he','',0),(450921,12526,'el','',0),(450922,12526,'zh','',0),(450923,12526,'sv','',0),(450924,12526,'it','',0),(450925,12526,'tl','',0),(450926,12526,'th','',0),(450927,12526,'hi','',0),(450928,12526,'ms','',0),(450929,12526,'ar','',0),(450930,12526,'fr','',0),(450931,12526,'jp','',0),(450932,12526,'pt','',0),(450933,12526,'ru','',0),(450934,12526,'es','',0),(450935,12526,'de','',0),(450936,12526,'en','',0),(450937,12527,'is','',0),(450938,12527,'dr','',0),(450939,12527,'pr','',0),(450940,12527,'tr','',0),(450941,12527,'pl','',0),(450942,12527,'bg','',0),(450943,12527,'ur','',0),(450944,12527,'sr','',0),(450945,12527,'vi','',0),(450946,12527,'af','',0),(450947,12527,'ro','',0),(450948,12527,'et','',0),(450949,12527,'si','',0),(450950,12527,'ba','',0),(450951,12527,'nl','',0),(450952,12527,'fi','',0),(450953,12527,'no','',0),(450954,12527,'da','',0),(450955,12527,'ko','',0),(450956,12527,'he','',0),(450957,12527,'el','',0),(450958,12527,'zh','',0),(450959,12527,'sv','',0),(450960,12527,'it','',0),(450961,12527,'tl','',0),(450962,12527,'th','',0),(450963,12527,'hi','',0),(450964,12527,'ms','',0),(450965,12527,'ar','',0),(450966,12527,'fr','',0),(450967,12527,'jp','',0),(450968,12527,'pt','',0),(450969,12527,'ru','',0),(450970,12527,'es','',0),(450971,12527,'de','',0),(450972,12527,'en','',0),(450973,12528,'is','',0),(450974,12528,'dr','',0),(450975,12528,'pr','',0),(450976,12528,'tr','',0),(450977,12528,'pl','',0),(450978,12528,'bg','',0),(450979,12528,'ur','',0),(450980,12528,'sr','',0),(450981,12528,'vi','',0),(450982,12528,'af','',0),(450983,12528,'ro','',0),(450984,12528,'et','',0),(450985,12528,'si','',0),(450986,12528,'ba','',0),(450987,12528,'nl','',0),(450988,12528,'fi','',0),(450989,12528,'no','',0),(450990,12528,'da','',0),(450991,12528,'ko','',0),(450992,12528,'he','',0),(450993,12528,'el','',0),(450994,12528,'zh','',0),(450995,12528,'sv','',0),(450996,12528,'it','',0),(450997,12528,'tl','',0),(450998,12528,'th','',0),(450999,12528,'hi','',0),(451000,12528,'ms','',0),(451001,12528,'ar','',0),(451002,12528,'fr','',0),(451003,12528,'jp','',0),(451004,12528,'pt','',0),(451005,12528,'ru','',0),(451006,12528,'es','',0),(451007,12528,'de','',0),(451008,12528,'en','',0),(451009,12529,'is','',0),(451010,12529,'dr','',0),(451011,12529,'pr','',0),(451012,12529,'tr','',0),(451013,12529,'pl','',0),(451014,12529,'bg','',0),(451015,12529,'ur','',0),(451016,12529,'sr','',0),(451017,12529,'vi','',0),(451018,12529,'af','',0),(451019,12529,'ro','',0),(451020,12529,'et','',0),(451021,12529,'si','',0),(451022,12529,'ba','',0),(451023,12529,'nl','',0),(451024,12529,'fi','',0),(451025,12529,'no','',0),(451026,12529,'da','',0),(451027,12529,'ko','',0),(451028,12529,'he','',0),(451029,12529,'el','',0),(451030,12529,'zh','',0),(451031,12529,'sv','',0),(451032,12529,'it','',0),(451033,12529,'tl','',0),(451034,12529,'th','',0),(451035,12529,'hi','',0),(451036,12529,'ms','',0),(451037,12529,'ar','',0),(451038,12529,'fr','',0),(451039,12529,'jp','',0),(451040,12529,'pt','',0),(451041,12529,'ru','',0),(451042,12529,'es','',0),(451043,12529,'de','',0),(451044,12529,'en','',0),(451045,12530,'is','',0),(451046,12530,'dr','',0),(451047,12530,'pr','',0),(451048,12530,'tr','',0),(451049,12530,'pl','',0),(451050,12530,'bg','',0),(451051,12530,'ur','',0),(451052,12530,'sr','',0),(451053,12530,'vi','',0),(451054,12530,'af','',0),(451055,12530,'ro','',0),(451056,12530,'et','',0),(451057,12530,'si','',0),(451058,12530,'ba','',0),(451059,12530,'nl','',0),(451060,12530,'fi','',0),(451061,12530,'no','',0),(451062,12530,'da','',0),(451063,12530,'ko','',0),(451064,12530,'he','',0),(451065,12530,'el','',0),(451066,12530,'zh','',0),(451067,12530,'sv','',0),(451068,12530,'it','',0),(451069,12530,'tl','',0),(451070,12530,'th','',0),(451071,12530,'hi','',0),(451072,12530,'ms','',0),(451073,12530,'ar','',0),(451074,12530,'fr','',0),(451075,12530,'jp','',0),(451076,12530,'pt','',0),(451077,12530,'ru','',0),(451078,12530,'es','',0),(451079,12530,'de','',0),(451080,12530,'en','',0),(451081,12531,'is','',0),(451082,12531,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ø¯Ø³Øª Ø§Ù†Ø¬Ø§Ù… Ø¨Ø±Ø§ÛŒ Ù…ÙˆØ§Ø±Ø¯ ØºÙ„Ø§Ù Ù‡Ø³ØªÙ†Ø¯ Ù†Ù‡ Ø¯Ù†Ø¨Ø§Ù„ Ø§Ø² Ø¢Ù†Ø¬Ø§ÛŒÛŒ Ú©Ù‡ Ø¢Ù†Ù‡Ø§ \"Ø¯Ø± ØªÙ‚Ø§Ø¶Ø§ÛŒ ØªÙˆÙ„ÛŒØ¯ Ù…ÛŒ Ø´ÙˆØ¯\".<p>Ø§Ú¯Ø± Ø´Ù…Ø§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù†ÙˆØ¹ Ù…ÙˆØ±Ø¯ Ùˆ ÙØ±Ùˆ',0),(451083,12531,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø± Ø¯Ø³Øª Ø§Ù†Ø¬Ø§Ù… Ø¨Ø±Ø§ÛŒ Ù…ÙˆØ§Ø±Ø¯ ØºÙ„Ø§Ù Ù‡Ø³ØªÙ†Ø¯ Ù†Ù‡ Ø¯Ù†Ø¨Ø§Ù„ Ø§Ø² Ø¢Ù†Ø¬Ø§ÛŒÛŒ Ú©Ù‡ Ø¢Ù†Ù‡Ø§ \"Ø¯Ø± ØªÙ‚Ø§Ø¶Ø§ÛŒ ØªÙˆÙ„ÛŒØ¯ Ù…ÛŒ Ø´ÙˆØ¯\".<p>Ø§Ú¯Ø± Ø´Ù…Ø§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù†ÙˆØ¹ Ù…ÙˆØ±Ø¯ Ùˆ ÙØ±Ùˆ',0),(451084,12531,'tr','Miktar, eldeki POD Ã¶ÄŸeler iÃ§in deÄŸil izlenir \"beri\"isteÄŸe baÄŸlÄ± olarak Ã¼retilir.<p>Belirtilen bu tÃ¼r Ã¶ÄŸeler iÃ§in bir miktar var ve bir tane Sat, eldeki satÄ±ÅŸ sonrasÄ± deÄŸiÅŸmez.',0),(451085,12531,'pl','IloÅ›Ä‡ na rÄ™ka POD elementy nie sÄ… Å›ledzone, poniewaÅ¼ one sÄ… \"produkowane na Å¼Ä…danie\".<p>JeÅ›li masz iloÅ›ci okreÅ›lone dla tego typu elementu i sprzedaÄ‡ jednÄ…, na strony nie zmieni siÄ™ po sprzedaÅ¼y.',0),(451086,12531,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° Ñ€ÑŠÐºÐ° Ð·Ð° POD ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð½Ðµ ÑÐµ Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ñ‚, Ñ‚ÑŠÐ¹ ÐºÐ°Ñ‚Ð¾ Ñ‚Ðµ ÑÐ° \"Ð¿Ñ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð¸ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°\".<p>ÐÐºÐ¾ Ð¸Ð¼Ð°Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¾ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ñ‚Ð¸Ð¿',0),(451087,12531,'ur','Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø± ÛØ§ØªÚ¾ Ù¾Ú¾Ù„ÛŒ Ø§Ø´ÛŒØ§ Ú©Û’ Ù„ÛŒÛ’ ÛÛŒÚº Ù†Û Ø³Ø±Ø§Øº Ù„Ú¯Ø§ÛŒØ§ Ú†ÙˆÙ†Ú©Û ÙˆÛ \"Ø·Ù„Ø¨ Ù¾Ø± Ù¾ÛŒØ¯Ø§ ÛÙˆØªÛ’ ÛÛŒÚº\" Û”<p>Ù¾Ø±-ÛØ§ØªÚ¾ Ø§Ø³ ÙˆÙ‚Øª ØªÚ© ÙØ±ÙˆØ®Øª Ú©Û’ Ø¨Ø¹Ø¯ ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø±Û’ Ú¯Ø§ Ø§Ú¯Ø± Ø¢Ù¾ Ø§Ø³ Ù‚Ø³Ù',0),(451088,12531,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð°-Ñ€ÑƒÐºÐ° Ð·Ð° ÐšÐÐŸÐ¡Ð£Ð›Ð£ ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ðµ Ð¿Ñ€Ð°Ñ‚Ðµ Ð¾Ñ‚ÐºÐ°ÐºÐ¾ ÑÑƒ \"Ñ€Ð°Ð·Ð²Ð¸Ñ˜ÐµÐ½Ðµ Ð½Ð° Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²\".<p>ÐÐºÐ¾ Ð¸Ð¼Ð°Ñ‚Ðµ Ð½ÐµÐºÑƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ Ð½Ð°Ð²ÐµÐ´ÐµÐ½ Ð·Ð° Ð¾Ð²Ñƒ Ð²Ñ€ÑÑ‚Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¸ Ð¿Ñ€Ð¾Ð´Ð° Ñ˜',0),(451089,12531,'vi','Sá»‘ lÆ°á»£ng cho nhá»¯ng máº·t hÃ ng POD khÃ´ng Ä‘Æ°á»£c theo dÃµi ká»ƒ tá»« khi chÃºng Ä‘Æ°á»£c sáº£n xuáº¥t theo yÃªu cáº§u.náº¿u báº¡n cÃ³ sá»‘ lÆ°á»£ng quy Ä‘á»‹nh cho máº·t hÃ ng nÃ y thÃ¬ sá»‘ lÆ°á»£ng sáº½ khÃ´ng thay Ä‘á»•i sau khi bÃ¡n hÃ ng',0),(451090,12531,'af','Die hoeveelheid op-hand vir POD items is nie opgespoor nie, want hulle is \"geproduseer op aanvraag\".<p>As jy \'n hoeveelheid gespesifiseer is vir hierdie tipe item en verkoop een, die op-hand sal nie verander na die verkoop.',0),(451091,12531,'ro','Cantitatea pe mÃ¢nÄƒ pentru POD elemente nu sunt urmÄƒrite, deoarece acestea sunt \"produse la cerere\".<p>DacÄƒ aveÅ£i o cantitate specificatÄƒ pentru acest tip de element ÅŸi vinde unul, pe-o parte nu se va schimba dupÄƒ vÃ¢nzare.',0),(451092,12531,'et','Kogus vaba POD Ã¼ksusi ei jÃ¤lgita, kuna nad on\"on demand\".<p>Kui olete seda tÃ¼Ã¼pi kauba jaoks mÃ¤Ã¤ratud kogus ja mÃ¼Ã¼a Ã¼ks, ei muutu vaba pÃ¤rast mÃ¼Ã¼ki.',0),(451093,12531,'si','KoliÄina na roko za artikle POD ne beleÅ¾i, ker se \"pridelujejo na povpraÅ¡evanje\".<p>ÄŒe so koliÄine, doloÄene za to vrsto elementa in prodati enega, na strani ne bo spremenilo po prodaji.',0),(451094,12531,'ba','Kuantitas di tangan untuk POD item tidak dilacak karena mereka adalah \"dihasilkan pada permintaan\".<p>Jika Anda memiliki jumlah yang ditentukan untuk jenis item dan menjual salah satu, tangan yang tidak akan berubah setelah penjualan.',0),(451095,12531,'nl','De hoeveelheid in voorraad voor POD items worden niet bijgehouden aangezien zij vervaardigd zijn met\"on demand\".<p>Als u een aantal dat is opgegeven voor dit type object hebt en een object verkopen, zal de hand niet wijzigen na de verkoop.',0),(451096,12531,'fi','MÃ¤Ã¤rÃ¤ kÃ¤ytettÃ¤vissÃ¤ POD kohteita ei valvota, koska \"tuottaa kysyntÃ¤Ã¤n\".<p>Jos sinulla on tÃ¤mÃ¤ntyyppisiÃ¤ kohteita varten mÃ¤Ã¤ritetyn mÃ¤Ã¤rÃ¤n ja myydÃ¤, on kÃ¤si ei muutu myynnin jÃ¤lkeen.',0),(451097,12531,'no','Antall beholdningen for POD varer registreres ikke siden de er \"produsert on demand\".<p>Hvis du har et antall angitt for denne typen vare og selge en, endres ikke beholdningen etter salget.',0),(451098,12531,'da','Den mÃ¦ngde pÃ¥-side for POD elementer spores ikke, da de er \"produceret on demand\".<p>Hvis du har en mÃ¦ngde, der er angivet for denne type af element og sÃ¦lge en, vil side ikke Ã¦ndre efter salget.',0),(451099,12531,'ko','ì´í›„ ê·¸ë“¤ì€ \"ìƒì‚° ìˆ˜ìš”ì—\" í¬ë“œ í•­ëª©ì— ëŒ€ í•œ ì†ì— ìˆ˜ëŸ‰ ì¶”ì  ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.<p>ì´ëŸ¬í•œ ìœ í˜•ì˜ í•­ëª©ì— ëŒ€í•´ ì§€ì • ëœ ìˆ˜ëŸ‰ì´ í•˜ë‚˜ë¥¼ íŒë§¤ í•˜ëŠ” ê²½ìš°ì— ì§ì ‘ íŒë§¤ í›„ ë³€ê²½ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(451100,12531,'he','×”×›×ž×•×ª ×‘× ×ž×¦× ×¢×‘×•×¨ ×¤×¨×™×˜×™× ×¤×•×“ ×œ× ×ž×ª×‘×¦×¢ ×ž××– ×”× \"×ž×™×•×¦×¨×™× ×¢×œ ×¤×™ ×“×¨×™×©×”\".<p>×× ×™×© ×œ×š ×›×ž×•×ª ×©×¦×•×™× ×• ×¢×‘×•×¨ ×¡×•×’ ×–×” ×©×œ ×¤×¨×™×˜ ×œ×ž×›×•×¨ ××—×“, ×‘× ×ž×¦× ×œ× ×™×©×ª× ×” ×œ××—×¨ ×”×ž×›×™',0),(451101,12531,'el','Î— Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎµÏ€Î¬Î½Ï‰-Ï‡Î­ÏÎ¹ Î³Î¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± POD Î´ÎµÎ½ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿Ï…Î¸Î¿ÏÎ½Ï„Î±Î¹ Î´ÎµÎ´Î¿Î¼Î­Î½Î¿Ï… ÏŒÏ„Î¹ \"Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î±Î¹ ÎºÎ±Ï„ÏŒÏ€Î¹Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚\".<p>Î•Î¬Î½ Î­Ï‡ÎµÏ„Îµ Î¼Î¹Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… ÎºÎ±Î¸Î¿',0),(451102,12531,'zh','è´§åˆ°ä»˜æ¬¾é¡¹ç›®çš„çŽ°æœ‰æ•°é‡æ— æ³•è·Ÿè¸ªå› ä¸ºå®ƒä»¬æ˜¯â€œæ ¹æ®éœ€æ±‚ç”Ÿäº§â€ã€‚å¦‚æžœæ‚¨æœ‰æ­¤é¡¹ç›®ç±»åž‹çš„ç‰¹å®šæ•°é‡å¹¶å‡ºå”®ä¸€ä»½ï¼ŒçŽ°æœ‰è´§é‡åœ¨å”®åŽä¸ä¼šæ”¹å˜ã€‚',0),(451103,12531,'sv','Den kvantitet pÃ¥ handen fÃ¶r POD artiklar spÃ¥ras inte eftersom de \"produceras pÃ¥ begÃ¤ran\".<p>Om du har en kvantitet som har angetts fÃ¶r denna typ av objekt och sÃ¤lja en, kommer de inte att Ã¤ndra efter fÃ¶rsÃ¤ljningen.',0),(451104,12531,'it','La quantitÃ  a portata di mano per gli elementi POD non vengono rilevate, poichÃ© essi sono \"prodotti on demand\".<p>Se avete una quantitÃ  specificata per questo tipo di elemento e vendere uno, su-mano non cambierÃ  dopo la vendita.',0),(451105,12531,'tl','',0),(451106,12531,'th','à¸¡à¸µà¹„à¸¡à¹ˆà¸¡à¸µà¸•à¸´à¸”à¸•à¸²à¸¡à¸›à¸£à¸´à¸¡à¸²à¸“à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸„à¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™à¹€à¸™à¸·à¹ˆà¸­à¸‡à¸ˆà¸²à¸à¸žà¸§à¸à¹€à¸‚à¸² \"à¸œà¸¥à¸´à¸•à¸•à¸²à¸¡à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£\"<p>à¸–à¹‰à¸²',0),(451107,12531,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¤°-à¤¹à¤¾à¤¥ à¤•à¥‡ à¤²à¤¿à¤ POD à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤¨à¤¹à¥€à¤‚ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥‡ à¤µà¥‡ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚\"à¤®à¤¾à¤‚à¤— à¤ªà¤°\" à¤Ÿà¥à¤°à¥ˆà¤• à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚à¥¤<p>à¤¯à¤¦à¤¿ à¤†à',0),(451108,12531,'ms','Kuantiti di-tangan untuk POD item tidak dikesan kerana ia \"dihasilkan atas permintaan\".<p>Jika anda mempunyai kuantiti yang ditentukan bagi jenis item dan menjual salah satu, yang bertugas tidak akan berubah selepas jualan.',0),(451109,12531,'ar','Ù„Ø§ ÙŠØªÙ… ØªØ¹Ù‚Ø¨ ÙƒÙ…ÙŠØ© ÙÙŠ-ÙŠØ¯Ù‡ Ù„Ù„Ø¨Ù†ÙˆØ¯ Ø¬Ø±Ø§Ø¨ Ø£Ù†Ù‡Ø§ \"ØªÙ†ØªØ¬ Ø­Ø³Ø¨ Ø§Ù„Ø·Ù„Ø¨\".<p>Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø¯ÙŠÙƒ ÙƒÙ…ÙŠØ© Ù…Ø­Ø¯Ø¯Ø© Ù„Ù‡Ø°Ø§ Ø§Ù„Ù†ÙˆØ¹ Ù…Ù† Ø¹Ù†ØµØ± ÙˆØ¨ÙŠØ¹ ÙˆØ§Ø­Ø¯ØŒ Ù„Ù† ØªØªØºÙŠØ± ÙÙŠ Ø§Ù„ÙŠØ¯ Ø¨Ø¹Ø¯ Ø§Ù„Ø¨ÙŠØ¹.',0),(451110,12531,'fr','La quantitÃ© disponible pour les Ã©lÃ©ments POD ne sont pas suivies car ils sont Â« produits Ã  la demande Â».<p>Si vous avez une quantitÃ© spÃ©cifiÃ©e pour ce type de question et vendez un, le stock ne changera pas aprÃ¨s la vente.',0),(451111,12531,'jp','ä»¥æ¥ã€å½¼ã‚‰ã¯\"ã‚ªãƒ³ãƒ‡ãƒžãƒ³ãƒ‰\"ç”Ÿç”£ã€æ•°é‡ã®æ‰‹æŒãƒãƒƒãƒ‰ ã‚¢ã‚¤ãƒ†ãƒ ã¯è¿½è·¡ã•ã‚Œã¾ã›ã‚“ã€‚<p>å ´åˆã¯ã“ã®é …ç›®ã®ç¨®é¡žã«å¯¾ã—ã¦æŒ‡å®šã•ã‚ŒãŸæ•°é‡ã‚’ 1 ã¤ã‚’è²©å£²ã€è²©å£²ã®å¾Œã§æ‰‹ã¯å¤‰æ›´ã•ã‚Œã¾ã›ã‚“ã€‚',0),(451112,12531,'pt','A quantidade disponÃ­vel para itens POD nÃ£o sÃ£o rastreadas desde que eles sÃ£o \"produzidos sob demanda\".<p>Se vocÃª tiver uma quantidade especificada para este tipo de item e vende um, sobre a mÃ£o nÃ£o vai mudar apÃ³s a venda.',0),(451113,12531,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ñ€ÑƒÐºÑƒ Ð´Ð»Ñ POD ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð½Ðµ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°ÑŽÑ‚ÑÑ, Ð¿Ð¾ÑÐºÐ¾Ð»ÑŒÐºÑƒ Ð¾Ð½Ð¸ Â«Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚ÑÑ Ð¿Ð¾ Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸ÑŽÂ».<p>Ð•ÑÐ»Ð¸ Ñƒ Ð²Ð°Ñ ÐµÑÑ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, ÑƒÐºÐ°Ð·Ð°Ð½Ð½Ð¾Ðµ Ð´Ð»',0),(451114,12531,'es','La cantidad que hay para POD items no estan siguidas ya que son \"producidos por demanda\". <p>Si tiene una cantidad especificada por este tipo de item y vende uno, la cantidad en reserva no cambiarÃ¡ despuÃ©s de la venta.',0),(451115,12531,'de','Die Menge an Hand fÃ¼r POD-Elemente werden nicht verfolgt, da sie \"on-Demand produziert werden\".<p>Wenn Sie Artikel verkaufen und eine Menge, die fÃ¼r diese Art von Element angegeben haben, Ã¤ndert sich die Hand nicht nach dem Verkauf.',0),(451116,12531,'en','The quantity on-hand for POD items are not tracked since they are \"produced on demand\". <p>If you have a quantity specified for this type of item and sell one, the on-hand will not change after the sale.',0),(451117,12532,'is','',0),(451118,12532,'dr','',0),(451119,12532,'pr','',0),(451120,12532,'tr','',0),(451121,12532,'pl','',0),(451122,12532,'bg','',0),(451123,12532,'ur','',0),(451124,12532,'sr','',0),(451125,12532,'vi','',0),(451126,12532,'af','',0),(451127,12532,'ro','',0),(451128,12532,'et','',0),(451129,12532,'si','',0),(451130,12532,'ba','',0),(451131,12532,'nl','',0),(451132,12532,'fi','',0),(451133,12532,'no','',0),(451134,12532,'da','',0),(451135,12532,'ko','',0),(451136,12532,'he','',0),(451137,12532,'el','',0),(451138,12532,'zh','',0),(451139,12532,'sv','',0),(451140,12532,'it','',0),(451141,12532,'tl','',0),(451142,12532,'th','',0),(451143,12532,'hi','',0),(451144,12532,'ms','',0),(451145,12532,'ar','',0),(451146,12532,'fr','',0),(451147,12532,'jp','',0),(451148,12532,'pt','',0),(451149,12532,'ru','',0),(451150,12532,'es','',0),(451151,12532,'de','',0),(451152,12532,'en','',0),(451153,12533,'is','',0),(451154,12533,'dr','',0),(451155,12533,'pr','',0),(451156,12533,'tr','',0),(451157,12533,'pl','',0),(451158,12533,'bg','',0),(451159,12533,'ur','',0),(451160,12533,'sr','',0),(451161,12533,'vi','',0),(451162,12533,'af','',0),(451163,12533,'ro','',0),(451164,12533,'et','',0),(451165,12533,'si','',0),(451166,12533,'ba','',0),(451167,12533,'nl','',0),(451168,12533,'fi','',0),(451169,12533,'no','',0),(451170,12533,'da','',0),(451171,12533,'ko','',0),(451172,12533,'he','',0),(451173,12533,'el','',0),(451174,12533,'zh','',0),(451175,12533,'sv','',0),(451176,12533,'it','',0),(451177,12533,'tl','',0),(451178,12533,'th','',0),(451179,12533,'hi','',0),(451180,12533,'ms','',0),(451181,12533,'ar','',0),(451182,12533,'fr','',0),(451183,12533,'jp','',0),(451184,12533,'pt','',0),(451185,12533,'ru','',0),(451186,12533,'es','',0),(451187,12533,'de','',0),(451188,12533,'en','',0),(451189,12534,'is','',0),(451190,12534,'dr','',0),(451191,12534,'pr','',0),(451192,12534,'tr','',0),(451193,12534,'pl','',0),(451194,12534,'bg','',0),(451195,12534,'ur','',0),(451196,12534,'sr','',0),(451197,12534,'vi','',0),(451198,12534,'af','',0),(451199,12534,'ro','',0),(451200,12534,'et','',0),(451201,12534,'si','',0),(451202,12534,'ba','',0),(451203,12534,'nl','',0),(451204,12534,'fi','',0),(451205,12534,'no','',0),(451206,12534,'da','',0),(451207,12534,'ko','',0),(451208,12534,'he','',0),(451209,12534,'el','',0),(451210,12534,'zh','',0),(451211,12534,'sv','',0),(451212,12534,'it','',0),(451213,12534,'tl','',0),(451214,12534,'th','',0),(451215,12534,'hi','',0),(451216,12534,'ms','',0),(451217,12534,'ar','',0),(451218,12534,'fr','',0),(451219,12534,'jp','',0),(451220,12534,'pt','',0),(451221,12534,'ru','',0),(451222,12534,'es','',0),(451223,12534,'de','',0),(451224,12534,'en','',0),(451225,12535,'is','',0),(451226,12535,'dr','',0),(451227,12535,'pr','',0),(451228,12535,'tr','',0),(451229,12535,'pl','',0),(451230,12535,'bg','',0),(451231,12535,'ur','',0),(451232,12535,'sr','',0),(451233,12535,'vi','',0),(451234,12535,'af','',0),(451235,12535,'ro','',0),(451236,12535,'et','',0),(451237,12535,'si','',0),(451238,12535,'ba','',0),(451239,12535,'nl','',0),(451240,12535,'fi','',0),(451241,12535,'no','',0),(451242,12535,'da','',0),(451243,12535,'ko','',0),(451244,12535,'he','',0),(451245,12535,'el','',0),(451246,12535,'zh','',0),(451247,12535,'sv','',0),(451248,12535,'it','',0),(451249,12535,'tl','',0),(451250,12535,'th','',0),(451251,12535,'hi','',0),(451252,12535,'ms','',0),(451253,12535,'ar','',0),(451254,12535,'fr','',0),(451255,12535,'jp','',0),(451256,12535,'pt','',0),(451257,12535,'ru','',0),(451258,12535,'es','',0),(451259,12535,'de','',0),(451260,12535,'en','',0),(451261,12536,'is','',0),(451262,12536,'dr','',0),(451263,12536,'pr','',0),(451264,12536,'tr','',0),(451265,12536,'pl','',0),(451266,12536,'bg','',0),(451267,12536,'ur','',0),(451268,12536,'sr','',0),(451269,12536,'vi','',0),(451270,12536,'af','',0),(451271,12536,'ro','',0),(451272,12536,'et','',0),(451273,12536,'si','',0),(451274,12536,'ba','',0),(451275,12536,'nl','',0),(451276,12536,'fi','',0),(451277,12536,'no','',0),(451278,12536,'da','',0),(451279,12536,'ko','',0),(451280,12536,'he','',0),(451281,12536,'el','',0),(451282,12536,'zh','',0),(451283,12536,'sv','',0),(451284,12536,'it','',0),(451285,12536,'tl','',0),(451286,12536,'th','',0),(451287,12536,'hi','',0),(451288,12536,'ms','',0),(451289,12536,'ar','',0),(451290,12536,'fr','',0),(451291,12536,'jp','',0),(451292,12536,'pt','',0),(451293,12536,'ru','',0),(451294,12536,'es','',0),(451295,12536,'de','',0),(451296,12536,'en','',0),(451297,12537,'is','',0),(451298,12537,'dr','',0),(451299,12537,'pr','',0),(451300,12537,'tr','',0),(451301,12537,'pl','',0),(451302,12537,'bg','',0),(451303,12537,'ur','',0),(451304,12537,'sr','',0),(451305,12537,'vi','',0),(451306,12537,'af','',0),(451307,12537,'ro','',0),(451308,12537,'et','',0),(451309,12537,'si','',0),(451310,12537,'ba','',0),(451311,12537,'nl','',0),(451312,12537,'fi','',0),(451313,12537,'no','',0),(451314,12537,'da','',0),(451315,12537,'ko','',0),(451316,12537,'he','',0),(451317,12537,'el','',0),(451318,12537,'zh','',0),(451319,12537,'sv','',0),(451320,12537,'it','',0),(451321,12537,'tl','',0),(451322,12537,'th','',0),(451323,12537,'hi','',0),(451324,12537,'ms','',0),(451325,12537,'ar','',0),(451326,12537,'fr','',0),(451327,12537,'jp','',0),(451328,12537,'pt','',0),(451329,12537,'ru','',0),(451330,12537,'es','',0),(451331,12537,'de','',0),(451332,12537,'en','',0),(451333,12538,'is','',0),(451334,12538,'dr','',0),(451335,12538,'pr','',0),(451336,12538,'tr','',0),(451337,12538,'pl','',0),(451338,12538,'bg','',0),(451339,12538,'ur','',0),(451340,12538,'sr','',0),(451341,12538,'vi','',0),(451342,12538,'af','',0),(451343,12538,'ro','',0),(451344,12538,'et','',0),(451345,12538,'si','',0),(451346,12538,'ba','',0),(451347,12538,'nl','',0),(451348,12538,'fi','',0),(451349,12538,'no','',0),(451350,12538,'da','',0),(451351,12538,'ko','',0),(451352,12538,'he','',0),(451353,12538,'el','',0),(451354,12538,'zh','',0),(451355,12538,'sv','',0),(451356,12538,'it','',0),(451357,12538,'tl','',0),(451358,12538,'th','',0),(451359,12538,'hi','',0),(451360,12538,'ms','',0),(451361,12538,'ar','',0),(451362,12538,'fr','',0),(451363,12538,'jp','',0),(451364,12538,'pt','',0),(451365,12538,'ru','',0),(451366,12538,'es','',0),(451367,12538,'de','',0),(451368,12538,'en','',0),(451369,12539,'is','',0),(451370,12539,'dr','',0),(451371,12539,'pr','',0),(451372,12539,'tr','',0),(451373,12539,'pl','',0),(451374,12539,'bg','',0),(451375,12539,'ur','',0),(451376,12539,'sr','',0),(451377,12539,'vi','',0),(451378,12539,'af','',0),(451379,12539,'ro','',0),(451380,12539,'et','',0),(451381,12539,'si','',0),(451382,12539,'ba','',0),(451383,12539,'nl','',0),(451384,12539,'fi','',0),(451385,12539,'no','',0),(451386,12539,'da','',0),(451387,12539,'ko','',0),(451388,12539,'he','',0),(451389,12539,'el','',0),(451390,12539,'zh','',0),(451391,12539,'sv','',0),(451392,12539,'it','',0),(451393,12539,'tl','',0),(451394,12539,'th','',0),(451395,12539,'hi','',0),(451396,12539,'ms','',0),(451397,12539,'ar','',0),(451398,12539,'fr','',0),(451399,12539,'jp','',0),(451400,12539,'pt','',0),(451401,12539,'ru','',0),(451402,12539,'es','',0),(451403,12539,'de','',0),(451404,12539,'en','',0),(451405,12540,'is','',0),(451406,12540,'dr','',0),(451407,12540,'pr','',0),(451408,12540,'tr','',0),(451409,12540,'pl','',0),(451410,12540,'bg','',0),(451411,12540,'ur','',0),(451412,12540,'sr','',0),(451413,12540,'vi','',0),(451414,12540,'af','',0),(451415,12540,'ro','',0),(451416,12540,'et','',0),(451417,12540,'si','',0),(451418,12540,'ba','',0),(451419,12540,'nl','',0),(451420,12540,'fi','',0),(451421,12540,'no','',0),(451422,12540,'da','',0),(451423,12540,'ko','',0),(451424,12540,'he','',0),(451425,12540,'el','',0),(451426,12540,'zh','',0),(451427,12540,'sv','',0),(451428,12540,'it','',0),(451429,12540,'tl','',0),(451430,12540,'th','',0),(451431,12540,'hi','',0),(451432,12540,'ms','',0),(451433,12540,'ar','',0),(451434,12540,'fr','',0),(451435,12540,'jp','',0),(451436,12540,'pt','',0),(451437,12540,'ru','',0),(451438,12540,'es','',0),(451439,12540,'de','',0),(451440,12540,'en','',0),(451441,12541,'is','',0),(451442,12541,'dr','',0),(451443,12541,'pr','',0),(451444,12541,'tr','',0),(451445,12541,'pl','',0),(451446,12541,'bg','',0),(451447,12541,'ur','',0),(451448,12541,'sr','',0),(451449,12541,'vi','',0),(451450,12541,'af','',0),(451451,12541,'ro','',0),(451452,12541,'et','',0),(451453,12541,'si','',0),(451454,12541,'ba','',0),(451455,12541,'nl','',0),(451456,12541,'fi','',0),(451457,12541,'no','',0),(451458,12541,'da','',0),(451459,12541,'ko','',0),(451460,12541,'he','',0),(451461,12541,'el','',0),(451462,12541,'zh','',0),(451463,12541,'sv','',0),(451464,12541,'it','',0),(451465,12541,'tl','',0),(451466,12541,'th','',0),(451467,12541,'hi','',0),(451468,12541,'ms','',0),(451469,12541,'ar','',0),(451470,12541,'fr','',0),(451471,12541,'jp','',0),(451472,12541,'pt','',0),(451473,12541,'ru','',0),(451474,12541,'es','',0),(451475,12541,'de','',0),(451476,12541,'en','',0),(451477,12542,'is','',0),(451478,12542,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø± Ø¯Ø³Øª Ø§Ù†Ø¬Ø§Ù… Ø¨Ø±Ø§ÛŒ Ù…ÙˆØ§Ø±Ø¯ ØºÙ„Ø§Ù Ù‡Ø³ØªÙ†Ø¯ Ù†Ù‡ Ø¯Ù†Ø¨Ø§Ù„ Ø§Ø² Ø¢Ù†Ø¬Ø§ÛŒÛŒ Ú©Ù‡ Ø¢Ù†Ù‡Ø§ \"Ø¯Ø± ØªÙ‚Ø§Ø¶Ø§ÛŒ ØªÙˆÙ„ÛŒØ¯ Ù…ÛŒ Ø´ÙˆØ¯\". Ø§Ú¯Ø± Ø´Ù…Ø§ ØªØ¹Ø¯Ø§Ø¯ Ù…Ø´Ø®Øµ Ùˆ ÙØ±ÙˆØ´ ÛŒÚ©ÛŒ Ø¯Ø± Ø¯Ø³Øª ØªØºÛŒÛŒØ± Ø®ÙˆØ§Ù‡Ø¯ Ú©',0),(451479,12542,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø± Ø¯Ø³Øª Ø§Ù†Ø¬Ø§Ù… Ø¨Ø±Ø§ÛŒ Ù…ÙˆØ§Ø±Ø¯ ØºÙ„Ø§Ù Ù‡Ø³ØªÙ†Ø¯ Ù†Ù‡ Ø¯Ù†Ø¨Ø§Ù„ Ø§Ø² Ø¢Ù†Ø¬Ø§ÛŒÛŒ Ú©Ù‡ Ø¢Ù†Ù‡Ø§ \"Ø¯Ø± ØªÙ‚Ø§Ø¶Ø§ÛŒ ØªÙˆÙ„ÛŒØ¯ Ù…ÛŒ Ø´ÙˆØ¯\". Ø§Ú¯Ø± Ø´Ù…Ø§ ØªØ¹Ø¯Ø§Ø¯ Ù…Ø´Ø®Øµ Ùˆ ÙØ±ÙˆØ´ ÛŒÚ©ÛŒ Ø¯Ø± Ø¯Ø³Øª ØªØºÛŒÛŒØ± Ø®ÙˆØ§Ù‡Ø¯ Ú©',0),(451480,12542,'tr','Miktar, eldeki POD Ã¶ÄŸeler iÃ§in deÄŸil izlenir \"beri\"isteÄŸe baÄŸlÄ± olarak Ã¼retilir. Belirtilen bir miktar var ve bir tane Sat, eldeki deÄŸiÅŸmez.<p>Fiziksel ve bitmiÅŸ Ã¼rÃ¼nler aynÄ± ÅŸekilde davranÄ±r ve stok azaltacaktÄ±r.',0),(451481,12542,'pl','IloÅ›Ä‡ na rÄ™ka POD elementy nie sÄ… Å›ledzone, poniewaÅ¼ one sÄ… \"produkowane na Å¼Ä…danie\". JeÅ›li iloÅ›Ä‡ okreÅ›lona i sprzedaÄ‡ jednÄ…, na strony nie zmieni siÄ™.<p>Fizyczne i gotowe towary zachowujÄ… siÄ™ tak samo i spowoduje zmniejszenie zapasÃ³w.',0),(451482,12542,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ñ€ÑŠÐºÐ° Ð·Ð° POD ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð½Ðµ ÑÐµ Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ñ‚, Ñ‚ÑŠÐ¹ ÐºÐ°Ñ‚Ð¾ Ñ‚Ðµ ÑÐ° \"Ð¿Ñ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð¸ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°\". ÐÐºÐ¾ ÑÑ‚Ðµ ÐºÐ¾Ð» Ð·Ð°Ð´Ð°Ð´ÐµÐ½ Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ð½Ð° ÐµÐ´Ð¸Ð½, Ð¿Ð¾Ð´ Ñ€ÑŠÐºÐ°,',0),(451483,12542,'ur','Ù‚ÛŒ Ù¾Ø± ÛØ§ØªÚ¾ Ù¾Ú¾Ù„ÛŒ Ø§Ø´ÛŒØ§ Ú©Û’ Ù„ÛŒÛ’ ÛÛŒÚº Ù†Û Ø³Ø±Ø§Øº Ù„Ú¯Ø§ÛŒØ§ Ú†ÙˆÙ†Ú©Û ÙˆÛ \"Ø·Ù„Ø¨ Ù¾Ø± Ù¾ÛŒØ¯Ø§ ÛÙˆØªÛ’ ÛÛŒÚº\" Û” Ø§Ú¯Ø± Ø¢Ù¾ Ø§Ø®ØªØµØ§ØµÛŒ Ø§ÛŒÚ© Ù‚ÛŒ ÛÛ’ Ø§ÙˆØ± Ø§ÛŒÚ© ÙØ±ÙˆØ®Øª, Ù¾Ø±-ÛØ§ØªÚ¾ ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø±Û’ Ú¯Ø§ ',0),(451484,12542,'sr','ÐšÐ¾Ð» . Ð½Ð°-Ñ€ÑƒÐºÐ° Ð·Ð° ÐšÐÐŸÐ¡Ð£Ð›Ð£ ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ðµ Ð¿Ñ€Ð°Ñ‚Ðµ Ð¾Ñ‚ÐºÐ°ÐºÐ¾ ÑÑƒ \"Ñ€Ð°Ð·Ð²Ð¸Ñ˜ÐµÐ½Ðµ Ð½Ð° Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²\". ÐÐºÐ¾ ÑÑ‚Ðµ Ð½Ð°Ð²ÐµÐ»Ð¸ Ð½Ð° ÐšÐ¾Ð» Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¼ 1, Ð½Ð° Ñ€ÑƒÐºÑƒ ÑÐµ Ð½ÐµÑ›Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ð¸.<p>Ð¤Ð¸Ð·Ð¸Ñ‡ÐºÐµ ',0),(451485,12542,'vi','Qty cho cÃ¡c háº¡ng má»¥c POD khÃ´ng Ä‘Æ°á»£c theo dÃµi ká»ƒ tá»« khi há» Ä‘Æ°á»£c \"sáº£n xuáº¥t theo yÃªu cáº§u.náº¿u báº¡n cÃ³ má»™t sá»‘ lÆ°á»£ng quy Ä‘á»‹nh thÃ¬ sá»‘ lÆ°á»£ng sáº½ khÃ´ng thay Ä‘á»•i. Cáº£ váº­t lÃ½ vÃ  thÃ nh pháº©m Ä‘á»u giáº£m hÃ',0),(451486,12542,'af','Die qty op-hand vir POD items is nie opgespoor nie, want hulle is \"geproduseer op aanvraag\". As jy \'n qty gespesifiseer en verkoop een, die op-hand sal verander nie.<p>Fisiese en klaar goedere dieselfde manier optree en voorraad sal verminder.',0),(451487,12542,'ro','Cantit pe mÃ¢nÄƒ pentru POD elemente nu sunt urmÄƒrite, deoarece acestea sunt \"produse la cerere\". DacÄƒ aveÅ£i o cantitate specificatÄƒ ÅŸi vinde unul, pe-o parte nu se va schimba.<p>Fizice ÅŸi terminat mÄƒrfurilor se comporte acelaÅŸi mod ÅŸi va reduce ',0),(451488,12542,'et','Kogus vaba POD Ã¼ksusi ei jÃ¤lgita, kuna nad on\"on demand\". Kui on mÃ¤Ã¤ratud kogus ja mÃ¼Ã¼a Ã¼ks vaba ei muutu.<p>FÃ¼Ã¼silise ja viimistletud kaupade kÃ¤ituda samamoodi ja vÃ¤hendab varude.',0),(451489,12542,'si','Kol na roko POD elementov ne beleÅ¾i, ker se \"pridelujejo na povpraÅ¡evanje\". ÄŒe so koliÄina, doloÄena in eno prodati, na strani ne bo spremenilo.<p>FiziÄni in konÄal blaga se obnaÅ¡ajo na enak naÄin in bo zmanjÅ¡anje zaloge.',0),(451490,12542,'ba','Qty di tangan untuk POD item tidak dilacak karena mereka adalah \"dihasilkan pada permintaan\". Jika Anda memiliki qty ditentukan dan menjual salah satu, tangan yang tidak akan berubah.<p>Fisik dan barang jadi berperilaku dengan cara yang sama dan akan meng',0),(451491,12542,'nl','Het aantal op-hand voor POD items worden niet bijgehouden aangezien zij vervaardigd zijn met\"on demand\". Als u een aantal opgegeven hebt en een verkopen, zal niet de hand veranderen.<p>Fysieke en klaar goederen dezelfde manier gedragen en inventaris zal v',0),(451492,12542,'fi','MÃ¤Ã¤rÃ¤ kÃ¤ytettÃ¤vissÃ¤ POD kohteita ei valvota, koska \"tuottaa kysyntÃ¤Ã¤n\". Jos sinulla on mÃ¤Ã¤ritetty mÃ¤Ã¤rÃ¤ ja myydÃ¤, on kÃ¤si ei muutu.<p>Fyysinen ja valmis tavarat samalla tavalla ja vÃ¤hentÃ¤Ã¤ varaston.',0),(451493,12542,'no','Antall beholdningen for POD varer registreres ikke siden de er \"produsert on demand\". Hvis du har et antall angitt og selge en, endres ikke beholdningen.<p>Fysiske og ferdigvarer fungere pÃ¥ samme mÃ¥te og vil redusere lageret.',0),(451494,12542,'da','Antal on-side for POD elementer spores ikke, da de er \"produceret on demand\". Hvis du har et antal angivet og sÃ¦lge en, vil side ikke Ã¦ndre.<p>Fysiske og fÃ¦rdige varer opfÃ¸rer sig pÃ¥ samme mÃ¥de og vil reducere lageret.',0),(451495,12542,'ko','ì´í›„ ê·¸ë“¤ì€ \"ìƒì‚° ìˆ˜ìš”ì—\" í¬ë“œ í•­ëª©ì— ëŒ€ í•œ ì†ì— qty ì¶”ì  ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤. ì§€ì • ëœ ìˆ˜ëŸ‰ì„ê°€ì§€ê³  í•˜ë‚˜ë¥¼ íŒë§¤ í•˜ëŠ” ê²½ìš°ì— ì§ì ‘ ë³€ê²½ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.<p>ì‹¤ì œ ì™„ë£Œ ìƒí’ˆ ê°™ì€ ë°©ì‹ìœ¼ë¡œ ë™ìž‘ í•˜ ê³',0),(451496,12542,'he','×›×ž×•×ª ×‘× ×ž×¦× ×¢×‘×•×¨ ×¤×¨×™×˜×™× ×¤×•×“ ×œ× ×ž×ª×‘×¦×¢ ×ž××– ×”× \"×ž×™×•×¦×¨×™× ×¢×œ ×¤×™ ×“×¨×™×©×”\". ×× ×™×© ×œ×›× ×›×ž×•×ª ×©×¦×•×™×Ÿ ×œ×ž×›×•×¨ ××—×“, ×‘× ×ž×¦× ×œ× ×™×©×ª× ×”.<p>×¤×™×–×™×ª ×¡×—×•×¨×•×ª ×¡×™×™× ×œ×”×ª× ×”×’ ×‘××•×',0),(451497,12542,'el','Î¤Î¿ qty ÎµÏ€Î¬Î½Ï‰-Ï‡Î­ÏÎ¹ Î³Î¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± POD Î´ÎµÎ½ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿Ï…Î¸Î¿ÏÎ½Ï„Î±Î¹ Î´ÎµÎ´Î¿Î¼Î­Î½Î¿Ï… ÏŒÏ„Î¹ \"Ï€Î±ÏÎ¬Î³Î¿Î½Ï„Î±Î¹ ÎºÎ±Ï„ÏŒÏ€Î¹Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚\". Î•Î¬Î½ Î­Ï‡ÎµÏ„Îµ Î¼Î¹Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… ÎºÎ±Î¸Î¿ÏÎ¯Î¶ÎµÏ„Î±Î',0),(451498,12542,'zh','è´§åˆ°ä»˜æ¬¾é¡¹ç›®çš„çŽ°æœ‰æ•°é‡æ— æ³•è·Ÿè¸ªå› ä¸ºå®ƒä»¬æ˜¯â€œæ ¹æ®éœ€æ±‚ç”Ÿäº§â€ã€‚å¦‚æžœæ‚¨æœ‰æ­¤é¡¹ç›®ç±»åž‹çš„ç‰¹å®šæ•°é‡å¹¶å‡ºå”®ä¸€ä»½ï¼ŒçŽ°æœ‰è´§é‡åœ¨å”®åŽä¸ä¼šæ”¹å˜ã€‚å®žé™…çš„å’Œå®Œæˆçš„è´§ç‰©ä¼šæŒ‰ç…§åŒæ ·æ–¹æ³•å·¥ä½œå¹¶ä¼šå‡å°‘åº“å­˜',0),(451499,12542,'sv','Antal pÃ¥-hand fÃ¶r POD artiklar spÃ¥ras inte eftersom de \"produceras pÃ¥ begÃ¤ran\". Om du har ett antal anges och sÃ¤lja en, kommer de inte att Ã¤ndra.<p>Fysiska och fÃ¤rdiga varor beter sig pÃ¥ samma sÃ¤tt och kommer att minska inventering.',0),(451500,12542,'it','Il qty a portata di mano per gli elementi POD non vengono rilevate, poichÃ© essi sono \"prodotti on demand\". Se avete un qty specificato e vendere uno, su-mano non cambierÃ .<p>Fisico e finito di beni si comportano allo stesso modo e ridurre le scorte.',0),(451501,12542,'tl','',0),(451502,12542,'th','à¸¡à¸µà¹„à¸¡à¹ˆà¸¡à¸µà¸•à¸´à¸”à¸•à¸²à¸¡à¸›à¸£à¸´à¸¡à¸²à¸“à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸„à¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™à¹€à¸™à¸·à¹ˆà¸­à¸‡à¸ˆà¸²à¸à¸žà¸§à¸à¹€à¸‚à¸² \"à¸œà¸¥à¸´à¸•à¸•à¸²à¸¡à¸„à¸§à¸²à¸¡à¸•à¹‰à¸­à¸‡à¸à¸²à¸£\" à¸–à¹‰à¸²à¸',0),(451503,12542,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¤°-à¤¹à¤¾à¤¥ à¤•à¥‡ à¤²à¤¿à¤ POD à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤¨à¤¹à¥€à¤‚ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥‡ à¤µà¥‡ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚\"à¤®à¤¾à¤‚à¤— à¤ªà¤°\" à¤Ÿà¥à¤°à¥ˆà¤• à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚à¥¤ à¤¯à¤¦à¤¿ à¤†à¤ª',0),(451504,12542,'ms','Dalam qty atas tangan untuk POD item tidak dikesan kerana ia \"dihasilkan atas permintaan\". Jika anda mempunyai qty yang dinyatakan dan menjual salah satu, yang bertugas tidak akan berubah.<p>Fizikal dan barangan siap berkelakuan dengan cara yang sama dan ',0),(451505,12542,'ar','Ù„Ø§ ÙŠØªÙ… ØªØ¹Ù‚Ø¨ qty ÙÙŠ-ÙŠØ¯Ù‡ Ù„Ù„Ø¨Ù†ÙˆØ¯ Ø¬Ø±Ø§Ø¨ Ø£Ù†Ù‡Ø§ \"ØªÙ†ØªØ¬ Ø­Ø³Ø¨ Ø§Ù„Ø·Ù„Ø¨\". Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø¯ÙŠÙƒ ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø­Ø¯Ø¯Ø© ÙˆØ¨ÙŠØ¹ ÙˆØ§Ø­Ø¯ØŒ Ù„Ù† ÙŠØºÙŠØ± ÙÙŠ Ø§Ù„ÙŠØ¯.<p>Ø§Ù„Ù…Ø§Ø¯ÙŠØ© ÙˆØ§Ù„Ø³Ù„Ø¹ Ù…Ù†ØªÙ‡ÙŠØ© ØªØªØµØ±Ù Ø¨Ù†ÙØ',0),(451506,12542,'fr','La QtÃ© en stock pour les Ã©lÃ©ments POD ne sont pas suivies car ils sont Â« produits Ã  la demande Â». Si vous avez une quantitÃ© spÃ©cifiÃ©e et vendez un, le stock ne changera pas.<p>Physique et produits finis se comportent de la mÃªme faÃ§on et rÃ©duir',0),(451507,12542,'jp','ä»¥æ¥ã€å½¼ã‚‰ã¯\"ã‚ªãƒ³ãƒ‡ãƒžãƒ³ãƒ‰\"ç”Ÿç”£ã€æ•°é‡ã®æ‰‹æŒãƒãƒƒãƒ‰ ã‚¢ã‚¤ãƒ†ãƒ ã¯è¿½è·¡ã•ã‚Œã¾ã›ã‚“ã€‚å ´åˆã¯ã€æ•°é‡ã‚’æŒ‡å®šã—ã¦ 1 ã¤ã‚’è²©å£²ã€æ‰‹ã«ã¯å¤‰æ›´ã•ã‚Œã¾ã›ã‚“ã€‚<p>ç‰©ç†çš„ãªå®Œæˆå“åŒã˜ã‚ˆã†ã«å‹•ä½œã—ã€åœ¨åº«ã®',0),(451508,12542,'pt','O qty disponÃ­vel para itens POD nÃ£o sÃ£o rastreadas desde que eles sÃ£o \"produzidos sob demanda\". Se vocÃª tiver uma quantidade especificada e vende um, sobre a mÃ£o nÃ£o vai mudar.<p>FÃ­sica e produtos acabados se comportam da mesma maneira e irÃ¡ redu',0),(451509,12542,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð½Ð° Ñ€ÑƒÐºÑƒ Ð´Ð»Ñ POD ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð½Ðµ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°ÑŽÑ‚ÑÑ, Ñ‚Ð°Ðº ÐºÐ°Ðº Ð¾Ð½Ð¸ Â«Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ÑÑ‚ÑÑ Ð¿Ð¾ Ñ‚Ñ€ÐµÐ±Ð¾Ð²Ð°Ð½Ð¸ÑŽÂ». Ð•ÑÐ»Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑƒÐºÐ°Ð·Ð°Ð½Ð½Ñ‹Ñ… Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ‚ÑŒ Ð¾Ð´Ð¸Ð½, Ð½Ð° Ñ€ÑƒÐºÑ',0),(451510,12542,'es','La cantidad en reserva para POD items no estan seguido ya que estan \"Producido por Demanda\". Si tiene una cantidad especificada y vende una, la cantidad en reserva no cambiarÃ¡.<p> Bienes fisicos y Terminados comportan en la misma manera y reducirÃ¡ el in',0),(451511,12542,'de','Die Qty Lagerbestand fÃ¼r POD-Elemente werden nicht verfolgt, da sie \"on-Demand produziert werden\". Wenn Sie Artikel verkaufen und eine Menge angegeben haben, wird die Hand nicht Ã¤ndern.<p>Physikalische und fertig waren genauso zu Verhalten und reduziert',0),(451512,12542,'en','The qty on-hand for POD items are not tracked since they are \"produced on demand\". If you have a qty specified and sell one, the on-hand will not change.<p>Physical and Finished Goods behave the same way and will reduce inventory.',0),(451513,12543,'is','',0),(451514,12543,'dr','',0),(451515,12543,'pr','',0),(451516,12543,'tr','',0),(451517,12543,'pl','',0),(451518,12543,'bg','',0),(451519,12543,'ur','',0),(451520,12543,'sr','',0),(451521,12543,'vi','',0),(451522,12543,'af','',0),(451523,12543,'ro','',0),(451524,12543,'et','',0),(451525,12543,'si','',0),(451526,12543,'ba','',0),(451527,12543,'nl','',0),(451528,12543,'fi','',0),(451529,12543,'no','',0),(451530,12543,'da','',0),(451531,12543,'ko','',0),(451532,12543,'he','',0),(451533,12543,'el','',0),(451534,12543,'zh','',0),(451535,12543,'sv','',0),(451536,12543,'it','',0),(451537,12543,'tl','',0),(451538,12543,'th','',0),(451539,12543,'hi','',0),(451540,12543,'ms','',0),(451541,12543,'ar','',0),(451542,12543,'fr','',0),(451543,12543,'jp','',0),(451544,12543,'pt','',0),(451545,12543,'ru','',0),(451546,12543,'es','',0),(451547,12543,'de','',0),(451548,12543,'en','',0),(451549,12544,'is','',0),(451550,12544,'dr','',0),(451551,12544,'pr','',0),(451552,12544,'tr','',0),(451553,12544,'pl','',0),(451554,12544,'bg','',0),(451555,12544,'ur','',0),(451556,12544,'sr','',0),(451557,12544,'vi','',0),(451558,12544,'af','',0),(451559,12544,'ro','',0),(451560,12544,'et','',0),(451561,12544,'si','',0),(451562,12544,'ba','',0),(451563,12544,'nl','',0),(451564,12544,'fi','',0),(451565,12544,'no','',0),(451566,12544,'da','',0),(451567,12544,'ko','',0),(451568,12544,'he','',0),(451569,12544,'el','',0),(451570,12544,'zh','',0),(451571,12544,'sv','',0),(451572,12544,'it','',0),(451573,12544,'tl','',0),(451574,12544,'th','',0),(451575,12544,'hi','',0),(451576,12544,'ms','',0),(451577,12544,'ar','',0),(451578,12544,'fr','',0),(451579,12544,'jp','',0),(451580,12544,'pt','',0),(451581,12544,'ru','',0),(451582,12544,'es','',0),(451583,12544,'de','',0),(451584,12544,'en','',0),(451585,12545,'is','',0),(451586,12545,'dr','',0),(451587,12545,'pr','',0),(451588,12545,'tr','',0),(451589,12545,'pl','',0),(451590,12545,'bg','',0),(451591,12545,'ur','',0),(451592,12545,'sr','',0),(451593,12545,'vi','',0),(451594,12545,'af','',0),(451595,12545,'ro','',0),(451596,12545,'et','',0),(451597,12545,'si','',0),(451598,12545,'ba','',0),(451599,12545,'nl','',0),(451600,12545,'fi','',0),(451601,12545,'no','',0),(451602,12545,'da','',0),(451603,12545,'ko','',0),(451604,12545,'he','',0),(451605,12545,'el','',0),(451606,12545,'zh','',0),(451607,12545,'sv','',0),(451608,12545,'it','',0),(451609,12545,'tl','',0),(451610,12545,'th','',0),(451611,12545,'hi','',0),(451612,12545,'ms','',0),(451613,12545,'ar','',0),(451614,12545,'fr','',0),(451615,12545,'jp','',0),(451616,12545,'pt','',0),(451617,12545,'ru','',0),(451618,12545,'es','',0),(451619,12545,'de','',0),(451620,12545,'en','',0),(451621,12546,'is','',0),(451622,12546,'dr','',0),(451623,12546,'pr','',0),(451624,12546,'tr','',0),(451625,12546,'pl','',0),(451626,12546,'bg','',0),(451627,12546,'ur','',0),(451628,12546,'sr','',0),(451629,12546,'vi','',0),(451630,12546,'af','',0),(451631,12546,'ro','',0),(451632,12546,'et','',0),(451633,12546,'si','',0),(451634,12546,'ba','',0),(451635,12546,'nl','',0),(451636,12546,'fi','',0),(451637,12546,'no','',0),(451638,12546,'da','',0),(451639,12546,'ko','',0),(451640,12546,'he','',0),(451641,12546,'el','',0),(451642,12546,'zh','',0),(451643,12546,'sv','',0),(451644,12546,'it','',0),(451645,12546,'tl','',0),(451646,12546,'th','',0),(451647,12546,'hi','',0),(451648,12546,'ms','',0),(451649,12546,'ar','',0),(451650,12546,'fr','',0),(451651,12546,'jp','',0),(451652,12546,'pt','',0),(451653,12546,'ru','',0),(451654,12546,'es','',0),(451655,12546,'de','',0),(451656,12546,'en','',0),(451657,12547,'is','',0),(451658,12547,'dr','',0),(451659,12547,'pr','',0),(451660,12547,'tr','',0),(451661,12547,'pl','',0),(451662,12547,'bg','',0),(451663,12547,'ur','',0),(451664,12547,'sr','',0),(451665,12547,'vi','',0),(451666,12547,'af','',0),(451667,12547,'ro','',0),(451668,12547,'et','',0),(451669,12547,'si','',0),(451670,12547,'ba','',0),(451671,12547,'nl','',0),(451672,12547,'fi','',0),(451673,12547,'no','',0),(451674,12547,'da','',0),(451675,12547,'ko','',0),(451676,12547,'he','',0),(451677,12547,'el','',0),(451678,12547,'zh','',0),(451679,12547,'sv','',0),(451680,12547,'it','',0),(451681,12547,'tl','',0),(451682,12547,'th','',0),(451683,12547,'hi','',0),(451684,12547,'ms','',0),(451685,12547,'ar','',0),(451686,12547,'fr','',0),(451687,12547,'jp','',0),(451688,12547,'pt','',0),(451689,12547,'ru','',0),(451690,12547,'es','',0),(451691,12547,'de','',0),(451692,12547,'en','',0),(451693,12548,'is','',0),(451694,12548,'dr','',0),(451695,12548,'pr','',0),(451696,12548,'tr','',0),(451697,12548,'pl','',0),(451698,12548,'bg','',0),(451699,12548,'ur','',0),(451700,12548,'sr','',0),(451701,12548,'vi','',0),(451702,12548,'af','',0),(451703,12548,'ro','',0),(451704,12548,'et','',0),(451705,12548,'si','',0),(451706,12548,'ba','',0),(451707,12548,'nl','',0),(451708,12548,'fi','',0),(451709,12548,'no','',0),(451710,12548,'da','',0),(451711,12548,'ko','',0),(451712,12548,'he','',0),(451713,12548,'el','',0),(451714,12548,'zh','',0),(451715,12548,'sv','',0),(451716,12548,'it','',0),(451717,12548,'tl','',0),(451718,12548,'th','',0),(451719,12548,'hi','',0),(451720,12548,'ms','',0),(451721,12548,'ar','',0),(451722,12548,'fr','',0),(451723,12548,'jp','',0),(451724,12548,'pt','',0),(451725,12548,'ru','',0),(451726,12548,'es','',0),(451727,12548,'de','',0),(451728,12548,'en','',0),(451729,12549,'is','',0),(451730,12549,'dr','',0),(451731,12549,'pr','',0),(451732,12549,'tr','',0),(451733,12549,'pl','',0),(451734,12549,'bg','',0),(451735,12549,'ur','',0),(451736,12549,'sr','',0),(451737,12549,'vi','',0),(451738,12549,'af','',0),(451739,12549,'ro','',0),(451740,12549,'et','',0),(451741,12549,'si','',0),(451742,12549,'ba','',0),(451743,12549,'nl','',0),(451744,12549,'fi','',0),(451745,12549,'no','',0),(451746,12549,'da','',0),(451747,12549,'ko','',0),(451748,12549,'he','',0),(451749,12549,'el','',0),(451750,12549,'zh','',0),(451751,12549,'sv','',0),(451752,12549,'it','',0),(451753,12549,'tl','',0),(451754,12549,'th','',0),(451755,12549,'hi','',0),(451756,12549,'ms','',0),(451757,12549,'ar','',0),(451758,12549,'fr','',0),(451759,12549,'jp','',0),(451760,12549,'pt','',0),(451761,12549,'ru','',0),(451762,12549,'es','',0),(451763,12549,'de','',0),(451764,12549,'en','',0),(451765,12550,'is','',0),(451766,12550,'dr','',0),(451767,12550,'pr','',0),(451768,12550,'tr','',0),(451769,12550,'pl','',0),(451770,12550,'bg','',0),(451771,12550,'ur','',0),(451772,12550,'sr','',0),(451773,12550,'vi','',0),(451774,12550,'af','',0),(451775,12550,'ro','',0),(451776,12550,'et','',0),(451777,12550,'si','',0),(451778,12550,'ba','',0),(451779,12550,'nl','',0),(451780,12550,'fi','',0),(451781,12550,'no','',0),(451782,12550,'da','',0),(451783,12550,'ko','',0),(451784,12550,'he','',0),(451785,12550,'el','',0),(451786,12550,'zh','',0),(451787,12550,'sv','',0),(451788,12550,'it','',0),(451789,12550,'tl','',0),(451790,12550,'th','',0),(451791,12550,'hi','',0),(451792,12550,'ms','',0),(451793,12550,'ar','',0),(451794,12550,'fr','',0),(451795,12550,'jp','',0),(451796,12550,'pt','',0),(451797,12550,'ru','',0),(451798,12550,'es','',0),(451799,12550,'de','',0),(451800,12550,'en','',0),(451801,12551,'is','',0),(451802,12551,'dr','',0),(451803,12551,'pr','',0),(451804,12551,'tr','',0),(451805,12551,'pl','',0),(451806,12551,'bg','',0),(451807,12551,'ur','',0),(451808,12551,'sr','',0),(451809,12551,'vi','',0),(451810,12551,'af','',0),(451811,12551,'ro','',0),(451812,12551,'et','',0),(451813,12551,'si','',0),(451814,12551,'ba','',0),(451815,12551,'nl','',0),(451816,12551,'fi','',0),(451817,12551,'no','',0),(451818,12551,'da','',0),(451819,12551,'ko','',0),(451820,12551,'he','',0),(451821,12551,'el','',0),(451822,12551,'zh','',0),(451823,12551,'sv','',0),(451824,12551,'it','',0),(451825,12551,'tl','',0),(451826,12551,'th','',0),(451827,12551,'hi','',0),(451828,12551,'ms','',0),(451829,12551,'ar','',0),(451830,12551,'fr','',0),(451831,12551,'jp','',0),(451832,12551,'pt','',0),(451833,12551,'ru','',0),(451834,12551,'es','',0),(451835,12551,'de','',0),(451836,12551,'en','',0),(451837,12552,'is','',0),(451838,12552,'dr','',0),(451839,12552,'pr','',0),(451840,12552,'tr','',0),(451841,12552,'pl','',0),(451842,12552,'bg','',0),(451843,12552,'ur','',0),(451844,12552,'sr','',0),(451845,12552,'vi','',0),(451846,12552,'af','',0),(451847,12552,'ro','',0),(451848,12552,'et','',0),(451849,12552,'si','',0),(451850,12552,'ba','',0),(451851,12552,'nl','',0),(451852,12552,'fi','',0),(451853,12552,'no','',0),(451854,12552,'da','',0),(451855,12552,'ko','',0),(451856,12552,'he','',0),(451857,12552,'el','',0),(451858,12552,'zh','',0),(451859,12552,'sv','',0),(451860,12552,'it','',0),(451861,12552,'tl','',0),(451862,12552,'th','',0),(451863,12552,'hi','',0),(451864,12552,'ms','',0),(451865,12552,'ar','',0),(451866,12552,'fr','',0),(451867,12552,'jp','',0),(451868,12552,'pt','',0),(451869,12552,'ru','',0),(451870,12552,'es','',0),(451871,12552,'de','',0),(451872,12552,'en','',0),(451873,12553,'is','',0),(451874,12553,'dr','ÙÛŒØ²ÛŒÚ©ÛŒ Ø¨Ø§ÛŒØ¯ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù‚Ø±Ø§Ø± Ú¯ÛŒØ±Ø¯ Ø¨Ø±Ø§ÛŒ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÛŒÙ‡ Ùˆ Ú©Ø§Ù„Ø§Ù‡Ø§ÛŒ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ø®ÙˆØ§Ù‡Ø¯ Ø¨ÙˆØ¯ Ù…ÙˆØ§Ø±Ø¯ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¢Ù…Ø§Ø¯Ù‡ ÙØ±ÙˆØ´. Ø§ÛŒÙ† Ù‡Ø± Ø¯Ùˆ Ø±ÙØªØ§Ø± Ù‡Ù…Ø§Ù† Ø±Ø§Ù‡ Ùˆ Ø§Ø² Ù…ÙˆØ¬Ù',0),(451875,12553,'pr','ÙÛŒØ²ÛŒÚ©ÛŒ Ø¨Ø§ÛŒØ¯ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù‚Ø±Ø§Ø± Ú¯ÛŒØ±Ø¯ Ø¨Ø±Ø§ÛŒ Ù…ÙˆØ§Ø¯ Ø§ÙˆÙ„ÛŒÙ‡ Ùˆ Ú©Ø§Ù„Ø§Ù‡Ø§ÛŒ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ø®ÙˆØ§Ù‡Ø¯ Ø¨ÙˆØ¯ Ù…ÙˆØ§Ø±Ø¯ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¢Ù…Ø§Ø¯Ù‡ ÙØ±ÙˆØ´. Ø§ÛŒÙ† Ù‡Ø± Ø¯Ùˆ Ø±ÙØªØ§Ø± Ù‡Ù…Ø§Ù† Ø±Ø§Ù‡ Ùˆ Ø§Ø² Ù…ÙˆØ¬Ù',0),(451876,12553,'tr','Fizik-meli var olmak kullanÄ±lmÄ±ÅŸ iÃ§in hammadde ve bitmiÅŸ Ã¼rÃ¼nler standart hazÄ±r SatÄ±yoruz Ã¼rÃ¼n-ecek var olmak. Bu ikisi de aynÄ± ÅŸekilde davranÄ±r ve kullanÄ±ldÄ±ÄŸÄ±nda stoktan alÄ±nacaktÄ±r.',0),(451877,12553,'pl','Fizyczne powinny byÄ‡ wykorzystywane do surowcÃ³w i gotowych towarÃ³w bÄ™dÄ… standardowe elementy gotowe do sprzedaÅ¼y. Oba te zachowujÄ… siÄ™ tak samo i bÄ™dzie pobierane z magazynu uÅ¼ywanego.',0),(451878,12553,'bg','Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð·Ð° ÑÑƒÑ€Ð¾Ð²Ð¸Ð½Ð¸ Ð¸ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸ ÑÑ‚Ð¾ÐºÐ¸ Ñ‰Ðµ Ð±ÑŠÐ´Ð°Ñ‚ Ð²Ð°ÑˆÐ¸Ñ‚Ðµ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð½Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°. Ð¢ÐµÐ·Ð¸ Ð´Ð²Ð°Ð¼Ð°Ñ‚Ð° ÑÐµ Ð´ÑŠÑ€Ð¶Ð°',0),(451879,12553,'ur','Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø®Ø§Ù… Ù…Ø§Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§Ù†Ø§ Ú†Ø§ÛØ¦Û’ Ø§ÙˆØ± Ù…Ø§Ù„ Ø®ØªÙ… ÛÙˆ Ú¯ÛŒØ§ Ø¢Ù¾ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡ ÙØ±ÙˆØ®Øª Ú©Û’ Ù„Ø¦Û’ ØªÛŒØ§Ø± ÛÙˆ Ø¬Ø§Ø¦Û’ Ú¯Ø§ Û” ÙˆÛ Ø¯ÙˆÙ†ÙˆÚº Ø§Ø³ÛŒ Ø·Ø±Ø­ Ø¨Ø±ØªØ§Ø¤ Ø§ÙˆØ± Ø¬Ø¨ Ø§Ø³Ø',0),(451880,12553,'sr','Ð¤Ð¸Ð·Ð¸ÐºÐ°Ð»Ð½Ð° Ñ‚Ñ€ÐµÐ±Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð·Ð° ÑÐ¸Ñ€Ð¾Ð²Ð¸Ð½Ðµ Ð¸ Ð·Ð°Ð²Ñ€ÑˆÐ¸Ð¾ Ñ€Ð¾Ð±Ð° Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ. ÐžÐ²Ð¸ Ð¾Ð±Ð¾Ñ˜Ðµ ÑÐµ Ð¿Ð¾Ð½Ð°ÑˆÐ°Ñ˜Ñƒ Ð½Ð° Ð¸ÑÑ‚Ð¸ Ð½Ð°Ñ‡Ð¸Ð½ Ð¸ Ð±Ð¸Ñ‚Ð¸ ÐŸÑ€Ðµ',0),(451881,12553,'vi','Váº­t lÃ½ nÃªn Ä‘Æ°á»£c sá»­ dá»¥ng váº­t liá»‡u thÃ´ vÃ  hÃ ng hÃ³a thÃ nh pháº©m sáº½ lÃ  tiÃªu chuáº©n cá»§a nhá»¯ng máº·t hÃ ng Ä‘Ã£ sáºµn sÃ ng bÃ¡n. Hai cÃ¡i nÃ y cÃ³ cÃ¹ng 1 cÃ¡ch váº­n hÃ nh vÃ  sáº½ Ä‘Æ°á»£c giao hÃ ng khi Ä‘Æ°á»£c sá»­ dá»¥ng',0),(451882,12553,'af','Fisiese moet aangewend word vir grondstowwe en klaar goedere sal jou standaard gereed-vir-verkoop items. Hierdie beide dieselfde manier optree en van voorraad wanneer gebruik geneem sal word.',0),(451883,12553,'ro','Fizic ar trebui folosite pentru materiile prime ÅŸi terminat mÄƒrfurile vor fi elementele de gata-la-vinde standard. Aceste ambele se comporte acelaÅŸi mod ÅŸi vor fi preluate din stoc atunci cÃ¢nd este utilizat.',0),(451884,12553,'et','FÃ¼Ã¼silise kasutatud toorainete ja viimistletud kaupade on standard valmis mÃ¼Ã¼a kaupu. Need mÃµlemad kÃ¤ituda samamoodi ja laost vÃ¤ljastamist kasutamisel.',0),(451885,12553,'si','FiziÄno je treba uporabiti za surovine in konÄal blaga bo standardnih pripravljenih za prodajo postavk. Ti tako obnaÅ¡ajo na enak naÄin in bo vzeta iz zaloge pri uporabi.',0),(451886,12553,'ba','Fisik harus digunakan untuk bahan baku dan barang jadi akan siap-untuk-menjual item Anda standar. Keduanya berperilaku dengan cara yang sama dan akan diambil dari inventaris ketika digunakan.',0),(451887,12553,'nl','Fysieke moet worden gebruikt voor grondstoffen en afgewerkt goederen zullen uw standaardartikelen klaar-aan-verkopen. Deze beide zich gedragen dezelfde manier en vanuit de voorraad wanneer gebruikt zullen worden genomen.',0),(451888,12553,'fi','Fyysinen kÃ¤ytetÃ¤Ã¤n raaka-aineiden ja valmis tavarat tulevat olemaan valmis myydÃ¤ vakiovarusteena. NÃ¤mÃ¤ molemmat samalla tavalla ja otetaan varastosta kÃ¤ytettynÃ¤.',0),(451889,12553,'no','Fysisk skal brukes for rÃ¥varer og ferdigvarer blir standard klar Ã¥ selge varene. Disse begge fungere pÃ¥ samme mÃ¥te og vil bli tatt fra lageret nÃ¥r det brukes.',0),(451890,12553,'da','Fysisk bÃ¸r anvendes til rÃ¥materialer og fÃ¦rdige varer vil vÃ¦re din standard klar til at sÃ¦lge varer. Disse bÃ¥de opfÃ¸rer sig pÃ¥ samme mÃ¥de og vil blive taget fra lager nÃ¥r de anvendes.',0),(451891,12553,'ko','ì‹¤ì œ ì› ìž¬ë£Œ ì‚¬ìš© í•´ì•¼ í•˜ë©° ì™„ë£Œ ìƒí’ˆì€ í‘œì¤€ íŒë§¤ ì¤€ë¹„ í•­ëª© ì¼ ê²ƒ ì´ë‹¤. ì´ ë‘˜ ë‹¤ ë™ì¼í•œ ë°©ì‹ìœ¼ë¡œ ë™ìž‘ í•˜ ê³  ì¸ë²¤í† ë¦¬ì—ì„œ ì‚¬ìš© ë  ë•Œ ì°ì€ ê²ƒìž…ë‹ˆë‹¤.',0),(451892,12553,'he','×”×¤×™×–×™ ××ž×•×¨ ×œ×©×ž×© ×¢×‘×•×¨ ×—×•×ž×¨×™ ×’×œ×, ×¡×—×•×¨×•×ª ×¡×™×™× ×™×”×™×” ×¤×¨×™×˜×™× ×¡×˜× ×“×¨×˜×™×™× ×©×œ×š ×ž×•×›×Ÿ ×›×“×™ ×œ×ž×›×•×¨. ××œ×” ×”×Ÿ ×ž×ª× ×”×’×•×ª ×‘××•×ª×• ×”××•×¤×Ÿ, ×™×™×œ×§×— ×ž×”×‘×™×ª ×ž×œ××™ ×‘×¢×ª ×©×™×ž×•×©.',0),(451893,12553,'el','Î¦Ï…ÏƒÎ¹ÎºÎ® Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î± Ï„Î¹Ï‚ Ï€ÏÏŽÏ„ÎµÏ‚ ÏÎ»ÎµÏ‚ ÎºÎ±Î¹ ÎµÎ¼Ï€Î¿ÏÎµÏÎ¼Î±Ï„Î± Ï„ÎµÎ»ÎµÎ¹ÏŽÏƒÎµÎ¹ Î¸Î± ÏƒÎ±Ï‚ Ï€ÏÏŒÏ„Ï…Ï€Î± Î­Ï„Î¿Î¹Î¼Î¿ Î½Î± Ï€Ï‰Î»Î®ÏƒÎ¿Ï…Î½ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±. Î‘Ï…Ï„Î¬ Ï„Î± Î´ÏÎ¿ Ïƒ',0),(451894,12553,'zh','å®žé™…åº”ç”¨äºŽåŽŸæ–™ï¼Œå®Œæˆçš„è´§ç‰©ä¼šæˆä¸ºæ‚¨æ ‡å‡†çš„å¾…å”®è´§ç‰©ã€‚è¿™äº›ä¼šæŒ‰ç…§åŒæ ·çš„æ–¹æ³•ï¼Œå¹¶ä¼šåœ¨ä½¿ç”¨æ—¶ä»Žåº“å­˜ä¸­è¢«å–å‡ºã€‚',0),(451895,12553,'sv','Fysiska bÃ¶r anvÃ¤ndas fÃ¶r rÃ¥varor och fÃ¤rdiga varor blir din standard redo att sÃ¤lja objekt. Dessa bÃ¥da beter sig pÃ¥ samma sÃ¤tt och tas frÃ¥n lagret nÃ¤r den anvÃ¤nds.',0),(451896,12553,'it','Fisica deve essere utilizzato per materie e merci finito sarÃ  tuoi articoli standard pronto a vendere. Entrambi si comportano allo stesso modo e saranno presi dall\'inventario quando viene utilizzato.',0),(451897,12553,'tl','',0),(451898,12553,'th','à¸ˆà¸£à¸´à¸‡à¸„à¸§à¸£à¸ˆà¸°à¹ƒà¸Šà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¸§à¸±à¸•à¸–à¸¸à¸”à¸´à¸š à¹à¸¥à¸°à¸ªà¸´à¸™à¸„à¹‰à¸²à¹€à¸ªà¸£à¹‡à¸ˆà¸ˆà¸°à¸¡à¸µà¸£à¸²à¸¢à¸à¸²à¸£à¸‚à¸­à¸‡à¸„à¸¸à¸“à¸žà¸£à¹‰à¸­à¸¡à¸à¸²à¸£à¸‚à¸²à¸¢à¸¡à¸²à¸•à¸£à¸à¸²à¸™ à¹€à¸«à¸¥à¹ˆà¸²à¸™à¸µà¹‰à¸—à¸±à',0),(451899,12553,'hi','à¤­à¥Œà¤¤à¤¿à¤• à¤•à¤šà¥à¤šà¥‡ à¤®à¤¾à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤ à¤”à¤° à¤®à¤¾à¤² à¤–à¤¤à¥à¤® à¤¹à¥‹ à¤…à¤ªà¤¨à¥‡ à¤®à¤¾à¤¨à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¯à¤¾à¤°-à¤¬à¥‡à¤šà¤¨à¥‡ à¤†à¤‡à¤Ÿà¤® à¤¹à',0),(451900,12553,'ms','Fizikal perlu digunakan untuk bahan-bahan mentah dan barangan siap akan bersedia untuk menjual barang-barang anda standard. -Kedua-duanya sekali berkelakuan dengan cara yang sama dan akan diambil daripada inventori apabila digunakan.',0),(451901,12553,'ar','Ø§Ù„Ø¨Ø¯Ù†ÙŠØ© ÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ØªØ³ØªØ®Ø¯Ù… Ù„Ù„Ù…ÙˆØ§Ø¯ Ø§Ù„Ø®Ø§Ù… Ùˆ \"Ø§Ù„Ø³Ù„Ø¹ Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡\" Ø³ÙˆÙ ØªÙƒÙˆÙ† Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ Ø¬Ø§Ù‡Ø²Ø© Ù„Ù„Ø¨ÙŠØ¹. Ù‡Ø°Ù‡ ÙƒÙ„ ØªØªØµØ±Ù Ø¨Ù†ÙØ³ Ø§Ù„Ø·Ø±ÙŠÙ‚Ø©ØŒ ÙˆØ³ÙˆÙ ØªØ¤Ø®Ø',0),(451902,12553,'fr','Physique doit Ãªtre utilisÃ© pour les matiÃ¨res premiÃ¨res et produits finis sera votre prÃªt-Ã -vendre des Ã©lÃ©ments standard. Ces deux comportent de la mÃªme faÃ§on et seront prises Ã  partir de l\'inventaire lorsqu\'il est utilisÃ©.',0),(451903,12553,'jp','åŽŸæ–™ã«ä½¿ç”¨ã™ã‚‹ç‰©ç†çš„ãªå®Œæˆå“ã¨æ¨™æº–çš„ãªæº–å‚™ãŒã§ãã¦è²©å£²ã™ã‚‹ã‚¢ã‚¤ãƒ†ãƒ ã€‚ã“ã‚Œã‚‰ã¯ä¸¡æ–¹ã¨ã‚‚åŒã˜ã‚ˆã†ã«å‹•ä½œã—ã€ä½¿ç”¨æ™‚ã®åœ¨åº«ã‹ã‚‰å–ã‚‰ã‚Œã¾ã™ã€‚',0),(451904,12553,'pt','FÃ­sica deve ser usada para matÃ©rias-primas e produtos acabados serÃ¡ seus padrÃ£o pronto-Ã -vendem itens. Ambos se comportam da mesma forma e serÃ£o tirados de inventÃ¡rio quando usado.',0),(451905,12553,'ru','Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ°Ñ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒÑÑ Ð´Ð»Ñ ÑÑ‹Ñ€ÑŒÑ Ð¸ Ð³Ð¾Ñ‚Ð¾Ð²Ð¾Ð¹ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ†Ð¸Ð¸ Ð±ÑƒÐ´ÐµÑ‚ Ð²Ð°ÑˆÐ¸ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð³Ð¾Ñ‚Ð¾Ð²Ñ‹ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸. Ð­Ñ‚Ð¸ Ð¾Ð±Ð° Ð²ÐµÐ´ÑƒÑ‚ ÑÐµÐ±Ñ Ñ‚Ð°Ðº ',0),(451906,12553,'es','FÃ­sico se debe usar para Materia Prima y Bienes Terminados serÃ¡ el estÃ¡ndar para sus items listos para vender. Estos do comportan en la misma manera y se tomarÃ¡n del inventario cuand estÃ¡n usados.',0),(451907,12553,'de','Physikalische fÃ¼r Rohstoffe verwendet werden sollte, und fertig waren werden Ihre bereit-zu-Sell-Standardelemente. Diese beiden werden Verhalten sich die gleiche Weise und aus dem Lager verwendet.',0),(451908,12553,'en','Physical should be used for Raw Materials and Finished Goods will be your standard ready-to-sell items. These both behave the same way and will be taken from inventory when used.',0),(451909,12554,'is','',0),(451910,12554,'dr','',0),(451911,12554,'pr','',0),(451912,12554,'tr','',0),(451913,12554,'pl','',0),(451914,12554,'bg','',0),(451915,12554,'ur','',0),(451916,12554,'sr','',0),(451917,12554,'vi','',0),(451918,12554,'af','',0),(451919,12554,'ro','',0),(451920,12554,'et','',0),(451921,12554,'si','',0),(451922,12554,'ba','',0),(451923,12554,'nl','',0),(451924,12554,'fi','',0),(451925,12554,'no','',0),(451926,12554,'da','',0),(451927,12554,'ko','',0),(451928,12554,'he','',0),(451929,12554,'el','',0),(451930,12554,'zh','',0),(451931,12554,'sv','',0),(451932,12554,'it','',0),(451933,12554,'tl','',0),(451934,12554,'th','',0),(451935,12554,'hi','',0),(451936,12554,'ms','',0),(451937,12554,'ar','',0),(451938,12554,'fr','',0),(451939,12554,'jp','',0),(451940,12554,'pt','',0),(451941,12554,'ru','',0),(451942,12554,'es','',0),(451943,12554,'de','',0),(451944,12554,'en','',0),(451945,12555,'is','',0),(451946,12555,'dr','',0),(451947,12555,'pr','',0),(451948,12555,'tr','',0),(451949,12555,'pl','',0),(451950,12555,'bg','',0),(451951,12555,'ur','',0),(451952,12555,'sr','',0),(451953,12555,'vi','',0),(451954,12555,'af','',0),(451955,12555,'ro','',0),(451956,12555,'et','',0),(451957,12555,'si','',0),(451958,12555,'ba','',0),(451959,12555,'nl','',0),(451960,12555,'fi','',0),(451961,12555,'no','',0),(451962,12555,'da','',0),(451963,12555,'ko','',0),(451964,12555,'he','',0),(451965,12555,'el','',0),(451966,12555,'zh','',0),(451967,12555,'sv','',0),(451968,12555,'it','',0),(451969,12555,'tl','',0),(451970,12555,'th','',0),(451971,12555,'hi','',0),(451972,12555,'ms','',0),(451973,12555,'ar','',0),(451974,12555,'fr','',0),(451975,12555,'jp','',0),(451976,12555,'pt','',0),(451977,12555,'ru','',0),(451978,12555,'es','',0),(451979,12555,'de','',0),(451980,12555,'en','',0),(451981,12556,'is','',0),(451982,12556,'dr','',0),(451983,12556,'pr','',0),(451984,12556,'tr','',0),(451985,12556,'pl','',0),(451986,12556,'bg','',0),(451987,12556,'ur','',0),(451988,12556,'sr','',0),(451989,12556,'vi','',0),(451990,12556,'af','',0),(451991,12556,'ro','',0),(451992,12556,'et','',0),(451993,12556,'si','',0),(451994,12556,'ba','',0),(451995,12556,'nl','',0),(451996,12556,'fi','',0),(451997,12556,'no','',0),(451998,12556,'da','',0),(451999,12556,'ko','',0),(452000,12556,'he','',0),(452001,12556,'el','',0),(452002,12556,'zh','',0),(452003,12556,'sv','',0),(452004,12556,'it','',0),(452005,12556,'tl','',0),(452006,12556,'th','',0),(452007,12556,'hi','',0),(452008,12556,'ms','',0),(452009,12556,'ar','',0),(452010,12556,'fr','',0),(452011,12556,'jp','',0),(452012,12556,'pt','',0),(452013,12556,'ru','',0),(452014,12556,'es','',0),(452015,12556,'de','',0),(452016,12556,'en','',0),(452017,12557,'is','',0),(452018,12557,'dr','',0),(452019,12557,'pr','',0),(452020,12557,'tr','',0),(452021,12557,'pl','',0),(452022,12557,'bg','',0),(452023,12557,'ur','',0),(452024,12557,'sr','',0),(452025,12557,'vi','',0),(452026,12557,'af','',0),(452027,12557,'ro','',0),(452028,12557,'et','',0),(452029,12557,'si','',0),(452030,12557,'ba','',0),(452031,12557,'nl','',0),(452032,12557,'fi','',0),(452033,12557,'no','',0),(452034,12557,'da','',0),(452035,12557,'ko','',0),(452036,12557,'he','',0),(452037,12557,'el','',0),(452038,12557,'zh','',0),(452039,12557,'sv','',0),(452040,12557,'it','',0),(452041,12557,'tl','',0),(452042,12557,'th','',0),(452043,12557,'hi','',0),(452044,12557,'ms','',0),(452045,12557,'ar','',0),(452046,12557,'fr','',0),(452047,12557,'jp','',0),(452048,12557,'pt','',0),(452049,12557,'ru','',0),(452050,12557,'es','',0),(452051,12557,'de','',0),(452052,12557,'en','',0),(452053,12558,'is','',0),(452054,12558,'dr','',0),(452055,12558,'pr','',0),(452056,12558,'tr','',0),(452057,12558,'pl','',0),(452058,12558,'bg','',0),(452059,12558,'ur','',0),(452060,12558,'sr','',0),(452061,12558,'vi','',0),(452062,12558,'af','',0),(452063,12558,'ro','',0),(452064,12558,'et','',0),(452065,12558,'si','',0),(452066,12558,'ba','',0),(452067,12558,'nl','',0),(452068,12558,'fi','',0),(452069,12558,'no','',0),(452070,12558,'da','',0),(452071,12558,'ko','',0),(452072,12558,'he','',0),(452073,12558,'el','',0),(452074,12558,'zh','',0),(452075,12558,'sv','',0),(452076,12558,'it','',0),(452077,12558,'tl','',0),(452078,12558,'th','',0),(452079,12558,'hi','',0),(452080,12558,'ms','',0),(452081,12558,'ar','',0),(452082,12558,'fr','',0),(452083,12558,'jp','',0),(452084,12558,'pt','',0),(452085,12558,'ru','',0),(452086,12558,'es','',0),(452087,12558,'de','',0),(452088,12558,'en','',0),(452089,12559,'is','',0),(452090,12559,'dr','',0),(452091,12559,'pr','',0),(452092,12559,'tr','',0),(452093,12559,'pl','',0),(452094,12559,'bg','',0),(452095,12559,'ur','',0),(452096,12559,'sr','',0),(452097,12559,'vi','',0),(452098,12559,'af','',0),(452099,12559,'ro','',0),(452100,12559,'et','',0),(452101,12559,'si','',0),(452102,12559,'ba','',0),(452103,12559,'nl','',0),(452104,12559,'fi','',0),(452105,12559,'no','',0),(452106,12559,'da','',0),(452107,12559,'ko','',0),(452108,12559,'he','',0),(452109,12559,'el','',0),(452110,12559,'zh','',0),(452111,12559,'sv','',0),(452112,12559,'it','',0),(452113,12559,'tl','',0),(452114,12559,'th','',0),(452115,12559,'hi','',0),(452116,12559,'ms','',0),(452117,12559,'ar','',0),(452118,12559,'fr','',0),(452119,12559,'jp','',0),(452120,12559,'pt','',0),(452121,12559,'ru','',0),(452122,12559,'es','',0),(452123,12559,'de','',0),(452124,12559,'en','',0),(452125,12560,'is','',0),(452126,12560,'dr','',0),(452127,12560,'pr','',0),(452128,12560,'tr','',0),(452129,12560,'pl','',0),(452130,12560,'bg','',0),(452131,12560,'ur','',0),(452132,12560,'sr','',0),(452133,12560,'vi','',0),(452134,12560,'af','',0),(452135,12560,'ro','',0),(452136,12560,'et','',0),(452137,12560,'si','',0),(452138,12560,'ba','',0),(452139,12560,'nl','',0),(452140,12560,'fi','',0),(452141,12560,'no','',0),(452142,12560,'da','',0),(452143,12560,'ko','',0),(452144,12560,'he','',0),(452145,12560,'el','',0),(452146,12560,'zh','',0),(452147,12560,'sv','',0),(452148,12560,'it','',0),(452149,12560,'tl','',0),(452150,12560,'th','',0),(452151,12560,'hi','',0),(452152,12560,'ms','',0),(452153,12560,'ar','',0),(452154,12560,'fr','',0),(452155,12560,'jp','',0),(452156,12560,'pt','',0),(452157,12560,'ru','',0),(452158,12560,'es','',0),(452159,12560,'de','',0),(452160,12560,'en','',0),(452161,12561,'is','',0),(452162,12561,'dr','',0),(452163,12561,'pr','',0),(452164,12561,'tr','',0),(452165,12561,'pl','',0),(452166,12561,'bg','',0),(452167,12561,'ur','',0),(452168,12561,'sr','',0),(452169,12561,'vi','',0),(452170,12561,'af','',0),(452171,12561,'ro','',0),(452172,12561,'et','',0),(452173,12561,'si','',0),(452174,12561,'ba','',0),(452175,12561,'nl','',0),(452176,12561,'fi','',0),(452177,12561,'no','',0),(452178,12561,'da','',0),(452179,12561,'ko','',0),(452180,12561,'he','',0),(452181,12561,'el','',0),(452182,12561,'zh','',0),(452183,12561,'sv','',0),(452184,12561,'it','',0),(452185,12561,'tl','',0),(452186,12561,'th','',0),(452187,12561,'hi','',0),(452188,12561,'ms','',0),(452189,12561,'ar','',0),(452190,12561,'fr','',0),(452191,12561,'jp','',0),(452192,12561,'pt','',0),(452193,12561,'ru','',0),(452194,12561,'es','',0),(452195,12561,'de','',0),(452196,12561,'en','',0),(452197,12562,'is','',0),(452198,12562,'dr','',0),(452199,12562,'pr','',0),(452200,12562,'tr','',0),(452201,12562,'pl','',0),(452202,12562,'bg','',0),(452203,12562,'ur','',0),(452204,12562,'sr','',0),(452205,12562,'vi','',0),(452206,12562,'af','',0),(452207,12562,'ro','',0),(452208,12562,'et','',0),(452209,12562,'si','',0),(452210,12562,'ba','',0),(452211,12562,'nl','',0),(452212,12562,'fi','',0),(452213,12562,'no','',0),(452214,12562,'da','',0),(452215,12562,'ko','',0),(452216,12562,'he','',0),(452217,12562,'el','',0),(452218,12562,'zh','',0),(452219,12562,'sv','',0),(452220,12562,'it','',0),(452221,12562,'tl','',0),(452222,12562,'th','',0),(452223,12562,'hi','',0),(452224,12562,'ms','',0),(452225,12562,'ar','',0),(452226,12562,'fr','',0),(452227,12562,'jp','',0),(452228,12562,'pt','',0),(452229,12562,'ru','',0),(452230,12562,'es','',0),(452231,12562,'de','',0),(452232,12562,'en','',0),(452233,12563,'is','',0),(452234,12563,'dr','',0),(452235,12563,'pr','',0),(452236,12563,'tr','',0),(452237,12563,'pl','',0),(452238,12563,'bg','',0),(452239,12563,'ur','',0),(452240,12563,'sr','',0),(452241,12563,'vi','',0),(452242,12563,'af','',0),(452243,12563,'ro','',0),(452244,12563,'et','',0),(452245,12563,'si','',0),(452246,12563,'ba','',0),(452247,12563,'nl','',0),(452248,12563,'fi','',0),(452249,12563,'no','',0),(452250,12563,'da','',0),(452251,12563,'ko','',0),(452252,12563,'he','',0),(452253,12563,'el','',0),(452254,12563,'zh','',0),(452255,12563,'sv','',0),(452256,12563,'it','',0),(452257,12563,'tl','',0),(452258,12563,'th','',0),(452259,12563,'hi','',0),(452260,12563,'ms','',0),(452261,12563,'ar','',0),(452262,12563,'fr','',0),(452263,12563,'jp','',0),(452264,12563,'pt','',0),(452265,12563,'ru','',0),(452266,12563,'es','',0),(452267,12563,'de','',0),(452268,12563,'en','',0),(452269,12564,'is','',0),(452270,12564,'dr','',0),(452271,12564,'pr','',0),(452272,12564,'tr','',0),(452273,12564,'pl','',0),(452274,12564,'bg','',0),(452275,12564,'ur','',0),(452276,12564,'sr','',0),(452277,12564,'vi','',0),(452278,12564,'af','',0),(452279,12564,'ro','',0),(452280,12564,'et','',0),(452281,12564,'si','',0),(452282,12564,'ba','',0),(452283,12564,'nl','',0),(452284,12564,'fi','',0),(452285,12564,'no','',0),(452286,12564,'da','',0),(452287,12564,'ko','',0),(452288,12564,'he','',0),(452289,12564,'el','',0),(452290,12564,'zh','',0),(452291,12564,'sv','',0),(452292,12564,'it','',0),(452293,12564,'tl','',0),(452294,12564,'th','',0),(452295,12564,'hi','',0),(452296,12564,'ms','',0),(452297,12564,'ar','',0),(452298,12564,'fr','',0),(452299,12564,'jp','',0),(452300,12564,'pt','',0),(452301,12564,'ru','',0),(452302,12564,'es','',0),(452303,12564,'de','',0),(452304,12564,'en','',0),(452305,12565,'is','',0),(452306,12565,'dr','',0),(452307,12565,'pr','',0),(452308,12565,'tr','',0),(452309,12565,'pl','',0),(452310,12565,'bg','',0),(452311,12565,'ur','',0),(452312,12565,'sr','',0),(452313,12565,'vi','',0),(452314,12565,'af','',0),(452315,12565,'ro','',0),(452316,12565,'et','',0),(452317,12565,'si','',0),(452318,12565,'ba','',0),(452319,12565,'nl','',0),(452320,12565,'fi','',0),(452321,12565,'no','',0),(452322,12565,'da','',0),(452323,12565,'ko','',0),(452324,12565,'he','',0),(452325,12565,'el','',0),(452326,12565,'zh','',0),(452327,12565,'sv','',0),(452328,12565,'it','',0),(452329,12565,'tl','',0),(452330,12565,'th','',0),(452331,12565,'hi','',0),(452332,12565,'ms','',0),(452333,12565,'ar','',0),(452334,12565,'fr','',0),(452335,12565,'jp','',0),(452336,12565,'pt','',0),(452337,12565,'ru','',0),(452338,12565,'es','',0),(452339,12565,'de','',0),(452340,12565,'en','',0),(452341,12566,'is','',0),(452342,12566,'dr','',0),(452343,12566,'pr','',0),(452344,12566,'tr','',0),(452345,12566,'pl','',0),(452346,12566,'bg','',0),(452347,12566,'ur','',0),(452348,12566,'sr','',0),(452349,12566,'vi','',0),(452350,12566,'af','',0),(452351,12566,'ro','',0),(452352,12566,'et','',0),(452353,12566,'si','',0),(452354,12566,'ba','',0),(452355,12566,'nl','',0),(452356,12566,'fi','',0),(452357,12566,'no','',0),(452358,12566,'da','',0),(452359,12566,'ko','',0),(452360,12566,'he','',0),(452361,12566,'el','',0),(452362,12566,'zh','',0),(452363,12566,'sv','',0),(452364,12566,'it','',0),(452365,12566,'tl','',0),(452366,12566,'th','',0),(452367,12566,'hi','',0),(452368,12566,'ms','',0),(452369,12566,'ar','',0),(452370,12566,'fr','',0),(452371,12566,'jp','',0),(452372,12566,'pt','',0),(452373,12566,'ru','',0),(452374,12566,'es','',0),(452375,12566,'de','',0),(452376,12566,'en','',0),(452377,12567,'is','',0),(452378,12567,'dr','',0),(452379,12567,'pr','',0),(452380,12567,'tr','',0),(452381,12567,'pl','',0),(452382,12567,'bg','',0),(452383,12567,'ur','',0),(452384,12567,'sr','',0),(452385,12567,'vi','',0),(452386,12567,'af','',0),(452387,12567,'ro','',0),(452388,12567,'et','',0),(452389,12567,'si','',0),(452390,12567,'ba','',0),(452391,12567,'nl','',0),(452392,12567,'fi','',0),(452393,12567,'no','',0),(452394,12567,'da','',0),(452395,12567,'ko','',0),(452396,12567,'he','',0),(452397,12567,'el','',0),(452398,12567,'zh','',0),(452399,12567,'sv','',0),(452400,12567,'it','',0),(452401,12567,'tl','',0),(452402,12567,'th','',0),(452403,12567,'hi','',0),(452404,12567,'ms','',0),(452405,12567,'ar','',0),(452406,12567,'fr','',0),(452407,12567,'jp','',0),(452408,12567,'pt','',0),(452409,12567,'ru','',0),(452410,12567,'es','',0),(452411,12567,'de','',0),(452412,12567,'en','',0),(452413,12568,'is','',0),(452414,12568,'dr','',0),(452415,12568,'pr','',0),(452416,12568,'tr','',0),(452417,12568,'pl','',0),(452418,12568,'bg','',0),(452419,12568,'ur','',0),(452420,12568,'sr','',0),(452421,12568,'vi','',0),(452422,12568,'af','',0),(452423,12568,'ro','',0),(452424,12568,'et','',0),(452425,12568,'si','',0),(452426,12568,'ba','',0),(452427,12568,'nl','',0),(452428,12568,'fi','',0),(452429,12568,'no','',0),(452430,12568,'da','',0),(452431,12568,'ko','',0),(452432,12568,'he','',0),(452433,12568,'el','',0),(452434,12568,'zh','',0),(452435,12568,'sv','',0),(452436,12568,'it','',0),(452437,12568,'tl','',0),(452438,12568,'th','',0),(452439,12568,'hi','',0),(452440,12568,'ms','',0),(452441,12568,'ar','',0),(452442,12568,'fr','',0),(452443,12568,'jp','',0),(452444,12568,'pt','',0),(452445,12568,'ru','',0),(452446,12568,'es','',0),(452447,12568,'de','',0),(452448,12568,'en','',0),(452449,12569,'is','',0),(452450,12569,'dr','',0),(452451,12569,'pr','',0),(452452,12569,'tr','',0),(452453,12569,'pl','',0),(452454,12569,'bg','',0),(452455,12569,'ur','',0),(452456,12569,'sr','',0),(452457,12569,'vi','',0),(452458,12569,'af','',0),(452459,12569,'ro','',0),(452460,12569,'et','',0),(452461,12569,'si','',0),(452462,12569,'ba','',0),(452463,12569,'nl','',0),(452464,12569,'fi','',0),(452465,12569,'no','',0),(452466,12569,'da','',0),(452467,12569,'ko','',0),(452468,12569,'he','',0),(452469,12569,'el','',0),(452470,12569,'zh','',0),(452471,12569,'sv','',0),(452472,12569,'it','',0),(452473,12569,'tl','',0),(452474,12569,'th','',0),(452475,12569,'hi','',0),(452476,12569,'ms','',0),(452477,12569,'ar','',0),(452478,12569,'fr','',0),(452479,12569,'jp','',0),(452480,12569,'pt','',0),(452481,12569,'ru','',0),(452482,12569,'es','',0),(452483,12569,'de','',0),(452484,12569,'en','',0),(452485,12570,'is','',0),(452486,12570,'dr','',0),(452487,12570,'pr','',0),(452488,12570,'tr','',0),(452489,12570,'pl','',0),(452490,12570,'bg','',0),(452491,12570,'ur','',0),(452492,12570,'sr','',0),(452493,12570,'vi','',0),(452494,12570,'af','',0),(452495,12570,'ro','',0),(452496,12570,'et','',0),(452497,12570,'si','',0),(452498,12570,'ba','',0),(452499,12570,'nl','',0),(452500,12570,'fi','',0),(452501,12570,'no','',0),(452502,12570,'da','',0),(452503,12570,'ko','',0),(452504,12570,'he','',0),(452505,12570,'el','',0),(452506,12570,'zh','',0),(452507,12570,'sv','',0),(452508,12570,'it','',0),(452509,12570,'tl','',0),(452510,12570,'th','',0),(452511,12570,'hi','',0),(452512,12570,'ms','',0),(452513,12570,'ar','',0),(452514,12570,'fr','',0),(452515,12570,'jp','',0),(452516,12570,'pt','',0),(452517,12570,'ru','',0),(452518,12570,'es','',0),(452519,12570,'de','',0),(452520,12570,'en','',0),(452521,12571,'is','',0),(452522,12571,'dr','',0),(452523,12571,'pr','',0),(452524,12571,'tr','',0),(452525,12571,'pl','',0),(452526,12571,'bg','',0),(452527,12571,'ur','',0),(452528,12571,'sr','',0),(452529,12571,'vi','',0),(452530,12571,'af','',0),(452531,12571,'ro','',0),(452532,12571,'et','',0),(452533,12571,'si','',0),(452534,12571,'ba','',0),(452535,12571,'nl','',0),(452536,12571,'fi','',0),(452537,12571,'no','',0),(452538,12571,'da','',0),(452539,12571,'ko','',0),(452540,12571,'he','',0),(452541,12571,'el','',0),(452542,12571,'zh','',0),(452543,12571,'sv','',0),(452544,12571,'it','',0),(452545,12571,'tl','',0),(452546,12571,'th','',0),(452547,12571,'hi','',0),(452548,12571,'ms','',0),(452549,12571,'ar','',0),(452550,12571,'fr','',0),(452551,12571,'jp','',0),(452552,12571,'pt','',0),(452553,12571,'ru','',0),(452554,12571,'es','',0),(452555,12571,'de','',0),(452556,12571,'en','',0),(452557,12572,'is','',0),(452558,12572,'dr','',0),(452559,12572,'pr','',0),(452560,12572,'tr','',0),(452561,12572,'pl','',0),(452562,12572,'bg','',0),(452563,12572,'ur','',0),(452564,12572,'sr','',0),(452565,12572,'vi','',0),(452566,12572,'af','',0),(452567,12572,'ro','',0),(452568,12572,'et','',0),(452569,12572,'si','',0),(452570,12572,'ba','',0),(452571,12572,'nl','',0),(452572,12572,'fi','',0),(452573,12572,'no','',0),(452574,12572,'da','',0),(452575,12572,'ko','',0),(452576,12572,'he','',0),(452577,12572,'el','',0),(452578,12572,'zh','',0),(452579,12572,'sv','',0),(452580,12572,'it','',0),(452581,12572,'tl','',0),(452582,12572,'th','',0),(452583,12572,'hi','',0),(452584,12572,'ms','',0),(452585,12572,'ar','',0),(452586,12572,'fr','',0),(452587,12572,'jp','',0),(452588,12572,'pt','',0),(452589,12572,'ru','',0),(452590,12572,'es','',0),(452591,12572,'de','',0),(452592,12572,'en','',0),(452593,12573,'is','',0),(452594,12573,'dr','',0),(452595,12573,'pr','',0),(452596,12573,'tr','',0),(452597,12573,'pl','',0),(452598,12573,'bg','',0),(452599,12573,'ur','',0),(452600,12573,'sr','',0),(452601,12573,'vi','',0),(452602,12573,'af','',0),(452603,12573,'ro','',0),(452604,12573,'et','',0),(452605,12573,'si','',0),(452606,12573,'ba','',0),(452607,12573,'nl','',0),(452608,12573,'fi','',0),(452609,12573,'no','',0),(452610,12573,'da','',0),(452611,12573,'ko','',0),(452612,12573,'he','',0),(452613,12573,'el','',0),(452614,12573,'zh','',0),(452615,12573,'sv','',0),(452616,12573,'it','',0),(452617,12573,'tl','',0),(452618,12573,'th','',0),(452619,12573,'hi','',0),(452620,12573,'ms','',0),(452621,12573,'ar','',0),(452622,12573,'fr','',0),(452623,12573,'jp','',0),(452624,12573,'pt','',0),(452625,12573,'ru','',0),(452626,12573,'es','',0),(452627,12573,'de','',0),(452628,12573,'en','',0),(452629,12574,'is','',0),(452630,12574,'dr','',0),(452631,12574,'pr','',0),(452632,12574,'tr','',0),(452633,12574,'pl','',0),(452634,12574,'bg','',0),(452635,12574,'ur','',0),(452636,12574,'sr','',0),(452637,12574,'vi','',0),(452638,12574,'af','',0),(452639,12574,'ro','',0),(452640,12574,'et','',0),(452641,12574,'si','',0),(452642,12574,'ba','',0),(452643,12574,'nl','',0),(452644,12574,'fi','',0),(452645,12574,'no','',0),(452646,12574,'da','',0),(452647,12574,'ko','',0),(452648,12574,'he','',0),(452649,12574,'el','',0),(452650,12574,'zh','',0),(452651,12574,'sv','',0),(452652,12574,'it','',0),(452653,12574,'tl','',0),(452654,12574,'th','',0),(452655,12574,'hi','',0),(452656,12574,'ms','',0),(452657,12574,'ar','',0),(452658,12574,'fr','',0),(452659,12574,'jp','',0),(452660,12574,'pt','',0),(452661,12574,'ru','',0),(452662,12574,'es','',0),(452663,12574,'de','',0),(452664,12574,'en','',0),(452665,12575,'is','',0),(452666,12575,'dr','Ø§Ú¯Ø± ÛŒÚ© Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ø¯Ùˆ Ø¨Ø§Ø± Ø¯Ø± Ø­Ø§Ù„ Ø´Ø¯Ù‡ Ùˆ Ø´Ù…Ø§ Ù…ÛŒ Ø®ÙˆØ§Ù‡Ù… Ø¨Ù‡ Ø§Ø¯ØºØ§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø±Ø§ Ø¨Ù‡ ÛŒÚ© ÙØ§ÛŒÙ„ Ø¨Ù‡ Ø¨Ø±ÙˆÛŒØ¯:<p><b>ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§-> Ù…Ø´ØªØ±ÛŒØ§Ù†-> Ù…Ø´ØªØ±ÛŒØ§Ù† Ø§Ø¯ØºØ§Ù…</b>',0),(452667,12575,'pr','Ø§Ú¯Ø± ÛŒÚ© Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ø¯Ùˆ Ø¨Ø§Ø± Ø¯Ø± Ø­Ø§Ù„ Ø´Ø¯Ù‡ Ùˆ Ø´Ù…Ø§ Ù…ÛŒ Ø®ÙˆØ§Ù‡Ù… Ø¨Ù‡ Ø§Ø¯ØºØ§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø±Ø§ Ø¨Ù‡ ÛŒÚ© ÙØ§ÛŒÙ„ Ø¨Ù‡ Ø¨Ø±ÙˆÛŒØ¯:<p><b>ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§-> Ù…Ø´ØªØ±ÛŒØ§Ù†-> Ù…Ø´ØªØ±ÛŒØ§Ù† Ø§Ø¯ØºØ§Ù…</b>',0),(452668,12575,'tr','Bir mÃ¼ÅŸteri iki kez oluÅŸturulduÄŸu ve bilgileri bir dosyaya birleÅŸtirmek istiyorsanÄ±z gidin:<p><b>Ä°lgili kiÅŸileri mÃ¼ÅŸteriler birleÅŸtirme mÃ¼ÅŸteriler->-></b>',0),(452669,12575,'pl','JeÅ›li klient utworzono dwa razy i chcesz scaliÄ‡ dane do jednego pliku, przejdÅº do:<p><b>Kontakty-> klienci-> klienci korespondencji seryjnej</b>',0),(452670,12575,'bg','ÐÐºÐ¾ ÐµÐ´Ð¸Ð½ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ðµ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° Ð´Ð²Ð° Ð¿ÑŠÑ‚Ð¸ Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¾Ð±ÐµÐ´Ð¸Ð½Ð¸Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑÑ‚Ð° Ð² ÐµÐ´Ð¸Ð½ Ñ„Ð°Ð¹Ð», Ð¿Ð¾ÑÐµÑ‚ÐµÑ‚Ðµ:<p><b>ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸-> ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸-> Ð¾Ð±ÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸</b>',0),(452671,12575,'ur','Ø§Ú¯Ø± Ø§ÛŒÚ© Ú¯Ø§ÛÚ© Ú©Ùˆ Ø¯Ùˆ Ù…Ø±ØªØ¨Û Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§ Ú¯ÛŒØ§ ØªÚ¾Ø§ Ø§ÙˆØ± Ø¢Ù¾ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§ÛŒÚ© Ù…Ø³Ù„ Ù…ÛŒÚº Ø¶Ù… Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº Ú©Û’ Ù„Ø¦Û’ Ø¬Ø§Ù†Ø§:<p><b>Ø±ÙˆØ§Ø¨Ø· Ú¯Ø§ÛÚ©ÙˆÚº Ø¶Ù… ØµØ§Ø±ÙÛŒÙ†->-></b>',0),(452672,12575,'sr','ÐÐºÐ¾ ÐºÑƒÐ¿Ð°Ñ† Ñ˜Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð° Ð´Ð²Ð° Ð¿ÑƒÑ‚Ð°, Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¾Ð±Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ñƒ Ñ˜ÐµÐ´Ð½Ð¾Ñ˜ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸ Ð¿Ð¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ:<p><b>ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸ Ð¸ ÐºÑƒÐ¿Ñ†Ðµ Ð¸ ÐºÑƒÐ¿Ñ†Ðµ Ð·Ð° Ð¾Ð±Ñ˜ÐµÐ´Ð¸ÑšÐ°Ð²Ð°ÑšÐ',0),(452673,12575,'vi','Náº¿u 1 khÃ¡ch hÃ ng Ä‘Æ°á»£c táº¡o 2 láº§n thÃ¬ báº¡n cáº§n há»£p nháº¥t thÃ nh 1 táº­p tin, LiÃªn lac->khÃ¡ch hÃ ng-> há»£p nháº¥t khÃ¡ch hÃ ng',0),(452674,12575,'af','As \'n klant was twee keer geskep en jy wil graag die inligting saamvoeg in een lÃªer gaan na:<p><b>Kontakte-> kliÃ«nte-> saamsmelt en kliÃ«nte</b>',0),(452675,12575,'ro','DacÄƒ un client a fost creat de douÄƒ ori ÅŸi aÅ£i dori sÄƒ Ã®mbinaÈ›i informaÈ›iile Ã®ntr-un fiÅŸier du-te la:<p><b>Contacte-> clienÅ£ii-> Ã®mbinare clienÅ£ii</b>',0),(452676,12575,'et','Kui klient on loodud kaks korda ja te soovite merge Ã¼hte faili teavet minna:<p><b>-> Hotelli-> kooste hotelli kontaktid</b>',0),(452677,12575,'si','ÄŒe stranka je bila dvakrat created in bi Å¾eleli zdruÅ¾iti informacije v eno datoteko, pojdite na:<p><b>Stiki-> stranke-> spajanje stranke</b>',0),(452678,12575,'ba','Jika pelanggan diciptakan dua kali dan Anda ingin menggabungkan informasi ke dalam satu file pergi ke:<p><b>Kontak-> pelanggan-> pelanggan Merge</b>',0),(452679,12575,'nl','Als een klant tweemaal gemaakt en u wilt de gegevens samenvoegen tot Ã©Ã©n bestand gaat u naar:<p><b>Contacten-> klanten-> samenvoegen klanten</b>',0),(452680,12575,'fi','Jos asiakas on luotu kahdesti ja haluat yhdistÃ¤Ã¤ tiedot yhdeksi tiedostoksi Siirry:<p><b>Yhteystiedot-> asiakkaat-> yhdistÃ¤misen asiakkaat</b>',0),(452681,12575,'no','Hvis en kunde ble opprettet to ganger og du vil flette informasjon i Ã©n fil gÃ¥ til:<p><b>Kontakter-> kunder-> flettingen kunder</b>',0),(452682,12575,'da','Hvis en kunde blev oprettet to gange, og du vil flette oplysningerne til Ã©n fil skal du gÃ¥ til:<p><b>Kontakter-> gÃ¦ster-> Flet kunder</b>',0),(452683,12575,'ko','ê³ ê° ë‘ ë²ˆ ìƒì„± í•˜ ê³  í•˜ë‚˜ì˜ íŒŒì¼ì— ì •ë³´ë¥¼ ë³‘í•© í•˜ë ¤ë©´ë¡œ ì´ë™:<p><b>ì—°ë½ì²˜ ë³‘í•© ê³ ê°-> ê³ ê°-></b>',0),(452684,12575,'he','×× ×œ×§×•×— × ×•×¦×¨ ×¤×¢×ž×™×™× ×•×”×•× ×©×‘×¨×¦×•× ×š ×œ×ž×–×’ ××ª ×”×ž×™×“×¢ ×œ×ª×•×š ×§×•×‘×¥ ××—×“ ×œ×œ×›×ª:<p><b>×× ×©×™ ×§×©×¨-> ×”×œ×§×•×—×•×ª-> ×ž×™×–×•×’ ×”×œ×§×•×—×•×ª</b>',0),(452685,12575,'el','Î‘Î½ Î­Î½Î±Ï‚ Ï€ÎµÎ»Î¬Ï„Î·Ï‚ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î´ÏÎ¿ Ï†Î¿ÏÎ­Ï‚ ÎºÎ±Î¹ Î½Î± Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÏƒÏ…Î³Ï‡Ï‰Î½ÎµÏÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÎµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿, Ï€Î·Î³Î±Î¯Î½ÎµÏ„Îµ ÏƒÏ„Î¿:<p><b>Î•Ï€Î±Ï†Î­Ï‚-> Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(452686,12575,'zh','å¦‚æžœä¸€ä¸ªå®¢æˆ·è¢«åˆ›å»ºä¸¤æ¬¡å¹¶ä¸”ä½ æƒ³åˆå¹¶ä¿¡æ¯åˆ°ä¸€ä¸ªæ–‡ä»¶ä¸­ï¼Œåˆ°ï¼šè”ç³»->å®¢æˆ·->åˆå¹¶å®¢æˆ·',0),(452687,12575,'sv','Om en kund skapades tvÃ¥ gÃ¥nger och du vill koppla information till en fil gÃ¥ till:<p><b>Kontakter-> kunder-> koppla kunder</b>',0),(452688,12575,'it','Se un cliente Ã¨ stato creato due volte e piacerebbe unire le informazioni in un file, andare a:<p><b>Contatti-> clienti-> Merge clienti</b>',0),(452689,12575,'tl','',0),(452690,12575,'th','à¸–à¹‰à¸²à¸¥à¸¹à¸à¸„à¹‰à¸²à¸–à¸¹à¸à¸ªà¸£à¹‰à¸²à¸‡à¸ªà¸­à¸‡à¸„à¸£à¸±à¹‰à¸‡ à¹à¸¥à¸°à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸œà¸ªà¸²à¸™ à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¥à¸‡à¹ƒà¸™à¹à¸Ÿà¹‰à¸¡à¸«à¸™à¸¶à¹ˆà¸‡à¹„à¸›à¸¢à¸±à¸‡:<p><b>à¸•à¸´à¸”à¸•à¹ˆà¸­->à¸¥à¸¹à¸à¸„à¹‰à¸²->à¸¥à¸¹à¸',0),(452691,12575,'hi','à¤¯à¤¦à¤¿ à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤¦à¥‹ à¤¬à¤¾à¤° à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¥à¤¾ à¤”à¤° à¤¤à¥à¤® à¤à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤®à¥‡à¤‚ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¤°à¥à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤œà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(452692,12575,'ms','Jika pelanggan telah dicipta dua kali dan anda ingin menggabungkan maklumat tersebut ke dalam satu fail pergi ke:<p><b>Kenalan-> pelanggan-> pelanggan gabungan</b>',0),(452693,12575,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø¹Ù…ÙŠÙ„ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡ Ù…Ø±ØªÙŠÙ†ØŒ ÙˆÙƒÙ†Øª ØªØ±ØºØ¨ ÙÙŠ Ø¯Ù…Ø¬ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ÙÙŠ Ù…Ù„Ù ÙˆØ§Ø­Ø¯ Ø§Ù„Ø°Ù‡Ø§Ø¨ Ø¥Ù„Ù‰:<p><b>Ø¬Ù‡Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„-> Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡-> Ø¯Ù…Ø¬ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡</b>',0),(452694,12575,'fr','Si un client a Ã©tÃ© crÃ©Ã© deux fois et que vous souhaitez fusionner les informations dans un seul fichier, aller Ã  :<p><b>Contacts-> clients-> clients de fusion</b>',0),(452695,12575,'jp','é¡§å®¢ 2 å›žä½œæˆã—ã€æƒ…å ±ã‚’ 1 ã¤ã®ãƒ•ã‚¡ã‚¤ãƒ«ã«ãƒžãƒ¼ã‚¸ã—ãŸã„å ´åˆã«è¡Œãï¼š<p><b>Merge ã®é¡§å®¢-> ãŠå®¢æ§˜-> é€£çµ¡å…ˆ</b>',0),(452696,12575,'pt','Se duas vezes, foi criado um cliente e gostaria de mesclar as informaÃ§Ãµes em um arquivo, vÃ¡ para:<p><b>Contatos-> clientes-> clientes de mesclagem</b>',0),(452697,12575,'ru','Ð•ÑÐ»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð±Ñ‹Ð» ÑÐ¾Ð·Ð´Ð°Ð½ Ð´Ð²Ð°Ð¶Ð´Ñ‹ Ð¸ Ð²Ñ‹ Ñ…Ð¾Ñ‚ÐµÐ»Ð¸ Ð±Ñ‹ Ð¾Ð±ÑŠÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð² Ð¾Ð´Ð¸Ð½ Ñ„Ð°Ð¹Ð» Ð¿ÐµÑ€ÐµÐ¹Ð´Ð¸Ñ‚Ðµ Ðº:<p><b>ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñ‹-> ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²-> ÑÐ»Ð¸ÑÐ½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²</b>',0),(452698,12575,'es','Si un cliente se creÃ³ dos veces y quisiera fusionar la informaciÃ³n en un file va a:<p><b>Contactos ->Clientes ->Combinar Clientes</b>',0),(452699,12575,'de','Wenn ein Kunde zweimal erstellt wurde und die Informationen zu einer Datei zusammenfÃ¼gen mÃ¶chten gehen Sie zu:<p><b>Kontakte-> Kunden-> Merge-Kunden</b>',0),(452700,12575,'en','If a customer was created twice and you would like to merge the information into one file go to:<p><b>Contacts -> Customers -> Merge Customers</b>',0),(452701,12576,'is','',0),(452702,12576,'dr','',0),(452703,12576,'pr','',0),(452704,12576,'tr','',0),(452705,12576,'pl','',0),(452706,12576,'bg','',0),(452707,12576,'ur','',0),(452708,12576,'sr','',0),(452709,12576,'vi','',0),(452710,12576,'af','',0),(452711,12576,'ro','',0),(452712,12576,'et','',0),(452713,12576,'si','',0),(452714,12576,'ba','',0),(452715,12576,'nl','',0),(452716,12576,'fi','',0),(452717,12576,'no','',0),(452718,12576,'da','',0),(452719,12576,'ko','',0),(452720,12576,'he','',0),(452721,12576,'el','',0),(452722,12576,'zh','',0),(452723,12576,'sv','',0),(452724,12576,'it','',0),(452725,12576,'tl','',0),(452726,12576,'th','',0),(452727,12576,'hi','',0),(452728,12576,'ms','',0),(452729,12576,'ar','',0),(452730,12576,'fr','',0),(452731,12576,'jp','',0),(452732,12576,'pt','',0),(452733,12576,'ru','',0),(452734,12576,'es','',0),(452735,12576,'de','',0),(452736,12576,'en','',0),(452737,12577,'is','',0),(452738,12577,'dr','',0),(452739,12577,'pr','',0),(452740,12577,'tr','',0),(452741,12577,'pl','',0),(452742,12577,'bg','',0),(452743,12577,'ur','',0),(452744,12577,'sr','',0),(452745,12577,'vi','',0),(452746,12577,'af','',0),(452747,12577,'ro','',0),(452748,12577,'et','',0),(452749,12577,'si','',0),(452750,12577,'ba','',0),(452751,12577,'nl','',0),(452752,12577,'fi','',0),(452753,12577,'no','',0),(452754,12577,'da','',0),(452755,12577,'ko','',0),(452756,12577,'he','',0),(452757,12577,'el','',0),(452758,12577,'zh','',0),(452759,12577,'sv','',0),(452760,12577,'it','',0),(452761,12577,'tl','',0),(452762,12577,'th','',0),(452763,12577,'hi','',0),(452764,12577,'ms','',0),(452765,12577,'ar','',0),(452766,12577,'fr','',0),(452767,12577,'jp','',0),(452768,12577,'pt','',0),(452769,12577,'ru','',0),(452770,12577,'es','',0),(452771,12577,'de','',0),(452772,12577,'en','',0),(452773,12578,'is','',0),(452774,12578,'dr','Ø¨Ø±Ø§ÛŒ Ù¾ÛŒØ¯Ø§ Ú©Ø±Ø¯Ù† ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ§Ø±Ø¯ Ø¯Ø± Ø¯Ø³Øª Ø¯Ø± Ù‡Ø± Ù…Ú©Ø§Ù† Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯:<p><b>Ù…ÙˆØ¬ÙˆØ¯ÛŒ-> Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙÛŒØ²ÛŒÚ©ÛŒ</b><p>Ø§Ú¯Ø± Ø´Ù…Ø§ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ Ú©Ø¯ Ú©Ø§Ù„Ø§ Ùˆ Ø¬Ø³ØªØ¬ÙˆÛŒ Ø¢Ù† Ø¯Ø± Ø¯Ø³Øª Ø§Ù†Ø¬Ø§Ù… Ø¨Ø±',0),(452775,12578,'pr','Ø¨Ø±Ø§ÛŒ Ù¾ÛŒØ¯Ø§ Ú©Ø±Ø¯Ù† ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ§Ø±Ø¯ Ø¯Ø± Ø¯Ø³Øª Ø¯Ø± Ù‡Ø± Ù…Ú©Ø§Ù† Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯:<p><b>Ù…ÙˆØ¬ÙˆØ¯ÛŒ-> Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙÛŒØ²ÛŒÚ©ÛŒ</b><p>Ø§Ú¯Ø± Ø´Ù…Ø§ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ Ú©Ø¯ Ú©Ø§Ù„Ø§ Ùˆ Ø¬Ø³ØªØ¬ÙˆÛŒ Ø¢Ù† Ø¯Ø± Ø¯Ø³Øª Ø§Ù†Ø¬Ø§Ù… Ø¨Ø±',0),(452776,12578,'tr','Bulmak iÃ§in her yerde el Ã¶ÄŸelerin sayÄ±sÄ±nÄ± tÄ±klatÄ±n:<p><b>Stok fiziksel stok-></b><p>Madde kodu ile arama girin bu eldeki her konumu gÃ¶sterir.',0),(452777,12578,'pl','Aby znaleÅºÄ‡ numer pozycji strony w kaÅ¼dej lokalizacji kliknij, aby:<p><b>Spis-> inwentarza</b><p>JeÅ›li wpiszesz kod towaru i Szukaj pokaÅ¼e na rÄ™kÄ™ dla kaÅ¼dej lokalizacji.',0),(452778,12578,'bg','Ð—Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð½Ð° Ñ€ÑŠÐºÐ° Ð²ÑŠÐ² Ð²ÑÑÐºÐ¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð°:<p><b>Ð¡ÐºÐ»Ð°Ð´-> Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸ Ð·Ð°Ð¿Ð°ÑÐ¸</b><p>ÐÐºÐ¾ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑ',0),(452779,12578,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù…ÛŒÚº ÛØ± Ù…Ù‚Ø§Ù… Ù¾Ø± Ú©Ù„Ú© Ú©Ø± Ú©Û’ ÛØ§ØªÚ¾ Ù¾Ø± ØªÙ„Ø§Ø´ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’:<p><b>Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ-></b><p>Ø¢Ù¾ Ø´Û’ Ú©ÙˆÚˆ Ø§ÙˆØ± Ú©ÛŒ ØªÙ„Ø§Ø´ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ ÛÙˆ ØªÙˆ Ø§Ø³ Ù¾Ø± ÛØ§Øª',0),(452780,12578,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¾Ð½Ð°ÑˆÐ»Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° Ð½Ð° ÑÐ²Ð°ÐºÐ¾Ñ˜ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ ÐºÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð°:<p><b>Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¸ Ð¿Ð¾Ð¿Ð¸ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°</b><p>ÐÐºÐ¾ ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¸ Ð¿Ñ€ÐµÑ‚Ñ€Ð°',0),(452781,12578,'vi','Äá»ƒ tÃ¬m sá»‘ cÃ¡c máº·t hÃ ng á»Ÿ má»—i nÆ¡i, thÃ¬ nháº¥p vÃ o HÃ ng tá»“n kho-> hÃ ng tá»“n kho váº­t lÃ½. Náº¿u báº¡n nháº­p mÃ£ hÃ ng vÃ  tÃ¬m kiáº¿m thÃ¬ nÃ³ sáº½ thá»ƒ hiá»‡n ra cho tá»«ng nÆ¡i',0),(452782,12578,'af','Vind die aantal items op hand in elke ligging te klik:<p><b>Voorraad-> fisiese voorraad</b><p>As jy die item kode en soek dit sal wys die op-hand vir elke ligging intik.',0),(452783,12578,'ro','Pentru a afla numÄƒrul de articole pe mÃ¢na Ã®n fiecare locaÅ£ie click pentru:<p><b>Inventarul-> inventar fizic</b><p>DacÄƒ introduceÅ£i codul de articol ÅŸi de cÄƒutare vÄƒ va arÄƒta pe-o parte pentru fiecare locatie.',0),(452784,12578,'et','Leia iga asukoha kaubad arv klÃµpsake:<p><b>Varude inventuuri-></b><p>Kui sisestate kaubakoodi ja Otsi See nÃ¤itab vaba asuk.',0),(452785,12578,'si','Najti Å¡tevilo elementov na roko v vsako lokacijo kliknite na:<p><b>Zaloge-> popisa zaloge</b><p>ÄŒe vnesete Å¡ifro artikla in iskanja prikaÅ¾e na roko za vsako mesto.',0),(452786,12578,'ba','Untuk menemukan jumlah item di tangan di setiap lokasi klik untuk:<p><b>Persediaan-> persediaan fisik</b><p>Jika Anda memasukkan kode barang dan Cari itu akan menunjukkan di tangan untuk setiap lokasi.',0),(452787,12578,'nl','Het aantal exemplaren in voorraad op elke locatie Klik om te zoeken naar:<p><b>Voorraad-> inventarisatie</b><p>Als u de artikelcode en zoek het zal tonen de op-hand voor elke vestiging invoeren.',0),(452788,12578,'fi','LÃ¶ytÃ¤Ã¤ kÃ¤sillÃ¤ kussakin sijainnissa kappalemÃ¤Ã¤rÃ¤ napsauttamalla:<p><b>Varaston fyysisen varaston-></b><p>Jos syÃ¶tÃ¤t nimikkeen koodi ja Etsi se nÃ¤yttÃ¤Ã¤ kunkin sijainnin varasto.',0),(452789,12578,'no','For Ã¥ finne Klikk antall varer i hvert sted Ã¥:<p><b>Lageret-> vareopptelling</b><p>Hvis du angir varekoden og sÃ¸k vises beholdningen for hvert sted.',0),(452790,12578,'da','At finde antallet varer pÃ¥ hÃ¥nd i hver placering klik til:<p><b>Lager-> lageropgÃ¸relse</b><p>Hvis du indtaster den varekode og sÃ¸ge det vil vise pÃ¥ hÃ¥nden for hver lokation.',0),(452791,12578,'ko','ê° ìœ„ì¹˜ í´ë¦­ì— ë°˜ë©´ì— í•­ëª© ìˆ˜ë¥¼ ì°¾ìœ¼ë ¤ë©´:<p><b>ì‹¤ì œ ìž¬ê³ -> ìž¬ê³ </b><p>ê²€ìƒ‰ í•˜ ê³  í•­ëª© ì½”ë“œë¥¼ ìž…ë ¥ í•˜ë©´ ê° ìœ„ì¹˜ì— ì§ì ‘ í‘œì‹œ ë©ë‹ˆë‹¤.',0),(452792,12578,'he','×›×“×™ ×œ×ž×¦×•× ×ž×¡×¤×¨ ×¤×¨×™×˜×™× ×§×™×™×ž×™× ×›×œ ×ž×™×§×•× ×œ×—×¥ ×›×“×™:<p><b>×ž×œ××™-> ×ž×œ××™ ×¤×™×–×™</b><p>×× ×ª×–×™×Ÿ ××ª ×§×•×“ ×”×¤×¨×™×˜ ×•××ª ×—×™×¤×•×© ×–×” ×™×¨××” ×‘× ×ž×¦× ×¢×‘×•×¨ ×›×œ ×ž×™×§×•×.',0),(452793,12578,'el','ÎÎ± Î²ÏÎµÎ¯Ï„Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Ï‰Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î³Î¹Î± Ï„Î¿ Ï‡Î­ÏÎ¹ ÏƒÎµ ÎºÎ¬Î¸Îµ Î¸Î­ÏƒÎ· ÎºÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î±:<p><b>Î‘Ï€Î¿Î³ÏÎ±Ï†Î®-> Ï†Ï…ÏƒÎ¹ÎºÎ®Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚</b><p>Î‘Î½ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ ÎºÏ‰Î´Î¹ÎºÏŒ Ï„Î¿Ï… ÎµÎ',0),(452794,12578,'zh','è¦æ‰¾åˆ°æ¯ä¸€ä¸ªä½ç½®çŽ°æœ‰çš„é¡¹ç›®æ•°ï¼Œç‚¹å‡»åˆ°ï¼šåº“å­˜->å®žé™…åº“å­˜\r\nå¦‚æžœæ‚¨è¾“å…¥é¡¹ç›®ä»£ç å¹¶æŸ¥æ‰¾ï¼Œå®ƒä¼šæ˜¾ç¤ºæ¯ä¸€ä½ç½®çš„çŽ°æœ‰è´§ç‰©ã€‚\r\n',0),(452795,12578,'sv','Att hitta antalet artiklar pÃ¥ hand i varje lÃ¤ge pÃ¥ att:<p><b>Inventering-> inventering</b><p>Om du anger den Artikelkod och sÃ¶ka kommer det Visa lagerbehÃ¥llning fÃ¶r varje plats.',0),(452796,12578,'it','Per trovare il numero di elementi a disposizione in ogni posizione Clicca per:<p><b>Inventario-> inventario fisico</b><p>Se si immette il codice articolo e la ricerca mostrerÃ  gli a portata di mano per ogni posizione.',0),(452797,12578,'tl','',0),(452798,12578,'th','à¸«à¸² à¸ˆà¸³à¸™à¸§à¸™à¸‚à¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸„à¸‡à¹€à¸«à¸¥à¸·à¸­à¹ƒà¸™à¹à¸•à¹ˆà¸¥à¸°à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­:<p><b>à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡->à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸—à¸²à¸‡à¸à¸²à¸¢à¸ à¸²à¸ž</b><p>à¸–à',0),(452799,12578,'hi','à¤–à¥‹à¤œà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¤¾à¤¥ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤° à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚:<p><b>à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤‡à¤¨à¤µà¥‡',0),(452800,12578,'ms','Untuk mencari jumlah item di tangan di setiap lokasi klik untuk:<p><b>Inventori-> Inventori fizikal</b><p>Jika anda memasukkan kod item dan Cari ia akan menunjukkan yang bertugas bagi setiap lokasi.',0),(452801,12578,'ar','Ù„Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø¹Ø¯Ø¯ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø© ÙÙŠ Ù…ØªÙ†Ø§ÙˆÙ„ Ø§Ù„ÙŠØ¯ ÙÙŠ ÙƒÙ„ Ù…ÙƒØ§Ù† Ø¥Ù„Ù‰:<p><b>Ø§Ù„Ù…Ø®Ø²ÙˆÙ†-> Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„ÙØ¹Ù„ÙŠ</b><p>Ø¥Ø°Ø§ Ù‚Ù…Øª Ø¨Ø¥Ø¯Ø®Ø§Ù„ ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù ÙˆØ§Ù„Ø¨Ø­Ø« Ø³ÙˆÙ ØªØ¸Ù',0),(452802,12578,'fr','Pour trouver le nombre d\'Ã©lÃ©ments sur la main Ã  chaque emplacement, cliquez sur Ã  :<p><b>L\'inventaire,-> inventaire physique</b><p>Si vous entrez le code d\'article et de la recherche, il montrera le stock pour chaque emplacement.',0),(452803,12578,'jp','è¦‹ã¤ã‘ã‚‹ãŸã‚ã®æ‰‹ã§ãã‚Œãžã‚Œã®å ´æ‰€ã®é …ç›®ã®æ•°ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦ã„ã¾ã™ã€‚<p><b>åœ¨åº«ã®ç¾ç‰©åœ¨åº«-></b><p>é …ç›®ã‚³ãƒ¼ãƒ‰ã®æ¤œç´¢ã‚’å…¥åŠ›ã™ã‚‹å ´æ‰€ã”ã¨ã«æ‰‹ãŒè¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(452804,12578,'pt','Para encontrar o nÃºmero de itens na mÃ£o em cada localizaÃ§Ã£o clique para:<p><b>InventÃ¡rio-> inventÃ¡rio fÃ­sico</b><p>Se vocÃª digitar o cÃ³digo do artigo e a pesquisa mostrarÃ¡ Ã  mÃ£o para cada local.',0),(452805,12578,'ru','ÐÐ°Ð¹Ñ‚Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð½Ð° Ñ€ÑƒÐºÐµ Ð² ÐºÐ°Ð¶Ð´Ð¾Ð¼ Ð¼ÐµÑÑ‚Ðµ Ð½Ð°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹:<p><b>Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ-> Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¾Ð¹ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸</b><p>Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð²Ð²Ð¾Ð´Ð¸Ñ‚Ðµ ÐšÐ¾Ð´ Ñ‚Ð¾Ð²Ð',0),(452806,12578,'es','Para encontra un nÃºmero de items en reserva en cada colocaciÃ³n clik a:<p><b>Inventario ->Inventario FÃ­sico</b><p>Si entra el cÃ³digo del item y buscalo, mostrarÃ¡ la colocaciÃ³n de la reserva.',0),(452807,12578,'de','Klicken Sie die Anzahl der Elemente auf der Seite an den einzelnen Standorten an:<p><b>-> Inventur Inventar</b><p>Geben Sie den Code und Suche, zeigt es auf der Hand fÃ¼r jeden Standort.',0),(452808,12578,'en','To find the number of items on hand in each location click to:<p><b>Inventory -> Physical Inventory</b><p>If you enter the item code and search it will show the on-hand for each location.',0),(452809,12579,'is','',0),(452810,12579,'dr','Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù‡Ø²ÛŒÙ†Ù‡ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø§ Ø±ÙØªÙ† Ø¨Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡:<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ-> Ù…ÙˆØ±Ø¯ Ø´Ø±ÙˆØ¹ ØªÙˆØ§Ø²Ù†</b><p>Ø¯Ø± Ø§ÛŒÙ†Ø¬Ø§ Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ù…Ù‚Ø¯Ø§Ø± Ø§ÙˆÙ„ÛŒÙ‡ Ø¯Ø§Ø±ÛŒØ¯ Ùˆ Ù‡Ø²ÛŒÙ†Ù',0),(452811,12579,'pr','Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù‡Ø²ÛŒÙ†Ù‡ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø§ Ø±ÙØªÙ† Ø¨Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡:<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ-> Ù…ÙˆØ±Ø¯ Ø´Ø±ÙˆØ¹ ØªÙˆØ§Ø²Ù†</b><p>Ø¯Ø± Ø§ÛŒÙ†Ø¬Ø§ Ø´Ù…Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ù…Ù‚Ø¯Ø§Ø± Ø§ÙˆÙ„ÛŒÙ‡ Ø¯Ø§Ø±ÛŒØ¯ Ùˆ Ù‡Ø²ÛŒÙ†Ù',0),(452812,12579,'tr','Madde maliyeti giderek ayarlayabilirsiniz:<p><b>YÃ¶netici Kurulumu envanter madde bakiyelerini baÅŸlayan->-></b><p>Burada sen-si olmak ilk miktar ve maddenin maliyetini girebilirsiniz.',0),(452813,12579,'pl','Kosztu towaru mogÄ… byÄ‡ ustawione, przechodzÄ…c do:<p><b>Admin-> instalacji magazynowych-> element poczÄ…wszy od salda</b><p>Tutaj moÅ¼na wprowadziÄ‡ poczÄ…tkowej iloÅ›ci, jakie masz i koszt towaru.',0),(452814,12579,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¸ ÐºÐ°Ñ‚Ð¾ Ð¾Ñ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð°:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÑÐºÐ»Ð°Ð´-> ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð±Ð°Ð»Ð°Ð½ÑÐ¸</b><p>Ð¢ÑƒÐº Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð²ÑŠÐ²ÐµÐ´Ðµ',0),(452815,12579,'ur','Ø´Û’ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø·Ø±Ù Ø¬Ø§ØªÛ’ ÛÙˆØ¦Û’ Ù…Ø±ØªØ¨ ÛÙˆ Ø³Ú©ØªÛ’ ÛÛŒÚº:<p><b>Ø§ÛŒÚˆÙ…Ù† Ø´Û’ Ø¨ÛŒÙ„Ù†Ø³ Ú©Ø§ Ø¢ØºØ§Ø²-> Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ-></b><p>ÛŒÛØ§Úº Ø¢Ù¾ Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ø¢Ù¾ Ú©Û’ Ù¾Ø§Ø³ ÛÛ’ Ø§ÙˆØ± Ø´Û’ Ú©ÛŒ Ù‚ÛŒÙ…',0),(452816,12579,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¿Ð¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ñ‚Ð°ÐºÐ¾ Ð´Ð°:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¿Ð¾Ñ‡Ð¸ÑšÐµ ÑÐ°Ð»Ð´Ð°</b><p>ÐžÐ²Ð´Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¿Ð¾Ñ‡ÐµÑ‚Ð½Ñƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ ',0),(452817,12579,'vi','Chi phÃ­ máº·t hÃ ng cÃ³ thá»ƒ Ä‘Æ°á»£c thiáº¿t láº­p báº±ng cÃ¡ch: Quáº£n trá»‹->thiáº¿t láº­p hÃ ng tá»“n kho-> sá»‘ dÆ° Ä‘áº§u ká»³. á»ž Ä‘Ã¢y báº¡n cÃ³ thá»ƒ nháº­p sá»‘ lÆ°á»£ng Ä‘áº§u ká»³ mÃ  báº¡n cÃ³ vÃ  chi phÃ­ cá»§a máº·t hÃ ng',0),(452818,12579,'af','Die item koste kan opgestel word deur te gaan na:<p><b>Admin-> opstelling voorraad-> Item begin saldo\'s</b><p>Hier jy kan Tik die aanvanklike hoeveelheid wat jy het en die koste van die item.',0),(452819,12579,'ro','Cost articol pot fi setate de gÃ¢nd sÄƒ:<p><b>Admin-> Setup inventar-> element Ã®ncepÃ¢nd cu soldurile</b><p>Aici aveÅ£i posibilitatea sÄƒ introduceÅ£i cantitatea iniÅ£ialÄƒ aveÅ£i ÅŸi costul elementului.',0),(452820,12579,'et','Kauba kulu saab seada minnes:<p><b>Admin-> Setup lao-> Ã¼ksuse algus saldod</b><p>Siia saate sisestada on algkogusest ning kauba omahind.',0),(452821,12579,'si','StroÅ¡ek artikla lahko nastavite z tekoÄ:<p><b>Admin-> nastavitev zaloge-> element zaÄne bilance</b><p>Tukaj lahko vnesete zaÄetno koliÄino imate in stroÅ¡ek artikla.',0),(452822,12579,'ba','Item biaya dapat diatur dengan pergi ke:<p><b>Admin-> Setup persediaan-> Item mulai saldo</b><p>Di sini Anda dapat memasukkan Anda memiliki kuantitas awal dan biaya item.',0),(452823,12579,'nl','De kostprijs kan worden ingesteld door te gaan naar:<p><b>Admin-> Setup voorraad-> Item begin saldi</b><p>Hier kunt u de oorspronkelijke hoeveelheid hebt en de kosten van het item.',0),(452824,12579,'fi','Nimikkeen kuluihin voidaan asettaa luona astuva jotta:<p><b>Admin-> asetukset varaston-> tuotteen alkusaldot</b><p>TÃ¤hÃ¤n kenttÃ¤Ã¤n voidaan syÃ¶ttÃ¤Ã¤ alkuperÃ¤inen mÃ¤Ã¤rÃ¤ sinulla ja nimikkeen kustannusta.',0),(452825,12579,'no','Varekost kan angis ved Ã¥ gÃ¥ til:<p><b>Admin-> installasjonsprogrammet lager-> elementet begynner saldoer</b><p>Her kan du angi det fÃ¸rste antallet du har og kostnadene for varen.',0),(452826,12579,'da','Vareomkostningen kan indstilles ved at gÃ¥ til:<p><b>Admin-> Setup lager-> vare begyndt saldi</b><p>Her kan du angive den oprindelige mÃ¦ngde du har og varens pris.',0),(452827,12579,'ko','í•­ëª© ë¹„ìš© ì´ë™ í•˜ ì—¬ ì„¤ì •í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p><b>ê´€ë¦¬ìž ì„¤ì¹˜ ìž¬ê³  í•­ëª© ì‹œìž‘ ìž”ì•¡->-></b><p>ì—¬ê¸° ë‹¹ì‹ ì´ ì´ˆê¸° ìˆ˜ëŸ‰ ë° í•­ëª©ì˜ ë¹„ìš©ì„ ìž…ë ¥í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(452828,12579,'he','× ×™×ª×Ÿ ×œ×”×’×“×™×¨ ××ª ×¢×œ×•×ª ×¤×¨×™×˜ ×¢×œ ×™×“×™ ×”×•×œ×š:<p><b>Admin-> ×”×’×“×¨×ª ×ž×œ××™-> ×¤×¨×™×˜ ×ž×ª×—×™×œ ×™×ª×¨×•×ª</b><p>×›××Ÿ ×‘××¤×©×¨×•×ª×š ×œ×”×–×™×Ÿ ××ª ×”×›×ž×•×ª ×”×¨××©×•× ×™×ª ×©×™×© ×œ×š ×•××ª ×”×¢×œ×•×ª ×©×œ ×”×¤×¨×™×˜.',0),(452829,12579,'el','Î¤Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ Ï„Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÏÏ…Î¸Î¼Î¹ÏƒÏ„ÎµÎ¯ Î¼Îµ Ï„Î· Î¼ÎµÏ„Î¬Î²Î±ÏƒÎ·:<p><b>Admin-> Ï€Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚-> ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±ÏÏ‡Î¯Î¶ÎµÎ¹ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯ÎµÏ‚</b><p>Î•Î´ÏŽ Î¼Ï€Î¿ÏÎµÎ¯Ï',0),(452830,12579,'zh','é¡¹ç›®æˆæœ¬å¯ä»¥è¢«è®¾ç½®ï¼Œåˆ°ï¼šç®¡ç†->åº“å­˜ç®¡ç†->é¡¹ç›®æœŸåˆç»“ä½™\r\nè¿™é‡Œæ‚¨å¯ä»¥è¾“å…¥æ‚¨æœ‰çš„æœ€åˆæ•°é‡ä»¥åŠé¡¹ç›®çš„æˆæœ¬ã€‚\r\n',0),(452831,12579,'sv','Artikelkostnaden kan anges genom att gÃ¥ till:<p><b>Admin-> Setup inventering-> objekt bÃ¶rjar saldon</b><p>HÃ¤r kan du ange den ursprungliga kvantitet som du har och kostnaden fÃ¶r artikeln.',0),(452832,12579,'it','Il costo dell\'elemento puÃ² essere impostato andando su:<p><b>Admin-> Inventory Setup-> voce inizio saldi</b><p>Qui Ã¨ possibile immettere la quantitÃ  iniziale che hai e il costo dell\'articolo.',0),(452833,12579,'tl','',0),(452834,12579,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸´à¸™à¸„à¹‰à¸² à¹‚à¸”à¸¢à¹„à¸›à¸—à¸µà¹ˆ:<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡->à¸ªà¸´à¸™à¸„à¹‰à¸²à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸•à¹‰à¸™à¸‡à¸§à¸”</b><p>à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¸„',0),(452835,12579,'hi','à¤†à¤‡à¤Ÿà¤® à¤²à¤¾à¤—à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾ à¤°à¤¹à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤®à¥‡à¤‚ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤¶à¥à¤°à¥à¤†à¤¤->-',0),(452836,12579,'ms','Kos barang boleh ditetapkan dengan pergi ke:<p><b>Admin-> persediaan inventori-> Item bermula baki</b><p>Di sini anda boleh masukkan kuantiti awal anda dan kos butiran tersebut.',0),(452837,12579,'ar','ÙŠÙ…ÙƒÙ† ØªØ¹ÙŠÙŠÙ† ØªÙƒÙ„ÙØ© Ø§Ù„ØµÙ†Ù Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ø§Ù„Ø°Ù‡Ø§Ø¨ Ø¥Ù„Ù‰:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-> Ø§Ù„Ø¨Ù†Ø¯ Ø§Ø¨ØªØ¯Ø§Ø¡ Ù…Ù† Ø£Ø±ØµØ¯Ø©</b><p>Ù‡Ù†Ø§ ÙŠÙ…ÙƒÙ†Ùƒ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø£ÙˆÙ„ÙŠØ© Ø§Ù„ØªÙŠ Ù„Ø¯ÙŠÙƒ ÙˆØªÙ',0),(452838,12579,'fr','Le coÃ»t peut Ãªtre dÃ©fini en allant sur :<p><b>Admin-> Setup inventaire-> point dÃ©but soldes</b><p>Ici, vous pouvez saisir la quantitÃ© initiale que vous avez et le coÃ»t de l\'article.',0),(452839,12579,'jp','å“ç›®åŽŸä¾¡ã«è¡Œãã“ã¨ã«ã‚ˆã£ã¦è¨­å®šã§ãã¾ã™ã€‚<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªé …ç›®é–‹å§‹æ®‹é«˜->-></b><p>ã“ã“ã§ã‚ãªãŸãŒæŒã£ã¦ã„ã‚‹åˆæœŸæ•°é‡ã¨å“ç›®ã®ã‚³ã‚¹ãƒˆã‚’å…¥åŠ›ã§ãã¾ã™ã€‚',0),(452840,12579,'pt','O custo de item pode ser definido indo a:<p><b>Admin-> Setup inventÃ¡rio-> Item comeÃ§ando saldos</b><p>Aqui pode introduzir a quantidade inicial que vocÃª tem e o custo do item.',0),(452841,12579,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð¼Ð¾Ð¶ÐµÑ‚ ÑƒÑÑ‚Ð°Ð½Ð°Ð²Ð»Ð¸Ð²Ð°Ñ‚ÑŒÑÑ Ð¿ÑƒÑ‚ÐµÐ¼ Ð¸Ð´Ñ‚Ð¸ Ðº:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ-> Ð¿ÑƒÐ½ÐºÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¾ÑÑ‚Ð°Ñ‚ÐºÐ¾Ð²</b><p>Ð—Ð´ÐµÑÑŒ Ð²Ñ‹ Ð¼Ð¾Ð¶ÐµÑ‚',0),(452842,12579,'es','El costo del item se puede configurar por ir a:<p><b>Admin - Configurar Inventario -> Item Saldos de Inicio</b><p>',0),(452843,12579,'de','Die Artikelkosten kann festgelegt werden, indem Sie auf:<p><b>Admin-> Lager Einrichtung-> Element Anfang Salden</b><p>Hier kÃ¶nnen Sie eingeben, die Anfangsmenge, die Sie haben und die Kosten fÃ¼r das Element.',0),(452844,12579,'en','The item cost can be set by going to:<p><b>Admin -> Setup Inventory -> Item Beginning Balances</b><p> Here you can enter the initial quantity you have and the cost of the item.',0),(452845,12580,'is','',0),(452846,12580,'dr','',0),(452847,12580,'pr','',0),(452848,12580,'tr','',0),(452849,12580,'pl','',0),(452850,12580,'bg','',0),(452851,12580,'ur','',0),(452852,12580,'sr','',0),(452853,12580,'vi','',0),(452854,12580,'af','',0),(452855,12580,'ro','',0),(452856,12580,'et','',0),(452857,12580,'si','',0),(452858,12580,'ba','',0),(452859,12580,'nl','',0),(452860,12580,'fi','',0),(452861,12580,'no','',0),(452862,12580,'da','',0),(452863,12580,'ko','',0),(452864,12580,'he','',0),(452865,12580,'el','',0),(452866,12580,'zh','',0),(452867,12580,'sv','',0),(452868,12580,'it','',0),(452869,12580,'tl','',0),(452870,12580,'th','',0),(452871,12580,'hi','',0),(452872,12580,'ms','',0),(452873,12580,'ar','',0),(452874,12580,'fr','',0),(452875,12580,'jp','',0),(452876,12580,'pt','',0),(452877,12580,'ru','',0),(452878,12580,'es','',0),(452879,12580,'de','',0),(452880,12580,'en','',0),(452881,12581,'is','',0),(452882,12581,'dr','Ù„ÛŒØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ ØºÛŒØ± Ù…ÙˆØ±Ø¯ Ø¨Ø¯ÙˆÙ† ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯. Ø§Ú¯Ø± Ø´Ù…Ø§ Ù†Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø¨Ù‡ Ø¯Ø³ØªÛŒ Ù…ÙˆØ±Ø¯ Ù‡Ø± Ø¨Ø§Ø± ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ Ùˆ ÛŒØ§ Ù…Ø§ÛŒÙ„ Ø¨Ù‡ Ù¾ÛŒÚ¯ÛŒØ±ÛŒ Ú†Ù‡ Ø¨Ù‡ Ø´Ù…Ø§ ÙØ±ÙˆØ®ØªÙ‡ Ø§Ù†Ø¯ØŒ Ø§Ù‚Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø§',0),(452883,12581,'pr','Ù„ÛŒØ³Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ ØºÛŒØ± Ù…ÙˆØ±Ø¯ Ø¨Ø¯ÙˆÙ† ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯. Ø§Ú¯Ø± Ø´Ù…Ø§ Ù†Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø¨Ù‡ Ø¯Ø³ØªÛŒ Ù…ÙˆØ±Ø¯ Ù‡Ø± Ø¨Ø§Ø± ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ Ùˆ ÛŒØ§ Ù…Ø§ÛŒÙ„ Ø¨Ù‡ Ù¾ÛŒÚ¯ÛŒØ±ÛŒ Ú†Ù‡ Ø¨Ù‡ Ø´Ù…Ø§ ÙØ±ÙˆØ®ØªÙ‡ Ø§Ù†Ø¯ØŒ Ø§Ù‚Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø§',0),(452884,12581,'tr','Orada sigara stok Ã¶ÄŸesi liste yok. El ile bir Ã¶ÄŸeyi girin her zaman veya ne sattÄ±nÄ±z izlemek istediÄŸiniz istiyorsanÄ±z, stok maddelerinin bir rasgele sayÄ± elde olmayan oluÅŸturulabilir. ',0),(452885,12581,'pl','Istnieje nie towar-list. JeÅ›li nie chcesz rÄ™cznie wprowadziÄ‡ element kaÅ¼dego czas albo Å¼yczyÄ‡ wobec utrzymywaÄ‡ Å›lad od co sprzedaÅ‚eÅ›, zapasÃ³w mogÄ… byÄ‡ tworzone z dowolnego numeru na dÅ‚oni. ',0),(452886,12581,'bg','ÐÑÐ¼Ð° ÑÐ¿Ð¸ÑÑŠÑ†Ð¸-ÑÐºÐ»Ð°Ð´Ð¾Ð² Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ». ÐÐºÐ¾ Ð½Ðµ Ð¸ÑÐºÐ°Ñ‚Ðµ Ñ€ÑŠÑ‡Ð½Ð¾ Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð²ÑÐµÐºÐ¸ Ð¿ÑŠÑ‚ Ð¸Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° ÑÐ»ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ°ÐºÐ²Ð¾ ÑÑ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð»Ð¸, ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð',0),(452887,12581,'ur','Ú©ÙˆØ¦ÛŒ ØºÛŒØ± Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ ÙÛØ±Ø³ØªÛŒÚº ÛÛŒÚº Û” Ø§Ú¯Ø± Ø¢Ù¾ Ú©Ùˆ Ø¯Ø³ØªÛŒ Ø·ÙˆØ± Ù¾Ø± ÛØ± ÙˆÙ‚Øª Ø§ÛŒÚ© Ø´Û’ Ø¯Ø§Ø®Ù„ ÛŒØ§ Ú©ÛŒ Ø³Ø±Ø§Øº Ø±Ø§Û Ø±Ú©Ú¾ÛŒÚº Ø¬Ùˆ Ø¢Ù¾ Ø¨ÛŒÚ†ÛŒ ÛÛŒÚº Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº Ú©Û’ Ù„Ø¦Û’ Ù†ÛÛŒÚº Ú©Ø±Ù†Ø§ Ú',0),(452888,12581,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð»Ð¸ÑÑ‚Ð° Ð½ÐµÐ¼Ð° Ð±ÐµÐ· Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°. ÐÐºÐ¾ Ð½Ðµ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ñ€ÑƒÑ‡Ð½Ð¾ ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑÑ‚Ð°Ð²ÐºÐµ ÑÐ²Ð°ÐºÐ¸ Ð¿ÑƒÑ‚ ÐºÐ°Ð´Ð° Ð¸Ð»Ð¸ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¿Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑˆÑ‚Ð° ÑÑ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð»Ð¸, Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð',0),(452889,12581,'vi','KhÃ´ng cÃ³ danh sÃ¡ch hÃ ng tá»“n kho. Náº¿u báº¡n khÃ´ng muá»‘n nháº­p tay cho má»—i máº·t hÃ ng hoáº·c muá»‘n theo dÃµi nhá»¯ng cÃ¡i Ä‘Ã£ bÃ¡n, danh má»¥c hÃ ng tá»“n kho cÃ³ thá»ƒ Ä‘Æ°á»£c táº¡o ra vá»›i sá»‘ tÃ¹y Ã½',0),(452890,12581,'af','Daar is geen item nie-voorraad lyste nie. As jy nie wil handmatig voer \'n item elke keer of wil hou van wat jy verkoop het, voorraad items geskep kan word met \'n arbitrÃªre nommer op-hand. ',0),(452891,12581,'ro','Nu existÄƒ nicio listÄƒ de non-inventar element. DacÄƒ nu doriÅ£i sÄƒ introduceÅ£i un articol de fiecare datÄƒ sau doresc pentru a urmÄƒri ceea ce au vÃ¢ndut manual, obiecte de inventar pot fi create cu un arbitrare numÄƒr pe-o parte. ',0),(452892,12581,'et','On-laokauba loendeid pole. Kui soovite kÃ¤sitsi sisestada kauba iga kord vÃµi soovivad omada Ã¼levaadet ei mÃ¼Ã¼nud, saab mÃµne suvalise arvu vaba laokaupade luua. ',0),(452893,12581,'si','Seznami ne artikla zaloge obstajajo. ÄŒe ne Å¾elite roÄno vnesite element vsakokrat ali Å¾elijo, da bi spremljali kaj si prodal, elemente zaloge lahko ustvarite s za poljubno Å¡tevilo na roke. ',0),(452894,12581,'ba','Ada tidak ada non-persediaan item daftar. Jika Anda tidak ingin secara manual memasukkan item setiap kali atau berharap untuk melacak apa yang Anda telah menjual, persediaan barang dapat dibuat dengan sewenang-wenang nomor di tangan. ',0),(452895,12581,'nl','Er zijn geen lijsten niet-voorraadartikel. Als u niet wilt handmatig elke keer een item opgeven of wenst te houden van wat u hebt verkocht, kunnen voorraadartikelen worden gemaakt met een willekeurig aantal op-hand. ',0),(452896,12581,'fi','Luetteloita ei ole Varastotuote. Jos et halua manuaalisesti syÃ¶ttÃ¤Ã¤ kohteen tai haluavat seuratakseen on myyty, varastonimikkeiden voidaan luoda mielivaltainen kÃ¤ytettÃ¤vissÃ¤. ',0),(452897,12581,'no','Det er ingen ikke-lagervare lister. Hvis du ikke vil angi et element hver gang eller Ã¸nsker Ã¥ holde styr pÃ¥ hva du har solgt manuelt, kan lagervarer opprettes med en vilkÃ¥rlig pÃ¥ lager. ',0),(452898,12581,'da','Der er ingen ikke-lagervare lister. Hvis du ikke Ã¸nsker at manuelt indtaste et element hver gang eller Ã¸nsker at holde styr pÃ¥ hvad du har solgt, kan lagervarer laves med et vilkÃ¥rligt antal pÃ¥-hÃ¥nd. ',0),(452899,12581,'ko','ì•„ë‹ˆ ë¹„ ìž¬ê³  í•­ëª© ëª©ë¡ì´ ìžˆìŠµë‹ˆë‹¤. ë§Œì•½ ë‹¹ì‹ ì´ ìˆ˜ë™ìœ¼ë¡œ ê° ì‹œê°„ í•­ëª©ì„ ìž…ë ¥ í•˜ê±°ë‚˜ ì›í•˜ëŠ” ë‹¹ì‹ ì€ íŒë§¤ë¥¼ ì¶”ì  í•˜ ê³  ì‹¶ì§€ ì•Šì•„, ìž¬ê³  ëª©ë¡ í’ˆëª© ìž„ì˜ì˜ ë²ˆí˜¸ì—-ì†ìœ¼ë¡œ ë§Œë“¤ ìˆ˜ ìžˆìŠµë‹ˆë‹¤. ',0),(452900,12581,'he','×™×©× × ××™×Ÿ ×¨×©×™×ž×•×ª ×¤×¨×™×˜ ×©××™× ×• ×”×ž×œ××™. ×× ××ª×” ×œ× ×¨×•×¦×” ×œ×”×–×™×Ÿ ×‘×›×œ ×¤×¢× ×¤×¨×™×˜ ××• ×—×‘×œ ×œ×¢×§×•×‘ ××—×¨ ×ž×” ×ž×›×¨×ª ×‘××•×¤×Ÿ ×™×“× ×™, × ×™×ª×Ÿ ×œ×™×¦×•×¨ ×¤×¨×™×˜×™ ×ž×œ××™ ×¢× ×©×¨×™×¨×•×ª×™ ×ž×¡×¤×¨ ',0),(452901,12581,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÎºÎ±Î¼Î¯Î± Î»Î¯ÏƒÏ„ÎµÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¼Î·-Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚. Î•Î¬Î½ Î´ÎµÎ½ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÎ¬Î¸Îµ Ï†Î¿ÏÎ¬ Î¼Îµ Î¼Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î¿ Ï„ÏÏŒÏ€Î¿ Î® Î½Î± Î¸Î­Î»Î¿Ï…Î½ Î½Î± Ï€Î±ÏÎ±ÎºÎ¿Î»Î',0),(452902,12581,'zh','æ²¡æœ‰æ— åº“å­˜é¡¹åˆ—è¡¨ã€‚å¦‚æžœæ‚¨ä¸æƒ³æ¯ä¸€æ¬¡æ‰‹åŠ¨è¾“å…¥ä¸€ä¸ªé¡¹ç›®æˆ–å¸Œæœ›ç»§ç»­è·Ÿè¸ªæ‚¨æ‰€é”€å”®çš„è´§ç‰©ï¼Œåˆ›å»ºæœ‰çŽ°æœ‰ä»»æ„æ•°é‡çš„åº“å­˜é¡¹ç›®ã€‚',0),(452903,12581,'sv','Det finns inga icke-inventering objektlistor. Om du inte vill manuellt ange ett objekt varje gÃ¥ng eller vill hÃ¥lla koll pÃ¥ vad du har sÃ¥lt, kan lagerartiklar skapas med ett godtyckligt nummer till hands. ',0),(452904,12581,'it','Non ci sono gli elenchi non a magazzino. Se non volete inserire un elemento ogni volta o desidera tenere traccia di quello che hanno venduto manualmente, articoli di magazzino possono essere creati con un arbitrario numero a portata di mano. ',0),(452905,12581,'tl','',0),(452906,12581,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¹„à¸¡à¹ˆà¹„à¸”à¹‰ à¸–à¹‰à¸²à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸›à¹‰à¸­à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¹à¸•à¹ˆà¸¥à¸°à¸„à¸£à¸±à¹‰à¸‡ à¸«à¸£à¸·à¸­à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸•à¸´à¸”à¸•à¸²à¸¡à¸ªà¸´à',0),(452907,12581,'hi','à¤µà¤¹à¤¾à¤ à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤•à¥‹à¤ˆ à¤—à¥ˆà¤°-à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¸à¥‚à¤šà¤¿à¤¯à¥‹à¤‚à¥¤ à¤¯à¤¦à¤¿ à¤†à¤ª à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤°à¥‚à¤ª à¤¸à¥‡ à¤¹à¤° à¤¬à¤¾à¤° à¤à¤• à¤†à¤‡à¤Ÿà¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤•à¥à¤¯à¤¾ à¤†à¤ª à¤',0),(452908,12581,'ms','Terdapat senarai inventori tidak. Jika anda tidak mahu secara manual masukkan item setiap kali atau meminta anda untuk menjejaki apa yang anda telah dijual, item inventori boleh diwujudkan dengan yang sewenang-wenangnya nombor atas tangan. ',0),(452909,12581,'ar','ÙˆÙ‡Ù†Ø§Ùƒ Ù„Ø§ Ù‚ÙˆØ§Ø¦Ù… Ø¹Ù†ØµØ± ØºÙŠØ± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†. Ø¥Ø°Ø§ ÙƒÙ†Øª Ù„Ø§ ØªØ±ÙŠØ¯ Ø£Ù† ÙŠØ¯ÙˆÙŠØ§Ù‹ Ø¥Ø¯Ø®Ø§Ù„ Ø¹Ù†ØµØ± ÙƒÙ„ Ø§Ù„ÙˆÙ‚Øª Ø£Ùˆ Ø£ØªÙ…Ù†Ù‰ Ù„ØªØªØ¨Ø¹ Ù…Ø§ ÙƒÙ†Øª Ù‚Ø¯ Ø¨ÙŠØ¹ØªØŒ ÙŠÙ…ÙƒÙ† Ø¥Ù†Ø´Ø§Ø¡ Ø¨Ù†ÙˆØ¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù…Ø¹ ØªØ¹Ø³ÙÙŠ',0),(452910,12581,'fr','Il n\'y a aucune listes hors stocks. Si vous ne voulez pas entrer Ã  chaque fois un Ã©lÃ©ment ou souhaitez garder une trace de ce que vous avez vendu manuellement, les articles en stock peuvent Ãªtre crÃ©Ã©s avec une arbitraire numÃ©ro Ã  portÃ©e de main. ',0),(452911,12581,'jp','éžåœ¨åº«ã‚¢ã‚¤ãƒ†ãƒ ã®ãƒªã‚¹ãƒˆã¯ã‚ã‚Šã¾ã›ã‚“ã€‚æ‰‹å‹•ã§é …ç›®ã‚’å…¥åŠ›ã™ã‚‹ãŸã³ã«ã€ã¾ãŸã¯ã‚ãªãŸãŒè²©å£²ã—ã¦ã„ã‚‹ã‚’è¿½è·¡ã—ãŸã„å ´åˆã§ã€ä»»æ„æ•°ã®æ‰‹æŒåœ¨åº«å“ç›®ã‚’ä½œæˆã§ãã¾ã™ã€‚',0),(452912,12581,'pt','NÃ£o hÃ¡ nenhum listas de itens nÃ£o-inventÃ¡rio. Se vocÃª nÃ£o quiser manualmente inserir um item de cada vez ou desejo de acompanhar o que vocÃª vendeu, itens de inventÃ¡rio podem ser criados com uma arbitrÃ¡ria nÃºmero na mÃ£o. ',0),(452913,12581,'ru','ÐÐµÑ‚ ÑÐ¿Ð¸ÑÐºÐ¾Ð² Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð¼. Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð½Ðµ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ ÐºÐ°Ð¶Ð´Ñ‹Ð¹ Ñ€Ð°Ð· Ð²Ð²Ð¾Ð´Ð¸Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ñ‚ÑŒ, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ð¿Ñ€Ð¾Ð´Ð°Ð»Ð¸, Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¼',0),(452914,12581,'es','No hay listas de items de no inventario. Si no quiere entrar un item manualmentes cada vez o desea seguir la pista de lo que ha vendido, items de inventario pueden estar creados con un nÃºmero arbitrario de las cosas en reserva.',0),(452915,12581,'de','Es gibt keine nicht-Lagerartikel-Listen. Wenn Sie nicht mÃ¶chten, manuell jedes Mal eingeben, ein Element oder wÃ¼nschen zu behalten was Sie verkauft haben, kÃ¶nnen Lagerartikel mit einer beliebigen Anzahl auf-Hand erstellt werden. ',0),(452916,12581,'en','There are no non-inventory item lists. If you don\'t want to manually enter an item each time or wish to keep track of what you have sold, inventory items can be created with an arbitrary number on-hand. ',0),(452917,12582,'is','',0),(452918,12582,'dr','',0),(452919,12582,'pr','',0),(452920,12582,'tr','',0),(452921,12582,'pl','',0),(452922,12582,'bg','',0),(452923,12582,'ur','',0),(452924,12582,'sr','',0),(452925,12582,'vi','',0),(452926,12582,'af','',0),(452927,12582,'ro','',0),(452928,12582,'et','',0),(452929,12582,'si','',0),(452930,12582,'ba','',0),(452931,12582,'nl','',0),(452932,12582,'fi','',0),(452933,12582,'no','',0),(452934,12582,'da','',0),(452935,12582,'ko','',0),(452936,12582,'he','',0),(452937,12582,'el','',0),(452938,12582,'zh','',0),(452939,12582,'sv','',0),(452940,12582,'it','',0),(452941,12582,'tl','',0),(452942,12582,'th','',0),(452943,12582,'hi','',0),(452944,12582,'ms','',0),(452945,12582,'ar','',0),(452946,12582,'fr','',0),(452947,12582,'jp','',0),(452948,12582,'pt','',0),(452949,12582,'ru','',0),(452950,12582,'es','',0),(452951,12582,'de','',0),(452952,12582,'en','',0),(452953,12583,'is','',0),(452954,12583,'dr','',0),(452955,12583,'pr','',0),(452956,12583,'tr','',0),(452957,12583,'pl','',0),(452958,12583,'bg','',0),(452959,12583,'ur','',0),(452960,12583,'sr','',0),(452961,12583,'vi','',0),(452962,12583,'af','',0),(452963,12583,'ro','',0),(452964,12583,'et','',0),(452965,12583,'si','',0),(452966,12583,'ba','',0),(452967,12583,'nl','',0),(452968,12583,'fi','',0),(452969,12583,'no','',0),(452970,12583,'da','',0),(452971,12583,'ko','',0),(452972,12583,'he','',0),(452973,12583,'el','',0),(452974,12583,'zh','',0),(452975,12583,'sv','',0),(452976,12583,'it','',0),(452977,12583,'tl','',0),(452978,12583,'th','',0),(452979,12583,'hi','',0),(452980,12583,'ms','',0),(452981,12583,'ar','',0),(452982,12583,'fr','',0),(452983,12583,'jp','',0),(452984,12583,'pt','',0),(452985,12583,'ru','',0),(452986,12583,'es','',0),(452987,12583,'de','',0),(452988,12583,'en','',0),(452989,12584,'is','',0),(452990,12584,'dr','',0),(452991,12584,'pr','',0),(452992,12584,'tr','',0),(452993,12584,'pl','',0),(452994,12584,'bg','',0),(452995,12584,'ur','',0),(452996,12584,'sr','',0),(452997,12584,'vi','',0),(452998,12584,'af','',0),(452999,12584,'ro','',0),(453000,12584,'et','',0),(453001,12584,'si','',0),(453002,12584,'ba','',0),(453003,12584,'nl','',0),(453004,12584,'fi','',0),(453005,12584,'no','',0),(453006,12584,'da','',0),(453007,12584,'ko','',0),(453008,12584,'he','',0),(453009,12584,'el','',0),(453010,12584,'zh','',0),(453011,12584,'sv','',0),(453012,12584,'it','',0),(453013,12584,'tl','',0),(453014,12584,'th','',0),(453015,12584,'hi','',0),(453016,12584,'ms','',0),(453017,12584,'ar','',0),(453018,12584,'fr','',0),(453019,12584,'jp','',0),(453020,12584,'pt','',0),(453021,12584,'ru','',0),(453022,12584,'es','',0),(453023,12584,'de','',0),(453024,12584,'en','',0),(453025,12585,'is','',0),(453026,12585,'dr','',0),(453027,12585,'pr','',0),(453028,12585,'tr','',0),(453029,12585,'pl','',0),(453030,12585,'bg','',0),(453031,12585,'ur','',0),(453032,12585,'sr','',0),(453033,12585,'vi','',0),(453034,12585,'af','',0),(453035,12585,'ro','',0),(453036,12585,'et','',0),(453037,12585,'si','',0),(453038,12585,'ba','',0),(453039,12585,'nl','',0),(453040,12585,'fi','',0),(453041,12585,'no','',0),(453042,12585,'da','',0),(453043,12585,'ko','',0),(453044,12585,'he','',0),(453045,12585,'el','',0),(453046,12585,'zh','',0),(453047,12585,'sv','',0),(453048,12585,'it','',0),(453049,12585,'tl','',0),(453050,12585,'th','',0),(453051,12585,'hi','',0),(453052,12585,'ms','',0),(453053,12585,'ar','',0),(453054,12585,'fr','',0),(453055,12585,'jp','',0),(453056,12585,'pt','',0),(453057,12585,'ru','',0),(453058,12585,'es','',0),(453059,12585,'de','',0),(453060,12585,'en','',0),(453061,12586,'is','',0),(453062,12586,'dr','',0),(453063,12586,'pr','',0),(453064,12586,'tr','',0),(453065,12586,'pl','',0),(453066,12586,'bg','',0),(453067,12586,'ur','',0),(453068,12586,'sr','',0),(453069,12586,'vi','',0),(453070,12586,'af','',0),(453071,12586,'ro','',0),(453072,12586,'et','',0),(453073,12586,'si','',0),(453074,12586,'ba','',0),(453075,12586,'nl','',0),(453076,12586,'fi','',0),(453077,12586,'no','',0),(453078,12586,'da','',0),(453079,12586,'ko','',0),(453080,12586,'he','',0),(453081,12586,'el','',0),(453082,12586,'zh','',0),(453083,12586,'sv','',0),(453084,12586,'it','',0),(453085,12586,'tl','',0),(453086,12586,'th','',0),(453087,12586,'hi','',0),(453088,12586,'ms','',0),(453089,12586,'ar','',0),(453090,12586,'fr','',0),(453091,12586,'jp','',0),(453092,12586,'pt','',0),(453093,12586,'ru','',0),(453094,12586,'es','',0),(453095,12586,'de','',0),(453096,12586,'en','',0),(453097,12587,'is','',0),(453098,12587,'dr','Ø¨Ù‡ \"Ø§ÛŒØ§Ù„Ø§Øª\" Ø§Ø² Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÛŒØ´ ÙØ±Ø¶ Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ù‡ÛŒØ¯:<p><b>-> Ù…Ø¯ÛŒØ±-> Ù…Ø¯ÛŒØ± Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø¯ÙˆÙ„Øª Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´</b>',0),(453099,12587,'pr','Ø¨Ù‡ \"Ø§ÛŒØ§Ù„Ø§Øª\" Ø§Ø² Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÛŒØ´ ÙØ±Ø¶ Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ù‡ÛŒØ¯:<p><b>-> Ù…Ø¯ÛŒØ±-> Ù…Ø¯ÛŒØ± Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø¯ÙˆÙ„Øª Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´</b>',0),(453100,12587,'tr','\"BirleÅŸik\" ABD varsayÄ±lan ayarlarÄ± deÄŸiÅŸtirmek iÃ§in:<p><b>Admin Admin kurulumu->-> devlet yeni/DÃ¼zenle</b>',0),(453101,12587,'pl','Aby zmodyfikowaÄ‡ \"PaÅ„stwa\" z USA ustawienia domyÅ›lne:<p><b>Admin-> konfiguracji Admin-> stan Nowy Edytuj</b>',0),(453102,12587,'bg','Ð—Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ \"Ð”ÑŠÑ€Ð¶Ð°Ð²Ð¸\" Ð¾Ñ‚ Ð¡ÐÐ© Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ:<p><b>Admin-> Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-> Ð¿Ð¾ÑÐ¾Ñ‡Ð²Ð°Ñ‚ Ð½Ð¾Ð²Ð¸/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ</b>',0),(453103,12587,'ur','\"Ø§Ù…Ø±ÛŒÚ©Û\" Ø§Ù…Ø±ÛŒÚ©Û Ú©Û’ Ø·Û’ Ø´Ø¯Û Ø³Û’ Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ… Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’:<p><b>Ø§ÛŒÚˆÙ…Ù† Admin Ø³ÛŒÙ¹ Ø§Ù¾->-> Ø±ÛŒØ§Ø³Øª Ù†ÛŒÙˆ/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº</b>',0),(453104,12587,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ð»Ð¸ \"Ð”Ñ€Ð¶Ð°Ð²Ð°\" Ð¸Ð· Ð¡Ñ˜ÐµÐ´Ð¸ÑšÐµÐ½Ð¸Ñ… Ð”Ñ€Ð¶Ð°Ð²Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸:<p><b>ÐœÐ¸ Ñ˜Ðµ Ð°Ð´Ð¼Ð¸Ð½ Ð¸ ÐÐ´Ð¼Ð¸Ð½ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð½Ð¾Ð²Ð¸Ñ…/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ</b>',0),(453105,12587,'vi','Äá»ƒ chá»‰nh sá»­a\"tiá»ƒu bang\" tá»« máº·c Ä‘á»‹nh US: quáº£n trá»‹->cÃ i Ä‘áº·t quáº£n trá»‹-> ThÃªm má»›i/sá»­a tiá»ƒu bang',0),(453106,12587,'af','Om te wysig \"State\" van die Amerikaanse verstek:<p><b>Admin-> Admin opstelling-> meld nuwe/redigeer</b>',0),(453107,12587,'ro','Pentru a modifica \"State\" la valorile implicite SUA:<p><b>Admin->-Admin Setup-> nouÄƒ/editare de stat</b>',0),(453108,12587,'et','\"Riigid\": USA vaikesÃ¤tete muutmine<p><b>Admin-> Admin seadistamine-> mÃ¤rkida uus/Muuda</b>',0),(453109,12587,'si','ÄŒe Å¾elite spremeniti \"DrÅ¾ave\" iz ZDA privzete nastavitve:<p><b>Admin-> Admin Setup-> navesti nove izdajati /</b>',0),(453110,12587,'ba','Memodifikasi \"Serikat\" dari US default:<p><b>Admin-> Admin Setup-> negara baru/Edit</b>',0),(453111,12587,'nl','\"Staten\" van de Amerikaanse standaardinstellingen wijzigen<p><b>Admin-> Admin Setup-> staat nieuwe/bewerken</b>',0),(453112,12587,'fi','Muokkaaminen \"Valtiot\" USA: n oletukset:<p><b>Admin Admin asetukset->-> valtion uusi tai Muokkaa</b>',0),(453113,12587,'no','Endre \"Stater\" fra amerikanske standardene:<p><b>Admin-> Admin Setup-> staten ny/Rediger</b>',0),(453114,12587,'da','At Ã¦ndre \"Stater\" fra amerikanske standarder:<p><b>Admin-> Admin Setup-> stat nyt/Rediger</b>',0),(453115,12587,'ko','ë¯¸êµ­ ê¸°ë³¸ê°’ì—ì„œ \"ìƒíƒœ\"ë¥¼ ìˆ˜ì •í• :<p><b>ê´€ë¦¬ìž ê´€ë¦¬ìž ì„¤ì¹˜->-> ìƒíƒœ ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘</b>',0),(453116,12587,'he','×›×“×™ ×œ×©× ×•×ª ××ª \"×”×‘×¨×™×ª\" ×”×ž×—×“×œ ×‘××¨×” ×‘:<p><b>Admin-> ×ž× ×”×œ ×”×”×ª×§× ×”-> ×ž×¦×‘ ×—×“×©/×¢×¨×™×›×”</b>',0),(453117,12587,'el','Î“Î¹Î± Î½Î± Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ \"ÎœÎ­Î»Î·\" Î±Ï€ÏŒ Ï„Î¹Ï‚ Î—Î Î‘ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚:<p><b>Admin-> Admin Setup-> Î±Î½Î±Ï†Î­ÏÎµÎ¹ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±</b>',0),(453118,12587,'zh','ä»Žç¾Žå›½é»˜è®¤å€¼ä¿®æ”¹â€œç»Ÿè®¡â€ï¼šç®¡ç†->ç®¡ç†è®¾ç½®->ç»Ÿè®¡æ–°å»º/ä¿®æ”¹',0),(453119,12587,'sv','Ã„ndra \"Staterna\" frÃ¥n USA-defaults:<p><b>Admin-> Admin instÃ¤llning-> ange ny/redigera</b>',0),(453120,12587,'it','Modificare \"Stati\" rispetto alle impostazioni predefinite di US:<p><b>Admin-> Admin Setup-> nuova/modifica di stato</b>',0),(453121,12587,'tl','',0),(453122,12587,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™ \"à¸­à¹€à¸¡à¸£à¸´à¸à¸²\" à¸ˆà¸²à¸à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸‚à¸­à¸‡à¸ªà¸«à¸£à¸±à¸à¸­à¹€à¸¡à¸£à¸´à¸à¸²:<p><b>-> Admin-> Admin à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸–à¸²à¸™à¸°à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚</',0),(453123,12587,'hi','à¤…à¤®à¥‡à¤°à¤¿à¤•à¥€ à¤šà¥‚à¤• à¤¸à¥‡ \"à¤°à¤¾à¤œà¥à¤¯à¥‹à¤‚\" à¤•à¥‹ à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª->-> à¤°à¤¾à¤œà¥à¤¯ à¤¨à¤ˆ/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ ',0),(453124,12587,'ms','Untuk mengubah suai \"Syarikat\" dari lalai AS:<p><b>-> Admin-> Persediaan Admin Negeri baru/Edit</b>',0),(453125,12587,'ar','Ù„ØªØ¹Ø¯ÙŠÙ„ \"Ø§Ù„Ø¯ÙˆÙ„\" Ù…Ù† Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ø§Ù„ÙˆÙ„Ø§ÙŠØ§Øª Ø§Ù„Ù…ØªØ­Ø¯Ø©:<p><b>-> Ø§Ù„Ù…Ø´Ø±Ù-> Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø´Ø±Ù Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©/ØªØ­Ø±ÙŠØ±</b>',0),(453126,12587,'fr','Pour modifier les Â« Ã‰tats Â» des valeurs par dÃ©faut des Ã‰tats-Unis :<p><b>Admin-> Admin Setup-> nouveau/modification d\'Ã‰tat</b>',0),(453127,12587,'jp','ã€Œç±³å›½ã€ç±³å›½ã®æ—¢å®šå€¤ã‹ã‚‰å¤‰æ›´: ã™ã‚‹<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—-> ç®¡ç†-> çŠ¶æ…‹ã®ä½œæˆã¨ç·¨é›†</b>',0),(453128,12587,'pt','Para modificar os \"Estados\" dos padrÃµes dos EUA:<p><b>Admin-> Admin Setup-> estado novo/editar</b>',0),(453129,12587,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Â«Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð°Â» Ð¾Ñ‚ Ð¡Ð¨Ð Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ:<p><b>ÐÐ´Ð¼Ð¸Ð½-> Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸-> Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ/Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ</b>',0);
INSERT INTO `langdef` VALUES (453130,12587,'es','Par modificar \"Estados\" de los defectos de EEUU:<p><b>Admin -> ConfiguraciÃ³n -> Estado Nuevo/Editar</b>',0),(453131,12587,'de','\"Staaten\" von den US-Standardwerten Ã¤ndern:<p><b>Admin-> Admin Setup-> Zustand neu/bearbeiten</b>',0),(453132,12587,'en','To modify \"States\" from the US defaults:<p><b>Admin -> Admin Setup -> State New/Edit</b>',0),(453133,12588,'is','',0),(453134,12588,'dr','',0),(453135,12588,'pr','',0),(453136,12588,'tr','',0),(453137,12588,'pl','',0),(453138,12588,'bg','',0),(453139,12588,'ur','',0),(453140,12588,'sr','',0),(453141,12588,'vi','',0),(453142,12588,'af','',0),(453143,12588,'ro','',0),(453144,12588,'et','',0),(453145,12588,'si','',0),(453146,12588,'ba','',0),(453147,12588,'nl','',0),(453148,12588,'fi','',0),(453149,12588,'no','',0),(453150,12588,'da','',0),(453151,12588,'ko','',0),(453152,12588,'he','',0),(453153,12588,'el','',0),(453154,12588,'zh','',0),(453155,12588,'sv','',0),(453156,12588,'it','',0),(453157,12588,'tl','',0),(453158,12588,'th','',0),(453159,12588,'hi','',0),(453160,12588,'ms','',0),(453161,12588,'ar','',0),(453162,12588,'fr','',0),(453163,12588,'jp','',0),(453164,12588,'pt','',0),(453165,12588,'ru','',0),(453166,12588,'es','',0),(453167,12588,'de','',0),(453168,12588,'en','',0),(453169,12589,'is','',0),(453170,12589,'dr','',0),(453171,12589,'pr','',0),(453172,12589,'tr','',0),(453173,12589,'pl','',0),(453174,12589,'bg','',0),(453175,12589,'ur','',0),(453176,12589,'sr','',0),(453177,12589,'vi','',0),(453178,12589,'af','',0),(453179,12589,'ro','',0),(453180,12589,'et','',0),(453181,12589,'si','',0),(453182,12589,'ba','',0),(453183,12589,'nl','',0),(453184,12589,'fi','',0),(453185,12589,'no','',0),(453186,12589,'da','',0),(453187,12589,'ko','',0),(453188,12589,'he','',0),(453189,12589,'el','',0),(453190,12589,'zh','',0),(453191,12589,'sv','',0),(453192,12589,'it','',0),(453193,12589,'tl','',0),(453194,12589,'th','',0),(453195,12589,'hi','',0),(453196,12589,'ms','',0),(453197,12589,'ar','',0),(453198,12589,'fr','',0),(453199,12589,'jp','',0),(453200,12589,'pt','',0),(453201,12589,'ru','',0),(453202,12589,'es','',0),(453203,12589,'de','',0),(453204,12589,'en','',0),(453205,12590,'is','',0),(453206,12590,'dr','',0),(453207,12590,'pr','',0),(453208,12590,'tr','',0),(453209,12590,'pl','',0),(453210,12590,'bg','',0),(453211,12590,'ur','',0),(453212,12590,'sr','',0),(453213,12590,'vi','',0),(453214,12590,'af','',0),(453215,12590,'ro','',0),(453216,12590,'et','',0),(453217,12590,'si','',0),(453218,12590,'ba','',0),(453219,12590,'nl','',0),(453220,12590,'fi','',0),(453221,12590,'no','',0),(453222,12590,'da','',0),(453223,12590,'ko','',0),(453224,12590,'he','',0),(453225,12590,'el','',0),(453226,12590,'zh','',0),(453227,12590,'sv','',0),(453228,12590,'it','',0),(453229,12590,'tl','',0),(453230,12590,'th','',0),(453231,12590,'hi','',0),(453232,12590,'ms','',0),(453233,12590,'ar','',0),(453234,12590,'fr','',0),(453235,12590,'jp','',0),(453236,12590,'pt','',0),(453237,12590,'ru','',0),(453238,12590,'es','',0),(453239,12590,'de','',0),(453240,12590,'en','',0),(453241,12591,'is','',0),(453242,12591,'dr','',0),(453243,12591,'pr','',0),(453244,12591,'tr','',0),(453245,12591,'pl','',0),(453246,12591,'bg','',0),(453247,12591,'ur','',0),(453248,12591,'sr','',0),(453249,12591,'vi','',0),(453250,12591,'af','',0),(453251,12591,'ro','',0),(453252,12591,'et','',0),(453253,12591,'si','',0),(453254,12591,'ba','',0),(453255,12591,'nl','',0),(453256,12591,'fi','',0),(453257,12591,'no','',0),(453258,12591,'da','',0),(453259,12591,'ko','',0),(453260,12591,'he','',0),(453261,12591,'el','',0),(453262,12591,'zh','',0),(453263,12591,'sv','',0),(453264,12591,'it','',0),(453265,12591,'tl','',0),(453266,12591,'th','',0),(453267,12591,'hi','',0),(453268,12591,'ms','',0),(453269,12591,'ar','',0),(453270,12591,'fr','',0),(453271,12591,'jp','',0),(453272,12591,'pt','',0),(453273,12591,'ru','',0),(453274,12591,'es','',0),(453275,12591,'de','',0),(453276,12591,'en','',0),(453277,12592,'is','',0),(453278,12592,'dr','',0),(453279,12592,'pr','',0),(453280,12592,'tr','',0),(453281,12592,'pl','',0),(453282,12592,'bg','',0),(453283,12592,'ur','',0),(453284,12592,'sr','',0),(453285,12592,'vi','',0),(453286,12592,'af','',0),(453287,12592,'ro','',0),(453288,12592,'et','',0),(453289,12592,'si','',0),(453290,12592,'ba','',0),(453291,12592,'nl','',0),(453292,12592,'fi','',0),(453293,12592,'no','',0),(453294,12592,'da','',0),(453295,12592,'ko','',0),(453296,12592,'he','',0),(453297,12592,'el','',0),(453298,12592,'zh','',0),(453299,12592,'sv','',0),(453300,12592,'it','',0),(453301,12592,'tl','',0),(453302,12592,'th','',0),(453303,12592,'hi','',0),(453304,12592,'ms','',0),(453305,12592,'ar','',0),(453306,12592,'fr','',0),(453307,12592,'jp','',0),(453308,12592,'pt','',0),(453309,12592,'ru','',0),(453310,12592,'es','',0),(453311,12592,'de','',0),(453312,12592,'en','',0),(453313,12593,'is','',0),(453314,12593,'dr','GL Ø§Ø¹ØªØ¨Ø§Ø± Ø¯Ø± Ø¨Ø§Ù†Ú© Ø³Ù¾Ø±Ø¯Ù‡:<p><b>Ù„Ø¬Ø±-> Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ù…Ø¬Ù„Ù‡-> ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø± Ø¬Ø¯ÛŒØ¯</b><p>Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÛŒ Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø§ÛŒ ÙˆØ±ÙˆØ¯ GL ÛŒÚ©ÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ Ùˆ Ø¢Ù† Ø±Ø§ Ø¯Ø± Ø¨Ø§Ù†Ú© Ø³Ù¾Ø±Ø¯Ù‡ Ù„ØºØ²',0),(453315,12593,'pr','GL Ø§Ø¹ØªØ¨Ø§Ø± Ø¯Ø± Ø¨Ø§Ù†Ú© Ø³Ù¾Ø±Ø¯Ù‡:<p><b>Ù„Ø¬Ø±-> Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ù…Ø¬Ù„Ù‡-> ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø± Ø¬Ø¯ÛŒØ¯</b><p>Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÛŒ Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø§ÛŒ ÙˆØ±ÙˆØ¯ GL ÛŒÚ©ÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ Ùˆ Ø¢Ù† Ø±Ø§ Ø¯Ø± Ø¨Ø§Ù†Ú© Ø³Ù¾Ø±Ø¯Ù‡ Ù„ØºØ²',0),(453316,12593,'tr','Banka mevduat Ã¼zerinde GL kredisi:<p><b>Genel muhasebe gÃ¼nlÃ¼k giriÅŸlerine yeni gÃ¼nlÃ¼k girdisi->-></b><p>Bir GL giriÅŸ iÃ§in Ã‡ek hesabÄ±nÄ± seÃ§in ve banka havalesi ve banka Rec gÃ¶rÃ¼necek.<p>Ad koymak ve check # \"FiÅŸ aÃ§Ä±klama\".',0),(453317,12593,'pl','GL kredyty na przelew:<p><b>KsiÄ™gi-> wpisÃ³w w Dzienniku-> nowÄ… pozycjÄ™ dziennika</b><p>Wybierz swojego konta bankowego za jeden wpis GL i pojawiÄ… siÄ™ na Twojej pokwitowania bank i Bank Rec.<p>UmieÅ›ciÄ‡ nazwÄ™ i sprawdziÄ‡ # w \"Voucher opis\".',0),(453318,12593,'bg','GL ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸Ñ‚Ðµ Ð¿Ð¾ Ð±Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚:<p><b>ÐšÐ½Ð¸Ð³Ð° Ð·Ð°-> Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°-> Ð½Ð¾Ð² Ð·Ð°Ð¿Ð¸Ñ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°</b><p>Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° ÐµÐ´Ð¸Ð½ GL Ð·Ð°Ð¿Ð¸Ñ',0),(453319,12593,'ur','Ø¬ÛŒØ¬Û’ Ú©Ø±ÛŒÚˆÙ¹ Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ Ù¾Ø±:<p><b>-> Ù†ÛŒØ§ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª-> Ú©Ú¾Ø§ØªØ§</b><p>Ø§ÛŒÚ© Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ù„ÛŒÛ’ Ø§Ù¾Ù†Û’ Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø',0),(453320,12593,'sr','Ð“Ð› ÑˆÐ¿Ð¸Ñ†Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð±Ð°Ð½ÐºÐµ:<p><b>ÐšÑšÐ¸Ð³Ðµ Ð¸ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ° Ð¸ Ð½Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ</b><p>ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð²Ð°Ñˆ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð·Ð° Ñ˜ÐµÐ´Ð½Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ Ð“Ð› Ð¸ Ð¾Ð½Ð° Ñ›Ðµ ÑÐµ Ð¿Ð¾Ñ˜Ð°',0),(453321,12593,'vi','GL dÆ° cÃ³ trÃªn TK ngÃ¢n hÃ ng: Phiáº¿u ke toan-> nháº­p phiáº¿u-> nháº­p má»›i. Chá»n tÃ i khoáº£n Ä‘Ã£ kiá»ƒm tra cho má»—i láº§n nháº­p phiáº¿u, nÃ³ sáº½ xuáº¥t hiá»‡n trÃªn phiáº¿u tiá»n gá»­i ngÃ¢n hÃ ng cá»§a báº¡n. nháº­p tÃªn vÃ  nháº¥p vÃ o \"d',0),(453322,12593,'af','GL krediete op Bank deposito:<p><b>Grootboek-> joernaalinskrywings-> nuwe joernaal inskrywing</b><p>Kies jou Kontroleer tans rekening vir een GL inskrywing en dit op jou bank deposito strokie en die Bank Rec sal verskyn.<p>Die naam sit en kontroleer # in ',0),(453323,12593,'ro','GL credite pe depozite bancare:<p><b>Registru-> jurnal-> nouÄƒ intrare Ã®n jurnal</b><p>AlegeÅ£i contul de verificare pentru o singurÄƒ intrare GL ÅŸi acesta va apÄƒrea pe alunecare dumneavoastrÄƒ de depozit bancar si Banca Rec.<p>Pune numele ÅŸi verifica',0),(453324,12593,'et','GL krediiti pangahoiuste:<p><b>Pearaamatu-> pÃ¤evikukannete-> Uus pÃ¤evikukanne</b><p>Vali oma pangakonto GL kannet ning see ilmub teie pank deposiitkviitungi ja panga Rec.<p>Pane nimi ja kontrollige # \"Kande kirjeldus\".',0),(453325,12593,'si','GL kreditov na banÄni depozit:<p><b>Postavke-> dnevnik-> nov vnos v dnevnik</b><p>Izberite vaÅ¡ tekoÄi raÄun za eno postavko GL in se bo pojavil na vaÅ¡ banÄni depozit slip in banka Rec.<p>Dal ime in preverite # \"Bon opis\".',0),(453326,12593,'ba','GL kredit pada deposito Bank:<p><b>Buku besar-> entri jurnal-> entri jurnal baru</b><p>Pilih rekening Anda untuk satu entri GL dan akan muncul pada slip setoran bank Anda dan Bank Rec.<p>Menempatkan nama dan periksa # di \"Voucher Deskripsi\".',0),(453327,12593,'nl','GL credits op bankstorting:<p><b>Posten-> logboekitems-> Nieuw logboekitem</b><p>Kies uw betaalrekening voor Ã©Ã©n GL post en het zal verschijnen op uw afgiftebewijs bank en de Bank Rec.<p>De naam en Controleer # in \'Voucher Description\'.',0),(453328,12593,'fi','GL laajuus pankki tallettaa:<p><b>Kirjanpidon-> pÃ¤ivyrimerkintÃ¶jen-> uusi pÃ¤ivyrimerkintÃ¤</b><p>Valitse yksi GL merkintÃ¤ pankkitililtÃ¤si ja se nÃ¤kyy teidÃ¤n pankkitalletus liukua ja pankin Rec.<p>Laita nimi ja tarkista # \"Tositteen kuvaus\".',0),(453329,12593,'no','GL studiepoeng pÃ¥ bankinnskudd:<p><b>Finans-> loggoppfÃ¸ringer-> ny loggoppfÃ¸ring</b><p>Velg din brukskonto for Ã©n GL og vises pÃ¥ din bankinnskudd slip og Bank Rec.<p>Sette navn og sjekk # i \"Bilaget beskrivelse\".',0),(453330,12593,'da','GL credits pÃ¥ Bank depositum:<p><b>Finans-> journaloptegnelser-> ny journaloptegnelse</b><p>VÃ¦lg din checkkonto for en GL posten og vises pÃ¥ din bank kvitteringen og Bank Rec.<p>SÃ¦t navn og kontroller # \"Voucher beskrivelse\".',0),(453331,12593,'ko','ì€í–‰ ì˜ˆê¸ˆì— GL í¬ë ˆë”§:<p><b>-> ìƒˆ ì—…ë¬´ ì¼ì§€ í•­ëª© ì—…ë¬´ ì¼ì§€ í•­ëª©-> ì›ìž¥</b><p>í•˜ë‚˜ì˜ GL í•­ëª©ì— ëŒ€ í•œ ê·€í•˜ì˜ ë‹¹ì¢Œ ê³„ì¢Œë¥¼ ì„ íƒ í•˜ ê³  ê·¸ê²ƒì€ ë‹¹ì‹ ì˜ ì€í–‰ ì˜ˆê¸ˆ ì „í‘œ ë° ì€í–‰ Recì— ë‚˜íƒ€ë‚©ë‹ˆë‹¤.<p>ì´ë',0),(453332,12593,'he','GL ×§×¨×“×™×˜×™× ×¢×œ ×¤×™×§×“×•×Ÿ ×”×‘× ×§:<p><b>×¡×¤×¨ ×”×—×©×‘×•× ×•×ª-> ×¢×¨×›×™ ×™×•×ž×Ÿ-> ×¢×¨×š ×™×•×ž×Ÿ ×—×“×©</b><p>×œ×‘×—×•×¨ ×ž×”×—×¡×›×•× ×•×ª ×©×œ×š ×œ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×¢×¨×š GL ××—×“, ×”×•× ×™×•×¤×™×¢ ×¢×œ ×©×œ×š ×”×¤×§×“×” ×œ×‘× ×§, ×',0),(453333,12593,'el','GL Ï€Î¹ÏƒÏ„ÏŽÏƒÎµÎ¹Ï‚ ÏƒÏ„Î·Î½ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÎµ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ:<p><b>Î›Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®-> ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ ÎµÏ†Î·Î¼ÎµÏÎ¯Î´Î±-> Î½Î­Î± ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ¹ÏƒÎ· Ï‡ÏÎ¿Î½Î¹ÎºÎ¿Ï</b><p>Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±Ïƒ',0),(453334,12593,'zh','é“¶è¡Œå­˜æ¬¾ä¸­çš„æ€»å¸è´·æ¬¾ï¼šåˆ†ç±»å¸->æ—¥å¿—æ¡ç›®->æ–°æ—¥å¿—æ¡ç›®\r\né€‰æ‹©æ‚¨æ€»å¸æ¡ç›®çš„æ”¯ç¥¨å¸æˆ·ï¼Œå®ƒä¼šæ˜¾ç¤ºåœ¨æ‚¨çš„é“¶è¡Œå­˜æ¬¾å•å’Œé“¶è¡Œè®°å½•ä¸Šã€‚æŠŠåç§°ä¸Žæ”¯ç¥¨å·å†™åœ¨â€œå‡­è¯æè¿°â€ä¸Šã€‚\r\n',0),(453335,12593,'sv','GL tillgodohavanden pÃ¥ bankinsÃ¤ttning:<p><b>Redovisningen-> journalposter-> ny journalpost</b><p>VÃ¤lj ditt lÃ¶nekonto fÃ¶r en GL post och det kommer att visas pÃ¥ din bank insÃ¤ttningsblanketten och Bank Rec.<p>LÃ¤gg namnet och kolla # i \"Voucher beskr',0),(453336,12593,'it','Crediti GL sul deposito bancario:<p><b>ContabilitÃ -> voci di diario-> nuova voce di diario</b><p>Scegli il tuo conto corrente per una voce GL e apparirÃ  sul tuo distinta di deposito bancario e la banca Rec.<p>Mettere il nome e verifica # nella \"Descrizi',0),(453337,12593,'tl','',0),(453338,12593,'th','GL à¹€à¸„à¸£à¸”à¸´à¸•à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸˜à¸™à¸²à¸„à¸²à¸£:<p><b>à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—->à¸£à¸²à¸¢->à¸£à¸²à¸¢à¹ƒà¸«à¸¡à¹ˆ</b><p>à¹€à¸¥à¸·à¸­à¸à¸šà¸±à¸à¸Šà¸µà¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸',0),(453339,12593,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤ªà¤° à¤œà¥€à¤à¤² à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ:<p><b>à¤–à¤¾à¤¤à¤¾à¤¬à¤¹à¥€ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤¨à¤ˆ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿->-></b><p>à¤…à¤ªà¤¨à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š à¤',0),(453340,12593,'ms','GL kredit Bank Deposit:<p><b>Lejar-> catatan jurnal-> jurnal entri baru</b><p>Pilih akaun anda memeriksa untuk satu penyertaan GL dan ia akan muncul di bank deposit slip dan Bank Rec.<p>Letakkan nama dan menyemak # \"Baucer Perihalan\".',0),(453341,12593,'ar','GL Ø§Ù„Ø£Ø±ØµØ¯Ø© Ø§Ù„Ø¯Ø§Ø¦Ù†Ø© Ø¹Ù„Ù‰ \"Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©\":<p><b>Ø§Ù„Ø£Ø³ØªØ§Ø°-> Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©-> Ø¥Ø¯Ø®Ø§Ù„ Ø¯ÙØªØ± ÙŠÙˆÙ…ÙŠØ© Ø¬Ø¯ÙŠØ¯</b><p>Ø§Ø®ØªØ± ÙØ­Øµ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù„Ø¥Ø¯Ø®Ø§Ù„ GL ÙˆØ§Ø­Ø¯ Ù',0),(453342,12593,'fr','CrÃ©dits GL sur des dÃ©pÃ´ts bancaires :<p><b>Livre-> des entrÃ©es de Journal-> la nouvelle entrÃ©e du Journal</b><p>Choisissez votre compte-chÃ¨ques pour une entrÃ©e GL et il apparaÃ®tra sur votre bordereau de dÃ©pÃ´t bancaire et le Rec de la Banque.<p>A',0),(453343,12593,'jp','éŠ€è¡Œé é‡‘ã® GL ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ:<p><b>å…ƒå¸³ä»•è¨³å¸³ã‚¨ãƒ³ãƒˆãƒªæ–°ã—ã„ä»•è¨³å¸³ã‚¨ãƒ³ãƒˆãƒª->-></b><p>1 ã¤ã® GL ã‚¨ãƒ³ãƒˆãƒªã®å½“åº§é é‡‘å£åº§ã‚’é¸æŠžã—ã€éŠ€è¡Œã®å…¥é‡‘ä¼ç¥¨ã¨éŠ€è¡Œ Rec ã«è¡¨ç¤ºã•ã‚Œã¾ã™ã€‚<p>åå‰ã‚’å…¥ã‚Œã¦ã—ã€',0),(453344,12593,'pt','CrÃ©ditos GL em depÃ³sito bancÃ¡rio:<p><b>Livro-> entradas de diÃ¡rio-> nova entrada de diÃ¡rio</b><p>Escolha sua conta corrente para uma entrada GL e ele aparecerÃ¡ no seu comprovante de depÃ³sito do banco e o banco Rec.<p>Coloque o nome e verificar # em',0),(453345,12593,'ru','GL ÐºÑ€ÐµÐ´Ð¸Ñ‚Ñ‹ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚:<p><b>Ð“Ðš-> Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ-> Ð½Ð¾Ð²Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ</b><p>Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð’Ð°Ñˆ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ Ð´Ð»Ñ Ð¾Ð´Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ GL, Ð¸ Ð¾Ð½ Ð¿Ð¾Ñ',0),(453346,12593,'es','CrÃ©dito de LM sobre DepÃ³sitos Bancarios:<p><b> Libro Mayor -> Entradas del Diario -> Nuevas Entradas al Diario</b><p> Selecciona su cuenta de cheques para una entrada de LM y aparecerÃ¡ en su ficha de depÃ³sito y el record de Banco. <p>Entra su nombre y',0),(453347,12593,'de','GL-Credits auf Bank hinterlegen:<p><b>Finanzbuchhaltung-> JournaleintrÃ¤ge-> neuer Journaleintrag</b><p>WÃ¤hlen Sie Ihr Girokonto fÃ¼r ein GL-Eintrag und es erscheint auf Ihren Einzahlungsbeleg der Bank und die Bank-Rec.<p>Geben Sie den Namen und Ã¼berprÃ',0),(453348,12593,'en','GL credits on Bank Deposit:<p><b>Ledger -> Journal Entries -> New Journal Entry</b><p> Choose your checking account for one GL entry and it will appear on your bank deposit slip and the Bank Rec.<p>Put the name and check # in \"Voucher Description\".',0),(453349,12594,'is','',0),(453350,12594,'dr','',0),(453351,12594,'pr','',0),(453352,12594,'tr','',0),(453353,12594,'pl','',0),(453354,12594,'bg','',0),(453355,12594,'ur','',0),(453356,12594,'sr','',0),(453357,12594,'vi','',0),(453358,12594,'af','',0),(453359,12594,'ro','',0),(453360,12594,'et','',0),(453361,12594,'si','',0),(453362,12594,'ba','',0),(453363,12594,'nl','',0),(453364,12594,'fi','',0),(453365,12594,'no','',0),(453366,12594,'da','',0),(453367,12594,'ko','',0),(453368,12594,'he','',0),(453369,12594,'el','',0),(453370,12594,'zh','',0),(453371,12594,'sv','',0),(453372,12594,'it','',0),(453373,12594,'tl','',0),(453374,12594,'th','',0),(453375,12594,'hi','',0),(453376,12594,'ms','',0),(453377,12594,'ar','',0),(453378,12594,'fr','',0),(453379,12594,'jp','',0),(453380,12594,'pt','',0),(453381,12594,'ru','',0),(453382,12594,'es','',0),(453383,12594,'de','',0),(453384,12594,'en','',0),(453385,12595,'is','',0),(453386,12595,'dr','Ø¨Ø±Ø§ÛŒ ÙˆÛŒØ±Ø§ÛŒØ´ ÙØ§Ú©ØªÙˆØ± Ùˆ ØªØ§Ø«ÛŒØ± Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø§ÛŒØ¯ Ø­Ø°Ù ÙØ§Ú©ØªÙˆØ± (Ú©Ù‡ Ù…Ù†Ø¸ÙˆØ± Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¨Ø§Ø²) Ùˆ ÙØ§Ú©ØªÙˆØ± Ø¢Ù† Ø±Ø§ Ù¾Ø³ Ø§Ø² Ø§ÛŒØ¬Ø§Ø¯ ØªØºÛŒÛŒØ±Ø§Øª Ø¯ÙˆØ¨Ø§Ø±Ù‡.',0),(453387,12595,'pr','Ø¨Ø±Ø§ÛŒ ÙˆÛŒØ±Ø§ÛŒØ´ ÙØ§Ú©ØªÙˆØ± Ùˆ ØªØ§Ø«ÛŒØ± Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø§ÛŒØ¯ Ø­Ø°Ù ÙØ§Ú©ØªÙˆØ± (Ú©Ù‡ Ù…Ù†Ø¸ÙˆØ± Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¨Ø§Ø²) Ùˆ ÙØ§Ú©ØªÙˆØ± Ø¢Ù† Ø±Ø§ Ù¾Ø³ Ø§Ø² Ø§ÛŒØ¬Ø§Ø¯ ØªØºÛŒÛŒØ±Ø§Øª Ø¯ÙˆØ¨Ø§Ø±Ù‡.',0),(453388,12595,'tr','Fatura dÃ¼zenlemek ve stok etkiler (Bu sÄ±rada yeniden aÃ§ar) fatura silme ve deÄŸiÅŸiklik yapÄ±ldÄ±ktan sonra yeniden fatura.',0),(453389,12595,'pl','Aby edytowaÄ‡ fakturÄ™ i wpÅ‚ywajÄ… na magazynie naleÅ¼y usunÄ…Ä‡ faktury (ktÃ³ry otwiera zamÃ³wienia) i ponownie faktura to po wprowadzeniu zmian.',0),(453390,12595,'bg','Ð”Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸ Ð·Ð°ÑÐµÐ³Ð½Ð°Ñ‚ ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð°ÑÐ¸ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, (ÐºÐ¾Ð¹Ñ‚Ð¾ Ð¾Ñ‚Ð²Ð°Ñ€Ñ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾ Ñ€ÐµÐ´) Ð¸ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾ Ð³Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÑÐ»ÐµÐ´ ÐºÐ°Ñ‚Ð¾ Ð½Ð°Ð¿Ñ',0),(453391,12595,'ur','Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ø§ÙˆØ± Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ùˆ Ù…ØªØ§Ø«Ø± Ú©Ø±Ù†Ø§ Ø¢Ù¾ Ú©Ùˆ Ø§Ù†ÙˆØ§Ø¦Ø³ (Ø¬Ùˆ Ø­Ú©Ù… Ù¾Ú¾Ø± Ú©Ú¾Ù„ Ø±ÛØ§ ÛÛ’) Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’ Ø§ÙˆØ± ÛŒÛ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ø¹Ø¯ Ø¯ÙˆØ¨Ø§Ø±Û Ø§Ù†ÙˆØ§Ø¦Ø³ Û”',0),(453392,12595,'sr','Ð—Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸ ÑƒÑ‚Ð¸Ñ‡Ñƒ Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ (ÐºÐ¾Ñ˜Ð° ÑÐµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð¾Ñ‚Ð²Ð°Ñ€Ð° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ) Ð¸ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð³Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµÑ‚Ðµ Ð¿Ð¾ÑÐ»Ðµ Ð¸Ð·Ð²Ñ€ÑˆÐµÐ½Ð¸Ñ',0),(453393,12595,'vi','Äá»ƒ sá»­a hÃ³a Ä‘Æ¡n mÃ  cÃ³ áº£nh hÆ°á»Ÿng Ä‘áº¿n hÃ ng tá»“n kho, báº¡n pháº£i xÃ³a hÃ³a Ä‘Æ¡n vÃ  xuáº¥t láº¡i hÃ³a Ä‘Æ¡n sau khi ghi nháº­n nhá»¯ng thay Ä‘á»•i',0),(453394,12595,'af','Redigeer \'n faktuur en voorraad beÃ¯nvloed jy moet skrap die faktuur (wat heropen die orde) en dit weer na veranderinge invoice.',0),(453395,12595,'ro','Pentru a edita o facturÄƒ ÅŸi afecteazÄƒ inventar trebuie sÄƒ ÅŸtergeÅ£i factura (care redeschide ordinea) ÅŸi re-l facturÄƒ dupÄƒ efectuarea de modificÄƒri.',0),(453396,12595,'et','Muuta arve ja mÃµjutavad varude peate kustutama arve (mis avab taas tellimus) ja uuesti arveldada pÃ¤rast muutuste tegemist.',0),(453397,12595,'si','Urejanje raÄuna in vpliva na zaloge morate izbrisati raÄun (ki odpre vrstni red) in ponovno izdate po spremembe.',0),(453398,12595,'ba','Untuk mengedit faktur dan mempengaruhi persediaan Anda harus menghapus faktur (yang dibuka urutan) dan kembali faktur setelah membuat perubahan.',0),(453399,12595,'nl','U moet om te bewerken een factuur en inventaris van invloed zijn op de factuur (die heropent de volgorde) verwijderen en opnieuw factureren nadat u wijzigingen hebt.',0),(453400,12595,'fi','Muokkaa laskua ja vaikuttaa varaston Poista lasku (jotka avataan jÃ¤rjestyksessÃ¤) ja laskun uudelleen muutosten tekemisen jÃ¤lkeen.',0),(453401,12595,'no','Du mÃ¥ slette fakturaen (som gjenÃ¥pner rekkefÃ¸lgen) og Ã¥ fakturere den etter endringer for Ã¥ redigere en faktura og pÃ¥virker lageret.',0),(453402,12595,'da','Hvis du vil redigere en faktura og pÃ¥virke opgÃ¸relsen skal du slette fakturaen (som genÃ¥bner rÃ¦kkefÃ¸lgen) og re fakturere det efter at foretage Ã¦ndringer.',0),(453403,12595,'ko','ì¸ë³´ì´ìŠ¤ íŽ¸ì§‘ í•˜ ê³  ìž¬ê³ ì— ì˜í–¥ì„ ë¯¸ì¹  ì†¡ìž¥ (ì´ ìˆœì„œ ëŒ€ë¡œ ë‹¤ì‹œ íƒœì–´ë‚œ ë‹¤)ë¥¼ ì‚­ì œ í•˜ ê³  ë‹¤ì‹œ ë³€ê²½í•œ í›„ ì†¡ìž¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(453404,12595,'he','×›×“×™ ×œ×¢×¨×•×š ×—×©×‘×•× ×™×ª ×•×ž×©×¤×™×¢×™× ×¢×œ ×ž×œ××™ ××ª×” ×—×™×™×‘ ×œ×ž×—×•×§ ××ª ×”×—×©×‘×•× ×™×ª (××©×¨ ×™×¤×ª×— ××ª ×”×¡×“×¨) ×•×—×©×‘×•× ×™×ª ×ž×—×“×© ×–×” ×œ××—×¨ ×‘×™×¦×•×¢ ×©×™× ×•×™×™×.',0),(453405,12595,'el','ÎÎ± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î­Î½Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎºÎ±Î¹ Î½Î± ÎµÏ€Î·ÏÎµÎ¬ÏƒÎµÎ¹ Ï„Î·Î½ Î±Ï€Î¿Î³ÏÎ±Ï†Î® Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ (Ï„Î¿ Î¿Ï€Î¿Î¯Î¿ Î±Î½Î¿Î¯Î³ÎµÎ¹ ÎºÎ±Î¹ Ï€Î¬Î»Î¹ Ï„Î· ÏƒÎµÎ¹ÏÎ¬) ÎºÎ±Î¹ Î½Î± ',0),(453406,12595,'zh','è¦ç¼–è¾‘ä¸€ä¸ªå‘ç¥¨å¹¶å½±å“åº“å­˜ï¼Œæ‚¨å¿…é¡»åˆ é™¤å‘ç¥¨ï¼ˆé‡æ–°æ‰“å¼€è®¢å•ï¼‰å¹¶åœ¨è¿›è¡Œå˜æ›´åŽé‡æ–°å¼€å…·å…¶å‘ç¥¨ã€‚',0),(453407,12595,'sv','Om du vill redigera en faktura och pÃ¥verkar lagret mÃ¥ste du ta bort fakturan (som Ã¥terÃ¶ppnar ordningen) och Ã¥ter fakturera det efter Ã¤ndringar.',0),(453408,12595,'it','Per modificare una fattura e influenzare l\'inventario Ã¨ necessario eliminare la fattura (che riapre l\'ordine) e nuovamente la fattura dopo aver apportato modifiche.',0),(453409,12595,'tl','',0),(453410,12595,'th','à¸à¸²à¸£à¹à¸à¹‰à¹„à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ à¹à¸¥à¸°à¸ªà¹ˆà¸‡à¸œà¸¥à¸à¸£à¸°à¸—à¸šà¸•à¹ˆà¸­à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡ à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸¥à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ (à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡) à¹à¸¥à¸°à¸­',0),(453411,12595,'hi','à¤à¤• à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤¸à¥‚à¤šà¥€ à¤•à¥‹ à¤ªà¥à¤°à¤­à¤¾à¤µà¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤ª à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ (à¤œà¥‹ à¤‘à¤°à¥à¤¡à¤° reopens) à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤”à¤° à¤‡à¤¸à¥‡ à¤«à¤¿à¤°',0),(453412,12595,'ms','Untuk mengedit invois dan menjejaskan inventori anda mesti menghapuskan invois (yang membuka semula pesanan) dan semula invois selepas membuat perubahan.',0),(453413,12595,'ar','Ù„ØªØ­Ø±ÙŠØ± ÙØ§ØªÙˆØ±Ø© ÙˆØªØ¤Ø«Ø± Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ÙŠØ¬Ø¨ Ø­Ø°Ù Ø§Ù„ÙØ§ØªÙˆØ±Ø© (Ø§Ù„Ø°ÙŠ ÙŠÙØªØ­ Ø£Ø¨ÙˆØ§Ø¨Ù‡ Ù…Ù† Ø¬Ø¯ÙŠØ¯ Ø¨Ø§Ù„ØªØ±ØªÙŠØ¨) ÙˆØ¥Ø¹Ø§Ø¯Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø£Ù†Ù‡ Ø¨Ø¹Ø¯ Ø¥Ø¬Ø±Ø§Ø¡ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª.',0),(453414,12595,'fr','Pour Ã©diter une facture et d\'influer sur l\'inventaire, vous devez supprimer la facture (qui s\'ouvre Ã  nouveau l\'ordre) et re-il facture aprÃ¨s avoir modifiÃ©.',0),(453415,12595,'jp','è«‹æ±‚æ›¸ã‚’ç·¨é›†ã—ã€åœ¨åº«ã«å½±éŸ¿ã™ã‚‹ã«ã¯ã€è«‹æ±‚ (é †åºã‚’å†åº¦é–‹ã) ã‚’å‰Šé™¤ã—ã€å¤‰æ›´ã‚’åŠ ãˆãŸå¾Œå†è«‹æ±‚ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(453416,12595,'pt','Para editar uma fatura e afetam o inventÃ¡rio vocÃª deve excluir a factura (que reabre a ordem) e re-fatura-lo depois de fazer alteraÃ§Ãµes.',0),(453417,12595,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¸ Ð²Ð»Ð¸ÑÑŽÑ‚ Ð½Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð° (ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ð¹ Ð¾Ñ‚ÐºÑ€Ñ‹Ð²Ð°ÐµÑ‚ÑÑ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°) Ð¸ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð¿Ð¾ÑÐ»Ðµ Ð²Ð½ÐµÑÐµÐ½Ð¸',0),(453418,12595,'es','Para editar una factura y se hace efecto en el inventario debe eliminar la factura (que reabre el orden) y refacturarlo depuÃ©s de hacer los cambios',0),(453419,12595,'de','Zum Bearbeiten einer Rechnung und Einfluss auf Inventar mÃ¼ssen Sie lÃ¶schen die Rechnung (die die Reihenfolge Ã¶ffnet) und erneut nach Ã„nderungen Rechnung zu stellen.',0),(453420,12595,'en','To edit an invoice and affect inventory you must delete the invoice (which reopens the order) and re-invoice it after making changes.',0),(453421,12596,'is','',0),(453422,12596,'dr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø¨Ù‡ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø®ÙˆØ¯ Ø³Ù¾Ø³ Ù…Ø§Ú˜ÙˆÙ„ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø§ Ø¨Ø±Ø§ÛŒ Ø´Ù…Ø§ Ù…Ù†Ø§Ø³Ø¨ Ø§Ø³Øª:<p><b>-> Ø¨Ø®Ø´ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø',0),(453423,12596,'pr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø¨Ù‡ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø®ÙˆØ¯ Ø³Ù¾Ø³ Ù…Ø§Ú˜ÙˆÙ„ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø§ Ø¨Ø±Ø§ÛŒ Ø´Ù…Ø§ Ù…Ù†Ø§Ø³Ø¨ Ø§Ø³Øª:<p><b>-> Ø¨Ø®Ø´ Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø',0),(453424,12596,'tr','Yinelenen yukarÄ± ayarlamak istiyorsanÄ±z, mÃ¼ÅŸterileriniz iÃ§in o zaman bizim Ã¶deme planÄ± modÃ¼lÃ¼ fatura tam size gÃ¶re:<p><b>Fatura Ã¶deme planlarÄ± bÃ¶lÃ¼mÃ¼-></b>',0),(453425,12596,'pl','JeÅ›li chcesz skonfigurowaÄ‡ powtarzajÄ…ce siÄ™ pÅ‚atnoÅ›ci dla klientÃ³w to nasz moduÅ‚ planu pÅ‚atnoÅ›ci jest dla Ciebie:<p><b>PÅ‚atnoÅ›ci-> planÃ³w pÅ‚atnoÅ›ci sekcji</b>',0),(453426,12596,'bg','ÐÐºÐ¾ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚Ðµ Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸, ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð° Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½ Ð¼Ð¾Ð´ÑƒÐ» Ðµ Ð·Ð° Ð²Ð°Ñ:<p><b>Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½Ð¾Ð',0),(453427,12596,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ù…Ú©Ø±Ø± Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº ØªÙˆ Ø§Ù¾Ù†Û’ Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ù„Ø¦Û’ ÛÙ…Ø§Ø±Û’ Ù¾ÛŒÙ…Ù†Ù¹ Ù¾Ù„Ø§Ù† Ù…Ø§ÚˆÛŒÙˆÙ„ Ú©Ùˆ Ù¾Ú¾Ø± Ø­Ø³Ø§Ø¨ Ú©Ø±Ù†Ø§ Ø¢Ù¾ Ú©Û’ Ù„Ø¦Û’ ÛÛ’:<p><b>Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø§ Ù…Ù†ØµÙˆØ¨Û Ø³ÛŒÚ©Ø´Ù†-> Ø¨Ù„ Ú©Û',0),(453428,12596,'sr','ÐÐºÐ¾ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¿Ð¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð¾Ð½Ð°Ð²Ñ™Ð°ÑšÐµ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð·Ð° ÐºÑƒÐ¿Ñ†Ðµ Ð¾Ð½Ð´Ð° Ð½Ð°Ð¼ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð¿Ð»Ð°Ð½ Ð¼Ð¾Ð´ÑƒÐ» Ñ˜Ðµ Ð·Ð° Ð²Ð°Ñ:<p><b>ÐžÐ±Ñ€Ð°Ñ‡ÑƒÐ½ Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ Ð¿Ð»Ð°Ð½Ð¸Ñ€Ð° ÑÐµÐºÑ†Ð¸Ñ˜Ð°</b>',0),(453429,12596,'vi','Náº¿u báº¡n muá»‘n thiáº¿t láº­p thanh toÃ¡n Ä‘á»‹nh ká»³ cho khÃ¡ch hÃ ng thÃ¬ vÃ o : Thanh toÃ¡n->pháº§n Káº¿ hoáº¡ch thanh toÃ¡n',0),(453430,12596,'af','As jy wil opstel herhalende fakturering vir jou kliÃ«nte dan ons betaling plan module is vir jou:<p><b>-> Betaling planne artikel fakturering</b>',0),(453431,12596,'ro','DacÄƒ doriÅ£i sÄƒ configuraÅ£i recurente de facturare pentru clienÅ£ii dvs. apoi modul nostru de plan de platÄƒ este pentru tine:<p><b>Facturare-> planuri de platÄƒ secÅ£iunea</b>',0),(453432,12596,'et','Kui soovite luua uuendatavate arvelduse oma klientidele siis meie otsemaksete kava moodul on teie jaoks:<p><b>Arvete-> maksmine plaanid jagu</b>',0),(453433,12596,'si','ÄŒe Å¾elite nastaviti ponavljajoÄe se zaraÄunavanje za vaÅ¡e stranke, nato naÅ¡i plaÄilni naÄrt modul je za vas:<p><b>ZaraÄunavanje-> plaÄilo naÄrtov oddelek</b>',0),(453434,12596,'ba','Jika Anda ingin mengatur berulang penagihan untuk pelanggan Anda kemudian modul rencana pembayaran kami adalah untuk Anda:<p><b>Penagihan-> bagian rencana pembayaran</b>',0),(453435,12596,'nl','Als u wilt instellen terugkerende is facturering voor uw klanten dan onze betaling plan module voor jou:<p><b>Facturering-> sectie betaling plannen</b>',0),(453436,12596,'fi','Jos haluat perustaa toistuvia laskutus asiakkaillesi sitten maksu suunnitelman moduuli on sinulle:<p><b>Laskutus-> Maksu suunnitelmat jakso</b>',0),(453437,12596,'no','Du kan sette opp gjentakende er fakturering for dine kunder sÃ¥ vÃ¥r betaling plan modul for deg:<p><b>Fakturering-> betaling planer delen</b>',0),(453438,12596,'da','Hvis du Ã¸nsker at oprette tilbagevendende er fakturering for dine kunder sÃ¥ vores betalingsmodul plan for dig:<p><b>Fakturering-> betaling planer sektion</b>',0),(453439,12596,'ko','ë˜í’€ì´ë¥¼ ì„¤ì • í•˜ë ¤ëŠ” ê²½ìš° ë‹¤ìŒ ìš°ë¦¬ì˜ ì§€ë¶ˆ ê³„íš ëª¨ë“ˆ ê³ ê°ì— ëŒ€ í•œ ì²­êµ¬ ë‹¹ì‹ ì„ ìœ„í•´ ì´ë‹¤:<p><b>ê²°ì œ ì§€ë¶ˆ ê³„íš ì„¹ì…˜-></b>',0),(453440,12596,'he','×× ×‘×¨×¦×•× ×š ×œ×”×’×“×™×¨ ×›×—×•×–×¨×•×ª ×—×™×•×‘ ×¢×‘×•×¨ ×”×œ×§×•×—×•×ª ×©×œ×š ×•××– ×ž×•×“×•×œ ×”×ª×•×›× ×™×ª ×©×œ× ×• ×ª×©×œ×•× ×–×” ×‘×©×‘×™×œ×š:<p><b>×—×™×•×‘-> ×ž×“×•×¨ ×ª×›× ×™×•×ª ×”×ª×©×œ×•×ž×™×</b>',0),(453441,12596,'el','Î‘Î½ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î¿ÏÎ¯ÏƒÎµÏ„Îµ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÏƒÎ±Ï‚, ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î±, Î¼Î±Ï‚ ÎµÎ½ÏŒÏ„Î·Ï„Î± ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ ÎµÎ¯Î½Î±Î¹ Î³Î¹Î± ÏƒÎ±Ï‚:<p><b>Î§ÏÎ­Ï‰ÏƒÎ·Ï‚-> Ï€Î',0),(453442,12596,'zh','å¦‚æžœæ‚¨è¦ä¸ºæ‚¨çš„å®¢æˆ·è®¾ç½®ç»­è®¢ä»˜è´¹ï¼Œé‚£ä¹ˆæˆ‘ä»¬çš„ä»˜æ¬¾è®¡åˆ’æ¨¡å—æ­£ç¬¦åˆæ‚¨è¦æ±‚ï¼šå…¥è´¦->ä»˜æ¬¾è®¡åˆ’éƒ¨åˆ†ã€‚',0),(453443,12596,'sv','Om du vill stÃ¤lla in Ã¥terkommande Ã¤r fakturering fÃ¶r dina kunder sedan vÃ¥r betalning plan modul fÃ¶r dig:<p><b>Fakturering-> betalning planer avsnitt</b>',0),(453444,12596,'it','Se si desidera impostare ricorrenti di fatturazione per i vostri clienti quindi il nostro modulo del piano di pagamento Ã¨ per voi:<p><b>Fatturazione-> sezione piani di pagamento</b>',0),(453445,12596,'tl','',0),(453446,12596,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸à¸²à¸£à¹€à¸à¸´à¸”à¸‹à¹‰à¸³ à¸—à¸µà¹ˆà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²à¸‚à¸­à¸‡à¸„à¸¸à¸“à¹à¸¥à¹‰à¸§à¹‚à¸¡à¸”à¸¹à¹à¸œà¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸',0),(453447,12596,'hi','à¤…à¤ªà¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¤®à¤¾à¤°à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤¤à¤¬ à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤¤à¥à¤®à¥à¤¹à¤¾à¤°à¥‡ à¤²à¤¿à¤ à¤¹à¥ˆ à¤…à¤—à¤° à¤†à¤ª à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤Šà¤ªà¤° à',0),(453448,12596,'ms','Jika anda hendak menyediakan berulang bil untuk pelanggan-pelanggan anda kemudian modul pelan pembayaran kami adalah untuk anda:<p><b>Bil-> Seksyen bayaran pelan</b>',0),(453449,12596,'ar','Ø¥Ø°Ø§ ÙƒÙ†Øª ØªØ±ØºØ¨ ÙÙŠ Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…ØªÙƒØ±Ø±Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø«Ù… ÙˆØ­Ø¯Ø© Ø®Ø·Ø© Ø§Ù„Ø¯ÙØ¹ Ù„Ø¯ÙŠÙ†Ø§ Ø¨Ø§Ù„Ù†Ø³Ø¨Ø© Ù„Ùƒ:<p><b>Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ù‚Ø³Ù… \"Ø®Ø·Ø· Ø§Ù„Ø¯ÙØ¹\"</b>',0),(453450,12596,'fr','Si vous souhaitez configurer rÃ©currents de facturation pour vos clients puis notre module de paiement plan est fait pour vous :<p><b>Facturation-> section des Plans de paiement</b>',0),(453451,12596,'jp','ç¹°ã‚Šè¿”ã—ã‚’è¨­å®šã™ã‚‹å ´åˆã¯ç§ãŸã¡ãŠæ”¯æ‰•ã„ãƒ—ãƒ©ãƒ³ ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã—ãŠå®¢æ§˜ã®è«‹æ±‚ã¯ã€ä»¥ä¸‹<p><b>ã€Œæ”¯æ‰•ãƒ—ãƒ©ãƒ³ã€ã‚»ã‚¯ã‚·ãƒ§ãƒ³-> è«‹æ±‚</b>',0),(453452,12596,'pt','Se vocÃª deseja configurar recorrentes faturamento para seus clientes entÃ£o nosso mÃ³dulo de plano de pagamento Ã© para vocÃª:<p><b>Faturamento-> seÃ§Ã£o planos de pagamento</b>',0),(453453,12596,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³ Ð´Ð»Ñ Ð²Ð°ÑˆÐ¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð², Ñ‚Ð¾Ð³Ð´Ð° Ð½Ð°Ñˆ Ð¼Ð¾Ð´ÑƒÐ»ÑŒ Ð¿Ð»Ð°Ð½ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð´Ð»Ñ Ð²Ð°Ñ:<p><b>Ð‘Ð¸Ð»Ð»Ð¸Ð½Ð³-> ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð¿Ð»Ð°Ð½Ñ‹ ',0),(453454,12596,'es','Si quiere configurar facturaciÃ³n recurrente para sus clientes entonces  nuestra modulo de plan de pagos es para ti:<p><b>FacturaciÃ³n ->SecciÃ³n de Planes de Pago</b>',0),(453455,12596,'de','Wenn Sie wiederkehrende einrichten mÃ¶chten ist die Abrechnung fÃ¼r Ihre Kunden dann unsere Zahlung Plan Modul fÃ¼r Sie:<p><b>Abrechnung-> Zahlung PlÃ¤ne Abschnitt</b>',0),(453456,12596,'en','If you want to set up recurring billing for your customers then our payment plan module is for you:<p><b>Billing -> Payment Plans section</b>',0),(453457,12597,'is','',0),(453458,12597,'dr','Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± Ø­Ø°Ù ÙØ§Ú©ØªÙˆØ± Ø´Ù…Ø§ Ø§ÙˆÙ„ Ø¨Ø§ÛŒØ¯ Ù‡Ø± Ú¯ÙˆÙ†Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø³Øª Ú©Ù‡ Ø¨Ù‡ Ø¢Ù† Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯Ù‡ Ø¨Ø§Ø·Ù„:<p><b>-> ÙØ§Ú©ØªÙˆØ±-> Ø®Ø§Ù„ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨</b><p>Ø§Ú©Ù†ÙˆÙ† reaccess ÙØ§Ú©ØªÙˆØ± Ùˆ Ø§Ù†ØªØ®Ø§Ø¨ Ø³',0),(453459,12597,'pr','Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± Ø­Ø°Ù ÙØ§Ú©ØªÙˆØ± Ø´Ù…Ø§ Ø§ÙˆÙ„ Ø¨Ø§ÛŒØ¯ Ù‡Ø± Ú¯ÙˆÙ†Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø³Øª Ú©Ù‡ Ø¨Ù‡ Ø¢Ù† Ø§Ø¹Ù…Ø§Ù„ Ø´Ø¯Ù‡ Ø¨Ø§Ø·Ù„:<p><b>-> ÙØ§Ú©ØªÙˆØ±-> Ø®Ø§Ù„ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨</b><p>Ø§Ú©Ù†ÙˆÙ† reaccess ÙØ§Ú©ØªÙˆØ± Ùˆ Ø§Ù†ØªØ®Ø§Ø¨ Ø³',0),(453460,12597,'tr','Fatura silme iÃ§in bu konuda iÃ§in uygulanan herhangi bir Ã¶deme geÃ§ersiz:<p><b>Fatura fatura Ã¶demeleri Void->-></b><p>Åžimdi fatura engellendiÄŸini ile ve seÃ§me \'un-post\'. O-ebilmek var olmak silmek ÅŸimdi.',0),(453461,12597,'pl','Aby usunÄ…Ä‡ fakturÄ™, najpierw naleÅ¼y uniewaÅ¼niÄ‡ wszelkie pÅ‚atnoÅ›ci, ktÃ³re zostaÅ‚y zastosowane do niego na:<p><b>PÅ‚atnoÅ›ci-> faktury-> niewaÅ¼ne pÅ‚atnoÅ›ci</b><p>Teraz ponownego dostÄ™pu faktury i wybierz \'un-post \". Teraz mogÄ… byÄ‡ usuniÄ™te.',0),(453462,12597,'bg','Ð—Ð° Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿ÑŠÑ€Ð²Ð¾ Ð´Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ, ÐºÐ¾Ð¸Ñ‚Ð¾ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸ ÐºÑŠÐ¼ Ð½ÐµÐ³Ð¾ Ð²:<p><b>Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸-> Ð½ÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ Ð¿',0),(453463,12597,'ur','Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ø­Ø°Ù Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ØŒ Ø¢Ù¾ Ú©Ùˆ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ú©Ø³ÛŒ Ù‚Ø³Ù… Ú©Ø§ Ù…Ø¹Ø§ÙˆØ¶Û Ø¬Ùˆ Ø§Ø³ Ù¾Ø± Ù„Ú¯Ø§Ø¦Û’ Ú¯Ø¦Û’ ÛÛŒÚº ØµÙØ± Ú†Ø§ÛÛŒÛ’:<p><b>Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ø§Ø·Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ->-></b><p>',0),(453464,12597,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ, Ð¿Ñ€Ð²Ð¾ Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‚Ðµ Ð½ÐµÐºÐµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ ÐºÐ¾Ñ˜Ðµ ÑÑƒ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð´Ð°, Ð½Ð°:<p><b>Ð—Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð° Ð¸ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ</',0),(453465,12597,'vi','Äá»ƒ xÃ³a 1 hÃ³a Ä‘Æ¡n,trÆ°á»›c tiÃªn báº¡n pháº£i lÃ m vÃ´ hiá»‡u hÃ³a cÃ¡c khoáº£n thanh toÃ¡n: Thanh toÃ¡n-> hÃ³a Ä‘Æ¡n-> vÃ´ hiá»‡u hÃ³a cÃ¡c khoáº£n thanh toÃ¡n. Truy cáº­p loáº¡i hÃ³a Ä‘Æ¡n vÃ  chá»n \"un-post\". giá» nÃ³ cÃ³ thá»ƒ Ä‘Æ°á»£c xÃ³a',0),(453466,12597,'af','Om \'n faktuur te skrap, moet jy enige betalings wat toegepas is om dit by eerste void:<p><b>Fakturering-> fakture-> leemte betalings</b><p>Reaccess die faktuur nou en kies \'un-pos \'. Dit kan nou geskrap word nie.',0),(453467,12597,'ro','Pentru a ÅŸterge o facturÄƒ, trebuie sÄƒ anula prima orice plÄƒÅ£i care au fost aplicate la:<p><b>Facturare-> facturi-> nul plÄƒÅ£i</b><p>Acum reaccess facturÄƒ ÅŸi selectaÅ£i \'un-post \". Acum poate fi sters.',0),(453468,12597,'et','Arve kustutamiseks tuleb esmalt tÃ¼histada makseid, mis on seotud selle juures:<p><b>-> Arvete-> tÃ¼hine maksete arved</b><p>NÃ¼Ã¼d reaccess arve ning valige sissemaksemÃ¤Ã¤r-post \". See saab nÃ¼Ã¼d kustutada.',0),(453469,12597,'si','ÄŒe Å¾elite izbrisati raÄun, mora najprej niÄna plaÄila, ki so bili uporabljeni za to na:<p><b>ZaraÄunavanje-> raÄuni-> niÄna plaÄila</b><p>Zdaj moÅ¾nost raÄun in izberite \'un-post \". To lahko izbrisano.',0),(453470,12597,'ba','Untuk menghapus faktur, Anda harus terlebih dahulu void setiap pembayaran yang telah diterapkan untuk itu di:<p><b>Penagihan-> faktur-> Batal pembayaran</b><p>Sekarang reaccess faktur dan pilih \'un-post\'. Ini sekarang dapat dihapus.',0),(453471,12597,'nl','Om een factuur te verwijderen, moet u eerst eventuele betalingen die zijn toegepast om het op te vernietigen:<p><b>Facturering-> facturen-> vervallen betalingen</b><p>Nu reaccess van de factuur en selecteer \'un-post\'. Het kan nu worden verwijderd.',0),(453472,12597,'fi','Jotta poistaa laskun mitÃ¤tÃ¶it maksut, jotka on kohdistettu sitÃ¤:<p><b>Laskutus-> laskujen-> mitÃ¤tÃ¶n maksut</b><p>Nyt reaccess lasku ja valitse un-post \". Se voi nyt poistaa.',0),(453473,12597,'no','For Ã¥ slette en faktura, mÃ¥ du fÃ¸rst annullere alle betalinger som er brukt til det pÃ¥:<p><b>Fakturering-> fakturaer-> annullert betaling</b><p>NÃ¥ reaccess fakturaen og velg un-post \". Det kan nÃ¥ bli slettet.',0),(453474,12597,'da','For at slette en faktura, skal du fÃ¸rst annullere eventuelle betalinger, der er blevet anvendt til det pÃ¥:<p><b>Fakturering-> fakturaer-> Void betalinger</b><p>Nu Forbyd fakturaen og vÃ¦lg \'un-post\'. Det kan nu blive slettet.',0),(453475,12597,'ko','ì²­êµ¬ì„œë¥¼ ì‚­ì œ í•˜ê¸° ìœ„í•˜ì—¬ ì²˜ìŒì— ê·¸ê²ƒì— ì ìš© ëœ ëª¨ë“  ì§€ë¶ˆì„ ë¬´íš¨í™” í•´ì•¼ í•©ë‹ˆë‹¤.<p><b>ì†¡ìž¥ Void ì§€ë¶ˆ->-> ê²°ì œ</b><p>ì´ì œ ì†¡ìž¥ ì—¬ ê³  ìœ ì—” ê²Œì‹œë¬¼ ì„ íƒ \'. ê·¸ê²ƒì€ ì§€ê¸ˆ ì‚­ì œí•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(453476,12597,'he','×›×“×™ ×œ×ž×—×•×§ ×—×©×‘×•× ×™×ª, ×¢×œ×™×š ×œ×©×œ×•×œ ×§×•×“× ×›×œ ×”×ª×©×œ×•×ž×™× ××©×¨ ×”×•×—×œ×• ×¢×œ ×–×”:<p><b>×—×™×•×‘-> ×—×©×‘×•× ×™×•×ª-> ×ª×©×œ×•×ž×™× Void</b><p>×¢×›×©×™×• reaccess ××ª ×”×—×©×‘×•× ×™×ª ×•×‘×—×¨ ×™×œ×“-×¤×•×¡×˜ \'. ×–×” ×¢×›×',0),(453477,12597,'el','Î“Î¹Î± Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î­Î½Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿, Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€ÏÏŽÏ„Î± Î½Î± Î±ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Î¿Ï€Î¿Î¹ÎµÏƒÎ´Î®Ï€Î¿Ï„Îµ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÏ†Î±ÏÎ¼Î¿ÏƒÏ„ÎµÎ¯ ÏƒÎµ Î±Ï…Ï„ÏŒ ÏƒÏ„Î¿:<p><b>Î§ÏÎ­Ï‰ÏƒÎ·Ï‚-> Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î',0),(453478,12597,'zh','è¦åˆ é™¤å‘ç¥¨ï¼Œæ‚¨å¿…é¡»é¦–å…ˆåºŸé™¤æ‰€æœ‰å·²ç»åº”ç”¨åˆ°å…¶çš„ä»˜æ¬¾ï¼šå…¥è´¦->å‘ç¥¨->åºŸé™¤ä»˜æ¬¾\r\nçŽ°åœ¨é‡æ–°è®¿é—®å‘ç¥¨å¹¶é€‰æ‹©â€œä¸å‘å¸ƒâ€ã€‚å®ƒçŽ°åœ¨å°†å¯ä»¥è¢«åˆ é™¤ã€‚',0),(453479,12597,'sv','FÃ¶r att ta bort en faktura, mÃ¥ste du fÃ¶rst makulera alla betalningar som har tillÃ¤mpat den pÃ¥:<p><b>Fakturering-> fakturor-> ogiltiga betalningar</b><p>Nu komma fakturan och vÃ¤lj \'un-post \". Det kan nu tas bort.',0),(453480,12597,'it','Per eliminare una fattura, devono prima annullare eventuali pagamenti che sono stati applicati a:<p><b>Fatturazione-> fatture-> Void pagamenti</b><p>Ora nuovamente la fattura e selezionare \' un-post\'. Ora puÃ² essere eliminato.',0),(453481,12597,'tl','',0),(453482,12597,'th','à¸¥à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹‚à¸¡à¸†à¸°à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¹ƒà¸Šà¹‰à¹„à¸›à¸—à¸µà¹ˆ:<p><b>->à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰->à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸¢à¸à¹€à¸¥à¸´à¸à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€',0),(453483,12597,'hi','à¤à¤• à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤, à¤†à¤ª à¤ªà¤¹à¤²à¥€ à¤¬à¤¾à¤° à¤•à¥‹à¤ˆ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤° à¤‡à¤¸à¥‡ à¤²à¤¾à¤—à¥‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾:<p><b>à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤šà¤¾à¤²',0),(453484,12597,'ms','Untuk menghapuskan invois, anda mesti terlebih dahulu membatalkan apa-apa bayaran yang telah digunakan untuk ia di:<p><b>Bil-> invois-> pembayaran tidak sah</b><p>Sekarang reaccess invois dan pilih \'un-post\'. Ia kini boleh dipadamkan.',0),(453485,12597,'ar','Ø¨ØºÙŠØ© Ø­Ø°Ù ÙØ§ØªÙˆØ±Ø©ØŒ ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø£ÙˆÙ„Ø§Ù‹ Ø¨Ø§Ø·Ù„ Ø£ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… ØªØ·Ø¨ÙŠÙ‚Ù‡Ø§ Ù„Ø£Ù†Ù‡Ø§ ÙÙŠ:<p><b>Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> ÙÙˆØ§ØªÙŠØ±-> Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¨Ø§Ø·Ù„Ø©</b><p>Ø§Ù„Ø¢Ù† Ø¥Ø¹Ø§Ù‚ØªÙ‡ Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙˆØ­',0),(453486,12597,'fr','Afin de supprimer une facture, vous devez tout d\'abord invalider tous les paiements qui ont Ã©tÃ© appliquÃ©s lors :<p><b>Facturation-> factures-> paiements Sub</b><p>Maintenant accÃ¨s Ã  la facture l\'impossibilitÃ© et sÃ©lectionnez un post\'. Il peut Ãªtre',0),(453487,12597,'jp','è«‹æ±‚æ›¸ã‚’å‰Šé™¤ã™ã‚‹ãŸã‚ã«æœ€åˆã«ãã‚Œã«é©ç”¨ã•ã‚Œã¦ã„ã‚‹ä»»æ„ã®æ”¯æ‰•ã„ã‚’ç„¡åŠ¹ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚<p><b>->-> Void æ”¯æ‰•ã„è«‹æ±‚æ›¸è«‹æ±‚</b><p>ä»Š \'un ã®ãƒã‚¹ãƒˆã‚’é¸æŠžã—ã¦ã€è«‹æ±‚æ›¸ã®ã‚¢ã‚¯ã‚»ã‚¹ \'ã€‚ä»Šã™ãå‰Š',0),(453488,12597,'pt','Para excluir uma fatura, vocÃª primeiro deve anular qualquer pagamento que tenha sido aplicado a ele em:<p><b>Faturamento-> facturas-> Void pagamentos</b><p>Agora aplicar a factura e selecione un-post\'. Agora pode ser excluÃ­da.',0),(453489,12597,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ, Ð²Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐ½Ð°Ñ‡Ð°Ð»Ð° Ð»Ð¸ÑˆÐ¸Ñ‚ÑŒ Ð»ÑŽÐ±Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð±Ñ‹Ð»Ð¸ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÐµÐ½Ñ‹ Ðº Ð½ÐµÐ¼Ñƒ Ð½Ð°:<p><b>Ð‘Ð¸Ð»Ð»Ð¸Ð½Ð³-> ÑÑ‡ÐµÑ‚Ð¾Ð²-> Void Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸</b><p>Ð¢ÐµÐ¿ÐµÑ€ÑŒ Ð¿Ð',0),(453490,12597,'es','Para eliminar una factura, primero debe anular algunos pagos se habian aplicados a ella a.<p><b>FacturaciÃ³n ->Facturas -> Anular Pagos</b><p>Ahora reacessar la factura y selecciona \'desasentar\'. Ahora se puede eliminarla.',0),(453491,12597,'de','Um eine Rechnung zu lÃ¶schen, mÃ¼ssen Sie zuerst alle Zahlungen erlischt, die es bei angewendet wurden:<p><b>Abrechnung-> Rechnungen-> Void Zahlungen</b><p>Nun erneut die Rechnung auf Sie zuzugreifen, und wÃ¤hlen Sie un-Post \". Es kann jetzt gelÃ¶scht wer',0),(453492,12597,'en','In order to delete an invoice, you must first void any payments that have been applied to it at:<p><b>Billing -> Invoices -> Void Payments</b><p>Now reaccess the invoice and select \'un-post\'. It can now be deleted.',0),(453493,12598,'is','',0),(453494,12598,'dr','Ú©Ø§Ù‡Ø´ Ù‚ÛŒÙ…Øª Ù…Ø´ØªØ±ÛŒ Ø§Ù†Ø¬Ø§Ù… Ù…ÛŒ Ø´ÙˆØ¯ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú¯Ø±ÙˆÙ‡ Ù…Ø´ØªØ±ÛŒ<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ùˆ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-> Ú¯Ø±ÙˆÙ‡ Ù…Ø´ØªØ±ÛŒ</b><p>Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ Ù†Ø§Ù… Ù…Ø§Ù†Ù†Ø¯ ØªØ®ÙÛŒÙ Ø§Ø±Ø´Ø¯ Ø³Ù¾Ø³ ØªØ¹ÛŒ',0),(453495,12598,'pr','Ú©Ø§Ù‡Ø´ Ù‚ÛŒÙ…Øª Ù…Ø´ØªØ±ÛŒ Ø§Ù†Ø¬Ø§Ù… Ù…ÛŒ Ø´ÙˆØ¯ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú¯Ø±ÙˆÙ‡ Ù…Ø´ØªØ±ÛŒ<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ùˆ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-> Ú¯Ø±ÙˆÙ‡ Ù…Ø´ØªØ±ÛŒ</b><p>Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ Ù†Ø§Ù… Ù…Ø§Ù†Ù†Ø¯ ØªØ®ÙÛŒÙ Ø§Ø±Ø´Ø¯ Ø³Ù¾Ø³ ØªØ¹ÛŒ',0),(453496,12598,'tr','MÃ¼ÅŸteri fiyat indirimleri yapÄ±lÄ±r mÃ¼ÅŸteri gruplarÄ± kullanma<p><b>YÃ¶netici Kurulumu-fatura mÃ¼ÅŸteri gruplarÄ±->-></b><p>KÄ±demli indirim gibi bir ad girin, sonra bu indirimle sahip olmak istediÄŸiniz mÃ¼ÅŸterilerin atayÄ±n:<p><b>Ä°lgili kiÅŸileri ',0),(453497,12598,'pl','ObniÅ¼ki cen klienta odbywa siÄ™ za pomocÄ… grup klientÃ³w<p><b>Admin-> instalacji Billing-> grup klientÃ³w</b><p>Wpisz nazwÄ™, na przykÅ‚ad starszego zniÅ¼ki, a nastÄ™pnie przypisaÄ‡ klientÃ³w trzeba ten rabat na:<p><b>Kontakty-> klienci-> WyÅ›wietl/Edyt',0),(453498,12598,'bg','ÐÐ°Ð¼Ð°Ð»ÐµÐ½Ð¸Ñ Ð½Ð° Ñ†ÐµÐ½Ð¸Ñ‚Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÐµ Ð¸Ð·Ð²ÑŠÑ€ÑˆÐ²Ð° Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰Ñ‚Ð° Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> Ð³Ñ€ÑƒÐ¿Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸</b><p>Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ',0),(453499,12598,'ur','Ú¯Ø§ÛÚ© Ù‚ÛŒÙ…Øª Ù…ÛŒÚº Ú©Ù¹ÙˆØªÛŒ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ú©Ø§Ù… Ú©Ø±ØªÛŒ ÛÛŒÚº Ú¯Ø§ÛÚ© Ú¯Ø±ÙˆÙ¾Ø³ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’<p><b>Ø§ÛŒÚˆÙ…Ù† Ø³ÛŒÙ¹ Ø§Ù¾-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø³Ù¹Ù…Ø± Ú¯Ø±ÙˆÙ¾Ø³->-></b><p>Ø§ÛŒÚ© Ø³ÛŒÙ†Ø¦Ø± Ú†Ú¾ÙˆÙ¹ØŒ Ø¬ÛŒØ³Û',0),(453500,12598,'sr','Ð¡Ð¼Ð°ÑšÐµÑšÐµ Ñ†ÐµÐ½Ð° ÐºÑƒÐ¿Ñ†Ð° ÑÑƒ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸ ÐºÐ¾Ñ€Ð¸ÑÑ‚ÐµÑ›Ð¸ Ð³Ñ€ÑƒÐ¿Ðµ ÐºÑƒÐ¿Ð°Ñ†Ð°<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ-Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ Ð³Ñ€ÑƒÐ¿Ðµ ÐºÑƒÐ¿Ð°Ñ†Ð°</b><p>Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸Ð¼Ðµ, ÐºÐ°Ð¾ ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð¡ÐµÐ½Ð¸Ð¾Ñ€ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°, ',0),(453501,12598,'vi','Giáº£m giÃ¡ khÃ¡ch hÃ ng Ä‘Æ°á»£c thá»±c hiá»‡n báº±ng cÃ¡ch sá»­ dá»¥ng nhÃ³m khÃ¡ch hÃ ng: quáº£n trá»‹->thiáº¿t láº­p thanh toÃ¡n-> nhÃ³m khÃ¡ch hÃ ng-> nháº­p 1 tÃªn nhÆ° lÃ  giáº£m giÃ¡ Ä‘áº·c biá»‡t, sau Ä‘Ã³ báº¡n chá»‰ Ä‘á»‹nh khÃ¡ch hÃ ng mÃ  bï¿',0),(453502,12598,'af','KliÃ«nt prysverlagings is gedoen met behulp van kliÃ«nt groepe<p><b>Admin-> opstel-fakturering-> kliÃ«nt groepe</b><p>Tik \'n naam, soos Senior afslag, dan wys die kliÃ«nte wat jy wil hÃª hierdie afslag by:<p><b>Kontakte-> kliÃ«nte-> / Redigeer aansig</b>',0),(453503,12598,'ro','Reducerile de preÅ£ client sunt fÄƒcut utilizÃ¢nd grupuri de clienÅ£i<p><b>Admin-> Setup-facturare-> grupuri de clienÅ£i</b><p>IntroduceÅ£i un nume, cum ar fi Senior Discount, apoi atribuiÅ£i clienÅ£ii pe care doriÅ£i sÄƒ aveÅ£i aceastÄƒ reducere la:<p><b',0),(453504,12598,'et','Kliendi hinnaalanduste lÃµpetanud kasutades KliendirÃ¼hmad<p><b>Admin-> Setup-arved-> KliendirÃ¼hmad</b><p>Sisestage nimi, nÃ¤iteks kÃµrgemate allahindlust, siis mÃ¤Ã¤rata teistele seda soodustust hotelli:<p><b>Kontaktid-> hotelli Vaata/Muuda-></b>',0),(453505,12598,'si','KonÄali zniÅ¾anje cen za kupca z uporabo skupine kupcev<p><b>Admin-> Setup-zaraÄunavanje-> skupine kupcev</b><p>Vnesite ime, kot viÅ¡ji popust, nato dodelite kupce, Å¾elite imeti ta popust na:<p><b>Stiki-> stranke-> ogled/urejanje</b>',0),(453506,12598,'ba','Penurunan harga pelanggan dilakukan menggunakan kelompok pelanggan<p><b>Admin-> Setup-penagihan-> kelompok pelanggan</b><p>Masukkan nama, seperti diskon Senior, kemudian menetapkan pelanggan Anda ingin memiliki diskon ini di:<p><b>Kontak-> pelanggan-> Lih',0),(453507,12598,'nl','Klant prijsverlagingen zijn gedaan met behulp van klantgroepen<p><b>Admin-> Setup-Billing-> klantgroepen</b><p>Voer een naam, zoals Senior korting, en de klanten die u wilt hebben deze korting op toewijzen:<p><b>Contacten-> klanten-> bekijken/bewerken</b>',0),(453508,12598,'fi','Asiakkaan hinnanalennukset tehdÃ¤Ã¤n kÃ¤yttÃ¤en asiakasryhmÃ¤t<p><b>Admin-> mÃ¤Ã¤ritettÃ¤vÃ¤ laskutus-> asiakasryhmÃ¤t</b><p>Kirjoita nimi, kuten Senior alennus, sitten mÃ¤Ã¤rittÃ¤Ã¤ asiakkaille, haluat saada tÃ¤mÃ¤n alennuksen:<p><b>Yhteystiedot-> asiakk',0),(453509,12598,'no','Kunden prisreduksjoner utfÃ¸res ved hjelp av kundegrupper<p><b>Admin-> Setup-fakturering-> kundegrupper</b><p>Oppgi et navn som Senior rabatt, og deretter tilordne kundene du vil ha denne rabatten pÃ¥:<p><b>Kontakter-> kunder-> Vis/Rediger</b>',0),(453510,12598,'da','Kunde prisnedsÃ¦ttelser er gjort ved hjÃ¦lp af kundegrupper<p><b>Admin-> Setup-fakturering-> kundegrupper</b><p>Indtast et navn, som Senior rabat, og derefter tildele de kunder, du vil have denne rabat pÃ¥:<p><b>Kontakter-> gÃ¦ster-> Vis/Rediger</b>',0),(453511,12598,'ko','ê³ ê° ê°€ê²© ì¸í•˜ í•´ ê³ ê° ê·¸ë£¹ì„ ì‚¬ìš© í•˜ ì—¬<p><b>ê´€ë¦¬ìž ì„¤ì •-ê²°ì œ ê³ ê° ê·¸ë£¹->-></b><p>ìˆ˜ì„ í• ì¸, ê°™ì€ ì´ë¦„ì„ ìž…ë ¥ í•œ ë‹¤ìŒ ê³ ê°ì—ì´ í• ì¸ì„ ê°–ê³  ì‹¶ì–´ í• ë‹¹:<p><b>ì—°ë½ì²˜-> ë³´ê¸°/íŽ¸ì§‘-> ê³ ê°</b>',0),(453512,12598,'he','×”×¤×—×ª×•×ª ×ž×—×™×¨×™× ×œ×§×•×—×•×ª × ×¢×©×™× ×‘××ž×¦×¢×•×ª ×§×‘×•×¦×•×ª ×œ×§×•×—×•×ª<p><b>Admin-> ×”×”×ª×§× ×”-×—×™×•×‘-> ×§×‘×•×¦×•×ª ×œ×§×•×—×•×ª</b><p>×”×–×Ÿ ×©×, ×›×’×•×Ÿ ×”× ×—×” ×‘×›×™×¨, ×•×œ××—×¨ ×ž×›×Ÿ ×œ×”×§×¦×•×ª ××ª ×”×œ×§×•×—×•×ª ×©×',0),(453513,12598,'el','ÎœÎµÎ¯Ï‰ÏƒÎ· Ï„Ï‰Î½ Ï„Î¹Î¼ÏŽÎ½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ Î³Î¯Î½Î¿Î½Ï„Î±Î¹ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Î¿Î¼Î¬Î´ÎµÏ‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚-> Î¿Î¼Î¬Î´ÎµÏ‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½</b><p>Î Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î±',0),(453514,12598,'zh','å®¢æˆ·å®šä»·é™ä½Žä»¥å®Œæˆï¼Œä½¿ç”¨å®¢æˆ·ç»„ï¼šç®¡ç†->è®¾ç½®å…¥è´¦->å®¢æˆ·ç»„ã€‚\r\nè¾“å…¥ä¸€ä¸ªåç§°ï¼Œä¾‹å¦‚é«˜çº§æŠ˜æ‰£ï¼Œç„¶åŽåˆ†é…ç»™ä½ è¦çš„å®¢æˆ·æŠ˜æ‰£ï¼Œåœ¨ï¼šè”ç³»->å®¢æˆ·->æŸ¥çœ‹/ç¼–è¾‘',0),(453515,12598,'sv','Kunden prissÃ¤nkningar gÃ¶rs med hjÃ¤lp av kundgrupper<p><b>Admin-> Setup-fakturering-> kundgrupper</b><p>Ange ett namn, som Senior rabatt, och sedan tilldela de kunder som du vill ha denna rabatt pÃ¥:<p><b>Kontakter-> kunder-> Visa/redigera</b>',0),(453516,12598,'it','Riduzioni di prezzo del cliente vengono eseguite utilizzando gruppi di clienti<p><b>Admin-> Setup-fatturazione-> gruppi di clienti</b><p>Immettere un nome, come Senior sconto, quindi assegnare i clienti che si desidera avere questo sconto presso:<p><b>Con',0),(453517,12598,'tl','',0),(453518,12598,'th','à¸¥à¸”à¸£à¸²à¸„à¸²à¸¥à¸¹à¸à¸„à¹‰à¸²à¸ˆà¸°à¸—à¸³à¹‚à¸”à¸¢à¹ƒà¸Šà¹‰à¸à¸¥à¸¸à¹ˆà¸¡à¸¥à¸¹à¸à¸„à¹‰à¸²<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™->à¸à¸¥à¸¸à¹ˆà¸¡à¸¥à¸¹à¸à¸„à¹‰à¸²</b><p>à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­ à¹€à¸Šà¹ˆà¸™à¸ªà¹ˆà',0),(453519,12598,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¥‚à¤²à¥à¤¯ à¤®à¥‡à¤‚ à¤•à¤Ÿà¥Œà¤¤à¥€ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¤¾<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª-à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸',0),(453520,12598,'ms','Penurunan harga pelanggan akan dilakukan menggunakan Kumpulan pelanggan<p><b>Admin-> persediaan-bil-> Kumpulan pelanggan</b><p>Masukkan nama, seperti diskaun kanan, maka peruntukkan pelanggan yang anda mahu mempunyai diskaun ini pada:<p><b>Kenalan-> pelan',0),(453521,12598,'ar','ÙŠØªÙ… ØªØ®ÙÙŠØ¶ Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… \"Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡\"<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡</b><p>Ø£Ø¯Ø®Ù„ Ø§Ø³Ù…Ø§Ù‹ØŒ Ù…Ø«Ù„ \"ÙƒØ¨Ø§Ø± Ø§Ù„Ø®ØµÙ…\"ØŒ Ø«Ù… ØªØ¹ÙŠÙŠÙ† Ø§Ù',0),(453522,12598,'fr','Les rÃ©ductions de prix client sont effectuÃ©es Ã  l\'aide de groupes de clients<p><b>Admin-> Setup-facturation-> groupes de clients</b><p>Entrez un nom, comme principal Discount, puis affecter les clients Ã  que vous voulez avoir cette remise :<p><b>Conta',0),(453523,12598,'jp','é¡§å®¢å€¤å¼•ãã‚’è¡Œã£ã¦é¡§å®¢ã®ã‚°ãƒ«ãƒ¼ãƒ—ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—èª²é‡‘é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—->-></b><p>ã‚·ãƒ‹ã‚¢å‰²å¼•ãªã©ã®åå‰ã‚’å…¥åŠ›ã—ã€ã“ã®å‰²å¼•ã«ã—é¡§å®¢ã‚’å‰²ã‚Šå½“ã¦ã¾ã™ã€‚<p><b>é€£çµ¡å…ˆã®è¡¨ç¤º/',0),(453524,12598,'pt','ReduÃ§Ãµes de preÃ§o de cliente sÃ£o feitas usando grupos de clientes<p><b>Admin-> Setup-faturamento-> grupos de clientes</b><p>Insira um nome, como Senior de desconto, entÃ£o atribuir os clientes que vocÃª quer ter este desconto no:<p><b>Contatos-> clien',0),(453525,12598,'ru','Ð¡Ð½Ð¸Ð¶ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¾ÑÑƒÑ‰ÐµÑÑ‚Ð²Ð»ÑÐµÑ‚ÑÑ Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ Ð³Ñ€ÑƒÐ¿Ð¿ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³-> Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²</b><p>Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¸Ð¼Ñ, Ð½Ð°Ð¿Ñ€Ð¸Ð¼',0),(453526,12598,'es','Reducciones de precios de clientes ya terminaron usar Grupos de Clientes<p><b>Admin -> ConfiguraciÃ³n-FacturaciÃ³n -> Grupos de Clientes</b><p>Entra un nombre, como Descuento de Viejos, entonces asigna los clientes que quiere tener este descuento a:<p> <b',0),(453527,12598,'de','Kunden Preissenkungen erfolgen mit Kundengruppen<p><b>Admin-> Setup-Billing-> Kundengruppen</b><p>Geben Sie einen Namen wie Senior Rabatt, dann weisen Sie die Kunden soll dieser Rabatt an:<p><b>Kontakte-> Kunden-> anzeigen/bearbeiten</b>',0),(453528,12598,'en','Customer price reductions are done using Customer Groups<p><b>Admin -> Setup-Billing -> Customer Groups</b><p>Enter a name, such as Senior Discount, then assign the customers you want to have this discount at:<p> <b>Contacts -> Customers -> View/Edit ',0),(453529,12599,'is','',0),(453530,12599,'dr','',0),(453531,12599,'pr','',0),(453532,12599,'tr','',0),(453533,12599,'pl','',0),(453534,12599,'bg','',0),(453535,12599,'ur','',0),(453536,12599,'sr','',0),(453537,12599,'vi','',0),(453538,12599,'af','',0),(453539,12599,'ro','',0),(453540,12599,'et','',0),(453541,12599,'si','',0),(453542,12599,'ba','',0),(453543,12599,'nl','',0),(453544,12599,'fi','',0),(453545,12599,'no','',0),(453546,12599,'da','',0),(453547,12599,'ko','',0),(453548,12599,'he','',0),(453549,12599,'el','',0),(453550,12599,'zh','',0),(453551,12599,'sv','',0),(453552,12599,'it','',0),(453553,12599,'tl','',0),(453554,12599,'th','',0),(453555,12599,'hi','',0),(453556,12599,'ms','',0),(453557,12599,'ar','',0),(453558,12599,'fr','',0),(453559,12599,'jp','',0),(453560,12599,'pt','',0),(453561,12599,'ru','',0),(453562,12599,'es','',0),(453563,12599,'de','',0),(453564,12599,'en','',0),(453565,12600,'is','',0),(453566,12600,'dr','',0),(453567,12600,'pr','',0),(453568,12600,'tr','',0),(453569,12600,'pl','',0),(453570,12600,'bg','',0),(453571,12600,'ur','',0),(453572,12600,'sr','',0),(453573,12600,'vi','',0),(453574,12600,'af','',0),(453575,12600,'ro','',0),(453576,12600,'et','',0),(453577,12600,'si','',0),(453578,12600,'ba','',0),(453579,12600,'nl','',0),(453580,12600,'fi','',0),(453581,12600,'no','',0),(453582,12600,'da','',0),(453583,12600,'ko','',0),(453584,12600,'he','',0),(453585,12600,'el','',0),(453586,12600,'zh','',0),(453587,12600,'sv','',0),(453588,12600,'it','',0),(453589,12600,'tl','',0),(453590,12600,'th','',0),(453591,12600,'hi','',0),(453592,12600,'ms','',0),(453593,12600,'ar','',0),(453594,12600,'fr','',0),(453595,12600,'jp','',0),(453596,12600,'pt','',0),(453597,12600,'ru','',0),(453598,12600,'es','',0),(453599,12600,'de','',0),(453600,12600,'en','',0),(453601,12601,'is','',0),(453602,12601,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ Ù…ØªØ¹Ø¯Ø¯:<p>Ù…Ù‚Ø¯Ø§Ø± Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ú©Ø´ØªÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.<p>Ø­Ø§ØµÙ„ Ú©Ù†ÛŒØ¯ Ú©Ù‡ Ø´Ù…Ø§ Ø§Ù†Ø¬Ø§Ù… <b>Ù†Ù…ÛŒ</b> Ø¨Ø±Ø±Ø³ÛŒ Ø¬Ø¹Ø¨Ù‡ \"Ø³ÙØ§Ø±Ø´ Ú©Ø§Ù…Ù„ Ø§Ø³Øª\".<p>ÙˆÙ‚ØªÛŒ Ú©Ù‡ Ø´Ù…Ø§ Ø¢Ù…Ø§Ø¯Ù‡ Ø¨Ù‡ Ú©Ø´',0),(453603,12601,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ Ù…ØªØ¹Ø¯Ø¯:<p>Ù…Ù‚Ø¯Ø§Ø± Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ú©Ø´ØªÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.<p>Ø­Ø§ØµÙ„ Ú©Ù†ÛŒØ¯ Ú©Ù‡ Ø´Ù…Ø§ Ø§Ù†Ø¬Ø§Ù… <b>Ù†Ù…ÛŒ</b> Ø¨Ø±Ø±Ø³ÛŒ Ø¬Ø¹Ø¨Ù‡ \"Ø³ÙØ§Ø±Ø´ Ú©Ø§Ù…Ù„ Ø§Ø³Øª\".<p>ÙˆÙ‚ØªÛŒ Ú©Ù‡ Ø´Ù…Ø§ Ø¢Ù…Ø§Ø¯Ù‡ Ø¨Ù‡ Ú©Ø´',0),(453604,12601,'tr','Birden Ã§ok sevk irsaliyeleri:<p>Sevk etmek istediÄŸiniz miktarÄ± seÃ§in.<p>YaptÄ±ÄŸÄ±nÄ±zdan emin olun \"emri tamamlandÄ±\" kutusunu kontrol <b>deÄŸil</b> .<p>Kalan sevk etmeye hazÄ±r olduÄŸunuzda Ã¶ÄŸeleri gidin:<p><b>SipariÅŸleri madde sipariÅŸler gemi s',0),(453605,12601,'pl','Wielu przesyÅ‚ek:<p>Wybierz iloÅ›Ä‡, ktÃ³rÄ… chcesz wysÅ‚aÄ‡.<p>Upewnij siÄ™, Å¼e zrobisz <b>nie</b> zaznacz pole \"zamÃ³wienie jest juÅ¼ gotowe\".<p>Gdy jesteÅ› gotowy do wysyÅ‚ki, pozostaÅ‚e przedmioty przejdÅº do:<p><b>ZamÃ³wienia-> przedmiotu zamÃ³wieni',0),(453606,12601,'bg','ÐœÐ½Ð¾Ð¶ÐµÑÑ‚Ð²Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸:<p>Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾, ÐºÐ¾ÐµÑ‚Ð¾ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ñ‚Ðµ.<p>ÐÐµ Ð·Ð°Ð±Ñ€Ð°Ð²ÑÐ¹Ñ‚Ðµ Ð´Ð° <b>Ð½Ðµ</b> Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¿Ð¾Ð»ÐµÑ‚Ð¾ \"Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° ',0),(453607,12601,'ur','Ø§ÛŒÚ© Ø³Û’ Ø²ÛŒØ§Ø¯Û ØªØ±Ø³ÛŒÙ„:<p>Ø¬ÛØ§Ø² Ú©Û’ Ù„ÛŒÛ’ Ø­Ø³Ø¨ Ø®ÙˆØ§ÛØ´ Ù…Ù‚Ø¯Ø§Ø± Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Û”<p>Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ú©ÛŒØ§ <b>Ù†ÛÛŒÚº</b> \"ØªØ±ØªÛŒØ¨ Ù…Ú©Ù…Ù„ ÛÛ’\" Ø®Ø§Ù†Û Ù¾Ú‘ØªØ§Ù„ Û”<p>Ø¬Ø¨ Ø¢Ù¾ Ø¨Ø§Ù‚ÛŒ Ø¬ÛØ§Ø² Ú©Û',0),(453608,12601,'sr','Ð’Ð¸ÑˆÐµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ:<p>ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ ÐºÐ¾Ñ˜Ñƒ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚Ðµ.<p>Ð¡Ð²Ð°ÐºÐ°ÐºÐ¾ Ñ˜Ðµ <b>Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¾ÐºÐ²Ð¸Ñ€ \"Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° Ñ˜Ðµ ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½\"</b> .<p>ÐšÐ°Ð´Ð° Ð±ÑƒÐ´ÐµÑ‚Ðµ ÑÐ¿Ñ€ÐµÐ¼Ð½Ð¸ ',0),(453609,12601,'vi','Nhiá»u lÃ´ hÃ ng: Chá»n sá»‘ lÆ°á»£ng báº¡n muá»‘n xuáº¥t, Ä‘áº£m báº£o ráº±ng báº¡n khÃ´ng chá»n há»™p\" Ä‘Æ¡n hÃ ng Ä‘Ã£ hoÃ n thÃ nh\". Khi báº¡n Ä‘Ã£ sáºµ sÃ ng xuáº¥t máº·t hÃ ng cÃ²n láº¡i: Ä‘Æ¡n hÃ ng-Danh má»¥c Ä‘Æ¡n hÃ ng-xuáº¥t Ä‘Æ¡n hÃ ng',0),(453610,12601,'af','Meervoudige gestuur:<p>Kies die hoeveelheid wat jy wil skip.<p>Maak seker jy doen <b>nie</b> kontroleer die \"orde is voltooi\" blokkie.<p>Wanneer jy gereed is om die skip die oorblywende items gaan na:<p><b>Bestellings-> Item bestellings-> skip orde</b>',0),(453611,12601,'ro','Transporturilor multiple:<p>Alege cantitatea pe care doriÅ£i pentru a navei.<p>AsiguraÅ£i-vÄƒ cÄƒ tu a face <b>nu</b> a verifica cutie \"ordinea este completÄƒ\".<p>CÃ¢nd sunteÅ£i gata pentru a navei rÄƒmase elementele du-te la:<p><b>Comenzi-> element comen',0),(453612,12601,'et','Mitme saadetisi:<p>Vali laevade kogus.<p>Veenduge, et te ei <b>kontrolli \"tellimus on lÃµplik\" kasti</b> .<p>Kui olete valmis laeva Ã¼lejÃ¤Ã¤nud kirjed minna:<p><b>Tellimused-> kauba tellimuste-> laevatellimuselt</b>',0),(453613,12601,'si','VeÄ poÅ¡iljk:<p>Izberite koliÄino, ki jo Å¾elite ladjo.<p>Poskrbite za <b>potrditveno polje \"da je popoln\"</b> .<p>Ko ste pripravljeni za dobavo preostale elemente iti:<p><b>NaroÄila-> element naroÄila-> dobave naloga</b>',0),(453614,12601,'ba','Beberapa pengiriman:<p>Pilih jumlah yang Anda inginkan untuk kapal.<p>Pastikan Anda melakukan <b>tidak</b> centang kotak \"urutan lengkap\".<p>Ketika Anda siap untuk kapal sisa barang-barang pergi ke:<p><b>Perintah-> Item pesanan-> rangka kapal</b>',0),(453615,12601,'nl','Meerdere zendingen:<p>Kies het aantal dat u wilt verzenden.<p>Zorg ervoor dat u <b>niet</b> het vak \"bestelling is compleet\" selectievakje.<p>Wanneer u bent klaar om te verzenden de resterende ga objecten naar:<p><b>Bestellingen-> Item Orders-> schip volg',0),(453616,12601,'fi','Useita toimitukset:<p>Valitse mÃ¤Ã¤rÃ¤, jonka haluat lÃ¤hettÃ¤Ã¤.<p>Ettet <b>ole</b> valintaruutu \"tilaus on valmis\".<p>Kun olet valmis alusta, loput kohteita Siirry:<p><b>Tilaukset-> kohteen tilauksia-> aluksen tilausmÃ¤Ã¤rÃ¤stÃ¤</b>',0),(453617,12601,'no','Flere forsendelser:<p>Velg antallet du vil sende.<p>Kontroller at du gjÃ¸r <b>ikke</b> sjekk boksen \"bestillingen er fullfÃ¸rt\".<p>NÃ¥r du er klar til Ã¥ sendes de resterende gÃ¥ elementene til:<p><b>Bestillinger-> element ordrer-> skip ordre</b>',0),(453618,12601,'da','Flere forsendelser:<p>VÃ¦lg det antal, du vil afsende.<p>SÃ¸rg for at du gÃ¸r <b>ikke</b> check boksen \"ordren er fÃ¦rdig\".<p>NÃ¥r du er klar til at skibet de resterende gÃ¥ varer til:<p><b>Ordrer-> vare ordrer-> skib rÃ¦kkefÃ¸lge</b>',0),(453619,12601,'ko','ì—¬ëŸ¬ ë°œì†¡ë¬¼:<p>ë°œì†¡ í•˜ê³ ìž í•˜ëŠ” ìˆ˜ëŸ‰ì„ ì„ íƒ í•©ë‹ˆë‹¤.<p>ë‹¹ì‹ ì´ í•  ë‹¤ëŠ” ê²ƒì„ í™•ì¸ <b>í•˜ì§€</b> í™•ì¸ \"ì£¼ë¬¸ì´ ì™„ë£Œ ë˜ ë©´\" ìƒìž.<p>ìž”ì—¬ ë°œì†¡ í•˜ ê²Œ ì¤€ë¹„ ë˜ì–´ ìžˆì„ ë•Œ í•­ëª©ì„ ì´ë™:<p><b>ë°° ìˆœì„œ-> í•­ëª',0),(453620,12601,'he','×ž×©×œ×•×—×™× ×ž×¨×•×‘×™×:<p>×‘×—×¨ ××ª ×”×›×ž×•×ª ×©×‘×¨×¦×•× ×š ×œ×©×œ×•×—.<p>×”×§×¤×“ ×œ×‘×¦×¢ <b>×œ×</b> ×”×¡×™×ž×•×Ÿ ×‘×ª×™×‘×ª \"×¡×“×¨ ×ª×•×©×œ×\".<p>×›××©×¨ ×ª×”×™×” ×ž×•×›×Ÿ ×œ×©×œ×•×— ××ª ×©××¨ ×”×¤×¨×™×˜×™× ×œ×œ×›×ª:<p><b>×”×–×ž× ×•×ª-> ',0),(453621,12601,'el','Î Î¿Î»Î»Î±Ï€Î»Î­Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚:<p>Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î¼ÎµÏ„Î±Ï†Î­ÏÎµÎ¹.<p>Î’ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ Î­Ï‡ÎµÏ„Îµ ÎºÎ¬Î½ÎµÎ¹ <b>Î´ÎµÎ½</b> ÎµÎ»Î­Î³Ï‡Î¿Ï… Ï€Î»Î±Î¯ÏƒÎ¹Î¿ \"Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÎ¯Î½Î±',0),(453622,12601,'zh','å¤šæ¬¡è£…è¿ï¼šé€‰æ‹©æ‚¨æƒ³è¦è£…è¿çš„æ•°é‡ã€‚ç¡®ä¿æ‚¨æ²¡æœ‰é€‰ä¸­â€œè®¢å•å®Œæˆâ€çš„é€‰æ¡†ã€‚å½“æ‚¨å‡†å¤‡å¥½è£…è¿å‰©ä¸‹çš„é¡¹ç›®æ—¶ï¼Œåˆ°ï¼šè®¢å•->é¡¹ç›®è®¢å•->è£…è¿è®¢å•',0),(453623,12601,'sv','Flera leveranser:<p>VÃ¤lj det antal som du vill leverera.<p>GÃ¶ra sÃ¤ker du gÃ¶r <b>inte</b> Markera rutan \"bestÃ¤llningen Ã¤r klar\".<p>NÃ¤r du Ã¤r redo att leverera de Ã¥terstÃ¥ende gÃ¥r objekt till:<p><b>Order-> post order-> fartyget Order</b>',0),(453624,12601,'it','Spedizioni multiple:<p>Scegli la quantitÃ  che vuoi spedire.<p>Assicuratevi di fare <b>non</b> selezionare la casella \"ordine Ã¨ completo\".<p>Quando siete pronti per la spedizione i rimanenti oggetti vanno a:<p><b>Ordini-> voce ordini-> ordine nave</b>',0),(453625,12601,'tl','',0),(453626,12601,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸«à¸¥à¸²à¸¢:<p>à¹€à¸¥à¸·à¸­à¸à¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸µà¹ˆà¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡<p>à¹à¸™à¹ˆà¹ƒà¸ˆà¸§à¹ˆà¸²à¸„à¸¸à¸“<b>à¹„à¸¡à¹ˆ</b>à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸¥à¹ˆà¸­à¸‡ \"à¸ªà¸±à¹ˆà¸‡à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸',0),(453627,12601,'hi','à¤à¤•à¤¾à¤§à¤¿à¤• à¤²à¤¦à¤¾à¤¨:<p>à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤šà¥à¤›à¤¿à¤¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚à¥¤<p>à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤•à¤° <b>à¤¨à¤¹à¥€à¤‚</b> à¤šà¥‡à¤• à¤¬à¥‰à¤•à¥',0),(453628,12601,'ms','Berbilang penghantaran:<p>Pilih kuantiti yang anda mahu untuk kapal.<p>Pastikan anda melakukan <b>tidak</b> semak kotak \"pesanan selesai\".<p>Apabila anda bersedia untuk menghantar baki barang-barang pergi ke:<p><b>Perintah-> Item pesanan-> perintah kapal<',0),(453629,12601,'ar','Ø´Ø­Ù†Ø§Øª Ù…ØªØ¹Ø¯Ø¯Ø©:<p>Ø§Ø®ØªØ± Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ØªÙŠ ØªØ±ÙŠØ¯ Ø´Ø­Ù†.<p>ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù† Ù„Ø¯ÙŠÙƒ <b>Ø¹Ø¯Ù…</b> Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù…Ø±Ø¨Ø¹ \"ØªØ±ØªÙŠØ¨ Ø§ÙƒØªÙ…Ø§Ù„\".<p>Ø¹Ù†Ø¯Ù…Ø§ ÙƒÙ†Øª Ø¹Ù„Ù‰ Ø§Ø³ØªØ¹Ø¯Ø§Ø¯ Ù„Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ© ØªØ°Ù‡Ø¨ ',0),(453630,12601,'fr','Envois multiples :<p>Choisissez la quantitÃ© que vous souhaitez expÃ©dier.<p>Assurez-vous que vous faites <b>pas</b> de cocher la case \"commande est terminÃ©e\".<p>Lorsque vous Ãªtes prÃªt Ã  expÃ©dier les autres Ã©lÃ©ments allez :<p><b>Commandes-> command',0),(453631,12601,'jp','è¤‡æ•°ã®é€ä»˜:<p>å‡ºè·ã™ã‚‹æ•°é‡ã‚’é¸æŠžã—ã¾ã™ã€‚<p>ãã ã•ã„ã€Œæ³¨æ–‡ãŒå®Œäº†ã€ãƒœãƒƒã‚¯ã‚¹ã‚’ãƒã‚§ãƒƒã‚¯<b>ã•ã‚Œã¦ã„ã¾ã›ã‚“</b>ã€‚<p>æ®‹ã‚Šã‚’å‡ºè·ã™ã‚‹æº–å‚™ãŒã§ãã¦ã„ã‚‹ã¨ãé …ç›®ã«ç§»å‹•ã—ã¾ã™ã€‚<p><b>èˆ¹ã®é †åº-> é',0),(453632,12601,'pt','VÃ¡rias remessas:<p>Escolha a quantidade que vocÃª deseja remeter.<p>Certifique-se vocÃª <b>nÃ£o</b> marcar a caixa \"ordem Ã© completa\".<p>Quando vocÃª estÃ¡ pronto para enviar os restantes itens acesse:<p><b>Ordens-> Item ordens-> ordem de navio</b>',0),(453633,12601,'ru','ÐÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð¿Ð°Ñ€Ñ‚Ð¸Ð¹:<p>Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, ÐºÐ¾Ñ‚Ð¾Ñ€Ð¾Ðµ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ.<p>Ð£Ð±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ <b>Ð½Ðµ</b> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ñ„Ð»Ð°Ð¶Ð¾Ðº Â«Ð·Ð°ÐºÐ°Ð·Â».<p>ÐšÐ¾Ð³Ð´Ð° Ð²Ñ‹ Ð±ÑƒÐ´ÐµÑ‚Ðµ Ð',0),(453634,12601,'es','EnvÃ­os Multiples: <p> Selecciona la cantidad que quiere enviar. <p>Asegura que <b>no</b> tacha la caja de \"el orden es completo\".<p> Cuando estÃ¡ listo enviar los items que queda va a.<p><b>Ordenes -> Ordenes de Items -> Enviar Orden</b>',0),(453635,12601,'de','Mehrere Sendungen:<p>WÃ¤hlen Sie die Menge, die Sie versenden mÃ¶chten.<p>Stellen Sie sicher, Sie tun <b>nicht</b> Ã¼berprÃ¼fen Feld \"Auftrag ist abgeschlossen\".<p>Wenn Sie bereit sind, die restlichen Schiff gehen Elemente zu:<p><b>Bestellungen-> Element ',0),(453636,12601,'en','Multiple Shipments: <p> Choose the quantity that you want to ship.<p>Make sure you do <b>not</b> check the \"order is complete\" box. <p> When you are ready to ship the remaining items go to:<p><b>Orders -> Item Orders -> Ship Order</b>',0),(453637,12602,'is','',0),(453638,12602,'dr','',0),(453639,12602,'pr','',0),(453640,12602,'tr','',0),(453641,12602,'pl','',0),(453642,12602,'bg','',0),(453643,12602,'ur','',0),(453644,12602,'sr','',0),(453645,12602,'vi','',0),(453646,12602,'af','',0),(453647,12602,'ro','',0),(453648,12602,'et','',0),(453649,12602,'si','',0),(453650,12602,'ba','',0),(453651,12602,'nl','',0),(453652,12602,'fi','',0),(453653,12602,'no','',0),(453654,12602,'da','',0),(453655,12602,'ko','',0),(453656,12602,'he','',0),(453657,12602,'el','',0),(453658,12602,'zh','',0),(453659,12602,'sv','',0),(453660,12602,'it','',0),(453661,12602,'tl','',0),(453662,12602,'th','',0),(453663,12602,'hi','',0),(453664,12602,'ms','',0),(453665,12602,'ar','',0),(453666,12602,'fr','',0),(453667,12602,'jp','',0),(453668,12602,'pt','',0),(453669,12602,'ru','',0),(453670,12602,'es','',0),(453671,12602,'de','',0),(453672,12602,'en','',0),(453673,12603,'is','',0),(453674,12603,'dr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§ÙˆØ§Ø®Ø± Ùˆ Ù†Ø±Ø® Ø¨Ù‡Ø±Ù‡ Ø¯Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡:<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ùˆ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-> Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø´Ø±Ú©Øª</b><p>Ø³Ù¾Ø³ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ù†Ø§ÙØ¹ØŒ Ø¯Ø± Ø­Ø§Ù„ Ø§Ø¬Ø±Ø§ØŒ Ø§Ú¯Ø± Ù‡',0),(453675,12603,'pr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§ÙˆØ§Ø®Ø± Ùˆ Ù†Ø±Ø® Ø¨Ù‡Ø±Ù‡ Ø¯Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡:<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ùˆ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-> Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø´Ø±Ú©Øª</b><p>Ø³Ù¾Ø³ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ù†Ø§ÙØ¹ØŒ Ø¯Ø± Ø­Ø§Ù„ Ø§Ø¬Ø±Ø§ØŒ Ø§Ú¯Ø± Ù‡',0),(453676,12603,'tr','EÄŸer gecikme bedeli ve faiz oranlarÄ±nÄ± ayarlayÄ±n:<p><b>YÃ¶netici Kurulumu-fatura ÅŸirket seÃ§enekleri->-></b><p>daha sonra herhangi bir fatura Vade tarihinin faiz hesaplamak, Ã§alÄ±ÅŸtÄ±ran, bu gecikme bedeli ekler.',0),(453677,12603,'pl','JeÅ›li uÅ¼ytkownik zestaw pÃ³Åºno opÅ‚aty i stopy procentowe w:<p><b>Admin->-> firmy opcje konfiguracji rozliczeÅ„</b><p>a nastÄ™pnie uruchamiajÄ…c obliczania odsetek, jeÅ›li istniejÄ… faktury przeszÅ‚oÅ›ci wymagalnoÅ›ci, ono wola dodaÄ‡ opÅ‚aty za pÃ³Åºn',0),(453678,12603,'bg','ÐÐºÐ¾ ÑÑ‚Ðµ Ð·Ð°Ð´Ð°Ð»Ð¸ ÐºÑ€Ð°Ñ Ñ‚Ð°ÐºÑÐ° Ð¸ Ð»Ð¸Ñ…Ð²ÐµÐ½Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¸ Ð²:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¾Ð¿Ñ†Ð¸Ð¸</b><p>Ð¢Ð¾Ð³Ð°Ð²Ð° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ñ…Ð²Ð',0),(453679,12603,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ú©Û’ Ù…Ø±Ø­ÙˆÙ… Ú©ÛŒ ÙÛŒØ³ Ø§ÙˆØ± Ø³ÙˆØ¯ Ú©ÛŒ Ø´Ø±Ø­ Ù…ÛŒÚº Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº:<p><b>Ø§ÛŒÚˆÙ…Ù† Ø³ÛŒÙ¹ Ø§Ù¾-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª->-></b><p>Ù¾Ú¾Ø± Ø¬Ø¨ ÛÛŒÚº Ø§Ú¯Ø± Ú©ÙˆØ¦ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ ÙˆØ§Ø¬Ø¨ ØªØ§Ø±ÛŒØ® Ù…Ø§Ø¶ÛŒ',0),(453680,12603,'sr','ÐÐºÐ¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¾Ð¿Ð¾Ð¼ÐµÐ½Ð° Ð¸ ÐºÐ°Ð¼Ð°Ñ‚Ð½Ðµ ÑÑ‚Ð¾Ð¿Ðµ Ñƒ:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ-Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ</b><p>Ð° Ð¾Ð½Ð´Ð° ÐºÐ°Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÑ€ÐµÐ½Ðµ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ ÐºÐ°Ð¼Ð°Ñ‚Ð°, Ð°ÐºÐ¾ Ð¿Ð¾ÑÑ‚',0),(453681,12603,'vi','Náº¿u báº¡n thiáº¿t láº­p tiá»n pháº¡t trá»… háº¡n vÃ  lÃ£i suáº¥t thÃ¬ vÃ o Quáº£n trá»‹->thiáº¿t láº­p thanh toÃ¡n-> tÃ¹y chá»n cÃ´ng ty. Khi tÃ­nh lÃ£i suáº¥t, náº¿u cÃ³ báº¥t ká»³ hÃ³a Ä‘Æ¡n nÃ o trá»… háº¡n, thÃ¬ nÃ³ sáº½ hiá»ƒn thá»‹ phÃ­ trá»… hï',0),(453682,12603,'af','Indien jy stel die laat fooi en rentekoerse in:<p><b>Admin-> opstel-fakturering-> maatskappy opsies</b><p>dan wanneer loop bereken rente, indien daar enige fakture verby die betaaldatum is, sal dit die fooi laat byvoeg.',0),(453683,12603,'ro','DacÄƒ setaÅ£i taxÄƒ de Ã®ntÃ¢rziere ÅŸi dobÃ¢nzi Ã®n:<p><b>Admin-> Setup-facturare-> opÅ£iuni de companie</b><p>atunci cÃ¢nd ruleazÄƒ calcula dobÃ¢nda, dacÄƒ existÄƒ orice facturile trecut data scadenÅ£ei, se va adÄƒuga taxÄƒ de Ã®ntÃ¢rziere.',0),(453684,12603,'et','Kui seate viivis ja intressimÃ¤Ã¤rad on:<p><b>Admin-> Setup-arved-> firma Valikud</b><p>siis kui on mÃ¶Ã¶dunud tÃ¤htaeg arveid intressi arvutamiseks sÃµites lisab hilinenud tasu.',0),(453685,12603,'si','ÄŒe nastavite pozno pristojbine in obrestne mere v:<p><b>Admin-> Setup-zaraÄunavanje-> podjetje moÅ¾nosti</b><p>potem ko teÄe izraÄun obresti, Äe so vse raÄune Äez rok, bodo dodali pozno pristojbina.',0),(453686,12603,'ba','Jika Anda menetapkan biaya terlambat dan suku bunga di:<p><b>Admin-> Setup-penagihan-> pilihan perusahaan</b><p>maka ketika menjalankan minat menghitung, jika ada apapun faktur melewati tanggal jatuh tempo, ia akan menambahkan biaya akhir.',0),(453687,12603,'nl','Als u de te late betaling en rente in instellen:<p><b>Admin-> Setup-Billing-> bedrijf opties</b><p>dan wanneer lopende rente berekenen als er facturen voorbij de vervaldatum, het de te late betaling toevoegen zal.',0),(453688,12603,'fi','Jos mÃ¤Ã¤ritÃ¤t viivÃ¤styskorko ja korot:<p><b>Admin asetukset-laskutus-> yhtiÃ¶lle vaihtoehtoja-></b><p>Kun kÃ¤ynnissÃ¤ Laske korko, jos kaikki laskut erÃ¤pÃ¤ivÃ¤Ã¤n mennessÃ¤ ohi, se lisÃ¤Ã¤ myÃ¶hÃ¤Ã¤n maksu.',0),(453689,12603,'no','Hvis du angir forsinkelsesavgift og renten i:<p><b>Admin-> Setup-fakturering-> selskapet alternativer</b><p>sÃ¥ nÃ¥r du kjÃ¸rer Beregn renter, hvis det er noen fakturaer forbi forfallsdatoen, Ã¸ker forsinkelsesavgift.',0),(453690,12603,'da','Hvis du indstiller sen gebyr og renter i:<p><b>Admin-> Setup-fakturering-> selskab indstillinger</b><p>sÃ¥ nÃ¥r du kÃ¸rer beregne renter, hvis der er nogen fakturaer forbi forfaldsdatoen, vil det tilfÃ¸je en sen gebyr.',0),(453691,12603,'ko','ì—°ì²´ ë£Œ ë° ê¸ˆë¦¬ë¥¼ ì„¤ì • í•˜ë©´:<p><b>ê´€ë¦¬ìž ì„¤ì •-ê²°ì œ íšŒì‚¬ ì˜µì…˜->-></b><p>ë‹¤ìŒ ì‹¤í–‰í•  ë•Œ ê³„ì‚° ì´ìž, ì–´ë–¤ ì²­êµ¬ì„œëŠ” ê¸°í•œ ì§€ë‚œ ê²½ìš°, ì—°ì²´ ë£Œë¥¼ ì¶”ê°€ í•©ë‹ˆë‹¤.',0),(453692,12603,'he','×× ×ª×’×“×™×¨ ××ª ××™×—×•×¨ ×•××ª ×”×¨×™×‘×™×ª ×‘:<p><b>Admin-> ×”×”×ª×§× ×”-×—×™×•×‘-> ××¤×©×¨×•×™×•×ª ×”×—×‘×¨×”</b><p>×•××– ×‘×¢×ª ×”×¤×¢×œ×ª ×—×™×©×•×‘ ×”×¨×™×‘×™×ª, ×× ×™×©× × ×›×œ×©×”×• ×‘×¨×—×•×‘ ××—×¨×™ ×ª××¨×™×š ×”×™×¢×“, ×–×” ×™×•×¡×',0),(453693,12603,'el','Î•Î¬Î½ Î¿ÏÎ¯ÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€ÏÏŒÏƒÏ†Î±Ï„Î· Î±Î¼Î¿Î¹Î²Î® ÎºÎ±Î¹ Ï„Î± ÎµÏ€Î¹Ï„ÏŒÎºÎ¹Î± ÏƒÎµ:<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚-> ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚</b><p>ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î±, ÏŒÏ„Î±Î½ ÎµÎºÏ„ÎµÎ»ÎµÎ¯ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Ï',0),(453694,12603,'zh','å¦‚æžœä½ è®¾ç½®æ»žçº³é‡‘å’Œç½‘çŽ‡ï¼Œåœ¨ï¼šç®¡ç†->è®¾ç½®å…¥è´¦->å…¬å¸é€‰é¡¹\r\nç„¶åŽå½“è¿è¡Œè®¡ç®—åˆ©æ¯æ—¶ï¼Œå¦‚æžœæœ‰ä»»ä½•è¿‡æœŸå‘ç¥¨ï¼Œå®ƒéƒ½ä¼šå¢žåŠ æ–°çš„æ»žçº³é‡‘ã€‚',0),(453695,12603,'sv','Om du anger fÃ¶rseningsavgift och rÃ¤ntor i:<p><b>Admin-> Setup-fakturering-> fÃ¶retag alternativ</b><p>sedan nÃ¤r du kÃ¶r berÃ¤kna rÃ¤nta, om det finns nÃ¥gra fakturor fÃ¶rbi fÃ¶rfallodatum, lÃ¤ggs i fÃ¶rseningsavgift.',0),(453696,12603,'it','Se si imposta il ritardato pagamento e tassi di interesse in:<p><b>Admin->-> azienda opzioni Setup-fatturazione</b><p>allora quando si esegue il calcolo interesse, se ci sono eventuali fatture oltre la data di scadenza, aggiungerÃ  il canone tardo.',0),(453697,12603,'tl','',0),(453698,12603,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸¥à¹ˆà¸²à¸Šà¹‰à¸²à¹à¸¥à¸°à¸­à¸±à¸•à¸£à¸²à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¹ƒà¸™:<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™->à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸šà¸£à¸',0),(453699,12603,'hi','à¤…à¤—à¤° à¤†à¤ª à¤¦à¥‡à¤° à¤¸à¥‡ à¤¶à¥à¤²à¥à¤• à¤”à¤° à¤¬à¥à¤¯à¤¾à¤œ à¤¦à¤°à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª-à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤•à¤‚à¤ªà¤¨à¥€ à¤µà¤¿à¤•à¤²à¥à¤ª->-></b><p>à¤¤à¤¬ à¤œà¤¬ à¤¬à¥',0),(453700,12603,'ms','Jika anda menetapkan yuran lewat dan faedah:<p><b>Admin-> persediaan-bil-> Opsyen Syarikat</b><p>Maka apabila menjalankan kepentingan mengira, jika terdapat sebarang invois melepasi tarikh matang, ia akan menambah bayaran lewat.',0),(453701,12603,'ar','Ø¥Ø°Ø§ Ù‚Ù…Øª Ø¨ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ù…ØªØ£Ø®Ø±Ø© ÙˆØ£Ø³Ø¹Ø§Ø± Ø§Ù„ÙØ§Ø¦Ø¯Ø© ÙÙŠ:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ©</b><p>Ø«Ù… Ø¹Ù†Ø¯ ØªØ´ØºÙŠÙ„ \"Ø­Ø³Ø§Ø¨ Ø§Ù„ÙØ§Ø¦Ø¯Ø©\"ØŒ Ø¥Ø°Ø§ ÙƒØ§Ù† Ù‡Ù†Ø§Ùƒ Ø£ÙŠ',0),(453702,12603,'fr','Si vous dÃ©finissez la surtaxe et taux d\'intÃ©rÃªt :<p><b>Admin-> Setup-facturation-> Options de la sociÃ©tÃ©</b><p>puis lors de l\'exÃ©cution de calculer les intÃ©rÃªts, s\'il n\'y a aucune facture au-delÃ  de la date d\'Ã©chÃ©ance, il ajoutera les frais de ',0),(453703,12603,'jp','å ´åˆã¯ã€å»¶æ»žæ–™ã¨åˆ©å­çŽ‡ã‚’è¨­å®šã—ã¾ã™ã€‚<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è«‹æ±‚ä¼šç¤¾ã‚ªãƒ—ã‚·ãƒ§ãƒ³->-></b><p>ãã®å¾ŒéŽåŽ»ã®æœŸæ—¥ã¯ã€è«‹æ±‚æ›¸ãŒã‚ã‚‹å ´åˆã¯ã€åˆ©æ¯ã®è¨ˆç®—ã‚’å®Ÿè¡Œã—ã¦ã€å»¶æ»žæ–™ãŒè¿½åŠ ã•ã‚Œã¾ã™ã€‚',0),(453704,12603,'pt','Se vocÃª definir a taxa de atraso e as taxas de juros:<p><b>Admin-> Setup-faturamento-> opÃ§Ãµes de empresa</b><p>em seguida, quando executando calcular juros, se houver qualquer facturas passado a data de vencimento, ele irÃ¡ adicionar a taxa de atraso.',0),(453705,12603,'ru','Ð•ÑÐ»Ð¸ Ð·Ð°Ð´Ð°Ñ‚ÑŒ ÐºÐ¾Ð½Ñ†Ðµ Ð²Ð·Ð½Ð¾Ñ Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ñ‹Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³-> ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚Ñ‹</b><p>Ð—Ð°Ñ‚ÐµÐ¼ Ð¿Ñ€Ð¸ Ð·Ð°Ð¿ÑƒÑÐºÐµ Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ñ†Ð',0),(453706,12603,'es','Si configura el cargo de pagar tarde y tasas de interÃ©ses en:<p><b>Admin -> ConfiguraciÃ³n-FacturaciÃ³n -> Opciones de Empresa</b><p>entonces cuando abre Calcula InterÃ©ses, si hay algunas facturas pasando la fecha por pagar, aÃ±adirÃ¡ el cargo de pagar ',0),(453707,12603,'de','Wenn Sie die GebÃ¼hr fÃ¼r verspÃ¤tete und Zinsen in festlegen:<p><b>Admin-> Setup-Billing-> Firma Optionen</b><p>dann wenn Zins berechnen, gibt es Rechnungen nach dem FÃ¤lligkeitsdatum, es die VerspÃ¤tungsgebÃ¼hr addiert.',0),(453708,12603,'en','If you set the late fee and interest rates in:<p><b>Admin -> Setup-Billing -> Company Options</b><p>then when running Calculate Interest, if there are any invoices past the due date, it will add the late fee.',0),(453709,12604,'is','',0),(453710,12604,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø±ÛŒØ§ÙØª Ú©Ø±Ø¯:<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ùˆ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-> Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ.</b><p>Ø¯Ø± Ø¬Ø¹Ø¨Ù‡ \"Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯\" Ú©Ø§Ø±Ø¨Ø± (Ø¢ÙÙ„Ø§ÛŒÙ†) Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨',0),(453711,12604,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø±ÛŒØ§ÙØª Ú©Ø±Ø¯:<p><b>Ù…Ø¯ÛŒØ±-> ØªÙ†Ø¸ÛŒÙ… Ùˆ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-> Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ.</b><p>Ø¯Ø± Ø¬Ø¹Ø¨Ù‡ \"Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯\" Ú©Ø§Ø±Ø¨Ø± (Ø¢ÙÙ„Ø§ÛŒÙ†) Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨',0),(453712,12604,'tr','PayPal Ã¶demeler: alÄ±nan<p><b>YÃ¶netici Kurulumu-fatura kredi kartÄ± seÃ§enekleri->->.</b><p>\'KullanÄ±labilir iÅŸlemci\' kutusunda \'Manuel (Ã§evrimdÄ±ÅŸÄ±)\' seÃ§in.<p>YeÅŸil tÄ±klatÄ±n + Yeni bir hesap eklemek iÃ§in.<p>Ne zaman seÃ§im PayPal veya diÄŸer b',0),(453713,12604,'pl','Otrzymane pÅ‚atnoÅ›ci PayPal:<p><b>Admin-> instalacji Billing-> opcje karty kredytowej.</b><p>W polu \'DostÄ™pne procesory\' wybierz \"RÄ™czny (offline)\".<p>Kliknij zielony +, aby dodaÄ‡ nowe konto.<p>Wybierz ten gdy PayPal lub inne usÅ‚ugi.',0),(453714,12604,'bg','PayPal Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> Ð¾Ð¿Ñ†Ð¸Ð¸ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°.</b><p>Ð’ Ð¿Ð¾Ð»ÐµÑ‚Ð¾ Ð·Ð° \"ÐÐ°Ð»Ð¸Ñ‡ÐµÐ½ Ð¿Ñ€Ð¾Ñ†ÐµÑ\" Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ \"Ð ÑŠÑ‡Ð½Ð¾ (Ð¾',0),(453715,12604,'ur','Ù¾Û’ Ù¾Ø§Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…ÙˆØµÙˆÙ„:<p><b>Ø§ÛŒÚˆÙ…Ù† Ø³ÛŒÙ¹ Ø§Ù¾-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª->-> Û”</b><p>\'Ø¯Ø³ØªÛŒØ§Ø¨ Ù¾Ø±ÙˆØ³ÛŒØ³Ø±Ø²\' Ú©Û’ Ø®Ø§Ù†Û’ Ù…ÛŒÚº \'(Ø¢Ù Ù„Ø§Ø¦Ù†) Ø¯Ø³ØªÛŒ\' Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±ÛŒÚº Û',0),(453716,12604,'sr','ÐŸÐ°yÐŸÐ°Ð» ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ-Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ.</b><p>Ð£ Ð¾ÐºÐ²Ð¸Ñ€Ñƒ \'Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€Ðµ\' Ð¾Ð´Ð°Ð±Ñ€Ð°Ñ‚Ð¸ \'ÐŸÑ€Ð¸Ñ€ÑƒÑ‡Ð½Ð¸Ðº (Ð²Ð°Ð½ Ð¼Ñ',0),(453717,12604,'vi','Nhá»¯ng khoáº£n Paypal Ä‘Ã£ nháº­n:Quáº£n trá»‹-thiáº¿t láº­p thanh toÃ¡n-tÃ¹y chá»n tháº» tÃ­n dá»¥ng. á»Ÿ há»™p\" ngÆ°á»i truy cáº­p tá»“n táº¡i\", chá»n\"lÃ m báº±ng tay\", nháº¥p vÃ o mÃ u xanh lÃ¡ cÃ¢y+ Ä‘á»ƒ táº¡o TK má»›i. Chá»n TK nÃ y khi cÃ³ Pay',0),(453718,12604,'af','PayPal betalings ontvang:<p><b>Admin-> opstel-fakturering-> kredietkaart opsies.</b><p>In die \'beskikbaar verwerkers\' boks \'(ongekoppel) handleiding\' kies.<p>Klik groen + nuwe rekening byvoeg.<p>Kies hierdie wanneer PayPal of ander diens.',0),(453719,12604,'ro','PayPal plÄƒÅ£i primite:<p><b>Admin-> Setup-facturare-> opÅ£iuni de Card de Credit.</b><p>ÃŽn caseta de \"Procesoare disponibile\" alege \"Manualul (offline)\".<p>FaceÅ£i clic pe verde + sÄƒ adÄƒugaÅ£i noul cont.<p>Alege acest lucru atunci cÃ¢nd PayPal sau alt',0),(453720,12604,'et','PayPal makseid vastu:<p><b>Admin-> seadistuse-arved-> krediitkaardi vÃµimalusi.</b><p>Saadaval protsessoril kasti valida \"Manual (Ã¼henduseta)\".<p>KlÃµpsake rohelist + Lisa uus konto.<p>Vali kui PayPal vÃµi muud teenust.',0),(453721,12604,'si','Prejeta plaÄila PayPal:<p><b>Admin-> Setup-zaraÄunavanje-> kreditno kartico moÅ¾nosti.</b><p>V polje \"Na voljo procesorji\" izberite \"priroÄnik (offline).<p>Kliknite zeleno + dodati nov raÄun.<p>To, ko izberete PayPal ali drugih storitev.',0),(453722,12604,'ba','PayPal pembayaran yang diterima:<p><b>Admin-> Setup-penagihan-> pilihan kartu kredit.</b><p>Dalam kotak \'Tersedia prosesor\' Pilih \'Manual (offline)\'.<p>Klik hijau + untuk menambahkan account baru.<p>Ini ketika memilih PayPal atau layanan lainnya.',0),(453723,12604,'nl','PayPal-betalingen ontvangen:<p><b>Admin-> Setup-Billing-> creditcard opties.</b><p>Kies \'Handmatig (offline)\' in het vak \'Beschikbare Processors\'.<p>Klik op groene + nieuwe account toe te voegen.<p>Kies deze wanneer PayPal of andere dienst.',0),(453724,12604,'fi','Saadut PayPal maksut:<p><b>Admin-> mÃ¤Ã¤ritettÃ¤vÃ¤ laskutus-> luottokortin vaihtoehtoja.</b><p>Valitse kÃ¤ytettÃ¤vissÃ¤ prosessorit-ruudusta manuaalinen (offline).<p>Valitse vihreÃ¤ + LisÃ¤Ã¤ uusi tili.<p>Valitse tÃ¤stÃ¤, kun PayPal tai muuhun palveluun.',0),(453725,12604,'no','PayPal-betalinger mottatt:<p><b>Admin-> Setup-fakturering-> kredittkort alternativer.</b><p>I boksen tilgjengelige prosessorer\' velge manuell (frakoblet).<p>Klikk grÃ¸nn + for Ã¥ legge til ny konto.<p>Velg dette nÃ¥r PayPal eller annen tjeneste.',0),(453726,12604,'da','PayPal betalinger modtaget:<p><b>Admin-> Setup-fakturering-> kreditkort muligheder.</b><p>I boksen \'TilgÃ¦ngelige processorer\' vÃ¦lge \'Manual (offline)\'.<p>Klik pÃ¥ green + for at tilfÃ¸je nye konto.<p>VÃ¦lg dette, nÃ¥r PayPal eller anden service.',0),(453727,12604,'ko','íŽ˜ì´íŒ” ê²°ì œë¥¼ ë°›ì•˜ë‹¤:<p><b>ê´€ë¦¬ìž ì„¤ì •-ê²°ì œ ì‹ ìš© ì¹´ë“œ ì˜µì…˜->->.</b><p>\' ì‚¬ìš© ê°€ëŠ¥í•œ í”„ë¡œì„¸ì„œ \' ìƒìžì—ì„œ \'ë§¤ë‰´ì–¼ (ì˜¤í”„ ë¼ì¸)\'ì„ ì„ íƒ í•©ë‹ˆë‹¤.<p>ë…¹ìƒ‰ì„ í´ë¦­ + ìƒˆ ê³„ì •ì„ ì¶”ê°€ í•©ë‹ˆë‹¤.<p>ì´ ë•Œ ì„ í',0),(453728,12604,'he','PayPal ×ª×©×œ×•×ž×™× ×©×”×ª×§×‘×œ×•:<p><b>Admin-> ×”×”×ª×§× ×”-×—×™×•×‘-> ××¤×©×¨×•×™×•×ª ×›×¨×˜×™×¡ ××©×¨××™.</b><p>×‘×ª×™×‘×” \'×ž×¢×‘×“×™× ×”×–×ž×™× ×™×\' ×‘×—×¨ \'×ž×“×¨×™×š (×œ× ×ž×§×•×•×Ÿ)\'.<p>×™×¨×•×§ ×œ×—×¥ + ×œ×”×•×¡×™×£ ×—×©×‘×•×Ÿ ×—×“×©.<p>',0),(453729,12604,'el','PayPal Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… ÎµÎ¹ÏƒÏ€ÏÎ¬Ï„Ï„Î¿Î½Ï„Î±Î¹:<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚-> Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚.</b><p>Î£Ï„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ Â«Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î­Ï‚Â» ÎµÏ€Î¹Î»Î­Î¾Ï„Î',0),(453730,12604,'zh','æ”¶åˆ°çš„è´å®ä»˜æ¬¾ï¼šç®¡ç†->è®¾ç½®å…¥è´¦->åˆ›å»ºå¡é€‰é¡¹\r\nåœ¨â€œå¯ç”¨å¤„ç†å™¨â€é€‰æ¡†ä¸­é€‰å‡ºâ€œæ‰‹åŠ¨ï¼ˆæ–­å¼€è¿žæŽ¥ï¼‰â€ç‚¹å‡»ç»¿è‰²+æ–°å¢žå¸æˆ·ã€‚å½“è´å®æˆ–å…¶ä»–æœåŠ¡é€‰æ‹©æ­¤æ—¶ã€‚',0),(453731,12604,'sv','PayPal betalningar:<p><b>Admin-> Setup-fakturering-> kreditkort alternativ.</b><p>I rutan \"TillgÃ¤ngliga processorer\" vÃ¤ljer du \"Manuell (offline)\".<p>Klicka pÃ¥ grÃ¶na + fÃ¶r att lÃ¤gga till nytt konto.<p>VÃ¤lj detta nÃ¤r PayPal eller annan tjÃ¤nst.',0),(453732,12604,'it','PayPal pagamenti ricevuti:<p><b>Admin-> Setup-fatturazione-> opzioni di carta di credito.</b><p>Nella casella \'Processori disponibili\' scegliere \'Manuale (offline)\'.<p>Fare clic sul verde + per aggiungere il nuovo account.<p>Scegliere questo quando PayPal',0),(453733,12604,'tl','',0),(453734,12604,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸œà¹ˆà¸²à¸™à¹„à¸”à¹‰à¸£à¸±à¸š:<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™->à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•</b><p>à¹ƒà¸™à¸à¸¥à¹ˆà¸­à¸‡ \'à¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸•à¸±à¸',0),(453735,12604,'hi','à¤ªà¥‡à¤ªà¥ˆà¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª-à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤µà¤¿à¤•à¤²à¥à¤ª->->à¥¤</b><p>\'à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤°\' à¤¬',0),(453736,12604,'ms','Bayaran PayPal yang diterima:<p><b>Admin-> persediaan-bil-> pilihan kad kredit.</b><p>Dalam kotak \'Disediakan pemproses\' memilih \'Manual (offline)\'.<p>Klik hijau + untuk menambah akaun baru.<p>Memilih ketika ini PayPal atau perkhidmatan lain.',0),(453737,12604,'ar','ÙˆØªÙ„Ù‚Ù‰ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¨Ø£ÙŠ Ø¨Ø§Ù„:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ø®ÙŠØ§Ø±Ø§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†.</b><p>ÙÙŠ Ø§Ù„Ù…Ø±Ø¨Ø¹ \'\"Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬Ø§Øª Ø§Ù„Ù…ØªÙˆÙØ±Ø©\"\' Ø§Ø®ØªØ± \'Ø§Ù„Ø¯Ù„ÙŠÙ„\' (ØºÙŠØ± Ù…ØªØµÙ„).<p>Ø§Ù†Ù',0),(453738,12604,'fr','PayPal paiements reÃ§us :<p><b>Admin-> Setup-facturation-> Options de carte de crÃ©dit.</b><p>Dans la boÃ®te de Â« Processeurs disponibles Â» Choisissez Â« Manuel (hors ligne) Â».<p>Cliquez sur le vert + pour ajouter un nouveau compte.<p>Choisir Ã§a quand',0),(453739,12604,'jp','PayPal æ”¯æ‰•ã„ã‚’å—ã‘å–ã£ãŸï¼š<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è«‹æ±‚ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ ã‚ªãƒ—ã‚·ãƒ§ãƒ³->->.</b><p>\'åˆ©ç”¨å¯èƒ½ãªãƒ—ãƒ­ã‚»ãƒƒã‚µ\' ãƒœãƒƒã‚¯ã‚¹ \'ãƒžãƒ‹ãƒ¥ã‚¢ãƒ« (ã‚ªãƒ•ãƒ©ã‚¤ãƒ³)\' ã‚’é¸æŠžã—ã¾ã™ã€‚<p>ç·‘ã‚’ã‚¯ãƒªãƒƒã‚¯ã',0),(453740,12604,'pt','PayPal Pagamentos recebidos:<p><b>Admin-> Setup-faturamento-> opÃ§Ãµes de cartÃ£o de crÃ©dito.</b><p>Na caixa \'Processadores disponÃ­veis\' escolha \'Manual (offline)\'.<p>Clique em verde + para adicionar a nova conta.<p>Escolher quando PayPal ou outro servi',0),(453741,12604,'ru','PayPal Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³-> Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚Ð¾Ð² ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚.</b><p>Ð’ Ð¿Ð¾Ð»Ðµ Â«Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€Ñ‹Â» Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ \'Ð ÑƒÐºÐ¾Ð²Ð¾',0),(453742,12604,'es','Pagos Por Paypal Recibidos:<p><b>Admin ->ConfiguraciÃ³n-FacturaciÃ³n -> Opciones de Tarjeta de CrÃ©dito.</b><p> En la caja de \"Procesadores Disponibles\" selecciona \'Manual (no en linea)\'.<p>Clik verde + para agregar una nueva cuenta.<p>Selecciona este cua',0),(453743,12604,'de','PayPal-Zahlungen empfangen:<p><b>Admin-> Setup-Billing-> Kreditkarte Optionen.</b><p>WÃ¤hlen Sie im Feld \'VerfÃ¼gbaren Prozessoren\' \"Handbuch (offline)\".<p>Klicken Sie auf grÃ¼n + neues Konto hinzufÃ¼gen.<p>WÃ¤hlen Sie diese bei PayPal oder einem anderen ',0),(453744,12604,'en','PayPal Payments Received:<p><b>Admin -> Setup-Billing -> Credit Card Options.</b><p> In the \'Available Processors\' box choose \'Manual (offline)\'.<p>Click green + to add new account.<p>Choose this when PayPal or other service.',0),(453745,12605,'is','',0),(453746,12605,'dr','',0),(453747,12605,'pr','',0),(453748,12605,'tr','',0),(453749,12605,'pl','',0),(453750,12605,'bg','',0),(453751,12605,'ur','',0),(453752,12605,'sr','',0),(453753,12605,'vi','',0),(453754,12605,'af','',0),(453755,12605,'ro','',0),(453756,12605,'et','',0),(453757,12605,'si','',0),(453758,12605,'ba','',0),(453759,12605,'nl','',0),(453760,12605,'fi','',0),(453761,12605,'no','',0),(453762,12605,'da','',0),(453763,12605,'ko','',0),(453764,12605,'he','',0),(453765,12605,'el','',0),(453766,12605,'zh','',0),(453767,12605,'sv','',0),(453768,12605,'it','',0),(453769,12605,'tl','',0),(453770,12605,'th','',0),(453771,12605,'hi','',0),(453772,12605,'ms','',0),(453773,12605,'ar','',0),(453774,12605,'fr','',0),(453775,12605,'jp','',0),(453776,12605,'pt','',0),(453777,12605,'ru','',0),(453778,12605,'es','',0),(453779,12605,'de','',0),(453780,12605,'en','',0),(453781,12606,'is','',0),(453782,12606,'dr','EFT Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ Ù…ÛŒ ØªÙˆØ§Ù† Ø¯Ø± Ø¨Ø§Ø·Ù„ Ù…ÛŒ Ø´ÙˆØ¯:<p><b>Payables->-> Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ùˆ Ù„ØºÙˆ Ú†Ú© Ú†Ú©</b>',0),(453783,12606,'pr','EFT Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ Ù…ÛŒ ØªÙˆØ§Ù† Ø¯Ø± Ø¨Ø§Ø·Ù„ Ù…ÛŒ Ø´ÙˆØ¯:<p><b>Payables->-> Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ùˆ Ù„ØºÙˆ Ú†Ú© Ú†Ú©</b>',0),(453784,12606,'tr','EFT Ã¶demelerini de geÃ§ersiz kÄ±lmak:<p><b>BorÃ§ Ã§ekleri gÃ¶rÃ¼ntÃ¼leyin/iptal denetimleri->-></b>',0),(453785,12606,'pl','EFT pÅ‚atnoÅ›ci moÅ¼e byÄ‡ uniewaÅ¼nione na:<p><b>ZobowiÄ…zania-> kontroli-> kontroli widoku/Anuluj</b>',0),(453786,12606,'bg','EFT Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½ Ð²:<p><b>Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ-> Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸-> Ð¸Ð·Ð³Ð»ÐµÐ´/Ð¾Ñ‚ÐºÐ°Ð· Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸</b>',0),(453787,12606,'ur','EFT Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ù…ÛŒÚº ÙˆÙˆØ§ÚˆÛŒØ¯ Ø¬Ø§ Ø³Ú©ØªÛ’ ÛÛŒÚº:<p><b>Ú†ÛŒÚ© Ú†ÛŒÚ© Ù…Ù†Ø¸Ø±/Ù…Ù†Ø³ÙˆØ®->-> Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³</b>',0),(453788,12606,'sr','Ð•Ð¤Ð¢ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð¼Ð¾Ð³Ñƒ Ð±Ð¸Ñ‚Ð¸ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ ÐºÐ¾Ð´:<p><b>Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·/ÐžÑ‚ÐºÐ°Ð¶Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ</b>',0),(453789,12606,'vi','Thanh toÃ¡n EFT cÃ³ thá»ƒ Ä‘Æ°á»£c há»§y bá» táº¡i: Pháº£i tráº£-> kiá»ƒm tra-> xem/ há»§y, kiá»ƒm tra',0),(453790,12606,'af','EFT betalings kan by ontlaste word:<p><b>Waardedalingstoetse-> kontrole-> bekyk/kanselleer ondersoeke</b>',0),(453791,12606,'ro','EFT plÄƒÅ£i pot fi anulate la:<p><b>Datorii-> controale-> Vezi/anuleazÄƒ controale</b>',0),(453792,12606,'et','EFT makseid saab kehtetu suunas:<p><b>VÃµlad-> kontrollide-> View/Loobu kontrolli</b>',0),(453793,12606,'si','EFT plaÄil se lahko razveljavi na:<p><b>Obveznosti-> pregledi-> pregledi pogled/PrekliÄi</b>',0),(453794,12606,'ba','Pembayaran TDE dapat voided di:<p><b>Hutang-> cek-> View/membatalkan cek</b>',0),(453795,12606,'nl','EFT betalingen kunnen worden vernietigd op:<p><b>Schulden-> controles-> bekijken/annuleren controles</b>',0),(453796,12606,'fi','EFT-maksut voi mitÃ¤tÃ¶idÃ¤ on:<p><b>Ostovelat-> tarkastusten-> View/Peruuta tarkastukset</b>',0),(453797,12606,'no','EFT betaling kan annulleres pÃ¥:<p><b>LeverandÃ¸rgjeld-> sjekker-> Vis/Avbestill sjekker</b>',0),(453798,12606,'da','EFT betalinger kan kasseres pÃ¥:<p><b>GÃ¦ld-> kontrol-> Se/annullere Checks</b>',0),(453799,12606,'ko','ì „ìž ì†¡ê¸ˆ ì§€ë¶ˆì— ë¬´íš¨ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p><b>ë¯¸ì§€ê¸‰ê¸ˆ ê²€ì‚¬ ë³´ê¸°/ì·¨ì†Œ í™•ì¸->-></b>',0),(453800,12606,'he','× ×™×ª×Ÿ ×œ×‘×˜×œ ××ª ×ª×•×§×¤×• ×©×œ ×ª×©×œ×•×ž×™× EFT:<p><b>×–×›××™×-> ×‘×“×™×§×•×ª-> ×¦×¤×™×™×”/×‘×™×˜×•×œ ×”×¦\'×§×™×</b>',0),(453801,12606,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Î—ÎœÎ§ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±ÎºÏ…ÏÏ‰Î¸ÎµÎ¯ ÏƒÏ„Î¿:<p><b>Î Î»Î·ÏÏ‰Ï„Î­Ï‰Î½-> Î­Î»ÎµÎ³Ï‡Î¿Î¹-> ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Ï€ÏÎ¿Î²Î¿Î»Î®/Î±ÎºÏÏÏ‰ÏƒÎ·</b>',0),(453802,12606,'zh','ç”µå­ä»˜æ¬¾äº¤æ˜“ä»˜æ¬¾å¯ä»¥è¢«åºŸé™¤ï¼šåº”ä»˜æ¬¾é¡¹->æ”¯ç¥¨->æŸ¥çœ‹/å–æ¶ˆæ”¯ç¥¨',0),(453803,12606,'sv','EFT betalningar kan ogiltigfÃ¶rklaras pÃ¥:<p><b>LeverantÃ¶rsskulder-> kontroller-> Visa/Avbryt kontroller</b>',0),(453804,12606,'it','Pagamenti EFT possono essere annullati presso:<p><b>-> Controlli-> controlli Visualizza/Cancella i debiti</b>',0),(453805,12606,'tl','',0),(453806,12606,'th','EFT à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸ªà¸²à¸¡à¸²à¸£à¸–à¸¢à¸à¹„à¸”à¹‰à¸—à¸µà¹ˆ:<p><b>à¹€à¸ˆà¹‰à¸²->à¹€à¸Šà¹‡à¸„->à¸”à¸¹/à¸¢à¸à¹€à¸¥à¸´à¸à¹€à¸Šà¹‡à¸„</b>',0),(453807,12606,'hi','à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ voided à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚:<p><b>à¤¦à¥ƒà¤¶à¥à¤¯/à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚ à¤šà¥‡à¤•-> à¤šà¥‡à¤•-> payables</b>',0),(453808,12606,'ms','Pembayaran EFT boleh voided pada:<p><b>Pemiutang-> pemeriksaan-> pemeriksaan View/Batal</b>',0),(453809,12606,'ar','ÙŠÙ…ÙƒÙ† Ø¥Ù„ØºØ§Ø¡ ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø£Ù…ÙˆØ§Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª ÙÙŠ:<p><b>Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹-> Ø§Ù„Ø´ÙŠÙƒØ§Øª-> Ø¹Ø±Ø¶/Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø´ÙŠÙƒØ§Øª</b>',0),(453810,12606,'fr','Paiements EFT peuvent Ãªtre invalidÃ©es Ã  :<p><b>Comptes fournisseurs-> contrÃ´les-> contrÃ´les consulter/annuler</b>',0),(453811,12606,'jp','éŠ€è¡Œå£åº§æŒ¯è¾¼ã§ç„¡åŠ¹ã«ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚<p><b>è²·æŽ›é‡‘ãƒã‚§ãƒƒã‚¯è¡¨ç¤º/ã‚­ãƒ£ãƒ³ã‚»ãƒ« ãƒã‚§ãƒƒã‚¯->-></b>',0),(453812,12606,'pt','Pagamentos de EFT podem ser cancelados no:<p><b>-> Cheques-> ver/cancelar cheques a pagar</b>',0),(453813,12606,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð¼Ð¾Ð¶Ð½Ð¾ Ð±ÑƒÐ´ÐµÑ‚ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð° Ð²:<p><b>ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ-> Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸-> Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ð¾Ñ‚Ð¼ÐµÐ½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¾Ðº</b>',0),(453814,12606,'es','Pagos de EFT se puede anular a:<p><b>Pagables -> Cheques -> Visionar/Cancelar Cheques</b>',0),(453815,12606,'de','EFT-Zahlungen kÃ¶nnen storniert werden, bei:<p><b>Verbindlichkeiten-> PrÃ¼fungen-> anzeigen/Abbrechen-PrÃ¼fungen</b>',0),(453816,12606,'en','EFT payments can be voided at:<p><b>Payables -> Checks -> View/Cancel Checks</b>',0),(453817,12607,'is','',0),(453818,12607,'dr','',0),(453819,12607,'pr','',0),(453820,12607,'tr','',0),(453821,12607,'pl','',0),(453822,12607,'bg','',0),(453823,12607,'ur','',0),(453824,12607,'sr','',0),(453825,12607,'vi','',0),(453826,12607,'af','',0),(453827,12607,'ro','',0),(453828,12607,'et','',0),(453829,12607,'si','',0),(453830,12607,'ba','',0),(453831,12607,'nl','',0),(453832,12607,'fi','',0),(453833,12607,'no','',0),(453834,12607,'da','',0),(453835,12607,'ko','',0),(453836,12607,'he','',0),(453837,12607,'el','',0),(453838,12607,'zh','',0),(453839,12607,'sv','',0),(453840,12607,'it','',0),(453841,12607,'tl','',0),(453842,12607,'th','',0),(453843,12607,'hi','',0),(453844,12607,'ms','',0),(453845,12607,'ar','',0),(453846,12607,'fr','',0),(453847,12607,'jp','',0),(453848,12607,'pt','',0),(453849,12607,'ru','',0),(453850,12607,'es','',0),(453851,12607,'de','',0),(453852,12607,'en','',0),(453853,12608,'is','',0),(453854,12608,'dr','',0),(453855,12608,'pr','',0),(453856,12608,'tr','',0),(453857,12608,'pl','',0),(453858,12608,'bg','',0),(453859,12608,'ur','',0),(453860,12608,'sr','',0),(453861,12608,'vi','',0),(453862,12608,'af','',0),(453863,12608,'ro','',0),(453864,12608,'et','',0),(453865,12608,'si','',0),(453866,12608,'ba','',0),(453867,12608,'nl','',0),(453868,12608,'fi','',0),(453869,12608,'no','',0),(453870,12608,'da','',0),(453871,12608,'ko','',0),(453872,12608,'he','',0),(453873,12608,'el','',0),(453874,12608,'zh','',0),(453875,12608,'sv','',0),(453876,12608,'it','',0),(453877,12608,'tl','',0),(453878,12608,'th','',0),(453879,12608,'hi','',0),(453880,12608,'ms','',0),(453881,12608,'ar','',0),(453882,12608,'fr','',0),(453883,12608,'jp','',0),(453884,12608,'pt','',0),(453885,12608,'ru','',0),(453886,12608,'es','',0),(453887,12608,'de','',0),(453888,12608,'en','',0),(453889,12609,'is','',0),(453890,12609,'dr','',0),(453891,12609,'pr','',0),(453892,12609,'tr','',0),(453893,12609,'pl','',0),(453894,12609,'bg','',0),(453895,12609,'ur','',0),(453896,12609,'sr','',0),(453897,12609,'vi','',0),(453898,12609,'af','',0),(453899,12609,'ro','',0),(453900,12609,'et','',0),(453901,12609,'si','',0),(453902,12609,'ba','',0),(453903,12609,'nl','',0),(453904,12609,'fi','',0),(453905,12609,'no','',0),(453906,12609,'da','',0),(453907,12609,'ko','',0),(453908,12609,'he','',0),(453909,12609,'el','',0),(453910,12609,'zh','',0),(453911,12609,'sv','',0),(453912,12609,'it','',0),(453913,12609,'tl','',0),(453914,12609,'th','',0),(453915,12609,'hi','',0),(453916,12609,'ms','',0),(453917,12609,'ar','',0),(453918,12609,'fr','',0),(453919,12609,'jp','',0),(453920,12609,'pt','',0),(453921,12609,'ru','',0),(453922,12609,'es','',0),(453923,12609,'de','',0),(453924,12609,'en','',0),(453925,12610,'is','',0),(453926,12610,'dr',':ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-Ø·Ø±Ø­ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª- Ø§ØµÙ„Ø§Ø­ Ø·Ø±Ø­ ',0),(453927,12610,'pr','Ú†Ú¯ÙˆÙ†Ù‡ Ù…ÛŒ ØªÙˆØ§Ù† ÛŒÚ© Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ Ù…ØªÙˆÙ‚Ù Ú©Ø±Ø¯:ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-Ø·Ø±Ø­ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª- ÙˆÛŒØ±Ø§ÛŒØ´ Ø·Ø±Ø­ ',0),(453928,12610,'tr','NasÄ±l bir Ã¶deme planÄ± durdurmak iÃ§in:<p><b>Fatura Ã¶deme->-> dÃ¼zenleme planÄ± planlarÄ±</b><p>\"0\" \"Kat sayÄ±\" kutusuna girin ve \"Sonraki Ã¶deme vade\" bugÃ¼nÃ¼n tarihine ayarlayÄ±n.<p>Eski Ã¶deme planÄ± kayÄ±t tutma amaÃ§larÄ± iÃ§in kaydetme Ã¶neririz',0),(453929,12610,'pl','Jak zatrzymaÄ‡ Plan pÅ‚atnoÅ›ci:<p><b>PÅ‚atnoÅ›ci-> pÅ‚atnoÅ›ci plany-> edycja planu</b><p>Wpisz \"0\" w polu \"Numer razy\" i ustawiÄ‡ \"nastÄ™pnej pÅ‚atnoÅ›ci termin\" z dniem dzisiejszym.<p>Zalecamy zapisywanie stary Plan pÅ‚atnoÅ›ci dla celÃ³w ewidencji!',0),(453930,12610,'bg','ÐšÐ°Ðº Ð´Ð° ÑÐµ ÑÐ¿Ñ€Ðµ Ð½Ð° Ð¿Ð»Ð°Ð½ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ:<p><b>Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ-> Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½</b><p>Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ \"0\" Ð² Ð¿Ð¾Ð»ÐµÑ‚Ð¾ \"ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°\" Ð¸ Ð·Ð°Ð´Ð°Ð¹Ñ‚Ðµ \"Ð¡Ð»Ð',0),(453931,12610,'ur','Ø§ÛŒÚ© Ú©Û’ Ù¾ÛŒÙ…Ù†Ù¹ Ù¾Ù„Ø§Ù† Ú©Ùˆ Ø±ÙˆÚ©Ù†Û’ Ú©Ø§ Ø·Ø±ÛŒÙ‚Û:<p><b>Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù¾ÛŒÙ…Ù†Ù¹-> ØªØ¯ÙˆÛŒÙ† Ù¾Ù„Ø§Ù†-> Ú©Ø§ Ù…Ù†ØµÙˆØ¨Û</b><p>Ø§ÛŒÚ© \"0\" Ú©Ùˆ \"Ø²Ù…Ø§Ù†Û’ Ú©Û’ Ù†Ù…Ø¨Ø±\" Ø®Ø§Ù†Û Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Ø§ÙˆØ± \"Ø§Ú¯Ù„ÛŒ Ø§Ø¯Ø§Ø',0),(453932,12610,'sr','ÐšÐ°ÐºÐ¾ Ð·Ð°ÑƒÑÑ‚Ð°Ð²Ð¸Ñ‚Ð¸ ÐŸÐ»Ð°Ð½ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°:<p><b>ÐÐ°Ð¿Ð»Ð°Ñ‚Ðµ Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð¿Ð»Ð°Ð½Ð¸Ñ€Ð° Ð¸ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ð½Ð°</b><p>Ð£ Ð¿Ð¾Ñ™Ñƒ \"Ð‘Ñ€Ð¾Ñ˜ Ð¿ÑƒÑ‚Ð°\" ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ \"0\" Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ \"Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(453933,12610,'vi','lÃ m cÃ¡ch nÃ o Ä‘á»ƒ cháº·n má»™t káº¿ hoáº¡ch thanh toÃ¡n: Thanh toÃ¡n-káº¿ hoáº¡ch thanh toÃ¡n-sá»­a káº¿ hoáº¡ch. nháº­p\"0\" trong há»™p\"sá»‘ cá»§a thá»i gian\"vÃ  thiáº¿t láº­p háº¡n thanh toÃ¡n tiáº¿p theo',0),(453934,12610,'af','Hoe om te stop \'n betaling beplan:<p><b>Fakturering-> betaling planne-> redigeer Plan</b><p>\'N \"0\" in die \"Getal van tye\" blokkie tik en stel die \"volgende betaling sperdatum\" tot vandag se datum.<p>Ons stel voor dat die ou betaling beplan vir rekordhoudi',0),(453935,12610,'ro','Cum la spre oprire un Plan de platÄƒ:<p><b>Facturare-> platÄƒ planuri-> editare Plan</b><p>IntroduceÅ£i un \"0\" Ã®n caseta de \"NumÄƒrul de ori\" ÅŸi setaÅ£i \"viitoare de plata data scadenÅ£ei\" la data de astÄƒzi.<p>VÄƒ sugerÄƒm sÄƒ economisire a planului de',0),(453936,12610,'et','Kuidas peatada otsemaksete kava:<p><b>Arvete-> maksmine plaanid-> Redigeeri plaani</b><p>Sisestage \"0\" vÃ¤ljale \"Mitu korda\" ning mÃ¤Ã¤ra \"JÃ¤rgmine makse tÃ¤htaeg\" kuupÃ¤evaga.<p>Soovitame salvestada vana maksegraafiku sÃ¤ilitamise eesmÃ¤rgil!',0),(453937,12610,'si','Kako zastajati a plaÄilni naÄrt:<p><b>ZaraÄunavanje-> plaÄilo naÄrtov-> urejanje naÄrt</b><p>\"0\" v polje \"Å tevilka Times\" in \"naslednji plaÄilni rok nastavite\" danes.<p>Predlagamo, da varÄevanje stari plaÄilni naÄrt za vodenje evidence namene!',0),(453938,12610,'ba','Bagaimana untuk menghentikan rencana pembayaran:<p><b>Penagihan-> pembayaran rencana-> Edit rencana</b><p>Masukkan \"0\" dalam \"Nomor Times\" kotak dan set \"berikutnya tanggal jatuh tempo pembayaran\" untuk tanggal.<p>Sebaiknya menyimpan lama pembayaran renca',0),(453939,12610,'nl','Hoe te stoppen met een betaling Plan:<p><b>Facturering-> betaling plannen-> bewerken Plan</b><p>Voer een \'0\' in het vak \"Aantal of Times\" en de \"volgende betaling einddatum instelt\" op de datum van vandaag.<p>Wij stellen voor opslaan van het oude betaling',0),(453940,12610,'fi','Kuinka lopettaa maksu suunnitelma:<p><b>Laskutus-> Maksu suunnitelmat-> Muokkaa suunnitelmaa</b><p>Kirjoita \"Monta kertaa\"-ruutuun \"0\" ja aseta \"Seuraavan maksun erÃ¤pÃ¤ivÃ¤\" pÃ¤ivÃ¤stÃ¤.<p>Kannattaa sÃ¤Ã¤stÃ¤Ã¤ vanhan maksu suunnitelman tietojen sÃ¤ilytt',0),(453941,12610,'no','Hvordan Ã¥ stoppe en betaling Plan:<p><b>Fakturering-> betaling planer-> Rediger Plan</b><p>Skriv inn \"0\" i boksen \"Nummer av Times\" og sette \"Neste betalingen forfallsdatoen\" i dag.<p>Vi foreslÃ¥r at lagring av gamle betaling Plan for posten-holde formÃ¥',0),(453942,12610,'da','Hvordan man kan stoppe en betaling planen:<p><b>Fakturering-> betaling planer-> Rediger Plan</b><p>Indtast \"0\" i boksen \"Antal af gange\" og sÃ¦t \"NÃ¦ste betaling forfaldsdatoen\" til dags dato.<p>Vi foreslÃ¥ at gemme den gamle betaling Plan til registrerin',0),(453943,12610,'ko','ì§€ë¶ˆ ê³„íšì„ ì¤‘ì§€ í•˜ëŠ” ë°©ë²•:<p><b>ê²°ì œ-> ê²°ì œ íŽ¸ì§‘ ê³„íš-> ê³„íš</b><p>\"ì‹œëŒ€ì˜ ìˆ˜\" ìƒìžì—ì„œ \"0\"ì„ ìž…ë ¥ í•˜ ê³  \"ë‹¤ìŒ ê²°ì œ ì˜ˆì •ì¼\" ì˜¤ëŠ˜ ë‚ ì§œë¡œ ì„¤ì •.<p>ê¸°ë¡ ìœ ì§€ ëª©ì ì„ ìœ„í•´ ì˜¤ëž˜ ëœ ì§€ë¶ˆ ê³„íšì„ ì €',0),(453944,12610,'he','××™×š ×œ×¢×¦×•×¨ ××ª ×ª×•×›× ×™×ª ×”×ª×©×œ×•×:<p><b>×—×™×•×‘-> ×”×ª×©×œ×•× ×ª×•×›× ×™×•×ª-> ×ª×•×›× ×™×ª ×¢×¨×™×›×”</b><p>×”×–×Ÿ \"0\" ×‘×ª×™×‘×” \"×ž×¡×¤×¨ ×©×œ ×¤×¢×ž×™×\" ×•×œ×”×’×“×™×¨ ××ª \"×”×‘× ×‘×©×œ ×ª××¨×™×š ×”×ª×©×œ×•×\" ×”×ª××¨×™×š ×©×œ ×”',0),(453945,12610,'el','Î ÏŽÏ‚ Î½Î± ÏƒÏ„Î±Î¼Î±Ï„Î®ÏƒÎµÎ¹ Î­Î½Î± ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚:<p><b>Î§ÏÎ­Ï‰ÏƒÎ·Ï‚-> Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ ÏƒÏ‡Î­Î´Î¹Î±-> ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ‡Î­Î´Î¹Î¿</b><p>Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± \"0\" ÏƒÏ„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ \"Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½ ÎºÎ±Î¹ÏÏŽÎ½\" Î',0),(453946,12610,'zh','å¦‚ä½•åœæ­¢ä¸€ä¸ªä»˜æ¬¾è®¡åˆ’ï¼šå…¥è´¦>ä»˜æ¬¾è®¡åˆ’->ç¼–è¾‘è®¡åˆ’\r\nåœ¨â€œæ—¶é—´æ•°â€æ¡†é‡Œè¾“å…¥â€œ0â€å¹¶è®¾ç½®â€œä¸‹ä¸€ä»˜æ¬¾æˆªæ­¢æ—¥æœŸâ€åˆ°ä»Šå¤©çš„æ—¥æœŸã€‚ä¸ºä¿å­˜è®°å½•ï¼Œæˆ‘ä»¬å»ºè®®ä¿å­˜æ—§çš„ä»˜æ¬¾è®¡åˆ’ã€‚',0),(453947,12610,'sv','Hur man stoppar en betalningsplan:<p><b>Fakturering-> betalning planer-> redigera Plan</b><p>Anger du \"0\" i rutan \"Nummer av tider\" och \"NÃ¤sta betalning fÃ¶rfallodatum\" att dagens datum.<p>Vi fÃ¶reslÃ¥r att spara den gamla betalningsplan fÃ¶r registrerin',0),(453948,12610,'it','Come fermare un piano di pagamento:<p><b>Piani di fatturazione-> pagamento-> modifica piano</b><p>Inserire un \"0\" nella casella \"Numero di volte\" e impostare il \"prossimo pagamento scadenza\" alla data odierna.<p>Consigliamo di salvare il vecchio programma',0),(453949,12610,'tl','',0),(453950,12610,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸«à¸¢à¸¸à¸”à¹à¸œà¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™:<p><b>à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™->à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹à¸œà¸™->à¹à¸œà¸™à¹à¸à¹‰à¹„à¸‚</b><p>à¹ƒà¸ªà¹ˆ \"0\" à¹ƒà¸™à¸Šà¹ˆà¸­à¸‡ \"à¸ˆà¸³à¸™à¸§à¸™à¸„à¸£à¸±à¹‰à¸‡\" ',0),(453951,12610,'hi','à¤•à¥ˆà¤¸à¥‡ à¤à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥‹ à¤°à¥‹à¤•à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤:<p><b>à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤­à¥à¤—à¤¤à¤¾à¤¨->-> à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¯à¥‹à¤œà¤¨à¤¾ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾</b><p>à¤à¤• \"0\" \"à¤Ÿà¤¾à¤‡à¤®à',0),(453952,12610,'ms','Bagaimana untuk berhenti pelan bayaran:<p><b>Bil-> pembayaran pelan-> pelan Edit</b><p>Masukkan \"0\" dalam kotak \"Nombor Times\" dan Setkan \"Seterusnya tarikh bayaran kena dibayar\" ke tarikh hari ini.<p>Kami cadangkan anda menyimpan pelan bayaran lama untuk',0),(453953,12610,'ar','ÙƒÙŠÙ Ù„ÙˆÙ‚Ù \"Ø®Ø·Ø© Ø§Ù„Ø¯ÙØ¹\":<p><b>Ø®Ø·Ø· Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> Ø§Ù„Ø¯ÙØ¹-> Ø®Ø·Ø© ØªØ­Ø±ÙŠØ±</b><p>Ø£Ø¯Ø®Ù„ \"0\" ÙÙŠ Ø§Ù„Ù…Ø±Ø¨Ø¹ \"Ø¹Ø¯Ø¯ Ù…Ø±Ø§Øª\" ÙˆØªØ¹ÙŠÙŠÙ† \"ØªØ§Ø±ÙŠØ® Ø§Ù„Ø³Ø¯Ø§Ø¯ Ø§Ù„ØªØ§Ù„ÙŠ Ø§Ù„ÙˆØ§Ø¬Ø¨\" Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„ÙŠÙˆÙ….<p>ÙˆÙ†Ø­Ù† ',0),(453954,12610,'fr','Comment arrÃªter un Plan de paiement :<p><b>Plans de facturation-> paiement-> Edit Plan</b><p>Entrez un Â« 0 Â» dans la case Â« Nombre de fois Â» et dÃ©finir le Â« prochain paiement Date d\'Ã©chÃ©ance Â» date du jour.<p>Nous suggÃ©rons de sauver le vieux p',0),(453955,12610,'jp','æ”¯æ‰•è¨ˆç”»ã‚’åœæ­¢ã™ã‚‹æ–¹æ³•ï¼š<p><b>æ”¯æ‰•ã„-> æ–™é‡‘ãƒ—ãƒ©ãƒ³ç·¨é›†è¨ˆç”»-></b><p>ã€Œå›žæ•°ã€ãƒœãƒƒã‚¯ã‚¹ã«ã€Œ0ã€ã‚’å…¥åŠ›ã—ã¦ã€æ¬¡å›žæ”¯æ‰•æœŸæ—¥\"\"ä»Šæ—¥ã®æ—¥ä»˜ã«è¨­å®šã€‚<p>è¨˜éŒ²ä¿ç®¡ç›®çš„ã®ãŸã‚ã®å¤ã„æ”¯æ‰•ãƒ—ãƒ©ãƒ³ã®ä¿å­˜ã‚’',0),(453956,12610,'pt','Como parar um plano de pagamento:<p><b>Faturamento-> pagamento planos-> editar plano</b><p>Inserir um \"0\" na caixa \"NÃºmero de vezes\" e defina o \"prÃ³ximo pagamento data de vencimento\" Ã  data de hoje.<p>Sugerimos salvar o velho plano de pagamento para fi',0),(453957,12610,'ru','ÐšÐ°Ðº Ð¾ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ð»Ð°Ð½ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹:<p><b>ÐŸÐ»Ð°Ð½Ñ‹ ÑÑ‡ÐµÑ‚Ð¾Ð²-> Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹-> Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð»Ð°Ð½</b><p>Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Â«0Â» Ð² Ð¿Ð¾Ð»Ðµ Â«ÐÐ¾Ð¼ÐµÑ€ Ñ€Ð°Ð·Â» Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Â«Ð”Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð²ÐµÐ´ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐ´ÑƒÑ',0),(453958,12610,'es','Como parar un Plan de Pago:<p><b>FacturaciÃ³n -> Planes de Pago -> Editar Plan</b><p>Entra un cero en la caja del \"nÃºmero de veces\" y configura el \"Proximo Pago Fecha Vencida\" a la fecha de hoy.<p> sugerimos guardar el plan viejo de ahorros para proosito',0),(453959,12610,'de','Wie eine Zahlung Plan zu stoppen:<p><b>Abrechnung-> Zahlung PlÃ¤ne-> bearbeiten-Plan</b><p>Geben Sie \"0\" im Feld \"Anzahl der Times\" und \"NÃ¤chste Zahlung FÃ¤lligkeit\" auf das aktuelle Datum festgelegt.<p>Wir schlagen vor, sparen der alten Zahlung Plan fÃ¼',0),(453960,12610,'en','How to stop a Payment Plan:<p><b>Billing -> Payment Plans -> Edit Plan</b><p>Enter a \"0\" in the \"Number of Times\" box and set the \"Next Payment Due Date\" to today\'s date.<p>We suggest saving the old Payment Plan for record-keeping purposes!',0),(453961,12611,'is','',0),(453962,12611,'dr','',0),(453963,12611,'pr','',0),(453964,12611,'tr','',0),(453965,12611,'pl','',0),(453966,12611,'bg','',0),(453967,12611,'ur','',0),(453968,12611,'sr','',0),(453969,12611,'vi','',0),(453970,12611,'af','',0),(453971,12611,'ro','',0),(453972,12611,'et','',0),(453973,12611,'si','',0),(453974,12611,'ba','',0),(453975,12611,'nl','',0),(453976,12611,'fi','',0),(453977,12611,'no','',0),(453978,12611,'da','',0),(453979,12611,'ko','',0),(453980,12611,'he','',0),(453981,12611,'el','',0),(453982,12611,'zh','',0),(453983,12611,'sv','',0),(453984,12611,'it','',0),(453985,12611,'tl','',0),(453986,12611,'th','',0),(453987,12611,'hi','',0),(453988,12611,'ms','',0),(453989,12611,'ar','',0),(453990,12611,'fr','',0),(453991,12611,'jp','',0),(453992,12611,'pt','',0),(453993,12611,'ru','',0),(453994,12611,'es','',0),(453995,12611,'de','',0),(453996,12611,'en','',0),(453997,12612,'is','',0),(453998,12612,'dr',':Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§-Ø®Ø±ÛŒØ¯-Ø¯Ø±ÛŒØ§ÙØª Ø¨Ø¯ÙˆÙ† ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÛŒØ¯',0),(453999,12612,'pr','Ø¨Ø±Ø§ÛŒ Ù…Ø­Ø§Ø³Ø¨Ù‡ ÛŒÚ© Ú©Ø§Ù„Ø§ÛŒ Ø¨Ø±Ú¯Ø´ØªÛŒ Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯:Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§-Ø®Ø±ÛŒØ¯-Ø¯Ø±ÛŒØ§ÙØª Ø¨Ø¯ÙˆÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(454000,12612,'tr','Ä°ade edilen maddeyi PO Ã¼zerinde alÄ±nan hesap iÃ§in:<p><b>SipariÅŸ BorÃ§lar->-> satÄ±n alma</b><p>(Bu envanter azaltÄ±r) negatif bir miktar alÄ±rsÄ±nÄ±z.<p>AyrÄ±ca, negatif bir miktar iÃ§in yeni posta oluÅŸturmak sonra almak.',0),(454001,12612,'pl','Aby uwzglÄ™dniÄ‡ element zwrÃ³cony przyjÄ…Å‚ PO:<p><b>ZobowiÄ…zania-> zakup-> otrzymaÄ‡ bez PO</b><p>OtrzymujÄ… iloÅ›Ä‡ ujemnÄ…, (co spowoduje zmniejszenie zapasÃ³w).<p>MoÅ¼na rÃ³wnieÅ¼ wygenerowaÄ‡ nowy PO iloÅ›ci negatywnych, nastÄ™pnie jej otrzymania.',0),(454002,12612,'bg','Ð”Ð° ÑÐµ Ð¾Ñ‚Ñ‡Ð¸Ñ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð½Ð° PO:<p><b>Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ-> Ð·Ð°ÐºÑƒÐ¿ÑƒÐ²Ð°Ð½Ðµ Ð½Ð°-> Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚ Ð±ÐµÐ· PO</b><p>ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ (ÐºÐ¾ÐµÑ‚Ð¾ Ñ‰Ðµ Ð½Ð°Ð¼Ð°',0),(454003,12612,'ur','Ù¾ÙˆØ³Ù¹ Ù¾Ø± Ù…ÙˆØµÙˆÙ„Û ÙˆØ§Ù¾Ø³ÛŒ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù„ÛŒÛ’:<p><b>Ø¨ØºÛŒØ± Ù¾Ùˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ->-> Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº</b><p>Ø§ÛŒÚ© Ù…Ù†ÙÛŒ Ù…Ù‚Ø¯Ø§Ø± (Ø¬Ùˆ Ú©Û Ø¢Ù¾ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ù… ÛÙˆ Ø¬Ø§Ø¦Û’ Ú¯Ø§) ',0),(454004,12612,'sr','Ð£ Ð¾Ð±Ð·Ð¸Ñ€ Ð·Ð° Ð²Ñ€Ð°Ñ›ÐµÐ½Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½ Ð½Ð° ÐŸÐž:<p><b>Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð¸ ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ñƒ Ð¸ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼ Ð±ÐµÐ· ÐŸÐž</b><p>ÐŸÑ€Ð¸Ð¼Ð¸Ñ‚Ðµ Ð½ÐµÐºÑƒ Ð½ÐµÐ³Ð°Ñ‚Ð¸Ð²Ð½Ñƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ (ÐºÐ¾Ñ˜Ð¸ Ñ›Ðµ ÑÐ¼Ð°ÑšÐ¸Ñ‚Ð¸ Ñ‚Ð²Ð¾Ñ˜ Ð·Ð°Ð',0),(454005,12612,'vi','Äá»ƒ giáº£i thÃ­ch cho máº·t hÃ ng hoÃ n tráº£ trong PO: Pháº£i thanh toÃ¡n-mua hÃ ng-nháº­n khÃ´ng PO, nháº­n sá»‘ lÆ°á»£ng lÃ m giáº£m hÃ ng tá»“n kho. báº¡n cÅ©ng cÃ³ thá»ƒ táº¡o ra má»™t Po sá»‘ lÆ°á»£ng Ã¢m vÃ  nháº­n nÃ³',0),(454006,12612,'af','Om die rekening vir \'n teruggestuurde-item ontvang op PO:<p><b>Waardedalingstoetse->-> aankoop ontvang sonder PO</b><p>Ontvang \'n negatiewe hoeveelheid (wat sal verminder jou voorraad).<p>Jy kan ook \'n nuwe PO vir \'n negatiewe hoeveelheid genereer, en dan',0),(454007,12612,'ro','Pentru a cont pentru un element returnate primite pe PO:<p><b>Datorii-> de cumpÄƒrare-> primi fÄƒrÄƒ PO</b><p>Primesc o cantitate negativ (care va reduce inventar).<p>De asemenea, puteÅ£i genera o PO noi pentru o cantitate negativ, apoi Ã®l primesc.',0),(454008,12612,'et','Et vÃµtta arvesse tagastatud kauba saanud PO:<p><b>VÃµlad->-> ostmise vastu ilma PO</b><p>Saada negatiivne kogus, (mis vÃ¤hendab teie varudes).<p>Saate ka luua uue PO negatiivne kogus siis seda vastu vÃµtta.',0),(454009,12612,'si','RaÄun za vrnjeni artikel, prejet PO:<p><b>Obveznosti-> nakupu-> prejmete ne PO</b><p>Prejeli negativno koliÄino (kateri hoteti zmanjÅ¡ati zaloge).<p>Lahko tudi ustvarjajo nove pad za negativno koliÄino, nato pa prejeli.',0),(454010,12612,'ba','Untuk memperhitungkan item yang dikembalikan diterima pada PO:<p><b>Hutang-> membeli-> menerima tanpa PO</b><p>Menerima negatif kuantitas (yang akan mengurangi persediaan).<p>Anda juga dapat menghasilkan PO baru untuk kuantitas negatif, kemudian meneriman',0),(454011,12612,'nl','Ter verantwoording voor een geretourneerd artikel ontvangen op PO:<p><b>Schulden-> kopen-> ontvangen zonder PO</b><p>Ontvangen een negatief aantal (die zal verminderen uw voorraad).<p>U kunt ook een nieuwe PO voor een negatief aantal genereren en vervolge',0),(454012,12612,'fi','Huomioon palautettua nimikettÃ¤ vastaanotettaessa PO:<p><b>Ostovelat-> ostaa-> vastaanottaa ilman PO</b><p>Saavat negatiivisen mÃ¤Ã¤rÃ¤n, (joka vÃ¤hentÃ¤Ã¤ varaston).<p>Voit myÃ¶s luoda uuden PO negatiivinen arvo sitten perille.',0),(454013,12612,'no','Konto for en returnert vare pÃ¥ PO:<p><b>LeverandÃ¸rgjeld-> kjÃ¸pe-> motta uten PO</b><p>Motta et negativt antall (som vil redusere beholdningen).<p>Du kan ogsÃ¥ generere en ny PO for et negativt antall, deretter mottar den.',0),(454014,12612,'da','For at tage hÃ¸jde for en returneret vare modtaget pÃ¥ PO:<p><b>GÃ¦ld-> kÃ¸be-> modtager uden PO</b><p>Modtage et negativt antal, (som vil reducere din beholdning).<p>Du kan ogsÃ¥ generere en ny PO for et negativt antal, sÃ¥ modtager den.',0),(454015,12612,'ko','í¬ì— ë°›ì€ ë°˜í™˜ ë˜ëŠ” í•­ëª©ì— ëŒ€ í•œ ê³„ì •:<p><b>-> êµ¬ë§¤-> ë¯¸ì§€ê¸‰ê¸ˆ í¬ ì—†ì´ ìˆ˜ì‹ </b><p>ìŒì˜ ìˆ˜ëŸ‰ (ì–´ë–¤ ìž¬ê³ ë¥¼ ì¤„ì¼ ê²ƒìž…ë‹ˆë‹¤)ë¥¼ ë°›ì„ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.<p>ë˜í•œ ìŒì˜ ìˆ˜ëŸ‰ì— ëŒ€ í•œ ìƒˆ ì‚¬ì„œí•¨ ìƒì„± ë‹¤ìŒ ê·¸ê',0),(454016,12612,'he','×œ×§×—×ª ×‘×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×¤×¨×™×˜ ×ž×•×—×–×¨ ×”×ª×§×‘×œ ×‘ ×¤×•:<p><b>×–×›××™×-> ×¨×›×™×©×ª-> ×œ×§×‘×œ ×ž×‘×œ×™ ×¤×•</b><p>×ž×§×‘×œ×™× ×›×ž×•×ª ×©×œ×™×œ×™ (××©×¨ ×ª×¤×—×™×ª ××ª ×”×ž×œ××™ ×©×œ×š).<p>××ª×” ×™×›×•×œ ×’× ×œ×™×¦×•×¨ ×©×œ ×¤×• ×—×',0),(454017,12612,'el','ÎÎ± Î»Î¿Î³Î¿Î´Î¿Ï„Î®ÏƒÎµÎ¹ Î³Î¹Î± Î­Î½Î± ÎµÎ¯Î´Î¿Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹ÏƒÏ„ÏÎ¬Ï†Î·ÎºÎµ Ï€ÎµÏÎ¹Î®Î»Î¸Îµ ÏƒÏ„Î¹Ï‚ PO:<p><b>Î Î»Î·ÏÏ‰Ï„Î­Ï‰Î½-> Î±Î³Î¿ÏÎ¬-> Î»Î¬Î²ÎµÏ„Îµ Ï‡Ï‰ÏÎ¯Ï‚ PO</b><p>Î›Î¬Î²ÎµÏ„Îµ Î¼Î¹Î± Î±ÏÎ½Î·Ï„Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± (Î· Î¿Ï€Î¿Î¯Î± Î',0),(454018,12612,'zh','è¦è¯´æ˜Žä¸€ä¸ªè¿”å›žçš„è®¢å•é¡¹ç›®å·²æŽ¥æ”¶ï¼šåº”ä»˜è´¦æ¬¾->è´­ä¹°->æ”¶åˆ°æ²¡æœ‰è®¢å•è´§ç‰©\r\næ”¶åˆ°ä¸€ä¸ªè´Ÿæ•°é‡ï¼ˆä¼šå‡å°‘æ‚¨çš„åº“å­˜ï¼‰ã€‚æ‚¨ä¹Ÿå¯ä»¥ä¸ºä¸€ä¸ªè´Ÿæ•°é‡å»ºç«‹ä¸€ä¸ªæ–°çš„è®¢å•ï¼Œç„¶åŽæŽ¥å—å®ƒã€‚',0),(454019,12612,'sv','Att redovisa fÃ¶r en returnerad artikel mottagen PO:<p><b>LeverantÃ¶rsskulder-> kÃ¶per-> fÃ¥r utan PO</b><p>FÃ¥r en negativ kvantitet (vilket kommer att minska ditt lager).<p>Du kan ocksÃ¥ generera en ny PO fÃ¶r en negativ kvantitet, sedan ta emot den.',0),(454020,12612,'it','Per tenere conto di un elemento restituito ricevuto sul PO:<p><b>Debiti-> acquisto-> ricevano senza PO</b><p>Ricevere una quantitÃ  negativa (che ridurrÃ  il vostro inventario).<p>Ãˆ inoltre possibile generare un nuovo PO per una quantitÃ  negativa, quind',0),(454021,12612,'tl','',0),(454022,12612,'th','à¸šà¸±à¸à¸Šà¸µà¸à¸²à¸£à¸£à¸±à¸šà¹ƒà¸™ PO:<p><b>à¹€à¸ˆà¹‰à¸²->à¸‹à¸·à¹‰à¸­->à¸£à¸±à¸š à¹‚à¸”à¸¢ PO</b><p>à¸£à¸±à¸šà¸›à¸£à¸´à¸¡à¸²à¸“à¸„à¹ˆà¸²à¸¥à¸š (à¸‹à¸¶à¹ˆà¸‡à¸ˆà¸°à¸Šà¹ˆà¸§à¸¢à¸¥à¸”à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡)<p>à¸„à¸¸à¸“à¸ªà¸²à¸¡à¸²à¸£à¸–à¸',0),(454023,12612,'hi','à¤•à¥‹à¤ˆ à¤²à¥Œà¤Ÿà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤® à¤ªà¤° à¤ªà¥‹ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤:<p><b>à¤•à¥à¤°à¤¯->-> payables PO à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤</b><p>à¤à¤• à¤¨à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤',0),(454024,12612,'ms','Kepada akaun bagi item-item yang dikembalikan yang diterima pada PO:<p><b>Pemiutang-> membeli-> menerima tanpa PO</b><p>Menerima bahan negatif (yang akan mengurangkan inventori anda).<p>Anda juga boleh menjana PO baru untuk kuantiti negatif, maka ianya di',0),(454025,12612,'ar','Ù„Ø­Ø³Ø§Ø¨ ØµÙ†Ù Ø§Ù„Ù…Ø±ØªØ¬Ø¹ Ø§Ù„ÙˆØ§Ø±Ø¯Ø© ÙÙŠ Øµ. Ø¨:<p><b>Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø¨Ø§Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹-> Ø´Ø±Ø§Ø¡-> Ø¯ÙˆÙ† Ø¨Ùˆ</b><p>ØªØªÙ„Ù‚Ù‰ ÙƒÙ…ÙŠØ© Ø³Ø§Ù„Ø¨Ø© (Ø§Ù„Ø°ÙŠ Ø³ÙŠØªÙ… ØªÙ‚Ù„ÙŠÙ„ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ).<p>ÙŠÙ…Ùƒ',0),(454026,12612,'fr','Afin de tenir compte pour un article retournÃ© reÃ§u le PO :<p><b>Comptes fournisseurs-> d\'achat-> recevoir sans PO</b><p>Recevoir une quantitÃ© nÃ©gative (ce qui permettra de rÃ©duire votre inventaire).<p>Vous pouvez Ã©galement gÃ©nÃ©rer un nouveau PO po',0),(454027,12612,'jp','PO å—ä¿¡è¿”ã•ã‚Œã‚‹é …ç›®ã‚’ï¼š<p><b>-> ã‚’è³¼å…¥-> å‚µå‹™ PO ã›ãšå—ä¿¡ã—ã¾ã™ã€‚</b><p>ï¼ˆã“ã‚Œã¯ã‚ãªãŸã®åœ¨åº«ã‚’å‰Šæ¸›) å¦å®šçš„ãªé‡ã‚’å—ã‘å–ã‚‹ã€‚<p>è² ã®æ•°é‡ã®æ–°ã—ã„ PO ã‚’ç”Ÿæˆã—ã€ãã‚Œã‚’å—ã‘å–ã‚‹ã“ã¨ã‚‚ã§ãã¾ã',0),(454028,12612,'pt','A conta para um item retornado recebido em PO:<p><b>Contas a pagar-> compra-> recebe sem PO</b><p>Receba uma quantidade negativa (que irÃ¡ reduzir seu inventÃ¡rio).<p>VocÃª tambÃ©m pode gerar um novo PO para uma quantidade negativa, e recebÃª-lo.',0),(454029,12612,'ru','Ð”Ð»Ñ ÑƒÑ‡ÐµÑ‚Ð° Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð½Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð½Ð° PO:<p><b>ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ-> Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸-> Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð±ÐµÐ· PO</b><p>ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ',0),(454030,12612,'es','Para rendir cuenta de un item de devoluciÃ³n recibido en un OC:<p><b>Pagables -> Compras ->Recibe sin OC</b><p> Recibe una cantidad negativa (que reducirÃ¡ su inventario).<p>TambiÃ©n puede generar un nuevo OC para una cantidad negativa, entonces la recibe',0),(454031,12612,'de','Um ein zurÃ¼ckgerufenes Element empfangen am PO zu berÃ¼cksichtigen:<p><b>Verbindlichkeiten->-> Einkauf erhalten ohne PO</b><p>Erhalten Sie eine negative Menge (das Inventar reduziert wird).<p>Sie kÃ¶nnen auch eine neue PO fÃ¼r eine negative Menge zu gene',0),(454032,12612,'en','To account for a returned item received on PO:<p><b>Payables -> Purchasing -> Receive Without PO</b><p> Receive a negative quantity (which will reduce your inventory).<p>You can also generate a new PO for a negative quantity, then receive it.',0),(454033,12613,'is','',0),(454034,12613,'dr','',0),(454035,12613,'pr','',0),(454036,12613,'tr','',0),(454037,12613,'pl','',0),(454038,12613,'bg','',0),(454039,12613,'ur','',0),(454040,12613,'sr','',0),(454041,12613,'vi','',0),(454042,12613,'af','',0),(454043,12613,'ro','',0),(454044,12613,'et','',0),(454045,12613,'si','',0),(454046,12613,'ba','',0),(454047,12613,'nl','',0),(454048,12613,'fi','',0),(454049,12613,'no','',0),(454050,12613,'da','',0),(454051,12613,'ko','',0),(454052,12613,'he','',0),(454053,12613,'el','',0),(454054,12613,'zh','',0),(454055,12613,'sv','',0),(454056,12613,'it','',0),(454057,12613,'tl','',0),(454058,12613,'th','',0),(454059,12613,'hi','',0),(454060,12613,'ms','',0),(454061,12613,'ar','',0),(454062,12613,'fr','',0),(454063,12613,'jp','',0),(454064,12613,'pt','',0),(454065,12613,'ru','',0),(454066,12613,'es','',0),(454067,12613,'de','',0),(454068,12613,'en','',0),(454069,12614,'is','',0),(454070,12614,'dr','.Ø§Ú¯Ø± Ø´Ù…Ø§ÛŒÚ© Ø¨ÛŒØ¬Ú© Ø±Ø§ Ø¯Ø±ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ø¯Ø³ØªÛŒ Ú©Ù‡ Ø´Ù…Ø§Ø±Ù‡ ÛŒÚ©Ø³',0),(454071,12614,'pr','Ú©Ù†ØªØ±Ù„ Ø¯Ø³ØªÛŒ Ø¨Ø±Ø§ÛŒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÛŒÛŒ Ú©Ù‡ Ø´Ù…Ø§Ø§Ø² Ø·Ø±ÛŒÙ‚ ØµÙØ­Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙˆØ§Ø±Ø¯Ù†Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆÙ†Ø¯.Ø§Ú¯Ø± Ø´Ù…Ø§ÛŒÚ© ÙØ§Ú©ØªÙˆØ± Ø±Ø§ Ø¯Ø±ØµÙˆØ±ØªØ­Ø³Ø§Ø¨Ù‡Ø§ÛŒ Ø¯Ø³ØªÛŒ Ú©Ù‡ Ø´Ù…Ø§Ø±Ù‡ ÛŒÚ©Ø³Ø',0),(454072,12614,'tr','Manuel kontroller, yeni faturalarÄ± ekran girmediniz faturalarÄ± iÃ§in kullanÄ±lÄ±r. AynÄ± numara BorÃ§lar listesine el ile faturalarÄ± Fatura girerseniz hesabÄ± oluÅŸtururken bir hata ile bir ileti gÃ¶rÃ¼ntÃ¼lenir. ',0),(454073,12614,'pl','RÄ™czne kontrole sÄ… uÅ¼ywane dla rachunkÃ³w, ktÃ³re nie zostaÅ‚y wprowadzone przez nowy ekran rachunki. Po wprowadzeniu faktury w rÄ™czne rachunki, ktÃ³re jest ten sam numer w liÅ›cie zobowiÄ…zaÅ„ pojawi siÄ™ komunikat bÅ‚Ä…d tworzenie wyboru. ',0),(454074,12614,'bg','Ð ÑŠÑ‡Ð½Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ Ð·Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸, Ð½Ðµ ÑÑ‚Ðµ Ð²ÑŠÐ²ÐµÐ»Ð¸ Ð½Ð¾Ð² ÐµÐºÑ€Ð°Ð½ ÑÐ¼ÐµÑ‚ÐºÐ¸. ÐÐºÐ¾ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð² Ñ€ÑŠÑ‡Ð½Ð¾ ÑÐ¼ÐµÑ‚ÐºÐ¸, Ñ‚Ð¾Ð²Ð° Ðµ ÐµÐ´Ð¸Ð½ Ð¸ ÑÑŠÑ‰ Ð½Ð¾Ð¼ÐµÑ€ Ð² ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð·Ð°',0),(454075,12614,'ur','Ø¯Ø³ØªÛŒ Ú†ÛŒÚ© Ø¢Ù¾ Ú©Ùˆ Ù†Ø¦Û’ Ø¨Ù„ Ø³Ú©Ø±ÛŒÙ† Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ø¯Ø§Ø®Ù„ Ù†ÛÛŒÚº Ú©Û’ Ø¨Ù„ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û” Ø§Ú¯Ø± Ø¢Ù¾ Ø¯Ø³ØªÛŒ Ø¨Ù„ Ú©Û Ø¢Ù¾ Ú©Û’ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ Ú©ÛŒ ÙÛØ±Ø³Øª Ù…ÛŒÚº Ø§Ø³ÛŒ Ù†Ù…Ø¨Ø± ÛÛ’ Ù…ÛŒÚº Ø§',0),(454076,12614,'sr','Ð ÑƒÐºÐ¾Ð¼ Ð¿Ð¸ÑÐ°Ð½Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ðµ ÑÐµ Ð·Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð½Ð¸ÑÑ‚Ðµ ÑƒÐ½ÐµÐ»Ð¸ ÐºÑ€Ð¾Ð· Ð½Ð¾Ð²Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ ÐµÐºÑ€Ð°Ð½Ð°. ÐÐºÐ¾ ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ñƒ Ñ€ÑƒÑ‡Ð½Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ, Ñ‚Ð¾ Ñ˜Ðµ Ð¸ÑÑ‚Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð½Ð° Ð»Ð¸ÑÑ‚Ð¸ Ð´Ñƒ',0),(454077,12614,'vi','Kiá»ƒm tra báº±ng tay Ä‘Æ°á»£c sá»­ dá»¥ng cho cÃ¡c hÃ³a Ä‘Æ¡n báº¡n chÆ°a nháº­p thÃ´ng qua mÃ n hÃ¬nh hÃ³a Ä‘Æ¡n má»›i. Náº¿u báº¡n vÃ o má»™t hÃ³a Ä‘Æ¡n trong hÆ°á»›ng dáº«n sá»­ dá»¥ng hÃ³a Ä‘Æ¡n Ä‘Ã³ lÃ  cÃ¹ng má»™t sá»‘ trong danh sÃ¡ch cÃ¡c khoáº£n',0),(454078,12614,'af','Handmatige kontrole vir rekeninge wat jy ingetik het nie, deur die nuwe rekeninge skerm gebruik word. As jy \'n faktuur in handleiding rekeninge wat dieselfde nommer in jou Waardedalingstoetse lys tik \'n boodskap sal verskyn met \'n fout om die tjek te skep',0),(454079,12614,'ro','VerificÄƒri manuale sunt folosite pentru facturile nu aÅ£i introdus un nou ecran facturile. DacÄƒ introduceÅ£i o facturÄƒ Ã®n facturile manualÄƒ, care este acelaÅŸi numÄƒr Ã®n lista ta de cumpÄƒrÄƒri ÅŸi datorii va apÄƒrea un mesaj cu o eroare la crearea ',0),(454080,12614,'et','KÃ¤sitsi kontrolli kasutatakse arveid midagi pole uusi arveid ekraani kaudu. Arve sisestamisel kÃ¤sitsi arveid, mis on sama palju ostuvÃµlgade loend kuvatakse teade koos tÅ¡eki loomisel ilmnes tÃµrge. ',0),(454081,12614,'si','RoÄno pregledi se uporabljajo za raÄune niste vnesli skozi nov zaslon menice. ÄŒe vnesete raÄun v roÄni menice, ki je isto Å¡tevilko na seznamu obveznosti, se bo prikazalo sporoÄilo z napako ustvarjanje Äek. ',0),(454082,12614,'ba','Cek manual yang digunakan untuk tagihan Anda belum memasukkan melalui layar tagihan baru. Jika Anda memasukkan faktur tagihan manual yang adalah nomor yang sama dalam daftar hutang Anda pesan akan muncul pesan kesalahan yang membuat cek. ',0),(454083,12614,'nl','Handmatige controles worden gebruikt voor facturen die u niet hebt opgegeven via het nieuwe scherm van de rekeningen. Als u een factuur in handmatige rekeningen die hetzelfde nummer in de lijst van uw schulden invoert verschijnt een bericht met een fout b',0),(454084,12614,'fi','KÃ¤sin tarkistaa kÃ¤ytetÃ¤Ã¤n laskuja et ole kirjoittanut uusia laskuja nÃ¤ytÃ¶llÃ¤. Jos laskun syÃ¶ttÃ¤minen manuaalinen laskut, jotka on sama mÃ¤Ã¤rÃ¤ ostovelat-luettelosta viesti nÃ¤kyy virhe luotaessa sekin. ',0),(454085,12614,'no','Manuelle kontroller brukes for regninger ikke har angitt nye regninger skjermen. Hvis du angir en faktura i manuell regninger som er samme nummer i listen leverandÃ¸rgjeld vises en melding med en feil under oppretting av sjekk. ',0),(454086,12614,'da','Manuel kontrol anvendes for regninger, du ikke har indtastet via skÃ¦rmbilledet nye regninger. Hvis du indtaster en faktura i manuel regninger, der er det samme i din gÃ¦ld liste vises en meddelelse med en fejl under oprettelse af check. ',0),(454087,12614,'ko','ìˆ˜ë™ ê²€ì‚¬ ë²•ì•ˆ ìƒˆë¡œìš´ ê³„ì‚° ì„œ í™”ë©´ì„ í†µí•´ ìž…ë ¥ í•˜ì§€ ì‚¬ìš© ë©ë‹ˆë‹¤. ë¯¸ì§€ê¸‰ê¸ˆ ëª©ë¡ì— ê°™ì€ ë²ˆí˜¸ ìˆ˜ë™ ì²­êµ¬ì„œì— ì†¡ìž¥ì„ ìž…ë ¥ í•˜ë©´ ì²´í¬ë¥¼ ë§Œë“œëŠ” ì˜¤ë¥˜ ë©”ì‹œì§€ê°€ ë‚˜íƒ€ë‚©ë‹ˆë‹¤. ',0),(454088,12614,'he','×‘×“×™×§×•×ª ×™×“× ×™×•×ª ×ž×©×ž×©×™× ×¢×‘×•×¨ ×—×©×‘×•× ×•×ª ×©×œ× ×”×–× ×ª ×ž×‘×¢×“ ×œ×ž×¡×š ×©×˜×¨×•×ª ×—×“×©×™×. ×”×–×Ÿ ×—×©×‘×•× ×™×ª ×™×“× ×™×ª ××ª ×”×—×©×‘×•× ×•×ª ×–×” ××•×ª×• ×”×ž×¡×¤×¨ ×‘×¨×©×™×ž×” ×–×›××™× ×ª×•×¤×™×¢ ×”×•×“×¢×” ×¢× ××™',0),(454089,12614,'el','Î•Î³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î¿ ÎµÎ»Î­Î³Ï‡Ï‰Î½ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î´ÎµÎ½ Î­Ï‡ÎµÏ„Îµ ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÎ¹ Î¼Î­ÏƒÎ± Î±Ï€ÏŒ Ï„Î· Î½Î­Î± Î¿Î¸ÏŒÎ½Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚. Î‘Î½ ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î',0),(454090,12614,'zh','æ‰‹åŠ¨æ”¯ç¥¨ç”¨äºŽæ‚¨æ²¡æœ‰é€šè¿‡æ–°å¸é¡µé¢è¾“å…¥çš„å¸å•ã€‚å¦‚æžœæ‚¨åœ¨å…·æœ‰ä¸Žæ‚¨åº”ä»˜è´¦æ¬¾åˆ—è¡¨ç›¸åŒç¼–å·çš„æ‰‹åŠ¨å¸å•ä¸Šè¾“å…¥ä¸€ä¸ªæ”¯ç¥¨ï¼Œé”™è¯¯åˆ›å»ºæ”¯ç¥¨æ¶ˆæ¯å°†ä¼šå‡ºçŽ°ã€‚',0),(454091,12614,'sv','Manuella kontroller anvÃ¤nds fÃ¶r rÃ¤kningar du inte har angett via den nya rÃ¤kningar skÃ¤rmen. Om du anger en faktura i manuella rÃ¤kningar som Ã¤r samma nummer i listan leverantÃ¶rsskulder visas ett meddelande med ett fel att skapa kontrollen. ',0),(454092,12614,'it','Controlli manuali sono utilizzati per le bollette che non hai inserito attraverso il nuovo schermo di bollette. Se si immette una fattura in bollette manuale che Ã¨ lo stesso numero nel vostro elenco di debiti, apparirÃ  un messaggio con un errore durante',0),(454093,12614,'tl','',0),(454094,12614,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡à¸ˆà¸°à¹ƒà¸Šà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¸„à¸¸à¸“à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸›à¹‰à¸­à¸™à¸œà¹ˆà¸²à¸™à¸«à¸™à¹‰à¸²à¸ˆà¸­à¸ªà¸¹à¸•à¸£à¹ƒà¸«à¸¡à¹ˆ à¸–à¹‰à¸²à¸„à¸¸à¸“à¸›à¹‰à¸­à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸',0),(454095,12614,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤šà¥‡à¤• à¤¬à¤¿à¤² à¤†à¤ªà¤•à¥‹ à¤¨à¤¯à¤¾ à¤¬à¤¿à¤² à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤¦à¤°à¥à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤¹à¥ˆ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¹à¥ˆà¥¤ à¤¯à¤¦à',0),(454096,12614,'ms','Pemeriksaan secara manual yang digunakan untuk bil-bil yang anda belum melalui skrin bil baru. Jika anda memasukkan invois dalam bil-bil secara manual iaitu dengan bilangan yang sama dalam senarai pemiutang mesej akan muncul dengan ralat yang mewujudkan c',0),(454097,12614,'ar','ÙŠØªÙ… Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„ÙØ­Øµ Ø§Ù„ÙŠØ¯ÙˆÙŠ Ù„Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªÙŠ Ù„Ù… ØªÙ‚Ù… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ù…Ù† Ø®Ù„Ø§Ù„ Ø´Ø§Ø´Ø© ÙÙˆØ§ØªÙŠØ± Ø¬Ø¯ÙŠØ¯Ø©. Ø¥Ø°Ø§ Ù‚Ù…Øª Ø¨Ø¥Ø¯Ø®Ø§Ù„ ÙØ§ØªÙˆØ±Ø© ÙÙŠ ÙÙˆØ§ØªÙŠØ± Ø§Ù„ÙŠØ¯ÙˆÙŠ Ø§Ù„Ø°ÙŠ Ù‡Ùˆ Ù†ÙØ³ Ø§Ù„Ø±Ù‚Ù… ÙÙŠ Ù‚',0),(454098,12614,'fr','ContrÃ´les manuels sont utilisÃ©s pour les factures, que vous n\'avez pas saisi via le nouvel Ã©cran de factures. Si vous saisissez une facture dans des projets de loi manuels qui est le mÃªme numÃ©ro dans votre liste des comptes fournisseurs, qu\'un messag',0),(454099,12614,'jp','æ–°ã—ã„è«‹æ±‚æ›¸ç”»é¢ã‚’å…¥åŠ›ã—ã¦ã„ãªã„æ‰‹å½¢æ‰‹å‹•ãƒã‚§ãƒƒã‚¯ãŒä½¿ç”¨ã•ã‚Œã¾ã™ã€‚æ‰‹å‹•æ‰‹å½¢å‚µå‹™ãƒªã‚¹ãƒˆã§åŒã˜æ•°ã§ã‚ã‚‹ã«è«‹æ±‚æ›¸ã‚’å…¥åŠ›ã—ãŸå ´åˆã€ãƒã‚§ãƒƒã‚¯ã‚’ä½œæˆä¸­ã«ã‚¨ãƒ©ãƒ¼ã¨è¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(454100,12614,'pt','Controlos manuais sÃ£o utilizados para as contas que vocÃª nÃ£o digitou atravÃ©s da nova tela de contas. Se vocÃª inserir uma factura em notas manuais que Ã© o mesmo nÃºmero na sua lista de contas a pagar, que aparecerÃ¡ uma mensagem com um erro ao criar ',0),(454101,12614,'ru','Ð ÑƒÑ‡Ð½Ð¾Ð¹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑŽÑ‚ÑÑ Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð°, ÐºÐ¾Ñ‚Ð¾Ñ€ÑƒÑŽ Ð²Ñ‹ Ð²Ð²ÐµÐ»Ð¸ Ð½Ðµ Ñ‡ÐµÑ€ÐµÐ· ÑÐºÑ€Ð°Ð½ Ð½Ð¾Ð²Ñ‹Ñ… Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¾Ð². Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð²Ð²ÐµÐ´ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð² Ñ€ÑƒÑ‡Ð½Ð¾Ð¹ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐº',0),(454102,12614,'es','Cheques manuales se usan par recibos que no se han entrado por la pantalla de nuevos recibos. Si entra una factura en recibos manuales eso es el mismo nÃºmero en su lista de pagables, un mensaje aparecerÃ¡ con un error creando el cheque.',0),(454103,12614,'de','Manuelle Kontrollen werden Rechnungen, die Sie nicht durch den neuen Rechnungen-Bildschirm eingegeben haben. Wenn Sie eine Rechnung in Manuelle Rechnungen, die die gleiche Anzahl in Ihrer Verbindlichkeiten-Liste eingeben erscheint eine Meldung mit Fehler ',0),(454104,12614,'en','Manual checks are used for bills you have not entered through the new bills screen. If you enter an invoice in manual bills that is the same number in your payables list a message will appear with an error creating the check. ',0),(454105,12615,'is','',0),(454106,12615,'dr','Ø§Ú¯Ø±Ø´Ù…Ø§ Ø®Ø·Ø§ÛŒ Ú†Ú© Ø¯Ø³ØªÛŒ(Ú©Ù†ØªØ±Ù„ Ø¯Ø³ØªÛŒ) Ø¨Ø§ Ø¹Ù†ÙˆØ§Ù† \" Ù‡ÛŒÚ† Ø­Ø³Ø§Ø¨ Ù„ÛŒØ¬Ø±ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡\" Ø±Ø§ Ø¯Ø±ÛŒØ§ÙØª Ú©Ø±Ø¯ÛŒØ¯Ù…Ø³ÛŒØ± Ø²ÛŒØ± Ø±Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ú©Ù†ÛŒØ¯:Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ… Ø­Ø³',0),(454107,12615,'pr','Ø§Ú¯Ø±Ø´Ù…Ø§ Ø®Ø·Ø§ÛŒ Ú†Ú© Ø¯Ø³ØªÛŒ(Ú©Ù†ØªØ±Ù„ Ø¯Ø³ØªÛŒ) Ø¨Ø§ Ø¹Ù†ÙˆØ§Ù† \" Ù‡ÛŒÚ† Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡\" Ø±Ø§ Ø¯Ø±ÛŒØ§ÙØª Ú©Ø±Ø¯ÛŒØ¯Ù…Ø³ÛŒØ± Ø²ÛŒØ± Ø±Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ú©Ù†ÛŒØ¯:Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ… Ø­Ø³Ø',0),(454108,12615,'tr','Manuel kontrol hatasÄ± alÄ±rsanÄ±z \"HayÄ±r GL hesabÄ± seÃ§tiyseniz miktar iÃ§in\"\'check-in:<p><b>YÃ¶netici Kurulumu BorÃ§lar Genel Kurulum->-></b><p>BazÄ± hesaplarÄ±n dÃ¼zgÃ¼n doldurulur deÄŸil muhtemeldir.',0),(454109,12615,'pl','JeÅ›li zostanie wyÅ›wietlony bÅ‚Ä…d sprawdziÄ‡ podrÄ™cznik \"Nr GL konta wybrana na kwotÄ™\" zameldowanie:<p><b>Admin-> zobowiÄ…zania ustawienia-> ustawienia ogÃ³lne</b><p>Jest to prawdopodobnie niektÃ³re z konta nie zostanÄ… wypeÅ‚nione prawidÅ‚owo.',0),(454110,12615,'bg','ÐÐºÐ¾ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð° ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° \"â„– GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð·Ð° ÑÑƒÐ¼Ð°\" Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ-> ÐžÐ±Ñ‰Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°</',0),(454111,12615,'ur','Ø§Ú¯Ø± Ø¢Ù¾ Ø¯Ø³ØªÛŒ Ù¾Ú‘ØªØ§Ù„ Ù†Ù‚Øµ ÙˆØµÙˆÙ„ \"Ú©ÙˆØ¦ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ø±Ù‚Ù… Ú©Û’ Ù„ÛŒÛ’\" Ù…ÛŒÚº Ú†ÛŒÚ© Ú©Ø±ÛŒÚº:<p><b>Ø§ÛŒÚˆÙ…Ù†-> Ø¬Ù†Ø±Ù„ Ø³ÛŒÙ¹ Ø§Ù¾ Ø³ÛŒÙ¹ Ø§Ù¾ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³-></b><p>ÛŒÛ Ø§Ù…Ú©Ø§Ù† Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ù…ÛŒ',0),(454112,12615,'sr','ÐÐºÐ¾ Ð´Ð¾Ð±Ð¸Ñ˜ÐµÑ‚Ðµ Ð³Ñ€ÐµÑˆÐºÑƒ Ð¿Ñ€Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸ Ð¿Ñ€Ð¸Ñ€ÑƒÑ‡Ð½Ð¸Ðº \"ÐÐµ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ\" Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð·Ð° Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ñƒ Ð¸ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð³Ð»Ð°Ð',0),(454113,12615,'vi','Náº¿u báº¡n nháº­n 1 lá»—i kiá»ƒm tra tay\"khÃ´ng cÃ³ TK GL Ä‘á»ƒ chá»n sá»‘ tiá»n\". VÃ o quáº£n trá»‹-thiáº¿t láº­p cÃ¡c khoáº£n pháº£i tráº£-thiáº¿t láº­p chung.NÃ³ cÃ³ thá»ƒ lÃ  má»™t vÃ i TK khÃ´ng Ä‘Ãºng',0),(454114,12615,'af','As jy ontvang \'n handleiding gaan fout \"Nee GL rekening gekies vir bedrag\" in kontroleer:<p><b>Admin-> opstelling Waardedalingstoetse-> algemene opstelling</b><p>Dit is waarskynlik sommige van die rekeninge is nie ingevul behoorlik.',0),(454115,12615,'ro','DacÄƒ primiÅ£i o eroare de Manual a verifica \"No GL contul selectat pentru suma\" check-in:<p><b>Admin-> Parametrizare cumpÄƒrÄƒri ÅŸi datorii-> General Setup</b><p>Este probabil unele dintre conturile nu sunt completate mod corespunzÄƒtor.',0),(454116,12615,'et','Kui kÃ¤sitsi kontrollida tÃµrge \"Nr GL konto valitud summa eest\" sisse:<p><b>Admin-> seadistus hankijatele-> Ã¼ldine seadistus</b><p>TÃµenÃ¤oliselt mÃµned kontod on tÃ¤idetud nÃµuetekohaselt.',0),(454117,12615,'si','ÄŒe roÄno preverite napaki \"No GL raÄun izbrana za znesek\" vpisati:<p><b>Admin-> Setup obveznosti-> Nastavitev sploÅ¡nega</b><p>To je verjetno nekaj raÄunov ne izpolnite pravilno.',0),(454118,12615,'ba','Jika Anda menerima galat Periksa Manual \"No GL Account yang dipilih untuk jumlah\" check-in:<p><b>Admin-> Setup hutang-> tetapan Umum</b><p>Ada kemungkinan beberapa account tidak diisi dengan benar.',0),(454119,12615,'nl','Als u een handleiding controleren fout ontvangt inchecken \"No GL Account geselecteerd voor bedrag\":<p><b>Admin-> Setup schulden-> algemene Setup</b><p>Het is waarschijnlijk dat sommige van de rekeningen niet correct zijn ingevuld.',0),(454120,12615,'fi','Jos manuaalinen tarkistaa virhe \"N GL huomioon valittu mÃ¤Ã¤rÃ¤\" tarkistaa:<p><b>Admin asetukset ostovelkojen-> asennuksen-></b><p>On todennÃ¤kÃ¶istÃ¤, joidenkin tilien ei ole tÃ¤ytetty oikein.',0),(454121,12615,'no','Hvis du fÃ¥r en manuell sjekk feil innsjekking \"No GL konto valgt for belÃ¸p\":<p><b>Admin-> Setup leverandÃ¸rgjeld-> generelt oppsett</b><p>Det er trolig noen av kontoene ikke er fylt ut riktig.',0),(454122,12615,'da','Hvis du modtager fejlen manuel Check indtjekning \"No GL konto valgt for belÃ¸b\":<p><b>Admin-> Setup kreditorstyring-> General Setup</b><p>Det er sandsynligvis nogle af regnskaberne ikke er udfyldt korrekt.',0),(454123,12615,'ko','ìˆ˜ë™ í™•ì¸ ì˜¤ë¥˜ê°€ ë°œìƒ í•˜ë©´ \"No GL ê³„ì • ì„ íƒí•œ ê¸ˆì•¡ì— ëŒ€ í•œ\" ì²´í¬ ì¸:<p><b>ì¼ë°˜ ì„¤ì¹˜-> ì„¤ì¹˜ ë¯¸ì§€ê¸‰ê¸ˆ-> ê´€ë¦¬ìž</b><p>ê³„ì • ì¤‘ ì¼ë¶€ ì œëŒ€ë¡œ ê°€ë“ í•˜ì§€ ë†’ìŠµë‹ˆë‹¤.',0),(454124,12615,'he','×× ×ž×ª×§×‘×œ×ª ×©×’×™××ª ×œ×‘×“×•×§ ×™×“× ×™×ª \"×œ× GL ×—×©×‘×•×Ÿ × ×‘×—×¨ ×‘×¡×›×•×\" ×‘×“×•×§ ×‘:<p><b>Admin-> ×”×”×ª×§× ×” ×–×›××™×-> ×›×œ×œ×™ ×”×ª×§× ×”</b><p>×¡×‘×™×¨ ×©×—×œ×§ ×”×—×©×‘×•× ×•×ª ×œ× ×ž×•×œ××• ×›×¨××•×™.',0),(454125,12615,'el','Î•Î¬Î½ Î»Î¬Î²ÎµÏ„Îµ Î­Î½Î± ÏƒÏ†Î¬Î»Î¼Î± ÎµÎ»Î­Î³Î¾Ï„Îµ ÎµÎ³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î¿ \"No GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ Î³Î¹Î± Ï€Î¿ÏƒÏŒ\" check-in:<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½-> Î Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ·</b><p>Î•Î¯Î½Î±Î¹ ',0),(454126,12615,'zh','å¦‚æžœæ‚¨æ”¶åˆ°ä¸€ä¸ªæ‰‹åŠ¨æ”¯ç¥¨é”™è¯¯â€œæ²¡æœ‰ä¸ºé‡‘é¢é€‰ä¸­æ€»å¸å¸å·â€ï¼Œç™»å…¥ï¼šç®¡ç†->è®¾ç½®åº”ä»˜è´¦æ¬¾>æ™®é€šè®¾ç½®\r\nä¹Ÿè®¸æ˜¯å› ä¸ºæ²¡æœ‰æ­£ç¡®å¡«å†™æŸäº›å¸æˆ·ã€‚',0),(454127,12615,'sv','Om du fÃ¥r manuellt kontrollera felmeddelandet incheckning \"Nr GL konto valt belopp\":<p><b>Admin-> Setup leverantÃ¶rsskulder-> allmÃ¤n instÃ¤llning</b><p>Det Ã¤r sannolikt nÃ¥gra av kontona inte fylls i korrekt.',0),(454128,12615,'it','Se si riceve un errore di verifica manuale \"No GL Account selezionato per quantitÃ \" check-in:<p><b>Admin-> Setup debiti-> Setup generale</b><p>Ãˆ probabile che alcuni dei conti non sono stati compilati correttamente.',0),(454129,12615,'tl','',0),(454130,12615,'th','à¸–à¹‰à¸²à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡ \"à¹„à¸¡à¹ˆà¸¡à¸µ GL à¹€à¸¥à¸·à¸­à¸à¸šà¸±à¸à¸Šà¸µà¸ªà¸³à¸«à¸£à¸±à¸šà¸¢à¸­à¸”à¹€à¸‡à¸´à¸™\" à¹€à¸Šà¹‡à¸„à¸­à¸´à¸™:<p><b>Admin->à¹€à¸ˆà¹‰à¸²à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²->à¸•à¸±à¹‰à¸‡à¸„',0),(454131,12615,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤à¤• à¤®à¥ˆà¤¨à¥à¤…à¤² à¤•à¥€ à¤œà¤¾à¤à¤š à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚ \"à¤¸à¤‚ GL à¤–à¤¾à¤¤à¥‡ à¤šà¥à¤¨à¤¾ à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤²à¤¿à¤\":<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª Paya',0),(454132,12615,'ms','Jika anda mendapat ralat semak Manual \"No GL akaun terpilih bagi jumlah\" semak:<p><b>Admin-> persediaan pemiutang-> persediaan umum</b><p>Ini mungkin sebahagian daripada akaun-akaun tidak diisi dengan betul.',0),(454133,12615,'ar','Ø¥Ø°Ø§ ÙƒÙ†Øª ØªØªÙ„Ù‚Ù‰ Ø®Ø·Ø£ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø¯Ù„ÙŠÙ„ \"Ù„Ø§ GL Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø­Ø¯Ø¯ Ù„Ù…Ù‚Ø¯Ø§Ø±\" ØªØ­Ù‚Ù‚:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø¥Ø¹Ø¯Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø¹Ø§Ù…Ø©</b><p>ÙˆÙŠØ±Ø¬Ø­ Ø¨Ø¹Ø¶ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ù„Ø§ ÙŠØªÙ…',0),(454134,12615,'fr','Si vous recevez une erreur de contrÃ´le manuel Â« Non GL compte sÃ©lectionnÃ© pour montant Â» arrivÃ©e :<p><b>Admin-> configuration des comptes fournisseurs-> installation gÃ©nÃ©rale</b><p>Il est probable que certains des comptes ne sont pas remplis corre',0),(454135,12615,'jp','ãƒžãƒ‹ãƒ¥ã‚¢ãƒ« ãƒã‚§ãƒƒã‚¯ ã‚¨ãƒ©ãƒ¼ãŒç™ºç”Ÿã™ã‚‹å ´åˆã¯ãƒã‚§ãƒƒã‚¯ã‚¤ãƒ³ã€ŒGL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆé¸æŠžãªã—é‡‘é¡ã‚’ã€ï¼š<p><b>ä¸€èˆ¬çš„ãªã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—-> ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—å‚µå‹™-> ç®¡ç†è€…</b><p>ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ä¸€éƒ¨ã¯é©åˆ‡å¡—ã‚Šã¤ã¶',0),(454136,12615,'pt','Se vocÃª receber um erro de verificar Manual \"NÃ£o GL conta selecionada para quantidade\" check-in:<p><b>Admin-> contas a pagar-> General Setup configuraÃ§Ã£o</b><p>Ã‰ provÃ¡vel que algumas das contas nÃ£o sÃ£o preenchidas corretamente.',0),(454137,12615,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»Ð¸ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¾Ð± Ð¾ÑˆÐ¸Ð±ÐºÐµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ñ€ÑƒÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ Â«No GL ÑÑ‡ÐµÑ‚ Ð²Ñ‹Ð±Ñ€Ð°Ð½ Ð½Ð° ÑÑƒÐ¼Ð¼ÑƒÂ» Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹->',0),(454138,12615,'es','Si recibe un Error de Cheque Manual \"No Seleccionaba una Cuenta LM Por la Cantidad\" chequea en<p><b>Admin -> ConfiguraciÃ³n Pagables -> ConfiguraciÃ³n General</b><p>Es probable que unas de las cuentas no estan llenadas correctamente.',0),(454139,12615,'de','Wenn Sie einen Manual Check Fehler erhalten Einchecken \"Nr. GL Konto ausgewÃ¤hlt fÃ¼r Betrag\":<p><b>Admin-> Setup Verbindlichkeiten-> General Setup</b><p>Es ist wahrscheinlich, dass einige der Konten nicht richtig ausgefÃ¼llt sind.',0),(454140,12615,'en','If you receive a Manual Check Error \"No GL Account Selected for Amount \" check in:<p><b>Admin -> Setup Payables -> General Setup</b><p>It is likely some of the accounts are not filled in properly.',0),(454141,12616,'is','',0),(454142,12616,'dr','',0),(454143,12616,'pr','',0),(454144,12616,'tr','',0),(454145,12616,'pl','',0),(454146,12616,'bg','',0),(454147,12616,'ur','',0),(454148,12616,'sr','',0),(454149,12616,'vi','',0),(454150,12616,'af','',0),(454151,12616,'ro','',0),(454152,12616,'et','',0),(454153,12616,'si','',0),(454154,12616,'ba','',0),(454155,12616,'nl','',0),(454156,12616,'fi','',0),(454157,12616,'no','',0),(454158,12616,'da','',0),(454159,12616,'ko','',0),(454160,12616,'he','',0),(454161,12616,'el','',0),(454162,12616,'zh','',0),(454163,12616,'sv','',0),(454164,12616,'it','',0),(454165,12616,'tl','',0),(454166,12616,'th','',0),(454167,12616,'hi','',0),(454168,12616,'ms','',0),(454169,12616,'ar','',0),(454170,12616,'fr','',0),(454171,12616,'jp','',0),(454172,12616,'pt','',0),(454173,12616,'ru','',0),(454174,12616,'es','',0),(454175,12616,'de','',0),(454176,12616,'en','',0),(454177,12617,'is','',0),(454178,12617,'dr',':ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-Ø¨ÛŒØ¬Ú©Ù‡Ø§-Ù„ØºÙˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§.Ø´Ù…Ø§Ø±Ù‡ Ø§Ø¹ØªØ¨Ø§Ø± Ø¨ÛŒØ¬Ú© ÛŒØ§Ø®Ø±ÛŒØ¯Ø§Ø±Ø§Ù†  Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯Ùˆ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ Ù„ØºÙˆ Ú©Ù†ÛŒØ¯.ØµØ¯ÙˆØ± ØµÙˆØ±Øª',0),(454179,12617,'pr','Ù„ØºÙˆ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ:ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨-ÙØ§Ú©ØªÙˆØ±Ù‡Ø§-Ù„ØºÙˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§.Ø´Ù…Ø§Ø±Ù‡ Ø§Ø¹ØªØ¨Ø§Ø± ÙØ§Ú©ØªÙˆØ± ÛŒØ§Ø®Ø±ÛŒØ¯Ø§Ø±Ø§Ù†  Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯Ùˆ Ø¨Ø§Ø² Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ Ù„ØºÙˆ Ú©Ù†ÛŒØ¯.ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ',0),(454180,12617,'tr','Ä°ade faturasÄ± iptal etmek:<p><b>Fatura fatura Ã¶demeleri Void->->.</b><p>Ä°ade faturasÄ± numarasÄ±nÄ± veya mÃ¼ÅŸteri ve iptal geri Ã¶deme girin.<p><b>Fatura faturalarÄ± Fatura dÃ¼zenleme->->.</b><p>Ä°ade faturasÄ± dÃ¼zenleyin. \"Unpost\"\'i tÄ±klatÄ±n.<p>F',0),(454181,12617,'pl','Anulowanie faktury korygujÄ…cej:<p><b>PÅ‚atnoÅ›ci-> faktury-> pÅ‚atnoÅ›ci za niewaÅ¼ne.</b><p>Wpisz numer faktury kredytu lub klienta i niewaÅ¼ne refundacji.<p><b>PÅ‚atnoÅ›ci-> faktury-> edycja faktury.</b><p>Edytuj rachunku kredytowego. Kliknij \"Unpost\".',0),(454182,12617,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ Ð·Ð° Ð¾Ñ‚ÐºÐ°Ð·:<p><b>Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ-> Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸-> Ð½ÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ.</b><p>Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð¸Ð»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸ Ð½ÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ Ð²ÑŠÐ·',0),(454183,12617,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº:<p><b>Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ø§Ø·Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ->-> Û”</b><p>Ú©Ø±ÛŒÚˆÙ¹ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø± ÛŒØ§ Ú¯Ø§ÛÚ© Ø§ÙˆØ± Ø¨Ø§Ø·Ù„ ÙˆØ§Ù¾Ø³ÛŒ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”<p><b>Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ÙˆØ¨Ø¬',0),(454184,12617,'sr','ÐžÑ‚ÐºÐ°Ð¶Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ:<p><b>Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐ° Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð° Ð¸ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ.</b><p>Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸Ñ… \"Ð¸Ð»Ð¸\" ÐšÑƒÐ¿Ð°Ñ† \"Ð¸\" Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ñƒ Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°.<p><b>Ð¤Ð°',0),(454185,12617,'vi','há»§y báº£ng ghi nhá»› tÃ­n dá»¥ng: Thanh toÃ¡n-hÃ³a Ä‘Æ¡n-vÃ´ hiá»‡u hÃ³a cÃ¡c khoáº£n thanh toÃ¡n. Nháº­p sá»‘ hÃ³a Ä‘Æ¡n tÃ­n dá»¥ng hoáº·c khÃ¡ch hÃ ng vÃ  vÃ´ hiÃªu hoÃ n tráº£. Thanh toÃ¡n-hÃ³a Ä‘Æ¡n-sá»­a hÃ³a Ä‘Æ¡n, nháº¥p \"un-post\"',0),(454186,12617,'af','Kanselleer krediet Memo:<p><b>Fakturering-> fakture-> leemte betalings.</b><p>Tik krediet faktuur nommer of kliÃ«nt en leemte terugbetaling.<p><b>Fakturering-> fakture-> redigeer faktuur.</b><p>Redigeer die krediet faktuur. Klik \"Unpost\".<p>Na die faktuur',0),(454187,12617,'ro','NotÄƒ de Credit de anulare:<p><b>Facturare-> facturi-> nul plÄƒÅ£i.</b><p>IntroduceÅ£i numÄƒrul de facturÄƒ credit sau client ÅŸi restituirea nule.<p><b>Facturare-> facturi-> Edit facturÄƒ.</b><p>Editare factura de credit. FaceÅ£i clic pe \"Unpost\".<p>DupÄ',0),(454188,12617,'et','Kreeditarve Ã¶elda:<p><b>Arved arved-> tÃ¼hine makseid->.</b><p>Sisestage krediidi arvenumbri vÃµi kliendi ja tÃ¼hine toetust.<p><b>->-> Edit arve arved arvete koostamine.</b><p>Redigeeri laenu arvelt. KlÃµpsake \"Unpost\".<p>PÃ¤rast unposting arve saate se',0),(454189,12617,'si','PrekliÄi dobropis:<p><b>ZaraÄunavanje-> raÄuni-> niÄna plaÄila.</b><p>Vnesite Å¡tevilko raÄuna kreditne ali kupca in niÄna nadomestila.<p><b>ZaraÄunavanje-> raÄuni-> urejanje raÄuna.</b><p>Urejanje kreditne raÄuna. Kliknite \"Unpost\".<p>Po unpos',0),(454190,12617,'ba','Membatalkan Memo kredit:<p><b>Penagihan-> faktur-> Batal pembayaran.</b><p>Masukkan nomor invoice kredit atau pelanggan dan pengembalian Batal.<p><b>Penagihan-> faktur-> Edit faktur.</b><p>Mengedit faktur kredit. Klik \"Unpost\".<p>Setelah unposting faktur ',0),(454191,12617,'nl','Annuleren creditnota:<p><b>Facturering-> facturen-> vervallen betalingen.</b><p>Voer credit factuurnummer of klant en nietig restitutie.<p><b>Facturering-> facturen-> bewerken factuur.</b><p>Bewerk de krediet-factuur. Klik op \"Unpost\".<p>Na unposting de f',0),(454192,12617,'fi','Peruuta hyvityslaskun:<p><b>Laskutus laskujen-> mitÃ¤tÃ¶n maksujen->.</b><p>Kirjoita luotto laskunumeron tai asiakkaan ja mitÃ¤tÃ¶n tuen.<p><b>Laskutus laskujen-> Muokkaa laskun->.</b><p>Muokkaa luotto laskua. Valitse \"Unpost\".<p>JÃ¤lkeen unposting lasku ',0),(454193,12617,'no','Avbryte kreditnota:<p><b>Fakturering-> fakturaer-> ugyldig betalinger.</b><p>Angi kreditt fakturanummer eller kundens og ugyldige refusjon.<p><b>Fakturering-> fakturaer-> Rediger fakturaen.</b><p>Redigere kreditt fakturaen. Klikk \"Unpost\".<p>Etter unposti',0),(454194,12617,'da','Annullere kreditnota:<p><b>Fakturering-> fakturaer-> Void betalinger.</b><p>Angiv kredit fakturanummer eller kunde og ugyldige restitution.<p><b>Fakturering-> fakturaer-> Rediger faktura.</b><p>Redigere kreditfaktura. Klik pÃ¥ \"Unpost\".<p>Efter unposting ',0),(454195,12617,'ko','ì·¨ì†Œ ì‹ ìš© ë©”ëª¨:<p><b>ì†¡ìž¥ Void ì§€ë¶ˆ->-> ê²°ì œìž…ë‹ˆë‹¤.</b><p>ì‹ ìš© ì†¡ìž¥ ë²ˆí˜¸ ë˜ëŠ” ê³ ê° ë° ë¬´íš¨ í™˜ë¶ˆì„ ìž…ë ¥ í•©ë‹ˆë‹¤.<p><b>-> íŽ¸ì§‘ ì¸ë³´ì´ìŠ¤ ì¸ë³´ì´ìŠ¤-> ê²°ì œìž…ë‹ˆë‹¤.</b><p>íŽ¸ì§‘ ì‹ ìš© ì†¡ìž¥. \"Unpost\"ì„ í´ë¦­ í',0),(454196,12617,'he','×‘×™×˜×•×œ ×”×–×™×›×•×™:<p><b>×—×™×•×‘-> ×—×©×‘×•× ×™×•×ª-> ×ª×©×œ×•×ž×™× Void.</b><p>×”×–×Ÿ ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª ××©×¨××™ ××• ×”×—×–×¨ ×”×¨×™×§ ×©×œ ×œ×§×•×—×•×ª.<p><b>×—×™×•×‘-> ×—×©×‘×•× ×™×•×ª-> ×¢×¨×™×›×” ×—×©×‘×•× ×™×ª.</b><p>×¢×¨×•×š ××ª ×”',0),(454197,12617,'el','Î‘ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿:<p><b>Î§ÏÎ­Ï‰ÏƒÎ·Ï‚-> Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±-> Î¬ÎºÏ…ÏÎ± Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚.</b><p>Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£ Î® Ï€ÎµÎ»Î¬Ï„Î· ÎºÎ±Î¹ Î¬ÎºÏ…ÏÎ· ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®.<p><b',0),(454198,12617,'zh','å–æ¶ˆä¿¡ç”¨å¤‡å¿˜å½•ï¼šå…¥è´¦->å‘ç¥¨->åºŸé™¤ä»˜æ¬¾\r\nè¾“å…¥ä¿¡ç”¨å‘ç¥¨å·ç æˆ–è€…é¡¾å®¢å¹¶åºŸé™¤é€€æ¬¾ã€‚å…¥è´¦->å‘ç¥¨->ç¼–è¾‘å‘ç¥¨ã€‚\r\nç¼–è¾‘ä¿¡ç”¨å‘ç¥¨ã€‚ç‚¹å‡»â€œä¸å‘å¸ƒâ€ï¼Œä¸å‘å¸ƒå‘ç¥¨åŽï¼Œæ‚¨å³å¯åˆ é™¤å‘ç¥¨ã€‚',0),(454199,12617,'sv','Avbryt kreditnota:<p><b>Fakturering-> fakturor-> ogiltiga betalningar.</b><p>Ange kredit fakturanummer eller kund och void Ã¥terbetalning.<p><b>Fakturering-> fakturor-> redigera faktura.</b><p>Redigera kredit fakturan. Klicka pÃ¥ \"Unpost\".<p>Efter unposti',0),(454200,12617,'it','Annullare la nota di credito:<p><b>Fatturazione-> fatture-> pagamenti nulle.</b><p>Inserisci numero fattura credito o cliente e rimborso nulla.<p><b>Fatturazione-> fatture-> modifica fattura.</b><p>Modificare la fattura del credito. Fare clic su \"Unpost\".',0),(454201,12617,'tl','',0),(454202,12617,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¸«à¸™à¸µà¹‰:<p><b>à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰->à¹€à¸›à¹‡à¸™à¹‚à¸¡à¸†à¸°à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™-></b><p>à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­ à¸«à¸£à¸·à¸­à¸¥à¸¹à¸à¸',0),(454203,12617,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚:<p><b>à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤šà¤¾à¤²à¤¾à¤¨ à¤¶à¥‚à¤¨à¥à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨->->à¥¤</b><p>à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤”à¤° à¤¶à¥‚à¤¨à¥',0),(454204,12617,'ms','Membatalkan Memo kredit:<p><b>Bil-> invois-> pembayaran tidak sah.</b><p>Masukkan nombor invois kredit atau pelanggan dan bayaran balik yang tidak sah.<p><b>Bil-> invois-> Edit invois.</b><p>Edit invois kredit. Klik \"Unpost\".<p>Selepas unposting invois an',0),(454205,12617,'ar','Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ù…Ø°ÙƒØ±Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†:<p><b>Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> ÙÙˆØ§ØªÙŠØ±-> Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¨Ø§Ø·Ù„Ø©.</b><p>Ù‚Ù… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø£Ùˆ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ÙˆØ±Ø¯ Ø¨Ø§Ø·Ù„Ø©.<p><b>Ø§Ù„ÙÙˆØ§ØªÙŠØ±-> ÙÙˆØ§ØªÙŠØ±-',0),(454206,12617,'fr','Annuler la note de crÃ©dit :<p><b>Facturation-> factures-> paiements Sub.</b><p>Entrez le numÃ©ro de facture de crÃ©dit ou de clientÃ¨le et de remboursement Sub.<p><b>Facturation-> factures-> Edit facture.</b><p>Modifier la facture de crÃ©dit. Cliquez sur',0),(454207,12617,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆãƒ¡ãƒ¢ã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã—ã¾ã™ã€‚<p><b>è«‹æ±‚æ›¸æ”¯æ‰•ã‚’ Void->-> è«‹æ±‚ã€‚</b><p>ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆè«‹æ±‚æ›¸ç•ªå·ã‚„é¡§å®¢ã¨ void æ‰•ã„æˆ»ã—ã‚’å…¥åŠ›ã—ã¾ã™ã€‚<p><b>è«‹æ±‚æ›¸è«‹æ±‚æ›¸ç·¨é›†->-> è«‹æ±‚ã€‚</b><p>ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã®è«‹æ',0),(454208,12617,'pt','Cancele a nota de crÃ©dito:<p><b>Faturamento-> facturas-> Void pagamentos.</b><p>Digite o nÃºmero de fatura de crÃ©dito ou cliente e restituiÃ§Ã£o void.<p><b>Faturamento-> facturas-> editar a factura.</b><p>Edite a factura de crÃ©dito. Clique em \"Unpost\".',0),(454209,12617,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ñ‹:<p><b>Ð‘Ð¸Ð»Ð»Ð¸Ð½Ð³-> ÑÑ‡ÐµÑ‚Ð¾Ð²-> Void Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹.</b><p>Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð° Ð¸Ð»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð° void.<p><b>Ð‘Ð¸Ð»Ð»Ð¸Ð½Ð³-> ÑÑ‡ÐµÑ‚Ð¾Ð²-> Ð¸Ð·Ð¼ÐµÐ½Ð¸',0),(454210,12617,'es','Cancela un Memo de CrÃ©dito:<p><b>FacturaciÃ³n->Facturas->pagos Nulos.</b><p>Entra nÃºmero de factura de crÃ©dito o cliente y anular la devoluciÃ³n.<p><b>FacturaciÃ³n->Facturas->Editar Factura.</b><p>Edita la factura de crÃ©dito. Clik \"Desasentar\".<p>Desp',0),(454211,12617,'de','\"Abbrechen\" Gutschrift:<p><b>Abrechnung-> Rechnungen-> Void Zahlungen.</b><p>Geben Sie Kredit-Rechnungsnummer oder Kunde und void Erstattung.<p><b>Abrechnung-> Rechnungen-> bearbeiten Rechnung.</b><p>Bearbeiten Sie die Kredit-Rechnung. Klicken Sie auf \"Un',0),(454212,12617,'en','Cancel Credit Memo:<p><b>Billing->Invoices->Void Payments.</b><p>Enter credit invoice number or customer and void refund.<p><b>Billing->Invoices->Edit Invoice.</b><p>Edit the credit invoice. Click \"Unpost\".<p>After unposting the invoice you can delete it.',0),(454213,12618,'is','',0),(454214,12618,'dr','/ Ù¾Ø±Ø¯Ø§Ø®Øª  Ø±Ø§ Ø¯Ø± ØµÙØ­Ù‡ Ù†ÙˆØ´ØªÙ† Ú†Ú© Ù‡Ø§ Ø¨Ø¨ÛŒÙ†ÛŒØ¯Ø§ÛŒÙ† Ø²Ù…Ø§Ù†ÛŒ Ø§ØªÙØ§Ù‚ Ù…ÛŒ Ø§ÙØªØ¯ Ø§Ú¯Ø±ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø´Ù…Ø§ØªÙ†Ù‡Ø§ ÛŒÚ© Ø¨ÛŒØ¬Ú© Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª(Ø­',0),(454215,12618,'pr','Ø§Ú¯Ø± Ù†Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ ÛŒÚ© ÙØ§Ú©ØªÙˆØ±Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…/ Ù¾Ø±Ø¯Ø§Ø®Øª  Ø±Ø§ Ø¯Ø± ØµÙØ­Ù‡ Ù†ÙˆØ´ØªÙ† Ú†Ú© Ù‡Ø§ Ø¨Ø¨ÛŒÙ†ÛŒØ¯Ø§ÛŒÙ† Ø²Ù…Ø§Ù†ÛŒ Ø§ØªÙØ§Ù‚ Ù…ÛŒ Ø§ÙØªØ¯ Ø§Ú¯Ø±ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø´Ù…Ø§ØªÙ†Ù‡Ø§ ÛŒÚ© ÙØ§Ú©ØªÙˆØ± Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª(Ø­',0),(454216,12618,'tr','On-tutun/Ã¶deme fatura yazmak denetler ekranda gÃ¶remiyorsanÄ±z bu satÄ±cÄ±nÄ±za yalnÄ±zca bir fatura Ã¶demek iÃ§in vardÄ±r oluÅŸur.',0),(454217,12618,'pl','JeÅ›li nie widzisz na-Hold/pÅ‚aciÄ‡ faktury na ekranie pisze sprawdza ten wystÄ™puje, jeÅ›li sprzedawca ma tylko jednÄ… fakturÄ™ do zapÅ‚aty.',0),(454218,12618,'bg','ÐÐºÐ¾ Ð½Ðµ Ð²Ð¸Ð¶Ð´Ð°Ñ‚Ðµ Ð½Ð° On-Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ/Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð° ÐµÐºÑ€Ð°Ð½Ð°, Ð¿Ð¸ÑˆÐ°Ñ‚ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÐ²Ð° Ñ‚Ð¾Ð²Ð° ÑÐµ ÑÐ»ÑƒÑ‡Ð²Ð°, Ð°ÐºÐ¾ Ð²Ð°ÑˆÐ¸ÑÑ‚ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ðµ ÑÐ°Ð¼Ð¾ ÐµÐ´Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð·Ð° Ð´Ð° Ð¿Ð»Ð°Ñ‚',0),(454219,12618,'ur','Ø¢Ù¾ Ú©Ùˆ Ù„Ú©Ú¾Ù†Û’ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ØªØ§ ÛÛ’ Ø³Ú©Ø±ÛŒÙ† Ù¾Ø± Ø§ÛŒÚ© Ø¢Ù†-ÛÙˆÙ„Úˆ/ØªÙ†Ø®ÙˆØ§Û Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÛÛŒÚº Ø¯ÛŒÚ©Ú¾ØªÛ’ ÛÛŒÚº ØªÙˆ ØµØ±Ù Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§Ù¾Ù†Û’ ÙØ±ÙˆØ´Ù†Ø¯Û ÛÛ’ ØªÙˆ ÛŒÛ ÙˆØ§Ù‚Ø¹ ',0),(454220,12618,'sr','ÐÐºÐ¾ Ð½Ðµ Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð´Ð°Ñ™Ðµ-Ñ‡ÐµÐºÐ°ÑšÐµ/Ð¿Ð»Ð°Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð½Ð° ÐµÐºÑ€Ð°Ð½Ñƒ Ð¿Ð¸ÑÐ°Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð° Ð´Ð¾ Ð¾Ð²Ð¾Ð³Ð° Ð´Ð¾Ð»Ð°Ð·Ð¸ Ð°ÐºÐ¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð¸Ð¼Ð° ÑÐ°Ð¼Ð¾ Ñ˜ÐµÐ´Ð½Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸.',0),(454221,12618,'vi','Náº¿u báº¡n khÃ´ng tháº¥y 1 hÃ³a Ä‘Æ¡n trÃªn mÃ n hÃ¬nh, Ä‘iá»u nÃ y xuáº¥t hiá»‡n náº¿u nhÃ  cung cáº¥p cá»§a báº¡n chá»‰ cÃ³ 1 hÃ³a Ä‘Æ¡n pháº£i thanh toÃ¡n',0),(454222,12618,'af','Dit gebeur as jou handelaar het slegs een faktuur te betaal, as jy \'n op-hou vas/betaal faktuur op die skryf kontroleer skerm sien nie.',0),(454223,12618,'ro','DacÄƒ nu vedeÅ£i o facturÄƒ de platÄƒ On-Hold pe ecranul scrie verificÄƒ acest lucru se Ã®ntÃ¢mplÄƒ Ã®n cazul Ã®n care furnizorul are doar o singurÄƒ facturÄƒ sÄƒ plÄƒteascÄƒ.',0),(454224,12618,'et','Kui te ei nÃ¤e On-Hold/maksa arve kirjutada kontrollib ekraani see juhtub, kui tarnija on ainult Ã¼he arve tasuda.',0),(454225,12618,'si','ÄŒe ne vidite na Äakanju/plaÄilo raÄuna na zaslonu pisati preveri to se zgodi, Äe vaÅ¡ prodajalec ima le en raÄun za plaÄilo.',0),(454226,12618,'ba','Jika Anda tidak melihat faktur On-tahan/bayar pada layar menulis cek ini terjadi jika Vendor Anda memiliki hanya satu faktur untuk membayar.',0),(454227,12618,'nl','Als u een On-Hold/Pay factuur niet op het scherm schrijven controleert ziet dit treedt op als uw leverancier slechts Ã©Ã©n factuur heeft te betalen.',0),(454228,12618,'fi','Jos et nÃ¤e laskun maksa-edelleen-pidÃ¤ kirjoittaa tarkistaa nÃ¤ytÃ¶n nÃ¤in tapahtuu, jos myyjÃ¤ on vain yksi lasku maksaa.',0),(454229,12618,'no','Hvis du ikke ser en pÃ¥-Hold/betale fakturaen pÃ¥ skjermbildet skrive sjekker skjer dette hvis leverandÃ¸ren har bare Ã©n faktura betale.',0),(454230,12618,'da','Hvis du ikke kan se en On-Hold/betalings faktura pÃ¥ skÃ¦rmbilledet skrive kontrollerer sker dette, hvis leverandÃ¸ren har kun Ã©n faktura til at betale.',0),(454231,12618,'ko','ê²€ì‚¬ ìž‘ì„± í™”ë©´ì—ì„œ On ë³´ë¥˜/ì§€ë¶ˆ ì¸ë³´ì´ìŠ¤ë¥¼ í‘œì‹œ ë˜ì§€ ì•Šìœ¼ë©´ ê³µê¸‰ ì—…ì²´ì— ë¬¸ì˜ í•œ ì†¡ìž¥ ì§€ë¶ˆ í•˜ëŠ” ê²½ìš° ë°œìƒ í•©ë‹ˆë‹¤.',0),(454232,12618,'he','×× ××™× ×š ×¨×•××” ×—×©×‘×•× ×™×ª ×‘×œ×”×—×–×™×§ ×•×¢×¨×•×¦×™ ×©×œ× ×¢×œ ×”×ž×¡×š ×œ×›×ª×•×‘ ×‘×•×“×§ ×ž×¦×‘ ×–×” ×ž×ª×¨×—×© ×× ×œ×™×¦×¨×Ÿ ×™×© ×—×©×‘×•× ×™×ª ××—×ª ×‘×œ×‘×“ ×œ×©×œ×.',0),(454233,12618,'el','Î•Î¬Î½ Î´ÎµÎ½ Î²Î»Î­Ï€ÎµÏ„Îµ Î­Î½Î± On-Hold/ÏƒÏ…Î½Î´ÏÎ¿Î¼Î·Ï„Î¹ÎºÎ® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÏ„Î·Î½ Î¿Î¸ÏŒÎ½Î· Î³ÏÎ¬ÏˆÎµÎ¹ ÎµÎ»Î­Î³Ï‡ÎµÎ¹ Î±Ï…Ï„ÏŒ ÏƒÏ…Î¼Î²Î±Î¯Î½ÎµÎ¹ Î±Î½ Ï„Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏƒÎ±Ï‚ Î­Ï‡ÎµÎ¹ Î¼ÏŒÎ½Î¿ Î­Î½Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î³Î¹Î± ',0),(454234,12618,'zh','å¦‚æžœæ‚¨æ²¡æœ‰åœ¨ä¹¦å†™å‘ç¥¨é¡µé¢çœ‹è§çŽ°æœ‰/ä»˜æ¬¾å‘ç¥¨ï¼Œè¿™åªä¼šå‡ºçŽ°åœ¨æ‚¨çš„ä¾›åº”å•†åªè¦ä¸ºä¸€å¼ å‘ç¥¨ä»˜è´¹çš„æƒ…å†µä¸‹ã€‚',0),(454235,12618,'sv','Om du inte ser en On-Hold/betala fakturan pÃ¥ skÃ¤rmen skriver kontrollerar intrÃ¤ffar detta om leverantÃ¶ren har bara en faktura att betala.',0),(454236,12618,'it','Se non vedete una fattura On-Hold/Pay sullo schermo scrivere controlla questo si verifica se il fornitore ha solo una fattura da pagare.',0),(454237,12618,'tl','',0),(454238,12618,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¹€à¸«à¹‡à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¹‰à¸²à¸‡/à¸Šà¸³à¸£à¸°à¹ƒà¸™à¸«à¸™à¹‰à¸²à¸ˆà¸­à¸šà¸±à¸™à¸—à¸¶à¸à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š à¸™à¸µà¹‰à¹€à¸à¸´à¸”à¸‚à¸¶à¹‰à¸™à¸–à¹‰à¸²à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸¡à¸µà',0),(454239,12618,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤²à¤¿à¤–à¤¨à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤ªà¤° à¤à¤• à¤ªà¤°-à¤ªà¤•à¤¡à¤¼/à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤¦à¥‡à¤–à¤¤à¥‡ à¤¹à¥ˆà¤‚ à¤‡à¤¸ à¤¹à¥‹à¤¤à¥€ à¤¹à¥ˆ à¤¯à¤¦à¤¿ à¤•à¥‡à¤µà¤² à¤',0),(454240,12618,'ms','Jika anda tidak melihat invois di-pegang/Pay di skrin tulis menyemak ini berlaku jika penjual anda mempunyai hanya satu invois untuk membayar.',0),(454241,12618,'ar','Ø¥Ø°Ø§ Ù„Ù… ØªØ´Ø§Ù‡Ø¯ \"ÙØ§ØªÙˆØ±Ø©\" Ø¹Ù„Ù‰ Ø¹Ù‚Ø¯/Ø§Ù„Ø£Ø¬Ø± Ø¹Ù„Ù‰ Ø§Ù„Ø´Ø§Ø´Ø© \"ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø´ÙŠÙƒØ§Øª\" ÙˆÙ‡Ø°Ø§ ÙŠØ­Ø¯Ø« Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ø¨Ø§Ø¦Ø¹ ÙØ§ØªÙˆØ±Ø© ÙˆØ§Ø­Ø¯Ø© ÙÙ‚Ø· Ø¯ÙØ¹.',0),(454242,12618,'fr','Si vous ne voyez pas une facture On-Hold/payante sur l\'Ã©cran Ã©crire vÃ©rifie cela se produit si votre vendeur n\'a qu\'une seule facture Ã  payer.',0),(454243,12618,'jp','æ›¸ãè¾¼ã¿ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ç”»é¢ä¸Šã«ãƒ›ãƒ¼ãƒ«ãƒ‰/æ”¯æ‰•è«‹æ±‚æ›¸ãŒè¡¨ç¤ºã•ã‚Œãªã„å ´åˆã¯ã€ãƒ™ãƒ³ãƒ€ãƒ¼ãŒã‚ã‚‹ 1 ã¤ã ã‘ã®è«‹æ±‚æ›¸ã‚’æ”¯æ‰•ã†å ´åˆã“ã‚Œç™ºç”Ÿã—ã¾ã™ã€‚',0),(454244,12618,'pt','Se vocÃª nÃ£o vir uma fatura On-Hold/Pay na tela de escrever verifica isso ocorre se o fornecedor tem apenas uma fatura para pagar.',0),(454245,12618,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð½Ðµ Ð²Ð¸Ð´Ð¸Ñ‚Ðµ On-Hold/Ð¾Ð¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð° Ð½Ð° ÑÐºÑ€Ð°Ð½Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑÐµÑ‚ ÑÑ‚Ð¾ Ð¿Ñ€Ð¾Ð¸ÑÑ…Ð¾Ð´Ð¸Ñ‚, ÐµÑÐ»Ð¸ Ð²Ð°Ñˆ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð¸Ð¼ÐµÐµÑ‚ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¾Ð´Ð¸Ð½ ÑÑ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹.',0),(454246,12618,'es','Si no ve un En-Espera/Pagar Factura en la pantalla de Escribir Cheques. Este ocurre si su proveedor sol tiene una factura por pagar.',0),(454247,12618,'de','Wenn Sie eine On-Hold/Pay-Rechnung nicht auf dem Bildschirm schreiben Ã¼berprÃ¼ft sehen dies geschieht, wenn Ihr Anbieter nur eine Rechnung zu bezahlen hat.',0),(454248,12618,'en','If you do not see an On-Hold/Pay Invoice on the Write Checks screen this occurs if your Vendor has only one invoice to pay.',0),(454249,12619,'is','',0),(454250,12619,'dr','',0),(454251,12619,'pr','',0),(454252,12619,'tr','',0),(454253,12619,'pl','',0),(454254,12619,'bg','',0),(454255,12619,'ur','',0),(454256,12619,'sr','',0),(454257,12619,'vi','',0),(454258,12619,'af','',0),(454259,12619,'ro','',0),(454260,12619,'et','',0),(454261,12619,'si','',0),(454262,12619,'ba','',0),(454263,12619,'nl','',0),(454264,12619,'fi','',0),(454265,12619,'no','',0),(454266,12619,'da','',0),(454267,12619,'ko','',0),(454268,12619,'he','',0),(454269,12619,'el','',0),(454270,12619,'zh','',0),(454271,12619,'sv','',0),(454272,12619,'it','',0),(454273,12619,'tl','',0),(454274,12619,'th','',0),(454275,12619,'hi','',0),(454276,12619,'ms','',0),(454277,12619,'ar','',0),(454278,12619,'fr','',0),(454279,12619,'jp','',0),(454280,12619,'pt','',0),(454281,12619,'ru','',0),(454282,12619,'es','',0),(454283,12619,'de','',0),(454284,12619,'en','',0),(454285,12620,'is','',0),(454286,12620,'dr','',0),(454287,12620,'pr','',0),(454288,12620,'tr','',0),(454289,12620,'pl','',0),(454290,12620,'bg','',0),(454291,12620,'ur','',0),(454292,12620,'sr','',0),(454293,12620,'vi','',0),(454294,12620,'af','',0),(454295,12620,'ro','',0),(454296,12620,'et','',0),(454297,12620,'si','',0),(454298,12620,'ba','',0),(454299,12620,'nl','',0),(454300,12620,'fi','',0),(454301,12620,'no','',0),(454302,12620,'da','',0),(454303,12620,'ko','',0),(454304,12620,'he','',0),(454305,12620,'el','',0),(454306,12620,'zh','',0),(454307,12620,'sv','',0),(454308,12620,'it','',0),(454309,12620,'tl','',0),(454310,12620,'th','',0),(454311,12620,'hi','',0),(454312,12620,'ms','',0),(454313,12620,'ar','',0),(454314,12620,'fr','',0),(454315,12620,'jp','',0),(454316,12620,'pt','',0),(454317,12620,'ru','',0),(454318,12620,'es','',0),(454319,12620,'de','',0),(454320,12620,'en','',0),(454321,12621,'is','',0),(454322,12621,'dr','',0),(454323,12621,'pr','',0),(454324,12621,'tr','',0),(454325,12621,'pl','',0),(454326,12621,'bg','',0),(454327,12621,'ur','',0),(454328,12621,'sr','',0),(454329,12621,'vi','',0),(454330,12621,'af','',0),(454331,12621,'ro','',0),(454332,12621,'et','',0),(454333,12621,'si','',0),(454334,12621,'ba','',0),(454335,12621,'nl','',0),(454336,12621,'fi','',0),(454337,12621,'no','',0),(454338,12621,'da','',0),(454339,12621,'ko','',0),(454340,12621,'he','',0),(454341,12621,'el','',0),(454342,12621,'zh','',0),(454343,12621,'sv','',0),(454344,12621,'it','',0),(454345,12621,'tl','',0),(454346,12621,'th','',0),(454347,12621,'hi','',0),(454348,12621,'ms','',0),(454349,12621,'ar','',0),(454350,12621,'fr','',0),(454351,12621,'jp','',0),(454352,12621,'pt','',0),(454353,12621,'ru','',0),(454354,12621,'es','',0),(454355,12621,'de','',0),(454356,12621,'en','',0),(454357,12622,'is','',0),(454358,12622,'dr','',0),(454359,12622,'pr','',0),(454360,12622,'tr','',0),(454361,12622,'pl','',0),(454362,12622,'bg','',0),(454363,12622,'ur','',0),(454364,12622,'sr','',0),(454365,12622,'vi','',0),(454366,12622,'af','',0),(454367,12622,'ro','',0),(454368,12622,'et','',0),(454369,12622,'si','',0),(454370,12622,'ba','',0),(454371,12622,'nl','',0),(454372,12622,'fi','',0),(454373,12622,'no','',0),(454374,12622,'da','',0),(454375,12622,'ko','',0),(454376,12622,'he','',0),(454377,12622,'el','',0),(454378,12622,'zh','',0),(454379,12622,'sv','',0),(454380,12622,'it','',0),(454381,12622,'tl','',0),(454382,12622,'th','',0),(454383,12622,'hi','',0),(454384,12622,'ms','',0),(454385,12622,'ar','',0),(454386,12622,'fr','',0),(454387,12622,'jp','',0),(454388,12622,'pt','',0),(454389,12622,'ru','',0),(454390,12622,'es','',0),(454391,12622,'de','',0),(454392,12622,'en','',0),(454393,12623,'is','',0),(454394,12623,'dr','',0),(454395,12623,'pr','',0),(454396,12623,'tr','',0),(454397,12623,'pl','',0),(454398,12623,'bg','',0),(454399,12623,'ur','',0),(454400,12623,'sr','',0),(454401,12623,'vi','',0),(454402,12623,'af','',0),(454403,12623,'ro','',0),(454404,12623,'et','',0),(454405,12623,'si','',0),(454406,12623,'ba','',0),(454407,12623,'nl','',0),(454408,12623,'fi','',0),(454409,12623,'no','',0),(454410,12623,'da','',0),(454411,12623,'ko','',0),(454412,12623,'he','',0),(454413,12623,'el','',0),(454414,12623,'zh','',0),(454415,12623,'sv','',0),(454416,12623,'it','',0),(454417,12623,'tl','',0),(454418,12623,'th','',0),(454419,12623,'hi','',0),(454420,12623,'ms','',0),(454421,12623,'ar','',0),(454422,12623,'fr','',0),(454423,12623,'jp','',0),(454424,12623,'pt','',0),(454425,12623,'ru','',0),(454426,12623,'es','',0),(454427,12623,'de','',0),(454428,12623,'en','',0),(454429,12624,'is','',0),(454430,12624,'dr','',0),(454431,12624,'pr','',0),(454432,12624,'tr','',0),(454433,12624,'pl','',0),(454434,12624,'bg','',0),(454435,12624,'ur','',0),(454436,12624,'sr','',0),(454437,12624,'vi','',0),(454438,12624,'af','',0),(454439,12624,'ro','',0),(454440,12624,'et','',0),(454441,12624,'si','',0),(454442,12624,'ba','',0),(454443,12624,'nl','',0),(454444,12624,'fi','',0),(454445,12624,'no','',0),(454446,12624,'da','',0),(454447,12624,'ko','',0),(454448,12624,'he','',0),(454449,12624,'el','',0),(454450,12624,'zh','',0),(454451,12624,'sv','',0),(454452,12624,'it','',0),(454453,12624,'tl','',0),(454454,12624,'th','',0),(454455,12624,'hi','',0),(454456,12624,'ms','',0),(454457,12624,'ar','',0),(454458,12624,'fr','',0),(454459,12624,'jp','',0),(454460,12624,'pt','',0),(454461,12624,'ru','',0),(454462,12624,'es','',0),(454463,12624,'de','',0),(454464,12624,'en','',0),(454465,12625,'is','',0),(454466,12625,'dr','ØªØ§ Ø¢Ù†Ø¬Ø§ Ú©Ù‡ Ø¨Ù‡ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Authorize.net Ùˆ PSiGate Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ù‡Ø§ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ú¯Ù†Ø¬Ø§Ù†Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª.<p>Ø¨Ø§ Ø§ÛŒÙ† Ø­Ø§Ù„ Ø¯ÛŒÚ¯Ø±Ø§Ù† ØªÙˆØ³Ø· Ø³ÙØ§Ø±Ø´ÛŒ - <b>support@',0),(454467,12625,'pr','ØªØ§ Ø¢Ù†Ø¬Ø§ Ú©Ù‡ Ø¨Ù‡ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Authorize.net Ùˆ PSiGate Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ù‡Ø§ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ú¯Ù†Ø¬Ø§Ù†Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª.<p>Ø¨Ø§ Ø§ÛŒÙ† Ø­Ø§Ù„ Ø¯ÛŒÚ¯Ø±Ø§Ù† ØªÙˆØ³Ø· Ø³ÙØ§Ø±Ø´ÛŒ - <b>support@',0),(454468,12625,'tr','BildiÄŸim kadarÄ±yla kredi kartÄ± Ã¶demeleri iÃ§in seÃ§enekler Authorize.net ve PSiGate iÅŸlemci varsayÄ±lan olarak eklenir.<p>Ancak baÅŸkalarÄ± tarafÄ±ndan Ã¶zelleÅŸtirme - detaylÄ± bilgi iÃ§in irtibat <b>support@nolapro.com</b> ayarlanabilir!',0),(454469,12625,'pl','W miarÄ™ moÅ¼liwoÅ›ci pÅ‚atnoÅ›ci kartÄ… kredytowÄ… procesory Authorize.net i PSiGate znajdujÄ… siÄ™ domyÅ›lnie.<p>Jednak inni moÅ¼na ustawiÄ‡ przez dostosowywanie - kontakt <b>support@nolapro.com</b> wiÄ™cej!',0),(454470,12625,'bg','Ð©Ð¾ ÑÐµ Ð¾Ñ‚Ð½Ð°ÑÑ Ð´Ð¾ Ð¾Ð¿Ñ†Ð¸Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð½Ð° Authorize.net Ð¸ PSiGate Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€Ð¸ ÑÐ° Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ.<p>ÐžÐ±Ð°Ñ‡Ðµ Ð´Ñ€ÑƒÐ³Ð¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð·Ð°Ð´Ð°Ð´Ðµ',0),(454471,12625,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ø¬ÛØ§Úº ØªÚ© Authorize.net Ø§ÙˆØ± Ù¾Ø³ÛŒÚ¯Ù¹ÛŒ Ù¾Ø±ÙˆØ³ÛŒØ³Ø±Ø² ÚˆÛŒÙØ§Ù„Ù¹ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”<p>ØªØ§ÛÙ… Ø¯ÙˆØ³Ø±ÙˆÚº ØªØ®ØµÛŒØµ Ú©Ø§Ø±ÛŒ - Ù…Ø²ÛŒØ¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©',0),(454472,12625,'sr','Ð¨Ñ‚Ð¾ ÑÐµ Ñ‚Ð¸Ñ‡Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Authorize.net Ð¸ ÐŸÐ¡Ð¸Ð“Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€Ð¸ ÑÑƒ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾ ÑƒÐºÑ™ÑƒÑ‡ÐµÐ½.<p>ÐœÐµÑ’ÑƒÑ‚Ð¸Ð¼ Ð´Ñ€ÑƒÐ³Ð¸ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¿Ð¾Ð´ÐµÑÐ¸Ñ‚Ð¸ Ð¿Ð¾ Ð¿Ñ€Ð¸Ð',0),(454473,12625,'vi','Theo nhÆ° cÃ¡c tÃ¹y chá»n cho cÃ¡c khoáº£n thanh toÃ¡n tháº» tÃ­n dá»¥ng the authorize.net, ngÆ°á»i truy cáº­p lÃ  pháº£i Ä‘Æ°á»£c máº·c Ä‘á»‹nh.Tuy nhiÃªn nhá»¯ng ngÆ°á»i khÃ¡c cÃ³ thá»ƒ Ä‘Æ°á»£c thiáº¿t láº­p tÃ¹y biáº¿n',0),(454474,12625,'af','Sover opsies vir kredietkaart betalings is die Authorize.net en PSiGate verwerkers ingesluit by verstek.<p>Egter ander opgestel kan word deur aanpassing - kontak <b>support@nolapro.com</b> vir meer info!',0),(454475,12625,'ro','ÃŽn ceea ce priveÅŸte opÅ£iunile pentru plÄƒÅ£i card de credit procesoare Authorize.net ÅŸi PSiGate sunt incluse Ã®n mod implicit.<p>TotuÅŸi alÅ£ii poate fi Ã®nfiinÅ£at de personalizare - contact <b>support@nolapro.com</b> pentru mai multe informaÅ£ii!',0),(454476,12625,'et','Niipalju kui Valikud lisatasud on vaikimisi kaasatud Authorize.net ja PSiGate protsessorid.<p>Aga teised saate seadistada kohandamine - kontakt <b>support@nolapro.com</b> rohkem infot!',0),(454477,12625,'si','ÄŒe je moÅ¾nosti za plaÄila s kreditno kartico so privzeto vkljuÄeni Authorize.net in PSiGate procesorje.<p>Vendar drugi lahko ustanovijo customization - kontaktna <b>support@nolapro.com</b> za veÄ info!',0),(454478,12625,'ba','Sejauh pilihan untuk pembayaran kartu kredit prosesor Authorize.net dan PSiGate disertakan secara default.<p>Namun orang lain dapat diatur oleh kustomisasi - kontak <b>support@nolapro.com</b> untuk info lebih lanjut!',0),(454479,12625,'nl','Zoveel opties voor credit card betalingen worden de Authorize.net en PSiGate processoren standaard opgenomen.<p>Maar anderen kunnen worden ingesteld door Personalisatiemogelijkheden - contact <b>support@nolapro.com</b> voor meer info!',0),(454480,12625,'fi','MitÃ¤ hoitovaihtoehtoja luottokorttimaksut oletusarvon mukaan Authorize.net ja PSiGate prosessorit.<p>Kuitenkin toiset voi perustaa rÃ¤Ã¤tÃ¤lÃ¶inti - yhteystiedot <b>support@nolapro.com</b> lisÃ¤tietoja!',0),(454481,12625,'no','SÃ¥ langt alternativene for kredittkortbetalinger er Authorize.net og PSiGate-prosessorer inkludert som standard.<p>Men andre kan defineres av tilpasning - kontakt <b>support@nolapro.com</b> for mer info!',0),(454482,12625,'da','Hvad angÃ¥r muligheder for betaling med kreditkort er Authorize.net og PSiGate processorer inkluderet som standard.<p>Andre kan dog sÃ¦ttes op ved tilpasning - kontakt <b>support@nolapro.com</b> for mere info!',0),(454483,12625,'ko','ì‹ ìš© ì¹´ë“œ ê²°ì œì— ëŒ€ í•œ ì˜µì…˜ê¹Œì§€ Authorize.net ë° PSiGate í”„ë¡œì„¸ì„œëŠ” ê¸°ë³¸ì ìœ¼ë¡œ í¬í•¨ ë˜ì–´ ìžˆìŠµë‹ˆë‹¤.<p>ê·¸ëŸ¬ë‚˜ ë‹¤ë¥¸ ì‚¬ìš©ìž ì •ì˜-ë” ë§Žì€ ì •ë³´ì— ëŒ€ í•œ ì—°ë½ì²˜ <b>support@nolapro.com</b> ì—¬ ì„¤ì •í•  ìˆ˜ ìžˆì',0),(454484,12625,'he','×ž×‘×—×™× ×ª ××¤×©×¨×•×™×•×ª ×¢×‘×•×¨ ×ª×©×œ×•×ž×™× ×‘××ž×¦×¢×•×ª ×›×¨×˜×™×¡ ××©×¨××™ ×ž×¢×‘×“×™ Authorize.net ×• PSiGate ×›×œ×•×œ×™× ×›×‘×¨×™×¨×ª ×ž×—×“×œ.<p>××•×œ× ××—×¨×™× × ×™×ª×Ÿ ×œ×”×’×“×™×¨ ×¢×œ ×™×“×™ ×”×ª××ž×” ××™×©×™×ª - <b>support@n',0),(454485,12625,'el','ÎŒÏƒÎ¿Î½ Î±Ï†Î¿ÏÎ¬ Ï„Î¹Ï‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î³Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Ï„Ï‰Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÏŽÎ½ Authorize.net ÎºÎ±Î¹ PSiGate Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î®.<p>Î©ÏƒÏ„ÏŒÏƒÎ¿ Î¬Î»Î»Î¿Î¹ Î¼Ï€Î',0),(454486,12625,'zh','å¯¹äºŽä¿¡ç”¨å¡ä»˜æ¬¾é€‰é¡¹ï¼ŒAuthorize.netå’ŒPSiGateå¤„ç†å™¨ä¼šè¢«é»˜è®¤å€¼åŒ…æ‹¬åœ¨å†…ã€‚ä½†æ˜¯å…¶ä»–é¡¹å¯ä»¥ç”¨ä¸ªæ€§åŒ–è®¾ç½®â€”â€”éœ€è¦æ›´å¤šä¿¡æ¯è¯·è”ç³»support@nolapro.com',0),(454487,12625,'sv','NÃ¤r det gÃ¤ller alternativ fÃ¶r kreditkortsbetalningar ingÃ¥r Authorize.net och PSiGate processorerna som standard.<p>Men andra kan inrÃ¤ttas av anpassning - kontakta <b>support@nolapro.com</b> fÃ¶r mer info!',0),(454488,12625,'it','Per quanto riguarda le opzioni per i pagamenti con carta di credito i processori Authorize.net e PSiGate sono inclusi per impostazione predefinita.<p>Tuttavia gli altri possono essere impostati di personalizzazione - contatta <b>support@nolapro.com</b> pe',0),(454489,12625,'tl','',0),(454490,12625,'th','à¹€à¸—à¹ˆà¸²à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸• à¹‚à¸›à¸£à¹€à¸‹à¸ªà¹€à¸‹à¸­à¸£à¹Œ Authorize.net à¹à¸¥à¸° PSiGate à¸£à¸§à¸¡à¸­à¸¢à¸¹à¹ˆ à¹‚à¸”à¸¢à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™<p>à¸­à',0),(454491,12625,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¤²à¥à¤ª à¤œà¤¹à¤¾à¤ à¤¤à¤• Authorize.net à¤”à¤° PSiGate à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤° à¤®à¥‡à¤‚ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤°à¥‚à¤ª à¤¸à¥‡ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚à¥¤<',0),(454492,12625,'ms','Setakat pilihan untuk pembayaran menggunakan kad kredit pemproses Authorize.net dan PSiGate akan disertakan secara lalai.<p>Walau bagaimanapun lain-lain boleh disediakan oleh penyesuaian - hubungi <b>support@nolapro.com</b> untuk maklumat lanjut!',0),(454493,12625,'ar','ÙÙŠÙ…Ø§ ÙŠØªØ¹Ù„Ù‚ Ø¨Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ù…ØªØ§Ø­Ø© Ù„Ù„Ø¯ÙØ¹ Ø¨Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ÙŠØªÙ… ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬Ø§Øª Authorize.net ÙˆØ¨Ø³Ø¬ÙŠØª Ø¨Ø´ÙƒÙ„ Ø§ÙØªØ±Ø§Ø¶ÙŠ.<p>ÙˆÙ„ÙƒÙ† Ø§Ù„Ø¨Ø¹Ø¶ Ø§Ù„Ø¢Ø®Ø± ÙŠÙ…ÙƒÙ† Ø¥Ø¹Ø¯Ø§Ø¯ Ø¨Ø§Ù„ØªØ®ØµÙŠØµ-Ø',0),(454494,12625,'fr','En ce qui concerne les options pour les paiements par carte de crÃ©dit, les processeurs Authorize.net et PSiGate sont inclus par dÃ©faut.<p>Cependant d\'autres peuvent Ãªtre mis en place par personnalisation - contacter <b>support@nolapro.com</b> pour plus',0),(454495,12625,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ”¯æ‰•ã„ã®ã‚ªãƒ—ã‚·ãƒ§ãƒ³é™ã‚Š Authorize.net ã¨ PSiGate ãƒ—ãƒ­ã‚»ãƒƒã‚µãŒæ—¢å®šã§å«ã¾ã‚Œã¾ã™ã€‚<p>ã—ã‹ã—ä»–ã®ã‚ˆã†ã«è¨­å®šã§ãã¾ã™ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚º - ãŠå•ã„åˆã‚ã›<b>support@nolapro.com</b>è©³ç´°æƒ…å ± ï¼',0),(454496,12625,'pt','Na medida em que as opÃ§Ãµes para pagamentos com cartÃ£o de crÃ©dito, os processadores Authorize.net e PSiGate sÃ£o incluÃ­dos por padrÃ£o.<p>No entanto os outros podem ser instituÃ­dos pela personalizaÃ§Ã£o - contato <b>support@nolapro.com</b> para mais ',0),(454497,12625,'ru','ÐŸÐ¾ Ð¼ÐµÑ€Ðµ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹ Authorize.net Ð¸ PSiGate Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€Ñ‹ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ.<p>ÐžÐ´Ð½Ð°ÐºÐ¾ Ð´Ñ€ÑƒÐ³Ð¸Ðµ Ð¼Ð¾Ð³ÑƒÑ‚ ÑÐ¾Ð·Ð´Ð°Ð²Ð°Ñ‚ÑŒÑÑ Ð¿ÑƒÑ‚ÐµÐ¼ Ð½Ð°Ñ',0),(454498,12625,'es','En cuestiÃ³n de opciones para pagos por tarjeta de crÃ©dito, los procesadores de Authorize.net y PSIGate se incluyen por defecto.<p> Sin embargo otros se pueden configurar por prsonalizaciÃ³n - cantacta <b>support@nolapro.com</b> para mÃ¡s informaciÃ³n!',0),(454499,12625,'de','So weit wie Optionen fÃ¼r Zahlungen mit Kreditkarte sind die Authorize.net und PSiGate Prozessoren standardmÃ¤ÃŸig enthalten.<p>Jedoch kÃ¶nnen andere durch Anpassung - Kontakt <b>support@nolapro.com</b> fÃ¼r mehr Info eingerichtet werden!',0),(454500,12625,'en','As far as options for credit card payments the Authorize.net and PSiGate processors are included by default.<p>However others can be set up by customization - contact <b>support@nolapro.com</b> for more info!',0),(454501,12626,'is','',0),(454502,12626,'dr','',0),(454503,12626,'pr','',0),(454504,12626,'tr','',0),(454505,12626,'pl','',0),(454506,12626,'bg','',0),(454507,12626,'ur','',0),(454508,12626,'sr','',0),(454509,12626,'vi','',0),(454510,12626,'af','',0),(454511,12626,'ro','',0),(454512,12626,'et','',0),(454513,12626,'si','',0),(454514,12626,'ba','',0),(454515,12626,'nl','',0),(454516,12626,'fi','',0),(454517,12626,'no','',0),(454518,12626,'da','',0),(454519,12626,'ko','',0),(454520,12626,'he','',0),(454521,12626,'el','',0),(454522,12626,'zh','',0),(454523,12626,'sv','',0),(454524,12626,'it','',0),(454525,12626,'tl','',0),(454526,12626,'th','',0),(454527,12626,'hi','',0),(454528,12626,'ms','',0),(454529,12626,'ar','',0),(454530,12626,'fr','',0),(454531,12626,'jp','',0),(454532,12626,'pt','',0),(454533,12626,'ru','',0),(454534,12626,'es','',0),(454535,12626,'de','',0),(454536,12626,'en','',0),(454537,12627,'is','',0),(454538,12627,'dr',':Ù…Ø¯ÛŒØ±ÛŒØª- ØªÙ†Ø¸ÛŒÙ… Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§- ØªÙ†Ø¸ÛŒÙ… Ú©Ù„ÛŒ ÙˆØ§Ú¯Ø± Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø±Ø¯Ú¯ÛŒØ±ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ±Ù…Ø§ÛŒØ´Ø§Øª Ø®Ø±ÛŒØ¯ Ø§Ø² Ø·Ø±ÛŒÙ‚ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø±Ø§ ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒØ¯Ú©Ø§Ø¯Ø± Ø±Ø§ ',0),(454539,12627,'pr','ÙÙ‚Ø· Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§Ø¨Ø¨ÛŒÙ†ÛŒØ¯:Ù…Ø¯ÛŒØ±ÛŒØª- ØªÙ†Ø¸ÛŒÙ… Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§- ØªÙ†Ø¸ÛŒÙ… Ú©Ù„ÛŒ ÙˆØ§Ú¯Ø± Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø±Ø¯Ú¯ÛŒØ±ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÛŒØ¯ Ø§Ø² Ø·Ø±ÛŒÙ‚ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø±Ø§ ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒØ¯Ú©Ø§Ø¯Ø± Ø±Ø§ Ø',0),(454540,12627,'tr','Sadece ziyaret edin:<p><b>YÃ¶netici Kurulumu BorÃ§lar Genel Kurulum->-></b><p>ve izleme PO\'Ä±n Ã¶deme kredi kartÄ± ile etkinleÅŸtirmek istiyorsanÄ±z bu onay kutusunu seÃ§in.',0),(454541,12627,'pl','Po prostu odwiedÅº:<p><b>Admin-> zobowiÄ…zania ustawienia-> ustawienia ogÃ³lne</b><p>i zaznacz pole wyboru, jeÅ›li chcesz wÅ‚Ä…czyÄ‡ Å›ledzenie pÅ‚atnoÅ›ci PO za pomocÄ… karty kredytowej.',0),(454542,12627,'bg','ÐŸÑ€Ð¾ÑÑ‚Ð¾ Ð¿Ð¾ÑÐµÑ‚ÐµÑ‚Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ-> ÐžÐ±Ñ‰Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°</b><p>Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¾Ñ‚Ð¼ÐµÑ‚ÐºÐ° Ð² ÐºÐ²Ð°Ð´Ñ€Ð°Ñ‚Ñ‡ÐµÑ‚Ð¾, Ð°ÐºÐ¾ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ñ€Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚Ðµ Ð¿Ñ€Ð¾',0),(454543,12627,'ur','ØµØ±Ù Ù…Ù„Ø§Ø­Ø¸Û Ú©Ø±ÛŒÚº:<p><b>Ø§ÛŒÚˆÙ…Ù†-> Ø¬Ù†Ø±Ù„ Ø³ÛŒÙ¹ Ø§Ù¾ Ø³ÛŒÙ¹ Ø§Ù¾ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³-></b><p>Ø§ÙˆØ± Ø§Ú¯Ø± Ø¢Ù¾ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ù¾Ùˆ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø³Û’ Ø¨Ø§Ø®Ø¨Ø± Ø±Ú©Ú¾Ù†Û’ Ú©Ùˆ Ø§ÛÙ„ Ø¨Ù†Ø§Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº Ø',0),(454544,12627,'sr','ÐˆÐµÐ´Ð½Ð¾ÑÑ‚Ð°Ð²Ð½Ð¾ Ð¿Ð¾ÑÑ˜ÐµÑ‚Ð¸Ñ‚Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð·Ð° Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ñƒ Ð¸ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð³Ð»Ð°Ð²Ð½Ðµ</b><p>Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ð¾Ñ€ Ñƒ Ð¿Ð¾Ñ™Ñƒ Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°ÐºÐ¾ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¾Ð¼Ð¾Ð³ÑƒÑ›Ð¸Ñ',0),(454545,12627,'vi','ÄÆ¡n giáº£n chá»‰ cáº§n ghÃ© thÄƒm:CÃ i Ä‘áº·t pháº£i tráº£ -> CÃ i Ä‘áº·t vÃ  chá»n há»™p kiá»ƒm náº¿u báº¡n muá»‘n kÃ­ch hoáº¡t tÃ­nh nÄƒng theo dÃµi thanh toÃ¡n cá»§a PO qua tháº» tÃ­n dá»¥ng.',0),(454546,12627,'af','Besoek eenvoudig:<p><b>Admin-> opstelling Waardedalingstoetse-> algemene opstelling</b><p>en kies die merkblokkie as jy wil dop van betaling van PO se via kredietkaart te aktiveer.',0),(454547,12627,'ro','Pur ÅŸi simplu vizitaÅ£i:<p><b>Admin-> Parametrizare cumpÄƒrÄƒri ÅŸi datorii-> General Setup</b><p>ÅŸi selectaÅ£i caseta de selectare dacÄƒ doriÅ£i sÄƒ activaÅ£i urmÄƒrirea plÄƒÈ›ii PO prin card de credit.',0),(454548,12627,'et','Lihtsalt kÃ¼lastada:<p><b>Admin-> seadistus hankijatele-> Ã¼ldine seadistus</b><p>ja mÃ¤rkige ruut, kui soovite lubada PO\'s maksmise kaudu krediitkaardi jÃ¤lgimine.',0),(454549,12627,'si','Preprosto obiÅ¡Äite:<p><b>Admin-> Setup obveznosti-> Nastavitev sploÅ¡nega</b><p>in izberite potrditveno polje, Äe Å¾elite omogoÄiti sledenje osebe PO plaÄila s kreditno kartico.',0),(454550,12627,'ba','Cukup kunjungi:<p><b>Admin-> Setup hutang-> tetapan Umum</b><p>dan centang kotak jika Anda ingin mengaktifkan pelacakan pembayaran PO melalui kartu kredit.',0),(454551,12627,'nl','Gewoon bezoek:<p><b>Admin-> Setup schulden-> algemene Setup</b><p>en schakel het selectievakje in als u wilt bijhouden van de betaling van PO\'s via creditcard inschakelen.',0),(454552,12627,'fi','Vieraile:<p><b>Admin asetukset ostovelkojen-> asennuksen-></b><p>ja valitse valintaruutu, jos haluat ottaa kÃ¤yttÃ¶Ã¶n seuranta PO maksamisesta luottokortilla.',0),(454553,12627,'no','Bare gÃ¥:<p><b>Admin-> Setup leverandÃ¸rgjeld-> generelt oppsett</b><p>og velg alternativet hvis du vil aktivere sporing av betaling av PO via kredittkort.',0),(454554,12627,'da','Du skal blot besÃ¸ge:<p><b>Admin-> Setup kreditorstyring-> General Setup</b><p>og Marker afkrydsningsfeltet, hvis du vil aktivere sporing af betaling af PO\'S via kreditkort.',0),(454555,12627,'ko','ë‹¨ìˆœížˆ ë°©ë¬¸.<p><b>ì¼ë°˜ ì„¤ì¹˜-> ì„¤ì¹˜ ë¯¸ì§€ê¸‰ê¸ˆ-> ê´€ë¦¬ìž</b><p>ê·¸ë¦¬ê³  í¬ì˜ì˜ ì‹ ìš© ì¹´ë“œë¥¼ í†µí•´ ì§€ë¶ˆì˜ ì¶”ì ì„ í™œì„±í™” í•˜ë ¤ë©´ í™•ì¸ëž€ì„ ì„ íƒ í•©ë‹ˆë‹¤.',0),(454556,12627,'he','×¤×©×•×˜ ×‘×§×¨:<p><b>Admin-> ×”×”×ª×§× ×” ×–×›××™×-> ×›×œ×œ×™ ×”×ª×§× ×”</b><p>×‘×—×¨ ××ª ×ª×™×‘×ª ×”×¡×™×ž×•×Ÿ ×× ×‘×¨×¦×•× ×š ×œ××¤×©×¨ ×ž×¢×§×‘ ×©×œ ×ª×©×œ×•×-××• ×‘××ž×¦×¢×•×ª ×›×¨×˜×™×¡ ××©×¨××™.',0),(454557,12627,'el','Î‘Ï€Î»Î¬ ÎµÏ€Î¹ÏƒÎºÎµÏ†Î¸ÎµÎ¯Ï„Îµ:<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½-> Î Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ·</b><p>ÎºÎ±Î¹ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Î½ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€Î±Ï',0),(454558,12627,'zh','ä»…æŸ¥çœ‹ï¼šç®¡ç†->è®¾ç½®åº”ä»˜æ¬¾é¡¹->æ™®é€šè®¾ç½®ã€‚å¦‚æžœä½ æƒ³é€šè¿‡ä¿¡ç”¨å¡è®¢å•ä»˜æ¬¾è¿½è¸ªç”Ÿæ•ˆï¼Œé€‰æ‹©è¯¥é€‰æ¡†ã€‚',0),(454559,12627,'sv','Bara besÃ¶ka:<p><b>Admin-> Setup leverantÃ¶rsskulder-> allmÃ¤n instÃ¤llning</b><p>VÃ¤lj kryssrutan om du vill aktivera spÃ¥rning fÃ¶r betalning av PO via kreditkort.',0),(454560,12627,'it','Basta visitare:<p><b>Admin-> Setup debiti-> Setup generale</b><p>e selezionare la casella di controllo se si desidera attivare la traccia del pagamento del PO tramite carta di credito.',0),(454561,12627,'tl','',0),(454562,12627,'th','à¹€à¸žà¸µà¸¢à¸‡à¸Šà¸¡:<p><b>Admin->à¹€à¸ˆà¹‰à¸²à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸—à¸±à¹ˆà¸§à¹„à¸›</b><p>à¹€à¸¥à¸·à¸­à¸à¸à¸¥à¹ˆà¸­à¸‡à¸à¸²à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¸–à¹‰à¸²à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à',0),(454563,12627,'hi','à¤¬à¤¸ à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤° à¤œà¤¾à¤à¤:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª Payables à¤œà¤¨à¤°à¤² à¤¸à¥‡à¤Ÿà¤…à¤ª->-></b><p>à¤”à¤° à¤…à¤—à¤° à¤¤à¥à¤® à¤ªà¥‹ à¤•à¥‡ à¤•à¥‡ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤œà¤°à¤¿à¤ à¤­à¥à¤',0),(454564,12627,'ms','Hanya layari:<p><b>Admin-> persediaan pemiutang-> persediaan umum</b><p>dan pilih kotak semak jika anda mahu untuk membolehkan pengesanan pembayaran di PO melalui kad kredit.',0),(454565,12627,'ar','Ø¨Ø¨Ø³Ø§Ø·Ø© Ù‚Ù… Ø¨Ø²ÙŠØ§Ø±Ø©:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø¥Ø¹Ø¯Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø¹Ø§Ù…Ø©</b><p>ÙˆÙ‚Ù… Ø¨ØªØ­Ø¯ÙŠØ¯ Ø®Ø§Ù†Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø¥Ø°Ø§ ÙƒÙ†Øª ØªØ±ÙŠØ¯ ØªÙ…ÙƒÙŠÙ† Ø§Ù„ØªØªØ¨Ø¹ Ù„Ø¯ÙØ¹ Ø¨Ùˆ Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ø¨Ø·Ø§Ù‚Ø© ',0),(454566,12627,'fr','Il suffit de visiter :<p><b>Admin-> configuration des comptes fournisseurs-> installation gÃ©nÃ©rale</b><p>et sÃ©lectionnez la case Ã  cocher si vous souhaitez activer le suivi du paiement des bons de commande par carte de crÃ©dit.',0),(454567,12627,'jp','å˜ã«å‚ç…§ã—ã¦ãã ã•ã„ã€‚<p><b>ä¸€èˆ¬çš„ãªã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—-> ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—å‚µå‹™-> ç®¡ç†è€…</b><p>PO ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æ±ºæ¸ˆã®è¿½è·¡ã‚’æœ‰åŠ¹ã«ã™ã‚‹å ´åˆã€ãƒã‚§ãƒƒã‚¯ ãƒœãƒƒã‚¯ã‚¹ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(454568,12627,'pt','Basta visite:<p><b>Admin-> contas a pagar-> General Setup configuraÃ§Ã£o</b><p>e marque a caixa de seleÃ§Ã£o se vocÃª deseja ativar o rastreamento de pagamento de PO via cartÃ£o de crÃ©dito.',0),(454569,12627,'ru','ÐŸÑ€Ð¾ÑÑ‚Ð¾ Ð¿Ð¾ÑÐµÑ‚Ð¸Ñ‚Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹-> ÐžÐ±Ñ‰Ð°Ñ ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°</b><p>Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ñ„Ð»Ð°Ð¶Ð¾Ðº, ÐµÑÐ»Ð¸ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ Ð',0),(454570,12627,'es','Simplemente visita:<p><b>Admin -> Configurar Pagables -> ConfiguraciÃ³n General</b><p>y selecciona la caja si quiere habilitar el rastreo de pagos de OC\'s via Tarjeta de CrÃ©dito.',0),(454571,12627,'de','Besuchen Sie einfach:<p><b>Admin-> Setup Verbindlichkeiten-> General Setup</b><p>und aktivieren Sie das KontrollkÃ¤stchen, wenn Sie Verfolgung von Kreditkartenzahlung des POs aktivieren mÃ¶chten.',0),(454572,12627,'en','Simply visit:<p><b>Admin -> Setup Payables -> General Setup</b><p>and select the check box if you want to enable tracking of payment of PO\'s via credit card.',0),(454573,12628,'is','',0),(454574,12628,'dr','Ø§Ú¯Ø± Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ú©Ù‡ ÙˆØ§Ø­Ø¯Ù‡Ø§ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø± ÛŒÚ© Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ø¸Ø§Ù‡Ø± Ù†Ø´ÙˆØ¯.Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ… Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§- ØªÙ†Ø¸ÛŒÙ… Ú©Ù„ÛŒ. ØªÛŒÚ© Ú©Ø§Ø¯Ø± \"Ù‚ÛŒÙ…Øª Ø±Ø§ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡\" Ø±Ø§ Ø¨Ø±Ø¯Ø§Ø',0),(454575,12628,'pr','Ø§Ú¯Ø± Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ú©Ù‡ ÙˆØ§Ø­Ø¯Ù‡Ø§ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø± ÛŒÚ© Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ø¸Ø§Ù‡Ø± Ù†Ø´ÙˆØ¯.Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ… Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§- ØªÙ†Ø¸ÛŒÙ… Ú©Ù„ÛŒ. ØªÛŒÚ© Ú©Ø§Ø¯Ø± \"Ù‚ÛŒÙ…Øª Ø±Ø§ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ù†Ø´Ø§Ù† Ù†Ø¯Ù‡\" Ø±Ø§ Ø¨Ø±Ø¯Ø§Ø',0),(454576,12628,'tr','Birim fiyatlarÄ± PO ziyaret iÃ§in gÃ¶rÃ¼nmesini istiyorsanÄ±z:<p><b>YÃ¶netici Kurulumu BorÃ§lar Genel Kurulum->->.</b><p>Uncheck belgili tanÄ±mlÄ±k kutu \"Yapmak deÄŸil gÃ¶stermek fiyatlarÄ± Ã¼zerinde PO\".',0),(454577,12628,'pl','JeÅ›li nie chcesz, aby ceny jednostkowe do stawienia siÄ™ na wizytÄ™ PO:<p><b>Admin-> zobowiÄ…zania ustawienia-> ustawienia ogÃ³lne.</b><p>UsuÅ„ zaznaczenie pola \"Czy nie PokaÅ¼ ceny na PO\".',0),(454578,12628,'bg','ÐÐºÐ¾ Ð½Ðµ Ð¶ÐµÐ»Ð°ÐµÑ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ð¸ Ð´Ð° ÑÐµ Ð¿Ð¾ÑÐ²Ð¸ Ð½Ð° PO Ð¿Ð¾ÑÐµÑ‰ÐµÐ½Ð¸Ðµ:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ-> ÐžÐ±Ñ‰Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°.</b><p>ÐœÐ°Ñ…Ð½ÐµÑ‚Ðµ Ð¾Ñ‚Ð¼ÐµÑ‚ÐºÐ°Ñ‚Ð° Ð¾Ñ‚',0),(454579,12628,'ur','Ø§Ú¯Ø± Ø¢Ù¾ ÛŒÙˆÙ†Ù¹ Ù‚ÛŒÙ…ØªÛŒÚº Ø§ÛŒÚ© Ù¾Ùˆ Ø¯ÙˆØ±Û’ Ù¾Ø± Ø¸Ø§ÛØ± Ú©Ø±Ù†Ø§ Ù†ÛÛŒÚº Ú†Ø§ÛØªÛ’ Û”<p><b>Ø§ÛŒÚˆÙ…Ù†-> Ø¬Ù†Ø±Ù„ Ø³ÛŒÙ¹ Ø§Ù¾ Ø³ÛŒÙ¹ Ø§Ù¾ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³-> Û”</b><p>\"Ú©Ø±ØªÛ’ ÛÛŒÚº Ù†Û Ø¯Ú©Ú¾Ø§Ù†Û’ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ù¾Ø± Ù¾Ùˆ\" Ø®Ø§Ù†Û Ø¨',0),(454580,12628,'sr','ÐÐºÐ¾ Ð½Ðµ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° ÑÐµ Ð¿Ð¾Ñ˜Ð°Ð²Ð¸ Ñƒ Ð¿Ð¾ÑÐµÑ‚Ð¸ ÐŸÐž Ñ†ÐµÐ½Ð°Ð¼Ð°:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð·Ð° Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ñƒ Ð¸ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð³Ð»Ð°Ð²Ð½Ðµ.</b><p>ÐŸÐ¾Ð½Ð¸ÑˆÑ‚Ð¸Ñ‚Ðµ Ð¾ÐºÐ²Ð¸Ñ€ \"Ð”Ð° Ð½Ðµ Ð¿Ð¾ÐºÐ°Ð·ÑƒÑ˜Ñƒ Ñ†ÐµÐ½',0),(454581,12628,'vi','náº¿u báº¡n khÃ´ng muá»‘n Ä‘Æ¡n giÃ¡ xuáº¥t hiá»‡n trÃªn PO thÃ¬ vÃ o: quáº£n trá»‹-thiáº¿t láº­p khoáº£n pháº£i tráº£-thiáº¿t láº­p chung, bá» chá»\"KhÃ´ng thá»ƒ hiá»‡n giÃ¡ trÃªn PO\"',0),(454582,12628,'af','As jy nie wil hÃª die eenheid pryse om te verskyn op \'n PO besoek:<p><b>Admin-> opstelling Waardedalingstoetse-> algemene opstelling.</b><p>Ontmerk die boks \"Doen nie wys pryse op PO\".',0),(454583,12628,'ro','DacÄƒ nu doriÅ£i preÅ£urile unitare sÄƒ aparÄƒ pe o vizitÄƒ PO:<p><b>Admin-> Parametrizare cumpÄƒrÄƒri ÅŸi datorii-> Parametrizare.</b><p>DebifaÅ£i caseta \"Face nu aratÄƒ preÅ£urile pe PO\".',0),(454584,12628,'et','Kui te ei soovi Ã¼hikuhinnad ilmuvad PO kÃ¼lastus:<p><b>Admin-> seadistus hankijatele-> Ã¼ldine seadistus.</b><p>LÃ¼lita kasti \"Ei ole nÃ¤idata hindu linna PO\".',0),(454585,12628,'si','ÄŒe ne Å¾elite, da so cene na enoto na obisk PO:<p><b>Admin-> Setup obveznosti-> Nastavitev sploÅ¡nega.</b><p>Nenadzirljiv Å¡katla \"Storiti ne kaÅ¾ejo cene na pad\".',0),(454586,12628,'ba','Jika Anda tidak ingin harga satuan muncul di PO kunjungi:<p><b>Admin-> Setup hutang-> tetapan umum.</b><p>Hapus centang pada kotak \"Apakah tidak menunjukkan harga pada PO\".',0),(454587,12628,'nl','Als u niet dat de prijzen per eenheid wilt worden weergegeven op een bezoek PO:<p><b>Admin-> Setup schulden-> algemene Setup.</b><p>Uncheck de doos \"Doen niet Toon prijzen op PO\".',0),(454588,12628,'fi','Jos et halua nÃ¤kyvÃ¤n PO yksikkÃ¶hinnat kÃ¤y:<p><b>Admin asetukset ostovelkojen-> asennuksen->.</b><p>EhkÃ¤isemÃ¤tÃ¶n lyÃ¶dÃ¤ \"TehdÃ¤ ei NÃ¤ytÃ¤ hinnat on PO\".',0),(454589,12628,'no','Hvis du ikke vil at salgsprisene skal vises pÃ¥ en PO besÃ¸k:<p><b>Admin-> Setup leverandÃ¸rgjeld-> generelt oppsett.</b><p>Fjern merket i boksen \"GjÃ¸r ikke vise prisene pÃ¥ PO\".',0),(454590,12628,'da','Hvis du ikke Ã¸nsker at salgsprisen skal vises pÃ¥ en PO besÃ¸g:<p><b>Admin-> Setup kreditorstyring-> General Setup.</b><p>Fjern markeringen i afkrydsningsfeltet \"GÃ¸r ikke vise priser pÃ¥ PO\".',0),(454591,12628,'ko','ë‹¨ìœ„ ê°€ê²© í¬ ë°©ë¬¸ì— í‘œì‹œë¥¼ í•˜ì§€ ì•Šìœ¼ë ¤ë©´:<p><b>ì¼ë°˜ ì„¤ì¹˜-> ì„¤ì¹˜ ë¯¸ì§€ê¸‰ê¸ˆ-> ê´€ë¦¬ìžìž…ë‹ˆë‹¤.</b><p>\"í•  í•˜ì§€ í‘œì‹œ ê°€ê²©ì— í¬\" í™•ì¸ëž€ì˜ ì„ íƒì„ ì·¨ì†Œ í•©ë‹ˆë‹¤.',0),(454592,12628,'he','×× ××ª×” ×œ× ×¨×•×¦×” ××ª ×”×ž×—×™×¨×™× ×œ×™×—×™×“×” ×œ×”×•×¤×™×¢ ×¢×œ ×‘×™×§×•×¨ ×¤×•:<p><b>Admin-> ×”×”×ª×§× ×” ×–×›××™×-> ×›×œ×œ×™ ×”×ª×§× ×”.</b><p>×‘×˜×œ ××ª ×¡×™×ž×•×Ÿ ×”×ª×™×‘×” \"×œ× ×œ×”×¦×™×’ ×ž×—×™×¨×™× ×¢×œ ×¤×•\".',0),(454593,12628,'el','Î•Î¬Î½ Î´ÎµÎ½ Î¸Î­Î»ÎµÏ„Îµ Ï„Î¹Ï‚ Ï„Î¹Î¼Î­Ï‚ Î¼Î¿Î½Î¬Î´Ï‰Î½ Î½Î± ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ ÏƒÎµ Î¼Î¹Î± ÎµÏ€Î¯ÏƒÎºÎµÏˆÎ· Ï„Î¿Ï… PO:<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½-> Ï€Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ·.</b><p>Î‘Ï€Î¿ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ ',0),(454594,12628,'zh','å¦‚æžœæ‚¨ä¸æƒ³å•ä½ä»·æ ¼å‡ºçŽ°åœ¨ä¸€ä¸ªè®¢å•ä¸Šï¼Œè¯·æŸ¥çœ‹ï¼šç®¡ç†->è®¾ç½®åº”ä»˜è´¦æ¬¾->æ™®é€šè®¾ç½®\r\nå‹¾é™¤â€œä¸åœ¨è®¢å•ä¸Šæ˜¾ç¤ºä»·æ ¼â€é€‰æ¡†ã€‚\r\n',0),(454595,12628,'sv','Om du inte vill att a-priserna ska visas pÃ¥ PO besÃ¶k:<p><b>Admin-> Setup leverantÃ¶rsskulder-> allmÃ¤n instÃ¤llning.</b><p>Avmarkera rutan \"GÃ¶r inte Visa priserna pÃ¥ PO\".',0),(454596,12628,'it','Se non si desidera visitare i prezzi unitari per apparire un PO:<p><b>Admin-> Setup debiti-> Setup generale.</b><p>Deselezionare la casella \"Do non visualizza i prezzi sul PO\".',0),(454597,12628,'tl','',0),(454598,12628,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸£à¸²à¸„à¸²à¸•à¹ˆà¸­à¸«à¸™à¹ˆà¸§à¸¢à¸—à¸µà¹ˆà¸›à¸£à¸²à¸à¸à¹€à¸à¸µà¹ˆà¸¢à¸§à¸à¸±à¸šà¸à¸²à¸£à¹€à¸¢à¸µà¹ˆà¸¢à¸¡à¸Šà¸¡ PO:<p><b>Admin->à¹€à¸ˆà¹‰à¸²à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸—à¸±à¹ˆà¸§à¹',0),(454599,12628,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤¨à¤¹à¥€à¤‚ à¤šà¤¾à¤¹à¤¤à¥‡ à¤•à¤¿ à¤à¤• PO à¤ªà¤° à¤ªà¥à¤°à¤•à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤ªà¤° à¤œà¤¾à¤à¤:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª Payables à¤œà¤¨à¤°à¤² à¤',0),(454600,12628,'ms','Jika anda tidak mahu harga unit untuk hadir melawat PO:<p><b>Admin-> persediaan pemiutang-> persediaan umum.</b><p>Buang tanda kotak \"Jangan tidak menunjukkan harga di PO\".',0),(454601,12628,'ar','Ø¥Ø°Ø§ ÙƒÙ†Øª Ù„Ø§ ØªØ±ÙŠØ¯ Ø£Ø³Ø¹Ø§Ø± Ø§Ù„ÙˆØ­Ø¯Ø© ØªØ¸Ù‡Ø± Ø¹Ù„Ù‰ Ø²ÙŠØ§Ø±Ø© Ø¨Ùˆ:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø¥Ø¹Ø¯Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø¹Ø§Ù…Ø©.</b><p>Ù‚Ù… Ø¨Ø¥Ù„ØºØ§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ù…Ø±Ø¨Ø¹ \"Ø¹Ø¯Ù… Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¹',0),(454602,12628,'fr','Si vous ne voulez pas les prix unitaires de comparaÃ®tre lors d\'une visite de PO :<p><b>Admin-> configuration des comptes fournisseurs-> installation gÃ©nÃ©rale.</b><p>DÃ©cochez la case Â« Faire pas afficher les prix sur PO Â».',0),(454603,12628,'jp','PO ã«è¡¨ç¤ºã™ã‚‹å˜ä½ã®ä¾¡æ ¼ã‚’æœ›ã‚“ã§ã„ãªã„å ´åˆå‚ç…§ã—ã¦ãã ã•ã„ã€‚<p><b>ä¸€èˆ¬çš„ãªã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—-> ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—å‚µå‹™-> ç®¡ç†è€…ã€‚</b><p>\"ã¯ãªã„è¡¨ç¤ºä¾¡æ ¼ã« PO\"ãƒœãƒƒã‚¯ã‚¹ã‚’ã‚ªãƒ•ã«ã—ã¾ã™ã€‚',0),(454604,12628,'pt','Se vocÃª nÃ£o quiser que os preÃ§os unitÃ¡rios para aparecer em uma visita de PO:<p><b>Admin-> contas a pagar-> General Setup Setup.</b><p>Desmarque a caixa \"Fazer nÃ£o mostram os preÃ§os em PO\".',0),(454605,12628,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð½Ðµ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÐµÑ‚Ð¸Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‹ ÐµÐ´Ð¸Ð½Ð¸Ñ† Ð¿Ð¾ÑÐ²Ð»ÑÑ‚ÑŒÑÑ Ð½Ð° PO:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹-> ÐžÐ±Ñ‰Ð°Ñ ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°.</b><p>Ð¡Ð½Ð¸Ð¼Ð¸Ñ‚Ðµ Ñ„Ð»Ð°Ð¶Ð¾Ðº Â«Ð¡Ð´ÐµÐ',0),(454606,12628,'es','Si no quiere que los precios por unidad no aparecen en una visita de OC:<p><b>Admin -> ConfiguraciÃ³n de Pagables ->ConfiguraciÃ³n General.</b><p>\r\nNo chequea la caja \"no Muestra Los Precios en el OC\".',0),(454607,12628,'de','Wenn Sie nicht, dass die Einheitspreise auf einen PO-Besuch angezeigt werden mÃ¶chten:<p><b>Admin-> Setup Verbindlichkeiten-> General Setup.</b><p>Deaktivieren Sie das KontrollkÃ¤stchen \"Tun nicht zeigen Preise am PO\".',0),(454608,12628,'en','If you do not want the unit prices to appear on a PO visit:<p><b>Admin -> Setup Payables -> General Setup.</b><p>\r\nUncheck the box \"Do Not Show Prices on PO\". ',0),(454609,12629,'is','',0),(454610,12629,'dr','ØªØ®ÙÛŒÙ ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÛŒØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡:Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø±Ø· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø±:Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ… Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§-Ø´Ø±Ø§ÛŒØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡.Ø§Ù†ØªØ®Ø§Ø¨ Ø§ÛŒÙ† Ø¯Ø± \" Ø´Ø±Ø§ÛŒØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡-Ø§ÛŒÙ† ÙØ±Ù…Ø§ÛŒØ´ Ø®Ø±ÛŒØ¯\"ØªØ®ÙÛŒÙ Ø§Ø¹',0),(454611,12629,'pr','ØªØ®ÙÛŒÙ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡:Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø±Ø· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø±:Ù…Ø¯ÛŒØ±ÛŒØª-ØªÙ†Ø¸ÛŒÙ… Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§-Ø´Ø±Ø§ÛŒØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡.Ø§Ù†ØªØ®Ø§Ø¨ Ø§ÛŒÙ† Ø¯Ø± \" Ø´Ø±Ø§ÛŒØ· ÙØ±ÙˆØ´Ù†Ø¯Ù‡-Ø§ÛŒÙ† Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯\"ØªØ®ÙÛŒÙ Ø§Ø¹Ù…Ø§',0),(454612,12629,'tr','PO satÄ±cÄ± indirim:<p>SatÄ±cÄ± vadede oluÅŸturun:<p><b>YÃ¶netici Kurulumu BorÃ§lar satÄ±cÄ± aÃ§Ä±sÄ±ndan->->.</b><p>\'SatÄ±cÄ± Terms-This indirim uygulanacak SE\'de\' seÃ§eneÄŸini seÃ§in.<p>SatÄ±cÄ± terim kÃ¼mesi:<p><b>KiÅŸileri dÃ¼zenleme satÄ±cÄ±-> satÄ±c',0),(454613,12629,'pl','PO dostawcy zniÅ¼ki:<p>Tworzenie terminu dostawcy w:<p><b>Admin-> instalacji zobowiÄ…zania-> warunki dostawcy.</b><p>Wybierz tÄ™ opcjÄ™, w \"dostawcy Terms-This PO\' do zastosowania zniÅ¼ki.<p>Ustawianie dostawcy termin:<p><b>Kontakty-> dostawcÃ³w-> edycja ',0),(454614,12629,'bg','PO Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº:<p>Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð·Ñ€Ð°Ð· Ð²:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ-> ÑƒÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº.</b><p>Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð¾Ð²Ð°, Ð²',0),(454615,12629,'ur','Ù¾Ùˆ ÙˆÛŒÙ†ÚˆØ± Ø±Ø¹Ø§ÛŒØª:<p>ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­ Ù…ÛŒÚº Ø¨Ù†Ø§Ø¦ÛŒÚº:<p><b>Ø§ÛŒÚˆÙ…Ù† ÙˆÛŒÙ†ÚˆØ± Ø´Ø±Ø§Ø¦Ø·-> Ø³ÛŒÙ¹ Ø§Ù¾ Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³-> Û”</b><p>ÛŒÛ \'ÙˆÛŒÙ†ÚˆØ± Terms-This Ø±Ø¹Ø§ÛŒØª Ú©Ø§ Ø§Ø·Ù„Ø§Ù‚ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù¾ÙˆØ³Ù¹ Ù…ÛŒÚº\' Ù…',0),(454616,12629,'sr','ÐŸÐž Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ñƒ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°:<p>ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¼Ð°Ð½Ð´Ð°Ñ‚ Ð½Ð°:<p><b>ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°.</b><p>Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ Ñƒ \'Ð”Ð¾Ð±Ð°Ð²Ñ',0),(454617,12629,'vi','PO chiáº¿t kháº¥u cá»§a nhÃ  cung cáº¥p, táº¡o má»¥c nhÃ  cung cáº¥p má»›i trong: Quáº£n trá»‹-cÃ i Ä‘áº·t khoáº£n pháº£i tráº£-Danh má»¥c nhÃ  cung cáº¥p. Chá»n\" danh má»¥c nhÃ  cung cáº¥p-PO nÃ y\" Ä‘á»ƒ Ã¡p dá»¥ng chiáº¿t kháº¥u',0),(454618,12629,'af','Posbus handelaar afslag:<p>Skep handelaar termyn in:<p><b>Admin-> opstelling Waardedalingstoetse-> handelaar terme.</b><p>Kies dit in \'Handelaar Terms-This PO\' om die afslag te dien.<p>Stel handelaar termyn:<p><b>Kontakte-> verkopers-> redigeer handelaar<',0),(454619,12629,'ro','PO furnizor de reducere:<p>Termenul de furnizor Ã®n a crea:<p><b>Admin-> Parametrizare cumpÄƒrÄƒri ÅŸi datorii-> termeni de furnizor.</b><p>SelectaÅ£i aceastÄƒ opÅ£iune Ã®n \'Furnizor Terms-This PO\' a aplica discountul.<p>Stabilit termenul de furnizor:<p><',0),(454620,12629,'et','PO hankija Soodushind:<p>Loo hankija mÃµiste:<p><b>Admin-> seadistus hankijatele-> hankija tingimused.</b><p>Valige seda \'tarnija Terms-This PO\"et rakendada allahindlust.<p>MÃ¤Ã¤rata hankija mÃµiste:<p><b>-> Hankijate-> Edit hankija kontaktid</b><p>Lisage',0),(454621,12629,'si','Popust PO dobavitelju:<p>Ustvarite izraz dobavitelja v:<p><b>Admin-> Setup obveznosti-> pogoji prodajalca.</b><p>Izberite to moÅ¾nost, v \"Prodajalec Terms-This PO\" da velja popust.<p>Nastavite dobavitelja izraz:<p><b>Stiki-> prodajalci-> urejanje dobavite',0),(454622,12629,'ba','Diskon Vendor PO:<p>Buat Penjual istilah dalam:<p><b>Admin-> Setup hutang-> Vendor persyaratan.</b><p>Pilih ini di \'Vendor Terms-This PO\' untuk menerapkan diskon.<p>Menetapkan jangka Penjual:<p><b>Kontak-> vendor-> Edit Vendor</b><p>Masukkan istilah dalam',0),(454623,12629,'nl','PO leverancier korting:<p>Maak leverancier termijn in:<p><b>Admin-> Setup schulden-> leverancier voorwaarden.</b><p>Selecteer deze optie in \'Leverancier Terms-This PO\' toe te passen van de korting.<p>Leverancier termijn instellen<p><b>Contacten-> leveranc',0),(454624,12629,'fi','PO toimittajan alennus:<p>Luo toimittajan termi:<p><b>Admin asetukset ostovelkojen-> toimittajan->.</b><p>Valitse tÃ¤mÃ¤ \"toimittajan Terms-This PO\' soveltaa alennus.<p>Toimittajaluokan termi:<p><b>Yhteystiedot-> toimittajat-> Muokkaa toimittajaa</b><p>Li',0),(454625,12629,'no','PO leverandÃ¸r rabatt:<p>Opprette leverandÃ¸ren begrepet:<p><b>Admin-> Setup leverandÃ¸rgjeld-> leverandÃ¸ren vilkÃ¥r.</b><p>Velg dette i \"leverandÃ¸r Terms-This PO\' rabatten.<p>Angi leverandÃ¸rens begrepet:<p><b>Kontakter-> leverandÃ¸rer-> Rediger levera',0),(454626,12629,'da','PO forhandler rabat:<p>Opret kreditoren sigt i:<p><b>Admin-> Setup kreditorstyring-> kreditor vilkÃ¥r.</b><p>VÃ¦lg denne indstilling i \'LeverandÃ¸r Terms-This PO\' til at anvende nedsatte.<p>Angive leverandÃ¸r sigt:<p><b>Kontakter-> leverandÃ¸rer-> Rediger',0),(454627,12629,'ko','í¬ ê³µê¸‰ ì—…ì²´ í• ì¸:<p>ì— ê³µê¸‰ ì—…ì²´ ìš©ì–´ë¥¼ ë§Œë“­ë‹ˆë‹¤.<p><b>ê´€ë¦¬ìž ì„¤ì¹˜ ë¯¸ì§€ê¸‰ê¸ˆ ê³µê¸‰ ì—…ì²´ ì¡°ê±´->->ìž…ë‹ˆë‹¤.</b><p>\'ê³µê¸‰ ì—…ì²´ Terms-This í¬\' í• ì¸ì„ ì ìš© í•˜ë ¤ë©´ì´ ì˜µì…˜ì„ ì„ íƒ í•©ë‹ˆë‹¤.<p>ê³µê¸‰ ì—…ì²´ ìš©ì',0),(454628,12629,'he','×¤×• ×”×¡×¤×§ ×”×”× ×—×”:<p>×œ×™×¦×•×¨ ×¡×¤×§ ×ž×•× ×—:<p><b>Admin-> ×”×”×ª×§× ×” ×–×›××™×-> ×ª× ××™ ×”×¡×¤×§.</b><p>×‘×—×¨ ×‘××¤×©×¨×•×ª ×–×• \'×¡×¤×§ Terms-This ×¤×•\' ×›×“×™ ×œ×”×—×™×œ ××ª ×”×”× ×—×”.<p>×”×’×“×¨×ª ×”×ž×•× ×— ×”×¡×¤×§:<p><b>×× ×©×™ ',0),(454629,12629,'el','PO Î­ÎºÏ€Ï„Ï‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®:<p>Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î¸Î·Ï„ÎµÎ¯Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®:<p><b>Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï€Î»Î·ÏÏ‰Ï„Î­Ï‰Î½-> ÏŒÏÎ¿Ï…Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®.</b><p>Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® Ïƒ',0),(454630,12629,'zh','è®¢å•ä¾›åº”å•†æŠ˜æ‰£ï¼šåˆ›å»ºä¾›åº”å•†æ¡æ¬¾åœ¨ï¼šç®¡ç†->è®¾ç½®åº”ä»˜è´¦æ¬¾->ä¾›åº”å•†æ¡æ¬¾\r\nåœ¨â€œä¾›åº”å•†æ¡æ¬¾-æ­¤è®¢å•â€å¤„é€‰æ‹©æ­¤ä»¥åº”ç”¨æŠ˜æ‰£ã€‚è®¾ç½®ä¾›åº”å•†æ¡æ¬¾ï¼šè”ç³»->ä¾›åº”å•†->ç¼–è¾‘ä¾›åº”å•†\r\nåœ¨â€œä»˜æ¬¾æ¡æ¬¾-IDâ€å¤„æ’å…¥æ',0),(454631,12629,'sv','PO leverantÃ¶r rabatt:<p>Skapa leverantÃ¶r term i:<p><b>Admin-> Setup leverantÃ¶rsskulder-> sÃ¤ljaren.</b><p>Markera detta i \"LeverantÃ¶r Terms-This PO\" att tillÃ¤mpa rabatten.<p>Ange leverantÃ¶r sikt:<p><b>Kontakter-> leverantÃ¶rer-> redigera leverantÃ¶r',0),(454632,12629,'it','PO Vendor sconto:<p>Creare termine fornitore in:<p><b>Admin-> Setup debiti-> termini di fornitore.</b><p>Selezionare questa opzione in \'Vendor Terms-This PO\' di applicare lo sconto.<p>Impostare il termine fornitore:<p><b>Contatti-> venditori-> modifica fo',0),(454633,12629,'tl','',0),(454634,12629,'th','PO à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸ªà¹ˆà¸§à¸™à¸¥à¸”:<p>à¸ªà¸£à¹‰à¸²à¸‡à¸§à¸²à¸£à¸°à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢:<p><b>Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸ˆà¹‰à¸²->à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢</b><p>à¹€à¸¥à¸·',0),(454635,12629,'hi','PO à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤›à¥‚à¤Ÿ:<p>à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾à¤°à¥à¤¯à¤•à¤¾à¤² à¤®à¥‡à¤‚ à¤¬à¤¨à¤¾à¤à¤:<p><b>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª Payables à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¶à¤°à¥à¤¤à¥‹à¤‚->->à¥¤</b><p>à¤¯à¤¹ \'à¤µà¤¿à¤•à¥',0),(454636,12629,'ms','PO penjual diskaun:<p>Mencipta istilah penjual di:<p><b>Admin-> persediaan pemiutang-> syarat-syarat penjual.</b><p>Pilih ini di \'Penjual Terms-This PO\' untuk memohon diskaun.<p>Menetapkan tempoh penjual:<p><b>Kenalan-> vendor-> penjual Edit</b><p>Masukka',0),(454637,12629,'ar','Øµ. Ø¨ Ø¨Ø§Ø¦Ø¹ Ø§Ù„Ø®ØµÙ…:<p>Ø¥Ù†Ø´Ø§Ø¡ ØªØ¹Ø¨ÙŠØ± Ø§Ù„Ù…ÙˆØ±Ø¯ ÙÙŠ:<p><b>Ø§Ù„Ù…Ø´Ø±Ù-> Ø¥Ø¹Ø¯Ø§Ø¯ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹-> Ø´Ø±ÙˆØ· Ø§Ù„Ø¨Ø§Ø¦Ø¹.</b><p>Ø­Ø¯Ø¯ Ù‡Ø°Ø§ Ø§Ù„Ø®ÙŠØ§Ø± ÙÙŠ \'\"Ø¨Ùˆ ØªÙŠØ±Ù…Ø³Ø«ÙŠØ³ Ø§Ù„Ù…ÙˆØ±Ø¯\"\' ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø®ØµÙ….<p>Øª',0),(454638,12629,'fr','PO fournisseur Discount :<p>CrÃ©er le terme fournisseur en :<p><b>Admin-> configuration des comptes fournisseurs-> les termes du vendeur.</b><p>SÃ©lectionnez cette option dans Â« vendeur Terms-This PO\' Ã  laquelle la remise.<p>Terme de jeu de l\'Ã©diteur :',0),(454639,12629,'jp','PO ãƒ™ãƒ³ãƒ€ãƒ¼ã®å‰²å¼•ï¼š<p>ãƒ™ãƒ³ãƒ€ãƒ¼ã®ç”¨èªžã‚’ä½œæˆã—ã¾ã™ã€‚<p><b>ç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—è²·æŽ›é‡‘ãƒ™ãƒ³ãƒ€ãƒ¼ç”¨èªž->->.</b><p>å‰²å¼•ã‚’é©ç”¨ã™ã‚‹ \' ãƒ™ãƒ³ãƒ€ãƒ¼ Terms-This PO\' ã§ã“ã‚Œã‚’é¸æŠžã—ã¾ã™ã€‚<p>ãƒ™ãƒ³ãƒ€ãƒ¼ã®ç”¨èªžã‚’è¨',0),(454640,12629,'pt','PO vendedor desconto:<p>Crie o termo fornecedor em:<p><b>Admin-> pagamentos de instalaÃ§Ã£o-> termos de fornecedor.</b><p>Selecione esta opÃ§Ã£o em \'Vendor Terms-This PO\' para aplicar o desconto.<p>Definir o termo fornecedor:<p><b>Contatos-> fornecedores-',0),(454641,12629,'ru','PO Ð°Ð±Ð¾Ð½ÐµÐ¼ÐµÐ½Ñ‚Ð° ÑÐºÐ¸Ð´ÐºÐ°:<p>Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð° Ð²:<p><b>ÐÐ´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ¾Ð¹-> ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð°Ð±Ð¾Ð½ÐµÐ¼ÐµÐ½Ñ‚Ð°.</b><p>Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð¾ Ð² \'ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ter',0),(454642,12629,'es','OC Descuento de Proveedor:<p>Crear TÃ©rmino Proveedor en:<p><b>Admin->ConfiguraciÃ³n de Pagables->TÃ©rminos de Proveedor.</b><p>Selecciona este en \'TÃ©rminos de Proveedor-Este OC\' para aplicar al descuento. <p>Configurar Termino de Proveedor:<p><b>Contact',0),(454643,12629,'de','PO-Hersteller-Rabatt:<p>Erstellen Sie Hersteller-Begriff in:<p><b>Admin-> Setup Verbindlichkeiten-> Hersteller Bedingungen.</b><p>WÃ¤hlen Sie diese in \'Vendor Terms-This PO\' den Rabatt anwenden.<p>Legen Sie die Hersteller-Begriff:<p><b>Kontakte-> Anbieter',0),(454644,12629,'en','PO Vendor Discount:<p>Create vendor term in:<p><b>Admin->Setup Payables->Vendor Terms.</b><p>Select this in \'Vendor Terms-This PO\' to apply the discount.<p>Set Vendor Term:<p><b>Contacts->Vendors->Edit Vendor</b><p>Insert the term in \"Payment Terms-ID\".',0),(454645,12630,'is','',0),(454646,12630,'dr','.Ø§ÛŒÙ† Ø±Ø§ Ø¯Ø± Ù…Ø³ÛŒØ± Ø²ÛŒØ± Ø¢Ù¾Ø¯ÛŒØª Ú©Ù†ÛŒØ¯:Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¬Ù†Ø³-Ø§Ø¬Ù†Ø§Ø³-Ø§ØµÙ„Ø§Ø­ Ø¬Ù†Ø³.Ø§Ù†ØªØ®Ø§Ø¨ Ú©',0),(454647,12630,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÛŒØ¯ Ú©Ø¯ Ù…Ø­ØµÙˆÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø±Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†Ù†Ø¯ Ùˆ Ù†Ù‡ Ú©Ø¯ Ú©Ø§Ù„Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§.Ø§ÛŒÙ† Ø±Ø§ Ø¯Ø± Ù…Ø³ÛŒØ± Ø²ÛŒØ± Ø¢Ù¾Ø¯ÛŒØª Ú©Ù†ÛŒØ¯:Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§-Ú©Ø§Ù„Ø§Ù‡Ø§-ÙˆÛŒØ±Ø§ÛŒØ´ Ú©Ø§Ù„Ø§.Ø§Ù†ØªØ®Ø§Ø¨ Ú©',0),(454648,12630,'tr','PO\'Ä±n satÄ±cÄ± Ã¼rÃ¼n kodu envanter madde kodu kullanÄ±n. Ä°Ã§inde gÃ¼ncelleme<p><b>Envanter Ã¶ÄŸeleri DÃ¼zenle Ã¶ÄŸesini->-></b><p>\"Madde satÄ±cÄ±sÄ± Ekle/DÃ¼zenle\" seÃ§in.<p>DeÄŸiÅŸiklik satÄ±cÄ± Ã¼rÃ¼n kodu, kayÄ±t ve bu artÄ±k yazdÄ±rÄ±rken yansÄ±tÄ±',0),(454649,12630,'pl','PO uÅ¼yÄ‡ kod produktu dostawcy nie kod pozycji zapasÃ³w. Aktualizacja to w<p><b>Spis-> elementy-> Edytuj element</b><p>Wybierz \"Dostawca zapasu Dodaj/Edytuj\".<p>Zmiana dostawcy kod produktu, Zapisz i to teraz bÄ™dÄ… odzwierciedlane podczas drukowania.',0),(454650,12630,'bg','ÐžÐŸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð²Ð¸Ñ ÐºÐ¾Ð´ Ð½Ðµ ÐºÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´. ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° Ð³Ð¾ Ð²<p><b>Ð¡ÐºÐ»Ð°Ð´-> ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸-> Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚</b><p>Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚',0),(454651,12630,'ur','Ù¾Ùˆ Ú©Û’ ÙˆÛŒÙ†ÚˆØ± Ù¾Ø±ÙˆÚˆÚ©Ù¹ Ú©ÙˆÚˆ Ù†ÛÛŒÚº Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ú©ÙˆÚˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÛŒÚº Û” Ø§Ø³ Ù…ÛŒÚº ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº<p><b>Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§ ØªØ¯ÙˆÛŒÙ† Ø´Û’->-></b><p>\"Ø´Û’ ÙˆÛŒÙ†ÚˆØ± Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ¯ÙˆÛŒÙ',0),(454652,12630,'sr','ÐŸÐ¾Ð¾Ð²Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð° Ð½Ð¸Ñ˜Ðµ Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°. ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð³Ð° Ñƒ<p><b>Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¸ ÑÑ‚Ð°Ð²ÐºÑƒ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ</b><p>Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸',0),(454653,12630,'vi','Viá»‡c sá»­ dá»¥ng cÃ¡c mÃ£ sáº£n pháº©m bÃ¡n hÃ ng khÃ´ng pháº£i lÃ  MÃ£ HÃ ng tá»“n kho. Cáº­p nháº­t trong <b> <p> tá»“n kho-> Máº·t hÃ ng-> thÃªm khoáº£n  <p> Chá»n \"ngÆ°á»i bÃ¡n hÃ ng má»¥c Add / Edit\". <p> Thay Ä‘á»•i MÃ£ sáº£n pháº©m ngÆ°á»i bÃ¡',0),(454654,12630,'af','Posbus se gebruik die handelaar produk kode nie voorraad Item kode. Werk dit in<p><b>Voorraad-> Items-> redigeer Item</b><p>Kies \"Item handelaar byvoeg/redigeer\".<p>Verander die handelaar produk kode, stoor en dit nou weerspieÃ«l sal word wanneer om te dr',0),(454655,12630,'ro','PO pe utilizaÅ£i codul de produs furnizor nu inventar cod articol. ActualizaÅ£i-l Ã®n<p><b>Inventarul-> elemente-> Editare element</b><p>SelectaÅ£i \"Furnizor articol AdÄƒugare/Editare\".<p>Schimba codul de produs furnizor, salvare ÅŸi acest lucru va reflec',0),(454656,12630,'et','PO\'s kasutada hankija Tootekood lao kaubakoodi. Uuenda seda<p><b>Lao-> Ã¼ksuste-> Redigeeri Ã¼ksust</b><p>Valige \"Kauba hankija lisamine vÃµi redigeerimine\".<p>Muuda Tootekood hankija, Salvesta ja see on nÃ¼Ã¼d kajastatud printimisel.',0),(454657,12630,'si','Organizacij s Å¡ifro dobavitelja izdelka ne Å ifra artikla zaloge. Modernizirati to v<p><b>Zaloge-> elementov-> urejevalni element</b><p>Izberite \"Dobaviteljev artikla dodati/urediti\".<p>Sprememba dobavitelja oznako proizvoda, Shrani in to bo zdaj kaÅ¾e p',0),(454658,12630,'ba','PO menggunakan kode produk Vendor tidak kode barang persediaan. Update di<p><b>Persediaan-> item-> Edit Item</b><p>Pilih \"Item Vendor Tambah/Edit\".<p>Perubahan kode produk Vendor, Simpan dan ini sekarang akan tercermin saat mencetak.',0),(454659,12630,'nl','PO\'s via de leverancier-productcode niet inventaris Artikelcode. Bijwerken in<p><b>Voorraad-> Items-> bewerken Item</b><p>Selecteer \'Artikelleverancier toevoegen/bewerken\'.<p>Wijziging de leverancier Product Code, opslaan en dit zal nu worden weergegeven ',0),(454660,12630,'fi','PO kÃ¤yttÃ¤Ã¤ toimittajan Tuotekoodi varaston nimikkeen koodi. PÃ¤ivitÃ¤ se<p><b>Varaston-> kohteita-> Edit Item</b><p>Valitse \"Nimiketoimittaja lisÃ¤Ã¤minen tai muokkaaminen\".<p>Toimittajan tuotekoodi, Tallenna ja tÃ¤mÃ¤ muutos nÃ¤kyy nyt tulostettaessa.',0),(454661,12630,'no','PO bruke varekoden leverandÃ¸ren ikke lager Varekode. Oppdatere den i<p><b>Lageret-> elementer-> redigeringselement</b><p>Velg \"VareleverandÃ¸r Legg til/Rediger\".<p>Endre produktkoden leverandÃ¸r, lagre, og dette gjenspeiles nÃ¥ ved utskrift.',0),(454662,12630,'da','POS bruge produktet Kreditorkoden ikke lager varekode. Opdatere det i<p><b>Beholdning-> punkter-> Rediger element</b><p>VÃ¦lg \"Vare/leverandÃ¸r TilfÃ¸j/Rediger\".<p>Ã†ndre leverandÃ¸r produktkode, Gem og dette afspejles nu, nÃ¥r du udskriver.',0),(454663,12630,'ko','í¬ì˜ ê³µê¸‰ ì—…ì²´ ì œí’ˆ ì½”ë“œ ì—†ëŠ” ìž¬ê³  í’ˆëª© ì½”ë“œë¥¼ ì‚¬ìš©í•©ë‹ˆë‹¤. ê·¸ê²ƒì„ ì—…ë°ì´íŠ¸í•©ë‹ˆë‹¤<p><b>ì¸ë²¤í† ë¦¬ í•­ëª© íŽ¸ì§‘ í•­ëª©->-></b><p>\"ê³µê¸‰ ì—…ì²´ í•­ëª© ì¶”ê°€/íŽ¸ì§‘\"ì„ ì„ íƒ í•©ë‹ˆë‹¤.<p>ë³€ê²½ ì €ìž¥ í•˜ ê³ ì´ ì—…ì²´',0),(454664,12630,'he','-××• ×œ×”×©×ª×ž×© ×‘×§×•×“ ×”×ž×•×¦×¨ ×¡×¤×§ ×œ× ×§×•×“ ×¤×¨×™×˜ ×ž×œ××™. ×¢×“×›×•×Ÿ ×–×” ×‘<p><b>×ž×œ××™-> ×¤×¨×™×˜×™×-> ×¤×¨×™×˜ ×¢×¨×™×›×ª</b><p>×‘×—×¨ \"×¤×¨×™×˜ ×¡×¤×§ ×”×•×¡×£/×¢×¨×•×š\".<p>×©×™× ×•×™ ×§×•×“ ×ž×•×¦×¨ ×¡×¤×§, ×©×ž×•×¨ ×•×–×” ×¢×›×',0),(454665,12630,'el','ÎŸÎ  Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ ÎµÎ¯Î´Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´ÎµÎ½ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚. Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÎµ<p><b>Î‘Ï€Î¿Î³ÏÎ±Ï†Î®-> Î±Î½Ï„Î¹ÎºÎµÎ¯Î¼ÎµÎ½Î±-> ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…</b><p>Î•Ï€',0),(454666,12630,'zh','è®¢å•ä½¿ç”¨ä¾›åº”å•†ç”Ÿäº§ä»£ç è€Œéžåº“å­˜é¡¹ç›®ä»£ç ã€‚æ›´æ–°åœ¨ï¼šåº“å­˜>é¡¹ç›®->ç¼–è¾‘é¡¹ç›®\r\né€‰æ‹©â€œé¡¹ç›®ä¾›åº”å•†æ–°å¢ž/ç¼–è¾‘â€ã€‚æ›´æ”¹ä¾›åº”å•†ä»£ç å¹¶ä¿å­˜ï¼Œå³ä¼šåœ¨æ‰“å°æ—¶åæ˜ å‡ºã€‚\r\n',0),(454667,12630,'sv','PO anvÃ¤nda leverantÃ¶rens produktkoden inte inventering Artikelkod. Uppdatera den i<p><b>Inventering-> poster-> redigera objekt</b><p>VÃ¤lj \"Artikelns leverantÃ¶r LÃ¤gg till/redigera\".<p>Ã„ndra leverantÃ¶rens produktkod, spara och detta Ã¥terspeglas nu n',0),(454668,12630,'it','PO \' utilizza il codice prodotto del fornitore non inventario codice articolo. Aggiornata in<p><b>Inventario-> elementi-> Modifica elemento</b><p>Selezionare \"Articolo fornitore Aggiungi/modifica\".<p>Cambiare il codice prodotto del fornitore, Salva e ques',0),(454669,12630,'tl','',0),(454670,12630,'th','à¸‚à¸­à¸‡ PO à¹ƒà¸Šà¹‰à¸£à¸«à¸±à¸ªà¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆà¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡ à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹ƒà¸™<p><b>à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡->->à¸ª',0),(454671,12630,'hi','à¤ªà¥‹ à¤•à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤•à¥‹à¤¡ à¤¨à¤¹à¥€à¤‚ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚à¥¤ à¤¯à¤¹ à¤®à¥‡à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚<p><b>à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ ',0),(454672,12630,'ms','PO di gunakan kod produk Penjual tidak inventori Item kod. Kemaskini Terakhir dalam<p><b>Inventori-> item-> Edit Item</b><p>Pilih \"Penjual Item Tambah/Edit\".<p>Tukar kod produk penjual, simpan dan ini kini dapat dilihat apabila percetakan.',0),(454673,12630,'ar','Ø¨Ùˆ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø±Ù…Ø² Ø§Ù„Ù…Ù†ØªØ¬ Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ù„Ø§ \"ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù ÙÙŠ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†\". ØªØ­Ø¯ÙŠØ«Ù‡ ÙÙŠ<p><b>Ø§Ù„Ù…Ø®Ø²ÙˆÙ†-> Ø§Ù„Ø¹Ù†Ø§ØµØ±-> Ø¹Ù†ØµØ± ØªØ­Ø±ÙŠØ±</b><p>Ø­Ø¯Ø¯ \"Ø¨Ø§Ø¦Ø¹ Ø§Ù„Ø¹Ù†ØµØ± Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ±\".<p>ØªØºÙŠÙŠØ± \"Ø±Ù…Ø',0),(454674,12630,'fr','PO utilise le Code produit du vendeur pas l\'inventaire Item Code. Mettre Ã  jour en<p><b>Inventaire-> Ã©lÃ©ments-> Ã©lÃ©ment de modification</b><p>SÃ©lectionnez Â« Article fournisseur ajouter/modifier Â».<p>Changer le Code produit du vendeur, Save et cela',0),(454675,12630,'jp','PO ã®ãƒ™ãƒ³ãƒ€ãƒ¼è£½å“ã‚³ãƒ¼ãƒ‰ãªã„ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªé …ç›®ã‚³ãƒ¼ãƒ‰ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚ãã‚Œã‚’æ›´æ–°ã—ã¾ã™ã€‚<p><b>ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªé …ç›®ç·¨é›†é …ç›®->-></b><p>ã€Œã‚¢ã‚¤ãƒ†ãƒ  ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¿½åŠ /ç·¨é›†ã€ã‚’é¸æŠžã—ã¾ã™ã€‚<p>å¤‰æ›´ãƒ™ãƒ',0),(454676,12630,'pt','PO use o cÃ³digo de produto do fornecedor nÃ£o Inventory Item cÃ³digo. AtualizÃ¡-lo em<p><b>InventÃ¡rio-> itens-> Editar Item</b><p>Selecione \"Fornecedor do Item Adicionar/Editar\".<p>Alterar o cÃ³digo de produto do fornecedor, salvar e isso serÃ¡ refletid',0),(454677,12630,'ru','Ð¡ÐŸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ ÐºÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð½Ðµ ÐºÐ¾Ð´ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð°. ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐµÐ³Ð¾ Ð²<p><b>Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ-> Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ñ‹-> Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚</b><p>Ð',0),(454678,12630,'es','OC\'s usan el cÃ³digo de Producto de Proveedor no el CÃ³digo de Item de Inventario. Actualizalo en:<p><b>Inventario->Items->Editar Item</b><p>Selecciona \"Proveedor del Item /Agregar/Editar\".<p> Cambia el CÃ³digo de Producto de Proveedor. Guardar y Este acc',0),(454679,12630,'de','PA\'s verwenden den Vendor Produktcode nicht Inventar-Feld-Code. Aktualisieren sie in<p><b>Inventar-> Elemente-> Element bearbeiten</b><p>WÃ¤hlen Sie \"Artikellieferant hinzufÃ¼gen/bearbeiten\".<p>Ã„nderung der Vendor Produktcode, speichern, und das wird jet',0),(454680,12630,'en','POs use the Vendor Product Code not Inventory Item Code. Update it in<p><b>Inventory->Items->Edit Item</b><p>Select \"Item Vendor Add/Edit\".<p> Change the Vendor Product Code, Save and this will now be reflected when printing.',0),(454681,12631,'is','',0),(454682,12631,'dr','',0),(454683,12631,'pr','',0),(454684,12631,'tr','',0),(454685,12631,'pl','',0),(454686,12631,'bg','',0),(454687,12631,'ur','',0),(454688,12631,'sr','',0),(454689,12631,'vi','',0),(454690,12631,'af','',0),(454691,12631,'ro','',0),(454692,12631,'et','',0),(454693,12631,'si','',0),(454694,12631,'ba','',0),(454695,12631,'nl','',0),(454696,12631,'fi','',0),(454697,12631,'no','',0),(454698,12631,'da','',0),(454699,12631,'ko','',0),(454700,12631,'he','',0),(454701,12631,'el','',0),(454702,12631,'zh','',0),(454703,12631,'sv','',0),(454704,12631,'it','',0),(454705,12631,'tl','',0),(454706,12631,'th','',0),(454707,12631,'hi','',0),(454708,12631,'ms','',0),(454709,12631,'ar','',0),(454710,12631,'fr','',0),(454711,12631,'jp','',0),(454712,12631,'pt','',0),(454713,12631,'ru','',0),(454714,12631,'es','',0),(454715,12631,'de','',0),(454716,12631,'en','',0),(454717,12632,'is','',0),(454718,12632,'dr','.Ùˆ Ú©ÙˆØ¯ Ø¬Ù†Ø³ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¬Ù†Ø³ Ù†ÛŒØ³Øª.',0),(454719,12632,'pr','Ø¯Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÛŒØ¯ Ú©Ø¯ Ú©Ø§Ù„Ø§ Ú©Ø¯ Ú©Ø§Ù„Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø³Øª.Ùˆ Ú©Ø¯ Ú©Ø§Ù„Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ Ù†ÛŒØ³Øª.',0),(454720,12632,'tr','POs Ã¼zerinde satÄ±cÄ± madde kodu, kendi stok madde kodu madde kodudur.',0),(454721,12632,'pl','Na POs kod towaru jest kod towaru dostawcy, nie kod pozycji zapasÃ³w.',0),(454722,12632,'bg','ÐÐ° POs ÐºÐ¾Ð´Ð° Ðµ ÐºÐ¾Ð´ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚, Ð½Ðµ ÑÐ¸ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ ÐºÐ¾Ð´.',0),(454723,12632,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ù¾Ø± Ø´Û’ Ú©ÙˆÚˆØŒ ÙˆÛŒÙ†ÚˆØ± Ø´Û’ Ú©ÙˆÚˆ ÛÛ’ØŒ Ù†Û Ø¢Ù¾ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ø¶Ø§Ø¨Ø·Û ÛÛ’ Û”',0),(454724,12632,'sr','ÐÐ° ÐŸÐžÑ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ñ˜Ðµ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°, Ð½Ðµ Ñ‚Ð²Ð¾Ñ˜ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° ÐºÐ¾Ð´.',0),(454725,12632,'vi','TrÃªn Ä‘Æ¡n Ä‘áº·t hÃ ng, mÃ£ hÃ ng bÃ¡n lÃ  mÃ£ hÃ ng ngÆ°á»i bÃ¡n, khÃ´ng pháº£i mÃ£ hÃ ng tá»“n kho',0),(454726,12632,'af','Op POs die Item kode is die handelaar Item kode, nie jou voorraad item kode.',0),(454727,12632,'ro','Pe POs cod articol este codul de articol furnizor, nu vÄƒ cod articol inventar.',0),(454728,12632,'et','POs kauba kood on hankija kaubakoodi, mitte oma lao kaubakoodi.',0),(454729,12632,'si','Na POs Å ifra artikla je Å ifra artikla dobavitelja, ne zaloge artiklov kodo.',0),(454730,12632,'ba','Pada POs Item kode adalah kode Item Vendor, tidak kode barang inventaris Anda.',0),(454731,12632,'nl','Op POs is de artikelcode de leverancierscode Item, niet uw voorraad object code.',0),(454732,12632,'fi','Nimikkeen koodi on POs toimittajan tuotekoodi, ei varastoa nimikkeen koodi.',0),(454733,12632,'no','PÃ¥ POs er varekoden leverandÃ¸ren varekoden, ikke din lager Varekode.',0),(454734,12632,'da','PÃ¥ POs er varekoden kreditor Varekode, ikke din beholdning varekode.',0),(454735,12632,'ko','POsì— í•­ëª© ì½”ë“œ ê³µê¸‰ ì—…ì²´ í•­ëª© ì½”ë“œ, ìž¬ê³  í’ˆëª© ì½”ë“œ í•˜ì§€ìž…ë‹ˆë‹¤.',0),(454736,12632,'he','×‘- POs ×§×•×“ ×”×¤×¨×™×˜ ×”×•× ×¡×¤×§ ×¤×¨×™×˜ ×§×•×“, ×œ× ××ª ×§×•×“ ×¤×¨×™×˜ ×ž×œ××™.',0),(454737,12632,'el','Î Î©Î£ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï„Î¿Ï… ÎµÎ¯Î´Î¿Ï…Ï‚ ÎµÎ¯Î½Î±Î¹ Î¿ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®, Î´ÎµÎ½ ÏƒÎ±Ï‚ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚.',0),(454738,12632,'zh','åœ¨è®¢å•ä¸Šï¼Œé¡¹ç›®ä»£ç æ˜¯ä¾›åº”å•†é¡¹ç›®ä»£ç ï¼Œä¸æ˜¯æ‚¨çš„åº“å­˜é¡¹ç›®ä»£ç ã€‚',0),(454739,12632,'sv','PÃ¥ POs Ã¤r Artikelkod leverantÃ¶r Artikelkod, inte din inventering Artikelkod.',0),(454740,12632,'it','Il codice Ã¨ un codice articolo fornitore, non il codice articolo di magazzino su POs.',0),(454741,12632,'tl','',0),(454742,12632,'th','POs à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²à¸¡à¸µà¸£à¸«à¸±à¸ª à¸œà¸¹à¹‰à¸‚à¸²à¸¢ à¸ªà¸´à¸™à¸„à¹‰à¸² à¹„à¸¡à¹ˆà¸‚à¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²',0),(454743,12632,'hi','à¤ªà¤° POs à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡, à¤¨à¤¹à¥€à¤‚ à¤…à¤ªà¤¨à¥‡ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤¹à¥ˆà¥¤',0),(454744,12632,'ms','POs kod Item adalah kod Item penjual, tidak inventori item kod anda.',0),(454745,12632,'ar','ÙÙŠ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ù‡Ùˆ ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù Ø§Ù„Ù…ÙˆØ±Ø¯ØŒ Ù„Ø§ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¹Ù†ØµØ± Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(454746,12632,'fr','Sur POs le point de Code est le Code d\'article du vendeur, pas votre code d\'article de l\'inventaire.',0),(454747,12632,'jp','POs ã®å•†å“ã‚³ãƒ¼ãƒ‰ã¯ä»•å…¥å…ˆé …ç›®ã‚³ãƒ¼ãƒ‰ãªã„ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªé …ç›®ã‚³ãƒ¼ãƒ‰ã§ã™ã€‚',0),(454748,12632,'pt','Na POs o Item de cÃ³digo Ã© o cÃ³digo de Item do vendedor, nÃ£o seu cÃ³digo de item de inventÃ¡rio.',0),(454749,12632,'ru','ÐÐ° POs Ñ‚Ð¾Ð²Ð°Ñ€Ð° ÐºÐ¾Ð´ â€” ÐšÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°, Ð½Ðµ Ð²Ð°Ñˆ ÐºÐ¾Ð´ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð°.',0),(454750,12632,'es','Tratando con OCs el codigo de item en el cÃ³digo de item de Proveedor, no su cÃ³digo de item de inventario.',0),(454751,12632,'de','Am POs ist der Item-Code den Herstellercode Element, nicht Ihr Inventar-Feld-Code.',0),(454752,12632,'en','On POs the Item Code is the Vendor Item Code, not your inventory item code.',0),(454753,12633,'is','',0),(454754,12633,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø¹Ø¯ Ø§Ø² Ø§ÛŒÙ†Ú©Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯  Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯  ',0),(454755,12633,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø¹Ø¯ Ø§Ø² Ø§ÛŒÙ†Ú©Ù‡ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯  Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§Ø¶Ø§ÙÙ‡ Ø´ÙˆØ¯  ',0),(454756,12633,'tr','Ek satÄ±cÄ± Ã¼cretleri, malÄ± aldÄ±ktan sonra ve AP\'ye geÃ§irmeden Ã¶nce eklenebilir.',0),(454757,12633,'pl','Dodatkowe opÅ‚aty dostawcy mogÄ… byÄ‡ dodawane po odebraniu przesyÅ‚ki, a przed przekazaniem do AP.',0),(454758,12633,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ñ‚Ð°ÐºÑÐ¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° ÑÐµ Ð´Ð¾Ð±Ð°Ð²ÑÑ‚, ÑÐ»ÐµÐ´ ÐºÐ°Ñ‚Ð¾ Ð¿Ñ€Ð°Ñ‚ÐºÐ°Ñ‚Ð° Ðµ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð° Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¿Ñ€ÐµÐ¼Ð¸Ð½Ðµ ÐºÑŠÐ¼ Ð°Ð¿.',0),(454759,12633,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©Û’ Ø§Ø¶Ø§ÙÛŒ Ú†Ø§Ø±Ø¬Ø² Ú©Û’ Ø¨Ø¹Ø¯ Ú©ÛŒ Ú©Ú¾ÛŒÙ¾ ÙˆØµÙˆÙ„ Ú©ÛŒ ÛÛ’ Ø§ÙˆØ± Ø§Ø³Û’ AP Ú©Û’ Ú¯Ø²Ø±Ù†Û’ Ø³Û’ Ù¾ÛÙ„Û’ Ø§Ø¶Ø§ÙÛ Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ ÛÛ’ Û”',0),(454760,12633,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¼Ð¾Ð¶Ðµ ÑÐµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð½Ð°ÐºÐ¾Ð½ ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ñ˜Ðµ Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾, Ð¸ Ð¿Ñ€Ðµ ÑƒÐ¿ÑƒÑ›Ð¸Ð²Ð°ÑšÐ° ÐÐŸ.',0),(454761,12633,'vi','táº¥t cáº£ chi phÃ­ bá»• sung cá»§a nhÃ  cung cáº¥p cÃ³ thá»ƒ Ä‘Æ°á»£c thÃªm vÃ o sau khi hÃ ng vá» vÃ  trÆ°á»›c khi chuyá»ƒn qua bá»™ pháº­n thanh toÃ¡n',0),(454762,12633,'af','Addisionele koste van die verkoper kan bygevoeg word nadat die verskeping is ontvang en voor verby dit AP.',0),(454763,12633,'ro','Furnizor de taxe suplimentare pot fi adÄƒugate dupÄƒ expediere este primit ÅŸi Ã®nainte de a trece-l la AP.',0),(454764,12633,'et','Hankija lisakulude lisamist, kui saadetis on saanud ja enne lÃ¤biva AP.',0),(454765,12633,'si','Dodatne stroÅ¡ke dobavitelja lahko dodajo po prejemu poÅ¡iljke in preden gre AP.',0),(454766,12633,'ba','Biaya Vendor tambahan dapat ditambahkan setelah pengiriman diterima dan sebelum lewat ke AP.',0),(454767,12633,'nl','Extra kosten van de leverancier kunnen worden toegevoegd nadat de verzending is ontvangen en voordat dit wordt doorgegeven aan AP.',0),(454768,12633,'fi','Toimittajan lisÃ¤maksu voidaan lisÃ¤tÃ¤ lÃ¤hetyksen vastaanottamisen jÃ¤lkeen ja ennen sen AP.',0),(454769,12633,'no','Tilleggskostnader for leverandÃ¸r kan legges nÃ¥r leveransen er mottatt og fÃ¸r den sendes til AP.',0),(454770,12633,'da','Kreditor tillÃ¦gsgebyrer kan tilfÃ¸jes efter forsendelsen er modtaget, og fÃ¸r det til AP.',0),(454771,12633,'ko','ì¶”ê°€ ê³µê¸‰ ì—…ì²´ ìš”ê¸ˆ ë°°ì†¡ ë°›ì€ í›„ ê³  APì— ì „ë‹¬ í•˜ê¸° ì „ì— ì¶”ê°€í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(454772,12633,'he','× ×™×ª×Ÿ ×œ×”×•×¡×™×£ ×¡×¤×§ ×—×™×•×‘×™× × ×•×¡×¤×™× ×œ××—×¨ ×§×‘×œ×ª ×”×ž×©×œ×•×—, ×œ×¤× ×™ ×”×¢×‘×¨×ª×Ÿ ××œ AP.',0),(454773,12633,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼ÎµÏ„Î¬ Ï„Î·Î½ Ï€Î±ÏÎ±Î»Î±Î²Î® Ï„Î·Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚, ÎºÎ±Î¹ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î· Î´Î¹Î¿Ï‡Î­Ï„ÎµÏ…ÏƒÎ· Î±Ï€.',0),(454774,12633,'zh','å¯ä»¥åœ¨è´§è¿æ”¶åˆ°åŽï¼Œä»˜æ¬¾åˆ°åº”ä»˜è´¦æ¬¾å‰å¢žåŠ é™„åŠ çš„ä¾›åº”å•†è´¹ç”¨ã€‚',0),(454775,12633,'sv','Ytterligare leverantÃ¶r avgifter kan lÃ¤ggas efter fÃ¶rsÃ¤ndelsen mottagits och innan det till AP.',0),(454776,12633,'it','Le spese aggiuntive del fornitore possono essere aggiunto dopo aver ricevuta la spedizione e prima di passarlo all\'AP.',0),(454777,12633,'tl','',0),(454778,12633,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸žà¸´à¹ˆà¸¡à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸«à¸¥à¸±à¸‡ à¸ˆà¸²à¸à¹„à¸”à¹‰à¸£à¸±à¸šà¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ à¹à¸¥à¸°à¸à¹ˆà¸­à¸™à¸—à¸µà¹ˆ à¸ˆà¸°à¸œà¹ˆ',0),(454779,12633,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤­à¤¾à¤° à¤¬à¤¾à¤¦ à¤²à¤¦à¤¾à¤¨ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥ˆ à¤”à¤° à¤¯à¤¹ à¤à¤ªà¥€ à¤•à¥‹ à¤—à¥à¤œà¤° à¤œà¤¾à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤œà¥‹à¤¡à¤¼à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(454780,12633,'ms','Tambahan caj penjual boleh ditambah selepas penghantaran diterima dan sebelum lulus ke AP.',0),(454781,12633,'ar','ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ© Ù…Ù† Ø§Ù„Ù…ÙˆØ±Ø¯ Ø¨Ø¹Ø¯ Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ø´Ø­Ù†Ø© ÙˆÙ‚Ø¨Ù„ ØªÙ…Ø±ÙŠØ± ÙØ¥Ù†Ù‡ Ø¥Ù„Ù‰ ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³.',0),(454782,12633,'fr','Des frais supplÃ©mentaires de fournisseur peuvent Ãªtre ajoutÃ©s aprÃ¨s rÃ©ception de la livraison et avant de passer Ã  l\'AP.',0),(454783,12633,'jp','å‡ºè·ãŒå—ä¿¡ã•ã‚ŒãŸå¾Œã€AP ã«æ¸¡ã™å‰ã«ã€ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¿½åŠ æ–™é‡‘ã‚’è¿½åŠ ã§ãã¾ã™ã€‚',0),(454784,12633,'pt','Encargos adicionais do fornecedor podem ser adicionados apÃ³s o carregamento Ã© recebido e antes de passÃ¡-lo para AP.',0),(454785,12633,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð° Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð¿Ð¾ÑÐ»Ðµ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð³Ñ€ÑƒÐ·Ð° Ð¸ Ð¿ÐµÑ€ÐµÐ´ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡ÐµÐ¹ Ð² Ð°Ð¿.',0),(454786,12633,'es','Cargos adicionales de Proveedor se puede agregar despuÃ©s del envÃ­o se recibe y antes que pasa al CP.',0),(454787,12633,'de','ZusÃ¤tzliche Anbieter GebÃ¼hren kÃ¶nnen hinzugefÃ¼gt werden, nachdem die Sendung empfangen wird und vor der Ãœbergabe an AP.',0),(454788,12633,'en','Additional Vendor charges can be added after the shipment is received and before passing it to AP.',0),(454789,12634,'is','',0),(454790,12634,'dr','.Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÛŒØ¯Ú©Ù‡ Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§Ø¬Ù†Ø§Ø³ÛŒÛŒ Ú©Ù‡ Ø´Ù…Ø§ Ø¯Ø±ÛŒØ§ÙØª Ù†Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯. Ù‡Ù…Ú†Ù†ÛŒÙ† Ù…Ø·Ù…Ø¦Ù†',0),(454791,12634,'pr','Ø§Ú¯Ø± Ø´Ù…Ø§ ÙÙ‚Ø· Ù‚Ø³Ù…ØªÛŒ Ø§Ø² ÛŒÚ© Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ø±Ø§ Ø¯Ø±ÛŒØ§ÙØª Ú©Ø±Ø¯ÛŒØ¯.Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÛŒØ¯Ú©Ù‡ Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ù„Ø§Ù‡Ø§ÛŒÛŒ Ú©Ù‡ Ø´Ù…Ø§ Ø¯Ø±ÛŒØ§ÙØª Ù†Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯ ØµÙØ± Ø¨Ø§Ø´Ø¯. Ù‡Ù…Ú†Ù†ÛŒÙ† Ù…Ø·Ù…Ø¦Ù†',0),(454792,12634,'tr','PO yapmak emin bir parÃ§asÄ± sadece alÄ±rsanÄ±z miktarÄ± alÄ±nan maddelerin deÄŸil aldÄ±nÄ±z mÄ± 0\'dÄ±r.<p>AyrÄ±ca, kÄ±smi PO almadan Ã¶nce alÄ±nan posta kutusunun iÅŸaretli olmadÄ±ÄŸÄ±ndan emin olun.',0),(454793,12634,'pl','JeÅ›li otrzymasz tylko czÄ™Å›Ä‡ PO upewnij siÄ™, Å¼e iloÅ›Ä‡ przyjÄ™ta jest 0 dla elementÃ³w, ktÃ³re nie otrzymasz.<p>RÃ³wnieÅ¼ upewnij siÄ™, Å¼e otrzymane PO pole nie jest zaznaczone przed otrzymaniem PO czÄ™Å›ciowej.',0),(454794,12634,'bg','ÐÐºÐ¾ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Ñ‡Ð°ÑÑ‚ Ð¾Ñ‚ PO Ð£Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ðµ 0 Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð½Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚Ðµ.<p>Ð¡ÑŠÑ‰Ð¾ Ñ‚Ð°ÐºÐ° ÑÐµ ÑƒÐ²ÐµÑ€ÐµÑ‚Ðµ, Ñ‡Ðµ PO Ð¿Ð¾Ð»ÑƒÑ‡Ð¸ ÐºÑƒÑ‚Ð¸Ð¹ÐºÐ° Ðµ Ð±ÐµÐ· Ð¾Ñ‚Ð¼ÐµÑ‚',0),(454795,12634,'ur','Ù…Ù‚Ø¯Ø§Ø± Ù…Ù„ÛŒ 0 Ø¢Ù¾ Ú©Ùˆ Ù…ÙˆØµÙˆÙ„ Ù†ÛÛŒÚº ÛÙˆØ§ Ø§Ù† Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ù„Ø¦Û’ Ø§Ú¯Ø± Ø¢Ù¾ ØµØ±Ù Ø§ÛŒÚ© Ù¾Ùˆ ÛŒÙ‚ÛŒÙ† Ú©Ø§ Ø­ØµÛ Ø­Ø§ØµÙ„ ÛÛ’ Û”<p>Ø§Ø³ Ú©Û’ Ø¹Ù„Ø§ÙˆÛØŒ Ù¾Ùˆ Ù…Ù„ÛŒ Ø¨Ø§Ú©Ø³ Ø¬Ø²ÙˆÛŒ Ù¾Ùˆ Ø­Ø§ØµÙ„ Ú©Ø±Ù†Û’ Ø³Û’ Ù¾ÛÙ„Û’ ØºÛŒØ± Ù¾',0),(454796,12634,'sr','ÐÐºÐ¾ Ð¿Ñ€Ð¸Ð¼Ð°Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Ð´ÐµÐ¾ ÐŸÐž ÑƒÐ²ÐµÑ€Ð¸Ñ‚Ðµ ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ˜Ðµ 0 Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ñ‚Ðµ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾.<p>Ð¢Ð°ÐºÐ¾Ñ’Ðµ , ÑƒÐ²ÐµÑ€Ð¸Ñ‚Ðµ ÑÐµ Ð´Ð° Ð¾ÐºÐ²Ð¸Ñ€ ÐŸÐž Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾ ÐÐµÐ¿Ñ€Ð¾Ð²Ñ˜ÐµÑ€ÐµÐ½Ð¸ Ð¿Ñ€Ðµ Ð¿Ñ€Ð',0),(454797,12634,'vi','náº¿u báº¡n chá»‰ nháº­n Ä‘Æ°á»£c má»™t pháº§n cá»§a Ä‘Æ¡n Ä‘áº·t hÃ ng, hÃ£y Ä‘áº£m báº£o ráº±ng sá»‘ lÆ°á»£ng hÃ ng hÃ³a nháº­n Ä‘Æ°á»£c lÃ  0, vÃ  cÅ©ng Ä‘áº£m báº£o ráº±ng Ä‘Æ¡n Ä‘áº·t hÃ ng váº«n chÆ°a Ä‘Æ°á»£c kiá»ƒm tra trÆ°á»›c khi nháº­n má»™t ph',0),(454798,12634,'af','As jy ontvang slegs deel van \'n PO maak seker dat die hoeveelheid wat ontvang is 0 vir die items wat jy nie ontvang het nie.<p>Maak ook seker die PO ontvang boks voor ontvangs van die gedeeltelike PO ongemerk is.',0),(454799,12634,'ro','DacÄƒ primiÅ£i doar o parte din o PO asiguraÅ£i-vÄƒ cÄƒ cantitatea primitÄƒ este 0 pentru elementele de nu ai primit.<p>De asemenea, asiguraÅ£i-vÄƒ cÄƒ PO a primit caseta este debifatÄƒ Ã®nainte de a primi PO parÅ£ialÄƒ.',0),(454800,12634,'et','Kui kuvatakse ainult osa PO veenduge tarnitud kogus on 0 ning te ei saa Ã¼ksusi.<p>Samuti veenduge, et PO sai kast on mÃ¤rkimata enne saanud osalise PO.',0),(454801,12634,'si','ÄŒe prejmete samo del PO poskrbite, da prevzeta koliÄina je 0 za artikle, ki niste prejeli.<p>Prav tako se prepriÄajte, PO prejetih Å¡katla je neoviran pred prejemom delno PO.',0),(454802,12634,'ba','Jika Anda hanya menerima bagian dari PO pastikan kuantitas menerima adalah 0 untuk item yang Anda tidak menerima.<p>Juga, pastikan kotak PO diterima dicentang sebelum menerima PO parsial.',0),(454803,12634,'nl','Als het foutbericht alleen deel uit van een PO-zorg ervoor dat is de hoeveelheid ontvangen 0 voor de items die u niet hebt ontvangen.<p>Ook, zorg ervoor dat het vak PO ontvangen is niet-gecontroleerde vÃ³Ã³r de ontvangst van de gedeeltelijke PO.',0),(454804,12634,'fi','Jos vain osa PO Varmista vastaanotettu mÃ¤Ã¤rÃ¤ on 0 nimikkeille ei tule nÃ¤yttÃ¶Ã¶n.<p>Varmista myÃ¶s, ettÃ¤ PO sai-ruutu on valittuna ennen kuin saa osittainen PO.',0),(454805,12634,'no','Hvis du bare fÃ¥r en del av en PO sikre er antall mottatt 0 for elementene du ikke mottok.<p>Kontroller ogsÃ¥ PO mottatt boksen ikke er avmerket fÃ¸r delvis PO.',0),(454806,12634,'da','Hvis du kun modtage en del af et PO SÃ¸rg for er den mÃ¦ngde modtaget 0 for de varer, du ikke har modtaget.<p>OgsÃ¥, SÃ¸rg for boksen PO modtaget er markeret fÃ¸r du modtager den delvise PO.',0),(454807,12634,'ko','ë¶€ë¶„ì˜ í¬ í™•ì¸ ë°›ì„ ìˆ˜ëŸ‰ ìˆ˜ì‹ ì€ ë°›ì§€ ëª»í•œ í•­ëª©ì— ëŒ€ í•œ 0ìž…ë‹ˆë‹¤.<p>ë˜í•œ, í¬ ë°›ì€ ìƒìž ë¶€ë¶„ í¬ ë°›ê¸° ì „ì— ì„ íƒ í•˜ì§€ ì•Šìœ¼ë©´ í™•ì¸ í•˜ì‹­ì‹œì˜¤.',0),(454808,12634,'he','×× ××ª×” ×ž×§×‘×œ ×¨×§ ×—×œ×§ ×¤×• ×œ×•×•×“× ×›×ž×•×ª ×©×”×ª×§×‘×œ×• \' ×”×•× 0 ×¢×‘×•×¨ ×”×¤×¨×™×˜×™× ×©×œ× ×§×™×‘×œ×ª.<p>×›×ž×• ×›×Ÿ, ×•×“× ×©×”×ª×™×‘×” ×¤×• ×”×ª×§×‘×œ ××™× ×” ×ž×¡×•×ž× ×ª ×œ×¤× ×™ ×§×‘×œ×ª ×”×¨×›×© ×—×œ×§×™×ª.',0),(454809,12634,'el','Î•Î¬Î½ Î»Î¬Î²ÎµÏ„Îµ Î¼ÏŒÎ½Î¿ Î¼Î­ÏÎ¿Ï‚ Ï„Î·Ï‚ Î¼Î¹Î± PO Î²ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ Î· Ï€Î±ÏÎ±Î»Î·Ï†Î¸ÎµÎ¯ÏƒÎ± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎµÎ¯Î½Î±Î¹ 0 Î³Î¹Î± Ï„Î± ÎµÎ¯Î´Î· Ï€Î¿Ï… Î´ÎµÎ½ Î»Î¬Î²Î±Ï„Îµ.<p>Î•Ï€Î¯ÏƒÎ·Ï‚, Î²ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ ÎµÎ¯Î½Î±Î¹ ÎµÏ€',0),(454810,12634,'zh','å¦‚æžœæ‚¨åªæ”¶åˆ°è®¢å•çš„éƒ¨åˆ†è´§ç‰©ï¼Œè¯·ç¡®è®¤â€œæ”¶åˆ°çš„æ•°é‡â€ä¸­å¯¹äºŽæ‚¨æœªæ”¶åˆ°çš„è´§ç‰©æ•°ä¸º0ã€‚åŒæ—¶ï¼Œè¯·ç¡®è®¤åœ¨æ”¶åˆ°éƒ¨åˆ†è®¢å•è´§ç‰©å‰â€œè®¢å•æ”¶åˆ°â€é€‰æ¡†å·²è¢«å‹¾é™¤ã€‚',0),(454811,12634,'sv','Om du bara fÃ¥r del av en PO kontrollera Ã¤r Inlevererat 0 fÃ¶r de objekt som du inte har fÃ¥tt.<p>Kontrollera ocksÃ¥ att PO fick kryssrutan Ã¤r avmarkerad innan de fÃ¥r partiell PO.',0),(454812,12634,'it','Se ricevete solo parte di assicurarsi un PO la quantitÃ  ricevuta Ã¨ 0 per le voci che non ricevete.<p>Inoltre, assicurarsi che la casella di PO ricevuto Ã¨ selezionata prima di ricevere il PO parziale.',0),(454813,12634,'tl','',0),(454814,12634,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¹„à¸”à¹‰à¸£à¸±à¸šà¹€à¸‰à¸žà¸²à¸°à¸ªà¹ˆà¸§à¸™à¸‚à¸­à¸‡ PO à¹ƒà¸«à¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸§à¹ˆà¸² à¸à¸²à¸£à¹„à¸”à¹‰à¸£à¸±à¸šà¸›à¸£à¸´à¸¡à¸²à¸“à¹€à¸›à¹‡à¸™ 0 à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸„à¸¸à¸“à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸£à¸±à¸š<p>à',0),(454815,12634,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤•à¥‡à¤µà¤² à¤à¤• PO à¤¯à¤•à¥€à¤¨ à¤¹à¥ˆ à¤•à¤¿ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¤¾ à¤¹à¤¿à¤¸à¥à¤¸à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤†à¤‡à¤Ÿà¤® à¤†à¤ª à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤¥à¤¾ à¤•à¥‡ à',0),(454816,12634,'ms','Jika anda hanya menerima sebahagian daripada yang Pastikan PO kuantiti yang diterima adalah 0 atas perkara-perkara yang anda tidak menerima.<p>Juga, pastikan kotak PO diterima tidak disemak sebelum menerima PO separa.',0),(454817,12634,'ar','Ø¥Ø°Ø§ ÙƒÙ†Øª ØªØªÙ„Ù‚Ù‰ Ø³ÙˆÙ‰ Ø¬Ø²Ø¡ Ù…Ù† Ø¨Ùˆ ØªØ£ÙƒØ¯ \"ØªÙ„Ù‚ÙŠ Ø§Ù„ÙƒÙ…ÙŠØ©\" Ù‡Ùˆ 0 Ù„Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„ØªÙŠ Ù„Ù… ØªØ­ØµÙ„.<p>Ø£ÙŠØ¶Ø§ØŒ ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù† Ø§Ù„Ù…Ø±Ø¨Ø¹ \"ØªÙ„Ù‚ÙŠ Ø¨Ø±ÙŠØ¯\" ØºÙŠØ± Ù…Ø­Ø¯Ø¯ Ù‚Ø¨Ù„ ØªÙ„Ù‚ÙŠ Ø¨Ùˆ Ø¬Ø²Ø¦ÙŠØ©.',0),(454818,12634,'fr','Si vous recevez seulement partie d\'une marque de PO que la quantitÃ© reÃ§ue est 0 pour les Ã©lÃ©ments que vous n\'avez pas reÃ§u.<p>Aussi, assurez-vous que la boÃ®te de PO reÃ§u n\'est pas cochÃ©e avant de recevoir le PO partielle.',0),(454819,12634,'jp','PO ã®ç¢ºèªã®ä¸€éƒ¨ã®ã¿ãŒè¡¨ç¤ºã•ã‚Œã‚‹å ´åˆå—ä¿¡é‡ã¯å—ã‘å–ã£ã¦ã„ãªã„é …ç›® 0 ã§ã™ã€‚<p>ã¾ãŸã€PO å—ä¿¡] ãƒã‚§ãƒƒã‚¯ ãƒœãƒƒã‚¯ã‚¹ãŒéƒ¨åˆ†çš„ãª PO ã‚’å—ä¿¡ã™ã‚‹å‰ã«ã„ã‚‹ã“ã¨ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(454820,12634,'pt','Se vocÃª receber apenas parte de um Verifique PO se a quantidade recebida Ã© 0 para os itens que vocÃª nÃ£o recebeu.<p>AlÃ©m disso, certifique-se de que caixa PO recebido estÃ¡ desmarcada antes de receber o PO parcial.',0),(454821,12634,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ð¾Ð»ÑƒÑ‡Ð°ÐµÑ‚Ðµ Ñ‡Ð°ÑÑ‚ÑŒ PO ÑƒÐ±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ… Ñ€Ð°Ð²ÐµÐ½ 0 Ð´Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð², ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð²Ñ‹ Ð½Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»Ð¸.<p>ÐšÑ€Ð¾Ð¼Ðµ Ñ‚Ð¾Ð³Ð¾ ÑƒÐ±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ',0),(454822,12634,'es','Si solo recibe una parte de un OC, asegura que la Cantidad Recibida es 0 para los items que no recibe. <p> TambiÃ©n asegura que la caja del OC Recibiddo no estÃ¡ tachada antes que recibir el OC parcial.',0),(454823,12634,'de','Erhalten Sie nur Teil einer PO achten ist die Menge empfangen 0 fÃ¼r die Elemente, die Sie nicht erhalten haben.<p>Stellen Sie auÃŸerdem sicher, dass das PO empfangen KontrollkÃ¤stchen deaktiviert ist, bevor Sie erhalten teilweisen PO.',0),(454824,12634,'en','If you only receive part of a PO make sure the Quantity Received is 0 for the items you did not receive. <p> Also, make sure the PO Received box is unchecked before receiving the partial PO.',0),(454825,12635,'is','',0),(454826,12635,'dr','',0),(454827,12635,'pr','',0),(454828,12635,'tr','',0),(454829,12635,'pl','',0),(454830,12635,'bg','',0),(454831,12635,'ur','',0),(454832,12635,'sr','',0),(454833,12635,'vi','',0),(454834,12635,'af','',0),(454835,12635,'ro','',0),(454836,12635,'et','',0),(454837,12635,'si','',0),(454838,12635,'ba','',0),(454839,12635,'nl','',0),(454840,12635,'fi','',0),(454841,12635,'no','',0),(454842,12635,'da','',0),(454843,12635,'ko','',0),(454844,12635,'he','',0),(454845,12635,'el','',0),(454846,12635,'zh','',0),(454847,12635,'sv','',0),(454848,12635,'it','',0),(454849,12635,'tl','',0),(454850,12635,'th','',0),(454851,12635,'hi','',0),(454852,12635,'ms','',0),(454853,12635,'ar','',0),(454854,12635,'fr','',0),(454855,12635,'jp','',0),(454856,12635,'pt','',0),(454857,12635,'ru','',0),(454858,12635,'es','',0),(454859,12635,'de','',0),(454860,12635,'en','',0),(454861,12636,'is','',0),(454862,12636,'dr','',0),(454863,12636,'pr','',0),(454864,12636,'tr','',0),(454865,12636,'pl','',0),(454866,12636,'bg','',0),(454867,12636,'ur','',0),(454868,12636,'sr','',0),(454869,12636,'vi','',0),(454870,12636,'af','',0),(454871,12636,'ro','',0),(454872,12636,'et','',0),(454873,12636,'si','',0),(454874,12636,'ba','',0),(454875,12636,'nl','',0),(454876,12636,'fi','',0),(454877,12636,'no','',0),(454878,12636,'da','',0),(454879,12636,'ko','',0),(454880,12636,'he','',0),(454881,12636,'el','',0),(454882,12636,'zh','',0),(454883,12636,'sv','',0),(454884,12636,'it','',0),(454885,12636,'tl','',0),(454886,12636,'th','',0),(454887,12636,'hi','',0),(454888,12636,'ms','',0),(454889,12636,'ar','',0),(454890,12636,'fr','',0),(454891,12636,'jp','',0),(454892,12636,'pt','',0),(454893,12636,'ru','',0),(454894,12636,'es','',0),(454895,12636,'de','',0),(454896,12636,'en','',0),(454897,12637,'is','',0),(454898,12637,'dr',':Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§-Ú†Ú© Ù‡Ø§-Ú†Ú© Ù‡Ø§ÛŒ Ø¯Ø³ØªÛŒ-Ø´Ù…Ø§ Ù†ÛŒØ§Ø²ÛŒ Ù†ÛŒØ³Øª Ú©Ù‡ ÛŒÚ© Ø´Ù…Ø§Ø±Ù‡ Ø¨ÛŒØ¬Ú© Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(454899,12637,'pr','Ø¬Ù‡Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø¯ÙˆÙ† ÙØ§Ú©ØªÙˆØ± Ø§Ø² Ù…Ø³ÛŒØ± Ø²ÛŒØ±:Ù¾Ø±Ø¯Ø§Ø®ØªÙ†ÛŒ Ù‡Ø§-Ú†Ú© Ù‡Ø§-Ú†Ú© Ù‡Ø§ÛŒ Ø¯Ø³ØªÛŒ-Ø´Ù…Ø§ Ù†ÛŒØ§Ø²ÛŒ Ù†ÛŒØ³Øª Ú©Ù‡ ÛŒÚ© Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(454900,12637,'tr','Bir satÄ±cÄ± olmayan bir fatura Ã¶demek iÃ§in gidin:<p><b>BorÃ§ Ã§ekleri manuel kontroller->-></b><p>Bir fatura numarasÄ±nÄ± girmeniz gerekmez.',0),(454901,12637,'pl','Aby zapÅ‚aciÄ‡ dostawcy bez faktury przejdÅº do:<p><b>ZobowiÄ…zania-> kontroli-> rÄ™czne kontrole</b><p>Nie trzeba wpisaÄ‡ numer faktury.',0),(454902,12637,'bg','Ð—Ð° Ð´Ð° Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð±ÐµÐ· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¾Ñ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð°:<p><b>Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ-> Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸-> Ñ‡ÐµÐºÐ¾Ð²Ðµ</b><p>ÐÐµ Ðµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°.',0),(454903,12637,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© ÙˆÛŒÙ†ÚˆØ± Ú©Û’ Ø¨ØºÛŒØ± Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ù¾Ø± Ø¬Ø§Ø¦ÛŒÚº:<p><b>Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³-> Ø¯Ø³ØªÛŒ Ú†ÛŒÚ© Ú†ÛŒÚ©-></b><p>Ø¢Ù¾ Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª Ù†ÛÛŒÚº ÛÛ’ Û”',0),(454904,12637,'sr','Ð”Ð° Ð¿Ð»Ð°Ñ‚Ð¸Ð¼ Ð±ÐµÐ· Ð°Ð½ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¿Ð¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ:<p><b>Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð¸ Ñ€ÑƒÐºÐ¾Ð¼ Ð¿Ð¸ÑÐ°Ð½Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ</b><p>ÐÐµ Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ.',0),(454905,12637,'vi','Äá»ƒ thanh toÃ¡n cho nhÃ  cung cáº¥p khÃ´ng cÃ³ hÃ³a Ä‘Æ¡n thÃ¬ pháº£i : pháº£i tráº£->kiá»ƒm tra->kiá»ƒm tra thá»§ cÃ´ng-> khÃ´ng cáº§n nháº­p sá»‘ hÃ³a Ä‘Æ¡n',0),(454906,12637,'af','Om te betaal \'n handelaar sonder \'n faktuur gaan na:<p><b>Waardedalingstoetse-> kontrole-> handmatige kontrole</b><p>Jy hoef nie \'n faktuur nommer insleutel.',0),(454907,12637,'ro','SÄƒ plÄƒteascÄƒ unui furnizor fÄƒrÄƒ facturÄƒ un du-te la:<p><b>Datorii-> controale-> controale manuale</b><p>Nu aveÅ£i nevoie sÄƒ introduceÅ£i un numÄƒr de facturÄƒ.',0),(454908,12637,'et','Maksma minna an hankijaarve ilma:<p><b>VÃµlad-> kontrollide-> kÃ¤sitsi kontrollimine</b><p>Sa pead sisestada arve number.',0),(454909,12637,'si','PlaÄati dobavitelju brez an raÄun z iti:<p><b>Obveznosti->-> roÄno pregledi pregledi</b><p>Vam ni treba vnesti Å¡tevilko raÄuna.',0),(454910,12637,'ba','Untuk membayar Vendor tanpa tagihan pergi ke:<p><b>Hutang-> cek-> cek Manual</b><p>Anda tidak perlu memasukkan nomor faktur.',0),(454911,12637,'nl','Een leverancier zonder een factuur ga betalen naar:<p><b>Schulden-> controles-> handmatige controles</b><p>U hoeft niet een factuurnummer in te voeren.',0),(454912,12637,'fi','Maksaa toimittajan ilman laskun Siirry:<p><b>Ostovelat-> tarkastusten-> kÃ¤sin tarkistaa</b><p>Et tarvitse laskun numero.',0),(454913,12637,'no','Betale gÃ¥ en uten en leverandÃ¸rfaktura til:<p><b>LeverandÃ¸rgjeld-> sjekker-> manuell sjekker</b><p>Du trenger ikke Ã¥ angi et fakturanummer.',0),(454914,12637,'da','For at betale gÃ¥ uden en en kreditorfaktura til:<p><b>GÃ¦ld-> kontrol-> manuel kontrol</b><p>Du behÃ¸ver ikke at angive et fakturanummer.',0),(454915,12637,'ko','ì§€ë¶ˆ í•˜ëŠ” ì²­êµ¬ì„œ ì—†ì´ ê³µê¸‰ ì—…ì²´ì—ê°€ ë¼:<p><b>ìˆ˜ë™ ê²€ì‚¬-> ê²€ì‚¬-> ë¯¸ì§€ê¸‰ê¸ˆ</b><p>ì†¡ìž¥ ë²ˆí˜¸ë¥¼ ìž…ë ¥í•  í•„ìš”ê°€ ì—†ìŠµë‹ˆë‹¤.',0),(454916,12637,'he','×›×“×™ ×œ×©×œ× ×¢×‘×•×¨ ×”×¡×¤×§ ×œ×œ× ×—×©×‘×•× ×™×ª ××œ:<p><b>×–×›××™×-> ×‘×“×™×§×•×ª-> ×‘×“×™×§×•×ª ×™×“× ×™×•×ª</b><p>××ª×” ×œ× ×¦×¨×™×š ×œ×”×–×™×Ÿ ××ª ×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª.',0),(454917,12637,'el','ÎÎ± Ï€Î»Î·ÏÏŽÏƒÎµÎ¹ Î­Î½Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï‡Ï‰ÏÎ¯Ï‚ Î­Î½Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¼ÎµÏ„Î±Î²ÎµÎ¯Ï„Îµ:<p><b>Î Î»Î·ÏÏ‰Ï„Î­Ï‰Î½-> Î­Î»ÎµÎ³Ï‡Î¿Î¹-> ÎµÎ³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î¿ ÎµÎ»Î­Î³Ï‡Ï‰Î½</b><p>Î”ÎµÎ½ Ï‡ÏÎµÎ¹Î¬Î¶ÎµÏ„Î±Î¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ ',0),(454918,12637,'zh','è¦ç»™æ²¡æœ‰å¼€å…·å‘ç¥¨çš„ä¾›åº”å•†ä»˜è´¹ï¼Œåˆ°ï¼šåº”ä»˜è´¦æ¬¾->æ”¯ç¥¨->æ‰‹åŠ¨æ”¯ç¥¨\r\næ‚¨ä¸éœ€è¦è¾“å…¥ä¸€ä¸ªæ”¯ç¥¨å·ç ã€‚\r\n',0),(454919,12637,'sv','FÃ¶r att betala gÃ¥ utan en en leverantÃ¶rsfaktura till:<p><b>LeverantÃ¶rsskulder-> kontroller-> manuella kontroller</b><p>Du behÃ¶ver inte ange ett fakturanummer.',0),(454920,12637,'it','Per pagare una fattura fornitore senza an andare a:<p><b>Debiti-> controlli-> controlli manuali</b><p>Non Ã¨ necessario immettere un numero di fattura.',0),(454921,12637,'tl','',0),(454922,12637,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¹„à¸¡à¹ˆà¸¡à¸µà¸­à¸±à¸™à¸«à¸™à¸µà¹‰à¹„à¸›:<p><b>à¹€à¸ˆà¹‰à¸²->à¹€à¸Šà¹‡à¸„->à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡</b><p>à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(454923,12637,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾ à¤à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¤° à¤œà¤¾à¤à¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤:<p><b>Payables à¤œà¤¾à¤à¤šà¥‹à¤‚ à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤šà¥‡à¤•->-></b><p>à¤',0),(454924,12637,'ms','Untuk membayar satu penjual tanpa an invois pergi ke:<p><b>Pemiutang-> pemeriksaan-> pemeriksaan secara Manual</b><p>Anda tidak perlu memasukkan nombor invois.',0),(454925,12637,'ar','Ù„Ø¯ÙØ¹ \"Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ø¯ÙˆÙ† ÙØ§ØªÙˆØ±Ø©\" Ø§Ù„Ø°Ù‡Ø§Ø¨ Ø¥Ù„Ù‰:<p><b>Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹-> Ø§Ù„Ø´ÙŠÙƒØ§Øª-> Ø§Ù„ÙØ­Øµ Ø§Ù„ÙŠØ¯ÙˆÙŠ</b><p>Ù„Ø§ ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… ÙØ§ØªÙˆØ±Ø©.',0),(454926,12637,'fr','Pour payer un vendeur sans facture an rendez-vous sur :<p><b>Comptes fournisseurs-> contrÃ´les-> vÃ©rifications manuelles</b><p>Vous n\'avez pas besoin d\'entrer un numÃ©ro de facture.',0),(454927,12637,'jp','æ”¯æ‰•ã‚’ä»•å…¥å…ˆè«‹æ±‚ã›ãšã«è¡Œããªã•ã„ã€‚<p><b>æ‰‹å‹•ãƒã‚§ãƒƒã‚¯-> ãƒã‚§ãƒƒã‚¯-> å‚µå‹™</b><p>è«‹æ±‚æ›¸ç•ªå·ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(454928,12637,'pt','Para pagar uma factura de fornecedor sem an ir para:<p><b>Contas a pagar-> cheques-> verificaÃ§Ãµes manuais</b><p>VocÃª nÃ£o precisa digitar um nÃºmero de factura.',0),(454929,12637,'ru','Ð”Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð±ÐµÐ· Ð¸Ð´Ñ‚Ð¸ Ðº:<p><b>ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ-> Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸-> Ñ€ÑƒÑ‡Ð½Ð¾Ð¹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸</b><p>Ð’Ð°Ð¼ Ð½Ðµ Ð½ÑƒÐ¶Ð½Ð¾ Ð²Ð²Ð¾Ð´Ð¸Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ',0),(454930,12637,'es','Para pagar un Proveedor Sin una Factura va a:<p><b>Pagables -> Cheques -> Cheques Manuales',0),(454931,12637,'de','Bezahlen gehen eine ohne eine Kreditorenrechnung Sie zu:<p><b>Verbindlichkeiten-> PrÃ¼fungen-> manuelle PrÃ¼fungen</b><p>Sie mÃ¼ssen keine Rechnungsnummer eingeben.',0),(454932,12637,'en','To pay a Vendor Without an Invoice go to:<p><b>Payables -> Checks -> Manual Checks</b><p>You do not need to enter an Invoice number.',0),(454933,12638,'is','',0),(454934,12638,'dr','',0),(454935,12638,'pr','',0),(454936,12638,'tr','',0),(454937,12638,'pl','',0),(454938,12638,'bg','',0),(454939,12638,'ur','',0),(454940,12638,'sr','',0),(454941,12638,'vi','',0),(454942,12638,'af','',0),(454943,12638,'ro','',0),(454944,12638,'et','',0),(454945,12638,'si','',0),(454946,12638,'ba','',0),(454947,12638,'nl','',0),(454948,12638,'fi','',0),(454949,12638,'no','',0),(454950,12638,'da','',0),(454951,12638,'ko','',0),(454952,12638,'he','',0),(454953,12638,'el','',0),(454954,12638,'zh','',0),(454955,12638,'sv','',0),(454956,12638,'it','',0),(454957,12638,'tl','',0),(454958,12638,'th','',0),(454959,12638,'hi','',0),(454960,12638,'ms','',0),(454961,12638,'ar','',0),(454962,12638,'fr','',0),(454963,12638,'jp','',0),(454964,12638,'pt','',0),(454965,12638,'ru','',0),(454966,12638,'es','',0),(454967,12638,'de','',0),(454968,12638,'en','',0),(454969,12639,'is','',0),(454970,12639,'dr','',0),(454971,12639,'pr','',0),(454972,12639,'tr','',0),(454973,12639,'pl','',0),(454974,12639,'bg','',0),(454975,12639,'ur','',0),(454976,12639,'sr','',0),(454977,12639,'vi','',0),(454978,12639,'af','',0),(454979,12639,'ro','',0),(454980,12639,'et','',0),(454981,12639,'si','',0),(454982,12639,'ba','',0),(454983,12639,'nl','',0),(454984,12639,'fi','',0),(454985,12639,'no','',0),(454986,12639,'da','',0),(454987,12639,'ko','',0),(454988,12639,'he','',0),(454989,12639,'el','',0),(454990,12639,'zh','',0),(454991,12639,'sv','',0),(454992,12639,'it','',0),(454993,12639,'tl','',0),(454994,12639,'th','',0),(454995,12639,'hi','',0),(454996,12639,'ms','',0),(454997,12639,'ar','',0),(454998,12639,'fr','',0),(454999,12639,'jp','',0),(455000,12639,'pt','',0),(455001,12639,'ru','',0),(455002,12639,'es','',0),(455003,12639,'de','',0),(455004,12639,'en','',0),(455005,12640,'is','',0),(455006,12640,'dr','',0),(455007,12640,'pr','',0),(455008,12640,'tr','',0),(455009,12640,'pl','',0),(455010,12640,'bg','',0),(455011,12640,'ur','',0),(455012,12640,'sr','',0),(455013,12640,'vi','',0),(455014,12640,'af','',0),(455015,12640,'ro','',0),(455016,12640,'et','',0),(455017,12640,'si','',0),(455018,12640,'ba','',0),(455019,12640,'nl','',0),(455020,12640,'fi','',0),(455021,12640,'no','',0),(455022,12640,'da','',0),(455023,12640,'ko','',0),(455024,12640,'he','',0),(455025,12640,'el','',0),(455026,12640,'zh','',0),(455027,12640,'sv','',0),(455028,12640,'it','',0),(455029,12640,'tl','',0),(455030,12640,'th','',0),(455031,12640,'hi','',0),(455032,12640,'ms','',0),(455033,12640,'ar','',0),(455034,12640,'fr','',0),(455035,12640,'jp','',0),(455036,12640,'pt','',0),(455037,12640,'ru','',0),(455038,12640,'es','',0),(455039,12640,'de','',0),(455040,12640,'en','',0),(455041,12641,'is','',0),(455042,12641,'dr','',0),(455043,12641,'pr','',0),(455044,12641,'tr','',0),(455045,12641,'pl','',0),(455046,12641,'bg','',0),(455047,12641,'ur','',0),(455048,12641,'sr','',0),(455049,12641,'vi','',0),(455050,12641,'af','',0),(455051,12641,'ro','',0),(455052,12641,'et','',0),(455053,12641,'si','',0),(455054,12641,'ba','',0),(455055,12641,'nl','',0),(455056,12641,'fi','',0),(455057,12641,'no','',0),(455058,12641,'da','',0),(455059,12641,'ko','',0),(455060,12641,'he','',0),(455061,12641,'el','',0),(455062,12641,'zh','',0),(455063,12641,'sv','',0),(455064,12641,'it','',0),(455065,12641,'tl','',0),(455066,12641,'th','',0),(455067,12641,'hi','',0),(455068,12641,'ms','',0),(455069,12641,'ar','',0),(455070,12641,'fr','',0),(455071,12641,'jp','',0),(455072,12641,'pt','',0),(455073,12641,'ru','',0),(455074,12641,'es','',0),(455075,12641,'de','',0),(455076,12641,'en','',0),(455077,12642,'is','',0),(455078,12642,'dr','Ø³ÙØ§Ø±Ø´ÛŒ Ú©Ø±Ø¯Ù† Ø§ÛŒÙ†',0),(455079,12642,'pr','Ø³ÙØ§Ø±Ø´ÛŒ Ú©Ø±Ø¯Ù† Ø§ÛŒÙ†',0),(455080,12642,'tr','Ã–zelleÅŸtirmek',0),(455081,12642,'pl','Dostosuj go',0),(455082,12642,'bg','ÐŸÐµÑ€ÑÐ¾Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð³Ð¾',0),(455083,12642,'ur','Ø§Ø³ Ú©ÛŒ ØªØ®ØµÛŒØµ Ú©Ø±ÛŒÚº',0),(455084,12642,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ð¸Ñ‚Ð¸ Ñ‚Ð°ÐºÐ¾',0),(455085,12642,'vi','tÃ¹y nÃ³',0),(455086,12642,'af','Pasmaak dit',0),(455087,12642,'ro','ParticularizaÅ£i-l',0),(455088,12642,'et','Kohandada seda',0),(455089,12642,'si','Prilagodite',0),(455090,12642,'ba','Menyesuaikan',0),(455091,12642,'nl','Aanpassen',0),(455092,12642,'fi','Muokata sitÃ¤',0),(455093,12642,'no','Tilpasse den',0),(455094,12642,'da','Tilpasse det',0),(455095,12642,'ko','ì‚¬ìš©ìž ì§€ì •',0),(455096,12642,'he','×œ×”×ª××™× ××•×ª×” ××™×©×™×ª',0),(455097,12642,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼ÏŒÏƒÎµÏ„Îµ',0),(455098,12642,'zh','å®šåˆ¶',0),(455099,12642,'sv','Anpassa det',0),(455100,12642,'it','Personalizzarlo',0),(455101,12642,'tl','',0),(455102,12642,'th','à¸à¸²à¸£à¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡',0),(455103,12642,'hi','à¤¯à¤¹ à¤…à¤¨à¥à¤•à¥‚à¤²à¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(455104,12642,'ms','Menyesuaikan ia',0),(455105,12642,'ar','ØªØ®ØµÙŠØµÙ‡',0),(455106,12642,'fr','Personnalisez-le',0),(455107,12642,'jp','ãã‚Œã‚’ã‚«ã‚¹ã‚¿ãƒžã‚¤ã‚ºã—ã¾ã™ã€‚',0),(455108,12642,'pt','PersonalizÃ¡-lo',0),(455109,12642,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ ÐµÐ³Ð¾',0),(455110,12642,'es','Personalizalo',0),(455111,12642,'de','Passen Sie es',0),(455112,12642,'en','Customize It',0),(455113,12643,'is','',0),(455114,12643,'dr','Ù…Ø¨Ù„Øº',0),(455115,12643,'pr','Ù…Ø¨Ù„Øº',0),(455116,12643,'tr','Tutar',0),(455117,12643,'pl','Kwota',0),(455118,12643,'bg','Ð¡ÑƒÐ¼Ð°',0),(455119,12643,'ur','Ù…Ù‚Ø¯Ø§Ø±',0),(455120,12643,'sr','Ð˜Ð·Ð½Ð¾Ñ',0),(455121,12643,'vi','ThÃ nh tiá»n',0),(455122,12643,'af','Bedrag',0),(455123,12643,'ro','Suma',0),(455124,12643,'et','Summa',0),(455125,12643,'si','Znesek',0),(455126,12643,'ba','Jumlah',0),(455127,12643,'nl','Bedrag',0),(455128,12643,'fi','MÃ¤Ã¤rÃ¤',0),(455129,12643,'no','BelÃ¸p',0),(455130,12643,'da','BelÃ¸b',0),(455131,12643,'ko','ê¸ˆì•¡',0),(455132,12643,'he','×›×ž×•×ª',0),(455133,12643,'el','Î Î¿ÏƒÏŒ',0),(455134,12643,'zh','é‡‘é¢',0),(455135,12643,'sv','Belopp',0),(455136,12643,'it','Importo',0),(455137,12643,'tl','',0),(455138,12643,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™',0),(455139,12643,'hi','à¤°à¤¾à¤¶à¤¿',0),(455140,12643,'ms','Jumlah',0),(455141,12643,'ar','Ø§Ù„Ù…Ø¨Ù„Øº',0),(455142,12643,'fr','Montant',0),(455143,12643,'jp','é‡',0),(455144,12643,'pt','Quantidade',0),(455145,12643,'ru','Ð¡ÑƒÐ¼Ð¼Ð°',0),(455146,12643,'es','Monto',0),(455147,12643,'de','Betrag',0),(455148,12643,'en','Amount',0),(455149,12644,'is','',0),(455150,12644,'dr','/Ø§ØµÙ„Ø§Ø­ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(455151,12644,'pr','Ø§ÙØ²ÙˆØ¯Ù†/Ø§ØµÙ„Ø§Ø­ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª ',0),(455152,12644,'tr','Ã–deme bilgilerini Ekle/DeÄŸiÅŸtir',0),(455153,12644,'pl','Dodawanie/modyfikowanie informacji o pÅ‚atnoÅ›ci',0),(455154,12644,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(455155,12644,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§ Ø¶Ø§ÙÛ/ØªØ±Ù…ÛŒÙ… Ú©Ø±ÛŒÚº',0),(455156,12644,'sr','Ð”Ð¾Ð´Ð°Ñ˜ /Ð¸Ð·Ð¼ÐµÐ½Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¿Ð»Ð°Ñ›Ð°ÑšÑƒ',0),(455157,12644,'vi','ThÃªm/chá»‰nh sá»­a thÃ´ng tin thanh toÃ¡nn',0),(455158,12644,'af','Voeg/wysig-betaling inligting',0),(455159,12644,'ro','Adauga/modifica informatii de plata',0),(455160,12644,'et','Lisa/Muuda Makseinfo',0),(455161,12644,'si','Dodaj/spremeni informacije o plaÄilu',0),(455162,12644,'ba','Menambahkan/mengubah informasi pembayaran',0),(455163,12644,'nl','Betalingsgegevens toevoegen/wijzigen',0),(455164,12644,'fi','Maksutietojen lisÃ¤Ã¤minen tai muokkaaminen',0),(455165,12644,'no','Legg til/endre betalingsinformasjon',0),(455166,12644,'da','TilfÃ¸j/Rediger betalingsoplysninger',0),(455167,12644,'ko','ê²°ì œ ì •ë³´ ì¶”ê°€/ìˆ˜ì •',0),(455168,12644,'he','×”×•×¡×¤×”/×©×™× ×•×™ ×©×œ ×¤×¨×˜×™ ×”×ª×©×œ×•×',0),(455169,12644,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(455170,12644,'zh','å¢žåŠ /ä¿®æ”¹ä»˜æ¬¾ä¿¡æ¯',0),(455171,12644,'sv','LÃ¤gg till/Ã„ndra betalningsinformation',0),(455172,12644,'it','Aggiungere/modificare le informazioni di pagamento',0),(455173,12644,'tl','',0),(455174,12644,'th','à¹€à¸žà¸´à¹ˆà¸¡/à¹à¸à¹‰à¹„à¸‚à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(455175,12644,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(455176,12644,'ms','Tambah/ubah suai maklumat pembayaran',0),(455177,12644,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ¹Ø¯ÙŠÙ„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¯ÙØ¹',0),(455178,12644,'fr','Ajouter/modifier les informations de paiement',0),(455179,12644,'jp','ãŠæ”¯æ‰•ã„æƒ…å ±ã®è¿½åŠ /å¤‰æ›´ã—ã¾ã™ã€‚',0),(455180,12644,'pt','Adicionar/modificar as informaÃ§Ãµes de pagamento',0),(455181,12644,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½ÑƒÑŽ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ',0),(455182,12644,'es','Agregar/Modificar InformaciÃ³n de Pagos',0),(455183,12644,'de','HinzufÃ¼gen/Ã„ndern von Zahlungsinformationen',0),(455184,12644,'en','Add/Modify Payment Information',0),(455185,12645,'is','',0),(455186,12645,'dr','/Ø§ØµÙ„Ø§Ø­ Ø§Ø´ØªØ±Ø§Ú© ',0),(455187,12645,'pr','Ø§ÙØ²ÙˆØ¯Ù†/Ø§ØµÙ„Ø§Ø­ Ø§Ø´ØªØ±Ø§Ú© ',0),(455188,12645,'tr','Abonelik Ekle/DeÄŸiÅŸtir',0),(455189,12645,'pl','Dodawanie/modyfikowanie subskrypcja',0),(455190,12645,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(455191,12645,'ur','Ø±Ú©Ù†ÛŒØª Ø§ Ø¶Ø§ÙÛ/ØªØ±Ù…ÛŒÙ… Ú©Ø±ÛŒÚº',0),(455192,12645,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /Ð¸Ð·Ð¼ÐµÐ½Ð° Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(455193,12645,'vi','ThÃªm/chá»‰nh sá»­a thuÃª bao',0),(455194,12645,'af','Voeg/wysig-intekening',0),(455195,12645,'ro','AdÄƒugare/Modificare abonament',0),(455196,12645,'et','Lisa/Muuda tellimust',0),(455197,12645,'si','Dodaj/spremeni naroÄnino',0),(455198,12645,'ba','Tambah/modifikasi berlangganan',0),(455199,12645,'nl','Abonnement toevoegen/wijzigen',0),(455200,12645,'fi','LisÃ¤Ã¤ tai muuta tilaus',0),(455201,12645,'no','Legg til/endre abonnement',0),(455202,12645,'da','TilfÃ¸j/Rediger abonnement',0),(455203,12645,'ko','êµ¬ë… ì¶”ê°€/ìˆ˜ì •',0),(455204,12645,'he','×”×•×¡×¤×”/×©×™× ×•×™ ×©×œ ×ž× ×•×™',0),(455205,12645,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¯Î·ÏƒÎ· ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®',0),(455206,12645,'zh','å¢žåŠ /ä¿®æ”¹è®¤è‚¡',0),(455207,12645,'sv','LÃ¤gg till/Ã¤ndra abonnemang',0),(455208,12645,'it','Aggiungi/modifica abbonamento',0),(455209,12645,'tl','',0),(455210,12645,'th','à¹€à¸žà¸´à¹ˆà¸¡/à¹à¸à¹‰à¹„à¸‚à¸ªà¸¡à¸²à¸Šà¸´à¸',0),(455211,12645,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾',0),(455212,12645,'ms','Tambah/ubah suai langganan',0),(455213,12645,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ¹Ø¯ÙŠÙ„ Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(455214,12645,'fr','Ajouter/modifier l\'abonnement',0),(455215,12645,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã®è¿½åŠ /å¤‰æ›´ã—ã¾ã™ã€‚',0),(455216,12645,'pt','Adicionar/modificar assinatura',0),(455217,12645,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÑƒ',0),(455218,12645,'es','Agregar/Modificar una SuscripciÃ³n',0),(455219,12645,'de','Abonnement hinzufÃ¼gen/Ã¤ndern',0),(455220,12645,'en','Add/Modify Subscription',0),(455221,12646,'is','',0),(455222,12646,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÛŒÚ© Ø§Ø´ØªØ±Ø§Ú© Ø¬Ø¯ÛŒØ¯ ',0),(455223,12646,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÛŒÚ© Ø§Ø´ØªØ±Ø§Ú© Ø¬Ø¯ÛŒØ¯ ',0),(455224,12646,'tr','Yeni Abonelik Ekle',0),(455225,12646,'pl','Dodaj nowÄ… subskrypcjÄ™',0),(455226,12646,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(455227,12646,'ur','Ù†Ø¦Û’ Ø±Ú©Ù†ÛŒØª Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(455228,12646,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ ÑƒÐ¿Ð¸Ñ',0),(455229,12646,'vi','thÃªm má»™t vÄƒn kiá»‡n má»›i',0),(455230,12646,'af','Voeg \'n nuwe inskrywing',0),(455231,12646,'ro','AdÄƒugaÅ£i un abonament nou',0),(455232,12646,'et','Lisa uus tellimus',0),(455233,12646,'si','Dodajanje nove naroÄnine',0),(455234,12646,'ba','Menambahkan langganan baru',0),(455235,12646,'nl','Een nieuw abonnement toevoegen',0),(455236,12646,'fi','LisÃ¤Ã¤ uusi tilaus',0),(455237,12646,'no','Legge til et nytt abonnement',0),(455238,12646,'da','TilfÃ¸je et nyt abonnement',0),(455239,12646,'ko','ìƒˆ êµ¬ë… ì¶”ê°€',0),(455240,12646,'he','×”×•×¡×£ ×ž× ×•×™ ×—×“×©',0),(455241,12646,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹Î± Î½Î­Î± ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®',0),(455242,12646,'zh','å¢žåŠ ä¸€ä¸ªæ–°è®¤è‚¡',0),(455243,12646,'sv','LÃ¤gga till ett nytt abonnemang',0),(455244,12646,'it','Aggiungere una nuova sottoscrizione',0),(455245,12646,'tl','',0),(455246,12646,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ªà¸¡à¸²à¸Šà¸´à¸à¹ƒà¸«à¸¡à¹ˆ',0),(455247,12646,'hi','à¤à¤• à¤¨à¤ˆ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(455248,12646,'ms','Tambah langganan baru',0),(455249,12646,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ø´ØªØ±Ø§Ùƒ Ø¬Ø¯ÙŠØ¯',0),(455250,12646,'fr','Ajouter un nouvel abonnement',0),(455251,12646,'jp','æ–°ã—ã„ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(455252,12646,'pt','Adicionar uma nova assinatura',0),(455253,12646,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ¸',0),(455254,12646,'es','Agregar una Nueva SuscripciÃ³n',0),(455255,12646,'de','FÃ¼gen Sie ein neues Abonnement',0),(455256,12646,'en','Add A New Subscription',0),(455257,12647,'is','',0),(455258,12647,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø´ØªØ±Ø§Ú© Ø¬Ø¯ÛŒØ¯',0),(455259,12647,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ø´ØªØ±Ø§Ú© Ø¬Ø¯ÛŒØ¯',0),(455260,12647,'tr','Yeni Abonelik Ekle',0),(455261,12647,'pl','Dodaj nowÄ… subskrypcjÄ™',0),(455262,12647,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(455263,12647,'ur','Ù†Ø¦Û’ Ø±Ú©Ù†ÛŒØª Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(455264,12647,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ ÑƒÐ¿Ð¸Ñ',0),(455265,12647,'vi','ThÃªm thuÃª bao má»›i',0),(455266,12647,'af','Voeg nuwe intekening',0),(455267,12647,'ro','Adauga abonament nou',0),(455268,12647,'et','Lisa uus tellimus',0),(455269,12647,'si','Dodajanje nove naroÄnine',0),(455270,12647,'ba','Menambahkan langganan baru',0),(455271,12647,'nl','Nieuw abonnement toevoegen',0),(455272,12647,'fi','LisÃ¤Ã¤ uusi tilaus',0),(455273,12647,'no','Legg til nytt abonnement',0),(455274,12647,'da','TilfÃ¸j nyt abonnement',0),(455275,12647,'ko','ìƒˆ êµ¬ë… ì¶”ê°€',0),(455276,12647,'he','×”×•×¡×£ ×ž× ×•×™ ×—×“×©',0),(455277,12647,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®',0),(455278,12647,'zh','å¢žåŠ æ–°è®¤è‚¡',0),(455279,12647,'sv','LÃ¤gg till ny prenumeration',0),(455280,12647,'it','Aggiungi nuova sottoscrizione',0),(455281,12647,'tl','',0),(455282,12647,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ªà¸¡à¸²à¸Šà¸´à¸à¹ƒà¸«à¸¡à¹ˆ',0),(455283,12647,'hi','à¤¨à¤ˆ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(455284,12647,'ms','Tambah langganan baru',0),(455285,12647,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ø´ØªØ±Ø§Ùƒ Ø¬Ø¯ÙŠØ¯',0),(455286,12647,'fr','Ajouter nouvel abonnement',0),(455287,12647,'jp','æ–°ã—ã„ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(455288,12647,'pt','Adicionar nova assinatura',0),(455289,12647,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÑƒ',0),(455290,12647,'es','Agregar una Nueva SuscripciÃ³n',0),(455291,12647,'de','Neues Abonnement hinzufÃ¼gen',0),(455292,12647,'en','Add New Subscription',0),(455293,12648,'is','',0),(455294,12648,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§ÛŒÙ† Ø§Ø´ØªØ±Ø§Ú© Ø±Ø§ Ù„ØºÙˆ Ú©Ù†ÛŒØ¯ØŸ',0),(455295,12648,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§ÛŒÙ† Ø§Ø´ØªØ±Ø§Ú© Ø±Ø§ Ù„ØºÙˆ Ú©Ù†ÛŒØ¯ØŸ',0),(455296,12648,'tr','Bu aboneliÄŸi iptal etmek istediÄŸinizden emin misiniz?',0),(455297,12648,'pl','Czy na pewno chcesz anulowaÄ‡ tÄ™ subskrypcjÄ™?',0),(455298,12648,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚?',0),(455299,12648,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ø³ Ú©ÛŒ Ø±Ú©Ù†ÛŒØª Ù…Ù†Ø³ÙˆØ® Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(455300,12648,'sr','Ð”Ð° Ð»Ð¸ ÑÑ‚Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ð¾Ð²Ñƒ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ñƒ?',0),(455301,12648,'vi','Há»§y thuÃª bao nÃ y ?',0),(455302,12648,'af','Is jy seker jy wil hierdie intekening kanselleer?',0),(455303,12648,'ro','Sigur revocaÈ›i acest abonament?',0),(455304,12648,'et','Kas kindlasti selle tellimuse tÃ¼histada?',0),(455305,12648,'si','Ali ste prepriÄani, da Å¾elite preklicati naroÄnino?',0),(455306,12648,'ba','Apakah Anda yakin mau membatalkan langganan ini?',0),(455307,12648,'nl','Weet u zeker dat u wilt dit abonnement opzeggen?',0),(455308,12648,'fi','Haluatko varmasti peruuttaa tÃ¤mÃ¤n tilauksen?',0),(455309,12648,'no','Er du sikker pÃ¥ at du vil avbryte abonnementet?',0),(455310,12648,'da','Er du sikker pÃ¥ du vil annullere abonnementet?',0),(455311,12648,'ko','ë‹¹ì‹ ì€ì´ êµ¬ë…ì„ ì·¨ì†Œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(455312,12648,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×‘×˜×œ ××ª ×”×ž× ×•×™?',0),(455313,12648,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î±ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î· ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®;',0),(455314,12648,'zh','ä½ ç¡®å®šä½ è¦å–æ¶ˆæ­¤è®¢é‡‘å—ï¼Ÿ',0),(455315,12648,'sv','Ã„r du sÃ¤ker pÃ¥ att du vill avbryta prenumerationen?',0),(455316,12648,'it','Sei sicuro di che voler cancellare questo abbonamento?',0),(455317,12648,'tl','',0),(455318,12648,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸¢à¸à¹€à¸¥à¸´à¸à¸ªà¸¡à¸²à¸Šà¸´à¸à¸™à¸µà¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(455319,12648,'hi','à¤•à¥à¤¯à¤¾ à¤µà¤¾à¤•à¤ˆ à¤†à¤ª à¤‡à¤¸ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤•à¥‹ à¤°à¤¦à¥à¤¦ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(455320,12648,'ms','Adakah anda pasti anda mahu membatalkan langganan ini?',0),(455321,12648,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø¥Ù„ØºØ§Ø¡ Ù‡Ø°Ø§ Ø§Ù„Ø§Ø´ØªØ±Ø§ÙƒØŸ',0),(455322,12648,'fr','ÃŠtes-vous certain de que vouloir annuler cet abonnement ?',0),(455323,12648,'jp','ã“ã®ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã™ã‚‹ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(455324,12648,'pt','Tem certeza que deseja cancelar esta assinatura?',0),(455325,12648,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÑƒ?',0),(455326,12648,'es','Esta seguro que quiere cancelar esta suscripciÃ³n',0),(455327,12648,'de','Bist du sicher, dass Sie dieses Abonnement kÃ¼ndigen?',0),(455328,12648,'en','Are you sure you want to cancel this subscription?',0),(455329,12649,'is','',0),(455330,12649,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯Ø§Ø´ØªØ±Ø§Ú© Ø®ÙˆØ¯ Ø±Ø§ Ø§ØµÙ„Ø§Ø­ Ú©Ù†ÛŒØ¯ØŸ',0),(455331,12649,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯Ø§Ø´ØªØ±Ø§Ú© Ø®ÙˆØ¯ Ø±Ø§ Ø§ØµÙ„Ø§Ø­ Ú©Ù†ÛŒØ¯ØŸ',0),(455332,12649,'tr','AboneliÄŸinizi deÄŸiÅŸtirmek istediÄŸinizden emin misiniz?',0),(455333,12649,'pl','Czy na pewno chcesz zmodyfikowaÄ‡ subskrypcji?',0),(455334,12649,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚Ð° ÑÐ¸?',0),(455335,12649,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ù¾Ù†ÛŒ Ø±Ú©Ù†ÛŒØª Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ… Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(455336,12649,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ñƒ?',0),(455337,12649,'vi','thay Ä‘á»•i Ä‘Äƒng kÃ½ cá»§a báº¡n ?',0),(455338,12649,'af','Is jy seker jy wil jou intekening te wysig?',0),(455339,12649,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ modificaÅ£i abonamentul?',0),(455340,12649,'et','Kas kindlasti muuta oma tellimust?',0),(455341,12649,'si','Ali ste prepriÄani, da Å¾elite spremeniti naroÄnino?',0),(455342,12649,'ba','Apakah Anda yakin Anda ingin memodifikasi langganan Anda?',0),(455343,12649,'nl','Weet u zeker dat u wilt wijzigen uw abonnement?',0),(455344,12649,'fi','Oletko varma, ettÃ¤ haluat muokata tilauksen?',0),(455345,12649,'no','Er du sikker pÃ¥ at du vil endre abonnementet?',0),(455346,12649,'da','Er du sikker pÃ¥ du vil Ã¦ndre dit abonnement?',0),(455347,12649,'ko','ë‹¹ì‹ ì€ ê·€í•˜ì˜ êµ¬ë…ì„ ìˆ˜ì • í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(455348,12649,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×©× ×•×ª ××ª ×”×ž× ×•×™?',0),(455349,12649,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î· ÏƒÏ…Î½Î´ÏÎ¿Î¼Î® ÏƒÎ±Ï‚;',0),(455350,12649,'zh','ä½ ç¡®å®šè¦ä¿®æ”¹ä½ çš„è®¢å•ï¼Ÿ',0),(455351,12649,'sv','Ã„r du sÃ¤ker du vill Ã¤ndra din prenumeration?',0),(455352,12649,'it','Sei sicuro di che voler modificare l\'abbonamento?',0),(455353,12649,'tl','',0),(455354,12649,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸›à¸£à¸±à¸šà¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸ªà¸¡à¸²à¸Šà¸´à¸à¸‚à¸­à¸‡à¸„à¸¸à¸“à¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(455355,12649,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤…à¤ªà¤¨à¥€ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤•à¥‹ à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(455356,12649,'ms','Adakah anda pasti hendak mengubah suai langganan anda?',0),(455357,12649,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ ØªØ¹Ø¯ÙŠÙ„ Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ Ø§Ù„Ø®Ø§Øµ Ø¨ÙƒØŸ',0),(455358,12649,'fr','ÃŠtes-vous certain de que vouloir modifier votre abonnement ?',0),(455359,12649,'jp','ã‚ãªãŸã®ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã‚’å¤‰æ›´ã™ã‚‹ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(455360,12649,'pt','Tem certeza que deseja modificar sua assinatura?',0),(455361,12649,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ð°ÑˆÑƒ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÑƒ?',0),(455362,12649,'es','Esta seguro que quiere modificar su suscripciÃ³n',0),(455363,12649,'de','Sind Sie sicher, dass Sie Ihr Abonnement Ã¤ndern mÃ¶chten?',0),(455364,12649,'en','Are you sure you want to modify your subscription?',0),(455365,12650,'is','',0),(455366,12650,'dr','ÛŒÚ© Ø§Ø´ØªØ±Ø§Ú© Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(455367,12650,'pr','ÛŒÚ© Ø§Ø´ØªØ±Ø§Ú© Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(455368,12650,'tr','Bir abonelik zaten var.',0),(455369,12650,'pl','Subskrypcja juÅ¼ istnieje',0),(455370,12650,'bg','ÐÐ±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(455371,12650,'ur','Ø§ÛŒÚ© Ø±Ú©Ù†ÛŒØª Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(455372,12650,'sr','ÐŸÑ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(455373,12650,'vi','Ä‘Äƒng kÃ½ Ä‘Ã£ Tá»“n táº¡i',0),(455374,12650,'af','\'N inskrywing reeds bestaan',0),(455375,12650,'ro','ExistÄƒ deja un abonament',0),(455376,12650,'et','Tellimus juba olemas',0),(455377,12650,'si','NaroÄnino Å¾e obstaja',0),(455378,12650,'ba','Berlangganan sudah ada',0),(455379,12650,'nl','Een abonnement al bestaat',0),(455380,12650,'fi','Tilaus, joka on jo olemassa',0),(455381,12650,'no','Et abonnement eksisterer allerede',0),(455382,12650,'da','Et abonnement allerede findes',0),(455383,12650,'ko','êµ¬ë… í•„í„°ê°€ ì´ë¯¸ ì¡´ìž¬',0),(455384,12650,'he','×ž× ×•×™ ×›×‘×¨ ×§×™×™×',0),(455385,12650,'el','ÎœÎ¹Î± ÏƒÏ…Î½Î´ÏÎ¿Î¼Î® Ï€Î¿Ï… Î®Î´Î· Ï…Ï€Î¬ÏÏ‡ÎµÎ¹',0),(455386,12650,'zh','ä¸€ä¸ªè®¢å•å·²ç»å­˜åœ¨',0),(455387,12650,'sv','En prenumeration redan finns',0),(455388,12650,'it','Esiste un abbonamento giÃ ',0),(455389,12650,'tl','',0),(455390,12650,'th','à¸šà¸­à¸à¹à¸¥à¹‰à¸§à¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(455391,12650,'hi','à¤à¤• à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(455392,12650,'ms','Langganan sudah wujud',0),(455393,12650,'ar','Ø§Ø´ØªØ±Ø§Ùƒ Ø§Ù„ÙØ¹Ù„ Ù…ÙˆØ¬ÙˆØ¯',0),(455394,12650,'fr','Il existe un abonnement dÃ©jÃ ',0),(455395,12650,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã¯æ—¢ã«å­˜åœ¨ã—ã¾ã™',0),(455396,12650,'pt','Uma assinatura jÃ¡ existe',0),(455397,12650,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐºÐ° ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(455398,12650,'es','Una SuscripciÃ³n Ya Existe',0),(455399,12650,'de','Ein Abonnement bereits vorhanden ist',0),(455400,12650,'en','A Subscription Already Exists',0),(455401,12651,'is','',0),(455402,12651,'dr','Ø´Ø±ÙˆØ¹',0),(455403,12651,'pr','Ø´Ø±ÙˆØ¹',0),(455404,12651,'tr','BaÅŸlar',0),(455405,12651,'pl','Rozpoczyna siÄ™',0),(455406,12651,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð²Ð°',0),(455407,12651,'ur','Ø³Û’ Ø´Ø±ÙˆØ¹ ÛÙˆØªØ§ ÛÛ’',0),(455408,12651,'sr','ÐŸÐ¾Ñ‡Ð¸ÑšÐµ',0),(455409,12651,'vi','Báº¯t Ä‘áº§u',0),(455410,12651,'af','Begin',0),(455411,12651,'ro','ÃŽncepe',0),(455412,12651,'et','Algab',0),(455413,12651,'si','Se zaÄne',0),(455414,12651,'ba','Dimulai',0),(455415,12651,'nl','Begint',0),(455416,12651,'fi','Alkaa',0),(455417,12651,'no','Begynner',0),(455418,12651,'da','Begynder',0),(455419,12651,'ko','ì‹œìž‘',0),(455420,12651,'he','×ž×ª×—×™×œ×”',0),(455421,12651,'el','Î‘ÏÏ‡Î¯Î¶ÎµÎ¹',0),(455422,12651,'zh','å¼€å§‹',0),(455423,12651,'sv','BÃ¶rjar',0),(455424,12651,'it','Inizia',0),(455425,12651,'tl','',0),(455426,12651,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(455427,12651,'hi','à¤¶à¥à¤°à¥‚ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ',0),(455428,12651,'ms','Bermula',0),(455429,12651,'ar','ÙˆÙŠØ¨Ø¯Ø£',0),(455430,12651,'fr','Commence',0),(455431,12651,'jp','é–‹å§‹',0),(455432,12651,'pt','ComeÃ§a',0),(455433,12651,'ru','ÐÐ°Ñ‡Ð¸Ð½Ð°ÐµÑ‚ÑÑ',0),(455434,12651,'es','Comienza',0),(455435,12651,'de','Beginnt',0),(455436,12651,'en','Begins',0),(455437,12652,'is','',0),(455438,12652,'dr','ØªØºÛŒÛŒØ± Ø§Ø´ØªØ±Ø§Ú©',0),(455439,12652,'pr','ØªØºÛŒÛŒØ± Ø§Ø´ØªØ±Ø§Ú©',0),(455440,12652,'tr','Abonelik deÄŸiÅŸtirme',0),(455441,12652,'pl','Zmiana subskrypcji',0),(455442,12652,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(455443,12652,'ur','Ø±Ú©Ù†ÛŒØª ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(455444,12652,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(455445,12652,'vi','Thay Ä‘á»•i thuÃªbao',0),(455446,12652,'af','Intekengeld verander',0),(455447,12652,'ro','Schimbare abonament',0),(455448,12652,'et','Muuda tellimust',0),(455449,12652,'si','Sprememba vpisa',0),(455450,12652,'ba','Mengubah berlangganan',0),(455451,12652,'nl','Abonnement wijzigen',0),(455452,12652,'fi','Muuta tilausta',0),(455453,12652,'no','Endre abonnement',0),(455454,12652,'da','Ã†ndring af abonnement',0),(455455,12652,'ko','êµ¬ë… ë³€ê²½',0),(455456,12652,'he','×œ×©× ×•×ª ××ª ×”×ž× ×•×™',0),(455457,12652,'el','Î‘Î»Î»Î±Î³Î® ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(455458,12652,'zh','æ›´æ”¹è®¢é‡‘',0),(455459,12652,'sv','Ã„ndra abonnemang',0),(455460,12652,'it','Cambiare abbonamento',0),(455461,12652,'tl','',0),(455462,12652,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸à¸²à¸£à¸šà¸­à¸à¸£à¸±à¸šà¹€à¸›à¹‡à¸™à¸ªà¸¡à¸²à¸Šà¸´à¸',0),(455463,12652,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(455464,12652,'ms','Perubahan yuran',0),(455465,12652,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(455466,12652,'fr','Changer d\'abonnement',0),(455467,12652,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(455468,12652,'pt','Alterar assinatura',0),(455469,12652,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÑƒ',0),(455470,12652,'es','Cambia la SuscripciÃ³n',0),(455471,12652,'de','Abonnement Ã¤ndern',0),(455472,12652,'en','Change Subscription',0),(455473,12653,'is','',0),(455474,12653,'dr','Ø§Ø´ØªØ±Ø§Ú© Ø®ÙˆØ¯ Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ù‡ÛŒØ¯',0),(455475,12653,'pr','Ø§Ø´ØªØ±Ø§Ú© Ø®ÙˆØ¯ Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ù‡ÛŒØ¯',0),(455476,12653,'tr','Abonelik deÄŸiÅŸtirme',0),(455477,12653,'pl','Zmiana subskrypcji',0),(455478,12653,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(455479,12653,'ur','Ø§Ù¾Ù†ÛŒ Ø±Ú©Ù†ÛŒØª ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(455480,12653,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ñƒ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ñƒ',0),(455481,12653,'vi','Thay Ä‘á»•i thuÃª bao cá»§a báº¡n',0),(455482,12653,'af','Verander u Subskripsie',0),(455483,12653,'ro','Schimbarea abonamentului',0),(455484,12653,'et','Muuda oma tellimust',0),(455485,12653,'si','Spremenite vaÅ¡ abomna',0),(455486,12653,'ba','Merubah langganan Anda',0),(455487,12653,'nl','Uw abonnement wijzigen',0),(455488,12653,'fi','Muuttaa tilaustasi',0),(455489,12653,'no','Endre abonnementet',0),(455490,12653,'da','Ã†ndre dit abonnement',0),(455491,12653,'ko','ê°€ìž… ë³€ê²½',0),(455492,12653,'he','×”×’×“×¨×•×ª ×”×ž× ×•×™',0),(455493,12653,'el','Î‘Î»Î»Î¬Î¾Ï„Îµ Ï„Î·Î½ ÏƒÏ…Î½Î´ÏÎ¿Î¼Î® ÏƒÎ±Ï‚',0),(455494,12653,'zh','æ›´æ”¹ä½ çš„è®¢é‡‘',0),(455495,12653,'sv','Ã„ndra din prenumeration',0),(455496,12653,'it','Modificare il tuo abbonamento',0),(455497,12653,'tl','',0),(455498,12653,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸à¸²à¸£à¸ªà¸¡à¸±à¸„à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(455499,12653,'hi','à¤†à¤ªà¤•à¥€ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(455500,12653,'ms','Menukar langganan anda',0),(455501,12653,'ar','ØªØºÙŠÙŠØ± Ø§Ø´ØªØ±Ø§ÙƒÙƒ',0),(455502,12653,'fr','Modifier votre formule d\'abonnement',0),(455503,12653,'jp','ãŠå®¢æ§˜ã®ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(455504,12653,'pt','Alterar sua assinatura',0),(455505,12653,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÑƒ',0),(455506,12653,'es','Cambia a Su SuscripciÃ³n',0),(455507,12653,'de','Abonnement Ã¤ndern',0),(455508,12653,'en','Change Your Subscription',0),(455509,12654,'is','',0),(455510,12654,'dr','Ø§Ø´ØªØ±Ø§Ú© Ø§Ø®ÛŒØ±',0),(455511,12654,'pr','Ø§Ø´ØªØ±Ø§Ú© Ø§Ø®ÛŒØ±',0),(455512,12654,'tr','GeÃ§erli abonelik',0),(455513,12654,'pl','BieÅ¼Ä…ca subskrypcja',0),(455514,12654,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸Ñ Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(455515,12654,'ur','Ø­Ø§Ù„ÛŒÛ Ø±Ú©Ù†ÛŒØª',0),(455516,12654,'sr','ÐŸÑ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ñƒ',0),(455517,12654,'vi','Subscription hiá»‡n nay',0),(455518,12654,'af','Huidige intekening',0),(455519,12654,'ro','Abonament curent',0),(455520,12654,'et','Praeguse tellimuse',0),(455521,12654,'si','Trenutna vpis',0),(455522,12654,'ba','Berlangganan sekarang',0),(455523,12654,'nl','Huidige abonnement',0),(455524,12654,'fi','Nykyisen tilauksen',0),(455525,12654,'no','Gjeldende abonnement',0),(455526,12654,'da','NuvÃ¦rende abonnement',0),(455527,12654,'ko','í˜„ìž¬ êµ¬ë…',0),(455528,12654,'he','×”×ž× ×•×™ ×”× ×•×›×—×™',0),(455529,12654,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎµÎ³Î³ÏÎ±Ï†Î®',0),(455530,12654,'zh','å½“å‰è®¢é‡‘',0),(455531,12654,'sv','Nuvarande prenumeration',0),(455532,12654,'it','Abbonamento attuale',0),(455533,12654,'tl','',0),(455534,12654,'th','à¸à¸²à¸£à¸ªà¸¡à¸±à¸„à¸£à¸ªà¸¡à¸²à¸Šà¸´à¸',0),(455535,12654,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾',0),(455536,12654,'ms','Langganan semasa',0),(455537,12654,'ar','Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(455538,12654,'fr','Abonnement en cours',0),(455539,12654,'jp','ç¾åœ¨ã®ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³',0),(455540,12654,'pt','Assinatura atual',0),(455541,12654,'ru','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ°',0),(455542,12654,'es','SuscripciÃ³n Actual',0),(455543,12654,'de','Aktuelles Abonnement',0),(455544,12654,'en','Current Subscription',0),(455545,12655,'is','',0),(455546,12655,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø®ÙˆØ§Ù†Ø¯Ù† Ø§Ø´ØªØ±Ø§Ú©',0),(455547,12655,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø®ÙˆØ§Ù†Ø¯Ù† Ø§Ø´ØªØ±Ø§Ú©',0),(455548,12655,'tr','Hata okuma abonelik',0),(455549,12655,'pl','BÅ‚Ä…d odczytu subskrypcja',0),(455550,12655,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ñ‡ÐµÑ‚ÐµÐ½Ðµ Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(455551,12655,'ur','Ù†Ù‚Øµ Ù¾Ú‘Ú¾Ù†Û’ Ú©ÛŒ Ø±Ú©Ù†ÛŒØª',0),(455552,12655,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ñ‡Ð¸Ñ‚Ð°ÑšÐ° Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(455553,12655,'vi','Lá»—i khi Ä‘á»c ',0),(455554,12655,'af','Fout lees intekening',0),(455555,12655,'ro','Eroare citire abonament',0),(455556,12655,'et','TÃµrge lugemise tellimus',0),(455557,12655,'si','Napake branja naroÄnino',0),(455558,12655,'ba','Kesalahan membaca berlangganan',0),(455559,12655,'nl','Fout lezing abonnement',0),(455560,12655,'fi','Virhe kÃ¤sittelyssÃ¤ tilaus',0),(455561,12655,'no','Feil under lesing abonnement',0),(455562,12655,'da','Fejl lÃ¦sning abonnement',0),(455563,12655,'ko','ì˜¤ë¥˜ ì½ê¸° êµ¬ë…',0),(455564,12655,'he','×©×’×™××” ×‘×§×¨×™××” ×ž× ×•×™',0),(455565,12655,'el','Î£Ï†Î¬Î»Î¼Î± Î±Î½Î¬Î³Î½Ï‰ÏƒÎ·Ï‚ ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®',0),(455566,12655,'zh','è¯»è®¢å•é”™è¯¯',0),(455567,12655,'sv','Fel lÃ¤sning prenumeration',0),(455568,12655,'it','Errore lettura abbonamento',0),(455569,12655,'tl','',0),(455570,12655,'th','à¸ªà¸¡à¸±à¸„à¸£à¸ªà¸¡à¸²à¸Šà¸´à¸à¸­à¹ˆà¸²à¸™à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(455571,12655,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¤ à¤¨ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾',0),(455572,12655,'ms','Ralat membaca langganan',0),(455573,12655,'ar','Ø®Ø·Ø£ Ø§Ù„Ù‚Ø±Ø§Ø¡Ø© Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(455574,12655,'fr','Erreur lecture abonnement',0),(455575,12655,'jp','ã‚¨ãƒ©ãƒ¼èª­æ›¸ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³',0),(455576,12655,'pt','Assinatura de erro leitura',0),(455577,12655,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ñ‡Ñ‚ÐµÐ½Ð¸Ñ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ¸',0),(455578,12655,'es','Error Leyendo la SuscripciÃ³n',0),(455579,12655,'de','Fehler lesen Abo',0),(455580,12655,'en','Error Reading Subscription',0),(455581,12656,'is','',0),(455582,12656,'dr','ØªØºÛŒÛŒØ± Ù…Ø³ÛŒØ± Ø¨Ù‡ ØµÙØ­Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(455583,12656,'pr','ØªØºÛŒÛŒØ± Ù…Ø³ÛŒØ± Ø¨Ù‡ ØµÙØ­Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(455584,12656,'tr','Ã–deme sayfasÄ±na yÃ¶nlendirme',0),(455585,12656,'pl','Przekierowanie do strony pÅ‚atnoÅ›ci',0),(455586,12656,'bg','ÐŸÑ€ÐµÐ½Ð°ÑÐ¾Ñ‡Ð²Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(455587,12656,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ ØµÙØ­Û’ Ù¾Ø± Ø±ÛŒ ÚˆØ§Ø¦Ø±ÛŒÚ©Ù¹ Ú©Ø¦Û’',0),(455588,12656,'sr','ÐŸÑ€ÐµÑƒÑÐ¼ÐµÑ€Ð°Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(455589,12656,'vi','tá»›i trang thanh toÃ¡n láº§n ná»¯a',0),(455590,12656,'af','Na betaling bladsy herlei',0),(455591,12656,'ro','RedirecÅ£ionarea cÄƒtre pagina de platÄƒ',0),(455592,12656,'et','Suunan maksmise lehele',0),(455593,12656,'si','Preusmerjanje na strani plaÄila',0),(455594,12656,'ba','Mengarahkan ke halaman pembayaran',0),(455595,12656,'nl','Omleiden naar betalingspagina',0),(455596,12656,'fi','Uudelleenohjaaminen Maksusivu',0),(455597,12656,'no','Omadressere til betalingssiden',0),(455598,12656,'da','Omdirigering til betalingssiden',0),(455599,12656,'ko','ê²°ì œ íŽ˜ì´ì§€ë¡œ ë¦¬ë””ë ‰ì…˜',0),(455600,12656,'he','× ×™×ª×•×‘ ×ž×—×“×© ×œ×“×£ ×ª×©×œ×•×',0),(455601,12656,'el','Î‘Î½Î±ÎºÎ±Ï„ÎµÏÎ¸Ï…Î½ÏƒÎ· ÏƒÏ„Î· ÏƒÎµÎ»Î¯Î´Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(455602,12656,'zh','é‡å¯„åˆ°ä»˜æ¬¾é¡µé¢',0),(455603,12656,'sv','Omdirigera till betalningssidan',0),(455604,12656,'it','Reindirizzamento alla pagina di pagamento',0),(455605,12656,'tl','',0),(455606,12656,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸—à¸´à¸¨à¸—à¸²à¸‡à¹„à¸›à¸«à¸™à¹‰à¸²à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(455607,12656,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤ªà¥à¤¨à¤ƒ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¤¿à¤¤ à¤•à¤° à¤•à¥‡',0),(455608,12656,'ms','Mengubah hala ke Laman bayaran',0),(455609,12656,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªÙˆØ¬ÙŠÙ‡ Ø¥Ù„Ù‰ ØµÙØ­Ø© Ø§Ù„Ø¯ÙØ¹',0),(455610,12656,'fr','Redirection vers la Page de paiement',0),(455611,12656,'jp','ãŠæ”¯æ‰•ã„ãƒšãƒ¼ã‚¸ã«ãƒªãƒ€ã‚¤ãƒ¬ã‚¯ãƒˆã—ã¾ã™ã€‚',0),(455612,12656,'pt','Redirecionando para pÃ¡gina de pagamento',0),(455613,12656,'ru','ÐŸÐµÑ€ÐµÐ½Ð°Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(455614,12656,'es','Redirigiendo a la PÃ¡gina de Pagos',0),(455615,12656,'de','Umleitung auf der Seite \"Zahlung\"',0),(455616,12656,'en','Redirecting To Payment Page',0),(455617,12657,'is','',0),(455618,12657,'dr','Ø§Ø´ØªØ±Ø§Ú© Ø±Ø§Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ',0),(455619,12657,'pr','Ø§Ø´ØªØ±Ø§Ú© Ø±Ø§Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ',0),(455620,12657,'tr','Abonelik SeÃ§',0),(455621,12657,'pl','Wybierz abonament',0),(455622,12657,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(455623,12657,'ur','Ø±Ú©Ù†ÛŒØª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(455624,12657,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(455625,12657,'vi','Chá»n thuÃª bao',0),(455626,12657,'af','Kies intekening',0),(455627,12657,'ro','SelectaÅ£i abonament',0),(455628,12657,'et','Valige tellimus',0),(455629,12657,'si','Izbira naroÄnine',0),(455630,12657,'ba','Pilih berlangganan',0),(455631,12657,'nl','Selecteer abonnement',0),(455632,12657,'fi','Valitse tilaus',0),(455633,12657,'no','Velg abonnementet',0),(455634,12657,'da','VÃ¦lg abonnement',0),(455635,12657,'ko','êµ¬ë…ì„ ì„ íƒ',0),(455636,12657,'he','×‘×—×¨ ×ž× ×•×™',0),(455637,12657,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®',0),(455638,12657,'zh','é€‰æ‹©è®¤è´­',0),(455639,12657,'sv','VÃ¤lj abonnemang',0),(455640,12657,'it','Selezionare la sottoscrizione',0),(455641,12657,'tl','',0),(455642,12657,'th','à¹€à¸¥à¸·à¸­à¸à¸à¸²à¸£à¸šà¸­à¸à¸£à¸±à¸šà¹€à¸›à¹‡à¸™à¸ªà¸¡à¸²à¸Šà¸´à¸',0),(455643,12657,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(455644,12657,'ms','Pilih langganan',0),(455645,12657,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(455646,12657,'fr','SÃ©lectionnez l\'abonnement',0),(455647,12657,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(455648,12657,'pt','Selecione a assinatura',0),(455649,12657,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÑƒ',0),(455650,12657,'es','Selecciona SuscripciÃ³n',0),(455651,12657,'de','Abonnement',0),(455652,12657,'en','Select Subscription',0),(455653,12658,'is','',0),(455654,12658,'dr','(ØªØ¹Ù‡Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª )Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(455655,12658,'pr','Ø§Ø´ØªØ±Ø§Ú©(ØªØ¹Ù‡Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª )Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯',0),(455656,12658,'tr','Abonelik baÅŸarÄ±yla eklendi',0),(455657,12658,'pl','PomyÅ›lnie dodane subskrypcja',0),(455658,12658,'bg','ÐÐ±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(455659,12658,'ur','Ø±Ú©Ù†ÛŒØª Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(455660,12658,'sr','ÐŸÑ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(455661,12658,'vi','ÄÄƒng kÃ½ thÃªm thÃ nh cÃ´ng',0),(455662,12658,'af','Inskrywing suksesvol bygevoeg',0),(455663,12658,'ro','Abonament adÄƒugat cu succes',0),(455664,12658,'et','Lisatud tellimus',0),(455665,12658,'si','NaroÄnina uspeÅ¡no dodani',0),(455666,12658,'ba','Berlangganan berhasil ditambahkan',0),(455667,12658,'nl','Abonnement toegevoegd',0),(455668,12658,'fi','Allekirjoitus lisÃ¤ttiin',0),(455669,12658,'no','Abonnement lagt',0),(455670,12658,'da','Abonnement tilfÃ¸jet',0),(455671,12658,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ê°€ìž…',0),(455672,12658,'he','×ž× ×•×™ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(455673,12658,'el','Î£Ï…Î½Î´ÏÎ¿Î¼Î® Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(455674,12658,'zh','ä¼šè´¹æ·»åŠ æˆåŠŸ',0),(455675,12658,'sv','Prenumeration lagts',0),(455676,12658,'it','Abbonamento aggiunto con successo',0),(455677,12658,'tl','',0),(455678,12658,'th','à¸ªà¸¡à¸±à¸„à¸£à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(455679,12658,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(455680,12658,'ms','Langganan yang berjaya menambah',0),(455681,12658,'ar','Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(455682,12658,'fr','Abonnement ajoutÃ© avec succÃ¨s',0),(455683,12658,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸã€‚',0),(455684,12658,'pt','Assinatura adicionada com sucesso',0),(455685,12658,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(455686,12658,'es','SuscripciÃ³n Agregada Exitosamente',0),(455687,12658,'de','Abonnement erfolgreich hinzugefÃ¼gt',0),(455688,12658,'en','Subscription Added Successfully',0),(455689,12659,'is','',0),(455690,12659,'dr','(ØªØ¹Ù‡Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª )Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ù„ØºÙˆ Ø´Ø¯',0),(455691,12659,'pr','Ø§Ø´ØªØ±Ø§Ú©(ØªØ¹Ù‡Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª )Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ù„ØºÙˆ Ø´Ø¯',0),(455692,12659,'tr','Abonelik baÅŸarÄ±yla iptal edildi',0),(455693,12659,'pl','Subskrypcja anulowana pomyÅ›lnie',0),(455694,12659,'bg','ÐÐ±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(455695,12659,'ur','Ø±Ú©Ù†ÛŒØª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(455696,12659,'sr','ÐŸÑ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ð° Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(455697,12659,'vi','ThuÃª bao há»§y bá» thÃ nh cÃ´ng',0),(455698,12659,'af','Subskripsie gekanselleer suksesvol',0),(455699,12659,'ro','Abonament anulat cu succes',0),(455700,12659,'et','Tellimust tÃ¼histatud edukalt',0),(455701,12659,'si','NaroÄnina uspeÅ¡no preklicano',0),(455702,12659,'ba','Berlangganan dibatalkan berhasil',0),(455703,12659,'nl','Abonnement geannuleerd met succes',0),(455704,12659,'fi','Tilaus peruutettiin onnistuneesti',0),(455705,12659,'no','Abonnement avbrutt vellykket',0),(455706,12659,'da','Abonnementet annulleret med succes',0),(455707,12659,'ko','êµ¬ë…ì´ ì„±ê³µì ìœ¼ë¡œ ì·¨ì†Œ',0),(455708,12659,'he','×ž× ×•×™ ×‘×•×˜×œ ×‘×”×¦×œ×—×”',0),(455709,12659,'el','Î•Î³Î³ÏÎ±Ï†Î® Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(455710,12659,'zh','ä¼šè´¹å–æ¶ˆæˆåŠŸ',0),(455711,12659,'sv','Prenumerationen avbryts framgÃ¥ngsrikt',0),(455712,12659,'it','Abbonamento annullato con successo',0),(455713,12659,'tl','',0),(455714,12659,'th','à¸šà¸­à¸à¸¢à¸à¹€à¸¥à¸´à¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(455715,12659,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤°à¤¦à¥à¤¦ à¤•à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤•',0),(455716,12659,'ms','Langganan yang dibatalkan telah berjaya',0),(455717,12659,'ar','Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ Ø¥Ù„ØºØ§Ø¡ Ø¨Ù†Ø¬Ø§Ø­',0),(455718,12659,'fr','Abonnement annulÃ© avec succÃ¨s',0),(455719,12659,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ãŒæ­£å¸¸ã«å–ã‚Šæ¶ˆã•ã‚Œã¾ã—ãŸ',0),(455720,12659,'pt','SubscriÃ§Ã£o cancelada com sucesso',0),(455721,12659,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(455722,12659,'es','SuscripciÃ³n Cancelada Exitosamente',0),(455723,12659,'de','Abonnement erfolgreich gekÃ¼ndigt',0),(455724,12659,'en','Subscription Canceled Successfully',0),(455725,12660,'is','',0),(455726,12660,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯ Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯Ú©Ø§Ø±Øª Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ Ø¨Ø§ ÛŒÚ© Ù†Ù…ÙˆÙ†Ù‡ Ø¬Ø¯ÛŒØ¯Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ† Ú©Ù†ÛŒØ¯ØŸ',0),(455727,12660,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯ Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯Ú©Ø§Ø±Øª Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ Ø¨Ø§ ÛŒÚ© Ù†Ù…ÙˆÙ†Ù‡ Ø¬Ø¯ÛŒØ¯Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ† Ú©Ù†ÛŒØ¯ØŸ',0),(455728,12660,'tr','Mevcut kart yenisi ile deÄŸiÅŸtirmek istiyor musunuz?',0),(455729,12660,'pl','Czy na pewno chcesz zastÄ…piÄ‡ istniejÄ…ce karty na nowÄ…?',0),(455730,12660,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð·Ð°Ð¼ÐµÑÑ‚Ð¸Ñ‚Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð°Ñ‚Ð° ÐºÐ°Ñ€Ñ‚Ð° Ñ Ð½Ð¾Ð² ÐµÐ´Ð¸Ð½?',0),(455731,12660,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ú©Ùˆ Ù…ÙˆØ¬ÙˆØ¯Û Ú©Ø§Ø±Úˆ Ú©Ùˆ Ø§ÛŒÚ© Ù†ÛŒØ§ Ú©Û’ Ø³Ø§ØªÚ¾ Ø¨Ø¯Ù„Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(455732,12660,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð·Ð°Ð¼Ð¸Ñ˜ÐµÐ½Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ ÑÐ° Ð½Ð¾Ð²Ð¾Ð³?',0),(455733,12660,'vi','Thay tháº¿ tháº» hiá»‡n cÃ³ vá»›i má»™t má»›i?',0),(455734,12660,'af','Is jy seker jy wil die bestaande kaart met \'n nuwe een vervang?',0),(455735,12660,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ Ã®nlocuiÅ£i card existent cu unul nou?',0),(455736,12660,'et','Kas soovite asendada olemasoleva kaardi teise?',0),(455737,12660,'si','Ali ste prepriÄani, da Å¾elite zamenjati obstojeÄo kartico z novim?',0),(455738,12660,'ba','Apakah Anda yakin Anda ingin mengganti kartu yang ada dengan yang baru?',0),(455739,12660,'nl','Weet u zeker dat u wilt de bestaande kaart vervangen door een nieuwe?',0),(455740,12660,'fi','Oletko varma, ettÃ¤ haluat korvata olemassa olevan kortin uuteen?',0),(455741,12660,'no','Er du sikker pÃ¥ at du vil erstatte det eksisterende kortet med en ny?',0),(455742,12660,'da','Vil du erstatte den eksisterende kort med en ny?',0),(455743,12660,'ko','ë‹¹ì‹ ì€ ìƒˆ ê²ƒìœ¼ë¡œ ê¸°ì¡´ ì¹´ë“œë¥¼ êµì²´ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(455744,12660,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×”×—×œ×™×£ ××ª ×”×›×¨×˜×™×¡ ×”×§×™×™× ×‘×—×“×©?',0),(455745,12660,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î±Î½Ï„Î¹ÎºÎ±Ï„Î±ÏƒÏ„Î®ÏƒÎµÏ„Îµ Ï„Î·Î½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎ± ÎºÎ¬ÏÏ„Î± Î¼Îµ Î­Î½Î± ÎºÎ±Î¹Î½Î¿ÏÏÎ³Î¹Î¿;',0),(455746,12660,'zh','ä½ ç¡®å®šä½ è¦ä»¥æ–°çš„å¡æ›´æ¢å·²æœ‰çš„å¡å—ï¼Ÿ',0),(455747,12660,'sv','Ã„r du sÃ¤ker du vill ersÃ¤tta den befintliga kortet med en ny?',0),(455748,12660,'it','Sei sicuro di che voler sostituire la scheda esistente con uno nuovo?',0),(455749,12660,'tl','',0),(455750,12660,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹à¸—à¸™à¸à¸²à¸£à¹Œà¸”à¸­à¸¢à¸¹à¹ˆ à¸”à¹‰à¸§à¸¢à¹ƒà¸«à¸¡à¹ˆà¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(455751,12660,'hi','à¤¤à¥à¤® à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤†à¤ª à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤¨à¤¯à¤¾ à¤à¤• à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤œà¤—à¤¹ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(455752,12660,'ms','Adakah anda pasti anda mahu menggantikan Kad yang sedia ada dengan yang baru?',0),(455753,12660,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø§Ø³ØªØ¨Ø¯Ø§Ù„ Ø§Ù„Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø© Ø¨ÙˆØ§Ø­Ø¯ Ø¬Ø¯ÙŠØ¯ØŸ',0),(455754,12660,'fr','ÃŠtes-vous sÃ»r de que vouloir remplacer la carte existante par une nouvelle ?',0),(455755,12660,'jp','æ—¢å­˜ã®ã‚«ãƒ¼ãƒ‰ã‚’æ–°ã—ã„ã‚‚ã®ã¨äº¤æ›ã—ã¦ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(455756,12660,'pt','Tem certeza que deseja substituir o cartÃ£o existente com um novo?',0),(455757,12660,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð·Ð°Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÑƒÑŽ ÐºÐ°Ñ€Ñ‚Ñƒ Ñ Ð½Ð¾Ð²Ñ‹Ð¼?',0),(455758,12660,'es','Esta seguro que quiere reemplazar la tarjeta existente con una nueva',0),(455759,12660,'de','Sind Sie sicher, dass Sie die vorhandene Karte durch eine neue ersetzen mÃ¶chten?',0),(455760,12660,'en','Are you sure you want to replace the existing card with a new one?',0),(455761,12661,'is','',0),(455762,12661,'dr','Ø®Ø·Ø§Ø¯Ø± Ú¯Ø±ÙØªÙ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(455763,12661,'pr','Ø®Ø·Ø§Ø¯Ø± Ú¯Ø±ÙØªÙ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(455764,12661,'tr','Kredi kartÄ± bilgisi alÄ±nÄ±rken hata oluÅŸtu',0),(455765,12661,'pl','Uzyskanie karty kredytowej informacje o bÅ‚Ä™dzie',0),(455766,12661,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(455767,12661,'ur','Ù†Ù‚Øµ Ø­ØµÙˆÙ„ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(455768,12661,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ÑÑ‚Ð°Ñ˜Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ ÑÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°Ð¼Ð°',0),(455769,12661,'vi','Lá»—i khi láº¥y thÃ´ng tin tháº» ghi cÃ³',0),(455770,12661,'af','Fout om kredietkaart inligting',0),(455771,12661,'ro','Eroare obtinerea cardului de Credit Info',0),(455772,12661,'et','Viga saada krediitkaardi Info',0),(455773,12661,'si','Napaka pridobivanje kreditno kartico Info',0),(455774,12661,'ba','Kesalahan mendapatkan kartu kredit Info',0),(455775,12661,'nl','Fout krijgen Credit Card Info',0),(455776,12661,'fi','Virhe haettaessa luottokortin tiedot',0),(455777,12661,'no','Feil Ã¥ fÃ¥ kredittkort Info',0),(455778,12661,'da','Fejl at fÃ¥ kreditkort Info',0),(455779,12661,'ko','ì˜¤ë¥˜ ì§€ ê³  ì‹ ìš© ì¹´ë“œ ì •ë³´',0),(455780,12661,'he','×¤×¨×˜×™ ×›×¨×˜×™×¡ ×”××©×¨××™ ×ž×§×‘×œ ×©×’×™××”',0),(455781,12661,'el','Î£Ï†Î¬Î»Î¼Î± Î½Î± Ï€Î¬ÏÎµÎ¹ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(455782,12661,'zh','é”™è¯¯èŽ·å¾—ä¿¡ç”¨å¡ä¿¡æ¯',0),(455783,12661,'sv','Fel att fÃ¥ kreditkort Info',0),(455784,12661,'it','Errore ricevendo Info carta di credito',0),(455785,12661,'tl','',0),(455786,12661,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸£à¸±à¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(455787,12661,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤²à¥‡à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(455788,12661,'ms','Maklumat kad kredit mendapat ralat',0),(455789,12661,'ar','Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(455790,12661,'fr','Erreur obtenir Info carte de crÃ©dit',0),(455791,12661,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æƒ…å ±ã®å–å¾—ã‚¨ãƒ©ãƒ¼',0),(455792,12661,'pt','Erro recebendo informaÃ§Ã£o de cartÃ£o de crÃ©dito',0),(455793,12661,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ðµ',0),(455794,12661,'es','Error Conseguiendo Info de Tarjeta de CrÃ©dito',0),(455795,12661,'de','Erste Kreditkarte von StÃ¶rungsinfo',0),(455796,12661,'en','Error Getting Credit Card Info',0),(455797,12662,'is','',0),(455798,12662,'dr','Ø®Ø·Ø§ Ø¯Ø± Ú¯Ø±ÙØªÙ† Ù¾Ø§Ø±Ø§Ù…ØªØ±Ù‡Ø§ÛŒ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ ',0),(455799,12662,'pr','Ø®Ø·Ø§ Ø¯Ø± Ú¯Ø±ÙØªÙ† Ù¾Ø§Ø±Ø§Ù…ØªØ±Ù‡Ø§ÛŒ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ ',0),(455800,12662,'tr','Kredi kartÄ± parametreleri alÄ±nÄ±rken hata oluÅŸtu',0),(455801,12662,'pl','BÅ‚Ä…d uzyskanie parametrÃ³w karty kredytowej',0),(455802,12662,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¸',0),(455803,12662,'ur','Ù†Ù‚Øµ Ø­ØµÙˆÙ„ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù¾ÛŒØ±Ø§ Ù…ÛŒÙ¹Ø±',0),(455804,12662,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ÑÑ‚Ð°Ñ˜Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¸',0),(455805,12662,'vi','Lá»—i khi láº¥y thÃ´ng sá»‘ tháº» ghi cÃ³',0),(455806,12662,'af','Fout om kredietkaart Parameters',0),(455807,12662,'ro','Eroare obtinerea cardului de Credit parametrii',0),(455808,12662,'et','Viga saada krediitkaardiga parameetrid',0),(455809,12662,'si','Napaka pridobivanje kreditno kartico parametrov',0),(455810,12662,'ba','Kesalahan mendapatkan kartu kredit parameter',0),(455811,12662,'nl','Fout krijgen creditcard Parameters',0),(455812,12662,'fi','Virhe haettaessa luottokorttiparametrit',0),(455813,12662,'no','Feil Ã¥ fÃ¥ kredittkort parametere',0),(455814,12662,'da','Fejl at fÃ¥ kreditkort parametre',0),(455815,12662,'ko','ì˜¤ë¥˜ ì§€ ê³  ì‹ ìš© ì¹´ë“œ ë§¤ê°œ ë³€ìˆ˜',0),(455816,12662,'he','×¤×¨×ž×˜×¨×™× ×‘×›×¨×˜×™×¡ ××©×¨××™ ×ž×§×‘×œ ×©×’×™××”',0),(455817,12662,'el','Î£Ï†Î¬Î»Î¼Î± Î½Î± Ï€Î¬ÏÎµÎ¹ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Ï€Î±ÏÎ±Î¼Î­Ï„ÏÎ¿Ï…Ï‚',0),(455818,12662,'zh','é”™è¯¯èŽ·å¾—ä¿¡ç”¨å¡å‚æ•°',0),(455819,12662,'sv','Fel att fÃ¥ kreditkort parametrar',0),(455820,12662,'it','Errore ottenere parametri di carta di credito',0),(455821,12662,'tl','',0),(455822,12662,'th','à¸žà¸²à¸£à¸²à¸¡à¸´à¹€à¸•à¸­à¸£à¹Œà¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¸à¸²à¸£à¸£à¸±à¸šà¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(455823,12662,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¹à¥‹ à¤°à¤¹à¥€ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤ªà¥ˆà¤°à¤¾à¤®à¥€à¤Ÿà¤°',0),(455824,12662,'ms','Ralat mendapat kad kredit parameter',0),(455825,12662,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù…Ø¹Ù„Ù…Ø§Øª',0),(455826,12662,'fr','ParamÃ¨tres de carte de crÃ©dit obtenir erreur',0),(455827,12662,'jp','ã‚¨ãƒ©ãƒ¼å–å¾—ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ãƒ‘ãƒ©ãƒ¡ãƒ¼ã‚¿ãƒ¼',0),(455828,12662,'pt','Erro ficando parÃ¢metros de cartÃ£o de crÃ©dito',0),(455829,12662,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹',0),(455830,12662,'es','Error Conseguiendo ParÃ¡metros de Tarjeta de CrÃ©dito',0),(455831,12662,'de','Erste Kreditkarte Fehlerparameter.',0),(455832,12662,'en','Error Getting Credit Card Parameters',0),(455833,12663,'is','',0),(455834,12663,'dr','Ø®Ø·Ø§ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ø³Ø§Ø²ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(455835,12663,'pr','Ø®Ø·Ø§ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ø³Ø§Ø²ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(455836,12663,'tr','Kredi kartÄ± bilgisi kaydedilirken hata oluÅŸtu',0),(455837,12663,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania informacji karty kredytowej',0),(455838,12663,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(455839,12663,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø­ÙÙˆØ¸ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(455840,12663,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ¿Ñ€ÐµÐ¼Ð°ÑšÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ ÑÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°Ð¼Ð°',0),(455841,12663,'vi','Lá»—i khi lÆ°u thÃ´ng tin tháº» ghi cÃ³',0),(455842,12663,'af','Fout met die stoor van kredietkaart inligting',0),(455843,12663,'ro','Eroare la salvarea informaÅ£ii despre carduri de Credit',0),(455844,12663,'et','Krediitkaardi Info salvestamise tÃµrge',0),(455845,12663,'si','Napaka pri shranjevanju kreditno kartico Info',0),(455846,12663,'ba','Kesalahan menyimpan informasi kartu kredit',0),(455847,12663,'nl','Fout bij het opslaan Credit Card Info',0),(455848,12663,'fi','Virhe tallennettaessa luottokortin tiedot',0),(455849,12663,'no','Feil under lagring av kredittkort-informasjon',0),(455850,12663,'da','Fejl under lagring af kreditkort Info',0),(455851,12663,'ko','ì‹ ìš© ì¹´ë“œ ì •ë³´ë¥¼ ì €ìž¥ í•˜ëŠ” ì˜¤ë¥˜',0),(455852,12663,'he','×©×’×™××” ×‘×¢×ª ×©×ž×™×¨×ª ×¤×¨×˜×™ ×›×¨×˜×™×¡ ××©×¨××™',0),(455853,12663,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(455854,12663,'zh','é”™è¯¯ä¿å­˜ä¿¡ç”¨å¡ä¿¡æ¯',0),(455855,12663,'sv','Fel vid sparande av kreditkort Info',0),(455856,12663,'it','Errore durante il salvataggio Info carta di credito',0),(455857,12663,'tl','',0),(455858,12663,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(455859,12663,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(455860,12663,'ms','Ralat menyimpan maklumat kad kredit',0),(455861,12663,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(455862,12663,'fr','Erreur d\'enregistrement d\'informations de carte de crÃ©dit',0),(455863,12663,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰æƒ…å ±ã‚’ä¿å­˜ä¸­ã«ã‚¨ãƒ©ãƒ¼',0),(455864,12663,'pt','Erro ao salvar informaÃ§Ãµes de cartÃ£o de crÃ©dito',0),(455865,12663,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ðµ',0),(455866,12663,'es','Error Guardando Info d Tarjetas de CrÃ©dito',0),(455867,12663,'de','Fehler beim Speichern der Kreditkarten-Informationen',0),(455868,12663,'en','Error Saving Credit Card Info',0),(455869,12664,'is','',0),(455870,12664,'dr','Ø®Ø·Ø§ÛŒ Ø¨Ø§Ø·Ù„ Ø³Ø§Ø²ÛŒ Ø¢Ø²Ù…Ø§ÛŒØ´ÛŒ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(455871,12664,'pr','Ø®Ø·Ø§ÛŒ Ø¨Ø§Ø·Ù„ Ø³Ø§Ø²ÛŒ Ø¢Ø²Ù…Ø§ÛŒØ´ÛŒ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(455872,12664,'tr','Hata test kredi kartÄ± iÅŸlemi geÃ§ersiz kÄ±lma',0),(455873,12664,'pl','BÅ‚Ä…d mikcji badania transakcji karty kredytowej',0),(455874,12664,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÑÑ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° ÑÐ´ÐµÐ»ÐºÐ°',0),(455875,12664,'ur','Ù†Ù‚Øµ Ù¹ÛŒØ³Ù¹ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù„ÛŒÙ† Ø¯ÛŒÙ† ÙˆÙˆØ§Ø¯Ø§Ù†Ú¯',0),(455876,12664,'sr','Ð“Ñ€ÐµÑˆÐºÐ° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸Ð¼ Ð¢ÐµÑÑ‚',0),(455877,12664,'vi','Lá»—i khi thá»­ xÃ³a giao dá»‹ch tháº» ghi cÃ³',0),(455878,12664,'af','Fout Voiding toets kredietkaart transaksie',0),(455879,12664,'ro','Eroare anularea tranzactiei de Card de Credit de testare',0),(455880,12664,'et','TÃµrge Voiding Test krediitkaardi tehing',0),(455881,12664,'si','Napaka razveljavili Test transakcijo s kreditno kartico',0),(455882,12664,'ba','Kesalahan membatalkan transaksi kartu kredit tes',0),(455883,12664,'nl','Fout Test creditcardtransactie ongeldig te verklaren',0),(455884,12664,'fi','HylkÃ¤Ã¤kÃ¶ hÃ¤n testin luottokorttitapahtuman virhe',0),(455885,12664,'no','Feil renons Test kredittkorttransaksjon',0),(455886,12664,'da','Fejl tÃ¸mme Test kreditkorttransaktion',0),(455887,12664,'ko','ì‹ ìš© ì¹´ë“œ ê±°ëž˜ë¥¼ ë¬´íš¨í™” í•˜ëŠ” ì˜¤ë¥˜',0),(455888,12664,'he','×©×’×™××” ×”×¨×§×” ×ž×‘×—×Ÿ ×ª× ×•×¢×” ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(455889,12664,'el','Î£Ï†Î¬Î»Î¼Î± Î½Î± Î±ÎºÏ…ÏÏŽÏƒÎµÎ¹ Ï„Î·Î½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Î´Î¿ÎºÎ¹Î¼Î®',0),(455890,12664,'zh','é”™è¯¯ï¼šæ— æ•ˆæµ‹è¯•ä¿¡ç”¨å¡äº¤æ˜“',0),(455891,12664,'sv','Fel tÃ¶mning Test kreditkortstransaktion',0),(455892,12664,'it','Errore di annullare la transazione di carta di credito di prova',0),(455893,12664,'tl','',0),(455894,12664,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸¢à¸à¹€à¸¥à¸´à¸à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸”à¸ªà¸­à¸š',0),(455895,12664,'hi','à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ Voiding à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(455896,12664,'ms','Ralat yang mengganggu transaksi kredit kad ujian',0),(455897,12664,'ar','Ø®Ø·Ø£ ÙŠÙØ±Øº Ø§Ù„Ø§Ø®ØªØ¨Ø§Ø± Ù…Ø¹Ø§Ù…Ù„Ø© Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(455898,12664,'fr','Erreur en annulant la Transaction par carte de crÃ©dit Test',0),(455899,12664,'jp','æŽ’å°¿ãƒ†ã‚¹ãƒˆ ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ã‚¨ãƒ©ãƒ¼',0),(455900,12664,'pt','Erro miccional teste transaÃ§Ãµes de cartÃ£o de crÃ©dito',0),(455901,12664,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¼Ð¾Ñ‡ÐµÐ¸ÑÐ¿ÑƒÑÐºÐ°Ð½Ð¸Ñ Ñ‚ÐµÑÑ‚Ð¾Ð²Ð¾Ð¹ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(455902,12664,'es','Error Anulando la TransacciÃ³n de la Tarjeta de CrÃ©dito de Prueba',0),(455903,12664,'de','Fehler Test Kreditkarten-Transaktion stornieren',0),(455904,12664,'en','Error Voiding Test Credit Card Transaction',0),(455905,12665,'is','',0),(455906,12665,'dr','Ú©Ø§Ø±Øª Ø¬Ø¯ÛŒØ¯',0),(455907,12665,'pr','Ú©Ø§Ø±Øª Ø¬Ø¯ÛŒØ¯',0),(455908,12665,'tr','Yeni kart',0),(455909,12665,'pl','Nowa karta',0),(455910,12665,'bg','ÐÐ¾Ð²Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(455911,12665,'ur','Ù†Ø¦Û’ Ú©Ø§Ø±Úˆ',0),(455912,12665,'sr','ÐÐ¾Ð²Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(455913,12665,'vi','Tháº» má»›i',0),(455914,12665,'af','Nuwe Kaart',0),(455915,12665,'ro','Nou Card',0),(455916,12665,'et','Uus kaart',0),(455917,12665,'si','Nova kartica',0),(455918,12665,'ba','Kartu baru',0),(455919,12665,'nl','Nieuwe kaart',0),(455920,12665,'fi','Uusi kortti',0),(455921,12665,'no','Nye Card',0),(455922,12665,'da','Nyt kort',0),(455923,12665,'ko','ìƒˆë¡œìš´ ì¹´ë“œ',0),(455924,12665,'he','×›×¨×˜×™×¡ ×—×“×©',0),(455925,12665,'el','ÎÎ­Î± ÎºÎ¬ÏÏ„Î±',0),(455926,12665,'zh','æ–°å¡',0),(455927,12665,'sv','Nytt kort',0),(455928,12665,'it','Nuova scheda',0),(455929,12665,'tl','',0),(455930,12665,'th','à¸šà¸±à¸•à¸£à¹ƒà¸«à¸¡à¹ˆ',0),(455931,12665,'hi','à¤¨à¤ à¤•à¤¾à¤°à¥à¤¡',0),(455932,12665,'ms','Kad baru',0),(455933,12665,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(455934,12665,'fr','Nouvelle carte',0),(455935,12665,'jp','æ–°ã—ã„ã‚«ãƒ¼ãƒ‰',0),(455936,12665,'pt','Novo cartÃ£o',0),(455937,12665,'ru','ÐÐ¾Ð²Ð°Ñ ÐºÐ°Ñ€Ñ‚Ð°',0),(455938,12665,'es','Nueva Tarjeta',0),(455939,12665,'de','Neue Karte',0),(455940,12665,'en','New Card',0),(455941,12666,'is','',0),(455942,12666,'dr','Ø§Ú©Ù†ÙˆÙ† Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù† Ø±ÙˆØ´Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†ÛŒØ³Øª',0),(455943,12666,'pr','Ø§Ú©Ù†ÙˆÙ† Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù† Ø±ÙˆØ´Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†ÛŒØ³Øª',0),(455944,12666,'tr','Åžu anda Ã¶deme yÃ¶ntemleri eklemek mÃ¼mkÃ¼n deÄŸil',0),(455945,12666,'pl','Nie moÅ¼na dodaÄ‡ metody pÅ‚atnoÅ›ci w tej chwili',0),(455946,12666,'bg','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð°Ñ‡Ð¸Ð½Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð¾ Ñ‚Ð¾Ð²Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(455947,12666,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± Ù…ÛŒÚº Ø§Ø³ ÙˆÙ‚Øª Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Û’ Ú©Û’ Ù‚Ø§Ø¨Ù„ Ù†ÛÛŒÚº',0),(455948,12666,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð´Ð¾Ð´Ð°Ñ‚Ðµ ÐÐ°Ñ‡Ð¸Ð½Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñƒ Ð¾Ð²Ð¾Ð¼ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚ÐºÑƒ',0),(455949,12666,'vi','khÃ´ng thá»ƒ thÃªm phÆ°Æ¡ng thá»©c thanh toÃ¡n vÃ o lÃºc nÃ y',0),(455950,12666,'af','Nie in staat om te voeg by hierdie tyd en betaalmetodes',0),(455951,12666,'ro','Nu sunt Ã®n mÄƒsurÄƒ sÄƒ adÄƒugaÅ£i metode de platÄƒ Ã®n acest moment',0),(455952,12666,'et','Pole vÃµimalik lisada makseviisid praegu',0),(455953,12666,'si','Ne more dodati naÄini plaÄila v tem trenutku',0),(455954,12666,'ba','Tidak dapat menambahkan metode pembayaran saat ini',0),(455955,12666,'nl','Niet in staat om toe te voegen betalingsmethoden op dit moment',0),(455956,12666,'fi','Ei voi lisÃ¤tÃ¤ maksutapoja tÃ¤llÃ¤ hetkellÃ¤',0),(455957,12666,'no','Kan ikke legge til betalingsmetoder pÃ¥ dette tidspunktet',0),(455958,12666,'da','Ikke i stand til at tilfÃ¸je betalingsmetoder pÃ¥ dette tidspunkt',0),(455959,12666,'ko','ì´ ì´ë²ˆì— ê²°ì œ ë°©ë²• ì¶”ê°€ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(455960,12666,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×•×¡×™×£ ×©×™×˜×•×ª ×ª×©×œ×•× ×‘×–×ž×Ÿ ×”×–×”',0),(455961,12666,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î¼ÎµÎ¸ÏŒÎ´Î¿Ï…Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î±Ï…Ï„Î® Ï„Î· ÏƒÏ„Î¹Î³Î¼Î®',0),(455962,12666,'zh','æ­¤æ—¶æ— æ³•æ·»åŠ æ”¯ä»˜æ–¹å¼',0),(455963,12666,'sv','Inte kunna lÃ¤gga till betalningsmetoder vid denna tid',0),(455964,12666,'it','Non in grado di aggiungere metodi di pagamento in questo momento',0),(455965,12666,'tl','',0),(455966,12666,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸žà¸´à¹ˆà¸¡à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸™à¸‚à¸“à¸°à¸™à¸µà¹‰',0),(455967,12666,'hi','à¤‡à¤¸ à¤¸à¤®à¤¯ à¤ªà¤° à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤°à¥€à¤•à¥‹à¤‚ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤•à¥à¤·à¤® à¤¨à¤¹à¥€à¤‚',0),(455968,12666,'ms','Tidak dapat menambah kaedah pembayaran pada masa ini',0),(455969,12666,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¥Ø¶Ø§ÙØ© Ø·Ø±Ù‚ Ø§Ù„Ø¯ÙØ¹ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„ÙˆÙ‚Øª',0),(455970,12666,'fr','Pas en mesure d\'ajouter des mÃ©thodes de paiement en ce moment',0),(455971,12666,'jp','ã“ã®æ™‚ç‚¹ã§æ”¯æ‰•ã„æ–¹æ³•ã‚’è¿½åŠ ã™ã‚‹ã«ã¯ã€ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(455972,12666,'pt','NÃ£o Ã© capaz de adicionar mÃ©todos de pagamento neste momento',0),(455973,12666,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¼ÐµÑ‚Ð¾Ð´Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð½Ð° ÑÑ‚Ð¾Ñ‚ Ñ€Ð°Ð·',0),(455974,12666,'es','No se Puede Agregar MÃ©todos de Pago en Este Momento',0),(455975,12666,'de','Nicht in der Lage, zu diesem Zeitpunkt Zahlungsmethoden hinzufÃ¼gen',0),(455976,12666,'en','Not Able To Add Payment Methods At This Time',0),(455977,12667,'is','',0),(455978,12667,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯',0),(455979,12667,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯',0),(455980,12667,'tr','Ã–deme bilgisi baÅŸarÄ±yla kaydedildi',0),(455981,12667,'pl','Informacje o pÅ‚atnoÅ›ci zapisane',0),(455982,12667,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(455983,12667,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(455984,12667,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ Ð˜Ð½Ñ„Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(455985,12667,'vi','Ä‘Ã£ lÆ°u thÃ´ng tin thanh toÃ¡n thÃ nh cÃ´ng',0),(455986,12667,'af','Betalingsinligting suksesvol gestoor',0),(455987,12667,'ro','InformaÅ£ii de platÄƒ salvat cu succes',0),(455988,12667,'et','Makse Info edukalt salvestatud',0),(455989,12667,'si','PlaÄilo Info uspeÅ¡no shranjen',0),(455990,12667,'ba','Pembayaran Info disimpan berhasil',0),(455991,12667,'nl','Betalingsinfo succesvol opgeslagen',0),(455992,12667,'fi','Maksu Info tallennettu',0),(455993,12667,'no','Betalingsinformasjon lagret',0),(455994,12667,'da','Betaling Info gemt med succes',0),(455995,12667,'ko','ê²°ì œ ì •ë³´ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(455996,12667,'he','×¤×¨×˜×™ ×”×ª×©×œ×•× ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(455997,12667,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(455998,12667,'zh','ä»˜æ¬¾ä¿¡æ¯ä¿å­˜æˆåŠŸ',0),(455999,12667,'sv','Betalning information sparats',0),(456000,12667,'it','Info pagamento salvato correttamente',0),(456001,12667,'tl','',0),(456002,12667,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(456003,12667,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(456004,12667,'ms','Maklumat pembayaran yang berjaya disimpan',0),(456005,12667,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ø­ÙØ¸Ù‡ Ø¨Ù†Ø¬Ø§Ø­',0),(456006,12667,'fr','Info paiement enregistrÃ© avec succÃ¨s',0),(456007,12667,'jp','æ”¯æ‰•ã„æƒ…å ±ãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(456008,12667,'pt','InformaÃ§Ã£o de pagamento, salva com sucesso',0),(456009,12667,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð°',0),(456010,12667,'es','Info de Pagos Guardado Exitosamente',0),(456011,12667,'de','Zahlungsinfo erfolgreich gespeichert',0),(456012,12667,'en','Payment Info Saved Successfully',0),(456013,12668,'is','',0),(456014,12668,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø´Ø¯',0),(456015,12668,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø´Ø¯',0),(456016,12668,'tr','Ã–deme bilgileri baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(456017,12668,'pl','PomyÅ›lnie zaktualizowane Informacje o pÅ‚atnoÅ›ci',0),(456018,12668,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(456019,12668,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(456020,12668,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ Ð˜Ð½Ñ„Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(456021,12668,'vi','cáº­p nháº­t thÃ´ng tin thanh toÃ¡n thÃ nh cÃ´ng',0),(456022,12668,'af','Betalingsinligting suksesvol bygewerk',0),(456023,12668,'ro','InformaÅ£ii de platÄƒ actualizat cu succes',0),(456024,12668,'et','Makse Info vÃ¤rskendamine Ãµnnestus',0),(456025,12668,'si','PlaÄilo Info uspeÅ¡no posodobljena',0),(456026,12668,'ba','Pembayaran Info diperbarui berhasil',0),(456027,12668,'nl','Betalingsinfo bijgewerkt',0),(456028,12668,'fi','Maksu Info pÃ¤ivitetty',0),(456029,12668,'no','Betalingsinformasjon oppdatert',0),(456030,12668,'da','Betaling Info opdateret',0),(456031,12668,'ko','ê²°ì œ ì •ë³´ë¥¼ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(456032,12668,'he','×¤×¨×˜×™ ×”×ª×©×œ×•× ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(456033,12668,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ½Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(456034,12668,'zh','ä»˜æ¬¾ä¿¡æ¯æ›´æ–°æˆåŠŸ',0),(456035,12668,'sv','Betalning information uppdaterades',0),(456036,12668,'it','Info pagamento aggiornato con successo',0),(456037,12668,'tl','',0),(456038,12668,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(456039,12668,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(456040,12668,'ms','Maklumat pembayaran yang berjaya dikemas kini',0),(456041,12668,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(456042,12668,'fr','Info paiement correctement mis Ã  jour',0),(456043,12668,'jp','æ”¯æ‰•ã„æƒ…å ±ãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(456044,12668,'pt','InformaÃ§Ã£o de pagamento atualizada com sucesso',0),(456045,12668,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ðµ, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(456046,12668,'es','Info de Pagos Actualizado Exitosamente',0),(456047,12668,'de','Zahlungsinfo erfolgreich aktualisiert',0),(456048,12668,'en','Payment Info Updated Successfully',0),(456049,12669,'is','',0),(456050,12669,'dr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø§Ø±ÛŒ',0),(456051,12669,'pr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø§Ø±ÛŒ',0),(456052,12669,'tr','GeÃ§erli Ã¶deme yÃ¶ntemi',0),(456053,12669,'pl','Aktualne metody pÅ‚atnoÅ›ci',0),(456054,12669,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¼ÐµÑ‚Ð¾Ð´ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(456055,12669,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù…ÙˆØ¬ÙˆØ¯Û Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø±',0),(456056,12669,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð½Ð°Ñ‡Ð¸Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(456057,12669,'vi','phÆ°Æ¡ng thá»©c thanh toÃ¡n hiá»‡n nay',0),(456058,12669,'af','Huidige Betalingsmetode',0),(456059,12669,'ro','Metoda de plata curent',0),(456060,12669,'et','Praeguse makseviisi',0),(456061,12669,'si','Trenutni naÄin plaÄila',0),(456062,12669,'ba','Saat ini metode pembayaran',0),(456063,12669,'nl','Huidige betalingsmethode',0),(456064,12669,'fi','Nykyinen maksutapa',0),(456065,12669,'no','Gjeldende betalingsmÃ¥te',0),(456066,12669,'da','Aktuelle betalingsmetode',0),(456067,12669,'ko','í˜„ìž¬ ê²°ì œ ë°©ë²•',0),(456068,12669,'he','×©×™×˜×ª ×”×ª×©×œ×•× ×”× ×•×›×—×™',0),(456069,12669,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î¼Î­Î¸Î¿Î´Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(456070,12669,'zh','å½“å‰ä»˜æ¬¾æ–¹å¼',0),(456071,12669,'sv','Aktuell betalningsmetod',0),(456072,12669,'it','Metodo di pagamento corrente',0),(456073,12669,'tl','',0),(456074,12669,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(456075,12669,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¦à¥à¤§à¤¤à¤¿',0),(456076,12669,'ms','Kaedah pembayaran semasa',0),(456077,12669,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(456078,12669,'fr','Mode de paiement actuel',0),(456079,12669,'jp','ç¾åœ¨ã®ãŠæ”¯æ‰•æ–¹æ³•',0),(456080,12669,'pt','MÃ©todo de pagamento atual',0),(456081,12669,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð¼ÐµÑ‚Ð¾Ð´ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(456082,12669,'es','MÃ©todo de Pago Actual',0),(456083,12669,'de','Aktuelle Zahlungsart',0),(456084,12669,'en','Current Payment Method',0),(456085,12670,'is','',0),(456086,12670,'dr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø®ÛŒØ±',0),(456087,12670,'pr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø®ÛŒØ±',0),(456088,12670,'tr','Son Ã¶deme iÅŸlemleri',0),(456089,12670,'pl','Ostatnich transakcji pÅ‚atniczych',0),(456090,12670,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ñ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð°',0),(456091,12670,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù„ÛŒÙ† Ø¯ÛŒÙ†',0),(456092,12670,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð³ Ð¿Ñ€Ð¾Ð¼ÐµÑ‚Ð°',0),(456093,12670,'vi','cÃ¡c giao dá»‹ch thanh toÃ¡n gáº§n Ä‘Ã¢y',0),(456094,12670,'af','Onlangse betaling transaksies',0),(456095,12670,'ro','Recente tranzacÅ£ii de platÄƒ',0),(456096,12670,'et','Tehtud maksetehingud',0),(456097,12670,'si','Nedavni plaÄilnih transakcij',0),(456098,12670,'ba','Transaksi pembayaran terakhir',0),(456099,12670,'nl','Recente betalingstransacties',0),(456100,12670,'fi','Hotelliin maksutapahtumat',0),(456101,12670,'no','Siste betalingstransaksjoner',0),(456102,12670,'da','Seneste betalingstransaktioner',0),(456103,12670,'ko','ìµœê·¼ ì§€ë¶ˆ ê±°ëž˜',0),(456104,12670,'he','×ª× ×•×¢×•×ª ×ª×©×œ×•× ×”××—×¨×•× ×•×ª',0),(456105,12670,'el','Î ÏÏŒÏƒÏ†Î±Ï„Ï‰Î½ ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(456106,12670,'zh','æœ€è¿‘ä»˜æ¬¾äº¤æ˜“',0),(456107,12670,'sv','Senaste transaktioner',0),(456108,12670,'it','Recenti operazioni di pagamento',0),(456109,12670,'tl','',0),(456110,12670,'th','à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(456111,12670,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨',0),(456112,12670,'ms','Hari urus niaga bayaran',0),(456113,12670,'ar','Ø­Ø±ÙƒØ§Øª Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(456114,12670,'fr','Ces derniÃ¨res opÃ©rations de paiement',0),(456115,12670,'jp','æœ€è¿‘ã®æ±ºæ¸ˆå–å¼•',0),(456116,12670,'pt','Recentes operaÃ§Ãµes de pagamento',0),(456117,12670,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(456118,12670,'es','Transacciones de Pagos Recientes',0),(456119,12670,'de','Den letzten Zahlungsverkehr',0),(456120,12670,'en','Recent Payment Transactions',0),(456121,12671,'is','',0),(456122,12671,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ù„Ø§ØµÙ‡',0),(456123,12671,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ù„Ø§ØµÙ‡',0),(456124,12671,'tr','Ã–zet bilgiler',0),(456125,12671,'pl','Informacje podsumowujÄ…ce',0),(456126,12671,'bg','ÐžÐ±Ð¾Ð±Ñ‰ÐµÐ½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(456127,12671,'ur','Ø®Ù„Ø§ØµÛ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(456128,12671,'sr','Ð¡Ð°Ð¶ÐµÑ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(456129,12671,'vi','ThÃ´ng tin tÃ³m lÆ°á»£c',0),(456130,12671,'af','Opsommende inligting',0),(456131,12671,'ro','InformaÈ›ii sumare',0),(456132,12671,'et','KokkuvÃµtlik teave',0),(456133,12671,'si','Povzetek informacij',0),(456134,12671,'ba','Informasi Ringkasan',0),(456135,12671,'nl','Beknopte informatie',0),(456136,12671,'fi','Yhteenvetotiedot',0),(456137,12671,'no','Sammendragsinformasjon',0),(456138,12671,'da','Oversigtsoplysninger',0),(456139,12671,'ko','ìš”ì•½ ì •ë³´',0),(456140,12671,'he','×ž×™×“×¢ ×¡×™×›×•×',0),(456141,12671,'el','Î£Ï…Î½Î¿Ï€Ï„Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(456142,12671,'zh','æ‘˜è¦ä¿¡æ¯',0),(456143,12671,'sv','Sammanfattande Information',0),(456144,12671,'it','Informazioni di riepilogo',0),(456145,12671,'tl','',0),(456146,12671,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¸£à¸¸à¸›',0),(456147,12671,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(456148,12671,'ms','Ringkasan maklumat',0),(456149,12671,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÙˆØ¬Ø²Ø©',0),(456150,12671,'fr','Renseignements sommaires',0),(456151,12671,'jp','æ¦‚è¦æƒ…å ±',0),(456152,12671,'pt','InformaÃ§Ãµes resumidas',0),(456153,12671,'ru','Ð¡Ð²Ð¾Ð´Ð½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(456154,12671,'es','InformaciÃ³n Sumaria',0),(456155,12671,'de','Zusammenfassende Informationen',0),(456156,12671,'en','Summary Information',0),(456157,12672,'is','',0),(456158,12672,'dr','Ø´Ù…Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±Ù‡ÛŒÚ† Ø§Ø´ØªØ±Ø§Ú© ÙØ¹Ø§Ù„ÛŒ Ù†Ø¯Ø§Ø±ÛŒØ¯',0),(456159,12672,'pr','Ø´Ù…Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±Ù‡ÛŒÚ† Ø§Ø´ØªØ±Ø§Ú© ÙØ¹Ø§Ù„ÛŒ Ù†Ø¯Ø§Ø±ÛŒØ¯',0),(456160,12672,'tr','Åžu anda hiÃ§bir etkin abonelikler var',0),(456161,12672,'pl','Obecnie masz Å¼adnych aktywnych subskrypcji',0),(456162,12672,'bg','Ð’ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° ÑÐ° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚Ð¸',0),(456163,12672,'ur','Ø¢Ù¾ Ø§Ø³ ÙˆÙ‚Øª Ú©ÙˆØ¦ÛŒ ÙØ¹Ø§Ù„ Ù…Ù…Ø¨Ø±Ø´Ù¾ ÛÛ’',0),(456164,12672,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð½ÐµÐ¼Ð°Ñ‚Ðµ Ð½ÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ñƒ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ñƒ',0),(456165,12672,'vi','hiá»‡n nay báº¡n khÃ´ng cÃ³ cÃ¡c Ä‘Äƒng kÃ½ cÃ³ hiá»‡u lá»±c',0),(456166,12672,'af','U Het Huidiglik Geen Aktiewe Subskripsies',0),(456167,12672,'ro','ÃŽn prezent aveÅ£i nicio abonamente activ',0),(456168,12672,'et','Teil on praegu aktiivsed tellimused',0),(456169,12672,'si','Imate trenutno ni aktivno naroÄnine',0),(456170,12672,'ba','Saat ini Anda memiliki langganan tidak aktif',0),(456171,12672,'nl','Je hebt momenteel geen actieve abonnementen',0),(456172,12672,'fi','Sinulla ei ole aktiivisia tilauksia',0),(456173,12672,'no','Du har ingen aktive abonnementer',0),(456174,12672,'da','Du har i Ã¸jeblikket ingen aktive abonnementer',0),(456175,12672,'ko','í˜„ìž¬ í™œì„± êµ¬ë…ì´ ì—†ëŠ”',0),(456176,12672,'he','×™×© ×œ×š ×›×¨×’×¢ ××™×Ÿ ×ž× ×•×™×™× ×¤×¢×™×œ×™×',0),(456177,12672,'el','ÎˆÏ‡ÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÎµÎ½ÎµÏÎ³Î­Ï‚ ÏƒÏ…Î½Î´ÏÎ¿Î¼Î­Ï‚',0),(456178,12672,'zh','æ‚¨æœ€è¿‘æ²¡æœ‰æ´»è·ƒçš„è®¤è‚¡',0),(456179,12672,'sv','Du har fÃ¶r nÃ¤rvarande inga aktiva prenumerationer',0),(456180,12672,'it','Attualmente si dispone di alcuna sottoscrizione attive',0),(456181,12672,'tl','',0),(456182,12672,'th','à¸‚à¸“à¸°à¸™à¸µà¹‰à¸¡à¸µà¸ªà¸¡à¸²à¸Šà¸´à¸à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸­à¸¢à¸¹à¹ˆà¹„à¸¡à¹ˆ',0),(456183,12672,'hi','à¤†à¤ª à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤•à¥‹à¤ˆ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤¹à¥ˆ',0),(456184,12672,'ms','Anda kini mempunyai langganan tidak aktif',0),(456185,12672,'ar','Ù„Ø¯ÙŠÙƒ Ø­Ø§Ù„ÙŠØ§ Ù„Ø§ Ø§Ø´ØªØ±Ø§ÙƒØ§Øª Ù†Ø´Ø·Ø©',0),(456186,12672,'fr','Vous n\'avez actuellement aucun abonnement actif',0),(456187,12672,'jp','ç¾åœ¨ãŒã‚ã‚‹ãªã„ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³',0),(456188,12672,'pt','VocÃª tem, atualmente, nÃ£o hÃ¡ assinaturas ativas',0),(456189,12672,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ñƒ Ð²Ð°Ñ Ð½ÐµÑ‚ Ð°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ñ… Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¾Ðº',0),(456190,12672,'es','Acutalmente No Tiene Suscripciones Activas',0),(456191,12672,'de','Sie haben derzeit keine aktiven Abonnements',0),(456192,12672,'en','You Currently Have No Active Subscriptions',0),(456193,12673,'is','',0),(456194,12673,'dr','Ú©Ù…Ú© Ú¯Ø±ÙØªÙ†',0),(456195,12673,'pr','Ú©Ù…Ú© Ú¯Ø±ÙØªÙ†',0),(456196,12673,'tr','YardÄ±m alma',0),(456197,12673,'pl','UzyskaÄ‡ pomoc',0),(456198,12673,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(456199,12673,'ur','Ù…Ø¯Ø¯ Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº Û”',0),(456200,12673,'sr','Ð”Ð¾Ð±Ð¸Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›',0),(456201,12673,'vi','Nháº­n trá»£ giÃºp',0),(456202,12673,'af','Kry hulp',0),(456203,12673,'ro','ObÅ£ine ajutor',0),(456204,12673,'et','Abi saamine',0),(456205,12673,'si','PomoÄ',0),(456206,12673,'ba','Mendapatkan bantuan',0),(456207,12673,'nl','Help-informatie opvragen',0),(456208,12673,'fi','Ohjeita',0),(456209,12673,'no','FÃ¥ hjelp',0),(456210,12673,'da','FÃ¥ hjÃ¦lp',0),(456211,12673,'ko','ë„ì›€ì„ ë°›ì„',0),(456212,12673,'he','×œ×§×‘×œ ×¢×–×¨×”',0),(456213,12673,'el','Î›Î¬Î²ÎµÏ„Îµ Î²Î¿Î®Î¸ÎµÎ¹Î±',0),(456214,12673,'zh','èŽ·å–å¸®åŠ©',0),(456215,12673,'sv','FÃ¥ hjÃ¤lp',0),(456216,12673,'it','Ottenere aiuto',0),(456217,12673,'tl','',0),(456218,12673,'th','à¸‚à¸­à¸„à¸§à¸²à¸¡à¸Šà¹ˆà¸§à¸¢à¹€à¸«à¸¥à¸·à¸­',0),(456219,12673,'hi','à¤®à¤¦à¤¦ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¥‡à¤‚',0),(456220,12673,'ms','Mendapatkan bantuan',0),(456221,12673,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(456222,12673,'fr','Obtenir de l\'aide',0),(456223,12673,'jp','åŠ©ã‘ã‚’å¾—ã‚‹',0),(456224,12673,'pt','Obter ajuda',0),(456225,12673,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒ',0),(456226,12673,'es','Obtener ayuda',0),(456227,12673,'de','Holen Sie sich Hilfe',0),(456228,12673,'en','Get Help',0),(456229,12674,'is','',0),(456230,12674,'dr','ÙˆØ¨ Ø³Ø§ÛŒØª NolaPro',0),(456231,12674,'pr','ÙˆØ¨ Ø³Ø§ÛŒØª NolaPro',0),(456232,12674,'tr','NolaPro Web sitesi',0),(456233,12674,'pl','NolaPro Strona internetowa',0),(456234,12674,'bg','NolaPro ÑƒÐµÐ±ÑÐ°Ð¹Ñ‚',0),(456235,12674,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹',0),(456236,12674,'sr','ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ WÐµÐ± Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(456237,12674,'vi','NolaPro trang web',0),(456238,12674,'af','NolaPro webwerf',0),(456239,12674,'ro','Site-ul NolaPro',0),(456240,12674,'et','NolaPro kodulehel',0),(456241,12674,'si','NolaPro spletna stran',0),(456242,12674,'ba','Situs web NolaPro',0),(456243,12674,'nl','NolaPro Website',0),(456244,12674,'fi','NolaPro sivusto',0),(456245,12674,'no','NolaPro nettsted',0),(456246,12674,'da','NolaPro hjemmeside',0),(456247,12674,'ko','NolaPro ì›¹ì‚¬ì´íŠ¸',0),(456248,12674,'he','××ª×¨ NolaPro',0),(456249,12674,'el','Î™ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î± NolaPro',0),(456250,12674,'zh','NolaPro ç½‘ç«™',0),(456251,12674,'sv','NolaPro hemsida',0),(456252,12674,'it','Sito Web NolaPro',0),(456253,12674,'tl','',0),(456254,12674,'th','à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ NolaPro',0),(456255,12674,'hi','NolaPro à¤µà¥‡à¤¬à¤¸à¤¾à¤‡à¤Ÿ',0),(456256,12674,'ms','Laman web NolaPro',0),(456257,12674,'ar','Ù…ÙˆÙ‚Ø¹ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ',0),(456258,12674,'fr','Site Web NolaPro',0),(456259,12674,'jp','NolaPro ã‚¦ã‚§ãƒ–ã‚µã‚¤ãƒˆ',0),(456260,12674,'pt','NolaPro Website',0),(456261,12674,'ru','NolaPro Ð²ÐµÐ±-ÑÐ°Ð¹Ñ‚',0),(456262,12674,'es','Sitio web subscribe',0),(456263,12674,'de','Artikel-Website',0),(456264,12674,'en','NolaPro Website',0),(456265,12675,'is','',0),(456266,12675,'dr','Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ',0),(456267,12675,'pr','Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ',0),(456268,12675,'tr','Destek seÃ§enekleri',0),(456269,12675,'pl','Opcje pomocy technicznej',0),(456270,12675,'bg','ÐžÐ¿Ñ†Ð¸Ð¸ Ð·Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(456271,12675,'ur','Ù…Ø¹Ø§ÙˆÙ†Øª Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(456272,12675,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ð¿Ð¾Ð´Ñ€ÑˆÐºÐµ',0),(456273,12675,'vi','Tuá»³ chá»n Há»— trá»£',0),(456274,12675,'af','Ondersteuning opsies',0),(456275,12675,'ro','OpÅ£iuni de suport',0),(456276,12675,'et','Tugiteenustest',0),(456277,12675,'si','MoÅ¾nosti podpore',0),(456278,12675,'ba','Opsi dukungan',0),(456279,12675,'nl','Ondersteuningsopties',0),(456280,12675,'fi','Tukivaihtoehdot',0),(456281,12675,'no','KundestÃ¸ttealternativer',0),(456282,12675,'da','Supportmuligheder',0),(456283,12675,'ko','ì§€ì› ì˜µì…˜',0),(456284,12675,'he','××¤×©×¨×•×™×•×ª ×ª×ž×™×›×”',0),(456285,12675,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ Ï…Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î·Ï‚',0),(456286,12675,'zh','æ”¯æŒé€‰é¡¹',0),(456287,12675,'sv','Supportalternativ',0),(456288,12675,'it','Opzioni di supporto',0),(456289,12675,'tl','',0),(456290,12675,'th','à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸à¸²à¸£à¸ªà¸™à¸±à¸šà¸ªà¸™à¸¸à¸™',0),(456291,12675,'hi','à¤¸à¤®à¤°à¥à¤¥à¤¨ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(456292,12675,'ms','Opsyen sokongan',0),(456293,12675,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø¯Ø¹Ù…',0),(456294,12675,'fr','Options de support',0),(456295,12675,'jp','ã‚µãƒãƒ¼ãƒˆ ãƒ» ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(456296,12675,'pt','OpÃ§Ãµes de suporte',0),(456297,12675,'ru','Ð’Ð°Ñ€Ð¸Ð°Ð½Ñ‚Ñ‹ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ¸',0),(456298,12675,'es','Opciones de Soporte',0),(456299,12675,'de','Support-Optionen',0),(456300,12675,'en','Support Options',0),(456301,12676,'is','',0),(456302,12676,'dr','Ø³Ø§ÛŒØª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ ',0),(456303,12676,'pr','Ø³Ø§ÛŒØª Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ ',0),(456304,12676,'tr','Destek sitesi',0),(456305,12676,'pl','Witryna pomocy technicznej',0),(456306,12676,'bg','ÐŸÐ¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ° Ð½Ð° ÑÐ°Ð¹Ñ‚Ð°',0),(456307,12676,'ur','Ø³Ù¾ÙˆØ±Ù¹ Ø³Ø§Ø¦Ù¹',0),(456308,12676,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð¿Ð¾Ð´Ñ€ÑˆÐºÐµ',0),(456309,12676,'vi','nÆ¡i há»— trá»£',0),(456310,12676,'af','Ondersteuning werf',0),(456311,12676,'ro','Suport Site',0),(456312,12676,'et','Support Site',0),(456313,12676,'si','Mestu za podporo',0),(456314,12676,'ba','Situs dukungan',0),(456315,12676,'nl','Ondersteuningssite',0),(456316,12676,'fi','Tukisivusto',0),(456317,12676,'no','KundestÃ¸tte',0),(456318,12676,'da','Support-websted',0),(456319,12676,'ko','ì§€ì› ì‚¬ì´íŠ¸',0),(456320,12676,'he','××ª×¨ ×ª×ž×™×›×ª',0),(456321,12676,'el','Î¥Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î· ÏƒÏ„Î¿Î½ Ï„ÏŒÏ€Î¿ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(456322,12676,'zh','æ”¯æŒç«™ç‚¹',0),(456323,12676,'sv','StÃ¶d webbplats',0),(456324,12676,'it','Sito di supporto',0),(456325,12676,'tl','',0),(456326,12676,'th','à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¸ªà¸™à¸±à¸šà¸ªà¸™à¸¸à¸™',0),(456327,12676,'hi','à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾ à¤¸à¤¾à¤‡à¤Ÿ',0),(456328,12676,'ms','Tapak sokongan',0),(456329,12676,'ar','Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø¯Ø¹Ù…',0),(456330,12676,'fr','Site de soutien',0),(456331,12676,'jp','ã‚µãƒãƒ¼ãƒˆ ã‚µã‚¤ãƒˆ',0),(456332,12676,'pt','Site de suporte',0),(456333,12676,'ru','Ð¡Ð°Ð¹Ñ‚ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ¸',0),(456334,12676,'es','Sitio de Soporte',0),(456335,12676,'de','Support-Website',0),(456336,12676,'en','Support Site',0),(456337,12677,'is','',0),(456338,12677,'dr','Ù…ØªÙ† Ø±Ø§Ù‡Ù†Ù…Ø§',0),(456339,12677,'pr','Ù…ØªÙ† Ø±Ø§Ù‡Ù†Ù…Ø§',0),(456340,12677,'tr','Metin yardÄ±m',0),(456341,12677,'pl','Tekst pomocy',0),(456342,12677,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ Ð·Ð° Ñ‚ÐµÐºÑÑ‚',0),(456343,12677,'ur','Ù…Ø¯Ø¯ Ù…ØªÙ†',0),(456344,12677,'sr','Ð¢ÐµÐºÑÑ‚ Ð¿Ð¾Ð¼Ð¾Ñ›Ð¸',0),(456345,12677,'vi','VÄƒn báº£n trá»£ giÃºp',0),(456346,12677,'af','Teks hulp',0),(456347,12677,'ro','Textul ajutor',0),(456348,12677,'et','Teksti spikker',0),(456349,12677,'si','Besedila pomoÄ',0),(456350,12677,'ba','Teks bantuan',0),(456351,12677,'nl','Tekstbestanden Help',0),(456352,12677,'fi','Teksti ohje',0),(456353,12677,'no','Tekst hjelp',0),(456354,12677,'da','HjÃ¦lp til tekst',0),(456355,12677,'ko','í…ìŠ¤íŠ¸ ë„ì›€ë§',0),(456356,12677,'he','×˜×§×¡×˜ ×¢×–×¨×”',0),(456357,12677,'el','Î’Î¿Î®Î¸ÎµÎ¹Î± ÎºÎµÎ¯Î¼ÎµÎ½Î¿',0),(456358,12677,'zh','æ–‡æœ¬å¸®åŠ©',0),(456359,12677,'sv','Text hjÃ¤lp',0),(456360,12677,'it','Aiuto testo',0),(456361,12677,'tl','',0),(456362,12677,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰',0),(456363,12677,'hi','à¤ªà¤¾à¤  à¤¸à¤¹à¤¾à¤¯à¤¤à¤¾',0),(456364,12677,'ms','Teks bantuan',0),(456365,12677,'ar','Ù†Øµ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª',0),(456366,12677,'fr','Texte aide',0),(456367,12677,'jp','ãƒ†ã‚­ã‚¹ãƒˆã®ãƒ˜ãƒ«ãƒ—',0),(456368,12677,'pt','Ajuda de texto',0),(456369,12677,'ru','Ð¢ÐµÐºÑÑ‚ ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸',0),(456370,12677,'es','Ayuda de Texto',0),(456371,12677,'de','Text-Hilfe',0),(456372,12677,'en','Text Help',0),(456373,12678,'is','',0),(456374,12678,'dr','Ø¯ÛŒØ¯Ù† Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(456375,12678,'pr','Ø¯ÛŒØ¯Ù† Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(456376,12678,'tr','Eklentileri gÃ¶rme',0),(456377,12678,'pl','Zobacz Dodatki',0),(456378,12678,'bg','Ð’Ð¸Ð¶Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(456379,12678,'ur','Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª Ù…Ù„Ø§Ø­Ø¸Û Ú©Ø±ÛŒÚº',0),(456380,12678,'sr','Ð’Ð¸Ð´Ð¸Ð¼ Ð´Ð¾Ð´Ð°Ñ†Ð¸Ð¼Ð°',0),(456381,12678,'vi','Xem add-ons',0),(456382,12678,'af','Sien byvoegsels',0),(456383,12678,'ro','A se vedea Suplimente',0),(456384,12678,'et','Vt lisandmooduleid',0),(456385,12678,'si','Glejte dodatki',0),(456386,12678,'ba','Tampilkan Pengaya',0),(456387,12678,'nl','Add-Ons bekijken',0),(456388,12678,'fi','Katso lisÃ¤osat',0),(456389,12678,'no','Se tillegg',0),(456390,12678,'da','Se tilfÃ¸jelser',0),(456391,12678,'ko','ì¶”ê°€ ê¸°ëŠ¥ì„ ì°¸ì¡° í•˜ì‹­ì‹œì˜¤',0),(456392,12678,'he','×¨××” ×ª×•×¡×¤×•×ª',0),(456393,12678,'el','Î”ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎµÏ‚',0),(456394,12678,'zh','æŸ¥çœ‹é™„åŠ è£…ç½®',0),(456395,12678,'sv','Se tillÃ¤gg',0),(456396,12678,'it','Vedi Componenti aggiuntivi',0),(456397,12678,'tl','',0),(456398,12678,'th','à¸”à¸¹à¹‚à¸›à¸£à¹à¸à¸£à¸¡ Add-on',0),(456399,12678,'hi','à¤à¤¡-à¤‘à¤¨à¥à¤¸ à¤¦à¥‡à¤–à¤¨à¥‡',0),(456400,12678,'ms','Lihat tambahan',0),(456401,12678,'ar','Ø§Ù„Ø¥Ø¶Ø§ÙØ§Øª',0),(456402,12678,'fr','Voir Add-ons',0),(456403,12678,'jp','ã‚¢ãƒ‰ã‚ªãƒ³ã‚’å‚ç…§ã—ã¦ãã ã•ã„ã€‚',0),(456404,12678,'pt','Ver Complementos',0),(456405,12678,'ru','Ð£Ð²Ð¸Ð´ÐµÑ‚ÑŒ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(456406,12678,'es','Ve Add-Ons',0),(456407,12678,'de','Add-ons anzeigen',0),(456408,12678,'en','See Add-Ons',0),(456409,12679,'is','',0),(456410,12679,'dr','Ú©Ø¯ ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒ Ø±Ø§Ø§Ø¬Ø±Ø§ Ú©Ù†ÛŒØ¯ ',0),(456411,12679,'pr','Ú©Ø¯ ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒ Ø±Ø§Ø§Ø¬Ø±Ø§ Ú©Ù†ÛŒØ¯ ',0),(456412,12679,'tr','Aktivasyon kodlarÄ± uygulayÄ±n',0),(456413,12679,'pl','ZastosowaÄ‡ kody aktywacyjne',0),(456414,12679,'bg','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°Ð½Ðµ Ð½Ð° Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð´Ð¾Ð²Ðµ',0),(456415,12679,'ur','Ø§ÛŒÚ©Ù¹ÛŒÙˆÛŒØ´Ù† Ú©ÙˆÚˆ Ù„Ú¯Ø§Ø¦ÛŒÚº',0),(456416,12679,'sr','Ð”Ð¾Ð´ÐµÑ™Ð¸Ð²Ð°ÑšÐµ ÑˆÐ¸Ñ„Ð°Ñ€Ð° Ð·Ð° Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(456417,12679,'vi','Ãp dá»¥ng mÃ£ sá»‘ kÃ­ch hoáº¡t',0),(456418,12679,'af','Aktivering kodes van toepassing',0),(456419,12679,'ro','Se aplicÄƒ codurile de activare',0),(456420,12679,'et','Rakenda aktiveerimise koodid',0),(456421,12679,'si','Uporablja Activation zbornik',0),(456422,12679,'ba','Menerapkan kode aktivasi',0),(456423,12679,'nl','Activatiecodes toepassen',0),(456424,12679,'fi','Soveltaa aktivointikoodia',0),(456425,12679,'no','Bruke aktivisering koder',0),(456426,12679,'da','Anvende aktivisering koder',0),(456427,12679,'ko','ì •í’ˆ ì¸ì¦ ì½”ë“œë¥¼ ì ìš©',0),(456428,12679,'he','×”×—×œ×ª ×§×•×“×™ ×”×¤×¢×œ×”',0),(456429,12679,'el','Î•Ï†Î±ÏÎ¼ÏŒÏƒÎµÏ„Îµ ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚ ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚',0),(456430,12679,'zh','åº”ç”¨æ¿€æ´»ç ',0),(456431,12679,'sv','TillÃ¤mpa aktiveringskoder',0),(456432,12679,'it','Applicare i codici di attivazione',0),(456433,12679,'tl','',0),(456434,12679,'th','à¹ƒà¸Šà¹‰à¸£à¸«à¸±à¸ªà¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(456435,12679,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯à¤£ à¤•à¥‹à¤¡ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(456436,12679,'ms','Menggunakan kod-kod pengaktifan',0),(456437,12679,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø±Ù…ÙˆØ² Ø§Ù„ØªÙ†Ø´ÙŠØ·',0),(456438,12679,'fr','Appliquer les Codes d\'Activation',0),(456439,12679,'jp','æ´»æ€§åŒ–ã‚³ãƒ¼ãƒ‰ã‚’é©ç”¨ã—ã¾ã™ã€‚',0),(456440,12679,'pt','Aplicar os cÃ³digos de ativaÃ§Ã£o',0),(456441,12679,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÐºÐ¾Ð´Ñ‹ Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ð¸',0),(456442,12679,'es','Aplicar los CÃ³digos de Activation',0),(456443,12679,'de','Anwendung der Aktivierungscodes',0),(456444,12679,'en','Apply Activation Codes',0),(456445,12680,'is','',0),(456446,12680,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø²Ù…Ø§Ù† &amp; Ù…ÙˆØ§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ',0),(456447,12680,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø²Ù…Ø§Ù† &amp; Ù…ÙˆØ§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ',0),(456448,12680,'tr','Zaman & malzeme GiriÅŸi Ekle',0),(456449,12680,'pl','Dodaj czas & materiaÅ‚Ã³w wejÅ›cia',0),(456450,12680,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð²Ñ€ÐµÐ¼Ðµ & Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸ Ð·Ð°Ð¿Ð¸Ñ',0),(456451,12680,'ur','ÙˆÙ‚Øª & Ù…ÙˆØ§Ø¯ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(456452,12680,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° & Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð»Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(456453,12680,'vi','ThÃªm thá»i gian &amp; má»¥c nháº­p váº­t liá»‡u',0),(456454,12680,'af','Voeg tyd & materiaal inskrywing',0),(456455,12680,'ro','Adauga timp & materiale de intrare',0),(456456,12680,'et','Lisa aeg & materjalide kanne',0),(456457,12680,'si','Dodati Äas & vnos materialov',0),(456458,12680,'ba','Menambahkan waktu & bahan entri',0),(456459,12680,'nl','Tijd & materialen vermelding toevoegen',0),(456460,12680,'fi','LisÃ¤Ã¤ aikaa & materiaalien merkintÃ¤',0),(456461,12680,'no','Legge til tid & materialer oppfÃ¸ring',0),(456462,12680,'da','TilfÃ¸je tid & materialer post',0),(456463,12680,'ko','ì‹œê°„ & ìžë£Œ í•­ëª© ì¶”ê°€',0),(456464,12680,'he','×œ×”×•×¡×™×£ ×–×ž×Ÿ & ×—×•×ž×¨×™ ×”×–× ×”',0),(456465,12680,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï‡ÏÏŒÎ½Î¿ & Ï…Î»Î¹ÎºÎ¬ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(456466,12680,'zh','æ·»åŠ æ—¶é—´ &amp; ææ–™æ¡ç›®',0),(456467,12680,'sv','LÃ¤gga till tid & material intrÃ¤de',0),(456468,12680,'it','Aggiungi tempo & entrata materiali',0),(456469,12680,'tl','',0),(456470,12680,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸§à¸¥à¸² & à¸£à¸²à¸¢à¸à¸²à¸£à¸§à¸±à¸ªà¸”à¸¸à¹à¸¥à¸°à¸ªà¹ˆà¸§à¸™à¸›à¸£à¸°à¸à¸­à¸š',0),(456471,12680,'hi','à¤¸à¤®à¤¯ & à¤¸à¤¾à¤®à¤—à¥à¤°à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(456472,12680,'ms','Tambah masa & kemasukan bahan-bahan',0),(456473,12680,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆÙ‚Øª Ø¢Ù†Ø¯ Ø¯Ø®ÙˆÙ„ Ø§Ù„Ù…ÙˆØ§Ø¯',0),(456474,12680,'fr','Ajouter temps & l\'entrÃ©e de matÃ©riaux',0),(456475,12680,'jp','æ™‚é–“ & ææ–™ã‚¨ãƒ³ãƒˆãƒªã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(456476,12680,'pt','Adicionar tempo & entrada de materiais',0),(456477,12680,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ & Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ñ‹ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(456478,12680,'es','AÃ±adir tiempo &amp; la entrada de los materiales',0),(456479,12680,'de','Zeit & Materialien-Eintrag hinzufÃ¼gen',0),(456480,12680,'en','Add Time & Materials Entry',0),(456481,12681,'is','',0),(456482,12681,'dr','Ø¬Ø³ØªØ¬ÙˆÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø³ÙØ§Ø±Ø´',0),(456483,12681,'pr','Ø¬Ø³ØªØ¬ÙˆÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø³ÙØ§Ø±Ø´',0),(456484,12681,'tr','GeliÅŸtirilmiÅŸ sipariÅŸ arama',0),(456485,12681,'pl','Szukaj zaawansowane zlecenia',0),(456486,12681,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¾ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(456487,12681,'ur','Ø§Ø¹Ù„ÛŒ ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªÙ„Ø§Ø´',0),(456488,12681,'sr','ÐÐ°Ð¿Ñ€ÐµÐ´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(456489,12681,'vi','TÃ¬m kiáº¿m Ä‘Æ¡n hÃ ng nÃ¢ng cao ',0),(456490,12681,'af','Gevorderde Bestellingssoektog',0),(456491,12681,'ro','CÄƒutare avansatÄƒ ordine',0),(456492,12681,'et','TÃ¤psem tellimuse Otsi',0),(456493,12681,'si','Napredno vrstni red iskanja',0),(456494,12681,'ba','Cari maju Order',0),(456495,12681,'nl','Geavanceerde Order zoeken',0),(456496,12681,'fi','Edistyneen Etsi',0),(456497,12681,'no','ForhÃ¥ndsbestilling sÃ¸k',0),(456498,12681,'da','Avanceret ordre sÃ¸gning',0),(456499,12681,'ko','ê³ ê¸‰ ì£¼ë¬¸ ê²€ìƒ‰',0),(456500,12681,'he','×—×™×¤×•×© ×ž×ª×§×“× ×¡×“×¨',0),(456501,12681,'el','Î ÏÎ¿Î·Î³Î¼Î­Î½Î· ÏƒÎµÎ¹ÏÎ¬ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(456502,12681,'zh','å…ˆè¿›çš„é¡ºåºæœç´¢',0),(456503,12681,'sv','Avancerade ordning SÃ¶k',0),(456504,12681,'it','Ricerca avanzata di ordine',0),(456505,12681,'tl','',0),(456506,12681,'th','à¸„à¹‰à¸™à¸«à¸²à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡',0),(456507,12681,'hi','à¤‰à¤¨à¥à¤¨à¤¤ à¤†à¤¦à¥‡à¤¶ à¤–à¥‹à¤œ',0),(456508,12681,'ms','Carian lanjutan perintah',0),(456509,12681,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† ØªØ±ØªÙŠØ¨ Ù…ØªÙ‚Ø¯Ù…',0),(456510,12681,'fr','Recherche avancÃ©e d\'ordre',0),(456511,12681,'jp','é«˜åº¦ãªæ³¨æ–‡ã®æ¤œç´¢',0),(456512,12681,'pt','Pesquisa avanÃ§ada de ordem',0),(456513,12681,'ru','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð· Ð¿Ð¾Ð¸ÑÐº',0),(456514,12681,'es','Busqueda de Pedido Avanzado',0),(456515,12681,'de','Erweiterte Auftrag Suche',0),(456516,12681,'en','Advanced Order Search',0),(456517,12682,'is','',0),(456518,12682,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª',0),(456519,12682,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª',0),(456520,12682,'tr','SipariÅŸleri oluÅŸturmak',0),(456521,12682,'pl','Tworzenie zamÃ³wienia',0),(456522,12682,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(456523,12682,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªØ¹Ù…ÛŒØ±',0),(456524,12682,'sr','Ð˜Ð·Ð³Ñ€Ð°Ð´Ð¸ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(456525,12682,'vi','ÄÆ¡n HÃ ng Sáº£n Xuáº¥t Khi Äáº·t HÃ ng',0),(456526,12682,'af','Bou van bestellings',0),(456527,12682,'ro','Construi comenzi',0),(456528,12682,'et','Ehitada tellimused',0),(456529,12682,'si','Graditi naroÄila',0),(456530,12682,'ba','Membangun perintah',0),(456531,12682,'nl','Bouwen van Orders',0),(456532,12682,'fi','Rakentaa tilaukset',0),(456533,12682,'no','Bygge bestillinger',0),(456534,12682,'da','Bygge ordrer',0),(456535,12682,'ko','ë¹Œë“œ ìˆœì„œ',0),(456536,12682,'he','×œ×‘× ×•×ª ×”×–×ž× ×•×ª',0),(456537,12682,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(456538,12682,'zh','æž„å»ºé¡ºåº',0),(456539,12682,'sv','Bygga order',0),(456540,12682,'it','Costruire gli ordini',0),(456541,12682,'tl','',0),(456542,12682,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(456543,12682,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(456544,12682,'ms','Membina pesanan',0),(456545,12682,'ar','Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø±',0),(456546,12682,'fr','CrÃ©er des ordres',0),(456547,12682,'jp','æ³¨æ–‡ã‚’æ§‹ç¯‰ã—ã¾ã™ã€‚',0),(456548,12682,'pt','Ordens de construÃ§Ã£o',0),(456549,12682,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(456550,12682,'es','Ordenes ConstrucciÃ³n',0),(456551,12682,'de','Erstellen von Bestellungen',0),(456552,12682,'en','Build Orders',0),(456553,12683,'is','',0),(456554,12683,'dr','Ø¨Ø±Ø§ÛŒ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ù…ÛŒØ²Ø¨Ø§Ù† Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(456555,12683,'pr','Ø¨Ø±Ø§ÛŒ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ù…ÛŒØ²Ø¨Ø§Ù† Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(456556,12683,'tr','BarÄ±ndÄ±rÄ±lan bir hesabÄ± kurmak iÃ§in burayÄ± tÄ±klatÄ±n',0),(456557,12683,'pl','Kliknij tutaj, aby skonfigurowaÄ‡ konto akademik',0),(456558,12683,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° ÑÐµ ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ñ…Ð¾ÑÑ‚Ð²Ð°Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(456559,12683,'ur','ÛŒÛØ§Úº Ø§ÛŒÚ© Ù…ÛŒØ²Ø¨Ø§Ù† Ø´Ø¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(456560,12683,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ð¾Ð´ÐµÑÐ¸Ð»Ð¸ Ñ˜Ð°Ð²Ð½Ð¸Ñ… Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(456561,12683,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ cÃ i Ä‘áº·t má»™t tÃ i khoáº£n Hosted',0),(456562,12683,'af','Klik hier om te stel \'n gehuisveste rekening',0),(456563,12683,'ro','Click aici pentru a parametriza un cont gazduit',0),(456564,12683,'et','Kliki siia loodud Hosted konto',0),(456565,12683,'si','Kliknite tukaj, da ustanovi Hosted raÄun',0),(456566,12683,'ba','Klik di sini untuk mengatur Account host',0),(456567,12683,'nl','Klik hier om een gehoste Account instellen',0),(456568,12683,'fi','Klikkaa tÃ¤stÃ¤ perustaa isÃ¤nnÃ¶i tili',0),(456569,12683,'no','Klikk her for Ã¥ sette opp en Hosted konto',0),(456570,12683,'da','Klik her for at oprette en Hosted konto',0),(456571,12683,'ko','í˜¸ìŠ¤íŒ…ëœ ê³„ì • ì„¤ì • í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­í•©ë‹ˆë‹¤',0),(456572,12683,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×’×“×™×¨ ×—×©×‘×•×Ÿ ×ž×ª××¨×—',0),(456573,12683,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± ÏÏ…Î¸Î¼Î¯ÏƒÎµÏ„Îµ Î­Î½Î± Ï†Î¹Î»Î¿Î¾ÎµÎ½Î®ÏƒÎµÎ¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(456574,12683,'zh','ç‚¹å‡»è¿™é‡Œæ¥æ–°å»ºä¸€ä¸ªä¸»åŠžå¸æˆ·',0),(456575,12683,'sv','Klicka hÃ¤r fÃ¶r att stÃ¤lla in en vÃ¤rd konto',0),(456576,12683,'it','Clicca qui per configurare un Account di hosting',0),(456577,12683,'tl','',0),(456578,12683,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸±à¸à¸Šà¸µà¹‚à¸®à¸ªà¸•à¹Œ',0),(456579,12683,'hi','à¤¸à¥‡à¤Ÿ à¤…à¤ª à¤à¤• à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤®à¥‡à¤œà¤¬à¤¾à¤¨à¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(456580,12683,'ms','Klik di sini untuk Set Up akaun yang dihos',0),(456581,12683,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¥Ù†Ø´Ø§Ø¡ Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ¶Ø§ÙØ©',0),(456582,12683,'fr','Cliquez ici pour configurer un compte hÃ©bergÃ©',0),(456583,12683,'jp','ãƒ›ã‚¹ãƒˆã•ã‚Œã¦ã„ã‚‹ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¨­å®šã™ã‚‹ã«ã¯ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™ã€‚',0),(456584,12683,'pt','Clique aqui para configurar uma conta hospedada',0),(456585,12683,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð½Ñ‹Ñ…',0),(456586,12683,'es','Hace Clik Aqui Para Establecer Una Cuenta Hospedada',0),(456587,12683,'de','Klicken Sie hier, so richten Sie ein gehostetes Konto',0),(456588,12683,'en','Click Here To Set Up A Hosted Account',0),(456589,12684,'is','',0),(456590,12684,'dr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ù†Ù…Ø§ÛŒØ´ Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§ Ø¯Ø± ØµÙØ­Ø§Øª',0),(456591,12684,'pr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ù†Ù…Ø§ÛŒØ´ Ø¢Ø¨ Ùˆ Ù‡ÙˆØ§ Ø¯Ø± ØµÙØ­Ø§Øª',0),(456592,12684,'tr','Hava ekran sayfalarÄ± gizle',0),(456593,12684,'pl','Ukryj Pogoda wyÅ›wietlania na stronach',0),(456594,12684,'bg','Ð¡ÐºÑ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð²Ñ€ÐµÐ¼ÐµÑ‚Ð¾ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(456595,12684,'ur','Ù…ÙˆØ³Ù… ÚˆØ³Ù¾Ù„Û’ ØµÙØ­Ø§Øª Ù¾Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(456596,12684,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÐŸÑ€Ð¸ÐºÐ°Ð· Ð²Ñ€ÐµÐ¼ÐµÐ½ÑÐºÐµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ð¼Ð°',0),(456597,12684,'vi','GiÃ¡u hiá»‡n thá»i tiáº¿t trÃªn trang',0),(456598,12684,'af','Versteek weer vertoon op die bladsye',0),(456599,12684,'ro','Ascunde vreme afiÅŸare pagini',0),(456600,12684,'et','Peida Ilm NÃ¤ita lehekÃ¼lgedel',0),(456601,12684,'si','Skrij Vreme Display na straneh',0),(456602,12684,'ba','Menyembunyikan cuaca tampilan halaman',0),(456603,12684,'nl','Weather Display op pagina\'s verbergen',0),(456604,12684,'fi','Piilota Weather Display sivuilla',0),(456605,12684,'no','Skjule VÃ¦r vises pÃ¥ sider',0),(456606,12684,'da','Skjule Weather Display pÃ¥ sider',0),(456607,12684,'ko','íŽ˜ì´ì§€ì— ë‚ ì”¨ í‘œì‹œ ìˆ¨ê¸°ê¸°',0),(456608,12684,'he','×”×¡×ª×¨ ×ª×¦×•×’×ª ×ž×–×’ ×”××•×•×™×¨ ×‘×“×¤×™×',0),(456609,12684,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Weather Display ÏƒÏ„Î¹Ï‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚',0),(456610,12684,'zh','éšè—é¡µé¢ä¸Šçš„å¤©æ°”æ˜¾ç¤º',0),(456611,12684,'sv','DÃ¶lja Weather Display pÃ¥ sidor',0),(456612,12684,'it','Nascondere Weather Display su pagine',0),(456613,12684,'tl','',0),(456614,12684,'th','à¸‹à¹ˆà¸­à¸™à¹à¸ªà¸”à¸‡à¸ªà¸ à¸²à¸žà¸­à¸²à¸à¸²à¸¨à¸«à¸™à¹‰à¸²',0),(456615,12684,'hi','à¤®à¥Œà¤¸à¤® à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤ªà¤° à¤›à¥à¤ªà¤¾à¤à¤',0),(456616,12684,'ms','Sembunyi paparan cuaca di muka surat',0),(456617,12684,'ar','Ø¥Ø®ÙØ§Ø¡ Ø¹Ø±Ø¶ Ø§Ù„Ø·Ù‚Ø³ Ø¹Ù„Ù‰ ØµÙØ­Ø§Øª',0),(456618,12684,'fr','Masquer l\'affichage de la mÃ©tÃ©o sur Pages',0),(456619,12684,'jp','ãƒšãƒ¼ã‚¸ã§å¤©æ°—äºˆå ±ã‚’è¡¨ç¤ºéžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(456620,12684,'pt','Ocultar a exibiÃ§Ã£o de tempo nas pÃ¡ginas',0),(456621,12684,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð³Ð¾Ð´Ñ‹ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ…',0),(456622,12684,'es','Esconde Desplega de la Clima en las PÃ¡ginas',0),(456623,12684,'de','Weather Display auf Seiten ausblenden',0),(456624,12684,'en','Hide Weather Display On Pages',0),(456625,12685,'is','',0),(456626,12685,'dr',' Ù…Ø¯ÛŒØ±ÛŒØª Ø§Ø´ØªØ±Ø§Ú©',0),(456627,12685,'pr',' Ù…Ø¯ÛŒØ±ÛŒØª Ø§Ø´ØªØ±Ø§Ú©',0),(456628,12685,'tr','Abonelik YÃ¶net',0),(456629,12685,'pl','ZarzÄ…dzanie subskrypcja',0),(456630,12685,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(456631,12685,'ur','Ø±Ú©Ù†ÛŒØª Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±ÛŒÚº',0),(456632,12685,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(456633,12685,'vi','Quáº£n lÃ½ há»™i',0),(456634,12685,'af','Bestuur intekening',0),(456635,12685,'ro','Gestiona abonament',0),(456636,12685,'et','Hallata tellimus',0),(456637,12685,'si','Upravljanje naroÄnine',0),(456638,12685,'ba','Mengelola langganan',0),(456639,12685,'nl','Abonnement beheren',0),(456640,12685,'fi','Hallita tilaus',0),(456641,12685,'no','HÃ¥ndtere abonnement',0),(456642,12685,'da','Administrere abonnement',0),(456643,12685,'ko','êµ¬ë… ê´€ë¦¬',0),(456644,12685,'he','× ×™×”×•×œ ×ž× ×•×™',0),(456645,12685,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®',0),(456646,12685,'zh','ç®¡ç†ä¼šè´¹',0),(456647,12685,'sv','Hantera abonnemang',0),(456648,12685,'it','Gestire l\'abbonamento',0),(456649,12685,'tl','',0),(456650,12685,'th','à¸ˆà¸±à¸”à¸à¸²à¸£à¸à¸²à¸£à¸šà¸­à¸à¸£à¸±à¸šà¹€à¸›à¹‡à¸™à¸ªà¸¡à¸²à¸Šà¸´à¸',0),(456651,12685,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(456652,12685,'ms','Menguruskan langganan',0),(456653,12685,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(456654,12685,'fr','GÃ©rer l\'abonnement',0),(456655,12685,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã‚’ç®¡ç†ã—ã¾ã™ã€‚',0),(456656,12685,'pt','Gerenciar inscriÃ§Ã£o',0),(456657,12685,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ°Ð¼Ð¸',0),(456658,12685,'es','Administrar SuscripciÃ³n',0),(456659,12685,'de','Abonnement verwalten',0),(456660,12685,'en','Manage Subscription',0),(456661,12686,'is','',0),(456662,12686,'dr','Ù‡ÛŒÚ† Ø³ÙØ§Ø±Ø´Ø§Øª Ù‡Ù…Ø§Ù‡Ù†Ú¯ÛŒ',0),(456663,12686,'pr','Ù‡ÛŒÚ† Ø³ÙØ§Ø±Ø´Ø§Øª Ù‡Ù…Ø§Ù‡Ù†Ú¯ÛŒ',0),(456664,12686,'tr','EÅŸleÅŸen hiÃ§bir emir',0),(456665,12686,'pl','Nie pasujÄ…ce zamÃ³wieÅ„',0),(456666,12686,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(456667,12686,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø´Ø§Ø¨Û Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(456668,12686,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(456669,12686,'vi','khÃ´ng liÃªn káº¿t cÃ¡c Ä‘Æ¡n hÃ ng',0),(456670,12686,'af','Geen passende bestellings',0),(456671,12686,'ro','Nici o ordine de potrivire',0),(456672,12686,'et','Pole vastavaid tellimusi',0),(456673,12686,'si','Brez ujemanja naroÄil',0),(456674,12686,'ba','Tidak ada order yang cocok',0),(456675,12686,'nl','Geen overeenkomende Orders',0),(456676,12686,'fi','Ei vastaavia tilauksia',0),(456677,12686,'no','Ingen samsvarende ordre',0),(456678,12686,'da','Ingen matchende ordrer',0),(456679,12686,'ko','ì•„ë‹ˆ ì¼ì¹˜ ìˆœì„œ',0),(456680,12686,'he','××™×Ÿ ×”×–×ž× ×•×ª ×ª×•××ž×•×ª',0),(456681,12686,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(456682,12686,'zh','æ²¡æœ‰åŒ¹é…çš„è®¢å•',0),(456683,12686,'sv','Inga matchande order',0),(456684,12686,'it','Nessun ordine corrispondente',0),(456685,12686,'tl','',0),(456686,12686,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸•à¸£à¸‡à¸à¸±à¸™',0),(456687,12686,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤†à¤¦à¥‡à¤¶',0),(456688,12686,'ms','Tiada perintah yang sepadan',0),(456689,12686,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙˆØ§Ù…Ø± Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(456690,12686,'fr','Aucune commande ne correspondant',0),(456691,12686,'jp','ä¸€è‡´ã™ã‚‹é †åºç„¡ã—',0),(456692,12686,'pt','Nenhuma ordem correspondente',0),(456693,12686,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ',0),(456694,12686,'es','No Hay Ordenes Pareados',0),(456695,12686,'de','Keine passende AuftrÃ¤ge',0),(456696,12686,'en','No Matching Orders',0),(456697,12687,'is','',0),(456698,12687,'dr','/ ÙˆØ§Ø­Ø¯ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(456699,12687,'pr','ÙˆØ§Ø­Ø¯ ÙØ±ÙˆØ´ ÙØ±ÙˆØ´ Ø¬Ø¯ÛŒØ¯ / ÙˆØ§Ø­Ø¯ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(456700,12687,'tr','Yeni satÄ±ÅŸ/fiyat birimi',0),(456701,12687,'pl','Nowa jednostka sprzedaÅ¼y/Cennik',0),(456702,12687,'bg','ÐÐ¾Ð²Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸/Ñ†ÐµÐ½Ð¸',0),(456703,12687,'ur','Ù†Ø¦Û’ ÛŒÙˆÙ†Ù¹ ÙØ±ÙˆØ®Øª/Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(456704,12687,'sr','ÐÐ¾Ð²Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ/Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(456705,12687,'vi','Ä‘Æ¡n vá»‹ giÃ¡/doanh sá»‘ má»›i',0),(456706,12687,'af','Nuwe verkope/pryse eenheid',0),(456707,12687,'ro','Noua unitate de vÃ¢nzÄƒri/preturi',0),(456708,12687,'et','Uute mÃ¼Ã¼gi/hind Ã¼hiku',0),(456709,12687,'si','Nove prodaje/cene enote',0),(456710,12687,'ba','Unit penjualan/harga baru',0),(456711,12687,'nl','Nieuwe eenheid verkoop/prijzen',0),(456712,12687,'fi','Uusi myynti/hinnoittelu yksikkÃ¶',0),(456713,12687,'no','Nye salg/priser enheten',0),(456714,12687,'da','Nye salg/prissÃ¦tning enhed',0),(456715,12687,'ko','ìƒˆë¡œìš´ íŒë§¤/ê°€ê²© ë‹¨ìœ„',0),(456716,12687,'he','×™×—×™×“×” ×—×“×©×” ×ª×ž×—×•×¨/×ž×›×™×¨×•×ª',0),(456717,12687,'el','ÎÎ­Î± Î¼Î¿Î½Î¬Î´Î± Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚/Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(456718,12687,'zh','æ–°é”€å”®/è®¡ä»·å•ä½',0),(456719,12687,'sv','Ny fÃ¶rsÃ¤ljning/prissÃ¤ttning enhet',0),(456720,12687,'it','Nuova unitÃ  di vendite/prezzi',0),(456721,12687,'tl','',0),(456722,12687,'th','à¸«à¸™à¹ˆà¸§à¸¢à¸‚à¸²à¸¢/à¸£à¸²à¸„à¸²à¹ƒà¸«à¸¡à¹ˆ',0),(456723,12687,'hi','à¤¨à¤ˆ à¤‡à¤•à¤¾à¤ˆ à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€/à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(456724,12687,'ms','Unit jualan/harga baru',0),(456725,12687,'ar','ÙˆØ­Ø¯Ø© Ø¬Ø¯ÙŠØ¯Ø© Ù„ØªØ³Ø¹ÙŠØ± Ù…Ø¨ÙŠØ¹Ø§Øª/',0),(456726,12687,'fr','Nouvelle unitÃ© de ventes/tarification',0),(456727,12687,'jp','æ–°ã—ã„è²©å£²ä¾¡æ ¼/å˜ä½',0),(456728,12687,'pt','Nova unidade de vendas/preÃ§os',0),(456729,12687,'ru','ÐÐ¾Ð²Ð¾Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¸ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(456730,12687,'es','Nuevas Ventas/Unidad de Precios',0),(456731,12687,'de','Neue Sales/Preise-Einheit',0),(456732,12687,'en','New Sales/Pricing Unit',0),(456733,12688,'is','',0),(456734,12688,'dr','/ ÙˆØ§Ø­Ø¯ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(456735,12688,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ ÙˆØ§Ø­Ø¯ÙØ±ÙˆØ´ / ÙˆØ§Ø­Ø¯ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(456736,12688,'tr','SatÄ±ÅŸ/fiyat birim DÃ¼zenle',0),(456737,12688,'pl','Edycja jednostki sprzedaÅ¼y/Cennik',0),(456738,12688,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸/Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(456739,12688,'ur','ÛŒÙˆÙ†Ù¹ ÙØ±ÙˆØ®Øª/Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ…',0),(456740,12688,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ/Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(456741,12688,'vi','Chá»‰nh sá»­a Ä‘Æ¡n vá»‹ doanh sá»‘/giÃ¡',0),(456742,12688,'af','Redigeer verkope/pryse eenheid',0),(456743,12688,'ro','Editare unitate de vÃ¢nzÄƒri/preturi',0),(456744,12688,'et','MÃ¼Ã¼gi/hind Ã¼ksuse redigeerimine',0),(456745,12688,'si','Urejanje prodaje/cene enote',0),(456746,12688,'ba','Mengedit penjualan/harga satuan',0),(456747,12688,'nl','Verkoop/prijzen eenheid bewerken',0),(456748,12688,'fi','Muokkaa myynti/hinnoittelu yksikkÃ¶',0),(456749,12688,'no','Redigere salg/priser enhet',0),(456750,12688,'da','Redigere salg/prissÃ¦tning enhed',0),(456751,12688,'ko','íŒë§¤/ê°€ê²© ë‹¨ìœ„ íŽ¸ì§‘',0),(456752,12688,'he','×¢×¨×™×›×ª ×™×—×™×“×ª ×ž×›×™×¨×•×ª/×ª×ž×—×•×¨',0),(456753,12688,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚/Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· Î¼Î¿Î½Î¬Î´Î±',0),(456754,12688,'zh','ç¼–è¾‘é”€å”®/è®¡ä»·å•ä½',0),(456755,12688,'sv','Redigera fÃ¶rsÃ¤ljning/prissÃ¤ttning enhet',0),(456756,12688,'it','Modifica dei prezzi di vendita/unitÃ ',0),(456757,12688,'tl','',0),(456758,12688,'th','à¹à¸à¹‰à¹„à¸‚à¸«à¸™à¹ˆà¸§à¸¢à¸à¸²à¸£à¸‚à¸²à¸¢/à¸£à¸²à¸„à¸²',0),(456759,12688,'hi','à¤‡à¤•à¤¾à¤ˆ à¤µà¤¿à¤•à¥à¤°à¤¯/à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(456760,12688,'ms','Edit Unit jualan/harga',0),(456761,12688,'ar','ØªØ­Ø±ÙŠØ± ÙˆØ­Ø¯Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª/Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(456762,12688,'fr','Modifier l\'unitÃ© de vente/prix',0),(456763,12688,'jp','è²©å£²/ä¾¡æ ¼å˜ä½ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(456764,12688,'pt','Editar unidade vendas/preÃ§os',0),(456765,12688,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð±Ð»Ð¾ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¸ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(456766,12688,'es','Editar Ventas/Unidad de Precios',0),(456767,12688,'de','Verkauf/Preise Einheit bearbeiten',0),(456768,12688,'en','Edit Sales/Pricing Unit',0),(456769,12689,'is','',0),(456770,12689,'dr','Ø¨Ø§Ø±Ú¯Ø°Ø§Ø±ÛŒ ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø¨Ø±Ø§ÛŒ ',0),(456771,12689,'pr','Ø¨Ø§Ø±Ú¯Ø°Ø§Ø±ÛŒ ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ø¨Ø±Ø§ÛŒ ',0),(456772,12689,'tr','DÃ¼kkan iÃ§in yÃ¼kleme',0),(456773,12689,'pl','Sklep dla',0),(456774,12689,'bg','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Ð·Ð° Ð·Ð°Ñ€ÐµÐ¶Ð´Ð°Ð½Ðµ Ð·Ð°',0),(456775,12689,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù„ÙˆÚˆ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(456776,12689,'sr','Ð Ð°Ð´ÑšÐ° ÑƒÑ‡Ð¸Ñ‚Ð°Ð²Ð°ÑšÐ° Ð·Ð°',0),(456777,12689,'vi','Táº£i cá»­a hÃ ng cho',0),(456778,12689,'af','Winkel laai vir',0),(456779,12689,'ro','Magazin de Ã®ncÄƒrcare pentru',0),(456780,12689,'et','Kauplus laadimisel',0),(456781,12689,'si','Tovor za shop',0),(456782,12689,'ba','Toko Loading untuk',0),(456783,12689,'nl','Productieverdeling voor',0),(456784,12689,'fi','Shop lataaminen',0),(456785,12689,'no','Shop lasting',0),(456786,12689,'da','Produktionsbelastning for',0),(456787,12689,'ko','ê°€ ê²Œì— ëŒ€ í•œ ë¡œë“œ',0),(456788,12689,'he','×—× ×•×ª ×¢×‘×•×¨',0),(456789,12689,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± Ï†ÏŒÏÏ„Ï‰ÏƒÎ·Ï‚ Î³Î¹Î±',0),(456790,12689,'zh','è½½å…¥è´­ç‰©',0),(456791,12689,'sv','Butik fÃ¶r',0),(456792,12689,'it','Negozio di carico per',0),(456793,12689,'tl','',0),(456794,12689,'th','à¸£à¹‰à¸²à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¹‚à¸«à¸¥à¸”',0),(456795,12689,'hi','à¤¦à¥à¤•à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥‹à¤¡ à¤¹à¥‹ à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(456796,12689,'ms','Kedai yang memuatkan untuk',0),(456797,12689,'ar','ØªØ­Ù…ÙŠÙ„ Ù„Ù„Ù…Ø­Ù„',0),(456798,12689,'fr','Magasin de chargement pour',0),(456799,12689,'jp','ã‚·ãƒ§ãƒƒãƒ—ã®èª­ã¿è¾¼ã¿',0),(456800,12689,'pt','Loja de carregamento para',0),(456801,12689,'ru','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð´Ð»Ñ',0),(456802,12689,'es','Taller Cargando Para',0),(456803,12689,'de','Shop fÃ¼r be-',0),(456804,12689,'en','Shop Loading for',0),(456805,12690,'is','',0),(456806,12690,'dr','Ù…Ø¯ÛŒØ±ÛŒØª Ø«Ø¨Øª Ù†Ø§Ù… Ø§Ú©Ù†ÙˆÙ† Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(456807,12690,'pr','Ù…Ø¯ÛŒØ±ÛŒØª Ø«Ø¨Øª Ù†Ø§Ù… Ø§Ú©Ù†ÙˆÙ† Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(456808,12690,'tr','Abonelik yÃ¶netimi ÅŸu anda kullanÄ±labilir deÄŸil',0),(456809,12690,'pl','ZarzÄ…dzanie PrenumeratÄ… nie dostÄ™pne w tej chwili',0),(456810,12690,'bg','ÐÐ±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ðµ ÑÐ° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸ Ð¿Ð¾ Ñ‚Ð¾Ð²Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(456811,12690,'ur','Ø±Ú©Ù†ÛŒØª Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ø§Ø³ ÙˆÙ‚Øª Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº ÛÛ’',0),(456812,12690,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ð¾Ð¼ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ Ñƒ Ð¾Ð²Ð¾Ð¼ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚ÐºÑƒ',0),(456813,12690,'vi','ÄÄƒng kÃ½ quáº£n lÃ½ khÃ´ng cÃ³ sáºµn táº¡i thá»i Ä‘iá»ƒm nÃ y',0),(456814,12690,'af','Intekengeld bestuur nie beskikbaar op hierdie tydstip',0),(456815,12690,'ro','Abonament de Management nu sunt disponibile Ã®n acest moment',0),(456816,12690,'et','Tellimuste haldus pole hetkel saadaval',0),(456817,12690,'si','Upravljanje naroÄnine ni na voljo v tem trenutku',0),(456818,12690,'ba','Berlangganan tidak tersedia saat ini',0),(456819,12690,'nl','Beheer van het abonnement niet beschikbaar op dit moment',0),(456820,12690,'fi','Tilausten hallinta ei ole kÃ¤ytettÃ¤vissÃ¤ tÃ¤llÃ¤ hetkellÃ¤',0),(456821,12690,'no','Abonnementsadministrasjon ikke tilgjengelig for Ã¸yeblikket',0),(456822,12690,'da','Abonnement Management ikke tilgÃ¦ngelig pÃ¥ dette tidspunkt',0),(456823,12690,'ko','ì´ ì‹œê°„ì— ì‚¬ìš©í•  ìˆ˜ ì—†ëŠ” êµ¬ë… ê´€ë¦¬',0),(456824,12690,'he','× ×™×”×•×œ ×ž× ×•×™×™× ×œ× ×–×ž×™×Ÿ ×›×¨×’×¢',0),(456825,12690,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· ÏƒÏ…Î½Î´ÏÎ¿Î¼ÏŽÎ½ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Î±Ï…Ï„Î® Ï„Î· ÏƒÏ„Î¹Î³Î¼Î®',0),(456826,12690,'zh','æ­¤æ—¶ä¼šè´¹ç®¡ç†ä¸å¯ç”¨',0),(456827,12690,'sv','Prenumerationshantering inte tillgÃ¤nglig vid denna tid',0),(456828,12690,'it','Gestione degli abbonamenti non disponibile in questo momento',0),(456829,12690,'tl','',0),(456830,12690,'th','à¸ˆà¸±à¸”à¸à¸²à¸£à¸šà¸­à¸à¹„à¸¡à¹ˆà¸§à¹ˆà¸²à¸‡à¹ƒà¸™à¸‚à¸“à¸°à¸™à¸µà¹‰',0),(456831,12690,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤‡à¤¸ à¤¸à¤®à¤¯ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(456832,12690,'ms','Pengurusan langganan tidak tersedia buat masa ini',0),(456833,12690,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ ØºÙŠØ± Ù…ØªÙˆÙØ±Ø© ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„ÙˆÙ‚Øª',0),(456834,12690,'fr','Gestion des abonnements non disponible en ce moment',0),(456835,12690,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ç®¡ç†ã¯ã“ã®æ™‚ç‚¹ã§',0),(456836,12690,'pt','GestÃ£o de subscriÃ§Ã£o nÃ£o estÃ¡ disponÃ­vel neste momento',0),(456837,12690,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð½Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ð´Ð»Ñ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ°Ð¼Ð¸',0),(456838,12690,'es','gestiÃ³n de SuscripciÃ³n No esta Disponible en Este Momento',0),(456839,12690,'de','Abonnementverwaltung diesmal nicht vorhanden',0),(456840,12690,'en','Subscription Management Not Available At This Time',0),(456841,12691,'is','',0),(456842,12691,'dr','Ù…Ø­Ù„ Ù‚ÙØ³Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(456843,12691,'pr','Ù…Ø­Ù„ Ù‚ÙØ³Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(456844,12691,'tr','Bin/raf konumu',0),(456845,12691,'pl','Lokalizacja bin/pÃ³Å‚ka',0),(456846,12691,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¡Ðš/ÑÑ‚ÐµÐ»Ð°Ð¶',0),(456847,12691,'ur','Ø¨Ù†/Ø´ÛŒÙ„Ù Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(456848,12691,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð‘Ð¸Ð½/Ð¿Ð¾Ð»Ð¸Ñ†Ð°',0),(456849,12691,'vi','Vá»‹ trÃ­ sá»t rÃ¡c/ ká»‡ sÃ¡ch',0),(456850,12691,'af','Asblik/rak ligging',0),(456851,12691,'ro','LocaÅ£ie bin/raft',0),(456852,12691,'et','Bin/riiuli kohta',0),(456853,12691,'si','Mesta regal/polica',0),(456854,12691,'ba','Lokasi bin rak',0),(456855,12691,'nl','Bin/plank locatie',0),(456856,12691,'fi','Bin/hylly sijainti',0),(456857,12691,'no','Bin/sokkel plassering',0),(456858,12691,'da','Bin/hylde placering',0),(456859,12691,'ko','ë¹ˆ/ì„ ë°˜ ìœ„ì¹˜',0),(456860,12691,'he','×ž×™×§×•× ×¡×œ ××• ×ž×“×£',0),(456861,12691,'el','Bin/ÏÎ¬Ï†Î¹ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(456862,12691,'zh','è£…è®¢/è´§æž¶ä½ç½®',0),(456863,12691,'sv','Bin/hylla lÃ¤ge',0),(456864,12691,'it','Posizione di bin/mensola',0),(456865,12691,'tl','',0),(456866,12691,'th','à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸Šà¹ˆà¸­à¸‡à¹€à¸à¹‡à¸š/à¸Šà¸±à¹‰à¸™',0),(456867,12691,'hi','à¤¬à¤¿à¤¨/à¤¶à¥‡à¤²à¥à¤« à¤¸à¥à¤¥à¤¾à¤¨',0),(456868,12691,'ms','Lokasi bin/rak',0),(456869,12691,'ar','Ù…ÙˆÙ‚Ø¹ Ø¨Ù†/Ø§Ù„Ø¬Ø±Ù',0),(456870,12691,'fr','Emplacement de l\'Ã©tagÃ¨re/bin',0),(456871,12691,'jp','ç®±/æ£šã®å ´æ‰€',0),(456872,12691,'pt','LocalizaÃ§Ã£o de bin/prateleira',0),(456873,12691,'ru','ÐœÐµÑÑ‚Ð¾Ð½Ð°Ñ…Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð±Ð¸Ð½/Ð¿Ð¾Ð»ÐºÐ°',0),(456874,12691,'es','LocaciÃ³n de Recipiente/Estante',0),(456875,12691,'de','Bin/Regal-Lage',0),(456876,12691,'en','Bin/Shelf Location',0),(456877,12692,'is','',0),(456878,12692,'dr','Ù†Ù…Ø§ÛŒØ´ ÙˆØ¶Ø¹ÛŒØª ÙØ§Ú©ØªÙˆØ±',0),(456879,12692,'pr','Ù†Ù…Ø§ÛŒØ´ ÙˆØ¶Ø¹ÛŒØª ÙØ§Ú©ØªÙˆØ±',0),(456880,12692,'tr','Fatura durumu gÃ¶ster',0),(456881,12692,'pl','PokaÅ¼ stan faktury',0),(456882,12692,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð¹ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°',0),(456883,12692,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø­Ø§Ù„Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(456884,12692,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(456885,12692,'vi','Thá»ƒ hiá»‡n tÃ¬nh tráº¡ng cá»§a hÃ³a Ä‘Æ¡n',0),(456886,12692,'af','Faktuur Status te wys',0),(456887,12692,'ro','StÃ£rii de facturÄƒ',0),(456888,12692,'et','NÃ¤ita arve olek',0),(456889,12692,'si','PrikaÅ¾i stanje raÄuna',0),(456890,12692,'ba','Menunjukkan Status faktur',0),(456891,12692,'nl','Toon Factuurstatus',0),(456892,12692,'fi','NÃ¤ytÃ¤ laskun tila',0),(456893,12692,'no','Vis Fakturastatus',0),(456894,12692,'da','Vis Fakturastatus',0),(456895,12692,'ko','ì†¡ìž¥ ìƒíƒœ ë³´ê¸°',0),(456896,12692,'he','×”×¦×’ ×ž×¦×‘ ×—×©×‘×•× ×™×ª',0),(456897,12692,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(456898,12692,'zh','æ˜¾ç¤ºå‘ç¥¨çŠ¶æ€',0),(456899,12692,'sv','Visa fakturastatus',0),(456900,12692,'it','Mostrare lo stato di fattura',0),(456901,12692,'tl','',0),(456902,12692,'th','à¹à¸ªà¸”à¸‡à¸ªà¸–à¸²à¸™à¸°à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(456903,12692,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(456904,12692,'ms','Tayang Status invois',0),(456905,12692,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø­Ø§Ù„Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(456906,12692,'fr','Afficher l\'Ã©tat de la facture',0),(456907,12692,'jp','è«‹æ±‚æ›¸ã®çŠ¶æ…‹ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(456908,12692,'pt','Mostrar Status da fatura',0),(456909,12692,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ‚Ð°Ñ‚ÑƒÑ ÑÑ‡ÐµÑ‚Ð°',0),(456910,12692,'es','Muestra Estatus de Factura',0),(456911,12692,'de','Rechnungsstatus anzeigen',0),(456912,12692,'en','Show Invoice Status',0),(456913,12693,'is','',0),(456914,12693,'dr','ÙˆÛŒÚ˜Ú¯ÛŒ',0),(456915,12693,'pr','ÙˆÛŒÚ˜Ú¯ÛŒ',0),(456916,12693,'tr','GeleceÄŸi',0),(456917,12693,'pl','PrzyszÅ‚oÅ›Ä‡',0),(456918,12693,'bg','Ð‘ÑŠÐ´ÐµÑ‰ÐµÑ‚Ð¾',0),(456919,12693,'ur','Ù…Ø³ØªÙ‚Ø¨Ù„',0),(456920,12693,'sr','Ð‘ÑƒÐ´ÑƒÑ›Ð½Ð¾ÑÑ‚',0),(456921,12693,'vi','tÆ°Æ¡ng lai',0),(456922,12693,'af','Toekoms',0),(456923,12693,'ro','Viitorul',0),(456924,12693,'et','Tulevik',0),(456925,12693,'si','Prihodnost',0),(456926,12693,'ba','Masa depan',0),(456927,12693,'nl','Toekomst',0),(456928,12693,'fi','Tulevaisuuden',0),(456929,12693,'no','Fremtiden',0),(456930,12693,'da','Fremtid',0),(456931,12693,'ko','ë¯¸ëž˜',0),(456932,12693,'he','×”×¢×ª×™×“',0),(456933,12693,'el','ÎœÎ­Î»Î»Î¿Î½',0),(456934,12693,'zh','æœªæ¥',0),(456935,12693,'sv','Framtid',0),(456936,12693,'it','Futuro',0),(456937,12693,'tl','',0),(456938,12693,'th','à¹ƒà¸™à¸­à¸™à¸²à¸„à¸•',0),(456939,12693,'hi','à¤­à¤µà¤¿à¤·à¥à¤¯',0),(456940,12693,'ms','Masa depan',0),(456941,12693,'ar','Ø§Ù„Ù…Ø³ØªÙ‚Ø¨Ù„',0),(456942,12693,'fr','Avenir',0),(456943,12693,'jp','æœªæ¥',0),(456944,12693,'pt','Futuro',0),(456945,12693,'ru','Ð‘ÑƒÐ´ÑƒÑ‰ÐµÐµ',0),(456946,12693,'es','Futuro',0),(456947,12693,'de','Zukunft',0),(456948,12693,'en','Future',0),(456949,12694,'is','',0),(456950,12694,'dr','Ø§Ø´ØªØ±Ø§Ú©Ø§Øª',0),(456951,12694,'pr','Ø§Ø´ØªØ±Ø§Ú©Ø§Øª',0),(456952,12694,'tr','Abonelikleri',0),(456953,12694,'pl','Subskrypcje',0),(456954,12694,'bg','ÐÐ±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚Ð¸',0),(456955,12694,'ur','Ù…Ù…Ø¨Ø±Ø´Ù¾',0),(456956,12694,'sr','ÐŸÑ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(456957,12694,'vi','ÄÄƒng kÃ½',0),(456958,12694,'af','Intekeninge',0),(456959,12694,'ro','Abonamente',0),(456960,12694,'et','Tellimine',0),(456961,12694,'si','NaroÄnine',0),(456962,12694,'ba','Langganan',0),(456963,12694,'nl','Abonnementen',0),(456964,12694,'fi','Tilaukset',0),(456965,12694,'no','Abonnementer',0),(456966,12694,'da','Abonnementer',0),(456967,12694,'ko','êµ¬ë…',0),(456968,12694,'he','×ž× ×•×™×™×',0),(456969,12694,'el','Î£Ï…Î½Î´ÏÎ¿Î¼Î­Ï‚',0),(456970,12694,'zh','ä¼šè´¹',0),(456971,12694,'sv','Abonnemang',0),(456972,12694,'it','Abbonamenti',0),(456973,12694,'tl','',0),(456974,12694,'th','à¸šà¸­à¸à¸£à¸±à¸šà¹€à¸›à¹‡à¸™à¸ªà¸¡à¸²à¸Šà¸´à¸',0),(456975,12694,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾à¤à¤',0),(456976,12694,'ms','Langganan',0),(456977,12694,'ar','Ø§Ø´ØªØ±Ø§ÙƒØ§Øª',0),(456978,12694,'fr','Abonnements',0),(456979,12694,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³',0),(456980,12694,'pt','Assinaturas',0),(456981,12694,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐºÐ¸',0),(456982,12694,'es','Suscripciones',0),(456983,12694,'de','Abonnements',0),(456984,12694,'en','Subscriptions',0),(456985,12695,'is','',0),(456986,12695,'dr','Ø®Ø·Ø§ Ø¯Ø± Ú¯Ø±ÙØªÙ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÛŒØ¯Ø§Ø±',0),(456987,12695,'pr','Ø®Ø·Ø§ Ø¯Ø± Ú¯Ø±ÙØªÙ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÛŒØ¯Ø§Ø±',0),(456988,12695,'tr','MÃ¼ÅŸteri bilgileri alÄ±nÄ±rken hata oluÅŸtu',0),(456989,12695,'pl','Uzyskanie informacji o bÅ‚Ä™dzie klienta',0),(456990,12695,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(456991,12695,'ur','Ù†Ù‚Øµ Ø­ØµÙˆÙ„ Ú¯Ø§ÛÚ© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(456992,12695,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð´Ð¾Ð±Ð¸Ñ˜Ð°ÑšÑƒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐºÑƒÐ¿Ñ†Ñƒ',0),(456993,12695,'vi','Lá»—i khi láº¥y thÃ´ng tin khÃ¡ch hÃ ng',0),(456994,12695,'af','Fout om kliÃ«nte-inligting',0),(456995,12695,'ro','Obtinerea de informatii despre clienti eroare',0),(456996,12695,'et','Viga saada kliendiinfo',0),(456997,12695,'si','Napaka pridobivanje podatkov o strankah',0),(456998,12695,'ba','Informasi nasabah mendapatkan kesalahan',0),(456999,12695,'nl','Fout krijgen klantgegevens',0),(457000,12695,'fi','Virhe haettaessa asiakkaan tietoja',0),(457001,12695,'no','Feil komme kundeinformasjon',0),(457002,12695,'da','Fejl at fÃ¥ kundeoplysninger',0),(457003,12695,'ko','ì˜¤ë¥˜ ê°€ì ¸ì˜¤ëŠ” ê³ ê° ì •ë³´',0),(457004,12695,'he','×¤×¨×˜×™ ×”×œ×§×•×— ×ž×§×‘×œ ×©×’×™××”',0),(457005,12695,'el','ÎÎ± Ï€Î¬ÏÎµÎ¹ Ï€ÎµÎ»Î¬Ï„Î· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚',0),(457006,12695,'zh','é”™è¯¯èŽ·å¾—å®¢æˆ·ä¿¡æ¯',0),(457007,12695,'sv','Fel att fÃ¥ kundinformation',0),(457008,12695,'it','Errore ricevendo informazioni cliente',0),(457009,12695,'tl','',0),(457010,12695,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸£à¸±à¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(457011,12695,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¹à¥‹ à¤°à¤¹à¥€ à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(457012,12695,'ms','Maklumat pelanggan mendapat ralat',0),(457013,12695,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(457014,12695,'fr','Error Getting informations client',0),(457015,12695,'jp','é¡§å®¢æƒ…å ±ã®å–å¾—ã‚¨ãƒ©ãƒ¼',0),(457016,12695,'pt','InformaÃ§Ãµes sobre o cliente a erro',0),(457017,12695,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð¼ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸',0),(457018,12695,'es','Error Conseguiendo InformaciÃ³n de Cliente',0),(457019,12695,'de','Fehler immer Kundeninformationen',0),(457020,12695,'en','Error Getting Customer Information',0),(457021,12696,'is','',0),(457022,12696,'dr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(457023,12696,'pr','Ø®Ø·Ø§ ÙŠ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÙŠ ÙƒØ±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®Ø±ÙŠØ¯Ø§Ø± ',0),(457024,12696,'tr','Hata gÃ¼ncelleÅŸtirme mÃ¼ÅŸteri bilgileri',0),(457025,12696,'pl','BÅ‚Ä…d aktualizacji informacji o klientach',0),(457026,12696,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑÑ‚Ð° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(457027,12696,'ur','Ù†Ù‚Øµ Ú¯Ø§ÛÚ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(457028,12696,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐºÑƒÐ¿Ñ†Ñƒ',0),(457029,12696,'vi','LÃ´i khi cáº­p nháº­t thÃ´ng tin khÃ¡ch hÃ ng',0),(457030,12696,'af','Fout Outobywerking kliÃ«nt inligting',0),(457031,12696,'ro','Eroare actualizarea informaÅ£iilor despre clienÅ£i',0),(457032,12696,'et','Viga ajakohastamine kliendiinfo',0),(457033,12696,'si','Napaka aÅ¾uriranje podatkov o strankah',0),(457034,12696,'ba','Kesalahan update informasi pelanggan',0),(457035,12696,'nl','Fout bijwerken klantgegevens',0),(457036,12696,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ asiakastiedot',0),(457037,12696,'no','Feil oppdatering kundeinformasjon',0),(457038,12696,'da','Fejl opdatering kundeoplysninger',0),(457039,12696,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ê³ ê° ì •ë³´',0),(457040,12696,'he','×©×’×™××” ×¢×“×›×•×Ÿ ×¤×¨×˜×™ ×œ×§×•×—',0),(457041,12696,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÎµÎ»Î¬Ï„Î· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚',0),(457042,12696,'zh','é”™è¯¯æ›´æ–°å®¢æˆ·ä¿¡æ¯',0),(457043,12696,'sv','Fel uppdatera kundinformation',0),(457044,12696,'it','Errore aggiornamento informazioni cliente',0),(457045,12696,'tl','',0),(457046,12696,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(457047,12696,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(457048,12696,'ms','Ralat pengemaskinian maklumat pelanggan',0),(457049,12696,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(457050,12696,'fr','Erreur mise Ã  jour client Information',0),(457051,12696,'jp','é¡§å®¢æƒ…å ±ã®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(457052,12696,'pt','Erro Atualizando informaÃ§Ãµes de clientes',0),(457053,12696,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(457054,12696,'es','Error Actualizando InformaciÃ³n de Cliente',0),(457055,12696,'de','Fehler Aktualisierung Kundendaten',0),(457056,12696,'en','Error Updating Customer Information',0),(457057,12697,'is','',0),(457058,12697,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø³ØªÙ‡',0),(457059,12697,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø¨Ø³ØªÙ‡',0),(457060,12697,'tr','# Paketleri',0),(457061,12697,'pl','# Pakiety',0),(457062,12697,'bg','# ÐžÐ¿Ð°ÐºÐ¾Ð²ÐºÐ¸',0),(457063,12697,'ur','# Ù¾ÛŒÚ©Ø¬Ø²',0),(457064,12697,'sr','# ÐŸÐ°ÐºÐµÑ‚Ð¸',0),(457065,12697,'vi','# bÆ°u kiá»‡n/ thÃ¹ng hÃ ng',0),(457066,12697,'af','# Pakkette',0),(457067,12697,'ro','# Pachete',0),(457068,12697,'et','# Paketid',0),(457069,12697,'si','# Paketi',0),(457070,12697,'ba','# Paket',0),(457071,12697,'nl','# Pakketten',0),(457072,12697,'fi','# Paketit',0),(457073,12697,'no','# Pakker',0),(457074,12697,'da','# Pakker',0),(457075,12697,'ko','# íŒ¨í‚¤ì§€',0),(457076,12697,'he','# ×—×‘×™×œ×•×ª',0),(457077,12697,'el','# Î Î±ÎºÎ­Ï„Î±',0),(457078,12697,'zh','#åŒ…è£¹',0),(457079,12697,'sv','# Paket',0),(457080,12697,'it','# Pacchetti',0),(457081,12697,'tl','',0),(457082,12697,'th','# à¹à¸žà¸„à¹€à¸à¸ˆ',0),(457083,12697,'hi','# à¤¸à¤‚à¤•à¥à¤²',0),(457084,12697,'ms','# Pakej-pakej',0),(457085,12697,'ar','# Ø§Ù„Ø­Ø²Ù…',0),(457086,12697,'fr','# Paquets',0),(457087,12697,'jp','ï¼ƒ ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸',0),(457088,12697,'pt','# Pacotes',0),(457089,12697,'ru','# ÐŸÐ°ÐºÐµÑ‚Ñ‹',0),(457090,12697,'es','# Paquetes',0),(457091,12697,'de','# Pakete',0),(457092,12697,'en','# Packages',0),(457093,12698,'is','',0),(457094,12698,'dr','Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª ØªÙˆÙ„ÙŠØ¯ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± \r\n\r\n',0),(457095,12698,'pr','Ø³ÙŠØ³ØªÙ… Ù…Ø¯ÙŠØ±ÙŠØª ØªÙˆÙ„ÙŠØ¯ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± \r\n\r\n',0),(457096,12698,'tr','PMS #',0),(457097,12698,'pl','PMS #',0),(457098,12698,'bg','PMS #',0),(457099,12698,'ur','ÙˆØ²Ø±Ø§Ø¦Û’ Ø§Ø¹Ø¸Ù… Ú©Ø§ #',0),(457100,12698,'sr','ÐŸÐœÐ¡ #',0),(457101,12698,'vi','PMS #',0),(457102,12698,'af','PMS #',0),(457103,12698,'ro','PMS #',0),(457104,12698,'et','PMS #',0),(457105,12698,'si','PMS #',0),(457106,12698,'ba','PMS #',0),(457107,12698,'nl','PMS #',0),(457108,12698,'fi','PMS #',0),(457109,12698,'no','PMS #',0),(457110,12698,'da','PMS #',0),(457111,12698,'ko','PMS #',0),(457112,12698,'he','×ª×¡×ž×•× ×ª ×§×“× ×•×¡×ª×™×ª #',0),(457113,12698,'el','PMS #',0),(457114,12698,'zh','â€œå½©é€šé…è‰²ç³»ç»Ÿâ€œ#',0),(457115,12698,'sv','PMS #',0),(457116,12698,'it','PMS #',0),(457117,12698,'tl','',0),(457118,12698,'th','à¸­à¸²à¸à¸²à¸£à¸™à¸µà¹‰#',0),(457119,12698,'hi','à¤ªà¥€à¤à¤®à¤à¤¸ #',0),(457120,12698,'ms','PMS #',0),(457121,12698,'ar','Ø§Ù„Ø¯ÙˆØ±Ø© Ø§Ù„Ø´Ù‡Ø±ÙŠØ© #',0),(457122,12698,'fr','PMS #',0),(457123,12698,'jp','PM #',0),(457124,12698,'pt','PMS #',0),(457125,12698,'ru','PMS #',0),(457126,12698,'es','PMS #',0),(457127,12698,'de','PMS #',0),(457128,12698,'en','PMS #',0),(457129,12699,'is','',0),(457130,12699,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ',0),(457131,12699,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ',0),(457132,12699,'tr','Teklif #',0),(457133,12699,'pl','Cytat #',0),(457134,12699,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° #',0),(457135,12699,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ #',0),(457136,12699,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ #',0),(457137,12699,'vi','BÃ¡o giÃ¡ sá»‘',0),(457138,12699,'af','Kwotasie #',0),(457139,12699,'ro','Citat #',0),(457140,12699,'et','Tsiteeri #',0),(457141,12699,'si','Citiram #',0),(457142,12699,'ba','Mengutip #',0),(457143,12699,'nl','Citeer #',0),(457144,12699,'fi','Lainata #',0),(457145,12699,'no','Sitere #',0),(457146,12699,'da','Citere #',0),(457147,12699,'ko','# ì¸ìš©',0),(457148,12699,'he','×¦×™×˜×•×˜ #',0),(457149,12699,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ #',0),(457150,12699,'zh','æŠ¥ä»·#',0),(457151,12699,'sv','Citera #',0),(457152,12699,'it','Citazione #',0),(457153,12699,'tl','',0),(457154,12699,'th','à¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²#',0),(457155,12699,'hi','à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ #',0),(457156,12699,'ms','Quote #',0),(457157,12699,'ar','Ø§Ù‚ØªØ¨Ø§Ø³ #',0),(457158,12699,'fr','Cite #',0),(457159,12699,'jp','ï¼ƒ ã‚’å¼•ç”¨ã—ã¾ã™ã€‚',0),(457160,12699,'pt','CitaÃ§Ã£o #',0),(457161,12699,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° #',0),(457162,12699,'es','CotizaciÃ³n #',0),(457163,12699,'de','Zitat #',0),(457164,12699,'en','Quote #',0),(457165,12700,'is','',0),(457166,12700,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø°Ø®ÛŒØ±Ù‡ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø±Ø§Ø¬Ù‡Øª Ø­ÙØ¸ ØªØºÛŒÛŒØ±Ø§Øª Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(457167,12700,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø°Ø®ÛŒØ±Ù‡ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ Ø±Ø§Ø¬Ù‡Øª Ø­ÙØ¸ ØªØºÛŒÛŒØ±Ø§Øª Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(457168,12700,'tr','Sen-meli tÄ±kÄ±rtÄ± kurtarmak deÄŸiÅŸiklikleri tutmak iÃ§in alÄ±ntÄ±.',0),(457169,12700,'pl','NaleÅ¼y kliknÄ…Ä‡ przycisk Zapisz cytat zachowaÄ‡ zmiany.',0),(457170,12700,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ Ð·Ð° Ð´Ð° Ð·Ð°Ð¿Ð°Ð·Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ.',0),(457171,12700,'ur','Ø¢Ù¾ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§Ù‚ØªØ¨Ø§Ø³ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(457172,12700,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ ÐºÐ»Ð¸ÐºÐ½ÑƒÑ‚Ð¸ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ñ‚Ð¸ Ð´Ð° Ð·Ð°Ð´Ñ€Ð¶Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ.',0),(457173,12700,'vi','Báº¡n pháº£i nháº¥p vÃ o nÃºt LÆ°u Ä‘á»ƒ giá»¯ cÃ¡c thay Ä‘á»•i',0),(457174,12700,'af','U moet Stoor Kwotasie kliek om veranderinge te behou.',0),(457175,12700,'ro','Tu trebuie sÄƒ faceÅ£i clic pe SalvaÅ£i citat pentru a pÄƒstra schimbÄƒrile.',0),(457176,12700,'et','KlÃµpsake Salvesta tsitaat muudatused sÃ¤ilitada.',0),(457177,12700,'si','Kliknite Shrani citiram, da spremembe.',0),(457178,12700,'ba','Anda harus mengklik Simpan kutipan untuk menyimpan perubahan.',0),(457179,12700,'nl','U moet klikt u op Opslaan citeren om te houden van wijzigingen.',0),(457180,12700,'fi','Valitse Tallenna lainata muutokset.',0),(457181,12700,'no','Du mÃ¥ klikke Lagre siterer Ã¥ beholde endringene.',0),(457182,12700,'da','Du skal klikke pÃ¥ Gem tilbud for at holde Ã¦ndringer.',0),(457183,12700,'ko','ë³€ê²½ ë‚´ìš©ì„ ìœ ì§€ í•˜ë ¤ë©´ ì¸ìš© ì €ìž¥ì„ í´ë¦­ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(457184,12700,'he','×¢×œ×™×š ×œ×œ×—×•×¥ ×¢×œ ×©×ž×•×¨ ×œ×¦×˜×˜ ×œ×©×ž×•×¨ ×©×™× ×•×™×™×.',0),(457185,12700,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± ÎºÎ¬Î½ÎµÏ„Îµ ÎºÎ»Î¹Îº Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï€Î±ÏÎ±Î¸Î­ÏƒÏ‰ Î³Î¹Î± Î½Î± ÎºÏÎ±Ï„Î®ÏƒÎµÎ¹ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚.',0),(457186,12700,'zh','ä½ å¿…é¡»ç‚¹å‡»ä¿å­˜æŠ¥ä»·ä»¥ä¿å­˜æ›´æ”¹ã€‚',0),(457187,12700,'sv','Du mÃ¥ste klicka pÃ¥ Spara citerar att spara Ã¤ndringar.',0),(457188,12700,'it','Ãˆ necessario fare clic Salva citare per mantenere le modifiche.',0),(457189,12700,'tl','',0),(457190,12700,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸„à¸¥à¸´à¸à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸ªà¸™à¸­à¹ƒà¸«à¹‰à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(457191,12700,'hi','à¤†à¤ª à¤¬à¥‹à¤²à¥€ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨à¥‹à¤‚ à¤•à¥‹ à¤¬à¤¨à¤¾à¤ à¤°à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(457192,12700,'ms','Anda mesti klik Simpan Quote untuk menyimpan perubahan.',0),(457193,12700,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø§Ù„Ù†Ù‚Ø± ÙÙˆÙ‚ \"Ø­ÙØ¸ Ø§Ù‚ØªØ¨Ø³\" Ø§Ù„Ø§Ø­ØªÙØ§Ø¸ Ø¨Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª.',0),(457194,12700,'fr','Vous devez cliquer sur Enregistrer citer pour conserver les modifications.',0),(457195,12700,'jp','å¤‰æ›´ã‚’ä¿æŒã™ã‚‹å¼•ç”¨ã‚’ä¿å­˜ã‚’ã‚¯ãƒªãƒƒã‚¯ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(457196,12700,'pt','VocÃª deve clicar em salvar citar para manter as alteraÃ§Ãµes.',0),(457197,12700,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð½Ð°Ð¶Ð°Ñ‚ÑŒ ÐºÐ½Ð¾Ð¿ÐºÑƒ Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ.',0),(457198,12700,'es','Debe hacer clik en Guardar CotizaciÃ³n para retener los cambios.',0),(457199,12700,'de','Sie mÃ¼ssen klicken, speichern Sie zitieren, um Ã„nderungen zu erhalten.',0),(457200,12700,'en','You must click Save Quote to keep changes.',0),(457201,12701,'is','',0),(457202,12701,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø®Ø±ÛŒØ¯Ø§Ø±',0),(457203,12701,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø®Ø±ÛŒØ¯Ø§Ø±',0),(457204,12701,'tr','MÃ¼ÅŸteri #',0),(457205,12701,'pl','Klient #',0),(457206,12701,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ #',0),(457207,12701,'ur','Ú©Ø³Ù¹Ù…Ø± #',0),(457208,12701,'sr','ÐšÑƒÐ¿Ð°Ñ† #',0),(457209,12701,'vi','khÃ¡ch hÃ ng #',0),(457210,12701,'af','KliÃ«nt #',0),(457211,12701,'ro','Client #',0),(457212,12701,'et','Kliendi #',0),(457213,12701,'si','Kupec #',0),(457214,12701,'ba','Pelanggan #',0),(457215,12701,'nl','Klant #',0),(457216,12701,'fi','Asiakas #',0),(457217,12701,'no','Kunden #',0),(457218,12701,'da','Kunde #',0),(457219,12701,'ko','ê³ ê° #',0),(457220,12701,'he','×œ×§×•×— #',0),(457221,12701,'el','Î ÎµÎ»Î¬Ï„Î· #',0),(457222,12701,'zh','å®¢æˆ· #',0),(457223,12701,'sv','Kunden #',0),(457224,12701,'it','Cliente #',0),(457225,12701,'tl','',0),(457226,12701,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²#',0),(457227,12701,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• #',0),(457228,12701,'ms','Baca #',0),(457229,12701,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ #',0),(457230,12701,'fr','Client #',0),(457231,12701,'jp','é¡§å®¢ #',0),(457232,12701,'pt','Cliente #',0),(457233,12701,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ #',0),(457234,12701,'es','Cliente #',0),(457235,12701,'de','Kunden #',0),(457236,12701,'en','Customer #',0),(457237,12702,'is','',0),(457238,12702,'dr','Ù¾Ø³ÙˆØ±Ø¯ Ø¯Ø± Ø·ÛŒ Ø«Ø¨Øª Ù†Ø§Ù… Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯  ',0),(457239,12702,'pr','Ù¾Ø³ÙˆØ±Ø¯ Ø¯Ø± Ø·ÛŒ Ø«Ø¨Øª Ù†Ø§Ù… Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯  ',0),(457240,12702,'tr','KayÄ±t sÄ±rasÄ±nda oluÅŸturulan ÅŸifre',0),(457241,12702,'pl','HasÅ‚o utworzone podczas rejestracji',0),(457242,12702,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð¸ Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(457243,12702,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø³Ø§Ø¦Ù† Ø§Ù¾ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† ØªØ®Ù„ÛŒÙ‚ Ú©ÛŒØ§',0),(457244,12702,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ° ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð° Ñ‚Ð¾ÐºÐ¾Ð¼ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ðµ Ð½Ð°',0),(457245,12702,'vi','Máº­t kháº©u Ä‘Ã£ Ä‘Æ°á»£c táº¡o trong quÃ¡ trÃ¬nh Ä‘Äƒng nháº­p',0),(457246,12702,'af','Wagwoord geskep tydens intekening',0),(457247,12702,'ro','Parolei create Ã®n timpul Ã®nscriere',0),(457248,12702,'et','Registreerumise kÃ¤igus loodud parool',0),(457249,12702,'si','Geslo pri prijavi',0),(457250,12702,'ba','Sandi yang dibuat saat pendaftaran',0),(457251,12702,'nl','Wachtwoord gemaakt tijdens aanmelden',0),(457252,12702,'fi','Aikana kirjautumisen salasana',0),(457253,12702,'no','Passordet opprettet under registreringen',0),(457254,12702,'da','Password skabt under tilmelding',0),(457255,12702,'ko','ê°€ìž… í•˜ëŠ” ë™ì•ˆ ë§Œë“  ì•”í˜¸',0),(457256,12702,'he','×”×¡×™×¡×ž×” ×©× ×•×¦×¨×• ×‘×ž×”×œ×š ×”×”×¦×˜×¨×¤×•×ª',0),(457257,12702,'el','ÎšÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ³Î³ÏÎ±Ï†Î®',0),(457258,12702,'zh','æ³¨å†Œæ—¶å¯†ç åˆ›å»º',0),(457259,12702,'sv','LÃ¶senord skapas under Signup',0),(457260,12702,'it','Password creata durante la registrazione',0),(457261,12702,'tl','',0),(457262,12702,'th','à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸—à¸µà¹ˆà¸ªà¸£à¹‰à¸²à¸‡à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸¥à¸‡à¸—à¸°à¹€à¸šà¸µà¸¢à¸™',0),(457263,12702,'hi','à¤ªà¤‚à¤œà¥€à¤•à¤°à¤£ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¬à¤¨à¤¾à¤ à¤—à¤ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡',0),(457264,12702,'ms','Kata laluan semasa pendaftaran',0),(457265,12702,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø£Ø«Ù†Ø§Ø¡ Ø§Ù„ØªØ³Ø¬ÙŠÙ„',0),(457266,12702,'fr','Mot de passe crÃ©Ã© au cours de l\'inscription',0),(457267,12702,'jp','ç™»éŒ²æ™‚ã«ä½œæˆã—ãŸãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰',0),(457268,12702,'pt','Senha criada durante a inscriÃ§Ã£o',0),(457269,12702,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ, ÑÐ¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ñ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¸',0),(457270,12702,'es','ContraseÃ±a Creada Durante la InscripciÃ³n',0),(457271,12702,'de','Passwort bei der Anmeldung erstellt',0),(457272,12702,'en','Password Created During Signup',0),(457273,12703,'is','',0),(457274,12703,'dr','Ú©Ù…Ú© Ø³Ø±ÛŒØ¹',0),(457275,12703,'pr','Ú©Ù…Ú© Ø³Ø±ÛŒØ¹',0),(457276,12703,'tr','HÄ±zlÄ± yardÄ±m',0),(457277,12703,'pl','Szybka pomoc',0),(457278,12703,'bg','Ð‘ÑŠÑ€Ð·Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰',0),(457279,12703,'ur','ÙÙˆØ±ÛŒ Ù…Ø¯Ø¯',0),(457280,12703,'sr','Ð‘Ñ€Ð·Ð° Ð¿Ð¾Ð¼Ð¾Ñ›',0),(457281,12703,'vi','trá»£ giÃºp nhanh',0),(457282,12703,'af','Vinnige hulp',0),(457283,12703,'ro','Ajutor rapid',0),(457284,12703,'et','Kiiret abi',0),(457285,12703,'si','Hitro pomoÄ',0),(457286,12703,'ba','Bantuan cepat',0),(457287,12703,'nl','Snelle hulp',0),(457288,12703,'fi','Nopeasti apua',0),(457289,12703,'no','Rask hjelp',0),(457290,12703,'da','Hurtig hjÃ¦lp',0),(457291,12703,'ko','ë¹ ë¥¸ ë„ì›€ë§',0),(457292,12703,'he','×¢×–×¨×” ×ž×”×™×¨×”',0),(457293,12703,'el','Î“ÏÎ®Î³Î¿ÏÎ· Î²Î¿Î®Î¸ÎµÎ¹Î±',0),(457294,12703,'zh','å¿«é€Ÿå¸®åŠ©',0),(457295,12703,'sv','Snabb hjÃ¤lp',0),(457296,12703,'it','Aiuto rapido',0),(457297,12703,'tl','',0),(457298,12703,'th','à¸Šà¹ˆà¸§à¸¢à¹€à¸«à¸¥à¸·à¸­à¸”à¹ˆà¸§à¸™',0),(457299,12703,'hi','à¤¤à¥à¤µà¤°à¤¿à¤¤ à¤®à¤¦à¤¦',0),(457300,12703,'ms','Membantu cepat',0),(457301,12703,'ar','Ù…Ø³Ø§Ø¹Ø¯Ø© Ø³Ø±ÙŠØ¹Ø©',0),(457302,12703,'fr','Aide rapide',0),(457303,12703,'jp','ã‚¯ã‚¤ãƒƒã‚¯ ãƒ˜ãƒ«ãƒ—',0),(457304,12703,'pt','Ajuda rÃ¡pida',0),(457305,12703,'ru','Ð‘Ñ‹ÑÑ‚Ñ€Ð°Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒ',0),(457306,12703,'es','Ayuda Rapida',0),(457307,12703,'de','Schnelle Hilfe',0),(457308,12703,'en','Quick Help',0),(457309,12704,'is','',0),(457310,12704,'dr','2',0),(457311,12704,'pr','ÙÙ‚Ø· ÙˆÙ‚ØªÛŒ Ø¨ÛŒØ´ Ø§Ø² ÛŒÚ© Ø¬ÙˆÙ‡Ø± Ø¯Ø± Ø·Ø±Ù 2',0),(457312,12704,'tr','Sadece ne zaman birden fazla mÃ¼rekkep yan iki',0),(457313,12704,'pl','Tylko wtedy, gdy wiÄ™cej niÅ¼ jeden atramentu na stronie dwa',0),(457314,12704,'bg','Ð¡Ð°Ð¼Ð¾ ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð¸Ð½ Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð°, Ð´Ð²Ðµ',0),(457315,12704,'ur','Ø¬Ø¨ ØµØ±Ù Ø§ÛŒÚ© Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù¾Ø± Ø§Ù†Ú© Ø¯Ùˆ Ø·Ø±Ù Ø¯Ø§Ø±ÛŒ',0),(457316,12704,'sr','Ð¡Ð°Ð¼Ð¾ ÐºÐ°Ð´Ð° Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ñ˜ÐµÐ´Ð½Ð¾Ð³ Ð·Ð°Ð¿Ð¸ÑÐ° Ð¿ÐµÑ€Ð¾Ð¼ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð° Ð´Ð²Ð°',0),(457317,12704,'vi','chá»‰ khi má»±c máº·t 1 nhiá»u hÆ¡n máº­t 2',0),(457318,12704,'af','Slegs wanneer meer as een Ink op kant twee',0),(457319,12704,'ro','Numai Ã®n cazul Ã®n care mai multe de cernealÄƒ pe partea de douÄƒ',0),(457320,12704,'et','Ainult Kuna enam kui Ã¼he tindi pool kaks',0),(457321,12704,'si','Le kdaj veÄ Ärnila na strani dva',0),(457322,12704,'ba','Hanya ketika lebih dari satu tinta pada sisi dua',0),(457323,12704,'nl','Alleen wanneer meer dan Ã©Ã©n inkt op kant 2',0),(457324,12704,'fi','Vain silloin, kun useampi kuin yksi muste On puoli',0),(457325,12704,'no','Bare nÃ¥r mer enn Ã©n trykkfarge pÃ¥ Side to',0),(457326,12704,'da','Kun nÃ¥r mere end Ã©n trykfarve pÃ¥ Side to',0),(457327,12704,'ko','í•˜ë‚˜ ì´ìƒì˜ ìž‰í¬ì— ê²½ìš°ì— ë‘ ê°€ì§€ ì¸¡ë©´',0),(457328,12704,'he','×¨×§ ×›××©×¨ ×“×™×• ××—×“ ××• ×™×•×ª×¨ ×¢×œ ×¦×“ ×©× ×™',0),(457329,12704,'el','ÎœÏŒÎ½Î¿ ÏŒÏ„Î±Î½ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ± Î±Ï€ÏŒ Î­Î½Î± Î¼ÎµÎ»Î¬Î½Î¹Î± ÏƒÏ„Î·Î½ Ï€Î»ÎµÏ…ÏÎ¬ Î´ÏÎ¿',0),(457330,12704,'zh','ä»…å½“ä¾§é¢2æœ‰å¤šäºŽä¸€ç§å¢¨æ°´',0),(457331,12704,'sv','Bara nÃ¤r mer Ã¤n en tryckfÃ¤rg pÃ¥ sida tvÃ¥',0),(457332,12704,'it','Solo quando piÃ¹ di un inchiostro sul lato due',0),(457333,12704,'tl','',0),(457334,12704,'th','à¹€à¸¡à¸·à¹ˆà¸­à¸à¸§à¹ˆà¸²à¸«à¸™à¸¶à¹ˆà¸‡à¸«à¸¡à¸¶à¸à¸šà¸™ à¸ªà¸­à¸‡à¸‚à¹‰à¸²à¸‡',0),(457335,12704,'hi','à¤œà¤¬ à¤•à¥‡à¤µà¤² à¤à¤• à¤…à¤§à¤¿à¤• à¤‡à¤‚à¤• à¤ªà¤° à¤¦à¥‹ à¤ªà¤•à¥à¤·',0),(457336,12704,'ms','Hanya apabila lebih daripada satu dakwat pada tepi dua',0),(457337,12704,'ar','ÙÙ‚Ø· Ø¹Ù†Ø¯ ÙˆØ§Ø­Ø¯ Ø£Ùˆ Ø£ÙƒØ«Ø± Ù…Ù† Ø­Ø¨Ø± Ø¹Ù„Ù‰ Ø§Ù„Ø¬Ø§Ù†Ø¨ Ø§Ø«Ù†ÙŠÙ†',0),(457338,12704,'fr','Seulement quand plus d\'une encre sur deux cÃ´tÃ©',0),(457339,12704,'jp','ã ã‘ã¨ãã« 1 ã¤ä»¥ä¸Šã®ã‚¤ãƒ³ã‚¯ ã‚µã‚¤ãƒ‰ 2',0),(457340,12704,'pt','Somente quando mais de uma tinta no lado dois',0),(457341,12704,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ñ‚Ð¾Ð³Ð´Ð°, ÐºÐ¾Ð³Ð´Ð° Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ð¾Ð´Ð¸Ð½ Ñ‡ÐµÑ€Ð½Ð¸Ð»Ð° Ð½Ð° ÑÑ‚Ð¾Ñ€Ð¾Ð½Ðµ 2',0),(457342,12704,'es','Solo Cuando Hay MÃ¡s que Una Tinta en el Lado Dos',0),(457343,12704,'de','Nur dann, wenn mehrere Tusche auf Seite 2',0),(457344,12704,'en','Only When More Than One Ink On Side Two',0),(457345,12705,'is','',0),(457346,12705,'dr','Ø·Ø±Ù Ø¯Ùˆ Ú©Ù†ØªØ±Ù„ Ø«Ø¨Øª Ù†Ø§Ù…',0),(457347,12705,'pr','Ø·Ø±Ù Ø¯Ùˆ Ú©Ù†ØªØ±Ù„ Ø«Ø¨Øª Ù†Ø§Ù…',0),(457348,12705,'tr','Yan iki sÄ±kÄ± kayÄ±t',0),(457349,12705,'pl','Dwie strony rejestracji mocno',0),(457350,12705,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð´Ð²Ðµ Ñ‚ÐµÑÐ½Ð¸ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(457351,12705,'ur','Ø·Ø±Ù Ø¯Ùˆ ØªÙ†Ú¯ Ø±Ø¬Ø³Ù¹Ø±ÛŒØ´Ù†',0),(457352,12705,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð° Ð´Ð²Ð° ÑƒÑÐºÐ¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ð°',0),(457353,12705,'vi','Hai bÃªn Ä‘Äƒng kÃ½ cháº·t cháº½',0),(457354,12705,'af','Kant twee stywe registrasie',0),(457355,12705,'ro','Partea doi strans Ã®nregistrare',0),(457356,12705,'et','Pool kaks tihe registreerimine',0),(457357,12705,'si','Strani dve tesen registracije',0),(457358,12705,'ba','Pendaftaran ketat dua sisi',0),(457359,12705,'nl','Kant twee strakke registratie',0),(457360,12705,'fi','Puoli kaksi tiukka rekisterÃ¶inti',0),(457361,12705,'no','Siden to stramme registrering',0),(457362,12705,'da','Side to stramme registrering',0),(457363,12705,'ko','ì¸¡ ë‘ ê½‰ ë“±ë¡',0),(457364,12705,'he','×¦×“ ×©× ×™ ×¨×™×©×•× ×—×–×§',0),(457365,12705,'el','Î”ÏÎ¿ ÏƒÏ†Î¹Ï‡Ï„ÏŒ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ Ï€Î»ÎµÏ…ÏÎ¬',0),(457366,12705,'zh','ä¾§2 ç´§å¯†ç™»è®°',0),(457367,12705,'sv','Sidan tvÃ¥ trÃ¥nga registrering',0),(457368,12705,'it','Registrazione stretto due lato',0),(457369,12705,'tl','',0),(457370,12705,'th','à¸¥à¸‡à¸—à¸°à¹€à¸šà¸µà¸¢à¸™à¸‡à¸§à¸”à¸—à¸µà¹ˆà¸ªà¸­à¸‡à¸”à¹‰à¸²à¸™',0),(457371,12705,'hi','à¤ªà¤•à¥à¤· à¤¦à¥‹ à¤¤à¤‚à¤— à¤ªà¤‚à¤œà¥€à¤•à¤°à¤£',0),(457372,12705,'ms','Pendaftaran ketat dua sisi',0),(457373,12705,'ar','ØªØ³Ø¬ÙŠÙ„ Ø¶ÙŠÙ‚ Ø§Ø«Ù†ÙŠÙ† Ø§Ù„Ø¬Ø§Ù†Ø¨',0),(457374,12705,'fr','Inscription serrÃ© deux cÃ´tÃ©',0),(457375,12705,'jp','å´ã® 2 ã¤ã®ã‚¿ã‚¤ãƒˆãªç™»éŒ²',0),(457376,12705,'pt','Lado dois registro apertado',0),(457377,12705,'ru','Ð¡Ñ‚Ð¾Ñ€Ð¾Ð½Ð° Ð´Ð²Ð° Ñ‚ÑƒÐ³Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(457378,12705,'es','Lado Dos RegistraciÃ³n Apretada',0),(457379,12705,'de','Seite zwei engen Registrierung',0),(457380,12705,'en','Side Two Tight Registration',0),(457381,12706,'is','',0),(457382,12706,'dr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„Ú©Ø±Ø¯ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡',0),(457383,12706,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„Ú©Ø±Ø¯ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡',0),(457384,12706,'tr','BasÄ±mevi performans istatistikleri',0),(457385,12706,'pl','Drukarnia statystyki wydajnoÅ›ci',0),(457386,12706,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° ÐµÑ„ÐµÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ€Ð¸Ñ‚Ðµ',0),(457387,12706,'ur','Ù¾Ø±Ø§Ù†Ù¹Ø´ÙˆÙ¾ Ú©ÛŒ Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±',0),(457388,12706,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð° ÐŸÑ€Ð¸Ð½Ñ‚ÑÑ…Ð¾Ð¿',0),(457389,12706,'vi','báº£ng in sá»‘ liá»‡u thá»‘ng kÃª thá»±c hiá»‡n',0),(457390,12706,'af','Printshop prestasie statistieke',0),(457391,12706,'ro','Statistici de performanÅ£Äƒ printshop',0),(457392,12706,'et','TrÃ¼kikojale jÃµudlusstatistika',0),(457393,12706,'si','Statistiko uspeÅ¡nosti tiskarne',0),(457394,12706,'ba','Statistik kinerja Printshop',0),(457395,12706,'nl','PrintShop prestatiestatistieken',0),(457396,12706,'fi','Painotalon tehokkuustilastoja',0),(457397,12706,'no','Trykkeriets resultatstatistikk',0),(457398,12706,'da','Printshop effektivitetsstatistikker',0),(457399,12706,'ko','Printshop ì„±ëŠ¥ í†µê³„',0),(457400,12706,'he','×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™× ×”×™×™×¢×•×¥',0),(457401,12706,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Ï€ÏŒÎ´Î¿ÏƒÎ·Ï‚ Ï„Ï…Ï€Î¿Î³ÏÎ±Ï†ÎµÎ¯Î¿Ï…',0),(457402,12706,'zh','æ‰“å°ç»©æ•ˆç»Ÿè®¡',0),(457403,12706,'sv','Tryckeriet prestandastatistik',0),(457404,12706,'it','Statistiche sulle prestazioni PrintShop',0),(457405,12706,'tl','',0),(457406,12706,'th','Printshop à¸ªà¸–à¸´à¸•à¸´à¹€à¸à¸µà¹ˆà¸¢à¸§à¸à¸±à¸šà¸›à¸£à¸°à¸ªà¸´à¸—à¸˜à¸´à¸ à¸²à¸ž',0),(457407,12706,'hi','Printshop à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡',0),(457408,12706,'ms','Statistik prestasi Printshop',0),(457409,12706,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡ Ø§Ù„Ù…Ø·Ø¨Ø¹Ø©',0),(457410,12706,'fr','Statistiques de performances PrintShop',0),(457411,12706,'jp','Printshop ãƒ‘ãƒ•ã‚©ãƒ¼ãƒžãƒ³ã‚¹çµ±è¨ˆ',0),(457412,12706,'pt','EstatÃ­sticas de desempenho de tipografia',0),(457413,12706,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð³Ñ€Ð°Ñ„Ð¸Ð¸',0),(457414,12706,'es','EstadÃ­sticas de Funcionamiento de Taller de Imprenta',0),(457415,12706,'de','PrintShop-Performance-Statistiken',0),(457416,12706,'en','Printshop Performance Statistics',0),(457417,12707,'is','',0),(457418,12707,'dr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„Ú©Ø±Ø¯ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ØªØ§Ø±ÛŒØ® Ù‡Ø§',0),(457419,12707,'pr','Ø¢Ù…Ø§Ø± Ø¹Ù…Ù„Ú©Ø±Ø¯ Ú†Ø§Ù¾Ø®Ø§Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ØªØ§Ø±ÛŒØ® Ù‡Ø§',0),(457420,12707,'tr','BasÄ±mevi performans istatistikleri tarihleri',0),(457421,12707,'pl','Drukarnia statystyki wydajnoÅ›ci dla dat',0),(457422,12707,'bg','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ€Ð¸Ñ‚Ðµ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð° Ð´Ð°Ñ‚Ð¸',0),(457423,12707,'ur','Ù¾Ø±Ø§Ù†Ù¹Ø´ÙˆÙ¾ Ú©ÛŒ Ú©Ø§Ø±Ú©Ø±Ø¯Ú¯ÛŒ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©Û’ Ù„Ø¦Û’',0),(457424,12707,'sr','ÐŸÑ€Ð¸Ð½Ñ‚ÑÑ…Ð¾Ð¿ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð¿ÐµÑ€Ñ„Ð¾Ñ€Ð¼Ð°Ð½ÑÐ°Ð¼Ð° Ð·Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ðµ',0),(457425,12707,'vi','báº£ng in sá»‘ liá»‡u thá»‘ng kÃª thá»±c hiá»‡n cho ngÃ y',0),(457426,12707,'af','Printshop prestasie statistieke vir datums',0),(457427,12707,'ro','Printshop statistici de performanÅ£Äƒ pentru dvs.',0),(457428,12707,'et','TrÃ¼kikojale jÃµudlusstatistika kuupÃ¤evad',0),(457429,12707,'si','Tiskarni statistiko uspeÅ¡nosti za datume',0),(457430,12707,'ba','Printshop statistik kinerja untuk tanggal',0),(457431,12707,'nl','PrintShop prestatiestatistieken voor de datums',0),(457432,12707,'fi','Painotalon tehokkuustilastot pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(457433,12707,'no','Trykkeriets resultatstatistikk For datoer',0),(457434,12707,'da','Printshop effektivitetsstatistikker For datoer',0),(457435,12707,'ko','ë‚ ì§œì— ëŒ€ í•œ Printshop ì„±ëŠ¥ í†µê³„',0),(457436,12707,'he','×”×™×™×¢×•×¥ ×¡×˜×˜×™×¡×˜×™×§×ª ×‘×™×¦×•×¢×™× ×¢×‘×•×¨ ×ª××¨×™×›×™×',0),(457437,12707,'el','Î¤Ï…Ï€Î¿Î³ÏÎ±Ï†ÎµÎ¯Î¿Ï… ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Ï‰Î½ ÎµÏ€Î¹Î´ÏŒÏƒÎµÏ‰Î½ Î³Î¹Î± Ï„Î¹Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(457438,12707,'zh','æ‰“å°å•†åº—åˆ†æ—¥ç»©æ•ˆç»Ÿè®¡',0),(457439,12707,'sv','Tryckeriet prestandastatistik fÃ¶r datum',0),(457440,12707,'it','PrintShop statistiche sulle prestazioni per le date',0),(457441,12707,'tl','',0),(457442,12707,'th','à¸ªà¸–à¸´à¸•à¸´à¸›à¸£à¸°à¸ªà¸´à¸—à¸˜à¸´à¸ à¸²à¸ž Printshop à¸§à¸±à¸™à¸—à¸µà¹ˆ',0),(457443,12707,'hi','Printshop à¤¤à¤¾à¤°à¥€à¤–à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤†à¤à¤•à¤¡à¤¼à¥‡',0),(457444,12707,'ms','Statistik prestasi Printshop pada tarikh',0),(457445,12707,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø§Ù„Ø£Ø¯Ø§Ø¡ Ø§Ù„Ù…Ø·Ø¨Ø¹Ø© Ù„Ù„ØªÙˆØ§Ø±ÙŠØ®',0),(457446,12707,'fr','Imprimerie des statistiques de performances pour les Dates',0),(457447,12707,'jp','æ—¥ä»˜ã® Printshop ãƒ‘ãƒ•ã‚©ãƒ¼ãƒžãƒ³ã‚¹çµ±è¨ˆæƒ…å ±',0),(457448,12707,'pt','EstatÃ­sticas de Performance grÃ¡fica para datas',0),(457449,12707,'ru','Ð¢Ð¸Ð¿Ð¾Ð³Ñ€Ð°Ñ„Ð¸Ð¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÑƒ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð´Ð»Ñ Ð´Ð°Ñ‚Ñ‹',0),(457450,12707,'es','EstadÃ­sticas de Funcionamiento de Taller de Imprenta Por Fecha',0),(457451,12707,'de','PrintShop-Performance-Statistiken fÃ¼r Termine',0),(457452,12707,'en','Printshop Performance Statistics For Dates',0),(457453,12708,'is','',0),(457454,12708,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ§Ù‚Ø¹ÛŒ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(457455,12708,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ§Ù‚Ø¹ÛŒ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(457456,12708,'tr','GerÃ§ek verisi bulunamadÄ±',0),(457457,12708,'pl','Nie znaleziono danych rzeczywistych',0),(457458,12708,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(457459,12708,'ur','Ú©ÙˆØ¦ÛŒ Ø­Ù‚ÛŒÙ‚ÛŒ Ú©ÙˆØ§Ø¦Ù Ù¾Ø§ÛŒØ§',0),(457460,12708,'sr','ÐÐµÐ¼Ð° ÑÑ‚Ð²Ð°Ñ€Ð½Ð¸Ñ… Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð½Ð°ÑˆÐ°Ð¾',0),(457461,12708,'vi','khÃ´ng tÃ¬m tháº¥y sá»‘ thá»±c táº¿',0),(457462,12708,'af','Geen werklike Data gevind',0),(457463,12708,'ro','Nu existÄƒ date reale gÄƒsit',0),(457464,12708,'et','Tegelik andmeid ei leitud',0),(457465,12708,'si','Ni dejanske podatke najdemo',0),(457466,12708,'ba','Tidak ada Data aktual yang ditemukan',0),(457467,12708,'nl','Geen werkelijke gegevens gevonden',0),(457468,12708,'fi','Ei todellisia tietoja ei lÃ¶ytynyt',0),(457469,12708,'no','Ingen faktiske Data funnet',0),(457470,12708,'da','Nogen faktiske Data fundet',0),(457471,12708,'ko','ì‹¤ì œ ë°ì´í„°ê°€ ë°œê²¬',0),(457472,12708,'he','××™×Ÿ × ×ª×•× ×™× ×‘×¤×•×¢×œ × ×ž×¦××•',0),(457473,12708,'el','Î”ÎµÎ½ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(457474,12708,'zh','å®žé™…æ•°æ®æœªæ‰¾åˆ°',0),(457475,12708,'sv','Inga faktiska Data hittades',0),(457476,12708,'it','Dati reali trovati',0),(457477,12708,'tl','',0),(457478,12708,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ˆà¸£à¸´à¸‡',0),(457479,12708,'hi','à¤•à¥‹à¤ˆ à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(457480,12708,'ms','Tiada Data sebenar yang ditemui',0),(457481,12708,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ÙØ¹Ù„ÙŠØ©',0),(457482,12708,'fr','Pas trouvÃ©es de donnÃ©es rÃ©elles',0),(457483,12708,'jp','å®Ÿéš›ã®ãƒ‡ãƒ¼ã‚¿ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(457484,12708,'pt','NÃ£o encontrados os dados reais',0),(457485,12708,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(457486,12708,'es','No se Encuentra Datos Actuales',0),(457487,12708,'de','Keine tatsÃ¤chlichen Daten gefunden',0),(457488,12708,'en','No Actual Data Found',0),(457489,12709,'is','',0),(457490,12709,'dr','Ù¾Ø±Ø³Ø´ ÙØ§Ù‚Ø¯ Ù†Ø§Ù… ',0),(457491,12709,'pr','Ù¾Ø±Ø³Ø´ ÙØ§Ù‚Ø¯ Ù†Ø§Ù… ',0),(457492,12709,'tr','Soru yoksun adÄ±',0),(457493,12709,'pl','Pytanie nie ma nazwy',0),(457494,12709,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° Ð¸Ð¼Ðµ Ð½Ð° Ð²ÑŠÐ¿Ñ€Ð¾Ñ',0),(457495,12709,'ur','Ø³ÙˆØ§Ù„ Ù„Ø§Ú©Ú¾ Ù†Ø§Ù…',0),(457496,12709,'sr','ÐŸÐ¸Ñ‚Ð°ÑšÐµ Ð½ÐµÐ¼Ð° Ð¸Ð¼Ðµ',0),(457497,12709,'vi','há»i tÃªn thiáº¿u',0),(457498,12709,'af','Vraag nie naam',0),(457499,12709,'ro','ÃŽntrebarea nu are nume',0),(457500,12709,'et','KÃ¼simus puudub nimi',0),(457501,12709,'si','VpraÅ¡anje nima ime',0),(457502,12709,'ba','Pertanyaan kekurangan nama',0),(457503,12709,'nl','Vraag mist naam',0),(457504,12709,'fi','Kysymys puuttuu nimi',0),(457505,12709,'no','SpÃ¸rsmÃ¥l mangler navn',0),(457506,12709,'da','SpÃ¸rgsmÃ¥l mangler navn',0),(457507,12709,'ko','ì§ˆë¬¸ ë¶€ì¡± ì´ë¦„',0),(457508,12709,'he','×©××œ×” ×—×¡×¨ ×©×',0),(457509,12709,'el','Î•ÏÏŽÏ„Î·Î¼Î± ÏƒÏ„ÎµÏÎµÎ¯Ï„Î±Î¹ ÏŒÎ½Î¿Î¼Î±',0),(457510,12709,'zh','é—®é¢˜ç¼ºå°‘åç§°',0),(457511,12709,'sv','FrÃ¥gan saknar namn',0),(457512,12709,'it','Domanda manca nome',0),(457513,12709,'tl','',0),(457514,12709,'th','à¸Šà¸·à¹ˆà¸­à¸„à¸³à¸–à¸²à¸¡à¸‚à¸²à¸”',0),(457515,12709,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨ à¤•à¤¾ à¤…à¤­à¤¾à¤µ à¤¨à¤¾à¤®',0),(457516,12709,'ms','Soalan tidak nama',0),(457517,12709,'ar','Ø§Ù„Ø³Ø¤Ø§Ù„ ÙŠÙØªÙ‚Ø± Ø¥Ù„Ù‰ Ø§Ø³Ù…',0),(457518,12709,'fr','Nom de manques de question',0),(457519,12709,'jp','è³ªå•ãŒæ¬ ã‘ã¦ã„ã‚‹ã®åå‰',0),(457520,12709,'pt','Pergunta carece de nome',0),(457521,12709,'ru','Ð’Ð¾Ð¿Ñ€Ð¾Ñ Ð½Ðµ Ð¸Ð¼ÐµÐµÑ‚ Ð¸Ð¼Ñ',0),(457522,12709,'es','La CuestiÃ³n Falta Nombre',0),(457523,12709,'de','Frage fehlt Name',0),(457524,12709,'en','Question Lacks Name',0),(457525,12710,'is','',0),(457526,12710,'dr','Ù¾Ø±Ø³Ø´ ÙØ§Ù‚Ø¯ Ù†ÙˆØ¹ Ù¾Ø§Ø³Ø® ',0),(457527,12710,'pr','Ù¾Ø±Ø³Ø´ ÙØ§Ù‚Ø¯ Ù†ÙˆØ¹ Ù¾Ø§Ø³Ø® ',0),(457528,12710,'tr','Soru yoksun yanÄ±t tÃ¼rÃ¼',0),(457529,12710,'pl','Pytanie nie ma odpowiedzi typu',0),(457530,12710,'bg','Ð¢Ð¸Ð¿ Ð²ÑŠÐ¿Ñ€Ð¾Ñ Ð»Ð¸Ð¿ÑÐ²Ð° Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€',0),(457531,12710,'ur','Ø³ÙˆØ§Ù„ Ù„Ø§Ú©Ú¾ Ù‚Ø³Ù… Ø¬ÙˆØ§Ø¨ÛŒ Ø¹Ù…Ù„',0),(457532,12710,'sr','Ð’Ñ€ÑÑ‚Ð° Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€Ð° Ð½Ð° Ð¿Ð¸Ñ‚Ð°ÑšÐµ Ð½ÐµÐ¼Ð°',0),(457533,12710,'vi','há»i pháº©n tráº£ lá»i thiáº¿u',0),(457534,12710,'af','Vraag nie reaksie tipe',0),(457535,12710,'ro','ÃŽntrebare nu are rÄƒspuns tip',0),(457536,12710,'et','KÃ¼simus puudub vastuse tÃ¼Ã¼p',0),(457537,12710,'si','VpraÅ¡anje nima odgovora tipa',0),(457538,12710,'ba','Pertanyaan kekurangan respon jenis',0),(457539,12710,'nl','Vraagtype mist reactie',0),(457540,12710,'fi','Kysymys ei ole vastaustyyppi',0),(457541,12710,'no','Svartypen for spÃ¸rsmÃ¥let mangler',0),(457542,12710,'da','Mangler svar spÃ¸rgsmÃ¥lstype',0),(457543,12710,'ko','ì§ˆë¬¸ ë¶€ì¡± ì‘ë‹µ ìœ í˜•',0),(457544,12710,'he','×©××œ×” ×—×¡×¨ ×¡×•×’ ×ª×’×•×‘×”',0),(457545,12710,'el','Î£Ï„ÎµÏÎµÎ¯Ï„Î±Î¹ ÎµÏÏŽÏ„Î·ÏƒÎ· Î±Ï€Î¬Î½Ï„Î·ÏƒÎ· Ï„Î¿Ï… Ï„ÏÏ€Î¿Ï…',0),(457546,12710,'zh','é—®é¢˜ç¼ºå°‘å›žåº”ç±»åž‹',0),(457547,12710,'sv','FrÃ¥gan saknar svarstyp',0),(457548,12710,'it','Domanda manca risposta tipo',0),(457549,12710,'tl','',0),(457550,12710,'th','à¸Šà¸™à¸´à¸”à¸•à¸­à¸šà¸„à¸³à¸–à¸²à¸¡à¸‚à¸²à¸”',0),(457551,12710,'hi','à¤ªà¥à¤°à¤¶à¥à¤¨ à¤•à¤¾ à¤…à¤­à¤¾à¤µ \"à¤œà¤µà¤¾à¤¬\" à¤ªà¥à¤°à¤•à¤¾à¤°',0),(457552,12710,'ms','Jenis respons soalan tidak',0),(457553,12710,'ar','Ø§Ù„Ø³Ø¤Ø§Ù„ ÙŠÙØªÙ‚Ø± Ø¥Ù„Ù‰ Ù†ÙˆØ¹ Ø§Ù„Ø§Ø³ØªØ¬Ø§Ø¨Ø©',0),(457554,12710,'fr','Type de question n\'a pas rÃ©ponse',0),(457555,12710,'jp','è³ªå•ãŒæ¬ ã‘ã¦ã„ã‚‹å¿œç­”ã‚¿ã‚¤ãƒ—',0),(457556,12710,'pt','Tipo de pergunta nÃ£o tem resposta',0),(457557,12710,'ru','Ð’Ð¾Ð¿Ñ€Ð¾Ñ Ð½Ðµ Ð¸Ð¼ÐµÐµÑ‚ Ð¾Ñ‚Ð²ÐµÑ‚Ð° Ñ‚Ð¸Ð¿Ð°',0),(457558,12710,'es','La CuestiÃ³n Falta Tipo de Respuesta',0),(457559,12710,'de','Frage fehlt Antworttyp',0),(457560,12710,'en','Question Lacks Response Type',0),(457561,12711,'is','',0),(457562,12711,'dr','Ø¢Ø¯Ø±Ø³ Ø§Ø±Ø³Ø§Ù„ Ø¯ÛŒÚ¯Ø±',0),(457563,12711,'pr','Ø¢Ø¯Ø±Ø³ Ø§Ø±Ø³Ø§Ù„ Ø¯ÛŒÚ¯Ø±',0),(457564,12711,'tr','BaÅŸka bir teslimat adresi',0),(457565,12711,'pl','Inny adres dostawy',0),(457566,12711,'bg','Ð”Ñ€ÑƒÐ³ Ð°Ð´Ñ€ÐµÑ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(457567,12711,'ur','Ú©Ø³ÛŒ Ø¯ÙˆØ³Ø±Û’ Ú©ÛŒ Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú©Ø§ Ù¾ØªÛ',0),(457568,12711,'sr','Ð”Ñ€ÑƒÐ³Ñƒ Ð°Ð´Ñ€ÐµÑÑƒ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(457569,12711,'vi','Äá»‹a chá»‰ giao hÃ ng khÃ¡c',0),(457570,12711,'af','Nog \'n aflewering adres',0),(457571,12711,'ro','O alta adresa de livrare',0),(457572,12711,'et','Teine tarneaadress',0),(457573,12711,'si','Drug naslov za dostavo',0),(457574,12711,'ba','Alamat pengiriman yang lain',0),(457575,12711,'nl','Een ander leveringsadres',0),(457576,12711,'fi','Toinen osoite',0),(457577,12711,'no','En annen leveringsadresse',0),(457578,12711,'da','En anden leveringsadresse',0),(457579,12711,'ko','ë‹¤ë¥¸ ë°°ë‹¬ ì£¼ì†Œ',0),(457580,12711,'he','×›×ª×•×‘×ª ×ž×©×œ×•×— × ×•×¡×¤×ª',0),(457581,12711,'el','Î†Î»Î»Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(457582,12711,'zh','å¦ä¸€ä¸ªé€è´§åœ°å€',0),(457583,12711,'sv','En annan leveransadress',0),(457584,12711,'it','Un altro indirizzo di consegna',0),(457585,12711,'tl','',0),(457586,12711,'th','à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸­à¸µà¸',0),(457587,12711,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ à¤µà¤¿à¤¤à¤°à¤£ à¤ªà¤¤à¤¾',0),(457588,12711,'ms','Satu lagi alamat penghantaran',0),(457589,12711,'ar','Ø¢Ø®Ø± Ø¹Ù†ÙˆØ§Ù† Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(457590,12711,'fr','Une autre adresse de livraison',0),(457591,12711,'jp','åˆ¥ã®é…é€å…ˆä½æ‰€',0),(457592,12711,'pt','Outro endereÃ§o de entrega',0),(457593,12711,'ru','Ð”Ñ€ÑƒÐ³Ð¾Ð¹ Ð°Ð´Ñ€ÐµÑ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(457594,12711,'es','Otra DirecciÃ³n de Entrega',0),(457595,12711,'de','Eine andere Lieferadresse',0),(457596,12711,'en','Another Delivery Address',0),(457597,12712,'is','',0),(457598,12712,'dr','Ø®Ø·Ø§ Ø¯Ø±Ø®ÙˆØ§Ù†Ø¯Ù† ÙØ§ÛŒÙ„',0),(457599,12712,'pr','Ø®Ø·Ø§ Ø¯Ø±Ø®ÙˆØ§Ù†Ø¯Ù† ÙØ§ÛŒÙ„',0),(457600,12712,'tr','Dosya okuma hatasÄ±',0),(457601,12712,'pl','BÅ‚Ä…d odczytu pliku',0),(457602,12712,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ñ‡ÐµÑ‚ÐµÐ½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(457603,12712,'ur','Ù…Ø³Ù„ Ù…Ø·Ø§Ù„Ø¹Û Ù†Ù‚Øµ',0),(457604,12712,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ñ‡Ð¸Ñ‚Ð°ÑšÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(457605,12712,'vi','Lá»—i khi Ä‘á»c file',0),(457606,12712,'af','Kon nie lÃªer lees nie',0),(457607,12712,'ro','Eroare citire fiÅŸier',0),(457608,12712,'et','TÃµrge faili lugemisel',0),(457609,12712,'si','Napaka pri branju datoteke',0),(457610,12712,'ba','Kesalahan membaca File',0),(457611,12712,'nl','Fout bij lezen van bestand',0),(457612,12712,'fi','Virhe luettaessa tiedostoa',0),(457613,12712,'no','Feil ved lesing av fil',0),(457614,12712,'da','Fejl lÃ¦sning af fil',0),(457615,12712,'ko','ì˜¤ë¥˜ ì½ê¸° íŒŒì¼',0),(457616,12712,'he','×©×’×™××” ×‘×§×¨×™××” ×§×•×‘×¥',0),(457617,12712,'el','Î›Î¬Î¸Î¿Ï‚ Î±Î½Î¬Î³Î½Ï‰ÏƒÎ· Ï„Î¿Ï… Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(457618,12712,'zh','è¯»æ–‡ä»¶é”™è¯¯',0),(457619,12712,'sv','Fel vid lÃ¤sning av fil',0),(457620,12712,'it','Errore lettura File',0),(457621,12712,'tl','',0),(457622,12712,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸­à¹ˆà¸²à¸™à¹à¸Ÿà¹‰à¸¡',0),(457623,12712,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤®à¥‡à¤‚ à¤ªà¤ à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(457624,12712,'ms','Ralat membaca fail',0),(457625,12712,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ù‚Ø±Ø§Ø¡Ø© Ø§Ù„Ù…Ù„Ù',0),(457626,12712,'fr','Erreur lecture fichier',0),(457627,12712,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®èª­ã¿å–ã‚Šã‚¨ãƒ©ãƒ¼',0),(457628,12712,'pt','Erro ao ler arquivo',0),(457629,12712,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ñ‡Ñ‚ÐµÐ½Ð¸Ñ Ñ„Ð°Ð¹Ð»Ð°',0),(457630,12712,'es','Error Leyendo el File',0),(457631,12712,'de','Fehler beim Lesen der Datei',0),(457632,12712,'en','Error Reading File',0),(457633,12713,'is','',0),(457634,12713,'dr','Ø§Ø´ØªØ±Ø§Ú©Ø§Øª Ù…ÙˆØ¬ÙˆØ¯',0),(457635,12713,'pr','Ø§Ø´ØªØ±Ø§Ú©Ø§Øª Ù…ÙˆØ¬ÙˆØ¯',0),(457636,12713,'tr','Mevcut abonelikleri',0),(457637,12713,'pl','DostÄ™pnych subskrypcji',0),(457638,12713,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¸ Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚Ð¸',0),(457639,12713,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ Ø³Ø¨Ø³Ú©Ø±Ù¾Ø´Ù†Ø²',0),(457640,12713,'sr','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ðµ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(457641,12713,'vi','ThuÃª bao cÃ³ sáºµn',0),(457642,12713,'af','Beskikbare Subskripsies',0),(457643,12713,'ro','Abonamente disponibile',0),(457644,12713,'et','Saadaval tellimine',0),(457645,12713,'si','Na voljo naroÄnine',0),(457646,12713,'ba','Tersedia langganan',0),(457647,12713,'nl','Beschikbare abonnementen',0),(457648,12713,'fi','Saatavissa olevat tilaukset',0),(457649,12713,'no','Tilgjengelige abonnementer',0),(457650,12713,'da','TilgÃ¦ngelig abonnementer',0),(457651,12713,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” êµ¬ë…',0),(457652,12713,'he','×–×ž×™×Ÿ ×ž× ×•×™×™×',0),(457653,12713,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼ÎµÏ‚ ÏƒÏ…Î½Î´ÏÎ¿Î¼Î­Ï‚',0),(457654,12713,'zh','å¯ç”¨çš„è®¢é‡‘',0),(457655,12713,'sv','TillgÃ¤ngliga prenumerationer',0),(457656,12713,'it','Abbonamenti disponibili',0),(457657,12713,'tl','',0),(457658,12713,'th','à¸¡à¸µà¸ªà¸¡à¸²à¸Šà¸´à¸',0),(457659,12713,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾à¤à¤',0),(457660,12713,'ms','Yuran-yuran yang disediakan',0),(457661,12713,'ar','Ø§Ù„Ø§Ø´ØªØ±Ø§ÙƒØ§Øª Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(457662,12713,'fr','Abonnements disponibles',0),(457663,12713,'jp','åˆ©ç”¨å¯èƒ½ãªã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³',0),(457664,12713,'pt','Assinaturas disponÃ­veis',0),(457665,12713,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ¸',0),(457666,12713,'es','Suscripciones Disponibles',0),(457667,12713,'de','VerfÃ¼gbare Abonnements',0),(457668,12713,'en','Available Subscriptions',0),(457669,12714,'is','',0),(457670,12714,'dr','Ø¯ÙˆØ±Ù‡ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯Ø± Ù‡Ø± Ø³Ø§Ù„',0),(457671,12714,'pr','Ø¯ÙˆØ±Ù‡ ØµØ¯ÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¯Ø± Ù‡Ø± Ø³Ø§Ù„',0),(457672,12714,'tr','YÄ±llÄ±k Ã¶deme dÃ¶nemleri',0),(457673,12714,'pl','Okresy rozliczeniowe rocznie',0),(457674,12714,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸ Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¾',0),(457675,12714,'ur','Ø³Ø§Ù„Ø§Ù†Û Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¯Øª',0),(457676,12714,'sr','ÐÐ°Ð¿Ð»Ð°Ñ‚Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ñ‚Ð¾ÐºÐ¾Ð¼ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(457677,12714,'vi','Ká»³ láº­p hÃ³a Ä‘Æ¡n hÃ ng nÄƒm',0),(457678,12714,'af','Fakturering periodes Per jaar',0),(457679,12714,'ro','Perioade de facturare pe an',0),(457680,12714,'et','Arved perioodidel aastas',0),(457681,12714,'si','ZaraÄunavanje obdobij na leto',0),(457682,12714,'ba','Periode penagihan Per tahun',0),(457683,12714,'nl','Facturering termijnen Per jaar',0),(457684,12714,'fi','Laskutus maksukertojen',0),(457685,12714,'no','Fakturering perioder Per Ã¥r',0),(457686,12714,'da','Fakturering perioder pr. Ã¥r',0),(457687,12714,'ko','ì—°ê°„ ê²°ì œ ê¸°ê°„',0),(457688,12714,'he','×—×™×•×‘ ×ª×§×•×¤×•×ª ×‘×©× ×”',0),(457689,12714,'el','Î§ÏÎ­Ï‰ÏƒÎ·Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Ï‰Î½ Î±Î½Î¬ Î­Ï„Î¿Ï‚',0),(457690,12714,'zh','æ¯å¹´è®¡è´¹æ—¶é—´',0),(457691,12714,'sv','Fakturering perioder Per Ã¥r',0),(457692,12714,'it','Periodi di fatturazione all\'anno',0),(457693,12714,'tl','',0),(457694,12714,'th','à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸•à¹ˆà¸­à¸›à¸µ',0),(457695,12714,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤·',0),(457696,12714,'ms','Bil tempoh setahun',0),(457697,12714,'ar','ÙØªØ±Ø§Øª Ø§Ù„ÙÙˆØªØ±Ø© ÙÙŠ Ø§Ù„Ø³Ù†Ø©',0),(457698,12714,'fr','PÃ©riodes de facturation par an',0),(457699,12714,'jp','å¹´é–“è«‹æ±‚æœŸé–“',0),(457700,12714,'pt','PerÃ­odos de faturamento por ano',0),(457701,12714,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¾Ð² Ð² Ð³Ð¾Ð´',0),(457702,12714,'es','PerÃ­odos de FacturaciÃ³n Por AÃ±o',0),(457703,12714,'de','Abrechnung Perioden pro Jahr',0),(457704,12714,'en','Billing Periods Per Year',0),(457705,12715,'is','',0),(457706,12715,'dr','(ØªØ¹Ù‡Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(457707,12715,'pr','Ø§Ø´ØªØ±Ø§Ú©(ØªØ¹Ù‡Ø¯ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(457708,12715,'tr','Abonelik',0),(457709,12715,'pl','Subskrypcja',0),(457710,12715,'bg','ÐÐ±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(457711,12715,'ur','Ú©ÛŒ Ø±Ú©Ù†ÛŒØª',0),(457712,12715,'sr','ÐŸÑ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ð°',0),(457713,12715,'vi','ÄÄƒng kÃ½',0),(457714,12715,'af','Intekening',0),(457715,12715,'ro','Abonament',0),(457716,12715,'et','Tellimus',0),(457717,12715,'si','NaroÄnina',0),(457718,12715,'ba','Berlangganan',0),(457719,12715,'nl','Abonnement',0),(457720,12715,'fi','Tilaus',0),(457721,12715,'no','Abonnement',0),(457722,12715,'da','Abonnement',0),(457723,12715,'ko','êµ¬ë…',0),(457724,12715,'he','×ž× ×•×™',0),(457725,12715,'el','Î£Ï…Î½Î´ÏÎ¿Î¼Î®',0),(457726,12715,'zh','ä¼šè´¹',0),(457727,12715,'sv','Prenumeration',0),(457728,12715,'it','Abbonamento',0),(457729,12715,'tl','',0),(457730,12715,'th','à¸šà¸­à¸à¸£à¸±à¸šà¹€à¸›à¹‡à¸™à¸ªà¸¡à¸²à¸Šà¸´à¸',0),(457731,12715,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾',0),(457732,12715,'ms','Langganan',0),(457733,12715,'ar','Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(457734,12715,'fr','Abonnement',0),(457735,12715,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³',0),(457736,12715,'pt','Assinatura',0),(457737,12715,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐºÐ°',0),(457738,12715,'es','SuscripciÃ³n',0),(457739,12715,'de','Abonnement',0),(457740,12715,'en','Subscription',0),(457741,12716,'is','',0),(457742,12716,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÛŒØ§Øª Ù…Ø¨Ù†Ø§ÛŒ Ù†Ù‚Ø¯ÛŒ',0),(457743,12716,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø§Ù„ÛŒØ§Øª Ù…Ø¨Ù†Ø§ÛŒ Ù†Ù‚Ø¯ÛŒ',0),(457744,12716,'tr','Nakit olarak vergi raporlama',0),(457745,12716,'pl','Åšrodki pieniÄ™Å¼ne na podstawie podatku sprawozdawczoÅ›ci',0),(457746,12716,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ Ð¾ÑÐ½Ð¾Ð²Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð¾Ñ‚Ñ‡Ð¸Ñ‚Ð°Ð½Ðµ',0),(457747,12716,'ur','Ú©ÛŒØ´ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¹ÛŒÚ©Ø³ Ø±Ù¾ÙˆØ±Ù¹ Ú©Ø§Ø±ÛŒ',0),(457748,12716,'sr','Ð£Ð½Ð¾Ð²Ñ‡Ð¸Ñ‚Ð¸ Ð¾ÑÐ½Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ð²Ð°ÑšÐµ',0),(457749,12716,'vi','BÃ¡o cÃ¡o thuáº¿ báº±ng cÆ¡ sá»Ÿ tiá»n máº·t ',0),(457750,12716,'af','Kontant Basis Belastingverslaggewing',0),(457751,12716,'ro','Numerar baza fiscalÄƒ de raportare',0),(457752,12716,'et','Raha eraldi maksuaruandluse',0),(457753,12716,'si','Denarni osnovi davÄno poroÄanje',0),(457754,12716,'ba','Uang dasar pelaporan pajak',0),(457755,12716,'nl','Contant geld Basis belastingrapportering',0),(457756,12716,'fi','KÃ¤teisellÃ¤ perusta veroilmoitusta',0),(457757,12716,'no','Kontanter Basis-rapportering',0),(457758,12716,'da','Cash grundlag skatteindberetning',0),(457759,12716,'ko','í˜„ê¸ˆìœ¼ë¡œ ì„¸ê¸ˆ ë³´ê³ ',0),(457760,12716,'he','×œ×¤×“×•×ª ××ª ×‘×¡×™×¡ ×”×ž×¡ ×“×™×•×•×—',0),(457761,12716,'el','ÎœÎµÏ„ÏÎ·Ï„Î¬ Î²Î¬ÏƒÎ· Î¦ÎŸÎ¡ÎŸÎ›ÎŸÎ“Î™ÎšÎ•Î£ Î Î›Î—Î¡ÎŸÎ¦ÎŸÎ¡Î—Î£Î—Î£',0),(457762,12716,'zh','çŽ°é‡‘æ”¶ä»˜åˆ¶ç¨Žæ”¶æŠ¥å‘Š',0),(457763,12716,'sv','Kontanter Basis momsrapportering',0),(457764,12716,'it','Base di cassa fiscale segnalazione',0),(457765,12716,'tl','',0),(457766,12716,'th','à¹€à¸à¸“à¸‘à¹Œà¹€à¸‡à¸´à¸™à¸ªà¸”à¸£à¸²à¸¢à¸‡à¸²à¸™à¸ à¸²à¸©à¸µ',0),(457767,12716,'hi','à¤¨à¤•à¤¦à¥€ à¤†à¤§à¤¾à¤° à¤Ÿà¥ˆà¤•à¥à¤¸ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¤¿à¤‚à¤—',0),(457768,12716,'ms','Tunai asas cukai Laporan',0),(457769,12716,'ar','Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³ Ø§Ù„Ø¥Ø¨Ù„Ø§Øº Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ',0),(457770,12716,'fr','Base de trÃ©sorerie dÃ©claration',0),(457771,12716,'jp','åŸºç¤Žã®ç¾é‡‘ç¨Žãƒ¬ãƒãƒ¼ãƒˆ',0),(457772,12716,'pt','Dinheiro a base fiscal Reporting',0),(457773,12716,'ru','ÐÐ°Ð»Ð¸Ñ‡Ð½Ñ‹Ð¼Ð¸ ÐžÑÐ½Ð¾Ð²Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð½Ð¾ÑÑ‚Ð¸',0),(457774,12716,'es','Informando de Impuestos de Base de Efectivo',0),(457775,12716,'de','Cash Basis Tax Reporting',0),(457776,12716,'en','Cash Basis Tax Reporting',0),(457777,12717,'is','',0),(457778,12717,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø±Ø§Ø¯Ø±Ø·ÛŒ Ù…Ø¯Øª ØªÚ©Ù…ÛŒÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ù‡ Ø±ÙˆØ² Ù†Ú©Ù†ÛŒØ¯',0),(457779,12717,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø±Ø§Ø¯Ø±Ø·ÛŒ Ù…Ø¯Øª ØªÚ©Ù…ÛŒÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ù‡ Ø±ÙˆØ² Ù†Ú©Ù†ÛŒØ¯',0),(457780,12717,'tr','Maliyetleri Fulfillment sipariÅŸler nakliye sÄ±rasÄ±nda gÃ¼ncelleme yapmak',0),(457781,12717,'pl','Nie aktualizacji koszty podczas transportu realizacji zamÃ³wieÅ„',0),(457782,12717,'bg','ÐÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(457783,12717,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø´Ù¾Ù†Ú¯ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ø§Ù¾ ÚˆÛŒÙ¹ Ù†ÛÛŒÚº Ú©Ø±ØªÛ’',0),(457784,12717,'sr','ÐÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(457785,12717,'vi','KhÃ´ng cáº­p nháº­t chi phÃ­ trong suá»‘t quÃ¡ trÃ¬nh váº­n chuyá»ƒn hoÃ n thÃ nh Ä‘Æ¡n hÃ ng',0),(457786,12717,'af','Koste gedurende gestuur van nakoming Orders bywerk nie',0),(457787,12717,'ro','Nu se actualizeazÄƒ costurile Ã®n timpul navigaÅ£iei Ã®ndeplinirea comenzilor',0),(457788,12717,'et','Uuenda kulude ajal plaanitud tellimuste saatmine',0),(457789,12717,'si','Ne posodobitev stroÅ¡kov med dostava izpolnitev naroÄil',0),(457790,12717,'ba','Tidak memperbarui biaya selama pengiriman pemenuhan order',0),(457791,12717,'nl','Kosten niet bijwerken tijdens de verzending van vervulling Orders',0),(457792,12717,'fi','Ã„lÃ¤ pÃ¤ivitÃ¤ kustannukset tÃ¤yttÃ¤minen tilaukset kuljetuksen aikana',0),(457793,12717,'no','Oppdater ikke kostnader under frakt av fullfÃ¸ringen bestillinger',0),(457794,12717,'da','Opdateres ikke omkostninger under forsendelse for Fulfillment ordrer',0),(457795,12717,'ko','í–‰ ì£¼ë¬¸ ë°°ì†¡ ì¤‘ ë¹„ìš©ì„ ì—…ë°ì´íŠ¸ í•˜ì§€ ì•ŠìŒ',0),(457796,12717,'he','××œ ×ª×¢×“×›×Ÿ ×¢×œ×•×™×•×ª ×‘×ž×”×œ×š ×”×ž×©×œ×•×— ×©×œ ×ž×™×ž×•×© ×”×–×ž× ×•×ª',0),(457797,12717,'el','Î”ÎµÎ½ ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÎ±Ï„Î¬ Ï„Î· Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬ Ï„Ï‰Î½ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(457798,12717,'zh','åœ¨å±¥è¡Œè®¢å•è¿é€ä¸­ä¸æ›´æ–°æˆæœ¬',0),(457799,12717,'sv','Uppdatera inte kostnader vid leverans av uppfyllelse order',0),(457800,12717,'it','Non aggiornare i costi durante la spedizione di evasione ordini',0),(457801,12717,'tl','',0),(457802,12717,'th','à¸­à¸±à¸žà¹€à¸”à¸•à¸•à¹‰à¸™à¸—à¸¸à¸™à¹ƒà¸™à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸à¸²à¸£à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(457803,12717,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤²à¤¾à¤—à¤¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¨ à¤•à¤°à¥‡à¤‚',0),(457804,12717,'ms','Kemaskini Terakhir kos semasa penghantaran pesanan memenuhi',0),(457805,12717,'ar','Ù„Ø§ ØªÙ‚Ù… Ø¨ØªØ­Ø¯ÙŠØ« Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø£Ø«Ù†Ø§Ø¡ Ø´Ø­Ù† Ø£ÙˆØ§Ù…Ø± Ø§Ù„ÙˆÙØ§Ø¡',0),(457806,12717,'fr','Ne pas mettre Ã  jour frais lors de l\'expÃ©dition d\'ordres de traitement',0),(457807,12717,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ãƒ» ã‚ªãƒ¼ãƒ€ãƒ¼ã®å‡ºè·æ™‚ã«ã‚³ã‚¹ãƒˆã‚’æ›´æ–°ã—ã¾ã›ã‚“ã€‚',0),(457808,12717,'pt','NÃ£o atualizar os custos durante o envio de ordens de cumprimento',0),(457809,12717,'ru','ÐÐµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÑÑ‚ÑŒ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹ Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ñ Ñ‚Ñ€Ð°Ð½ÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(457810,12717,'es','No Actualiza los Costos Durante el EnvÃ­o de Ordenes de Transporte o de Cumplimiento',0),(457811,12717,'de','Aktualisieren Sie Kosten wÃ¤hrend des Versands der Fulfillment-Bestellungen nicht',0),(457812,12717,'en','Do Not Update Costs During Shipping Of Fulfillment Orders',0),(457813,12718,'is','',0),(457814,12718,'dr',':Ø§ÛŒÙ† Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø¨Ø§ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¬Ù†Ø³Ø¨Ø§Ø¹Ø« Ø§ÛŒØ¬Ø§Ø¯ Ù…Ø´Ú©Ù„ Ø¯Ø± Ø­Ø³Ø§Ø¨ Ù„ÛŒØ¬Ø± Ø´ÙˆØ¯  ',0),(457815,12718,'pr','Ø§Ø®Ø·Ø§Ø±:Ø§ÛŒÙ† Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø¨Ø§ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§Ø¨Ø§Ø¹Ø« Ø§ÛŒØ¬Ø§Ø¯ Ù…Ø´Ú©Ù„ Ø¯Ø± Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„ Ø´ÙˆØ¯  ',0),(457816,12718,'tr','UyarÄ±: Bu GL. stok maliyeti ile sorunlara neden',0),(457817,12718,'pl','OstrzeÅ¼enie: MoÅ¼e to spowodowaÄ‡ problemy z kosztÃ³w magazynowych w GL.',0),(457818,12718,'bg','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ: Ð¢Ð¾Ð²Ð° Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€ÐµÐ´Ð¸Ð·Ð²Ð¸ÐºÐ° Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð¸ Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð½Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð² GL.',0),(457819,12718,'ur','ØªÙ†Ø¨ÛŒÛ: Ø§Ø³ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ø³Ø§Ø¦Ù„ Ù…ÛŒÚº Ø¨Ú©Ú¾ÛŒØ± Ø±ÛØ§ Ú©Ø§ Ø¨Ø§Ø¹Ø« ÛÙˆ Ø³Ú©ØªØ§ ÛÛ’',0),(457820,12718,'sr','Ð£Ð¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ : ÐžÐ²Ð¾ Ð¼Ð¾Ð¶Ðµ Ð¿Ñ€Ð¾ÑƒÐ·Ñ€Ð¾ÐºÐ¾Ð²Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ðµ ÑÐ° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ñƒ Ñ˜Ðµ Ð²Ð¾Ñ˜Ð½Ð¸Ðº.',0),(457821,12718,'vi','Cáº£nh bÃ¡o: Äiá»u nÃ y cÃ³ thá»ƒ gÃ¢y ra váº¥n Ä‘á» vá»›i chi phÃ­ hÃ ng tá»“n kho trong GL.',0),(457822,12718,'af','Waarskuwing: Dit kan probleme veroorsaak met voorraad kostes in die GL.',0),(457823,12718,'ro','Avertisment: Acest lucru ar putea cauza probleme cu costurile de inventar Ã®n GL.',0),(457824,12718,'et','Hoiatus: See vÃµib pÃµhjustada probleeme varude kulud ning GL.',0),(457825,12718,'si','Opozorilo: To lahko povzroÄi teÅ¾ave s stroÅ¡ki popisa v v GL.',0),(457826,12718,'ba','Peringatan: Ini mungkin menyebabkan masalah dengan biaya persediaan di GL.',0),(457827,12718,'nl','Waarschuwing: Hierdoor kan problemen met voorraadkosten in de GL.',0),(457828,12718,'fi','Varoitus: TÃ¤mÃ¤ saattaa aiheuttaa ongelmia varaston kustannuksia GL.',0),(457829,12718,'no','Advarsel: Dette kan forÃ¥rsake problemer med lagerkostnader i GL.',0),(457830,12718,'da','Advarsel: Dette kan forÃ¥rsage problemer med lageromkostninger i GL.',0),(457831,12718,'ko','ê²½ê³ : ì´ê²ƒì€ GL.ì— ìž¬ê³  ë¹„ìš© ë¬¸ì œê°€ ë°œìƒí•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(457832,12718,'he','××–×”×¨×”: ×–×” ×¢×œ×•×œ ×œ×’×¨×•× ×œ×‘×¢×™×•×ª ×¢× ×¢×œ×•×™×•×ª ×”×ž×œ××™ ×©×“×¨×•×ª',0),(457833,12718,'el','Î ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·: Î‘Ï…Ï„ÏŒ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Ï€ÏÎ¿ÎºÎ±Î»Î­ÏƒÎµÎ¹ Ï€ÏÎ¿Î²Î»Î®Î¼Î±Ï„Î± Î¼Îµ ÎºÏŒÏƒÏ„Î¿Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ ÏƒÎµ Ï„Î¿ GL.',0),(457834,12718,'zh','è­¦å‘Šï¼šè¿™å¯èƒ½ä¼šå¯¼è‡´æ€»å¸åº“å­˜æˆæœ¬äº§ç”Ÿé—®é¢˜ï¼Œ',0),(457835,12718,'sv','Varning: Detta kan orsaka problem med lagerkostnader i GL.',0),(457836,12718,'it','Attenzione: Questo potrebbe causare problemi con i costi di inventario nella GL.',0),(457837,12718,'tl','',0),(457838,12718,'th','à¸„à¸³à¹€à¸•à¸·à¸­à¸™: à¸™à¸µà¹‰à¸­à¸²à¸ˆà¸—à¸³à¹ƒà¸«à¹‰à¹€à¸à¸´à¸”à¸›à¸±à¸à¸«à¸²à¸à¸±à¸šà¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¹ƒà¸™à¸ˆà¸µà¹à¸­à¸¥',0),(457839,12718,'hi','à¤šà¥‡à¤¤à¤¾à¤µà¤¨à¥€: à¤¯à¤¹ à¤—à¥à¤²à¥‚à¤•à¥‹à¤œ à¤®à¥‡à¤‚ à¤®à¤¾à¤² à¤•à¥€ à¤²à¤¾à¤—à¤¤ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤®à¤¸à¥à¤¯à¤¾à¤“à¤‚ à¤•à¤¾ à¤•à¤¾à¤°à¤£ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(457840,12718,'ms','Amaran: Ini mungkin menyebabkan masalah dengan kos inventori di GL. di',0),(457841,12718,'ar','ØªØ­Ø°ÙŠØ±: Ù‡Ø°Ø§ Ù‚Ø¯ ÙŠØ³Ø¨Ø¨ Ù…Ø´Ø§ÙƒÙ„ Ù…Ø¹ ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ÙÙŠ Ø§Ù„Ø£Ø³ØªØ§Ø°',0),(457842,12718,'fr','AVERTISSEMENT : Ceci pourrait poser des problÃ¨mes avec les coÃ»ts d\'inventaire dans le GL.',0),(457843,12718,'jp','è­¦å‘Šï¼š ã“ã‚Œã§å•é¡Œã‚’å¼•ãèµ·ã“ã™åœ¨åº«ã‚³ã‚¹ãƒˆã¨ã€gl.',0),(457844,12718,'pt','Aviso: Isto pode causar problemas com os custos de inventÃ¡rio no GL.',0),(457845,12718,'ru','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ: Ð­Ñ‚Ð¾ Ð¼Ð¾Ð¶ÐµÑ‚ Ð²Ñ‹Ð·Ð²Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ñ‹ Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð² Ð² Ð³Ð».',0),(457846,12718,'es','Aviso: Esta acciÃ³n puede causar problemas con costos de inventario en LM',0),(457847,12718,'de','Warnung: Dies mÃ¶glicherweise Probleme mit Lagerkosten in der GL.',0),(457848,12718,'en','Warning: This might cause problems with inventory costs in the GL.',0),(457849,12719,'is','',0),(457850,12719,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø¨Ù†Ø§ÛŒ Ù†Ù‚Ø¯ÛŒ ',0),(457851,12719,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø¨Ù†Ø§ÛŒ Ù†Ù‚Ø¯ÛŒ ',0),(457852,12719,'tr','Nakit olarak rapor',0),(457853,12719,'pl','Podstawie raportu kasowego',0),(457854,12719,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ Ð¾ÑÐ½Ð¾Ð²Ð° Ð´Ð¾ÐºÐ»Ð°Ð´',0),(457855,12719,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ø±Ù¾ÙˆØ±Ù¹',0),(457856,12719,'sr','ÐžÑÐ½Ð¾Ð²Ð° Ð±Ð»Ð°Ð³Ð°Ñ˜Ð½Ðµ',0),(457857,12719,'vi','CÆ¡ sá»Ÿ bÃ¡o cÃ¡o tiá»n máº·t',0),(457858,12719,'af','Kontant Basis Verslag',0),(457859,12719,'ro','Raport de bazÄƒ de numerar',0),(457860,12719,'et','Raha regulaarselt aru',0),(457861,12719,'si','Denarni osnovi poroÄilo',0),(457862,12719,'ba','Tunai dasar laporan',0),(457863,12719,'nl','Cash Basis rapport',0),(457864,12719,'fi','Perusteella kassaraportti',0),(457865,12719,'no','Cash grunnlag rapport',0),(457866,12719,'da','Cash grundlag rapport',0),(457867,12719,'ko','í˜„ê¸ˆ ë‹¨ìœ„ë¡œ ë³´ê³ ì„œ',0),(457868,12719,'he','×“×•×— ×‘×¡×™×¡ ×ž×–×•×ž×Ÿ',0),(457869,12719,'el','Î¤Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ Î²Î¬ÏƒÎ· Î­ÎºÎ¸ÎµÏƒÎ·',0),(457870,12719,'zh','çŽ°é‡‘åˆ¶æŠ¥å‘Š',0),(457871,12719,'sv','Cash underlagsrapport',0),(457872,12719,'it','Relazione di base di cassa',0),(457873,12719,'tl','',0),(457874,12719,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¹€à¸à¸“à¸‘à¹Œà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(457875,12719,'hi','à¤¨à¤•à¤¦à¥€ à¤†à¤§à¤¾à¤° à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(457876,12719,'ms','Laporan asas Tunai',0),(457877,12719,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø£Ø³Ø§Ø³ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(457878,12719,'fr','Rapport de base de trÃ©sorerie',0),(457879,12719,'jp','ç¾é‡‘ã”ã¨ã®ãƒ¬ãƒãƒ¼ãƒˆ',0),(457880,12719,'pt','RelatÃ³rio de base de dinheiro',0),(457881,12719,'ru','ÐžÑÐ½Ð¾Ð²Ñƒ ÐºÐ°ÑÑÐ¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(457882,12719,'es','Informe de Base de Efectivo',0),(457883,12719,'de','Bargeld Grundlage Bericht',0),(457884,12719,'en','Cash Basis Report',0),(457885,12720,'is','',0),(457886,12720,'dr',' Ù…Ù‚Ø¯Ø§Ø±Ù…Ø¹Ø§Ù',0),(457887,12720,'pr',' Ù…Ù‚Ø¯Ø§Ø±Ù…Ø¹Ø§Ù',0),(457888,12720,'tr','Muaf tutar',0),(457889,12720,'pl','Kwota zwolnienia',0),(457890,12720,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ñ‚ ÑÑƒÐ¼Ð°',0),(457891,12720,'ur','Ù…Ø³ØªØ«Ù†ÛŒ Ø±Ù‚Ù…',0),(457892,12720,'sr','Ð˜Ð·ÑƒÐ·ÐµÑ‚ Ð¸Ð·Ð½Ð¾Ñ',0),(457893,12720,'vi','Loáº¡i trá»« giÃ¡ trá»‹',0),(457894,12720,'af','Vrygestelde bedrag',0),(457895,12720,'ro','Scutit suma',0),(457896,12720,'et','Maksuvaba summa',0),(457897,12720,'si','OproÅ¡Äene znesek',0),(457898,12720,'ba','Jumlah dibebaskan',0),(457899,12720,'nl','Vrijgesteld bedrag',0),(457900,12720,'fi','Verovapaa summa',0),(457901,12720,'no','Unntatt belÃ¸p',0),(457902,12720,'da','Afgiftsfri belÃ¸b',0),(457903,12720,'ko','ë©´ì œ ê¸ˆì•¡',0),(457904,12720,'he','×¡×›×•× ×¤×˜×•×¨',0),(457905,12720,'el','Î¤Î¿ Ï€Î¿ÏƒÏŒ',0),(457906,12720,'zh','è±å…æ•°é¢',0),(457907,12720,'sv','Undanta belopp',0),(457908,12720,'it','QuantitÃ  esenti',0),(457909,12720,'tl','',0),(457910,12720,'th','à¸ˆà¸³à¸™à¸§à¸™à¹€à¸‡à¸´à¸™à¸¢à¸à¹€à¸§à¹‰à¸™',0),(457911,12720,'hi','à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤°à¤¾à¤¶à¤¿',0),(457912,12720,'ms','Amaun yang dikecualikan',0),(457913,12720,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¥Ø¹ÙØ§Ø¡',0),(457914,12720,'fr','Montant exonÃ©rÃ©',0),(457915,12720,'jp','æŽ§é™¤é‡‘é¡',0),(457916,12720,'pt','Quantidade isenta',0),(457917,12720,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ñ‹ ÑÑƒÐ¼Ð¼Ñ‹',0),(457918,12720,'es','Cantidad Exenta',0),(457919,12720,'de','Steuerfreier Betrag',0),(457920,12720,'en','Exempt Amount',0),(457921,12721,'is','',0),(457922,12721,'dr','Ù†Ù…Ø§ÛŒØ´ ØªÙˆØ¶ÛŒØ­Ø§Øª Ú©Ø§Ù„Ø§',0),(457923,12721,'pr','Ù†Ù…Ø§ÛŒØ´ ØªÙˆØ¶ÛŒØ­Ø§Øª Ú©Ø§Ù„Ø§',0),(457924,12721,'tr','Ã–ÄŸe aÃ§Ä±klama gÃ¶ster',0),(457925,12721,'pl','PokaÅ¼ element opis',0),(457926,12721,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(457927,12721,'ur','Ø´Û’ ØªØµØ±ÛŒØ­ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(457928,12721,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ Ð¾Ð¿Ð¸Ñ',0),(457929,12721,'vi','Thá»ƒ hiá»‡n diá»…n giáº£i cá»§a danh má»¥c',0),(457930,12721,'af','Wys Item Beskrywing',0),(457931,12721,'ro','Element AratÄƒ Descriere',0),(457932,12721,'et','NÃ¤ita kauba kirjeldus',0),(457933,12721,'si','PokaÅ¾i element opis',0),(457934,12721,'ba','Menunjukkan Deskripsi Item',0),(457935,12721,'nl','Beschrijving Item weergeven',0),(457936,12721,'fi','NÃ¤ytÃ¤ kohteen kuvaus',0),(457937,12721,'no','Vis beskrivelse',0),(457938,12721,'da','Vis vare beskrivelse',0),(457939,12721,'ko','í•­ëª© ì„¤ëª… ë³´ê¸°',0),(457940,12721,'he','×”×¦×’ ×¤×¨×™×˜ ×ª×™××•×¨',0),(457941,12721,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(457942,12721,'zh','æ˜¾ç¤ºé¡¹ç›®æè¿°',0),(457943,12721,'sv','Visa objekt Beskrivning',0),(457944,12721,'it','Visualizza articolo Descrizione',0),(457945,12721,'tl','',0),(457946,12721,'th','à¹à¸ªà¸”à¸‡à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸£à¸²à¸¢à¸à¸²à¸£',0),(457947,12721,'hi','à¤®à¤¦ à¤µà¤¿à¤µà¤°à¤£ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(457948,12721,'ms','Menunjukkan perkara keterangan',0),(457949,12721,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„ÙˆØµÙ',0),(457950,12721,'fr','Afficher les Description',0),(457951,12721,'jp','é …ç›®ã®èª¬æ˜Žã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(457952,12721,'pt','Mostrar Item DescriÃ§Ã£o',0),(457953,12721,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(457954,12721,'es','Muestra DescripciÃ³n de Item',0),(457955,12721,'de','Element Beschreibung anzeigen',0),(457956,12721,'en','Show Item Description',0),(457957,12722,'is','',0),(457958,12722,'dr','Ù†Ù…Ø§ÛŒØ´ ÙØ§Ú©ØªÙˆØ±',0),(457959,12722,'pr','Ù†Ù…Ø§ÛŒØ´ ÙØ§Ú©ØªÙˆØ±',0),(457960,12722,'tr','FaturayÄ± GÃ¶rÃ¼ntÃ¼le',0),(457961,12722,'pl','Zobacz faktura',0),(457962,12722,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(457963,12722,'ur','Ù…Ù†Ø¸Ø± Ø§Ù†ÙˆØ§Ø¦Ø³',0),(457964,12722,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(457965,12722,'vi','Xem hÃ³a Ä‘Æ¡n',0),(457966,12722,'af','Besigtig Faktuur',0),(457967,12722,'ro','Vezi factura',0),(457968,12722,'et','Kuva arve',0),(457969,12722,'si','Pogledu raÄuna',0),(457970,12722,'ba','Lihat faktur',0),(457971,12722,'nl','Factuur bekijken',0),(457972,12722,'fi','NÃ¤ytÃ¤ lasku',0),(457973,12722,'no','Vis fakturaen',0),(457974,12722,'da','Vis faktura',0),(457975,12722,'ko','ë³´ê¸° ì†¡ìž¥',0),(457976,12722,'he','×”×¦×’ ×—×©×‘×•× ×™×ª',0),(457977,12722,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(457978,12722,'zh','æŸ¥çœ‹å‘ç¥¨',0),(457979,12722,'sv','Visa faktura',0),(457980,12722,'it','Vista fattura',0),(457981,12722,'tl','',0),(457982,12722,'th','à¸”à¸¹à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(457983,12722,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸',0),(457984,12722,'ms','Lihat invois',0),(457985,12722,'ar','Ø¹Ø±Ø¶ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(457986,12722,'fr','Afficher la facture',0),(457987,12722,'jp','ç´å“æ›¸ã®è¡¨ç¤º',0),(457988,12722,'pt','Ver fatura',0),(457989,12722,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÑ‡ÐµÑ‚Ð°',0),(457990,12722,'es','Visionar Factura',0),(457991,12722,'de','Rechnung anzeigen',0),(457992,12722,'en','View Invoice',0),(457993,12723,'is','',0),(457994,12723,'dr','Ù¾ÛŒØºØ§Ù… Ø¯Ø§Ø®Ù„ÛŒ',0),(457995,12723,'pr','Ù¾ÛŒØºØ§Ù… Ø¯Ø§Ø®Ù„ÛŒ',0),(457996,12723,'tr','Ä°Ã§ ileti gÃ¶nderme',0),(457997,12723,'pl','WewnÄ™trznej komunikacji',0),(457998,12723,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(457999,12723,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ù¾ÛŒØºØ§Ù… Ø±Ø³Ø§Ù†ÛŒ',0),(458000,12723,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð½Ð° Ð¿Ð¾Ñ€ÑƒÐºÐ°',0),(458001,12723,'vi','thÃ´ng tin ná»™i bá»™',0),(458002,12723,'af','Interne Boodskapdiens',0),(458003,12723,'ro','Mesagerie internÄƒ',0),(458004,12723,'et','Sisemine sÃµnumside',0),(458005,12723,'si','Notranjega sporoÄila',0),(458006,12723,'ba','Pesan internal',0),(458007,12723,'nl','Intern berichtensysteem',0),(458008,12723,'fi','SisÃ¤inen viestintÃ¤',0),(458009,12723,'no','Interne meldinger',0),(458010,12723,'da','Interne Messaging',0),(458011,12723,'ko','ë‚´ë¶€ ë©”ì‹œì§•',0),(458012,12723,'he','×ž×¡×¨×™× ×¤× ×™×ž×™×™×',0),(458013,12723,'el','Î‘Î½Ï„Î±Î»Î»Î±Î³Î® ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÏŽÎ½ Î¼Î·Î½Ï…Î¼Î¬Ï„Ï‰Î½',0),(458014,12723,'zh','å†…éƒ¨æ¶ˆæ¯',0),(458015,12723,'sv','Interna meddelanden',0),(458016,12723,'it','Messaggistica interna',0),(458017,12723,'tl','',0),(458018,12723,'th','à¸ªà¹ˆà¸‡à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸ à¸²à¸¢à¹ƒà¸™',0),(458019,12723,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¸à¤‚à¤¦à¥‡à¤¶',0),(458020,12723,'ms','Mesej dalaman',0),(458021,12723,'ar','Ø§Ù„Ù…Ø±Ø§Ø³Ù„Ø© Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(458022,12723,'fr','La messagerie interne',0),(458023,12723,'jp','å†…éƒ¨ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ãƒ³ã‚°',0),(458024,12723,'pt','Mensagens internas',0),(458025,12723,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÑÑ ÑÐ¸ÑÑ‚ÐµÐ¼Ð° Ð¾Ð±Ð¼ÐµÐ½Ð° ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸ÑÐ¼Ð¸',0),(458026,12723,'es','Mensajes Internales',0),(458027,12723,'de','Interne Nachrichten',0),(458028,12723,'en','Internal Messaging',0),(458029,12724,'is','',0),(458030,12724,'dr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø¨ÛŒÙ†',0),(458031,12724,'pr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø¨ÛŒÙ†',0),(458032,12724,'tr','ArasÄ±nda YayÄ±nlanan',0),(458033,12724,'pl','PisaÅ‚ miÄ™dzy',0),(458034,12724,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾ Ð¼ÐµÐ¶Ð´Ñƒ',0),(458035,12724,'ur','Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(458036,12724,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¾ Ð¸Ð·Ð¼ÐµÑ’Ñƒ',0),(458037,12724,'vi','káº¿t chuyá»ƒn giá»¯a',0),(458038,12724,'af','Tussen gepos',0),(458039,12724,'ro','Postat Ã®ntre',0),(458040,12724,'et','Postitatud',0),(458041,12724,'si','Objavljeno med',0),(458042,12724,'ba','Diposting antara',0),(458043,12724,'nl','Gepost tussen',0),(458044,12724,'fi','LÃ¤hetetty vÃ¤lillÃ¤',0),(458045,12724,'no','Skrevet mellom',0),(458046,12724,'da','Sendt mellem',0),(458047,12724,'ko','ë°°ì¹˜ í•˜ëŠ” ì‚¬ì´',0),(458048,12724,'he','×¤×•×¨×¡× ×‘×™×Ÿ',0),(458049,12724,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®Î¸Î·ÎºÎµ Î¼ÎµÏ„Î±Î¾Ï',0),(458050,12724,'zh','å¼ è´´ä¹‹é—´',0),(458051,12724,'sv','Inlagd mellan',0),(458052,12724,'it','Pubblicato tra',0),(458053,12724,'tl','',0),(458054,12724,'th','à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(458055,12724,'hi','à¤•à¥‡ à¤¬à¥€à¤š à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(458056,12724,'ms','Dipos antara',0),(458057,12724,'ar','Ù†Ø´Ø±Øª Ø¨ÙŠÙ†',0),(458058,12724,'fr','PostÃ© entre',0),(458059,12724,'jp','é–“ã«æŽ²ç¤º',0),(458060,12724,'pt','Publicadas entre',0),(458061,12724,'ru','ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¾ Ð¼ÐµÐ¶Ð´Ñƒ',0),(458062,12724,'es','Asentado Entre',0),(458063,12724,'de','Und zwischen',0),(458064,12724,'en','Posted Between',0),(458065,12725,'is','',0),(458066,12725,'dr','Ø§Ù…ØªÛŒØ§Ø²Ø§Øª Ú©Ø§Ø±Ø¨Ø± Ø²ÛŒØ±  Ø¨Ø±Ø§ÛŒ Ø§Ø¯Ø§Ù…Ù‡ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²Ø§Ø³Øª',0),(458067,12725,'pr','Ø§Ù…ØªÛŒØ§Ø²Ø§Øª Ú©Ø§Ø±Ø¨Ø± Ø²ÛŒØ±  Ø¨Ø±Ø§ÛŒ Ø§Ø¯Ø§Ù…Ù‡ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²Ø§Ø³Øª',0),(458068,12725,'tr','AÅŸaÄŸÄ±daki kullanÄ±cÄ± ayrÄ±calÄ±klarÄ±nÄ± devam etmek iÃ§in gerekli olan',0),(458069,12725,'pl','NastÄ™pujÄ…ce uprawnienia uÅ¼ytkownika sÄ… potrzebne, aby przejÅ›Ä‡',0),(458070,12725,'bg','Ð¡Ð»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸Ð²Ð¸Ð»ÐµÐ³Ð¸Ð¸ ÑÐ° Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸, Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸Ñ‚Ðµ',0),(458071,12725,'ur','Ø¢Ú¯Û’ Ø¨Ú‘Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ ØµØ§Ø±Ù Ú©Û’ Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(458072,12725,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ðµ Ð¿Ñ€Ð¸Ð²Ð¸Ð»ÐµÐ³Ð¸Ñ˜Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° ÐºÐ¾Ñ˜Ð¸ ÑÑƒ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¸ Ð·Ð° Ð½Ð°ÑÑ‚Ð°Ð²Ð°Ðº',0),(458073,12725,'vi','Nhá»¯ng Ä‘áº·c quyá»n cá»§a ngÆ°á»i sá»­ dá»¥ng sau Ä‘Ã¢y lÃ  cáº§n thiáº¿t Ä‘á»ƒ tiáº¿n hÃ nh',0),(458074,12725,'af','Die volgende gebruiker voorregte is nodig om voort te',0),(458075,12725,'ro','UrmÄƒtoarele privilegii de utilizator sunt necesare pentru a proceda',0),(458076,12725,'et','Kasutaja Ãµigused on vaja jÃ¤tkata',0),(458077,12725,'si','Te uporabniÅ¡ke pravice so potrebne za nadaljevanje',0),(458078,12725,'ba','Hak pengguna berikut diperlukan untuk melanjutkan',0),(458079,12725,'nl','De volgende gebruikersrechten nodig zijn om verder te gaan',0),(458080,12725,'fi','Seuraavia kÃ¤yttÃ¶oikeuksia tarvitaan edetÃ¤',0),(458081,12725,'no','FÃ¸lgende brukerrettigheter er nÃ¸dvendig for Ã¥ fortsette',0),(458082,12725,'da','De fÃ¸lgende brugerrettigheder er nÃ¸dvendige for at fortsÃ¦tte',0),(458083,12725,'ko','ë‹¤ìŒ ì‚¬ìš©ìž ê¶Œí•œì´ ì§„í–‰ í•˜ëŠ” ë° í•„ìš”í•œ',0),(458084,12725,'he','×”×¨×©××•×ª ×”×ž×©×ª×ž×© ×”×‘××™× × ×“×¨×©×™× ×œ×”×ž×©×™×š',0),(458085,12725,'el','Î¤Î± ÎµÎ¾Î®Ï‚ Ï€ÏÎ¿Î½ÏŒÎ¼Î¹Î± Ï‡ÏÎ®ÏƒÏ„Î· Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î³Î¹Î± Î½Î± Ï€ÏÎ¿Ï‡Ï‰ÏÎ®ÏƒÎ¿Ï…Î¼Îµ',0),(458086,12725,'zh','ä¸‹åˆ—ç”¨æˆ·æƒé™è¢«å¿…éœ€ç»§ç»­',0),(458087,12725,'sv','FÃ¶ljande anvÃ¤ndarbehÃ¶righeter krÃ¤vs fÃ¶r att fortsÃ¤tta',0),(458088,12725,'it','I seguenti privilegi utente sono necessari per procedere',0),(458089,12725,'tl','',0),(458090,12725,'th','à¸ªà¸´à¸—à¸˜à¸´à¹Œà¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¸ˆà¸°à¸•à¹‰à¸­à¸‡à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸•à¹ˆà¸­à¹„à¸›',0),(458091,12725,'hi','à¤†à¤—à¥‡ à¤¬à¤¢à¤¼à¤¨à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤®à¥à¤¨ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤µà¤¿à¤¶à¥‡à¤·à¤¾à¤§à¤¿à¤•à¤¾à¤° à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¤‚',0),(458092,12725,'ms','Keistimewaan pengguna berikut diperlukan untuk meneruskan',0),(458093,12725,'ar','Ø§Ù…ØªÙŠØ§Ø²Ø§Øª Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„ØªØ§Ù„ÙŠØ© Ø¶Ø±ÙˆØ±ÙŠØ© Ù„Ù„Ù…Ø¶ÙŠ Ù‚Ø¯Ù…Ø§',0),(458094,12725,'fr','Les privilÃ¨ges d\'utilisateur suivants sont nÃ©cessaires pour aller de l\'avant',0),(458095,12725,'jp','ç¶šè¡Œã™ã‚‹ã€æ¬¡ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©é™ãŒå¿…è¦',0),(458096,12725,'pt','Os privilÃ©gios de usuÃ¡rio a seguir sÃ£o necessÃ¡rios para prosseguir',0),(458097,12725,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð¿Ñ€Ð¸Ð²Ð¸Ð»ÐµÐ³Ð¸Ð¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ñ‹ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶ÐµÐ½Ð¸Ñ',0),(458098,12725,'es','Los siguientes privilegios se necesitan para proceder',0),(458099,12725,'de','Die folgenden Benutzerberechtigungen sind erforderlich, um fortzufahren',0),(458100,12725,'en','The following user privileges are needed to proceed',0),(458101,12726,'is','',0),(458102,12726,'dr','Ø¨Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ø§ÛŒÙ† Ú©Ø§Ø¯Ø± Ù…Ù† ØªØµØ¯ÛŒÙ‚ Ù…ÛŒ Ú©Ù†Ù… Ú©Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø±Ø§ Ø®ÙˆØ§Ù†Ø¯Ù‡ Ùˆ Ù…ØªÙˆ Ø¬Ù‡ Ø´Ø¯Ù‡ Ø§Ù…',0),(458103,12726,'pr','Ø¨Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ø§ÛŒÙ† Ú©Ø§Ø¯Ø± Ù…Ù† ØªØµØ¯ÛŒÙ‚ Ù…ÛŒ Ú©Ù†Ù… Ú©Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø±Ø§ Ø®ÙˆØ§Ù†Ø¯Ù‡ Ùˆ Ù…ØªÙˆ Ø¬Ù‡ Ø´Ø¯Ù‡ Ø§Ù…',0),(458104,12726,'tr','Bu kutuyu iÅŸaretleyerek, ben okudum tasdik ve<br>Bu iletide yer alan bilgileri anlamak.',0),(458105,12726,'pl','ZaznaczajÄ…c to pole, potwierdzam, Å¼e przeczytaÅ‚em i<br>zrozumieÄ‡ informacje zawarte w tej wiadomoÅ›ci.',0),(458106,12726,'bg','Ð§Ñ€ÐµÐ· Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ñ‚Ð¾Ð²Ð° Ð¿Ð¾Ð»Ðµ, Ð°Ð· Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´Ð°Ð²Ð°Ð¼, Ñ‡Ðµ ÑÑŠÐ¼ Ð¿Ñ€Ð¾Ñ‡ÐµÐ» Ð¸<br>Ñ€Ð°Ð·Ñ‡Ð¸Ñ‚Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑÑ‚Ð°, ÑÑŠÐ´ÑŠÑ€Ð¶Ð°Ñ‰Ð° ÑÐµ Ð² Ñ‚Ð¾Ð²Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ.',0),(458107,12726,'ur','ÛŒÛ Ø¨Ø§Ú©Ø³ Ú©ÛŒ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ØŒ Ù…ÛŒÚº Ù…ÛŒÚº Ù†Û’ Ù¾Ú‘Ú¾Ø§ ÛÛ’ Ú©Û ØªØµØ¯ÛŒÙ‚ Ø§ÙˆØ±<br>Ø§Ø³ Ù¾ÛŒØºØ§Ù… Ù…ÛŒÚº Ø´Ø§Ù…Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ùˆ Ø³Ù…Ø¬Ú¾ØªÛ’ ÛÛŒÚº Û”',0),(458108,12726,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð°Ð²Ð°ÑšÐµÐ¼ Ð¾Ð²Ñƒ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ, Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™ÑƒÑ˜ÐµÐ¼ Ð´Ð° ÑÐ°Ð¼ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ð»Ð¸ Ð¸<br>Ð Ð°Ð·ÑƒÐ¼ÐµÐ¼ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ ÐºÐ¾Ñ˜Ðµ ÑÐµ Ð½Ð°Ð»Ð°Ð·Ðµ Ñƒ Ð¾Ð²Ð¾Ñ˜ Ð¿Ð¾Ñ€ÑƒÑ†Ð¸.',0),(458109,12726,'vi','Báº±ng cÃ¡ch kiá»ƒm tra thÃ´ng bÃ¡o nÃ y, tÃ´i xÃ¡c nháº­n ráº±ng tÃ´i Ä‘Ã£ Ä‘á»c vÃ  <br/>',0),(458110,12726,'af','Deur kontroleer hierdie boks, het ek sertifiseer dat ek gelees het en<br>verstaan die inligting vervat in hierdie boodskap.',0),(458111,12726,'ro','BifÃ¢nd aceastÄƒ casetÄƒ, certific cÄƒ am citit ÅŸi<br>Ã®nÅ£eleg informaÅ£iile conÅ£inute Ã®n acest mesaj.',0),(458112,12726,'et','Ruudu kontrollides kinnitan, et olen lugenud ja<br>mÃµistavad selles sÃµnumis sisalduva teabe.',0),(458113,12726,'si','Z izbiro tega polja, potrjujem, da sem prebral in<br>razumejo informacije v to sporoÄilo.',0),(458114,12726,'ba','Dengan mencentang kotak ini, saya menyatakan bahwa saya telah membaca dan<br>memahami informasi yang terkandung dalam pesan ini.',0),(458115,12726,'nl','Door dit vakje aan te vinken, ik verklaar dat ik heb gelezen en<br>de informatie in dit bericht opgenomen in begrijpt.',0),(458116,12726,'fi','TÃ¤mÃ¤n ruudun rastittamalla vakuutan, ettÃ¤ olen lukenut ja<br>ymmÃ¤rtÃ¤Ã¤ tÃ¤mÃ¤n viestin tiedot.',0),(458117,12726,'no','Merker denne boksen, jeg bekrefter at jeg har lest og<br>forstÃ¥ informasjonen i denne meldingen.',0),(458118,12726,'da','Ved at markere dette felt, attesterer, at jeg har lÃ¦st og<br>forstÃ¥ oplysningerne i denne meddelelse.',0),(458119,12726,'ko','ì´ í™•ì¸ëž€ì„ ì„ íƒ í•˜ ì—¬ ì½ê³ ëŠ” ì¦ëª… ë°<br>ì´ ë©”ì‹œì§€ì— í¬í•¨ ëœ ì •ë³´ë¥¼ ì´í•´ í•©ë‹ˆë‹¤.',0),(458120,12726,'he','×¢×œ ×™×“×™ ×¡×™×ž×•×Ÿ ×ª×™×‘×” ×–×•, ×©××§×‘×¢ ×›×™ ×§×¨××ª×™,<br>×œ×”×‘×™×Ÿ ××ª ×”×ž×™×“×¢ ×”×›×œ×•×œ ×‘×”×•×“×¢×” ×–×•.',0),(458121,12726,'el','Î•Ï€Î¹Î»Î­Î³Î¿Î½Ï„Î±Ï‚ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿, Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹ÏŽ ÏŒÏ„Î¹ Î­Ï‡Ï‰ Î´Î¹Î±Î²Î¬ÏƒÎµÎ¹ ÎºÎ±Î¹<br>ÎºÎ±Ï„Î±Î½Î¿Î®ÏƒÎ¿Ï…Î½ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î¿Ï… Ï€ÎµÏÎ¹Î­Ï‡Î¿Î½Ï„Î±Î¹ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î®Î½Ï…Î¼Î±.',0),(458122,12726,'zh','é€‰ä¸­æ­¤æ¡†ï¼Œæˆ‘ä¿è¯æˆ‘å·²é˜…è¯»å¹¶äº†è§£æ­¤æ¶ˆæ¯æ‰€åŒ…å«çš„ä¿¡æ¯ã€‚',0),(458123,12726,'sv','Genom att markera denna ruta, intygar jag att jag har lÃ¤st och<br>fÃ¶rstÃ¥ den information som finns i detta meddelande.',0),(458124,12726,'it','Selezionando questa casella, dichiaro di aver letto e<br>comprendere le informazioni contenute in questo messaggio.',0),(458125,12726,'tl','',0),(458126,12726,'th','à¹‚à¸”à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸¥à¹ˆà¸­à¸‡à¸™à¸µà¹‰ à¸‰à¸±à¸™à¸£à¸±à¸šà¸£à¸­à¸‡à¸§à¹ˆà¸² à¸‰à¸±à¸™à¹„à¸”à¹‰à¸­à¹ˆà¸²à¸™ à¹à¸¥à¸°<br>à¹€à¸‚à¹‰à¸²à¹ƒà¸ˆà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸™à¸µà¹‰',0),(458127,12726,'hi','à¤‡à¤¸ à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¤•à¥‡, à¤®à¥ˆà¤‚ à¤ªà¥à¤°à¤®à¤¾à¤£à¤¿à¤¤ à¤•à¤°à¤¤à¥‡ à¤¹à¥ˆ à¤•à¤¿ à¤®à¥ˆà¤‚à¤¨à¥‡ à¤ªà¤¢à¤¼à¤¾ à¤¹à¥ˆ à¤”à¤°<br>à¤‡à¤¸ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤¨à¤¿à¤¹à¤¿à¤¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤®à¤à¤¤à¥‡ à¤¹',0),(458128,12726,'ms','Dengan menanda kotak ini, saya mengesahkan bahawa saya telah membaca dan<br>memahami maklumat yang terkandung dalam mesej ini.',0),(458129,12726,'ar','Ø¨Ø§Ø®ØªÙŠØ§Ø± Ù‡Ø°Ø§ Ø§Ù„Ù…Ø±Ø¨Ø¹ØŒ Ø£Ù‚Ø± Ø¨Ø£Ù†ÙŠ Ù‚Ø±Ø£Øª  ÙˆÙÙ‡Ù…Øª Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªÙŠ ØªØ­ØªÙˆÙŠÙ‡Ø§ Ù‡Ø°Ù‡ Ø§Ù„Ø±Ø³Ø§Ù„Ø©.',0),(458130,12726,'fr','En cochant cette case, je certifie que j\'ai lu et<br>comprendre les informations contenues dans ce message.',0),(458131,12726,'jp','ã“ã®ãƒœãƒƒã‚¯ã‚¹ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¦èª­ã‚“ã ã“ã¨ãŒã‚ã‚‹ã‚’è¨¼æ˜Žã—ã€<br>ã“ã®ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã«å«ã¾ã‚Œã‚‹æƒ…å ±ã‚’ç†è§£ã—ã¾ã™ã€‚',0),(458132,12726,'pt','Marcando esta caixa, eu declaro que li e<br>compreenda as informaÃ§Ãµes contidas nesta mensagem.',0),(458133,12726,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ð² ÑÑ‚Ð¾Ñ‚ Ñ„Ð»Ð°Ð¶Ð¾Ðº, Ñ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´Ð°ÑŽ, Ñ‡Ñ‚Ð¾ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ð» Ð¸<br>Ð¿Ð¾Ð½Ð¸Ð¼Ð°ÐµÑ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ, ÑÐ¾Ð´ÐµÑ€Ð¶Ð°Ñ‰ÑƒÑŽÑÑ Ð² ÑÑ‚Ð¾Ð¼ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¸.',0),(458134,12726,'es','Por tachar esta caja, certifico que he leido y </b> entiendo la informaciÃ³n',0),(458135,12726,'de','Durch Ankreuzen dieses Feldes bestÃ¤tige ich, dass ich gelesen habe und<br>in dieser Nachricht enthaltene Informationen zu verstehen.',0),(458136,12726,'en','By checking this box, I certify that I have read and <br/> understand the information contained in this message.',0),(458137,12727,'is','',0),(458138,12727,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø¹ØªØ¨Ø± Ù†ÛŒØ³Øª',0),(458139,12727,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø¹ØªØ¨Ø± Ù†ÛŒØ³Øª',0),(458140,12727,'tr','GeÃ§ersiz satÄ±cÄ±',0),(458141,12727,'pl','NieprawidÅ‚owy dostawcy',0),(458142,12727,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(458143,12727,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² ÙØ±ÙˆØ´Ù†Ø¯Û',0),(458144,12727,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(458145,12727,'vi','nhÃ  cung cáº¥p khÃ´ng cÃ³',0),(458146,12727,'af','Ongeldige handelaar',0),(458147,12727,'ro','Furnizor nevalid',0),(458148,12727,'et','Sobimatu hankija',0),(458149,12727,'si','Neveljaven dobavitelja',0),(458150,12727,'ba','Vendor tidak valid',0),(458151,12727,'nl','Ongeldige leverancier',0),(458152,12727,'fi','Virheellinen toimittaja',0),(458153,12727,'no','Ugyldig leverandÃ¸r',0),(458154,12727,'da','Ugyldig leverandÃ¸r',0),(458155,12727,'ko','ìž˜ëª» ëœ ê³µê¸‰ ì—…ì²´',0),(458156,12727,'he','×”×¡×¤×§ ×œ× ×—×•×§×™',0),(458157,12727,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(458158,12727,'zh','æ— æ•ˆçš„ä¾›åº”å•†',0),(458159,12727,'sv','Ogiltig leverantÃ¶r',0),(458160,12727,'it','Fornitore non valido',0),(458161,12727,'tl','',0),(458162,12727,'th','à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(458163,12727,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(458164,12727,'ms','Penjual yang tidak sah',0),(458165,12727,'ar','Ø§Ù„Ù…ÙˆØ±Ø¯ ØºÙŠØ± ØµØ§Ù„Ø­Ø©',0),(458166,12727,'fr','Fournisseur non valide',0),(458167,12727,'jp','ç„¡åŠ¹ãªãƒ™ãƒ³ãƒ€ãƒ¼',0),(458168,12727,'pt','Fornecedor invÃ¡lido',0),(458169,12727,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº',0),(458170,12727,'es','Proveedor InvÃ¡lido',0),(458171,12727,'de','UngÃ¼ltige VerkÃ¤ufer',0),(458172,12727,'en','Invalid Vendor',0),(458173,12728,'is','',0),(458174,12728,'dr','..',0),(458175,12728,'pr','Ø§Ù…Ø¶Ø§Ù‡Ø§ÛŒ Ù…Ù…Ú©Ù†..',0),(458176,12728,'tr','Sigs mÃ¼mkÃ¼n',0),(458177,12728,'pl','MoÅ¼liwe sigs',0),(458178,12728,'bg','Sigs Ð²ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð¾',0),(458179,12728,'ur','Ø³Ø§Ú¯Ø³ Ù…Ù…Ú©Ù† ÛÙˆ',0),(458180,12728,'sr','Ð¡Ð¸Ð³Ñ Ð¼Ð¾Ð³ÑƒÑ›Ðµ',0),(458181,12728,'vi','CÃ³ thá»ƒ sigs',0),(458182,12728,'af','Sigs moontlik',0),(458183,12728,'ro','Sigs posibil',0),(458184,12728,'et','Sigs vÃµimalik',0),(458185,12728,'si','Sigs mogoÄe',0),(458186,12728,'ba','Mungkin SIGS',0),(458187,12728,'nl','Sigs mogelijk',0),(458188,12728,'fi','Sigs mahdollista',0),(458189,12728,'no','Sigs mulig',0),(458190,12728,'da','Sigs muligt',0),(458191,12728,'ko','í†µì‹  ê°€ëŠ¥',0),(458192,12728,'he','×”××¤×©×¨ ×¡×™×’×¡',0),(458193,12728,'el','Î”Ï…Î½Î±Ï„ÏŒÎ½ sigs',0),(458194,12728,'zh','å®žè´¨åˆ©ç›Šå°ç»„å¯èƒ½',0),(458195,12728,'sv','Sigs mÃ¶jligt',0),(458196,12728,'it','Sigs possibili',0),(458197,12728,'tl','',0),(458198,12728,'th','à¸ªà¸¸à¸” Sigs',0),(458199,12728,'hi','Sigs à¤¸à¤‚à¤­à¤µ',0),(458200,12728,'ms','Ia mungkin',0),(458201,12728,'ar','Ù…Ù…ÙƒÙ† Sigs',0),(458202,12728,'fr','Sigs Possible',0),(458203,12728,'jp','Sig ãŒå¯èƒ½',0),(458204,12728,'pt','PossÃ­vel de Sigs',0),(458205,12728,'ru','Ð’Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Sigs',0),(458206,12728,'es','Sigs Posible',0),(458207,12728,'de','Sigs mÃ¶glich',0),(458208,12728,'en','Sigs Possible',0),(458209,12729,'is','',0),(458210,12729,'dr','ØªØ¹Ø¯Ø§Ø¯Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† Ù…Ø´ØªØ±Ú© Ø§Ù„Ù…Ù†Ø§ÙØ¹',0),(458211,12729,'pr','ØªØ¹Ø¯Ø§Ø¯Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† Ù…Ø´ØªØ±Ú© Ø§Ù„Ù…Ù†Ø§ÙØ¹',0),(458212,12729,'tr','Sigs sayÄ±sÄ±',0),(458213,12729,'pl','Liczba sygnaturki',0),(458214,12729,'bg','Ð‘Ñ€Ð¾Ð¹ Sigs',0),(458215,12729,'ur','Ø³Ø§Ú¯Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(458216,12729,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¡Ð¸Ð³Ñ',0),(458217,12729,'vi','sá»‘ sigs',0),(458218,12729,'af','Aantal Sigs',0),(458219,12729,'ro','NumÄƒrul de Sigs',0),(458220,12729,'et','Sigs arv',0),(458221,12729,'si','Å tevilo Sigs',0),(458222,12729,'ba','Jumlah SIG',0),(458223,12729,'nl','Aantal Sigs',0),(458224,12729,'fi','MÃ¤Ã¤rÃ¤ Sigs',0),(458225,12729,'no','Antall Sigs',0),(458226,12729,'da','Antallet af Sigs',0),(458227,12729,'ko','ì‹œê·¸ë§ˆì˜ ìˆ˜',0),(458228,12729,'he','×ž×¡×¤×¨ ×¡×™×’×¡',0),(458229,12729,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Sigs',0),(458230,12729,'zh','å®žè´¨åˆ©ç›Šå°ç»„çš„æ•°ç›®',0),(458231,12729,'sv','Antal Sigs',0),(458232,12729,'it','Numero di firme',0),(458233,12729,'tl','',0),(458234,12729,'th','à¸ˆà¸³à¸™à¸§à¸™ Sigs',0),(458235,12729,'hi','Sigs à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(458236,12729,'ms','Jumlah ia',0),(458237,12729,'ar','Ø¹Ø¯Ø¯ Ù…Ù† Sigs',0),(458238,12729,'fr','Nombre de Sigs',0),(458239,12729,'jp','Sig ã®æ•°',0),(458240,12729,'pt','NÃºmero de Sigs',0),(458241,12729,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Sigs',0),(458242,12729,'es','NÃºmero de Firmas',0),(458243,12729,'de','Anzahl der Sigs',0),(458244,12729,'en','Number of Sigs',0),(458245,12730,'is','',0),(458246,12730,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¬Ù‡Øª ÙˆÛŒØ±Ø§ÛŒØ´',0),(458247,12730,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¬Ù‡Øª ÙˆÛŒØ±Ø§ÛŒØ´',0),(458248,12730,'tr','Gemi iÃ§in DÃ¼zenle',0),(458249,12730,'pl','Statek do edycji',0),(458250,12730,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(458251,12730,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(458252,12730,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(458253,12730,'vi','Chuyá»ƒn Ä‘áº¿n Ä‘á»ƒ sá»­a',0),(458254,12730,'af','Skip-om te redigeer',0),(458255,12730,'ro','Livrare-la editare',0),(458256,12730,'et','Edit',0),(458257,12730,'si','Ladja za urejanje',0),(458258,12730,'ba','Kapal ke Edit',0),(458259,12730,'nl','Verzendadres bewerken',0),(458260,12730,'fi','Toimitusasiakkaan muokkaus',0),(458261,12730,'no','Lever til-Rediger',0),(458262,12730,'da','Skib-til Rediger',0),(458263,12730,'ko','ë°°ë¥¼ íŽ¸ì§‘',0),(458264,12730,'he','×¢×¨×™×›×” ×œ×ž×©×œ×•×—',0),(458265,12730,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(458266,12730,'zh','èˆ¹è‡³ç¼–è¾‘',0),(458267,12730,'sv','Leveransadress redigera',0),(458268,12730,'it','Spedire a Edit',0),(458269,12730,'tl','',0),(458270,12730,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹„à¸›à¹à¸à¹‰à¹„à¸‚',0),(458271,12730,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(458272,12730,'ms','Kapal untuk Edit',0),(458273,12730,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù„ØªØ­Ø±ÙŠØ±',0),(458274,12730,'fr','Ship-to Edit',0),(458275,12730,'jp','èˆ¹ã‚’ç·¨é›†',0),(458276,12730,'pt','Envio-a editar',0),(458277,12730,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(458278,12730,'es','Enviar-A Editar',0),(458279,12730,'de','Lieferadresse bearbeiten',0),(458280,12730,'en','Ship-to Edit',0),(458281,12731,'is','',0),(458282,12731,'dr','...',0),(458283,12731,'pr','Ø§Ù…Ø¶Ø§Ù‡Ø§...',0),(458284,12731,'tr','Sigs',0),(458285,12731,'pl','Sygnaturki',0),(458286,12731,'bg','Sigs',0),(458287,12731,'ur','Ø³Ø§Ú¯Ø³',0),(458288,12731,'sr','Ð¡Ð¸Ð³Ñ',0),(458289,12731,'vi','Sigs',0),(458290,12731,'af','Sigs',0),(458291,12731,'ro','Sigs',0),(458292,12731,'et','Sigs',0),(458293,12731,'si','Sigs',0),(458294,12731,'ba','SIG',0),(458295,12731,'nl','Sigs',0),(458296,12731,'fi','Sigs',0),(458297,12731,'no','Sigs',0),(458298,12731,'da','Sigs',0),(458299,12731,'ko','ì‹œ ê·¸',0),(458300,12731,'he','×¡×™×’×¡',0),(458301,12731,'el','Sigs',0),(458302,12731,'zh','å®žè´¨åˆ©ç›Šå°ç»„',0),(458303,12731,'sv','Sigs',0),(458304,12731,'it','Sigs',0),(458305,12731,'tl','',0),(458306,12731,'th','Sigs',0),(458307,12731,'hi','Sigs',0),(458308,12731,'ms','Ia',0),(458309,12731,'ar','Sigs',0),(458310,12731,'fr','Sigs',0),(458311,12731,'jp','Sig',0),(458312,12731,'pt','Sigs',0),(458313,12731,'ru','ÐžÐ—Ð“',0),(458314,12731,'es','Sigs',0),(458315,12731,'de','Sigs',0),(458316,12731,'en','Sigs',0),(458317,12732,'is','',0),(458318,12732,'dr','Ø§Ø²Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ¹Ø¯Ø§Ø¯ Ø®Ø±ÛŒØ¯Ø§Ø±Ø§Ù† Ø¨ÛŒØ´ØªØ± Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(458319,12732,'pr','Ø§Ø²Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ¹Ø¯Ø§Ø¯ Ø®Ø±ÛŒØ¯Ø§Ø±Ø§Ù† Ø¨ÛŒØ´ØªØ± Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(458320,12732,'tr','MÃ¼ÅŸteriler iÃ§in en fazla sayÄ±sÄ± aÅŸÄ±ldÄ±',0),(458321,12732,'pl','Przekroczono maksymalnÄ… liczbÄ™ klientÃ³w',0),(458322,12732,'bg','Ð• Ð½Ð°Ð´Ñ…Ð²ÑŠÑ€Ð»ÐµÐ½ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ Ð±Ñ€Ð¾Ð¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(458323,12732,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ØªØ¹Ø¯Ø§Ø¯ Ù…ÛŒÚº Ú¯Ø§ÛÚ©ÙˆÚº Ø³Û’ ØªØ¬Ø§ÙˆØ² Ú©Ø± Ú¯Ø¦ÛŒ ÛÛ’',0),(458324,12732,'sr','ÐŸÑ€ÐµÐ¼Ð°ÑˆÐµÐ½ Ñ˜Ðµ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»Ð°Ð½ Ð±Ñ€Ð¾Ñ˜ ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(458325,12732,'vi','Tá»‘i Ä‘a sá»‘ khÃ¡ch hÃ ng Ä‘Æ°á»£c vÆ°á»£t quÃ¡',0),(458326,12732,'af','Maksimum aantal kliÃ«nte het nie oorskry is nie',0),(458327,12732,'ro','S-a depÄƒÈ™it numÄƒrul maxim de clienÅ£ii',0),(458328,12732,'et','Hotelli maksimumarv on Ã¼letatud',0),(458329,12732,'si','PreseÅ¾eno najveÄje Å¡tevilo stranke',0),(458330,12732,'ba','Jumlah maksimum pelanggan telah melampaui',0),(458331,12732,'nl','Maximum aantal klanten is overschreden',0),(458332,12732,'fi','Asiakkaat enimmÃ¤ismÃ¤Ã¤rÃ¤ on ylitetty',0),(458333,12732,'no','Maksimalt antall kunder er overskredet',0),(458334,12732,'da','Maksimale antal gÃ¦ster er overskredet',0),(458335,12732,'ko','ê³ ê°ì˜ ìµœëŒ€ ê°œìˆ˜ë¥¼ ì´ˆê³¼ í–ˆìŠµë‹ˆë‹¤.',0),(458336,12732,'he','×”×ž×¡×¤×¨ ×”×ž×¨×‘×™ ×©×œ ×”×œ×§×•×—×•×ª ××™×¨×¢×” ×—×¨×™×’×”',0),(458337,12732,'el','ÎžÎµÏ€ÎµÏÎ¬ÏƒÏ„Î·ÎºÎµ Î¿ Î¼Î­Î³Î¹ÏƒÏ„Î¿Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(458338,12732,'zh','å·²è¶…å‡ºå®¢æˆ·çš„æœ€å¤§æ•°ç›®',0),(458339,12732,'sv','Maximalt antal kunder har Ã¶verskridits',0),(458340,12732,'it','Ãˆ stato superato il numero massimo di clienti',0),(458341,12732,'tl','',0),(458342,12732,'th','à¹€à¸à¸´à¸™à¸ˆà¸³à¸™à¸§à¸™à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(458343,12732,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥€ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤¾à¤° à¤¹à¥‹ à¤—à¤ˆ à¤¹à¥ˆ',0),(458344,12732,'ms','Maksimum bilangan pelanggan telah melebihi',0),(458345,12732,'ar','ØªÙ… ØªØ¬Ø§ÙˆØ² Ø£Ù‚ØµÙ‰ Ø¹Ø¯Ø¯ Ù…Ù† Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(458346,12732,'fr','Nombre maximal de clients a Ã©tÃ© dÃ©passÃ©e',0),(458347,12732,'jp','é¡§å®¢ã®æœ€å¤§æ•°ã‚’è¶…ãˆã¾ã—ãŸ',0),(458348,12732,'pt','Foi excedido o nÃºmero mÃ¡ximo de clientes',0),(458349,12732,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐµÐ½Ð¾ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(458350,12732,'es','Se ExcediÃ³ el NÃºmero Maximo de Clientes ',0),(458351,12732,'de','Maximale Anzahl der Kunden wurde Ã¼berschritten',0),(458352,12732,'en','Maximum Number of Customers Has Been Exceeded',0),(458353,12733,'is','',0),(458354,12733,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡',0),(458355,12733,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡',0),(458356,12733,'tr','Hesaplanan toplam',0),(458357,12733,'pl','Obliczone Å‚Ä…cznie',0),(458358,12733,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐµÐ¼Ð°Ñ‚Ð° Ð¾Ð±Ñ‰Ð° ÑÑƒÐ¼Ð°',0),(458359,12733,'ur','Ù…Ø­Ø³ÙˆØ¨ Ù…ÛŒØ²Ø§Ù†',0),(458360,12733,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚Ð¸ Ð·Ð±Ð¸Ñ€',0),(458361,12733,'vi','TÃ­nh tá»•ng',0),(458362,12733,'af','Berekende Totaal',0),(458363,12733,'ro','Total calculat',0),(458364,12733,'et','Arvutatud kogusumma',0),(458365,12733,'si','IzraÄunane vsote',0),(458366,12733,'ba','Total dihitung',0),(458367,12733,'nl','Berekende totaal',0),(458368,12733,'fi','Lasketun summan',0),(458369,12733,'no','Beregnede totalen',0),(458370,12733,'da','Beregnede samlede',0),(458371,12733,'ko','ê³„ì‚° ëœ ì´',0),(458372,12733,'he','×¡×š ×”×›×œ ×ž×—×•×©×‘',0),(458373,12733,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÏ„Î±Î¹ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(458374,12733,'zh','è®¡ç®—çš„æ€»è®¡',0),(458375,12733,'sv','BerÃ¤knad Total',0),(458376,12733,'it','Totale calcolato',0),(458377,12733,'tl','',0),(458378,12733,'th','à¸œà¸¥à¸£à¸§à¸¡à¸—à¸µà¹ˆà¸„à¸³à¸™à¸§à¸“à¹„à¸”à¹‰',0),(458379,12733,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¿à¤¤ à¤¯à¥‹à¤—',0),(458380,12733,'ms','Kiraan jumlah',0),(458381,12733,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù…Ø­Ø³ÙˆØ¨',0),(458382,12733,'fr','Total calculÃ©',0),(458383,12733,'jp','é›†è¨ˆ',0),(458384,12733,'pt','Total calculado',0),(458385,12733,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾Ð²Ð¾Ðµ',0),(458386,12733,'es','Total Calculado',0),(458387,12733,'de','Berechnete Summe',0),(458388,12733,'en','Calculated Total',0),(458389,12734,'is','',0),(458390,12734,'dr','Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙˆÛŒÚ˜Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(458391,12734,'pr','Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙˆÛŒÚ˜Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ ',0),(458392,12734,'tr','KullanÄ±lan Ã¶zel fiyatlandÄ±rma',0),(458393,12734,'pl','Specjalne ceny uÅ¼ywanych',0),(458394,12734,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ñ†ÐµÐ½Ð¸ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°',0),(458395,12734,'ur','Ø®ØµÙˆØµÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(458396,12734,'sr','ÐŸÐ¾ÑÐµÐ±Ð½Ðµ Ñ†ÐµÐ½Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(458397,12734,'vi','GiÃ¡ Ä‘áº·c biá»‡t Ä‘Æ°á»£c sá»­ dá»¥ng',0),(458398,12734,'af','Spesiale pryse gebruik',0),(458399,12734,'ro','PreÅ£uri speciale utilizate',0),(458400,12734,'et','Erilisi hinnakujundust kasutatakse',0),(458401,12734,'si','Posebne cene, ki se uporablja',0),(458402,12734,'ba','Harga khusus digunakan',0),(458403,12734,'nl','Speciale prijzen gebruikt',0),(458404,12734,'fi','Erikoishintaan kÃ¤yttÃ¤Ã¤',0),(458405,12734,'no','Spesialpriser brukes',0),(458406,12734,'da','SÃ¦rlige priser anvendes',0),(458407,12734,'ko','íŠ¹ë³„ ê°€ê²© ì‚¬ìš©',0),(458408,12734,'he','×ª×ž×—×•×¨ ×ž×™×•×—×“×ª ×‘×©×™×ž×•×©',0),(458409,12734,'el','Î•Î¹Î´Î¹ÎºÎ­Ï‚ Ï„Î¹Î¼Î­Ï‚ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹',0),(458410,12734,'zh','ç”¨äºŽç‰¹æ®Šå®šä»·',0),(458411,12734,'sv','SÃ¤rskild prissÃ¤ttning anvÃ¤nds',0),(458412,12734,'it','Prezzi speciali usati',0),(458413,12734,'tl','',0),(458414,12734,'th','à¸£à¸²à¸„à¸²à¸žà¸´à¹€à¸¨à¸©à¹ƒà¸Šà¹‰',0),(458415,12734,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¤°à¤¤à¥‡ à¤¥à¥‡',0),(458416,12734,'ms','Harga khas yang digunakan',0),(458417,12734,'ar','Ø§Ù„ØªØ³Ø¹ÙŠØ± Ø§Ù„Ø®Ø§ØµØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø©',0),(458418,12734,'fr','Prix spÃ©ciaux utilisÃ©s',0),(458419,12734,'jp','ç‰¹åˆ¥ä¾¡æ ¼ã‚’ä½¿ç”¨',0),(458420,12734,'pt','PreÃ§os especiais usados',0),(458421,12734,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ñ†ÐµÐ½Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ',0),(458422,12734,'es','Precios Especiales Usados',0),(458423,12734,'de','Sonderpreise verwendet',0),(458424,12734,'en','Special Pricing Used',0),(458425,12735,'is','',0),(458426,12735,'dr','Ø´Ù…Ø§ Ø§Ø² Ø­Ø¯ Ù…Ø¬Ø§Ø² ÙØ±Ø§ØªØ± Ø±ÙØªÙ‡ Ø§ÛŒØ¯',0),(458427,12735,'pr','Ø´Ù…Ø§ Ø§Ø² Ø­Ø¯ Ù…Ø¬Ø§Ø² ÙØ±Ø§ØªØ± Ø±ÙØªÙ‡ Ø§ÛŒØ¯',0),(458428,12735,'tr','Ä°zin verilen sÄ±nÄ±rÄ± aÅŸtÄ±nÄ±z',0),(458429,12735,'pl','PrzekroczyÅ‚eÅ› Limit dozwolony',0),(458430,12735,'bg','ÐÐ°Ð´Ð²Ð¸ÑˆÐ¸Ð»Ð¸ ÑÑ‚Ðµ Ð³Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð°, Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð°',0),(458431,12735,'ur','Ø¢Ù¾ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ú©ÛŒ Ø­Ø¯ Ø³Û’ ØªØ¬Ø§ÙˆØ² Ú©Ø± Ú†Ú©Ø§ ÛÛ’',0),(458432,12735,'sr','ÐŸÑ€ÐµÐºÐ¾Ñ€Ð°Ñ‡Ð¸Ð»Ð¸ ÑÑ‚Ðµ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÑšÐµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(458433,12735,'vi','Báº¡n Ä‘Ã£ vÆ°á»£t quÃ¡ cÃ¡c giá»›i háº¡n cho phÃ©p',0),(458434,12735,'af','Jy het die toegelate limiet oorskry',0),(458435,12735,'ro','A fost depÄƒÈ™itÄƒ limita permisÄƒ',0),(458436,12735,'et','Olete Ã¼letanud lubatud piiri',0),(458437,12735,'si','Presegli ste dovoljeno omejitev',0),(458438,12735,'ba','Anda telah melebihi batas yang diperbolehkan',0),(458439,12735,'nl','U hebt de overschreden toegestaan',0),(458440,12735,'fi','Olet ylittÃ¤nyt sallitun rajan',0),(458441,12735,'no','Du har overskredet tillatt',0),(458442,12735,'da','Du har overskredet den tilladte',0),(458443,12735,'ko','í—ˆìš© í•œê³„ë¥¼ ì´ˆê³¼ í–ˆìŠµë‹ˆë‹¤.',0),(458444,12735,'he','×—×¨×’×ª ×ž×ž×’×‘×œ×ª ×”×ž×•×ª×¨',0),(458445,12735,'el','ÎˆÏ‡ÎµÏ„Îµ Ï…Ï€ÎµÏÎ²ÎµÎ¯ Ï„Î¿ ÏŒÏÎ¹Î¿ Ï€Î¿Ï… ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(458446,12735,'zh','æ‚¨å·²è¶…å‡ºäº†å…è®¸çš„é™åˆ¶',0),(458447,12735,'sv','Du har Ã¶verskridit den grÃ¤ns tillÃ¥tet',0),(458448,12735,'it','Hai superato il limite consentito',0),(458449,12735,'tl','',0),(458450,12735,'th','à¸„à¸¸à¸“à¸¡à¸µà¹€à¸à¸´à¸™à¸‚à¸µà¸”à¸ˆà¸³à¸à¸±à¸”à¸—à¸µà¹ˆà¸­à¸™à¸¸à¸à¸²à¸•',0),(458451,12735,'hi','à¤†à¤ª à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤•à¥€ à¤¸à¥€à¤®à¤¾ à¤ªà¤¾à¤° à¤•à¤° à¤šà¥à¤•à¥‡ à¤¹à¥ˆà¤‚',0),(458452,12735,'ms','Anda telah melebihi had yang dibenarkan',0),(458453,12735,'ar','Ù„Ù‚Ø¯ ØªØ¬Ø§ÙˆØ²Øª Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(458454,12735,'fr','Vous avez dÃ©passÃ© la limite permise',0),(458455,12735,'jp','è¨±å¯ã•ã‚Œã‚‹åˆ¶é™ã‚’è¶…ãˆã¦ã„ã¾ã™ã€‚',0),(458456,12735,'pt','VocÃª excedeu o limite permitido',0),(458457,12735,'ru','Ð’Ñ‹ Ð¿Ñ€ÐµÐ²Ñ‹ÑÐ¸Ð»Ð¸ Ð´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ Ð¿Ñ€ÐµÐ´ÐµÐ»',0),(458458,12735,'es','Se ExcediÃ³ el LÃ­mite Permitido',0),(458459,12735,'de','Sie haben die Grenze Ã¼berschritten.',0),(458460,12735,'en','You Have Exceeded the Limit Allowed',0),(458461,12736,'is','',0),(458462,12736,'dr','-Ù‡Ù…Ù‡ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡',0),(458463,12736,'pr','Ø¨ÛŒØ´ Ø§Ø² Ø­Ø¯Ø§Ú©Ø«Ø± Ø®Ø±ÛŒØ¯Ø§Ø±Ø§Ù†-Ù‡Ù…Ù‡ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡',0),(458464,12736,'tr','En bÃ¼yÃ¼k mÃ¼ÅŸteriler aÅŸÄ±ldÄ± - tÃ¼m ithal',0),(458465,12736,'pl','Przekroczenie maksymalnej klientÃ³w - nie wszystkie importowane',0),(458466,12736,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð½Ð°Ð´Ð²Ð¸ÑˆÐ°Ð²Ð° - Ð½Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð²Ð½ÐµÑÐµÐ½Ð¸',0),(458467,12736,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ú¯Ø§ÛÚ©ÙˆÚº Ø³Û’ Ù…ØªØ¬Ø§ÙˆØ² - Ù†ÛÛŒÚº ØªÙ…Ø§Ù… Ø¯Ø±Ø¢Ù…Ø¯',0),(458468,12736,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° ÐºÑƒÐ¿Ñ†Ðµ Ð¿Ñ€ÐµÐ¼Ð°ÑˆÐ¸Ð¾ - Ð½Ð¸ÑÑƒ ÑÐ²Ð¸ ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸',0),(458469,12736,'vi','Tá»‘i Ä‘a sá»‘ khÃ¡ch hÃ ng -táº¥t cáº£ khÃ´ng Ä‘Æ°á»£c nháº­p',0),(458470,12736,'af','Maksimum kliÃ«nte oorskry - nie al ingevoer',0),(458471,12736,'ro','ClienÅ£ii maximÄƒ depÄƒÅŸitÄƒ - nu toate importate',0),(458472,12736,'et','Maksimaalne hotelli Ã¼letas - kÃµik imporditud',0),(458473,12736,'si','PreseÅ¾eno najveÄje stranke - vsi uvoÅ¾eni',0),(458474,12736,'ba','Pelanggan maksimum melebihi - tidak semua diimpor',0),(458475,12736,'nl','Maximale klanten overschreden - niet alle geÃ¯mporteerd',0),(458476,12736,'fi','Mahdollisimman asiakkaita ylitetty: kaikki tuodut',0),(458477,12736,'no','Maksimal kunder overskredet - ikke alle importert',0),(458478,12736,'da','Maksimale kunder overskredet - ikke alle importerede',0),(458479,12736,'ko','ìµœëŒ€ ê³ ê° ì´ˆê³¼-ëª¨ë“  ìˆ˜ìž…',0),(458480,12736,'he','×ž×¨×‘×™×ª ×”×œ×§×•×—×•×ª ×—×¨×™×’×” - ×œ× ×›×•×œ× ××•×”×‘×™×',0),(458481,12736,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï…Ï€Î­ÏÎ²Î±ÏƒÎ· - Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏŒÎ»Î± ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(458482,12736,'zh','æœ€å¤§çš„å®¢æˆ·è¶…è¿‡-å¹¶ä¸æ˜¯æ‰€æœ‰å¯¼å…¥',0),(458483,12736,'sv','Maximal kunder Ã¶vertrÃ¤ffat - inte alla importerade',0),(458484,12736,'it','Clienti massimi superata - non tutti importati',0),(458485,12736,'tl','',0),(458486,12736,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¹€à¸à¸´à¸™ - à¹„à¸¡à¹ˆà¸«à¸¡à¸”à¸—à¸µà¹ˆà¸™à¸³à¹€à¸‚à¹‰à¸²',0),(458487,12736,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤ªà¤¾à¤° à¤•à¤° - à¤¨à¤¹à¥€à¤‚ à¤¸à¤­à¥€ à¤†à¤¯à¤¾à¤¤à¤¿à¤¤',0),(458488,12736,'ms','Maksimum pelanggan melebihi - tidak semua yang diimport',0),(458489,12736,'ar','ØªØ¬Ø§ÙˆØ² Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù…Ù† Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡-Ù„ÙŠØ³Øª ÙƒÙ„Ù‡Ø§ Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(458490,12736,'fr','Clients maximum dÃ©passÃ© - pas tous importÃ©s',0),(458491,12736,'jp','æœ€å¤§ã®é¡§å®¢ã‚’è¶…ãˆã¾ã—ãŸ - ã™ã¹ã¦ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(458492,12736,'pt','Clientes mÃ¡ximos excedido - nem todos importados',0),(458493,12736,'ru','ÐœÐ°ÐºÑÐ¸Ð¼ÑƒÐ¼ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ñ€ÐµÐ²Ñ‹ÑÐ¸Ð»Ð¸ - Ð½Ðµ Ð²ÑÐµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐµÐ¼Ñ‹Ðµ',0),(458494,12736,'es','Se Excede el NÃºmero Maximo de Clientes - No Todos Importados',0),(458495,12736,'de','Maximale Kunden Ã¼berschritten - nicht alle importiert',0),(458496,12736,'en','Maximum Customers Exceeded - Not All Imported',0),(458497,12737,'is','',0),(458498,12737,'dr','-Ù‡Ù…Ù‡ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡',0),(458499,12737,'pr','Ø¨ÛŒØ´ Ø§Ø² Ø­Ø¯Ø§Ú©Ø«Ø± Ú©Ø§Ù„Ø§-Ù‡Ù…Ù‡ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡',0),(458500,12737,'tr','En fazla Ã¶ÄŸe aÅŸÄ±ldÄ± - tÃ¼m ithal',0),(458501,12737,'pl','Przekroczona maksymalna liczba elementÃ³w - nie wszystkie importowane',0),(458502,12737,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ Ð±Ñ€Ð¾Ð¹ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð½Ð°Ð´Ð²Ð¸ÑˆÐ°Ð²Ð° - Ð½Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð²Ð½ÐµÑÐµÐ½Ð¸',0),(458503,12737,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø§Ø´ÛŒØ§ Ø³Û’ Ù…ØªØ¬Ø§ÙˆØ² - Ù†ÛÛŒÚº ØªÙ…Ø§Ù… Ø¯Ø±Ø¢Ù…Ø¯',0),(458504,12737,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð°Ð½ Ð±Ñ€Ð¾Ñ˜ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ñ€ÐµÐ¼Ð°ÑˆÐ¸Ð¾ - Ð½Ð¸ÑÑƒ ÑÐ²Ð¸ ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸',0),(458505,12737,'vi','Tá»‘i Ä‘a sá»‘ má»¥c -táº¥t cáº£ khÃ´ng Ä‘Æ°á»£c nháº­p',0),(458506,12737,'af','Maksimum Items oorskry - nie al ingevoer',0),(458507,12737,'ro','Elemente de maximÄƒ depÄƒÅŸitÄƒ - nu toate importate',0),(458508,12737,'et','Ãœksuste maksimumarv Ã¼letada - kÃµik imporditud',0),(458509,12737,'si','NajveÄ elementov preseÅ¾ena - vsi uvoÅ¾eni',0),(458510,12737,'ba','Melebihi maksimum item - tidak semua diimpor',0),(458511,12737,'nl','Maximale Items overschreden - niet alle geÃ¯mporteerd',0),(458512,12737,'fi','Kohteiden enimmÃ¤ismÃ¤Ã¤rÃ¤ ylitetty: kaikki tuodut',0),(458513,12737,'no','Maksimalt antall elementer overskredet - ikke alle importert',0),(458514,12737,'da','Maksimale elementer overskredet - ikke alle importerede',0),(458515,12737,'ko','ìµœëŒ€ í•­ëª© ì´ˆê³¼-ëª¨ë“  ìˆ˜ìž…',0),(458516,12737,'he','×¤×¨×™×˜×™× ×ž×™×¨×‘×™ ×—×¨×™×’×” - ×œ× ×›×•×œ× ××•×”×‘×™×',0),(458517,12737,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î¿Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Ï…Ï€Î­ÏÎ²Î±ÏƒÎ· - Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏŒÎ»Î± ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(458518,12737,'zh','æœ€å¤§çš„é¡¹ç›®ä¸Šå¤§å¤§è¶…è¶Š â€” â€” å¹¶ä¸æ˜¯æ‰€æœ‰å¯¼å…¥',0),(458519,12737,'sv','Maximal objekt Ã¶vertrÃ¤ffat - inte alla importerade',0),(458520,12737,'it','Massimo colli superato - non tutti importati',0),(458521,12737,'tl','',0),(458522,12737,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¹€à¸à¸´à¸™ - à¹„à¸¡à¹ˆà¸«à¸¡à¸”à¸—à¸µà¹ˆà¸™à¸³à¹€à¸‚à¹‰à¸²',0),(458523,12737,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤ªà¤¾à¤° à¤•à¤° - à¤¨à¤¹à¥€à¤‚ à¤¸à¤­à¥€ à¤†à¤¯à¤¾à¤¤à¤¿à¤¤',0),(458524,12737,'ms','Butiran maksimum melebihi - tidak semua yang diimport',0),(458525,12737,'ar','ØªØ¬Ø§ÙˆØ² Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ù„Ø¹Ù†Ø§ØµØ±-Ù„ÙŠØ³Øª ÙƒÙ„Ù‡Ø§ Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(458526,12737,'fr','Ã‰lÃ©ments maximum dÃ©passÃ© - pas tous importÃ©s',0),(458527,12737,'jp','æœ€å¤§ã®é …ç›®æ•°ã‚’è¶…ãˆã¦ã„ã¾ã™ - ã™ã¹ã¦ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(458528,12737,'pt','Itens mÃ¡ximos excedido - nem todos importados',0),(458529,12737,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐµÐ½Ð¾ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ðµ Ñ‡Ð¸ÑÐ»Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² - Ð½Ðµ Ð²ÑÐµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐµÐ¼Ñ‹Ðµ',0),(458530,12737,'es','Se Excede el NÃºmero Maximo de Items - No Todos Importados',0),(458531,12737,'de','Maximale Elemente Ã¼berschritten - nicht alle importiert',0),(458532,12737,'en','Maximum Items Exceeded - Not All Imported',0),(458533,12738,'is','',0),(458534,12738,'dr','Ø§Ø²Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ¹Ø¯Ø§Ø¯Ú©Ø§Ù„Ø§Ù‡Ø§ Ø¨ÛŒØ´ØªØ± Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(458535,12738,'pr','Ø§Ø²Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ¹Ø¯Ø§Ø¯Ú©Ø§Ù„Ø§Ù‡Ø§ Ø¨ÛŒØ´ØªØ± Ø´Ø¯Ù‡ Ø§Ø³Øª ',0),(458536,12738,'tr','En fazla Ã¶ÄŸe sayÄ±sÄ± aÅŸÄ±ldÄ±',0),(458537,12738,'pl','Przekroczono maksymalnÄ… liczbÄ™ elementÃ³w',0),(458538,12738,'bg','Ð• Ð½Ð°Ð´Ñ…Ð²ÑŠÑ€Ð»ÐµÐ½ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ Ð±Ñ€Ð¾Ð¹ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(458539,12738,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ø¨Ú‘ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø¢Ú¯Û’ Ø¨Ú‘Ú¾ Ú†Ú©ÛŒ ÛÛ’',0),(458540,12738,'sr','ÐŸÑ€ÐµÐ¼Ð°ÑˆÐµÐ½ Ñ˜Ðµ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»Ð°Ð½ Ð±Ñ€Ð¾Ñ˜ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(458541,12738,'vi','Tá»‘i Ä‘a sá»‘ má»¥c Ä‘Æ°á»£c vÆ°á»£t quÃ¡',0),(458542,12738,'af','Maksimum aantal Items oorskry',0),(458543,12738,'ro','S-a depÄƒÈ™it numÄƒrul maxim de elemente',0),(458544,12738,'et','Ãœksuste suurim arv Ã¼letas',0),(458545,12738,'si','NajveÄje Å¡tevilo elementov je preseÅ¾eno',0),(458546,12738,'ba','Maksimum jumlah item telah melampaui',0),(458547,12738,'nl','Maximum aantal Items is overschreden',0),(458548,12738,'fi','Kohteiden enimmÃ¤ismÃ¤Ã¤rÃ¤ on ylitetty',0),(458549,12738,'no','Maksimalt antall elementer er overskredet',0),(458550,12738,'da','Maksimalt antal elementer er overskredet',0),(458551,12738,'ko','í•­ëª©ì˜ ìµœëŒ€ ê°œìˆ˜ë¥¼ ì´ˆê³¼ í–ˆìŠµë‹ˆë‹¤.',0),(458552,12738,'he','×”×ž×¡×¤×¨ ×”×ž×™×¨×‘×™ ×©×œ ×¤×¨×™×˜×™× ××™×¨×¢×” ×—×¨×™×’×”',0),(458553,12738,'el','ÎžÎµÏ€ÎµÏÎ¬ÏƒÏ„Î·ÎºÎµ Î¿ Î¼Î­Î³Î¹ÏƒÏ„Î¿Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(458554,12738,'zh','å·²è¶…å‡ºæœ€å¤§é¡¹ç›®æ•°',0),(458555,12738,'sv','Maximalt antal objekt har Ã¶verskridits',0),(458556,12738,'it','Ãˆ stato superato il numero massimo di elementi',0),(458557,12738,'tl','',0),(458558,12738,'th','à¹€à¸à¸´à¸™à¸ˆà¸³à¸™à¸§à¸™à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¸‚à¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(458559,12738,'hi','à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥€ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤¾à¤° à¤¹à¥‹ à¤—à¤ˆ à¤¹à¥ˆ',0),(458560,12738,'ms','Maksimum bilangan item telah melebihi',0),(458561,12738,'ar','ØªÙ… ØªØ¬Ø§ÙˆØ² Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ø¹Ø¯Ø¯ Ù…Ù† Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(458562,12738,'fr','Nombre maximal d\'Ã©lÃ©ments a Ã©tÃ© dÃ©passÃ©e',0),(458563,12738,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®æœ€å¤§æ•°ã‚’è¶…ãˆã¾ã—ãŸ',0),(458564,12738,'pt','Foi excedido o nÃºmero mÃ¡ximo de itens',0),(458565,12738,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐµÐ½Ð¾ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ðµ Ñ‡Ð¸ÑÐ»Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(458566,12738,'es','Se ExcediÃ³ el NÃºmero Maximo de Items ',0),(458567,12738,'de','Maximale Anzahl von Elementen wurde Ã¼berschritten',0),(458568,12738,'en','Maximum Number of Items Has Been Exceeded',0),(458569,12739,'is','',0),(458570,12739,'dr','Ú©Ø§Ø¯Ø±Ø§Ø¶Ø§ÙÛŒ',0),(458571,12739,'pr','Ú©Ø§Ø¯Ø±Ø§Ø¶Ø§ÙÛŒ',0),(458572,12739,'tr','Ek kutularÄ±',0),(458573,12739,'pl','Dodatkowe pola',0),(458574,12739,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(458575,12739,'ur','Ø§Ø¶Ø§ÙÛŒ Ø®Ø§Ù†Û’',0),(458576,12739,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÐºÑƒÑ‚Ð¸Ñ˜Ðµ',0),(458577,12739,'vi','Pháº§n cá»™ng thÃªm',0),(458578,12739,'af','Addisionele Bokse',0),(458579,12739,'ro','Cutii suplimentare',0),(458580,12739,'et','TÃ¤iendav kastid',0),(458581,12739,'si','Dodatna polja',0),(458582,12739,'ba','Tambahan kotak',0),(458583,12739,'nl','Aanvullende boxen',0),(458584,12739,'fi','LisÃ¤ruudut',0),(458585,12739,'no','Flere bokser',0),(458586,12739,'da','Yderligere bokse',0),(458587,12739,'ko','ì¶”ê°€ ìƒìž',0),(458588,12739,'he','×ª×™×‘×•×ª × ×•×¡×¤×•×ª',0),(458589,12739,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Ï‡Î±ÏÏ„Î¿ÎºÎ¹Î²ÏŽÏ„Î¹Î±',0),(458590,12739,'zh','é™„åŠ æ¡†',0),(458591,12739,'sv','Ytterligare lÃ¥dor',0),(458592,12739,'it','Altre caselle',0),(458593,12739,'tl','',0),(458594,12739,'th','à¸à¸¥à¹ˆà¸­à¸‡à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(458595,12739,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¬à¤•à¥à¤¸à¥‡',0),(458596,12739,'ms','Perkhidmatan tambahan',0),(458597,12739,'ar','Ù…Ø±Ø¨Ø¹Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ©',0),(458598,12739,'fr','BoÃ®tes supplÃ©mentaires',0),(458599,12739,'jp','è¿½åŠ ã®ãƒœãƒƒã‚¯ã‚¹',0),(458600,12739,'pt','Caixas adicionais',0),(458601,12739,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÑ‰Ð¸ÐºÐ¸',0),(458602,12739,'es','Cajas adicionales',0),(458603,12739,'de','ZusÃ¤tzliche Boxen',0),(458604,12739,'en','Additional Boxes',0),(458605,12740,'is','',0),(458606,12740,'dr','Ú©Ø§Ø¯Ø± Ø§ÙˆÙ„',0),(458607,12740,'pr','Ú©Ø§Ø¯Ø± Ø§ÙˆÙ„',0),(458608,12740,'tr','Ä°lk kutu',0),(458609,12740,'pl','Pierwsze pole',0),(458610,12740,'bg','ÐŸÑŠÑ€Ð²Ð¾Ñ‚Ð¾ Ð¿Ð¾Ð»Ðµ',0),(458611,12740,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø®Ø§Ù†Û',0),(458612,12740,'sr','ÐŸÑ€Ð²Ð° ÐºÑƒÑ‚Ð¸Ñ˜Ð°',0),(458613,12740,'vi','Há»™p Ä‘áº§u tiÃªn',0),(458614,12740,'af','Eerste blokkie',0),(458615,12740,'ro','Prima casetÄƒ',0),(458616,12740,'et','Esimene kast',0),(458617,12740,'si','Prvo polje',0),(458618,12740,'ba','Kotak pertama',0),(458619,12740,'nl','Eerste vak',0),(458620,12740,'fi','EnsimmÃ¤iseen ruutuun',0),(458621,12740,'no','FÃ¸rste boksen',0),(458622,12740,'da','FÃ¸rste boks',0),(458623,12740,'ko','ì²« ë²ˆì§¸ ìƒìž',0),(458624,12740,'he','×”×ª×™×‘×” ×”×¨××©×•× ×”',0),(458625,12740,'el','Î ÏÏŽÏ„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿',0),(458626,12740,'zh','ç¬¬ä¸€ä¸ªæ¡†ä¸­',0),(458627,12740,'sv','FÃ¶rsta rutan',0),(458628,12740,'it','Prima casella',0),(458629,12740,'tl','',0),(458630,12740,'th','à¸à¸¥à¹ˆà¸­à¸‡à¹à¸£à¸',0),(458631,12740,'hi','à¤ªà¤¹à¤²à¥‡ à¤¬à¥‰à¤•à¥à¤¸',0),(458632,12740,'ms','Kotak pertama',0),(458633,12740,'ar','Ø§Ù„Ù…Ø±Ø¨Ø¹ Ø§Ù„Ø£ÙˆÙ„',0),(458634,12740,'fr','PremiÃ¨re case',0),(458635,12740,'jp','æœ€åˆã®ãƒœãƒƒã‚¯ã‚¹',0),(458636,12740,'pt','Primeira caixa',0),(458637,12740,'ru','ÐŸÐµÑ€Ð²Ð¾Ðµ Ð¿Ð¾Ð»Ðµ',0),(458638,12740,'es','Primer Cajon',0),(458639,12740,'de','Ersten Feld',0),(458640,12740,'en','First Box',0),(458641,12741,'is','',0),(458642,12741,'dr','Ø¨Ø¯ÙˆÙ† Ø¬Ø³ØªØ¬ÙˆÛŒ Ø§ØªÙˆÙ…Ø§ØªÛŒÚ© Ø§Ø²Ø¬Ø¯ÙˆÙ„ Ø²ÛŒØ± Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(458643,12741,'pr','Ø¨Ø¯ÙˆÙ† Ø¬Ø³ØªØ¬ÙˆÛŒ Ø§ØªÙˆÙ…Ø§ØªÛŒÚ© Ø§Ø²Ø¬Ø¯ÙˆÙ„ Ø²ÛŒØ± Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(458644,12741,'tr','EÄŸer deÄŸilse otomatik arama kullanÄ±m tablosu aÅŸaÄŸÄ±da fiyatlandÄ±rma',0),(458645,12741,'pl','JeÅ›li nie automatyczne uÅ¼ycie tabela odnoÅ›nikÃ³w poniÅ¼ej ceny',0),(458646,12741,'bg','ÐÐºÐ¾ Ð½Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð° Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ Ð·Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(458647,12741,'ur','Ø§Ú¯Ø± Ù†ÛÛŒÚº Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø®ÙˆØ¯ Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù…ÛŒØ² Ú©Û’ Ù†ÛŒÚ†Û’',0),(458648,12741,'sr','ÐÐºÐ¾ Ð½Ð¸Ñ˜Ðµ ÐÑƒÑ‚Ð¾ Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ñ‚Ð°Ð±ÐµÐ»Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ð·Ð° Ð¾Ð´Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñ†ÐµÐ½Ð°',0),(458649,12741,'vi','Náº¿u khÃ´ng tÃ¬m kiáº¿m tá»± Ä‘á»™ng thÃ¬ sá»­ dá»¥ng báº£ng dÆ°á»›i Ä‘Ã¢y cho giÃ¡ thÃ nh',0),(458650,12741,'af','Indien nie outomatiese opsoek gebruik tabel vir pryse',0),(458651,12741,'ro','DacÄƒ nu Auto utilizare tabel de cÄƒutare de mai jos pentru preÅ£uri',0),(458652,12741,'et','Vastasel juhul Auto kasutamine Otsingutabeli allapoole hinnakujunduse',0),(458653,12741,'si','ÄŒe ne Auto iskanje uporabi spodnji tabeli za cenitev',0),(458654,12741,'ba','Jika tidak Auto Lookup Gunakan tabel di bawah ini untuk harga',0),(458655,12741,'nl','Zoniet Auto Lookup-gebruik de tabel hieronder voor prijzen',0),(458656,12741,'fi','Jos ei Auto kÃ¤yttÃ¤Ã¤ hakutaulukkoa alla hinnoittelu',0),(458657,12741,'no','Hvis ikke automatisk oppslag Bruk tabellen under For priser',0),(458658,12741,'da','Hvis ikke automatisk opslag Brug tabellen nedenfor til prissÃ¦tning',0),(458659,12741,'ko','í•˜ì§€ ì•Šì„ ê²½ìš° ìžë™ ì¡°íšŒ ì‚¬ìš© ì•„ëž˜ í‘œ ê°€ê²©',0),(458660,12741,'he','×× ×œ× ××•×˜×•×ž×˜×™ ×˜×‘×œ×ª ×‘×“×™×§×ª ×ž×™×“×¢ ×œ×©×™×ž×•×© ×ž×ª×—×ª ×œ×‘×™×¨×•×¨',0),(458661,12741,'el','Î‘Î½ ÏŒÏ‡Î¹ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Ï‡ÏÎ®ÏƒÎ· Ï€Î¯Î½Î±ÎºÎ± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚ Ï€Î¿Ï… Î±ÎºÎ¿Î»Î¿Ï…Î¸ÎµÎ¯ Î³Î¹Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(458662,12741,'zh','å¦‚æžœä¸æ˜¯è‡ªåŠ¨æŸ¥æ‰¾ä½¿ç”¨å®šä»·è¡¨',0),(458663,12741,'sv','Om inte automatisk sÃ¶kning anvÃ¤ndningstabellen nedan fÃ¶r prissÃ¤ttning',0),(458664,12741,'it','Se non la tabella di uso ricerca automatica sotto per i prezzi',0),(458665,12741,'tl','',0),(458666,12741,'th','à¸–à¹‰à¸² à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸–à¸¢à¸™à¸•à¹Œà¹ƒà¸Šà¹‰à¸•à¸²à¸£à¸²à¸‡à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸à¸³à¸«à¸™à¸”à¸£à¸²à¸„à¸²',0),(458667,12741,'hi','à¤¨à¤¹à¥€à¤‚ à¤¤à¥‹ à¤²à¥à¤•à¤…à¤ª à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚ à¤®à¥‡à¤œ à¤•à¥‡ à¤¨à¥€à¤šà¥‡ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤‘à¤Ÿà¥‹',0),(458668,12741,'ms','Jika tidak Auto Lookup Gunakan jadual di bawah untuk harga',0),(458669,12741,'ar','Ø¥Ø°Ø§ Ù„Ù… ÙŠÙƒÙ† Ø§Ù„Ø¨Ø­Ø« Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø£Ø¯Ù†Ø§Ù‡ Ù„Ù„ØªØ³Ø¹ÙŠØ±',0),(458670,12741,'fr','Dans le cas contraire Auto recherche indiquez dans le tableau ci-dessous pour les tarifs',0),(458671,12741,'jp','ã•ã‚Œã¦ã„ãªã„å ´åˆè‡ªå‹•ãƒ«ãƒƒã‚¯ã‚¢ãƒƒãƒ— ãƒ†ãƒ¼ãƒ–ãƒ«ã‚’ä½¿ç”¨ä»¥ä¸‹ã®ä¾¡æ ¼',0),(458672,12741,'pt','Se nÃ£o for Auto tabela de uso de pesquisa abaixo para preÃ§os',0),(458673,12741,'ru','Ð•ÑÐ»Ð¸ Ð½ÐµÑ‚ Ð°Ð²Ñ‚Ð¾ Ð¿Ð¾Ð´ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñƒ Ð½Ð¸Ð¶Ðµ Ð´Ð»Ñ Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(458674,12741,'es','Si No Es Auto Busqueda Usa la Tabla Abajo para Precios',0),(458675,12741,'de','Wenn nicht automatisch Lookup Verwendungstabelle unten fÃ¼r die Preisfindung',0),(458676,12741,'en','If Not Auto Lookup Use Table Below For Pricing',0),(458677,12742,'is','',0),(458678,12742,'dr','(Ø¬Ø§ Ø§ÙØªØ§Ø¯Ú¯ÛŒ) Ø¨Ø±Ø§ÛŒ Ø±Ù†Ú¯ Ù…Ø´Ø§Ø¨Ù‡ Ù†Ø¨Ø§Ø´Ø¯ ',0),(458679,12742,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ú©Ù†ÛŒØ¯ Ø§Ú¯Ø± Ù‡ÛŒÚ† Ù‚Ø·Ø±Ù‡(Ø¬Ø§ Ø§ÙØªØ§Ø¯Ú¯ÛŒ) Ø¨Ø±Ø§ÛŒ Ø±Ù†Ú¯ Ù…Ø´Ø§Ø¨Ù‡ Ù†Ø¨Ø§Ø´Ø¯ ',0),(458680,12742,'tr','Damla yok eÄŸer iÃ§in aynÄ± renk kontrol',0),(458681,12742,'pl','SprawdÅº, czy nie spadek w tym samym kolorze',0),(458682,12742,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ð»Ð¸ Ð½ÑÐ¼Ð° ÐºÐ°Ð¿ÐºÐ° Ð·Ð° ÐµÐ´Ð¸Ð½ Ð¸ ÑÑŠÑ‰Ð¸ Ñ†Ð²ÑÑ‚',0),(458683,12742,'ur','Ø§Ú¯Ø± Ú©ÙˆØ¦ÛŒ Ù‚Ø·Ø±Û Ø§ÛŒÚ© ÛÛŒ Ø±Ù†Ú¯ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(458684,12742,'sr','ÐÐºÐ¾ Ð½ÐµÐ¼Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ðµ ÐŸÐ¾Ñ‚Ñ€Ð°Ð¶Ð¸ Ð¸ÑÑ‚Ðµ Ð±Ð¾Ñ˜Ðµ',0),(458685,12742,'vi','Kiá»ƒm tra náº¿u khÃ´ng drop cÃ¹ng mÃ u',0),(458686,12742,'af','Kontroleer as geen druppel vir dieselfde kleur',0),(458687,12742,'ro','VerificaÅ£i dacÄƒ nici o picÄƒturÄƒ de aceeasi culoare',0),(458688,12742,'et','Kui Ã¼kski tilk otsida sama vÃ¤rvi',0),(458689,12742,'si','Preverite, Äe ne spusti za iste barve',0),(458690,12742,'ba','Periksa apakah ada Drop untuk warna yang sama',0),(458691,12742,'nl','Controleer of geen Drop voor dezelfde kleur',0),(458692,12742,'fi','Tarkista jos ole samaa vÃ¤riÃ¤',0),(458693,12742,'no','Sjekk om No Drop For samme farge',0),(458694,12742,'da','Check hvis ingen Drop For samme farve',0),(458695,12742,'ko','í•˜ë½ í•˜ëŠ” ê²½ìš° ë™ì¼í•œ ìƒ‰ê¹”ì— ëŒ€ í•œ í™•ì¸',0),(458696,12742,'he','×‘×“×•×§ ×× ××™×Ÿ ×™×¨×™×“×” ×‘××•×ª×• ×¦×‘×¢',0),(458697,12742,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î±Î½ Î´ÎµÎ½ Ï€Ï„ÏŽÏƒÎ· Î³Î¹Î± Ï„Î¿ Î¯Î´Î¹Î¿ Ï‡ÏÏŽÎ¼Î±',0),(458698,12742,'zh','æ£€æŸ¥æ˜¯å¦æ²¡æœ‰ä¸‹é™ä¸ºç›¸åŒçš„é¢œè‰²',0),(458699,12742,'sv','Kontrollera om ingen droppe fÃ¶r samma fÃ¤rg',0),(458700,12742,'it','Verificare se nessuna goccia stesso colore',0),(458701,12742,'tl','',0),(458702,12742,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸–à¹‰à¸²à¹„à¸¡à¹ˆà¸«à¸¥à¹ˆà¸™à¸ªà¸µà¹€à¸”à¸µà¸¢à¸§à¸à¸±à¸™',0),(458703,12742,'hi','à¤¯à¤¦à¤¿ à¤•à¥‹à¤ˆ à¤¬à¥‚à¤‚à¤¦ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤¹à¥€ à¤°à¤‚à¤— à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(458704,12742,'ms','Semak jika tiada perubahan warna yang sama',0),(458705,12742,'ar','Ù…Ø¹Ø±ÙØ© Ù…Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø§ Ø¥Ø³Ù‚Ø§Ø· Ù„Ù†ÙØ³ Ø§Ù„Ù„ÙˆÙ†',0),(458706,12742,'fr','VÃ©rifiez si aucune goutte de mÃªme couleur',0),(458707,12742,'jp','åŒã˜è‰²ã®å ´åˆãªã—ãƒ‰ãƒ­ãƒƒãƒ—ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(458708,12742,'pt','Verifique se nenhuma gota de mesma cor',0),(458709,12742,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ, ÐµÑÐ»Ð¸ Ð½Ð¸ ÐºÐ°Ð¿Ð»Ð¸ Ð´Ð»Ñ Ð¾Ð´Ð½Ð¾Ð³Ð¾ Ñ†Ð²ÐµÑ‚Ð°',0),(458710,12742,'es','Cheque Si no Habia Caida para El Mismo Color',0),(458711,12742,'de','ÃœberprÃ¼fen Sie, ob kein Tropfen fÃ¼r dieselbe Farbe',0),(458712,12742,'en','Check If No Drop For Same Color',0),(458713,12743,'is','',0),(458714,12743,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ø¯Ø§Ø¯Ù† Ø¨Ù‡ ØªÚ©Ø«ÛŒØ± ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³Øª',0),(458715,12743,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ø¯Ø§Ø¯Ù† Ø¨Ù‡ ØªÚ©Ø«ÛŒØ± ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³Øª',0),(458716,12743,'tr','Yinelenen PO izin ver',0),(458717,12743,'pl','PozwalajÄ… PO duplikat',0),(458718,12743,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ñ‰Ð¸ PO',0),(458719,12743,'ur','Ù…Ø«Ù†ÛŒ Ù¾Ùˆ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(458720,12743,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚Ð° ÐŸÐž',0),(458721,12743,'vi','Cho phÃ©p sao Ä‘Æ¡n hÃ ng',0),(458722,12743,'af','Laat duplikaat PO',0),(458723,12743,'ro','Permite duplicat PO',0),(458724,12743,'et','Luba duplikaatide PO',0),(458725,12743,'si','Dovoli podvojene PO',0),(458726,12743,'ba','Memungkinkan duplikat PO',0),(458727,12743,'nl','Toestaan dubbele PO',0),(458728,12743,'fi','Salli kaksoiskappaleet PO',0),(458729,12743,'no','Tillat dupliserte PO',0),(458730,12743,'da','Tillad identiske PO',0),(458731,12743,'ko','ì¤‘ë³µ í¬ í—ˆìš©',0),(458732,12743,'he','×œ××¤×©×¨ ×¤×• ×›×¤×•×œ×™×',0),(458733,12743,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î± Î´Î¹Ï€Î»Î¬ PO',0),(458734,12743,'zh','å…è®¸å¤åˆ¶çš„é‡‡è´­è®¢å•',0),(458735,12743,'sv','TillÃ¥t dubbla PO',0),(458736,12743,'it','Consentire PO duplicato',0),(458737,12743,'tl','',0),(458738,12743,'th','à¸­à¸™à¸¸à¸à¸²à¸•à¸‹à¹‰à¸³ PO',0),(458739,12743,'hi','à¤¡à¥à¤ªà¥à¤²à¥€à¤•à¥‡à¤Ÿ à¤ªà¥€à¤“ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(458740,12743,'ms','Membenarkan salinan PO',0),(458741,12743,'ar','ØªØ³Ù…Ø­ Ø¨Ùˆ Ù…ÙƒØ±Ø±Ø©',0),(458742,12743,'fr','Laissez PO en double',0),(458743,12743,'jp','PO ã®é‡è¤‡ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(458744,12743,'pt','Permitir duplicar PO',0),(458745,12743,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ PO',0),(458746,12743,'es','Permite OC Duplicado',0),(458747,12743,'de','Doppelte PO zu ermÃ¶glichen',0),(458748,12743,'en','Allow Duplicate PO',0),(458749,12744,'is','',0),(458750,12744,'dr','Ù‡Ø± Ø¯Ùˆ Ø·Ø±Ù',0),(458751,12744,'pr','Ù‡Ø± Ø¯Ùˆ Ø·Ø±Ù',0),(458752,12744,'tr','Her iki',0),(458753,12744,'pl','Po obu stronach',0),(458754,12744,'bg','Ð˜ Ð´Ð²ÐµÑ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸',0),(458755,12744,'ur','Ø¯ÙˆÙ†ÙˆÚº Ø§Ø·Ø±Ø§Ù',0),(458756,12744,'sr','ÐžÐ±Ðµ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(458757,12744,'vi','Cáº£ 2 máº·t',0),(458758,12744,'af','Beide Kante',0),(458759,12744,'ro','Ambele pÄƒrÅ£i',0),(458760,12744,'et','MÃµlemad pooled',0),(458761,12744,'si','Obe strani',0),(458762,12744,'ba','Kedua belah pihak',0),(458763,12744,'nl','Beide zijden',0),(458764,12744,'fi','Molemmin puolin',0),(458765,12744,'no','Begge sider',0),(458766,12744,'da','Begge sider',0),(458767,12744,'ko','ì–‘ìª½ ëª¨ë‘',0),(458768,12744,'he','×©× ×™ ×”×¦×“×“×™×',0),(458769,12744,'el','ÎšÎ±Î¹ Î¿Î¹ Î´ÏÎ¿ Ï€Î»ÎµÏ…ÏÎ­Ï‚',0),(458770,12744,'zh','åŒæ–¹',0),(458771,12744,'sv','BÃ¥da sidor',0),(458772,12744,'it','Entrambi i lati',0),(458773,12744,'tl','',0),(458774,12744,'th','à¸—à¸±à¹‰à¸‡à¸ªà¸­à¸‡à¸”à¹‰à¸²à¸™',0),(458775,12744,'hi','à¤¦à¥‹à¤¨à¥‹à¤‚ à¤ªà¤•à¥à¤·à¥‹à¤‚ à¤¨à¥‡',0),(458776,12744,'ms','Kedua-dua belah',0),(458777,12744,'ar','ÙƒÙ„Ø§ Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠÙ†',0),(458778,12744,'fr','Les deux cÃ´tÃ©s',0),(458779,12744,'jp','ä¸¡å´',0),(458780,12744,'pt','Ambos os lados',0),(458781,12744,'ru','ÐžÐ±Ðµ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(458782,12744,'es','Ambos Lados',0),(458783,12744,'de','Beide Seiten',0),(458784,12744,'en','Both Sides',0),(458785,12745,'is','',0),(458786,12745,'dr','(Ø³Ù‡Ø§Ù…',0),(458787,12745,'pr','Ø­Ø°Ù Ø§ÛŒÙ† Ø§Ù†Ø¨Ø§Ø±(Ø³Ù‡Ø§Ù…',0),(458788,12745,'tr','Bu hisse senedi Sil',0),(458789,12745,'pl','UsuÅ„ ten czas',0),(458790,12745,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð·Ð°Ð¿Ð°Ñ',0),(458791,12745,'ur','ÛŒÛ Ø§Ø³Ù¹Ø§Ú© Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(458792,12745,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¾Ð²Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(458793,12745,'vi','xÃ³a hÃ ng tá»“n kho nÃ y',0),(458794,12745,'af','Skrap hierdie voorraad',0),(458795,12745,'ro','ÅžtergeÅ£i acest stoc',0),(458796,12745,'et','Kustuta selle varu',0),(458797,12745,'si','Brisanje tega staleÅ¾a',0),(458798,12745,'ba','Menghapus saham ini',0),(458799,12745,'nl','Dit bestand verwijderen',0),(458800,12745,'fi','Poista tÃ¤mÃ¤n kannan',0),(458801,12745,'no','Slett dette lager',0),(458802,12745,'da','Slet denne bestand',0),(458803,12745,'ko','ì´ ì‚¬ì§„ ì‚­ì œ',0),(458804,12745,'he','×œ×ž×—×•×§ ××ª ×”×ž× ×™×”',0),(458805,12745,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î±Ï…Ï„Î¿Ï',0),(458806,12745,'zh','åˆ é™¤è¿™åªè‚¡ç¥¨',0),(458807,12745,'sv','Ta bort detta bestÃ¥nd',0),(458808,12745,'it','Eliminare questo Stock',0),(458809,12745,'tl','',0),(458810,12745,'th','à¸¥à¸šà¸«à¸¸à¹‰à¸™à¸™à¸µà¹‰',0),(458811,12745,'hi','à¤‡à¤¸ à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(458812,12745,'ms','Menghapuskan stok ini',0),(458813,12745,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(458814,12745,'fr','Supprimer ce Stock',0),(458815,12745,'jp','ã“ã®æ ªå¼ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(458816,12745,'pt','Excluir este estoque',0),(458817,12745,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð·Ð°Ð¿Ð°Ñ',0),(458818,12745,'es','Eliminar Este Inventario',0),(458819,12745,'de','Dieser bestand zu lÃ¶schen',0),(458820,12745,'en','Delete This Stock',0),(458821,12746,'is','',0),(458822,12746,'dr','(Ø³Ù‡Ø§Ù…',0),(458823,12746,'pr','Ø¬ÙˆÙ‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§ÛŒÙ† Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ù†Ø¨Ø§Ø±(Ø³Ù‡Ø§Ù…',0),(458824,12746,'tr','Bu hisse senedi kullanÄ±lan mÃ¼rekkepler',0),(458825,12746,'pl','Farby uÅ¼ywane tej akcji',0),(458826,12746,'bg','ÐœÐ°ÑÑ‚Ð¸Ð»Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ñ‚Ð¾Ð·Ð¸ Ð·Ð°Ð¿Ð°Ñ',0),(458827,12746,'ur','Ø§Ù†Ú©Ø³ Ø§Ø³ Ø§Ø³Ù¹Ø§Ú© Ú©Ø±ØªÛ’ ØªÚ¾Û’ Û”',0),(458828,12746,'sr','ÐœÐ°ÑÑ‚Ð¸Ð»Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¾Ð²Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(458829,12746,'vi','má»±c Ä‘Æ°á»£c dÃ¹ng trong kho',0),(458830,12746,'af','Ink gebruik hierdie voorraad',0),(458831,12746,'ro','Cernelurile folosite acest stoc',0),(458832,12746,'et','Tinte kasutatakse kÃµnealuste kalavarude',0),(458833,12746,'si','ÄŒrnila uporabljajo tega staleÅ¾a',0),(458834,12746,'ba','Tinta digunakan saham ini',0),(458835,12746,'nl','Inkten gebruikt dit bestand',0),(458836,12746,'fi','Musteet kÃ¤yttÃ¤Ã¤ tÃ¤mÃ¤n kannan',0),(458837,12746,'no','Blekkfarger brukes dette lager',0),(458838,12746,'da','Trykfarver anvendt denne bestand',0),(458839,12746,'ko','ì´ ì£¼ì‹ì„ ì‚¬ìš© í•˜ëŠ” ìž‰í¬',0),(458840,12746,'he','×ž×œ××™ ×–×” ×œ×”×©×ª×ž×© ×‘×¡×•×’×™ ×“×™×•',0),(458841,12746,'el','ÎœÎµÎ»Î¬Î½Î¹Î± Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ ÎµÎ½ Î»ÏŒÎ³Ï‰ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(458842,12746,'zh','æ²¹å¢¨ç”¨è¿™åªè‚¡ç¥¨',0),(458843,12746,'sv','TryckfÃ¤rger anvÃ¤nds detta bestÃ¥nd',0),(458844,12746,'it','Inchiostri usati questo Stock',0),(458845,12746,'tl','',0),(458846,12746,'th','à¸«à¸¡à¸¶à¸à¹ƒà¸Šà¹‰à¸«à¸¸à¹‰à¸™à¸™à¸µà¹‰',0),(458847,12746,'hi','à¤¯à¤¹ à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤ªà¥à¤°à¤¯à¥à¤•à¥à¤¤',0),(458848,12746,'ms','Dakwat digunakan stok ini',0),(458849,12746,'ar','Ø§Ù„Ø£Ø­Ø¨Ø§Ø± Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(458850,12746,'fr','Encres utilisÃ©es ce Stock',0),(458851,12746,'jp','ã‚¤ãƒ³ã‚­ä½¿ç”¨ã“ã®æ ªå¼',0),(458852,12746,'pt','As tintas usadas este estoque',0),(458853,12746,'ru','Ð§ÐµÑ€Ð½Ð¸Ð»Ð°, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÐ¼Ñ‹Ðµ ÑÑ‚Ð¾Ñ‚ Ð·Ð°Ð¿Ð°Ñ',0),(458854,12746,'es','Tintas Usadas Este Stock',0),(458855,12746,'de','Druckfarben verwendet diese Aktie',0),(458856,12746,'en','Inks Used This Stock',0),(458857,12747,'is','',0),(458858,12747,'dr','ÙÙ‚Ø· ÛŒÚ© Ø·Ø±Ù',0),(458859,12747,'pr','ÙÙ‚Ø· ÛŒÚ© Ø·Ø±Ù',0),(458860,12747,'tr','Bir tarafÄ± sadece',0),(458861,12747,'pl','Po jednej stronie tylko',0),(458862,12747,'bg','Ð•Ð´Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð° ÑÐ°Ð¼Ð¾',0),(458863,12747,'ur','Ø§ÛŒÚ© Ø·Ø±Ù Ø¯Ø§Ø±ÛŒ ØµØ±Ù',0),(458864,12747,'sr','ÐˆÐµÐ´Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð° ÑÐ°Ð¼Ð¾',0),(458865,12747,'vi','Chá»‰ máº·t má»™t',0),(458866,12747,'af','Een kant slegs',0),(458867,12747,'ro','Partea una numai',0),(458868,12747,'et','Pool Ã¼ks ainult',0),(458869,12747,'si','Strani eno samo',0),(458870,12747,'ba','Sisi satu hanya',0),(458871,12747,'nl','Kant 1 alleen',0),(458872,12747,'fi','Puoli vain',0),(458873,12747,'no','Siden en bare',0),(458874,12747,'da','Side en kun',0),(458875,12747,'ko','í•œ ìª½ë§Œ',0),(458876,12747,'he','×¦×“ ××—×“ ×‘×œ×‘×“',0),(458877,12747,'el','ÎœÎ¯Î± Ï€Î»ÎµÏ…ÏÎ¬ Î¼ÏŒÎ½Î¿',0),(458878,12747,'zh','ä¸€è¾¹ä¸€ä¸ªåª',0),(458879,12747,'sv','Sidan ett endast',0),(458880,12747,'it','Lato uno solo',0),(458881,12747,'tl','',0),(458882,12747,'th','à¸‚à¹‰à¸²à¸‡à¸«à¸™à¸¶à¹ˆà¸‡à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(458883,12747,'hi','à¤à¤• à¤“à¤° à¤•à¥‡à¤µà¤²',0),(458884,12747,'ms','Tepi satu sahaja',0),(458885,12747,'ar','Ø¬Ø§Ù†Ø¨ ÙˆØ§Ø­Ø¯ ÙÙ‚Ø·',0),(458886,12747,'fr','Un cÃ´tÃ© uniquement',0),(458887,12747,'jp','1 ã¤ã®å´é¢ã ã‘',0),(458888,12747,'pt','Um lado sÃ³',0),(458889,12747,'ru','ÐžÐ´Ð½Ð° ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð° Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(458890,12747,'es','Lado Uno Solamente',0),(458891,12747,'de','Eine Seite nur',0),(458892,12747,'en','Side One Only',0),(458893,12748,'is','',0),(458894,12748,'dr','ÙÙ‚Ø· Ø¯Ùˆ Ø·Ø±Ù',0),(458895,12748,'pr','ÙÙ‚Ø· Ø¯Ùˆ Ø·Ø±Ù',0),(458896,12748,'tr','Ä°ki tarafÄ±nda sadece',0),(458897,12748,'pl','Dwie strony tylko',0),(458898,12748,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð°, Ð´Ð²Ðµ ÑÐ°Ð¼Ð¾',0),(458899,12748,'ur','Ø¯Ùˆ Ú©ÛŒ Ø·Ø±Ù Ø¯Ø§Ø±ÛŒ ØµØ±Ù',0),(458900,12748,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð° Ð´Ð²Ð° ÑÐ°Ð¼Ð¾',0),(458901,12748,'vi','Chá»‰ máº·t 2',0),(458902,12748,'af','Kant twee slegs',0),(458903,12748,'ro','DouÄƒ laterale numai',0),(458904,12748,'et','Pool kaks ainult',0),(458905,12748,'si','Strani dve le',0),(458906,12748,'ba','Sisi dua hanya',0),(458907,12748,'nl','Kant twee alleen',0),(458908,12748,'fi','Puoli vain',0),(458909,12748,'no','Side to bare',0),(458910,12748,'da','Side to kun',0),(458911,12748,'ko','ë‘ ìª½ë§Œ',0),(458912,12748,'he','×¦×“ ×©× ×™ ×‘×œ×‘×“',0),(458913,12748,'el','Î”ÏÎ¿ Ï€Î»ÎµÏ…ÏÎ¬ Î¼ÏŒÎ½Î¿',0),(458914,12748,'zh','ä¾§ä¸¤åª',0),(458915,12748,'sv','Sidan tvÃ¥ endast',0),(458916,12748,'it','Lato due solo',0),(458917,12748,'tl','',0),(458918,12748,'th','à¸‚à¹‰à¸²à¸‡à¸ªà¸­à¸‡à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(458919,12748,'hi','à¤¦à¥‹ à¤ªà¤•à¥à¤· à¤•à¥‡à¤µà¤²',0),(458920,12748,'ms','Tepi dua sahaja',0),(458921,12748,'ar','Ø§Ù„Ø¬Ø§Ù†Ø¨ Ø§Ø«Ù†ÙŠÙ† ÙÙ‚Ø·',0),(458922,12748,'fr','CÃ´tÃ© deux seulement',0),(458923,12748,'jp','ã‚µã‚¤ãƒ‰ 2 ã®ã¿',0),(458924,12748,'pt','Lado dois apenas',0),(458925,12748,'ru','Ð¡Ð±Ð¾ÐºÑƒ Ð´Ð²Ð° Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(458926,12748,'es','Lado Dos Solamente',0),(458927,12748,'de','Seite 2 nur',0),(458928,12748,'en','Side Two Only',0),(458929,12749,'is','',0),(458930,12749,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ Ø²ÛŒÙ¾ Ø§Ø±Ø³Ø§Ù„',0),(458931,12749,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ Ø²ÛŒÙ¾ Ø§Ø±Ø³Ø§Ù„',0),(458932,12749,'tr','Ä°hracat ZIP dosyasÄ±nÄ± indirin',0),(458933,12749,'pl','Pobierz plik Zip eksportu',0),(458934,12749,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Zip Ñ„Ð°Ð¹Ð» Ð·Ð° ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(458935,12749,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ø²Ù¾ ÙØ§Ø¦Ù„ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(458936,12749,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¼Ð¸Ñ‚Ðµ Ð—Ð¸Ð¿ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ð¸Ð·Ð²Ð¾Ð·',0),(458937,12749,'vi','táº£i báº£ng mÃ£',0),(458938,12749,'af','Uitvoer Zip lÃªer aflaai',0),(458939,12749,'ro','Export Zip Dosar',0),(458940,12749,'et','Lae Zip faili',0),(458941,12749,'si','Izvoz Zip datoteko prenesite',0),(458942,12749,'ba','Men-download File Zip ekspor',0),(458943,12749,'nl','Export Zip-bestand downloaden',0),(458944,12749,'fi','Vie Zip tiedosto',0),(458945,12749,'no','Last ned Zip eksportfilen',0),(458946,12749,'da','Download Zip eksportfilen',0),(458947,12749,'ko','ìˆ˜ì¶œ Zip íŒŒì¼ì„ ë‹¤ìš´ë¡œë“œ',0),(458948,12749,'he','×”×•×¨×“ ××ª ×§×•×‘×¥ ×”-Zip ×”×™×™×¦×•×',0),(458949,12749,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ Zip Î±ÏÏ‡ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚',0),(458950,12749,'zh','ä¸‹è½½å¯¼å‡º Zip æ–‡ä»¶',0),(458951,12749,'sv','HÃ¤mta Zip-filen fÃ¶r Export',0),(458952,12749,'it','Scarica il File Zip di esportazione',0),(458953,12749,'tl','',0),(458954,12749,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹„à¸Ÿà¸¥à¹Œ Zip à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(458955,12749,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤œà¤¼à¤¿à¤ª à¤«à¤¼à¤¾à¤‡à¤² à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(458956,12749,'ms','Muat turun fail Zip eksport',0),(458957,12749,'ar','ØªØ­Ù…ÙŠÙ„ Ù…Ù„Ù Zip Ø§Ù„ØªØµØ¯ÙŠØ±',0),(458958,12749,'fr','TÃ©lÃ©charger le fichier Zip d\'exportation',0),(458959,12749,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã® Zip ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(458960,12749,'pt','Baixar arquivo Zip de exportaÃ§Ã£o',0),(458961,12749,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ Zip-Ñ„Ð°Ð¹Ð» ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(458962,12749,'es','Descargar Archivo Zip de ExportaciÃ³n',0),(458963,12749,'de','Export-Zip-Datei herunterladen',0),(458964,12749,'en','Download Export Zip File',0),(458965,12750,'is','',0),(458966,12750,'dr','Ø®Ø·Ø§ÛŒ Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÛŒÙ„',0),(458967,12750,'pr','Ø®Ø·Ø§ÛŒ Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÛŒÙ„',0),(458968,12750,'tr','Hata dosya yÃ¼kleme',0),(458969,12750,'pl','BÅ‚Ä…d przekazywanie pliku',0),(458970,12750,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(458971,12750,'ur','Ù†Ù‚Øµ Ù…Ø³Ù„ Ø§Ù¾ Ù„ÙˆÚˆ',0),(458972,12750,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ð°ÑšÐµ',0),(458973,12750,'vi','Lá»—i khi cáº­p nháº­t file',0),(458974,12750,'af','Kon nie lÃªer oplaai nie',0),(458975,12750,'ro','Eroare de Ã®ncÄƒrcare fiÅŸier',0),(458976,12750,'et','Viga Ã¼leslaadimisel faili',0),(458977,12750,'si','Napaka pri nalaganju datoteke',0),(458978,12750,'ba','Kesalahan meng-upload File',0),(458979,12750,'nl','Fout bij uploaden van bestand',0),(458980,12750,'fi','Virhe lataamalla tiedosto',0),(458981,12750,'no','Feil ved opplasting av fil',0),(458982,12750,'da','Fejl ved upload af fil',0),(458983,12750,'ko','ì—…ë¡œë“œ íŒŒì¼ ì˜¤ë¥˜',0),(458984,12750,'he','×©×’×™××” ×”×¢×œ××ª ×§×•×‘×¥',0),(458985,12750,'el','Î£Ï†Î¬Î»Î¼Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï… Ï†ÏŒÏÏ„Ï‰Î¼Î±',0),(458986,12750,'zh','ä¸Šè½½æ–‡ä»¶æ—¶å‡ºé”™',0),(458987,12750,'sv','Fel ladda upp fil',0),(458988,12750,'it','Errore di caricamento File',0),(458989,12750,'tl','',0),(458990,12750,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¹à¸Ÿà¹‰à¸¡',0),(458991,12750,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(458992,12750,'ms','Ralat muat naik fail',0),(458993,12750,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ù…Ù„Ù',0),(458994,12750,'fr','Erreur chargement fichier',0),(458995,12750,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ ã‚¨ãƒ©ãƒ¼',0),(458996,12750,'pt','Erro ao carregar arquivo',0),(458997,12750,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐµ Ñ„Ð°Ð¹Ð»Ð°',0),(458998,12750,'es','Error Subiendo File',0),(458999,12750,'de','Fehler beim Hochladen der Datei',0),(459000,12750,'en','Error Uploading File',0),(459001,12751,'is','',0),(459002,12751,'dr','Ø§Ø±Ø³Ø§Ù„ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ú†Ù†Ø¯ Ù„Ø­Ø¸Ù‡ Ø·ÙˆÙ„ Ø¨Ú©Ø´Ø¯',0),(459003,12751,'pr','Ø§Ø±Ø³Ø§Ù„ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ú†Ù†Ø¯ Ù„Ø­Ø¸Ù‡ Ø·ÙˆÙ„ Ø¨Ú©Ø´Ø¯',0),(459004,12751,'tr','Ä°hracat birkaÃ§ dakika sÃ¼rebilir.',0),(459005,12751,'pl','WywÃ³z moÅ¼e zajÄ…Ä‡ kilka minut',0),(459006,12751,'bg','Ð˜Ð·Ð½Ð¾Ñ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ñ‚Ð½ÐµÐ¼Ðµ Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð¸',0),(459007,12751,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ù…ÛŒÚº Ú©Ú†Ú¾ Ù…Ù†Ù¹ Ù„Ú¯ Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(459008,12751,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ð¾Ñ‚Ñ€Ð°Ñ˜Ðµ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð°.',0),(459009,12751,'vi','káº¿t xuáº¥t sáº½ máº¥t khoáº£ng máº¥y phÃºt',0),(459010,12751,'af','Uitvoer kan \'n paar minute neem',0),(459011,12751,'ro','Export poate dura cÃ¢teva minute',0),(459012,12751,'et','Eksport vÃµib vÃµtta mÃµned minutid',0),(459013,12751,'si','Izvoz lahko traja nekaj minut',0),(459014,12751,'ba','Ekspor mungkin mengambil beberapa menit',0),(459015,12751,'nl','Uitvoer kan een paar minuten duren',0),(459016,12751,'fi','Voi viedÃ¤ muutaman minuutin',0),(459017,12751,'no','Eksporten kan ta noen minutter',0),(459018,12751,'da','Eksport kan tage et par minutter',0),(459019,12751,'ko','ìˆ˜ì¶œ ëª‡ ë¶„ì´ ê±¸ë¦´ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(459020,12751,'he','×™×™×¦×•× ×¢×œ×•×œ ×œ×§×—×ª ×›×ž×” ×“×§×•×ª',0),(459021,12751,'el','Î•Î¾Î±Î³Ï‰Î³Î® Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î¹Î±ÏÎºÎ­ÏƒÎµÎ¹ Î¼ÎµÏÎ¹ÎºÎ¬ Î»ÎµÏ€Ï„Î¬',0),(459022,12751,'zh','å‡ºå£å¯èƒ½éœ€è¦å‡ åˆ†é’Ÿæ—¶é—´',0),(459023,12751,'sv','Export kan ta nÃ¥gra minuter',0),(459024,12751,'it','Esportazione puÃ² richiedere qualche minuto',0),(459025,12751,'tl','',0),(459026,12751,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸­à¸²à¸ˆà¹ƒà¸Šà¹‰à¹€à¸§à¸¥à¸²à¹„à¸¡à¹ˆà¸à¸µà¹ˆà¸™à¸²à¸—à¸µ',0),(459027,12751,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤à¤• à¤•à¥à¤› à¤®à¤¿à¤¨à¤Ÿ à¤²à¤— à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(459028,12751,'ms','Eksport mungkin mengambil masa beberapa minit',0),(459029,12751,'ar','Ø§Ù„ØªØµØ¯ÙŠØ± Ù‚Ø¯ ÙŠØ³ØªØºØ±Ù‚ Ø¨Ø¶Ø¹ Ø¯Ù‚Ø§Ø¦Ù‚',0),(459030,12751,'fr','Exportation peut prendre quelques Minutes',0),(459031,12751,'jp','è¼¸å‡ºã¯æ•°åˆ†ã‚’ã‹ã‹ã‚‹å ´åˆãŒã‚ã‚Šã¾ã™ã€‚',0),(459032,12751,'pt','ExportaÃ§Ã£o pode levar alguns minutos',0),(459033,12751,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð¼Ð¾Ð¶ÐµÑ‚ Ð·Ð°Ð½ÑÑ‚ÑŒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚',0),(459034,12751,'es','Exportar Puede Tomar Unos Minutos',0),(459035,12751,'de','Export kann einige Minuten dauern.',0),(459036,12751,'en','Export May Take A Few Minutes',0),(459037,12752,'is','',0),(459038,12752,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯',0),(459039,12752,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯',0),(459040,12752,'tr','GÃ¶nderilen verme isteÄŸi',0),(459041,12752,'pl','WywÃ³z wniosek zostaÅ‚ zÅ‚oÅ¼ony',0),(459042,12752,'bg','Ð˜Ð·Ð½Ð¾Ñ Ð¸ÑÐºÐ°Ð½ÐµÑ‚Ð¾ Ðµ Ð¿Ð¾Ð´Ð°Ð´ÐµÐ½Ð¾',0),(459043,12752,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø±Ø³Ø§Ù„ Ú©Ø±Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(459044,12752,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¿Ð¾Ð´Ð½ÐµÑ‚Ð¾Ð³',0),(459045,12752,'vi','Káº¿t xuáº¥t Ä‘á» nghá»‹ Ä‘Ã£ Ä‘á»‡ trÃ¬nh',0),(459046,12752,'af','Uitvoer versoek ingedien is',0),(459047,12752,'ro','S-a depus cererea de export',0),(459048,12752,'et','Ekspordi taotluse esitanud',0),(459049,12752,'si','Poslana je bila zahteva izvozno',0),(459050,12752,'ba','Permintaan ekspor telah disampaikan',0),(459051,12752,'nl','Export aanvraag is verzonden',0),(459052,12752,'fi','Vienti pyyntÃ¶ on toimitettu',0),(459053,12752,'no','Eksport-forespÃ¸rsel er sendt',0),(459054,12752,'da','Eksport anmodning er blevet indgivet',0),(459055,12752,'ko','ë‚´ë³´ë‚´ê¸° ìš”ì²­ì´ ì œì¶œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(459056,12752,'he','×™×™×¦×•× ×©×‘×§×©×” × ×©×œ×—×”',0),(459057,12752,'el','ÎˆÏ‡ÎµÎ¹ Ï…Ï€Î¿Î²Î»Î·Î¸ÎµÎ¯ Î±Î¯Ï„Î·Î¼Î± ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚',0),(459058,12752,'zh','å‡ºå£çš„è¯·æ±‚å·²æäº¤',0),(459059,12752,'sv','Export begÃ¤ran har lÃ¤mnats in',0),(459060,12752,'it','Ãˆ stata presentata la richiesta di esportazione',0),(459061,12752,'tl','',0),(459062,12752,'th','à¸ªà¹ˆà¸‡à¸„à¸³à¸‚à¸­à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(459063,12752,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(459064,12752,'ms','Permintaan eksport telah dikemukakan',0),(459065,12752,'ar','ÙˆÙ‚Ø¯ Ù‚Ø¯Ù… Ø·Ù„Ø¨ ØªØµØ¯ÙŠØ±',0),(459066,12752,'fr','Demande d\'exportation a Ã©tÃ© soumis',0),(459067,12752,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆè¦æ±‚ãŒé€ä¿¡ã•ã‚Œã¾ã—ãŸ',0),(459068,12752,'pt','SolicitaÃ§Ã£o de exportaÃ§Ã£o apresentou',0),(459069,12752,'ru','Ð‘Ñ‹Ð» Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(459070,12752,'es','Pedido de Exportar se SometiÃ³',0),(459071,12752,'de','Export-Anforderung wurde Ã¼bermittelt',0),(459072,12752,'en','Export Request Has Been Submitted',0),(459073,12753,'is','',0),(459074,12753,'dr','Ø§Ø±Ø³Ø§Ù„ ÙØ§ÛŒÙ„ Ø²ÛŒÙ¾',0),(459075,12753,'pr','Ø§Ø±Ø³Ø§Ù„ ÙØ§ÛŒÙ„ Ø²ÛŒÙ¾',0),(459076,12753,'tr','ZIP dosyasÄ± dÄ±ÅŸa aktarma',0),(459077,12753,'pl','Eksportuj plik Zip',0),(459078,12753,'bg','Zip Ñ„Ð°Ð¹Ð» Ð·Ð° ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(459079,12753,'ur','Ø²Ù¾ Ù…Ø³Ù„ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(459080,12753,'sr','Ð—Ð¸Ð¿ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð·Ð° Ð¸Ð·Ð²Ð¾Ð·',0),(459081,12753,'vi','káº¿t xuáº¥t file zip',0),(459082,12753,'af','Zip-lÃªer uitvoer',0),(459083,12753,'ro','Export fiÅŸier Zip',0),(459084,12753,'et','Zip faili eksportida',0),(459085,12753,'si','Izvoz Å¾viÅ¾g pila',0),(459086,12753,'ba','Ekspor Zip File',0),(459087,12753,'nl','Zip-bestand exporteren',0),(459088,12753,'fi','Zip-tiedoston vieminen',0),(459089,12753,'no','Eksportere Zip-fil',0),(459090,12753,'da','Eksportere Zip-fil',0),(459091,12753,'ko','Zip íŒŒì¼ ë‚´ë³´ë‚´ê¸°',0),(459092,12753,'he','×™×™×¦×•× ×§×•×‘×¥ Zip',0),(459093,12753,'el','Î•Î¾Î¬Î³ÎµÏ„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Zip',0),(459094,12753,'zh','å°† Zip æ–‡ä»¶å¯¼å‡º',0),(459095,12753,'sv','Exportera Zip-fil',0),(459096,12753,'it','Esportare File Zip',0),(459097,12753,'tl','',0),(459098,12753,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¹à¸Ÿà¹‰à¸¡ Zip',0),(459099,12753,'hi','à¤œà¤¼à¤¿à¤ª à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(459100,12753,'ms','Eksport fail Zip',0),(459101,12753,'ar','ØªØµØ¯ÙŠØ± Ù…Ù„Ù Ù…Ø¶ØºÙˆØ·',0),(459102,12753,'fr','Exporter fichier Zip',0),(459103,12753,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã® Zip ãƒ•ã‚¡ã‚¤ãƒ«',0),(459104,12753,'pt','Exportar arquivo Zip',0),(459105,12753,'ru','Zip-Ñ„Ð°Ð¹Ð» ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(459106,12753,'es','Exportar Zip File',0),(459107,12753,'de','Zipdatei exportieren',0),(459108,12753,'en','Export Zip File',0),(459109,12754,'is','',0),(459110,12754,'dr','ÙˆÛŒÚ˜Ú¯ÛŒ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(459111,12754,'pr','ÙˆÛŒÚ˜Ú¯ÛŒ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(459112,12754,'tr','Ã–zellik yok',0),(459113,12754,'pl','Funkcja nie jest dostÄ™pna',0),(459114,12754,'bg','Ð¤ÑƒÐ½ÐºÑ†Ð¸ÑÑ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð°',0),(459115,12754,'ur','ÙÛŒÚ†Ø± Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº',0),(459116,12754,'sr','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð°',0),(459117,12754,'vi','Ä‘áº·c tÃ­nh khÃ´ng cÃ³',0),(459118,12754,'af','Kenmerk nie beskikbaar nie',0),(459119,12754,'ro','CaracteristicÄƒ nu este disponibilÄƒ',0),(459120,12754,'et','Funktsioon pole saadaval',0),(459121,12754,'si','Funkcija ni na voljo',0),(459122,12754,'ba','Fitur tidak tersedia',0),(459123,12754,'nl','Functie niet beschikbaar',0),(459124,12754,'fi','Ominaisuus ei ole kÃ¤ytettÃ¤vissÃ¤',0),(459125,12754,'no','Funksjonen er ikke tilgjengelig',0),(459126,12754,'da','Funktionen ikke tilgÃ¦ngelig',0),(459127,12754,'ko','ì‚¬ìš©í•  ìˆ˜ ì—†ëŠ” ê¸°ëŠ¥',0),(459128,12754,'he','×ª×›×•× ×” ×œ× ×–×ž×™×Ÿ',0),(459129,12754,'el','Î— Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„Î± Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î·',0),(459130,12754,'zh','åŠŸèƒ½ä¸å¯ç”¨',0),(459131,12754,'sv','Funktionen inte tillgÃ¤nglig',0),(459132,12754,'it','Caratteristica non disponibile',0),(459133,12754,'tl','',0),(459134,12754,'th','à¸„à¸¸à¸“à¸¥à¸±à¸à¸©à¸“à¸°à¹„à¸¡à¹ˆà¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(459135,12754,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚',0),(459136,12754,'ms','Ciri-ciri yang tidak terdapat',0),(459137,12754,'ar','Ù…ÙŠØ²Ø© ØºÙŠØ± Ù…ØªÙˆÙØ±Ø©',0),(459138,12754,'fr','FonctionnalitÃ© non disponible',0),(459139,12754,'jp','åˆ©ç”¨ã§ããªã„æ©Ÿèƒ½ã—ã¾ã™ã€‚',0),(459140,12754,'pt','Recurso nÃ£o disponÃ­vel',0),(459141,12754,'ru','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ Ð½Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð°',0),(459142,12754,'es','CaracterÃ­stica No Disponible',0),(459143,12754,'de','Feature steht nicht zur VerfÃ¼gung',0),(459144,12754,'en','Feature Not Available',0),(459145,12755,'is','',0),(459146,12755,'dr','Ù†ÙˆØ¹ ÙØ§ÛŒÙ„ Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(459147,12755,'pr','Ù†ÙˆØ¹ ÙØ§ÛŒÙ„ Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(459148,12755,'tr','Dosya tÃ¼rÃ¼ne izin verilmiyor',0),(459149,12755,'pl','Typ pliku nie wolno',0),(459150,12755,'bg','ÐÐµÑ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½ Ñ‚Ð¸Ð¿ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(459151,12755,'ur','Ù…Ø³Ù„ Ù‚Ø³Ù… Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº',0),(459152,12755,'sr','Ð¢Ð¸Ð¿ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(459153,12755,'vi','loáº¡i file khÃ´ng Ä‘Æ°á»£c cháº¥p nháº­n',0),(459154,12755,'af','LÃªertipe nie toegelaat',0),(459155,12755,'ro','Tip de fiÅŸier nepermis',0),(459156,12755,'et','FailitÃ¼Ã¼p pole lubatud',0),(459157,12755,'si','Vrsta datoteke ni dovoljeno',0),(459158,12755,'ba','Jenis file yang tidak diizinkan',0),(459159,12755,'nl','Bestandstype niet toegestaan',0),(459160,12755,'fi','TiedostotyyppiÃ¤ ei sallita',0),(459161,12755,'no','Filtype ikke tillatt',0),(459162,12755,'da','Filtype ikke tilladt',0),(459163,12755,'ko','íŒŒì¼ í˜•ì‹ì„ ì‚¬ìš©í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(459164,12755,'he','×¡×•×’ ×”×§×•×‘×¥ ××™× ×” ×ž×•×ª×¨×ª',0),(459165,12755,'el','Î¤ÏÏ€Î¿ Î±ÏÏ‡ÎµÎ¯Î¿Ï… Ï€Î¿Ï… Î´ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(459166,12755,'zh','ä¸å…è®¸çš„æ–‡ä»¶ç±»åž‹',0),(459167,12755,'sv','Filtypen inte tillÃ¥tet',0),(459168,12755,'it','Tipo di file non consentito',0),(459169,12755,'tl','',0),(459170,12755,'th','à¸Šà¸™à¸´à¸”à¹à¸Ÿà¹‰à¸¡à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(459171,12755,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(459172,12755,'ms','Jenis fail yang tidak dibenarkan',0),(459173,12755,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù…Ù„Ù ØºÙŠØ± Ù…Ø³Ù…ÙˆØ­',0),(459174,12755,'fr','Type de fichier non autorisÃ©',0),(459175,12755,'jp','è¨±å¯ã•ã‚Œã¦ã„ãªã„ãƒ•ã‚¡ã‚¤ãƒ«ã®ç¨®é¡ž',0),(459176,12755,'pt','Tipo de arquivo nÃ£o permitido',0),(459177,12755,'ru','Ð¢Ð¸Ð¿ Ñ„Ð°Ð¹Ð»Ð° Ð½Ðµ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(459178,12755,'es','No se Permite Este Tipo de File',0),(459179,12755,'de','Dateityp nicht erlaubt',0),(459180,12755,'en','File Type Not Allowed',0),(459181,12756,'is','',0),(459182,12756,'dr','ÙØ§ÛŒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯ ',0),(459183,12756,'pr','ÙØ§ÛŒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯ ',0),(459184,12756,'tr','Dosya baÅŸarÄ±yla karÅŸÄ±ya yÃ¼klendi',0),(459185,12756,'pl','Plik zostaÅ‚ pomyÅ›lnie przesÅ‚any',0),(459186,12756,'bg','Ð¤Ð°Ð¹Ð»ÑŠÑ‚ Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÐ°Ñ‡ÐµÐ½',0),(459187,12756,'ur','ÙØ§Ø¦Ù„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ Ù„ÙˆÚˆ ÛÙˆÚ¯Ø¦ÛŒ',0),(459188,12756,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(459189,12756,'vi','cáº­p nháº­t file thÃ nh cÃ´ng',0),(459190,12756,'af','LÃªer suksesvol opgelaai',0),(459191,12756,'ro','FiÅŸierul Ã®ncÄƒrcat cu succes',0),(459192,12756,'et','Faili Ã¼leslaadimine Ãµnnestus',0),(459193,12756,'si','Datoteko uspeÅ¡no naloÅ¾ili',0),(459194,12756,'ba','File berhasil diupload',0),(459195,12756,'nl','Bestand geÃ¼pload',0),(459196,12756,'fi','Tiedoston lataaminen onnistui',0),(459197,12756,'no','Fil lastet',0),(459198,12756,'da','Fil uploadet succesfuldt',0),(459199,12756,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë¡œë“œ ëœ íŒŒì¼',0),(459200,12756,'he','×”×§×•×‘×¥ × ×˜×¢×Ÿ ×‘×”×¦×œ×—×”',0),(459201,12756,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Ï€Î¿Ï… Ï†Î¿ÏÏ„ÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(459202,12756,'zh','æ–‡ä»¶å·²æˆåŠŸä¸Šè½½',0),(459203,12756,'sv','Filen upp framgÃ¥ngsrikt',0),(459204,12756,'it','File caricato con successo',0),(459205,12756,'tl','',0),(459206,12756,'th','à¹à¸Ÿà¹‰à¸¡à¸—à¸µà¹ˆà¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(459207,12756,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(459208,12756,'ms','Fail yang dimuat naik dengan jayanya',0),(459209,12756,'ar','Ø§Ù„Ù…Ù„Ù ØªÙ… ØªØ­Ù…ÙŠÙ„Ù‡ Ø¨Ù†Ø¬Ø§Ø­',0),(459210,12756,'fr','Fichier tÃ©lÃ©chargÃ© avec succÃ¨s',0),(459211,12756,'jp','æ­£å¸¸ã«ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã•ã‚ŒãŸãƒ•ã‚¡ã‚¤ãƒ«',0),(459212,12756,'pt','Arquivo carregado com sucesso',0),(459213,12756,'ru','Ð¤Ð°Ð¹Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð·Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½',0),(459214,12756,'es','File Subido Exitosamente',0),(459215,12756,'de','Datei erfolgreich hochgeladen',0),(459216,12756,'en','File Uploaded Successfully',0),(459217,12757,'is','',0),(459218,12757,'dr','Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(459219,12757,'pr','Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(459220,12757,'tr','Dosya yÃ¼kleme baÅŸarÄ±sÄ±z oldu',0),(459221,12757,'pl','Upload plikÃ³w nie powiodÅ‚o siÄ™',0),(459222,12757,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(459223,12757,'ur','Ù…Ø³Ù„ Ø§Ù¾ Ù„ÙˆÚˆ Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§',0),(459224,12757,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(459225,12757,'vi','cáº­p nháº­t file tháº¥t báº¡i',0),(459226,12757,'af','LÃªer oplaai het misluk',0),(459227,12757,'ro','FiÅŸier de Ã®ncÄƒrcare nu a reuÅŸit',0),(459228,12757,'et','Faili Ã¼leslaadimine nurjus',0),(459229,12757,'si','Nalaganje datotek ni uspela',0),(459230,12757,'ba','File Upload gagal',0),(459231,12757,'nl','Bestandsupload mislukt',0),(459232,12757,'fi','Tiedoston lataus epÃ¤onnistui',0),(459233,12757,'no','Filopplasting mislyktes',0),(459234,12757,'da','Fil Upload mislykkedes',0),(459235,12757,'ko','íŒŒì¼ ì—…ë¡œë“œ ì‹¤íŒ¨',0),(459236,12757,'he','×”×¢×œ××ª ×§×•×‘×¥ × ×›×©×œ',0),(459237,12757,'el','Upload Î±ÏÏ‡ÎµÎ¯Î¿Ï… Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(459238,12757,'zh','æ–‡ä»¶ä¸Šè½½å¤±è´¥',0),(459239,12757,'sv','FilÃ¶verfÃ¶ringen misslyckades',0),(459240,12757,'it','Upload di file non riuscita',0),(459241,12757,'tl','',0),(459242,12757,'th','à¸à¸²à¸£à¸­à¸±à¸žà¹‚à¸«à¸¥à¸”à¹„à¸Ÿà¸¥à¹Œà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(459243,12757,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤ªà¤²à¥‹à¤¡ à¤µà¤¿à¤«à¤² à¤¹à¥à¤†',0),(459244,12757,'ms','Muat naik fail yang gagal',0),(459245,12757,'ar','ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ù…Ù„Ù ÙØ´Ù„',0),(459246,12757,'fr','Upload de fichier a Ã©chouÃ©',0),(459247,12757,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(459248,12757,'pt','Upload do arquivo falhado',0),(459249,12757,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð·Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð»',0),(459250,12757,'es','Subido de File FallÃ³',0),(459251,12757,'de','Dateiupload fehlgeschlagen',0),(459252,12757,'en','File Upload Failed',0),(459253,12758,'is','',0),(459254,12758,'dr','Ø¨Ù‡ ØµÙØ­Ù‡ ÙˆØ±ÙˆØ¯ Ø¨Ø±ÙˆÛŒØ¯',0),(459255,12758,'pr','Ø¨Ù‡ ØµÙØ­Ù‡ ÙˆØ±ÙˆØ¯ Ø¨Ø±ÙˆÛŒØ¯',0),(459256,12758,'tr','SayfayÄ± almak iÃ§in gitmek',0),(459257,12758,'pl','PrzejdÅº do strony przywozu',0),(459258,12758,'bg','ÐžÑ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð° Ð²Ð½Ð¾Ñ',0),(459259,12758,'ur','ØµÙØ­Û Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¬Ø§Ù†Ø§',0),(459260,12758,'sr','Ð˜Ð´Ð¸ Ð·Ð° ÑƒÐ²Ð¾Ð· ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(459261,12758,'vi','tá»›i trang nháº­p',0),(459262,12758,'af','Gaan na bladsy invoer',0),(459263,12758,'ro','Du-te la filme de Import',0),(459264,12758,'et','Mine impordi leht',0),(459265,12758,'si','Pojdi na uvoz strani',0),(459266,12758,'ba','Pergi untuk mengimpor Halaman',0),(459267,12758,'nl','Ga naar pagina importeert',0),(459268,12758,'fi','Menemme tuoda sivun',0),(459269,12758,'no','GÃ¥r Ã¥ importere side',0),(459270,12758,'da','GÃ¥ til importere side',0),(459271,12758,'ko','ê°€ì ¸ì˜¬ íŽ˜ì´ì§€ ì´ë™',0),(459272,12758,'he','×œ×œ×›×ª ×ž×™×™×‘× ×“×£',0),(459273,12758,'el','Î Î¬Ï‰ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î· ÏƒÎµÎ»Î¯Î´Î±',0),(459274,12758,'zh','åŽ»å¯¼å…¥é¡µ',0),(459275,12758,'sv','GÃ¥ till importera sidan',0),(459276,12758,'it','Vai alla pagina di importazione',0),(459277,12758,'tl','',0),(459278,12758,'th','à¹„à¸›à¸—à¸µà¹ˆà¸«à¸™à¹‰à¸²à¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(459279,12758,'hi','à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‹ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤“',0),(459280,12758,'ms','Pergi untuk mengimport Laman',0),(459281,12758,'ar','Ø§Ù†ØªÙ‚Ù„ Ø¥Ù„Ù‰ ØµÙØ­Ø© Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(459282,12758,'fr','Aller Ã  la Page d\'importation',0),(459283,12758,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ãƒšãƒ¼ã‚¸ã«ç§»å‹•ã—ã¾ã™ã€‚',0),(459284,12758,'pt','Ir Ã  pÃ¡gina de importaÃ§Ã£o',0),(459285,12758,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(459286,12758,'es','Va a PÃ¡gina de ImportaciÃ³n',0),(459287,12758,'de','Gehen Sie zu Seite importieren',0),(459288,12758,'en','Go To Import Page',0),(459289,12759,'is','',0),(459290,12759,'dr','Ù‡ÛŒÚ† Ø§Ø±Ø³Ø§Ù„ÛŒ Ø¨Ø±Ø§ÛŒ Ø¯Ø§Ù†Ù„ÙˆØ¯ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(459291,12759,'pr','Ù‡ÛŒÚ† Ø§Ø±Ø³Ø§Ù„ÛŒ Ø¨Ø±Ø§ÛŒ Ø¯Ø§Ù†Ù„ÙˆØ¯ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(459292,12759,'tr','HenÃ¼z indirmek iÃ§in mevcut ihracat',0),(459293,12759,'pl','Nie eksportu dostÄ™pne do pobrania jeszcze',0),(459294,12759,'bg','Ð˜Ð·Ð½Ð¾ÑÑŠÑ‚ Ð½Ðµ Ð½Ð°Ð»Ð¸Ñ‡ÐµÐ½ Ð·Ð° Ð¸Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð²ÑÐµ Ð¾Ñ‰Ðµ',0),(459295,12759,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ø±Ø¢Ù…Ø¯ Ø¯Ø³ØªÛŒØ§Ø¨ Ø§Ø¨Ú¾ÛŒ ØªÚ© ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Û’ Ù„ÛŒÛ’',0),(459296,12759,'sr','ÐÐµÐ¼Ð° Ð¸Ð·Ð²Ð¾Ð·Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½ Ð·Ð° Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ñ˜Ð¾Ñˆ',0),(459297,12759,'vi','khÃ´ng sáºµn sÃ ng káº¿t xuáº¥t vÃ¬ chÆ°a táº£i',0),(459298,12759,'af','Geen uitvoer beskikbaar vir aflaai nog',0),(459299,12759,'ro','Exportul nu folositor pentru drum liber Ã®ncÄƒ',0),(459300,12759,'et','Veel allalaadimiseks saadaval eksport',0),(459301,12759,'si','Se izvoz, ki so na voljo za Download Å¡e',0),(459302,12759,'ba','Ekspor tidak tersedia untuk di-Download namun',0),(459303,12759,'nl','Geen uitvoer beschikbaar voor Download nog',0),(459304,12759,'fi','Ei viedÃ¤ saatavana ladata vielÃ¤',0),(459305,12759,'no','Ingen eksport tilgjengelig For nedlasting ennÃ¥',0),(459306,12759,'da','Ingen eksport tilgÃ¦ngelige For Download endnu',0),(459307,12759,'ko','ì•„ì§ ë‹¤ìš´ë¡œë“œë¥¼ ìœ„í•´ ì‚¬ìš©í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ìˆ˜ì¶œ',0),(459308,12759,'he','××™×Ÿ ×™×™×¦×•× ×–×ž×™× ×™× ×œ×”×•×¨×“×” ×¢×“×™×™×Ÿ',0),(459309,12759,'el','Î‘Ï€Î±Î³Î¿ÏÎµÏÎµÏ„Î±Î¹ Î· ÎµÎ¾Î±Î³Ï‰Î³Î® Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Î³Î¹Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÏ„ÏŽÎ½ÎµÎ¹ Î±ÎºÏŒÎ¼Î±',0),(459310,12759,'zh','å¯ä¾›ä¸‹è½½å°šæœªæ²¡æœ‰å‡ºå£',0),(459311,12759,'sv','Ingen Export som Ã¤r tillgÃ¤nglig fÃ¶r nedladdning Ã¤nnu',0),(459312,12759,'it','Nessuna esportazione disponibile per il Download ancora',0),(459313,12759,'tl','',0),(459314,12759,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¹„à¸¡à¹ˆà¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹„à¸”à¹‰',0),(459315,12759,'hi','à¤¨à¤¹à¥€à¤‚ à¤…à¤­à¥€ à¤¤à¤• à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤',0),(459316,12759,'ms','Eksport tidak tersedia untuk dimuat turun lagi',0),(459317,12759,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªØµØ¯ÙŠØ± Ù…ØªØ§Ø­ Ù„Ù„ØªØ­Ù…ÙŠÙ„ Ø¨Ø¹Ø¯',0),(459318,12759,'fr','Aucune exportation disponible pour tÃ©lÃ©charger encore',0),(459319,12759,'jp','ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã¯ã¾ã åˆ©ç”¨å¯èƒ½ãªãªã„è¼¸å‡º',0),(459320,12759,'pt','NÃ£o hÃ¡ exportaÃ§Ã£o disponÃ­vel para Download ainda',0),(459321,12759,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð½Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹ Ð´Ð»Ñ ÑÐºÐ°Ñ‡Ð¸Ð²Ð°Ð½Ð¸Ñ ÐµÑ‰Ðµ',0),(459322,12759,'es','No File de ExportaciÃ³n Disponible TodavÃ­a',0),(459323,12759,'de','Kein Export verfÃ¼gbar zum Download noch',0),(459324,12759,'en','No Export Available For Download Yet',0),(459325,12760,'is','',0),(459326,12760,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØµØ§Ø¯Ø±Ø§Øª Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø±',0),(459327,12760,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØµØ§Ø¯Ø±Ø§Øª Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø±',0),(459328,12760,'tr','Bekleyen ihracat talepleri',0),(459329,12760,'pl','Å»Ä…dania oczekujÄ…ce eksportu',0),(459330,12760,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ð¸Ð·Ð½Ð¾Ñ Ð¸ÑÐºÐ°Ð½Ð¸Ñ',0),(459331,12760,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø¨Ø±Ø¢Ù…Ø¯',0),(459332,12760,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð¸Ð·Ð²Ð¾Ð· Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ',0),(459333,12760,'vi','ChÆ°a lÃ m Ä‘á» nghá»‹ xuáº¥t',0),(459334,12760,'af','Hangende uitvoer versoeke',0),(459335,12760,'ro','Cereri de Export Ã®n aÅŸteptare',0),(459336,12760,'et','Ootel ekspordi taotlused',0),(459337,12760,'si','ÄŒakajoÄe izvoznih zahtev',0),(459338,12760,'ba','Permintaan ekspor yang tertunda',0),(459339,12760,'nl','Aanvragen in behandeling Export',0),(459340,12760,'fi','Odottava vienti pyynnÃ¶t',0),(459341,12760,'no','Ventende Eksporter forespÃ¸rsler',0),(459342,12760,'da','Ventende eksport anmodninger',0),(459343,12760,'ko','ë³´ë¥˜ ì¤‘ì¸ ë‚´ë³´ë‚´ê¸° ìš”ì²­',0),(459344,12760,'he','×‘×§×©×•×ª ×ž×ž×ª×™× ×•×ª ×™×™×¦×•×',0),(459345,12760,'el','Î‘Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚',0),(459346,12760,'zh','æŒ‚èµ·çš„å‡ºå£ç”³è¯·',0),(459347,12760,'sv','VÃ¤ntande Export fÃ¶rfrÃ¥gningar',0),(459348,12760,'it','Richieste di esportazione in sospeso',0),(459349,12760,'tl','',0),(459350,12760,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸­à¸¢à¸¹à¹ˆà¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸žà¸´à¸ˆà¸²à¸£à¸“à¸²à¸„à¸³à¸‚à¸­',0),(459351,12760,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚',0),(459352,12760,'ms','Permintaan eksport yang belum selesai',0),(459353,12760,'ar','Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØªØµØ¯ÙŠØ± Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(459354,12760,'fr','Demandes en attente d\'exportation',0),(459355,12760,'jp','ä¿ç•™ä¸­ã®ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆè¦æ±‚',0),(459356,12760,'pt','SolicitaÃ§Ãµes de exportaÃ§Ã£o pendentes',0),(459357,12760,'ru','ÐžÐ¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð²',0),(459358,12760,'es','Peticiones de Exportar Pendientes',0),(459359,12760,'de','Ausstehende Export-Anfragen',0),(459360,12760,'en','Pending Export Requests',0),(459361,12761,'is','',0),(459362,12761,'dr','Ù„Ø·ÙØ§ Ù‚Ø¨Ù„ Ø§Ø² Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† Ø§Ø¨Ø²Ø§Ø±ÙØ§ÛŒÙ„ Ù‡Ø§ÛŒ ÙØ´Ø±Ø¯Ù‡ ÙØ±Ù…Øª Ù¾ÛŒ Ø§Ú† Ù¾ÛŒ Ø±Ø§ ÙØ¹Ø§Ù„ Ú©Ù†ÛŒØ¯  ',0),(459363,12761,'pr','Ù„Ø·ÙØ§ Ù‚Ø¨Ù„ Ø§Ø² Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† Ø§Ø¨Ø²Ø§Ø±ÙØ§ÛŒÙ„ Ù‡Ø§ÛŒ ÙØ´Ø±Ø¯Ù‡ ÙØ±Ù…Øª Ù¾ÛŒ Ø§Ú† Ù¾ÛŒ Ø±Ø§ ÙØ¹Ø§Ù„ Ú©Ù†ÛŒØ¯  ',0),(459364,12761,'tr','LÃ¼tfen bu aracÄ± kullanmadan Ã¶nce ZIP PHP eklentisini etkinleÅŸtirin',0),(459365,12761,'pl','ProszÄ™ wÅ‚Ä…czyÄ‡ rozszerzenie PHP Zip przed uÅ¼yciem tego narzÄ™dzia',0),(459366,12761,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Zip PHP Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð°Ð²Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚',0),(459367,12761,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø²Ù¾ Ù¾ÛŒ Ø§ÛŒÚ† Ù¾ÛŒ Ú©ÛŒ ØªÙˆØ³ÛŒØ¹ Ø§Ø³ Ù¹ÙˆÙ„ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(459368,12761,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð—Ð¸Ð¿ ÐŸÐ¥ÐŸ Ð¿Ñ€Ð¾ÑˆÐ¸Ñ€ÐµÑšÐµ Ð¿Ñ€Ðµ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ðµ Ð¾Ð²Ðµ Ð°Ð»Ð°Ñ‚ÐºÐµ',0),(459369,12761,'vi','xin khá»Ÿi Ä‘á»™ng má»Ÿ rroongj PHP zip trÆ°á»›c khi sá»­ dá»¥ng cÃ´ng cá»¥ nÃ y',0),(459370,12761,'af','Aktiveer asseblief die ritssluiter PHP uitbreiding voor die gebruik van hierdie instrument',0),(459371,12761,'ro','VÄƒ rugÄƒm sÄƒ activaÅ£i extensia Zip PHP Ã®nainte de a utiliza acest instrument',0),(459372,12761,'et','Aktiveerige Zip PHP laiendus enne selle tÃ¶Ã¶riista',0),(459373,12761,'si','Aktivirajte Zip PHP razseÅ¾nost spredaj Using to orodje',0),(459374,12761,'ba','Silakan Aktifkan ekstensi PHP Zip sebelum menggunakan alat ini',0),(459375,12761,'nl','Activeer de Zip PHP extensie voordat u dit hulpprogramma gebruikt',0),(459376,12761,'fi','Aktivoi Zip PHP ala ennen tÃ¤mÃ¤n tyÃ¶kalun kÃ¤yttÃ¤mistÃ¤',0),(459377,12761,'no','Aktiver Zip PHP forlengelsen fÃ¸r du bruker dette verktÃ¸yet',0),(459378,12761,'da','Aktiver venligst Zip PHP forlÃ¦ngelse fÃ¸r du bruger dette vÃ¦rktÃ¸j',0),(459379,12761,'ko','ì´ ë„êµ¬ë¥¼ ì‚¬ìš© í•˜ê¸° ì „ì— Zip PHP í™•ìž¥ í™œì„±í™”',0),(459380,12761,'he','×‘×‘×§×©×” ×œ×”×¤×¢×™×œ ××ª ×”×¡×™×•×ž×ª PHP Zip ×œ×¤× ×™ ×”×©×™×ž×•×© ×‘×›×œ×™ ×–×”',0),(459381,12761,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î·Î½ ÎµÏ€Î­ÎºÏ„Î±ÏƒÎ· PHP Zip Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î· Ï‡ÏÎ®ÏƒÎ· Î±Ï…Ï„Î¿Ï Ï„Î¿Ï… ÎµÏÎ³Î±Î»ÎµÎ¯Î¿Ï…',0),(459382,12761,'zh','è¯·ä½¿ç”¨æ­¤å·¥å…·ä¹‹å‰æ¿€æ´» Zip PHP æ‰©å±•',0),(459383,12761,'sv','VÃ¤nligen aktivera tillÃ¤gget Zip PHP innan du anvÃ¤nder detta verktyg',0),(459384,12761,'it','Si prega di attivare l\'estensione PHP Zip prima di utilizzare questo strumento',0),(459385,12761,'tl','',0),(459386,12761,'th','à¹‚à¸›à¸£à¸”à¹€à¸£à¸µà¸¢à¸à¹ƒà¸Šà¹‰à¸™à¸²à¸¡à¸ªà¸à¸¸à¸¥ PHP Zip à¸à¹ˆà¸­à¸™à¹ƒà¸Šà¹‰à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¸™à¸µà¹‰',0),(459387,12761,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤œà¤¼à¤¿à¤ª PHP à¤à¤•à¥à¤¸à¤Ÿà¥‡à¤‚à¤¶à¤¨ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(459388,12761,'ms','Sila aktifkan Zip PHP sambungan sebelum menggunakan alat ini',0),(459389,12761,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªÙ†Ø´ÙŠØ· Ù…Ù„Ø­Ù‚ Ø¨ÙŠ Zip Ù‚Ø¨Ù„ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù‡Ø°Ù‡ Ø§Ù„Ø£Ø¯Ø§Ø©',0),(459390,12761,'fr','Veuillez activer l\'Extension Zip en PHP avant d\'utiliser cet outil',0),(459391,12761,'jp','ã“ã®ãƒ„ãƒ¼ãƒ«ã‚’ä½¿ç”¨ã™ã‚‹å‰ã«ã€Zip ã® PHP æ‹¡å¼µãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã‚’æœ‰åŠ¹ã«ã—ã¦ãã ã•ã„ã€‚',0),(459392,12761,'pt','Por favor, ative a extensÃ£o PHP Zip antes de usar esta ferramenta',0),(459393,12761,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€ÑƒÐ¹Ñ‚Ðµ Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð¸Ðµ PHP Zip Ð¿ÐµÑ€ÐµÐ´ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸ÐµÐ¼ ÑÑ‚Ð¾Ð³Ð¾ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(459394,12761,'es','Favor de Activar la ExtensiÃ³n de Zip PHP Antes Que Usar Esta Herramienta',0),(459395,12761,'de','Bitte aktivieren Sie die Zip-PHP-Erweiterung, bevor Sie dieses Tool verwenden',0),(459396,12761,'en','Please Activate The Zip PHP Extension Before Using This Tool',0),(459397,12762,'is','',0),(459398,12762,'dr','Ø§Ø±Ø³Ø§Ù„ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø³Ø±ÛŒØ¹',0),(459399,12762,'pr','Ø§Ø±Ø³Ø§Ù„ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø³Ø±ÛŒØ¹',0),(459400,12762,'tr','QuickBooks ihracat',0),(459401,12762,'pl','QuickBooks eksportu',0),(459402,12762,'bg','QuickBooks Ð¸Ð·Ð½Ð¾Ñ',0),(459403,12762,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ø¨Ø±Ø¢Ù…Ø¯',0),(459404,12762,'sr','QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ Ð¸Ð·Ð²Ð¾Ð·Ð°',0),(459405,12762,'vi','káº¿t xuáº¥t Quicbooks',0),(459406,12762,'af','QuickBooks uitvoer',0),(459407,12762,'ro','QuickBooks Export',0),(459408,12762,'et','QuickBooksi ekspordi',0),(459409,12762,'si','QuickBooks izvoz',0),(459410,12762,'ba','QuickBooks ekspor',0),(459411,12762,'nl','QuickBooks exporteren',0),(459412,12762,'fi','QuickBooks vienti',0),(459413,12762,'no','QuickBooks eksport',0),(459414,12762,'da','QuickBooks eksport',0),(459415,12762,'ko','QuickBooks ìˆ˜ì¶œ',0),(459416,12762,'he','×™×™×¦×•× QuickBooks',0),(459417,12762,'el','QuickBooks ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚',0),(459418,12762,'zh','QuickBooks å‡ºå£',0),(459419,12762,'sv','QuickBooks Export',0),(459420,12762,'it','QuickBooks Export',0),(459421,12762,'tl','',0),(459422,12762,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸ QuickBooks',0),(459423,12762,'hi','QuickBooks à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤',0),(459424,12762,'ms','QuickBooks eksport',0),(459425,12762,'ar','ØªØµØ¯ÙŠØ± Ù‚Ø±Ø§Ø¡',0),(459426,12762,'fr','Exportation de QuickBooks',0),(459427,12762,'jp','QuickBooks ã®ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ',0),(459428,12762,'pt','ExportaÃ§Ã£o de QuickBooks',0),(459429,12762,'ru','QuickBooks ÑÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(459430,12762,'es','Quickbooks Exportar',0),(459431,12762,'de','QuickBooks-Export',0),(459432,12762,'en','QuickBooks Export',0),(459433,12763,'is','',0),(459434,12763,'dr','Ø§Ø±Ø§Ø¦Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ ØµÙØ­Ù‡ ÙˆØ¨ Ø±Ø§Ø¨Ø· Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø³Ø±ÛŒØ¹  ',0),(459435,12763,'pr','Ø§Ø±Ø§Ø¦Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ ØµÙØ­Ù‡ ÙˆØ¨ Ø±Ø§Ø¨Ø· Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø³Ø±ÛŒØ¹  ',0),(459436,12763,'tr','QuickBooks Web Connector verme isteÄŸi gÃ¶nderme',0),(459437,12763,'pl','ZÅ‚oÅ¼yÄ‡ wniosek eksportu do programu QuickBooks Web Connector',0),(459438,12763,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð·Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ ÐºÑŠÐ¼ QuickBooks ÑƒÐµÐ± ÐºÐ¾Ð½ÐµÐºÑ‚Ð¾Ñ€',0),(459439,12763,'ur','ÙˆÛŒØ¨ Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ú©Û’ Ú©Ù†ÛŒÚ©Ù¹Ø± Ú©Û’ Ù„Ø¦Û’ Ø¨Ø±Ø¢Ù…Ø¯ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¬Ù…Ø¹ Ú©Ø±Ø§Ø¦ÛŒÚº',0),(459440,12763,'sr','ÐŸÐ¾Ð´Ð½ÐµÑÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¸Ð·Ð²Ð¾Ð· QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ WÐµÐ± ÐºÐ¾Ð½ÐµÐºÑ‚Ð¾Ñ€Ð¾Ð¼',0),(459441,12763,'vi','Gá»­i yÃªu cáº§u xuáº¥t kháº©u QuickBooks Web káº¿t ná»‘i',0),(459442,12763,'af','Uitvoer versoek om QuickBooks Web verbinder voorlÃª',0),(459443,12763,'ro','Trimiteti cerere de Export a QuickBooks Web conector',0),(459444,12763,'et','Esitada ekspordi QuickBooks Web liides',0),(459445,12763,'si','PredloÅ¾iti izvozno zahtevo QuickBooks ujeti prikljuÄek',0),(459446,12763,'ba','Kirim permintaan ekspor untuk QuickBooks Web Connector',0),(459447,12763,'nl','Export verzoek aan QuickBooks Web Connector',0),(459448,12763,'fi','Vienti toimittavat QuickBooks Web Connector',0),(459449,12763,'no','Sende eksport til QuickBooks Web Connector',0),(459450,12763,'da','Anmode eksport til QuickBooks Web Connector',0),(459451,12763,'ko','QuickBooks ì›¹ ì»¤ë„¥í„° ë‚´ë³´ë‚´ê¸° ìš”ì²­ ì œì¶œ',0),(459452,12763,'he','×œ×”×’×™×© ×‘×§×©×” ×™×™×¦×•× QuickBooks ×•×‘×ž×§×©×¨',0),(459453,12763,'el','Î¥Ï€Î¿Î²Î¬Î»Î¿Ï…Î½ Î±Î¯Ï„Î·ÏƒÎ· ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ ÎšÎ¿Î½Î­ÎºÏ„Î¿ÏÎ±Ï‚ QuickBooks Web',0),(459454,12763,'zh','å‡ºå£å°†è¯·æ±‚æäº¤åˆ° QuickBooks Web è¿žæŽ¥å™¨',0),(459455,12763,'sv','Skicka Export begÃ¤ran till QuickBooks Web Connector',0),(459456,12763,'it','Invia richiesta di esportazione a QuickBooks Web Connector',0),(459457,12763,'tl','',0),(459458,12763,'th','à¸ªà¹ˆà¸‡à¸ªà¹ˆà¸‡à¸à¸²à¸£à¸£à¹‰à¸­à¸‡à¸‚à¸­à¹€à¸žà¸·à¹ˆà¸­à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¹€à¸§à¹‡à¸š QuickBooks',0),(459459,12763,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ QuickBooks à¤µà¥‡à¤¬ à¤•à¤¨à¥‡à¤•à¥à¤Ÿà¤° à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(459460,12763,'ms','Mengemukakan permintaan eksport dengan QuickBooks Web',0),(459461,12763,'ar','ØªÙ‚Ø¯ÙŠÙ… Ø·Ù„Ø¨ ØªØµØ¯ÙŠØ± Ø¥Ù„Ù‰ Ø±Ø§Ø¨Ø· ÙˆÙŠØ¨ Ù‚Ø±Ø§Ø¡',0),(459462,12763,'fr','Soumettre la demande d\'exportation Ã  QuickBooks Web Connector',0),(459463,12763,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆè¦æ±‚ã‚’æå‡ºã™ã‚‹ QuickBooks Web ã‚³ãƒã‚¯ã‚¿',0),(459464,12763,'pt','Enviar pedido de exportaÃ§Ã£o ao conector de QuickBooks Web',0),(459465,12763,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð´Ð»Ñ QuickBooks Web Connector',0),(459466,12763,'es','Somete Pedido de ExportaciÃ³n al Conector de Web de Quickbooks',0),(459467,12763,'de','Export Anfrage an QuickBooks Web Connector',0),(459468,12763,'en','Submit Export Request To QuickBooks Web Connector',0),(459469,12764,'is','',0),(459470,12764,'dr','Ø¢Ù¾Ù„ÙˆØ¯',0),(459471,12764,'pr','Ø¢Ù¾Ù„ÙˆØ¯',0),(459472,12764,'tr','KarÅŸÄ±ya yÃ¼kleme',0),(459473,12764,'pl','PrzesÅ‚aÄ‡',0),(459474,12764,'bg','ÐšÐ°Ñ‡Ð²Ð°Ð½Ðµ',0),(459475,12764,'ur','Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(459476,12764,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð¸',0),(459477,12764,'vi','táº£i',0),(459478,12764,'af','Oplaai',0),(459479,12764,'ro','ÃŽncÄƒrcaÅ£i',0),(459480,12764,'et','Lisamise kuupÃ¤ev',0),(459481,12764,'si','Upload',0),(459482,12764,'ba','Meng-upload',0),(459483,12764,'nl','Upload',0),(459484,12764,'fi','Lataa',0),(459485,12764,'no','Laste opp',0),(459486,12764,'da','Upload',0),(459487,12764,'ko','ì—…ë¡œë“œ',0),(459488,12764,'he','×œ×”×¢×œ×•×ª',0),(459489,12764,'el','Î‘Î½ÎµÎ²Î¬ÏƒÏ„Îµ',0),(459490,12764,'zh','ä¸Šä¼ ',0),(459491,12764,'sv','Ladda upp',0),(459492,12764,'it','Caricare',0),(459493,12764,'tl','',0),(459494,12764,'th','à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”',0),(459495,12764,'hi','à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(459496,12764,'ms','Muat naik',0),(459497,12764,'ar','ØªØ­Ù…ÙŠÙ„',0),(459498,12764,'fr','TÃ©lÃ©charger',0),(459499,12764,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰',0),(459500,12764,'pt','Fazer upload',0),(459501,12764,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ',0),(459502,12764,'es','Subir',0),(459503,12764,'de','Upload',0),(459504,12764,'en','Upload',0),(459505,12765,'is','',0),(459506,12765,'dr','(ØµØ§Ø¯Ø±Ø§ØªÛŒ) Ù…ÙˆØ¬ÙˆØ¯',0),(459507,12765,'pr','Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ Ø²ÛŒÙ¾ Ø§Ø±Ø³Ø§Ù„ÛŒ(ØµØ§Ø¯Ø±Ø§ØªÛŒ) Ù…ÙˆØ¬ÙˆØ¯',0),(459508,12765,'tr','Varolan bir ihracat ZIP dosyasÄ±nÄ± yÃ¼kleyin.',0),(459509,12765,'pl','Wgraj plik Zip istniejÄ…cego eksportu',0),(459510,12765,'bg','ÐšÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰ Ð¸Ð·Ð½Ð¾Ñ Zip Ñ„Ð°Ð¹Ð»',0),(459511,12765,'ur','Ø§ÛŒÚ© Ù…ÙˆØ¬ÙˆØ¯Û Ø¨Ø±Ø¢Ù…Ø¯ Ø²Ù¾ ÙØ§Ø¦Ù„ Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(459512,12765,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð—Ð¸Ð¿ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð¸Ð·Ð²Ð¾Ð·Ð°',0),(459513,12765,'vi','Táº£i táº­p tin trÃ­ch xuáº¥t Ä‘ang tá»“n táº¡i',0),(459514,12765,'af','Bestaande uitvoer Zip lÃªer oplaai',0),(459515,12765,'ro','ÃŽncÄƒrcaÅ£i un fiÅŸier existent Export Zip',0),(459516,12765,'et','Olemasolevate eksporti Zip faili Ã¼les laadida',0),(459517,12765,'si','Upload obstojeÄi datoteki Zip izvoz',0),(459518,12765,'ba','Meng-upload File Zip ekspor yang ada',0),(459519,12765,'nl','Een bestaande uitvoer Zip bestand uploaden',0),(459520,12765,'fi','Lataa olemassa vienti Zip-tiedosto',0),(459521,12765,'no','Laste opp en eksisterende Zip eksportfil',0),(459522,12765,'da','Uploade en eksisterende eksport zipfil',0),(459523,12765,'ko','ê¸°ì¡´ ìˆ˜ì¶œ Zip íŒŒì¼ì„ ì—…ë¡œë“œ',0),(459524,12765,'he','×”×¢×œ××ª ×§×•×‘×¥ Zip ×§×™×™× ×™×¦×•×',0),(459525,12765,'el','Î‘Î½ÎµÎ²Î¬ÏƒÏ„Îµ Î­Î½Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½ Î±ÏÏ‡ÎµÎ¯Î¿ Zip ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚',0),(459526,12765,'zh','çŽ°æœ‰çš„å‡ºå£ Zip æ–‡ä»¶ä¸Šä¼ ',0),(459527,12765,'sv','Ladda upp en befintlig Export Zip-fil',0),(459528,12765,'it','Caricare un File Zip di esportazione esistente',0),(459529,12765,'tl','',0),(459530,12765,'th','à¸­à¸±à¸žà¹‚à¸«à¸¥à¸”à¹„à¸Ÿà¸¥à¹Œ Zip à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(459531,12765,'hi','à¤•à¤¿à¤¸à¥€ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤œà¤¼à¤¿à¤ª à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(459532,12765,'ms','Muat naik fail Zip eksport sedia ada',0),(459533,12765,'ar','ØªØ­Ù…ÙŠÙ„ Ù…Ù„Ù Ù…Ø¶ØºÙˆØ· Ù…ÙˆØ¬ÙˆØ¯ ÙÙŠ Ø§Ù„ØªØµØ¯ÙŠØ±',0),(459534,12765,'fr','TÃ©lÃ©charger un fichier Zip Export',0),(459535,12765,'jp','æ—¢å­˜ã®ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã® Zip ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(459536,12765,'pt','Fazer upload de um arquivo de Zip de exportaÃ§Ã£o existente',0),(459537,12765,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÐµÐ³Ð¾ Zip-Ñ„Ð°Ð¹Ð»Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(459538,12765,'es','Subir Un File Zip de Exportar Existente',0),(459539,12765,'de','Eine vorhandene Export-Zip-Datei hochladen',0),(459540,12765,'en','Upload An Existing Export Zip File',0),(459541,12766,'is','',0),(459542,12766,'dr','Ø®Ø·Ø§ÛŒ Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† ÙØ§ÛŒÙ„ Ø²ÛŒÙ¾',0),(459543,12766,'pr','Ø®Ø·Ø§ÛŒ Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† ÙØ§ÛŒÙ„ Ø²ÛŒÙ¾',0),(459544,12766,'tr','Bu Zip dosyasÄ± ile Ã§alÄ±ÅŸma hatasÄ±',0),(459545,12766,'pl','O pracÄ™ z tym plikiem Zip',0),(459546,12766,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ Ñ‚Ð¾Ð·Ð¸ Zip Ñ„Ð°Ð¹Ð»',0),(459547,12766,'ur','Ø§Ø³ Ø²Ù¾ Ù…Ø³Ù„ Ú©Û’ Ø³Ø§ØªÚ¾ Ú©Ø§Ù… Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(459548,12766,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ñ€Ð°Ð´Ñƒ ÑÐ° Ð¾Ð²Ð¾Ð¼ Ð—Ð¸Ð¿ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(459549,12766,'vi','Lá»—i khi lÃ m viá»‡c vá»›i file zip',0),(459550,12766,'af','Fout met hierdie Zip lÃªer werk',0),(459551,12766,'ro','Eroare de lucru cu acest fiÅŸier Zip',0),(459552,12766,'et','TÃ¶Ã¶tamine Zip faili tÃµrge',0),(459553,12766,'si','Napake, ki delajo s to Å¾viÅ¾g pila',0),(459554,12766,'ba','Kesalahan yang bekerja dengan File Zip ini',0),(459555,12766,'nl','Fout werken met dit Zip-bestand',0),(459556,12766,'fi','Virhe kanssa tÃ¤mÃ¤ Zip-tiedosto',0),(459557,12766,'no','Feil arbeidet med zipfilen',0),(459558,12766,'da','Fejl arbejder med denne Zip-fil',0),(459559,12766,'ko','ì´ Zip íŒŒì¼ ìž‘ì—… ì˜¤ë¥˜',0),(459560,12766,'he','×©×’×™××” ×¢×•×‘×“ ×¢× ×§×•×‘×¥ ×”-Zip ×”×–×”',0),(459561,12766,'el','Î£Ï†Î¬Î»Î¼Î± Ï€Î¿Ï… ÎµÏÎ³Î¬Î¶Î¿Î½Ï„Î±Î¹ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Zip',0),(459562,12766,'zh','ä½¿ç”¨è¯¥ Zip æ–‡ä»¶çš„é”™è¯¯',0),(459563,12766,'sv','Fel som arbetar med denna Zip-fil',0),(459564,12766,'it','Errore lavorando con questo File Zip',0),(459565,12766,'tl','',0),(459566,12766,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™à¸à¸±à¸šà¹„à¸Ÿà¸¥à¹Œ Zip à¸™à¸µà¹‰',0),(459567,12766,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‡à¤¸ à¤œà¤¼à¤¿à¤ª à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¤¾à¤°à¥à¤¯ à¤•à¤°à¤¨à¤¾',0),(459568,12766,'ms','Ralat yang bekerja dengan fail Zip ini',0),(459569,12766,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø¹Ù…Ù„ Ù…Ø¹ Ù‡Ø°Ø§ Ø§Ù„Ù…Ù„Ù Zip',0),(459570,12766,'fr','Erreur travailler avec ce fichier Zip',0),(459571,12766,'jp','ã“ã® Zip ãƒ•ã‚¡ã‚¤ãƒ«ã®æ“ä½œã‚¨ãƒ©ãƒ¼',0),(459572,12766,'pt','Erro de trabalhar com este arquivo Zip',0),(459573,12766,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ñ Zip-Ñ„Ð°Ð¹Ð»',0),(459574,12766,'es','Error Trabajando con este File de Zip',0),(459575,12766,'de','Fehler, die Arbeiten mit dieser Zipdatei',0),(459576,12766,'en','Error Working With This Zip File',0),(459577,12767,'is','',0),(459578,12767,'dr','Ù„Ø·ÙØ§ Ø§Ø¨ØªØ¯Ø§ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯ ',0),(459579,12767,'pr','Ù„Ø·ÙØ§ Ø§Ø¨ØªØ¯Ø§ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯ ',0),(459580,12767,'tr','LÃ¼tfen Ã¶nce bir banka hesabÄ± ekleyin',0),(459581,12767,'pl','ProszÄ™ najpierw dodaÄ‡ konto bankowe',0),(459582,12767,'bg','ÐœÐ¾Ð»Ñ, Ð´Ð¾Ð±Ð°Ð²ÐµÑ‚Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿ÑŠÑ€Ð²Ð¾',0),(459583,12767,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§ÛŒÚ© Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(459584,12767,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð¿Ñ€Ð²Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(459585,12767,'vi','vui lÃ²ng thÃªm thÃ´ng tin ngÃ¢n hÃ ng trÆ°á»›c',0),(459586,12767,'af','Voeg asseblief eers \'n bankrekening',0),(459587,12767,'ro','VÄƒ rugÄƒm sÄƒ adÄƒugaÅ£i un cont bancar Ã®n primul rÃ¢nd',0),(459588,12767,'et','Lisage esmalt pangakonto',0),(459589,12767,'si','Najprej dodajte banÄni raÄun',0),(459590,12767,'ba','Harap menambahkan rekening Bank pertama',0),(459591,12767,'nl','Voeg eerst een bankrekening',0),(459592,12767,'fi','LisÃ¤Ã¤ pankkitili ensin',0),(459593,12767,'no','Legg en bankkonto fÃ¸rst',0),(459594,12767,'da','Skal du fÃ¸rst tilfÃ¸je en bankkonto',0),(459595,12767,'ko','ë¨¼ì € ì€í–‰ ê³„ì¢Œë¥¼ ì¶”ê°€ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(459596,12767,'he','× × ×”×•×¡×£ ×—×©×‘×•×Ÿ ×‘× ×§ ×§×•×“×',0),(459597,12767,'el','Î Î±ÏÎ±ÎºÎ±Î»ÎµÎ¯ÏƒÎ¸Îµ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î­Î½Î± Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€ÏÏŽÏ„Î±',0),(459598,12767,'zh','è¯·å…ˆæ·»åŠ ä¸€ä¸ªé“¶è¡Œè´¦æˆ·',0),(459599,12767,'sv','LÃ¤gg till ett bankkonto fÃ¶rst',0),(459600,12767,'it','Si prega di aggiungere un conto bancario prima',0),(459601,12767,'tl','',0),(459602,12767,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£à¸à¹ˆà¸­à¸™',0),(459603,12767,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤¹à¤²à¥‡ à¤à¤• à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(459604,12767,'ms','Sila tambah akaun Bank terlebih dahulu',0),(459605,12767,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨ Ø¨Ù†ÙƒÙŠ Ø£ÙˆÙ„Ø§Ù‹',0),(459606,12767,'fr','S\'il vous plaÃ®t ajouter d\'abord un compte bancaire',0),(459607,12767,'jp','æœ€åˆã«ã€éŠ€è¡Œå£åº§ã‚’è¿½åŠ ã—ã¦ãã ã•ã„ã€‚',0),(459608,12767,'pt','Por favor, adicione uma conta de banco primeiro',0),(459609,12767,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð´Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ ÑÐ½Ð°Ñ‡Ð°Ð»Ð° Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ ÑÑ‡ÐµÑ‚',0),(459610,12767,'es','Favor de Agregar Una Cuenta Bancaria Primero',0),(459611,12767,'de','Bitte fÃ¼gen Sie zunÃ¤chst ein Bankkonto',0),(459612,12767,'en','Please Add A Bank Account First',0),(459613,12768,'is','',0),(459614,12768,'dr','Ù„Ø·ÙØ§ÛŒÚ© ÙØ§ÛŒÙ„ Ø§Ø±Ø³Ø§Ù„ÛŒ Ø±Ø§ Ø¢Ù¾Ù„ÙˆØ¯ Ú©Ù†ÛŒØ¯ ÛŒØ§ Ø§Ø¨ØªØ¯Ø§ Ø¨Ø§ ÙØ±Ø§ÛŒÙ†Ø¯Ø§Ø±Ø³Ø§Ù„ Ø´Ø±ÙˆØ¹ Ú©Ù†ÛŒØ¯  ',0),(459615,12768,'pr','Ù„Ø·ÙØ§ÛŒÚ© ÙØ§ÛŒÙ„ Ø§Ø±Ø³Ø§Ù„ÛŒ Ø±Ø§ Ø¢Ù¾Ù„ÙˆØ¯ Ú©Ù†ÛŒØ¯ ÛŒØ§ Ø§Ø¨ØªØ¯Ø§ Ø¨Ø§ ÙØ±Ø§ÛŒÙ†Ø¯Ø§Ø±Ø³Ø§Ù„ Ø´Ø±ÙˆØ¹ Ú©Ù†ÛŒØ¯  ',0),(459616,12768,'tr','LÃ¼tfen bir dÄ±ÅŸa aktarma dosyasÄ± yÃ¼kleyebilir veya verme iÅŸlemi Ã¶nce baÅŸlamak',0),(459617,12768,'pl','ProszÄ™ przesÅ‚aÄ‡ plik eksportu lub rozpoczÄ…Ä‡ procesu eksportowania pierwszym',0),(459618,12768,'bg','ÐœÐ¾Ð»Ñ, ÐºÐ°Ñ‡Ð¸ Ñ„Ð°Ð¹Ð» Ð·Ð° ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð»Ð¸ Ð·Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð½Ð° Ð¸Ð·Ð½Ð¾Ñ Ð¿ÑŠÑ€Ð²Ð¾',0),(459619,12768,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ù…Ø³Ù„ Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº ÛŒØ§ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Û’ Ø¹Ù…Ù„ Ú©Ø§ Ø¢ØºØ§Ø²',0),(459620,12768,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ð¸Ð·Ð²Ð¾Ð· Ð¸Ð»Ð¸ Ð¿Ñ€Ð²Ð¾ Ð¿Ð¾Ñ‡ÐµÑ‚Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ð¸Ð·Ð²Ð¾Ð·Ð°',0),(459621,12768,'vi','vui lÃ²ng táº£i 1 file excel hoáº·c báº¯t Ä‘áº§u quÃ¡ trÃ¬nh káº¿t xuáº¥t trÆ°á»›c',0),(459622,12768,'af','Asseblief \'n uitvoer lÃªer oplaai of die uitvoerproses eers Begin',0),(459623,12768,'ro','VÄƒ rugÄƒm sÄƒ Ã®ncÄƒrcaÅ£i un fiÅŸier de Export sau de a Ã®ncepe procesul de Export primul',0),(459624,12768,'et','Ekspordi faili Upload vÃµi lÃ¤hen Ekspordiprotsess kÃµigepealt',0),(459625,12768,'si','Prosim Upload izvoz pila ali zaÄeti postopek izvaÅ¾anja najprej',0),(459626,12768,'ba','Silahkan meng-Upload File ekspor atau memulai proses ekspor',0),(459627,12768,'nl','Upload een exportbestand of beginnen het exportproces eerst',0),(459628,12768,'fi','Lataa vientitiedoston tai aloittaa vientiprosessin ensin',0),(459629,12768,'no','Behage sende en eksportfil eller starte eksportprosessen fÃ¸rst',0),(459630,12768,'da','Venligst Upload en eksportfil eller begynde eksportprocessen fÃ¸rst',0),(459631,12768,'ko','ì œë°œ ë‚´ë³´ë‚´ê¸° íŒŒì¼ ì—…ë¡œë“œ ë˜ëŠ” ë‚´ë³´ë‚´ê¸° í”„ë¡œì„¸ìŠ¤ë¥¼ ë¨¼ì € ì‹œìž‘',0),(459632,12768,'he','× × ×œ×”×¢×œ×•×ª ×§×•×‘×¥ ×™×™×¦×•× ××• ×œ×”×ª×—×™×œ ××ª ×ª×”×œ×™×š ×”×™×™×¦×•× ×§×•×“×',0),(459633,12768,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Î±Î½ÎµÎ²Î¬ÏƒÎµÏ„Îµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ Î® Î½Î± Î¾ÎµÎºÎ¹Î½Î®ÏƒÎµÎ¹ Î· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ Ï€ÏÏŽÏ„Î±',0),(459634,12768,'zh','è¯·ä¸Šä¼ ä¸€ä¸ªå¯¼å‡ºæ–‡ä»¶æˆ–ç¬¬ä¸€æ¬¡å¼€å§‹å¯¼å‡ºè¿‡ç¨‹',0),(459635,12768,'sv','VÃ¤nligen ladda upp en Export-fil eller bÃ¶rja exportprocessen fÃ¶rst',0),(459636,12768,'it','Si prega di caricare un File di esportazione o iniziare il processo di esportazione prima',0),(459637,12768,'tl','',0),(459638,12768,'th','à¸à¸£à¸¸à¸“à¸²à¸­à¸±à¸žà¹‚à¸«à¸¥à¸”à¹„à¸Ÿà¸¥à¹Œà¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸ à¸«à¸£à¸·à¸­à¹€à¸£à¸´à¹ˆà¸¡à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸à¹ˆà¸­à¸™',0),(459639,12768,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤¿à¤¸à¥€ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤ªà¤²à¥‹à¤¡ à¤¯à¤¾ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤ªà¤¹à¤²à¥€ à¤¬à¤¾à¤° à¤¶à¥à¤°à¥‚ à¤¹à¥‹',0),(459640,12768,'ms','Sila memuat turun satu fail eksport atau memulakan proses eksport pertama',0),(459641,12768,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ù…ÙŠÙ„ Ù…Ù„Ù ØªØµØ¯ÙŠØ± Ø£Ùˆ Ø¨Ø¯Ø¡ Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ØªØµØ¯ÙŠØ± Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(459642,12768,'fr','Veuillez tÃ©lÃ©charger un fichier d\'exportation ou de commencer le processus d\'exportation d\'abord',0),(459643,12768,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã™ã‚‹ã‹ã¾ãšã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ—ãƒ­ã‚»ã‚¹ã‚’é–‹å§‹ã—ã¦ãã ã•ã„ã€‚',0),(459644,12768,'pt','Por favor, fazer Upload de um arquivo de exportaÃ§Ã£o ou iniciar o processo de exportaÃ§Ã£o, primeiro',0),(459645,12768,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð·Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° Ð¸Ð»Ð¸ Ð½Ð°Ñ‡Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÑÑ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(459646,12768,'es','Favor de Subir un File de ExportaciÃ³n o Empezar el Proceso de ExportaciÃ³n Primero',0),(459647,12768,'de','Bitte laden Sie eine Datei exportieren oder den Exportvorgang beginne',0),(459648,12768,'en','Please Upload An Export File Or Begin The Export Process First',0),(459649,12769,'is','',0),(459650,12769,'dr','ÙØ§ÛŒÙ„ Ø§Ø±Ø³Ø§Ù„ÛŒ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø± Ú©Ø±Ø¯Ù† ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯  ',0),(459651,12769,'pr','ÙØ§ÛŒÙ„ Ø§Ø±Ø³Ø§Ù„ÛŒ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø± Ú©Ø±Ø¯Ù† ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯  ',0),(459652,12769,'tr','Verme dosyasÄ± ile Ã§alÄ±ÅŸma yok',0),(459653,12769,'pl','Brak pliku eksportu do pracy z',0),(459654,12769,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð½Ð¾Ñ Ñ„Ð°Ð¹Ð» Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ',0),(459655,12769,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ù…Ø³Ù„ Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ù„ Ú©Ø± Ú©Ø§Ù… Ú©Ø±Ù†Ø§ ÛÛ’ Û”',0),(459656,12769,'sr','ÐÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð¸Ð·Ð²Ð¾Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð·Ð° Ñ€Ð°Ð´ ÑÐ°',0),(459657,12769,'vi','KhÃ´ng cÃ³ táº­p tin trÃ­ch xuáº¥t Ä‘á»ƒ lÃ m viá»‡c vá»›i',0),(459658,12769,'af','Daar Is geen uitvoer lÃªer om te werk met',0),(459659,12769,'ro','Nu existÄƒ nici un fiÅŸier de Export sÄƒ lucreze cu',0),(459660,12769,'et','Puudub ekspordi faili tÃ¶Ã¶',0),(459661,12769,'si','Ni izvozne datoteke za delo z',0),(459662,12769,'ba','Ada tidak ada ekspor File untuk bekerja dengan',0),(459663,12769,'nl','Er Is geen exportbestand te werken met',0),(459664,12769,'fi','Tiedostoa ei ole vienti yhdessÃ¤',0),(459665,12769,'no','Det er ingen eksportfil Ã¥ jobbe med',0),(459666,12769,'da','Der er ingen eksportfil at arbejde med',0),(459667,12769,'ko','ì´ ìž‘ì—…ì„ ë‚´ë³´ë‚´ê¸° íŒŒì¼ì´ ì—†ìŠµë‹ˆë‹¤.',0),(459668,12769,'he','××™×Ÿ ×§×•×‘×¥ ×™×™×¦×•× ×œ×¢×‘×•×“ ××™×ª×•',0),(459669,12769,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÎºÎ±Î½Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ ÏƒÏ„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼Îµ',0),(459670,12769,'zh','å¯¹å·¥ä½œæ²¡æœ‰å¯¼å‡ºæ–‡ä»¶',0),(459671,12769,'sv','Det finns ingen exportfil att arbeta med',0),(459672,12769,'it','Non non c\'Ã¨ nessun File di esportazione al lavoro con',0),(459673,12769,'tl','',0),(459674,12769,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹à¸Ÿà¹‰à¸¡à¹„à¸¡à¹ˆà¸ªà¹ˆà¸‡à¸­à¸­à¸à¹„à¸›à¸—à¸³à¸‡à¸²à¸™à¸à¸±à¸š',0),(459675,12769,'hi','à¤µà¤¹à¤¾à¤ à¤•à¥‹à¤ˆ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¤¾à¤® à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¥ˆ',0),(459676,12769,'ms','Terdapat tiada fail eksport untuk bekerja dengan',0),(459677,12769,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø£ÙŠ Ù…Ù„Ù Ø§Ù„ØªØµØ¯ÙŠØ± Ø¥Ù„Ù‰ Ø§Ù„Ø¹Ù…Ù„ Ù…Ø¹',0),(459678,12769,'fr','Il n\'y a aucun fichier d\'exportation afin d\'utiliser',0),(459679,12769,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«ã®æ“ä½œã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(459680,12769,'pt','NÃ£o hÃ¡ nenhum arquivo de exportaÃ§Ã£o para o trabalho com',0),(459681,12769,'ru','ÐÐµÑ‚ Ñ„Ð°Ð¹Ð»Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° Ð´Ð»Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ñ',0),(459682,12769,'es','No Hay File de ExportaciÃ³n Con Que Trabajar',0),(459683,12769,'de','Es gibt keine Exportdatei fÃ¼r die Arbeit mit',0),(459684,12769,'en','There Is No Export File To Work With',0),(459685,12770,'is','',0),(459686,12770,'dr','Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø´Ø±Ú©Øª Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø³Ø±ÛŒØ¹ Ø´Ù…Ø§ Ø§ÛŒÙ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø±Ø§Ù†Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(459687,12770,'pr','Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø´Ø±Ú©Øª Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø³Ø±ÛŒØ¹ Ø´Ù…Ø§ Ø§ÛŒÙ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø±Ø§Ù†Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ ',0),(459688,12770,'tr','QuickBooks ÅŸirket bu verileri iÃ§ermeyebilir',0),(459689,12770,'pl','QuickBooks firmy nie mogÄ… zawieraÄ‡ dane',0),(459690,12770,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° QuickBooks ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÑŠÐ´ÑŠÑ€Ð¶Ð° Ñ‚ÐµÐ·Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(459691,12770,'ur','Ø¢Ù¾ Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ø§Ø³ Ú©ÙˆØ§Ø¦Ù Ú©ÛŒ Ø­Ø§Ù…Ù„ Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©ØªÛŒ ÛÛ’',0),(459692,12770,'sr','Ð’Ð°ÑˆÐ° QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐ°Ð´Ñ€Ð¶Ð¸ Ð¾Ð²Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(459693,12770,'vi','CÃ´ng ty QuickBooks cá»§a báº¡n cÃ³ thá»ƒ khÃ´ng chá»©a Ä‘á»±ng dá»¯ liá»‡u nÃ y',0),(459694,12770,'af','U QuickBooks Company Mag Moontlik nie Hierdie Data Bevat',0),(459695,12770,'ro','Compania dumneavoastrÄƒ QuickBooks nu poate conÈ›ine datele',0),(459696,12770,'et','QuickBooksi firma vÃµib sisaldada andmeid',0),(459697,12770,'si','Podjetju QuickBooks ne sme vsebovati teh podatkov',0),(459698,12770,'ba','Perusahaan QuickBooks Anda mungkin tidak berisi Data ini',0),(459699,12770,'nl','Uw bedrijf QuickBooks kunnen deze gegevens niet bevatten',0),(459700,12770,'fi','QuickBooks yritys ei saa sisÃ¤ltÃ¤Ã¤ tiedot',0),(459701,12770,'no','Firmaet QuickBooks kan ikke inneholde disse dataene',0),(459702,12770,'da','Virksomheden QuickBooks indeholder muligvis ikke disse Data',0),(459703,12770,'ko','QuickBooks íšŒì‚¬ê°€ì´ ë°ì´í„°ë¥¼ ì‚¬ìš©í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(459704,12770,'he','×™×™×ª×›×Ÿ ×”×—×‘×¨×” QuickBooks ×©×œ×š ××™× × ×ž×›×™×œ×™× × ×ª×•× ×™× ××œ×”',0),(459705,12770,'el','Î— ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÏƒÎ±Ï‚ QuickBooks Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï€ÎµÏÎ¹Î­Ï‡ÎµÎ¹ Î±Ï…Ï„Î¬ Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(459706,12770,'zh','QuickBooks è´µå¸å¯èƒ½ä¸åŒ…å«æ­¤æ•°æ®',0),(459707,12770,'sv','FÃ¶retaget QuickBooks fÃ¥r inte innehÃ¥lla dessa uppgifter',0),(459708,12770,'it','Vostra azienda QuickBooks non possono contenere dati',0),(459709,12770,'tl','',0),(459710,12770,'th','à¸šà¸£à¸´à¸©à¸±à¸— QuickBooks à¸‚à¸­à¸‡à¸„à¸¸à¸“à¸­à¸²à¸ˆà¸›à¸£à¸°à¸à¸­à¸šà¸”à¹‰à¸§à¸¢à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸™à¸µà¹‰',0),(459711,12770,'hi','à¤…à¤ªà¤¨à¥‡ QuickBooks à¤•à¤‚à¤ªà¤¨à¥€ à¤‡à¤¸ à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾',0),(459712,12770,'ms','Syarikat QuickBooks anda tidak boleh mengandungi Data ini',0),(459713,12770,'ar','Ø´Ø±ÙƒØ© QuickBooks Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù‚Ø¯ Ù„Ø§ ÙŠØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ Ù‡Ø°Ù‡ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(459714,12770,'fr','Votre compagnie de QuickBooks ne contienne pas de ces donnÃ©es',0),(459715,12770,'jp','QuickBooks ä¼šç¤¾ã¯ã“ã®ãƒ‡ãƒ¼ã‚¿ã‚’å«ã‚ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(459716,12770,'pt','Sua empresa de QuickBooks nÃ£o pode conter dados',0),(459717,12770,'ru','Ð’Ð°ÑˆÐµÐ¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ QuickBooks Ð¼Ð¾Ð¶ÐµÑ‚ Ð½Ðµ ÑÐ¾Ð´ÐµÑ€Ð¶Ð°Ñ‚ÑŒ ÑÑ‚Ð¸ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(459718,12770,'es','Su Empresa de Quickbooks se Puede Contener Estos Datos',0),(459719,12770,'de','Ihrem QuickBooks Unternehmen kÃ¶nnen diese Daten nicht enthalten.',0),(459720,12770,'en','Your QuickBooks Company May Not Contain This Data',0),(459721,12771,'is','',0),(459722,12771,'dr','ØµØ§Ø¯Ø±Ø§Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ù¾Ø±Ø´ÛŒÙ†',0),(459723,12771,'pr','ØµØ§Ø¯Ø±Ø§Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ù¾Ø±Ø´ÛŒÙ†',0),(459724,12771,'tr','QuickBooks verilerini verme',0),(459725,12771,'pl','Eksportowanie danych programu QuickBooks',0),(459726,12771,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QuickBooks Ð´Ð°Ð½Ð½Ð¸',0),(459727,12771,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ú©ÙˆØ§Ø¦Ù Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(459728,12771,'sr','Ð˜Ð·Ð²Ð¾Ð· QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(459729,12771,'vi','Xuáº¥t dá»¯ liá»‡u QuickBooks',0),(459730,12771,'af','QuickBooks Data uitvoer',0),(459731,12771,'ro','Export date QuickBooks',0),(459732,12771,'et','QuickBooksi andmete eksportimine',0),(459733,12771,'si','Podatki programa QuickBooks izvoz',0),(459734,12771,'ba','Ekspor QuickBooks Data',0),(459735,12771,'nl','QuickBooks-gegevens exporteren',0),(459736,12771,'fi','QuickBooks vientitiedot',0),(459737,12771,'no','Eksportere QuickBooks-Data',0),(459738,12771,'da','Eksportere QuickBooks-Data',0),(459739,12771,'ko','QuickBooks ë°ì´í„° ë‚´ë³´ë‚´ê¸°',0),(459740,12771,'he','×™×™×¦×•× × ×ª×•× ×™× QuickBooks',0),(459741,12771,'el','Î•Î¾Î±Î³Î¬Î³ÎµÏ„Îµ Î´ÎµÎ´Î¿Î¼Î­Î½Î± QuickBooks',0),(459742,12771,'zh','QuickBooks æ•°æ®å¯¼å‡º',0),(459743,12771,'sv','Exportera QuickBooks-Data',0),(459744,12771,'it','Esportare dati di QuickBooks',0),(459745,12771,'tl','',0),(459746,12771,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥ QuickBooks',0),(459747,12771,'hi','QuickBooks à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(459748,12771,'ms','Mengeksport QuickBooks Data',0),(459749,12771,'ar','ØªØµØ¯ÙŠØ± Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ù…Ù† QuickBooks',0),(459750,12771,'fr','Exporter des donnÃ©es de QuickBooks',0),(459751,12771,'jp','QuickBooks ã®ãƒ‡ãƒ¼ã‚¿ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(459752,12771,'pt','Exportar dados do QuickBooks',0),(459753,12771,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… QuickBooks',0),(459754,12771,'es','Exportar datos de QuickBooks',0),(459755,12771,'de','QuickBooks-Daten exportieren',0),(459756,12771,'en','Export QuickBooks Data',0),(459757,12772,'is','',0),(459758,12772,'dr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯',0),(459759,12772,'pr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯',0),(459760,12772,'tr','Varolan iÅŸlemleri baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(459761,12772,'pl','IstniejÄ…cych transakcji pomyÅ›lnie zaktualizowana',0),(459762,12772,'bg','Ð¡ÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(459763,12772,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(459764,12772,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(459765,12772,'vi','Giao dá»‹ch Ä‘ang cÃ³ Ä‘Ã£ Ä‘Æ°á»£c cáº­p nháº­t thÃ nh cÃ´ng',0),(459766,12772,'af','Bestaande transaksies suksesvol bygewerk',0),(459767,12772,'ro','Existente tranzactii actualizat cu succes',0),(459768,12772,'et','Olemasolevate kannete vÃ¤rskendatud',0),(459769,12772,'si','ObstojeÄe transakcije uspeÅ¡no posodobljena',0),(459770,12772,'ba','Ada transaksi berhasil',0),(459771,12772,'nl','Bestaande transacties met succes bijgewerkt',0),(459772,12772,'fi','Olemassa olevien tapahtumien pÃ¤ivittÃ¤minen onnistui',0),(459773,12772,'no','Eksisterende transaksjoner oppdatert',0),(459774,12772,'da','Eksisterende transaktioner opdateret',0),(459775,12772,'ko','ê¸°ì¡´ íŠ¸ëžœìž­ì…˜ì´ ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(459776,12772,'he','×ª× ×•×¢×•×ª ×§×™×™×ž×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(459777,12772,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎµÏ‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(459778,12772,'zh','å·²æˆåŠŸæ›´æ–°çš„çŽ°æœ‰äº¤æ˜“è®°å½•',0),(459779,12772,'sv','Befintliga transaktioner uppdaterats',0),(459780,12772,'it','Transazioni esistenti aggiornate con successo',0),(459781,12772,'tl','',0),(459782,12772,'th','à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(459783,12772,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(459784,12772,'ms','Urus-niaga yang sedia ada yang berjaya dikemas kini',0),(459785,12772,'ar','Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(459786,12772,'fr','Mis Ã  jour avec succÃ¨s des Transactions existantes',0),(459787,12772,'jp','æ—¢å­˜ã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(459788,12772,'pt','TransaÃ§Ãµes existentes atualizadas com sucesso',0),(459789,12772,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(459790,12772,'es','Transacciones Existentes Actualizadas Exitosamente',0),(459791,12772,'de','Vorhandene Transaktionen erfolgreich aktualisiert',0),(459792,12772,'en','Existing Transactions Updated Successfully',0),(459793,12773,'is','',0),(459794,12773,'dr',' Ø§ÛŒÙ† Ù…Ø±Ø­Ù„Ù‡ Ù‚Ø§Ø¨Ù„ Ø¨Ø§Ø²Ú¯Ø´Øª Ù†ÛŒØ³Øª',0),(459795,12773,'pr',' Ø§ÛŒÙ† Ù…Ø±Ø­Ù„Ù‡ Ù‚Ø§Ø¨Ù„ Ø¨Ø§Ø²Ú¯Ø´Øª Ù†ÛŒØ³Øª',0),(459796,12773,'tr','Bu adÄ±m geri alÄ±namaz',0),(459797,12773,'pl','Ten krok nie moÅ¼na cofnÄ…Ä‡',0),(459798,12773,'bg','Ð¢Ð°Ð·Ð¸ ÑÑ‚ÑŠÐ¿ÐºÐ° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð¾',0),(459799,12773,'ur','ÛŒÛ Ù…Ø±Ø­Ù„Û Ú©Ø§Ù„Ø¹Ø¯Ù… Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§',0),(459800,12773,'sr','ÐžÐ²Ð°Ñ˜ ÐºÐ¾Ñ€Ð°Ðº Ð½Ð¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¾Ð¿Ð¾Ð·Ð²Ð°Ñ‚Ð¸',0),(459801,12773,'vi','bÆ°á»›c nÃ y khÃ´ng thá»ƒ khÃ´ng xong',0),(459802,12773,'af','Hierdie stap kan nie ontdoen word',0),(459803,12773,'ro','Acest pas nu poate fi anulatÄƒ',0),(459804,12773,'et','Selles etapis ei saa tagasi vÃµtta',0),(459805,12773,'si','Ta korak ni mogoÄe razveljaviti',0),(459806,12773,'ba','Langkah ini tidak bisa dibatalkan',0),(459807,12773,'nl','Deze stap kan niet ongedaan worden gemaakt',0),(459808,12773,'fi','TÃ¤ssÃ¤ vaiheessa ei voi kumota',0),(459809,12773,'no','Dette trinnet kan ikke angres',0),(459810,12773,'da','Dette trin kan ikke fortrydes',0),(459811,12773,'ko','ì´ ë‹¨ê³„ëŠ” ì‹¤í–‰ ì·¨ì†Œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(459812,12773,'he','×©×œ×‘ ×–×” ×‘×œ×ª×™ ×”×¤×™×š',0),(459813,12773,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ Î²Î®Î¼Î± Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î½Î±Î¹ÏÎµÎ¸ÎµÎ¯',0),(459814,12773,'zh','æ­¤æ­¥éª¤æ— æ³•æ’¤æ¶ˆ',0),(459815,12773,'sv','Detta steg kan inte Ã¥ngras',0),(459816,12773,'it','Questo passaggio non puÃ² essere annullato',0),(459817,12773,'tl','',0),(459818,12773,'th','à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸¥à¸´à¸à¸—à¸³',0),(459819,12773,'hi','à¤¯à¤¹ à¤•à¤¦à¤® à¤ªà¥‚à¤°à¥à¤µà¤µà¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(459820,12773,'ms','Langkah ini tidak boleh dibuat asal',0),(459821,12773,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„ØªØ±Ø§Ø¬Ø¹ Ø¹Ù† Ù‡Ø°Ù‡ Ø§Ù„Ø®Ø·ÙˆØ©',0),(459822,12773,'fr','Cette Ã©tape ne peut Î©tre annulÎ˜e',0),(459823,12773,'jp','ã“ã®æ‰‹é †ã¯å…ƒã«æˆ»ã™ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(459824,12773,'pt','Esta etapa nÃ£o pode ser desfeita',0),(459825,12773,'ru','Ð­Ñ‚Ð¾Ñ‚ ÑˆÐ°Ð³ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð¾',0),(459826,12773,'es','Este Paso No se Puede Dshacer',0),(459827,12773,'de','Dieser Schritt kann nicht rÃ¼ckgÃ¤ngig gemacht werden.',0),(459828,12773,'en','This Step Cannot Be Undone',0),(459829,12774,'is','',0),(459830,12774,'dr','Ù‡Ù…Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ Ø¨Ø§ Ø§ÛŒÙ† Ù¾ÙˆÙ„ Ø±Ø§ÛŒØ¬ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ú©Ù†ÛŒØ¯',0),(459831,12774,'pr','Ù‡Ù…Ù‡ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ Ø¨Ø§ Ø§ÛŒÙ† Ù¾ÙˆÙ„ Ø±Ø§ÛŒØ¬ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ú©Ù†ÛŒØ¯',0),(459832,12774,'tr','Bu para ile tÃ¼m varolan hareketleri gÃ¼ncelleÅŸtirme',0),(459833,12774,'pl','Aktualizacja wszystkich istniejÄ…cych transakcji z tej waluty',0),(459834,12774,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ñ Ñ‚Ð°Ð·Ð¸ Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(459835,12774,'ur','Ø§Ø³ Ú©Ø±Ù†Ø³ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ ØªÙ…Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯Û Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(459836,12774,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÑÐ²Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÑÐ° Ð¾Ð²Ñƒ Ð²Ð°Ð»ÑƒÑ‚Ñƒ',0),(459837,12774,'vi','Cáº­p nháº­t Táº¥t cáº£ cÃ¡c giao dá»‹ch hiá»‡n táº¡i vá»›i tiá»n tá»‡ nÃ y',0),(459838,12774,'af','Dateer alle bestaande transaksies met hierdie geldeenheid',0),(459839,12774,'ro','ActualizaÅ£i toate tranzacÅ£iile existente cu aceastÄƒ valutÄƒ',0),(459840,12774,'et','Uuendada kÃµigi olemasolevate tehingute tegemisel',0),(459841,12774,'si','Posodobite vse obstojeÄe transakcije s to valuto',0),(459842,12774,'ba','Memperbarui semua transaksi yang ada dengan mata uang ini',0),(459843,12774,'nl','Bijwerken van alle bestaande transacties met deze valuta',0),(459844,12774,'fi','PÃ¤ivitÃ¤ kaikki nykyiset tapahtumat tÃ¤ssÃ¤ valuutassa',0),(459845,12774,'no','Oppdatere alle eksisterende transaksjoner med denne valutaen',0),(459846,12774,'da','Opdatere alle eksisterende transaktioner med denne valuta',0),(459847,12774,'ko','ì´ í†µí™”ì™€ ëª¨ë“  ê¸°ì¡´ íŠ¸ëžœìž­ì…˜ì—ì„œ ì—…ë°ì´íŠ¸',0),(459848,12774,'he','×¢×“×›×•×Ÿ ×›×œ ×ª× ×•×¢×•×ª ×§×™×™×ž×•×ª ×¢× ×ž×˜×‘×¢ ×–×”',0),(459849,12774,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎµÏ‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±',0),(459850,12774,'zh','ä½¿ç”¨è¿™ç§è´§å¸æ›´æ–°æ‰€æœ‰çŽ°æœ‰çš„äº¤æ˜“è®°å½•',0),(459851,12774,'sv','Uppdatera alla befintliga transaktioner med denna valuta',0),(459852,12774,'it','Aggiornare tutte le transazioni esistenti con questa valuta',0),(459853,12774,'tl','',0),(459854,12774,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸” à¸”à¹‰à¸§à¸¢à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™à¸™à¸µà¹‰',0),(459855,12774,'hi','à¤‡à¤¸ à¤®à¥à¤¦à¥à¤°à¤¾ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤­à¥€ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(459856,12774,'ms','Mengemaskini semua transaksi yang sedia ada dengan Mata Wang ini',0),(459857,12774,'ar','ØªØ­Ø¯ÙŠØ« ÙƒØ§ÙØ© Ø§Ù„Ø­Ø±ÙƒØ§Øª Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø© Ø¨Ù‡Ø°Ù‡ Ø§Ù„Ø¹Ù…Ù„Ø©',0),(459858,12774,'fr','Mise Ã  jour de toutes les Transactions existantes avec cette monnaie',0),(459859,12774,'jp','ã“ã®é€šè²¨ã®ã™ã¹ã¦ã®æ—¢å­˜ã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(459860,12774,'pt','Atualizar todas as transaÃ§Ãµes existentes com esta moeda',0),(459861,12774,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð²ÑÐµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ñ ÑÑ‚Ð¾Ð¹ Ð²Ð°Ð»ÑŽÑ‚Ð¾Ð¹',0),(459862,12774,'es','Actualizar Todas las Transacciones Existentes con Este Divisa',0),(459863,12774,'de','Aktualisieren Sie alle vorhandene Transaktionen mit dieser WÃ¤hrung',0),(459864,12774,'en','Update All Existing Transactions With This Currency',0),(459865,12775,'is','',0),(459866,12775,'dr','/Ø§ØµÙ„Ø§Ø­',0),(459867,12775,'pr','Ø§Ø±Ø²  Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(459868,12775,'tr','Para birimi yeni/DÃ¼zenle',0),(459869,12775,'pl','Nowe waluty/edycja',0),(459870,12775,'bg','ÐÐ¾Ð²Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(459871,12775,'ur','Ù†Ø¦Û’ Ú©Ø±Ù†Ø³ÛŒ/ØªØ¯ÙˆÛŒÙ†',0),(459872,12775,'sr','ÐÐ¾Ð²Ð° Ð²Ð°Ð»ÑƒÑ‚Ð°/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(459873,12775,'vi','thÃªm/ chá»‰nh sá»­a tiá»n tá»‡',0),(459874,12775,'af','Geldeenheid Nuwe/Redigeer',0),(459875,12775,'ro','Noua monedÄƒ/editare',0),(459876,12775,'et','Valuuta uus/Muuda',0),(459877,12775,'si','Valuta novega/Uredi',0),(459878,12775,'ba','Mata uang baru/Edit',0),(459879,12775,'nl','Nieuwe valuta/bewerken',0),(459880,12775,'fi','Uusi valuutta/muokata',0),(459881,12775,'no','Valuta ny/Rediger',0),(459882,12775,'da','Valuta ny/Rediger',0),(459883,12775,'ko','í†µí™” ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘',0),(459884,12775,'he','×ž×˜×‘×¢ ×—×“×©/×¢×¨×™×›×”',0),(459885,12775,'el','ÎÎ­Î¿ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(459886,12775,'zh','è´§å¸æ–°å»º/ç¼–è¾‘',0),(459887,12775,'sv','Ny valuta/redigera',0),(459888,12775,'it','Valuta nuovo/modifica',0),(459889,12775,'tl','',0),(459890,12775,'th','à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚',0),(459891,12775,'hi','à¤¨à¤ˆ à¤®à¥à¤¦à¥à¤°à¤¾/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(459892,12775,'ms','Mata Wang baru/Edit',0),(459893,12775,'ar','Ø§Ù„Ø¹Ù…Ù„Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©/ØªØ­Ø±ÙŠØ±',0),(459894,12775,'fr','Nouvelle monnaie/modifier',0),(459895,12775,'jp','é€šè²¨ã®ä½œæˆã¨ç·¨é›†',0),(459896,12775,'pt','Nova moeda/editar',0),(459897,12775,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð²Ð°Ð»ÑŽÑ‚Ñ‹/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(459898,12775,'es','Moneda Nuevo/Editar',0),(459899,12775,'de','WÃ¤hrung neu/bearbeiten',0),(459900,12775,'en','Currency New/Edit',0),(459901,12776,'is','',0),(459902,12776,'dr','Ù†Ø±Ø® Ù‡Ø§ÛŒ Ø§Ø±Ø²',0),(459903,12776,'pr','Ù†Ø±Ø® Ù‡Ø§ÛŒ Ø§Ø±Ø²',0),(459904,12776,'tr','DÃ¶viz kurlarÄ±',0),(459905,12776,'pl','Kursy walut',0),(459906,12776,'bg','Ð’Ð°Ð»ÑƒÑ‚Ð½Ð¸ ÐºÑƒÑ€ÑÐ¾Ð²Ðµ',0),(459907,12776,'ur','Ú©Ø±Ù†Ø³ÛŒ Ú©ÛŒ Ø´Ø±Ø­',0),(459908,12776,'sr','Ð’Ð°Ð»ÑƒÑ‚Ð°',0),(459909,12776,'vi','tá»· lá»‡ tiá»n tá»‡',0),(459910,12776,'af','Geldeenheid Koers',0),(459911,12776,'ro','Valutar',0),(459912,12776,'et','Valuutakursid',0),(459913,12776,'si','TeÄajih',0),(459914,12776,'ba','Kurs mata uang',0),(459915,12776,'nl','Wisselkoersen',0),(459916,12776,'fi','Valuuttakurssit',0),(459917,12776,'no','Valutakurser',0),(459918,12776,'da','Valutakurser',0),(459919,12776,'ko','í†µí™” ìš”ê¸ˆ',0),(459920,12776,'he','×©×¢×¨×™ ×”×—×œ×™×¤×™×Ÿ',0),(459921,12776,'el','Î™ÏƒÎ¿Ï„Î¹Î¼Î¯ÎµÏ‚ Î½Î¿Î¼Î¹ÏƒÎ¼Î¬Ï„Ï‰Î½',0),(459922,12776,'zh','è´§å¸æ±‡çŽ‡',0),(459923,12776,'sv','Valutakurser',0),(459924,12776,'it','Tassi di cambio',0),(459925,12776,'tl','',0),(459926,12776,'th','à¸­à¸±à¸•à¸£à¸²à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™',0),(459927,12776,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤¦à¤°',0),(459928,12776,'ms','Kadar Mata Wang',0),(459929,12776,'ar','Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Øª',0),(459930,12776,'fr','Taux de change',0),(459931,12776,'jp','é€šè²¨ãƒ¬ãƒ¼ãƒˆ',0),(459932,12776,'pt','Taxas de cÃ¢mbio',0),(459933,12776,'ru','ÐšÑƒÑ€ÑÑ‹ Ð²Ð°Ð»ÑŽÑ‚',0),(459934,12776,'es','Tipos de Cambio',0),(459935,12776,'de','WÃ¤hrungskurse',0),(459936,12776,'en','Currency Rates',0),(459937,12777,'is','',0),(459938,12777,'dr','Ù‡ÛŒÚ† Ø±Ú©ÙˆØ±Ø¯ÛŒ Ø¨Ø§ Ø§ÛŒÙ† Ù…Ø¹ÛŒØ§Ø± Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ù†ÛŒØ³Øª',0),(459939,12777,'pr','Ù‡ÛŒÚ† Ø±Ú©ÙˆØ±Ø¯ÛŒ Ø¨Ø§ Ø§ÛŒÙ† Ù…Ø¹ÛŒØ§Ø± Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ù†ÛŒØ³Øª',0),(459940,12777,'tr','KayÄ±t Ã¶lÃ§Ã¼tleriyle eÅŸleÅŸmedi',0),(459941,12777,'pl','Å»adne rekordy dopasowane kryteriÃ³w',0),(459942,12777,'bg','ÐÐµ Ð¾Ñ‚Ð³Ð¾Ð²Ð°Ñ€ÑÑ‚ Ð½Ð° ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ð¸Ñ‚Ðµ',0),(459943,12777,'ur','Ú©ÙˆØ¦ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø³ÙˆÙ¹ÛŒ Ø³Û’ Ù…Ø´Ø§Ø¨Û',0),(459944,12777,'sr','ÐÐ¸Ñ˜ÐµÐ´Ð°Ð½ Ð·Ð°Ð¿Ð¸Ñ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ð¾ ÑÐ° ÐºÑ€Ð¸Ñ‚ÐµÑ€Ð¸Ñ˜ÑƒÐ¼Ð¸Ð¼Ð°',0),(459945,12777,'vi','khÃ´ng cÃ³ ghi chÃ©p nÃ o Ä‘áº¡t tiÃªu chuáº©n',0),(459946,12777,'af','Geen rekords kriteria gepas',0),(459947,12777,'ro','ÃŽnregistrÄƒri potrivit criteriilor',0),(459948,12777,'et','Kirjeid ei vastanud kriteeriumidele',0),(459949,12777,'si','Noben zapis ujema z merilom',0),(459950,12777,'ba','Tidak ada catatan yang cocok dengan kriteria',0),(459951,12777,'nl','Geen Records gevonden die aan Criteria',0),(459952,12777,'fi','MikÃ¤Ã¤n tietueista ei vastannut ehtoja',0),(459953,12777,'no','Ingen poster oppfylte kriteriene',0),(459954,12777,'da','Ingen poster matcher kriterier',0),(459955,12777,'ko','ì¡°ê±´ê³¼ ì¼ì¹˜ í•˜ëŠ” ë ˆì½”ë“œê°€ ì—†ìŠµë‹ˆë‹¤.',0),(459956,12777,'he','×¨×©×•×ž×•×ª ×ª×•××ž×•×ª ×œ×§×¨×™×˜×¨×™×•× ×™×',0),(459957,12777,'el','Î”ÎµÎ½ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÏƒÏ…Î¼Ï†Ï‰Î½Î·Î¼Î­Î½Î± ÎºÏÎ¹Ï„Î®ÏÎ¹Î±',0),(459958,12777,'zh','ä¸Žæ¡ä»¶ä¸åŒ¹é…çš„ä»»ä½•è®°å½•',0),(459959,12777,'sv','Inga poster matchade kriterierna',0),(459960,12777,'it','Nessun record trovato criteri',0),(459961,12777,'tl','',0),(459962,12777,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸•à¸£à¸‡à¸à¸±à¸šà¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚',0),(459963,12777,'hi','à¤•à¥‹à¤ˆ à¤…à¤­à¤¿à¤²à¥‡à¤– à¤®à¤¾à¤¨à¤¦à¤‚à¤¡à¥‹à¤‚ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥‡',0),(459964,12777,'ms','Tiada rekod dipadankan kriteria',0),(459965,12777,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø³Ø¬Ù„Ø§Øª Ù…Ø·Ø§Ø¨Ù‚Ø© Ø§Ù„Ù…Ø¹Ø§ÙŠÙŠØ±',0),(459966,12777,'fr','Aucun enregistrement ne correspondance au critÃ¨re de',0),(459967,12777,'jp','æ¡ä»¶ã«ä¸€è‡´ã™ã‚‹ãƒ¬ã‚³ãƒ¼ãƒ‰ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(459968,12777,'pt','NÃ£o hÃ¡ registros correspondem a critÃ©rios',0),(459969,12777,'ru','ÐÐµÑ‚ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹, ÑƒÐ´Ð¾Ð²Ð»ÐµÑ‚Ð²Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ… ÑƒÑÐ»Ð¾Ð²Ð¸ÑÐ¼',0),(459970,12777,'es','No Hay CriterÃ­a Para Record Emparejados',0),(459971,12777,'de','Keine Aufzeichnungen brachten Kriterien',0),(459972,12777,'en','No Records Matched Criteria',0),(459973,12778,'is','',0),(459974,12778,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø³Ù…Øª \r\nA ',0),(459975,12778,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø³Ù…Øª \r\nA ',0),(459976,12778,'tr','Bir parÃ§a numarasÄ±nÄ± seÃ§in',0),(459977,12778,'pl','Wybierz numer katalogowy',0),(459978,12778,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ‡Ð°ÑÑ‚',0),(459979,12778,'ur','Ø§ÛŒÚ© Ø­ØµÛ Ù†Ù…Ø¨Ø± Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(459980,12778,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð´ÐµÐ»Ð°',0),(459981,12778,'vi','Chá»n 1 sá»‘ thay tháº¿',0),(459982,12778,'af','Kies \'n deel nommer',0),(459983,12778,'ro','SelectaÅ£i un numÄƒr de parte',0),(459984,12778,'et','Valige osa Number',0),(459985,12778,'si','Izberite Å¡tevilko dela',0),(459986,12778,'ba','Pilih nomor bagian',0),(459987,12778,'nl','Selecteer een onderdeelnummer',0),(459988,12778,'fi','Valitse osan numero',0),(459989,12778,'no','Velg et delenummer',0),(459990,12778,'da','VÃ¦lg et varenummer',0),(459991,12778,'ko','ë¶€í’ˆ ë²ˆí˜¸ë¥¼ ì„ íƒ',0),(459992,12778,'he','×‘×—×¨ ×ž×¡×¤×¨ ×—×œ×§',0),(459993,12778,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Ï€ÎµÎ´Î¯Î¿ \"ÎšÏ‰Î´.\"',0),(459994,12778,'zh','é€‰æ‹©ä¸€ä¸ªéƒ¨ä»¶å·',0),(459995,12778,'sv','VÃ¤lj en delnummer',0),(459996,12778,'it','Selezionare un numero di parte',0),(459997,12778,'tl','',0),(459998,12778,'th','à¹€à¸¥à¸·à¸­à¸à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸ªà¹ˆà¸§à¸™',0),(459999,12778,'hi','à¤à¤• à¤­à¤¾à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(460000,12778,'ms','Pilih beberapa bahagian',0),(460001,12778,'ar','Ù‚Ù… Ø¨ØªØ­Ø¯ÙŠØ¯ Ø±Ù‚Ù… Ø§Ù„Ø¬Ø²Ø¡',0),(460002,12778,'fr','SÃ©lectionnez un numÃ©ro de piÃ¨ce',0),(460003,12778,'jp','éƒ¨å“ç•ªå·ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(460004,12778,'pt','Selecione um nÃºmero de peÃ§a',0),(460005,12778,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(460006,12778,'es','Selecciona un NÃºmero de Parte',0),(460007,12778,'de','WÃ¤hlen Sie eine Teilenummer',0),(460008,12778,'en','Select A Part Number',0),(460009,12779,'is','',0),(460010,12779,'dr','Ø´Ù…Ø§ Ø§Ú©Ù†ÙˆÙ† Ø¨Ù‡ ÛŒÚ© Ø³Ø§ÛŒØª Ø®Ø§Ø±Ø¬ Ø§Ø² Ø§ÛŒÙ† Ø¨Ø±Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆÛŒØ¯',0),(460011,12779,'pr','Ø´Ù…Ø§ Ø§Ú©Ù†ÙˆÙ† Ø¨Ù‡ ÛŒÚ© Ø³Ø§ÛŒØª Ø®Ø§Ø±Ø¬ Ø§Ø² Ø§ÛŒÙ† Ø¨Ø±Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆÛŒØ¯',0),(460012,12779,'tr','Åžimdi dÄ±ÅŸÄ±nda farklÄ± bir siteye alÄ±nacaktÄ±r',0),(460013,12779,'pl','Teraz zostaniesz przeniesiony do innej lokacji poza',0),(460014,12779,'bg','Ð¡ÐµÐ³Ð° Ñ‰Ðµ ÑÐµ Ð²Ð·ÐµÐ¼Ð°Ñ‚ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð¾ Ð¼ÑÑÑ‚Ð¾ Ð¸Ð·Ð²ÑŠÐ½',0),(460015,12779,'ur','Ø¢Ù¾ Ø§Ø¨ Ú©Û’ Ø¨Ø§ÛØ± Ø§ÛŒÚ© Ù…Ø®ØªÙ„Ù ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ù„Û’ Ø¬Ø§ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(460016,12779,'sr','Ð¡Ð°Ð´Ð° Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð´Ð²ÐµÐ´ÐµÐ½Ð¸ Ñƒ Ð´Ñ€ÑƒÐ³Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð¸Ð·Ð²Ð°Ð½ Ð¾Ð´',0),(460017,12779,'vi','Báº¡n sáº½ Ä‘Æ°a Ä‘áº¿n 1 trang web khÃ¡c ',0),(460018,12779,'af','Jy sal nou geneem word na \'n ander perseel buite',0),(460019,12779,'ro','Acum va fi luat de un alt site in afara de',0),(460020,12779,'et','Siis nÃ¼Ã¼d tuleb vÃµtta eri ala vÃ¤ljaspool',0),(460021,12779,'si','Bo zdaj treba drugo mesto zunaj',0),(460022,12779,'ba','Anda kini akan diarahkan ke situs lain di luar',0),(460023,12779,'nl','U zal nu worden genomen naar een andere site buiten',0),(460024,12779,'fi','Sinun on nyt otettava toimipaikan ulkopuolella',0),(460025,12779,'no','Du vil nÃ¥ bli tatt til et annet omrÃ¥de utenfor',0),(460026,12779,'da','Du vil nu blive taget til et andet websted uden for',0),(460027,12779,'ko','ë‹¹ì‹ ì´ ì§€ê¸ˆ ì™¸ë¶€ì˜ ë‹¤ë¥¸ ì‚¬ì´íŠ¸ì— ì—°ê²° ë©ë‹ˆë‹¤.',0),(460028,12779,'he','×›×¢×ª ×ª×•×¢×‘×¨ ×œ××ª×¨ ××—×¨ ×ž×—×•×¥',0),(460029,12779,'el','Î¤ÏŽÏÎ± Î¸Î± Î¼ÎµÏ„Î±Ï†ÎµÏÎ¸ÎµÎ¯Ï„Îµ ÏƒÎµ Î¼Î¹Î± Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÎ® Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Î­Î¾Ï‰ Î±Ï€ÏŒ',0),(460030,12779,'zh','ä½ çŽ°åœ¨è¢«å¸¦åˆ°ä¸€ä¸ªä¸åŒçš„ç«™ç‚¹ä¹‹å¤–çš„',0),(460031,12779,'sv','Du kommer nu att tas till en annan plats utanfÃ¶r',0),(460032,12779,'it','Ora sarai reindirizzato a un sito diverso di fuori di',0),(460033,12779,'tl','',0),(460034,12779,'th','à¸•à¸­à¸™à¸™à¸µà¹‰à¸›à¸à¸´à¸šà¸±à¸•à¸´à¹„à¸›à¸¢à¸±à¸‡à¹„à¸‹à¸•à¹Œà¸­à¸·à¹ˆà¸™à¸ à¸²à¸¢à¸™à¸­à¸',0),(460035,12779,'hi','à¤¤à¥à¤® à¤…à¤¬ à¤à¤• à¤…à¤²à¤— à¤¸à¤¾à¤‡à¤Ÿ à¤•à¥‡ à¤¬à¤¾à¤¹à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥‡ à¤œà¤¾à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾',0),(460036,12779,'ms','Anda kini akan dibawa ke halaman lain di luar',0),(460037,12779,'ar','Ø³ÙŠØªÙ… Ù†Ù‚Ù„Ùƒ Ø§Ù„Ø¢Ù† Ø¥Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ Ø¢Ø®Ø± Ø®Ø§Ø±Ø¬ Ù…Ù†',0),(460038,12779,'fr','Vous serez maintenant vers un autre site en dehors de',0),(460039,12779,'jp','ã‚ãªãŸã®å¤–ã®åˆ¥ã®ã‚µã‚¤ãƒˆã«è¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(460040,12779,'pt','Agora vocÃª serÃ¡ levado para um site diferente fora do',0),(460041,12779,'ru','Ð¢ÐµÐ¿ÐµÑ€ÑŒ Ð²Ñ‹ Ð¿Ð¾Ð¿Ð°Ð´ÐµÑ‚Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð¾Ð¹ ÑÐ°Ð¹Ñ‚ Ð·Ð° Ð¿Ñ€ÐµÐ´ÐµÐ»Ð°Ð¼Ð¸',0),(460042,12779,'es','Ahora se lleva a un sitio afuera de',0),(460043,12779,'de','Sie gelangen nun in einen anderen Standort auÃŸerhalb der',0),(460044,12779,'en','You will now be taken to a different site outside of',0),(460045,12780,'is','',0),(460046,12780,'dr','Ø¨Ø§ÛŒØ¯ Ø§Ù†ÙˆØ§Ø¹ Ú©Ø§Ø± Ù‚Ø¨Ù„ Ø§Ø² Ø§ÛŒØ¬Ø§Ø¯ Ù„ÛŒØ³ØªÙ‡Ø§ÛŒ Ù‚ÛŒÙ…Øª Ø§ÛŒØ¬Ø§Ø¯ Ø´ÙˆØ¯',0),(460047,12780,'pr','Ø¨Ø§ÛŒØ¯ Ø§Ù†ÙˆØ§Ø¹ Ú©Ø§Ø± Ù‚Ø¨Ù„ Ø§Ø² Ø§ÛŒØ¬Ø§Ø¯ Ù„ÛŒØ³ØªÙ‡Ø§ÛŒ Ù‚ÛŒÙ…Øª Ø§ÛŒØ¬Ø§Ø¯ Ø´ÙˆØ¯',0),(460048,12780,'tr','BazÄ± iÅŸ tÃ¼rlerinin fiyat listelerini oluÅŸturmadan Ã¶nce oluÅŸturmanÄ±z gerekir',0),(460049,12780,'pl','NaleÅ¼y utworzyÄ‡ kilka typÃ³w pracy przed tworzenie cennikÃ³w',0),(460050,12780,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ Ð½ÑÐºÐ¾Ð¸ Ð²Ð¸Ð´Ð¾Ð²Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ñ€ÐµÐ´Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ð»Ð¸ÑÑ‚Ð¸',0),(460051,12780,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø¨Ù†Ø§Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ú©Ú†Ú¾ Ú©Ø§Ù… Ø§Ù‚Ø³Ø§Ù… ØªØ®Ù„ÛŒÙ‚ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒÛ’',0),(460052,12780,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð½ÐµÐºÐµ Ð²Ñ€ÑÑ‚Ðµ Ñ€Ð°Ð´Ð° Ð¿Ñ€Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐ° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐµ',0),(460053,12780,'vi','pháº£i táº¡o vÃ i loáº¡i cÃ´ng viá»‡c trÆ°á»›c khi táº¡o danh sÃ¡ch giÃ¡',0),(460054,12780,'af','Sommige tipes werk moet skep voor skep prys lyste',0),(460055,12780,'ro','Trebuie sÄƒ creaÅ£i unele tipuri de muncÄƒ Ã®nainte de a crea liste de preÅ£uri',0),(460056,12780,'et','Tuleb luua mÃµned tÃ¶Ã¶liikide loomisega hinnakirjad',0),(460057,12780,'si','Morate ustvariti nekatere vrste dela pred ustvarjanjem ceniki',0),(460058,12780,'ba','Harus membuat beberapa jenis karya sebelum membuat daftar harga',0),(460059,12780,'nl','Sommige werksoorten moet maken voordat u maakt prijslijsten',0),(460060,12780,'fi','On luotava tyÃ¶tÃ¤ joidenkin ennen luomista hinnastot',0),(460061,12780,'no','MÃ¥ opprette noen arbeidstyper fÃ¸r du lager prislister',0),(460062,12780,'da','Skal oprette nogle arbejdstyper fÃ¸r du opretter prislister',0),(460063,12780,'ko','ê°€ê²© ëª©ë¡ì„ ë§Œë“¤ê¸° ì „ì— ì–´ë–¤ ìž‘ì—… ì¢…ë¥˜ë¥¼ ë§Œë“¤ì–´ì•¼ í•©ë‹ˆë‹¤.',0),(460064,12780,'he','×¢×œ×™×š ×œ×™×¦×•×¨ ×›×ž×” ×¡×•×’×™ ×¢×‘×•×“×” ×œ×¤× ×™ ×™×¦×™×¨×ª ×ž×—×™×¨×•× ×™×',0),(460065,12780,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î¼ÎµÏÎ¹ÎºÎ¿ÏÏ‚ Ï„ÏÏ€Î¿Ï…Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï…Ï‚',0),(460066,12780,'zh','åˆ›å»ºä»·ç›®è¡¨ä¹‹å‰ï¼Œå¿…é¡»åˆ›å»ºä¸€äº›å·¥ä½œç±»åž‹',0),(460067,12780,'sv','MÃ¥ste skapa vissa arbetstyper av innan du skapar prislistor',0),(460068,12780,'it','Necessario creare alcuni tipi di lavoro prima di creare listini prezzi',0),(460069,12780,'tl','',0),(460070,12780,'th','à¸•à¹‰à¸­à¸‡à¸ªà¸£à¹‰à¸²à¸‡à¸šà¸²à¸‡à¸Šà¸™à¸´à¸”à¸—à¸³à¸‡à¸²à¸™à¸à¹ˆà¸­à¸™à¸—à¸µà¹ˆà¸ˆà¸°à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸„à¸²à¸•à¸¥à¸²à¸”',0),(460071,12780,'hi','à¤•à¥à¤› à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¤¿à¤¯à¤¾à¤ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¬à¤¨à¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(460072,12780,'ms','Mesti mencipta beberapa jenis kerja sebelum mencipta senarai harga',0),(460073,12780,'ar','ÙŠØ¬Ø¨ Ø¥Ù†Ø´Ø§Ø¡ Ø¨Ø¹Ø¶ Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¹Ù…Ù„ Ù‚Ø¨Ù„ Ø¥Ù†Ø´Ø§Ø¡ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(460074,12780,'fr','Devez crÃ©er certains Types de travail avant de crÃ©er des listes de prix',0),(460075,12780,'jp','ä¾¡æ ¼è¡¨ã‚’ä½œæˆã™ã‚‹å‰ã«ã„ãã¤ã‹ã®ä½œæ¥­ã®ç¨®é¡žã‚’ä½œæˆã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(460076,12780,'pt','Deve criar alguns tipos de trabalho antes de criar listas de preÃ§os',0),(460077,12780,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ñ‚Ð¸Ð¿Ð¾Ð² Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ñ… Ð¿ÐµÑ€ÐµÐ´ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸ÐµÐ¼ Ð¿Ñ€Ð°Ð¹Ñ Ð»Ð¸ÑÑ‚Ñ‹',0),(460078,12780,'es','Debe Crear Algunos Tipos de Trabajo Antes Que Crear Listas de Precios',0),(460079,12780,'de','MÃ¼ssen einige Arbeitstypen erstellen vor dem Erstellen von Preislisten',0),(460080,12780,'en','Must Create Some Work Types Before Creating Price Lists',0),(460081,12781,'is','',0),(460082,12781,'dr','Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù†Ø§Ù…',0),(460083,12781,'pr','Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù†Ø§Ù…',0),(460084,12781,'tr','Alternatif Ã¶deme yeri adÄ±',0),(460085,12781,'pl','Alternatywna nazwa zapÅ‚aciÄ‡',0),(460086,12781,'bg','ÐÐ»Ñ‚ÐµÑ€Ð½Ð°Ñ‚Ð¸Ð²ÐµÐ½ Ð¿Ð»Ð°Ñ‰Ð°-Ð½Ð° Ð¸Ð¼Ðµ',0),(460087,12781,'ur','Ù…ØªØ¨Ø§Ø¯Ù„ ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ù†Ø§Ù…',0),(460088,12781,'sr','ÐÐ»Ñ‚ÐµÑ€Ð½Ð°Ñ‚Ð¸Ð²Ð½Ð¾ Ð¸Ð¼Ðµ Ð·Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ñƒ',0),(460089,12781,'vi','HoÃ¡n Ä‘á»•i Thanh toÃ¡n sang Ä‘áº·t tÃªn',0),(460090,12781,'af','Alternatiewe betaal-om die naam',0),(460091,12781,'ro','Alternative de platÄƒ-la nume',0),(460092,12781,'et','Asendusliikme tasu nimetus',0),(460093,12781,'si','Alternate plaÄilo â€“ ime',0),(460094,12781,'ba','Bayar-untuk alternatif nama',0),(460095,12781,'nl','Alternatieve betalen aan naam',0),(460096,12781,'fi','Vaihtoehtoinen maksu kohteeseen-nimi',0),(460097,12781,'no','Alternative Betal til-navn',0),(460098,12781,'da','Alternative Pay-til navn',0),(460099,12781,'ko','ëŒ€ì²´ ì§€ë¶ˆì— ì´ë¦„',0),(460100,12781,'he','×©× ×—×œ×•×¤×™. ×œ×©×œ× ×›×“×™',0),(460101,12781,'el','Î Î»Î·ÏÏ‰Î¼Î® ÏƒÎµ ÎµÎ½Î±Î»Î»Î±ÎºÏ„Î¹ÎºÏŒ ÏŒÎ½Î¿Î¼Î±',0),(460102,12781,'zh','å¤‡ç”¨è–ªé…¬çš„åç§°',0),(460103,12781,'sv','Betala till alternativa namn',0),(460104,12781,'it','Nome alternativo Pay-a',0),(460105,12781,'tl','',0),(460106,12781,'th','à¸Šà¸·à¹ˆà¸­à¸­à¸·à¹ˆà¸™à¸ˆà¹ˆà¸²à¸¢à¹ƒà¸«à¹‰',0),(460107,12781,'hi','à¤µà¥ˆà¤•à¤²à¥à¤ªà¤¿à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¤¾ à¤¨à¤¾à¤®',0),(460108,12781,'ms','Membayar untuk ganti nama',0),(460109,12781,'ar','Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø¨Ø¯ÙŠÙ„ Ù„Ù„Ø¯ÙØ¹',0),(460110,12781,'fr','Ã€ payer autre nom',0),(460111,12781,'jp','ä»£æ›¿æ”¯æ‰•ã„å…ˆå',0),(460112,12781,'pt','Nome alternativo Pay-a',0),(460113,12781,'ru','Ð˜Ð¼Ñ Ð°Ð»ÑŒÑ‚ÐµÑ€Ð½Ð°Ñ‚Ð¸Ð²Ð½Ð¾Ð³Ð¾ Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(460114,12781,'es','Nombre Alternado de Pagar-a',0),(460115,12781,'de','Alternative Zahlung an Name',0),(460116,12781,'en','Alternate Pay-to Name',0),(460117,12782,'is','',0),(460118,12782,'dr',' ÙÛŒÙ„Ø¯ Ø±Ø§ Ø®Ø§Ù„ÛŒ Ø¨Ú¯Ø°Ø§Ø±ÛŒØ¯ Ø¯Ø± ØµÙˆØ±ØªÛŒ Ú©Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§Ø´Ø¯',0),(460119,12782,'pr',' ÙÛŒÙ„Ø¯ Ø±Ø§ Ø®Ø§Ù„ÛŒ Ø¨Ú¯Ø°Ø§Ø±ÛŒØ¯ Ø¯Ø± ØµÙˆØ±ØªÛŒ Ú©Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§Ø´Ø¯',0),(460120,12782,'tr','Ã–deme yeri satÄ±cÄ± adÄ± ise boÅŸ bÄ±rakÄ±n',0),(460121,12782,'pl','Pozostaw je puste, jeÅ›li odbiorca jest nazwa dostawcy',0),(460122,12782,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð°ÐºÐ¾ Ð¿Ð»Ð°Ñ‰Ð°-Ð½Ð° Ð¸Ð¼Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(460123,12782,'ur','Ø§Ú¯Ø± ØªÙ†Ø®ÙˆØ§Û Ú©Û’ ÙˆÛŒÙ†ÚˆØ± Ù†Ø§Ù… ÛÛ’ ØªÙˆ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº Û”',0),(460124,12782,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð°ÐºÐ¾ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ Ñ˜Ðµ Ð¸Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(460125,12782,'vi','Äá»ƒ trá»‘ng náº¿u ngÆ°á»i nháº­n lÃ  tÃªn nhÃ  cung cáº¥p',0),(460126,12782,'af','LeÃ« verlaat as betaal-is handelaar naam',0),(460127,12782,'ro','LÄƒsaÅ£i necompletat dacÄƒ platÄƒ-la furnizor de nume',0),(460128,12782,'et','JÃ¤ta tÃ¼hjaks, kui saaja on hankija nimi',0),(460129,12782,'si','Pustite prazno, Äe plaÄilo je ime dobavitelja',0),(460130,12782,'ba','Kosongkan jika membayar untuk nama Penjual',0),(460131,12782,'nl','Leeg laten als betalen aan leverancier naam',0),(460132,12782,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi jos laskuttajan on toimittajan nimi',0),(460133,12782,'no','La stÃ¥ tomt hvis Betal til-leverandÃ¸r',0),(460134,12782,'da','Efterlad Blank hvis Pay-til kreditornavnet',0),(460135,12782,'ko','ì§€ë¶ˆ í•˜ëŠ” ê³µê¸‰ ì—…ì²´ ì´ë¦„ ê²½ìš° ë¹ˆì„ ë– ë‚˜',0),(460136,12782,'he','×œ×”×©××™×¨ ×¨×™×§ ×× ×”×©×›×¨-×”×™× ×©× ×”×¡×¤×§',0),(460137,12782,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ ÎµÎ¬Î½ Ï€Î»Î·ÏÏ‰Î¼Î® ÏƒÎµ ÎµÎ¯Î½Î±Î¹ ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(460138,12782,'zh','ç©ºï¼Œå¦‚æžœæ”¯ä»˜ç»™ä¾›åº”å•†åç§°',0),(460139,12782,'sv','LÃ¤mna tomt om betalas leverantÃ¶rsnamn',0),(460140,12782,'it','Lasciare vuoto se Pay-a Ã¨ nome fornitore',0),(460141,12782,'tl','',0),(460142,12782,'th','à¸›à¸¥à¹ˆà¸­à¸¢à¹ƒà¸«à¹‰à¸§à¹ˆà¸²à¸‡à¸–à¹‰à¸²à¸ˆà¹ˆà¸²à¸¢ à¸Šà¸·à¹ˆà¸­ à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(460143,12782,'hi','à¤–à¤¾à¤²à¥€ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚ à¤¯à¤¦à¤¿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤¨à¤¾à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¹à¥ˆ',0),(460144,12782,'ms','Biarkan kosong jika membayar kepada penjual nama',0),(460145,12782,'ar','ØªØ±Ùƒ ÙØ§Ø±ØºØ§Ù‹ Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ø¯ÙØ¹ Ø¥Ù„Ù‰ Ù‡Ùˆ \"Ø§Ø³Ù… Ø§Ù„Ù…ÙˆØ±Ø¯\"',0),(460146,12782,'fr','Laisser en blanc si Ã  payer est le nom du vendeur',0),(460147,12782,'jp','ç©ºç™½ã®ã¾ã¾ã«ãŠæ”¯æ‰•ã„ã«ãƒ™ãƒ³ãƒ€ãƒ¼åãŒã‚ã‚‹å ´åˆ',0),(460148,12782,'pt','Deixar em branco se Pagto.-a nome fornecedor',0),(460149,12782,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, ÐµÑÐ»Ð¸ Ð¾Ð¿Ð»Ð°Ñ‚Ð° Ð¸Ð¼Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(460150,12782,'es','Deja en Blanco si Pagar A es el Nombre del Proveedor',0),(460151,12782,'de','Lassen Sie leer, wenn Zahlung an VerkÃ¤ufer Name',0),(460152,12782,'en','Leave Blank if Pay-to is Vendor Name',0),(460153,12783,'is','',0),(460154,12783,'dr','- Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(460155,12783,'pr','Ø¨Ø¯ÙˆÙ†- Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(460156,12783,'tr','PazarlÄ±k',0),(460157,12783,'pl','Niezbywalne',0),(460158,12783,'bg','ÐÐµ Ð¿Ð¾Ð´Ð»ÐµÐ¶Ð¸ Ð½Ð° Ð´Ð¾Ð³Ð¾Ð²Ð°Ñ€ÑÐ½Ðµ',0),(460159,12783,'ur','Ù†Ø§Ù‚Ø§Ø¨Ù„Ù',0),(460160,12783,'sr','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð¿Ñ€ÐµÐ³Ð¾Ð²Ð°Ñ€Ð°Ñ‚Ð¸',0),(460161,12783,'vi','khÃ´ng chuyá»ƒn nhÆ°á»£ng',0),(460162,12783,'af','Nie-onderhandelbare',0),(460163,12783,'ro','Non-negociabile',0),(460164,12783,'et','Mittekaubeldavad',0),(460165,12783,'si','Neprenosljive',0),(460166,12783,'ba','Non-Negotiable',0),(460167,12783,'nl','Niet-onderhandelbaar',0),(460168,12783,'fi','Neuvotella',0),(460169,12783,'no','Ikke-omsettelige',0),(460170,12783,'da','Ikke-omsÃ¦ttelige',0),(460171,12783,'ko','íƒ€í˜‘í• ',0),(460172,12783,'he','×œ× ×¡×—×™×¨',0),(460173,12783,'el','Î‘Î´Î¹Î±Ï€ÏÎ±Î³Î¼Î¬Ï„ÎµÏ…Ï„Î·',0),(460174,12783,'zh','éžé¢è®®',0),(460175,12783,'sv','Icke-fÃ¶rhandlingsbara',0),(460176,12783,'it','Non negoziabile',0),(460177,12783,'tl','',0),(460178,12783,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸¡à¸·à¸­à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(460179,12783,'hi','à¤•à¥‹à¤ˆ à¤¸à¤®à¤à¥Œà¤¤à¤¾',0),(460180,12783,'ms','Tidak boleh dirunding',0),(460181,12783,'ar','ØºÙŠØ± Ù‚Ø§Ø¨Ù„ Ù„Ù„ØªØ¯Ø§ÙˆÙ„',0),(460182,12783,'fr','Non nÃ©gociable',0),(460183,12783,'jp','éžäº¤æ¸‰å¯èƒ½',0),(460184,12783,'pt','NÃ£o-negociÃ¡vel',0),(460185,12783,'ru','ÐÐµÐ¾Ð±Ð¾Ñ€Ð¾Ñ‚Ð½Ñ‹Ðµ',0),(460186,12783,'es','No-Negociable',0),(460187,12783,'de','Nicht verhandelbar',0),(460188,12783,'en','Non-Negotiable',0),(460189,12784,'is','',0),(460190,12784,'dr','Ø¨Ø±Ø§ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú†Ú© Ù‡Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(460191,12784,'pr','Ø¨Ø±Ø§ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú†Ú© Ù‡Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(460192,12784,'tr','Denetimleri gÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klatÄ±n',0),(460193,12784,'pl','Kliknij, aby wyÅ›wietliÄ‡ kontroli',0),(460194,12784,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(460195,12784,'ur','Ú†ÛŒÚ© Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(460196,12784,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(460197,12784,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ Xem Kiá»ƒm tra',0),(460198,12784,'af','Klik om te bekyk kontroleer',0),(460199,12784,'ro','Click pentru a vizualiza controale',0),(460200,12784,'et','KlÃµpsake, et kuvada kontrollimine',0),(460201,12784,'si','Kliknite za ogled pregledi',0),(460202,12784,'ba','Klik untuk Lihat cek',0),(460203,12784,'nl','Klik om te bekijken controles',0),(460204,12784,'fi','Klikkaa nÃ¤hdÃ¤ksesi tarkastukset',0),(460205,12784,'no','Klikk for Ã¥ vise sjekker',0),(460206,12784,'da','Klik her for at se kontrol',0),(460207,12784,'ko','ê²€ì‚¬ë¥¼ í´ë¦­',0),(460208,12784,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’ ×‘×“×™×§×•×ª',0),(460209,12784,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î¿Ï…Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚',0),(460210,12784,'zh','å•å‡»æ­¤å¤„å¯æŸ¥çœ‹æ£€æŸ¥',0),(460211,12784,'sv','Klicka fÃ¶r att visa kontroller',0),(460212,12784,'it','Clicca per visualizzare i controlli',0),(460213,12784,'tl','',0),(460214,12784,'th','à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(460215,12784,'hi','à¤œà¤¾à¤à¤š à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(460216,12784,'ms','Klik untuk melihat pemeriksaan',0),(460217,12784,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ø¹Ø±Ø¶ Ø§Ù„Ø´ÙŠÙƒØ§Øª',0),(460218,12784,'fr','Cliquez sur pour afficher les contrÃ´les',0),(460219,12784,'jp','ãƒã‚§ãƒƒã‚¯ã‚’è¡¨ç¤ºã™ã‚‹] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(460220,12784,'pt','Clique para ver os controlos',0),(460221,12784,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¾Ðº',0),(460222,12784,'es','Haga Clik para Visionar Cheques',0),(460223,12784,'de','Klicken zur Ansicht Ã¼berprÃ¼ft',0),(460224,12784,'en','Click to View Checks',0),(460225,12785,'is','',0),(460226,12785,'dr','Ù‚Ø§Ø¨Ù„ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù†ÛŒØ³Øª',0),(460227,12785,'pr','Ù‚Ø§Ø¨Ù„ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù†ÛŒØ³Øª',0),(460228,12785,'tr','PazarlÄ±k yok',0),(460229,12785,'pl','Nie podlegajÄ… negocjacjom',0),(460230,12785,'bg','ÐÐµ Ð¿Ð¾ Ð´Ð¾Ð³Ð¾Ð²Ð°Ñ€ÑÐ½Ðµ',0),(460231,12785,'ur','Ù†Û Ø¨Ø§Øª Ú†ÛŒØª Ú©Ø±',0),(460232,12785,'sr','Ð‘ÐµÐ· Ð¿Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð°',0),(460233,12785,'vi','khÃ´ng thÆ°Æ¡ng lÆ°á»£ng',0),(460234,12785,'af','Nie onderhandelbaar',0),(460235,12785,'ro','Nu negociabil',0),(460236,12785,'et','Ei ole kaubeldavad',0),(460237,12785,'si','Niso prenosljive',0),(460238,12785,'ba','Tidak Negotiable',0),(460239,12785,'nl','Niet verhandelbaar',0),(460240,12785,'fi','Ole neuvoteltavissa',0),(460241,12785,'no','Ikke forhandles',0),(460242,12785,'da','Ikke omsÃ¦ttelige',0),(460243,12785,'ko','ì•„ë‹ˆ í˜‘ìƒ',0),(460244,12785,'he','×œ× ×¤×ª×•×— ×œ×ž×©× ×•×ž×ª×Ÿ',0),(460245,12785,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Ï€ÏÎ±Î³Î¼Î±Ï„ÎµÏÏƒÎ¹Î¼Î·',0),(460246,12785,'zh','Not Negotiable',0),(460247,12785,'sv','Inte fÃ¶rhandlingsbart',0),(460248,12785,'it','Non trattabile',0),(460249,12785,'tl','',0),(460250,12785,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸•à¹ˆà¸­à¸£à¸­à¸‡',0),(460251,12785,'hi','à¤¨à¤¹à¥€à¤‚ à¤ªà¤°à¤•à¥à¤°à¤¾à¤®à¥à¤¯',0),(460252,12785,'ms','Tidak boleh dirunding',0),(460253,12785,'ar','ØºÙŠØ± Ù‚Ø§Ø¨Ù„Ø© Ù„Ù„ØªÙØ§ÙˆØ¶',0),(460254,12785,'fr','Non nÃ©gociable',0),(460255,12785,'jp','äº¤æ¸‰å¯èƒ½ã§ãªã„ã§ã™ã€‚',0),(460256,12785,'pt','NÃ£o Ã© negociÃ¡vel',0),(460257,12785,'ru','ÐÐµ Ð¿Ð¾Ð´Ð»ÐµÐ¶Ð°Ñ‚ Ð¾Ð±ÑÑƒÐ¶Ð´ÐµÐ½Ð¸ÑŽ',0),(460258,12785,'es','No Negociable',0),(460259,12785,'de','Nicht verhandelbar',0),(460260,12785,'en','Not Negotiable',0),(460261,12786,'is','',0),(460262,12786,'dr','Ø¯Ù‚ÛŒÙ‚Ù‡ Compositiion',0),(460263,12786,'pr','Ø¯Ù‚ÛŒÙ‚Ù‡ Compositiion',0),(460264,12786,'tr','Dakika Compositiion',0),(460265,12786,'pl','Minut Compositiion',0),(460266,12786,'bg','Compositiion Ð¼Ð¸Ð½ÑƒÑ‚Ð¸',0),(460267,12786,'ur','Ù…Ù†Ù¹ Ú©ÙˆÙ…Ù¾ÙˆØ³Ø§Ù¹Ø§Ø§Ø§ÙˆÙ†',0),(460268,12786,'sr','Ð¦Ð¾Ð¼Ð¿Ð¾ÑÐ¸Ñ‚Ð¸Ð¸Ð¾Ð½ Ð¼Ð¸Ð½ÑƒÑ‚Ð°',0),(460269,12786,'vi','Compositiion phÃºt',0),(460270,12786,'af','Minute Compositiion',0),(460271,12786,'ro','Minute Compositiion',0),(460272,12786,'et','Minutit Compositiion',0),(460273,12786,'si','Minut Compositiion',0),(460274,12786,'ba','Compositiion menit',0),(460275,12786,'nl','Minuten Compositiion',0),(460276,12786,'fi','Minuuttia Compositiion',0),(460277,12786,'no','Minutter Compositiion',0),(460278,12786,'da','Minutter Compositiion',0),(460279,12786,'ko','ë¶„ Compositiion',0),(460280,12786,'he','Compositiion ×“×§×•×ª',0),(460281,12786,'el','Compositiion Î»ÎµÏ€Ï„Î¬',0),(460282,12786,'zh','åˆ†é’Ÿ Compositiion',0),(460283,12786,'sv','Minuter Compositiion',0),(460284,12786,'it','Minuti Compositiion',0),(460285,12786,'tl','',0),(460286,12786,'th','Compositiion à¸™à¸²à¸—à¸µ',0),(460287,12786,'hi','à¤®à¤¿à¤¨à¤Ÿ Compositiion',0),(460288,12786,'ms','Compositiion minit',0),(460289,12786,'ar','ÙƒÙˆÙ…Ø¨ÙˆØ³ÙŠØªÙŠÙŠÙˆÙ† Ø¯Ù‚ÙŠÙ‚Ø©',0),(460290,12786,'fr','Compositiion minutes',0),(460291,12786,'jp','åˆ† Compositiion',0),(460292,12786,'pt','Compositiion minutos',0),(460293,12786,'ru','Compositiion Ð¼Ð¸Ð½ÑƒÑ‚',0),(460294,12786,'es','Minutos Compositiion',0),(460295,12786,'de','Minuten-Compositiion',0),(460296,12786,'en','Minutes Compositiion',0),(460297,12787,'is','',0),(460298,12787,'dr','Ø§ØµÙ„Ø§Ø­ Ù„ÛŒØ³Øª Ù‡Ø§ÛŒ Ù‚ÛŒÙ…Øª Ø¨ÙˆØ³ÛŒÙ„Ù‡ Ø¯Ø±ØµØ¯',0),(460299,12787,'pr','Ø§ØµÙ„Ø§Ø­ Ù„ÛŒØ³Øª Ù‡Ø§ÛŒ Ù‚ÛŒÙ…Øª Ø¨ÙˆØ³ÛŒÙ„Ù‡ Ø¯Ø±ØµØ¯',0),(460300,12787,'tr','Fiyat listesi yÃ¼zdesi ile deÄŸiÅŸtirme',0),(460301,12787,'pl','Modyfikowanie wykazÃ³w cen przez procent',0),(460302,12787,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ð»Ð¸ÑÑ‚Ð¸ Ñ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(460303,12787,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø¨Ù„Ø­Ø§Ø¸ ØªÙ†Ø§Ø³Ø¨ Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ… Ú©Ø±ÛŒÚº',0),(460304,12787,'sr','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐµ Ð¿Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñƒ',0),(460305,12787,'vi','chá»‰nh sá»­a danh sÃ¡ch giÃ¡ theo pháº§n trÄƒm',0),(460306,12787,'af','Modifiseer prys lyste deur persentasie',0),(460307,12787,'ro','Modifica listele de preÅ£uri procent',0),(460308,12787,'et','Muuda hinnakirjad protsendi vÃµrra',0),(460309,12787,'si','Spremeniti cenike odstotek',0),(460310,12787,'ba','Memodifikasi daftar harga persentase',0),(460311,12787,'nl','Prijslijsten met Percentage wijzigen',0),(460312,12787,'fi','Muokata hinnastoja prosenttiyksikkÃ¶Ã¤',0),(460313,12787,'no','Endre prislister prosentvis',0),(460314,12787,'da','Redigere prislister procent',0),(460315,12787,'ko','ë°±ë¶„ìœ¨ ê°€ê²© ëª©ë¡ ìˆ˜ì •',0),(460316,12787,'he','×œ×©× ×•×ª ×ž×—×™×¨×•× ×™× ×œ×¤×™ ××—×•×–×™×',0),(460317,12787,'el','Î¤ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï…Ï‚ Ï„Î¹Î¼ÏŽÎ½ ÎºÎ±Ï„Î¬ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(460318,12787,'zh','ä¿®æ”¹ä»·æ ¼åˆ—è¡¨æŒ‰ç™¾åˆ†æ¯”',0),(460319,12787,'sv','Ã„ndra prislistor med procentsats',0),(460320,12787,'it','Modificare i listini di percentuale',0),(460321,12787,'tl','',0),(460322,12787,'th','à¸›à¸£à¸±à¸šà¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸£à¸²à¸„à¸²à¸•à¸¥à¸²à¸”à¸•à¸²à¸¡à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œ',0),(460323,12787,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(460324,12787,'ms','Mengubahsuai senarai harga mengikut peratusan',0),(460325,12787,'ar','ØªØ¹Ø¯ÙŠÙ„ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¨Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ©',0),(460326,12787,'fr','Modifier les listes de prix en pourcentage',0),(460327,12787,'jp','å‰²åˆã§ä¾¡æ ¼è¡¨ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(460328,12787,'pt','Modificar listas de preÃ§o por porcentagem',0),(460329,12787,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚Ñ‹ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(460330,12787,'es','Modifica Listas de Precios por Porcentaje',0),(460331,12787,'de','Preislisten von Prozentsatz Ã¤ndern',0),(460332,12787,'en','Modify Price Lists by Percentage',0),(460333,12788,'is','',0),(460334,12788,'dr','(ÙˆØ±ÙˆØ¯ÛŒ)Ø§ÛŒÙ†Ø¬Ø§ Ø¨Ù‡ Ù…Ø¹Ù†Ø§ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø§ÛŒ Ù‡Ø± Ù†ÙˆØ¹ Ø§Ù†ØªØ®Ø§Ø¨ Ø¬ÙˆÙ‡Ø± Ø¨Ø±Ø§ÛŒ Ø·Ø±Ù 1 Ø§Ø³Øª  ',0),(460335,12788,'pr','Ù…Ù†ÙÛŒ ÛŒÚ© Ø«Ø¨Øª(ÙˆØ±ÙˆØ¯ÛŒ)Ø§ÛŒÙ†Ø¬Ø§ Ø¨Ù‡ Ù…Ø¹Ù†Ø§ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø§ÛŒ Ù‡Ø± Ù†ÙˆØ¹ Ø§Ù†ØªØ®Ø§Ø¨ Ø¬ÙˆÙ‡Ø± Ø¨Ø±Ø§ÛŒ Ø·Ø±Ù 1 Ø§Ø³Øª  ',0),(460336,12788,'tr','Buraya tek bir giriÅŸ mÃ¼rekkep seÃ§imleri iÃ§in bir yan anlamÄ± uygulamak',0),(460337,12788,'pl','Minus jeden wpis tutaj Å›rodki stosuje siÄ™ do zaznaczeÅ„ atramentu dla strony, jeden',0),(460338,12788,'bg','ÐœÐ¸Ð½ÑƒÑ ÐµÐ´Ð¸Ð½ Ð·Ð°Ð¿Ð¸Ñ Ñ‚ÑƒÐº ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° ÑÐµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°Ñ‚ ÐºÑŠÐ¼ Ð²ÑÐµÐºÐ¸ Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ ÑÐµÐ»ÐµÐºÑ†Ð¸Ð¸ Ð·Ð° ÑÑ‚Ñ€Ð°Ð½Ð° ÐµÐ´Ð½Ð°',0),(460339,12788,'ur','ÛŒÛØ§Úº Ø§ÛŒÚ© Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ù†ÙÛŒ Ø°Ø±Ø§Ø¦Ø¹ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§ÛŒÚ© Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ø§Ù†Ú© Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¯Û’',0),(460340,12788,'sr','ÐœÐ¸Ð½ÑƒÑ Ñ˜ÐµÐ´Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ð²Ð´Ðµ Ð·Ð½Ð°Ñ‡Ð¸ Ð¾Ð´Ð½Ð¾ÑÐ¸Ñ‚Ð¸ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾ Ð¸Ð·Ð±Ð¾Ñ€Ðµ ÐºÐ¾Ñ˜Ðµ Ñ˜Ðµ Ð·Ð° ÑÑ‚Ñ€Ð°Ð½Ñƒ Ñ˜ÐµÐ´Ð°Ð½',0),(460341,12788,'vi','thiáº¿u má»™t entry á»Ÿ Ä‘Ã¢y cÃ³ nghÄ©a lÃ  Ã¡p dá»¥ng Ä‘á»ƒ viáº¿t cho bÃªn thá»© nháº¥t',0),(460342,12788,'af','Minus een inskrywing hier beteken op enige ink seleksies vir kant een',0),(460343,12788,'ro','Minus o intrare aici Ã®nseamnÄƒ se aplicÄƒ orice selecÅ£ii de cernealÄƒ pentru partea de unul',0),(460344,12788,'et','Miinus Ã¼ks kanne siin vahendeid rakendada mis tahes vÃ¤rvi Valikud pool Ã¼ks',0),(460345,12788,'si','Minus eno postavko tukaj pomeni veljajo za vsako Ärnilo izbore za strani, ena',0),(460346,12788,'ba','Minus satu entri di sini berarti menerapkan pilihan tinta untuk sisi satu',0),(460347,12788,'nl','Minus Ã©Ã©n post hier toepassen middelen op elke inkt selecties voor kant een',0),(460348,12788,'fi','Miinus yksi merkintÃ¤ tarkoittaa koske muste valintoja puolella yksi',0),(460349,12788,'no','Minus Ã©n oppfÃ¸ring her gjelder betyr alle blekk valg for side 1',0),(460350,12788,'da','Minus Ã©n indgang her gÃ¦lder betyder for eventuelle blÃ¦k markeringer for side, en',0),(460351,12788,'ko','ì—¬ê¸°ì— í•˜ë‚˜ì˜ í•­ëª©ì„ ëº€ ì˜ë¯¸ í•œ ì¸¡ë©´ì— ëŒ€ í•œ ì–´ë–¤ ìž‰í¬ ì„ íƒì— ì ìš©',0),(460352,12788,'he','×¤×—×•×ª ×¢×¨×š ××—×“ ×›××Ÿ ××ž×¦×¢×™ ×œ×”×—×™×œ ×¢×œ ×›×œ ×”×‘×—×™×¨×•×ª ×“×™×• ×¢×‘×•×¨ ×¦×“ ××—×“',0),(460353,12788,'el','ÎœÎµÎ¯Î¿Î½ Î¼Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î® ÎµÎ´ÏŽ Î¼Î­ÏƒÎ± Î¹ÏƒÏ‡ÏÎ¿Ï…Î½ Î³Î¹Î± ÎºÎ¬Î¸Îµ Î¼ÎµÎ»Î¬Î½Î¹ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î³Î¹Î± Ï€Î»ÎµÏ…ÏÎ¬ Î­Î½Î±',0),(460354,12788,'zh','å‡åŽ»ä¸€ä¸ªæ¡ç›®åœ¨è¿™é‡Œæ„å‘³ç€é€‚ç”¨äºŽä»»ä½•å¢¨è¿¹é€‰æ‹©çš„ä¸€é¢',0),(460355,12788,'sv','Minus en post hÃ¤r gÃ¤lla betyder blÃ¤ck markeringar fÃ¶r sidan',0),(460356,12788,'it','Meno una voce qui significa applica a tutte le selezioni di inchiostro per lato uno',0),(460357,12788,'tl','',0),(460358,12788,'th','à¸¥à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸«à¸™à¸¶à¹ˆà¸‡à¸—à¸µà¹ˆà¸™à¸µà¹ˆ à¸«à¸¡à¸²à¸¢à¸–à¸¶à¸‡à¹ƒà¸Šà¹‰à¸à¸²à¸£à¹€à¸¥à¸·à¸­à¸à¸«à¸¡à¸¶à¸à¹ƒà¸” à¹† à¹ƒà¸™à¸”à¹‰à¸²à¸™à¸«à¸™à¸¶à¹ˆà¸‡',0),(460359,12788,'hi','à¤à¤• à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¶à¥‚à¤¨à¥à¤¯ à¤¸à¥‡ à¤¯à¤¹à¤¾à¤ à¤®à¤¤à¤²à¤¬ à¤¹à¥ˆ à¤à¤• à¤ªà¤•à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤‡à¤‚à¤• à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¥‚',0),(460360,12788,'ms','Tolak satu entri di sini cara memohon kepada mana-mana pilihan dakwat bagi bahagian satu',0),(460361,12788,'ar','Ù†Ø§Ù‚Øµ ÙˆØ§Ø­Ø¯ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ù‡Ù†Ø§ ØªØ·Ø¨ÙŠÙ‚ ÙˆØ³Ø§Ø¦Ù„ Ù„Ø£ÙŠØ© ØªØ­Ø¯ÙŠØ¯Ø§Øª Ø§Ù„Ø­Ø¨Ø± Ù„Ø¬Ø§Ù†Ø¨ ÙˆØ§Ø­Ø¯',0),(460362,12788,'fr','Moins une entrÃ©e ici moyens s\'appliquent Ã  toutes les sÃ©lections d\'encre pour cÃ´tÃ© un',0),(460363,12788,'jp','1 ã¤ã®ã‚¨ãƒ³ãƒˆãƒªã‚’ã“ã“ã§ãƒžã‚¤ãƒŠã‚¹æ‰‹æ®µé¸æŠžã‚’é©ç”¨ã™ã‚‹ä»»æ„ã®ã‚¤ãƒ³ã‚¯ã®ã„ãšã‚Œã‹ã®å´',0),(460364,12788,'pt','Menos uma entrada aqui, significa que se aplicam para todas as seleÃ§Ãµes de tinta para o lado um',0),(460365,12788,'ru','ÐœÐ¸Ð½ÑƒÑ Ð¾Ð´Ð¸Ð½ Ð²Ñ…Ð¾Ð´ Ð·Ð´ÐµÑÑŒ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÑÑŽÑ‚ÑÑ Ðº Ð»ÑŽÐ±Ð¾Ð¹ Ð²Ñ‹Ð±Ð¾Ñ€ Ñ‡ÐµÑ€Ð½Ð¸Ð» Ð´Ð»Ñ Ð¾Ð´Ð½Ð° ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð°',0),(460366,12788,'es','Menos de Una Entrada Aqui significa aplicar cualquieras selcciones de Tintas para lado uno',0),(460367,12788,'de','Minus einen Eintrag hier gelten Mittel fÃ¼r alle Freihand-Auswahl fÃ¼r Seite eins',0),(460368,12788,'en','Minus one entry here means apply to any ink selections for side one',0),(460369,12789,'is','',0),(460370,12789,'dr','(ÙˆØ±ÙˆØ¯ÛŒ)Ø§ÛŒÙ†Ø¬Ø§ Ø¨Ù‡ Ù…Ø¹Ù†Ø§ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø§ÛŒ Ù‡Ø± Ù†ÙˆØ¹ Ø§Ù†ØªØ®Ø§Ø¨ Ø¬ÙˆÙ‡Ø±Ø¨Ø±Ø§ÛŒ Ø·Ø±Ù 2 Ø§Ø³Øª 2',0),(460371,12789,'pr','Ù…Ù†ÙÛŒ ÛŒÚ© Ø«Ø¨Øª(ÙˆØ±ÙˆØ¯ÛŒ)Ø§ÛŒÙ†Ø¬Ø§ Ø¨Ù‡ Ù…Ø¹Ù†Ø§ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø§ÛŒ Ù‡Ø± Ù†ÙˆØ¹ Ø§Ù†ØªØ®Ø§Ø¨ Ø¬ÙˆÙ‡Ø±Ø¨Ø±Ø§ÛŒ Ø·Ø±Ù 2 Ø§Ø³Øª 2',0),(460372,12789,'tr','Buraya tek bir giriÅŸ anlamÄ±na gelir herhangi bir mÃ¼rekkep seÃ§imleri iki taraf iÃ§in geÃ§erli',0),(460373,12789,'pl','Minus jeden wpis tutaj Å›rodki stosuje siÄ™ do zaznaczeÅ„ atramentu na stronie dwa',0),(460374,12789,'bg','ÐœÐ¸Ð½ÑƒÑ ÐµÐ´Ð¸Ð½ Ð·Ð°Ð¿Ð¸Ñ Ñ‚ÑƒÐº ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° ÑÐµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°Ñ‚ ÐºÑŠÐ¼ Ð²ÑÐµÐºÐ¸ Ñ€ÑŠÐºÐ¾Ð¿Ð¸Ñ ÑÐµÐ»ÐµÐºÑ†Ð¸Ð¸ Ð·Ð° ÑÑ‚Ñ€Ð°Ð½Ð° Ð´Ð²Ðµ',0),(460375,12789,'ur','ÛŒÛØ§Úº Ø§ÛŒÚ© Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ù†ÙÛŒ ÛŒØ¹Ù†ÛŒ Ø¯Ùˆ ÙØ±ÛŒÙ‚ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ø§Ù†Ú© Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¯Û’',0),(460376,12789,'sr','ÐœÐ¸Ð½ÑƒÑ Ñ˜ÐµÐ´Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ð²Ð´Ðµ Ð·Ð½Ð°Ñ‡Ð¸ Ð¾Ð´Ð½Ð¾ÑÐ¸Ñ‚Ð¸ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾ Ð¸Ð·Ð±Ð¾Ñ€Ðµ ÐºÐ¾Ñ˜Ðµ Ñ˜Ðµ Ð·Ð° ÑÑ‚Ñ€Ð°Ð½Ð° 2',0),(460377,12789,'vi','thiáº¿u má»™t entry á»Ÿ Ä‘Ã¢y cÃ³ nghÄ©a lÃ  Ã¡p dá»¥ng Ä‘á»ƒ viáº¿t cho bÃªn thá»© hai',0),(460378,12789,'af','Minus een inskrywing hier beteken op enige ink seleksies vir kant twee',0),(460379,12789,'ro','Minus o intrare aici Ã®nseamnÄƒ se aplicÄƒ orice selecÅ£ii de cernealÄƒ pentru partea 2',0),(460380,12789,'et','Miinus Ã¼ks kanne siin tÃ¤hendab rakenduvad tint valikute side kaks',0),(460381,12789,'si','Minus eno postavko tukaj pomeni veljajo za vsako Ärnilo izbore za dvema',0),(460382,12789,'ba','Minus satu entri di sini berarti menerapkan pilihan tinta untuk sisi dua',0),(460383,12789,'nl','Minus Ã©Ã©n post hier toepassen middelen op elke inkt selecties voor kant twee',0),(460384,12789,'fi','Miinus yksi merkintÃ¤ tarkoittaa koske muste valintoja ja toinen puoli',0),(460385,12789,'no','Minus Ã©n oppfÃ¸ring her gjelder betyr alle blekk valg siden to',0),(460386,12789,'da','Minus Ã©n indgang her gÃ¦lder betyder for eventuelle blÃ¦k markeringer til side to',0),(460387,12789,'ko','ì—¬ê¸°ì— í•˜ë‚˜ì˜ í•­ëª©ì„ ëº€ ë°©ë²• ì¸¡ë©´ 2ì— ëŒ€ í•œ ì–´ë–¤ ìž‰í¬ ì„ íƒì— ì ìš©',0),(460388,12789,'he','×¤×—×•×ª ×¢×¨×š ××—×“ ×›××Ÿ ××ž×¦×¢×™ ×œ×”×—×™×œ ×¢×œ ×›×œ ×”×‘×—×™×¨×•×ª ×“×™×• ×¢×‘×•×¨ ×¦×“ ×©× ×™',0),(460389,12789,'el','ÎœÎµÎ¯Î¿Î½ Î¼Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î® ÎµÎ´ÏŽ Î¼Î­ÏƒÎ± Î¹ÏƒÏ‡ÏÎ¿Ï…Î½ Î³Î¹Î± ÎºÎ¬Î¸Îµ Î¼ÎµÎ»Î¬Î½Î¹ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î³Î¹Î± Î´ÏÎ¿ Ï€Î»ÎµÏ…ÏÎ¬',0),(460390,12789,'zh','å‡åŽ»ä¸€ä¸ªæ¡ç›®åœ¨è¿™é‡Œæ„å‘³ç€é€‚ç”¨äºŽä»»ä½•å¢¨è¿¹é€‰æ‹©çš„ä¸¤è¾¹',0),(460391,12789,'sv','Minus en post hÃ¤r gÃ¤lla betyder blÃ¤ck markeringar fÃ¶r sidan tvÃ¥',0),(460392,12789,'it','Meno una voce qui significa applica a tutte le selezioni di inchiostro per lato due',0),(460393,12789,'tl','',0),(460394,12789,'th','à¸¥à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸«à¸™à¸¶à¹ˆà¸‡à¸—à¸µà¹ˆà¸™à¸µà¹ˆ à¸«à¸¡à¸²à¸¢à¸–à¸¶à¸‡à¹ƒà¸Šà¹‰à¸à¸²à¸£à¹€à¸¥à¸·à¸­à¸à¸«à¸¡à¸¶à¸à¹ƒà¸” à¹† à¸ªà¸³à¸«à¸£à¸±à¸šà¸”à¹‰à¸²à¸™à¸‚à¹‰à¸²à¸‡à¸—à¸±à¹‰à¸‡à¸ªà¸­à¸‡',0),(460395,12789,'hi','à¤¯à¤¹à¤¾à¤ à¤à¤• à¤¹à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¶à¥‚à¤¨à¥à¤¯ à¤¸à¥‡ à¤¦à¥‹ à¤ªà¤•à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤‡à¤‚à¤• à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤§à¤¨ à¤²à¤¾à¤—à¥‚',0),(460396,12789,'ms','Tolak satu entri di sini cara memohon kepada mana-mana pilihan dakwat bagi bahagian dua',0),(460397,12789,'ar','Ù†Ø§Ù‚Øµ ÙˆØ§Ø­Ø¯ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ù‡Ù†Ø§ ØªØ·Ø¨ÙŠÙ‚ ÙˆØ³Ø§Ø¦Ù„ Ù„Ø£ÙŠØ© ØªØ­Ø¯ÙŠØ¯Ø§Øª Ø§Ù„Ø­Ø¨Ø± Ù„Ù„Ø¬Ø§Ù†Ø¨ Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(460398,12789,'fr','Moins une entrÃ©e ici moyens s\'appliquent Ã  toutes les sÃ©lections d\'encre pour face 2',0),(460399,12789,'jp','1 ã¤ã®ã‚¨ãƒ³ãƒˆãƒªã‚’ã“ã“ã§ãƒžã‚¤ãƒŠã‚¹æ‰‹æ®µé¸æŠžã‚’é©ç”¨ã™ã‚‹ä»»æ„ã®ã‚¤ãƒ³ã‚¯å´ 2',0),(460400,12789,'pt','Menos uma entrada aqui significa que se aplicam a todas as seleÃ§Ãµes de tinta para o lado dois',0),(460401,12789,'ru','ÐœÐ¸Ð½ÑƒÑ Ð¾Ð´Ð¸Ð½ Ð²Ñ…Ð¾Ð´ Ð·Ð´ÐµÑÑŒ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÑÑŽÑ‚ÑÑ Ðº Ð»ÑŽÐ±Ð¾Ð¹ Ð²Ñ‹Ð±Ð¾Ñ€ Ñ‡ÐµÑ€Ð½Ð¸Ð» Ð´Ð»Ñ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð° 2',0),(460402,12789,'es','Menos de Una Entrada Aqui significa aplicar cualquieras selcciones de Tintas para lado dos',0),(460403,12789,'de','Minus einen Eintrag hier gelten Mittel fÃ¼r alle Freihand-Auswahl fÃ¼r die Seite zwei',0),(460404,12789,'en','Minus one entry here means apply to any ink selections for side two',0),(460405,12790,'is','',0),(460406,12790,'dr','Ø¶Ø±Ø¨ ØªÙ…Ø§Ù… Ù‚ÛŒÙ…ØªÙ‡Ø§ Ø¨Ø§ Ø§ÛŒÙ† Ù…Ù‚Ø¯Ø§Ø±',0),(460407,12790,'pr','Ø¶Ø±Ø¨ ØªÙ…Ø§Ù… Ù‚ÛŒÙ…ØªÙ‡Ø§ Ø¨Ø§ Ø§ÛŒÙ† Ù…Ù‚Ø¯Ø§Ø±',0),(460408,12790,'tr','TÃ¼m fiyatlar bu miktar tarafÄ±ndan Ã§arpÄ±n',0),(460409,12790,'pl','NaleÅ¼y pomnoÅ¼yÄ‡ wszystkie ceny o tÄ™ kwotÄ™',0),(460410,12790,'bg','Ð£Ð¼Ð½Ð¾Ð¶Ð°Ð²Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ†ÐµÐ½Ð¸ Ñ Ñ‚Ð°Ð·Ð¸ ÑÑƒÐ¼Ð°',0),(460411,12790,'ur','ØªÙ…Ø§Ù… Ù‚ÛŒÙ…ØªÙˆÚº Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ÛŒÛ Ø±Ù‚Ù… Ø¶Ø±Ø¨',0),(460412,12790,'sr','ÐŸÐ¾Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚Ðµ ÑÐ²Ðµ Ñ†ÐµÐ½Ðµ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð¸Ð·Ð½Ð¾Ñ',0),(460413,12790,'vi','táº¥t cáº£ cÃ¡c má»©c giÃ¡ bá»Ÿi sá»‘ nÃ y',0),(460414,12790,'af','Vermenigvuldig Alle Pryse deur Hierdie Bedrag',0),(460415,12790,'ro','Multiplica preturile suma',0),(460416,12790,'et','Korrutab kÃµik hinnad selle summaga',0),(460417,12790,'si','Vse cene ta znesek pomnoÅ¾imo',0),(460418,12790,'ba','Kalikan seluruh harga oleh jumlah ini',0),(460419,12790,'nl','Alle prijzen door dit bedrag vermenigvuldigen',0),(460420,12790,'fi','Kerro kaikki hinnat tÃ¤llÃ¤ mÃ¤Ã¤rÃ¤llÃ¤',0),(460421,12790,'no','Multipliser alle priser prosentsats',0),(460422,12790,'da','Multiplicer alle priser af dette belÃ¸b',0),(460423,12790,'ko','ì´ ê¸ˆì•¡ì„ ê¸°ì¤€ìœ¼ë¡œ ëª¨ë“  ê°€ê²©ì„ ê³±í•˜ë©´',0),(460424,12790,'he','×œ×”×›×¤×™×œ ××ª ×›×œ ×”×ž×—×™×¨×™× ×‘×ž×™×“×” ×–×•',0),(460425,12790,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î¬ÏƒÎµÎ¹ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Ï„Î¹Î¼Î­Ï‚ Î±Ï€ÏŒ Ï„Î¿ Ï€Î¿ÏƒÏŒ Î±Ï…Ï„ÏŒ',0),(460426,12790,'zh','ç¹æ®–è¿™ä¸€æ•°é¢çš„æ‰€æœ‰ä»·æ ¼',0),(460427,12790,'sv','Multiplicera alla priser med detta belopp',0),(460428,12790,'it','Tutti i prezzi di questo importo si moltiplicano',0),(460429,12790,'tl','',0),(460430,12790,'th','à¸„à¸¹à¸“à¸£à¸²à¸„à¸²à¸•à¸²à¸¡à¸ˆà¸³à¸™à¸§à¸™à¸™à¸µà¹‰',0),(460431,12790,'hi','à¤¸à¤­à¥€ à¤•à¥€à¤®à¤¤à¥‡à¤‚ à¤‡à¤¸ à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡ à¤—à¥à¤£à¤¾ à¤•à¤°à¥‡à¤‚',0),(460432,12790,'ms','Membiak semua harga oleh jumlah ini',0),(460433,12790,'ar','Ù‚Ù… Ø¨Ø¶Ø±Ø¨ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¨Ù‡Ø°Ø§ Ø§Ù„Ù…Ø¨Ù„Øº',0),(460434,12790,'fr','Multiplier tous les prix de ce montant',0),(460435,12790,'jp','ã“ã®é‡‘é¡ã§ã™ã¹ã¦ã®ä¾¡æ ¼ã‚’ä¹—ç®—ã—ã¾ã™ã€‚',0),(460436,12790,'pt','Multiplicar todos os preÃ§os por este montante',0),(460437,12790,'ru','Ð’ÑÐµ Ñ†ÐµÐ½Ñ‹ Ð½Ð° ÑÑ‚Ñƒ ÑÑƒÐ¼Ð¼Ñƒ ÑƒÐ¼Ð½Ð¾Ð¶Ð¸Ñ‚ÑŒ',0),(460438,12790,'es','Multiplica Todos los Precios por Este Cantidad',0),(460439,12790,'de','Alle Preise um diesen Betrag multiplizieren',0),(460440,12790,'en','Multiply All Prices by This Amount',0),(460441,12791,'is','',0),(460442,12791,'dr','1Ø¨Ø§ Ø§ÛŒÙ† Ø´Ù…Ø§Ø±Ù‡ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø§Ø³Øª',0),(460443,12791,'pr','ÙÙ‚Ø· Ø¶Ø±Ø¨ Ú©Ù†ÛŒØ¯ Ø§Ú¯Ø±Ø­Ø¯Ø§Ú©Ø«Ø± Ø·Ø±Ù Ø¬ÙˆÙ‡Ø±  1Ø¨Ø§ Ø§ÛŒÙ† Ø´Ù…Ø§Ø±Ù‡ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø§Ø³Øª',0),(460444,12791,'tr','Sadece Ã§arpma EÄŸer Max mÃ¼rekkepleri yan bir maÃ§ bu sayÄ±',0),(460445,12791,'pl','Tylko pomnoÅ¼yÄ‡ jeÅ›li Max farb po stronie jeden mecze ten numer',0),(460446,12791,'bg','Ð¡Ð°Ð¼Ð¾ Ð´Ð° ÑÐµ Ñ€Ð°Ð·Ð¼Ð½Ð¾Ð¶Ð°Ð²Ð°Ñ‚, Ð°ÐºÐ¾ ÐœÐ°ÐºÑ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° ÑÑ‚Ñ€Ð°Ð½Ð° ÐµÐ´Ð¸Ð½ Ð¼Ð°Ñ‡Ð¾Ð²Ðµ Ñ‚Ð¾Ð·Ð¸ Ð½Ð¾Ð¼ÐµÑ€',0),(460447,12791,'ur','Ø§Ú¯Ø± ØµØ±Ù Ø¶Ø±Ø¨ Ù…ÛŒÚ©Ø³ Ø§Ù†Ú©Ø³ Ú©ÛŒ Ø·Ø±Ù Ø§ÛŒÚ© Ù…ÛŒÚ† Ø§Ø³ Ù†Ù…Ø¨Ø±',0),(460448,12791,'sr','Ð¡Ð°Ð¼Ð¾ Ð¼Ð½Ð¾Ð¶ÐµÑšÐµ Ð°ÐºÐ¾ ÐœÐ°ÐºÑ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸ Ñ˜ÐµÐ´Ð½Ð¾Ð³ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð¾Ð²Ð°Ñ˜ Ð±Ñ€Ð¾Ñ˜',0),(460449,12791,'vi','Chá»‰ nhÃ¢n náº¿u Inks tá»‘i Ä‘a máº·t 1 khá»›p vá»›i sá»‘ nÃ y',0),(460450,12791,'af','Vermenigvuldig net as Max ink kant een pas hierdie nommer',0),(460451,12791,'ro','Multiplica numai dacÄƒ partea Max cerneluri meciuri un acest numÄƒr',0),(460452,12791,'et','Kui korrutada Max tindid pool Ã¼ks sobib see Number',0),(460453,12791,'si','Samo mnoÅ¾ijo, Äe Max Ärnila strani ene tekme ta Å¡tevilka',0),(460454,12791,'ba','Hanya kalikan jika Max tinta sisi satu pertandingan ini nomor',0),(460455,12791,'nl','Alleen vermenigvuldigen als Max inkten kant Ã©Ã©n wedstrijden dit nummer',0),(460456,12791,'fi','Moninkertaistaa jos Max musteet puolella yksi ottelut tÃ¤mÃ¤ numero',0),(460457,12791,'no','Bare multiplisere hvis Max blekkfarger Side ett kamper denne tall',0),(460458,12791,'da','Kun formere sig hvis Max trykfarver Side Ã©t kampe dette nummer',0),(460459,12791,'ko','ê²½ìš°ë§Œ ê³±í•˜ë©´ ìµœëŒ€ ìž‰í¬ ìª½ í•œ ì„ ìˆ˜ê°€ ìˆ˜',0),(460460,12791,'he','×œ×”×›×¤×™×œ ×¨×§ ×× ×ž×§×¡ ×“×™×• ×¦×“ ×’×¤×¨×•×¨×™× ×–×” ×ž×¡×¤×¨ ××—×“',0),(460461,12791,'el','ÎœÏŒÎ½Î¿ Î½Î± Ï€Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î¿ÏÎ½ ÎµÎ¬Î½ Max Î¼ÎµÎ»Î¬Î½Î¹Î± Ï€Î»ÎµÏ…ÏÎ¬ Î­Î½Î± Î±Î³ÏŽÎ½ÎµÏ‚ Î±Ï…Ï„ÏŒ Î±ÏÎ¹Î¸Î¼ÏŒ',0),(460462,12791,'zh','åªæœ‰ç¹æ®–å¦‚æžœæœ€å¤§æ²¹å¢¨ä¾§ä¸€ä¸ªåŒ¹é…è¿™ä¸ªå·ç ',0),(460463,12791,'sv','Bara multiplicera om Max blÃ¤ck sida ett matcher detta nummer',0),(460464,12791,'it','Moltiplicare solo se Max inchiostri lato uno partite questo numero',0),(460465,12791,'tl','',0),(460466,12791,'th','à¸„à¸¹à¸“à¸–à¹‰à¸²à¹€à¸‰à¸žà¸²à¸° à¸ˆà¸³à¸™à¸§à¸™à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¸«à¸¡à¸¶à¸à¸”à¹‰à¸²à¸™à¸«à¸™à¸¶à¹ˆà¸‡à¸•à¸£à¸‡à¸™à¸µà¹‰',0),(460467,12791,'hi','à¤•à¥‡à¤µà¤² à¤¯à¤¦à¤¿ à¤—à¥à¤£à¤¾ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¥€ à¤“à¤° à¤à¤• à¤®à¥ˆà¤š à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(460468,12791,'ms','Hanya membiak jika Max dakwat sampingan satu perlawanan ini nombor',0),(460469,12791,'ar','Ù…Ø¶Ø§Ø¹ÙØ© Ø¥Ù„Ø§ Ø¥Ø°Ø§ ÙƒØ§Ù† \"Ù…Ø§ÙƒØ³ Ø§Ù„Ø£Ø­Ø¨Ø§Ø± Ø§Ù„Ø¬Ø§Ù†Ø¨ Ù…Ø¨Ø§Ø±ÙŠØ§Øª Ù‡Ø°Ø§ Ø±Ù‚Ù… ÙˆØ§Ø­Ø¯\"',0),(460470,12791,'fr','Multiplier seulement si Max encres cÃ´tÃ© un Matches ce numero',0),(460471,12791,'jp','å ´åˆã«ã®ã¿ä¹—ç®—æœ€å¤§ã‚¤ãƒ³ã‚­å´ 1 ã¤ã¨ä¸€è‡´ã™ã‚‹ã“ã®æ•°',0),(460472,12791,'pt','SÃ³ se multiplicam se Max tintas lado partidas este um nÃºmero',0),(460473,12791,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÑƒÐ¼Ð½Ð¾Ð¶Ð¸Ñ‚ÑŒ ÐµÑÐ»Ð¸ ÐœÐ°ÐºÑ ÐºÑ€Ð°ÑÐºÐ¸ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ðµ Ð¾Ð´Ð¸Ð½ Ð¼Ð°Ñ‚Ñ‡ÐµÐ¹ ÑÑ‚Ð¾Ñ‚ Ð½Ð¾Ð¼ÐµÑ€',0),(460474,12791,'es','Solo Multiplica si el Maximo de Tintas de Lado Uno se Empareja Este NÃºmero',0),(460475,12791,'de','Nur multiplizieren, wenn Max Tinten Seite eine Ãœbereinstimmungen dieser Zahl',0),(460476,12791,'en','Only Multiply if Max Inks Side One Matches This Number',0),(460477,12792,'is','',0),(460478,12792,'dr','2 Ø¨Ø§ Ø§ÛŒÙ† Ø´Ù…Ø§Ø±Ù‡ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø§Ø³Øª',0),(460479,12792,'pr','ÙÙ‚Ø· Ø¶Ø±Ø¨ Ú©Ù†ÛŒØ¯ Ø§Ú¯Ø±Ø­Ø¯Ø§Ú©Ø«Ø± Ø·Ø±Ù Ø¬ÙˆÙ‡Ø± 2 Ø¨Ø§ Ø§ÛŒÙ† Ø´Ù…Ø§Ø±Ù‡ Ù‡Ù…Ø§Ù‡Ù†Ú¯ Ø§Ø³Øª',0),(460480,12792,'tr','Sadece Ã§arpma Max mÃ¼rekkepleri iki yan bu sayÄ± eÅŸleÅŸir',0),(460481,12792,'pl','Tylko pomnoÅ¼yÄ‡ jeÅ›li Max farb stronie dwa mecze ten numer',0),(460482,12792,'bg','Ð¡Ð°Ð¼Ð¾ Ñ€Ð°Ð·Ð¼Ð½Ð¾Ð¶Ð°Ð²Ð°Ñ‚ Ð°ÐºÐ¾ ÐœÐ°ÐºÑ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° ÑÑ‚Ñ€Ð°Ð½Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð° Ñ Ñ‚Ð¾Ð·Ð¸ Ð½Ð¾Ð¼ÐµÑ€',0),(460483,12792,'ur','Ø§Ú¯Ø± Ø¯Ùˆ Ù…ÛŒÚ©Ø³ Ø§Ù†Ú©Ø³ Ú©ÛŒ Ø·Ø±Ù Ø¯Ø§Ø±ÛŒ ØµØ±Ù Ø¨Ú‘Ú¾Ø§Ø¦Û’ Ø§Ø³ ØªØ¹Ø¯Ø§Ø¯ Ø³Û’ Ù…Ù„ØªØ§ ÛÛ’',0),(460484,12792,'sr','Ð¡Ð°Ð¼Ð¾ Ð¼Ð½Ð¾Ð¶ÐµÑšÐµ Ð»Ð¸ ÐœÐ°x Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° ÑÑ‚Ñ€Ð°Ð½Ð° Ð´Ð²Ð° Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð° Ð¾Ð²Ð°Ñ˜ Ð±Ñ€Ð¾Ñ˜',0),(460485,12792,'vi','Chá»‰ nhÃ¢n náº¿u Inks tá»‘i Ä‘a máº·t 1 khá»›p vá»›i sá»‘ nÃ y',0),(460486,12792,'af','Slegs vermenigvuldig as Max ink kant twee pas by hierdie nommer',0),(460487,12792,'ro','Numai multiplica dacÄƒ Max Cerneluri partea douÄƒ meciuri acest numÄƒr',0),(460488,12792,'et','Ainult Korruta kas Max tindid pool kaks kattub see Number',0),(460489,12792,'si','Samo mnoÅ¾ijo Äe Max Ärnila strani dve tekme to Å¡tevilo',0),(460490,12792,'ba','Hanya kalikan jika Max tinta sisi dua pertandingan ini nomor',0),(460491,12792,'nl','Alleen wedstrijden vermenigvuldigen als Max-inkten kant twee dit nummer',0),(460492,12792,'fi','Vain kertoa Max musteet puoli vastaako tÃ¤mÃ¤ numero',0),(460493,12792,'no','Multipliser hvis Max blekkfarger Side to treff dette nummeret',0),(460494,12792,'da','Kun svarer formere hvis Max trykfarver Side to dette tal',0),(460495,12792,'ko','ë§Œ ê³±í•˜ê¸° ë§¥ìŠ¤ ìž‰í¬ ì¸¡ë©´ 2 ì¼ì¹˜ì´ ìˆ˜',0),(460496,12792,'he','×¨×§ ×œ×”×›×¤×™×œ ×× ×ž×§×¡ ×“×™×• ×¦×“ ×©× ×™ ×ª×•×× ××ª ×”×ž×¡×¤×¨ ×”×–×”',0),(460497,12792,'el','ÎœÏŒÎ½Î¿ Ï€Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î¬ÏƒÏ„Îµ Î±Î½ Max Î¼ÎµÎ»Î¬Î½Î¹Î± Ï€Î»ÎµÏ…ÏÎ¬ Î´ÏÎ¿ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î±Ï…Ï„ÏŒÏ‚ Î¿ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(460498,12792,'zh','åªä¹˜å¦‚æžœæœ€å¤§æ²¹å¢¨è¾¹ä¸¤ä¸ªåŒ¹é…æ­¤å·ç ',0),(460499,12792,'sv','Bara matchar multiplicera om Max blÃ¤ck sida tvÃ¥ detta nummer',0),(460500,12792,'it','Solo moltiplicare se Max inchiostri lato due corrisponde a questo numero',0),(460501,12792,'tl','',0),(460502,12792,'th','à¹€à¸‰à¸žà¸²à¸° à¸„à¸¹à¸“à¸–à¹‰à¸²à¸«à¸¡à¸¶à¸à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¸‚à¹‰à¸²à¸‡ 2 à¸•à¸£à¸‡à¸à¸±à¸šà¹€à¸¥à¸‚à¸™à¸µà¹‰',0),(460503,12792,'hi','à¤¯à¤¦à¤¿ à¤¦à¥‹ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¥€ à¤“à¤° à¤•à¥‡à¤µà¤² à¤—à¥à¤£à¤¾ à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¤à¤¾ à¤¹à¥ˆ',0),(460504,12792,'ms','Hanya darabkan jika dakwat Max tepi dua perlawanan ini nombor',0),(460505,12792,'ar','ÙÙ‚Ø· Ø¶Ø±Ø¨ ÙŠØ·Ø§Ø¨Ù‚ Ø­Ø§Ù„ Ø§Ù„Ø£Ø­Ø¨Ø§Ø± Ù…Ø§ÙƒØ³ Ø§Ù„Ø¬Ø§Ù†Ø¨ Ø§Ø«Ù†ÙŠÙ† Ù‡Ø°Ø§ Ø§Ù„Ø¹Ø¯Ø¯',0),(460506,12792,'fr','Seulement multiplier si Max encres cÃ´tÃ© deux correspond Ã  ce numÃ©ro',0),(460507,12792,'jp','ã®ã¿ä¹—ç®—æœ€å¤§ã‚¤ãƒ³ã‚­ ã‚µã‚¤ãƒ‰ 2 å ´åˆç•ªå·ã¨ä¸€è‡´ã™ã‚‹ã“ã®',0),(460508,12792,'pt','SÃ³ multiplicar se Max tintas lado dois coincide com este nÃºmero',0),(460509,12792,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÑƒÐ¼Ð½Ð¾Ð¶Ð¸Ñ‚ÑŒ ÐµÑÐ»Ð¸ ÐœÐ°ÐºÑ ÐºÑ€Ð°ÑÐºÐ¸ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ðµ Ð´Ð²Ð° ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÑÑ‚Ð¾Ñ‚ Ð½Ð¾Ð¼ÐµÑ€',0),(460510,12792,'es','Solo Multiplica si el Maximo de Tintas de Lado Dos se Empareja Este NÃºmero',0),(460511,12792,'de','Nur wenn Max-Tinten zwei seitliche entspricht multiplizieren diese Nummer',0),(460512,12792,'en','Only Multiply if Max Inks Side Two Matches This Number',0),(460513,12793,'is','',0),(460514,12793,'dr','(Ú¯Ø¯Ø§Ù…) Ø¨Ø±ÙˆØ² Ø´Ø¯Ù‡ ØªÙˆØ³Ø· ÙÛŒØµØ¯',0),(460515,12793,'pr','Ø³Ù‡Ø§Ù… (Ø§Ù†Ø¨Ø§Ø±) Ø¨Ø±ÙˆØ² Ø´Ø¯Ù‡ ØªÙˆØ³Ø· Ø¯Ø±ØµØ¯',0),(460516,12793,'tr','Stok gÃ¼ncelleÅŸtirme yÃ¼zdesi ile',0),(460517,12793,'pl','Czas aktualizacji przez procent',0),(460518,12793,'bg','Ð¡ÐºÐ»Ð°Ð´ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(460519,12793,'ur','Ø´Ø±Ø­ ÙÛŒ ØµØ¯ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø³Ù¹Ø§Ú© Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(460520,12793,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ð£Ð¿Ð´Ð°Ñ‚Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚',0),(460521,12793,'vi','Cáº­p nháº­t hÃ ng tá»“n kho báº±ng pháº§n trÄƒm',0),(460522,12793,'af','Voorraad bywerking deur persentasie',0),(460523,12793,'ro','Actualizare valori de procent',0),(460524,12793,'et','Varude uuendamine protsendimÃ¤Ã¤ra vÃµrra',0),(460525,12793,'si','Zalog posodobitev odstotek',0),(460526,12793,'ba','Informasi saham persentase',0),(460527,12793,'nl','Voorraad Update door Percentage',0),(460528,12793,'fi','Varaston pÃ¤ivitys prosenttiyksikkÃ¶Ã¤',0),(460529,12793,'no','Lager oppdateringen prosentvis',0),(460530,12793,'da','Aktieopdatering procent',0),(460531,12793,'ko','ë¹„ìœ¨ë¡œ ì£¼ì‹ ì—…ë°ì´íŠ¸',0),(460532,12793,'he','×¢×“×›×•×Ÿ ×ž×œ××™ ×œ×¤×™ ××—×•×–×™×',0),(460533,12793,'el','Î— ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ· Î¼ÎµÏ„Î¿Ï‡ÏŽÎ½ ÎºÎ±Ï„Î¬ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(460534,12793,'zh','æŒ‰ç™¾åˆ†æ¯”çš„åº“å­˜æ›´æ–°',0),(460535,12793,'sv','Lager uppdatering av andel',0),(460536,12793,'it','Aggiornamento magazzino di percentuale',0),(460537,12793,'tl','',0),(460538,12793,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸•à¸²à¸¡à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œ',0),(460539,12793,'hi','à¤¶à¥‡à¤¯à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥‡ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(460540,12793,'ms','Kemaskini stok oleh peratusan',0),(460541,12793,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¨Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ©',0),(460542,12793,'fr','Mise Ã  jour stock par pourcentage',0),(460543,12793,'jp','å‰²åˆã§æ ªä¾¡æƒ…å ±æ›´æ–°',0),(460544,12793,'pt','AtualizaÃ§Ã£o de estoque por porcentagem',0),(460545,12793,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(460546,12793,'es','ActualizaciÃ³n de Stock por Porcentaje',0),(460547,12793,'de','Bestandsfortschreibung Prozentanteils',0),(460548,12793,'en','Stock Update by Percentage',0),(460549,12794,'is','',0),(460550,12794,'dr','Ù¾ÛŒØ´ Ù†Ù…Ø§ÛŒØ´ Ú†Ø§Ù¾ Ø¯Ø± Ù‡Ø± ØµÙØ­Ù‡',0),(460551,12794,'pr','Ù¾ÛŒØ´ Ù†Ù…Ø§ÛŒØ´ Ú†Ø§Ù¾ Ø¯Ø± Ù‡Ø± ØµÙØ­Ù‡',0),(460552,12794,'tr','Sayfa baÅŸÄ±na bir Ã¶n baskÄ±lÄ±',0),(460553,12794,'pl','Jedna strona z nadrukiem',0),(460554,12794,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð½ ÐµÐ´Ð¸Ð½ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(460555,12794,'ur','Ø§ÛŒÚ© ÙÛŒ ØµÙØ­Û Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹Ø¯',0),(460556,12794,'sr','Ð¤Ð°Ð±Ñ€Ð¸Ñ‡ÐºÐ¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½ Ñ˜ÐµÐ´Ð°Ð½ Ð¿Ð¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(460557,12794,'vi','in trÆ°á»›c tá»«ng trang',0),(460558,12794,'af','Preprinted een per bladsy',0),(460559,12794,'ro','O pre-imprimate per paginÄƒ',0),(460560,12794,'et','Eelprinditud Ã¼he lehekÃ¼lje',0),(460561,12794,'si','Nespremenljivo enega na strani',0),(460562,12794,'ba','Cetakan satu per halaman',0),(460563,12794,'nl','Voorgedrukte Ã©Ã©n per pagina',0),(460564,12794,'fi','Esipainettua yksi per sivu',0),(460565,12794,'no','ForhÃ¥ndstrykte Ã©n per side',0),(460566,12794,'da','Fortrykt Ã©n pr. side',0),(460567,12794,'ko','íŽ˜ì´ì§€ì— í•˜ë‚˜ì”© ì¸ì‡„',0),(460568,12794,'he','××—×“ ×ž×•×“×¤×¡ ×ž×¨××© ×œ×›×œ ×¢×ž×•×“',0),(460569,12794,'el','Î ÏÎ¿Ï„Ï…Ï€Ï‰Î¼Î­Î½ÎµÏ‚ 1 Î±Î½Î¬ ÏƒÎµÎ»Î¯Î´Î±',0),(460570,12794,'zh','é¢„æ‰“å°çš„ä¸€é¡µ',0),(460571,12794,'sv','FÃ¶rtryckt en per sida',0),(460572,12794,'it','Uno per pagina prestampata',0),(460573,12794,'tl','',0),(460574,12794,'th','à¸«à¸™à¸¶à¹ˆà¸‡à¸žà¸´à¸¡à¸žà¹Œà¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²à¸•à¹ˆà¸­à¸«à¸™à¹‰à¸²',0),(460575,12794,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¥ƒà¤·à¥à¤  à¤à¤• preprinted',0),(460576,12794,'ms','Pracetak satu per Laman',0),(460577,12794,'ar','Ù…Ø·Ø¨ÙˆØ¹ ÙˆØ§Ø­Ø¯ Ù„ÙƒÙ„ ØµÙØ­Ø©',0),(460578,12794,'fr','Un prÃ©-imprimÃ© par Page',0),(460579,12794,'jp','1 ãƒšãƒ¼ã‚¸ã‚ãŸã‚Šå°åˆ·ç”¨ç´™',0),(460580,12794,'pt','Um por pÃ¡gina prÃ©-impressos',0),(460581,12794,'ru','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð½Ð½Ð°Ñ Ð¾Ð´Ð¸Ð½ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(460582,12794,'es','Preimprimido Uno por PÃ¡gina',0),(460583,12794,'de','Vorgedruckte einer pro Seite',0),(460584,12794,'en','Preprinted One per Page',0),(460585,12795,'is','',0),(460586,12795,'dr','Ø¯Ø±ØµØ¯ Ø¬Ù‡Øª Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¨Ù‡ Ø¨Ù‡Ø§ÛŒ Ø¨Ø±Ú¯Ø´Øª Ø´Ø¯Ù‡ ',0),(460587,12795,'pr','Ø¯Ø±ØµØ¯ Ø¬Ù‡Øª Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¨Ù‡ Ø¨Ù‡Ø§ÛŒ Ø¨Ø±Ú¯Ø´Øª Ø´Ø¯Ù‡ ',0),(460588,12795,'tr','DÃ¶ndÃ¼rÃ¼len deÄŸer eklemek iÃ§in yÃ¼zde',0),(460589,12795,'pl','Procent dodac do zwracanych wartoÅ›ci',0),(460590,12795,'bg','% Ð—Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ ÐºÑŠÐ¼ Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð°Ñ‚Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(460591,12795,'ur','ÙˆØ§Ù¾Ø³ Ù‚Ø¯Ø± Ú©Ùˆ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Ø§ ÙÛŒØµØ¯',0),(460592,12795,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð²Ñ€Ð°Ñ›ÐµÐ½Ð° Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(460593,12795,'vi','pháº§n trÄƒm Ä‘á»ƒ thÃªm vÃ o giÃ¡ trá»‹ bá»‹ tráº£ láº¡i ',0),(460594,12795,'af','Persent teruggestuurde waarde by',0),(460595,12795,'ro','La sutÄƒ pentru a adÄƒuga valoare returnate',0),(460596,12795,'et','Protsenti tagastatud vÃ¤Ã¤rtuse lisamine',0),(460597,12795,'si','Odstotkov dodati vrnjena vrednost',0),(460598,12795,'ba','Persen untuk menambah nilai kembali',0),(460599,12795,'nl','Procent toe te voegen aan geretourneerde waarde',0),(460600,12795,'fi','Prosenttia lisÃ¤Ã¤minen palautettu arvo',0),(460601,12795,'no','Prosent legge til returnerte verdien',0),(460602,12795,'da','Procent til at tilfÃ¸je til returnerede vÃ¦rdi',0),(460603,12795,'ko','ë°˜í™˜ ëœ ê°’ì„ ì¶”ê°€ í•˜ë ¤ë©´ %',0),(460604,12795,'he','××—×•×–×™×, ×¢×œ ×ž× ×ª ×œ×”×•×¡×™×£ ×œ×¢×¨×š ×”×ž×•×—×–×¨',0),(460605,12795,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Î³Î¹Î± Î½Î± Î±Ï…Î¾Î¬Î½Ï‰ Ï„Î·Î½ ÎµÏ€Î¹ÏƒÏ„ÏÎµÏ†ÏŒÎ¼ÎµÎ½Î· Ï„Î¹Î¼Î®',0),(460606,12795,'zh','%å°†æ·»åŠ åˆ°è¿”å›žçš„å€¼',0),(460607,12795,'sv','Procent att lÃ¤gga till vÃ¤rdet som returneras',0),(460608,12795,'it','Per cento da aggiungere al valore restituito',0),(460609,12795,'tl','',0),(460610,12795,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¸„à¹ˆà¸²à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¸„à¸·à¸™',0),(460611,12795,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤ªà¤¸ à¤†à¤ à¤®à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(460612,12795,'ms','Peratus untuk menambah nilai pulangan',0),(460613,12795,'ar','ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ø±Ø¬Ø§Ø¹Ù‡Ø§',0),(460614,12795,'fr','Pour cent d\'ajouter Ã  la valeur retournÃ©e',0),(460615,12795,'jp','è¿”ã•ã‚ŒãŸå€¤ã«è¿½åŠ ã™ã‚‹ %',0),(460616,12795,'pt','Por cento para adicionar ao valor retornado',0),(460617,12795,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð´Ð»Ñ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÐ¼Ð¾Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(460618,12795,'es','Porcentaje de Aumentar al Valor de DevoluciÃ³n',0),(460619,12795,'de','Prozent auf zurÃ¼ckgegebene Wert hinzufÃ¼gen',0),(460620,12795,'en','Percent to Add to Returned Value',0),(460621,12796,'is','',0),(460622,12796,'dr','- 25 ÛŒØ¹Ù†ÛŒ 25 ÙÛŒØµØ¯ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯ ',0),(460623,12796,'pr','ØµÙØ± Ø¨Ù‡ Ø§ÛŒÙ† Ù…Ø¹Ù†ÛŒ Ø§Ø³Øª Ú©Ù‡ Ú†ÛŒØ²ÛŒ Ø§Ø¶Ø§ÙÙ‡ Ù†Ú©Ù†ÛŒØ¯ - 25 ÛŒØ¹Ù†ÛŒ 25 Ø¯Ø±ØµØ¯ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯ ',0),(460624,12796,'tr','HiÃ§bir ÅŸey, sÄ±fÄ±r eklemek 25 anlamÄ±na gelir yÃ¼zde 25\'i ekle',0),(460625,12796,'pl','Zero oznacza nic, dodaÄ‡ 25 oznacza dodaÄ‡ 25 procent',0),(460626,12796,'bg','ÐÑƒÐ»Ð° Ð¾Ð·Ð½Ð°Ñ‡Ð°Ð²Ð° Ð½Ð¸Ñ‰Ð¾, Ð´Ð¾Ð±Ð°Ð²Ð¸ 25 Ð¾Ð·Ð½Ð°Ñ‡Ð°Ð²Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸ 25 Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(460627,12796,'ur','ØµÙØ± Ú©Ø§ Ù…Ø·Ù„Ø¨ Ú©Ú†Ú¾ Ù†ÛØŒ Ú©Ø§ Ø§Ø¶Ø§ÙÛ 25 ÛŒØ¹Ù†ÛŒ 25 ÙÛŒØµØ¯ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(460628,12796,'sr','ÐÑƒÐ»Ð° Ð·Ð½Ð°Ñ‡Ð¸ Ð´Ð° Ð½Ð¸ÑˆÑ‚Ð°, Ð´Ð¾Ð´Ð°Ñ‚Ðµ 25 ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ 25%',0),(460629,12796,'vi','Zero nghÄ©a lÃ  trá»‘ng rá»—ng, 25 nghÄ©a lÃ  25%',0),(460630,12796,'af','Nul beteken niks, voeg 25 beteken voeg 25 persent',0),(460631,12796,'ro','Zero Ã®nseamnÄƒ adÄƒuga nimic, Ã®nseamnÄƒ 25 Adauga 25 la sutÄƒ',0),(460632,12796,'et','Null tÃ¤hendab lisada midagi, 25 vahend lisada 25 protsenti',0),(460633,12796,'si','NiÄ pomeni dodati niÄ, dodamo 25 pomeni 25 odstotkov',0),(460634,12796,'ba','Nol berarti menambahkan apa-apa, berarti 25 menambahkan 25 persen',0),(460635,12796,'nl','Nul betekent niets, voeg toe 25 middelen toevoegen 25 procent',0),(460636,12796,'fi','Nolla tarkoittaa mitÃ¤Ã¤n, lisÃ¤Ã¤ 25 keinoja lisÃ¤tÃ¤ 25 prosenttia',0),(460637,12796,'no','Null betyr legger ingenting, 25 betyr legge til 25 prosent',0),(460638,12796,'da','Nul betyder tilfÃ¸jer intet, 25 betyder tilfÃ¸je 25 procent',0),(460639,12796,'ko','0, ì•„ë¬´ê²ƒë„ ì¶”ê°€ 25 ìˆ˜ë‹¨ ì¶”ê°€ 25%',0),(460640,12796,'he','××¤×¡ ××ž×¦×¢×™× ×œ×”×•×¡×™×£ ×“×‘×¨, ××•×ž×¨ 25 ×œ×”×•×¡×™×£ 25 ××—×•×–',0),(460641,12796,'el','Î— Ï„Î¹Î¼Î® Î¼Î·Î´Î­Î½ ÏƒÎ·Î¼Î±Î¯Î½ÎµÎ¹ Î´ÎµÎ½ Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Ï…Î½ Ï„Î¯Ï€Î¿Ï„Î±, 25 Î¼Î­ÏƒÎ± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Ï…Î½ 25 Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(460642,12796,'zh','é›¶æ„å‘³ç€æ·»åŠ ä»»ä½•ä¸œè¥¿ï¼Œ25 æ‰‹æ®µå¢žåŠ  25%',0),(460643,12796,'sv','Noll innebÃ¤r tillfÃ¶r nÃ¥got, 25 sÃ¤tt lÃ¤gga 25 procent',0),(460644,12796,'it','Zero significa aggiungere nulla, 25 significa aggiungere 25 per cento',0),(460645,12796,'tl','',0),(460646,12796,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸¨à¸¹à¸™à¸¢à¹Œà¸«à¸¡à¸²à¸¢à¸–à¸¶à¸‡à¸­à¸°à¹„à¸£ à¸«à¸¡à¸²à¸¢à¸–à¸¶à¸‡ 25 à¹€à¸žà¸´à¹ˆà¸¡ 25 à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œ',0),(460647,12796,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¤¾ à¤®à¤¤à¤²à¤¬ à¤¹à¥ˆ à¤•à¥à¤› à¤­à¥€ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ, à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ 25 à¤¸à¤¾à¤§à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ 25 à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(460648,12796,'ms','Sifar bermaksud menambah apa-apa, 25 cara menambah 25 peratus',0),(460649,12796,'ar','Ø§Ù„ØµÙØ± ÙŠØ¹Ù†ÙŠ Ù„Ø§ ØªØ¶ÙŠÙ Ø´ÙŠØ¦Ø§ØŒ Ø§Ù„ÙˆØ³Ø§Ø¦Ù„ 25 Ø¥Ø¶Ø§ÙØ© 25 ÙÙŠ Ø§Ù„Ù…Ø§Ø¦Ø©',0),(460650,12796,'fr','ZÃ©ro, n\'ajoute rien, 25 moyens ajouter 25 pour cent',0),(460651,12796,'jp','0 è¿½åŠ ä½•ã‚‚ã€25 ã¯ 25 ï¼… ã‚’è¿½åŠ ',0),(460652,12796,'pt','Zero significa adiciona nada, 25 significa adiciona 25 por cento',0),(460653,12796,'ru','ÐÑƒÐ»ÐµÐ²Ð¾Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¾Ð·Ð½Ð°Ñ‡Ð°ÐµÑ‚ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½ÐµÑ‡ÐµÐ³Ð¾, 25 Ð¾Ð·Ð½Ð°Ñ‡Ð°ÐµÑ‚ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ 25%',0),(460654,12796,'es','Zero Quiere Decir Nada, 25 Significa Aumenta por 25 Porciento',0),(460655,12796,'de','HinzufÃ¼gen von NULL bedeutet nichts, 25 Mittel hinzufÃ¼gen 25 Prozent',0),(460656,12796,'en','Zero Means Add Nothing, 25 Means Add 25 Percent',0),(460657,12797,'is','',0),(460658,12797,'dr','Ø¶Ø±ÛŒØ¨ Ù‚ÛŒÙ…Øª',0),(460659,12797,'pr','Ø¶Ø±ÛŒØ¨ Ù‚ÛŒÙ…Øª',0),(460660,12797,'tr','Fiyat Ã§arpanÄ±',0),(460661,12797,'pl','MnoÅ¼nik ceny',0),(460662,12797,'bg','Ð¦ÐµÐ½Ð° Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚ÐµÐ»',0),(460663,12797,'ur','Ù‚ÛŒÙ…Øª Ø¶Ø§Ø±Ø¨',0),(460664,12797,'sr','Ð¦ÐµÐ½Ð° Ð¼Ð½Ð¾Ð¶Ð¸Ð»Ð°Ñ†',0),(460665,12797,'vi','tÄƒng giÃ¡',0),(460666,12797,'af','Prys Vermenigvuldiger',0),(460667,12797,'ro','Pret de multiplicare',0),(460668,12797,'et','Hind kordaja',0),(460669,12797,'si','Cena multiplikator',0),(460670,12797,'ba','Harga Multiplier',0),(460671,12797,'nl','Prijs vermenigvuldiger',0),(460672,12797,'fi','Hinta kerroin',0),(460673,12797,'no','Pris multiplikatoren',0),(460674,12797,'da','Pris multiplikator',0),(460675,12797,'ko','ê°€ê²© ë°°ìœ¨',0),(460676,12797,'he','×ž×›×¤×™×œ ×ž×—×™×¨',0),(460677,12797,'el','Î¤Î¹Î¼Î® Ï€Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î®',0),(460678,12797,'zh','ä»·æ ¼ä¹˜æ•°',0),(460679,12797,'sv','Pris multiplikator',0),(460680,12797,'it','Moltiplicatore del prezzo',0),(460681,12797,'tl','',0),(460682,12797,'th','à¸•à¸±à¸§à¸„à¸¹à¸“à¸£à¸²à¸„à¸²',0),(460683,12797,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤—à¥à¤£à¤•',0),(460684,12797,'ms','Pengganda harga',0),(460685,12797,'ar','Ù…Ø¶Ø§Ø¹Ù Ø§Ù„Ø³Ø¹Ø±',0),(460686,12797,'fr','Prix multiplicateur',0),(460687,12797,'jp','ä¾¡æ ¼ã®ä¹—æ•°',0),(460688,12797,'pt','Multiplicador de preÃ§o',0),(460689,12797,'ru','Ð¦ÐµÐ½Ð° Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒ',0),(460690,12797,'es','Multiplicador de Precios',0),(460691,12797,'de','Preis-Multiplikator',0),(460692,12797,'en','Price Multiplier',0),(460693,12798,'is','',0),(460694,12798,'dr','Ù…Ø¬Ù…ÙˆØ¹',0),(460695,12798,'pr','Ù…Ø¬Ù…ÙˆØ¹',0),(460696,12798,'tr','Toplam',0),(460697,12798,'pl','O Å‚Ä…cznej dÅ‚ugoÅ›ci',0),(460698,12798,'bg','ÐžÐ±Ñ‰Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(460699,12798,'ur','Ú©Ù„',0),(460700,12798,'sr','Ð£ ÑƒÐºÑƒÐ¿Ð½Ð¾Ð¼ Ð¸Ð·Ð½Ð¾ÑÑƒ',0),(460701,12798,'vi','Tá»•ng cá»™ng',0),(460702,12798,'af','Hoogteverskil',0),(460703,12798,'ro','ÃŽn valoare totalÄƒ de',0),(460704,12798,'et','Kokku',0),(460705,12798,'si','ViÅ¡ini',0),(460706,12798,'ba','Berjumlah',0),(460707,12798,'nl','In totaal',0),(460708,12798,'fi','YhteensÃ¤',0),(460709,12798,'no','Totalt',0),(460710,12798,'da','PÃ¥ i alt',0),(460711,12798,'ko','ì´',0),(460712,12798,'he','×‘×¡×™×›×•×',0),(460713,12798,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¿Ï ÏÏˆÎ¿Ï…Ï‚',0),(460714,12798,'zh','å…±è®¡',0),(460715,12798,'sv','PÃ¥ totalt',0),(460716,12798,'it','Per un totale di',0),(460717,12798,'tl','',0),(460718,12798,'th','à¸œà¸¥à¸£à¸§à¸¡',0),(460719,12798,'hi','à¤¯à¥‹à¤—',0),(460720,12798,'ms','Berjumlah',0),(460721,12798,'ar','ÙŠØ¨Ù„Øº Ù…Ø¬Ù…ÙˆØ¹Ù‡Ø§',0),(460722,12798,'fr','Pour un total de',0),(460723,12798,'jp','åˆè¨ˆ',0),(460724,12798,'pt','Totalizando',0),(460725,12798,'ru','Ð’ Ð¾Ð±Ñ‰ÐµÐ¹ ÑÐ»Ð¾Ð¶Ð½Ð¾ÑÑ‚Ð¸',0),(460726,12798,'es','Totalizando',0),(460727,12798,'de','In HÃ¶he von',0),(460728,12798,'en','Totalling',0),(460729,12799,'is','',0),(460730,12799,'dr','...',0),(460731,12799,'pr','Ø¬ÙˆØ§Ø¨ Ø¶Ø±Ø¨Ø¯Ø± Ù…Ù‚Ø¯Ø§Ø±...',0),(460732,12799,'tr','YanÄ±t M miktarÄ± x',0),(460733,12799,'pl','OdpowiedÅº x iloÅ›Ä‡ M',0),(460734,12799,'bg','ÐžÑ‚Ð³Ð¾Ð²Ð¾Ñ€ x M ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(460735,12799,'ur','X M Ù…Ù‚Ø¯Ø§Ø± Ú©Ø§ Ø¬ÙˆØ§Ø¨',0),(460736,12799,'sr','ÐžÐ´Ð³Ð¾Ð²Ð¾Ñ€ x Ðœ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(460737,12799,'vi','Tráº£ lá»i x M sá»‘ lÆ°á»£ng',0),(460738,12799,'af','Antwoord x M hoeveelheid',0),(460739,12799,'ro','RÄƒspunsul x M cantitatea',0),(460740,12799,'et','Vastus x M kogus',0),(460741,12799,'si','Odgovor x koliÄina M',0),(460742,12799,'ba','Jawaban x jumlah M',0),(460743,12799,'nl','Antwoord x M hoeveelheid',0),(460744,12799,'fi','Vastaus x M mÃ¤Ã¤rÃ¤',0),(460745,12799,'no','Svaret x M antall',0),(460746,12799,'da','Svaret x Mikkelsen mÃ¦ngde',0),(460747,12799,'ko','M ì–‘ x ëŒ€ë‹µ',0),(460748,12799,'he','×”×ª×©×•×‘×” x ×›×ž×•×ª ×–',0),(460749,12799,'el','Î‘Ï€Î¬Î½Ï„Î·ÏƒÎ· x Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± M',0),(460750,12799,'zh','X M æ•°é‡çš„ç­”æ¡ˆ',0),(460751,12799,'sv','Svar x M kvantitet',0),(460752,12799,'it','Risposta x quantitÃ  M',0),(460753,12799,'tl','',0),(460754,12799,'th','à¸„à¸³à¸•à¸­à¸š x à¸›à¸£à¸´à¸¡à¸²à¸“ M',0),(460755,12799,'hi','à¤‰à¤¤à¥à¤¤à¤° à¤®à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ x',0),(460756,12799,'ms','Jawapan x kuantiti M',0),(460757,12799,'ar','Ø¬ÙˆØ§Ø¨ Ã— Ø§Ù„ÙƒÙ…ÙŠØ© Ù…',0),(460758,12799,'fr','RÃ©ponse x M quantitÃ©',0),(460759,12799,'jp','M æ•°é‡ x ç­”ãˆ',0),(460760,12799,'pt','Resposta x quantidade de M',0),(460761,12799,'ru','ÐžÑ‚Ð²ÐµÑ‚ x M ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(460762,12799,'es','Respuesta x Cantidad M',0),(460763,12799,'de','Antwort x M Menge',0),(460764,12799,'en','Answer x M Quantity',0),(460765,12800,'is','',0),(460766,12800,'dr','(Ù…Ø´ØªØ±ÛŒØ§Ù†) Ù…ÛŒØ²Ø¨Ø§Ù† Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(460767,12800,'pr','Ø§ÛŒÙ† ÙˆÛŒÚ˜Ú¯ÛŒ Ø¨Ø±Ø§ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±(Ù…Ø´ØªØ±ÛŒØ§Ù†) Ù…ÛŒØ²Ø¨Ø§Ù† Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(460768,12800,'tr','Bu Ã¶zelliÄŸi barÄ±ndÄ±rÄ±lan mÃ¼ÅŸterileri iÃ§in mevcut deÄŸildir.',0),(460769,12800,'pl','Ta funkcja nie jest dostÄ™pna dla klientÃ³w obsÅ‚ugiwanych',0),(460770,12800,'bg','Ð¢Ð°Ð·Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð½Ðµ Ðµ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð° Ð·Ð° Ñ…Ð¾ÑÑ‚Ð²Ð°Ð½Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(460771,12800,'ur','ÛŒÛ Ø®ØµÙˆØµÛŒØª Ù…ÛŒØ²Ø¨Ø§Ù† ØµØ§Ø±ÙÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº ÛÛ’',0),(460772,12800,'sr','ÐžÐ²Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ð·Ð° Ñ˜Ð°Ð²Ð½Ð¸Ñ… ÐºÑƒÐ¿Ñ†Ðµ',0),(460773,12800,'vi','TÃ­nh nÄƒng nÃ y thÃ¬ khÃ´ng sáºµn sÃ ng cho khach hÃ ng cÃ³ tá»• chá»©c',0),(460774,12800,'af','Hierdie kenmerk Is nie beskikbaar vir kliÃ«nte wat gehuisves',0),(460775,12800,'ro','AceastÄƒ caracteristicÄƒ nu este disponibilÄƒ pentru clienÅ£ii gÄƒzduit',0),(460776,12800,'et','See funktsioon pole saadaval vÃµÃµrustas klientidele',0),(460777,12800,'si','Ta funkcija ni na voljo za gostujoÄe stranke',0),(460778,12800,'ba','Fitur ini tidak tersedia untuk pelanggan host',0),(460779,12800,'nl','Deze functie Is niet beschikbaar voor gehoste klanten',0),(460780,12800,'fi','TÃ¤mÃ¤ ominaisuus ei ole saatavilla isÃ¤nnÃ¶i asiakkaille',0),(460781,12800,'no','Denne funksjonen er ikke tilgjengelig For vertsbaserte kunder',0),(460782,12800,'da','Denne funktion er ikke tilgÃ¦ngelig For hostede kunder',0),(460783,12800,'ko','ì´ ê¸°ëŠ¥ì€ í˜¸ìŠ¤íŠ¸ ê³ ê°ì„ ìœ„í•´ ì‚¬ìš©í•  ìˆ˜',0),(460784,12800,'he','×ª×›×•× ×” ×–×• ××™× ×” ×–×ž×™× ×” ×¢×‘×•×¨ ×”×œ×§×•×—×•×ª ×ž×ª××¨×—',0),(460785,12800,'el','Î‘Ï…Ï„Î® Î· Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„Î± Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Î³Î¹Î± Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï†Î¹Î»Î¿Î¾ÎµÎ½ÎµÎ¯Ï„Î±Î¹',0),(460786,12800,'zh','æ­¤åŠŸèƒ½ä¸å¯ç”¨äºŽæ‰¿è½½å®¢æˆ·',0),(460787,12800,'sv','Den hÃ¤r funktionen Ã¤r inte tillgÃ¤nglig fÃ¶r vÃ¤rd kunder',0),(460788,12800,'it','Questa funzionalitÃ  non Ã¨ disponibile per i clienti ospitati',0),(460789,12800,'tl','',0),(460790,12800,'th','à¸„à¸¸à¸“à¸¥à¸±à¸à¸©à¸“à¸°à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹€à¸›à¹‡à¸™à¹‚à¸®à¸ªà¸•à¹Œ',0),(460791,12800,'hi','à¤‡à¤¸ à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤•à¥€ à¤®à¥‡à¤œà¤¬à¤¾à¤¨à¥€ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(460792,12800,'ms','Ciri-ciri ini tidak disediakan untuk pelanggan-pelanggan yang dihos',0),(460793,12800,'ar','Ù‡Ø°Ù‡ Ø§Ù„Ù…ÙŠØ²Ø© ØºÙŠØ± Ù…ØªÙˆÙØ±Ø© Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡ ÙˆØ§Ø³ØªØ¶Ø§ÙØª',0),(460794,12800,'fr','Cette fonctionnalitÃ© n\'est pas disponible pour les clients hÃ©bergÃ©s',0),(460795,12800,'jp','ã“ã®æ©Ÿèƒ½ã¯ãƒ›ã‚¹ãƒˆã®é¡§å®¢ã®ãŸã‚åˆ©ç”¨ã§ãã¾ã›ã‚“ã€‚',0),(460796,12800,'pt','Esse recurso nÃ£o estÃ¡ disponÃ­vel para os clientes hospedados',0),(460797,12800,'ru','Ð­Ñ‚Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ Ð½Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ð´Ð»Ñ Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(460798,12800,'es','Esta CaracterÃ­stica No Esta Disponible Para Clientes Hospedados',0),(460799,12800,'de','Dieses Feature ist nicht verfÃ¼gbar fÃ¼r gehostete Kunden',0),(460800,12800,'en','This Feature Is Not Available For Hosted Customers',0),(460801,12801,'is','',0),(460802,12801,'dr','Ø§Ù‚Ù„Ø§Ù… Ø¯Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª Ù†Ù‚Ø¯ÛŒ Ø¨Ø¯ÙˆÙ† Ø§Ø«Ø± Ø¨Ø± Ù†Ù‚Ø¯ÛŒÙ†Ú¯ÛŒ ',0),(460803,12801,'pr','Ø§Ù‚Ù„Ø§Ù… Ø¯Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª Ù†Ù‚Ø¯ÛŒ Ø¨Ø¯ÙˆÙ† Ø§Ø«Ø± Ø¨Ø± Ù†Ù‚Ø¯ÛŒÙ†Ú¯ÛŒ ',0),(460804,12801,'tr','Vergiye tabi gelir nakit deÄŸil etkileyen Ã¶ÄŸeler',0),(460805,12801,'pl','Elementy dochÃ³d do opodatkowania nie wpÅ‚ywajÄ…cych na gotÃ³wkÄ™',0),(460806,12801,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð² Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð¸Ñ Ð´Ð¾Ñ…Ð¾Ð´ Ð½Ðµ Ð·Ð°ÑÑÐ³Ð°Ñ‚ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸',0),(460807,12801,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… Ú©Ùˆ Ù…ØªØ§Ø«Ø± Ù†ÛÛŒÚº Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ Ø¢Ù…Ø¯Ù†ÛŒ Ù…ÛŒÚº Ø§Ø´ÛŒØ§Ø¡',0),(460808,12801,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ñƒ Ð¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´ Ð½Ðµ ÑƒÑ‚Ð¸Ñ‡Ðµ Ð½Ð° Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ñƒ',0),(460809,12801,'vi','CÃ¡c máº·t hÃ ng trong thu nháº­p chá»‹u tháº¿ Ä‘ang khÃ´ng áº£nh hÆ°á»Ÿng Ä‘áº¿n tiá»n',0),(460810,12801,'af','Items in belasbare inkomste beÃ¯nvloed nie kontant',0),(460811,12801,'ro','Elementele din venituri impozabile nu afecteazÄƒ numerar',0),(460812,12801,'et','Kaupade maksustatava tulu hulka ei mÃµjuta raha',0),(460813,12801,'si','Elementov v obdavÄljivi dobiÄek, ne vpliva na denarni',0),(460814,12801,'ba','Item dalam penghasilan kena pajak tidak mempengaruhi tunai',0),(460815,12801,'nl','Items in de belastbare winst niet van invloed op Cash',0),(460816,12801,'fi','Kohteiden verotettavaa tuloa ei vaikuta kÃ¤teistÃ¤',0),(460817,12801,'no','Elementer i skattbar inntekt ikke pÃ¥virker kontanter',0),(460818,12801,'da','Elementer i skattepligtige indkomst ikke pÃ¥virker Cash',0),(460819,12801,'ko','ê³¼ì„¸ ì†Œë“ í•˜ì§€ í˜„ê¸ˆì— ì˜í–¥ì„ ë¯¸ì¹˜ëŠ” í•­ëª©',0),(460820,12801,'he','×¤×¨×™×˜×™ ×”×”×›× ×¡×” ×”×—×™×™×‘×ª ×œ× ×ž×©×¤×™×¢ ×¢×œ ×ž×–×•×ž× ×™×',0),(460821,12801,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏ„Î¿ Ï†Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­Î¿ ÎµÎ¹ÏƒÏŒÎ´Î·Î¼Î± Ï€Î¿Ï… Î´ÎµÎ½ ÎµÏ€Î·ÏÎµÎ¬Î¶Î¿Ï…Î½ Ï„Î± Î¼ÎµÏ„ÏÎ·Ï„Î¬',0),(460822,12801,'zh','åœ¨ä¸å½±å“çŽ°é‡‘çš„åº”çº³ç¨Žæ‰€å¾—é¡¹ç›®',0),(460823,12801,'sv','Objekt i den skattepliktiga inkomsten som inte pÃ¥verkar likvida medel',0),(460824,12801,'it','Elementi di reddito imponibile non influisce sulla cassa',0),(460825,12801,'tl','',0),(460826,12801,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µà¸£à¸²à¸¢à¹„à¸”à¹‰à¹„à¸¡à¹ˆà¸à¸£à¸°à¸—à¸šà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(460827,12801,'hi','à¤¨à¤•à¤¦à¥€ à¤•à¥‹ à¤ªà¥à¤°à¤­à¤¾à¤µà¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¯à¥‹à¤—à¥ à¤¯ à¤†à¤¯ à¤®à¥‡à¤‚ à¤†à¤‡à¤Ÿà¤®',0),(460828,12801,'ms','Item dalam pendapatan bercukai yang tidak melibatkan Wang Tunai',0),(460829,12801,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± ÙÙŠ Ø§Ù„Ø¯Ø®Ù„ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ù„Ø§ ØªØ¤Ø«Ø± Ø¹Ù„Ù‰ Ø§Ù„Ù†Ù‚Ø¯ÙŠØ©',0),(460830,12801,'fr','Ã‰lÃ©ments de revenu imposable, sans incidence sur la trÃ©sorerie',0),(460831,12801,'jp','èª²ç¨Žæ‰€å¾—ã«å½±éŸ¿ã—ã¦ã„ãªã„ç¾é‡‘é …ç›®',0),(460832,12801,'pt','Itens do rendimento tributÃ¡vel, nÃ£o afetando o dinheiro',0),(460833,12801,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð² Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ñ‹Ð¹ Ð´Ð¾Ñ…Ð¾Ð´, Ð½Ðµ Ð·Ð°Ñ‚Ñ€Ð°Ð³Ð¸Ð²Ð°Ñ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ',0),(460834,12801,'es','Items en Renta Imponible Que No Afecta el Efectivo',0),(460835,12801,'de','Elemente in steuerbares Einkommen nicht beeinflussen Cash',0),(460836,12801,'en','Items in Taxable Income Not Affecting Cash',0),(460837,12802,'is','',0),(460838,12802,'dr','ØªÙˆØ¶ÛŒØ­ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡',0),(460839,12802,'pr','ØªÙˆØ¶ÛŒØ­ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡',0),(460840,12802,'tr','Nakit akÄ±ÅŸÄ± tanÄ±mÄ±',0),(460841,12802,'pl','Definicja przepÅ‚ywu Å›rodkÃ³w pieniÄ™Å¼nych',0),(460842,12802,'bg','Ð”ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ Ð½Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸',0),(460843,12802,'ur','Ú©ÛŒØ´ ÙÙ„Ùˆ Ú©ÛŒ ØªØ¹Ø±ÛŒÙ',0),(460844,12802,'sr','Ð”ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð° Ð½Ð¾Ð²Ñ‡Ð°Ð½Ð¾Ð³ Ñ‚Ð¾ÐºÐ°',0),(460845,12802,'vi','Äá»‹nh nghÄ©a dÃ²ng tiá»n',0),(460846,12802,'af','Kontantvloei Definisie',0),(460847,12802,'ro','DefiniÅ£ie de fluxul de numerar',0),(460848,12802,'et','Rahavoogude mÃµiste',0),(460849,12802,'si','Opredelitev denarnih tokov',0),(460850,12802,'ba','Definisi arus kas',0),(460851,12802,'nl','Cash-Flow definitie',0),(460852,12802,'fi','Kassavirta mÃ¤Ã¤ritelmÃ¤',0),(460853,12802,'no','KontantstrÃ¸m definisjon',0),(460854,12802,'da','Cash Flow Definition',0),(460855,12802,'ko','í˜„ê¸ˆ íë¦„ ì •ì˜',0),(460856,12802,'he','×”×’×“×¨×ª ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(460857,12802,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ Ï„Ï‰Î½ Ï„Î±Î¼ÎµÎ¹Î±ÎºÏŽÎ½ ÏÎ¿ÏŽÎ½',0),(460858,12802,'zh','çŽ°é‡‘æµçš„å®šä¹‰',0),(460859,12802,'sv','KassaflÃ¶de Definition',0),(460860,12802,'it','Definizione del flusso di cassa',0),(460861,12802,'tl','',0),(460862,12802,'th','à¸„à¸³à¸™à¸´à¸¢à¸²à¸¡à¸‚à¸­à¸‡à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(460863,12802,'hi','à¤¨à¤•à¤¦à¥€ à¤ªà¥à¤°à¤µà¤¾à¤¹ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾',0),(460864,12802,'ms','Definisi aliran tunai',0),(460865,12802,'ar','ØªØ¹Ø±ÙŠÙ Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(460866,12802,'fr','DÃ©finition de flux de trÃ©sorerie',0),(460867,12802,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ» ãƒ•ãƒ­ãƒ¼ã®å®šç¾©',0),(460868,12802,'pt','DefiniÃ§Ã£o de fluxo de caixa',0),(460869,12802,'ru','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð´ÐµÐ½ÐµÐ¶Ð½Ð¾Ð³Ð¾ Ð¿Ð¾Ñ‚Ð¾ÐºÐ°',0),(460870,12802,'es','DefiniciÃ³n de Flujo de Efectivo',0),(460871,12802,'de','Cashflow-Definition',0),(460872,12802,'en','Cash Flow Definition',0),(460873,12803,'is','',0),(460874,12803,'dr','Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡',0),(460875,12803,'pr','Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬ÙˆÙ‡',0),(460876,12803,'tr','Nakit akÄ±ÅŸÄ± raporu',0),(460877,12803,'pl','Sprawozdanie z przepÅ‚ywu Å›rodkÃ³w pieniÄ™Å¼nych',0),(460878,12803,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸',0),(460879,12803,'ur','Ú©ÛŒØ´ ÙÙ„Ùˆ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(460880,12803,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸ Ñ‚Ð¾Ðº Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(460881,12803,'vi','BÃ¡o cÃ¡o lÆ°u chuyá»ƒn tiá»n tá»‡',0),(460882,12803,'af','Kontantvloei Staat',0),(460883,12803,'ro','Raport de fluxul de numerar',0),(460884,12803,'et','Rahavoogude aruanne',0),(460885,12803,'si','PoroÄilo o denarnem toku',0),(460886,12803,'ba','Laporan arus kas',0),(460887,12803,'nl','Rapport cashflow',0),(460888,12803,'fi','Kassavirtaraportti',0),(460889,12803,'no','KontantstrÃ¸m-rapporten',0),(460890,12803,'da','PengestrÃ¸msanalyse',0),(460891,12803,'ko','í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œ',0),(460892,12803,'he','×“×•×— ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(460893,12803,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚',0),(460894,12803,'zh','çŽ°é‡‘æµé‡æŠ¥è¡¨',0),(460895,12803,'sv','KassaflÃ¶desrapport',0),(460896,12803,'it','Rapporto flusso di cassa',0),(460897,12803,'tl','',0),(460898,12803,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(460899,12803,'hi','à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(460900,12803,'ms','Laporan aliran tunai',0),(460901,12803,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(460902,12803,'fr','Rapport de flux de trÃ©sorerie',0),(460903,12803,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆ',0),(460904,12803,'pt','RelatÃ³rio de fluxo de caixa',0),(460905,12803,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… Ð¿Ð¾Ñ‚Ð¾ÐºÐ¾Ð²',0),(460906,12803,'es','Informe de Flujo de Efectivo',0),(460907,12803,'de','Cashflow-Bericht',0),(460908,12803,'en','Cash Flow Report',0),(460909,12804,'is','',0),(460910,12804,'dr','Ø§ÛŒØ¬Ø§Ø¯ ØªÙˆØ¶ÛŒØ­Ø§Øª Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬Ù‡',0),(460911,12804,'pr','Ø§ÛŒØ¬Ø§Ø¯ ØªÙˆØ¶ÛŒØ­Ø§Øª Ú¯Ø²Ø§Ø±Ø´ Ú¯Ø±Ø¯Ø´ ÙˆØ¬Ù‡',0),(460912,12804,'tr','Nakit akÄ±ÅŸÄ± raporu tanÄ±mÄ± oluÅŸturma',0),(460913,12804,'pl','Tworzenie definicji raportu przepÅ‚ywu Å›rodkÃ³w pieniÄ™Å¼nych',0),(460914,12804,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ Ð½Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸',0),(460915,12804,'ur','Ú©ÛŒØ´ ÙÙ„Ùˆ Ø±Ù¾ÙˆØ±Ù¹ ØªØ¹Ø±ÛŒÙ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(460916,12804,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð½Ð¾Ð²Ñ‡Ð°Ð½Ð¾Ð³ Ñ‚Ð¾ÐºÐ°',0),(460917,12804,'vi','táº¡o Ä‘á»‹nh nghÄ©a bÃ¡o cÃ¡o dÃ²ng tiá»n',0),(460918,12804,'af','Skep kontantvloei verslag definisie',0),(460919,12804,'ro','Crea definiÅ£ie de raport fluxul de numerar',0),(460920,12804,'et','Rahavoogude aruande definitsiooni loomine',0),(460921,12804,'si','Ustvarjanje denarnih tokov definicije poroÄila',0),(460922,12804,'ba','Menciptakan definisi laporan arus kas',0),(460923,12804,'nl','Cash-Flow rapportdefinitie maken',0),(460924,12804,'fi','Luo kassavirta raporttimÃ¤Ã¤ritys',0),(460925,12804,'no','Opprette kontantstrÃ¸m rapportdefinisjon',0),(460926,12804,'da','Oprette Cash Flow rapportdefinition',0),(460927,12804,'ko','í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œ ì •ì˜ ë§Œë“¤ê¸°',0),(460928,12804,'he','×œ×™×¦×•×¨ ×”×’×“×¨×ª ×”×“×•×— ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(460929,12804,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï„Î±Î¼ÎµÎ¹Î±ÎºÏŽÎ½ ÏÎ¿ÏŽÎ½ Î¿ÏÎ¹ÏƒÎ¼ÏŒÏ‚ Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(460930,12804,'zh','åˆ›å»ºçŽ°é‡‘æµé‡æŠ¥è¡¨å®šä¹‰',0),(460931,12804,'sv','Skapa kassaflÃ¶de rapportdefinition',0),(460932,12804,'it','Creare la definizione di rapporto flusso di cassa',0),(460933,12804,'tl','',0),(460934,12804,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸‚à¹‰à¸­à¸à¸³à¸«à¸™à¸”à¸‚à¸­à¸‡à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(460935,12804,'hi','à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(460936,12804,'ms','Mencipta definisi laporan aliran tunai',0),(460937,12804,'ar','Ø¥Ù†Ø´Ø§Ø¡ ØªØ¹Ø±ÙŠÙ ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(460938,12804,'fr','CrÃ©er la dÃ©finition de rapport de flux de trÃ©sorerie',0),(460939,12804,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆå®šç¾©ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(460940,12804,'pt','Criar a definiÃ§Ã£o de relatÃ³rio de fluxo de caixa',0),(460941,12804,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° Ð´Ð²Ð¸Ð¶ÐµÐ½Ð¸Ñ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(460942,12804,'es','Crear DefiniciÃ³n del Informe de Flujo de Efectivo',0),(460943,12804,'de','Erstellen von Cashflow-Report-Definition',0),(460944,12804,'en','Create Cash Flow Report Definition',0),(460945,12805,'is','',0),(460946,12805,'dr','Ù‡Ù…ÛŒØ´Ù‡ Ø§Ø² Ø§ÛŒÙ† Ø³Ø§ÛŒØ² Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(460947,12805,'pr','Ù‡Ù…ÛŒØ´Ù‡ Ø§Ø² Ø§ÛŒÙ† Ø³Ø§ÛŒØ² Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(460948,12805,'tr','Her zaman bu boyutunu kullan',0),(460949,12805,'pl','Zawsze uÅ¼ywaÄ‡ tej wielkoÅ›ci',0),(460950,12805,'bg','Ð’Ð¸Ð½Ð°Ð³Ð¸ Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹ Ñ‚Ð¾Ð·Ð¸ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(460951,12805,'ur','ÛÙ…ÛŒØ´Û Ø§Ø³ Ø³Ø§Ø¦Ø² Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(460952,12805,'sr','Ð£Ð²ÐµÐº ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¾Ð²Ñƒ Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(460953,12805,'vi','LuÃ´n luÃ´n dÃ¹ng cá»Ÿ nÃ y',0),(460954,12805,'af','Gebruik altyd hierdie grootte',0),(460955,12805,'ro','UtilizaÅ£i Ã®ntotdeauna aceastÄƒ dimensiune',0),(460956,12805,'et','Kasuta alati selle suurus',0),(460957,12805,'si','Vedno uporabite to velikost',0),(460958,12805,'ba','Selalu menggunakan ukuran ini',0),(460959,12805,'nl','Gebruik altijd deze grootte',0),(460960,12805,'fi','KÃ¤ytÃ¤ aina tÃ¤tÃ¤ kokoa',0),(460961,12805,'no','Bruk alltid denne stÃ¸rrelsen',0),(460962,12805,'da','Brug altid denne stÃ¸rrelse',0),(460963,12805,'ko','í•­ìƒì´ í¬ê¸°ë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(460964,12805,'he','×ª×ž×™×“ ×œ×”×©×ª×ž×© ×‘×’×•×“×œ ×”×–×”',0),(460965,12805,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Ï€Î¬Î½Ï„Î± Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î­Î³ÎµÎ¸Î¿Ï‚',0),(460966,12805,'zh','å§‹ç»ˆä½¿ç”¨æ­¤å¤§å°',0),(460967,12805,'sv','AnvÃ¤nd alltid denna storlek',0),(460968,12805,'it','Utilizzare sempre questa dimensione',0),(460969,12805,'tl','',0),(460970,12805,'th','à¹ƒà¸Šà¹‰à¸‚à¸™à¸²à¸”à¸™à¸µà¹‰à¹€à¸ªà¸¡à¸­',0),(460971,12805,'hi','à¤¹à¤®à¥‡à¤¶à¤¾ à¤‡à¤¸ à¤†à¤•à¤¾à¤° à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(460972,12805,'ms','Sentiasa gunakan saiz ini',0),(460973,12805,'ar','Ø¯Ø§Ø¦Ù…Ø§Ù‹ Ø§Ø³ØªØ®Ø¯Ù… Ù‡Ø°Ø§ Ø§Ù„Ø­Ø¬Ù…',0),(460974,12805,'fr','Utilisez toujours cette taille',0),(460975,12805,'jp','å¸¸ã«ã“ã®ã‚µã‚¤ã‚ºã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(460976,12805,'pt','Utilize sempre este tamanho',0),(460977,12805,'ru','Ð’ÑÐµÐ³Ð´Ð° Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ ÑÑ‚Ð¾Ñ‚ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(460978,12805,'es','Siempre Usa Este TamaÃ±o',0),(460979,12805,'de','Verwenden Sie immer diese GrÃ¶ÃŸe',0),(460980,12805,'en','Always Use This Size',0),(460981,12806,'is','',0),(460982,12806,'dr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ ÙØ±ÙˆØ´',0),(460983,12806,'pr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ ÙØ±ÙˆØ´',0),(460984,12806,'tr','SatÄ±ÅŸ baÅŸlayacak',0),(460985,12806,'pl','Data rozpoczÄ™cia sprzedaÅ¼y',0),(460986,12806,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(460987,12806,'ur','Ø³ÛŒÙ„Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø¢ØºØ§Ø²',0),(460988,12806,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(460989,12806,'vi','NgÃ y báº¯t Ä‘áº§u bÃ¡n hÃ ng',0),(460990,12806,'af','Begin datum van verkope',0),(460991,12806,'ro','ÃŽncepe de vÃ¢nzÄƒri data',0),(460992,12806,'et','Algus kuupÃ¤ev',0),(460993,12806,'si','ZaÄetni datum prodaje',0),(460994,12806,'ba','Mulai tanggal penjualan',0),(460995,12806,'nl','Verkoop begindatum',0),(460996,12806,'fi','Myynnin alkamispÃ¤ivÃ¤',0),(460997,12806,'no','Starte salgsslutt',0),(460998,12806,'da','Begynde salgsdato',0),(460999,12806,'ko','íŒë§¤ ë‚ ì§œë¥¼ ì‹œìž‘',0),(461000,12806,'he','×ª××¨×™×š ×”×ž×›×™×¨×” ×‘×’×™×Ÿ',0),(461001,12806,'el','ÎˆÎ½Î±ÏÎ¾Î· Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(461002,12806,'zh','å¼€å§‹é”€å”®æ—¥æœŸ',0),(461003,12806,'sv','BÃ¶rja FÃ¶rsÃ¤ljningsdatum',0),(461004,12806,'it','Iniziano le vendite data',0),(461005,12806,'tl','',0),(461006,12806,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸‚à¸²à¸¢à¸§à¸±à¸™',0),(461007,12806,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¤à¤¿à¤¥à¤¿ à¤¶à¥à¤°à¥‚',0),(461008,12806,'ms','Mula tarikh jualan',0),(461009,12806,'ar','ÙŠØ¨Ø¯Ø£ ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(461010,12806,'fr','Date de dÃ©but de vente',0),(461011,12806,'jp','è²©å£²æ—¥ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(461012,12806,'pt','ComeÃ§am vendas data',0),(461013,12806,'ru','Ð”Ð°Ñ‚Ñ‹ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(461014,12806,'es','Comienza Fecha de Ventas',0),(461015,12806,'de','BEGIN Verkaufsdatum',0),(461016,12806,'en','Begin Sales Date',0),(461017,12807,'is','',0),(461018,12807,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø­Ø¯ Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ ',0),(461019,12807,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø­Ø¯ Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ ',0),(461020,12807,'tr','Maddenin yeniden sipariÅŸ puan hesaplama',0),(461021,12807,'pl','ObliczyÄ‡ elementu ZmieÅ„ kolejnoÅ›Ä‡ punktÃ³w',0),(461022,12807,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(461023,12807,'ur','Ø´Û’ Ú©Ùˆ Ù¾Ú¾Ø± ØªØ±ØªÛŒØ¨ Ø¯ÛŒÙ†Û’ Ú©Û’ Ù…Ù‚Ø§Ù…Ø§Øª Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(461024,12807,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ñ‚Ð°Ñ‡ÐºÐµ Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(461025,12807,'vi','Ä‘iá»ƒm tÃ­nh toÃ¡n Ä‘Æ¡n Ä‘áº·t hÃ ng láº¡i',0),(461026,12807,'af','Item herrangskik punte bereken',0),(461027,12807,'ro','CalculaÅ£i punctele de reluare a comenzii element',0),(461028,12807,'et','Arvutatakse kauba kordustellimuse punktid',0),(461029,12807,'si','IzraÄun toÄk naroÄanja artikla',0),(461030,12807,'ba','Menghitung poin menyusun ulang Item',0),(461031,12807,'nl','Bereken Item bestelfrequentie punten',0),(461032,12807,'fi','Nimikkeen uusintatilausvÃ¤lin pisteitÃ¤',0),(461033,12807,'no','Beregne element omorganisere punkt',0),(461034,12807,'da','Beregne vare Omorganiser punkter',0),(461035,12807,'ko','í•­ëª© ìž¬ì£¼ë¬¸ ì  ê³„ì‚°',0),(461036,12807,'he','×—×™×©×•×‘ × ×§×•×“×•×ª ×¡×“×¨ ×ž×—×“×© ×¤×¨×™×˜',0),(461037,12807,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÎ¹ Ï„Î¿ ÏƒÎ·Î¼ÎµÎ¯Î¿ Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏƒÎ·Î¼ÎµÎ¯Î±',0),(461038,12807,'zh','è®¡ç®—é¡¹ç›®å†è®¢è´­ç‚¹',0),(461039,12807,'sv','BerÃ¤kna objekt ordna poÃ¤ng',0),(461040,12807,'it','Calcolare la voce punti di riordino',0),(461041,12807,'tl','',0),(461042,12807,'th','à¸„à¸³à¸™à¸§à¸“à¸ˆà¸¸à¸”à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¹ƒà¸«à¸¡à¹ˆà¸‚à¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(461043,12807,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤…à¤‚à¤• à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(461044,12807,'ms','Pengiraan Item susun semula Mata',0),(461045,12807,'ar','Ø­Ø³Ø§Ø¨ Ù†Ù‚Ø§Ø· Ø¥Ø¹Ø§Ø¯Ø© ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù†ØµØ±',0),(461046,12807,'fr','Calculer point de rÃ©approvisionnement Points',0),(461047,12807,'jp','é …ç›®ã®ä¸¦ã¹æ›¿ãˆã®ãƒã‚¤ãƒ³ãƒˆã‚’è¨ˆç®—ã—ã¾ã™ã€‚',0),(461048,12807,'pt','Calcular Item reordenar pontos',0),(461049,12807,'ru','Ð’Ñ‹Ñ‡Ð¸ÑÐ»Ð¸Ñ‚ÑŒ Ñ‚Ð¾Ñ‡ÐºÐ¸ Ð´Ð¾Ð·Ð°ÐºÐ°Ð·Ð° Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(461050,12807,'es','Calculo de Punto de Reordenar del Inventario',0),(461051,12807,'de','Berechnen der Punkte Element neu anordnen',0),(461052,12807,'en','Calculate Item Reorder Points',0),(461053,12808,'is','',0),(461054,12808,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù…Ø§Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ø­Ø¯Ø§Ú©Ø«Ø± Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(461055,12808,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù…Ø§Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ø­Ø¯Ø§Ú©Ø«Ø± Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(461056,12808,'tr','Eldeki maksimum sayÄ±da',0),(461057,12808,'pl','Liczba miesiÄ™cy do maksymalnie na rÄ™kÄ™',0),(461058,12808,'bg','Ð‘Ñ€Ð¾ÑÑ‚ Ð½Ð° Ð¼ÐµÑÐµÑ†Ð¸Ñ‚Ðµ Ð·Ð° Ð¼Ð°ÐºÑÐ¸Ð¼ÑƒÐ¼ Ð½Ð° Ñ€ÑŠÐºÐ°',0),(461059,12808,'ur','ÛØ§ØªÚ¾ Ù¾Ø± Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ú©Û’ Ù„Ø¦Û’ Ù…ÛÛŒÙ†ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(461060,12808,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¼ÐµÑÐµÑ†Ð¸ Ð·Ð° Ð¼Ð°ÐºÑÐ¸Ð¼ÑƒÐ¼ Ð½Ð° Ñ€ÑƒÑ†Ð¸',0),(461061,12808,'vi','sá»‘ thÃ¡ng tá»‘i Ä‘a hiá»‡n cÃ³',0),(461062,12808,'af','Aantal maande vir maksimum op Hand',0),(461063,12808,'ro','NumÄƒrul de luni pentru maxim pe mÃ¢nÄƒ',0),(461064,12808,'et','Kuuks ja maksimaalselt kÃ¤si number',0),(461065,12808,'si','Å tevilo mesecev, za najveÄ na roko',0),(461066,12808,'ba','Beberapa bulan untuk maksimum di tangan',0),(461067,12808,'nl','Aantal maanden voor Maximum aan de kant',0),(461068,12808,'fi','Useita kuukausia enintÃ¤Ã¤n kÃ¤sillÃ¤',0),(461069,12808,'no','Antall mÃ¥neder For maksimum beholdning',0),(461070,12808,'da','Antallet af mÃ¥neder For maksimum pÃ¥ hÃ¥nd',0),(461071,12808,'ko','ë°˜ë©´ì— ìµœëŒ€ì— ëŒ€ í•œ ê°œì›” ìˆ˜',0),(461072,12808,'he','×ž×¡×¤×¨ ×”×—×•×“×©×™× ×ž×§×¡×™×ž×œ×™×ª ×¢×œ ×”×™×“',0),(461073,12808,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î¼Î·Î½ÏŽÎ½ Î³Î¹Î± Î¼Î­Î³Î¹ÏƒÏ„Î· Î±Ï†',0),(461074,12808,'zh','æ‰‹ä¸Šæœ€å¤§çš„æœˆæ•°',0),(461075,12808,'sv','Antalet mÃ¥nader fÃ¶r maximal Ã¥',0),(461076,12808,'it','Numero di mesi per massimo sulla mano',0),(461077,12808,'tl','',0),(461078,12808,'th','à¸ˆà¸³à¸™à¸§à¸™à¹€à¸”à¸·à¸­à¸™à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¸„à¸£à¸­à¸‡',0),(461079,12808,'hi','à¤¹à¤¾à¤¥ à¤ªà¤° à¤…à¤§à¤¿à¤•à¤¤à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¹à¥€à¤¨à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(461080,12808,'ms','Bilangan bulan maksimum pada tangan',0),(461081,12808,'ar','Ø¹Ø¯Ø¯ Ù…Ù† Ø£Ø´Ù‡Ø± Ù„Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ø¹Ù„Ù‰ ÙŠØ¯',0),(461082,12808,'fr','Nombre de mois pour Maximum sur la main',0),(461083,12808,'jp','æ•°ãƒ¶æœˆæœ€å¤§æ‰‹',0),(461084,12808,'pt','NÃºmero de meses para mÃ¡ximo na mÃ£o',0),(461085,12808,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¼ÐµÑÑÑ†ÐµÐ² Ð´Ð»Ñ Ð¼Ð°ÐºÑÐ¸Ð¼ÑƒÐ¼ Ð½Ð° Ñ€ÑƒÐºÐµ',0),(461086,12808,'es','NÃºmero de Meses Para MÃ¡ximo Disponible',0),(461087,12808,'de','Anzahl der Monate fÃ¼r maximal auf der Seite',0),(461088,12808,'en','Number Of Months For Maximum On Hand',0),(461089,12809,'is','',0),(461090,12809,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù…Ø§Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ø­Ø¯Ø§Ù‚Ù„ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(461091,12809,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù…Ø§Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ø­Ø¯Ø§Ù‚Ù„ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(461092,12809,'tr','Minimum eldeki ay sayÄ±sÄ±',0),(461093,12809,'pl','Liczba miesiÄ™cy minimum na rÄ™kÄ™',0),(461094,12809,'bg','Ð‘Ñ€Ð¾ÑÑ‚ Ð½Ð° Ð¼ÐµÑÐµÑ†Ð¸Ñ‚Ðµ Ð·Ð° Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼ Ð½Ð° Ñ€ÑŠÐºÐ°',0),(461095,12809,'ur','ÛØ§ØªÚ¾ Ù¾Ø± Ú©Ù… Ø§Ø² Ú©Ù… Ú©Û’ Ù„Ø¦Û’ Ù…ÛÛŒÙ†ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(461096,12809,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¼ÐµÑÐµÑ†Ð¸ Ð·Ð° ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼ Ð½Ð° Ñ€ÑƒÑ†Ð¸',0),(461097,12809,'vi','sá»‘ thÃ¡ng Ã­t nháº¥t hiá»‡n cÃ³',0),(461098,12809,'af','Aantal maande vir Minimum op Hand',0),(461099,12809,'ro','NumÄƒrul de luni pentru minim pe parte',0),(461100,12809,'et','Kuu miinimum kÃ¤si number',0),(461101,12809,'si','Å tevilo mesecev za najmanj na roko',0),(461102,12809,'ba','Beberapa bulan untuk Minimum di tangan',0),(461103,12809,'nl','Aantal maanden voor Minimum aan de kant',0),(461104,12809,'fi','MÃ¤Ã¤rÃ¤Ã¤ pienin varastosaldo',0),(461105,12809,'no','Antall mÃ¥neder For Minimum tilgjengelig',0),(461106,12809,'da','Antallet af mÃ¥neder For Minimum pÃ¥ hÃ¥nd',0),(461107,12809,'ko','í•œíŽ¸ ìµœì†Œì— ëŒ€ í•œ ê°œì›” ìˆ˜',0),(461108,12809,'he','×ž×¡×¤×¨ ×—×•×“×©×™× ×œ×›×œ ×”×¤×—×•×ª ×¢×œ ×”×™×“',0),(461109,12809,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î¼Î·Î½ÏŽÎ½ Î³Î¹Î± ÎµÎ»Î¬Ï‡Î¹ÏƒÏ„Î¿ Î±Ï†',0),(461110,12809,'zh','æ‰‹ä¸Šçš„æœ€ä½Žçš„æœˆæ•°',0),(461111,12809,'sv','Antal mÃ¥nader fÃ¶r Minimum pÃ¥ Hand',0),(461112,12809,'it','Numero di mesi per minimo sulla mano',0),(461113,12809,'tl','',0),(461114,12809,'th','à¸ˆà¸³à¸™à¸§à¸™à¹€à¸”à¸·à¸­à¸™à¸™à¹‰à¸­à¸¢à¸„à¸‡',0),(461115,12809,'hi','à¤¹à¤¾à¤¥ à¤ªà¤° à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¹à¥€à¤¨à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(461116,12809,'ms','Beberapa bulan untuk sekurang-kurangnya pada tangan',0),(461117,12809,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø£Ø´Ù‡Ø± Ù„Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† Ù†Ø§Ø­ÙŠØ©',0),(461118,12809,'fr','Nombre de mois pendant au moins sur la main',0),(461119,12809,'jp','æ•°ãƒ¶æœˆæœ€ä½Žæ‰‹',0),(461120,12809,'pt','NÃºmero de meses para mÃ­nimo na mÃ£o',0),(461121,12809,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¼ÐµÑÑÑ†ÐµÐ² Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼ Ð½Ð° Ñ€ÑƒÐºÐµ',0),(461122,12809,'es','NÃºmero de Meses Para Minimo Disponible',0),(461123,12809,'de','Anzahl der Monate fÃ¼r mindestens auf Hand',0),(461124,12809,'en','Number Of Months For Minimum On Hand',0),(461125,12810,'is','',0),(461126,12810,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù…Ø§Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ø­Ø¯Ø§Ú©Ø«Ø± Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(461127,12810,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù…Ø§Ù‡ Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ø­Ø¯Ø§Ú©Ø«Ø± Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ù…Ø¬Ø¯Ø¯',0),(461128,12810,'tr','Ay iÃ§in yeniden sipariÅŸ miktarÄ±',0),(461129,12810,'pl','Liczba miesiÄ™cy iloÅ›Ä‡ ponownego zamÃ³wienia',0),(461130,12810,'bg','Ð‘Ñ€Ð¾ÑÑ‚ Ð½Ð° Ð¼ÐµÑÐµÑ†Ð¸Ñ‚Ðµ Ð·Ð° Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡Ð°Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(461131,12810,'ur','Ø±ÛŒÚ©Ø§Ø±ÚˆØ± Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ú©Û’ Ù„Ø¦Û’ Ù…ÛÛŒÙ†ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(461132,12810,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¼ÐµÑÐµÑ†Ð¸ Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(461133,12810,'vi','sá»‘ thÃ¡ng cho cháº¥t lÆ°á»£ng Ä‘Æ¡n hÃ ng Ä‘áº·t láº¡i',0),(461134,12810,'af','Aantal maande vir herrangskik hoeveelheid',0),(461135,12810,'ro','NumÄƒrul de luni de reluare a comenzii cantitate',0),(461136,12810,'et','Mitu kuud kordustellimuse kogus',0),(461137,12810,'si','Å tevilo mesecev za koliÄina vnoviÄnega naroÄila',0),(461138,12810,'ba','Beberapa bulan untuk menyusun ulang kuantitas',0),(461139,12810,'nl','Aantal maanden voor bestelaantal',0),(461140,12810,'fi','Useita kuukausia uusintatil. mÃ¤Ã¤rÃ¤',0),(461141,12810,'no','Antall mÃ¥neder For gjenbestilling',0),(461142,12810,'da','Antallet af mÃ¥neder For ordrekvantummet',0),(461143,12810,'ko','ìž¬ì£¼ë¬¸ ìˆ˜ëŸ‰ì— ëŒ€ í•œ ê°œì›” ìˆ˜',0),(461144,12810,'he','×ž×¡×¤×¨ ×”×—×•×“×©×™× ×¢×‘×•×¨ ×—×™×“×•×© ×›×ž×•×ª',0),(461145,12810,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î¼Î·Î½ÏŽÎ½ Î³Î¹Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(461146,12810,'zh','å‡ ä¸ªæœˆçš„å†è®¢è´­æ•°é‡',0),(461147,12810,'sv','Antalet mÃ¥nader fÃ¶r ordna kvantitet',0),(461148,12810,'it','Numero di mesi per quantitÃ  di riordino',0),(461149,12810,'tl','',0),(461150,12810,'th','à¸ˆà¸³à¸™à¸§à¸™à¹€à¸”à¸·à¸­à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸µà¹ˆà¸ªà¸±à¹ˆà¸‡',0),(461151,12810,'hi','à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¹à¥€à¤¨à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(461152,12810,'ms','Beberapa bulan untuk susun semula kuantiti',0),(461153,12810,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø£Ø´Ù‡Ø± Ù„ÙƒÙ…ÙŠØ© Ø¥Ø¹Ø§Ø¯Ø© ØªØ±ØªÙŠØ¨',0),(461154,12810,'fr','Nombre de mois pour rÃ©organiser quantitÃ©',0),(461155,12810,'jp','æ•°ãƒ¶æœˆã®å†ç™ºæ³¨æ•°é‡',0),(461156,12810,'pt','NÃºmero de meses para reordenar quantidade',0),(461157,12810,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¼ÐµÑÑÑ†ÐµÐ² Ð´Ð»Ñ Ð´Ð¾Ð·Ð°ÐºÐ°Ð·Ð° ÐšÐ¾Ð»-Ð²Ð¾',0),(461158,12810,'es','NÃºmero de Meses Para Cantidad de Reordenar',0),(461159,12810,'de','Anzahl der Monate fÃ¼r Bestellmenge',0),(461160,12810,'en','Number Of Months For Reorder Quantity',0),(461161,12811,'is','',0),(461162,12811,'dr','ÙØ±Ø§ÛŒÙ†Ø¯ Ú©Ø§Ù…Ù„ Ø´Ø¯',0),(461163,12811,'pr','ÙØ±Ø§ÛŒÙ†Ø¯ Ú©Ø§Ù…Ù„ Ø´Ø¯',0),(461164,12811,'tr','Ä°ÅŸlem tamamlandÄ±',0),(461165,12811,'pl','Kompletny proces',0),(461166,12811,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑÑŠÑ‚ Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸',0),(461167,12811,'ur','Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ù…Ú©Ù…Ù„',0),(461168,12811,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚ÑƒÐ¿ÐºÐ°',0),(461169,12811,'vi','hoÃ n thÃ nh xá»­ lÃ½',0),(461170,12811,'af','Proses voltooi',0),(461171,12811,'ro','Procesul complet',0),(461172,12811,'et','Protsess valmis',0),(461173,12811,'si','Celoten proces',0),(461174,12811,'ba','Proses lengkap',0),(461175,12811,'nl','Proces voltooid',0),(461176,12811,'fi','Toiminto valmis',0),(461177,12811,'no','Prosessen fullfÃ¸rt',0),(461178,12811,'da','Proces fuldstÃ¦ndig',0),(461179,12811,'ko','í”„ë¡œì„¸ìŠ¤ ì™„ë£Œ',0),(461180,12811,'he','×ª×”×œ×™×š ×©×œ×',0),(461181,12811,'el','Î Î»Î®ÏÎ· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±',0),(461182,12811,'zh','è¿‡ç¨‹å®Œæˆ',0),(461183,12811,'sv','Processen komplett',0),(461184,12811,'it','Processo completo',0),(461185,12811,'tl','',0),(461186,12811,'th','à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(461187,12811,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤ªà¥‚à¤°à¥à¤£',0),(461188,12811,'ms','Proses lengkap',0),(461189,12811,'ar','Ø§ÙƒØªÙ…Ø§Ù„ Ø¹Ù…Ù„ÙŠØ©',0),(461190,12811,'fr','Processus complet',0),(461191,12811,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã®å®Œäº†',0),(461192,12811,'pt','Processo completo',0),(461193,12811,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ Ð¿Ð¾Ð»Ð½Ð¾Ð¹',0),(461194,12811,'es','Proceso Completo',0),(461195,12811,'de','Prozess abgeschlossen',0),(461196,12811,'en','Process Complete',0),(461197,12812,'is','',0),(461198,12812,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ø±ÛŒØ¯Ø§Ø± Ø§Ø²Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ´ Ù‡Ø§',0),(461199,12812,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø®Ø±ÛŒØ¯Ø§Ø± Ø§Ø²Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ´ Ù‡Ø§',0),(461200,12812,'tr','SatÄ±ÅŸ toplamlarÄ±, mÃ¼ÅŸteri raporu',0),(461201,12812,'pl','Klienta Raport podsumowania sprzedaÅ¼y',0),(461202,12812,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ð° Ð¾Ð±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(461203,12812,'ur','Ø³ÛŒÙ„Ø² Ù…ÛŒØ²Ø§Ù† Ú©Û’ Ú¯Ø§ÛÚ© Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(461204,12812,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÐºÑƒÐ¿Ð°Ñ† Ð·Ð° ÑƒÐºÑƒÐ¿Ð½Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(461205,12812,'vi','tá»•ng sá»‘ bÃ¡o cÃ¡o bÃ¡n hÃ ng',0),(461206,12812,'af','KliÃ«nt verslag van totale verkope',0),(461207,12812,'ro','Client raport de vÃ¢nzÄƒri totaluri',0),(461208,12812,'et','Kliendi aruanne mÃ¼Ã¼gi kogusummad',0),(461209,12812,'si','PoroÄilo o strankah prodajne vsote',0),(461210,12812,'ba','Laporan pelanggan dari total penjualan',0),(461211,12812,'nl','Klant verslag van verkooptotalen',0),(461212,12812,'fi','Myynnin raportti asiakkaan',0),(461213,12812,'no','Kunden rapport av totalt salg',0),(461214,12812,'da','Kunde betÃ¦nkning af salgstotaler',0),(461215,12812,'ko','ì´ ë§¤ì¶œì˜ ê³ ê° ë³´ê³ ì„œ',0),(461216,12812,'he','×œ×§×•×—×•×ª ×“×•×— ×©×œ ×¡×›×•×ž×™ ×ž×›×™×¨×•×ª',0),(461217,12812,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· Ï„Î·Ï‚ Ï„Î± ÏƒÏÎ½Î¿Î»Î± Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(461218,12812,'zh','å®¢æˆ·æŠ¥å‘Šçš„æ€»é”€å”®é¢',0),(461219,12812,'sv','Rapport av fÃ¶rsÃ¤ljningssummor',0),(461220,12812,'it','Rapporto di cliente di vendite totali',0),(461221,12812,'tl','',0),(461222,12812,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸¢à¸­à¸”à¸‚à¸²à¸¢à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(461223,12812,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¯à¥‹à¤— à¤•à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(461224,12812,'ms','Baca Laporan daripada jumlah jualan',0),(461225,12812,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…Ù† Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(461226,12812,'fr','Rapport de client du total des ventes',0),(461227,12812,'jp','é¡§å®¢ã®å£²ä¸Šåˆè¨ˆã®ãƒ¬ãƒãƒ¼ãƒˆ',0),(461228,12812,'pt','Cliente relatÃ³rio de totais de vendas',0),(461229,12812,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‡Ð¸Ðº Ð´Ð¾ÐºÐ»Ð°Ð´Ðµ Ð¸Ñ‚Ð¾Ð³Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(461230,12812,'es','Informe de Cliente de Totales de Ventas',0),(461231,12812,'de','Kundenbericht der GesamtumsÃ¤tze',0),(461232,12812,'en','Customer Report Of Sales Totals',0),(461233,12813,'is','',0),(461234,12813,'dr','12 Ù…Ø§Ù‡Ù‡ ØªØ§Ø±ÛŒØ®Ú†Ù‡ ÙØ±ÙˆØ´ Ø®Ø±ÛŒØ¯Ø§Ø± Ø¨Ø±Ø§ÛŒ',0),(461235,12813,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ÛŒ 12 Ù…Ø§Ù‡Ù‡ ØªØ§Ø±ÛŒØ®Ú†Ù‡ ÙØ±ÙˆØ´ Ø®Ø±ÛŒØ¯Ø§Ø± Ø¨Ø±Ø§ÛŒ',0),(461236,12813,'tr','Stok 12 aylÄ±k mÃ¼ÅŸteri satÄ±ÅŸ geÃ§miÅŸi',0),(461237,12813,'pl','Spis 12 miesiÄ™cy klient historii sprzedaÅ¼y dla',0),(461238,12813,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ 12 Ð¼ÐµÑÐµÑ† ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°Ñ‚Ð° Ð·Ð°',0),(461239,12813,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ 12 Ù…Ø§Û Ú©Ø³Ù¹Ù…Ø± Ø³ÛŒÙ„Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(461240,12813,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° 12 Ð¼ÐµÑÐµÑ†Ð¸ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÐºÑƒÐ¿Ñ†Ñƒ Ð·Ð°',0),(461241,12813,'vi','lá»‹ch sá»­ bÃ¡n hÃ ng 12 thÃ¡ng theo khÃ¡ch hÃ ng',0),(461242,12813,'af','Inventaris 12 maand kliÃ«nt verkope geskiedenis vir',0),(461243,12813,'ro','Inventarul istoric vÃ¢nzÄƒri client 12 luni pentru',0),(461244,12813,'et','Lao 12 kuu mÃ¼Ã¼k kliendile â€“ ajalugu jaoks',0),(461245,12813,'si','Zaloge 12 mesec Zgodovina prodaje kupcu za',0),(461246,12813,'ba','Persediaan 12 bulan sejarah pelanggan penjualan untuk',0),(461247,12813,'nl','Inventaris 12 maand Verkoophistorie klant voor',0),(461248,12813,'fi','Varaston 12 kuukauden Asiakkaan myyntihistoria varten',0),(461249,12813,'no','Lager 12 mÃ¥neders kundesalg For',0),(461250,12813,'da','Beholdning 12 mÃ¥ned kunde salgshistorik For',0),(461251,12813,'ko','12 ì›” ê³ ê° íŒë§¤ ì—­ì‚¬ì— ëŒ€ í•œ ìž¬ê³ ',0),(461252,12813,'he','×ž×œ××™ 12 ×—×•×“×©×™× ×”×œ×§×•×— ×”×™×¡×˜×•×¨×™×™×ª ×ž×›×™×¨×•×ª ×¢×‘×•×¨',0),(461253,12813,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® 12 Î¼Î®Î½Î± Î¹ÏƒÏ„Î¿ÏÎ¯Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€ÎµÎ»Î¬Ï„Î· Î³Î¹Î±',0),(461254,12813,'zh','åº“å­˜ä¸º 12 ä¸ªæœˆå®¢æˆ·é”€å”®åŽ†å²è®°å½•',0),(461255,12813,'sv','Inventering 12 mÃ¥naders KundfÃ¶rsÃ¤ljningshistorik fÃ¶r',0),(461256,12813,'it','Inventario 12 mese vendite cliente di storia per',0),(461257,12813,'tl','',0),(461258,12813,'th','à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸à¸²à¸£à¸‚à¸²à¸¢à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸² 12 à¹€à¸”à¸·à¸­à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸ªà¸³à¸«à¸£à¸±à¸š',0),(461259,12813,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ 12 à¤®à¤¹à¥€à¤¨à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(461260,12813,'ms','Inventori 12 bulan pelanggan jualan sejarah bagi',0),(461261,12813,'ar','12 ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„ ÙÙŠ Ø§Ù„Ø´Ù‡Ø± Ù„Ù„Ù…Ø®Ø²ÙˆÙ†',0),(461262,12813,'fr','12 mois l\'inventaire client historique de ventes pour',0),(461263,12813,'jp','12 æœˆé¡§å®¢è²©å£²ã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªå±¥æ­´',0),(461264,12813,'pt','12 mÃªs cliente histÃ³rico de vendas para o inventÃ¡rio',0),(461265,12813,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ 12 Ð¼ÐµÑÑÑ†Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ',0),(461266,12813,'es','Inventario 12 meses Ventas de Clientes Historia Para',0),(461267,12813,'de','Inventar 12 Monate Kunde Vertriebshistorie fÃ¼r',0),(461268,12813,'en','Inventory 12 Month Customer Sales History For',0),(461269,12814,'is','',0),(461270,12814,'dr','12 Ù…Ø§Ù‡Ù‡ ØªØ§  ØªØ§Ø±ÛŒØ®Ú†Ù‡ ÙØ±ÙˆØ´  Ø¨Ø±Ø§ÛŒ',0),(461271,12814,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ÛŒ 12 Ù…Ø§Ù‡Ù‡ ØªØ§  ØªØ§Ø±ÛŒØ®Ú†Ù‡ ÙØ±ÙˆØ´  Ø¨Ø±Ø§ÛŒ',0),(461272,12814,'tr','Stok 12 aylÄ±k birim satÄ±ÅŸ geÃ§miÅŸi',0),(461273,12814,'pl','12 miesiÄ…c Jednostka sprzedaÅ¼y historia dla zapasÃ³w',0),(461274,12814,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ 12 Ð¼ÐµÑÐµÑ†Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð·Ð°',0),(461275,12814,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ 12 Ù…Ø§Û ÛŒÙˆÙ†Ù¹ ÙØ±ÙˆØ®Øª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(461276,12814,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° 12 Ð¼ÐµÑÐµÑ†Ð¸ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð°',0),(461277,12814,'vi','Lá»‹ch sá»­ bÃ¡n hÃ ng 12 thÃ¡ng theo Ä‘Æ¡n vá»‹',0),(461278,12814,'af','Inventaris 12 maand eenheid verkope geskiedenis vir',0),(461279,12814,'ro','Inventarul 12 luni unitate istoric vÃ¢nzÄƒri pentru',0),(461280,12814,'et','Lao 12-kuulise Ã¼hiku mÃ¼Ã¼gi ajaloos jaoks',0),(461281,12814,'si','Zaloge 12 mesec enota Zgodovina prodaje za',0),(461282,12814,'ba','Persediaan 12 bulan Unit penjualan sejarah untuk',0),(461283,12814,'nl','Inventaris 12 maand eenheid verkoophistorie voor',0),(461284,12814,'fi','Varaston 12 kuukauden yksikÃ¶n myynti historia',0),(461285,12814,'no','Lager 12 mÃ¥neders enhet Salgshistorikk For',0),(461286,12814,'da','Beholdning 12 mÃ¥neders enhed salgshistorik For',0),(461287,12814,'ko','ìž¬ê³  12 ê°œì›” ë‹¨ìœ„ íŒë§¤ ì—­ì‚¬ì— ëŒ€ í•œ',0),(461288,12814,'he','×ž×œ××™ 12 ×—×•×“×©×™× ×™×—×™×“×ª ×”×™×¡×˜×•×¨×™×™×ª ×ž×›×™×¨×•×ª ×¢×‘×•×¨',0),(461289,12814,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® 12 Î¼Î®Î½Î± Î¹ÏƒÏ„Î¿ÏÎ¯Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î¼Î¿Î½Î¬Î´Î± Î³Î¹Î±',0),(461290,12814,'zh','åº“å­˜ä¸º 12 ä¸ªæœˆå•ä½é”€å”®åŽ†å²è®°å½•',0),(461291,12814,'sv','Inventering 12 mÃ¥naders enhet FÃ¶rsÃ¤ljningshistorik fÃ¶r',0),(461292,12814,'it','Inventario mese 12 unitÃ  vendite di storia per',0),(461293,12814,'tl','',0),(461294,12814,'th','à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸à¸²à¸£à¸‚à¸²à¸¢à¸‚à¸­à¸‡à¸«à¸™à¹ˆà¸§à¸¢ 12 à¹€à¸”à¸·à¸­à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸ªà¸³à¸«à¸£à¸±à¸š',0),(461295,12814,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ 12 à¤®à¤¹à¥€à¤¨à¥‡ à¤‡à¤•à¤¾à¤ˆ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤•à¥‡ à¤²à¤¿à¤',0),(461296,12814,'ms','Inventori 12 bulan Unit jualan sejarah bagi',0),(461297,12814,'ar','12 Ø´Ù‡Ø± ÙˆØ­Ø¯Ø© ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„Ù„Ù…Ø®Ø²ÙˆÙ†',0),(461298,12814,'fr','L\'inventaire 12 mois unitÃ© historique des ventes pour',0),(461299,12814,'jp','12 æœˆå˜ä½“å£²ã‚Šä¸Šã’é«˜ã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªå±¥æ­´',0),(461300,12814,'pt','Unidade mÃªs 12 histÃ³rico de vendas para o inventÃ¡rio',0),(461301,12814,'ru','ÐŸÐ¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¶ÑƒÑ€Ð½Ð°Ð» Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ 12 Ð¼ÐµÑÑÑ†ÐµÐ² Ð´Ð»Ñ',0),(461302,12814,'es','Inventario 12 meses Ventas de Unidades Historia Para',0),(461303,12814,'de','Inventar 12-monatigen Einheit Vertriebshistorie fÃ¼r',0),(461304,12814,'en','Inventory 12 Month Unit Sales History For',0),(461305,12815,'is','',0),(461306,12815,'dr','12 Ù…Ø§Ù‡Ù‡ Ù…ÙˆÚ†ÙˆØ¯ÛŒ Ø¬Ù†Ø³',0),(461307,12815,'pr','ÙØ±ÙˆØ´ 12 Ù…Ø§Ù‡Ù‡ Ù…ÙˆÚ†ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(461308,12815,'tr','Madde satÄ±ÅŸlarÄ± - 12 aylÄ±k',0),(461309,12815,'pl','SprzedaÅ¼ zapasÃ³w - dwunastomiesiÄ™czne',0),(461310,12815,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ - 12 Ð¼ÐµÑÐµÑ†Ð°',0),(461311,12815,'ur','Ø´Û’ Ú©ÛŒ ÙØ±ÙˆØ®Øª - 12 Ù…Ø§Û',0),(461312,12815,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° - 12 Ð¼ÐµÑÐµÑ†Ð¸',0),(461313,12815,'vi','hÃ ng bÃ¡n 12 thÃ¡ng',0),(461314,12815,'af','Item verkope - 12 maande',0),(461315,12815,'ro','Element de vÃ¢nzÄƒri - 12 luni',0),(461316,12815,'et','Kaupade mÃ¼Ã¼k - 12 kuu',0),(461317,12815,'si','Prodaje artikla - 12 mesec',0),(461318,12815,'ba','Penjualan barang - 12 bulan',0),(461319,12815,'nl','Artikelverkoop - 12 maand',0),(461320,12815,'fi','Nimikkeen myynti - 12 kuukauden',0),(461321,12815,'no','Varesalg - 12 mÃ¥neder',0),(461322,12815,'da','Varesalg - 12 mÃ¥neders',0),(461323,12815,'ko','í•­ëª© íŒë§¤-12 ê°œì›”',0),(461324,12815,'he','×¤×¨×™×˜ ×ž×›×™×¨×•×ª - 12 ×—×•×“×©×™×',0),(461325,12815,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ - 12 Î¼Î·Î½ÏŽÎ½',0),(461326,12815,'zh','é¡¹ç›®é”€å”®-12 ä¸ªæœˆ',0),(461327,12815,'sv','ArtikelfÃ¶rsÃ¤ljning - 12 mÃ¥naders',0),(461328,12815,'it','Vendite - 12 mesi',0),(461329,12815,'tl','',0),(461330,12815,'th','à¸‚à¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸² - 12 à¹€à¸”à¸·à¸­à¸™',0),(461331,12815,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ - 12 à¤®à¤¹à¥€à¤¨à¥‡',0),(461332,12815,'ms','Item jualan - 12 bulan',0),(461333,12815,'ar','Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø£ØµÙ†Ø§Ù-12 Ø´Ù‡Ø±',0),(461334,12815,'fr','Point de ventes - 12 mois',0),(461335,12815,'jp','é …ç›®ã®è²©å£² - 12 æœˆ',0),(461336,12815,'pt','Vendas de itens - 12 meses',0),(461337,12815,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ - 12 Ð¼ÐµÑÑÑ†ÐµÐ²',0),(461338,12815,'es','Ventas de Inventario 12 Meses',0),(461339,12815,'de','ArtikelverkÃ¤ufe - 12 Monate',0),(461340,12815,'en','Item Sales - 12 Month',0),(461341,12816,'is','',0),(461342,12816,'dr','Ú¯Ø²Ø§Ø±Ø´ Ú©Ø§Ù„Ø§Ø§Ø² ÙˆØ§Ø­Ø¯Ù‡Ø§ÛŒ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡',0),(461343,12816,'pr','Ú¯Ø²Ø§Ø±Ø´ Ú©Ø§Ù„Ø§Ø§Ø² ÙˆØ§Ø­Ø¯Ù‡Ø§ÛŒ ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡',0),(461344,12816,'tr','Ã–ÄŸe rapor birimleri sattÄ±',0),(461345,12816,'pl','Element raportu jednostek sprzedanych',0),(461346,12816,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð´Ð¾ÐºÐ»Ð°Ð´ Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸, Ð¿Ñ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¸',0),(461347,12816,'ur','Ø´Û’ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹ ÛŒÙˆÙ†Ù¹ÙˆÚº Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(461348,12816,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ñ˜Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¾.',0),(461349,12816,'vi','bÃ¡o cÃ¡o Ä‘Æ¡n vá»‹ hÃ ng Ä‘Ã£ bÃ¡n',0),(461350,12816,'af','Item verslag van eenhede verkoop',0),(461351,12816,'ro','Articol raport de unitÄƒÅ£i vÃ¢ndute',0),(461352,12816,'et','Ãœksuse aruande Ã¼hikut mÃ¼Ã¼dud',0),(461353,12816,'si','PoroÄilo element enot prodanih',0),(461354,12816,'ba','Item laporan unit dijual',0),(461355,12816,'nl','Item verslag van eenheden verkocht',0),(461356,12816,'fi','Nimikkeen raportti yksikkÃ¶Ã¤ myydÃ¤Ã¤n',0),(461357,12816,'no','Elementet rapporten enheter solgt',0),(461358,12816,'da','Punkt pÃ¥ dagsordenen betÃ¦nkning af enheder solgt',0),(461359,12816,'ko','ë‹¨ìœ„ í•­ëª© ë³´ê³ ì„œ íŒë§¤',0),(461360,12816,'he','×“×•×— ×¤×¨×™×˜×™× ×©×œ ×™×—×™×“×•×ª ×©× ×ž×›×¨×•',0),(461361,12816,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î­ÎºÎ¸ÎµÏƒÎ· Ï„Ï‰Î½ Î¼Î¿Î½Î¬Î´Ï‰Î½ Ï€Î¿Ï… Ï€Ï‰Î»Î¿ÏÎ½Ï„Î±Î¹',0),(461362,12816,'zh','é¡¹ç›®æŠ¥å‘Šçš„å•ä½å‡ºå”®',0),(461363,12816,'sv','Objektet rapport av enheter sÃ¤ljs',0),(461364,12816,'it','Rapporto di elemento di unitÃ  vendute',0),(461365,12816,'tl','',0),(461366,12816,'th','à¸‚à¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²à¸£à¸²à¸¢à¸‡à¸²à¸™à¸‚à¸­à¸‡à¸«à¸™à¹ˆà¸§à¸¢',0),(461367,12816,'hi','à¤¬à¥‡à¤šà¤¾ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤•à¥‡ à¤†à¤‡à¤Ÿà¤® à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(461368,12816,'ms','Perkara laporan unit dijual',0),(461369,12816,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø¨Ù†Ø¯ Ù„Ù„ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù…Ø¨Ø§Ø¹Ø©',0),(461370,12816,'fr','Point de rapport des unitÃ©s vendues',0),(461371,12816,'jp','é …ç›®å˜ä½ã®ãƒ¬ãƒãƒ¼ãƒˆã‚’è²©å£²',0),(461372,12816,'pt','Item relatÃ³rio de unidades vendidas',0),(461373,12816,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð´Ð¾ÐºÐ»Ð°Ð´ ÐµÐ´Ð¸Ð½Ð¸Ñ† Ð¿Ñ€Ð¾Ð´Ð°Ð½Ð¾',0),(461374,12816,'es','Item Informe de Unidades Vendidos',0),(461375,12816,'de','Top Bericht des Einheiten verkauft',0),(461376,12816,'en','Item Report Of Units Sold',0),(461377,12817,'is','',0),(461378,12817,'dr','Ù„ØºÙˆ ÛŒØ§ Ø­Ø°Ù',0),(461379,12817,'pr','Ù„ØºÙˆ ÛŒØ§ Ø­Ø°Ù',0),(461380,12817,'tr','Ä°ptal veya KaldÄ±r',0),(461381,12817,'pl','Anuluj lub usuÅ„',0),(461382,12817,'bg','ÐžÑ‚ÐºÐ°Ð· Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ',0),(461383,12817,'ur','Ù…Ù†Ø³ÙˆØ® ÛŒØ§ ÛÙ¹Ø§Ø¦ÛŒÚº',0),(461384,12817,'sr','ÐžÑ‚ÐºÐ°Ð¶Ð¸\"Ð¸Ð»Ð¸\" Ð£ÐºÐ»Ð¾Ð½Ð¸',0),(461385,12817,'vi','Há»§y hoáº·c di chuyá»ƒn',0),(461386,12817,'af','Kanselleer of verwyder',0),(461387,12817,'ro','Revocare sau eliminare',0),(461388,12817,'et','Loobu vÃµi eemaldamine',0),(461389,12817,'si','PrekliÄi ali odstrani',0),(461390,12817,'ba','Batal atau Hapus',0),(461391,12817,'nl','Annuleren of verwijderen',0),(461392,12817,'fi','Peruuta tai poista',0),(461393,12817,'no','Avbryt eller fjern',0),(461394,12817,'da','Annuller eller fjern',0),(461395,12817,'ko','ì·¨ì†Œ ë˜ëŠ” ì œê±°',0),(461396,12817,'he','×‘×™×˜×•×œ ××• ×”×¡×¨×”',0),(461397,12817,'el','Î‘ÎºÏ…ÏÏŽÏƒÏ„Îµ Î® ÎºÎ±Ï„Î¬ÏÎ³Î·ÏƒÎ·',0),(461398,12817,'zh','å–æ¶ˆæˆ–åˆ é™¤',0),(461399,12817,'sv','Avbryt eller ta bort',0),(461400,12817,'it','Annulla o Rimuovi',0),(461401,12817,'tl','',0),(461402,12817,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¸«à¸£à¸·à¸­à¸¥à¸š',0),(461403,12817,'hi','à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚',0),(461404,12817,'ms','Batal atau alih keluar',0),(461405,12817,'ar','Ø¥Ù„ØºØ§Ø¡ Ø£Ùˆ Ø¥Ø²Ø§Ù„Ø©',0),(461406,12817,'fr','Annuler ou supprimer',0),(461407,12817,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã¾ãŸã¯å‰Šé™¤ã—ã¾ã™ã€‚',0),(461408,12817,'pt','Cancelar ou remover',0),(461409,12817,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¸Ð»Ð¸ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ',0),(461410,12817,'es','Cancela o Quita',0),(461411,12817,'de','Abbrechen oder entfernen',0),(461412,12817,'en','Cancel Or Remove',0),(461413,12818,'is','',0),(461414,12818,'dr','Ø­Ø°Ù Ú©Ø§Ù„Ø§ Ø¨Ø± Ø§Ø³Ø§Ø³ Ú¯Ø±ÙˆÙ‡',0),(461415,12818,'pr','Ø­Ø°Ù Ú©Ø§Ù„Ø§ Ø¨Ø± Ø§Ø³Ø§Ø³ Ú¯Ø±ÙˆÙ‡',0),(461416,12818,'tr','Ã–ÄŸeleri silme',0),(461417,12818,'pl','Usuwanie elementÃ³w',0),(461418,12818,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(461419,12818,'ur','Ø§Ø´ÛŒØ§ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(461420,12818,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(461421,12818,'vi','hÃ ng ra khá»i danh sÃ¡ch',0),(461422,12818,'af','Skrap Items',0),(461423,12818,'ro','È˜tergere elemente',0),(461424,12818,'et','Ãœksuste kustutamine',0),(461425,12818,'si','IzbriÅ¡ite elemente',0),(461426,12818,'ba','Menghapus item',0),(461427,12818,'nl','Items verwijderen',0),(461428,12818,'fi','Kohteiden poistaminen',0),(461429,12818,'no','Slette elementer',0),(461430,12818,'da','Slette elementer',0),(461431,12818,'ko','í•­ëª© ì‚­ì œ',0),(461432,12818,'he','×ž×—×§ ×¤×¨×™×˜×™×',0),(461433,12818,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(461434,12818,'zh','åˆ é™¤é¡¹ç›®',0),(461435,12818,'sv','Ta bort objekt',0),(461436,12818,'it','Eliminare gli elementi',0),(461437,12818,'tl','',0),(461438,12818,'th','à¸¥à¸šà¸£à¸²à¸¢à¸à¸²à¸£',0),(461439,12818,'hi','à¤†à¤‡à¤Ÿà¤® à¤¹à¤Ÿà¤¾à¤à¤',0),(461440,12818,'ms','Menghapuskan item',0),(461441,12818,'ar','Ø­Ø°Ù Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(461442,12818,'fr','Supprimer des Ã©lÃ©ments',0),(461443,12818,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(461444,12818,'pt','Excluir itens',0),(461445,12818,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(461446,12818,'es','Item Eliminar por CategorÃ­a',0),(461447,12818,'de','LÃ¶schen von Elementen',0),(461448,12818,'en','Delete Items',0),(461449,12819,'is','',0),(461450,12819,'dr','Ø§ÛŒØ¬Ø§Ø¯ ØªØºÛŒÛŒØ±Ø§Øª',0),(461451,12819,'pr','Ø§ÛŒØ¬Ø§Ø¯ ØªØºÛŒÛŒØ±Ø§Øª',0),(461452,12819,'tr','DeÄŸiÅŸiklik yapma',0),(461453,12819,'pl','Zmiany',0),(461454,12819,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(461455,12819,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(461456,12819,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(461457,12819,'vi','thay Ä‘á»•i',0),(461458,12819,'af','Maak veranderinge',0),(461459,12819,'ro','Face modificÄƒri',0),(461460,12819,'et','Teha muudatusi',0),(461461,12819,'si','Spreminjati',0),(461462,12819,'ba','Membuat perubahan',0),(461463,12819,'nl','Wijzigingen aanbrengen',0),(461464,12819,'fi','Tee muutokset',0),(461465,12819,'no','GjÃ¸re endringer',0),(461466,12819,'da','Foretage Ã¦ndringer',0),(461467,12819,'ko','ë³€ê²½',0),(461468,12819,'he','×©×™× ×•×™×™×',0),(461469,12819,'el','ÎšÎ¬Î½ÎµÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚',0),(461470,12819,'zh','è¿›è¡Œæ›´æ”¹',0),(461471,12819,'sv','GÃ¶ra Ã¤ndringar',0),(461472,12819,'it','Apportare modifiche',0),(461473,12819,'tl','',0),(461474,12819,'th','à¸—à¸³à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(461475,12819,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(461476,12819,'ms','Membuat perubahan',0),(461477,12819,'ar','Ø¥Ø¬Ø±Ø§Ø¡ ØªØºÙŠÙŠØ±Ø§Øª',0),(461478,12819,'fr','Apporter des modifications',0),(461479,12819,'jp','å¤‰æ›´ã‚’åŠ ãˆã‚‹',0),(461480,12819,'pt','Fazer alteraÃ§Ãµes',0),(461481,12819,'ru','Ð’Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(461482,12819,'es','Hace Cambios',0),(461483,12819,'de','Ã„nderungen vornehmen',0),(461484,12819,'en','Make Changes',0),(461485,12820,'is','',0),(461486,12820,'dr','Ø­Ø°Ù ÙÛŒØ²ÛŒÚ©ÛŒ',0),(461487,12820,'pr','Ø­Ø°Ù ÙÛŒØ²ÛŒÚ©ÛŒ',0),(461488,12820,'tr','Fiziksel olarak kaldÄ±rÄ±n',0),(461489,12820,'pl','UsuÅ„ fizycznie',0),(461490,12820,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð½ÐµÑ‚Ðµ Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸',0),(461491,12820,'ur','Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø·ÙˆØ± Ù¾Ø± Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(461492,12820,'sr','Ð£ÐºÐ»Ð¾Ð½Ð¸Ñ‚Ðµ Ñ„Ð¸Ð·Ð¸Ñ‡ÐºÐ¸',0),(461493,12820,'vi','ÄÆ°a Physically',0),(461494,12820,'af','Fisies verwyder',0),(461495,12820,'ro','EliminaÅ£i fizic',0),(461496,12820,'et','Eemalda fÃ¼Ã¼siliselt',0),(461497,12820,'si','FiziÄno odstraniti',0),(461498,12820,'ba','Menghapus fisik',0),(461499,12820,'nl','Fysiek verwijderen',0),(461500,12820,'fi','Poistaa fyysisesti',0),(461501,12820,'no','Fjerne fysisk',0),(461502,12820,'da','Fjerne fysisk',0),(461503,12820,'ko','ë¬¼ë¦¬ì ìœ¼ë¡œ ì œê±°',0),(461504,12820,'he','×ž×¡×™×¨ ×¤×™×–×™×ª',0),(461505,12820,'el','Î‘Ï†Î±Î¹ÏÎ­ÏƒÏ„Îµ ÏƒÏ‰Î¼Î±Ï„Î¹ÎºÎ¬',0),(461506,12820,'zh','ç‰©ç†ä¸Šåˆ é™¤',0),(461507,12820,'sv','Bort fysiskt',0),(461508,12820,'it','Rimuovere fisicamente',0),(461509,12820,'tl','',0),(461510,12820,'th','à¹€à¸­à¸²à¸ˆà¸£à¸´à¸‡',0),(461511,12820,'hi','à¤¶à¤¾à¤°à¥€à¤°à¤¿à¤• à¤°à¥‚à¤ª à¤¸à¥‡ à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚',0),(461512,12820,'ms','Keluarkan secara fizikal',0),(461513,12820,'ar','Ø¥Ø²Ø§Ù„Ø© Ø¬Ø³Ø¯ÙŠØ§',0),(461514,12820,'fr','Retirez physiquement',0),(461515,12820,'jp','ç‰©ç†çš„ã«å‰Šé™¤ã—ã¾ã™ã€‚',0),(461516,12820,'pt','Remover fisicamente',0),(461517,12820,'ru','Ð¤Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ',0),(461518,12820,'es','Eliminar Fisicamente',0),(461519,12820,'de','Physisch entfernen',0),(461520,12820,'en','Remove Physically',0),(461521,12821,'is','',0),(461522,12821,'dr','Ú†Ú© Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(461523,12821,'pr','Ú†Ú© Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(461524,12821,'tr','PO kontrol listesi',0),(461525,12821,'pl','Lista kontrolna PO',0),(461526,12821,'bg','PO Ð§ÐµÐºÐ»Ð¸ÑÑ‚',0),(461527,12821,'ur','Ù¾Ùˆ Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(461528,12821,'sr','ÐŸÐž ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(461529,12821,'vi','danh sÃ¡ch Ä‘Æ¡n mua hÃ ng',0),(461530,12821,'af','Posbus Kontrolelys',0),(461531,12821,'ro','Lista de verificare PO',0),(461532,12821,'et','PO Meelespea',0),(461533,12821,'si','PO kontrolni seznam',0),(461534,12821,'ba','PO Checklist',0),(461535,12821,'nl','PO Checklist',0),(461536,12821,'fi','PO tarkistuslista',0),(461537,12821,'no','PO sjekkliste',0),(461538,12821,'da','PO tjekliste',0),(461539,12821,'ko','í¬ ê²€ì‚¬ ëª©ë¡',0),(461540,12821,'he','×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢ ×¤×•',0),(461541,12821,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Î½Î¬',0),(461542,12821,'zh','å¤§åŸ”æ¸…å•',0),(461543,12821,'sv','PO checklista',0),(461544,12821,'it','PO Checklist',0),(461545,12821,'tl','',0),(461546,12821,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š PO',0),(461547,12821,'hi','PO à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ',0),(461548,12821,'ms','Senarai Semak PO',0),(461549,12821,'ar','Øµ. Ø¨ Ù‚Ø§Ø¦Ù…Ø© Ù…Ø±Ø¬Ø¹ÙŠØ©',0),(461550,12821,'fr','Liste de contrÃ´le de PO',0),(461551,12821,'jp','PO ã®ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆ',0),(461552,12821,'pt','Checklist de PO',0),(461553,12821,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¿Ð¾',0),(461554,12821,'es','OC Lista de ComprobaciÃ³n',0),(461555,12821,'de','PO-Checkliste',0),(461556,12821,'en','PO Checklist',0),(461557,12822,'is','',0),(461558,12822,'dr','Ú†Ú© Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(461559,12822,'pr','Ú†Ú© Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(461560,12822,'tr','PO PO denetim listesi',0),(461561,12822,'pl','PO listÄ™ kontrolnÄ… dla PO',0),(461562,12822,'bg','PO Ð§ÐµÐºÐ»Ð¸ÑÑ‚ Ð·Ð° PO',0),(461563,12822,'ur','Ù¾Ùˆ Ù¾Ùˆ Ú©Û’ Ù„Ø¦Û’ Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(461564,12822,'sr','ÐŸÐž ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ Ð·Ð° ÐŸÐ¾Ð°',0),(461565,12822,'vi','Danh sÃ¡ch kiá»ƒm tra Ä‘Æ¡n mua hÃ ng',0),(461566,12822,'af','Posbus Kontrolelys vir PO',0),(461567,12822,'ro','PO lista de verificare pentru PO',0),(461568,12822,'et','PO Meelespea PO',0),(461569,12822,'si','PO kontrolni seznam za PO',0),(461570,12822,'ba','PO Checklist untuk PO',0),(461571,12822,'nl','PO controlelijst voor PO',0),(461572,12822,'fi','PO muistilista PO',0),(461573,12822,'no','PO Sjekkliste For PO',0),(461574,12822,'da','PO tjekliste For PO',0),(461575,12822,'ko','í¬ í¬ì— ëŒ€ í•œ ê²€ì‚¬ ëª©ë¡',0),(461576,12822,'he','×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢ ×”×–×ž× ×ª ×¨×›×© ×¢×‘×•×¨ ×”×–×ž× ×ª ×¨×›×©',0),(461577,12822,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… PO Î³Î¹Î± Ï€Î¿',0),(461578,12822,'zh','å¤§åŸ”å¤§åŸ”æ¸…å•',0),(461579,12822,'sv','PO checklista fÃ¶r PO',0),(461580,12822,'it','PO Checklist per PO',0),(461581,12822,'tl','',0),(461582,12822,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š PO à¸ªà¸³à¸«à¸£à¸±à¸š PO',0),(461583,12822,'hi','à¤ªà¥‹ à¤ªà¥‹ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ',0),(461584,12822,'ms','Senarai Semak PO PO',0),(461585,12822,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ø®ØªÙŠØ§Ø± Ø¨Ùˆ Ø¨Ùˆ',0),(461586,12822,'fr','Liste de vÃ©rification PO pour PO',0),(461587,12822,'jp','PO ã®ãƒãƒ¼ ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆ',0),(461588,12822,'pt','PO Checklist para PO',0),(461589,12822,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº PO Ð´Ð»Ñ PO',0),(461590,12822,'es','OC Lista de ComprobaciÃ³n para OC',0),(461591,12822,'de','PO-Checkliste fÃ¼r PO',0),(461592,12822,'en','PO Checklist For PO',0),(461593,12823,'is','',0),(461594,12823,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø­ØµÙˆÙ„',0),(461595,12823,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø­ØµÙˆÙ„',0),(461596,12823,'tr','ÃœrÃ¼n numarasÄ±',0),(461597,12823,'pl','Numer produktu',0),(461598,12823,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(461599,12823,'ur','Ù…ØµÙ†ÙˆØ¹Û Ù†Ù…Ø¨Ø±',0),(461600,12823,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(461601,12823,'vi','sá»‘ sáº£n pháº©m',0),(461602,12823,'af','Produk getal',0),(461603,12823,'ro','NumÄƒr produs',0),(461604,12823,'et','Toote Number',0),(461605,12823,'si','Å tevilka izdelka',0),(461606,12823,'ba','Nomor produk',0),(461607,12823,'nl','Productnummer',0),(461608,12823,'fi','Tuotenumero',0),(461609,12823,'no','Produktnummeret',0),(461610,12823,'da','Produktnummer',0),(461611,12823,'ko','ì œí’ˆ ë²ˆí˜¸',0),(461612,12823,'he','×ž×¡×¤×¨ ×ž×•×¦×¨',0),(461613,12823,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Ï‰Î½',0),(461614,12823,'zh','äº§å“ç¼–å·',0),(461615,12823,'sv','Produktnummer',0),(461616,12823,'it','Numero prodotto',0),(461617,12823,'tl','',0),(461618,12823,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œ',0),(461619,12823,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤•à¥à¤°à¤®à¤¾à¤‚à¤•',0),(461620,12823,'ms','Nombor produk',0),(461621,12823,'ar','Ø±Ù‚Ù… Ø§Ù„Ù…Ù†ØªØ¬',0),(461622,12823,'fr','NumÃ©ro de produit',0),(461623,12823,'jp','è£½å“ç•ªå·',0),(461624,12823,'pt','NÃºmero do produto',0),(461625,12823,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(461626,12823,'es','NÃºmero de Producto',0),(461627,12823,'de','Produkt-Nummer',0),(461628,12823,'en','Product Number',0),(461629,12824,'is','',0),(461630,12824,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÛŒØ§ÙØªÛŒ',0),(461631,12824,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±ÛŒØ§ÙØªÛŒ',0),(461632,12824,'tr','AlÄ±nan miktar',0),(461633,12824,'pl','IloÅ›Ä‡ otrzymanych',0),(461634,12824,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(461635,12824,'ur','Ù…Ù‚Ø¯Ø§Ø± Ù…Ù„ÛŒ',0),(461636,12824,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ñƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(461637,12824,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ nháº­n',0),(461638,12824,'af','Hoeveelheid ontvang',0),(461639,12824,'ro','Cantitatea primitÄƒ',0),(461640,12824,'et','Saadud kogus',0),(461641,12824,'si','Prevzeto koliÄino',0),(461642,12824,'ba','Jumlah yang diterima',0),(461643,12824,'nl','Ontvangen aantal',0),(461644,12824,'fi','Vastaanotettu mÃ¤Ã¤rÃ¤',0),(461645,12824,'no','Antall mottatt',0),(461646,12824,'da','Modtagne antal',0),(461647,12824,'ko','ë°›ì€ ìˆ˜ëŸ‰',0),(461648,12824,'he','×”×›×ž×•×ª ×©×”×ª×§×‘×œ×”',0),(461649,12824,'el','Î Î±ÏÎ±Î»Î·Ï†Î¸ÎµÎ¯ÏƒÎ± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(461650,12824,'zh','æ”¶åˆ°çš„æ•°é‡',0),(461651,12824,'sv','Inlevererad kvantitet',0),(461652,12824,'it','Quantitativo ricevuto',0),(461653,12824,'tl','',0),(461654,12824,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸š',0),(461655,12824,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(461656,12824,'ms','Kuantiti yang diterima',0),(461657,12824,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø³ØªÙ„Ù…Ø©',0),(461658,12824,'fr','QuantitÃ© reÃ§ue',0),(461659,12824,'jp','å—ã‘å–ã‚‰ã‚ŒãŸé‡',0),(461660,12824,'pt','Quantidade recebida',0),(461661,12824,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(461662,12824,'es','Cantidad Recibida',0),(461663,12824,'de','Gelieferte Menge',0),(461664,12824,'en','Quantity Received',0),(461665,12825,'is','',0),(461666,12825,'dr','Ú†Ø§Ù¾ Ú†Ú© Ù„ÛŒØ³Øª',0),(461667,12825,'pr','Ú†Ø§Ù¾ Ú†Ú© Ù„ÛŒØ³Øª',0),(461668,12825,'tr','Denetim listesini yazdÄ±rÄ±n',0),(461669,12825,'pl','Drukuj listÄ™ kontrolnÄ…',0),(461670,12825,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(461671,12825,'ur','ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(461672,12825,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(461673,12825,'vi','in danh sÃ¡ch kiá»ƒm tra',0),(461674,12825,'af','Druk Kontrolelys',0),(461675,12825,'ro','ImprimaÅ£i lista de verificare',0),(461676,12825,'et','Printige kontroll-loend',0),(461677,12825,'si','Natisnite kontrolni seznam',0),(461678,12825,'ba','Mencetak daftar periksa',0),(461679,12825,'nl','Controlelijst afdrukken',0),(461680,12825,'fi','Tulosta tarkistusluettelo',0),(461681,12825,'no','Utskriften sjekkliste',0),(461682,12825,'da','Udskriv tjeklisten',0),(461683,12825,'ko','ì¸ì‡„ ê²€ì‚¬ ëª©ë¡',0),(461684,12825,'he','×”×“×¤×¡ ×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢',0),(461685,12825,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î»Î¯ÏƒÏ„Î±Ï‚',0),(461686,12825,'zh','æ‰“å°çš„æ ¸å¯¹æ¸…å•',0),(461687,12825,'sv','Skriva ut checklistan',0),(461688,12825,'it','Stampare la lista di controllo',0),(461689,12825,'tl','',0),(461690,12825,'th','à¸žà¸´à¸¡à¸žà¹Œà¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(461691,12825,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ',0),(461692,12825,'ms','Cetak senarai semak',0),(461693,12825,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚Ø§Ø¦Ù…Ø© Ù…Ø±Ø¬Ø¹ÙŠØ©',0),(461694,12825,'fr','Imprimer la liste de contrÃ´le',0),(461695,12825,'jp','å°åˆ·ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆ',0),(461696,12825,'pt','Imprimir lista de verificaÃ§Ã£o',0),(461697,12825,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(461698,12825,'es','Imprimir Lista de ComprobaciÃ³n',0),(461699,12825,'de','Checkliste drucken',0),(461700,12825,'en','Print Checklist',0),(461701,12826,'is','',0),(461702,12826,'dr','12 Ù…Ø§Ù‡ ',0),(461703,12826,'pr','ÙØ±ÙˆØ´ 12 Ù…Ø§Ù‡ ',0),(461704,12826,'tr','Madde satÄ±ÅŸlarÄ± - 12 aylÄ±k',0),(461705,12826,'pl','SprzedaÅ¼ zapasÃ³w - dwunastomiesiÄ™czne',0),(461706,12826,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ - 12 Ð¼ÐµÑÐµÑ†Ð°',0),(461707,12826,'ur','Ø´Û’ Ú©ÛŒ ÙØ±ÙˆØ®Øª - 12 Ù…Ø§Û',0),(461708,12826,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° - 12 Ð¼ÐµÑÐµÑ†Ð¸',0),(461709,12826,'vi','12 thÃ¡ng doanh sá»‘',0),(461710,12826,'af','Item Verkope - 12 Maande',0),(461711,12826,'ro','Element de vÃ¢nzÄƒri - 12 luni',0),(461712,12826,'et','Kaupade mÃ¼Ã¼k - 12 kuu',0),(461713,12826,'si','Prodaje artikla - 12 mesec',0),(461714,12826,'ba','Penjualan barang - 12 bulan',0),(461715,12826,'nl','Artikelverkoop - 12 maand',0),(461716,12826,'fi','Nimikkeen myynti - 12 kuukauden',0),(461717,12826,'no','Varesalg - 12 mÃ¥neder',0),(461718,12826,'da','Varesalg - 12 mÃ¥neders',0),(461719,12826,'ko','í•­ëª© íŒë§¤-12 ê°œì›”',0),(461720,12826,'he','×¤×¨×™×˜ ×ž×›×™×¨×•×ª - 12 ×—×•×“×©×™×',0),(461721,12826,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ - 12 Î¼Î·Î½ÏŽÎ½',0),(461722,12826,'zh','é¡¹ç›®é”€å”®-12 ä¸ªæœˆ',0),(461723,12826,'sv','12 MÃ¥nadens fÃ¶rsÃ¤ljning',0),(461724,12826,'it','Vendite - 12 mesi',0),(461725,12826,'tl','',0),(461726,12826,'th','à¸‚à¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸² - 12 à¹€à¸”à¸·à¸­à¸™',0),(461727,12826,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ - 12 à¤®à¤¹à¥€à¤¨à¥‡',0),(461728,12826,'ms','Item jualan - 12 bulan',0),(461729,12826,'ar','Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø£ØµÙ†Ø§Ù-12 Ø´Ù‡Ø±',0),(461730,12826,'fr','Point de ventes - 12 mois',0),(461731,12826,'jp','é …ç›®ã®è²©å£² - 12 æœˆ',0),(461732,12826,'pt','Vendas de itens - 12 meses',0),(461733,12826,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ - 12 Ð¼ÐµÑÑÑ†ÐµÐ²',0),(461734,12826,'es','Venta de 12 Meses',0),(461735,12826,'de','ArtikelverkÃ¤ufe - 12 Monate',0),(461736,12826,'en','Item Sales - 12 Month',0),(461737,12827,'is','',0),(461738,12827,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù†Ù‚Ø§Ø· Ø³ÙØ§Ø±Ø´ ',0),(461739,12827,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù†Ù‚Ø§Ø· Ø³ÙØ§Ø±Ø´ ',0),(461740,12827,'tr','Maddenin yeniden sipariÅŸ puan hesaplama',0),(461741,12827,'pl','ObliczyÄ‡ elementu ZmieÅ„ kolejnoÅ›Ä‡ punktÃ³w',0),(461742,12827,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(461743,12827,'ur','Ø´Û’ Ú©Ùˆ Ù¾Ú¾Ø± ØªØ±ØªÛŒØ¨ Ø¯ÛŒÙ†Û’ Ú©Û’ Ù…Ù‚Ø§Ù…Ø§Øª Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(461744,12827,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ñ‚Ð°Ñ‡ÐºÐµ Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(461745,12827,'vi','TÃ­nh  Ä‘iá»ƒm Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(461746,12827,'af','Item herrangskik punte bereken',0),(461747,12827,'ro','CalculaÅ£i punctele de reluare a comenzii element',0),(461748,12827,'et','Arvutatakse kauba kordustellimuse punktid',0),(461749,12827,'si','IzraÄun toÄk naroÄanja artikla',0),(461750,12827,'ba','Menghitung poin menyusun ulang Item',0),(461751,12827,'nl','Bereken Item bestelfrequentie punten',0),(461752,12827,'fi','Nimikkeen uusintatilausvÃ¤lin pisteitÃ¤',0),(461753,12827,'no','Beregne element omorganisere punkt',0),(461754,12827,'da','Beregne vare Omorganiser punkter',0),(461755,12827,'ko','í•­ëª© ìž¬ì£¼ë¬¸ ì  ê³„ì‚°',0),(461756,12827,'he','×—×™×©×•×‘ × ×§×•×“×•×ª ×¡×“×¨ ×ž×—×“×© ×¤×¨×™×˜',0),(461757,12827,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÎ¹ Ï„Î¿ ÏƒÎ·Î¼ÎµÎ¯Î¿ Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏƒÎ·Î¼ÎµÎ¯Î±',0),(461758,12827,'zh','è®¡ç®—é¡¹ç›®å†è®¢è´­ç‚¹',0),(461759,12827,'sv','BerÃ¤kna objekt ordna poÃ¤ng',0),(461760,12827,'it','Calcolare la voce punti di riordino',0),(461761,12827,'tl','',0),(461762,12827,'th','à¸„à¸³à¸™à¸§à¸“à¸ˆà¸¸à¸”à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¹ƒà¸«à¸¡à¹ˆà¸‚à¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(461763,12827,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤…à¤‚à¤• à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(461764,12827,'ms','Pengiraan Item susun semula Mata',0),(461765,12827,'ar','Ø­Ø³Ø§Ø¨ Ù†Ù‚Ø§Ø· Ø¥Ø¹Ø§Ø¯Ø© ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù†ØµØ±',0),(461766,12827,'fr','Calculer point de rÃ©approvisionnement Points',0),(461767,12827,'jp','é …ç›®ã®ä¸¦ã¹æ›¿ãˆã®ãƒã‚¤ãƒ³ãƒˆã‚’è¨ˆç®—ã—ã¾ã™ã€‚',0),(461768,12827,'pt','Calcular Item reordenar pontos',0),(461769,12827,'ru','Ð’Ñ‹Ñ‡Ð¸ÑÐ»Ð¸Ñ‚ÑŒ Ñ‚Ð¾Ñ‡ÐºÐ¸ Ð´Ð¾Ð·Ð°ÐºÐ°Ð·Ð° Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(461770,12827,'es','Calcula Puntos de Orden',0),(461771,12827,'de','Berechnen der Punkte Element neu anordnen',0),(461772,12827,'en','Calculate Item Reorder Points',0),(461773,12828,'is','',0),(461774,12828,'dr','Ø­Ø°Ù Ú©Ø§Ù„Ø§Ù‡Ø§',0),(461775,12828,'pr','Ø­Ø°Ù Ú©Ø§Ù„Ø§Ù‡Ø§',0),(461776,12828,'tr','Ã–ÄŸeleri silme',0),(461777,12828,'pl','Usuwanie elementÃ³w',0),(461778,12828,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(461779,12828,'ur','Ø§Ø´ÛŒØ§ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(461780,12828,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(461781,12828,'vi','XÃ³a cÃ¡c má»¥c',0),(461782,12828,'af','Skrap Items',0),(461783,12828,'ro','È˜tergere elemente',0),(461784,12828,'et','Ãœksuste kustutamine',0),(461785,12828,'si','IzbriÅ¡ite elemente',0),(461786,12828,'ba','Menghapus item',0),(461787,12828,'nl','Items verwijderen',0),(461788,12828,'fi','Kohteiden poistaminen',0),(461789,12828,'no','Slette elementer',0),(461790,12828,'da','Slette elementer',0),(461791,12828,'ko','í•­ëª© ì‚­ì œ',0),(461792,12828,'he','×ž×—×§ ×¤×¨×™×˜×™×',0),(461793,12828,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½',0),(461794,12828,'zh','åˆ é™¤é¡¹ç›®',0),(461795,12828,'sv','Ta bort objekt',0),(461796,12828,'it','Eliminare gli elementi',0),(461797,12828,'tl','',0),(461798,12828,'th','à¸¥à¸šà¸£à¸²à¸¢à¸à¸²à¸£',0),(461799,12828,'hi','à¤†à¤‡à¤Ÿà¤® à¤¹à¤Ÿà¤¾à¤à¤',0),(461800,12828,'ms','Menghapuskan item',0),(461801,12828,'ar','Ø­Ø°Ù Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(461802,12828,'fr','Supprimer des Ã©lÃ©ments',0),(461803,12828,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(461804,12828,'pt','Excluir itens',0),(461805,12828,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(461806,12828,'es','Eliminar Items',0),(461807,12828,'de','LÃ¶schen von Elementen',0),(461808,12828,'en','Delete Items',0),(461809,12829,'is','',0),(461810,12829,'dr','Ø­Ø°Ù Ú©Ø§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ú¯Ø±ÙˆÙ‡',0),(461811,12829,'pr','Ø­Ø°Ù Ú©Ø§Ù„Ø§Ù‡Ø§ Ø¨Ø§ Ú¯Ø±ÙˆÙ‡',0),(461812,12829,'tr','Kategoriye gÃ¶re Ã¶ÄŸeleri silme',0),(461813,12829,'pl','Usuwanie elementÃ³w wedÅ‚ug kategorii',0),(461814,12829,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(461815,12829,'ur','Ø²Ù…Ø±Û’ Ú©Û’ Ù„Ø­Ø§Ø¸ Ø³Û’ Ø§Ø´ÛŒØ§ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(461816,12829,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ñ€ÐµÐ¼Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸',0),(461817,12829,'vi','xÃ³a cÃ¡c má»¥c trong danh sÃ¡ch',0),(461818,12829,'af','Skrap Items volgens kategorie',0),(461819,12829,'ro','È˜tergere elemente de categoria',0),(461820,12829,'et','Ãœksuste kategooria kustutamine',0),(461821,12829,'si','IzbriÅ¡ite elemente po kategoriji',0),(461822,12829,'ba','Menghapus item menurut kategori',0),(461823,12829,'nl','Items per categorie verwijderen',0),(461824,12829,'fi','Poistaa kohteita luokittain',0),(461825,12829,'no','Slette elementer etter kategori',0),(461826,12829,'da','Slette elementer efter kategori',0),(461827,12829,'ko','ë²”ì£¼ë³„ìœ¼ë¡œ í•­ëª©ì„ ì‚­ì œ',0),(461828,12829,'he','×ž×—×§ ×¤×¨×™×˜×™× ×œ×¤×™ ×§×˜×’×•×¨×™×”',0),(461829,12829,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î±Î½Î¬ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(461830,12829,'zh','åˆ é™¤ç±»åˆ«çš„é¡¹ç›®',0),(461831,12829,'sv','Ta bort objekt efter kategori',0),(461832,12829,'it','Eliminare gli elementi di categoria',0),(461833,12829,'tl','',0),(461834,12829,'th','à¸¥à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸—',0),(461835,12829,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤¹à¤Ÿà¤¾à¤à¤',0),(461836,12829,'ms','Menghapuskan item mengikut Kategori',0),(461837,12829,'ar','Ø­Ø°Ù Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø­Ø³Ø¨ Ø§Ù„ÙØ¦Ø©',0),(461838,12829,'fr','Supprimer les Ã©lÃ©ments par catÃ©gorie',0),(461839,12829,'jp','ã‚«ãƒ†ã‚´ãƒªåˆ¥ã®ã‚¢ã‚¤ãƒ†ãƒ ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(461840,12829,'pt','Excluir itens por categoria',0),(461841,12829,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÐ¼',0),(461842,12829,'es','Eliminar Items por CategorÃ­a',0),(461843,12829,'de','LÃ¶schen von Elementen nach Kategorie',0),(461844,12829,'en','Delete Items By Category',0),(461845,12830,'is','',0),(461846,12830,'dr','ØªØ±ÛŒÙ„ÛŒÙˆÙ†',0),(461847,12830,'pr','ØªØ±ÛŒÙ„ÛŒÙˆÙ†',0),(461848,12830,'tr','Trilyon',0),(461849,12830,'pl','Bln',0),(461850,12830,'bg','Ð¢Ñ€Ð¸Ð»Ð¸Ð¾Ð½Ð°',0),(461851,12830,'ur','Ú©Ú¾Ø±Ø¨',0),(461852,12830,'sr','Ð¢Ñ€Ð¸Ð»Ð»Ð¸Ð¾Ð½',0),(461853,12830,'vi','NghÃ¬n tá»·',0),(461854,12830,'af','Trillion',0),(461855,12830,'ro','Trilion',0),(461856,12830,'et','Trillion',0),(461857,12830,'si','Bilijonov',0),(461858,12830,'ba','Trillion',0),(461859,12830,'nl','Biljoen',0),(461860,12830,'fi','Euroopassa',0),(461861,12830,'no','Billioner',0),(461862,12830,'da','Trillion',0),(461863,12830,'ko','ì¡°',0),(461864,12830,'he','×”×˜×¨×™×œ×™×•×Ÿ ×“×•×œ×¨ ×”××œ×•',0),(461865,12830,'el','Î¤ÏÎ¹ÏƒÎµÎºÎ±Ï„Î¿Î¼Î¼ÏÏÎ¹Î±',0),(461866,12830,'zh','ä¸‡äº¿',0),(461867,12830,'sv','Biljoner',0),(461868,12830,'it','Trilione',0),(461869,12830,'tl','',0),(461870,12830,'th','Trillion',0),(461871,12830,'hi','Trillion',0),(461872,12830,'ms','Trilion',0),(461873,12830,'ar','ØªØ±ÙŠÙ„ÙŠÙˆÙ†',0),(461874,12830,'fr','Billion',0),(461875,12830,'jp','å…†',0),(461876,12830,'pt','TrilhÃ£o',0),(461877,12830,'ru','Ð¢Ñ€Ð»Ð½',0),(461878,12830,'es','TrillÃ³n',0),(461879,12830,'de','Billionen',0),(461880,12830,'en','Trillion',0),(461881,12831,'is','',0),(461882,12831,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(461883,12831,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(461884,12831,'tr','Bir fatura numarasÄ± girmelisiniz',0),(461885,12831,'pl','NaleÅ¼y wpisaÄ‡ numer faktury',0),(461886,12831,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(461887,12831,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(461888,12831,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(461889,12831,'vi','Báº¡n Pháº£i Nháº­p Má»™t Sá»‘ HoÃ¡ Ä‘Æ¡n',0),(461890,12831,'af','U moet \'n Faktuurnommer invoer',0),(461891,12831,'ro','Trebuie sÄƒ introduceÅ£i un numÄƒr de facturÄƒ',0),(461892,12831,'et','Sisestage arve Number',0),(461893,12831,'si','Vnesite Å¡tevilko raÄuna',0),(461894,12831,'ba','Anda harus memasukkan nomor Invoice',0),(461895,12831,'nl','U moet een factuurnummer invoeren',0),(461896,12831,'fi','Kirjoita laskunumero',0),(461897,12831,'no','Du mÃ¥ angi et fakturanummer',0),(461898,12831,'da','Du skal angive et fakturanummer',0),(461899,12831,'ko','ì†¡ìž¥ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(461900,12831,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(461901,12831,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(461902,12831,'zh','æ‚¨å¿…é¡»è¾“å…¥å‘ç¥¨ç¼–å·',0),(461903,12831,'sv','Du mÃ¥ste ange ett fakturanummer',0),(461904,12831,'it','Ãˆ necessario immettere un numero di fattura',0),(461905,12831,'tl','',0),(461906,12831,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(461907,12831,'hi','à¤†à¤ª à¤•à¥‹à¤ˆ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(461908,12831,'ms','Anda mesti masukkan nombor invois',0),(461909,12831,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(461910,12831,'fr','Vous devez entrer un numÃ©ro de facture',0),(461911,12831,'jp','è«‹æ±‚æ›¸ç•ªå·ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(461912,12831,'pt','VocÃª deve digitar um nÃºmero de factura',0),(461913,12831,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(461914,12831,'es','Debe Entrar Un NÃºmero de Factura',0),(461915,12831,'de','Sie mÃ¼ssen eine Rechnungsnummer eingeben.',0),(461916,12831,'en','You Must Enter An Invoice Number',0),(461917,12832,'is','',0),(461918,12832,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ Ù¾Ø³ØªÛŒ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(461919,12832,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ Ù¾Ø³ØªÛŒ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(461920,12832,'tr','Bir satÄ±cÄ± veya PO numarasÄ± girmelisiniz',0),(461921,12832,'pl','NaleÅ¼y wprowadziÄ‡ dostawcy lub numer zamÃ³wienia',0),(461922,12832,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð»Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(461923,12832,'ur','Ø¢Ù¾ Ø§ÛŒÚ© ÙˆÛŒÙ†ÚˆØ± ÛŒØ§ Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(461924,12832,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸Ð»Ð¸ Ð±Ñ€Ð¾Ñ˜ ÐÐ°Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ðµ',0),(461925,12832,'vi','Báº¡n pháº£i nháº­p Má»™t ngÆ°á»i bÃ¡n hÃ ng Hoáº·c Sá»‘ PO',0),(461926,12832,'af','Jy moet \'n handelaar of Posbus nommer intik',0),(461927,12832,'ro','Trebuie sÄƒ introduceÅ£i un furnizor sau un numÄƒr PO',0),(461928,12832,'et','Peate sisestama hankija vÃµi PO Number',0),(461929,12832,'si','Vnesti morate dobavitelja ali Å¡tevilka NaroÄilnice',0),(461930,12832,'ba','Anda harus memasukkan Vendor atau nomor PO',0),(461931,12832,'nl','U moet een leverancier of PO-nummer invoeren',0),(461932,12832,'fi','Kirjoita toimittajan tai Ostotilauksen numero',0),(461933,12832,'no','Du mÃ¥ angi en leverandÃ¸r eller innkjÃ¸psordrenummer',0),(461934,12832,'da','Du skal angive en kreditor eller PO-nummer',0),(461935,12832,'ko','ê³µê¸‰ ì—…ì²´ ë˜ëŠ” PO ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(461936,12832,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×¡×¤×§ ××• ×ž×¡×¤×¨ ×”-PO',0),(461937,12832,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î® Î±Î½Î¬ Î±ÏÎ¹Î¸Î¼ÏŒ',0),(461938,12832,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªä¾›åº”å•†æˆ–é‡‡è´­è®¢å•ç¼–å·',0),(461939,12832,'sv','Du mÃ¥ste ange en leverantÃ¶r eller inkÃ¶psordernummer',0),(461940,12832,'it','Ãˆ necessario immettere un fornitore o il numero di PO',0),(461941,12832,'tl','',0),(461942,12832,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸«à¸£à¸·à¸­à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ PO',0),(461943,12832,'hi','à¤¤à¥à¤® à¤à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¯à¤¾ à¤ªà¥‹ à¤¨à¤‚à¤¬à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(461944,12832,'ms','Anda mesti masukkan penjual atau nombor PO',0),(461945,12832,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ù…ÙˆØ±Ø¯ Ø£Ùˆ Ø±Ù‚Ù… Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡',0),(461946,12832,'fr','Vous devez entrer un vendeur ou un numÃ©ro de PO',0),(461947,12832,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã¾ãŸã¯ PO ç•ªå·ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(461948,12832,'pt','VocÃª deve digitar um nÃºmero de PO ou fornecedor',0),(461949,12832,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»Ñ Ð¸Ð»Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(461950,12832,'es','Debe Entrar Un Proveedor o NÃºmero OC',0),(461951,12832,'de','Sie mÃ¼ssen ein VerkÃ¤ufer oder Bestellnummer eingeben.',0),(461952,12832,'en','You Must Enter A Vendor Or PO Number',0),(461953,12833,'is','',0),(461954,12833,'dr','Ù¾Ø³ÙˆØ±Ø¯ Ø®ÙˆØ¯ Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ù‡ÛŒØ¯',0),(461955,12833,'pr','Ù¾Ø³ÙˆØ±Ø¯ Ø®ÙˆØ¯ Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ù‡ÛŒØ¯',0),(461956,12833,'tr','ParolanÄ±zÄ± deÄŸiÅŸtirme',0),(461957,12833,'pl','Zmiana hasÅ‚a',0),(461958,12833,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½ÐµÑ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð°Ñ‚Ð° ÑÐ¸',0),(461959,12833,'ur','Ø¢Ù¾ Ú©Ø§ Ù¾Ø§Ø³ ÙˆØ±Úˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(461960,12833,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ',0),(461961,12833,'vi','Thay Ä‘á»•i máº­t kháº©u',0),(461962,12833,'af','Verander u Wagwoord',0),(461963,12833,'ro','SchimbaÅ£i-vÄƒ parola',0),(461964,12833,'et','Parooli muutmine',0),(461965,12833,'si','Spremenite geslo',0),(461966,12833,'ba','Mengubah sandi',0),(461967,12833,'nl','Uw wachtwoord wijzigen',0),(461968,12833,'fi','Vaihda salasana',0),(461969,12833,'no','Endre passordet',0),(461970,12833,'da','Ã†ndre din adgangskode',0),(461971,12833,'ko','ë¹„ë°€ ë²ˆí˜¸ë¥¼ ë³€ê²½',0),(461972,12833,'he','×œ×©× ×•×ª ××ª ×”×¡×™×¡×ž×” ×©×œ×š',0),(461973,12833,'el','Î‘Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ ÏƒÎ±Ï‚',0),(461974,12833,'zh','æ›´æ”¹æ‚¨çš„å¯†ç ',0),(461975,12833,'sv','Ã„ndra ditt lÃ¶senord',0),(461976,12833,'it','Cambiare la Password',0),(461977,12833,'tl','',0),(461978,12833,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(461979,12833,'hi','à¤…à¤ªà¤¨à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(461980,12833,'ms','Menukar kata laluan anda',0),(461981,12833,'ar','ØªØºÙŠÙŠØ± ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(461982,12833,'fr','Changer votre mot de passe',0),(461983,12833,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(461984,12833,'pt','Alterar sua senha',0),(461985,12833,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÐ²Ð¾Ð¹ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ',0),(461986,12833,'es','Cambia su ContraseÃ±a',0),(461987,12833,'de','Ã„ndern Sie Ihr Passwort',0),(461988,12833,'en','Change your Password',0),(461989,12834,'is','',0),(461990,12834,'dr','Ø¨Ø±Ø±Ø³ÛŒ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø³ÛŒØ³ØªÙ…',0),(461991,12834,'pr','Ø¨Ø±Ø±Ø³ÛŒ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø³ÛŒØ³ØªÙ…',0),(461992,12834,'tr','Sistem ayarlarÄ±nÄ± denetleyin',0),(461993,12834,'pl','SprawdÅº ustawienia systemu',0),(461994,12834,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼Ð½Ð¸Ñ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸',0),(461995,12834,'ur','Ù†Ø¸Ø§Ù… Ø³ÛŒÙ¹Ù†Ú¯ÙˆÚº Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(461996,12834,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(461997,12834,'vi','CÃ i Ä‘áº·t  há»‡ thá»‘ng sÃ©c',0),(461998,12834,'af','Kontroleer Stelsel Instellings',0),(461999,12834,'ro','VerificaÅ£i setÄƒrile de sistem',0),(462000,12834,'et','SÃ¼steemi sÃ¤tete kontrollimine',0),(462001,12834,'si','Preverite sistemske nastavitve',0),(462002,12834,'ba','Periksa pengaturan sistem',0),(462003,12834,'nl','Controleer de systeeminstellingen',0),(462004,12834,'fi','Tarkista JÃ¤rjestelmÃ¤asetukset',0),(462005,12834,'no','Sjekk systeminnstillinger',0),(462006,12834,'da','Kontrollere Systemindstillinger',0),(462007,12834,'ko','ì‹œìŠ¤í…œ ì„¤ì • í™•ì¸',0),(462008,12834,'he','×‘×“×•×§ ××ª ×”×’×“×¨×•×ª ×”×ž×¢×¨×›×ª',0),(462009,12834,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î¹Ï‚ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚',0),(462010,12834,'zh','æ£€æŸ¥ç³»ç»Ÿè®¾ç½®',0),(462011,12834,'sv','Kontrollera SysteminstÃ¤llningar',0),(462012,12834,'it','Controllare le impostazioni di sistema',0),(462013,12834,'tl','',0),(462014,12834,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸£à¸°à¸šà¸š',0),(462015,12834,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(462016,12834,'ms','Semak seting sistem',0),(462017,12834,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù…',0),(462018,12834,'fr','VÃ©rifiez les paramÃ¨tres du systÃ¨me',0),(462019,12834,'jp','ã‚·ã‚¹ãƒ†ãƒ è¨­å®šã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(462020,12834,'pt','Verifique as configuraÃ§Ãµes do sistema',0),(462021,12834,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹',0),(462022,12834,'es','Checar ConfiguraciÃ³n del Sistema',0),(462023,12834,'de','ÃœberprÃ¼fen Sie die Systemeinstellungen',0),(462024,12834,'en','Check System Settings',0),(462025,12835,'is','',0),(462026,12835,'dr','Ø¨Ø§Ø²Ø¨ÛŒÙ†ÛŒ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(462027,12835,'pr','Ø¨Ø§Ø²Ø¨ÛŒÙ†ÛŒ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(462028,12835,'tr','Ä°nceleme fatura seÃ§enekleri',0),(462029,12835,'pl','PrzeglÄ…d opcji faktura',0),(462030,12835,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð²ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð¾ÑÑ‚Ð¸',0),(462031,12835,'ur','Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’ Ú©Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(462032,12835,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(462033,12835,'vi','chá»n lá»±a Ä‘Ã¡nh giÃ¡ hÃ³a Ä‘Æ¡n',0),(462034,12835,'af','Hersiening faktuur opsies',0),(462035,12835,'ro','OpÅ£iuni de facturÄƒ revizuire',0),(462036,12835,'et','Ãœlevaade arve Valikud',0),(462037,12835,'si','MoÅ¾nosti pregleda raÄuna',0),(462038,12835,'ba','Tinjauan faktur pilihan',0),(462039,12835,'nl','Beoordeling factuur opties',0),(462040,12835,'fi','Laskun tarkistusasetuksensa',0),(462041,12835,'no','Alternativer for gjennomsyn faktura',0),(462042,12835,'da','Anmeldelse faktura indstillinger',0),(462043,12835,'ko','ê²€í†  ì†¡ìž¥ ì˜µì…˜',0),(462044,12835,'he','×¡×§×™×¨×ª ×”×—×©×‘×•× ×™×ª',0),(462045,12835,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·Ï‚',0),(462046,12835,'zh','å®¡æŸ¥å‘ç¥¨é€‰é¡¹',0),(462047,12835,'sv','Faktura granskningsalternativ',0),(462048,12835,'it','Opzioni di revisione fattura',0),(462049,12835,'tl','',0),(462050,12835,'th','à¸•à¸£à¸§à¸ˆà¸—à¸²à¸™à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(462051,12835,'hi','à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(462052,12835,'ms','Opsyen invois',0),(462053,12835,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ø³ØªØ¹Ø±Ø§Ø¶ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(462054,12835,'fr','Consulter les Options de facturation',0),(462055,12835,'jp','å¯©æŸ»è«‹æ±‚æ›¸ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(462056,12835,'pt','OpÃ§Ãµes de revisÃ£o fatura',0),(462057,12835,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð² ÑÑ‡ÐµÑ‚Ð°',0),(462058,12835,'es','Revisar Opciones de Factura',0),(462059,12835,'de','Bewertung Rechnung Optionen',0),(462060,12835,'en','Review Invoice Options',0),(462061,12836,'is','',0),(462062,12836,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(462063,12836,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(462064,12836,'tr','Oturum aÃ§',0),(462065,12836,'pl','Zaloguj siÄ™',0),(462066,12836,'bg','Ð’Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(462067,12836,'ur','Ø¯Ø±Ø¬ Ú©Ø±ÙŠÚº',0),(462068,12836,'sr','Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸ ÑÐµ',0),(462069,12836,'vi','Ä‘Äƒng nháº­p',0),(462070,12836,'af','Teken aan',0),(462071,12836,'ro','conecteazÄƒ-te',0),(462072,12836,'et','Logi sisse',0),(462073,12836,'si','prijava',0),(462074,12836,'ba','Masuk',0),(462075,12836,'nl','Aanmelden',0),(462076,12836,'fi','Kirjaudu sisÃ¤Ã¤n',0),(462077,12836,'no','logg pÃ¥',0),(462078,12836,'da','Log pÃ¥',0),(462079,12836,'ko','ë¡œê·¸ì¸',0),(462080,12836,'he','×›× ×¡',0),(462081,12836,'el','Î£Ï…Î½Î´Î­ÏƒÎ¿Ï…',0),(462082,12836,'zh','ç™»å½•',0),(462083,12836,'sv','Logga in',0),(462084,12836,'it','Accedi',0),(462085,12836,'tl','',0),(462086,12836,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(462087,12836,'hi','à¤²à¥‰à¤— à¤‡à¤¨ à¤•à¤°à¥‹',0),(462088,12836,'ms','log masuk',0),(462089,12836,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(462090,12836,'fr','Ouvrir une session',0),(462091,12836,'jp','ãƒ­ã‚°ã‚¤ãƒ³',0),(462092,12836,'pt','Iniciar sessÃ£o',0),(462093,12836,'ru','Ð’Ð¾Ð¹Ñ‚Ð¸',0),(462094,12836,'es','Login',0),(462095,12836,'de','Anmelden',0),(462096,12836,'en','Log In',0),(462097,12837,'is','',0),(462098,12837,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ø¨Ù‡ ÙˆØ±ÙˆØ¯ Ù…Ø¯ÛŒØ± Ø³ÛŒØ³ØªÙ… ',0),(462099,12837,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ø¨Ù‡ ÙˆØ±ÙˆØ¯ Ù…Ø¯ÛŒØ± Ø³ÛŒØ³ØªÙ… ',0),(462100,12837,'tr','Sistem YÃ¶neticisi oturum aÃ§ma izin',0),(462101,12837,'pl','UmoÅ¼liwienia logowania administratora systemu',0),(462102,12837,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ ÑÐ¸ÑÑ‚ÐµÐ¼ÐµÐ½ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ Ð²Ð»Ð¸Ð·Ð°Ð½Ð¸Ñ',0),(462103,12837,'ur','Ù†Ø¸Ø§Ù… Ù…Ù†ØªØ¸Ù… Ù„Ø§Ú¯ Ø§Ù† Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(462104,12837,'sr','ÐžÐ¼Ð¾Ð³ÑƒÑ›Ð¸Ñ‚Ð¸ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐ°',0),(462105,12837,'vi','Cho phÃ©p truy cáº­p há»‡ thá»‘ng quáº£n lÃ½',0),(462106,12837,'af','Laat jou stelseladministrateur aantekening toe',0),(462107,12837,'ro','Permite Login Administrator de sistem',0),(462108,12837,'et','Luba sÃ¼steemiadministraator logimine',0),(462109,12837,'si','OmogoÄi prijave skrbnika sistema',0),(462110,12837,'ba','Memungkinkan Administrator sistem login',0),(462111,12837,'nl','Systeembeheerder Logins toestaan',0),(462112,12837,'fi','Salli jÃ¤rjestelmÃ¤nvalvojan kirjautumiset',0),(462113,12837,'no','Tillate systemansvarlig logikk',0),(462114,12837,'da','Tillad System Administrator Login',0),(462115,12837,'ko','ì‹œìŠ¤í…œ ê´€ë¦¬ìž ë¡œê·¸ì¸ì„ í—ˆìš©',0),(462116,12837,'he','×œ××¤×©×¨ ×œ×ž× ×”×œ ×”×ž×¢×¨×›×ª ×›× ×™×¡×•×ª',0),(462117,12837,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€ÎµÎ¹ ÏƒÏ…Î½Î´Î­ÏƒÎµÎ¹Ï‚ Ï„Î¿Ï… Î´Î¹Î±Ï‡ÎµÎ¹ÏÎ¹ÏƒÏ„Î® Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚',0),(462118,12837,'zh','å…è®¸ç³»ç»Ÿç®¡ç†å‘˜ç™»å½•',0),(462119,12837,'sv','LÃ¥ta systemadministratÃ¶ren inloggningar',0),(462120,12837,'it','Consentire gli account di accesso di amministratore di sistema',0),(462121,12837,'tl','',0),(462122,12837,'th','à¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¸œà¸¹à¹‰à¸”à¸¹à¹à¸¥à¸£à¸°à¸šà¸šà¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(462123,12837,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤²à¥‰à¤—à¤‡à¤¨à¥à¤¸ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(462124,12837,'ms','Membolehkan pentadbir sistem login',0),(462125,12837,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ù…Ø³Ø¤ÙˆÙ„ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(462126,12837,'fr','Autoriser les connexions administrateur systÃ¨me',0),(462127,12837,'jp','ã‚·ã‚¹ãƒ†ãƒ ç®¡ç†è€…ã®ãƒ­ã‚°ã‚¤ãƒ³ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(462128,12837,'pt','Permitir logons de administrador do sistema',0),(462129,12837,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð²Ñ…Ð¾Ð´ ÑÐ¸ÑÑ‚ÐµÐ¼Ð½Ð¾Ð³Ð¾ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð°',0),(462130,12837,'es','Permite Logins del Amdinistrador del Sistema',0),(462131,12837,'de','Systemadministrator Anmeldungen zulassen',0),(462132,12837,'en','Allow System Administrator Logins',0),(462133,12838,'is','',0),(462134,12838,'dr','(Ø¬Ù†Ø³ ',0),(462135,12838,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„ Ø¨Ù‡ Ø§ÛŒÙ† Ù…ÙˆØ±Ø¯(Ø¬Ù†Ø³ ',0),(462136,12838,'tr','Bu madde GL hesap ekle',0),(462137,12838,'pl','Dodaj konto GL do tego elementu',0),(462138,12838,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° GL Ð°ÐºÐ°ÑƒÐ½Ñ‚ ÐºÑŠÐ¼ Ñ‚Ð¾Ð·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(462139,12838,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø³ Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(462140,12838,'sr','Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(462141,12838,'vi','ThÃªm TK Tá»•ng há»£p cho tÃ i khoáº£n nÃ y.',0),(462142,12838,'af','GL rekening Voeg hierdie item',0),(462143,12838,'ro','Adauga GL cont la acest element',0),(462144,12838,'et','Selle Ã¼ksuse GL konto lisamine',0),(462145,12838,'si','GL raÄun dodati ta element',0),(462146,12838,'ba','Menambahkan GL Account untuk Item ini',0),(462147,12838,'nl','GL Account toevoegen aan dit Item',0),(462148,12838,'fi','LisÃ¤Ã¤ GL tili tÃ¤hÃ¤n kohteeseen',0),(462149,12838,'no','Legge til GL-konto for dette elementet',0),(462150,12838,'da','TilfÃ¸je GL konto til dette element',0),(462151,12838,'ko','ì´ í•­ëª©ì— GL ê³„ì •ì„ ì¶”ê°€í•©ë‹ˆë‹¤',0),(462152,12838,'he','×”×•×¡×£ ×—×©×‘×•×Ÿ GL ×œ×¤×¨×™×˜ ×–×”',0),(462153,12838,'el','Î‘Ï…Î¾Î¬Î½Ï‰ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(462154,12838,'zh','æ€»å¸å¸æˆ·æ·»åŠ åˆ°æ­¤é¡¹ç›®',0),(462155,12838,'sv','LÃ¤gga till GL konto till det hÃ¤r objektet',0),(462156,12838,'it','Aggiungi Account GL a questo elemento',0),(462157,12838,'tl','',0),(462158,12838,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸™à¸µà¹‰',0),(462159,12838,'hi','GL à¤–à¤¾à¤¤à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(462160,12838,'ms','Menambah akaun GL untuk Item ini',0),(462161,12838,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨ GL Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¨Ù†Ø¯',0),(462162,12838,'fr','Ajouter compte GL Ã  ce point',0),(462163,12838,'jp','ã“ã®é …ç›®ã« GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(462164,12838,'pt','Adicionar conta GL para este Item',0),(462165,12838,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL Ðº ÑÑ‚Ð¾Ð¼Ñƒ Ð¿ÑƒÐ½ÐºÑ‚Ñƒ',0),(462166,12838,'es','Agregar Cuenta LM a Este Item',0),(462167,12838,'de','Dieses Element GL-Konto hinzufÃ¼gen',0),(462168,12838,'en','Add GL Account To This Item',0),(462169,12839,'is','',0),(462170,12839,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø±ÛŒØ§Ù† Ù†Ù‚Ø¯ÛŒÙ†Ú¯ÛŒ',0),(462171,12839,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ú¯Ø²Ø§Ø±Ø´ Ø¬Ø±ÛŒØ§Ù† Ù†Ù‚Ø¯ÛŒÙ†Ú¯ÛŒ',0),(462172,12839,'tr','Nakit akÄ±ÅŸÄ± raporu oluÅŸturma',0),(462173,12839,'pl','Zestaw sprawozdania z przepÅ‚ywu Å›rodkÃ³w pieniÄ™Å¼nych',0),(462174,12839,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚Ð¾Ñ†Ð¸',0),(462175,12839,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒØ´ ÙÙ„Ùˆ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(462176,12839,'sr','ÐŸÐ¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ‚Ð¾Ðº Ð½Ð¾Ð²Ñ†Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(462177,12839,'vi','Thiáº¿t láº­p BÃ¡o cÃ¡o lÆ°u chuyá»ƒn tiá»n tá»‡',0),(462178,12839,'af','Kontantvloei verslag opgestel',0),(462179,12839,'ro','Configurarea fluxului de numerar raport',0),(462180,12839,'et','Saate seadistada rahavoogude aruanne',0),(462181,12839,'si','Nastavite poroÄilo o denarnem toku',0),(462182,12839,'ba','Mengatur laporan arus kas',0),(462183,12839,'nl','Rapport cashflow instellen',0),(462184,12839,'fi','MÃ¤Ã¤ritÃ¤ kassavirtaraportti',0),(462185,12839,'no','Sette opp kontantstrÃ¸m-rapporten',0),(462186,12839,'da','OpsÃ¦tning af Cash Flow',0),(462187,12839,'ko','í˜„ê¸ˆ íë¦„ ë³´ê³ ì„œë¥¼ ì„¤ì •',0),(462188,12839,'he','×›×•×•× ×Ÿ ×“×•×— ×ª×–×¨×™× ×ž×–×•×ž× ×™×',0),(462189,12839,'el','ÎˆÏ‡ÎµÎ¹ ÏƒÏ…ÏƒÏ„Î±Î¸ÎµÎ¯ Î­ÎºÎ¸ÎµÏƒÎ· Ï„Î±Î¼ÎµÎ¹Î±ÎºÎ­Ï‚ ÏÎ¿Î­Ï‚',0),(462190,12839,'zh','è®¾ç½®çŽ°é‡‘æµé‡æŠ¥è¡¨',0),(462191,12839,'sv','StÃ¤ll in kassaflÃ¶desrapport',0),(462192,12839,'it','Impostare Report flusso di cassa',0),(462193,12839,'tl','',0),(462194,12839,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸£à¸°à¹à¸ªà¹€à¸‡à¸´à¸™à¸ªà¸”',0),(462195,12839,'hi','à¤•à¥ˆà¤¶ à¤«à¥à¤²à¥‹ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤Šà¤ªà¤° à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(462196,12839,'ms','Menyediakan laporan aliran tunai',0),(462197,12839,'ar','Ù‚Ù… Ø¨Ø¥Ø¹Ø¯Ø§Ø¯ ØªÙ‚Ø±ÙŠØ± Ø§Ù„ØªØ¯ÙÙ‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(462198,12839,'fr','Mettre en place le rapport de flux de trÃ©sorerie',0),(462199,12839,'jp','ã‚­ãƒ£ãƒƒã‚·ãƒ¥ ãƒ•ãƒ­ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆã‚’è¨­å®šã—ã¾ã™ã€‚',0),(462200,12839,'pt','Configurar o relatÃ³rio de fluxo de caixa',0),(462201,12839,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸',0),(462202,12839,'es','Configurar Informe de Flujo de Efectivo',0),(462203,12839,'de','Einrichten von Cashflow-Bericht',0),(462204,12839,'en','Set Up Cash Flow Report',0),(462205,12840,'is','',0),(462206,12840,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(462207,12840,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(462208,12840,'tr','BaÅŸarÄ±sÄ±z oturum aÃ§ma',0),(462209,12840,'pl','Logowanie nie powiodÅ‚o siÄ™',0),(462210,12840,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(462211,12840,'ur','Ù†Ø§Ú©Ø§Ù… Ù„Ø§Ú¯ Ø§Ù†',0),(462212,12840,'sr','ÐŸÑ€Ð¾Ð¿Ð°Ð»Ð¸ Ð›Ð¾Ð³Ð¸Ð½',0),(462213,12840,'vi','Ä‘Äƒng nháº­p tháº¥t báº¡',0),(462214,12840,'af','Inteken het misluk',0),(462215,12840,'ro','Nu a reuÅŸit Login',0),(462216,12840,'et','EbaÃµnnestunud sisselogimine',0),(462217,12840,'si','PrepriÄevalnost ne zadostovati',0),(462218,12840,'ba','Login gagal',0),(462219,12840,'nl','Mislukte Login',0),(462220,12840,'fi','Ole kirjautunut',0),(462221,12840,'no','Mislykket pÃ¥logging',0),(462222,12840,'da','Mislykkede Login',0),(462223,12840,'ko','ì‹¤íŒ¨ í•œ ë¡œê·¸ì¸',0),(462224,12840,'he','×”×›× ×™×¡×” ×”×›×•×©×œ',0),(462225,12840,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î·Î¼Î­Î½Î· ÎµÎ¯ÏƒÎ¿Î´Î¿Ï‚',0),(462226,12840,'zh','å¤±è´¥çš„ç™»å½•',0),(462227,12840,'sv','Misslyckad inloggning',0),(462228,12840,'it','Login fallito',0),(462229,12840,'tl','',0),(462230,12840,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(462231,12840,'hi','à¤…à¤¸à¤«à¤² à¤²à¥‰à¤—à¤¿à¤¨',0),(462232,12840,'ms','Log masuk gagal',0),(462233,12840,'ar','ÙØ´Ù„ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(462234,12840,'fr','Ã‰chec de connexion',0),(462235,12840,'jp','å¤±æ•—ã—ãŸãƒ­ã‚°ã‚¤ãƒ³',0),(462236,12840,'pt','Falha de Login',0),(462237,12840,'ru','ÐÐµÑƒÐ´Ð°Ñ‡Ð½Ñ‹Ðµ',0),(462238,12840,'es','Login FallÃ³',0),(462239,12840,'de','Fehlgeschlagener Login',0),(462240,12840,'en','Failed Login',0),(462241,12841,'is','',0),(462242,12841,'dr','Ø¯Ù‚ÛŒÙ‚Ù‡ Ø¬Ù‡Øª ØµØ¨Ø± Ú©Ø±Ø¯Ù†',0),(462243,12841,'pr','Ø¯Ù‚ÛŒÙ‚Ù‡ Ø¬Ù‡Øª ØµØ¨Ø± Ú©Ø±Ø¯Ù†',0),(462244,12841,'tr','Bir dakika dakika',0),(462245,12841,'pl','Minut czekaÄ‡',0),(462246,12841,'bg','ÐœÐ¸Ð½ÑƒÑ‚Ð¸ ÐºÑŠÐ¼ Ñ‡Ð°ÐºÐ°Ð¼',0),(462247,12841,'ur','Ù…Ù†Ù¹ Ú©Û’ Ø§Ù†ØªØ¸Ø§Ø± Ú©Û’ Ù„Ø¦Û’',0),(462248,12841,'sr','ÐœÐ¸Ð½ÑƒÑ‚Ð° Ñ†ÐµÐºÐ°Ñ˜',0),(462249,12841,'vi','Ä‘á»£i vÃ i phÃºt',0),(462250,12841,'af','Minute te wag',0),(462251,12841,'ro','Minute sÄƒ aÅŸteptaÅ£i',0),(462252,12841,'et','Minutit ootama',0),(462253,12841,'si','Minut Äakanja',0),(462254,12841,'ba','Menit untuk menunggu',0),(462255,12841,'nl','Minuten te wachten',0),(462256,12841,'fi','Odota minuutin',0),(462257,12841,'no','Minutter Ã¥ vente',0),(462258,12841,'da','Minutter til at vente',0),(462259,12841,'ko','ëŒ€ê¸° í•˜ëŠ” ë¶„',0),(462260,12841,'he','×“×§×•×ª ×¢×“ ×¨×’×¢',0),(462261,12841,'el','Î›ÎµÏ€Ï„Î¬ Î½Î± Ï€ÎµÏÎ¹Î¼Î­Î½ÎµÎ¹',0),(462262,12841,'zh','å‡ åˆ†é’Ÿåˆ°ç­‰å¾…',0),(462263,12841,'sv','Minuter att vÃ¤nta',0),(462264,12841,'it','Minuti di attesa',0),(462265,12841,'tl','',0),(462266,12841,'th','à¸™à¸²à¸—à¸µà¹€à¸žà¸·à¹ˆà¸­à¸£à¸­',0),(462267,12841,'hi','à¤®à¤¿à¤¨à¤Ÿ à¤ªà¥à¤°à¤¤à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(462268,12841,'ms','Minit untuk tunggu',0),(462269,12841,'ar','Ø¯Ù‚Ø§Ø¦Ù‚ Ø§Ù„Ø§Ù†ØªØ¸Ø§Ø±',0),(462270,12841,'fr','Minutes d\'attente',0),(462271,12841,'jp','åˆ†é–“å¾…æ©Ÿã™ã‚‹',0),(462272,12841,'pt','Minutos de espera',0),(462273,12841,'ru','ÐœÐ¸Ð½ÑƒÑ‚ Ð¶Ð´Ð°Ñ‚ÑŒ',0),(462274,12841,'es','Minutos para Esperar',0),(462275,12841,'de','Minuten warten',0),(462276,12841,'en','Minutes To Wait',0),(462277,12842,'is','',0),(462278,12842,'dr','ÙÛŒ Ù…Ø¯Øª Ø¯Ø§Ø± ',0),(462279,12842,'pr','ÙÛŒ Ù…Ø¯Øª Ø¯Ø§Ø± ',0),(462280,12842,'tr','bir saat Ã¼creti',0),(462281,12842,'pl','opÅ‚ata jednorazowa',0),(462282,12842,'bg','ÐµÐ´Ð½Ð¾ÐºÑ€Ð°Ñ‚Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(462283,12842,'ur','Ø§ÛŒÚ© Ù¹Ø§Ø¦Ù… Ú©ÛŒ ÙÛŒØ³',0),(462284,12842,'sr','ÐˆÐµÐ´Ð½Ð¾ÐºÑ€Ð°Ñ‚Ð½Ð° Ð½Ð°ÐºÐ½Ð°Ð´Ð°',0),(462285,12842,'vi','PhÃ­ 1 láº§n',0),(462286,12842,'af','eenmalige fooi',0),(462287,12842,'ro','taxÄƒ o singurÄƒ datÄƒ',0),(462288,12842,'et','Ã¼hekordne tasu',0),(462289,12842,'si','One-Time Pristojbina',0),(462290,12842,'ba','biaya satu kali',0),(462291,12842,'nl','eenmalige kosten',0),(462292,12842,'fi','Kertamaksu',0),(462293,12842,'no','engangsavgift',0),(462294,12842,'da','engangs-gebyr',0),(462295,12842,'ko','í•œ ì‹œê°„ ìš”ê¸ˆ',0),(462296,12842,'he','×¢×ž×œ×” ×—×“ ×¤×¢×ž×™×ª',0),(462297,12842,'el','one-time Î±Î¼Î¿Î¹Î²Î®',0),(462298,12842,'zh','ä¸€æ¬¡æ€§è´¹ç”¨',0),(462299,12842,'sv','engÃ¥ngsavgift',0),(462300,12842,'it','tantum',0),(462301,12842,'tl','',0),(462302,12842,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹€à¸žà¸µà¸¢à¸‡à¸„à¸£à¸±à¹‰à¸‡à¹€à¸”à¸µà¸¢à¸§',0),(462303,12842,'hi','à¤à¤• à¤¬à¤¾à¤° à¤¶à¥à¤²à¥à¤•',0),(462304,12842,'ms','Yuran sekali sepanjang pengajian',0),(462305,12842,'ar','Ø±Ø³ÙˆÙ… ØªØ¯ÙØ¹ Ù…Ø±Ø© ÙˆØ§Ø­Ø¯Ø©',0),(462306,12842,'fr','paiement unique',0),(462307,12842,'jp','ãƒ¯ãƒ³ã‚¿ã‚¤ãƒ æ–™é‡‘',0),(462308,12842,'pt','taxa Ãºnica',0),(462309,12842,'ru','Ð¾Ð´Ð½Ð¾Ñ€Ð°Ð·Ð¾Ð²Ñ‹Ð¹ Ð²Ð·Ð½Ð¾Ñ',0),(462310,12842,'es','Cuota de Una Vez',0),(462311,12842,'de','einmalige GebÃ¼hr',0),(462312,12842,'en','one-time fee',0),(462313,12843,'is','',0),(462314,12843,'dr','Ø§Ø±Ø³Ø§Ù„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø² Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø±ÛŒØ¹  ',0),(462315,12843,'pr','Ø§Ø±Ø³Ø§Ù„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø² Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³Ø±ÛŒØ¹  ',0),(462316,12843,'tr','QuickBooks verileri',0),(462317,12843,'pl','Eksportowanie danych z programu QuickBooks',0),(462318,12843,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¾Ñ‚ QuickBooks',0),(462319,12843,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ø³Û’ Ú©ÙˆØ§Ø¦Ù Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(462320,12843,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¸Ð· QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ',0),(462321,12843,'vi','Káº¿t xuáº¥t dá»¯ liá»‡u tá»« sá»• ',0),(462322,12843,'af','Voer Data vanaf QuickBooks',0),(462323,12843,'ro','ExportaÈ›i datele din QuickBooks',0),(462324,12843,'et','QuickBooksi andmete eksportimine',0),(462325,12843,'si','Izvoz podatkov iz programa QuickBooks',0),(462326,12843,'ba','Mengekspor Data dari QuickBooks',0),(462327,12843,'nl','Exporteer gegevens uit QuickBooks',0),(462328,12843,'fi','Tietojen vieminen QuickBooks',0),(462329,12843,'no','Eksporter Data fra QuickBooks',0),(462330,12843,'da','Eksportere Data fra QuickBooks',0),(462331,12843,'ko','QuickBooksì—ì„œ ë°ì´í„° ë‚´ë³´ë‚´ê¸°',0),(462332,12843,'he','×œ×™×™×¦× × ×ª×•× ×™× ×ž- QuickBooks',0),(462333,12843,'el','Î•Î¾Î±Î³Ï‰Î³Î® Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î±Ï€ÏŒ QuickBooks',0),(462334,12843,'zh','ä»Ž QuickBooks å¯¼å‡ºæ•°æ®',0),(462335,12843,'sv','Exportera Data frÃ¥n SPCS',0),(462336,12843,'it','Esportare dati da QuickBooks',0),(462337,12843,'tl','',0),(462338,12843,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ˆà¸²à¸ QuickBooks',0),(462339,12843,'hi','QuickBooks à¤¸à¥‡ à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(462340,12843,'ms','Mengeksport Data dari QuickBooks',0),(462341,12843,'ar','ØªØµØ¯ÙŠØ± Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ù…Ù† QuickBooks',0),(462342,12843,'fr','Exporter des donnÃ©es de QuickBooks',0),(462343,12843,'jp','QuickBooks ã‹ã‚‰ãƒ‡ãƒ¼ã‚¿ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(462344,12843,'pt','Exportar dados do QuickBooks',0),(462345,12843,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¸Ð· QuickBooks',0),(462346,12843,'es','Exportar Datos de Quickbooks',0),(462347,12843,'de','Exportieren von Daten aus QuickBooks',0),(462348,12843,'en','Export Data from QuickBooks',0),(462349,12844,'is','',0),(462350,12844,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ø³Ø±ÙˆÛŒØ³ Ø®Ø¯Ù…Ø§Øª Ú©Ø§Ø±Ù…Ù†Ø¯ Ø±Ø§ Ø­Ø¯Ø§Ù‚Ù„ Ø¨Ù‡ ÛŒÚ© Ú©Ø§Ø±ÙØ±Ù…Ø§ ÛŒØ§ ÛŒÚ© ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø®ØªØµØ§Øµ Ø¯Ù‡ÛŒØ¯',0),(462351,12844,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ø³Ø±ÙˆÛŒØ³ Ø®Ø¯Ù…Ø§Øª Ú©Ø§Ø±Ù…Ù†Ø¯ Ø±Ø§ Ø­Ø¯Ø§Ù‚Ù„ Ø¨Ù‡ ÛŒÚ© Ú©Ø§Ø±ÙØ±Ù…Ø§ ÛŒØ§ ÛŒÚ© ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø®ØªØµØ§Øµ Ø¯Ù‡ÛŒØ¯',0),(462352,12844,'tr','LÃ¼tfen hizmet iÅŸÃ§i sÄ±nÄ±fÄ± en az bir (1) Ã§alÄ±ÅŸan veya satÄ±cÄ±ya atama',0),(462353,12844,'pl','NaleÅ¼y przypisaÄ‡ klasÄ™ pracownik serwisu do co najmniej jednego (1) pracownik lub dostawcy',0),(462354,12844,'bg','Ð’ÑŠÐ·Ð»Ð¾Ð¶ÐµÑ‚Ðµ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº ÐºÐ»Ð°Ñ Ð½Ð°Ð¹-Ð¼Ð°Ð»ÐºÐ¾ ÐµÐ´Ð¸Ð½ (1) ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¸Ð»Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(462355,12844,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø³Ø±ÙˆØ³ Ú©Ø§Ø±Ú©Ù† Ú©Ù„Ø§Ø³ Ø§ÛŒÚ© Ú©Ù… Ø§Ø² Ú©Ù… (1) Ù…Ù„Ø§Ø²Ù… ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û Ú©Ùˆ ØªÙÙˆÛŒØ¶',0),(462356,12844,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´Ð°Ð²Ð°ÑšÐµ ÑƒÑÐ»ÑƒÐ³Ðµ Ñ€Ð°Ð´Ð½Ð¸ÐºÑƒ Ð½Ð°Ñ˜Ð¼Ð°ÑšÐµ Ñ˜ÐµÐ´Ð°Ð½ (1) Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(462357,12844,'vi','vui lÃ²ng phÃ¢n chia dá»‹ch vá»¥ cÃ´ng viá»‡c cho Ã­t nháº¥t 1 ngÆ°á»i lao Ä‘á»™ng hoáº·c nhÃ  cung cáº¥p',0),(462358,12844,'af','Wys asseblief \'n diens werker klas vir ten minste een (1) werknemer of handelaar',0),(462359,12844,'ro','VÄƒ rugÄƒm sÄƒ asociaÅ£i o clasÄƒ de lucrÄƒtor de serviciu cel puÅ£in un (1) angajatul sau furnizor',0),(462360,12844,'et','Palun mÃ¤Ã¤rata tÃ¶Ã¶taja teenindusklass vÃ¤hemalt Ã¼ks (1) tÃ¶Ã¶taja vÃµi hankija',0),(462361,12844,'si','Prosim dodelite storitev delavec razred vsaj enega (1) delavec ali dobavitelja',0),(462362,12844,'ba','Silakan menetapkan kelas pekerja layanan untuk setidaknya satu (1) karyawan atau Vendor',0),(462363,12844,'nl','Gelieve een serviceklasse werknemer aan ten minste Ã©Ã©n (1) werknemer of leverancier toewijzen',0),(462364,12844,'fi','MÃ¤Ã¤ritÃ¤ tyÃ¶ntekijÃ¤n palveluluokan vÃ¤hintÃ¤Ã¤n yksi (1) tyÃ¶ntekijÃ¤n tai toimittajan',0),(462365,12844,'no','Vennligst Tildel en arbeidstaker tjenesteklassen minst Ã©n (1) ansatt eller leverandÃ¸r',0),(462366,12844,'da','Tildel en Service arbejdstager klasse til mindst Ã©n (1) medarbejderen eller leverandÃ¸r',0),(462367,12844,'ko','ì ì–´ë„ í•˜ë‚˜ì˜ (1) ì§ì› ë˜ëŠ” ê³µê¸‰ ì—…ì²´ì— ì„œë¹„ìŠ¤ ìž‘ì—…ìž í´ëž˜ìŠ¤ë¥¼ í• ë‹¹ í•˜ì‹­ì‹œì˜¤',0),(462368,12844,'he','×‘×‘×§×©×” ×œ×”×§×¦×•×ª ×ž×—×œ×§×” ×¢×•×‘×“ ×©×™×¨×•×ª ×œ×¤×—×•×ª ××—×ª (1) ×”×¢×•×‘×“ ××• ×¡×¤×§',0),(462369,12844,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ Î¼Î¹Î± Ï…Ï€Î·ÏÎµÏƒÎ¯Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ ÏƒÎµ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î­Î½Î± (1) Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(462370,12844,'zh','è¯·å°†æœåŠ¡ Worker ç±»åˆ†é…åˆ°è‡³å°‘ä¸€ä¸ª 1 å‘˜å·¥æˆ–ä¾›åº”å•†',0),(462371,12844,'sv','VÃ¤nligen tilldela en tjÃ¤nst arbetstagare klass fÃ¶r Ã¥tminstone en (1) medarbetare eller leverantÃ¶r',0),(462372,12844,'it','Per favore assegnare una classe di servizio lavoro almeno uno 1 dipendente o fornitore',0),(462373,12844,'tl','',0),(462374,12844,'th','à¸à¸£à¸¸à¸“à¸²à¸à¸³à¸«à¸™à¸”à¹ƒà¸«à¹‰à¸„à¸¥à¸²à¸ªà¸šà¸£à¸´à¸à¸²à¸£à¸œà¸¹à¹‰à¸›à¸à¸´à¸šà¸±à¸•à¸´à¸‡à¸²à¸™à¸­à¸¢à¹ˆà¸²à¸‡à¸™à¹‰à¸­à¸¢à¸«à¸™à¸¶à¹ˆà¸‡ (1) à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸«à¸£à¸·à¸­à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(462375,12844,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¸à¥‡à¤µà¤¾ à¤®à¤œà¤¦à¥‚à¤° à¤µà¤°à¥à¤— à¤•à¥‡ à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• (1) à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(462376,12844,'ms','Sila peruntukkan kelas pekerja Perkhidmatan sekurang-kurangnya satu (1) pekerja atau Penjual',0),(462377,12844,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¹ÙŠÙŠÙ† \"ÙØ¦Ø© Ø¹Ø§Ù…Ù„ Ø§Ù„Ø®Ø¯Ù…Ø©\" Ù„Ù„Ù…ÙˆØ¸Ù Ø£Ùˆ Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„ ÙˆØ§Ø­Ø¯ 1',0),(462378,12844,'fr','Veuillez attribuer une classe de Service de travail au moins un 1 employÃ© ou fournisseur',0),(462379,12844,'jp','å°‘ãªãã¨ã‚‚ 1 ã¤ã® 1 å¾“æ¥­å“¡ã¾ãŸã¯ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’ã‚µãƒ¼ãƒ“ã‚¹ ãƒ¯ãƒ¼ã‚«ãƒ¼ ã‚¯ãƒ©ã‚¹ã‚’å‰²ã‚Šå½“ã¦ã¦ãã ã•ã„ã€‚',0),(462380,12844,'pt','Por favor, atribua uma classe de trabalhador do serviÃ§o a pelo menos 1 de um empregado ou fornecedor',0),(462381,12844,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð½Ð°Ð·Ð½Ð°Ñ‡ÑŒÑ‚Ðµ Ð¿Ð¾ ÐºÑ€Ð°Ð¹Ð½ÐµÐ¹ Ð¼ÐµÑ€Ðµ Ð¾Ð´Ð½Ð¾Ð³Ð¾ (1) Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº Ð¸Ð»Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº ÐºÐ»Ð°ÑÑ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ° ÑÐ»ÑƒÐ¶Ð±Ñ‹',0),(462382,12844,'es','Favor de asignar un Clase de Trabajadores de Servicos al por lo menos de un Empleado o Vendedor',0),(462383,12844,'de','Bitte weisen Sie eine Service-Worker-Klasse mit mindestens einem 1 Mitarbeiter oder Kreditor',0),(462384,12844,'en','Please assign a Service Worker Class to at least one (1) Employee or Vendor',0),(462385,12845,'is','',0),(462386,12845,'dr','(Ù…Ø¯ÛŒØ±-Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ ÙØ±Ù…Ø§ÛŒØ´Ø§Øª ',0),(462387,12845,'pr','Ù„Ø·ÙØ§ Ø­Ø¯Ø§Ù‚Ù„ ÛŒÚ© Ù†ÙˆØ¹ Ø³Ø±ÙˆÛŒØ³ Ø±Ø§ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ú©Ù†ÛŒØ¯Ùˆ ÛŒÚ© Ú¯Ø±ÙˆÙ‡ Ø®Ø¯Ù…Ø§Øª(Ù…Ø¯ÛŒØ±-Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª ',0),(462388,12845,'tr','LÃ¼tfen en az bir (1) hizmet tÃ¼rÃ¼ ve bir (1) hizmet sÄ±nÄ±fÄ±-> Kur-emir (YÃ¶netici) ayarlayÄ±n',0),(462389,12845,'pl','ProszÄ™ ustawiÄ‡ typ usÅ‚ugi co najmniej jeden (1) i jeden (1) klasy usÅ‚ugi (Admin-> instalacji-zamÃ³wienia)',0),(462390,12845,'bg','ÐœÐ¾Ð»Ñ, Ð·Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð°Ð¹-Ð¼Ð°Ð»ÐºÐ¾ ÐµÐ´Ð¸Ð½ (1) ÑƒÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð¸ ÐµÐ´Ð¸Ð½ (1) ÑƒÑÐ»ÑƒÐ³Ð°Ñ‚Ð° ÐºÐ»Ð°Ñ (Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°)',0),(462391,12845,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø³Ø±ÙˆØ³ Ù‚Ø³Ù… Ø§ÛŒÚ© Ú©Ù… Ø§Ø² Ú©Ù… (1) Ø§ÙˆØ± Ø§ÛŒÚ© (1) Ø³Ø±ÙˆØ³ Ú©Ù„Ø§Ø³ (Ø§ÛŒÚˆÙ…Ù†-> Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Û’ Ø­Ú©Ù…) Ù…Ø±ØªØ¨ Ú©Ø±ÛŒÚº',0),(462392,12845,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° Ð¿Ð¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð²Ñ€ÑÑ‚Ñƒ ÑÐµÑ€Ð²Ð¸ÑÐ° Ð·Ð° Ð½Ð°Ñ˜Ð¼Ð°ÑšÐµ Ñ˜ÐµÐ´Ð°Ð½ (1) Ð¸ Ñ˜ÐµÐ´Ð°Ð½ (1) ÑƒÑÐ»ÑƒÐ³Ð° ÐºÐ»Ð°ÑÐµ (ÐÐ´Ð¼Ð¸Ð½ Ð¸ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°)',0),(462393,12845,'vi','vui lÃ²ng thiáº¿t láº­p Ã­t nháº¥t 1 loáº¡i dá»‹ch vá»¥ vÃ  má»™t cáº¥p dá»‹ch vá»¥ (Admin->setup->orders)',0),(462394,12845,'af','Stel asseblief ten minste een (1) diens tipe en een (1) diens klas (Admin-> opstel-bestellings)',0),(462395,12845,'ro','VÄƒ rugÄƒm sÄƒ parametrizaÅ£i cel puÅ£in un (1) tipul de serviciu ÅŸi un (1) Serviciul de clasa (Admin-> configurare comenzi)',0),(462396,12845,'et','Palun seadistage vÃ¤hemalt Ã¼ks (1) teenuse liik ja Ã¼he (1) teenuse klass (Admin-> seadistuse-tellimused)',0),(462397,12845,'si','Prosim nastavite vsaj enega (1) vrsto storitve in en (1) storitev razred (Admin-> Setup-naroÄila)',0),(462398,12845,'ba','Silakan membuat setidaknya satu (1) jenis layanan dan satu (1) Service Class (Admin-> Setup-order)',0),(462399,12845,'nl','Service Type ten minste Ã©Ã©n (1) en Ã©Ã©n (1) Service-klasse (Admin-> Setup-Orders) kunt u instellen',0),(462400,12845,'fi','MÃ¤Ã¤ritÃ¤ vÃ¤hintÃ¤Ã¤n yksi (1) tyyppi ja yksi (1) Palveluluokka (Admin-> asetukset-tilaukset)',0),(462401,12845,'no','Angi minst Ã©n (1) tjenestetype og ett (1) tjenesteklassen (Admin-> Setup-ordrer)',0),(462402,12845,'da','Skal du oprette mindst Ã©n (1) Service Type og Ã©t (1) tjenesteklassen (Admin-> Setup-ordrer)',0),(462403,12845,'ko','ì„œë¹„ìŠ¤ ìœ í˜•ì„ ìµœì†Œí•œ í•˜ë‚˜ (1) ë° (1) ì„œë¹„ìŠ¤ í´ëž˜ìŠ¤ (ê´€ë¦¬ìž ì„¤ì¹˜ ìˆœì„œ->)ë¥¼ ì„¤ì • í•˜ì‹­ì‹œì˜¤',0),(462404,12845,'he','× × ×”×’×“×¨ ××ª ×¡×•×’ ×”×©×™×¨×•×ª ×œ×¤×—×•×ª ××—×ª (1) ×•××—×“ (1) ×ž×—×œ×§×ª ×©×™×¨×•×ª (×ž× ×”×œ-> ×”×”×ª×§× ×”-Orders)',0),(462405,12845,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î¿ÏÎ¯ÏƒÏ„Îµ ÎµÎ´ÏŽ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î­Î½Î± (1) Ï„ÏÏ€Î¿Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ ÎºÎ±Î¹ Î­Î½Î± (1) ÎºÎ»Î¬ÏƒÎ· Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚ (Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·-Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚)',0),(462406,12845,'zh','è¯·è®¾ç½®è‡³å°‘ä¸€ä¸ª 1 æœåŠ¡ç±»åž‹å’Œä¸€ä¸ª 1 æœåŠ¡ç±» ï¼ˆ-> å®‰è£…è®¢å•ç®¡ç†å‘˜ï¼‰',0),(462407,12845,'sv','StÃ¤ll upp minst en (1) typ av tjÃ¤nst och en (1) tjÃ¤nste-klassificerar (Admin-> Setup-order)',0),(462408,12845,'it','Per favore, impostare tipo di servizio di almeno un 1 e 1 una classe di servizio (Admin-> Setup-ordini)',0),(462409,12845,'tl','',0),(462410,12845,'th','à¸à¸£à¸¸à¸“à¸²à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸­à¸¢à¹ˆà¸²à¸‡à¸™à¹‰à¸­à¸¢à¸«à¸™à¸¶à¹ˆà¸‡ (1) à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸šà¸£à¸´à¸à¸²à¸£à¹à¸¥à¸°à¸«à¸™à¸¶à¹ˆà¸‡ (1) à¸šà¸£à¸´à¸à¸²à¸£à¸„à¸¥à¸²à¸ª (Admin->à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡)',0),(462411,12845,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• (1) à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤”à¤° (1) à¤¸à¥‡à¤µà¤¾ à¤µà¤°à¥à¤— (à¤¸à¥‡à¤Ÿà¤…à¤ª à¤†à¤¦à¥‡à¤¶-> à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤•) à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(462412,12845,'ms','Sila sediakan sekurang-kurangnya satu (1) jenis perkhidmatan dan satu (1) Perkhidmatan kelas (Admin-> persediaan-pesanan)',0),(462413,12845,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¹Ø¯Ø§Ø¯ Ù†ÙˆØ¹ Ø§Ù„Ø®Ø¯Ù…Ø© 1 ÙˆØ§Ø­Ø¯ Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„ØŒ ÙˆÙØ¦Ø© Ø§Ù„Ø®Ø¯Ù…Ø© 1 ÙˆØ§Ø­Ø¯ (Ø§Ù„Ù…Ø´Ø±Ù-> Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯)',0),(462414,12845,'fr','S\'il vous plaÃ®t mettre en place au moins un 1 Type de Service et 1 une classe de Service (Admin-> Setup-commandes)',0),(462415,12845,'jp','å°‘ãªãã¨ã‚‚ 1 ã¤ 1 ã‚µãƒ¼ãƒ“ã‚¹ã®ç¨®é¡žã¨ 1 ã¤ 1 ã®ã‚µãƒ¼ãƒ“ã‚¹ ã‚¯ãƒ©ã‚¹ ï¼ˆç®¡ç†è€…ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—æ³¨æ–‡->ï¼‰ ã‚’è¨­å®šã—ã¦ãã ã•ã„ã€‚',0),(462416,12845,'pt','Por favor, configurar o tipo de serviÃ§o pelo menos um 1 e 1 uma classe de serviÃ§o (Admin-> Setup-ordens)',0),(462417,12845,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð¿Ð¾ ÐºÑ€Ð°Ð¹Ð½ÐµÐ¹ Ð¼ÐµÑ€Ðµ Ð¾Ð´Ð½Ð¾Ð³Ð¾ (1) Ð¸ Ð¾Ð´Ð¸Ð½ (1) ÐºÐ»Ð°ÑÑ ÑÐ»ÑƒÐ¶Ð±Ñ‹ (Admin-> ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸-Ð·Ð°ÐºÐ°Ð·Ñ‹)',0),(462418,12845,'es','Favor configurar por lo menos un Tipo de Servicio y un Clase de Servicio (Admin -> Configurar-Pedidos)',0),(462419,12845,'de','Richten Sie bitte mindestens ein 1-Diensttyp und eine 1-Service-Klasse (Admin-> Setup-Bestellungen)',0),(462420,12845,'en','Please set up at least one (1) Service Type and one (1) Service Class (Admin -> Setup-Orders)',0),(462421,12846,'is','',0),(462422,12846,'dr','ÙØ§Ú©ØªÙˆØ± Ù¾Ø§ÛŒØ§Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª ',0),(462423,12846,'pr','ÙØ§Ú©ØªÙˆØ± Ù¾Ø§ÛŒØ§Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª ',0),(462424,12846,'tr','Fatura son notlar',0),(462425,12846,'pl','Faktura koniec notatki',0),(462426,12846,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° ÐºÑ€Ð°Ð¹ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(462427,12846,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ø®ØªØªØ§Ù…ÛŒ Ù†ÙˆÙ¹',0),(462428,12846,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð·Ð° ÐºÑ€Ð°Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(462429,12846,'vi','ghi chÃº cuá»‘i hÃ³a Ä‘Æ¡n ',0),(462430,12846,'af','Faktuur einde notas',0),(462431,12846,'ro','Notele de final facturÄƒ',0),(462432,12846,'et','Arve End mÃ¤rkmed',0),(462433,12846,'si','RaÄun konec opombe',0),(462434,12846,'ba','Catatan akhir faktur',0),(462435,12846,'nl','Factuur eindnoten',0),(462436,12846,'fi','Laskun lopussa toteaa',0),(462437,12846,'no','Faktura fotnoter',0),(462438,12846,'da','Faktura slutningen noter',0),(462439,12846,'ko','ì†¡ìž¥ ë ë…¸íŠ¸',0),(462440,12846,'he','×”×¢×¨×•×ª ×¡×™×•× ×—×©×‘×•× ×™×ª',0),(462441,12846,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï„Î­Î»Î¿Ï…Ï‚',0),(462442,12846,'zh','å‘ç¥¨ç»“æŸæ³¨é‡Š',0),(462443,12846,'sv','Faktura slutet anteckningar',0),(462444,12846,'it','Note di fine fattura',0),(462445,12846,'tl','',0),(462446,12846,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸—à¹‰à¸²à¸¢à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(462447,12846,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤…à¤‚à¤¤ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(462448,12846,'ms','Nota-Nota akhir invois',0),(462449,12846,'ar','ÙˆØªÙ„Ø§Ø­Ø¸ Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(462450,12846,'fr','Notes de fin de facture',0),(462451,12846,'jp','è«‹æ±‚æ›¸ã®æœ€å¾Œã®ãƒŽãƒ¼ãƒˆ',0),(462452,12846,'pt','Notas finais de factura',0),(462453,12846,'ru','ÐžÑ‚Ð¼ÐµÑ‡Ð°ÐµÑ‚ ÐºÐ¾Ð½ÐµÑ† ÑÑ‡ÐµÑ‚Ð°',0),(462454,12846,'es','Notas Finales Facturas',0),(462455,12846,'de','Rechnung-Filme',0),(462456,12846,'en','Invoice End Notes',0),(462457,12847,'is','',0),(462458,12847,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ù¾Ø§ÛŒØ§Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª  ',0),(462459,12847,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ù¾Ø§ÛŒØ§Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª  ',0),(462460,12847,'tr','PO son notlar',0),(462461,12847,'pl','PO koniec notatki',0),(462462,12847,'bg','PO ÐºÑ€Ð°Ð¹ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(462463,12847,'ur','Ù¾Ùˆ Ø§Ø®ØªØªØ§Ù…ÛŒ Ù†ÙˆÙ¹',0),(462464,12847,'sr','ÐŸÐž ÐºÑ€Ð°Ñ˜Ñƒ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(462465,12847,'vi','ghi chÃº cuá»‘i Ä‘Æ¡n mua hÃ ng',0),(462466,12847,'af','Posbus einde notas',0),(462467,12847,'ro','Notele de final PO',0),(462468,12847,'et','PO End mÃ¤rkmed',0),(462469,12847,'si','PO koncu opombe',0),(462470,12847,'ba','Catatan akhir PO',0),(462471,12847,'nl','PO eindnoten',0),(462472,12847,'fi','PO lopussa toteaa',0),(462473,12847,'no','PO fotnoter',0),(462474,12847,'da','PO slutningen noter',0),(462475,12847,'ko','í¬ ë ë…¸íŠ¸',0),(462476,12847,'he','×¤×• ×¡×•×£ ×¤×ª×§×™×',0),(462477,12847,'el','PO ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï„Î­Î»Î¿Ï…Ï‚',0),(462478,12847,'zh','å¤§åŸ”å°¾éƒ¨é™„æ³¨',0),(462479,12847,'sv','PO slutet anteckningar',0),(462480,12847,'it','Note finali di PO',0),(462481,12847,'tl','',0),(462482,12847,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸—à¹‰à¸²à¸¢ PO',0),(462483,12847,'hi','PO à¤…à¤‚à¤¤ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(462484,12847,'ms','Nota-Nota akhir PO',0),(462485,12847,'ar','Øµ. Ø¨ Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(462486,12847,'fr','Notes de fin de PO',0),(462487,12847,'jp','PO æ–‡æœ«è„šæ³¨',0),(462488,12847,'pt','Notas finais de PO',0),(462489,12847,'ru','PO ÐºÐ¾Ð½ÐµÑ† Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(462490,12847,'es','OC Notas Finales',0),(462491,12847,'de','PO-Filme',0),(462492,12847,'en','PO End Notes',0),(462493,12848,'is','',0),(462494,12848,'dr','- Ù…Ø¯ÛŒØ±ÛŒØª',0),(462495,12848,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ - Ù…Ø¯ÛŒØ±ÛŒØª',0),(462496,12848,'tr','Kurulum - Admin',0),(462497,12848,'pl','Instalator - Admin',0),(462498,12848,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€',0),(462499,12848,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ - Ø§ÛŒÚˆÙ…Ù†',0),(462500,12848,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - ÐÐ´Ð¼Ð¸Ð½',0),(462501,12848,'vi','Thiáº¿t láº­p-quáº£n trá»‹',0),(462502,12848,'af','Opstelling - Admin',0),(462503,12848,'ro','Configurare - Admin',0),(462504,12848,'et','Setup - Admin',0),(462505,12848,'si','Setup - Admin',0),(462506,12848,'ba','Pengaturan - Admin',0),(462507,12848,'nl','Setup - Admin',0),(462508,12848,'fi','Setup - Admin',0),(462509,12848,'no','Oppsett - Admin',0),(462510,12848,'da','Setup - Admin',0),(462511,12848,'ko','ì„¤ì •-ê´€ë¦¬ìž',0),(462512,12848,'he','×”×’×“×¨×•×ª - Admin',0),(462513,12848,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· - Admin',0),(462514,12848,'zh','è®¾ç½®-ç®¡ç†å‘˜',0),(462515,12848,'sv','Setup - Admin',0),(462516,12848,'it','Installazione - Admin',0),(462517,12848,'tl','',0),(462518,12848,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² - Admin',0),(462519,12848,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤•',0),(462520,12848,'ms','Persediaan - Admin',0),(462521,12848,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯--Ø§Ù„Ù…Ø´Ø±Ù',0),(462522,12848,'fr','Installation - Admin',0),(462523,12848,'jp','ç®¡ç†è€…ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(462524,12848,'pt','InstalaÃ§Ã£o - Admin',0),(462525,12848,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° - Admin',0),(462526,12848,'es','ConfiguraciÃ³n  - Admin',0),(462527,12848,'de','Setup - Admin',0),(462528,12848,'en','Setup - Admin',0),(462529,12849,'is','',0),(462530,12849,'dr','Ù…Ø³ÛŒØ±Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(462531,12849,'pr','Ù…Ø³ÛŒØ±Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(462532,12849,'tr','Eklenti dizini',0),(462533,12849,'pl','Rozszerzenia katalogu',0),(462534,12849,'bg','Ð”Ð¾Ð±Ð°Ð²ÐºÐ° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ñ',0),(462535,12849,'ur','Ø¨Ø±-Ø§ Ø¶Ø§ÙÛ ÚˆØ§Ø¦Ø±ÛŒÚ©Ù¹Ø±ÛŒ',0),(462536,12849,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð°Ðº ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³Ð°',0),(462537,12849,'vi','Add -on directory',0),(462538,12849,'af','Byvoegsel gids',0),(462539,12849,'ro','Supliment Director',0),(462540,12849,'et','Lisandmooduli kataloog',0),(462541,12849,'si','Dodatek imenik',0),(462542,12849,'ba','Add-On direktori',0),(462543,12849,'nl','Add-On Directory',0),(462544,12849,'fi','Add-On hakemisto',0),(462545,12849,'no','Add-On Directory',0),(462546,12849,'da','TilfÃ¸jelse Register',0),(462547,12849,'ko','ë¶€ê°€ ê¸°ëŠ¥ ë””ë ‰í„°ë¦¬',0),(462548,12849,'he','×ž×“×¨×™×š ×”×¨×—×‘×”',0),(462549,12849,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î¿ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿',0),(462550,12849,'zh','åŠ è½½ç›®å½•',0),(462551,12849,'sv','TillÃ¤gg katalog',0),(462552,12849,'it','Componente aggiuntivo Directory',0),(462553,12849,'tl','',0),(462554,12849,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¹„à¸”à¹€à¸£à¸à¸—à¸­à¸£à¸µ',0),(462555,12849,'hi','à¤à¤¡-à¤‘à¤¨ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¤¿à¤•à¤¾',0),(462556,12849,'ms','Direktori tambahan',0),(462557,12849,'ar','Ø§Ù„Ø¯Ù„ÙŠÙ„ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(462558,12849,'fr','RÃ©pertoire de l\'Add-on',0),(462559,12849,'jp','ã‚¢ãƒ‰ã‚ªãƒ³ ãƒ‡ã‚£ãƒ¬ã‚¯ãƒˆãƒª',0),(462560,12849,'pt','DiretÃ³rio de complemento',0),(462561,12849,'ru','ÐšÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(462562,12849,'es','Agregar sobre Directorio',0),(462563,12849,'de','Add-on-Verzeichnis',0),(462564,12849,'en','Add-On Directory',0),(462565,12850,'is','',0),(462566,12850,'dr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª Ø¨Ø§Ù†Ú© Ù‚Ø¨Ù„ Ø§Ø² ØªØ±Ø§Ø² Ù¾Ø§ÛŒØ§Ù†ÛŒ',0),(462567,12850,'pr','ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª Ø¨Ø§Ù†Ú© Ù‚Ø¨Ù„ Ø§Ø² ØªØ±Ø§Ø² Ù¾Ø§ÛŒØ§Ù†ÛŒ',0),(462568,12850,'tr','Banka deyimi Ã¶nceki bitiÅŸ bakiyesi',0),(462569,12850,'pl','Bilansu banku przed zakoÅ„czeniem instrukcja',0),(462570,12850,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ ÐºÑ€Ð°Ð¹ Ð±Ð°Ð»Ð°Ð½Ñ',0),(462571,12850,'ur','Ø¨ÛŒÙ†Ú© Ú©Ø§ Ø¨ÛŒØ§Ù† Ù¾ÛÙ„Û’ Ø®ØªÙ… ÛÙˆÙ†Û’ ØªÙˆØ§Ø²Ù†',0),(462572,12850,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð¸Ð³ÑƒÐ¼Ð°Ð½ ÐºÑ€Ð°Ñ˜ Ð½Ð° Ñ€Ð°Ñ†ÑƒÐ½Ñƒ',0),(462573,12850,'vi','Sá»‘ dÆ° ngÃ¢n hÃ ngcuá»‘i ká»³ trÆ°á»›c ',0),(462574,12850,'af','Bank verklaring vooraf einde balans',0),(462575,12850,'ro','Bancare declaraÅ£ie prealabilÄƒ care se Ã®ncheie echilibru',0),(462576,12850,'et','Panga vÃ¤ljavÃµte eelneva lÃµppsaldo',0),(462577,12850,'si','Banka predhodno izjavo konÄni saldo',0),(462578,12850,'ba','Saldo akhir sebelum pernyataan bank',0),(462579,12850,'nl','Verklaring voorafgaande Ending banksaldo',0),(462580,12850,'fi','Pankin ilmoitus ennen loppusaldo',0),(462581,12850,'no','Bank uttalelse tidligere sluttsaldo',0),(462582,12850,'da','Bank erklÃ¦ring forudgÃ¥ende slutsaldo',0),(462583,12850,'ko','ì€í–‰ ë¬¸ ì‚¬ì „ ê²°ë§ ê· í˜•',0),(462584,12850,'he','×™×ª×¨×ª ×—×©×‘×•×Ÿ ×”×‘× ×§ ×¡×•×£ ×ž×•×§×“×ž×ª ×”×¦×”×¨×”',0),(462585,12850,'el','Î”Î®Î»Ï‰ÏƒÎ· Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î·Ï‚ Ï„ÎµÏÎ¼Î±Ï„Î¹ÏƒÎ¼ÏŒ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± Ï„ÏÎ±Ï€ÎµÎ¶ÏŽÎ½',0),(462586,12850,'zh','é“¶è¡Œå£°æ˜Žäº‹å…ˆæœŸæœ«ä½™é¢',0),(462587,12850,'sv','Bank uttalande tidigare slut balans',0),(462588,12850,'it','Saldi di fine previa dichiarazione di banca',0),(462589,12850,'tl','',0),(462590,12850,'th','à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸ªà¸´à¹‰à¸™à¸‡à¸§à¸”à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸¢à¸­à¸”à¸ˆà¸²à¸à¸˜à¸™à¸²à¸„à¸²à¸£',0),(462591,12850,'hi','à¤¬à¥ˆà¤‚à¤• à¤¬à¤¯à¤¾à¤¨ à¤ªà¥‚à¤°à¥à¤µ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¸à¤‚à¤¤à¥à¤²à¤¨',0),(462592,12850,'ms','Baki berakhir awal Penyata Bank',0),(462593,12850,'ar','Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ø®ØªØ§Ù…ÙŠ Ø§Ù„Ø³Ø§Ø¨Ù‚Ø© Ø¨ÙŠØ§Ù† Ù„Ù„Ø¨Ù†Ùƒ',0),(462594,12850,'fr','Solde en banque dÃ©claration prÃ©alable fin',0),(462595,12850,'jp','éŠ€è¡Œã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆå‰æœŸæœ«æ®‹é«˜',0),(462596,12850,'pt','Saldo final de prÃ©via declaraÃ§Ã£o',0),(462597,12850,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ Ð±Ð°Ð½ÐºÐ° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð´Ð¾ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(462598,12850,'es','Saldo Anterior del Estado de Cuenta Bancaria',0),(462599,12850,'de','Banksaldo Anweisung vor Ende',0),(462600,12850,'en','Bank Statement Prior Ending Balance',0),(462601,12851,'is','',0),(462602,12851,'dr','Ø¯ÛŒØ¯Ù† ÙØ§ÛŒÙ„ Ù¾ÛŒÙˆØ³Øª',0),(462603,12851,'pr','Ø¯ÛŒØ¯Ù† ÙØ§ÛŒÙ„ Ù¾ÛŒÙˆØ³Øª',0),(462604,12851,'tr','Eki gÃ¶rmek',0),(462605,12851,'pl','Patrz zaÅ‚Ä…cznik',0),(462606,12851,'bg','Ð’Ð¸Ð¶ Ð¿Ñ€Ð¸ÐºÐ°Ñ‡ÐµÐ½Ð¸Ñ Ñ„Ð°Ð¹Ð»',0),(462607,12851,'ur','Ù…Ù„Ø­Ù‚ Ø¯ÛŒÚ©Ú¾Ùˆ',0),(462608,12851,'sr','Ð’Ð¸Ð´Ð¸ Ð¿Ñ€Ð¸Ð»Ð¾Ð³',0),(462609,12851,'vi','Xem táº­p tin Ä‘Ã­nh kÃ¨m',0),(462610,12851,'af','Sien Aanhangsel',0),(462611,12851,'ro','A se vedea ataÅŸamentul',0),(462612,12851,'et','Vt manust',0),(462613,12851,'si','Glej Prilogo',0),(462614,12851,'ba','Lihat Lampiran',0),(462615,12851,'nl','Zie bijlage',0),(462616,12851,'fi','Ks. liite',0),(462617,12851,'no','Se vedlegg',0),(462618,12851,'da','Se vedhÃ¦ftet fil',0),(462619,12851,'ko','ì²¨ë¶€ íŒŒì¼ ì°¸ì¡°',0),(462620,12851,'he','×¨××” ×§×•×‘×¥ ×ž×¦×•×¨×£',0),(462621,12851,'el','Î”ÎµÎ¯Ï„Îµ Ï„Î¿ ÏƒÏ…Î½Î·Î¼Î¼Î­Î½Î¿',0),(462622,12851,'zh','è¯·å‚é˜…é™„ä»¶',0),(462623,12851,'sv','Se bilaga',0),(462624,12851,'it','Vedi allegato',0),(462625,12851,'tl','',0),(462626,12851,'th','à¸”à¸¹à¹€à¸­à¸à¸ªà¸²à¸£à¹à¸™à¸š',0),(462627,12851,'hi','à¤…à¤¨à¥à¤²à¤—à¥à¤¨à¤• à¤¦à¥‡à¤–à¥‡à¤‚',0),(462628,12851,'ms','Sila lihat lampiran',0),(462629,12851,'ar','Ø§Ù†Ø¸Ø± Ø§Ù„Ù…Ø±ÙÙ‚Ø§Øª',0),(462630,12851,'fr','Voir la piÃ¨ce jointe',0),(462631,12851,'jp','æ·»ä»˜ãƒ•ã‚¡ã‚¤ãƒ«ã‚’å‚ç…§ã—ã¦ãã ã•ã„ã€‚',0),(462632,12851,'pt','Ver anexo',0),(462633,12851,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð²Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(462634,12851,'es','Ve Anexo',0),(462635,12851,'de','Siehe Anlage',0),(462636,12851,'en','See Attachment',0),(462637,12852,'is','',0),(462638,12852,'dr','ØªØ§Ø±ÛŒØ® ØªØ®ÙÛŒÙ Ù¾Ø§ÛŒØ§Ù† Ù…Ø§Ù‡',0),(462639,12852,'pr','ØªØ§Ø±ÛŒØ® ØªØ®ÙÛŒÙ Ù¾Ø§ÛŒØ§Ù† Ù…Ø§Ù‡',0),(462640,12852,'tr','AyÄ±n tarihi sonu indirim',0),(462641,12852,'pl','Rabat Data koÅ„ca miesiÄ…ca',0),(462642,12852,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð´Ð°Ñ‚Ð° ÐºÑ€Ð°Ð¹ Ð½Ð° Ð¼ÐµÑÐµÑ†',0),(462643,12852,'ur','ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹ Ù…ÛÛŒÙ†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(462644,12852,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° Ð´Ð°Ñ‚ÑƒÐ¼ ÐºÑ€Ð°Ñ˜Ð° Ð¼ÐµÑÐµÑ†Ð°',0),(462645,12852,'vi','Giáº£m giÃ¡ ngÃ y cuá»‘i cÃ¹ng cá»§a thÃ¡ng',0),(462646,12852,'af','Datum einde van maand afslag',0),(462647,12852,'ro','Reducere data sfarsitul lunii',0),(462648,12852,'et','Hinnaalandi kuupÃ¤eva kuu lÃµpuni',0),(462649,12852,'si','Popust datum konca meseca',0),(462650,12852,'ba','DISKON TERBAIK untuk tanggal akhir bulan',0),(462651,12852,'nl','Goedkope datum einde van de maand',0),(462652,12852,'fi','Alennus pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n kuukauden loppuun',0),(462653,12852,'no','Rabatt dato etter mÃ¥ned',0),(462654,12852,'da','Discount dato slutningen af mÃ¥neden',0),(462655,12852,'ko','ë‹¬ì˜ ë ë‚ ì§œë¥¼ í• ì¸',0),(462656,12852,'he','×”× ×—×” ×ª××¨×™×š ×¡×•×£ ×”×—×•×“×©',0),(462657,12852,'el','Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î¼Î®Î½Î±',0),(462658,12852,'zh','æŠ˜æ‰£æ—¥æœŸæˆªè‡³æœˆåº•',0),(462659,12852,'sv','Rabatt datum slutet av mÃ¥naden',0),(462660,12852,'it','Sconto Data fine mese',0),(462661,12852,'tl','',0),(462662,12852,'th','à¸¥à¸”à¸§à¸±à¸™à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢à¸‚à¸­à¸‡à¹€à¸”à¸·à¸­à¸™',0),(462663,12852,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤¤à¤¿à¤¥à¤¿ à¤®à¤¾à¤¹ à¤•à¥‡ à¤…à¤‚à¤¤',0),(462664,12852,'ms','Diskaun tarikh akhir bulan',0),(462665,12852,'ar','Ø®ØµÙ… ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø´Ù‡Ø±',0),(462666,12852,'fr','Date de la fin du mois de remise',0),(462667,12852,'jp','æœˆæœ«æ—¥ã¾ã§ã‚’å‰²å¼•ã—ã¾ã™ã€‚',0),(462668,12852,'pt','Data final do mÃªs de desconto',0),(462669,12852,'ru','Ð”Ð°Ñ‚Ð° ÐºÐ¾Ð½Ñ†Ð° Ð¼ÐµÑÑÑ†Ð° ÑÐºÐ¸Ð´ÐºÐ°',0),(462670,12852,'es','Fecha de Descuento del Fin de Mes',0),(462671,12852,'de','Rabatt Datum Ende des Monats',0),(462672,12852,'en','Discount Date End Of Month',0),(462673,12853,'is','',0),(462674,12853,'dr','Ø®Ø§Ù„Øµ ØªØ§Ø±ÛŒØ® Ø³Ø±Ø±Ø³ÛŒØ¯ Ù¾Ø§ÛŒØ§Ù† Ù…Ø§Ù‡',0),(462675,12853,'pr','Ø®Ø§Ù„Øµ ØªØ§Ø±ÛŒØ® Ø³Ø±Ø±Ø³ÛŒØ¯ Ù¾Ø§ÛŒØ§Ù† Ù…Ø§Ù‡',0),(462676,12853,'tr','Ay sonu tarihi nedeniyle net',0),(462677,12853,'pl','Netto naleÅ¼ne Data koÅ„ca miesiÄ…ca',0),(462678,12853,'bg','NET Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð° ÐºÑ€Ð°Ð¹ Ð½Ð° Ð¼ÐµÑÐµÑ†',0),(462679,12853,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ù…ÛÛŒÙ†Û Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ø¬Ø§Ù„',0),(462680,12853,'sr','ÐÐµÑ‚ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ ÐºÑ€Ð°Ñ˜Ð° Ð¼ÐµÑÐµÑ†Ð°',0),(462681,12853,'vi','NgÃ y Ä‘áº¿n háº¡n thá»±c cuá»‘i cÃ¹ng cá»§a thÃ¡ng',0),(462682,12853,'af','Netto verskuldigde datum einde van die maand',0),(462683,12853,'ro','Net datorate data sfarsitul lunii',0),(462684,12853,'et','Net tÃµttu kuupÃ¤eva kuu lÃµpuni',0),(462685,12853,'si','Net zaradi datum konca meseca',0),(462686,12853,'ba','Net karena tanggal akhir bulan',0),(462687,12853,'nl','Net verschuldigde datum einde van de maand',0),(462688,12853,'fi','NET koska pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n kuukauden loppuun',0),(462689,12853,'no','Netto grunn dato etter mÃ¥ned',0),(462690,12853,'da','Net grund dato slutningen af mÃ¥neden',0),(462691,12853,'ko','Net ë‚ ì§œ ì›”ë§ ì˜ˆì •',0),(462692,12853,'he','× ×˜×• ×¢×§×‘ ×ª××¨×™×š ×¡×•×£ ×”×—×•×“×©',0),(462693,12853,'el','NET Î»ÏŒÎ³Ï‰ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î¼Î®Î½Î±',0),(462694,12853,'zh','åˆ°æœŸæ—¥æœŸæœˆåº•ç½‘',0),(462695,12853,'sv','Net Due Date slutet av mÃ¥naden',0),(462696,12853,'it','Netto dovuto data fine mese',0),(462697,12853,'tl','',0),(462698,12853,'th','à¸ªà¸¸à¸—à¸˜à¸´à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¹€à¸”à¸·à¸­à¸™',0),(462699,12853,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤…à¤‚à¤¤ à¤®à¥‡à¤‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¨à¤¿à¤¯à¤¤ à¤¨à¥‡à¤Ÿ',0),(462700,12853,'ms','Bersih kerana tarikh akhir bulan',0),(462701,12853,'ar','ØµØ§ÙÙŠ Ø§Ù„Ù…Ø³ØªØ­Ù‚ ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø´Ù‡Ø±',0),(462702,12853,'fr','NET Due Date de la fin du mois',0),(462703,12853,'jp','æœˆæœ«æ—¥ã¾ã§äºˆå®š net',0),(462704,12853,'pt','NET Data fim de mÃªs',0),(462705,12853,'ru','NET Ð¸Ð·-Ð·Ð° Ð´Ð°Ñ‚Ñ‹ ÐºÐ¾Ð½Ñ†Ð° Ð¼ÐµÑÑÑ†Ð°',0),(462706,12853,'es','Fecha Vencida Neta Fin de Mes',0),(462707,12853,'de','NET wegen Termin Ende des Monats',0),(462708,12853,'en','Net Due Date End Of Month',0),(462709,12854,'is','',0),(462710,12854,'dr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ±Ø§Ø² Ù…Ø´ØªØ±ÛŒ ',0),(462711,12854,'pr','Ø§ÙØ²ÙˆØ¯Ù† ØªØ±Ø§Ø² Ù…Ø´ØªØ±ÛŒ ',0),(462712,12854,'tr','MÃ¼ÅŸteri bakiyeleri Ekle',0),(462713,12854,'pl','Dodaj klienta salda',0),(462714,12854,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ Ð±Ð°Ð»Ð°Ð½ÑÐ¸',0),(462715,12854,'ur','ÙˆØµÙˆÙ„ Ú©Ø§Ø± Ø¨ÛŒÙ„Ù†Ø³ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(462716,12854,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð° ÑÐ°Ð»Ð´Ð°',0),(462717,12854,'vi','ThÃªm sá»‘ dÆ° khÃ¡ch hÃ ng',0),(462718,12854,'af','Voeg kliÃ«nt saldo\'s',0),(462719,12854,'ro','Adauga solduri Client',0),(462720,12854,'et','Lisada kliendi saldod',0),(462721,12854,'si','Dodajanje odjemalca bilance',0),(462722,12854,'ba','Menambahkan klien saldo',0),(462723,12854,'nl','Client saldi toevoegen',0),(462724,12854,'fi','LisÃ¤Ã¤ asiakkaan saldot',0),(462725,12854,'no','Legge til klienten saldoer',0),(462726,12854,'da','TilfÃ¸je klient saldi',0),(462727,12854,'ko','í´ë¼ì´ì–¸íŠ¸ ê· í˜• ì¶”ê°€',0),(462728,12854,'he','×œ×”×•×¡×™×£ ×™×ª×¨×•×ª ×œ×§×•×—',0),(462729,12854,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î± Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(462730,12854,'zh','æ·»åŠ å®¢æˆ·ä½™é¢',0),(462731,12854,'sv','LÃ¤gg till klienten saldon',0),(462732,12854,'it','Aggiungere Client saldi',0),(462733,12854,'tl','',0),(462734,12854,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(462735,12854,'hi','à¤•à¥à¤²à¤¾à¤‡à¤‚à¤Ÿ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(462736,12854,'ms','Tambah baki pelanggan',0),(462737,12854,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ø±ØµØ¯Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(462738,12854,'fr','Ajouter Client soldes',0),(462739,12854,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆã®æ®‹é«˜ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(462740,12854,'pt','Adicionar cliente saldos',0),(462741,12854,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾ÑÑ‚Ð°Ñ‚ÐºÐ¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(462742,12854,'es','Agregar Balances de Clientes',0),(462743,12854,'de','HinzufÃ¼gen von Client-Salden',0),(462744,12854,'en','Add Client Balances',0),(462745,12855,'is','',0),(462746,12855,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙˆÚ¯ÙˆÛŒ Ø´Ø±Ú©Øª',0),(462747,12855,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù„ÙˆÚ¯ÙˆÛŒ Ø´Ø±Ú©Øª',0),(462748,12855,'tr','Åžirket logo ekleme',0),(462749,12855,'pl','DodaÄ‡ logo firmy',0),(462750,12855,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð¸ Ð»Ð¾Ð³Ð°',0),(462751,12855,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø¹Ù„Ø§Ù…Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(462752,12855,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(462753,12855,'vi','ThÃªm biá»ƒu tÆ°á»£ng cÃ´ng ty',0),(462754,12855,'af','Voeg maatskappy logo\'s',0),(462755,12855,'ro','Adauga firma logo-uri',0),(462756,12855,'et','Lisa firma logod',0),(462757,12855,'si','Dodaj logotipi podjetja',0),(462758,12855,'ba','Menambahkan logo perusahaan',0),(462759,12855,'nl','Bedrijfslogo toevoegen',0),(462760,12855,'fi','LisÃ¤Ã¤ yrityksen logot',0),(462761,12855,'no','Legge til firmalogoer',0),(462762,12855,'da','TilfÃ¸je firmalogoer',0),(462763,12855,'ko','íšŒì‚¬ ë¡œê³ ë¥¼ ì¶”ê°€',0),(462764,12855,'he','×œ×”×•×¡×™×£ ×œ×•×’×• ×—×‘×¨×”',0),(462765,12855,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î± Î»Î¿Î³ÏŒÏ„Ï…Ï€Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(462766,12855,'zh','æ·»åŠ å…¬å¸å¾½æ ‡',0),(462767,12855,'sv','LÃ¤gg till fÃ¶retagslogotyper',0),(462768,12855,'it','Aggiungere loghi aziendali',0),(462769,12855,'tl','',0),(462770,12855,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹‚à¸¥à¹‚à¸à¹‰à¸šà¸£à¸´à¸©à¸±à¸—',0),(462771,12855,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤²à¥‹à¤—à¥‹ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(462772,12855,'ms','Tambah logo syarikat',0),(462773,12855,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø¹Ø§Ø±Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ©',0),(462774,12855,'fr','Ajouter des Logos d\'entreprise',0),(462775,12855,'jp','ä¼šç¤¾ã®ãƒ­ã‚´ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(462776,12855,'pt','Adicionar logotipos da empresa',0),(462777,12855,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿Ñ‹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(462778,12855,'es','Agregar Logos de la Empresa',0),(462779,12855,'de','HinzufÃ¼gen von Firmenlogos',0),(462780,12855,'en','Add Company Logos',0),(462781,12856,'is','',0),(462782,12856,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø±Ø® Ú©Ø§Ø±Ú¯Ø±',0),(462783,12856,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù†Ø±Ø® Ú©Ø§Ø±Ú¯Ø±',0),(462784,12856,'tr','Emek oranlarÄ± Ekle',0),(462785,12856,'pl','DodaÄ‡ pracy cena',0),(462786,12856,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ñ€ÑƒÐ´Ð° Ñ†ÐµÐ½Ð¸',0),(462787,12856,'ur','Ù…Ø²Ø¯ÙˆØ± Ú©ÛŒ Ø´Ø±Ø­ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(462788,12856,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ñ€Ð°Ð´Ð½Ð¾ ÑÑ‚Ð¾Ð¿Ðµ',0),(462789,12856,'vi','ThÃªm tá»· lá»‡ lao Ä‘á»™ng',0),(462790,12856,'af','Voeg arbeid tariewe',0),(462791,12856,'ro','Adauga muncii tarife',0),(462792,12856,'et','Lisada Labor mÃ¤Ã¤rad',0),(462793,12856,'si','Dodaj Labor stopnje',0),(462794,12856,'ba','Tambahkan harga tenaga kerja',0),(462795,12856,'nl','Toevoegen van arbeid tarieven',0),(462796,12856,'fi','LisÃ¤tÃ¤ tyÃ¶voiman hinnat',0),(462797,12856,'no','Legge til Ap. priser',0),(462798,12856,'da','TilfÃ¸je Labor priser',0),(462799,12856,'ko','ë…¸ë™ ìš”ê¸ˆ ì¶”ê°€',0),(462800,12856,'he','×”×•×¡×¤×ª ×ž×—×™×¨×™ ×”×¢×‘×•×“×”',0),(462801,12856,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î¿ÏƒÎ¿ÏƒÏ„Î¬',0),(462802,12856,'zh','æ·»åŠ åŠ³åŠ¨çŽ‡',0),(462803,12856,'sv','LÃ¤gg till Labor priser',0),(462804,12856,'it','Aggiungi tariffe di manodopera',0),(462805,12856,'tl','',0),(462806,12856,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸­à¸±à¸•à¸£à¸²à¹à¸£à¸‡à¸‡à¸²à¸™',0),(462807,12856,'hi','à¤¶à¥à¤°à¤® à¤¦à¤°à¥‹à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(462808,12856,'ms','Menambah kadar buruh',0),(462809,12856,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ø¯Ù„Ø§Øª Ø§Ù„Ø¹Ù…Ù„',0),(462810,12856,'fr','Ajouter les tarifs du travail',0),(462811,12856,'jp','åŠ´åƒçŽ‡ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(462812,12856,'pt','Adicionar taxas trabalhistas',0),(462813,12856,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ‚Ñ€ÑƒÐ´Ð¾Ð²Ð¾Ð¹ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(462814,12856,'es','Agregar Tasas de Trabajo',0),(462815,12856,'de','Labor Preise hinzufÃ¼gen',0),(462816,12856,'en','Add Labor Rates',0),(462817,12857,'is','',0),(462818,12857,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„',0),(462819,12857,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø­Ù„',0),(462820,12857,'tr','KonumlarÄ± Ekle',0),(462821,12857,'pl','DodaÄ‡ lokalizacje',0),(462822,12857,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¼ÐµÑÑ‚Ð°',0),(462823,12857,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(462824,12857,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(462825,12857,'vi','ThÃªm Ä‘á»‹a Ä‘iá»ƒm',0),(462826,12857,'af','Voeg liggings',0),(462827,12857,'ro','Adauga locatii',0),(462828,12857,'et','Asukohtade lisamiseks',0),(462829,12857,'si','Dodajanje lokacije',0),(462830,12857,'ba','Menambahkan lokasi',0),(462831,12857,'nl','Locaties toevoegen',0),(462832,12857,'fi','LisÃ¤Ã¤ sijainteja',0),(462833,12857,'no','Legge til plasseringer',0),(462834,12857,'da','TilfÃ¸je steder',0),(462835,12857,'ko','ìœ„ì¹˜ ì¶”ê°€',0),(462836,12857,'he','×œ×”×•×¡×™×£ ×ž×™×§×•×ž×™×',0),(462837,12857,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚',0),(462838,12857,'zh','æ·»åŠ ä½ç½®',0),(462839,12857,'sv','LÃ¤gga till platser',0),(462840,12857,'it','Aggiungere posizioni',0),(462841,12857,'tl','',0),(462842,12857,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ªà¸–à¸²à¸™',0),(462843,12857,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(462844,12857,'ms','Tambah lokasi',0),(462845,12857,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ§Ù‚Ø¹',0),(462846,12857,'fr','Ajouter un lieu',0),(462847,12857,'jp','å ´æ‰€ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(462848,12857,'pt','Adicionar locais',0),(462849,12857,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¹',0),(462850,12857,'es','Agregar Locales',0),(462851,12857,'de','HinzufÃ¼gen von Standorten',0),(462852,12857,'en','Add Locations',0),(462853,12858,'is','',0),(462854,12858,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ Ø®Ø¯Ù…Ø§Øª',0),(462855,12858,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ Ø®Ø¯Ù…Ø§Øª',0),(462856,12858,'tr','Hizmet sÄ±nÄ±flarÄ± ekleme',0),(462857,12858,'pl','Dodaj serwis klasy',0),(462858,12858,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð° ÐºÐ»Ð°ÑÐ¾Ð²Ðµ',0),(462859,12858,'ur','Ø®Ø¯Ù…Øª Ú©Ù„Ø§Ø³ÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(462860,12858,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑƒÑÐ»ÑƒÐ³Ðµ Ð¿Ñ€ÐµÐ´Ð°Ð²Ð°ÑšÐ°',0),(462861,12858,'vi','ThÃªm cáº¥p phá»¥c vá»¥',0),(462862,12858,'af','Voeg diens klasse',0),(462863,12858,'ro','Adauga serviciu clase',0),(462864,12858,'et','Lisada teenindustaset',0),(462865,12858,'si','Dodaj storitve razredov',0),(462866,12858,'ba','Tambahkan layanan kelas',0),(462867,12858,'nl','Service klassen toevoegen',0),(462868,12858,'fi','LisÃ¤Ã¤ palveluluokat',0),(462869,12858,'no','Legge til Tjenesteklasser',0),(462870,12858,'da','TilfÃ¸je tjenesteklasser',0),(462871,12858,'ko','ì„œë¹„ìŠ¤ í´ëž˜ìŠ¤ ì¶”ê°€',0),(462872,12858,'he','×”×•×¡×¤×ª ×ž×—×œ×§×•×ª ×©×™×¨×•×ª',0),(462873,12858,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ Ï…Ï€Î·ÏÎµÏƒÎ¯Î± Ï„Î¬Î¾ÎµÎ¹Ï‚',0),(462874,12858,'zh','æ·»åŠ æœåŠ¡ç±»',0),(462875,12858,'sv','LÃ¤gg till tjÃ¤nsteklasser',0),(462876,12858,'it','Aggiungere le classi di servizio',0),(462877,12858,'tl','',0),(462878,12858,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸£à¸´à¸à¸²à¸£à¸Šà¸±à¹‰à¸™',0),(462879,12858,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¤•à¥à¤·à¤¾à¤“à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(462880,12858,'ms','Tambah kelas Perkhidmatan',0),(462881,12858,'ar','Ø¥Ø¶Ø§ÙØ© ÙØ¦Ø§Øª Ø§Ù„Ø®Ø¯Ù…Ø©',0),(462882,12858,'fr','Ajouter des Classes de Service',0),(462883,12858,'jp','ã‚µãƒ¼ãƒ“ã‚¹ ã‚¯ãƒ©ã‚¹ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(462884,12858,'pt','Adicionar Classes de serviÃ§o',0),(462885,12858,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÐºÐ»Ð°ÑÑÑ‹ ÑÐ»ÑƒÐ¶Ð±',0),(462886,12858,'es','Agregar Clases de Servicio',0),(462887,12858,'de','Serviceklassen hinzufÃ¼gen',0),(462888,12858,'en','Add Service Classes',0),(462889,12859,'is','',0),(462890,12859,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·ÙˆØ­ ÙˆØ¶Ø¹ÛŒØª ',0),(462891,12859,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³Ø·ÙˆØ­ ÙˆØ¶Ø¹ÛŒØª ',0),(462892,12859,'tr','Durum dÃ¼zeyleri ekleme',0),(462893,12859,'pl','DodaÄ‡ statusy',0),(462894,12859,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ ÑÑ‚Ð°Ñ‚ÑƒÑ Ð½Ð¸Ð²Ð°',0),(462895,12859,'ur','Ø­Ø§Ù„Øª Ú©ÛŒ Ø³Ø·Ø­ÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(462896,12859,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð¸Ð²Ð¾Ð°',0),(462897,12859,'vi','ThÃªm cáº¥p tÃ¬nh tráº¡ng',0),(462898,12859,'af','Voeg Status vlakke',0),(462899,12859,'ro','AdÄƒugaÅ£i niveluri de stare',0),(462900,12859,'et','Lisada olek',0),(462901,12859,'si','Dodaj Status ravni',0),(462902,12859,'ba','Menambahkan tingkat Status',0),(462903,12859,'nl','Statusniveaus toevoegen',0),(462904,12859,'fi','LisÃ¤Ã¤ tila tasot',0),(462905,12859,'no','Legge til statusnivÃ¥ene',0),(462906,12859,'da','TilfÃ¸je statusniveauer',0),(462907,12859,'ko','ìƒíƒœ ìˆ˜ì¤€ ì¶”ê°€',0),(462908,12859,'he','×”×•×¡×£ ×¨×ž×•×ª ×ž×¦×‘',0),(462909,12859,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÎµÏ€Î¯Ï€ÎµÎ´Î± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(462910,12859,'zh','æ·»åŠ çŠ¶æ€çº§åˆ«',0),(462911,12859,'sv','LÃ¤gga till statusnivÃ¥er',0),(462912,12859,'it','Aggiungere livelli di Status',0),(462913,12859,'tl','',0),(462914,12859,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸°à¸”à¸±à¸šà¸ªà¸–à¸²à¸™à¸°',0),(462915,12859,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¸à¥à¤¤à¤°à¥‹à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(462916,12859,'ms','Menambah tahap Status',0),(462917,12859,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ù…Ø±ÙƒØ²',0),(462918,12859,'fr','Ajouter des niveaux de statut',0),(462919,12859,'jp','çŠ¶æ…‹ã®ãƒ¬ãƒ™ãƒ«ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(462920,12859,'pt','Adicionar nÃ­veis de Status',0),(462921,12859,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑ‚Ð°Ñ‚ÑƒÑ ÑƒÑ€Ð¾Ð²Ð½Ð¸',0),(462922,12859,'es','Agregar Nivel de Estatus',0),(462923,12859,'de','Statusebenen hinzufÃ¼gen',0),(462924,12859,'en','Add Status Levels',0),(462925,12860,'is','',0),(462926,12860,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª',0),(462927,12860,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù†ÙˆØ§Ø¹ Ø®Ø¯Ù…Ø§Øª',0),(462928,12860,'tr','Hizmet tÃ¼rleri ekleme',0),(462929,12860,'pl','DodaÄ‡ rodzaje usÅ‚ug',0),(462930,12860,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²Ð¸Ð´Ð¾Ð²Ðµ ÑƒÑÐ»ÑƒÐ³Ð¸ Ð·Ð°',0),(462931,12860,'ur','Ø³Ø±ÙˆØ³ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(462932,12860,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÑÑ‚Ðµ ÑƒÑÐ»ÑƒÐ³Ð°',0),(462933,12860,'vi','ThÃªm loáº¡i dá»‹ch vá»¥',0),(462934,12860,'af','Voeg tipes van diens',0),(462935,12860,'ro','Adauga tipurile de servicii de',0),(462936,12860,'et','Lisada teenuseliikide',0),(462937,12860,'si','Dodaj vrste storitev',0),(462938,12860,'ba','Menambahkan jenis layanan',0),(462939,12860,'nl','Soorten Service toevoegen',0),(462940,12860,'fi','LisÃ¤Ã¤ palvelut',0),(462941,12860,'no','Legge Service',0),(462942,12860,'da','TilfÃ¸je typer af Service',0),(462943,12860,'ko','ì„œë¹„ìŠ¤ì˜ ì¢…ë¥˜ë¥¼ ì¶”ê°€',0),(462944,12860,'he','×œ×”×•×¡×™×£ ×¡×•×’×™ ×©×™×¨×•×ª',0),(462945,12860,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï„ÏÏ€Î¿Ï…Ï‚ Ï„Î·Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚',0),(462946,12860,'zh','æ·»åŠ æœåŠ¡çš„ç±»åž‹',0),(462947,12860,'sv','LÃ¤gger till typer av Service',0),(462948,12860,'it','Aggiungere tipi di servizio',0),(462949,12860,'tl','',0),(462950,12860,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸šà¸£à¸´à¸à¸²à¸£',0),(462951,12860,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(462952,12860,'ms','Tambah jenis-jenis Perkhidmatan',0),(462953,12860,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù†ÙˆØ§Ø¹ Ù…Ù† Ø§Ù„Ø®Ø¯Ù…Ø©',0),(462954,12860,'fr','Ajouter des Types de Service',0),(462955,12860,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã®ç¨®é¡žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(462956,12860,'pt','Adicionar tipos de serviÃ§o',0),(462957,12860,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð²Ð¸Ð´Ñ‹ ÑƒÑÐ»ÑƒÐ³',0),(462958,12860,'es','Agregar Tipos de Servicio',0),(462959,12860,'de','Arten von Service hinzufÃ¼gen',0),(462960,12860,'en','Add Types of Service',0),(462961,12861,'is','',0),(462962,12861,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø±ÙˆØ¹ ØªØ±Ø§Ø²Ù‡Ø§',0),(462963,12861,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø´Ø±ÙˆØ¹ ØªØ±Ø§Ø²Ù‡Ø§',0),(462964,12861,'tr','Bill BaÅŸlangÄ±Ã§ bakiyesi',0),(462965,12861,'pl','Salda rachunku Start',0),(462966,12861,'bg','Ð‘Ð¸Ð» Ð¡Ñ‚Ð°Ñ€Ñ‚ Ð±Ð°Ð»Ð°Ð½ÑÐ¸',0),(462967,12861,'ur','Ø¨Ù„ Ø´Ø±ÙˆØ¹ Ø¨ÛŒÙ„Ù†Ø³',0),(462968,12861,'sr','Ð‘Ð¸Ð» Ð¡Ñ‚Ð°Ñ€Ñ‚ ÑÐ°Ð»Ð´Ð°',0),(462969,12861,'vi','Láº­p Sá»‘ dÆ° Ä‘áº§u ká»³ ',0),(462970,12861,'af','Wetsontwerp begin saldo\'s',0),(462971,12861,'ro','Bill Ã®ncepe solduri',0),(462972,12861,'et','Bill alguse saldod',0),(462973,12861,'si','Bill zaÄetni saldo',0),(462974,12861,'ba','Bill mulai saldo',0),(462975,12861,'nl','Bill Start saldi',0),(462976,12861,'fi','Bill alkaa saldot',0),(462977,12861,'no','Bill Start balanserer',0),(462978,12861,'da','Bill begyndelsen saldi',0),(462979,12861,'ko','ë¹Œ ì‹œìž‘ ê· í˜•',0),(462980,12861,'he','×‘×™×œ ×”×ª×—×œ×” ×™×ª×¨×•×ª',0),(462981,12861,'el','Î¥Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ Bill Î­Î½Î±ÏÎ¾Î·',0),(462982,12861,'zh','æ¡ä¾‹è‰æ¡ˆå¼€å§‹ä½™é¢',0),(462983,12861,'sv','Bill Start balanser',0),(462984,12861,'it','Bill inizio saldi',0),(462985,12861,'tl','',0),(462986,12861,'th','à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(462987,12861,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤®à¥‡à¤‚ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿',0),(462988,12861,'ms','Baki mula Rang undang-undang',0),(462989,12861,'ar','Ø£Ø±ØµØ¯Ø© Ø¨Ø¯Ø§ÙŠØ© Ø¨ÙŠÙ„',0),(462990,12861,'fr','Projet de loi dÃ©but soldes',0),(462991,12861,'jp','ãƒ“ãƒ«ã®é–‹å§‹æ®‹é«˜',0),(462992,12861,'pt','Saldos de inÃ­cio Bill',0),(462993,12861,'ru','Ð‘Ð¸Ð»Ð» Ð½Ð°Ñ‡Ð°Ð»Ð¾ Ð¾ÑÑ‚Ð°Ñ‚ÐºÐ¸',0),(462994,12861,'es','Recibo Balances de Comienza',0),(462995,12861,'de','Bill Start-Guthaben',0),(462996,12861,'en','Bill Start Balances',0),(462997,12862,'is','',0),(462998,12862,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(462999,12862,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(463000,12862,'tr','Kredi kartÄ± kurulumu',0),(463001,12862,'pl','Ustawienia karty kredytowej',0),(463002,12862,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(463003,12862,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø³ÛŒÙ¹ Ø§Ù¾',0),(463004,12862,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(463005,12862,'vi','thiáº¿t láº­p tháº» tÃ­n dá»¥ng',0),(463006,12862,'af','Kredietkaart Opstelling',0),(463007,12862,'ro','Card de credit de configurare',0),(463008,12862,'et','Krediitkaardi seadistamine',0),(463009,12862,'si','Kreditne kartice Setup',0),(463010,12862,'ba','Kartu kredit Setup',0),(463011,12862,'nl','Credit Card Setup',0),(463012,12862,'fi','Luottokortin asetukset',0),(463013,12862,'no','Kredittkort oppsett',0),(463014,12862,'da','OpsÃ¦tning af kreditkort',0),(463015,12862,'ko','ì‹ ìš© ì¹´ë“œ ì„¤ì •',0),(463016,12862,'he','×”×’×“×¨×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(463017,12862,'el','Î¡ÏÎ¸Î¼Î¹ÏƒÎ· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(463018,12862,'zh','ä¿¡ç”¨å¡è®¾ç½®',0),(463019,12862,'sv','Kreditkort Setup',0),(463020,12862,'it','Installazione di carta di credito',0),(463021,12862,'tl','',0),(463022,12862,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(463023,12862,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(463024,12862,'ms','Persediaan kad kredit',0),(463025,12862,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(463026,12862,'fr','Installation de la carte de crÃ©dit',0),(463027,12862,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(463028,12862,'pt','InstalaÃ§Ã£o do cartÃ£o de crÃ©dito',0),(463029,12862,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(463030,12862,'es','ConfiguraciÃ³n Tarjetas de CrÃ©dito',0),(463031,12862,'de','Kreditkarte-Setup',0),(463032,12862,'en','Credit Card Setup',0),(463033,12863,'is','',0),(463034,12863,'dr','Ø´Ø±ÙˆØ¹ ØªØ±Ø§Ø²Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(463035,12863,'pr','Ø´Ø±ÙˆØ¹ ØªØ±Ø§Ø²Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(463036,12863,'tr','GL BaÅŸlangÄ±Ã§ bakiyesi',0),(463037,12863,'pl','GL Start salda',0),(463038,12863,'bg','GL Ð¡Ñ‚Ð°Ñ€Ñ‚ Ð±Ð°Ð»Ð°Ð½ÑÐ¸',0),(463039,12863,'ur','Ø¬ÛŒØ¬Û’ Ø´Ø±ÙˆØ¹ Ø¨ÛŒÙ„Ù†Ø³',0),(463040,12863,'sr','Ð“Ð› Ð¡Ñ‚Ð°Ñ€Ñ‚ ÑÐ°Ð»Ð´Ð°',0),(463041,12863,'vi','Sá»‘ dÆ° Ä‘áº§u ',0),(463042,12863,'af','GL begin saldo\'s',0),(463043,12863,'ro','Soldurilor de pornire GL',0),(463044,12863,'et','GL alguse saldod',0),(463045,12863,'si','GL zaÄetni saldo',0),(463046,12863,'ba','GL mulai saldo',0),(463047,12863,'nl','GL Start saldi',0),(463048,12863,'fi','GL alusta saldot',0),(463049,12863,'no','GL Start saldoer',0),(463050,12863,'da','GL Start balancer',0),(463051,12863,'ko','GL ì‹œìž‘ ê· í˜•',0),(463052,12863,'he','×™×ª×¨×•×ª ×”×ª×—×œ×” GL',0),(463053,12863,'el','Î¥Ï€ÏŒÎ»Î¿Î¹Ï€Î± Î­Î½Î±ÏÎ¾Î· GL',0),(463054,12863,'zh','GL èµ·å§‹ä½™é¢',0),(463055,12863,'sv','GL Start balanser',0),(463056,12863,'it','GL inizio saldi',0),(463057,12863,'tl','',0),(463058,12863,'th','à¸¢à¸­à¸”à¸”à¸¸à¸¥à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸‚à¸­à¸‡ GL',0),(463059,12863,'hi','à¤œà¥€à¤à¤² à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¸à¤‚à¤¤à¥à¤²à¤¨',0),(463060,12863,'ms','Baki mula GL',0),(463061,12863,'ar','Ø£Ø±ØµØ¯Ø© Ø¨Ø¯Ø§ÙŠØ© GL',0),(463062,12863,'fr','Soldes de dÃ©part GL',0),(463063,12863,'jp','GL ã®é–‹å§‹æ®‹é«˜',0),(463064,12863,'pt','Saldos de inÃ­cio GL',0),(463065,12863,'ru','ÐžÑÑ‚Ð°Ñ‚ÐºÐ¸ Start GL',0),(463066,12863,'es','LM Balances de Inicio',0),(463067,12863,'de','GL-Start-Guthaben',0),(463068,12863,'en','GL Start Balances',0),(463069,12864,'is','',0),(463070,12864,'dr','Ø³Ø·ÙˆØ­ Ù‚ÛŒÙ…Øª Ú©Ø§Ù„Ø§',0),(463071,12864,'pr','Ø³Ø·ÙˆØ­ Ù‚ÛŒÙ…Øª Ú©Ø§Ù„Ø§',0),(463072,12864,'tr','Madde fiyat dÃ¼zeyleri',0),(463073,12864,'pl','Poziomy cen towaru',0),(463074,12864,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Ñ†ÐµÐ½Ð° Ð½Ð¸Ð²Ð°',0),(463075,12864,'ur','Ø´Û’ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø³Ø·Ø­',0),(463076,12864,'sr','ÐÐ¸Ð²Ð¾Ð¸Ð¼Ð° Ñ†ÐµÐ½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(463077,12864,'vi','cÃ¡c má»©c giÃ¡',0),(463078,12864,'af','Item prys vlakke',0),(463079,12864,'ro','Nivelurile de preÈ› element',0),(463080,12864,'et','Kauba hinnatasemete',0),(463081,12864,'si','Ravni cen artiklov',0),(463082,12864,'ba','Tingkat harga item',0),(463083,12864,'nl','Objectprijs niveaus',0),(463084,12864,'fi','Nimikkeen hintataso',0),(463085,12864,'no','Vareprisen nivÃ¥er',0),(463086,12864,'da','Varepris niveauer',0),(463087,12864,'ko','í•­ëª© ê°€ê²© ìˆ˜ì¤€',0),(463088,12864,'he','×¨×ž×•×ª ×ž×—×™×¨ ×”×¤×¨×™×˜',0),(463089,12864,'el','Î¤Î± ÎµÏ€Î¯Ï€ÎµÎ´Î± Ï„Î¹Î¼ÏŽÎ½ ÎµÎ¹Î´ÏŽÎ½',0),(463090,12864,'zh','é¡¹ç›®ä»·æ ¼æ°´å¹³',0),(463091,12864,'sv','Objektet prisnivÃ¥er',0),(463092,12864,'it','Livelli di prezzo articolo',0),(463093,12864,'tl','',0),(463094,12864,'th','à¸£à¸°à¸”à¸±à¸šà¸£à¸²à¸„à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(463095,12864,'hi','à¤†à¤‡à¤Ÿà¤® à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤°',0),(463096,12864,'ms','Paras harga item',0),(463097,12864,'ar','Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¨Ù†Ø¯',0),(463098,12864,'fr','Niveaux de prix de point',0),(463099,12864,'jp','é …ç›®ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«',0),(463100,12864,'pt','NÃ­veis de preÃ§o do item',0),(463101,12864,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÑƒÑ€Ð¾Ð²Ð½Ð¸ Ñ†ÐµÐ½',0),(463102,12864,'es','Item Estructura de Precios',0),(463103,12864,'de','Element-Preisniveau',0),(463104,12864,'en','Item Price Levels',0),(463105,12865,'is','',0),(463106,12865,'dr','(Ù…Ø¹Ø§Ø´',0),(463107,12865,'pr','Ù…Ø²Ø§ÛŒØ§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª(Ø­Ù‚ÙˆÙ‚',0),(463108,12865,'tr','FaydalarÄ± Ã¶demek',0),(463109,12865,'pl','WypÅ‚aty Å›wiadczeÅ„',0),(463110,12865,'bg','Ð˜Ð·Ð¿Ð»Ð°Ñ‰Ð° Ð¾Ð±ÐµÐ·Ñ‰ÐµÑ‚ÐµÐ½Ð¸Ñ',0),(463111,12865,'ur','ÙˆØ¸Ø§Ø¦Ù Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(463112,12865,'sr','ÐŸÐ»Ð°Ñ›Ð°Ñ˜Ñƒ Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾ÑÐµ',0),(463113,12865,'vi','lá»£i Ã­ch thanh toÃ¡n',0),(463114,12865,'af','Voordele betaal',0),(463115,12865,'ro','PlÄƒti beneficii',0),(463116,12865,'et','HÃ¼vitise maksmist',0),(463117,12865,'si','PlaÄilo dajatve',0),(463118,12865,'ba','Membayar manfaat',0),(463119,12865,'nl','Betalen van de uitkeringen',0),(463120,12865,'fi','Etuuksien',0),(463121,12865,'no','Betale ytelser',0),(463122,12865,'da','Udbetale ydelser',0),(463123,12865,'ko','í˜œíƒì„ ì§€ë¶ˆ',0),(463124,12865,'he','×œ×©×œ× ×”×˜×‘×•×ª',0),(463125,12865,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Î¿Ï†Î­Î»Î·',0),(463126,12865,'zh','æ”¯ä»˜æ´¥è´´',0),(463127,12865,'sv','Betala fÃ¶rmÃ¥ner',0),(463128,12865,'it','Pagare i benefici',0),(463129,12865,'tl','',0),(463130,12865,'th','à¸ˆà¹ˆà¸²à¸¢à¸œà¸¥à¸›à¸£à¸°à¹‚à¸¢à¸Šà¸™à¹Œ',0),(463131,12865,'hi','à¤²à¤¾à¤­à¥‹à¤‚ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(463132,12865,'ms','Membayar manfaat',0),(463133,12865,'ar','Ø¯ÙØ¹ Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚Ø§Øª',0),(463134,12865,'fr','Verser des prestations',0),(463135,12865,'jp','åˆ©ç‚¹ã‚’æ”¯æ‰•ã†',0),(463136,12865,'pt','Pagar benefÃ­cios',0),(463137,12865,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾ÑÐ¾Ð±Ð¸Ð¹',0),(463138,12865,'es','Pagos Beneficios',0),(463139,12865,'de','Zahlt jeder',0),(463140,12865,'en','Pay Benefits',0),(463141,12866,'is','',0),(463142,12866,'dr','(Ø¨ÛŒØ¬Ú©Ù‡Ø§ÛŒ) Ù¾Ø±Ø¯Ø§Ø®Øª(Ù…Ø¹Ø§Ø´',0),(463143,12866,'pr','Ø¹ÙˆØ§Ù…Ù„(ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ) Ù¾Ø±Ø¯Ø§Ø®Øª(Ø­Ù‚ÙˆÙ‚',0),(463144,12866,'tr','FaktÃ¶rler Ã¶demek',0),(463145,12866,'pl','ZapÅ‚aciÄ‡ czynnikÃ³w',0),(463146,12866,'bg','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚Ð¾Ñ€Ð¸',0),(463147,12866,'ur','Ø¹ÙˆØ§Ù…Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(463148,12866,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚Ð¾Ñ€Ð°',0),(463149,12866,'vi','há»‡ sá»‘ thanh toÃ¡n',0),(463150,12866,'af','Betaal faktore',0),(463151,12866,'ro','PlÄƒteascÄƒ factori',0),(463152,12866,'et','Maksma tegurid',0),(463153,12866,'si','PlaÄati dejavniki',0),(463154,12866,'ba','Membayar faktor',0),(463155,12866,'nl','Betalen factoren',0),(463156,12866,'fi','Maksu tekijÃ¤t',0),(463157,12866,'no','Betale faktorer',0),(463158,12866,'da','Betale faktorer',0),(463159,12866,'ko','ìš”ì¸ ì§€ë¶ˆ',0),(463160,12866,'he','×œ×©×œ× ×’×•×¨×ž×™×',0),(463161,12866,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ Ï€Î±ÏÎ¬Î³Î¿Î½Ï„ÎµÏ‚',0),(463162,12866,'zh','è–ªé…¬å› ç´ ',0),(463163,12866,'sv','Betala faktorer',0),(463164,12866,'it','Pagare i fattori',0),(463165,12866,'tl','',0),(463166,12866,'th','à¸ˆà¹ˆà¸²à¸¢à¸›à¸±à¸ˆà¸ˆà¸±à¸¢',0),(463167,12866,'hi','à¤•à¤¾à¤°à¤•à¥‹à¤‚ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(463168,12866,'ms','Membayar faktor-faktor',0),(463169,12866,'ar','Ø¯ÙØ¹ Ø§Ù„Ø¹ÙˆØ§Ù…Ù„',0),(463170,12866,'fr','Payer des facteurs',0),(463171,12866,'jp','è¦å› ã‚’æ”¯æ‰•ã†',0),(463172,12866,'pt','Pagar os fatores',0),(463173,12866,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ñ„Ð°ÐºÑ‚Ð¾Ñ€Ñ‹',0),(463174,12866,'es','Pagos Factores',0),(463175,12866,'de','Faktoren zu zahlen',0),(463176,12866,'en','Pay Factors',0),(463177,12867,'is','',0),(463178,12867,'dr','Ø³Ø±ÛŒ Ù‚ÛŒÙ…Øª ØªÙØ§ÙˆØª Ø¨ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ù‚ÙŠÙ…Øª Ú©Ø§Ù„Ø§   ',0),(463179,12867,'pr','Ø³Ø±ÛŒ Ù‚ÛŒÙ…Øª ØªÙØ§ÙˆØª Ø¨ÙŠÙ† Ù‡Ø²ÙŠÙ†Ù‡ Ùˆ Ù‚ÙŠÙ…Øª Ú©Ø§Ù„Ø§   ',0),(463180,12867,'tr','FiyatÄ± Markup set',0),(463181,12867,'pl','Ceny zestawÃ³w znacznikÃ³w',0),(463182,12867,'bg','ÐšÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¸ Ð·Ð° Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð°',0),(463183,12867,'ur','Ù‚ÛŒÙ…Øª Ù…Ø§Ø±Ú© Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ØªØ§ ÛÛ’',0),(463184,12867,'sr','Ð¦ÐµÐ½Ð° Ð½Ð°Ð·Ð½Ð°ÐºÐµ ÑÐºÑƒÐ¿Ð¾Ð²Ð°',0),(463185,12867,'vi','Láº­p giÃ¡ tÄƒng',0),(463186,12867,'af','Prys Markup stelle',0),(463187,12867,'ro','Seturi de Markup Pret',0),(463188,12867,'et','Hind Markup komplektid',0),(463189,12867,'si','Cena Markup sklopov',0),(463190,12867,'ba','Harga Markup set',0),(463191,12867,'nl','Prijs Markup Sets',0),(463192,12867,'fi','Hinta Markup setit',0),(463193,12867,'no','Pris Markup sett',0),(463194,12867,'da','Pris Markup sÃ¦t',0),(463195,12867,'ko','ê°€ê²© íƒœê·¸ ì„¸íŠ¸',0),(463196,12867,'he','×¢×¨×›×•×ª ×¡×™×ž×•×Ÿ ×ž×—×™×¨',0),(463197,12867,'el','Î¤Î¹Î¼Î® ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚ ÏƒÏÎ½Î¿Î»Î±',0),(463198,12867,'zh','ä»·æ ¼æ ‡è®°é›†',0),(463199,12867,'sv','Pris Markup apparater',0),(463200,12867,'it','Prezzo set di Markup',0),(463201,12867,'tl','',0),(463202,12867,'th','à¸£à¸²à¸„à¸²à¸Šà¸¸à¸”à¸¡à¸²à¸£à¹Œà¸à¸­à¸±à¸›',0),(463203,12867,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤¸à¥‡à¤Ÿ',0),(463204,12867,'ms','Harga Markup set',0),(463205,12867,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(463206,12867,'fr','Ensembles de balisage prix',0),(463207,12867,'jp','ä¾¡æ ¼ãƒžãƒ¼ã‚¯ã‚¢ãƒƒãƒ— ã‚»ãƒƒãƒˆ',0),(463208,12867,'pt','Conjuntos de marcaÃ§Ã£o do preÃ§o',0),(463209,12867,'ru','Ð¦ÐµÐ½Ð° Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸ Ð½Ð°Ð±Ð¾Ñ€Ñ‹',0),(463210,12867,'es','Juegos de Costos de Margines de Beneficio ',0),(463211,12867,'de','Preis Markup-Sets',0),(463212,12867,'en','Price Markup Sets',0),(463213,12868,'is','',0),(463214,12868,'dr','ØªÙ†Ø¸ÛŒÙ… Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(463215,12868,'pr','ØªÙ†Ø¸ÛŒÙ… Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(463216,12868,'tr','GeliÅŸmiÅŸ seÃ§enekler kÃ¼mesi',0),(463217,12868,'pl','Zestaw opcje zaawansowane',0),(463218,12868,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(463219,12868,'ur','Ø§Ø¹Ù„ÛŒ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(463220,12868,'sr','ÐžÐ´Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð·Ð° Ð½Ð°Ð¿Ñ€ÐµÐ´Ð½Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(463221,12868,'vi','Thiáº¿t láº­p TÃ¹y chá»n nÃ¢ng cao',0),(463222,12868,'af','Stel gevorderde opsies',0),(463223,12868,'ro','Set de opÅ£iuni avansate',0),(463224,12868,'et','TÃ¤psemate suvandite seadmine',0),(463225,12868,'si','Nabor dodatne moÅ¾nosti',0),(463226,12868,'ba','Set lanjutan pilihan',0),(463227,12868,'nl','Set geavanceerde opties',0),(463228,12868,'fi','MÃ¤Ã¤ritÃ¤ lisÃ¤asetukset',0),(463229,12868,'no','Angi avanserte innstillinger',0),(463230,12868,'da','Angiv avancerede indstillinger',0),(463231,12868,'ko','ê³ ê¸‰ ì˜µì…˜ ì„¤ì •',0),(463232,12868,'he','×§×‘×•×¦×ª ××¤×©×¨×•×™×•×ª ×ž×ª×§×“×ž×•×ª',0),(463233,12868,'el','Î£ÏÎ½Î¿Î»Î¿ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î³Î¹Î± Ï€ÏÎ¿Ï‡Ï‰ÏÎ·Î¼Î­Î½Î¿Ï…Ï‚',0),(463234,12868,'zh','è®¾ç½®é«˜çº§é€‰é¡¹',0),(463235,12868,'sv','Ange avancerade alternativ',0),(463236,12868,'it','Set di opzioni avanzate',0),(463237,12868,'tl','',0),(463238,12868,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡',0),(463239,12868,'hi','à¤‰à¤¨à¥à¤¨à¤¤ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¸à¥‡à¤Ÿ',0),(463240,12868,'ms','Set opsyen lebih maju',0),(463241,12868,'ar','ØªØ¹ÙŠÙŠÙ† Ø®ÙŠØ§Ø±Ø§Øª Ù…ØªÙ‚Ø¯Ù…Ø©',0),(463242,12868,'fr','Ensemble des Options avancÃ©es',0),(463243,12868,'jp','è©³ç´°ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã®è¨­å®š',0),(463244,12868,'pt','Conjunto de opÃ§Ãµes avanÃ§adas',0),(463245,12868,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð²',0),(463246,12868,'es','Configurar Opciones Avanzadas',0),(463247,12868,'de','Satz Erweiterte Optionen',0),(463248,12868,'en','Set Advanced Options',0),(463249,12869,'is','',0),(463250,12869,'dr','ØªÙ†Ø¸ÛŒÙ… Ø¢Ø¯Ø±Ø³ Ø´Ø±Ú©Øª',0),(463251,12869,'pr','ØªÙ†Ø¸ÛŒÙ… Ø¢Ø¯Ø±Ø³ Ø´Ø±Ú©Øª',0),(463252,12869,'tr','Set ÅŸirket adresi',0),(463253,12869,'pl','Adres firmy zestaw',0),(463254,12869,'bg','ÐšÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð°Ð´Ñ€ÐµÑ',0),(463255,12869,'ur','Ø³ÛŒÙ¹ Ú©Ù…Ù¾Ù†ÛŒ Ù¾ØªÛ',0),(463256,12869,'sr','ÐÐ´Ñ€ÐµÑÐ° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ ÑÐºÑƒÐ¿',0),(463257,12869,'vi','CÃ i Ä‘áº·t Ä‘á»‹a chá»‰ cÃ´ng ty',0),(463258,12869,'af','Stel maatskappy adres',0),(463259,12869,'ro','Adresa set companiei',0),(463260,12869,'et','Komplekt ettevÃµtte aadress',0),(463261,12869,'si','Set podjetje naslov',0),(463262,12869,'ba','Alamat perusahaan set',0),(463263,12869,'nl','Set bedrijfsadres',0),(463264,12869,'fi','Set yrityksen osoite',0),(463265,12869,'no','Sett firmaadresse',0),(463266,12869,'da','SÃ¦t firmaadresse',0),(463267,12869,'ko','ì„¸íŠ¸ íšŒì‚¬ ì£¼ì†Œ',0),(463268,12869,'he','×›×ª×•×‘×ª ×”×—×‘×¨×” ×¢×¨×›×”',0),(463269,12869,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ ÏƒÏÎ½Î¿Î»Î¿',0),(463270,12869,'zh','å…¬å¸é›†åœ°å€',0),(463271,12869,'sv','Ange fÃ¶retagets adress',0),(463272,12869,'it','Set della ditta',0),(463273,12869,'tl','',0),(463274,12869,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸•à¸±à¹‰à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(463275,12869,'hi','à¤¸à¥‡à¤Ÿ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤ªà¤¤à¤¾',0),(463276,12869,'ms','Alamat Syarikat set',0),(463277,12869,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø´Ø±ÙƒØ© Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(463278,12869,'fr','Adresse de la sociÃ©tÃ© de jeu',0),(463279,12869,'jp','ã‚»ãƒƒãƒˆã®ä¼šç¤¾ã®ä½æ‰€',0),(463280,12869,'pt','EndereÃ§o da empresa de conjunto',0),(463281,12869,'ru','ÐÐ´Ñ€ÐµÑ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð½Ð°Ð±Ð¾Ñ€',0),(463282,12869,'es','Configurar DirecciÃ³n de Empresa',0),(463283,12869,'de','Satz Firmenadresse',0),(463284,12869,'en','Set Company Address',0),(463285,12870,'is','',0),(463286,12870,'dr','ØªÙ†Ø¸ÛŒÙ… Ø³ÛŒØ§Ø³Øª Ø¨Ø±Ú¯Ø´Øª ',0),(463287,12870,'pr','ØªÙ†Ø¸ÛŒÙ… Ø³ÛŒØ§Ø³Øª Ø¨Ø±Ú¯Ø´Øª ',0),(463288,12870,'tr','Ä°ade ilkesi ayarla',0),(463289,12870,'pl','Zestaw zwrotÃ³w',0),(463290,12870,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð° Ð·Ð° Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ',0),(463291,12870,'ur','Ø³ÛŒÙ¹ ÙˆØ§Ù¾Ø³ Ù¾Ø§Ù„ÛŒØ³ÛŒ',0),(463292,12870,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ Ñ€ÐµÐºÐ»Ð°Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(463293,12870,'vi','CÃ i Ä‘áº·t chÃ­nh sÃ¡ch hoÃ n tráº£',0),(463294,12870,'af','Stel terug beleid',0),(463295,12870,'ro','SetaÅ£i politica de returnare',0),(463296,12870,'et','Sea tagasisaatmispoliitika',0),(463297,12870,'si','Set politiko vraÄanja',0),(463298,12870,'ba','Menetapkan kebijakan pengembalian',0),(463299,12870,'nl','Set retourbeleid',0),(463300,12870,'fi','Aseta palautusoikeus',0),(463301,12870,'no','Angi returrett',0),(463302,12870,'da','SÃ¦t returret',0),(463303,12870,'ko','ì„¤ì •ëœ ë°˜í™˜ ì •ì±…',0),(463304,12870,'he','×§×‘×™×¢×ª ×ž×“×™× ×™×•×ª ×”×—×–×¨×”',0),(463305,12870,'el','Î§Î±ÏÎ¬ÏƒÏƒÎµÏ„Î±Î¹ Î· Ï€Î¿Î»Î¹Ï„Î¹ÎºÎ® ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚',0),(463306,12870,'zh','è®¾ç½®é€€è´§æ”¿ç­–',0),(463307,12870,'sv','Ange Returpolicy',0),(463308,12870,'it','Politica di ritorno insieme',0),(463309,12870,'tl','',0),(463310,12870,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸™à¹‚à¸¢à¸šà¸²à¸¢à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¸„à¸·à¸™',0),(463311,12870,'hi','à¤¸à¥‡à¤Ÿ à¤µà¤¾à¤ªà¤¸à¥€ à¤¨à¥€à¤¤à¤¿',0),(463312,12870,'ms','Polisi pemulangan yang ditetapkan',0),(463313,12870,'ar','ØªØ¹ÙŠÙŠÙ† Ø¹ÙˆØ¯Ø© Ø§Ù„Ø³ÙŠØ§Ø³Ø©',0),(463314,12870,'fr','Politique de retour ensemble',0),(463315,12870,'jp','ãƒªã‚¿ãƒ¼ãƒ³ ãƒãƒªã‚·ãƒ¼',0),(463316,12870,'pt','Definir polÃ­tica de devoluÃ§Ã£o',0),(463317,12870,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð¿Ð¾Ð»Ð¸Ñ‚Ð¸ÐºÐ° Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð°',0),(463318,12870,'es','Configura Politica de DevoluciÃ³n',0),(463319,12870,'de','Set RÃ¼ckgabebedingungen',0),(463320,12870,'en','Set Return Policy',0),(463321,12871,'is','',0),(463322,12871,'dr','-1',0),(463323,12871,'pr','ØªÙ†Ø¸ÛŒÙ… Ù…Ø§Ù„ÛŒØ§ØªÙ‡Ø§ÛŒ ÙØ±ÙˆØ´-1\r\n',0),(463324,12871,'tr','Set satÄ±ÅŸ vergileri - 1',0),(463325,12871,'pl','Zestaw podatek - 1',0),(463326,12871,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ - 1',0),(463327,12871,'ur','Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ - 1',0),(463328,12871,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð¿Ð¾Ñ€ÐµÐ· - 1',0),(463329,12871,'vi','Thiáº¿t láº­p thuáº¿ bÃ¡n hÃ ng - 1',0),(463330,12871,'af','Stel verkope belastings - 1',0),(463331,12871,'ro','Set taxa la vÃ¢nzÄƒri - 1',0),(463332,12871,'et','Sea makse - 1',0),(463333,12871,'si','Iz prodaje davki - 1',0),(463334,12871,'ba','Pajak penjualan set - 1',0),(463335,12871,'nl','Set belastingen op de verkoop - 1',0),(463336,12871,'fi','MÃ¤Ã¤ritÃ¤ arvonlisÃ¤vero - 1',0),(463337,12871,'no','Angi mva - 1',0),(463338,12871,'da','Angiv moms - 1',0),(463339,12871,'ko','ì„¸íŠ¸ íŒë§¤ ì„¸ê¸ˆ-1',0),(463340,12871,'he','×”×’×“×¨×ª ×ž×¢ ×ž- 1',0),(463341,12871,'el','Î£ÏÎ½Î¿Î»Î¿ Ï†ÏŒÏÏ‰Î½ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ - 1',0),(463342,12871,'zh','è®¾ç½®çš„é”€å”®ç¨Žé‡‘-1',0),(463343,12871,'sv','StÃ¤ll in moms - 1',0),(463344,12871,'it','Impostare le imposte sulle vendite - 1',0),(463345,12871,'tl','',0),(463346,12871,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢ - 1',0),(463347,12871,'hi','à¤¸à¥‡à¤Ÿ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥‹à¤‚ - 1',0),(463348,12871,'ms','Cukai jualan set - 1',0),(463349,12871,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª-1',0),(463350,12871,'fr','Taxes de vente Set - 1',0),(463351,12871,'jp','ã‚»ãƒƒãƒˆè²©å£²ç¨Ž - 1',0),(463352,12871,'pt','Definir os impostos de vendas - 1',0),(463353,12871,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð½Ð°Ð»Ð¾Ð³Ð¸ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ - 1',0),(463354,12871,'es','Configura La IVA - 1',0),(463355,12871,'de','Set Umsatzsteuer - 1',0),(463356,12871,'en','Set Sales Taxes - 1',0),(463357,12872,'is','',0),(463358,12872,'dr','-2',0),(463359,12872,'pr','ØªÙ†Ø¸ÛŒÙ… Ù…Ø§Ù„ÛŒØ§ØªÙ‡Ø§ÛŒ ÙØ±ÙˆØ´-2',0),(463360,12872,'tr','Set satÄ±ÅŸ vergileri - 2',0),(463361,12872,'pl','Zestaw podatek - 2',0),(463362,12872,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ - 2',0),(463363,12872,'ur','Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ - 2',0),(463364,12872,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð¿Ð¾Ñ€ÐµÐ· - 2',0),(463365,12872,'vi','Thiáº¿t láº­p thuáº¿ bÃ¡n hÃ ng - 2',0),(463366,12872,'af','Stel verkope belastings - 2',0),(463367,12872,'ro','Set taxa la vÃ¢nzÄƒri - 2',0),(463368,12872,'et','Sea makse - 2',0),(463369,12872,'si','Iz prodaje davki - 2',0),(463370,12872,'ba','Pajak penjualan set - 2',0),(463371,12872,'nl','Set belastingen op de verkoop - 2',0),(463372,12872,'fi','MÃ¤Ã¤ritÃ¤ arvonlisÃ¤vero - 2',0),(463373,12872,'no','Angi mva - 2',0),(463374,12872,'da','Angiv moms - 2',0),(463375,12872,'ko','ì„¸íŠ¸ íŒë§¤ ì„¸ê¸ˆ-2',0),(463376,12872,'he','×”×’×“×¨×ª ×ž×¢ ×ž- 2',0),(463377,12872,'el','Î£ÏÎ½Î¿Î»Î¿ Ï†ÏŒÏÏ‰Î½ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ - 2',0),(463378,12872,'zh','è®¾ç½®çš„é”€å”®ç¨Žé‡‘-2',0),(463379,12872,'sv','StÃ¤ll in moms - 2',0),(463380,12872,'it','Tasse di vendita set - 2',0),(463381,12872,'tl','',0),(463382,12872,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢ - 2',0),(463383,12872,'hi','à¤¸à¥‡à¤Ÿ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥‹à¤‚ - 2',0),(463384,12872,'ms','Cukai jualan set - 2',0),(463385,12872,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª-2',0),(463386,12872,'fr','Taxes de vente Set - 2',0),(463387,12872,'jp','ã‚»ãƒƒãƒˆè²©å£²ç¨Ž - 2',0),(463388,12872,'pt','Definir os impostos de vendas - 2',0),(463389,12872,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð½Ð°Ð»Ð¾Ð³Ð¸ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ - 2',0),(463390,12872,'es','Configura La IVA - 2',0),(463391,12872,'de','Set Umsatzsteuer - 2',0),(463392,12872,'en','Set Sales Taxes - 2',0),(463393,12873,'is','',0),(463394,12873,'dr','ØªÙ†Ø¸ÛŒÙ… Ù†Ø§Ù… Ù‡Ø§ÛŒ ÙˆØ§Ø­Ø¯',0),(463395,12873,'pr','ØªÙ†Ø¸ÛŒÙ… Ù†Ø§Ù… Ù‡Ø§ÛŒ ÙˆØ§Ø­Ø¯',0),(463396,12873,'tr','Set birim adlarÄ±',0),(463397,12873,'pl','Zestaw jednostek',0),(463398,12873,'bg','Ð—Ð°Ð´Ð°Ð¹ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¸Ð¼ÐµÐ½Ð°',0),(463399,12873,'ur','Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº ÛŒÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù…',0),(463400,12873,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ Ð¸Ð¼ÐµÐ½Ð°',0),(463401,12873,'vi','Thiáº¿t láº­p cÃ¡c tÃªn Ä‘Æ¡n vá»‹',0),(463402,12873,'af','Stel eenheid name',0),(463403,12873,'ro','Nume de unitatea de set',0),(463404,12873,'et','Sea Ã¼ksuse nimed',0),(463405,12873,'si','Set enota imena',0),(463406,12873,'ba','Unit menetapkan nama',0),(463407,12873,'nl','Namen van set eenheden',0),(463408,12873,'fi','MÃ¤Ã¤ritÃ¤ yksikkÃ¶ nimet',0),(463409,12873,'no','Angi enhetsnavn',0),(463410,12873,'da','SÃ¦t enheden navne',0),(463411,12873,'ko','ì„¤ì •ëœ ë‹¨ìœ„ ì´ë¦„',0),(463412,12873,'he','×™×—×™×“×ª ×œ×”×’×“×™×¨ ×©×ž×•×ª',0),(463413,12873,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ Î¼Î¿Î½Î¬Î´Î± Î¿Î½ÏŒÎ¼Î±Ï„Î±',0),(463414,12873,'zh','è®¾ç½®çš„å•ä½åç§°',0),(463415,12873,'sv','Ange namn',0),(463416,12873,'it','Nomi delle unitÃ  set',0),(463417,12873,'tl','',0),(463418,12873,'th','à¸Šà¸·à¹ˆà¸­à¸«à¸™à¹ˆà¸§à¸¢à¸à¸³à¸«à¸™à¸”',0),(463419,12873,'hi','à¤¸à¥‡à¤Ÿ à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤•à¥‡ à¤¨à¤¾à¤®',0),(463420,12873,'ms','Nama-nama set Unit',0),(463421,12873,'ar','Ø£Ø³Ù…Ø§Ø¡ ÙˆØ­Ø¯Ø© Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(463422,12873,'fr','Noms des unitÃ©s Set',0),(463423,12873,'jp','ã‚»ãƒƒãƒˆå˜ä½ã®åå‰',0),(463424,12873,'pt','Nomes de unidade de conjunto',0),(463425,12873,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð±Ð»Ð¾ÐºÐ° Ð¸Ð¼ÐµÐ½Ð°',0),(463426,12873,'es','Configura Nombres de Unidades',0),(463427,12873,'de','Set Einheitennamen',0),(463428,12873,'en','Set Unit Names',0),(463429,12874,'is','',0),(463430,12874,'dr','Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ø¬Ø¯ÛŒØ¯',0),(463431,12874,'pr','Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ø¬Ø¯ÛŒØ¯',0),(463432,12874,'tr','Yeni vergi yÄ±lÄ± baÅŸlatmak',0),(463433,12874,'pl','RozpoczÄ™cie nowego roku podatkowego',0),(463434,12874,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð°Ñ‚Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(463435,12874,'ur','Ù†Ø¦Û’ Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø§Ø³ Ø³Ø§Ù„ Ú©Ø§ Ø¢ØºØ§Ø²',0),(463436,12874,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð°Ðº Ð½Ð¾Ð²Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¿Ð¾Ñ€ÐµÐ·',0),(463437,12874,'vi','Báº¯t Ä‘áº§u nÄƒm thuáº¿ má»›i',0),(463438,12874,'af','Begin nuwe belastingjaar',0),(463439,12874,'ro','ÃŽncepe noul an fiscal',0),(463440,12874,'et','Alusta uut maksuaasta',0),(463441,12874,'si','ZaÄnite novo davÄno leto',0),(463442,12874,'ba','Mulai tahun pajak baru',0),(463443,12874,'nl','Nieuwe fiscale jaar start',0),(463444,12874,'fi','Aloittaa uuden verovuoden',0),(463445,12874,'no','Starte nye inntektsÃ¥ret',0),(463446,12874,'da','Start nye skatteÃ¥r',0),(463447,12874,'ko','ìƒˆë¡œìš´ ê³¼ì„¸ ì—°ë„ ì‹œìž‘',0),(463448,12874,'he','×œ×”×ª×—×™×œ ×©× ×ª ×ž×¡ ×—×“×©×”',0),(463449,12874,'el','ÎžÎµÎºÎ¹Î½Î®ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŒ Î­Ï„Î¿Ï‚',0),(463450,12874,'zh','å¼€å§‹æ–°çš„çº³ç¨Žå¹´åº¦',0),(463451,12874,'sv','Starta nya beskattningsÃ¥ret',0),(463452,12874,'it','Iniziare il nuovo anno fiscale',0),(463453,12874,'tl','',0),(463454,12874,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸›à¸µà¸ à¸²à¸©à¸µà¹ƒà¸«à¸¡à¹ˆ',0),(463455,12874,'hi','à¤¨à¤ à¤•à¤° à¤µà¤°à¥à¤· à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤•à¤°à¥‡à¤‚',0),(463456,12874,'ms','Mula tahun cukai baru',0),(463457,12874,'ar','ØªØ¨Ø¯Ø£ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(463458,12874,'fr','Commencez la nouvelle annÃ©e d\'imposition',0),(463459,12874,'jp','æ–°ã—ã„èª²ç¨Žå¹´åº¦ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(463460,12874,'pt','ComeÃ§ar o novo ano fiscal',0),(463461,12874,'ru','ÐÐ°Ñ‡Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´',0),(463462,12874,'es','Empieza Nuevo Ejercicio Fiscal',0),(463463,12874,'de','Start der neuen Steuerjahr',0),(463464,12874,'en','Start New Tax Year',0),(463465,12875,'is','',0),(463466,12875,'dr','Ø²Ù…Ø§Ù† Ù¾Ø±ÛŒÙ†Øª Ú¯Ø±ÙØªÙ† Ú©Ù†Ø§Ø±Ù‡ Ù‡Ø§ Ø±Ø§ ØªÙ†Ø¸ÛŒÙ… Ú©Ù†ÛŒØ¯',0),(463467,12875,'pr','Ø²Ù…Ø§Ù† Ù¾Ø±ÛŒÙ†Øª Ú¯Ø±ÙØªÙ† Ú©Ù†Ø§Ø±Ù‡ Ù‡Ø§ Ø±Ø§ ØªÙ†Ø¸ÛŒÙ… Ú©Ù†ÛŒØ¯',0),(463468,12875,'tr','1099 yan, yazdÄ±rma sÄ±rasÄ±nda ayarlayÄ±n.',0),(463469,12875,'pl','1099 dostosowanie po stronie podczas drukowania',0),(463470,12875,'bg','1099 ÐºÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð° ÑÑ‚Ñ€Ð°Ð½Ð° Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚',0),(463471,12875,'ur','1099 Ú©ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ Ø·Ø±Ù Ø§ÛŒÚˆØ¬Ø³Ù¹',0),(463472,12875,'sr','1099 ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð° Ð¿Ð¾Ð´ÐµÑÐ¸ ÑÑ‚Ñ€Ð°Ð½Ñƒ Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ°',0),(463473,12875,'vi','1099 Äiá»u chá»‰nh dá»c khi in ',0),(463474,12875,'af','1099 Verstel Kant Wanneer Druk',0),(463475,12875,'ro','1099 ajusta secundare la imprimare',0),(463476,12875,'et','1099 reguleerida kÃ¼lje printimisel',0),(463477,12875,'si','1099 prilagodite strani pri tiskanju',0),(463478,12875,'ba','1099 menyesuaikan sisi ketika mencetak',0),(463479,12875,'nl','1099 aanpassen kant bij het afdrukken',0),(463480,12875,'fi','1099 sÃ¤Ã¤tÃ¤Ã¤ puolella tulostettaessa',0),(463481,12875,'no','1099 justere siden ved utskrift',0),(463482,12875,'da','1099 justere Side under udskrivning',0),(463483,12875,'ko','1099 ì¡°ì • ì¸¡ë©´ ì¸ì‡„ ë  ë•Œ',0),(463484,12875,'he','1099 ×œ×”×ª××™× ××ª ×”×¦×“ ×‘×¢×ª ×”×“×¤×¡×”',0),(463485,12875,'el','1099 Ï€ÏÎ¿ÏƒÎ±ÏÎ¼ÏŒÏƒÎµÏ„Îµ Ï€Î»ÎµÏ…ÏÎ¬ ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(463486,12875,'zh','1099 è°ƒæ•´ä¾§æ‰“å°æ—¶',0),(463487,12875,'sv','1099 Justera sida vid utskrift',0),(463488,12875,'it','1099 regolare di lato durante la stampa',0),(463489,12875,'tl','',0),(463490,12875,'th','1099 à¸›à¸£à¸±à¸šà¸”à¹‰à¸²à¸™à¸‚à¹‰à¸²à¸‡à¹€à¸¡à¸·à¹ˆà¸­à¸žà¸´à¸¡à¸žà¹Œ',0),(463491,12875,'hi','1099 à¤•à¥€ à¤“à¤° à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¤°à¤¤à¥‡ à¤¸à¤®à¤¯ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(463492,12875,'ms','1099 melaraskan sampingan apabila percetakan',0),(463493,12875,'ar','1099 Ø¶Ø¨Ø· Ø§Ù„Ø¬Ø§Ù†Ø¨ Ø¹Ù†Ø¯ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(463494,12875,'fr','1099 rÃ©gler lors de l\'impression',0),(463495,12875,'jp','1099 å´ã‚’èª¿æ•´ã¯ã€å°åˆ·ã™ã‚‹ã¨ã',0),(463496,12875,'pt','1099 ajuste lateral ao imprimir',0),(463497,12875,'ru','1099 Ð¾Ñ‚Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹ Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(463498,12875,'es','1099 Ajuste el Lado Cuando Imprime',0),(463499,12875,'de','1099 anpassen Seite beim Drucken',0),(463500,12875,'en','1099 Adjust Side When Printing',0),(463501,12876,'is','',0),(463502,12876,'dr','Ø²Ù…Ø§Ù† Ù¾Ø±ÛŒÙ†Øª Ú¯Ø±ÙØªÙ† Ø¨Ø§Ù„Ø§ÛŒ ØµÙØ­Ù‡ Ø±Ø§ ØªÙ†Ø¸ÛŒÙ… Ú©Ù†ÛŒØ¯',0),(463503,12876,'pr','Ø²Ù…Ø§Ù† Ù¾Ø±ÛŒÙ†Øª Ú¯Ø±ÙØªÙ† Ø¨Ø§Ù„Ø§ÛŒ ØµÙØ­Ù‡ Ø±Ø§ ØªÙ†Ø¸ÛŒÙ… Ú©Ù†ÛŒØ¯',0),(463504,12876,'tr','1099 Ã¼st baskÄ± yaparken ayarlayÄ±n',0),(463505,12876,'pl','1099 dostosowaÄ‡ Top podczas drukowania',0),(463506,12876,'bg','1099 Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¾Ñ‚Ð³Ð¾Ñ€Ðµ Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚',0),(463507,12876,'ur','1099 Ú†Ú¾Ø§Ù¾ØªÛ’ ÛÙˆØ¦Û’ Ù…ÙˆØ²ÙˆÚº Ú©Ø±ÛŒÚº Ø¨Ø§Ù„Ø§',0),(463508,12876,'sr','1099 ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð° Ð¿Ð¾Ð´ÐµÑÐ¸ Ð³Ð¾Ñ€Ðµ Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ°',0),(463509,12876,'vi','1099 Äiá»u chá»‰nh Ä‘áº§u trang khi in',0),(463510,12876,'af','1099 Verstel Bokant Wanneer Druk',0),(463511,12876,'ro','1099 ajusta sus la imprimare',0),(463512,12876,'et','1099 Sobita Ã¼les printimisel',0),(463513,12876,'si','1099 prilagodite vrh pri tiskanju',0),(463514,12876,'ba','1099 menyesuaikan atas ketika mencetak',0),(463515,12876,'nl','1099 aanpassen Top bij het afdrukken',0),(463516,12876,'fi','1099 ylÃ¶s tulostettaessa',0),(463517,12876,'no','1099 justere topp ved utskrift',0),(463518,12876,'da','1099 justere Top ved udskrivning',0),(463519,12876,'ko','1099 ì¡°ì • ìƒë‹¨ ì¸ì‡„',0),(463520,12876,'he','1099 ×œ×”×ª××™× ×”×¢×œ×™×•×Ÿ ×‘×¢×ª ×”×“×¤×¡×”',0),(463521,12876,'el','1099 ÏÏ…Î¸Î¼Î¯ÏƒÎµÏ„Îµ ÎºÎ¿ÏÏ…Ï†Î®, ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(463522,12876,'zh','1099 è°ƒæ•´é¡¶éƒ¨æ‰“å°æ—¶',0),(463523,12876,'sv','1099 Justera Ã¶vre marg vid utskrift',0),(463524,12876,'it','1099 regolare Top durante la stampa',0),(463525,12876,'tl','',0),(463526,12876,'th','1099 à¸›à¸£à¸±à¸šà¸”à¹‰à¸²à¸™à¸šà¸™à¹€à¸¡à¸·à¹ˆà¸­à¸žà¸´à¸¡à¸žà¹Œ',0),(463527,12876,'hi','1099 à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¤°à¤¤à¥‡ à¤¸à¤®à¤¯ à¤Šà¤ªà¤° à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(463528,12876,'ms','1099 melaraskan atas apabila percetakan',0),(463529,12876,'ar','1099 Ø¶Ø¨Ø· Ø£Ø¹Ù„Ù‰ Ø¹Ù†Ø¯ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(463530,12876,'fr','1099 ajuster dessus lors de l\'impression',0),(463531,12876,'jp','1099 èª¿æ•´ãƒˆãƒƒãƒ—ã‚’å°åˆ·ã™ã‚‹ã¨ã',0),(463532,12876,'pt','1099 ajuste superior ao imprimir',0),(463533,12876,'ru','1099 Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Top Ð¿Ñ€Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(463534,12876,'es','1099 Ajuste la Encima Cuando Imprime',0),(463535,12876,'de','1099 passen Top, beim Drucken',0),(463536,12876,'en','1099 Adjust Top When Printing',0),(463537,12877,'is','',0),(463538,12877,'dr','Ù…ØªÙ† ÙØ§Ú©ØªÙˆØ±',0),(463539,12877,'pr','Ù…ØªÙ† ÙØ§Ú©ØªÙˆØ±',0),(463540,12877,'tr','Fatura metni',0),(463541,12877,'pl','Tekst faktury',0),(463542,12877,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ‚ÐµÐºÑÑ‚',0),(463543,12877,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…ØªÙ†',0),(463544,12877,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ñ‚ÐµÐºÑÑ‚',0),(463545,12877,'vi','pháº§n viáº¿t hÃ³a Ä‘Æ¡n',0),(463546,12877,'af','Faktuur teks',0),(463547,12877,'ro','Text de facturÄƒ',0),(463548,12877,'et','Arve tekst',0),(463549,12877,'si','Besedilo raÄuna',0),(463550,12877,'ba','Invoice Text',0),(463551,12877,'nl','Factuur tekst',0),(463552,12877,'fi','Laskun teksti',0),(463553,12877,'no','Faktura tekst',0),(463554,12877,'da','Faktura tekst',0),(463555,12877,'ko','ì†¡ìž¥ í…ìŠ¤íŠ¸',0),(463556,12877,'he','×—×©×‘×•× ×™×ª ×˜×§×¡×˜',0),(463557,12877,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(463558,12877,'zh','å‘ç¥¨æ–‡æœ¬',0),(463559,12877,'sv','Faktura Text',0),(463560,12877,'it','Testo di fattura',0),(463561,12877,'tl','',0),(463562,12877,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(463563,12877,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¤¾à¤ ',0),(463564,12877,'ms','Teks invois',0),(463565,12877,'ar','Ù†Øµ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(463566,12877,'fr','Texte de facture',0),(463567,12877,'jp','è«‹æ±‚æ›¸ã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(463568,12877,'pt','Texto de factura',0),(463569,12877,'ru','Ð¢ÐµÐºÑÑ‚ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(463570,12877,'es','Texto de Factura',0),(463571,12877,'de','Rechnung-Text',0),(463572,12877,'en','Invoice Text',0),(463573,12878,'is','',0),(463574,12878,'dr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ Ù…Ø±Ú©Ø² Ø¨Ø§Ù„Ø§ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(463575,12878,'pr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ Ù…Ø±Ú©Ø² Ø¨Ø§Ù„Ø§ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(463576,12878,'tr','Ãœst Merkezi fatura metni',0),(463577,12878,'pl','Tekst do gÃ³ry centrum faktury',0),(463578,12878,'bg','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Ñ‚Ð¾Ð¿ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(463579,12878,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± Ú©Û’ Ù…Ø±Ú©Ø² Ú©Û’ Ù„ÛŒÛ’ Ù…ØªÙ†',0),(463580,12878,'sr','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Ð³Ð»Ð°Ð²Ð½Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(463581,12878,'vi','vÄƒn báº£n Ä‘á»‘i vá»›i trung tÃ¢m cá»§a hÃ³a Ä‘Æ¡n',0),(463582,12878,'af','Teks vir Top sentrum van faktuur',0),(463583,12878,'ro','Text pentru centrul de Top de facturÄƒ',0),(463584,12878,'et','Teksti arvelt Top keskus',0),(463585,12878,'si','Besedilo za Top Center raÄuna',0),(463586,12878,'ba','Teks untuk pusat atas faktur',0),(463587,12878,'nl','Tekst voor Top Center voor factuur',0),(463588,12878,'fi','Tekstin alkuun Center laskun',0),(463589,12878,'no','Tekst For toppen midten av faktura',0),(463590,12878,'da','Tekst til Top centrum af faktura',0),(463591,12878,'ko','ì²­êµ¬ì„œì˜ ìµœê³  ì„¼í„°ì— ëŒ€ í•œ í…ìŠ¤íŠ¸',0),(463592,12878,'he','×˜×§×¡×˜ ×¢×‘×•×¨ ×ž×¨×›×– ×”×¢×œ×™×•×Ÿ ×©×œ ×—×©×‘×•× ×™×ª',0),(463593,12878,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Î³Î¹Î± Ï„Î·Î½ ÎºÎ¿ÏÏ…Ï†Î® ÎºÎ­Î½Ï„ÏÎ¿ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(463594,12878,'zh','å‘ç¥¨é¡¶éƒ¨ä¸­å¿ƒçš„æ–‡æœ¬',0),(463595,12878,'sv','Text fÃ¶r Ã¶vre mitten av faktura',0),(463596,12878,'it','Testo per centro superiore della fattura',0),(463597,12878,'tl','',0),(463598,12878,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸šà¸™à¸à¸¥à¸²à¸‡à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œ',0),(463599,12878,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤¶à¥€à¤°à¥à¤· à¤•à¥‡à¤‚à¤¦à¥à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤ ',0),(463600,12878,'ms','Teks untuk Pusat atas invois',0),(463601,12878,'ar','Ù†Øµ Ù„Ù…Ø±ÙƒØ² Ø£Ø¹Ù„Ù‰ Ù…Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(463602,12878,'fr','Texte pour le haut de la page Centre de facture',0),(463603,12878,'jp','ãƒˆãƒƒãƒ—è«‹æ±‚æ›¸ä¸­å¿ƒã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(463604,12878,'pt','Texto para o centro superior da fatura',0),(463605,12878,'ru','Ð¢ÐµÐºÑÑ‚ Ð´Ð»Ñ Ñ‚Ð¾Ð¿ Ñ†ÐµÐ½Ñ‚Ñ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(463606,12878,'es','Texto Para Encima Centrado de Factura',0),(463607,12878,'de','Text fÃ¼r Top Center Rechnung',0),(463608,12878,'en','Text For Top Center Of Invoice',0),(463609,12879,'is','',0),(463610,12879,'dr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ù„Ø§ÛŒ Ø³Ù…Øª Ú†Ù¾ ÙØ§Ú©ØªÙˆØ±',0),(463611,12879,'pr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ù„Ø§ÛŒ Ø³Ù…Øª Ú†Ù¾ ÙØ§Ú©ØªÙˆØ±',0),(463612,12879,'tr','Metni Ã¼st iÃ§in faturanÄ±n yaptÄ±',0),(463613,12879,'pl','Tekst do gÃ³ry po lewej stronie faktury',0),(463614,12879,'bg','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Ð³Ð¾Ñ€Ð½Ð¸Ñ Ð»ÑÐ² ÑŠÐ³ÑŠÐ» Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(463615,12879,'ur','Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± Ú©Û’ Ù„ÛŒÛ’ Ù…ØªÙ† Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒØ§',0),(463616,12879,'sr','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Ð¢Ð¾Ð¿ Ð¾ÑÑ‚Ð°Ð»Ð¾ Ð¾Ð´ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(463617,12879,'vi','Canh trÃ¡i phÃ­a trÃªn cá»§a hÃ³a Ä‘Æ¡n',0),(463618,12879,'af','Teks vir bo links van faktuur',0),(463619,12879,'ro','Textul de sus din stÃ¢nga a facturii',0),(463620,12879,'et','Teksti Ã¼la jÃ¤Ã¤nud arve',0),(463621,12879,'si','Besedilo za Top levo raÄuna',0),(463622,12879,'ba','Teks untuk atas kiri faktur',0),(463623,12879,'nl','Tekst voor Top links van factuur',0),(463624,12879,'fi','Tekstin alkuun jÃ¤ljellÃ¤ laskun',0),(463625,12879,'no','Teksten Ã¸verst til venstre pÃ¥ fakturaen',0),(463626,12879,'da','Teksten Ã¸verst til venstre for faktura',0),(463627,12879,'ko','ì²­êµ¬ì„œì˜ ì™¼ìª½ ìƒë‹¨ì— ëŒ€ í•œ í…ìŠ¤íŠ¸',0),(463628,12879,'he','×˜×§×¡×˜ ×¢×‘×•×¨ ×”×¢×œ×™×•×Ÿ ×”×©×ž××œ×™ ×©×œ ×—×©×‘×•× ×™×ª',0),(463629,12879,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Î³Î¹Î± Ï„Î·Î½ ÎºÎ¿ÏÏ…Ï†Î® Î±ÏÎ¹ÏƒÏ„ÎµÏÎ¬ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(463630,12879,'zh','æ–‡æœ¬é¡¶éƒ¨ç•™ä¸‹çš„å‘ç¥¨',0),(463631,12879,'sv','Text fÃ¶r Top kvar av faktura',0),(463632,12879,'it','Testo per la parte superiore sinistra della fattura',0),(463633,12879,'tl','',0),(463634,12879,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸”à¹‰à¸²à¸™à¸šà¸™à¸‹à¹‰à¸²à¸¢à¸‚à¸­à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(463635,12879,'hi','à¤¶à¥€à¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤  à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¤¾ à¤›à¥‹à¤¡à¤¼ à¤¦à¤¿à¤¯à¤¾',0),(463636,12879,'ms','Teks untuk bahagian atas kiri invois',0),(463637,12879,'ar','ØªØ±Ùƒ Ø§Ù„Ù†Øµ Ù„Ø£Ø¹Ù„Ù‰ Ù…Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(463638,12879,'fr','Pour la partie supÃ©rieure gauche de la facture',0),(463639,12879,'jp','è«‹æ±‚æ›¸ã®å·¦æœ€ä¸Šéƒ¨ã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(463640,12879,'pt','Texto para o topo esquerdo da factura',0),(463641,12879,'ru','Ð¢ÐµÐºÑÑ‚ Ð´Ð»Ñ Ð²ÐµÑ€Ñ…Ð½ÐµÐ¹ Ð»ÐµÐ²Ð¾Ð¹ Ñ‡Ð°ÑÑ‚Ð¸ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(463642,12879,'es','Texto Para Encima Izquierda de Factura',0),(463643,12879,'de','Text fÃ¼r Top Links der Rechnung',0),(463644,12879,'en','Text For Top Left Of Invoice',0),(463645,12880,'is','',0),(463646,12880,'dr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ù„Ø§ÛŒ Ø³Ù…Øª Ø±Ø§Ø³Øª ÙØ§Ú©ØªÙˆØ±',0),(463647,12880,'pr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ù„Ø§ÛŒ Ø³Ù…Øª Ø±Ø§Ø³Øª ÙØ§Ú©ØªÙˆØ±',0),(463648,12880,'tr','Metin iÃ§in tepe doÄŸru-in fatura',0),(463649,12880,'pl','Tekst do gÃ³ry od faktury',0),(463650,12880,'bg','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Ð³Ð¾Ñ€Ð½Ð¸Ñ Ð´ÐµÑÐµÐ½ ÑŠÐ³ÑŠÐ» Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(463651,12880,'ur','Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± Ú©Û’ Ù„ÛŒÛ’ Ù…ØªÙ† Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø¯Ø§Ø¦ÛŒÚº Ø·Ø±Ù',0),(463652,12880,'sr','Ð¢ÐµÐºÑÑ‚ Ð½Ð° Ð²Ñ€Ñ…Ñƒ Ð´ÐµÑÐ½Ð¾ Ð¾Ð´ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(463653,12880,'vi','Canh pháº£i phÃ­a trÃªn cá»§a hÃ³a Ä‘Æ¡n',0),(463654,12880,'af','Teks vir bo regs van faktuur',0),(463655,12880,'ro','Text pentru partea de sus dreapta a facturii',0),(463656,12880,'et','Teksti Ã¼les paremale ning arve',0),(463657,12880,'si','Besedilo za Top pravica do raÄuna',0),(463658,12880,'ba','Teks untuk atas hak untuk faktur',0),(463659,12880,'nl','Tekst voor Top recht van factuur',0),(463660,12880,'fi','Tekstin alkuun oikealla puolella laskun',0),(463661,12880,'no','Tekst For topp rett av faktura',0),(463662,12880,'da','Teksten Ã¸verst hÃ¸jre hjÃ¸rne af faktura',0),(463663,12880,'ko','ìƒë‹¨ í…ìŠ¤íŠ¸ ì†¡ìž¥ì˜ ì˜¤ë¥¸ìª½',0),(463664,12880,'he','×˜×§×¡×˜ ×¢×‘×•×¨ ×”×¢×œ×™×•×Ÿ ×”×™×ž× ×™ ×©×œ ×—×©×‘×•× ×™×ª',0),(463665,12880,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Î³Î¹Î± Ï„Î·Î½ ÎºÎ¿ÏÏ…Ï†Î® Î´ÎµÎ¾Î¹Î¬ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(463666,12880,'zh','é¡¶éƒ¨çš„æ–‡æœ¬æ­£ç¡®çš„å‘ç¥¨',0),(463667,12880,'sv','Text fÃ¶r Top direkt pÃ¥ fakturan',0),(463668,12880,'it','Testo per la parte superiore destra della fattura',0),(463669,12880,'tl','',0),(463670,12880,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸”à¹‰à¸²à¸™à¸šà¸™à¸‚à¸§à¸²à¸‚à¸­à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(463671,12880,'hi','à¤¶à¥€à¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤  à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(463672,12880,'ms','Teks untuk betul-betul daripada invois',0),(463673,12880,'ar','Ø§Ù„Ù†Øµ Ù„Ø£Ø¹Ù„Ù‰ Ø§Ù„ÙŠÙ…ÙŠÙ† Ù…Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(463674,12880,'fr','Texte pour la partie supÃ©rieure droite de la facture',0),(463675,12880,'jp','ãƒ†ã‚­ã‚¹ãƒˆä¸Šã®è«‹æ±‚æ›¸ã®å³',0),(463676,12880,'pt','Texto para a parte superior direita da factura',0),(463677,12880,'ru','Ð¢ÐµÐºÑÑ‚ Ð´Ð»Ñ Ð²ÐµÑ€Ñ…Ð½ÐµÐ¹ Ð¿Ñ€Ð°Ð²Ð¾Ð¹ Ñ‡Ð°ÑÑ‚Ð¸ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(463678,12880,'es','Texto Para Encima Derecha de Factura',0),(463679,12880,'de','Text fÃ¼r oben rechts auf Rechnung',0),(463680,12880,'en','Text For Top Right Of Invoice',0),(463681,12881,'is','',0),(463682,12881,'dr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ Ø²ÛŒØ± Ù…Ø¬Ù…ÙˆØ¹ ÙØ§Ú©ØªÙˆØ±',0),(463683,12881,'pr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ Ø²ÛŒØ± Ù…Ø¬Ù…ÙˆØ¹ ÙØ§Ú©ØªÙˆØ±',0),(463684,12881,'tr','Metin iÃ§in fatura toplamÄ±nda altÄ±nda',0),(463685,12881,'pl','Tekst do kwoty faktury',0),(463686,12881,'bg','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Ð¿Ð¾Ð´ Ð¾Ð±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(463687,12881,'ur','Ù…ØªÙ† Ú©Û’ Ù„Ø¦Û’ Ú©Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ ØªØ­Øª',0),(463688,12881,'sr','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Ð¿Ð¾Ð´ ÑƒÐºÑƒÐ¿Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(463689,12881,'vi','VÄƒn báº£n cho theo tá»•ng sá»‘ hÃ³a Ä‘Æ¡n',0),(463690,12881,'af','Teks vir onder faktuur totaal',0),(463691,12881,'ro','Textul de sub Total factura',0),(463692,12881,'et','Teksti eest arve kogusumma alusel',0),(463693,12881,'si','Besedilo za pod skupni znesek raÄuna.',0),(463694,12881,'ba','Teks untuk di bawah Total faktur',0),(463695,12881,'nl','Tekst voor onder Factuurtotaal',0),(463696,12881,'fi','Tekstin alle lasku yhteensÃ¤',0),(463697,12881,'no','Teksten Under fakturatotalen',0),(463698,12881,'da','Tekst til Under fakturatotalen',0),(463699,12881,'ko','ì²­êµ¬ì„œ í•©ê³„ ì•„ëž˜ì— ëŒ€ í•œ í…ìŠ¤íŠ¸',0),(463700,12881,'he','×˜×§×¡×˜ ×¢×‘×•×¨ ×ª×—×ª ×¡×›×•× ×—×©×‘×•× ×™×ª',0),(463701,12881,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Î³Î¹Î± Under ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(463702,12881,'zh','æ–‡æœ¬æ ¹æ®å‘ç¥¨åˆè®¡',0),(463703,12881,'sv','Text fÃ¶r Under fakturasumman',0),(463704,12881,'it','Testo per sotto totale fattura',0),(463705,12881,'tl','',0),(463706,12881,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸ à¸²à¸¢à¹ƒà¸•à¹‰à¸œà¸¥à¸£à¸§à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(463707,12881,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤  à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥à¤² à¤•à¥‡ à¤¤à¤¹à¤¤',0),(463708,12881,'ms','Teks untuk di bawah jumlah invois',0),(463709,12881,'ar','Ø§Ù„Ù†Øµ Ù„ØªØ­Øª Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(463710,12881,'fr','Texte pour sous Total de la facture',0),(463711,12881,'jp','è«‹æ±‚æ›¸ã®åˆè¨ˆã®ä¸‹ã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(463712,12881,'pt','Texto para sob Total da factura',0),(463713,12881,'ru','Ð¢ÐµÐºÑÑ‚ Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð° Ð²ÑÐµÐ³Ð¾',0),(463714,12881,'es','Texto Para Bajo de Factura',0),(463715,12881,'de','Text fÃ¼r unter Rechnungssumme',0),(463716,12881,'en','Text For Under Invoice Total',0),(463717,12882,'is','',0),(463718,12882,'dr','Ù…ØªÙ† ÙˆØ¨ Ø³Ø§ÛŒØª Ø¨Ø±Ø§ÛŒ Ù¾Ø§ÛŒÛŒÙ† ÙˆØ³Ø· ÙØ§Ú©ØªÙˆØ±',0),(463719,12882,'pr','Ù…ØªÙ† ÙˆØ¨ Ø³Ø§ÛŒØª Ø¨Ø±Ø§ÛŒ Ù¾Ø§ÛŒÛŒÙ† ÙˆØ³Ø· ÙØ§Ú©ØªÙˆØ±',0),(463720,12882,'tr','Web sitesi metin, alt merkezi fatura iÃ§in',0),(463721,12882,'pl','Strona internetowa tekst na dole centrum faktury',0),(463722,12882,'bg','Ð£ÐµÐ±ÑÐ°Ð¹Ñ‚ Ñ‚ÐµÐºÑÑ‚ Ð·Ð° Ð´Ð¾Ð»Ð½Ð¸Ñ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(463723,12882,'ur','Ø¨Ù…Ø±Ú©Ø² Ù¾Ø§ÛŒØ§Ù† Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ú©Ø§ Ù…ØªÙ†',0),(463724,12882,'sr','WÐµÐ± Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ñ‚ÐµÐºÑÑ‚Ð° Ð·Ð° Ð´Ð½Ð¾ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(463725,12882,'vi','VÄƒn báº£n cá»§a website Ä‘á»‘i vá»›i trung tÃ¢m phiÃ dÆ°á»›i cá»§a hÃ³a Ä‘Æ¡n',0),(463726,12882,'af','Webwerf teks vir onderste sentrum van faktuur',0),(463727,12882,'ro','Site-ul Text pentru jos centrul de facturÄƒ',0),(463728,12882,'et','Veebilehe teksti alt Center arve',0),(463729,12882,'si','Spletna stran besedila spodaj centru raÄunu',0),(463730,12882,'ba','Situs teks untuk bawah pusat faktur',0),(463731,12882,'nl','Website tekst voor Bottom Center voor factuur',0),(463732,12882,'fi','TekstiÃ¤ pohja Center laskun',0),(463733,12882,'no','Hjemmeside tekst For bunnen sentrum av faktura',0),(463734,12882,'da','Hjemmeside tekst til bunden Center af faktura',0),(463735,12882,'ko','í•˜ë‹¨ ì¤‘ì•™ì˜ ì†¡ìž¥ì— ëŒ€ í•œ ì›¹ì‚¬ì´íŠ¸ í…ìŠ¤íŠ¸',0),(463736,12882,'he','××ª×¨ ×˜×§×¡×˜ ×¢×‘×•×¨ ×ž×¨×›×– ×”×ª×—×ª×•×Ÿ ×©×œ ×—×©×‘×•× ×™×ª',0),(463737,12882,'el','Î™ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î± ÎºÎµÎ¯Î¼ÎµÎ½Î¿ Î³Î¹Î± Ï„Î¿ ÎºÎ­Î½Ï„ÏÎ¿ Ï„Î¿Ï… ÎºÎ¬Ï„Ï‰ Î¼Î­ÏÎ¿Ï‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(463738,12882,'zh','å‘ç¥¨åº•éƒ¨ä¸­å¿ƒç½‘ç«™æ–‡æœ¬',0),(463739,12882,'sv','Hemsida Text fÃ¶r botten Center fÃ¶r faktura',0),(463740,12882,'it','Testo del sito per fondo centro di fattura',0),(463741,12882,'tl','',0),(463742,12882,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¸¨à¸¹à¸™à¸¢à¹Œà¸à¸¥à¸²à¸‡à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡à¸‚à¸­à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(463743,12882,'hi','à¤¤à¤² à¤•à¥‡à¤‚à¤¦à¥à¤° à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¥‡à¤¬à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤¾à¤ ',0),(463744,12882,'ms','Teks Laman web untuk Pusat bawah invois',0),(463745,12882,'ar','Ø§Ù„Ù†Øµ Ø¹Ù„Ù‰ Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª Ù„Ù…Ø±ÙƒØ² Ø§Ù„Ù‚Ø§Ø¹ Ù…Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(463746,12882,'fr','Texte de site Web pour le centre bas de la facture',0),(463747,12882,'jp','è«‹æ±‚æ›¸ä¸‹éƒ¨ã‚»ãƒ³ã‚¿ãƒ¼ã®ã‚¦ã‚§ãƒ–ã‚µã‚¤ãƒˆã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(463748,12882,'pt','Texto do site para baixo centro de factura',0),(463749,12882,'ru','Ð¡Ð°Ð¹Ñ‚ Ñ‚ÐµÐºÑÑ‚ Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð° Ð½Ð¸Ð¶Ð½Ð¸Ð¹ Ñ†ÐµÐ½Ñ‚Ñ€',0),(463750,12882,'es','Texto de Sitio de Web Para el Bajo Centro de la Factura',0),(463751,12882,'de','Webseite Text fÃ¼r Bottom Center Rechnung',0),(463752,12882,'en','Website Text For Bottom Center Of Invoice',0),(463753,12883,'is','',0),(463754,12883,'dr','Ø¯ÙˆÙ„Øª ÙØ¯Ø±Ø§Ù„',0),(463755,12883,'pr','Ø¯ÙˆÙ„Øª ÙØ¯Ø±Ø§Ù„',0),(463756,12883,'tr','Federal hÃ¼kÃ¼met',0),(463757,12883,'pl','RzÄ…d federalny',0),(463758,12883,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¾Ñ‚Ð¾ Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÐµÐ»ÑÑ‚Ð²Ð¾',0),(463759,12883,'ur','ÙˆÙØ§Ù‚ÛŒ Ø­Ú©ÙˆÙ…Øª',0),(463760,12883,'sr','Ð¡Ð°Ð²ÐµÐ·Ð½Ð° Ð²Ð»Ð°Ð´Ð°',0),(463761,12883,'vi','nhÃ  nÆ°á»›c liÃªn bang',0),(463762,12883,'af','Federale Regering',0),(463763,12883,'ro','Guvernul federal',0),(463764,12883,'et','FÃ¶deraalvalitsus',0),(463765,12883,'si','Zvezna vlada',0),(463766,12883,'ba','Pemerintah federal',0),(463767,12883,'nl','Federale overheid',0),(463768,12883,'fi','Liittohallitus',0),(463769,12883,'no','FÃ¸derale regjeringen',0),(463770,12883,'da','Forbundsregeringen',0),(463771,12883,'ko','ì—°ë°© ì •ë¶€',0),(463772,12883,'he','×”×ž×ž×©×œ×” ×”×¤×“×¨×œ×™×ª',0),(463773,12883,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® ÎºÏ…Î²Î­ÏÎ½Î·ÏƒÎ·',0),(463774,12883,'zh','è”é‚¦æ”¿åºœ',0),(463775,12883,'sv','FÃ¶rbundsregeringen',0),(463776,12883,'it','Governo federale',0),(463777,12883,'tl','',0),(463778,12883,'th','à¸£à¸±à¸à¸šà¸²à¸¥à¸à¸¥à¸²à¸‡',0),(463779,12883,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤¸à¤°à¤•à¤¾à¤°',0),(463780,12883,'ms','Kerajaan Persekutuan',0),(463781,12883,'ar','Ø§Ù„Ø­ÙƒÙˆÙ…Ø© Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(463782,12883,'fr','Gouvernement fÃ©dÃ©ral',0),(463783,12883,'jp','é€£é‚¦æ”¿åºœ',0),(463784,12883,'pt','Governo Federal',0),(463785,12883,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ðµ Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð¾',0),(463786,12883,'es','Gobierno Federal',0),(463787,12883,'de','Bundesregierung',0),(463788,12883,'en','Federal Government',0),(463789,12884,'is','',0),(463790,12884,'dr','Ù†ÙˆØ¹ Ú©Ø§Ø±ÙØ±Ù…Ø§',0),(463791,12884,'pr','Ù†ÙˆØ¹ Ú©Ø§Ø±ÙØ±Ù…Ø§',0),(463792,12884,'tr','Ä°ÅŸveren tÃ¼r',0),(463793,12884,'pl','Rodzaju pracodawcy',0),(463794,12884,'bg','Ð’Ð¸Ð´ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»Ñ',0),(463795,12884,'ur','Ø¢Ø¬Ø± Ú©ÛŒ Ù‚Ø³Ù…',0),(463796,12884,'sr','Ð’Ñ€ÑÑ‚Ð° Ð¿Ð¾ÑÐ»Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(463797,12884,'vi','Loáº¡i sá»­ dá»¥ng lao Ä‘á»™ng',0),(463798,12884,'af','Soort van werkgewer',0),(463799,12884,'ro','Fel de angajator',0),(463800,12884,'et','TÃ¶Ã¶andja Kind',0),(463801,12884,'si','Lojalnost',0),(463802,12884,'ba','Jenis majikan',0),(463803,12884,'nl','Soort werkgever',0),(463804,12884,'fi','Sellainen tyÃ¶nantaja',0),(463805,12884,'no','Slags arbeidsgiver',0),(463806,12884,'da','Form for arbejdsgiver',0),(463807,12884,'ko','ê³ ìš©ì£¼ì˜ ì¢…ë¥˜',0),(463808,12884,'he','×¡×•×’ ×©×œ ×”×ž×¢×¡×™×§',0),(463809,12884,'el','Î•Î¯Î´Î¿Ï‚ Ï„Î¿Ï… ÎµÏÎ³Î¿Î´ÏŒÏ„Î·',0),(463810,12884,'zh','ç±»ä¼¼çš„é›‡ä¸»',0),(463811,12884,'sv','Typ av arbetsgivare',0),(463812,12884,'it','Tipo di datore di lavoro',0),(463813,12884,'tl','',0),(463814,12884,'th','à¸›à¸£à¸°à¹€à¸ à¸—à¸‚à¸­à¸‡à¸™à¸²à¸¢à¸ˆà¹‰à¸²à¸‡',0),(463815,12884,'hi','à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤•à¥€ à¤¤à¤°à¤¹',0),(463816,12884,'ms','Jenis majikan',0),(463817,12884,'ar','Ù†ÙˆØ¹ Ù…Ù† ØµØ§Ø­Ø¨ Ø§Ù„Ø¹Ù…Ù„',0),(463818,12884,'fr','Type d\'employeur',0),(463819,12884,'jp','é›‡ç”¨è€…ã®ç¨®é¡ž',0),(463820,12884,'pt','Tipo de empregador',0),(463821,12884,'ru','Ð’Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»Ñ',0),(463822,12884,'es','Tipo de Patron',0),(463823,12884,'de','Art des Arbeitgebers',0),(463824,12884,'en','Kind of Employer',0),(463825,12885,'is','',0),(463826,12885,'dr','(Ø¹Ø¯Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(463827,12885,'pr','Ø¨Ù‡ Ú©Ø§Ø± Ù†Ø¨Ø±ÛŒØ¯ (Ø¹Ø¯Ù… Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(463828,12885,'tr','HiÃ§biri Uygula',0),(463829,12885,'pl','Brak zastosowania',0),(463830,12885,'bg','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°Ñ‚',0),(463831,12885,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ú¾ÛŒ Ù„Ú¯Ø§Ø¦ÛŒÚº',0),(463832,12885,'sr','ÐÐ¸Ñ˜ÐµÐ´Ð°Ð½ Ð¾Ð´Ð½Ð¾ÑÐµ',0),(463833,12885,'vi','khÃ´ng Ã¡p dá»¥ng',0),(463834,12885,'af','Geen geld',0),(463835,12885,'ro','Nu se aplicÄƒ',0),(463836,12885,'et','Ãœkski ei kehti',0),(463837,12885,'si','Ne uporabljajo',0),(463838,12885,'ba','Tidak berlaku',0),(463839,12885,'nl','Geen toepassing',0),(463840,12885,'fi','MikÃ¤Ã¤n ei pÃ¤de',0),(463841,12885,'no','Ingen gjelder',0),(463842,12885,'da','Ingen finder anvendelse',0),(463843,12885,'ko','ì ìš© ë˜ì§€',0),(463844,12885,'he','××£ ××—×“ ×œ× ×—×œ×™×',0),(463845,12885,'el','ÎšÎ±Î½Î­Î½Î±Ï‚ Î´ÎµÎ½ Î¹ÏƒÏ‡ÏÎ¿Ï…Î½',0),(463846,12885,'zh','æ²¡æœ‰ä»»ä½•é€‚ç”¨',0),(463847,12885,'sv','Ingen tillÃ¤mpas',0),(463848,12885,'it','Nessuno si applicano',0),(463849,12885,'tl','',0),(463850,12885,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸Šà¹‰',0),(463851,12885,'hi','à¤•à¥‹à¤ˆ à¤­à¥€ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(463852,12885,'ms','Tidak memohon',0),(463853,12885,'ar','ÙŠØªÙ… ØªØ·Ø¨ÙŠÙ‚ Ø£ÙŠ',0),(463854,12885,'fr','Aucune ne s\'applique',0),(463855,12885,'jp','é©ç”¨ãªã—',0),(463856,12885,'pt','Nenhum se aplica',0),(463857,12885,'ru','ÐÐµ Ð¿Ñ€Ð¸Ð¼ÐµÐ½ÑÑ‚ÑŒ',0),(463858,12885,'es','Ninguno Aplica',0),(463859,12885,'de','Keine angewendet',0),(463860,12885,'en','None Apply',0),(463861,12886,'is','',0),(463862,12886,'dr','Ú©Ø§Ø±ÙØ±Ù…Ø§ Ø¯ÙˆÙ„Øª Ø§ÛŒØ§Ù„ØªÛŒ Ùˆ Ù…Ø­Ù„ÛŒ',0),(463863,12886,'pr','Ú©Ø§Ø±ÙØ±Ù…Ø§ Ø¯ÙˆÙ„Øª Ø§ÛŒØ§Ù„ØªÛŒ Ùˆ Ù…Ø­Ù„ÛŒ',0),(463864,12886,'tr','Devlet ve yerel yÃ¶netimler iÅŸveren',0),(463865,12886,'pl','PaÅ„stwa i samorzÄ…du terytorialnego pracodawcy',0),(463866,12886,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²Ð°Ñ‚Ð° Ð¸ Ð¼ÐµÑÑ‚Ð½Ð°Ñ‚Ð° Ð²Ð»Ð°ÑÑ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»',0),(463867,12886,'ur','Ø±ÛŒØ§Ø³Øª Ø§ÙˆØ± Ù…Ù‚Ø§Ù…ÛŒ Ø­Ú©ÙˆÙ…Øª Ú©Ø§ Ø¢Ø¬Ø±',0),(463868,12886,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ðµ Ð¸ Ð»Ð¾ÐºÐ°Ð»Ð½Ðµ ÑƒÐ¿Ñ€Ð°Ð²Ðµ Ð¿Ð¾ÑÐ»Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(463869,12886,'vi','NgÆ°á»i tuyá»ƒn dá»¥ng Ä‘á»‹a phÆ°Æ¡ng vÃ  nhÃ  nÆ°á»›c',0),(463870,12886,'af','Staats- en Plaaslike Regering werkgewer',0),(463871,12886,'ro','Stat ÅŸi Guvernul Local angajator',0),(463872,12886,'et','Riigi- ja kohaliku omavalitsuse tÃ¶Ã¶andja',0),(463873,12886,'si','DrÅ¾ava in lokalna vlada delodajalec',0),(463874,12886,'ba','Negara dan majikan lokal pemerintah',0),(463875,12886,'nl','Staat en lokale overheid werkgever',0),(463876,12886,'fi','Valtion ja paikallishallinnon tyÃ¶nantajan',0),(463877,12886,'no','Statlige og lokale myndigheter arbeidsgiver',0),(463878,12886,'da','Staten og lokale offentlige arbejdsgiver',0),(463879,12886,'ko','ì£¼ ë° ì§€ë°© ì •ë¶€ê°€ ê³ ìš©ì£¼',0),(463880,12886,'he','×”×ž×“×™× ×” ×•××ª ×”×ž×¢×¡×™×§ ×”×©×œ×˜×•×Ÿ ×”×ž×§×•×ž×™',0),(463881,12886,'el','ÎšÏÎ¬Ï„Î¿Ï‚ ÎºÎ±Î¹ Ï„Î¿Ï€Î¹ÎºÎ® Î±Ï…Ï„Î¿Î´Î¹Î¿Î¯ÎºÎ·ÏƒÎ· ÎµÏÎ³Î¿Î´ÏŒÏ„Î·',0),(463882,12886,'zh','å›½å®¶å’Œåœ°æ–¹æ”¿åºœé›‡ä¸»',0),(463883,12886,'sv','Statliga och kommunala arbetsgivare',0),(463884,12886,'it','Stato e governo locale datore di lavoro',0),(463885,12886,'tl','',0),(463886,12886,'th','à¸£à¸±à¸à¹à¸¥à¸°à¸™à¸²à¸¢à¸ˆà¹‰à¸²à¸‡à¸£à¸±à¸à¸šà¸²à¸¥à¸—à¹‰à¸­à¸‡à¸–à¸´à¹ˆà¸™',0),(463887,12886,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤”à¤° à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤¸à¤°à¤•à¤¾à¤° à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾',0),(463888,12886,'ms','Negeri dan kerajaan tempatan majikan',0),(463889,12886,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø© ÙˆØ§Ù„Ø­ÙƒÙˆÙ…Ø© Ø§Ù„Ù…Ø­Ù„ÙŠØ© ØµØ§Ø­Ø¨ Ø§Ù„Ø¹Ù…Ù„',0),(463890,12886,'fr','Ã‰tat et gouvernement Local employeur',0),(463891,12886,'jp','å·žãŠã‚ˆã³åœ°æ–¹æ”¿åºœã®é›‡ç”¨è€…',0),(463892,12886,'pt','Estado e Governo Local empregador',0),(463893,12886,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ñ… Ð¸ Ð¼ÐµÑÑ‚Ð½Ñ‹Ñ… Ð¾Ñ€Ð³Ð°Ð½Ð¾Ð² Ð²Ð»Ð°ÑÑ‚Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»Ñ',0),(463894,12886,'es','Patron de Gobierno Federal y Estatal',0),(463895,12886,'de','Staatlichen und lokalen Regierung Arbeitgeber',0),(463896,12886,'en','State and Local Government Employer',0),(463897,12887,'is','',0),(463898,12887,'dr','Ù…Ø¹Ø§Ù Ù…Ø§Ù„ÛŒØ§Øª Ø§ÛŒØ§Ù„ØªÛŒ Ùˆ Ù…Ø­Ù„ÛŒ Ú©Ø§Ø±ÙØ±Ù…Ø§ ',0),(463899,12887,'pr','Ù…Ø¹Ø§Ù Ù…Ø§Ù„ÛŒØ§Øª Ø§ÛŒØ§Ù„ØªÛŒ Ùˆ Ù…Ø­Ù„ÛŒ Ú©Ø§Ø±ÙØ±Ù…Ø§ ',0),(463900,12887,'tr','Devlet ve yerel vergi muafiyet iÅŸveren',0),(463901,12887,'pl','PaÅ„stwa i podatek pracodawca zwolniony',0),(463902,12887,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²Ð½Ð¸ Ð¸ Ð¼ÐµÑÑ‚Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð´ÐµÐ½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»',0),(463903,12887,'ur','Ø±ÛŒØ§Ø³Øª Ø§ÙˆØ± Ù…Ù‚Ø§Ù…ÛŒ Ù¹ÛŒÚ©Ø³ Ù…Ø³ØªØ«Ù†ÛŒ Ø¢Ø¬Ø±',0),(463904,12887,'sr','Ð”Ñ€Ð¶Ð°Ð²Ðµ Ð¸ Ð»Ð¾ÐºÐ°Ð»Ð½Ð¸Ñ… Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð¸Ð·ÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ð¾ÑÐ»Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(463905,12887,'vi','NhÃ  tuyá»ƒn dá»¥ng nhÃ  nÆ°á»›c vÃ  Ä‘á»‹a phÆ°Æ¡ng Ä‘Æ°á»£c miá»…n thuáº¿',0),(463906,12887,'af','Staats- en plaaslike belasting vrygestel werkgewer',0),(463907,12887,'ro','Angajatorul scutite de stat ÅŸi taxe locale',0),(463908,12887,'et','Riigi ja kohalike maksude vabastada tÃ¶Ã¶andja',0),(463909,12887,'si','DrÅ¾ava in lokalne davka oproÅ¡Äene delodajalca',0),(463910,12887,'ba','Negara bagian dan pajak lokal majikan dibebaskan',0),(463911,12887,'nl','Staat en lokale belasting vrijgesteld werkgever',0),(463912,12887,'fi','Valtion- ja kunnallisverosta vapautettu tyÃ¶nantajan',0),(463913,12887,'no','Statlige og lokale Tax Exempt arbeidsgiver',0),(463914,12887,'da','Statslige og lokale skatter undtaget arbejdsgiver',0),(463915,12887,'ko','êµ­ê°€ ì§€ë°© ì„¸ ë©´ì œ ê³ ìš©ì£¼',0),(463916,12887,'he','×”×ž×¢×¡×™×§ ×¤×˜×•×¨ ×”×ž×“×™× ×” ×•×ž×¡ ×ž×§×•×ž×™',0),(463917,12887,'el','ÎšÏÎ¬Ï„Î¿Ï‚ ÎºÎ±Î¹ Ï„Î¿Ï€Î¹ÎºÎ® Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Î±Ï€Î±Î»Î»Î±Î³Î® ÎµÏÎ³Î¿Î´ÏŒÏ„Î·',0),(463918,12887,'zh','å›½å®¶å’Œåœ°æ–¹ç¨Žæ”¶è±å…é›‡ä¸»',0),(463919,12887,'sv','Statliga och lokala skatt undantas arbetsgivare',0),(463920,12887,'it','Stato e tassa locale datore di lavoro esenti',0),(463921,12887,'tl','',0),(463922,12887,'th','à¸™à¸²à¸¢à¸ˆà¹‰à¸²à¸‡à¸¢à¸à¹€à¸§à¹‰à¸™à¸£à¸±à¸à¹à¸¥à¸°à¸ à¸²à¸©à¸µà¸—à¹‰à¸­à¸‡à¸–à¸´à¹ˆà¸™',0),(463923,12887,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤”à¤° à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾',0),(463924,12887,'ms','Majikan dikecualikan cukai tempatan dan Negeri',0),(463925,12887,'ar','ØµØ§Ø­Ø¨ Ø§Ù„Ø¹Ù…Ù„ Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¯ÙˆÙ„Ø© ÙˆØ§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø­Ù„ÙŠØ©',0),(463926,12887,'fr','Ã‰tat et taxe locale employeur exemptÃ©',0),(463927,12887,'jp','å·žãŠã‚ˆã³åœ°æ–¹ç¨Žã®æŽ§é™¤é›‡ç”¨è€…',0),(463928,12887,'pt','Empregador isento estado e impostos locais',0),(463929,12887,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ñ… Ð¸ Ð¼ÐµÑÑ‚Ð½Ñ‹Ñ… Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°ÑŽÑ‚ÑÑ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»ÑŒ',0),(463930,12887,'es','Patron de ExenciÃ³n de Impuestos Federal y Estatal',0),(463931,12887,'de','Staatliche und lokale Steuer befreit Arbeitgeber',0),(463932,12887,'en','State and Local Tax Exempt Employer',0),(463933,12888,'is','',0),(463934,12888,'dr','Ù…Ø§Ù„ÛŒØ§Øª Ù…Ø¹Ø§Ù Ú©Ø§Ø±ÙØ±Ù…Ø§',0),(463935,12888,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ù…Ø¹Ø§Ù Ú©Ø§Ø±ÙØ±Ù…Ø§',0),(463936,12888,'tr','Vergi muafiyet iÅŸveren',0),(463937,12888,'pl','Podatku zwolnione pracodawcy',0),(463938,12888,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð´ÐµÐ½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»',0),(463939,12888,'ur','Ù¹ÛŒÚ©Ø³ Ù…Ø³ØªØ«Ù†ÛŒ Ø¢Ø¬Ø±',0),(463940,12888,'sr','Ð˜Ð·ÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ð¾ÑÐ»Ð¾Ð´Ð°Ð²Ð°Ñ† Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(463941,12888,'vi','NgÆ°á»i sá»­ dá»¥ng lao Ä‘á»™ng Ä‘Æ°á»£c miá»…n thuáº¿',0),(463942,12888,'af','Belasting vrygestel werkgewer',0),(463943,12888,'ro','Fiscale scutite de angajator',0),(463944,12888,'et','Maksudest vabastada tÃ¶Ã¶andja',0),(463945,12888,'si','Delodajalec oproÅ¡Äena davka',0),(463946,12888,'ba','Pajak dibebaskan majikan',0),(463947,12888,'nl','Belasting vrijgesteld werkgever',0),(463948,12888,'fi','Veroa ei sovelleta tyÃ¶nantajan',0),(463949,12888,'no','Tax Exempt arbeidsgiver',0),(463950,12888,'da','Skat undtaget arbejdsgiver',0),(463951,12888,'ko','ì„¸ê¸ˆ ë©´ì œ ê³ ìš©ì£¼',0),(463952,12888,'he','×”×ž×¢×¡×™×§ ×¤×˜×•×¨ ×ž×ž×¡',0),(463953,12888,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Î±Ï€Î±Î»Î»Î±Î³Î® ÎµÏÎ³Î¿Î´ÏŒÏ„Î·',0),(463954,12888,'zh','ç¨ŽåŠ¡è±å…é›‡ä¸»',0),(463955,12888,'sv','Skatt undantas arbetsgivare',0),(463956,12888,'it','Datore di lavoro esenti IVA',0),(463957,12888,'tl','',0),(463958,12888,'th','à¸™à¸²à¸¢à¸ˆà¹‰à¸²à¸‡à¸¢à¸à¹€à¸§à¹‰à¸™à¸ à¸²à¸©à¸µ',0),(463959,12888,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¿à¤¯à¥‹à¤•à¥à¤¤à¤¾',0),(463960,12888,'ms','Majikan dikecualikan cukai',0),(463961,12888,'ar','Ø¶Ø±ÙŠØ¨Ø© ÙŠØ¹ÙÙŠ ØµØ§Ø­Ø¨ Ø§Ù„Ø¹Ù…Ù„',0),(463962,12888,'fr','Employeur exonÃ©rÃ©s de taxe',0),(463963,12888,'jp','ç¨Žå…é™¤ã®é›‡ç”¨è€…',0),(463964,12888,'pt','Empregador isento de imposto',0),(463965,12888,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð¾Ð´Ð°Ñ‚ÐµÐ»Ñ',0),(463966,12888,'es','Patron Exento de Impuestos',0),(463967,12888,'de','Steuer befreit Arbeitgeber',0),(463968,12888,'en','Tax Exempt Employer',0),(463969,12889,'is','',0),(463970,12889,'dr','1',0),(463971,12889,'pr','Ø¢Ø¯Ø±Ø³ 1',0),(463972,12889,'tr','Adres 1',0),(463973,12889,'pl','Adres 1',0),(463974,12889,'bg','ÐÐ´Ñ€ÐµÑ 1',0),(463975,12889,'ur','Ù¾ØªØ§ 1',0),(463976,12889,'sr','ÐÐ´Ñ€ÐµÑÐ° 1',0),(463977,12889,'vi','Äá»‹a Chá»‰ 1',0),(463978,12889,'af','Adres 1',0),(463979,12889,'ro','Adresa 1',0),(463980,12889,'et','Aadressi 1',0),(463981,12889,'si','Naslov 1',0),(463982,12889,'ba','Alamat 1',0),(463983,12889,'nl','Adres 1',0),(463984,12889,'fi','Osoite 1',0),(463985,12889,'no','Adresse 1',0),(463986,12889,'da','Adresse 1',0),(463987,12889,'ko','ì£¼ì†Œ 1',0),(463988,12889,'he','×›×ª×•×‘×ª 1',0),(463989,12889,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· 1',0),(463990,12889,'zh','åœ°å€ 1',0),(463991,12889,'sv','Adress: 1',0),(463992,12889,'it','Indirizzo 1',0),(463993,12889,'tl','',0),(463994,12889,'th','à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆ 1',0),(463995,12889,'hi','à¤ªà¤¤à¤¾ 1',0),(463996,12889,'ms','Alamat 1',0),(463997,12889,'ar','Ø§Ù„Ø¹Ù†ÙˆØ§Ù† 1',0),(463998,12889,'fr','Adresse 1',0),(463999,12889,'jp','ã‚¢ãƒ‰ãƒ¬ã‚¹ 1',0),(464000,12889,'pt','EndereÃ§o 1',0),(464001,12889,'ru','ÐÐ´Ñ€ÐµÑ 1',0),(464002,12889,'es','DirecciÃ³n 1',0),(464003,12889,'de','Adresse 1',0),(464004,12889,'en','Address 1',0),(464005,12890,'is','',0),(464006,12890,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ú¯Ø²Ø§Ø±Ø´ Ø¯Ù‡ÛŒ Ø¢Ù†Ù„Ø§ÛŒÙ†',0),(464007,12890,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ú¯Ø²Ø§Ø±Ø´ Ø¯Ù‡ÛŒ Ø¢Ù†Ù„Ø§ÛŒÙ†',0),(464008,12890,'tr','Online raporlama Kur',0),(464009,12890,'pl','Konfiguracja raportowania online',0),(464010,12890,'bg','ÐžÐ½Ð»Ð°Ð¹Ð½ Ð¾Ñ‚Ñ‡Ð¸Ñ‚Ð°Ð½Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(464011,12890,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ø¢Ù† Ù„Ø§Ø¦Ù† Ú©ÙˆØ±ÛŒØ¬',0),(464012,12890,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð° ÐžÐ½Ð»Ð¸Ð½Ðµ Ð·Ð° Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ð²Ð°ÑšÐµ',0),(464013,12890,'vi','Thiáº¿t láº­p bÃ¡o cÃ¡o trá»±c tuyáº¿n',0),(464014,12890,'af','Aanlyn rapportering opstelling',0),(464015,12890,'ro','Raportare online Setup',0),(464016,12890,'et','Online aruandluse seadistamine',0),(464017,12890,'si','Spletni poroÄevalnega Setup',0),(464018,12890,'ba','Setup pelaporan online',0),(464019,12890,'nl','Online rapportage Setup',0),(464020,12890,'fi','Online raportoinnin asetukset',0),(464021,12890,'no','Online-redegjÃ¸relse oppsett',0),(464022,12890,'da','Online rapportering Setup',0),(464023,12890,'ko','ì˜¨ë¼ì¸ ë³´ê³  ì„¤ì¹˜',0),(464024,12890,'he','×”×’×“×¨×ª ×“×™×•×•×— ×ž×§×•×•×Ÿ',0),(464025,12890,'el','Î¡ÏÎ¸Î¼Î¹ÏƒÎ· online Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(464026,12890,'zh','ç½‘ä¸Šç”³æŠ¥è®¾ç½®',0),(464027,12890,'sv','Online rapportering Setup',0),(464028,12890,'it','Impostazione di segnalazione online',0),(464029,12890,'tl','',0),(464030,12890,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸£à¸²à¸¢à¸‡à¸²à¸™à¸­à¸­à¸™à¹„à¸¥à¸™à¹Œ',0),(464031,12890,'hi','à¤‘à¤¨à¤²à¤¾à¤‡à¤¨ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¤¿à¤‚à¤— à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(464032,12890,'ms','Persediaan laporan dalam talian',0),(464033,12890,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ± Ø¹Ø¨Ø± Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(464034,12890,'fr','Installation de Reporting en ligne',0),(464035,12890,'jp','ã‚ªãƒ³ãƒ©ã‚¤ãƒ³ ãƒ¬ãƒãƒ¼ãƒˆ ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(464036,12890,'pt','ConfiguraÃ§Ã£o de relatÃ³rios on-line',0);
INSERT INTO `langdef` VALUES (464037,12890,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð½Ð¾ÑÑ‚Ð¸',0),(464038,12890,'es','ConfiguraciÃ³n de Reportar en Linea',0),(464039,12890,'de','Online-Reporting-Setup',0),(464040,12890,'en','Online Reporting Setup',0),(464041,12891,'is','',0),(464042,12891,'dr','ØªÙ„ÙÙ† Ø¯Ø§Ø®Ù„ÛŒ',0),(464043,12891,'pr','ØªÙ„ÙÙ† Ø¯Ø§Ø®Ù„ÛŒ',0),(464044,12891,'tr','Telefon uzantÄ±sÄ±',0),(464045,12891,'pl','Telefon Extension',0),(464046,12891,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¸Ðµ',0),(464047,12891,'ur','ÙÙˆÙ† Ø§ÛŒÚ©Ø³Ù¹Ù†Ø´Ù†',0),(464048,12891,'sr','Ð›Ð¾ÐºÐ°Ð»',0),(464049,12891,'vi','má»Ÿ rá»™ng phone',0),(464050,12891,'af','Foon uitbreiding',0),(464051,12891,'ro','Prelungire de telefon',0),(464052,12891,'et','Telefoni laiendamine',0),(464053,12891,'si','Telefon razÅ¡iritve',0),(464054,12891,'ba','Telepon Extension',0),(464055,12891,'nl','Toestelnummer',0),(464056,12891,'fi','Alanumero',0),(464057,12891,'no','Internnummer',0),(464058,12891,'da','Telefon udvidelse',0),(464059,12891,'ko','ì „í™” í™•ìž¥',0),(464060,12891,'he','×˜×œ×¤×•×Ÿ',0),(464061,12891,'el','Î¤Î·Î½ ÎµÏ€Î­ÎºÏ„Î±ÏƒÎ· Ï„Î¿Ï… Ï„Î·Î»ÎµÏ†ÏŽÎ½Î¿Ï…',0),(464062,12891,'zh','ç”µè¯åˆ†æœº',0),(464063,12891,'sv','Anknytning',0),(464064,12891,'it','Estensione del telefono',0),(464065,12891,'tl','',0),(464066,12891,'th','à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œ',0),(464067,12891,'hi','à¤«à¤¼à¥‹à¤¨ à¤à¤•à¥à¤¸à¤Ÿà¥‡à¤‚à¤¶à¤¨',0),(464068,12891,'ms','Sambungan telefon',0),(464069,12891,'ar','Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„ØªÙ…Ø¯ÙŠØ¯',0),(464070,12891,'fr','Poste tÃ©lÃ©phonique',0),(464071,12891,'jp','å†…ç·šé›»è©±',0),(464072,12891,'pt','ExtensÃ£o de telefone',0),(464073,12891,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð¸Ðµ',0),(464074,12891,'es','ExtensiÃ³n TelefÃ³nica',0),(464075,12891,'de','Durchwahl',0),(464076,12891,'en','Phone Extension',0),(464077,12892,'is','',0),(464078,12892,'dr','Ø¯Ùˆ Ù†Ø§Ù…Ù‡',0),(464079,12892,'pr','Ø¯Ùˆ Ù†Ø§Ù…Ù‡',0),(464080,12892,'tr','Ä°ki mektup',0),(464081,12892,'pl','Dwie litery',0),(464082,12892,'bg','Ð”Ð²Ðµ Ð¿Ð¸ÑÐ¼Ð¾',0),(464083,12892,'ur','Ø¯Ùˆ Ø®Ø·',0),(464084,12892,'sr','Ð”Ð²Ð° Ð¿Ð¸ÑÐ¼Ð°',0),(464085,12892,'vi','2 kÃ½ tá»±',0),(464086,12892,'af','Twee Letter',0),(464087,12892,'ro','DouÄƒ litere',0),(464088,12892,'et','Kaks kirja',0),(464089,12892,'si','2 Ärki',0),(464090,12892,'ba','Dua huruf',0),(464091,12892,'nl','Twee letters',0),(464092,12892,'fi','Kaksikirjaiminen',0),(464093,12892,'no','To brev',0),(464094,12892,'da','To bogstaver',0),(464095,12892,'ko','2 íŽ¸ì§€',0),(464096,12892,'he','×©×ª×™ ××•×ª×™×•×ª',0),(464097,12892,'el','Î”ÏÎ¿ ÎµÏ€Î¹ÏƒÏ„Î¿Î»Î®',0),(464098,12892,'zh','ä¸¤ä¸ªå­—æ¯',0),(464099,12892,'sv','TvÃ¥ bokstÃ¤ver',0),(464100,12892,'it','Lettera di due',0),(464101,12892,'tl','',0),(464102,12892,'th','à¸ªà¸­à¸‡à¸•à¸±à¸§à¸­à¸±à¸à¸©à¸£',0),(464103,12892,'hi','à¤¦à¥‹ à¤ªà¤¤à¥à¤°',0),(464104,12892,'ms','Dua Surat',0),(464105,12892,'ar','Ø±Ø³Ø§Ù„Ø© Ø§Ø«Ù†ÙŠÙ†',0),(464106,12892,'fr','Deux lettres',0),(464107,12892,'jp','2 ã¤ã®æ‰‹ç´™',0),(464108,12892,'pt','Duas letras',0),(464109,12892,'ru','Ð”Ð²Ð° Ð¿Ð¸ÑÑŒÐ¼Ð°',0),(464110,12892,'es','Dos Letras',0),(464111,12892,'de','Zwei Buchstaben',0),(464112,12892,'en','Two Letter',0),(464113,12893,'is','',0),(464114,12893,'dr','1099',0),(464115,12893,'pr','Ø®Ø¯Ù…Ø§Øª Ù…Ø§Ù„ÛŒØ§Øª Ø¯Ø§Ø®Ù„ÛŒ 1099',0),(464116,12893,'tr','IRS 1099',0),(464117,12893,'pl','IRS 1099',0),(464118,12893,'bg','IRS 1099',0),(464119,12893,'ur','Ø§ 1099',0),(464120,12893,'sr','Ð˜Ð Ð¡ 1099 ÐšÐžÐœÐŸÐ›Ð•Ð¢ÐÐ',0),(464121,12893,'vi','IRS 1099',0),(464122,12893,'af','IRS 1099',0),(464123,12893,'ro','IRS 1099',0),(464124,12893,'et','IRS-I 1099',0),(464125,12893,'si','IRS 1099',0),(464126,12893,'ba','IRS 1099',0),(464127,12893,'nl','IRS 1099',0),(464128,12893,'fi','IRS 1099',0),(464129,12893,'no','IRS 1099',0),(464130,12893,'da','IRS 1099',0),(464131,12893,'ko','êµ­ì„¸ì²­ 1099',0),(464132,12893,'he','×ž×¡ ×”×›× ×¡×” 1099',0),(464133,12893,'el','IRS 1099',0),(464134,12893,'zh','IRS 1099',0),(464135,12893,'sv','IRS 1099',0),(464136,12893,'it','IRS 1099',0),(464137,12893,'tl','',0),(464138,12893,'th','IRS 1099',0),(464139,12893,'hi','à¤†à¤ˆà¤†à¤°à¤à¤¸ 1099',0),(464140,12893,'ms','IRS 1099',0),(464141,12893,'ar','IRS 1099',0),(464142,12893,'fr','IRS 1099',0),(464143,12893,'jp','IRS 1099',0),(464144,12893,'pt','IRS 1099',0),(464145,12893,'ru','IRS 1099',0),(464146,12893,'es','IRS 1099',0),(464147,12893,'de','IRS 1099',0),(464148,12893,'en','IRS 1099',0),(464149,12894,'is','',0),(464150,12894,'dr','Ù‡ÛŒÚ† Ø§Ø·Ù„Ø§Ø¹Ø§ØªÛŒ Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(464151,12894,'pr','Ù‡ÛŒÚ† Ø§Ø·Ù„Ø§Ø¹Ø§ØªÛŒ Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(464152,12894,'tr','GÃ¶nderilen veri',0),(464153,12894,'pl','Nie dane przesyÅ‚ane',0),(464154,12894,'bg','ÐÑÐ¼Ð° Ð´Ð°Ð½Ð½Ð¸, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(464155,12894,'ur','Ú©ÙˆØ¦ÛŒ ÚˆÛŒÙ¹Ø§ Ø¨Ú¾ÛŒØ¬Ø§',0),(464156,12894,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÐºÐ¾Ñ˜Ð¸ ÑÐµ ÑˆÐ°Ñ™Ñƒ',0),(464157,12894,'vi','khÃ´ng cÃ³ dá»¯ liá»‡u Ä‘Ã£ gá»­i',0),(464158,12894,'af','Geen Data gestuur',0),(464159,12894,'ro','Nu existÄƒ date trimise',0),(464160,12894,'et','Saadetud andmed',0),(464161,12894,'si','Ni podatki, poslani',0),(464162,12894,'ba','Tidak ada Data yang dikirim',0),(464163,12894,'nl','Geen gegevens worden verzonden',0),(464164,12894,'fi','LÃ¤hetettÃ¤vÃ¤t tiedot',0),(464165,12894,'no','Ingen Data sendt',0),(464166,12894,'da','Ingen Data, der sendes',0),(464167,12894,'ko','ë°ì´í„° ì „ì†¡',0),(464168,12894,'he','××™×Ÿ × ×ª×•× ×™× ×©× ×©×œ×—×•',0),(464169,12894,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(464170,12894,'zh','æ²¡æœ‰å‘é€çš„æ•°æ®',0),(464171,12894,'sv','Inga Data skickas',0),(464172,12894,'it','Dati non inviati',0),(464173,12894,'tl','',0),(464174,12894,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸ªà¹ˆà¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(464175,12894,'hi','à¤•à¥‹à¤ˆ à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤­à¥‡à¤œà¤¾ à¤¹à¥ˆ',0),(464176,12894,'ms','Tiada Data yang dihantar',0),(464177,12894,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø±Ø³Ù„Ø©',0),(464178,12894,'fr','Aucune donnÃ©es envoyÃ©es',0),(464179,12894,'jp','é€ä¿¡ã•ã‚ŒãŸãƒ‡ãƒ¼ã‚¿ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(464180,12894,'pt','NÃ£o hÃ¡ dados enviados',0),(464181,12894,'ru','ÐÐµÑ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ…, Ð¿ÐµÑ€ÐµÐ´Ð°Ð²Ð°ÐµÐ¼Ñ‹Ñ…',0),(464182,12894,'es','No se Mando Ningunos Datos',0),(464183,12894,'de','Keine Daten gesendet',0),(464184,12894,'en','No Data Sent',0),(464185,12895,'is','',0),(464186,12895,'dr','(Ø«Ø¨Øª Ù‡Ø§) Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯',0),(464187,12895,'pr','Ø±Ú©ÙˆØ±Ø¯Ù‡Ø§(Ø«Ø¨Øª Ù‡Ø§) Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯',0),(464188,12895,'tr','KayÄ±t baÅŸarÄ±yla kaydedildi',0),(464189,12895,'pl','Zapisane rekordy',0),(464190,12895,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(464191,12895,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(464192,12895,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(464193,12895,'vi','Ä‘Ã£ lÆ°u há»“ sÆ¡ thÃ nh cÃ´ng',0),(464194,12895,'af','Rekords suksesvol gestoor',0),(464195,12895,'ro','ÃŽnregistrÄƒri salvat cu succes',0),(464196,12895,'et','Edukalt salvestatud',0),(464197,12895,'si','Zapisi, shranjen',0),(464198,12895,'ba','Catatan yang disimpan berhasil',0),(464199,12895,'nl','Records opgeslagen',0),(464200,12895,'fi','Tietueiden tallentaminen onnistui',0),(464201,12895,'no','Poster lagret',0),(464202,12895,'da','Poster gemmes korrekt',0),(464203,12895,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” ë ˆì½”ë“œ',0),(464204,12895,'he','×¨×©×•×ž×•×ª ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(464205,12895,'el','Î‘ÏÏ‡ÎµÎ¯Î± Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(464206,12895,'zh','è®°å½•å·²æˆåŠŸä¿å­˜',0),(464207,12895,'sv','Poster som sparats',0),(464208,12895,'it','Record salvati con successo',0),(464209,12895,'tl','',0),(464210,12895,'th','à¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(464211,12895,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(464212,12895,'ms','Rekod berjaya disimpan',0),(464213,12895,'ar','Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(464214,12895,'fr','Enregistrements sauvegardÃ©s avec succÃ¨s',0),(464215,12895,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚ŒãŸãƒ¬ã‚³ãƒ¼ãƒ‰',0),(464216,12895,'pt','Registros salvos com sucesso',0),(464217,12895,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(464218,12895,'es','Records Guardados Exitosamente',0),(464219,12895,'de','DatensÃ¤tze erfolgreich gespeichert',0),(464220,12895,'en','Records Saved Successfully',0),(464221,12896,'is','',0),(464222,12896,'dr','1099 Ø±Ø§ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ù†Ø¯ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ø¯Ø± Ø§ÛŒÙ† Ù„ÛŒØ³Øª Ø¨Ø±Ø±Ø³ÛŒ Ø´Ø¯ ',0),(464223,12896,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ø§ÛŒØ¯Ø±Ø³ÛŒØ¯Ù‡Ø§ÛŒ  1099 Ø±Ø§ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ù†Ø¯ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ø¯Ø± Ø§ÛŒÙ† Ù„ÛŒØ³Øª Ø¨Ø±Ø±Ø³ÛŒ Ø´Ø¯ ',0),(464224,12896,'tr','SatÄ±cÄ±lar bu listede gÃ¶stermek iÃ§in Ã¶dÃ¼nÃ§ aldÄ±ÄŸÄ± 1099 seÃ§eneÄŸi olmasÄ± gerekir.',0),(464225,12896,'pl','Sprzedawcy muszÄ… mieÄ‡ otrzymuje 1099 opcji sprawdzane, aby pokazaÄ‡ na tej liÅ›cie.',0),(464226,12896,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸Ñ‚Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð°Ñ‚ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð° 1099 Ð¾Ð¿Ñ†Ð¸Ñ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚ Ð² Ñ‚Ð¾Ð·Ð¸ ÑÐ¿Ð¸ÑÑŠÐº.',0),(464227,12896,'ur','Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº 1099 ÙˆØµÙˆÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø± Ú©Ùˆ Ø§Ø³ ÙÛØ±Ø³Øª Ù…ÛŒÚº Ù†Ù…Ø§ÛŒØ´ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ø´Ø¯Û ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ Û”',0),(464228,12896,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸ Ð¼Ð¾Ñ€Ð° Ð´Ð° Ð¿Ñ€Ð¸Ð¼Ð° 1099 ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ð¾ Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ð½Ð° Ð¾Ð²Ð¾Ñ˜ Ð»Ð¸ÑÑ‚Ð¸.',0),(464229,12896,'vi','CÃ¡c nhÃ  cung cáº¥p pháº£i nháº­n 1.099 tÃ¹y chá»n kiá»ƒm tra Ä‘á»ƒ hiá»ƒn thá»‹ trong danh sÃ¡ch. ',0),(464230,12896,'af','Verkopers moet ontvang 1099 opsie om te wys in hierdie lys gekontroleer het.',0),(464231,12896,'ro','VÃ¢nzÄƒtorii trebuie sÄƒ aibÄƒ opÅ£iune primeÅŸte 1099 verificate pentru a arÄƒta Ã®n aceastÄƒ listÄƒ.',0),(464232,12896,'et','Hankijad peavad olema saab 1099 mÃ¤rgituks nÃ¤idata selles loendis.',0),(464233,12896,'si','Prodajalci morajo imeti prejme 1099 moÅ¾nost preveriti pokazati na tem seznamu.',0),(464234,12896,'ba','Vendor harus menerima 1099 opsi untuk menunjukkan dalam daftar ini.',0),(464235,12896,'nl','Leveranciers moeten ontvangt 1099 optie gecontroleerd om te laten zien in deze lijst.',0),(464236,12896,'fi','Toimittajat on oltava saa 1099 mahdollisuutta tarkistaa tÃ¤ssÃ¤ luettelossa.',0),(464237,12896,'no','LeverandÃ¸rer mÃ¥ mottar 1099-alternativet som er valgt i denne listen.',0),(464238,12896,'da','LeverandÃ¸rer skal have modtager 1099 indstilling kontrolleres for at vise pÃ¥ denne liste.',0),(464239,12896,'ko','ê³µê¸‰ ì—…ì²´ 1099 ìˆ˜ì‹  ì˜µì…˜ì„ì´ ëª©ë¡ì— í‘œì‹œ í•˜ë ¤ë©´ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(464240,12896,'he','×¡×¤×§×™ ×©×™×¨×•×ª×™× ×—×™×™×‘ ×œ×”×™×•×ª 1099 ×ž×§×‘×œ ××¤×©×¨×•×ª ×œ×‘×“×•×§ ×›×“×™ ×œ×”×¦×™×’ ×‘×¨×©×™×ž×” ×–×•.',0),(464241,12896,'el','Î Ï‰Î»Î·Ï„Î­Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ 1099 Ï€ÏÎ¿Î±Î¹ÏÎµÏ„Î¹ÎºÎ® Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„Î± ÎµÎ»ÎµÎ³Ï‡Î¼Î­Î½Î· ÎµÏ€Î¹Î´ÎµÎ¹ÎºÎ½ÏÏ‰ ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· Î»Î¯ÏƒÏ„Î±.',0),(464242,12896,'zh','ä¾›åº”å•†å¿…é¡»å…·æœ‰æŽ¥æ”¶ 1099å¹´é€‰ä¸­åœ¨æ­¤åˆ—è¡¨ä¸­æ˜¾ç¤ºçš„é€‰é¡¹ã€‚',0),(464243,12896,'sv','LeverantÃ¶rer mÃ¥ste ha mottar 1099 alternativet markerat fÃ¶r att visa i den hÃ¤r listan.',0),(464244,12896,'it','Fornitori devono avere 1099 riceve opzione selezionata per mostrare in questo elenco.',0),(464245,12896,'tl','',0),(464246,12896,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸ 1099 à¹„à¸”à¹‰à¸£à¸±à¸šà¹€à¸¥à¸·à¸­à¸à¹ƒà¸«à¹‰à¹à¸ªà¸”à¸‡à¹ƒà¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸™à¸µà¹‰',0),(464247,12896,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ 1099 à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤µà¤¿à¤•à¤²à¥à¤ª à¤‡à¤¸ à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥€ à¤œà¤¾à¤à¤š à¤¹à¥‹à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(464248,12896,'ms','Pembekal hendaklah mempunyai pilihan 1099 menerima, disemak untuk menunjukkan dalam senarai ini.',0),(464249,12896,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯Ù‰ Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ† 1099 ÙŠØªÙ„Ù‚Ù‰ Ø§Ù„Ø®ÙŠØ§Ø± Ù…Ø­Ø¯Ø¯Ø§Ù‹ Ù„ØªØ¸Ù‡Ø± ÙÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©.',0),(464250,12896,'fr','Fournisseurs doivent avoir reÃ§oit 1099 cochÃ©e pour montrer dans cette liste.',0),(464251,12896,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã¯ã€1099 ã‚’å—ã‘å–ã‚‹ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’ã“ã®ä¸€è¦§ã«è¡¨ç¤ºã™ã‚‹ã‚ªãƒ³ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(464252,12896,'pt','Os fornecedores devem ter 1099 recebe opÃ§Ã£o marcada para mostrar nesta lista.',0),(464253,12896,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¸Ð¼ÐµÑ‚ÑŒ 1099, Ð¿Ð¾Ð»ÑƒÑ‡Ð°ÐµÑ‚ Ñ„Ð»Ð°Ð¶Ð¾Ðº Ð´Ð»Ñ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ Ð² ÑÑ‚Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÐµ.',0),(464254,12896,'es','Vendedores debe tener la opciÃ³n recibir 1099 tachada para aparecer en esta lista',0),(464255,12896,'de','Anbieter mÃ¼ssen erhÃ¤lt 1099 Option \"umgekehrt\" in dieser Liste zu zeigen.',0),(464256,12896,'en','Vendors must have Receives 1099 option checked to show in this list.',0),(464257,12897,'is','',0),(464258,12897,'dr','Ù†Ù…Ø§ÛŒØ´ Ú¯Ø²Ø§Ø±Ø´ Ùˆ Ú†Ø§Ù¾',0),(464259,12897,'pr','Ù†Ù…Ø§ÛŒØ´ Ú¯Ø²Ø§Ø±Ø´ Ùˆ Ú†Ø§Ù¾',0),(464260,12897,'tr','Raporu GÃ¶rÃ¼ntÃ¼le & YazdÄ±r',0),(464261,12897,'pl','WyÅ›wietl raport & wydruku',0),(464262,12897,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ & Ð¿ÐµÑ‡Ð°Ñ‚',0),(464263,12897,'ur','Ù…Ù†Ø¸Ø± Ø±Ù¾ÙˆØ±Ù¹ & Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(464264,12897,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð·Ð²Ñ˜ÐµÑˆÑ‚Ð°Ñ˜ & ÐŸÑ€Ð¸Ð½Ñ‚',0),(464265,12897,'vi','Xem bÃ¡o cÃ¡o vÃ  in',0),(464266,12897,'af','Besigtig Verslag & Druk',0),(464267,12897,'ro','Vizualizare raport & Print',0),(464268,12897,'et','Kuva aruanne & printimine',0),(464269,12897,'si','Ogled poroÄila & Print',0),(464270,12897,'ba','Lihat laporan & cetak',0),(464271,12897,'nl','Rapport weergeven & afdrukken',0),(464272,12897,'fi','NÃ¤ytÃ¤ raportti & tulosta',0),(464273,12897,'no','Vis rapport & Print',0),(464274,12897,'da','Vis rapport & Print',0),(464275,12897,'ko','ë³´ê³ ì„œ ë³´ê¸° & ì¸ì‡„',0),(464276,12897,'he','×”×¦×’ ×“×•×— & ×”×“×¤×¡×”',0),(464277,12897,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ & ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(464278,12897,'zh','æŸ¥çœ‹æŠ¥å‘Š &amp; æ‰“å°',0),(464279,12897,'sv','Visa rapport & Print',0),(464280,12897,'it','Visualizza Report & stampa',0),(464281,12897,'tl','',0),(464282,12897,'th','à¸”à¸¹à¸£à¸²à¸¢à¸‡à¸²à¸™ & à¸žà¸´à¸¡à¸žà¹Œ',0),(464283,12897,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ & à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(464284,12897,'ms','Lihat laporan & cetak',0),(464285,12897,'ar','Ø¹Ø±Ø¶ Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø¢Ù†Ø¯ Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(464286,12897,'fr','Afficher le rapport & Print',0),(464287,12897,'jp','ãƒ¬ãƒãƒ¼ãƒˆã®è¡¨ç¤º & ãƒ—ãƒªãƒ³ãƒˆ',0),(464288,12897,'pt','Exibir relatÃ³rio & impressÃ£o',0),(464289,12897,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð° & Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(464290,12897,'es','Vistar el Reporte y Imprimir',0),(464291,12897,'de','Bericht anzeigen & drucken',0),(464292,12897,'en','View Report & Print',0),(464293,12898,'is','',0),(464294,12898,'dr','1099Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®ÙˆØ¯',0),(464295,12898,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ùˆ Ø³Ù¾Ø³ Ø°Ø®ÛŒØ±Ù‡ 1099Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®ÙˆØ¯',0),(464296,12898,'tr','DÃ¼zenlemek ve 1099 verileri Ã¶nce kaydedin.',0),(464297,12898,'pl','Edytuj, a nastÄ™pnie Zapisz dane 1099 po raz pierwszy.',0),(464298,12898,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¸ ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð° Ð¿ÑŠÑ€Ð²Ð¾ Ð´Ð° Ð·Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ ÑÐ¸ 1099.',0),(464299,12898,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù¾Ú¾Ø± Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§Ù¾Ù†Û’ 1099 Ú©ÙˆØ§Ø¦Ù Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº Û”',0),(464300,12898,'sr','Ð£Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ð¸ ÑÐ°Ñ‡ÑƒÐ²Ð°Ñ˜Ñ‚Ðµ Ð²Ð°ÑˆÐµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ 1099 ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð° Ð¿Ñ€Ð²Ð¾.',0),(464301,12898,'vi','thÃªm vÃ  sau Ä‘Ã³ lÆ°u cho báº¡n sá»‘ 1099 trÆ°á»›c',0),(464302,12898,'af','Redigeer en stoor dan eers jou 1099 data.',0),(464303,12898,'ro','Edita ÅŸi apoi salvaÅ£i datele 1099 primul.',0),(464304,12898,'et','Redigeerige ja salvestage 1099-andmete esimene.',0),(464305,12898,'si','Uredite in nato shranite podatke 1099 prviÄ.',0),(464306,12898,'ba','Mengedit dan kemudian menyimpan 1099 data pertama.',0),(464307,12898,'nl','Bewerken en sla uw 1099 gegevens eerst.',0),(464308,12898,'fi','Muokkaa ja Tallenna 1099 tiedot ensin.',0),(464309,12898,'no','Redigere og lagre 1099 dataene fÃ¸rst.',0),(464310,12898,'da','Rediger og Gem dine 1099-oplysninger fÃ¸rst.',0),(464311,12898,'ko','íŽ¸ì§‘ í•˜ ê³  ë¨¼ì € 1099 ë°ì´í„°ë¥¼ ì €ìž¥ í•©ë‹ˆë‹¤.',0),(464312,12898,'he','×¢×¨×™×›×” ×•×œ××—×¨ ×ž×›×Ÿ ×œ×©×ž×•×¨ ××ª ×”× ×ª×•× ×™× 1099 ×©×œ×š ×§×•×“×.',0),(464313,12898,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ ÎºÎ±Î¹ ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î± Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± 1099 Ï€ÏÏŽÏ„Î±.',0),(464314,12898,'zh','ç¼–è¾‘ï¼Œç„¶åŽä¿å­˜æ‚¨çš„ 1099å¹´æ•°æ®ç¬¬ä¸€æ¬¡ã€‚',0),(464315,12898,'sv','Redigera och spara sedan dina 1099-data fÃ¶rst.',0),(464316,12898,'it','Modificare e poi salvare i dati di 1099 prima.',0),(464317,12898,'tl','',0),(464318,12898,'th','à¹à¸à¹‰à¹„à¸‚ à¹à¸¥à¸°à¸ˆà¸²à¸à¸™à¸±à¹‰à¸™ à¸šà¸±à¸™à¸—à¸¶à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥ 1099 à¸„à¸£à¸±à¹‰à¸‡à¹à¸£à¸',0),(464319,12898,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤¤à¤¬ à¤ªà¤¹à¤²à¥€ à¤¬à¤¾à¤° à¤…à¤ªà¤¨à¥‡ 1099 à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚à¥¤',0),(464320,12898,'ms','Edit dan Simpan data 1099 anda terlebih dahulu.',0),(464321,12898,'ar','ØªØ­Ø±ÙŠØ±ØŒ Ø«Ù… Ù‚Ù… Ø¨Ø­ÙØ¸ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª 1099 Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ Ø£ÙˆÙ„Ø§Ù‹.',0),(464322,12898,'fr','Modifier et puis enregistrez vos donnÃ©es de 1099 tout d\'abord.',0),(464323,12898,'jp','ç·¨é›†ã—ã€æœ€åˆã® 1099å¹´ãƒ‡ãƒ¼ã‚¿ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(464324,12898,'pt','Edite e salve seus dados 1099 primeiro.',0),(464325,12898,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ, Ð° Ð·Ð°Ñ‚ÐµÐ¼ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÐ¸ Ð´Ð°Ð½Ð½Ñ‹Ðµ 1099 ÑÐ½Ð°Ñ‡Ð°Ð»Ð°.',0),(464326,12898,'es','Edita y Guarda',0),(464327,12898,'de','Bearbeiten Sie und speichern Sie dann Ihre 1099-Daten zuerst.',0),(464328,12898,'en','Edit and then save your 1099 data first.',0),(464329,12899,'is','',0),(464330,12899,'dr','1099 Ø¯Ø§Ø¯Ù‡ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(464331,12899,'pr','1099 Ø¯Ø§Ø¯Ù‡ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(464332,12899,'tr','HayÄ±r 1099 veri bulundu',0),(464333,12899,'pl','Danych nr 1099',0),(464334,12899,'bg','â„– 1099 Ð´Ð°Ð½Ð½Ð¸, Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(464335,12899,'ur','Ú©ÙˆØ¦ÛŒ 1099 Ú©ÙˆØ§Ø¦Ù Ù¾Ø§ÛŒØ§',0),(464336,12899,'sr','1099 ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð° Ð½Ðµ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð¸',0),(464337,12899,'vi','khÃ´ng tÃ¬m tháº¥y dá»¯ liá»‡u sá»‘ 1099',0),(464338,12899,'af','Nr 1099 Data gevind',0),(464339,12899,'ro','No 1099 date gÄƒsite',0),(464340,12899,'et','Nr 1099 andmete leitud',0),(464341,12899,'si','No 1099 podatkov naÅ¡el',0),(464342,12899,'ba','1099 tidak ada Data yang ditemukan',0),(464343,12899,'nl','No 1099 gegevens gevonden',0),(464344,12899,'fi','N 1099 tiedot',0),(464345,12899,'no','Fant ingen 1099-Data',0),(464346,12899,'da','Ingen 1099-oplysninger fundet',0),(464347,12899,'ko','ì•„ë‹ˆ 1099 ë°ì´í„° ë°œê²¬',0),(464348,12899,'he','× ×ª×•× ×™× 1099. ×œ× × ×ž×¦××•',0),(464349,12899,'el','1099 Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(464350,12899,'zh','å‘çŽ°æ²¡æœ‰ 1099 æ•°æ®',0),(464351,12899,'sv','Nr 1099-Data finns',0),(464352,12899,'it','1099 no dati trovati',0),(464353,12899,'tl','',0),(464354,12899,'th','1099 à¹„à¸¡à¹ˆà¸žà¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(464355,12899,'hi','à¤¸à¤‚ 1099 à¤¡à¥‡à¤Ÿà¤¾ à¤ªà¤¾à¤¯à¤¾',0),(464356,12899,'ms','Maklumat No 1099',0),(464357,12899,'ar','ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¨ÙŠØ§Ù†Ø§Øª Ù„Ø§ 1099',0),(464358,12899,'fr','DonnÃ©es de 1099 non trouvÃ©es',0),(464359,12899,'jp','No ã® 1099 ãƒ‡ãƒ¼ã‚¿ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(464360,12899,'pt','Dados de 1099 nÃ£o encontrados',0),(464361,12899,'ru','No 1099 Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(464362,12899,'es','No es Encuentra Ningunos Datos de 1099',0),(464363,12899,'de','Nr. 1099 Daten gefunden',0),(464364,12899,'en','No 1099 Data Found',0),(464365,12900,'is','',0),(464366,12900,'dr','Ù‡ÛŒÚ† Ù…Ø§Ù„ÛŒØ§Øª Ø³Ø§Ù„Ø§Ù†Ù‡ Ø§ÛŒØªÙ†Ø¸ÛŒÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª  ',0),(464367,12900,'pr','Ù‡ÛŒÚ† Ù…Ø§Ù„ÛŒØ§Øª Ø³Ø§Ù„Ø§Ù†Ù‡ Ø§ÛŒØªÙ†Ø¸ÛŒÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª  ',0),(464368,12900,'tr','Vergi yÄ±l ayarlanmadÄ±',0),(464369,12900,'pl','Nie zestaw roku podatkowego',0),(464370,12900,'bg','ÐÑÐ¼Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸',0),(464371,12900,'ur','Ú©ÙˆØ¦ÛŒ Ù¹ÛŒÚ©Ø³ Ø³Ø§Ù„ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(464372,12900,'sr','Ð¡ÐµÑ‚ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð±ÐµÐ· Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(464373,12900,'vi','khÃ´ng láº­p thuáº¿ nÄƒm',0),(464374,12900,'af','Geen belasting jaar stel',0),(464375,12900,'ro','Nici un Set de anul fiscal',0),(464376,12900,'et','Mingit maksu aasta komplekt',0),(464377,12900,'si','Ni nastavljenega leto davka',0),(464378,12900,'ba','Tidak ada pajak tahun Set',0),(464379,12900,'nl','Geen fiscale jaar ingesteld',0),(464380,12900,'fi','Ei veroa vuonna asetettu',0),(464381,12900,'no','Ingen skatt Ã¥ret sett',0),(464382,12900,'da','Ingen skat Ã¥r sÃ¦t',0),(464383,12900,'ko','ì•„ë‹ˆ ì„¸ê¸ˆ ë…„ ì„¸íŠ¸',0),(464384,12900,'he','×œ× ×”×•×’×“×¨×• ×©× ×ª ×”×ž×¡',0),(464385,12900,'el','ÎšÎ±Î½Î­Î½Î± Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŒ Î­Ï„Î¿Ï‚ ÏƒÏÎ½Î¿Î»Î¿',0),(464386,12900,'zh','æ— ç¨Žå¹´é›†åˆ',0),(464387,12900,'sv','Ingen skatt Ã¥r som',0),(464388,12900,'it','Nessun Set di anno fiscale',0),(464389,12900,'tl','',0),(464390,12900,'th','à¸Šà¸¸à¸”à¸›à¸µà¸ à¸²à¸©à¸µà¹„à¸¡à¹ˆ',0),(464391,12900,'hi','à¤•à¥‹à¤ˆ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¸à¤¾à¤² à¤¸à¥‡à¤Ÿ',0),(464392,12900,'ms','Tiada cukai tahun Set',0),(464393,12900,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©',0),(464394,12900,'fr','Aucun ensemble de l\'annÃ©e fiscale',0),(464395,12900,'jp','ç¨Žå¹´ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(464396,12900,'pt','Nenhum conjunto de ano fiscal',0),(464397,12900,'ru','ÐÐ°Ð±Ð¾Ñ€ Ð½Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´',0),(464398,12900,'es','No se ConfigurÃ³ el AÃ±o',0),(464399,12900,'de','Keine Steuer-Jahreszusammenstellung',0),(464400,12900,'en','No Tax Year Set',0),(464401,12901,'is','',0),(464402,12901,'dr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÛŒÙ„',0),(464403,12901,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÛŒÙ„',0),(464404,12901,'tr','DosyanÄ±n sÃ¼tunu biÃ§imi',0),(464405,12901,'pl','Plik formatu kolumny',0),(464406,12901,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð° ÐºÐ¾Ð»Ð¾Ð½Ð°',0),(464407,12901,'ur','Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ù…Ø³Ù„',0),(464408,12901,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÐºÐ¾Ð»Ð¾Ð½Ðµ',0),(464409,12901,'vi','file dáº¡ng cá»™t',0),(464410,12901,'af','LÃªerformaat kolom',0),(464411,12901,'ro','Dosar Format coloane',0),(464412,12901,'et','Veeru vormingus',0),(464413,12901,'si','Stolpec zapisa',0),(464414,12901,'ba','Format file kolom',0),(464415,12901,'nl','Kolom bestandsindeling',0),(464416,12901,'fi','Sarakkeen tiedostomuoto',0),(464417,12901,'no','Kolonnen filformat',0),(464418,12901,'da','Kolonne filformat',0),(464419,12901,'ko','íŒŒì¼ ì—´ í˜•ì‹',0),(464420,12901,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×§×•×‘×¥',0),(464421,12901,'el','Î£Ï„Î®Î»Î· Î¼Î¿ÏÏ†Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(464422,12901,'zh','æ–‡ä»¶åˆ—çš„æ ¼å¼',0),(464423,12901,'sv','Kolumn filformatet',0),(464424,12901,'it','Formato di file colonne',0),(464425,12901,'tl','',0),(464426,12901,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œà¹„à¸Ÿà¸¥à¹Œ',0),(464427,12901,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(464428,12901,'ms','Format kolum fail',0),(464429,12901,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ ÙÙŠ Ù…Ù„Ù',0),(464430,12901,'fr','Format de colonne de fichier',0),(464431,12901,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®åˆ—ã®å½¢å¼',0),(464432,12901,'pt','Formato de coluna do arquivo',0),(464433,12901,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð¾Ð²',0),(464434,12901,'es','Formato Fila Columna',0),(464435,12901,'de','Spalte-Dateiformat',0),(464436,12901,'en','File Column Format',0),(464437,12902,'is','',0),(464438,12902,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ØªÙˆØ¶ÛŒØ­Ø§Øª Ù„ÛŒØ³Øª Ù…ÙˆØ§Ø¯ ',0),(464439,12902,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ØªÙˆØ¶ÛŒØ­Ø§Øª Ù„ÛŒØ³Øª Ù…ÙˆØ§Ø¯ ',0),(464440,12902,'tr','ÃœrÃ¼n ReÃ§etesi tanÄ±mlarÄ±nÄ± iÃ§e aktarma',0),(464441,12902,'pl','ZaimportowaÄ‡ definicje BOM',0),(464442,12902,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐšÐ˜ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ð¸',0),(464443,12902,'ur','Ø¨Ø§Ù… Ú©ÛŒ ØªØ¹Ø±ÛŒÙ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(464444,12902,'sr','Ð£Ð²Ð¾Ð· Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ðµ',0),(464445,12902,'vi','Nháº­p Ä‘á»‹nh nghÄ©a BÃ”M',0),(464446,12902,'af','Voer BOM definisies',0),(464447,12902,'ro','DefiniÅ£ii de LM-ului de import',0),(464448,12902,'et','Koosluse mÃµisteid',0),(464449,12902,'si','Uvoz Kosovnice opredelitve',0),(464450,12902,'ba','Impor BOM definisi',0),(464451,12902,'nl','Importeren van Stuklijst definities',0),(464452,12902,'fi','Tuoda Tuoterakenteen mÃ¤Ã¤ritelmiÃ¤',0),(464453,12902,'no','Importere Stykkliste definisjoner',0),(464454,12902,'da','Importerer Styklisten definitioner',0),(464455,12902,'ko','BOM ì •ì˜ ê°€ì ¸ì˜¤ê¸°',0),(464456,12902,'he','×œ×™×™×‘× ×”×’×“×¨×•×ª ×”-BOM',0),(464457,12902,'el','ÎŸÏÎ¹ÏƒÎ¼Î¿Î¯ Ï„Î·Ï‚ Ï„ÎµÏ‡Î½Î¹ÎºÎ®Ï‚ Î ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(464458,12902,'zh','å¯¼å…¥ç‰©æ–™æ¸…å•å®šä¹‰',0),(464459,12902,'sv','Importera standarddefinitioner fÃ¶r Strukturlista',0),(464460,12902,'it','Importare le definizioni BOM',0),(464461,12902,'tl','',0),(464462,12902,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸‚à¹‰à¸­à¸à¸³à¸«à¸™à¸” BOM',0),(464463,12902,'hi','à¤†à¤¯à¤¾à¤¤ BOM à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾à¤à¤',0),(464464,12902,'ms','Definisi BOM import',0),(464465,12902,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ ØªØ¹Ø±ÙŠÙØ§Øª BOM',0),(464466,12902,'fr','Importer des dÃ©finitions de la nomenclature',0),(464467,12902,'jp','éƒ¨å“è¡¨ã®å®šç¾©ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(464468,12902,'pt','Importar definiÃ§Ãµes de BOM',0),(464469,12902,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(464470,12902,'es','Importar Definiciones de BOM',0),(464471,12902,'de','BOM Definitionen importieren',0),(464472,12902,'en','Import BOM Definitions',0),(464473,12903,'is','',0),(464474,12903,'dr','ÙˆØ±ÙˆØ¯ Ù†Ø§Ù…ÙˆÙÙ‚',0),(464475,12903,'pr','ÙˆØ±ÙˆØ¯ Ù†Ø§Ù…ÙˆÙÙ‚',0),(464476,12903,'tr','Alma baÅŸarÄ±sÄ±z oldu',0),(464477,12903,'pl','Importowanie nie powiodÅ‚o siÄ™',0),(464478,12903,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(464479,12903,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ù†Ø§Ú©Ø§Ù… ÛÙˆ Ú¯ÛŒØ§',0),(464480,12903,'sr','Ð£Ð²Ð¾Ð· Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ¾',0),(464481,12903,'vi','nháº­p tháº¥t báº¡i',0),(464482,12903,'af','Invoer het misluk',0),(464483,12903,'ro','Importul nu a reuÈ™it',0),(464484,12903,'et','Importimine nurjus',0),(464485,12903,'si','Uvoz ni uspel',0),(464486,12903,'ba','Impor gagal',0),(464487,12903,'nl','Importeren is mislukt',0),(464488,12903,'fi','Tuonti epÃ¤onnistui',0),(464489,12903,'no','Import mislyktes',0),(464490,12903,'da','Importen mislykkedes',0),(464491,12903,'ko','ê°€ì ¸ì˜¤ê¸° ì‹¤íŒ¨',0),(464492,12903,'he','×”×™×™×‘×•× × ×›×©×œ',0),(464493,12903,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(464494,12903,'zh','å¯¼å…¥å¤±è´¥',0),(464495,12903,'sv','Importen misslyckades',0),(464496,12903,'it','Importazione fallita',0),(464497,12903,'tl','',0),(464498,12903,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(464499,12903,'hi','à¤†à¤¯à¤¾à¤¤ à¤µà¤¿à¤«à¤²',0),(464500,12903,'ms','Import yang gagal',0),(464501,12903,'ar','ÙØ´Ù„ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(464502,12903,'fr','Importation a Ã©chouÃ©',0),(464503,12903,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã«å¤±æ•—ã—ã¾ã—ãŸ',0),(464504,12903,'pt','ImportaÃ§Ã£o falhada',0),(464505,12903,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(464506,12903,'es','ImportaciÃ³n FallÃ³',0),(464507,12903,'de','Import fehlgeschlagen',0),(464508,12903,'en','Import Failed',0),(464509,12904,'is','',0),(464510,12904,'dr','Ú©Ø¯ Ú©Ø§Ù„Ø§ÛŒ Ø§ØµÙ„ÛŒ',0),(464511,12904,'pr','Ú©Ø¯ Ú©Ø§Ù„Ø§ÛŒ Ø§ØµÙ„ÛŒ',0),(464512,12904,'tr','Ana madde kodu',0),(464513,12904,'pl','GÅ‚Ã³wny kod towaru',0),(464514,12904,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð·Ð° Ð¼Ð°Ð³Ð¸ÑÑ‚ÑŠÑ€',0),(464515,12904,'ur','Ù…Ø§Ø³Ù¹Ø± Ø´Û’ Ú©ÙˆÚˆ',0),(464516,12904,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¼Ð°ÑÑ‚ÐµÑ€',0),(464517,12904,'vi','mÃ£ hÃ ng chá»§',0),(464518,12904,'af','Meester Item kode',0),(464519,12904,'ro','Master cod articol',0),(464520,12904,'et','Kapten kauba kood',0),(464521,12904,'si','Å ifra artikla Master',0),(464522,12904,'ba','Kode barang Master',0),(464523,12904,'nl','Master Artikelcode',0),(464524,12904,'fi','Master Nimikekoodi',0),(464525,12904,'no','Master Varekode',0),(464526,12904,'da','Master varekode',0),(464527,12904,'ko','ë§ˆìŠ¤í„° í•­ëª© ì½”ë“œ',0),(464528,12904,'he','×§×•×“ ×¤×¨×™×˜ ×ž××¡×˜×¨',0),(464529,12904,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Master',0),(464530,12904,'zh','ç¡•å£«é¡¹ç›®ä»£ç ',0),(464531,12904,'sv','Master Artikelkod',0),(464532,12904,'it','Codice articolo Master',0),(464533,12904,'tl','',0),(464534,12904,'th','à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²à¸«à¸¥à¸±à¸',0),(464535,12904,'hi','à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤®à¤¦ à¤•à¥‹à¤¡',0),(464536,12904,'ms','Kod Item induk',0),(464537,12904,'ar','ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ',0),(464538,12904,'fr','Code article Master',0),(464539,12904,'jp','ãƒžã‚¹ã‚¿ãƒ¼ ã‚¢ã‚¤ãƒ†ãƒ  ã‚³ãƒ¼ãƒ‰',0),(464540,12904,'pt','CÃ³digo mestre',0),(464541,12904,'ru','ÐœÐ°ÑÑ‚ÐµÑ€ ÐºÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(464542,12904,'es','CÃ³digo Maestro de Item',0),(464543,12904,'de','Master Artikelcode',0),(464544,12904,'en','Master Item Code',0),(464545,12905,'is','',0),(464546,12905,'dr','(Ø¬Ù†Ø³) Ø²ÛŒØ±Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¯Ø± Ù‡Ø± Ù‚ÛŒÙ…Øª Ù†Ù‡Ø§ÛŒÛŒ',0),(464547,12905,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ±Ø¯(Ú©Ø§Ù„Ø§) Ø²ÛŒØ±Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¯Ø± Ù‡Ø± Ù‚ÛŒÙ…Øª Ù†Ù‡Ø§ÛŒÛŒ',0),(464548,12905,'tr','Son parÃ§a kullanÄ±lan alt Ã¶ÄŸe miktarÄ±',0),(464549,12905,'pl','IloÅ›Ä‡ zapasu sub na koÅ„cowy fragment',0),(464550,12905,'bg','ÐŸÐ¾Ð´ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð°, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ Ð·Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð°Ñ‚Ð° Ñ‡Ð°ÑÑ‚',0),(464551,12905,'ur','Ø°ÛŒÙ„ÛŒ Ø´Û’ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± ÙÛŒ Ø¢Ø®Ø±ÛŒ Ù¹Ú©Ú‘Ø§ Ú©Ùˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§',0),(464552,12905,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¿Ð¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÐºÐ¾Ð½Ð°Ñ‡Ð½Ð¸ ÐºÐ¾Ð¼Ð°Ð´Ð½Ð°',0),(464553,12905,'vi','Sá»‘ lÆ°á»£ng tiá»ƒu má»¥c Ä‘Æ°á»£c sá»­ dá»¥ng trÃªn máº£nh cuá»‘i cÃ¹ng',0),(464554,12905,'af','Sub Item hoeveelheid gebruik Per finale stuk',0),(464555,12905,'ro','Sub cantitatea pentru fiecare piesa de Final',0),(464556,12905,'et','Sub kaubakoguse kohta lÃµplik tÃ¼kk',0),(464557,12905,'si','Sub koliÄino artikla na konÄni kos',0),(464558,12905,'ba','Sub Item kuantitas digunakan Per Final Piece',0),(464559,12905,'nl','Sub artikelaantal gebruikt Per laatste stuk',0),(464560,12905,'fi','Sub nimikkeen mÃ¤Ã¤rÃ¤ kohti viimeinen pala',0),(464561,12905,'no','Sub vareantallet brukes Per siste',0),(464562,12905,'da','Sub vareantallet anvendes pr. sidste brik',0),(464563,12905,'ko','í•˜ìœ„ í•­ëª© ìˆ˜ëŸ‰ ë§ˆì§€ë§‰ ì¡°ê° ë‹¹ ì‚¬ìš©',0),(464564,12905,'he','×›×ž×•×ª ×”×¤×¨×™×˜ sub ×‘×©×™×ž×•×© ×œ×›×œ ×”×—×œ×§ ×”××—×¨×•×Ÿ',0),(464565,12905,'el','Î¥Ï€Î¿ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± ÎµÎ¯Î´Î¿Ï…Ï‚ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ ÏƒÎµ ÎºÎ¬Î¸Îµ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(464566,12905,'zh','ä½¿ç”¨æ¯æœ€åŽä¸€å—çš„å­é¡¹ç›®æ•°é‡',0),(464567,12905,'sv','Sub objekt kvantitet som anvÃ¤nds Per sista pusselbiten',0),(464568,12905,'it','Sub articolo quantitÃ  utilizzata Per la parte finale',0),(464569,12905,'tl','',0),(464570,12905,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸ªà¸´à¸™à¸„à¹‰à¸²à¸¢à¹ˆà¸­à¸¢à¹ƒà¸Šà¹‰à¸•à¹ˆà¸­à¸Šà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(464571,12905,'hi','à¤‰à¤ª à¤†à¤‡à¤Ÿà¤® à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤…à¤‚à¤¤à¤¿à¤® à¤Ÿà¥à¤•à¤¡à¤¼à¤¾ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(464572,12905,'ms','Sub Item kuantiti yang digunakan setiap sekeping akhir',0),(464573,12905,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„ØµÙ†Ù Ø§Ù„ÙØ±Ø¹ÙŠØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…Ø© Ù„ÙƒÙ„ Ù‚Ø·Ø¹Ø© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ',0),(464574,12905,'fr','Void point quantitÃ© utilisÃ©e par piÃ¨ce finale',0),(464575,12905,'jp','ã‚µãƒ–é …ç›®ã®æ•°é‡ãŒæœ€å¾Œã®ãƒ”ãƒ¼ã‚¹ã”ã¨ã«ä½¿ç”¨ã•ã‚Œã¾ã™ã€‚',0),(464576,12905,'pt','Sub Item quantidade usada pela parte Final',0),(464577,12905,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Sub Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð·Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ ÐºÑƒÑÐ¾Ñ‡ÐµÐº',0),(464578,12905,'es','Cantidad de Sub Item Que Se Utiliza Por Pieza Final',0),(464579,12905,'de','Sub Artikelmenge pro letzte StÃ¼ck',0),(464580,12905,'en','Sub Item Quantity Used Per Final Piece',0),(464581,12906,'is','',0),(464582,12906,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ù„ÛŒØ³Øª Ù…ÙˆØ§Ø¯',0),(464583,12906,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ù„ÛŒØ³Øª Ù…ÙˆØ§Ø¯',0),(464584,12906,'tr','ÃœrÃ¼n ReÃ§etesi emir alma',0),(464585,12906,'pl','PrzywÃ³z BOM zamÃ³wienia',0),(464586,12906,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐšÐ˜ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(464587,12906,'ur','Ø¨Ø§Ù… Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(464588,12906,'sr','Ð£Ð²Ð¾Ð· Ð½Ð°Ð»Ð¾Ð³Ð° Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ð°',0),(464589,12906,'vi','Nháº­p cÃ¡c Ä‘Æ¡n hÃ ng BOM',0),(464590,12906,'af','BOM bestellings voer',0),(464591,12906,'ro','Importa ordinele de LM',0),(464592,12906,'et','Impordi Koosluse tellimused',0),(464593,12906,'si','Uvoz Kosovnica naroÄila',0),(464594,12906,'ba','Impor BOM pesanan',0),(464595,12906,'nl','BOM Orders importeren',0),(464596,12906,'fi','Tuo Tuoterakenteen tilaukset',0),(464597,12906,'no','Importere Stykkliste ordrer',0),(464598,12906,'da','Importerer Styklisten ordrer',0),(464599,12906,'ko','ê°€ì ¸ì˜¤ê¸° BOM ì£¼ë¬¸',0),(464600,12906,'he','×™×™×‘×•× BOM ×”×–×ž× ×•×ª',0),(464601,12906,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï„ÎµÏ‡Î½Î¹ÎºÏŽÎ½ Ï€ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†ÏŽÎ½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(464602,12906,'zh','è®¢å•å¯¼å…¥ç‰©æ–™æ¸…å•',0),(464603,12906,'sv','Importera BOM order',0),(464604,12906,'it','Importazione ordini BOM',0),(464605,12906,'tl','',0),(464606,12906,'th','BOM à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(464607,12906,'hi','BOM à¤†à¤¦à¥‡à¤¶ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(464608,12906,'ms','Perintah-perintah BOM import',0),(464609,12906,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø´Ø¬Ø±Ø© Ø£ÙˆØ§Ù…Ø±',0),(464610,12906,'fr','Importer des ordres BOM',0),(464611,12906,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆéƒ¨å“è¡¨ã®é †åº',0),(464612,12906,'pt','BOM ordens de importaÃ§Ã£o',0),(464613,12906,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(464614,12906,'es','Importar Pedidos de BOM',0),(464615,12906,'de','Import-BOM-Bestellungen',0),(464616,12906,'en','Import BOM Orders',0),(464617,12907,'is','',0),(464618,12907,'dr','(Ø§ÛŒØ¬Ø§Ø¯',0),(464619,12907,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ØµÙ„ÛŒ Ø¨Ø±Ø§ÛŒ Ø³Ø§Ø®ØªÙ†(Ø§ÛŒØ¬Ø§Ø¯',0),(464620,12907,'tr','Master miktar To Make',0),(464621,12907,'pl','IloÅ›Ä‡ Master zrobiÄ‡',0),(464622,12907,'bg','ÐœÐ°Ð³Ð¸ÑÑ‚ÑŠÑ€ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, Ð·Ð° Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸',0),(464623,12907,'ur','Ù…Ø§Ø³Ù¹Ø± Ù…Ù‚Ø¯Ø§Ø± Ú©Ùˆ',0),(464624,12907,'sr','Ð“Ð¾ÑÐ¿Ð¾Ð´Ð°Ñ€ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ',0),(464625,12907,'vi','lÆ°á»£ng hÃ ng chá»§ Ä‘á»ƒ lÃ m',0),(464626,12907,'af','Meester hoeveelheid te maak',0),(464627,12907,'ro','Cantitatea de Master pentru a face',0),(464628,12907,'et','Kapten kogus margi',0),(464629,12907,'si','Master koliÄina narediti',0),(464630,12907,'ba','Master kuantitas membuat',0),(464631,12907,'nl','Master te maken aantal',0),(464632,12907,'fi','Master mÃ¤Ã¤rÃ¤ saada',0),(464633,12907,'no','Master antall gjÃ¸re',0),(464634,12907,'da','Master mÃ¦ngde til at gÃ¸re',0),(464635,12907,'ko','ë§ˆìŠ¤í„° ìˆ˜ëŸ‰ í™•ì¸ì„',0),(464636,12907,'he','×ž××¡×˜×¨ ×›×ž×•×ª ×›×“×™ ×œ×”×¤×•×š',0),(464637,12907,'el','Master Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î½Î± ÎºÎ¬Î½Î¿Ï…Î½',0),(464638,12907,'zh','ä½¿ä¸»æœºæ•°é‡',0),(464639,12907,'sv','Master antal att gÃ¶ra',0),(464640,12907,'it','QuantitÃ  di Master da fare',0),(464641,12907,'tl','',0),(464642,12907,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸«à¸¥à¸±à¸à¸à¸²à¸£à¸—à¸³',0),(464643,12907,'hi','à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¬à¤¨à¤¾à¤à¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(464644,12907,'ms','Bahan utama untuk membuat',0),(464645,12907,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ù„Ø¬Ø¹Ù„',0),(464646,12907,'fr','QuantitÃ© de maÃ®tre Ã  faire',0),(464647,12907,'jp','ç¢ºèªã™ã‚‹ãƒžã‚¹ã‚¿ãƒ¼é‡',0),(464648,12907,'pt','Quantidade de mestre para fazer',0),(464649,12907,'ru','ÐœÐ°ÑÑ‚ÐµÑ€ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ',0),(464650,12907,'es','Cantidad Maestro Para Hacer',0),(464651,12907,'de','Master-Menge zu machen',0),(464652,12907,'en','Master Quantity To Make',0),(464653,12908,'is','',0),(464654,12908,'dr','(Ø¬Ù†Ø³) Ø²ÛŒØ± Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù‚Ø±Ø§Ø± Ú¯ÛŒØ±Ø¯',0),(464655,12908,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ±Ø¯(Ú©Ø§Ù„Ø§) Ø²ÛŒØ± Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù‚Ø±Ø§Ø± Ú¯ÛŒØ±Ø¯',0),(464656,12908,'tr','KullanÄ±lacak alt Ã¶ÄŸe miktarÄ±',0),(464657,12908,'pl','Sub element iloÅ›Ä‡ do wykorzystania',0),(464658,12908,'bg','ÐŸÐ¾Ð´ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°',0),(464659,12908,'ur','Ø°ÛŒÙ„ÛŒ Ø´Û’ Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(464660,12908,'sr','ÐŸÐ¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° ÐºÐ¾Ñ˜Ð¸ Ñ›Ðµ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸',0),(464661,12908,'vi','Sá»‘ lÆ°á»£ng tiá»ƒu má»¥c Ä‘Æ°á»£c sá»­ dá»¥ng',0),(464662,12908,'af','Sub-Item hoeveelheid gebruik word',0),(464663,12908,'ro','Sub cantitatea pentru a fi utilizate',0),(464664,12908,'et','Sub kasutatav kauba kogus',0),(464665,12908,'si','Uporabljena sub artikla koliÄina',0),(464666,12908,'ba','Sub jumlah Item untuk digunakan',0),(464667,12908,'nl','Sub artikelaantal om te worden gebruikt',0),(464668,12908,'fi','Sub nimikkeen mÃ¤Ã¤rÃ¤ kÃ¤ytetÃ¤Ã¤n',0),(464669,12908,'no','Sub vareantall som skal brukes',0),(464670,12908,'da','Sub vareantallet skal bruges',0),(464671,12908,'ko','ì‚¬ìš©í•  í•˜ìœ„ í•­ëª© ìˆ˜ëŸ‰',0),(464672,12908,'he','×¡××‘ ×›×ž×•×ª ×”×¤×¨×™×˜ ×›×“×™ ×œ×©×ž×©',0),(464673,12908,'el','Î¥Ï€Î¿-ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ¼ÎµÎ½Î·',0),(464674,12908,'zh','å­é¡¹ç›®ä½¿ç”¨çš„æ•°é‡',0),(464675,12908,'sv','Sub artikelkvantiteten ska anvÃ¤ndas',0),(464676,12908,'it','Sub articolo quantitÃ  da utilizzare',0),(464677,12908,'tl','',0),(464678,12908,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸ªà¸´à¸™à¸„à¹‰à¸²à¸¢à¹ˆà¸­à¸¢à¸—à¸µà¹ˆà¸ˆà¸°à¹ƒà¸Šà¹‰',0),(464679,12908,'hi','à¤‰à¤ª à¤†à¤‡à¤Ÿà¤® à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(464680,12908,'ms','Kuantiti Item sub untuk digunakan',0),(464681,12908,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„ØµÙ†Ù Ø§Ù„ÙØ±Ø¹ÙŠ Ø§Ø³ØªØ®Ø¯Ø§Ù…Ù‡Ø§',0),(464682,12908,'fr','Void quantitÃ© d\'articles Ã  utiliser',0),(464683,12908,'jp','ã‚µãƒ–é …ç›®ã®äºˆå®šä½¿ç”¨é‡',0),(464684,12908,'pt','Sub Item quantidade a ser usada',0),(464685,12908,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Sub Ð´Ð»Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(464686,12908,'es','Cantidad de Sub Item Que Se Utiliza',0),(464687,12908,'de','Unterpunkt Menge verwendet werden',0),(464688,12908,'en','Sub Item Quantity To Be Used',0),(464689,12909,'is','',0),(464690,12909,'dr','Ù†Ù…Ø§ÛŒØ´ Ø®Ù„Ø§ØµÙ‡',0),(464691,12909,'pr','Ù†Ù…Ø§ÛŒØ´ Ø®Ù„Ø§ØµÙ‡',0),(464692,12909,'tr','Ã–zetini gÃ¶rÃ¼ntÃ¼le',0),(464693,12909,'pl','WyÅ›wietl podsumowanie',0),(464694,12909,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(464695,12909,'ur','Ø®Ù„Ø§ØµÛ Ú©Ø§ Ù…Ù†Ø¸Ø± Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(464696,12909,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ€ÐµÐ·Ð¸Ð¼ÐµÐ°',0),(464697,12909,'vi','Xem tÃ³m táº¯t',0),(464698,12909,'af','Bekyk opsomming',0),(464699,12909,'ro','Vezi Rezumat',0),(464700,12909,'et','Kuva KokkuvÃµte',0),(464701,12909,'si','Pogled Povzetek',0),(464702,12909,'ba','Lihat ringkasan',0),(464703,12909,'nl','Weergave Samenvatting',0),(464704,12909,'fi','NÃ¤ytÃ¤ Yhteenveto',0),(464705,12909,'no','Vis Sammendrag',0),(464706,12909,'da','Se oversigt',0),(464707,12909,'ko','ìš”ì•½ ë³´ê¸°',0),(464708,12909,'he','×”×¦×’×ª ×¡×™×›×•×',0),(464709,12909,'el','Î ÏÎ¿Î²Î¿Î»Î® Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(464710,12909,'zh','æŸ¥çœ‹æ‘˜è¦',0),(464711,12909,'sv','Visa Sammanfattning',0),(464712,12909,'it','Visualizzazione Riepilogo',0),(464713,12909,'tl','',0),(464714,12909,'th','à¸¡à¸¸à¸¡à¸¡à¸­à¸‡à¸ªà¸£à¸¸à¸›',0),(464715,12909,'hi','à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¦à¥‡à¤–à¥‡à¤‚',0),(464716,12909,'ms','Paparan ringkasan',0),(464717,12909,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ù„Ø®Øµ',0),(464718,12909,'fr','Afficher le rÃ©sumÃ©',0),(464719,12909,'jp','ãƒ“ãƒ¥ãƒ¼ã®æ¦‚è¦',0),(464720,12909,'pt','Modo de exibiÃ§Ã£o Resumo',0),(464721,12909,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(464722,12909,'es','Vistar Sumario',0),(464723,12909,'de','Zusammenfassung anzeigen',0),(464724,12909,'en','View Summary',0),(464725,12910,'is','',0),(464726,12910,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯Ø¨Ù‡ ØµÙˆØ±Øª Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ú©Ù†ÛŒØ¯ØŸ',0),(464727,12910,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯Ø¨Ù‡ ØµÙˆØ±Øª Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ú©Ù†ÛŒØ¯ØŸ',0),(464728,12910,'tr','Elektronik olarak dosyalamak istiyor musunuz?',0),(464729,12910,'pl','Czy na pewno chcesz zÅ‚oÅ¼yÄ‡ drogÄ… elektronicznÄ…?',0),(464730,12910,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° ÑÐµ Ð¿Ð¾Ð´Ð°Ð´Ðµ Ð¿Ð¾ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÐµÐ½ Ð¿ÑŠÑ‚?',0),(464731,12910,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ù„ÛŒÚ©Ù¹Ø±Ø§Ù†Ú© ÙØ§Ø¦Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(464732,12910,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÑÐºÐ¸Ð¼ Ð¿ÑƒÑ‚ÐµÐ¼?',0),(464733,12910,'vi','ná»™p Ä‘Æ¡n Ä‘iá»‡n tá»­?',0),(464734,12910,'af','Is jy seker jy wil die lÃªer elektronies?',0),(464735,12910,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ fiÅŸier electronic?',0),(464736,12910,'et','Kas kindlasti elektrooniliselt?',0),(464737,12910,'si','Ali ste prepriÄani, da Å¾elite vloÅ¾iti elektronsko?',0),(464738,12910,'ba','Apakah Anda yakin Anda ingin file elektronik?',0),(464739,12910,'nl','Weet u zeker dat u wilt elektronisch bestand?',0),(464740,12910,'fi','Oletko varma, ettÃ¤ haluat tiedoston sÃ¤hkÃ¶isesti?',0),(464741,12910,'no','Er du sikker pÃ¥ at du vil sende elektronisk?',0),(464742,12910,'da','Er du sikker pÃ¥ du vil fil elektronisk?',0),(464743,12910,'ko','ë‹¹ì‹ ì€ ì „ìž íŒŒì¼ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(464744,12910,'he','? ××ª×” ×‘×˜×•×— ×©××ª×” ×¨×•×¦×”? ×œ×”×’×™×© ×‘××•×¤×Ÿ ××œ×§×˜×¨×•× ×™',0),(464745,12910,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Ï…Ï€Î¿Î²Î¬Î»ÎµÏ„Îµ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¬;',0),(464746,12910,'zh','ä½ ç¡®å®šä½ æƒ³è¦æ–‡ä»¶ä»¥ç”µå­æ–¹å¼ï¼Ÿ',0),(464747,12910,'sv','Ã„r du sÃ¤ker du vill fil elektroniskt?',0),(464748,12910,'it','Sei sicuro di che voler file elettronicamente?',0),(464749,12910,'tl','',0),(464750,12910,'th','à¸„à¸¸à¸“à¹à¸™à¹ˆà¹ƒà¸ˆà¸„à¸¸à¸“à¸¢à¸·à¹ˆà¸™à¸—à¸²à¸‡à¸­à¸´à¹€à¸¥à¹‡à¸à¸—à¸£à¸­à¸™à¸´à¸à¸ªà¹Œà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(464751,12910,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤²à¥‡à¤•à¥à¤Ÿà¥à¤°à¥‰à¤¨à¤¿à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(464752,12910,'ms','Adakah anda pasti yang anda ingin fail secara elektronik?',0),(464753,12910,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø§Ù„Ù…Ù„Ù Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠØ§ØŸ',0),(464754,12910,'fr','ÃŠtes-vous certain de que vouloir produire par voie Ã©lectronique ?',0),(464755,12910,'jp','é›»å­çš„ã«æå‡ºã™ã‚‹ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(464756,12910,'pt','Tem certeza que quer apresentar eletronicamente?',0),(464757,12910,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÑŒ Ð² ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¼ Ð²Ð¸Ð´Ðµ?',0),(464758,12910,'es','Â¿Esta seguro que quiere presentar electronicament?',0),(464759,12910,'de','Bist du sicher, dass Sie elektronisch einreichen mÃ¶chten?',0),(464760,12910,'en','Are you sure you want to file electronically?',0),(464761,12911,'is','',0),(464762,12911,'dr','.... Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(464763,12911,'pr','Ø¨Ø±Ø±Ø³ÛŒ ÙˆØ¶Ø¹ÛŒØª .... Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(464764,12911,'tr','Elektronik dosyalama durumunu denetleme',0),(464765,12911,'pl','SprawdÅº stan zgÅ‚oszenia elektroniczne',0),(464766,12911,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ñ‚Ð¾ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ',0),(464767,12911,'ur','Ø§Ù„ÛŒÚ©Ù¹Ø±Ø§Ù†Ú© Ø¨ØªØ§Ø¦ÛŒÚº Ø­Ø§Ù„Øª Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(464768,12911,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÑÐºÐ¾ Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ',0),(464769,12911,'vi','TÃ¬nh tráº¡ng lÆ°u trá»¯ sÃ©c Ä‘iá»‡n tá»­',0),(464770,12911,'af','Kontroleer elektroniese indiening Status',0),(464771,12911,'ro','VerificaÅ£i starea electronice de depunere',0),(464772,12911,'et','Elektroonilise esitamise oleku kontrollimine',0),(464773,12911,'si','Preverite stanje elektronsko arhiviranje',0),(464774,12911,'ba','Memeriksa Status pengajuan elektronik',0),(464775,12911,'nl','Elektronische neerlegging Status controleren',0),(464776,12911,'fi','SÃ¤hkÃ¶inen arkistointi tilan tarkistaminen',0),(464777,12911,'no','Kontrollere statusen for elektronisk arkivering',0),(464778,12911,'da','Kontrollere Status for elektronisk arkivering',0),(464779,12911,'ko','ì „ìž ì‹ ì²­ ìƒíƒœ í™•ì¸',0),(464780,12911,'he','×‘×“×™×§×ª ×ž×¦×‘ ×ª×™×•×§ ××œ×§×˜×¨×•× ×™×ª',0),(464781,12911,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ® Î±ÏÏ‡ÎµÎ¹Î¿Î¸Î­Ï„Î·ÏƒÎ·',0),(464782,12911,'zh','æ£€æŸ¥ç”µå­æŠ¥ç¨ŽçŠ¶æ€',0),(464783,12911,'sv','Kontrollera Status fÃ¶r elektronisk arkivering',0),(464784,12911,'it','Verificare lo stato di deposito elettronico',0),(464785,12911,'tl','',0),(464786,12911,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸ˆà¸±à¸”à¹€à¸à¹‡à¸šà¹à¸Ÿà¹‰à¸¡à¸­à¸´à¹€à¸¥à¹‡à¸à¸—à¸£à¸­à¸™à¸´à¸à¸ªà¹Œ',0),(464787,12911,'hi','à¤‡à¤²à¥‡à¤•à¥à¤Ÿà¥à¤°à¥‰à¤¨à¤¿à¤• à¤«à¤¾à¤‡à¤²à¤¿à¤‚à¤— à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(464788,12911,'ms','Semak Status pemfailan elektronik',0),(464789,12911,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø­Ø§Ù„Ø© Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(464790,12911,'fr','VÃ©rifier l\'Ã©tat de dÃ©pÃ´t Ã©lectronique',0),(464791,12911,'jp','é›»å­ãƒ•ã‚¡ã‚¤ãƒªãƒ³ã‚°çŠ¶æ…‹ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(464792,12911,'pt','Verificar Status de arquivamento eletrÃ´nico',0),(464793,12911,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ð´Ð°Ñ‡Ð¸',0),(464794,12911,'es','Checar Estatus (Filing Status)Electronico',0),(464795,12911,'de','Elektronische Einreichung Status Ã¼berprÃ¼fen',0),(464796,12911,'en','Check Electronic Filing Status',0),(464797,12912,'is','',0),(464798,12912,'dr','ÙØ§ÛŒÙ„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(464799,12912,'pr','ÙØ§ÛŒÙ„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(464800,12912,'tr','Elektronik dosya',0),(464801,12912,'pl','Plik elektronicznie',0),(464802,12912,'bg','ÐŸÐ¾ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÐµÐ½ Ð¿ÑŠÑ‚ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(464803,12912,'ur','Ø§Ù„ÛŒÚ©Ù¹Ø±Ø§Ù†Ú© ÙØ§Ø¦Ù„',0),(464804,12912,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÑÐºÐ¸Ð¼ Ð¿ÑƒÑ‚ÐµÐ¼',0),(464805,12912,'vi','há»“ sÆ¡ Ä‘iá»‡n tá»­',0),(464806,12912,'af','LÃªer elektronies',0),(464807,12912,'ro','Dosar electronic',0),(464808,12912,'et','Elektrooniliselt',0),(464809,12912,'si','Elektronsko datoteko',0),(464810,12912,'ba','File elektronik',0),(464811,12912,'nl','Elektronisch bestand',0),(464812,12912,'fi','Tiedoston sÃ¤hkÃ¶isesti',0),(464813,12912,'no','Filen elektronisk',0),(464814,12912,'da','Fil elektronisk',0),(464815,12912,'ko','ì „ìž íŒŒì¼',0),(464816,12912,'he','×§×•×‘×¥ ××œ×§×˜×¨×•× ×™×ª',0),(464817,12912,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¬',0),(464818,12912,'zh','ç”µå­æ–‡ä»¶',0),(464819,12912,'sv','Fil elektroniskt',0),(464820,12912,'it','File elettronicamente',0),(464821,12912,'tl','',0),(464822,12912,'th','à¸¢à¸·à¹ˆà¸™à¸—à¸²à¸‡à¸­à¸´à¹€à¸¥à¹‡à¸à¸—à¸£à¸­à¸™à¸´à¸à¸ªà¹Œ',0),(464823,12912,'hi','à¤‡à¤²à¥‡à¤•à¥à¤Ÿà¥à¤°à¥‰à¤¨à¤¿à¤• à¤«à¤¼à¤¾à¤‡à¤²',0),(464824,12912,'ms','Fail secara elektronik',0),(464825,12912,'ar','Ø§Ù„Ù…Ù„Ù Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠØ§',0),(464826,12912,'fr','DÃ©pÃ´t Ã©lectronique',0),(464827,12912,'jp','é›»å­çš„ã«æå‡ºã—ã¾ã™ã€‚',0),(464828,12912,'pt','Arquivo eletronicamente',0),(464829,12912,'ru','Ð¤Ð°Ð¹Ð»Ð° Ð² ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¼ Ð²Ð¸Ð´Ðµ',0),(464830,12912,'es','Presentar Electronicamente',0),(464831,12912,'de','Datei elektronisch',0),(464832,12912,'en','File Electronically',0),(464833,12913,'is','',0),(464834,12913,'dr','ÛŒÚ© Ø®Ø·Ø§ Ø±Ø® Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª',0),(464835,12913,'pr','ÛŒÚ© Ø®Ø·Ø§ Ø±Ø® Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª',0),(464836,12913,'tr','Bir hata oluÅŸtu',0),(464837,12913,'pl','WystÄ…piÅ‚ bÅ‚Ä…d',0),(464838,12913,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð° Ð³Ñ€ÐµÑˆÐºÐ°',0),(464839,12913,'ur','Ø§ÛŒÚ© Ù†Ù‚Øµ ÛÙˆ Ú¯ÛŒØ§',0),(464840,12913,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð³Ñ€ÐµÑˆÐºÐµ',0),(464841,12913,'vi','Lá»—i Ä‘Ã£ Ä‘Æ°á»£c hiá»‡n ra',0),(464842,12913,'af','\'N Fout het voorgekom',0),(464843,12913,'ro','A apÄƒrut o eroare',0),(464844,12913,'et','Ilmnes tÃµrge',0),(464845,12913,'si','PriÅ¡lo je do napake',0),(464846,12913,'ba','Sebuah kesalahan telah terjadi',0),(464847,12913,'nl','Een fout er is opgetreden',0),(464848,12913,'fi','Virhe',0),(464849,12913,'no','Feil ved',0),(464850,12913,'da','Der er opstÃ¥et en fejl',0),(464851,12913,'ko','ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(464852,12913,'he','××™×¨×¢×” ×©×’×™××”',0),(464853,12913,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î±',0),(464854,12913,'zh','å‡ºçŽ°äº†ä¸€ä¸ªé”™è¯¯',0),(464855,12913,'sv','Ett fel har uppstÃ¥tt',0),(464856,12913,'it','Si Ã¨ verificato un errore',0),(464857,12913,'tl','',0),(464858,12913,'th','à¹€à¸à¸´à¸”à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(464859,12913,'hi','à¤•à¥‹à¤ˆ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤¹à¥à¤ˆ',0),(464860,12913,'ms','Satu ralat telah berlaku',0),(464861,12913,'ar','Ù„Ù‚Ø¯ Ø­Ø¯Ø« Ø®Ø·Ø£',0),(464862,12913,'fr','Une erreur est survenue',0),(464863,12913,'jp','ã‚¨ãƒ©ãƒ¼ãŒç™ºç”Ÿã—ã¾ã—ãŸ',0),(464864,12913,'pt','Ocorreu um erro',0),(464865,12913,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð° Ð¾ÑˆÐ¸Ð±ÐºÐ°',0),(464866,12913,'es','Se OccuriÃ³ un Error',0),(464867,12913,'de','Ein Fehler ist aufgetreten',0),(464868,12913,'en','An Error Has Occurred',0),(464869,12914,'is','',0),(464870,12914,'dr','Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø¯Ø± Ø§ÛŒÙ† Ø²Ù…Ø§Ù† Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(464871,12914,'pr','Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø¯Ø± Ø§ÛŒÙ† Ø²Ù…Ø§Ù† Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(464872,12914,'tr','Elektronik dosyalama ÅŸu anda kullanÄ±labilir deÄŸil',0),(464873,12914,'pl','Elektroniczne zgÅ‚oszenia nie sÄ… dostÄ™pne w tej chwili',0),(464874,12914,'bg','Ð•Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¸ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ, Ð½Ðµ ÑÐ° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸ Ð¿Ð¾ Ñ‚Ð¾Ð²Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(464875,12914,'ur','Ø§Ù„ÛŒÚ©Ù¹Ø±Ø§Ù†Ú© Ø¨ØªØ§Ø¦ÛŒÚº Ø§Ø³ ÙˆÙ‚Øª Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº ÛÛ’',0),(464876,12914,'sr','Ð•Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½ÑÐºÐ¾ Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ Ñƒ Ð¾Ð²Ð¾Ð¼ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚ÐºÑƒ',0),(464877,12914,'vi','khÃ´ng thá»ƒ Ä‘iá»n tá»± Ä‘á»™ng  vÃ o lÃºc nÃ y',0),(464878,12914,'af','Elektroniese indiening by hierdie tyd nie beskikbaar',0),(464879,12914,'ro','Depozit electronice nu sunt disponibile Ã®n acest moment',0),(464880,12914,'et','Elektroonilise esitamise hetkel pole saadaval',0),(464881,12914,'si','Elektronsko arhiviranje ni na voljo v tem trenutku',0),(464882,12914,'ba','Pengajuan elektronik tidak tersedia saat ini',0),(464883,12914,'nl','Elektronische neerlegging niet beschikbaar op dit moment',0),(464884,12914,'fi','SÃ¤hkÃ¶inen arkistointi ei ole kÃ¤ytettÃ¤vissÃ¤ tÃ¤llÃ¤ hetkellÃ¤',0),(464885,12914,'no','Elektronisk arkivering ikke tilgjengelig for Ã¸yeblikket',0),(464886,12914,'da','Elektronisk arkivering ikke tilgÃ¦ngelig pÃ¥ dette tidspunkt',0),(464887,12914,'ko','ì´ ì‹œê°„ì— ì‚¬ìš©í•  ìˆ˜ ì—†ëŠ” ì „ìž ì‹ ê³ ',0),(464888,12914,'he','×ª×™×•×§ ××œ×§×˜×¨×•× ×™×ª ×œ× ×–×ž×™×Ÿ ×›×¨×’×¢',0),(464889,12914,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ® Î±ÏÏ‡ÎµÎ¹Î¿Î¸Î­Ï„Î·ÏƒÎ· Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Î±Ï…Ï„Î® Ï„Î· ÏƒÏ„Î¹Î³Î¼Î®',0),(464890,12914,'zh','æ­¤æ—¶æ²¡æœ‰å¯ä¾›é€‰æ‹©çš„ç”µå­æŠ¥ç¨Ž',0),(464891,12914,'sv','Elektronisk arkivering inte tillgÃ¤nglig vid denna tid',0),(464892,12914,'it','Deposito elettronico non disponibile in questo momento',0),(464893,12914,'tl','',0),(464894,12914,'th','à¸­à¸´à¹€à¸¥à¹‡à¸à¸—à¸£à¸­à¸™à¸´à¸à¸ªà¹Œà¸¢à¸·à¹ˆà¸™à¹„à¸¡à¹ˆà¸§à¹ˆà¸²à¸‡à¹ƒà¸™à¸‚à¸“à¸°à¸™à¸µà¹‰',0),(464895,12914,'hi','à¤‡à¤²à¥‡à¤•à¥à¤Ÿà¥à¤°à¥‰à¤¨à¤¿à¤• à¤«à¤¾à¤‡à¤²à¤¿à¤‚à¤— à¤®à¥‡à¤‚ à¤‡à¤¸ à¤¸à¤®à¤¯ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(464896,12914,'ms','Pemfailan elektronik tidak tersedia buat masa ini',0),(464897,12914,'ar','Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ ØºÙŠØ± Ù…ØªÙˆÙØ±Ø© ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„ÙˆÙ‚Øª',0),(464898,12914,'fr','DÃ©pÃ´t Ã©lectronique non disponible en ce moment',0),(464899,12914,'jp','ã“ã®æ™‚ç‚¹ã§ã¯åˆ©ç”¨ã§ããªã„é›»å­ãƒ•ã‚¡ã‚¤ãƒªãƒ³ã‚°',0),(464900,12914,'pt','Arquivamento eletrÃ´nico nÃ£o estÃ¡ disponÃ­vel neste momento',0),(464901,12914,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð°Ñ Ð¿Ð¾Ð´Ð°Ñ‡Ð° Ð·Ð°ÑÐ²Ð¾Ðº Ð² Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð½Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð°',0),(464902,12914,'es','PresentaciÃ³n Electronica No EstÃ¡ Disponible en Este Momento',0),(464903,12914,'de','Elektronische Anmeldung zur Zeit nicht verfÃ¼gbar',0),(464904,12914,'en','Electronic Filing Not Available At This Time',0),(464905,12915,'is','',0),(464906,12915,'dr','W-2Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(464907,12915,'pr',' ÙØ§ÛŒÙ„ W-2Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(464908,12915,'tr','W-2 elektronik dosya',0),(464909,12915,'pl','DrogÄ… elektronicznÄ… plik W-2',0),(464910,12915,'bg','ÐŸÐ¾ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÐµÐ½ Ð¿ÑŠÑ‚ Ð½Ð° Ñ„Ð°Ð¹Ð» W-2',0),(464911,12915,'ur','W-2 Ø§Ù„ÛŒÚ©Ù¹Ø±Ø§Ù†Ú© ÙØ§Ø¦Ù„',0),(464912,12915,'sr','Ð•Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½ÑÐºÐ¸Ð¼ Ð¿ÑƒÑ‚ÐµÐ¼ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ W-2',0),(464913,12915,'vi','File Ä‘iá»‡n tá»­ W-2',0),(464914,12915,'af','LÃªer W-2 elektronies',0),(464915,12915,'ro','FiÅŸier W-2 electronic',0),(464916,12915,'et','Faili W-2 elektrooniliselt',0),(464917,12915,'si','Elektronsko datoteko W-2',0),(464918,12915,'ba','File W-2 elektronik',0),(464919,12915,'nl','Bestand W-2 elektronisch',0),(464920,12915,'fi','Tiedoston W-2 sÃ¤hkÃ¶isesti',0),(464921,12915,'no','Filen W-2 elektronisk',0),(464922,12915,'da','Fil W-2 elektronisk',0),(464923,12915,'ko','W-2ë¥¼ ì „ìž íŒŒì¼',0),(464924,12915,'he','×§×•×‘×¥ W-2 ×‘××•×¤×Ÿ ××œ×§×˜×¨×•× ×™',0),(464925,12915,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ W-2 Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¬',0),(464926,12915,'zh','ç”µå­æ–‡ä»¶ W 2',0),(464927,12915,'sv','Fil W-2 elektroniskt',0),(464928,12915,'it','W-2 del file elettronicamente',0),(464929,12915,'tl','',0),(464930,12915,'th','à¹à¸Ÿà¹‰à¸¡ W 2 à¸­à¸´à¹€à¸¥à¹‡à¸à¸—à¸£à¸­à¸™à¸´à¸à¸ªà¹Œ',0),(464931,12915,'hi','W-2 à¤‡à¤²à¥‡à¤•à¥à¤Ÿà¥à¤°à¥‰à¤¨à¤¿à¤• à¤«à¤¼à¤¾à¤‡à¤²',0),(464932,12915,'ms','Fail W-2 secara elektronik',0),(464933,12915,'ar','Ù…Ù„Ù 2 Ø« Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠØ§',0),(464934,12915,'fr','Par voie Ã©lectronique le fichier W-2',0),(464935,12915,'jp','W 2 ã®é›»å­ãƒ•ã‚¡ã‚¤ãƒ«ã—ã¾ã™ã€‚',0),(464936,12915,'pt','Eletronicamente o arquivo W-2',0),(464937,12915,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¼ Ð²Ð¸Ð´Ðµ Ñ„Ð°Ð¹Ð»Ð° W-2',0),(464938,12915,'es','Presenta el W-2 Electronicamente',0),(464939,12915,'de','W-2 elektronisch Datei',0),(464940,12915,'en','File W-2 Electronically',0),(464941,12916,'is','',0),(464942,12916,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† ÙˆÛŒÚ˜Ú¯ÛŒ ÙØ±Ù…Øª Ø²ÛŒØ± Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯\r\n  PHP SOAP',0),(464943,12916,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† ÙˆÛŒÚ˜Ú¯ÛŒ ÙØ±Ù…Øª Ø²ÛŒØ± Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯\r\n  PHP SOAP',0),(464944,12916,'tr','Bu Ã¶zelliÄŸi kullanmak iÃ§in PHP SOAP uzantÄ±sÄ± olmalÄ±dÄ±r.',0),(464945,12916,'pl','Musi mieÄ‡ rozszerzenie PHP SOAP, aby uÅ¼yÄ‡ tej funkcji.',0),(464946,12916,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð°Ñ‚ Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¸Ðµ Ð½Ð° PHP ÑÐ°Ð¿ÑƒÐ½ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ.',0),(464947,12916,'ur','Ø¢Ù¾ Ú©Ùˆ ÛŒÛ ÙÛŒÚ†Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù¾ÛŒ Ø§ÛŒÚ† Ù¾ÛŒ ØµØ§Ø¨Ù† ØªÙˆØ³ÛŒØ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ Û”',0),(464948,12916,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð¾Ð·Ð½Ð°ÐºÑƒ \"ÐŸÐ¥ÐŸ ÑÐ°Ð¿ÑƒÐ½\" Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ð»Ð¸ Ð¾Ð²Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ.',0),(464949,12916,'vi','Báº¡n pháº£i cÃ³ pháº§n má»Ÿ rá»™ng SOAP PHP Ä‘á»ƒ sá»­ dá»¥ng tÃ­nh nÄƒng nÃ y',0),(464950,12916,'af','Jy moet die PHP seep uitbreiding om hierdie kenmerk te gebruik het.',0),(464951,12916,'ro','Trebuie sÄƒ aveÅ£i extensia de PHP sapun pentru a utiliza aceastÄƒ caracteristicÄƒ.',0),(464952,12916,'et','PHP SOAP pikendamine selle funktsiooni kasutamiseks peab teil olema.',0),(464953,12916,'si','PHP SOAP podaljÅ¡anje za uporabo te funkcije morate imeti.',0),(464954,12916,'ba','Anda harus memiliki ekstensi PHP sabun untuk menggunakan fitur ini.',0),(464955,12916,'nl','U moet de PHP SOAP-extensie om deze functie te gebruiken.',0),(464956,12916,'fi','Tarvitset tÃ¤tÃ¤ toimintoa PHP SOAP laajentaminen.',0),(464957,12916,'no','Du mÃ¥ ha PHP sÃ¥pe forlengelsen Ã¥ bruke denne funksjonen.',0),(464958,12916,'da','Du skal have PHP SOAP udvidelse til at bruge denne funktion.',0),(464959,12916,'ko','ì´ ê¸°ëŠ¥ì„ ì‚¬ìš© í•˜ë ¤ë©´ PHP SOAP í™•ìž¥ì´ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(464960,12916,'he','×™×© ××ª ×”×¡×™×•×ž×ª PHP ×¡×‘×•×Ÿ ×›×“×™ ×œ×”×©×ª×ž×© ×‘×ª×›×•× ×” ×–×•.',0),(464961,12916,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Ï„Î·Î½ ÎµÏ€Î­ÎºÏ„Î±ÏƒÎ· PHP Î£Î‘Î ÎŸÎŽÎÎ™ Î³Î¹Î± Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î· Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„Î±.',0),(464962,12916,'zh','ä½ å¿…é¡»è¦ä½¿ç”¨æ­¤åŠŸèƒ½çš„ PHP SOAP æ‰©å±•ã€‚',0),(464963,12916,'sv','Du mÃ¥ste ha PHP SOAP-tillÃ¤gget till den hÃ¤r funktionen.',0),(464964,12916,'it','Deve avere l\'estensione SOAP PHP per utilizzare questa funzionalitÃ .',0),(464965,12916,'tl','',0),(464966,12916,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸™à¸²à¸¡à¸ªà¸à¸¸à¸¥ PHP à¸ªà¸šà¸¹à¹ˆà¹ƒà¸Šà¹‰à¸„à¸¸à¸“à¸¥à¸±à¸à¸©à¸“à¸°à¸™à¸µà¹‰',0),(464967,12916,'hi','à¤†à¤ª à¤‡à¤¸ à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ PHP à¤¸à¤¾à¤¬à¥à¤¨ à¤à¤•à¥à¤¸à¤Ÿà¥‡à¤‚à¤¶à¤¨ à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(464968,12916,'ms','Anda mesti mempunyai sambungan PHP SABUN untuk menggunakan ciri ini.',0),(464969,12916,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù…Ù„Ø­Ù‚ \"Ø¨ÙŠ Ø§Ù„ØµØ§Ø¨ÙˆÙ†\" Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù‡Ø°Ù‡ Ø§Ù„Ù…ÙŠØ²Ø©.',0),(464970,12916,'fr','Vous devez avoir l\'extension PHP SOAP Ã  utiliser cette fonctionnalitÃ©.',0),(464971,12916,'jp','ã“ã®æ©Ÿèƒ½ã‚’ä½¿ç”¨ã™ã‚‹ PHP ã® SOAP æ‹¡å¼µæ©Ÿèƒ½ãŒå¿…è¦ã§ã™ã€‚',0),(464972,12916,'pt','VocÃª deve ter a extensÃ£o PHP SOAP para usar esse recurso.',0),(464973,12916,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¸Ð¼ÐµÑ‚ÑŒ Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð¸Ðµ PHP SOAP Ð´Ð»Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑÑ‚Ð¾Ð¹ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸.',0),(464974,12916,'es','Debe tener el PHP SOAP extensiÃ³n para usar esta atributo',0),(464975,12916,'de','Sie mÃ¼ssen die PHP SOAP-Erweiterung um diese Funktion nutzen.',0),(464976,12916,'en','You must have the PHP SOAP extension to use this feature.',0),(464977,12917,'is','',0),(464978,12917,'dr','ØªØ§Ø±ÛŒØ® ØªØ®ÙÛŒÙ Ù¾Ø§ÛŒØ§Ù† Ù…Ø§Ù‡',0),(464979,12917,'pr','ØªØ§Ø±ÛŒØ® ØªØ®ÙÛŒÙ Ù¾Ø§ÛŒØ§Ù† Ù…Ø§Ù‡',0),(464980,12917,'tr','AyÄ±n tarihi sonu indirim',0),(464981,12917,'pl','Rabat Data koÅ„ca miesiÄ…ca',0),(464982,12917,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð´Ð°Ñ‚Ð° ÐºÑ€Ð°Ð¹ Ð½Ð° Ð¼ÐµÑÐµÑ†',0),(464983,12917,'ur','ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹ Ù…ÛÛŒÙ†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(464984,12917,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° Ð´Ð°Ñ‚ÑƒÐ¼ ÐºÑ€Ð°Ñ˜Ð° Ð¼ÐµÑÐµÑ†Ð°',0),(464985,12917,'vi','NgÃ y chiáº¿t kháº¥u cuá»‘i cÃ¹ng cá»§a thÃ¡ng',0),(464986,12917,'af','Datum einde van maand afslag',0),(464987,12917,'ro','Reducere data sfarsitul lunii',0),(464988,12917,'et','Hinnaalandi kuupÃ¤eva kuu lÃµpuni',0),(464989,12917,'si','Popust datum konca meseca',0),(464990,12917,'ba','DISKON TERBAIK untuk tanggal akhir bulan',0),(464991,12917,'nl','Goedkope datum einde van de maand',0),(464992,12917,'fi','Alennus pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n kuukauden loppuun',0),(464993,12917,'no','Rabatt dato etter mÃ¥ned',0),(464994,12917,'da','Discount dato slutningen af mÃ¥neden',0),(464995,12917,'ko','ë‹¬ì˜ ë ë‚ ì§œë¥¼ í• ì¸',0),(464996,12917,'he','×”× ×—×” ×ª××¨×™×š ×¡×•×£ ×”×—×•×“×©',0),(464997,12917,'el','Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î¼Î®Î½Î±',0),(464998,12917,'zh','æŠ˜æ‰£æ—¥æœŸæˆªè‡³æœˆåº•',0),(464999,12917,'sv','Rabatt datum slutet av mÃ¥naden',0),(465000,12917,'it','Sconto Data fine mese',0),(465001,12917,'tl','',0),(465002,12917,'th','à¸¥à¸”à¸§à¸±à¸™à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢à¸‚à¸­à¸‡à¹€à¸”à¸·à¸­à¸™',0),(465003,12917,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤¤à¤¿à¤¥à¤¿ à¤®à¤¾à¤¹ à¤•à¥‡ à¤…à¤‚à¤¤',0),(465004,12917,'ms','Diskaun tarikh akhir bulan',0),(465005,12917,'ar','Ø®ØµÙ… ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø´Ù‡Ø±',0),(465006,12917,'fr','Date de la fin du mois de remise',0),(465007,12917,'jp','æœˆæœ«æ—¥ã¾ã§ã‚’å‰²å¼•ã—ã¾ã™ã€‚',0),(465008,12917,'pt','Data final do mÃªs de desconto',0),(465009,12917,'ru','Ð”Ð°Ñ‚Ð° ÐºÐ¾Ð½Ñ†Ð° Ð¼ÐµÑÑÑ†Ð° ÑÐºÐ¸Ð´ÐºÐ°',0),(465010,12917,'es','Fecha de Descuento Fin de Mes',0),(465011,12917,'de','Rabatt Datum Ende des Monats',0),(465012,12917,'en','Discount Date End Of Month',0),(465013,12918,'is','',0),(465014,12918,'dr','ØªØ§Ø±ÛŒØ® ØªØ®ÙÛŒÙ Ø¯Ø± Ù…Ø§Ù‡ Ø¢ÛŒÙ†Ø¯Ù‡',0),(465015,12918,'pr','ØªØ§Ø±ÛŒØ® ØªØ®ÙÛŒÙ Ø¯Ø± Ù…Ø§Ù‡ Ø¢ÛŒÙ†Ø¯Ù‡',0),(465016,12918,'tr','Ä°skonto tarihi ay takip',0),(465017,12918,'pl','Data rabatu na po miesiÄ…cu',0),(465018,12918,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð½Ð° ÑÐ»ÐµÐ´Ð²Ð°Ñ‰ Ð¼ÐµÑÐµÑ†',0),(465019,12918,'ur','ØªØ§Ø±ÛŒØ® Ù…Ø§Û Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(465020,12918,'sr','Ð”Ð°Ñ‚ÑƒÐ¼Ð° ÐºÐ°ÑÐ°ÑÐºÐ¾Ð½Ñ‚Ð° Ð½Ð° Ð¿Ð¾ÑÐ»Ðµ Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(465021,12918,'vi','NgÃ y chiáº¿t kháº¥u cá»§a thÃ¡ng tiáº¿p theo',0),(465022,12918,'af','Datum op volgende maand afslag',0),(465023,12918,'ro','Data reducerii pe luna',0),(465024,12918,'et','Hinnaalandi kuupÃ¤eva kohta jÃ¤rgneva kuu',0),(465025,12918,'si','Datuma kasaskonta na po mesecu',0),(465026,12918,'ba','Diskon tanggal pada mengikuti bulan',0),(465027,12918,'nl','Contantkorting op de volgende maand',0),(465028,12918,'fi','Alennus pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤Ã¤ seuraavan kuukauden',0),(465029,12918,'no','Kontantrabattdato pÃ¥ etter mÃ¥ned',0),(465030,12918,'da','Kontantrabatdato pÃ¥ efter mÃ¥ned',0),(465031,12918,'ko','ë‹¤ìŒ ë‹¬ì— ë‚ ì§œë¥¼ í• ì¸',0),(465032,12918,'he','×”× ×—×” ×ª××¨×™×š ×¢×œ ××—×¨×™ ×—×•×“×©',0),(465033,12918,'el','Î¤Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚ Î¼ÎµÏ„Î¬ Ï„Î¿ Î¼Î®Î½Î±',0),(465034,12918,'zh','åœ¨ä»¥ä¸‹æœˆæŠ˜æ‰£æ—¥æœŸ',0),(465035,12918,'sv','Kassarabattsdatumet pÃ¥ fÃ¶ljande mÃ¥nad',0),(465036,12918,'it','Sconto successivo mese data',0),(465037,12918,'tl','',0),(465038,12918,'th','à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¸§à¸±à¸™à¸•à¹ˆà¸­à¹€à¸”à¸·à¸­à¸™',0),(465039,12918,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¤¾ à¤ªà¤¾à¤²à¤¨ à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ',0),(465040,12918,'ms','Diskaun tarikh terakhir mengikut bulan',0),(465041,12918,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø®ØµÙ… Ø¹Ù„Ù‰ Ø¨Ø¹Ø¯ Ø´Ù‡Ø±',0),(465042,12918,'fr','Promos Date sur suivant mois',0),(465043,12918,'jp','æ¬¡ã®æœˆã®æ—¥ä»˜ã‚’å‰²å¼•ã—ã¾ã™ã€‚',0),(465044,12918,'pt','Desconto data no seguinte mÃªs',0),(465045,12918,'ru','Ð”Ð°Ñ‚Ð° ÑÐºÐ¸Ð´ÐºÐ¸ Ð½Ð° Ð¿Ð¾ÑÐ»Ðµ Ð¼ÐµÑÑÑ†Ð°',0),(465046,12918,'es','Fecha de Descuento en el Mes Siguente',0),(465047,12918,'de','Discount-Datum auf den Monat folgt',0),(465048,12918,'en','Discount Date On Following Month',0),(465049,12919,'is','',0),(465050,12919,'dr','Ø®Ø§Ù„Øµ Ø±ÙˆØ² Ø§Ø² Ù…Ø§Ù‡ Ú¯Ø°Ø´ØªÙ‡',0),(465051,12919,'pr','Ø®Ø§Ù„Øµ Ø±ÙˆØ² Ø§Ø² Ù…Ø§Ù‡ Ú¯Ø°Ø´ØªÙ‡',0),(465052,12919,'tr','Ay Prox net gÃ¼nÃ¼',0),(465053,12919,'pl','Netto dzieÅ„ miesiÄ…ca Prox',0),(465054,12919,'bg','ÐÐµÑ‚Ð¾ Ð´ÐµÐ½ Ð¾Ñ‚ Ð¼ÐµÑÐµÑ† Prox',0),(465055,12919,'ur','Ù…Ø§Û Ù¾Ø±Ø§ÙˆÙ† Ú©Ø§ Ø¬Ø§Ù„ Ø¯Ù†',0),(465056,12919,'sr','ÐÐµÑ‚Ð¾ Ð´Ð°Ð½ Ñƒ Ð¼ÐµÑÐµÑ†Ñƒ ÐŸÑ€Ð¾x',0),(465057,12919,'vi','Sá»‘ ngÃ y thá»±c cá»§a thÃ¡ng sau',0),(465058,12919,'af','Dag van die maand Prox netto',0),(465059,12919,'ro','Zi net de lunÄƒ Prox',0),(465060,12919,'et','Net pÃ¤ev kuu Prox',0),(465061,12919,'si','Neto dan mesec Prox',0),(465062,12919,'ba','Bersih hari bulan Prox',0),(465063,12919,'nl','Dag van maand Prox netto',0),(465064,12919,'fi','NET pÃ¤ivÃ¤ kuukauden Prox',0),(465065,12919,'no','Netto dagen i mÃ¥neden Prox',0),(465066,12919,'da','Netto dag i mÃ¥neden Prox',0),(465067,12919,'ko','ë‹¬ Proxì˜ ìˆœ ì¼',0),(465068,12919,'he','×”×™×•× × ×˜×• ×©×œ ×—×•×“×© Prox',0),(465069,12919,'el','ÎšÎ±Î¸Î±ÏÎ® Î·Î¼Î­ÏÎ± Ï„Î¿Ï… Î¼Î®Î½Î± Prox',0),(465070,12919,'zh','å‡€å¤©æœˆæ„Ÿåº”',0),(465071,12919,'sv','Net dagen av mÃ¥naden Prox',0),(465072,12919,'it','NET giorno del mese Prox',0),(465073,12919,'tl','',0),(465074,12919,'th','à¸ªà¸¸à¸—à¸˜à¸´à¸§à¸±à¸™à¹€à¸”à¸·à¸­à¸™ Prox',0),(465075,12919,'hi','à¤®à¤¹à¥€à¤¨à¥‡ Prox à¤•à¥‡ à¤¦à¤¿à¤¨ à¤¨à¥‡à¤Ÿ',0),(465076,12919,'ms','Bersih hari bulan Prox',0),(465077,12919,'ar','ÙŠÙˆÙ… ØµØ§Ù Ù…Ù† Prox Ø§Ù„Ø´Ù‡Ø±',0),(465078,12919,'fr','NET jour de mois Prox',0),(465079,12919,'jp','æœˆ Prox ã®ç´”æ—¥',0),(465080,12919,'pt','NET o dia do mÃªs Prox',0),(465081,12919,'ru','Ð§Ð¸ÑÑ‚Ñ‹Ð¹ Ð´ÐµÐ½ÑŒ Ð¼ÐµÑÑÑ†Ð° Prox',0),(465082,12919,'es','Fecha Neta del DÃ­a del Mes Prox',0),(465083,12919,'de','NET Tag des Monats Prox',0),(465084,12919,'en','Net Day Of Month Prox',0),(465085,12920,'is','',0),(465086,12920,'dr','1099',0),(465087,12920,'pr','Ø¯Ø±ÛŒØ§ÙØª 1099',0),(465088,12920,'tr','1099 alÄ±r',0),(465089,12920,'pl','Otrzymuje 1099',0),(465090,12920,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð° 1099',0),(465091,12920,'ur','1099 ÙˆØµÙˆÙ„ Ú©Ø±ØªØ§ ÛÛ’',0),(465092,12920,'sr','ÐŸÑ€Ð¸Ð¼Ð° 1099 ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð°',0),(465093,12920,'vi','nháº­n 1099',0),(465094,12920,'af','1099 ontvang',0),(465095,12920,'ro','PrimeÅŸte 1099',0),(465096,12920,'et','Saab 1099',0),(465097,12920,'si','Prejme 1099',0),(465098,12920,'ba','Menerima 1099',0),(465099,12920,'nl','1099 ontvangt',0),(465100,12920,'fi','Saa 1099',0),(465101,12920,'no','Mottar 1099',0),(465102,12920,'da','Modtager 1099',0),(465103,12920,'ko','1099ë¥¼ ë°›ìŠµë‹ˆë‹¤.',0),(465104,12920,'he','×ž×§×‘×œ 1099',0),(465105,12920,'el','Î›Î±Î¼Î²Î¬Î½ÎµÎ¹ 1099',0),(465106,12920,'zh','æŽ¥æ”¶ 1099',0),(465107,12920,'sv','Tar emot 1099',0),(465108,12920,'it','Riceve 1099',0),(465109,12920,'tl','',0),(465110,12920,'th','à¸£à¸±à¸š 1099',0),(465111,12920,'hi','1099 à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(465112,12920,'ms','Menerima 1099',0),(465113,12920,'ar','ÙŠØªÙ„Ù‚Ù‰ 1099',0),(465114,12920,'fr','ReÃ§oit 1099',0),(465115,12920,'jp','1099 ã‚’å—ã‘å–ã‚‹',0),(465116,12920,'pt','Recebe 1099',0),(465117,12920,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð°ÐµÑ‚ 1099',0),(465118,12920,'es','Recibe 1099',0),(465119,12920,'de','ErhÃ¤lt 1099',0),(465120,12920,'en','Receives 1099',0),(465121,12921,'is','',0),(465122,12921,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª',0),(465123,12921,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª',0),(465124,12921,'tr','Ä°thalat yapÄ± sipariÅŸleri',0),(465125,12921,'pl','PrzywÃ³z wykonania zamÃ³wienia',0),(465126,12921,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(465127,12921,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©ÛŒ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(465128,12921,'sr','Ð£Ð²Ð¾Ð· Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(465129,12921,'vi','Nháº­p Ä‘Æ¡n hÃ ng Build',0),(465130,12921,'af','Invoer bou bestellings',0),(465131,12921,'ro','Ordinele de a construi de import',0),(465132,12921,'et','Impordi ehitada tellimused',0),(465133,12921,'si','Uvoz graditi naroÄila',0),(465134,12921,'ba','Impor membangun perintah',0),(465135,12921,'nl','Import Build Orders',0),(465136,12921,'fi','Tuonti muodostaa tilaukset',0),(465137,12921,'no','Importer bygge bestillinger',0),(465138,12921,'da','Import bygge ordrer',0),(465139,12921,'ko','ê°€ì ¸ì˜¤ê¸° ë¹Œë“œ ìˆœì„œ',0),(465140,12921,'he','×™×™×‘×•× ×œ×‘× ×•×ª ×”×–×ž× ×•×ª',0),(465141,12921,'el','ÎšÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Î±Î½Î¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(465142,12921,'zh','å¯¼å…¥ç”Ÿæˆè®¢å•',0),(465143,12921,'sv','Bygga bestÃ¤llning',0),(465144,12921,'it','Importazione compilazione ordini',0),(465145,12921,'tl','',0),(465146,12921,'th','à¸ªà¸±à¹ˆà¸‡à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ªà¸£à¹‰à¸²à¸‡',0),(465147,12921,'hi','à¤†à¤¯à¤¾à¤¤ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤†à¤¦à¥‡à¤¶',0),(465148,12921,'ms','Perintah membina import',0),(465149,12921,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø§Ø¡ Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(465150,12921,'fr','Importation Build Orders',0),(465151,12921,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®ãƒ“ãƒ«ãƒ‰é †åº',0),(465152,12921,'pt','ImportaÃ§Ã£o de ordens de construÃ§Ã£o',0),(465153,12921,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° ÑÐ±Ð¾Ñ€ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(465154,12921,'es','Importar Pedidos Incrementales',0),(465155,12921,'de','Import Build Orders',0),(465156,12921,'en','Import Build Orders',0),(465157,12922,'is','',0),(465158,12922,'dr','Ù…ØªÙ† ÙØ§Ú©ØªÙˆØ± Ø¨Ø±Ø§ÛŒ ÙØ±Ù… ÙØ§Ú©ØªÙˆØ±ÙˆÛŒÚ˜Ù‡ ',0),(465159,12922,'pr','Ù…ØªÙ† ÙØ§Ú©ØªÙˆØ± Ø¨Ø±Ø§ÛŒ ÙØ±Ù… ÙØ§Ú©ØªÙˆØ±ÙˆÛŒÚ˜Ù‡ ',0),(465160,12922,'tr','Ã–zel fatura formu iÃ§in fatura metni',0),(465161,12922,'pl','Tekst faktury faktury specjalny formularz',0),(465162,12922,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ‚ÐµÐºÑÑ‚ Ð·Ð° ÑÐ¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€',0),(465163,12922,'ur','Ø®ØµÙˆØµÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ ÙØ§Ø±Ù… Ú©Û’ Ù„ÛŒÛ’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…ØªÙ†',0),(465164,12922,'sr','Ð¢ÐµÐºÑÑ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð·Ð° Ð¿Ð¾ÑÐµÐ±Ð½Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¾Ð±Ñ€Ð°ÑÑ†Ð°',0),(465165,12922,'vi','pháº§n viáº¿t hÃ³a Ä‘Æ¡n cho máº«u hÃ³a Ä‘Æ¡n Ä‘áº·c biá»‡t',0),(465166,12922,'af','Faktuur teks vir spesiale faktuur vorm',0),(465167,12922,'ro','Text de facturÄƒ pentru formularul de facturÄƒ speciale',0),(465168,12922,'et','Arve tekst spetsiaalne arve vorm',0),(465169,12922,'si','Besedilo raÄuna za poseben raÄun v obrazcu raÄun',0),(465170,12922,'ba','Invoice Text untuk bentuk khusus faktur',0),(465171,12922,'nl','Factuur tekst voor speciale factuurformulier',0),(465172,12922,'fi','Laskun teksti erityistÃ¤ laskulomake',0),(465173,12922,'no','Faktura tekst for spesielle faktura-skjemaet',0),(465174,12922,'da','Faktura tekst for sÃ¦rlige fakturaformularen',0),(465175,12922,'ko','íŠ¹ë³„ í•œ ì†¡ìž¥ ì–‘ì‹ì— ëŒ€ í•œ ì†¡ìž¥ í…ìŠ¤íŠ¸',0),(465176,12922,'he','×˜×§×¡×˜ ×—×©×‘×•× ×™×ª ×¢×‘×•×¨ ×˜×•×¤×¡ ×ž×™×•×—×“ ×—×©×‘×•× ×™×ª',0),(465177,12922,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Î³Î¹Î± ÎµÎ¹Î´Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¼Î¿ÏÏ†Î®',0),(465178,12922,'zh','ä¸“ç”¨å‘ç¥¨å½¢å¼å‘ç¥¨æ–‡æœ¬',0),(465179,12922,'sv','Faktura Text fÃ¶r sÃ¤rskild faktura Form',0),(465180,12922,'it','Testo fattura per fattura speciale forma',0),(465181,12922,'tl','',0),(465182,12922,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸™à¹à¸šà¸šà¸Ÿà¸­à¸£à¹Œà¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸žà¸´à¹€à¸¨à¸©',0),(465183,12922,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¤¾à¤ ',0),(465184,12922,'ms','Invois teks untuk borang khas invois',0),(465185,12922,'ar','Ù†Øµ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù„Ù†Ù…ÙˆØ°Ø¬ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø®Ø§ØµØ©',0),(465186,12922,'fr','Texte de facture pour formulaire facture spÃ©ciale',0),(465187,12922,'jp','ç‰¹åˆ¥ãªè«‹æ±‚æ›¸ãƒ•ã‚©ãƒ¼ãƒ ã®è«‹æ±‚æ›¸ã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(465188,12922,'pt','Texto de factura de forma especial na factura',0),(465189,12922,'ru','Ð¢ÐµÐºÑÑ‚ ÑÑ‡ÐµÑ‚Ð° Ð·Ð° ÑÑ‡ÐµÑ‚ ÑÐ¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ð¹ Ñ„Ð¾Ñ€Ð¼Ñ‹',0),(465190,12922,'es','Texto de Factura Para Forma Especial de Factura',0),(465191,12922,'de','Rechnung Text fÃ¼r spezielle Rechnungsformular',0),(465192,12922,'en','Invoice Text for Special Invoice Form',0),(465193,12923,'is','',0),(465194,12923,'dr','(Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(465195,12923,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ú©Ø§Ø±Øª Ø³Ù‡ Ø¨Ø¹Ø¯ÛŒ(Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(465196,12923,'tr','3dcart kurulumu',0),(465197,12923,'pl','3dcart instalacji',0),(465198,12923,'bg','3dcart Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(465199,12923,'ur','3dcart Ø³ÛŒÙ¹ Ø§Ù¾',0),(465200,12923,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð°',0),(465201,12923,'vi','CÃ i Ä‘áº·t 3dart  ',0),(465202,12923,'af','3dcart Opstelling',0),(465203,12923,'ro','3dcart de configurare',0),(465204,12923,'et','3dcart seadistamine',0),(465205,12923,'si','3dcart nastavitev',0),(465206,12923,'ba','3dcart Setup',0),(465207,12923,'nl','3dcart Setup',0),(465208,12923,'fi','3dcart asetukset',0),(465209,12923,'no','3dcart oppsett',0),(465210,12923,'da','3dcart opsÃ¦tning',0),(465211,12923,'ko','3dcart ì„¤ì¹˜',0),(465212,12923,'he','×”×’×“×¨×ª 3dcart',0),(465213,12923,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ 3dcart',0),(465214,12923,'zh','3dcart å®‰è£…ç¨‹åº',0),(465215,12923,'sv','InstÃ¤llningar 3:e parts varukorg',0),(465216,12923,'it','3Dcart Setup',0),(465217,12923,'tl','',0),(465218,12923,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² 3dcart',0),(465219,12923,'hi','3dcart à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(465220,12923,'ms','3dcart persediaan',0),(465221,12923,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ 3dcart',0),(465222,12923,'fr','3Dcart Setup',0),(465223,12923,'jp','3dcart ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(465224,12923,'pt','3Dcart Setup',0),(465225,12923,'ru','3dcart ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(465226,12923,'es','ConfiguraciÃ³n de Carrito 3D',0),(465227,12923,'de','3dcart Setup',0),(465228,12923,'en','3dcart Setup',0),(465229,12924,'is','',0),(465230,12924,'dr','Ù†Ø´Ø§Ù†ÛŒ ØµÙØ­Ù‡ ÙˆØ¨ ÙØ±ÙˆØ´Ú¯Ø§Ù‡',0),(465231,12924,'pr','Ù†Ø´Ø§Ù†ÛŒ ØµÙØ­Ù‡ ÙˆØ¨ ÙØ±ÙˆØ´Ú¯Ø§Ù‡',0),(465232,12924,'tr','MaÄŸaza URL',0),(465233,12924,'pl','Adres URL sklepu',0),(465234,12924,'bg','ÐœÐ°Ð³Ð°Ð·Ð¸Ð½ URL',0),(465235,12924,'ur','Ø³Ù¹ÙˆØ± URL',0),(465236,12924,'sr','Ð¡ÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ðµ Ð£Ð Ð›',0),(465237,12924,'vi','Kho chá»©a URL',0),(465238,12924,'af','Winkel URL',0),(465239,12924,'ro','Magazin URL',0),(465240,12924,'et','Poe URL',0),(465241,12924,'si','Trgovina URL',0),(465242,12924,'ba','URL Toko',0),(465243,12924,'nl','Winkel-URL',0),(465244,12924,'fi','Store URL',0),(465245,12924,'no','Store-URL',0),(465246,12924,'da','Butik URL',0),(465247,12924,'ko','ì €ìž¥ì†Œ URL',0),(465248,12924,'he','×›×ª×•×‘×ª ×—× ×•×ª',0),(465249,12924,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± URL',0),(465250,12924,'zh','å­˜å‚¨ URL',0),(465251,12924,'sv','Lagra URL',0),(465252,12924,'it','URL del negozio',0),(465253,12924,'tl','',0),(465254,12924,'th','à¹€à¸à¹‡à¸š URL',0),(465255,12924,'hi','à¤¸à¥à¤Ÿà¥‹à¤° à¤¯à¥‚à¤†à¤°à¤à¤²',0),(465256,12924,'ms','URL kedai',0),(465257,12924,'ar','Ø±Ø§Ø¨Ø· Ø§Ù„Ù…ØªØ¬Ø±',0),(465258,12924,'fr','URL de la boutique',0),(465259,12924,'jp','URL ã‚’ä¿å­˜',0),(465260,12924,'pt','URL da loja',0),(465261,12924,'ru','URL-Ð°Ð´Ñ€ÐµÑ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð°',0),(465262,12924,'es','URL de Tienda',0),(465263,12924,'de','Shop-URL',0),(465264,12924,'en','Store URL',0),(465265,12925,'is','',0),(465266,12925,'dr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ ØªØ¹Ø¯Ø§Ø¯ ÙˆØ³Ø± Ø³ØªÙˆÙ† ÙˆØ§Ø­Ø¯',0),(465267,12925,'pr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ ØªØ¹Ø¯Ø§Ø¯ ÙˆØ³Ø± Ø³ØªÙˆÙ† ÙˆØ§Ø­Ø¯',0),(465268,12925,'tr','Metin iÃ§in miktar & birim sÃ¼tun baÅŸ',0),(465269,12925,'pl','Tekst na iloÅ›Ä‡ & jednostki kolumnÄ™ gÅ‚owa',0),(465270,12925,'bg','Ð¢ÐµÐºÑÑ‚ Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ & ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° ÐºÐ¾Ð»Ð¾Ð½Ð° Ð³Ð»Ð°Ð²Ð°Ñ‚Ð°',0),(465271,12925,'ur','Ù‚ÛŒ & ÛŒÙˆÙ†Ù¹ Ú©Ø§Ù„Ù… Ø³Ø± Ú©Û’ Ù„ÛŒÛ’ Ù…ØªÙ†',0),(465272,12925,'sr','Ð¢ÐµÐºÑÑ‚ Ð·Ð° ÐšÐ¾Ð» & Ð³Ð»Ð°Ð²Ðµ ÐºÐ¾Ð»Ð¾Ð½Ð¸ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(465273,12925,'vi','vÄƒn báº£n vá» sá»‘ lÆ°á»£ng vÃ  tiÃªu Ä‘á» cá»™t Ä‘Æ¡n vá»‹',0),(465274,12925,'af','Teks vir Qty & eenheid kolom kop',0),(465275,12925,'ro','Text pentru cantit & capul de coloanÄƒ unitate',0),(465276,12925,'et','Teksti kogus & veeru teenistuse juhataja',0),(465277,12925,'si','Besedilo za kol & enoto glavo stolpca',0),(465278,12925,'ba','Teks untuk Qty & kepala kolom Unit',0),(465279,12925,'nl','Tekst voor aantal & eenheid kolomkop',0),(465280,12925,'fi','Tekstin mÃ¤Ã¤rÃ¤ & sarakkeen yksikÃ¶npÃ¤Ã¤llikkÃ¶',0),(465281,12925,'no','Tekst For antall & kolonnen leder',0),(465282,12925,'da','Tekst til Qty & enhed kolonne hoved',0),(465283,12925,'ko','Qty & ë‹¨ìœ„ ì—´ ë¨¸ë¦¬ì— ëŒ€ í•œ í…ìŠ¤íŠ¸',0),(465284,12925,'he','×˜×§×¡×˜ ×¢×‘×•×¨ ×›×ž×•×ª ×©×œ & ×¨××© ×¢×ž×•×“×” ×™×—×™×“×”',0),(465285,12925,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Î³Î¹Î± Qty & ÏƒÏ„Î®Î»Î· ÎµÏ€Î¹ÎºÎµÏ†Î±Î»Î®Ï‚ Î¼Î¿Î½Î¬Î´Î±Ï‚',0),(465286,12925,'zh','æ•°é‡ &amp; è‚¡åˆ—æ ‡å¤´çš„æ–‡æœ¬',0),(465287,12925,'sv','Text fÃ¶r antal & kolumn enhetschef',0),(465288,12925,'it','Testo per q. tÃ  & testa colonna unitÃ ',0),(465289,12925,'tl','',0),(465290,12925,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸£à¸´à¸¡à¸²à¸“ & à¸«à¸™à¹ˆà¸§à¸¢à¸«à¸±à¸§à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œ',0),(465291,12925,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ & à¤‡à¤•à¤¾à¤ˆ à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¤¿à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤ ',0),(465292,12925,'ms','Teks untuk Qty & Ketua kolum Unit',0),(465293,12925,'ar','Ù†Øµ Ù„Ù„ÙƒÙ…ÙŠØ© Ø¢Ù†Ø¯ ÙˆØ­Ø¯Ø© Ø±Ø£Ø³ Ø§Ù„Ø¹Ù…ÙˆØ¯',0),(465294,12925,'fr','Texte pour la quantitÃ© & de la tÃªte de la colonne',0),(465295,12925,'jp','Qty & ãƒ¦ãƒ‹ãƒƒãƒˆåˆ—ãƒ˜ãƒƒãƒ€ãƒ¼ã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(465296,12925,'pt','Texto para Qty & cabeÃ§a de coluna unidade',0),(465297,12925,'ru','Ð¢ÐµÐºÑÑ‚ Ð´Ð»Ñ Qty & Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ð¸Ðº Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð¾Ð²',0),(465298,12925,'es','Texto Encabezador Para Columna de Cantidad y Unidad',0),(465299,12925,'de','Text fÃ¼r Qty & Einheit SpaltenÃ¼berschrift',0),(465300,12925,'en','Text For Qty & Unit Column Head',0),(465301,12926,'is','',0),(465302,12926,'dr','(Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ ',0),(465303,12926,'pr','Ø§Ø¯ØºØ§Ù… Ú©Ø§Ø±Øª Ø³Ù‡ Ø¨Ø¹Ø¯ÛŒ (Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ ',0),(465304,12926,'tr','3dcart entegrasyon',0),(465305,12926,'pl','Integracja 3dcart',0),(465306,12926,'bg','3dcart Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ',0),(465307,12926,'ur','3dcart Ø§Ù†Ø¶Ù…Ø§Ù…',0),(465308,12926,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ˜Ðµ',0),(465309,12926,'vi','3dcart tÃ­ch há»£p',0),(465310,12926,'af','3dmandjie Integrasie',0),(465311,12926,'ro','3dcart de integrare',0),(465312,12926,'et','3dcart integreerimine',0),(465313,12926,'si','3dcart povezovanje',0),(465314,12926,'ba','3dcart integrasi',0),(465315,12926,'nl','3dcart integratie',0),(465316,12926,'fi','Yhdentymisen 3dcart',0),(465317,12926,'no','3dcart integrering',0),(465318,12926,'da','3dcart Integration',0),(465319,12926,'ko','3dcart í†µí•©',0),(465320,12926,'he','3dcart ××™× ×˜×’×¨×¦×™×”',0),(465321,12926,'el','ÎŸÎ»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ 3dcart',0),(465322,12926,'zh','3dcart é›†æˆ',0),(465323,12926,'sv','integration med 3:e parts varukorg',0),(465324,12926,'it','3Dcart integrazione',0),(465325,12926,'tl','',0),(465326,12926,'th','à¸£à¸§à¸¡ 3dcart',0),(465327,12926,'hi','3dcart à¤à¤•à¥€à¤•à¤°à¤£',0),(465328,12926,'ms','Integrasi 3dcart',0),(465329,12926,'ar','Ø§Ù„ØªÙƒØ§Ù…Ù„ 3dcart',0),(465330,12926,'fr','3Dcart intÃ©gration',0),(465331,12926,'jp','3dcart çµ±åˆ',0),(465332,12926,'pt','3Dcart integraÃ§Ã£o',0),(465333,12926,'ru','3dcart Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ',0),(465334,12926,'es','IntegraciÃ³n de Carrito 3D',0),(465335,12926,'de','3dcart Integration',0),(465336,12926,'en','3dcart Integration',0),(465337,12927,'is','',0),(465338,12927,'dr','(Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ  ',0),(465339,12927,'pr','   Ø´Ù†Ø§Ø³Ù‡ Ø³ÙØ§Ø±Ø´ Ú©Ø§Ø±Øª Ø³Ù‡ Ø¨Ø¹Ø¯ÛŒ (Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ  ',0),(465340,12927,'tr','3dcart SipariÅŸ No',0),(465341,12927,'pl','3dcart identyfikator zamÃ³wienia',0),(465342,12927,'bg','3dcart Ð˜Ð” Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(465343,12927,'ur','3dcart Ø¢Ø±ÚˆØ± Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(465344,12927,'sr','Ð˜Ð” Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(465345,12927,'vi','3dcart MÃ£ Lá»‡nh',0),(465346,12927,'af','3dmandjie Bestelling ID',0),(465347,12927,'ro','3dcart Order ID',0),(465348,12927,'et','3dcart Tellimuse ID',0),(465349,12927,'si','ID naroÄila 3dcart',0),(465350,12927,'ba','ID pesanan 3dcart',0),(465351,12927,'nl','3dcart Order-ID',0),(465352,12927,'fi','3dcart tilauksen tunnus',0),(465353,12927,'no','3dcart ordre-ID',0),(465354,12927,'da','3dcart ordre-ID',0),(465355,12927,'ko','3dcart ì£¼ë¬¸ ë²ˆí˜¸',0),(465356,12927,'he','×ž×–×”×” ×”×–×ž× ×” 3dcart',0),(465357,12927,'el','3dcart Î Î±ÏÎ±Î³Î³',0),(465358,12927,'zh','3dcart è®¢å• ID',0),(465359,12927,'sv','Order nummer 3:e parts varukorg',0),(465360,12927,'it','3Dcart Order ID',0),(465361,12927,'tl','',0),(465362,12927,'th','à¸£à¸«à¸±à¸ªà¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­ 3dcart',0),(465363,12927,'hi','3dcart à¤•à¥à¤°à¤® ID',0),(465364,12927,'ms','3dcart perintah ID',0),(465365,12927,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù†Ø¸Ø§Ù… 3dcart',0),(465366,12927,'fr','RÃ©f. de commande 3Dcart',0),(465367,12927,'jp','3dcart æ³¨æ–‡ ID',0),(465368,12927,'pt','3Dcart ordem ID',0),(465369,12927,'ru','3dcart Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(465370,12927,'es','ID del Pedido del Carrito 3D',0),(465371,12927,'de','Bestell-Nr. 3dcart',0),(465372,12927,'en','3dcart Order ID',0),(465373,12928,'is','',0),(465374,12928,'dr','(Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ  ',0),(465375,12928,'pr','  Ø³Ø§Ø²Ú¯Ø§Ø± Ú©Ø±Ø¯Ù† ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ú©Ø§Ø±Øª Ø³Ù‡ Ø¨Ø¹Ø¯ÛŒ(Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ  ',0),(465376,12928,'tr','3dcart ayarlarÄ±nÄ± yapma',0),(465377,12928,'pl','Ustawienia 3dcart',0),(465378,12928,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹Ñ‚Ðµ 3dcart Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸',0),(465379,12928,'ur','3dcart Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº Ù…Ø·Ø§Ø¨Ù‚ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(465380,12928,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(465381,12928,'vi','Äiá»u chá»‰nh cÃ i Ä‘áº·t 3dcart',0),(465382,12928,'af','Verstel 3dcart instellings',0),(465383,12928,'ro','ReglaÈ›i setÄƒrile 3dcart',0),(465384,12928,'et','3dcart sÃ¤tete kohandamine',0),(465385,12928,'si','Prilagodite 3dcart nastavitve',0),(465386,12928,'ba','Menyesuaikan pengaturan 3dcart',0),(465387,12928,'nl','3dcart instellingen aanpassen',0),(465388,12928,'fi','3dcart sÃ¤Ã¤tÃ¤minen',0),(465389,12928,'no','Justere innstillinger for 3dcart',0),(465390,12928,'da','Justere indstillinger for 3dcart',0),(465391,12928,'ko','3dcart ì„¤ì • ì¡°ì •',0),(465392,12928,'he','×œ×›×•×•× ×Ÿ ×”×’×“×¨×•×ª 3dcart',0),(465393,12928,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼ÏŒÏƒÎµÏ„Îµ Ï„Î¹Ï‚ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ 3dcart',0),(465394,12928,'zh','è°ƒæ•´ 3dcart è®¾ç½®',0),(465395,12928,'sv','Justera instÃ¤llningar fÃ¶r 3dcart',0),(465396,12928,'it','Regolare le impostazioni 3dcart',0),(465397,12928,'tl','',0),(465398,12928,'th','à¸›à¸£à¸±à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² 3dcart',0),(465399,12928,'hi','3dcart à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(465400,12928,'ms','Laras seting 3dcart',0),(465401,12928,'ar','Ø¶Ø¨Ø· Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª 3dcart',0),(465402,12928,'fr','Ajuster les paramÃ¨tres de 3dcart',0),(465403,12928,'jp','3dcart è¨­å®šã‚’èª¿æ•´ã—ã¾ã™ã€‚',0),(465404,12928,'pt','Ajustar as configuraÃ§Ãµes do 3dcart',0),(465405,12928,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ 3dcart',0),(465406,12928,'es','Ajuste las Opciones de Carrito 3D',0),(465407,12928,'de','3dcart-Einstellungen anpassen',0),(465408,12928,'en','Adjust 3dcart Settings',0),(465409,12929,'is','',0),(465410,12929,'dr','ÛŒÚ© Ø®Ø·Ø§ Ù‡Ù†Ú¯Ø§Ù… Ø§Ø±Ø³Ø§Ù„ Ø±Ø® Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª',0),(465411,12929,'pr','ÛŒÚ© Ø®Ø·Ø§ Ù‡Ù†Ú¯Ø§Ù… Ø§Ø±Ø³Ø§Ù„ Ø±Ø® Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª',0),(465412,12929,'tr','Alma sÄ±rasÄ±nda hata oluÅŸtu',0),(465413,12929,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas importowania',0),(465414,12929,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð° Ð³Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(465415,12929,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±Ù†Û’ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ø§ÛŒÚ© Ù†Ù‚Øµ ÛÙˆ Ú¯ÛŒØ§',0),(465416,12929,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð³Ñ€ÐµÑˆÐºÐµ Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑƒÐ²Ð¾Ð·Ð°',0),(465417,12929,'vi','CÃ³ lá»—i Ä‘Ã£ xáº£y ra',0),(465418,12929,'af','\'N Fout het voorgekom terwyl die invoer',0),(465419,12929,'ro','A apÄƒrut o eroare Ã®n timp ce importul',0),(465420,12929,'et','Importimisel ilmnes tÃµrge',0),(465421,12929,'si','UvaÅ¾anje je priÅ¡lo do napake',0),(465422,12929,'ba','Terjadi kesalahan saat mengimpor',0),(465423,12929,'nl','Er is een fout opgetreden tijdens het importeren',0),(465424,12929,'fi','Virhe tuotaessa',0),(465425,12929,'no','Det oppstod en feil under import',0),(465426,12929,'da','Der opstod en fejl under import af',0),(465427,12929,'ko','ê°€ì ¸ì˜¤ëŠ” ë™ì•ˆ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(465428,12929,'he','××™×¨×¢×” ×©×’×™××” ×‘×¢×ª ×™×™×‘×•×',0),(465429,12929,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(465430,12929,'zh','å¯¼å…¥æ—¶å‡ºé”™',0),(465431,12929,'sv','Ett fel intrÃ¤ffade vid import',0),(465432,12929,'it','Si Ã¨ verificato un errore durante l\'importazione',0),(465433,12929,'tl','',0),(465434,12929,'th','à¹€à¸à¸´à¸”à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¸‚à¸“à¸°à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(465435,12929,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¤à¥‡ à¤¸à¤®à¤¯ à¤à¤• à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤¹à¥à¤ˆ',0),(465436,12929,'ms','Satu ralat berlaku semasa mengimport',0),(465437,12929,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(465438,12929,'fr','Une erreur s\'est produite lors de l\'importation',0),(465439,12929,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆä¸­ã«ã‚¨ãƒ©ãƒ¼ãŒç™ºç”Ÿã—ã¾ã—ãŸ',0),(465440,12929,'pt','Ocorreu um erro ao importar',0),(465441,12929,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð° Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ðµ',0),(465442,12929,'es','Se OccuriÃ³ un Error Mientras que Importar',0),(465443,12929,'de','Fehler beim Importieren',0),(465444,12929,'en','An Error Occurred While Importing',0),(465445,12930,'is','',0),(465446,12930,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ø±Ø³Ø§Ù„ Ø³ÙØ§Ø±Ø´Ø§Øª Ù†ÛŒØ³Øª',0),(465447,12930,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ø±Ø³Ø§Ù„ Ø³ÙØ§Ø±Ø´Ø§Øª Ù†ÛŒØ³Øª',0),(465448,12930,'tr','Emir alÄ±namadÄ±',0),(465449,12930,'pl','Nie moÅ¼na importowaÄ‡ zamÃ³wienia',0),(465450,12930,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(465451,12930,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ø§ Ø¯Ø±Ø¢Ù…Ø¯ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Û”',0),(465452,12930,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÑƒÐ²ÐµÑÑ‚Ð¸ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(465453,12930,'vi','khÃ´ng thá»ƒ nháº­p Ä‘Æ¡n hÃ ng',0),(465454,12930,'af','Kon bestellings invoer nie',0),(465455,12930,'ro','Ar putea importa ordinele',0),(465456,12930,'et','Tellimust ei saa importida',0),(465457,12930,'si','Strjena lava ne uvoz nalogov',0),(465458,12930,'ba','Tidak bisa mengimpor pesanan',0),(465459,12930,'nl','Orders kon niet importeren',0),(465460,12930,'fi','Voisi maahantuoda tilaukset',0),(465461,12930,'no','Kan ikke importere ordrer',0),(465462,12930,'da','Kunne ikke importere ordrer',0),(465463,12930,'ko','ìˆœì„œë¥¼ ê°€ì ¸ì˜¬ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(465464,12930,'he','×œ× ×™×›×•×œ ×œ×™×™×‘× ×”×–×ž× ×•×ª',0),(465465,12930,'el','Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎ±Î½ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³Î¿Ï…Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(465466,12930,'zh','ä¸èƒ½å¯¼å…¥å‘½ä»¤',0),(465467,12930,'sv','Kan inte importera order',0),(465468,12930,'it','Non potrebbe importare gli ordini',0),(465469,12930,'tl','',0),(465470,12930,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸™à¸³à¹€à¸‚à¹‰à¸²à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(465471,12930,'hi','à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‹ à¤†à¤¯à¤¾à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(465472,12930,'ms','Boleh mengimport pesanan',0),(465473,12930,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£ÙˆØ§Ù…Ø±',0),(465474,12930,'fr','Ne pouvait pas importer les commandes',0),(465475,12930,'jp','å—æ³¨ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(465476,12930,'pt','NÃ£o foi possÃ­vel importar as ordens',0),(465477,12930,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(465478,12930,'es','No PodÃ­a Importar Pedidos',0),(465479,12930,'de','Bestellungen kÃ¶nnen nicht importiert werden.',0),(465480,12930,'en','Could Not Import Orders',0),(465481,12931,'is','',0),(465482,12931,'dr','Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± ',0),(465483,12931,'pr','Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± ',0),(465484,12931,'tr','Fatura numarasÄ±',0),(465485,12931,'pl','Od numeru faktury',0),(465486,12931,'bg','ÐžÑ‚ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(465487,12931,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø± Ø³Û’',0),(465488,12931,'sr','Ð˜Ð· Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(465489,12931,'vi','tá»« hÃ³a Ä‘Æ¡n sá»‘',0),(465490,12931,'af','Van faktuur nommer',0),(465491,12931,'ro','La numÄƒrul facturii',0),(465492,12931,'et','Arve Number:',0),(465493,12931,'si','S Å¡tevilko raÄuna',0),(465494,12931,'ba','Dari faktur jumlah',0),(465495,12931,'nl','Van factuurnummer',0),(465496,12931,'fi','Laskun numero',0),(465497,12931,'no','Fra fakturanummer',0),(465498,12931,'da','Fra fakturanummer',0),(465499,12931,'ko','ì†¡ìž¥ ë²ˆí˜¸ì—ì„œ',0),(465500,12931,'he','×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(465501,12931,'el','Î‘Ï€ÏŒ Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(465502,12931,'zh','ä»Žå‘ç¥¨ç¼–å·',0),(465503,12931,'sv','FrÃ¥n fakturanummer',0),(465504,12931,'it','Dal numero di fattura',0),(465505,12931,'tl','',0),(465506,12931,'th','à¸ˆà¸²à¸à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œ',0),(465507,12931,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤¸à¥‡',0),(465508,12931,'ms','Dari nombor invois',0),(465509,12931,'ar','Ù…Ù† Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(465510,12931,'fr','Du numÃ©ro de facture',0),(465511,12931,'jp','è«‹æ±‚æ›¸ç•ªå·ã‹ã‚‰',0),(465512,12931,'pt','Do nÃºmero da fatura',0),(465513,12931,'ru','ÐžÑ‚ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(465514,12931,'es','Del NÃºmero de Factura',0),(465515,12931,'de','Von Rechnungsnummer',0),(465516,12931,'en','From Invoice Number',0),(465517,12932,'is','',0),(465518,12932,'dr','Ù‡ÛŒÚ† Ø³ÙØ§Ø±Ø´ÛŒ Ø¨Ø±Ø§ÛŒ ÙˆØ±ÙˆØ¯ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(465519,12932,'pr','Ù‡ÛŒÚ† Ø³ÙØ§Ø±Ø´ÛŒ Ø¨Ø±Ø§ÛŒ ÙˆØ±ÙˆØ¯ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(465520,12932,'tr','SipariÅŸ alma iÃ§in seÃ§ilen yok',0),(465521,12932,'pl','Nie zamÃ³wienia wybrany do importu',0),(465522,12932,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(465523,12932,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø§Ø±ÛŒ',0),(465524,12932,'sr','ÐÐ¸ÐºÐ°ÐºÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸ Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(465525,12932,'vi','khÃ´ng cÃ³ Ä‘Æ¡n hÃ ng Ä‘Æ°á»£c chá»n Ä‘á»ƒ nháº­p',0),(465526,12932,'af','Geen bestellings gekies vir invoer',0),(465527,12932,'ro','Comenzi selectate pentru Import',0),(465528,12932,'et','Pole tellimusi importimiseks valitud',0),(465529,12932,'si','Brez naroÄil, izbran za uvoz',0),(465530,12932,'ba','Tidak ada order yang dipilih untuk impor',0),(465531,12932,'nl','Geen Orders geselecteerd voor importeren',0),(465532,12932,'fi','Tuotavaksi valittu tilaukset',0),(465533,12932,'no','Ingen ordrer som er valgt For Import',0),(465534,12932,'da','Ingen ordrer, valgt til Import',0),(465535,12932,'ko','ì•„ë‹ˆ ì£¼ë¬¸ ê°€ì ¸ì˜¤ê¸° ìœ„í•´ ì„ íƒí•œ',0),(465536,12932,'he','×¤×§×•×“×•×ª ×©× ×‘×—×¨ ×¢×‘×•×¨ ×™×™×‘×•×',0),(465537,12932,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(465538,12932,'zh','æ²¡æœ‰é€‰æ‹©è¦å¯¼å…¥çš„è®¢å•',0),(465539,12932,'sv','Inga order som valts fÃ¶r Import',0),(465540,12932,'it','Nessun ordine selezionato per l\'importazione',0),(465541,12932,'tl','',0),(465542,12932,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(465543,12932,'hi','à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¯à¤¾à¤¤',0),(465544,12932,'ms','Tiada perintah yang dipilih bagi Import',0),(465545,12932,'ar','Ù„Ø§ Ø£ÙˆØ§Ù…Ø± Ù…Ø­Ø¯Ø¯Ø© Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(465546,12932,'fr','Aucune commande sÃ©lectionnÃ© pour l\'importation',0),(465547,12932,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã‚’é¸æŠžã—ãŸæ³¨æ–‡ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(465548,12932,'pt','Nenhuma ordem selecionada para importaÃ§Ã£o',0),(465549,12932,'ru','ÐÐµÑ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð², Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ð¼Ð¸ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(465550,12932,'es','No se Seleccionan Pedidos Para Exportar',0),(465551,12932,'de','Keine Bestellungen fÃ¼r den Import ausgewÃ¤hlt',0),(465552,12932,'en','No Orders Selected For Import',0),(465553,12933,'is','',0),(465554,12933,'dr','Ù‡ÛŒÚ† Ø³ÙØ§Ø±Ø´ÛŒ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø¨ÙˆØ¯',0),(465555,12933,'pr','Ù‡ÛŒÚ† Ø³ÙØ§Ø±Ø´ÛŒ ÙˆØ§Ø±Ø¯ Ù†Ø´Ø¯Ù‡ Ø¨ÙˆØ¯',0),(465556,12933,'tr','Emir ithal edildi',0),(465557,12933,'pl','ZamÃ³wienia nie zostaÅ‚y przywiezione',0),(465558,12933,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐ° Ð²Ð½ÐµÑÐµÐ½Ð¸',0),(465559,12933,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ø±Ø¢Ù…Ø¯ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(465560,12933,'sr','ÐÐ¸ÐºÐ°ÐºÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ° ÑÑƒ ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸.',0),(465561,12933,'vi','khÃ´ng cÃ³ Ä‘Æ¡n hÃ ng Ä‘Ã£ Ä‘Æ°á»£c nháº­p',0),(465562,12933,'af','Geen bestellings ingevoer was',0),(465563,12933,'ro','Comenzi nu au fost importate',0),(465564,12933,'et','Pole tellimusi imporditi',0),(465565,12933,'si','UvoÅ¾enih ni bilo naroÄil',0),(465566,12933,'ba','Tidak ada order yang diimpor',0),(465567,12933,'nl','Geen Orders werden ingevoerd',0),(465568,12933,'fi','Ei tilauksia ei tuotu',0),(465569,12933,'no','Ingen ordrer ble importert',0),(465570,12933,'da','Ingen ordrer blev importeret',0),(465571,12933,'ko','ì•„ë¬´ ìˆœì„œ ìˆ˜ìž… í–ˆë‹¤',0),(465572,12933,'he','×¤×§×•×“×•×ª ×™×•×‘××•',0),(465573,12933,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ ÎµÎ¹ÏƒÎ®Ï‡Î¸Î·ÏƒÎ±Î½',0),(465574,12933,'zh','æ²¡æœ‰è®¢å•è¢«å¯¼å…¥',0),(465575,12933,'sv','Inga order importerades',0),(465576,12933,'it','Nessun ordini sono stato importato',0),(465577,12933,'tl','',0),(465578,12933,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(465579,12933,'hi','à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤†à¤¯à¤¾à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¥à¥‡',0),(465580,12933,'ms','Pesanan tidak diimport',0),(465581,12933,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù„Ø§ Ø£ÙˆØ§Ù…Ø±',0),(465582,12933,'fr','Pas de commandes ont Ã©tÃ© importÃ©es',0),(465583,12933,'jp','æ³¨æ–‡ã¯ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã¾ã›ã‚“ã§ã—ãŸã€‚',0),(465584,12933,'pt','NÃ£o hÃ¡ ordens foram importados',0),(465585,12933,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð½Ðµ Ð±Ñ‹Ð»Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹',0),(465586,12933,'es','Ningunos Pedidos se Importaron',0),(465587,12933,'de','Keine AuftrÃ¤ge wurden importiert.',0),(465588,12933,'en','No Orders Were Imported',0),(465589,12934,'is','',0),(465590,12934,'dr','100 ÙØ±Ù…Ø§ÛŒØ´ Ø¯Ø± ÛŒÚ© Ø²Ù…Ø§Ù† Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(465591,12934,'pr','ÙÙ‚Ø· 100 Ø³ÙØ§Ø±Ø´ Ø¯Ø± ÛŒÚ© Ø²Ù…Ø§Ù† Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯ ',0),(465592,12934,'tr','Sadece 100 sipariÅŸlerini aynÄ± anda getirilebilir.',0),(465593,12934,'pl','Tylko 100 zamÃ³wieÅ„ moÅ¼e byÄ‡ wniesiona w jednym czasie.',0),(465594,12934,'bg','Ð¡Ð°Ð¼Ð¾ 100 Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ñ€ÐµÐ´ÑÐ²ÑÐ²Ð°Ð½Ð¸ ÐµÐ´Ð½Ð¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾.',0),(465595,12934,'ur','ØµØ±Ù 100 Ø§Ø­Ú©Ø§Ù… Ø§ÛŒÚ© ÙˆÙ‚Øª Ù…ÛŒÚº Ù„Ø§ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ ÛÛ’ Û”',0),(465596,12934,'sr','Ð¡Ð°Ð¼Ð¾ 100 Ð½Ð°Ð»Ð¾Ð³Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ñƒ Ñ˜ÐµÐ´Ð½Ð¾Ð¼ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚ÐºÑƒ Ð´Ð¾Ð²ÐµÐ´ÐµÐ½.',0),(465597,12934,'vi','Chá»‰ 100 Ä‘Æ¡n hÃ ng Ä‘Æ°á»£c mua vÃ o lÃºc nÃ y',0),(465598,12934,'af','Slegs 100 bestellings kan gebring word op een slag.',0),(465599,12934,'ro','Numai 100 comenzi poate fi adus Ã®n la un moment dat.',0),(465600,12934,'et','100 tellimust saab kasvanud samal ajal.',0),(465601,12934,'si','Samo 100 naroÄil se lahko obravnava v enem trenutku.',0),(465602,12934,'ba','Hanya 100 pesanan dapat dibawa pada satu waktu.',0),(465603,12934,'nl','Slechts 100 bestellingen kunnen op een bepaald moment worden gebracht.',0),(465604,12934,'fi','Vain 100 tilausta voi tuoda kerralla.',0),(465605,12934,'no','Bare 100 bestillinger kan bringes samtidig.',0),(465606,12934,'da','Kun 100 ordrer kan blive bragt pÃ¥ Ã©n gang.',0),(465607,12934,'ko','100 ì£¼ë¬¸ í•œ ë²ˆì— ê°€ì ¸ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(465608,12934,'he','×¨×§ 100 ×¤×§×•×“×•×ª ×™×›×•×œ ×œ×”×›× ×™×¡ ×‘×¢×ª ×•×‘×¢×•× ×” ××—×ª.',0),(465609,12934,'el','ÎœÏŒÎ½Î¿ 100 Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Ï€Î±ÏÎ¿Ï…ÏƒÎ¹Î±ÏƒÏ„Î¿ÏÎ½ Î¼Î­ÏƒÎ± ÏƒÎµ Î­Î½Î± Ï‡ÏÏŒÎ½Î¿.',0),(465610,12934,'zh','åªæœ‰ 100 ä»½è®¢å•å¯ä»¥å¸¦æ¥ä¸€æ¬¡ã€‚',0),(465611,12934,'sv','Endast 100 bestÃ¤llningar kan fÃ¶ras in pÃ¥ en gÃ¥ng.',0),(465612,12934,'it','Solo 100 ordini possono essere portati un tempo.',0),(465613,12934,'tl','',0),(465614,12934,'th','à¸ªà¸±à¹ˆà¸‡ 100 à¹€à¸—à¹ˆà¸²à¸ªà¸²à¸¡à¸²à¸£à¸–à¸ªà¸²à¸¡à¸²à¸£à¸–à¸™à¸³à¸¡à¸²à¹ƒà¸™à¸„à¸£à¸±à¹‰à¸‡à¹€à¸”à¸µà¸¢à¸§',0),(465615,12934,'hi','à¤•à¥‡à¤µà¤² 100 à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤à¤• à¤¹à¥€ à¤¸à¤®à¤¯ à¤®à¥‡à¤‚ à¤²à¤¾à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(465616,12934,'ms','Hanya 100 pesanan boleh dibawa dalam satu masa.',0),(465617,12934,'ar','Ø£ÙˆØ§Ù…Ø± ÙÙ‚Ø· 100 ÙŠÙ…ÙƒÙ† Ø£Ù† ØªØªØ­Ù‚Ù‚ ÙˆÙ‚Øª ÙˆØ§Ø­Ø¯.',0),(465618,12934,'fr','Seulement 100 commandes peuvent Ãªtre amenÃ©s en mÃªme temps.',0),(465619,12934,'jp','ã®ã¿ 100 æ³¨æ–‡åŒæ™‚ã«ã§ãã¾ã™ã€‚',0),(465620,12934,'pt','Apenas 100 ordens podem ser trazidas ao mesmo tempo.',0),(465621,12934,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ 100 Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¿Ñ€Ð¸Ð²Ð»ÐµÑ‡ÐµÐ½Ñ‹ Ð¾Ð´Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ñ.',0),(465622,12934,'es','Solamente 100 Pedidos se Puede Entrar a la Vez',0),(465623,12934,'de','Nur 100 Bestellungen kÃ¶nnen auf einmal eingebracht werden.',0),(465624,12934,'en','Only 100 orders can be brought in at one time.',0),(465625,12935,'is','',0),(465626,12935,'dr','Ù„Ø·ÙØ§ Ø§Ø¨ØªØ¯Ø§ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø³Ø¨Ø¯ Ø®Ø±ÛŒØ¯ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø±Ø§ ØªÙ†Ø¸ÛŒÙ… Ú©Ù†ÛŒØ¯ ',0),(465627,12935,'pr','Ù„Ø·ÙØ§ Ø§Ø¨ØªØ¯Ø§ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø³Ø¨Ø¯ Ø®Ø±ÛŒØ¯ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø±Ø§ ØªÙ†Ø¸ÛŒÙ… Ú©Ù†ÛŒØ¯ ',0),(465628,12935,'tr','LÃ¼tfen 3dcart ayarlarÄ±nÄ± ilk',0),(465629,12935,'pl','ProszÄ™ dostosowaÄ‡ ustawienia 3dcart pierwszy',0),(465630,12935,'bg','ÐšÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸Ñ‚Ðµ Ð½Ð° 3dcart Ð¿ÑŠÑ€Ð²Ð¸',0),(465631,12935,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ 3dcart Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº Ù…Ø·Ø§Ø¨Ù‚ Ø¨Ù†Ø§Ù†Û’ Ù¾ÛÙ„ÛŒ',0),(465632,12935,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¿Ñ€Ð²Ð¸',0),(465633,12935,'vi','vui lÃ²ng Ä‘iá»u chá»‰nh thiáº¿t láº­p 3dcart trÆ°á»›c',0),(465634,12935,'af','Pas asseblief 3dcart instellings eerste',0),(465635,12935,'ro','VÄƒ rugÄƒm sÄƒ ajustaÅ£i setÄƒrile de 3dcart prima',0),(465636,12935,'et','Palun 3dcart sÃ¤tteid reguleerida esimese',0),(465637,12935,'si','Prosimo prilagodite 3dcart nastavitve prvi',0),(465638,12935,'ba','Silahkan Sesuaikan pengaturan 3dcart pertama',0),(465639,12935,'nl','Wijzig 3dcart instellingen eerste',0),(465640,12935,'fi','SÃ¤Ã¤dÃ¤ 3dcart asetukset ensimmÃ¤inen',0),(465641,12935,'no','Juster innstillingene for 3dcart fÃ¸rste',0),(465642,12935,'da','Kan du justere indstillingerne for 3dcart fÃ¸rste',0),(465643,12935,'ko','3dcart ì„¤ì •ì„ ì¡°ì • í•˜ì‹­ì‹œì˜¤ ì²« ë²ˆì§¸',0),(465644,12935,'he','×‘×‘×§×©×” ×œ×”×ª××™× ××ª ×”×’×“×¨×•×ª 3dcart ×”×¨××©×•×Ÿ',0),(465645,12935,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÏÏ…Î¸Î¼Î¯ÏƒÎµÏ„Îµ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Ï„Î·Ï‚ 3dcart Ï€ÏÏŽÏ„Î·',0),(465646,12935,'zh','è¯·è°ƒæ•´ 3dcart è®¾ç½®ç¬¬ä¸€',0),(465647,12935,'sv','VÃ¤nligen justera instÃ¤llningarna fÃ¶r 3dcart fÃ¶rsta',0),(465648,12935,'it','Regolare impostazioni di 3dcart primo',0),(465649,12935,'tl','',0),(465650,12935,'th','à¸à¸£à¸¸à¸“à¸²à¸›à¸£à¸±à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² 3dcart à¹à¸£à¸',0),(465651,12935,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ 3dcart à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤ªà¤¹à¤²à¥€',0),(465652,12935,'ms','Sila ubah seting 3dcart pertama',0),(465653,12935,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¶Ø¨Ø· Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª 3dcart Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(465654,12935,'fr','Veuillez rÃ©gler les paramÃ¨tres de 3dcart premiÃ¨re',0),(465655,12935,'jp','3dcart ã®è¨­å®šã‚’èª¿æ•´ã—ã¦ãã ã•ã„æœ€åˆ',0),(465656,12935,'pt','Por favor, ajuste as configuraÃ§Ãµes 3dcart primeiro',0),(465657,12935,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ 3dcart Ð¿ÐµÑ€Ð²Ñ‹Ð¹',0),(465658,12935,'es','Por Favor Ajuste Primero la ConfiguraciÃ³n de 3DCarrito',0),(465659,12935,'de','Passen Sie 3dcart Einstellungen erste',0),(465660,12935,'en','Please Adjust 3dcart Settings First',0),(465661,12936,'is','',0),(465662,12936,'dr','Ù„Ø·ÙØ§ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ú©Ù†ÛŒØ¯',0),(465663,12936,'pr','Ù„Ø·ÙØ§ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ú©Ù†ÛŒØ¯',0),(465664,12936,'tr','LÃ¼tfen sipariÅŸlerinizi doÄŸrulayÄ±n',0),(465665,12936,'pl','SprawdÅº, czy Twoje zamÃ³wienia',0),(465666,12936,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(465667,12936,'ur','Ø¢Ù¾ Ú©Û’ Ø­Ú©Ù… Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(465668,12936,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(465669,12936,'vi','Vui lÃ²ng xÃ¡c nháº­n Ä‘Æ¡n Ä‘áº·t hÃ ng cá»§a báº¡n',0),(465670,12936,'af','Verifieer asseblief jou bestellings',0),(465671,12936,'ro','VÄƒ rugÄƒm sÄƒ verificaÅ£i dacÄƒ comenzile dumneavoastra',0),(465672,12936,'et','Palun kontrollige oma tellimust',0),(465673,12936,'si','Prosimo, preverite vaÅ¡e naloge',0),(465674,12936,'ba','Harap verifikasi pesanan Anda',0),(465675,12936,'nl','Controleer of uw bestellingen',0),(465676,12936,'fi','Tarkista tilauksesi',0),(465677,12936,'no','Kontroller bestillinger',0),(465678,12936,'da','BekrÃ¦ft din ordrer',0),(465679,12936,'ko','ë‹¹ì‹ ì˜ ìˆœì„œë¥¼ í™•ì¸ í•˜ì‹­ì‹œì˜¤',0),(465680,12936,'he','× × ×•×“× ××ª ×”×¤×§×•×“×•×ª ×©×œ×š',0),(465681,12936,'el','Î•Ï€Î±Î»Î·Î¸ÎµÏÏƒÏ„Îµ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÏƒÎ±Ï‚',0),(465682,12936,'zh','è¯·ç¡®è®¤æ‚¨çš„è®¢å•',0),(465683,12936,'sv','VÃ¤nligen kontrollera dina bestÃ¤llningar',0),(465684,12936,'it','Verificare i tuoi ordini',0),(465685,12936,'tl','',0),(465686,12936,'th','à¹‚à¸›à¸£à¸”à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(465687,12936,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤ªà¤¨à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿',0),(465688,12936,'ms','Sila sahkan pesanan anda',0),(465689,12936,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(465690,12936,'fr','S\'il vous plaÃ®t vÃ©rifier vos commandes',0),(465691,12936,'jp','ã”æ³¨æ–‡ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(465692,12936,'pt','Por favor, verifique se as suas ordens',0),(465693,12936,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð²Ð°ÑˆÐ¸ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(465694,12936,'es','Por favor verifique sus Ã³rdenes',0),(465695,12936,'de','Bitte Ã¼berprÃ¼fen Sie Ihre Bestellungen',0),(465696,12936,'en','Please Verify Your Orders',0),(465697,12937,'is','',0),(465698,12937,'dr','.',0),(465699,12937,'pr','ØªÙ†Ø¸ÛŒÙ… Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ø¨Ø±Ø§ÛŒ Ú¯Ø±ÙØªÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø² Ø¢Ù† Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±.',0),(465700,12937,'tr','Bu fatura numarasÄ± sipariÅŸleri almak iÃ§in bir fatura numarasÄ± kÃ¼me.',0),(465701,12937,'pl','Zestaw numer faktury, aby zamÃ³wienia z tego numeru faktury.',0),(465702,12937,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð·Ð° Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð½Ð°.',0),(465703,12937,'ur','Ø§Ø³ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù†Ù…Ø¨Ø± Ø³Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ø­Ø§ØµÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Û”',0),(465704,12937,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð´Ð° Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ð¼ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð¸Ð· Ñ‚Ð°Ñ˜ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ.',0),(465705,12937,'vi','Thiáº¿t láº­p sá»‘ hÃ³a Ä‘Æ¡n Ä‘á»ƒ cÃ³ Ä‘Æ¡n Ä‘áº·t hÃ ng tá»« sá»‘ hÃ³a Ä‘Æ¡n Ä‘Ã³',0),(465706,12937,'af','Stel \'n faktuur nommer kry bestellings uit daardie faktuur nommer.',0),(465707,12937,'ro','SetaÅ£i un numÄƒr de facturÄƒ pentru a obÅ£ine comenzi la care numÄƒrul facturii.',0),(465708,12937,'et','MÃ¤Ã¤ra arve numbrit saada tellimuse arve number.',0),(465709,12937,'si','Nastavite Å¡tevilko raÄuna zadobiti naroÄila s to Å¡tevilko raÄuna.',0),(465710,12937,'ba','Mengatur nomor Invoice untuk mendapatkan pesanan dari nomor faktur itu pada.',0),(465711,12937,'nl','Stel een factuurnummer om bestellingen van die factuurnummer op.',0),(465712,12937,'fi','MÃ¤Ã¤ritÃ¤ laskunumero saada tilaukset laskunumero.',0),(465713,12937,'no','Angi et fakturanummer fÃ¥ bestillinger fra at fakturanummeret.',0),(465714,12937,'da','Angive et fakturanummer at fÃ¥ ordrer fra denne fakturanummeret.',0),(465715,12937,'ko','ê·¸ ì†¡ìž¥ ë²ˆí˜¸ì—ì„œ ìˆœì„œë¥¼ ì–»ì„ì— ì†¡ìž¥ ë²ˆí˜¸ë¥¼ ì„¤ì • í•©ë‹ˆë‹¤.',0),(465716,12937,'he','×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª ×œ×§×‘×œ ×”×–×ž× ×•×ª ××ª ×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª ×”×’×“×¨.',0),(465717,12937,'el','ÎŸÏÎ¯ÏƒÏ„Îµ Î­Î½Î±Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Î½Î± Ï€ÏÎ¿Ï‡Ï‰ÏÎ®ÏƒÎ¿Ï…Î¼Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Ï€ÏŒ ÎµÎºÎµÎ¯Î½Î¿ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï….',0),(465718,12937,'zh','è®¾ç½®å‘ç¥¨ç¼–å·ï¼Œä»¥å¾—åˆ°è®¢å•ï¼Œå‘ç¥¨ç¼–å·ã€‚',0),(465719,12937,'sv','Ange ett fakturanummer fÃ¶r att fÃ¥ order frÃ¥n det fakturanumret.',0),(465720,12937,'it','Impostare un numero di fattura per ricevere ordini da quel numero di fattura su.',0),(465721,12937,'tl','',0),(465722,12937,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸ˆà¸°à¹„à¸”à¹‰à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ˆà¸²à¸à¹€à¸¥à¸‚à¸—à¸µà¹ˆà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸™',0),(465723,12937,'hi','à¤à¤• à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤‰à¤¸ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚à¥¤',0),(465724,12937,'ms','Menetapkan satu nombor invois untuk mendapatkan pesanan dari nombor invois itu.',0),(465725,12937,'ar','ØªØ¹ÙŠÙŠÙ† \"Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©\" Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø± Ù…Ù† Ø°Ù„Ùƒ Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¹Ù„Ù‰.',0),(465726,12937,'fr','DÃ©finissez un numÃ©ro de facture pour obtenir des commandes de ce numÃ©ro de facture.',0),(465727,12937,'jp','ãã®è«‹æ±‚æ›¸ç•ªå·ã‹ã‚‰ã®æ³¨æ–‡ã‚’å–å¾—ã™ã‚‹ã«ã¯ã€è«‹æ±‚æ›¸ç•ªå·ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(465728,12937,'pt','Defina um nÃºmero de factura para obter as ordens desse nÃºmero de factura.',0),(465729,12937,'ru','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð¾Ñ‚ ÑÑ‚Ð¾Ð³Ð¾ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð½Ð°.',0),(465730,12937,'es','Configurar un NÃºmero de Factura Para Conseguir Desde Esa Factura en Adelante',0),(465731,12937,'de','Legen Sie eine Rechnungsnummer, Bestellungen von dieser Rechnung Zahl zu erhalten, auf.',0),(465732,12937,'en','Set an Invoice Number to get orders from that invoice number on.',0),(465733,12938,'is','',0),(465734,12938,'dr','Ù„ÛŒØ³Øª Ø¢Ù…Ø§Ø± ÙˆØ±ÙˆØ¯ÛŒ Ø´ØºÙ„ ',0),(465735,12938,'pr','Ù„ÛŒØ³Øª Ø¢Ù…Ø§Ø± ÙˆØ±ÙˆØ¯ÛŒ Ø´ØºÙ„ ',0),(465736,12938,'tr','Ä°ÅŸ giriÅŸ istatistikleri listesi',0),(465737,12938,'pl','Lista zadaÅ„ wejÅ›cia statystyki',0),(465738,12938,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(465739,12938,'ur','Ú©Ø§Ù… ÙÛØ±Ø³Øª Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ÙˆØ´Ù…Ø§Ø±',0),(465740,12938,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¡Ñ‚Ð°Ñ‚Ñ ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ð¾ÑÐ»Ð°',0),(465741,12938,'vi','ghi danh sÃ¡ch tÃ¬nh tráº¡ng cÃ´ng viá»‡c',0),(465742,12938,'af','Werk inskrywing verbruikerstatistieke lys',0),(465743,12938,'ro','Lista de statistici Job intrare',0),(465744,12938,'et','TÃ¶Ã¶ Stats loendis',0),(465745,12938,'si','Delo vstop statistika seznam',0),(465746,12938,'ba','Daftar pekerjaan entri Statistik',0),(465747,12938,'nl','Baan Entry Stats lijst',0),(465748,12938,'fi','Projektin tilastot maahantulokieltoluetteloon',0),(465749,12938,'no','OppfÃ¸ringen statistikk jobblisten',0),(465750,12938,'da','Posten statistik joblisten',0),(465751,12938,'ko','ìž‘ì—… í•­ëª© í†µê³„ ëª©ë¡',0),(465752,12938,'he','×¨×©×™×ž×ª ×”×¢×‘×•×“×•×ª ×›× ×™×¡×” ×¡×˜×˜×™×¡×˜×™×§×”',0),(465753,12938,'el','Î›Î¯ÏƒÏ„Î± ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ Î­Î½Î±ÏÎ¾Î· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(465754,12938,'zh','å·¥ä½œæ¡ç›®ç»Ÿè®¡åˆ—è¡¨',0),(465755,12938,'sv','Posten statistik jobblistan',0),(465756,12938,'it','Lista di lavoro voce Stats',0),(465757,12938,'tl','',0),(465758,12938,'th','à¸‡à¸²à¸™à¸ªà¸–à¸´à¸•à¸´à¸£à¸²à¸¢à¸à¸²à¸£',0),(465759,12938,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤†à¤à¤•à¤¡à¤¼à¥‡ à¤¸à¥‚à¤šà¥€',0),(465760,12938,'ms','Senarai statistik kemasukan kerja',0),(465761,12938,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø¯Ø®ÙˆÙ„ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(465762,12938,'fr','Liste des Stats Job',0),(465763,12938,'jp','ã‚¸ãƒ§ãƒ– ã‚¨ãƒ³ãƒˆãƒªã®çµ±è¨ˆæƒ…å ±ãƒªã‚¹ãƒˆ',0),(465764,12938,'pt','Lista de estatÃ­sticas do trabalho entrada',0),(465765,12938,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°Ð´Ð°Ð½Ð¸Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(465766,12938,'es','Estadisticas de Lista de Inicia de Trabajo',0),(465767,12938,'de','Job-Eintrag-Stats-Liste',0),(465768,12938,'en','Job Entry Stats List',0),(465769,12939,'is','',0),(465770,12939,'dr',' Ø´Ø®Øµ  Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´',0),(465771,12939,'pr',' Ø´Ø®Øµ  Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´',0),(465772,12939,'tr','SipariÅŸ giriÅŸi kiÅŸi',0),(465773,12939,'pl','KolejnoÅ›ci wpisu osoby',0),(465774,12939,'bg','Ð ÐµÐ´ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð»Ð¸Ñ†Ðµ',0),(465775,12939,'ur','Ø¢Ø±ÚˆØ± Ø§Ù†Ù¹Ø±ÛŒ Ø´Ø®Øµ',0),(465776,12939,'sr','Ð ÐµÐ´ Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð¾ÑÐ¾Ð±Ð°',0),(465777,12939,'vi','Nháº­p Ä‘Æ¡n hÃ ng cÃ¡ nhÃ¢n',0),(465778,12939,'af','Orde inskrywing persoon',0),(465779,12939,'ro','Ordine de intrare persoana',0),(465780,12939,'et','Tellimuse kande isik',0),(465781,12939,'si','Vrstni red vnosa oseba',0),(465782,12939,'ba','Urutan entri orang',0),(465783,12939,'nl','Order Entry persoon',0),(465784,12939,'fi','Tilata merkintÃ¤ henkilÃ¶',0),(465785,12939,'no','Bestille oppfÃ¸ring Person',0),(465786,12939,'da','Orden post Person',0),(465787,12939,'ko','ì£¼ë¬¸ í•­ëª© ì‚¬ëžŒ',0),(465788,12939,'he','×¡×“×¨ ×”×›× ×™×¡×” ×œ××“×',0),(465789,12939,'el','Î‘Î¯Ï„Î·ÏƒÎ· ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… Ï€ÏÏŒÏƒÏ‰Ï€Î¿',0),(465790,12939,'zh','è®¢å•æ¡ç›®çš„äºº',0),(465791,12939,'sv','Order Entry Person',0),(465792,12939,'it','Ordine entrata persona',0),(465793,12939,'tl','',0),(465794,12939,'th','à¸ªà¸±à¹ˆà¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸¸à¸„à¸„à¸¥',0),(465795,12939,'hi','à¤•à¥à¤°à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿',0),(465796,12939,'ms','Perintah kemasukan orang',0),(465797,12939,'ar','Ø£Ù…Ø± Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø´Ø®Øµ',0),(465798,12939,'fr','Commande entrÃ©e personne',0),(465799,12939,'jp','æ³¨æ–‡å…¥åŠ›æ‹…å½“è€…',0),(465800,12939,'pt','Pessoa de entrada de ordem',0),(465801,12939,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð²ÑŠÐµÐ·Ð´Ð° Ð»Ð¸Ñ†Ð°',0),(465802,12939,'es','Person de Entrar Pedidos',0),(465803,12939,'de','Order Entry Person',0),(465804,12939,'en','Order Entry Person',0),(465805,12940,'is','',0),(465806,12940,'dr','(ÙˆÙ„Ø§ÛŒØª )Ø«Ø¨Øª ÙØ±Ù…Ø§ÛŒØ´  ',0),(465807,12940,'pr',' ÙˆØ¶Ø¹ÛŒØª(Ø§Ø³ØªØ§Ù†)Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´  ',0),(465808,12940,'tr','SipariÅŸ giriÅŸ istatistikleri',0),(465809,12940,'pl','KolejnoÅ›Ä‡ wprowadzania statystyki',0),(465810,12940,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð·Ð° Ð·Ð°Ð¿Ð¸Ñ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(465811,12940,'ur','Ø¢Ø±ÚˆØ± Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ÙˆØ´Ù…Ø§Ø±',0),(465812,12940,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(465813,12940,'vi','Nháº­p Ä‘Æ¡n hÃ ng Stats',0),(465814,12940,'af','Orde inskrywing statistiek',0),(465815,12940,'ro','Ordine de intrare statistici',0),(465816,12940,'et','Tellimuse kanne Stats',0),(465817,12940,'si','Vrstni red vnosa statistika',0),(465818,12940,'ba','Urutan catatan statistik',0),(465819,12940,'nl','Order Entry Stats',0),(465820,12940,'fi','Jotta tapahtuma tilastot',0),(465821,12940,'no','Bestille oppfÃ¸ring statistikk',0),(465822,12940,'da','Orden post statistik',0),(465823,12940,'ko','ì£¼ë¬¸ í•­ëª© í†µê³„',0),(465824,12940,'he','×”×¡×“×¨ ×›× ×™×¡×” ×¡×˜×˜×™×¡×˜×™×§×”',0),(465825,12940,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(465826,12940,'zh','è®¢å•æ¡ç›®ç»Ÿè®¡',0),(465827,12940,'sv','Order Entry statistik',0),(465828,12940,'it','Ordine entrata Stats',0),(465829,12940,'tl','',0),(465830,12940,'th','à¸ªà¸–à¸´à¸•à¸´à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(465831,12940,'hi','à¤•à¥à¤°à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤†à¤à¤•à¤¡à¤¼à¥‡',0),(465832,12940,'ms','Statistik kemasukan perintah',0),(465833,12940,'ar','Ø¥Ø­ØµØ§Ø¦ÙŠØ§Øª Ø¯Ø®ÙˆÙ„ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(465834,12940,'fr','Commande entrÃ©e Stats',0),(465835,12940,'jp','æ³¨æ–‡ã‚¨ãƒ³ãƒˆãƒªã®çµ±è¨ˆæƒ…å ±',0),(465836,12940,'pt','EstatÃ­sticas de entrada de ordem',0),(465837,12940,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(465838,12940,'es','Estadisticas de Entrar Pedidos',0),(465839,12940,'de','Bestellung-Eintrag-Statistik',0),(465840,12940,'en','Order Entry Stats',0),(465841,12941,'is','',0),(465842,12941,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø²Ù…Ø§Ù† Ù¾ÛŒÚ¯ÛŒØ±ÛŒ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(465843,12941,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø²Ù…Ø§Ù† Ù¾ÛŒÚ¯ÛŒØ±ÛŒ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(465844,12941,'tr','Ã‡alÄ±ÅŸanÄ±n zaman izleme ekleme',0),(465845,12941,'pl','Dodaj czas pracownik Å›ledzenie',0),(465846,12941,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð²Ñ€ÐµÐ¼Ðµ',0),(465847,12941,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Û’ ÙˆÙ‚Øª Ø³Ø±Ø§Øº Ø±Ø§Û Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(465848,12941,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐ°',0),(465849,12941,'vi','ThÃªm hiá»‡u chá»‰nh thá»i gian nhan viÃªn',0),(465850,12941,'af','Voeg werknemer tyd dop',0),(465851,12941,'ro','Adauga timp angajat de urmÄƒrire',0),(465852,12941,'et','Lisada tÃ¶Ã¶taja aja jÃ¤lgimine',0),(465853,12941,'si','Dodaj zaposlenega Äasu sledenja',0),(465854,12941,'ba','Tambahkan karyawan waktu pelacakan',0),(465855,12941,'nl','Toevoegen van werknemer Time Tracking',0),(465856,12941,'fi','LisÃ¤Ã¤ tyÃ¶ntekijÃ¤ kertaa seurantakoodin',0),(465857,12941,'no','Legge til ansattes tid sporingsprogrammer',0),(465858,12941,'da','TilfÃ¸je medarbejder tid Tracking',0),(465859,12941,'ko','ì§ì› ì‹œê°„ ì¶”ì  ì¶”ê°€',0),(465860,12941,'he','×œ×”×•×¡×™×£ ×–×ž×Ÿ ×”×¢×•×‘×“ ×ž×¢×§×‘',0),(465861,12941,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿ Ï‡ÏÏŒÎ½Î¿Ï‚ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚',0),(465862,12941,'zh','æ·»åŠ å‘˜å·¥çš„æ—¶é—´è·Ÿè¸ª',0),(465863,12941,'sv','LÃ¤gg till anstÃ¤lldas tidredovisning',0),(465864,12941,'it','Aggiungi tempo dipendente di monitoraggio',0),(465865,12941,'tl','',0),(465866,12941,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸§à¸¥à¸²à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸•à¸´à¸”à¸•à¸²à¸¡',0),(465867,12941,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¸à¤®à¤¯ à¤ªà¤° à¤¨à¤œà¤¼à¤° à¤°à¤–à¤¨à¥‡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(465868,12941,'ms','Tambah pengesanan masa pekerja',0),(465869,12941,'ar','Ø¥Ø¶Ø§ÙØ© ØªØªØ¨Ø¹ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ù…ÙˆØ¸Ù',0),(465870,12941,'fr','Ajouter le suivi du temps employÃ©',0),(465871,12941,'jp','å¾“æ¥­å“¡ã®æ™‚é–“ãƒˆãƒ©ãƒƒã‚­ãƒ³ã‚°ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(465872,12941,'pt','Adicionar o controle de tempo empregado',0),(465873,12941,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ñ‚ÑŒ',0),(465874,12941,'es','Agregar Rastreo de Horas de Empleado',0),(465875,12941,'de','HinzufÃ¼gen von Mitarbeiter-Zeiterfassung',0),(465876,12941,'en','Add Employee Time Tracking',0),(465877,12942,'is','',0),(465878,12942,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ ÙˆÙ¾ÛŒÚ¯ÛŒØ±ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ ',0),(465879,12942,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø³ÙØ§Ø±Ø´ ÙˆÙ¾ÛŒÚ¯ÛŒØ±ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ ',0),(465880,12942,'tr','SipariÅŸ & envanter izleme ekleme',0),(465881,12942,'pl','DodaÄ‡ zamÃ³wienie & zapasy w handlu holowanie',0),(465882,12942,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ñ€ÐµÐ´ & Ð¾Ð¿Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(465883,12942,'ur','ØªØ±ØªÛŒØ¨ & Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø³Ø±Ø§Øº Ø±Ø§Û Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(465884,12942,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° & Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(465885,12942,'vi','ThÃªm lá»‹ch hiá»‡u chá»‰nh Ä‘Æ¡n hÃ ng vÃ  hÃ ng tá»“n kho',0),(465886,12942,'af','Voeg orde & voorraad dop',0),(465887,12942,'ro','Adauga ordinea & inventar de urmÄƒrire',0),(465888,12942,'et','Lisada tellimuse & laoseisu jÃ¤lgimine',0),(465889,12942,'si','Dodaj naroÄilo & inventar tir',0),(465890,12942,'ba','Tambahkan perintah & pelacakan inventaris',0),(465891,12942,'nl','Toevoegen van orde & inventaris het volgen',0),(465892,12942,'fi','LisÃ¤Ã¤ tilaus & varaston seuranta',0),(465893,12942,'no','Legge til rekkefÃ¸lgen & lagertelling',0),(465894,12942,'da','TilfÃ¸j Order & lagersporing',0),(465895,12942,'ko','ì¶”ê°€ ì£¼ë¬¸ & ìž¬ê³  ì¶”ì ',0),(465896,12942,'he','×œ×”×•×¡×™×£ ×¡×“×¨ & × ×™×”×•×œ ×ž×¢×§×‘ ××—×¨ ×ž×¦××™',0),(465897,12942,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¬Î¾Î· & Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(465898,12942,'zh','æ·»åŠ è®¢å• &amp; åº“å­˜è·Ÿè¸ª',0),(465899,12942,'sv','LÃ¤gg till ordning & inventering spÃ¥rning',0),(465900,12942,'it','Aggiungi ordine & Inventory Tracking',0),(465901,12942,'tl','',0),(465902,12942,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ & à¸•à¸´à¸”à¸•à¸²à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(465903,12942,'hi','à¤†à¤¦à¥‡à¤¶ & à¤¸à¥‚à¤šà¥€ à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(465904,12942,'ms','Menambah perintah & Penjejakan Inventori',0),(465905,12942,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù…Ø± Ø¢Ù†Ø¯ ØªØªØ¨Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(465906,12942,'fr','Ajouter la commande & de suivi de l\'inventaire',0),(465907,12942,'jp','è¿½åŠ æ³¨æ–‡ & åœ¨åº«ã‚’è¿½è·¡ã—ã¾ã™ã€‚',0),(465908,12942,'pt','Adicionar ordem & controle de estoque',0),(465909,12942,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð· & Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð½Ð¾Ð³Ð¾ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ñ',0),(465910,12942,'es','Agregar Rastreo de Pedidos & Inventario',0),(465911,12942,'de','FÃ¼gen Sie Bestellung & \"InventarÃ¼berwachung hinzu\"',0),(465912,12942,'en','Add Order & Inventory Tracking',0),(465913,12943,'is','',0),(465914,12943,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(465915,12943,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(465916,12943,'tr','Bordro paketine ekleyin',0),(465917,12943,'pl','Dodaj listy pÅ‚ac Suite',0),(465918,12943,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ñ‚Ð° Ð°Ð¿Ð°Ñ€Ñ‚Ð°Ð¼ÐµÐ½Ñ‚',0),(465919,12943,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ø³ÙˆÙ¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(465920,12943,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð°Ð¿Ð°Ñ€Ñ‚Ð¼Ð°Ð½',0),(465921,12943,'vi','ThÃªm pháº§n thanh toÃ¡n lÆ°Æ¡ng',0),(465922,12943,'af','Voeg heeltydse Suite',0),(465923,12943,'ro','Adauga salarizare Suite',0),(465924,12943,'et','Lisada palgaarvestuse sviit',0),(465925,12943,'si','Dodaj Payroll Suite',0),(465926,12943,'ba','Tambahkan penggajian Suite',0),(465927,12943,'nl','Toevoegen van Payroll Suite',0),(465928,12943,'fi','LisÃ¤tÃ¤ palkanlaskennan Suite',0),(465929,12943,'no','Legge til lÃ¸nn Suite',0),(465930,12943,'da','TilfÃ¸je lÃ¸nningslisten Suite',0),(465931,12943,'ko','ì¶”ê°€ ê¸‰ì—¬ ìŠ¤ìœ„íŠ¸',0),(465932,12943,'he','×œ×”×•×¡×™×£ ×©×›×¨ ×¡×•×•×™×˜×”',0),(465933,12943,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ ÏƒÎ¿Ï…Î¯Ï„Î±',0),(465934,12943,'zh','æ·»åŠ å·¥èµ„å•å¥—ä»¶',0),(465935,12943,'sv','LÃ¤gg till lÃ¶nelistan Suite',0),(465936,12943,'it','Aggiungi Suite paghe',0),(465937,12943,'tl','',0),(465938,12943,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸—',0),(465939,12943,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤¸à¥à¤‡à¤Ÿ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(465940,12943,'ms','Tambah gaji Suite',0),(465941,12943,'ar','Ø¥Ø¶Ø§ÙØ© Ø¬Ù†Ø§Ø­ ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(465942,12943,'fr','Ajouter paie Suite',0),(465943,12943,'jp','çµ¦ä¸Žã‚¹ã‚¤ãƒ¼ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(465944,12943,'pt','Adicione a folha de pagamento Suite',0),(465945,12943,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð›ÑŽÐºÑ',0),(465946,12943,'es','Agregar Suite de Nomina',0),(465947,12943,'de','Payroll-Suite hinzufÃ¼gen',0),(465948,12943,'en','Add Payroll Suite',0),(465949,12944,'is','',0),(465950,12944,'dr','ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ø§Ø±ØªÙ‚Ø§Ø¡',0),(465951,12944,'pr','ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ø§Ø±ØªÙ‚Ø§Ø¡',0),(465952,12944,'tr','Ã–zellik yÃ¼kseltme',0),(465953,12944,'pl','Uaktualnienia funkcji',0),(465954,12944,'bg','ÐªÐ¿Ð³Ñ€ÐµÐ¹Ð´ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(465955,12944,'ur','Ø¯Ø±Ø¬Û Ø§ÙØ²ÙˆÚº Ø®ØµÙˆØµÛŒØ§Øª',0),(465956,12944,'sr','ÐÐ°Ð´Ð¾Ð³Ñ€Ð°Ð´Ð¸Ñ‚Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ',0),(465957,12944,'vi','TÃ­nh nÄƒng nÃ¢ng cáº¥p',0),(465958,12944,'af','Gradeer kenmerke',0),(465959,12944,'ro','FaceÅ£i upgrade caracteristici',0),(465960,12944,'et','Upgrade funktsioonid',0),(465961,12944,'si','Nadgraditi funkcije',0),(465962,12944,'ba','Meng-upgrade fitur',0),(465963,12944,'nl','Upgrade functies',0),(465964,12944,'fi','Ylennyksen ominaisuudet',0),(465965,12944,'no','Oppgradere funksjoner',0),(465966,12944,'da','Opgradere funktioner',0),(465967,12944,'ko','ì—…ê·¸ë ˆì´ë“œ ê¸°ëŠ¥',0),(465968,12944,'he','×ª×›×•× ×•×ª ×”×©×“×¨×•×’',0),(465969,12944,'el','Î”Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„ÎµÏ‚ Î±Î½Î±Î²Î¬Î¸Î¼Î¹ÏƒÎ·Ï‚',0),(465970,12944,'zh','å‡çº§åŠŸèƒ½',0),(465971,12944,'sv','Uppgradera funktioner',0),(465972,12944,'it','Aggiornamento caratteristiche',0),(465973,12944,'tl','',0),(465974,12944,'th','à¸­à¸±à¸žà¹€à¸à¸£à¸”à¸¥à¸±à¸à¸©à¸“à¸°à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™',0),(465975,12944,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾à¤“à¤‚ à¤•à¤¾ à¤‰à¤¨à¥à¤¨à¤¯à¤¨',0),(465976,12944,'ms','Menaik taraf ciri-ciri',0),(465977,12944,'ar','ØªØ±Ù‚ÙŠØ© Ø§Ù„Ù…ÙŠØ²Ø§Øª',0),(465978,12944,'fr','FonctionnalitÃ©s de mise Ã  niveau',0),(465979,12944,'jp','æ©Ÿèƒ½ã‚’ã‚¢ãƒƒãƒ—ã‚°ãƒ¬ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(465980,12944,'pt','Atualizar recursos',0),(465981,12944,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¾Ð²',0),(465982,12944,'es','CaracterÃ­sticas de actualizaciÃ³n',0),(465983,12944,'de','Upgrade-Funktionen',0),(465984,12944,'en','Upgrade Features',0),(465985,12945,'is','',0),(465986,12945,'dr','Ø¢ÛŒØ§ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ù‡Ø¨ÙˆØ¯ Ø§Ù…Ú©Ø§Ù†Ø§Øª Ø§Ø³Øª ',0),(465987,12945,'pr','Ø¢ÛŒØ§ Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ù‡Ø¨ÙˆØ¯ Ø§Ù…Ú©Ø§Ù†Ø§Øª Ø§Ø³Øª ',0),(465988,12945,'tr','Bulut yÃ¼kseltme Ã¶zellikleri',0),(465989,12945,'pl','Chmura uaktualnienia funkcji',0),(465990,12945,'bg','ÐžÐ±Ð»Ð°Ðº ÑŠÐ¿Ð³Ñ€ÐµÐ¹Ð´ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(465991,12945,'ur','Ø¨Ø§Ø¯Ù„ Ø¯Ø±Ø¬Û Ø§ÙØ²ÙˆÚº Ø®ØµÙˆØµÛŒØ§Øª',0),(465992,12945,'sr','ÐžÐ±Ð»Ð°Ðº Ð½Ð°Ð´Ð¾Ð³Ñ€Ð°Ð´ÑšÑƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ',0),(465993,12945,'vi','ÄÃ¡m mÃ¢y nÃ¢ng cáº¥p tÃ­nh nÄƒng',0),(465994,12945,'af','Wolk opgradering kenmerke',0),(465995,12945,'ro','Nor caracteristici actualizare',0),(465996,12945,'et','Pilv uuendamise funktsioonid',0),(465997,12945,'si','Oblak nadgradnjo funkcije',0),(465998,12945,'ba','Fitur Upgrade awan',0),(465999,12945,'nl','Wolk Upgrade functies',0),(466000,12945,'fi','Pilvi pÃ¤ivityksen ominaisuudet',0),(466001,12945,'no','Sky oppgradere funksjoner',0),(466002,12945,'da','Cloud opgradering funktioner',0),(466003,12945,'ko','í´ë¼ìš°ë“œ ì—…ê·¸ë ˆì´ë“œ ê¸°ëŠ¥',0),(466004,12945,'he','×ª×›×•× ×•×ª ×”×©×“×¨×•×’ ×¢× ×Ÿ',0),(466005,12945,'el','Î£ÏÎ½Î½ÎµÏ†Î¿ Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„ÎµÏ‚ Î±Î½Î±Î²Î¬Î¸Î¼Î¹ÏƒÎ·Ï‚',0),(466006,12945,'zh','äº‘å‡çº§åŠŸèƒ½',0),(466007,12945,'sv','Moln uppgradera funktioner',0),(466008,12945,'it','Aggiornamento funzionalitÃ  cloud',0),(466009,12945,'tl','',0),(466010,12945,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸›à¸£à¸±à¸šà¸£à¸¸à¹ˆà¸™à¹€à¸¡à¸†',0),(466011,12945,'hi','à¤‰à¤¨à¥à¤¨à¤¤ à¤¸à¥à¤µà¤¿à¤§à¤¾à¤“à¤‚ à¤•à¥‡ à¤¬à¤¾à¤¦à¤²',0),(466012,12945,'ms','Ciri-ciri peningkatan awan',0),(466013,12945,'ar','Ø³Ø­Ø§Ø¨Ø© ØªØ±Ù‚ÙŠØ© Ø§Ù„Ù…ÙŠØ²Ø§Øª',0),(466014,12945,'fr','FonctionnalitÃ©s de mise Ã  niveau de nuage',0),(466015,12945,'jp','ã‚¯ãƒ©ã‚¦ãƒ‰ ãƒ» ã‚¢ãƒƒãƒ—ã‚°ãƒ¬ãƒ¼ãƒ‰æ©Ÿèƒ½',0),(466016,12945,'pt','Recursos de atualizaÃ§Ã£o de nuvem',0),(466017,12945,'ru','ÐžÑÐ¾Ð±ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð¾Ð±Ð»Ð°ÐºÐµ',0),(466018,12945,'es','CaracterÃ­sticas de Actualizaciones Cloud',0),(466019,12945,'de','Wolke-Upgrade-Funktionen',0),(466020,12945,'en','Cloud Upgrade Features',0),(466021,12946,'is','',0),(466022,12946,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ø§Ø² Ú†Ù†Ø¯ Ø§Ø±Ø²',0),(466023,12946,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ø§Ø² Ú†Ù†Ø¯ Ø§Ø±Ø²',0),(466024,12946,'tr','Ã‡oklu para birimi desteÄŸini eklemeniz',0),(466025,12946,'pl','Dodanie obsÅ‚ugi wielu walut',0),(466026,12946,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¼Ð½Ð¾Ð³Ð¾Ð²Ð°Ð»ÑƒÑ‚Ð½Ð° Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(466027,12946,'ur','Ú©Ø«ÛŒØ± Ú©Ø±Ù†Ø³ÛŒ Ú©ÛŒ Ø­Ù…Ø§ÛŒØª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(466028,12946,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÐ° Ð²Ð¸ÑˆÐµ Ð²Ð°Ð»ÑƒÑ‚Ð° Ð¿Ð¾Ð´Ñ€ÑˆÐºÐ°',0),(466029,12946,'vi','ThÃªm há»— trá»£ Ä‘a tiá»n tá»‡',0),(466030,12946,'af','Voeg multi geldeenheid ondersteuning',0),(466031,12946,'ro','Adauga multi-valutÄƒ de sprijin',0),(466032,12946,'et','Lisada mitme valuuta toetust',0),(466033,12946,'si','Dodaj podporo multi-valute',0),(466034,12946,'ba','Tambahkan dukungan multi-mata uang',0),(466035,12946,'nl','Multi-valuta ondersteuning toevoegen',0),(466036,12946,'fi','LisÃ¤tÃ¤ usean valuutan tuki',0),(466037,12946,'no','Legge til stÃ¸tte for flere valutaer',0),(466038,12946,'da','FÃ¸je understÃ¸ttelse af Multi-valuta',0),(466039,12946,'ko','ë‹¤ì¤‘ í†µí™” ì§€ì›',0),(466040,12946,'he','×œ×”×•×¡×™×£ ×ž×˜×‘×¢ ×¨×™×‘×•×™ ×ª×ž×™×›×”',0),(466041,12946,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ Ï…Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î· Ï€Î¿Î»Ï…-Î½Î¿Î¼Î¯ÏƒÎ¼Î±Ï„Î¿Ï‚',0),(466042,12946,'zh','æ·»åŠ å¤šå¸ç§çš„æ”¯æŒ',0),(466043,12946,'sv','LÃ¤gga till flera valutor stÃ¶d',0),(466044,12946,'it','Aggiungere il supporto multi-valuta',0),(466045,12946,'tl','',0),(466046,12946,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸²à¸£à¸ªà¸™à¸±à¸šà¸ªà¸™à¸¸à¸™à¸«à¸¥à¸²à¸¢à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™',0),(466047,12946,'hi','à¤¬à¤¹à¥ à¤®à¥à¤¦à¥à¤°à¤¾ à¤¸à¤®à¤°à¥à¤¥à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(466048,12946,'ms','Menambah sokongan pelbagai Mata Wang',0),(466049,12946,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¯Ø¹Ù… Ø§Ù„Ù…ØªØ¹Ø¯Ø¯ Ø§Ù„Ø¹Ù…Ù„Ø§Øª',0),(466050,12946,'fr','Ajouter multi-devise',0),(466051,12946,'jp','è¤‡æ•°é€šè²¨ã®ã‚µãƒãƒ¼ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(466052,12946,'pt','Adicionar suporte multi-moeda',0),(466053,12946,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÑƒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¸Ñ… Ð²Ð°Ð»ÑŽÑ‚',0),(466054,12946,'es','Agregar Soporte para Multi-Divisas',0),(466055,12946,'de','Multi-Currency-UnterstÃ¼tzung hinzufÃ¼gen',0),(466056,12946,'en','Add Multi-Currency Support',0),(466057,12947,'is','',0),(466058,12947,'dr','Ø³ÙØ§Ø±Ø´ Ù‚Ø¨Ù„Ø§ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(466059,12947,'pr','Ø³ÙØ§Ø±Ø´ Ù‚Ø¨Ù„Ø§ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(466060,12947,'tr','Zaten daha Ã¶nce alÄ±nan sipariÅŸ',0),(466061,12947,'pl','ZamÃ³wienie juÅ¼ wczeÅ›niej importowany',0),(466062,12947,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð²ÐµÑ‡Ðµ Ð²Ð½ÐµÑÐµÐ½Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ Ñ‚Ð¾Ð²Ð°',0),(466063,12947,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ù¾ÛÙ„Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(466064,12947,'sr','ÐÐ°Ð»Ð¾Ð³ Ð²ÐµÑ› ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸ Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾',0),(466065,12947,'vi','ÄÆ¡n hÃ ng Ä‘Ã£ Ä‘Æ°á»£c nháº­p tá»« trÆ°á»›c',0),(466066,12947,'af','Orde wat reeds voorheen ingevoer',0),(466067,12947,'ro','Comanda deja importate anterior',0),(466068,12947,'et','JÃ¤rjekorras juba varem imporditud',0),(466069,12947,'si','Nalog Å¾e uvoÅ¾eni',0),(466070,12947,'ba','Pesanan yang sudah diimpor sebelumnya',0),(466071,12947,'nl','Volgorde eerder al is geÃ¯mporteerd',0),(466072,12947,'fi','JÃ¤rjestyksessÃ¤ jo aiemmin tuonut',0),(466073,12947,'no','Orden allerede tidligere importert',0),(466074,12947,'da','Bestil allerede importeret tidligere',0),(466075,12947,'ko','ì´ë¯¸ ê°€ì ¸ì˜¨ ì´ì „ ìˆœì„œ',0),(466076,12947,'he','×¡×“×¨ ×›×‘×¨ ×™×™×‘××ª ×‘×¢×‘×¨',0),(466077,12947,'el','Î£ÎµÎ¹ÏÎ¬ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î®Î´Î· ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯ Ï€ÏÎ¿Î·Î³Î¿Ï…Î¼Î­Î½Ï‰Ï‚',0),(466078,12947,'zh','å·²å¯¼å…¥ä»¥å‰çš„è®¢å•',0),(466079,12947,'sv','Ordning redan importerat tidigare',0),(466080,12947,'it','Ordine giÃ  importato in precedenza',0),(466081,12947,'tl','',0),(466082,12947,'th','à¸ªà¸±à¹ˆà¸‡à¸™à¸³à¹€à¸‚à¹‰à¸²à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰à¹à¸¥à¹‰à¸§',0),(466083,12947,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤ªà¤¹à¤²à¥‡ à¤†à¤¯à¤¾à¤¤ à¤†à¤¦à¥‡à¤¶',0),(466084,12947,'ms','Perintah yang telah diimport sebelum ini',0),(466085,12947,'ar','Ø£Ù…Ø± Ø³Ø¨Ù‚ Ø§Ø³ØªÙŠØ±Ø§Ø¯Ù‡Ø§ Ø³Ø§Ø¨Ù‚Ø§',0),(466086,12947,'fr','Ordre dÃ©jÃ  importÃ© prÃ©cÃ©demment',0),(466087,12947,'jp','æ—¢ã«ä»¥å‰ã‚¤ãƒ³ãƒãƒ¼ãƒˆé †åº',0),(466088,12947,'pt','Ordem jÃ¡ importado anteriormente',0),(466089,12947,'ru','Ð—Ð°ÐºÐ°Ð· ÑƒÐ¶Ðµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ñ€Ð°Ð½ÐµÐµ',0),(466090,12947,'es','Pedido Ya ImportÃ³ Previamente',0),(466091,12947,'de','Bestellung bereits zuvor importiert',0),(466092,12947,'en','Order Already Imported Previously',0),(466093,12948,'is','',0),(466094,12948,'dr','Ù„Ø·ÙØ§ Ø³ÙØ§Ø±Ø´Ø§Øª ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ú©Ù†ÛŒØ¯ ',0),(466095,12948,'pr','Ù„Ø·ÙØ§ Ø³ÙØ§Ø±Ø´Ø§Øª ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ú©Ù†ÛŒØ¯ ',0),(466096,12948,'tr','AlÄ±nan sipariÅŸler lÃ¼tfen doÄŸrulayÄ±n',0),(466097,12948,'pl','SprawdÅº, czy przywoÅ¼one zamÃ³wienia',0),(466098,12948,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(466099,12948,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¢Ù¾ Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(466100,12948,'sr','ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ ÑƒÐ²ÐµÐ·ÐµÐ½Ðµ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(466101,12948,'vi','vui lÃ²ng xÃ¡c nháº­n cÃ¡c Ä‘Æ¡n hÃ ng Ä‘Ã£ nháº­p',0),(466102,12948,'af','Verifieer asseblief jou ingevoerde bestellings',0),(466103,12948,'ro','VÄƒ rugÄƒm sÄƒ verificaÅ£i dacÄƒ ordinele dumneavoastrÄƒ importate',0),(466104,12948,'et','Palun veenduge, et teie imporditud tellimused',0),(466105,12948,'si','Prosimo, preverite vaÅ¡e uvoÅ¾eni nalogi',0),(466106,12948,'ba','Harap verifikasi pesanan Anda impor',0),(466107,12948,'nl','Controleer of uw geÃ¯mporteerde bestellingen',0),(466108,12948,'fi','Tarkista tuodut tilaukset',0),(466109,12948,'no','Kontroller importerte bestillinger',0),(466110,12948,'da','Kontroller dine importerede ordrer',0),(466111,12948,'ko','ê°€ì ¸ì˜¨ëœ ëª…ë ¹ì„ í™•ì¸ í•˜ì‹­ì‹œì˜¤',0),(466112,12948,'he','× × ×•×“× ×›×™ ×”×”×•×¨××•×ª ×”×ž×™×•×‘××™× ×©×œ×š',0),(466113,12948,'el','Î•Ï€Î±Î»Î·Î¸ÎµÏÏƒÏ„Îµ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÏƒÎ±Ï‚ ÎµÎ¹ÏƒÎ±Î³ÏŒÎ¼ÎµÎ½Î±',0),(466114,12948,'zh','è¯·éªŒè¯æ‚¨è¾“å…¥çš„è®¢å•',0),(466115,12948,'sv','VÃ¤nligen kontrollera dina importerade order',0),(466116,12948,'it','Si prega di verificare gli ordini importati',0),(466117,12948,'tl','',0),(466118,12948,'th','à¹‚à¸›à¸£à¸”à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸™à¸³à¹€à¸‚à¹‰à¸²à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(466119,12948,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤†à¤ªà¤•à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤¿à¤ à¤—à¤ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿',0),(466120,12948,'ms','Sila sahkan pesanan anda diimport',0),(466121,12948,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø£ÙˆØ§Ù…Ø±Ùƒ Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(466122,12948,'fr','S\'il vous plaÃ®t vÃ©rifier vos commandes importÃ©s',0),(466123,12948,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚ŒãŸã”æ³¨æ–‡ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(466124,12948,'pt','Por favor, verifique se suas ordens importados',0),(466125,12948,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð’Ð°ÑˆÐ¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(466126,12948,'es','Por Favor Verifica Sus Pedidos de ImportaciÃ³n',0),(466127,12948,'de','Bitte Ã¼berprÃ¼fen Sie Ihre importierten Bestellungen',0),(466128,12948,'en','Please Verify Your Imported Orders',0),(466129,12949,'is','',0),(466130,12949,'dr','(Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(466131,12949,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ú©Ø§Ø±Øª Ø³Ù‡ Ø¨Ø¹Ø¯ÛŒ(Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(466132,12949,'tr','3DCart emir alma',0),(466133,12949,'pl','Importu 3DCart zamÃ³wienia',0),(466134,12949,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ 3DCart Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(466135,12949,'ur','3DCart Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(466136,12949,'sr','Ð£Ð²Ð¾Ð· 3Ð”Ð¦Ð°Ñ€Ñ‚ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(466137,12949,'vi','Nháº­p Ä‘Æ¡n Ä‘áº·t hÃ ng 3DCart',0),(466138,12949,'af','Voer 3DCart bestellings',0),(466139,12949,'ro','3DCart comenzilor de import',0),(466140,12949,'et','Impordi 3DCart tellimused',0),(466141,12949,'si','Uvoz 3DCart naroÄila',0),(466142,12949,'ba','Impor 3DCart pesanan',0),(466143,12949,'nl','3DCart Orders importeren',0),(466144,12949,'fi','Tuo 3DCart tilaukset',0),(466145,12949,'no','Importere 3DCart bestillinger',0),(466146,12949,'da','Importere 3DCart ordrer',0),(466147,12949,'ko','ê°€ì ¸ì˜¤ê¸° 3DCart ì£¼ë¬¸',0),(466148,12949,'he','×™×™×‘×•× 3DCart ×”×–×ž× ×•×ª',0),(466149,12949,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® 3DCart Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(466150,12949,'zh','è®¢å•å¯¼å…¥ 3DCart',0),(466151,12949,'sv','3DCart bestÃ¤llning',0),(466152,12949,'it','Importazione ordini 3DCart',0),(466153,12949,'tl','',0),(466154,12949,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ 3DCart',0),(466155,12949,'hi','3DCart à¤†à¤¦à¥‡à¤¶ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(466156,12949,'ms','Perintah-perintah 3DCart import',0),(466157,12949,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£ÙˆØ§Ù…Ø± 3DCart',0),(466158,12949,'fr','3DCart commande',0),(466159,12949,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ 3DCart æ³¨æ–‡',0),(466160,12949,'pt','3DCart ordens de importaÃ§Ã£o',0),(466161,12949,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ 3DCart Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(466162,12949,'es','Importar Pedidos Del 3DCarrito',0),(466163,12949,'de','Import 3DCart Bestellungen',0),(466164,12949,'en','Import 3dcart Orders',0),(466165,12950,'is','',0),(466166,12950,'dr','(Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ú¯Ø¯Ø§Ù…) Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯Ø­ØªÛŒ Ø§Ú¯Ø± Ù…Ù†ÙÛŒ Ø¨Ø§Ø´Ø¯',0),(466167,12950,'pr','ÙÙ‚Ø· ÙƒØ§Ù„Ø§Ù‡Ø§ÙŠ(Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø§Ù†Ø¨Ø§Ø±) Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯Ø­ØªÛŒ Ø§Ú¯Ø± Ù…Ù†ÙÛŒ Ø¨Ø§Ø´Ø¯',0),(466168,12950,'tr','Sadece eldeki maddeleri bile dahil EÄŸer negatif',0),(466169,12950,'pl','Obejmuje tylko pozycje na rÄ™kÄ™ nawet jeÅ›li negatywne',0),(466170,12950,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÑÐ°Ð¼Ð¾ Ð½Ð° Ñ€ÑŠÐºÐ° Ñ‚Ð¾Ñ‡ÐºÐ¸ Ð´Ð¾Ñ€Ð¸ Ð°ÐºÐ¾ ÑÐ° Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»Ð½Ð¸',0),(466171,12950,'ur','ØµØ±Ù ÛØ§ØªÚ¾ Ù¾Ø± Ø§Ø´ÛŒØ§Ø¡ Ú©Ùˆ Ø¨Ú¾ÛŒ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº Ø§Ú¯Ø± Ù…Ù†ÙÛŒ',0),(466172,12950,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ ÑÐ°Ð¼Ð¾ Ð½Ð° Ñ€ÑƒÐºÑƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ, Ñ‡Ð°Ðº Ð¸ Ð°ÐºÐ¾ Ñ˜Ðµ Ð½ÐµÐ³Ð°Ñ‚Ð¸Ð²Ð½Ð°',0),(466173,12950,'vi','Náº¿u khÃ´ng chá»‰ bao gá»“m hÃ ng Ä‘ang cÃ³ sáºµn',0),(466174,12950,'af','Selfs net op-hand Items insluit as negatiewe',0),(466175,12950,'ro','Include numai elemente de pe-o parte chiar dacÄƒ negativ',0),(466176,12950,'et','Sisaldab ainult vaba punkte isegi kui negatiivne',0),(466177,12950,'si','VkljuÄujejo samo elemente na roko tudi Äe je negativno',0),(466178,12950,'ba','Termasuk hanya barang-barang di tangan bahkan jika negatif',0),(466179,12950,'nl','Zelfs alleen op de hand Items worden opgenomen als negatieve',0),(466180,12950,'fi','Ovat vain varastonimikkeet jopa negatiiviset',0),(466181,12950,'no','Inkluderer bare beholdningsvarer selv hvis negativ',0),(466182,12950,'da','Omfatter kun disponible varer selv hvis negativ',0),(466183,12950,'ko','ì‹¬ì§€ì–´ ì§ì ‘ í•­ëª©ë§Œ í¬í•¨ ê²½ìš°',0),(466184,12950,'he','×œ×›×œ×•×œ ×¨×§ ×¤×¨×™×˜×™× ×‘× ×ž×¦× ××¤×™×œ×• ×× ×”×•× ×©×œ×™×œ×™',0),(466185,12950,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Î¼ÏŒÎ½Î¿ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏ„Î· Î´Î¹Î¬Î¸ÎµÏƒÎ® ÏƒÎ±Ï‚ Î±ÎºÏŒÎ¼Î· ÎºÎ±Î¹ Î±Î½ ÎµÎ¯Î½Î±Î¹ Î±ÏÎ½Î·Ï„Î¹ÎºÎ®',0),(466186,12950,'zh','ç”šè‡³åŒ…æ‹¬åªæœ‰æ‰‹å¤´é¡¹ç›®å¦‚æžœä¸ºè´Ÿæ•°',0),(466187,12950,'sv','Ta bara behÃ¥llning objekt Ã¤ven om negativa',0),(466188,12950,'it','Includere solo gli elementi a disposizione, anche se negativo',0),(466189,12950,'tl','',0),(466190,12950,'th','à¸£à¸§à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¹„à¸”à¹‰à¸–à¹‰à¸²à¹€à¸›à¹‡à¸™à¸„à¹ˆà¸²à¸¥à¸š',0),(466191,12950,'hi','à¤•à¥‡à¤µà¤² à¤¹à¤¾à¤¥ à¤ªà¤° à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤®à¥‡à¤‚ à¤­à¥€ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚ à¤¯à¤¦à¤¿ à¤¨à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤•',0),(466192,12950,'ms','Perkara-perkara yang hanya bertugas walaupun jika negatif',0),(466193,12950,'ar','ØªØ´Ù…Ù„ ÙÙ‚Ø· Ø¹Ù„Ù‰ ÙŠØ¯ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø­ØªÙ‰ Ø¥Ø°Ø§ ÙƒØ§Ù† Ø³Ø§Ù„Ø¨Ø§Ù‹',0),(466194,12950,'fr','Inclure uniquement les Ã©lÃ©ments en main mÃªme si nÃ©gatif',0),(466195,12950,'jp','ã§ã‚‚æ‰‹ã®ã‚¢ã‚¤ãƒ†ãƒ ã®ã¿ãŒå«ã¾ã‚Œã¾ã™ãŒè² ã®å ´åˆ',0),(466196,12950,'pt','Incluem apenas os itens Ã  mÃ£o nem se negativo',0),(466197,12950,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ‚Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð² Ð½Ð°Ð»Ð¸Ñ‡Ð¸Ð¸ Ð´Ð°Ð¶Ðµ ÐµÑÐ»Ð¸ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹',0),(466198,12950,'es','Incluye Solamente Items Disponibles Aunque Si Estan Negativos',0),(466199,12950,'de','Beinhalten nur vorrÃ¤tige Artikel sogar negativ',0),(466200,12950,'en','Include Only On-hand Items Even If Negative',0),(466201,12951,'is','',0),(466202,12951,'dr','-Ø¯ÛŒØª Ø±Ø§ÛŒÚ¯Ø§Ù†',0),(466203,12951,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø¬Ù‡Øª Ø¢Ù¾ -Ø¯ÛŒØª Ø±Ø§ÛŒÚ¯Ø§Ù†',0),(466204,12951,'tr','Ãœcretsiz gÃ¼ncelleme kontrol',0),(466205,12951,'pl','SprawdÅº za darmo aktualizacji',0),(466206,12951,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð·Ð° Ð±ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(466207,12951,'ur','Ù…ÙØª Ú©Û’ Ù„Ø¦Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(466208,12951,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(466209,12951,'vi','Kiá»ƒm tra cáº­p nháº­t miá»…n phÃ­',0),(466210,12951,'af','Gaan na vir Gratis Opdatering',0),(466211,12951,'ro','Verifica gratuit pentru actualizare',0),(466212,12951,'et','Check tasuta vÃ¤rskendus',0),(466213,12951,'si','Preverite brezplaÄno posodobitev',0),(466214,12951,'ba','Periksa secara gratis Update',0),(466215,12951,'nl','Controleer of er gratis Update',0),(466216,12951,'fi','Ruudullinen ajaksi vapauttaa pÃ¤ivitys',0),(466217,12951,'no','Sjekk gratis oppdatering',0),(466218,12951,'da','Tjek gratis opdatering',0),(466219,12951,'ko','ë¬´ë£Œ ì—…ë°ì´íŠ¸ í™•ì¸',0),(466220,12951,'he','×‘×“×•×§ ×‘×—×™× × Update',0),(466221,12951,'el','Î•Î»Î­Î³Î¾Ï„Îµ Î´Ï‰ÏÎµÎ¬Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(466222,12951,'zh','æ£€æŸ¥å¯ç”¨æ›´æ–°',0),(466223,12951,'sv','Kolla gratis uppdatering',0),(466224,12951,'it','Verifica gratis aggiornamento',0),(466225,12951,'tl','',0),(466226,12951,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸Ÿà¸£à¸µ',0),(466227,12951,'hi','à¤®à¥à¤«à¥à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(466228,12951,'ms','Menyemak secara percuma Update',0),(466229,12951,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„ØªØ­Ø¯ÙŠØ« Ù…Ø¬Ø§Ù†Ø§Ù‹',0),(466230,12951,'fr','VÃ©rifier la mise Ã  jour gratuite',0),(466231,12951,'jp','ç„¡æ–™ã®æ›´æ–°ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(466232,12951,'pt','Verifique gratuitamente atualizaÃ§Ã£o',0),(466233,12951,'ru','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(466234,12951,'es','Checar para ActualizaciÃ³n GrÃ¡tis',0),(466235,12951,'de','ÃœberprÃ¼fen Sie kostenlos Update',0),(466236,12951,'en','Check for Free Update',0),(466237,12952,'is','',0),(466238,12952,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø±Ø§ÛŒÚ¯Ø§Ù† Ù„ÛŒÙ†ÙˆÚ©Ø³',0),(466239,12952,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø±Ø§ÛŒÚ¯Ø§Ù† Ù„ÛŒÙ†ÙˆÚ©Ø³',0),(466240,12952,'tr','Linux Ã¼cretsiz gÃ¼ncelleme',0),(466241,12952,'pl','BezpÅ‚atna aktualizacja Linux',0),(466242,12952,'bg','Linux Ð±ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(466243,12952,'ur','Ù„ÛŒÙ†Ú©Ø³ Ù…ÙØª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(466244,12952,'sr','Ð›Ð¸Ð½Ñƒx Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(466245,12952,'vi','cáº­p nháº­t Linux miá»…n phÃ­',0),(466246,12952,'af','Linux gratis bywerking',0),(466247,12952,'ro','Update gratuit Linux',0),(466248,12952,'et','Linux tasuta vÃ¤rskendus',0),(466249,12952,'si','Linux brezplaÄno posodobitev',0),(466250,12952,'ba','Linux gratis Update',0),(466251,12952,'nl','Linux gratis Update',0),(466252,12952,'fi','Linux ilmainen pÃ¤ivitys',0),(466253,12952,'no','Linux gratis oppdatering',0),(466254,12952,'da','Linux gratis opdatering',0),(466255,12952,'ko','ë¦¬ëˆ…ìŠ¤ ë¬´ë£Œ ì—…ë°ì´íŠ¸',0),(466256,12952,'he','×¢×“×›×•×Ÿ ×—×™× × ×œ×™× ×•×§×¡',0),(466257,12952,'el','Linux Î´Ï‰ÏÎµÎ¬Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(466258,12952,'zh','Linux å…è´¹æ›´æ–°',0),(466259,12952,'sv','Linux gratis uppdatering',0),(466260,12952,'it','Aggiornamento gratuito Linux',0),(466261,12952,'tl','',0),(466262,12952,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸Ÿà¸£à¸µ Linux',0),(466263,12952,'hi','à¤²à¤¿à¤¨à¤•à¥à¤¸ à¤¨à¤¿à¤ƒà¤¶à¥à¤²à¥à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(466264,12952,'ms','Kemas kini percuma Linux',0),(466265,12952,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø¬Ø§Ù†ÙŠ Ù„ÙŠÙ†ÙƒØ³',0),(466266,12952,'fr','Mise Ã  jour gratuite de Linux',0),(466267,12952,'jp','Linux ã®ç„¡æ–™ã‚¢ãƒƒãƒ—ãƒ‡ãƒ¼ãƒˆ',0),(466268,12952,'pt','AtualizaÃ§Ã£o gratuita do Linux',0),(466269,12952,'ru','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Linux',0),(466270,12952,'es','Linux ActualizaciÃ³n GrÃ¡tis',0),(466271,12952,'de','Linux-gratis-Update',0),(466272,12952,'en','Linux Free Update',0),(466273,12953,'is','',0),(466274,12953,'dr','Ø¬Ø¯ÛŒØ¯ØªØ±ÛŒÙ† Ù†Ø³Ø®Ù‡',0),(466275,12953,'pr','Ø¬Ø¯ÛŒØ¯ØªØ±ÛŒÙ† Ù†Ø³Ø®Ù‡',0),(466276,12953,'tr','En son sÃ¼rÃ¼m',0),(466277,12953,'pl','Najnowsza wersja',0),(466278,12953,'bg','ÐÐ°Ð¹-Ð½Ð¾Ð²Ð°Ñ‚Ð° Ð²ÐµÑ€ÑÐ¸Ñ',0),(466279,12953,'ur','Ø­Ø§Ù„ÛŒÛ ØªØ±ÛŒÙ† ÙˆØ±Ú˜Ù†',0),(466280,12953,'sr','ÐÐ°Ñ˜Ð½Ð¾Ð²Ð¸Ñ˜Ð° Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð°',0),(466281,12953,'vi','phiÃªn báº£n gáº§n nháº¥t',0),(466282,12953,'af','Mees onlangse weergawe',0),(466283,12953,'ro','Cea mai recentÄƒ versiune',0),(466284,12953,'et','KÃµige vÃ¤rskem versioon',0),(466285,12953,'si','NajnovejÅ¡a razliÄica',0),(466286,12953,'ba','Versi terbaru',0),(466287,12953,'nl','Meest recente versie',0),(466288,12953,'fi','Viimeisin versio',0),(466289,12953,'no','Nyeste versjon',0),(466290,12953,'da','Seneste Version',0),(466291,12953,'ko','ê°€ìž¥ ìµœê·¼ ë²„ì „',0),(466292,12953,'he','×”×’×™×¨×¡×” ×”×¢×“×›× ×™×ª ×‘×™×•×ª×¨',0),(466293,12953,'el','Î— Ï€Î¹Î¿ Ï€ÏÏŒÏƒÏ†Î±Ï„Î· Î­ÎºÎ´Î¿ÏƒÎ·',0),(466294,12953,'zh','æœ€æ–°ç‰ˆæœ¬',0),(466295,12953,'sv','Den senaste versionen',0),(466296,12953,'it','Versione piÃ¹ recente',0),(466297,12953,'tl','',0),(466298,12953,'th','à¸£à¸¸à¹ˆà¸™à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(466299,12953,'hi','à¤¸à¤¬à¤¸à¥‡ à¤¹à¤¾à¤² à¤•à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(466300,12953,'ms','Versi paling baru',0),(466301,12953,'ar','Ø£Ø­Ø¯Ø« Ø¥ØµØ¯Ø§Ø±',0),(466302,12953,'fr','Version la plus rÃ©cente',0),(466303,12953,'jp','æœ€æ–°ãƒãƒ¼ã‚¸ãƒ§ãƒ³',0),(466304,12953,'pt','VersÃ£o mais recente',0),(466305,12953,'ru','Ð¡Ð°Ð¼Ð°Ñ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÑÑ Ð²ÐµÑ€ÑÐ¸Ñ',0),(466306,12953,'es','VersiÃ³n MÃ¡s Reciente',0),(466307,12953,'de','Die aktuelle Version',0),(466308,12953,'en','Most Recent Version',0),(466309,12954,'is','',0),(466310,12954,'dr','ÙˆÛŒÙ†Ø¯ÙˆØ² Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø±Ø§ÛŒÚ¯Ø§Ù†',0),(466311,12954,'pr','ÙˆÛŒÙ†Ø¯ÙˆØ² Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø±Ø§ÛŒÚ¯Ø§Ù†',0),(466312,12954,'tr','Windows Ã¼cretsiz gÃ¼ncelleme',0),(466313,12954,'pl','BezpÅ‚atna aktualizacja Windows',0),(466314,12954,'bg','Ð‘ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Windows',0),(466315,12954,'ur','Ù…ÙØª Windows ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(466316,12954,'sr','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ðµ ÑƒÑÐ»ÑƒÐ³Ðµ WÐ¸Ð½Ð´Ð¾wÑ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(466317,12954,'vi','Cáº­p nháº­t windows miá»…n phÃ­',0),(466318,12954,'af','Windows gratis bywerking',0),(466319,12954,'ro','Windows Update gratuit',0),(466320,12954,'et','Windowsi tasuta vÃ¤rskendus',0),(466321,12954,'si','Windows Update prostega',0),(466322,12954,'ba','Windows Update gratis',0),(466323,12954,'nl','Windows gratis Update',0),(466324,12954,'fi','Windows Update',0),(466325,12954,'no','Windows gratis oppdatering',0),(466326,12954,'da','Windows gratis opdatering',0),(466327,12954,'ko','ìœˆë„ìš° ë¬´ë£Œ ì—…ë°ì´íŠ¸',0),(466328,12954,'he','Windows Update ×—×™× ×',0),(466329,12954,'el','Î”Ï‰ÏÎµÎ¬Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Windows',0),(466330,12954,'zh','å…è´¹çš„ Windows æ›´æ–°',0),(466331,12954,'sv','Windows gratis uppdatering',0),(466332,12954,'it','Aggiornamento gratuito a Windows',0),(466333,12954,'tl','',0),(466334,12954,'th','Windows Update à¸Ÿà¸£à¸µ',0),(466335,12954,'hi','Windows à¤¨à¤¿: à¤¶à¥à¤²à¥à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(466336,12954,'ms','Windows Update percuma',0),(466337,12954,'ar','ØªØ­Ø¯ÙŠØ« ÙˆÙŠÙ†Ø¯ÙˆØ² Ù…Ø¬Ø§Ù†ÙŠØ©',0),(466338,12954,'fr','Mise Ã  jour gratuite de Windows',0),(466339,12954,'jp','Windows ã®ç„¡æ–™ã‚¢ãƒƒãƒ—ãƒ‡ãƒ¼ãƒˆ',0),(466340,12954,'pt','AtualizaÃ§Ã£o gratuita do Windows',0),(466341,12954,'ru','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Windows',0),(466342,12954,'es','Windows ActualizaciÃ³n GrÃ¡tis',0),(466343,12954,'de','Kostenlose Windows-Update',0),(466344,12954,'en','Windows Free Update',0),(466345,12955,'is','',0),(466346,12955,'dr','Ù†Ø³Ø®Ù‡ Ø§Ø®ÛŒØ± Ø´Ù…Ø§',0),(466347,12955,'pr','Ù†Ø³Ø®Ù‡ Ø§Ø®ÛŒØ± Ø´Ù…Ø§',0),(466348,12955,'tr','GeÃ§erli sÃ¼rÃ¼mÃ¼nÃ¼z',0),(466349,12955,'pl','BieÅ¼Ä…ca wersja',0),(466350,12955,'bg','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð²Ð¸ Ð²ÐµÑ€ÑÐ¸Ñ',0),(466351,12955,'ur','Ø¢Ù¾ Ú©Û’ Ø­Ø§Ù„ÛŒÛ ÙˆØ±Ú˜Ù†',0),(466352,12955,'sr','Ð’Ð°ÑˆÐ° Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð°',0),(466353,12955,'vi','PhiÃªn báº£n hiá»‡n táº¡i cá»§a báº¡n',0),(466354,12955,'af','U Huidige Weergawe',0),(466355,12955,'ro','Versiunea curentÄƒ',0),(466356,12955,'et','Praegune versioon',0),(466357,12955,'si','Trenutna razliÄica',0),(466358,12955,'ba','Versi sekarang',0),(466359,12955,'nl','Uw huidige versie',0),(466360,12955,'fi','Nykyinen versio',0),(466361,12955,'no','Gjeldende versjon',0),(466362,12955,'da','Din nuvÃ¦rende Version',0),(466363,12955,'ko','í˜„ìž¬ ë²„ì „',0),(466364,12955,'he','×”×’×™×¨×¡×” ×”× ×•×›×—×™×ª ×©×œ×š',0),(466365,12955,'el','Î¤Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î­ÎºÎ´Î¿ÏƒÎ·',0),(466366,12955,'zh','æ‚¨å½“å‰çš„ç‰ˆæœ¬',0),(466367,12955,'sv','Din aktuella Version',0),(466368,12955,'it','La versione corrente',0),(466369,12955,'tl','',0),(466370,12955,'th','à¸£à¸¸à¹ˆà¸™à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(466371,12955,'hi','à¤…à¤ªà¤¨à¥‡ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(466372,12955,'ms','Versi semasa',0),(466373,12955,'ar','Ø§Ù„Ø¥ØµØ¯Ø§Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(466374,12955,'fr','Votre Version actuelle',0),(466375,12955,'jp','ç¾åœ¨ã®ãƒãƒ¼ã‚¸ãƒ§ãƒ³',0),(466376,12955,'pt','Sua versÃ£o atual',0),(466377,12955,'ru','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ Ð²ÐµÑ€ÑÐ¸Ñ',0),(466378,12955,'es','Su VersiÃ³n Actual',0),(466379,12955,'de','Die aktuelle Version',0),(466380,12955,'en','Your Current Version',0),(466381,12956,'is','',0),(466382,12956,'dr','Ø³ÛŒØ³ØªÙ… Ø¹Ø§Ù…Ù„ Ø´Ù…Ø§',0),(466383,12956,'pr','Ø³ÛŒØ³ØªÙ… Ø¹Ø§Ù…Ù„ Ø´Ù…Ø§',0),(466384,12956,'tr','Ä°ÅŸletim sisteminiz',0),(466385,12956,'pl','System operacyjny',0),(466386,12956,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð° ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(466387,12956,'ur','Ø¢Ù¾ Ú©Ø§ Ù†Ø¸Ø§Ù…',0),(466388,12956,'sr','Ð’Ð°Ñˆ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ð¸ ÑÐ¸ÑÑ‚ÐµÐ¼',0),(466389,12956,'vi','Há»‡ thá»‘ng hoáº¡t Ä‘á»™ng cá»§a báº¡n',0),(466390,12956,'af','U Bedryfssisteem',0),(466391,12956,'ro','Sistemul de operare',0),(466392,12956,'et','Teie operatsioonisÃ¼steem',0),(466393,12956,'si','VaÅ¡ operacijski sistem',0),(466394,12956,'ba','Sistem operasi Anda',0),(466395,12956,'nl','Uw besturingssysteem',0),(466396,12956,'fi','KÃ¤yttÃ¤vÃ¤ elimistÃ¶',0),(466397,12956,'no','Operativsystemet',0),(466398,12956,'da','Dit operativsystem',0),(466399,12956,'ko','ìš´ì˜ ì²´ì œ',0),(466400,12956,'he','×ž×¢×¨×›×ª ×”×”×¤×¢×œ×” ×©×œ×š',0),(466401,12956,'el','Î¤Î¿ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¹ÎºÏŒ ÏƒÎ±Ï‚ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(466402,12956,'zh','æ‚¨çš„æ“ä½œç³»ç»Ÿ',0),(466403,12956,'sv','Ditt operativsystem',0),(466404,12956,'it','Sistema operativo',0),(466405,12956,'tl','',0),(466406,12956,'th','à¸£à¸°à¸šà¸šà¸›à¸à¸´à¸šà¸±à¸•à¸´à¸à¸²à¸£',0),(466407,12956,'hi','à¤†à¤ªà¤•à¤¾ à¤‘à¤ªà¤°à¥‡à¤Ÿà¤¿à¤‚à¤— à¤¸à¤¿à¤¸à¥à¤Ÿà¤®',0),(466408,12956,'ms','Sistem operasi anda',0),(466409,12956,'ar','Ù†Ø¸Ø§Ù… Ø§Ù„ØªØ´ØºÙŠÙ„ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(466410,12956,'fr','Votre systÃ¨me d\'exploitation',0),(466411,12956,'jp','ãŠä½¿ã„ã®ã‚ªãƒšãƒ¬ãƒ¼ãƒ†ã‚£ãƒ³ã‚° ã‚·ã‚¹ãƒ†ãƒ ',0),(466412,12956,'pt','Seu sistema operacional',0),(466413,12956,'ru','Ð’Ð°ÑˆÐ° Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð°Ñ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(466414,12956,'es','Su Sistema Operativo',0),(466415,12956,'de','Ihr Betriebssystem',0),(466416,12956,'en','Your Operating System',0),(466417,12957,'is','',0),(466418,12957,'dr','Ù†Ø³Ø®Ù‡ Ø´Ù…Ø§ Ø¬Ø¯ÛŒØ¯ Ø§Ø³Øª',0),(466419,12957,'pr','Ù†Ø³Ø®Ù‡ Ø´Ù…Ø§ Ø¬Ø¯ÛŒØ¯ Ø§Ø³Øª',0),(466420,12957,'tr','GeÃ§erli sÃ¼rÃ¼mdÃ¼r',0),(466421,12957,'pl','Twoja wersja jest prÄ…d',0),(466422,12957,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° Ð²ÐµÑ€ÑÐ¸Ñ Ðµ Ñ‚Ð¾Ðº',0),(466423,12957,'ur','Ø¢Ù¾ Ú©Û’ ÙˆØ±Ú˜Ù† Ú©Ø§ Ø±ÛŒÙ„Ø§ ÛÛ’',0),(466424,12957,'sr','Ð¢Ð²Ð¾Ñ˜Ð° Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð° Ñ˜Ðµ ÑÑ‚Ñ€ÑƒÑ˜Ð°',0),(466425,12957,'vi','PhiÃªn báº£n cá»§a báº¡n lÃ  phiÃªn báº£n hiá»‡n hÃ nh',0),(466426,12957,'af','U Weergawe is die Huidige',0),(466427,12957,'ro','Versiunea este curent',0),(466428,12957,'et','Teie versioon on hoovus',0),(466429,12957,'si','VaÅ¡a razliÄica je trenutno',0),(466430,12957,'ba','Versi Anda adalah arus',0),(466431,12957,'nl','Uw versie is huidige',0),(466432,12957,'fi','Versio on nykyisen',0),(466433,12957,'no','Din versjon er gjeldende',0),(466434,12957,'da','Din Version er aktuelle',0),(466435,12957,'ko','ë²„ì „ì€ í˜„ìž¬',0),(466436,12957,'he','×”×’×¨×¡×” ×©×œ×š ×”×™× ×–×¨×',0),(466437,12957,'el','Î£Î±Ï‚ Î­ÎºÎ´Î¿ÏƒÎ· ÎµÎ¯Î½Î±Î¹ ÏÎµÏÎ¼Î±',0),(466438,12957,'zh','æ‚¨çš„ç‰ˆæœ¬æ˜¯å½“å‰',0),(466439,12957,'sv','Din Version Ã¤r strÃ¶m',0),(466440,12957,'it','Ãˆ la versione corrente',0),(466441,12957,'tl','',0),(466442,12957,'th','à¸£à¸¸à¹ˆà¸™à¸‚à¸­à¸‡à¸„à¸¸à¸“à¹€à¸›à¹‡à¸™à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(466443,12957,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤…à¤ªà¤¨à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤¹à¥ˆ',0),(466444,12957,'ms','Versi anda adalah semasa',0),(466445,12957,'ar','Ù‡Ùˆ Ø§Ù„Ø¥ØµØ¯Ø§Ø± Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(466446,12957,'fr','Votre Version est courant',0),(466447,12957,'jp','ãŠä½¿ã„ã®ãƒãƒ¼ã‚¸ãƒ§ãƒ³ã¯ã€ç¾åœ¨',0),(466448,12957,'pt','Sua versÃ£o Ã© corrente',0),(466449,12957,'ru','Ð’Ð°ÑˆÐ° Ð²ÐµÑ€ÑÐ¸Ñ-Ñ‚Ð¾Ðº',0),(466450,12957,'es','Su VersiÃ³n EstÃ¡ Actualizada',0),(466451,12957,'de','Ihre Version ist aktuell',0),(466452,12957,'en','Your Version is Current',0),(466453,12958,'is','',0),(466454,12958,'dr','Ø¢Ù¾Ø¯ÛŒØª Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±',0),(466455,12958,'pr','Ø¢Ù¾Ø¯ÛŒØª Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±',0),(466456,12958,'tr','NolaPro GÃ¼ncellemeler',0),(466457,12958,'pl','NolaPro aktualizacje',0),(466458,12958,'bg','NolaPro Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(466459,12958,'ur','Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ø§Ù¾ ÚˆÛŒÙ¹Ø³',0),(466460,12958,'sr','ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(466461,12958,'vi','Cáº­p Nháº­t NolaPro ',0),(466462,12958,'af','NolaPro bywerkings',0),(466463,12958,'ro','ActualizÄƒri NolaPro',0),(466464,12958,'et','NolaPro uuendused',0),(466465,12958,'si','NolaPro posodobitve',0),(466466,12958,'ba','NolaPro pembaruan',0),(466467,12958,'nl','NolaPro Updates',0),(466468,12958,'fi','NolaPro pÃ¤ivitykset',0),(466469,12958,'no','NolaPro oppdateringer',0),(466470,12958,'da','NolaPro opdateringer',0),(466471,12958,'ko','NolaPro ì—…ë°ì´íŠ¸',0),(466472,12958,'he','×¢×“×›×•× ×™× NolaPro',0),(466473,12958,'el','NolaPro ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹Ï‚',0),(466474,12958,'zh','NolaPro æ›´æ–°',0),(466475,12958,'sv','NolaPro uppdateringar',0),(466476,12958,'it','NolaPro aggiornamenti',0),(466477,12958,'tl','',0),(466478,12958,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡ NolaPro',0),(466479,12958,'hi','NolaPro à¤…à¤ªà¤¡à¥‡à¤Ÿ',0),(466480,12958,'ms','Kemas kini NolaPro',0),(466481,12958,'ar','ØªØ­Ø¯ÙŠØ«Ø§Øª Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ',0),(466482,12958,'fr','Mises Ã  jour NolaPro',0),(466483,12958,'jp','NolaPro æ›´æ–°',0),(466484,12958,'pt','NolaPro atualizaÃ§Ãµes',0),(466485,12958,'ru','NolaPro Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(466486,12958,'es','Actualizaciones de NolaPro',0),(466487,12958,'de','Artikel-Updates',0),(466488,12958,'en','NolaPro Updates',0),(466489,12959,'is','',0),(466490,12959,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø±ÙˆØ´ Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(466491,12959,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø±ÙˆØ´ Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(466492,12959,'tr','VarsayÄ±lan komisyon yÃ¶ntemi',0),(466493,12959,'pl','DomyÅ›lna metoda Komisji',0),(466494,12959,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð¼ÐµÑ‚Ð¾Ð´',0),(466495,12959,'ur','Ø·Û’ Ø´Ø¯Û Ú©Ù…ÛŒØ´Ù† Ø·Ø±ÛŒÙ‚Û',0),(466496,12959,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¼ÐµÑ‚Ð¾Ð´ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ðµ',0),(466497,12959,'vi','PhÆ°Æ¡ng thá»©c chiáº¿t kháº¥u máº·c Ä‘á»‹nh',0),(466498,12959,'af','Verstek Kommissie metode',0),(466499,12959,'ro','Metoda de Comisia implicitÄƒ',0),(466500,12959,'et','Vaikimisi komisjoni meetod',0),(466501,12959,'si','Privzetega naÄina za Komisijo',0),(466502,12959,'ba','Default Komisi metode',0),(466503,12959,'nl','Commissie standaardmethode',0),(466504,12959,'fi','Komission oletusmenetelmÃ¤',0),(466505,12959,'no','Kommisjonen standardmetoden',0),(466506,12959,'da','Kommissionen standardmetoden',0),(466507,12959,'ko','ê¸°ë³¸ ìˆ˜ìˆ˜ë£Œ ë©”ì„œë“œ',0),(466508,12959,'he','×©×™×˜×ª ×”×¢×ž×œ×•×ª ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(466509,12959,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¼Î­Î¸Î¿Î´Î¿Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®',0),(466510,12959,'zh','é»˜è®¤å§”å‘˜ä¼šæ³•',0),(466511,12959,'sv','Kommissionen standardmetoden',0),(466512,12959,'it','Metodo Commissione predefinito',0),(466513,12959,'tl','',0),(466514,12959,'th','à¸§à¸´à¸˜à¸µà¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸³à¸™à¸±à¸à¸‡à¸²à¸™à¸„à¸“à¸°à¸à¸£à¸£à¸¡à¸à¸²à¸£',0),(466515,12959,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤µà¤¿à¤§à¤¿ à¤†à¤¯à¥‹à¤—',0),(466516,12959,'ms','Kaedah Suruhanjaya lalai',0),(466517,12959,'ar','Ø£Ø³Ù„ÙˆØ¨ Ø§Ù„Ù„Ø¬Ù†Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(466518,12959,'fr','MÃ©thode de Commission par dÃ©faut',0),(466519,12959,'jp','æ—¢å®šå§”å“¡ä¼šæ³•',0),(466520,12959,'pt','MÃ©todo padrÃ£o de ComissÃ£o',0),(466521,12959,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¼ÐµÑ‚Ð¾Ð´ ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(466522,12959,'es','MÃ©todo Predeterminado de Comisiones ',0),(466523,12959,'de','Kommission Standardmethode',0),(466524,12959,'en','Default Commission Method',0),(466525,12960,'is','',0),(466526,12960,'dr','-Ø¯Ú©Ù…Ù‡ Ø§ØµÙ„Ø§Ø­ Ø±Ø§ Ø¬Ù‡Øª Ø¨Ø±Ø±Ø³ÛŒ  Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ø®ÙˆØ¯ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ùˆ Ø³Ù¾Ø³ Ù‚Ø¨Ù„ Ø§Ø² Ú†Ø§Ù¾ ÙØ±Ù… Ù‡Ø§ Ø§Ø¨ØªØ¯Ø§ Ø¢Ù†Ø±Ø§ Ø°Ø®ÛŒØ±Ù‡ Ú©Ù†ÛŒØ¯  ',0),(466527,12960,'pr','Ù„Ø·ÙØ§ Ø¨Ø±Ú¯Ø±Ø¯ÛŒØ¯-Ø¯Ú©Ù…Ù‡ ÙˆÛŒØ±Ø§ÛŒØ´ Ø±Ø§ Ø¬Ù‡Øª Ø¨Ø±Ø±Ø³ÛŒ  Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ø®ÙˆØ¯ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ùˆ Ø³Ù¾Ø³ Ù‚Ø¨Ù„ Ø§Ø² Ú†Ø§Ù¾ ÙØ±Ù… Ù‡Ø§ Ø§Ø¨ØªØ¯Ø§ Ø¢Ù†Ø±Ø§ Ø°Ø®ÛŒØ±Ù‡ Ú©Ù†ÛŒØ¯  ',0),(466528,12960,'tr','LÃ¼tfen geri dÃ¶n, sonra Save ilk Ã¶nce yazdÄ±rma formlarÄ± ve verilerinizi doÄŸrulamak iÃ§in DÃ¼zenle\'yi tÄ±klatÄ±n.',0),(466529,12960,'pl','ProszÄ™ wrÃ³ciÄ‡, kliknij przycisk Edytuj, aby sprawdziÄ‡ swoje dane i nastÄ™pnie zapisz najpierw przed drukowaniem formularzy.',0),(466530,12960,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÑ€Ð½ÐµÑ‚Ðµ, Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ, Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸ Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð´Ð°Ð½Ð½Ð¸ Ð¸ Ð¿Ð¾ÑÐ»Ðµ Ð·Ð°Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¿Ñ€ÑŠÐ² Ð¿Ñ€ÐµÐ´Ð¸ Ñ„Ð¾Ñ€Ð¼Ð¸.',0),(466531,12960,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ ÙˆØ§Ù¾Ø³ Ø¬Ø§ Ú©Ø± Ø§Ù¾Ù†Û’ Ú©ÙˆØ§Ø¦Ù Ø§ÙˆØ± Ù¾Ú¾Ø± Ù…Ø­ÙÙˆØ¸ ÙØ§Ø±Ù… Ú©ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ø³Û’ Ù‚Ø¨Ù„ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ØªØ±Ù…ÛŒÙ… Ú©Ø±ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(466532,12960,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð²Ñ€Ð°Ñ‚Ð¸ ÑÐµ, ÐºÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð£Ñ€ÐµÐ´Ð¸ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ð»Ð¸ Ð²Ð°ÑˆÐµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¸ Ð¾Ð½Ð´Ð° Ð¡Ð°Ð²Ðµ Ð¿Ñ€Ð²Ð¾ Ð¿Ñ€ÐµÐ´ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ†Ð°.',0),(466533,12960,'vi','vui lÃ²ng trá»Ÿ láº¡i, kÃ­ch vÃ o chá»‰nh sá»­a Ä‘á»ƒ xÃ¡c nháº­n dá»¯ liá»‡u cá»§a báº¡n vÃ  sau Ä‘Ã³ lÆ°u trÆ°á»›c khi in ra',0),(466534,12960,'af','Gaan asseblief terug, klik Redigeer jou data en dan stoor eers voor druk vorms te verifieer.',0),(466535,12960,'ro','VÄƒ rugÄƒm sÄƒ reveniÅ£i, faceÅ£i clic pe Editare pentru a verifica al tÄƒu date ÅŸi apoi Save prima Ã®nainte de tipÄƒrirea formularelor.',0),(466536,12960,'et','Palun tagasi minna, klÃµpsake nuppu Redigeeri kontrollida oma andmed ja seejÃ¤rel Salvesta vormide printimiseks enne.',0),(466537,12960,'si','Prosimo, pojdite nazaj, kliknite Uredi, da preverite svoje podatke in nato shranite prvi spredaj tiskanje obrazcev.',0),(466538,12960,'ba','Silakan kembali, klik Edit untuk memverifikasi data Anda dan kemudian simpan terlebih dahulu sebelum pencetakan bentuk.',0),(466539,12960,'nl','Ga terug, klik op bewerken om te controleren of uw gegevens en vervolgens opslaan eerst alvorens afdrukken van formulieren.',0),(466540,12960,'fi','Siirry takaisin, Muokkaa tietoja ja sitten Tallenna ennen lomakkeiden painamisessa.',0),(466541,12960,'no','Vennligst gÃ¥ tilbake, klikk Rediger for Ã¥ kontrollere data og deretter lagre fÃ¸r utskrift av skjemaer.',0),(466542,12960,'da','GÃ¥ venligst tilbage, klik pÃ¥ Rediger for at kontrollere dine data og derefter gemme fÃ¸rst fÃ¸r udskrivning former.',0),(466543,12960,'ko','ë‹¤ì‹œ ì´ë™ í•˜ì‹­ì‹œì˜¤, ë°ì´í„°ì™€ ì¸ì‡„ í˜•íƒœ ì „ì— ë¨¼ì € í›„ ì €ìž¥ í™•ì¸ í•˜ë ¤ë©´ íŽ¸ì§‘ì„ í´ë¦­ í•©ë‹ˆë‹¤.',0),(466544,12960,'he','×‘×‘×§×©×”, ×ª×—×–×•×¨, ×œ×—×¥ ×¢×œ ×¢×¨×™×›×” ×›×“×™ ×œ××ž×ª ××ª ×”× ×ª×•× ×™× ×•×©×ž×™×¨×” ×•××– ×œ×¨××©×•× ×” ×œ×¤× ×™ ×”×“×¤×¡×ª ×˜×¤×¡×™×.',0),(466545,12960,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï€Î·Î³Î±Î¯Î½ÎµÏ„Îµ Ï€Î¯ÏƒÏ‰, ÎºÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î³Î¹Î± Ï„Î·Î½ ÎµÏ€Î±Î»Î®Î¸ÎµÏ…ÏƒÎ· Ï„Ï‰Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ ÏƒÎ±Ï‚ ÎºÎ±Î¹ ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï€ÏÏŽÏ„Î± Ï€ÏÎ¹Î',0),(466546,12960,'zh','è¯·å›žåŽ»ï¼Œå•å‡»ç¼–è¾‘ä»¥éªŒè¯æ‚¨çš„æ•°æ®å’Œå…ˆæ‰“å°è¡¨å•ç„¶åŽä¿å­˜ã€‚',0),(466547,12960,'sv','GÃ¥ tillbaka, klicka pÃ¥ Redigera om du vill kontrollera dina data och sedan spara fÃ¶rst innan att skriva ut bildar.',0),(466548,12960,'it','Si prega di tornare indietro, fare clic su modifica per verificare i tuoi dati e quindi salvarlo prima prima forme di stampa.',0),(466549,12960,'tl','',0),(466550,12960,'th','à¸à¸£à¸¸à¸“à¸²à¸à¸¥à¸±à¸šà¹„à¸› à¸„à¸¥à¸´à¸à¹à¸à¹‰à¹„à¸‚à¹€à¸žà¸·à¹ˆà¸­à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹à¸¥à¸°à¸šà¸±à¸™à¸—à¸¶à¸à¹à¸¥à¹‰à¸§à¸„à¸£à¸±à¹‰à¸‡à¹à¸£à¸à¸à¹ˆà¸­à¸™à¸—à¸µà¹ˆà¸ˆà¸°à¸žà¸´à¸¡à¸žà¹Œà¹à¸šà¸šà¸Ÿà¸­à¸£à¹Œà¸¡à¸‚à¸­à¸‡à¸',0),(466551,12960,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤µà¤¾à¤ªà¤¸ à¤œà¤¾à¤à¤, à¤†à¤ªà¤•à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤”à¤° à¤¤à¤¬ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤ªà¤¹à¤²à¥€ à¤¬à¤¾à¤° à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(466552,12960,'ms','Sila kembali, klik Edit untuk mengesahkan data dan kemudian simpan terlebih dahulu sebelum borang-borang percetakan anda.',0),(466553,12960,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„Ø°Ù‡Ø§Ø¨ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ØŒ Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ ØªØ­Ø±ÙŠØ± Ù„Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª ÙˆØ­ÙØ¸ Ø«Ù… Ø£ÙˆÙ„Ø§Ù‹ Ù‚Ø¨Ù„ Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù†Ù…Ø§Ø°Ø¬ Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(466554,12960,'fr','Veuillez revenir en arriÃ¨re, cliquez sur modifier pour vÃ©rifier vos donnÃ©es et puis enregistrez tout d\'abord avant l\'impression des formulaires.',0),(466555,12960,'jp','æˆ»ã£ã¦ãã ã•ã„ã€ãƒ‡ãƒ¼ã‚¿ã¨ãƒ•ã‚©ãƒ¼ãƒ ã®å°åˆ·ã®å‰ã«æœ€åˆã«å…¥åŠ›ã—ã¦ä¿å­˜ã‚’ç¢ºèªã™ã‚‹ç·¨é›†ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™ã€‚',0),(466556,12960,'pt','Por favor, volte, clique em Editar para verificar seus dados e salve primeiro antes de formas de impressÃ£o.',0),(466557,12960,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²ÐµÑ€Ð½Ð¸Ñ‚ÐµÑÑŒ Ð½Ð°Ð·Ð°Ð´, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð²Ð°ÑˆÐ¸ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð¸ Ð·Ð°Ñ‚ÐµÐ¼ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ¶Ð´Ðµ Ñ‡ÐµÐ¼ Ð¿ÐµÑ‡Ð°Ñ‚Ð½Ñ‹Ðµ Ñ„Ð¾Ñ€Ð¼Ñ‹ Ð½Ð°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐºÐ½Ð¾Ð¿ÐºÑƒ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ.',0),(466558,12960,'es','Por Favor Regresa, hace click en Editar para verificar sus datos y Guarda antes que imprimir las formas',0),(466559,12960,'de','Bitte gehen Sie zurÃ¼ck, klicken Sie auf Bearbeiten, um Ihre Daten und dann speichern bevor Druckformen zu Ã¼berprÃ¼fen.',0),(466560,12960,'en','Please go back, click Edit to verify your data and then Save first before printing forms.',0),(466561,12961,'is','',0),(466562,12961,'dr','Ø¨Ø§ Ø¬Ù…Ø¹ ÙØ§Ú©ØªÙˆØ± Ú©Ù…ØªØ± Ø§Ø² Ù…Ø§Ù„ÛŒØ§Øª Ùˆ Ø§Ø±Ø³Ø§Ù„',0),(466563,12961,'pr','Ø¨Ø§ Ø¬Ù…Ø¹ ÙØ§Ú©ØªÙˆØ± Ú©Ù…ØªØ± Ø§Ø² Ù…Ø§Ù„ÛŒØ§Øª Ùˆ Ø§Ø±Ø³Ø§Ù„',0),(466564,12961,'tr','Fatura toplam tarafÄ±ndan daha az vergi & nakliye',0),(466565,12961,'pl','Przez Å‚Ä…cznÄ… mniej podatkowej & wysyÅ‚ki',0),(466566,12961,'bg','ÐžÑ‚ Ð¾Ð±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð´Ð°Ð½ÑŠÐº & Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(466567,12961,'ur','Ú©Ù… Ù¹ÛŒÚ©Ø³ & Ø´Ù¾Ù†Ú¯ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ú©Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(466568,12961,'sr','ÐŸÐ¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð±Ð¸Ñ€Ñƒ Ð¼Ð°ÑšÐµ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(466569,12961,'vi','Theo Tá»•ng hÃ³a Ä‘Æ¡n Ã­t hÆ¡n thuáº¿ vÃ  váº­n chuyá»ƒn.',0),(466570,12961,'af','Deur faktuur totaal minder belasting & gestuur',0),(466571,12961,'ro','De facturÄƒ Total mai puÅ£in impozit & transport',0),(466572,12961,'et','Arve kokku vÃ¤hem tulumaksu & laevandus',0),(466573,12961,'si','RaÄun skupaj manj davka & dostava',0),(466574,12961,'ba','Oleh Total tagihan kurang pajak & pengiriman',0),(466575,12961,'nl','Door factuurbedrag minder belasting & verzending',0),(466576,12961,'fi','Lasku yhteensÃ¤ vÃ¤hemmÃ¤n veroa & toimitus',0),(466577,12961,'no','Av fakturatotalen mindre skatt & frakt',0),(466578,12961,'da','Af fakturatotalen mindre skat & Shipping',0),(466579,12961,'ko','ëœ ì„¸ê¸ˆ & ë°°ì†¡ ì†¡ìž¥ ì´ìœ¼ë¡œ',0),(466580,12961,'he','×¢×œ ×™×“×™ ×¡×š ×”×—×©×‘×•× ×™×ª ×¤×—×•×ª ×ž×¡ & ×ž×©×œ×•×—',0),(466581,12961,'el','Î‘Ï€ÏŒ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î»Î¹Î³ÏŒÏ„ÎµÏÎ¿ Ï†ÏŒÏÎ¿ & Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(466582,12961,'zh','ç”±å°‘ç¨Ž &amp; èˆªè¿å‘ç¥¨åˆè®¡',0),(466583,12961,'sv','Av fakturasumman mindre skatt & frakt',0),(466584,12961,'it','Di fattura totale meno fiscale & spedizione',0),(466585,12961,'tl','',0),(466586,12961,'th','à¸œà¸¥à¸£à¸§à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸«à¸±à¸à¸ à¸²à¸©à¸µ & à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(466587,12961,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¯à¥‹à¤— à¤¸à¥‡ à¤•à¤® à¤Ÿà¥ˆà¤•à¥à¤¸ & à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(466588,12961,'ms','Oleh jumlah invois tolak cukai & perkapalan',0),(466589,12961,'ar','Ù…Ù† Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø£Ù‚Ù„ Ø¶Ø±ÙŠØ¨Ø© Ø¢Ù†Ø¯ Ø§Ù„Ø´Ø­Ù†',0),(466590,12961,'fr','Par facture Total moins l\'impÃ´t & expÃ©dition',0),(466591,12961,'jp','è«‹æ±‚æ›¸åˆè¨ˆç¨Ž & é€æ–™ä»¥ä¸‹',0),(466592,12961,'pt','Por factura Total menos imposto & de transporte',0),(466593,12961,'ru','ÐÐ° ÑÑ‡ÐµÑ‚ Ð²ÑÐµÐ³Ð¾ Ð¼ÐµÐ½ÑŒÑˆÐµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² & Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(466594,12961,'es','Por Total de Factura Menos Impuestos y Transporte',0),(466595,12961,'de','Von Rechnungssumme abzÃ¼glich Steuer & Versand',0),(466596,12961,'en','By Invoice Total Less Tax & Shipping',0),(466597,12962,'is','',0),(466598,12962,'dr','Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø´Ø¯',0),(466599,12962,'pr','Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø´Ø¯',0),(466600,12962,'tr','Komisyonlar baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(466601,12962,'pl','Prowizje pomyÅ›lnie zaktualizowana',0),(466602,12962,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(466603,12962,'ur','Ú©Ù…ÛŒØ´Ù†ÙˆÚº Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(466604,12962,'sr','ÐŸÑ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(466605,12962,'vi','Cáº­p nháº­t hoa há»“ng thÃ nh cÃ´ng',0),(466606,12962,'af','Kommissies suksesvol bygewerk',0),(466607,12962,'ro','Comisioane actualizat cu succes',0),(466608,12962,'et','VÃ¤rskendatud komisjonitasud',0),(466609,12962,'si','Provizije, ki je uspeÅ¡no posodobljena',0),(466610,12962,'ba','Komisi yang berhasil',0),(466611,12962,'nl','Commissies bijgewerkt',0),(466612,12962,'fi','PÃ¤ivitetty palkkiot',0),(466613,12962,'no','Provisjoner oppdatert',0),(466614,12962,'da','Provisioner opdateret',0),(466615,12962,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ìˆ˜ìˆ˜ë£Œ',0),(466616,12962,'he','×¢×ž×œ×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(466617,12962,'el','Î ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(466618,12962,'zh','å§”å‘˜ä¼šå·²æˆåŠŸæ›´æ–°',0),(466619,12962,'sv','Provisioner uppdaterats',0),(466620,12962,'it','Commissioni aggiornate con successo',0),(466621,12962,'tl','',0),(466622,12962,'th','à¸„à¸“à¸°à¸à¸£à¸£à¸¡à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(466623,12962,'hi','à¤†à¤¯à¥‹à¤—à¥‹à¤‚ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(466624,12962,'ms','Komisen yang berjaya dikemas kini',0),(466625,12962,'ar','Ø§Ù„Ù„Ø¬Ø§Ù† Ø§Ù„ØªÙŠ ØªÙ… ØªØ­Ø¯ÙŠØ«Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(466626,12962,'fr','Mis Ã  jour avec succÃ¨s les commissions',0),(466627,12962,'jp','æ­£å¸¸ã«æ›´æ–°æ‰‹æ•°æ–™',0),(466628,12962,'pt','ComissÃµes atualizadas com sucesso',0),(466629,12962,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¹, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(466630,12962,'es','Comisiones Actualizadas Exitosamente',0),(466631,12962,'de','Provisionen, die erfolgreich aktualisiert',0),(466632,12962,'en','Commissions Updated Successfully',0),(466633,12963,'is','',0),(466634,12963,'dr','ØªØ§Ø±ÛŒØ® Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(466635,12963,'pr','ØªØ§Ø±ÛŒØ® Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(466636,12963,'tr','Komisyon tarihi',0),(466637,12963,'pl','Komisja Data',0),(466638,12963,'bg','ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð´Ð°Ñ‚Ð°',0),(466639,12963,'ur','Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(466640,12963,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð´Ð°Ñ‚ÑƒÐ¼',0),(466641,12963,'vi','ngÃ y hoa há»“ng',0),(466642,12963,'af','Kommissie datum',0),(466643,12963,'ro','Data de Comisie',0),(466644,12963,'et','Komisjon kuupÃ¤eva',0),(466645,12963,'si','Komisija datum',0),(466646,12963,'ba','Komisi tanggal',0),(466647,12963,'nl','Commissie datum',0),(466648,12963,'fi','Komission pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(466649,12963,'no','Kommisjonen dato',0),(466650,12963,'da','Kommissionen dato',0),(466651,12963,'ko','ìœ„ì›íšŒ ë‚ ì§œ',0),(466652,12963,'he','×•×¢×“×ª ×ª××¨×™×š',0),(466653,12963,'el','Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(466654,12963,'zh','å§”å‘˜ä¼šæ—¥æœŸ',0),(466655,12963,'sv','Kommissionen datum',0),(466656,12963,'it','Data di Commissione',0),(466657,12963,'tl','',0),(466658,12963,'th','à¸§à¸±à¸™à¸„à¸“à¸°à¸à¸£à¸£à¸¡à¸à¸²à¸£',0),(466659,12963,'hi','à¤•à¤®à¥€à¤¶à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(466660,12963,'ms','Tarikh Suruhanjaya',0),(466661,12963,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù„Ø¬Ù†Ø©',0),(466662,12963,'fr','Date de la Commission',0),(466663,12963,'jp','å§”å“¡ä¼šã®æ—¥ä»˜',0),(466664,12963,'pt','ComissÃ£o data',0),(466665,12963,'ru','ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ð”Ð°Ñ‚Ð°',0),(466666,12963,'es','Fecha de ComisiÃ³n',0),(466667,12963,'de','Kommission Datum',0),(466668,12963,'en','Commission Date',0),(466669,12964,'is','',0),(466670,12964,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ú©Ù†ÛŒØ¯',0),(466671,12964,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ú©Ù†ÛŒØ¯',0),(466672,12964,'tr','Ã–deme yapmayÄ±nÄ±z',0),(466673,12964,'pl','Nie pÅ‚acÄ…',0),(466674,12964,'bg','ÐÐµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚',0),(466675,12964,'ur','Ø§Ø¯Ø§ Ù†ÛÛŒÚº Ú©Ø±ØªÛ’',0),(466676,12964,'sr','ÐÐµ Ð¿Ð»Ð°Ñ›Ð°Ñ˜Ñƒ',0),(466677,12964,'vi','KhÃ´ng tráº£',0),(466678,12964,'af','Betaal nie',0),(466679,12964,'ro','Nu plÄƒtiÅ£i',0),(466680,12964,'et','Ei maksa',0),(466681,12964,'si','Ne plaÄajo',0),(466682,12964,'ba','Tidak membayar',0),(466683,12964,'nl','Betaal niet',0),(466684,12964,'fi','EivÃ¤t maksa',0),(466685,12964,'no','Betal ikke',0),(466686,12964,'da','Betale ikke',0),(466687,12964,'ko','ì§€ë¶ˆ í•˜ì§€ ì•Šìœ¼ë©´',0),(466688,12964,'he','×œ× ×ž×©×œ×ž×™×',0),(466689,12964,'el','Î”ÎµÎ½ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½',0),(466690,12964,'zh','ä¸æ”¯ä»˜',0),(466691,12964,'sv','Betala inte',0),(466692,12964,'it','Non si paga',0),(466693,12964,'tl','',0),(466694,12964,'th','à¹„à¸¡à¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(466695,12964,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¤¤à¥‡',0),(466696,12964,'ms','Tidak perlu membayar',0),(466697,12964,'ar','ÙˆÙ„Ø§ ÙŠØ¯ÙØ¹',0),(466698,12964,'fr','Ne payez pas',0),(466699,12964,'jp','æ‰•ã£ã¦ã„ã¾ã›ã‚“ã€‚',0),(466700,12964,'pt','NÃ£o pagam',0),(466701,12964,'ru','ÐÐµ Ð¿Ð»Ð°Ñ‚ÑÑ‚',0),(466702,12964,'es','No Paga',0),(466703,12964,'de','Zahlen nicht',0),(466704,12964,'en','Do Not Pay',0),(466705,12965,'is','',0),(466706,12965,'dr','ÙÛŒÙ„ØªØ± Ø¨Ø§ ÙˆØ¶Ø¹ÛŒØª',0),(466707,12965,'pr','ÙÛŒÙ„ØªØ± Ø¨Ø§ ÙˆØ¶Ø¹ÛŒØª',0),(466708,12965,'tr','Duruma gÃ¶re filtre uygulama',0),(466709,12965,'pl','FiltrowaÄ‡ wedÅ‚ug stanu',0),(466710,12965,'bg','Ð¤Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°Ð¹ Ð¿Ð¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(466711,12965,'ur','ÙÙ„Ù¹Ø± Ø¨Ù…Ø·Ø§Ø¨Ù‚ Ø­Ø§Ù„Øª',0),(466712,12965,'sr','Ð¤Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾ ÑÑ‚Ð°Ñ‚ÑƒÑÑƒ',0),(466713,12965,'vi','Lá»c theo tráº¡ng thÃ¡i',0),(466714,12965,'af','Filter volgens Status',0),(466715,12965,'ro','Filtrare dupÄƒ stare',0),(466716,12965,'et','Filtreeri oleku jÃ¤rgi',0),(466717,12965,'si','Filtriraj po Status',0),(466718,12965,'ba','Filter menurut Status',0),(466719,12965,'nl','Filteren op Status',0),(466720,12965,'fi','Suodata tilan mukaan',0),(466721,12965,'no','Filtrer etter Status',0),(466722,12965,'da','Filtrer efter Status',0),(466723,12965,'ko','ìƒíƒœë³„ìœ¼ë¡œ í•„í„°ë§',0),(466724,12965,'he','×œ×¡× ×Ÿ ×œ×¤×™ ×ž×¦×‘',0),(466725,12965,'el','Î¦Î¹Î»Ï„ÏÎ¬ÏÎ¹ÏƒÎ¼Î± Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¿ ÎºÎ±Î¸ÎµÏƒÏ„ÏŽÏ‚',0),(466726,12965,'zh','æŒ‰çŠ¶æ€ç­›é€‰',0),(466727,12965,'sv','Filtrera efter Status',0),(466728,12965,'it','Filtra per stato',0),(466729,12965,'tl','',0),(466730,12965,'th','à¸à¸£à¸­à¸‡à¸•à¸²à¸¡à¸ªà¸–à¸²à¸™à¸°',0),(466731,12965,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¥‡ à¤…à¤¨à¥à¤¸à¤¾à¤° à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤° à¤•à¤°à¥‡à¤‚',0),(466732,12965,'ms','Menapis dengan Status',0),(466733,12965,'ar','ØªØµÙÙŠØ© Ø­Ø³Ø¨ Ø§Ù„Ø­Ø§Ù„Ø©',0),(466734,12965,'fr','Filtrer par statut',0),(466735,12965,'jp','ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã«ã‚ˆã‚‹ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼ã—ã¾ã™ã€‚',0),(466736,12965,'pt','Filtrar por Status',0),(466737,12965,'ru','Ð¤Ð¸Ð»ÑŒÑ‚Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð¾ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸ÑŽ',0),(466738,12965,'es','Filtrar Por SituaciÃ³n',0),(466739,12965,'de','Filtern nach Status',0),(466740,12965,'en','Filter By Status',0),(466741,12966,'is','',0),(466742,12966,'dr',' Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÛŒ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ÙˆÙ‚ØªÛŒ Ú©Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(466743,12966,'pr',' Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÛŒ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ ÙˆÙ‚ØªÛŒ Ú©Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(466744,12966,'tr','Ã–deme ne zaman satÄ±ÅŸ kiÅŸi Ã¶denen komisyon iÅŸaretle',0),(466745,12966,'pl','Znak Komisja wypÅ‚acane, gdy zostaÅ‚a wypÅ‚acona sprzedawcy',0),(466746,12966,'bg','ÐœÐ°Ñ€Ðº ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð¿Ð»Ð°Ñ‰Ð°, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð»Ð¸Ñ†Ðµ Ðµ Ð±Ð¸Ð»Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð°',0),(466747,12966,'ur','Ø³ÛŒÙ„Ø² Ø´Ø®Øµ Ø§Ø¯Ø§ Ù†ÛÛŒÚº Ú©ÛŒ Ú¯Ø¦ÛŒ ÛÛ’ Ø¬Ø¨ ØªÙ†Ø®ÙˆØ§Û Ú©Ù…ÛŒØ´Ù† Ú©Ùˆ Ù†Ø´Ø§Ù† Ø²Ø¯ Ú©Ø±ÛŒÚº',0),(466748,12966,'sr','ÐžÐ·Ð½Ð°Ñ‡Ð°Ð²Ð°ÑšÐµ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¿Ð»Ð°Ñ‚Ð¸Ð¾ ÐºÐ°Ð´Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¾ÑÐ¾Ð±Ð° Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð»Ð°',0),(466749,12966,'vi','Ä‘Ã¡nh dáº¥u tiá»n hoa há»“ng Ä‘Ã£ tráº£ khi nhÃ¢n viÃªn kinh doanh Ä‘Æ°á»£c thanh toÃ¡n',0),(466750,12966,'af','Merk die kommissie betaal wanneer die verkope persoon betaal is',0),(466751,12966,'ro','Marca Comisiei plÄƒtesc atunci cÃ¢nd persoana de vÃ¢nzÄƒri a fost plÄƒtit',0),(466752,12966,'et','MÃ¤rkida komisjoni kui mÃ¼Ã¼k isik Paide',0),(466753,12966,'si','OznaÄite provizije, plaÄane ko sales oseba plaÄana',0),(466754,12966,'ba','Menandai Komisi dibayar ketika orang penjualan telah dibayar',0),(466755,12966,'nl','Mark de Commissie betaald wanneer de verkoop persoon heeft betaald',0),(466756,12966,'fi','Merkitse tÃ¤mÃ¤n palkkion myyjÃ¤ maksettaessa',0),(466757,12966,'no','Merke Kommisjonen betalt nÃ¥r selgeren er innbetalt',0),(466758,12966,'da','Markere provision nÃ¥r salget person har betalt',0),(466759,12966,'ko','ë•Œ íŒë§¤ ì‚¬ëžŒì„ ì§€ë¶ˆì„ ì§€ë¶ˆ í•˜ëŠ” ìœ„ì›íšŒë¥¼ í‘œì‹œ',0),(466760,12966,'he','×œ×¡×ž×Ÿ ××ª ×”×¢×ž×œ×” ×©×™×œ×ž×ª×™ ×›××©×¨ ××™×© ×ž×›×™×¨×•×ª ×›×‘×¨ ×©×•×œ×',0),(466761,12966,'el','Î•Ï€Î¹ÏƒÎ·Î¼Î¬Î½ÎµÏ„Îµ Ï„Î·Î½ Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹Î± Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹ ÏŒÏ„Î±Î½ Ï„Î¿ Ï€ÏÏŒÏƒÏ‰Ï€Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€Î¿Ï… Î­Ï‡ÎµÎ¹ ÎºÎ±Ï„Î±Î²Î»Î·Î¸ÎµÎ¯',0),(466762,12966,'zh','æ ‡è®°çš„é”€å”®äººå‘˜å·²æ”¯ä»˜æ—¶ï¼Œéœ€æ”¯ä»˜ä½£é‡‘',0),(466763,12966,'sv','Markera den provision som betalas nÃ¤r fÃ¶rsÃ¤ljare som har betalats',0),(466764,12966,'it','Contrassegnare la Commissione pagata quando il venditore Ã¨ stata pagata',0),(466765,12966,'tl','',0),(466766,12966,'th','à¸—à¸³à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸ªà¸£à¸´à¸¡à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢à¹€à¸¡à¸·à¹ˆà¸­à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢à¹„à¸”à¹‰à¸£à¸±à¸šà¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(466767,12966,'hi','à¤œà¤¬ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤†à¤¯à¥‹à¤— à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(466768,12966,'ms','Tandakan Suruhanjaya dibayar apabila orang jualan yang telah dibayar',0),(466769,12966,'ar','ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù„Ø¬Ù†Ø© ØªØ¯ÙØ¹ Ø¹Ù†Ø¯Ù…Ø§ Ø³Ø¯Ø¯ Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(466770,12966,'fr','Marquer la commission versÃ©e lorsque le vendeur a Ã©tÃ© payÃ©',0),(466771,12966,'jp','å–¶æ¥­æ‹…å½“è€…ãŒæ”¯æ‰•ã‚ã‚Œã¦ã„ã‚‹ã¨ãã«æ”¯æ‰•ã‚ã‚Œã‚‹ä»»å‹™ã‚’ãƒžãƒ¼ã‚¯ã—ã¾ã™ã€‚',0),(466772,12966,'pt','Marcar a ComissÃ£o paga quando o vendedor tiver sido paga',0),(466773,12966,'ru','ÐœÐ°Ñ€Ðº ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸, ÐºÐ¾Ð³Ð´Ð° Ð±Ñ‹Ð» Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½ Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°Ð¼',0),(466774,12966,'es','Marcar las comisiones pagadas cuando el vendedor habÃ­a pagado',0),(466775,12966,'de','Markieren Sie die Kommission gezahlt, wenn der VerkÃ¤ufer gezahlt worden ist',0),(466776,12966,'en','Mark the commission paid when the sales person has been paid',0),(466777,12967,'is','',0),(466778,12967,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(466779,12967,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(466780,12967,'tr','Fatura iÃ§in Ã¶deme alÄ±ndÄ±ktan',0),(466781,12967,'pl','Otrzymano pÅ‚atnoÅ›ci za faktury',0),(466782,12967,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾ Ðµ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¾ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°',0),(466783,12967,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…ÙˆØµÙˆÙ„ Ù†ÛÛŒÚº ÛÙˆØ¦ÛŒ ÛÛ’',0),(466784,12967,'sr','Ð¡Ñ‚Ð¸Ð³Ð»Ð° Ñ˜Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(466785,12967,'vi','thanh toÃ¡n Ä‘Ã£ Ä‘Æ°á»£c nháº­n cho hÃ³a Ä‘Æ¡n',0),(466786,12967,'af','Betaling ontvang is vir die faktuur',0),(466787,12967,'ro','S-a primit de platÄƒ pentru factura',0),(466788,12967,'et','OsavÃµtutasu arve laekumist',0),(466789,12967,'si','Prejetju raÄuna',0),(466790,12967,'ba','Pembayaran yang telah diterima untuk faktur',0),(466791,12967,'nl','Betaling heeft ontvangen voor de factuur',0),(466792,12967,'fi','Maksu on saatu laskun',0),(466793,12967,'no','Betaling er mottatt for fakturaen',0),(466794,12967,'da','Betaling er for fakturaen modtaget',0),(466795,12967,'ko','ì†¡ìž¥ì— ëŒ€ í•œ ì§€ë¶ˆì´ ì ‘ìˆ˜ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(466796,12967,'he','×”×ª×©×œ×•× ×©×”×ª×§×‘×œ ×¢×‘×•×¨ ×”×—×©×‘×•× ×™×ª',0),(466797,12967,'el','Î Î»Î·ÏÏ‰Î¼Î®Ï‚ Î­Ï‡ÎµÎ¹ Î»Î·Ï†Î¸ÎµÎ¯ Î³Î¹Î± Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(466798,12967,'zh','ä»˜æ¬¾çš„å‘ç¥¨',0),(466799,12967,'sv','Betalning har mottagits fÃ¶r fakturan',0),(466800,12967,'it','Pagamento Ã¨ stato ricevuto per la fattura',0),(466801,12967,'tl','',0),(466802,12967,'th','à¹„à¸”à¹‰à¸£à¸±à¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(466803,12967,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(466804,12967,'ms','Bayaran telah diterima untuk invois',0),(466805,12967,'ar','ØªÙ… Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ø¯ÙØ¹ Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(466806,12967,'fr','Paiement a Ã©tÃ© reÃ§u pour la facture',0),(466807,12967,'jp','è«‹æ±‚æ›¸ã®æ”¯æ‰•ã„ã‚’å—ã‘ãŸ',0),(466808,12967,'pt','Pagamento foi recebido para a factura',0),(466809,12967,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶ Ð±Ñ‹Ð» Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½ Ð·Ð° ÑÑ‡ÐµÑ‚',0),(466810,12967,'es','Pago se RecibiÃ³ para \r\nEsta Factura',0),(466811,12967,'de','Zahlung hat fÃ¼r die Rechnung',0),(466812,12967,'en','Payment has been received for the invoice',0),(466813,12968,'is','',0),(466814,12968,'dr','Ù‡Ø± Ù‚Ù„Ù… Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± Ø´Ø¯Ù‡',0),(466815,12968,'pr','Ù‡Ø± Ù‚Ù„Ù… Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± Ø´Ø¯Ù‡',0),(466816,12968,'tr','Faturalanan envanter madde bazÄ±nda',0),(466817,12968,'pl','Na pozycji zafakturowanych zapasÃ³w',0),(466818,12968,'bg','ÐÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ ÑÐºÐ»Ð°Ð´Ð¾Ð² Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(466819,12968,'ur','ÙÛŒ Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’',0),(466820,12968,'sr','ÐŸÐ¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(466821,12968,'vi','tá»«ng má»¥c hÃ ng Ä‘Æ°á»£c xuáº¥t hÃ³a Ä‘Æ¡n',0),(466822,12968,'af','Per Invoiced voorraad Item',0),(466823,12968,'ro','Fiecare element de inventar facturate',0),(466824,12968,'et','Arveldatud varudes oleva kauba kohta',0),(466825,12968,'si','Na fakturiranih zaloge artikla',0),(466826,12968,'ba','Per Item persediaan tagihan',0),(466827,12968,'nl','Per gefactureerde voorraadartikel',0),(466828,12968,'fi','Laskutettua nimikettÃ¤ kohti',0),(466829,12968,'no','Per fakturerte lagervare',0),(466830,12968,'da','Per fakturerede lagervare',0),(466831,12968,'ko','ì²­êµ¬ì„œ ìž¬ê³  í•­ëª© ë‹¹',0),(466832,12968,'he','×œ×›×œ ×¤×¨×™×˜ ×ž×œ××™ ×©×—×•×™×‘×”',0),(466833,12968,'el','Î‘Î½Î¬ ÎµÎ¯Î´Î¿Ï‚ Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(466834,12968,'zh','æ¯ä¸ªå¼€ç¥¨çš„åº“å­˜é¡¹ç›®',0),(466835,12968,'sv','Per fakturerad lagerartikel',0),(466836,12968,'it','Per ogni articolo di magazzino fatturata',0),(466837,12968,'tl','',0),(466838,12968,'th','à¸•à¹ˆà¸­à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(466839,12968,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¤¿à¤ à¤—à¤ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¤à¤¿',0),(466840,12968,'ms','Satu inventori invois',0),(466841,12968,'ar','ÙƒÙ„ ØµÙ†Ù Ø¨Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(466842,12968,'fr','Par article de stock facturÃ©',0),(466843,12968,'jp','è«‹æ±‚æ›¸ã®åœ¨åº«å“ç›®ã”ã¨',0),(466844,12968,'pt','Por Item de inventÃ¡rio facturado',0),(466845,12968,'ru','Ð—Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ ÑÑ‡ÐµÑ‚Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(466846,12968,'es','Item de Inventario Por Factura',0),(466847,12968,'de','Pro fakturierten Lagerartikel',0),(466848,12968,'en','Per Invoiced Inventory Item',0),(466849,12969,'is','',0),(466850,12969,'dr','Ù…ÛŒØ²Ø§Ù† Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(466851,12969,'pr','Ù…ÛŒØ²Ø§Ù† Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(466852,12969,'tr','SatÄ±ÅŸ temsilcisi iÃ§in komisyon oranÄ± kullanÄ±lÄ±r',0),(466853,12969,'pl','Stawka prowizji dla sprzedawcy jest uÅ¼ywany',0),(466854,12969,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ÑŠÑ‚ Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð»Ð¸Ñ†Ðµ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°',0),(466855,12969,'ur','Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ø´Ø±Ø­ Ø³ÛŒÙ„Ø² Ø´Ø®Øµ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(466856,12969,'sr','Ð¡Ñ‚Ð¾Ð¿Ð° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¾ÑÐ¾Ð±Ñƒ ÐºÐ¾Ñ˜Ð° ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸.',0),(466857,12969,'vi','Tá»· lá»‡ pháº§n trÄƒm hoa há»“ng cá»§a ngÆ°á»i bÃ¡n hÃ ng Ä‘Æ°á»£c sá»­ dá»¥ng ',0),(466858,12969,'af','Die Kommissie koers vir die verkope persoon gebruik is',0),(466859,12969,'ro','Rata comision pentru persoana de vÃ¢nzÄƒri este utilizat',0),(466860,12969,'et','MÃ¼Ã¼k isik komisjonile mÃ¤Ã¤ra kasutatakse',0),(466861,12969,'si','Stopnja provizije za prodajalca se uporablja',0),(466862,12969,'ba','Tingkat komisi untuk penjualan orang digunakan',0),(466863,12969,'nl','De Commissie tarief voor de verkoop persoon wordt gebruikt',0),(466864,12969,'fi','MyyjÃ¤ provision kÃ¤ytetÃ¤Ã¤n',0),(466865,12969,'no','Kommisjon for selgeren brukes',0),(466866,12969,'da','Provisionssats for salget person bruges',0),(466867,12969,'ko','íŒë§¤ ì‚¬ëžŒì— ëŒ€ í•œ ìˆ˜ìˆ˜ë£Œ ë¹„ìœ¨ ì‚¬ìš©',0),(466868,12969,'he','×©×™×¢×•×¨ ×”×¢×ž×œ×” ×¢×‘×•×¨ ××™×© ×ž×›×™×¨×•×ª ×ž×©×ž×©',0),(466869,12969,'el','Î— Î¹ÏƒÎ¿Ï„Î¹Î¼Î¯Î± Ï„Î·Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®Ï‚ Î³Î¹Î± Ï„Î¿ Ï€ÏÏŒÏƒÏ‰Ï€Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹',0),(466870,12969,'zh','ç»™é”€å”®äººå‘˜çš„ä½£é‡‘çŽ‡ä½¿ç”¨',0),(466871,12969,'sv','Provisionssats fÃ¶r fÃ¶rsÃ¤ljare som anvÃ¤nds',0),(466872,12969,'it','Il tasso di Commissione per la persona di vendite Ã¨ utilizzato',0),(466873,12969,'tl','',0),(466874,12969,'th','à¹ƒà¸Šà¹‰à¸­à¸±à¸•à¸£à¸²à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¹ˆà¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢',0),(466875,12969,'hi','à¤†à¤¯à¥‹à¤— à¤¦à¤° à¤¬à¤¿à¤•à¥à¤°à¥€ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¯à¥‹à¤— à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¹à¥ˆ',0),(466876,12969,'ms','Kadar komisen untuk jualan orang digunakan',0),(466877,12969,'ar','ÙŠØªÙ… Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù…Ø¹Ø¯Ù„ Ø§Ù„Ù„Ø¬Ù†Ø© Ù„Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(466878,12969,'fr','Le taux de commission pour le vendeur est utilisÃ©',0),(466879,12969,'jp','è²©å£²å“¡ã®æ‰‹æ•°æ–™çŽ‡ã®ä½¿ç”¨ã—ã¾ã™ã€‚',0),(466880,12969,'pt','A taxa de ComissÃ£o para o vendedor Ã© usada',0),(466881,12969,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ ÑÑ‚Ð°Ð²ÐºÐ° ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°Ð¼',0),(466882,12969,'es','La tasa de comisiÃ³n para el vendedor se utiliza',0),(466883,12969,'de','Die Provision fÃ¼r den Vertriebsmitarbeiter wird verwendet',0),(466884,12969,'en','The commission rate for the sales person is used',0),(466885,12970,'is','',0),(466886,12970,'dr','ÙØ§Ú©ØªÙˆØ± Ù‡Ù†ÙˆØ² Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(466887,12970,'pr','ÙØ§Ú©ØªÙˆØ± Ù‡Ù†ÙˆØ² Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(466888,12970,'tr','FaturayÄ± henÃ¼z Ã¶denmemiÅŸ',0),(466889,12970,'pl','Faktury nie zostaÅ‚y jeszcze wypÅ‚acone',0),(466890,12970,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð²ÑÐµ Ð¾Ñ‰Ðµ Ð½Ðµ Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¾',0),(466891,12970,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ø¨Ú¾ÛŒ ØªÚ© Ø¯ÛŒ Ø¬Ø§ØªÛŒ ÛÛ’ Ù†Û',0),(466892,12970,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ñ˜Ð¾Ñˆ Ð½Ð¸Ñ˜Ðµ Ð¿Ð»Ð°Ñ›ÐµÐ½Ð°',0),(466893,12970,'vi','HÃ³a Ä‘Æ¡n nÃ y váº«n chÆ°a Ä‘Æ°á»£c thanh toÃ¡n',0),(466894,12970,'af','Die faktuur het nie nog betaal is',0),(466895,12970,'ro','Factura nu a fost Ã®ncÄƒ plÄƒtite',0),(466896,12970,'et','Arve ei ole veel makstud',0),(466897,12970,'si','RaÄunu Å¡e niso bili plaÄani',0),(466898,12970,'ba','Faktur belum dibayar',0),(466899,12970,'nl','De factuur is nog niet betaald',0),(466900,12970,'fi','Lasku ei ole vielÃ¤ maksettu',0),(466901,12970,'no','Fakturaen er ennÃ¥ ikke betalt',0),(466902,12970,'da','Fakturaen endnu ikke er blevet betalt',0),(466903,12970,'ko','ì†¡ìž¥ ì•„ì§ ì§€ë¶ˆ í•˜ì§€ ì•Šì€',0),(466904,12970,'he','×”×—×©×‘×•× ×™×ª ×™×© ×©×˜×¨× × ×¤×¨×¢×•',0),(466905,12970,'el','Î”ÎµÎ½ Î­Ï‡ÎµÎ¹ Ï€Î»Î·ÏÏŽÏƒÎµÎ¹ Î±ÎºÏŒÎ¼Î± Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(466906,12970,'zh','å°šæœªæ”¯ä»˜çš„å‘ç¥¨',0),(466907,12970,'sv','Fakturan har Ã¤nnu inte betalats',0),(466908,12970,'it','La fattura non Ã¨ ancora stata pagata',0),(466909,12970,'tl','',0),(466910,12970,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(466911,12970,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤…à¤­à¥€ à¤¤à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(466912,12970,'ms','Invois telah masih belum dibayar',0),(466913,12970,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù„Ù… ØªØ³Ø¯Ø¯ Ø¨Ø¹Ø¯',0),(466914,12970,'fr','La facture n\'a pas encore Ã©tÃ© payÃ©e',0),(466915,12970,'jp','è«‹æ±‚æ›¸ãŒã¾ã æ”¯æ‰•ã‚ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(466916,12970,'pt','A factura ainda nÃ£o foi pago',0),(466917,12970,'ru','Ð¡Ñ‡ÐµÑ‚ Ð½Ðµ Ð±Ñ‹Ð» Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½',0),(466918,12970,'es','La Factura TodavÃ­a no se ha pagado',0),(466919,12970,'de','Die Rechnung wurde noch nicht bezahlt',0),(466920,12970,'en','The invoice has not yet been paid',0),(466921,12971,'is','',0),(466922,12971,'dr','Ø§Ù‚Ù„Ø§Ù… Ø¯Ø± ÙØ§Ú©ØªÙˆØ± Ø¨Ø§ÛŒØ¯ ÛŒÚ© ØªÙ†Ø¸ÛŒÙ… Ù…Ù‚Ø¯Ø§Ø± Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ù†Ø¯',0),(466923,12971,'pr','Ø§Ù‚Ù„Ø§Ù… Ø¯Ø± ÙØ§Ú©ØªÙˆØ± Ø¨Ø§ÛŒØ¯ ÛŒÚ© ØªÙ†Ø¸ÛŒÙ… Ù…Ù‚Ø¯Ø§Ø± Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ù†Ø¯',0),(466924,12971,'tr','Faturadaki maddelerin bir komisyon tutarÄ± ayarla olmalÄ±dÄ±r',0),(466925,12971,'pl','Pozycji na fakturze musi mieÄ‡ kwoty Komisja zestaw',0),(466926,12971,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸Ñ‚Ðµ Ð²ÑŠÐ² Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° ÑÑƒÐ¼Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(466927,12971,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù¾Ø± Ø§Ø´ÛŒØ§ Ø§ÛŒÚ© Ú©Ù…ÛŒØ´Ù† Ø±Ù‚Ù… Ù…Ù‚Ø±Ø± ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(466928,12971,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ»Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¼Ð¾Ñ€Ð° Ð¸Ð¼Ð°Ñ‚Ð¸ Ð¸Ð·Ð½Ð¾Ñ Ñƒ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð¸, Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ',0),(466929,12971,'vi','CÃ¡i máº·t hÃ ng trÃªn hÃ³a Ä‘Æ¡n nÃ y pháº£i cÃ³ sá»‘ tiá»n hoa há»“ng',0),(466930,12971,'af','Die items op die faktuur moet \'n Kommissie bedrag gestel het',0),(466931,12971,'ro','Elementele care figureazÄƒ pe facturÄƒ trebuie sÄƒ aibÄƒ o sumÄƒ de Comisia stabilit',0),(466932,12971,'et','Arvel olevad kaubad peavad olema mÃ¤Ã¤ratud komisjoni summa',0),(466933,12971,'si','Artikle na raÄunu morajo imeti Komisija znesek, nastavite',0),(466934,12971,'ba','Item pada faktur harus memiliki jumlah Komisi ditetapkan',0),(466935,12971,'nl','De artikelen op de factuur moeten beschikken over een bedrag van de Commissie instellen',0),(466936,12971,'fi','Laskussa olevat nimikkeet on provision mÃ¤Ã¤rÃ¤ asettaa',0),(466937,12971,'no','Varene pÃ¥ fakturaen mÃ¥ ha en provisjonsbelÃ¸pet satt',0),(466938,12971,'da','Varerne pÃ¥ fakturaen skal have en Kommissionen belÃ¸b',0),(466939,12971,'ko','ì†¡ìž¥ì— í•­ëª© ìˆ˜ìˆ˜ë£Œ ê¸ˆì•¡ì„ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(466940,12971,'he','×”×¤×¨×™×˜×™× ×‘×—×©×‘×•× ×™×ª ×—×™×™×‘ ×œ×”×™×•×ª ×¡×›×•× ×”×¢×ž×œ×” ×œ×”×’×“×™×¨',0),(466941,12971,'el','Î¤Î± ÎµÎ¯Î´Î· Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÎ¹ Î¼Î¹Î± Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Ï€Î¿ÏƒÏŒ Ï€Î¿Ï…',0),(466942,12971,'zh','è¿™äº›é¡¹ç›®åœ¨å‘ç¥¨ä¸Šçš„å¿…é¡»æœ‰è®¾ç½®ä½£é‡‘é‡‘é¢',0),(466943,12971,'sv','Artiklarna pÃ¥ fakturan mÃ¥ste ha en kommissionen belopp',0),(466944,12971,'it','Le voci sulla fattura devono avere una quantitÃ  di Commissione impostare',0),(466945,12971,'tl','',0),(466946,12971,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸ˆà¸³à¸™à¸§à¸™à¸„à¸“à¸°à¸à¸£à¸£à¸¡à¸à¸²à¸£à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡',0),(466947,12971,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤ªà¤° à¤†à¤‡à¤Ÿà¤® à¤à¤• à¤•à¤®à¥€à¤¶à¤¨ à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(466948,12971,'ms','Item-item pada invois mesti mempunyai jumlah komisen yang ditetapkan',0),(466949,12971,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ø¨Ù†ÙˆØ¯ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù…Ø¨Ù„Øº Ø§Ù„Ø¹Ù…ÙˆÙ„Ø© ØªØ¹ÙŠÙŠÙ†',0),(466950,12971,'fr','Les Ã©lÃ©ments sur la facture doivent avoir un montant de commission',0),(466951,12971,'jp','è«‹æ±‚æ›¸ã®é …ç›®ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™è¨­å®šã®ã‚³ãƒŸãƒƒã‚·ãƒ§ãƒ³é‡‘é¡',0),(466952,12971,'pt','Os itens na factura devem ter uma quantidade de ComissÃ£o definido',0),(466953,12971,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð½Ð° ÑÑ‡ÐµÑ‚Ðµ-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ, Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¸Ð¼ÐµÑ‚ÑŒ Ñ€Ð°Ð·Ð¼ÐµÑ€ ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(466954,12971,'es','Los items en la factura deben tener una cantidad de comisi\'on configurada',0),(466955,12971,'de','Die Elemente auf der Rechnung mÃ¼ssen einen Provisionsbetrag festgelegt',0),(466956,12971,'en','The items on the invoice must have a commission amount set',0),(466957,12972,'is','',0),(466958,12972,'dr','Ø§ÛŒÙ† Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ù†Ø¨Ø§ÛŒØ¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ø¯ ÙˆÙ†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø¯Ø±Ù…Ø¬Ù…ÙˆØ¹ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯  ',0),(466959,12972,'pr','Ø§ÛŒÙ† Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ù†Ø¨Ø§ÛŒØ¯ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ø¯ ÙˆÙ†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø¯Ø±Ù…Ø¬Ù…ÙˆØ¹ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯  ',0),(466960,12972,'tr','Bu komisyon Ã¶deme yapÄ±lmayacaÄŸÄ±nÄ± ve toplamlarÄ± dahil deÄŸildir',0),(466961,12972,'pl','Komisja nie powinna byÄ‡ wypÅ‚acona i nie jest uwzglÄ™dniony w sum',0),(466962,12972,'bg','Ð¢Ð°Ð·Ð¸ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð»Ð°Ñ‰Ð° Ð¸ Ð½Ðµ Ðµ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð° Ð² ÑÑƒÐ¼Ð¸Ñ‚Ðµ',0),(466963,12972,'ur','ÛŒÛ Ú©Ù…ÛŒØ´Ù† Ø§Ø¯Ø§ Ù†ÛÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛØ¦Û’ Ø§ÙˆØ± Ù…ÛŒØ²Ø§Ù† Ù…ÛŒÚº Ø´Ø§Ù…Ù„ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(466964,12972,'sr','ÐžÐ²Ð° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð½Ðµ Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° ÑÐµ Ð¿Ð»Ð°Ñ‚Ð¸ Ð¸ Ð½Ð¸Ñ˜Ðµ ÑƒÐºÑ™ÑƒÑ‡ÐµÐ½ Ñƒ Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(466965,12972,'vi','Hoa há»“ng nÃ y khÃ´ng nÃªn Ä‘Æ°á»£c tráº£ vÃ  khÃ´ng bao gá»“m trong pháº§n tá»•ng cá»™ng',0),(466966,12972,'af','Hierdie Kommissie moet nie betaal word nie en is nie ingesluit in die totale',0),(466967,12972,'ro','Aceasta Comisie nu ar trebui sÄƒ fie plÄƒtite ÅŸi nu este inclus Ã®n totaluri',0),(466968,12972,'et','See komisjon peaks maksmata ning on kaasatud kogusummade',0),(466969,12972,'si','To Komisiji ne bi smelo biti plaÄano in niso vkljuÄeni v vsote',0),(466970,12972,'ba','Komisi ini tidak boleh dibayar dan tidak termasuk dalam Total',0),(466971,12972,'nl','Deze Commissie mag niet worden betaald en is niet opgenomen in totalen',0),(466972,12972,'fi','Komissio ei makseta ja ei sisÃ¤lly summat',0),(466973,12972,'no','Denne kommisjonen ikke skal betales og er ikke inkludert i totaler',0),(466974,12972,'da','Kommissionen bÃ¸r ikke betales og er ikke inkluderet i totaler',0),(466975,12972,'ko','ì´ ìœ„ì›íšŒëŠ” ì§€ë¶ˆ ë˜ì§€ ì•Šì„ í•©ê³„ì— í¬í•¨ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(466976,12972,'he','×”×¢×ž×œ×” ×”×–××ª ×œ× ×¦×¨×™×š ×œ×”×™×•×ª ×ž×©×•×œ×, ××™× ×” ×›×œ×•×œ×” ×¡×›×•×ž×™×',0),(466977,12972,'el','Î‘Ï…Ï„Î® Î· Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® Î´ÎµÎ½ Î¸Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î´Î¿Î¸ÎµÎ¯ ÎºÎ±Î¹ Î´ÎµÎ½ Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÏ„Î±Î¹ ÏƒÏ„Î± ÏƒÏÎ½Î¿Î»Î±',0),(466978,12972,'zh','è¿™ä¸ªå§”å‘˜ä¼šä¸åº”æ”¯ä»˜å’Œä¸è®¡å…¥æ€»æ•°',0),(466979,12972,'sv','Denna kommission inte bÃ¶r betalas och ingÃ¥r inte i summor',0),(466980,12972,'it','Questa Commissione non dovrebbe essere pagata e non Ã¨ inclusa nei totali',0),(466981,12972,'tl','',0),(466982,12972,'th','à¸„à¸“à¸°à¸à¸£à¸£à¸¡à¸à¸²à¸£à¹„à¸¡à¹ˆà¸„à¸§à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ à¹à¸¥à¸°à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸£à¸§à¸¡à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸œà¸¥à¸£à¸§à¸¡',0),(466983,12972,'hi','à¤‡à¤¸ à¤•à¤®à¥€à¤¶à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤ à¤”à¤° à¤¯à¥‹à¤— à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(466984,12972,'ms','Suruhanjaya ini tidak akan dibayar dan tidak termasuk dalam jumlah',0),(466985,12972,'ar','Ù‡Ø°Ù‡ Ø§Ù„Ù„Ø¬Ù†Ø© Ù„Ø§ ÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ØªØ¯ÙØ¹ØŒ ÙˆÙ„Ø§ ØªØ¯Ø±Ø¬ ÙÙŠ Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹',0),(466986,12972,'fr','Cette commission ne devrait pas Ãªtre payÃ©e et n\'est pas incluse dans les totaux',0),(466987,12972,'jp','ã“ã®å§”å“¡ä¼šã¯æ”¯æ‰•ã‚ã‚Œãªã„ã¨åˆè¨ˆã«ã¯å«ã¾ã‚Œã¾ã›ã‚“',0),(466988,12972,'pt','Esta ComissÃ£o nÃ£o deveria ser pago e nÃ£o estÃ¡ incluÃ­do nos totais',0),(466989,12972,'ru','Ð­Ñ‚Ð° ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ñ Ð½Ðµ Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ Ð¸ Ð½Ðµ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ Ð² Ð¸Ñ‚Ð¾Ð³Ð¾Ð²Ñ‹Ðµ',0),(466990,12972,'es','Esta ComisiÃ³n no se debe pagar y no estÃ¡ incluido en los totales',0),(466991,12972,'de','Diese Kommission sollte nicht gezahlt werden und nicht in Summen enthalten',0),(466992,12972,'en','This commission should not be paid and is not included in totals',0),(466993,12973,'is','',0),(466994,12973,'dr','Ù†Ù…Ø§ÛŒØ´ Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ù‡Ø§',0),(466995,12973,'pr','Ù†Ù…Ø§ÛŒØ´ Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ù‡Ø§',0),(466996,12973,'tr','GÃ¶rÃ¼nÃ¼m komisyonlarÄ±',0),(466997,12973,'pl','Widok prowizji',0),(466998,12973,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸',0),(466999,12973,'ur','Ù…Ù†Ø¸Ø± Ú©Ù…ÛŒØ´Ù†ÙˆÚº',0),(467000,12973,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ñ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ðµ',0),(467001,12973,'vi','Xem hoa há»“ng',0),(467002,12973,'af','Bekyk kommissies',0),(467003,12973,'ro','Vezi comisii',0),(467004,12973,'et','Vaade komisjonitasud',0),(467005,12973,'si','Pogled komisij',0),(467006,12973,'ba','Lihat komisi',0),(467007,12973,'nl','Weergave commissies',0),(467008,12973,'fi','NÃ¤ytÃ¤ palkkiot',0),(467009,12973,'no','Vis provisjoner',0),(467010,12973,'da','Se provisioner',0),(467011,12973,'ko','ë³´ê¸° ìœ„ì›íšŒ',0),(467012,12973,'he','×ª×¦×•×’×ª ×¢×ž×œ×•×ª',0),(467013,12973,'el','Î†Ï€Î¿ÏˆÎ· Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚',0),(467014,12973,'zh','è§†å›¾ä½£é‡‘',0),(467015,12973,'sv','Visa provisioner',0),(467016,12973,'it','Vista commissioni',0),(467017,12973,'tl','',0),(467018,12973,'th','à¸”à¸¹à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™',0),(467019,12973,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤†à¤¯à¥‹à¤—à¥‹à¤‚',0),(467020,12973,'ms','Pandangan Suruhanjaya',0),(467021,12973,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù„Ø¬Ø§Ù†',0),(467022,12973,'fr','Voir Commissions',0),(467023,12973,'jp','ãƒ“ãƒ¥ãƒ¼ã®æ‰‹æ•°æ–™',0),(467024,12973,'pt','ComissÃµes de exibiÃ§Ã£o',0),(467025,12973,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¹',0),(467026,12973,'es','Vistar Comisiones',0),(467027,12973,'de','Ansicht-Kommissionen',0),(467028,12973,'en','View Commissions',0),(467029,12974,'is','',0),(467030,12974,'dr','Ú©Ø§Ù„Ø§ÛŒ Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ø«Ø§Ø¨Øª',0),(467031,12974,'pr','Ú©Ø§Ù„Ø§ÛŒ Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ø«Ø§Ø¨Øª',0),(467032,12974,'tr','Madde dÃ¼z Komisyonu',0),(467033,12974,'pl','Element pÅ‚aski Komisji',0),(467034,12974,'bg','ÐŸÐ»Ð¾ÑÑŠÐº ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(467035,12974,'ur','Ø´Û’ ÙÙ„ÛŒÙ¹ Ú©Ù…ÛŒØ´Ù†',0),(467036,12974,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ñ€Ð°Ð²Ð°Ð½ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ðµ',0),(467037,12974,'vi','máº·t báº±ng hoa há»“ng hÃ ng',0),(467038,12974,'af','Item plat Kommissie',0),(467039,12974,'ro','Elementul plat Comisiei',0),(467040,12974,'et','Ãœksuse tasasele komisjoni',0),(467041,12974,'si','Element ravno Komisija',0),(467042,12974,'ba','Item datar komisi',0),(467043,12974,'nl','Item platte Commissie',0),(467044,12974,'fi','Nimikkeen tasainen komission',0),(467045,12974,'no','Elementet Flat kommisjonen',0),(467046,12974,'da','Vare flad Kommissionen',0),(467047,12974,'ko','í•­ëª© íŽ¸í‰í•œ ìœ„ì›íšŒ',0),(467048,12974,'he','×”× ×¦×™×‘×•×ª ×©×˜×•×— ×¤×¨×™×˜',0),(467049,12974,'el','Î•Ï€Î¯Ï€ÎµÎ´Î· Î•Ï€Î¹Ï„ÏÎ¿Ï€Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(467050,12974,'zh','é¡¹å¹³å§”å‘˜ä¼š',0),(467051,12974,'sv','Objektet platt kommissionen',0),(467052,12974,'it','Elemento piatto Commissione',0),(467053,12974,'tl','',0),(467054,12974,'th','à¸™à¸²à¸¢à¹à¸šà¸™à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(467055,12974,'hi','à¤†à¤‡à¤Ÿà¤® à¤«à¥à¤²à¥ˆà¤Ÿ à¤†à¤¯à¥‹à¤—',0),(467056,12974,'ms','Item rata Suruhanjaya',0),(467057,12974,'ar','Ø§Ù„Ù„Ø¬Ù†Ø© Ø§Ù„Ø¨Ù†Ø¯ Ù…Ø³Ø·Ø­',0),(467058,12974,'fr','Point plat Commission',0),(467059,12974,'jp','é …ç›®ã®ãƒ•ãƒ©ãƒƒãƒˆãªæ‰‹æ•°æ–™',0),(467060,12974,'pt','ComissÃ£o plano de item',0),(467061,12974,'ru','ÐŸÐ»Ð¾ÑÐºÐ¸Ð¹ ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ð¿ÑƒÐ½ÐºÑ‚',0),(467062,12974,'es','Item ComisiÃ³n Fijo',0),(467063,12974,'de','Element-flach-Kommission',0),(467064,12974,'en','Item Flat Commission',0),(467065,12975,'is','',0),(467066,12975,'dr','Ø¯Ø±ØµØ¯ Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ú©Ø§Ù„Ø§ ',0),(467067,12975,'pr','Ø¯Ø±ØµØ¯ Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ú©Ø§Ù„Ø§ ',0),(467068,12975,'tr','Madde yÃ¼zde Komisyonu',0),(467069,12975,'pl','Element procent Komisji',0),(467070,12975,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(467071,12975,'ur','Ø´Û’ ÙÛŒØµØ¯ Ú©Ù…ÛŒØ´Ù†',0),(467072,12975,'sr','ÐšÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð·Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(467073,12975,'vi','pháº§n trÄƒm hoa há»“ng hÃ ng',0),(467074,12975,'af','Item persent Kommissie',0),(467075,12975,'ro','Element Comisiei la sutÄƒ',0),(467076,12975,'et','Kauba protsenti komisjoni',0),(467077,12975,'si','Element odstotek provizije',0),(467078,12975,'ba','Komisi persen barang',0),(467079,12975,'nl','Item percentage Commissie',0),(467080,12975,'fi','Nimikkeen prosenttia komission',0),(467081,12975,'no','Elementet prosent kommisjonen',0),(467082,12975,'da','Vare procent Kommissionen',0),(467083,12975,'ko','í•­ëª© % ìœ„ì›íšŒ',0),(467084,12975,'he','×¤×¨×™×˜ ××—×•×–×™× ×”× ×¦×™×‘×•×ª',0),(467085,12975,'el','Î Î¿ÏƒÎ¿ÏƒÏ„Î¹Î±Î¯Î± Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(467086,12975,'zh','é¡¹ç›®ç™¾åˆ†æ¯”å§”å‘˜ä¼š',0),(467087,12975,'sv','Objektet procent kommissionen',0),(467088,12975,'it','Elemento Commissione percentuale',0),(467089,12975,'tl','',0),(467090,12975,'th','à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™à¹€à¸›à¹‡à¸™à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸‚à¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(467091,12975,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¤®à¥€à¤¶à¤¨',0),(467092,12975,'ms','Suruhanjaya peratus item',0),(467093,12975,'ar','Ù„Ø¬Ù†Ø© Ø§Ù„Ù…Ø¦Ø© Ø§Ù„Ø¨Ù†Ø¯',0),(467094,12975,'fr','Point pourcentage Commission',0),(467095,12975,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆæ‰‹æ•°æ–™',0),(467096,12975,'pt','ComissÃ£o percentual de item',0),(467097,12975,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ð¿ÑƒÐ½ÐºÑ‚',0),(467098,12975,'es','Item Porcentaje de ComisiÃ³n',0),(467099,12975,'de','Element Prozent Kommission',0),(467100,12975,'en','Item Percent Commission',0),(467101,12976,'is','',0),(467102,12976,'dr','Ø¯Ø±ÛŒØ§ÙØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(467103,12976,'pr','Ø¯Ø±ÛŒØ§ÙØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(467104,12976,'tr','GÃ¼ncelleÅŸtirmeler alÄ±n',0),(467105,12976,'pl','Pobierz aktualizacje',0),(467106,12976,'bg','ÐœÐ°Ñ…Ð½Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(467107,12976,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(467108,12976,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸',0),(467109,12976,'vi','cáº­p nháº­t nÃ¢ng cáº¥p',0),(467110,12976,'af','Kry bywerkings',0),(467111,12976,'ro','ObÅ£ineÅ£i actualizÄƒri',0),(467112,12976,'et','Saada uuendused',0),(467113,12976,'si','Pridobite posodobitve',0),(467114,12976,'ba','Dapatkan update',0),(467115,12976,'nl','Ontvang Updates',0),(467116,12976,'fi','Hae pÃ¤ivityksiÃ¤',0),(467117,12976,'no','FÃ¥ oppdateringer',0),(467118,12976,'da','FÃ¥ opdateringer',0),(467119,12976,'ko','ì—…ë°ì´ íŠ¸ë¥¼ ë°›ì„',0),(467120,12976,'he','×§×‘×œ ×¢×“×›×•× ×™×',0),(467121,12976,'el','Î›Î¬Î²ÎµÏ„Îµ ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹Ï‚',0),(467122,12976,'zh','èŽ·å–æ›´æ–°',0),(467123,12976,'sv','FÃ¥ uppdateringar',0),(467124,12976,'it','Ricevi aggiornamenti',0),(467125,12976,'tl','',0),(467126,12976,'th','à¸£à¸±à¸šà¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(467127,12976,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¥‡à¤‚',0),(467128,12976,'ms','Dapatkan Kemas kini',0),(467129,12976,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„ØªØ­Ø¯ÙŠØ«Ø§Øª',0),(467130,12976,'fr','Obtenir des mises Ã  jour',0),(467131,12976,'jp','æ›´æ–°ãƒ—ãƒ­ã‚°ãƒ©ãƒ ã‚’å…¥æ‰‹ã—ã¾ã™ã€‚',0),(467132,12976,'pt','Receba as atualizaÃ§Ãµes',0),(467133,12976,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(467134,12976,'es','Consigue Actualizaciones',0),(467135,12976,'de','Holen Sie sich Updates',0),(467136,12976,'en','Get Updates',0),(467137,12977,'is','',0),(467138,12977,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù‡Ø§',0),(467139,12977,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù‡Ø§',0),(467140,12977,'tr','GÃ¼ncelleÅŸtirmeleri',0),(467141,12977,'pl','Aktualizacje',0),(467142,12977,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(467143,12977,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒØ§Úº',0),(467144,12977,'sr','Ð˜ÑÐ¿Ñ€Ð°Ð²ÐºÐµ',0),(467145,12977,'vi','Cáº­p nháº­t',0),(467146,12977,'af','Opdaterings',0),(467147,12977,'ro','ActualizÄƒri',0),(467148,12977,'et','Uuendused',0),(467149,12977,'si','Posodobitve',0),(467150,12977,'ba','Update',0),(467151,12977,'nl','Updates',0),(467152,12977,'fi','PÃ¤ivitykset',0),(467153,12977,'no','Oppdateringer',0),(467154,12977,'da','Opdateringer',0),(467155,12977,'ko','ì—…ë°ì´íŠ¸',0),(467156,12977,'he','×¢×“×›×•× ×™×',0),(467157,12977,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹Ï‚',0),(467158,12977,'zh','æ›´æ–°',0),(467159,12977,'sv','Uppdateringar',0),(467160,12977,'it','Aggiornamenti',0),(467161,12977,'tl','',0),(467162,12977,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(467163,12977,'hi','à¤…à¤ªà¤¡à¥‡à¤Ÿ',0),(467164,12977,'ms','Kemas kini',0),(467165,12977,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ«Ø§Øª',0),(467166,12977,'fr','Mises Ã  jour',0),(467167,12977,'jp','æ›´æ–°ãƒ—ãƒ­ã‚°ãƒ©ãƒ ',0),(467168,12977,'pt','AtualizaÃ§Ãµes',0),(467169,12977,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(467170,12977,'es','Actualizaciones',0),(467171,12977,'de','Aktuelles',0),(467172,12977,'en','Updates',0),(467173,12978,'is','',0),(467174,12978,'dr','Ù…Ø³Ø¯ÙˆØ¯ Ú©Ø±Ø¯Ù† ÙˆØ±ÙˆØ¯ Ø¨Ù‡ ØµÙØ­Ù‡ Ú¯ÙˆÚ¯Ù„',0),(467175,12978,'pr','Ù…Ø³Ø¯ÙˆØ¯ Ú©Ø±Ø¯Ù† ÙˆØ±ÙˆØ¯ Ø¨Ù‡ ØµÙØ­Ù‡ Ú¯ÙˆÚ¯Ù„',0),(467176,12978,'tr','Blok Google oturumlarÄ±',0),(467177,12978,'pl','Blok Google logowania',0),(467178,12978,'bg','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ðµ Ð½Ð° Google Ð²Ð»Ð¸Ð·Ð°Ð½Ð¸Ñ',0),(467179,12978,'ur','Ú¯ÙˆÚ¯Ù„ Ù„Ø§Ú¯ Ø§Ù† Ø¨Ù„Ø§Ú© Ú©Ø±ÛŒÚº',0),(467180,12978,'sr','Ð‘Ð»Ð¾Ðº Ð“Ð¾Ð¾Ð³Ð»Ðµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐ°',0),(467181,12978,'vi','Cháº·n ',0),(467182,12978,'af','Blok Google aantekening toe',0),(467183,12978,'ro','Bloc Google Logins',0),(467184,12978,'et','Block Google logimine',0),(467185,12978,'si','Blok Google prijav',0),(467186,12978,'ba','Blok Google login',0),(467187,12978,'nl','Blok Google Logins',0),(467188,12978,'fi','Block Google kirjautumiset',0),(467189,12978,'no','Block Google logikk',0),(467190,12978,'da','Blokere Google Logins',0),(467191,12978,'ko','êµ¬ê¸€ ë¡œê·¸ì¸ì„ ì°¨ë‹¨',0),(467192,12978,'he','×œ×—×¡×•× ×›× ×™×¡×•×ª ×’×•×’×œ',0),(467193,12978,'el','ÎœÏ€Î»Î¿Îº Google Logins',0),(467194,12978,'zh','é˜»æ­¢è°·æ­Œç™»å½•',0),(467195,12978,'sv','Blockera Google inloggningar',0),(467196,12978,'it','Bloccare gli account di accesso di Google',0),(467197,12978,'tl','',0),(467198,12978,'th','à¸šà¸¥à¹‡à¸­à¸à¸¥à¹‡à¸­à¸à¸­à¸´à¸™à¸‚à¸­à¸‡ Google',0),(467199,12978,'hi','à¤¬à¥à¤²à¥‰à¤• à¤—à¥‚à¤—à¤² à¤²à¥‰à¤—à¤¿à¤¨',0),(467200,12978,'ms','Blok Google login',0),(467201,12978,'ar','ÙƒØªÙ„Ø© Ø¬ÙˆØ¬Ù„ ØªØ³Ø¬ÙŠÙ„Ø§Øª Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(467202,12978,'fr','Bloquer les connexions de Google',0),(467203,12978,'jp','Google ãƒ­ã‚°ã‚¤ãƒ³ã‚’ãƒ–ãƒ­ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(467204,12978,'pt','Bloco Google Logins',0),(467205,12978,'ru','Ð‘Ð»Ð¾Ðº Google Ð»Ð¾Ð³Ð¸Ð½Ñ‹',0),(467206,12978,'es','Bloquea Logins de Google',0),(467207,12978,'de','Block Google Logins',0),(467208,12978,'en','Block Google Logins',0),(467209,12979,'is','',0),(467210,12979,'dr','Ø§Ø² Ø¢Ø¯Ø±Ø³ Ø§ÛŒÙ…ÛŒÙ„ Ø­Ø³Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø®ÙˆØ¯ Ù…Ø·Ù…Ø¦Ù†  Ø´ÙˆÛŒØ¯',0),(467211,12979,'pr','Ø§Ø² Ø¢Ø¯Ø±Ø³ Ø§ÛŒÙ…ÛŒÙ„ Ø­Ø³Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø®ÙˆØ¯ Ù…Ø·Ù…Ø¦Ù†  Ø´ÙˆÛŒØ¯',0),(467212,12979,'tr','GeÃ§erli Google hesabÄ± kullanÄ±cÄ± hesabÄ±nÄ±zdaki e-posta adresi olduÄŸundan emin olun',0),(467213,12979,'pl','Upewnij siÄ™, Å¼e adres e-mail na koncie uÅ¼ytkownika jest prawidÅ‚owym kontem Google',0),(467214,12979,'bg','Ð¡Ðµ ÑƒÐ²ÐµÑ€ÐµÑ‚Ðµ, Ñ‡Ðµ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑÐ° Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ðµ Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð¿Ñ€Ð¾Ñ„Ð¸Ð» Ð² Google',0),(467215,12979,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ú©Û’ ØµØ§Ø±Ù Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾Ø± Ø§ÛŒ Ù…ÛŒÙ„ Ù¾ØªÛ Ø¬Ø§Ø¦Ø² Google Ø§Ú©Ø§Ø¤Ù†Ù¹ ÛÛ’ Û”',0),(467216,12979,'sr','Ð‘Ð¸Ñ‚Ð¸ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ñ˜Ðµ Ð°Ð´Ñ€ÐµÑÐ° Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ Ð½Ð° Ð²Ð°Ñˆ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸ Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ Ð²Ð°Ð¶ÐµÑ›Ð¸ Ð“Ð¾Ð¾Ð³Ð»Ðµ Ð½Ð°Ð»Ð¾Ð³',0),(467217,12979,'vi','Äáº£m báº£o Ä‘á»‹a chá»‰ email cá»§a báº¡n hÆ¡p lá»‡ trÃªn Google',0),(467218,12979,'af','Maak seker dat die e-pos adres op u rekening is \'n geldige Google-rekening',0),(467219,12979,'ro','AsiguraÅ£i-vÄƒ cÄƒ adresa de email pe contul de utilizator este un cont valid Google',0),(467220,12979,'et','Veenduge, et teie konto meiliaadress on kehtiv Google\'i konto',0),(467221,12979,'si','Bodite prepriÄani, naslov za uporabniÅ¡ki raÄun ni veljaven raÄun Google',0),(467222,12979,'ba','Pastikan alamat email di akun pengguna account Google yang valid',0),(467223,12979,'nl','Zorg ervoor dat het e-mailadres voor uw gebruikersaccount is een geldige Google-account',0),(467224,12979,'fi','Varmista, ettÃ¤ tilisi sÃ¤hkÃ¶postiosoite on kelvollinen Google-tilin',0),(467225,12979,'no','Kontroller at e-postadressen pÃ¥ brukerkontoen din er en gyldig Google-konto',0),(467226,12979,'da','SÃ¸rg for e-mail-adressen pÃ¥ din brugerkonto er en gyldig Google-konto',0),(467227,12979,'ko','ì‚¬ìš©ìž ê³„ì •ì— ì´ë©”ì¼ ì£¼ì†ŒëŠ” ìœ íš¨í•œ Google ê³„ì • í™•ì¸',0),(467228,12979,'he','×œ×”×™×•×ª ×‘×˜×•×— ×©×›×ª×•×‘×ª ×”×“×•× ×¢×œ ×—×©×‘×•×Ÿ ×”×ž×©×ª×ž×© ×©×œ×š ×”×•× ×—×©×‘×•×Ÿ Google ×—×•×§×™',0),(467229,12979,'el','Î’ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î³Î¹Î± Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï‡ÏÎ®ÏƒÏ„Î· ÏƒÎ±Ï‚ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Google',0),(467230,12979,'zh','è¯·ç¡®ä¿æ‚¨çš„ç”¨æˆ·å¸æˆ·çš„ç”µå­é‚®ä»¶åœ°å€æ˜¯æœ‰æ•ˆçš„è°·æ­Œå¸æˆ·',0),(467231,12979,'sv','Se till den e-postadressen pÃ¥ ditt anvÃ¤ndarkonto Ã¤r ett giltigt Google-konto',0),(467232,12979,'it','Assicurarsi che l\'indirizzo e-mail sul tuo account utente Ã¨ un account valido di Google',0),(467233,12979,'tl','',0),(467234,12979,'th','à¹ƒà¸«à¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸§à¹ˆà¸² à¸­à¸¢à¸¹à¹ˆà¸­à¸µà¹€à¸¡à¸¥à¹Œà¸‚à¸­à¸‡à¸šà¸±à¸à¸Šà¸µà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸¡à¸µà¸šà¸±à¸à¸Šà¸µ Google à¸—à¸µà¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(467235,12979,'hi','à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ªà¤•à¥‡ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤–à¤¾à¤¤à¥‡ à¤ªà¤° à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¤¾ à¤à¤• à¤®à¤¾à¤¨à¥à¤¯ Google à¤–à¤¾à¤¤à¤¾ à¤¹à¥ˆ',0),(467236,12979,'ms','Pastikan alamat e-mel pada akaun anda adalah akaun Google yang sah',0),(467237,12979,'ar','ØªØ£ÙƒØ¯ Ù…Ù† Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¹Ù„Ù‰ Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø­Ø³Ø§Ø¨ Google ØµØ§Ù„Ø­',0),(467238,12979,'fr','N\'oubliez pas que l\'adresse de courrier Ã©lectronique sur votre compte d\'utilisateur est un compte Google valide',0),(467239,12979,'jp','è‡ªåˆ†ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã¯ã€æœ‰åŠ¹ãª Google ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(467240,12979,'pt','Certifique-se de que o endereÃ§o de e-mail na sua conta de usuÃ¡rio Ã© uma conta vÃ¡lida do Google',0),(467241,12979,'ru','Ð£Ð±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾ Ð°Ð´Ñ€ÐµÑ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð² ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð¾Ð¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÑŒÑŽ Google',0),(467242,12979,'es','Asegura que la direcciÃ³n de Email en su cuenta de usuario es una cuenta Google valida',0),(467243,12979,'de','Achten Sie darauf, dass die e-Mail-Adresse auf Ihrem Benutzerkonto ein gÃ¼ltiges Google-Konto ist',0),(467244,12979,'en','Be sure the email address on your user account is a valid Google account',0),(467245,12980,'is','',0),(467246,12980,'dr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ±ÙˆØ¯ Ø¨Ù‡ ØµÙØ­Ù‡ Ø§ÛŒÙ†ØªØ±Ù†ØªÛŒ',0),(467247,12980,'pr','Ø®Ø·Ø§ Ø¯Ø± ÙˆØ±ÙˆØ¯ Ø¨Ù‡ ØµÙØ­Ù‡ Ø§ÛŒÙ†ØªØ±Ù†ØªÛŒ',0),(467248,12980,'tr','Oturum aÃ§mada hata',0),(467249,12980,'pl','BÅ‚Ä…d rejestrowania',0),(467250,12980,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(467251,12980,'ur','Ù„Ø§Ú¯ Ø¢Ù† ÛÙˆÙ†Û’ Ù†Ù‚Øµ',0),(467252,12980,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐ°',0),(467253,12980,'vi','Lá»—i Ä‘Äƒng nháº­p',0),(467254,12980,'af','Fout teken',0),(467255,12980,'ro','Eroare autentificare',0),(467256,12980,'et','Viga sisselogimine',0),(467257,12980,'si','Napaka pri prijavi',0),(467258,12980,'ba','Error log In',0),(467259,12980,'nl','Fout inloggen',0),(467260,12980,'fi','Virhe kirjauduttaessa',0),(467261,12980,'no','Feil under pÃ¥logging',0),(467262,12980,'da','LogfÃ¸ring af fejl i',0),(467263,12980,'ko','ë¡œê·¸ì¸ ì˜¤ë¥˜',0),(467264,12980,'he','×¨×™×©×•× ×©×’×™××•×ª ×‘-',0),(467265,12980,'el','ÎšÎ±Ï„Î±Î³ÏÎ±Ï†Î®Ï‚ ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½ ÏƒÏ„Î¿',0),(467266,12980,'zh','æ—¥å¿—çš„é”™è¯¯',0),(467267,12980,'sv','Felloggning i',0),(467268,12980,'it','Registrazione degli errori In',0),(467269,12980,'tl','',0),(467270,12980,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(467271,12980,'hi','à¤²à¥‰à¤—à¤¿à¤‚à¤— à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(467272,12980,'ms','Ralat log In',0),(467273,12980,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(467274,12980,'fr','Erreur connexion',0),(467275,12980,'jp','ãƒ­ã‚°ã‚¤ãƒ³ ã‚¨ãƒ©ãƒ¼',0),(467276,12980,'pt','Erro login',0),(467277,12980,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²Ñ…Ð¾Ð´Ð° Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ',0),(467278,12980,'es','Error Entrando',0),(467279,12980,'de','Fehlerprotokollierung',0),(467280,12980,'en','Error Logging In',0),(467281,12981,'is','',0),(467282,12981,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ú¯ÙˆÚ¯Ù„ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(467283,12981,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ú¯ÙˆÚ¯Ù„ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(467284,12981,'tr','Google oturum aÃ§ma baÅŸarÄ±sÄ±z oldu',0),(467285,12981,'pl','Google logowanie nie powiodÅ‚o siÄ™',0),(467286,12981,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Google Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(467287,12981,'ur','Google Ù„Ø§Ú¯ Ø§Ù† Ù†Ø§Ú©Ø§Ù…',0),(467288,12981,'sr','Ð“Ð¾Ð¾Ð³Ð»Ðµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÐ»Ð°',0),(467289,12981,'vi','Ä‘Äƒng nháº­p google tháº¥t báº¡i',0),(467290,12981,'af','Google aantekening het misluk',0),(467291,12981,'ro','Conectare Google nu a reuÅŸit',0),(467292,12981,'et','Google sisselogimine nurjus',0),(467293,12981,'si','Varljiva Å¾oga prijava ni uspela',0),(467294,12981,'ba','Google Login gagal',0),(467295,12981,'nl','Google de aanmelding is mislukt',0),(467296,12981,'fi','Google Kirjautuminen epÃ¤onnistui',0),(467297,12981,'no','Google pÃ¥logging mislyktes',0),(467298,12981,'da','Google-Login mislykkedes',0),(467299,12981,'ko','êµ¬ê¸€ ë¡œê·¸ì¸ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(467300,12981,'he','×’×•×’×œ ×”×›× ×™×¡×” × ×›×©×œ×”',0),(467301,12981,'el','Google ÏƒÏÎ½Î´ÎµÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(467302,12981,'zh','è°·æ­Œç™»å½•å¤±è´¥',0),(467303,12981,'sv','Google inloggning misslyckades',0),(467304,12981,'it','Google accesso non riuscito',0),(467305,12981,'tl','',0),(467306,12981,'th','Google à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(467307,12981,'hi','à¤—à¥‚à¤—à¤² à¤²à¥‰à¤—à¤¿à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(467308,12981,'ms','Log masuk Google gagal',0),(467309,12981,'ar','ÙØ´Ù„ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø¥Ù„Ù‰ Ø¬ÙˆØ¬Ù„',0),(467310,12981,'fr','Ã‰chec de la connexion de Google',0),(467311,12981,'jp','Google ãƒ­ã‚°ã‚¤ãƒ³ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(467312,12981,'pt','Falha no Login do Google',0),(467313,12981,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²Ñ…Ð¾Ð´Ð° Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ Google',0),(467314,12981,'es','Login a Google FallÃ³',0),(467315,12981,'de','Fehler bei der Google-Anmeldung',0),(467316,12981,'en','Google Login Failed',0),(467317,12982,'is','',0),(467318,12982,'dr','Ø¨Ø§ Ø­Ø³Ø§Ø¨ ÙˆØ±ÙˆØ¯ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ú¯ÙˆÚ¯Ù„ Ù…Ø¬Ø§Ø² Ù‡Ø³ØªÙ†Ø¯',0),(467319,12982,'pr','Ø¨Ø§ Ø­Ø³Ø§Ø¨ ÙˆØ±ÙˆØ¯ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ú¯ÙˆÚ¯Ù„ Ù…Ø¬Ø§Ø² Ù‡Ø³ØªÙ†Ø¯',0),(467320,12982,'tr','VarsayÄ±lan olarak, Google HesabÄ±nÄ±zda oturum aÃ§ma izin verilir.',0),(467321,12982,'pl','DomyÅ›lnie logowania konta Google sÄ… dozwolone.',0),(467322,12982,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÑÐ° Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸ Ð²Ð»Ð¸Ð·Ð°Ð½Ð¸Ñ Ð² Ð¿Ñ€Ð¾Ñ„Ð¸Ð»Ð° Ð² Google.',0),(467323,12982,'ur','ÚˆÛŒÙØ§Ù„Ù¹ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Google Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…ÛŒÚº Ù„Ø§Ú¯ Ø§Ù† Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ ÛÛŒÚº Û”',0),(467324,12982,'sr','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾Ñ˜ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ðµ ÑÑƒ Ð“Ð¾Ð¾Ð³Ð»Ðµ Ñ€Ð°Ñ‡ÑƒÐ½ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐ°.',0),(467325,12982,'vi','Theo máº·c Ä‘á»‹nh Ä‘Äƒng nháº­p TÃ i khoáº£n Google Ä‘Æ°á»£c phÃ©p.',0),(467326,12982,'af','By verstek Google-rekening aantekening toe toegelaat is.',0),(467327,12982,'ro','ÃŽn mod implicit Google socotealÄƒ login-uri sunt permise.',0),(467328,12982,'et','Vaikimisi lubatakse Google\'i konto sisselogimise.',0),(467329,12982,'si','Privzeto so dovoljene prijave v raÄun pri Googlu.',0),(467330,12982,'ba','Secara default, Google Account login diperbolehkan.',0),(467331,12982,'nl','Standaard zijn Google-Account aanmeldingen toegestaan.',0),(467332,12982,'fi','Oletuksena Google-tilien kirjautumistunnusten sallitaan.',0),(467333,12982,'no','Som standard tillates Google regningen logikk.',0),(467334,12982,'da','Som standard er Google-konto-logon tilladt.',0),(467335,12982,'ko','ê¸°ë³¸ì ìœ¼ë¡œ Google ê³„ì • ë¡œê·¸ì¸ì´ í—ˆìš© ë©ë‹ˆë‹¤.',0),(467336,12982,'he','×›×‘×¨×™×¨×ª ×ž×—×“×œ, ×—×©×‘×•×Ÿ Google ×›× ×™×¡×•×ª ×ž×•×ª×¨.',0),(467337,12982,'el','Î‘Ï€ÏŒ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î®, ÎµÏ€Î¹Ï„ÏÎ­Ï€Î¿Î½Ï„Î±Î¹ ÏƒÏ…Î½Î´Î­ÏƒÎµÎ¹Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Google.',0),(467338,12982,'zh','é»˜è®¤æƒ…å†µä¸‹å…è®¸ Google å¸æˆ·ç™»å½•ã€‚',0),(467339,12982,'sv','Som standard tillÃ¥ts Google konto inloggningar.',0),(467340,12982,'it','Per impostazione predefinita sono consentiti gli accessi Google Account.',0),(467341,12982,'tl','',0),(467342,12982,'th','à¸¥à¹‡à¸­à¸à¸­à¸´à¸™à¸šà¸±à¸à¸Šà¸µ Google à¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸• à¹‚à¸”à¸¢à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(467343,12982,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤°à¥‚à¤ª à¤¸à¥‡ Google à¤–à¤¾à¤¤à¥‡ à¤²à¥‰à¤—à¤‡à¤¨à¥à¤¸ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¹à¥ˆà¤‚à¥¤',0),(467344,12982,'ms','Secara lalai login akaun Google yang dibenarkan.',0),(467345,12982,'ar','Ø¨Ø´ÙƒÙ„ Ø§ÙØªØ±Ø§Ø¶ÙŠ ÙŠØªÙ… Ø§Ù„Ø³Ù…Ø§Ø­ ØªØ³Ø¬ÙŠÙ„Ø§Øª Ø¯Ø®ÙˆÙ„ Ø­Ø³Ø§Ø¨ Google.',0),(467346,12982,'fr','Par dÃ©faut les identifiants du compte Google sont autorisÃ©es.',0),(467347,12982,'jp','æ—¢å®šã§ã¯ Google ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ãƒ­ã‚°ã‚¤ãƒ³ãŒè¨±å¯ã•ã‚Œã¾ã™ã€‚',0),(467348,12982,'pt','Por padrÃ£o, sÃ£o permitidas logons da conta do Google.',0),(467349,12982,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ñ‹ Ð¸Ð¼ÐµÐ½Ð° Ð²Ñ…Ð¾Ð´Ð° Ð² Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚ Google.',0),(467350,12982,'es','Por defecto logins de Cuentas Google se permiten',0),(467351,12982,'de','StandardmÃ¤ÃŸig sind Google-Konto-Logins zulÃ¤ssig.',0),(467352,12982,'en','By default Google Account logins are permitted.',0),(467353,12983,'is','',0),(467354,12983,'dr','-> Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ - Ù…Ø¯ÛŒØ±ÛŒØª -> ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø³ÛŒØ³ØªÙ…',0),(467355,12983,'pr','Ø§ÛŒÙ† Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø¯Ø± Ù…Ø¯ÛŒØ±ÛŒØª Ù…ØªÙˆÙ‚Ù Ø´ÙˆØ¯ -> Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ - Ù…Ø¯ÛŒØ±ÛŒØª -> ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø³ÛŒØ³ØªÙ…',0),(467356,12983,'tr','Bu kurulum - sistem ayarlarÄ±-> Admin-> admin kapatÄ±labilir',0),(467357,12983,'pl','To moÅ¼e byÄ‡ wyÅ‚Ä…czona w Admin-> instalacji - Admin-> ustawienia systemu',0),(467358,12983,'bg','Ð¢Ð¾Ð²Ð° Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¸Ð·ÐºÐ»ÑŽÑ‡ÐµÐ½Ð° Ð² Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€-> ÑÐ¸ÑÑ‚ÐµÐ¼Ð½Ð¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸',0),(467359,12983,'ur','ÛŒÛ Ø³ÛŒÙ¹ Ø§Ù¾ - Ø§ÛŒÚˆÙ…Ù† Ù†Ø¸Ø§Ù… Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº->-> Ø§ÛŒÚˆÙ…Ù† Ù…ÛŒÚº Ø¢Ù Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ ÛÛ’',0),(467360,12983,'sr','ÐžÐ²Ð¾ Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¸ÑÐºÑ™ÑƒÑ‡ÐµÐ½Ð° Ñƒ ÐÐ´Ð¼Ð¸Ð½ Ð¸ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€ÑÐºÐµ Ð¸ ÑÐ¸ÑÑ‚ÐµÐ¼ÑÐºÐµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ',0),(467361,12983,'vi','Äiá»u nÃ y cÃ³ thá»ƒ Ä‘Æ°á»£c táº¯t trong pháº§n quáº£n trá»‹-> cÃ i Ä‘áº·t quáº£n trá»‹-> thiáº¿t láº­p há»‡ thá»‘ng',0),(467362,12983,'af','Dit in Admin-> opstel - Admin-> stelselinstellings afgeskakel kan word',0),(467363,12983,'ro','Acest lucru poate fi oprit Ã®n Admin-> Setup - Admin-> setÄƒrile de sistem',0),(467364,12983,'et','See saab lÃ¼litada Setup --> sÃ¼steemi seaded Admin-> Admin',0),(467365,12983,'si','To lahko izklopite v Admin-> Setup - Admin-> sistemske nastavitve',0),(467366,12983,'ba','Hal ini dapat dimatikan di Admin-> Setup - Admin-> pengaturan sistem',0),(467367,12983,'nl','Dit kan worden uitgeschakeld in Admin-> Setup - Admin-> systeeminstellingen',0),(467368,12983,'fi','TÃ¤mÃ¤ voi poistaa kÃ¤ytÃ¶stÃ¤ admin-> asetukset - Admin-> JÃ¤rjestelmÃ¤asetukset',0),(467369,12983,'no','Dette kan deaktiveres i Admin-> oppsett - Admin-> systeminnstillinger',0),(467370,12983,'da','Dette kan slÃ¥s fra i Admin-> Setup - Admin-> Systemindstillinger',0),(467371,12983,'ko','ì´ ì„¤ì •-ì‹œìŠ¤í…œ ì„¤ì •-> ê´€ë¦¬ìž-> ê´€ë¦¬ìžì—ì„œ í•´ì œí•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(467372,12983,'he','×–×” ×™×›×•×œ ×œ×”×™×•×ª ×›×‘×•×™ ×‘- Admin-> ×”×”×ª×§× ×” - Admin-> ×”×’×“×¨×•×ª ×ž×¢×¨×›×ª',0),(467373,12983,'el','Î‘Ï…Ï„ÏŒ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ ÏƒÏ„Î¿ Admin-> ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· - Admin-> ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚',0),(467374,12983,'zh','è¿™å¯ä»¥åœ¨-> è®¾ç½®--> ç³»ç»Ÿè®¾ç½®ç®¡ç†å‘˜ç®¡ç†å‘˜å…³é—­',0),(467375,12983,'sv','Detta kan stÃ¤ngas av i Admin-> Setup - Admin-> SysteminstÃ¤llningar',0),(467376,12983,'it','Questo puÃ² essere spento in Admin-> Setup - Admin-> impostazioni di sistema',0),(467377,12983,'tl','',0),(467378,12983,'th','à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸›à¸´à¸”à¸›à¸´à¸”à¹„à¸”à¹‰à¹ƒà¸™ Admin->à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² - Admin->à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸£à¸°à¸šà¸š',0),(467379,12983,'hi','à¤¯à¤¹ à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤¸à¥‡à¤Ÿà¤…à¤ª --> à¤ªà¥à¤°à¤£à¤¾à¤²à¥€ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤•-> à¤®à¥‡à¤‚ à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥‹ à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(467380,12983,'ms','Ini boleh dimatikan admin-> Persediaan - Admin-> seting sistem',0),(467381,12983,'ar','ÙˆÙ‡Ø°Ø§ ÙŠÙ…ÙƒÙ† Ø¥ÙŠÙ‚Ø§Ù ÙÙŠ Ø§Ù„Ù…Ø´Ø±Ù-> Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø§Ù„Ù…Ø´Ø±Ù-> \"Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù…\"',0),(467382,12983,'fr','Ceci peut Ãªtre dÃ©sactivÃ© en Admin-> Setup - Admin-> panneau de configuration',0),(467383,12983,'jp','ã“ã‚Œã¯ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— - ã‚·ã‚¹ãƒ†ãƒ è¨­å®š-> ç®¡ç†-> ç®¡ç†ã§ã‚ªãƒ•ã«ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(467384,12983,'pt','Este pode ser desligado em Admin-> Setup - Admin-> configuraÃ§Ãµes do sistema',0),(467385,12983,'ru','Ð­Ñ‚Ð¾ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¾Ñ‚ÐºÐ»ÑŽÑ‡ÐµÐ½Ð° Ð² Ð°Ð´Ð¼Ð¸Ð½-> Setup - Admin-> Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹',0),(467386,12983,'es','Este se puede apagar en Admin -> ConfiguraciÃ³n - Admin ->ConfiguraciÃ³n de Sistema',0),(467387,12983,'de','Dies kann im Admin-> Setup - Admin-> Systemeinstellungen abgeschaltet werden',0),(467388,12983,'en','This can be turned off in Admin -> Setup - Admin -> System Settings',0),(467389,12984,'is','',0),(467390,12984,'dr','Ú©Ù„ÛŒØ¯ Ú©Ù†ØªØ±Ù„ Ø±Ø§ Ø¬Ù‡Øª Ø§Ù†ØªØ®Ø§Ø¨ Ú†Ù†Ø¯ Ø´Ø±Ú©Øª Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÛŒØ¯',0),(467391,12984,'pr','Ú©Ù„ÛŒØ¯ Ú©Ù†ØªØ±Ù„ Ø±Ø§ Ø¬Ù‡Øª Ø§Ù†ØªØ®Ø§Ø¨ Ú†Ù†Ø¯ Ø´Ø±Ú©Øª Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÛŒØ¯',0),(467392,12984,'tr','Select birden Ã§ok ÅŸirket iÃ§in Control tuÅŸunu basÄ±lÄ± tutun',0),(467393,12984,'pl','Przytrzymaj klawisz Control wybierz wielu firm',0),(467394,12984,'bg','Ð—Ð°Ð´Ñ€ÑŠÐ¶Ñ‚Ðµ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ð¸Ñ Ð±ÑƒÑ‚Ð¾Ð½, Ð·Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(467395,12984,'ur','Ù…Ù†ØªØ®Ø¨ Ù…ØªØ¹Ø¯Ø¯ Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ú©Ùˆ Ú©Ù†Ù¹Ø±ÙˆÙ„ Ø¨Ù¹Ù† Ø¯Ø¨Ø§ Ø±Ú©Ú¾ÛŒÚº',0),(467396,12984,'sr','Ð”Ñ€Ð¶Ð¸Ñ‚Ðµ Ñ‚Ð°ÑÑ‚ÐµÑ€ Ð¦Ð¾Ð½Ñ‚Ñ€Ð¾Ð» ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°Ð¼Ð° Ð²Ð¸ÑˆÐµÑÑ‚Ñ€ÑƒÐºÐ¸ Ð¸Ð·Ð±Ð¾Ñ€',0),(467397,12984,'vi','giá»¯ quyá»n kiá»ƒm soÃ¡t Ä‘á»ƒ lá»±a chá»n cÃ¡c cÃ´ng ty Ä‘a quá»‘c gia',0),(467398,12984,'af','Hou beheer sleutel kies verskeie maatskappye',0),(467399,12984,'ro','MenÅ£ineÅ£i apÄƒsatÄƒ tasta de Control pentru a selecta mai multe companii',0),(467400,12984,'et','Control klahvi Vali mitu ettevÃµtete',0),(467401,12984,'si','Tipko Control izberite veÄ podjetij',0),(467402,12984,'ba','Tahan tombol Control untuk memilih beberapa perusahaan',0),(467403,12984,'nl','Selecteer meerdere bedrijven Control-toets ingedrukt houden',0),(467404,12984,'fi','PidÃ¤ CTRL-nÃ¤ppÃ¤intÃ¤ Valitse useita yrityksiÃ¤',0),(467405,12984,'no','Hold kontroll-tasten for Ã¥ velge flere selskaper',0),(467406,12984,'da','Hold CTRL-tasten for at vÃ¦lge flere virksomheder',0),(467407,12984,'ko','ì„ íƒ ì—¬ëŸ¬ íšŒì‚¬ì— ì œì–´ í‚¤ë¥¼ ëˆ„ë¥¸ ì±„ë¡œ',0),(467408,12984,'he','×”×§×™×©×• ×”×‘×§×¨×” ×‘×—×¨ ×ž×¡×¤×¨ ×—×‘×¨×•×ª',0),(467409,12984,'el','ÎšÏÎ±Ï„Î¿ÏÎ½ Ï„Î¿ ÎºÎ»ÎµÎ¹Î´Î¯ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î³Î¹Î± Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® Ï€Î¿Î»Î»ÏŽÎ½ ÎµÏ„Î±Î¹ÏÎµÎ¹ÏŽÎ½',0),(467410,12984,'zh','æŒ‰ä½æŽ§åˆ¶é”®é€‰æ‹©å¤šä¸ªå…¬å¸',0),(467411,12984,'sv','HÃ¥ll CTRL-tangenten VÃ¤lj flera fÃ¶retag',0),(467412,12984,'it','Tenere premuto il tasto di controllo per selezionare piÃ¹ aziende',0),(467413,12984,'tl','',0),(467414,12984,'th','à¹à¸›à¹‰à¸™à¸„à¸§à¸šà¸„à¸¸à¸¡à¸„à¹‰à¸²à¸‡à¹„à¸§à¹‰à¹€à¸žà¸·à¹ˆà¸­à¹€à¸¥à¸·à¸­à¸à¸«à¸¥à¸²à¸¢ à¸šà¸£à¸´à¸©à¸±à¸—',0),(467415,12984,'hi','à¤šà¥à¤¨à¥‡à¤‚ à¤à¤•à¤¾à¤§à¤¿à¤• à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤¯à¤‚à¤¤à¥à¤°à¤£ à¤•à¥à¤‚à¤œà¥€ à¤•à¥‹ à¤¦à¤¬à¤¾à¤ à¤°à¤–à¥‡à¤‚',0),(467416,12984,'ms','Tahan kekunci kawalan kepada syarikat-syarikat berbilang Pilih',0),(467417,12984,'ar','Ø§Ø¶ØºØ· Ø§Ù„Ù…ÙØªØ§Ø­ Control Ù„ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø´Ø±ÙƒØ§Øª Ù…ØªØ¹Ø¯Ø¯Ø©',0),(467418,12984,'fr','Maintenez la touche ContrÃ´le enfoncÃ©e pour sÃ©lectionner plusieurs entreprises',0),(467419,12984,'jp','ã‚³ãƒ³ãƒˆãƒ­ãƒ¼ãƒ« ã‚­ãƒ¼ã‚’æŠ¼ã—ãªãŒã‚‰é¸æŠžè¤‡æ•°ã®ä¼æ¥­ã«',0),(467420,12984,'pt','Segure a tecla Control para selecionar mÃºltiplas empresas',0),(467421,12984,'ru','Ð£Ð´ÐµÑ€Ð¶Ð¸Ð²Ð°Ð¹Ñ‚Ðµ ÐºÐ»Ð°Ð²Ð¸ÑˆÑƒ Control Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¹',0),(467422,12984,'es','Queda Oprimido la Tecla de Control Para eleccionar Empresas Multiples',0),(467423,12984,'de','Halten Sie STRG-Taste wÃ¤hlen Sie mehrere Unternehmen',0),(467424,12984,'en','Hold Control Key To Select Multiple Companies',0),(467425,12985,'is','',0),(467426,12985,'dr','Ú©Ø¯Ø§Ù… Ø´Ø±Ú©Øª Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(467427,12985,'pr','Ú©Ø¯Ø§Ù… Ø´Ø±Ú©Øª Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ø¢ÙˆØ±Ø¯Ù‡ Ø´ÙˆØ¯',0),(467428,12985,'tr','Hangi ÅŸirketleri dahil',0),(467429,12985,'pl','To jakiej firmy',0),(467430,12985,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÐºÐ¾Ð¸ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(467431,12985,'ur','Ø¬Ù† Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(467432,12985,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ¾Ñ˜Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(467433,12985,'vi','Bao gá»“m cÃ´ng ty nÃ o',0),(467434,12985,'af','Watter maatskappye sluit',0),(467435,12985,'ro','Includ care companiile',0),(467436,12985,'et','Kaasata ettevÃµtted',0),(467437,12985,'si','VkljuÄujejo katera podjetja',0),(467438,12985,'ba','Termasuk perusahaan yang',0),(467439,12985,'nl','Welke bedrijven omvatten',0),(467440,12985,'fi','Kuuluvat yritykset',0),(467441,12985,'no','Hvilke firmaer',0),(467442,12985,'da','Indeholde hvilke virksomheder',0),(467443,12985,'ko','ì–´ë–¤ íšŒì‚¬ë¥¼ í¬í•¨',0),(467444,12985,'he','×›×•×œ×œ×™× ××™×œ×• ×—×‘×¨×•×ª',0),(467445,12985,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï€Î¿Î¹ÎµÏ‚ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚',0),(467446,12985,'zh','åŒ…æ‹¬å“ªäº›å…¬å¸',0),(467447,12985,'sv','Inkludera vilka fÃ¶retag',0),(467448,12985,'it','Comprendere che le imprese',0),(467449,12985,'tl','',0),(467450,12985,'th','à¸£à¸§à¸¡à¸—à¸µà¹ˆà¸šà¸£à¸´à¸©à¸±à¸—',0),(467451,12985,'hi','à¤œà¥‹ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(467452,12985,'ms','Termasuk syarikat-syarikat yang',0),(467453,12985,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„ØªÙŠ',0),(467454,12985,'fr','Comprennent que les entreprises',0),(467455,12985,'jp','ã©ã®ä¼æ¥­ãŒå«ã¾ã‚Œã¾ã™',0),(467456,12985,'pt','Incluir quais empresas',0),(467457,12985,'ru','ÐšÐ°ÐºÐ¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(467458,12985,'es','Incluye Cuales Empresas',0),(467459,12985,'de','Welche Firmen gehÃ¶ren',0),(467460,12985,'en','Include Which Companies',0),(467461,12986,'is','',0),(467462,12986,'dr','ÙÙ‚Ø· Ø²Ù…Ø§Ù†ÛŒ Ú©Ø§Ø± Ù…ÛŒ Ú©Ù†Ø¯ Ú©Ù‡ Ø´Ø±Ú©Øª Ù‡Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø³Ø§Ù„ Ù…Ø§Ù„ÛŒ ÛŒÚ©Ø³Ø§Ù†ÛŒ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ù†Ø¯',0),(467463,12986,'pr','ÙÙ‚Ø· Ø²Ù…Ø§Ù†ÛŒ Ú©Ø§Ø± Ù…ÛŒ Ú©Ù†Ø¯ Ú©Ù‡ Ø´Ø±Ú©Øª Ù‡Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø³Ø§Ù„ Ù…Ø§Ù„ÛŒ ÛŒÚ©Ø³Ø§Ù†ÛŒ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ù†Ø¯',0),(467464,12986,'tr','Sadece Ä°nÅŸaat ÅŸirketleri seÃ§tiyseniz, aynÄ± mali yÄ±l sahip',0),(467465,12986,'pl','DziaÅ‚a tylko jeÅ›li wybrany firmy majÄ… tego samego roku obrachunkowego',0),(467466,12986,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð¼Ð°Ñ‚ ÑÑŠÑ‰Ð°Ñ‚Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(467467,12986,'ur','Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ ØªÙˆ ØµØ±Ù Ø§Ø³ÛŒ Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ ÛÛ’',0),(467468,12986,'sr','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¾Ð½Ð¸ÑˆÐµ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð° Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð° Ð¸Ð¼Ð°Ñ˜Ñƒ Ð¸ÑÑ‚Ðµ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(467469,12986,'vi','chá»‰ lÃ m viá»‡c náº¿u cÃ´ng ty Ä‘Æ°á»£c chá»n cÃ³ nÄƒm tÃ i chÃ­nh giá»‘ng ',0),(467470,12986,'af','Werk slegs as maatskappye gekies het dieselfde Fiskale jaar',0),(467471,12986,'ro','FuncÅ£ioneazÄƒ numai dacÄƒ selectatÄƒ firme au acelaÅŸi an Fiscal',0),(467472,12986,'et','TÃ¶Ã¶tab ainult kui valitud ettevÃµtted on sama majandusaasta',0),(467473,12986,'si','Deluje samo Äe izbrana podjetja imajo istega poslovnega leta',0),(467474,12986,'ba','Hanya bekerja jika dipilih perusahaan memiliki sama tahun fiskal',0),(467475,12986,'nl','Werkt alleen als de geselecteerde bedrijven hebben dezelfde fiscale jaar',0),(467476,12986,'fi','Toimii vain jos yritykset ovat samalla tilikaudella',0),(467477,12986,'no','Fungerer bare hvis valgte selskaper har samme regnskapsÃ¥r',0),(467478,12986,'da','Virker kun hvis valgt virksomheder Have samme regnskabsÃ¥r',0),(467479,12986,'ko','íšŒì‚¬ë¥¼ ì„ íƒ í•˜ëŠ” ê²½ìš° ìž‘í’ˆë§Œê°€ì§€ê³  ë™ì¼í•œ íšŒê³„ ì—°ë„',0),(467480,12986,'he','×¢×•×‘×“ ×¨×§ ×× × ×‘×—×¨ ×—×‘×¨×•×ª ×™×© ×‘××•×ª×” ×©× ×ª ×›×¡×¤×™×',0),(467481,12986,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³ÎµÎ¯ Î¼ÏŒÎ½Î¿ ÎµÎ¬Î½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Î­Ï‡Î¿Ï…Î½ Ï„Î¿ Î¯Î´Î¹Î¿ Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚',0),(467482,12986,'zh','åªæœ‰å¦‚æžœé€‰å®šå…¬å¸çš„ä½œå“æœ‰åŒä¸€ä¼šè®¡å¹´åº¦',0),(467483,12986,'sv','Fungerar bara om utvalda fÃ¶retag har samma rÃ¤kenskapsÃ¥r',0),(467484,12986,'it','Funziona solo se selezionato aziende hanno stesso anno fiscale',0),(467485,12986,'tl','',0),(467486,12986,'th','à¸ˆà¸°à¸—à¸³à¸‡à¸²à¸™à¹„à¸”à¹‰à¸–à¹‰à¸²à¹€à¸¥à¸·à¸­à¸à¸šà¸£à¸´à¸©à¸±à¸—à¹„à¸”à¹‰à¸›à¸µà¹€à¸”à¸µà¸¢à¸§',0),(467487,12986,'hi','à¤…à¤—à¤° à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¥‡à¤µà¤² à¤•à¤¾à¤® à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤à¤• à¤¹à¥€ à¤µà¤¿à¤¤à¥à¤¤à¥€à¤¯ à¤µà¤°à¥à¤· à¤¹à¥ˆ',0),(467488,12986,'ms','Hanya kerja jika memilih Syarikat mempunyai tahun fiskal yang sama',0),(467489,12986,'ar','ÙŠØ¹Ù…Ù„ ÙÙ‚Ø· ÙÙŠ Ø­Ø§Ù„Ø© ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø´Ø±ÙƒØ§Øª Ù„Ø¯ÙŠÙ‡Ø§ Ù†ÙØ³ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(467490,12986,'fr','Ne fonctionne que si sÃ©lectionnÃ© entreprises ont mÃªme exercice',0),(467491,12986,'jp','ä¼šç¤¾ã‚’é¸æŠžã—ãŸå ´åˆã®ã¿å‹•ä½œã—ã¾ã™ã‚ã‚‹åŒä¸€å¹´åº¦',0),(467492,12986,'pt','SÃ³ funciona se tiver selecionado empresas tÃªm o mesmo ano Fiscal',0),(467493,12986,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð°ÐµÑ‚ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð²Ñ‹Ð±Ñ€Ð°Ð½ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¹ Ð¸Ð¼ÐµÑŽÑ‚ Ð¶Ðµ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´',0),(467494,12986,'es','Solo Funciona Si Empresas Seleccionadas Tienen el Mismo Ejercicio Fiscal',0),(467495,12986,'de','Funktioniert nur, wenn Firmen ausgewÃ¤hlt haben eines GeschÃ¤ftsjahres',0),(467496,12986,'en','Only Works If Selected Companies Have Same Fiscal Year',0),(467497,12987,'is','',0),(467498,12987,'dr','Ø´Ø±Ú©ØªÙ‡Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(467499,12987,'pr','Ø´Ø±Ú©ØªÙ‡Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(467500,12987,'tr','SeÃ§ili ÅŸirketler',0),(467501,12987,'pl','Wybranych przedsiÄ™biorstw',0),(467502,12987,'bg','Ð˜Ð·Ð±Ñ€Ð°Ð½Ð¸ Ñ„Ð¸Ñ€Ð¼Ð¸',0),(467503,12987,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ù…Ù¾Ù†ÛŒØ§Úº',0),(467504,12987,'sr','ÐžÐ´Ð°Ð±Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(467505,12987,'vi','Nhá»¯ng cÃ´ng ty Ä‘Ã£ chá»n',0),(467506,12987,'af','Geselekteerde maatskappye',0),(467507,12987,'ro','Companiile selectate',0),(467508,12987,'et','Valitud ettevÃµtted',0),(467509,12987,'si','Izbrani podjetji',0),(467510,12987,'ba','Perusahaan-perusahaan yang dipilih',0),(467511,12987,'nl','Geselecteerde bedrijven',0),(467512,12987,'fi','Valitut yritykset',0),(467513,12987,'no','Utvalgte selskaper',0),(467514,12987,'da','Udvalgte selskaber',0),(467515,12987,'ko','ì„ íƒí•œ íšŒì‚¬',0),(467516,12987,'he','×—×‘×¨×•×ª ×©× ×‘×—×¨×•',0),(467517,12987,'el','Î•Ï€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚',0),(467518,12987,'zh','é€‰å®šçš„å…¬å¸',0),(467519,12987,'sv','Utvalda fÃ¶retag',0),(467520,12987,'it','Aziende selezionate',0),(467521,12987,'tl','',0),(467522,12987,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(467523,12987,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚',0),(467524,12987,'ms','Syarikat-syarikat terpilih',0),(467525,12987,'ar','Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„Ù…Ø®ØªØ§Ø±Ø©',0),(467526,12987,'fr','SociÃ©tÃ©s sÃ©lectionnÃ©es',0),(467527,12987,'jp','é¸ã°ã‚ŒãŸä¼æ¥­',0),(467528,12987,'pt','Empresas seleccionadas',0),(467529,12987,'ru','Ð˜Ð·Ð±Ñ€Ð°Ð½Ð½Ñ‹Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(467530,12987,'es','Selecciona Empresas',0),(467531,12987,'de','AusgewÃ¤hlte Unternehmen',0),(467532,12987,'en','Selected Companies',0),(467533,12988,'is','',0),(467534,12988,'dr','Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ù¾Ø§ÛŒØ§Ù† Ù…Ø§Ù‡',0),(467535,12988,'pr','Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ù¾Ø§ÛŒØ§Ù† Ù…Ø§Ù‡',0),(467536,12988,'tr','Standart ay sonu',0),(467537,12988,'pl','Standardowe koniec miesiÄ…ca',0),(467538,12988,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ ÐºÑ€Ð°Ñ Ð½Ð° Ð¼ÐµÑÐµÑ†',0),(467539,12988,'ur','Ù…Ø§Û Ú©Û’ Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø¢Ø®Ø±',0),(467540,12988,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ ÐºÑ€Ð°Ñ˜ Ð¼ÐµÑÐµÑ†Ð°',0),(467541,12988,'vi','Cuá»‘i thÃ¡ng chuáº©n',0),(467542,12988,'af','Standaard einde van die maand',0),(467543,12988,'ro','Standard de sfÃ¢rÅŸitul de luni',0),(467544,12988,'et','Standard kuu lÃµpuni',0),(467545,12988,'si','Standard koncem meseca',0),(467546,12988,'ba','Standar akhir bulan',0),(467547,12988,'nl','Standaard einde van de maand',0),(467548,12988,'fi','Kahden kuukauden loppuun',0),(467549,12988,'no','Standard slutten av mÃ¥neden',0),(467550,12988,'da','Standard slutningen af mÃ¥neden',0),(467551,12988,'ko','í‘œì¤€ ì›”ë§',0),(467552,12988,'he','×ª×§×Ÿ ×¡×•×£ ×”×—×•×“×©',0),(467553,12988,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ Ï„Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î¼Î®Î½Î±',0),(467554,12988,'zh','æœˆæ ‡å‡†æœˆåº•',0),(467555,12988,'sv','Standard slutet av mÃ¥naden',0),(467556,12988,'it','EstremitÃ  standard del mese',0),(467557,12988,'tl','',0),(467558,12988,'th','à¸¡à¸²à¸•à¸£à¸à¸²à¸™à¸ªà¸´à¹‰à¸™à¹€à¸”à¸·à¸­à¸™',0),(467559,12988,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤…à¤‚à¤¤ à¤®à¥‡à¤‚ à¤®à¤¾à¤¨à¤•',0),(467560,12988,'ms','Standard penghujung bulan',0),(467561,12988,'ar','Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ© Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø´Ù‡Ø±',0),(467562,12988,'fr','Standard de fin de mois',0),(467563,12988,'jp','æœˆã®æ¨™æº–çš„ãªçµ‚ã‚ã‚Š',0),(467564,12988,'pt','PadrÃ£o final do mÃªs',0),(467565,12988,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ ÐºÐ¾Ð½ÐµÑ† Ð¼ÐµÑÑÑ†Ð°',0),(467566,12988,'es','Fin de Mes EstÃ¡ndar',0),(467567,12988,'de','Standard Ende des Monats',0),(467568,12988,'en','Standard End Of Month',0),(467569,12989,'is','',0),(467570,12989,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ú†Ù‡ Ø±ÙˆØ²ÛŒ Ù…Ø§Ù‡ Ø±Ø§ Ø¨Ø³ØªÙ‡ Ø§Ø³Øª',0),(467571,12989,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ú†Ù‡ Ø±ÙˆØ²ÛŒ Ù…Ø§Ù‡ Ø±Ø§ Ø¨Ø³ØªÙ‡ Ø§Ø³Øª',0),(467572,12989,'tr','SatÄ±cÄ± hangi gÃ¼n ay kapatÄ±r',0),(467573,12989,'pl','Sprzedawca zamyka miesiÄ…c na co dzieÅ„',0),(467574,12989,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð·Ð°Ñ‚Ð²Ð°Ñ€Ñ Ð² ÐºÐ°ÐºÑŠÐ² Ð´ÐµÐ½ Ð¼ÐµÑÐµÑ†',0),(467575,12989,'ur','ÙˆÛŒÙ†ÚˆØ± Ù…ÛÛŒÙ†Û Ú©Ø³ Ø¯Ù† Ø¨Ù†Ø¯ Ú©Ø±ØªØ§ ÛÛ’ Û”',0),(467576,12989,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð°Ñ‚Ð²Ð°Ñ€Ð° Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð° Ð½Ð° ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð´Ð°Ð½Ð°Ñ Ð´Ð°Ð½',0),(467577,12989,'vi','nhÃ  cung cáº¥p káº¿t thÃºc thÃ¡ng vÃ o ngÃ y nÃ o',0),(467578,12989,'af','Verkoper sluit maand op watter dag',0),(467579,12989,'ro','Furnizor se Ã®nchide luna ce zi',0),(467580,12989,'et','Hankija sulgeb kuu mida pÃ¤ev',0),(467581,12989,'si','Prodajalec zapre mesec kakÅ¡en dan',0),(467582,12989,'ba','Penjual menutup bulan pada hari apa',0),(467583,12989,'nl','Leverancier sluit maand op welke dag',0),(467584,12989,'fi','Toimittajan sulkee kuukauden minÃ¤ pÃ¤ivÃ¤nÃ¤',0),(467585,12989,'no','LeverandÃ¸ren avsluttes mÃ¥ned pÃ¥ hvilken dag',0),(467586,12989,'da','Kreditor lukker mÃ¥ned pÃ¥ hvad dag',0),(467587,12989,'ko','ê³µê¸‰ ì—…ì²´ê°€ ë‹«ìŠµë‹ˆë‹¤ ë¬´ìŠ¨ ì¼ì— ë‹¬',0),(467588,12989,'he','×”×¡×¤×§ ×¡×•×’×¨ ×—×•×“×© ×‘××™×–×” ×™×•×',0),(467589,12989,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ ÎºÎ»ÎµÎ¯Î½ÎµÎ¹ Î¼Î®Î½Î± Î Î¿Î¹Î± Î¼Î­ÏÎ±',0),(467590,12989,'zh','ä¾›åº”å•†å…³é—­æœˆçš„å“ªä¸€å¤©',0),(467591,12989,'sv','LeverantÃ¶r stÃ¤nger mÃ¥naden pÃ¥ vilken dag',0),(467592,12989,'it','Fornitore chiude il mese in quale giorno',0),(467593,12989,'tl','',0),(467594,12989,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸›à¸´à¸”à¹€à¸”à¸·à¸­à¸™à¹ƒà¸™à¸§à¸±à¸™à¹ƒà¸”',0),(467595,12989,'hi','à¤•à¥à¤¯à¤¾ à¤¦à¤¿à¤¨ à¤ªà¤° à¤®à¤¹à¥€à¤¨à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤‚à¤¦ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(467596,12989,'ms','Penjual ditutup pada hari apa',0),(467597,12989,'ar','Ø§Ù„Ø¨Ø§Ø¦Ø¹ ÙŠØºÙ„Ù‚ Ø§Ù„Ø´Ù‡Ø± ÙÙŠ ÙŠÙˆÙ… Ù…Ø§',0),(467598,12989,'fr','Fournisseur ferme mois quel jour',0),(467599,12989,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ãŒæ¯Žæœˆä½•æ—¥ã«çµ‚äº†ã—ã¾ã™ã€‚',0),(467600,12989,'pt','Vendedor fecha o mÃªs em que dia',0),(467601,12989,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ† Ð·Ð°ÐºÑ€Ñ‹Ð²Ð°ÐµÑ‚ Ð¼ÐµÑÑÑ† Ð½Ð° ÐºÐ°ÐºÐ¾Ð¹ Ð´ÐµÐ½ÑŒ',0),(467602,12989,'es','Venedor Cierre el Mes en Que DÃ­a',0),(467603,12989,'de','Hersteller schlieÃŸt Monat an welchem Tag',0),(467604,12989,'en','Vendor Closes Month On What Day',0),(467605,12990,'is','',0),(467606,12990,'dr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„',0),(467607,12990,'pr','Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„',0),(467608,12990,'tr','Ä°hracat kategorileri',0),(467609,12990,'pl','Kategorie do eksportu',0),(467610,12990,'bg','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð·Ð° ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(467611,12990,'ur','Ø²Ù…Ø±Û Ø¬Ø§Øª Ú©ÛŒ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’',0),(467612,12990,'sr','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð·Ð° Ð¸Ð·Ð²Ð¾Ð·',0),(467613,12990,'vi','Thá»ƒ loáº¡i Ä‘á»ƒ xuáº¥t kháº©u',0),(467614,12990,'af','KategorieÃ« uitvoer',0),(467615,12990,'ro','Categorii pentru Export',0),(467616,12990,'et','Ekspordi Kategooriad',0),(467617,12990,'si','Kategorije za izvoz',0),(467618,12990,'ba','Kategori untuk ekspor',0),(467619,12990,'nl','CategorieÃ«n te exporteren',0),(467620,12990,'fi','Luokat vie',0),(467621,12990,'no','Kategorier Eksporter',0),(467622,12990,'da','Kategorier til eksport',0),(467623,12990,'ko','ì¹´í…Œê³ ë¦¬ ë‚´ë³´ë‚´ê¸°',0),(467624,12990,'he','×§×˜×’×•×¨×™×•×ª ×œ×™×™×¦×•×',0),(467625,12990,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± ÎµÎ¾Î±Î³Ï‰Î³Î®',0),(467626,12990,'zh','è¦å¯¼å‡ºç±»åˆ«',0),(467627,12990,'sv','Kategorier fÃ¶r Export',0),(467628,12990,'it','Categorie di esportazione',0),(467629,12990,'tl','',0),(467630,12990,'th','à¸›à¸£à¸°à¹€à¸ à¸—à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(467631,12990,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(467632,12990,'ms','Kategori untuk eksport',0),(467633,12990,'ar','ÙØ¦Ø§Øª Ù„Ù„ØªØµØ¯ÙŠØ±',0),(467634,12990,'fr','CatÃ©gories d\'exportation',0),(467635,12990,'jp','ã‚«ãƒ†ã‚´ãƒªã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã™ã‚‹',0),(467636,12990,'pt','Categorias para exportaÃ§Ã£o',0),(467637,12990,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ð´Ð»Ñ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(467638,12990,'es','CatagorÃ­as Para Exportar',0),(467639,12990,'de','Kategorien zum Export',0),(467640,12990,'en','Categories To Export',0),(467641,12991,'is','',0),(467642,12991,'dr','ÙÛŒÙ„Ø¯Ù‡Ø§Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø§Ø±Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(467643,12991,'pr','ÙÛŒÙ„Ø¯Ù‡Ø§Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø§Ø±Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(467644,12991,'tr','Verilecek alanlarÄ± seÃ§in',0),(467645,12991,'pl','Wybierz pola do eksportu',0),(467646,12991,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ð»ÐµÑ‚Ð°Ñ‚Ð° Ð·Ð° ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(467647,12991,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ù‚Ø·Ø¹Ø§Øª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(467648,12991,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ™Ð° Ð·Ð° Ð¸Ð·Ð²Ð¾Ð·',0),(467649,12991,'vi','Chá»n pháº¡m vi Ä‘á»ƒ Ä‘Äƒng xuáº¥t',0),(467650,12991,'af','Kies die velde om uitvoer',0),(467651,12991,'ro','AlegeÅ£i cÃ¢mpurile pentru Export',0),(467652,12991,'et','Vali vÃ¤lju eksportida',0),(467653,12991,'si','Izberite polja za izvoz',0),(467654,12991,'ba','Memilih bidang untuk ekspor',0),(467655,12991,'nl','Kies de velden om te exporteren',0),(467656,12991,'fi','Valitse vietÃ¤vien kenttien',0),(467657,12991,'no','Velg felt som skal eksporteres',0),(467658,12991,'da','VÃ¦lg felter til eksport',0),(467659,12991,'ko','ë‚´ë³´ë‚¼ í•„ë“œ ì„ íƒ',0),(467660,12991,'he','×‘×—×¨ ×©×“×•×ª ×œ×™×™×¦×•×',0),(467661,12991,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î± Ï€ÎµÎ´Î¯Î± Î³Î¹Î± ÎµÎ¾Î±Î³Ï‰Î³Î®',0),(467662,12991,'zh','é€‰æ‹©è¦å¯¼å‡ºçš„å­—æ®µ',0),(467663,12991,'sv','VÃ¤lj fÃ¤lt fÃ¶r Export',0),(467664,12991,'it','Scegliere i campi da esportare',0),(467665,12991,'tl','',0),(467666,12991,'th','à¹€à¸¥à¸·à¸­à¸à¸Ÿà¸´à¸¥à¸”à¹Œà¸—à¸µà¹ˆà¸ˆà¸°à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(467667,12991,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤šà¥à¤¨à¥‡à¤‚',0),(467668,12991,'ms','Pilih medan untuk dieksport',0),(467669,12991,'ar','Ø§Ø®ØªØ± Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ø±Ø§Ø¯ ØªØµØ¯ÙŠØ±Ù‡Ø§',0),(467670,12991,'fr','Choisissez les champs Ã  exporter',0),(467671,12991,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã™ã‚‹ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’é¸æŠžã—ã¾ã™',0),(467672,12991,'pt','Escolha os campos para exportaÃ§Ã£o',0),(467673,12991,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ Ð¿Ð¾Ð»ÐµÐ¹ Ð´Ð»Ñ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(467674,12991,'es','Selecciona Campos Para Exportar',0),(467675,12991,'de','WÃ¤hlen Sie Felder zum Export',0),(467676,12991,'en','Choose Fields To Export',0),(467677,12992,'is','',0),(467678,12992,'dr','ÙÛŒÙ„Ø¯Ù‡Ø§ÛŒ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(467679,12992,'pr','ÙÛŒÙ„Ø¯Ù‡Ø§ÛŒ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(467680,12992,'tr','Ã–zel alanlar',0),(467681,12992,'pl','Pola niestandardowe',0),(467682,12992,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(467683,12992,'ur','Ù…Ø®ØµÙˆØµ Ù‚Ø·Ø¹Ø§Øª',0),(467684,12992,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ñ™Ð°',0),(467685,12992,'vi','trÆ°á»ng tá»± táº¡o',0),(467686,12992,'af','Pasgemaakte velde',0),(467687,12992,'ro','CÃ¢mpuri particularizate',0),(467688,12992,'et','Kohandatud vÃ¤ljad',0),(467689,12992,'si','Polja po meri',0),(467690,12992,'ba','Bidang kustom',0),(467691,12992,'nl','Aangepaste velden',0),(467692,12992,'fi','Mukautetut kentÃ¤t',0),(467693,12992,'no','Egendefinerte felt',0),(467694,12992,'da','Brugerdefinerede felter',0),(467695,12992,'ko','ì‚¬ìš©ìž ì •ì˜ í•„ë“œ',0),(467696,12992,'he','×©×“×•×ª ×ž×•×ª××ž×™× ××™×©×™×ª',0),(467697,12992,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î± Ï€ÎµÎ´Î¯Î±',0),(467698,12992,'zh','è‡ªå®šä¹‰å­—æ®µ',0),(467699,12992,'sv','Anpassade fÃ¤lt',0),(467700,12992,'it','Campi personalizzati',0),(467701,12992,'tl','',0),(467702,12992,'th','à¸Ÿà¸´à¸¥à¸”à¹Œà¹à¸šà¸šà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡',0),(467703,12992,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤«à¥€à¤²à¥à¤¡à¥à¤¸',0),(467704,12992,'ms','Bidang Kastam',0),(467705,12992,'ar','Ø­Ù‚ÙˆÙ„ Ù…Ø®ØµØµØ©',0),(467706,12992,'fr','Champs personnalisÃ©s',0),(467707,12992,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼è¨­å®šãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰',0),(467708,12992,'pt','Campos personalizados',0),(467709,12992,'ru','ÐÐ°ÑÑ‚Ñ€Ð°Ð¸Ð²Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ð¾Ð»Ñ',0),(467710,12992,'es','Campos Personalizados',0),(467711,12992,'de','Benutzerdefinierte Felder',0),(467712,12992,'en','Custom Fields',0),(467713,12993,'is','',0),(467714,12993,'dr','2 Ø³Ø§Ù„ ØªØ§Ø±ÛŒØ®Ú†Ù‡ ÙØ±ÙˆØ´',0),(467715,12993,'pr','Ø§Ø±Ø³Ø§Ù„ 2 Ø³Ø§Ù„ ØªØ§Ø±ÛŒØ®Ú†Ù‡ ÙØ±ÙˆØ´',0),(467716,12993,'tr','2 yÄ±llÄ±k satÄ±ÅŸ tarihi verme',0),(467717,12993,'pl','Eksport 2-letnia historia sprzedaÅ¼y',0),(467718,12993,'bg','2-Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°Ñ‚Ð° Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(467719,12993,'ur','Ø¯Ùˆ Ø³Ø§Ù„ ÙØ±ÙˆØ®Øª ØªØ§Ø±ÛŒØ® Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(467720,12993,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ 2-Ð³Ð¾Ð´Ð¸ÑˆÑšÐ¾Ñ˜ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð¸',0),(467721,12993,'vi','Káº¿t xuáº¥t 2- Lá»‹ch sá»­ bÃ¡n hÃ ng nÄƒm',0),(467722,12993,'af','Voer 2-jaar verkope geskiedenis',0),(467723,12993,'ro','2 ani de istoric vÃ¢nzÄƒri de export',0),(467724,12993,'et','Eksport 2-aastane mÃ¼Ã¼k ajalugu',0),(467725,12993,'si','Izvoz 2-letno zgodovino prodaje',0),(467726,12993,'ba','Ekspor 2-tahun sejarah penjualan',0),(467727,12993,'nl','2-jarige verkoop Geschiedenis exporteren',0),(467728,12993,'fi','Vie 2 vuoden myynti historia',0),(467729,12993,'no','Eksportere 2 Ã¥rs historikk',0),(467730,12993,'da','Eksportere 2-Ã¥rige salgshistorik',0),(467731,12993,'ko','2 ë…„ íŒë§¤ ì—­ì‚¬ë¥¼ ë‚´ë³´ë‚´ê¸°',0),(467732,12993,'he','×™×™×¦×•× ×”×™×¡×˜×•×¨×™×™×ª ×ž×›×™×¨×•×ª ×©× ×ª×™×™×',0),(467733,12993,'el','Î•Î¾Î±Î³Ï‰Î³Î® 2-ÎµÏ„Î® Î¹ÏƒÏ„Î¿ÏÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(467734,12993,'zh','å‡ºå£ 2 å¹´é”€å”®åŽ†å²è®°å½•',0),(467735,12993,'sv','Exportera 2 Ã¥rs fÃ¶rsÃ¤ljning historia',0),(467736,12993,'it','Esportare la cronologia delle vendite di 2 anni',0),(467737,12993,'tl','',0),(467738,12993,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸à¸²à¸£à¸‚à¸²à¸¢ 2 à¸›à¸µ',0),(467739,12993,'hi','2-à¤¸à¤¾à¤² à¤¬à¤¿à¤•à¥à¤°à¥€ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(467740,12993,'ms','Sejarah 2-tahun jualan eksport',0),(467741,12993,'ar','ØªØµØ¯ÙŠØ± ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª 2-Ø§Ù„Ø³Ù†Ø©',0),(467742,12993,'fr','Exporter l\'historique des ventes 2 ans',0),(467743,12993,'jp','2 å¹´é–“ã®è²©å£²å±¥æ­´ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(467744,12993,'pt','Exportar o histÃ³rico de vendas de 2 anos',0),(467745,12993,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ 2-Ð»ÐµÑ‚Ð½ÑÑ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(467746,12993,'es','ExportaciÃ³ne Historia de Ventas Para Dos AÃ±os',0),(467747,12993,'de','2-jÃ¤hrige Vertriebshistorie exportieren',0),(467748,12993,'en','Export 2-Year Sales History',0),(467749,12994,'is','',0),(467750,12994,'dr','Ø§Ø±Ø³Ø§Ù„ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§',0),(467751,12994,'pr','Ø§Ø±Ø³Ø§Ù„ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§',0),(467752,12994,'tr','Ä°hracat maliyetleri',0),(467753,12994,'pl','Koszty wywozu',0),(467754,12994,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(467755,12994,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(467756,12994,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð¸Ð·Ð²Ð¾Ð·Ð°',0),(467757,12994,'vi','Káº¿t xuáº¥t chi phÃ­',0),(467758,12994,'af','Uitvoer koste',0),(467759,12994,'ro','Costurile de export',0),(467760,12994,'et','Ekspordi kulusid',0),(467761,12994,'si','Izvozne stroÅ¡ke',0),(467762,12994,'ba','Biaya ekspor',0),(467763,12994,'nl','Exporteren van kosten',0),(467764,12994,'fi','Vientikustannukset',0),(467765,12994,'no','Eksportere kostnader',0),(467766,12994,'da','Eksportere omkostninger',0),(467767,12994,'ko','ìˆ˜ì¶œ ë¹„ìš©',0),(467768,12994,'he','×¢×œ×•×™×•×ª ×”×™×™×¦×•×',0),(467769,12994,'el','Î¤o ÎºÏŒÏƒÏ„oÏ‚ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚',0),(467770,12994,'zh','å‡ºå£æˆæœ¬',0),(467771,12994,'sv','Exportera kostnader',0),(467772,12994,'it','Costi di esportazione',0),(467773,12994,'tl','',0),(467774,12994,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(467775,12994,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤²à¤¾à¤—à¤¤',0),(467776,12994,'ms','Kos eksport',0),(467777,12994,'ar','ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„ØªØµØ¯ÙŠØ±',0),(467778,12994,'fr','CoÃ»ts d\'exportation',0),(467779,12994,'jp','è¼¸å‡ºè²»ç”¨',0),(467780,12994,'pt','Custos de exportaÃ§Ã£o',0),(467781,12994,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð½Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(467782,12994,'es','Costos de ExportaciÃ³n',0),(467783,12994,'de','Exportkosten',0),(467784,12994,'en','Export Costs',0),(467785,12995,'is','',0),(467786,12995,'dr','Ø§Ø±Ø³Ø§Ù„ Ø³Ø·ÙˆØ­ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ù†Ø¨Ø§Ø± ',0),(467787,12995,'pr','Ø§Ø±Ø³Ø§Ù„ Ø³Ø·ÙˆØ­ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ù†Ø¨Ø§Ø± ',0),(467788,12995,'tr','Eldeki dÃ¼zeyleri vermek',0),(467789,12995,'pl','Eksportu na rÄ™kÄ™',0),(467790,12995,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€ÑŠÐºÐ° Ð½Ð¸Ð²Ð°',0),(467791,12995,'ur','Ø³Ø·Ø­ Ù¾Ø± ÛØ§ØªÚ¾ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(467792,12995,'sr','ÐÐ° Ñ€ÑƒÑ†Ð¸ Ð½Ð¸Ð²Ð¾ Ð¸Ð·Ð²Ð¾Ð·Ð°',0),(467793,12995,'vi','káº¿t xuáº¥t cÃ¡c má»¥c hiá»‡n cÃ³',0),(467794,12995,'af','Uitvoer op-Hand vlakke',0),(467795,12995,'ro','Pe-o parte nivelul de export',0),(467796,12995,'et','Vaba ekspordimahust',0),(467797,12995,'si','Izvoz na roko ravni',0),(467798,12995,'ba','Ekspor tingkat di tangan',0),(467799,12995,'nl','Exporteren op de Hand niveaus',0),(467800,12995,'fi','Vienti kÃ¤ytettÃ¤vissÃ¤ tasolla',0),(467801,12995,'no','Eksportere beholdning nivÃ¥er',0),(467802,12995,'da','Eksportere disponibel niveauer',0),(467803,12995,'ko','ì§ì ‘ ë ˆë²¨ì„ ë‚´ë³´ë‚´ê¸°',0),(467804,12995,'he','×™×™×¦×•× ×‘× ×ž×¦× ×¨×ž×•×ª',0),(467805,12995,'el','Î•Î¾Î±Î³Ï‰Î³Î® ÏƒÏ„Î· Î´Î¹Î¬Î¸ÎµÏƒÎ® ÏƒÎ±Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î±',0),(467806,12995,'zh','å‡ºå£æ‰‹å¤´ä¸Šæ°´å¹³',0),(467807,12995,'sv','Exportera till hands nivÃ¥er',0),(467808,12995,'it','Esportare i livelli a portata di mano',0),(467809,12995,'tl','',0),(467810,12995,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸„à¸£à¸­à¸‡à¸£à¸°à¸”à¸±à¸š',0),(467811,12995,'hi','à¤ªà¤° à¤¹à¤¾à¤¥ à¤¸à¥à¤¤à¤°à¥‹à¤‚ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(467812,12995,'ms','Eksport pada tangan tahap',0),(467813,12995,'ar','ØªØµØ¯ÙŠØ± Ù…Ø³ØªÙˆÙŠØ§Øª ÙÙŠ Ø§Ù„ÙŠØ¯',0),(467814,12995,'fr','Ã€ portÃ©e de main des niveaux d\'exportation',0),(467815,12995,'jp','æ‰‹ã§ãƒ¬ãƒ™ãƒ«ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(467816,12995,'pt','Exportar os nÃ­veis na mÃ£o',0),(467817,12995,'ru','ÐÐ° Ñ€ÑƒÐºÑƒ Ð¾Ð±ÑŠÐµÐ¼ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(467818,12995,'es','Exportaciones Cantidades Disponibles',0),(467819,12995,'de','VorrÃ¤tige Ebenen exportieren',0),(467820,12995,'en','Export On-Hand Levels',0),(467821,12996,'is','',0),(467822,12996,'dr','Ø§Ø±Ø³Ø§Ù„ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§',0),(467823,12996,'pr','Ø§Ø±Ø³Ø§Ù„ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§',0),(467824,12996,'tr','DÄ±ÅŸa aktarma seÃ§enekleri',0),(467825,12996,'pl','Opcje eksportu',0),(467826,12996,'bg','Ð˜Ð·Ð½Ð¾Ñ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(467827,12996,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(467828,12996,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ð¸Ð·Ð²Ð¾Ð·Ð°',0),(467829,12996,'vi','Káº¿t xuáº¥t tÃ¹y Ã½',0),(467830,12996,'af','Uitvoer opsies',0),(467831,12996,'ro','OpÅ£iunile de export',0),(467832,12996,'et','EkspordivÃµimalused',0),(467833,12996,'si','MoÅ¾nosti izvoza',0),(467834,12996,'ba','Ekspor pilihan',0),(467835,12996,'nl','Exportopties voor',0),(467836,12996,'fi','Vientiasetukset',0),(467837,12996,'no','Eksportalternativer',0),(467838,12996,'da','Eksportindstillinger',0),(467839,12996,'ko','ë‚´ë³´ë‚´ê¸° ì˜µì…˜',0),(467840,12996,'he','××¤×©×¨×•×™×•×ª ×™×™×¦×•×',0),(467841,12996,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚',0),(467842,12996,'zh','å¯¼å‡ºé€‰é¡¹',0),(467843,12996,'sv','Exportalternativ',0),(467844,12996,'it','Opzioni di esportazione',0),(467845,12996,'tl','',0),(467846,12996,'th','à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(467847,12996,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(467848,12996,'ms','Eksport pilihan',0),(467849,12996,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø§Ù„ØªØµØ¯ÙŠØ±',0),(467850,12996,'fr','Options d\'exportation',0),(467851,12996,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã®ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(467852,12996,'pt','OpÃ§Ãµes de exportaÃ§Ã£o',0),(467853,12996,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(467854,12996,'es','Opciones de Exportar',0),(467855,12996,'de','Export-Optionen',0),(467856,12996,'en','Export Options',0),(467857,12997,'is','',0),(467858,12997,'dr','Ø§Ø±Ø³Ø§Ù„ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(467859,12997,'pr','Ø§Ø±Ø³Ø§Ù„ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(467860,12997,'tr','Fiyat verme',0),(467861,12997,'pl','Eksport, ceny',0),(467862,12997,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(467863,12997,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(467864,12997,'sr','Ð˜Ð·Ð²Ð¾Ð· Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°',0),(467865,12997,'vi','Káº¿t xuáº¥t giÃ¡',0),(467866,12997,'af','Uitvoer pryse',0),(467867,12997,'ro','De stabilire a preÅ£urilor de export',0),(467868,12997,'et','Ekspordi hindade',0),(467869,12997,'si','Izvozne cene',0),(467870,12997,'ba','Ekspor harga',0),(467871,12997,'nl','Exporteren prijzen',0),(467872,12997,'fi','Vie hinnoittelu',0),(467873,12997,'no','Eksportere priser',0),(467874,12997,'da','Eksportere prissÃ¦tning',0),(467875,12997,'ko','ìˆ˜ì¶œ ê°€ê²©',0),(467876,12997,'he','×™×™×¦×•× ×ª×ž×—×•×¨',0),(467877,12997,'el','Î•Î¾Î±Î³Ï‰Î³Î® Ï„Î¹Î¼ÏŽÎ½',0),(467878,12997,'zh','å‡ºå£å®šä»·',0),(467879,12997,'sv','Exportera prissÃ¤ttning',0),(467880,12997,'it','Esportazione dei prezzi',0),(467881,12997,'tl','',0),(467882,12997,'th','à¸à¸²à¸£à¸à¸³à¸«à¸™à¸”à¸£à¸²à¸„à¸²à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(467883,12997,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(467884,12997,'ms','Eksport harga',0),(467885,12997,'ar','ØªØµØ¯ÙŠØ± Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(467886,12997,'fr','Prix Ã  l\'exportation',0),(467887,12997,'jp','ä¾¡æ ¼è¨­å®šã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(467888,12997,'pt','PreÃ§os de exportaÃ§Ã£o',0),(467889,12997,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð½Ñ‹Ðµ Ñ†ÐµÐ½Ñ‹',0),(467890,12997,'es','Precios de Exportar',0),(467891,12997,'de','Export Preise',0),(467892,12997,'en','Export Pricing',0),(467893,12998,'is','',0),(467894,12998,'dr','Ø§Ø±Ø³Ø§Ù„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(467895,12998,'pr','Ø§Ø±Ø³Ø§Ù„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(467896,12998,'tr','SatÄ±cÄ± Bilgisi verme',0),(467897,12998,'pl','WywÃ³z dostawcy',0),(467898,12998,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°',0),(467899,12998,'ur','ÙˆÛŒÙ†ÚˆØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(467900,12998,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ñƒ',0),(467901,12998,'vi','Káº¿t xuáº¥t thÃ´ng tin nhÃ  cung cáº¥p',0),(467902,12998,'af','Uitvoer handelaar Info',0),(467903,12998,'ro','Export furnizor de informaÅ£ie',0),(467904,12998,'et','Ekspordi hankijate Info',0),(467905,12998,'si','Izvoz prodajalca Info',0),(467906,12998,'ba','Ekspor Vendor Info',0),(467907,12998,'nl','Export Vendor Info',0),(467908,12998,'fi','ViedÃ¤ toimittajan Info',0),(467909,12998,'no','Eksporter leverandÃ¸r Info',0),(467910,12998,'da','Eksportere leverandÃ¸r Info',0),(467911,12998,'ko','ìˆ˜ì¶œ ê³µê¸‰ ì—…ì²´ ì •ë³´',0),(467912,12998,'he','×¤×¨×˜×™ ×¡×¤×§ ×™×™×¦×•×',0),(467913,12998,'el','Î•Î¾Î±Î³Ï‰Î³Î® Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(467914,12998,'zh','å‡ºå£ä¾›åº”å•†ä¿¡æ¯',0),(467915,12998,'sv','Exportera leverantÃ¶rens Info',0),(467916,12998,'it','Esportare informazioni del fornitore',0),(467917,12998,'tl','',0),(467918,12998,'th','à¸ªà¹ˆà¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(467919,12998,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(467920,12998,'ms','Eksport maklumat penjual.',0),(467921,12998,'ar','ØªØµØ¯ÙŠØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(467922,12998,'fr','Exportation d\'informations du vendeur',0),(467923,12998,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼æƒ…å ±ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(467924,12998,'pt','Exportar informaÃ§Ã£o do fornecedor',0),(467925,12998,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(467926,12998,'es','Exportaciones Info de Vendedor',0),(467927,12998,'de','Export-HÃ¤ndler-Info',0),(467928,12998,'en','Export Vendor Info',0),(467929,12999,'is','',0),(467930,12999,'dr','ÙØ§ÛŒÙ„ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ Ø¨Ø§ÛŒØ¯ ØªÙˆØ³Ø· ÛŒÚ© Ù…ØªØ®ØµØµ Ø¨Ø§ Ø§ÛŒÙ† Ø§Ø¨Ø²Ø§Ø± Ø§ÛŒØ¬Ø§Ø¯ Ø´ÙˆØ¯',0),(467931,12999,'pr','ÙØ§ÛŒÙ„ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ Ø¨Ø§ÛŒØ¯ ØªÙˆØ³Ø· ÛŒÚ© Ù…ØªØ®ØµØµ Ø¨Ø§ Ø§ÛŒÙ† Ø§Ø¨Ø²Ø§Ø± Ø§ÛŒØ¬Ø§Ø¯ Ø´ÙˆØ¯',0),(467932,12999,'tr','AlÄ±nacak dosya aynÄ± bu araÃ§ tarafÄ±ndan yapÄ±lmÄ±ÅŸ bir dÄ±ÅŸarÄ± aktarÄ±m Ã¼zerinden oluÅŸturulmuÅŸ olmalÄ±dÄ±r.',0),(467933,12999,'pl','Import z pliku musi byÄ‡ utworzony z eksportu, wykonane przez tego samego narzÄ™dzia.',0),(467934,12999,'bg','Ð¤Ð°Ð¹Ð»ÑŠÑ‚ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐ° Ð±Ð¸Ð»Ð¸ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð¸ Ð¾Ñ‚ Ð¸Ð·Ð½Ð¾Ñ, Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÐ½ Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ ÑÑŠÑ‰Ð¸Ñ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚.',0),(467935,12999,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø³Ù„ Ø§Ø³ Ø§Ø³ÛŒ Ù¹ÙˆÙ„ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ú©ÛŒ Ú¯Ø¦ÛŒ Ø§ÛŒÚ© Ø¨Ø±Ø¢Ù…Ø¯ Ø³Û’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Ø¶Ø±ÙˆØ± Û”',0),(467936,12999,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð·Ð° ÑƒÐ²Ð¾Ð· Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð° Ð¸Ð· Ð·Ð° Ð¸Ð·Ð²Ð¾Ð· Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð¾Ð²Ðµ Ð¸ÑÑ‚Ðµ Ð°Ð»Ð°Ñ‚ÐºÐµ.',0),(467937,12999,'vi','file Ä‘á»ƒ nháº­p pháº£i Ä‘Æ°á»£c táº¡o tá»« má»™t cÃ´ng cá»¥ giá»‘ng nhÆ° váº­y',0),(467938,12999,'af','LÃªer invoer moet geskep uit \'n uitvoer deur hierdie dieselfde instrument gemaak.',0),(467939,12999,'ro','FiÅŸierul de import trebuie sÄƒ au fost create de un export de acest instrument acelaÅŸi.',0),(467940,12999,'et','Faili importimiseks peate olema loonud alates sama pluginaga toimuva ekspordi.',0),(467941,12999,'si','Datoteka za uvoz mora biti ustvarjena od izvoza, ki ga to isto orodje.',0),(467942,12999,'ba','File untuk mengimpor harus dibuat dari ekspor yang dibuat oleh alat ini sama.',0),(467943,12999,'nl','Te importeren bestand moet zijn gemaakt van een export gemaakt door deze dezelfde tool.',0),(467944,12999,'fi','Tuotavan tiedoston on oltava luotu viennistÃ¤ tekemÃ¤t sama tyÃ¶kalu.',0),(467945,12999,'no','Fil som skal importeres mÃ¥ vÃ¦re opprettet fra en eksport laget av samme verktÃ¸yet.',0),(467946,12999,'da','Importer fil skal vÃ¦re oprettet fra en eksport af denne samme vÃ¦rktÃ¸j.',0),(467947,12999,'ko','ê°€ì ¸ì˜¬ íŒŒì¼ì„ì´ ê°™ì€ ë„êµ¬ì— ì˜í•´ ìˆ˜ì¶œì—ì„œ ìƒì„± í•©ë‹ˆë‹¤.',0),(467948,12999,'he','×—×™×™×‘ ×§×•×‘×¥ ×œ×™×™×‘×•× × ×•×¦×¨ ×ž×™×™×¦×•× ×©× ×¢×©×• ×¢×œ ×™×“×™ ××•×ª×• ×›×œ×™ ×–×”.',0),(467949,12999,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡Î¿Ï…Î½ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸ÎµÎ¯ Î±Ï€ÏŒ Î³Î¯Î½ÎµÏ„Î±Î¹ Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ Î¯Î´Î¹Î¿ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚.',0),(467950,12999,'zh','è¦å¯¼å…¥çš„æ–‡ä»¶å¿…é¡»ç”±å‡ºå£ç”±è¿™ç›¸åŒçš„å·¥å…·ã€‚',0),(467951,12999,'sv','Fil som ska importeras mÃ¥ste ha skapats frÃ¥n en export av denna samma verktyg.',0),(467952,12999,'it','File da importare sono stati creati da un\'esportazione fatta da questo stesso strumento.',0),(467953,12999,'tl','',0),(467954,12999,'th','à¹à¸Ÿà¹‰à¸¡à¸™à¸³à¹€à¸‚à¹‰à¸²à¸•à¹‰à¸­à¸‡à¸–à¸¹à¸à¸ªà¸£à¹‰à¸²à¸‡à¸ˆà¸²à¸à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸”à¹‰à¸§à¸¢à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¹€à¸”à¸µà¸¢à¸§à¸à¸±à¸™à¸™à¸µà¹‰',0),(467955,12999,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹ à¤à¤• à¤¹à¥€ à¤‰à¤ªà¤•à¤°à¤£ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤•à¤¿à¤ à¤—à¤ à¤à¤• à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤¸à¥‡ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(467956,12999,'ms','Fail untuk diimport mesti telah diwujudkan dari eksport dibuat oleh alat ini sama.',0),(467957,12999,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØªÙ… Ø¥Ù†Ø´Ø§Ø¡ Ù…Ù„Ù Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù† ØªØµØ¯ÙŠØ± Ø§Ù„Ù…Ù‚Ø¯Ù…Ø© Ù…Ù† Ù‡Ø°Ù‡ Ø§Ù„Ø£Ø¯Ø§Ø© Ù†ÙØ³Ù‡Ø§.',0),(467958,12999,'fr','Fichier Ã  importer doit avoir Ã©tÃ© crÃ©Ã© d\'une exportation faite par ce mÃªme outil.',0),(467959,12999,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹ãƒ•ã‚¡ã‚¤ãƒ«ãŒã“ã®åŒã˜ãƒ„ãƒ¼ãƒ«ã«ã‚ˆã£ã¦ä½œã‚‰ã‚ŒãŸã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã‹ã‚‰ä½œæˆã•ã‚Œã¦ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(467960,12999,'pt','Arquivo de importaÃ§Ã£o deve ter sido criado de uma exportaÃ§Ã£o feita por esta mesma ferramenta.',0),(467961,12999,'ru','Ð¤Ð°Ð¹Ð» Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ ÑÐ¾Ð·Ð´Ð°Ð½ Ð¸Ð· ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°, ÑÐ´ÐµÐ»Ð°Ð½Ð½Ñ‹Ðµ ÑÑ‚Ð¸Ð¼ Ð¶Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð¼.',0),(467962,12999,'es','Archivo para importar debÃ­a estar Creado de una exportaciÃ³n hecho por esta misma herramienta',0),(467963,12999,'de','Zu importierende Datei muss aus einem Export gemacht von diesem gleichen Tool erstellt worden sein.',0),(467964,12999,'en','File to import must have been created from an export made by this same tool.',0),(467965,13000,'is','',0),(467966,13000,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ÛŒ Ø§ÙˆÙ„ÛŒÙ‡  Ø§Ø±Ø³Ø§Ù„ ÙØ§ÛŒÙ„',0),(467967,13000,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ÛŒ Ø§ÙˆÙ„ÛŒÙ‡  Ø§Ø±Ø³Ø§Ù„ ÙØ§ÛŒÙ„',0),(467968,13000,'tr','Ã–nce stok verme dosyasÄ± al',0),(467969,13000,'pl','Plik eksportu importu przed zapasÃ³w',0),(467970,13000,'bg','Ð¤Ð°Ð¹Ð» Ð·Ð° ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ð½Ð¾Ñ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(467971,13000,'ur','Ù¾ÛŒØ´Ú¯ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¨Ø±Ø¢Ù…Ø¯ Ù…Ø³Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(467972,13000,'sr','Ð˜Ð³ÑƒÐ¼Ð°Ð½ Ð·Ð°Ð»Ð¸Ñ…Ð° ÑƒÐ²Ð¾Ð· Ð¸Ð·Ð²Ð¾Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(467973,13000,'vi','Nháº­p kho trÆ°á»›c káº¿t xuáº¥t tá»« file',0),(467974,13000,'af','Vooraf voorraad invoer uitvoer lÃªer',0),(467975,13000,'ro','FiÅŸier de Export import prealabilÄƒ inventar',0),(467976,13000,'et','Impordi eelneva varude ekspordi fail',0),(467977,13000,'si','Izvoz datoteke za uvoz predhodno zaloge',0),(467978,13000,'ba','File ekspor impor sebelumnya persediaan',0),(467979,13000,'nl','Import voorafgaande inventaris exportbestand',0),(467980,13000,'fi','Tuontitiedoston ennen varaston vienti',0),(467981,13000,'no','Importer tidligere lager eksportfilen',0),(467982,13000,'da','Importer forudgÃ¥ende lager eksportfil',0),(467983,13000,'ko','ì´ì „ ì¸ë²¤í† ë¦¬ ë‚´ë³´ë‚´ê¸° íŒŒì¼ ê°€ì ¸ì˜¤ê¸°',0),(467984,13000,'he','×™×™×‘×•× ×§×•×‘×¥ ×”×™×™×¦×•× ×ž×œ××™ ×ž×¨××©',0),(467985,13000,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï… ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(467986,13000,'zh','å¯¼å…¥æœŸåˆåº“å­˜å¯¼å‡ºæ–‡ä»¶',0),(467987,13000,'sv','Importera tidigare inventering exportfil',0),(467988,13000,'it','Importazione File di esportazione inventario preventiva',0),(467989,13000,'tl','',0),(467990,13000,'th','à¹„à¸Ÿà¸¥à¹Œà¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸à¹ˆà¸­à¸™à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(467991,13000,'hi','à¤†à¤¯à¤¾à¤¤ à¤ªà¥‚à¤°à¥à¤µ à¤¸à¥‚à¤šà¥€ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤²',0),(467992,13000,'ms','Fail eksport import inventori terlebih dahulu',0),(467993,13000,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù„Ù Ø§Ù„ØªØµØ¯ÙŠØ± Ø§Ù„Ø¬Ø±Ø¯ Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(467994,13000,'fr','Fichier d\'exportation importation prÃ©alable de l\'inventaire',0),(467995,13000,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆå‰ã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«',0),(467996,13000,'pt','Arquivo de exportaÃ§Ã£o importaÃ§Ã£o inventÃ¡rio prÃ©vio',0),(467997,13000,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ñ„Ð°Ð¹Ð»Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° Ð´Ð¾ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(467998,13000,'es','Importar Archivo de Inventario de ExportaciÃ³n Anterior',0),(467999,13000,'de','Vorherige Inventar-Export-Datei importieren',0),(468000,13000,'en','Import Prior Inventory Export File',0),(468001,13001,'is','',0),(468002,13001,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙˆØ§Ø±Ø¯ Ø´Ø¯',0),(468003,13001,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙˆØ§Ø±Ø¯ Ø´Ø¯',0),(468004,13001,'tr','Stok veri baÅŸarÄ±yla alÄ±ndÄ±',0),(468005,13001,'pl','Magazynowych dane zaimportowane pomyÅ›lnie',0),(468006,13001,'bg','Ð¡ÐºÐ»Ð°Ð´ Ð´Ð°Ð½Ð½Ð¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(468007,13001,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ ÚˆÛŒÙ¹Ø§',0),(468008,13001,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ ÐºÐ¾Ñ˜Ð¸ ÑÑƒ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸',0),(468009,13001,'vi','nháº­p dá»¯ liá»‡u hÃ ng hÃ³a thÃ nh cÃ´ng',0),(468010,13001,'af','Voorraad Data suksesvol ingevoer',0),(468011,13001,'ro','Inventarul datele importate cu succes',0),(468012,13001,'et','Inventuuri andmed edukalt imporditud',0),(468013,13001,'si','Popis podatkov uspeÅ¡no uvoÅ¾en',0),(468014,13001,'ba','Data inventarisasi berhasil diimpor',0),(468015,13001,'nl','Voorraadgegevens geÃ¯mporteerd',0),(468016,13001,'fi','Varaston tietojen tuonti onnistui',0),(468017,13001,'no','Lagerdata importert',0),(468018,13001,'da','Lagerdata importeret',0),(468019,13001,'ko','ì„±ê³µì ìœ¼ë¡œ ê°€ì ¸ì˜¨ ìž¬ê³  ë°ì´í„°',0),(468020,13001,'he','× ×ª×•× ×™ ×ž×œ××™ ×™×•×‘××• ×‘×”×¦×œ×—×”',0),(468021,13001,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Ï„Ï‰Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(468022,13001,'zh','åº“å­˜æ•°æ®æˆåŠŸå¯¼å…¥',0),(468023,13001,'sv','Inventeringsdata har importerats',0),(468024,13001,'it','Dati di inventario importati correttamente',0),(468025,13001,'tl','',0),(468026,13001,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸—à¸µà¹ˆà¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(468027,13001,'hi','à¤¸à¥‚à¤šà¥€ à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤¯à¤¾à¤¤',0),(468028,13001,'ms','Data inventori yang berjaya diimport',0),(468029,13001,'ar','Ø­ØµØ± Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(468030,13001,'fr','L\'inventaire donnÃ©es importÃ©es avec succÃ¨s',0),(468031,13001,'jp','æ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚ŒãŸã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒª ãƒ‡ãƒ¼ã‚¿',0),(468032,13001,'pt','Dados de inventÃ¡rio importados com Ãªxito',0),(468033,13001,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½',0),(468034,13001,'es','Datos de Inventario Importados Exitosamente',0),(468035,13001,'de','Bestandsdaten, die erfolgreich importiert',0),(468036,13001,'en','Inventory Data Imported Successfully',0),(468037,13002,'is','',0),(468038,13002,'dr','/ Ø§Ø±Ø³Ø§Ù„ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¬Ù†Ø³',0),(468039,13002,'pr','Ø§Ø¨Ø²Ø§Ø± ÙˆÛŒØ±Ø§ÛŒØ´ ÙˆØ±ÙˆØ¯/ Ø§Ø±Ø³Ø§Ù„ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§',0),(468040,13002,'tr','Envanter verme/alma dÃ¼zenleme aracÄ±',0),(468041,13002,'pl','NarzÄ™dzie Edycja zapasÃ³w eksportu/importu',0),(468042,13002,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð¸Ð·Ð½Ð¾Ñ/Ð²Ð½Ð¾Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚',0),(468043,13002,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¨Ø±Ø¢Ù…Ø¯/Ø¯Ø±Ø¢Ù…Ø¯ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº Ù¹ÙˆÙ„',0),(468044,13002,'sr','ÐÐ»Ð°Ñ‚ÐºÐµ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¸Ð·Ð²Ð¾Ð·Ð½Ð¾/ÑƒÐ²Ð¾Ð·Ð½Ð¸Ñ… Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(468045,13002,'vi','xuÃ¢t hÃ ng/ nháº­p them cÃ´ng cá»¥',0),(468046,13002,'af','Inventaris uitvoer/invoer redigeer instrument',0),(468047,13002,'ro','Instrument de editare inventar Export/Import',0),(468048,13002,'et','Varude eksport/Import redigeerida tÃ¶Ã¶riist',0),(468049,13002,'si','Orodje za urejanje zaloge izvoz/uvoz',0),(468050,13002,'ba','Persediaan alat Edit ekspor/impor',0),(468051,13002,'nl','Inventarisatieprogramma exporteren/importeren bewerken',0),(468052,13002,'fi','Varastoon vienti/tuonti muokata tyÃ¶kalu',0),(468053,13002,'no','Rediger lagerverktÃ¸yet eksport/Import',0),(468054,13002,'da','Eksport/Import Rediger oversigtsvÃƒÂ¦rktÃƒÂ¸jet',0),(468055,13002,'ko','ì¸ë²¤í† ë¦¬ ë‚´ë³´ë‚´ê¸°/ê°€ì ¸ì˜¤ê¸° íŽ¸ì§‘ ë„êµ¬',0),(468056,13002,'he','×ž×œ××™ ×™×™×‘×•×/×™×™×¦×•× ×›×œ×™ ×¢×¨×™×›×”',0),(468057,13002,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÎ¾Î±Î³Ï‰Î³ÏŽÎ½/ÎµÎ¹ÏƒÎ±Î³Ï‰Î³ÏŽÎ½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÏÎ³Î±Î»ÎµÎ¯Î¿',0),(468058,13002,'zh','æ¸…å•å¯¼å‡º/å¯¼å…¥ç¼–è¾‘å·¥å…·',0),(468059,13002,'sv','Inventering Export/Import redigera verktyg',0),(468060,13002,'it','Strumento di inventario Import/Export Edit',0),(468061,13002,'tl','',0),(468062,13002,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¹à¸à¹‰à¹„à¸‚à¸ªà¹ˆà¸‡à¸­à¸­à¸/à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(468063,13002,'hi','à¤¸à¥‚à¤šà¥€ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤/à¤†à¤¯à¤¾à¤¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤‰à¤ªà¤•à¤°à¤£',0),(468064,13002,'ms','Inventori Eksport/Import Edit alat',0),(468065,13002,'ar','Ø§Ù„Ø¬Ø±Ø¯ Ø£Ø¯Ø§Ø© ØªØ­Ø±ÙŠØ± Ø§Ù„ØªØµØ¯ÙŠØ±/Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(468066,13002,'fr','Outil d\'Ã©dition de l\'inventaire Import/Export',0),(468067,13002,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ/ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®ç·¨é›†ãƒ„ãƒ¼ãƒ«',0),(468068,13002,'pt','Ferramenta de ediÃ§Ã£o do inventÃ¡rio exportaÃ§Ã£o/importaÃ§Ã£o',0),(468069,13002,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°/Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(468070,13002,'es','Inventario Herramienta de Editar  Importar/Exportar',0),(468071,13002,'de','Export/Import bearbeiten Inventurprogramm',0),(468072,13002,'en','Inventory Export/Import Edit Tool',0),(468073,13003,'is','',0),(468074,13003,'dr','Ù…Ø­Ù„ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„',0),(468075,13003,'pr','Ù…Ø­Ù„ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„',0),(468076,13003,'tr','Stok konumlarÄ± iÃ§in dÄ±ÅŸa aktarma',0),(468077,13003,'pl','Lokalizacje zapasÃ³w do eksportu',0),(468078,13003,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÑÑ‚Ð° Ð½Ð° ÑÐºÐ»Ð°Ð´Ð° Ð·Ð° ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(468079,13003,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ù‚Ø§Ù…Ø§Øª Ø³Û’ Ø¨Ø±Ø¢Ù…Ø¯',0),(468080,13003,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð·Ð° Ð¸Ð·Ð²Ð¾Ð·',0),(468081,13003,'vi','Äá»‹a Ä‘iá»ƒm hÃ ng hÃ³a Ä‘á»ƒ xuáº¥t',0),(468082,13003,'af','Inventaris liggings uitvoer',0),(468083,13003,'ro','Inventarul locaÈ›ii de Export',0),(468084,13003,'et','Lao asukohtade eksportimisse',0),(468085,13003,'si','Lokacijami inventarja za izvoz',0),(468086,13003,'ba','Persediaan lokasi untuk ekspor',0),(468087,13003,'nl','Voorraadlocaties exporteren',0),(468088,13003,'fi','Varaston sijaintien vie',0),(468089,13003,'no','Lagerlokasjoner Eksporter',0),(468090,13003,'da','Lokaliteter med beholdning til eksport',0),(468091,13003,'ko','ìˆ˜ì¶œì„ ìž¬ê³  ìœ„ì¹˜',0),(468092,13003,'he','×ž×œ××™ ×ž×™×§×•×ž×™× ×œ×™×™×¦×•×',0),(468093,13003,'el','Î˜Î­ÏƒÎ· Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î³Î¹Î± ÎµÎ¾Î±Î³Ï‰Î³Î®',0),(468094,13003,'zh','åº“å­˜åœ°ç‚¹åˆ°å‡ºå£',0),(468095,13003,'sv','Inventarieplatser export',0),(468096,13003,'it','Posizioni di inventario per esportazione',0),(468097,13003,'tl','',0),(468098,13003,'th','à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(468099,13003,'hi','à¤¸à¥‚à¤šà¥€ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚',0),(468100,13003,'ms','Lokasi inventori untuk eksport',0),(468101,13003,'ar','Ù…ÙˆØ§Ù‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù„Ù„ØªØµØ¯ÙŠØ±',0),(468102,13003,'fr','L\'inventaire des lieux Ã  l\'exportation',0),(468103,13003,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã™ã‚‹åœ¨åº«å ´æ‰€',0),(468104,13003,'pt','Locais de estoque para exportaÃ§Ã£o',0),(468105,13003,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¼ÐµÑÑ‚ Ð´Ð»Ñ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(468106,13003,'es','Inventario Locales Para Exportar',0),(468107,13003,'de','Inventar-Standorten zum Export',0),(468108,13003,'en','Inventory Locations To Export',0),(468109,13004,'is','',0),(468110,13004,'dr','Ø§ØµÙ„Ø§Ø­ ÙØ§ÛŒÙ„ Ø§Ø±Ø³Ø§Ù„',0),(468111,13004,'pr','Ø§ØµÙ„Ø§Ø­ ÙØ§ÛŒÙ„ Ø§Ø±Ø³Ø§Ù„',0),(468112,13004,'tr','DeÄŸiÅŸtirilen dosya',0),(468113,13004,'pl','Zmodyfikowany plik',0),(468114,13004,'bg','ÐœÐ¾Ð´Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð¸ ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚ÐµÐ½ Ñ„Ð°Ð¹Ð»',0),(468115,13004,'ur','ØªØ±Ù…ÛŒÙ… Ø´Ø¯Û Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ù…Ø³Ù„',0),(468116,13004,'sr','ÐœÐ¾Ð´Ð¸Ñ„Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¸ Ð¸Ð·Ð²Ð¾Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(468117,13004,'vi','ÄÃ£ sá»­a file excel',0),(468118,13004,'af','Gemodifiseerde uitvoer lÃªer',0),(468119,13004,'ro','Modificat Export fiÅŸier',0),(468120,13004,'et','Muundatud ekspordi fail',0),(468121,13004,'si','Spremenjenih izvozno datoteko',0),(468122,13004,'ba','File dimodifikasi ekspor',0),(468123,13004,'nl','Gemodificeerde exportbestand',0),(468124,13004,'fi','Muokatun vientitiedoston',0),(468125,13004,'no','Modifisert eksportfilen',0),(468126,13004,'da','Modificerede eksportfilen',0),(468127,13004,'ko','ìˆ˜ì • ëœ ë‚´ë³´ë‚´ê¸° íŒŒì¼',0),(468128,13004,'he','×§×•×‘×¥ ×”×™×™×¦×•× ×©×©×•× ×”',0),(468129,13004,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Ï‰Î½',0),(468130,13004,'zh','ä¿®æ”¹çš„å¯¼å‡ºæ–‡ä»¶',0),(468131,13004,'sv','Modifierade exportfil',0),(468132,13004,'it','File di esportazione modificato',0),(468133,13004,'tl','',0),(468134,13004,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸Ÿà¹‰à¸¡',0),(468135,13004,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤²',0),(468136,13004,'ms','Fail eksport yang diubahsuai',0),(468137,13004,'ar','Ù…Ù„Ù Ø§Ù„ØªØµØ¯ÙŠØ± ØªÙ… Ø§Ù„ØªØ¹Ø¯ÙŠÙ„',0),(468138,13004,'fr','Exportation mis Ã  jour le fichier',0),(468139,13004,'jp','å¤‰æ›´ã•ã‚ŒãŸã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«',0),(468140,13004,'pt','Arquivo de exportaÃ§Ã£o modificados',0),(468141,13004,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ñ„Ð°Ð¹Ð»Ð°',0),(468142,13004,'es','File de ExportaciÃ³n Modificado',0),(468143,13004,'de','GeÃ¤nderte Exportdatei',0),(468144,13004,'en','Modified Export File',0),(468145,13005,'is','',0),(468146,13005,'dr','Ø³Ø·ÙˆØ­ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… Ùˆ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯  Ø¨Ø§ Ø§ÛŒÙ† Ø§Ø¨Ø²Ø§Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø´ÙˆØ¯ ',0),(468147,13005,'pr','Ø³Ø·ÙˆØ­ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… Ùˆ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯  Ø¨Ø§ Ø§ÛŒÙ† Ø§Ø¨Ø²Ø§Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø´ÙˆØ¯ ',0),(468148,13005,'tr','Eldeki dÃ¼zeyleri ve maliyetleri bu araÃ§ ile gÃ¼ncelleÅŸtirilemez.',0),(468149,13005,'pl','Poziomy zapasÃ³w oraz kosztÃ³w nie moÅ¼na zaktualizowaÄ‡ rezygnowaÄ‡ ten narzÄ™dzie.',0),(468150,13005,'bg','Ð¡ Ñ‚Ð¾Ð·Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° Ð½Ð° Ñ€ÑŠÐºÐ° Ð½Ð¸Ð²Ð° Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸.',0),(468151,13005,'ur','Ø§Ø³ Ø¢Ù„Û’ Ú©Û’ Ø³Ø§ØªÚ¾ ØªØ§Ø²Û Ù†ÛÛŒÚº Ú©ÛŒ Ø¬Ø§ Ø³Ú©ØªÛŒ-ÛØ§ØªÚ¾ Ø³Ø·Ø­ Ø§ÙˆØ± Ø§Ø®Ø±Ø§Ø¬Ø§Øª Û”',0),(468152,13005,'sr','ÐÐ¸Ð²Ð¾Ð° Ð½Ð° Ñ€ÑƒÐºÑƒ Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ ÑÐµ Ð½Ðµ Ð¼Ð¾Ð³Ñƒ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ð¸ Ð¿Ð¾Ð¼Ð¾Ñ›Ñƒ Ð¾Ð²Ðµ Ð°Ð»Ð°Ñ‚ÐºÐµ.',0),(468153,13005,'vi','CÃ¡c má»©c vÃ  chi phÃ­ Ä‘ang cÃ³ khÃ´ng thá»ƒ cáº­p nháº­t vá»›i dá»¥ng cá»¥ nÃ y',0),(468154,13005,'af','Op-hand vlakke en koste kan nie bygewerk word met hierdie instrument.',0),(468155,13005,'ro','Nivelurile de pe-o parte ÅŸi costurile nu pot fi actualizate cu acest instrument.',0),(468156,13005,'et','Vaba kaubavaru tasemete ja kulusid ei saa vÃ¤rskendada selle tÃ¶Ã¶riistaga.',0),(468157,13005,'si','Na roko ravni in stroÅ¡kov ni mogoÄe posodobiti s tem orodjem.',0),(468158,13005,'ba','Tingkat di tangan dan biaya tidak dapat diperbarui dengan alat ini.',0),(468159,13005,'nl','Op de hand niveaus en kosten kunnen niet worden bijgewerkt met deze tool.',0),(468160,13005,'fi','KÃ¤sillÃ¤ tasoilla ja se maksaa ei voi pÃ¤ivittÃ¤Ã¤ tÃ¤llÃ¤ tyÃ¶kalulla.',0),(468161,13005,'no','Beholdning nivÃ¥er og kostnader kan ikke oppdateres med dette verktÃ¸yet.',0),(468162,13005,'da','Disponibel niveauer og omkostninger kan ikke opdateres med dette vÃ¦rktÃ¸j.',0),(468163,13005,'ko','ì´ ë„êµ¬ì— ì†ì„ ìˆ˜ì¤€ê³¼ ë¹„ìš©ì„ ì—…ë°ì´íŠ¸í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(468164,13005,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×¢×“×›×Ÿ ×¢×œ-×™×“ ×¨×ž×•×ª ×•×¢×œ×•×™×•×ª ×¢× ×”×›×œ×™ ×”×–×”.',0),(468165,13005,'el','Î£Ï„Î· Î´Î¹Î¬Î¸ÎµÏƒÎ® ÏƒÎ±Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î± ÎºÎ±Î¹ Ï„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ½Î·Î¼ÎµÏÏ‰Î¸ÎµÎ¯ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿.',0),(468166,13005,'zh','ä¸èƒ½ä½¿ç”¨æ­¤å·¥å…·æ›´æ–°æ‰‹å¤´ä¸Šæ°´å¹³å’Œè´¹ç”¨ã€‚',0),(468167,13005,'sv','BehÃ¥llning nivÃ¥er och kostnader kan inte uppdateras med detta verktyg.',0),(468168,13005,'it','Costi e livelli a disposizione non possono essere aggiornati con questo strumento.',0),(468169,13005,'tl','',0),(468170,13005,'th','à¸£à¸°à¸”à¸±à¸šà¸‚à¸­à¸‡à¸„à¸‡à¹€à¸«à¸¥à¸·à¸­à¹à¸¥à¸°à¸•à¹‰à¸™à¸—à¸¸à¸™à¹„à¸¡à¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¸™à¸µà¹‰',0),(468171,13005,'hi','à¤‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤ªà¤° à¤¹à¤¾à¤¥ à¤¸à¥à¤¤à¤°à¥‹à¤‚ à¤”à¤° à¤²à¤¾à¤—à¤¤à¥¤',0),(468172,13005,'ms','Tahap atas tangan dan bayaran tidak dikemaskini dengan alat ini.',0),(468173,13005,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„ÙØ¹Ù„ÙŠØ© ÙˆØ§Ù„ØªÙƒØ§Ù„ÙŠÙ Ù…Ø¹ Ù‡Ø°Ù‡ Ø§Ù„Ø£Ø¯Ø§Ø©.',0),(468174,13005,'fr','CoÃ»ts et les niveaux de stock ne peut pas Ãªtre mis Ã  jour avec cet outil.',0),(468175,13005,'jp','ã“ã®ãƒ„ãƒ¼ãƒ«ã‚’ä½¿ã£ã¦æ‰‹ã§ãƒ¬ãƒ™ãƒ«ã¨ã‚³ã‚¹ãƒˆã‚’æ›´æ–°ã§ãã¾ã›ã‚“ã€‚',0),(468176,13005,'pt','Custos e nÃ­veis na mÃ£o nÃ£o podem ser atualizados com esta ferramenta.',0),(468177,13005,'ru','ÐÐ° Ñ€ÑƒÐºÑƒ ÑƒÑ€Ð¾Ð²Ð½Ð¸ Ð¸ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð½Ðµ Ð¼Ð¾Ð³ÑƒÑ‚ Ð¾Ð±Ð½Ð¾Ð²Ð»ÑÑ‚ÑŒÑÑ Ñ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ ÑÑ‚Ð¾Ð³Ð¾ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð°.',0),(468178,13005,'es','Niveles de Existencias y Costos No Se Pueden Actualizar con Esta Herramienta',0),(468179,13005,'de','VorrÃ¤tige Ebenen und Kosten kÃ¶nnen mit diesem Tool aktualisiert werden.',0),(468180,13005,'en','On-hand levels and costs cannot be updated with this tool.',0),(468181,13006,'is','',0),(468182,13006,'dr','Ù„Ø·ÙØ§ Ø§Ø­ØªÛŒØ§Ø· Ø±Ø§ Ø¨Ø§ Ø§ÛŒÙ† ÙˆØ±ÙˆØ¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯ Ø²Ù…Ø§Ù†ÛŒ Ú©Ù‡ ØªØºÛŒÛŒØ±Ø§Øª Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´ÙˆØ¯  ',0),(468183,13006,'pr','Ù„Ø·ÙØ§ Ø§Ø­ØªÛŒØ§Ø· Ø±Ø§ Ø¨Ø§ Ø§ÛŒÙ† ÙˆØ±ÙˆØ¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯ Ø²Ù…Ø§Ù†ÛŒ Ú©Ù‡ ØªØºÛŒÛŒØ±Ø§Øª Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´ÙˆØ¯  ',0),(468184,13006,'tr','LÃ¼tfen dikkatli olun bu alma ile gibi deÄŸiÅŸiklikler geri alÄ±namaz.',0),(468185,13006,'pl','Prosimy o ostroÅ¼noÅ›Ä‡ z tego importu jako zmiany moÅ¼na cofnÄ…Ä‡.',0),(468186,13006,'bg','ÐœÐ¾Ð»Ñ, Ð±ÑŠÐ´ÐµÑ‚Ðµ Ð²Ð½Ð¸Ð¼Ð°Ñ‚ÐµÐ»Ð½Ð¸ Ñ Ñ‚Ð¾Ð²Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ, ÐºÐ°Ñ‚Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð½Ðµ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð¸.',0),(468187,13006,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Ø§Ù„Ø¹Ø¯Ù… Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ Ø¬ÛŒØ³Ø§ Ú©Û Ø§Ø­ØªÛŒØ§Ø· Ø§Ø³ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Û”',0),(468188,13006,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð‘ÑƒÐ´Ð¸Ñ‚Ðµ Ð¿Ð°Ð¶Ñ™Ð¸Ð²Ð¸ ÑÐ° Ð¾Ð²Ð¸Ð¼ ÑƒÐ²Ð¾Ð·Ð¾Ð¼ ÐºÐ°Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð¾Ð¿Ð¾Ð·Ð²Ð°Ñ‚Ð¸.',0),(468189,13006,'vi','vui lÃ²ng sá»­ dá»¥ng lá»i cáº£nh bÃ¡o khi nháº­p vÃ¬ thay Ä‘á»•i nÃ o cÅ©ng khÃ´ng thá»ƒ hoÃ n thÃ nh',0),(468190,13006,'af','Asseblief versigtig met hierdie invoer gebruik soos veranderinge kan nie ontdoen word nie.',0),(468191,13006,'ro','VÄƒ rugÄƒm sÄƒ folosiÅ£i prudenÅ£Äƒ cu acest import ca modificÄƒrile nu poate fi anulatÄƒ.',0),(468192,13006,'et','Palun ei saa kasutada ettevaatlikult selle impordi muutusi tagasi vÃµtta.',0),(468193,13006,'si','Prosimo, bodite previdni s tem uvozom, kot spremembe ni mogoÄe razveljaviti.',0),(468194,13006,'ba','Gunakan hati-hati dengan impor ini sebagai perubahan tidak bisa dibatalkan.',0),(468195,13006,'nl','Gelieve wees voorzichtig met deze import als wijzigingen kunnen niet ongedaan worden gemaakt.',0),(468196,13006,'fi','KÃ¤yttÃ¤kÃ¤Ã¤ varoen tÃ¤mÃ¤n tuonnin kanssa kuin muutoksia ei voi perua.',0),(468197,13006,'no','Bruk forsiktig med denne importen som endringene ikke kan angres.',0),(468198,13006,'da','Brug venligst forsigtighed med denne import, da Ã¦ndringerne ikke kan fortrydes.',0),(468199,13006,'ko','ì‚¬ìš© í•˜ì‹­ì‹œì˜¤ ì£¼ì˜ì´ ê°€ì ¸ì˜¤ê¸° ë³€ê²½ ë‚´ìš©ì„ ì‹¤í–‰ ì·¨ì†Œí•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(468200,13006,'he','×‘×‘×§×©×” ×”×™×–×”×¨×• ×¢× ×™×™×‘×•× ×–×” ×©×™× ×•×™×™× ×‘×œ×ª×™ ×”×¤×™×š.',0),(468201,13006,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï€ÏÎ¿ÏƒÎ¿Ï‡Î® Î¼Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®, ÏŒÏ€Ï‰Ï‚ Î±Î»Î»Î±Î³Î­Ï‚ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î½Î±Î¹ÏÎµÎ¸ÎµÎ¯.',0),(468202,13006,'zh','è¯·è°¨æ…Žä½¿ç”¨æ­¤å¯¼å…¥ä¸ºæ— æ³•æ’¤æ¶ˆæ›´æ”¹ã€‚',0),(468203,13006,'sv','AnvÃ¤nd fÃ¶rsiktighet med importen som fÃ¶rÃ¤ndringar inte kan Ã¥ngras.',0),(468204,13006,'it','Si prega di usare cautela con questa importazione come modifiche non possono essere annullate.',0),(468205,13006,'tl','',0),(468206,13006,'th','à¹‚à¸›à¸£à¸”à¹ƒà¸Šà¹‰à¸„à¸§à¸²à¸¡à¸£à¸°à¸¡à¸±à¸”à¸£à¸°à¸§à¸±à¸‡à¸à¸±à¸šà¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²à¸™à¸µà¹‰à¹€à¸›à¹‡à¸™à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸¥à¸´à¸à¸—à¸³',0),(468207,13006,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤ªà¥‚à¤°à¥à¤µà¤µà¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤‡à¤¸ à¤†à¤¯à¤¾à¤¤ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤¾à¤µà¤§à¤¾à¤¨à¥€ à¤•à¤¾ à¤ªà¥à¤°à¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚à¥¤',0),(468208,13006,'ms','Sila berhati-hati dengan import ini kerana perubahan tidak boleh dibuat asal.',0),(468209,13006,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø­Ø°Ø± Ù…Ø¹ Ù‡Ø°Ø§ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙƒÙ…Ø§ Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„ØªØ±Ø§Ø¬Ø¹ Ø¹Ù† Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª.',0),(468210,13006,'fr','S\'il vous plaÃ®t soyez prudent avec cette importation comme changements ne peuvent pas Ãªtre annulÃ©e.',0),(468211,13006,'jp','å¤‰æ›´ã¯å…ƒã«æˆ»ã™ã“ã¨ãŒã§ããªã„ã®ã§ã“ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆã«æ³¨æ„ã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(468212,13006,'pt','Por favor, tenha cuidado com esta importaÃ§Ã£o, como alteraÃ§Ãµes nÃ£o podem ser desfeitas.',0),(468213,13006,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð±ÑƒÐ´ÑŒÑ‚Ðµ Ð¾ÑÑ‚Ð¾Ñ€Ð¾Ð¶Ð½Ñ‹ Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°, ÐºÐ°Ðº Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð½ÐµÐ»ÑŒÐ·Ñ Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ.',0),(468214,13006,'es','Por Favor utiliza cauciÃ³n con esta importcaiÃ³n porque cambios no se pued deshacer',0),(468215,13006,'de','Bitte Vorsicht mit diesen Import wie Ã„nderungen rÃ¼ckgÃ¤ngig gemacht werden kÃ¶nnen.',0),(468216,13006,'en','Please use caution with this import as changes cannot be undone.',0),(468217,13007,'is','',0),(468218,13007,'dr','Ù„Ø·ÙØ§ Ø§Ø² Ø§Ø¨Ø²Ø§Ø±ØªÙ†Ø¸ÛŒÙ… Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ù‚Ù„Ø§Ù… Ø¬Ù‡Øª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯ ',0),(468219,13007,'pr','Ù„Ø·ÙØ§ Ø§Ø² Ø§Ø¨Ø²Ø§Ø±ØªÙ†Ø¸ÛŒÙ… Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ù‚Ù„Ø§Ù… Ø¬Ù‡Øª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯ ',0),(468220,13007,'tr','LÃ¼tfen madde maliyet ayarlama aracÄ± maliyetleri gÃ¼ncelleÅŸtirmek iÃ§in kullanÄ±n.',0),(468221,13007,'pl','UÅ¼yj narzÄ™dzia element kosztÃ³w dostosowania do aktualizacji kosztÃ³w.',0),(468222,13007,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸.',0),(468223,13007,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø´Û’ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©Û’ Ø°Ø±ÛŒØ¹Û Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Û”',0),(468224,13007,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð°Ð»Ð°Ñ‚ÐºÑƒ ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð·Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°.',0),(468225,13007,'vi','vui lÃ²ng sá»­ dá»¥ng dá»¥ng cá»¥ Ä‘iá»u chá»‰nh chi phÃ­ má»¥c hÃ ng nÃ y Ä‘á»ƒ cáº­p nháº­t chi phÃ­',0),(468226,13007,'af','Gebruik asseblief die Item koste aanpassing instrument koste opdateer.',0),(468227,13007,'ro','VÄƒ rugÄƒm sÄƒ utilizaÅ£i instrumentul ajustare Cost element pentru a actualiza costurile.',0),(468228,13007,'et','Palun Uuenda maksab kauba omahinna korrigeerimise tÃ¶Ã¶riista abil.',0),(468229,13007,'si','Prosimo, uporabite element stroÅ¡ki prilagajanja orodje za posodobitev stroÅ¡kov.',0),(468230,13007,'ba','Gunakan alat Item biaya penyesuaian untuk biaya update.',0),(468231,13007,'nl','Gebruik het aanpassingsgereedschap Item kosten om kosten bijwerken.',0),(468232,13007,'fi','Kustannusten pÃ¤ivittÃ¤minen nimikekustannusten muutoksia-tyÃ¶kalun avulla.',0),(468233,13007,'no','Bruk verktÃ¸yet element kostnadsjustering oppdatere kostnader.',0),(468234,13007,'da','Brug vÃ¦rktÃ¸jet vare kostregulering til at opdatere omkostningerne.',0),(468235,13007,'ko','ë¹„ìš© ì—…ë°ì´íŠ¸ë¥¼ í•­ëª© ë¹„ìš© ì¡°ì • ë„êµ¬ë¥¼ ì´ìš©í•´ ì£¼ì‹­ì‹œì˜¤.',0),(468236,13007,'he','×”×©×ª×ž×© ×‘×›×œ×™ ×”×”×ª××ž×” ×¢×œ×•×ª ×”×¤×¨×™×˜ ×›×“×™ ×œ×¢×“×›×Ÿ ×¢×œ×•×™×•×ª.',0),(468237,13007,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¯Î·ÏƒÎµ Ï„Î¿ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î³Î¹Î± Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Ï„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚.',0),(468238,13007,'zh','è¯·ä½¿ç”¨é¡¹ç›®æˆæœ¬è°ƒæ•´å·¥å…·æ¥æ›´æ–°æˆæœ¬ã€‚',0),(468239,13007,'sv','AnvÃ¤nd verktyget artikelkostnadsjusteringar uppdatera kostnader.',0),(468240,13007,'it','Si prega di utilizzare lo strumento di regolazione costo elemento per aggiornare i costi.',0),(468241,13007,'tl','',0),(468242,13007,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸Šà¹‰à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¹€à¸žà¸·à¹ˆà¸­à¸­à¸±à¸žà¹€à¸”à¸•à¸•à¹‰à¸™à¸—à¸¸à¸™',0),(468243,13007,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤²à¤¾à¤—à¤¤ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤‡à¤Ÿà¤® à¤²à¤¾à¤—à¤¤ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤•à¤°à¤£ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚à¥¤',0),(468244,13007,'ms','Sila gunakan alat pelarasan kos Item untuk mendapatkan bayaran.',0),(468245,13007,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø£Ø¯Ø§Ø© \"Ø¹Ù†ØµØ± ØªÙƒÙ„ÙØ© Ø§Ù„ØªÙƒÙŠÙ\" Ù„ØªØ­Ø¯ÙŠØ« Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ.',0),(468246,13007,'fr','Veuillez utiliser l\'outil d\'ajustement des coÃ»ts article pour mettre Ã  jour les coÃ»ts.',0),(468247,13007,'jp','ã‚³ã‚¹ãƒˆã‚’æ›´æ–°ã™ã‚‹ã®ã«ã‚¢ã‚¤ãƒ†ãƒ ã®ã‚³ã‚¹ãƒˆèª¿æ•´ãƒ„ãƒ¼ãƒ«ã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(468248,13007,'pt','Por favor, use a ferramenta de ajuste de custo de Item para atualizar os custos.',0),(468249,13007,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð² Ð¿ÑƒÐ½ÐºÑ‚ ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹.',0),(468250,13007,'es','Por Favor utiliza la herramienta de ajuste del costo del item para actualizar costos',0),(468251,13007,'de','Bitte benutzen Sie das Element Kosten-Korrekturwerkzeug Kosten aktualisieren.',0),(468252,13007,'en','Please use the Item Cost Adjustment tool to update costs.',0),(468253,13008,'is','',0),(468254,13008,'dr','Ù„Ø·ÙØ§ Ø§Ø² Ø§Ø¨Ø²Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙÛŒØ²ÛŒÚ©ÛŒ Ú©Ø§Ù„Ø§ Ø¬Ù‡Øª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø³Ø·ÙˆØ­ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(468255,13008,'pr','Ù„Ø·ÙØ§ Ø§Ø² Ø§Ø¨Ø²Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙÛŒØ²ÛŒÚ©ÛŒ Ú©Ø§Ù„Ø§ Ø¬Ù‡Øª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø³Ø·ÙˆØ­ Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù… Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(468256,13008,'tr','LÃ¼tfen eldeki dÃ¼zeylerini gÃ¼ncelleÅŸtirmek iÃ§in Fiziksel Envanter AracÄ±\'nÄ± kullanÄ±n',0),(468257,13008,'pl','UÅ¼yj narzÄ™dzia inwentaryzacji do aktualizacji dostÄ™pnych poziomÃ³w',0),(468258,13008,'bg','ÐœÐ¾Ð»Ñ, Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð·Ð° Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸Ñ‚Ðµ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð´Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚Ðµ Ð½Ð° Ñ€ÑŠÐºÐ° Ð½Ð¸Ð²Ð°',0),(468259,13008,'ur','Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ø¢Ù„Û’ Ù¾Ø± ÛØ§ØªÚ¾ Ø³Ø·Ø­ÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(468260,13008,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð°Ð»Ð°Ñ‚ÐºÑƒ Ð¿Ð¾Ð¿Ð¸ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð»Ð¸ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð°Ð¶ÐµÑ‚Ðµ Ð½Ð¸Ð²Ð¾Ðµ',0),(468261,13008,'vi','vui lÃ²ng sá»­ dá»¥ng dá»¥ng cá»¥ lÃ½ hÃ³a hÃ ng tá»“n kho Ä‘á»ƒ cáº­p nháº­t cÃ¡c má»©c Ä‘ang cÃ³ ',0),(468262,13008,'af','Gebruik asseblief die fisiese voorraad instrument om te werk op-hand vlakke',0),(468263,13008,'ro','VÄƒ rugÄƒm sÄƒ utilizaÅ£i instrumentul inventar fizic pentru a actualiza nivelurile de pe-o parte',0),(468264,13008,'et','Uuenda vaba kaubavaru tasemete inventuuri tÃ¶Ã¶riista abil',0),(468265,13008,'si','Prosimo, uporabite orodje popisa posodobiti na roko ravni',0),(468266,13008,'ba','Gunakan alat persediaan fisik untuk memperbarui tingkat di tangan',0),(468267,13008,'nl','Gelieve te gebruiken de fysieke Inventory tool om te werken op de hand niveaus',0),(468268,13008,'fi','KÃ¤ytÃ¤ fyysisen varaston tyÃ¶kalu pÃ¤ivittÃ¤Ã¤ kÃ¤ytettÃ¤vissÃ¤ tasolla',0),(468269,13008,'no','Bruk verktÃ¸yet vareopptelling oppdatere lagerbeholdningen nivÃ¥er',0),(468270,13008,'da','Brug vÃ¦rktÃ¸jet lageropgÃ¸relse opdatere disponibel niveauer',0),(468271,13008,'ko','ì œë°œ ì‹¤ì œ ìž¬ê³  ë„êµ¬ë¥¼ ì‚¬ìš© í•˜ ì—¬ ì§ì ‘ ìˆ˜ì¤€ ì—…ë°ì´íŠ¸',0),(468272,13008,'he','×”×©×ª×ž×© ×‘×›×œ×™ ×ž×œ××™ ×¤×™×–×™ ×›×“×™ ×œ×¢×“×›×Ÿ ×¢×œ-×™×“ ×¨×ž×•×ª',0),(468273,13008,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ, Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î¿ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ Ï„Î·Ï‚ Ï†Ï…ÏƒÎ¹ÎºÎ®Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ ÏƒÏ„Î· Î´Î¹Î¬Î¸ÎµÏƒÎ® ÏƒÎ±Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î±',0),(468274,13008,'zh','è¯·ä½¿ç”¨ç›˜ç‚¹å·¥å…·æ¥æ›´æ–°æ‰‹å¤´ä¸Šæ°´å¹³',0),(468275,13008,'sv','AnvÃ¤nd verktyget inventering fÃ¶r att uppdatera behÃ¥llning nivÃ¥er',0),(468276,13008,'it','Si prega di utilizzare lo strumento di inventario fisico per aggiornare i livelli a portata di mano',0),(468277,13008,'tl','',0),(468278,13008,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸Šà¹‰à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¸à¸²à¸¢à¸ à¸²à¸žà¹€à¸žà¸·à¹ˆà¸­à¸„à¸‡à¸£à¸°à¸”à¸±à¸šà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(468279,13008,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤° à¤¹à¤¾à¤¥ à¤¸à¥à¤¤à¤°à¥‹à¤‚ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥Œà¤¤à¤¿à¤• à¤¸à¥‚à¤šà¥€ à¤‰à¤ªà¤•à¤°à¤£ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(468280,13008,'ms','Sila gunakan alat inventori fizikal untuk mengemaskini tahap atas tangan',0),(468281,13008,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø£Ø¯Ø§Ø© \"Ø§Ù„Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø§Ø¯ÙŠ\" Ù„ØªØ­Ø¯ÙŠØ« Ù…Ø³ØªÙˆÙŠØ§Øª ÙÙŠ Ø§Ù„ÙŠØ¯',0),(468282,13008,'fr','Veuillez utiliser l\'outil d\'inventaire pour mettre Ã  jour les niveaux de stock',0),(468283,13008,'jp','æ‰‹ã®ãƒ¬ãƒ™ãƒ«ã‚’æ›´æ–°ã™ã‚‹ã®ã«ç‰©ç†çš„ãªã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒª ãƒ„ãƒ¼ãƒ«ã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(468284,13008,'pt','Por favor, use a ferramenta de inventÃ¡rio fÃ­sico para atualizar os nÃ­veis na mÃ£o',0),(468285,13008,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð¾ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð´Ð»Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑƒÑ€Ð¾Ð²Ð½ÐµÐ¹ Ð½Ð° Ñ€ÑƒÐºÑƒ',0),(468286,13008,'es','Por Favor Utiliza la herramienta de inventario fÃ­sico para actualizar niveles de existencias',0),(468287,13008,'de','Bitte benutzen Sie das Tool Inventur, Lagerbestand-Level zu aktualisieren',0),(468288,13008,'en','Please use the Physical Inventory tool to update on-hand levels',0),(468289,13009,'is','',0),(468290,13009,'dr','ÙØ§ÛŒÙ„ Ø¯Ø± ÙØ±Ù…Øª Ù…Ù†Ø§Ø³Ø¨ Ù†ÛŒØ³Øª',0),(468291,13009,'pr','ÙØ§ÛŒÙ„ Ø¯Ø± ÙØ±Ù…Øª Ù…Ù†Ø§Ø³Ø¨ Ù†ÛŒØ³Øª',0),(468292,13009,'tr','Dosya doÄŸru biÃ§imde deÄŸil',0),(468293,13009,'pl','Plik nie jest w odpowiednim formacie',0),(468294,13009,'bg','Ð¤Ð°Ð¹Ð»ÑŠÑ‚ Ð½Ðµ Ðµ Ð² Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¸Ñ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(468295,13009,'ur','Ù…Ø³Ù„ ØµØ­ÛŒØ­ ÙˆØ¶Ø¹ Ù…ÛŒÚº Ù†ÛÛŒÚº ÛÛ’ Û”',0),(468296,13009,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð¸Ñ˜Ðµ Ñƒ Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð°Ñ˜ÑƒÑ›ÐµÐ¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(468297,13009,'vi','táº­p tin nÃ y cÃ³ Ä‘á»‹nh dáº¡ng khÃ´ng Ä‘Ãºng',0),(468298,13009,'af','Die lÃªer Is nie In die regte formaat',0),(468299,13009,'ro','FiÅŸierul nu este Ã®n Format corect',0),(468300,13009,'et','Fail pole Ãµiges vormingus',0),(468301,13009,'si','Datoteka ni v pravilni obliki',0),(468302,13009,'ba','File ini tidak dalam Format yang benar',0),(468303,13009,'nl','Het bestand Is niet In de juiste notatie',0),(468304,13009,'fi','Tiedosto ei ole oikeassa muodossa',0),(468305,13009,'no','Filen er ikke i riktig Format',0),(468306,13009,'da','Filen er ikke i det rigtige Format',0),(468307,13009,'ko','íŒŒì¼ì€ ì˜¬ë°”ë¥¸ í˜•ì‹',0),(468308,13009,'he','×”×§×•×‘×¥ ××™× ×• ×‘×ª×‘× ×™×ª ×”× ×›×•× ×”',0),(468309,13009,'el','Î¤Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÎµ ÏƒÏ‰ÏƒÏ„Î® Î¼Î¿ÏÏ†Î®',0),(468310,13009,'zh','è¯¥æ–‡ä»¶ä¸æ˜¯æ­£ç¡®çš„æ ¼å¼',0),(468311,13009,'sv','Filen Ã¤r inte i rÃ¤tt Format',0),(468312,13009,'it','Il File non Ã¨ nel formato giusto',0),(468313,13009,'tl','',0),(468314,13009,'th','à¹à¸Ÿà¹‰à¸¡à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸£à¸¹à¸›à¹à¸šà¸šà¹€à¸«à¸¡à¸²à¸°à¸ªà¸¡',0),(468315,13009,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤¹à¥€ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(468316,13009,'ms','Fail ini tidak dalam Format yang betul',0),(468317,13009,'ar','Ø§Ù„Ù…Ù„Ù Ù„ÙŠØ³ ÙÙŠ Ø§Ù„ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„ØµØ­ÙŠØ­',0),(468318,13009,'fr','Le fichier n\'est pas dans le bon Format',0),(468319,13009,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ãŒæ­£ã—ã„å½¢å¼ã§ãªã„ã§ã™ã€‚',0),(468320,13009,'pt','O arquivo nÃ£o estÃ¡ no formato',0),(468321,13009,'ru','Ð­Ñ‚Ð¾Ñ‚ Ñ„Ð°Ð¹Ð» Ð½Ð°Ñ…Ð¾Ð´Ð¸Ñ‚ÑÑ Ð½Ðµ Ð² Ð½ÑƒÐ¶Ð½Ð¾Ð¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ',0),(468322,13009,'es','El File No Esta en El Formato Correcto',0),(468323,13009,'de','Die Datei ist nicht im richtigen Format',0),(468324,13009,'en','The File Is Not In The Right Format',0),(468325,13010,'is','',0),(468326,13010,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† Ø§Ø¨Ø²Ø§Ø± Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ Ø¯Ø± ÙØ±Ù…Øª\r\nCSV\r\nØªØºÛŒÛŒØ±Ø§Øª Ø±Ø§ Ø§Ù†Ø¬Ø§Ù… Ø¯Ù‡ÛŒØ¯ ÙˆØ¯ÙˆØ¨Ø§Ø±Ù‡ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(468327,13010,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† Ø§Ø¨Ø²Ø§Ø± Ø¬Ù‡Øª Ø§Ø±Ø³Ø§Ù„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ú©Ø§Ù„Ø§ Ø¯Ø± ÙØ±Ù…Øª\r\nCSV\r\nØªØºÛŒÛŒØ±Ø§Øª Ø±Ø§ Ø§Ù†Ø¬Ø§Ù… Ø¯Ù‡ÛŒØ¯ ÙˆØ¯ÙˆØ¨Ø§Ø±Ù‡ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(468328,13010,'tr','Envanter verileri CSV biÃ§iminde verin, deÄŸiÅŸiklikleri yapÄ±n ve reimport iÃ§in bu aracÄ± kullanÄ±n.',0),(468329,13010,'pl','To narzÄ™dzie umoÅ¼liwia eksportowanie danych w formacie CSV zapasÃ³w, zmiany i ponownie zaimportowaÄ‡.',0),(468330,13010,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚, Ð·Ð° Ð´Ð° ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð´Ð°Ð½Ð½Ð¸ Ð² CSV Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚, Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¸ Ð²Ð½ÐµÑÐµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾.',0),(468331,13010,'ur','CSV ÙˆØ¶Ø¹ Ù…ÛŒÚº Ø¢Ù¾ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ ÚˆÛŒÙ¹Ø§ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚºØŒ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø±ÛŒØ§Ù…Ù¾ÙˆØ±Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ Ù¹ÙˆÙ„ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Û”',0),(468332,13010,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ð°Ð»Ð°Ñ‚ Ð·Ð° Ð¸Ð·Ð²Ð¾Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñƒ Ð¦Ð¡Ð’ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°, Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¸ Ð¼Ð°Ð»Ð¾Ð¼ Ñ‚Ð°ÐºÑÐ¾Ð¼.',0),(468333,13010,'vi','Sá»­ dá»¥ng cÃ´ng cá»¥ nÃ y Ä‘á»ƒ xuáº¥t dá»¯ liá»‡u hÃ ng tá»“n kho cá»§a báº¡n á»Ÿ Ä‘á»‹nh dáº¡ng CSV, thay Ä‘á»•i vÃ  tÃ¡i nháº­p.',0),(468334,13010,'af','Gebruik hierdie instrument om jou voorraad data in CSV formaat uitvoer, maak veranderinge en reimport.',0),(468335,13010,'ro','UtilizaÅ£i acest instrument pentru a exporta datele de inventar Ã®n CSV format, face modificÄƒri ÅŸi reimportaÅ£i.',0),(468336,13010,'et','Selle tÃ¶Ã¶riistaga saate eksportida oma varude andmeid CSV-vormingus, teha muudatusi ja importige uuesti.',0),(468337,13010,'si','Uporabite to orodje za izvoz popis podatkov v CSV format, spreminjati in znova uvozite.',0),(468338,13010,'ba','Gunakan tool ini untuk mengekspor data inventaris Anda dalam CSV format, membuat perubahan dan reimport.',0),(468339,13010,'nl','Gebruik dit hulpmiddel om uw inventarisatiegegevens in CSV-indeling exporteren, wijzigingen aanbrengen en opnieuw importeren.',0),(468340,13010,'fi','TÃ¤mÃ¤n tyÃ¶kalun avulla voit viedÃ¤ varaston tiedot CSV-muodossa, muuttaa ja tuoda uudelleen.',0),(468341,13010,'no','Bruk dette verktÃ¸yet eksporterer du lagerdata i CSV-format, gjÃ¸re endringer og importerer.',0),(468342,13010,'da','Brug dette vÃ¦rktÃ¸j til at eksportere dataene opgÃ¸relse i CSV-format, foretage Ã¦ndringer og importere igen.',0),(468343,13010,'ko','ì´ ë„êµ¬ë¥¼ ì‚¬ìš© í•˜ ì—¬ CSV í˜•ì‹ìœ¼ë¡œ ì¸ë²¤í† ë¦¬ ë°ì´í„° ë‚´ë³´ë‚´ê¸°, ë³€ê²½ ë° ë‹¤ì‹œ ê°€ì ¸ì˜µë‹ˆë‹¤.',0),(468344,13010,'he','×”×©×ª×ž×© ×‘×›×œ×™ ×–×” ×›×“×™ ×œ×™×™×¦× ××ª ×”× ×ª×•× ×™× ×”×ž×œ××™ ×©×œ×š ×‘×ª×‘× ×™×ª CSV, ×©×™× ×•×™×™×, ×œ×™×™×‘× ×ž×—×“×©.',0),(468345,13010,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ Î³Î¹Î± Î½Î± ÎµÎ¾Î±Î³Î¬Î³ÎµÏ„Îµ Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï„Î·Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ ÏƒÎµ Î¼Î¿ÏÏ†Î® CSV, ÎµÏ€Î¹Ï†Î­ÏÎ¿Ï…Î¼Îµ Î±Î»Î»Î±Î³Î­Ï‚ ÎºÎ±Î¹ ÎµÏ€Î±Î½Î±Î»Î¬Î²ÎµÏ„Îµ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®.',0),(468346,13010,'zh','ä½¿ç”¨æ­¤å·¥å…·å¯å¯¼å‡ºåº“å­˜æ•°æ® CSV æ ¼å¼ã€ æ›´æ”¹å’Œé‡æ–°å¯¼å…¥ã€‚',0),(468347,13010,'sv','AnvÃ¤nda verktyget fÃ¶r att exportera lagerdata i CSV-format, gÃ¶ra Ã¤ndringar och importera igen.',0),(468348,13010,'it','Utilizzare questo strumento per esportare i dati di inventario in formato CSV, apportare modifiche e reimportare.',0),(468349,13010,'tl','',0),(468350,13010,'th','à¹ƒà¸Šà¹‰à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¸™à¸µà¹‰à¹€à¸žà¸·à¹ˆà¸­à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸‚à¸­à¸‡à¸„à¸¸à¸“à¹ƒà¸™à¸£à¸¹à¸›à¹à¸šà¸š CSV à¸—à¸³à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡ à¹à¸¥à¸°à¸™à¸³à¹€à¸‚à¹‰',0),(468351,13010,'hi','à¤…à¤ªà¤¨à¥‡ à¤¸à¥‚à¤šà¥€ à¤¡à¥‡à¤Ÿà¤¾ CSV à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚, à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤° à¤”à¤° à¤ªà¥à¤¨à¤°à¥à¤¨à¤¿à¤¯à¤¾à¤¤ à¤•à¤°à¤¤à¥‡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤•à¤¾ à',0),(468352,13010,'ms','Menggunakan alat ini untuk mengeksport data inventori anda dalam CSV format, membuat perubahan dan reimport.',0),(468353,13010,'ar','Ø§Ø³ØªØ®Ø¯Ù… Ù‡Ø°Ù‡ Ø§Ù„Ø£Ø¯Ø§Ø© Ù„ØªØµØ¯ÙŠØ± Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ ÙÙŠ ØªÙ†Ø³ÙŠÙ‚ CSVØŒ ÙˆØ¥Ø¬Ø±Ø§Ø¡ ØªØºÙŠÙŠØ±Ø§Øª ÙˆÙ‚Ù…Øª Ø¨Ø¥Ø¹Ø§Ø¯Ø© Ø§Ø³ØªÙŠØ±Ø§Ø¯.',0),(468354,13010,'fr','Utilisez cet outil pour exporter vos donnÃ©es de l\'inventaire au format CSV, d\'apporter des modifications et de rÃ©importer.',0),(468355,13010,'jp','CSV å½¢å¼ã§ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒª ãƒ‡ãƒ¼ã‚¿ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã€å¤‰æ›´ã€å†ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹ã«ã¯ã€ã“ã®ãƒ„ãƒ¼ãƒ«ã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(468356,13010,'pt','Use esta ferramenta para exportar os dados do inventÃ¡rio no formato CSV, fazer alteraÃ§Ãµes e reimportar.',0),(468357,13010,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ ÑÑ‚Ð¾Ñ‚ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ð´Ð»Ñ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð² Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ CSV, Ð²Ð½ÐµÑÑ‚Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¸ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐ¹Ñ‚Ðµ.',0),(468358,13010,'es','Utiliza esta herramienta para exportar sus datos de inventario en el formato CSV, hace cambios y reimporta.',0),(468359,13010,'de','Verwenden Sie dieses Tool Ihre Bestandsdaten im CSV-Format exportieren, Ã„nderungen vornehmen und neu importieren.',0),(468360,13010,'en','Use this tool to export your inventory data in CSV format, make changes and reimport.',0),(468361,13011,'is','',0),(468362,13011,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© ÙØ§ÛŒÙ„ Ø§Ø±Ø³Ø§Ù„ Ú©Ù†ÛŒØ¯',0),(468363,13011,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© ÙØ§ÛŒÙ„ Ø§Ø±Ø³Ø§Ù„ Ú©Ù†ÛŒØ¯',0),(468364,13011,'tr','Bir dosya gÃ¶ndermek gerekir',0),(468365,13011,'pl','Musisz przesÅ‚aÄ‡ plik',0),(468366,13011,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾Ð´Ð°Ð´ÐµÑ‚Ðµ Ñ„Ð°Ð¹Ð»',0),(468367,13011,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù…Ø³Ù„ Ø§Ø±Ø³Ø§Ù„ Ú©Ø±ÛŒÚº',0),(468368,13011,'sr','ÐÐµÐ¾Ð¿Ñ…Ð¾Ð´Ð½Ð¾ Ñ˜Ðµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(468369,13011,'vi','Báº¡n pháº£i ná»™p 1 táº­p tin',0),(468370,13011,'af','Jy moet \'n lÃªer voorlÃª',0),(468371,13011,'ro','Trebuie sa depuneti un dosar',0),(468372,13011,'et','Esitage fail',0),(468373,13011,'si','Morate poslati datoteko',0),(468374,13011,'ba','Anda harus mengirimkan File',0),(468375,13011,'nl','U dient een bestand',0),(468376,13011,'fi','Sinun on lÃ¤hetettÃ¤vÃ¤ tiedosto',0),(468377,13011,'no','Du mÃ¥ sende en fil',0),(468378,13011,'da','Du skal sende en fil',0),(468379,13011,'ko','íŒŒì¼ì„ ì œì¶œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(468380,13011,'he','×¢×œ×™×š ×œ×”×’×™×© ×§×•×‘×¥',0),(468381,13011,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï…Ï€Î¿Î²Î¬Î»ÎµÏ„Îµ Î­Î½Î± Î±ÏÏ‡ÎµÎ¯Î¿',0),(468382,13011,'zh','æ‚¨å¿…é¡»æäº¤çš„æ–‡ä»¶',0),(468383,13011,'sv','Du mÃ¥ste skicka en fil',0),(468384,13011,'it','Ãˆ necessario inviare un File',0),(468385,13011,'tl','',0),(468386,13011,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸ªà¹ˆà¸‡à¹à¸Ÿà¹‰à¸¡',0),(468387,13011,'hi','à¤¤à¥à¤® à¤à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(468388,13011,'ms','Anda mesti menghantar fail',0),(468389,13011,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø±Ø³Ø§Ù„ Ù…Ù„Ù',0),(468390,13011,'fr','Vous devez soumettre un fichier',0),(468391,13011,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é€ä¿¡ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(468392,13011,'pt','VocÃª deve enviar um arquivo',0),(468393,13011,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð»',0),(468394,13011,'es','Debe Someter un File',0),(468395,13011,'de','Sie mÃ¼ssen eine Datei senden.',0),(468396,13011,'en','You Must Submit A File',0),(468397,13012,'is','',0),(468398,13012,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§ÙˆÙ„',0),(468399,13012,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§ÙˆÙ„',0),(468400,13012,'tr','Ä°lk Mkt.',0),(468401,13012,'pl','Pierwszy iloÅ›Ä‡',0),(468402,13012,'bg','ÐŸÑŠÑ€Ð²Ð¸ ÐºÐ¾Ð»',0),(468403,13012,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ù‚ÛŒ',0),(468404,13012,'sr','ÐŸÑ€Ð²Ð¸ ÐšÐ¾Ð».',0),(468405,13012,'vi','sá»‘ lÆ°á»£ng Ä‘áº§u tiÃªn',0),(468406,13012,'af','Eerste Qty',0),(468407,13012,'ro','Prima cantitate',0),(468408,13012,'et','Esimene kogus',0),(468409,13012,'si','Prvi koliÄina',0),(468410,13012,'ba','Pertama Qty',0),(468411,13012,'nl','Eerste aantal',0),(468412,13012,'fi','EnsimmÃ¤inen mÃ¤Ã¤rÃ¤',0),(468413,13012,'no','FÃ¸rste Ant',0),(468414,13012,'da','FÃ¸rste Qty',0),(468415,13012,'ko','ì²« ë²ˆì§¸ ìˆ˜ëŸ‰',0),(468416,13012,'he','×›×ž×•×ª ×”×¨××©×•×Ÿ',0),(468417,13012,'el','Î ÏÏŽÏ„Î· Qty',0),(468418,13012,'zh','ç¬¬ä¸€æ¬¡çš„æ•°é‡',0),(468419,13012,'sv','FÃ¶rsta Kvt',0),(468420,13012,'it','Primo Qty',0),(468421,13012,'tl','',0),(468422,13012,'th','à¸ˆà¸³à¸™à¸§à¸™à¹à¸£à¸',0),(468423,13012,'hi','à¤ªà¤¹à¤²à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(468424,13012,'ms','Qty pertama',0),(468425,13012,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(468426,13012,'fr','PremiÃ¨re QtÃ©',0),(468427,13012,'jp','æœ€åˆã®æ•°é‡',0),(468428,13012,'pt','Primeiro Qty',0),(468429,13012,'ru','ÐŸÐµÑ€Ð²Ñ‹Ð¹ ÐšÐ¾Ð»',0),(468430,13012,'es','Primera Cantidad',0),(468431,13012,'de','Erste Qty',0),(468432,13012,'en','First Qty',0),(468433,13013,'is','',0),(468434,13013,'dr','Ø¢Ø®Ø±ÛŒÙ† Ù…Ù‚Ø¯Ø§Ø±',0),(468435,13013,'pr','Ø¢Ø®Ø±ÛŒÙ† Ù…Ù‚Ø¯Ø§Ø±',0),(468436,13013,'tr','Son miktar',0),(468437,13013,'pl','Ostatni iloÅ›Ä‡',0),(468438,13013,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(468439,13013,'ur','Ø¢Ø®Ø±ÛŒ Ù‚ÛŒ',0),(468440,13013,'sr','Ð—Ð°Ð´ÑšÐ¸ ÐšÐ¾Ð».',0),(468441,13013,'vi','Sá»‘ lÆ°á»£ng cuá»‘i',0),(468442,13013,'af','Laaste Qty',0),(468443,13013,'ro','Ultima cantitate',0),(468444,13013,'et','Viimase kogus',0),(468445,13013,'si','Zadnji kol',0),(468446,13013,'ba','Terakhir Qty',0),(468447,13013,'nl','Laatste stuks',0),(468448,13013,'fi','Viime mÃ¤Ã¤rÃ¤',0),(468449,13013,'no','Siste antall',0),(468450,13013,'da','Sidste Qty',0),(468451,13013,'ko','ë§ˆì§€ë§‰ ìˆ˜ëŸ‰',0),(468452,13013,'he','×›×ž×•×ª ×”××—×¨×•× ×™×',0),(468453,13013,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Qty',0),(468454,13013,'zh','æœ€åŽçš„æ•°é‡',0),(468455,13013,'sv','Senaste Kvt',0),(468456,13013,'it','Ultimo Qty',0),(468457,13013,'tl','',0),(468458,13013,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(468459,13013,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(468460,13013,'ms','Qty terakhir',0),(468461,13013,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(468462,13013,'fr','DerniÃ¨re quantitÃ©',0),(468463,13013,'jp','æœ€å¾Œã®æ•°é‡',0),(468464,13013,'pt','Ãšltima Qty',0),(468465,13013,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ ÐšÐ¾Ð»',0),(468466,13013,'es','Ultima Cantidad',0),(468467,13013,'de','Letzte Qty',0),(468468,13013,'en','Last Qty',0),(468469,13014,'is','',0),(468470,13014,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù…ØªÙˆØ³Ø·',0),(468471,13014,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù…ØªÙˆØ³Ø·',0),(468472,13014,'tr','Orta miktar',0),(468473,13014,'pl','PoÅ‚owy iloÅ›Ä‡',0),(468474,13014,'bg','Ð¡Ñ€ÐµÐ´Ð°Ñ‚Ð° ÐºÐ¾Ð»',0),(468475,13014,'ur','ÙˆØ³Ø· Ù‚ÛŒ',0),(468476,13014,'sr','Ð¡Ñ€ÐµÐ´Ð¸Ð½Ð¾Ð¼ ÐšÐ¾Ð».',0),(468477,13014,'vi','khá»‘i lÆ°á»£ng giá»¯a',0),(468478,13014,'af','Middel Qty',0),(468479,13014,'ro','Cantit Ã®n mijlocul',0),(468480,13014,'et','Mid kogus',0),(468481,13014,'si','Sredi kol',0),(468482,13014,'ba','Pertengahan Qty',0),(468483,13014,'nl','Mid Qty',0),(468484,13014,'fi','PuolivÃ¤lissÃ¤ mÃ¤Ã¤rÃ¤',0),(468485,13014,'no','Midten av antall',0),(468486,13014,'da','Midten af Qty',0),(468487,13014,'ko','ì¤‘ë°˜ ìˆ˜ëŸ‰',0),(468488,13014,'he','×›×ž×•×ª ×‘××ž×¦×¢',0),(468489,13014,'el','ÎœÎ­ÏƒÎ± Ï„Î¿Ï… Qty',0),(468490,13014,'zh','ä¸­æœŸçš„æ•°é‡',0),(468491,13014,'sv','Mitten av Kvt',0),(468492,13014,'it','MetÃ  Qty',0),(468493,13014,'tl','',0),(468494,13014,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸à¸¥à¸²à¸‡',0),(468495,13014,'hi','à¤®à¤§à¥à¤¯ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(468496,13014,'ms','Qty pertengahan',0),(468497,13014,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„ÙƒÙ…ÙŠØ©',0),(468498,13014,'fr','Qty Mid',0),(468499,13014,'jp','åŠã°æ•°é‡',0),(468500,13014,'pt','Qtde de meados',0),(468501,13014,'ru','Ð¡ÐµÑ€ÐµÐ´Ð¸Ð½Ðµ ÑˆÑ‚',0),(468502,13014,'es','Cantidad Media',0),(468503,13014,'de','Mitte Qty',0),(468504,13014,'en','Mid Qty',0),(468505,13015,'is','',0),(468506,13015,'dr','(Ú¯Ø¯Ø§Ù…)Ø¨Ø±Ø§ÛŒ ÙˆØ§Ø­Ø¯ Ø®Ø±ÛŒØ¯',0),(468507,13015,'pr','ØªØ¹Ø¯Ø§Ø¯ ÙˆØ§Ø­Ø¯Ø³Ù‡Ø§Ù…(Ø§Ù†Ø¨Ø§Ø±)Ø¨Ø±Ø§ÛŒ ÙˆØ§Ø­Ø¯ Ø®Ø±ÛŒØ¯',0),(468508,13015,'tr','SatÄ±nalma birimi baÅŸÄ±na sayÄ± stok birimi',0),(468509,13015,'pl','Numer jednostki czas jednostkowy zakupu',0),(468510,13015,'bg','Ð‘Ñ€Ð¾Ð¹ Ð°ÐºÑ†Ð¸Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(468511,13015,'ur','Ù†Ù…Ø¨Ø± Ø§Ø³Ù¹Ø§Ú© ÛŒÙˆÙ†Ù¹ ÙÛŒ ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(468512,13015,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð°ÐºÑ†Ð¸Ñ˜Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(468513,13015,'vi','sá»‘ Ä‘Æ¡n vá»‹ hÃ ng trong kho trÃªn tá»«ng Ä‘Æ¡n vá»‹ mua hÃ ng',0),(468514,13015,'af','Aantal grootvee-eenheid Per aankoop eenheid',0),(468515,13015,'ro','NumÄƒr unitate stoc Per unitate de cumpÄƒrare',0),(468516,13015,'et','Numbri varude Ã¼ksuse ostuÃ¼hiku kohta',0),(468517,13015,'si','Å tevilo delnic enoto na enote',0),(468518,13015,'ba','Nomor Unit saham Per Pembelian Unit',0),(468519,13015,'nl','Nummer voorraad eenheid Per aankoop eenheid',0),(468520,13015,'fi','Numero varastossa yksikkÃ¶ ostoyksikkÃ¶Ã¤ kohden',0),(468521,13015,'no','Antall lager enhet Per innkjÃ¸psenhet',0),(468522,13015,'da','Antal Stock enhed pr. KÃ¸bsenhed',0),(468523,13015,'ko','êµ¬ë§¤ ë‹¨ìœ„ ë‹¹ ë²ˆí˜¸ ìž¬ê³  ë‹¨ìœ„',0),(468524,13015,'he','×ž×¡×¤×¨ ×”×ž× ×™×•×ª ×”×™×—×™×“×” ×œ×™×—×™×“×” ×¨×›×™×©×”',0),(468525,13015,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î¼Î¿Î½Î¬Î´Î± Î¶Ï‰Î¹ÎºÎ¿Ï ÎºÎµÏ†Î±Î»Î±Î¯Î¿Ï… Î±Î½Î¬ Î¼Î¿Î½Î¬Î´Î± Î±Î³Î¿ÏÎ¬',0),(468526,13015,'zh','æ¯ä¸ªé‡‡è´­å•ä½æ•°çš„è‚¡ç¥¨å•ä½',0),(468527,13015,'sv','Antal aktie Per inkÃ¶psenhet',0),(468528,13015,'it','Numero unitÃ  di riserva Per acquisto di unitÃ ',0),(468529,13015,'tl','',0),(468530,13015,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸«à¸™à¹ˆà¸§à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸•à¹ˆà¸­à¸«à¸™à¹ˆà¸§à¸¢à¸à¸²à¸£à¸‹à¸·à¹‰à¸­',0),(468531,13015,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤–à¤°à¥€à¤¦ à¤‡à¤•à¤¾à¤ˆ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥à¤Ÿà¥‰à¤• à¤‡à¤•à¤¾à¤ˆ',0),(468532,13015,'ms','Nombor Unit saham bagi setiap Unit pembelian',0),(468533,13015,'ar','Ø±Ù‚Ù… ÙˆØ­Ø¯Ø© Ø§Ù„Ø£Ø³Ù‡Ù… ÙƒÙ„ ÙˆØ­Ø¯Ø© Ø§Ù„Ø´Ø±Ø§Ø¡',0),(468534,13015,'fr','NumÃ©ro unitÃ© Stock unitaire d\'achat',0),(468535,13015,'jp','è³¼è²·å˜ä½ã‚ãŸã‚Šæ•°ã®æ ªå¼ã®å˜ä½',0),(468536,13015,'pt','NÃºmero conservado em estoque unidade por unidade de compra',0),(468537,13015,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð°ÐºÑ†Ð¸Ð¹ Ð±Ð»Ð¾Ðº Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñƒ',0),(468538,13015,'es','NÃºmero Unidad de Existencias Por Unidad de Venta',0),(468539,13015,'de','Anzahl Lager Unit pro Bestelleinheit',0),(468540,13015,'en','Number Stock Unit Per Purchase Unit',0),(468541,13016,'is','',0),(468542,13016,'dr','Ù‡Ø²ÛŒÙ†Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(468543,13016,'pr','Ù‡Ø²ÛŒÙ†Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(468544,13016,'tr','SatÄ±cÄ± maliyet',0),(468545,13016,'pl','Koszt sprzedawcy',0),(468546,13016,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(468547,13016,'ur','ÙˆÛŒÙ†ÚˆØ± Ù„Ø§Ú¯Øª',0),(468548,13016,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(468549,13016,'vi','Chi phÃ­ cá»§a nhÃ  cung cáº¥p',0),(468550,13016,'af','Handelaar koste',0),(468551,13016,'ro','Furnizor de Cost',0),(468552,13016,'et','Hankija kulu',0),(468553,13016,'si','StroÅ¡ki za dobavitelja',0),(468554,13016,'ba','Biaya Penjual',0),(468555,13016,'nl','Leverancier kosten',0),(468556,13016,'fi','Toimittajan kustannukset',0),(468557,13016,'no','LeverandÃ¸ren kostnader',0),(468558,13016,'da','Kreditor omkostninger',0),(468559,13016,'ko','ê³µê¸‰ ì—…ì²´ ë¹„ìš©',0),(468560,13016,'he','×¢×œ×•×ª ×”×¡×¤×§',0),(468561,13016,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(468562,13016,'zh','ä¾›åº”å•†æˆæœ¬',0),(468563,13016,'sv','LeverantÃ¶rens kostnad',0),(468564,13016,'it','Costo fornitore',0),(468565,13016,'tl','',0),(468566,13016,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(468567,13016,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤²à¤¾à¤—à¤¤',0),(468568,13016,'ms','Penjual kos',0),(468569,13016,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ù…ÙˆØ±Ø¯',0),(468570,13016,'fr','CoÃ»t du vendeur',0),(468571,13016,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®ã‚³ã‚¹ãƒˆ',0),(468572,13016,'pt','Custo do fornecedor',0),(468573,13016,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð°Ð±Ð¾Ð½ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(468574,13016,'es','Costo de Vendedor',0),(468575,13016,'de','Hersteller-Kosten',0),(468576,13016,'en','Vendor Cost',0),(468577,13017,'is','',0),(468578,13017,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(468579,13017,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(468580,13017,'tr','SatÄ±cÄ± kimliÄŸi',0),(468581,13017,'pl','Identyfikator dostawcy',0),(468582,13017,'bg','Ð˜Ð” Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°',0),(468583,13017,'ur','ÙˆÛŒÙ†ÚˆØ± Ø´Ù†Ø§Ø®Øª',0),(468584,13017,'sr','Ð˜Ð” Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(468585,13017,'vi','ID nhÃ  cung cáº¥p',0),(468586,13017,'af','Handelaar ID',0),(468587,13017,'ro','Furnizor de ID',0),(468588,13017,'et','Hankija ID',0),(468589,13017,'si','ID prodajalca',0),(468590,13017,'ba','Penjual ID',0),(468591,13017,'nl','Vendor ID',0),(468592,13017,'fi','Toimittajatunnus',0),(468593,13017,'no','LeverandÃ¸r-ID',0),(468594,13017,'da','Forhandler-ID',0),(468595,13017,'ko','ê³µê¸‰ ì—…ì²´ ID',0),(468596,13017,'he','×ž×–×”×” ×¡×¤×§',0),(468597,13017,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(468598,13017,'zh','ä¾›åº”å•† ID',0),(468599,13017,'sv','-ID fÃ¶r leverantÃ¶r',0),(468600,13017,'it','ID fornitore',0),(468601,13017,'tl','',0),(468602,13017,'th','à¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(468603,13017,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ ID',0),(468604,13017,'ms','Vendor ID',0),(468605,13017,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…ÙˆØ±Ø¯',0),(468606,13017,'fr','Vendor ID',0),(468607,13017,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ID',0),(468608,13017,'pt','ID do fornecedor',0),(468609,13017,'ru','ÐšÐžÐ” Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(468610,13017,'es','ID de Vendedor',0),(468611,13017,'de','Hersteller-ID',0),(468612,13017,'en','Vendor ID',0),(468613,13018,'is','',0),(468614,13018,'dr','(ÙˆØ²Ù†ÙŠ',0),(468615,13018,'pr','Ù‡Ø²ÙŠÙ†Ù‡ Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù…ÙˆØ²ÙˆÙ†(ÙˆØ²Ù†ÙŠ',0),(468616,13018,'tr','WTD Avg maliyet',0),(468617,13018,'pl','WTD Avg koszt',0),(468618,13018,'bg','WTD Avg Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(468619,13018,'ur','ÙˆÙ¹Ø¯ Ø§ÙˆØ³Ø· Ù„Ø§Ú¯Øª',0),(468620,13018,'sr','WÑ‚Ð´ ÐÐ²Ð³ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(468621,13018,'vi','WTD Avg chi phÃ­',0),(468622,13018,'af','Wtd Avg koste',0),(468623,13018,'ro','Costul de Avg WTD',0),(468624,13018,'et','WTD Avg kulu',0),(468625,13018,'si','Wtd Avg stroÅ¡ki',0),(468626,13018,'ba','Wtd Avg biaya',0),(468627,13018,'nl','WTD Avg kosten',0),(468628,13018,'fi','WTD Avg kustannukset',0),(468629,13018,'no','WTD Avg kostnader',0),(468630,13018,'da','WTD Avg omkostninger',0),(468631,13018,'ko','Wtd í‰ê·  ë¹„ìš©',0),(468632,13018,'he','×¢×œ×•×ª Avg Wtd',0),(468633,13018,'el','WTD Avg ÎºÏŒÏƒÏ„Î¿Ï‚',0),(468634,13018,'zh','Wtd å¹³å‡å®¢æˆ¿ç§Ÿé‡‘æˆæœ¬',0),(468635,13018,'sv','WTD Avg kostnad',0),(468636,13018,'it','WTD Avg costo',0),(468637,13018,'tl','',0),(468638,13018,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™ Wtd Avg',0),(468639,13018,'hi','Wtd à¤”à¤¸à¤¤ à¤²à¤¾à¤—à¤¤',0),(468640,13018,'ms','Kos Avg WTD',0),(468641,13018,'ar','ÙŠÙˆÙ… Ø§Ù„Ø°ÙƒØ±Ù‰ Ø§Ù„Ø¹Ø§Ù„Ù…ÙŠ Ù…ØªÙˆØ³Ø· Ø§Ù„ØªÙƒÙ„ÙØ©',0),(468642,13018,'fr','WTD Avg coÃ»t',0),(468643,13018,'jp','Wtd ã®å¹³å‡è²»ç”¨',0),(468644,13018,'pt','WTD Avg custo',0),(468645,13018,'ru','WTD ÑÑ€ÐµÐ´Ð½Ð¸Ðµ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹',0),(468646,13018,'es','WTD Costo Promedio',0),(468647,13018,'de','WTD-Avg-Kosten',0),(468648,13018,'en','Wtd Avg Cost',0),(468649,13019,'is','',0),(468650,13019,'dr','(ÙˆØ²Ù†ÙŠ',0),(468651,13019,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙŠØ§Ù†Ú¯ÙŠÙ† Ù…ÙˆØ²ÙˆÙ†(ÙˆØ²Ù†ÙŠ',0),(468652,13019,'tr','WTD Avg Mkt.',0),(468653,13019,'pl','WTD Avg Qty',0),(468654,13019,'bg','WTD Avg ÐºÐ¾Ð»',0),(468655,13019,'ur','ÙˆÙ¹Ø¯ Ø§ÙˆØ³Ø· Ù‚ÛŒ',0),(468656,13019,'sr','WÑ‚Ð´ ÐÐ²Ð³ ÐšÐ¾Ð».',0),(468657,13019,'vi','WTD Avg Qty',0),(468658,13019,'af','Wtd Avg Qty',0),(468659,13019,'ro','Cantitate de Avg WTD',0),(468660,13019,'et','WTD Avg kogus',0),(468661,13019,'si','Wtd Avg kol',0),(468662,13019,'ba','Wtd Avg Qty',0),(468663,13019,'nl','WTD Avg Qty',0),(468664,13019,'fi','WTD Avg mÃ¤Ã¤rÃ¤',0),(468665,13019,'no','WTD Avg Ant',0),(468666,13019,'da','WTD Avg Qty',0),(468667,13019,'ko','Wtd í‰ê·  ìˆ˜ëŸ‰',0),(468668,13019,'he','×›×ž×•×ª ×©×œ Avg Wtd',0),(468669,13019,'el','WTD Avg Qty',0),(468670,13019,'zh','Wtd Avg æ•°é‡',0),(468671,13019,'sv','WTD Avg Kvt',0),(468672,13019,'it','WTD Avg Qty',0),(468673,13019,'tl','',0),(468674,13019,'th','à¸›à¸£à¸´à¸¡à¸²à¸“ Wtd Avg',0),(468675,13019,'hi','Wtd à¤”à¤¸à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(468676,13019,'ms','WTD Avg Qty',0),(468677,13019,'ar','ÙŠÙˆÙ… Ø§Ù„Ø°ÙƒØ±Ù‰ Ø§Ù„Ø¹Ø§Ù„Ù…ÙŠ Ù…ØªÙˆØ³Ø· Ø§Ù„ÙƒÙ…ÙŠØ©',0),(468678,13019,'fr','WTD Avg Qty',0),(468679,13019,'jp','Wtd Avg æ•°é‡',0),(468680,13019,'pt','WTD Avg Qty',0),(468681,13019,'ru','WTD Avg Qty',0),(468682,13019,'es','WTD Cantidad Promedio',0),(468683,13019,'de','WTD Avg Qty',0),(468684,13019,'en','Wtd Avg Qty',0),(468685,13020,'is','',0),(468686,13020,'dr','Ù…Ù‚Ø¯Ø§Ø± ØªØ§ Ø§ÛŒÙ† ØªØ§Ø±ÛŒØ® Ø§Ø² Ø³Ø§Ù„',0),(468687,13020,'pr','Ù…Ù‚Ø¯Ø§Ø± ØªØ§ Ø§ÛŒÙ† ØªØ§Ø±ÛŒØ® Ø§Ø² Ø³Ø§Ù„',0),(468688,13020,'tr','YTD Amt',0),(468689,13020,'pl','Amt OPR',0),(468690,13020,'bg','ÐžÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Amt',0),(468691,13020,'ur','ÛŒÙ¹Ø¯ Ø§Ù…Ù¹',0),(468692,13020,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð Ð•Ð¤. Ð’Ð°Ð».',0),(468693,13020,'vi','Tá»•ng sá»‘ tiá»n Ä‘áº§u nÄƒm Ä‘áº¿n nay',0),(468694,13020,'af','JTD Bedrag',0),(468695,13020,'ro','YTD Amt',0),(468696,13020,'et','YTD Amt',0),(468697,13020,'si','YTD Amt',0),(468698,13020,'ba','YTD Amt',0),(468699,13020,'nl','YTD Amt',0),(468700,13020,'fi','Vuoden alusta Amt',0),(468701,13020,'no','YTD Amt',0),(468702,13020,'da','Ã…TD-Amt',0),(468703,13020,'ko','YTD Amt',0),(468704,13020,'he','Amt ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(468705,13020,'el','YTD Amt',0),(468706,13020,'zh','YTD Amt',0),(468707,13020,'sv','YTD Amt',0),(468708,13020,'it','YTD Amt',0),(468709,13020,'tl','',0),(468710,13020,'th','à¸ˆà¸³à¸™à¸§à¸™ YTD',0),(468711,13020,'hi','YTD Amt',0),(468712,13020,'ms','Amt THK',0),(468713,13020,'ar','Ø§Ù„Ù‚Ø¶Ø§Ø© Ø§Ù„ØªÙˆÙ†Ø³ÙŠÙŠÙ† Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(468714,13020,'fr','Amt CDA',0),(468715,13020,'jp','YTD Amt',0),(468716,13020,'pt','YTD Amt',0),(468717,13020,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð° Amt',0),(468718,13020,'es','Monto AÃ±o a la Fecha',0),(468719,13020,'de','YTD Amt',0),(468720,13020,'en','YTD Amt',0),(468721,13021,'is','',0),(468722,13021,'dr','Ù…Ù‚Ø¯Ø§Ø± ØªØ§ Ø§ÛŒÙ† ØªØ§Ø±ÛŒØ® Ø§Ø² Ø³Ø§Ù„ ',0),(468723,13021,'pr','Ù…Ù‚Ø¯Ø§Ø± ØªØ§ Ø§ÛŒÙ† ØªØ§Ø±ÛŒØ® Ø§Ø² Ø³Ø§Ù„ ',0),(468724,13021,'tr','YTD Mkt.',0),(468725,13021,'pl','IloÅ›Ä‡ OPR',0),(468726,13021,'bg','ÐžÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° ÐºÐ¾Ð»',0),(468727,13021,'ur','ÛŒÙ¹Ø¯ Ù‚ÛŒ',0),(468728,13021,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° ÐšÐ¾Ð».',0),(468729,13021,'vi','Tá»•ng sá»‘ lÆ°á»£ng Ä‘áº§u nÄƒm Ä‘áº¿n nay',0),(468730,13021,'af','JTD Hoeveelheid',0),(468731,13021,'ro','YTD cantit',0),(468732,13021,'et','YTD kogus',0),(468733,13021,'si','YTD kol',0),(468734,13021,'ba','YTD Qty',0),(468735,13021,'nl','YTD Qty',0),(468736,13021,'fi','Vuoden alusta mÃ¤Ã¤rÃ¤',0),(468737,13021,'no','YTD Ant',0),(468738,13021,'da','Ã…TD-antal',0),(468739,13021,'ko','YTD ìˆ˜ëŸ‰',0),(468740,13021,'he','×›×ž×•×ª ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(468741,13021,'el','YTD Qty',0),(468742,13021,'zh','YTD æ•°é‡',0),(468743,13021,'sv','YTD Kvt',0),(468744,13021,'it','YTD Qty',0),(468745,13021,'tl','',0),(468746,13021,'th','YTD à¸›à¸£à¸´à¸¡à¸²à¸“',0),(468747,13021,'hi','YTD à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(468748,13021,'ms','Qty THK',0),(468749,13021,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(468750,13021,'fr','YTD QtÃ©',0),(468751,13021,'jp','YTD æ•°é‡',0),(468752,13021,'pt','YTD Qty',0),(468753,13021,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(468754,13021,'es','Cantidad AÃ±o a la Fecha',0),(468755,13021,'de','YTD Qty',0),(468756,13021,'en','YTD Qty',0),(468757,13022,'is','',0),(468758,13022,'dr','/ÙˆØ±ÙˆØ¯ Ø§ØµÙ„Ø§Ø­ Ø§Ø¨Ø²Ø§Ø±',0),(468759,13022,'pr','Ø§Ø±Ø³Ø§Ù„/ÙˆØ±ÙˆØ¯ ÙˆÛŒØ±Ø§ÛŒØ´ Ø§Ø¨Ø²Ø§Ø±',0),(468760,13022,'tr','Verme/alma dÃ¼zenleme aracÄ±',0),(468761,13022,'pl','NarzÄ™dzie Edycja eksportu/importu',0),(468762,13022,'bg','Ð˜Ð·Ð½Ð¾Ñ/Ð²Ð½Ð¾Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚',0),(468763,13022,'ur','Ø¯Ø±Ø¢Ù…Ø¯/Ø¨Ø±Ø¢Ù…Ø¯ ØªØ¯ÙˆÛŒÙ† Ù¹ÙˆÙ„',0),(468764,13022,'sr','Ð˜Ð·Ð²Ð¾Ð· /ÑƒÐ²Ð¾Ð· Ð°Ð»Ð°Ñ‚ÐºÐµ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(468765,13022,'vi','Xuáº¥t/ nháº­p thÃªm dá»¥ng cá»¥',0),(468766,13022,'af','Uitvoer/invoer redigeer instrument',0),(468767,13022,'ro','Instrument de editare de Import-export',0),(468768,13022,'et','Ekspordi/impordi redigeerida tÃ¶Ã¶riist',0),(468769,13022,'si','Izvoz/uvoz orodje za urejanje',0),(468770,13022,'ba','Ekspor/impor alat Edit',0),(468771,13022,'nl','Export/Import Edit-hulpmiddel',0),(468772,13022,'fi','Vienti/tuonti muokata tyÃ¶kalu',0),(468773,13022,'no','Eksport/Import redigere verktÃ¸yet',0),(468774,13022,'da','Eksport Rediger vÃ¦rktÃ¸j',0),(468775,13022,'ko','ë‚´ë³´ë‚´ê¸°/ê°€ì ¸ì˜¤ê¸° íŽ¸ì§‘ ë„êµ¬',0),(468776,13022,'he','×™×™×¦×•×/×™×™×‘×•× ×›×œ×™ ×¢×¨×™×›×”',0),(468777,13022,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚/ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(468778,13022,'zh','è¿›å‡ºå£ç¼–è¾‘å·¥å…·',0),(468779,13022,'sv','Exportera/importera redigera verktyg',0),(468780,13022,'it','Esportazione/importazione strumento Edit',0),(468781,13022,'tl','',0),(468782,13022,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸/à¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¹à¸à¹‰à¹„à¸‚',0),(468783,13022,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤/à¤†à¤¯à¤¾à¤¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤‰à¤ªà¤•à¤°à¤£',0),(468784,13022,'ms','Eksport/Import alat Edit',0),(468785,13022,'ar','Ø£Ø¯Ø§Ø© ØªØ­Ø±ÙŠØ± Ø§Ù„ØªØµØ¯ÙŠØ±/Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(468786,13022,'fr','Outil d\'Ã©dition Import/Export',0),(468787,13022,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ/ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®ç·¨é›†ãƒ„ãƒ¼ãƒ«',0),(468788,13022,'pt','Ferramenta de ediÃ§Ã£o de exportaÃ§Ã£o/importaÃ§Ã£o',0),(468789,13022,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚/Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(468790,13022,'es','Exportar/Importar Herramienta Para Editar',0),(468791,13022,'de','Export/Import-Bearbeiten-Werkzeug',0),(468792,13022,'en','Export/Import Edit Tool',0),(468793,13023,'is','',0),(468794,13023,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§  Ø±ÙˆØ²Ù‡Ø§ ØªØ§ ØªØ§Ø±ÛŒØ® Ø³Ø± Ø±Ø³ÛŒØ¯ ',0),(468795,13023,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø³ÙØ§Ø±Ø´ Ø§Ø¬Ø±Ø§  Ø±ÙˆØ²Ù‡Ø§ ØªØ§ ØªØ§Ø±ÛŒØ® Ø³Ø± Ø±Ø³ÛŒØ¯ ',0),(468796,13023,'tr','KarÅŸÄ±lama sipariÅŸi varsayÄ±lan gÃ¼n vade iÃ§in Tarih',0),(468797,13023,'pl','Termin realizacji zamÃ³wienia domyÅ›lne dni do ukoÅ„czenia',0),(468798,13023,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ñ€ÐµÐ´ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð½Ð¸ Ð´Ð¾ Ð¿Ð°Ð´ÐµÐ¶',0),(468799,13023,'ur','Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ø·Û’ Ø´Ø¯Û Ø¯Ù† Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(468800,13023,'sr','Ð˜ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾Ð³ Ð´Ð°Ð½Ð° Ð´Ð° ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(468801,13023,'vi','CÃ¡c Ä‘Æ¡n hÃ ng máº·c Ä‘á»‹nh cáº­p nháº­t ngÃ y Ä‘áº¿n háº¡n',0),(468802,13023,'af','Vervulling orde verstek dae om verskuldigde datum',0),(468803,13023,'ro','ÃŽndeplinirea comenzii implicit zile a Due',0),(468804,13023,'et','Plaanitud tellimuse vaikimisi pÃ¤eva nÃµuetekohaselt',0),(468805,13023,'si','Datum izpolnitve nalog privzeto dni do zapadlosti',0),(468806,13023,'ba','Pemenuhan Order Default hari untuk Due Date',0),(468807,13023,'nl','Vervulling volgorde standaard dagen Due Date',0),(468808,13023,'fi','TÃ¤yttÃ¤minen jotta laiminlyÃ¶minen pÃ¤ivÃ¤Ã¤ jotta arvonmukainen',0),(468809,13023,'no','Oppfyllelse for standard dager til grunn',0),(468810,13023,'da','Opfyldelse for standard dage til behÃ¸rig dato',0),(468811,13023,'ko','ë•Œë¬¸ì— í–‰ ìˆœì„œ ê¸°ë³¸ ì¼ ë‚ ì§œ',0),(468812,13023,'he','×”×’×©×ž×” ×¡×“×¨ ×‘×¨×™×¨×ª ×ž×—×“×œ ×™×ž×™× ×‘×©×œ ×ª××¨×™×š',0),(468813,13023,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î·Î¼Î­ÏÎµÏ‚ ÏƒÎµ Î¿Ï†ÎµÎ¹Î»ÏŒÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(468814,13023,'zh','å±¥è¡Œè®¢å•é»˜è®¤å¤©è‡³åˆ°æœŸæ—¥æœŸ',0),(468815,13023,'sv','Uppfyllelse ordning standard dagar till rakt',0),(468816,13023,'it','Evasione ordine predefinito giorni alla scadenza Data',0),(468817,13023,'tl','',0),(468818,13023,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™',0),(468819,13023,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¾à¤°à¥€à¤–',0),(468820,13023,'ms','Memenuhi perintah lalai hari untuk habis tempoh tarikh',0),(468821,13023,'ar','ÙˆÙØ§Ø¡ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ ÙŠÙˆÙ…Ø§ Ù„Ù„ÙˆØ§Ø¬Ø¨ Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(468822,13023,'fr','RÃ©alisation ordre par dÃ©faut jours de Due Date',0),(468823,13023,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ã‚ªãƒ¼ãƒ€ãƒ¼æ—¢å®šã™ã‚‹ãŸã‚ã«æ—¥',0),(468824,13023,'pt','Dias de padrÃ£o de ordem de cumprimento para devido data',0),(468825,13023,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð½ÐµÐ¹ Ð´Ð»Ñ Ð½Ð°Ð´Ð»ÐµÐ¶Ð°Ñ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹',0),(468826,13023,'es','DÃ­as por Defecto a la Fecha de Vencimiento de Orden de Cumplimiento',0),(468827,13023,'de','ErfÃ¼llung Bestellung Standard Tage zu Due',0),(468828,13023,'en','Fulfillment Order Default Days To Due Date',0),(468829,13024,'is','',0),(468830,13024,'dr','(Ù…ÙˆØ±Ø¯) Ø¯Ø±Ø§Ø±Ø³Ø§Ù„ Ø¬Ù†Ø³(Ø­Ù…Ù„) ÙˆØ§ÛŒØ¬Ø§Ø¯ Ø¨ÛŒØ¬Ú©  ',0),(468831,13024,'pr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ú©Ø§Ù„Ø§(Ù…ÙˆØ±Ø¯) Ø¯Ø±Ø§Ø±Ø³Ø§Ù„ Ú©Ø§Ù„Ø§(Ø­Ù…Ù„) ÙˆØ§ÛŒØ¬Ø§Ø¯ ÙØ§Ú©ØªÙˆØ±  ',0),(468832,13024,'tr','Nakliye & faturalama iÃ§inde Ã¶ÄŸe SeÃ§enekleri gizle',0),(468833,13024,'pl','Ukryj element Opcje wysyÅ‚ki & fakturowania',0),(468834,13024,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¾Ð¿Ñ†Ð¸Ð¸Ñ‚Ðµ Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð² ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ & Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(468835,13024,'ur','Ø´Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ù…ÛŒÚº Ø´Ù¾Ù†Ú¯ & Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(468836,13024,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÑÑ‚Ð°Ð²ÐºÑƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ Ñƒ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(468837,13024,'vi','Giáº¥u sá»± chá»n lá»±a cÃ¡c má»¥c trong váº­n chuyá»ƒn vÃ  in hÃ³a Ä‘Æ¡n',0),(468838,13024,'af','Versteek Item opsies In gestuur & fakturering',0),(468839,13024,'ro','Ascunde opÅ£iunile de element Ã®n transport & facturare',0),(468840,13024,'et','Peida Ã¼ksuse suvandite Shipping & arveldamine',0),(468841,13024,'si','Skrij element moÅ¾nosti v Shipping & fakturiranje',0),(468842,13024,'ba','Sembunyikan Item pilihan dalam pengiriman & faktur',0),(468843,13024,'nl','Verbergen Itemopties In verzending & facturering',0),(468844,13024,'fi','Piilota kohde vaihtoehtoja merenkulun & laskutus',0),(468845,13024,'no','Skjul elementet alternativer i Shipping & fakturering',0),(468846,13024,'da','Skjule elementet indstillinger i Shipping & fakturering',0),(468847,13024,'ko','ë°°ì†¡ & ì†¡ìž¥ì—ì„œ í•­ëª© ì˜µì…˜ ìˆ¨ê¸°ê¸°',0),(468848,13024,'he','×”×¡×ª×¨×ª ×¤×¨×™×˜ ××¤×©×¨×•×™×•×ª ×ž×©×œ×•×— & ×œ×”×¤×§×ª ×—×©×‘×•× ×™×ª',0),(468849,13024,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ ÏƒÏ„Î·Î½ Î½Î±Ï…Ï„Î¹Î»Î¯Î± & Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(468850,13024,'zh','éšè—åœ¨èˆªè¿ &amp; å¼€ç¥¨çš„é¡¹ç›®é€‰é¡¹',0),(468851,13024,'sv','DÃ¶lj Objektalternativ i frakt & fakturering',0),(468852,13024,'it','Nascondi opzioni elemento nella spedizione & fatturazione',0),(468853,13024,'tl','',0),(468854,13024,'th','à¸‹à¹ˆà¸­à¸™à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¹ƒà¸™à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ & à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(468855,13024,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— & à¤šà¤¾à¤²à¤¾à¤¨ à¤®à¥‡à¤‚ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¤²à¥à¤ª à¤›à¥à¤ªà¤¾à¤à¤',0),(468856,13024,'ms','Sembunyi Item pilihan dalam perkapalan & invois',0),(468857,13024,'ar','Ø¥Ø®ÙØ§Ø¡ Ø®ÙŠØ§Ø±Ø§Øª Ø¹Ù†ØµØ± ÙÙŠ Ø§Ù„Ø´Ø­Ù† Ø¢Ù†Ø¯ Ø§Ù„ÙÙˆØªØ±Ø©',0),(468858,13024,'fr','Cacher les Options de l\'Ã©lÃ©ment dans la marine marchande & de facturation',0),(468859,13024,'jp','é€æ–™ & è«‹æ±‚é …ç›®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(468860,13024,'pt','Ocultar opÃ§Ãµes Item no transporte & de facturaÃ§Ã£o',0),(468861,13024,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð² Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° & ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(468862,13024,'es','Esconde Opciones de Item en FacturaciÃ³n y Transporte',0),(468863,13024,'de','Optionen fÃ¼r im Versand & Rechnungsstellung zu verstecken',0),(468864,13024,'en','Hide Item Options In Shipping & Invoicing',0),(468865,13025,'is','',0),(468866,13025,'dr','Ø±ÙˆØ²Ù‡Ø§ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ØªØ§ Ø³Ø± Ø±Ø³ÛŒØ¯ ',0),(468867,13025,'pr','Ø±ÙˆØ²Ù‡Ø§ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ØªØ§ Ø³Ø± Ø±Ø³ÛŒØ¯ ',0),(468868,13025,'tr','Servis sipariÅŸi varsayÄ±lan gÃ¼n vade tarihi',0),(468869,13025,'pl','Data Service Order domyÅ›lne dni Due',0),(468870,13025,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð½Ð¸ Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾ Ð´Ð°Ñ‚Ð°',0),(468871,13025,'ur','Ø®Ø¯Ù…Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ø·Û’ Ø´Ø¯Û Ø¯Ù† Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(468872,13025,'sr','Ð£ÑÐ»ÑƒÐ³Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾Ð³ Ð´Ð°Ð½Ð° Ð´Ð° ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(468873,13025,'vi','ÄÆ¡n hÃ ng dá»‹ch vá»¥ máº·c Ä‘á»‹nh Ä‘áº¿n háº¡n',0),(468874,13025,'af','Diens bestel verstek dae om verskuldigde datum',0),(468875,13025,'ro','Serviciul ordine implicitÄƒ zile a Due',0),(468876,13025,'et','Teenuse tellimuse vaikimisi pÃ¤eva nÃµuetekohaselt',0),(468877,13025,'si','Storitev nalog privzeto dni do zapadlosti, datum',0),(468878,13025,'ba','Layanan urutan Default hari untuk Due Date',0),(468879,13025,'nl','Service Order standaard dagen Due Date',0),(468880,13025,'fi','Palvelun tilauksen oletus pÃ¤ivÃ¤Ã¤ jotta arvonmukainen',0),(468881,13025,'no','Tjenesten for standard dager til grunn',0),(468882,13025,'da','Service Bestil standard dage til behÃ¸rig dato',0),(468883,13025,'ko','ë•Œë¬¸ì— ì„œë¹„ìŠ¤ ìˆœì„œ ê¸°ë³¸ ì¼ ë‚ ì§œ',0),(468884,13025,'he','×©×™×¨×•×ª ×¡×“×¨ ×‘×¨×™×¨×ª ×ž×—×“×œ ×™×ž×™× ×‘×©×œ ×ª××¨×™×š',0),(468885,13025,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î·Î¼Î­ÏÎµÏ‚ ÏƒÎµ Î¿Ï†ÎµÎ¹Î»ÏŒÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(468886,13025,'zh','æœåŠ¡è®¢å•é»˜è®¤å¤©è‡³åˆ°æœŸæ—¥æœŸ',0),(468887,13025,'sv','Service bestÃ¤llning standard dagar till rakt',0),(468888,13025,'it','Servizio ordine predefinito giorni alla scadenza Data',0),(468889,13025,'tl','',0),(468890,13025,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸šà¸£à¸´à¸à¸²à¸£à¸ˆà¸°à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™',0),(468891,13025,'hi','à¤¸à¥‡à¤µà¤¾ à¤†à¤¦à¥‡à¤¶ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¾à¤°à¥€à¤–',0),(468892,13025,'ms','Perkhidmatan perintah lalai hari untuk habis tempoh tarikh',0),(468893,13025,'ar','Ø®Ø¯Ù…Ø© Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ ÙŠÙˆÙ…Ø§ Ù„Ù„ÙˆØ§Ø¬Ø¨ Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(468894,13025,'fr','Date de commande de service par dÃ©faut jours Ã  Due',0),(468895,13025,'jp','ã‚µãƒ¼ãƒ“ã‚¹é †åºæ—¢å®šã™ã‚‹ãŸã‚ã«æ—¥',0),(468896,13025,'pt','Dias de padrÃ£o de ordem de serviÃ§o para devido data',0),(468897,13025,'ru','Ð¡Ð»ÑƒÐ¶Ð±Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð½ÐµÐ¹ Ð´Ð»Ñ Ð½Ð°Ð´Ð»ÐµÐ¶Ð°Ñ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹',0),(468898,13025,'es','Orden de Servicio DÃ­as por Defecto Hasta DÃ­a de Vencimiento',0),(468899,13025,'de','Service Bestellung Standard Tage Due Date',0),(468900,13025,'en','Service Order Default Days To Due Date',0),(468901,13026,'is','',0),(468902,13026,'dr','/ Ø§ØµÙ„Ø§Ø­ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø®ØªÙ„Ù',0),(468903,13026,'pr','Ù†Ù…Ø§ÛŒØ´/ ÙˆÛŒØ±Ø§ÛŒØ´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø®ØªÙ„Ù',0),(468904,13026,'tr','BaÅŸka bir satÄ±cÄ±nÄ±n GÃ¶rÃ¼ntÃ¼le/DÃ¼zenle',0),(468905,13026,'pl','WyÅ›wietl/Edytuj rÃ³Å¼nych dostawcÃ³w',0),(468906,13026,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ñ€ÑƒÐ³ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(468907,13026,'ur','Ù…Ø®ØªÙ„Ù ÙˆÛŒÙ†ÚˆØ± Ù…Ù†Ø¸Ø±/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(468908,13026,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ /Ð£Ñ€ÐµÐ´Ð¸ Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(468909,13026,'vi','Xem/chá»‰nh sá»­a khÃ¡ch hÃ ng khÃ¡c.',0),(468910,13026,'af','Bekyk/redigeer ander handelaar',0),(468911,13026,'ro','Vizualizare/Editare alt furnizor',0),(468912,13026,'et','Vaata/Muuda erineva hankija',0),(468913,13026,'si','Ogled/urejanje drugega dobavitelja',0),(468914,13026,'ba','Lihat/Edit Vendor yang berbeda',0),(468915,13026,'nl','Andere leverancier bekijken/bewerken',0),(468916,13026,'fi','NÃ¤ytÃ¤/Muokkaa toimittajatapahtumat',0),(468917,13026,'no','Vise/redigere annen leverandÃ¸r',0),(468918,13026,'da','Se/Rediger anden leverandÃ¸r',0),(468919,13026,'ko','ë³´ê¸°/íŽ¸ì§‘ ë‹¤ë¥¸ ê³µê¸‰ ì—…ì²´',0),(468920,13026,'he','×”×¦×’/×¢×¨×•×š ×¡×¤×§×™× ×©×•× ×™×',0),(468921,13026,'el','Î ÏÎ¿Î²Î¿Î»Î®/Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÎ­Ï‚',0),(468922,13026,'zh','æŸ¥çœ‹/ç¼–è¾‘ä¸åŒçš„ä¾›åº”å•†',0),(468923,13026,'sv','Visa/redigera annan leverantÃ¶r',0),(468924,13026,'it','Visualizza/modifica fornitore diverso',0),(468925,13026,'tl','',0),(468926,13026,'th','à¹à¸à¹‰à¹„à¸‚à¸¡à¸¸à¸¡à¸¡à¸­à¸‡à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸—à¸µà¹ˆà¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸à¸±à¸™',0),(468927,13026,'hi','à¤¦à¥‡à¤–à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤­à¤¿à¤¨à¥à¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(468928,13026,'ms','Penjual berbeza pandangan/Edit',0),(468929,13026,'ar','Ø¹Ø±Ø¶/ØªØ­Ø±ÙŠØ± Ù…ÙˆØ±Ø¯ Ù…Ø®ØªÙ„ÙØ©',0),(468930,13026,'fr','Afficher/modifier fournisseur diffÃ©rent',0),(468931,13026,'jp','ç•°ãªã‚‹ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¡¨ç¤º/ç·¨é›†',0),(468932,13026,'pt','Exibir/editar diferentes fornecedores',0),(468933,13026,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ñ‹Ñ… Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(468934,13026,'es','Visionar/Editar Proveeedor Diferente',0),(468935,13026,'de','Bearbeiten Sie anzeigen/verschiedenen Anbieter',0),(468936,13026,'en','View/Edit Different Vendor',0),(468937,13027,'is','',0),(468938,13027,'dr','...',0),(468939,13027,'pr','Ø§ÛŒØ¬Ø§Ø¯ ÙØ§Ú©ØªÙˆØ±...',0),(468940,13027,'tr','POS Fatura oluÅŸtur',0),(468941,13027,'pl','Tworzenie faktury POS',0),(468942,13027,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° POS',0),(468943,13027,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(468944,13027,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð·Ð° ÐŸÐžÐ¡',0),(468945,13027,'vi','táº¡o hÃ³a Ä‘Æ¡n POS',0),(468946,13027,'af','POS faktuur te skep',0),(468947,13027,'ro','Creare facturÄƒ POS',0),(468948,13027,'et','POS arve koostamine',0),(468949,13027,'si','Ustvarite raÄun POS',0),(468950,13027,'ba','Membuat faktur POS',0),(468951,13027,'nl','POS factuur maken',0),(468952,13027,'fi','POS laskun luominen',0),(468953,13027,'no','Opprette POS faktura',0),(468954,13027,'da','Oprette POS faktura',0),(468955,13027,'ko','POS ì†¡ìž¥ ë§Œë“¤ê¸°',0),(468956,13027,'he','×¦×•×¨ ×—×©×‘×•× ×™×ª POS',0),(468957,13027,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… POS',0),(468958,13027,'zh','åˆ›å»º POS å‘ç¥¨',0),(468959,13027,'sv','Skapa POS faktura',0),(468960,13027,'it','Creare fattura POS',0),(468961,13027,'tl','',0),(468962,13027,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ POS',0),(468963,13027,'hi','POS à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¬à¤¨à¤¾à¤à¤',0),(468964,13027,'ms','Mencipta invois POS',0),(468965,13027,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¨ÙŠØ¹',0),(468966,13027,'fr','CrÃ©er facture POS',0),(468967,13027,'jp','POS ã®è«‹æ±‚æ›¸ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(468968,13027,'pt','Criar fatura POS',0),(468969,13027,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ ÑÑ‡ÐµÑ‚ POS',0),(468970,13027,'es','Crear Factura de PDV',0),(468971,13027,'de','Erstellen Sie POS-Rechnung',0),(468972,13027,'en','Create POS Invoice',0),(468973,13028,'is','',0),(468974,13028,'dr','Ø®Ø·Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙØ§Ú©ØªÙˆØ±ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(468975,13028,'pr','Ø®Ø·Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙØ§Ú©ØªÙˆØ±ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(468976,13028,'tr','Hata iÅŸleme EDI faturalar',0),(468977,13028,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas przetwarzania faktury EDI',0),(468978,13028,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð²Ð°Ð½Ðµ EDI Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(468979,13028,'ur','Ù†Ù‚Øµ Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ø§ÛŒØ¯Ø§ ÙˆØ¨Ø¬Ù„ÛŒ',0),(468980,13028,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð¾Ð±Ñ€Ð°Ð´Ð¸ Ð•Ð”Ð˜ÐˆÐ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(468981,13028,'vi','Lá»—i trong quÃ¡ trÃ¬nh EDI hÃ³a Ä‘Æ¡n',0),(468982,13028,'af','Fout verwerking EDI fakture',0),(468983,13028,'ro','Eroare la prelucrarea EDI facturi',0),(468984,13028,'et','TÃ¶Ã¶tlemise tÃµrge EDI arveid',0),(468985,13028,'si','Napaka pri obdelavi EDI raÄunov',0),(468986,13028,'ba','Kesalahan pengolahan EDI faktur',0),(468987,13028,'nl','Foutverwerking EDI-facturen',0),(468988,13028,'fi','Virhe kÃ¤siteltÃ¤essÃ¤ EDI laskut',0),(468989,13028,'no','Feilbehandling EDI fakturaer',0),(468990,13028,'da','Fejl under behandling EDI fakturaer',0),(468991,13028,'ko','ì˜¤ë¥˜ ì²˜ë¦¬ EDI ì²­êµ¬ì„œ',0),(468992,13028,'he','×©×’×™××” ×‘×¢×™×‘×•×“ EDI ×—×©×‘×•× ×™×•×ª',0),(468993,13028,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± EDI Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(468994,13028,'zh','é”™è¯¯å¤„ç† EDI å‘ç¥¨',0),(468995,13028,'sv','Fel vid hantering EDI-fakturor',0),(468996,13028,'it','Errore elaborazione fatture EDI',0),(468997,13028,'tl','',0),(468998,13028,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ EDI à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(468999,13028,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤‚à¤¸à¤¾à¤§à¤¨ EDI à¤šà¤¾à¤²à¤¾à¤¨',0),(469000,13028,'ms','Ralat pemprosesan EDI invois',0),(469001,13028,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ù…Ø¹Ø§Ù„Ø¬Ø© ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(469002,13028,'fr','Erreur lors du traitement EDI factures',0),(469003,13028,'jp','EDI ã®è«‹æ±‚æ›¸ã®ã‚¨ãƒ©ãƒ¼å‡¦ç†',0),(469004,13028,'pt','Erro ao processar faturas EDI',0),(469005,13028,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ EDI ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(469006,13028,'es','Error Procesando EDI Facturas',0),(469007,13028,'de','Fehler beim Verarbeiten EDI-Rechnungen',0),(469008,13028,'en','Error Processing EDI Invoices',0),(469009,13029,'is','',0),(469010,13029,'dr','ÙˆÛŒØ±Ø§Ø³Øª ØµØ§Ø¯Ø± Ø³ÙØ§Ø±Ø´Ø§Øª',0),(469011,13029,'pr','ÙˆÛŒØ±Ø§Ø³Øª ØµØ§Ø¯Ø± Ø³ÙØ§Ø±Ø´Ø§Øª',0),(469012,13029,'tr','DÄ±ÅŸa aktarÄ±lan EDI sipariÅŸler',0),(469013,13029,'pl','ZamÃ³wienia wywoÅ¼onych EDI',0),(469014,13029,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ EDI Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(469015,13029,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û Ø§ÛŒØ¯Ø§ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(469016,13029,'sr','Ð˜Ð·Ð²ÐµÐ·ÐµÐ½Ð¸ Ð•Ð”Ð˜ÐˆÐ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(469017,13029,'vi','ÄÆ¡n Ä‘áº·t hÃ ng xuáº¥t kháº©u EDI',0),(469018,13029,'af','Uitgevoerde EDI bestellings',0),(469019,13029,'ro','EDI exportate comenzi',0),(469020,13029,'et','Eksporditud EDI tellimused',0),(469021,13029,'si','IzvoÅ¾eni EDI naroÄila',0),(469022,13029,'ba','EDI diekspor pesanan',0),(469023,13029,'nl','GeÃ«xporteerde EDI Orders',0),(469024,13029,'fi','Viety EDI-tilaukset',0),(469025,13029,'no','Eksporterte EDI ordrer',0),(469026,13029,'da','Eksporterede EDI ordrer',0),(469027,13029,'ko','ë‚´ë³´ë‚¸ëœ EDI ì£¼ë¬¸',0),(469028,13029,'he','EDI ×”×ž×™×•×¦× ×”×–×ž× ×•×ª',0),(469029,13029,'el','ÎŸÎ¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÎµÎ¾Î¬Î³Î¿Î½Ï„Î±Î¹ EDI',0),(469030,13029,'zh','å¯¼å‡ºçš„ EDI è®¢å•',0),(469031,13029,'sv','Exporterade EDI order',0),(469032,13029,'it','Ordini EDI esportato',0),(469033,13029,'tl','',0),(469034,13029,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ªà¹ˆà¸‡à¸­à¸­à¸ EDI',0),(469035,13029,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¥€ à¤—à¤ˆ EDI à¤†à¤¦à¥‡à¤¶',0),(469036,13029,'ms','Pesanan eksport import',0),(469037,13029,'ar','Ø£ÙˆØ§Ù…Ø± ØªØµØ¯ÙŠØ± Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(469038,13029,'fr','Commandes EDI exportÃ©',0),(469039,13029,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã•ã‚ŒãŸ EDI æ³¨æ–‡',0),(469040,13029,'pt','Ordens EDI exportado',0),(469041,13029,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹ Ð­Ð”Ð˜ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(469042,13029,'es','Ã“rdenes de exportaciÃ³n EDI',0),(469043,13029,'de','Exportierte EDI-Bestellungen',0),(469044,13029,'en','Exported EDI Orders',0),(469045,13030,'is','',0),(469046,13030,'dr','Ø§Ø±Ø³Ø§Ù„ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(469047,13030,'pr','Ø§Ø±Ø³Ø§Ù„ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(469048,13030,'tr','EDI faturalarÄ± verme',0),(469049,13030,'pl','EDI faktury wywozowe',0),(469050,13030,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° EDI Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(469051,13030,'ur','Ø§ÛŒØ¯Ø§ ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(469052,13030,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð•Ð”Ð˜ÐˆÐ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(469053,13030,'vi','Káº¿t xuáº¥t hÃ³a Ä‘Æ¡n EDI',0),(469054,13030,'af','Uitvoer EDI fakture',0),(469055,13030,'ro','EDI facturi de export',0),(469056,13030,'et','Ekspordi EDI arveid',0),(469057,13030,'si','Izvoz EDI raÄunov',0),(469058,13030,'ba','Tagihan ekspor EDI',0),(469059,13030,'nl','EDI-facturen exporteren',0),(469060,13030,'fi','EDI laskuja',0),(469061,13030,'no','Eksportere EDI fakturaer',0),(469062,13030,'da','Eksportere EDI fakturaer',0),(469063,13030,'ko','EDI ì†¡ìž¥ ë‚´ë³´ë‚´ê¸°',0),(469064,13030,'he','×™×™×¦×•× ×—×©×‘×•× ×™×•×ª EDI',0),(469065,13030,'el','EDI Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎµÎ¾Î±Î³Ï‰Î³ÏŽÎ½ Ï€Î¿Ï… ÎµÎ¯Ï‡Î±Î½',0),(469066,13030,'zh','å‡ºå£ EDI å‘ç¥¨',0),(469067,13030,'sv','Exportera EDI-fakturor',0),(469068,13030,'it','Esportazione fatture EDI',0),(469069,13030,'tl','',0),(469070,13030,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸‚à¸­à¸‡ EDI',0),(469071,13030,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ EDI à¤šà¤¾à¤²à¤¾à¤¨',0),(469072,13030,'ms','Eksport import invois',0),(469073,13030,'ar','ØªØµØ¯ÙŠØ± ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(469074,13030,'fr','Export factures EDI',0),(469075,13030,'jp','EDI ã®è«‹æ±‚æ›¸ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(469076,13030,'pt','EDI facturas de exportaÃ§Ã£o',0),(469077,13030,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð­Ð”Ð˜ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(469078,13030,'es','Exportar EDI Facturas',0),(469079,13030,'de','Export-EDI-Rechnungen',0),(469080,13030,'en','Export EDI Invoices',0),(469081,13031,'is','',0),(469082,13031,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(469083,13031,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(469084,13031,'tr','DÄ±ÅŸa aktarÄ±lmÄ±ÅŸ faturalar',0),(469085,13031,'pl','Faktury wywoÅ¼onych',0),(469086,13031,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(469087,13031,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ø±Ø¢Ù…Ø¯',0),(469088,13031,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¸Ð·Ð²ÐµÐ·ÐµÐ½Ð¸',0),(469089,13031,'vi','hÃ³a Ä‘Æ¡n Ä‘Ã£ Ä‘Æ°á»£c xuáº¥t',0),(469090,13031,'af','Fakture uitgevoer',0),(469091,13031,'ro','Facturi exportate',0),(469092,13031,'et','Arved eksporditud',0),(469093,13031,'si','RaÄuni izvaÅ¾ajo',0),(469094,13031,'ba','Tagihan ekspor',0),(469095,13031,'nl','Facturen exporteren',0),(469096,13031,'fi','Laskut viedÃ¤Ã¤n',0),(469097,13031,'no','Fakturaer eksporteres',0),(469098,13031,'da','Fakturaer eksporteret',0),(469099,13031,'ko','ìˆ˜ì¶œ ì¸ë³´ì´ìŠ¤',0),(469100,13031,'he','×—×©×‘×•× ×™×•×ª ×ž×™×•×¦××™×',0),(469101,13031,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… ÎµÎ¾Î¬Î³Î¿Î½Ï„Î±Î¹',0),(469102,13031,'zh','å‘ç¥¨å¯¼å‡º',0),(469103,13031,'sv','Fakturor som exporteras',0),(469104,13031,'it','Fatture esportate',0),(469105,13031,'tl','',0),(469106,13031,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(469107,13031,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤¿à¤¯à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(469108,13031,'ms','Invois-invois yang dieksport',0),(469109,13031,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ØµØ¯Ø±Ø©',0),(469110,13031,'fr','Factures exportÃ©es',0),(469111,13031,'jp','è«‹æ±‚æ›¸ã®ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ',0),(469112,13031,'pt','Facturas exportadas',0),(469113,13031,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð½Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(469114,13031,'es','Facturas Exportadas',0),(469115,13031,'de','Rechnungen exportiert',0),(469116,13031,'en','Invoices Exported',0),(469117,13032,'is','',0),(469118,13032,'dr','Ù‡ÛŒÚ† ÙØ§ÛŒÙ„ÛŒ Ø§Ú©Ù†ÙˆÙ† Ø§ÛŒØ¬Ø§Ø¯ Ù†Ø´ÙˆØ¯',0),(469119,13032,'pr','Ù‡ÛŒÚ† ÙØ§ÛŒÙ„ÛŒ Ø§Ú©Ù†ÙˆÙ† Ø§ÛŒØ¬Ø§Ø¯ Ù†Ø´ÙˆØ¯',0),(469120,13032,'tr','Åžu anda oluÅŸturulan dosya',0),(469121,13032,'pl','Nie ma plikÃ³w tworzonych w tym czasie',0),(469122,13032,'bg','ÐÑÐ¼Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð¸ Ð¿Ð¾ Ñ‚Ð¾Ð²Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(469123,13032,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø³Ù„ Ø§Ø³ ÙˆÙ‚Øª Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(469124,13032,'sr','ÐÐµÐ¼Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ðµ Ñƒ Ð¾Ð²Ð¾Ð¼ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚ÐºÑƒ',0),(469125,13032,'vi','khÃ´ng cÃ³ file Ä‘Æ°á»£c táº¡o lÃºc nÃ y',0),(469126,13032,'af','Geen lÃªers is geskep by hierdie tyd',0),(469127,13032,'ro','Nu fiÅŸierele create Ã®n acest moment',0),(469128,13032,'et','Sel ajal loodud faile',0),(469129,13032,'si','Ne datoteke, ustvarjene v tem trenutku',0),(469130,13032,'ba','Tidak ada file yang dibuat saat ini',0),(469131,13032,'nl','Geen bestanden die zijn gemaakt op dit moment',0),(469132,13032,'fi','Tiedostoja ei luoda tÃ¤llÃ¤ hetkellÃ¤',0),(469133,13032,'no','Ingen filer som er opprettet pÃ¥ denne tiden',0),(469134,13032,'da','Ingen filer er oprettet pÃ¥ dette tidspunkt',0),(469135,13032,'ko','ì´ ì´ë²ˆì— ë§Œë“  íŒŒì¼ì´ ì—†ìŠµë‹ˆë‹¤',0),(469136,13032,'he','××™×Ÿ ×§×‘×¦×™× ×©× ×•×¦×¨×• ×‘×–×ž×Ÿ ×”×–×”',0),(469137,13032,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î±ÏÏ‡ÎµÎ¯Î± Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿ÏÏÎ³Î·ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· ÏƒÏ„Î¹Î³Î¼Î®',0),(469138,13032,'zh','ä¸åœ¨æ­¤æ—¶åˆ›å»ºçš„æ–‡ä»¶',0),(469139,13032,'sv','Inga filer som skapats vid denna tid',0),(469140,13032,'it','Nessun file creato in questo momento',0),(469141,13032,'tl','',0),(469142,13032,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹à¸Ÿà¹‰à¸¡à¸—à¸µà¹ˆà¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸™à¸‚à¸“à¸°à¸™à¸µà¹‰',0),(469143,13032,'hi','à¤•à¥‹à¤ˆ à¤‡à¤¸ à¤¸à¤®à¤¯ à¤®à¥‡à¤‚ à¤¬à¤¨à¤¾à¤ˆ à¤—à¤ˆ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(469144,13032,'ms','Tiada fail yang dicipta pada masa ini',0),(469145,13032,'ar','Ù„Ø§ Ø§Ù„Ù…Ù„ÙØ§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„ÙˆÙ‚Øª',0),(469146,13032,'fr','Aucun fichier crÃ©Ã© en ce moment',0),(469147,13032,'jp','ã“ã®æ™‚ç‚¹ã§ä½œæˆã•ã‚ŒãŸãƒ•ã‚¡ã‚¤ãƒ«ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(469148,13032,'pt','Nenhum arquivo criado neste momento',0),(469149,13032,'ru','Ð‘ÐµÐ· Ñ„Ð°Ð¹Ð»Ð¾Ð², ÑÐ¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð² ÑÑ‚Ð¾ Ð²Ñ€ÐµÐ¼Ñ',0),(469150,13032,'es','No Crearon File En Este Momento',0),(469151,13032,'de','Keine Dateien, die zu dieser Zeit erstellt',0),(469152,13032,'en','No Files Created At This Time',0),(469153,13033,'is','',0),(469154,13033,'dr','ØºÛŒØ± ÙØ¹Ø§Ù„ Ø´Ø¯Ù‡',0),(469155,13033,'pr','ØºÛŒØ± ÙØ¹Ø§Ù„ Ø´Ø¯Ù‡',0),(469156,13033,'tr','Engelli',0),(469157,13033,'pl','OsÃ³b niepeÅ‚nosprawnych',0),(469158,13033,'bg','Ð¥Ð¾Ñ€Ð° Ñ',0),(469159,13033,'ur','Ù…Ø¹Ø°ÙˆØ±',0),(469160,13033,'sr','ÐžÐ½ÐµÐ¼Ð¾Ð³ÑƒÑ›ÐµÐ½Ð¾',0),(469161,13033,'vi','Bá»‹ loáº¡i',0),(469162,13033,'af','Gestremde',0),(469163,13033,'ro','Cu handicap',0),(469164,13033,'et','Erivajadustega',0),(469165,13033,'si','Invalidne',0),(469166,13033,'ba','Penyandang Cacat',0),(469167,13033,'nl','Handicap',0),(469168,13033,'fi','Vammaisten',0),(469169,13033,'no','Deaktivert',0),(469170,13033,'da','Handicappede',0),(469171,13033,'ko','ì‚¬ìš© ì•ˆ í•¨',0),(469172,13033,'he','×‘×¢×œ×™ ×ž×•×’×‘×œ×•×™×•×ª',0),(469173,13033,'el','Î†Ï„Î¿Î¼Î± Î¼Îµ ÎµÎ¹Î´Î¹ÎºÎ­Ï‚ Î±Î½Î¬Î³ÎºÎµÏ‚',0),(469174,13033,'zh','å·²ç¦ç”¨',0),(469175,13033,'sv','Funktionshindrade',0),(469176,13033,'it','Disabili',0),(469177,13033,'tl','',0),(469178,13033,'th','à¸›à¸´à¸”à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(469179,13033,'hi','à¤µà¤¿à¤•à¤²à¤¾à¤‚à¤—',0),(469180,13033,'ms','Kurang Upaya',0),(469181,13033,'ar','Ø°ÙˆÙŠ',0),(469182,13033,'fr','HandicapÃ©s',0),(469183,13033,'jp','ç„¡åŠ¹ã«ãªã£ã¦ã„ã¾ã™ã€‚',0),(469184,13033,'pt','Com deficiÃªncia',0),(469185,13033,'ru','Ð˜Ð½Ð²Ð°Ð»Ð¸Ð´Ð¾Ð²',0),(469186,13033,'es','Deshabilitado',0),(469187,13033,'de','Behinderte',0),(469188,13033,'en','Disabled',0),(469189,13034,'is','',0),(469190,13034,'dr','Ù‚Ø§Ø¨Ù„ÛŒØª Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡ ØºÛŒØ± ÙØ¹Ø§Ù„ Ø§Ø³Øª ',0),(469191,13034,'pr','Ù‚Ø§Ø¨Ù„ÛŒØª Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡ ØºÛŒØ± ÙØ¹Ø§Ù„ Ø§Ø³Øª ',0),(469192,13034,'tr','Eklentiyi devre dÄ±ÅŸÄ± bÄ±rakÄ±n',0),(469193,13034,'pl','WyÅ‚Ä…czyÄ‡ dodatek',0),(469194,13034,'bg','Ð—Ð°Ð±Ñ€Ð°Ð½Ð¸ Ð´Ð¾Ð±Ð°Ð²ÐºÐ°Ñ‚Ð°',0),(469195,13034,'ur','Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ù†Ø§Ø§ÛÙ„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(469196,13034,'sr','ÐžÐ½ÐµÐ¼Ð¾Ð³ÑƒÑ›Ð¸Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð°Ðº',0),(469197,13034,'vi','bá»‹ loáº¡i thÃªm',0),(469198,13034,'af','Versper byvoegsel',0),(469199,13034,'ro','DezactivaÅ£i supliment',0),(469200,13034,'et','Keela lisandmoodul',0),(469201,13034,'si','Onesposobiti poveÄati-naprej',0),(469202,13034,'ba','Menonaktifkan Add-On',0),(469203,13034,'nl','Invoegtoepassing uitschakelen',0),(469204,13034,'fi','Poista lisÃ¤osa kÃ¤ytÃ¶stÃ¤',0),(469205,13034,'no','Deaktivere tillegg',0),(469206,13034,'da','Deaktiver tilfÃ¸jelse',0),(469207,13034,'ko','ë¶€ê°€ ê¸°ëŠ¥ì„ ì‚¬ìš© í•˜ì§€ ì•Šë„ë¡ ì„¤ì •',0),(469208,13034,'he','×‘×˜×œ ××ª ×”×¨×—×‘×”',0),(469209,13034,'el','Î‘Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î¿ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î¿',0),(469210,13034,'zh','ç¦ç”¨åŠ è½½é¡¹',0),(469211,13034,'sv','Inaktivera tillÃ¤gg',0),(469212,13034,'it','Disabilitare il componente aggiuntivo',0),(469213,13034,'tl','',0),(469214,13034,'th','à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™ Add-On',0),(469215,13034,'hi','à¤à¤¡-à¤‘à¤¨ à¤•à¥‹ à¤…à¤•à¥à¤·à¤® à¤•à¤°à¥‡à¤‚',0),(469216,13034,'ms','Tidak membenarkan tambahan',0),(469217,13034,'ar','Ù‚Ù… Ø¨ØªØ¹Ø·ÙŠÙ„ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(469218,13034,'fr','DÃ©sactiver le module',0),(469219,13034,'jp','ã‚¢ãƒ‰ã‚ªãƒ³ã‚’ç„¡åŠ¹ã«ã—ã¾ã™ã€‚',0),(469220,13034,'pt','Desabilitar o complemento',0),(469221,13034,'ru','ÐžÑ‚ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð½Ð°Ð´ÑÑ‚Ñ€Ð¾Ð¹ÐºÑƒ',0),(469222,13034,'es','Deshabilitar Add-On',0),(469223,13034,'de','Deaktivieren von Add-ons anzeigen',0),(469224,13034,'en','Disable Add-On',0),(469225,13035,'is','',0),(469226,13035,'dr','ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒ Ù…Ø¬Ø¯Ø¯ Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(469227,13035,'pr','ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒ Ù…Ø¬Ø¯Ø¯ Ù‚Ø§Ø¨Ù„ÛŒØª Ø§Ø¶Ø§ÙÙ‡ Ø³Ø§Ø²ÛŒ Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(469228,13035,'tr','Eklentiyi yeniden etkinleÅŸtirmek',0),(469229,13035,'pl','Ponowne uaktywnianie dodatek',0),(469230,13035,'bg','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÐºÐ°Ñ‚Ð°',0),(469231,13035,'ur','Ø¨Ø±-Ø§ Ø¶Ø§ÙÛ Ø¯ÙˆØ¨Ø§Ø±Û Ú†Ø§Ù„Ùˆ Ú©Ø±ÛŒÚº',0),(469232,13035,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð°Ðº',0),(469233,13035,'vi','KÃ­ch hoáº¡t loáº¡i',0),(469234,13035,'af','Heraktiveer byvoegsel',0),(469235,13035,'ro','ReactivaÅ£i supliment',0),(469236,13035,'et','Lisandmooduli uuesti aktiveerida',0),(469237,13035,'si','Znova aktivirajte dodatek',0),(469238,13035,'ba','Mengaktifkan kembali Pengaya',0),(469239,13035,'nl','Add-On opnieuw activeren',0),(469240,13035,'fi','Aktivoi Add',0),(469241,13035,'no','Aktivere tillegg',0),(469242,13035,'da','Genaktivere tilfÃ¸jelse',0),(469243,13035,'ko','ì¶”ê°€ ê¸°ëŠ¥ì„ ë‹¤ì‹œ í™œì„±í™”',0),(469244,13035,'he','×”×¤×¢×œ ×ž×—×“×© ×”×¨×—×‘×”',0),(469245,13035,'el','Î•Ï€Î±Î½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î¿Ï…',0),(469246,13035,'zh','é‡æ–°æ¿€æ´»çš„åŠ è½½é¡¹',0),(469247,13035,'sv','Aktivera tillÃ¤gg',0),(469248,13035,'it','Riattivare il componente aggiuntivo',0),(469249,13035,'tl','',0),(469250,13035,'th','à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™ Add-On',0),(469251,13035,'hi','à¤à¤¡-à¤‘à¤¨ à¤•à¥‹ à¤«à¤¿à¤° à¤¸à¥‡ à¤¸à¤•à¥à¤°à¤¿à¤¯',0),(469252,13035,'ms','Mengaktifkan semula tambahan',0),(469253,13035,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªÙ†Ø´ÙŠØ· Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(469254,13035,'fr','RÃ©activer le module',0),(469255,13035,'jp','ã‚¢ãƒ‰ã‚ªãƒ³ã‚’å†ã‚¢ã‚¯ãƒ†ã‚£ãƒ–åŒ–ã—ã¾ã™ã€‚',0),(469256,13035,'pt','Reativar o complemento',0),(469257,13035,'ru','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ',0),(469258,13035,'es','Reactivar Add-On',0),(469259,13035,'de','Reaktivieren Sie Add-ons anzeigen',0),(469260,13035,'en','Reactivate Add-On',0),(469261,13036,'is','',0),(469262,13036,'dr','(Ø¨ÛŒÙ„Ø§Ù†Ø³ Ø´ÛŒØª',0),(469263,13036,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø­Ø³Ø§Ø¨ Ù…ÙˆØ§Ø²Ù†Ù‡(ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡',0),(469264,13036,'tr','GÃ¶rÃ¼nÃ¼m hesap bakiyeleri',0),(469265,13036,'pl','Widok sald',0),(469266,13036,'bg','Ð¡Ð°Ð»Ð´Ð°Ñ‚Ð° Ð¿Ð¾ ÑÐ¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ Ð·Ð° Ð¸Ð·Ð³Ð»ÐµÐ´',0),(469267,13036,'ur','Ù…Ù†Ø¸Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨ÛŒÙ„Ù†Ø³',0),(469268,13036,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÑÐ°Ð»Ð´Ð°',0),(469269,13036,'vi','Xem báº£ng cÃ¢n Ä‘á»‘i tÃ i khoáº£n',0),(469270,13036,'af','Bekyk rekening saldo\'s',0),(469271,13036,'ro','Soldurile conturilor de vedere',0),(469272,13036,'et','Kuva konto saldode',0),(469273,13036,'si','Pogled saldih kontov',0),(469274,13036,'ba','Melihat saldo rekening',0),(469275,13036,'nl','Weergave rekeningsaldi',0),(469276,13036,'fi','NÃ¤ytÃ¤ tilien saldot',0),(469277,13036,'no','Vis kontosaldoer',0),(469278,13036,'da','Se kontosaldi',0),(469279,13036,'ko','ë³´ê¸° ê³„ì • ìž”ì•¡',0),(469280,13036,'he','×™×ª×¨×•×ª ×©×œ ×—×©×‘×•× ×•×ª ×ª×¦×•×’×”',0),(469281,13036,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(469282,13036,'zh','æŸ¥çœ‹å¸æˆ·ä½™é¢',0),(469283,13036,'sv','Visa kontosaldon',0),(469284,13036,'it','Visualizzazione saldi',0),(469285,13036,'tl','',0),(469286,13036,'th','à¸”à¸¹à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸šà¸±à¸à¸Šà¸µ',0),(469287,13036,'hi','à¤¦à¥ƒà¤¶à¥ à¤¯ à¤–à¤¾à¤¤à¥‡ à¤®à¥‡à¤‚ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿',0),(469288,13036,'ms','Baki akaun View',0),(469289,13036,'ar','Ø¹Ø±Ø¶ Ø£Ø±ØµØ¯Ø© Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(469290,13036,'fr','Affichage soldes',0),(469291,13036,'jp','è¡¨ç¤ºã‚¢ã‚«ã‚¦ãƒ³ãƒˆæ®‹é«˜',0),(469292,13036,'pt','Ver os saldos de conta',0),(469293,13036,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¾ÑÑ‚Ð°Ñ‚ÐºÐ¾Ð² Ð½Ð° ÑÑ‡ÐµÑ‚Ð°Ñ…',0),(469294,13036,'es','Vistar Balances de Cuentas',0),(469295,13036,'de','Kontosalden anzeigen',0),(469296,13036,'en','View Account Balances',0),(469297,13037,'is','',0),(469298,13037,'dr','Ø®Ø·Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(469299,13037,'pr','Ø®Ø·Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(469300,13037,'tr','Hata iÅŸleme EDI sipariÅŸler',0),(469301,13037,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas przetwarzania zamÃ³wieÅ„ EDI',0),(469302,13037,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð²Ð°Ð½Ðµ EDI Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(469303,13037,'ur','Ù†Ù‚Øµ Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ø§ÛŒØ¯Ø§ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(469304,13037,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ Ð¾Ð±Ñ€Ð°Ð´Ð¸ Ð•Ð”Ð˜ÐˆÐ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(469305,13037,'vi','Lá»—i trong quÃ¡ trÃ¬nh EDI Ä‘Æ¡n hÃ ng',0),(469306,13037,'af','Fout verwerking EDI bestellings',0),(469307,13037,'ro','Eroare la prelucrarea EDI comenzi',0),(469308,13037,'et','TÃ¶Ã¶tlemise tÃµrge EDI tellimused',0),(469309,13037,'si','Napaka pri obdelavi naroÄil EDI',0),(469310,13037,'ba','Kesalahan pengolahan EDI pesanan',0),(469311,13037,'nl','Foutverwerking EDI Orders',0),(469312,13037,'fi','Virhe kÃ¤siteltÃ¤essÃ¤ EDI tilaukset',0),(469313,13037,'no','Feilbehandling EDI ordrer',0),(469314,13037,'da','Fejl under behandling EDI ordrer',0),(469315,13037,'ko','ì˜¤ë¥˜ ì²˜ë¦¬ EDI ì£¼ë¬¸',0),(469316,13037,'he','×©×’×™××” ×‘×¢×™×‘×•×“ ×”×–×ž× ×•×ª EDI',0),(469317,13037,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± EDI Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(469318,13037,'zh','é”™è¯¯å¤„ç† EDI è®¢å•',0),(469319,13037,'sv','Fel vid hantering EDI order',0),(469320,13037,'it','Errore elaborazione ordini EDI',0),(469321,13037,'tl','',0),(469322,13037,'th','à¸ªà¸±à¹ˆà¸‡ EDI à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(469323,13037,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤‚à¤¸à¤¾à¤§à¤¨ EDI à¤†à¤¦à¥‡à¤¶',0),(469324,13037,'ms','Ralat memproses perintah EDI',0),(469325,13037,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø·Ù„Ø¨Ø§Øª Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(469326,13037,'fr','Traitement de l\'erreur des commandes EDI',0),(469327,13037,'jp','EDI æ³¨æ–‡ã®ã‚¨ãƒ©ãƒ¼å‡¦ç†',0),(469328,13037,'pt','Processamento de erro EDI de pedidos',0),(469329,13037,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð­ÐžÐ”',0),(469330,13037,'es','Error Procesando EDI Pedidos',0),(469331,13037,'de','Fehler beim Verarbeiten EDI-Bestellungen',0),(469332,13037,'en','Error Processing EDI Orders',0),(469333,13038,'is','',0),(469334,13038,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(469335,13038,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(469336,13038,'tr','EDI emir alma',0),(469337,13038,'pl','ZamÃ³wieÅ„ przywozowych EDI',0),(469338,13038,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° EDI Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(469339,13038,'ur','Ø§ÛŒØ¯Ø§ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(469340,13038,'sr','Ð£Ð²Ð¾Ð· Ð•Ð”Ð˜ÐˆÐ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(469341,13038,'vi','Nháº­p Ä‘Æ¡n Ä‘áº·t hÃ ng EDI',0),(469342,13038,'af','EDI bestellings voer',0),(469343,13038,'ro','Importa ordinele de EDI',0),(469344,13038,'et','Impordi EDI tellimused',0),(469345,13038,'si','Uvoz naroÄil EDI',0),(469346,13038,'ba','Impor EDI pesanan',0),(469347,13038,'nl','Import EDI Orders',0),(469348,13038,'fi','Tuo EDI-tilaukset',0),(469349,13038,'no','Importere EDI ordrer',0),(469350,13038,'da','Importere EDI ordrer',0),(469351,13038,'ko','ê°€ì ¸ì˜¤ê¸° EDI ì£¼ë¬¸',0),(469352,13038,'he','×™×™×‘×•× EDI ×”×–×ž× ×•×ª',0),(469353,13038,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ EDI',0),(469354,13038,'zh','å¯¼å…¥ EDI è®¢å•',0),(469355,13038,'sv','EDI bestÃ¤llning',0),(469356,13038,'it','Importazione ordini EDI',0),(469357,13038,'tl','',0),(469358,13038,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ªà¸±à¹ˆà¸‡ EDI',0),(469359,13038,'hi','EDI à¤†à¤¦à¥‡à¤¶ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(469360,13038,'ms','Perintah-perintah EDI import',0),(469361,13038,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£ÙˆØ§Ù…Ø± Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(469362,13038,'fr','Importer les commandes EDI',0),(469363,13038,'jp','EDI æ³¨æ–‡ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(469364,13038,'pt','ImportaÃ§Ã£o de ordens EDI',0),(469365,13038,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð­ÐžÐ”',0),(469366,13038,'es','Importar Pedidos de EDI',0),(469367,13038,'de','Import-EDI-Bestellungen',0),(469368,13038,'en','Import EDI Orders',0),(469369,13039,'is','',0),(469370,13039,'dr','ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÛŒØ¯  ',0),(469371,13039,'pr','ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø³ÙØ§Ø±Ø´Ø§Øª Ø¬Ø¯ÛŒØ¯  ',0),(469372,13039,'tr','Yeni EDI sipariÅŸler',0),(469373,13039,'pl','Nowe zamÃ³wienia EDI',0),(469374,13039,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° EDI',0),(469375,13039,'ur','Ø§ÛŒØ¯Ø§ Ú©Û’ Ù†Ø¦Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(469376,13039,'sr','ÐÐ¾Ð²Ð° Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ° Ð·Ð° Ð•Ð”Ð˜ÐˆÐ',0),(469377,13039,'vi','Ä‘Æ¡n hÃ ng EDI má»›i',0),(469378,13039,'af','Nuwe EDI bestellings',0),(469379,13039,'ro','Noi comenzi de EDI',0),(469380,13039,'et','Uued EDI tellimused',0),(469381,13039,'si','Nova naroÄila EDI',0),(469382,13039,'ba','Perintah EDI baru',0),(469383,13039,'nl','Nieuwe EDI Orders',0),(469384,13039,'fi','EDI-tilausten',0),(469385,13039,'no','EDI ordreinngang',0),(469386,13039,'da','Nye EDI ordrer',0),(469387,13039,'ko','ìƒˆë¡œìš´ EDI ì£¼ë¬¸',0),(469388,13039,'he','×”×–×ž× ×•×ª ×—×“×©×•×ª ××“×™',0),(469389,13039,'el','ÎÎ­ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ EDI',0),(469390,13039,'zh','ç”µå­æ•°æ®äº¤æ¢çš„æ–°è®¢å•',0),(469391,13039,'sv','Nya EDI order',0),(469392,13039,'it','Nuovi ordini EDI',0),(469393,13039,'tl','',0),(469394,13039,'th','à¸ªà¸±à¹ˆà¸‡ EDI à¹ƒà¸«à¸¡à¹ˆ',0),(469395,13039,'hi','à¤¨à¤ EDI à¤†à¤¦à¥‡à¤¶',0),(469396,13039,'ms','Perintah EDI baru',0),(469397,13039,'ar','Ø£ÙˆØ§Ù…Ø± Ø¬Ø¯ÙŠØ¯Ø© Ù…Ù† Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(469398,13039,'fr','Nouvelles commandes EDI',0),(469399,13039,'jp','æ–°ã—ã„ EDI æ³¨æ–‡',0),(469400,13039,'pt','Novas ordens EDI',0),(469401,13039,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ EDI',0),(469402,13039,'es','Nuevos Pedidos EDI',0),(469403,13039,'de','Neue EDI-Bestellungen',0),(469404,13039,'en','New EDI Orders',0),(469405,13040,'is','',0),(469406,13040,'dr','Ù‡ÛŒÚ† ÙØ§ÛŒÙ„ÛŒ Ø¬Ù‡Øª Ø®ÙˆØ§Ù†Ø¯Ù† Ø¯Ø± Ø§ÛŒÙ† Ø²Ù…Ø§Ù†',0),(469407,13040,'pr','Ù‡ÛŒÚ† ÙØ§ÛŒÙ„ÛŒ Ø¬Ù‡Øª Ø®ÙˆØ§Ù†Ø¯Ù† Ø¯Ø± Ø§ÛŒÙ† Ø²Ù…Ø§Ù†',0),(469408,13040,'tr','Åžu anda iÃ§inde okumak iÃ§in dosya yok',0),(469409,13040,'pl','Brak plikÃ³w do odczytu w tej chwili',0),(469410,13040,'bg','ÐÑÐ¼Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ Ð·Ð° Ñ‡ÐµÑ‚ÐµÐ½Ðµ Ð² Ð¿Ð¾ Ñ‚Ð¾Ð²Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(469411,13040,'ur','Ø§Ø³ ÙˆÙ‚Øª Ù…ÛŒÚº Ù¾Ú‘Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ù…Ø³Ù„ÛŒÚº',0),(469412,13040,'sr','ÐÐµÐ¼Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð·Ð° Ñ‡Ð¸Ñ‚Ð°ÑšÐµ Ñƒ Ñƒ Ð¾Ð²Ð¾Ð¼ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚ÐºÑƒ',0),(469413,13040,'vi','khÃ´ng cÃ³ file Ä‘á»ƒ Ä‘á»c lÃºc nÃ y',0),(469414,13040,'af','Geen lÃªers om te lees In hierdie tyd',0),(469415,13040,'ro','Nu fiÅŸierele de citit Ã®n acest moment',0),(469416,13040,'et','Loe sel ajal faile pole',0),(469417,13040,'si','Ni datotek za branje v v tem Äasu',0),(469418,13040,'ba','Tidak ada file untuk dibaca di saat ini',0),(469419,13040,'nl','Geen bestanden om te lezen In op dit moment',0),(469420,13040,'fi','Ei tiedostoja lukea tÃ¤llÃ¤ hetkellÃ¤',0),(469421,13040,'no','Ingen filer Ã¥ lese i denne gangen',0),(469422,13040,'da','Ingen filer at lÃ¦se i pÃ¥ dette tidspunkt',0),(469423,13040,'ko','ì´ ì‹œì ì—ì„œ ì½ê¸° íŒŒì¼ ì—†ìŒ',0),(469424,13040,'he','××™×Ÿ ×§×‘×¦×™× ×œ×§×¨×™××” ×‘×‘×™×ª ×‘×–×ž×Ÿ ×”×–×”',0),(469425,13040,'el','Î‘ÏÏ‡ÎµÎ¯Î± Î³Î¹Î± Î½Î± Î´Î¹Î±Î²Î¬ÏƒÎµÏ„Îµ ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· ÏƒÏ„Î¹Î³Î¼Î®',0),(469426,13040,'zh','é˜…è¯»åœ¨è¿™ä¸ªæ—¶å€™æ²¡æœ‰æ–‡ä»¶',0),(469427,13040,'sv','Inga filer att lÃ¤sa i vid denna tid',0),(469428,13040,'it','Nessun file da leggere In questo momento',0),(469429,13040,'tl','',0),(469430,13040,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹à¸Ÿà¹‰à¸¡à¸à¸²à¸£à¸­à¹ˆà¸²à¸™à¹ƒà¸™à¸„à¸£à¸±à¹‰à¸‡à¸™à¸µà¹‰',0),(469431,13040,'hi','à¤‡à¤¸ à¤¸à¤®à¤¯ à¤®à¥‡à¤‚ à¤ªà¤¢à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚',0),(469432,13040,'ms','Tiada fail untuk dibaca pada masa ini',0),(469433,13040,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ù„ÙØ§Øª Ù„Ù„Ù‚Ø±Ø§Ø¡Ø© ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„ÙˆÙ‚Øª',0),(469434,13040,'fr','Aucun fichier Ã  lire en ce moment',0),(469435,13040,'jp','ã“ã®æ™‚ç‚¹ã§èª­ã¿å–ã‚Šã™ã‚‹ãƒ•ã‚¡ã‚¤ãƒ«ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(469436,13040,'pt','NÃ£o hÃ¡ arquivos para leitura neste momento',0),(469437,13040,'ru','ÐÐµÑ‚ Ñ„Ð°Ð¹Ð»Ð¾Ð² Ð´Ð»Ñ Ñ‡Ñ‚ÐµÐ½Ð¸Ñ Ð² Ð½Ð° ÑÑ‚Ð¾Ñ‚ Ñ€Ð°Ð·',0),(469438,13040,'es','No Files Para Leer En Este Momento',0),(469439,13040,'de','Keine Dateien zum Lesen In diesem Zeitpunkt',0),(469440,13040,'en','No Files To Read In At This Time',0),(469441,13041,'is','',0),(469442,13041,'dr','ÙØ§ÛŒÙ„ Ø³ÙØ§Ø±Ø´ Ø¯Ø± ÙØ±Ù…Øª ØµØ­ÛŒØ­ Ù†ÛŒØ³Øª',0),(469443,13041,'pr','ÙØ§ÛŒÙ„ Ø³ÙØ§Ø±Ø´ Ø¯Ø± ÙØ±Ù…Øª ØµØ­ÛŒØ­ Ù†ÛŒØ³Øª',0),(469444,13041,'tr','SÄ±ra dosyasÄ± doÄŸru biÃ§imde deÄŸil',0),(469445,13041,'pl','Plik zamÃ³wienia nie jest w niepoprawnym formacie.',0),(469446,13041,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ñ„Ð°Ð¹Ð»ÑŠÑ‚ Ð½Ðµ Ðµ Ð² Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¸Ñ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(469447,13041,'ur','ØªØ±ØªÛŒØ¨ Ù…Ø³Ù„ ØµØ­ÛŒØ­ ÙˆØ¶Ø¹ Ù…ÛŒÚº Ù†ÛÛŒÚº ÛÛ’ Û”',0),(469448,13041,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð¸Ñ˜Ðµ Ñƒ Ð¸ÑÐ¿Ñ€Ð°Ð²Ð½Ð¾Ð¼ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ',0),(469449,13041,'vi','ÄÆ¡n Ä‘áº·t hÃ ng nÃ y thÃ¬ khÃ´ng Ä‘Ãºng Ä‘á»‹nh dáº¡ng',0),(469450,13041,'af','Die orde-lÃªer Is nie In die korrekte formaat',0),(469451,13041,'ro','Ordinul fiÅŸierul nu este Ã®n Format corect',0),(469452,13041,'et','Et fail pole Ãµiges vormingus',0),(469453,13041,'si','Naloga datoteka ni v pravilni obliki',0),(469454,13041,'ba','Order File ini tidak dalam Format yang benar',0),(469455,13041,'nl','De Order-bestand Is niet In de juiste indeling',0),(469456,13041,'fi','Jotta tiedosto ei ole oikeassa muodossa',0),(469457,13041,'no','RekkefÃ¸lgefilen er ikke riktig format',0),(469458,13041,'da','Filen rÃ¦kkefÃ¸lge er ikke i korrekt Format',0),(469459,13041,'ko','ìˆœì„œ íŒŒì¼ì€ ì˜¬ë°”ë¥¸ í˜•ì‹',0),(469460,13041,'he','×§×•×‘×¥ ×”×¡×™×“×•×¨ ××™× ×• ×‘×ª×‘× ×™×ª ×”× ×›×•× ×”',0),(469461,13041,'el','Î¤Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÏ„Î· ÏƒÏ‰ÏƒÏ„Î® Î¼Î¿ÏÏ†Î®',0),(469462,13041,'zh','é¡ºåºæ–‡ä»¶æ˜¯ä¸æ­£ç¡®çš„æ ¼å¼',0),(469463,13041,'sv','Sorteringsfilen Ã¤r inte i rÃ¤tt Format',0),(469464,13041,'it','Il File dell\'ordine non Ã¨ nel formato corretto',0),(469465,13041,'tl','',0),(469466,13041,'th','à¸ªà¸±à¹ˆà¸‡à¹à¸Ÿà¹‰à¸¡à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸£à¸¹à¸›à¹à¸šà¸šà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(469467,13041,'hi','à¤†à¤¦à¥‡à¤¶ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤¹à¥€ à¤¸à¥à¤µà¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(469468,13041,'ms','Fail Perintah ini tidak dalam Format yang betul',0),(469469,13041,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…Ù„Ù Ù„ÙŠØ³ ÙÙŠ Ø§Ù„ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„ØµØ­ÙŠØ­',0),(469470,13041,'fr','Le fichier de commande n\'est pas au format appropriÃ©',0),(469471,13041,'jp','é †åºãƒ•ã‚¡ã‚¤ãƒ«ã¯æ­£ã—ã„å½¢å¼ã§ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(469472,13041,'pt','O arquivo de ordem nÃ£o estÃ¡ no formato correto',0),(469473,13041,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ñ„Ð°Ð¹Ð» Ð½Ð°Ñ…Ð¾Ð´Ð¸Ñ‚ÑÑ Ð½Ðµ Ð² Ð¿Ñ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ñ‹Ð¹ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(469474,13041,'es','El File de Orden No Esta en el Formato Correcto',0),(469475,13041,'de','Die Reihenfolge ist nicht im richtigen Format',0),(469476,13041,'en','The Order File Is Not In The Correct Format',0),(469477,13042,'is','',0),(469478,13042,'dr','Ø¯Ùˆ Ø±Ø¯ÛŒÙ Ø§ÙˆÙ„ Ø¨Ø§Ù„Ø§ Ø±Ø§Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ÙØ§ÛŒÙ„ Ø§Ø±Ø³Ø§Ù„ÛŒ Ø®Ø§Ù„ÛŒ Ø¨Ú¯Ø°Ø§Ø±ÛŒØ¯  ',0),(469479,13042,'pr','Ø¯Ùˆ Ø±Ø¯ÛŒÙ Ø§ÙˆÙ„ Ø¨Ø§Ù„Ø§ Ø±Ø§Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ÙØ§ÛŒÙ„ Ø§Ø±Ø³Ø§Ù„ÛŒ Ø®Ø§Ù„ÛŒ Ø¨Ú¯Ø°Ø§Ø±ÛŒØ¯  ',0),(469480,13042,'tr','Ãœst 2 satÄ±r verme dosyasÄ±ndan olduÄŸu gibi bÄ±rakÄ±n.',0),(469481,13042,'pl','ZostawiÄ‡ u gÃ³ry 2 wiersze z pliku eksportu, jak jest.',0),(469482,13042,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð³Ð¾Ñ€Ð½Ð°Ñ‚Ð° 2 Ñ€ÐµÐ´Ð° Ð¾Ñ‚ Ñ„Ð°Ð¹Ð»Ð° Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ, ÐºÐ°ÐºÑ‚Ð¾ Ðµ.',0),(469483,13042,'ur','ÛÛ’ Ø¬ÛŒØ³Ø§ Ú©Û Ø¨Ø±Ø¢Ù…Ø¯ Ù…Ø³Ù„ Ø³Û’ Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± 2 ØµÙÛŒÚº Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº Û”',0),(469484,13042,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð°Ñ˜Ð²Ð¸ÑˆÐ¸ 2 Ñ€ÐµÐ´Ð° Ð¸Ð· Ð˜Ð·Ð²Ð¾Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÐºÐ°Ð¾ ÑˆÑ‚Ð¾ Ñ˜Ðµ.',0),(469485,13042,'vi','Äá»ƒ trá»‘ng 2 dÃ²ng trÃªn tá»« file káº¿t xuáº¥t',0),(469486,13042,'af','Laat die boonste 2 rye van die uitvoer lÃªer is.',0),(469487,13042,'ro','LÄƒsaÅ£i top 2 rÃ¢nduri din fiÅŸierul de export, aÅŸa cum este.',0),(469488,13042,'et','JÃ¤tta top 2 rida on ekspordifaili.',0),(469489,13042,'si','Pustite top 2 vrstice iz v izvozno datoteko, kot je.',0),(469490,13042,'ba','Meninggalkan 2 baris atas dari file ekspor sebagai.',0),(469491,13042,'nl','Verlaat de bovenste 2 rijen van het exportbestand als is.',0),(469492,13042,'fi','JÃ¤tÃ¤ top 2 krs vientitiedostosta sellaisenaan.',0),(469493,13042,'no','La pÃ¥ topp 2 rader fra eksportfilen er.',0),(469494,13042,'da','AfgÃ¥ eksportfilen som er de Ã¸verste 2 rÃ¦kker.',0),(469495,13042,'ko','ë‚´ë³´ë‚´ê¸° íŒŒì¼ì€ì—ì„œ ìƒìœ„ 2 í–‰ì„ ë‘¡ë‹ˆë‹¤.',0),(469496,13042,'he','×™×•×¦××™× ××ª 2 ×”×©×•×¨×•×ª ×‘×§×•×‘×¥ ×”×™×™×¦×•× ×”×•×.',0),(469497,13042,'el','Î‘Ï†Î®ÏƒÏ„Îµ Ï„Î¿ ÎµÏ€Î¬Î½Ï‰ 2 ÏƒÎµÎ¹ÏÎ­Ï‚ Î±Ï€ÏŒ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ ÏŒÏ€Ï‰Ï‚ ÎµÎ¯Î½Î±Î¹.',0),(469498,13042,'zh','ä»Žå¯¼å‡ºæ–‡ä»¶æ­£ç¦»å¼€å‰ 2 è¡Œã€‚',0),(469499,13042,'sv','LÃ¤mna de Ã¶versta 2 raderna frÃ¥n export-filen som Ã¤r.',0),(469500,13042,'it','Lasciare le prime 2 righe dal file di esportazione come Ã¨.',0),(469501,13042,'tl','',0),(469502,13042,'th','à¸›à¸¥à¹ˆà¸­à¸¢à¹à¸–à¸§à¸šà¸™à¸—à¸µà¹ˆ 2 à¸ˆà¸²à¸à¹„à¸Ÿà¸¥à¹Œà¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸à¹€à¸›à¹‡à¸™',0),(469503,13042,'hi','à¤¶à¥€à¤°à¥à¤· 2 à¤ªà¤‚à¤•à¥à¤¤à¤¿à¤¯à¥‹à¤‚ à¤¸à¥‡ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚à¥¤',0),(469504,13042,'ms','Meninggalkan baris 2 atas dari fail eksport seadanya.',0),(469505,13042,'ar','ØªØ±Ùƒ Ø§Ù„ØµÙÙˆÙ 2 Ø£Ø¹Ù„Ù‰ Ù…Ù† Ù…Ù„Ù Ø§Ù„ØªØµØ¯ÙŠØ± ÙƒÙ…Ø§ Ù‡Ùˆ.',0),(469506,13042,'fr','Laisser les 2 premiÃ¨res lignes du fichier d\'exportation comme c\'est.',0),(469507,13042,'jp','ä¸Šéƒ¨ã® 2 è¡Œã¯ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰æ®‹ã—ã¾ã™ã€‚',0),(469508,13042,'pt','Deixe as top 2 linhas do arquivo de exportaÃ§Ã£o, como Ã©.',0),(469509,13042,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¢Ð¾Ð¿ 2 ÑÑ‚Ñ€Ð¾Ðº Ð¸Ð· Ñ„Ð°Ð¹Ð»Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°, ÐºÐ°Ðº ÑÑ‚Ð¾.',0),(469510,13042,'es','Deja las primeras Dos Filas Encima del file de ExportaciÃ³n Como Es',0),(469511,13042,'de','Lassen Sie die obersten 2 Zeilen aus der Exportdatei ist.',0),(469512,13042,'en','Leave the top 2 rows from the export file as is.',0),(469513,13043,'is','',0),(469514,13043,'dr','Ù„ÛŒØ³Øª Ø¨Ø§Ø±Ú© Ù…Ø±Ø§Ø­Ù„ ÙØ±Ø§ÛŒÙ†Ø¯',0),(469515,13043,'pr','Ù„ÛŒØ³Øª Ø¨Ø§Ø±Ú© Ù…Ø±Ø§Ø­Ù„ ÙØ±Ø§ÛŒÙ†Ø¯',0),(469516,13043,'tr','Ä°ÅŸlem aÅŸamalarÄ± barkod listesi',0),(469517,13043,'pl','Lista kodÃ³w kreskowych etapy procesu',0),(469518,13043,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑ ÐµÑ‚Ð°Ð¿Ð¸ Ð±Ð°Ñ€ÐºÐ¾Ð´ ÑÐ¿Ð¸ÑÑŠÐº',0),(469519,13043,'ur','Ø¹Ù…Ù„ Ù…Ø±Ø§Ø­Ù„ Ø¨Ø§Ø±Ú©ÙˆÚˆ ÙÛØ±Ø³Øª',0),(469520,13043,'sr','Ð›Ð¸ÑÑ‚Ð° Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð° Ñ„Ð°Ð·Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑÐ°',0),(469521,13043,'vi','danh sÃ¡ch mÃ£ giai Ä‘oáº¡n tiáº¿n hÃ nh',0),(469522,13043,'af','Proses stadiums strepieskode lys',0),(469523,13043,'ro','Etapele procesului de coduri de bare lista',0),(469524,13043,'et','Protsessi etapid vÃ¶Ã¶tkoodi loend',0),(469525,13043,'si','Seznam Ärtne kode faz procesa',0),(469526,13043,'ba','Daftar Barcode tahap proses',0),(469527,13043,'nl','Proceslijst stadia Barcode',0),(469528,13043,'fi','Prosessi viivakoodi luettelo',0),(469529,13043,'no','Barcode prosesslisten stadier',0),(469530,13043,'da','Processen faser stregkode liste',0),(469531,13043,'ko','í”„ë¡œì„¸ìŠ¤ ë‹¨ê³„ ë°”ì½”ë“œ ëª©ë¡',0),(469532,13043,'he','×¨×©×™×ž×ª ×‘×¨×§×•×“ ×©×œ×‘×™× ×‘×ª×”×œ×™×š',0),(469533,13043,'el','Î›Î¯ÏƒÏ„Î± Barcode ÏƒÏ„Î¬Î´Î¹Î± Î´Î¹ÎµÏÎ³Î±ÏƒÎ¹ÏŽÎ½',0),(469534,13043,'zh','è¿‡ç¨‹é˜¶æ®µæ¡å½¢ç æ¸…å•',0),(469535,13043,'sv','Process stegen Barcode lista',0),(469536,13043,'it','Elenco codici a barre fasi di processo',0),(469537,13043,'tl','',0),(469538,13043,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£',0),(469539,13043,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤šà¤°à¤£à¥‹à¤‚ à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤¸à¥‚à¤šà¥€',0),(469540,13043,'ms','Senarai kod bar peringkat proses',0),(469541,13043,'ar','Ù…Ø±Ø§Ø­Ù„ Ø¹Ù…Ù„ÙŠØ© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¨Ø§Ø±ÙƒÙˆØ¯',0),(469542,13043,'fr','Liste des codes Ã  barres processus Ã©tapes',0),(469543,13043,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã®æ®µéšŽ [ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ ãƒªã‚¹ãƒˆ]',0),(469544,13043,'pt','Lista de cÃ³digo de barras de estÃ¡gios de processos',0),(469545,13043,'ru','Ð¨Ñ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ ÑÐ¿Ð¸ÑÐ¾Ðº ÑÑ‚Ð°Ð¿Ð¾Ð² Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ°',0),(469546,13043,'es','Procesar Etapas Lista de cÃ³digo de Barras',0),(469547,13043,'de','Prozess-Stufen-Barcode-Liste',0),(469548,13043,'en','Process Stages Barcode List',0),(469549,13044,'is','',0),(469550,13044,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ø§Ø±Ú©Ø¯ ÙˆØ±ÙˆØ¯ÛŒ',0),(469551,13044,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ø§Ø±Ú©Ø¯ ÙˆØ±ÙˆØ¯ÛŒ',0),(469552,13044,'tr','Barkod giriÅŸ gÃ¶rÃ¼nÃ¼m',0),(469553,13044,'pl','Kod kreskowy wejÅ›cie widok',0),(469554,13044,'bg','Ð’ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ñ€ÐºÐ¾Ð´ Ð¸Ð·Ð³Ð»ÐµÐ´',0),(469555,13044,'ur','Ø¨Ø§Ø±Ú©ÙˆÚˆ Ø§Ù† Ù¾Ù¹ Ù…Ù†Ø¸Ø±',0),(469556,13044,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð·Ð° ÑƒÐ½Ð¾Ñ Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð°',0),(469557,13044,'vi','Xem mÃ£ váº¡ch vÃ o',0),(469558,13044,'af','Strepieskode insette bekyk',0),(469559,13044,'ro','Coduri de bare de intrare Vezi',0),(469560,13044,'et','VÃ¶Ã¶tkoodi sisend vaade',0),(469561,13044,'si','Pogled vnosa Ärtne kode',0),(469562,13044,'ba','Lihat barcode Input',0),(469563,13044,'nl','Barcode Input weergave',0),(469564,13044,'fi','Viivakoodi Input View',0),(469565,13044,'no','Barcode Input visning',0),(469566,13044,'da','Stregkode Input Se',0),(469567,13044,'ko','ë°”ì½”ë“œ ìž…ë ¥ ë³´ê¸°',0),(469568,13044,'he','×ª×¦×•×’×ª ×§×œ×˜ ×‘×¨×§×•×“',0),(469569,13044,'el','Î†Ï€Î¿ÏˆÎ· Ï„Î·Ï‚ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… Ï„Î¿Ï… barcode',0),(469570,13044,'zh','æ¡ç è¾“å…¥è§†å›¾',0),(469571,13044,'sv','Streckkod indata Visa',0),(469572,13044,'it','Vista ingresso codice a barre',0),(469573,13044,'tl','',0),(469574,13044,'th','à¸”à¸¹à¸›à¹‰à¸­à¸™à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”',0),(469575,13044,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤‡à¤¨à¤ªà¥à¤Ÿ à¤¦à¥ƒà¤¶à¥à¤¯',0),(469576,13044,'ms','Paparan Input Kod Bar',0),(469577,13044,'ar','Ø¹Ø±Ø¶ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠ',0),(469578,13044,'fr','Vue de code-barre',0),(469579,13044,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰å…¥åŠ›ãƒ“ãƒ¥ãƒ¼',0),(469580,13044,'pt','Vista da entrada de cÃ³digo de barras',0),(469581,13044,'ru','Ð’Ð¸Ð´ Ð²Ð²Ð¾Ð´Ð° ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´Ð°',0),(469582,13044,'es','Vista de Entrad de CÃ³digo de Barras',0),(469583,13044,'de','Barcode-Eingang anzeigen',0),(469584,13044,'en','Barcode Input View',0),(469585,13045,'is','',0),(469586,13045,'dr','Ù…Ø±Ø­Ù„Ù‡  Ø«Ø¨Øª Ø´Ø¯Ù‡ Ù…Ø¹ØªØ¨Ø± Ù†ÛŒØ³Øª',0),(469587,13045,'pr','Ù…Ø±Ø­Ù„Ù‡  Ø«Ø¨Øª Ø´Ø¯Ù‡ Ù…Ø¹ØªØ¨Ø± Ù†ÛŒØ³Øª',0),(469588,13045,'tr','GeÃ§ersiz AÅŸama girdi',0),(469589,13045,'pl','NieprawidÅ‚owy etap wszedÅ‚',0),(469590,13045,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ ÐµÑ‚Ð°Ð¿ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸',0),(469591,13045,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ù…Ø±Ø­Ù„Û’ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(469592,13045,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð° Ñ„Ð°Ð·Ð° ÑƒÑˆÐ°Ð¾',0),(469593,13045,'vi','BÆ°á»›c nháº­p vÃ´ hiá»‡u',0),(469594,13045,'af','Ongeldige stadium ingetik',0),(469595,13045,'ro','Etapa nevalidÄƒ a intrat',0),(469596,13045,'et','Sobimatu etapp sisestatud',0),(469597,13045,'si','Neveljavna stopnja, vstopil',0),(469598,13045,'ba','Memasuki tahap yang tidak valid',0),(469599,13045,'nl','Ongeldige fase ingevoerd',0),(469600,13045,'fi','Virheellinen vaihe tuli',0),(469601,13045,'no','Ugyldig fase angitt',0),(469602,13045,'da','Ugyldigt fase trÃ¥dte',0),(469603,13045,'ko','ìž˜ëª» ëœ ë‹¨ê³„ ìž…ë ¥',0),(469604,13045,'he','×”×‘×ž×” ×œ× ×—×•×§×™×™× × ×›× ×¡',0),(469605,13045,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ¿ ÏƒÏ„Î¬Î´Î¹Î¿ Î¬ÏÏ‡Î¹ÏƒÎµ',0),(469606,13045,'zh','é˜¶æ®µæ— æ•ˆè¾“å…¥',0),(469607,13045,'sv','Ogiltig scenen trÃ¤dde',0),(469608,13045,'it','Fase non valido inserito',0),(469609,13045,'tl','',0),(469610,13045,'th','à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸—à¸µà¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™',0),(469611,13045,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤šà¤°à¤£ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(469612,13045,'ms','Peringkat tidak sah yang dimasukkan',0),(469613,13045,'ar','Ø§Ù„Ù…Ø±Ø­Ù„Ø© ØºÙŠØ± ØµØ§Ù„Ø­ Ø¯Ø®Ù„Øª',0),(469614,13045,'fr','Stade non valide entrÃ©',0),(469615,13045,'jp','ç„¡åŠ¹ãªã‚¹ãƒ†ãƒ¼ã‚¸ã«å…¥ã£ãŸ',0),(469616,13045,'pt','EstÃ¡gio invÃ¡lido entrado',0),(469617,13045,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ ÑÑ‚Ð°Ð¿ Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»',0),(469618,13045,'es','Etapa Invalida se Entra',0),(469619,13045,'de','UngÃ¼ltige BÃ¼hne eingegeben',0),(469620,13045,'en','Invalid Stage Entered',0),(469621,13046,'is','',0),(469622,13046,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø±Ø­Ù„Ù‡ Ø¬Ø¯ÛŒØ¯',0),(469623,13046,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø±Ø­Ù„Ù‡ Ø¬Ø¯ÛŒØ¯',0),(469624,13046,'tr','Yeni sahne kimliÄŸi',0),(469625,13046,'pl','Nowy etap ID',0),(469626,13046,'bg','ÐÐ¾Ð² ÐµÑ‚Ð°Ð¿ Ð˜Ð”',0),(469627,13046,'ur','Ø§Ø³Ù¹ÛŒØ¬ Ú©ÛŒ Ù†Ø¦ÛŒ Ø´Ù†Ø§Ø®Øª',0),(469628,13046,'sr','ÐÐ¾Ð²Ð° Ñ„Ð°Ð·Ð° Ð˜Ð”',0),(469629,13046,'vi','giai Ä‘oáº¡n má»›i ID',0),(469630,13046,'af','Nuwe stadium ID',0),(469631,13046,'ro','Noul stadiu ID',0),(469632,13046,'et','Uue etapi ID.',0),(469633,13046,'si','Novi fazi ID',0),(469634,13046,'ba','ID tahap baru',0),(469635,13046,'nl','Nieuwe fase ID',0),(469636,13046,'fi','Uuden vaiheen tunnus',0),(469637,13046,'no','Nye stadium-ID',0),(469638,13046,'da','Nyt stadie-ID',0),(469639,13046,'ko','ìƒˆë¡œìš´ ë‹¨ê³„ ID',0),(469640,13046,'he','×ž×–×”×” ×©×œ×‘ ×—×“×©',0),(469641,13046,'el','ÎÎ­Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ„Î¬Î´Î¹Î¿',0),(469642,13046,'zh','æ–°é˜¶æ®µ ID',0),(469643,13046,'sv','Nya Stage-ID',0),(469644,13046,'it','Nuova fase ID',0),(469645,13046,'tl','',0),(469646,13046,'th','ID à¸‚à¸±à¹‰à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(469647,13046,'hi','à¤¨à¤¯à¤¾ à¤šà¤°à¤£ à¤†à¤ˆà¤¡à¥€',0),(469648,13046,'ms','ID peringkat baru',0),(469649,13046,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø±Ø­Ù„Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(469650,13046,'fr','Nouveau stade ID',0),(469651,13046,'jp','æ–°ã—ã„ã‚¹ãƒ†ãƒ¼ã‚¸ ID',0),(469652,13046,'pt','Nova fase ID',0),(469653,13046,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÑÑ‚Ð°Ð¿ ID',0),(469654,13046,'es','Nueva Etapa ID',0),(469655,13046,'de','Neue BÃ¼hne-ID',0),(469656,13046,'en','New Stage ID',0),(469657,13047,'is','',0),(469658,13047,'dr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(469659,13047,'pr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(469660,13047,'tr','LÃ¼tfen sipariÅŸ numarasÄ± girin',0),(469661,13047,'pl','ProszÄ™ wpisaÄ‡ numer zamÃ³wienia',0),(469662,13047,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(469663,13047,'ur','Ø§ÛŒÚ© Ù†Ø¸Ù… Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(469664,13047,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(469665,13047,'vi','vui lÃ²ng nháº­p má»™t sá»‘ Ä‘Æ¡n hÃ ng',0),(469666,13047,'af','Tik asseblief \'n bestelling nommer',0),(469667,13047,'ro','Va rugam introduceti un numar de ordine',0),(469668,13047,'et','Sisestage korralduse Number',0),(469669,13047,'si','VpiÅ¡ite zaporedno Å¡tevilko',0),(469670,13047,'ba','Masukkan nomor urut',0),(469671,13047,'nl','Voer een ordernummer heeft opgegeven',0),(469672,13047,'fi','Kirjoita tilausnumero',0),(469673,13047,'no','Angi et bestillingsnummer',0),(469674,13047,'da','Angiv et ordrenummer',0),(469675,13047,'ko','ì£¼ë¬¸ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(469676,13047,'he','×”×–×™× ×• ××ª ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(469677,13047,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(469678,13047,'zh','è¯·è¾“å…¥è®¢å•å·',0),(469679,13047,'sv','Ange ordernummer',0),(469680,13047,'it','Per favore inserisci un numero di ordine',0),(469681,13047,'tl','',0),(469682,13047,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(469683,13047,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤‘à¤°à¥à¤¡à¤° à¤¨à¤‚à¤¬à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(469684,13047,'ms','Sila masukkan nombor perintah untuk',0),(469685,13047,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨',0),(469686,13047,'fr','Veuillez entrer un numÃ©ro de commande',0),(469687,13047,'jp','æ³¨æ–‡ç•ªå·ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(469688,13047,'pt','Por favor, digite um nÃºmero de ordem',0),(469689,13047,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(469690,13047,'es','Por Favor Entra un NÃºmero de Pedido',0),(469691,13047,'de','Bitte geben Sie eine Bestellnummer',0),(469692,13047,'en','Please Enter An Order Number',0),(469693,13048,'is','',0),(469694,13048,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ø´Ù†Ø§Ø³Ù‡ Ù…Ø±Ø­Ù„Ù‡ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(469695,13048,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ø´Ù†Ø§Ø³Ù‡ Ù…Ø±Ø­Ù„Ù‡ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ',0),(469696,13048,'tr','LÃ¼tfen Stage kimliÄŸi girin',0),(469697,13048,'pl','ProszÄ™ wprowadziÄ‡ ID etapie',0),(469698,13048,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð˜Ð” Ð½Ð° ÐµÑ‚Ð°Ð¿',0),(469699,13048,'ur','Ø§ÛŒÚ© Ø§Ø³Ù¹ÛŒØ¬ ID Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(469700,13048,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð˜Ð” Ð·Ð° Ð¿Ð¾Ð·Ð¾Ñ€Ð½Ð¸Ñ†Ñƒ',0),(469701,13048,'vi','vui lÃ²ng nháº­p ID cho giai Ä‘oáº¡n ',0),(469702,13048,'af','Tik asseblief \'n stadium ID',0),(469703,13048,'ro','IntroduceÈ›i un ID de etapÄƒ',0),(469704,13048,'et','Sisestage etapi ID',0),(469705,13048,'si','Vnesite ID fazi',0),(469706,13048,'ba','Masukkan ID panggung',0),(469707,13048,'nl','Voer een ID stadium',0),(469708,13048,'fi','Kirjoita vaiheen tunnus',0),(469709,13048,'no','Angi en stadium-ID',0),(469710,13048,'da','Angiv et stadie-ID',0),(469711,13048,'ko','ë‹¨ê³„ IDë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(469712,13048,'he','×× × ×”×–×Ÿ ×ž×–×”×” ×©×œ×‘',0),(469713,13048,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ ÏƒÏ„Î¬Î´Î¹Î¿',0),(469714,13048,'zh','è¯·è¾“å…¥ä¸€ä¸ªé˜¶æ®µ ID',0),(469715,13048,'sv','Ange ett skede-ID',0),(469716,13048,'it','Inserire un ID di fase',0),(469717,13048,'tl','',0),(469718,13048,'th','à¸à¸£à¸¸à¸“à¸²à¸›à¹‰à¸­à¸™à¸£à¸«à¸±à¸ªà¸‚à¸±à¹‰à¸™à¸•à¸­à¸™',0),(469719,13048,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¸à¥à¤Ÿà¥‡à¤œ ID à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(469720,13048,'ms','Sila masukkan ID peringkat',0),(469721,13048,'ar','ÙŠØ±Ø¬Ù‰ Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø±Ø­Ù„Ø©',0),(469722,13048,'fr','Veuillez saisir un code de Stage',0),(469723,13048,'jp','ã‚¹ãƒ†ãƒ¼ã‚¸ ID ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(469724,13048,'pt','Por favor, introduza um ID de palco',0),(469725,13048,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÑÑ‚Ð°Ð´Ð¸Ð¸',0),(469726,13048,'es','Por Favor Entra un ID de Etapa',0),(469727,13048,'de','Bitte geben Sie eine BÃ¼hne-ID',0),(469728,13048,'en','Please Enter A Stage ID',0),(469729,13049,'is','',0),(469730,13049,'dr','Ø§Ø³Ú©Ù† Ø¨Ø§Ø±Ú©Ø¯',0),(469731,13049,'pr','Ø§Ø³Ú©Ù† Ø¨Ø§Ø±Ú©Ø¯',0),(469732,13049,'tr','Barkod tarama',0),(469733,13049,'pl','Skanowanie kodÃ³w kreskowych',0),(469734,13049,'bg','Ð¡ÐºÐ°Ð½Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ñ€ÐºÐ¾Ð´',0),(469735,13049,'ur','Ø¨Ø§Ø±Ú©ÙˆÚˆ Ø§Ø³Ú©ÛŒÙ†',0),(469736,13049,'sr','Ð¡ÐºÐµÐ½Ð¸Ñ€Ð°ÑšÐµÐ¼ Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð°',0),(469737,13049,'vi','quÃ©t mÃ£ váº¡ch',0),(469738,13049,'af','Skandeer strepieskode',0),(469739,13049,'ro','Scanare coduri de bare',0),(469740,13049,'et','Skaneerida Triipkood',0),(469741,13049,'si','Scan Barcode',0),(469742,13049,'ba','Memindai Barcode',0),(469743,13049,'nl','Scan de Barcode',0),(469744,13049,'fi','Skannaa viivakoodi',0),(469745,13049,'no','Skanne strekkode',0),(469746,13049,'da','Scanne stregkoder',0),(469747,13049,'ko','ë°”ì½”ë“œ ìŠ¤ìº”',0),(469748,13049,'he','×¡×¨×™×§×ª ×‘×¨×§×•×“',0),(469749,13049,'el','Î£Î¬ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Barcode',0),(469750,13049,'zh','æ‰«ææ¡ç ',0),(469751,13049,'sv','Skanna streckkoden',0),(469752,13049,'it','La scansione di codici a barre',0),(469753,13049,'tl','',0),(469754,13049,'th','à¸ªà¹à¸à¸™à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”',0),(469755,13049,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤¸à¥à¤•à¥ˆà¤¨ à¤•à¤°à¥‡à¤‚',0),(469756,13049,'ms','Imbas Kod Bar',0),(469757,13049,'ar','Ù…Ø³Ø­ Ø§Ù„Ø¨Ø§Ø±ÙƒÙˆØ¯',0),(469758,13049,'fr','Scanner code-barres',0),(469759,13049,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã‚’ã‚¹ã‚­ãƒ£ãƒ³ã—ã¾ã™ã€‚',0),(469760,13049,'pt','Varredura de cÃ³digo de barras',0),(469761,13049,'ru','Ð¡ÐºÐ°Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´Ð°',0),(469762,13049,'es','Escanear CÃ³digo de Barras',0),(469763,13049,'de','Barcode-Scan',0),(469764,13049,'en','Scan Barcode',0),(469765,13050,'is','',0),(469766,13050,'dr','Ù†Ù…Ø§ÛŒØ´ ÙˆØ±ÙˆØ¯ÛŒ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(469767,13050,'pr','Ù†Ù…Ø§ÛŒØ´ ÙˆØ±ÙˆØ¯ÛŒ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(469768,13050,'tr','Standart giriÅŸ gÃ¶rÃ¼nÃ¼m',0),(469769,13050,'pl','Standardowy widok danych wejÅ›ciowych',0),(469770,13050,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ð²Ñ…Ð¾Ð´ Ð¸Ð·Ð³Ð»ÐµÐ´',0),(469771,13050,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø§Ù† Ù¾Ù¹ Ù…Ù†Ø¸Ø±',0),(469772,13050,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð·Ð° ÑƒÐ½Ð¾Ñ',0),(469773,13050,'vi','Xem Ä‘áº§u vÃ o chuáº©n',0),(469774,13050,'af','Standaard insette bekyk',0),(469775,13050,'ro','Vizualizarea standard de intrare',0),(469776,13050,'et','Standardvaade sisend',0),(469777,13050,'si','Standardni pogled vnosa',0),(469778,13050,'ba','Standar Input',0),(469779,13050,'nl','Input standaardweergave',0),(469780,13050,'fi','Standard Input View',0),(469781,13050,'no','Angi standardvisning',0),(469782,13050,'da','Input standardvisning',0),(469783,13050,'ko','í‘œì¤€ ìž…ë ¥ëœ ë³´ê¸°',0),(469784,13050,'he','×ª×¦×•×’×ª ×§×œ×˜ ×¡×˜× ×“×¨×˜×™',0),(469785,13050,'el','ÎšÎ±Î½Î¿Î½Î¹ÎºÎ® Ï€ÏÎ¿Î²Î¿Î»Î® ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(469786,13050,'zh','æ ‡å‡†è¾“å…¥çš„è§†å›¾',0),(469787,13050,'sv','Standard Input View',0),(469788,13050,'it','Vista ingresso standard',0),(469789,13050,'tl','',0),(469790,13050,'th','à¸¡à¸¸à¸¡à¸¡à¸­à¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸›à¹‰à¸­à¸™à¸„à¹ˆà¸²à¸¡à¸²à¸•à¸£à¸à¸²à¸™',0),(469791,13050,'hi','à¤®à¤¾à¤¨à¤• à¤‡à¤¨à¤ªà¥à¤Ÿ à¤¦à¥ƒà¤¶à¥à¤¯',0),(469792,13050,'ms','Paparan Input yang standard',0),(469793,13050,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ',0),(469794,13050,'fr','Affichage d\'entrÃ©e standard',0),(469795,13050,'jp','æ¨™æº–å…¥åŠ›ãƒ“ãƒ¥ãƒ¼',0),(469796,13050,'pt','ExibiÃ§Ã£o de entrada padrÃ£o',0),(469797,13050,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð²Ð¸Ð´ Ð²Ð²Ð¾Ð´Ð°',0),(469798,13050,'es','Vista Estandar de Input',0),(469799,13050,'de','Standard-Eingabe-Fenster',0),(469800,13050,'en','Standard Input View',0),(469801,13051,'is','',0),(469802,13051,'dr','Ù†Ù…Ø§ÛŒØ´ Ù„ÛŒØ³Øª Ø¨Ø§Ø±Ú©Ø¯ ',0),(469803,13051,'pr','Ù†Ù…Ø§ÛŒØ´ Ù„ÛŒØ³Øª Ø¨Ø§Ø±Ú©Ø¯ ',0),(469804,13051,'tr','Sahne barkod listesini gÃ¶rÃ¼ntÃ¼le',0),(469805,13051,'pl','Lista kodÃ³w kreskowych etapie widok',0),(469806,13051,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð·Ð° Ð±Ð°Ñ€ÐºÐ¾Ð´ Ð½Ð° ÐµÑ‚Ð°Ð¿',0),(469807,13051,'ur','Ù…Ù†Ø¸Ø± Ø§Ø³Ù¹ÛŒØ¬ Ø¨Ø§Ø±Ú©ÙˆÚˆ ÙÛØ±Ø³Øª',0),(469808,13051,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð»Ð¸ÑÑ‚Ðµ Ð·Ð° Ð¿Ð¾Ð·Ð¾Ñ€Ð½Ð¸Ñ†Ñƒ Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð°',0),(469809,13051,'vi','Xem danh sÃ¡ch Barcode',0),(469810,13051,'af','Bekyk stadium strepieskode lys',0),(469811,13051,'ro','Vezi etapa de coduri de bare lista',0),(469812,13051,'et','Etapi vÃ¶Ã¶tkoodi loend',0),(469813,13051,'si','Ogled seznama fazi Ärtne kode',0),(469814,13051,'ba','Lihat daftar Barcode panggung',0),(469815,13051,'nl','Lijst van weergave fase Barcode',0),(469816,13051,'fi','Vaiheessa viivakoodi luettelo',0),(469817,13051,'no','Vis stadiet strekkode liste',0),(469818,13051,'da','Se fase stregkode liste',0),(469819,13051,'ko','ë¬´ëŒ€ ë°”ì½”ë“œ ëª©ë¡ ë³´ê¸°',0),(469820,13051,'he','×ª×¦×•×’×ª ×¨×©×™×ž×ª ×‘×¨×§×•×“ ×”×‘×ž×”',0),(469821,13051,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»Î¯ÏƒÏ„Î±Ï‚ Barcode ÏƒÏ„Î¬Î´Î¹Î¿',0),(469822,13051,'zh','æŸ¥çœ‹é˜¶æ®µæ¡ç åˆ—è¡¨',0),(469823,13051,'sv','Visa scenen Barcode lista',0),(469824,13051,'it','Vedi la lista dei codici a barre Stage',0),(469825,13051,'tl','',0),(469826,13051,'th','à¸”à¸¹à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™',0),(469827,13051,'hi','à¤¸à¥à¤Ÿà¥‡à¤œ à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤¸à¥‚à¤šà¥€ à¤¦à¥‡à¤–à¥‡à¤‚',0),(469828,13051,'ms','Lihat senarai Barcode peringkat',0),(469829,13051,'ar','Ù…Ù† Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø±Ø­Ù„Ø© Ø§Ù„Ø¨Ø§Ø±ÙƒÙˆØ¯',0),(469830,13051,'fr','Liste de codes Ã  barres vue stade',0),(469831,13051,'jp','è¡¨ç¤ºæ®µéšŽ [ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ ãƒªã‚¹ãƒˆ]',0),(469832,13051,'pt','Ver lista de cÃ³digo de barras de fase',0),(469833,13051,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº ÑÑ‚Ð°Ð´Ð¸Ð¸ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´Ð¾Ð²',0),(469834,13051,'es','Vistar Lista de Etapas de CÃ³digo de Barras',0),(469835,13051,'de','BÃ¼hne-Barcode-Anzeigeliste',0),(469836,13051,'en','View Stage Barcode List',0),(469837,13052,'is','',0),(469838,13052,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯',0),(469839,13052,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯',0),(469840,13052,'tr','Varolan bir hesabÄ± dÃ¼zenlemek',0),(469841,13052,'pl','Edycja istniejÄ…cego konta',0),(469842,13052,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(469843,13052,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(469844,13052,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›ÐµÐ³ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(469845,13052,'vi','ThÃªm tÃ i khoáº£n Ä‘ang cÃ³',0),(469846,13052,'af','Redigeer bestaande rekening',0),(469847,13052,'ro','Editare cont existent',0),(469848,13052,'et','Muuda olemasolevat kontot',0),(469849,13052,'si','Uredi obstojeÄi raÄun',0),(469850,13052,'ba','Mengedit Account yang ada',0),(469851,13052,'nl','Bestaande Account bewerken',0),(469852,13052,'fi','Muokata luotua tiliÃ¤',0),(469853,13052,'no','Redigere eksisterende forretningsforbindelse',0),(469854,13052,'da','Redigere eksisterende konto',0),(469855,13052,'ko','ê¸°ì¡´ ê³„ì • íŽ¸ì§‘',0),(469856,13052,'he','×¢×¨×™×›×ª ×—×©×‘×•×Ÿ ×§×™×™×',0),(469857,13052,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(469858,13052,'zh','ç¼–è¾‘çŽ°æœ‰å¸æˆ·',0),(469859,13052,'sv','Redigera befintligt konto',0),(469860,13052,'it','Modificare Account esistente',0),(469861,13052,'tl','',0),(469862,13052,'th','à¹à¸à¹‰à¹„à¸‚à¸šà¸±à¸à¸Šà¸µà¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(469863,13052,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤–à¤¾à¤¤à¥‡ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(469864,13052,'ms','Edit akaun sedia ada',0),(469865,13052,'ar','ØªØ­Ø±ÙŠØ± Ø­Ø³Ø§Ø¨ Ù…ÙˆØ¬ÙˆØ¯',0),(469866,13052,'fr','Modifier le compte existant',0),(469867,13052,'jp','æ—¢å­˜ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(469868,13052,'pt','Editar conta existente',0),(469869,13052,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰ÐµÐ¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(469870,13052,'es','Editar Cuenta Existente',0),(469871,13052,'de','Bestehenden Account bearbeiten',0),(469872,13052,'en','Edit Existing Account',0),(469873,13053,'is','',0),(469874,13053,'dr','Ø§ÛŒÙ† Ù‚Ø§Ø¨Ù„ÛŒØª Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø¨Ù‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±ØºÛŒØ± ÙØ¹Ø§Ù„ Ø§Ø³Øª ',0),(469875,13053,'pr','Ø§ÛŒÙ† Ù‚Ø§Ø¨Ù„ÛŒØª Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø¨Ù‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±ØºÛŒØ± ÙØ¹Ø§Ù„ Ø§Ø³Øª ',0),(469876,13053,'tr','Bu eklentiyi devre dÄ±ÅŸÄ± bÄ±rakÄ±ldÄ±',0),(469877,13053,'pl','Ten dodatek zostaÅ‚ wyÅ‚Ä…czony',0),(469878,13053,'bg','Ð¢Ð°Ð·Ð¸ Ð´Ð¾Ð±Ð°Ð²ÐºÐ° Ðµ Ð·Ð°Ð±Ñ€Ð°Ð½ÐµÐ½Ð°',0),(469879,13053,'ur','ÛŒÛ Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ú©Ùˆ Ù†Ø§Ø§ÛÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(469880,13053,'sr','ÐžÐ²Ð°Ñ˜ Ð´Ð¾Ð´Ð°Ñ‚Ð°Ðº Ñ˜Ðµ Ð¾Ð½ÐµÐ¼Ð¾Ð³ÑƒÑ›ÐµÐ½',0),(469881,13053,'vi','CÃ¡i add-on nÃ y Ä‘Ã£ bá»‹ vÃ´ hiá»‡u hÃ³a',0),(469882,13053,'af','Hierdie byvoegsel is versper',0),(469883,13053,'ro','Acest supliment a fost dezactivat',0),(469884,13053,'et','See lisandmoodul on keelatud',0),(469885,13053,'si','Ta dodatek je bil onemogoÄen',0),(469886,13053,'ba','Pengaya ini telah dinonaktifkan',0),(469887,13053,'nl','Deze Add-On is uitgeschakeld',0),(469888,13053,'fi','TÃ¤mÃ¤ lisÃ¤osa on poistettu kÃ¤ytÃ¶stÃ¤',0),(469889,13053,'no','Dette tillegget er deaktivert',0),(469890,13053,'da','Denne tilfÃ¸jelse er blevet deaktiveret',0),(469891,13053,'ko','ì´ ë¶€ê°€ ê¸°ëŠ¥ ì‚¬ìš©ì´ ì¤‘ì§€ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(469892,13053,'he','×”×¨×—×‘×” ×–×• ×‘×•×˜×œ×”',0),(469893,13053,'el','Î¤Î¿ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î¿ Î­Ï‡ÎµÎ¹ Î±Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯',0),(469894,13053,'zh','æ­¤åŠ è½½é¡¹å·²è¢«ç¦ç”¨',0),(469895,13053,'sv','Detta tillÃ¤gg har inaktiverats',0),(469896,13053,'it','Questo componente aggiuntivo Ã¨ stato disattivato',0),(469897,13053,'tl','',0),(469898,13053,'th','à¹„à¸”à¹‰à¸–à¸¹à¸à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™ add-on à¸•à¸±à¸§à¸™à¸µà¹‰',0),(469899,13053,'hi','à¤‡à¤¸ à¤à¤¡-à¤‘à¤¨ à¤…à¤•à¥à¤·à¤® à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(469900,13053,'ms','Tambahan ini telah dinyahdayakan',0),(469901,13053,'ar','ØªÙ… ØªØ¹Ø·ÙŠÙ„ Ù‡Ø°Ù‡ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(469902,13053,'fr','Ce module a Ã©tÃ© dÃ©sactivÃ©',0),(469903,13053,'jp','ã“ã®ã‚¢ãƒ‰ã‚ªãƒ³ãŒç„¡åŠ¹ã«ãªã£ã¦ã„ã¾ã™ã€‚',0),(469904,13053,'pt','Este complemento foi desativado',0),(469905,13053,'ru','Ð­Ñ‚Ð¾ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð±Ñ‹Ð»Ð¾ Ð¾Ñ‚ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¾',0),(469906,13053,'es','Este Add-On Ha Sido Desconectado',0),(469907,13053,'de','Dieses Add-on wurde deaktiviert',0),(469908,13053,'en','This Add-On Has Been Disabled',0),(469909,13054,'is','',0),(469910,13054,'dr','Ø¯Ø± Ù‡Ø²Ø§Ø±Ø§Ù†',0),(469911,13054,'pr','Ø¯Ø± Ù‡Ø²Ø§Ø±Ø§Ù†',0),(469912,13054,'tr','Binlerce',0),(469913,13054,'pl','W tysiÄ…cach',0),(469914,13054,'bg','Ð’ Ñ…Ð¸Ð»ÑÐ´Ð¸',0),(469915,13054,'ur','ÛØ²Ø§Ø±ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù…ÛŒÚº',0),(469916,13054,'sr','Ð£ Ñ…Ð¸Ñ™Ð°Ð´Ð°Ð¼Ð°',0),(469917,13054,'vi','ngÃ n',0),(469918,13054,'af','In duisende',0),(469919,13054,'ro','ÃŽn mii',0),(469920,13054,'et','Tuhandetes',0),(469921,13054,'si','V tisoÄ',0),(469922,13054,'ba','Ribuan',0),(469923,13054,'nl','In duizendtallen',0),(469924,13054,'fi','Tuhansia',0),(469925,13054,'no','I tusenvis',0),(469926,13054,'da','I tusindvis',0),(469927,13054,'ko','ìˆ˜ì²œì—',0),(469928,13054,'he','×‘××œ×¤×™×',0),(469929,13054,'el','Î£Îµ Ï‡Î¹Î»Î¹Î¬Î´ÎµÏ‚',0),(469930,13054,'zh','ä»¥åƒè®¡',0),(469931,13054,'sv','I tusental',0),(469932,13054,'it','In migliaia',0),(469933,13054,'tl','',0),(469934,13054,'th','à¹ƒà¸™à¸«à¸¥à¸±à¸à¸žà¸±à¸™',0),(469935,13054,'hi','à¤¹à¤œà¤¾à¤°à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤®à¥‡à¤‚',0),(469936,13054,'ms','Dalam beribu-ribu',0),(469937,13054,'ar','Ø¨Ø§Ù„Ø¢Ù„Ø§Ù',0),(469938,13054,'fr','En milliers',0),(469939,13054,'jp','ä½•åƒã‚‚ã®',0),(469940,13054,'pt','Em milhares',0),(469941,13054,'ru','Ð’ Ñ‚Ñ‹ÑÑÑ‡Ð°Ñ…',0),(469942,13054,'es','En Miles',0),(469943,13054,'de','In tausend',0),(469944,13054,'en','In Thousands',0),(469945,13055,'is','',0),(469946,13055,'dr','Ø§Ú¯Ø± Ø¯Ø± Ú†Ù†Ø¯ Ø«Ø§Ù†ÛŒÙ‡  Ø¨Ø·ÙˆØ± Ø§ØªÙˆÙ…Ø§ØªÛŒÚ© Ø§Ø²ØµÙØ­Ù‡ Ø®Ø§Ø±Ø¬ Ù†Ø´Ø¯ÛŒØ¯ Ù„Ø·ÙØ§ Ø®Ø§Ø±Ø¬ Ø´ÙˆÛŒØ¯ Ùˆ Ø¨Ø±Ú¯Ø±Ø¯ÛŒØ¯',0),(469947,13055,'pr','Ø§Ú¯Ø± Ø¯Ø± Ú†Ù†Ø¯ Ø«Ø§Ù†ÛŒÙ‡  Ø¨Ø·ÙˆØ± Ø§ØªÙˆÙ…Ø§ØªÛŒÚ© Ø§Ø²ØµÙØ­Ù‡ Ø®Ø§Ø±Ø¬ Ù†Ø´Ø¯ÛŒØ¯ Ù„Ø·ÙØ§ Ø®Ø§Ø±Ø¬ Ø´ÙˆÛŒØ¯ Ùˆ Ø¨Ø±Ú¯Ø±Ø¯ÛŒØ¯',0),(469948,13055,'tr','Size otomatik olarak birkaÃ§ saniye iÃ§inde oturum aÃ§mamÄ±ÅŸ ise Ã§Ä±kÄ±ÅŸ ve tekrar.',0),(469949,13055,'pl','JeÅ›li jesteÅ› nie automatycznie zalogowany kilka sekund, proszÄ™ zalogowaÄ‡ i z powrotem.',0),(469950,13055,'bg','ÐÐºÐ¾ Ð½Ðµ ÑÑ‚Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð²Ð»ÐµÐ·Ð»Ð¸ ÑÐ»ÐµÐ´ Ð½ÑÐºÐ¾Ð»ÐºÐ¾ ÑÐµÐºÑƒÐ½Ð´Ð¸, Ð¼Ð¾Ð»Ñ, Ð²Ð»ÐµÐ·Ñ‚Ðµ Ð¸ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾.',0),(469951,13055,'ur','Ø¢Ù¾ Ø®ÙˆØ¯Ú©Ø§Ø± Ø·ÙˆØ± Ù¾Ø± Ú†Ù†Ø¯ Ø³ÛŒÚ©Ù†Úˆ Ù…ÛŒÚº Ù„Ø§Ú¯ Ø§Ù† ÛÛŒÚº Ù†Û ØªÙˆ Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù„Ø§Ú¯ Ø¢Ø¤Ù¹ Ø§ÙˆØ± ÙˆØ§Ù¾Ø³ Û”',0),(469952,13055,'sr','ÐÐºÐ¾ Ð½Ð¸ÑÑ‚Ðµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð¸ Ð·Ð° Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ ÑÐµÐºÑƒÐ½Ð´Ð¸, Ð¼Ð¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ Ð¸ Ñƒ.',0),(469953,13055,'vi','Náº¿u báº¡n khÃ´ng Ä‘Æ°á»£c Ä‘Äƒng nháº­p tá»± Ä‘á»™ng trong vÃ i giÃ¢y ná»¯a, xin vui lÃ²ng thoÃ¡t ra vÃ  vÃ o láº¡i',0),(469954,13055,'af','As jy is nie outomaties afgeteken in \'n paar sekondes, asseblief teken en terug.',0),(469955,13055,'ro','DacÄƒ nu sunteÅ£i automat conectat Ã®n cÃ¢teva secunde, vÄƒ rugÄƒm sÄƒ ieÅŸiÅ£i ÅŸi Ã®napoi Ã®n.',0),(469956,13055,'et','Kui sa ei ole logitakse automaatselt mÃµne sekundi, logige vÃ¤lja ja uuesti sisse.',0),(469957,13055,'si','ÄŒe niste samodejno prijavljeni v nekaj sekundah, prosim odjaviti in nazaj.',0),(469958,13055,'ba','Jika Anda tidak secara otomatis masuk dalam beberapa detik, silahkan logout dan kembali.',0),(469959,13055,'nl','Als u niet automatisch ingelogd bent uit in een paar seconden, log uit en weer in.',0),(469960,13055,'fi','Jos et ole automaattisesti kirjautunut muutamassa sekunnissa, kirjaudu ulos ja takaisin.',0),(469961,13055,'no','Hvis du ikke er automatisk logget i noen sekunder, vennligst logg ut og tilbake i.',0),(469962,13055,'da','Hvis du ikke er automatisk logget i et par sekunder, skal du logge og tilbage i.',0),(469963,13055,'ko','ë¡œê·¸ì¸ í•˜ì§€ ì•Šì€ ê²½ìš° ìžë™ìœ¼ë¡œ ë°–ìœ¼ë¡œ ëª‡ ì´ˆ ì•ˆì—, ë¡œê·¸ ì•„ì›ƒ í•˜ ê³  ë‹¤ì‹œ í•˜ì‹­ì‹œì˜¤.',0),(469964,13055,'he','×× ××ª×” ×œ× ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™ ×ž×—×•×‘×¨ ×‘×¢×•×“ ×›×ž×” ×©× ×™×•×ª, ×‘×‘×§×©×” ×”×ª× ×ª×§, ×—×–×¨×” ×¤× ×™×ž×”.',0),(469965,13055,'el','Î‘Î½ Î´ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î± ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯ ÏƒÎµ Î¼ÎµÏÎ¹ÎºÎ¬ Î´ÎµÏ…Ï„ÎµÏÏŒÎ»ÎµÏ€Ï„Î±, Ï€Î±ÏÎ±ÎºÎ±Î»ÏŽ Î±Ï€Î¿ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ ÎºÎ±Î¹ Ï€Î¯ÏƒÏ‰ ÏƒÏ„Î¿.',0),(469966,13055,'zh','å¦‚æžœæ‚¨ä¸è‡ªåŠ¨ç™»å½•å‡ ç§’é’ŸåŽï¼Œè¯·é€€å‡ºå¹¶é‡æ–°ç™»å½•çš„ã€‚',0),(469967,13055,'sv','Om du inte Ã¤r automatiskt inloggad i nÃ¥gra sekunder, vÃ¤nligen logga ut och tillbaka.',0),(469968,13055,'it','Se non sono connesso automaticamente in pochi secondi, esci ed indietro nel.',0),(469969,13055,'tl','',0),(469970,13055,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¹„à¸§à¹‰à¸­à¸­à¸à¹ƒà¸™à¹„à¸¡à¹ˆà¸à¸µà¹ˆà¸§à¸´à¸™à¸²à¸—à¸µ à¸à¸£à¸¸à¸“à¸²à¸­à¸­à¸à¸ˆà¸²à¸à¸£à¸°à¸šà¸š à¹à¸¥à¸°à¸à¸¥à¸±à¸š',0),(469971,13055,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤•à¥à¤› à¤¹à¥€ à¤¸à¥‡à¤•à¤‚à¤¡ à¤®à¥‡à¤‚ à¤²à¥‰à¤— à¤‡à¤¨ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ, à¤•à¥ƒà¤ªà¤¯à¤¾ à¤²à¥‰à¤— à¤†à¤‰à¤Ÿ à¤”à¤° à¤µà¤¾à¤ªà¤¸ à¤®à¥‡à¤‚à¥¤',0),(469972,13055,'ms','Jika anda tidak secara automatik log dalam beberapa saat, sila log dan kembali dalam.',0),(469973,13055,'ar','Ø¥Ø°Ø§ Ù„Ù… ØªÙ‚Ù… ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨ØªØ³Ø¬ÙŠÙ„ ÙÙŠ Ø¨Ø¶Ø¹ Ø«ÙˆØ§Ù†ØŒ Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø®Ø±ÙˆØ¬ ÙˆØ§Ù„Ø¹ÙˆØ¯Ø© ÙÙŠ.',0),(469974,13055,'fr','Si vous n\'Ãªtes pas automatiquement dÃ©connectÃ© en quelques secondes, veuillez fermer la session et de retour en.',0),(469975,13055,'jp','è‡ªå‹•çš„ã«æ•°ç§’ã§ãƒ­ã‚°ã‚¢ã‚¦ãƒˆã—ã¦ã„ãªã„å ´åˆã¯ã€ãƒ­ã‚°ã‚¢ã‚¦ãƒˆã®å‰å¾Œã€‚',0),(469976,13055,'pt','Se vocÃª nÃ£o estÃ¡ automaticamente conectado em poucos segundos, por favor, efetue logout e voltar.',0),(469977,13055,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ð½Ðµ Ð·Ð°Ð»Ð¾Ð³Ð¸Ð½ÐµÐ½Ñ‹ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ñ‡ÐµÑ€ÐµÐ· Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ ÑÐµÐºÑƒÐ½Ð´, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð¹Ñ‚Ð¸ Ð¸ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾ Ð².',0),(469978,13055,'es','Si no ha salido automaticamente en unos segundos Log Out y entra otra vez',0),(469979,13055,'de','Wenn Sie nicht automatisch in wenigen Sekunden abgemeldet sind, bitte melden Sie ab und wieder rein.',0),(469980,13055,'en','If you are not automatically logged out in a few seconds, please log out and back in.',0),(469981,13056,'is','',0),(469982,13056,'dr','Ù‡ÛŒÚ† ØªÙ†Ø¸ÛŒÙ…ÛŒ Ø¯Ø± Ø§ÛŒÙ† Ù†Ø§Ø­ÛŒÙ‡',0),(469983,13056,'pr','Ù‡ÛŒÚ† ØªÙ†Ø¸ÛŒÙ…ÛŒ Ø¯Ø± Ø§ÛŒÙ† Ù†Ø§Ø­ÛŒÙ‡',0),(469984,13056,'tr','Bu alanda hiÃ§bir kurulum',0),(469985,13056,'pl','Nie ustawienia w tym obszarze',0),(469986,13056,'bg','ÐÑÐ¼Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð² Ñ‚Ð°Ð·Ð¸ Ð¾Ð±Ð»Ð°ÑÑ‚',0),(469987,13056,'ur','Ø§Ø³ Ø¹Ù„Ø§Ù‚Û’ Ù…ÛŒÚº Ú©ÙˆØ¦ÛŒ Ø³ÛŒÙ¹ Ø§Ù¾',0),(469988,13056,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐ° Ñƒ Ð¾Ð²Ð¾Ñ˜ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(469989,13056,'vi','khÃ´ng thiáº¿t láº­p cho khu nÃ y',0),(469990,13056,'af','Geen opstelling in hierdie gebied',0),(469991,13056,'ro','Nici o instalare Ã®n acest domeniu',0),(469992,13056,'et','Ãœkski Setup selles valdkonnas',0),(469993,13056,'si','Namestitev ni na tem podroÄju',0),(469994,13056,'ba','Tidak ada Setup di daerah ini',0),(469995,13056,'nl','Geen Setup op dit gebied',0),(469996,13056,'fi','Ei Setup tÃ¤llÃ¤ alalla',0),(469997,13056,'no','Ingen installasjon pÃ¥ dette omrÃ¥det',0),(469998,13056,'da','Ingen opsÃ¦tning i dette omrÃ¥de',0),(469999,13056,'ko','ì´ ì§€ì—­ì— ìžˆëŠ” ì•„ë¬´ ì„¤ì •',0),(470000,13056,'he','×ž×œ×›×•×“×ª ×‘××–×•×¨ ×”×–×”',0),(470001,13056,'el','Î”ÎµÎ½ Setup ÏƒÎµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï„Î¿Î¼Î­Î±',0),(470002,13056,'zh','åœ¨è¿™ä¸€é¢†åŸŸæ²¡æœ‰å®‰è£…',0),(470003,13056,'sv','Ingen installation pÃ¥ detta omrÃ¥de',0),(470004,13056,'it','Nessuna installazione in quest\'Area',0),(470005,13056,'tl','',0),(470006,13056,'th','à¹„à¸¡à¹ˆà¸•à¸´à¸”à¸•à¸±à¹‰à¸‡à¹ƒà¸™à¸žà¸·à¹‰à¸™à¸—à¸µà¹ˆà¸™à¸µà¹‰',0),(470007,13056,'hi','à¤‡à¤¸ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤®à¥‡à¤‚ à¤•à¥‹à¤ˆ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(470008,13056,'ms','Persediaan tiada di kawasan ini',0),(470009,13056,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø¨Ø±Ù†Ø§Ù…Ø¬ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù…Ø¬Ø§Ù„',0),(470010,13056,'fr','Pas de configuration dans ce domaine',0),(470011,13056,'jp','ã“ã®é ˜åŸŸã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(470012,13056,'pt','Nenhuma configuraÃ§Ã£o nesta Ã¡rea',0),(470013,13056,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð½Ðµ Ð² ÑÑ‚Ð¾Ð¹ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(470014,13056,'es','No ConfiguraciÃ³n en Esta Area',0),(470015,13056,'de','Kein Setup in diesem Bereich',0),(470016,13056,'en','No Setup in this Area',0),(470017,13057,'is','',0),(470018,13057,'dr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÛŒ ØµÙØ­Ù‡ ',0),(470019,13057,'pr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÛŒ ØµÙØ­Ù‡ ',0),(470020,13057,'tr','Sayfa numaralarÄ±nÄ± gizle',0),(470021,13057,'pl','Ukryj numery stron',0),(470022,13057,'bg','Ð¡ÐºÑ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(470023,13057,'ur','ØµÙØ­Û Ù†Ù…Ø¨Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(470024,13057,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(470025,13057,'vi','Giáº¥u cÃ¡c sá»‘ trang',0),(470026,13057,'af','Versteek bladsynommers',0),(470027,13057,'ro','Ascunde numere de paginÄƒ',0),(470028,13057,'et','Peida lehekÃ¼ljenumbrid',0),(470029,13057,'si','Skrije Å¡tevilke strani',0),(470030,13057,'ba','Menyembunyikan nomor halaman',0),(470031,13057,'nl','Verbergen van paginanummers',0),(470032,13057,'fi','Piilota sivunumerot',0),(470033,13057,'no','Skjule sidetall',0),(470034,13057,'da','Skjul sidetal',0),(470035,13057,'ko','íŽ˜ì´ì§€ ë²ˆí˜¸ ìˆ¨ê¸°ê¸°',0),(470036,13057,'he','×”×¡×ª×¨ ×ž×¡×¤×¨×™ ×¢×ž×•×“×™×',0),(470037,13057,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î±ÏÎ¹Î¸Î¼ÏŽÎ½ ÏƒÎµÎ»Î¯Î´Î±Ï‚',0),(470038,13057,'zh','éšè—é¡µç ',0),(470039,13057,'sv','DÃ¶lja sidnumren',0),(470040,13057,'it','Nascondere i numeri di pagina',0),(470041,13057,'tl','',0),(470042,13057,'th','à¸‹à¹ˆà¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸«à¸™à¹‰à¸²',0),(470043,13057,'hi','à¤ªà¥ƒà¤·à¥à¤  à¤•à¥à¤°à¤®à¤¾à¤‚à¤•à¥‹à¤‚ à¤•à¥‹ à¤›à¤¿à¤ªà¤¾à¤¨à¥‡',0),(470044,13057,'ms','Sembunyikan nombor',0),(470045,13057,'ar','Ø¥Ø®ÙØ§Ø¡ Ø£Ø±Ù‚Ø§Ù… Ø§Ù„ØµÙØ­Ø§Øª',0),(470046,13057,'fr','Masquer les numÃ©ros de Page',0),(470047,13057,'jp','ãƒšãƒ¼ã‚¸ç•ªå·ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(470048,13057,'pt','Ocultar nÃºmeros de pÃ¡gina',0),(470049,13057,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†',0),(470050,13057,'es','Esconde NÃºmeros de PÃ¡ginas',0),(470051,13057,'de','Seitenzahlen ausblenden',0),(470052,13057,'en','Hide Page Numbers',0),(470053,13058,'is','',0),(470054,13058,'dr','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¶Ø§ÙÙ‡ Ø§ÛŒ Ù†Ù…Ø§ÛŒØ´ Ø¯Ø§Ø¯Ù‡ Ù†Ø´ÙˆØ¯',0),(470055,13058,'pr','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¶Ø§ÙÙ‡ Ø§ÛŒ Ù†Ù…Ø§ÛŒØ´ Ø¯Ø§Ø¯Ù‡ Ù†Ø´ÙˆØ¯',0),(470056,13058,'tr','GÃ¶rÃ¼ntÃ¼lenen hiÃ§bir ekstra miktar',0),(470057,13058,'pl','Nie dodatkowÄ… iloÅ›Ä‡ wyÅ›wietlane',0),(470058,13058,'bg','ÐÑÐ¼Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚',0),(470059,13058,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø¶Ø§ÙÛŒ Ù‚ÛŒ Ø¯Ú©Ú¾Ø§Ø¦Û’',0),(470060,13058,'sr','ÐÐµÐ¼Ð° ÐµÐºÑÑ‚Ñ€Ð° ÐšÐ¾Ð» Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½Ð°',0),(470061,13058,'vi','khÃ´ng thÃªm sá»‘ lÆ°á»£ng Ä‘Æ°á»£c hiá»ƒn thá»‹',0),(470062,13058,'af','Geen ekstra Qty vertoon',0),(470063,13058,'ro','Nici o cantitate suplimentare afisate',0),(470064,13058,'et','Mingit ekstra kogus kuvatakse',0),(470065,13058,'si','Brez dodatnih koliÄina, prikazani',0),(470066,13058,'ba','Tidak ada Qty tambahan yang ditampilkan',0),(470067,13058,'nl','Geen Extra aantal weergegeven',0),(470068,13058,'fi','Ei ylimÃ¤Ã¤rÃ¤inen mÃ¤Ã¤rÃ¤ nÃ¤kyy',0),(470069,13058,'no','Ingen ekstra antall vises',0),(470070,13058,'da','Ingen ekstra antal vises',0),(470071,13058,'ko','ì•„ë‹ˆ ì¶”ê°€ ìˆ˜ëŸ‰ í‘œì‹œ',0),(470072,13058,'he','××™×Ÿ ×›×ž×•×ª × ×•×¡×¤×ª ×”×ž×•×¦×’×ª',0),(470073,13058,'el','ÎšÎ±Î¼Î¯Î± ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Qty ÎµÎ¼Ï†Î±Î½Î¯Î¶ÎµÏ„Î±Î¹',0),(470074,13058,'zh','æ²¡æœ‰é¢å¤–çš„æ•°é‡æ˜¾ç¤º',0),(470075,13058,'sv','Ingen Extra kvantitet visas',0),(470076,13058,'it','Nessun Extra Qty visualizzato',0),(470077,13058,'tl','',0),(470078,13058,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹„à¸¡à¹ˆà¹€à¸à¸´à¸™à¸—à¸µà¹ˆà¹à¸ªà¸”à¸‡',0),(470079,13058,'hi','à¤•à¥‹à¤ˆ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤',0),(470080,13058,'ms','Tiada Qty tambahan yang dipaparkan',0),(470081,13058,'ar','Ù„Ø§ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ© Ø§Ù„Ù…Ø¹Ø±ÙˆØ¶Ø©',0),(470082,13058,'fr','Aucune quantitÃ© supplÃ©mentaire affichÃ©e',0),(470083,13058,'jp','ãªã„ä½™åˆ†ãªæ•°é‡ã‚’è¡¨ç¤º',0),(470084,13058,'pt','Nenhum Extra Qty exibido',0),(470085,13058,'ru','Ð‘ÐµÐ· Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Qty Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°ÑŽÑ‚ÑÑ',0),(470086,13058,'es','No Desplga Cantidad Extra',0),(470087,13058,'de','Keine zusÃ¤tzlichen Qty angezeigt',0),(470088,13058,'en','No Extra Qty Displayed',0),(470089,13059,'is','',0),(470090,13059,'dr','Ù†Ù…Ø§ÛŒØ´ Ø®Ø· Ø§Ù…Ø¶Ø§ Ø®Ø±ÛŒØ¯Ø§Ø±',0),(470091,13059,'pr','Ù†Ù…Ø§ÛŒØ´ Ø®Ø· Ø§Ù…Ø¶Ø§ Ø®Ø±ÛŒØ¯Ø§Ø±',0),(470092,13059,'tr','MÃ¼ÅŸteri imza satÄ±rÄ±nÄ± gÃ¶ster',0),(470093,13059,'pl','PokaÅ¼ wiersz podpisu klienta',0),(470094,13059,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´ Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð¸Ñ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(470095,13059,'ur','Ú©Ø³Ù¹Ù…Ø± Ø¯Ø³ØªØ®Ø· Ù„Ø§Ø¦Ù† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(470096,13059,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ñ‚Ð¿Ð¸Ñ ÐºÑƒÐ¿Ñ†Ð°',0),(470097,13059,'vi','Thá»ƒ hiá»‡n dÃ²ng chá»¯ kÃ½ cá»§a khÃ¡ch hÃ ng',0),(470098,13059,'af','KliÃ«nt handtekening lyn wys',0),(470099,13059,'ro','AratÄƒ linia de semnÄƒturÄƒ client',0),(470100,13059,'et','NÃ¤ita kliendi allkirjarida',0),(470101,13059,'si','PokaÅ¾i Ärto podpis kupca',0),(470102,13059,'ba','Menunjukkan garis tanda tangan nasabah',0),(470103,13059,'nl','Klant handtekeningregel weergeven',0),(470104,13059,'fi','NÃ¤ytÃ¤ asiakkaan allekirjoituksen rivi',0),(470105,13059,'no','Vis kunde signaturlinje',0),(470106,13059,'da','Vis kunde signaturlinje',0),(470107,13059,'ko','ê³ ê° ì„œëª… ë¼ì¸ í‘œì‹œ',0),(470108,13059,'he','×”×¦×’ ×©×•×¨×ª ×”×—×ª×™×ž×” ×©×œ ×”×œ×§×•×—',0),(470109,13059,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î³ÏÎ±Î¼Î¼Î® Ï…Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(470110,13059,'zh','æ˜¾ç¤ºå®¢æˆ·ç­¾åè¡Œ',0),(470111,13059,'sv','Visa kund signatur linje',0),(470112,13059,'it','Visualizza la riga della firma cliente',0),(470113,13059,'tl','',0),(470114,13059,'th','à¹à¸ªà¸”à¸‡à¸šà¸£à¸£à¸—à¸±à¸”à¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(470115,13059,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(470116,13059,'ms','Menunjukkan talian tandatangan pelanggan',0),(470117,13059,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø³Ø·Ø± ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(470118,13059,'fr','Voir la ligne de Signature client',0),(470119,13059,'jp','é¡§å®¢ã®ç½²åæ¬„ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(470120,13059,'pt','Mostrar a linha de assinatura do cliente',0),(470121,13059,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾ÐºÑƒ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(470122,13059,'es','Muestra Linea de Firma de Cliente',0),(470123,13059,'de','Kunden-Signaturzeile anzeigen',0),(470124,13059,'en','Show Customer Signature Line',0),(470125,13060,'is','',0),(470126,13060,'dr','Ù†Ù…Ø§ÛŒØ´ ØªØ®ÙÛŒÙØ§Øª Ø¯Ø± ÙØ±Ù…',0),(470127,13060,'pr','Ù†Ù…Ø§ÛŒØ´ ØªØ®ÙÛŒÙØ§Øª Ø¯Ø± ÙØ±Ù…',0),(470128,13060,'tr','Ä°ndirimler formda gÃ¶ster',0),(470129,13060,'pl','PokaÅ¼ zniÅ¼ki na formie',0),(470130,13060,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ð½Ð° Ñ„Ð¾Ñ€Ð¼ÑƒÐ»ÑÑ€',0),(470131,13060,'ur','Ø¢Ø®Ø± Ù…ÛŒÚº Ú†Ú¾ÙˆÙ¹ Ú©Û’ ÙØ§Ø±Ù… Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(470132,13060,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ðµ Ð½Ð° Ð¾Ð±Ñ€Ð°ÑÑ†Ñƒ',0),(470133,13060,'vi','Thá»ƒ hiá»‡n chiáº¿t kháº¥u trÃªn máº«u',0),(470134,13060,'af','Wys afslag op vorm',0),(470135,13060,'ro','AratÄƒ reduceri pe formular',0),(470136,13060,'et','NÃ¤ita hinnaalandite vorm',0),(470137,13060,'si','Prikaz popustov na obrazcu',0),(470138,13060,'ba','Lihat diskon formulir',0),(470139,13060,'nl','Toon kortingen op formulier',0),(470140,13060,'fi','NÃ¤ytÃ¤ alennukset-lomakkeessa',0),(470141,13060,'no','Vis rabatter pÃ¥ skjemaet',0),(470142,13060,'da','Vis rabatter pÃ¥ Form',0),(470143,13060,'ko','ì–‘ì‹ì— ë³´ê¸° í• ì¸',0),(470144,13060,'he','×”× ×—×•×ª ×”×¦×’ ×˜×•×¤×¡',0),(470145,13060,'el','Î•ÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï†ÏŒÏÎ¼Î±Ï‚',0),(470146,13060,'zh','åœ¨è¡¨å•ä¸Šæ˜¾ç¤ºæŠ˜æ‰£',0),(470147,13060,'sv','Visa rabatter pÃ¥ Form',0),(470148,13060,'it','Visualizza sconti sulla forma',0),(470149,13060,'tl','',0),(470150,13060,'th','à¹à¸ªà¸”à¸‡à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¹ƒà¸™à¹à¸šà¸šà¸Ÿà¸­à¸£à¹Œà¸¡',0),(470151,13060,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤›à¥‚à¤Ÿ',0),(470152,13060,'ms','Menunjukkan diskaun di borang',0),(470153,13060,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø®ØµÙˆÙ…Ø§Øª Ø¹Ù„Ù‰ Ø§Ù„Ù†Ù…ÙˆØ°Ø¬',0),(470154,13060,'fr','Voir la remises sur formulaire',0),(470155,13060,'jp','ãƒ•ã‚©ãƒ¼ãƒ ã«å‰²å¼•ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(470156,13060,'pt','Mostrar descontos no formulÃ¡rio',0),(470157,13060,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÐºÐ¸Ð´ÐºÐ¸ Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ðµ',0),(470158,13060,'es','Muestra Descuentos en La Forma',0),(470159,13060,'de','ERMÃ„SSIGUNGEN auf Formular anzeigen',0),(470160,13060,'en','Show Discounts On Form',0),(470161,13061,'is','',0),(470162,13061,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¢Ø®Ø± ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¯Ø± ÙØ§Ú©ØªÙˆØ± Ø§ØµÙ„ÛŒ',0),(470163,13061,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¢Ø®Ø± ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¯Ø± ÙØ§Ú©ØªÙˆØ± Ø§ØµÙ„ÛŒ',0),(470164,13061,'tr','Ana faturada show son notlar',0),(470165,13061,'pl','PokaÅ¼ koniec notatki na gÅ‚Ã³wnym faktury',0),(470166,13061,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÑ€Ð°Ð¹ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ð½Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(470167,13061,'ur','Ø§Ø®ØªØªØ§Ù…ÛŒ Ù†ÙˆÙ¹ Ù…ÛŒÙ† Ú©Û’ Ø¨Ù„ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(470168,13061,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐºÑ€Ð°Ñ˜ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð½Ð° Ð³Ð»Ð°Ð²Ð½Ð¾Ð¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(470169,13061,'vi','Thá»ƒ hiá»‡n nhá»¯ng lÆ°u Ã½ cuá»‘i cÃ¹ng trÃªn hÃ³a Ä‘Æ¡n chÃ­nh',0),(470170,13061,'af','Einde notas op die belangrikste faktuur wys',0),(470171,13061,'ro','AratÄƒ Note de final principal facturÄƒ',0),(470172,13061,'et','NÃ¤ita End mÃ¤rgib peamine arvel',0),(470173,13061,'si','Show konec opombe na glavni raÄuna',0),(470174,13061,'ba','Lihat catatan akhir utama faktur',0),(470175,13061,'nl','Eindnoten Toon op belangrijkste factuur',0),(470176,13061,'fi','NÃ¤ytÃ¤ hotelli lopussa toteaa tÃ¤rkein laskussa',0),(470177,13061,'no','Vis fotnoter pÃ¥ hoved faktura',0),(470178,13061,'da','Vis slutningen noter pÃ¥ vigtigste faktura',0),(470179,13061,'ko','ì£¼ ì†¡ìž¥ì— ìµœì¢… ë…¸íŠ¸ ë³´ê¸°',0),(470180,13061,'he','×”×¦×’ ×”×¢×¨×•×ª ×¡×™×•× ×¢×œ ×—×©×‘×•× ×™×ª ×”×¨××©×™',0),(470181,13061,'el','Show Î£Î—ÎœÎ•Î™Î©Î£Î•Î™Î£ Ï„Î­Î»Î¿Ï‚ ÎºÏÏÎ¹Î¿ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(470182,13061,'zh','ä¸»è¦çš„å‘ç¥¨ä¸Šæ˜¾ç¤ºç»“æŸæ³¨é‡Š',0),(470183,13061,'sv','Visa slutet anteckningar pÃ¥ huvudsakliga faktura',0),(470184,13061,'it','Visualizza note finali sulla fattura principale',0),(470185,13061,'tl','',0),(470186,13061,'th','à¹à¸ªà¸”à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸«à¸¥à¸±à¸',0),(470187,13061,'hi','à¤…à¤‚à¤¤ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¦à¤¿à¤–à¤¾à¤à¤ à¤ªà¤° à¤®à¥à¤–à¥à¤¯ à¤šà¤¾à¤²à¤¾à¤¨',0),(470188,13061,'ms','Menunjukkan Nota-Nota akhir pada invois yang utama',0),(470189,13061,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠ',0),(470190,13061,'fr','Montrer les Notes de fin sur facture principale',0),(470191,13061,'jp','ä¸»ãªè«‹æ±‚æ›¸ã«æ–‡æœ«è„šæ³¨ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(470192,13061,'pt','Mostrar notas de fim no principal factura',0),(470193,13061,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾Ñ‚Ð¼ÐµÑ‡Ð°ÐµÑ‚ ÐºÐ¾Ð½ÐµÑ† Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ ÑÑ‡ÐµÑ‚',0),(470194,13061,'es','Muestra Notas Finales en La Factura Principal',0),(470195,13061,'de','Ende Hinweise auf wesentliche Rechnung anzeigen',0),(470196,13061,'en','Show End Notes On Main Invoice',0),(470197,13062,'is','',0),(470198,13062,'dr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ Ø²ÛŒØ± Ø´Ù…Ø§Ø±Ù‡ ØµÙØ­Ù‡ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(470199,13062,'pr','Ù…ØªÙ† Ø¨Ø±Ø§ÛŒ Ø²ÛŒØ± Ø´Ù…Ø§Ø±Ù‡ ØµÙØ­Ù‡ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(470200,13062,'tr','Metin iÃ§in deyim sayfa numarasÄ± altÄ±nda',0),(470201,13062,'pl','Tekst pod numer strony instrukcja',0),(470202,13062,'bg','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Ð¿Ð¾Ð´ Ð´ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(470203,13062,'ur','Ú©Û’ Ù„ÛŒÛ’ Ù…ØªÙ† Ú©Ø§ Ø¨ÛŒØ§Ù† ØµÙØ­Û Ù†Ù…Ø¨Ø± Ú©Û’ ØªØ­Øª',0),(470204,13062,'sr','Ð¢ÐµÐºÑÑ‚ Ð·Ð° Ð¿Ð¾Ð´ Ð¸Ð·Ñ˜Ð°Ð²Ð° Ð±Ñ€Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(470205,13062,'vi','VÄƒn báº£n cho theo tuyÃªn bá»‘ trang sá»‘',0),(470206,13062,'af','Teks vir onder stelling bladsy nommer',0),(470207,13062,'ro','Textul de sub numÄƒrul de paginÄƒ declaraÅ£ie',0),(470208,13062,'et','Teksti alusel avalduse lehekÃ¼ljenumber',0),(470209,13062,'si','Besedilo za pod Å¡tevilko strani izjavo',0),(470210,13062,'ba','Teks untuk nomor halaman pernyataan',0),(470211,13062,'nl','Tekst voor onder verklaring paginanummer',0),(470212,13062,'fi','Tekstin mukaan ilmoitus sivun numero',0),(470213,13062,'no','Teksten Under uttalelse sidetall',0),(470214,13062,'da','Tekst til Under erklÃ¦ring sidetal',0),(470215,13062,'ko','ë¬¸ íŽ˜ì´ì§€ ë²ˆí˜¸ì— ëŒ€ í•œ í…ìŠ¤íŠ¸',0),(470216,13062,'he','×˜×§×¡×˜ ×¢×‘×•×¨ ×ª×—×ª ×ž×¡×¤×¨ ×”×¢×ž×•×“ ×”×¦×”×¨×”',0),(470217,13062,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Î³Î¹Î± ÏƒÏÎ¼Ï†Ï‰Î½Î± Î¼Îµ Ï„Î· Î´Î®Î»Ï‰ÏƒÎ· Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÏƒÎµÎ»Î¯Î´Î±Ï‚',0),(470218,13062,'zh','æ ¹æ®å£°æ˜Žé¡µç¼–å·çš„æ–‡æœ¬',0),(470219,13062,'sv','Text fÃ¶r Under uttalande sidnummer',0),(470220,13062,'it','Testo per sotto istruzione numero di pagina',0),(470221,13062,'tl','',0),(470222,13062,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸ à¸²à¸¢à¹ƒà¸•à¹‰à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸«à¸™à¹‰à¸²à¸‚à¸­à¸‡à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(470223,13062,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤ªà¥ƒà¤·à¥à¤  à¤•à¥à¤°à¤®à¤¾à¤‚à¤• à¤•à¥‡ à¤¤à¤¹à¤¤ à¤ªà¤¾à¤  à¤•à¥‡ à¤²à¤¿à¤',0),(470224,13062,'ms','Teks untuk di bawah nombor halaman penyata',0),(470225,13062,'ar','Ø§Ù„Ù†Øµ Ù„ØªØ­Øª Ø±Ù‚Ù… ØµÙØ­Ø© Ø§Ù„Ø¨ÙŠØ§Ù†',0),(470226,13062,'fr','Texte pour sous le numÃ©ro de Page de dÃ©claration',0),(470227,13062,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã®ãƒšãƒ¼ã‚¸ç•ªå·ã®ä¸‹ã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(470228,13062,'pt','Texto para sob o nÃºmero de pÃ¡gina de instruÃ§Ã£o',0),(470229,13062,'ru','Ð¢ÐµÐºÑÑ‚ Ð´Ð»Ñ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹',0),(470230,13062,'es','NÃºmero de PÃ¡gina de Texto Para Frase Abajo',0),(470231,13062,'de','Text fÃ¼r unter Anweisung Seitenzahl',0),(470232,13062,'en','Text For Under Statement Page Number',0),(470233,13063,'is','',0),(470234,13063,'dr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÛŒ',0),(470235,13063,'pr','Ø¯Ø±ØµØ¯ Ù…Ø§Ù„ÛŒ',0),(470236,13063,'tr','Ekonomi yÃ¼zde',0),(470237,13063,'pl','Procent finansÃ³w',0),(470238,13063,'bg','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(470239,13063,'ur','Ø®Ø²Ø§Ù†Û ÙÛŒØµØ¯',0),(470240,13063,'sr','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¸Ñ˜Ð° Ð¿Ð¾ÑÑ‚Ð¾',0),(470241,13063,'vi','pháº§n trÄƒm tÃ i chÃ­nh',0),(470242,13063,'af','Finansies persent',0),(470243,13063,'ro','FinanÅ£elor la sutÄƒ',0),(470244,13063,'et','Finance protsenti',0),(470245,13063,'si','Finance odstotkov',0),(470246,13063,'ba','Keuangan persen',0),(470247,13063,'nl','FinanciÃ«n procent',0),(470248,13063,'fi','Rahoituksen prosenttia',0),(470249,13063,'no','Finans prosent',0),(470250,13063,'da','Finance procent',0),(470251,13063,'ko','ê¸ˆìœµ %',0),(470252,13063,'he','××—×•×– ×ž×™×ž×•×Ÿ',0),(470253,13063,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï‡ÏÎ·Î¼Î±Ï„Î¿Î´ÏŒÏ„Î·ÏƒÎ·Ï‚',0),(470254,13063,'zh','é‡‘èž %',0),(470255,13063,'sv','Finans procent',0),(470256,13063,'it','Per cento delle finanze',0),(470257,13063,'tl','',0),(470258,13063,'th','à¹€à¸‡à¸´à¸™à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œ',0),(470259,13063,'hi','à¤µà¤¿à¤¤à¥à¤¤ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(470260,13063,'ms','Kewangan peratus',0),(470261,13063,'ar','Ø§Ù„Ù…Ø§Ù„ÙŠØ© ÙÙŠ Ø§Ù„Ù…Ø§Ø¦Ø©',0),(470262,13063,'fr','Finances pour cent',0),(470263,13063,'jp','é‡‘èžãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ',0),(470264,13063,'pt','Por cento de finanÃ§as',0),(470265,13063,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(470266,13063,'es','Financiar Porcentaje',0),(470267,13063,'de','Finanzen-Prozent',0),(470268,13063,'en','Finance Percent',0),(470269,13064,'is','',0),(470270,13064,'dr','Ø¯ÙØªØ± Ú©Ù„ Ø¨Ø±Ø§ÛŒ ÙÛŒ',0),(470271,13064,'pr','Ø¯ÙØªØ± Ú©Ù„ Ø¨Ø±Ø§ÛŒ ÙÛŒ',0),(470272,13064,'tr','GL iÃ§in Ã¼cret',0),(470273,13064,'pl','GL za opÅ‚atÄ…',0),(470274,13064,'bg','GL Ð·Ð° Ñ‚Ð°ÐºÑÐ°',0),(470275,13064,'ur','Ø¬ÛŒØ¬Û’ ÙÛŒØ³ Ú©Û’ Ù„Ø¦Û’ Ú©Û’',0),(470276,13064,'sr','Ð“Ð› ÑƒÐ· Ð½Ð°ÐºÐ½Ð°Ð´Ñƒ',0),(470277,13064,'vi','Sá»• cÃ¡i cho phÃ­',0),(470278,13064,'af','GL vir fooi',0),(470279,13064,'ro','GL contra cost',0),(470280,13064,'et','GL eest',0),(470281,13064,'si','GL za plaÄilo',0),(470282,13064,'ba','GL biaya',0),(470283,13064,'nl','GL voor vergoeding',0),(470284,13064,'fi','GL vastaan',0),(470285,13064,'no','GL mot',0),(470286,13064,'da','GL mod gebyr',0),(470287,13064,'ko','ìˆ˜ìˆ˜ë£Œì— ëŒ€ í•œ GL',0),(470288,13064,'he','GL ×ª×ž×•×¨×ª ×ª×©×œ×•×',0),(470289,13064,'el','GL Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(470290,13064,'zh','GL è´¹',0),(470291,13064,'sv','GL fÃ¶r avgift',0),(470292,13064,'it','GL per tassa',0),(470293,13064,'tl','',0),(470294,13064,'th','GL à¸ªà¸³à¸«à¸£à¸±à¸šà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(470295,13064,'hi','à¤œà¥€à¤à¤² à¤¶à¥à¤²à¥à¤• à¤•à¥‡ à¤²à¤¿à¤',0),(470296,13064,'ms','GL bayaran',0),(470297,13064,'ar','GL Ù„Ù„Ø±Ø³ÙˆÙ…',0),(470298,13064,'fr','GL pour le frais',0),(470299,13064,'jp','æ–™é‡‘ã®ãŸã‚ã® GL',0),(470300,13064,'pt','GL por taxa',0),(470301,13064,'ru','GL Ð·Ð° Ð¿Ð»Ð°Ñ‚Ñƒ',0),(470302,13064,'es','LM para Cuota',0),(470303,13064,'de','GL gegen GebÃ¼hr',0),(470304,13064,'en','GL For Fee',0),(470305,13065,'is','',0),(470306,13065,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„ Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† ÙÛŒ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(470307,13065,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„ Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† ÙÛŒ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(470308,13065,'tr','Ãœcretini GL hesabÄ± girmeniz gerekir.',0),(470309,13065,'pl','NaleÅ¼y wprowadziÄ‡ konto GL za opÅ‚atÄ….',0),(470310,13065,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ð° GL Ð·Ð° Ñ‚Ð°ÐºÑÐ°Ñ‚Ð°.',0),(470311,13065,'ur','Ø¢Ù¾ Ú©ÛŒ ÙÛŒØ³ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(470312,13065,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ñ€Ð°Ñ‡ÑƒÐ½ Ñƒ Ð“Ð› Ð·Ð° Ñ…Ð¾Ð½Ð¾Ñ€Ð°Ñ€.',0),(470313,13065,'vi','Báº¡n pháº£i nháº­p má»™t tÃ i khoáº£n GL cho chi phÃ­',0),(470314,13065,'af','U moet \'n AG rekening vir die fooi invoer.',0),(470315,13065,'ro','Trebuie sÄƒ introduceÅ£i un cont GL pentru taxa.',0),(470316,13065,'et','Sisestage GL konto tasu.',0),(470317,13065,'si','Vnesti morate GL raÄun za plaÄilo.',0),(470318,13065,'ba','Anda harus memasukkan rekening GL untuk biaya.',0),(470319,13065,'nl','U moet een GL-account invoeren voor de vergoeding.',0),(470320,13065,'fi','Kirjoita Kirjanpitotilin pÃ¤Ã¤tilin maksun.',0),(470321,13065,'no','Du mÃ¥ angi en GL konto for gebyret.',0),(470322,13065,'da','Du skal angive en GL konto for gebyret.',0),(470323,13065,'ko','ìˆ˜ìˆ˜ë£Œì— ëŒ€ í•œ GL ê³„ì •ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(470324,13065,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×—×©×‘×•×Ÿ GL ×¢×‘×•×¨ ×“×ž×™.',0),(470325,13065,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î³Î¹Î± Ï„Î¿ Ï„Î­Î»Î¿Ï‚.',0),(470326,13065,'zh','ä½ å¿…é¡»è¾“å…¥è´¹ç”¨çš„æ€»å¸ç§‘ç›®ã€‚',0),(470327,13065,'sv','Du mÃ¥ste ange ett GL konto fÃ¶r avgiften.',0),(470328,13065,'it','Ãˆ necessario immettere un account GL per la tassa.',0),(470329,13065,'tl','',0),(470330,13065,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸ªà¸³à¸«à¸£à¸±à¸šà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(470331,13065,'hi','à¤†à¤ªà¤•à¥‹ à¤à¤• GL à¤–à¤¾à¤¤à¤¾ à¤¶à¥à¤²à¥à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(470332,13065,'ms','Anda mesti masukkan akaun GL untuk yuran.',0),(470333,13065,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø­Ø³Ø§Ø¨ GL Ù„Ù„Ø±Ø³ÙˆÙ….',0),(470334,13065,'fr','Vous devez entrer un compte GL pour les frais.',0),(470335,13065,'jp','æ‰‹æ•°æ–™ã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(470336,13065,'pt','VocÃª deve digitar uma conta GL para a taxa.',0),(470337,13065,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL Ð´Ð»Ñ Ð³Ð¾Ð½Ð¾Ñ€Ð°Ñ€Ð°.',0),(470338,13065,'es','Debe Entrar Una Cuenta LM Para La Cuota',0),(470339,13065,'de','Sie mÃ¼ssen fÃ¼r die GebÃ¼hr ein GL-Konto eingeben.',0),(470340,13065,'en','You must enter a GL account for the fee.',0),(470341,13066,'is','',0),(470342,13066,'dr','(Ø¨Ù‡Ø§ÛŒ ÙˆØ§Ø­Ø¯',0),(470343,13066,'pr','Ø´Ù‡Ø±ÛŒÙ‡(Ø¨Ù‡Ø§ÛŒ ÙˆØ§Ø­Ø¯',0),(470344,13066,'tr','Ãœcreti',0),(470345,13066,'pl','OpÅ‚ata za',0),(470346,13066,'bg','Ð¢Ð°ÐºÑÐ°',0),(470347,13066,'ur','ÙÛŒØ³',0),(470348,13066,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ð°',0),(470349,13066,'vi','phÃ­',0),(470350,13066,'af','Fooi',0),(470351,13066,'ro','Taxa',0),(470352,13066,'et','Tasu',0),(470353,13066,'si','Pristojbina',0),(470354,13066,'ba','Biaya',0),(470355,13066,'nl','Vergoeding',0),(470356,13066,'fi','Maksu',0),(470357,13066,'no','Gebyr',0),(470358,13066,'da','Gebyr',0),(470359,13066,'ko','ìš”ê¸ˆ',0),(470360,13066,'he','×“×ž×™',0),(470361,13066,'el','Î‘Î¼Î¿Î¹Î²Î®',0),(470362,13066,'zh','è´¹ç”¨',0),(470363,13066,'sv','Avgift',0),(470364,13066,'it','Tassa',0),(470365,13066,'tl','',0),(470366,13066,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(470367,13066,'hi','à¤¶à¥à¤²à¥à¤•',0),(470368,13066,'ms','Yuran',0),(470369,13066,'ar','Ø±Ø³ÙˆÙ…',0),(470370,13066,'fr','Frais',0),(470371,13066,'jp','æ–™é‡‘',0),(470372,13066,'pt','Taxa',0),(470373,13066,'ru','ÐŸÐ»Ð°Ñ‚Ð°',0),(470374,13066,'es','Cuota',0),(470375,13066,'de','GebÃ¼hr',0),(470376,13066,'en','Fee',0),(470377,13067,'is','',0),(470378,13067,'dr','Ù…Ø¨Ù„Øº Ù…Ø§Ù„ÛŒ',0),(470379,13067,'pr','Ù…Ø¨Ù„Øº Ù…Ø§Ù„ÛŒ',0),(470380,13067,'tr','Finansman tutarÄ±',0),(470381,13067,'pl','Kwota finansowania',0),(470382,13067,'bg','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¸ ÑÑƒÐ¼Ð°',0),(470383,13067,'ur','Ù…Ø§Ù„ÛŒØ§Øª Ú©ÛŒ Ø±Ù‚Ù…',0),(470384,13067,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð·Ð°Ñ‚ÐµÐ·Ð½Ð¸Ñ… ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(470385,13067,'vi','Sá»‘ liá»‡u tÃ i chÃ­nh',0),(470386,13067,'af','Bedrag van Finansies',0),(470387,13067,'ro','FinanÅ£elor suma',0),(470388,13067,'et','Rahastamise summa',0),(470389,13067,'si','Znesek financiranja',0),(470390,13067,'ba','Jumlah keuangan',0),(470391,13067,'nl','FinanciÃ«n bedrag',0),(470392,13067,'fi','Rahoituksen mÃ¤Ã¤rÃ¤',0),(470393,13067,'no','Finans belÃ¸p',0),(470394,13067,'da','Finance belÃ¸b',0),(470395,13067,'ko','ê¸ˆìœµ ê¸ˆì•¡',0),(470396,13067,'he','×¡×›×•× ×ž×™×ž×•×Ÿ',0),(470397,13067,'el','ÎŸÎ¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŽÎ½ Ï€Î¿ÏƒÏŒ',0),(470398,13067,'zh','èžèµ„é‡‘é¢',0),(470399,13067,'sv','Finans belopp',0),(470400,13067,'it','QuantitÃ  di finanza',0),(470401,13067,'tl','',0),(470402,13067,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™',0),(470403,13067,'hi','à¤µà¤¿à¤¤à¥à¤¤ à¤°à¤¾à¤¶à¤¿',0),(470404,13067,'ms','Jumlah pembiayaan yang',0),(470405,13067,'ar','Ù…Ø¨Ù„Øº Ø§Ù„ØªÙ…ÙˆÙŠÙ„',0),(470406,13067,'fr','Montant de la finance',0),(470407,13067,'jp','èžè³‡é¡',0),(470408,13067,'pt','Quantidade de finanÃ§as',0),(470409,13067,'ru','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€ÑƒÐµÐ¼Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(470410,13067,'es','Monto Financiado',0),(470411,13067,'de','Finanzen-Betrag',0),(470412,13067,'en','Finance Amount',0),(470413,13068,'is','',0),(470414,13068,'dr','(Ù‡Ø²ÛŒÙ†Ù‡) Ù…Ø§Ù„ÛŒ',0),(470415,13068,'pr','Ø´Ø§Ø±Ú˜(Ù‡Ø²ÛŒÙ†Ù‡) Ù…Ø§Ù„ÛŒ',0),(470416,13068,'tr','Vade farkÄ±',0),(470417,13068,'pl','Nota odsetkowa',0),(470418,13068,'bg','Ð—Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð¸ Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ',0),(470419,13068,'ur','Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ú†Ø§Ø±Ø¬Ø²',0),(470420,13068,'sr','Ð—Ð°Ñ‚ÐµÐ·Ð½Ñƒ ÐºÐ°Ð¼Ð°Ñ‚Ñƒ',0),(470421,13068,'vi','PhÃ­ tÃ i chÃ­nh',0),(470422,13068,'af','FinansiÃ«le las',0),(470423,13068,'ro','TaxÄƒ financiarÄƒ',0),(470424,13068,'et','Viivise',0),(470425,13068,'si','Bremepis',0),(470426,13068,'ba','Biaya keuangan',0),(470427,13068,'nl','Rentefactuur',0),(470428,13068,'fi','ViivÃ¤styskulu',0),(470429,13068,'no','Rentenota',0),(470430,13068,'da','Rentenota',0),(470431,13068,'ko','ê¸ˆìœµ ë¹„ìš©',0),(470432,13068,'he','×ª×©×œ×•× ×›×¡×¤×™×',0),(470433,13068,'el','Î¤ÏŒÎºÏ‰Î½',0),(470434,13068,'zh','è´¢åŠ¡è´¹ç”¨',0),(470435,13068,'sv','Finans avgift',0),(470436,13068,'it','Addebito interessi',0),(470437,13068,'tl','',0),(470438,13068,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸—à¸²à¸‡à¸à¸²à¸£à¹€à¸‡à¸´à¸™',0),(470439,13068,'hi','à¤µà¤¿à¤¤à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(470440,13068,'ms','Caj kewangan',0),(470441,13068,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„ØªÙ…ÙˆÙŠÙ„',0),(470442,13068,'fr','Frais financiers',0),(470443,13068,'jp','é‡‘èžè«¸è²»ç”¨',0),(470444,13068,'pt','Carga de finanÃ§as',0),(470445,13068,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(470446,13068,'es','Cargos para Financiar',0),(470447,13068,'de','Finanzierungskosten',0),(470448,13068,'en','Finance Charge',0),(470449,13069,'is','',0),(470450,13069,'dr','Ù†Ø§Ø¯Ø±Ø³Øª',0),(470451,13069,'pr','Ù†Ø§Ø¯Ø±Ø³Øª',0),(470452,13069,'tr','Inv',0),(470453,13069,'pl','Inv',0),(470454,13069,'bg','Ð˜Ð½Ð²',0),(470455,13069,'ur','Ø§Ù†Ùˆ',0),(470456,13069,'sr','Ð˜Ð½Ð²',0),(470457,13069,'vi','hÃ³a Ä‘Æ¡n',0),(470458,13069,'af','Inv',0),(470459,13069,'ro','Inv',0),(470460,13069,'et','Inv',0),(470461,13069,'si','Inv',0),(470462,13069,'ba','INV',0),(470463,13069,'nl','INV',0),(470464,13069,'fi','Inv',0),(470465,13069,'no','Inv',0),(470466,13069,'da','Inv',0),(470467,13069,'ko','ì¸ë³´ì´ìŠ¤',0),(470468,13069,'he','Inv',0),(470469,13069,'el','Inv',0),(470470,13069,'zh','Inv',0),(470471,13069,'sv','Inv',0),(470472,13069,'it','Inv',0),(470473,13069,'tl','',0),(470474,13069,'th','Inv',0),(470475,13069,'hi','Inv',0),(470476,13069,'ms','Songsang',0),(470477,13069,'ar','Ù„Ù„Ø§Ø³ØªØ«Ù…Ø§Ø±Ø§Øª',0),(470478,13069,'fr','Inv',0),(470479,13069,'jp','æœ¬æŠ•è³‡æ³•äºº',0),(470480,13069,'pt','Inv',0),(470481,13069,'ru','Inv',0),(470482,13069,'es','Inv',0),(470483,13069,'de','Inv',0),(470484,13069,'en','Inv',0),(470485,13070,'is','',0),(470486,13070,'dr','Ø®Ø·Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(470487,13070,'pr','Ø®Ø·Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ',0),(470488,13070,'tr','Hata iÅŸleme EDI gÃ¶nderiler',0),(470489,13070,'pl','BÅ‚Ä…d przetwarzania EDI przesyÅ‚ek',0),(470490,13070,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° EDI ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(470491,13070,'ur','Ù†Ù‚Øµ Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ø§ÛŒØ¯Ø§ ØªØ±Ø³ÛŒÙ„',0),(470492,13070,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¾Ð±Ñ€Ð°Ð´Ðµ Ð•Ð”Ð˜ÐˆÐ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(470493,13070,'vi','Lá»—i trong quÃ¡ trÃ¬nh EDI váº­n chuyá»ƒn',0),(470494,13070,'af','Fout verwerking EDI gestuur',0),(470495,13070,'ro','Eroare de prelucrare EDI transporturile',0),(470496,13070,'et','Viga tÃ¶Ã¶tlemine EDI saadetised',0),(470497,13070,'si','Napake obdelave EDI poÅ¡iljk',0),(470498,13070,'ba','Kesalahan pengolahan EDI pengiriman',0),(470499,13070,'nl','Fout Processing EDI zendingen',0),(470500,13070,'fi','Virhe kÃ¤sittely EDI siirtojen',0),(470501,13070,'no','Feil behandling EDI forsendelser',0),(470502,13070,'da','Fejl forarbejdning EDI forsendelser',0),(470503,13070,'ko','ì˜¤ë¥˜ ì²˜ë¦¬ EDI ì¶œí•˜ ëŸ‰',0),(470504,13070,'he','×©×’×™××” ×‘×¢×™×‘×•×“ EDI ×ž×©×œ×•×—×™×',0),(470505,13070,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ EDI Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(470506,13070,'zh','é”™è¯¯å¤„ç† EDI å‘è´§',0),(470507,13070,'sv','Fel behandling EDI transporter',0),(470508,13070,'it','Errore elaborazione EDI spedizioni',0),(470509,13070,'tl','',0),(470510,13070,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ EDI à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(470511,13070,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤‚à¤¸à¤¾à¤§à¤¨ EDI à¤²à¤¦à¤¾à¤¨',0),(470512,13070,'ms','Ralat pemprosesan EDI penghantaran',0),(470513,13070,'ar','Ø®Ø·Ø£ ÙÙŠ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ø´Ø­Ù†Ø§Øª Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(470514,13070,'fr','Erreur traitement EDI expÃ©ditions',0),(470515,13070,'jp','ã‚¨ãƒ©ãƒ¼å‡¦ç† EDI å‡ºè·',0),(470516,13070,'pt','Erro de processamento EDI embarques',0),(470517,13070,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ EDI Ð³Ñ€ÑƒÐ·Ð¾Ð²',0),(470518,13070,'es','Error Procesando EDI EnvÃ­os',0),(470519,13070,'de','Fehler Verarbeitung EDI Sendungen',0),(470520,13070,'en','Error Processing EDI Shipments',0),(470521,13071,'is','',0),(470522,13071,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª  Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(470523,13071,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª  Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(470524,13071,'tr','DÄ±ÅŸa aktarÄ±lan EDI gÃ¶nderiler',0),(470525,13071,'pl','PrzesyÅ‚ek wywoÅ¼onych EDI',0),(470526,13071,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ EDI ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(470527,13071,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û Ø§ÛŒØ¯Ø§ ØªØ±Ø³ÛŒÙ„',0),(470528,13071,'sr','Ð˜Ð·Ð²ÐµÐ·ÐµÐ½Ð¸ Ð•Ð”Ð˜ÐˆÐ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(470529,13071,'vi','Káº¿t xuáº¥t váº­n chuyá»ƒn EDI',0),(470530,13071,'af','Uitgevoerde EDI gestuur',0),(470531,13071,'ro','ÃŽncÄƒrcÄƒturile exportate EDI',0),(470532,13071,'et','Eksporditud EDI saadetised',0),(470533,13071,'si','EDI izvoÅ¾eno poÅ¡iljk',0),(470534,13071,'ba','EDI diekspor pengiriman',0),(470535,13071,'nl','GeÃ«xporteerde EDI zendingen',0),(470536,13071,'fi','Viety EDI siirtojen',0),(470537,13071,'no','Eksporterte EDI forsendelser',0),(470538,13071,'da','Eksporterede EDI forsendelser',0),(470539,13071,'ko','ë‚´ë³´ë‚¸ëœ EDI ì¶œí•˜',0),(470540,13071,'he','EDI ×”×ž×™×•×¦× ×ž×©×œ×•×—×™×',0),(470541,13071,'el','Î•Î¾Î±Î³ÏŒÎ¼ÎµÎ½Î± EDI Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(470542,13071,'zh','å¯¼å‡ºçš„ EDI å‘è´§',0),(470543,13071,'sv','Exporterade EDI transporter',0),(470544,13071,'it','EDI esportato spedizioni',0),(470545,13071,'tl','',0),(470546,13071,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¹ˆà¸‡à¸­à¸­à¸ EDI',0),(470547,13071,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¥€ à¤—à¤ˆ EDI à¤²à¤¦à¤¾à¤¨',0),(470548,13071,'ms','Penghantaran import eksport',0),(470549,13071,'ar','Ø§Ù„Ø´Ø­Ù†Ø§Øª Ø§Ù„Ù…ØµØ¯Ø±Ø© Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(470550,13071,'fr','Envois exportÃ©s EDI',0),(470551,13071,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã•ã‚ŒãŸ EDI å‡ºè·',0),(470552,13071,'pt','EDI exportado embarques',0),(470553,13071,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð·ÐºÐ¸ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐµÐ¼Ñ‹Ñ… Ð­ÐžÐ”',0),(470554,13071,'es','EDI EnvÃ­os Exportados',0),(470555,13071,'de','Exportierte EDI-Sendungen',0),(470556,13071,'en','Exported EDI Shipments',0),(470557,13072,'is','',0),(470558,13072,'dr','Ø§Ø±Ø³Ø§Ù„ ØªØ¹Ø¯Ø§Ø¯ Ù…ØªÙˆØ³Ø· Ù†Ù…ÙˆÙ†Ù‡ Ù‡Ø§ÙŠ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡ ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª  ',0),(470559,13072,'pr','Ø§Ø±Ø³Ø§Ù„ ØªØ¹Ø¯Ø§Ø¯ Ù…ØªÙˆØ³Ø· Ù†Ù…ÙˆÙ†Ù‡ Ù‡Ø§ÙŠ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡ ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª  ',0),(470560,13072,'tr','EDI ASN verme',0),(470561,13072,'pl','WywÃ³z EDI ASN',0),(470562,13072,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° EDI ASN',0),(470563,13072,'ur','Ø§ÛŒØ¯Ø§ Ø§Ø³Ù† Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(470564,13072,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð•Ð”Ð˜ ÐÐ¡Ð',0),(470565,13072,'vi','Káº¿t xuáº¥t EDI ASN',0),(470566,13072,'af','Uitvoer EDI ASN',0),(470567,13072,'ro','Export EDI ASN',0),(470568,13072,'et','Ekspordi EDI ASN',0),(470569,13072,'si','Izvoz EDI ASN',0),(470570,13072,'ba','Ekspor EDI ASN',0),(470571,13072,'nl','Export EDI ASN',0),(470572,13072,'fi','Viennin EDI ASN',0),(470573,13072,'no','Eksportere EDI ASN',0),(470574,13072,'da','Eksportere EDI ASN',0),(470575,13072,'ko','EDI ASN ë‚´ë³´ë‚´ê¸°',0),(470576,13072,'he','×™×™×¦×•× EDI ASN',0),(470577,13072,'el','Î•Î¾Î±Î³Ï‰Î³Î® EDI ASN',0),(470578,13072,'zh','å‡ºå£ EDI ASN',0),(470579,13072,'sv','Exportera EDI ASN',0),(470580,13072,'it','Esportazione EDI ASN',0),(470581,13072,'tl','',0),(470582,13072,'th','à¸ªà¹ˆà¸‡ EDI ASN',0),(470583,13072,'hi','EDI ASN à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(470584,13072,'ms','ASN import eksport',0),(470585,13072,'ar','ØªØµØ¯ÙŠØ± ASN Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(470586,13072,'fr','Export EDI ASN',0),(470587,13072,'jp','EDI ASN ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(470588,13072,'pt','ExportaÃ§Ã£o EDI ASN',0),(470589,13072,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð­Ð”Ð˜ ASN',0),(470590,13072,'es','EDI ASN Exportadas',0),(470591,13072,'de','Export EDI ASN',0),(470592,13072,'en','Export EDI ASN',0),(470593,13073,'is','',0),(470594,13073,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(470595,13073,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(470596,13073,'tr','Verilen sevkiyat',0),(470597,13073,'pl','PrzesyÅ‚ek wywoÅ¼onych',0),(470598,13073,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(470599,13073,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ù†ÛÛŒÚº Ù„ÛŒØªÛŒ',0),(470600,13073,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð¸Ð·Ð²ÐµÐ·ÐµÐ½Ð¸',0),(470601,13073,'vi','CÃ¡c lÃ´ hÃ ng xuáº¥t kháº©u',0),(470602,13073,'af','Vervoer uitgevoer',0),(470603,13073,'ro','ÃŽncÄƒrcÄƒturile exportate',0),(470604,13073,'et','Saadetised eksportimisel',0),(470605,13073,'si','PoÅ¡iljke, ki se izvozijo',0),(470606,13073,'ba','Pengiriman diekspor',0),(470607,13073,'nl','Zendingen geÃ«xporteerd',0),(470608,13073,'fi','LÃ¤hetykset viedÃ¤Ã¤n',0),(470609,13073,'no','Forsendelser eksporteres',0),(470610,13073,'da','Forsendelser eksporteret',0),(470611,13073,'ko','ìˆ˜ì¶œ ì„ ì ',0),(470612,13073,'he','×ž×©×œ×•×—×™× ×ž×™×•×¦××™×',0),(470613,13073,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ Ï€Î¿Ï… ÎµÎ¾Î¬Î³Î¿Î½Ï„Î±Î¹',0),(470614,13073,'zh','å‡ºå£çš„è´§ç‰©',0),(470615,13073,'sv','Transporter som exporteras',0),(470616,13073,'it','Spedizioni esportate',0),(470617,13073,'tl','',0),(470618,13073,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(470619,13073,'hi','à¤²à¤¦à¤¾à¤¨ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤',0),(470620,13073,'ms','Penghantaran yang dieksport',0),(470621,13073,'ar','Ø§Ù„Ø´Ø­Ù†Ø§Øª Ø§Ù„Ù…ØµØ¯Ø±Ø©',0),(470622,13073,'fr','Envois exportÃ©s',0),(470623,13073,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã®å‡ºè·å°æ•°',0),(470624,13073,'pt','Embarques exportados',0),(470625,13073,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð½Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(470626,13073,'es','Envios Exportados',0),(470627,13073,'de','Sendungen, die exportiert',0),(470628,13073,'en','Shipments Exported',0),(470629,13074,'is','',0),(470630,13074,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª  Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(470631,13074,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ ØªØ¨Ø§Ø¯Ù„ Ø§Ù„ÙƒØªØ±ÙˆÙ†ÙŠÙƒÙŠ Ø§Ø·Ù„Ø§Ø¹Ø§Øª  Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯',0),(470632,13074,'tr','DÄ±ÅŸa aktarÄ±lan EDI faturalar',0),(470633,13074,'pl','Faktury EDI wywoÅ¼onych',0),(470634,13074,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ EDI Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(470635,13074,'ur','Ø¨Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û Ø§ÛŒØ¯Ø§ ÙˆØ¨Ø¬Ù„ÛŒ',0),(470636,13074,'sr','Ð˜Ð·Ð²ÐµÐ·ÐµÐ½Ð¸ Ð•Ð”Ð˜ÐˆÐ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(470637,13074,'vi','Káº¿t xuáº¥t hÃ³a Ä‘Æ¡n EDI',0),(470638,13074,'af','Uitgevoerde EDI fakture',0),(470639,13074,'ro','EDI exportate facturi',0),(470640,13074,'et','Eksporditud EDI arveid',0),(470641,13074,'si','IzvoÅ¾eni EDI raÄunov',0),(470642,13074,'ba','EDI diekspor faktur',0),(470643,13074,'nl','GeÃ«xporteerde EDI-facturen',0),(470644,13074,'fi','Viety EDI laskut',0),(470645,13074,'no','Eksporterte EDI fakturaer',0),(470646,13074,'da','Eksporterede EDI fakturaer',0),(470647,13074,'ko','ë‚´ë³´ë‚¸ëœ EDI ì²­êµ¬ì„œ',0),(470648,13074,'he','EDI ×”×ž×™×•×¦× ×—×©×‘×•× ×™×•×ª',0),(470649,13074,'el','Î•Î¾Î±Î³ÏŒÎ¼ÎµÎ½Î± EDI Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(470650,13074,'zh','å¯¼å‡ºçš„ EDI å‘ç¥¨',0),(470651,13074,'sv','Exporterade EDI-fakturor',0),(470652,13074,'it','Fatture EDI esportato',0),(470653,13074,'tl','',0),(470654,13074,'th','EDI à¸ªà¹ˆà¸‡à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(470655,13074,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¥€ à¤—à¤ˆ EDI à¤šà¤¾à¤²à¤¾à¤¨',0),(470656,13074,'ms','EDI dieksport invois',0),(470657,13074,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ØµØ¯Ø±Ø© Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(470658,13074,'fr','Factures EDI exportÃ©',0),(470659,13074,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã•ã‚ŒãŸ EDI è«‹æ±‚æ›¸',0),(470660,13074,'pt','EDI exportado facturas',0),(470661,13074,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐµÐ¼Ñ‹Ðµ Ð­Ð”Ð˜ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(470662,13074,'es','EDI Facturas Exportadas',0),(470663,13074,'de','Exportierte EDI-Rechnungen',0),(470664,13074,'en','Exported EDI Invoices',0),(470665,13075,'is','',0),(470666,13075,'dr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¬Ù‡Øª Ù¾Ø±ÛŒÙ†Øª Ø¯Ø± ØµÙØ­Ø§Øª Ø¨Ø¹Ø¯ÛŒ',0),(470667,13075,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ Ø¬Ù‡Øª Ù¾Ø±ÛŒÙ†Øª Ø¯Ø± ØµÙØ­Ø§Øª Ø¨Ø¹Ø¯ÛŒ',0),(470668,13075,'tr','SayfalarÄ± aÅŸaÄŸÄ±daki notlarÄ± yazdÄ±rmak iÃ§in',0),(470669,13075,'pl','Notatki do druku na nastÄ™pujÄ…cych stronach',0),(470670,13075,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(470671,13075,'ur','ØµÙØ­Ø§Øª Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ù¾Ø± Ù†ÙˆÙ¹ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’',0),(470672,13075,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð° ÑÐ»ÐµÐ´ÐµÑ›Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(470673,13075,'vi','ghi chÃº cho in trÃªn trang tiáº¿p theo',0),(470674,13075,'af','Notas om druk op die volgende bladsye',0),(470675,13075,'ro','Note pentru a imprima pe urmÄƒtoarele pagini',0),(470676,13075,'et','Lisades Prindi pÃ¤rast lehekÃ¼lgede',0),(470677,13075,'si','Opombe za tiskanje na naslednjih straneh',0),(470678,13075,'ba','Catatan untuk cetak mengikuti Halaman',0),(470679,13075,'nl','Toelichting op afdrukken op volgende pagina \'s',0),(470680,13075,'fi','Tulosta liitetiedoissa lehdestÃ¤',0),(470681,13075,'no','Notater til ut pÃ¥ fÃ¸lgende sider',0),(470682,13075,'da','Noter til Print pÃ¥ fÃ¸lgende sider',0),(470683,13075,'ko','ë‹¤ìŒ íŽ˜ì´ì§€ì— ì¸ì‡„ í•˜ë ¤ë©´ ë…¸íŠ¸',0),(470684,13075,'he','×”×¢×¨×•×ª ×¢×œ ×”×“×¤×¡ ×¢×œ ×‘×¢×§×‘×•×ª ×“×¤×™',0),(470685,13075,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏƒÏ„Î¹Ï‚ Î±ÎºÏŒÎ»Î¿Ï…Î¸ÎµÏ‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚',0),(470686,13075,'zh','æ³¨æ„åœ¨ä»¥ä¸‹é¡µæ‰“å°',0),(470687,13075,'sv','Anteckningar till Print pÃ¥ fÃ¶ljande sidor',0),(470688,13075,'it','Note per la stampa su pagine seguenti',0),(470689,13075,'tl','',0),(470690,13075,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¹€à¸¡à¸·à¹ˆà¸­à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸™à¸«à¸™à¹‰à¸²à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰',0),(470691,13075,'hi','à¤¨à¥‹à¤Ÿà¥à¤¸ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤•à¤¾ à¤ªà¤¾à¤²à¤¨ à¤ªà¤° à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(470692,13075,'ms','Nota-nota untuk cetakan pada muka surat berikut',0),(470693,13075,'ar','Ù…Ø°ÙƒØ±Ø§Øª Ù„Ù„Ø·Ø¨Ø§Ø¹Ø© Ø¹Ù† Ø¨Ø¹Ø¯ ØµÙØ­Ø§Øª',0),(470694,13075,'fr','Notes Ã  imprimer sur les Pages suivantes',0),(470695,13075,'jp','æ¬¡ã®ãƒšãƒ¼ã‚¸ã«å°åˆ·ã™ã‚‹ãƒŽãƒ¼ãƒˆ',0),(470696,13075,'pt','Notas para impressÃ£o nos seguintes pÃ¡ginas',0),(470697,13075,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð½Ð° ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ñ… ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ…',0),(470698,13075,'es','Notas para Imprimir En Las Siguentes PÃ¡ginas',0),(470699,13075,'de','Hinweise zur Print auf folgenden Seiten',0),(470700,13075,'en','Notes To Print On Following Pages',0),(470701,13076,'is','',0),(470702,13076,'dr','(Ù‡Ø²ÛŒÙ†Ù‡) Ù…Ø§Ù„ÛŒ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(470703,13076,'pr','Ø´Ø§Ø±Ú˜(Ù‡Ø²ÛŒÙ†Ù‡) Ù…Ø§Ù„ÛŒ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(470704,13076,'tr','Ã–deme vade farkÄ±',0),(470705,13076,'pl','Nota odsetkowa dla pÅ‚atnoÅ›ci',0),(470706,13076,'bg','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð¸ Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(470707,13076,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ú†Ø§Ø±Ø¬Ø²',0),(470708,13076,'sr','Ð—Ð°Ñ‚ÐµÐ·Ð½Ð¸Ñ… ÐºÐ°Ð¼Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ',0),(470709,13076,'vi','PhÃ­ tÃ i chÃ­nh Ä‘á»ƒ thanh toÃ¡n',0),(470710,13076,'af','FinansiÃ«le las vir betaling',0),(470711,13076,'ro','Taxa financiarÄƒ pentru plata',0),(470712,13076,'et','Viivise maksmiseks',0),(470713,13076,'si','Bremepis za plaÄilo',0),(470714,13076,'ba','Biaya keuangan untuk pembayaran',0),(470715,13076,'nl','Rentefactuur voor betaling',0),(470716,13076,'fi','ViivÃ¤styskulu maksun',0),(470717,13076,'no','Rentenota For betaling',0),(470718,13076,'da','Rentenota For betaling',0),(470719,13076,'ko','ì§€ë¶ˆì— ëŒ€ í•œ ê¸ˆìœµ ë¹„ìš©',0),(470720,13076,'he','×ª×©×œ×•× ×›×¡×¤×™× ×œ×ª×©×œ×•×',0),(470721,13076,'el','Î¤ÏŒÎºÏ‰Î½ Î³Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î®',0),(470722,13076,'zh','æ”¯ä»˜çš„èžèµ„è´¹ç”¨',0),(470723,13076,'sv','Finans avgift fÃ¶r betalning',0),(470724,13076,'it','Addebito interessi per il pagamento',0),(470725,13076,'tl','',0),(470726,13076,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸—à¸²à¸‡à¸à¸²à¸£à¹€à¸‡à¸´à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(470727,13076,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤¤à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(470728,13076,'ms','Caj kewangan untuk bayaran',0),(470729,13076,'ar','Ø±Ø³Ù… Ù…Ø§Ù„ÙŠ Ù„Ø¯ÙØ¹',0),(470730,13076,'fr','Pour le paiement des frais financiers',0),(470731,13076,'jp','é‡‘èžè«¸è²»ç”¨ã®æ”¯æ‰•ã„',0),(470732,13076,'pt','Carga de FinanÃ§as para pagamento',0),(470733,13076,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(470734,13076,'es','Cargos de Financiar para Pagar',0),(470735,13076,'de','Finanzen-kostenlos Zahlung',0),(470736,13076,'en','Finance Charge For Payment',0),(470737,13077,'is','',0),(470738,13077,'dr','Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(470739,13077,'pr','Ù…Ù‚Ø¯Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(470740,13077,'tr','Fatura tutarÄ±',0),(470741,13077,'pl','KwotÄ™ rachunku',0),(470742,13077,'bg','Ð‘Ð¸Ð» ÑÑƒÐ¼Ð°',0),(470743,13077,'ur','Ø¨Ù„ Ú©ÛŒ Ø±Ù‚Ù…',0),(470744,13077,'sr','Ð‘Ð¸Ð» Ð¸Ð·Ð½Ð¾Ñ',0),(470745,13077,'vi','Sá»‘ tiá»n trÃªn hÃ³a Ä‘Æ¡n',0),(470746,13077,'af','Wetsontwerp bedrag',0),(470747,13077,'ro','Factura suma',0),(470748,13077,'et','Arve summa',0),(470749,13077,'si','Bill znesek',0),(470750,13077,'ba','Jumlah tagihan',0),(470751,13077,'nl','Bill bedrag',0),(470752,13077,'fi','Laskun summa',0),(470753,13077,'no','Telefonregning belÃ¸pet',0),(470754,13077,'da','Telefonregning belÃ¸b',0),(470755,13077,'ko','ë¹Œ ê¸ˆì•¡',0),(470756,13077,'he','×›×ž×•×ª ×‘×™×œ',0),(470757,13077,'el','Bill Ï€Î¿ÏƒÏŒ',0),(470758,13077,'zh','å•é‡‘é¢',0),(470759,13077,'sv','Bill belopp',0),(470760,13077,'it','Importo fattura',0),(470761,13077,'tl','',0),(470762,13077,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¹ƒà¸™à¸šà¸´à¸¥',0),(470763,13077,'hi','à¤¬à¤¿à¤² à¤°à¤¾à¤¶à¤¿',0),(470764,13077,'ms','Jumlah perlu di bayar',0),(470765,13077,'ar','Ù…Ø¨Ù„Øº Ø¨ÙŠÙ„',0),(470766,13077,'fr','Montant de la facture',0),(470767,13077,'jp','è«‹æ±‚é¡',0),(470768,13077,'pt','Quantidade da conta',0),(470769,13077,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÑ‡ÐµÑ‚Ð°',0),(470770,13077,'es','Monto de Recibo',0),(470771,13077,'de','Bill Betrag',0),(470772,13077,'en','Bill Amount',0),(470773,13078,'is','',0),(470774,13078,'dr','ÙØ§Ú©ØªÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(470775,13078,'pr','ÙØ§Ú©ØªÙˆØ± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(470776,13078,'tr','Fatura fatura',0),(470777,13078,'pl','Bill faktury',0),(470778,13078,'bg','Ð‘Ð¸Ð» Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(470779,13078,'ur','Ø¨Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(470780,13078,'sr','Ð‘Ð¸Ð» Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(470781,13078,'vi','Láº­p hÃ³a Ä‘Æ¡n',0),(470782,13078,'af','Wetsontwerp faktuur',0),(470783,13078,'ro','Bill facturÄƒ',0),(470784,13078,'et','Arve arve',0),(470785,13078,'si','Bill raÄuna',0),(470786,13078,'ba','Faktur tagihan',0),(470787,13078,'nl','Bill factuur',0),(470788,13078,'fi','Bill lasku',0),(470789,13078,'no','Bill faktura',0),(470790,13078,'da','Bill faktura',0),(470791,13078,'ko','ì²­êµ¬ì„œ ì²­êµ¬ì„œ',0),(470792,13078,'he','×‘×™×œ ×—×©×‘×•× ×™×ª',0),(470793,13078,'el','Bill Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(470794,13078,'zh','å‘ç¥¨',0),(470795,13078,'sv','Bill faktura',0),(470796,13078,'it','Fattura fattura',0),(470797,13078,'tl','',0),(470798,13078,'th','à¸šà¸´à¸¥à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(470799,13078,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤šà¤¾à¤²à¤¾à¤¨',0),(470800,13078,'ms','Bil invois',0),(470801,13078,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙØ§ØªÙˆØ±Ø©',0),(470802,13078,'fr','Effet facture',0),(470803,13078,'jp','è«‹æ±‚æ›¸ã®è«‹æ±‚',0),(470804,13078,'pt','Fatura',0),(470805,13078,'ru','Ð‘Ð¸Ð»Ð» ÑÑ‡ÐµÑ‚Ð°',0),(470806,13078,'es','Recibo Factura',0),(470807,13078,'de','Wechsel Rechnung',0),(470808,13078,'en','Bill Invoice',0),(470809,13079,'is','',0),(470810,13079,'dr','ÙØ±Ù… ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(470811,13079,'pr','ÙØ±Ù… ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(470812,13079,'tr','Gelen faturalar',0),(470813,13079,'pl','Faktury od',0),(470814,13079,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¾Ñ‚',0),(470815,13079,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø³Û’',0),(470816,13079,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸Ð·',0),(470817,13079,'vi','hÃ³a Ä‘Æ¡n tá»«',0),(470818,13079,'af','Fakture vanaf',0),(470819,13079,'ro','Facturi de',0),(470820,13079,'et','Arved',0),(470821,13079,'si','RaÄune iz',0),(470822,13079,'ba','Faktur dari',0),(470823,13079,'nl','Facturen van',0),(470824,13079,'fi','Laskut',0),(470825,13079,'no','Fakturaer fra',0),(470826,13079,'da','Fakturaer fra',0),(470827,13079,'ko','ì†¡ìž¥',0),(470828,13079,'he','×—×©×‘×•× ×™×•×ª ×ž×ª×•×š',0),(470829,13079,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î±Ï€ÏŒ',0),(470830,13079,'zh','ä»Žå‘ç¥¨',0),(470831,13079,'sv','Fakturor frÃ¥n',0),(470832,13079,'it','Fatture da',0),(470833,13079,'tl','',0),(470834,13079,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸ˆà¸²à¸',0),(470835,13079,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¥‡',0),(470836,13079,'ms','Invois dari',0),(470837,13079,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ù…Ù†',0),(470838,13079,'fr','Factures de',0),(470839,13079,'jp','è«‹æ±‚æ›¸ã‹ã‚‰',0),(470840,13079,'pt','Faturas de',0),(470841,13079,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(470842,13079,'es','Facturas De',0),(470843,13079,'de','Rechnungen von',0),(470844,13079,'en','Invoices From',0),(470845,13080,'is','',0),(470846,13080,'dr','Ø§Ø±Ø³Ø§Ù„ Ø²Ù…Ø§Ù†',0),(470847,13080,'pr','Ø§Ø±Ø³Ø§Ù„ Ø²Ù…Ø§Ù†',0),(470848,13080,'tr','GÃ¶nderme ZamanÄ±',0),(470849,13080,'pl','PrzeÅ›lij czas',0),(470850,13080,'bg','Ð’Ñ€ÐµÐ¼Ðµ Ð·Ð° Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ',0),(470851,13080,'ur','ÙˆÙ‚Øª Ø¬Ù…Ø¹ Ú©Ø±Ø§Ø¦ÛŒÚº',0),(470852,13080,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð¿Ñ€Ð¾ÑÐ»ÐµÑ’Ð¸Ð²Ð°ÑšÐ°',0),(470853,13080,'vi','Gá»­i thá»i gian',0),(470854,13080,'af','Tyd voorlÃª',0),(470855,13080,'ro','Momentul trimiterii',0),(470856,13080,'et','Edasta kellaaeg',0),(470857,13080,'si','ÄŒas poÅ¡iljanja',0),(470858,13080,'ba','Kirim waktu',0),(470859,13080,'nl','Tijd verzenden',0),(470860,13080,'fi','LÃ¤hettÃ¤Ã¤',0),(470861,13080,'no','Sendetid',0),(470862,13080,'da','Afsendelsestidspunktet',0),(470863,13080,'ko','ì œì¶œ ì‹œê°„',0),(470864,13080,'he','×œ×–×ž×Ÿ ×”×ž×¡×™×¨×”',0),(470865,13080,'el','Î¥Ï€Î¿Î²Î¬Î»ÎµÎ¹ Ï„Î¿ Ï‡ÏÏŒÎ½Î¿',0),(470866,13080,'zh','æäº¤æ—¶é—´',0),(470867,13080,'sv','LÃ¤mna in tid',0),(470868,13080,'it','Presentare il tempo',0),(470869,13080,'tl','',0),(470870,13080,'th','à¹€à¸§à¸¥à¸²à¸ªà¹ˆà¸‡',0),(470871,13080,'hi','à¤¸à¤®à¤¯ à¤œà¤®à¤¾ à¤•à¤°à¥‡à¤‚',0),(470872,13080,'ms','Hantar masa',0),(470873,13080,'ar','ÙˆÙ‚Øª Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(470874,13080,'fr','Soumettre le temps',0),(470875,13080,'jp','é€ä¿¡æ™‚åˆ»',0),(470876,13080,'pt','Submeter o tempo',0),(470877,13080,'ru','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ',0),(470878,13080,'es','Tiempo Para Someter',0),(470879,13080,'de','Zeit senden',0),(470880,13080,'en','Submit Time',0),(470881,13081,'is','',0),(470882,13081,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙØ§Ú©ØªÙˆØ± TCA',0),(470883,13081,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙØ§Ú©ØªÙˆØ± TCA',0),(470884,13081,'tr','TCA fatura raporu',0),(470885,13081,'pl','Raportu \"faktura\" TCA',0),(470886,13081,'bg','TCA Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð´Ð¾ÐºÐ»Ð°Ð´',0),(470887,13081,'ur','Ù¹Ú©ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(470888,13081,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ \"Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°\" Ð¢Ð¦Ð',0),(470889,13081,'vi','BÃ¡o cÃ¡o hÃ³a Ä‘Æ¡n TCA',0),(470890,13081,'af','TCA faktuur verslag',0),(470891,13081,'ro','Raportul de facturÄƒ TCA',0),(470892,13081,'et','TCA arvete aruanne',0),(470893,13081,'si','TCA raÄuna poroÄilo',0),(470894,13081,'ba','TCA Invoice Report',0),(470895,13081,'nl','TCA factuurrapport',0),(470896,13081,'fi','TCA lasku-raporttiin',0),(470897,13081,'no','TCA fakturarapporten',0),(470898,13081,'da','TCA fakturarapport',0),(470899,13081,'ko','TCA ì†¡ìž¥ ë³´ê³ ì„œ',0),(470900,13081,'he','×“×•×— ×—×©×‘×•× ×™×•×ª TCA',0),(470901,13081,'el','TCA Î­ÎºÎ¸ÎµÏƒÎ· \"Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿\"',0),(470902,13081,'zh','TCA å‘ç¥¨æŠ¥è¡¨',0),(470903,13081,'sv','TCA fakturarapport',0),(470904,13081,'it','Report Fattura TCA',0),(470905,13081,'tl','',0),(470906,13081,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸‚à¸­à¸‡ TCA',0),(470907,13081,'hi','TCA à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(470908,13081,'ms','TCA invois Laporan',0),(470909,13081,'ar','ØªÙ‚Ø±ÙŠØ± ÙØ§ØªÙˆØ±Ø© TCA',0),(470910,13081,'fr','Ã‰tat facture TCA',0),(470911,13081,'jp','TCA è«‹æ±‚æ›¸ãƒ¬ãƒãƒ¼ãƒˆ',0),(470912,13081,'pt','RelatÃ³rio de fatura TCA',0),(470913,13081,'ru','TCA ÑÑ‡Ñ‘Ñ‚Ð°',0),(470914,13081,'es','TCA Informe de Facturas',0),(470915,13081,'de','TCA Rechnungsbericht',0),(470916,13081,'en','TCA Invoice Report',0),(470917,13082,'is','',0),(470918,13082,'dr','.... Ù†ÛŒØ³Øª',0),(470919,13082,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ØªØºÛŒÛŒØ± Ù‚ÛŒÙ…ØªÙ‡Ø§ÛŒ .... Ù†ÛŒØ³Øª',0),(470920,13082,'tr','POS fiyatlarÄ± deÄŸiÅŸtiremezsiniz',0),(470921,13082,'pl','Nie moÅ¼na zmieniÄ‡ ceny POS',0),(470922,13082,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÑÑ‚Ðµ POS Ñ†ÐµÐ½Ð¸',0),(470923,13082,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(470924,13082,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ð¸ ÐŸÐžÐ¡ Ñ†ÐµÐ½Ðµ',0),(470925,13082,'vi','KhÃ´ng thá»ƒ thay Ä‘á»•i giÃ¡ POS',0),(470926,13082,'af','POS pryse kan verander',0),(470927,13082,'ro','Nu se poate modifica preÅ£urile POS',0),(470928,13082,'et','Standardiseerimata POS hinnad',0),(470929,13082,'si','Ne morete spremeniti cene POS',0),(470930,13082,'ba','Tidak dapat mengubah harga POS',0),(470931,13082,'nl','POS prijzen wijzigen niet',0),(470932,13082,'fi','Ei voi muuttaa POS hinnat',0),(470933,13082,'no','Kan ikke endre POS priser',0),(470934,13082,'da','Kan ikke Ã¦ndre POS priser',0),(470935,13082,'ko','POS ê°€ê²©ì„ ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(470936,13082,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×©× ×•×ª ×ž×—×™×¨×™× POS',0),(470937,13082,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î»Î»Î¬Î¾ÎµÎ¹ Ï„Î¹Ï‚ Ï„Î¹Î¼Î­Ï‚ Ï„Ï‰Î½ POS',0),(470938,13082,'zh','ä¸èƒ½æ›´æ”¹ POS ä»·æ ¼',0),(470939,13082,'sv','Kan inte Ã¤ndra POS priser',0),(470940,13082,'it','Non Ã¨ possibile modificare i prezzi POS',0),(470941,13082,'tl','',0),(470942,13082,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸£à¸²à¸„à¸² POS',0),(470943,13082,'hi','POS à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤•à¥‹ à¤¬à¤¦à¤² à¤¨à¤¹à¥€à¤‚ à¤¸à¤•à¤¤à¥‡',0),(470944,13082,'ms','Tidak boleh menukar harga POS',0),(470945,13082,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØºÙŠÙŠØ± Ø£Ø³Ø¹Ø§Ø± POS',0),(470946,13082,'fr','Impossible de modifier les prix de POS',0),(470947,13082,'jp','POS ã®ä¾¡æ ¼ã‚’å¤‰æ›´ã§ãã¾ã›ã‚“ã€‚',0),(470948,13082,'pt','NÃ£o Ã© possÃ­vel alterar os preÃ§os POS',0),(470949,13082,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‹ POS',0),(470950,13082,'es','No se Puede Cambiar Precios de PDV',0),(470951,13082,'de','POS Preise kann nicht geÃ¤ndert werden.',0),(470952,13082,'en','Cannot Change POS Prices',0),(470953,13083,'is','',0),(470954,13083,'dr','ØªØ§Ø±ÛŒØ® Ø§ÙØªØªØ§Ø­ Ø­Ø³Ø§Ø¨',0),(470955,13083,'pr','ØªØ§Ø±ÛŒØ® Ø§ÙØªØªØ§Ø­ Ø­Ø³Ø§Ø¨',0),(470956,13083,'tr','Hesap aÃ§Ä±lÄ±ÅŸ tarihi',0),(470957,13083,'pl','Konto otwartych Data',0),(470958,13083,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð° Ð´Ð°Ñ‚Ð°',0),(470959,13083,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ú¾ÙˆÙ„ÛŒÚº ØªØ§Ø±ÛŒØ®',0),(470960,13083,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(470961,13083,'vi','NgÃ y má»Ÿ TK',0),(470962,13083,'af','Rekening Openingsdatum',0),(470963,13083,'ro','Data Deschidere cont',0),(470964,13083,'et','Konto avatud kuupÃ¤ev',0),(470965,13083,'si','Datum odprtja raÄuna',0),(470966,13083,'ba','Tanggal Buka akun',0),(470967,13083,'nl','Open datum rekening',0),(470968,13083,'fi','Tili avoin pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(470969,13083,'no','Konto Ã…pningsdato',0),(470970,13083,'da','Konto Ã¥ben dato',0),(470971,13083,'ko','ê³„ì • ì˜¤í”ˆ ë‚ ì§œ',0),(470972,13083,'he','×ª××¨×™×š ×¤×ª×™×—×ª ×—×©×‘×•×Ÿ',0),(470973,13083,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î±Î½Î¿Î¹ÎºÏ„Î®Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚',0),(470974,13083,'zh','å¸æˆ·çš„å¼€æ”¾æ—¥æœŸ',0),(470975,13083,'sv','Konto Ã¶ppet datum',0),(470976,13083,'it','Conto Open Data',0),(470977,13083,'tl','',0),(470978,13083,'th','à¸§à¸±à¸™à¹€à¸›à¸´à¸”à¸šà¸±à¸à¸Šà¸µ',0),(470979,13083,'hi','à¤–à¤¾à¤¤à¤¾ à¤–à¥‹à¤²à¥‡à¤‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(470980,13083,'ms','Akaun tarikh dibuka',0),(470981,13083,'ar','ØªØ§Ø±ÙŠØ® ÙØªØ­ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(470982,13083,'fr','Date d\'ouverture compte',0),(470983,13083,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ã‚ªãƒ¼ãƒ—ãƒ³æ—¥',0),(470984,13083,'pt','Conta aberta data',0),(470985,13083,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°',0),(470986,13083,'es','Fecha de Apertura de Cuenta',0),(470987,13083,'de','Konto offenem Ende',0),(470988,13083,'en','Account Open Date',0),(470989,13084,'is','',0),(470990,13084,'dr','Ø§Ù…Ø¶Ø§ Ø®Ø±ÛŒØ¯Ø§Ø±',0),(470991,13084,'pr','Ø§Ù…Ø¶Ø§ Ø®Ø±ÛŒØ¯Ø§Ø±',0),(470992,13084,'tr','MÃ¼ÅŸteri imza',0),(470993,13084,'pl','Podpis klienta',0),(470994,13084,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ Ð¿Ð¾Ð´Ð¿Ð¸Ñ',0),(470995,13084,'ur','Ú©Ø³Ù¹Ù…Ø± Ø¯Ø³ØªØ®Ø·',0),(470996,13084,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸Ñ ÐºÑƒÐ¿Ñ†Ð°',0),(470997,13084,'vi','chá»¯ kÃ½ khÃ¡ch hÃ ng',0),(470998,13084,'af','Handtekening van kliÃ«nt',0),(470999,13084,'ro','SemnÄƒturÄƒ client',0),(471000,13084,'et','Kliendi allkiri',0),(471001,13084,'si','Podpis kupca',0),(471002,13084,'ba','Tanda tangan nasabah',0),(471003,13084,'nl','Handtekening van de klant',0),(471004,13084,'fi','Asiakkaan allekirjoitus',0),(471005,13084,'no','Kunden signatur',0),(471006,13084,'da','Kundens underskrift',0),(471007,13084,'ko','ê³ ê° ì„œëª…',0),(471008,13084,'he','×—×ª×™×ž×ª ×”×œ×§×•×—',0),(471009,13084,'el','Î¥Ï€Î¿Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(471010,13084,'zh','å®¢æˆ·ç­¾å',0),(471011,13084,'sv','Kundsignatur',0),(471012,13084,'it','Firma del cliente',0),(471013,13084,'tl','',0),(471014,13084,'th','à¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(471015,13084,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°',0),(471016,13084,'ms','Tandatangan pelanggan',0),(471017,13084,'ar','ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(471018,13084,'fr','Signature client',0),(471019,13084,'jp','é¡§å®¢ã‹ã‚‰ã®ç½²å',0),(471020,13084,'pt','Assinatura do cliente',0),(471021,13084,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(471022,13084,'es','Firma de Cliente',0),(471023,13084,'de','Kunden-Unterschrift',0),(471024,13084,'en','Customer Signature',0),(471025,13085,'is','',0),(471026,13085,'dr','...',0),(471027,13085,'pr','ØªÚ©Ø±Ø§Ø± Ù†Ø§Ù…...',0),(471028,13085,'tr','Rep adÄ±',0),(471029,13085,'pl','Nazwa Rep',0),(471030,13085,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»',0),(471031,13085,'ur','Ø¬Ù…ÛÙˆØ±ÛŒÛ Ú©Û’ Ù†Ø§Ù…',0),(471032,13085,'sr','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð½Ð¸Ðº Ð¸Ð¼Ðµ',0),(471033,13085,'vi','tÃªn Ä‘áº¡i lÃ½',0),(471034,13085,'af','Naam van verteenwoordiger',0),(471035,13085,'ro','Numele de rep',0),(471036,13085,'et','Rep nimi',0),(471037,13085,'si','Rep ime',0),(471038,13085,'ba','Nama Rep',0),(471039,13085,'nl','Rep naam',0),(471040,13085,'fi','Rep nimi',0),(471041,13085,'no','Rep navn',0),(471042,13085,'da','Rep navn',0),(471043,13085,'ko','ë‹´ë‹¹ìž ì´ë¦„',0),(471044,13085,'he','×©× × ×¦×™×’',0),(471045,13085,'el','ÎŒÎ½Î¿Î¼Î± rep',0),(471046,13085,'zh','ä»£è¡¨å§“å',0),(471047,13085,'sv','Rep namn',0),(471048,13085,'it','Nome Rep',0),(471049,13085,'tl','',0),(471050,13085,'th','à¸Šà¸·à¹ˆà¸­à¸•à¸±à¸§à¹à¸—à¸™',0),(471051,13085,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(471052,13085,'ms','Nama wakil',0),(471053,13085,'ar','Ø§Ø³Ù… Ù…Ù†Ø¯ÙˆØ¨',0),(471054,13085,'fr','Nom de REP',0),(471055,13085,'jp','æ‹…å½“è€…å',0),(471056,13085,'pt','Nome do representante',0),(471057,13085,'ru','Ð˜Ð¼Ñ REP',0),(471058,13085,'es','Nombre de Representante',0),(471059,13085,'de','Rep Name',0),(471060,13085,'en','Rep Name',0),(471061,13086,'is','',0),(471062,13086,'dr','ØªÚ©Ø±Ø§Ø± Ø§Ù…Ø¶Ø§',0),(471063,13086,'pr','ØªÚ©Ø±Ø§Ø± Ø§Ù…Ø¶Ø§',0),(471064,13086,'tr','Rep imza',0),(471065,13086,'pl','Podpis Rep',0),(471066,13086,'bg','ÐŸÐ¾Ð´Ð¿Ð¸Ñ Ð½Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»',0),(471067,13086,'ur','Ø¬Ù…ÛÙˆØ±ÛŒÛ Ø¯Ø³ØªØ®Ø·',0),(471068,13086,'sr','Ð ÐµÐ¿ÑƒÑ‚Ð°Ñ†Ð¸Ñ˜Ð° Ð¿Ð¾Ñ‚Ð¿Ð¸Ñ',0),(471069,13086,'vi','chá»¯ kÃ½ Ä‘áº¡i lÃ½',0),(471070,13086,'af','Handtekening van verteenwoordiger',0),(471071,13086,'ro','Rep semnÄƒtura',0),(471072,13086,'et','Rep allkiri',0),(471073,13086,'si','Rep podpis',0),(471074,13086,'ba','Rep Signature',0),(471075,13086,'nl','Rep handtekening',0),(471076,13086,'fi','Rep allekirjoitus',0),(471077,13086,'no','Rep signatur',0),(471078,13086,'da','Rep underskrift',0),(471079,13086,'ko','ë‹´ë‹¹ìž ì„œëª…',0),(471080,13086,'he','×—×ª×™×ž×ª × ×¦×™×’',0),(471081,13086,'el','Î¥Ï€Î¿Î³ÏÎ±Ï†Î® rep',0),(471082,13086,'zh','ä»£è¡¨ç­¾å',0),(471083,13086,'sv','Rep signatur',0),(471084,13086,'it','Firma del rappresentante',0),(471085,13086,'tl','',0),(471086,13086,'th','à¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™à¹à¸—à¸™',0),(471087,13086,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿ à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°',0),(471088,13086,'ms','Tandatangan wakil',0),(471089,13086,'ar','ØªÙˆÙ‚ÙŠØ¹ Ù…Ù†Ø¯ÙˆØ¨',0),(471090,13086,'fr','Signature de REP',0),(471091,13086,'jp','æ‹…å½“è€…ã®ç½²å',0),(471092,13086,'pt','Assinatura do representante',0),(471093,13086,'ru','REP Ð¿Ð¾Ð´Ð¿Ð¸ÑÑŒ',0),(471094,13086,'es','Firma de Representante',0),(471095,13086,'de','Rep-Signatur',0),(471096,13086,'en','Rep Signature',0),(471097,13087,'is','',0),(471098,13087,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø§Ù„ÛŒØ§ØªÛŒ ',0),(471099,13087,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø§Ù„ÛŒØ§ØªÛŒ ',0),(471100,13087,'tr','Vergi numarasÄ±',0),(471101,13087,'pl','Numer identyfikacji podatkowej',0),(471102,13087,'bg','Ð”Ð°Ð½ÑŠÑ‡ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(471103,13087,'ur','Ù¹ÛŒÚ©Ø³ Ù†Ù…Ø¨Ø±',0),(471104,13087,'sr','ÐŸÐ”Ð’ Ð±Ñ€Ð¾Ñ˜',0),(471105,13087,'vi','MÃ£ sá»‘ thuáº¿',0),(471106,13087,'af','Belasting nommer',0),(471107,13087,'ro','NumÄƒrul de impozitare',0),(471108,13087,'et','Maksu kood',0),(471109,13087,'si','DavÄna Å¡tevilka',0),(471110,13087,'ba','NPWP',0),(471111,13087,'nl','BTW nummer',0),(471112,13087,'fi','Veronumero',0),(471113,13087,'no','Skattenummer',0),(471114,13087,'da','-Nummer',0),(471115,13087,'ko','ì„¸ê¸ˆ ë²ˆí˜¸',0),(471116,13087,'he','×ž×¡×¤×¨ ×ž×¡',0),(471117,13087,'el','Î‘Î¦Îœ',0),(471118,13087,'zh','ç¨Žå·',0),(471119,13087,'sv','Momsnummer',0),(471120,13087,'it','Numero fiscale',0),(471121,13087,'tl','',0),(471122,13087,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸ à¸²à¸©à¸µ',0),(471123,13087,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¨à¤‚à¤¬à¤°',0),(471124,13087,'ms','Nombor cukai',0),(471125,13087,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(471126,13087,'fr','NumÃ©ro fiscal',0),(471127,13087,'jp','ç¨Žç•ªå·',0),(471128,13087,'pt','NÃºmero de contribuinte',0),(471129,13087,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(471130,13087,'es','NÃºmero de Contribuyente',0),(471131,13087,'de','Steuernummer',0),(471132,13087,'en','Tax Number',0),(471133,13088,'is','',0),(471134,13088,'dr','ÙÙ‚Ø· Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ ØªØ¨ ÙˆÛŒØ±Ø§ÛŒØ´  Ø±Ø§Ø¯Ø± ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÛŒ Ù†Ù…Ø§ÛŒØ´ Ø¯Ù‡Ø¯  ',0),(471135,13088,'pr','ÙÙ‚Ø· Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ ØªØ¨ ÙˆÛŒØ±Ø§ÛŒØ´  Ø±Ø§Ø¯Ø± ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÛŒ Ù†Ù…Ø§ÛŒØ´ Ø¯Ù‡Ø¯  ',0),(471136,13088,'tr','YalnÄ±zca GÃ¶rÃ¼nÃ¼m sekmesinde MÃ¼ÅŸteri sayfayÄ± dÃ¼zenleyebilir miyim',0),(471137,13088,'pl','Tylko widok edytowaÄ‡ kartÄ™ na stronie klienta',0),(471138,13088,'bg','ÐœÐ¾Ð¶Ðµ ÑÐ°Ð¼Ð¾ Ð¸Ð·Ð³Ð»ÐµÐ´ Ñ€Ð°Ð·Ð´ÐµÐ» \"Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ\" Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(471139,13088,'ur','ØµØ±Ù Ù…Ù†Ø¸Ø± Ø¬Ø¯ÙˆÙ„ Ù¾Ø± Ú©Ø³Ù¹Ù…Ø± ØµÙØ­Û ØªØ¯ÙˆÛŒÙ† Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(471140,13088,'sr','ÐœÐ¾Ð³Ñƒ ÑÐ°Ð¼Ð¾ Ð¿Ñ€Ð¸ÐºÐ°Ð· ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° \"Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ\" Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÐºÑƒÐ¿Ñ†Ð°',0),(471141,13088,'vi','Chá»‰ cÃ³ thá»ƒ xem thanh Ä‘ia62uchá»‰nh trÃªn trang KhÃ¡ch hÃ ng',0),(471142,13088,'af','Kan net bekyk oortjie op kliÃ«nt bladsy redigeer',0),(471143,13088,'ro','EditeazÄƒ doar Vezi Tab pe pagina de client',0),(471144,13088,'et','Saab ainult vaates redigeerida vahekaardil klient lehele',0),(471145,13088,'si','Lahko samo pogled izdajati zanka na stran kupca',0),(471146,13088,'ba','Dapat hanya Lihat mengedit Tab pada halaman pelanggan',0),(471147,13088,'nl','Alleen weergave kan tabblad op klantenpagina bewerken',0),(471148,13088,'fi','Vain muokata asiakkaan sivun vÃ¤lilehteÃ¤',0),(471149,13088,'no','Redigerer bare Vis kategorien pÃ¥ kundens side',0),(471150,13088,'da','Kun se kan redigere fane pÃ¥ kundens side',0),(471151,13088,'ko','ë§Œ ë³´ê¸° ê³ ê° íŽ˜ì´ì§€ì— íƒ­ì„ ìˆ˜ì •í•  ìˆ˜ ìžˆìŠµë‹ˆê¹Œ',0),(471152,13088,'he','×”×× ×¨×§ ×”×ª×¦×•×’×” ×œ×¢×¨×•×š ×œ×©×•× ×™×ª ×‘×“×£ ×œ×§×•×—×•×ª',0),(471153,13088,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î¼ÏŒÎ½Î¿ Î¬Ï€Î¿ÏˆÎ· ÎºÎ±ÏÏ„Î­Î»Î± \"Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±\" ÏƒÏ„Î· ÏƒÎµÎ»Î¯Î´Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(471154,13088,'zh','å¯ä»¥åªæŸ¥çœ‹ç¼–è¾‘å®¢æˆ·é¡µä¸Šçš„é€‰é¡¹å¡å—',0),(471155,13088,'sv','Endast Visa kan redigera Tab pÃ¥ kundens sida',0),(471156,13088,'it','PuÃ² solo visualizzazione modifica scheda cliente pagina',0),(471157,13088,'tl','',0),(471158,13088,'th','à¸”à¸¹à¹€à¸‰à¸žà¸²à¸°à¹à¸à¹‰à¹„à¸‚à¹à¸—à¹‡à¸šà¸«à¸™à¹‰à¸²à¸¥à¸¹à¸à¸„à¹‰à¸²à¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(471159,13088,'hi','à¤•à¥‡à¤µà¤² à¤¦à¥ƒà¤¶à¥à¤¯ à¤Ÿà¥ˆà¤¬ à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(471160,13088,'ms','Boleh lihat hanya mengedit Tab halaman pelanggan',0),(471161,13088,'ar','ÙŠÙ…ÙƒÙ† ÙÙ‚Ø· Ø¹Ø±Ø¶ ØªØ­Ø±ÙŠØ± Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¨ÙˆÙŠØ¨ Ø¹Ù„Ù‰ ØµÙØ­Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(471162,13088,'fr','Peut seulement vue modifier onglet page client',0),(471163,13088,'jp','ãƒ“ãƒ¥ãƒ¼ã®ã¿é¡§å®¢ãƒšãƒ¼ã‚¸ã®ã‚¿ãƒ–ã‚’ç·¨é›†ã§ãã¾ã™ã€‚',0),(471164,13088,'pt','Pode apenas Exibir Editar guia na pÃ¡gina do cliente',0),(471165,13088,'ru','ÐœÐ¾Ð¶Ð½Ð¾ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²ÐºÐ»Ð°Ð´ÐºÑƒ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‡Ð¸ÐºÐ°',0),(471166,13088,'es','Solo Puede Ver Tab de Editar en la PÃ¡gina de Cliente',0),(471167,13088,'de','Nur Ansicht kann auf Kundenseite Registerkarte Bearbeiten',0),(471168,13088,'en','Can Only View Edit Tab On Customer Page',0),(471169,13089,'is','',0),(471170,13089,'dr','Ø¬Ù‡Øª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø¨Ù‡ Ø¢Ø®Ø±ÛŒÙ† ÙˆØ±Ú˜Ù† Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø§Ø² Ø¯Ø§Ø®Ù„ Ø³Ø§ÛŒØª Ø§ÛŒÙ† Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ Ø±Ø§ Ø¯Ù†Ø¨Ø§Ù„ Ú©Ù†ÛŒØ¯ ',0),(471171,13089,'pr','Ø¬Ù‡Øª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø¨Ù‡ Ø¢Ø®Ø±ÛŒÙ† ÙˆØ±Ú˜Ù† Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø§Ø² Ø¯Ø§Ø®Ù„ Ø³Ø§ÛŒØª Ø§ÛŒÙ† Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ Ø±Ø§ Ø¯Ù†Ø¨Ø§Ù„ Ú©Ù†ÛŒØ¯ ',0),(471172,13089,'tr','NolaPro son sÃ¼rÃ¼mÃ¼ iÃ§inden gÃ¼ncelleÅŸtirmek iÃ§in aÅŸaÄŸÄ±daki talimatlarÄ± izleyin.',0),(471173,13089,'pl','Do aktualizacji z poziomu NolaPro do najnowszej wersji, wykonaj nastÄ™pujÄ…ce czynnoÅ›ci.',0),(471174,13089,'bg','Ð—Ð° Ð´Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚Ðµ Ð¾Ñ‚ Ð²ÑŠÑ‚Ñ€Ðµ NolaPro Ð´Ð¾ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð°Ñ‚Ð° Ð²ÐµÑ€ÑÐ¸Ñ ÑÐ»ÐµÐ´Ð²Ð°Ð¹Ñ‚Ðµ Ñ‚ÐµÐ·Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸.',0),(471175,13089,'ur','Ø§Ù†Ø¯Ø± Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ ØªØ§Ø²Û ØªØ±ÛŒÙ† ÙˆØ±Ú˜Ù† Ú©Û’ Ù„Ø¦Û’ Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ú©ÛŒ Ù¾ÛŒØ±ÙˆÛŒ Ú©Ø±ÛŒÚº Ø§Ù† ÛØ¯Ø§ÛŒØ§Øª Û”',0),(471176,13089,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð»Ð¸ Ð¸Ð·Ð½ÑƒÑ‚Ñ€Ð° ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð½Ð° Ð½Ð°Ñ˜Ð½Ð¾Ð²Ð¸Ñ˜Ñƒ Ð²ÐµÑ€Ð·Ð¸Ñ˜Ñƒ Ð¸ Ð¿Ñ€Ð°Ñ‚Ð¸ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°.',0),(471177,13089,'vi','Äá»ƒ cáº­p nháº­t phiÃªn báº£n má»›i nháº¥t NolaPro lÃ m theo nhá»¯ng hÆ°á»›ng dáº«n sau',0),(471178,13089,'af','Om te werk van binne NolaPro na die jongste weergawe volg hierdie instruksies.',0),(471179,13089,'ro','Pentru a actualiza din cadrul NolaPro la ultima versiune urmaÅ£i aceste instrucÅ£iuni.',0),(471180,13089,'et','VÃ¤rskendamiseks rakenduses NolaPro uusimaks jÃ¤rgige neid juhiseid.',0),(471181,13089,'si','Posodobiti od znotraj NolaPro na najnovejÅ¡o razliÄico, sledite tem navodilom.',0),(471182,13089,'ba','Untuk memperbarui dari dalam NolaPro ke versi terbaru ikuti petunjuk ini.',0),(471183,13089,'nl','Als u wilt bijwerken vanuit NolaPro naar de nieuwste versie Volg deze instructies.',0),(471184,13089,'fi','PÃ¤ivittÃ¤Ã¤ kÃ¤sin NolaPro uusimman version noudattamalla nÃ¤itÃ¤ ohjeita.',0),(471185,13089,'no','FÃ¸lg disse instruksjonene for Ã¥ oppdatere innenfra NolaPro til den nyeste versjonen.',0),(471186,13089,'da','NolaPro til den nyeste version FÃ¸lg disse instruktioner for at opdatere indefra.',0),(471187,13089,'ko','ë‚´ì—ì„œ ì—…ë°ì´íŠ¸ë¥¼ ìµœì‹  ë²„ì „ìœ¼ë¡œ NolaPro ë‹¤ìŒì´ ì§€ì¹¨ì„ ë”°ë¥´ì‹­ì‹œì˜¤.',0),(471188,13089,'he','×›×“×™ ×œ×¢×“×›×Ÿ ×ž×‘×¤× ×™× NolaPro ××ª ×”×’×¨×¡×” ×‘×¦×¢ ×”×•×¨××•×ª ××œ×”.',0),(471189,13089,'el','Î“Î¹Î± Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€ÏŒ Ï„Î¿ ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÏŒ NolaPro ÏƒÏ„Î·Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î­ÎºÎ´Î¿ÏƒÎ·, Î±ÎºÎ¿Î»Î¿Ï…Î¸Î®ÏƒÏ„Îµ Î±Ï…Ï„Î­Ï‚ Ï„Î¹Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚.',0),(471190,13089,'zh','ä»Žå†…éƒ¨è¿›è¡Œæ›´æ–°åˆ°æœ€æ–°ç‰ˆæœ¬çš„ NolaProï¼Œè¯·æŒ‰ç…§è¿™äº›è¯´æ˜Žã€‚',0),(471191,13089,'sv','NolaPro till den senaste versionen FÃ¶lj dessa instruktioner fÃ¶r att uppdatera inifrÃ¥n.',0),(471192,13089,'it','Per aggiornare da dentro NolaPro all\'ultima versione seguire queste istruzioni.',0),(471193,13089,'tl','',0),(471194,13089,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ˆà¸²à¸à¸ à¸²à¸¢à¹ƒà¸™ NolaPro à¸£à¸¸à¹ˆà¸™à¸¥à¹ˆà¸²à¸ªà¸¸à¸”à¸•à¸²à¸¡à¸„à¸³à¹à¸™à¸°à¸™à¸³à¹€à¸«à¸¥à¹ˆà¸²à¸™à¸µà¹‰',0),(471195,13089,'hi','NolaPro à¤¨à¤µà¥€à¤¨à¤¤à¤® à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¨ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¤¾ à¤ªà¤¾à¤²à¤¨ à¤•à¤°à¥‡à¤‚à¥¤',0),(471196,13089,'ms','Untuk mengemas kini dalam NolaPro kepada versi terkini ikuti arahan.',0),(471197,13089,'ar','Ù„ØªØ­Ø¯ÙŠØ« Ù…Ù† Ø¯Ø§Ø®Ù„ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ø¥Ù„Ù‰ Ø§Ù„Ø¥ØµØ¯Ø§Ø± Ø§Ù„Ø£Ø­Ø¯Ø« Ø§ØªØ¨Ø¹ Ù‡Ø°Ù‡ Ø§Ù„Ø¥Ø±Ø´Ø§Ø¯Ø§Øª.',0),(471198,13089,'fr','Pour mettre Ã  jour de l\'intÃ©rieur, NolaPro vers la derniÃ¨re version suivez ces instructions.',0),(471199,13089,'jp','æœ€æ–°ã®ãƒãƒ¼ã‚¸ãƒ§ãƒ³ã« NolaPro å†…ã‹ã‚‰ã‚’æ›´æ–°ã™ã‚‹ã«ã¯ã€ã¯ã€æ¬¡ã®æ‰‹é †ã‚’å®Ÿè¡Œã—ã¾ã™ã€‚',0),(471200,13089,'pt','Para atualizar de dentro NolaPro para a versÃ£o mais recente siga estas instruÃ§Ãµes.',0),(471201,13089,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¸Ð·Ð½ÑƒÑ‚Ñ€Ð¸ NolaPro Ðº Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ¹ Ð²ÐµÑ€ÑÐ¸Ð¸ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚Ðµ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸.',0),(471202,13089,'es','Para actualizar dentro de NolaPro a la versiÃ³n actual sigue stas instrucciones',0),(471203,13089,'de','Um von innen zu aktualisieren Artikel auf die neueste Version folgen Sie diesen Anweisungen.',0),(471204,13089,'en','To update from within NolaPro to the latest version follow these instructions.',0),(471205,13090,'is','',0),(471206,13090,'dr','-Ú¯Ø²ÛŒÙ†Ù‡ 1',0),(471207,13090,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ-Ú¯Ø²ÛŒÙ†Ù‡ 1',0),(471208,13090,'tr','1. seÃ§enek Rehberi - gÃ¼ncelleme',0),(471209,13090,'pl','Aktualizacja Przewodnik - opcja 1',0),(471210,13090,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€ÑŠÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ - Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ 1',0),(471211,13090,'ur','Ø§Ø®ØªÛŒØ§Ø± 1 Ú¯Ø§Ø¦ÛŒÚˆ - ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(471212,13090,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð²Ð¾Ð´Ð¸Ñ‡ - Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° 1',0),(471213,13090,'vi','HÆ°á»›ng dáº«n cáº­p nhÃ¢t- bÆ°á»›c 1',0),(471214,13090,'af','Werk gids - opsie 1',0),(471215,13090,'ro','Actualizare ghid - opÅ£iunea 1',0),(471216,13090,'et','Uuendatud juhend - variant 1',0),(471217,13090,'si','Posodobite vodnik - moÅ¾nost 1',0),(471218,13090,'ba','Memperbarui panduan - opsi 1',0),(471219,13090,'nl','Update gids - optie 1',0),(471220,13090,'fi','PÃ¤ivitÃ¤ opas - vaihtoehto 1',0),(471221,13090,'no','Oppdatere Guide - alternativ 1',0),(471222,13090,'da','Opdatere Guide - indstilling 1',0),(471223,13090,'ko','ì—…ë°ì´íŠ¸ ê°€ì´ë“œ-ì˜µì…˜ 1',0),(471224,13090,'he','×¢×“×›×•×Ÿ ×¡×™×˜×™ - ××¤×©×¨×•×ª 1',0),(471225,13090,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Î¿Î´Î·Î³ÏŒÏ‚ - ÎµÏ€Î¹Î»Î¿Î³Î® 1',0),(471226,13090,'zh','æ›´æ–°æŒ‡å—-å¤‡é€‰æ¡ˆæ–‡ 1',0),(471227,13090,'sv','Uppdatera Guide - alternativ 1',0),(471228,13090,'it','Aggiornamento guida - opzione 1',0),(471229,13090,'tl','',0),(471230,13090,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸„à¸¹à¹ˆà¸¡à¸·à¸­ - à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸—à¸µà¹ˆ 1',0),(471231,13090,'hi','à¤—à¤¾à¤‡à¤¡ - à¤µà¤¿à¤•à¤²à¥à¤ª 1 à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(471232,13090,'ms','Kemaskini Terakhir panduan - pilihan 1',0),(471233,13090,'ar','ØªØ­Ø¯ÙŠØ« Ø¯Ù„ÙŠÙ„--Ø§Ù„Ø®ÙŠØ§Ø± 1',0),(471234,13090,'fr','Mise Ã  jour du Guide - Option 1',0),(471235,13090,'jp','æ›´æ–°ã‚¬ã‚¤ãƒ‰ - ã‚ªãƒ—ã‚·ãƒ§ãƒ³ 1',0),(471236,13090,'pt','AtualizaÃ§Ã£o guia - opÃ§Ã£o 1',0),(471237,13090,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Guide - Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ 1',0),(471238,13090,'es','Guia de Actualizaciones - OpciÃ³n 1',0),(471239,13090,'de','Update Guide - Option 1',0),(471240,13090,'en','Update Guide - Option 1',0),(471241,13091,'is','',0),(471242,13091,'dr','Ø¬Ù‡Øª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø¨Ù‡ Ø¢Ø®Ø±ÛŒÙ† ÙˆØ±Ú˜Ù† Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±Ø§ÛŒÙ† Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ Ø±Ø§ Ø¯Ù†Ø¨Ø§Ù„ Ú©Ù†ÛŒØ¯ ',0),(471243,13091,'pr','Ø¬Ù‡Øª Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ø¨Ù‡ Ø¢Ø®Ø±ÛŒÙ† ÙˆØ±Ú˜Ù† Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±Ø§ÛŒÙ† Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ù‡Ø§ Ø±Ø§ Ø¯Ù†Ø¨Ø§Ù„ Ú©Ù†ÛŒØ¯ ',0),(471244,13091,'tr','NolaPro sitesinden en son gÃ¼ncelleÅŸtirmesini karÅŸÄ±dan yÃ¼klemek iÃ§in aÅŸaÄŸÄ±daki talimatlarÄ± izleyin.',0),(471245,13091,'pl','Aby pobraÄ‡ najnowszÄ… aktualizacjÄ™ z witryny NolaPro wykonaj nastÄ™pujÄ…ce czynnoÅ›ci.',0),(471246,13091,'bg','Ð—Ð° Ð´Ð° Ð¸Ð·Ñ‚ÐµÐ³Ð»Ð¸Ñ‚Ðµ Ð½Ð°Ð¹-Ð½Ð¾Ð²Ð°Ñ‚Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¾Ñ‚ ÑÐ°Ð¹Ñ‚Ð° Ð½Ð° NolaPro ÑÐ»ÐµÐ´Ð²Ð°Ð¹Ñ‚Ðµ Ñ‚ÐµÐ·Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸.',0),(471247,13091,'ur','ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§ Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ø³Ø§Ø¦Ù¹ Ø³Û’ ØªØ§Ø²Û ØªØ±ÛŒÙ† Ø§Ù¾ ÚˆÛŒÙ¹ Ú©ÛŒ Ù¾ÛŒØ±ÙˆÛŒ Ø§Ù† ÛØ¯Ø§ÛŒØ§Øª Û”',0),(471248,13091,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÐ»Ð¸ Ð½Ð°Ñ˜Ð½Ð¾Ð²Ð¸Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÐ° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð¸ Ð¿Ñ€Ð°Ñ‚Ð¸ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°.',0),(471249,13091,'vi','Äáº» táº£i phiÃªn báº£n má»›i nháº¥t cá»§a NolaPro lÃ m theo nhá»¯ng hÆ°á»›ng dáº«n sau',0),(471250,13091,'af','Die jongste bywerking aflaai vanaf die NolaPro webwerf, volg hierdie instruksies.',0),(471251,13091,'ro','Pentru a descÄƒrca cea mai recentÄƒ actualizare de la site-ul NolaPro urmaÅ£i aceste instrucÅ£iuni.',0),(471252,13091,'et','Alla laadida uusima vÃ¤rskenduse saidilt NolaPro jÃ¤rgige neid juhiseid.',0),(471253,13091,'si','V travnato griÄevje ki postaja latenten modernizirati s strani NolaPro sledite tem navodilom.',0),(471254,13091,'ba','Untuk men-download update terbaru dari situs NolaPro ikuti petunjuk ini.',0),(471255,13091,'nl','De meest recente update van de site NolaPro Voer deze instructies om te downloaden.',0),(471256,13091,'fi','Lataa uusin pÃ¤ivitys NolaPro-sivustosta seuraavasti.',0),(471257,13091,'no','For Ã¥ laste ned den nyeste oppdateringen fra webomrÃ¥det NolaPro FÃ¸lg instruksjonene.',0),(471258,13091,'da','Du kan hente den nyeste opdatering fra webstedet NolaPro fÃ¸lge disse instruktioner.',0),(471259,13091,'ko','ë‹¤ìš´ë¡œë“œ í•˜ë ¤ë©´ NolaPro ì‚¬ì´íŠ¸ì—ì„œ ìµœì‹  ì—…ë°ì´íŠ¸ëŠ” ë‹¤ìŒì´ ì§€ì¹¨ì„ ë”°ë¥´ì‹­ì‹œì˜¤.',0),(471260,13091,'he','×›×“×™ ×œ×”×•×¨×™×“ ×”×¢×“×›×•×Ÿ ×”××—×¨×•×Ÿ ×‘××ª×¨ NolaPro ×‘×¦×¢ ×”×•×¨××•×ª ××œ×”.',0),(471261,13091,'el','ÎÎ± ÎºÎ±Ï„ÎµÎ²Î¬ÏƒÎµÏ„Îµ Ï„Î·Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€ÏŒ Ï„Î·Î½ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± NolaPro, Î±ÎºÎ¿Î»Î¿Ï…Î¸Î®ÏƒÏ„Îµ Î±Ï…Ï„Î­Ï‚ Ï„Î¹Ï‚ Î¿Î´Î·Î³Î¯ÎµÏ‚.',0),(471262,13091,'zh','è¦ä¸‹è½½æœ€æ–°çš„æ›´æ–°ï¼Œä»Ž NolaPro ç«™ç‚¹ï¼Œè¯·æŒ‰ç…§è¿™äº›è¯´æ˜Žã€‚',0),(471263,13091,'sv','Du kan hÃ¤mta den senaste uppdateringen frÃ¥n webbplatsen NolaPro FÃ¶lj dessa instruktioner.',0),(471264,13091,'it','Per scaricare l\'ultimo aggiornamento dal sito NolaPro seguire queste istruzioni.',0),(471265,13091,'tl','',0),(471266,13091,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¹ˆà¸²à¸ªà¸¸à¸”à¸ˆà¸²à¸à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ NolaPro à¸—à¸³à¸•à¸²à¸¡à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¹€à¸«à¸¥à¹ˆà¸²à¸™à¸µà¹‰à¹€à¸žà¸·à¹ˆà¸­à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”',0),(471267,13091,'hi','NolaPro à¤¸à¤¾à¤‡à¤Ÿ à¤¸à¥‡ à¤¨à¤µà¥€à¤¨à¤¤à¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¨ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¤¾ à¤ªà¤¾à¤²à¤¨ à¤•à¤°à¥‡à¤‚à¥¤',0),(471268,13091,'ms','Untuk memuat turun Kemaskini dari tapak NolaPro ikuti arahan.',0),(471269,13091,'ar','Ù„ØªØ­Ù…ÙŠÙ„ Ø¢Ø®Ø± ØªØ­Ø¯ÙŠØ« Ù…Ù† Ù…ÙˆÙ‚Ø¹ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ø§ØªØ¨Ø¹ Ù‡Ø°Ù‡ Ø§Ù„Ø¥Ø±Ø´Ø§Ø¯Ø§Øª.',0),(471270,13091,'fr','Pour tÃ©lÃ©charger la derniÃ¨re mise Ã  jour du site NolaPro suivez ces instructions.',0),(471271,13091,'jp','NolaPro ã‚µã‚¤ãƒˆã‹ã‚‰æœ€æ–°ã®æ›´æ–°ãƒ—ãƒ­ã‚°ãƒ©ãƒ ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã™ã‚‹ã«ã¯ã€æ¬¡ã®æ‰‹é †ã‚’å®Ÿè¡Œã—ã¾ã™ã€‚',0),(471272,13091,'pt','Para baixar a atualizaÃ§Ã£o mais recente do site NolaPro siga estas instruÃ§Ãµes.',0),(471273,13091,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð·Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ñ ÑÐ°Ð¹Ñ‚Ð° NolaPro Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚Ðµ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸.',0),(471274,13091,'es','Para descargar la actualizaciÃ³n actual de sitio de NolaPro sigue estas instrucciones',0),(471275,13091,'de','Zum download das neueste Update von der Website Artikel befolgen Sie diese Anweisungen.',0),(471276,13091,'en','To download the latest update from the NolaPro site follow these instructions.',0),(471277,13092,'is','',0),(471278,13092,'dr','- Ú¯Ø²ÛŒÙ†Ù‡ 2',0),(471279,13092,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ- Ú¯Ø²ÛŒÙ†Ù‡ 2',0),(471280,13092,'tr','KÄ±lavuzu - seÃ§enek 2 gÃ¼ncelleme',0),(471281,13092,'pl','Aktualizacja Przewodnik - opcja 2',0),(471282,13092,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€ÑŠÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ - Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ 2',0),(471283,13092,'ur','ÛØ¯Ø§ÛŒØª Ù†Ø§Ù…Û - Ø§Ø®ØªÛŒØ§Ø± 2 Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(471284,13092,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð²Ð¾Ð´Ð¸Ñ‡ - Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° 2',0),(471285,13092,'vi','HÆ°á»›ng dáº«n cáº­p nhÃ¢t- bÆ°á»›c 2',0),(471286,13092,'af','Werk gids - opsie 2',0),(471287,13092,'ro','Actualizare ghid - opÅ£iunea 2',0),(471288,13092,'et','Uuendatud juhend - variant 2',0),(471289,13092,'si','Posodobite vodnik - moÅ¾nost 2',0),(471290,13092,'ba','Memperbarui panduan - opsi 2',0),(471291,13092,'nl','Update gids - optie 2',0),(471292,13092,'fi','PÃ¤ivitÃ¤ opas - vaihtoehto 2',0),(471293,13092,'no','Oppdatere Guide - alternativ 2',0),(471294,13092,'da','Opdatere Guide - indstilling 2',0),(471295,13092,'ko','ì—…ë°ì´íŠ¸ ê°€ì´ë“œ-ì˜µì…˜ 2',0),(471296,13092,'he','×”××¤×©×¨×•×ª 2 ×¢×“×›×•×Ÿ ×¡×™×˜×™-',0),(471297,13092,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Î¿Î´Î·Î³ÏŒÏ‚ - ÎµÏ€Î¹Î»Î¿Î³Î® 2',0),(471298,13092,'zh','æ›´æ–°æŒ‡å—-å¤‡é€‰æ¡ˆæ–‡ 2',0),(471299,13092,'sv','Uppdatera Guide - alternativ 2',0),(471300,13092,'it','Aggiornamento guida - opzione 2',0),(471301,13092,'tl','',0),(471302,13092,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¹à¸™à¸°à¸™à¸³ - à¹à¸šà¸šà¸—à¸µà¹ˆ 2',0),(471303,13092,'hi','à¤—à¤¾à¤‡à¤¡ - 2 à¤µà¤¿à¤•à¤²à¥à¤ª à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(471304,13092,'ms','Kemaskini Terakhir panduan - pilihan 2',0),(471305,13092,'ar','ØªØ­Ø¯ÙŠØ« Ø¯Ù„ÙŠÙ„--Ø§Ù„Ø®ÙŠØ§Ø± 2',0),(471306,13092,'fr','Mise Ã  jour du Guide - Option 2',0),(471307,13092,'jp','æ›´æ–°ã‚¬ã‚¤ãƒ‰ - ã‚ªãƒ—ã‚·ãƒ§ãƒ³ 2',0),(471308,13092,'pt','AtualizaÃ§Ã£o guia - opÃ§Ã£o 2',0),(471309,13092,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Guide - Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ 2',0),(471310,13092,'es','Guia de ActualizaciÃ³n - OpciÃ³n 2',0),(471311,13092,'de','Update Guide - Variante 2',0),(471312,13092,'en','Update Guide - Option 2',0),(471313,13093,'is','',0),(471314,13093,'dr','A4',0),(471315,13093,'pr','A4',0),(471316,13093,'tr','A4',0),(471317,13093,'pl','A4',0),(471318,13093,'bg','A4',0),(471319,13093,'ur','A4',0),(471320,13093,'sr','Ð4',0),(471321,13093,'vi','A4',0),(471322,13093,'af','A4',0),(471323,13093,'ro','A4',0),(471324,13093,'et','A4',0),(471325,13093,'si','A4',0),(471326,13093,'ba','A4',0),(471327,13093,'nl','A4',0),(471328,13093,'fi','A4',0),(471329,13093,'no','A4',0),(471330,13093,'da','A4',0),(471331,13093,'ko','A4',0),(471332,13093,'he','A4',0),(471333,13093,'el','Î‘4',0),(471334,13093,'zh','A4',0),(471335,13093,'sv','A4',0),(471336,13093,'it','A4',0),(471337,13093,'tl','',0),(471338,13093,'th','A4',0),(471339,13093,'hi','A4',0),(471340,13093,'ms','A4',0),(471341,13093,'ar','A4',0),(471342,13093,'fr','A4',0),(471343,13093,'jp','A4',0),(471344,13093,'pt','A4',0),(471345,13093,'ru','A4',0),(471346,13093,'es','A4',0),(471347,13093,'de','A4',0),(471348,13093,'en','A4',0),(471349,13094,'is','',0),(471350,13094,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ú©Ø§Ù„Ø§ Ø¨Ø±Ø§ÛŒ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(471351,13094,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ú©Ø§Ù„Ø§ Ø¨Ø±Ø§ÛŒ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(471352,13094,'tr','VarsayÄ±lan madde maliyetlerinin SatÄ±cÄ± fiyat',0),(471353,13094,'pl','DomyÅ›lnie element kosztÃ³w do dostawcy ceny',0),(471354,13094,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(471355,13094,'ur','Ø·Û’ Ø´Ø¯Û Ø´Û’ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©Ø±Ù†Ø§',0),(471356,13094,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ñƒ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(471357,13094,'vi','máº·c Ä‘á»‹nh chi phÃ­ hÃ ng hÃ²a cho giÃ¡ cá»§a nhÃ  cung cáº¥p',0),(471358,13094,'af','Verstek Item koste na handelaar pryse',0),(471359,13094,'ro','Costurile de element implicit furnizor de stabilire a preÅ£urilor',0),(471360,13094,'et','Vaikimisi kauba kulud hankija hinnakujundus',0),(471361,13094,'si','Privzeti element stroÅ¡ke dobavitelju cen',0),(471362,13094,'ba','Default Item biaya untuk Vendor harga',0),(471363,13094,'nl','Standaarditem kosten aan leverancier prijzen',0),(471364,13094,'fi','Oletusarvo maksaa toimittajalle hinnoittelu',0),(471365,13094,'no','Standard kostnader leverandÃ¸r priser',0),(471366,13094,'da','Standard vareomkostninger til kreditor prissÃ¦tning',0),(471367,13094,'ko','ê¸°ë³¸ í•­ëª© ë¹„ìš© ê°€ê²© ê³µê¸‰ ì—…ì²´',0),(471368,13094,'he','×¢×œ×•×™×•×ª ×¤×¨×™×˜ ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×œ×¡×¤×§ ×ª×ž×—×•×¨',0),(471369,13094,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(471370,13094,'zh','é»˜è®¤ç‰©æ–™æˆæœ¬å‘ä¾›åº”å•†çš„å®šä»·',0),(471371,13094,'sv','Standard artikelkostnader till leverantÃ¶r prissÃ¤ttning',0),(471372,13094,'it','Costi di elemento predefinito al fornitore prezzi',0),(471373,13094,'tl','',0),(471374,13094,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸à¸²à¸£à¸à¸³à¸«à¸™à¸”à¸£à¸²à¸„à¸²',0),(471375,13094,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤²à¤¾à¤—à¤¤ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤',0),(471376,13094,'ms','Kos perkara lalai kepada penjual harga',0),(471377,13094,'ar','ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ø¨Ø§Ø¦Ø¹ Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(471378,13094,'fr','CoÃ»ts d\'article par dÃ©faut au fournisseur prix',0),(471379,13094,'jp','æ—¢å®šã®ã‚¢ã‚¤ãƒ†ãƒ ä¾¡æ ¼ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã«ã‚³ã‚¹ãƒˆ',0),(471380,13094,'pt','Custos de Item padrÃ£o para fornecedor preÃ§os',0),(471381,13094,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ñ†ÐµÐ½Ñ‹',0),(471382,13094,'es','Costo de Items a Precios de Proveedor Por Defecto ',0),(471383,13094,'de','Standard-Gegenstand-Preise an Lieferanten, die Preise',0),(471384,13094,'en','Default Item Costs To Vendor Pricing',0),(471385,13095,'is','',0),(471386,13095,'dr','ÙØ§Ú©ØªÙˆØ± Ùˆ Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµÙØ­Ù‡ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(471387,13095,'pr','ÙØ§Ú©ØªÙˆØ± Ùˆ Ø§Ù†Ø¯Ø§Ø²Ù‡ ØµÙØ­Ù‡ ØµÙˆØ±Øª ÙˆØ¶Ø¹ÛŒØª',0),(471388,13095,'tr','Fatura & deyim kaÄŸÄ±t boyutu',0),(471389,13095,'pl','Faktura & rozmiar papieru instrukcja',0),(471390,13095,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° & Ð´ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° Ñ…Ð°Ñ€Ñ‚Ð¸ÑÑ‚Ð°',0),(471391,13095,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ & Ø¨ÛŒØ§Ù† Ú©Ø§ØºØ° Ú©Ø§ Ø³Ø§Ø¦Ø²',0),(471392,13095,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ & Ð¸Ð·Ñ˜Ð°Ð²Ð° Ð²ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ðµ Ð¿Ð°Ð¿Ð¸Ñ€Ð°',0),(471393,13095,'vi','cá»¡ giáº¥y hÃ³a Ä‘Æ¡n vÃ  báº£ng kÃª',0),(471394,13095,'af','Faktuur & stelling papiergrootte',0),(471395,13095,'ro','FacturÄƒ & dimensiune de hÃ¢rtie declaraÅ£ia',0),(471396,13095,'et','Arve & aruande paberiformaadi',0),(471397,13095,'si','RaÄun & izjavo velikost papirja',0),(471398,13095,'ba','Faktur & ukuran kertas pernyataan',0),(471399,13095,'nl','Factuur & verklaring papierformaat',0),(471400,13095,'fi','Laskun & ilmoitus paperikoko',0),(471401,13095,'no','Faktura & uttalelse papirstÃ¸rrelse',0),(471402,13095,'da','Faktura & erklÃ¦ring papirstÃ¸rrelse',0),(471403,13095,'ko','ì†¡ìž¥ & ë¬¸ ìš©ì§€ í¬ê¸°',0),(471404,13095,'he','×—×©×‘×•× ×™×ª & ×’×•×“×œ × ×™×™×¨ ×”×¦×”×¨×”',0),(471405,13095,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ & Î´Î®Î»Ï‰ÏƒÎ· Î¼Î­Î³ÎµÎ¸Î¿Ï‚ Ï‡Î±ÏÏ„Î¹Î¿Ï',0),(471406,13095,'zh','å‘ç¥¨ &amp; è¯­å¥çº¸å¼ å¤§å°',0),(471407,13095,'sv','Faktura & uttalande pappersstorlek',0),(471408,13095,'it','Fattura & istruzione formato carta',0),(471409,13095,'tl','',0),(471410,13095,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ & à¸‚à¸™à¸²à¸”à¸à¸£à¸°à¸”à¸²à¸©à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(471411,13095,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ & à¤¬à¤¯à¤¾à¤¨ à¤•à¤¾à¤—à¤œà¤¼ à¤•à¥‡ à¤†à¤•à¤¾à¤°',0),(471412,13095,'ms','Invois & saiz kertas penyata',0),(471413,13095,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¢Ù†Ø¯ Ø¨ÙŠØ§Ù† Ø­Ø¬Ù… Ø§Ù„ÙˆØ±Ù‚',0),(471414,13095,'fr','Facture & dÃ©claration format de papier',0),(471415,13095,'jp','è«‹æ±‚æ›¸ & ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆç”¨ç´™ã‚µã‚¤ã‚º',0),(471416,13095,'pt','Fatura & tamanho de declaraÃ§Ã£o de papel',0),(471417,13095,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° & Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð±ÑƒÐ¼Ð°Ð³Ð¸',0),(471418,13095,'es','Factura y Extracto TamaÃ±o de Papel',0),(471419,13095,'de','Rechnung & Anweisung Papierformat',0),(471420,13095,'en','Invoice & Statement Paper Size',0),(471421,13096,'is','',0),(471422,13096,'dr','Ù†Ø§Ù…Ù‡',0),(471423,13096,'pr','Ù†Ø§Ù…Ù‡',0),(471424,13096,'tr','Mektup',0),(471425,13096,'pl','List',0),(471426,13096,'bg','ÐŸÐ¸ÑÐ¼Ð¾',0),(471427,13096,'ur','Ø­Ø±Ù',0),(471428,13096,'sr','ÐŸÐ¸ÑÐ¼Ð¾',0),(471429,13096,'vi','ThÆ°',0),(471430,13096,'af','Brief',0),(471431,13096,'ro','Scrisoare',0),(471432,13096,'et','TÃ¤ht',0),(471433,13096,'si','Pismo',0),(471434,13096,'ba','Surat',0),(471435,13096,'nl','Brief',0),(471436,13096,'fi','Kirje',0),(471437,13096,'no','Brev',0),(471438,13096,'da','Brev',0),(471439,13096,'ko','íŽ¸ì§€',0),(471440,13096,'he','×ž×›×ª×‘',0),(471441,13096,'el','Î•Ï€Î¹ÏƒÏ„Î¿Î»Î®',0),(471442,13096,'zh','ä¿¡',0),(471443,13096,'sv','Brev',0),(471444,13096,'it','Lettera',0),(471445,13096,'tl','',0),(471446,13096,'th','à¸•à¸±à¸§à¸­à¸±à¸à¸©à¸£',0),(471447,13096,'hi','à¤ªà¤¤à¥à¤°',0),(471448,13096,'ms','Surat',0),(471449,13096,'ar','Ø±Ø³Ø§Ù„Ø©',0),(471450,13096,'fr','Lettre',0),(471451,13096,'jp','æ‰‹ç´™',0),(471452,13096,'pt','Carta',0),(471453,13096,'ru','ÐŸÐ¸ÑÑŒÐ¼Ð¾',0),(471454,13096,'es','Carta',0),(471455,13096,'de','Brief',0),(471456,13096,'en','Letter',0),(471457,13097,'is','',0),(471458,13097,'dr','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ø³Ø§Ù„',0),(471459,13097,'pr','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ø³Ø§Ù„',0),(471460,13097,'tr','GeÃ§en yÄ±l Tarih',0),(471461,13097,'pl','Data ostatniego roku',0),(471462,13097,'bg','ÐœÐ¸Ð½Ð°Ð»Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(471463,13097,'ur','Ú¯Ø²Ø´ØªÛ Ø³Ø§Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(471464,13097,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¾ÑˆÐ»Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(471465,13097,'vi','NgÃ y cá»§a nÄƒm trÆ°á»›c',0),(471466,13097,'af','Datum Laas Jaar',0),(471467,13097,'ro','Data anul trecut',0),(471468,13097,'et','Eelmise aasta seisuga',0),(471469,13097,'si','Datum lani',0),(471470,13097,'ba','Tanggal tahun lalu',0),(471471,13097,'nl','Datum laatste jaar',0),(471472,13097,'fi','Edellisen vuoden pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤Ã¤n',0),(471473,13097,'no','Dato i fjor',0),(471474,13097,'da','Dato sidste Ã¥r',0),(471475,13097,'ko','ë‚ ì§œ ì§€ë‚œ 1 ë…„',0),(471476,13097,'he','×ª××¨×™×š ×‘×©× ×” ×©×¢×‘×¨×”',0),(471477,13097,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î­ÏÏ…ÏƒÎ¹',0),(471478,13097,'zh','åŽ»å¹´æ—¥æœŸ',0),(471479,13097,'sv','Datum fÃ¶rra Ã¥ret',0),(471480,13097,'it','Data dello scorso anno',0),(471481,13097,'tl','',0),(471482,13097,'th','à¸§à¸±à¸™à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢à¸‚à¸­à¸‡à¸›à¸µ',0),(471483,13097,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤¸à¤¾à¤² à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(471484,13097,'ms','Tarikh tahun',0),(471485,13097,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¹Ø§Ù… Ø§Ù„Ù…Ø§Ø¶ÙŠ',0),(471486,13097,'fr','Date de l\'an dernier',0),(471487,13097,'jp','æœ€å¾Œã®å¹´ã®æ—¥ä»˜',0),(471488,13097,'pt','Data ano passado',0),(471489,13097,'ru','Ð”Ð°Ñ‚Ñƒ Ð² Ð¿Ñ€Ð¾ÑˆÐ»Ð¾Ð¼ Ð³Ð¾Ð´Ñƒ',0),(471490,13097,'es','Fecha del AÃ±o Pasado',0),(471491,13097,'de','Datum im vergangenen Jahr',0),(471492,13097,'en','Date Last Year',0),(471493,13098,'is','',0),(471494,13098,'dr','ØªØ§Ø±ÛŒØ® Ø§ÛŒÙ† Ø³Ø§Ù„',0),(471495,13098,'pr','ØªØ§Ø±ÛŒØ® Ø§ÛŒÙ† Ø³Ø§Ù„',0),(471496,13098,'tr','Bu yÄ±lÄ±n',0),(471497,13098,'pl','Data w tym roku',0),(471498,13098,'bg','Ð¢Ð°Ð·Ð¸ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(471499,13098,'ur','Ø§Ø³ Ø³Ø§Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(471500,13098,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ð²Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(471501,13098,'vi','NgÃ y cá»§a nÄƒm nay',0),(471502,13098,'af','Datum Hierdie Jaar',0),(471503,13098,'ro','Data acest an',0),(471504,13098,'et','KÃ¤esoleva aasta',0),(471505,13098,'si','Datum letos',0),(471506,13098,'ba','Tanggal tahun ini',0),(471507,13098,'nl','Datum dit jaar',0),(471508,13098,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ tÃ¤nÃ¤ vuonna',0),(471509,13098,'no','Dato i Ã¥r',0),(471510,13098,'da','Dato Ã¥r',0),(471511,13098,'ko','ë‚ ì§œ ì˜¬í•´',0),(471512,13098,'he','×ª××¨×™×š ×”×©× ×”',0),(471513,13098,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï†Î­Ï„Î¿Ï‚',0),(471514,13098,'zh','ä»Šå¹´è‡³ä»Š',0),(471515,13098,'sv','Hittills i Ã¥r',0),(471516,13098,'it','Data quest\'anno',0),(471517,13098,'tl','',0),(471518,13098,'th','à¸§à¸±à¸™à¸›à¸µà¸™à¸µà¹‰',0),(471519,13098,'hi','à¤‡à¤¸ à¤¸à¤¾à¤² à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(471520,13098,'ms','Tarikh tahun ini',0),(471521,13098,'ar','Ø­ØªÙ‰ Ø§Ù„Ø¢Ù† Ù‡Ø°Ù‡ Ø§Ù„Ø³Ù†Ø©',0),(471522,13098,'fr','Date de cette annÃ©e',0),(471523,13098,'jp','ã“ã®å¹´ã®æ—¥ä»˜',0),(471524,13098,'pt','Data deste ano',0),(471525,13098,'ru','Ð”Ð°Ñ‚Ð° Ð² ÑÑ‚Ð¾Ð¼ Ð³Ð¾Ð´Ñƒ',0),(471526,13098,'es','Fecha Este AÃ±o',0),(471527,13098,'de','Tag Heuer',0),(471528,13098,'en','Date This Year',0),(471529,13099,'is','',0),(471530,13099,'dr','Ø³Ø§Ù„ Ø¬Ø¯ÛŒØ¯',0),(471531,13099,'pr','Ø³Ø§Ù„ Ø¬Ø¯ÛŒØ¯',0),(471532,13099,'tr','Yeni yÄ±l',0),(471533,13099,'pl','Nowy rok',0),(471534,13099,'bg','ÐÐ¾Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(471535,13099,'ur','Ù†ÛŒØ§ Ø³Ø§Ù„',0),(471536,13099,'sr','ÐÐ¾Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(471537,13099,'vi','nÄƒm má»›i',0),(471538,13099,'af','Nuwe jaar',0),(471539,13099,'ro','Anul nou',0),(471540,13099,'et','Uusaasta',0),(471541,13099,'si','Novo leto',0),(471542,13099,'ba','Tahun baru',0),(471543,13099,'nl','Nieuwjaar',0),(471544,13099,'fi','Uusi vuosi',0),(471545,13099,'no','NyttÃ¥r',0),(471546,13099,'da','NytÃ¥r',0),(471547,13099,'ko','ìƒˆ í•´',0),(471548,13099,'he','×©× ×” ×—×“×©×”',0),(471549,13099,'el','ÎÎ­Î¿ Î­Ï„Î¿Ï‚',0),(471550,13099,'zh','æ–°çš„ä¸€å¹´',0),(471551,13099,'sv','Nytt Ã¥r',0),(471552,13099,'it','Capodanno',0),(471553,13099,'tl','',0),(471554,13099,'th','à¸›à¸µà¹ƒà¸«à¸¡à¹ˆ',0),(471555,13099,'hi','à¤¨à¤¯à¤¾ à¤¸à¤¾à¤²',0),(471556,13099,'ms','Tahun baru',0),(471557,13099,'ar','Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(471558,13099,'fr','Nouvel an',0),(471559,13099,'jp','æ–°ã—ã„å¹´',0),(471560,13099,'pt','Ano novo',0),(471561,13099,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´',0),(471562,13099,'es','Nuevo AÃ±o',0),(471563,13099,'de','Neujahr',0),(471564,13099,'en','New Year',0),(471565,13100,'is','',0),(471566,13100,'dr','Ù†Ù…ÙˆÙ†Ù‡ ØªØ§Ø±ÛŒØ® Ù‡Ø§ ',0),(471567,13100,'pr','Ù†Ù…ÙˆÙ†Ù‡ ØªØ§Ø±ÛŒØ® Ù‡Ø§ ',0),(471568,13100,'tr','Tipik tarihleri',0),(471569,13100,'pl','Typowe terminy',0),(471570,13100,'bg','Ð¢Ð¸Ð¿Ð¸Ñ‡Ð½Ð¸ Ð´Ð°Ñ‚Ð¸',0),(471571,13100,'ur','Ù†ÙˆØ¹ÛŒ ØªØ§Ø±ÛŒØ®ÛŒÚº',0),(471572,13100,'sr','Ð¢Ð¸Ð¿Ð¸Ñ‡Ð½Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ðµ',0),(471573,13100,'vi','NgÃ y Ä‘iá»ƒn hÃ¬nh',0),(471574,13100,'af','Tipiese datums',0),(471575,13100,'ro','Tipice de dvs.',0),(471576,13100,'et','TÃ¼Ã¼piline kuupÃ¤evad',0),(471577,13100,'si','TipiÄna datumov',0),(471578,13100,'ba','Khas tanggal',0),(471579,13100,'nl','Typische datums',0),(471580,13100,'fi','Tyypillinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(471581,13100,'no','Vanlige datoer',0),(471582,13100,'da','Typiske datoer',0),(471583,13100,'ko','ì „í˜•ì ì¸ ë‚ ì§œ',0),(471584,13100,'he','×ª××¨×™×›×™ ×˜×™×¤×•×¡×™',0),(471585,13100,'el','Î¤Ï…Ï€Î¹ÎºÏŒ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(471586,13100,'zh','å…¸åž‹çš„çº¦ä¼š',0),(471587,13100,'sv','Typiska datum',0),(471588,13100,'it','Tipiche date',0),(471589,13100,'tl','',0),(471590,13100,'th','à¸§à¸±à¸™à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(471591,13100,'hi','à¤ à¥‡à¤  à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤',0),(471592,13100,'ms','Biasa pada tarikh',0),(471593,13100,'ar','Ù…ÙˆØ§Ø¹ÙŠØ¯ Ù†Ù…ÙˆØ°Ø¬ÙŠØ©',0),(471594,13100,'fr','Dates typiques',0),(471595,13100,'jp','å…¸åž‹çš„ãªæ—¥ä»˜',0),(471596,13100,'pt','Datas tÃ­picas',0),(471597,13100,'ru','Ð¢Ð¸Ð¿Ð¸Ñ‡Ð½Ñ‹Ðµ ÑÑ€Ð¾ÐºÐ¸',0),(471598,13100,'es','Fechas TÃ­picas',0),(471599,13100,'de','Typische Termine',0),(471600,13100,'en','Typical Dates',0),(471601,13101,'is','',0),(471602,13101,'dr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(471603,13101,'pr','Ø¨Ù‡ Ø±ÙˆØ²Ø±Ø³Ø§Ù†ÛŒ Ù†Ø§ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(471604,13101,'tr','GÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z',0),(471605,13101,'pl','Aktualizacja nie powiedzie',0),(471606,13101,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(471607,13101,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(471608,13101,'sr','Ð˜ÑÐ¿Ñ€Ð°Ð²ÐºÐ° Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð°',0),(471609,13101,'vi','Cáº­p nháº­t khÃ´ng thÃ nh cÃ´ng',0),(471610,13101,'af','Bywerking onsuksesvol',0),(471611,13101,'ro','Actualizare eÈ™uatÄƒ',0),(471612,13101,'et','VÃ¤rskendamine nurjus',0),(471613,13101,'si','Posodobitev je neuspeÅ¡na',0),(471614,13101,'ba','Update gagal',0),(471615,13101,'nl','Update mislukt',0),(471616,13101,'fi','PÃ¤ivitys epÃ¤onnistui',0),(471617,13101,'no','Oppdateringen mislyktes',0),(471618,13101,'da','Opdatering mislykket',0),(471619,13101,'ko','ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(471620,13101,'he','×¢×“×›×•×Ÿ ×œ× ×ž×•×¦×œ×—',0),(471621,13101,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Î½ÎµÏ€Î¹Ï„Ï…Ï‡Î®Ï‚',0),(471622,13101,'zh','æ›´æ–°å¤±è´¥',0),(471623,13101,'sv','Uppdatering misslyckas',0),(471624,13101,'it','Aggiornamento fallito',0),(471625,13101,'tl','',0),(471626,13101,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹„à¸¡à¹ˆà¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(471627,13101,'hi','à¤…à¤¸à¤«à¤² à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(471628,13101,'ms','Kemaskini yang tidak berjaya',0),(471629,13101,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ« ØºÙŠØ± Ù†Ø§Ø¬Ø­',0),(471630,13101,'fr','Mise Ã  jour Ã©choue',0),(471631,13101,'jp','æ›´æ–°ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(471632,13101,'pt','AtualizaÃ§Ã£o mal sucedida',0),(471633,13101,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½ÐµÑƒÐ´Ð°Ñ‡Ð½Ð¾Ð¹',0),(471634,13101,'es','ActualizaciÃ³n No Exitosa',0),(471635,13101,'de','Update nicht erfolgreich',0),(471636,13101,'en','Update Unsuccessful',0),(471637,13102,'is','',0),(471638,13102,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÛŒ Ø§Ø±Ø³Ø§Ù„ Ù…Ø¯Ø§Ø±Ú© Ø´Ø±Ú©Øª Ù…Ø§ Ø§Ø³Øª',0),(471639,13102,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÛŒ Ø§Ø±Ø³Ø§Ù„ Ù…Ø¯Ø§Ø±Ú© Ø´Ø±Ú©Øª Ù…Ø§ Ø§Ø³Øª',0),(471640,13102,'tr','Gemi belgeler iÃ§in firmamÄ±z Ã¼zerinden varsayÄ±lan',0),(471641,13102,'pl','DomyÅ›lnie z dokumentÃ³w statku jest firma',0),(471642,13102,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚ Ð·Ð° ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ðµ Ð½Ð°ÑˆÐ°Ñ‚Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(471643,13102,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª ÛÛ’ Ø§Ø³ Ù„Ø¦Û’ ÛÙ…Ø§Ø±ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ø³Û’ Ø·Û’ Ø´Ø¯Û',0),(471644,13102,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¸Ð· Ð·Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ðµ Ð±Ñ€Ð¾Ð´ Ñ˜Ðµ Ð½Ð°ÑˆÐ° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(471645,13102,'vi','máº·c Ä‘á»‹nh chá»©ng tá»« Ä‘áº¿n lÃ  cá»§a cÃ´ng ty chÃºng tÃ´i',0),(471646,13102,'af','Verstek uit vir skip dokumente Is ons maatskappy',0),(471647,13102,'ro','Implicit la pentru documentele navei este firma noastra',0),(471648,13102,'et','Vaikimisi saaja dokumendid on meie firma',0),(471649,13102,'si','Privzeta iz ladje dokumentov je naÅ¡e podjetje',0),(471650,13102,'ba','Default dari kapal dokumen adalah perusahaan kami',0),(471651,13102,'nl','Standaard voor schip documenten Is ons bedrijf',0),(471652,13102,'fi','Oletusarvon mukaan aluksen asiakirjat on yrityksemme',0),(471653,13102,'no','Standard fra skipet dokumenter er vÃ¥rt selskap',0),(471654,13102,'da','Standard fra skibet dokumenter er vores firma',0),(471655,13102,'ko','ì„ ë°• ë¬¸ì„œëŠ” ë‹¹ì‚¬ì—ì„œ ê¸°ë³¸',0),(471656,13102,'he','×‘×¨×™×¨×ª ×ž×—×“×œ ×©×œ ×”×¡×¤×™× ×” ×ž×¡×ž×›×™× ×”×™× ×”×—×‘×¨×” ×©×œ× ×•',0),(471657,13102,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î±Ï€ÏŒ Î³Î¹Î± Ï€Î»Î¿Î¯Î¿ Î­Î³Î³ÏÎ±Ï†Î± ÎµÎ¯Î½Î±Î¹ Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î¼Î±Ï‚',0),(471658,13102,'zh','æ¥è‡ªèˆ¹èˆ¶æ–‡ä»¶æ˜¯æˆ‘ä»¬å…¬å¸çš„é»˜è®¤å€¼',0),(471659,13102,'sv','StandardvÃ¤rde frÃ¥n fÃ¶r fartygets dokument Ã¤r vÃ¥rt fÃ¶retag',0),(471660,13102,'it','Default da per documenti della nave Ã¨ la nostra azienda',0),(471661,13102,'tl','',0),(471662,13102,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸£à¸´à¸©à¸±à¸—à¸‚à¸­à¸‡à¹€à¸£à¸²à¸ˆà¸°à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹€à¸­à¸à¸ªà¸²à¸£',0),(471663,13102,'hi','à¤œà¤¹à¤¾à¤œ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¤®à¤¾à¤°à¥€ à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥‡ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(471664,13102,'ms','Lalai dari dokumen-dokumen kapal adalah syarikat kami',0),(471665,13102,'ar','Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù…Ù† ÙˆØ«Ø§Ø¦Ù‚ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù‡Ùˆ Ø´Ø±ÙƒØªÙ†Ø§',0),(471666,13102,'fr','Par dÃ©faut Ã  partir de Documents du navire est notre compagnie',0),(471667,13102,'jp','èˆ¹ã®æ›¸é¡žã¯å½“ç¤¾ã‹ã‚‰ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã—ã¾ã™ã€‚',0),(471668,13102,'pt','PadrÃ£o de para documentos do navio Ã© nossa companhia',0),(471669,13102,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¸Ð· ÑÑƒÐ´Ð¾Ð²Ñ‹Ñ… Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð² ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð½Ð°ÑˆÐ° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(471670,13102,'es','De Por Enviar Documentos es de Nuestra Empresa Por Defecto',0),(471671,13102,'de','Standardwert von Schiff Dokumente unseres Unternehmens',0),(471672,13102,'en','Default From For Ship Documents Is Our Company',0),(471673,13103,'is','',0),(471674,13103,'dr','Ù†Ù…ÙˆÙ†Ù‡ ØªØ§Ø±ÛŒØ® Ù‡Ø§ Ø¨Ø§ Ù†ÙˆØ¹ Ú©Ø§Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(471675,13103,'pr','Ù†Ù…ÙˆÙ†Ù‡ ØªØ§Ø±ÛŒØ® Ù‡Ø§ Ø¨Ø§ Ù†ÙˆØ¹ Ú©Ø§Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(471676,13103,'tr','Ä°ÅŸ tÃ¼rÃ¼ ile tipik tarihleri kullanmak',0),(471677,13103,'pl','Typowe terminy korzystania z pracy typu',0),(471678,13103,'bg','Ð¢Ð¸Ð¿Ð¸Ñ‡Ð½Ð¸ Ð´Ð°Ñ‚Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ñ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(471679,13103,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ø®ØµÙˆØµ ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(471680,13103,'sr','Ð¢Ð¸Ð¿Ð¸Ñ‡Ð½Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ðµ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ ÑÐ° Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(471681,13103,'vi','NgÃ y Ä‘iá»ƒn hÃ¬nh sá»­ dá»¥ng vá»›i loáº¡i hÃ¬nh cÃ´ng viá»‡c',0),(471682,13103,'af','Tipiese datums gebruik met werk tipe',0),(471683,13103,'ro','Utilizarea tipic datele cu tipul de munca',0),(471684,13103,'et','TÃ¼Ã¼piline kuupÃ¤evade kasutamine tÃ¶Ã¶ tÃ¼Ã¼p',0),(471685,13103,'si','TipiÄna datume uporabe z vrsto dela',0),(471686,13103,'ba','Penggunaan khas tanggal dengan jenis pekerjaan',0),(471687,13103,'nl','Typische datums gebruik met werksoort',0),(471688,13103,'fi','Tyypillinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t kÃ¤ytettÃ¤vÃ¤ksi tyÃ¶n tyyppi',0),(471689,13103,'no','Typisk datoer bruk med arbeidstype',0),(471690,13103,'da','Typiske datoer brug med arbejdstype',0),(471691,13103,'ko','ìž‘ì—… í˜•ì‹ìœ¼ë¡œ ì „í˜•ì ì¸ ë‚ ì§œ ì‚¬ìš©',0),(471692,13103,'he','×ª××¨×™×›×™ ××•×¤×™×™× ×™ ×œ×©×™×ž×•×© ×¢× ×¡×•×’ ×¢×‘×•×“×”',0),(471693,13103,'el','Î¤Ï…Ï€Î¹ÎºÏŒ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚ Ï‡ÏÎ®ÏƒÎ· Î¼Îµ Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(471694,13103,'zh','å…¸åž‹çš„çº¦ä¼šä¸Žå·¥ä½œç±»åž‹ä¸€èµ·ä½¿ç”¨',0),(471695,13103,'sv','Typiska datum anvÃ¤ndning med arbetstyp',0),(471696,13103,'it','Uso tipico date con il tipo di lavoro',0),(471697,13103,'tl','',0),(471698,13103,'th','à¹‚à¸”à¸¢à¸—à¸±à¹ˆà¸§à¹„à¸›à¹ƒà¸Šà¹‰à¸à¸±à¸šà¸Šà¸™à¸´à¸”à¸‡à¸²à¸™',0),(471699,13103,'hi','à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤¸à¤¾à¤¥ à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤ à¤‰à¤ªà¤¯à¥‹à¤—',0),(471700,13103,'ms','Tarikh yang biasa digunakan dengan jenis kerja',0),(471701,13103,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„ØªÙˆØ§Ø±ÙŠØ® Ù†Ù…ÙˆØ°Ø¬ÙŠØ© Ù…Ø¹ Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(471702,13103,'fr','Utilisation de Dates typique avec le Type de travail',0),(471703,13103,'jp','å…¸åž‹çš„ãªæ—¥ä»˜åž‹ã‚’ä½¿ç”¨ã™ã‚‹ä½œæ¥­',0),(471704,13103,'pt','Uso tÃ­pico de datas com o tipo de trabalho',0),(471705,13103,'ru','Ð¢Ð¸Ð¿Ð¸Ñ‡Ð½Ñ‹Ðµ ÑÑ€Ð¾ÐºÐ¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ Ñ‚Ð¸Ð¿Ð¾Ð¼ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(471706,13103,'es','Uso de Fechas TÃ­picas Con Tipo de Trabajo',0),(471707,13103,'de','Typische Daten Verwendung mit Arbeitstyp',0),(471708,13103,'en','Typical Dates Use With Work Type',0),(471709,13104,'is','',0),(471710,13104,'dr','(Ù…Ø­Ù…ÙˆÙ„Ù‡)Ø¨Ø±Ø±Ø³ÛŒ Ù†Ø´Ø¯Ù‡ Ø§Ø² ÙØ±Ù…Ø§ÛŒØ´ ØªÙˆØ³Ø· Ø®Ø±ÛŒØ¯Ø§Ø±',0),(471711,13104,'pr','Ø§Ø±Ø³Ø§Ù„Ù‡Ø§ÛŒ(Ù…Ø­Ù…ÙˆÙ„Ù‡)Ø¨Ø±Ø±Ø³ÛŒ Ù†Ø´Ø¯Ù‡ Ø§Ø² Ø³ÙØ§Ø±Ø´ ØªÙˆØ³Ø· Ø®Ø±ÛŒØ¯Ø§Ø±',0),(471712,13104,'tr','MÃ¼ÅŸteriden sipariÅŸ tarafÄ±ndan denetlenmeyen gemiler',0),(471713,13104,'pl','Niezaznaczone statkÃ³w z zamÃ³wienia przez klienta',0),(471714,13104,'bg','ÐÐµÑ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½ ÐºÐ¾Ñ€Ð°Ð±Ð¸ Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(471715,13104,'ur','ØºÛŒØ± Ù¾Ú‘ØªØ§Ù„ Ø´Ø¯Û Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²ÙˆÚº Ú©Û’ Ø¢Ø±ÚˆØ± Ú©Û’ Ú¯Ø§ÛÚ© Ø³Û’',0),(471716,13104,'sr','ÐÐµÐ¿Ñ€Ð¾Ð²Ñ˜ÐµÑ€ÐµÐ½Ð¸ Ð±Ñ€Ð¾Ð´Ð¾Ð²Ðµ Ð¾Ð´ Ð¿Ð¾Ñ˜ÐµÐ´Ð¸Ð½Ð°Ñ‡Ð½Ð¸Ð¼ ÐºÑƒÐ¿Ñ†Ð°',0),(471717,13104,'vi','TÃ u chÆ°a Ä‘Æ°á»£c kiá»ƒm tra vá»›i Ä‘Æ¡n Ä‘áº·t hÃ ng bá»Ÿi khÃ¡ch hÃ ng',0),(471718,13104,'af','Ongemerk skepe van die orde-deur kliÃ«nt',0),(471719,13104,'ro','Navele neÃ®nregistrate la comanda-de client',0),(471720,13104,'et','Registreerimata laevade Order By kliendilt',0),(471721,13104,'si','Nenadzorovano ladij iz Order By kupec',0),(471722,13104,'ba','Kapal-kapal yang dicentang dari Order-oleh pelanggan',0),(471723,13104,'nl','Niet-gecontroleerde schepen van Order-By klant',0),(471724,13104,'fi','Tarkistamaton alusten Order By asiakkaalta',0),(471725,13104,'no','Ukontrollert skip fra Order By kunde',0),(471726,13104,'da','Ukontrolleret skibe fra ordre-for kunde',0),(471727,13104,'ko','ê³ ê° ì£¼ë¬¸ì— ì˜í•´ì—ì„œ í™•ì¸ ë˜ì§€ ì•Šì€ ë°°',0),(471728,13104,'he','×¡×¤×™× ×•×ª ×œ× ×ž×¡×•×ž×Ÿ ×œ×¤×™ ×œ×§×•×—',0),(471729,13104,'el','Î‘Î½ÎµÎ¾Î­Î»ÎµÎ³ÎºÏ„Î· Ï€Î»Î¿Î¯Î± Î±Ï€ÏŒ ÎºÎ±Ï„Î¬ Ï€ÎµÎ»Î¬Ï„Î·',0),(471730,13104,'zh','æœªé€‰ä¸­çš„èˆ¹ä»Ž Order By å®¢æˆ·',0),(471731,13104,'sv','Oskyddad fartyg frÃ¥n bestÃ¤llning av kund',0),(471732,13104,'it','Navi non controllati dall\'ordine da cliente',0),(471733,13104,'tl','',0),(471734,13104,'th','à¸¢à¸à¹€à¸£à¸·à¸­à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹‚à¸”à¸¢à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(471735,13104,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤†à¤¦à¥‡à¤¶ à¤¸à¥‡ à¤…à¤¨à¤¿à¤¯à¤‚à¤¤à¥à¤°à¤¿à¤¤ à¤œà¤¹à¤¾à¤œà¥‹à¤‚',0),(471736,13104,'ms','Kapal-kapal yang berdaftar dari pesanan oleh pelanggan',0),(471737,13104,'ar','Ø§Ù„Ø³ÙÙ† Ø¯ÙˆÙ† Ø±Ø§Ø¯Ø¹ Ù…Ù† ØªØ±ØªÙŠØ¨ Ø­Ø³Ø¨ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(471738,13104,'fr','Navires non contrÃ´lÃ©s d\'Order By client',0),(471739,13104,'jp','Order By é¡§å®¢ã‹ã‚‰ã‚ªãƒ•ã®èˆ¹',0),(471740,13104,'pt','Desmarcada navios da ordem-por cliente',0),(471741,13104,'ru','Ð¡Ð½ÑÑ‚ ÐºÐ¾Ñ€Ð°Ð±Ð»Ð¸ Ð¾Ñ‚ Order-By ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(471742,13104,'es','No Tachada se Envia Del Orden de Cliente',0),(471743,13104,'de','UngeprÃ¼fter Schiffe von Order By Kunden',0),(471744,13104,'en','Unchecked Ships From Order-By Customer',0),(471745,13105,'is','',0),(471746,13105,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(471747,13105,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± Ø§Ø±Ø²Ø´ Ø§ÙØ²ÙˆØ¯Ù‡',0),(471748,13105,'tr','KDV No.',0),(471749,13105,'pl','Nr VAT',0),(471750,13105,'bg','Ð”Ð”Ð¡.',0),(471751,13105,'ur','ÙˆØ§Ù¹ Ù†Ù…Ø¨Ø±',0),(471752,13105,'sr','Ð‘Ñ€ . ÐŸÐ”Ð’-Ð°.',0),(471753,13105,'vi','KhÃ´ng thuáº¿ GTGT',0),(471754,13105,'af','BTW Nr.',0),(471755,13105,'ro','TVA nr.',0),(471756,13105,'et','KÃ¤ibemaksu nr.',0),(471757,13105,'si','DDV Å¡t.',0),(471758,13105,'ba','Nomor PPN',0),(471759,13105,'nl','BTW-nr.',0),(471760,13105,'fi','ALV-kentÃ¤stÃ¤.',0),(471761,13105,'no','Mva-nr.',0),(471762,13105,'da','CVR nr.',0),(471763,13105,'ko','ë¶€ê°€ ê°€ì¹˜ì„¸ ë²ˆí˜¸',0),(471764,13105,'he','×ž×¢ ×ž ×ž×¡',0),(471765,13105,'el','Î‘Î¦Îœ',0),(471766,13105,'zh','å¢žå€¼ç¨Žå·',0),(471767,13105,'sv','VAT nr.',0),(471768,13105,'it','N. IVA',0),(471769,13105,'tl','',0),(471770,13105,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ VAT',0),(471771,13105,'hi','à¤µà¥ˆà¤Ÿ à¤¨à¤‚.',0),(471772,13105,'ms','VAT No.',0),(471773,13105,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©',0),(471774,13105,'fr','NÂ° de TVA',0),(471775,13105,'jp','ä»˜åŠ ä¾¡å€¤ç¨Žç•ªå·',0),(471776,13105,'pt','N Âº IVA',0),(471777,13105,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¿Ð»Ð°Ñ‚ÐµÐ»ÑŒÑ‰Ð¸ÐºÐ° ÐÐ”Ð¡',0),(471778,13105,'es','IVA No.',0),(471779,13105,'de','MwSt-Nr.',0),(471780,13105,'en','VAT No.',0),(471781,13106,'is','',0),(471782,13106,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ø±Ø³Ø§Ù„ Ø¨ÛŒØ´ØªØ± Ø§Ø² Ø­Ø¯ Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(471783,13106,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§Ø±Ø³Ø§Ù„ Ø¨ÛŒØ´ØªØ± Ø§Ø² Ø­Ø¯ Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(471784,13106,'tr','Fazla izin yollanamaz',0),(471785,13106,'pl','Nie moÅ¼na wysÅ‚aÄ‡ wiÄ™cej niÅ¼ dozwolone',0),(471786,13106,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð° Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾',0),(471787,13106,'ur','Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø§Ø¬Ø§Ø²Øª ÛŒØ§ÙØªÛ Ø¬ÛØ§Ø² Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(471788,13106,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚Ð¸ Ð²Ð¸ÑˆÐµ Ð¾Ð´ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ðµ',0),(471789,13106,'vi','KHÃ´ng thá»ƒ cho phÃ©p chuyá»ƒn táº£i hÆ¡n',0),(471790,13106,'af','Skip nie toegelaat meer as',0),(471791,13106,'ro','Nu poate livra permis mai mult',0),(471792,13106,'et','Ei saa saata rohkem kui lubatud',0),(471793,13106,'si','Ne morete ladje veÄ dovoljeno',0),(471794,13106,'ba','Tidak bisa kapal lebih dari diperbolehkan',0),(471795,13106,'nl','Ieder geval niet verzenden meer dan toegestaan',0),(471796,13106,'fi','Voi aluksen enemmÃ¤n kuin saa',0),(471797,13106,'no','Kan ikke sende mer enn tillatt',0),(471798,13106,'da','Kan ikke sende mere end tilladt',0),(471799,13106,'ko','ì´ìƒì˜ í—ˆìš© ë°°ì†¡í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(471800,13106,'he','×œ× ×™×›×•×œ×”. ×œ×©×œ×•×— ×™×•×ª×¨ ×ž ×ž×•×ª×¨',0),(471801,13106,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ¼Îµ Î½Î± Ï€Î»Î¿Î¯Î¿ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Ï„Î· Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„Î±',0),(471802,13106,'zh','ä¸èƒ½è¶…è¿‡å…è®¸çš„èˆ¹èˆ¶',0),(471803,13106,'sv','Kan inte leverera mer Ã¤n tillÃ¥tet',0),(471804,13106,'it','Non Ã¨ possibile spedire piÃ¹ di permesso',0),(471805,13106,'tl','',0),(471806,13106,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸ªà¹ˆà¸‡à¹„à¸”à¹‰à¸¡à¸²à¸à¸à¸§à¹ˆà¸²',0),(471807,13106,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤œà¤¹à¤¾à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(471808,13106,'ms','Tidak boleh menghantar lebih daripada dibenarkan',0),(471809,13106,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø´Ø­Ù† Ø£ÙƒØ«Ø± Ù…Ù† Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(471810,13106,'fr','Ne peut pas expÃ©dier plus de permis',0),(471811,13106,'jp','è¨±å®¹ç¯„å›²ã‚’è¶…ãˆã¦å‡ºè·ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(471812,13106,'pt','NÃ£o podemos enviar mais do que o permitido',0),(471813,13106,'ru','ÐÐµ Ð¼Ð¾Ð¶ÐµÐ¼ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð±Ð¾Ð»ÑŒÑˆÐµ, Ñ‡ÐµÐ¼ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾',0),(471814,13106,'es','No se puede enviar mÃ¡s que lo permite',0),(471815,13106,'de','Kann nicht Schiff mehr als erlaubt',0),(471816,13106,'en','Cannot Ship More Than Allowed',0),(471817,13107,'is','',0),(471818,13107,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ù‡ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú©Ø§ÙÛŒ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª ',0),(471819,13107,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ù‡ Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú©Ø§ÙÛŒ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª ',0),(471820,13107,'tr','Orada deÄŸil yeterli stok mevcut',0),(471821,13107,'pl','Tu jest nie tyle zapasÃ³w',0),(471822,13107,'bg','ÐÑÐ¼Ð° Ð´Ð¾ÑÑ‚Ð°Ñ‚ÑŠÑ‡Ð½Ð¾ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(471823,13107,'ur','Ú©Ø§ÙÛŒ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº',0),(471824,13107,'sr','ÐÐµÐ¼Ð° Ð´Ð¾Ð²Ð¾Ñ™Ð½Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(471825,13107,'vi','KhÃ´ng cÃ³ Ä‘á»§ hÃ ng tá»“n kho cÃ³ sáºµn',0),(471826,13107,'af','Daar nie genoeg voorraad beskikbaar Is nie',0),(471827,13107,'ro','Nu existÄƒ suficiente inventar disponibile',0),(471828,13107,'et','Saadaval pole piisavalt varude',0),(471829,13107,'si','Ni dovolj zaloge na voljo',0),(471830,13107,'ba','Ada tidak cukup persediaan yang tersedia',0),(471831,13107,'nl','Er Is niet voldoende voorraad beschikbaar',0),(471832,13107,'fi','Ei ole riittÃ¤vÃ¤sti varastoa',0),(471833,13107,'no','Det er ikke nok beholdning tilgjengelig',0),(471834,13107,'da','Der er ikke tilstrÃ¦kkelig lagerbeholdning',0),(471835,13107,'ko','ì‚¬ìš© ê°€ëŠ¥í•œ ì¶©ë¶„ í•œ ìž¬ê³  í•˜ì§€ëŠ”',0),(471836,13107,'he','××™×Ÿ ×ž×¡×¤×™×§ ×ž×œ××™ ×–×ž×™×Ÿ',0),(471837,13107,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î±ÏÎºÎµÏ„ÏŒ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î¿',0),(471838,13107,'zh','æ²¡æœ‰è¶³å¤Ÿçš„åº“å­˜å¯ç”¨',0),(471839,13107,'sv','Det finns inte tillrÃ¤ckligt inventeringen tillgÃ¤nglig',0),(471840,13107,'it','Non c\'Ã¨ abbastanza inventario disponibile',0),(471841,13107,'tl','',0),(471842,13107,'th','à¸¡à¸µà¹„à¸¡à¹ˆà¸¡à¸µà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¹€à¸žà¸µà¸¢à¸‡à¸žà¸­',0),(471843,13107,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ à¤ªà¤°à¥à¤¯à¤¾à¤ªà¥à¤¤ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€',0),(471844,13107,'ms','Sedia ada tidak cukup inventori',0),(471845,13107,'ar','Ù„Ø§ ÙŠØªÙˆÙØ± Ù…Ø§ ÙŠÙƒÙÙŠ Ù…Ù† Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(471846,13107,'fr','Il n\'y a pas assez l\'inventaire disponible',0),(471847,13107,'jp','ååˆ†ãªåœ¨åº«',0),(471848,13107,'pt','NÃ£o hÃ¡ estoque suficiente disponÃ­vel',0),(471849,13107,'ru','ÐÐµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð´Ð¾ÑÑ‚Ð°Ñ‚Ð¾Ñ‡Ð½Ð¾ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(471850,13107,'es','No Hay suficiente Inventario Disponible',0),(471851,13107,'de','Es gibt nicht genug VorrÃ¤te',0),(471852,13107,'en','There Is Not Enough Inventory Available',0),(471853,13108,'is','',0),(471854,13108,'dr','Ù…Ø¬Ù…ÙˆØ¹ ØªØ®ÙÛŒÙ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(471855,13108,'pr','Ù…Ø¬Ù…ÙˆØ¹ ØªØ®ÙÛŒÙ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(471856,13108,'tr','Ä°ndirimli toplam',0),(471857,13108,'pl','Suma zdyskontowanych',0),(471858,13108,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð¾Ð±Ñ‰Ð¾',0),(471859,13108,'ur','Ø±Ø¹Ø§ÛŒØªÛŒ Ú©Ù„',0),(471860,13108,'sr','Ð¡Ð° Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð¾Ð¼ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(471861,13108,'vi','Tá»•ng sá»‘ chiáº¿t kháº¥u',0),(471862,13108,'af','Verdiskonteerde totaal',0),(471863,13108,'ro','Reduse Total',0),(471864,13108,'et','Diskonteeritud kokku',0),(471865,13108,'si','Diskontirani skupaj',0),(471866,13108,'ba','Total DISKON',0),(471867,13108,'nl','Scherp geprijsde totaal',0),(471868,13108,'fi','Kokonaisalennus',0),(471869,13108,'no','Rabatterte totalt',0),(471870,13108,'da','Tilbagediskonterede alt',0),(471871,13108,'ko','í• ì¸ ëœ ì´',0),(471872,13108,'he','×”×›×•×œ×œ ×œ××—×¨ ×”×”× ×—×”',0),(471873,13108,'el','ÎœÎµÎ¹Ï‰Î¼Î­Î½ÎµÏ‚ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(471874,13108,'zh','æŠ˜æ‰£çš„æ€»é¢',0),(471875,13108,'sv','Rabatterade totalt',0),(471876,13108,'it','Totale scontato',0),(471877,13108,'tl','',0),(471878,13108,'th','à¸¢à¸­à¸”à¸£à¸§à¸¡à¸ªà¹ˆà¸§à¸™à¸¥à¸”',0),(471879,13108,'hi','à¤°à¤¿à¤¯à¤¾à¤¯à¤¤à¥€ à¤•à¥à¤²',0),(471880,13108,'ms','Jumlah Diskaun',0),(471881,13108,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ù…Ø®ÙØ¶Ø©',0),(471882,13108,'fr','Total prix rÃ©duit',0),(471883,13108,'jp','å‰²å¼•åˆè¨ˆ',0),(471884,13108,'pt','Total com desconto',0),(471885,13108,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾ ÑÐ¾ ÑÐºÐ¸Ð´ÐºÐ¾Ð¹',0),(471886,13108,'es','Total Descontado',0),(471887,13108,'de','ErmÃ¤ÃŸigte Total',0),(471888,13108,'en','Discounted Total',0),(471889,13109,'is','',0),(471890,13109,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ù‡Øª Ù…Ø´ØªØ±ÛŒ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(471891,13109,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ù‡Øª Ù…Ø´ØªØ±ÛŒ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(471892,13109,'tr','Fatura mÃ¼ÅŸterisi bulunamadÄ±',0),(471893,13109,'pl','Rachunek klienta nie znaleziono',0),(471894,13109,'bg','Ð¤Ð°ÐºÑ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(471895,13109,'ur','Ø¨Ù„ Ù…ÛŒÚº Ú¯Ø§ÛÚ© Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(471896,13109,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(471897,13109,'vi','KhÃ¡ch hÃ ng khÃ´ng tÃ¬m tháº¥y',0),(471898,13109,'af','Wetsontwerp kliÃ«nt nie gevind nie',0),(471899,13109,'ro','Factura client nu a fost gÄƒsit',0),(471900,13109,'et','Arve saaja ei leitud',0),(471901,13109,'si','RaÄun â€“ kupec, ni mogoÄe najti',0),(471902,13109,'ba','Tagihan kepada pelanggan tidak ditemukan',0),(471903,13109,'nl','Klant niet gevonden voor factuur',0),(471904,13109,'fi','Laskun saaja ei lÃ¶ydy',0),(471905,13109,'no','Faktura til kunde ikke funnet',0),(471906,13109,'da','Bill til kunde ikke fundet',0),(471907,13109,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” ê³ ê°ì— ê²Œ ë¹Œ',0),(471908,13109,'he','×‘×™×œ ×œ×œ×§×•×— ×œ× × ×ž×¦×',0),(471909,13109,'el','Bill Ï€ÎµÎ»Î¬Ï„Î· Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(471910,13109,'zh','æ‰¾ä¸åˆ°çš„å®¢æˆ·å¸å•',0),(471911,13109,'sv','Bill till kund hittades inte',0),(471912,13109,'it','Fattura al cliente non trovato',0),(471913,13109,'tl','',0),(471914,13109,'th','à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸¥à¸¹à¸à¸„à¹‰à¸²à¹„à¸¡à¹ˆà¸žà¸š',0),(471915,13109,'hi','à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²',0),(471916,13109,'ms','Rang undang-undang kepada pelanggan yang tidak dijumpai',0),(471917,13109,'ar','ÙØ§ØªÙˆØ±Ø© Ù„Ù„Ø¹Ù…ÙŠÙ„ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(471918,13109,'fr','Projet de loi au client introuvable',0),(471919,13109,'jp','è«‹æ±‚å…ˆé¡§å®¢ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(471920,13109,'pt','Bill ao cliente nÃ£o encontrado',0),(471921,13109,'ru','Ð‘Ð¸Ð»Ð» Ð·Ð°ÐºÐ°Ð·Ñ‡Ð¸ÐºÑƒ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(471922,13109,'es','No Se Ecuentra Recibo a Cliente',0),(471923,13109,'de','Rechnung an Kunden, die nicht gefunden',0),(471924,13109,'en','Bill To Customer Not Found',0),(471925,13110,'is','',0),(471926,13110,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ù‡Øª Ø¬Ø³ØªØ¬Ùˆ ',0),(471927,13110,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¬Ù‡Øª Ø¬Ø³ØªØ¬Ùˆ ',0),(471928,13110,'tr','Fatura arama',0),(471929,13110,'pl','Bill do wyszukiwania',0),(471930,13110,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(471931,13110,'ur','Ø¨Ù„ Ú©Û’ Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(471932,13110,'sr','Ð”Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(471933,13110,'vi','HÃ³a Ä‘Æ¡n cáº§n tÃ¬m',0),(471934,13110,'af','Wetsontwerp-na opsoek',0),(471935,13110,'ro','NotÄƒ de platÄƒ-la cÄƒutare',0),(471936,13110,'et','Bill otsing',0),(471937,13110,'si','Izstavite raÄun za iskanje',0),(471938,13110,'ba','Bill-untuk Lookup',0),(471939,13110,'nl','Factuurklant Lookup',0),(471940,13110,'fi','Laskutusasiakkaan haku',0),(471941,13110,'no','Faktura til-oppslag',0),(471942,13110,'da','Faktureres til opslag',0),(471943,13110,'ko','ì²­êµ¬ì„œë¥¼ ì¡°íšŒ',0),(471944,13110,'he','×‘×“×™×§×ª ×ž×™×“×¢ ×œ×—×™×•×‘',0),(471945,13110,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÏƒÎµ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(471946,13110,'zh','å¸å•å¯„å¾€æŸ¥æ‰¾',0),(471947,13110,'sv','Faktureras Lookup',0),(471948,13110,'it','Bill-alla ricerca',0),(471949,13110,'tl','',0),(471950,13110,'th','à¹ƒà¸«à¹‰à¸„à¹‰à¸™à¸«à¸²',0),(471951,13110,'hi','à¤²à¥à¤•à¤…à¤ª à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²',0),(471952,13110,'ms','Rang undang-undang untuk Lookup',0),(471953,13110,'ar','Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ù„Ù„Ø¨Ø­Ø«',0),(471954,13110,'fr','FacturÃ© Lookup',0),(471955,13110,'jp','æ³•æ¡ˆã‚’ãƒ«ãƒƒã‚¯ã‚¢ãƒƒãƒ—',0),(471956,13110,'pt','Bill-a pesquisa',0),(471957,13110,'ru','Ð‘Ð¸Ð»Ð» Ð´Ð»Ñ Ð¿Ð¾Ð¸ÑÐºÐ°',0),(471958,13110,'es','Recibo-Para Buscar',0),(471959,13110,'de','RechnungsempfÃ¤nger Lookup',0),(471960,13110,'en','Bill-To Lookup',0),(471961,13111,'is','',0),(471962,13111,'dr','-Ø¨Ù‡ Ù†Ø§Ù…',0),(471963,13111,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ -Ø¨Ù‡ Ù†Ø§Ù…',0),(471964,13111,'tr','Fatura yeri adÄ±',0),(471965,13111,'pl','Nazwa odbiorcy faktury',0),(471966,13111,'bg','Ð˜Ð¼Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(471967,13111,'ur','Ø¨Ù„ Ú©Û’ Ù†Ø§Ù…',0),(471968,13111,'sr','Ð˜Ð¼Ðµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(471969,13111,'vi','Láº­p tÃªn hÃ³a Ä‘Æ¡n',0),(471970,13111,'af','Wetsontwerp-om die naam',0),(471971,13111,'ro','NotÄƒ de platÄƒ-la nume',0),(471972,13111,'et','Maksja nimi',0),(471973,13111,'si','RaÄun â€“ ime',0),(471974,13111,'ba','Bill-untuk nama',0),(471975,13111,'nl','Factuurklant naam',0),(471976,13111,'fi','Laskutusasiakkaan nimeÃ¤',0),(471977,13111,'no','Faktura til-navn',0),(471978,13111,'da','Faktureringsnavnet',0),(471979,13111,'ko','ì²­êµ¬ì§€ ì´ë¦„',0),(471980,13111,'he','×œ×—×™×•×‘ ×©×',0),(471981,13111,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÏƒÎµ Î¿Î½Î¿Î¼Î±ÏƒÎ¯Î±',0),(471982,13111,'zh','æ¡ä¾‹è‰æ¡ˆçš„åç§°',0),(471983,13111,'sv','Faktureras namn',0),(471984,13111,'it','Fatturare a nome',0),(471985,13111,'tl','',0),(471986,13111,'th','à¸Šà¸·à¹ˆà¸­à¸£à¸²à¸¢à¸à¸²à¸£',0),(471987,13111,'hi','à¤¨à¤¾à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²',0),(471988,13111,'ms','Rang undang-undang untuk nama',0),(471989,13111,'ar','ÙØ§ØªÙˆØ±Ø© Ø¨Ø§Ø³Ù…',0),(471990,13111,'fr','Nom client facturÃ©',0),(471991,13111,'jp','è«‹æ±‚å…ˆå',0),(471992,13111,'pt','Nome Bill-a',0),(471993,13111,'ru','Ð‘Ð¸Ð»Ð»-Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ',0),(471994,13111,'es','Recibo-Para Nombrar',0),(471995,13111,'de','RechnungsempfÃ¤nger Name',0),(471996,13111,'en','Bill-To Name',0),(471997,13112,'is','',0),(471998,13112,'dr','ØªØ§Ø±ÛŒØ® Ø³ÙØ§Ø±Ø´ Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡',0),(471999,13112,'pr','ØªØ§Ø±ÛŒØ® Ø³ÙØ§Ø±Ø´ Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡',0),(472000,13112,'tr','AlÄ±nan tarih sÄ±rasÄ±',0),(472001,13112,'pl','Data zamÃ³wienia otrzymane',0),(472002,13112,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ñ€ÐµÐ´Ð°, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸',0),(472003,13112,'ur','ØªØ§Ø±ÛŒØ® Ú©Û’ Ø¢Ø±ÚˆØ± Ù…ÙˆØµÙˆÙ„',0),(472004,13112,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾',0),(472005,13112,'vi','NgÃ y nháº­n Ä‘Æ¡n hÃ ng',0),(472006,13112,'af','Datum Bestelling Ontvang',0),(472007,13112,'ro','Data comenzii primite',0),(472008,13112,'et','Saabumise kuupÃ¤eva jÃ¤rjekorras',0),(472009,13112,'si','Datum vrstnem',0),(472010,13112,'ba','Urutan tanggal diterima',0),(472011,13112,'nl','Datumvolgorde ontvangen',0),(472012,13112,'fi','Pvm-jÃ¤rjestys sai',0),(472013,13112,'no','DatorekkefÃ¸lge mottatt',0),(472014,13112,'da','Dato ordre modtaget',0),(472015,13112,'ko','ë°›ì€ ë‚ ì§œ ìˆœì„œ',0),(472016,13112,'he','×ª××¨×™×š: ×”×ª×§×‘×œ',0),(472017,13112,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÏƒÎµÎ¹ÏÎ¬',0),(472018,13112,'zh','æ”¶åˆ°çš„æ—¥æœŸé¡ºåº',0),(472019,13112,'sv','Datumordning fick',0),(472020,13112,'it','Data ordine ricevuto',0),(472021,13112,'tl','',0),(472022,13112,'th','à¸¥à¸³à¸”à¸±à¸šà¸‚à¸­à¸‡à¸§à¸±à¸™à¹„à¸”à¹‰à¸£à¸±à¸š',0),(472023,13112,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¤à¤¿à¤¥à¤¿ à¤•à¥à¤°à¤®',0),(472024,13112,'ms','Tarikh pesanan diterima',0),(472025,13112,'ar','ØªØ±ØªÙŠØ¨ ØªØ§Ø±ÙŠØ® ØªÙ„Ù‚ÙŠ',0),(472026,13112,'fr','Date commande reÃ§ue',0),(472027,13112,'jp','æ—¥ä»˜ã®é †åºã‚’å—ã‘å–ã£ãŸ',0),(472028,13112,'pt','Ordem de data recebido',0),(472029,13112,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð´Ð°Ñ‚Ñ‹ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ',0),(472030,13112,'es','Fecha Orden Recibido',0),(472031,13112,'de','Datum der Bestellung',0),(472032,13112,'en','Date Order Received',0),(472033,13113,'is','',0),(472034,13113,'dr','(Ø³ÙˆØ§Ø¨Ù‚)Ø§Ø±Ø³Ø§Ù„',0),(472035,13113,'pr','Ø®Ø·Ø§Ø¯Ø± Ø²Ù…Ø§Ù† Ø§ÛŒØ¬Ø§Ø¯ Ø§Ø·Ù„Ø§Ø¹Ø§Øª(Ø³ÙˆØ§Ø¨Ù‚)Ø§Ø±Ø³Ø§Ù„',0),(472036,13113,'tr','Gemi kayÄ±tlarÄ±nÄ±n oluÅŸturulmasÄ± sÄ±rasÄ±nda bir hata oluÅŸtu',0),(472037,13113,'pl','BÅ‚Ä…d podczas tworzenia dokumentacji statku',0),(472038,13113,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(472039,13113,'ur','Ø¬ÛØ§Ø² Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ',0),(472040,13113,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐ° Ð·Ð°Ð¿Ð¸ÑÐ° Ð±Ñ€Ð¾Ð´',0),(472041,13113,'vi','Lá»—i trong khi táº¡o há»“ sÆ¡ váº­n chuyá»ƒn',0),(472042,13113,'af','Fout tydens skepping van skip rekords',0),(472043,13113,'ro','Eroare Ã®n timpul creÄƒrii de Ã®nregistrÄƒri de navÄƒ',0),(472044,13113,'et','Laeva kirjete loomisel ilmnes tÃµrge',0),(472045,13113,'si','Napaka med ustvarjanjem zapisov ladje',0),(472046,13113,'ba','Error selama penciptaan kapal catatan',0),(472047,13113,'nl','Fout tijdens creatie van schip Records',0),(472048,13113,'fi','Virhe aikana laiva tietueiden luonti',0),(472049,13113,'no','Feil under oppretting av skipet poster',0),(472050,13113,'da','Fejl under oprettelsen af skibet poster',0),(472051,13113,'ko','ë°° ë ˆì½”ë“œ ìƒì„± ì‹œ ì˜¤ë¥˜',0),(472052,13113,'he','×©×’×™××” ×‘×¢×ª ×™×¦×™×¨×ª ×¨×©×•×ž×•×ª ×”×¡×¤×™× ×”',0),(472053,13113,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ Ï€Î»Î¿Î¯Î¿',0),(472054,13113,'zh','åœ¨èˆ¹èˆ¶è®°å½•çš„åˆ›å»ºè¿‡ç¨‹ä¸­çš„é”™è¯¯',0),(472055,13113,'sv','Fel vid skapandet av fartyget poster',0),(472056,13113,'it','Errore durante la creazione dei record di nave',0),(472057,13113,'tl','',0),(472058,13113,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸ªà¸£à¹‰à¸²à¸‡à¸‚à¸­à¸‡à¹€à¸£à¸·à¸­',0),(472059,13113,'hi','à¤œà¤¹à¤¾à¤œ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(472060,13113,'ms','Ralat semasa penciptaan rekod kapal',0),(472061,13113,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ Ø³Ø¬Ù„Ø§Øª Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(472062,13113,'fr','Erreur lors de la crÃ©ation d\'enregistrements de navire',0),(472063,13113,'jp','èˆ¹ã®è¨˜éŒ²ã®ä½œæˆä¸­ã«ã‚¨ãƒ©ãƒ¼',0),(472064,13113,'pt','Erro durante a criaÃ§Ã£o de registros de navio',0),(472065,13113,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ð¸ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(472066,13113,'es','Error Durante CreaciÃ³n de Records de EnvÃ­o',0),(472067,13113,'de','Fehler beim Erstellen der Schiff-DatensÃ¤tze',0),(472068,13113,'en','Error During Creation Of Ship Records',0),(472069,13114,'is','',0),(472070,13114,'dr','ØªØ§Ø±ÛŒØ® Ú©Ø´ØªÛŒ ØªØ±Ø¬ÛŒØ­ Ø¯Ø§Ø¯Ù‡',0),(472071,13114,'pr','ØªØ§Ø±ÛŒØ® Ú©Ø´ØªÛŒ ØªØ±Ø¬ÛŒØ­ Ø¯Ø§Ø¯Ù‡',0),(472072,13114,'tr','Tercih edilen sevk tarihi',0),(472073,13114,'pl','Preferowane daty',0),(472074,13114,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°Ñ‚Ð°',0),(472075,13114,'ur','ØªØ±Ø¬ÛŒØ­ÛŒ Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(472076,13114,'sr','ÐŸÑ€ÐµÑ„ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð±Ñ€Ð¾Ð´ Ð´Ð°Ñ‚ÑƒÐ¼',0),(472077,13114,'vi','Æ¯a thÃ­ch tÃ u ngÃ y',0),(472078,13114,'af','Voorkeur skip datum',0),(472079,13114,'ro','Data preferat navei',0),(472080,13114,'et','Eelistatud lÃ¤hetuskuupÃ¤ev',0),(472081,13114,'si','Raje ladja datum',0),(472082,13114,'ba','Pilihan kapal tanggal',0),(472083,13114,'nl','Gewenste verzenddatum',0),(472084,13114,'fi','Ensisijainen lÃ¤hetyspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(472085,13114,'no','Ã˜nsket forsendelsesdato',0),(472086,13114,'da','Foretrukne afsendelsesdato',0),(472087,13114,'ko','ê¸°ë³¸ ë°°ì†¡ì¼',0),(472088,13114,'he','×ª××¨×™×š ×ž×©×œ×•×— ×ž×•×¢×“×£',0),(472089,13114,'el','Î Î»Î¿Î¯Î¿ Ï€ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(472090,13114,'zh','é¦–é€‰çš„è£…è¿æ—¥æœŸ',0),(472091,13114,'sv','Rekommenderad transportdatum',0),(472092,13114,'it','Data di spedizione preferito',0),(472093,13114,'tl','',0),(472094,13114,'th','à¸§à¸±à¸™à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¸à¸²à¸£',0),(472095,13114,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(472096,13114,'ms','Tarikh pilihan kapal',0),(472097,13114,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„Ù…ÙØ¶Ù„',0),(472098,13114,'fr','Date d\'expÃ©dition prÃ©fÃ©rÃ©e',0),(472099,13114,'jp','æœ€å¯„ã‚Šã®å‡ºè·æ—¥',0),(472100,13114,'pt','Data de envio preferido',0),(472101,13114,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°ÐµÐ¼Ñ‹Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð”Ð°Ñ‚Ð°',0),(472102,13114,'es','Fecha de envÃ­o preferido',0),(472103,13114,'de','Bevorzugtes Lieferdatum',0),(472104,13114,'en','Preferred Ship Date',0),(472105,13115,'is','',0),(472106,13115,'dr','Ú†Ø§Ù¾ ØªØ§Ø±ÛŒØ®',0),(472107,13115,'pr','Ú†Ø§Ù¾ ØªØ§Ø±ÛŒØ®',0),(472108,13115,'tr','YazdÄ±rma tarihi',0),(472109,13115,'pl','Drukowanie daty',0),(472110,13115,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(472111,13115,'ur','ØªØ§Ø±ÛŒØ® Ù¾Ø±Ù†Ù¹',0),(472112,13115,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐ°',0),(472113,13115,'vi','ngÃ y in',0),(472114,13115,'af','Druk datum',0),(472115,13115,'ro','Imprimarea datei',0),(472116,13115,'et','Prindi kuupÃ¤ev',0),(472117,13115,'si','Datum tiskanja',0),(472118,13115,'ba','Mencetak tanggal',0),(472119,13115,'nl','Afdrukdatum',0),(472120,13115,'fi','PÃ¤ivÃ¤ys',0),(472121,13115,'no','Utskriftsdato',0),(472122,13115,'da','Print dato',0),(472123,13115,'ko','ì¸ì‡„ ë‚ ì§œ',0),(472124,13115,'he','×ª××¨×™×š ×”×“×¤×¡×”',0),(472125,13115,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(472126,13115,'zh','æ‰“å°æ—¥æœŸ',0),(472127,13115,'sv','Skriva ut datumet',0),(472128,13115,'it','Data della stampa',0),(472129,13115,'tl','',0),(472130,13115,'th','à¸žà¸´à¸¡à¸žà¹Œà¸§à¸±à¸™',0),(472131,13115,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(472132,13115,'ms','Tarikh cetak',0),(472133,13115,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(472134,13115,'fr','Date d\'impression',0),(472135,13115,'jp','æ—¥ä»˜ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(472136,13115,'pt','Imprimir a data',0),(472137,13115,'ru','Ð”Ð°Ñ‚Ð° Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(472138,13115,'es','Imprimir Fecha',0),(472139,13115,'de','Druckdatum',0),(472140,13115,'en','Print Date',0),(472141,13116,'is','',0),(472142,13116,'dr','Ú©Ø´ØªÛŒ Ø¨Ø¹Ø¯ Ø§Ø²',0),(472143,13116,'pr','Ú©Ø´ØªÛŒ Ø¨Ø¹Ø¯ Ø§Ø²',0),(472144,13116,'tr','Sonra gemi',0),(472145,13116,'pl','Statek po',0),(472146,13116,'bg','ÐšÐ¾Ñ€Ð°Ð± ÑÐ»ÐµÐ´',0),(472147,13116,'ur','Ú©Û’ Ø¨Ø¹Ø¯ Ø¬ÛØ§Ø²',0),(472148,13116,'sr','Ð‘Ñ€Ð¾Ð´ Ð½Ð°ÐºÐ¾Ð½',0),(472149,13116,'vi','TÃ u sau Ä‘á»£t',0),(472150,13116,'af','Skip na',0),(472151,13116,'ro','Navei dupÄƒ',0),(472152,13116,'et','PÃ¤rast laeva',0),(472153,13116,'si','Ladja po',0),(472154,13116,'ba','Kapal setelah',0),(472155,13116,'nl','Verzenden nadat u hebt',0),(472156,13116,'fi','Aluksen jÃ¤lkeen',0),(472157,13116,'no','Skipet etter',0),(472158,13116,'da','Skibet efter',0),(472159,13116,'ko','í›„ ë°œì†¡',0),(472160,13116,'he','×”×¡×¤×™× ×” ×œ××—×¨',0),(472161,13116,'el','Î Î»Î¿Î¯Î¿ Î¼ÎµÏ„Î¬',0),(472162,13116,'zh','èˆ¹åŽ',0),(472163,13116,'sv','Fartyget efter',0),(472164,13116,'it','Nave dopo',0),(472165,13116,'tl','',0),(472166,13116,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸',0),(472167,13116,'hi','à¤¬à¤¾à¤¦ à¤œà¤¹à¤¾à¤œ',0),(472168,13116,'ms','Kapal selepas',0),(472169,13116,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¨Ø¹Ø¯',0),(472170,13116,'fr','Navire aprÃ¨s',0),(472171,13116,'jp','å¾Œã§å‡ºè·ã—ã¾ã™ã€‚',0),(472172,13116,'pt','Depois do navio',0),(472173,13116,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿Ð¾ÑÐ»Ðµ',0),(472174,13116,'es','DespuÃ©s de la nave',0),(472175,13116,'de','Schiff nach',0),(472176,13116,'en','Ship After',0),(472177,13117,'is','',0),(472178,13117,'dr','Ú©Ø´ØªÛŒ Ù‚Ø¨Ù„ Ø§Ø²',0),(472179,13117,'pr','Ú©Ø´ØªÛŒ Ù‚Ø¨Ù„ Ø§Ø²',0),(472180,13117,'tr','Ã–nce gemi',0),(472181,13117,'pl','Statek przed',0),(472182,13117,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð¿Ñ€ÐµÐ´Ð¸',0),(472183,13117,'ur','Ø³Û’ Ù¾ÛÙ„Û’ Ø¬ÛØ§Ø²',0),(472184,13117,'sr','Ð‘Ñ€Ð¾Ð´ Ð¿Ñ€Ðµ',0),(472185,13117,'vi','TÃ u trÆ°á»›c khi',0),(472186,13117,'af','Skip voor',0),(472187,13117,'ro','Navei Ã®nainte de',0),(472188,13117,'et','Enne laeva',0),(472189,13117,'si','Ladje, preden',0),(472190,13117,'ba','Kapal sebelum',0),(472191,13117,'nl','Voordat het schip',0),(472192,13117,'fi','Aluksen ennen',0),(472193,13117,'no','Skipet fÃ¸r',0),(472194,13117,'da','Skibet fÃ¸r',0),(472195,13117,'ko','ì „ì— ë°°',0),(472196,13117,'he','×”×¡×¤×™× ×” ×œ×¤× ×™',0),(472197,13117,'el','Î Î»Î¿Î¯Î¿ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ',0),(472198,13117,'zh','èˆ¹å‰',0),(472199,13117,'sv','Fartyget innan',0),(472200,13117,'it','Nave prima',0),(472201,13117,'tl','',0),(472202,13117,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸à¹ˆà¸­à¸™',0),(472203,13117,'hi','à¤ªà¤¹à¤²à¥‡ à¤œà¤¹à¤¾à¤œ',0),(472204,13117,'ms','Kapal sebelum',0),(472205,13117,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù‚Ø¨Ù„',0),(472206,13117,'fr','ExpÃ©dier avant',0),(472207,13117,'jp','å‰ã«å‡ºè·ã—ã¾ã™ã€‚',0),(472208,13117,'pt','Navio antes',0),(472209,13117,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿ÐµÑ€ÐµÐ´',0),(472210,13117,'es','La nave antes de',0),(472211,13117,'de','Schiff vor',0),(472212,13117,'en','Ship Before',0),(472213,13118,'is','',0),(472214,13118,'dr','ÙØ§ÛŒÙ„ Ø±Ø§ Ø¶Ù…ÛŒÙ…Ù‡ Ú©Ù†ÛŒØ¯',0),(472215,13118,'pr','ÙØ§ÛŒÙ„ Ø±Ø§ Ø¶Ù…ÛŒÙ…Ù‡ Ú©Ù†ÛŒØ¯',0),(472216,13118,'tr','Dosya ekleme',0),(472217,13118,'pl','DoÅ‚Ä…cz plik',0),(472218,13118,'bg','ÐŸÑ€Ð¸ÐºÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(472219,13118,'ur','Ù…Ø³Ù„ Ù…Ù†Ø³Ù„Ú© Ú©Ø±ÛŒÚº',0),(472220,13118,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð¶Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(472221,13118,'vi','Há»“ sÆ¡ Ä‘Ã­nh kÃ¨m',0),(472222,13118,'af','Aangehegde LÃªer',0),(472223,13118,'ro','AtaÅŸaÅ£i fiÅŸiere',0),(472224,13118,'et','Manusta fail',0),(472225,13118,'si','PriloÅ¾ite datoteko',0),(472226,13118,'ba','Lampirkan File',0),(472227,13118,'nl','Bestand bijvoegen',0),(472228,13118,'fi','LiitÃ¤ tiedosto',0),(472229,13118,'no','Legg ved fil',0),(472230,13118,'da','VedhÃ¦fte fil',0),(472231,13118,'ko','íŒŒì¼ ì²¨ë¶€',0),(472232,13118,'he','×¦×¨×£ ×§×•×‘×¥',0),(472233,13118,'el','Î•Ï€Î¹ÏƒÏÎ½Î±ÏˆÎ· Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(472234,13118,'zh','é™„åŠ æ–‡ä»¶',0),(472235,13118,'sv','Bifoga fil',0),(472236,13118,'it','Allegare File',0),(472237,13118,'tl','',0),(472238,13118,'th','à¹à¸™à¸šà¹à¸Ÿà¹‰à¸¡',0),(472239,13118,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤¨à¥à¤²à¤—à¥à¤¨ à¤•à¤°à¥‡à¤‚',0),(472240,13118,'ms','Melampirkan fail',0),(472241,13118,'ar','Ø¥Ø±ÙØ§Ù‚ Ù…Ù„Ù',0),(472242,13118,'fr','Joindre fichier',0),(472243,13118,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‚’æ·»ä»˜ã—ã¾ã™ã€‚',0),(472244,13118,'pt','Anexar arquivo',0),(472245,13118,'ru','ÐŸÑ€Ð¸ÐºÑ€ÐµÐ¿Ð¸Ñ‚ÑŒ Ñ„Ð°Ð¹Ð»',0),(472246,13118,'es','Anexar File',0),(472247,13118,'de','Datei anhÃ¤ngen',0),(472248,13118,'en','Attach File',0),(472249,13119,'is','',0),(472250,13119,'dr','100',0),(472251,13119,'pr','Ø¬ÙˆØ§Ø¨ Ø¶Ø±Ø¨Ø¯Ø±Ú©Ù„ Ø³ÙØ§Ø±Ø´ ØªÙ‚Ø³ÛŒÙ… Ø¨Ø± 100',0),(472252,13119,'tr','Cevap X sipariÅŸ toplamÄ±nÄ±n 100 ile bÃ¶lÃ¼nmÃ¼ÅŸ',0),(472253,13119,'pl','Suma zamÃ³wienia odpowiedzi X dzielony przez 100',0),(472254,13119,'bg','ÐžÑ‚Ð³Ð¾Ð²Ð¾Ñ€ X Ñ€ÐµÐ´ Ð¾Ð±Ñ‰Ð¾, Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸ Ð¾Ñ‚ 100',0),(472255,13119,'ur','Ø¬ÙˆØ§Ø¨ X ØªØ±ØªÛŒØ¨ Ú©Ù„ 100 Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªÙ‚Ø³ÛŒÙ… Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(472256,13119,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€ X Ð¿Ð¾Ð´ÐµÑ™ÐµÐ½Ð¾ ÑÐ° 100',0),(472257,13119,'vi','Tráº£ lá»i Tá»•ng sá»‘ thá»© tá»± X chia cho 100',0),(472258,13119,'af','Antwoord X orde totaal gedeel deur 100',0),(472259,13119,'ro','RÄƒspunsul X ordine Total Ã®mpÄƒrÅ£it la 100',0),(472260,13119,'et','Vastus X tellimuse kogusumma jagatud 100',0),(472261,13119,'si','Odgovor X skupnega zneska deljeno s 100',0),(472262,13119,'ba','Jawaban X urutan Total dibagi 100',0),(472263,13119,'nl','Antwoord X Ordertotaal verdeeld door 100',0),(472264,13119,'fi','Vastaus X tilauksen summan jaettuna sadalla',0),(472265,13119,'no','Svaret X bestillingstotalen divideres med 100',0),(472266,13119,'da','Svaret X ordretotal divideret med 100',0),(472267,13119,'ko','ë‹µë³€ X ì£¼ë¬¸ í•©ê³„ë¥¼ 100ìœ¼ë¡œ ë‚˜ëˆˆ ê°’',0),(472268,13119,'he','×¡×™×›×•× ×”×–×ž× ×” ×”×ª×©×•×‘×” X ×—×œ×§×™ 100',0),(472269,13119,'el','Î‘Ï€Î¬Î½Ï„Î·ÏƒÎ· X Ï„Î¿ ÏƒÏ…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚ Î´Î¹Î±Î¹ÏÎ¿ÏÎ¼ÎµÎ½Î¿ Î¼Îµ Ï„Î¿ 100',0),(472270,13119,'zh','ç­”æ¡ˆ X è®¢å•æ€»é¢é™¤ä»¥ 100',0),(472271,13119,'sv','Svar X ordersumman dividerat med 100',0),(472272,13119,'it','Risposta X ordine totale diviso per 100',0),(472273,13119,'tl','',0),(472274,13119,'th','à¸¢à¸­à¸”à¸£à¸§à¸¡à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸„à¸³à¸•à¸­à¸š X à¸«à¸²à¸£ à¸”à¹‰à¸§à¸¢ 100',0),(472275,13119,'hi','à¤‰à¤¤à¥à¤¤à¤° à¤à¤•à¥à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥à¤² 100 à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤µà¤¿à¤­à¤¾à¤œà¤¿à¤¤',0),(472276,13119,'ms','Jawapan X jumlah pesanan yang dibahagikan dengan 100',0),(472277,13119,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø·Ù„Ø¨ÙŠØ© Ø¬ÙˆØ§Ø¨ X Ù…Ù‚Ø³ÙˆÙ…Ø§Ù‹ Ø¹Ù„Ù‰ 100',0),(472278,13119,'fr','RÃ©ponse X Total de la commande divisÃ© par 100',0),(472279,13119,'jp','ç­”ãˆ X æ³¨æ–‡ã®åˆè¨ˆãŒ 100 ã§é™¤ç®—',0),(472280,13119,'pt','Resposta X Total da ordem dividido por 100',0),(472281,13119,'ru','ÐžÑ‚Ð²ÐµÑ‚ X ÑÑƒÐ¼Ð¼Ð° Ð´ÐµÐ»Ð¸Ñ‚ÑÑ Ð½Ð° 100',0),(472282,13119,'es','Respuesta X Orden Total Entre 100',0),(472283,13119,'de','Antwort X Bestellsumme geteilt durch 100',0),(472284,13119,'en','Answer X Order Total Divided By 100',0),(472285,13120,'is','',0),(472286,13120,'dr','Ù¾Ø³ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(472287,13120,'pr','Ù¾Ø³ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(472288,13120,'tr','Fatura numarasÄ± Postfix',0),(472289,13120,'pl','Postfix numer faktury',0),(472290,13120,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¾Ð¼ÐµÑ€ Postfix',0),(472291,13120,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø± Ù¾ÙˆØ³Ù¹ÙØ³Ø§',0),(472292,13120,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð±Ñ€Ð¾Ñ˜ Ð¼Ð°Ð¸Ð»',0),(472293,13120,'vi','Pháº§n sau sá»‘ hÃ³a Ä‘Æ¡n',0),(472294,13120,'af','Faktuur nommer Postfix',0),(472295,13120,'ro','Postfix numÄƒrul facturii',0),(472296,13120,'et','Arve Number Postfix',0),(472297,13120,'si','Postfix Å¡tevilka raÄuna',0),(472298,13120,'ba','Postfix nomor faktur',0),(472299,13120,'nl','Factuur nummer Postfix',0),(472300,13120,'fi','Laskun numero Postfix',0),(472301,13120,'no','Faktura nummer Postfix',0),(472302,13120,'da','Faktura nummer Postfix',0),(472303,13120,'ko','ì†¡ìž¥ ë²ˆí˜¸ ì ‘ë¯¸ì‚¬',0),(472304,13120,'he','Postfix ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(472305,13120,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Postfix Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(472306,13120,'zh','å‘ç¥¨å·ç åŽç¼€',0),(472307,13120,'sv','Faktura nummer Postfix',0),(472308,13120,'it','Postfix numero fattura',0),(472309,13120,'tl','',0),(472310,13120,'th','Postfix à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(472311,13120,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤ªà¥‹à¤¸à¥à¤Ÿà¤«à¤¿à¤•à¥à¤¸',0),(472312,13120,'ms','Postfix nombor invois',0),(472313,13120,'ar','Postfix Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(472314,13120,'fr','Facture numÃ©ro Postfix',0),(472315,13120,'jp','è«‹æ±‚æ›¸ç•ªå·ã®æŽ¥å°¾è¾ž',0),(472316,13120,'pt','Postfix nÃºmero de factura',0),(472317,13120,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Postfix',0),(472318,13120,'es','NÃºmero de Factura Posfijo',0),(472319,13120,'de','Rechnung Nummer Postfix',0),(472320,13120,'en','Invoice Number Postfix',0),(472321,13121,'is','',0),(472322,13121,'dr','Ù¾ÛŒØ´ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(472323,13121,'pr','Ù¾ÛŒØ´ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(472324,13121,'tr','Fatura numarasÄ± Ã¶neki',0),(472325,13121,'pl','Prefiks numer faktury',0),(472326,13121,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ñ€ÐµÑ„Ð¸ÐºÑ',0),(472327,13121,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø³Ø§Ø¨Ù‚Û',0),(472328,13121,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€ÐµÑ„Ð¸ÐºÑ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(472329,13121,'vi','Pháº§n trÆ°á»›c sá»‘ hÃ³a Ä‘Æ¡n',0),(472330,13121,'af','Faktuur nommer voorvoegsel',0),(472331,13121,'ro','Prefixul numÄƒr facturÄƒ',0),(472332,13121,'et','Arve numbri eesliide',0),(472333,13121,'si','Å tevilo predpona raÄuna',0),(472334,13121,'ba','Awalan nomor faktur',0),(472335,13121,'nl','Factuur nummer voorvoegsel',0),(472336,13121,'fi','Laskun numeron etuliite',0),(472337,13121,'no','Faktura nummerprefiks',0),(472338,13121,'da','Faktura nummerprÃ¦fiks',0),(472339,13121,'ko','ì†¡ìž¥ ë²ˆí˜¸ ì ‘ë‘ì‚¬',0),(472340,13121,'he','×§×™×“×•×ž×ª ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(472341,13121,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€ÏÏŒÎ¸ÎµÎ¼Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(472342,13121,'zh','å‘ç¥¨å·ç å‰ç¼€',0),(472343,13121,'sv','Faktura nummerprefixet',0),(472344,13121,'it','Prefisso numero fattura',0),(472345,13121,'tl','',0),(472346,13121,'th','à¸™à¸³à¸«à¸™à¹‰à¸²à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(472347,13121,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤‰à¤ªà¤¸à¤°à¥à¤—',0),(472348,13121,'ms','Awalan nombor invois',0),(472349,13121,'ar','Ø¨Ø§Ø¯Ø¦Ø© Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(472350,13121,'fr','PrÃ©fixe du numÃ©ro de facture',0),(472351,13121,'jp','è«‹æ±‚æ›¸ç•ªå·ã®ãƒ—ãƒ¬ãƒ•ã‚£ãƒƒã‚¯ã‚¹',0),(472352,13121,'pt','Prefixo nÃºmero de factura',0),(472353,13121,'ru','ÐŸÑ€ÐµÑ„Ð¸ÐºÑ Ð½Ð¾Ð¼ÐµÑ€Ð° ÑÑ‡ÐµÑ‚Ð°',0),(472354,13121,'es','NÃºmero de Factura Prefijo',0),(472355,13121,'de','Rechnung NummernprÃ¤fix',0),(472356,13121,'en','Invoice Number Prefix',0),(472357,13122,'is','',0),(472358,13122,'dr','(ØªÙˆØ³Ø¹Ù‡)Ø¨ÛŒØ¬Ú©',0),(472359,13122,'pr','Ù…ØªÙ† Ø§Ø¶Ø§ÙÛŒ(ØªÙˆØ³Ø¹Ù‡)ÙØ§Ú©ØªÙˆØ±',0),(472360,13122,'tr','Fatura doldurma',0),(472361,13122,'pl','UzupeÅ‚nienie faktury',0),(472362,13122,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð»Ð°Ñ‚Ð°',0),(472363,13122,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù¾Ø§Ø¯Ø§Ù†Ú¯',0),(472364,13122,'sr','ÐŸÐ¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(472365,13122,'vi','HÃ³a Ä‘Æ¡n Ä‘á»‡m',0),(472366,13122,'af','Faktuur bo',0),(472367,13122,'ro','FacturÄƒ Padding',0),(472368,13122,'et','Arve polster',0),(472369,13122,'si','RaÄun oblazinjenje',0),(472370,13122,'ba','Padding faktur',0),(472371,13122,'nl','Factuur opvulling',0),(472372,13122,'fi','Laskun tÃ¤yte',0),(472373,13122,'no','Faktura utfylling',0),(472374,13122,'da','Faktura polstring',0),(472375,13122,'ko','ì†¡ìž¥ íŒ¨ë”©',0),(472376,13122,'he','×¨×™×¤×•×“ ×—×©×‘×•× ×™×ª',0),(472377,13122,'el','Î‘Î½Î±Ï€Î»Î®ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(472378,13122,'zh','å‘ç¥¨å¡«å……',0),(472379,13122,'sv','Faktura stoppning',0),(472380,13122,'it','Imbottitura di fattura',0),(472381,13122,'tl','',0),(472382,13122,'th','à¸£à¸°à¸¢à¸°à¸«à¹ˆà¸²à¸‡à¸‚à¸­à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(472383,13122,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ Padding',0),(472384,13122,'ms','Padding invois',0),(472385,13122,'ar','Ø§Ù„Ø­Ø´Ùˆ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(472386,13122,'fr','Rembourrage de facture',0),(472387,13122,'jp','è«‹æ±‚æ›¸ã®ãƒ‘ãƒ‡ã‚£ãƒ³ã‚°',0),(472388,13122,'pt','Preenchimento de nota fiscal',0),(472389,13122,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(472390,13122,'es','Factura Relleno',0),(472391,13122,'de','Rechnung-Polsterung',0),(472392,13122,'en','Invoice Padding',0),(472393,13123,'is','',0),(472394,13123,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¨Ø¹Ø¯ÛŒ',0),(472395,13123,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¨Ø¹Ø¯ÛŒ',0),(472396,13123,'tr','Bir sonraki sipariÅŸ numarasÄ±',0),(472397,13123,'pl','NastÄ™pny numer zamÃ³wienia',0),(472398,13123,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(472399,13123,'ur','Ø§Ú¯Ù„Ø§ Ø­Ú©Ù… Ù†Ù…Ø¨Ø±',0),(472400,13123,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(472401,13123,'vi','sá»‘ Ä‘Æ¡n hÃ ng tiáº¿p theo',0),(472402,13123,'af','Volgende volgorde nommer',0),(472403,13123,'ro','UrmÄƒtorul numÄƒr de ordine',0),(472404,13123,'et','JÃ¤rgmise jÃ¤rjekorranumbri',0),(472405,13123,'si','Naslednjo zaporedno Å¡tevilko',0),(472406,13123,'ba','Nomor pesanan berikutnya',0),(472407,13123,'nl','Volgende volgorde nummer',0),(472408,13123,'fi','Seuraava numero',0),(472409,13123,'no','Neste nummer',0),(472410,13123,'da','NÃ¦ste nummer',0),(472411,13123,'ko','ë‹¤ìŒ ì£¼ë¬¸ ë²ˆí˜¸',0),(472412,13123,'he','×ž×¡×¤×¨ ×”×”×–×ž× ×” ×”×‘××”',0),(472413,13123,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(472414,13123,'zh','ä¸‹ä¸€ä¸ªè®¢å•å·',0),(472415,13123,'sv','NÃ¤sta nummer',0),(472416,13123,'it','Numero di ordine successivo',0),(472417,13123,'tl','',0),(472418,13123,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸¥à¸³à¸”à¸±à¸šà¸–à¸±à¸”à¹„à¸›',0),(472419,13123,'hi','à¤…à¤—à¤²à¥‡ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(472420,13123,'ms','Seterusnya nombor pesanan',0),(472421,13123,'ar','Ø±Ù‚Ù… Ø§Ù„Ø£Ù…Ø± Ø§Ù„ØªØ§Ù„ÙŠ',0),(472422,13123,'fr','NumÃ©ro de commande suivant',0),(472423,13123,'jp','æ¬¡ã®æ³¨æ–‡ç•ªå·',0),(472424,13123,'pt','PrÃ³ximo nÃºmero de ordem',0),(472425,13123,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(472426,13123,'es','Proximo NÃºmero de Orden',0),(472427,13123,'de','NÃ¤chsten Bestellnummer',0),(472428,13123,'en','Next Order Number',0),(472429,13124,'is','',0),(472430,13124,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø±Ø³ÛŒØ¯ Ø¨Ø¹Ø¯ÛŒ',0),(472431,13124,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø±Ø³ÛŒØ¯ Ø¨Ø¹Ø¯ÛŒ',0),(472432,13124,'tr','Sonraki makbuz numarasÄ±',0),(472433,13124,'pl','NastÄ™pny numer blankietu',0),(472434,13124,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ°',0),(472435,13124,'ur','Ø§Ú¯Ù„Ø§ Ø±Ø³ÛŒØ¯ Ù†Ù…Ø¨Ø±',0),(472436,13124,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð°',0),(472437,13124,'vi','sá»‘ phiáº¿u thu tiáº¿p theo',0),(472438,13124,'af','Volgende kwitansie nommer',0),(472439,13124,'ro','UrmÄƒtorul numÄƒr de primire',0),(472440,13124,'et','JÃ¤rgmine tarne numbrit',0),(472441,13124,'si','Naslednji prejem Å¡tevilo',0),(472442,13124,'ba','Berikutnya nomor resi',0),(472443,13124,'nl','Volgende ontvangstnummer',0),(472444,13124,'fi','Seuraava vastaanoton numero',0),(472445,13124,'no','Neste kvitteringsnummer',0),(472446,13124,'da','NÃ¦ste kvitteringsnummeret',0),(472447,13124,'ko','ë‹¤ìŒ ì ‘ìˆ˜ ë²ˆí˜¸',0),(472448,13124,'he','×ž×¡×¤×¨ ×”×§×‘×œ×” ×”×‘×',0),(472449,13124,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î¿Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€Î±ÏÎ±Î»Î±Î²Î®',0),(472450,13124,'zh','æŽ¥ä¸‹æ¥çš„æ”¶æ®å·ç ',0),(472451,13124,'sv','NÃ¤sta kvittonumret',0),(472452,13124,'it','Prossimo numero di ricevuta',0),(472453,13124,'tl','',0),(472454,13124,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸à¸²à¸£à¸£à¸±à¸šà¸•à¹ˆà¸­à¹„à¸›',0),(472455,13124,'hi','à¤…à¤—à¤²à¥‡ à¤°à¤¸à¥€à¤¦ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(472456,13124,'ms','Nombor resit yang seterusnya',0),(472457,13124,'ar','Ø§Ù„Ù…Ù‚Ø¨Ù„ Ø§Ø³ØªÙ„Ø§Ù… Ø¹Ø¯Ø¯',0),(472458,13124,'fr','Prochain numÃ©ro de reÃ§u',0),(472459,13124,'jp','æ¬¡ã®é ˜åŽæ›¸ç•ªå·',0),(472460,13124,'pt','No prÃ³ximo nÃºmero do recibo',0),(472461,13124,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð½Ð¾Ð¼ÐµÑ€ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸',0),(472462,13124,'es','Proximo NÃºmero de Recibo',0),(472463,13124,'de','NÃ¤chste Belegnummer',0),(472464,13124,'en','Next Receipt Number',0),(472465,13125,'is','',0),(472466,13125,'dr',' Ù¾Ø³ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(472467,13125,'pr',' Ù¾Ø³ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ',0),(472468,13125,'tr','SipariÅŸ numara Postfix',0),(472469,13125,'pl','ZamÃ³wienie numer Postfix',0),(472470,13125,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð¾Ð¼ÐµÑ€ Postfix',0),(472471,13125,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ù¾ÙˆØ³Ù¹ÙØ³Ø§',0),(472472,13125,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¼Ð°Ð¸Ð» Ð½Ð°Ð»Ð¾Ð³Ð°',0),(472473,13125,'vi','Sá»‘ sau Ä‘Æ¡n hÃ ng',0),(472474,13125,'af','Bestelling nommer Postfix',0),(472475,13125,'ro','ComandÄƒ numÄƒrul Postfix',0),(472476,13125,'et','Tellimuse Number Postfix',0),(472477,13125,'si','Postfix Å¡tevilka naloga',0),(472478,13125,'ba','Urutan nomor Postfix',0),(472479,13125,'nl','Bestelling nummer Postfix',0),(472480,13125,'fi','Tilauksen numero Postfix',0),(472481,13125,'no','Bestill nummer Postfix',0),(472482,13125,'da','Ordre nummer Postfix',0),(472483,13125,'ko','ì£¼ë¬¸ ë²ˆí˜¸ ì ‘ë¯¸ì‚¬',0),(472484,13125,'he','Postfix ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(472485,13125,'el','Î¤Î¬Î¾Î· Î±ÏÎ¹Î¸Î¼Î¿Ï Postfix',0),(472486,13125,'zh','è®¢å•ç¼–å·åŽç¼€',0),(472487,13125,'sv','BestÃ¤llning nummer Postfix',0),(472488,13125,'it','Postfix numero ordine',0),(472489,13125,'tl','',0),(472490,13125,'th','Postfix à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(472491,13125,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¥‹à¤¸à¥à¤Ÿà¤«à¤¿à¤•à¥à¤¸',0),(472492,13125,'ms','Postfix nombor pesanan',0),(472493,13125,'ar','Ø£Ù…Ø± Ø¹Ø¯Ø¯ Postfix',0),(472494,13125,'fr','Ordre numÃ©ro Postfix',0),(472495,13125,'jp','æ³¨æ–‡ç•ªå·å¾Œç½®',0),(472496,13125,'pt','Ordem nÃºmero Postfix',0),(472497,13125,'ru','Ð—Ð°ÐºÐ°Ð· Ð½Ð¾Ð¼ÐµÑ€ Postfix',0),(472498,13125,'es','NÃºmero de Orden Posfijo',0),(472499,13125,'de','Bestellung Anzahl Postfix',0),(472500,13125,'en','Order Number Postfix',0),(472501,13126,'is','',0),(472502,13126,'dr','Ù¾ÛŒØ´ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(472503,13126,'pr','Ù¾ÛŒØ´ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(472504,13126,'tr','SipariÅŸ numara Ã¶neki',0),(472505,13126,'pl','Prefiks numeru zamÃ³wienia',0),(472506,13126,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð¿Ñ€ÐµÑ„Ð¸ÐºÑ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(472507,13126,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ø³Ø§Ø¨Ù‚Û',0),(472508,13126,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€ÐµÑ„Ð¸ÐºÑ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(472509,13126,'vi','Sá»‘ trÆ°á»›c Ä‘Æ¡n hÃ ng',0),(472510,13126,'af','Bestelling nommer voorvoegsel',0),(472511,13126,'ro','Prefix numeric ordine',0),(472512,13126,'et','Tootmistellimuse numbri eesliide',0),(472513,13126,'si','Å tevilo predpona naroÄila',0),(472514,13126,'ba','Urutan nomor awalan',0),(472515,13126,'nl','Bestelling nummer voorvoegsel',0),(472516,13126,'fi','Tilauksen numeron etuliite',0),(472517,13126,'no','Bestill nummerprefiks',0),(472518,13126,'da','Bestil nummerprÃ¦fiks',0),(472519,13126,'ko','ì£¼ë¬¸ ë²ˆí˜¸ ì ‘ë‘ì‚¬',0),(472520,13126,'he','×§×™×“×•×ž×ª ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(472521,13126,'el','Î¤Î¬Î¾Î· Î±ÏÎ¹Î¸Î¼Î¿Ï Ï€ÏÏŒÎ¸ÎµÎ¼Î±',0),(472522,13126,'zh','è®¢å•å·ç å‰ç¼€',0),(472523,13126,'sv','Ordning nummerprefixet',0),(472524,13126,'it','Prefisso numero ordine',0),(472525,13126,'tl','',0),(472526,13126,'th','à¸™à¸³à¸«à¸™à¹‰à¸²à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(472527,13126,'hi','à¤‘à¤°à¥à¤¡à¤° à¤¨à¤‚à¤¬à¤° à¤‰à¤ªà¤¸à¤°à¥à¤—',0),(472528,13126,'ms','Awalan nombor pesanan',0),(472529,13126,'ar','Ø£Ù…Ø± Ø¹Ø¯Ø¯ Ø¨Ø§Ø¯Ø¦Ø©',0),(472530,13126,'fr','PrÃ©fixe du numÃ©ro de commande',0),(472531,13126,'jp','æ³¨æ–‡ç•ªå·ã®ãƒ—ãƒ¬ãƒ•ã‚£ãƒƒã‚¯ã‚¹',0),(472532,13126,'pt','Prefixo de nÃºmero de ordem',0),(472533,13126,'ru','ÐŸÑ€ÐµÑ„Ð¸ÐºÑ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(472534,13126,'es','NÃºmero de Orden Prefijo',0),(472535,13126,'de','Bestellung NummernprÃ¤fix',0),(472536,13126,'en','Order Number Prefix',0),(472537,13127,'is','',0),(472538,13127,'dr','Ù…ØªÙ† Ø§Ø¶Ø§ÙÛŒ Ø³ÙØ§Ø±Ø´',0),(472539,13127,'pr','Ù…ØªÙ† Ø§Ø¶Ø§ÙÛŒ Ø³ÙØ§Ø±Ø´',0),(472540,13127,'tr','SipariÅŸ doldurma',0),(472541,13127,'pl','UzupeÅ‚nienie porzÄ…dku',0),(472542,13127,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ Ñ€ÐµÐ´',0),(472543,13127,'ur','Ø¢Ø±ÚˆØ± Ù¾Ø§Ø¯Ø§Ù†Ú¯',0),(472544,13127,'sr','ÐŸÐ¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(472545,13127,'vi','ÄÆ¡n hÃ ng Ä‘á»‡m',0),(472546,13127,'af','Orde bo',0),(472547,13127,'ro','UmpluturÄƒ de ordine',0),(472548,13127,'et','Tellimuse polster',0),(472549,13127,'si','Naloga oblazinjenje',0),(472550,13127,'ba','Urutan Padding',0),(472551,13127,'nl','Volgorde opvulling',0),(472552,13127,'fi','Tilauksen tÃ¤yttÃ¤minen',0),(472553,13127,'no','For utfylling',0),(472554,13127,'da','Bestil polstring',0),(472555,13127,'ko','ì£¼ë¬¸ íŒ¨ë”©',0),(472556,13127,'he','×”×–×ž× ×ª ×¨×™×¤×•×“',0),(472557,13127,'el','Î£ÎµÎ¹ÏÎ¬ Î±Î½Î±Ï€Î»Î®ÏÏ‰ÏƒÎ·',0),(472558,13127,'zh','é¡ºåºå¡«å……',0),(472559,13127,'sv','Ordning stoppning',0),(472560,13127,'it','Imbottitura di ordine',0),(472561,13127,'tl','',0),(472562,13127,'th','à¸£à¸°à¸¢à¸°à¸«à¹ˆà¸²à¸‡à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(472563,13127,'hi','à¤•à¥à¤°à¤® Padding',0),(472564,13127,'ms','Padding perintah',0),(472565,13127,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø­Ø´Ùˆ',0),(472566,13127,'fr','Rembourrage de l\'ordre',0),(472567,13127,'jp','é †åºã®ãƒ‘ãƒ‡ã‚£ãƒ³ã‚°',0),(472568,13127,'pt','Ordem de preenchimento',0),(472569,13127,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð·Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(472570,13127,'es','Relleno de Orden',0),(472571,13127,'de','Bestellung-Polsterung',0),(472572,13127,'en','Order Padding',0),(472573,13128,'is','',0),(472574,13128,'dr',' Ù¾Ø³ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø±Ø³ÛŒØ¯',0),(472575,13128,'pr',' Ù¾Ø³ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø±Ø³ÛŒØ¯',0),(472576,13128,'tr','Makbuz numarasÄ± Postfix',0),(472577,13128,'pl','Otrzymania numeru Postfix',0),(472578,13128,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð¾Ð¼ÐµÑ€ Postfix',0),(472579,13128,'ur','Ø±Ø³ÛŒØ¯ Ù†Ù…Ø¨Ø± Ù¾ÙˆØ³Ù¹ÙØ³Ø§',0),(472580,13128,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð±Ñ€Ð¾Ñ˜ Ð¼Ð°Ð¸Ð»',0),(472581,13128,'vi','sá»‘ sau sá»‘ phiáº¿u thu',0),(472582,13128,'af','Ontvangs nommer Postfix',0),(472583,13128,'ro','Primirea numÄƒrul Postfix',0),(472584,13128,'et','Kviitungi Number Postfix',0),(472585,13128,'si','Prejemu Postfix Å¡tevilka',0),(472586,13128,'ba','Postfix nomor tanda terima',0),(472587,13128,'nl','Ontvangst nummer Postfix',0),(472588,13128,'fi','Kuitti numero Postfix',0),(472589,13128,'no','Kvittering antall Postfix',0),(472590,13128,'da','Kvittering nummer Postfix',0),(472591,13128,'ko','ì˜ìˆ˜ì¦ ë²ˆí˜¸ ì ‘ë¯¸ì‚¬',0),(472592,13128,'he','Postfix ×ž×¡×¤×¨ ×§×‘×œ×”',0),(472593,13128,'el','Î Î±ÏÎ±Î»Î±Î²Î® Î±ÏÎ¹Î¸Î¼ÏŽÎ½ Postfix',0),(472594,13128,'zh','æ”¶æ®ç¼–å·åŽç¼€',0),(472595,13128,'sv','Kvitto nummer Postfix',0),(472596,13128,'it','Ricevuta numero Postfix',0),(472597,13128,'tl','',0),(472598,13128,'th','à¸£à¸±à¸šà¹€à¸¥à¸‚ Postfix',0),(472599,13128,'hi','à¤°à¤¸à¥€à¤¦ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¥‹à¤¸à¥à¤Ÿà¤«à¤¿à¤•à¥à¤¸',0),(472600,13128,'ms','Postfix nombor resit',0),(472601,13128,'ar','Ø§Ø³ØªÙ„Ø§Ù… Ø±Ù‚Ù… Postfix',0),(472602,13128,'fr','RÃ©ception numÃ©ro Postfix',0),(472603,13128,'jp','é ˜åŽæ›¸ç•ªå·å¾Œç½®',0),(472604,13128,'pt','Recibo nÃºmero Postfix',0),(472605,13128,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ðµ Ñ‡Ð¸ÑÐ»Ð° Postfix',0),(472606,13128,'es','NÃºmero de Recibo Posfijo',0),(472607,13128,'de','Eingang Nummer Postfix',0),(472608,13128,'en','Receipt Number Postfix',0),(472609,13129,'is','',0),(472610,13129,'dr','Ù¾ÛŒØ´ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø±Ø³ÛŒØ¯',0),(472611,13129,'pr','Ù¾ÛŒØ´ÙˆÙ†Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø±Ø³ÛŒØ¯',0),(472612,13129,'tr','Makbuz numarasÄ± Ã¶neki',0),(472613,13129,'pl','Otrzymania numeru prefiksu',0),(472614,13129,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ° Ð½Ð¾Ð¼ÐµÑ€Ð° Ð¿Ñ€ÐµÑ„Ð¸ÐºÑ',0),(472615,13129,'ur','Ø±Ø³ÛŒØ¯ Ù†Ù…Ø¨Ø± Ø³Ø§Ø¨Ù‚Û',0),(472616,13129,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð±Ñ€Ð¾Ñ˜ Ð¿Ñ€ÐµÑ„Ð¸ÐºÑ',0),(472617,13129,'vi','sá»‘ trÆ°á»›c sá»‘ phiáº¿u thu',0),(472618,13129,'af','Ontvangs nommer voorvoegsel',0),(472619,13129,'ro','Primirea Prefix numeric',0),(472620,13129,'et','Kviitungi Number eesliide',0),(472621,13129,'si','Prevzemnica Å¡tevilÄne predpone',0),(472622,13129,'ba','Awalan nomor tanda terima',0),(472623,13129,'nl','Ontvangst nummer voorvoegsel',0),(472624,13129,'fi','Kuitin numeron etuliite',0),(472625,13129,'no','Mottak nummerprefiks',0),(472626,13129,'da','Modtagelsen nummerprÃ¦fiks',0),(472627,13129,'ko','ì˜ìˆ˜ì¦ ë²ˆí˜¸ ì ‘ë‘ì‚¬',0),(472628,13129,'he','×§×™×“×•×ž×ª ×ž×¡×¤×¨ ×§×‘×œ×”',0),(472629,13129,'el','Î Î±ÏÎ±Î»Î±Î²Î® Î±ÏÎ¹Î¸Î¼ÏŽÎ½ Ï€ÏÏŒÎ¸ÎµÎ¼Î±',0),(472630,13129,'zh','æ”¶æ®å·ç å‰ç¼€',0),(472631,13129,'sv','Mottagandet nummerprefixet',0),(472632,13129,'it','Prefisso numero di ricevuta',0),(472633,13129,'tl','',0),(472634,13129,'th','à¸™à¸³à¸«à¸™à¹‰à¸²à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸£à¸±à¸š',0),(472635,13129,'hi','à¤°à¤¸à¥€à¤¦ à¤¨à¤‚à¤¬à¤° à¤‰à¤ªà¤¸à¤°à¥à¤—',0),(472636,13129,'ms','Awalan nombor resit',0),(472637,13129,'ar','Ø§Ø³ØªÙ„Ø§Ù… Ø¹Ø¯Ø¯ Ø¨Ø§Ø¯Ø¦Ø©',0),(472638,13129,'fr','PrÃ©fixe du numÃ©ro de rÃ©ception',0),(472639,13129,'jp','é ˜åŽæ›¸ç•ªå·ãƒ—ãƒ¬ãƒ•ã‚£ãƒƒã‚¯ã‚¹',0),(472640,13129,'pt','Prefixo de nÃºmero de recibo',0),(472641,13129,'ru','ÐŸÑ€ÐµÑ„Ð¸ÐºÑ Ð½Ð¾Ð¼ÐµÑ€Ð° ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸',0),(472642,13129,'es','NÃºmero de Recibo Prefijo',0),(472643,13129,'de','Eingang NummernprÃ¤fix',0),(472644,13129,'en','Receipt Number Prefix',0),(472645,13130,'is','',0),(472646,13130,'dr','Ù…ØªÙ† Ø§Ø¶Ø§ÙÛŒ Ø±Ø³ÛŒØ¯',0),(472647,13130,'pr','Ù…ØªÙ† Ø§Ø¶Ø§ÙÛŒ Ø±Ø³ÛŒØ¯',0),(472648,13130,'tr','AlÄ±ÅŸ irsaliyesi doldurma',0),(472649,13130,'pl','Potwierdzenie dopeÅ‚nienia',0),(472650,13130,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ° Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð»Ð°Ñ‚Ð°',0),(472651,13130,'ur','Ø±Ø³ÛŒØ¯ Ù¾Ø§Ø¯Ø§Ù†Ú¯',0),(472652,13130,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð¿ÑƒÑšÐµÑšÐµ',0),(472653,13130,'vi','sá»‘ Ä‘á»‡m phiáº¿u thu',0),(472654,13130,'af','Ontvangs bo',0),(472655,13130,'ro','Primirea Padding',0),(472656,13130,'et','Sissetuleku polster',0),(472657,13130,'si','Prejemu oblazinjenje',0),(472658,13130,'ba','Penerimaan Padding',0),(472659,13130,'nl','Ontvangst opvulling',0),(472660,13130,'fi','Vastaanoton tÃ¤yte',0),(472661,13130,'no','Mottak utfylling',0),(472662,13130,'da','Modtagelsen polstring',0),(472663,13130,'ko','ì˜ìˆ˜ì¦ íŒ¨ë”©',0),(472664,13130,'he','×¨×™×¤×•×“ ×§×‘×œ×”',0),(472665,13130,'el','Î Î±ÏÎ±Î»Î±Î²Î® Î±Î½Î±Ï€Î»Î®ÏÏ‰ÏƒÎ·',0),(472666,13130,'zh','æ”¶æ®å¡«å……',0),(472667,13130,'sv','Mottagandet stoppning',0),(472668,13130,'it','Imbottitura di ricevimento',0),(472669,13130,'tl','',0),(472670,13130,'th','à¸£à¸°à¸¢à¸°à¸«à¹ˆà¸²à¸‡à¸£à¸±à¸š',0),(472671,13130,'hi','à¤°à¤¸à¥€à¤¦ Padding',0),(472672,13130,'ms','Padding resit',0),(472673,13130,'ar','Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ø­Ø´Ùˆ',0),(472674,13130,'fr','Rembourrage de rÃ©ception',0),(472675,13130,'jp','é ˜åŽæ›¸ã®ãƒ‘ãƒ‡ã‚£ãƒ³ã‚°',0),(472676,13130,'pt','Preenchimento de recibo',0),(472677,13130,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸',0),(472678,13130,'es','Recibo Rellenado',0),(472679,13130,'de','Eingang Padding',0),(472680,13130,'en','Receipt Padding',0),(472681,13131,'is','',0),(472682,13131,'dr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ø¨Ø¹Ø¯ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(472683,13131,'pr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ø¨Ø¹Ø¯ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(472684,13131,'tr','Fatura numarasÄ± sonra gÃ¶rÃ¼ntÃ¼lenecek metni',0),(472685,13131,'pl','Tekst wydaje siÄ™ po numer faktury',0),(472686,13131,'bg','Ð¢ÐµÐºÑÑ‚ÑŠÑ‚ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð° ÑÐ»ÐµÐ´ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(472687,13131,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ú©Û’ Ø¨Ø¹Ø¯ Ø¸Ø§ÛØ± ÛÙˆÙ†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…ØªÙ†',0),(472688,13131,'sr','Ð¢ÐµÐºÑÑ‚ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð¿Ð¾Ñ˜Ð°Ð²Ð¸ ÐºÐ°Ð´ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(472689,13131,'vi','VÄƒn báº£n xuáº¥t hiá»‡n sau khi hoÃ¡ Ä‘Æ¡n sá»‘',0),(472690,13131,'af','Teks verskyn na faktuur nommer',0),(472691,13131,'ro','Textul sÄƒ aparÄƒ dupÄƒ numÄƒrul facturii',0),(472692,13131,'et','Paigutada arve Number',0),(472693,13131,'si','Prikaz besedila po Å¡tevilko raÄuna',0),(472694,13131,'ba','Teks yang muncul setelah faktur jumlah',0),(472695,13131,'nl','Tekst moet verschijnen na factuurnummer',0),(472696,13131,'fi','Tekstin jÃ¤lkeen laskunumero',0),(472697,13131,'no','Teksten vises etter fakturanummer',0),(472698,13131,'da','Tekst, der skal vises efter fakturanummer',0),(472699,13131,'ko','ì†¡ìž¥ ë²ˆí˜¸ ë’¤ì— í‘œì‹œ í•˜ëŠ” í…ìŠ¤íŠ¸',0),(472700,13131,'he','×”×˜×§×¡×˜ ×©×™×•×¤×™×¢ ×œ××—×¨ ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(472701,13131,'el','ÎšÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(472702,13131,'zh','æ˜¾ç¤ºåœ¨å‘ç¥¨ç¼–å·ä¹‹åŽçš„æ–‡æœ¬',0),(472703,13131,'sv','Text som ska visas efter fakturanummer',0),(472704,13131,'it','Testo a comparire dopo il numero della fattura',0),(472705,13131,'tl','',0),(472706,13131,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸—à¸µà¹ˆà¸ˆà¸°à¸›à¸£à¸²à¸à¸à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œ',0),(472707,13131,'hi','à¤ªà¤¾à¤  à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤ªà¥à¤°à¤•à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(472708,13131,'ms','Teks kelihatan selepas nombor invois',0),(472709,13131,'ar','Ø§Ù„Ù†Øµ Ø§Ù„Ø°ÙŠ Ø³ÙŠØ¸Ù‡Ø± Ø¨Ø¹Ø¯ Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(472710,13131,'fr','Texte s\'affiche aprÃ¨s le numÃ©ro de facture',0),(472711,13131,'jp','è«‹æ±‚æ›¸ç•ªå·å¾Œã«è¡¨ç¤ºã•ã‚Œã‚‹ãƒ†ã‚­ã‚¹ãƒˆ',0),(472712,13131,'pt','Texto a aparecer apÃ³s o nÃºmero da fatura',0),(472713,13131,'ru','Ð¢ÐµÐºÑÑ‚, Ð¿Ð¾ÑÐ²Ð»ÑÑŽÑ‰Ð¸Ð¹ÑÑ Ð¿Ð¾ÑÐ»Ðµ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(472714,13131,'es','Texto AparecerÃ¡ DespuÃ©s del NÃºmero de Factura',0),(472715,13131,'de','Text nach Rechnungsnummer angezeigt werden',0),(472716,13131,'en','Text To Appear After Invoice Number',0),(472717,13132,'is','',0),(472718,13132,'dr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ø¨Ø¹Ø¯ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(472719,13132,'pr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ø¨Ø¹Ø¯ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(472720,13132,'tr','SipariÅŸ numarasÄ± sonra gÃ¶rÃ¼ntÃ¼lenecek metni',0),(472721,13132,'pl','Tekst wydaje siÄ™ po numer zamÃ³wienia',0),(472722,13132,'bg','Ð¢ÐµÐºÑÑ‚ÑŠÑ‚ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð° ÑÐ»ÐµÐ´ Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(472723,13132,'ur','Ù…ØªÙ† Ú©Û’ Ø¨Ø¹Ø¯ Ù†Ø¸Ù… Ù†Ù…Ø¨Ø± Ú©Ùˆ Ø¸Ø§ÛØ± Ú©Ø±Ù†Ø§',0),(472724,13132,'sr','Ð¢ÐµÐºÑÑ‚ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð¿Ð¾Ñ˜Ð°Ð²Ð¸ ÐºÐ°Ð´ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(472725,13132,'vi','KÃ½ tá»± xuáº¥t hiá»‡n sau sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(472726,13132,'af','Teks verskyn na orde nommer',0),(472727,13132,'ro','Textul sÄƒ aparÄƒ dupÄƒ numÄƒrul de ordine',0),(472728,13132,'et','Tellimuse Number paigutada',0),(472729,13132,'si','Prikaz besedila po zaporedno Å¡tevilko',0),(472730,13132,'ba','Teks yang muncul setelah nomor pesanan',0),(472731,13132,'nl','Tekst moet verschijnen na ordernummer',0),(472732,13132,'fi','Tekstin jÃ¤lkeen tilausnumero',0),(472733,13132,'no','Teksten vises etter bestillingsnummer',0),(472734,13132,'da','Tekst, der skal vises efter lÃ¸benummer',0),(472735,13132,'ko','ì£¼ë¬¸ ë²ˆí˜¸ ë’¤ì— í‘œì‹œ í•˜ëŠ” í…ìŠ¤íŠ¸',0),(472736,13132,'he','×”×˜×§×¡×˜ ×©×™×•×¤×™×¢ ×œ××—×¨ ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(472737,13132,'el','ÎšÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(472738,13132,'zh','å‡ºçŽ°åœ¨è®¢å•ç¼–å·ä¹‹åŽçš„æ–‡æœ¬',0),(472739,13132,'sv','Text som ska visas efter ordernummer',0),(472740,13132,'it','Testo a comparire dopo il numero d\'ordine',0),(472741,13132,'tl','',0),(472742,13132,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸—à¸µà¹ˆà¸ˆà¸°à¸›à¸£à¸²à¸à¸à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(472743,13132,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤ªà¥à¤°à¤•à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤ ',0),(472744,13132,'ms','Teks kelihatan selepas nombor pesanan',0),(472745,13132,'ar','Ø§Ù„Ù†Øµ Ø§Ù„Ø°ÙŠ Ø³ÙŠØ¸Ù‡Ø± Ø¨Ø¹Ø¯ Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨',0),(472746,13132,'fr','Texte s\'affiche aprÃ¨s le numÃ©ro de commande',0),(472747,13132,'jp','æ³¨æ–‡ç•ªå·å¾Œã«è¡¨ç¤ºã•ã‚Œã‚‹ãƒ†ã‚­ã‚¹ãƒˆ',0),(472748,13132,'pt','Texto a aparecer apÃ³s o nÃºmero de ordem',0),(472749,13132,'ru','Ð¢ÐµÐºÑÑ‚, Ð¿Ð¾ÑÐ²Ð»ÑÑŽÑ‰Ð¸Ð¹ÑÑ Ð¿Ð¾ÑÐ»Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(472750,13132,'es','Texto AparecerÃ¡ DespuÃ©s del NÃºmero de Orden',0),(472751,13132,'de','Text nach Bestellnummer angezeigt werden',0),(472752,13132,'en','Text To Appear After Order Number',0),(472753,13133,'is','',0),(472754,13133,'dr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ø¨Ø¹Ø¯ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø±Ø³ÛŒØ¯',0),(472755,13133,'pr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ø¨Ø¹Ø¯ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø±Ø³ÛŒØ¯',0),(472756,13133,'tr','AlÄ±ÅŸ irsaliyesi numarasÄ±nÄ± sonra gÃ¶rÃ¼ntÃ¼lenecek metni',0),(472757,13133,'pl','Tekst sÄ… wyÅ›wietlane po otrzymaniu numeru',0),(472758,13133,'bg','Ð¢ÐµÐºÑÑ‚ÑŠÑ‚ Ð´Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð° ÑÐ»ÐµÐ´ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð±Ñ€Ð¾Ð¹',0),(472759,13133,'ur','Ø±Ø³ÛŒØ¯ Ù†Ù…Ø¨Ø± Ú©Û’ Ø¨Ø¹Ø¯ Ø¸Ø§ÛØ± ÛÙˆÙ†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…ØªÙ†',0),(472760,13133,'sr','Ð”Ð° ÑÐµ Ñ‚ÐµÐºÑÑ‚ Ð¿Ð¾Ñ˜Ð°Ð²Ð¸ Ð½Ð°ÐºÐ¾Ð½ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð° Ð±Ñ€Ð¾Ñ˜',0),(472761,13133,'vi','KÃ½ tá»± xuáº¥t hiá»‡n sau sá»‘ phiáº¿u thu',0),(472762,13133,'af','Teks verskyn na ontvangs nommer',0),(472763,13133,'ro','Textul sÄƒ aparÄƒ dupÄƒ primirea numÄƒrul',0),(472764,13133,'et','Kviitungi Number paigutada',0),(472765,13133,'si','Prikaz besedila po prejemu Å¡tevilka',0),(472766,13133,'ba','Teks yang muncul setelah nomor resi',0),(472767,13133,'nl','Tekst moet verschijnen na ontvangstnummer',0),(472768,13133,'fi','Tekstin jÃ¤lkeen vastaanoton numero',0),(472769,13133,'no','Teksten vises etter kvittering antall',0),(472770,13133,'da','Tekst, der skal vises efter kvitteringsnummeret',0),(472771,13133,'ko','í…ìŠ¤íŠ¸ í›„ì— ì ‘ìˆ˜ ë²ˆí˜¸ í‘œì‹œ',0),(472772,13133,'he','×”×˜×§×¡×˜ ×©×™×•×¤×™×¢ ×œ××—×¨ ×ž×¡×¤×¨ ×§×‘×œ×”',0),(472773,13133,'el','ÎšÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± ÎµÎ¼Ï†Î±Î½Î¯Î¶ÎµÏ„Î±Î¹ Î¼ÎµÏ„Î¬ Ï„Î·Î½ Ï€Î±ÏÎ±Î»Î±Î²Î® Î±ÏÎ¹Î¸Î¼Î¿Ï',0),(472774,13133,'zh','å‡ºçŽ°åœ¨æ”¶æ®ç¼–å·ä¹‹åŽçš„æ–‡æœ¬',0),(472775,13133,'sv','Text som ska visas efter kvitto nummer',0),(472776,13133,'it','Testo a comparire dopo il numero della ricevuta',0),(472777,13133,'tl','',0),(472778,13133,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸—à¸µà¹ˆà¸ˆà¸°à¸›à¸£à¸²à¸à¸à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸à¸²à¸£à¸£à¸±à¸š',0),(472779,13133,'hi','à¤°à¤¸à¥€à¤¦ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤ªà¥à¤°à¤•à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤ ',0),(472780,13133,'ms','Teks kelihatan selepas nombor resit',0),(472781,13133,'ar','Ø§Ù„Ù†Øµ Ø§Ù„Ø°ÙŠ Ø³ÙŠØ¸Ù‡Ø± Ø¨Ø¹Ø¯ Ø§Ø³ØªÙ„Ø§Ù… Ø¹Ø¯Ø¯',0),(472782,13133,'fr','Texte s\'affiche aprÃ¨s le numÃ©ro de reÃ§u',0),(472783,13133,'jp','é ˜åŽæ›¸ç•ªå·å¾Œã«è¡¨ç¤ºã•ã‚Œã‚‹ãƒ†ã‚­ã‚¹ãƒˆ',0),(472784,13133,'pt','Texto a aparecer depois do nÃºmero do recibo',0),(472785,13133,'ru','Ð¢ÐµÐºÑÑ‚, Ð¿Ð¾ÑÐ²Ð»ÑÑŽÑ‰Ð¸Ð¹ÑÑ Ð¿Ð¾ÑÐ»Ðµ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(472786,13133,'es','Texto AparecerÃ¡ DespuÃ©s del NÃºmero de Recibo',0),(472787,13133,'de','Text nach Belegnummer angezeigt werden',0),(472788,13133,'en','Text To Appear After Receipt Number',0),(472789,13134,'is','',0),(472790,13134,'dr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ù‚Ø¨Ù„ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(472791,13134,'pr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ù‚Ø¨Ù„ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(472792,13134,'tr','Fatura numarasÄ± Ã¶nce gÃ¶rÃ¼ntÃ¼lenecek metin',0),(472793,13134,'pl','Tekst do stawienia siÄ™ przed numer faktury',0),(472794,13134,'bg','Ð¢ÐµÐºÑÑ‚ Ð´Ð° ÑÐµ ÑÐ²Ð¸ Ð¿Ñ€ÐµÐ´ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(472795,13134,'ur','Ù…ØªÙ† Ø³Û’ Ù¾ÛÙ„Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø¸Ø§ÛØ± Ú©Ø±Ù†Ø§',0),(472796,13134,'sr','Ð¢ÐµÐºÑÑ‚ ÑÐµ Ð¿Ð¾Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(472797,13134,'vi','KÃ½ tá»± xuáº¥t hiá»‡n trÆ°á»›c sá»‘ hÃ³a Ä‘Æ¡n',0),(472798,13134,'af','Teks verskyn voor faktuur nommer',0),(472799,13134,'ro','Textul sÄƒ aparÄƒ Ã®nainte de numÄƒrul facturii',0),(472800,13134,'et','Arve numbrit kuvatav tekst',0),(472801,13134,'si','Prikaz besedila pred Å¡tevilko raÄuna',0),(472802,13134,'ba','Teks akan muncul sebelum nomor faktur',0),(472803,13134,'nl','Tekst om te verschijnen voor factuurnummer',0),(472804,13134,'fi','Tekstin nÃ¤kymÃ¤Ã¤n ennen laskunumero',0),(472805,13134,'no','Teksten som vises fÃ¸r fakturanummer',0),(472806,13134,'da','Tekst, der skal vises fÃ¸r fakturanummer',0),(472807,13134,'ko','ì†¡ìž¥ ë²ˆí˜¸ ì•žì— í…ìŠ¤íŠ¸',0),(472808,13134,'he','×”×˜×§×¡×˜ ×©×™×•×¤×™×¢ ×œ×¤× ×™ ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(472809,13134,'el','ÎšÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ ÎµÎ½ÏŽÏ€Î¹Î¿Î½ Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(472810,13134,'zh','å‘ç¥¨å·ç ä¹‹å‰æ˜¾ç¤ºçš„æ–‡å­—',0),(472811,13134,'sv','Text som ska visas fÃ¶re fakturanummer',0),(472812,13134,'it','Testo a comparire dinanzi a numero fattura',0),(472813,13134,'tl','',0),(472814,13134,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸—à¸µà¹ˆà¸ˆà¸°à¸›à¸£à¸²à¸à¸à¸à¹ˆà¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œ',0),(472815,13134,'hi','à¤ªà¤¾à¤  à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤ªà¥à¤°à¤•à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(472816,13134,'ms','Teks untuk hadir di hadapan nombor invois',0),(472817,13134,'ar','Ø§Ù„Ù†Øµ Ø§Ù„Ø°ÙŠ Ø³ÙŠØ¸Ù‡Ø± Ù‚Ø¨Ù„ Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(472818,13134,'fr','Texte de comparaÃ®tre devant le numÃ©ro de facture',0),(472819,13134,'jp','è«‹æ±‚æ›¸ç•ªå·ã®å‰ã«è¡¨ç¤ºã™ã‚‹ã«ã¯ã€ãƒ†ã‚­ã‚¹ãƒˆ',0),(472820,13134,'pt','Texto a ser exibido antes do nÃºmero da fatura',0),(472821,13134,'ru','Ð¢ÐµÐºÑÑ‚, Ð¿Ð¾ÑÐ²Ð»ÑÑŽÑ‰Ð¸Ð¹ÑÑ Ð¿ÐµÑ€ÐµÐ´ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(472822,13134,'es','Texto AparecerÃ¡ Antes del NÃºmero de Factura',0),(472823,13134,'de','Text vor Rechnungsnummer angezeigt werden',0),(472824,13134,'en','Text To Appear Before Invoice Number',0),(472825,13135,'is','',0),(472826,13135,'dr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ù‚Ø¨Ù„ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(472827,13135,'pr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ù‚Ø¨Ù„ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(472828,13135,'tr','SipariÅŸ numarasÄ± Ã¶nce gÃ¶rÃ¼ntÃ¼lenecek metin',0),(472829,13135,'pl','Tekst do stawienia siÄ™ przed numerem porzÄ…dkowym',0),(472830,13135,'bg','Ð¢ÐµÐºÑÑ‚ Ð´Ð° ÑÐµ ÑÐ²Ð¸ Ð¿Ñ€ÐµÐ´ Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(472831,13135,'ur','Ù…ØªÙ† Ø³Û’ Ù¾ÛÙ„Û’ Ù†Ø¸Ù… Ù†Ù…Ø¨Ø± Ú©Ùˆ Ø¸Ø§ÛØ± Ú©Ø±Ù†Ø§',0),(472832,13135,'sr','Ð¢ÐµÐºÑÑ‚ ÑÐµ Ð¿Ð¾Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(472833,13135,'vi','KÃ½ tá»± xuáº¥t hiá»‡n trÆ°á»›c sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(472834,13135,'af','Teks verskyn voor orde nommer',0),(472835,13135,'ro','Textul sÄƒ aparÄƒ Ã®nainte de numÄƒrul de ordine',0),(472836,13135,'et','Tootmistellimuse numbrit kuvatav tekst',0),(472837,13135,'si','Prikaz besedila pred zaporedno Å¡tevilko',0),(472838,13135,'ba','Teks akan muncul sebelum nomor pesanan',0),(472839,13135,'nl','Tekst om te verschijnen voor ordernummer',0),(472840,13135,'fi','Numeron edeltÃ¤vÃ¤ teksti',0),(472841,13135,'no','Teksten som vises fÃ¸r nummeret',0),(472842,13135,'da','Tekst, der skal vises fÃ¸r ordrenummer',0),(472843,13135,'ko','ì£¼ë¬¸ ë²ˆí˜¸ ì•žì— í…ìŠ¤íŠ¸',0),(472844,13135,'he','×”×˜×§×¡×˜ ×©×™×•×¤×™×¢ ×œ×¤× ×™ ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(472845,13135,'el','ÎšÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± ÎµÎ¼Ï†Î±Î½Î¯Î¶ÎµÏ„Î±Î¹ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(472846,13135,'zh','è¦åœ¨è®¢å•ç¼–å·ä¹‹å‰æ˜¾ç¤ºçš„æ–‡æœ¬',0),(472847,13135,'sv','Text som ska visas fÃ¶re ordernummer',0),(472848,13135,'it','Testo a comparire dinanzi il numero d\'ordine',0),(472849,13135,'tl','',0),(472850,13135,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸—à¸µà¹ˆà¸ˆà¸°à¸›à¸£à¸²à¸à¸à¸à¹ˆà¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(472851,13135,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤¹à¤²à¥‡ à¤ªà¥à¤°à¤•à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤ ',0),(472852,13135,'ms','Teks untuk hadir di hadapan nombor pesanan',0),(472853,13135,'ar','Ø§Ù„Ù†Øµ Ø§Ù„Ø°ÙŠ Ø³ÙŠØ¸Ù‡Ø± Ù‚Ø¨Ù„ Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨',0),(472854,13135,'fr','Texte de comparaÃ®tre devant le numÃ©ro de commande',0),(472855,13135,'jp','æ³¨æ–‡ç•ªå·ã®å‰ã«è¡¨ç¤ºã™ã‚‹ã«ã¯ã€ãƒ†ã‚­ã‚¹ãƒˆ',0),(472856,13135,'pt','Texto a ser exibido antes do nÃºmero de ordem',0),(472857,13135,'ru','Ð¢ÐµÐºÑÑ‚, Ð¿Ð¾ÑÐ²Ð»ÑÑŽÑ‰Ð¸Ð¹ÑÑ Ð¿ÐµÑ€ÐµÐ´ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(472858,13135,'es','Texto AparecerÃ¡ Antes del NÃºmero de Orden',0),(472859,13135,'de','Text vor der Bestellnummer angezeigt werden',0),(472860,13135,'en','Text To Appear Before Order Number',0),(472861,13136,'is','',0),(472862,13136,'dr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ù‚Ø¨Ù„ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø±Ø³ÛŒØ¯',0),(472863,13136,'pr','Ù…ØªÙ† Ø¬Ù‡Øª Ù†Ù…Ø§ÛŒØ´ Ù‚Ø¨Ù„ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø±Ø³ÛŒØ¯',0),(472864,13136,'tr','AlÄ±ÅŸ irsaliyesi numarasÄ±nÄ± Ã¶nce gÃ¶rÃ¼ntÃ¼lenecek metin',0),(472865,13136,'pl','Tekst do stawienia siÄ™ przed numer blankietu',0),(472866,13136,'bg','Ð¢ÐµÐºÑÑ‚ Ð´Ð° ÑÐµ ÑÐ²Ð¸ Ð¿Ñ€ÐµÐ´ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð±Ñ€Ð¾Ð¹',0),(472867,13136,'ur','Ø±Ø³ÛŒØ¯ Ù†Ù…Ø¨Ø± Ø³Û’ Ù¾ÛÙ„Û’ Ø¸Ø§ÛØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù¹ÛŒÚ©Ø³Ù¹',0),(472868,13136,'sr','Ð¢ÐµÐºÑÑ‚ ÑÐµ Ð¿Ð¾Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´ Ð±Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ñ†Ðµ',0),(472869,13136,'vi','KÃ½ tá»± xuáº¥t hiá»‡n trÆ°á»›c sá»‘ phiáº¿u thu',0),(472870,13136,'af','Teks verskyn voor ontvangs nommer',0),(472871,13136,'ro','Textul sÄƒ aparÄƒ Ã®nainte de primirea numÄƒrul',0),(472872,13136,'et','Tarne numbrit kuvatav tekst',0),(472873,13136,'si','Prikaz besedila pred prejem Å¡tevilo',0),(472874,13136,'ba','Teks akan muncul sebelum nomor resi',0),(472875,13136,'nl','Tekst om te verschijnen voor ontvangstnummer',0),(472876,13136,'fi','Kuitin numeron edeltÃ¤vÃ¤ teksti',0),(472877,13136,'no','Teksten som vises fÃ¸r kvitteringsnummer',0),(472878,13136,'da','Tekst, der skal vises fÃ¸r kvitteringsnummeret',0),(472879,13136,'ko','ì ‘ìˆ˜ ë²ˆí˜¸ ì•žì— í…ìŠ¤íŠ¸',0),(472880,13136,'he','×”×˜×§×¡×˜ ×©×™×•×¤×™×¢ ×œ×¤× ×™ ×ž×¡×¤×¨ ×§×‘×œ×”',0),(472881,13136,'el','ÎšÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± ÎµÎ¼Ï†Î±Î½Î¯Î¶ÎµÏ„Î±Î¹ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Ï€Î±ÏÎ±Î»Î±Î²Î® Î±ÏÎ¹Î¸Î¼Î¿Ï',0),(472882,13136,'zh','è¦åœ¨æ”¶æ®ç¼–å·ä¹‹å‰æ˜¾ç¤ºçš„æ–‡æœ¬',0),(472883,13136,'sv','Text som ska visas fÃ¶re kvitto nummer',0),(472884,13136,'it','Testo a comparire dinanzi il numero della ricevuta',0),(472885,13136,'tl','',0),(472886,13136,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸—à¸µà¹ˆà¸ˆà¸°à¸›à¸£à¸²à¸à¸à¸à¹ˆà¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸à¸²à¸£à¸£à¸±à¸š',0),(472887,13136,'hi','à¤°à¤¸à¥€à¤¦ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤ªà¥à¤°à¤•à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤ ',0),(472888,13136,'ms','Teks untuk hadir di hadapan nombor resit',0),(472889,13136,'ar','Ø§Ù„Ù†Øµ Ø§Ù„Ø°ÙŠ Ø³ÙŠØ¸Ù‡Ø± Ù‚Ø¨Ù„ Ø§Ø³ØªÙ„Ø§Ù… Ø¹Ø¯Ø¯',0),(472890,13136,'fr','Texte de comparaÃ®tre devant le numÃ©ro de reÃ§u',0),(472891,13136,'jp','é ˜åŽæ›¸ç•ªå·ã®å‰ã«è¡¨ç¤ºã™ã‚‹ã«ã¯ã€ãƒ†ã‚­ã‚¹ãƒˆ',0),(472892,13136,'pt','Texto a ser exibido antes do nÃºmero do recibo',0),(472893,13136,'ru','Ð¢ÐµÐºÑÑ‚, Ð¿Ð¾ÑÐ²Ð»ÑÑŽÑ‰Ð¸Ð¹ÑÑ Ð¿ÐµÑ€ÐµÐ´ Ð½Ð¾Ð¼ÐµÑ€ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸',0),(472894,13136,'es','Texto AparecerÃ¡ Antes del NÃºmero de Recibo',0),(472895,13136,'de','Text vor Belegnummer angezeigt werden',0),(472896,13136,'en','Text To Appear Before Receipt Number',0),(472897,13137,'is','',0),(472898,13137,'dr','ØªØ±ØªÛŒØ¨ Ú©Ø§Ø±Ø¨Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø´Ø±Ú©Øª ',0),(472899,13137,'pr','ØªØ±ØªÛŒØ¨ Ú©Ø§Ø±Ø¨Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø´Ø±Ú©Øª ',0),(472900,13137,'tr','Bu ÅŸirket iÃ§in kullanÄ±cÄ± dizileri',0),(472901,13137,'pl','Sekwencji uÅ¼ytkownika do tej firmy',0),(472902,13137,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð¿Ð¾ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ„Ð¸Ñ€Ð¼Ð°',0),(472903,13137,'ur','Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„Ø¦Û’ ØµØ§Ø±Ù Ù…ØªÙˆØ§Ù„ÛŒÛ (Ø±ÛŒØ§Ø¶ÛŒ)',0),(472904,13137,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº ÑÐµÐºÐ²ÐµÐ½Ñ†Ðµ Ð·Ð° Ð¾Ð²Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(472905,13137,'vi','TrÃ¬nh tá»± ngÆ°á»i dÃ¹ng Ä‘á»‘i vá»›i cÃ´ng ty nÃ y',0),(472906,13137,'af','Gebruiker rye vir hierdie maatskappy',0),(472907,13137,'ro','SecvenÈ›e utilizator pentru aceastÄƒ companie',0),(472908,13137,'et','Kasutaja jÃ¤rjestused selle firma',0),(472909,13137,'si','Uporabnik zaporedij za to podjetje',0),(472910,13137,'ba','Urutan pengguna untuk perusahaan ini',0),(472911,13137,'nl','Gebruiker sequenties voor dit bedrijf',0),(472912,13137,'fi','KÃ¤yttÃ¤jÃ¤n sarjoja tÃ¤lle yritykselle',0),(472913,13137,'no','Brukeren sekvenser For dette selskapet',0),(472914,13137,'da','Bruger sekvenser For dette selskab',0),(472915,13137,'ko','ì´ íšŒì‚¬ì— ëŒ€ í•œ ì‚¬ìš©ìž ì‹œí€€ìŠ¤',0),(472916,13137,'he','×¨×¦×¤×™× ×”×ž×©×ª×ž×© ×œ×—×‘×¨×” ×”×–×•',0),(472917,13137,'el','Î‘ÎºÎ¿Î»Î¿Ï…Î¸Î¯ÎµÏ‚ Ï„Î¿Ï… Ï‡ÏÎ®ÏƒÏ„Î· Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î±Ï…Ï„Î®',0),(472918,13137,'zh','è¿™å®¶å…¬å¸çš„ç”¨æˆ·åºåˆ—',0),(472919,13137,'sv','AnvÃ¤ndaren sekvenser fÃ¶r detta fÃ¶retag',0),(472920,13137,'it','Sequenze di utente per questa azienda',0),(472921,13137,'tl','',0),(472922,13137,'th','à¸¥à¸³à¸”à¸±à¸šà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸£à¸´à¸©à¸±à¸—à¸™à¸µà¹‰',0),(472923,13137,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¦à¥ƒà¤¶à¥à¤¯à¥‹à¤‚',0),(472924,13137,'ms','Pengguna rangkaian bagi Syarikat ini',0),(472925,13137,'ar','ØªØ³Ù„Ø³Ù„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ©',0),(472926,13137,'fr','SÃ©quences d\'utilisateur pour cette sociÃ©tÃ©',0),(472927,13137,'jp','ã“ã®ä¼šç¤¾ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ ã‚·ãƒ¼ã‚±ãƒ³ã‚¹',0),(472928,13137,'pt','SeqÃ¼Ãªncias de usuÃ¡rio para esta empresa',0),(472929,13137,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(472930,13137,'es','Secuencias Del Usuario Para Esta Empresa',0),(472931,13137,'de','Benutzer-Sequenzen fÃ¼r diese Firma',0),(472932,13137,'en','User Sequences For This Company',0),(472933,13138,'is','',0),(472934,13138,'dr','Ù†Ù…Ø§ÛŒØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(472935,13138,'pr','Ù†Ù…Ø§ÛŒØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(472936,13138,'tr','Verileri gÃ¶rÃ¼ntÃ¼leme',0),(472937,13138,'pl','Widok danych',0),(472938,13138,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸Ñ‚Ðµ',0),(472939,13138,'ur','Ú©ÙˆØ§Ø¦Ù Ù…Ù†Ø¸Ø±',0),(472940,13138,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(472941,13138,'vi','Xem dá»¯ liá»‡u',0),(472942,13138,'af','Bekyk Data',0),(472943,13138,'ro','Vizualizare date',0),(472944,13138,'et','Andmete kuvamine',0),(472945,13138,'si','Ogled podatkov',0),(472946,13138,'ba','Lihat Data',0),(472947,13138,'nl','Gegevens weergeven',0),(472948,13138,'fi','NÃ¤ytÃ¤ tiedot',0),(472949,13138,'no','Visningsdata',0),(472950,13138,'da','Visningsdata',0),(472951,13138,'ko','ë°ì´í„° ë³´ê¸°',0),(472952,13138,'he','×”×¦×’ × ×ª×•× ×™×',0),(472953,13138,'el','Î ÏÎ¿Î²Î¿Î»Î® Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(472954,13138,'zh','æŸ¥çœ‹æ•°æ®',0),(472955,13138,'sv','Visa Data',0),(472956,13138,'it','Visualizzazione dati',0),(472957,13138,'tl','',0),(472958,13138,'th','à¸¡à¸¸à¸¡à¸¡à¸­à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(472959,13138,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤¦à¥‡à¤–à¥‡à¤‚',0),(472960,13138,'ms','Paparan Data',0),(472961,13138,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(472962,13138,'fr','Afficher les donnÃ©es',0),(472963,13138,'jp','ãƒ‡ãƒ¼ã‚¿ã®è¡¨ç¤º',0),(472964,13138,'pt','ExibiÃ§Ã£o de dados',0),(472965,13138,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(472966,13138,'es','Ve Los Datos',0),(472967,13138,'de','Daten anzeigen',0),(472968,13138,'en','View Data',0),(472969,13139,'is','',0),(472970,13139,'dr','941 Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(472971,13139,'pr','ÙØ§ÛŒÙ„ 941 Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(472972,13139,'tr','941 elektronik dosya',0),(472973,13139,'pl','Plik 941 elektronicznie',0),(472974,13139,'bg','Ð¤Ð°Ð¹Ð» 941 Ð¿Ð¾ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÐµÐ½ Ð¿ÑŠÑ‚',0),(472975,13139,'ur','941 Ø§Ù„ÛŒÚ©Ù¹Ø±Ø§Ù†Ú© ÙØ§Ø¦Ù„',0),(472976,13139,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° 941 ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÑÐºÐ¸Ð¼ Ð¿ÑƒÑ‚ÐµÐ¼',0),(472977,13139,'vi','há»“ sÆ¡ Ä‘iá»‡n tá»­ 941',0),(472978,13139,'af','LÃªer 941 elektronies',0),(472979,13139,'ro','FiÅŸier 941 electronic',0),(472980,13139,'et','Faili 941 elektrooniliselt',0),(472981,13139,'si','Elektronsko datoteko 941',0),(472982,13139,'ba','File 941 elektronik',0),(472983,13139,'nl','941 elektronisch bestand',0),(472984,13139,'fi','Tiedoston 941 sÃ¤hkÃ¶isesti',0),(472985,13139,'no','Filen 941 elektronisk',0),(472986,13139,'da','Fil 941 elektronisk',0),(472987,13139,'ko','íŒŒì¼ 941: ì „ìž',0),(472988,13139,'he','×§×•×‘×¥ 941 ××œ×§×˜×¨×•× ×™×ª',0),(472989,13139,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ 941 Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¬',0),(472990,13139,'zh','ç”µå­æ–‡ä»¶ 941',0),(472991,13139,'sv','Fil 941 elektroniskt',0),(472992,13139,'it','941 del file elettronicamente',0),(472993,13139,'tl','',0),(472994,13139,'th','941 à¸¢à¸·à¹ˆà¸™à¸—à¸²à¸‡à¸­à¸´à¹€à¸¥à¹‡à¸à¸—à¸£à¸­à¸™à¸´à¸à¸ªà¹Œ',0),(472995,13139,'hi','941 à¤‡à¤²à¥‡à¤•à¥à¤Ÿà¥à¤°à¥‰à¤¨à¤¿à¤• à¤«à¤¼à¤¾à¤‡à¤²',0),(472996,13139,'ms','Fail 941 secara elektronik',0),(472997,13139,'ar','Ù…Ù„Ù 941 Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠØ§',0),(472998,13139,'fr','941 du dossier par voie Ã©lectronique',0),(472999,13139,'jp','941 ã‚’é›»å­çš„ã«ãƒ•ã‚¡ã‚¤ãƒ«ã—ã¾ã™ã€‚',0),(473000,13139,'pt','Arquivo 941 eletronicamente',0),(473001,13139,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¼ Ð²Ð¸Ð´Ðµ Ñ„Ð°Ð¹Ð»Ð° 941',0),(473002,13139,'es','File 941 Electronicamente',0),(473003,13139,'de','Datei 941 elektronisch',0),(473004,13139,'en','File 941 Electronically',0),(473005,13140,'is','',0),(473006,13140,'dr','Ù…Ø¬Ø§Ø² Ø¨Ù‡ ØªØºÛŒÛŒØ± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ù†ÛŒØ³Øª',0),(473007,13140,'pr','Ù…Ø¬Ø§Ø² Ø¨Ù‡ ØªØºÛŒÛŒØ± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ù†ÛŒØ³Øª',0),(473008,13140,'tr','SatÄ±ÅŸ temsilcisinin sipariÅŸleri deÄŸiÅŸtirmek iÃ§in izin',0),(473009,13140,'pl','Niemoge zmieniÄ‡ sprzedawcÄ™ na zamÃ³wienia',0),(473010,13140,'bg','ÐÐµ Ðµ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÑÑ‚ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ† Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(473011,13140,'ur','Ù¾Ø±Ø³Ù† Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº',0),(473012,13140,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° ÑÐµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ† Ð½Ð° Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð°',0),(473013,13140,'vi','khÃ´ng cho phÃ©p Ä‘á»•i nhÃ¢n viÃªn bÃ¡n hÃ ng trÃªn Ä‘Æ¡n hÃ ng',0),(473014,13140,'af','Nie toegelaat om te verander verkoopspersoon op bestellings',0),(473015,13140,'ro','Nu este permis sÄƒ modificaÅ£i comenzile de vÃ¢nzÄƒri',0),(473016,13140,'et','Ei ole lubatud muuta mÃ¼Ã¼giesindaja tellimused',0),(473017,13140,'si','Ni dovoljeno spremeniti prodajalca na naroÄila',0),(473018,13140,'ba','Tidak diperkenankan untuk mengubah Penjual atas perintah',0),(473019,13140,'nl','Niet toegestaan om te veranderen van verkoper op bestellingen',0),(473020,13140,'fi','Ei voi muuttaa myyjÃ¤n tilausten',0),(473021,13140,'no','Ikke tillatt Ã¥ endre selger ordrer',0),(473022,13140,'da','Ikke tilladt at Ã¦ndre sÃ¦lger pÃ¥ ordrer',0),(473023,13140,'ko','ì˜ì—… ì‚¬ì› ì£¼ë¬¸ì— ëŒ€í•´ ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(473024,13140,'he','××¡×•×¨ ×œ×©× ×•×ª ××™×© ×ž×›×™×¨×•×ª ×¢×œ ×”×–×ž× ×•×ª',0),(473025,13140,'el','Î”ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î½Î± Î±Î»Î»Î¬Î¾ÎµÎ¹ Ï€Ï‰Î»Î·Ï„Î® ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(473026,13140,'zh','ä¸å…è®¸æ›´æ”¹è®¢å•çš„é”€å”®äººå‘˜',0),(473027,13140,'sv','Inte tillÃ¥tet att Ã¤ndra sÃ¤ljare pÃ¥ order',0),(473028,13140,'it','Non Ã¨ consentito cambiare agente sugli ordini',0),(473029,13140,'tl','',0),(473030,13140,'th','à¹„à¸¡à¹ˆà¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢à¹ƒà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(473031,13140,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤ªà¤° à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚',0),(473032,13140,'ms','Tidak dibenarkan untuk menukar jurujual di pesanan',0),(473033,13140,'ar','ØºÙŠØ± Ù…Ø³Ù…ÙˆØ­ Ø¨ØªØºÙŠÙŠØ± Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø±',0),(473034,13140,'fr','Pas autorisÃ© Ã  modifier le vendeur sur les commandes',0),(473035,13140,'jp','å–¶æ¥­æ‹…å½“è€…ã®æ³¨æ–‡ã‚’å¤‰æ›´ã™ã‚‹ã«ã¯ã€ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(473036,13140,'pt','NÃ£o podem alterar o vendedor em ordens',0),(473037,13140,'ru','ÐÐµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐ°ÐµÑ‚ÑÑ Ð¸Ð·Ð¼ÐµÐ½ÑÑ‚ÑŒ Ð¼ÐµÐ½ÐµÐ´Ð¶ÐµÑ€Ð° Ð¿Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°Ð¼',0),(473038,13140,'es','No Se Permite Cambiar Vendedor en Los Ordenes',0),(473039,13140,'de','DÃ¼rfen VerkÃ¤ufer Bestellungen Ã¤ndern',0),(473040,13140,'en','Not Allowed To Change Salesperson On Orders',0),(473041,13141,'is','',0),(473042,13141,'dr','Ù„ÛŒØ³Øª Ù†Ù…ÙˆÙ†Ù‡ ØªØ§Ø±ÛŒØ® Ù‡Ø§',0),(473043,13141,'pr','Ù„ÛŒØ³Øª Ù†Ù…ÙˆÙ†Ù‡ ØªØ§Ø±ÛŒØ® Ù‡Ø§',0),(473044,13141,'tr','Tipik tarihleri listesi',0),(473045,13141,'pl','LiÅ›cie typowe terminy',0),(473046,13141,'bg','Ð¢Ð¸Ð¿Ð¸Ñ‡Ð½Ð¸ Ð´Ð°Ñ‚Ð¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(473047,13141,'ur','Ù…Ø®ØµÙˆØµ ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©ÛŒ ÙÛØ±Ø³Øª',0),(473048,13141,'sr','Ð¢Ð¸Ð¿Ð¸Ñ‡Ð½Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ðµ Ð»Ð¸ÑÑ‚Ð°',0),(473049,13141,'vi','Danh sÃ¡ch ngÃ y Ä‘iá»ƒn hÃ¬nh',0),(473050,13141,'af','Tipiese datums lys',0),(473051,13141,'ro','Lista tipic de dvs.',0),(473052,13141,'et','TÃ¼Ã¼piline kuupÃ¤evade loend',0),(473053,13141,'si','Seznam tipiÄnih datumov',0),(473054,13141,'ba','Daftar tanggal khas',0),(473055,13141,'nl','Typische data lijst',0),(473056,13141,'fi','Tyypillinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t luettelo',0),(473057,13141,'no','Typisk datoer-listen',0),(473058,13141,'da','Typiske datoer liste',0),(473059,13141,'ko','ì „í˜•ì ì¸ ë‚ ì§œ ëª©ë¡',0),(473060,13141,'he','×¨×©×™×ž×ª ×ª××¨×™×›×™ ×˜×™×¤×•×¡×™',0),(473061,13141,'el','Î›Î¯ÏƒÏ„Î± Ï„Ï…Ï€Î¹ÎºÎ¬ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(473062,13141,'zh','å…¸åž‹çš„çº¦ä¼šåˆ—è¡¨',0),(473063,13141,'sv','Typiska datum lista',0),(473064,13141,'it','Elenco date tipico',0),(473065,13141,'tl','',0),(473066,13141,'th','à¸£à¸²à¸¢à¸§à¸±à¸™à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(473067,13141,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¥‚à¤šà¥€',0),(473068,13141,'ms','Senarai tarikh tipikal',0),(473069,13141,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨ØªÙˆØ§Ø±ÙŠØ® Ù†Ù…ÙˆØ°Ø¬ÙŠØ©',0),(473070,13141,'fr','Liste de Dates typiques',0),(473071,13141,'jp','å…¸åž‹çš„ãªæ—¥ä»˜ã®ãƒªã‚¹ãƒˆ',0),(473072,13141,'pt','Lista de datas tÃ­picas',0),(473073,13141,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ñ‚Ð¸Ð¿Ð¸Ñ‡Ð½Ñ‹Ñ… Ð´Ð°Ñ‚',0),(473074,13141,'es','Lista De Fechas TÃ­picas',0),(473075,13141,'de','Typische Daten Liste',0),(473076,13141,'en','Typical Dates List',0),(473077,13142,'is','',0),(473078,13142,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù„ÛŒØ³Øª Ù‡Ø§',0),(473079,13142,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù„ÛŒØ³Øª Ù‡Ø§',0),(473080,13142,'tr','NumaralÄ± listeleri',0),(473081,13142,'pl','Numer listy',0),(473082,13142,'bg','Ð‘Ñ€Ð¾Ð¹ ÑÐ¿Ð¸ÑÑŠÑ†Ð¸',0),(473083,13142,'ur','Ù†Ù…Ø¨Ø± Ú©ÛŒ ÙÛØ±Ø³ØªÛŒÚº',0),(473084,13142,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð»Ð¸ÑÑ‚Ðµ',0),(473085,13142,'vi','danh sÃ¡ch sá»‘',0),(473086,13142,'af','Nommer lyste',0),(473087,13142,'ro','NumÄƒrul de liste',0),(473088,13142,'et','Numbritega loendid',0),(473089,13142,'si','Å tevilo seznamov',0),(473090,13142,'ba','Daftar nomor',0),(473091,13142,'nl','Aantal lijsten',0),(473092,13142,'fi','Numeron luettelot',0),(473093,13142,'no','Nummererte lister',0),(473094,13142,'da','Antal lister',0),(473095,13142,'ko','ë²ˆí˜¸ ëª©ë¡',0),(473096,13142,'he','×ž×¡×¤×¨ ×¨×©×™×ž×•×ª',0),(473097,13142,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Î¹',0),(473098,13142,'zh','ç¼–å·åˆ—è¡¨',0),(473099,13142,'sv','Antal listor',0),(473100,13142,'it','Numero liste',0),(473101,13142,'tl','',0),(473102,13142,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚',0),(473103,13142,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‚à¤šà¥€',0),(473104,13142,'ms','Senarai nombor',0),(473105,13142,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ù‚ÙˆØ§Ø¦Ù…',0),(473106,13142,'fr','Nombre de listes',0),(473107,13142,'jp','ç•ªå·ã®ãƒªã‚¹ãƒˆ',0),(473108,13142,'pt','NÃºmero de listas',0),(473109,13142,'ru','Ð§Ð¸ÑÐ»Ð¾ ÑÐ¿Ð¸ÑÐºÐ¾Ð²',0),(473110,13142,'es','Listas de NÃºmeros',0),(473111,13142,'de','Anzahl Listen',0),(473112,13142,'en','Number Lists',0),(473113,13143,'is','',0),(473114,13143,'dr','(Ø³Ù‡Ø§Ù…)Ù…ÙˆØ¬ÙˆØ¯ Ù†Ø¨Ø§Ø´Ø¯',0),(473115,13143,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ù†ÛŒØ³Øª Ø§Ú¯Ø±Ø§Ù†Ø¨Ø§Ø± (Ø³Ù‡Ø§Ù…)Ù…ÙˆØ¬ÙˆØ¯ Ù†Ø¨Ø§Ø´Ø¯',0),(473116,13143,'tr','SipariÅŸler stok, mevcut koyun olamaz',0),(473117,13143,'pl','Nie moÅ¼na skÅ‚adaÄ‡ zamÃ³wienia, jeÅ›li nie dostÄ™pnych zapasÃ³w',0),(473118,13143,'bg','ÐÐµ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð¿Ñ€Ð°Ð²ÑÑ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð°ÐºÐ¾ Ð½ÑÐ¼Ð° Ð½Ð°Ð»Ð¸Ñ‡ÐµÐ½ ÑÑŠÑÑ‚Ð°Ð²',0),(473119,13143,'ur','Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÙˆØ¦ÛŒ Ø§Ø³Ù¹Ø§Ú© Ø§Ú¯Ø± Ø¯Ø³ØªÛŒØ§Ø¨ Ú©ÛŒ Ø¬Ú¯Û Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªÛ’',0),(473120,13143,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ð¸ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ, Ð°ÐºÐ¾ Ð½ÐµÐ¼Ð° Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ðµ',0),(473121,13143,'vi','khÃ´ng thá»ƒ Ä‘áº·t hÃ ng náº¿u trong kho khÃ´ng cÃ³ sáºµn',0),(473122,13143,'af','Bestellings kan plaas as geen voorraad beskikbaar',0),(473123,13143,'ro','Nu puteÅ£i plasa comenzi daca nu stoc disponibil',0),(473124,13143,'et','Ei saa tellimuste kui ladu pole saadaval',0),(473125,13143,'si','Ne naroÄajo, Äe ne zaloge na voljo',0),(473126,13143,'ba','Tidak dapat menempatkan pesanan jika ada stok tersedia',0),(473127,13143,'nl','Kan geen Orders plaatsen als geen voorraad beschikbaar',0),(473128,13143,'fi','Voi tehdÃ¤ tilauksia, jos ei ole varastossa',0),(473129,13143,'no','Kan ikke plassere bestillinger hvis ingen lager tilgjengelig',0),(473130,13143,'da','Kan ikke placere ordrer, hvis ingen tilgÃ¦ngelige lager',0),(473131,13143,'ko','ê²½ìš° ìž¬ê³  ì—†ìŒ ì‚¬ìš© ê°€ëŠ¥í•œ ì£¼ë¬¸ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(473132,13143,'he','××™×Ÿ ×‘××¤×©×¨×•×ª×š ×œ×ž×§× ×”×–×ž× ×•×ª ×× ××™×Ÿ ×‘×ž×œ××™ ×–×ž×™×Ÿ',0),(473133,13143,'el','Î”ÎµÎ½ Ï…Ï€Î¿Î²Î¬Î»Î»Î¿Ï…Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚, ÎµÎ¬Î½ Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î±',0),(473134,13143,'zh','å¦‚æžœæ²¡æœ‰å¯ç”¨çš„è‚¡ç¥¨ä¸èƒ½ä¸‹è®¢å•',0),(473135,13143,'sv','Kan inte placera order om inga tillgÃ¤ngliga lager',0),(473136,13143,'it','Non Ã¨ possibile effettuare ordini se No Stock disponibili',0),(473137,13143,'tl','',0),(473138,13143,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸§à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸–à¹‰à¸²à¹„à¸¡à¹ˆà¸ªà¸•à¹Šà¸­à¸',0),(473139,13143,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‹à¤ˆ à¤¶à¥‡à¤¯à¤° à¤¯à¤¦à¤¿ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤œà¤—à¤¹ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(473140,13143,'ms','Tidak boleh membuat pesanan jika tiada stok tersedia',0),(473141,13143,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ÙˆØ¶Ø¹ Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø§ Ù…Ù† Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(473142,13143,'fr','Ne peut pas passer des commandes si aucun Stock disponible',0),(473143,13143,'jp','åœ¨åº«ãŒãªã„å ´åˆã€æ³¨æ–‡ã‚’ç½®ãã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(473144,13143,'pt','NÃ£o pode colocar ordens se nenhum estoque disponÃ­vel',0),(473145,13143,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ñ€Ð°Ð·Ð¼ÐµÑ‰Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹, ÐµÑÐ»Ð¸ Ð½ÐµÑ‚ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ñ… Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(473146,13143,'es','No se puede cumplir a los pedidos si no hay stock disponible.',0),(473147,13143,'de','Kann nicht wenn keine Lager verfÃ¼gbar bestellen',0),(473148,13143,'en','Cannot Place Orders If No Stock Available',0),(473149,13144,'is','',0),(473150,13144,'dr','Ù‡Ù†Ø±',0),(473151,13144,'pr','Ù‡Ù†Ø±',0),(473152,13144,'tr','Sanat',0),(473153,13144,'pl','Sztuka',0),(473154,13144,'bg','Ð˜Ð·ÐºÑƒÑÑ‚Ð²Ð¾',0),(473155,13144,'ur','Ø¢Ø±Ù¹',0),(473156,13144,'sr','ÐÑ€Ñ‚',0),(473157,13144,'vi','Nghá»‡ thuáº­t',0),(473158,13144,'af','Kuns',0),(473159,13144,'ro','Arta',0),(473160,13144,'et','Art',0),(473161,13144,'si','Art',0),(473162,13144,'ba','Seni',0),(473163,13144,'nl','Kunst',0),(473164,13144,'fi','Art',0),(473165,13144,'no','Art',0),(473166,13144,'da','Kunst',0),(473167,13144,'ko','ì˜ˆìˆ ',0),(473168,13144,'he','××ž× ×•×ª',0),(473169,13144,'el','Î¤Î­Ï‡Î½Î·',0),(473170,13144,'zh','è‰ºæœ¯',0),(473171,13144,'sv','Konst',0),(473172,13144,'it','Arte',0),(473173,13144,'tl','',0),(473174,13144,'th','à¸¨à¸´à¸¥à¸›à¸°',0),(473175,13144,'hi','à¤•à¤²à¤¾',0),(473176,13144,'ms','Seni',0),(473177,13144,'ar','Ø§Ù„ÙÙ†',0),(473178,13144,'fr','Art',0),(473179,13144,'jp','ã‚¢ãƒ¼ãƒˆ',0),(473180,13144,'pt','Arte',0),(473181,13144,'ru','Ð˜ÑÐºÑƒÑÑÑ‚Ð²Ð¾',0),(473182,13144,'es','Arte',0),(473183,13144,'de','Kunst',0),(473184,13144,'en','Art',0),(473185,13145,'is','',0),(473186,13145,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´',0),(473187,13145,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ø³ÙØ§Ø±Ø´',0),(473188,13145,'tr','VarsayÄ±lan sipariÅŸ notu',0),(473189,13145,'pl','Uwaga DomyÅ›lna kolejnoÅ›Ä‡',0),(473190,13145,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ€ÐµÐ´ Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(473191,13145,'ur','Ø·Û’ Ø´Ø¯Û ØªØ±ØªÛŒØ¨ Ù†ÙˆÙ¹',0),(473192,13145,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(473193,13145,'vi','Máº·c Ä‘á»‹nh ghi chÃº Ä‘Æ¡n hÃ ng',0),(473194,13145,'af','Verstek orde Nota',0),(473195,13145,'ro','NotÄƒ de comandÄƒ implicit',0),(473196,13145,'et','Tellimuse vaikemÃ¤rkused',0),(473197,13145,'si','Opomba privzeti vrstni red',0),(473198,13145,'ba','Default urutan catatan',0),(473199,13145,'nl','Standaard volgorde Opmerking',0),(473200,13145,'fi','Default jÃ¤rjestys Huomaa',0),(473201,13145,'no','Standardmerknader rekkefÃ¸lge',0),(473202,13145,'da','Standard rÃ¦kkefÃ¸lge BemÃ¦rk',0),(473203,13145,'ko','ê¸°ë³¸ ìˆœì„œ ì°¸ê³ ',0),(473204,13145,'he','×”×¢×¨×” ×¡×“×¨ ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(473205,13145,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÏƒÎµÎ¹ÏÎ¬ Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(473206,13145,'zh','é»˜è®¤é¡ºåºæ³¨é‡Š',0),(473207,13145,'sv','Standard ordning Obs',0),(473208,13145,'it','Nota ordine predefinito',0),(473209,13145,'tl','',0),(473210,13145,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(473211,13145,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤•à¥à¤°à¤® à¤¨à¥‹à¤Ÿ',0),(473212,13145,'ms','Nota pesanan lalai',0),(473213,13145,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„ØªØ±ØªÙŠØ¨ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(473214,13145,'fr','Remarque d\'ordre par dÃ©faut',0),(473215,13145,'jp','æ³¨æ–‡ã®æ—¢å®šã®æ³¨è¨˜',0),(473216,13145,'pt','Nota de encomenda padrÃ£o',0),(473217,13145,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(473218,13145,'es','Nota de Orden Por Defecto',0),(473219,13145,'de','Standard-Bestellhinweis',0),(473220,13145,'en','Default Order Note',0),(473221,13146,'is','',0),(473222,13146,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(473223,13146,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(473224,13146,'tr','Elektronik bordro dosyalama Kur',0),(473225,13146,'pl','Elektroniczne listy pÅ‚ac zgÅ‚oszenia instalacji',0),(473226,13146,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð° Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¸ Ð¢Ð Ð—',0),(473227,13146,'ur','Ø§Ù„ÛŒÚ©Ù¹Ø±Ø§Ù†Ú© Ù¾Û’ Ø±ÙˆÙ„ Ø¨ØªØ§Ø¦ÛŒÚº Ø³ÛŒÙ¹ Ø§Ù¾',0),(473228,13146,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐµ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÑÐºÐ¸ Ð¿Ð»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº',0),(473229,13146,'vi','Thiáº¿t láº­p tráº£ lÆ°Æ¡ng tá»± Ä‘á»™ng',0),(473230,13146,'af','Elektroniese heeltydse liassering opstelling',0),(473231,13146,'ro','Setup de depunere electronicÄƒ salarizare',0),(473232,13146,'et','E palgal esitamise seadistamine',0),(473233,13146,'si','Elektronski plaÄilni listi vloÅ¾itve Setup',0),(473234,13146,'ba','Electronic Payroll pengajuan Setup',0),(473235,13146,'nl','Elektronische Payroll indiening Setup',0),(473236,13146,'fi','SÃ¤hkÃ¶inen palkanlaskennan arkistointi asetukset',0),(473237,13146,'no','Elektronisk lÃ¸nn innlevering oppsett',0),(473238,13146,'da','Elektroniske lÃ¸n arkivering Setup',0),(473239,13146,'ko','ì „ìž ê¸‰ì—¬ ì‹ ê³  ì„¤ì¹˜',0),(473240,13146,'he','×”×’×“×¨×ª ×ª×™×•×§ ××œ×§×˜×¨×•× ×™×ª ×ž×©×›×•×¨×•×ª',0),(473241,13146,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ® ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(473242,13146,'zh','ç”µå­å·¥èµ„å•ç”³æŠ¥è®¾ç½®',0),(473243,13146,'sv','Elektroniska lÃ¶n ansÃ¶kan Setup',0),(473244,13146,'it','Installazione deposito elettronico Payroll',0),(473245,13146,'tl','',0),(473246,13146,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸­à¸´à¹€à¸¥à¹‡à¸à¸—à¸£à¸­à¸™à¸´à¸à¸ªà¹Œà¸¢à¸·à¹ˆà¸™',0),(473247,13146,'hi','à¤‡à¤²à¥‡à¤•à¥à¤Ÿà¥à¤°à¥‰à¤¨à¤¿à¤• à¤ªà¥‡à¤°à¥‹à¤² à¤«à¤¾à¤‡à¤²à¤¿à¤‚à¤— à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(473248,13146,'ms','Persediaan pemfailan elektronik gaji',0),(473249,13146,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯ Ø¥ÙŠØ¯Ø§Ø¹ Ø§Ù„Ø±ÙˆØ§ØªØ¨ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠØ©',0),(473250,13146,'fr','DÃ©pÃ´t Ã©lectronique de base salaires',0),(473251,13146,'jp','é›»å­çµ¦ä¸Žãƒ•ã‚¡ã‚¤ãƒªãƒ³ã‚° ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(473252,13146,'pt','ConfiguraÃ§Ã£o de arquivamento eletrÃ´nico da folha de pagamento',0),(473253,13146,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¿Ð¾Ð´Ð°Ñ‡Ð¸ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ñ… Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ñ… Ð²ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚ÐµÐ¹',0),(473254,13146,'es','ConfiguraciÃ³n de Archivar la NÃ³mina ElectrÃ³nica',0),(473255,13146,'de','Elektronische Einreichung Lohnstammdaten',0),(473256,13146,'en','Electronic Payroll Filing Setup',0),(473257,13147,'is','',0),(473258,13147,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡ ',0),(473259,13147,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡ ',0),(473260,13147,'tr','Kalan Mkt.',0),(473261,13147,'pl','IloÅ›Ä‡ pozostaÅ‚ych',0),(473262,13147,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾ÑÑ‚Ð°Ð²Ð°Ñ‰Ð¸',0),(473263,13147,'ur','Ø¨Ø§Ù‚ÛŒ qty.',0),(473264,13147,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾Ð³',0),(473265,13147,'vi','SÃ´ lÆ°á»£ng cÃ²n láº¡i',0),(473266,13147,'af','Qty. oor',0),(473267,13147,'ro','Cant. rÄƒmase',0),(473268,13147,'et','ÃœlejÃ¤Ã¤nud kogus',0),(473269,13147,'si','KoliÄina preostalih',0),(473270,13147,'ba','Qty. tersisa',0),(473271,13147,'nl','Aantal resterende',0),(473272,13147,'fi','JÃ¤ljellÃ¤ oleva mÃ¤Ã¤rÃ¤',0),(473273,13147,'no','Antall gjenvÃ¦rende',0),(473274,13147,'da','Antal resterende',0),(473275,13147,'ko','ë‚¨ì€ ìˆ˜ëŸ‰',0),(473276,13147,'he','×›×ž×•×ª ×©× ×•×ª×¨×”',0),(473277,13147,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î¿Ï… Î±Ï€Î¿Î¼Î­Î½ÎµÎ¹',0),(473278,13147,'zh','å‰©ä½™æ•°é‡',0),(473279,13147,'sv','Antal Ã¥terstÃ¥ende',0),(473280,13147,'it','QtÃ  rimanenti',0),(473281,13147,'tl','',0),(473282,13147,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸„à¸‡à¹€à¸«à¸¥à¸·à¸­',0),(473283,13147,'hi','à¤¶à¥‡à¤· à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(473284,13147,'ms','Qty. baki',0),(473285,13147,'ar','Qty. Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(473286,13147,'fr','QtÃ© restante',0),(473287,13147,'jp','æ®‹ã‚Šã®æ•°é‡',0),(473288,13147,'pt','Qtd. restante',0),(473289,13147,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð¾ÑÑ‚Ð°Ð²ÑˆÐ¸Ñ…ÑÑ',0),(473290,13147,'es','Cantidad Restante',0),(473291,13147,'de','Verbleibende Menge',0),(473292,13147,'en','Qty. Remaining',0),(473293,13148,'is','',0),(473294,13148,'dr','Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÛŒ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØªØ§ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡ ',0),(473295,13148,'pr','Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÛŒ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØªØ§ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡ ',0),(473296,13148,'tr','Mark doÄŸrulanmamÄ±ÅŸ',0),(473297,13148,'pl','Mark niepotwierdzone',0),(473298,13148,'bg','ÐœÐ°Ñ€Ðº Ð½ÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¸',0),(473299,13148,'ur','Ù…Ø§Ø±Ú© ØºÛŒØ± Ù…ØµØ¯Ù‚Û',0),(473300,13148,'sr','ÐœÐ°Ñ€Ðº Ð½ÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ðµ',0),(473301,13148,'vi','Ä‘Ã¡nh dáº¥u khÃ´ng xÃ¡c nháº­n',0),(473302,13148,'af','Merk onbevestigde',0),(473303,13148,'ro','Mark neconfirmate',0),(473304,13148,'et','MÃ¤rgi kinnitamata',0),(473305,13148,'si','Mark nepotrjeno',0),(473306,13148,'ba','Mark belum dikonfirmasi',0),(473307,13148,'nl','Mark onbevestigde',0),(473308,13148,'fi','Mark vahvistamaton',0),(473309,13148,'no','Mark ubekreftet',0),(473310,13148,'da','Mark ubekrÃ¦ftet',0),(473311,13148,'ko','ë§ˆí¬ ë¯¸í™•ì¸',0),(473312,13148,'he','×ž××¨×§ ×œ× ×ž××•×©×¨×™×.',0),(473313,13148,'el','Mark Î±Î½ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰Ï„ÎµÏ‚',0),(473314,13148,'zh','æœªç»è¯å®žçš„é©¬å…‹',0),(473315,13148,'sv','Mark obekrÃ¤ftade',0),(473316,13148,'it','Mark non confermato',0),(473317,13148,'tl','',0),(473318,13148,'th','à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸«à¸¡à¸²à¸¢',0),(473319,13148,'hi','à¤®à¤¾à¤°à¥à¤• à¤…à¤ªà¥à¤·à¥à¤Ÿ',0),(473320,13148,'ms','Mark belum disahkan',0),(473321,13148,'ar','ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© ØºÙŠØ± Ù…Ø¤ÙƒØ¯Ø©',0),(473322,13148,'fr','Marque non confirmÃ©es',0),(473323,13148,'jp','æœªç¢ºèªã®ãƒžãƒ¼ã‚¯',0),(473324,13148,'pt','Mark nÃ£o confirmados',0),(473325,13148,'ru','ÐœÐ°Ñ€Ðº Ð½ÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ',0),(473326,13148,'es','Marco No Confirmado',0),(473327,13148,'de','Mark unbestÃ¤tigt',0),(473328,13148,'en','Mark Unconfirmed',0),(473329,13149,'is','',0),(473330,13149,'dr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ù†Ø¬Ø§Ù… Ú†Ú¯ÙˆÙ†Ù‡',0),(473331,13149,'pr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ù†Ø¬Ø§Ù… Ú†Ú¯ÙˆÙ†Ù‡',0),(473332,13149,'tr','Fulfillment sipariÅŸler nasÄ±l tasfiye',0),(473333,13149,'pl','Jak usunÄ…Ä‡ realizacji zamÃ³wienia',0),(473334,13149,'bg','Ð§Ð¸ÑÑ‚ÐºÐ° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÐºÐ°Ðº',0),(473335,13149,'ur','ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ú©Ø³ Ø·Ø±Ø­ Ù¾Ø§Ú©',0),(473336,13149,'sr','ÐžÑ‡Ð¸ÑÑ‚Ð¸ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ ÐºÐ°ÐºÐ¾',0),(473337,13149,'vi','cÃ¡ch Ä‘iÃªn Ä‘Æ¡n hÃ ng trá»‘ng',0),(473338,13149,'af','Vee nakoming Orders hoe permanent uit',0),(473339,13149,'ro','Epurare Ã®mplinirea comenzi cum',0),(473340,13149,'et','Kuidas puhastada plaanitud tellimused',0),(473341,13149,'si','Kako purge izpolnitev naroÄila',0),(473342,13149,'ba','Bagaimana membersihkan pemenuhan order',0),(473343,13149,'nl','Vervulling Orders Hoe Purge',0),(473344,13149,'fi','Puhallus tÃ¤yttÃ¤minen tilauksia miten',0),(473345,13149,'no','TÃ¸mme fullfÃ¸ringen bestillinger hvor',0),(473346,13149,'da','Rense opfyldelse ordrer hvordan',0),(473347,13149,'ko','ì–´ë–»ê²Œì´ í–‰ ëª…ë ¹ ì œê±°',0),(473348,13149,'he','× ×§×” ×”×’×©×ž×” ×”×•×¨××•×ª ××™×š',0),(473349,13149,'el','Î•ÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ· ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€ÏŽÏ‚',0),(473350,13149,'zh','å¦‚ä½•æ¸…é™¤å±¥è¡Œè®¢å•',0),(473351,13149,'sv','Rensa uppfyllelse order hur',0),(473352,13149,'it','Purga come evasione ordini',0),(473353,13149,'tl','',0),(473354,13149,'th','à¸¥à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸­à¸¢à¹ˆà¸²à¸‡à¹„à¸£',0),(473355,13149,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤•à¥ˆà¤¸à¥‡ à¤®à¤¿à¤Ÿà¤¾à¤à¤',0),(473356,13149,'ms','Singkir memenuhi pesanan bagaimana',0),(473357,13149,'ar','Ø¥Ø²Ø§Ù„Ø© Ø£ÙˆØ§Ù…Ø± Ø§Ù„ÙˆÙØ§Ø¡ ÙƒÙŠÙ',0),(473358,13149,'fr','Purge des ordres de comment',0),(473359,13149,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ãƒ» ã‚ªãƒ¼ãƒ€ãƒ¼ã‚’ã©ã®ã‚ˆã†ã«ãƒ‘ãƒ¼ã‚¸ã—ã¾ã™ã€‚',0),(473360,13149,'pt','Purgar o ordens de cumprimento como',0),(473361,13149,'ru','ÐšÐ°Ðº Ð¾Ñ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(473362,13149,'es','Purgar Ordenes de Cumplimiento Como',0),(473363,13149,'de','Wie LÃ¶schen von Fulfillment-Bestellungen',0),(473364,13149,'en','Purge Fulfillment Orders How',0),(473365,13150,'is','',0),(473366,13150,'dr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª ØªÚ©Ù…ÛŒÙ„ Ø´Ø¯Ù‡ Ø§Ú¯Ø± Ø¨Ø§Ø² Ø§Ø³Øª Ø§ÛŒÙ† Ú†Ù†Ø¯ Ø±ÙˆØ² ÛŒØ§ Ø¨ÛŒØ´ØªØ± ',0),(473367,13150,'pr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª ØªÚ©Ù…ÛŒÙ„ Ø´Ø¯Ù‡ Ø§Ú¯Ø± Ø¨Ø§Ø² Ø§Ø³Øª Ø§ÛŒÙ† Ú†Ù†Ø¯ Ø±ÙˆØ² ÛŒØ§ Ø¨ÛŒØ´ØªØ± ',0),(473368,13150,'tr','EÄŸer Fulfillment sipariÅŸler tasfiye bu birÃ§ok gÃ¼n veya daha fazla aÃ§Ä±k',0),(473369,13150,'pl','PrzeczyÅ›Ä‡ realizacji zamÃ³wienia, jeÅ›li otworzyÄ‡ wiele dni lub wiÄ™cej',0),(473370,13150,'bg','ÐŸÑ€Ð¾Ð´ÑƒÑ…Ð²Ð°Ð½Ðµ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð°ÐºÐ¾ Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ñ‚Ð¾Ð²Ð° Ð¼Ð½Ð¾Ð³Ð¾ Ð´Ð½Ð¸ Ð¸Ð»Ð¸ Ð¿Ð¾Ð²ÐµÑ‡Ðµ',0),(473371,13150,'ur','Ø§Ú¯Ø± ØªÚ©Ù…ÛŒÙ„ Ø­Ú©Ù… Ù¾Ø§Ú© ÛŒÛ Ú©Ø¦ÛŒ Ø¯Ù† ÛŒØ§ Ø§Ø³ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ú©Ú¾ÙˆÙ„',0),(473372,13150,'sr','ÐžÑ‡Ð¸ÑÑ‚Ð¸ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ ÐÐºÐ¾ Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸Ð¼ Ð¾Ð²Ð¾ Ð¼Ð½Ð¾Ð³Ð¾ Ð´Ð°Ð½Ð°, Ð¸Ð»Ð¸ Ð²Ð¸ÑˆÐµ',0),(473373,13150,'vi','Ä‘iá»n Ä‘Æ¡n hÃ ng trá»‘ng náº¿u má»Ÿ trong nhiá»u ngÃ y hoáº·c hÆ¡n',0),(473374,13150,'af','Vee permanent uit vervulling bestellings as dit baie dae of meer oop',0),(473375,13150,'ro','Epurare Ã®ndeplinirea comenzilor dacÄƒ deschide aceasta multe zile sau mai mult',0),(473376,13150,'et','Juhtiva plaanitud tellimused, kui avada see mitu pÃ¤eva vÃµi rohkem',0),(473377,13150,'si','Purge izpolnitve naroÄila, Äe odprete to veliko dni ali veÄ',0),(473378,13150,'ba','Membersihkan pemenuhan pesanan jika buka ini berhari-hari atau lebih',0),(473379,13150,'nl','Purge vervulling Orders als Open dit vele dagen of meer',0),(473380,13150,'fi','Puhallus tÃ¤yttÃ¤minen tilauksia, jos Avaa tÃ¤mÃ¤ monta pÃ¤ivÃ¤Ã¤ tai enemmÃ¤n',0),(473381,13150,'no','PURGE fullfÃ¸ringen bestillinger om Ã¥pen denne mange dager eller mer',0),(473382,13150,'da','Rense opfyldelse ordrer, hvis Ã¥bne dette mange dage eller derover',0),(473383,13150,'ko','ê²½ìš° í–‰ ìˆœì„œë¥¼ ì œê±°ì´ ë©°ì¹  ì´ìƒ ì—´',0),(473384,13150,'he','× ×§×” ×ž×™×ž×•×© ×”×–×ž× ×•×ª ×× ×œ×¤×ª×•×— ××ª ×–×” ×™×ž×™× ×¨×‘×™× ××• ×™×•×ª×¨',0),(473385,13150,'el','Î•ÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ· ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½, ÎµÎ¬Î½ Î±Î½Î¿Î¯Î¾ÎµÏ„Îµ Î±Ï…Ï„ÏŒ Ï€Î¿Î»Î»Î­Ï‚ Î·Î¼Î­ÏÎµÏ‚ Î® Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ¿',0),(473386,13150,'zh','æ¸…é™¤å®Œæˆè®¢å•ï¼Œå¦‚æžœæ‰“å¼€è¿™å‡ å¤©æˆ–æ›´å¤š',0),(473387,13150,'sv','Rensa uppfyllelse order om Ã¶ppna den hÃ¤r mÃ¥nga dagar eller mer',0),(473388,13150,'it','Evasione ordini di spurgo se aprire questo molti giorni o piÃ¹',0),(473389,13150,'tl','',0),(473390,13150,'th','à¸¥à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸–à¹‰à¸²à¹€à¸›à¸´à¸”à¸™à¸µà¹‰à¸«à¸¥à¸²à¸¢à¸§à¸±à¸™à¸«à¸£à¸·à¸­à¸¡à¸²à¸à¸à¸§à¹ˆà¸²',0),(473391,13150,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°à¥à¤œ à¤…à¤—à¤° à¤¯à¤¹ à¤•à¤ˆ à¤¦à¤¿à¤¨à¥‹à¤‚ à¤¯à¤¾ à¤‰à¤¸à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤–à¥à¤²à¤¾',0),(473392,13150,'ms','Singkir memenuhi pesanan jika Buka ini hari banyak atau lebih',0),(473393,13150,'ar','Ø¥Ø²Ø§Ù„Ø© Ø£ÙˆØ§Ù…Ø± Ø§Ù„ÙˆÙØ§Ø¡ Ø¥Ø°Ø§ ÙØªØ­ Ù‡Ø°Ø§ Ø¹Ø¯Ø© Ø£ÙŠØ§Ù… Ø£Ùˆ Ø£ÙƒØ«Ø±',0),(473394,13150,'fr','Des ordres de purge si ouvrir ce nombre de jours ou plus',0),(473395,13150,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ãƒ» ã‚ªãƒ¼ãƒ€ãƒ¼ã‚’ãƒ‘ãƒ¼ã‚¸å¤šãã®æ—¥ä»¥ä¸Šã“ã‚Œã‚’é–‹ã',0),(473396,13150,'pt','Purgar o ordens de cumprimento, se abrir esta muitos dias ou mais',0),(473397,13150,'ru','ÐžÑ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð², ÐµÑÐ»Ð¸ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑ‚Ð¾ Ð¼Ð½Ð¾Ð³Ð¾ Ð´Ð½ÐµÐ¹ Ð¸Ð»Ð¸ Ð±Ð¾Ð»ÑŒÑˆÐµ',0),(473398,13150,'es','Purgar Ordenes de Cumplimiento si Abierto Estos Tantos DÃ­as o MÃ¡s',0),(473399,13150,'de','Fulfillment-Bestellungen zu lÃ¶schen, wenn dies viele Tage oder mehr zu Ã¶ffnen',0),(473400,13150,'en','Purge Fulfillment Orders If Open This Many Days Or More',0),(473401,13151,'is','',0),(473402,13151,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯Ø§ÛŒÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø±Ø§ Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ú©Ù†ÛŒØ¯ØŸ',0),(473403,13151,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯Ø§ÛŒÙ† Ø³ÙØ§Ø±Ø´Ø§Øª Ø±Ø§ Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ú©Ù†ÛŒØ¯ØŸ',0),(473404,13151,'tr','Bu sipariÅŸleri silmek istediÄŸinizden emin misiniz?',0),(473405,13151,'pl','Czy na pewno chcesz usunÄ…Ä‡ te zamÃ³wienia?',0),(473406,13151,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ñ‡Ð¸ÑÑ‚Ð¸ Ñ‚ÐµÐ·Ð¸ Ð·Ð°Ð¿Ð¾Ð²ÐµÐ´Ð¸?',0),(473407,13151,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ÛŒÛ Ø­Ú©Ù… Ù¾Ø§Ú© Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(473408,13151,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¾Ñ‡Ð¸ÑÑ‚Ð¸ Ð¾Ð²Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ?',0),(473409,13151,'vi','XÃ³a cÃ¡c Ä‘Æ¡n hÃ ng nÃ y?',0),(473410,13151,'af','Is jy seker jy wil vee permanent uit hierdie bestellings?',0),(473411,13151,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ purge aceste comenzi?',0),(473412,13151,'et','Kas kindlasti puhastada neid tellimusi?',0),(473413,13151,'si','Ali ste prepriÄani, da Å¾elite splakovanja te naloge?',0),(473414,13151,'ba','Apakah Anda yakin Anda ingin membersihkan pesanan ini?',0),(473415,13151,'nl','Weet u zeker dat u wilt verwijderen van deze orders?',0),(473416,13151,'fi','Oletko varma, ettÃ¤ haluat poistaa nÃ¤mÃ¤ tilaukset?',0),(473417,13151,'no','Er du sikker pÃ¥ at du vil fjerne disse ordrene?',0),(473418,13151,'da','Er du sikker pÃ¥ du vil rense disse ordrer?',0),(473419,13151,'ko','ë‹¹ì‹ ì€ ì´ëŸ¬í•œ ëª…ë ¹ì„ ì œê±° í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(473420,13151,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ×œ×¦×ž×™×ª×•×ª ××ª ×”×”×–×ž× ×•×ª ×”××œ×”?',0),(473421,13151,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎµÎ¾Î±Î³Î½Î¯ÏƒÎµÎ¹ Î±Ï…Ï„Î­Ï‚ Ï„Î¹Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚;',0),(473422,13151,'zh','ä½ ç¡®å®šä½ æƒ³è¦æ¸…é™¤è¿™äº›è®¢å•ï¼Ÿ',0),(473423,13151,'sv','Ã„r du sÃ¤ker pÃ¥ att du vill rensa dessa order?',0),(473424,13151,'it','Sei sicuro di che voler eliminare questi ordini?',0),(473425,13151,'tl','',0),(473426,13151,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸¥à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸«à¸¥à¹ˆà¸²à¸™à¸µà¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(473427,13151,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¨ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‹ à¤ªà¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(473428,13151,'ms','Adakah anda pasti anda mahu Singkir arahan ini?',0),(473429,13151,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø­Ø°Ù Ù‡Ø°Ù‡ Ø§Ù„Ø£ÙˆØ§Ù…Ø±ØŸ',0),(473430,13151,'fr','ÃŠtes-vous sÃ»r de que vouloir vider ces ordres ?',0),(473431,13151,'jp','ã“ã‚Œã‚‰ã®æ³¨æ–‡ã‚’å‰Šé™¤ã—ã¦ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(473432,13151,'pt','Tens a certeza de que deseja eliminar essas ordens?',0),(473433,13151,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¾Ñ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ ÑÑ‚Ð¸ Ð·Ð°ÐºÐ°Ð·Ñ‹?',0),(473434,13151,'es','Â¿Esta seguro que quiere purgar estes pedidos?',0),(473435,13151,'de','Bist du sicher, dass Sie diese AuftrÃ¤ge lÃ¶schen mÃ¶chten?',0),(473436,13151,'en','Are you sure you want to purge these orders?',0),(473437,13152,'is','',0),(473438,13152,'dr','Ø±ÙˆØ²Ù‡Ø§ÛŒ Ø¨Ø§Ø² Ø¬Ù‡Øª Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ ',0),(473439,13152,'pr','Ø±ÙˆØ²Ù‡Ø§ÛŒ Ø¨Ø§Ø² Ø¬Ù‡Øª Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ ',0),(473440,13152,'tr','GÃ¼n tasfiye iÃ§in aÃ§Ä±lacak',0),(473441,13152,'pl','Dni otwarte dla Purge',0),(473442,13152,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½ Ð² Ð´Ð½Ð¸ Ð´Ð° Ñ‡Ð¸ÑÑ‚ÐºÐ°',0),(473443,13152,'ur','Ø¯Ù† Ú©ÛŒ ØªØ·ÛÛŒØ± Ú©Ø±ÛŒÚº Ú©Ú¾ÙˆÙ„ÛŒÚº',0),(473444,13152,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾ (Ð´Ð°Ð½Ð¸) Ð·Ð° Ñ‡Ð¸ÑˆÑ›ÐµÑšÐµ',0),(473445,13152,'vi','ngÃ y má»Ÿ Ä‘á»ƒ xÃ³a',0),(473446,13152,'af','Dae oop vir vee',0),(473447,13152,'ro','Zile deschise pentru golire',0),(473448,13152,'et','PÃ¤eva avatud Purge',0),(473449,13152,'si','Dni odprt za splakovanje',0),(473450,13152,'ba','Hari terbuka untuk pembersihan',0),(473451,13152,'nl','Dagen Open voor Purge',0),(473452,13152,'fi','Tuhoa avoimet pÃ¤ivÃ¤t',0),(473453,13152,'no','Dager Ã¥pne Purge',0),(473454,13152,'da','Dage Ã…bn at Purge',0),(473455,13152,'ko','ì¼ ì—´ ì œê±°',0),(473456,13152,'he','×™×ž×™× ×¤×ª×•×—×™× ×œ×˜×™×”×•×¨',0),(473457,13152,'el','Î—Î¼Î­ÏÎµÏ‚ Î´Î¯Î½Î¿Ï…Î½ ÏƒÎµ ÎµÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ·',0),(473458,13152,'zh','å¤©å¼€åˆ°æ¸…é™¤',0),(473459,13152,'sv','Dagar Ã¶ppet fÃ¶r laxermedel',0),(473460,13152,'it','Giorni aperto a eliminazione dei fogli inceppati',0),(473461,13152,'tl','',0),(473462,13152,'th','à¸§à¸±à¸™à¹€à¸›à¸´à¸”à¸à¸²à¸£à¸¥à¹‰à¸²à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(473463,13152,'hi','à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤–à¥‹à¤²à¥‡à¤‚',0),(473464,13152,'ms','Hari terbuka kepada Singkir',0),(473465,13152,'ar','Ø£ÙŠØ§Ù… Ù…ÙØªÙˆØ­Ø© Ù„ØªØ·Ù‡ÙŠØ±',0),(473466,13152,'fr','VÃªlage Ã  Purge',0),(473467,13152,'jp','ãƒ‘ãƒ¼ã‚¸ã™ã‚‹æ—¥ã‚’é–‹ã',0),(473468,13152,'pt','Dias aberto ao expurgo',0),(473469,13152,'ru','Ð”Ð½Ð¸ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´ÑƒÐ²ÐºÐ¸',0),(473470,13152,'es','DÃ­as Abiertos Para Purgar',0),(473471,13152,'de','Tage der offenen entfernen',0),(473472,13152,'en','Days Open To Purge',0),(473473,13153,'is','',0),(473474,13153,'dr','Ø¯Ø±ÛŒØ§ÙØª Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª',0),(473475,13153,'pr','Ø¯Ø±ÛŒØ§ÙØª Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´Ø§Øª',0),(473476,13153,'tr','SipariÅŸleri listesini al',0),(473477,13153,'pl','UzyskaÄ‡ listÄ™ zleceÅ„',0),(473478,13153,'bg','Ð’Ð·ÐµÐ¼Ð¸ ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(473479,13153,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ø­Ø§ØµÙ„',0),(473480,13153,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð¸ Ð»Ð¸ÑÑ‚Ñƒ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(473481,13153,'vi','láº­p danh sÃ¡ch Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(473482,13153,'af','Lys van bestellings kry',0),(473483,13153,'ro','ObÅ£ineÅ£i lista de comenzi',0),(473484,13153,'et','Siin esitatud tellimuste loend',0),(473485,13153,'si','Dobili seznam nalogov',0),(473486,13153,'ba','Dapatkan daftar perintah',0),(473487,13153,'nl','Lijst van Orders krijgen',0),(473488,13153,'fi','Hanki luettelo tilaukset',0),(473489,13153,'no','Oversikt over ordrer',0),(473490,13153,'da','FÃ¥ listen af ordrer',0),(473491,13153,'ko','ì£¼ë¬¸ ëª©ë¡',0),(473492,13153,'he','×œ×§×‘×œ ×¨×©×™×ž×ª ×”×–×ž× ×•×ª',0),(473493,13153,'el','Î Î¬ÏÎµÏ„Îµ Î»Î¯ÏƒÏ„Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(473494,13153,'zh','å¾—åˆ°è®¢å•çš„åˆ—è¡¨',0),(473495,13153,'sv','Lista Ã¶ver order',0),(473496,13153,'it','Ottenere l\'elenco degli ordini',0),(473497,13153,'tl','',0),(473498,13153,'th','à¹€à¸£à¸µà¸¢à¸à¸”à¸¹à¸£à¸²à¸¢à¸à¸²à¸£à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(473499,13153,'hi','à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥€ à¤¸à¥‚à¤šà¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¥‡à¤‚',0),(473500,13153,'ms','Mendapatkan senarai pesanan',0),(473501,13153,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø§Ù„Ø£ÙˆØ§Ù…Ø±',0),(473502,13153,'fr','Obtenir la liste des commandes',0),(473503,13153,'jp','æ³¨æ–‡ã®ä¸€è¦§ã‚’å–å¾—ã—ã¾ã™ã€‚',0),(473504,13153,'pt','Obter a lista de pedidos',0),(473505,13153,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(473506,13153,'es','Conseguir Lista de Ordenes',0),(473507,13153,'de','Liste der Bestellungen abrufen',0),(473508,13153,'en','Get List Of Orders',0),(473509,13154,'is','',0),(473510,13154,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø´Ø¯ ',0),(473511,13154,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø´Ø¯ ',0),(473512,13154,'tr','SipariÅŸ baÅŸarÄ±yla temizlendi',0),(473513,13154,'pl','ZamÃ³wienia usuniÄ™te pomyÅ›lnie',0),(473514,13154,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð¿Ñ€Ð¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(473515,13154,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©ÛŒ ØµÙØ§Ø¦ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(473516,13154,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð¾Ñ‡Ð¸ÑˆÑ›ÐµÐ½Ð¾ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(473517,13154,'vi','ÄÃ£ bá» Ä‘Æ¡n Ä‘áº·t hÃ ng thÃ nh cÃ´ng',0),(473518,13154,'af','Bestellings Purged suksesvol',0),(473519,13154,'ro','Comenzi curÄƒÅ£it cu succes',0),(473520,13154,'et','Tellimused edukalt tuulutada',0),(473521,13154,'si','NaroÄila uspeÅ¡no oÄistimo',0),(473522,13154,'ba','Pesanan dibersihkan berhasil',0),(473523,13154,'nl','Bestellingen met succes verwijderd',0),(473524,13154,'fi','Tilaukset poistettu onnistuneesti',0),(473525,13154,'no','Bestillinger renset vellykket',0),(473526,13154,'da','Ordrer blev slettet med succes',0),(473527,13154,'ko','ì„±ê³µì ìœ¼ë¡œ ì œê±° í•˜ëŠ” ì£¼ë¬¸',0),(473528,13154,'he','×”×–×ž× ×•×ª ×œ×¦×ž×™×ª×•×ª ×‘×”×¦×œ×—×”',0),(473529,13154,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎºÎºÎ±Î¸Î±ÏÎ¹ÏƒÏ„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(473530,13154,'zh','è®¢å•æˆåŠŸæ¸…é™¤',0),(473531,13154,'sv','Order renade framgÃ¥ngsrikt',0),(473532,13154,'it','Ordini cancellati con successo',0),(473533,13154,'tl','',0),(473534,13154,'th','à¸ªà¸±à¹ˆà¸‡à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(473535,13154,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• Purged',0),(473536,13154,'ms','Perintah-perintah yang disingkirkan berjaya',0),(473537,13154,'ar','Ø£ÙˆØ§Ù…Ø± Ø¥Ø²Ø§Ù„Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(473538,13154,'fr','Commandes purgÃ©s avec succÃ¨s',0),(473539,13154,'jp','æ³¨æ–‡ãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸã€‚',0),(473540,13154,'pt','Ordens purgadas com sucesso',0),(473541,13154,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ñ‡Ð¸Ñ‰ÐµÐ½Ñ‹',0),(473542,13154,'es','Ordenes Purgados Exitosamente',0),(473543,13154,'de','Bestellungen erfolgreich gelÃ¶scht',0),(473544,13154,'en','Orders Purged Successfully',0),(473545,13155,'is','',0),(473546,13155,'dr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ',0),(473547,13155,'pr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ',0),(473548,13155,'tr','Temizle',0),(473549,13155,'pl','Czystka',0),(473550,13155,'bg','Ð§Ð¸ÑÑ‚ÐºÐ°',0),(473551,13155,'ur','ØµØ§Ù Ú©Ø±ÛŒÚº',0),(473552,13155,'sr','ÐžÑ‡Ð¸ÑÑ‚Ð¸',0),(473553,13155,'vi','trá»‘ng',0),(473554,13155,'af','Vee',0),(473555,13155,'ro','Epurare',0),(473556,13155,'et','Likvideeri',0),(473557,13155,'si','Purge',0),(473558,13155,'ba','Membersihkan',0),(473559,13155,'nl','Purge',0),(473560,13155,'fi','Puhdistus',0),(473561,13155,'no','TÃ¸mme',0),(473562,13155,'da','Udrensning',0),(473563,13155,'ko','ì§€ìš°ê¸°',0),(473564,13155,'he','×ž×—×§ ×œ×¦×ž×™×ª×•×ª',0),(473565,13155,'el','Î•ÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ·',0),(473566,13155,'zh','æ¸…é™¤',0),(473567,13155,'sv','Laxermedel',0),(473568,13155,'it','Eliminazione dei fogli inceppati',0),(473569,13155,'tl','',0),(473570,13155,'th','à¸à¸²à¸£à¸¥à¹‰à¸²à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(473571,13155,'hi','à¤ªà¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(473572,13155,'ms','Singkir',0),(473573,13155,'ar','ØªØ·Ù‡ÙŠØ±',0),(473574,13155,'fr','Purge',0),(473575,13155,'jp','ãƒ‘ãƒ¼ã‚¸',0),(473576,13155,'pt','Expurgo',0),(473577,13155,'ru','ÐžÑ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ',0),(473578,13155,'es','Purgar',0),(473579,13155,'de','SÃ¤uberung',0),(473580,13155,'en','Purge',0),(473581,13156,'is','',0),(473582,13156,'dr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ú†Ú¯ÙˆÙ†Ù‡',0),(473583,13156,'pr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ú†Ú¯ÙˆÙ†Ù‡',0),(473584,13156,'tr','Tasfiye nasÄ±l',0),(473585,13156,'pl','PrzeczyÅ›Ä‡ jak',0),(473586,13156,'bg','Ð§Ð¸ÑÑ‚ÐºÐ° ÐºÐ°Ðº',0),(473587,13156,'ur','ØµØ§Ù Ú©Ø±ÛŒÚº Ú©Ø³ Ø·Ø±Ø­',0),(473588,13156,'sr','ÐžÑ‡Ð¸ÑÑ‚Ð¸ ÐºÐ°ÐºÐ¾',0),(473589,13156,'vi','lÃ m trá»‘ng nhÆ° tháº¿ nÃ o',0),(473590,13156,'af','Vee permanent uit hoe',0),(473591,13156,'ro','Epurare cum',0),(473592,13156,'et','Likvideeri kuidas',0),(473593,13156,'si','Purge kako',0),(473594,13156,'ba','Membersihkan bagaimana',0),(473595,13156,'nl','Purge hoe',0),(473596,13156,'fi','Puhdistaa miten',0),(473597,13156,'no','TÃ¸mme hvordan',0),(473598,13156,'da','Rense hvordan',0),(473599,13156,'ko','ì œê±° ë°©ë²•',0),(473600,13156,'he','×ž×—×§ ×œ×¦×ž×™×ª×•×ª?',0),(473601,13156,'el','Î•ÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ· Ï€ÏŽÏ‚',0),(473602,13156,'zh','æ¸…é™¤å¦‚ä½•',0),(473603,13156,'sv','Rensa hur',0),(473604,13156,'it','Purga come',0),(473605,13156,'tl','',0),(473606,13156,'th','à¸à¸³à¸ˆà¸±à¸”à¸­à¸¢à¹ˆà¸²à¸‡à¹„à¸£',0),(473607,13156,'hi','à¤ªà¤°à¥à¤œ à¤•à¥ˆà¤¸à¥‡',0),(473608,13156,'ms','Singkir bagaimana',0),(473609,13156,'ar','ØªØ·Ù‡ÙŠØ± ÙƒÙŠÙ',0),(473610,13156,'fr','Purge comment',0),(473611,13156,'jp','ãƒ‘ãƒ¼ã‚¸æ–¹æ³•',0),(473612,13156,'pt','Expurgo como',0),(473613,13156,'ru','ÐžÑ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ ÐºÐ°Ðº',0),(473614,13156,'es','Purgar Como',0),(473615,13156,'de','LÃ¶schen wie',0),(473616,13156,'en','Purge How',0),(473617,13157,'is','',0),(473618,13157,'dr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø¨Ø§Ø² Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ù†Ø¬Ø§Ù…',0),(473619,13157,'pr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø¨Ø§Ø² Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ù†Ø¬Ø§Ù…',0),(473620,13157,'tr','AÃ§Ä±k Fulfillment sipariÅŸler temizle',0),(473621,13157,'pl','PrzeczyÅ›Ä‡ otwarte realizacji zamÃ³wienia',0),(473622,13157,'bg','ÐŸÑ€Ð¾Ð´ÑƒÑ…Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(473623,13157,'ur','Ú©Ú¾Ù„ÛŒ ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø­Ú©Ù… Ù¾Ø§Ú©',0),(473624,13157,'sr','ÐžÑ‡Ð¸ÑÑ‚Ð¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(473625,13157,'vi','bá» nhá»¯ng Ä‘Æ¡n hÃ ng Ä‘Ã£ Ä‘áº§y',0),(473626,13157,'af','Vee permanent oop nakoming Orders uit',0),(473627,13157,'ro','Epurare deschis Ã®ndeplinirea comenzilor',0),(473628,13157,'et','Likvideeri avatud plaanitud tellimused',0),(473629,13157,'si','Purge odprta izpolnitev naroÄila',0),(473630,13157,'ba','Membersihkan terbuka pemenuhan order',0),(473631,13157,'nl','Purge Open vervulling Orders',0),(473632,13157,'fi','Poista avoinna tÃ¤yttymyksen tilaukset',0),(473633,13157,'no','TÃ¸mme Ã¥pne fullfÃ¸ringen bestillinger',0),(473634,13157,'da','Rense Ã¥ben opfyldelse ordrer',0),(473635,13157,'ko','ì˜¤í”ˆì´ í–‰ ëª…ë ¹ ì œê±°',0),(473636,13157,'he','× ×§×” ×”×’×©×ž×” ×¤×ª×•×— ×”×–×ž× ×•×ª',0),(473637,13157,'el','Î•ÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ· Î±Î½Î¿Î¹ÎºÏ„Î® ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(473638,13157,'zh','æ¸…é™¤æ‰“å¼€å±¥è¡Œè®¢å•',0),(473639,13157,'sv','Rensa Ã¶ppna uppfyllelse order',0),(473640,13157,'it','Spurgo aperto compimento ordini',0),(473641,13157,'tl','',0),(473642,13157,'th','à¸¥à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹€à¸›à¸´à¸”',0),(473643,13157,'hi','à¤–à¥à¤²à¤¾ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°à¥à¤œ',0),(473644,13157,'ms','Singkir terbuka memenuhi perintah',0),(473645,13157,'ar','Ø¥Ø²Ø§Ù„Ø© Ø£ÙˆØ§Ù…Ø± Ù…ÙØªÙˆØ­Ø© ÙˆÙØ§Ø¡',0),(473646,13157,'fr','Purge ouverte des ordres',0),(473647,13157,'jp','ã‚ªãƒ¼ãƒ—ãƒ³ ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ãƒ» ã‚ªãƒ¼ãƒ€ãƒ¼ã‚’ãƒ‘ãƒ¼ã‚¸ã—ã¾ã™ã€‚',0),(473648,13157,'pt','Expurgo aberto de cumprimento ordens',0),(473649,13157,'ru','ÐžÑ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ð¾Ð³Ð¾ Ð¸ÑÐ¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(473650,13157,'es','Purgar Ordenes de Cumplimiento Abiertos',0),(473651,13157,'de','Offene Fulfillment-Bestellungen lÃ¶schen',0),(473652,13157,'en','Purge Open Fulfillment Orders',0),(473653,13158,'is','',0),(473654,13158,'dr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(473655,13158,'pr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(473656,13158,'tr','Emirleri Temizleme',0),(473657,13158,'pl','PrzeczyÅ›Ä‡ zamÃ³wienia',0),(473658,13158,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(473659,13158,'ur','Ø­Ú©Ù… Ù¾Ø§Ú©',0),(473660,13158,'sr','ÐžÑ‡Ð¸ÑÑ‚Ð¸ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(473661,13158,'vi','bá» Ä‘Æ¡n hÃ ng',0),(473662,13158,'af','Vee bestellings permanent uit',0),(473663,13158,'ro','Epurare comenzi',0),(473664,13158,'et','Kustuta tellimused',0),(473665,13158,'si','Purge naroÄila',0),(473666,13158,'ba','Purge perintah',0),(473667,13158,'nl','Purge Orders',0),(473668,13158,'fi','Poista tilaukset',0),(473669,13158,'no','Slett ordrer',0),(473670,13158,'da','Rense ordrer',0),(473671,13158,'ko','ì£¼ë¬¸ ì‚­ì œ',0),(473672,13158,'he','× ×§×” ×”×–×ž× ×•×ª',0),(473673,13158,'el','Î•ÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(473674,13158,'zh','æ¸…é™¤å‘½ä»¤',0),(473675,13158,'sv','Rensa order',0),(473676,13158,'it','Eliminare gli ordini',0),(473677,13158,'tl','',0),(473678,13158,'th','à¸¥à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(473679,13158,'hi','à¤ªà¤°à¥à¤œ à¤†à¤¦à¥‡à¤¶',0),(473680,13158,'ms','Singkir pesanan',0),(473681,13158,'ar','Ø¥Ø²Ø§Ù„Ø© Ø£ÙˆØ§Ù…Ø±',0),(473682,13158,'fr','Purger les commandes',0),(473683,13158,'jp','æ³¨æ–‡ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(473684,13158,'pt','Purgar as ordens',0),(473685,13158,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(473686,13158,'es','Purgar Ordenes',0),(473687,13158,'de','LÃ¶schen von Bestellungen',0),(473688,13158,'en','Purge Orders',0),(473689,13159,'is','',0),(473690,13159,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯Ù‡',0),(473691,13159,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯Ù‡',0),(473692,13159,'tr','Sevkiyat bloke',0),(473693,13159,'pl','WysyÅ‚ka zablokowany',0),(473694,13159,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½',0),(473695,13159,'ur','Ø¨Ù„Ø§Ú© Ø´Ø¯Û Ø´Ù¾Ù†Ú¯',0),(473696,13159,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ñ˜Ðµ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½',0),(473697,13159,'vi','Váº­n chuyá»ƒn bá»‹ cháº·n',0),(473698,13159,'af','Gestuur geblokkeer',0),(473699,13159,'ro','Transport blocate',0),(473700,13159,'et','Laevanduse blokeeritud',0),(473701,13159,'si','Ladijski promet blokiran',0),(473702,13159,'ba','Pengiriman yang diblokir',0),(473703,13159,'nl','Verzending geblokkeerd',0),(473704,13159,'fi','Toimitus estetty',0),(473705,13159,'no','Frakt blokkert',0),(473706,13159,'da','Shipping blokeret',0),(473707,13159,'ko','ë°œì†¡ ì°¨ë‹¨',0),(473708,13159,'he','×ž×©×œ×•×— ×—×¡×•×',0),(473709,13159,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î± Î¼Ï€Î»Î¿ÎºÎ±ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(473710,13159,'zh','èˆªè¿å—é˜»',0),(473711,13159,'sv','Frakt blockerade',0),(473712,13159,'it','Spedizione bloccata',0),(473713,13159,'tl','',0),(473714,13159,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸—à¸µà¹ˆà¸–à¸¹à¸à¸šà¸¥à¹‡à¸­à¸„',0),(473715,13159,'hi','à¤¬à¥à¤²à¥‰à¤• à¤•à¤¿à¤ à¤—à¤ à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(473716,13159,'ms','Penghantaran yang disekat',0),(473717,13159,'ar','Ø­Ø¸Ø± Ø§Ù„Ø´Ø­Ù†',0),(473718,13159,'fr','ExpÃ©dition bloquÃ©e',0),(473719,13159,'jp','å‡ºè·ãƒ–ãƒ­ãƒƒã‚¯',0),(473720,13159,'pt','NavegaÃ§Ã£o bloqueada',0),(473721,13159,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð°Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ð½',0),(473722,13159,'es','EnvÃ­o Bloqueado',0),(473723,13159,'de','Versand blockiert',0),(473724,13159,'en','Shipping Blocked',0),(473725,13160,'is','',0),(473726,13160,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‡Ù†Ø±ÛŒ',0),(473727,13160,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‡Ù†Ø±ÛŒ',0),(473728,13160,'tr','Sanat #',0),(473729,13160,'pl','Sztuka #',0),(473730,13160,'bg','ÐÑ€Ñ‚ #',0),(473731,13160,'ur','Ø¢Ø±Ù¹ #',0),(473732,13160,'sr','ÐÑ€Ñ‚ #',0),(473733,13160,'vi','Thiáº¿t káº¿ #',0),(473734,13160,'af','Kuns #',0),(473735,13160,'ro','Arta #',0),(473736,13160,'et','Art #',0),(473737,13160,'si','Art #',0),(473738,13160,'ba','Seni #',0),(473739,13160,'nl','Art #',0),(473740,13160,'fi','Art #',0),(473741,13160,'no','Art #',0),(473742,13160,'da','Kunst #',0),(473743,13160,'ko','ì•„íŠ¸ #',0),(473744,13160,'he','××ž× ×•×ª #',0),(473745,13160,'el','Î¤Î­Ï‡Î½Î· #',0),(473746,13160,'zh','è‰ºæœ¯ #',0),(473747,13160,'sv','Art #',0),(473748,13160,'it','Art #',0),(473749,13160,'tl','',0),(473750,13160,'th','à¸¨à¸´à¸¥à¸›à¸°#',0),(473751,13160,'hi','à¤•à¤²à¤¾ #',0),(473752,13160,'ms','Seni #',0),(473753,13160,'ar','ÙÙ† #',0),(473754,13160,'fr','Art #',0),(473755,13160,'jp','ã‚¢ãƒ¼ãƒˆ #',0),(473756,13160,'pt','Arte #',0),(473757,13160,'ru','ÐÑ€Ñ‚ #',0),(473758,13160,'es','Art #',0),(473759,13160,'de','Kunst #',0),(473760,13160,'en','Art #',0),(473761,13161,'is','',0),(473762,13161,'dr','Ø¢ÛŒØ§ Ø§Ø²Ø¯Ø­Ø§Ù… Ø³ÙØ§Ø±Ø´',0),(473763,13161,'pr','Ø¢ÛŒØ§ Ø§Ø²Ø¯Ø­Ø§Ù… Ø³ÙØ§Ø±Ø´',0),(473764,13161,'tr','Rush sipariÅŸ ÅŸey',0),(473765,13161,'pl','To pilne',0),(473766,13161,'bg','Ð• Ð±ÑŠÑ€Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(473767,13161,'ur','Ø±Ø´ Ú©ÛŒ ØªØ±ØªÛŒØ¨ ÛÛ’',0),(473768,13161,'sr','Ð ÑƒÑÑ… Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð°',0),(473769,13161,'vi','luá»“ng Ä‘Æ¡n hÃ ng',0),(473770,13161,'af','Stormloop orde is',0),(473771,13161,'ro','Este Rush ordine',0),(473772,13161,'et','On Rush korraldus',0),(473773,13161,'si','Rush nalog',0),(473774,13161,'ba','Order Rush',0),(473775,13161,'nl','Spoedorder is',0),(473776,13161,'fi','On kiireellisen tilauksen',0),(473777,13161,'no','Er hasteordre',0),(473778,13161,'da','Er hasteordre',0),(473779,13161,'ko','ë¶ ë¹” ìˆœì„œëŠ”',0),(473780,13161,'he','×¦×• ×”×’×™×•×¡',0),(473781,13161,'el','Î•Î¯Î½Î±Î¹ Î· ÏƒÎµÎ¹ÏÎ¬ Ï„Ï‰Î½ Î²Î¹Î±ÏƒÏÎ½Î·',0),(473782,13161,'zh','æ˜¯ç´§æ€¥è®¢å•',0),(473783,13161,'sv','Ã„r Rush Order',0),(473784,13161,'it','Ãˆ corsa all\'ordine',0),(473785,13161,'tl','',0),(473786,13161,'th','à¸ˆà¸°à¸ªà¸±à¹ˆà¸‡à¸§à¸´à¹ˆà¸‡',0),(473787,13161,'hi','à¤°à¤¶ à¤•à¥à¤°à¤® à¤¹à¥ˆ',0),(473788,13161,'ms','Adalah tergesa-gesa',0),(473789,13161,'ar','ÙŠØªÙ… ØªØ±ØªÙŠØ¨ Ø§Ù„Ø°Ø±ÙˆØ©',0),(473790,13161,'fr','Est la commande urgente',0),(473791,13161,'jp','æ€¥ãŽã®æ³¨æ–‡ã¯',0),(473792,13161,'pt','Ã‰ a ordem de arremetida',0),(473793,13161,'ru','-Ð¡Ñ€Ð¾Ñ‡Ð½Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð·',0),(473794,13161,'es','Es Orden de Prisa',0),(473795,13161,'de','Ist Rush Order',0),(473796,13161,'en','Is Rush Order',0),(473797,13162,'is','',0),(473798,13162,'dr','Ø³ÙØ§Ø±Ø´ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(473799,13162,'pr','Ø³ÙØ§Ø±Ø´ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(473800,13162,'tr','AlÄ±nan sipariÅŸ',0),(473801,13162,'pl','ZamÃ³wienia przez',0),(473802,13162,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°, Ð²Ð·ÐµÑ‚Ð¸ Ð¾Ñ‚',0),(473803,13162,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù„ÛŒ Ú¯Ø¦ÛŒ',0),(473804,13162,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ Ð¾Ð´Ð²ÐµÐ´ÐµÐ½ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(473805,13162,'vi','ÄÆ¡n hÃ ng Ä‘Æ°á»£c láº¥y bá»Ÿi',0),(473806,13162,'af','Volgorde geneem deur',0),(473807,13162,'ro','Ordinea de',0),(473808,13162,'et','Tellimuse vÃµtnud',0),(473809,13162,'si','Nalog, ki jih',0),(473810,13162,'ba','Urutan yang diambil oleh',0),(473811,13162,'nl','Volgorde genomen door',0),(473812,13162,'fi','Tilauksen tehnyt',0),(473813,13162,'no','Bestill tatt av',0),(473814,13162,'da','RÃ¦kkefÃ¸lge af',0),(473815,13162,'ko','ìˆœì„œì— ì˜í•´ ì´¬ì˜',0),(473816,13162,'he','×”×”×–×ž× ×” × ×œ×§×—×” ×¢×œ ×™×“×™',0),(473817,13162,'el','Î£ÎµÎ¹ÏÎ¬ Ï€Î¿Ï… Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ',0),(473818,13162,'zh','æ‰€é‡‡å–çš„é¡ºåº',0),(473819,13162,'sv','BestÃ¤llning av',0),(473820,13162,'it','Ordine preso da',0),(473821,13162,'tl','',0),(473822,13162,'th','à¸ªà¸±à¹ˆà¸‡à¹‚à¸”à¸¢',0),(473823,13162,'hi','à¤†à¤¦à¥‡à¤¶ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤²à¤¿à¤¯à¤¾',0),(473824,13162,'ms','Pesanan yang diambil oleh',0),(473825,13162,'ar','Ø§Ù„ØªØ±ØªÙŠØ¨ Ø§Ù„ØªÙŠ Ø§ØªØ®Ø°ØªÙ‡Ø§',0),(473826,13162,'fr','Commande prise par',0),(473827,13162,'jp','é †åºã§æ’®å½±ã—ã¾ã—ãŸã€‚',0),(473828,13162,'pt','Ordem tomada pelo',0),(473829,13162,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº, Ð¿Ñ€Ð¸Ð½ÑÑ‚Ñ‹Ðµ',0),(473830,13162,'es','Orden Tomado Por',0),(473831,13162,'de','Bestellung getroffenen',0),(473832,13162,'en','Order Taken By',0),(473833,13163,'is','',0),(473834,13163,'dr','Ø³Ø§Ù„ Ø³ÙØ§Ø±Ø´ ',0),(473835,13163,'pr','Ø³Ø§Ù„ Ø³ÙØ§Ø±Ø´ ',0),(473836,13163,'tr','SipariÅŸ yÄ±l',0),(473837,13163,'pl','Rok zamÃ³wienia',0),(473838,13163,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(473839,13163,'ur','ØªØ±ØªÛŒØ¨ Ø³Ø§Ù„',0),(473840,13163,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(473841,13163,'vi','ÄÆ¡n hÃ ng nÄƒm',0),(473842,13163,'af','Orde jaar',0),(473843,13163,'ro','Ordinul an',0),(473844,13163,'et','Korra aastas',0),(473845,13163,'si','Leto naroÄilo',0),(473846,13163,'ba','Urutan tahun',0),(473847,13163,'nl','Volgorde jaar',0),(473848,13163,'fi','Jotta vuoden',0),(473849,13163,'no','For Ã¥r',0),(473850,13163,'da','Bestil Ã¥r',0),(473851,13163,'ko','ì£¼ë¬¸ ë…„',0),(473852,13163,'he','×¡×“×¨ ×”×©× ×”',0),(473853,13163,'el','Î£ÎµÎ¹ÏÎ¬ Î­Ï„Î¿Ï‚',0),(473854,13163,'zh','è®¢è´­å¹´',0),(473855,13163,'sv','BestÃ¤lla Ã¥r',0),(473856,13163,'it','Ordine anno',0),(473857,13163,'tl','',0),(473858,13163,'th','à¸›à¸µà¸ªà¸±à¹ˆà¸‡',0),(473859,13163,'hi','à¤†à¤¦à¥‡à¤¶ à¤µà¤°à¥à¤·',0),(473860,13163,'ms','Tahun perintah',0),(473861,13163,'ar','Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¹Ø§Ù…',0),(473862,13163,'fr','AnnÃ©e de l\'ordre',0),(473863,13163,'jp','ç™ºæ³¨å¹´åº¦',0),(473864,13163,'pt','Ano de fim',0),(473865,13163,'ru','Ð“Ð¾Ð´ Ð·Ð°ÐºÐ°Ð·Ð°',0),(473866,13163,'es','AÃ±o Del Orden',0),(473867,13163,'de','Reihenfolge Jahr',0),(473868,13163,'en','Order Year',0),(473869,13164,'is','',0),(473870,13164,'dr','ØªØ§Ø±ÛŒØ® Ú©Ø´ØªÛŒ ØªØ±Ø¬ÛŒØ­ Ø¯Ø§Ø¯Ù‡',0),(473871,13164,'pr','ØªØ§Ø±ÛŒØ® Ú©Ø´ØªÛŒ ØªØ±Ø¬ÛŒØ­ Ø¯Ø§Ø¯Ù‡',0),(473872,13164,'tr','Tercih edilen sevk tarihi',0),(473873,13164,'pl','Preferowane daty',0),(473874,13164,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°Ñ‚Ð°',0),(473875,13164,'ur','ØªØ±Ø¬ÛŒØ­ÛŒ Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(473876,13164,'sr','ÐŸÑ€ÐµÑ„ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð±Ñ€Ð¾Ð´ Ð´Ð°Ñ‚ÑƒÐ¼',0),(473877,13164,'vi','Æ¯a thÃ­ch tÃ u ngÃ y',0),(473878,13164,'af','Voorkeur skip datum',0),(473879,13164,'ro','Data preferat navei',0),(473880,13164,'et','Eelistatud lÃ¤hetuskuupÃ¤ev',0),(473881,13164,'si','Raje ladja datum',0),(473882,13164,'ba','Pilihan kapal tanggal',0),(473883,13164,'nl','Gewenste verzenddatum',0),(473884,13164,'fi','Ensisijainen lÃ¤hetyspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(473885,13164,'no','Ã˜nsket forsendelsesdato',0),(473886,13164,'da','Foretrukne afsendelsesdato',0),(473887,13164,'ko','ê¸°ë³¸ ë°°ì†¡ì¼',0),(473888,13164,'he','×ª××¨×™×š ×ž×©×œ×•×— ×ž×•×¢×“×£',0),(473889,13164,'el','Î Î»Î¿Î¯Î¿ Ï€ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(473890,13164,'zh','é¦–é€‰çš„è£…è¿æ—¥æœŸ',0),(473891,13164,'sv','Rekommenderad transportdatum',0),(473892,13164,'it','Data di spedizione preferito',0),(473893,13164,'tl','',0),(473894,13164,'th','à¸§à¸±à¸™à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¸à¸²à¸£',0),(473895,13164,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(473896,13164,'ms','Tarikh pilihan kapal',0),(473897,13164,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„Ù…ÙØ¶Ù„',0),(473898,13164,'fr','Date d\'expÃ©dition prÃ©fÃ©rÃ©e',0),(473899,13164,'jp','æœ€å¯„ã‚Šã®å‡ºè·æ—¥',0),(473900,13164,'pt','Data de envio preferido',0),(473901,13164,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°ÐµÐ¼Ñ‹Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð”Ð°Ñ‚Ð°',0),(473902,13164,'es','Fecha de envÃ­o preferido',0),(473903,13164,'de','Bevorzugtes Lieferdatum',0),(473904,13164,'en','Preferred Ship Date',0),(473905,13165,'is','',0),(473906,13165,'dr','Ù…Ø´Ú©Ù„ Ø³ÙØ§Ø±Ø´',0),(473907,13165,'pr','Ù…Ø´Ú©Ù„ Ø³ÙØ§Ø±Ø´',0),(473908,13165,'tr','Sorun sipariÅŸ',0),(473909,13165,'pl','Problem kolejnoÅ›ci',0),(473910,13165,'bg','ÐŸÑ€Ð¾Ð±Ð»ÐµÐ¼ Ñ€ÐµÐ´',0),(473911,13165,'ur','Ù…Ø³Ø¦Ù„Û ØªØ±ØªÛŒØ¨',0),(473912,13165,'sr','ÐŸÑ€Ð¾Ð±Ð»ÐµÐ¼ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(473913,13165,'vi','Ä‘Æ¡n hÃ ng váº¥n Ä‘á»',0),(473914,13165,'af','Probleem orde',0),(473915,13165,'ro','Problema ordinii',0),(473916,13165,'et','Probleem jÃ¤rjekorras',0),(473917,13165,'si','Problem reda',0),(473918,13165,'ba','Masalah Order',0),(473919,13165,'nl','Probleem volgorde',0),(473920,13165,'fi','Ongelma jÃ¤rjestyksessÃ¤',0),(473921,13165,'no','Problemet for',0),(473922,13165,'da','Problem rÃ¦kkefÃ¸lge',0),(473923,13165,'ko','ë¬¸ì œ ìˆœì„œ',0),(473924,13165,'he','×‘×¢×™×™×ª ×¡×“×¨',0),(473925,13165,'el','Î ÏÏŒÎ²Î»Î·Î¼Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(473926,13165,'zh','é—®é¢˜é¡ºåº',0),(473927,13165,'sv','Problem fÃ¶r',0),(473928,13165,'it','Problema ordine',0),(473929,13165,'tl','',0),(473930,13165,'th','à¸¥à¸³à¸”à¸±à¸šà¸›à¸±à¸à¸«à¸²',0),(473931,13165,'hi','à¤¸à¤®à¤¸à¥à¤¯à¤¾ à¤•à¥à¤°à¤®',0),(473932,13165,'ms','Perintah masalah',0),(473933,13165,'ar','Ù…Ø´ÙƒÙ„Ø© Ø§Ù„Ù†Ø¸Ø§Ù…',0),(473934,13165,'fr','ProblÃ¨me commande',0),(473935,13165,'jp','å•é¡Œã®é †åº',0),(473936,13165,'pt','Ordem de problema',0),(473937,13165,'ru','ÐŸÑ€Ð¾Ð±Ð»ÐµÐ¼Ð° Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°',0),(473938,13165,'es','Problema de Orden',0),(473939,13165,'de','Problem bestellen',0),(473940,13165,'en','Problem Order',0),(473941,13166,'is','',0),(473942,13166,'dr','Ú©Ø´ØªÛŒ Ø¨Ø¹Ø¯ Ø§Ø²',0),(473943,13166,'pr','Ú©Ø´ØªÛŒ Ø¨Ø¹Ø¯ Ø§Ø²',0),(473944,13166,'tr','Sonra gemi',0),(473945,13166,'pl','Statek po',0),(473946,13166,'bg','ÐšÐ¾Ñ€Ð°Ð± ÑÐ»ÐµÐ´',0),(473947,13166,'ur','Ú©Û’ Ø¨Ø¹Ø¯ Ø¬ÛØ§Ø²',0),(473948,13166,'sr','Ð‘Ñ€Ð¾Ð´ Ð½Ð°ÐºÐ¾Ð½',0),(473949,13166,'vi','TÃ u sau Ä‘á»£t',0),(473950,13166,'af','Skip na',0),(473951,13166,'ro','Navei dupÄƒ',0),(473952,13166,'et','PÃ¤rast laeva',0),(473953,13166,'si','Ladja po',0),(473954,13166,'ba','Kapal setelah',0),(473955,13166,'nl','Verzenden nadat u hebt',0),(473956,13166,'fi','Aluksen jÃ¤lkeen',0),(473957,13166,'no','Skipet etter',0),(473958,13166,'da','Skibet efter',0),(473959,13166,'ko','í›„ ë°œì†¡',0),(473960,13166,'he','×”×¡×¤×™× ×” ×œ××—×¨',0),(473961,13166,'el','Î Î»Î¿Î¯Î¿ Î¼ÎµÏ„Î¬',0),(473962,13166,'zh','èˆ¹åŽ',0),(473963,13166,'sv','Fartyget efter',0),(473964,13166,'it','Nave dopo',0),(473965,13166,'tl','',0),(473966,13166,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸',0),(473967,13166,'hi','à¤¬à¤¾à¤¦ à¤œà¤¹à¤¾à¤œ',0),(473968,13166,'ms','Kapal selepas',0),(473969,13166,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¨Ø¹Ø¯',0),(473970,13166,'fr','Navire aprÃ¨s',0),(473971,13166,'jp','å¾Œã§å‡ºè·ã—ã¾ã™ã€‚',0),(473972,13166,'pt','Depois do navio',0),(473973,13166,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿Ð¾ÑÐ»Ðµ',0),(473974,13166,'es','DespuÃ©s de la nave',0),(473975,13166,'de','Schiff nach',0),(473976,13166,'en','Ship After',0),(473977,13167,'is','',0),(473978,13167,'dr','Ú©Ø´ØªÛŒ Ù‚Ø¨Ù„ Ø§Ø²',0),(473979,13167,'pr','Ú©Ø´ØªÛŒ Ù‚Ø¨Ù„ Ø§Ø²',0),(473980,13167,'tr','Ã–nce gemi',0),(473981,13167,'pl','Statek przed',0),(473982,13167,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð¿Ñ€ÐµÐ´Ð¸',0),(473983,13167,'ur','Ø³Û’ Ù¾ÛÙ„Û’ Ø¬ÛØ§Ø²',0),(473984,13167,'sr','Ð‘Ñ€Ð¾Ð´ Ð¿Ñ€Ðµ',0),(473985,13167,'vi','TÃ u trÆ°á»›c khi',0),(473986,13167,'af','Skip voor',0),(473987,13167,'ro','Navei Ã®nainte de',0),(473988,13167,'et','Enne laeva',0),(473989,13167,'si','Ladje, preden',0),(473990,13167,'ba','Kapal sebelum',0),(473991,13167,'nl','Voordat het schip',0),(473992,13167,'fi','Aluksen ennen',0),(473993,13167,'no','Skipet fÃ¸r',0),(473994,13167,'da','Skibet fÃ¸r',0),(473995,13167,'ko','ì „ì— ë°°',0),(473996,13167,'he','×”×¡×¤×™× ×” ×œ×¤× ×™',0),(473997,13167,'el','Î Î»Î¿Î¯Î¿ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ',0),(473998,13167,'zh','èˆ¹å‰',0),(473999,13167,'sv','Fartyget innan',0),(474000,13167,'it','Nave prima',0),(474001,13167,'tl','',0),(474002,13167,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸à¹ˆà¸­à¸™',0),(474003,13167,'hi','à¤ªà¤¹à¤²à¥‡ à¤œà¤¹à¤¾à¤œ',0),(474004,13167,'ms','Kapal sebelum',0),(474005,13167,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù‚Ø¨Ù„',0),(474006,13167,'fr','ExpÃ©dier avant',0),(474007,13167,'jp','å‰ã«å‡ºè·ã—ã¾ã™ã€‚',0),(474008,13167,'pt','Navio antes',0),(474009,13167,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿ÐµÑ€ÐµÐ´',0),(474010,13167,'es','La nave antes de',0),(474011,13167,'de','Schiff vor',0),(474012,13167,'en','Ship Before',0),(474013,13168,'is','',0),(474014,13168,'dr','Ø§Ú¯Ø± Ù…ØªÙ† Ø¯Ø± Ø¨Ø§Ù„Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ¹Ø¯Ø§Ø¯ Ú©Ø§Ø±Ø§Ú©ØªØ± Ù…Ø¬Ø§Ø² Ø§Ø³Øª',0),(474015,13168,'pr','Ø§Ú¯Ø± Ù…ØªÙ† Ø¯Ø± Ø¨Ø§Ù„Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ¹Ø¯Ø§Ø¯ Ú©Ø§Ø±Ø§Ú©ØªØ± Ù…Ø¬Ø§Ø² Ø§Ø³Øª',0),(474016,13168,'tr','Maksimum izin verilen karakter sayÄ±sÄ± yukarÄ±da metin seÃ§iliyse',0),(474017,13168,'pl','Po zaznaczeniu tekstu powyÅ¼ej, maksymalnÄ… liczbÄ™ znakÃ³w dozwolonych',0),(474018,13168,'bg','ÐÐºÐ¾ Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½ Ñ‚ÐµÐºÑÑ‚ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ, Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¸Ñ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½ Ð±Ñ€Ð¾Ð¹ Ð·Ð½Ð°Ñ†Ð¸',0),(474019,13168,'ur','Ø§Ú¯Ø± Ù…ØªÙ† Ú©Ø±ÛŒÚ©Ù¹Ø±ÙˆÚº Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ú©ÛŒ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ØªØ¹Ø¯Ø§Ø¯ Ø§ÙˆÙ¾Ø±ØŒ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ ÛÛ’',0),(474020,13168,'sr','ÐÐºÐ¾ Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½ Ñ‚ÐµÐºÑÑ‚ Ð¸Ð·Ð½Ð°Ð´, Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»Ð°Ð½ Ð±Ñ€Ð¾Ñ˜ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¸Ñ… Ð·Ð½Ð°ÐºÐ¾Ð²Ð°',0),(474021,13168,'vi','Náº¿u chÃº thÃ­ch á»Ÿ trÃªn Ä‘Æ°á»£c chá»n, thÃ¬ sá»‘ lá»›n nháº¥t Ä‘Æ°á»£c phÃ©p',0),(474022,13168,'af','As teks gekies Is bogenoemde maksimum getal karakters toegelaat',0),(474023,13168,'ro','DacÄƒ textul este selectat anterior, numÄƒrul maxim de caractere permis',0),(474024,13168,'et','Valitud teksti kohal, lubatud mÃ¤rkide maksimaalne arv',0),(474025,13168,'si','ÄŒe je besedilo oznaÄeno zgoraj, najveÄje dovoljeno Å¡tevilo znakov',0),(474026,13168,'ba','Jika teks yang dipilih di atas, jumlah maksimum karakter yang diizinkan',0),(474027,13168,'nl','Als tekst Is geselecteerd boven, Maximum aantal toegestane tekens',0),(474028,13168,'fi','Jos tekstiÃ¤ on valittuna yllÃ¤, suurin sallittu merkkien mÃ¤Ã¤rÃ¤',0),(474029,13168,'no','Hvis tekst er merket ovenfor, maksimalt antall tillatte tegn',0),(474030,13168,'da','Hvis teksten er markeret ovenfor, maksimalt antal tilladte tegn',0),(474031,13168,'ko','ìµœëŒ€ í—ˆìš© ë¬¸ìž ìˆ˜ ìœ„ì˜ í…ìŠ¤íŠ¸ë¥¼ ì„ íƒí•œ ê²½ìš°',0),(474032,13168,'he','×× × ×‘×—×¨ ×˜×§×¡×˜ ×œ×¢×™×œ, ×”×ž×¡×¤×¨ ×”×ž×¨×‘×™ ×©×œ ×ª×•×•×™× ×ž×•×ª×¨×™×',0),(474033,13168,'el','Î•Î¬Î½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰, Ï„Î¿ Î¼Î­Î³Î¹ÏƒÏ„Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÏ‰Î½ Ï€Î¿Ï… ÎµÏ€Î¹Ï„ÏÎ­Ï€Î¿Î½Ï„Î±Î¹',0),(474034,13168,'zh','å¦‚æžœæœªé€‰å®šæ–‡æœ¬ä»¥ä¸Šï¼Œæœ€å¤§å…è®¸çš„å­—ç¬¦æ•°',0),(474035,13168,'sv','Om Text Ã¤r markerad ovan, maximalt antal tillÃ¥tna tecken',0),(474036,13168,'it','Se viene selezionato il testo sopra, il numero massimo di caratteri consentito',0),(474037,13168,'tl','',0),(474038,13168,'th','à¸–à¹‰à¸²à¸¡à¸µà¹€à¸¥à¸·à¸­à¸à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸‚à¹‰à¸²à¸‡à¸•à¹‰à¸™ à¸ˆà¸³à¸™à¸§à¸™à¸•à¸±à¸§à¸­à¸±à¸à¸©à¸£à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(474039,13168,'hi','à¤¯à¤¦à¤¿ à¤ªà¤¾à¤  à¤µà¤°à¥à¤£à¥‹à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤•à¥€ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾, à¤•à¥‡ à¤Šà¤ªà¤° à¤šà¤¯à¤¨à¤¿à¤¤ à¤¹à¥ˆ',0),(474040,13168,'ms','Jika teks dipilih di atas, bilangan maksimum aksara yang dibenarkan',0),(474041,13168,'ar','Ø¥Ø°Ø§ ØªÙ… ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ù†Øµ Ø£Ø¹Ù„Ø§Ù‡ØŒ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ø£Ø­Ø±Ù Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(474042,13168,'fr','Si le texte est sÃ©lectionnÃ© ci-dessus, un nombre maximal de caractÃ¨res autorisÃ©s',0),(474043,13168,'jp','ä½¿ç”¨ã§ãã‚‹æ–‡å­—ã®æœ€å¤§æ•°ã®ä¸Šã§ãƒ†ã‚­ã‚¹ãƒˆãŒé¸æŠžã•ã‚Œã¦å ´åˆ',0),(474044,13168,'pt','Se o texto estiver selecionado acima, nÃºmero mÃ¡ximo de caracteres permitidos',0),(474045,13168,'ru','Ð•ÑÐ»Ð¸ Ñ‚ÐµÐºÑÑ‚ Ð²Ñ‹Ð´ÐµÐ»ÐµÐ½ Ð²Ñ‹ÑˆÐµ, Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¾Ð²',0),(474046,13168,'es','Si Texto Se Selecciona Arriba, NÃºmero Maximo de Caracteres son Permitidos',0),(474047,13168,'de','Wenn Text, Ã¼ber die maximal zulÃ¤ssige Anzahl von Zeichen markiert ist',0),(474048,13168,'en','If Text Is Selected Above, Maximum Number Of Characters Allowed',0),(474049,13169,'is','',0),(474050,13169,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ù†Ø³ Ø¨Ù‡ Ù„ÛŒØ³Øª ',0),(474051,13169,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¬Ù†Ø³ Ø¨Ù‡ Ù„ÛŒØ³Øª ',0),(474052,13169,'tr','Listesine Ã¶ÄŸe ekleme',0),(474053,13169,'pl','Dodawanie elementu do listy',0),(474054,13169,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÑŠÐ¼ ÑÐ¿Ð¸ÑÑŠÐº',0),(474055,13169,'ur','Ø´Û’ ÙÛØ±Ø³Øª Ù…ÛŒÚº Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(474056,13169,'sr','Ð”Ð¾Ð´Ð°Ñ˜ ÑÑ‚Ð°Ð²ÐºÑƒ Ñƒ Ð»Ð¸ÑÑ‚Ñƒ',0),(474057,13169,'vi','ThÃªm danh má»¥c vÃ o danh sÃ¡ch',0),(474058,13169,'af','Voeg die Item by lys',0),(474059,13169,'ro','AdÄƒugaÅ£i element de listÄƒ',0),(474060,13169,'et','Ãœksuse lisamiseks loendisse',0),(474061,13169,'si','Dodajanje elementa na seznam',0),(474062,13169,'ba','Menambahkan Item ke daftar',0),(474063,13169,'nl','Item toevoegen aan lijst',0),(474064,13169,'fi','Kohteen lisÃ¤Ã¤minen luetteloon',0),(474065,13169,'no','Legge til element i listen',0),(474066,13169,'da','FÃ¸je elementet til listen',0),(474067,13169,'ko','ëª©ë¡ì— í•­ëª© ì¶”ê°€',0),(474068,13169,'he','×œ×”×•×¡×™×£ ×¤×¨×™×˜ ×œ×¨×©×™×ž×”',0),(474069,13169,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… ÏƒÏ„Î· Î»Î¯ÏƒÏ„Î±',0),(474070,13169,'zh','å°†é¡¹ç›®æ·»åŠ åˆ°åˆ—è¡¨',0),(474071,13169,'sv','LÃ¤gga till objekt i listan',0),(474072,13169,'it','Aggiungere l\'elemento alla lista',0),(474073,13169,'tl','',0),(474074,13169,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¸¥à¸‡à¹ƒà¸™à¸£à¸²à¸¢à¸à¸²à¸£',0),(474075,13169,'hi','à¤¸à¥‚à¤šà¥€ à¤®à¥‡à¤‚ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(474076,13169,'ms','Menambah Item ke senarai',0),(474077,13169,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù†ØµØ± Ø¥Ù„Ù‰ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(474078,13169,'fr','Ajoutez l\'Ã©lÃ©ment Ã  la liste',0),(474079,13169,'jp','ãƒªã‚¹ãƒˆã«é …ç›®ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(474080,13169,'pt','Adicionar um Item Ã  lista',0),(474081,13169,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð² ÑÐ¿Ð¸ÑÐ¾Ðº',0),(474082,13169,'es','Agregar Item a la Lista',0),(474083,13169,'de','Element zur Liste hinzufÃ¼gen',0),(474084,13169,'en','Add Item To List',0),(474085,13170,'is','',0),(474086,13170,'dr','Ù„Ø·ÙØ§Ø§Ø¨ØªØ¯Ø§ ÛŒÚ© Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯ Ø³Ù¾Ø³ Ø¨Ø±Ú¯Ø±Ø¯ÛŒØ¯ ',0),(474087,13170,'pr','Ù„Ø·ÙØ§Ø§Ø¨ØªØ¯Ø§ ÛŒÚ© Ú¯Ø±ÙˆÙ‡ Ø­Ù‚ÙˆÙ‚ Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯ Ø³Ù¾Ø³ Ø¨Ø±Ú¯Ø±Ø¯ÛŒØ¯ ',0),(474088,13170,'tr','LÃ¼tfen ilk haklarÄ± grubu ekleyin, sonra geri gel.',0),(474089,13170,'pl','Najpierw Dodaj grupÄ™ praw, a nastÄ™pnie wrÃ³ciÄ‡.',0),(474090,13170,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ñ€Ð°Ð²Ð° Ð³Ñ€ÑƒÐ¿Ð° Ð¿ÑŠÑ€Ð²Ð¾, ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð° ÑÐµ Ð²ÑŠÑ€Ð½Ð°.',0),(474091,13170,'ur','Ø­Ù‚ÙˆÙ‚ Ú©Û’ Ø§ÛŒÚ© Ú¯Ø±ÙˆÙ¾ Ú©Ùˆ Ù¾ÛÙ„ÛŒ Ø¨Ø§Ø± Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº Ø§ÙˆØ± ÙˆØ§Ù¾Ø³ Ø¢Ø¦ÛŒÚº Û”',0),(474092,13170,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ðµ Ð¿Ñ€Ð°Ð²Ð° Ð¿Ñ€Ð²Ð¾, Ð° Ð¾Ð½Ð´Ð° ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ñ‚Ð¸.',0),(474093,13170,'vi','xin vui lÃ²ng thÃªm quyá»n cá»§a nhÃ³m trÆ°á»›c sau Ä‘Ã³ trá»Ÿ láº¡i',0),(474094,13170,'af','Asseblief eers \'n regte groep voeg, en dan terug te kom.',0),(474095,13170,'ro','VÄƒ rugÄƒm sÄƒ adÄƒugaÅ£i un grup de drepturile primul, apoi vin Ã®napoi.',0),(474096,13170,'et','Ã•iguste rÃ¼hma esmalt lisada siis tagasi tulla.',0),(474097,13170,'si','Prosim dodajte skupino pravice najprej, potem pa pridi nazaj.',0),(474098,13170,'ba','Silakan menambahkan grup hak terlebih dahulu, kemudian datang kembali.',0),(474099,13170,'nl','Gelieve een rechtengroep eerst toevoegen, dan komen terug.',0),(474100,13170,'fi','LisÃ¤Ã¤ oikeuksien ryhmÃ¤ ensin sitten tulla takaisin.',0),(474101,13170,'no','Behage legge en rettigheter gruppen fÃ¸rst, og deretter komme tilbake.',0),(474102,13170,'da','Venligst tilfÃ¸je en rettigheder gruppe fÃ¸rst og derefter komme tilbage.',0),(474103,13170,'ko','ì œë°œ ê¶Œë¦¬ ê·¸ë£¹ì„ ë¨¼ì € ì¶”ê°€ ë‹¤ìŒ ë‹¤ì‹œì™€ ì„œ.',0),(474104,13170,'he','× × ×œ×”×•×¡×™×£ ×§×‘×•×¦×” ×œ×–×›×•×™×•×ª ×ª×—×™×œ×” ×•×œ××—×¨ ×ž×›×Ÿ ×ª×—×–×•×¨.',0),(474105,13170,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î¼Î¹Î± Î¿Î¼Î¬Î´Î± Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï€ÏÏŽÏ„Î±, ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î±, Î½Î± ÎµÏ€Î±Î½Î­Î»Î¸ÎµÎ¹.',0),(474106,13170,'zh','è¯·æ·»åŠ ä¸€ä¸ªäººæƒç»„ç»‡ç¬¬ä¸€ï¼Œç„¶åŽå†å›žæ¥ã€‚',0),(474107,13170,'sv','VÃ¤nligen lÃ¤gga en rÃ¤ttighetsgrupp fÃ¶rst och sedan komma tillbaka.',0),(474108,13170,'it','Per favore aggiungere prima un gruppo di diritti, poi tornare indietro.',0),(474109,13170,'tl','',0),(474110,13170,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸žà¸´à¹ˆà¸¡ à¸à¸¥à¸¸à¹ˆà¸¡à¸ªà¸´à¸—à¸˜à¸´à¸à¹ˆà¸­à¸™ à¹à¸¥à¹‰à¸§à¸à¸¥à¸±à¸šà¸¡à¸²',0),(474111,13170,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤¹à¤²à¥‡ à¤à¤• à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤®à¥‚à¤¹ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚, à¤”à¤° à¤«à¤¿à¤° à¤µà¤¾à¤ªà¤¸ à¤†à¥¤',0),(474112,13170,'ms','Sila tambah Kumpulan hak terlebih dahulu, kemudian datang kembali.',0),(474113,13170,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø­Ù‚ÙˆÙ‚ Ø£ÙˆÙ„Ø§Ù‹ØŒ Ø«Ù… ÙŠØ£ØªÙŠ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰.',0),(474114,13170,'fr','S\'il vous plaÃ®t ajouter un groupe de droits tout d\'abord, puis revenir.',0),(474115,13170,'jp','æœ€åˆã«ã€æ¨©é™ã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ ã—ã¦æˆ»ã£ã¦ãã¦ãã ã•ã„ã€‚',0),(474116,13170,'pt','Por favor, adicione um grupo de direitos primeiro, depois volta.',0),(474117,13170,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð´Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð³Ñ€ÑƒÐ¿Ð¿Ñƒ Ð¿Ñ€Ð°Ð², Ð° Ð·Ð°Ñ‚ÐµÐ¼ Ð²ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ.',0),(474118,13170,'es','Por favor agregar un Grupo de Derechos primero y luego regresa aca.',0),(474119,13170,'de','Bitte fÃ¼gen Sie eine Rechte Gruppe zuerst, dann kommen Sie zurÃ¼ck.',0),(474120,13170,'en','Please add a Rights Group first, then come back.',0),(474121,13171,'is','',0),(474122,13171,'dr','Ù„Ø·ÙØ§Ø§Ø¨ØªØ¯Ø§ ÛŒÚ© Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯ Ø³Ù¾Ø³ Ø¨Ø±Ú¯Ø±Ø¯ÛŒØ¯ ',0),(474123,13171,'pr','Ù„Ø·ÙØ§Ø§Ø¨ØªØ¯Ø§ ÛŒÚ© Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯ Ø³Ù¾Ø³ Ø¨Ø±Ú¯Ø±Ø¯ÛŒØ¯ ',0),(474124,13171,'tr','LÃ¼tfen Ã¶nce bir kullanÄ±cÄ± ekleyin, sonra geri gel.',0),(474125,13171,'pl','Najpierw Dodaj uÅ¼ytkownika, a nastÄ™pnie wrÃ³ciÄ‡.',0),(474126,13171,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð¿ÑŠÑ€Ð²Ð¾, ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð° ÑÐµ Ð²ÑŠÑ€Ð½Ð°.',0),(474127,13171,'ur','Ú©Ø³ÛŒ ØµØ§Ø±Ù Ú©Ùˆ Ù¾ÛÙ„ÛŒ Ø¨Ø§Ø± Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº Ø§ÙˆØ± ÙˆØ§Ù¾Ø³ Ø¢Ø¦ÛŒÚº Û”',0),(474128,13171,'sr','ÐŸÑ€Ð²Ð¾ Ð´Ð° Ð´Ð¾Ð´Ð°Ñ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°, Ð° Ð·Ð°Ñ‚Ð¸Ð¼ ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ñ‚Ð¸.',0),(474129,13171,'vi','vui lÃ²ng thÃªm ngÆ°á»i sá»­ dá»¥ng trÆ°á»›c, rá»“i sau Ä‘Ã³ quay láº¡i',0),(474130,13171,'af','Asseblief eers \'n gebruiker byvoeg, en kom dan terug.',0),(474131,13171,'ro','VÄƒ rugÄƒm sÄƒ adÄƒugaÅ£i un utilizator prima datÄƒ, apoi vin Ã®napoi.',0),(474132,13171,'et','Lisa kasutaja Esiteks siis tagasi tulla.',0),(474133,13171,'si','Prosim dodajte uporabnika najprej, potem pa pridi nazaj.',0),(474134,13171,'ba','Silakan menambahkan pengguna pertama, kemudian datang kembali.',0),(474135,13171,'nl','Gelieve een gebruiker eerst toevoegen, dan komen terug.',0),(474136,13171,'fi','LisÃ¤Ã¤ kÃ¤yttÃ¤jÃ¤ ensimmÃ¤inen sitten tulla takaisin.',0),(474137,13171,'no','Vennligst legge til en bruker fÃ¸rst, og deretter komme tilbake.',0),(474138,13171,'da','Skal du tilfÃ¸je en bruger fÃ¸rst og derefter komme tilbage.',0),(474139,13171,'ko','ì œë°œ ë¨¼ì € ì‚¬ìš©ìžë¥¼ ì¶”ê°€ í›„ ë‹¤ì‹œì™€ ì„œ.',0),(474140,13171,'he','× × ×œ×”×•×¡×™×£ ×ž×©×ª×ž×© ×ª×—×™×œ×” ×•×œ××—×¨ ×ž×›×Ÿ ×ª×—×–×•×¨.',0),(474141,13171,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î­Î½Î± Ï‡ÏÎ®ÏƒÏ„Î·, Ï€ÏÏŽÏ„Î±, ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î± Î½Î± ÎµÏ€Î±Î½Î­Î»Î¸ÎµÎ¹.',0),(474142,13171,'zh','è¯·æ·»åŠ ä¸€ä¸ªç”¨æˆ·ç¬¬ä¸€ï¼Œç„¶åŽå†å›žæ¥ã€‚',0),(474143,13171,'sv','VÃ¤nligen lÃ¤gga till en anvÃ¤ndare fÃ¶rst och sedan komma tillbaka.',0),(474144,13171,'it','Per favore Aggiungi un utente prima, poi tornare indietro.',0),(474145,13171,'tl','',0),(474146,13171,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸žà¸´à¹ˆà¸¡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸à¹ˆà¸­à¸™ à¹à¸¥à¹‰à¸§à¸à¸¥à¸±à¸šà¸¡à¸²',0),(474147,13171,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¤¹à¤²à¥‡ à¤à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚, à¤¤à¥‹ à¤µà¤¾à¤ªà¤¸ à¤† à¤œà¤¾à¤“à¥¤',0),(474148,13171,'ms','Sila tambah pengguna terlebih dahulu, kemudian datang kembali.',0),(474149,13171,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…Ø³ØªØ®Ø¯Ù… Ø£ÙˆÙ„Ø§Ù‹ØŒ Ø«Ù… ÙŠØ£ØªÙŠ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰.',0),(474150,13171,'fr','S\'il vous plaÃ®t d\'abord ajouter un utilisateur, puis revenez.',0),(474151,13171,'jp','ã¾ãšã€ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’è¿½åŠ ã—ã¦æˆ»ã£ã¦ãã¦ãã ã•ã„ã€‚',0),(474152,13171,'pt','Por favor, adicione um usuÃ¡rio primeiro, depois volta.',0),(474153,13171,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð´Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ, Ð° Ð·Ð°Ñ‚ÐµÐ¼ Ð²ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ.',0),(474154,13171,'es','Por favor agregar un Usuario primero y luego regresa aca.',0),(474155,13171,'de','Bitte fÃ¼gen Sie einen Benutzer zuerst, dann kommen Sie zurÃ¼ck.',0),(474156,13171,'en','Please add a User first, then come back.',0),(474157,13172,'is','',0),(474158,13172,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ú¯Ø²ÛŒÙ†Ù‡ Ø±Ø§ Ø§Ø² Ø²ÛŒØ± Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(474159,13172,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ú¯Ø²ÛŒÙ†Ù‡ Ø±Ø§ Ø§Ø² Ø²ÛŒØ± Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(474160,13172,'tr','LÃ¼tfen aÅŸaÄŸÄ±daki seÃ§eneklerden birini seÃ§in',0),(474161,13172,'pl','Wybierz opcjÄ™ poniÅ¼ej',0),(474162,13172,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ñ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ',0),(474163,13172,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù†ÛŒÚ†Û’ Ø§Ø®ØªÛŒØ§Ø± Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(474164,13172,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð¾Ð»Ðµ Ð½Ð°Ð²ÐµÐ´ÐµÐ½Ñƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ',0),(474165,13172,'vi','vui lÃ²ng chá»n dÆ°á»›i Ä‘Ã¢y',0),(474166,13172,'af','Kies asseblief \'n opsie hier onder',0),(474167,13172,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i o opÅ£iune de mai jos',0),(474168,13172,'et','Palun valige alltoodud suvand',0),(474169,13172,'si','Izberite moÅ¾nost spodaj',0),(474170,13172,'ba','Silakan pilih opsi di bawah ini',0),(474171,13172,'nl','Selecteer hieronder een optie',0),(474172,13172,'fi','Valitse alta vaihtoehto',0),(474173,13172,'no','Velg et alternativ nedenfor',0),(474174,13172,'da','VÃ¦lg en indstilling nedenfor',0),(474175,13172,'ko','ì•„ëž˜ ì˜µì…˜ì„ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(474176,13172,'he','×× × ×‘×—×¨ ×‘××—×ª ×ž×”××¤×©×¨×•×™×•×ª ×”×‘××•×ª',0),(474177,13172,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Î¿ÏÎ¯ÏƒÏ„Îµ Î¼Î¹Î± ÎµÏ€Î¹Î»Î¿Î³Î® Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰',0),(474178,13172,'zh','è¯·é€‰æ‹©ä¸‹é¢çš„ä¸€ä¸ªé€‰é¡¹',0),(474179,13172,'sv','VÃ¤nligen vÃ¤lj ett alternativ nedan',0),(474180,13172,'it','Si prega di selezionare un\'opzione qui sotto',0),(474181,13172,'tl','',0),(474182,13172,'th','à¹‚à¸›à¸£à¸”à¹€à¸¥à¸·à¸­à¸à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡',0),(474183,13172,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¨à¥€à¤šà¥‡ à¤à¤• à¤µà¤¿à¤•à¤²à¥à¤ª à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(474184,13172,'ms','Sila buat pilihan di bawah',0),(474185,13172,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ø£Ø­Ø¯ Ø§Ù„Ø®ÙŠØ§Ø±Ø§Øª Ø£Ø¯Ù†Ø§Ù‡',0),(474186,13172,'fr','Veuillez sÃ©lectionner une Option ci-dessous',0),(474187,13172,'jp','ä»¥ä¸‹ã®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(474188,13172,'pt','Por favor, selecione uma opÃ§Ã£o abaixo',0),(474189,13172,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ Ð²Ð½Ð¸Ð·Ñƒ',0),(474190,13172,'es','Por Favor Selecciona Una OpciÃ³n Abajo',0),(474191,13172,'de','Bitte wÃ¤hlen Sie eine der folgenden Optionen',0),(474192,13172,'en','Please Select An Option Below',0),(474193,13173,'is','',0),(474194,13173,'dr','Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(474195,13173,'pr','Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(474196,13173,'tr','KullanÄ±cÄ± seÃ§in',0),(474197,13173,'pl','Wybierz uÅ¼ytkownika',0),(474198,13173,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(474199,13173,'ur','ØµØ§Ø±Ù Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(474200,13173,'sr','Ð˜Ð·Ð±Ð¾Ñ€ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(474201,13173,'vi','Chá»n ngÆ°á»i dÃ¹ng',0),(474202,13173,'af','Kies gebruiker',0),(474203,13173,'ro','SelectaÅ£i utilizator',0),(474204,13173,'et','Valige kasutaja',0),(474205,13173,'si','Izberite uporabnika',0),(474206,13173,'ba','Pilih pengguna',0),(474207,13173,'nl','Selecteer gebruiker',0),(474208,13173,'fi','Valitse kÃ¤yttÃ¤jÃ¤',0),(474209,13173,'no','Velg bruker',0),(474210,13173,'da','VÃ¦lg bruger',0),(474211,13173,'ko','ì‚¬ìš©ìž ì„ íƒ',0),(474212,13173,'he','×‘×—×¨ ×ž×©×ª×ž×©',0),(474213,13173,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï‡ÏÎ®ÏƒÏ„Î·',0),(474214,13173,'zh','é€‰æ‹©ç”¨æˆ·',0),(474215,13173,'sv','VÃ¤lj anvÃ¤ndare',0),(474216,13173,'it','Selezionare utente',0),(474217,13173,'tl','',0),(474218,13173,'th','à¹€à¸¥à¸·à¸­à¸à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(474219,13173,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(474220,13173,'ms','Pilih pengguna',0),(474221,13173,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(474222,13173,'fr','SÃ©lectionnez utilisateur',0),(474223,13173,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’é¸æŠžã—ã¾ã™',0),(474224,13173,'pt','Selecione o usuÃ¡rio',0),(474225,13173,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(474226,13173,'es','Selecciona Usuario',0),(474227,13173,'de','WÃ¤hlen Sie Benutzer',0),(474228,13173,'en','Select User',0),(474229,13174,'is','',0),(474230,13174,'dr','ØªÙ†Ø¸ÛŒÙ… Ø­Ù‚ÙˆÙ‚ Ø¨Ø±Ø§ÛŒ ÛŒÚ© Ú¯Ø±ÙˆÙ‡\r\nA',0),(474231,13174,'pr','ØªÙ†Ø¸ÛŒÙ… Ø­Ù‚ÙˆÙ‚ Ø¨Ø±Ø§ÛŒ ÛŒÚ© Ú¯Ø±ÙˆÙ‡\r\nA',0),(474232,13174,'tr','Bir grup iÃ§in ayarlanmÄ±ÅŸ haklarÄ±',0),(474233,13174,'pl','Zestaw praw dla grupy',0),(474234,13174,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(474235,13174,'ur','Ø§ÛŒÚ© Ú¯Ø±ÙˆÙ¾ Ú©Û’ Ù„Ø¦Û’ Ù…Ù‚Ø±Ø± Ø­Ù‚ÙˆÙ‚',0),(474236,13174,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð³Ñ€ÑƒÐ¿Ñƒ',0),(474237,13174,'vi','CÃ i Ä‘áº·t cÃ¡c quyá»n cho má»™t nhÃ³m',0),(474238,13174,'af','Stel regte vir \'n groep',0),(474239,13174,'ro','Drepturile stabilite pentru un grup',0),(474240,13174,'et','MÃ¤Ã¤ratud Ãµiguste rÃ¼hma',0),(474241,13174,'si','Nastavitev pravic za skupino',0),(474242,13174,'ba','Hak-hak yang ditetapkan untuk grup',0),(474243,13174,'nl','Set rechten voor een groep',0),(474244,13174,'fi','Aseta oikeudet ryhmÃ¤',0),(474245,13174,'no','Angi tilgangsrettigheter For en gruppe',0),(474246,13174,'da','SÃ¦t rettigheder til en gruppe',0),(474247,13174,'ko','ê·¸ë£¹ì— ëŒ€ í•œ ì„¤ì •ëœ ê¶Œí•œ',0),(474248,13174,'he','×§×‘×™×¢×ª ×–×›×•×™×•×ª ×œ×§×‘×•×¦×”',0),(474249,13174,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ Î´Î¹ÎºÎ±Î¹Ï‰Î¼Î¬Ï„Ï‰Î½ Î³Î¹Î± Î¼Î¹Î± Î¿Î¼Î¬Î´Î±',0),(474250,13174,'zh','ç»„è®¾ç½®çš„æƒé™',0),(474251,13174,'sv','Ange rÃ¤ttigheter fÃ¶r en grupp',0),(474252,13174,'it','Impostare i diritti per un gruppo',0),(474253,13174,'tl','',0),(474254,13174,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸´à¸—à¸˜à¸´à¹Œà¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸¥à¸¸à¹ˆà¸¡',0),(474255,13174,'hi','à¤à¤• à¤¸à¤®à¥‚à¤¹ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚ à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(474256,13174,'ms','Hak-hak yang ditetapkan untuk Kumpulan',0),(474257,13174,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø­Ù‚ÙˆÙ‚ Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(474258,13174,'fr','Droits de jeu pour un groupe',0),(474259,13174,'jp','ã‚°ãƒ«ãƒ¼ãƒ—ã®è¨­å®šæ¨©é™',0),(474260,13174,'pt','Conjunto de direitos para um grupo',0),(474261,13174,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð°Ð²Ð° Ð´Ð»Ñ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(474262,13174,'es','Configurar Derechos Para Un Grupo',0),(474263,13174,'de','Set Rechte fÃ¼r eine Gruppe',0),(474264,13174,'en','Set Rights For A Group',0),(474265,13175,'is','',0),(474266,13175,'dr','ØªÙ†Ø¸ÛŒÙ… Ø­Ù‚ÙˆÙ‚ Ø¨Ø±Ø§ÛŒ ÛŒÚ© Ú©Ø§Ø±Ø¨Ø± ',0),(474267,13175,'pr','ØªÙ†Ø¸ÛŒÙ… Ø­Ù‚ÙˆÙ‚ Ø¨Ø±Ø§ÛŒ ÛŒÚ© Ú©Ø§Ø±Ø¨Ø± ',0),(474268,13175,'tr','Tek bir kullanÄ±cÄ± haklarÄ±nÄ± ayarla',0),(474269,13175,'pl','Zestaw praw dla pojedynczego uÅ¼ytkownika',0),(474270,13175,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° ÐµÐ´Ð¸Ð½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(474271,13175,'ur','Ø­Ù‚ÙˆÙ‚ Ú©Ø³ÛŒ Ø³Ù†Ú¯Ù„ ØµØ§Ø±Ù Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(474272,13175,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ñ˜ÐµÐ´Ð½Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(474273,13175,'vi','CÃ i Ä‘áº·t cÃ¡c quyá»n cho má»™t ngÆ°á»i dÃ¹ng',0),(474274,13175,'af','Stel regte vir \'n enkele gebruiker',0),(474275,13175,'ro','Drepturile stabilite pentru un singur utilizator',0),(474276,13175,'et','MÃ¤Ã¤ratud Ãµigused Ã¼hele kasutajale',0),(474277,13175,'si','DoloÄene pravice za enega uporabnika',0),(474278,13175,'ba','Hak-hak yang ditetapkan untuk satu pengguna',0),(474279,13175,'nl','Rechten voor een enkele gebruiker ingesteld',0),(474280,13175,'fi','Yhden kÃ¤yttÃ¤jÃ¤n oikeuksien mÃ¤Ã¤rittÃ¤minen',0),(474281,13175,'no','Angi rettigheter For en bruker',0),(474282,13175,'da','Angive rettigheder For en enkelt bruger',0),(474283,13175,'ko','ë‹¨ì¼ ì‚¬ìš©ìžì— ëŒ€ í•œ ê¶Œë¦¬ë¥¼ ì„¤ì •',0),(474284,13175,'he','×œ×”×’×“×™×¨ ×–×›×•×™×•×ª ×¢×‘×•×¨ ×ž×©×ª×ž×© ×‘×•×“×“',0),(474285,13175,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ Î´Î¹ÎºÎ±Î¹Ï‰Î¼Î¬Ï„Ï‰Î½ Î³Î¹Î± Î­Î½Î±Î½ Ï‡ÏÎ®ÏƒÏ„Î·',0),(474286,13175,'zh','ä¸ºå•ä¸ªç”¨æˆ·è®¾ç½®æƒé™',0),(474287,13175,'sv','Ange rÃ¤ttigheter fÃ¶r en enda anvÃ¤ndare',0),(474288,13175,'it','Impostare i diritti per un singolo utente',0),(474289,13175,'tl','',0),(474290,13175,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸´à¸—à¸˜à¸´à¹Œà¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰',0),(474291,13175,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤à¤•à¤² à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(474292,13175,'ms','Hak-hak yang ditetapkan bagi pengguna tunggal',0),(474293,13175,'ar','ØªØ¹ÙŠÙŠÙ† Ø­Ù‚ÙˆÙ‚ Ù„Ù…Ø³ØªØ®Ø¯Ù… ÙˆØ§Ø­Ø¯',0),(474294,13175,'fr','DÃ©finir les droits d\'un utilisateur unique',0),(474295,13175,'jp','1 äººã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®æ¨©é™ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(474296,13175,'pt','Definir os direitos para um Ãºnico usuÃ¡rio',0),(474297,13175,'ru','Ð—Ð°Ð´Ð°Ñ‚ÑŒ Ð¿Ñ€Ð°Ð²Ð° Ð´Ð»Ñ Ð¾Ð´Ð½Ð¾Ð³Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(474298,13175,'es','Configurar Derechos Para Un Usuario Solitario',0),(474299,13175,'de','Rechte fÃ¼r einen einzelnen Benutzer festlegen',0),(474300,13175,'en','Set Rights For A Single User',0),(474301,13176,'is','',0),(474302,13176,'dr','Ø­Ù‚ÙˆÙ‚ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(474303,13176,'pr','Ø­Ù‚ÙˆÙ‚ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯',0),(474304,13176,'tr','Nakliye haklarÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(474305,13176,'pl','WysyÅ‚ka praw pomyÅ›lnie zaktualizowana',0),(474306,13176,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ñ€Ð°Ð²Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(474307,13176,'ur','Ø­Ù‚ÙˆÙ‚ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø´Ù¾Ù†Ú¯',0),(474308,13176,'sr','ÐŸÑ€Ð°Ð²Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(474309,13176,'vi','Quyá»n váº­n chuyá»ƒn Ä‘Æ°á»£c cáº­p nháº­t thÃ nh cÃ´ng',0),(474310,13176,'af','Regte suksesvol opgedateer gestuur',0),(474311,13176,'ro','Drepturi maritime actualizat cu succes',0),(474312,13176,'et','Laevanduse Ãµiguste vÃ¤rskendamine Ãµnnestus',0),(474313,13176,'si','Dostava pravice uspeÅ¡no posodobljena',0),(474314,13176,'ba','Hak-hak pengiriman yang berhasil',0),(474315,13176,'nl','Verzending rechten bijgewerkt',0),(474316,13176,'fi','Toimitus oikeutta pÃ¤ivittÃ¤minen onnistui',0),(474317,13176,'no','Skipsfartsrettigheter oppdatert',0),(474318,13176,'da','Shipping rettigheder opdateret',0),(474319,13176,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ë°°ì†¡ ê¶Œë¦¬',0),(474320,13176,'he','×–×›×•×™×•×ª ×”×¡×¤× ×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(474321,13176,'el','Î”Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(474322,13176,'zh','å·²æˆåŠŸæ›´æ–°çš„èˆªè¿æƒåˆ©',0),(474323,13176,'sv','Frakt rÃ¤ttigheter uppdaterats',0),(474324,13176,'it','Diritti di spedizione aggiornati con successo',0),(474325,13176,'tl','',0),(474326,13176,'th','à¸ªà¹ˆà¸‡à¸ªà¸´à¸—à¸˜à¸´à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(474327,13176,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(474328,13176,'ms','Hak-hak perkapalan yang berjaya dikemas kini',0),(474329,13176,'ar','Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(474330,13176,'fr','Mis Ã  jour avec succÃ¨s les droits d\'expÃ©dition',0),(474331,13176,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸé…é€æ¨©åˆ©',0),(474332,13176,'pt','Direitos de frete atualizados com sucesso',0),(474333,13176,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ñ€Ð°Ð², Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(474334,13176,'es','Derechos de EnvÃ­o Actualizados Exitosamente',0),(474335,13176,'de','Versand Rechte erfolgreich aktualisiert',0),(474336,13176,'en','Shipping Rights Updated Successfully',0),(474337,13177,'is','',0),(474338,13177,'dr','(Ø­Ù…Ù„) Ú©Ù†Ø¯',0),(474339,13177,'pr','Ø§ÛŒÙ† Ú¯Ø±ÙˆÙ‡ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯Ú©Ø§Ù„Ø§Ù‡Ø§ Ø±Ø§ Ø§Ø² Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ Ø²ÛŒØ± Ø§Ø±Ø³Ø§Ù„(Ø­Ù…Ù„) Ú©Ù†Ø¯',0),(474340,13177,'tr','Bu grup aÅŸaÄŸÄ±daki kategorilerden maddeleri sevk edemem',0),(474341,13177,'pl','Ta grupa nie statek elementy z nastÄ™pujÄ…cych kategorii',0),(474342,13177,'bg','Ð¢Ð°Ð·Ð¸ Ð³Ñ€ÑƒÐ¿Ð° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸Ñ‚Ðµ Ð¾Ñ‚ ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(474343,13177,'ur','ÛŒÛ Ú¯Ø±ÙˆÙ¾ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ø²Ù…Ø±ÙˆÚº Ø³Û’ Ø§Ø´ÛŒØ§Ø¡ Ø¬ÛØ§Ø² Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(474344,13177,'sr','ÐžÐ²Ð¾Ñ˜ Ð³Ñ€ÑƒÐ¿Ð¸ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ð¸Ð· ÑÐ»Ð¸Ñ˜ÐµÐ´ÐµÑ›Ð¸Ñ… ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(474345,13177,'vi','NhÃ³m nÃ y khÃ´ng thá»ƒ xuáº¥t cÃ¡c máº·t hÃ ng sau Ä‘Ã¢y',0),(474346,13177,'af','Hierdie groep kan Items uit die volgende kategorieÃ« skip',0),(474347,13177,'ro','Acest grup nu poate navÄƒ elemente din urmÄƒtoarele categorii de',0),(474348,13177,'et','Sellesse rÃ¼hma ei saa lÃ¤hetada kaupu jÃ¤rgmistesse kategooriatesse:',0),(474349,13177,'si','Tej skupini ne morete ladje elementi iz naslednjih kategorij',0),(474350,13177,'ba','Kelompok ini tidak bisa kapal barang dari kategori berikut',0),(474351,13177,'nl','Deze groep kan niet objecten uit de volgende categorieÃ«n verzenden',0),(474352,13177,'fi','TÃ¤mÃ¤ ryhmÃ¤ voi aluksen kohteita seuraaviin ryhmiin',0),(474353,13177,'no','Denne gruppen kan ikke levere varer fra fÃ¸lgende kategorier',0),(474354,13177,'da','Denne gruppe kan ikke levere varer fra fÃ¸lgende kategorier',0),(474355,13177,'ko','ì´ ê·¸ë£¹ì€ ë‹¤ìŒê³¼ ê°™ì€ ë²”ì£¼ì—ì„œ ìƒí’ˆì„ ë°°ì†¡ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(474356,13177,'he','×§×‘×•×¦×” ×–×• ×œ× ×™×›×•×œ×”. ×œ×©×œ×•×— ×¤×¨×™×˜×™× ×ž×”×§×˜×’×•×¨×™×•×ª ×”×‘××•×ª',0),(474357,13177,'el','Î‘Ï…Ï„Î® Î· Î¿Î¼Î¬Î´Î± Î´ÎµÎ½ ÏƒÏ„ÎµÎ¯Î»ÎµÏ„Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Ï€ÏŒ Ï„Î¹Ï‚ Î±ÎºÏŒÎ»Î¿Ï…Î¸ÎµÏ‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(474358,13177,'zh','æ­¤ç»„ä¸èƒ½ä»Žä»¥ä¸‹ç±»åˆ«èˆ¹èˆ¶é¡¹ç›®',0),(474359,13177,'sv','Denna grupp kan inte leverera artiklar frÃ¥n fÃ¶ljande kategorier',0),(474360,13177,'it','Questo gruppo non puÃ² spedire gli articoli dalle seguenti categorie',0),(474361,13177,'tl','',0),(474362,13177,'th','à¸à¸¥à¸¸à¹ˆà¸¡à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ˆà¸²à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰',0),(474363,13177,'hi','à¤‡à¤¸ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥‹ à¤¨à¤¿à¤®à¥à¤¨ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤¸à¥‡ à¤œà¤¹à¤¾à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(474364,13177,'ms','Kumpulan ini tidak boleh menghantar item dari kategori-kategori yang berikut',0),(474365,13177,'ar','Ù‡Ø°Ù‡ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø´Ø­Ù† Ø§Ù„Ø£ØµÙ†Ø§Ù Ù…Ù† Ø§Ù„ÙØ¦Ø§Øª Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(474366,13177,'fr','Ce groupe ne peut expÃ©dier des articles provenant des catÃ©gories suivantes',0),(474367,13177,'jp','ã“ã®ã‚°ãƒ«ãƒ¼ãƒ—ã¯ã€æ¬¡ã®ã‚«ãƒ†ã‚´ãƒªã‹ã‚‰é …ç›®ã‚’å‡ºè·ã§ãã¾ã›ã‚“ã€‚',0),(474368,13177,'pt','Este grupo nÃ£o enviamos artigos das seguintes categorias',0),(474369,13177,'ru','Ð­Ñ‚Ð° Ð³Ñ€ÑƒÐ¿Ð¿Ð° Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÑÑ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¸Ð· ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ñ… ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹',0),(474370,13177,'es','Este Grupo No Puede Enviar Items De Las Siguentes CategorÃ­as',0),(474371,13177,'de','Diese Gruppe kann nicht aus den folgenden Kategorien Artikel versenden.',0),(474372,13177,'en','This Group Cannot Ship Items From The Following Categories',0),(474373,13178,'is','',0),(474374,13178,'dr','Ø§ÛŒÙ† Ú©Ø§Ø±Ø¨Ø± Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ú©Ø§Ù„Ø§Ù‡Ø§ Ø±Ø§ Ø§Ø² Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ Ø²ÛŒØ± Ø§Ø±Ø³Ø§Ù„ Ú©Ù†Ø¯',0),(474375,13178,'pr','Ø§ÛŒÙ† Ú©Ø§Ø±Ø¨Ø± Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ú©Ø§Ù„Ø§Ù‡Ø§ Ø±Ø§ Ø§Ø² Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ Ø²ÛŒØ± Ø§Ø±Ø³Ø§Ù„ Ú©Ù†Ø¯',0),(474376,13178,'tr','Bu kullanÄ±cÄ± aÅŸaÄŸÄ±daki kategorilerden maddeleri sevk edemem',0),(474377,13178,'pl','Ten uÅ¼ytkownik nie statek elementy z nastÄ™pujÄ…cych kategorii',0),(474378,13178,'bg','Ð¢Ð¾Ð·Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸Ñ‚Ðµ Ð¾Ñ‚ ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(474379,13178,'ur','Ø§Ø³ ØµØ§Ø±Ù Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ø²Ù…Ø±ÙˆÚº Ø³Û’ Ø§Ø´ÛŒØ§Ø¡ Ø¬ÛØ§Ø² Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(474380,13178,'sr','ÐžÐ²Ð°Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ð¸Ð· ÑÐ»Ð¸Ñ˜ÐµÐ´ÐµÑ›Ð¸Ñ… ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(474381,13178,'vi','NgÆ°á»i dÃ¹ng nÃ y khÃ´ng thá»ƒ xuáº¥t cÃ¡c máº·t hÃ ng sau Ä‘Ã¢y',0),(474382,13178,'af','Hierdie gebruiker kan Items uit die volgende kategorieÃ« skip',0),(474383,13178,'ro','Acest utilizator nu poate navÄƒ elemente din urmÄƒtoarele categorii de',0),(474384,13178,'et','See kasutaja ei saa lÃ¤hetada kaupu jÃ¤rgmistesse kategooriatesse:',0),(474385,13178,'si','Tega uporabnika ne morete ladje elementi iz naslednjih kategorij',0),(474386,13178,'ba','Pengguna ini tidak dapat kapal barang dari kategori berikut',0),(474387,13178,'nl','Deze gebruiker kan niet verzenden Items uit de volgende categorieÃ«n',0),(474388,13178,'fi','TÃ¤mÃ¤ kÃ¤yttÃ¤jÃ¤ voi aluksen kohteita seuraaviin ryhmiin',0),(474389,13178,'no','Denne brukeren kan ikke levere varer fra fÃ¸lgende kategorier',0),(474390,13178,'da','Denne bruger kan ikke levere varer fra fÃ¸lgende kategorier',0),(474391,13178,'ko','ì´ ì‚¬ìš©ìžëŠ” ë‹¤ìŒê³¼ ê°™ì€ ì¹´í…Œê³ ë¦¬ì—ì„œ ìƒí’ˆì„ ë°°ì†¡ ì—†ìŠµë‹ˆë‹¤.',0),(474392,13178,'he','×ž×©×ª×ž×© ×–×” ×œ× ×™×›×•×œ×”. ×œ×©×œ×•×— ×¤×¨×™×˜×™× ×ž×”×§×˜×’×•×¨×™×•×ª ×”×‘××•×ª',0),(474393,13178,'el','Î‘Ï…Ï„ÏŒÏ‚ Î¿ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ Î´ÎµÎ½ ÏƒÏ„ÎµÎ¯Î»ÎµÏ„Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î±Ï€ÏŒ Ï„Î¹Ï‚ Î±ÎºÏŒÎ»Î¿Ï…Î¸ÎµÏ‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(474394,13178,'zh','æ­¤ç”¨æˆ·ä¸èƒ½ä»Žä»¥ä¸‹ç±»åˆ«èˆ¹èˆ¶é¡¹ç›®',0),(474395,13178,'sv','Den hÃ¤r anvÃ¤ndaren inte kan leverera artiklar frÃ¥n fÃ¶ljande kategorier',0),(474396,13178,'it','Questo utente non puÃ² spedire gli articoli dalle seguenti categorie',0),(474397,13178,'tl','',0),(474398,13178,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ˆà¸²à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰',0),(474399,13178,'hi','à¤‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹ à¤¨à¤¿à¤®à¥à¤¨ à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤¸à¥‡ à¤œà¤¹à¤¾à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(474400,13178,'ms','Pengguna ini tidak boleh menghantar item dari kategori-kategori yang berikut',0),(474401,13178,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø´Ø­Ù† Ø§Ù„Ø£ØµÙ†Ø§Ù Ù…Ù† Ø§Ù„ÙØ¦Ø§Øª Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(474402,13178,'fr','Cet utilisateur ne peut pas expÃ©dier des articles provenant des catÃ©gories suivantes',0),(474403,13178,'jp','ã“ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã¯ã€æ¬¡ã®ã‚«ãƒ†ã‚´ãƒªã‹ã‚‰é …ç›®ã‚’å‡ºè·ã§ãã¾ã›ã‚“ã€‚',0),(474404,13178,'pt','Este usuÃ¡rio nÃ£o pode enviar artigos das seguintes categorias',0),(474405,13178,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÑÑ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¸Ð· ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ñ… ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¹',0),(474406,13178,'es','Este Usuario No Puede Enviar Items De Las Siguentes CategorÃ­as',0),(474407,13178,'de','Dieser Benutzer kann nicht aus den folgenden Kategorien Artikel versenden.',0),(474408,13178,'en','This User Cannot Ship Items From The Following Categories',0),(474409,13179,'is','',0),(474410,13179,'dr','Ø§ÛŒÙ† Ú©Ø§Ø±Ø¨Ø± Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ú©Ø§Ù„Ø§Ù‡Ø§ÛŒ Ø´Ø®ØµÛŒ Ø²ÛŒØ± Ø±Ø§Ø§Ø±Ø³Ø§Ù„ Ú©Ù†Ø¯ ',0),(474411,13179,'pr','Ø§ÛŒÙ† Ú©Ø§Ø±Ø¨Ø± Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ú©Ø§Ù„Ø§Ù‡Ø§ÛŒ Ø´Ø®ØµÛŒ Ø²ÛŒØ± Ø±Ø§Ø§Ø±Ø³Ø§Ù„ Ú©Ù†Ø¯ ',0),(474412,13179,'tr','Bu kullanÄ±cÄ± aÅŸaÄŸÄ±daki Ã¶ÄŸeleri yollanamaz',0),(474413,13179,'pl','Ten uÅ¼ytkownik nie statek nastÄ™pujÄ…ce elementy indywidualne',0),(474414,13179,'bg','Ð¢Ð¾Ð·Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ñ‚Ðµ ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¾Ñ‚Ð´ÐµÐ»Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(474415,13179,'ur','Ø§Ø³ ØµØ§Ø±Ù Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ø§Ù†ÙØ±Ø§Ø¯ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ø¬ÛØ§Ø² Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(474416,13179,'sr','ÐžÐ²Ð°Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚Ð¸ ÑÑ™ÐµÐ´ÐµÑ›Ðµ Ð¿Ð¾Ñ˜ÐµÐ´Ð¸Ð½Ð°Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(474417,13179,'vi','NgÆ°á»i dÃ¹ng nÃ y khÃ´ng thá»ƒ xuáº¥t cÃ¡c máº·t hÃ ng cÃ¡ nhÃ¢n sau.',0),(474418,13179,'af','Hierdie gebruiker kan die volgende individuele Items skip',0),(474419,13179,'ro','Acest utilizator nu poate livra urmÄƒtoarele elemente individuale',0),(474420,13179,'et','See kasutaja ei saa lÃ¤hetada jÃ¤rgmisi punkte',0),(474421,13179,'si','Tega uporabnika ne morete ladje naslednjih posameznih elementov',0),(474422,13179,'ba','Pengguna ini tidak bisa kapal item individu berikut',0),(474423,13179,'nl','Deze gebruiker kan niet de volgende afzonderlijke objecten verzenden',0),(474424,13179,'fi','TÃ¤mÃ¤ kÃ¤yttÃ¤jÃ¤ voi toimittaa seuraavat yksittÃ¤iset tuotteet',0),(474425,13179,'no','Denne brukeren kan ikke levere fÃ¸lgende individuelle elementer',0),(474426,13179,'da','Denne bruger kan ikke skib fÃ¸lgende individuelle produkter',0),(474427,13179,'ko','ì´ ì‚¬ìš©ìžëŠ” ë‹¤ìŒê³¼ ê°™ì€ ê°œë³„ í•­ëª© ë°°ì†¡í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(474428,13179,'he','×ž×©×ª×ž×© ×–×” ×œ× ×™×›×•×œ×”. ×œ×©×œ×•×— ××ª ×”×¤×¨×™×˜×™× ×”×‘×•×“×“×™× ×”×‘××™×',0),(474429,13179,'el','Î‘Ï…Ï„ÏŒÏ‚ Î¿ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ Î´ÎµÎ½ ÏƒÏ„ÎµÎ¯Î»ÎµÏ„Îµ Ï„Î± Î±ÎºÏŒÎ»Î¿Ï…Î¸Î± ÎµÏ€Î¹Î¼Î­ÏÎ¿Ï…Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(474430,13179,'zh','æ­¤ç”¨æˆ·ä¸èƒ½èˆ¹èˆ¶ä¸‹åˆ—å„é¡¹ç‰©å“',0),(474431,13179,'sv','AnvÃ¤ndaren kan inte leverera fÃ¶ljande enskilda produkter',0),(474432,13179,'it','Questo utente non puÃ² spedire i seguenti singoli elementi',0),(474433,13179,'tl','',0),(474434,13179,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¹à¸•à¹ˆà¸¥à¸°à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰',0),(474435,13179,'hi','à¤‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿à¤—à¤¤ à¤†à¤‡à¤Ÿà¤® à¤œà¤¹à¤¾à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(474436,13179,'ms','Pengguna ini tidak menghantar barang-barang individu yang berikut',0),(474437,13179,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø´Ø­Ù† Ø§Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„ÙØ±Ø¯ÙŠØ© Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(474438,13179,'fr','Cet utilisateur ne peut pas expÃ©dier les articles individuels suivants',0),(474439,13179,'jp','ã“ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã¯ã€æ¬¡ã®å€‹ã€… ã®ã‚¢ã‚¤ãƒ†ãƒ ã‚’å‡ºè·ã§ãã¾ã›ã‚“ã€‚',0),(474440,13179,'pt','Este usuÃ¡rio nÃ£o pode enviar os seguintes itens individuais',0),(474441,13179,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÑÑ‚ÑŒ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð¾Ñ‚Ð´ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹',0),(474442,13179,'es','Este Usuario No Puede Enviar Los Siguentes Items Individuales',0),(474443,13179,'de','Dieser Benutzer kann nicht die folgenden einzelnen Elemente Schiff',0),(474444,13179,'en','This User Cannot Ship The Following Individual Items',0),(474445,13180,'is','',0),(474446,13180,'dr','Ø­Ù‚ÙˆÙ‚ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø­Ù…Ù„ Ú©Ø§Ø±Ø¨Ø±',0),(474447,13180,'pr','Ø­Ù‚ÙˆÙ‚ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø­Ù…Ù„ Ú©Ø§Ø±Ø¨Ø±',0),(474448,13180,'tr','Nakliye haklara',0),(474449,13180,'pl','WysyÅ‚ka uprawnieÅ„',0),(474450,13180,'bg','ÐŸÑ€Ð°Ð²Ð° Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(474451,13180,'ur','ØµØ§Ø±Ù Ø´Ù¾Ù†Ú¯ Ø­Ù‚ÙˆÙ‚',0),(474452,13180,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ° Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(474453,13180,'vi','CÃ¡c quyá»n váº­n chuyá»ƒn cá»§a ngÆ°á»i sá»­ dá»¥ng',0),(474454,13180,'af','Gebruiker gestuur regte',0),(474455,13180,'ro','Drepturi maritime',0),(474456,13180,'et','Laevanduse kasutajaÃµigused',0),(474457,13180,'si','Dostava uporabniÅ¡ke pravice',0),(474458,13180,'ba','Hak-hak pengiriman pengguna',0),(474459,13180,'nl','Verzending gebruikersrechten',0),(474460,13180,'fi','Toimitus kÃ¤yttÃ¶oikeudet',0),(474461,13180,'no','Frakt brukerrettigheter',0),(474462,13180,'da','Brugerrettigheder Shipping',0),(474463,13180,'ko','ë°°ì†¡ ê¶Œí•œ',0),(474464,13180,'he','×–×›×•×™×•×ª ×ž×©×ª×ž×© ×ž×©×œ×•×—',0),(474465,13180,'el','Î§ÏÎ®ÏƒÏ„Î· Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(474466,13180,'zh','èˆªè¿çš„ç”¨æˆ·æƒé™',0),(474467,13180,'sv','Frakt anvÃ¤ndarrÃ¤ttigheter',0),(474468,13180,'it','Utente diritti di spedizione',0),(474469,13180,'tl','',0),(474470,13180,'th','à¸à¹ˆà¸­à¸™à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(474471,13180,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(474472,13180,'ms','Hak penghantaran pengguna',0),(474473,13180,'ar','Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(474474,13180,'fr','ExpÃ©dition des droits utilisateur',0),(474475,13180,'jp','é€æ–™ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©åˆ©',0),(474476,13180,'pt','Direitos de navegaÃ§Ã£o do usuÃ¡rio',0),(474477,13180,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ñ€Ð°Ð²Ð° Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(474478,13180,'es','Derechos de EnvÃ­o Del Usuario',0),(474479,13180,'de','Versand Benutzerrechte',0),(474480,13180,'en','User Shipping Rights',0),(474481,13181,'is','',0),(474482,13181,'dr','Ø´Ù…Ø§Ø¨Ø±Ø§ÛŒ ØªÙ†Ø¸ÛŒÙ… Ø­Ù‚ÙˆÙ‚ Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ÛŒØ¯ Ø­Ù‚ÙˆÙ‚ Ú©Ø§Ø±Ø¨Ø± Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ ',0),(474483,13181,'pr','Ø´Ù…Ø§Ø¨Ø±Ø§ÛŒ ØªÙ†Ø¸ÛŒÙ… Ø­Ù‚ÙˆÙ‚ Ú¯Ø±ÙˆÙ‡ Ø¨Ø§ÛŒØ¯ Ø­Ù‚ÙˆÙ‚ Ú©Ø§Ø±Ø¨Ø± Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ ',0),(474484,13181,'tr','KullanÄ±cÄ± haklarÄ± kÃ¼mesi grup haklarÄ± iÃ§in geliÅŸmiÅŸ olmalÄ±dÄ±r',0),(474485,13181,'pl','Musi mieÄ‡ zaawansowane prawa uÅ¼ytkownika do grupy zestaw praw',0),(474486,13181,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐ° Ð½Ð°Ð¿Ñ€ÐµÐ´Ð½Ð°Ð»Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ñ€Ð°Ð²Ð° Ð½Ð°Ð±Ð¾Ñ€ Ð³Ñ€ÑƒÐ¿Ð° Ð¿Ñ€Ð°Ð²Ð°',0),(474487,13181,'ur','Ø¢Ù¾ ØµØ§Ø±Ù Ú©Û’ Ø­Ù‚ÙˆÙ‚ Ù…Ù‚Ø±Ø± Ú¯Ø±ÙˆÙ¾ Ú©Û’ Ø­Ù‚ÙˆÙ‚ Ú©Û’ Ù„Ø¦Û’ Ù¾ÛŒØ´ Ù‚Ø¯Ù…ÛŒ Ú©ÛŒ ÛÛ’ Ø¶Ø±ÙˆØ±',0),(474488,13181,'sr','ÐÐ°Ð¿Ñ€ÐµÐ´Ð¾Ð²Ð°Ð»Ð¸ ÑÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ° Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° ÑÐºÑƒÐ¿ Ð³Ñ€ÑƒÐ¿Ð° Ð¿Ñ€Ð°Ð²Ð°',0),(474489,13181,'vi','Báº¡n pháº£i cÃ³ cÃ¡c quyá»n ngÆ°á»i dÃ¹ng nÃ¢ng cao Ä‘á»ƒ láº­p cÃ¡c quyá»n nhÃ³m',0),(474490,13181,'af','Jy moet gevorderde het gebruikersregte stel groep regte',0),(474491,13181,'ro','Tu trebuie sÄƒ au avansat drepturile de utilizator Set grup drepturile',0),(474492,13181,'et','Teil peab tÃ¤psemad kasutajaÃµiguste komplekti rÃ¼hma Ãµigused',0),(474493,13181,'si','Vi Å¾ivljati napreden uporabniÅ¡ke pravice skupine niz pravic',0),(474494,13181,'ba','Anda harus maju hak-hak pengguna untuk mengatur kelompok HAM',0),(474495,13181,'nl','U moet hebben geavanceerde gebruikersrechten aan Set groepsrechten',0),(474496,13181,'fi','On kehittynyt oikeutta asettaa ryhmÃ¤n oikeudet',0),(474497,13181,'no','Du mÃ¥ ha avansert brukerrettigheter sett gruppe rettigheter',0),(474498,13181,'da','Du skal Have avancerede brugerrettigheder til at angive rettigheder',0),(474499,13181,'ko','ë‹¹ì‹ ì€ ì‚¬ìš©ìž ê¶Œí•œ ì„¤ì • ê·¸ë£¹ ê¶Œë¦¬ëŠ” ê³ ê¸‰',0),(474500,13181,'he','×‘×˜×— ×™×© ×œ×š ×ž×ª×§×“×ž×™× ×–×›×•×™×•×ª ×ž×©×ª×ž×© ×‘×–×›×•×™×•×ª ×§×‘×•×¦×” ×§×‘×•×¦×”',0),(474501,13181,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Ï€ÏÎ¿Î·Î³Î¼Î­Î½ÎµÏ‚ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Ï‡ÏÎ®ÏƒÏ„Î· ÏƒÎµ Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± ÏƒÏÎ½Î¿Î»Î¿ Î¿Î¼Î¬Î´Î±Ï‚',0),(474502,13181,'zh','ä½ å¿…é¡»æ‹¥æœ‰å…ˆè¿›çš„è®¾ç½®ç»„æƒé™çš„ç”¨æˆ·æƒé™',0),(474503,13181,'sv','Du mÃ¥ste ha avancerade anvÃ¤ndarrÃ¤ttigheter till ange rÃ¤ttigheter',0),(474504,13181,'it','Devono avanzati diritti utente ai diritti Set Group',0),(474505,13181,'tl','',0),(474506,13181,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸ªà¸¹à¸‡à¸ªà¸´à¸—à¸˜à¸´à¸Šà¸¸à¸” à¸à¸¥à¸¸à¹ˆà¸¡à¸ªà¸´à¸—à¸˜à¸´à¹Œà¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(474507,13181,'hi','à¤†à¤ª à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤¸à¥‡à¤Ÿ à¤¸à¤®à¥‚à¤¹ à¤…à¤§à¤¿à¤•à¤¾à¤° à¤•à¥‹ à¤‰à¤¨à¥à¤¨à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(474508,13181,'ms','Anda mesti mempunyai lanjutan hak pengguna terhadap hak-hak Kumpulan Set',0),(474509,13181,'ar','ÙŠØ¬Ø¨ Ø£Ù† Ù„Ø¯ÙŠÙƒ Ø­Ù‚ÙˆÙ‚ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù„ØªØ¹ÙŠÙŠÙ† Ù…Ø¬Ù…ÙˆØ¹Ø© Ø­Ù‚ÙˆÙ‚ Ù…ØªÙ‚Ø¯Ù…Ø©',0),(474510,13181,'fr','Vous devez ont avancÃ© droits d\'utilisateur pour les droits de jeu de groupe',0),(474511,13181,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼æ¨©åˆ©ã‚»ãƒƒãƒˆ ã‚°ãƒ«ãƒ¼ãƒ—æ¨©ã‚’é«˜åº¦ãªãŒã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(474512,13181,'pt','VocÃª deve ter avanÃ§ado direitos de usuÃ¡rio ao grupo conjunto de direitos',0),(474513,13181,'ru','Ð Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ñ€Ð°Ð²Ð° Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð½Ð°Ð±Ð¾Ñ€ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ð¿Ñ€Ð°Ð²',0),(474514,13181,'es','Debe Tener Derechos de Usuario Avanzados Para Configurar Derechos Del Grupo',0),(474515,13181,'de','Sie mÃ¼ssen erweiterte Benutzerrechte Set Gruppenrechte',0),(474516,13181,'en','You Must Have Advanced User Rights To Set Group Rights',0),(474517,13182,'is','',0),(474518,13182,'dr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ù†Ø¬Ø§Ù…',0),(474519,13182,'pr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ù†Ø¬Ø§Ù…',0),(474520,13182,'tr','Fulfillment sipariÅŸler temizle',0),(474521,13182,'pl','PrzeczyÅ›Ä‡ realizacji zamÃ³wienia',0),(474522,13182,'bg','ÐŸÑ€Ð¾Ð´ÑƒÑ…Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(474523,13182,'ur','ØªÚ©Ù…ÛŒÙ„ Ø­Ú©Ù… Ù¾Ø§Ú©',0),(474524,13182,'sr','ÐžÑ‡Ð¸ÑÑ‚Ð¸ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(474525,13182,'vi','Ä‘iá»n Ä‘Æ¡n hÃ ng trá»‘ng',0),(474526,13182,'af','Vee nakoming Orders permanent uit',0),(474527,13182,'ro','Epurare Ã®ndeplinirea comenzilor',0),(474528,13182,'et','Likvideeri plaanitud tellimused',0),(474529,13182,'si','Purge izpolnitev naroÄila',0),(474530,13182,'ba','Membersihkan pemenuhan order',0),(474531,13182,'nl','Purge vervulling Orders',0),(474532,13182,'fi','Puhallus tÃ¤yttÃ¤minen tilaukset',0),(474533,13182,'no','TÃ¸mme fullfÃ¸ringen bestillinger',0),(474534,13182,'da','Rense opfyldelse ordrer',0),(474535,13182,'ko','ì´ í–‰ ëª…ë ¹ ì œê±°',0),(474536,13182,'he','× ×§×” ×ž×™×ž×•×© ×”×–×ž× ×•×ª',0),(474537,13182,'el','Î•ÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ· ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(474538,13182,'zh','æ¸…é™¤å®Œæˆè®¢å•',0),(474539,13182,'sv','Rensa uppfyllelse order',0),(474540,13182,'it','Purga evasione ordini',0),(474541,13182,'tl','',0),(474542,13182,'th','à¸¥à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(474543,13182,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤ªà¤°à¥à¤œ',0),(474544,13182,'ms','Singkir memenuhi perintah',0),(474545,13182,'ar','Ø¥Ø²Ø§Ù„Ø© Ø£ÙˆØ§Ù…Ø± Ø§Ù„ÙˆÙØ§Ø¡',0),(474546,13182,'fr','Purge des ordres',0),(474547,13182,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ãƒ» ã‚ªãƒ¼ãƒ€ãƒ¼ã‚’ãƒ‘ãƒ¼ã‚¸ã—ã¾ã™ã€‚',0),(474548,13182,'pt','Purgar o ordens de cumprimento',0),(474549,13182,'ru','ÐžÑ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(474550,13182,'es','Purgar Ordenes de Cumplimiento',0),(474551,13182,'de','Fulfillment-Bestellungen lÃ¶schen',0),(474552,13182,'en','Purge Fulfillment Orders',0),(474553,13183,'is','',0),(474554,13183,'dr','TBD',0),(474555,13183,'pr','TBD',0),(474556,13183,'tr','TBD',0),(474557,13183,'pl','TBD',0),(474558,13183,'bg','TBD',0),(474559,13183,'ur','Ù¹Ø¨Ø¯',0),(474560,13183,'sr','Ð¢Ð‘Ð”',0),(474561,13183,'vi','TBD',0),(474562,13183,'af','TBD',0),(474563,13183,'ro','TBD',0),(474564,13183,'et','TBD',0),(474565,13183,'si','TBD',0),(474566,13183,'ba','TBD',0),(474567,13183,'nl','TBD',0),(474568,13183,'fi','TBD',0),(474569,13183,'no','TBD',0),(474570,13183,'da','TBD',0),(474571,13183,'ko','ë¯¸ì •',0),(474572,13183,'he','TBD',0),(474573,13183,'el','TBD',0),(474574,13183,'zh','TBD',0),(474575,13183,'sv','TBD',0),(474576,13183,'it','TBD',0),(474577,13183,'tl','',0),(474578,13183,'th','TBD',0),(474579,13183,'hi','TBD',0),(474580,13183,'ms','TBD DETAILS',0),(474581,13183,'ar','Ø§Ù„Ø±Ø§ØªØ¨',0),(474582,13183,'fr','TBD',0),(474583,13183,'jp','æœªå®š',0),(474584,13183,'pt','TBD',0),(474585,13183,'ru','TBD',0),(474586,13183,'es','TBD',0),(474587,13183,'de','TBD',0),(474588,13183,'en','TBD',0),(474589,13184,'is','',0),(474590,13184,'dr','.Ù„Ø·ÙØ§ÙØ±Ø¯Ø§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÛŒ Ú©Ù†ÛŒØ¯ ÛŒØ§ Ø¨Ø§ Ù¾Ø´ØªÛŒØ¨Ø§Ù† ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯.',0),(474591,13184,'pr','Ø´Ù…Ø§ ØªØ¹Ø¯Ø§Ø¯Ú©Ø§Ù„Ø§ÛŒ Ø²ÛŒØ§Ø¯ÛŒ Ø±Ø§ Ø§Ø² Ø¯Ø³Øª Ø¯Ø§Ø¯Ù‡ Ø§ÛŒØ¯ ØªØ§ Ù¾Ø³ÙˆØ±Ø¯ Ø®ÙˆØ¯ Ø±Ø§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ ØªÙ†Ø¸ÛŒÙ… Ú©Ù†ÛŒØ¯.Ù„Ø·ÙØ§ÙØ±Ø¯Ø§ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø³Ø¹ÛŒ Ú©Ù†ÛŒØ¯ ÛŒØ§ Ø¨Ø§ Ù¾Ø´ØªÛŒØ¨Ø§Ù† ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯.',0),(474592,13184,'tr','Åžifrenizi sÄ±fÄ±rlamak iÃ§in de birÃ§ok kez baÅŸarÄ±sÄ±z oldu...<br>LÃ¼tfen yarÄ±n tekrar deneyin veya desteÄŸe baÅŸvurabilirsiniz.',0),(474593,13184,'pl','Zbyt wiele razy udaÅ‚o siÄ™ zresetowaÄ‡ hasÅ‚o...<br>ProszÄ™ sprÃ³bowaÄ‡ ponownie jutro, lub skontaktowaÄ‡ siÄ™ z obsÅ‚ugÄ….',0),(474594,13184,'bg','ÐÐµ ÑÐ° Ð¿Ñ€ÐµÐºÐ°Ð»ÐµÐ½Ð¾ Ð¼Ð½Ð¾Ð³Ð¾ Ð¿ÑŠÑ‚Ð¸ Ð´Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð°Ñ‚Ð° ÑÐ¸...<br>ÐžÐ¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¿Ð°Ðº ÑƒÑ‚Ñ€Ðµ Ð¸Ð»Ð¸ ÑÐµ ÑÐ²ÑŠÑ€Ð¶ÐµÑ‚Ðµ Ñ Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°Ñ‚Ð°.',0),(474595,13184,'ur','Ø¢Ù¾ Ù…ØªØ¹Ø¯Ø¯ Ø¨Ø§Ø± Ø§Ù¾Ù†Ø§ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛÛ’ ÛÛŒÚº...<br>Ú©Ù„ Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº ÛŒØ§ ØªØ¹Ø§ÙˆÙ† Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº Û”',0),(474596,13184,'sr','ÐœÐ½Ð¾Ð³Ð¾ Ð¿ÑƒÑ‚Ð° Ð½Ð¸ÑÐ¸ ÑƒÑÐ¿ÐµÐ¾ Ð´Ð° Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð¸ Ð²Ð°ÑˆÑƒ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ...<br>ÐŸÐ¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ ÑÑƒÑ‚Ñ€Ð° Ð¿Ð¾Ð½Ð¾Ð²Ð¾ Ð¸Ð»Ð¸ ÑÐµ Ð¾Ð±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´Ñ€ÑˆÑ†Ð¸.',0),(474597,13184,'vi','Báº¡n Ä‘Ã£ quÃ¡ nhiá»u láº§n khÃ´ng thÃ nh Ä‘á»ƒ thiáº¿t láº­p láº¡i máº­t kháº©u cá»§a báº¡n ...  Xin vui lÃ²ng thá»­ láº¡i vÃ o ngÃ y mai hoáº·c liÃªn láº¡c há»— trá»£.',0),(474598,13184,'af','Jy het te veel kere misluk om jou wagwoord te herstel...<br>Probeer weer mÃ´re of kontak ondersteuning.',0),(474599,13184,'ro','Au eÅŸuat prea multe ori pentru a reseta parola...<br>VÄƒ rugÄƒm sÄƒ Ã®ncercaÅ£i din nou mÃ¢ine sau contactaÅ£i asistenÅ£a.',0),(474600,13184,'et','Parooli lÃ¤htestamine on nurjus liiga palju kordi...<br>Proovige homme uuesti vÃµi pÃ¶Ã¶rduge tugiteenuse poole.',0),(474601,13184,'si','PreveÄkrat ni uspelo, da ponastavite geslo...<br>Poskusite spet jutri ali pa se obrnite na podporo.',0),(474602,13184,'ba','Anda telah gagal berkali-kali untuk membuat ulang sandi...<br>Silakan mencoba lagi besok atau menghubungi dukungan.',0),(474603,13184,'nl','Ook vele malen hebt u uw wachtwoord opnieuw instellen...<br>Probeer het morgen opnieuw of neem contact op met ondersteuning.',0),(474604,13184,'fi','Salasanan vaihtaminen on epÃ¤onnistunut liian monta kertaa...<br>YritÃ¤ huomenna uudelleen tai ota yhteyttÃ¤ tukeen.',0),(474605,13184,'no','Du har mislyktes for mange ganger Ã¥ tilbakestille passordet...<br>PrÃ¸v igjen i morgen eller kontakte kundestÃ¸tte.',0),(474606,13184,'da','Du har mislykkedes for mange gange til at nulstille din adgangskode...<br>Behage prÃ¸ve igen imorgen eller kontakte support.',0),(474607,13184,'ko','ë‹¹ì‹ ì€ ë¹„ë°€ ë²ˆí˜¸ë¥¼ ìž¬ì„¤ì • í•˜ë ¤ë©´ ë„ˆë¬´ ë§Žì€ ì‹œê°„ ì‹¤íŒ¨ í•œ...<br>ì œë°œ ë‚´ì¼ ë‹¤ì‹œ ì‹œë„ í•˜ê±°ë‚˜ ì§€ì› ì„œë¹„ìŠ¤ì— ë¬¸ì˜ í•©ë‹ˆë‹¤.',0),(474608,13184,'he','× ×›×©×œ×ª ×¤×¢×ž×™× ×¨×‘×•×ª ×ž×“×™ ×œ××™×¤×•×¡ ×”×¡×™×¡×ž×” ×©×œ×š...<br>× ×¡×” ×©×•×‘ ×ž×—×¨ ××• ×œ×¤× ×•×ª ×œ×ž×—×œ×§×ª ×”×ª×ž×™×›×”.',0),(474609,13184,'el','Î Î¬ÏÎ± Ï€Î¿Î»Î»Î­Ï‚ Ï†Î¿ÏÎ­Ï‚ Î­Ï‡ÎµÏ„Îµ Î±Ï€Î¿Ï„ÏÏ‡ÎµÎ¹ Î½Î± ÎµÏ€Î±Î½Î±Ï†Î­ÏÎµÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚...<br>Î”Î¿ÎºÎ¹Î¼Î¬ÏƒÏ„Îµ Ï€Î¬Î»Î¹ Î±ÏÏÎ¹Î¿ Î® ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î®ÏƒÏ„Îµ Î¼Îµ Ï„Î·Î½ Ï…Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î·.',0),(474610,13184,'zh','æœ‰å¤±è´¥æ¬¡æ•°å¤ªå¤šè¦é‡ç½®æ‚¨çš„å¯†ç ...<br>è¯·æ˜Žå¤©å†è¯•ï¼Œæˆ–ä¸Žæ”¯æŒéƒ¨é—¨è”ç³»ã€‚',0),(474611,13184,'sv','Du har misslyckats fÃ¶r mÃ¥nga gÃ¥nger att Ã¥terstÃ¤lla ditt lÃ¶senord...<br>FÃ¶rsÃ¶k igen i morgon eller kontakta support.',0),(474612,13184,'it','Hai fallito troppe volte reimpostare la password...<br>Si prega di provare domani o contattare il supporto.',0),(474613,13184,'tl','',0),(474614,13184,'th','à¸„à¸¸à¸“à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§à¸«à¸¥à¸²à¸¢à¸„à¸£à¸±à¹‰à¸‡à¹€à¸žà¸·à¹ˆà¸­à¸£à¸µà¹€à¸‹à¹‡à¸•à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸‚à¸­à¸‡à¸„à¸¸à¸“...<br>à¸à¸£à¸¸à¸“à¸²à¸¥à¸­à¸‡à¸­à¸µà¸à¸„à¸£à¸±à¹‰à¸‡à¸žà¸£à¸¸à¹ˆà¸‡à¸™à¸µà¹‰ à¸«à¸£à¸·à¸­à¸•à¸´à¸”à¸•à¹ˆà¸­à¸à¹ˆà¸²à¸¢à',0),(474615,13184,'hi','à¤†à¤ª à¤…à¤ªà¤¨à¥‡ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤•à¥‹ à¤°à¥€à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥€ à¤•à¤ˆ à¤¬à¤¾à¤° à¤µà¤¿à¤«à¤² à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚...<br>à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤² à¤«à¤¿à¤° à¤¸à¥‡ à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤¸à¤®à¤°à¥à¤¥à¤¨',0),(474616,13184,'ms','Anda telah gagal terlalu banyak kali untuk set semula kata laluan anda...<br>Sila cuba lagi esok atau hubungi sokongan.',0),(474617,13184,'ar','ÙˆÙ‚Ø¯ ÙØ´Ù„Øª ÙÙŠ Ù…Ø±Ø§Øª ÙƒØ«ÙŠØ±Ø© Ø¬Ø¯Ø§Ù‹ Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ...<br>ÙŠØ±Ø¬Ù‰ Ø§Ù„Ù…Ø­Ø§ÙˆÙ„Ø© Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ ØºØ¯Ø§ Ø£Ùˆ Ø§Ù„Ø§ØªØµØ§Ù„ Ø¨Ø§Ù„Ø¯Ø¹Ù….',0),(474618,13184,'fr','Vous n\'avez pas trop de fois rÃ©initialiser votre mot de passe...<br>S\'il vous plaÃ®t essayer Ã  nouveau demain, ou contactez le support.',0),(474619,13184,'jp','ä½•å›žã‚‚ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®ãƒªã‚»ãƒƒãƒˆã«å¤±æ•—ã—ãŸ.<br>æ˜Žæ—¥ã‚‚ã†ä¸€åº¦è©¦ã™ã‹ã€ã‚µãƒãƒ¼ãƒˆã«ãŠå•ã„åˆã‚ã›ãã ã•ã„ã€‚',0),(474620,13184,'pt','NÃ£o conseguiu muitas vezes redefinir sua senha...<br>Por favor, tente de novo amanhÃ£ ou contate o suporte.',0),(474621,13184,'ru','Ð’Ñ‹ Ð½Ðµ ÑÐ¼Ð¾Ð³Ð»Ð¸ ÑÐ±Ñ€Ð¾ÑÐ¸Ñ‚ÑŒ Ð²Ð°Ñˆ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ ÑÐ»Ð¸ÑˆÐºÐ¾Ð¼ Ð¼Ð½Ð¾Ð³Ð¾ Ñ€Ð°Ð·...<br>ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ð¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÑÐ½Ð¾Ð²Ð° Ð·Ð°Ð²Ñ‚Ñ€Ð°, Ð¸Ð»Ð¸ Ð¾Ð±Ñ€Ð°Ñ‚Ð¸Ñ‚ÐµÑÑŒ Ð² ÑÐ»ÑƒÐ¶Ð±Ñƒ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ¸.',0),(474622,13184,'es','Has fallado demasiado veces para reconfigura su password...Por favor intenta otra vez maÃ±ana o comunica con soporte.',0),(474623,13184,'de','Du hast zu oft versagt, um Ihr Passwort zurÃ¼ckzusetzen...<br>Bitte versuchen Sie es morgen wieder oder Support.',0),(474624,13184,'en','You have failed too many times to reset your password...<br>Please try again tomorrow or contact support.',0),(474625,13185,'is','',0),(474626,13185,'dr','{USER} Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø³Ø§ÛŒØª \'{SERVER_NAME}  ',0),(474627,13185,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø±ÛŒØ³Øª Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± {USER} Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø³Ø§ÛŒØª \'{SERVER_NAME}  ',0),(474628,13185,'tr','<p>Siteye \'{sunucu_adÄ±}\' kullanÄ±cÄ± \'{USER}\' parola sÄ±fÄ±rlama isteÄŸi yapÄ±ldÄ±ÄŸÄ± yeri</p><p>Devam etmek iÃ§in bu baÄŸlantÄ±yÄ± tÄ±klatÄ±n:</p><p><a href=\"{URL}\">{URL}</a></p><p>Ä°stek IP: {IP}</p>',0),(474629,13185,'pl','<p>Å»Ä…danie resetowania hasÅ‚a dla uÅ¼ytkownika \"{}\" zostaÅ‚ zÅ‚oÅ¼ony do strony {SERVER_NAME}</p><p>Kliknij ten link, aby kontynuowaÄ‡:</p><p><a href=\"{URL}\">{URL}</a></p><p>Wniosek z IP: {IP}</p>',0),(474630,13185,'bg','<p>Ð• Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÐ½Ð¾ Ð¸ÑÐºÐ°Ð½Ðµ Ð·Ð° Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð·Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» \"ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» {}\" Ð² ÑÐ°Ð¹Ñ‚Ð° \"{SERVER_NAME}\"</p><p>Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ñ‚Ð°Ð·Ð¸ Ð²Ñ€ÑŠÐ·ÐºÐ° Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸Ñ‚Ðµ:</p><p><',0),(474631,13185,'ur','<p>Ø§ÛŒÚ© Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø§Ø¦Û’ ØµØ§Ø±Ù {ØµØ§Ø±Ù} {SERVER_NAME} Ø§Ø³ Ø³Ø§Ø¦Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ø¨Ù†Ø§Ø¦ÛŒ Ú¯Ø¦ÛŒ ÛÛ’</p><p>Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ Ù„Ù†Ú© Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº:</p><p><a href=\"{URL}\">{URL}</a>',0),(474632,13185,'sr','<p>ÐœÐ¾Ð»Ð±Ð° Ð·Ð° Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ Ð·Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° \"{ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº}\" Ð¾ÑÑ‚Ð²Ð°Ñ€ÐµÐ½ Ñ˜Ðµ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ \'{Ð¸Ð¼Ðµ_ÑÐµÑ€Ð²ÐµÑ€Ð°}\'</p><p>ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð¾Ð²Ñƒ Ð²ÐµÐ·Ñƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸:</p>',0),(474633,13185,'vi','<p>Ä‘á» nghá»‹ táº¡o láº¡i máº­t kháº©u A cho ngÆ°á»i sá»­ dá»¥ng \'{NgÆ°á»i sá»­ dá»¥ng}\' Ä‘Æ°á»£c lÃ m táº¡i vá»‹ trÃ­\'{TÃªn mÃ¡y chá»§}\'</p><p> kÃ­ch vÃ o Ä‘Æ°á»ng dáº«n dÆ°á»›i Ä‘á»ƒ tiáº¿p tá»¥c:</p><p>{URL}</p><p>Äá» nghá»‹ tá»« IP: {IP}</p>',0),(474634,13185,'af','<p>\'N wagwoord terugstel versoek vir gebruiker \'{gebruiker}\' gemaak is na die webwerf \'{SERVER_NAME}\'</p><p>Klik hierdie skakel om voort te gaan:</p><p><a href=\"{URL}\">{URL}</a></p><p>Versoek van IP: {IP}</p>',0),(474635,13185,'ro','<p>O cerere de resetare parola de utilizator \'{utilizator}\' a fost fÄƒcutÄƒ la site-ul \"{nume_server}\"</p><p>FaceÅ£i clic pe acest link pentru a continua:</p><p><a href=\"{URL}\">{URL}</a></p><p>Cerere de la IP: {IP}</p>',0),(474636,13185,'et','<p>Parooli lÃ¤htestamise taotlus kasutaja {kasutaja} on teinud saidile {serveri_nimi}</p><p>KlÃµpsake linki Edasi:</p><p><a href=\"{URL}\">{URL}</a></p><p>Taotluse IP: {IP}</p>',0),(474637,13185,'si','<p>Ponastavitev zahteva geslo za uporabnika {uporabnik} je mesto {SERVER_NAME}</p><p>Kliknite to povezavo za nadaljevanje:</p><p><a href=\"{URL}\">{SPLETNI NASLOV}</a></p><p>Zahteva od IP: {IP}</p>',0),(474638,13185,'ba','<p>Permintaan ulang sandi untuk pengguna \'{pengguna}\' telah dibuat ke situs \'{SERVER_NAME}\'</p><p>Klik link ini untuk melanjutkan:</p><p><a href=\"{URL}\">{URL}</a></p><p>Permintaan dari IP: {IP}</p>',0),(474639,13185,'nl','<p>Een wachtwoord reset verzoek voor gebruiker \'{gebruiker}\' is geboekt naar de site \'{servernaam}\'</p><p>Klik op deze link om door te gaan:</p><p><a href=\"{URL}\">{URL}</a></p><p>Verzoek van IP: {IP}</p>',0),(474640,13185,'fi','<p>Uusi salasana kÃ¤yttÃ¤jÃ¤lle {kÃ¤yttÃ¤jÃ¤} on tehnyt sivuston {palvelimen_nimi}</p><p>Napsauttamalla tÃ¤tÃ¤ linkkiÃ¤:</p><p><a href=\"{URL}\">{URL}</a></p><p>PyyntÃ¶ IP: {IP}</p>',0),(474641,13185,'no','<p>Passord tilbakestillingsforespÃ¸rsel om brukeren \"{USER}\" har blitt gjort for webomrÃ¥det \"{servernavn}\"</p><p>Klikk denne koblingen for Ã¥ fortsette:</p><p><a href=\"{URL}\">{URL}</a></p><p>ForespÃ¸rsel fra IP: {IP}</p>',0),(474642,13185,'da','<p>Der er sket en password reset anmodning for brugeren \'{USER}\' til webstedet \'{SERVER_NAME}\'</p><p>Klik pÃ¥ dette link for at fortsÃ¦tte:</p><p><a href=\"{URL}\">{URL}</a></p><p>Anmodning fra IP: {IP}</p>',0),(474643,13185,'ko','<p>\'{SERVER_NAME}\' ì‚¬ì´íŠ¸ì— \' {ì‚¬ìš©ìž}\'ì— ëŒ€ í•œ ì•”í˜¸ ìž¬ì„¤ì • ìš”ì²­ì´ í–ˆë‹¤</p><p>ê³„ì† í•˜ë ¤ë©´ì´ ë§í¬ë¥¼ í´ë¦­ í•©ë‹ˆë‹¤.</p><p><a href=\"{URL}\">{URL}</a></p><p>IP ìš”ì²­: {IP}</p>',0),(474644,13185,'he','<p>×‘×§×©×ª ××™×¤×•×¡ ×¡×™×¡×ž×” ×¢×‘×•×¨ ×ž×©×ª×ž×© \'{×ž×©×ª×ž×©}\' ×”×¤×š ×œ××ª×¨ \"{SERVER_NAME}\"</p><p>×œ×—×¥ ×¢×œ ×§×™×©×•×¨ ×–×” ×›×“×™ ×œ×”×ž×©×™×š:</p><p><a href=\"{URL}\">{×›×ª×•×‘×ª URL}</a></p><p>×‘×§×©×” ×ž- IP: {IP}</p>',0),(474645,13185,'el','<p>ÎˆÏ‡ÎµÎ¹ Î³Î¯Î½ÎµÎ¹ Î±Î¯Ï„Î·ÏƒÎ· ÎµÏ€Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ ÎºÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î· \'{Î§Î¡Î‰Î£Î¤Î—Î£}\' ÏƒÏ„Î·Î½ Ï€ÎµÏÎ¹Î¿Ï‡Î® Â«ÎŒÎ½Î¿Î¼Î±_Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î® {}Â»</p><p>ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ ÏƒÏÎ½Î´ÎµÏƒÎ',0),(474646,13185,'zh','<p>\'{USER}\' ç”¨æˆ·å¯†ç é‡ç½®è¯·æ±‚å·²å‘è¯¥ç½‘ç«™ \'{SERVER_NAME}\'</p><p>è¯·å•å‡»æ­¤é“¾æŽ¥ä»¥ç»§ç»­ï¼š</p><p><a href=\"{URL}\">{URL}</a></p><p>ä»Ž ip åœ°å€çš„è¯·æ±‚ï¼š {IP}</p>',0),(474647,13185,'sv','<p>En begÃ¤ran om lÃ¶senord Ã¥terstÃ¤llning fÃ¶r anvÃ¤ndaren \'{USER}\' har gjorts pÃ¥ webbplatsen \"{SERVER_NAME}\"</p><p>Klicka pÃ¥ denna lÃ¤nk fÃ¶r att fortsÃ¤tta:</p><p><a href=\"{URL}\">{URL}</a></p><p>BegÃ¤ran frÃ¥n IP: {IP}</p>',0),(474648,13185,'it','<p>Una richiesta di reimpostazione password per l\'utente \'{}\' utente Ã¨ stato fatto per il sito \'{nome_server}\'</p><p>Clicca su questo link per continuare:</p><p><a href=\"{URL}\">{URL}</a></p><p>Richiesta da IP: {IP}</p>',0),(474649,13185,'tl','',0),(474650,13185,'th','<p>à¸—à¸³à¸„à¸³à¸‚à¸­à¸•à¸±à¹‰à¸‡à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰ \'{à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰}\' à¹„à¸› \'{SERVER_NAME }\'</p><p>à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸¥à¸´à¸‡à¸„à¹Œà¸™à¸µà¹‰à¹€à¸žà¸·à¹ˆà¸­à¸”à¸³à¹€à¸™à¸´à¸™à¸•à¹ˆà¸­:</p><p><a href=\"{URL',0),(474651,13185,'hi','<p>à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ \'{à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾}\' à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤°à¥€à¤¸à¥‡à¤Ÿ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤¾à¤‡à¤Ÿ \'{SERVER_NAME}\' à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ</p><p>à¤œà¤¾à¤°à¥€ à¤°à¤–à¤¨à',0),(474652,13185,'ms','<p>Permintaan set semula kata laluan untuk pengguna \'{}\' pengguna telah dibuat ke tapak \'{SERVER_NAME}\'</p><p>Klik pautan ini untuk meneruskan:</p><p><a href=\"{URL}\">{URL}</a></p><p>Permintaan dari IP: {IP}</p>',0),(474653,13185,'ar','<p>ÙˆÙ‚Ø¯ Ø£Ø­Ø±Ø² Ø·Ù„Ø¨ Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù… \'{Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…}\' Ø¥Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ \'{Ø§Ø³Ù… _ Ø§Ù„Ù…Ù„Ù‚Ù…}\'</p><p>Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù‡Ø°Ø§ Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø· Ù„Ù…ÙˆØ§ØµÙ„Ø©:</p><p><a href=\"{URL}\">{Ø¹Ù†ÙˆØ§Ù†}</a></p><p>Ø·',0),(474654,13185,'fr','<p>Une demande de rÃ©initialisation de mot de passe pour l\'utilisateur Â« {USER} Â» a Ã©tÃ© dÃ©posÃ©e auprÃ¨s du site Â« {nom_serveur} Â»</p><p>Cliquez sur ce lien pour continuer :</p><p><a href=\"{URL}\">{URL}</a></p><p>Demande d\'adresse IP: {IP}</p>',0),(474655,13185,'jp','<p>ã‚µã‚¤ãƒˆ \'{ã‚µãƒ¼ãƒãƒ¼å}\' ã‚’ãƒ¦ãƒ¼ã‚¶ãƒ¼ \' {}\' ã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®ãƒªã‚»ãƒƒãƒˆè¦æ±‚ã‚’ã—ã¾ã—ãŸ</p><p>ã“ã®ãƒªãƒ³ã‚¯ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ç¶šã‘ã¾ã™ã€‚</p><p><a href=\"{URL}\">{URL}</a></p><p>Ip ã‚¢ãƒ‰ãƒ¬ã‚¹ã‹ã‚‰ã®è¦æ±‚: {IP}</p>',0),(474656,13185,'pt','<p>Foi feita uma solicitaÃ§Ã£o de redefiniÃ§Ã£o de senha para usuÃ¡rio \'{usuÃ¡rio}\' o site \'{nome_servidor}\'</p><p>Clique neste link para continuar:</p><p><a href=\"{URL}\">{URL}</a></p><p>Pedido de IP: {IP}</p>',0),(474657,13185,'ru','<p>Ð‘Ñ‹Ð» Ð´Ð¾ÑÑ‚Ð¸Ð³Ð½ÑƒÑ‚ Ð·Ð°Ð¿Ñ€Ð¾Ñ ÑÐ±Ñ€Ð¾ÑÐ° Ð¿Ð°Ñ€Ð¾Ð»Ñ Ð´Ð»Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Â«{USER}Â» Ð½Ð° ÑÐ°Ð¹Ñ‚Ðµ Â«{Ð¸Ð¼Ñ_ÑÐµÑ€Ð²ÐµÑ€Ð°}Â»</p><p>Ð©ÐµÐ»ÐºÐ½Ð¸Ñ‚Ðµ ÑÑ‚Ñƒ ÑÑÑ‹Ð»ÐºÑƒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÑŒ:</p><p><a href=\"{URL}\">{',0),(474658,13185,'es','<p>Una solicitaciÃ³n por una reconfiguraciÃ³n de password par el usuario \'{USUARIO}\'se habÃ­a hecho al sitio \'{NOMBRE DE SERVIDO}\'</p><p>Clic este vinculo para continuar:</p><p>{URL}</p><p>PeticiÃ³n Del IP: {IP}</p>',0),(474659,13185,'de','<p>Kennwort hat zurÃ¼cksetzen fÃ¼r Benutzer \'{USER}\' auf der Website \'{Servername}\' gestellt wurde</p><p>Klicken Sie hier um fortzufahren:</p><p><a href=\"{URL}\">{URL}</a></p><p>Anfrage von IP: {IP}</p>',0),(474660,13185,'en','<p>A password reset request for user \'{USER}\' has been made to the site \'{SERVER_NAME}\'</p><p>Click this link to continue:</p><p><a href=\"{URL}\">{URL}</a></p><p>Request From IP: {IP}</p>',0),(474661,13186,'is','',0),(474662,13186,'dr','{USER} Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø³Ø§ÛŒØª \'{SERVER_NAME} Ø³Ø§Ø®ØªÙ‡ Ø´Ø¯Ù‡ Ø§Ø³Øª  <P> Ø§ÛŒÙ† ÛŒÙˆØ²Ø± Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø¯Ø§Ø±Ø¯. Ù„Ø·ÙØ§ Ø¨Ø§ Ù…Ø¯ÛŒØ± Ø®ÙˆØ¯ ØªÙ…Ø§Ø³',0),(474663,13186,'pr','Ø±Ø®ÙˆØ§Ø³Øª Ø±ÛŒØ³Øª Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± {USER} Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø³Ø§ÛŒØª \'{SERVER_NAME} Ø³Ø§Ø®ØªÙ‡ Ø´Ø¯Ù‡ Ø§Ø³Øª  <P> Ø§ÛŒÙ† Ú©Ø§Ø±Ø¨Ø± Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø¯Ø§Ø±Ø¯. Ù„Ø·ÙØ§ Ø¨Ø§ Ù…Ø¯ÛŒØ± Ø®ÙˆØ¯ ØªÙ…Ø§Ø³',0),(474664,13186,'tr','<p>Siteye \'{sunucu_adÄ±}\' kullanÄ±cÄ± \'{USER}\' parola sÄ±fÄ±rlama isteÄŸi yapÄ±ldÄ±ÄŸÄ± yeri</p><p>Bu kullanÄ±cÄ±nÄ±n parolasÄ±nÄ± sÄ±fÄ±rlamak iÃ§in ayrÄ±calÄ±klarÄ± yok.  LÃ¼tfen yÃ¶neticinize baÅŸvurun.</p><p>Ä°stek IP: {IP}</p>',0),(474665,13186,'pl','<p>Å»Ä…danie resetowania hasÅ‚a dla uÅ¼ytkownika \"{}\" zostaÅ‚ zÅ‚oÅ¼ony do strony {SERVER_NAME}</p><p>Ten uÅ¼ytkownik nie ma uprawnieÅ„, aby zresetowaÄ‡ hasÅ‚o.  Skontaktuj siÄ™ z administratorem.</p><p>Wniosek z IP: {IP}</p>',0),(474666,13186,'bg','<p>Ð• Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÐ½Ð¾ Ð¸ÑÐºÐ°Ð½Ðµ Ð·Ð° Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð·Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» \"ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» {}\" Ð² ÑÐ°Ð¹Ñ‚Ð° \"{SERVER_NAME}\"</p><p>Ð¢Ð¾Ð·Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð½ÑÐ¼Ð° Ð¿Ñ€Ð°Ð²Ð° Ð·Ð° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° ',0),(474667,13186,'ur','<p>Ø§ÛŒÚ© Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø§Ø¦Û’ ØµØ§Ø±Ù {ØµØ§Ø±Ù} {SERVER_NAME} Ø§Ø³ Ø³Ø§Ø¦Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ø¨Ù†Ø§Ø¦ÛŒ Ú¯Ø¦ÛŒ ÛÛ’</p><p>Ø§Ø³ ØµØ§Ø±Ù Ú©Û’ Ù¾Ø§Ø³ÙˆØ±Úˆ Ú©Ùˆ Ø¯ÙˆØ¨Ø§Ø±Û Ø³ÛŒÙ¹ Ú©Ø±Ù†Û’ Ú©Ø§ Ø­Ù‚ Ù†ÛÛŒÚº Ø±Ú©Ú¾ØªØ§ Û',0),(474668,13186,'sr','<p>ÐœÐ¾Ð»Ð±Ð° Ð·Ð° Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ Ð·Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° \"{ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº}\" Ð¾ÑÑ‚Ð²Ð°Ñ€ÐµÐ½ Ñ˜Ðµ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ \'{Ð¸Ð¼Ðµ_ÑÐµÑ€Ð²ÐµÑ€Ð°}\'</p><p>ÐžÐ²Ð°Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð½ÐµÐ¼Ð° Ð¿Ñ€Ð¸Ð²Ð¸Ð»ÐµÐ³Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð°',0),(474669,13186,'vi','<p>Ä‘á» nghá»‹ táº¡o láº¡i máº­t kháº©u A cho ngÆ°á»i sá»­ dá»¥ng \'{NgÆ°á»i sá»­ dá»¥ng}\' Ä‘Æ°á»£c lÃ m táº¡i vá»‹ trÃ­\'{TÃªn mÃ¡y chá»§}\'</p><p>NgÆ°á»i sá»­ dá»¥ng nÃ y khÃ´ng cÃ³ quyá»n táº¡o láº¡i máº­t kháº©u. Xin vui lÃ²ng liÃªn há»‡ ngÆ°á»i qu',0),(474670,13186,'af','<p>\'N wagwoord terugstel versoek vir gebruiker \'{gebruiker}\' gemaak is na die webwerf \'{SERVER_NAME}\'</p><p>Hierdie gebruiker het voorregte om die wagwoord te herstel nie.  Kontak asseblief jou stelseladministrateur.</p><p>Versoek van IP: {IP}</p>',0),(474671,13186,'ro','<p>O cerere de resetare parola de utilizator \'{utilizator}\' a fost fÄƒcutÄƒ la site-ul \"{nume_server}\"</p><p>Acest utilizator nu are privilegii pentru a reseta parola.  VÄƒ rugÄƒm sÄƒ contactaÅ£i administratorul.</p><p>Cerere de la IP: {IP}</p>',0),(474672,13186,'et','<p>Parooli lÃ¤htestamise taotlus kasutaja {kasutaja} on teinud saidile {serveri_nimi}</p><p>See kasutaja pole Ãµigusi taastada parool.  PÃ¶Ã¶rduge oma administraatori poole.</p><p>Taotluse IP: {IP}</p>',0),(474673,13186,'si','<p>Ponastavitev zahteva geslo za uporabnika {uporabnik} je mesto {SERVER_NAME}</p><p>Ta uporabnik nima privilegijev za ponastavitev gesla.  Obrnite se na skrbnika.</p><p>Zahteva od IP: {IP}</p>',0),(474674,13186,'ba','<p>Permintaan ulang sandi untuk pengguna \'{pengguna}\' telah dibuat ke situs \'{SERVER_NAME}\'</p><p>Pengguna tidak memiliki hak untuk menyetel ulang sandi.  Hubungi administrator Anda.</p><p>Permintaan dari IP: {IP}</p>',0),(474675,13186,'nl','<p>Een wachtwoord reset verzoek voor gebruiker \'{gebruiker}\' is geboekt naar de site \'{servernaam}\'</p><p>Deze gebruiker heeft geen privileges om het wachtwoord te resetten.  Neem contact op met uw beheerder.</p><p>Verzoek van IP: {IP}</p>',0),(474676,13186,'fi','<p>Uusi salasana kÃ¤yttÃ¤jÃ¤lle {kÃ¤yttÃ¤jÃ¤} on tehnyt sivuston {palvelimen_nimi}</p><p>TÃ¤llÃ¤ kÃ¤yttÃ¤jÃ¤llÃ¤ ei ole oikeuksia salasanan.  Ota yhteyttÃ¤ jÃ¤rjestelmÃ¤nvalvojaan.</p><p>PyyntÃ¶ IP: {IP}</p>',0),(474677,13186,'no','<p>Passord tilbakestillingsforespÃ¸rsel om brukeren \"{USER}\" har blitt gjort for webomrÃ¥det \"{servernavn}\"</p><p>Denne brukeren har ikke tillatelse til Ã¥ tilbakestille passordet.  Kontakt systemansvarlig.</p><p>ForespÃ¸rsel fra IP: {IP}</p>',0),(474678,13186,'da','<p>Der er sket en password reset anmodning for brugeren \'{USER}\' til webstedet \'{SERVER_NAME}\'</p><p>Denne bruger har ikke rettigheder til at nulstille adgangskoden.  Kontakt din administrator.</p><p>Anmodning fra IP: {IP}</p>',0),(474679,13186,'ko','<p>\'{SERVER_NAME}\' ì‚¬ì´íŠ¸ì— \' {ì‚¬ìš©ìž}\'ì— ëŒ€ í•œ ì•”í˜¸ ìž¬ì„¤ì • ìš”ì²­ì´ í–ˆë‹¤</p><p>ì´ ì‚¬ìš©ìž ì•”í˜¸ë¥¼ ë‹¤ì‹œ ì„¤ì •í•  ê¶Œí•œì´ ì—†ìŠµë‹ˆë‹¤.  ê´€ë¦¬ìžì— ê²Œ ë¬¸ì˜ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤.</p><p>IP ìš”ì²­: {IP}</p>',0),(474680,13186,'he','<p>×‘×§×©×ª ××™×¤×•×¡ ×¡×™×¡×ž×” ×¢×‘×•×¨ ×ž×©×ª×ž×© \'{×ž×©×ª×ž×©}\' ×”×¤×š ×œ××ª×¨ \"{SERVER_NAME}\"</p><p>×œ×ž×©×ª×ž×© ×–×” ××™×Ÿ ×”×¨×©××•×ª ×›×“×™ ×œ××¤×¡ ××ª ×”×¡×™×¡×ž×”.  ×× × ×¦×¨×• ×§×©×¨ ×¢× ×ž× ×”×œ ×”×ž×¢×¨×›×ª ×©×œ×š.</p><p>×‘×§×©×” ×ž-',0),(474681,13186,'el','<p>ÎˆÏ‡ÎµÎ¹ Î³Î¯Î½ÎµÎ¹ Î±Î¯Ï„Î·ÏƒÎ· ÎµÏ€Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ ÎºÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î· \'{Î§Î¡Î‰Î£Î¤Î—Î£}\' ÏƒÏ„Î·Î½ Ï€ÎµÏÎ¹Î¿Ï‡Î® Â«ÎŒÎ½Î¿Î¼Î±_Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î® {}Â»</p><p>Î‘Ï…Ï„ÏŒÏ‚ Î¿ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î´Î¹Îº',0),(474682,13186,'zh','<p>\'{USER}\' ç”¨æˆ·å¯†ç é‡ç½®è¯·æ±‚å·²å‘è¯¥ç½‘ç«™ \'{SERVER_NAME}\'</p><p>æ­¤ç”¨æˆ·æ²¡æœ‰æƒé™é‡ç½®å¯†ç ã€‚è¯·è”ç³»æ‚¨çš„ç®¡ç†å‘˜è”ç³»ã€‚</p><p>ä»Ž ip åœ°å€çš„è¯·æ±‚ï¼š {IP}</p>',0),(474683,13186,'sv','<p>En begÃ¤ran om lÃ¶senord Ã¥terstÃ¤llning fÃ¶r anvÃ¤ndaren \'{USER}\' har gjorts pÃ¥ webbplatsen \"{SERVER_NAME}\"</p><p>Den hÃ¤r anvÃ¤ndaren har inte behÃ¶righet fÃ¶r att Ã¥terstÃ¤lla lÃ¶senordet.  Kontakta din administratÃ¶r.</p><p>BegÃ¤ran frÃ¥n IP: {IP}',0),(474684,13186,'it','<p>Una richiesta di reimpostazione password per l\'utente \'{}\' utente Ã¨ stato fatto per il sito \'{nome_server}\'</p><p>Questo utente non dispone dei privilegi per reimpostare la password.  Contattare l\'amministratore.</p><p>Richiesta da IP: {IP}</p>',0),(474685,13186,'tl','',0),(474686,13186,'th','<p>à¸—à¸³à¸„à¸³à¸‚à¸­à¸•à¸±à¹‰à¸‡à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰ \'{à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰}\' à¹„à¸› \'{SERVER_NAME }\'</p><p>à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸¡à¸µà¸ªà¸´à¸—à¸˜à¸´à¹Œà¹ƒà¸™à¸à¸²à¸£à¸£à¸µà¹€à¸‹à¹‡à¸•à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™  à¸à¸£à',0),(474687,13186,'hi','<p>à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ \'{à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾}\' à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤°à¥€à¤¸à¥‡à¤Ÿ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¤¾à¤‡à¤Ÿ \'{SERVER_NAME}\' à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ</p><p>à¤‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤—à',0),(474688,13186,'ms','<p>Permintaan set semula kata laluan untuk pengguna \'{}\' pengguna telah dibuat ke tapak \'{SERVER_NAME}\'</p><p>Pengguna ini tidak mempunyai keistimewaan untuk mengeset semula kata laluan.  Sila hubungi pentadbir anda.</p><p>Permintaan dari IP: {IP}</p>',0),(474689,13186,'ar','<p>ÙˆÙ‚Ø¯ Ø£Ø­Ø±Ø² Ø·Ù„Ø¨ Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù… \'{Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…}\' Ø¥Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ \'{Ø§Ø³Ù… _ Ø§Ù„Ù…Ù„Ù‚Ù…}\'</p><p>Ù‡Ø°Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù„ÙŠØ³ Ù„Ø¯ÙŠÙ‡ Ø§Ù…ØªÙŠØ§Ø²Ø§Øª Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ±.  ',0),(474690,13186,'fr','<p>Une demande de rÃ©initialisation de mot de passe pour l\'utilisateur Â« {USER} Â» a Ã©tÃ© dÃ©posÃ©e auprÃ¨s du site Â« {nom_serveur} Â»</p><p>Cet utilisateur n\'a pas de privilÃ¨ges pour rÃ©initialiser le mot de passe.  Veuillez contacter votre administr',0),(474691,13186,'jp','<p>ã‚µã‚¤ãƒˆ \'{ã‚µãƒ¼ãƒãƒ¼å}\' ã‚’ãƒ¦ãƒ¼ã‚¶ãƒ¼ \' {}\' ã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®ãƒªã‚»ãƒƒãƒˆè¦æ±‚ã‚’ã—ã¾ã—ãŸ</p><p>ã“ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«ã¯ã€ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’ãƒªã‚»ãƒƒãƒˆã™ã‚‹ç‰¹æ¨©ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚ç®¡ç†è€…ã«å•ã„åˆã‚ã›ã¦ãã ã•ã„ã€‚</p>',0),(474692,13186,'pt','<p>Foi feita uma solicitaÃ§Ã£o de redefiniÃ§Ã£o de senha para usuÃ¡rio \'{usuÃ¡rio}\' o site \'{nome_servidor}\'</p><p>Este usuÃ¡rio nÃ£o tem privilÃ©gios para redefinir a senha.  Por favor, contate o administrador.</p><p>Pedido de IP: {IP}</p>',0),(474693,13186,'ru','<p>Ð‘Ñ‹Ð» Ð´Ð¾ÑÑ‚Ð¸Ð³Ð½ÑƒÑ‚ Ð·Ð°Ð¿Ñ€Ð¾Ñ ÑÐ±Ñ€Ð¾ÑÐ° Ð¿Ð°Ñ€Ð¾Ð»Ñ Ð´Ð»Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Â«{USER}Â» Ð½Ð° ÑÐ°Ð¹Ñ‚Ðµ Â«{Ð¸Ð¼Ñ_ÑÐµÑ€Ð²ÐµÑ€Ð°}Â»</p><p>Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð½Ðµ Ð¸Ð¼ÐµÐµÑ‚ Ð¿Ñ€Ð¸Ð²Ð¸Ð»ÐµÐ³Ð¸Ð¹ Ð´Ð»Ñ ÑÐ±Ñ€Ð¾ÑÐ° Ð¿Ð',0),(474694,13186,'es','<p>Una solicitaciÃ³n por una reconfiguraciÃ³n de password par el usuario \'{USUARIO}\'se habÃ­a hecho al sitio \'{NOMBRE DE SERVIDO}\'</p><p>Este usuario no tiene privilegios para reconfigura el password. Por favor comunica con su administrador.</p><p>PeticiÃ',0),(474695,13186,'de','<p>Kennwort hat zurÃ¼cksetzen fÃ¼r Benutzer \'{USER}\' auf der Website \'{Servername}\' gestellt wurde</p><p>Dieser Benutzer keine Berechtigungen zum ZurÃ¼cksetzen des Kennworts.  Bitte kontaktieren Sie Ihren Administrator.</p><p>Anfrage von IP: {IP}</p>',0),(474696,13186,'en','<p>A password reset request for user \'{USER}\' has been made to the site \'{SERVER_NAME}\'</p><p>This user does not have privileges to reset the password.  Please contact your administrator.</p><p>Request From IP: {IP}</p>',0),(474697,13187,'is','',0),(474698,13187,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¨Ø³ÛŒØ§Ø± Ú©ÙˆØªØ§Ù‡ Ø§Ø³Øª',0),(474699,13187,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¨Ø³ÛŒØ§Ø± Ú©ÙˆØªØ§Ù‡ Ø§Ø³Øª',0),(474700,13187,'tr','Parola Ã§ok kÄ±sa.',0),(474701,13187,'pl','HasÅ‚o jest zbyt krÃ³tki.',0),(474702,13187,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð°Ñ‚Ð° Ðµ Ð¿Ñ€ÐµÐºÐ°Ð»ÐµÐ½Ð¾ ÐºÑ€Ð°Ñ‚ÐºÐ°.',0),(474703,13187,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¨ÛØª Ú†Ú¾ÙˆÙ¹Ø§ ÛÛ’ Û”',0),(474704,13187,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ° Ñ˜Ðµ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÐºÐ°.',0),(474705,13187,'vi','Máº­t kháº©u quÃ¡ ngáº¯n',0),(474706,13187,'af','Wagwoord is te kort.',0),(474707,13187,'ro','Parola este prea scurta.',0),(474708,13187,'et','Parool on liiga lÃ¼hike.',0),(474709,13187,'si','Geslo je prekratko.',0),(474710,13187,'ba','Password terlalu pendek.',0),(474711,13187,'nl','Wachtwoord is te kort.',0),(474712,13187,'fi','Salasana on liian lyhyt.',0),(474713,13187,'no','Passordet er for kort.',0),(474714,13187,'da','Adgangskoden er for kort.',0),(474715,13187,'ko','ì•”í˜¸ê°€ ë„ˆë¬´ ì§§ìŠµë‹ˆë‹¤.',0),(474716,13187,'he','×”×¡×™×¡×ž×” ×”×™× ×§×¦×¨×” ×ž×“×™.',0),(474717,13187,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹ Ï€Î¿Î»Ï Î¼Î¹ÎºÏÎ®.',0),(474718,13187,'zh','å¯†ç æ˜¯å¤ªçŸ­ã€‚',0),(474719,13187,'sv','LÃ¶senordet Ã¤r fÃ¶r kort.',0),(474720,13187,'it','Password Ã¨ troppo corta.',0),(474721,13187,'tl','',0),(474722,13187,'th','à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸ˆà¸°à¸ªà¸±à¹‰à¸™à¹€à¸à¸´à¸™à¹„à¸›',0),(474723,13187,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¬à¤¹à¥à¤¤ à¤›à¥‹à¤Ÿà¤¾ à¤¹à¥ˆà¥¤',0),(474724,13187,'ms','Kata laluan adalah terlalu pendek.',0),(474725,13187,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± ØºÙŠØ± Ù‚ØµÙŠØ±Ø© Ø¬Ø¯Ø§Ù‹.',0),(474726,13187,'fr','Mot de passe est trop court.',0),(474727,13187,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ãŒçŸ­ã™ãŽã¾ã™ã€‚',0),(474728,13187,'pt','Senha Ã© muito curta.',0),(474729,13187,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ ÑÐ»Ð¸ÑˆÐºÐ¾Ð¼ ÐºÐ¾Ñ€Ð¾Ñ‚ÐºÐ¸Ð¹.',0),(474730,13187,'es','Password es demasiado corto',0),(474731,13187,'de','Passwort ist zu kurz.',0),(474732,13187,'en','Password is too short.',0),(474733,13188,'is','',0),(474734,13188,'dr','.',0),(474735,13188,'pr','Ù„Ø·ÙØ§ Ø§ÛŒÙ…ÛŒÙ„ Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒÛŒ Ø¨ÛŒØ´ØªØ± Ø¯Ø± Ù…ÙˆØ±Ø¯ Ú†Ú¯ÙˆÙ†Ú¯ÛŒ ØªÚ©Ù…ÛŒÙ„ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ± Ø®ÙˆØ¯Ú†Ú© Ú©Ù†ÛŒØ¯.',0),(474736,13188,'tr','LÃ¼tfen parola sÄ±fÄ±rlamayÄ± tamamlamak nasÄ±l yÃ¶nergeler iÃ§in e-postanÄ±zÄ± kontrol edin.',0),(474737,13188,'pl','SprawdÅº swÃ³j e-mail instrukcje do wykonania swojego resetowania hasÅ‚a.',0),(474738,13188,'bg','ÐœÐ¾Ð»Ñ, Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð°Ñ‚Ð° ÑÐ¸ Ð¿Ð¾Ñ‰Ð° Ð·Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ ÐºÐ°Ðº Ð´Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸Ñ‚Ðµ ÑÐ¸ Ð·Ð° Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°Ñ‚Ð°.',0),(474739,13188,'ur','Ø¢Ù¾ Ú©Ø§ Ø§ÛŒ Ù…ÛŒÙ„ Ø§Ù¾Ù†Ø§ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©Ùˆ Ù…Ú©Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛØ¯Ø§ÛŒØ§Øª Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº.',0),(474740,13188,'sr','ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ Ð’Ð°Ñˆ ÐµÐ¼Ð°Ð¸Ð» Ð·Ð° ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð¾ Ñ‚Ð¾Ð¼Ðµ ÐºÐ°ÐºÐ¾ Ð´Ð° Ð´Ð¾Ð²Ñ€ÑˆÐ¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ðµ Ð·Ð° Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ.',0),(474741,13188,'vi','Xin vui lÃ²ng kiá»ƒm tra há»™p thÆ° cá»§a báº¡n Ä‘á»ƒ xem hÆ°á»›ng dáº«n hoÃ n thÃ nh viá»‡c táº¡o láº¡i máº­t kháº©u cá»§a báº¡n ',0),(474742,13188,'af','Kontroleer asseblief jou e-pos vir instruksies oor hoe om jou wagwoord terugstel voltooi.',0),(474743,13188,'ro','VÄƒ rugÄƒm sÄƒ verificaÅ£i e-mailul pentru instrucÅ£iuni despre cum sÄƒ completaÅ£i vÄƒ reseta parola.',0),(474744,13188,'et','Palun kontrollige oma e-posti tÃ¤itke parooli lÃ¤htestamise juhiseid.',0),(474745,13188,'si','Prosim Äek vaÅ¡ email za navodila, kako izpolniti vaÅ¡ parola prikrivati.',0),(474746,13188,'ba','Periksa email Anda untuk petunjuk tentang cara untuk menyelesaikan reset password Anda.',0),(474747,13188,'nl','Controleer uw email voor instructies over hoe u uw wachtwoord opnieuw instellen.',0),(474748,13188,'fi','Tarkista sÃ¤hkÃ¶postisi ohjeet tÃ¤ydellinen salasanan nollaus.',0),(474749,13188,'no','Sjekk din email for instruksjoner om hvordan du fullfÃ¸rer din tilbakestilling av passord.',0),(474750,13188,'da','Tjek venligst din e-mail for at fÃ¥ instruktioner om, hvordan at fuldfÃ¸re dit password reset.',0),(474751,13188,'ko','ì•”í˜¸ ìž¬ì„¤ì •ì„ ì™„ë£Œ í•˜ëŠ” ë°©ë²•ì— ëŒ€ í•œ ì§€ì¹¨ì— ëŒ€ í•œ ê·€í•˜ì˜ ì´ë©”ì¼ì„ í™•ì¸ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤.',0),(474752,13188,'he','× × ×‘×“×•×§ ××ª ×”×“×•××¨ ×”××œ×§×˜×¨×•× ×™ ×©×œ×š ×œ×§×‘×œ×ª ×”×•×¨××•×ª ×œ×”×©×œ×ž×ª ×œ××™×¤×•×¡ ×”×¡×™×¡×ž×” ×©×œ×š.',0),(474753,13188,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ»Î­Î³Î¾Ï„Îµ Ï„Î¿ email ÏƒÎ±Ï‚ Î³Î¹Î± Î¿Î´Î·Î³Î¯ÎµÏ‚ Î³Î¹Î± Ï„Î¿ Ï€ÏŽÏ‚ Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ ÎµÏ€Î±Î½Î±Ï†Î¿ÏÎ¬ Ï„Î¿Ï… ÎºÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÏƒÎ±Ï‚.',0),(474754,13188,'zh','è¯·æ£€æŸ¥æ‚¨çš„ç”µå­é‚®ä»¶ï¼Œè¯´æ˜Žå¦‚ä½•å®Œæˆæ‚¨çš„å¯†ç é‡ç½®ã€‚',0),(474755,13188,'sv','VÃ¤nligen kontrollera din e-post fÃ¶r instruktioner om hur du slutfÃ¶r Ã¥terstÃ¤lla ditt lÃ¶senord.',0),(474756,13188,'it','Per favore controlla la tua e-mail per istruzioni su come completare la reimpostazione della password.',0),(474757,13188,'tl','',0),(474758,13188,'th','à¸à¸£à¸¸à¸“à¸²à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸­à¸µà¹€à¸¡à¸¥à¹Œà¸‚à¸­à¸‡à¸„à¸¸à¸“à¸ªà¸³à¸«à¸£à¸±à¸šà¸„à¸³à¹à¸™à¸°à¸™à¸³à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸£à¸µà¹€à¸‹à¹‡à¸•à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(474759,13188,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤ªà¤¨à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤°à¥€à¤¸à¥‡à¤Ÿ à¤•à¥‹ à¤ªà¥‚à¤°à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥ˆà¤¸à¥‡ à¤ªà¤° à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤ªà¤¨à¥‡ à¤ˆà¤®à¥‡à¤² à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚à¥¤',0),(474760,13188,'ms','Sila semak e-mel anda untuk arahan tentang bagaimana untuk melengkapkan set semula kata laluan anda.',0),(474761,13188,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø¥Ø±Ø´Ø§Ø¯Ø§Øª Ø­ÙˆÙ„ ÙƒÙŠÙÙŠØ© Ø¥ØªÙ…Ø§Ù… Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(474762,13188,'fr','Veuillez vÃ©rifier votre email pour obtenir des instructions sur la faÃ§on de remplir la rÃ©initialisation de votre mot de passe.',0),(474763,13188,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®ãƒªã‚»ãƒƒãƒˆã‚’å®Œäº†ã™ã‚‹æ–¹æ³•ã«ã¤ã„ã¦ã‚ãªãŸã®ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(474764,13188,'pt','Por favor, verifique seu e-mail para obter instruÃ§Ãµes sobre como concluir sua redefiniÃ§Ã£o de senha.',0),(474765,13188,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ ÑÐ²Ð¾ÑŽ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½ÑƒÑŽ Ð¿Ð¾Ñ‡Ñ‚Ñƒ Ð´Ð»Ñ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¹ Ð¾ Ñ‚Ð¾Ð¼, ÐºÐ°Ðº Ð·Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ Ð²Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð²Ð°ÑˆÐµÐ³Ð¾ Ð¿Ð°Ñ€Ð¾Ð»Ñ.',0),(474766,13188,'es','Por Favor rechecar su email para instrucciones sobre como completar la reconfiguraciÃ³n de su password',0),(474767,13188,'de','Bitte Ã¼berprÃ¼fen Sie Ihre e-Mail Hinweise dazu, wie Sie Ihre Passwort-Reset durchfÃ¼hren.',0),(474768,13188,'en','Please check your email for instructions on how to complete your password reset.',0),(474769,13189,'is','',0),(474770,13189,'dr','(Ù‡Ø²ÛŒÙ†Ù‡)Ø§Ø¶Ø§ÙÛŒ Ø¨Ø±Ø§ÛŒ Ù‡Ø±',0),(474771,13189,'pr','Ø´Ø§Ø±Ú˜(Ù‡Ø²ÛŒÙ†Ù‡)Ø§Ø¶Ø§ÙÛŒ Ø¨Ø±Ø§ÛŒ Ù‡Ø±',0),(474772,13189,'tr','Her baÅŸÄ±na ek Ã¼cret',0),(474773,13189,'pl','Dodatkowe opÅ‚aty za kaÅ¼dy',0),(474774,13189,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð° Ñ‚Ð°ÐºÑÐ° Ð·Ð° Ð²ÑÐµÐºÐ¸',0),(474775,13189,'ur','ÛØ± Ø§ÛŒÚ© Ù…ÛŒÚº ÙÛŒ Ø§Ø¶Ø§ÙÛŒ Ú†Ø§Ø±Ø¬',0),(474776,13189,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð° Ð½Ð°ÐºÐ½Ð°Ð´Ð° Ð¿Ð¾ Ñ˜ÐµÐ´Ð½Ð¾',0),(474777,13189,'vi','PhÃ­ cá»™ng thÃªm  trÃªn má»—i Ä‘Æ¡n vá»‹',0),(474778,13189,'af','Addisionele fooi Per elke',0),(474779,13189,'ro','Taxe suplimentare pentru fiecare',0),(474780,13189,'et','Lisatasu eest iga',0),(474781,13189,'si','DoplaÄila na vsak',0),(474782,13189,'ba','Biaya tambahan Per masing-masing',0),(474783,13189,'nl','Aanvullende vergoeding Per elk',0),(474784,13189,'fi','LisÃ¤maksu Per teos',0),(474785,13189,'no','Ekstra kostnad Per hver',0),(474786,13189,'da','Yderligere pristillÃ¦g pr. hver',0),(474787,13189,'ko','ê° ë‹¹ ì¶”ê°€ ìš”ê¸ˆ',0),(474788,13189,'he','×ª×©×œ×•× × ×•×¡×£ ×œ×›×œ ××—×“',0),(474789,13189,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Ï‡ÏÎ­Ï‰ÏƒÎ· Î±Î½Î¬ ÎºÎ¬Î¸Îµ',0),(474790,13189,'zh','é™„åŠ è´¹æ¯',0),(474791,13189,'sv','Extra kostnad Per varje',0),(474792,13189,'it','Costo aggiuntivo Per ogni',0),(474793,13189,'tl','',0),(474794,13189,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¹à¸•à¹ˆà¸¥à¸°',0),(474795,13189,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤ªà¥à¤°à¤¤à¤¿ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(474796,13189,'ms','Caj tambahan setiap setiap satu',0),(474797,13189,'ar','Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ© Ù„ÙƒÙ„',0),(474798,13189,'fr','Frais additionnels pour chaque',0),(474799,13189,'jp','å„è¿½åŠ æ–™é‡‘',0),(474800,13189,'pt','Custo adicional por cada um',0),(474801,13189,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð° Ð·Ð° ÐºÐ°Ð¶Ð´ÑƒÑŽ',0),(474802,13189,'es','Carga Adicional Por Cada Uno',0),(474803,13189,'de','Aufpreis pro StÃ¼ck',0),(474804,13189,'en','Additional Charge Per Each',0),(474805,13190,'is','',0),(474806,13190,'dr','(Ù‡Ø²ÛŒÙ†Ù‡)Ø§Ø¶Ø§ÙÛŒ Ø¨Ø±Ø§ÛŒ Ù‡Ø±ÙØ±Ù…Ø§ÛŒØ´',0),(474807,13190,'pr','Ø´Ø§Ø±Ú˜(Ù‡Ø²ÛŒÙ†Ù‡)Ø§Ø¶Ø§ÙÛŒ Ø¨Ø±Ø§ÛŒ Ù‡Ø±Ø³ÙØ§Ø±Ø´',0),(474808,13190,'tr','SipariÅŸ baÅŸÄ±na Addl gider',0),(474809,13190,'pl','Addl opÅ‚ata za zamÃ³wienie',0),(474810,13190,'bg','Addl Ñ‚Ð°ÐºÑÐ° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(474811,13190,'ur','Ø§Ø¯Ø¯Ù„ Ú©Û’ Ø§Ù„Ø²Ø§Ù… Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ ØªØ±ØªÛŒØ¨',0),(474812,13190,'sr','ÐÐ´Ð´Ð» Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¿Ð¾ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð¸',0),(474813,13190,'vi','ThÃªm phÃ­ má»—i Ä‘Æ¡n hÃ ng',0),(474814,13190,'af','Addl fooi Per bestelling',0),(474815,13190,'ro','Addl cost Per comandÄƒ',0),(474816,13190,'et','Addl tasu tellimuse kohta',0),(474817,13190,'si','Pokvariti se naboj na naroÄilo',0),(474818,13190,'ba','Addl biaya Per Order',0),(474819,13190,'nl','Addl kosten Per bestelling',0),(474820,13190,'fi','Addl maksu Per tilaus',0),(474821,13190,'no','Addl kostnad Per bestilling',0),(474822,13190,'da','Addl gebyr pr. ordre',0),(474823,13190,'ko','ì£¼ë¬¸ë‹¹ Addl ì¶©ì „',0),(474824,13190,'he','Addl ×ª×©×œ×•× ×œ×›×œ ×”×–×ž× ×”',0),(474825,13190,'el','Addl Ï‡ÏÎ­Ï‰ÏƒÎ· Î±Î½Î¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(474826,13190,'zh','Addl æ¯ä¸ªè®¢å•çš„è´¹ç”¨',0),(474827,13190,'sv','Addl kostnad Per Order',0),(474828,13190,'it','Addl carica per ogni ordine',0),(474829,13190,'tl','',0),(474830,13190,'th','Addl à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸•à¹ˆà¸­à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(474831,13190,'hi','à¤…à¤ªà¤° à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤ªà¥à¤°à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶',0),(474832,13190,'ms','Addl caj setiap pesanan',0),(474833,13190,'ar','Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ© Ù„ÙƒÙ„ Ø£Ù…Ø±',0),(474834,13190,'fr','Charge ADDL par commande',0),(474835,13190,'jp','æ³¨æ–‡ã‚ãŸã‚Š Addl æ–™é‡‘',0),(474836,13190,'pt','Addl custo por ordem',0),(474837,13190,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÑÐ±Ð¾Ñ€ Ð·Ð° Ð·Ð°ÐºÐ°Ð·',0),(474838,13190,'es','Carga Adicional Por Pedido',0),(474839,13190,'de','Addl kostenlos pro Bestellung',0),(474840,13190,'en','Addl Charge Per Order',0),(474841,13191,'is','',0),(474842,13191,'dr','Ù†Ø§Ù… Ø±Ù†Ú¯',0),(474843,13191,'pr','Ù†Ø§Ù… Ø±Ù†Ú¯',0),(474844,13191,'tr','Renk adÄ±',0),(474845,13191,'pl','Nazwa koloru',0),(474846,13191,'bg','Ð¦Ð²ÑÑ‚ Ð¸Ð¼Ðµ',0),(474847,13191,'ur','Ø±Ù†Ú¯ Ú©Ø§ Ù†Ø§Ù…',0),(474848,13191,'sr','ÐÐ°Ð·Ð¸Ð² Ð±Ð¾Ñ˜Ðµ',0),(474849,13191,'vi','TÃªn mÃ u',0),(474850,13191,'af','Kleurnaam',0),(474851,13191,'ro','Culoare nume',0),(474852,13191,'et','VÃ¤rvi nimetus',0),(474853,13191,'si','Barva ime',0),(474854,13191,'ba','Nama warna',0),(474855,13191,'nl','Kleurnaam',0),(474856,13191,'fi','VÃ¤rin nimi',0),(474857,13191,'no','Fargenavn',0),(474858,13191,'da','Kolorere benÃ¦vne',0),(474859,13191,'ko','ìƒ‰ìƒ ì´ë¦„',0),(474860,13191,'he','×©× ×©×œ ×¦×‘×¢',0),(474861,13191,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Ï‡ÏÏŽÎ¼Î±Ï„Î¿Ï‚',0),(474862,13191,'zh','é¢œè‰²åç§°',0),(474863,13191,'sv','FÃ¤rgnamn',0),(474864,13191,'it','Nome colore',0),(474865,13191,'tl','',0),(474866,13191,'th','à¸Šà¸·à¹ˆà¸­à¸ªà¸µ',0),(474867,13191,'hi','à¤°à¤‚à¤— à¤•à¤¾ à¤¨à¤¾à¤®',0),(474868,13191,'ms','Nama warna',0),(474869,13191,'ar','Ø§Ø³Ù… Ø§Ù„Ù„ÙˆÙ†',0),(474870,13191,'fr','Nom de couleur',0),(474871,13191,'jp','è‰²ã®åå‰',0),(474872,13191,'pt','Nome de cor',0),(474873,13191,'ru','Ð˜Ð¼Ñ Ñ†Ð²ÐµÑ‚Ð°',0),(474874,13191,'es','Nombre de Color',0),(474875,13191,'de','Farbname',0),(474876,13191,'en','Color Name',0),(474877,13192,'is','',0),(474878,13192,'dr','Ù¾ÙˆØ´Ø´ Ø±Ù†Ú¯Ù‡Ø§',0),(474879,13192,'pr','Ù¾ÙˆØ´Ø´ Ø±Ù†Ú¯Ù‡Ø§',0),(474880,13192,'tr','Kapak renkleri',0),(474881,13192,'pl','Pokrycie kolory',0),(474882,13192,'bg','Ð¦Ð²ÐµÑ‚Ð¾Ð²Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð¸Ñ†Ð°Ñ‚Ð°',0),(474883,13192,'ur','Ø±Ù†Ú¯ÙˆÚº Ú©Ø§ Ø§Ø­Ø§Ø·Û',0),(474884,13192,'sr','ÐŸÐ¾ÐºÑ€Ð¸Ñ˜ Ð±Ð¾Ñ˜Ðµ',0),(474885,13192,'vi','mÃ u ngoÃ i',0),(474886,13192,'af','Bedek kleure',0),(474887,13192,'ro','Acoperi culori',0),(474888,13192,'et','Kaane vÃ¤rvid',0),(474889,13192,'si','Zajema barve',0),(474890,13192,'ba','Sampul warna',0),(474891,13192,'nl','Cover kleuren',0),(474892,13192,'fi','Kuorten vÃ¤rivaihtoehtoja',0),(474893,13192,'no','Dekke farger',0),(474894,13192,'da','DÃ¦kke farver',0),(474895,13192,'ko','ì»¤ë²„ ìƒ‰ìƒ',0),(474896,13192,'he','×›×™×¡×•×™ ×¦×‘×¢×™',0),(474897,13192,'el','Î¤Î± Ï‡ÏÏŽÎ¼Î±Ï„Î± ÎºÎ¬Î»Ï…ÏˆÎ·Ï‚',0),(474898,13192,'zh','å°é¢é¢œè‰²',0),(474899,13192,'sv','TÃ¤cka fÃ¤rger',0),(474900,13192,'it','Copertina colori',0),(474901,13192,'tl','',0),(474902,13192,'th','à¸›à¸à¸ªà¸µ',0),(474903,13192,'hi','à¤†à¤µà¤°à¤£ à¤°à¤‚à¤—',0),(474904,13192,'ms','Warna-warna kulit',0),(474905,13192,'ar','ØªØºØ·ÙŠØ© Ø§Ù„Ø£Ù„ÙˆØ§Ù†',0),(474906,13192,'fr','Couverture couleurs',0),(474907,13192,'jp','è‰²ã‚’ã‚«ãƒãƒ¼ã—ã¾ã™ã€‚',0),(474908,13192,'pt','Cores de capa',0),(474909,13192,'ru','Ð¦Ð²ÐµÑ‚Ð° ÐºÑ€Ñ‹ÑˆÐºÐ¸',0),(474910,13192,'es','Colores de Tapa',0),(474911,13192,'de','Abdeckung Farben',0),(474912,13192,'en','Cover Colors',0),(474913,13193,'is','',0),(474914,13193,'dr','Ø±Ù†Ú¯Ù‡Ø§ÛŒ Ø¯Ø§Ø®Ù„ÛŒ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(474915,13193,'pr','Ø±Ù†Ú¯Ù‡Ø§ÛŒ Ø¯Ø§Ø®Ù„ÛŒ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(474916,13193,'tr','Ã–zel renkler iÃ§inde',0),(474917,13193,'pl','Niestandardowe wewnÄ…trz kolory',0),(474918,13193,'bg','ÐŸÐ¾ Ð¸Ð·Ð±Ð¾Ñ€ Ð² Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(474919,13193,'ur','Ù…Ø®ØµÙˆØµ Ø±Ù†Ú¯ Ú©Û’ Ø§Ù†Ø¯Ø±',0),(474920,13193,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¾ ÑƒÐ½ÑƒÑ‚Ñ€Ð° Ð±Ð¾Ñ˜Ðµ',0),(474921,13193,'vi','tá»± táº¡o mÃ u bÃªn trong',0),(474922,13193,'af','Pasgemaakte kleure binne',0),(474923,13193,'ro','Personalizate Ã®n interiorul culori',0),(474924,13193,'et','Kohandatud vÃ¤rvi sees',0),(474925,13193,'si','Custom znotraj barve',0),(474926,13193,'ba','Custom dalam warna',0),(474927,13193,'nl','Aangepaste binnen kleuren',0),(474928,13193,'fi','Custom vÃ¤rit sisÃ¤llÃ¤',0),(474929,13193,'no','Egendefinert i farger',0),(474930,13193,'da','Custom inde i farver',0),(474931,13193,'ko','ì‚¬ìš©ìž ì •ì˜ ìƒ‰ìƒ ë‚´ë¶€',0),(474932,13193,'he','×ž×•×ª×× ××™×©×™×ª ×‘×ª×•×š ×¦×‘×¢×™×',0),(474933,13193,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· Î¼Î­ÏƒÎ± Ï‡ÏÏŽÎ¼Î±Ï„Î±',0),(474934,13193,'zh','è‡ªå®šä¹‰å†…éƒ¨é¢œè‰²',0),(474935,13193,'sv','Anpassad inuti fÃ¤rger',0),(474936,13193,'it','Personalizzata all\'interno di colori',0),(474937,13193,'tl','',0),(474938,13193,'th','à¸ à¸²à¸¢à¹ƒà¸™à¸ªà¸µà¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡',0),(474939,13193,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤°à¤‚à¤—à¥‹à¤‚ à¤•à¥‡ à¤…à¤‚à¤¦à¤°',0),(474940,13193,'ms','Adat dalam warna-warna',0),(474941,13193,'ar','Ù…Ø®ØµØµ Ø¯Ø§Ø®Ù„ Ø§Ù„Ø£Ù„ÙˆØ§Ù†',0),(474942,13193,'fr','PersonnalisÃ© Ã  l\'intÃ©rieur de couleurs',0),(474943,13193,'jp','ã‚«ã‚¹ã‚¿ãƒ è‰²ã®å†…éƒ¨',0),(474944,13193,'pt','Costume dentro de cores',0),(474945,13193,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ð²Ð½ÑƒÑ‚Ñ€Ð¸ Ñ†Ð²ÐµÑ‚Ð¾Ð²',0),(474946,13193,'es','Colores a Dentro Personalizados',0),(474947,13193,'de','Benutzerdefinierte in Farben',0),(474948,13193,'en','Custom Inside Colors',0),(474949,13194,'is','',0),(474950,13194,'dr','Ø±Ù†Ú¯Ù‡Ø§ÛŒ Ø¨ÛŒØ±ÙˆÙ†ÛŒ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(474951,13194,'pr','Ø±Ù†Ú¯Ù‡Ø§ÛŒ Ø¨ÛŒØ±ÙˆÙ†ÛŒ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(474952,13194,'tr','Ã–zel renkler dÄ±ÅŸÄ±nda',0),(474953,13194,'pl','Niestandardowe poza kolory',0),(474954,13194,'bg','ÐŸÐ¾ Ð¸Ð·Ð±Ð¾Ñ€ Ð¸Ð·Ð²ÑŠÐ½ Ñ†Ð²ÐµÑ‚Ð¾Ð²Ðµ',0),(474955,13194,'ur','Ù…Ø®ØµÙˆØµ Ø±Ù†Ú¯ Ø³Û’ Ø¨Ø§ÛØ±',0),(474956,13194,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¾ Ð¸Ð·Ð²Ð°Ð½ Ð±Ð¾Ñ˜Ðµ',0),(474957,13194,'vi','tá»± táº¡o mÃ u bÃªn ngoÃ i',0),(474958,13194,'af','Pasgemaakte buite kleure',0),(474959,13194,'ro','Custom Ã®n afara culori',0),(474960,13194,'et','Kohandatud vÃ¤rvide vÃ¤ljaspool',0),(474961,13194,'si','Custom zunaj barve',0),(474962,13194,'ba','Custom luar warna',0),(474963,13194,'nl','Aangepaste buiten kleuren',0),(474964,13194,'fi','Custom vÃ¤rit ulkopuolella',0),(474965,13194,'no','Egendefinert utenfor farger',0),(474966,13194,'da','Custom udenfor farver',0),(474967,13194,'ko','ì‚¬ìš©ìž ì§€ì • ìƒ‰ìƒ ì™¸ë¶€',0),(474968,13194,'he','×ž×•×ª×× ××™×©×™×ª ×ž×—×•×¥ ×¦×‘×¢×™×',0),(474969,13194,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· ÎµÎºÏ„ÏŒÏ‚ Ï‡ÏÏŽÎ¼Î±Ï„Î±',0),(474970,13194,'zh','å¤–é¢çš„é¢œè‰²è‡ªå®šä¹‰',0),(474971,13194,'sv','Anpassad utanfÃ¶r fÃ¤rger',0),(474972,13194,'it','Custom fuori colori',0),(474973,13194,'tl','',0),(474974,13194,'th','à¸ à¸²à¸¢à¸™à¸­à¸à¸ªà¸µà¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡',0),(474975,13194,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤°à¤‚à¤—à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¾à¤¹à¤°',0),(474976,13194,'ms','Adat di luar warna',0),(474977,13194,'ar','Ù…Ø®ØµØµ Ø®Ø§Ø±Ø¬ Ø§Ù„Ø£Ù„ÙˆØ§Ù†',0),(474978,13194,'fr','PersonnalisÃ© en dehors des couleurs',0),(474979,13194,'jp','ã‚«ã‚¹ã‚¿ãƒ å¤–éƒ¨è‰²',0),(474980,13194,'pt','Costume fora cores',0),(474981,13194,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ð²Ð½Ðµ Ñ†Ð²ÐµÑ‚Ð¾Ð²',0),(474982,13194,'es','Colores a Fuera Personalizados',0),(474983,13194,'de','Benutzerdefinierte auÃŸerhalb Farben',0),(474984,13194,'en','Custom Outside Colors',0),(474985,13195,'is','',0),(474986,13195,'dr','Ø­Ø°Ù Ø§ÛŒÙ† Ø±Ø¯ÛŒÙ',0),(474987,13195,'pr','Ø­Ø°Ù Ø§ÛŒÙ† Ø±Ø¯ÛŒÙ',0),(474988,13195,'tr','Bu satÄ±r Sil',0),(474989,13195,'pl','UsunÄ…Ä‡ ten wiersz',0),(474990,13195,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ñ€ÐµÐ´',0),(474991,13195,'ur','Ø§Ø³ ØµÙ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(474992,13195,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ñ€ÐµÐ´',0),(474993,13195,'vi','XÃ³a dÃ²ng nÃ y',0),(474994,13195,'af','Skrap hierdie ry',0),(474995,13195,'ro','ÅžtergeÅ£i acest rÃ¢nd',0),(474996,13195,'et','Selle rea kustutamine',0),(474997,13195,'si','IzbriÅ¡ite to vrstico',0),(474998,13195,'ba','Hapus baris ini',0),(474999,13195,'nl','Deze rij verwijderen',0),(475000,13195,'fi','Poista tÃ¤mÃ¤ rivi',0),(475001,13195,'no','Slette denne raden',0),(475002,13195,'da','Slet denne rÃ¦kke',0),(475003,13195,'ko','ì´ í–‰ì„ ì‚­ì œ',0),(475004,13195,'he','×œ×ž×—×•×§ ×©×•×¨×” ×–×•',0),(475005,13195,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(475006,13195,'zh','åˆ é™¤è¿™ä¸€è¡Œ',0),(475007,13195,'sv','Ta bort denna rad',0),(475008,13195,'it','Eliminare questa riga',0),(475009,13195,'tl','',0),(475010,13195,'th','à¸¥à¸šà¹à¸–à¸§à¸™à¸µà¹‰',0),(475011,13195,'hi','à¤‡à¤¸ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(475012,13195,'ms','Hapuskan barisan ini',0),(475013,13195,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„ØµÙ',0),(475014,13195,'fr','Supprimer cette ligne',0),(475015,13195,'jp','ã“ã®è¡Œã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(475016,13195,'pt','Excluir esta linha',0),(475017,13195,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ ÑÑ‚Ñ€Ð¾ÐºÑƒ',0),(475018,13195,'es','Eliminar esta Linea',0),(475019,13195,'de','Diese Zeile lÃ¶schen',0),(475020,13195,'en','Delete This Row',0),(475021,13196,'is','',0),(475022,13196,'dr','Ø¯Ø±Ø¬ Ù¾ÙˆØ´Ø´ Ù‡Ø§',0),(475023,13196,'pr','Ø¯Ø±Ø¬ Ù¾ÙˆØ´Ø´ Ù‡Ø§',0),(475024,13196,'tr','Ä°Ã§ kapaklarÄ±',0),(475025,13196,'pl','WewnÄ…trz okÅ‚adki',0),(475026,13196,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ ÐºÐ°Ð¿Ð°Ñ†Ð¸',0),(475027,13196,'ur','Ø§Ù†Ø¯Ø± ØºÙ„Ø§Ù',0),(475028,13196,'sr','Ð˜Ð½ÑÐ¸Ð´Ðµ Ð·Ð°ÐºÐ»Ð¾Ð½Ðµ',0),(475029,13196,'vi','trong vá» bá»c',0),(475030,13196,'af','Binnekant dek',0),(475031,13196,'ro','Interiorul acoperÄƒ',0),(475032,13196,'et','Sees kaaned',0),(475033,13196,'si','Znotraj pokriva',0),(475034,13196,'ba','Dalam sampul',0),(475035,13196,'nl','Binnen Covers',0),(475036,13196,'fi','SisÃ¤ltÃ¤ kannet',0),(475037,13196,'no','Inne dekker',0),(475038,13196,'da','Inside dÃ¦kker',0),(475039,13196,'ko','ì•ˆìª½ ì»¤ë²„',0),(475040,13196,'he','×ž×›×¡×” ×ž×‘×¤× ×™×',0),(475041,13196,'el','ÎœÎ­ÏƒÎ± ÎºÎ±Î»ÏÏˆÎµÎ¹Ï‚',0),(475042,13196,'zh','å†…ç›–',0),(475043,13196,'sv','Inside tÃ¤cker',0),(475044,13196,'it','Copertine interne',0),(475045,13196,'tl','',0),(475046,13196,'th','à¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡à¸ à¸²à¸¢à¹ƒà¸™',0),(475047,13196,'hi','à¤…à¤‚à¤¦à¤° à¤•à¤µà¤°',0),(475048,13196,'ms','Meliputi dalam',0),(475049,13196,'ar','ÙŠØºØ·ÙŠ Ø§Ù„Ø¯Ø§Ø®Ù„',0),(475050,13196,'fr','Couvertures Ã  l\'intÃ©rieur',0),(475051,13196,'jp','ã‚«ãƒãƒ¼ã®å†…å´',0),(475052,13196,'pt','Tampas dentro',0),(475053,13196,'ru','Ð’Ð½ÑƒÑ‚Ñ€Ð¸ ÐºÑ€Ñ‹ÑˆÐºÐ¸',0),(475054,13196,'es','Tapas a Dentro',0),(475055,13196,'de','Im Detail umfasst',0),(475056,13196,'en','Inside Covers',0),(475057,13197,'is','',0),(475058,13197,'dr','(Ù¾ÙˆØ´Ø´) Ø®Ø§Ø±Ø¬ÛŒ',0),(475059,13197,'pr','Ú©Ø§ÙˆØ±Ù‡Ø§ÛŒ(Ù¾ÙˆØ´Ø´) Ø®Ø§Ø±Ø¬ÛŒ',0),(475060,13197,'tr','DÄ±ÅŸ kapaklar',0),(475061,13197,'pl','Poza obejmuje',0),(475062,13197,'bg','Ð’ÑŠÐ½ÑˆÐ½Ð¸ ÐºÐ°Ð¿Ð°Ñ†Ð¸',0),(475063,13197,'ur','Ø¨ÛŒØ±ÙˆÙ†ÛŒ ØºÙ„Ø§Ù',0),(475064,13197,'sr','Ð˜Ð·Ð²Ð°Ð½ Ð·Ð°ÐºÐ»Ð¾Ð½Ðµ',0),(475065,13197,'vi','lá»›p vá» bá» ngoÃ i',0),(475066,13197,'af','Buite dek',0),(475067,13197,'ro','AcoperÄƒ Ã®n afara',0),(475068,13197,'et','VÃ¤ljastpoolt katab',0),(475069,13197,'si','Zunaj zajema',0),(475070,13197,'ba','Di luar Covers',0),(475071,13197,'nl','Buiten Covers',0),(475072,13197,'fi','Ulkopuolella kattaa',0),(475073,13197,'no','Utenfor dekker',0),(475074,13197,'da','Covers',0),(475075,13197,'ko','ì™¸ë¶€ ì»¤ë²„',0),(475076,13197,'he','×ž×›×¡×” ×—×™×¦×•× ×™',0),(475077,13197,'el','ÎšÎ±Î»ÏÎ¼Î¼Î±Ï„Î± ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÏŽÎ½ ÏŒÏˆÎµÏ‰Î½',0),(475078,13197,'zh','å¤–é¢è¦†ç›–',0),(475079,13197,'sv','UtanfÃ¶r tÃ¤cker',0),(475080,13197,'it','Coperture esterne',0),(475081,13197,'tl','',0),(475082,13197,'th','à¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡à¸­à¸¢à¸¹à¹ˆà¸™à¸­à¸',0),(475083,13197,'hi','à¤¬à¤¾à¤¹à¤°à¥€ à¤•à¤µà¤°',0),(475084,13197,'ms','Meliputi di luar',0),(475085,13197,'ar','ÙŠØºØ·ÙŠ Ø®Ø§Ø±Ø¬',0),(475086,13197,'fr','Couvertures extÃ©rieures',0),(475087,13197,'jp','å¤–éƒ¨ã‚«ãƒãƒ¼',0),(475088,13197,'pt','Capas externas',0),(475089,13197,'ru','Ð’Ð½Ðµ ÐºÑ€Ñ‹ÑˆÐºÐ¸',0),(475090,13197,'es','Tapas Afuera',0),(475091,13197,'de','Ã„uÃŸeren Abdeckungen',0),(475092,13197,'en','Outside Covers',0),(475093,13198,'is','',0),(475094,13198,'dr','(Ù‡Ø²ÛŒÙ†Ù‡) Ù‡Ø±Ù‚ÛŒÙ…Øª(Ù†Ø±Ø® ',0),(475095,13198,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø´Ø§Ø±Ú˜(Ù‡Ø²ÛŒÙ†Ù‡) Ù‡Ø±Ù‚ÛŒÙ…Øª(Ù†Ø±Ø® ',0),(475096,13198,'tr','ParÃ§a baÅŸÄ±na Ã¼cret Ekle',0),(475097,13198,'pl','Dodaj bezpÅ‚atnie za sztukÄ™',0),(475098,13198,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð±Ñ€Ð¾Ð¹ÐºÐ°',0),(475099,13198,'ur','Ø§Ù„Ø²Ø§Ù… Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¹Ú©Ú‘Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(475100,13198,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð°ÐºÐ½Ð°Ð´Ð° Ð¿Ð¾ ÐºÐ¾Ð¼Ð°Ð´Ñƒ',0),(475101,13198,'vi','ThÃªm phÃ­ trÃªn má»—i Ä‘Æ¡n vá»‹',0),(475102,13198,'af','Voeg fooi Per stuk',0),(475103,13198,'ro','Adauga taxa Per bucata',0),(475104,13198,'et','Lisa tÃ¼kk kohta',0),(475105,13198,'si','Dodate dajatev na kos',0),(475106,13198,'ba','Menambahkan biaya Per buah',0),(475107,13198,'nl','Toevoegen gratis Per stuk',0),(475108,13198,'fi','LisÃ¤Ã¤t kulut Per kappale',0),(475109,13198,'no','Legger til Per brikke',0),(475110,13198,'da','TilfÃ¸je afgift Per Piece',0),(475111,13198,'ko','ì¡°ê° ë‹¹ ìš”ê¸ˆ ì¶”ê°€',0),(475112,13198,'he','×œ×”×•×¡×™×£ ×ª×©×œ×•× ×—×ª×™×›×”',0),(475113,13198,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ Ï‡ÏÎ­Ï‰ÏƒÎ· Î±Î½Î¬ Ï„ÎµÎ¼Î¬Ï‡Î¹Î¿',0),(475114,13198,'zh','æ·»åŠ æ¯ä»¶æ”¶è´¹',0),(475115,13198,'sv','LÃ¤gg till kostnad Per bit',0),(475116,13198,'it','Aggiungere il costo Per pezzo',0),(475117,13198,'tl','',0),(475118,13198,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸•à¹ˆà¸­à¸Šà¸´à¹‰à¸™',0),(475119,13198,'hi','à¤Ÿà¥à¤•à¤¡à¤¼à¤¾ à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¥à¤°à¤­à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(475120,13198,'ms','Tambah caj bagi setiap bahagian',0),(475121,13198,'ar','Ø¥Ø¶Ø§ÙØ© Ø±Ø³ÙˆÙ… Ù„ÙƒÙ„ Ù‚Ø·Ø¹Ø©',0),(475122,13198,'fr','Ajouter Charge par piÃ¨ce',0),(475123,13198,'jp','1 å€‹ã‚ãŸã‚Šæ–™é‡‘ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(475124,13198,'pt','Adicionar o custo por peÃ§a',0),(475125,13198,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð·Ð° ÑˆÑ‚ÑƒÐºÑƒ',0),(475126,13198,'es','Carga Adicional Por Pieza',0),(475127,13198,'de','FÃ¼gen Sie kostenlos pro StÃ¼ck',0),(475128,13198,'en','Add Charge Per Piece',0),(475129,13199,'is','',0),(475130,13199,'dr','(ÙˆÛŒÚ˜Ù‡',0),(475131,13199,'pr','Ù†ÙˆØ¹ ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡(ÙˆÛŒÚ˜Ù‡',0),(475132,13199,'tr','Ã–zel tÃ¼r',0),(475133,13199,'pl','Rodzaju promocje',0),(475134,13199,'bg','Ð¢Ð¸Ð¿ Ð¿Ñ€Ð¾Ð¼Ð¾Ñ†Ð¸Ð¸',0),(475135,13199,'ur','Ø®ØµÙˆØµÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(475136,13199,'sr','Ð’Ñ€ÑÑ‚Ðµ ÑÐ¿ÐµÑ†Ð¸Ñ˜Ð°Ð»Ð¸Ñ‚ÐµÑ‚Ð°',0),(475137,13199,'vi','Loáº¡i khuyáº¿n mÃ£i',0),(475138,13199,'af','Tipe Specials',0),(475139,13199,'ro','Tip de oferte speciale',0),(475140,13199,'et','TÃ¼Ã¼pi eripakkumist',0),(475141,13199,'si','Tip v akciji',0),(475142,13199,'ba','Jenis Spesial',0),(475143,13199,'nl','Soort Specials',0),(475144,13199,'fi','Tyyppi tarjoukset',0),(475145,13199,'no','Type tilbud',0),(475146,13199,'da','Type af tilbud',0),(475147,13199,'ko','íŠ¹ê°€ ìƒí’ˆì˜ ìœ í˜•',0),(475148,13199,'he','×“×‘×¨×™× ×ž×™×•×—×“×™×',0),(475149,13199,'el','Î¤ÏÏ€Î¿Ï‚-Î±Ï†Î¹ÎµÏÏŽÎ¼Î±Ï„Î±',0),(475150,13199,'zh','ç±»åž‹çš„ç‰¹ä»·',0),(475151,13199,'sv','Typ av Specials',0),(475152,13199,'it','Tipo di offerte speciali',0),(475153,13199,'tl','',0),(475154,13199,'th','à¸Šà¸™à¸´à¸”à¸žà¸´à¹€à¸¨à¸©',0),(475155,13199,'hi','à¤¸à¥à¤ªà¥‡à¤¶à¤² à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(475156,13199,'ms','Jenis istimewa',0),(475157,13199,'ar','Ù†ÙˆØ¹ Ù…Ù† Ø§Ù„Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø®Ø§ØµØ©',0),(475158,13199,'fr','Type de Specials',0),(475159,13199,'jp','ã‚¹ãƒšã‚·ãƒ£ãƒ«ã®ç¨®é¡ž',0),(475160,13199,'pt','Tipo de promoÃ§Ãµes',0),(475161,13199,'ru','Ð¢Ð¸Ð¿ ÑÐ¾Ð±Ñ‹Ñ‚Ð¸Ñ',0),(475162,13199,'es','Tipo de Especiales',0),(475163,13199,'de','Typ des Specials',0),(475164,13199,'en','Type Of Specials',0),(475165,13200,'is','',0),(475166,13200,'dr','ÙÛŒ Ù…Ø§Ù„ÛŒ ÛŒÚ©Ù†ÙˆØ§Ø®Øª ',0),(475167,13200,'pr','ÙÛŒ Ù…Ø§Ù„ÛŒ ÛŒÚ©Ù†ÙˆØ§Ø®Øª ',0),(475168,13200,'tr','Ekonomi sabit Ã¼cret',0),(475169,13200,'pl','Mieszkanie opÅ‚ata finansÃ³w',0),(475170,13200,'bg','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¸ Ñ„Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(475171,13200,'ur','Ù…Ø§Ù„ÛŒØ§Øª Ú©Û’ ÙÙ„ÛŒÙ¹ Ú©ÛŒ ÙÛŒØ³',0),(475172,13200,'sr','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¸Ñ˜Ð° Ñ…Ð¾Ð½Ð¾Ñ€Ð°Ñ€',0),(475173,13200,'vi','máº·t báº±ng phÃ­ tÃ i chÃ­nh',0),(475174,13200,'af','Finansies plat fooi',0),(475175,13200,'ro','TaxÄƒ fixÄƒ de finanÅ£e',0),(475176,13200,'et','Rahastada kindla tasu',0),(475177,13200,'si','Finance pavÅ¡alno pristojbino',0),(475178,13200,'ba','Biaya Flat keuangan',0),(475179,13200,'nl','FinanciÃ«n vergoeding',0),(475180,13200,'fi','Finance kiinteÃ¤ maksu',0),(475181,13200,'no','Finans fastprisen',0),(475182,13200,'da','Finance fast gebyr',0),(475183,13200,'ko','ê¸ˆìœµ ê· ì¼',0),(475184,13200,'he','×ž×™×ž×•×Ÿ ×©×›×¨ ×“×™×¨×”',0),(475185,13200,'el','Î•Ï†Î¬Ï€Î±Î¾Ï„Î­Î»Î¿Ï‚ Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŽÎ½',0),(475186,13200,'zh','è´¢åŠ¡è´¹ç”¨',0),(475187,13200,'sv','Finans avgift',0),(475188,13200,'it','Tariffa Flat di finanza',0),(475189,13200,'tl','',0),(475190,13200,'th','à¹€à¸‡à¸´à¸™à¸„à¹ˆà¸²à¹à¸šà¸™',0),(475191,13200,'hi','à¤µà¤¿à¤¤à¥à¤¤ à¤«à¥à¤²à¥ˆà¤Ÿ à¤¶à¥à¤²à¥à¤•',0),(475192,13200,'ms','Kos tetap kewangan',0),(475193,13200,'ar','ØªÙ…ÙˆÙŠÙ„ Ø±Ø³ÙˆÙ… Ù…Ø³Ø·Ø­Ø©',0),(475194,13200,'fr','Forfait de finances',0),(475195,13200,'jp','é‡‘èžå®šé¡æ–™é‡‘',0),(475196,13200,'pt','Taxa fixa de finanÃ§as',0),(475197,13200,'ru','Ð¤Ð¸Ð½Ð°Ð½ÑÑ‹ Ñ„Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½ÑƒÑŽ Ð¿Ð»Ð°Ñ‚Ñƒ',0),(475198,13200,'es','Financimiento Cuota Fijo',0),(475199,13200,'de','Finanzen-Pauschale',0),(475200,13200,'en','Finance Flat Fee',0),(475201,13201,'is','',0),(475202,13201,'dr','ØªØ§Ø±ÛŒØ® ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡',0),(475203,13201,'pr','ØªØ§Ø±ÛŒØ® ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡',0),(475204,13201,'tr','Onaylanan tarihi',0),(475205,13201,'pl','Zatwierdzonych dnia',0),(475206,13201,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾Ð´Ð¾Ð±Ñ€ÑÐ²Ð°Ð½Ðµ',0),(475207,13201,'ur','Ù…Ù†Ø¸ÙˆØ± Ø´Ø¯Û ØªØ§Ø±ÛŒØ®',0),(475208,13201,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(475209,13201,'vi','NgÃ¡y phÃª duyá»‡t',0),(475210,13201,'af','Goedgekeurde Datum',0),(475211,13201,'ro','Data aprobat',0),(475212,13201,'et','Kinnitamise kuupÃ¤ev',0),(475213,13201,'si','Odobreni',0),(475214,13201,'ba','Tanggal disetujui',0),(475215,13201,'nl','Goedgekeurde datum',0),(475216,13201,'fi','HyvÃ¤ksytty pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(475217,13201,'no','Godkjent dato',0),(475218,13201,'da','Godkendt dato',0),(475219,13201,'ko','ìŠ¹ì¸ëœ ë‚ ì§œ',0),(475220,13201,'he','×ª××¨×™×š ×ž××•×©×¨',0),(475221,13201,'el','Î•Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(475222,13201,'zh','æ‰¹å‡†çš„æ—¥æœŸ',0),(475223,13201,'sv','GodkÃ¤nda datum',0),(475224,13201,'it','Approvato data',0),(475225,13201,'tl','',0),(475226,13201,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(475227,13201,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(475228,13201,'ms','Tarikh diluluskan',0),(475229,13201,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…ÙˆØ§ÙÙ‚ Ø¹Ù„ÙŠÙ‡Ø§',0),(475230,13201,'fr','Date approuvÃ©',0),(475231,13201,'jp','æ‰¿èªå¹´æœˆæ—¥',0),(475232,13201,'pt','Data aprovada',0),(475233,13201,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ Ð´Ð°Ñ‚Ñ‹',0),(475234,13201,'es','Fecha Aprobado',0),(475235,13201,'de','Zugelassenen Datum',0),(475236,13201,'en','Approved Date',0),(475237,13202,'is','',0),(475238,13202,'dr','ØªØ§ÛŒÛŒØ¯ Ù…Ø¨Ø§Ù„Øº',0),(475239,13202,'pr','ØªØ§ÛŒÛŒØ¯ Ù…Ø¨Ø§Ù„Øº',0),(475240,13202,'tr','TutarlarÄ± onaylama',0),(475241,13202,'pl','Zatwierdza kwoty',0),(475242,13202,'bg','ÐžÐ´Ð¾Ð±Ñ€ÑÐ²Ð°Ñ‚ ÑÑƒÐ¼Ð¸',0),(475243,13202,'ur','Ø±Ù‚ÙˆÙ… Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ',0),(475244,13202,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð¸ Ð¸Ð·Ð½Ð¾ÑÐµ',0),(475245,13202,'vi','Sá»‘ tiá»n phÃª duyá»‡t',0),(475246,13202,'af','Goedgekeurde Bedrae',0),(475247,13202,'ro','AprobÄƒ cuantumurile',0),(475248,13202,'et','Kiita heaks summad',0),(475249,13202,'si','Odobri viÅ¡ino',0),(475250,13202,'ba','Menyetujui jumlah',0),(475251,13202,'nl','Goedkeuren van bedragen',0),(475252,13202,'fi','HyvÃ¤ksy mÃ¤Ã¤rÃ¤t',0),(475253,13202,'no','Godkjenne belÃ¸p',0),(475254,13202,'da','Godkende belÃ¸b',0),(475255,13202,'ko','ìŠ¹ì¸ ê¸ˆì•¡',0),(475256,13202,'he','×œ××©×¨ ×›×ž×•×™×•×ª',0),(475257,13202,'el','Î•Î³ÎºÏÎ¯Î½ÎµÎ¹ Ï„Î± Ï€Î¿ÏƒÎ¬',0),(475258,13202,'zh','æ ¸å‡†çš„æ•°é¢',0),(475259,13202,'sv','GodkÃ¤nna belopp',0),(475260,13202,'it','Approvare gli importi',0),(475261,13202,'tl','',0),(475262,13202,'th','à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™',0),(475263,13202,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€',0),(475264,13202,'ms','Meluluskan jumlah',0),(475265,13202,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø¨Ø§Ù„Øº',0),(475266,13202,'fr','Approuver les montants',0),(475267,13202,'jp','æ‰¿èªé‡‘é¡',0),(475268,13202,'pt','Aprovar os montantes',0),(475269,13202,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ ÑÑƒÐ¼Ð¼Ñ‹',0),(475270,13202,'es','Montos Aprobados',0),(475271,13202,'de','BetrÃ¤ge genehmigen',0),(475272,13202,'en','Approve Amounts',0),(475273,13203,'is','',0),(475274,13203,'dr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯ ÙˆØ§Ù‚Ø¹ÛŒ',0),(475275,13203,'pr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯ ÙˆØ§Ù‚Ø¹ÛŒ',0),(475276,13203,'tr','GerÃ§ek para',0),(475277,13203,'pl','Rzeczywistych Å›rodkÃ³w pieniÄ™Å¼nych',0),(475278,13203,'bg','Ð‘Ñ€Ð¾Ð¹ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¸',0),(475279,13203,'ur','Ù†Ù‚Ø¯ Ø§ØµÙ„',0),(475280,13203,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð¸ Ð½Ð¾Ð²Ð°Ñ†',0),(475281,13203,'vi','tiá»n máº·t thá»±c táº¿',0),(475282,13203,'af','Werklike Kontant',0),(475283,13203,'ro','Real de numerar',0),(475284,13203,'et','Raha tegeliku',0),(475285,13203,'si','Dejanski denarni',0),(475286,13203,'ba','Uang tunai yang sebenarnya',0),(475287,13203,'nl','Contant geld werkelijke',0),(475288,13203,'fi','Todellinen kÃ¤teistÃ¤',0),(475289,13203,'no','Kontanter faktisk',0),(475290,13203,'da','Kontant faktiske',0),(475291,13203,'ko','ì‹¤ì œ í˜„ê¸ˆ',0),(475292,13203,'he','×ž×–×•×ž× ×™× ×‘×¤×•×¢×œ',0),(475293,13203,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® Î¼ÎµÏ„ÏÎ·Ï„Î¬',0),(475294,13203,'zh','å®žé™…çš„çŽ°é‡‘',0),(475295,13203,'sv','Cash faktiska',0),(475296,13203,'it','Denaro reale',0),(475297,13203,'tl','',0),(475298,13203,'th','à¹€à¸‡à¸´à¸™à¸ªà¸”à¸ˆà¸£à¸´à¸‡',0),(475299,13203,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤¨à¤•à¤¦',0),(475300,13203,'ms','Wang Tunai yang sebenar',0),(475301,13203,'ar','Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø§Ù„ÙØ¹Ù„ÙŠØ©',0),(475302,13203,'fr','Argent rÃ©el',0),(475303,13203,'jp','å®Ÿéš›ã®ç¾é‡‘',0),(475304,13203,'pt','Dinheiro real',0),(475305,13203,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð² Ð² Ñ€ÐµÐ°Ð»ÑŒÐ½Ñ‹Ñ…',0),(475306,13203,'es','Efectivo Actual',0),(475307,13203,'de','Bargeld, die tatsÃ¤chliche',0),(475308,13203,'en','Cash Actual',0),(475309,13204,'is','',0),(475310,13204,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÙˆÙ„ Ù†Ù‚Ø¯ Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø² Ú©Ø§Ø±Ø¨Ø±',0),(475311,13204,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÙˆÙ„ Ù†Ù‚Ø¯ Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø² Ú©Ø§Ø±Ø¨Ø±',0),(475312,13204,'tr','KullanÄ±cÄ±dan alÄ±nan nakit miktarÄ±',0),(475313,13204,'pl','Kwota Å›rodkÃ³w pieniÄ™Å¼nych otrzymanych od uÅ¼ytkownika',0),(475314,13204,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑƒÐ¼Ð¸, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ Ð¾Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ',0),(475315,13204,'ur','Ù†Ù‚Ø¯ Ø±Ù‚Ù… ØµØ§Ø±Ù Ø³Û’ Ù…Ù„ÛŒ',0),(475316,13204,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð·Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ñƒ Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾ Ð¾Ð´ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(475317,13204,'vi','Sá»‘ tiá»n nháº­n Ä‘Æ°á»£c tá»« ngÆ°á»i sá»­ dá»¥ng',0),(475318,13204,'af','Kontantbedrag Ontvang Vanaf Gebruiker',0),(475319,13204,'ro','Suma de bani primite de la utilizator',0),(475320,13204,'et','Kasutajalt saadud raha summa',0),(475321,13204,'si','Denarni znesek, ki je Prejeto od uporabnika',0),(475322,13204,'ba','Jumlah uang tunai yang diterima dari pengguna',0),(475323,13204,'nl','Contante bedrag van gebruiker ontvangen',0),(475324,13204,'fi','KÃ¤teisvarojen mÃ¤Ã¤rÃ¤ kÃ¤yttÃ¤jÃ¤ltÃ¤ vastaanotettu',0),(475325,13204,'no','KontantbelÃ¸p mottatt fra brukeren',0),(475326,13204,'da','KontantbelÃ¸b modtaget fra brugeren',0),(475327,13204,'ko','ì‚¬ìš©ìž ë¡œë¶€í„° ë°›ì€ ê¸ˆì•¡ì„ í˜„ê¸ˆ',0),(475328,13204,'he','×¡×›×•× ×”×›×¡×£ ×©×”×ª×§×‘×œ ×ž×ž×©×ª×ž×© ×œ×ž×©×ª×ž×©',0),(475329,13204,'el','Î Î¿ÏƒÏŒ Î¼ÎµÏ„ÏÎ·Ï„ÏŽÎ½ Ï€Î¿Ï… Î­Î»Î±Î²Îµ Î±Ï€ÏŒ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(475330,13204,'zh','ä»Žç”¨æˆ·æ”¶åˆ°çš„çŽ°é‡‘é‡‘é¢',0),(475331,13204,'sv','Kontantbelopp som togs emot frÃ¥n anvÃ¤ndaren',0),(475332,13204,'it','Importo in denaro ricevuto dall\'utente',0),(475333,13204,'tl','',0),(475334,13204,'th','à¸ˆà¸³à¸™à¸§à¸™à¹€à¸‡à¸´à¸™à¸ªà¸”à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸ˆà¸²à¸à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(475335,13204,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¥‡ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤•à¤¦ à¤°à¤¾à¤¶à¤¿',0),(475336,13204,'ms','Amaun tunai yang diterima daripada pengguna',0),(475337,13204,'ar','Ù…Ù‚Ø¯Ø§Ø± Ø§Ù„Ù†Ù‚Ø¯ÙŠØ© Ø§Ù„ÙˆØ§Ø±Ø¯Ø© Ù…Ù† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(475338,13204,'fr','Montant en espÃ¨ces reÃ§u de l\'utilisateur',0),(475339,13204,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‹ã‚‰å—ã‘å–ã£ãŸç¾é‡‘ã®é¡',0),(475340,13204,'pt','Quantidade de dinheiro que recebeu do usuÃ¡rio',0),(475341,13204,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð², Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ñ‚ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(475342,13204,'es','Monto de Efectivo Recibido del Usuario',0),(475343,13204,'de','Cash-Betrag von Benutzer erhalten',0),(475344,13204,'en','Cash Amount Received From User',0),(475345,13205,'is','',0),(475346,13205,'dr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯ Ù…ØªÙØ§ÙˆØª',0),(475347,13205,'pr','Ù¾ÙˆÙ„ Ù†Ù‚Ø¯ Ù…ØªÙØ§ÙˆØª',0),(475348,13205,'tr','Nakit farkÄ±',0),(475349,13205,'pl','RÃ³Å¼nica gotÃ³wki',0),(475350,13205,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ Ñ€Ð°Ð·Ð»Ð¸ÐºÐ°',0),(475351,13205,'ur','Ù†Ù‚Ø¯ ÙØ±Ù‚',0),(475352,13205,'sr','Ð Ð°Ð·Ð»Ð¸ÐºÐ° Ñƒ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ð½Ð¸',0),(475353,13205,'vi','ChÃªnh lá»‡ch tiá»n',0),(475354,13205,'af','Kontant Verskil',0),(475355,13205,'ro','Diferenta de bani',0),(475356,13205,'et','Raha vahe',0),(475357,13205,'si','Gotovine razlika',0),(475358,13205,'ba','Perbedaan tunai',0),(475359,13205,'nl','Contant geld verschil',0),(475360,13205,'fi','KÃ¤teistÃ¤ ero',0),(475361,13205,'no','Kontanter forskjellen',0),(475362,13205,'da','Kontant forskel',0),(475363,13205,'ko','í˜„ê¸ˆ ì°¨ì´',0),(475364,13205,'he','×”×”×¤×¨×© ×‘×ž×–×•×ž×Ÿ',0),(475365,13205,'el','ÎœÎµÏ„ÏÎ·Ï„Î¬ Î´Î¹Î±Ï†Î¿ÏÎ¬',0),(475366,13205,'zh','çŽ°é‡‘å·®å¼‚',0),(475367,13205,'sv','Cash skillnaden',0),(475368,13205,'it','Differenza in contanti',0),(475369,13205,'tl','',0),(475370,13205,'th','à¸„à¸§à¸²à¸¡à¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸‚à¸­à¸‡à¹€à¸‡à¸´à¸™à¸ªà¸”',0),(475371,13205,'hi','à¤¨à¤•à¤¦ à¤…à¤‚à¤¤à¤°',0),(475372,13205,'ms','Perbezaan Wang Tunai',0),(475373,13205,'ar','Ø§Ù„ÙØ±Ù‚ Ø§Ù„Ù†Ù‚Ø¯ÙŠ',0),(475374,13205,'fr','DiffÃ©rence de trÃ©sorerie',0),(475375,13205,'jp','ç¾é‡‘ã®é•ã„',0),(475376,13205,'pt','DiferenÃ§a em dinheiro',0),(475377,13205,'ru','Ð Ð°Ð·Ð½Ð¸Ñ†Ð° Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ… ÑÑ€ÐµÐ´ÑÑ‚Ð²',0),(475378,13205,'es','Diferencia de Efectivo',0),(475379,13205,'de','Bargeld-Unterschied',0),(475380,13205,'en','Cash Difference',0),(475381,13206,'is','',0),(475382,13206,'dr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ ÙˆØ§Ù‚Ø¹ÛŒ',0),(475383,13206,'pr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ ÙˆØ§Ù‚Ø¹ÛŒ',0),(475384,13206,'tr','CC gerÃ§ek',0),(475385,13206,'pl','CC rzeczywiste',0),(475386,13206,'bg','CC Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ',0),(475387,13206,'ur','CC Ø§ØµÙ„',0),(475388,13206,'sr','Ð¦Ð¦ ÑÑ‚Ð²Ð°Ñ€Ð½Ðµ',0),(475389,13206,'vi','Äá»“ng gá»­ithá»±c táº¿',0),(475390,13206,'af','BK werklike',0),(475391,13206,'ro','CC reale',0),(475392,13206,'et','CC tegelik',0),(475393,13206,'si','CC dejanske',0),(475394,13206,'ba','CC aktual',0),(475395,13206,'nl','CC werkelijke',0),(475396,13206,'fi','CC itse',0),(475397,13206,'no','CC faktiske',0),(475398,13206,'da','CC faktiske',0),(475399,13206,'ko','ì‹¤ì œ CC',0),(475400,13206,'he','CC ×‘×¤×•×¢×œ',0),(475401,13206,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® CC',0),(475402,13206,'zh','CC å®žé™…',0),(475403,13206,'sv','CC faktiska',0),(475404,13206,'it','CC effettivo',0),(475405,13206,'tl','',0),(475406,13206,'th','CC à¸ˆà¸£à¸´à¸‡',0),(475407,13206,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿',0),(475408,13206,'ms','CC sebenar',0),(475409,13206,'ar','CC Ø§Ù„ÙØ¹Ù„ÙŠØ©',0),(475410,13206,'fr','CC rÃ©el',0),(475411,13206,'jp','å®Ÿéš›ã® CC',0),(475412,13206,'pt','CC real',0),(475413,13206,'ru','CC Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ð¹',0),(475414,13206,'es','CC Actual',0),(475415,13206,'de','CC tatsÃ¤chliche',0),(475416,13206,'en','CC Actual',0),(475417,13207,'is','',0),(475418,13207,'dr','Ù…Ø¨Ù„Øº Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ØªÙˆØ³Ø· Ú©Ø§Ø±Ø¨Ø±',0),(475419,13207,'pr','Ù…Ø¨Ù„Øº Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø§Ø¹Ù„Ø§Ù… Ø´Ø¯Ù‡ ØªÙˆØ³Ø· Ú©Ø§Ø±Ø¨Ø±',0),(475420,13207,'tr','KullanÄ±cÄ± tarafÄ±ndan bildirilen bilgi miktarÄ±',0),(475421,13207,'pl','CC iloÅ›ci zgÅ‚oszonych przez uÅ¼ytkownikÃ³w',0),(475422,13207,'bg','CC ÑÑƒÐ¼Ð°, ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸ Ð¾Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ',0),(475423,13207,'ur','ØµØ§Ø±Ù Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø±Ù¾ÙˆØ±Ù¹ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø³ÛŒ Ø³ÛŒ Ø±Ù‚Ù…',0),(475424,13207,'sr','Ð¦Ð¦ Ð¸Ð·Ð½Ð¾Ñ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ð»Ð¾ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(475425,13207,'vi','Äá»“ng gá»­i bÃ¡o cÃ¡o sá»‘ tiá»n  theo ngÆ°á»i sá»­ dá»¥ng',0),(475426,13207,'af','BK bedrag gerapporteer deur gebruiker',0),(475427,13207,'ro','CC suma raportate de cÄƒtre utilizator',0),(475428,13207,'et','CC summa kasutaja poolt',0),(475429,13207,'si','CC znesek referat z uporabnik',0),(475430,13207,'ba','Jumlah CC yang dilaporkan oleh pengguna',0),(475431,13207,'nl','CC bedrag gemeld door gebruiker',0),(475432,13207,'fi','CC ilmoittama kÃ¤yttÃ¤jÃ¤',0),(475433,13207,'no','CC mengde som rapporteres av bruker',0),(475434,13207,'da','CC belÃ¸b indberettet af brugeren',0),(475435,13207,'ko','ì‚¬ìš©ìžì— ì˜í•´ ë³´ê³  ëœ CC ê¸ˆì•¡ì´',0),(475436,13207,'he','×›×ž×•×ª CC ×©×“×•×•×—×• ×¢×œ-×™×“×™ ×”×ž×©×ª×ž×©',0),(475437,13207,'el','CC Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±Ï‚ Ï€Î¿Ï… Î±Î½Î±Ï†Î­ÏÎµÏ„Î±Î¹ Î±Ï€ÏŒ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(475438,13207,'zh','æŠ¥å‘Šç”±ç”¨æˆ·çš„ CC é‡‘é¢',0),(475439,13207,'sv','CC beloppet av anvÃ¤ndare',0),(475440,13207,'it','CC importo segnalato da utente',0),(475441,13207,'tl','',0),(475442,13207,'th','à¸ˆà¸³à¸™à¸§à¸™ CC à¸—à¸µà¹ˆà¸£à¸²à¸¢à¸‡à¸²à¸™ à¹‚à¸”à¸¢à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(475443,13207,'hi','CC à¤°à¤¾à¤¶à¤¿ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥€ à¤¸à¥‚à¤šà¤¨à¤¾',0),(475444,13207,'ms','Jumlah CC yang dilaporkan oleh pengguna',0),(475445,13207,'ar','CC Ø§Ù„Ù…Ø¨Ù„Øº Ø¹Ù†Ù‡Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(475446,13207,'fr','CC montant indiquÃ© par l\'utilisateur',0),(475447,13207,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«ã‚ˆã£ã¦å ±å‘Šã•ã‚ŒãŸ CC é‡',0),(475448,13207,'pt','Quantidade CC relatada pelo usuÃ¡rio',0),(475449,13207,'ru','Ð¡ÑƒÐ¼Ð¼Ð° CC, ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¼',0),(475450,13207,'es','CC Monto Reportado Por Usuario',0),(475451,13207,'de','CC-Menge, die vom Benutzer gemeldet',0),(475452,13207,'en','CC Amount Reported By User',0),(475453,13208,'is','',0),(475454,13208,'dr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù…ØªÙØ§ÙˆØª',0),(475455,13208,'pr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù…ØªÙØ§ÙˆØª',0),(475456,13208,'tr','CC farkÄ±',0),(475457,13208,'pl','RÃ³Å¼nica CC',0),(475458,13208,'bg','CC Ñ€Ð°Ð·Ð»Ð¸ÐºÐ°',0),(475459,13208,'ur','CC ÙØ±Ù‚',0),(475460,13208,'sr','Ð¦Ð¦ Ñ€Ð°Ð·Ð»Ð¸ÐºÐ°',0),(475461,13208,'vi','Äá»“ng gá»­i khÃ¡c nhau',0),(475462,13208,'af','BK verskil',0),(475463,13208,'ro','CC diferenÅ£a',0),(475464,13208,'et','CC erinevus',0),(475465,13208,'si','CC razlika',0),(475466,13208,'ba','Perbedaan CC',0),(475467,13208,'nl','CC verschil',0),(475468,13208,'fi','CC ero',0),(475469,13208,'no','CC forskjellen',0),(475470,13208,'da','CC forskel',0),(475471,13208,'ko','CC ì°¨ì´',0),(475472,13208,'he','×”×”×‘×“×œ CC',0),(475473,13208,'el','Î”Î¹Î±Ï†Î¿ÏÎ¬ CC',0),(475474,13208,'zh','CC çš„åŒºåˆ«',0),(475475,13208,'sv','CC skillnaden',0),(475476,13208,'it','Differenza CC',0),(475477,13208,'tl','',0),(475478,13208,'th','à¸„à¸§à¸²à¸¡à¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸‚à¸­à¸‡ CC',0),(475479,13208,'hi','CC à¤…à¤‚à¤¤à¤°',0),(475480,13208,'ms','Perbezaan CC',0),(475481,13208,'ar','Ø§Ù„ÙØ±Ù‚ CC',0),(475482,13208,'fr','DiffÃ©rence CC',0),(475483,13208,'jp','CC ã®é•ã„',0),(475484,13208,'pt','DiferenÃ§a CC',0),(475485,13208,'ru','Ð Ð°Ð·Ð½Ð¸Ñ†Ð° CC',0),(475486,13208,'es','CC Diferencia',0),(475487,13208,'de','CC-Unterschied',0),(475488,13208,'en','CC Difference',0),(475489,13209,'is','',0),(475490,13209,'dr','Ú†Ú© ÙˆØ§Ù‚Ø¹ÛŒ',0),(475491,13209,'pr','Ú†Ú© ÙˆØ§Ù‚Ø¹ÛŒ',0),(475492,13209,'tr','Onay gerÃ§ek',0),(475493,13209,'pl','SprawdÅº rzeczywiste',0),(475494,13209,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ñ€ÐµÐ°Ð»Ð½Ð¸Ñ‚Ðµ',0),(475495,13209,'ur','Ú†ÛŒÚ© Ø§Ù† Ø§ØµÙ„',0),(475496,13209,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ ÑÑ‚Ð²Ð°Ñ€Ð½Ðµ',0),(475497,13209,'vi','SÃ©c thá»±c táº¿',0),(475498,13209,'af','Kontroleer Werklike',0),(475499,13209,'ro','Selectare reale',0),(475500,13209,'et','Sisse tegelik',0),(475501,13209,'si','Preverjanje dejanskega',0),(475502,13209,'ba','Check aktual',0),(475503,13209,'nl','Selectievakje werkelijke',0),(475504,13209,'fi','Uloskirjautuminen todellinen',0),(475505,13209,'no','Sjekk faktiske',0),(475506,13209,'da','Check faktiske',0),(475507,13209,'ko','ì‹¤ì œ í™•ì¸',0),(475508,13209,'he','×”×¡×™×ž×•×Ÿ ×‘×¤×•×¢×œ',0),(475509,13209,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(475510,13209,'zh','æ£€æŸ¥å®žé™…',0),(475511,13209,'sv','Kontrollera faktiska',0),(475512,13209,'it','Controllo effettivo',0),(475513,13209,'tl','',0),(475514,13209,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸ˆà¸£à¸´à¸‡',0),(475515,13209,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤šà¥‡à¤•',0),(475516,13209,'ms','Semak yang sebenar',0),(475517,13209,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ÙØ¹Ù„ÙŠ',0),(475518,13209,'fr','Cocher rÃ©el',0),(475519,13209,'jp','å®Ÿéš›ã®ãƒã‚§ãƒƒã‚¯',0),(475520,13209,'pt','SeleÃ§Ã£o real',0),(475521,13209,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ð¹',0),(475522,13209,'es','Cheque Actual',0),(475523,13209,'de','KontrollkÃ¤stchen tatsÃ¤chlichen',0),(475524,13209,'en','Check Actual',0),(475525,13210,'is','',0),(475526,13210,'dr','Ù…Ø¨Ù„Øº Ú†Ú© Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø² Ú©Ø§Ø±Ø¨Ø±',0),(475527,13210,'pr','Ù…Ø¨Ù„Øº Ú†Ú© Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ø§Ø² Ú©Ø§Ø±Ø¨Ø±',0),(475528,13210,'tr','KullanÄ±cÄ±dan alÄ±nan kontrol edin',0),(475529,13210,'pl','SprawdÅº iloÅ›Ä‡ odebranych od uÅ¼ytkownikÃ³w',0),(475530,13210,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ ÑÑƒÐ¼Ð°Ñ‚Ð°, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð° Ð¾Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(475531,13210,'ur','ØµØ§Ø±Ù Ø³Û’ Ù…ÙˆØµÙˆÙ„Û Ø±Ù‚Ù… Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(475532,13210,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð¸Ð·Ð½Ð¾Ñ Ð¿Ñ€Ð¸Ð¼Ð¸Ð¾ Ð¾Ð´ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(475533,13210,'vi','Kiá»ƒm tra sá»‘ tiá»n nháº­n tá»« ngÆ°á»i sá»­ dá»¥ng',0),(475534,13210,'af','Kontroleer Bedrag Ontvang van die Gebruiker',0),(475535,13210,'ro','Selectare sume primite de la utilizator',0),(475536,13210,'et','Kontrollige saanud kasutaja palju',0),(475537,13210,'si','Preverite znesek, ki je Prejeto od uporabnika',0),(475538,13210,'ba','Memeriksa jumlah yang diterima dari pengguna',0),(475539,13210,'nl','Selectievakje bedrag van gebruiker ontvangen',0),(475540,13210,'fi','Tarkistaa mÃ¤Ã¤rÃ¤ kÃ¤yttÃ¤jÃ¤ltÃ¤ vastaanotettu',0),(475541,13210,'no','Kontrollere belÃ¸pet mottatt fra brukeren',0),(475542,13210,'da','Check belÃ¸b modtaget fra brugeren',0),(475543,13210,'ko','ì‚¬ìš©ìž ë¡œë¶€í„° ë°›ì€ ê¸ˆì•¡ì„ í™•ì¸',0),(475544,13210,'he','×œ×‘×“×•×§ ××ª ×”×¡×›×•× ×”×ž×ª×§×‘×œ ×ž×ž×©×ª×ž×© ×œ×ž×©×ª×ž×©',0),(475545,13210,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î¿ Ï€Î¿ÏƒÏŒ Ï€Î¿Ï… Î­Î»Î±Î²Îµ Î±Ï€ÏŒ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(475546,13210,'zh','æ£€æŸ¥æ”¶åˆ°ç”¨æˆ·çš„æ•°é‡',0),(475547,13210,'sv','Kontrollera belopp togs emot frÃ¥n anvÃ¤ndaren',0),(475548,13210,'it','Verificare l\'importo ricevuto dall\'utente',0),(475549,13210,'tl','',0),(475550,13210,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸ˆà¸²à¸à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(475551,13210,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¥‡ à¤ªà¥à¤°à¤¾à¤ªà¥ à¤¤ à¤°à¤¾à¤¶à¤¿ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(475552,13210,'ms','Menyemak jumlah yang diterima daripada pengguna',0),(475553,13210,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù„Ù…ØªÙ„Ù‚Ø§Ø© Ù…Ù† Ù…Ø³ØªØ®Ø¯Ù…',0),(475554,13210,'fr','Montant du chÃ¨que reÃ§u de l\'utilisateur',0),(475555,13210,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‹ã‚‰å—ä¿¡ã—ãŸé‡ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(475556,13210,'pt','Verificar o montante recebido do usuÃ¡rio',0),(475557,13210,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ ÑÑƒÐ¼Ð¼Ñƒ, Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½ÑƒÑŽ Ð¾Ñ‚ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(475558,13210,'es','Monto de Cheque Recibido Por El Usuario',0),(475559,13210,'de','Scheckbetrag erhielt von Benutzer',0),(475560,13210,'en','Check Amount Received From User',0),(475561,13211,'is','',0),(475562,13211,'dr','Ú†Ú© Ù…Ø®ØªÙ„Ù',0),(475563,13211,'pr','Ú†Ú© Ù…Ø®ØªÙ„Ù',0),(475564,13211,'tr','Onay fark',0),(475565,13211,'pl','SprawdÅº rÃ³Å¼nicÄ™',0),(475566,13211,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ñ€Ð°Ð·Ð»Ð¸ÐºÐ°',0),(475567,13211,'ur','ÙØ±Ù‚ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(475568,13211,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ñ€Ð°Ð·Ð»Ð¸ÐºÑƒ',0),(475569,13211,'vi','SÃ©c khÃ¡c',0),(475570,13211,'af','Kontroleer Verskil',0),(475571,13211,'ro','VerificaÅ£i diferenÅ£a',0),(475572,13211,'et','Kontrollige erinevus',0),(475573,13211,'si','Preverite razliko',0),(475574,13211,'ba','Memeriksa perbedaan',0),(475575,13211,'nl','Selectievakje verschil',0),(475576,13211,'fi','Tarkista ero',0),(475577,13211,'no','Se forskjellen',0),(475578,13211,'da','Check forskellen',0),(475579,13211,'ko','ì°¨ì´ í™•ì¸',0),(475580,13211,'he','×œ×‘×“×•×§ ××ª ×”×”×‘×“×œ',0),(475581,13211,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î· Î´Î¹Î±Ï†Î¿ÏÎ¬',0),(475582,13211,'zh','æ£€æŸ¥å·®å¼‚',0),(475583,13211,'sv','Kolla skillnaden',0),(475584,13211,'it','Controllare la differenza',0),(475585,13211,'tl','',0),(475586,13211,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸„à¸§à¸²à¸¡à¹à¸•à¸à¸•à¹ˆà¸²à¸‡',0),(475587,13211,'hi','à¤…à¤‚à¤¤à¤° à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(475588,13211,'ms','Semak perbezaan',0),(475589,13211,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„ÙØ±Ù‚',0),(475590,13211,'fr','VÃ©rifier la diffÃ©rence',0),(475591,13211,'jp','é•ã„ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(475592,13211,'pt','Verificar a diferenÃ§a',0),(475593,13211,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ñ€Ð°Ð·Ð½Ð¸Ñ†Ñƒ',0),(475594,13211,'es','Diferencia de Cheque',0),(475595,13211,'de','Unterschied zu Ã¼berprÃ¼fen',0),(475596,13211,'en','Check Difference',0),(475597,13212,'is','',0),(475598,13212,'dr','(ÙˆØµÙˆÙ„) ØªÙˆØ³Ø·',0),(475599,13212,'pr','Ø¬Ù…Ø¹ Ø¢ÙˆØ±ÛŒ Ø´Ø¯Ù‡(ÙˆØµÙˆÙ„) ØªÙˆØ³Ø·',0),(475600,13212,'tr','TarafÄ±ndan toplanan',0),(475601,13212,'pl','Zebrane przez',0),(475602,13212,'bg','Ð¡ÑŠÐ±Ñ€Ð°Ð½Ð¸ Ð¾Ñ‚',0),(475603,13212,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¬Ù…Ø¹ Ú©ÛŒ Ú¯Ø¦ÛŒ',0),(475604,13212,'sr','ÐŸÑ€Ð¸ÐºÑƒÐ¿Ñ™ÐµÐ½Ðµ Ð¿ÑƒÑ‚ÐµÐ¼',0),(475605,13212,'vi','Thu bá»Ÿi',0),(475606,13212,'af','Versamel deur',0),(475607,13212,'ro','Colectate de',0),(475608,13212,'et','Kogutud',0),(475609,13212,'si','Zbirajo',0),(475610,13212,'ba','Dikumpulkan oleh',0),(475611,13212,'nl','Verzameld door',0),(475612,13212,'fi','KerÃ¤Ã¤mÃ¤t',0),(475613,13212,'no','Samlet av',0),(475614,13212,'da','Indsamlet af',0),(475615,13212,'ko','ì— ì˜í•´ ìˆ˜ì§‘ ëœ',0),(475616,13212,'he','×©× ××¡×£ ×¢×œ-×™×“×™',0),(475617,13212,'el','Î£Ï…Î»Î»Î­Î³Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ',0),(475618,13212,'zh','ç”±æ”¶é›†',0),(475619,13212,'sv','Samlas in av',0),(475620,13212,'it','Raccolti da',0),(475621,13212,'tl','',0),(475622,13212,'th','à¸£à¸§à¸šà¸£à¸§à¸¡à¹‚à¸”à¸¢',0),(475623,13212,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤à¤•à¤¤à¥à¤°à¤¿à¤¤',0),(475624,13212,'ms','Dikumpul oleh',0),(475625,13212,'ar','Ø¬Ù…Ø¹ØªÙ‡Ø§',0),(475626,13212,'fr','Recueillis par',0),(475627,13212,'jp','ã«ã‚ˆã£ã¦åŽé›†ã•ã‚Œã¾ã—ãŸã€‚',0),(475628,13212,'pt','Coletados por',0),(475629,13212,'ru','Ð¡Ð¾Ð±Ñ€Ð°Ð½Ð½Ñ‹Ðµ',0),(475630,13212,'es','Cobrado Por',0),(475631,13212,'de','Zusammengestellt von',0),(475632,13212,'en','Collected By',0),(475633,13213,'is','',0),(475634,13213,'dr','(Ø¬Ù…Ø¹ Ø¢ÙˆØ±ÛŒ ) Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(475635,13213,'pr','ÙˆØµÙˆÙ„(Ø¬Ù…Ø¹ Ø¢ÙˆØ±ÛŒ ) Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§',0),(475636,13213,'tr','Ã–demeleri toplamak',0),(475637,13213,'pl','Zbieranie pÅ‚atnoÅ›ci',0),(475638,13213,'bg','Ð¡ÑŠÐ±Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(475639,13213,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¬Ù…Ø¹ Ú©Ø±ØªÛ’ ÛÛŒÚº',0),(475640,13213,'sr','ÐŸÑ€Ð¸ÐºÑƒÐ¿Ð¸Ð»Ð¸ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(475641,13213,'vi','Thu tiá»n ',0),(475642,13213,'af','Samel betalings',0),(475643,13213,'ro','Colecta plÄƒÅ£i',0),(475644,13213,'et','Maksete kogumine',0),(475645,13213,'si','Zbiranje plaÄil',0),(475646,13213,'ba','Mengumpulkan pembayaran',0),(475647,13213,'nl','Verzamelen van betalingen',0),(475648,13213,'fi','KerÃ¤tÃ¤ maksuja',0),(475649,13213,'no','Innkassere betaling',0),(475650,13213,'da','Indsamle betalinger',0),(475651,13213,'ko','ì§€ë¶ˆì„ ìˆ˜ì§‘',0),(475652,13213,'he','×œ×’×‘×™×™×ª ×ª×©×œ×•×ž×™×',0),(475653,13213,'el','Î£Ï…Î»Î»Î­Î³Î¿Ï…Î½ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(475654,13213,'zh','æ”¶é›†ä»˜æ¬¾',0),(475655,13213,'sv','Samla in betalningar',0),(475656,13213,'it','Raccogliere i pagamenti',0),(475657,13213,'tl','',0),(475658,13213,'th','à¸£à¸§à¸šà¸£à¸§à¸¡à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(475659,13213,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤•à¤¤à¥à¤°à¤¿à¤¤',0),(475660,13213,'ms','Mengumpul bayaran',0),(475661,13213,'ar','Ø¬Ù…Ø¹ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(475662,13213,'fr','Percevoir les paiements',0),(475663,13213,'jp','æ”¯æ‰•æƒ…å ±ã®åŽé›†ã—ã¾ã™ã€‚',0),(475664,13213,'pt','Receber pagamentos',0),(475665,13213,'ru','Ð¡Ð±Ð¾Ñ€ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(475666,13213,'es','Recoger Pagos',0),(475667,13213,'de','Sammeln Zahlungen',0),(475668,13213,'en','Collect Payments',0),(475669,13214,'is','',0),(475670,13214,'dr','Ø¯ÛŒÚ¯Ø± ÙˆØ§Ù‚Ø¹ÛŒ',0),(475671,13214,'pr','Ø¯ÛŒÚ¯Ø± ÙˆØ§Ù‚Ø¹ÛŒ',0),(475672,13214,'tr','DiÄŸer gerÃ§ek',0),(475673,13214,'pl','Inne rzeczywiste',0),(475674,13214,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¸',0),(475675,13214,'ur','Ø¯ÛŒÚ¯Ø± Ø§ØµÙ„',0),(475676,13214,'sr','Ð”Ñ€ÑƒÐ³Ðµ ÑÑ‚Ð²Ð°Ñ€Ð½Ðµ',0),(475677,13214,'vi','khÃ¡c thá»±c táº¿',0),(475678,13214,'af','Ander werklike',0),(475679,13214,'ro','Alte efective',0),(475680,13214,'et','Teised tegelikud',0),(475681,13214,'si','Drugi dejanski',0),(475682,13214,'ba','Lain aktual',0),(475683,13214,'nl','Andere werkelijke',0),(475684,13214,'fi','Muut todellinen',0),(475685,13214,'no','Andre faktiske',0),(475686,13214,'da','Andre faktiske',0),(475687,13214,'ko','ë‹¤ë¥¸ ì‹¤ì œ',0),(475688,13214,'he','××—×¨×™× ×‘×¤×•×¢×œ',0),(475689,13214,'el','Î†Î»Î»ÎµÏ‚ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ­Ï‚',0),(475690,13214,'zh','å¦ä¸€ä¸ªæ˜¯å®žé™…',0),(475691,13214,'sv','Andra faktiska',0),(475692,13214,'it','Altri effettivi',0),(475693,13214,'tl','',0),(475694,13214,'th','à¸­à¸·à¹ˆà¸™ à¹† à¸ˆà¸£à¸´à¸‡',0),(475695,13214,'hi','à¤…à¤¨à¥à¤¯ à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤•',0),(475696,13214,'ms','Lain-lain sebenar',0),(475697,13214,'ar','Ø§Ù„Ø£Ø®Ø±Ù‰ Ø§Ù„ÙØ¹Ù„ÙŠØ©',0),(475698,13214,'fr','Autres rÃ©elles',0),(475699,13214,'jp','ãã®ä»–å®Ÿç¸¾',0),(475700,13214,'pt','Outros reais',0),(475701,13214,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ',0),(475702,13214,'es','Otro Actual',0),(475703,13214,'de','Andere tatsÃ¤chliche',0),(475704,13214,'en','Other Actual',0),(475705,13215,'is','',0),(475706,13215,'dr','Ø¯ÛŒÚ¯Ø± Ù…Ù‚Ø§Ø¯ÛŒØ±Ú¯Ø²Ø§Ø±Ø´ Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÛŒÙ„Ù‡ Ú©Ø§Ø±Ø¨Ø±',0),(475707,13215,'pr','Ø¯ÛŒÚ¯Ø± Ù…Ù‚Ø§Ø¯ÛŒØ±Ú¯Ø²Ø§Ø±Ø´ Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÛŒÙ„Ù‡ Ú©Ø§Ø±Ø¨Ø±',0),(475708,13215,'tr','KullanÄ±cÄ± tarafÄ±ndan bildirilen diÄŸer tutar',0),(475709,13215,'pl','Inne iloÅ›Ä‡ zgÅ‚oszonych przez uÅ¼ytkownikÃ³w',0),(475710,13215,'bg','Ð”Ñ€ÑƒÐ³Ð° ÑÑƒÐ¼Ð°, ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸ Ð¾Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ',0),(475711,13215,'ur','ØµØ§Ø±Ù Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¯ÛŒÚ¯Ø± Ø±Ù‚Ù…',0),(475712,13215,'sr','Ð”Ñ€ÑƒÐ³Ð¸ Ð¸Ð·Ð½Ð¾Ñ Ñ˜Ðµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ð¾ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(475713,13215,'vi','Sá»‘ khÃ¡c Ä‘Æ°á»£c bÃ¡o cÃ¡o bá»Ÿi ngÆ°á»i sá»­ dá»¥ng',0),(475714,13215,'af','Ander bedrag wat gerapporteer is deur die gebruiker',0),(475715,13215,'ro','Alte suma raportate de cÄƒtre utilizator',0),(475716,13215,'et','Muude kasutaja poolt teatatud summa',0),(475717,13215,'si','Drugi znesek referat z uporabnik',0),(475718,13215,'ba','Jumlah lain dilaporkan oleh pengguna',0),(475719,13215,'nl','Andere bedrag gemeld door gebruiker',0),(475720,13215,'fi','Muut kÃ¤yttÃ¤jÃ¤n ilmoittama',0),(475721,13215,'no','Andre mengde som rapporteres av bruker',0),(475722,13215,'da','Andre belÃ¸b, der indberettes af brugeren',0),(475723,13215,'ko','ì‚¬ìš©ìžì— ì˜í•´ ë³´ê³  ëœ ë‹¤ë¥¸ ê¸ˆì•¡ì´',0),(475724,13215,'he','×¡×›×•× ××—×¨ ×©×“×•×•×—×• ×¢×œ-×™×“×™ ×”×ž×©×ª×ž×©',0),(475725,13215,'el','Î†Î»Î»Î¿ Ï€Î¿ÏƒÏŒ Ï€Î¿Ï… Î±Î½Î±Ï†Î­ÏÎ¸Î·ÎºÎ±Î½ Î±Ï€ÏŒ Ï„Î¿Î½ Ï‡ÏÎ®ÏƒÏ„Î·',0),(475726,13215,'zh','å…¶ä»–ç”¨æˆ·æ‰€æŠ¥å‘Šçš„é‡‘é¢',0),(475727,13215,'sv','Andra belopp som rapporterats av anvÃ¤ndare',0),(475728,13215,'it','Altro importo segnalato da utente',0),(475729,13215,'tl','',0),(475730,13215,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸­à¸·à¹ˆà¸™ à¹† à¸—à¸µà¹ˆà¸£à¸²à¸¢à¸‡à¸²à¸™ à¹‚à¸”à¸¢à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(475731,13215,'hi','à¤…à¤¨à¥à¤¯ à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥€ à¤¸à¥‚à¤šà¤¨à¤¾',0),(475732,13215,'ms','Lain-lain jumlah yang dilaporkan oleh pengguna',0),(475733,13215,'ar','Ø§Ù„Ø£Ø®Ø±Ù‰ Ø§Ù„Ù…Ø¨Ù„Øº Ø¹Ù†Ù‡Ø§ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(475734,13215,'fr','Autre montant indiquÃ© par l\'utilisateur',0),(475735,13215,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«ã‚ˆã£ã¦å ±å‘Šã•ã‚ŒãŸãã®ä»–ã®é‡‘é¡',0),(475736,13215,'pt','Outro montante reportado pelo usuÃ¡rio',0),(475737,13215,'ru','Ð”Ñ€ÑƒÐ³Ð°Ñ ÑÑƒÐ¼Ð¼Ð°, ÑÐ¾Ð¾Ð±Ñ‰Ð¸Ð» Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ',0),(475738,13215,'es','Otra Cantidad Reportada Por El Usuario',0),(475739,13215,'de','Andere Benutzer gemeldete Betrag',0),(475740,13215,'en','Other Amount Reported By User',0),(475741,13216,'is','',0),(475742,13216,'dr','ØªÙØ§ÙˆØª Ø¯ÛŒÚ¯Ø±',0),(475743,13216,'pr','ØªÙØ§ÙˆØª Ø¯ÛŒÚ¯Ø±',0),(475744,13216,'tr','DiÄŸer fark',0),(475745,13216,'pl','Druga rÃ³Å¼nica',0),(475746,13216,'bg','Ð”Ñ€ÑƒÐ³Ð° Ñ€Ð°Ð·Ð»Ð¸ÐºÐ°',0),(475747,13216,'ur','Ø¯ÛŒÚ¯Ø± ÙØ±Ù‚',0),(475748,13216,'sr','Ð”Ñ€ÑƒÐ³Ð° Ñ€Ð°Ð·Ð»Ð¸ÐºÐ°',0),(475749,13216,'vi','Sá»± khÃ¡c nhau khÃ¡c',0),(475750,13216,'af','Ander verskil',0),(475751,13216,'ro','Alte diferenÅ£e',0),(475752,13216,'et','Muud erinevust',0),(475753,13216,'si','Druga razlika',0),(475754,13216,'ba','Perbedaan lain',0),(475755,13216,'nl','Andere verschil',0),(475756,13216,'fi','Toinen ero',0),(475757,13216,'no','Andre forskjellen',0),(475758,13216,'da','Andre forskel',0),(475759,13216,'ko','ë‹¤ë¥¸ ì°¨ì´',0),(475760,13216,'he','×”×”×‘×“×œ ×”×©× ×™',0),(475761,13216,'el','Î†Î»Î»Î· Î´Î¹Î±Ï†Î¿ÏÎ¬',0),(475762,13216,'zh','å…¶ä»–çš„åŒºåˆ«',0),(475763,13216,'sv','Andra skillnaden',0),(475764,13216,'it','Altra differenza',0),(475765,13216,'tl','',0),(475766,13216,'th','à¸„à¸§à¸²à¸¡à¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸­à¸·à¹ˆà¸™ à¹†',0),(475767,13216,'hi','à¤…à¤¨à¥à¤¯ à¤…à¤‚à¤¤à¤°',0),(475768,13216,'ms','Perbezaan lain',0),(475769,13216,'ar','Ø§Ù„ÙØ±Ù‚ Ø§Ù„Ø£Ø®Ø±Ù‰',0),(475770,13216,'fr','Autre diffÃ©rence',0),(475771,13216,'jp','ä»–ã®é•ã„',0),(475772,13216,'pt','Outra diferenÃ§a',0),(475773,13216,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ñ€Ð°Ð·Ð½Ð¸Ñ†Ñ‹',0),(475774,13216,'es','Otra Diferencia',0),(475775,13216,'de','Andere Unterschied',0),(475776,13216,'en','Other Difference',0),(475777,13217,'is','',0),(475778,13217,'dr','Ù„Ø·ÙØ§ ÛŒÚ© ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(475779,13217,'pr','Ù„Ø·ÙØ§ ÛŒÚ© ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(475780,13217,'tr','LÃ¼tfen Ã¶deme tarihi seÃ§in',0),(475781,13217,'pl','ProszÄ™ wybraÄ‡ datÄ™ pÅ‚atnoÅ›ci',0),(475782,13217,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(475783,13217,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(475784,13217,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(475785,13217,'vi','vui lÃ²ng chá»n ngÃ y thanh toÃ¡n ',0),(475786,13217,'af','Kies asseblief \'n datum vir betaling',0),(475787,13217,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i o datÄƒ de platÄƒ',0),(475788,13217,'et','Palun mÃ¤rkige makse kuupÃ¤eva',0),(475789,13217,'si','Izberite datum plaÄila',0),(475790,13217,'ba','Silakan pilih tanggal pembayaran',0),(475791,13217,'nl','Selecteer een betalingsdatum',0),(475792,13217,'fi','Valitse maksupÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(475793,13217,'no','Velg en betalingsdato',0),(475794,13217,'da','VÃ¦lg venligst en betalingsdato',0),(475795,13217,'ko','ì§€ë¶ˆ ë‚ ì§œë¥¼ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(475796,13217,'he','× × ×‘×—×¨ ×ª××¨×™×š ×”×ª×©×œ×•×',0),(475797,13217,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(475798,13217,'zh','è¯·é€‰æ‹©ä»˜æ¬¾æ—¥æœŸ',0),(475799,13217,'sv','VÃ¤nligen vÃ¤lj ett betalningsdatum',0),(475800,13217,'it','Si prega di selezionare una data di pagamento',0),(475801,13217,'tl','',0),(475802,13217,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸¥à¸·à¸­à¸à¸§à¸±à¸™à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(475803,13217,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(475804,13217,'ms','Sila pilih tarikh pembayaran',0),(475805,13217,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹',0),(475806,13217,'fr','Veuillez sÃ©lectionner une Date de paiement',0),(475807,13217,'jp','æ”¯æ‰•æœŸæ—¥ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(475808,13217,'pt','Por favor, selecione uma data de pagamento',0),(475809,13217,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ñƒ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(475810,13217,'es','Por Favor Selecciona Una Fecha de Pago',0),(475811,13217,'de','Bitte wÃ¤hlen Sie ein Zahlungstermin',0),(475812,13217,'en','Please Select A Payment Date',0),(475813,13218,'is','',0),(475814,13218,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(475815,13218,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(475816,13218,'tr','LÃ¼tfen bir kullanÄ±cÄ± seÃ§in',0),(475817,13218,'pl','Wybierz uÅ¼ytkownika',0),(475818,13218,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(475819,13218,'ur','Ø§ÛŒÚ© ØµØ§Ø±Ù Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(475820,13218,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(475821,13218,'vi','vui lÃ²ng chá»n ngÆ°á»i sá»­ dá»¥ng',0),(475822,13218,'af','Kies asseblief \'n gebruiker',0),(475823,13218,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i un utilizator',0),(475824,13218,'et','Palun valige kasutaja',0),(475825,13218,'si','Izberite uporabnika',0),(475826,13218,'ba','Silakan pilih pengguna',0),(475827,13218,'nl','Selecteer een gebruiker',0),(475828,13218,'fi','Valitse kÃ¤yttÃ¤jÃ¤',0),(475829,13218,'no','Velg en bruker',0),(475830,13218,'da','VÃ¦lg venligst en bruger',0),(475831,13218,'ko','ì‚¬ìš©ìžë¥¼ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(475832,13218,'he','×‘×—×¨ ×ž×©×ª×ž×©',0),(475833,13218,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Ï‡ÏÎ®ÏƒÏ„Î·',0),(475834,13218,'zh','è¯·é€‰æ‹©ç”¨æˆ·',0),(475835,13218,'sv','VÃ¤lj en anvÃ¤ndare',0),(475836,13218,'it','Si prega di selezionare un utente',0),(475837,13218,'tl','',0),(475838,13218,'th','à¹‚à¸›à¸£à¸”à¹€à¸¥à¸·à¸­à¸à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(475839,13218,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(475840,13218,'ms','Sila pilih pengguna',0),(475841,13218,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ù…Ø³ØªØ®Ø¯Ù…',0),(475842,13218,'fr','Veuillez sÃ©lectionner un utilisateur',0),(475843,13218,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(475844,13218,'pt','Por favor, selecione um usuÃ¡rio',0),(475845,13218,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(475846,13218,'es','Por Favor Selecciona Un Usuario',0),(475847,13218,'de','Bitte wÃ¤hlen Sie einen Benutzer',0),(475848,13218,'en','Please Select A User',0),(475849,13219,'is','',0),(475850,13219,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ú©Ø§Ø±Ø¨Ø±',0),(475851,13219,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ú©Ø§Ø±Ø¨Ø±',0),(475852,13219,'tr','KullanÄ±cÄ± Ã¶deme koleksiyonu',0),(475853,13219,'pl','Kolekcja pÅ‚atnoÅ›ci uÅ¼ytkownika',0),(475854,13219,'bg','ÐšÐ¾Ð»ÐµÐºÑ†Ð¸Ñ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(475855,13219,'ur','ØµØ§Ø±Ù Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…Ø¬Ù…ÙˆØ¹Û',0),(475856,13219,'sr','ÐšÐ¾Ð»ÐµÐºÑ†Ð¸Ñ˜Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(475857,13219,'vi','Táº­p há»£p cÃ¡c khoáº£n thanh toÃ¡n cá»§a ngÆ°á»i dÃ¹ng',0),(475858,13219,'af','Gebruiker betaling versameling',0),(475859,13219,'ro','Utilizator perceperii',0),(475860,13219,'et','Kasutaja maksete kogumine',0),(475861,13219,'si','Uporabnika plaÄilnih zbirko',0),(475862,13219,'ba','Pengguna pembayaran koleksi',0),(475863,13219,'nl','Gebruiker betaling collectie',0),(475864,13219,'fi','KÃ¤yttÃ¤jÃ¤n perintÃ¤',0),(475865,13219,'no','Bruker betaling-samlingen',0),(475866,13219,'da','Bruger betaling samling',0),(475867,13219,'ko','ì‚¬ìš©ìž ì§€ë¶ˆ ì»¬ë ‰ì…˜',0),(475868,13219,'he','××•×¡×£ ×ª×©×œ×•× ×”×ž×©×ª×ž×©',0),(475869,13219,'el','Î£Ï…Î»Î»Î¿Î³Î® Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·',0),(475870,13219,'zh','ç”¨æˆ·è´§æ¬¾å›žæ”¶',0),(475871,13219,'sv','AnvÃ¤ndaren betalning insamling',0),(475872,13219,'it','Raccolta di pagamento utente',0),(475873,13219,'tl','',0),(475874,13219,'th','à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(475875,13219,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤‚à¤—à¥à¤°à¤¹',0),(475876,13219,'ms','Kutipan bayaran pengguna',0),(475877,13219,'ar','Ø¬Ù…Ø¹ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(475878,13219,'fr','Collection de paiement de l\'utilisateur',0),(475879,13219,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®æ”¯æ‰•ã„ã®ã‚³ãƒ¬ã‚¯ã‚·ãƒ§ãƒ³',0),(475880,13219,'pt','ColeÃ§Ã£o de pagamento do usuÃ¡rio',0),(475881,13219,'ru','Ð¡Ð±Ð¾Ñ€Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(475882,13219,'es','ColecciÃ³n de Pago Del Usuario',0),(475883,13219,'de','Benutzer-Inkasso',0),(475884,13219,'en','User Payment Collection',0),(475885,13220,'is','',0),(475886,13220,'dr','Ù†Ù…Ø§ÛŒØ´ Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ù…Ø¹ Ø¢ÙˆØ±ÛŒ Ø´Ø¯Ù‡  ',0),(475887,13220,'pr','Ù†Ù…Ø§ÛŒØ´ Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ù…Ø¹ Ø¢ÙˆØ±ÛŒ Ø´Ø¯Ù‡  ',0),(475888,13220,'tr','GÃ¶rÃ¼nÃ¼m Ã¶n Ã¶demeleri toplanan',0),(475889,13220,'pl','Zobacz wczeÅ›niejsze pÅ‚atnoÅ›ci pobrane',0),(475890,13220,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° Ð¿Ñ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ, ÑÑŠÐ±Ñ€Ð°Ð½Ð¸',0),(475891,13220,'ur','Ù…Ù†Ø¸Ø± Ù¾ÛŒØ´Ú¯ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¬Ù…Ø¹',0),(475892,13220,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð¿Ñ€Ð¸ÐºÑƒÐ¿Ñ™ÐµÐ½Ðµ',0),(475893,13220,'vi','Xem thanh toÃ¡n trÆ°á»›c khi thu',0),(475894,13220,'af','Bekyk vooraf betalings versamel',0),(475895,13220,'ro','Vezi plÄƒÅ£i prealabile colectate',0),(475896,13220,'et','Vaade eelnevalt maksed kogutud',0),(475897,13220,'si','Pogled predhodnega plaÄila zbirajo',0),(475898,13220,'ba','Lihat pembayaran sebelumnya yang dikumpulkan',0),(475899,13220,'nl','Weergave voorafgaande betalingen verzameld',0),(475900,13220,'fi','Katso etukÃ¤teen maksut kerÃ¤tÃ¤Ã¤n',0),(475901,13220,'no','Vis tidligere betalinger samlet',0),(475902,13220,'da','Se forudgÃ¥ende betalinger indsamlet',0),(475903,13220,'ko','ë³´ê¸° ì‚¬ì „ ì§€ë¶ˆ ìˆ˜ì§‘',0),(475904,13220,'he','×ª×¦×•×’×” ×ž×•×§×“×ž×ª ×ª×©×œ×•×ž×™× ×©× ××¡×¤×•',0),(475905,13220,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Î¬Ï€Î¿ÏˆÎ· Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… ÏƒÏ…Î»Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(475906,13220,'zh','è§†å›¾äº‹å…ˆä»˜æ¬¾æ”¶é›†',0),(475907,13220,'sv','Visa fÃ¶regÃ¥ende betalningar samlas in',0),(475908,13220,'it','Visualizzazione pagamenti precedenti raccolti',0),(475909,13220,'tl','',0),(475910,13220,'th','à¸”à¸¹à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸à¹ˆà¸­à¸™à¸£à¸§à¸šà¸£à¸§à¸¡',0),(475911,13220,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤ªà¥‚à¤°à¥à¤µ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤à¤•à¤¤à¥à¤°',0),(475912,13220,'ms','Pembayaran terlebih dahulu pandangan yang dikumpul',0),(475913,13220,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø³Ø¨Ù‚Ø© Ø§Ù„ØªÙŠ ØªÙ… Ø¬Ù…Ø¹Ù‡Ø§',0),(475914,13220,'fr','Vue des paiements prÃ©alables recueillies',0),(475915,13220,'jp','è¡¨ç¤ºå‰ã«ãŠæ”¯æ‰•ã„ã‚’åŽé›†',0),(475916,13220,'pt','Vista prÃ©via pagamentos recolhidos',0),(475917,13220,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ ÑÐ¾Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(475918,13220,'es','Ve Pagos Cobrados Anteriormente',0),(475919,13220,'de','Vorherige Zahlungen ansehen gesammelt',0),(475920,13220,'en','View Prior Payments Collected',0),(475921,13221,'is','',0),(475922,13221,'dr','Ú©Ù¾ÛŒ Ø³ÙØ§Ø±Ø´',0),(475923,13221,'pr','Ú©Ù¾ÛŒ Ø³ÙØ§Ø±Ø´',0),(475924,13221,'tr','Klon sipariÅŸ',0),(475925,13221,'pl','Klon zamÃ³wienia',0),(475926,13221,'bg','ÐšÐ»Ð¾Ð½Ð¸Ð½Ð³ Ñ€ÐµÐ´',0),(475927,13221,'ur','Ú©Ù„ÙˆÙ† Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(475928,13221,'sr','ÐšÐ»Ð¾Ð½ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(475929,13221,'vi','ÄÆ¡n Ä‘áº·t hÃ ng Clone',0),(475930,13221,'af','Kloon orde',0),(475931,13221,'ro','Clona ordine',0),(475932,13221,'et','Kloonide jÃ¤rjekorras',0),(475933,13221,'si','Klon nalog',0),(475934,13221,'ba','Klon Order',0),(475935,13221,'nl','Kloon volgorde',0),(475936,13221,'fi','Klooni jÃ¤rjestys',0),(475937,13221,'no','Klone rekkefÃ¸lge',0),(475938,13221,'da','Klon rÃ¦kkefÃ¸lge',0),(475939,13221,'ko','í´ë¡  ì£¼ë¬¸',0),(475940,13221,'he','×¡×“×¨ ×©×™×‘×•×˜',0),(475941,13221,'el','Î¤Î¬Î¾Î·Ï‚ Ï„Ï‰Î½ ÎºÎ»ÏŽÎ½Ï‰Î½',0),(475942,13221,'zh','å…‹éš†å‘½ä»¤',0),(475943,13221,'sv','Klon ordning',0),(475944,13221,'it','Ordine di clone',0),(475945,13221,'tl','',0),(475946,13221,'th','à¸ªà¸±à¹ˆà¸‡à¹‚à¸„à¸¥à¸™',0),(475947,13221,'hi','à¤•à¥à¤²à¥‹à¤¨ à¤•à¥à¤°à¤®',0),(475948,13221,'ms','Klon perintah',0),(475949,13221,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ù†Ø³Ø®',0),(475950,13221,'fr','Ordre de clone',0),(475951,13221,'jp','é †åºã®ã‚¯ãƒ­ãƒ¼ãƒ³ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(475952,13221,'pt','Ordem de clone',0),(475953,13221,'ru','ÐšÐ»Ð¾Ð½ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(475954,13221,'es','Orden de Clon',0),(475955,13221,'de','Klon-Bestellung',0),(475956,13221,'en','Clone Order',0),(475957,13222,'is','',0),(475958,13222,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ú©Ù¾ÛŒ Ø´Ø¯',0),(475959,13222,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ú©Ù¾ÛŒ Ø´Ø¯',0),(475960,13222,'tr','SipariÅŸ baÅŸarÄ±yla kopyalandÄ±',0),(475961,13222,'pl','Aby pomyÅ›lnie sklonowany',0),(475962,13222,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° ÐºÐ»Ð¾Ð½Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(475963,13222,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ú©Ù„ÙˆÙ†Ø¯ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(475964,13222,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ ÐºÐ»Ð¾Ð½Ð¸Ñ€Ð°Ð»Ð¸',0),(475965,13222,'vi','VÃ´ hiá»‡u Ä‘Æ¡n hÃ ng thÃ nh cÃ´ng',0),(475966,13222,'af','Orde suksesvol gekloon',0),(475967,13222,'ro','Ordinul clonat cu succes',0),(475968,13222,'et','Tellimus kloonitud edukalt',0),(475969,13222,'si','Nalog, ki so uspeÅ¡no klonirali',0),(475970,13222,'ba','Urutan clone berhasil',0),(475971,13222,'nl','Volgorde gekloond met succes',0),(475972,13222,'fi','Jotta kloonaamaan',0),(475973,13222,'no','Bestill klonet vellykket',0),(475974,13222,'da','Bestil klonet med succes',0),(475975,13222,'ko','ì„±ê³µì ìœ¼ë¡œ ë³µì œ í•˜ëŠ” ìˆœì„œ',0),(475976,13222,'he','×¡×“×¨ ×œ×©×›×¤×œ ×‘×”×¦×œ×—×”',0),(475977,13222,'el','Î£ÎµÎ¹ÏÎ¬ ÎºÎ»Ï‰Î½Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(475978,13222,'zh','å…‹éš†æˆåŠŸçš„å‘½ä»¤',0),(475979,13222,'sv','Ordning klonade framgÃ¥ngsrikt',0),(475980,13222,'it','Ordine clonato con successo',0),(475981,13222,'tl','',0),(475982,13222,'th','à¸ªà¸±à¹ˆà¸‡à¹‚à¸„à¸¥à¸™à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(475983,13222,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤•à¥à¤²à¥‹à¤¨',0),(475984,13222,'ms','Perintah yang kemudian diklon berjaya',0),(475985,13222,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…Ø³ØªÙ†Ø³Ø®Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(475986,13222,'fr','Ordre clonÃ© avec succÃ¨s',0),(475987,13222,'jp','æ³¨æ–‡ãŒæ­£å¸¸ã«è¤‡è£½',0),(475988,13222,'pt','Ordem clonado com sucesso',0),(475989,13222,'ru','Ð—Ð°ÐºÐ°Ð· ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÐ»Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½',0),(475990,13222,'es','Orden Clonado Exitosamente',0),(475991,13222,'de','Bestellung erfolgreich geklont',0),(475992,13222,'en','Order Cloned Successfully',0),(475993,13223,'is','',0),(475994,13223,'dr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ú©Ù¾ÛŒ Ø´Ø¯ ',0),(475995,13223,'pr','Ù‚ÙŠÙ…Øª Ù¾ÙŠØ´Ù†Ù‡Ø§Ø¯ÙŠ  Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ú©Ù¾ÛŒ Ø´Ø¯ ',0),(475996,13223,'tr','Teklif baÅŸarÄ±yla kopyalandÄ±',0),(475997,13223,'pl','Cytat klonowane pomyÅ›lnie',0),(475998,13223,'bg','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ð¼ ÐºÐ»Ð¾Ð½Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(475999,13223,'ur','Ú©Ù„ÙˆÙ†Ø¯ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ù‚ØªØ¨Ø§Ø³',0),(476000,13223,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ñ˜Ðµ ÐºÐ»Ð¾Ð½Ð¸Ñ€Ð°Ð¾',0),(476001,13223,'vi','vÃ´ hiá»‡u bÃ¡o giÃ¡ thÃ nh cÃ´ng',0),(476002,13223,'af','Aanhaling suksesvol gekloon',0),(476003,13223,'ro','OfertÄƒ de clonat cu succes',0),(476004,13223,'et','Tsitaat kloonitud edukalt',0),(476005,13223,'si','Citiram kloniranih uspeÅ¡no',0),(476006,13223,'ba','Mengutip clone berhasil',0),(476007,13223,'nl','Offerte met succes gekloond',0),(476008,13223,'fi','Lainaus kloonaamaan',0),(476009,13223,'no','Tilbud klonet vellykket',0),(476010,13223,'da','Citere klonede med succes',0),(476011,13223,'ko','ì„±ê³µì ìœ¼ë¡œ ë³µì œ ëœ ì¸ìš©',0),(476012,13223,'he','×”×¦×¢×ª ×ž×—×™×¨ ×œ×©×›×¤×œ ×‘×”×¦×œ×—×”',0),(476013,13223,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± ÎºÎ»Ï‰Î½Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(476014,13223,'zh','æŠ¥ä»·æˆåŠŸå…‹éš†äº†',0),(476015,13223,'sv','Citera klonade framgÃ¥ngsrikt',0),(476016,13223,'it','Citazione clonato con successo',0),(476017,13223,'tl','',0),(476018,13223,'th','à¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹‚à¸„à¸¥à¸™à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(476019,13223,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤•à¥à¤²à¥‹à¤¨',0),(476020,13223,'ms','Quote klon berjaya',0),(476021,13223,'ar','Ø§Ù‚ØªØ¨Ø³ Ø§Ù„Ù…Ø³ØªÙ†Ø³Ø®Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(476022,13223,'fr','Citation clonÃ©e avec succÃ¨s',0),(476023,13223,'jp','æ­£å¸¸ã«ã‚¯ãƒ­ãƒ¼ãƒ³ã¨ã—ã¦ä½œã‚‰ã‚ŒãŸå¼•ç”¨ã—ã¾ã™ã€‚',0),(476024,13223,'pt','CitaÃ§Ã£o clonada com sucesso',0),(476025,13223,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð°, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÐ»Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½',0),(476026,13223,'es','CotizaciÃ³n Clonada Exitosamente',0),(476027,13223,'de','Zitat erfolgreich geklont',0),(476028,13223,'en','Quote Cloned Successfully',0),(476029,13224,'is','',0),(476030,13224,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§ÛŒÙ† Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÛŒØ¯ØŸ',0),(476031,13224,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§ÛŒÙ† Ø±Ø§ Ø¨Ø¨Ù†Ø¯ÛŒØ¯ØŸ',0),(476032,13224,'tr','Bu kopyalamak istediÄŸinizden emin misiniz?',0),(476033,13224,'pl','Czy na pewno chcesz to klon?',0),(476034,13224,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° ÐºÐ»Ð¾Ð½Ð¸Ñ€Ð° Ñ‚Ð¾Ð²Ð°?',0),(476035,13224,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ÛŒÛ Ú©Ù„ÙˆÙ† Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(476036,13224,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð¾Ð²Ð¾ ÐºÐ»Ð¾Ð½Ð¸Ñ€Ð°Ñ‚Ð¸?',0),(476037,13224,'vi','NhÃ¢n báº£n nÃ y?',0),(476038,13224,'af','Is jy seker jy wil hierdie kloon?',0),(476039,13224,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ cloneze acest lucru?',0),(476040,13224,'et','Kas kindlasti see kloon?',0),(476041,13224,'si','Ali ste prepriÄani, da Å¾elite to klon?',0),(476042,13224,'ba','Apakah Anda yakin Anda ingin menduplikasi ini?',0),(476043,13224,'nl','Weet u zeker dat u wilt klonen dit?',0),(476044,13224,'fi','Oletko varma, ettÃ¤ haluat kloonata tÃ¤mÃ¤?',0),(476045,13224,'no','Er du sikker pÃ¥ at du vil klone dette?',0),(476046,13224,'da','Er du sikker pÃ¥ du vil klone det?',0),(476047,13224,'ko','ë‹¹ì‹ ì€ ì´ê²ƒì„ ë³µì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(476048,13224,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×©×›×¤×œ ××ª ×–×”?',0),(476049,13224,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎºÎ»Ï‰Î½Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒ;',0),(476050,13224,'zh','ä½ ç¡®å®šä½ æƒ³è¦å…‹éš†è¿™ï¼Ÿ',0),(476051,13224,'sv','Ã„r du sÃ¤ker du vill klona detta?',0),(476052,13224,'it','Sei sicuro di che voler clonare questo?',0),(476053,13224,'tl','',0),(476054,13224,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹‚à¸„à¸¥à¸™à¸™à¸µà¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(476055,13224,'hi','à¤•à¥à¤¯à¤¾ à¤µà¤¾à¤•à¤ˆ à¤†à¤ª à¤¯à¤¹ à¤•à¥à¤²à¥‹à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(476056,13224,'ms','Adakah anda pasti anda mahu klon ini?',0),(476057,13224,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø§Ø³ØªÙ†Ø³Ø§Ø® Ù‡Ø°Ø§ØŸ',0),(476058,13224,'fr','ÃŠtes-vous sÃ»r que vous voulez cloner cela ?',0),(476059,13224,'jp','ã“ã‚Œã®ã‚¯ãƒ­ãƒ¼ãƒ³ã‚’ä½œæˆã—ã¦ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(476060,13224,'pt','Tens a certeza de que vocÃª deseja clonar isto?',0),(476061,13224,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÐºÐ»Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð¾?',0),(476062,13224,'es','Â¿Esta seguro que quiere cerrar este?',0),(476063,13224,'de','Sind Sie sicher, dass Sie das Klonen mÃ¶chten?',0),(476064,13224,'en','Are you sure you want to clone this?',0),(476065,13225,'is','',0),(476066,13225,'dr','Ú©Ù¾ÛŒ',0),(476067,13225,'pr','Ú©Ù¾ÛŒ',0),(476068,13225,'tr','Klon',0),(476069,13225,'pl','Klon',0),(476070,13225,'bg','Ð’Ð¾Ð¹Ð½Ð°Ñ‚Ð° Ð½Ð° ÐºÐ»Ð¾Ð½Ð¸Ð½Ð³Ð¸Ñ‚Ðµ',0),(476071,13225,'ur','Ú©Ù„ÙˆÙ†',0),(476072,13225,'sr','ÐšÐ»Ð¾Ð½',0),(476073,13225,'vi','Clone',0),(476074,13225,'af','Kloon',0),(476075,13225,'ro','Clona',0),(476076,13225,'et','Kloon',0),(476077,13225,'si','Klon',0),(476078,13225,'ba','Klon',0),(476079,13225,'nl','Kloon',0),(476080,13225,'fi','Klooni',0),(476081,13225,'no','Klone',0),(476082,13225,'da','Klon',0),(476083,13225,'ko','í´ë¡ ',0),(476084,13225,'he','×©×™×‘×•×˜',0),(476085,13225,'el','ÎšÎ»ÏŽÎ½Î¿Ï‚',0),(476086,13225,'zh','å…‹éš†',0),(476087,13225,'sv','Klon',0),(476088,13225,'it','Clone',0),(476089,13225,'tl','',0),(476090,13225,'th','à¹‚à¸„à¸¥à¸™',0),(476091,13225,'hi','à¤•à¥à¤²à¥‹à¤¨',0),(476092,13225,'ms','Klon',0),(476093,13225,'ar','Ø§Ø³ØªÙ†Ø³Ø§Ø®',0),(476094,13225,'fr','Clone',0),(476095,13225,'jp','ã‚¯ãƒ­ãƒ¼ãƒ³',0),(476096,13225,'pt','Clone',0),(476097,13225,'ru','ÐšÐ»Ð¾Ð½',0),(476098,13225,'es','Clon',0),(476099,13225,'de','Klon',0),(476100,13225,'en','Clone',0),(476101,13226,'is','',0),(476102,13226,'dr','(Ø¢Ø®Ø±',0),(476103,13226,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ø¹Ø¯(Ø¢Ø®Ø±',0),(476104,13226,'tr','Gemi daha sonra',0),(476105,13226,'pl','PÃ³Åºniej statek',0),(476106,13226,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð¿Ð¾-ÐºÑŠÑÐ½Ð¾',0),(476107,13226,'ur','Ø¨Ø¹Ø¯ Ù…ÛŒÚº Ø¬ÛØ§Ø²',0),(476108,13226,'sr','Ð‘Ñ€Ð¾Ð´ Ñ˜Ðµ ÐºÐ°ÑÐ½Ð¸Ñ˜Ðµ',0),(476109,13226,'vi','Chuyá»ƒn sau',0),(476110,13226,'af','Skip Later',0),(476111,13226,'ro','Nava mai tÃ¢rziu',0),(476112,13226,'et','Laeva hiljem',0),(476113,13226,'si','Ladja kasneje',0),(476114,13226,'ba','Kapal kemudian',0),(476115,13226,'nl','Schip Later',0),(476116,13226,'fi','Aluksen myÃ¶hemmin',0),(476117,13226,'no','Skipet senere',0),(476118,13226,'da','Skibet senere',0),(476119,13226,'ko','ë‚˜ì¤‘ì— ë°°',0),(476120,13226,'he','×”×¡×¤×™× ×” ×ž××•×—×¨ ×™×•×ª×¨',0),(476121,13226,'el','Î Î»Î¿Î¯Î¿ Î±ÏÎ³ÏŒÏ„ÎµÏÎ±',0),(476122,13226,'zh','èˆ¹åŽ',0),(476123,13226,'sv','Fartyget senare',0),(476124,13226,'it','Nave piÃ¹ tardi',0),(476125,13226,'tl','',0),(476126,13226,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ à¸²à¸¢à¸«à¸¥à¸±à¸‡',0),(476127,13226,'hi','à¤¬à¤¾à¤¦ à¤®à¥‡à¤‚ à¤œà¤¹à¤¾à¤œ',0),(476128,13226,'ms','Kapal kemudian',0),(476129,13226,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© ÙÙŠ ÙˆÙ‚Øª Ù„Ø§Ø­Ù‚',0),(476130,13226,'fr','Navire plus tard',0),(476131,13226,'jp','å¾Œã§èˆ¹',0),(476132,13226,'pt','Mais tarde o navio',0),(476133,13226,'ru','ÐŸÐ¾Ð·Ð¶Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(476134,13226,'es','Envia MÃ¡s Tarde',0),(476135,13226,'de','Schiff spÃ¤ter',0),(476136,13226,'en','Ship Later',0),(476137,13227,'is','',0),(476138,13227,'dr','** Ø±ÙˆØ²Ù‡Ø§ÛŒ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§ÛŒÛŒØ¯',0),(476139,13227,'pr','Ø§Ø±Ø³Ø§Ù„ ** Ø±ÙˆØ²Ù‡Ø§ÛŒ Ø¨Ø¹Ø¯ Ø§Ø² ØªØ§ÛŒÛŒØ¯',0),(476140,13227,'tr','Gemi XX gÃ¼n onaylandÄ±ktan sonra',0),(476141,13227,'pl','Statek XX dni po zatwierdzeniu',0),(476142,13227,'bg','ÐšÐ¾Ñ€Ð°Ð± XX Ð´Ð½Ð¸ ÑÐ»ÐµÐ´ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(476143,13227,'ur','XX Ø¯Ù†ÙˆÚº Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Û’ Ø¨Ø¹Ø¯ Ø¬ÛØ§Ø²',0),(476144,13227,'sr','Ð‘Ñ€Ð¾Ð´ XX Ð´Ð°Ð½Ð° Ð½Ð°ÐºÐ¾Ð½ Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐ°',0),(476145,13227,'vi','Chuyá»ƒn XX ngÃ y sau khi phÃª duyá»‡t',0),(476146,13227,'af','Skip twintigste eeu dae na goedkeuring',0),(476147,13227,'ro','Nava XX zile dupÄƒ aprobarea',0),(476148,13227,'et','Laeva XX pÃ¤eva pÃ¤rast kinnitamist',0),(476149,13227,'si','Ladja XX dni po odobritvi',0),(476150,13227,'ba','Kapal XX hari setelah persetujuan',0),(476151,13227,'nl','Schip XX dagen na goedkeuring',0),(476152,13227,'fi','Aluksen XX pÃ¤ivÃ¤Ã¤ saatuaan',0),(476153,13227,'no','Skipet XX dager etter godkjenning',0),(476154,13227,'da','Skibet XX dage efter godkendelse',0),(476155,13227,'ko','ìŠ¹ì¸ í›„ ë°° XX ì¼',0),(476156,13227,'he','×”×¡×¤×™× ×” XX ×™×ž×™× ×œ××—×¨ ××™×©×•×¨',0),(476157,13227,'el','Î Î»Î¿Î¯Î¿ XX Î·Î¼Î­ÏÎµÏ‚ Î¼ÎµÏ„Î¬ Ï„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ·',0),(476158,13227,'zh','èˆ¹èˆ¶æ‰¹å‡†åŽçš„ XX å¤©',0),(476159,13227,'sv','Fartyget XX dagar efter godkÃ¤nnande',0),(476160,13227,'it','Nave XX giorni dopo l\'approvazione',0),(476161,13227,'tl','',0),(476162,13227,'th','à¹€à¸£à¸·à¸­ XX à¸§à¸±à¸™à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(476163,13227,'hi','à¤œà¤¹à¤¾à¤œ XX à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‡ à¤¬à¤¾à¤¦',0),(476164,13227,'ms','Kapal XX hari selepas kelulusan',0),(476165,13227,'ar','Ø³ÙÙŠÙ†Ø© XX ÙŠÙˆÙ…Ø§ Ø¨Ø¹Ø¯ Ù…ÙˆØ§ÙÙ‚Ø©',0),(476166,13227,'fr','Navire XX jours aprÃ¨s approbation',0),(476167,13227,'jp','æ‰¿èªå¾Œ XX æ—¥ã‚’å‡ºè·ã—ã¾ã™ã€‚',0),(476168,13227,'pt','Navio XX dias apÃ³s aprovaÃ§Ã£o',0),(476169,13227,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ XX Ð´Ð½ÐµÐ¹ Ð¿Ð¾ÑÐ»Ðµ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(476170,13227,'es','Envia XX DÃ­as DespuÃ©s de la AprobaciÃ³n',0),(476171,13227,'de','Schiff XX Tagen nach Genehmigung',0),(476172,13227,'en','Ship XX Days After Approval',0),(476173,13228,'is','',0),(476174,13228,'dr','Ú©Ù¾ÛŒ Ø¯Ø± Ø¯ÛŒÚ¯Ø±',0),(476175,13228,'pr','Ú©Ù¾ÛŒ Ø¯Ø± Ø¯ÛŒÚ¯Ø±',0),(476176,13228,'tr','DiÄŸerine kopyalama',0),(476177,13228,'pl','Kopiowanie na inne',0),(476178,13228,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð² Ð´Ñ€ÑƒÐ³Ð¸',0),(476179,13228,'ur','Ø¯ÙˆØ³Ø±Û’ Ø³Û’ Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(476180,13228,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð½Ð° Ð´Ñ€ÑƒÐ³Ðµ',0),(476181,13228,'vi','Sao chÃ©p tá»›i chá»— khÃ¡c',0),(476182,13228,'af','Kopieer na ander',0),(476183,13228,'ro','Copie la alte',0),(476184,13228,'et','Teise kopeerida',0),(476185,13228,'si','Kopiraj v drugih',0),(476186,13228,'ba','Menyalin lain',0),(476187,13228,'nl','KopiÃ«ren naar andere',0),(476188,13228,'fi','Kopioi muut',0),(476189,13228,'no','Kopiere til andre',0),(476190,13228,'da','Kopier til andre',0),(476191,13228,'ko','ë‹¤ë¥¸ ë³µì‚¬',0),(476192,13228,'he','×œ×”×¢×ª×™×§ ××ª ×”×©× ×™',0),(476193,13228,'el','Î‘Î½Ï„Î¹Î³ÏÎ±Ï†Î® ÏƒÎµ Î¬Î»Î»Î¿',0),(476194,13228,'zh','å°†å¤åˆ¶åˆ°å…¶ä»–',0),(476195,13228,'sv','Kopiera till andra',0),(476196,13228,'it','Copiare l\'altro',0),(476197,13228,'tl','',0),(476198,13228,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¹„à¸›à¸—à¸µà¹ˆà¸­à¸·à¹ˆà¸™',0),(476199,13228,'hi','à¤¦à¥‚à¤¸à¤°à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‰à¤ªà¥€',0),(476200,13228,'ms','Salin ke lain-lain',0),(476201,13228,'ar','Ù†Ø³Ø® Ø¥Ù„Ù‰ Ø§Ù„Ø¢Ø®Ø±',0),(476202,13228,'fr','Copier les autres',0),(476203,13228,'jp','ä»–ã«ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(476204,13228,'pt','Copiar para outro',0),(476205,13228,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð² Ð´Ñ€ÑƒÐ³Ð¸Ðµ',0),(476206,13228,'es','Copia al Otro',0),(476207,13228,'de','Kopieren in andere',0),(476208,13228,'en','Copy To Other',0),(476209,13229,'is','',0),(476210,13229,'dr','Ù¾ÙˆØ´Ø´ Ø´Ù…Ø§Ø±Ù‡',0),(476211,13229,'pr','Ù¾ÙˆØ´Ø´ Ø´Ù…Ø§Ø±Ù‡',0),(476212,13229,'tr','Kapak numarasÄ±',0),(476213,13229,'pl','OkÅ‚adka numeru',0),(476214,13229,'bg','ÐžÐ±Ñ…Ð²Ð°Ñ‰Ð°Ñ‚ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(476215,13229,'ur','ØªØ¹Ø§Ø±ÙÛŒ Ù†Ù…Ø¨Ø±',0),(476216,13229,'sr','ÐŸÐ¾ÐºÑ€Ð¸Ñ˜ Ð±Ñ€Ð¾Ñ˜',0),(476217,13229,'vi','sá»‘ ngoÃ i',0),(476218,13229,'af','Bedek nommer',0),(476219,13229,'ro','Coperta numÄƒrului',0),(476220,13229,'et','Kate arvu',0),(476221,13229,'si','Zajeti Å¡tevilo',0),(476222,13229,'ba','Menutupi nomor',0),(476223,13229,'nl','Aantal bestrijken',0),(476224,13229,'fi','Kattavat',0),(476225,13229,'no','Dekke nummer',0),(476226,13229,'da','Cover nummer',0),(476227,13229,'ko','ë²ˆí˜¸ ì»¤ë²„',0),(476228,13229,'he','×ž×¡×¤×¨ ×›×™×¡×•×™',0),(476229,13229,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¬Î»Ï…ÏˆÎ·',0),(476230,13229,'zh','è¦†ç›–æ•°',0),(476231,13229,'sv','TÃ¤cka nummer',0),(476232,13229,'it','Numero di copertura',0),(476233,13229,'tl','',0),(476234,13229,'th','à¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡à¸ˆà¸³à¸™à¸§à¸™',0),(476235,13229,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‹ à¤•à¤µà¤°',0),(476236,13229,'ms','Jumlah perlindungan',0),(476237,13229,'ar','ØªØºØ·ÙŠØ© Ø¹Ø¯Ø¯',0),(476238,13229,'fr','Nombre de couverture',0),(476239,13229,'jp','ç•ªå·ã‚’ã‚«ãƒãƒ¼ã—ã¾ã™ã€‚',0),(476240,13229,'pt','NÃºmero de capa',0),(476241,13229,'ru','ÐžÐ±Ð»Ð¾Ð¶ÐºÐ° Ð½Ð¾Ð¼ÐµÑ€',0),(476242,13229,'es','NÃºmero de Tapa',0),(476243,13229,'de','Anzahl erfassen',0),(476244,13229,'en','Cover Number',0),(476245,13230,'is','',0),(476246,13230,'dr','1 ',0),(476247,13230,'pr','Ø±Ù†Ú¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø´Ù…Ø§Ø±Ù‡1 ',0),(476248,13230,'tr','Ã–zel renk 1 adÄ±',0),(476249,13230,'pl','Nazwa kolor niestandardowy 1',0),(476250,13230,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ†Ð²ÑÑ‚ Ð¿Ð¾ Ð¸Ð·Ð±Ð¾Ñ€ 1',0),(476251,13230,'ur','Ù…Ø®ØµÙˆØµ Ø±Ù†Ú¯ 1 Ù†Ø§Ù…',0),(476252,13230,'sr','Ð˜Ð¼Ðµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ðµ Ð±Ð¾Ñ˜Ðµ 1',0),(476253,13230,'vi','tá»± táº¡o mÃ u tÃªn',0),(476254,13230,'af','Pasgemaakte kleur 1 naam',0),(476255,13230,'ro','Culoare particularizatÄƒ 1 nume',0),(476256,13230,'et','Kohandatud vÃ¤rvi 1 nimi',0),(476257,13230,'si','Ime barvo po meri 1',0),(476258,13230,'ba','Nama warna kustom 1',0),(476259,13230,'nl','Naam van aangepaste kleur 1',0),(476260,13230,'fi','Mukautetun vÃ¤rin 1 nimi',0),(476261,13230,'no','Farge 1 navn',0),(476262,13230,'da','Brugerdefinerede 1 farvenavn',0),(476263,13230,'ko','ì‚¬ìš©ìž ì§€ì • ìƒ‰ 1 ì´ë¦„',0),(476264,13230,'he','×©× ×¦×‘×¢ ×ž×•×ª×× ××™×©×™×ª 1',0),(476265,13230,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î¿ Ï‡ÏÏŽÎ¼Î± 1 ÏŒÎ½Î¿Î¼Î±',0),(476266,13230,'zh','1 çš„è‡ªå®šä¹‰é¢œè‰²åç§°',0),(476267,13230,'sv','Anpassad fÃ¤rg 1 namn',0),(476268,13230,'it','Nome colore personalizzato 1',0),(476269,13230,'tl','',0),(476270,13230,'th','à¸ªà¸µà¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡ 1 à¸Šà¸·à¹ˆà¸­',0),(476271,13230,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤°à¤‚à¤— 1 à¤¨à¤¾à¤®',0),(476272,13230,'ms','Nama warna tersuai 1',0),(476273,13230,'ar','Ø§Ø³Ù… Ù„ÙˆÙ† Ù…Ø®ØµØµ 1',0),(476274,13230,'fr','Nom de couleur personnalisÃ© 1',0),(476275,13230,'jp','ã‚«ã‚¹ã‚¿ãƒ  ã‚«ãƒ©ãƒ¼ 1 å',0),(476276,13230,'pt','Nome de cor personalizada 1',0),(476277,13230,'ru','Ð˜Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ð³Ð¾ Ñ†Ð²ÐµÑ‚Ð° 1',0),(476278,13230,'es','Color Personalizado 1 Nombre',0),(476279,13230,'de','Namen der benutzerdefinierten Farbe 1',0),(476280,13230,'en','Custom Color 1 Name',0),(476281,13231,'is','',0),(476282,13231,'dr','2',0),(476283,13231,'pr','Ø±Ù†Ú¯ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ø´Ù…Ø§Ø±Ù‡ 2',0),(476284,13231,'tr','Ã–zel renk 2 adÄ±',0),(476285,13231,'pl','Nazwa kolor niestandardowy 2',0),(476286,13231,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ†Ð²ÑÑ‚ Ð¿Ð¾ Ð¸Ð·Ð±Ð¾Ñ€ 2',0),(476287,13231,'ur','Ù…Ø®ØµÙˆØµ Ø±Ù†Ú¯ 2 Ù†Ø§Ù…',0),(476288,13231,'sr','Ð˜Ð¼Ðµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ðµ Ð±Ð¾Ñ˜Ðµ 2',0),(476289,13231,'vi','tá»± táº¡o mÃ u tÃªn',0),(476290,13231,'af','Pasgemaakte kleur 2 naam',0),(476291,13231,'ro','Culoare particularizatÄƒ 2 nume',0),(476292,13231,'et','Kohandatud vÃ¤rv 2 nimi',0),(476293,13231,'si','Ime po meri barva 2',0),(476294,13231,'ba','Nama warna kustom 2',0),(476295,13231,'nl','Naam van aangepaste kleur 2',0),(476296,13231,'fi','Mukautetun vÃ¤rin 2 nimi',0),(476297,13231,'no','Farge 2 navn',0),(476298,13231,'da','Brugerdefinerede 2 farvenavn',0),(476299,13231,'ko','ì‚¬ìš©ìž ì§€ì • ìƒ‰ 2 ì´ë¦„',0),(476300,13231,'he','×©× ×¦×‘×¢ ×ž×•×ª×× ××™×©×™×ª 2',0),(476301,13231,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î¿ Ï‡ÏÏŽÎ¼Î± 2 ÏŒÎ½Î¿Î¼Î±',0),(476302,13231,'zh','è‡ªå®šä¹‰é¢œè‰² 2 åç§°',0),(476303,13231,'sv','Anpassad fÃ¤rg 2 namn',0),(476304,13231,'it','Nome colore personalizzato 2',0),(476305,13231,'tl','',0),(476306,13231,'th','à¸Šà¸·à¹ˆà¸­à¸ªà¸µà¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡ 2',0),(476307,13231,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤°à¤‚à¤— 2 à¤•à¤¾ à¤¨à¤¾à¤®',0),(476308,13231,'ms','Nama warna tersuai 2',0),(476309,13231,'ar','Ø§Ø³Ù… Ù„ÙˆÙ† Ù…Ø®ØµØµ 2',0),(476310,13231,'fr','Nom de couleur personnalisÃ© 2',0),(476311,13231,'jp','ã‚«ã‚¹ã‚¿ãƒ è‰² 2 å',0),(476312,13231,'pt','Nome de cor personalizada 2',0),(476313,13231,'ru','Ð˜Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ð³Ð¾ Ñ†Ð²ÐµÑ‚Ð° 2',0),(476314,13231,'es','Color Personalizado 2 Nombre',0),(476315,13231,'de','Namen der benutzerdefinierten Farbe 2',0),(476316,13231,'en','Custom Color 2 Name',0),(476317,13232,'is','',0),(476318,13232,'dr','( ÙˆÛŒÚ˜Ù‡ Ù‡Ø§',0),(476319,13232,'pr','Ø«Ø¨Øª Ù‚ÛŒÙ…Øª Ú©Ù… Ø´Ø¯Ù‡( ÙˆÛŒÚ˜Ù‡ Ù‡Ø§',0),(476320,13232,'tr','Ä°ndirimdeki girin',0),(476321,13232,'pl','WprowadÅº promocje',0),(476322,13232,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼Ð¾Ñ†Ð¸Ð¸',0),(476323,13232,'ur','Ø®ØµÙˆØµÛŒ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(476324,13232,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑÐ¿ÐµÑ†Ð¸Ñ˜Ð°Ð»Ð¸Ñ‚ÐµÑ‚Ð¸',0),(476325,13232,'vi','Nháº­p riÃªng',0),(476326,13232,'af','Tik Specials',0),(476327,13232,'ro','IntroduceÅ£i speciale',0),(476328,13232,'et','Sisestage eripakkumist',0),(476329,13232,'si','Vnesite v akciji',0),(476330,13232,'ba','Masukkan Spesial',0),(476331,13232,'nl','Voer Specials',0),(476332,13232,'fi','Kirjoita tarjoukset',0),(476333,13232,'no','Angi Specials',0),(476334,13232,'da','Indtast tilbud',0),(476335,13232,'ko','íŠ¹ê°€ ìƒí’ˆ ìž…ë ¥',0),(476336,13232,'he','×”×–×Ÿ ×ž×‘×¦×¢×™×',0),(476337,13232,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î±Ï†Î¹ÎµÏÏŽÎ¼Î±Ï„Î±',0),(476338,13232,'zh','è¾“å…¥ç‰¹ä»·',0),(476339,13232,'sv','Ange Specials',0),(476340,13232,'it','Inserisci Specials',0),(476341,13232,'tl','',0),(476342,13232,'th','à¸£à¸°à¸šà¸¸à¸žà¸´à¹€à¸¨à¸©',0),(476343,13232,'hi','à¤¸à¥à¤ªà¥‡à¤¶à¤² à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(476344,13232,'ms','Masukkan istimewa',0),(476345,13232,'ar','Ø£Ø¯Ø®Ù„ Ø¹Ø±ÙˆØ¶ Ø®Ø§ØµØ©',0),(476346,13232,'fr','Entrez Specials',0),(476347,13232,'jp','ã‚¹ãƒšã‚·ãƒ£ãƒ«ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(476348,13232,'pt','Digite Specials',0),(476349,13232,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÐ¿ÐµÑ†',0),(476350,13232,'es','Entrar Especiales',0),(476351,13232,'de','Geben Sie Specials',0),(476352,13232,'en','Enter Specials',0),(476353,13233,'is','',0),(476354,13233,'dr','-Ø¨Ù‡ ÙØ±Ù…Ø§ÛŒØ´ Ø¨Ø±Ú¯Ø±Ø¯ÛŒØ¯',0),(476355,13233,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø²Ù…Ø§Ù† Ø°Ø®ÛŒØ±Ù‡ Ø³Ø§Ø²ÛŒ-Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ú¯Ø±Ø¯ÛŒØ¯',0),(476356,13233,'tr','Kaydet - dÃ¶nmek iÃ§in sipariÅŸ sÄ±rasÄ±nda hata',0),(476357,13233,'pl','BÅ‚Ä…d podczas zapisywania - powrÃ³t do zamÃ³wienia',0),(476358,13233,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ - Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(476359,13233,'ur','Ù…Ø­ÙÙˆØ¸ - Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÙˆØ§Ù¾Ø³ÛŒ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ù†Ù‚Øµ',0),(476360,13233,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñ‚Ð¾ÐºÐ¾Ð¼ Ñ‡ÑƒÐ²Ð°ÑšÐ° - Ð¿Ð¾Ð²Ñ€Ð°Ñ‚Ð°Ðº Ð½Ð° Ð½Ð°Ð»Ð¾Ð³',0),(476361,13233,'vi','Lá»—i khi lÆ°u- Trá»Ÿ láº¡i Ä‘á» nghá»‹',0),(476362,13233,'af','Fout tydens stoor - terugkeer na orde',0),(476363,13233,'ro','Eroare Ã®n timpul salva - Ã®ntoarcerea la comanda',0),(476364,13233,'et','Salvesta - tellimuse tagastamise ilmnes tÃµrge',0),(476365,13233,'si','Napaka med Save - vrnitev po naroÄilu',0),(476366,13233,'ba','Error selama Simpan - kembali ke urutan',0),(476367,13233,'nl','Fout tijdens opslaan - Return To Order',0),(476368,13233,'fi','Tallenna - paluu tilauksen virhe',0),(476369,13233,'no','Feil under lagring - tilbake til ordre',0),(476370,13233,'da','Fejl under Gem - tilbagevenden til ordre',0),(476371,13233,'ko','ì €ìž¥-ëŒì•„ê°€ê¸° ì£¼ë¬¸ ì¤‘ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤',0),(476372,13233,'he','×©×’×™××” ×‘×¢×ª ×©×ž×™×¨×ª - ×—×–×¨×” ×¢×œ ×¡×“×¨',0),(476373,13233,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· - ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î·',0),(476374,13233,'zh','ä¿å­˜-æ¢å¤ç§©åºè¿‡ç¨‹ä¸­å‡ºé”™',0),(476375,13233,'sv','Fel vid spara - Ã¥tergÃ¥ng till ordning',0),(476376,13233,'it','Errore durante il salvataggio - ritorno all\'ordine',0),(476377,13233,'tl','',0),(476378,13233,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸ - à¸ªà¹ˆà¸‡à¸„à¸·à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(476379,13233,'hi','à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ - à¤•à¥à¤°à¤® à¤•à¥€ à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¥‡ à¤¦à¥Œà¤°à¤¾à¤¨ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(476380,13233,'ms','Ralat semasa Simpan - kembali kepada perintah',0),(476381,13233,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸-Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(476382,13233,'fr','Erreur lors de l\'enregistrer - retour Ã  l\'ordre',0),(476383,13233,'jp','é †åºã¸ã®ãƒªã‚¿ãƒ¼ãƒ³ã‚’ä¿å­˜ä¸­ã«ã‚¨ãƒ©ãƒ¼',0),(476384,13233,'pt','Erro ao salvar - retorno Ã  ordem',0),(476385,13233,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ñ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ - Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ðº Ð¿Ð¾Ñ€ÑÐ´ÐºÑƒ',0),(476386,13233,'es','Error Durante Guardar - Regresa al Orden',0),(476387,13233,'de','Fehler beim Speichern - RÃ¼ckkehr zu bestellen',0),(476388,13233,'en','Error During Save - Return To Order',0),(476389,13234,'is','',0),(476390,13234,'dr','Ø·Ø±Ø§Ø­ÛŒ Ø¯Ø§Ø®Ù„ÛŒ ',0),(476391,13234,'pr','Ø·Ø±Ø§Ø­ÛŒ Ø¯Ø§Ø®Ù„ÛŒ ',0),(476392,13234,'tr','Ä°Ã§ tasarÄ±m Nr',0),(476393,13234,'pl','WewnÄ…trz projekt Nr',0),(476394,13234,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐµÐ½ Ð´Ð¸Ð·Ð°Ð¹Ð½ Nr',0),(476395,13234,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ† ÚˆÛŒØ²Ø§Ø¦Ù† Ø§ÛŒÙ† Ø¢Ø±',0),(476396,13234,'sr','Ð£Ð½ÑƒÑ‚Ð°Ñ€ Ð´Ð¸Ð·Ð°Ñ˜Ð½Ð° ÐÑ€',0),(476397,13234,'vi','trong phÃ¡c há»a',0),(476398,13234,'af','Binnekant ontwerp Nr',0),(476399,13234,'ro','Nr Design interior',0),(476400,13234,'et','Seest disain Nr',0),(476401,13234,'si','Znotraj Design Nr',0),(476402,13234,'ba','Nr dalam desain',0),(476403,13234,'nl','Inside Design Nr',0),(476404,13234,'fi','SisÃ¤ltÃ¤ Design Nr',0),(476405,13234,'no','Inne Design Nr',0),(476406,13234,'da','Indvendigt Design Nr',0),(476407,13234,'ko','ë‚´ë¶€ ë””ìžì¸ Nr',0),(476408,13234,'he','×¢×œ×•×Ÿ × ××˜ ×• ×¢×™×¦×•×‘ ×ž×‘×¤× ×™×',0),(476409,13234,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÏŒ ÏƒÏ‡ÎµÎ´Î¹Î±ÏƒÎ¼ÏŒ Nr',0),(476410,13234,'zh','å†…éƒ¨è®¾è®¡ Nr',0),(476411,13234,'sv','Inside Design Nr',0),(476412,13234,'it','Design interno Nr',0),(476413,13234,'tl','',0),(476414,13234,'th','Nr à¸­à¸­à¸à¹à¸šà¸šà¸ à¸²à¸¢à¹ƒà¸™',0),(476415,13234,'hi','à¤…à¤‚à¤¦à¤° à¤¡à¤¿à¤œà¤¾à¤‡à¤¨ à¤à¤¨. à¤†à¤°.',0),(476416,13234,'ms','Nr dalam reka bentuk',0),(476417,13234,'ar','ØªØµÙ…ÙŠÙ… Ø¯Ø§Ø®Ù„ Ø§Ù„Ù…Ø¬Ù„Ø©',0),(476418,13234,'fr','Nr Design intÃ©rieur',0),(476419,13234,'jp','å†…éƒ¨è¨­è¨ˆ Nr',0),(476420,13234,'pt','Interior Design Nr',0),(476421,13234,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ð¹ Ð´Ð¸Ð·Ð°Ð¹Ð½ Nr',0),(476422,13234,'es','NÃºmero de DiseÃ±o a Dentro',0),(476423,13234,'de','Im Detail: Muster Nr.',0),(476424,13234,'en','Inside Design Nr',0),(476425,13235,'is','',0),(476426,13235,'dr','(Ù¾ÙˆØ´Ø´',0),(476427,13235,'pr','Ù‡ÛŒÚ† Ú©Ø§ÙˆØ±ÛŒ(Ù¾ÙˆØ´Ø´',0),(476428,13235,'tr','HiÃ§bir kapak',0),(476429,13235,'pl','Nie pokrywa',0),(476430,13235,'bg','ÐÐµ Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ',0),(476431,13235,'ur','Ú©ÙˆØ¦ÛŒ Ú©ÙˆØ±',0),(476432,13235,'sr','Ð‘ÐµÐ· ÐºÐ¾Ñ€Ð¸Ñ†Ðµ',0),(476433,13235,'vi','khÃ´ng bao bÃ¬',0),(476434,13235,'af','Geen dekking',0),(476435,13235,'ro','Nici o acoperire',0),(476436,13235,'et','Puudub Ã¼levaade',0),(476437,13235,'si','Ne pokrivajo',0),(476438,13235,'ba','Tidak penutup',0),(476439,13235,'nl','Geen Cover',0),(476440,13235,'fi','Ei kata',0),(476441,13235,'no','Ingen dekke',0),(476442,13235,'da','Ingen dÃ¦kning',0),(476443,13235,'ko','ì•„ë‹ˆ ì»¤ë²„',0),(476444,13235,'he','××™×Ÿ ×ž×—×¡×”',0),(476445,13235,'el','ÎšÎ±Î¼Î¯Î± ÎºÎ¬Î»Ï…ÏˆÎ·',0),(476446,13235,'zh','æ²¡æœ‰ç›–',0),(476447,13235,'sv','Ingen tÃ¤ckning',0),(476448,13235,'it','Nessuna copertura',0),(476449,13235,'tl','',0),(476450,13235,'th','à¹„à¸¡à¹ˆà¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡',0),(476451,13235,'hi','à¤•à¥‹à¤ˆ à¤†à¤µà¤°à¤£',0),(476452,13235,'ms','Perlindungan tidak',0),(476453,13235,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ ØªØºØ·ÙŠØ©',0),(476454,13235,'fr','Sans couverture',0),(476455,13235,'jp','ã‚«ãƒãƒ¼ãªã—',0),(476456,13235,'pt','Sem cobertura',0),(476457,13235,'ru','Ð‘ÐµÐ· Ð¿Ð¾ÐºÑ€Ñ‹Ñ‚Ð¸Ñ',0),(476458,13235,'es','No Tapa',0),(476459,13235,'de','Keine Deckung',0),(476460,13235,'en','No Cover',0),(476461,13236,'is','',0),(476462,13236,'dr','Ù‡ÛŒÚ† Ù¾Ù†Ø¬Ø±Ù‡ Ø§ÛŒ',0),(476463,13236,'pr','Ù‡ÛŒÚ† Ù¾Ù†Ø¬Ø±Ù‡ Ø§ÛŒ',0),(476464,13236,'tr','Pencere yok',0),(476465,13236,'pl','Bez okna',0),(476466,13236,'bg','Ð‘ÐµÐ· Ð¿Ñ€Ð¾Ð·Ð¾Ñ€ÐµÑ†',0),(476467,13236,'ur','Ú©ÙˆØ¦ÛŒ Ø¯Ø±ÛŒÚ†Û',0),(476468,13236,'sr','Ð‘ÐµÐ· Ð¿Ñ€Ð¾Ð·Ð¾Ñ€Ð°',0),(476469,13236,'vi','khÃ´ng cá»­a sá»•',0),(476470,13236,'af','Geen venster',0),(476471,13236,'ro','FÄƒrÄƒ ferestre',0),(476472,13236,'et','Akent ei',0),(476473,13236,'si','Brez oken',0),(476474,13236,'ba','Tanpa jendela',0),(476475,13236,'nl','Geen venster',0),(476476,13236,'fi','Ei ikkunaa',0),(476477,13236,'no','Ingen vindu',0),(476478,13236,'da','Uden vindue',0),(476479,13236,'ko','ì°½ë¬¸ ì—†ìŒ',0),(476480,13236,'he','×œ×œ× ×—×œ×•×Ÿ',0),(476481,13236,'el','Î§Ï‰ÏÎ¯Ï‚ Ï€Î±ÏÎ¬Î¸Ï…ÏÎ¿',0),(476482,13236,'zh','æ— çª—',0),(476483,13236,'sv','Inget fÃ¶nster',0),(476484,13236,'it','Nessuna finestra',0),(476485,13236,'tl','',0),(476486,13236,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸«à¸™à¹‰à¸²à¸•à¹ˆà¸²à¸‡',0),(476487,13236,'hi','à¤•à¥‹à¤ˆ à¤–à¤¿à¤¡à¤¼à¤•à¥€',0),(476488,13236,'ms','Tanpa Tingkap',0),(476489,13236,'ar','Ù„Ø§ Ù†Ø§ÙØ°Ø©',0),(476490,13236,'fr','Pas de fenÃªtre',0),(476491,13236,'jp','çª“ãªã—',0),(476492,13236,'pt','Nenhuma janela',0),(476493,13236,'ru','Ð‘ÐµÐ· Ð¾ÐºÐ½Ð°',0),(476494,13236,'es','No Ventana',0),(476495,13236,'de','Kein Fenster',0),(476496,13236,'en','No Window',0),(476497,13237,'is','',0),(476498,13237,'dr','...',0),(476499,13237,'pr','Ø·Ø±Ø§Ø­ÛŒ Ø®Ø§Ø±Ø¬ÛŒ ...',0),(476500,13237,'tr','DÄ±ÅŸ tasarÄ±m Nr',0),(476501,13237,'pl','Poza projekt Nr',0),(476502,13237,'bg','Ð’ÑŠÐ½ÑˆÐµÐ½ Ð´Ð¸Ð·Ð°Ð¹Ð½ Nr',0),(476503,13237,'ur','Ø¨Ø§ÛØ± ÚˆÛŒØ²Ø§Ø¦Ù† Ø§ÛŒÙ† Ø¢Ø±',0),(476504,13237,'sr','Ð˜Ð·Ð²Ð°Ð½ Ð´Ð¸Ð·Ð°Ñ˜Ð½ ÐÑ€',0),(476505,13237,'vi','thiáº¿t káº¿ bÃªn ngoÃ i',0),(476506,13237,'af','Buite ontwerp Nr',0),(476507,13237,'ro','Nr Design exterior',0),(476508,13237,'et','VÃ¤ljaspool projekti Nr',0),(476509,13237,'si','Zunaj naÄrta Nr',0),(476510,13237,'ba','Nr luar desain',0),(476511,13237,'nl','Buiten ontwerp Nr',0),(476512,13237,'fi','Ulkopuolella Design Nr',0),(476513,13237,'no','Utvendig Design Nr',0),(476514,13237,'da','Udvendige Design Nr',0),(476515,13237,'ko','ì™¸ë¶€ ë””ìžì¸ Nr',0),(476516,13237,'he','×”×¢×™×¦×•×‘ ×”×—×™×¦×•× ×™ Nr',0),(476517,13237,'el','Î•Î¾Ï‰Ï„ÎµÏÎ¹ÎºÏŒ ÏƒÏ‡ÎµÎ´Î¹Î±ÏƒÎ¼ÏŒ Nr',0),(476518,13237,'zh','å¤–éƒ¨è®¾è®¡ Nr',0),(476519,13237,'sv','UtanfÃ¶r Design Nr',0),(476520,13237,'it','Design esterno Nr',0),(476521,13237,'tl','',0),(476522,13237,'th','Nr à¸­à¸­à¸à¹à¸šà¸šà¸ à¸²à¸¢à¸™à¸­à¸',0),(476523,13237,'hi','à¤¬à¤¾à¤¹à¤°à¥€ à¤¡à¤¿à¤œà¤¾à¤‡à¤¨ à¤à¤¨. à¤†à¤°.',0),(476524,13237,'ms','Reka bentuk luar Nr',0),(476525,13237,'ar','Nr Ø§Ù„ØªØµÙ…ÙŠÙ… Ø§Ù„Ø®Ø§Ø±Ø¬ÙŠ',0),(476526,13237,'fr','Nr Design extÃ©rieur',0),(476527,13237,'jp','å¤–å´ã®è¨­è¨ˆ Nr',0),(476528,13237,'pt','Design exterior Nr',0),(476529,13237,'ru','Ð’Ð½ÐµÑˆÐ½Ð¸Ð¹ Ð´Ð¸Ð·Ð°Ð¹Ð½ Nr',0),(476530,13237,'es','NÃºmero de DiseÃ±o Afuera',0),(476531,13237,'de','AuÃŸen Design Nr',0),(476532,13237,'en','Outside Design Nr',0),(476533,13238,'is','',0),(476534,13238,'dr','Ù…Ø¬ÙˆØ² Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ',0),(476535,13238,'pr','Ù…Ø¬ÙˆØ² Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± ',0),(476536,13238,'tr','Nr izni',0),(476537,13238,'pl','Zezwolenie Nr',0),(476538,13238,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸ Nr',0),(476539,13238,'ur','Ø§ÛŒÙ† Ø¢Ø± Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª',0),(476540,13238,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸Ñ‚Ðµ ÐÑ€',0),(476541,13238,'vi','cho phÃ©p Nr',0),(476542,13238,'af','Permit Nr',0),(476543,13238,'ro','Permite Nr',0),(476544,13238,'et','Luba Nr',0),(476545,13238,'si','Dovoli Nr',0),(476546,13238,'ba','Izin Nr',0),(476547,13238,'nl','Vergunning Nr',0),(476548,13238,'fi','Sallia Nr',0),(476549,13238,'no','Tillat Nr',0),(476550,13238,'da','Tillade Nr',0),(476551,13238,'ko','Nrì„ í—ˆìš©',0),(476552,13238,'he','×”×™×ª×¨ Nr',0),(476553,13238,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Nr',0),(476554,13238,'zh','å…è®¸ Nr',0),(476555,13238,'sv','TillstÃ¥nd Nr',0),(476556,13238,'it','Permesso Nr',0),(476557,13238,'tl','',0),(476558,13238,'th','à¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰ Nr',0),(476559,13238,'hi','à¤à¤¨. à¤†à¤°. à¤ªà¤°à¤®à¤¿à¤Ÿ',0),(476560,13238,'ms','Membenarkan Nr',0),(476561,13238,'ar','ØªØ³Ù…Ø­ Nr',0),(476562,13238,'fr','Permis Nr',0),(476563,13238,'jp','Nr ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(476564,13238,'pt','Permitir Nr',0),(476565,13238,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ Nr',0),(476566,13238,'es','NÃºmero de Permiso',0),(476567,13238,'de','Nr zu ermÃ¶glichen',0),(476568,13238,'en','Permit Nr',0),(476569,13239,'is','',0),(476570,13239,'dr','ØªØ¹Ø¯Ø§Ø¯ Ú©ØªØ§Ø¨ Ø¯Ø± ØªÙ†Ø¸ÛŒÙ… Ù†Ù‡Ø§ÛŒÛŒ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ ØµÙØ± Ø¨Ø§Ø´Ø¯',0),(476571,13239,'pr','ØªØ¹Ø¯Ø§Ø¯ Ú©ØªØ§Ø¨ Ø¯Ø± ØªÙ†Ø¸ÛŒÙ… Ù†Ù‡Ø§ÛŒÛŒ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ ØµÙØ± Ø¨Ø§Ø´Ø¯',0),(476572,13239,'tr','Son Set kitaplara miktarÄ± sÄ±fÄ±r olamaz',0),(476573,13239,'pl','IloÅ›Ä‡ ksiÄ…Å¼ek w ostateczny zestaw nie moÅ¼e byÄ‡ zerowa',0),(476574,13239,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° ÐºÐ½Ð¸Ð³Ð¸ Ð² ÐºÑ€Ð°ÐµÐ½ Ð½Ð°Ð±Ð¾Ñ€ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð½ÑƒÐ»Ð°',0),(476575,13239,'ur','Ø¢Ø®Ø±ÛŒ Ø³ÛŒÙ¹ Ù…ÛŒÚº Ú©ØªØ§Ø¨ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ ØµÙØ± Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©ØªØ§',0);
INSERT INTO `langdef` VALUES (476576,13239,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÐºÑšÐ¸Ð³Ð° Ñƒ ÐºÐ¾Ð½Ð°Ñ‡Ð½Ð¸ ÑÐºÑƒÐ¿ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð½ÑƒÐ»Ð°',0),(476577,13239,'vi','Sá»‘ lÆ°á»£ng sÃ¡ch trong táº­p cuá»‘i cÃ¹ng khÃ´ng thá»ƒ lÃ  Zero',0),(476578,13239,'af','Hoeveelheid boeke In finale stel nul kan wees',0),(476579,13239,'ro','Cantitatea de cÄƒrÅ£i din Final Set nu poate fi Zero',0),(476580,13239,'et','Asjassepuutuvust lÃµpuosa ei tohi olla null',0),(476581,13239,'si','KoliÄino knjig v konÄni nabor ne more biti niÄ',0),(476582,13239,'ba','Jumlah buku pada akhir Set tidak boleh nol',0),(476583,13239,'nl','Hoeveelheid boeken In Final Set mag niet nul',0),(476584,13239,'fi','Viimeinen kirjojen mÃ¤Ã¤rÃ¤ ei voi olla nolla',0),(476585,13239,'no','Antall bÃ¸ker i avgjÃ¸rende sett kan ikke vÃ¦re null',0),(476586,13239,'da','Antallet af bÃ¸ger i sidste sÃ¦t kan ikke vÃ¦re nul',0),(476587,13239,'ko','ë§ˆì§€ë§‰ ì„¸íŠ¸ì—ì„œë„ ì„œì˜ ìˆ˜ëŸ‰ 0ì´ ë  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(476588,13239,'he','×›×ž×•×ª ×”×¡×¤×¨×™× ×‘×¢×¨×›×ª ×”×¡×•×¤×™ ××™× ×• ×™×›×•×œ ×œ×”×™×•×ª ××¤×¡',0),(476589,13239,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î²Î¹Î²Î»Î¯Ï‰Î½ ÏƒÎµ Ï„ÎµÎ»Î¹ÎºÏŒ ÏƒÏÎ½Î¿Î»Î¿ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼Î·Î´Î­Î½',0),(476590,13239,'zh','ä¹¦ä¸­æœ€åŽä¸€ç»„çš„æ•°é‡ä¸èƒ½ä¸ºé›¶',0),(476591,13239,'sv','MÃ¤ngden bÃ¶cker i sista setet kan inte vara noll',0),(476592,13239,'it','QuantitÃ  di libri nel Set finale non puÃ² essere Zero',0),(476593,13239,'tl','',0),(476594,13239,'th','à¸ˆà¸³à¸™à¸§à¸™à¸«à¸™à¸±à¸‡à¸ªà¸·à¸­à¹ƒà¸™à¸Šà¸¸à¸”à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢à¹„à¸¡à¹ˆà¹€à¸›à¹‡à¸™à¸¨à¸¹à¸™à¸¢à¹Œ',0),(476595,13239,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¸à¥‡à¤Ÿ à¤®à¥‡à¤‚ à¤•à¤¿à¤¤à¤¾à¤¬à¥‹à¤‚ à¤•à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¶à¥‚à¤¨à¥à¤¯ à¤¹à¥‹ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(476596,13239,'ms','Kuantiti buku-buku dalam akhir tidak boleh sifar',0),(476597,13239,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªÙƒÙˆÙ† Ø§Ù„ÙƒÙ…ÙŠØ© Ù…Ù† Ø§Ù„ÙƒØªØ¨ ÙÙŠ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠØ© ØµÙØ±',0),(476598,13239,'fr','QuantitÃ© de livres dans l\'ensemble Final ne peut pas Ãªtre zÃ©ro',0),(476599,13239,'jp','æœ€çµ‚çš„ãªã‚»ãƒƒãƒˆã§ã®æ›¸ç±ã®é‡ã‚’ 0 ã«ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(476600,13239,'pt','Quantidade de livros em conjunto Final nÃ£o pode ser Zero',0),(476601,13239,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÐ½Ð¸Ð³ Ð² Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð½Ð°Ð±Ð¾Ñ€ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð²ÐµÐ½ Ð½ÑƒÐ»ÑŽ',0),(476602,13239,'es','Cantidad de libros en conjunto Final no puede ser cero',0),(476603,13239,'de','Menge von BÃ¼chern im letzten Satz darf nicht NULL sein.',0),(476604,13239,'en','Quantity Of Books In Final Set Cannot Be Zero',0),(476605,13240,'is','',0),(476606,13240,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ ÙˆÛŒØ±Ø§ÛŒØ´',0),(476607,13240,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ ÙˆÛŒØ±Ø§ÛŒØ´',0),(476608,13240,'tr','DÃ¼zenle olarak dÃ¶ndÃ¼rÃ¼r',0),(476609,13240,'pl','PowrÃ³t do edycji',0),(476610,13240,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(476611,13240,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ ÙˆØ§Ù¾Ø³',0),(476612,13240,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ñƒ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(476613,13240,'vi','trá»Ÿ láº¡i Ä‘á»ƒ sá»­a',0),(476614,13240,'af','Terugkeer om te redigeer',0),(476615,13240,'ro','Reveni la editare',0),(476616,13240,'et','Return To Edit',0),(476617,13240,'si','Vrnitev v urejanje',0),(476618,13240,'ba','Kembali ke Edit',0),(476619,13240,'nl','Terug naar Edit',0),(476620,13240,'fi','Palata Muokkaa',0),(476621,13240,'no','GÃ¥ tilbake til Rediger',0),(476622,13240,'da','Vende tilbage til Rediger',0),(476623,13240,'ko','íŽ¸ì§‘ ëŒì•„ê°€ê¸°',0),(476624,13240,'he','×œ×—×–×•×¨ ×¢×¨×™×›×”',0),(476625,13240,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® ÏƒÏ„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(476626,13240,'zh','è¿”å›žåˆ°ç¼–è¾‘',0),(476627,13240,'sv','Ã…tergÃ¥ till redigera',0),(476628,13240,'it','Ritornare a modifica',0),(476629,13240,'tl','',0),(476630,13240,'th','à¸à¸¥à¸±à¸šà¹„à¸›à¹à¸à¹‰à¹„à¸‚',0),(476631,13240,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¥Œà¤Ÿà¥‡à¤‚',0),(476632,13240,'ms','Kembali ke Edit',0),(476633,13240,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ ØªØ­Ø±ÙŠØ±',0),(476634,13240,'fr','Retour Ã  Edit',0),(476635,13240,'jp','ç·¨é›†ã«æˆ»ã‚‹',0),(476636,13240,'pt','Retornar para ediÃ§Ã£o',0),(476637,13240,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ð² Edit',0),(476638,13240,'es','Regresa al Edito',0),(476639,13240,'de','ZurÃ¼ck zu bearbeiten',0),(476640,13240,'en','Return To Edit',0),(476641,13241,'is','',0),(476642,13241,'dr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´',0),(476643,13241,'pr','Ø¨Ø±Ú¯Ø´Øª Ø¨Ù‡ Ø«Ø¨Øª Ø³ÙØ§Ø±Ø´',0),(476644,13241,'tr','SipariÅŸ giriÅŸi iÃ§in iade',0),(476645,13241,'pl','PowrÃ³t do zamÃ³wienia wpis',0),(476646,13241,'bg','Ð’ÑŠÑ€Ð½ÐµÑ‚Ðµ Ð´Ð° Ð¿Ð¾Ñ€ÑŠÑ‡Ð°Ñ‚Ðµ Ð·Ð°Ð¿Ð¸Ñ',0),(476647,13241,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÙˆØ§Ù¾Ø³',0),(476648,13241,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ñƒ Ð½Ð°Ñ€ÐµÐ´Ð¸ ÑÑ‚Ð°Ð²ÐºÐ°',0),(476649,13241,'vi','trá»Ÿ láº¡i Ä‘á»ƒ nháº­p Ä‘Æ¡n hÃ ng',0),(476650,13241,'af','Keer terug na inskrywing bestel',0),(476651,13241,'ro','Reveni pentru a comanda intrare',0),(476652,13241,'et','Naaske Telli kanne',0),(476653,13241,'si','Vrniti naroÄite vstopa',0),(476654,13241,'ba','Kembali untuk memesan entri',0),(476655,13241,'nl','Terug om te bestellen van binnenkomst',0),(476656,13241,'fi','Palaa tilaustenkÃ¤sittelyn',0),(476657,13241,'no','GÃ¥ tilbake til tidsfristgrupper',0),(476658,13241,'da','Vende tilbage for at bestille post',0),(476659,13241,'ko','ì£¼ë¬¸ í•­ëª© ë°˜í™˜',0),(476660,13241,'he','×—×–×•×¨ ××œ ×¡×“×¨ ×”×›× ×™×¡×”',0),(476661,13241,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î³Î¹Î± Î½Î± Î´Î¹Î±Ï„Î¬Î¾ÎµÎ¹ ÎµÎ³Î³ÏÎ±Ï†Î®',0),(476662,13241,'zh','è¿”å›žè®¢å•è¾“å…¥',0),(476663,13241,'sv','Ã…tergÃ¥ till deadlinegrupper',0),(476664,13241,'it','Restituire per ordinare la voce',0),(476665,13241,'tl','',0),(476666,13241,'th','à¸à¸¥à¸±à¸šà¹„à¸›à¸—à¸µà¹ˆà¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(476667,13241,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤µà¤¾à¤ªà¤¸ à¤œà¤¾à¤à¤',0),(476668,13241,'ms','Kembali kepada perintah kemasukan',0),(476669,13241,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ù„Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø£Ù…Ø±',0),(476670,13241,'fr','Retourner pour commander l\'entrÃ©e',0),(476671,13241,'jp','ã‚¨ãƒ³ãƒˆãƒªã®é †åºã«æˆ»ã‚‹',0),(476672,13241,'pt','Retornar para entrada de pedido',0),(476673,13241,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ð² Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð²ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ',0),(476674,13241,'es','Regresa al Entrado del Orden',0),(476675,13241,'de','ZurÃ¼ck zum Eintrag bestellen',0),(476676,13241,'en','Return To Order Entry',0),(476677,13242,'is','',0),(476678,13242,'dr','(ÙˆØ±ÙˆØ¯) ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡(ÙˆÛŒÚ˜Ù‡',0),(476679,13242,'pr','Ø«Ø¨Øª (ÙˆØ±ÙˆØ¯) ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡(ÙˆÛŒÚ˜Ù‡',0),(476680,13242,'tr','Ã–zel giriÅŸ',0),(476681,13242,'pl','Specjalne wejÅ›cia',0),(476682,13242,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾Ð¼Ð¾Ñ†Ð¸Ð¸',0),(476683,13242,'ur','Ø®ØµÙˆØµÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(476684,13242,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° ÑÐ¿ÐµÑ†Ð¸Ñ˜Ð°Ð»Ð¸Ñ‚ÐµÑ‚Ð¸',0),(476685,13242,'vi','Lá»‘i vÃ o Ä‘áº·t biá»‡t',0),(476686,13242,'af','Specials inskrywing',0),(476687,13242,'ro','Oferte speciale de intrare',0),(476688,13242,'et','Eripakkumised kanne',0),(476689,13242,'si','Vstop v akciji',0),(476690,13242,'ba','Entri Spesial',0),(476691,13242,'nl','Specials post',0),(476692,13242,'fi','Tarjoukset merkintÃ¤',0),(476693,13242,'no','Spesialtilbud-oppfÃ¸ring',0),(476694,13242,'da','Specials post',0),(476695,13242,'ko','íŠ¹ë³„ í•­ëª©',0),(476696,13242,'he','×ž×‘×¦×¢×™× ×›× ×™×¡×”',0),(476697,13242,'el','Î‘Ï†Î¹ÎµÏÏŽÎ¼Î±Ï„Î± ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(476698,13242,'zh','ç‰¹ä»·æ¡ç›®',0),(476699,13242,'sv','Specialerbjudanden intrÃ¤de',0),(476700,13242,'it','Voce offerte speciali',0),(476701,13242,'tl','',0),(476702,13242,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸žà¸´à¹€à¸¨à¸©',0),(476703,13242,'hi','à¤¸à¥à¤ªà¥‡à¤¶à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(476704,13242,'ms','Entri istimewa',0),(476705,13242,'ar','Ø¯Ø®ÙˆÙ„ Ø®Ø§ØµØ©',0),(476706,13242,'fr','EntrÃ©e de promotions',0),(476707,13242,'jp','ã‚¹ãƒšã‚·ãƒ£ãƒ« ã‚¨ãƒ³ãƒˆãƒª',0),(476708,13242,'pt','Entrada de especiais',0),(476709,13242,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ ÑÐ¾Ð±Ñ‹Ñ‚Ð¸Ñ',0),(476710,13242,'es','Entrar Especiales',0),(476711,13242,'de','Specials-Eintrag',0),(476712,13242,'en','Specials Entry',0),(476713,13243,'is','',0),(476714,13243,'dr','Ø¨Ø¹Ø¯ Ø§Ø²ÛŒÚ©Ø´Ù†Ø¨Ù‡ Ø¹Ø§Ø¯ÛŒ ',0),(476715,13243,'pr','Ø¨Ø¹Ø¯ Ø§Ø²ÛŒÚ©Ø´Ù†Ø¨Ù‡ Ø¹Ø§Ø¯ÛŒ ',0),(476716,13243,'tr','Sonra dÃ¼zenli Pazar',0),(476717,13243,'pl','Po lekcjach niedziela',0),(476718,13243,'bg','Ð¡Ð»ÐµÐ´ Ñ€ÐµÐ´Ð¾Ð²Ð½Ð¸ Ð½ÐµÐ´ÐµÐ»Ñ',0),(476719,13243,'ur','Ø§ØªÙˆØ§Ø± Ú©Û’ Ø±ÙˆØ² Ø¨Ø§Ù‚Ø§Ø¹Ø¯Û Ú©Û’ Ø¨Ø¹Ø¯',0),(476720,13243,'sr','ÐÐ°ÐºÐ¾Ð½ Ñ€ÐµÐ³ÑƒÐ»Ð°Ñ€Ð½Ðµ Ñƒ Ð½ÐµÐ´ÐµÑ™Ñƒ',0),(476721,13243,'vi','Sau chá»§ nháº­t thÃ´ng thÆ°á»ng ',0),(476722,13243,'af','Na gereelde Sondag',0),(476723,13243,'ro','DupÄƒ regulat duminicÄƒ',0),(476724,13243,'et','PÃ¤rast tavaline pÃ¼hapÃ¤ev',0),(476725,13243,'si','Po redni nedelja',0),(476726,13243,'ba','Setelah biasa minggu',0),(476727,13243,'nl','Na regelmatige zondag',0),(476728,13243,'fi','JÃ¤lkeen sÃ¤Ã¤nnÃ¶llisesti sunnuntai',0),(476729,13243,'no','Etter vanlig sÃ¸ndag',0),(476730,13243,'da','Efter regelmÃ¦ssig sÃ¸ndag',0),(476731,13243,'ko','ì¼ë°˜ ì¼ìš”ì¼ í›„',0),(476732,13243,'he','×œ××—×¨ ×§×‘×•×¢ ×‘×™×•× ×¨××©×•×Ÿ',0),(476733,13243,'el','ÎœÎµÏ„Î¬ Ï„Î·Î½ Ï„Î±ÎºÏ„Î¹ÎºÎ® ÎšÏ…ÏÎ¹Î±ÎºÎ®',0),(476734,13243,'zh','åŽç»å¸¸æ˜ŸæœŸå¤©',0),(476735,13243,'sv','Efter vanlig sÃ¶ndag',0),(476736,13243,'it','Dopo regolare domenica',0),(476737,13243,'tl','',0),(476738,13243,'th','à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸›à¸£à¸°à¸ˆà¸³à¸§à¸±à¸™à¸­à¸²à¸—à¸´à¸•à¸¢à¹Œ',0),(476739,13243,'hi','à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤°à¤µà¤¿à¤µà¤¾à¤° à¤•à¥‡ à¤¬à¤¾à¤¦',0),(476740,13243,'ms','Selepas kerap Ahad',0),(476741,13243,'ar','Ø¨Ø¹Ø¯ Ø§Ù„Ø¹Ø§Ø¯ÙŠØ© Ø§Ù„Ø£Ø­Ø¯',0),(476742,13243,'fr','AprÃ¨s les rÃ©guliÃ¨res dimanche',0),(476743,13243,'jp','å®šæœŸçš„ã«æ—¥æ›œæ—¥å¾Œ',0),(476744,13243,'pt','ApÃ³s Regular domingo',0),(476745,13243,'ru','ÐŸÐ¾ÑÐ»Ðµ Ñ€ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ñ‹Ñ… Ð²Ð¾ÑÐºÑ€ÐµÑÐµÐ½ÑŒÐµ',0),(476746,13243,'es','DespuÃ©s un Domingo Normal',0),(476747,13243,'de','Nach regelmÃ¤ÃŸigen Sonntag',0),(476748,13243,'en','After Regular Sunday',0),(476749,13244,'is','',0),(476750,13244,'dr','Ù‚Ø¨Ù„ Ø§Ø² ÛŒÚ©Ø´Ù†Ø¨Ù‡ Ù…Ø¹Ù…ÙˆÙ„',0),(476751,13244,'pr','Ù‚Ø¨Ù„ Ø§Ø² ÛŒÚ©Ø´Ù†Ø¨Ù‡ Ù…Ø¹Ù…ÙˆÙ„',0),(476752,13244,'tr','Daha Ã¶nce dÃ¼zenli Pazar',0),(476753,13244,'pl','Przed regularnym niedziela',0),(476754,13244,'bg','ÐŸÑ€ÐµÐ´Ð¸ Ñ€ÐµÐ´Ð¾Ð²Ð½Ð¾ Ð½ÐµÐ´ÐµÐ»Ñ',0),(476755,13244,'ur','Ø§ØªÙˆØ§Ø± Ú©Û’ Ø±ÙˆØ² Ø¨Ø§Ù‚Ø§Ø¹Ø¯Û Ø³Û’ Ù¾ÛÙ„Û’',0),(476756,13244,'sr','ÐŸÑ€Ðµ Ñ€ÐµÐ´Ð¾Ð²Ð½Ð¾ Ñƒ Ð½ÐµÐ´ÐµÑ™Ñƒ',0),(476757,13244,'vi','trÆ°á»›c chá»§ nhÃ¢t thÃ´ng thÆ°á»ng',0),(476758,13244,'af','Voor gereelde Sondag',0),(476759,13244,'ro','ÃŽnainte de regulat duminicÄƒ',0),(476760,13244,'et','Enne regulaarse pÃ¼hapÃ¤ev',0),(476761,13244,'si','Pred redno nedeljo',0),(476762,13244,'ba','Sebelum biasa minggu',0),(476763,13244,'nl','Voor regelmatige zondag',0),(476764,13244,'fi','Ennen sÃ¤Ã¤nnÃ¶llisen sunnuntai',0),(476765,13244,'no','FÃ¸r vanlig sÃ¸ndag',0),(476766,13244,'da','FÃ¸r regelmÃ¦ssige sÃ¸ndag',0),(476767,13244,'ko','ì¼ë°˜ ì¼ìš”ì¼ ì „ì—',0),(476768,13244,'he','×œ×¤× ×™ ×§×‘×•×¢ ×‘×™×•× ×¨××©×•×Ÿ',0),(476769,13244,'el','Î ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Ï„Î±ÎºÏ„Î¹ÎºÎ® ÎšÏ…ÏÎ¹Î±ÎºÎ®',0),(476770,13244,'zh','ä¹‹å‰ç»å¸¸æ˜ŸæœŸå¤©',0),(476771,13244,'sv','Innan vanlig sÃ¶ndag',0),(476772,13244,'it','Prima di regolare domenica',0),(476773,13244,'tl','',0),(476774,13244,'th','à¸à¹ˆà¸­à¸™à¸›à¸£à¸°à¸ˆà¸³à¸§à¸±à¸™à¸­à¸²à¸—à¸´à¸•à¸¢à¹Œ',0),(476775,13244,'hi','à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤°à¤µà¤¿à¤µà¤¾à¤° à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡',0),(476776,13244,'ms','Sebelum biasa hari Ahad',0),(476777,13244,'ar','Ù‚Ø¨Ù„ Ø§Ù„Ø¹Ø§Ø¯ÙŠØ© Ø§Ù„Ø£Ø­Ø¯',0),(476778,13244,'fr','Avant rÃ©guliÃ¨re dimanche',0),(476779,13244,'jp','å®šæœŸçš„ã«æ—¥æ›œæ—¥ã®å‰ã«',0),(476780,13244,'pt','Antes de Regular domingo',0),(476781,13244,'ru','ÐŸÐµÑ€ÐµÐ´ Ð¾Ñ‡ÐµÑ€ÐµÐ´Ð½Ð¾Ð¹ Ð²Ð¾ÑÐºÑ€ÐµÑÐµÐ½ÑŒÐµ',0),(476782,13244,'es','Antes que Domingo Normal',0),(476783,13244,'de','Vor dem regulÃ¤ren Sonntag',0),(476784,13244,'en','Before Regular Sunday',0),(476785,13245,'is','',0),(476786,13245,'dr','Ø´Ø±Ø­ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(476787,13245,'pr','Ø´Ø±Ø­ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(476788,13245,'tr','Ã–zel aÃ§Ä±klama',0),(476789,13245,'pl','Niestandardowy opis',0),(476790,13245,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(476791,13245,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¨ÛŒØ§Ù†',0),(476792,13245,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¸ Ð¾Ð¿Ð¸Ñ',0),(476793,13245,'vi','tá»± táº¡o diá»…n giáº£i',0),(476794,13245,'af','Pasgemaakte Beskrywing',0),(476795,13245,'ro','Descriere',0),(476796,13245,'et','Kohandatud kirjeldus',0),(476797,13245,'si','Meri opis',0),(476798,13245,'ba','Deskripsi kustom',0),(476799,13245,'nl','Aangepaste beschrijving',0),(476800,13245,'fi','Mukautettu kuvaus',0),(476801,13245,'no','Beskrivelse',0),(476802,13245,'da','Brugerdefineret beskrivelse',0),(476803,13245,'ko','ì‚¬ìš©ìž ì •ì˜ ì„¤ëª…',0),(476804,13245,'he','×ª×™××•×¨ ×ž×•×ª×× ××™×©×™×ª',0),(476805,13245,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(476806,13245,'zh','è‡ªå®šä¹‰è¯´æ˜Ž',0),(476807,13245,'sv','Anpassad Beskrivning',0),(476808,13245,'it','Descrizione personalizzata',0),(476809,13245,'tl','',0),(476810,13245,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹à¸šà¸šà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡',0),(476811,13245,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£',0),(476812,13245,'ms','Description/kawalan Kastam',0),(476813,13245,'ar','ÙˆØµÙ Ù…Ø®ØµØµ',0),(476814,13245,'fr','Description personnalisÃ©e',0),(476815,13245,'jp','ã‚«ã‚¹ã‚¿ãƒ ã®èª¬æ˜Ž',0),(476816,13245,'pt','DescriÃ§Ã£o personalizada',0),(476817,13245,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(476818,13245,'es','DescripciÃ³n Personalizada',0),(476819,13245,'de','Benutzerdefinierte Beschreibung',0),(476820,13245,'en','Custom Description',0),(476821,13246,'is','',0),(476822,13246,'dr','ØªØ§Ø±ÛŒØ® Ø§Ù†ØªØ®Ø§Ø¨',0),(476823,13246,'pr','ØªØ§Ø±ÛŒØ® Ø§Ù†ØªØ®Ø§Ø¨',0),(476824,13246,'tr','Tarih seÃ§imi',0),(476825,13246,'pl','Wyboru daty',0),(476826,13246,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(476827,13246,'ur','ØªØ§Ø±ÛŒØ® Ø§Ù†ØªØ®Ø§Ø¨',0),(476828,13246,'sr','Ð˜Ð·Ð±Ð¾Ñ€ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(476829,13246,'vi','Lá»±a chá»n ngÃ y',0),(476830,13246,'af','Datum Seleksie',0),(476831,13246,'ro','Data de selecÅ£ie',0),(476832,13246,'et','KuupÃ¤eva valik',0),(476833,13246,'si','Datum izbor',0),(476834,13246,'ba','Tanggal seleksi',0),(476835,13246,'nl','Datum selectie',0),(476836,13246,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ valinta',0),(476837,13246,'no','Datovalg',0),(476838,13246,'da','Dato Selection',0),(476839,13246,'ko','ë‚ ì§œ ì„ íƒ',0),(476840,13246,'he','×‘×—×™×¨×ª ×ª××¨×™×š',0),(476841,13246,'el','Î•Ï€Î¹Î»Î¿Î³Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚',0),(476842,13246,'zh','æ—¥æœŸé€‰æ‹©',0),(476843,13246,'sv','DatumvÃ¤ljaren',0),(476844,13246,'it','Selezione della data',0),(476845,13246,'tl','',0),(476846,13246,'th','à¹€à¸¥à¸·à¸­à¸à¸§à¸±à¸™à¸—à¸µà¹ˆ',0),(476847,13246,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤šà¤¯à¤¨',0),(476848,13246,'ms','Tarikh pemilihan',0),(476849,13246,'ar','ØªØ­Ø¯ÙŠØ¯ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(476850,13246,'fr','SÃ©lection de date',0),(476851,13246,'jp','æ—¥ä»˜é¸æŠž',0),(476852,13246,'pt','SeleÃ§Ã£o de datas',0),(476853,13246,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ Ð´Ð°Ñ‚Ñ‹',0),(476854,13246,'es','SelecciÃ³n de Fecha',0),(476855,13246,'de','Datumsauswahl',0),(476856,13246,'en','Date Selection',0),(476857,13247,'is','',0),(476858,13247,'dr','Nr ',0),(476859,13247,'pr',' Ø·Ø±Ø§Ø­ÛŒNr ',0),(476860,13247,'tr','Nr Tasarla',0),(476861,13247,'pl','Projekt Nr',0),(476862,13247,'bg','Ð”Ð¸Ð·Ð°Ð¹Ð½ Nr',0),(476863,13247,'ur','ÚˆÛŒØ²Ø§Ø¦Ù† Ø§ÛŒÙ† Ø¢Ø±',0),(476864,13247,'sr','Ð”Ð¸Ð·Ð°Ñ˜Ð½ ÐÑ€',0),(476865,13247,'vi','thiáº¿t káº¿ Nr',0),(476866,13247,'af','Ontwerp Nr',0),(476867,13247,'ro','Design Nr',0),(476868,13247,'et','Kujundus Nr',0),(476869,13247,'si','Design Nr',0),(476870,13247,'ba','Nr desain',0),(476871,13247,'nl','Ontwerp Nr',0),(476872,13247,'fi','Design Nr',0),(476873,13247,'no','Design Nr',0),(476874,13247,'da','Design Nr',0),(476875,13247,'ko','ë””ìžì¸ Nr',0),(476876,13247,'he','×¢×™×¦×•×‘ Nr',0),(476877,13247,'el','Î£Ï‡ÎµÎ´Î¹Î±ÏƒÎ¼ÏŒÏ‚ Nr',0),(476878,13247,'zh','è®¾è®¡ Nr',0),(476879,13247,'sv','Design Nr',0),(476880,13247,'it','Progettazione Nr',0),(476881,13247,'tl','',0),(476882,13247,'th','à¸­à¸­à¸à¹à¸šà¸š Nr',0),(476883,13247,'hi','à¤¡à¤¿à¤œà¤¾à¤‡à¤¨ à¤à¤¨. à¤†à¤°.',0),(476884,13247,'ms','Nr Reka bentuk',0),(476885,13247,'ar','ØªØµÙ…ÙŠÙ… Ø§Ù„Ù…Ø¬Ù„Ø©',0),(476886,13247,'fr','Conception Nr',0),(476887,13247,'jp','ãƒ‡ã‚¶ã‚¤ãƒ³ç•ªå· Nr',0),(476888,13247,'pt','Projeto Nr',0),(476889,13247,'ru','Ð”Ð¸Ð·Ð°Ð¹Ð½ Nr',0),(476890,13247,'es','Nro de DiseÃ±o',0),(476891,13247,'de','Design Nr.',0),(476892,13247,'en','Design Nr',0),(476893,13248,'is','',0),(476894,13248,'dr','Ø§ÙˆÙ„ ÛŒÚ©Ø´Ù†Ø¨Ù‡',0),(476895,13248,'pr','Ø§ÙˆÙ„ ÛŒÚ©Ø´Ù†Ø¨Ù‡',0),(476896,13248,'tr','Ä°lk Pazar gÃ¼nÃ¼',0),(476897,13248,'pl','Pierwsza niedziela',0),(476898,13248,'bg','ÐŸÑŠÑ€Ð²Ð°Ñ‚Ð° Ð½ÐµÐ´ÐµÐ»Ñ',0),(476899,13248,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§ØªÙˆØ§Ø±',0),(476900,13248,'sr','ÐŸÑ€Ð²Ðµ Ð½ÐµÐ´ÐµÑ™Ðµ',0),(476901,13248,'vi','chá»§ nháº­t Ä‘áº§u tiÃªn',0),(476902,13248,'af','Eerste Sondag',0),(476903,13248,'ro','Prima duminicÄƒ',0),(476904,13248,'et','Esimesel pÃ¼hapÃ¤eval',0),(476905,13248,'si','Prvo nedeljo',0),(476906,13248,'ba','Hari minggu pertama',0),(476907,13248,'nl','Eerste zondag',0),(476908,13248,'fi','EnsimmÃ¤isenÃ¤ sunnuntaina',0),(476909,13248,'no','FÃ¸rste sÃ¸ndag',0),(476910,13248,'da','FÃ¸rste sÃ¸ndag',0),(476911,13248,'ko','ì²« ë²ˆì§¸ ì¼ìš”ì¼',0),(476912,13248,'he','×™×•× ×¨××©×•×Ÿ ×”×¨××©×•×Ÿ',0),(476913,13248,'el','Î ÏÏŽÏ„Î· ÎšÏ…ÏÎ¹Î±ÎºÎ®',0),(476914,13248,'zh','ç¬¬ä¸€ä¸ªæ˜ŸæœŸæ—¥',0),(476915,13248,'sv','FÃ¶rsta sÃ¶ndagen',0),(476916,13248,'it','Prima domenica',0),(476917,13248,'tl','',0),(476918,13248,'th','à¸§à¸±à¸™à¸­à¸²à¸—à¸´à¸•à¸¢à¹Œà¹à¸£à¸',0),(476919,13248,'hi','à¤ªà¤¹à¤²à¤¾ à¤°à¤µà¤¿à¤µà¤¾à¤°',0),(476920,13248,'ms','Hari Ahad pertama',0),(476921,13248,'ar','Ø§Ù„ÙŠÙˆÙ… Ø§Ù„Ø£Ø­Ø¯ Ø£ÙˆÙ„',0),(476922,13248,'fr','Premier dimanche',0),(476923,13248,'jp','æœ€åˆã®æ—¥æ›œæ—¥',0),(476924,13248,'pt','Primeiro domingo',0),(476925,13248,'ru','ÐŸÐµÑ€Ð²Ð¾Ðµ Ð²Ð¾ÑÐºÑ€ÐµÑÐµÐ½ÑŒÐµ',0),(476926,13248,'es','Primero Domingo',0),(476927,13248,'de','Ersten Sonntag',0),(476928,13248,'en','First Sunday',0),(476929,13249,'is','',0),(476930,13249,'dr','Ú†Ù‡Ø§Ø±Ù…ÛŒÙ† ÛŒÚ©Ø´Ù†Ø¨Ù‡',0),(476931,13249,'pr','Ú†Ù‡Ø§Ø±Ù…ÛŒÙ† ÛŒÚ©Ø´Ù†Ø¨Ù‡',0),(476932,13249,'tr','DÃ¶rdÃ¼ncÃ¼ Pazar',0),(476933,13249,'pl','Czwarta niedziela',0),(476934,13249,'bg','Ð§ÐµÑ‚Ð²ÑŠÑ€Ñ‚Ð° Ð½ÐµÐ´ÐµÐ»Ñ',0),(476935,13249,'ur','Ú†ÙˆØªÚ¾Ø§ Ø§ØªÙˆØ§Ø±',0),(476936,13249,'sr','Ð§ÐµÑ‚Ð²Ñ€Ñ‚Ð¸ Ñƒ Ð½ÐµÐ´ÐµÑ™Ñƒ',0),(476937,13249,'vi','chá»§ nháº­t thá»© bá»‘n',0),(476938,13249,'af','Vierde Sondag',0),(476939,13249,'ro','Duminica patra',0),(476940,13249,'et','Neljandat pÃ¼hapÃ¤eva',0),(476941,13249,'si','ÄŒetrto nedeljo',0),(476942,13249,'ba','Keempat hari Minggu',0),(476943,13249,'nl','Vierde zondag',0),(476944,13249,'fi','NeljÃ¤s sunnuntai',0),(476945,13249,'no','Fjerde sÃ¸ndag',0),(476946,13249,'da','Fjerde sÃ¸ndag',0),(476947,13249,'ko','ë„¤ ë²ˆì§¸ ì¼ìš”ì¼',0),(476948,13249,'he','×‘×™×•× ×¨××©×•×Ÿ ×”×¨×‘×™×¢×™',0),(476949,13249,'el','Î¤Î­Ï„Î±ÏÏ„Î· ÎšÏ…ÏÎ¹Î±ÎºÎ®',0),(476950,13249,'zh','ç¬¬å››ä¸ªæ˜ŸæœŸæ—¥',0),(476951,13249,'sv','FjÃ¤rde sÃ¶ndagen',0),(476952,13249,'it','Quarta domenica',0),(476953,13249,'tl','',0),(476954,13249,'th','à¸§à¸±à¸™à¸­à¸²à¸—à¸´à¸•à¸¢à¹Œà¸—à¸µà¹ˆà¸ªà¸µà¹ˆ',0),(476955,13249,'hi','à¤šà¥Œà¤¥à¤¾ à¤°à¤µà¤¿à¤µà¤¾à¤°',0),(476956,13249,'ms','Ahad keempat',0),(476957,13249,'ar','Ø§Ù„Ø£Ø­Ø¯ Ø§Ù„Ø±Ø§Ø¨Ø¹',0),(476958,13249,'fr','QuatriÃ¨me dimanche',0),(476959,13249,'jp','ç¬¬ 4 æ—¥æ›œæ—¥',0),(476960,13249,'pt','Quarto domingo',0),(476961,13249,'ru','Ð§ÐµÑ‚Ð²ÐµÑ€Ñ‚Ð¾Ðµ Ð²Ð¾ÑÐºÑ€ÐµÑÐµÐ½ÑŒÐµ',0),(476962,13249,'es','Cuarto Domingo',0),(476963,13249,'de','Vierten Sonntag',0),(476964,13249,'en','Fourth Sunday',0),(476965,13250,'is','',0),(476966,13250,'dr','ØªØ§Ø±ÛŒØ® Ø¬ÙˆÙ‡Ø±',0),(476967,13250,'pr','ØªØ§Ø±ÛŒØ® Ø¬ÙˆÙ‡Ø±',0),(476968,13250,'tr','MÃ¼rekkep tarihi',0),(476969,13250,'pl','Data pisma odrÄ™cznego',0),(476970,13250,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾',0),(476971,13250,'ur','Ø§Ù†Ú© ØªØ§Ø±ÛŒØ®',0),(476972,13250,'sr','ÐœÐ°ÑÑ‚Ð¸Ð»Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼',0),(476973,13250,'vi','má»±c ngÃ y',0),(476974,13250,'af','Ink datum',0),(476975,13250,'ro','Data de cernealÄƒ',0),(476976,13250,'et','Tindi kuupÃ¤ev',0),(476977,13250,'si','Datum Ärnila',0),(476978,13250,'ba','Tinta tanggal',0),(476979,13250,'nl','Inkt datum',0),(476980,13250,'fi','Muste pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(476981,13250,'no','Blekk dato',0),(476982,13250,'da','BlÃ¦k dato',0),(476983,13250,'ko','ìž‰í¬ ë‚ ì§œ',0),(476984,13250,'he','×ª××¨×™×š ×“×™×•',0),(476985,13250,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¼ÎµÎ»Î¬Î½Î¹',0),(476986,13250,'zh','æ²¹å¢¨æ—¥æœŸ',0),(476987,13250,'sv','BlÃ¤ck datum',0),(476988,13250,'it','Inchiostro data',0),(476989,13250,'tl','',0),(476990,13250,'th','à¸§à¸±à¸™à¸«à¸¡à¸¶à¸',0),(476991,13250,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(476992,13250,'ms','Tarikh dakwat',0),(476993,13250,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø¨Ø±',0),(476994,13250,'fr','Date de l\'entrÃ©e manuscrite',0),(476995,13250,'jp','ã‚¤ãƒ³ã‚¯ã®æ—¥ä»˜',0),(476996,13250,'pt','Data de tinta',0),(476997,13250,'ru','Ink Ð”Ð°Ñ‚Ð°',0),(476998,13250,'es','fecha de Tinta',0),(476999,13250,'de','Tinte-Datum',0),(477000,13250,'en','Ink Date',0),(477001,13251,'is','',0),(477002,13251,'dr','Ø¢Ø®Ø±ÛŒÙ† ÛŒÚ©Ø´Ù†Ø¨Ù‡',0),(477003,13251,'pr','Ø¢Ø®Ø±ÛŒÙ† ÛŒÚ©Ø´Ù†Ø¨Ù‡',0),(477004,13251,'tr','GeÃ§en Pazar gÃ¼nÃ¼',0),(477005,13251,'pl','Ostatnia niedziela',0),(477006,13251,'bg','ÐœÐ¸Ð½Ð°Ð»Ð°Ñ‚Ð° Ð½ÐµÐ´ÐµÐ»Ñ',0),(477007,13251,'ur','Ú¯Ø²Ø´ØªÛ Ø§ØªÙˆØ§Ø±',0),(477008,13251,'sr','ÐŸÑ€Ð¾ÑˆÐ»Ðµ Ð½ÐµÐ´ÐµÑ™Ðµ',0),(477009,13251,'vi','chá»§ nháº­t trÆ°á»›c',0),(477010,13251,'af','Verlede Sondag',0),(477011,13251,'ro','Ultima duminicÄƒ',0),(477012,13251,'et','MÃ¶Ã¶dunud pÃ¼hapÃ¤eval',0),(477013,13251,'si','Zadnja nedelja',0),(477014,13251,'ba','Minggu',0),(477015,13251,'nl','Afgelopen zondag',0),(477016,13251,'fi','Viime sunnuntaina',0),(477017,13251,'no','Sist sÃ¸ndag',0),(477018,13251,'da','Sidste sÃ¸ndag',0),(477019,13251,'ko','ì§€ë‚œ ì¼ìš”ì¼',0),(477020,13251,'he','×‘×™×•× ×¨××©×•×Ÿ ×”××—×¨×•×Ÿ',0),(477021,13251,'el','Î¤Î·Î½ Ï€ÎµÏÎ±ÏƒÎ¼Î­Î½Î· ÎšÏ…ÏÎ¹Î±ÎºÎ®',0),(477022,13251,'zh','ä¸Šä¸ªæ˜ŸæœŸå¤©',0),(477023,13251,'sv','I sÃ¶ndags',0),(477024,13251,'it','Domenica scorsa',0),(477025,13251,'tl','',0),(477026,13251,'th','à¸§à¸±à¸™à¸­à¸²à¸—à¸´à¸•à¸¢à¹Œà¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(477027,13251,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤°à¤µà¤¿à¤µà¤¾à¤°',0),(477028,13251,'ms','Ahad lepas',0),(477029,13251,'ar','ÙŠÙˆÙ… Ø§Ù„Ø£Ø­Ø¯ Ø§Ù„Ù…Ø§Ø¶ÙŠ',0),(477030,13251,'fr','Dimanche dernier',0),(477031,13251,'jp','å…ˆé€±ã®æ—¥æ›œæ—¥',0),(477032,13251,'pt','No domingo passado',0),(477033,13251,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ Ð²Ð¾ÑÐºÑ€ÐµÑÐµÐ½ÑŒÐµ',0),(477034,13251,'es','El Domingo Pasado',0),(477035,13251,'de','Letzten Sonntag',0),(477036,13251,'en','Last Sunday',0),(477037,13252,'is','',0),(477038,13252,'dr','Ù‡ÛŒÚ† ØªÚ©Ø±Ø§Ø±ÛŒ',0),(477039,13252,'pr','Ù‡ÛŒÚ† ØªÚ©Ø±Ø§Ø±ÛŒ',0),(477040,13252,'tr','HiÃ§bir yineleme',0),(477041,13252,'pl','Nie powtarzaj',0),(477042,13252,'bg','Ð˜Ð¼Ð° Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÐµÐ½Ð¸Ðµ',0),(477043,13252,'ur','Ú©ÙˆØ¦ÛŒ Ø¯ÛØ±Ø§Ø¦ÛŒÚº',0),(477044,13252,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð½Ð°Ð²Ñ™Ð°ÑšÐ°',0),(477045,13252,'vi','khÃ´ng láº·p láº¡i',0),(477046,13252,'af','Geen herhaal',0),(477047,13252,'ro','Nu se repetÄƒ',0),(477048,13252,'et','No Kordus',0),(477049,13252,'si','Ponovitev',0),(477050,13252,'ba','Ada pengulangan',0),(477051,13252,'nl','Geen herhaling',0),(477052,13252,'fi','Toista',0),(477053,13252,'no','Noen gjentakelse',0),(477054,13252,'da','Ingen gentagelse',0),(477055,13252,'ko','ë°˜ë³µ',0),(477056,13252,'he','No Repeat',0),(477057,13252,'el','Î¥Ï€Î¬ÏÎ¾ÎµÎ¹ ÎµÏ€Î±Î½Î¬Î»Î·ÏˆÎ·',0),(477058,13252,'zh','ä¸é‡å¤',0),(477059,13252,'sv','Inte upprepas',0),(477060,13252,'it','Nessuna ripetizione',0),(477061,13252,'tl','',0),(477062,13252,'th','à¹„à¸¡à¹ˆà¸‹à¹‰à¸³',0),(477063,13252,'hi','à¤¨à¤¹à¥€à¤‚ à¤¦à¥‹à¤¹à¤°à¤¾à¤¨à¥‡',0),(477064,13252,'ms','Tiada ulangan',0),(477065,13252,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªÙƒØ±Ø§Ø±',0),(477066,13252,'fr','Pas de rÃ©pÃ©tition',0),(477067,13252,'jp','ç¹°ã‚Šè¿”ã—ãªã—',0),(477068,13252,'pt','NÃ£o se repita',0),(477069,13252,'ru','ÐÐµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð¸Ñ‚ÑŒ',0),(477070,13252,'es','No Repitir',0),(477071,13252,'de','Keine Wiederholung',0),(477072,13252,'en','No Repeat',0),(477073,13253,'is','',0),(477074,13253,'dr','ØªØ¹ÛŒÛŒÙ† Ø´ØºÙ„',0),(477075,13253,'pr','ØªØ¹ÛŒÛŒÙ† Ø´ØºÙ„',0),(477076,13253,'tr','YerleÅŸtirme',0),(477077,13253,'pl','Umieszczenie',0),(477078,13253,'bg','Ð Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(477079,13253,'ur','Ø¬Ú¯Û Ø¯Ø§Ø±ÛŒ',0),(477080,13253,'sr','ÐŸÐ¾Ð»Ð¾Ð¶Ð°Ñ˜',0),(477081,13253,'vi','sáº¯p xáº¿p',0),(477082,13253,'af','Plasing',0),(477083,13253,'ro','Plasarea',0),(477084,13253,'et','Paigutamine',0),(477085,13253,'si','Postavitev',0),(477086,13253,'ba','Penempatan',0),(477087,13253,'nl','Plaatsing',0),(477088,13253,'fi','Sijoitus',0),(477089,13253,'no','Plassering',0),(477090,13253,'da','Placering',0),(477091,13253,'ko','ë°°ì¹˜',0),(477092,13253,'he','×”×©×ž×”',0),(477093,13253,'el','Î¤Î¿Ï€Î¿Î¸Î­Ï„Î·ÏƒÎ·',0),(477094,13253,'zh','å®‰ç½®',0),(477095,13253,'sv','Placering',0),(477096,13253,'it','Posizionamento',0),(477097,13253,'tl','',0),(477098,13253,'th','à¸à¸²à¸£à¸ˆà¸±à¸”à¸§à¸²à¸‡',0),(477099,13253,'hi','à¤ªà¥à¤²à¥‡à¤¸à¤®à¥‡à¤‚à¤Ÿ',0),(477100,13253,'ms','Penempatan',0),(477101,13253,'ar','Ø§Ù„ØªÙ†Ø³ÙŠØ¨',0),(477102,13253,'fr','Placement',0),(477103,13253,'jp','é…ç½®',0),(477104,13253,'pt','ColocaÃ§Ã£o',0),(477105,13253,'ru','Ð Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ðµ',0),(477106,13253,'es','ColocaciÃ³n',0),(477107,13253,'de','Platzierung',0),(477108,13253,'en','Placement',0),(477109,13254,'is','',0),(477110,13254,'dr','Ø­Ø°Ù Ø®Ø·',0),(477111,13254,'pr','Ø­Ø°Ù Ø®Ø·',0),(477112,13254,'tr','SatÄ±rÄ±nÄ± kaldÄ±rÄ±n',0),(477113,13254,'pl','UsuÅ„ wiersz',0),(477114,13254,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð½Ð¸Ñ',0),(477115,13254,'ur','Ù„Ø§Ø¦Ù† ÛÙ¹Ø§Ø¦ÛŒÚº',0),(477116,13254,'sr','Ð£ÐºÐ»Ð°ÑšÐ°ÑšÐµ Ð»Ð¸Ð½Ð¸Ñ˜Ðµ',0),(477117,13254,'vi','bá» dÃ²ng',0),(477118,13254,'af','Verwyder lyn',0),(477119,13254,'ro','Elimina linie',0),(477120,13254,'et','Eemaldada rida',0),(477121,13254,'si','Odstranite vrstico',0),(477122,13254,'ba','Hapus baris',0),(477123,13254,'nl','Verwijder regel',0),(477124,13254,'fi','Poista rivi',0),(477125,13254,'no','Fjerne linje',0),(477126,13254,'da','Fjerne linje',0),(477127,13254,'ko','ì œê±° ë¼ì¸',0),(477128,13254,'he','×œ×”×¡×™×¨ ××ª ×§×•',0),(477129,13254,'el','Î‘Ï†Î±Î¹ÏÎ­ÏƒÏ„Îµ Ï„Î·Î½ Î³ÏÎ±Î¼Î¼Î®',0),(477130,13254,'zh','åˆ é™¤è¡Œ',0),(477131,13254,'sv','Ta bort rad',0),(477132,13254,'it','Rimuovere la linea',0),(477133,13254,'tl','',0),(477134,13254,'th','à¸¥à¸šà¸šà¸£à¸£à¸—à¸±à¸”',0),(477135,13254,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤¹à¤Ÿà¤¾à¤à¤',0),(477136,13254,'ms','Alih Keluar talian',0),(477137,13254,'ar','Ø¥Ø²Ø§Ù„Ø© Ø§Ù„Ø³Ø·Ø±',0),(477138,13254,'fr','Supprimer ligne',0),(477139,13254,'jp','è¡Œã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(477140,13254,'pt','Remover a linha',0),(477141,13254,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾ÐºÑƒ',0),(477142,13254,'es','Eliminar Linea',0),(477143,13254,'de','Zeile entfernen',0),(477144,13254,'en','Remove Line',0),(477145,13255,'is','',0),(477146,13255,'dr','ØªÚ©Ø±Ø§Ø±',0),(477147,13255,'pr','ØªÚ©Ø±Ø§Ø±',0),(477148,13255,'tr','Tekrarlar',0),(477149,13255,'pl','Powtarza',0),(477150,13255,'bg','Ð¡Ðµ Ð¿Ð¾Ð²Ñ‚Ð°Ñ€Ñ',0),(477151,13255,'ur','Ø¯ÛØ±Ø§ØªØ§ ÛÛ’',0),(477152,13255,'sr','ÐŸÐ¾Ð½Ð°Ð²Ñ™Ð°',0),(477153,13255,'vi','láº·p láº¡i',0),(477154,13255,'af','Herhaal',0),(477155,13255,'ro','Se repeta',0),(477156,13255,'et','Kordab',0),(477157,13255,'si','Ponavlja',0),(477158,13255,'ba','Mengulangi',0),(477159,13255,'nl','Wordt herhaald',0),(477160,13255,'fi','Toistaa',0),(477161,13255,'no','Gjentar',0),(477162,13255,'da','Gentager',0),(477163,13255,'ko','ë°˜ë³µ',0),(477164,13255,'he','×—×•×–×¨ ×¢×œ ×¢×¦×ž×•',0),(477165,13255,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î¬Î½ÎµÎ¹',0),(477166,13255,'zh','é‡å¤åºåˆ—',0),(477167,13255,'sv','Upprepar',0),(477168,13255,'it','Si ripete',0),(477169,13255,'tl','',0),(477170,13255,'th','à¸—à¸³à¸‹à¹‰à¸³',0),(477171,13255,'hi','à¤¦à¥‹à¤¹à¤°à¤¾à¤¤à¤¾ à¤¹à¥ˆ',0),(477172,13255,'ms','Mengulang',0),(477173,13255,'ar','ÙˆÙŠÙƒØ±Ø±',0),(477174,13255,'fr','RÃ©pÃ©titions',0),(477175,13255,'jp','ç¹°ã‚Šè¿”ã—',0),(477176,13255,'pt','Se repete',0),(477177,13255,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÐµÑ‚',0),(477178,13255,'es','Repitir',0),(477179,13255,'de','Wiederholungen',0),(477180,13255,'en','Repeats',0),(477181,13256,'is','',0),(477182,13256,'dr','ÛŒÚ©Ø´Ù†Ø¨Ù‡ Ø¯ÙˆÙ…',0),(477183,13256,'pr','ÛŒÚ©Ø´Ù†Ø¨Ù‡ Ø¯ÙˆÙ…',0),(477184,13256,'tr','Ä°kinci Pazar gÃ¼nÃ¼',0),(477185,13256,'pl','Druga niedziela',0),(477186,13256,'bg','Ð’Ñ‚Ð¾Ñ€Ð° Ð½ÐµÐ´ÐµÐ»Ñ',0),(477187,13256,'ur','Ø¯ÙˆØ³Ø±Ø§ Ø§ØªÙˆØ§Ø±',0),(477188,13256,'sr','Ð”Ñ€ÑƒÐ³Ðµ Ð½ÐµÐ´ÐµÑ™Ðµ',0),(477189,13256,'vi','NgÃ y chá»§ nháº­t thá»© 2',0),(477190,13256,'af','Tweede Sondag',0),(477191,13256,'ro','A doua duminicÄƒ',0),(477192,13256,'et','Teine pÃ¼hapÃ¤ev',0),(477193,13256,'si','Drugo nedeljo',0),(477194,13256,'ba','Minggu kedua',0),(477195,13256,'nl','Tweede zondag',0),(477196,13256,'fi','Toinen sunnuntai',0),(477197,13256,'no','Andre sÃ¸ndag',0),(477198,13256,'da','Anden sÃ¸ndag',0),(477199,13256,'ko','ë‘ ë²ˆì§¸ ì¼ìš”ì¼',0),(477200,13256,'he','×\' ×”×©× ×™',0),(477201,13256,'el','Î”ÎµÏÏ„ÎµÏÎ· ÎšÏ…ÏÎ¹Î±ÎºÎ®',0),(477202,13256,'zh','ç¬¬äºŒä¸ªæ˜ŸæœŸæ—¥',0),(477203,13256,'sv','Andra sÃ¶ndagen',0),(477204,13256,'it','Seconda domenica',0),(477205,13256,'tl','',0),(477206,13256,'th','à¸§à¸±à¸™à¸­à¸²à¸—à¸´à¸•à¸¢à¹Œà¸—à¸µà¹ˆà¸ªà¸­à¸‡',0),(477207,13256,'hi','à¤¦à¥‚à¤¸à¤°à¤¾ à¤°à¤µà¤¿à¤µà¤¾à¤°',0),(477208,13256,'ms','Ahad kedua',0),(477209,13256,'ar','Ø§Ù„Ø£Ø­Ø¯ Ø§Ù„Ø«Ø§Ù†ÙŠ',0),(477210,13256,'fr','DeuxiÃ¨me dimanche',0),(477211,13256,'jp','ç¬¬ 2 æ—¥æ›œæ—¥',0),(477212,13256,'pt','Segundo domingo',0),(477213,13256,'ru','Ð’Ñ‚Ð¾Ñ€Ð¾Ðµ Ð²Ð¾ÑÐºÑ€ÐµÑÐµÐ½ÑŒÐµ',0),(477214,13256,'es','Segundo Domingo',0),(477215,13256,'de','Zweiten Sonntag',0),(477216,13256,'en','Second Sunday',0),(477217,13257,'is','',0),(477218,13257,'dr','(ØªÙˆØ§Ù„ÛŒ',0),(477219,13257,'pr','Ø¯Ù†Ø¨Ø§Ù„Ù‡(ØªÙˆØ§Ù„ÛŒ',0),(477220,13257,'tr','SÄ±ra',0),(477221,13257,'pl','Sekwencja',0),(477222,13257,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð½Ð¾ÑÑ‚',0),(477223,13257,'ur','ØªØ³Ù„Ø³Ù„',0),(477224,13257,'sr','Ð¡ÐµÐºÐ²ÐµÐ½Ñ†Ð°',0),(477225,13257,'vi','TrÃ¬nh tá»±',0),(477226,13257,'af','Volgorde',0),(477227,13257,'ro','SecvenÅ£Äƒ',0),(477228,13257,'et','Jada',0),(477229,13257,'si','Zaporedje',0),(477230,13257,'ba','Urutan',0),(477231,13257,'nl','Volgorde',0),(477232,13257,'fi','JÃ¤rjestyksessÃ¤',0),(477233,13257,'no','Sekvens',0),(477234,13257,'da','Sekvens',0),(477235,13257,'ko','ì‹œí€€ìŠ¤',0),(477236,13257,'he','×¨×¦×£',0),(477237,13257,'el','Î‘ÎºÎ¿Î»Î¿Ï…Î¸Î¯Î±',0),(477238,13257,'zh','åºåˆ—',0),(477239,13257,'sv','Sekvens',0),(477240,13257,'it','Sequenza',0),(477241,13257,'tl','',0),(477242,13257,'th','à¸¥à¸³à¸”à¸±à¸š',0),(477243,13257,'hi','à¤…à¤¨à¥à¤•à¥à¤°à¤®',0),(477244,13257,'ms','Jujukan',0),(477245,13257,'ar','ØªØ³Ù„Ø³Ù„',0),(477246,13257,'fr','SÃ©quence',0),(477247,13257,'jp','ã‚·ãƒ¼ã‚±ãƒ³ã‚¹',0),(477248,13257,'pt','SeqÃ¼Ãªncia',0),(477249,13257,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚ÑŒ',0),(477250,13257,'es','Secuencia',0),(477251,13257,'de','Sequenz',0),(477252,13257,'en','Sequence',0),(477253,13258,'is','',0),(477254,13258,'dr','Ø±ÙˆØ² Ø®Ø§Øµ Ø§Ø² Ù…Ø§Ù‡',0),(477255,13258,'pr','Ø±ÙˆØ² Ø®Ø§Øµ Ø§Ø² Ù…Ø§Ù‡',0),(477256,13258,'tr','AyÄ±n belirli bir gÃ¼nÃ¼',0),(477257,13258,'pl','Dnia miesiÄ…ca',0),(477258,13258,'bg','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ð´ÐµÐ½ Ð¾Ñ‚ Ð¼ÐµÑÐµÑ†Ð°',0),(477259,13258,'ur','Ù…ÛÛŒÙ†Û Ú©ÛŒ Ù…Ø®ØµÙˆØµ Ø¯Ù†',0),(477260,13258,'sr','ÐžÐ´Ñ€ÐµÑ’ÐµÐ½Ð¸ Ð´Ð°Ð½ Ñƒ Ð¼ÐµÑÐµÑ†Ñƒ',0),(477261,13258,'vi','NgÃ y Ä‘áº·c biá»‡t cá»§a thÃ¡ng',0),(477262,13258,'af','Spesifieke dag van die maand',0),(477263,13258,'ro','AnumitÄƒ zi a lunii',0),(477264,13258,'et','Kindlal pÃ¤eval kuus',0),(477265,13258,'si','DoloÄen dan v mesecu',0),(477266,13258,'ba','Khusus hari bulan',0),(477267,13258,'nl','Specifieke dag van maand',0),(477268,13258,'fi','Tietty kuukauden pÃ¤ivÃ¤',0),(477269,13258,'no','Bestemte dagen i mÃ¥neden',0),(477270,13258,'da','Bestemt dag i mÃ¥neden',0),(477271,13258,'ko','ì›”ì˜ íŠ¹ì • ì¼',0),(477272,13258,'he','×™×•× ×ž×¡×•×™× ×©×œ ×—×•×“×©',0),(477273,13258,'el','Î£Ï…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î· Î·Î¼Î­ÏÎ± Ï„Î¿Ï… Î¼Î®Î½Î±',0),(477274,13258,'zh','æ¯æœˆçš„æŸå¤©',0),(477275,13258,'sv','Viss dag mÃ¥nad',0),(477276,13258,'it','Giorno specifico del mese',0),(477277,13258,'tl','',0),(477278,13258,'th','à¸§à¸±à¸™à¸‚à¸­à¸‡à¹€à¸”à¸·à¸­à¸™',0),(477279,13258,'hi','à¤®à¤¾à¤¹ à¤•à¥‡ à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤¦à¤¿à¤µà¤¸',0),(477280,13258,'ms','Hari yang ditetapkan dalam bulan',0),(477281,13258,'ar','ÙŠÙˆÙ… Ù…Ø¹ÙŠÙ† Ù…Ù† Ø§Ù„Ø´Ù‡Ø±',0),(477282,13258,'fr','Jour spÃ©cifique du mois',0),(477283,13258,'jp','æœˆã®ç‰¹å®šæ—¥',0),(477284,13258,'pt','Dia especÃ­fico do mÃªs',0),(477285,13258,'ru','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ñ‹Ð¹ Ð´ÐµÐ½ÑŒ Ð¼ÐµÑÑÑ†Ð°',0),(477286,13258,'es','DÃ­a EspecÃ­fico Del Mes',0),(477287,13258,'de','Bestimmten Tag des Monats',0),(477288,13258,'en','Specific Day Of Month',0),(477289,13259,'is','',0),(477290,13259,'dr','Ø³ÙˆÙ…ÛŒÙ† ÛŒÚ©Ø´Ù†Ø¨Ù‡',0),(477291,13259,'pr','Ø³ÙˆÙ…ÛŒÙ† ÛŒÚ©Ø´Ù†Ø¨Ù‡',0),(477292,13259,'tr','ÃœÃ§Ã¼ncÃ¼ Pazar gÃ¼nÃ¼',0),(477293,13259,'pl','Trzecia niedziela',0),(477294,13259,'bg','Ð¢Ñ€ÐµÑ‚Ð°Ñ‚Ð° Ð½ÐµÐ´ÐµÐ»Ñ',0),(477295,13259,'ur','ØªÛŒØ³Ø±Û’ Ø§ØªÙˆØ§Ø±',0),(477296,13259,'sr','Ð¢Ñ€ÐµÑ›Ð° Ð½ÐµÐ´ÐµÑ™Ð°',0),(477297,13259,'vi','Chá»§ nháº­t thá»© 3',0),(477298,13259,'af','Derde Sondag',0),(477299,13259,'ro','Treia duminicÄƒ',0),(477300,13259,'et','Kolmandal pÃ¼hapÃ¤eval',0),(477301,13259,'si','Tretja nedelja',0),(477302,13259,'ba','Hari minggu ketiga',0),(477303,13259,'nl','Derde zondag',0),(477304,13259,'fi','Kolmas sunnuntai',0),(477305,13259,'no','Tredje sÃ¸ndag',0),(477306,13259,'da','Tredje sÃ¸ndag',0),(477307,13259,'ko','ì„¸ ë²ˆì§¸ ì¼ìš”ì¼',0),(477308,13259,'he','×\' ×”×©×œ×™×©×™',0),(477309,13259,'el','Î¤ÏÎ¯Ï„Î· ÎšÏ…ÏÎ¹Î±ÎºÎ®',0),(477310,13259,'zh','ç¬¬ä¸‰ä¸ªæ˜ŸæœŸæ—¥',0),(477311,13259,'sv','Tredje sÃ¶ndagen',0),(477312,13259,'it','Terza domenica',0),(477313,13259,'tl','',0),(477314,13259,'th','à¸§à¸±à¸™à¸­à¸²à¸—à¸´à¸•à¸¢à¹Œà¸—à¸µà¹ˆà¸ªà¸²à¸¡',0),(477315,13259,'hi','à¤¤à¥€à¤¸à¤°à¤¾ à¤°à¤µà¤¿à¤µà¤¾à¤°',0),(477316,13259,'ms','Ahad ketiga',0),(477317,13259,'ar','Ø§Ù„Ø£Ø­Ø¯ Ø§Ù„Ø«Ø§Ù„Ø«',0),(477318,13259,'fr','TroisiÃ¨me dimanche',0),(477319,13259,'jp','ç¬¬ 3 æ—¥æ›œæ—¥',0),(477320,13259,'pt','Terceiro domingo',0),(477321,13259,'ru','Ð¢Ñ€ÐµÑ‚ÑŒÐµ Ð²Ð¾ÑÐºÑ€ÐµÑÐµÐ½ÑŒÐµ',0),(477322,13259,'es','Tercer Domingo',0),(477323,13259,'de','Dritter Sonntag',0),(477324,13259,'en','Third Sunday',0),(477325,13260,'is','',0),(477326,13260,'dr','ØºÛŒØ± ÙØ¹Ø§Ù„',0),(477327,13260,'pr','ØºÛŒØ± ÙØ¹Ø§Ù„',0),(477328,13260,'tr','Devre dÄ±ÅŸÄ± bÄ±rakma',0),(477329,13260,'pl','WyÅ‚Ä…cz',0),(477330,13260,'bg','Ð—Ð°Ð±Ñ€Ð°Ð½Ð¸',0),(477331,13260,'ur','Ù†Ø§Ø§ÛÙ„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(477332,13260,'sr','ÐžÐ½ÐµÐ¼Ð¾Ð³ÑƒÑ›Ð¸',0),(477333,13260,'vi','Loáº¡i\r\n',0),(477334,13260,'af','Versper',0),(477335,13260,'ro','Nu fi de acord',0),(477336,13260,'et','Keela',0),(477337,13260,'si','OnemogoÄi',0),(477338,13260,'ba','Menonaktifkan',0),(477339,13260,'nl','Uitschakelen',0),(477340,13260,'fi','Poista kÃ¤ytÃ¶stÃ¤',0),(477341,13260,'no','Deaktiver',0),(477342,13260,'da','Deaktiver',0),(477343,13260,'ko','ì‚¬ìš© ì•ˆ í•¨',0),(477344,13260,'he','×‘×˜×œ',0),(477345,13260,'el','Î‘Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(477346,13260,'zh','ç¦ç”¨',0),(477347,13260,'sv','Inaktivera',0),(477348,13260,'it','Disabilitare',0),(477349,13260,'tl','',0),(477350,13260,'th','à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(477351,13260,'hi','à¤…à¤•à¥à¤·à¤® à¤•à¤°à¥‡à¤‚',0),(477352,13260,'ms','Menyahdayakan',0),(477353,13260,'ar','ØªØ¹Ø·ÙŠÙ„',0),(477354,13260,'fr','DÃ©sactiver',0),(477355,13260,'jp','ç„¡åŠ¹ã«ã—ã¾ã™ã€‚',0),(477356,13260,'pt','Desativar',0),(477357,13260,'ru','ÐžÑ‚ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ',0),(477358,13260,'es','Hacer Inutil',0),(477359,13260,'de','Deaktivieren',0),(477360,13260,'en','Disable',0),(477361,13261,'is','',0),(477362,13261,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(477363,13261,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(477364,13261,'tr','FiÅŸe ait hata ekleme hareket',0),(477365,13261,'pl','BÅ‚Ä…d dodawania transakcji Voucher',0),(477366,13261,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð·Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(477367,13261,'ur','Ù†Ù‚Øµ Ø§Ø¶Ø§ÙÛ Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† ÙˆØ§Ø¤Ú†Ø± Ú©Û’ Ù„Ø¦Û’',0),(477368,13261,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ñƒ Ð·Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(477369,13261,'vi','Lá»—i khi thÃªm giao dá»‹ch cá»§a phiáº¿u',0),(477370,13261,'af','Fout voeg transaksie vir bewys',0),(477371,13261,'ro','Eroare adÄƒugarea de tranzacÅ£ie pentru Voucher',0),(477372,13261,'et','Viga lisades kanne kande',0),(477373,13261,'si','Napaka dodajanje transakcije za kupon',0),(477374,13261,'ba','Kesalahan transaksi menambahkan Voucher',0),(477375,13261,'nl','Fout toe te voegen transactie voor Voucher',0),(477376,13261,'fi','Virhe lisÃ¤Ã¤mÃ¤llÃ¤ tapahtuman tositteen',0),(477377,13261,'no','Feil Ã¥ legge transaksjonen For bilag',0),(477378,13261,'da','Fejl tilfÃ¸je transaktion For Voucher',0),(477379,13261,'ko','ë°”ìš°ì²˜ì— ëŒ€ í•œ ì˜¤ë¥˜ ì¶”ê°€ íŠ¸ëžœìž­ì…˜',0),(477380,13261,'he','×©×’×™××” ×”×•×¡×¤×ª ×ª× ×•×¢×” ×¢×‘×•×¨ ×©×•×‘×¨',0),(477381,13261,'el','Î£Ï†Î¬Î»Î¼Î± ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î³Î¹Î± ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(477382,13261,'zh','å‡­è¯çš„é”™è¯¯æ·»åŠ äº¤æ˜“è®°å½•',0),(477383,13261,'sv','Fel att lÃ¤gga till transaktionen fÃ¶r verifikation',0),(477384,13261,'it','Errore aggiunta transazione per Voucher',0),(477385,13261,'tl','',0),(477386,13261,'th','à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸³à¸„à¸±à¸',0),(477387,13261,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤‰à¤šà¤° à¤²à¥‡à¤¨à¤¦à¥‡à¤¨',0),(477388,13261,'ms','Ralat menambah bilangan transaksi baucar',0),(477389,13261,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø­Ø±ÙƒØ© Ù„Ù„Ø¥ÙŠØµØ§Ù„',0),(477390,13261,'fr','Erreur ajout de Transaction pour bon',0),(477391,13261,'jp','ã‚¨ãƒ©ãƒ¼ã®è¿½åŠ ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ä¼ç¥¨ã®',0),(477392,13261,'pt','Erro adicionando transaÃ§Ãµes de Voucher',0),(477393,13261,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ Ð´Ð»Ñ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(477394,13261,'es','Error Agregando TransacciÃ³n Par El Voucher',0),(477395,13261,'de','Fehler hinzufÃ¼gen Transaktion fÃ¼r Gutschein',0),(477396,13261,'en','Error Adding Transaction For Voucher',0),(477397,13262,'is','',0),(477398,13262,'dr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÛŒÙ„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± Ú©Ù„',0),(477399,13262,'pr','Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ† ÙØ§ÛŒÙ„ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± Ú©Ù„',0),(477400,13262,'tr','GL iÅŸlem dosyasÄ± sÃ¼tun biÃ§imi',0),(477401,13262,'pl','GL transakcji pliku formatu kolumny',0),(477402,13262,'bg','GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ ÐºÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(477403,13262,'ur','Ø¬ÛŒØ¬Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ù…Ø³Ù„ Ú©Ø§Ù„Ù… ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(477404,13262,'sr','Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ ÐºÐ¾Ð»Ð¾Ð½Ðµ',0),(477405,13262,'vi','Dáº¡ng file cá»™t cho cÃ¡c giao dá»‹ch sá»• cÃ¡i',0),(477406,13262,'af','GL transaksie kolom lÃªerformaat',0),(477407,13262,'ro','GL tranzacÅ£ie coloanei formatul de fiÅŸier',0),(477408,13262,'et','GL tehingu fail veeruvormingut',0),(477409,13262,'si','GL transakcije zapisa stolpec',0),(477410,13262,'ba','Format kolom GL transaksi File',0),(477411,13262,'nl','GL transactie bestand kolomindeling',0),(477412,13262,'fi','GL tapahtuman tiedostomuoto sarake',0),(477413,13262,'no','GL transaksjonen kolonnen filformat',0),(477414,13262,'da','GL transaktionen filformat kolonne',0),(477415,13262,'ko','GL íŠ¸ëžœìž­ì…˜ íŒŒì¼ ì—´ í˜•ì‹',0),(477416,13262,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×©×œ ×”×§×•×‘×¥ ×¢×¡×§×ª GL',0),(477417,13262,'el','GL ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® Î±ÏÏ‡ÎµÎ¯Î¿ Î¼Î¿ÏÏ†Î® ÏƒÏ„Î·Î»ÏŽÎ½',0),(477418,13262,'zh','GL äº¤æ˜“æ–‡ä»¶åˆ—æ ¼å¼',0),(477419,13262,'sv','GL transaktion-kolumn filformatet',0),(477420,13262,'it','GL transazione formato colonna',0),(477421,13262,'tl','',0),(477422,13262,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œà¹à¸Ÿà¹‰à¸¡à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡ GL',0),(477423,13262,'hi','GL à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(477424,13262,'ms','Format kolum fail urus niaga GL',0),(477425,13262,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ Ù…Ù„Ù Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª GL',0),(477426,13262,'fr','Format de colonne de fichier de Transaction GL',0),(477427,13262,'jp','GL ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ãƒ•ã‚¡ã‚¤ãƒ«åˆ—å½¢å¼',0),(477428,13262,'pt','Formato de coluna de arquivo de transaÃ§Ã£o de GL',0),(477429,13262,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ñ„Ð°Ð¹Ð»Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ GL',0),(477430,13262,'es','File de Transacciones LM Formato de Columnas',0),(477431,13262,'de','GL Transaktion Spalte Dateiformat',0),(477432,13262,'en','GL Transaction File Column Format',0),(477433,13263,'is','',0),(477434,13263,'dr','Ø§Ú¯Ø± Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¹ØªØ¨Ø§Ø± Ø¨Ø§ÛŒØ¯ Ù…Ù†ÙÛŒ Ø¨Ø§Ø´Ø¯',0),(477435,13263,'pr','Ø§Ú¯Ø± Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¹ØªØ¨Ø§Ø± Ø¨Ø§ÛŒØ¯ Ù…Ù†ÙÛŒ Ø¨Ø§Ø´Ø¯',0),(477436,13263,'tr','EÄŸer kredi tutarÄ± negatif olmalÄ±dÄ±r',0),(477437,13263,'pl','JeÅ›li kwota kredyt powinien byÄ‡ ujemna',0),(477438,13263,'bg','ÐÐºÐ¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÑÑƒÐ¼Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»Ð½Ð¾',0),(477439,13263,'ur','Ø§Ú¯Ø± Ú©Ø±ÛŒÚˆÙ¹ Ø±Ù‚Ù… Ù…Ù†ÙÛŒ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(477440,13263,'sr','ÐÐºÐ¾ Ð±Ð¸ Ñ‚Ñ€ÐµÐ±Ð°Ð¾ Ð±Ð¸Ñ‚Ð¸ Ð½ÐµÐ³Ð°Ñ‚Ð¸Ð²Ð°Ð½ Ð¸Ð·Ð½Ð¾Ñ Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(477441,13263,'vi','náº¿u ghi cÃ³, sá»‘ pháº£i ghi Ã¢m',0),(477442,13263,'af','Indien krediet bedrag moet negatief wees',0),(477443,13263,'ro','DacÄƒ valoarea creditului ar trebui sÄƒ fie negativ',0),(477444,13263,'et','Kui krediidi summa peab olema negatiivne',0),(477445,13263,'si','ÄŒe je znesek v dobro negativen',0),(477446,13263,'ba','Jika jumlah kredit harus negatif',0),(477447,13263,'nl','Als creditbedrag negatieve moet',0),(477448,13263,'fi','Jos hyvityssumma on oltava negatiivinen',0),(477449,13263,'no','Hvis kreditbelÃ¸p bÃ¸r vÃ¦re negativt',0),(477450,13263,'da','Hvis kreditbelÃ¸b skal vÃ¦re negativ',0),(477451,13263,'ko','ì‹ ìš© ê¸ˆì•¡ ì œì™¸ í•´ì•¼ í•˜ëŠ” ê²½ìš°',0),(477452,13263,'he','×× ×¡×›×•× ×”×–×™×›×•×™ ×¦×¨×™×›×” ×œ×”×™×•×ª ×©×œ×™×œ×™×ª',0),(477453,13263,'el','Î‘Î½ Ï„Î¿ Ï€Î¿ÏƒÏŒ Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î¼Î±ÏƒÏ„Îµ Î±ÏÎ½Î·Ï„Î¹ÎºÎ¿Î¯',0),(477454,13263,'zh','å¦‚æžœè´·æ–¹é‡‘é¢åº”ä¸ºè´Ÿæ•°',0),(477455,13263,'sv','Om kreditbeloppet ska vara negativa',0),(477456,13263,'it','Se l\'importo del credito dovrebbe essere negativo',0),(477457,13263,'tl','',0),(477458,13263,'th','à¸–à¹‰à¸²à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¸„à¸§à¸£à¹€à¸›à¹‡à¸™à¸„à¹ˆà¸²à¸¥à¸š',0),(477459,13263,'hi','à¤…à¤—à¤° à¤‹à¤£ à¤°à¤¾à¤¶à¤¿ à¤¨à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(477460,13263,'ms','Jika jumlah kredit harus negatif',0),(477461,13263,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ù…Ø¨Ù„Øº Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ØªÙƒÙˆÙ† Ø³Ù„Ø¨ÙŠØ©',0),(477462,13263,'fr','Si le montant du crÃ©dit devrait Ãªtre nÃ©gatif',0),(477463,13263,'jp','è²¸æ–¹é‡‘é¡ã‚’è² ã«ã™ã‚‹å¿…è¦ãŒã‚ã‚‹å ´åˆ',0),(477464,13263,'pt','Se o montante de crÃ©dito deve ser negativo',0),(477465,13263,'ru','Ð•ÑÐ»Ð¸ ÑÑƒÐ¼Ð¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð° Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼',0),(477466,13263,'es','Si Monto de CrÃ©dito Debe Ser Negativo',0),(477467,13263,'de','Wenn der Betrag negativ sein sollte',0),(477468,13263,'en','If Credit Amount Should Be Negative',0),(477469,13264,'is','',0),(477470,13264,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± Ú©Ù„',0),(477471,13264,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯ÙØªØ± Ú©Ù„',0),(477472,13264,'tr','GL hareketleri iÃ§e aktarma',0),(477473,13264,'pl','ZaimportowaÄ‡ transakcje GL',0),(477474,13264,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸Ñ‚Ðµ',0),(477475,13264,'ur','Ø¬ÛŒØ¬Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(477476,13264,'sr','Ð£Ð²Ð¾Ð· Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(477477,13264,'vi','nháº­p cÃ¡c giao dá»‹ch sá»• cÃ¡i',0),(477478,13264,'af','GL transaksies invoer',0),(477479,13264,'ro','GL tranzacÅ£ii de import',0),(477480,13264,'et','GL kannete importimine',0),(477481,13264,'si','Uvoz transakcij GL',0),(477482,13264,'ba','Impor GL transaksi',0),(477483,13264,'nl','Importeer GL transacties',0),(477484,13264,'fi','Tuo GL tapahtumat',0),(477485,13264,'no','Importere GL transaksjoner',0),(477486,13264,'da','GL-transaktioner for import',0),(477487,13264,'ko','GL íŠ¸ëžœìž­ì…˜ ê°€ì ¸ì˜¤ê¸°',0),(477488,13264,'he','×™×™×‘×•× GL ×¢×¡×§××•×ª',0),(477489,13264,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ GL',0),(477490,13264,'zh','å¯¼å…¥æ€»å¸äº¤æ˜“è®°å½•',0),(477491,13264,'sv','GL importtransaktioner',0),(477492,13264,'it','Operazioni di importazione GL',0),(477493,13264,'tl','',0),(477494,13264,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡ GL',0),(477495,13264,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚ GL à¤²à¥‡à¤¨à¤¦à¥‡à¤¨',0),(477496,13264,'ms','Urus niaga GL import',0),(477497,13264,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ GL Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(477498,13264,'fr','Transactions d\'importation GL',0),(477499,13264,'jp','GL ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(477500,13264,'pt','TransaÃ§Ãµes de GL importaÃ§Ã£o',0),(477501,13264,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ GL',0),(477502,13264,'es','Importar Transacciones de LM',0),(477503,13264,'de','Import-GL-Transaktionen',0),(477504,13264,'en','Import GL Transactions',0),(477505,13265,'is','',0),(477506,13265,'dr','Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(477507,13265,'pr','Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(477508,13265,'tr','Mevcut deÄŸil',0),(477509,13265,'pl','Nie dostÄ™pna',0),(477510,13265,'bg','ÐÐµ Ðµ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾',0),(477511,13265,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº',0),(477512,13265,'sr','ÐÐ¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾',0),(477513,13265,'vi','khÃ´ng cÃ³',0),(477514,13265,'af','Nie beskikbaar nie',0),(477515,13265,'ro','Nu este disponibil',0),(477516,13265,'et','Pole saadaval',0),(477517,13265,'si','Ni na voljo',0),(477518,13265,'ba','Tidak tersedia',0),(477519,13265,'nl','Niet beschikbaar',0),(477520,13265,'fi','Ei saatavilla',0),(477521,13265,'no','Ikke tilgjengelig',0),(477522,13265,'da','Ikke tilgÃ¦ngelig',0),(477523,13265,'ko','ì‚¬ìš©í•  ìˆ˜ ì—†ìŒ',0),(477524,13265,'he','×œ× ×–×ž×™×Ÿ',0),(477525,13265,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î·',0),(477526,13265,'zh','æ²¡æœ‰å¯ä¾›é€‰æ‹©',0),(477527,13265,'sv','Inte tillgÃ¤nglig',0),(477528,13265,'it','Non disponibile',0),(477529,13265,'tl','',0),(477530,13265,'th','à¹„à¸¡à¹ˆà¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(477531,13265,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(477532,13265,'ms','Tidak terdapat',0),(477533,13265,'ar','ØºÙŠØ± Ù…ØªÙˆÙØ±',0),(477534,13265,'fr','Non disponible',0),(477535,13265,'jp','åˆ©ç”¨ã§ãã¾ã›ã‚“ã€‚',0),(477536,13265,'pt','NÃ£o disponÃ­vel',0),(477537,13265,'ru','ÐÐµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾',0),(477538,13265,'es','No Disponible',0),(477539,13265,'de','Nicht verfÃ¼gbar',0),(477540,13265,'en','Not Available',0),(477541,13266,'is','',0),(477542,13266,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø³ØªØ§Ù†Ú©Ø§Ø± Ùˆ Ø§Ø¹ØªØ¨Ø§Ø±Ø¨Ø±Ø§Ø¨Ø± ØµÙØ± Ù†ÛŒØ³Øª',0),(477543,13266,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø³ØªØ§Ù†Ú©Ø§Ø± Ùˆ Ø§Ø¹ØªØ¨Ø§Ø±Ø¨Ø±Ø§Ø¨Ø± ØµÙØ± Ù†ÛŒØ³Øª',0),(477544,13266,'tr','BorÃ§larÄ±n & kredi toplamÄ± sÄ±fÄ±ra eÅŸit deÄŸil',0),(477545,13266,'pl','Suma obciÄ…Å¼eÅ„ & kredytÃ³w nie jest rÃ³wna Zero',0),(477546,13266,'bg','Ð¡ÑƒÐ¼Ð°Ñ‚Ð° Ð½Ð° Ð´ÐµÐ±Ð¸Ñ‚Ð¸ & ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸ Ð½Ðµ Ðµ Ñ€Ð°Ð²Ð½Ð¾ Ð½Ð° Ð½ÑƒÐ»Ð°',0),(477547,13266,'ur','ØµÙØ± Ú©ÛŒ Ø±Ù‚Ù… Ø¯ÛŒØ¨ØªØ³ & Ú©Ø±ÛŒÚˆÛŒÙ¹Ø³ Ú©Û’ Ù…Ø³Ø§ÙˆÛŒ Ù†ÛÛŒÚº',0),(477548,13266,'sr','Ð—Ð±Ð¸Ñ€ ÑÐ²Ð¸Ñ… Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð¸ Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° Ð½Ð¸Ñ˜Ðµ Ñ˜ÐµÐ´Ð½Ð°ÐºÐ¾ Ð½ÑƒÐ»Ð¸',0),(477549,13266,'vi','tá»•ng ná»£-cÃ³ khÃ´ng báº±ng 0',0),(477550,13266,'af','Som van debiete en krediete nie gelyk is aan nul',0),(477551,13266,'ro','Suma debitelor & credite nu este egal cu Zero',0),(477552,13266,'et','Deebetsumma & krediidi summa ei vÃµrdu nulliga',0),(477553,13266,'si','Vsote breme & kreditov ni enaka niÄ',0),(477554,13266,'ba','Jumlah debet & kredit tidak sama dengan nol',0),(477555,13266,'nl','Som van debet & Credits gelijk niet is aan nul',0),(477556,13266,'fi','Veloitukset & hyvitysten summa ei ole nolla',0),(477557,13266,'no','Summen av debiteringer & kreditt er ikke',0),(477558,13266,'da','Summen af debiteringer & kreditter ikke er lig nul',0),(477559,13266,'ko','ì°¨ë³€ & í•™ì ì˜ í•©ê³„ 0ë¥¼ ê°™ê²Œ í•˜ì§€ ì•ŠëŠ”ë‹¤',0),(477560,13266,'he','×¡×›×•× ×—×™×•×‘×™× & ×§×¨×“×™×˜×™× ××™× ×• ×©×•×•×” ××¤×¡',0),(477561,13266,'el','Î†Î¸ÏÎ¿Î¹ÏƒÎ¼Î± Ï„Ï‰Î½ Ï‡ÏÎµÏŽÏƒÎµÏ‰Î½ & Ï€Î¹ÏƒÏ„ÏŽÏƒÎµÎ¹Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î¯ÏƒÎ¿ Î¼Îµ Î¼Î·Î´Î­Î½',0),(477562,13266,'zh','å€Ÿæ–¹ &amp; å­¦åˆ†çš„æ€»å’Œå¹¶ä¸ç­‰äºŽé›¶',0),(477563,13266,'sv','Summan av debiteringar & krediter Ã¤r inte lika med noll',0),(477564,13266,'it','Somma dei debiti & crediti non Ã¨ uguale a Zero',0),(477565,13266,'tl','',0),(477566,13266,'th','à¸œà¸¥à¸£à¸§à¸¡à¸‚à¸­à¸‡à¹€à¸”à¸šà¸´à¸• & à¹€à¸„à¸£à¸”à¸´à¸•à¹€à¸—à¹ˆà¸²à¸à¸±à¸šà¸¨à¸¹à¸™à¸¢à¹Œ',0),(477567,13266,'hi','à¤¨à¤¾à¤®à¥‡ & à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿà¥à¤¸ à¤•à¤¾ à¤¯à¥‹à¤— à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¥‡ à¤¬à¤°à¤¾à¤¬à¤° à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(477568,13266,'ms','Jumlah debit & kredit sama dengan sifar',0),(477569,13266,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø®ØµÙˆÙ… Ø¢Ù†Ø¯ Ø£Ø±ØµØ¯Ø© Ù„Ø§ ØªØ³Ø§ÙˆÙŠ ØµÙØ±',0),(477570,13266,'fr','Somme des dÃ©bits & crÃ©dits n\'est pas Ã©gal Ã  zÃ©ro',0),(477571,13266,'jp','å€Ÿæ–¹ & ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã®åˆè¨ˆãŒã‚¼ãƒ­ã¨ç­‰ã—ããªã„ã§ã™ã€‚',0),(477572,13266,'pt','Soma dos dÃ©bitos & crÃ©ditos nÃ£o Ã© igual a Zero',0),(477573,13266,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð´ÐµÐ±ÐµÑ‚Ð¾Ð² & ÐºÑ€ÐµÐ´Ð¸Ñ‚Ñ‹ Ð½Ðµ Ñ€Ð°Ð²Ð½Ð¾ Ð½ÑƒÐ»ÑŽ',0),(477574,13266,'es','Suma de DÃ©bitos y CrÃ©ditos No Es Igual a Zero',0),(477575,13266,'de','Summe der SollbetrÃ¤ge & Credits gleich nicht 0 (null)',0),(477576,13266,'en','Sum Of Debits & Credits Does Not Equal Zero',0),(477577,13267,'is','',0),(477578,13267,'dr','Ø¢Ù¾Ù„ÙˆØ¯ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(477579,13267,'pr','Ø¢Ù¾Ù„ÙˆØ¯ Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(477580,13267,'tr','YÃ¼kleme baÅŸarÄ±lÄ±',0),(477581,13267,'pl','Wgraj sukces',0),(477582,13267,'bg','ÐšÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð°',0),(477583,13267,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(477584,13267,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð¸ ÑƒÑÐ¿ÐµÑˆÐ°Ð½',0),(477585,13267,'vi','Táº£i thÃ nh cÃ´ng',0),(477586,13267,'af','Suksesvolle oplaai',0),(477587,13267,'ro','ÃŽncÄƒrcaÅ£i-de succes',0),(477588,13267,'et','Laadida edukas',0),(477589,13267,'si','Upload uspeÅ¡en',0),(477590,13267,'ba','Upload sukses',0),(477591,13267,'nl','Succesvol uploaden',0),(477592,13267,'fi','Lataaminen onnistui',0),(477593,13267,'no','Laste opp vellykket',0),(477594,13267,'da','Upload vellykket',0),(477595,13267,'ko','ì—…ë¡œë“œ ì„±ê³µ',0),(477596,13267,'he','×œ×”×¢×œ×•×ª ×ž×•×¦×œ×—',0),(477597,13267,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÏ€Î¹Ï„Ï…Ï‡Î®Ï‚',0),(477598,13267,'zh','ä¸Šä¼ æˆåŠŸ',0),(477599,13267,'sv','Ladda upp framgÃ¥ngsrika',0),(477600,13267,'it','Caricare il successo',0),(477601,13267,'tl','',0),(477602,13267,'th','à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(477603,13267,'hi','à¤¸à¤«à¤² à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(477604,13267,'ms','Muat naik yang berjaya',0),(477605,13267,'ar','ØªØ­Ù…ÙŠÙ„ Ù†Ø§Ø¬Ø­',0),(477606,13267,'fr','TÃ©lÃ©charger rÃ©ussie',0),(477607,13267,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã®å®Œäº†',0),(477608,13267,'pt','Upload de sucesso',0),(477609,13267,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(477610,13267,'es','Carga Exitosa',0),(477611,13267,'de','Upload erfolgreich',0),(477612,13267,'en','Upload Successful',0),(477613,13268,'is','',0),(477614,13268,'dr','Ù†Ø§Ù… Ø³Ù†Ø¯ Ù‡Ø²ÛŒÙ†Ù‡',0),(477615,13268,'pr','Ù†Ø§Ù… Ø³Ù†Ø¯ Ù‡Ø²ÛŒÙ†Ù‡',0),(477616,13268,'tr','FiÅŸi adÄ±',0),(477617,13268,'pl','Nazwa bonu',0),(477618,13268,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(477619,13268,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©Û’ Ù†Ø§Ù…',0),(477620,13268,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¸Ð¼Ðµ',0),(477621,13268,'vi','TÃªn phiáº¿u',0),(477622,13268,'af','Bewys naam',0),(477623,13268,'ro','Voucher numele',0),(477624,13268,'et','Kande nimi',0),(477625,13268,'si','Voucher ime',0),(477626,13268,'ba','Nama voucher',0),(477627,13268,'nl','Waardebon naam',0),(477628,13268,'fi','Tositteen nimi',0),(477629,13268,'no','Bilag navn',0),(477630,13268,'da','Voucher navn',0),(477631,13268,'ko','ì¦ì„œ ì´ë¦„',0),(477632,13268,'he','×©×•×‘×¨ ×©×',0),(477633,13268,'el','ÎŒÎ½Î¿Î¼Î± Ï†ÏÎ»Î»Î¿Ï…',0),(477634,13268,'zh','å‡­è¯åç§°',0),(477635,13268,'sv','Verifikationen namn',0),(477636,13268,'it','Nome buono',0),(477637,13268,'tl','',0),(477638,13268,'th','à¸Šà¸·à¹ˆà¸­à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸',0),(477639,13268,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤•à¤¾ à¤¨à¤¾à¤®',0),(477640,13268,'ms','Nama baucer',0),(477641,13268,'ar','Ø§Ø³Ù… Ù‚Ø³ÙŠÙ…Ø©',0),(477642,13268,'fr','Bon nom',0),(477643,13268,'jp','åˆ¸å',0),(477644,13268,'pt','Nome de voucher',0),(477645,13268,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(477646,13268,'es','Nombre Del Voucher',0),(477647,13268,'de','Gutschein Name',0),(477648,13268,'en','Voucher Name',0),(477649,13269,'is','',0),(477650,13269,'dr','Ù¾Ø§ÛŒÛŒÙ† Ø¢ÙˆØ±Ø¯Ù† Ù‚ÛŒÙ…Øª',0),(477651,13269,'pr','Ù¾Ø§ÛŒÛŒÙ† Ø¢ÙˆØ±Ø¯Ù† Ù‚ÛŒÙ…Øª',0),(477652,13269,'tr','Etiketleme',0),(477653,13269,'pl','Markdown',0),(477654,13269,'bg','Markdown',0),(477655,13269,'ur','Ø³ÙÙˆØª',0),(477656,13269,'sr','ÐšÑšÐ¸Ñ›Ð¸Ñ†Ð°Ð¼Ð°',0),(477657,13269,'vi','giáº£m xuá»‘ng',0),(477658,13269,'af','Markdown',0),(477659,13269,'ro','Markdown',0),(477660,13269,'et','Allahindlusest aruandeperioodil tavapÃ¤rasest suurem',0),(477661,13269,'si','Markdown',0),(477662,13269,'ba','Penurunan harga',0),(477663,13269,'nl','Markdown',0),(477664,13269,'fi','Markdown',0),(477665,13269,'no','Markdown',0),(477666,13269,'da','Markdown',0),(477667,13269,'ko','Markdown',0),(477668,13269,'he','×”×•×–×œ×”',0),(477669,13269,'el','Markdown',0),(477670,13269,'zh','é™ä»·',0),(477671,13269,'sv','Markdown',0),(477672,13269,'it','Markdown',0),(477673,13269,'tl','',0),(477674,13269,'th','à¸£à¸§à¸¡à¸¢à¸­à¸”',0),(477675,13269,'hi','Markdown',0),(477676,13269,'ms','Markdown',0),(477677,13269,'ar','Ù…ØµØºØ±',0),(477678,13269,'fr','Markdown',0),(477679,13269,'jp','å€¤ä¸‹ã’',0),(477680,13269,'pt','Markdown',0),(477681,13269,'ru','Markdown',0),(477682,13269,'es','Rebaja',0),(477683,13269,'de','Markdown',0),(477684,13269,'en','Markdown',0),(477685,13270,'is','',0),(477686,13270,'dr','Ù¾Ø§ÛŒÛŒÙ† Ø¢ÙˆØ±Ø¯Ù† Ù‚ÛŒÙ…Øª Ø¨Ø± Ø§Ø³Ø§Ø³',0),(477687,13270,'pr','Ù¾Ø§ÛŒÛŒÙ† Ø¢ÙˆØ±Ø¯Ù† Ù‚ÛŒÙ…Øª Ø¨Ø± Ø§Ø³Ø§Ø³',0),(477688,13270,'tr','GÃ¶re etiketleme',0),(477689,13270,'pl','Promocji cenowych na podstawie',0),(477690,13270,'bg','Markdown, Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð°',0),(477691,13270,'ur','Ø³ÙÙˆØª Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø±',0),(477692,13270,'sr','ÐšÑšÐ¸Ñ›Ð¸Ñ†Ð°Ð¼Ð° Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ',0),(477693,13270,'vi','giáº£m xuá»‘ng dá»±a trÃªn',0),(477694,13270,'af','Markdown gebaseer op',0),(477695,13270,'ro','Markdown bazate pe',0),(477696,13270,'et','Allahindlusest aruandeperioodil tavapÃ¤rasest suurem pÃµhineb',0),(477697,13270,'si','Markdown, ki temelji na',0),(477698,13270,'ba','Penurunan harga berdasarkan',0),(477699,13270,'nl','Markdown gebaseerd op',0),(477700,13270,'fi','Markdown perustuu',0),(477701,13270,'no','Markdown basert pÃ¥',0),(477702,13270,'da','Markdown baseret pÃ¥',0),(477703,13270,'ko','Markdownì„ ê¸°ë°˜',0),(477704,13270,'he','×”×•×–×œ×” ×¢×œ ×‘×¡×™×¡',0),(477705,13270,'el','Markdown Î¼Îµ Î²Î¬ÏƒÎ·',0),(477706,13270,'zh','é™ä»·çš„åŸºç¡€',0),(477707,13270,'sv','Markdown baserat pÃ¥',0),(477708,13270,'it','Sulla base di Markdown',0),(477709,13270,'tl','',0),(477710,13270,'th','à¸£à¸§à¸¡à¸¢à¸­à¸”à¸•à¸²à¸¡',0),(477711,13270,'hi','à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤° markdown',0),(477712,13270,'ms','Markdown berdasarkan',0),(477713,13270,'ar','Ù…ØµØºØ± Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³',0),(477714,13270,'fr','Markdown basÃ© sur',0),(477715,13270,'jp','è¨˜æ³•ã«åŸºã¥ã',0),(477716,13270,'pt','Markdown baseado em',0),(477717,13270,'ru','Markdown, Ð¾ÑÐ½Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹ Ð½Ð°',0),(477718,13270,'es','Rebaja Basada En',0),(477719,13270,'de','Auf der Grundlage von markdown',0),(477720,13270,'en','Markdown Based On',0),(477721,13271,'is','',0),(477722,13271,'dr','Ø¯Ø±ØµØ¯ Ù¾Ø§ÛŒÛŒÙ† Ø¢ÙˆØ±Ø¯Ù† Ù‚ÛŒÙ…Øª',0),(477723,13271,'pr','Ø¯Ø±ØµØ¯ Ù¾Ø§ÛŒÛŒÙ† Ø¢ÙˆØ±Ø¯Ù† Ù‚ÛŒÙ…Øª',0),(477724,13271,'tr','Etiketleme yÃ¼zde',0),(477725,13271,'pl','Markdown procent',0),(477726,13271,'bg','Markdown Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(477727,13271,'ur','Ø³ÙÙˆØª ÙÛŒØµØ¯',0),(477728,13271,'sr','ÐšÑšÐ¸Ñ›Ð¸Ñ†Ð°Ð¼Ð° %',0),(477729,13271,'vi','pháº§n trÄƒm giáº£m xuá»‘ng',0),(477730,13271,'af','Markdown persent',0),(477731,13271,'ro','Markdown la sutÄƒ',0),(477732,13271,'et','Allahindlusest aruandeperioodil tavapÃ¤rasest suurem protsent',0),(477733,13271,'si','Markdown odstotkov',0),(477734,13271,'ba','Persen penurunan harga',0),(477735,13271,'nl','Markdown procent',0),(477736,13271,'fi','Markdown prosenttia',0),(477737,13271,'no','Markdown prosent',0),(477738,13271,'da','Markdown procent',0),(477739,13271,'ko','Markdown %',0),(477740,13271,'he','% ×”×•×–×œ×”',0),(477741,13271,'el','Markdown Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(477742,13271,'zh','é™ä»· %',0),(477743,13271,'sv','Markdown procent',0),(477744,13271,'it','Per cento Markdown',0),(477745,13271,'tl','',0),(477746,13271,'th','à¸£à¸§à¸¡à¸¢à¸­à¸”à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œ',0),(477747,13271,'hi','Markdown à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(477748,13271,'ms','Markdown peratus',0),(477749,13271,'ar','Ù…ØµØºØ± ÙÙŠ Ø§Ù„Ù…Ø§Ø¦Ø©',0),(477750,13271,'fr','Markdown pour cent',0),(477751,13271,'jp','Markdown %',0),(477752,13271,'pt','Por cento de desconto',0),(477753,13271,'ru','Markdown %',0),(477754,13271,'es','Rebaja Porcentaje',0),(477755,13271,'de','Markdown Prozent',0),(477756,13271,'en','Markdown Percent',0),(477757,13272,'is','',0),(477758,13272,'dr','Ù‡ÛŒÚ† Ø³Ø·Ø­ Ù‚ÛŒÙ…ØªÛŒ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(477759,13272,'pr','Ù‡ÛŒÚ† Ø³Ø·Ø­ Ù‚ÛŒÙ…ØªÛŒ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(477760,13272,'tr','HiÃ§bir fiyat seviyeleri mevcut',0),(477761,13272,'pl','Nie dostÄ™pne poziomy cen',0),(477762,13272,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ñ€Ð°Ð²Ð½Ð¸Ñ‰Ð°',0),(477763,13272,'ur','Ú©ÙˆØ¦ÛŒ Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ÙˆÚº Ú©Û’ Ø¯Ø³ØªÛŒØ§Ø¨',0),(477764,13272,'sr','ÐÐ¸Ð²Ð¾Ð¸Ð¼Ð° Ñ†ÐµÐ½Ð° Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð°',0),(477765,13272,'vi','khÃ´ng cÃ³ sáºµn cÃ¡c má»©c giÃ¡',0),(477766,13272,'af','Geen prys vlakke beskikbaar',0),(477767,13272,'ro','Nu nivelurile de preÅ£ disponibil',0),(477768,13272,'et','Hind tasemeid pole',0),(477769,13272,'si','Ne ravni cen, ki je na voljo',0),(477770,13272,'ba','Tingkat harga tidak tersedia',0),(477771,13272,'nl','Geen prijs niveaus beschikbaar',0),(477772,13272,'fi','Hintataso ei ole saatavilla',0),(477773,13272,'no','Ingen prisnivÃ¥ tilgjengelig',0),(477774,13272,'da','Ingen tilgÃ¦ngelige prisniveauer',0),(477775,13272,'ko','ì‚¬ìš©í•  ìˆ˜ ì—†ëŠ” ê°€ê²© ìˆ˜ì¤€',0),(477776,13272,'he','×¨×ž×•×ª ×ž×—×™×¨ ×œ× ×–×ž×™×Ÿ',0),(477777,13272,'el','Î”ÎµÎ½ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± ÎµÏ€Î¯Ï€ÎµÎ´Î± Ï„Î¹Î¼ÏŽÎ½',0),(477778,13272,'zh','æ²¡æœ‰å¯ç”¨çš„ä»·æ ¼æ°´å¹³',0),(477779,13272,'sv','Inget pris nivÃ¥er tillgÃ¤ngliga',0),(477780,13272,'it','No livelli di prezzo disponibili',0),(477781,13272,'tl','',0),(477782,13272,'th','à¸£à¸°à¸”à¸±à¸šà¸£à¸²à¸„à¸²à¹„à¸¡à¹ˆà¸§à¹ˆà¸²à¸‡',0),(477783,13272,'hi','à¤•à¥‹à¤ˆ à¤•à¥€à¤®à¤¤ à¤¸à¥à¤¤à¤° à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(477784,13272,'ms','Paras harga tidak disediakan',0),(477785,13272,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(477786,13272,'fr','Aucun niveau de prix disponible',0),(477787,13272,'jp','ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«ãŒãªã—',0),(477788,13272,'pt','NÃ£o hÃ¡ nÃ­veis de preÃ§o disponÃ­veis',0),(477789,13272,'ru','ÐÐµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ ÑƒÑ€Ð¾Ð²Ð½Ð¸ Ñ†ÐµÐ½',0),(477790,13272,'es','No Niveles de Precios Disponibles',0),(477791,13272,'de','Keine Preis-Level verfÃ¼gbar',0),(477792,13272,'en','No Price Levels Available',0),(477793,13273,'is','',0),(477794,13273,'dr','Ú©Ù¾ÛŒ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ',0),(477795,13273,'pr','Ú©Ù¾ÛŒ Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ',0),(477796,13273,'tr','AlÄ±ntÄ± clone',0),(477797,13273,'pl','Klon cytat',0),(477798,13273,'bg','ÐšÐ»Ð¾Ð½Ð¸Ð½Ð³ Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(477799,13273,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù¾ÛŒÙˆÙ†Ø¯ Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(477800,13273,'sr','ÐšÐ»Ð¾Ð½Ð¸Ñ€Ð°Ñ‚Ð¸ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(477801,13273,'vi','TrÃ­ch dáº«n Clone',0),(477802,13273,'af','Kloon aanhaling',0),(477803,13273,'ro','Clona citat',0),(477804,13273,'et','Kloonide Quote',0),(477805,13273,'si','Klon citat',0),(477806,13273,'ba','Klon kutipan',0),(477807,13273,'nl','Kloon offerte',0),(477808,13273,'fi','Klooni lainaus',0),(477809,13273,'no','Klone tilbud',0),(477810,13273,'da','Klon citat',0),(477811,13273,'ko','ê²¬ì ì„ ë³µì œ',0),(477812,13273,'he','×©×™×‘×•×˜ ×”×¦×¢×ª ×ž×—×™×¨',0),(477813,13273,'el','ÎšÎ»ÏŽÎ½Î¿Ï‚ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(477814,13273,'zh','å…‹éš†æŠ¥ä»·',0),(477815,13273,'sv','Klona citat',0),(477816,13273,'it','Clonare la citazione',0),(477817,13273,'tl','',0),(477818,13273,'th','à¹‚à¸„à¸¥à¸™à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(477819,13273,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤•à¥à¤²à¥‹à¤¨',0),(477820,13273,'ms','Klon Quote',0),(477821,13273,'ar','Ø§Ø³ØªÙ†Ø³Ø§Ø® Ø§Ù‚ØªØ¨Ø§Ø³',0),(477822,13273,'fr','Citation de clone',0),(477823,13273,'jp','å¼•ç”¨ã®ã‚¯ãƒ­ãƒ¼ãƒ³ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(477824,13273,'pt','CitaÃ§Ã£o de clone',0),(477825,13273,'ru','ÐšÐ»Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(477826,13273,'es','CotizaciÃ³n de Clon',0),(477827,13273,'de','Zitat zu klonen',0),(477828,13273,'en','Clone Quote',0),(477829,13274,'is','',0),(477830,13274,'dr','Ø­Ø¯Ø§Ú©Ø«Ø± Ø­Ø§Ø´ÛŒÙ‡ ÙØ±ÙˆØ´ Ù…Ø¬Ø§Ø²',0),(477831,13274,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± Ø­Ø§Ø´ÛŒÙ‡ ÙØ±ÙˆØ´ Ù…Ø¬Ø§Ø²',0),(477832,13274,'tr','Ä°zin verilen en fazla satÄ±ÅŸ marjÄ±',0),(477833,13274,'pl','Maksymalna margines sprzedaÅ¼y dozwolone',0),(477834,13274,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð¼Ð°Ñ€Ð¶ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(477835,13274,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ÙØ±ÙˆØ®Øª Ø­Ø§Ø´ÛŒÛ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(477836,13274,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¼Ð°Ñ€Ð³Ð¸Ð½Ñƒ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ðµ',0),(477837,13274,'vi','Lá»£i nhuáº­n bÃ¡n hÃ ng tá»‘i Ä‘a cho phÃ©p',0),(477838,13274,'af','Maksimum verkope marge toegelaat',0),(477839,13274,'ro','MarjÄƒ de vÃ¢nzÄƒri maxim permis',0),(477840,13274,'et','Lubatud suurim mÃ¼Ã¼gi marginaal',0),(477841,13274,'si','NajveÄje prodajne marÅ¾e, dovoljeno',0),(477842,13274,'ba','Margin penjualan maksimum yang diperbolehkan',0),(477843,13274,'nl','Maximale verkoop marge toegestaan',0),(477844,13274,'fi','Myynnin maksimi sallittu',0),(477845,13274,'no','Maksimal salg Margin tillatt',0),(477846,13274,'da','Maksimal salg Margin tilladt',0),(477847,13274,'ko','í—ˆìš© ìµœëŒ€ íŒë§¤ ë§ˆì§„',0),(477848,13274,'he','×”×©×•×œ×™×™× ×”×ž×›×™×¨×•×ª ×”×ž×¨×‘×™ ×”×ž×•×ª×¨',0),(477849,13274,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î¿ Ï€ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€Î¿Ï… ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(477850,13274,'zh','å…è®¸çš„æœ€å¤§é”€å”®æ¯›åˆ©çŽ‡',0),(477851,13274,'sv','Maximal fÃ¶rsÃ¤ljningsmarginal tillÃ¥tet',0),(477852,13274,'it','Margine vendite massimo consentito',0),(477853,13274,'tl','',0),(477854,13274,'th','à¸‚à¸²à¸¢à¸à¸³à¹„à¸£à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¸—à¸µà¹ˆà¸­à¸™à¸¸à¸à¸²à¸•',0),(477855,13274,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¬à¤¿à¤•à¥à¤°à¥€ à¤®à¤¾à¤°à¥à¤œà¤¿à¤¨ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(477856,13274,'ms','Margin jualan maksimum yang dibenarkan',0),(477857,13274,'ar','Ù‡Ø§Ù…Ø´ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(477858,13274,'fr','Marge de vente maximum autorisÃ©',0),(477859,13274,'jp','è¨±å¯ã•ã‚Œã‚‹æœ€å¤§ã®è²©å£²ãƒžãƒ¼ã‚¸ãƒ³',0),(477860,13274,'pt','Margem de vendas mÃ¡xima permitida',0),(477861,13274,'ru','ÐœÐ°ÐºÑÐ¸Ð¼ÑƒÐ¼ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¿Ð¾Ð»Ðµ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(477862,13274,'es','Margen de Ventas Maximas Permitidos',0),(477863,13274,'de','Maximale Umsatz Margin erlaubt',0),(477864,13274,'en','Maximum Sales Margin Allowed',0),(477865,13275,'is','',0),(477866,13275,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ø­Ø§Ø´ÛŒÙ‡ ÙØ±ÙˆØ´ Ù…Ø¬Ø§Ø²',0),(477867,13275,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ø­Ø§Ø´ÛŒÙ‡ ÙØ±ÙˆØ´ Ù…Ø¬Ø§Ø²',0),(477868,13275,'tr','Ä°zin verilen minimum satÄ±ÅŸ marjÄ±',0),(477869,13275,'pl','Minimalna marÅ¼a sprzedaÅ¼y dozwolone',0),(477870,13275,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð¸ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¼Ð°Ñ€Ð¶ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(477871,13275,'ur','Ú©Ù… Ø§Ø² Ú©Ù… ÙØ±ÙˆØ®Øª Ø­Ø§Ø´ÛŒÛ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(477872,13275,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¼Ð°Ñ€Ð³Ð¸Ð½Ñƒ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ðµ',0),(477873,13275,'vi','Lá»£i nhuáº­n bÃ¡n hÃ ng tá»‘i thiá»ƒu cho phÃ©p',0),(477874,13275,'af','Minimum verkope marge toegelaat',0),(477875,13275,'ro','Marja de vÃ¢nzare minim permis',0),(477876,13275,'et','Minimaalne lubatud mÃ¼Ã¼gi marginaal',0),(477877,13275,'si','Prodaje minimalnega dovoljeno',0),(477878,13275,'ba','Minimal penjualan Margin diperbolehkan',0),(477879,13275,'nl','Verkoop minimummarge toegestaan',0),(477880,13275,'fi','Pienin sallittu myyntikate',0),(477881,13275,'no','Minste salg margen tillatt',0),(477882,13275,'da','Minimum salg Margin tilladt',0),(477883,13275,'ko','í—ˆìš© ë˜ëŠ” ìµœì†Œ íŒë§¤ ë§ˆì§„',0),(477884,13275,'he','×”×‘×˜×—×•× ×•×ª ×ž×›×™×¨×•×ª ×ž×•×ª×¨',0),(477885,13275,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î¿ Ï€ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€Î¿Ï… ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(477886,13275,'zh','å…è®¸çš„æœ€ä½Žé”€å”®æ¯›åˆ©çŽ‡',0),(477887,13275,'sv','Minsta marginal fÃ¥r',0),(477888,13275,'it','Margine vendite minimo consentito',0),(477889,13275,'tl','',0),(477890,13275,'th','à¸£à¸°à¸¢à¸°à¸‚à¸­à¸šà¸‚à¸±à¹‰à¸™à¸•à¹ˆà¸³à¸—à¸µà¹ˆà¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¸‚à¸²à¸¢',0),(477891,13275,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤¬à¤¿à¤•à¥à¤°à¥€ à¤®à¤¾à¤°à¥à¤œà¤¿à¤¨ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(477892,13275,'ms','Minima Margin jualan yang dibenarkan',0),(477893,13275,'ar','Ù‡Ø§Ù…Ø´ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(477894,13275,'fr','Marge de vente minimale autorisÃ©e',0),(477895,13275,'jp','è¨±å¯ã•ã‚Œã‚‹æœ€å°è²©å£²ãƒžãƒ¼ã‚¸ãƒ³',0),(477896,13275,'pt','Margem de vendas mÃ­nima permitida',0),(477897,13275,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¼Ð°Ñ€Ð¶Ð° Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(477898,13275,'es','Margin de Ventas MÃ­nimas Permitidas',0),(477899,13275,'de','Minimalen Umsatz Rand erlaubt',0),(477900,13275,'en','Minimum Sales Margin Allowed',0),(477901,13276,'is','',0),(477902,13276,'dr','...',0),(477903,13276,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶  Ù†Ù‡ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù…Ø¬Ø§Ø² Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ...',0),(477904,13276,'tr','Not izin yok kredi varsayÄ±lan',0),(477905,13276,'pl','DomyÅ›lnie nie kredytowej dozwolone Uwaga',0),(477906,13276,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð½ÑÐ¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾ Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(477907,13276,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ù†ÙˆÙ¹ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø³Û’ Ø·Û’ Ø´Ø¯Û',0),(477908,13276,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½ÐµÐ¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð° Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(477909,13276,'vi','Máº·c Ä‘á»‹nh khÃ´ng cho phÃ©p ghi CÃ³',0),(477910,13276,'af','Verstek geen krediet Nota toegelaat',0),(477911,13276,'ro','Implicit nu permis notÄƒ de Credit',0),(477912,13276,'et','Vaikimisi ei ole lubatud mÃ¤rkus krediiti',0),(477913,13276,'si','Privzeto ni odbitek Opomba',0),(477914,13276,'ba','Default tidak ada kredit yang diperbolehkan catatan',0),(477915,13276,'nl','Standaard geen krediet toegestaan Opmerking',0),(477916,13276,'fi','Oletus ei hyvitys Huomautus',0),(477917,13276,'no','Standard ingen kreditt tillatt Merk',0),(477918,13276,'da','Standard ingen kredit tilladt BemÃ¦rk',0),(477919,13276,'ko','ì°¸ê³  í—ˆìš© ì‹ ìš©ì„ ê¸°ë³¸',0),(477920,13276,'he','×‘×¨×™×¨×ª ×ž×—×“×œ ×œ× ××©×¨××™ ×ž×•×ª×¨ ×”×¢×¨×”',0),(477921,13276,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® ÎºÎ±Î¼Î¯Î± Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ· ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(477922,13276,'zh','é»˜è®¤å…è®¸æ³¨æ„æ²¡æœ‰ä¿¡ç”¨',0),(477923,13276,'sv','Standard ingen kredit fÃ¥r anmÃ¤rkning',0),(477924,13276,'it','Non predefinito consentito la nota di credito',0),(477925,13276,'tl','',0),(477926,13276,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸',0),(477927,13276,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¨à¥‹à¤Ÿ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(477928,13276,'ms','Lalai tiada kredit yang dibenarkan Nota',0),(477929,13276,'ar','Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù„Ø§ ÙŠØ³Ù…Ø­ Ø¹Ù„Ù…Ø§',0),(477930,13276,'fr','Par dÃ©faut aucun crÃ©dit accordÃ© la Note',0),(477931,13276,'jp','æ³¨è¨±å¯ã•ã‚Œã¦ä¿¡ç”¨ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆãªã—',0),(477932,13276,'pt','PadrÃ£o sem crÃ©dito permitido nota',0),(477933,13276,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð½Ð¸ÐºÐ°ÐºÐ¾Ð¹ ÐºÑ€ÐµÐ´Ð¸Ñ‚, Ð”Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(477934,13276,'es','Nota de No CrÃ©dito Permitido Por Defecto',0),(477935,13276,'de','Standard keinen Kredit erlaubt Hinweis',0),(477936,13276,'en','Default No Credit Allowed Note',0),(477937,13277,'is','',0),(477938,13277,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¬Ø¯ÛŒØ¯ Ø§Ø¹ØªØ¨Ø§Ø± Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(477939,13277,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¬Ø¯ÛŒØ¯ Ø§Ø¹ØªØ¨Ø§Ø± Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(477940,13277,'tr','Yeni mÃ¼ÅŸteriler varsayÄ±lan izin verilen kredi iÃ§in',0),(477941,13277,'pl','Nowych klientÃ³w domyÅ›lnie na koncie, nie wolno',0),(477942,13277,'bg','Ð”Ð° Ð½Ðµ ÑÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð¾Ð²Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(477943,13277,'ur','Ù†Ø¦Û’ ØµØ§Ø±ÙÛŒÙ† Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ú©ÙˆØ¦ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û',0),(477944,13277,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ ÐºÑƒÐ¿Ñ†Ðµ Ð´Ð° Ð½ÐµÐ¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð° Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(477945,13277,'vi','khÃ¡ch hÃ ng má»›i máº·c Ä‘á»‹nh khÃ´ng Ä‘Æ°á»£c phÃ©p ghi cÃ³',0),(477946,13277,'af','Nuwe kliÃ«nte verstek tot geen krediet toegelaat',0),(477947,13277,'ro','ClienÅ£ii noi implicit la nici un Credit permis',0),(477948,13277,'et','Uute klientide vaikimisi ei ole lubatud krediiti',0),(477949,13277,'si','Nove stranke privzeto ni odbitek',0),(477950,13277,'ba','Pelanggan Baru Default ke tidak ada kredit yang diperbolehkan',0),(477951,13277,'nl','Nieuwe klanten standaard geen krediet toegestaan',0),(477952,13277,'fi','Uusia asiakkaita oletusarvoisesti ei hyvitys',0),(477953,13277,'no','Nye kunder som standard ingen kreditt tillatt',0),(477954,13277,'da','Nye kunder som standard ingen kredit tilladt',0),(477955,13277,'ko','ìƒˆë¡œìš´ ê³ ê° í—ˆìš© ì‹ ìš©ì„ ê¸°ë³¸',0),(477956,13277,'he','×œ×§×•×—×•×ª ×—×“×©×™× ×›×‘×¨×™×¨×ª ×ž×—×“×œ ×œ× ××©×¨××™ ×ž×•×ª×¨',0),(477957,13277,'el','ÎÎ­Î± Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î½Î± Ï„Î¹Î¼Î¬ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(477958,13277,'zh','æ–°å®¢æˆ·é»˜è®¤ä¸ºå…è®¸æ²¡æœ‰ä¿¡ç”¨',0),(477959,13277,'sv','Nya kunder som standard ingen kredit tillÃ¥tet',0),(477960,13277,'it','Nuovi clienti per impostazione predefinita non consentito di credito',0),(477961,13277,'tl','',0),(477962,13277,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸«à¸¡à¹ˆà¹€à¸£à¸´à¹ˆà¸¡à¹ƒà¸«à¹‰à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(477963,13277,'hi','à¤¨à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(477964,13277,'ms','Lalai pelanggan baru untuk tiada kredit yang dibenarkan',0),(477965,13277,'ar','Ø¹Ù…Ù„Ø§Ø¡ Ø¬Ø¯Ø¯ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù„Ø§ ÙŠØ³Ù…Ø­',0),(477966,13277,'fr','Nouveaux clients par dÃ©faut Ã  aucun crÃ©dit autorisÃ©',0),(477967,13277,'jp','æ–°ã—ã„é¡§å®¢ã¯ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã‚’è¨±å¯ã™ã‚‹æ—¢å®šã—ã¾ã™ã€‚',0),(477968,13277,'pt','Novos clientes sem crÃ©dito permitido como padrÃ£o',0),(477969,13277,'ru','ÐÐ¾Ð²Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð½Ðµ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(477970,13277,'es','Nuevos Clientes Son Predeterminados a No CrÃ©dito Permitido',0),(477971,13277,'de','Neukunden standardmÃ¤ÃŸig keinen Kredit erlaubt',0),(477972,13277,'en','New Customers Default To No Credit Allowed',0),(477973,13278,'is','',0),(477974,13278,'dr','Ù†Ú¯Ø§Ù‡ Ú©Ù†ÛŒØ¯ Ø¯Ø± Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(477975,13278,'pr','Ù†Ú¯Ø§Ù‡ Ú©Ù†ÛŒØ¯ Ø¯Ø± Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(477976,13278,'tr','KullanÄ±labilir miktar bak',0),(477977,13278,'pl','SpojrzeÄ‡ na iloÅ›Ä‡ dostÄ™pnych',0),(477978,13278,'bg','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð½ÐµÑ‚Ðµ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(477979,13278,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø± Ù†Ø¸Ø±',0),(477980,13278,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð°',0),(477981,13278,'vi','tÃ¬m sá»‘ lÆ°á»£ng sáºµn cÃ³',0),(477982,13278,'af','Kyk na die hoeveelheid beskikbaar',0),(477983,13278,'ro','Uita-te la cantitatea disponibilÄƒ',0),(477984,13278,'et','Pilk saadaolev kogus',0),(477985,13278,'si','Pogled na razpoloÅ¾ljivo koliÄino',0),(477986,13278,'ba','Lihatlah kuantitas yang tersedia',0),(477987,13278,'nl','Kijken naar beschikbare hoeveelheid',0),(477988,13278,'fi','Tarkastella kÃ¤ytettÃ¤vissÃ¤ olevaa mÃ¤Ã¤rÃ¤Ã¤',0),(477989,13278,'no','Se pÃ¥ tilgjengelige',0),(477990,13278,'da','Kig pÃ¥ disponible mÃ¦ngde',0),(477991,13278,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” ìˆ˜ëŸ‰ì„ ë³´ë©´',0),(477992,13278,'he','×ª×¡×ª×›×œ ×¢×œ ×›×ž×•×ª ×–×ž×™× ×”',0),(477993,13278,'el','Î•Î¾ÎµÏ„Î¬ÏƒÎ¿Ï…Î¼Îµ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(477994,13278,'zh','çœ‹çœ‹å¯ä¾›æ•°é‡',0),(477995,13278,'sv','Titta pÃ¥ tillgÃ¤ngliga kvantiteten',0),(477996,13278,'it','Guardate la quantitÃ  disponibile',0),(477997,13278,'tl','',0),(477998,13278,'th','à¸”à¸¹à¸—à¸µà¹ˆà¸›à¸£à¸´à¸¡à¸²à¸“',0),(477999,13278,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤®à¥‡à¤‚ à¤¦à¥‡à¤–à¥‹',0),(478000,13278,'ms','Lihat pada kuantiti yang disediakan',0),(478001,13278,'ar','Ø§Ù†Ø¸Ø±ÙˆØ§ Ø¥Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(478002,13278,'fr','Regardez la quantitÃ© disponible',0),(478003,13278,'jp','ä½¿ç”¨å¯èƒ½ãªæ•°é‡ã‚’è¦‹ã¦ãã ã•ã„ã€‚',0),(478004,13278,'pt','Olha a quantidade disponÃ­vel',0),(478005,13278,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€Ð¸Ñ‚Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ñ…',0),(478006,13278,'es','Ve a la Cantidad Disponible',0),(478007,13278,'de','Sehen Sie sich die verfÃ¼gbare Menge',0),(478008,13278,'en','Look At Quantity Available',0),(478009,13279,'is','',0),(478010,13279,'dr','Ù†Ú¯Ø§Ù‡ Ú©Ù†ÛŒØ¯ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø±Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(478011,13279,'pr','Ù†Ú¯Ø§Ù‡ Ú©Ù†ÛŒØ¯ Ø¨Ù‡ Ù…Ù‚Ø¯Ø§Ø±Ø¯Ø± Ø¯Ø³Øª Ø§Ù‚Ø¯Ø§Ù…',0),(478012,13279,'tr','Miktar bir yandan bak',0),(478013,13279,'pl','SpojrzeÄ‡ na iloÅ›Ä‡ na strony',0),(478014,13279,'bg','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð½ÐµÑ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ñ€ÑŠÐºÐ°',0),(478015,13279,'ur','Ø¬Ø§Ù†Ø¨ ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø± ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(478016,13279,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(478017,13279,'vi','tÃ¬m sá»‘ lÆ°á»£ng Ä‘ang cÃ³',0),(478018,13279,'af','Kyk na die hoeveelheid aan die Hand',0),(478019,13279,'ro','Uita-te la cantitatea pe parte',0),(478020,13279,'et','Pilk kogus kÃ¤si',0),(478021,13279,'si','Pogled na koliÄino na strani',0),(478022,13279,'ba','Lihatlah kuantitas di tangan',0),(478023,13279,'nl','Hoeveelheid aan kant kijken',0),(478024,13279,'fi','Katsokaa mÃ¤Ã¤rÃ¤ kÃ¤sillÃ¤',0),(478025,13279,'no','Se pÃ¥ antall pÃ¥ side',0),(478026,13279,'da','Kig pÃ¥ mÃ¦ngde pÃ¥ side',0),(478027,13279,'ko','ì–‘ ì†ì—ì„œ ë´',0),(478028,13279,'he','×ª×¨××” ××ª ×”×›×ž×•×ª ×¢×œ ×™×“',0),(478029,13279,'el','ÎšÎ¿Î¹Ï„Î¬Î¾Ï„Îµ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Ï†',0),(478030,13279,'zh','ä¸€æ–¹é¢çœ‹çœ‹æ•°é‡',0),(478031,13279,'sv','Titta pÃ¥ kvantitet Ã¥',0),(478032,13279,'it','Guardate la quantitÃ  d\' parte',0),(478033,13279,'tl','',0),(478034,13279,'th','à¸”à¸¹à¸›à¸£à¸´à¸¡à¸²à¸“à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸„à¸‡à¹€à¸«à¸¥à¸·à¸­',0),(478035,13279,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤¹à¤¾à¤¥ à¤ªà¤° à¤¦à¥‡à¤–à¥‹',0),(478036,13279,'ms','Lihatlah kuantiti di tangan',0),(478037,13279,'ar','Ø§Ù†Ø¸Ø±ÙˆØ§ Ø¥Ù„Ù‰ ÙƒÙ…ÙŠØ© Ù…Ù† Ù†Ø§Ø­ÙŠØ©',0),(478038,13279,'fr','Regardez quantitÃ© sur place',0),(478039,13279,'jp','ä¸€æ–¹ã§æ•°é‡ã‚’è¦‹ã¦ãã ã•ã„ã€‚',0),(478040,13279,'pt','Olha a quantidade por lado',0),(478041,13279,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€Ð¸Ñ‚Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(478042,13279,'es','Ve a la Cantidad a Mano',0),(478043,13279,'de','Sehen Sie sich die Menge auf Seite',0),(478044,13279,'en','Look At Quantity On Hand',0),(478045,13280,'is','',0),(478046,13280,'dr','(Ú¯Ø¯Ø§Ù…ÛŒ',0),(478047,13280,'pr','Ø²Ù…Ø§Ù†ÛŒ Ú©Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø³Ø¯ÙˆØ¯ Ø§Ø³Øª Ø¨Ø±Ø§ÛŒ Ù‡ÛŒÚ† Ø³Ù‡Ø§Ù…ÛŒ(Ø§Ù†Ø¨Ø§Ø±ÛŒ',0),(478048,13280,'tr','Ne zaman Stok sipariÅŸlerini engelleme',0),(478049,13280,'pl','Kiedy blokowanie zamÃ³wienia bez rÄ™ki',0),(478050,13280,'bg','ÐŸÑ€Ð¸ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð½Ð¸ÐºÐ¾Ñ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚',0),(478051,13280,'ur','Ø¬Ø¨ Ú©ÙˆØ¦ÛŒ Ø§Ø³Ù¹Ø§Ú© Ú©Û’ Ù„Ø¦Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ø¨Ù„Ø§Ú© Ú©Ø± Ø±ÛÛŒ',0),(478052,13280,'sr','ÐšÐ°Ð´Ð° ÑÐµ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° Ð½ÐµÐ¼Ð° Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(478053,13280,'vi','Khi cháº·n Ä‘Æ¡n hÃ ng Ä‘á»‘i vá»›i loáº¡i khÃ´ng cÃ³ chá»©ng khoÃ¡n',0),(478054,13280,'af','Wanneer bestellings vir geen voorraad blokkeer',0),(478055,13280,'ro','Atunci cÃ¢nd blocarea comenzi pentru nici un stoc',0),(478056,13280,'et','Kui blokeerimine tellimuste laoseis',0),(478057,13280,'si','Ko blokirate naroÄila za ne zaloge',0),(478058,13280,'ba','Saat memblokir pesanan untuk ada stok',0),(478059,13280,'nl','Tijdens het blokkeren van Orders voor geen voorraad',0),(478060,13280,'fi','Kun haluat estÃ¤Ã¤ tilauksia ei ole varastossa',0),(478061,13280,'no','NÃ¥r blokkerer ordrer For ingen lager',0),(478062,13280,'da','NÃ¥r blokering ordrer For nogen bestand',0),(478063,13280,'ko','ìž¬ê³  ì—†ìŒì— ëŒ€ í•œ ì£¼ë¬¸ ì°¨ë‹¨',0),(478064,13280,'he','×‘×¢×ª ×—×¡×™×ž×ª ×”×–×ž× ×•×ª ×¢×‘×•×¨ ×©×•× ×”×™×’×™×•×Ÿ',0),(478065,13280,'el','ÎŒÏ„Î±Î½ Ï„Î¿ ÎºÎ»ÎµÎ¯Î´Ï‰Î¼Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î³Î¹Î± Ï„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î´ÎµÎ½',0),(478066,13280,'zh','é˜»æ­¢æ²¡æœ‰è‚¡ç¥¨çš„è®¢å•æ—¶',0),(478067,13280,'sv','NÃ¤r blockering order fÃ¶r inga lager',0),(478068,13280,'it','Quando ordini per nessuna azione di blocco',0),(478069,13280,'tl','',0),(478070,13280,'th','à¹€à¸¡à¸·à¹ˆà¸­à¸šà¸¥à¹‡à¸­à¸à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸«à¸¸à¹‰à¸™',0),(478071,13280,'hi','à¤œà¤¬ à¤•à¥‹à¤ˆ à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤¬à¥à¤²à¥‰à¤•à¤¿à¤‚à¤—',0),(478072,13280,'ms','Semasa menyekat arahan tiada stok',0),(478073,13280,'ar','Ø¹Ù†Ø¯ Ø­Ø¸Ø± Ø£ÙˆØ§Ù…Ø± Ù„Ù„Ø§ Ù…Ø®Ø²ÙˆÙ†',0),(478074,13280,'fr','Lors du blocage des commandes pour aucun Stock',0),(478075,13280,'jp','ãƒ–ãƒ­ãƒƒã‚¯ã—ã¦ã„ã‚‹å—æ³¨åœ¨åº«ãŒãªã„å ´åˆ',0),(478076,13280,'pt','Quando o bloqueio de ordens para nenhum estoque',0),(478077,13280,'ru','ÐŸÑ€Ð¸ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ð¸ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð½Ð° Ð½ÐµÑ‚ Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(478078,13280,'es','Cuando Bloquean Ordenes Por No Stock',0),(478079,13280,'de','Wenn AuftrÃ¤ge fÃ¼r keine Lager blockiert',0),(478080,13280,'en','When Blocking Orders For No Stock',0),(478081,13281,'is','',0),(478082,13281,'dr','Ù†ÙˆØ§Ø± Ø¨Ø±Ø§ÛŒ Ù‡Ù…ÛŒØ´Ù‡ Ù…Ø®ÙÛŒ Ø¨Ø§Ø´Ø¯',0),(478083,13281,'pr','Ù†ÙˆØ§Ø± Ø¨Ø±Ø§ÛŒ Ù‡Ù…ÛŒØ´Ù‡ Ù…Ø®ÙÛŒ Ø¨Ø§Ø´Ø¯',0),(478084,13281,'tr','KalÄ±cÄ± olarak kenar Ã§ubuÄŸunu gizle',0),(478085,13281,'pl','StaÅ‚e Ukryj pasek boczny',0),(478086,13281,'bg','ÐŸÐ¾ÑÑ‚Ð¾ÑÐ½Ð½Ð¾ ÑÐºÑ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ‡Ð½Ð°Ñ‚Ð° Ð»ÐµÐ½Ñ‚Ð°',0),(478087,13281,'ur','Ù…Ø³ØªÙ‚Ù„ Ø·ÙˆØ± Ù¾Ø± Ø³Ø§Ø¦ÚˆØ¨Ø§Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(478088,13281,'sr','Ð¢Ñ€Ð°Ñ˜Ð½Ð¾ Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð±Ð¾Ñ‡Ð½Ñƒ Ñ‚Ñ€Ð°ÐºÑƒ',0),(478089,13281,'vi','giáº¥u máº·t thanh cá»‘ Ä‘á»‹nh',0),(478090,13281,'af','Permanent versteek Kantbalk',0),(478091,13281,'ro','Permanent ascundeÅ£i bara lateralÄƒ',0),(478092,13281,'et','PÃ¼sivalt Peida kÃ¼lgriba',0),(478093,13281,'si','Trajno Skrij stransko vrstico',0),(478094,13281,'ba','Permanen menyembunyikan Sidebar',0),(478095,13281,'nl','Permanent verbergen Sidebar',0),(478096,13281,'fi','PysyvÃ¤sti Piilota sivupalkki',0),(478097,13281,'no','Permanent Skjul Sidebar',0),(478098,13281,'da','Permanent Skjul sidebjÃ¦lke',0),(478099,13281,'ko','ì˜êµ¬ì ìœ¼ë¡œ ì‚¬ì´ë“œë°” ìˆ¨ê¸°ê¸°',0),(478100,13281,'he','×œ×¦×ž×™×ª×•×ª ×œ×”×¡×ª×™×¨ ××ª ×”×¡×¨×’×œ ×”×¦×™×“×™',0),(478101,13281,'el','ÎœÏŒÎ½Î¹Î¼Î± Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Ï€Î»ÎµÏ…ÏÎ¹ÎºÎ®Ï‚ ÎµÏÎ³Î±Î»ÎµÎ¹Î¿Î¸Î®ÎºÎ·Ï‚',0),(478102,13281,'zh','æ°¸ä¹…éšè—ä¾§è¾¹æ ',0),(478103,13281,'sv','Permanent DÃ¶lj Sidpanelen',0),(478104,13281,'it','Permanentemente Nascondi barra laterale',0),(478105,13281,'tl','',0),(478106,13281,'th','à¸‹à¹ˆà¸­à¸™ Sidebar à¸­à¸¢à¹ˆà¸²à¸‡à¸–à¸²à¸§à¸£',0),(478107,13281,'hi','à¤¸à¥à¤¥à¤¾à¤¯à¥€ à¤°à¥‚à¤ª à¤¸à¥‡ à¤¸à¤¾à¤‡à¤¡à¤¬à¤¾à¤° à¤›à¥à¤ªà¤¾à¤à¤',0),(478108,13281,'ms','Kekal menyembunyikan Bar sisi',0),(478109,13281,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø´Ø±ÙŠØ· Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠ Ø¨Ø´ÙƒÙ„ Ø¯Ø§Ø¦Ù…',0),(478110,13281,'fr','Masquer en permanence encadrÃ©',0),(478111,13281,'jp','ã‚µã‚¤ãƒ‰ãƒãƒ¼ã‚’éš ã™',0),(478112,13281,'pt','Permanentemente ocultar barra lateral',0),(478113,13281,'ru','ÐÐ°Ð²ÑÐµÐ³Ð´Ð° ÑÐºÑ€Ñ‹Ñ‚ÑŒ Ð±Ð¾ÐºÐ¾Ð²ÑƒÑŽ Ð¿Ð°Ð½ÐµÐ»ÑŒ',0),(478114,13281,'es','Esconde el Sidebar Permanentamente',0),(478115,13281,'de','Dauerhaft Sidebar ausblenden',0),(478116,13281,'en','Permanently Hide Sidebar',0),(478117,13282,'is','',0),(478118,13282,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø®Ø±ÛŒØ¯Ø§Ø±',0),(478119,13282,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø®Ø±ÛŒØ¯Ø§Ø±',0),(478120,13282,'tr','MÃ¼ÅŸteri Ã¶deme',0),(478121,13282,'pl','Odbiorcy pÅ‚atnoÅ›ci',0),(478122,13282,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(478123,13282,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(478124,13282,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ ÐºÑƒÐ¿Ñ†Ð°',0),(478125,13282,'vi','khÃ¡ch hÃ ng thanh toÃ¡n',0),(478126,13282,'af','KliÃ«nt betaling',0),(478127,13282,'ro','Client de platÄƒ',0),(478128,13282,'et','Kliendi makse',0),(478129,13282,'si','PlaÄila kupcev',0),(478130,13282,'ba','Pembayaran pelanggan',0),(478131,13282,'nl','Betaling van de klant',0),(478132,13282,'fi','Asiakkaan maksu',0),(478133,13282,'no','Kundebetaling',0),(478134,13282,'da','Debitorbetaling',0),(478135,13282,'ko','ê³ ê° ê²°ì œ',0),(478136,13282,'he','×ª×©×œ×•× ×œ×§×•×—',0),(478137,13282,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï€ÎµÎ»Î¬Ï„Î·',0),(478138,13282,'zh','å®¢æˆ·ä»˜æ¬¾',0),(478139,13282,'sv','Kundbetalning',0),(478140,13282,'it','Pagamento del cliente',0),(478141,13282,'tl','',0),(478142,13282,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(478143,13282,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(478144,13282,'ms','Pembayaran',0),(478145,13282,'ar','Ø¯ÙØ¹ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(478146,13282,'fr','Paiement du client',0),(478147,13282,'jp','é¡§å®¢æ”¯æ‰•',0),(478148,13282,'pt','Pagamento do cliente',0),(478149,13282,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(478150,13282,'es','Pago de Cliente',0),(478151,13282,'de','Kundenzahlung',0),(478152,13282,'en','Customer Payment',0),(478153,13283,'is','',0),(478154,13283,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÛŒÙ… Ø¯ÙØªØ± Ú©Ù„',0),(478155,13283,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÛŒÙ… Ø¯ÙØªØ± Ú©Ù„',0),(478156,13283,'tr','DoÄŸrudan GL Ã¶deme',0),(478157,13283,'pl','PÅ‚atnoÅ›ci bezpoÅ›rednie GL',0),(478158,13283,'bg','ÐŸÑ€ÑÐºÐ¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ GL',0),(478159,13283,'ur','Ø¬ÛŒØ¬Û’ Ù¾ÛŒÙ…Ù†Ù¹ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª',0),(478160,13283,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(478161,13283,'vi','Sá»• cÃ¡i thanh toÃ¡n trá»±c tiáº¿p',0),(478162,13283,'af','Direkte GL betaling',0),(478163,13283,'ro','GL platÄƒ directÄƒ',0),(478164,13283,'et','GL makstakse otse',0),(478165,13283,'si','Neposredno plaÄilo GL',0),(478166,13283,'ba','Pembayaran langsung GL',0),(478167,13283,'nl','Rechtstreekse betaling GL',0),(478168,13283,'fi','Suora GL maksu',0),(478169,13283,'no','Direkte GL betaling',0),(478170,13283,'da','Direkte GL betaling',0),(478171,13283,'ko','ì§ì ‘ GL ì§€ë¶ˆ',0),(478172,13283,'he','×ª×©×œ×•× ×™×©×™×¨ GL',0),(478173,13283,'el','Î‘Ï€ÎµÏ…Î¸ÎµÎ¯Î±Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î® GL',0),(478174,13283,'zh','ç›´æŽ¥ GL ä»˜æ¬¾',0),(478175,13283,'sv','Direkt GL utbetalning',0),(478176,13283,'it','GL pagamento diretto',0),(478177,13283,'tl','',0),(478178,13283,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ GL à¹‚à¸”à¸¢à¸•à¸£à¸‡',0),(478179,13283,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· GL à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(478180,13283,'ms','Mengarahkan pembayaran GL',0),(478181,13283,'ar','Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± GL',0),(478182,13283,'fr','GL paiement direct',0),(478183,13283,'jp','ç›´æŽ¥ GL æ”¯æ‰•ã„',0),(478184,13283,'pt','GL pagamento directo',0),(478185,13283,'ru','ÐŸÑ€ÑÐ¼Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ GL',0),(478186,13283,'es','Pago Directo de LM',0),(478187,13283,'de','GL Direktzahlung',0),(478188,13283,'en','Direct GL Payment',0),(478189,13284,'is','',0),(478190,13284,'dr','Ø¨Ø±Ø§ÛŒ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ ',0),(478191,13284,'pr','Ø¨Ø±Ø§ÛŒ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ ',0),(478192,13284,'tr','Ã–deme mevcut faturalar iÃ§in geÃ§erli deÄŸildir',0),(478193,13284,'pl','Nie dotyczÄ… pÅ‚atnoÅ›ci faktur istniejÄ…cych',0),(478194,13284,'bg','ÐÐµ ÑÐµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð°Ñ‚ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÐºÑŠÐ¼ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(478195,13284,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…ÙˆØ¬ÙˆØ¯Û ÙˆØ¨Ø¬Ù„ÛŒ Ù„Ø§Ú¯Ùˆ Ù†ÛÛŒÚº ÛÙˆØªÛ’ Û”',0),(478196,13284,'sr','ÐÐµ Ð¿Ñ€Ð¸Ð¼ÐµÑšÑƒÑ˜Ñƒ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð½Ð° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(478197,13284,'vi','khÃ´ng thanh toÃ¡n cho cÃ¡c hÃ³a Ä‘Æ¡n cÃ²n láº¡i',0),(478198,13284,'af','Geld nie betaling vir bestaande fakture',0),(478199,13284,'ro','Nu se aplicÄƒ plata facturilor existente',0),(478200,13284,'et','Kohaldada olemasolevate arvete makse',0),(478201,13284,'si','PlaÄilo ne uporabljajo za obstojeÄe raÄune',0),(478202,13284,'ba','Tidak berlaku pembayaran untuk faktur yang ada',0),(478203,13284,'nl','Betaling niet van toepassing op bestaande facturen',0),(478204,13284,'fi','Maksu ei koske aiemmin luoduissa laskuissa',0),(478205,13284,'no','Gjelde ikke betaling til eksisterende fakturaer',0),(478206,13284,'da','GÃ¦lde ikke betaling for eksisterende fakturaer',0),(478207,13284,'ko','ê¸°ì¡´ ì²­êµ¬ì„œ ì§€ë¶ˆ ì ìš© ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(478208,13284,'he','××™× ×Ÿ ×—×œ×•×ª ×¢×œ ×ª×©×œ×•× ×—×©×‘×•× ×™×•×ª ×§×™×™×ž×•×ª',0),(478209,13284,'el','Î”ÎµÎ½ Î¹ÏƒÏ‡ÏÎ¿Ï…Î½ Î³Î¹Î± Ï„Î¹Ï‚ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎµÏ‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(478210,13284,'zh','ä¸åº”ç”¨äºŽçŽ°æœ‰å‘ç¥¨ä»˜æ¬¾',0),(478211,13284,'sv','GÃ¤ller inte betalning fÃ¶r befintliga fakturor',0),(478212,13284,'it','Non applicare pagamento fatture esistenti',0),(478213,13284,'tl','',0),(478214,13284,'th','à¹ƒà¸Šà¹‰à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(478215,13284,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤²à¤¾à¤—à¥‚ à¤¨ à¤•à¤°à¥‡à¤‚',0),(478216,13284,'ms','Tidak dikenakan bayaran untuk invois yang sedia ada',0),(478217,13284,'ar','Ù„Ø§ ÙŠØªÙ… ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø¯ÙØ¹ Ø¹Ù„Ù‰ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(478218,13284,'fr','N\'entrent pas de paiement de factures existantes',0),(478219,13284,'jp','æ—¢å­˜ã®è«‹æ±‚æ›¸ã‚’æ”¯æ‰•ã‚’é©ç”¨ã•ã‚Œã¾ã›ã‚“ã€‚',0),(478220,13284,'pt','NÃ£o liquidar o pagamento de facturas existentes',0),(478221,13284,'ru','ÐÐµ ÐºÐ°ÑÐ°ÑŽÑ‚ÑÑ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(478222,13284,'es','No Aplica el Pago a Facturas Existentes',0),(478223,13284,'de','Zahlung auf vorhandenen Rechnungen nicht anwendbar',0),(478224,13284,'en','Do Not Apply Payment To Existing Invoices',0),(478225,13285,'is','',0),(478226,13285,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯ÙØªØ± Ú©Ù„',0),(478227,13285,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯ÙØªØ± Ú©Ù„',0),(478228,13285,'tr','GL Ã¶deme',0),(478229,13285,'pl','GL pÅ‚atnoÅ›ci',0),(478230,13285,'bg','GL Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(478231,13285,'ur','Ø¬ÛŒØ¬Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(478232,13285,'sr','Ð“Ð› Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(478233,13285,'vi','sá»• cÃ¡i thanh toÃ¡n',0),(478234,13285,'af','AG Betaling',0),(478235,13285,'ro','Plata GL',0),(478236,13285,'et','GL makse',0),(478237,13285,'si','GL plaÄilo',0),(478238,13285,'ba','GL pembayaran',0),(478239,13285,'nl','GL betaling',0),(478240,13285,'fi','GL maksu',0),(478241,13285,'no','GL betaling',0),(478242,13285,'da','GL betaling',0),(478243,13285,'ko','GL ì§€ë¶ˆ',0),(478244,13285,'he','×”×ª×©×œ×•× GL',0),(478245,13285,'el','GL Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(478246,13285,'zh','GL ä»˜æ¬¾',0),(478247,13285,'sv','GL betalning',0),(478248,13285,'it','Pagamento GL',0),(478249,13285,'tl','',0),(478250,13285,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ GL',0),(478251,13285,'hi','à¤œà¥€à¤à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(478252,13285,'ms','GL pembayaran',0),(478253,13285,'ar','Ø¯ÙØ¹ GL',0),(478254,13285,'fr','Paiement de GL',0),(478255,13285,'jp','GL ã®æ”¯æ‰•ã„',0),(478256,13285,'pt','Pagamento de GL',0),(478257,13285,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° GL',0),(478258,13285,'es','Pago de LM',0),(478259,13285,'de','GL-Zahlung',0),(478260,13285,'en','GL Payment',0),(478261,13286,'is','',0),(478262,13286,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ø®Ø±ÛŒØ¯Ø§Ø± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(478263,13286,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ø®Ø±ÛŒØ¯Ø§Ø± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(478264,13286,'tr','LÃ¼tfen bir mÃ¼ÅŸteri girin',0),(478265,13286,'pl','Podaj klienta',0),(478266,13286,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(478267,13286,'ur','Ø§ÛŒÚ© Ú¯Ø§ÛÚ© Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(478268,13286,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(478269,13286,'vi','vui lÃ²ng nháº­p má»™t khÃ¡ch hÃ ng',0),(478270,13286,'af','Tik asseblief \'n kliÃ«nt',0),(478271,13286,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un client',0),(478272,13286,'et','Palun sisesta klient',0),(478273,13286,'si','Vnesite kupca',0),(478274,13286,'ba','Masukkan pelanggan',0),(478275,13286,'nl','Voer een klant',0),(478276,13286,'fi','Kirjoita asiakkaan',0),(478277,13286,'no','Angi en kunde',0),(478278,13286,'da','Angiv venligst en kunde',0),(478279,13286,'ko','ê³ ê°ì„ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(478280,13286,'he','×”×–×™× ×• ×‘×‘×§×©×” ××ª ×”×œ×§×•×—',0),(478281,13286,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(478282,13286,'zh','è¯·è¾“å…¥ä¸€ä¸ªå®¢æˆ·',0),(478283,13286,'sv','Skriv in en kund',0),(478284,13286,'it','Si prega di inserire un cliente',0),(478285,13286,'tl','',0),(478286,13286,'th','à¸à¸£à¸¸à¸“à¸²à¸›à¹‰à¸­à¸™à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(478287,13286,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(478288,13286,'ms','Sila masukkan pelanggan',0),(478289,13286,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(478290,13286,'fr','Veuillez saisir un client',0),(478291,13286,'jp','é¡§å®¢ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(478292,13286,'pt','Por favor insira um cliente',0),(478293,13286,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(478294,13286,'es','Por favor Entra Un Cliente',0),(478295,13286,'de','Bitte geben Sie einen Kunden',0),(478296,13286,'en','Please Enter A Customer',0),(478297,13287,'is','',0),(478298,13287,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(478299,13287,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(478300,13287,'tr','LÃ¼tfen GL hesabÄ±nÄ± girin',0),(478301,13287,'pl','Podaj konto GL',0),(478302,13287,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð½Ð° GL',0),(478303,13287,'ur','Ø§ÛŒÚ© Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(478304,13287,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ñ€Ð°Ñ‡ÑƒÐ½ Ð£ Ð“Ð›',0),(478305,13287,'vi','vui lÃ²ng nháº­p tÃ i khoáº£n sá»• cÃ¡i',0),(478306,13287,'af','Tik asseblief \'n GL-rekening',0),(478307,13287,'ro','IntroduceÈ›i un cont GL',0),(478308,13287,'et','Keskmine hinne: GL konto',0),(478309,13287,'si','Vnesite raÄun GL',0),(478310,13287,'ba','Masukkan rekening GL',0),(478311,13287,'nl','Voer een GL-Account',0),(478312,13287,'fi','Kirjoita GL',0),(478313,13287,'no','Angi en gi-konto',0),(478314,13287,'da','Angiv en GL konto',0),(478315,13287,'ko','GL ê³„ì • ìž…ë ¥',0),(478316,13287,'he','×× × ×”×–×Ÿ ×—×©×‘×•×Ÿ GL',0),(478317,13287,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(478318,13287,'zh','è¯·è¾“å…¥æ€»å¸ç§‘ç›®',0),(478319,13287,'sv','Ange ett GL-konto',0),(478320,13287,'it','Immettere un Account GL',0),(478321,13287,'tl','',0),(478322,13287,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(478323,13287,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• GL à¤–à¤¾à¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(478324,13287,'ms','Sila masukkan satu akaun l',0),(478325,13287,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø­Ø³Ø§Ø¨ GL',0),(478326,13287,'fr','Veuillez entrer un compte GL',0),(478327,13287,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(478328,13287,'pt','Por favor, digite uma conta GL',0),(478329,13287,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL',0),(478330,13287,'es','Por favor Entra Una Cuenta LM',0),(478331,13287,'de','Bitte geben Sie eine Sako',0),(478332,13287,'en','Please Enter A GL Account',0),(478333,13288,'is','',0),(478334,13288,'dr','Ù„Ø·ÙØ§ ÛŒÚ© ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(478335,13288,'pr','Ù„Ø·ÙØ§ ÛŒÚ© ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(478336,13288,'tr','Bir satÄ±cÄ± giriniz',0),(478337,13288,'pl','ProszÄ™ podaÄ‡ sprzedawcy',0),(478338,13288,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(478339,13288,'ur','Ø§ÛŒÚ© Ø®ÙˆØ§Ù†Ú†Û ÙØ±ÙˆØ´ Ø®Ø§ØªÙˆÙ† Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(478340,13288,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(478341,13288,'vi','vui lÃ²ng nháº­p nhÃ  cung cáº¥p ',0),(478342,13288,'af','Tik asseblief \'n ondernemer',0),(478343,13288,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un furnizor',0),(478344,13288,'et','Palun sisestage hankija',0),(478345,13288,'si','Vnesite dobavitelja',0),(478346,13288,'ba','Masukkan Vendor',0),(478347,13288,'nl','Voer een leverancier',0),(478348,13288,'fi','Kirjoita toimittaja',0),(478349,13288,'no','Angi en leverandÃ¸r',0),(478350,13288,'da','Angiv et kreditor',0),(478351,13288,'ko','ê³µê¸‰ ì—…ì²´ë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(478352,13288,'he','×”×–×™× ×• ×‘×‘×§×©×” ××ª ×¡×¤×§',0),(478353,13288,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(478354,13288,'zh','è¯·è¾“å…¥ä¾›åº”å•†',0),(478355,13288,'sv','Ange en leverantÃ¶r',0),(478356,13288,'it','Inserisci un fornitore',0),(478357,13288,'tl','',0),(478358,13288,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸°à¸šà¸¸à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(478359,13288,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(478360,13288,'ms','Sila masukkan Vendor',0),(478361,13288,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ù…ÙˆØ±Ø¯',0),(478362,13288,'fr','Veuillez entrer un vendeur',0),(478363,13288,'jp','ä»•å…¥å…ˆã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(478364,13288,'pt','Por favor insira um fornecedor',0),(478365,13288,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÑƒ',0),(478366,13288,'es','Por Favor Entra Un Vendedor',0),(478367,13288,'de','Bitte geben Sie einen Kreditor',0),(478368,13288,'en','Please Enter A Vendor',0),(478369,13289,'is','',0),(478370,13289,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(478371,13289,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(478372,13289,'tr','SatÄ±cÄ±ya Ã¶deme',0),(478373,13289,'pl','PÅ‚atnoÅ›ci dostawcy',0),(478374,13289,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(478375,13289,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(478376,13289,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(478377,13289,'vi','Thanh toÃ¡n cho nhÃ  cung cáº¥p',0),(478378,13289,'af','Handelaar betaling',0),(478379,13289,'ro','Furnizor de platÄƒ',0),(478380,13289,'et','Hankija makse',0),(478381,13289,'si','PlaÄilo dobavitelja',0),(478382,13289,'ba','Penjual pembayaran',0),(478383,13289,'nl','Leverancier betaling',0),(478384,13289,'fi','Toimittajan maksu',0),(478385,13289,'no','LeverandÃ¸rbetaling',0),(478386,13289,'da','Kreditorbetaling',0),(478387,13289,'ko','ê³µê¸‰ ì—…ì²´ ì§€ë¶ˆ',0),(478388,13289,'he','×ª×©×œ×•× ×¡×¤×§',0),(478389,13289,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(478390,13289,'zh','ä¾›åº”å•†ä»˜æ¬¾',0),(478391,13289,'sv','LeverantÃ¶rsbetalning',0),(478392,13289,'it','Pagamento fornitore',0),(478393,13289,'tl','',0),(478394,13289,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(478395,13289,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(478396,13289,'ms','Pembayaran pembekal',0),(478397,13289,'ar','Ø¯ÙØ¹ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(478398,13289,'fr','Paiement fournisseur',0),(478399,13289,'jp','ä»•å…¥å…ˆæ”¯æ‰•',0),(478400,13289,'pt','Pagamento de fornecedores',0),(478401,13289,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð°Ð±Ð¾Ð½ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(478402,13289,'es','Pago al Proveedor',0),(478403,13289,'de','Kreditorenzahlung',0),(478404,13289,'en','Vendor Payment',0),(478405,13290,'is','',0),(478406,13290,'dr','Ø§Ú¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÛŒÙ„Ù‡',0),(478407,13290,'pr','Ø§Ú¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨ÙˆØ³ÛŒÙ„Ù‡',0),(478408,13290,'tr','EÄŸer tarafÄ±ndan Ã¶denen',0),(478409,13290,'pl','Czy wypÅ‚acane przez',0),(478410,13290,'bg','ÐÐºÐ¾ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð° Ð¾Ñ‚',0),(478411,13290,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø¯Ø§ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ ØªÙˆ',0),(478412,13290,'sr','ÐÐºÐ¾ Ð¿Ð»Ð°Ñ›Ð°Ñ˜Ñƒ',0),(478413,13290,'vi','náº¿u Ä‘Ã£ tráº£ bá»Ÿi',0),(478414,13290,'af','Indien betaal deur',0),(478415,13290,'ro','DacÄƒ plÄƒtite de',0),(478416,13290,'et','Kui tasutud',0),(478417,13290,'si','ÄŒe plaÄa',0),(478418,13290,'ba','Jika dibayar oleh',0),(478419,13290,'nl','Als betaald door',0),(478420,13290,'fi','Jos maksaa',0),(478421,13290,'no','Hvis betalt',0),(478422,13290,'da','Hvis betalt af',0),(478423,13290,'ko','ì— ì˜í•´ ì§€ë¶ˆ í•˜ëŠ” ê²½ìš°',0),(478424,13290,'he','×× ×©×™×œ× ×¢×œ ×™×“×™',0),(478425,13290,'el','Î‘Î½ ÎºÎ±Ï„Î±Î²Î»Î·Î¸ÎµÎ¯ Î±Ï€ÏŒ',0),(478426,13290,'zh','å¦‚æžœç”±æ”¯ä»˜',0),(478427,13290,'sv','Om betalas av',0),(478428,13290,'it','Se pagate da',0),(478429,13290,'tl','',0),(478430,13290,'th','à¸–à¹‰à¸²à¸Šà¸³à¸£à¸°à¸”à¹‰à¸§à¸¢',0),(478431,13290,'hi','à¤…à¤—à¤° à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(478432,13290,'ms','Jika dibayar oleh',0),(478433,13290,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† ÙŠØ¯ÙØ¹Ù‡Ø§',0),(478434,13290,'fr','Si payÃ© par',0),(478435,13290,'jp','å ´åˆã«ã‚ˆã£ã¦æ”¯æ‰•ã‚',0),(478436,13290,'pt','Se pago por',0),(478437,13290,'ru','Ð•ÑÐ»Ð¸ Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ',0),(478438,13290,'es','Si Pagado Por',0),(478439,13290,'de','Wenn Lasten',0),(478440,13290,'en','If Paid By',0),(478441,13291,'is','',0),(478442,13291,'dr','Ù‚Ø§Ø¨Ù„ÛŒØª Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø³ÙØ§Ø±Ø´',0),(478443,13291,'pr','Ù‚Ø§Ø¨Ù„ÛŒØª Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø³ÙØ§Ø±Ø´',0),(478444,13291,'tr','SipariÅŸ eklentileri',0),(478445,13291,'pl','ZamÃ³wienie Dodatki',0),(478446,13291,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(478447,13291,'ur','Ø­Ú©Ù… Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº ons',0),(478448,13291,'sr','Ð”Ð¾Ð´Ð°Ñ†Ð¸ Ð·Ð° Ð½Ð°Ð»Ð¾Ð³',0),(478449,13291,'vi','ThÃªm Ä‘Æ¡n hÃ ng',0),(478450,13291,'af','Orde byvoegsels',0),(478451,13291,'ro','Comanda Suplimente',0),(478452,13291,'et','Tellimuse lisandmoodulid',0),(478453,13291,'si','Naloga dodatkov',0),(478454,13291,'ba','Urutan Pengaya',0),(478455,13291,'nl','Volgorde Add-Ons',0),(478456,13291,'fi','Jotta lisÃ¤osat',0),(478457,13291,'no','For tillegg',0),(478458,13291,'da','Bestil tilfÃ¸jelser',0),(478459,13291,'ko','ì£¼ë¬¸ ì¶”ê°€ ê¸°ëŠ¥',0),(478460,13291,'he','×¡×“×¨ ×ª×•×¡×¤×•×ª',0),(478461,13291,'el','Î£ÎµÎ¹ÏÎ¬ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Ï‰Î½',0),(478462,13291,'zh','é¡ºåºåŠ è½½é¡¹',0),(478463,13291,'sv','BestÃ¤lla tillÃ¤gg',0),(478464,13291,'it','Componenti aggiuntivi di ordine',0),(478465,13291,'tl','',0),(478466,13291,'th','à¸ªà¸±à¹ˆà¸‡à¹‚à¸›à¸£à¹à¸à¸£à¸¡ Add-on',0),(478467,13291,'hi','à¤†à¤¦à¥‡à¤¶ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚-ons',0),(478468,13291,'ms','Perintah tambahan',0),(478469,13291,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(478470,13291,'fr','Modules de commande',0),(478471,13291,'jp','é †åºã®ã‚¢ãƒ‰ã‚ªãƒ³',0),(478472,13291,'pt','Complementos de ordem',0),(478473,13291,'ru','Ð—Ð°ÐºÐ°Ð· Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(478474,13291,'es','Orden Add-Ons',0),(478475,13291,'de','Bestellung Add-ons',0),(478476,13291,'en','Order Add-Ons',0),(478477,13292,'is','',0),(478478,13292,'dr','(ØªÙ†Ø¸ÛŒÙ…) ÛŒÚ© Ø¬Ù†Ø³',0),(478479,13292,'pr','ØªØ¹Ø¯ÛŒÙ„ Ú©Ø±Ø¯Ù†(ØªÙ†Ø¸ÛŒÙ…) ÛŒÚ© Ú©Ø§Ù„Ø§',0),(478480,13292,'tr','Tek Ã¶ÄŸe ayarlama',0),(478481,13292,'pl','Dopasuj pojedynczy element',0),(478482,13292,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹Ñ‚Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ‡ÐµÐ½ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(478483,13292,'ur','Ø§Ù†ÙØ±Ø§Ø¯ÛŒ Ø¢Ø¦ÛŒÙ¹Ù… Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(478484,13292,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ˜ÐµÐ´Ð¸Ð½Ð°Ñ‡Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(478485,13292,'vi','Äiá»u chá»‰nh háº¡n má»¥c Ä‘Æ¡n giáº£n',0),(478486,13292,'af','Verstel enkel Item',0),(478487,13292,'ro','Regla singur element',0),(478488,13292,'et','Reguleerida Ã¼he Ã¼ksuse',0),(478489,13292,'si','Prilagodite posamezen element',0),(478490,13292,'ba','Menyesuaikan Item tunggal',0),(478491,13292,'nl','Ã‰Ã©n Item aanpassen',0),(478492,13292,'fi','SÃ¤Ã¤tÃ¤Ã¤ yksittÃ¤isen kohteen',0),(478493,13292,'no','Justere enkeltelement',0),(478494,13292,'da','Justere enkelt element',0),(478495,13292,'ko','ë‹¨ì¼ í•­ëª© ì¡°ì •',0),(478496,13292,'he','×œ×”×ª××™× ××ª ×¤×¨×™×˜ ×‘×•×“×“',0),(478497,13292,'el','Î¡Ï…Î¸Î¼Î¯ÏƒÏ„Îµ Ï„Î¿ Î¼ÎµÎ¼Î¿Î½Ï‰Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(478498,13292,'zh','è°ƒæ•´å•ä¸ªé¡¹ç›®',0),(478499,13292,'sv','Justera enstaka objekt',0),(478500,13292,'it','Regolare il singolo elemento',0),(478501,13292,'tl','',0),(478502,13292,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸”à¸µà¸¢à¸§',0),(478503,13292,'hi','à¤à¤•à¤² à¤†à¤‡à¤Ÿà¤® à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(478504,13292,'ms','Laraskan Item tunggal',0),(478505,13292,'ar','Ø¶Ø¨Ø· Ø¹Ù†ØµØ± ÙˆØ§Ø­Ø¯',0),(478506,13292,'fr','RÃ©gler l\'Ã©lÃ©ment unique',0),(478507,13292,'jp','1 ã¤ã®é …ç›®ã‚’èª¿æ•´ã—ã¾ã™ã€‚',0),(478508,13292,'pt','Ajustar o Ãºnico Item',0),(478509,13292,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð¾Ñ‚Ð´ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(478510,13292,'es','Ajustar Item Solitario',0),(478511,13292,'de','Einzelnes Element anpassen',0),(478512,13292,'en','Adjust Single Item',0),(478513,13293,'is','',0),(478514,13293,'dr','Ø¯Ø± Ù…Ù‚Ø§Ø¨Ù„ Ø§Ù‚Ù„Ø§Ù… Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(478515,13293,'pr','Ø¯Ø± Ù…Ù‚Ø§Ø¨Ù„ Ø§Ù‚Ù„Ø§Ù… Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ø¯Ø± Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(478516,13293,'tr','PO Ã¼zerinde alÄ±nan maddelerin karÅŸÄ±',0),(478517,13293,'pl','Przeciwko pozycje na PO',0),(478518,13293,'bg','Ð¡Ñ€ÐµÑ‰Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° PO',0),(478519,13293,'ur','Ù¾ÙˆØ³Ù¹ Ù¾Ø± Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ø®Ù„Ø§Ù Ù…Ù„ÛŒ',0),(478520,13293,'sr','ÐŸÑ€Ð¾Ñ‚Ð¸Ð² Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ ÐºÐ¾Ñ˜Ð¸ ÑÑƒ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð¸ Ð½Ð° Ð¿Ð¾-Ð°',0),(478521,13293,'vi','Äá»‘i cÃ¡c háº¡n má»¥c trÃªn háº­ thá»‘ng',0),(478522,13293,'af','Teen Items ontvang op PO',0),(478523,13293,'ro','ÃŽmpotriva elementelor primite pe PO',0),(478524,13293,'et','Eest punkte saanud PO',0),(478525,13293,'si','Proti artiklih na PO',0),(478526,13293,'ba','Terhadap barang-barang yang diterima pada PO',0),(478527,13293,'nl','Tegen Items ontvangen op PO',0),(478528,13293,'fi','Vastaan sai PO',0),(478529,13293,'no','Mot varene som ble mottatt pÃ¥ PO',0),(478530,13293,'da','Imod varer, der modtages pÃ¥ PO',0),(478531,13293,'ko','í•­ëª©ì— ëŒ€ í•œ í¬ì— ë°›ì€',0),(478532,13293,'he','× ×’×“ ×¤×¨×™×˜×™× ×”×ª×§×‘×œ ×‘ ×¤×•',0),(478533,13293,'el','ÎšÎ±Ï„Î¬ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Î­Î»Î±Î²Îµ ÏƒÏ„Î¹Ï‚ PO',0),(478534,13293,'zh','ä¸Žé¡¹ç›®æ‰€æ”¶åˆ°çš„è®¢å•',0),(478535,13293,'sv','Varuposter mottagen PO',0),(478536,13293,'it','Contro gli elementi ricevuti sul PO',0),(478537,13293,'tl','',0),(478538,13293,'th','à¸à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¹ƒà¸™ PO',0),(478539,13293,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤ªà¤° à¤ªà¥‹ à¤•à¥‡ à¤–à¤¿à¤²à¤¾à¤«',0),(478540,13293,'ms','Terhadap item-item yang diterima pada PO',0),(478541,13293,'ar','Ø¶Ø¯ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„ÙˆØ§Ø±Ø¯Ø© ÙÙŠ Øµ. Ø¨.',0),(478542,13293,'fr','Contre les articles reÃ§us sur PO',0),(478543,13293,'jp','PO ã‚’å—ä¿¡ã—ãŸã‚¢ã‚¤ãƒ†ãƒ ã«å¯¾ã—ã¦',0),(478544,13293,'pt','Contra itens recebidos na PO',0),(478545,13293,'ru','ÐŸÑ€Ð¾Ñ‚Ð¸Ð² Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð¾Ð², Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ… Ð½Ð° PO',0),(478546,13293,'es','Contra Items Recibidos en OC',0),(478547,13293,'de','Gegen Elemente empfangen am PO',0),(478548,13293,'en','Against Items Received On PO',0),(478549,13294,'is','',0),(478550,13294,'dr','Ø§Ø¬Ø±Ø§ÛŒ Ù‡Ù…Ù‡ Ø§Ø² ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡',0),(478551,13294,'pr','Ø§Ø¬Ø±Ø§ÛŒ Ù‡Ù…Ù‡ Ø§Ø² ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡',0),(478552,13294,'tr','Toplam AP faturasÄ± uygulamak',0),(478553,13294,'pl','StosowaÄ‡ Å‚Ä…cznie z AP Bill',0),(478554,13294,'bg','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð°Ñ‚ Ð¾Ð±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð¾Ñ‚ ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð° Ð½Ð° Ð°Ð¿',0),(478555,13294,'ur','Ú©Ù„ AP Ø¨Ù„ Ø³Û’ Ù„Ú¯Ø§Ø¦ÛŒÚº Û”',0),(478556,13294,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ ÑƒÐºÑƒÐ¿Ð½Ð¾ Ð¸Ð· ÐÐŸ Ð‘Ð¸Ð»',0),(478557,13294,'vi','Ãp dá»¥ng Tá»•ng sá»‘ Tá»« hÃ³a Ä‘Æ¡n thanh toÃ¡n',0),(478558,13294,'af','Totaal van GP Wetsontwerp dien',0),(478559,13294,'ro','Se aplicÄƒ Total din AP Bill',0),(478560,13294,'et','Kokku alates AP Bill',0),(478561,13294,'si','Uporabljajo skupaj iz AP Bill',0),(478562,13294,'ba','Menerapkan Total dari AP Bill',0),(478563,13294,'nl','Totaal toepassing van AP Bill',0),(478564,13294,'fi','Soveltaa yhteensÃ¤ AP Bill',0),(478565,13294,'no','SÃ¸ke totalt fra AP Bill',0),(478566,13294,'da','Anvende alt fra AP Bill',0),(478567,13294,'ko','AP ë¹Œì—ì„œ ì´ì„ ì ìš©',0),(478568,13294,'he','×”×—×œ ×¡×” ×› ×ž×‘×™×œ AP',0),(478569,13294,'el','Î•Ï†Î±ÏÎ¼ÏŒÎ¶Î¿Î½Ï„Î±Î¹ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬ Î±Ï€ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï„Î¿Ï… AP',0),(478570,13294,'zh','åº”ç”¨å…±ä»Ž AP æ¡ä¾‹è‰æ¡ˆ',0),(478571,13294,'sv','TillÃ¤mpa totalt frÃ¥n AP Bill',0),(478572,13294,'it','Applicare totale da Bill AP',0),(478573,13294,'tl','',0),(478574,13294,'th','à¹ƒà¸Šà¹‰à¸¢à¸­à¸”à¸£à¸§à¸¡à¸ˆà¸²à¸à¸ªà¸¹à¸•à¸£ AP',0),(478575,13294,'hi','à¤•à¥à¤² à¤à¤ªà¥€ à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤¸à¥‡ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(478576,13294,'ms','Memohon jumlah dari AP Rang undang-undang',0),(478577,13294,'ar','ØªØ·Ø¨ÙŠÙ‚ Ù…Ø¬Ù…ÙˆØ¹Ø© Ù…Ù† Ø¨ÙŠÙ„ AP',0),(478578,13294,'fr','S\'applique au Total de Bill AP',0),(478579,13294,'jp','Ap é€šä¿¡æ³•æ¡ˆã‹ã‚‰åˆè¨ˆã‚’é©ç”¨ã—ã¾ã™ã€‚',0),(478580,13294,'pt','Aplicar o Total de Bill AP',0),(478581,13294,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½ÑÑ‚ÑŒ Ð²ÑÐµÐ³Ð¾ Ð¾Ñ‚ AP Ð‘Ð¸Ð»Ð»Ð°',0),(478582,13294,'es','Aplica Total Desde Recibo de CC',0),(478583,13294,'de','Gilt die Summe aus AP Bill',0),(478584,13294,'en','Apply Total From AP Bill',0),(478585,13295,'is','',0),(478586,13295,'dr','...',0),(478587,13295,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡...',0),(478588,13295,'tr','AP Bill',0),(478589,13295,'pl','AP Bill',0),(478590,13295,'bg','AP Ð±Ð¸Ð»',0),(478591,13295,'ur','AP Ø¨Ù„',0),(478592,13295,'sr','ÐÐŸ Ð‘Ð¸Ð»',0),(478593,13295,'vi','HÃ³a Ä‘Æ¡n thanh toÃ¡n',0),(478594,13295,'af','GP Wetsontwerp',0),(478595,13295,'ro','AP Bill',0),(478596,13295,'et','AP Bill',0),(478597,13295,'si','AP Bill',0),(478598,13295,'ba','AP Bill',0),(478599,13295,'nl','AP Bill',0),(478600,13295,'fi','AP-lasku',0),(478601,13295,'no','AP Bill',0),(478602,13295,'da','AP Bill',0),(478603,13295,'ko','AP ë¹Œ',0),(478604,13295,'he','×‘×™×œ AP',0),(478605,13295,'el','AP Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(478606,13295,'zh','ç¾Žè”ç¤¾æ¯”å°”',0),(478607,13295,'sv','AP Bill',0),(478608,13295,'it','Bill AP',0),(478609,13295,'tl','',0),(478610,13295,'th','à¸•à¸±à¹‹à¸§ AP',0),(478611,13295,'hi','à¤à¤ªà¥€ à¤µà¤¿à¤§à¥‡à¤¯à¤•',0),(478612,13295,'ms','AP Rang undang-undang',0),(478613,13295,'ar','AP Ø¨ÙŠÙ„',0),(478614,13295,'fr','Bill AP',0),(478615,13295,'jp','Ap é€šä¿¡æ³•æ¡ˆ',0),(478616,13295,'pt','Bill AP',0),(478617,13295,'ru','Ð‘Ð¸Ð»Ð» AP',0),(478618,13295,'es','Recibo de CC',0),(478619,13295,'de','AP Bill',0),(478620,13295,'en','AP Bill',0),(478621,13296,'is','',0),(478622,13296,'dr','ØªÙ†Ø¸ÛŒÙ… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡',0),(478623,13296,'pr','ØªÙ†Ø¸ÛŒÙ… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡',0),(478624,13296,'tr','AP fatura ayarlamasÄ±',0),(478625,13296,'pl','AP ustawy regulacji',0),(478626,13296,'bg','AP Ð±Ð¸Ð» ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ',0),(478627,13296,'ur','AP Ø¨Ù„ Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(478628,13296,'sr','ÐÐŸ Ð‘Ð¸Ð» ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(478629,13296,'vi','Äiá»u chá»‰nh hÃ³a Ä‘Æ¡n thanh toÃ¡n ',0),(478630,13296,'af','GP Wetsontwerp aanpassing',0),(478631,13296,'ro','AP Bill ajustare',0),(478632,13296,'et','AP arve korrigeerimine',0),(478633,13296,'si','AP Bill prilagoditev',0),(478634,13296,'ba','AP Bill penyesuaian',0),(478635,13296,'nl','AP Bill aanpassing',0),(478636,13296,'fi','AP Bill sÃ¤Ã¤tÃ¶',0),(478637,13296,'no','AP Bill justering',0),(478638,13296,'da','AP Bill justering',0),(478639,13296,'ko','AP ë²•ì•ˆ ì¡°ì •',0),(478640,13296,'he','×”×ª××ž×ª AP ×‘×™×œ',0),(478641,13296,'el','AP Bill Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚',0),(478642,13296,'zh','AP æ¡ä¾‹è‰æ¡ˆè°ƒæ•´',0),(478643,13296,'sv','AP Bill justering',0),(478644,13296,'it','Regolazione AP Bill',0),(478645,13296,'tl','',0),(478646,13296,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸¹à¸•à¸£ AP',0),(478647,13296,'hi','à¤à¤ªà¥€ à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(478648,13296,'ms','Pelarasan bil AP',0),(478649,13296,'ar','ØªØ¹Ø¯ÙŠÙ„ Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(478650,13296,'fr','Ajustement de l\'AP Bill',0),(478651,13296,'jp','Ap é€šä¿¡æ³•æ¡ˆèª¿æ•´',0),(478652,13296,'pt','Ajuste de Bill AP',0),(478653,13296,'ru','Ð ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²ÐºÐ° AP Ð‘Ð¸Ð»Ð»',0),(478654,13296,'es','Ajuste de Recibo CC',0),(478655,13296,'de','AP Bill Anpassung',0),(478656,13296,'en','AP Bill Adjustment',0),(478657,13297,'is','',0),(478658,13297,'dr','Ø§ØµÙ„Ø§Ø­ Ù‡Ø²ÛŒÙ†Ù‡',0),(478659,13297,'pr','Ø§ØµÙ„Ø§Ø­ Ù‡Ø²ÛŒÙ†Ù‡',0),(478660,13297,'tr','Maliyet ayarlama',0),(478661,13297,'pl','Koszt regulacji',0),(478662,13297,'bg','Ð¦ÐµÐ½Ð¾Ð²Ð¾ Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ',0),(478663,13297,'ur','Ù„Ø§Ú¯Øª Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(478664,13297,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’Ð°Ð²Ð°ÑšÐ°',0),(478665,13297,'vi','chá»‰nh sá»­a chi phÃ­',0),(478666,13297,'af','Koste aanpassing',0),(478667,13297,'ro','Ajustare cost',0),(478668,13297,'et','Kulude korrigeerimine',0),(478669,13297,'si','StroÅ¡ki prilagoditev',0),(478670,13297,'ba','Penyesuaian biaya',0),(478671,13297,'nl','Kosten aanpassing',0),(478672,13297,'fi','Hinnan muutos',0),(478673,13297,'no','Kostnader justering',0),(478674,13297,'da','Omkostninger justering',0),(478675,13297,'ko','ë¹„ìš©ëœ ì¡°ì •',0),(478676,13297,'he','×”×ª××ž×ª ×¢×œ×•×ª',0),(478677,13297,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(478678,13297,'zh','è´¹ç”¨çš„è°ƒæ•´',0),(478679,13297,'sv','Kostnad justering',0),(478680,13297,'it','Adeguamento costo',0),(478681,13297,'tl','',0),(478682,13297,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(478683,13297,'hi','à¤²à¤¾à¤—à¤¤ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(478684,13297,'ms','Pelarasan kos',0),(478685,13297,'ar','ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„ØªÙƒÙŠÙ',0),(478686,13297,'fr','CoÃ»t d\'ajustement',0),(478687,13297,'jp','ã‚³ã‚¹ãƒˆèª¿æ•´',0),(478688,13297,'pt','Ajuste de custo',0),(478689,13297,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(478690,13297,'es','Ajuste de Costo',0),(478691,13297,'de','KostengÃ¼nstige Anpassung',0),(478692,13297,'en','Cost Adjustment',0),(478693,13298,'is','',0),(478694,13298,'dr','+Ø¬Ø¨Ø±Ø§Ù†(Ú†Ø§Ù¾)Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ø§ÛŒØ¯ Ø¬Ù…Ø¹ Ø´ÙˆØ¯ Ø¨Ø§ 0',0),(478695,13298,'pr','Ù‡Ø²ÛŒÙ†Ù‡+Ø¬Ø¨Ø±Ø§Ù†(Ú†Ø§Ù¾)Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ø§ÛŒØ¯ Ø¬Ù…Ø¹ Ø´ÙˆØ¯ Ø¨Ø§ 0',0),(478696,13298,'tr','Maliyet + maliyet uzaklÄ±k 0 olarak toplamak gerekir',0),(478697,13298,'pl','Koszty + koszty przesuniÄ™cia naleÅ¼y zsumowaÄ‡ 0',0),(478698,13298,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ + Ñ†ÐµÐ½Ð° Ð¾Ñ„ÑÐµÑ‚ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑƒÐ¼Ð¸Ñ€Ð° Ð´Ð¾ 0',0),(478699,13298,'ur','Ù„Ø§Ú¯Øª + Ù„Ø§Ú¯Øª Ø¢ÙØ³Ù¹ 0 Ø³Û’ Ø­Ø§ØµÙ„ ÙŠÛ ÛÙˆØ§ ÙƒÛ Ú†Ø§ÛÛŒÛ’',0),(478700,13298,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº + Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¿Ð¾Ð¼Ð°Ðº Ð¼Ð¾Ñ€Ð° ÑÐ°Ð±Ñ€Ð°Ñ‚Ð¸ Ð½Ð° 0',0),(478701,13298,'vi','chi phÃ­ vÃ  phÃ­ bÃ¹ láº¡i tá»•ng pháº£i báº±ng 0',0),(478702,13298,'af','Koste + koste verreken moet som 0.',0),(478703,13298,'ro','Cost + Cost compensate trebuie sÄƒ rezuma la 0',0),(478704,13298,'et','Maksumus + kulude nihe tuleb summeerida 0',0),(478705,13298,'si','StroÅ¡ki + stroÅ¡kov odmik mora vsota 0',0),(478706,13298,'ba','Biaya + biaya Offset harus jumlah ke 0',0),(478707,13298,'nl','Kosten + kosten Offset moet optellen op 0',0),(478708,13298,'fi','Kustannukset kustannukset aikaeron summan on oltava 0',0),(478709,13298,'no','Kostpris + kostnad forskyvning mÃ¥ bli 0',0),(478710,13298,'da','Kostpris + omkostninger forskydning skal opsummere til 0',0),(478711,13298,'ko','ë¹„ìš© + ë¹„ìš©ëœ ì˜¤í”„ì…‹ 0ì— í•©ê³„ í•œë‹¤',0),(478712,13298,'he','×¢×œ×•×ª + ×”×™×¡×˜ ×¢×œ×•×ª ×—×™×™×‘ ×¡×›×•× 0',0),(478713,13298,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ + ÎºÏŒÏƒÏ„Î¿Ï‚ Offset Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¬Î¸ÏÎ¿Î¹ÏƒÎ¼Î± Î¼Îµ 0',0),(478714,13298,'zh','æˆæœ¬ + æˆæœ¬åç§»é‡çš„æ€»å’Œå¿…é¡»ä¸º 0',0),(478715,13298,'sv','Kostnad + kostnad Offset mÃ¥ste summan 0',0),(478716,13298,'it','Costo + Offset costo occorre sommare a 0',0),(478717,13298,'tl','',0),(478718,13298,'th','à¸•à¹‰à¸­à¸‡à¸£à¸§à¸¡à¸•à¹‰à¸™à¸—à¸¸à¸™ + à¸•à¹‰à¸™à¸—à¸¸à¸™à¸­à¸­à¸Ÿà¹€à¸‹à¹‡à¸• 0',0),(478719,13298,'hi','à¤²à¤¾à¤—à¤¤ + à¤²à¤¾à¤—à¤¤ à¤‘à¤«à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ 0 à¤•à¤¾ à¤¯à¥‹à¤— à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(478720,13298,'ms','Kos + kos ofset mesti jumlah 0',0),(478721,13298,'ar','ÙŠØ¬Ø¨ Ø­Ø³Ø§Ø¨ Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ØªÙƒÙ„ÙØ© + Ø¥Ø²Ø§Ø­Ø© Ø§Ù„ØªÙƒÙ„ÙØ© Ø¥Ù„Ù‰ 0',0),(478722,13298,'fr','CoÃ»t + coÃ»t Offset doit la somme Ã  0',0),(478723,13298,'jp','è²»ç”¨ + è²»ç”¨ã‚ªãƒ•ã‚»ãƒƒãƒˆã‚’ 0 ã«åˆè¨ˆã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(478724,13298,'pt','Custo + custo de deslocamento deve somar 0',0),(478725,13298,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ + ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÑÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð²Ð½Ð° 0',0),(478726,13298,'es','Costo + Offset de Costos Debe Sumar a 0',0),(478727,13298,'de','Kosten + Cost Offset muss 0 Summe',0),(478728,13298,'en','Cost + Cost Offset Must Sum To 0',0),(478729,13299,'is','',0),(478730,13299,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ ØµÙØ± Ø¨Ø§Ø´Ø¯',0),(478731,13299,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ ØµÙØ± Ø¨Ø§Ø´Ø¯',0),(478732,13299,'tr','Maliyet 0 olamaz',0),(478733,13299,'pl','Koszt nie moÅ¼e byÄ‡ 0',0),(478734,13299,'bg','Ð¦ÐµÐ½Ð°Ñ‚Ð° Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ 0',0),(478735,13299,'ur','Ù‚ÛŒÙ…Øª 0 Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©ØªØ§',0),(478736,13299,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð½Ðµ Ð¼Ð¾Ð³Ñƒ Ð±Ð¸Ñ‚Ð¸ 0',0),(478737,13299,'vi','chi phÃ­ khÃ´ng thá»ƒ báº±ng 0',0),(478738,13299,'af','Koste nie 0 kan wees nie',0),(478739,13299,'ro','Costul nu poate fi 0',0),(478740,13299,'et','Kulud ei tohi olla 0',0),(478741,13299,'si','StroÅ¡kov ne more biti 0',0),(478742,13299,'ba','Biaya tidak menjadi 0',0),(478743,13299,'nl','Kosten mogen niet 0',0),(478744,13299,'fi','Kustannuksia ei voi olla 0',0),(478745,13299,'no','Kostnader kan ikke vÃ¦re 0',0),(478746,13299,'da','Omkostningerne kan ikke vÃ¦re 0',0),(478747,13299,'ko','ë¹„ìš© 0 ì¼ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(478748,13299,'he','×¢×œ×•×ª ×œ× ×™×›×•×œ ×œ×”×™×•×ª 0',0),(478749,13299,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ 0',0),(478750,13299,'zh','æˆæœ¬ä¸èƒ½ä¸º 0',0),(478751,13299,'sv','Kostnaden kan inte vara 0',0),(478752,13299,'it','Costo non puÃ² essere 0',0),(478753,13299,'tl','',0),(478754,13299,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸•à¹‰à¸­à¸‡à¹„à¸¡à¹ˆà¹€à¸›à¹‡à¸™ 0',0),(478755,13299,'hi','à¤²à¤¾à¤—à¤¤ 0 à¤¹à¥‹ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(478756,13299,'ms','Kos tidak boleh 0',0),(478757,13299,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªÙƒÙˆÙ† Ø§Ù„ØªÙƒÙ„ÙØ© 0',0),(478758,13299,'fr','CoÃ»t ne peut pas Ãªtre 0',0),(478759,13299,'jp','ã‚³ã‚¹ãƒˆãŒ 0 ã«ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(478760,13299,'pt','Custo nÃ£o pode ser 0',0),(478761,13299,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ 0',0),(478762,13299,'es','Costo No Puede Ser 0',0),(478763,13299,'de','Kosten darf nicht 0 sein.',0),(478764,13299,'en','Cost Cannot Be 0',0),(478765,13300,'is','',0),(478766,13300,'dr','(Ú†Ø§Ù¾)Ù‡Ø²ÛŒÙ†Ù‡',0),(478767,13300,'pr','Ø¬Ø¨Ø±Ø§Ù†(Ú†Ø§Ù¾)Ù‡Ø²ÛŒÙ†Ù‡',0),(478768,13300,'tr','Maliyet mahsup hesabÄ±',0),(478769,13300,'pl','PrzesuniÄ™cie kosztÃ³w',0),(478770,13300,'bg','Ð¦ÐµÐ½Ð° Ð¾Ñ„ÑÐµÑ‚',0),(478771,13300,'ur','Ù„Ø§Ú¯Øª Ø¢ÙØ³Ù¹',0),(478772,13300,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ñƒ Ð¾Ð´Ð½Ð¾ÑÑƒ Ð½Ð°',0),(478773,13300,'vi','bÃ¹ trá»« chi phÃ­',0),(478774,13300,'af','Koste verreken',0),(478775,13300,'ro','Cost Offset',0),(478776,13300,'et','Kulude vastaskonto',0),(478777,13300,'si','StroÅ¡kovno odmik',0),(478778,13300,'ba','Biaya Offset',0),(478779,13300,'nl','Kosten Offset',0),(478780,13300,'fi','Kustannusten poikkeama',0),(478781,13300,'no','Kostnader forskyvning',0),(478782,13300,'da','Omkostninger forskydning',0),(478783,13300,'ko','ë¹„ìš©ëœ ì˜¤í”„ì…‹',0),(478784,13300,'he','×§×™×–×•×– ×¢×œ×•×ª',0),(478785,13300,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Offset',0),(478786,13300,'zh','æˆæœ¬çš„åç§»é‡',0),(478787,13300,'sv','Kostnad Offset',0),(478788,13300,'it','Costo Offset',0),(478789,13300,'tl','',0),(478790,13300,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸­à¸­à¸Ÿà¹€à¸‹à¹‡à¸•',0),(478791,13300,'hi','à¤²à¤¾à¤—à¤¤ à¤‘à¤«à¤¸à¥‡à¤Ÿ',0),(478792,13300,'ms','Mengimbangi kos',0),(478793,13300,'ar','Ø¥Ø²Ø§Ø­Ø© Ø§Ù„ØªÙƒÙ„ÙØ©',0),(478794,13300,'fr','CoÃ»t Offset',0),(478795,13300,'jp','è²»ç”¨ã®ã‚ªãƒ•ã‚»ãƒƒãƒˆ',0),(478796,13300,'pt','Custo de deslocamento',0),(478797,13300,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÑÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ',0),(478798,13300,'es','Offset de Costo',0),(478799,13300,'de','Kosten Offset',0),(478800,13300,'en','Cost Offset',0),(478801,13301,'is','',0),(478802,13301,'dr','Ù‡ÛŒÚ† ØªÙ†Ø¸ÛŒÙ… Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„',0),(478803,13301,'pr','Ù‡ÛŒÚ† ØªÙ†Ø¸ÛŒÙ… Ø­Ø³Ø§Ø¨ Ø¯ÙØªØ± Ú©Ù„',0),(478804,13301,'tr','GL hesabÄ± ayarlanmadÄ±',0),(478805,13301,'pl','Zestaw konto nie GL',0),(478806,13301,'bg','ÐÑÐ¼Ð° Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(478807,13301,'ur','Ú©ÙˆØ¦ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(478808,13301,'sr','ÐÐµÐ¼Ð° Ð¡ÐµÑ‚ ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð›',0),(478809,13301,'vi','khÃ´ng táº­p há»£p tÃ i khoáº£n sá»• cÃ¡i',0),(478810,13301,'af','Geen GL rekening stel',0),(478811,13301,'ro','Nici un Set de GL de cont',0),(478812,13301,'et','No GL komplekt',0),(478813,13301,'si','Ni nastavljenega raÄun GL',0),(478814,13301,'ba','No GL Account Set',0),(478815,13301,'nl','Geen GL Account Set',0),(478816,13301,'fi','Ei GL mÃ¤Ã¤ritetty',0),(478817,13301,'no','Ingen GL-konto satt',0),(478818,13301,'da','Ingen GL konto sÃ¦t',0),(478819,13301,'ko','GL ê³„ì • ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(478820,13301,'he','×œ× ×”×•×’×“×¨×• ×—×©×‘×•×Ÿ GL',0),(478821,13301,'el','ÎšÎ±Î½Î­Î½Î± ÏƒÏÎ½Î¿Î»Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ GL',0),(478822,13301,'zh','æ²¡æœ‰è®¾ç½®æ€»å¸å¸æˆ·',0),(478823,13301,'sv','Ingen GL konto Set',0),(478824,13301,'it','Nessun Set di Account GL',0),(478825,13301,'tl','',0),(478826,13301,'th','à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(478827,13301,'hi','à¤•à¥‹à¤ˆ GL à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿ',0),(478828,13301,'ms','Tiada Set akaun GL',0),(478829,13301,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø­Ø³Ø§Ø¨ GL',0),(478830,13301,'fr','Aucun ensemble de compte GL',0),(478831,13301,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(478832,13301,'pt','Nenhum conjunto de conta GL',0),(478833,13301,'ru','ÐÐ°Ð±Ð¾Ñ€ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ GL',0),(478834,13301,'es','No Cuenta LM Configurada',0),(478835,13301,'de','Kein GL Konto festgelegt',0),(478836,13301,'en','No GL Account Set',0),(478837,13302,'is','',0),(478838,13302,'dr','... Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(478839,13302,'pr','Ù‡ÛŒÚ† Ø±Ø³ÛŒØ¯ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ†... Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(478840,13302,'tr','HiÃ§bir giriÅŸ iÃ§in bu PO bulundu',0),(478841,13302,'pl','Potwierdzenia nie znaleziono PO tym',0),(478842,13302,'bg','ÐÑÐ¼Ð° Ð¿Ð¾ÑÑ‚ÑŠÐ¿Ð»ÐµÐ½Ð¸Ñ, Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ PO',0),(478843,13302,'ur','Ø§Ø³ Ù¾ÙˆØ³Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù„Ø§ Ú©ÙˆØ¦ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº',0),(478844,13302,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ Ð·Ð° Ð¾Ð²Ð°Ñ˜ ÐŸÐž',0),(478845,13302,'vi','khÃ´ng tÃ¬m tháº¥y phiáº¿u thu cho Ä‘Æ¡n hÃ ng nÃ y',0),(478846,13302,'af','Geen kwitansies vir hierdie PO gevind',0),(478847,13302,'ro','Nici Ã®ncasÄƒrile gÄƒsit pentru acest PO',0),(478848,13302,'et','Ei ole Ã¼htegi sissetulekut ei leitud selles PO',0),(478849,13302,'si','Ne prejemke za to PO',0),(478850,13302,'ba','Tidak ada bukti yang ditemukan untuk PO ini',0),(478851,13302,'nl','Geen gevonden voor deze PO ontvangsten',0),(478852,13302,'fi','Ei ole vastaanottoja lÃ¶ytyi tÃ¤mÃ¤ PO',0),(478853,13302,'no','Ingen mottak funnet For denne PO',0),(478854,13302,'da','Ingen kvitteringer fundet For denne PO',0),(478855,13302,'ko','ì´ í¬ì— ëŒ€ í•œ ë°œê²¬ ì•„ë¬´ ì˜ìˆ˜ì¦',0),(478856,13302,'he','××™×Ÿ ×§×‘×œ×•×ª ×©× ×ž×¦××• ×¢×‘×•×¨ ×¤×• ×”×–×”',0),(478857,13302,'el','Î”ÎµÎ½ Î±Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï€Î¿',0),(478858,13302,'zh','æ²¡æœ‰å‘çŽ°æ­¤ po è®¢å•çš„æ”¶è´§',0),(478859,13302,'sv','Inga kvitton finns fÃ¶r denna PO',0),(478860,13302,'it','Nessun entrate trovate per questo PO',0),(478861,13302,'tl','',0),(478862,13302,'th','à¸£à¸±à¸šà¹„à¸¡à¹ˆà¸žà¸šà¸ªà¸³à¸«à¸£à¸±à¸š PO à¸™à¸µà¹‰',0),(478863,13302,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤ªà¥‹ à¤ªà¤¾à¤¯à¤¾',0),(478864,13302,'ms','Tiada resit yang ditemui untuk PO ini',0),(478865,13302,'ar','Ù„Ø§ Ø¥ÙŠØµØ§Ù„Ø§Øª ØªØ¨ÙŠÙ† Ù„Ù‡Ø°Ø§ Ø¨Ùˆ',0),(478866,13302,'fr','Aucun reÃ§u trouvÃ© pour ce PO',0),(478867,13302,'jp','ã“ã® PO ã‚’è¦‹ã¤ã‘ãŸãªã„é ˜åŽæ›¸',0),(478868,13302,'pt','HÃ¡ recibos encontrados para esta PO',0),(478869,13302,'ru','Ð‘ÐµÐ· Ñ€Ð°ÑÐ¿Ð¸ÑÐ¾Ðº, Ð½Ð°ÑˆÐ»Ð¸ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ PO',0),(478870,13302,'es','No Recibos Encontrados Para Este OC',0),(478871,13302,'de','Keine Belege fÃ¼r diese PO gefunden',0),(478872,13302,'en','No Receipts Found For This PO',0),(478873,13303,'is','',0),(478874,13303,'dr','  ÛŒØ§ ÛŒÚ© ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ùˆ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆØ¯',0),(478875,13303,'pr','  ÛŒØ§ ÛŒÚ© ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ùˆ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆØ¯',0),(478876,13303,'tr','Ya da Bill ve PO seÃ§ilmelidir',0),(478877,13303,'pl','Czy Bill i PO musi byÄ‡ zaznaczone',0),(478878,13303,'bg','Ð˜Ð»Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ° Ð¸ PO Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½',0),(478879,13303,'ur','ÛŒØ§ Ø§ÛŒÚ© Ø¨Ù„ Ø§ÙˆØ± Ù¾Ùˆ Ù…Ù†ØªØ®Ø¨ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(478880,13303,'sr','Ð˜Ð»Ð¸ Ð‘Ð¸Ð» Ð¸ Ð¿Ð¾-Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½',0),(478881,13303,'vi','hay hÃ³a Ä‘Æ¡n vÃ  Ä‘Æ¡n mua hÃ ng pháº£i Ä‘Æ°á»£c chá»n',0),(478882,13303,'af','Of \'n Wetsontwerp en PO moet gekies word',0),(478883,13303,'ro','Sau un proiect de lege ÅŸi PO trebuie sÄƒ fie selectate',0),(478884,13303,'et','VÃµi valitud arve ja PO',0),(478885,13303,'si','Ali mora biti izbrana zakona in PO',0),(478886,13303,'ba','Atau tagihan dan PO harus dipilih',0),(478887,13303,'nl','Of een Bill en PO moet zijn ingeschakeld',0),(478888,13303,'fi','Tai Bill ja PO on valittuna',0),(478889,13303,'no','Eller en Bill og PO velges',0),(478890,13303,'da','Eller en Bill og PO skal vÃ¦lges',0),(478891,13303,'ko','ë¹Œê³¼ í¬ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤ ë˜ëŠ”',0),(478892,13303,'he','××• ×œ×”×™×•×ª ×ž×¡×•×ž× ×ª, ×‘×™×œ ×• ×¤×•',0),(478893,13303,'el','Î‰ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ Î­Î½Î± Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ ÎºÎ±Î¹ PO',0),(478894,13303,'zh','æˆ–æ¯”å°”å’Œå¤§åŸ”ï¼Œå¿…é¡»é€‰æ‹©',0),(478895,13303,'sv','Eller en Bill och PO mÃ¥ste vÃ¤ljas',0),(478896,13303,'it','O un Bill e PO deve essere selezionati',0),(478897,13303,'tl','',0),(478898,13303,'th','à¸«à¸£à¸·à¸­à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸•à¸±à¹‹à¸§à¹à¸¥à¸° PO',0),(478899,13303,'hi','à¤¯à¤¾ à¤à¤• à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤”à¤° à¤ªà¥‹ à¤šà¤¯à¤¨à¤¿à¤¤ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(478900,13303,'ms','Atau Rang undang-undang dan PO perlu dipilih',0),(478901,13303,'ar','Ø£Ùˆ ÙŠØ¬Ø¨ ØªØ­Ø¯ÙŠØ¯ Ø¨ÙŠÙ„ ÙˆØ¨Ùˆ',0),(478902,13303,'fr','Ou un projet de loi et PO doivent Ãªtre sÃ©lectionnÃ©s',0),(478903,13303,'jp','ãƒ“ãƒ«ã¨ PO ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã‹',0),(478904,13303,'pt','Ou um Bill e PO devem ser selecionados',0),(478905,13303,'ru','Ð˜Ð»Ð¸ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½ Ð‘Ð¸Ð»Ð»Ð° Ð¸ PO',0),(478906,13303,'es','O Un Recibo y OC Debe Ser Seleccionados',0),(478907,13303,'de','Oder eine Rechnung und PO gewÃ¤hlt werden',0),(478908,13303,'en','Or A Bill And PO Must Be Selected',0),(478909,13304,'is','',0),(478910,13304,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ Ú©Ø§Ù„Ø§Ù‡Ø§ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯Ø§Ú¯Ø± ÛŒÚ© Ù‚ÛŒÙ…Øª ØªÙ†Ø¸ÛŒÙ… Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ø¯',0),(478911,13304,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ Ú©Ø§Ù„Ø§Ù‡Ø§ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯Ø§Ú¯Ø± ÛŒÚ© Ù‚ÛŒÙ…Øª ØªÙ†Ø¸ÛŒÙ… Ø´Ø¯Ù‡ Ø¨Ø§Ø´Ø¯',0),(478912,13304,'tr','Bir maliyet ayarlanmÄ±ÅŸsa, etkilenen Ã¶ÄŸelerin sayÄ±sÄ±nÄ± girmeniz gerekir.',0),(478913,13304,'pl','NaleÅ¼y wprowadziÄ‡ liczbÄ™ elementÃ³w wpÅ‚yw, jeÅ›li koszt jest zestaw.',0),(478914,13304,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð±Ñ€Ð¾Ñ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸Ñ‚Ðµ, Ð°ÐºÐ¾ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¾.',0),(478915,13304,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù‚ÛŒÙ…Øª Ù…Ù‚Ø±Ø± Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Ø§Ú¯Ø± Ù…ØªØ§Ø«Ø±Û Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(478916,13304,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð±Ñ€Ð¾Ñ˜ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ð¾Ð³Ð¾Ñ’ÐµÐ½Ð° Ð°ÐºÐ¾ Ñ˜Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¿Ð¾Ð´ÐµÑˆÐµÐ½.',0),(478917,13304,'vi','Báº¡n pháº£i nháº­p sá»‘ lÆ°á»£ng cÃ¡c máº·t hÃ ng bá»‹ áº£nh hÆ°á»Ÿng náº¿u chi phÃ­ Ä‘Æ°á»£c thiáº¿t láº­p.',0),(478918,13304,'af','Jy moet die aantal items geraak as \'n koste is stel intik.',0),(478919,13304,'ro','IntroduceÅ£i numÄƒrul de articole afectate Ã®n cazul Ã®n care este stabilit un cost.',0),(478920,13304,'et','Peate sisestama Ã¼ksuste kui kulu on seatud arv.',0),(478921,13304,'si','Vnesite Å¡tevilo artiklov, ki so prizadeti, Äe je stroÅ¡ek.',0),(478922,13304,'ba','Anda harus memasukkan jumlah item yang terpengaruh jika biaya diatur.',0),(478923,13304,'nl','U moet het aantal items beÃ¯nvloed als een kosten is ingesteld.',0),(478924,13304,'fi','Kirjoita kappalemÃ¤Ã¤rÃ¤, jos kustannus on mÃ¤Ã¤ritetty.',0),(478925,13304,'no','Du mÃ¥ angi antall elementer pÃ¥virket hvis en kostnad er angitt.',0),(478926,13304,'da','Du skal angive antallet af emner berÃ¸rt, hvis omkostninger ligger.',0),(478927,13304,'ko','ë¹„ìš©ì„ ì„¤ì • í•˜ëŠ” ê²½ìš° ì˜í–¥ì„ ë°›ëŠ” í•­ëª©ì˜ ìˆ˜ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(478928,13304,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ××ª ×ž×¡×¤×¨ ×”×¤×¨×™×˜×™× ×ž×•×©×¤×¢×•×ª ×× ×¢×œ×•×ª ×ž×•×’×“×¨×ª.',0),(478929,13304,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Ï‰Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Ï€Î¿Ï… ÎµÏ€Î·ÏÎµÎ¬Î¶Î¿Î½Ï„Î±Î¹, Î±Î½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Î­Î½Î± ÎºÏŒÏƒÏ„Î¿Ï‚.',0),(478930,13304,'zh','æ‚¨å¿…é¡»è¾“å…¥å½±å“å¦‚æžœæˆæœ¬è®¾ç½®çš„é¡¹çš„æ•°ç›®ã€‚',0),(478931,13304,'sv','Du mÃ¥ste ange antalet artiklar som pÃ¥verkas om en kostnad Ã¤r instÃ¤lld.',0),(478932,13304,'it','Ãˆ necessario immettere il numero di elementi interessati se Ã¨ impostato un costo.',0),(478933,13304,'tl','',0),(478934,13304,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸‚à¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸œà¸¥à¸à¸£à¸°à¸—à¸šà¸–à¹‰à¸²à¸¡à¸µà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸•à¹‰à¸™à¸—à¸¸à¸™',0),(478935,13304,'hi','à¤¤à¥à¤® à¤à¤• à¤²à¤¾à¤—à¤¤ à¤ªà¤° à¤¸à¥‡à¤Ÿ à¤¹à¥ˆ à¤¯à¤¦à¤¿ à¤ªà¥à¤°à¤­à¤¾à¤µà¤¿à¤¤ à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(478936,13304,'ms','Anda mesti masukkan bilangan item yang terjejas jika kos yang ditetapkan.',0),(478937,13304,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…ØªØ£Ø«Ø±Ø© Ø¥Ø°Ø§ ØªÙ… ØªØ¹ÙŠÙŠÙ† ØªÙƒÙ„ÙØ©.',0),(478938,13304,'fr','Vous devez entrer le nombre d\'Ã©lÃ©ments affectÃ©s si un coÃ»t est dÃ©fini.',0),(478939,13304,'jp','ã‚³ã‚¹ãƒˆã‚’è¨­å®šã—ãŸå ´åˆã®å½±éŸ¿ã‚’å—ã‘ãŸé …ç›®ã®æ•°ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(478940,13304,'pt','VocÃª deve digitar o nÃºmero de itens afetados se um custo Ã© definido.',0),(478941,13304,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð², ÐµÑÐ»Ð¸ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÑƒÑÑ‚Ð°Ð½Ð°Ð²Ð»Ð¸Ð²Ð°ÐµÑ‚ÑÑ.',0),(478942,13304,'es','Debe Entrar el NÃºmero de Items afectados si un costo esta configurado',0),(478943,13304,'de','Sie mÃ¼ssen eingeben, die Anzahl der Elemente betroffen, wenn ein Preis gesetzt ist.',0),(478944,13304,'en','You must enter the number of items affected if a cost is set.',0),(478945,13305,'is','',0),(478946,13305,'dr','(Ø³Ù‡Ø§Ù…',0),(478947,13305,'pr','Ù‡Ù…Ú†Ù†ÛŒÙ† Ù†Ù…Ø§ÛŒØ´ ÙØ±Ù… Ø§Ù†Ø¨Ø§Ø±(Ø³Ù‡Ø§Ù…',0),(478948,13305,'tr','AyrÄ±ca gÃ¶rÃ¼nÃ¼mÃ¼ stoktan',0),(478949,13305,'pl','Zobacz rÃ³wnieÅ¼ czas od',0),(478950,13305,'bg','Ð¡ÑŠÑ‰Ð¾ Ñ‚Ð°ÐºÐ° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ ÑÑŠÑÑ‚Ð°Ð² Ð¾Ñ‚',0),(478951,13305,'ur','Ø§Ø³Ù¹Ø§Ú© Ø³Û’ Ø¨Ú¾ÛŒ Ø¯ÛŒÚ©Ú¾',0),(478952,13305,'sr','Ð¢Ð°ÐºÐ¾Ñ’Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð¸Ð·',0),(478953,13305,'vi','CÅ©ng xem tá»« kho',0),(478954,13305,'af','Bekyk ook voorraad van',0),(478955,13305,'ro','Vezi, de asemenea, stoc de',0),(478956,13305,'et','Ka vaade varu:',0),(478957,13305,'si','Tudi ogled parka od',0),(478958,13305,'ba','Juga lihat saham dari',0),(478959,13305,'nl','Ook bekijken voorraad van',0),(478960,13305,'fi','MyÃ¶s tarkastella kannan',0),(478961,13305,'no','Vise lager fra',0),(478962,13305,'da','OgsÃ¥ se bestand fra',0),(478963,13305,'ko','ì‚¬ì§„ ë³´ê¸°',0),(478964,13305,'he','×’× ×œ×”×¦×™×’ ×ž× ×™×•×ª ×ž',0),(478965,13305,'el','Î”ÎµÎ¯Ï„Îµ ÎµÏ€Î¯ÏƒÎ·Ï‚ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î±Ï€ÏŒ',0),(478966,13305,'zh','æ­¤å¤–å¯ä»¥æŸ¥çœ‹ä»Žè‚¡ç¥¨',0),(478967,13305,'sv','OcksÃ¥ Visa lager frÃ¥n',0),(478968,13305,'it','Mostra anche Stock da',0),(478969,13305,'tl','',0),(478970,13305,'th','à¸”à¸¹à¸ªà¸•à¹‡à¸­à¸',0),(478971,13305,'hi','à¤¶à¥‡à¤¯à¤° à¤¸à¥‡ à¤­à¥€ à¤¦à¥‡à¤–à¥‡à¤‚',0),(478972,13305,'ms','Juga lihat saham dari',0),(478973,13305,'ar','ÙƒÙ…Ø§ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ù‡Ù… Ù…Ù†',0),(478974,13305,'fr','DÃ©couvre aussi Stock de',0),(478975,13305,'jp','ã¾ãŸã‹ã‚‰ã®åœ¨åº«ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(478976,13305,'pt','TambÃ©m visualizar o estoque de',0),(478977,13305,'ru','Ð¢Ð°ÐºÐ¶Ðµ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð¸Ð·',0),(478978,13305,'es','TambiÃ©n Vistar Stock De',0),(478979,13305,'de','Sehen Sie auch ab Lager',0),(478980,13305,'en','Also View Stock From',0),(478981,13306,'is','',0),(478982,13306,'dr','Ú†Ø§Ù¾ Ø¨Ø§Ø±Ú©Ø¯',0),(478983,13306,'pr','Ú†Ø§Ù¾ Ø¨Ø§Ø±Ú©Ø¯',0),(478984,13306,'tr','Barkod yazdÄ±rma',0),(478985,13306,'pl','Drukowanie kodÃ³w kreskowych',0),(478986,13306,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð±Ð°Ñ€ÐºÐ¾Ð´',0),(478987,13306,'ur','Ø¨Ø§Ø±Ú©ÙˆÚˆ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(478988,13306,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð°',0),(478989,13306,'vi','in thanh báº£ng mÃ£',0),(478990,13306,'af','Druk strepieskode',0),(478991,13306,'ro','Imprima coduri de bare',0),(478992,13306,'et','Prindi vÃ¶Ã¶tkoodi',0),(478993,13306,'si','Tiskanje Ärtne kode',0),(478994,13306,'ba','Mencetak Barcode',0),(478995,13306,'nl','Barcode afdrukken',0),(478996,13306,'fi','Tulostaa viivakoodi',0),(478997,13306,'no','Skrive ut strekkoder',0),(478998,13306,'da','Udskrive stregkode',0),(478999,13306,'ko','ë°”ì½”ë“œ ì¸ì‡„',0),(479000,13306,'he','×”×“×¤×¡ ×‘×¨×§×•×“',0),(479001,13306,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î³ÏÎ±Î¼Î¼Î¹ÎºÎ¿Ï ÎºÏŽÎ´Î¹ÎºÎ±',0),(479002,13306,'zh','æ‰“å°æ¡ç ',0),(479003,13306,'sv','Skriva ut streckkoder',0),(479004,13306,'it','Stampa codici a barre',0),(479005,13306,'tl','',0),(479006,13306,'th','à¸žà¸´à¸¡à¸žà¹Œà¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”',0),(479007,13306,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(479008,13306,'ms','Cetak Kod Bar',0),(479009,13306,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø¨Ø§Ø±ÙƒÙˆØ¯',0),(479010,13306,'fr','Imprimer des codes Ã  barres',0),(479011,13306,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(479012,13306,'pt','ImpressÃ£o de cÃ³digo de barras',0),(479013,13306,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´Ð¾Ð²',0),(479014,13306,'es','Imprime Un CÃ³digo de Barras',0),(479015,13306,'de','Barcode drucken',0),(479016,13306,'en','Print Barcode',0),(479017,13307,'is','',0),(479018,13307,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯ Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§ÛŒÙ† Ø³ÙØ§Ø±Ø´ Ø±Ø§ Ø¨Ù‡ ÛŒÚ©  Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ ØªØ¨Ø¯ÛŒÙ„ Ú©Ù†ÛŒØ¯ØŸ',0),(479019,13307,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯ Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§ÛŒÙ† Ø³ÙØ§Ø±Ø´ Ø±Ø§ Ø¨Ù‡ ÛŒÚ©  Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ ØªØ¨Ø¯ÛŒÙ„ Ú©Ù†ÛŒØ¯ØŸ',0),(479020,13307,'tr','Bu sÄ±rada bir teklife dÃ¶nÃ¼ÅŸtÃ¼rmek istediÄŸinizden emin misiniz?',0),(479021,13307,'pl','Czy na pewno chcesz przekonwertowaÄ‡ Zakon ten cytat?',0),(479022,13307,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÐºÑŠÐ¼ Ð¾Ñ„ÐµÑ€Ñ‚Ð°?',0),(479023,13307,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§ÛŒÚ© Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Ùˆ Ø§Ø³ ØªØ±ØªÛŒØ¨ Ù…ÛŒÚº ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(479024,13307,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚ÑƒÑ˜ÐµÑ‚Ðµ Ð¾Ð²Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð°?',0),(479025,13307,'vi','Chuyá»ƒn lá»‡nh thÃ nh bÃ¡o giÃ¡?',0),(479026,13307,'af','Is jy seker jy wil hierdie orde omskep \'n kwotasie?',0),(479027,13307,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ se converteascÄƒ aceastÄƒ comandÄƒ de la un citat?',0),(479028,13307,'et','Kas kindlasti teisendada selle tellimuse pakkumise?',0),(479029,13307,'si','Ali ste prepriÄani, da Å¾elite pretvoriti ta nalog v citat?',0),(479030,13307,'ba','Apakah Anda yakin Anda ingin mengkonversi urutan ini mengutip?',0),(479031,13307,'nl','Weet u zeker dat u wilt converteren van deze bestelling aan een offerte?',0),(479032,13307,'fi','Oletko varma, ettÃ¤ haluat muuntaa tÃ¤mÃ¤n tilauksen tarjoukseen?',0),(479033,13307,'no','Er du sikker pÃ¥ at du vil konvertere denne rekkefÃ¸lgen til et tilbud?',0),(479034,13307,'da','Er du sikker pÃ¥, du vil konvertere denne ordre til et tilbud?',0),(479035,13307,'ko','ë‹¹ì‹ ì€ ê²¬ì ì—ì´ ìˆœì„œë¥¼ ë³€í™˜ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(479036,13307,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×”×ž×™×¨ ×¦×• ×–×” ×”×¦×¢×ª ×ž×—×™×¨?',0),(479037,13307,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î¼ÎµÏ„Î±Ï„ÏÎ­ÏˆÎµÏ„Îµ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬ ÏƒÎµ Î¼Î¹Î± Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬;',0),(479038,13307,'zh','ä½ ç¡®å®šä½ æƒ³è¦è¿™é¡¹å‘½ä»¤è½¬æ¢ä¸ºæŠ¥ä»·å•ï¼Ÿ',0),(479039,13307,'sv','Ã„r du sÃ¤ker du vill konvertera denna ordning till en offert?',0),(479040,13307,'it','Sei sicuro di che voler convertire questo ordine in una citazione?',0),(479041,13307,'tl','',0),(479042,13307,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹à¸›à¸¥à¸‡à¹€à¸›à¹‡à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸™à¸µà¹‰à¹€à¸ªà¸™à¸­à¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(479043,13307,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤‡à¤¸ à¤•à¥à¤°à¤® à¤®à¥‡à¤‚ à¤à¤• à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(479044,13307,'ms','Adakah anda pasti anda mahu menukar Perintah ini kepada sebut harga?',0),(479045,13307,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ ØªØ­ÙˆÙŠÙ„ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù… Ø¥Ù„Ù‰ Ø¹Ø±Ø¶ Ø£Ø³Ø¹Ø§Ø±ØŸ',0),(479046,13307,'fr','ÃŠtes-vous sÃ»r de que vouloir convertir cette commande Ã  une citation ?',0),(479047,13307,'jp','ã“ã®é †åºã€è¦‹ç©ã‚‚ã‚Šã«å¤‰æ›ã™ã‚‹ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(479048,13307,'pt','Tens a certeza de que vocÃª deseja converter esta ordem para uma citaÃ§Ã£o?',0),(479049,13307,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð² Ñ†Ð¸Ñ‚Ð°Ñ‚Ñƒ?',0),(479050,13307,'es','Â¿Esta seguro que quiere convertir este Pedido a una cotizaciÃ³n?',0),(479051,13307,'de','Sind Sie sicher, dass Sie diese Bestellung auf ein Angebot umwandeln mÃ¶chten?',0),(479052,13307,'en','Are you sure you want to convert this order to a quote?',0),(479053,13308,'is','',0),(479054,13308,'dr','ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡  Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ',0),(479055,13308,'pr','ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡  Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ',0),(479056,13308,'tr','Teklife dÃ¶nÃ¼ÅŸtÃ¼rÃ¼n',0),(479057,13308,'pl','PrzekonwertowaÄ‡ ofertÄ™',0),(479058,13308,'bg','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(479059,13308,'ur','Ú©Û’ Ø§Ù‚ØªØ¨Ø§Ø³ Ù…ÛŒÚº Ø¨Ø¯Ù„ÛŒÚº',0),(479060,13308,'sr','ÐŸÑ€ÐµÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð°',0),(479061,13308,'vi','chuyá»ƒn sang bÃ¡o giÃ¡',0),(479062,13308,'af','Omskep na aanhaling',0),(479063,13308,'ro','Conversia la citat',0),(479064,13308,'et','Teisenda tsitaat',0),(479065,13308,'si','Pretvori citat',0),(479066,13308,'ba','Mengkonversi ke kutipan',0),(479067,13308,'nl','Converteren naar offerte',0),(479068,13308,'fi','Muunna tarjous',0),(479069,13308,'no','Konvertere til tilbud',0),(479070,13308,'da','Konvertere til citat',0),(479071,13308,'ko','ê²¬ì ì„ ë³€í™˜',0),(479072,13308,'he','×”×ž×¨ ×”×¦×¢×ª ×ž×—×™×¨',0),(479073,13308,'el','ÎœÎµÏ„Î±Ï„ÏÎ¿Ï€Î® ÏƒÎµ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(479074,13308,'zh','è½¬æ¢æŠ¥ä»·å•',0),(479075,13308,'sv','Konvertera till citat',0),(479076,13308,'it','Convertire in citazione',0),(479077,13308,'tl','',0),(479078,13308,'th','à¹à¸›à¸¥à¸‡à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(479079,13308,'hi','à¤‰à¤¦à¥à¤§à¥ƒà¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(479080,13308,'ms','Menukar kepada sebut harga',0),(479081,13308,'ar','ØªØ­ÙˆÙŠÙ„ Ø¥Ù„Ù‰ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(479082,13308,'fr','Convertir en citation',0),(479083,13308,'jp','è¦‹ç©ã‚‚ã‚Šã¸ã®å¤‰æ›ã—ã¾ã™ã€‚',0),(479084,13308,'pt','Converter para citaÃ§Ã£o',0),(479085,13308,'ru','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ Ð² Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(479086,13308,'es','Convertir a Cotizar',0),(479087,13308,'de','Zitat von konvertieren',0),(479088,13308,'en','Convert To Quote',0),(479089,13309,'is','',0),(479090,13309,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©',0),(479091,13309,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©',0),(479092,13309,'tr','VarsayÄ±lan banka hesabÄ±',0),(479093,13309,'pl','DomyÅ›lne konto',0),(479094,13309,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°',0),(479095,13309,'ur','Ø¨Ù†ÛŒØ§Ø¯ÛŒ Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(479096,13309,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(479097,13309,'vi','TÃ i khoáº£n ngÃ¢n hÃ ng máº·c Ä‘á»‹nh',0),(479098,13309,'af','Verstek bankrekening',0),(479099,13309,'ro','Cont bancar implicit',0),(479100,13309,'et','Vaikimisi pangakonto',0),(479101,13309,'si','Privzeto banÄnega raÄuna',0),(479102,13309,'ba','Rekening Bank standar',0),(479103,13309,'nl','Standaard bankrekening',0),(479104,13309,'fi','Oletuspankkitili',0),(479105,13309,'no','Standard bankkonto',0),(479106,13309,'da','Standard Bank konto',0),(479107,13309,'ko','ê¸°ë³¸ ì€í–‰ ê³„ì¢Œ',0),(479108,13309,'he','×—×©×‘×•×Ÿ ×”×‘× ×§ ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(479109,13309,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(479110,13309,'zh','é»˜è®¤é“¶è¡Œå¸æˆ·',0),(479111,13309,'sv','Standard Bank konto',0),(479112,13309,'it','Conto bancario predefinito',0),(479113,13309,'tl','',0),(479114,13309,'th','à¸šà¸±à¸à¸Šà¸µ à¸˜à¸™à¸²à¸„à¸²à¸£à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(479115,13309,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾',0),(479116,13309,'ms','Akaun Bank lalai',0),(479117,13309,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(479118,13309,'fr','Compte bancaire par dÃ©faut',0),(479119,13309,'jp','æ—¢å®šã®éŠ€è¡Œå£åº§',0),(479120,13309,'pt','Conta bancÃ¡ria padrÃ£o',0),(479121,13309,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ ÑÑ‡ÐµÑ‚',0),(479122,13309,'es','Cuenta Bancaria por Defecto',0),(479123,13309,'de','Standard Bank-Konto',0),(479124,13309,'en','Default Bank Account',0),(479125,13310,'is','',0),(479126,13310,'dr','(Ù¾ÙˆØ´Ø´)ÙˆÙ‚ØªÛŒ Ø³ÛŒØ§Ù‡ Ø¯Ø§Ø®Ù„ Ùˆ Ø®Ø§Ø±Ø¬',0),(479127,13310,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø± Ú©Ø§ÙˆØ±(Ù¾ÙˆØ´Ø´)ÙˆÙ‚ØªÛŒ Ø³ÛŒØ§Ù‡ Ø¯Ø§Ø®Ù„ Ùˆ Ø®Ø§Ø±Ø¬',0),(479128,13310,'tr','Kapak siyah iÃ§inde & dÄ±ÅŸarÄ± zaman baÅŸÄ± maliyet',0),(479129,13310,'pl','Koszt pokrywa kiedy czarny w & siÄ™',0),(479130,13310,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° ÐºÐ¾Ñ€Ð¸Ñ†Ð°Ñ‚Ð°, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ñ‡ÐµÑ€Ð½Ð¾ Ð² &,',0),(479131,13310,'ur','Ø¬Ø¨ Ù…ÛŒÚº & Ø¨Ø§ÛØ± Ø³ÛŒØ§Û ØºÙ„Ø§Ù ÙÛŒ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ',0),(479132,13310,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ ÐºÐ¾Ñ€Ð¸Ñ†Ð°Ð¼Ð° ÐºÐ°Ð´Ð° Ñ†Ñ€Ð½Ð¸ Ñƒ & Ð½Ð°Ð¿Ð¾Ñ™Ðµ',0),(479133,13310,'vi','giÃ¡ má»—i vá» khi Ä‘en trong vÃ  ngoÃ i',0),(479134,13310,'af','Koste Per dekking wanneer swart In & uit',0),(479135,13310,'ro','Costul pe coperta cÃ¢nd negru Ã®n & afarÄƒ',0),(479136,13310,'et','Pealt katta kui Black & lÃ¤bi',0),(479137,13310,'si','StroÅ¡ki na pokrov ko Ärna v & ven',0),(479138,13310,'ba','Biaya tutup ketika hitam di & keluar',0),(479139,13310,'nl','Kosten Per Cover wanneer zwarte In & uit',0),(479140,13310,'fi','Hinta Per kansi kun musta & ulos',0),(479141,13310,'no','Kostnad Per Cover nÃ¥r svarte i & ut',0),(479142,13310,'da','Omkostning pr. dÃ¦kke nÃ¥r sort i & ud',0),(479143,13310,'ko','ì»¤ë²„ ë•Œ & ë°–ìœ¼ë¡œ ê²€ì€ ë‹¹ ë¹„ìš©',0),(479144,13310,'he','×¢×œ×•×ª ×”×›×™×¡×•×™ ×›××©×¨ ×©×—×•×¨ ×‘- &.',0),(479145,13310,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ ÎºÎ¬Î»Ï…ÏˆÎ· ÏŒÏ„Î±Î½ Î¼Î±ÏÏÎ¿ ÏƒÎµ & Î­Î¾Ï‰',0),(479146,13310,'zh','æ¯ä¸ªç›–å½“é»‘äººåœ¨ &amp; å‡ºçš„æˆæœ¬',0),(479147,13310,'sv','Kostnad Per locket nÃ¤r svart i & ut',0),(479148,13310,'it','Costo Per copertura quando nero In & fuori',0),(479149,13310,'tl','',0),(479150,13310,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸•à¹ˆà¸­à¹ƒà¸šà¸›à¸°à¸«à¸™à¹‰à¸²à¹€à¸¡à¸·à¹ˆà¸­à¸”à¸³à¹ƒà¸™ & à¸­à¸­à¸',0),(479151,13310,'hi','à¤œà¤¬ à¤®à¥‡à¤‚ & à¤¬à¤¾à¤¹à¤° à¤•à¤¾à¤²à¥‡ à¤†à¤µà¤°à¤£ à¤ªà¥à¤°à¤¤à¤¿ à¤²à¤¾à¤—à¤¤',0),(479152,13310,'ms','Kos satu kulit hitam di & Keluar',0),(479153,13310,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„ØºØ·Ø§Ø¡ Ø¹Ù†Ø¯ Ø§Ù„Ø³ÙˆØ¯ ÙÙŠ Ø¢Ù†Ø¯ Ø®Ø§Ø±Ø¬',0),(479154,13310,'fr','CoÃ»t par couverture lorsque noir en & sur',0),(479155,13310,'jp','ã¨ãã« & ã†ã¡é»’ã„ã‚«ãƒãƒ¼ã‚ãŸã‚Šã®è²»ç”¨',0),(479156,13310,'pt','Custo por cobertura quando preto em & fora',0),(479157,13310,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ð¾ÐºÑ€Ñ‹Ñ‚Ð¸Ñ, ÐºÐ¾Ð³Ð´Ð° Ñ‡ÐµÑ€Ð½Ñ‹Ð¹ Ð² & Ð¸Ð·',0),(479158,13310,'es','Costo por Tapa Cuando es Negro  Dentro y Fuera',0),(479159,13310,'de','Kosten pro Deckel Schwarz In &,',0),(479160,13310,'en','Cost Per Cover When Black In & Out',0),(479161,13311,'is','',0),(479162,13311,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø± Ú©Ø§ÙˆØ± ÙˆÙ‚ØªÛŒ Ø±Ù†Ú¯ Ø¯Ø§Ø®Ù„  Ø³ÛŒØ§Ù‡ Ø®Ø§Ø±Ø¬',0),(479163,13311,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø± Ú©Ø§ÙˆØ± ÙˆÙ‚ØªÛŒ Ø±Ù†Ú¯ Ø¯Ø§Ø®Ù„  Ø³ÛŒØ§Ù‡ Ø®Ø§Ø±Ø¬',0),(479164,13311,'tr','Kapak maliyet zaman iÃ§inde siyah renk',0),(479165,13311,'pl','Koszt pokrywa Kiedy kolor wewnÄ…trz czarny poza',0),(479166,13311,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° ÐºÐ¾Ñ€Ð¸Ñ†Ð°Ñ‚Ð° ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ñ†Ð²ÑÑ‚ Ð² Ñ‡ÐµÑ€Ð½Ð¾ Ð¸Ð·Ð²ÑŠÐ½',0),(479167,13311,'ur','ØªØ¹Ø§Ø±ÙÛŒ ÙÛŒ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ Ø¬Ø¨ Ø§Ù†Ø¯Ø± Ø¨Ø§ÛØ± Ø³ÛŒØ§Û Ø±Ù†Ú¯',0),(479168,13311,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ ÐºÐ¾Ñ€Ð¸Ñ†Ð°Ð¼Ð° ÐºÐ°Ð´Ð° Ð±Ð¾Ñ˜Ð° Ð¸Ð´Ðµ ÑƒÐ½ÑƒÑ‚Ð°Ñ€ Ñ†Ñ€Ð½Ð¸ Ð½Ð°Ð¿Ð¾Ñ™Ñƒ',0),(479169,13311,'vi','giÃ¡ má»—i vá» khi mÃ u bÃªn trong Ä‘en ngoÃ i',0),(479170,13311,'af','Koste Per dekking wanneer kleur binne swart buite',0),(479171,13311,'ro','Costul pe coperta cÃ¢nd culoare interior negru Ã®n afara',0),(479172,13311,'et','Pealt katta kuna vÃ¤rvi sees must vÃ¤ljaspool',0),(479173,13311,'si','StroÅ¡ki na pokrov ko barva znotraj Ärnega zunaj',0),(479174,13311,'ba','Biaya tutup Kapan warna dalam hitam di luar',0),(479175,13311,'nl','Kosten Per Cover wanneer kleur binnen Black buiten',0),(479176,13311,'fi','Hinta Per kansi kun vÃ¤ri sisÃ¤llÃ¤ musta',0),(479177,13311,'no','Kostnad Per Cover nÃ¥r fargen inne sort utenfor',0),(479178,13311,'da','Omkostning pr. dÃ¦kke nÃ¥r farve inde i sort uden for',0),(479179,13311,'ko','ë®ê°œ ë‹¹ ë¹„ìš© ë•Œ ë‚´ë¶€ ì™¸ë¶€ ë¸”ëž™ ìƒ‰ìƒ',0),(479180,13311,'he','×¢×œ×•×ª ×”×›×™×¡×•×™ ×›××©×¨ ×¦×‘×¢ ×‘×ª×•×š ×©×—×•×¨ ×‘×—×•×¥',0),(479181,13311,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ ÎºÎ¬Î»Ï…ÏˆÎ· ÏŒÏ„Î±Î½ Ï‡ÏÏŽÎ¼Î± Î¼Î­ÏƒÎ± Î¼Î±ÏÏÎ¿ Î­Î¾Ï‰ Î±Ï€ÏŒ',0),(479182,13311,'zh','æ¯å¥—æˆæœ¬å½“é¢œè‰²å¤–é»‘å†…',0),(479183,13311,'sv','Kostnad Per locket nÃ¤r fÃ¤rg inuti svart utanfÃ¶r',0),(479184,13311,'it','Costo Per la copertura di colore quando all\'interno di nero all\'esterno',0),(479185,13311,'tl','',0),(479186,13311,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸•à¹ˆà¸­à¹ƒà¸šà¸›à¸°à¸«à¸™à¹‰à¸²à¹€à¸¡à¸·à¹ˆà¸­à¸ªà¸µà¸ à¸²à¸¢à¹ƒà¸™à¸”à¸³à¸™à¸­à¸',0),(479187,13311,'hi','à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤à¤• à¤•à¤µà¤° à¤œà¤¬ à¤…à¤‚à¤¦à¤° à¤•à¥‡ à¤¬à¤¾à¤¹à¤° à¤•à¤¾à¤²à¤¾ à¤°à¤‚à¤—',0),(479188,13311,'ms','Bayaran perlindungan Bilakah warna di dalam hitam di luar',0),(479189,13311,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„ØªØºØ·ÙŠØ© Ø¹Ù†Ø¯Ù…Ø§ Ø§Ù„Ù„ÙˆÙ† Ø¯Ø§Ø®Ù„ Ø§Ù„Ø£Ø³ÙˆØ¯ Ø®Ø§Ø±Ø¬',0),(479190,13311,'fr','CoÃ»t par couverture quelle couleur intÃ©rieur noir Ã  l\'extÃ©rieur',0),(479191,13311,'jp','ã‚«ãƒãƒ¼ã‚ãŸã‚Šã®è²»ç”¨ã¨ãå¤–å´ã®é»’ã®å†…éƒ¨ã®è‰²',0),(479192,13311,'pt','Custo por cobertura quando cores dentro preto do lado de fora',0),(479193,13311,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ð¾ÐºÑ€Ñ‹Ñ‚Ð¸Ñ ÐºÐ¾Ð³Ð´Ð° Ñ†Ð²ÐµÑ‚ Ð²Ð½ÑƒÑ‚Ñ€Ð¸ Ñ‡ÐµÑ€Ð½Ñ‹Ð¹ ÑÐ½Ð°Ñ€ÑƒÐ¶Ð¸',0),(479194,13311,'es','Costo por Tapa Cuando el Color A Dentro',0),(479195,13311,'de','Kosten pro Gedeck als Farbe innen schwarz, auÃŸen',0),(479196,13311,'en','Cost Per Cover When Color Inside Black Outside',0),(479197,13312,'is','',0),(479198,13312,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø± Ú©Ø§ÙˆØ±ÙˆÙ‚ØªÛŒ Ø±Ù†Ú¯ Ø¯Ø§Ø®Ù„ Ùˆ Ø®Ø§Ø±Ø¬',0),(479199,13312,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø± Ú©Ø§ÙˆØ±ÙˆÙ‚ØªÛŒ Ø±Ù†Ú¯ Ø¯Ø§Ø®Ù„ Ùˆ Ø®Ø§Ø±Ø¬',0),(479200,13312,'tr','Kapak maliyet zaman iÃ§inde & dÄ±ÅŸarÄ± renk',0),(479201,13312,'pl','Koszt pokrywa Kiedy kolor w & siÄ™',0),(479202,13312,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° ÐºÐ¾Ñ€Ð¸Ñ†Ð°Ñ‚Ð° ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ñ†Ð²ÑÑ‚ Ð² &,',0),(479203,13312,'ur','ØªØ¹Ø§Ø±ÙÛŒ ÙÛŒ Ù„Ø§Ú¯Øª Ù…ÛŒÚº & Ø¨Ø§ÛØ± Ø¬Ø¨ Ø±Ù†Ú¯',0),(479204,13312,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ ÐºÐ¾Ñ€Ð¸Ñ†Ð°Ð¼Ð° ÐºÐ°Ð´Ð° Ð¾Ð±Ð¾Ñ˜Ð¸Ñ‚Ðµ Ñƒ & Ð½Ð°Ð¿Ð¾Ñ™Ðµ',0),(479205,13312,'vi','giÃ¡ má»—i vá» khi mÃ u trong vÃ  ngoÃ i',0),(479206,13312,'af','Koste Per dekking wanneer kleur In jou tuin uit',0),(479207,13312,'ro','Costul pe coperta Color cÃ¢nd Ã®n & afarÄƒ',0),(479208,13312,'et','Pealt katta & vÃ¤lja kui vÃ¤rvi',0),(479209,13312,'si','StroÅ¡ki na pokrov ko barva v & ven',0),(479210,13312,'ba','Biaya tutup Kapan warna di & keluar',0),(479211,13312,'nl','Kosten Per Cover wanneer kleur In & uit',0),(479212,13312,'fi','Hinta Per kansi kun vÃ¤ri & ulos',0),(479213,13312,'no','Kostnad Per Cover nÃ¥r farge i & ut',0),(479214,13312,'da','Omkostning pr. dÃ¦kke nÃ¥r farve i & ud',0),(479215,13312,'ko','ë®ê°œ ë‹¹ ë¹„ìš© ë•Œ & ê°œ ìƒ‰ìƒ',0),(479216,13312,'he','×¢×œ×•×ª ×”×›×™×¡×•×™ ×›××©×¨ ×¦×‘×¢ ×‘- &.',0),(479217,13312,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ ÎºÎ¬Î»Ï…ÏˆÎ· Ï‡ÏÏŽÎ¼Î±Ï„Î¿Ï‚ ÏŒÏ„Î±Î½ ÏƒÏ„Î¿ & Î­Î¾Ï‰',0),(479218,13312,'zh','æ¯å¥—æˆæœ¬å½“é¢œè‰²åœ¨ &amp; å‡º',0),(479219,13312,'sv','Kostnad Per locket nÃ¤r fÃ¤rg i & ut',0),(479220,13312,'it','Costo Per la copertura di colore quando In & fuori',0),(479221,13312,'tl','',0),(479222,13312,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸•à¹ˆà¸­à¸›à¸à¸ªà¸µà¹ƒà¸™ & à¸­à¸­à¸à¹€à¸¡à¸·à¹ˆà¸­',0),(479223,13312,'hi','à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤à¤• à¤•à¤µà¤° à¤œà¤¬ à¤°à¤‚à¤— à¤®à¥‡à¤‚ & à¤¬à¤¾à¤¹à¤°',0),(479224,13312,'ms','Bayaran perlindungan Bilakah warna dalam & Keluar',0),(479225,13312,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„ØªØºØ·ÙŠØ© Ø¹Ù†Ø¯Ù…Ø§ Ø§Ù„Ù„ÙˆÙ† ÙÙŠ Ø¢Ù†Ø¯ Ø®Ø§Ø±Ø¬',0),(479226,13312,'fr','CoÃ»t par couverture quelle couleur dans & Out',0),(479227,13312,'jp','ã‚«ãƒãƒ¼ã‚ãŸã‚Šã®ã‚³ã‚¹ãƒˆã§ & ã†ã¡è‰²ã®ã¨ã',0),(479228,13312,'pt','Custo por cobertura quando cores em & fora',0),(479229,13312,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ð¾ÐºÑ€Ñ‹Ñ‚Ð¸Ñ ÐºÐ¾Ð³Ð´Ð° Ñ†Ð²ÐµÑ‚ Ð² & Ð¸Ð·',0),(479230,13312,'es','Costo por Tapa Cuando el Color a Dentro y a Fuera',0),(479231,13312,'de','Kosten pro Gedeck als Farbe In &,',0),(479232,13312,'en','Cost Per Cover When Color In & Out',0),(479233,13313,'is','',0),(479234,13313,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø± Ú©Ø§ÙˆØ± ÙˆÙ‚ØªÛŒØ±Ù†Ú¯ Ø®Ø§Ø±Ø¬ Ø³ÛŒØ§Ù‡ Ø¯Ø§Ø®Ù„',0),(479235,13313,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø± Ú©Ø§ÙˆØ± ÙˆÙ‚ØªÛŒØ±Ù†Ú¯ Ø®Ø§Ø±Ø¬ Ø³ÛŒØ§Ù‡ Ø¯Ø§Ø®Ù„',0),(479236,13313,'tr','Kapak maliyet zaman iÃ§inde dÄ±ÅŸ siyah renk',0),(479237,13313,'pl','Koszt pokrywa Kiedy kolor czarny poza wewnÄ…trz',0),(479238,13313,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° ÐºÐ¾Ñ€Ð¸Ñ†Ð°Ñ‚Ð° ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ñ†Ð²ÑÑ‚ Ð¸Ð·Ð²ÑŠÐ½ Ð§ÐµÑ€Ð½Ð¾ Ð²ÑŠÑ‚Ñ€Ðµ',0),(479239,13313,'ur','ØªØ¹Ø§Ø±ÙÛŒ ÙÛŒ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ Ø¬Ø¨ Ø§Ù†Ø¯Ø± Ø¨Ø§ÛØ± Ø³ÛŒØ§Û Ø±Ù†Ú¯',0),(479240,13313,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ ÐºÐ¾Ñ€Ð¸Ñ†Ð°Ð¼Ð° ÐºÐ°Ð´Ð° Ð¾Ð±Ð¾Ñ˜Ð¸Ñ‚Ðµ ÑÐ¿Ð¾Ñ™Ð° Ñ†Ñ€Ð½Ð¸ ÑƒÐ½ÑƒÑ‚Ñ€Ð°',0),(479241,13313,'vi','giÃ¡ má»—i vá» khi mÃ u ngoÃ i trong Ä‘en',0),(479242,13313,'af','Koste Per dekking wanneer kleur buite swart binne',0),(479243,13313,'ro','Costul pe coperta cÃ¢nd culoare neagra din exterior Ã®n interiorul',0),(479244,13313,'et','Pealt katta kuna vÃ¤rv vÃ¤ljaspool must sees',0),(479245,13313,'si','StroÅ¡ki na pokrov ko barva zunaj Ärna, znotraj',0),(479246,13313,'ba','Biaya tutup Kapan warna hitam di luar dalam',0),(479247,13313,'nl','Kosten Per Cover wanneer kleur buiten Black binnen',0),(479248,13313,'fi','Hinta Per kansi kun vÃ¤ri ulkopuolella musta sisÃ¤llÃ¤',0),(479249,13313,'no','Kostnad Per Cover nÃ¥r farge utenfor Black innsiden',0),(479250,13313,'da','Omkostning pr. dÃ¦kke nÃ¥r farve udenfor sort indeni',0),(479251,13313,'ko','ë®ê°œ ë‹¹ ë¹„ìš© ë•Œ ë‚´ë¶€ ì™¸ë¶€ ë¸”ëž™ ìƒ‰ìƒ',0),(479252,13313,'he','×¢×œ×•×ª ×”×›×™×¡×•×™ ×›××©×¨ ×¦×‘×¢ ×©×—×•×¨ ×ž×‘×—×•×¥ ×¤× ×™×ž×”',0),(479253,13313,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ ÎºÎ¬Î»Ï…ÏˆÎ· ÏŒÏ„Î±Î½ Ï„Î¿ Î­Î¾Ï‰ Î¼Î±ÏÏÎ¿ Î¼Î­ÏƒÎ± Ï‡ÏÏŽÎ¼Î±',0),(479254,13313,'zh','æ¯å¥—æˆæœ¬å½“é¢œè‰²å¤–é»‘å†…',0),(479255,13313,'sv','Kostnad Per locket nÃ¤r fÃ¤rg utanfÃ¶r svart insida',0),(479256,13313,'it','Costo Per copertura quando colore esterno nero interno',0),(479257,13313,'tl','',0),(479258,13313,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸•à¹ˆà¸­à¹ƒà¸šà¸›à¸°à¸«à¸™à¹‰à¸²à¹€à¸¡à¸·à¹ˆà¸­à¸ªà¸µà¸”à¸³à¸ à¸²à¸¢à¸™à¸­à¸à¸ à¸²à¸¢à¹ƒà¸™',0),(479259,13313,'hi','à¤²à¤¾à¤—à¤¤ à¤ªà¥à¤°à¤¤à¤¿ à¤à¤• à¤•à¤µà¤° à¤œà¤¬ à¤…à¤‚à¤¦à¤° à¤¬à¤¾à¤¹à¤° à¤•à¤¾à¤²à¥‡ à¤°à¤‚à¤—',0),(479260,13313,'ms','Bayaran perlindungan Bilakah warna hitam di luar di dalam',0),(479261,13313,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„ØªØºØ·ÙŠØ© Ø¹Ù†Ø¯Ù…Ø§ Ø§Ù„Ù„ÙˆÙ† Ø§Ù„Ø£Ø³ÙˆØ¯ Ø®Ø§Ø±Ø¬ Ø¯Ø§Ø®Ù„',0),(479262,13313,'fr','CoÃ»t par couverture quelle couleur extÃ©rieur noir Ã  l\'intÃ©rieur',0),(479263,13313,'jp','ã‚«ãƒãƒ¼ã‚ãŸã‚Šã®è²»ç”¨ã¨ãå†…å´å¤–å´ãƒ–ãƒ©ãƒƒã‚¯ ã‚«ãƒ©ãƒ¼',0),(479264,13313,'pt','Custo por cobertura quando cores exterior preto dentro',0),(479265,13313,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿Ð¾ÐºÑ€Ñ‹Ñ‚Ð¸Ñ ÐºÐ¾Ð³Ð´Ð° Ñ†Ð²ÐµÑ‚ Ð²Ð½Ðµ Ñ‡ÐµÑ€Ð½Ñ‹Ð¹ Ð²Ð½ÑƒÑ‚Ñ€Ð¸',0),(479266,13313,'es','Costo por Tapa Cuando el Color a Fuera Negro a Dentro',0),(479267,13313,'de','Kosten pro Gedeck als Farbe auÃŸen schwarz innen',0),(479268,13313,'en','Cost Per Cover When Color Outside Black Inside',0),(479269,13314,'is','',0),(479270,13314,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ø±Ø§ÛŒ Ù‡Ø± ÙˆÙ‚ØªÛŒ Ø¨Ø¯ÙˆÙ† Ú©Ø§ÙˆØ± ',0),(479271,13314,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ø±Ø§ÛŒ Ù‡Ø± ÙˆÙ‚ØªÛŒ Ø¨Ø¯ÙˆÙ† Ú©Ø§ÙˆØ± ',0),(479272,13314,'tr','Her zaman yok maliyeti',0),(479273,13314,'pl','Koszt kaÅ¼dego gdy nie',0),(479274,13314,'bg','Ð¦ÐµÐ½Ð° Ð½Ð° Ð²ÑÐµÐºÐ¸ ÐµÐ´Ð¸Ð½, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð½ÑÐ¼Ð° Ð¿Ð¾ÐºÑ€Ð¸Ñ‚Ð¸Ðµ',0),(479275,13314,'ur','ÛØ± ÙÛŒ Ø¬Ø¨ Ú©ÙˆØ¦ÛŒ ØªØ¹Ø§Ø±ÙÛŒ Ù‚ÛŒÙ…Øª',0),(479276,13314,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð¿Ð¾ Ñ˜ÐµÐ´Ð½Ð¾ ÐºÐ°Ð´Ð° Ð½ÐµÐ¼Ð° Ð·Ð°ÐºÐ»Ð¾Ð½',0),(479277,13314,'vi','giÃ¡ má»—i vá» khi khÃ´ng cÃ³ mÃ u',0),(479278,13314,'af','Koste Per elke wanneer geen dekking',0),(479279,13314,'ro','Costul pe fiecare atunci cÃ¢nd nici o acoperire',0),(479280,13314,'et','Kulu iga, kui puudub Ã¼levaade',0),(479281,13314,'si','StroÅ¡ki na vsak ko ne pokrivajo',0),(479282,13314,'ba','Biaya masing-masing ketika tidak penutup',0),(479283,13314,'nl','Kosten Per elk wanneer geen Cover',0),(479284,13314,'fi','Kustannukset kunkin kun ei kata',0),(479285,13314,'no','Kostnad Per hver nÃ¥r ingen dekke',0),(479286,13314,'da','Omkostning pr. hver nÃ¥r ingen dÃ¦kning',0),(479287,13314,'ko','ë•Œ ì•„ë¬´ ì»¤ë²„ ê° ë‹¹ ë¹„ìš©',0),(479288,13314,'he','×¢×œ×•×ª ×›×œ ××—×“ ×›××©×¨ ××™×Ÿ ×ž×—×¡×”',0),(479289,13314,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î±Î½Î¬ ÎºÎ¬Î¸Îµ ÏŒÏ„Î±Î½ ÎºÎ±Î¼Î¯Î± ÎºÎ¬Î»Ï…ÏˆÎ·',0),(479290,13314,'zh','æˆæœ¬æ¯æ—¶æ¯«æ— é®æŽ©',0),(479291,13314,'sv','Kostnad Per varje nÃ¤r ingen tÃ¤ckning',0),(479292,13314,'it','Costo Per ciascuno quando nessuna copertura',0),(479293,13314,'tl','',0),(479294,13314,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¹à¸•à¹ˆà¸¥à¸°à¹€à¸¡à¸·à¹ˆà¸­à¹„à¸¡à¹ˆà¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡',0),(479295,13314,'hi','à¤œà¤¬ à¤•à¥‹à¤ˆ à¤†à¤µà¤°à¤£ à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤ªà¥à¤°à¤¤à¤¿ à¤²à¤¾à¤—à¤¤',0),(479296,13314,'ms','Kos setiap satu apabila perlindungan tidak',0),(479297,13314,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ù„ÙƒÙ„ Ø¹Ù†Ø¯ Ø¹Ø¯Ù… ÙˆØ¬ÙˆØ¯ ØºØ·Ø§Ø¡',0),(479298,13314,'fr','CoÃ»t par chacun lorsqu\'aucune couverture',0),(479299,13314,'jp','å„ã¨ããªã„ã‚«ãƒãƒ¼ã‚ãŸã‚Šã®è²»ç”¨',0),(479300,13314,'pt','Custo por cada um, quando nÃ£o hÃ¡ cobertura',0),(479301,13314,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð·Ð° ÐºÐ°Ð¶Ð´Ñ‹Ð¹ ÐºÐ¾Ð³Ð´Ð° Ð±ÐµÐ· Ð¿Ð¾ÐºÑ€Ñ‹Ñ‚Ð¸Ñ',0),(479302,13314,'es','Costo por Cada Uno Cuando No Hay Tapa',0),(479303,13314,'de','Kosten pro StÃ¼ck wenn keine Deckung',0),(479304,13314,'en','Cost Per Each When No Cover',0),(479305,13315,'is','',0),(479306,13315,'dr','Ø±ÙˆØ´Ù‡Ø§ÛŒ Ø¯Ø±ÛŒØ§ÙØª Ø³ÙØ§Ø±Ø´',0),(479307,13315,'pr','Ø±ÙˆØ´Ù‡Ø§ÛŒ Ø¯Ø±ÛŒØ§ÙØª Ø³ÙØ§Ø±Ø´',0),(479308,13315,'tr','SipariÅŸ alÄ±nma yÃ¶ntemleri',0),(479309,13315,'pl','ZamÃ³wienie odebrane metody',0),(479310,13315,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ Ð¼ÐµÑ‚Ð¾Ð´Ð¸',0),(479311,13315,'ur','Ù…ÙˆØµÙˆÙ„Û Ø·Ø±ÛŒÙ‚ÙˆÚº Ú©Ø§ Ø­Ú©Ù…',0),(479312,13315,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð¼ÐµÑ‚Ð¾Ð´Ðµ',0),(479313,13315,'vi','CÃ¡c phÆ°Æ¡ng thá»©c nháº­n Ä‘Æ¡n hÃ ng',0),(479314,13315,'af','Bestel ontvang metodes',0),(479315,13315,'ro','Ordinul primit metode',0),(479316,13315,'et','Selleks vastuvÃµetud meetodite',0),(479317,13315,'si','NaroÄite prejetih metode',0),(479318,13315,'ba','Order diterima metode',0),(479319,13315,'nl','Bestel ontvangen methoden',0),(479320,13315,'fi','Tilaa vastaan menetelmÃ¤t',0),(479321,13315,'no','Bestille mottatt metoder',0),(479322,13315,'da','Bestil modtagne metoder',0),(479323,13315,'ko','ì£¼ë¬¸ ë°›ì€ ë°©ë²•',0),(479324,13315,'he','×œ×”×–×ž×™×Ÿ ×©×™×˜×•×ª ×©×”×ª×§×‘×œ×•',0),(479325,13315,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î­Î»Î±Î²Îµ Î¼ÎµÎ¸ÏŒÎ´Î¿Ï…Ï‚',0),(479326,13315,'zh','è®¢å•æŽ¥æ”¶çš„æ–¹æ³•',0),(479327,13315,'sv','BestÃ¤ll mottagna metoder',0),(479328,13315,'it','Ordine ricevuti metodi',0),(479329,13315,'tl','',0),(479330,13315,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¹„à¸”à¹‰à¸£à¸±à¸šà¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(479331,13315,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¤à¤°à¥€à¤•à¥‹à¤‚',0),(479332,13315,'ms','Perintah kaedah-kaedah yang diterima',0),(479333,13315,'ar','ØªØ±ØªÙŠØ¨ Ø£Ø³Ø§Ù„ÙŠØ¨ Ø§Ù„ØªÙ„Ù‚ÙŠ',0),(479334,13315,'fr','Commander des mÃ©thodes reÃ§us',0),(479335,13315,'jp','æ³¨æ–‡å—ä¿¡ãƒ¡ã‚½ãƒƒãƒ‰',0),(479336,13315,'pt','Ordem recebidos mÃ©todos',0),(479337,13315,'ru','Ð—Ð°ÐºÐ°Ð· Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»Ð¸ Ð¼ÐµÑ‚Ð¾Ð´Ñ‹',0),(479338,13315,'es','MÃ©todos de Ordenes Recibidos',0),(479339,13315,'de','Bestellen Sie empfangene Methoden',0),(479340,13315,'en','Order Received Methods',0),(479341,13316,'is','',0),(479342,13316,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø§Ø²Ù…Ù†ÙˆÛŒ Ú©Ø´ÙˆÛŒÛŒ',0),(479343,13316,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø§Ø²Ù…Ù†ÙˆÛŒ Ú©Ø´ÙˆÛŒÛŒ',0),(479344,13316,'tr','Damla aÅŸaÄŸÄ± gizle',0),(479345,13316,'pl','Ukryj z spadaÄ‡ w dÃ³Å‚',0),(479346,13316,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¾Ñ‚ ÐºÐ°Ð¿ÐºÐ° Ð½Ð°Ð´Ð¾Ð»Ñƒ',0),(479347,13316,'ur','Ù‚Ø·Ø±Û Ø³Û’ Ù†ÛŒÚ†Û’ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(479348,13316,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ‚Ð¸ Ð¾Ð´ Ð¿Ð°Ð´Ð° Ð´Ð¾Ð»Ðµ',0),(479349,13316,'vi','Giáº¥u tá»« trÃªn xuá»‘ng',0),(479350,13316,'af','Steek van val af',0),(479351,13316,'ro','Ascunde de la Drop jos',0),(479352,13316,'et','Varjata Drop Down',0),(479353,13316,'si','Skriti pred spusti navzdol',0),(479354,13316,'ba','Sembunyikan dari Drop-Down',0),(479355,13316,'nl','Verbergen van Drop-Down',0),(479356,13316,'fi','Piiloutua pudota alas',0),(479357,13316,'no','Skjule fra Drop ned',0),(479358,13316,'da','Skjule fra Drop ned',0),(479359,13316,'ko','ë“œë¡­ì—ì„œ ë‹¤ìš´ ìˆ¨ê¸°ê¸°',0),(479360,13316,'he','×œ×”×¡×ª×ª×¨ ×ž×¤× ×™ ×™×¨×™×“×” ×œ×ž×˜×”',0),(479361,13316,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î±Ï€ÏŒ ÏƒÏ„Î±Î³ÏŒÎ½Î± ÎºÎ¬Ï„Ï‰',0),(479362,13316,'zh','éšè—ä»Žé™ä¸‹æ¥',0),(479363,13316,'sv','DÃ¶lja frÃ¥n droppa ned',0),(479364,13316,'it','Nascondere da goccia giÃ¹',0),(479365,13316,'tl','',0),(479366,13316,'th','à¸‹à¹ˆà¸­à¸™à¸ˆà¸²à¸à¸£à¸²à¸¢à¸à¸²à¸£à¹à¸šà¸šà¸«à¸¥à¹ˆà¸™à¸¥à¸‡',0),(479367,13316,'hi','à¤¡à¥à¤°à¥‰à¤ª à¤¸à¥‡ à¤¨à¥€à¤šà¥‡ à¤›à¥à¤ªà¤¾à¤à¤',0),(479368,13316,'ms','Menyembunyikan daripada jatuh ke bawah',0),(479369,13316,'ar','Ø¥Ø®ÙØ§Ø¡ Ù…Ù† Ø¥Ø³Ù‚Ø§Ø· Ù„Ø£Ø³ÙÙ„',0),(479370,13316,'fr','Cacher de baisse vers le bas',0),(479371,13316,'jp','ãƒ€ã‚¦ãƒ³ ãƒ‰ãƒ­ãƒƒãƒ—ã‹ã‚‰éžè¡¨ç¤ºã«ã—ã¾ã™ã€‚',0),(479372,13316,'pt','Esconder da gota para baixo',0),(479373,13316,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¾Ñ‚ Ð¿Ð°Ð´ÐµÐ½Ð¸Ñ Ð²Ð½Ð¸Ð·',0),(479374,13316,'es','Esconde de Menu Drop Down',0),(479375,13316,'de','Ausblenden von Drop Down',0),(479376,13316,'en','Hide From Drop Down',0),(479377,13317,'is','',0),(479378,13317,'dr','(Ø­Ø±Ø§Ø¬',0),(479379,13317,'pr','ÙØ¹Ø§Ù„ÛŒØªÙ‡Ø§ÛŒ ÙØ±ÙˆØ´(Ø­Ø±Ø§Ø¬',0),(479380,13317,'tr','SatÄ±ÅŸ kampanyalarÄ±',0),(479381,13317,'pl','Kampanii na rzecz sprzedaÅ¼y',0),(479382,13317,'bg','ÐšÐ°Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(479383,13317,'ur','Ø³ÛŒÙ„Ø² Ù…ÛÙ…Ø§Øª',0),(479384,13317,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ðµ ÐºÐ°Ð¼Ð¿Ð°ÑšÐµ',0),(479385,13317,'vi','Chiáº¿n dá»‹ch bÃ¡n hÃ ng',0),(479386,13317,'af','Verkope veldtogte',0),(479387,13317,'ro','Campaniile de vÃ¢nzÄƒri',0),(479388,13317,'et','MÃ¼Ã¼gikampaaniad',0),(479389,13317,'si','Prodajne akcije',0),(479390,13317,'ba','Penjualan kampanye',0),(479391,13317,'nl','Verkoopcampagnes',0),(479392,13317,'fi','Myy kampanja',0),(479393,13317,'no','Salgskampanjer',0),(479394,13317,'da','Salgs kampagner',0),(479395,13317,'ko','íŒë§¤ ìº íŽ˜ì¸',0),(479396,13317,'he','×ž×‘×¦×¢×™ ×ž×›×™×¨×•×ª',0),(479397,13317,'el','Î•ÎºÏƒÏ„ÏÎ±Ï„ÎµÎ¹ÏŽÎ½ Î³Î¹Î± Ï„Î¹Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(479398,13317,'zh','é”€å”®æ´»åŠ¨',0),(479399,13317,'sv','SÃ¤ljkampanjer',0),(479400,13317,'it','Campagne di vendita',0),(479401,13317,'tl','',0),(479402,13317,'th','à¸à¸²à¸£à¸ªà¹ˆà¸‡à¹€à¸ªà¸£à¸´à¸¡à¸à¸²à¸£à¸‚à¸²à¸¢',0),(479403,13317,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤…à¤­à¤¿à¤¯à¤¾à¤¨à¥‹à¤‚',0),(479404,13317,'ms','Kempen jualan',0),(479405,13317,'ar','Ø­Ù…Ù„Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(479406,13317,'fr','Campagnes de vente',0),(479407,13317,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ ãƒ» ã‚­ãƒ£ãƒ³ãƒšãƒ¼ãƒ³',0),(479408,13317,'pt','Campanhas de vendas',0),(479409,13317,'ru','ÐšÐ°Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¿Ð¾ ÑÐ±Ñ‹Ñ‚Ñƒ',0),(479410,13317,'es','CampaÃ±as de Ventas',0),(479411,13317,'de','Verkaufskampagnen',0),(479412,13317,'en','Sales Campaigns',0),(479413,13318,'is','',0),(479414,13318,'dr','Ø¯Ø±ÛŒØ§ÙØª Ø³ÙØ§Ø±Ø´ Ú†Ú¯ÙˆÙ†Ù‡',0),(479415,13318,'pr','Ø¯Ø±ÛŒØ§ÙØª Ø³ÙØ§Ø±Ø´ Ú†Ú¯ÙˆÙ†Ù‡',0),(479416,13318,'tr','NasÄ±l alÄ±ndÄ±ÄŸÄ±',0),(479417,13318,'pl','KolejnoÅ›ci jak',0),(479418,13318,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ ÐºÐ°Ðº',0),(479419,13318,'ur','Ú©Ø³ Ø·Ø±Ø­ Ø³Ù†ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(479420,13318,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½ ÐºÐ°ÐºÐ¾',0),(479421,13318,'vi','Nháº­n Ä‘Æ¡n hÃ ng tháº¿ nÃ o',0),(479422,13318,'af','Orde hoe ontvang',0),(479423,13318,'ro','Ordinul primit cum',0),(479424,13318,'et','Kuidas saadud',0),(479425,13318,'si','Kako vrstnem',0),(479426,13318,'ba','Urutan diterima bagaimana',0),(479427,13318,'nl','Bestelling ontvangen hoe',0),(479428,13318,'fi','Miten saapumisjÃ¤rjestyksessÃ¤',0),(479429,13318,'no','RekkefÃ¸lgen mottatt hvor',0),(479430,13318,'da','Ordre modtaget hvordan',0),(479431,13318,'ko','ì–´ë–»ê²Œ ìˆ˜ì‹  ìˆœì„œ',0),(479432,13318,'he','×¡×“×¨ ×§×™×‘×œ ×›×ž×”',0),(479433,13318,'el','Î ÏŽÏ‚ ÏƒÎµÎ¹ÏÎ¬',0),(479434,13318,'zh','å¦‚ä½•æŽ¥æ”¶é¡ºåº',0),(479435,13318,'sv','Ordning emot hur',0),(479436,13318,'it','Ordine ricevuto come',0),(479437,13318,'tl','',0),(479438,13318,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸à¸²à¸£',0),(479439,13318,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥ˆà¤¸à¥‡ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(479440,13318,'ms','Pesanan diterima bagaimana',0),(479441,13318,'ar','ØªØ±ØªÙŠØ¨ ØªÙ„Ù‚ÙŠ ÙƒÙŠÙ',0),(479442,13318,'fr','Commande reÃ§ue comment',0),(479443,13318,'jp','å—æ³¨æ–¹æ³•',0),(479444,13318,'pt','Ordem recebida como',0),(479445,13318,'ru','Ð—Ð°ÐºÐ°Ð· Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð» ÐºÐ°Ðº',0),(479446,13318,'es','Orden Como Recibido',0),(479447,13318,'de','Bestellung wie',0),(479448,13318,'en','Order Received How',0),(479449,13319,'is','',0),(479450,13319,'dr','(Ø­Ø±Ø§Ø¬',0),(479451,13319,'pr','ÙØ¹Ø§Ù„ÛŒØª ÙØ±ÙˆØ´(Ø­Ø±Ø§Ø¬',0),(479452,13319,'tr','SatÄ±ÅŸ kampanyasÄ±',0),(479453,13319,'pl','SprzedaÅ¼y kampanii',0),(479454,13319,'bg','ÐšÐ°Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(479455,13319,'ur','ÙØ±ÙˆØ®Øª Ú©ÛŒ Ù…ÛÙ…',0),(479456,13319,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ðµ ÐºÐ°Ð¼Ð¿Ð°ÑšÐµ',0),(479457,13319,'vi','Chiáº¿n dá»‹ch bÃ¡n hÃ ng',0),(479458,13319,'af','Verkope veldtog',0),(479459,13319,'ro','Campanie de vanzari',0),(479460,13319,'et','MÃ¼Ã¼gikampaania',0),(479461,13319,'si','Prodajne akcije',0),(479462,13319,'ba','Promosi penjualan',0),(479463,13319,'nl','Advertentiecampagne',0),(479464,13319,'fi','Myyntikampanjan',0),(479465,13319,'no','Kampanje',0),(479466,13319,'da','Salgskampagne',0),(479467,13319,'ko','íŒë§¤ ìº íŽ˜ì¸',0),(479468,13319,'he','×§×ž×¤×™×™×Ÿ ×ž×›×™×¨×•×ª',0),(479469,13319,'el','ÎšÎ±Î¼Ï€Î¬Î½Î¹Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(479470,13319,'zh','é”€å”®æ´»åŠ¨',0),(479471,13319,'sv','FÃ¶rsÃ¤ljningskampanj',0),(479472,13319,'it','Campagna vendite',0),(479473,13319,'tl','',0),(479474,13319,'th','à¹à¸„à¸¡à¹€à¸›à¸à¸à¸²à¸£à¸‚à¸²à¸¢',0),(479475,13319,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤…à¤­à¤¿à¤¯à¤¾à¤¨',0),(479476,13319,'ms','Kempen jualan',0),(479477,13319,'ar','Ø­Ù…Ù„Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(479478,13319,'fr','Campagne de souscription',0),(479479,13319,'jp','è²©å£²ã‚­ãƒ£ãƒ³ãƒšãƒ¼ãƒ³',0),(479480,13319,'pt','Campanha de vendas',0),(479481,13319,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶ ÐºÐ°Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(479482,13319,'es','CampaÃ±a de Ventas',0),(479483,13319,'de','Verkaufskampagne',0),(479484,13319,'en','Sales Campaign',0),(479485,13320,'is','',0),(479486,13320,'dr',' ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡',0),(479487,13320,'pr',' ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡',0),(479488,13320,'tr','Ã–zel ÃœrÃ¼nler',0),(479489,13320,'pl','Promocje',0),(479490,13320,'bg','ÐŸÑ€Ð¾Ð¼Ð¾Ñ†Ð¸Ð¸',0),(479491,13320,'ur','Ø®ØµÙˆØµÛŒ',0),(479492,13320,'sr','Ð¡Ð¿ÐµÑ†Ð¸Ñ˜Ð°Ð»Ð¸Ñ‚ÐµÑ‚Ð¸',0),(479493,13320,'vi','Äáº·c biÃªt',0),(479494,13320,'af','Specials',0),(479495,13320,'ro','Oferte speciale',0),(479496,13320,'et','Eripakkumised',0),(479497,13320,'si','V akciji',0),(479498,13320,'ba','Spesial',0),(479499,13320,'nl','Specials',0),(479500,13320,'fi','Tarjoukset',0),(479501,13320,'no','Spesialtilbud',0),(479502,13320,'da','Specials',0),(479503,13320,'ko','íŠ¹ê°€ ìƒí’ˆ',0),(479504,13320,'he','×ž×‘×¦×¢×™×',0),(479505,13320,'el','Î•Î¹Î´Î¹ÎºÎ­Ï‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ­Ï‚',0),(479506,13320,'zh','ç‰¹ä»·',0),(479507,13320,'sv','Specials',0),(479508,13320,'it','Offerte speciali',0),(479509,13320,'tl','',0),(479510,13320,'th','à¸žà¸´à¹€à¸¨à¸©',0),(479511,13320,'hi','à¤¸à¥à¤ªà¥‡à¤¶à¤²',0),(479512,13320,'ms','Istimewa',0),(479513,13320,'ar','Ø¹Ø±ÙˆØ¶ Ø®Ø§ØµØ©',0),(479514,13320,'fr','Offres spÃ©ciales',0),(479515,13320,'jp','ã‚¹ãƒšã‚·ãƒ£ãƒ«',0),(479516,13320,'pt','PromoÃ§Ãµes',0),(479517,13320,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(479518,13320,'es','Especiales',0),(479519,13320,'de','Specials',0),(479520,13320,'en','Specials',0),(479521,13321,'is','',0),(479522,13321,'dr','ØªÙˆØ²ÛŒØ¹ ÙØ±Ø§ÙˆØ§Ù†ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡',0),(479523,13321,'pr','ØªÙˆØ²ÛŒØ¹ ÙØ±Ø§ÙˆØ§Ù†ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡',0),(479524,13321,'tr','SeÃ§ili daÄŸÄ±tÄ±m frekans',0),(479525,13321,'pl','RozkÅ‚ad czÄ™stotliwoÅ›ci nie wybrany',0),(479526,13321,'bg','Ð§ÐµÑÑ‚Ð¾Ñ‚Ð° Ð½Ð° Ñ€Ð°Ð·Ð¿Ñ€Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð½Ðµ Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð°',0),(479527,13321,'ur','Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº Ø¨Ø§Ù†Ù¹ ØªØ¹Ø¯Ø¯',0),(479528,13321,'sr','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ†Ð¸Ñ˜Ðµ Ñ„Ñ€ÐµÐºÐ²ÐµÐ½Ñ†Ð¸Ñ˜Ðµ Ð½Ð¸Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(479529,13321,'vi','Sá»± phÃ¢n phá»‘i thÆ°á»ng xuyÃªn khÃ´ng Ä‘Æ°á»£c chá»n',0),(479530,13321,'af','Verspreiding frekwensie nie gekies',0),(479531,13321,'ro','FrecvenÅ£a de distribuÅ£ie nu selectat',0),(479532,13321,'et','Jaotus sagedus pole valitud',0),(479533,13321,'si','Porazdelitev frekvence ni potrjeno',0),(479534,13321,'ba','Distribusi frekuensi tidak dipilih',0),(479535,13321,'nl','Distributie frequentie niet geselecteerd',0),(479536,13321,'fi','Jakelu taajuus ei ole valittu',0),(479537,13321,'no','Distribusjon frekvens ikke valgt',0),(479538,13321,'da','Distribution hyppighed ikke valgt',0),(479539,13321,'ko','ë°°í¬ ì£¼íŒŒìˆ˜ ì„ íƒ í•˜ì§€',0),(479540,13321,'he','×ª×“×™×¨×•×ª ×”×”×¤×¦×” ×œ× × ×‘×—×¨',0),(479541,13321,'el','Î£Ï…Ï‡Î½ÏŒÏ„Î·Ï„Î± Î´Î¹Î±Î½Î¿Î¼Î®Ï‚ Î´ÎµÎ½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯',0),(479542,13321,'zh','æœªé€‰ä¸­çš„åˆ†å¸ƒé¢‘çŽ‡',0),(479543,13321,'sv','Distribution frekvens inte valt',0),(479544,13321,'it','Frequenza di distribuzione non selezionata',0),(479545,13321,'tl','',0),(479546,13321,'th','à¸„à¸§à¸²à¸¡à¸–à¸µà¹ˆà¸à¸²à¸£à¸à¸£à¸°à¸ˆà¸²à¸¢à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¹€à¸¥à¸·à¸­à¸',0),(479547,13321,'hi','à¤µà¤¿à¤¤à¤°à¤£ à¤†à¤µà¥ƒà¤¤à¥à¤¤à¤¿ à¤šà¤¯à¤¨à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚',0),(479548,13321,'ms','Kekerapan Pengagihan pendapatan yang tidak dipilih',0),(479549,13321,'ar','ØªÙˆØ²ÙŠØ¹ Ø§Ù„ØªØ±Ø¯Ø¯Ø§Øª ØºÙŠØ± Ù…Ø­Ø¯Ø¯',0),(479550,13321,'fr','FrÃ©quence de distribution non sÃ©lectionnÃ©',0),(479551,13321,'jp','é¸æŠžã•ã‚Œã¦ã„ãªã„é »åº¦åˆ†å¸ƒ',0),(479552,13321,'pt','FreqÃ¼Ãªncia de distribuiÃ§Ã£o nÃ£o seleccionada',0),(479553,13321,'ru','Ð Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ñ‡Ð°ÑÑ‚Ð¾Ñ‚Ñ‹ Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(479554,13321,'es','Frecuencia de DistribuciÃ³n No Seleccionada',0),(479555,13321,'de','Vertrieb-Frequenz, die nicht ausgewÃ¤hlt',0),(479556,13321,'en','Distribution Frequency Not Selected',0),(479557,13322,'is','',0),(479558,13322,'dr','Ø¯Ø± Ø®Ø§Ù†Ù‡ Ùˆ ÛŒØ§',0),(479559,13322,'pr','Ø¯Ø± Ø®Ø§Ù†Ù‡ Ùˆ ÛŒØ§',0),(479560,13322,'tr','Kurum iÃ§i veya',0),(479561,13322,'pl','WewnÄ™trznych lub',0),(479562,13322,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ Ð¸Ð»Ð¸',0),(479563,13322,'ur','Ú¯Ú¾Ø± ÛŒØ§',0),(479564,13322,'sr','ÐšÑ€Ð¸Ð¼Ð¸Ð½Ð°Ð» Ð¸Ð»Ð¸',0),(479565,13322,'vi','trong nhÃ  hoáº·c',0),(479566,13322,'af','In-huis of',0),(479567,13322,'ro','In-House sau',0),(479568,13322,'et','Majasisene vÃµi',0),(479569,13322,'si','Interne ali',0),(479570,13322,'ba','Rumah atau',0),(479571,13322,'nl','In-House of',0),(479572,13322,'fi','Talon tai',0),(479573,13322,'no','Huset eller',0),(479574,13322,'da','In-House eller',0),(479575,13322,'ko','ì‚¬ë‚´ ë˜ëŠ”',0),(479576,13322,'he','×œ×œ× ×¦×•×¨×š ×‘×ž×™×§×•×¨ ×—×•×¥ ××•',0),(479577,13322,'el','Î£Ï„Î¿ ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÏŒ Î®',0),(479578,13322,'zh','å†…éƒ¨æˆ–',0),(479579,13322,'sv','In-House eller',0),(479580,13322,'it','In-House o',0),(479581,13322,'tl','',0),(479582,13322,'th','à¹ƒà¸™à¸šà¹‰à¸²à¸™ à¸«à¸£à¸·à¸­',0),(479583,13322,'hi','à¤˜à¤° à¤®à¥‡à¤‚ à¤¯à¤¾',0),(479584,13322,'ms','Dalaman atau',0),(479585,13322,'ar','Ø¯Ø§Ø®Ù„ÙŠØ© Ø£Ùˆ',0),(479586,13322,'fr','Interne ou',0),(479587,13322,'jp','ç¤¾å†…ã¾ãŸã¯',0),(479588,13322,'pt','Internos ou',0),(479589,13322,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ðµ Ð¸Ð»Ð¸',0),(479590,13322,'es','En-Casa O',0),(479591,13322,'de','Inhouse oder',0),(479592,13322,'en','In-house Or',0),(479593,13323,'is','',0),(479594,13323,'dr','Ø®Ø±ÙˆØ¬ ØªØ§Ø±ÛŒØ® Ø§Ø² ØµÙØ­Ù‡ Ø§ØµÙ„ÛŒ',0),(479595,13323,'pr','Ø®Ø±ÙˆØ¬ ØªØ§Ø±ÛŒØ® Ø§Ø² ØµÙØ­Ù‡ Ø§ØµÙ„ÛŒ',0),(479596,13323,'tr','Tarihi ana hariÃ§ tut.',0),(479597,13323,'pl','WykluczyÄ‡ daty od gÅ‚Ã³wnego',0),(479598,13323,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ñ‚Ð° Ð¾Ñ‚ Ð³Ð»Ð°Ð²Ð½Ð¸Ñ',0),(479599,13323,'ur','ØªØ§Ø±ÛŒØ® Ù…ÛŒÙ† Ø³Û’ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(479600,13323,'sr','Ð˜ÑÐºÑ™ÑƒÑ‡Ð¸Ð²Ð°ÑšÐµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¸Ð· Ð³Ð»Ð°Ð²Ð½Ð¾Ð³',0),(479601,13323,'vi','khÃ´ng gá»“m ngÃ y tá»« chÃ­nh',0),(479602,13323,'af','Datum vanaf Hoofstraat uitsluit',0),(479603,13323,'ro','Exclude data la pagina principalÄƒ',0),(479604,13323,'et','VÃ¤lja Date Main',0),(479605,13323,'si','IzkljuÄijo datum glavne',0),(479606,13323,'ba','Mengecualikan tanggal dari Main',0),(479607,13323,'nl','Datum van Main uitsluiten',0),(479608,13323,'fi','JÃ¤ttÃ¤Ã¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ PÃ¤Ã¤sivu',0),(479609,13323,'no','Ekskluder dato fra Main',0),(479610,13323,'da','Udelukke dato fra Main',0),(479611,13323,'ko','Mainì—ì„œ ë‚ ì§œ ì œì™¸',0),(479612,13323,'he','×œ× ×œ×›×œ×•×œ ×ª××¨×™×š ×”×ž×¨×›×–×™×ª',0),(479613,13323,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¯ÎµÎ¹ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€ÏŒ Ï„Î·Î½ ÎºÏÏÎ¹Î±',0),(479614,13323,'zh','ä»Žä¸»è¦æŽ’é™¤æ—¥æœŸ',0),(479615,13323,'sv','Utesluta datum frÃ¥n Main',0),(479616,13323,'it','Escludere data dal principale',0),(479617,13323,'tl','',0),(479618,13323,'th','à¹„à¸¡à¹ˆà¸£à¸§à¸¡à¸§à¸±à¸™à¸«à¸¥à¸±à¸',0),(479619,13323,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤•à¥‹ à¤®à¥‡à¤¨ à¤¸à¥‡ à¤¬à¤¾à¤¹à¤°',0),(479620,13323,'ms','Tidak termasuk tarikh dari utama',0),(479621,13323,'ar','Ø§Ø³ØªØ¨Ø¹Ø§Ø¯ Ø§Ù„ØªØ§Ø±ÙŠØ® Ù…Ù† Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(479622,13323,'fr','Exclure la Date de la Main',0),(479623,13323,'jp','ãƒ¡ã‚¤ãƒ³ã‹ã‚‰ã®æ—¥ä»˜ã‚’é™¤å¤–ã—ã¾ã™ã€‚',0),(479624,13323,'pt','Excluir data do Main',0),(479625,13323,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð”Ð°Ñ‚Ð° Ð¸Ð· Ð³Ð»Ð°Ð²Ð½Ð¾Ð³Ð¾',0),(479626,13323,'es','Excluir Fecha del Main',0),(479627,13323,'de','Datum vom Main ausschlieÃŸen',0),(479628,13323,'en','Exclude Date From Main',0),(479629,13324,'is','',0),(479630,13324,'dr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† ÛŒØ§ Ø´Ø±ÙˆØ¹ Ù†Ø§ØµØ­ÛŒØ­ ÛŒØ§ Ø§Ø² Ù‚Ù„Ù… Ø§ÙØªØ§Ø¯Ù‡',0),(479631,13324,'pr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† ÛŒØ§ Ø´Ø±ÙˆØ¹ Ù†Ø§ØµØ­ÛŒØ­ ÛŒØ§ Ø§Ø² Ù‚Ù„Ù… Ø§ÙØªØ§Ø¯Ù‡',0),(479632,13324,'tr','Eksik veya geÃ§ersiz baÅŸlangÄ±Ã§ veya bitiÅŸ tarihi',0),(479633,13324,'pl','BrakujÄ…ce lub nieprawidÅ‚owe rozpoczÄ™cia lub daty zakoÅ„czenia',0),(479634,13324,'bg','Ð›Ð¸Ð¿ÑÐ²Ð°Ñ‰Ð¾ Ð¸Ð»Ð¸ Ð½ÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¾ ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð¸Ð»Ð¸ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(479635,13324,'ur','ØºØ§ Ø¦Ø¨ ÛŒØ§ Ù†Ø§Ø¬Ø§Ø¦Ø² Ø¢ØºØ§Ø² ÛŒØ§ Ø§Ø®ØªØªØ§Ù… ØªØ§Ø±ÛŒØ®',0),(479636,13324,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ð¸Ð»Ð¸ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð° Ð¾Ð·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¸Ð»Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(479637,13324,'vi','thiáº¿u hoáº·c ban Ä‘áº§u khÃ´ng giÃ¡ trá»‹ hoáº·c káº¿t thÃºc ngÃ y',0),(479638,13324,'af','Vermis Ã³f ongeldig Begin of einde datum',0),(479639,13324,'ro','Inceput de lipseÅŸte sau este Invalid sau data de sfÃ¢rÅŸit',0),(479640,13324,'et','Puuduv vÃµi lubamatu algus vÃµi lÃµpp kuupÃ¤ev',0),(479641,13324,'si','ManjkajoÄ ali neveljaven zaÄetni ali konÄni datum',0),(479642,13324,'ba','Mulai hilang atau tidak valid atau tanggal akhir',0),(479643,13324,'nl','Ontbrekende of ongeldige Begin- of einddatum',0),(479644,13324,'fi','Puuttuva tai virheellinen aloitus- tai pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(479645,13324,'no','Manglende eller ugyldig Begin- eller End dato',0),(479646,13324,'da','Manglende eller ugyldig start- eller slutdato',0),(479647,13324,'ko','ëˆ„ë½ ë˜ê±°ë‚˜ ìœ íš¨ í•˜ì§€ ì•Šì€ ì‹œìž‘ ë˜ëŠ” ì¢…ë£Œ ë‚ ì§œ',0),(479648,13324,'he','×‘×’×™×Ÿ ×—×¡×¨×™× ××• ×œ× ×—×•×§×™×™× ××• ×ª××¨×™×š ×”×¡×™×•×',0),(479649,13324,'el','Î›ÎµÎ¯Ï€ÎµÎ¹ Î® ÎµÎ¯Î½Î±Î¹ Î¬ÎºÏ…ÏÎ· Î­Î½Î±ÏÎ¾Î·Ï‚ Î® Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(479650,13324,'zh','ä¸¢å¤±æˆ–æ— æ•ˆçš„å¼€å§‹æˆ–ç»“æŸæ—¥æœŸ',0),(479651,13324,'sv','Saknas eller Ã¤r ogiltig start- och slutdatum',0),(479652,13324,'it','Begin mancante o non valido o data di fine',0),(479653,13324,'tl','',0),(479654,13324,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸‚à¸²à¸”à¸«à¸²à¸¢à¹„à¸› à¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡à¸«à¸£à¸·à¸­à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(479655,13324,'hi','à¤—à¥à¤® à¤¯à¤¾ à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤†à¤°à¤‚à¤­ à¤¯à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(479656,13324,'ms','Mulakan hilang atau tidak sah atau tarikh akhir',0),(479657,13324,'ar','ØªØ¨Ø¯Ø£ Ù…ÙÙ‚ÙˆØ¯Ø© Ø£Ùˆ ØºÙŠØ± ØµØ§Ù„Ø­Ø© Ø£Ùˆ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(479658,13324,'fr','Begin manquant ou non valide ou Date de fin',0),(479659,13324,'jp','è¡Œæ–¹ä¸æ˜Žã¾ãŸã¯ç„¡åŠ¹ãªé–‹å§‹ã¾ãŸã¯çµ‚äº†æ—¥',0),(479660,13324,'pt','Begin ausente ou invÃ¡lido ou data de tÃ©rmino',0),(479661,13324,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð¸Ð»Ð¸ Ð½ÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ðµ Begin Ð¸Ð»Ð¸ Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(479662,13324,'es','Ninguno O Invalido Fecha de Comienza o TerminaciÃ³n',0),(479663,13324,'de','Fehlender oder ungÃ¼ltiger Anfangs- oder Endtermin',0),(479664,13324,'en','Missing Or Invalid Begin Or End Date',0),(479665,13325,'is','',0),(479666,13325,'dr','ØªØ¹Ø¯Ø§Ø¯Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ù‚Ø¨Ù„ÛŒ',0),(479667,13325,'pr','ØªØ¹Ø¯Ø§Ø¯Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡ Ù‚Ø¨Ù„ÛŒ',0),(479668,13325,'tr','Daha Ã¶nce alÄ±nan miktar',0),(479669,13325,'pl','IloÅ›Ä‡ otrzymanych wczeÅ›niej',0),(479670,13325,'bg','ÐŸÑ€ÐµÐ´Ð¸ Ñ‚Ð¾Ð²Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(479671,13325,'ur','Ù‚Ø¨Ù„ Ø§Ø²ÛŒÚº Ù…ÙˆØµÙˆÙ„Û Ù…Ù‚Ø¯Ø§Ø±',0),(479672,13325,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ñƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(479673,13325,'vi','Sá»‘ lÆ°á»£ng Ä‘Ã£ nháº­n trÆ°á»›c',0),(479674,13325,'af','Hoeveelheid voorheen ontvang',0),(479675,13325,'ro','Cantitatea primitÄƒ anterior',0),(479676,13325,'et','Varem saadud kogus',0),(479677,13325,'si','KoliÄina prejete',0),(479678,13325,'ba','Kuantitas yang sebelumnya diterima',0),(479679,13325,'nl','Eerder ontvangen aantal',0),(479680,13325,'fi','Aiemmin vastaanotettu mÃ¤Ã¤rÃ¤',0),(479681,13325,'no','Tidligere mottatt antall',0),(479682,13325,'da','Tidligere modtagne antal',0),(479683,13325,'ko','ì´ì „ì— ë°›ì€ ìˆ˜ëŸ‰',0),(479684,13325,'he','×”×›×ž×•×ª ×©×”×ª×§×‘×œ×” ×§×•×“× ×œ×›×Ÿ',0),(479685,13325,'el','Î ÏÎ¿Î·Î³Î¿Ï…Î¼Î­Î½Ï‰Ï‚ Ï€Î±ÏÎ±Î»Î·Ï†Î¸ÎµÎ¯ÏƒÎ± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(479686,13325,'zh','ä»¥å‰æ”¶åˆ°çš„æ•°é‡',0),(479687,13325,'sv','Kvantitet som tidigare fÃ¥tt',0),(479688,13325,'it','QuantitÃ  precedentemente ricevuto',0),(479689,13325,'tl','',0),(479690,13325,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(479691,13325,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¤¹à¤²à¥‡ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(479692,13325,'ms','Kuantiti yang sebelum ini telah',0),(479693,13325,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø³ØªÙ„Ù…Ø© Ø³Ø§Ø¨Ù‚Ø§',0),(479694,13325,'fr','QuantitÃ© reÃ§ue prÃ©cÃ©demment',0),(479695,13325,'jp','ä»¥å‰ã«å—ä¿¡ã—ãŸæ•°é‡',0),(479696,13325,'pt','Quantidade recebida anteriormente',0),(479697,13325,'ru','Ð Ð°Ð½ÐµÐµ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(479698,13325,'es','Cantida Previamente Recibida',0),(479699,13325,'de','Zuvor erhaltene Menge',0),(479700,13325,'en','Quantity Previously Received',0),(479701,13326,'is','',0),(479702,13326,'dr','Ø«Ø¨Øª Ù†Ø§Ù…',0),(479703,13326,'pr','Ø«Ø¨Øª Ù†Ø§Ù…',0),(479704,13326,'tr','KayÄ±t',0),(479705,13326,'pl','Rejestracja',0),(479706,13326,'bg','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(479707,13326,'ur','Ø³Ø§Ø¦Ù† Ø§Ù¾',0),(479708,13326,'sr','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€ÑƒÑ˜Ñ‚Ðµ ÑÐµ',0),(479709,13326,'vi','ÄÄƒng kÃ½',0),(479710,13326,'af','Intekening',0),(479711,13326,'ro','ÃŽnscriere',0),(479712,13326,'et','Registreerumine',0),(479713,13326,'si','Prijava',0),(479714,13326,'ba','Pendaftaran',0),(479715,13326,'nl','Signup',0),(479716,13326,'fi','Kirjaudu',0),(479717,13326,'no','Registrering',0),(479718,13326,'da','Tilmelding',0),(479719,13326,'ko','ê°€ìž…',0),(479720,13326,'he','×”×¨×©×ž×”',0),(479721,13326,'el','Î•Î³Î³ÏÎ±Ï†Î®',0),(479722,13326,'zh','æ³¨å†Œ',0),(479723,13326,'sv','Signup',0),(479724,13326,'it','Signup',0),(479725,13326,'tl','',0),(479726,13326,'th','à¸¥à¸‡à¸—à¸°à¹€à¸šà¸µà¸¢à¸™',0),(479727,13326,'hi','à¤¸à¤¾à¤‡à¤¨à¤…à¤ª',0),(479728,13326,'ms','Pendaftaran',0),(479729,13326,'ar','Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(479730,13326,'fr','Signup',0),(479731,13326,'jp','ã‚µã‚¤ãƒ³ã‚¢ãƒƒãƒ—',0),(479732,13326,'pt','Signup',0),(479733,13326,'ru','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(479734,13326,'es','Signup',0),(479735,13326,'de','Signup',0),(479736,13326,'en','Signup',0),(479737,13327,'is','',0),(479738,13327,'dr','30Ø±ÙˆØ² Ù…Ø¬Ø§Ù†ÙŠ',0),(479739,13327,'pr','30Ø±ÙˆØ² Ù…Ø¬Ø§Ù†ÙŠ',0),(479740,13327,'tr','30 gÃ¼n Ã¼cretsiz',0),(479741,13327,'pl','30 dni za darmo',0),(479742,13327,'bg','30 Ð´Ð½Ð¸ Ð±ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð¾',0),(479743,13327,'ur','30 Ø¯Ù† Ù…ÙØª',0),(479744,13327,'sr','30 Ð´Ð°Ð½Ð° Ð¾ÑÐ»Ð¾Ð±Ð¾Ð´Ð¸Ñ‚Ð¸.',0),(479745,13327,'vi','30 ngÃ y miá»…n phÃ­',0),(479746,13327,'af','30 dae vry',0),(479747,13327,'ro','30 de zile gratuit',0),(479748,13327,'et','30 pÃ¤eva tasuta',0),(479749,13327,'si','30 dni brezplaÄno',0),(479750,13327,'ba','30 hari gratis',0),(479751,13327,'nl','30 dagen gratis',0),(479752,13327,'fi','30 pÃ¤ivÃ¤Ã¤ ilmaiseksi',0),(479753,13327,'no','30 dagers gratis',0),(479754,13327,'da','30 dage gratis',0),(479755,13327,'ko','30 ì¼ ë¬´ë£Œ',0),(479756,13327,'he','30 ×™×•× ×—×™× ×',0),(479757,13327,'el','30 Î·Î¼Î­ÏÎµÏ‚ Î´Ï‰ÏÎµÎ¬Î½',0),(479758,13327,'zh','30å¤©å…è´¹',0),(479759,13327,'sv','30 dagar gratis',0),(479760,13327,'it','30 giorni gratis',0),(479761,13327,'tl','',0),(479762,13327,'th','à¸Ÿà¸£à¸µ 30 à¸§à¸±à¸™',0),(479763,13327,'hi','à¤¨à¤¿: à¤¶à¥à¤²à¥à¤• 30 à¤¦à¤¿à¤¨à¥‹à¤‚',0),(479764,13327,'ms','30 hari percuma',0),(479765,13327,'ar','Ù…Ø¬Ø§Ù†Ø§Ù‹ 30 ÙŠÙˆÙ…Ø§',0),(479766,13327,'fr','30 jours gratuits',0),(479767,13327,'jp','30 æ—¥é–“ç„¡æ–™ã—ã¾ã™ã€‚',0),(479768,13327,'pt','30 dias grÃ¡tis',0),(479769,13327,'ru','30 Ð´Ð½ÐµÐ¹ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(479770,13327,'es','30 DiÃ¡s Gratis',0),(479771,13327,'de','30 Tage kostenlos',0),(479772,13327,'en','30 Days Free',0),(479773,13328,'is','',0),(479774,13328,'dr','Ù…ÙˆØ§ÙÙ‚ Ø¨Ø§ Ù‚ÙˆØ§Ù†ÙŠÙ† Ø§ÙŠÙ† Ø³Ø±ÙˆÙŠØ³ Ù…ÙŠ Ø¨Ø§Ø´Ù…',0),(479775,13328,'pr','Ù…ÙˆØ§ÙÙ‚ Ø¨Ø§ Ù‚ÙˆØ§Ù†ÙŠÙ† Ø§ÙŠÙ† Ø³Ø±ÙˆÙŠØ³ Ù…ÙŠ Ø¨Ø§Ø´Ù…',0),(479776,13328,'tr','Hizmet ÅŸartlarÄ±nÄ± kabul ediyorum',0),(479777,13328,'pl','Zgadzam siÄ™ na warunki korzystania z usÅ‚ugi',0),(479778,13328,'bg','Ð¡Ðµ ÑÐ¿Ð¾Ñ€Ð°Ð·ÑƒÐ¼ÑÐ²Ð°Ñ‚ Ð·Ð° Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÑƒÑÐ»ÑƒÐ³Ð°Ñ‚Ð°',0),(479779,13328,'ur','Ø³Ø±ÙˆØ³ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø· Ø³Û’ Ù…ØªÙÙ‚ ÛÙˆÚº Û”',0),(479780,13328,'sr','ÐŸÑ€Ð¸ÑÑ‚Ð°Ñ‚Ð¸ Ð´Ð° ÑƒÑÐ»Ð¾Ð²Ð¸ Ð¿Ð¾ÑÐ»Ð¾Ð²Ð°ÑšÐ°',0),(479781,13328,'vi','Äá»“ng Ã½ vá»›i Ä‘iá»u khoáº£n Dá»‹ch vá»¥',0),(479782,13328,'af','Instem tot die terme van die diens',0),(479783,13328,'ro','Sunt de acord cu termeni de serviciu',0),(479784,13328,'et','NÃµustuma kasutustingimustega',0),(479785,13328,'si','Se strinjate z pogoji storitev',0),(479786,13328,'ba','Setuju dengan Ketentuan Layanan',0),(479787,13328,'nl','Ga akkoord met Terms of Service',0),(479788,13328,'fi','HyvÃ¤ksy kÃ¤yttÃ¶ehdot',0),(479789,13328,'no','Godta vilkÃ¥rene for tjenesten',0),(479790,13328,'da','Acceptere Terms of Service',0),(479791,13328,'ko','ì„œë¹„ìŠ¤ ì•½ê´€ì— ë™ì˜',0),(479792,13328,'he','×ž×¡×›×™× ×œ×ª×§× ×•×Ÿ ×”××ª×¨',0),(479793,13328,'el','Î£Ï…Î¼Ï†Ï‰Î½ÏŽ Î¼Îµ Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î·Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚',0),(479794,13328,'zh','åŒæ„æœåŠ¡æ¡æ¬¾',0),(479795,13328,'sv','Samtycker till anvÃ¤ndarvillkor',0),(479796,13328,'it','Accettare Termini e condizioni del servizio',0),(479797,13328,'tl','',0),(479798,13328,'th','à¸¢à¸­à¸¡à¸£à¸±à¸šà¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸šà¸£à¸´à¸à¸²à¸£',0),(479799,13328,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥€ à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤¸à¥‡ à¤¸à¤¹à¤®à¤¤ à¤¹à¥‚à¤',0),(479800,13328,'ms','Bersetuju dengan syarat-syarat Perkhidmatan',0),(479801,13328,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø´Ø±ÙˆØ· Ø§Ù„Ø®Ø¯Ù…Ø©',0),(479802,13328,'fr','Acceptez les termes de Service',0),(479803,13328,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã®åˆ©ç”¨è¦ç´„ã«åŒæ„ã—ã¾ã™ã€‚',0),(479804,13328,'pt','Concorda com os termos de serviÃ§o',0),(479805,13328,'ru','Ð¡Ð¾Ð³Ð»Ð°ÑÐµÐ½ Ñ ÑƒÑÐ»Ð¾Ð²Ð¸ÑÐ¼Ð¸ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑƒÑÐ»ÑƒÐ³',0),(479806,13328,'es','Acepto los terminos de Servicio',0),(479807,13328,'de','Nutzungsbedingungen zustimmen',0),(479808,13328,'en','Agree to Terms of Service',0),(479809,13329,'is','',0),(479810,13329,'dr','Ø§ÙŠØ¬Ø§Ø¯  ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ù…ÙŠØ²Ø¨Ø§Ù†ÙŠ',0),(479811,13329,'pr','Ø§ÙŠØ¬Ø§Ø¯  ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ù…ÙŠØ²Ø¨Ø§Ù†ÙŠ',0),(479812,13329,'tr','BarÄ±ndÄ±rÄ±lan bir hesabÄ± oluÅŸturmak',0),(479813,13329,'pl','UtwÃ³rz konto hostowane',0),(479814,13329,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾Ð¼Ð°ÐºÐ¸Ð½ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(479815,13329,'ur','Ø§ÛŒÚ© Ù…ÛŒØ²Ø¨Ø§Ù† Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(479816,13329,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ñ˜Ð°Ð²Ð½Ð¸Ñ… Ð½Ð°Ð»Ð¾Ð³Ð°',0),(479817,13329,'vi','Táº¡o má»™t tÃ i khoáº£n lÆ°u trá»¯',0),(479818,13329,'af','Skep \'n gehuisveste rekening',0),(479819,13329,'ro','CreaÅ£i un cont gazduit',0),(479820,13329,'et','Hosted konto',0),(479821,13329,'si','Ustvarite raÄun, ki je gostila',0),(479822,13329,'ba','Membuat Account host',0),(479823,13329,'nl','Een gehoste Account aanmaken',0),(479824,13329,'fi','Luo isÃ¤nnÃ¶i tili',0),(479825,13329,'no','Opprette en Hosted konto',0),(479826,13329,'da','Oprette en Hosted konto',0),(479827,13329,'ko','í˜¸ìŠ¤íŒ…ëœ ê³„ì • ë§Œë“¤ê¸°',0),(479828,13329,'he','×œ×™×¦×•×¨ ×—×©×‘×•×Ÿ ×ž×ª××¨×—',0),(479829,13329,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î­Î½Î±Î½ Ï†Î¹Î»Î¿Î¾ÎµÎ½Î¿ÏÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(479830,13329,'zh','åˆ›å»ºä¸€ä¸ªæ‰˜ç®¡å¸æˆ·',0),(479831,13329,'sv','Skapa en vÃ¤rd konto',0),(479832,13329,'it','Creare un Account ospitato',0),(479833,13329,'tl','',0),(479834,13329,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹‚à¸®à¸ªà¸•à¹Œà¸šà¸±à¸à¸Šà¸µ',0),(479835,13329,'hi','à¤•à¥‹à¤ˆ à¤¹à¥‹à¤¸à¥à¤Ÿà¥‡à¤¡ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(479836,13329,'ms','Cipta akaun dihos',0),(479837,13329,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø­Ø³Ø§Ø¨ Ø§Ø³ØªØ¶Ø§ÙØ©',0),(479838,13329,'fr','CrÃ©er un compte hÃ©bergÃ©',0),(479839,13329,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ãƒ›ã‚¹ãƒˆã‚’ä½œæˆã—ã¾ã™ã€‚',0),(479840,13329,'pt','Criar uma conta hospedada',0),(479841,13329,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð½Ð¾Ð¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(479842,13329,'es','Crear Una Cuenta Hospedada',0),(479843,13329,'de','Ein gehostetes Konto erstellen',0),(479844,13329,'en','Create A Hosted Account',0),(479845,13330,'is','',0),(479846,13330,'dr','Ø§ÙŠØ¬Ø§Ø¯  ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ù…ÙŠØ²Ø¨Ø§Ù†ÙŠ',0),(479847,13330,'pr','Ø§ÙŠØ¬Ø§Ø¯  ÙŠÙƒ Ø­Ø³Ø§Ø¨ Ù…ÙŠØ²Ø¨Ø§Ù†ÙŠ',0),(479848,13330,'tr','Site oluÅŸturma',0),(479849,13330,'pl','Tworzenie witryny',0),(479850,13330,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¼Ð¾Ñ ÑÐ°Ð¹Ñ‚',0),(479851,13330,'ur','Ù…ÛŒØ±ÛŒ ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(479852,13330,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(479853,13330,'vi','Táº¡o trang web cá»§a tÃ´i',0),(479854,13330,'af','Skep My werf',0),(479855,13330,'ro','CreaÅ£i site-ul meu',0),(479856,13330,'et','Minu saidi loomine',0),(479857,13330,'si','Ustvarite svojo spletno stran',0),(479858,13330,'ba','Membuat situs saya',0),(479859,13330,'nl','Mijn Site maken',0),(479860,13330,'fi','Luo oma sivusto',0),(479861,13330,'no','Opprette webomrÃ¥det mitt',0),(479862,13330,'da','Oprette min hjemmeside',0),(479863,13330,'ko','ë‚´ ì‚¬ì´íŠ¸ ë§Œë“¤ê¸°',0),(479864,13330,'he','×¦×•×¨ ××ª ×”××ª×¨ ×©×œ×™',0),(479865,13330,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Ï„Î·Î½ Î¹ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î± Î¼Î¿Ï…',0),(479866,13330,'zh','åˆ›å»ºâ€œæˆ‘çš„ç½‘ç«™â€',0),(479867,13330,'sv','Skapa min webbplats',0),(479868,13330,'it','Creare il mio sito',0),(479869,13330,'tl','',0),(479870,13330,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(479871,13330,'hi','à¤®à¥‡à¤°à¥€ à¤¸à¤¾à¤‡à¤Ÿ à¤¬à¤¨à¤¾à¤à¤',0),(479872,13330,'ms','Mencipta Laman web saya',0),(479873,13330,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø®Ø§Øµ Ø¨ÙŠ',0),(479874,13330,'fr','CrÃ©er mon Site',0),(479875,13330,'jp','ç§ã®ã‚µã‚¤ãƒˆã‚’ä½œæˆã—ã¾ã™ã€‚',0),(479876,13330,'pt','Criar meu Site',0),(479877,13330,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ ÑÐ²Ð¾Ð¹ ÑÐ°Ð¹Ñ‚',0),(479878,13330,'es','Crear Mi Sitio',0),(479879,13330,'de','Meine Website erstellen',0),(479880,13330,'en','Create My Site',0),(479881,13331,'is','',0),(479882,13331,'dr','ØªØµÙˆÙŠØ± Ù…ØªÙØ§ÙˆØª',0),(479883,13331,'pr','ØªØµÙˆÙŠØ± Ù…ØªÙØ§ÙˆØª',0),(479884,13331,'tr','FarklÄ± resim',0),(479885,13331,'pl','Inny obraz',0),(479886,13331,'bg','Ð˜Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð¸',0),(479887,13331,'ur','Ù…Ø®ØªÙ„Ù ØªØµÙˆÛŒØ±',0),(479888,13331,'sr','Ð”Ñ€ÑƒÐ³Ð°Ñ‡Ð¸Ñ˜Ñƒ ÑÐ»Ð¸ÐºÑƒ',0),(479889,13331,'vi','HÃ¬nh áº£nh khÃ¡c nhau',0),(479890,13331,'af','Verskillende beeld',0),(479891,13331,'ro','Imagini diferite',0),(479892,13331,'et','Teistsugust pilti',0),(479893,13331,'si','DrugaÄno sliko',0),(479894,13331,'ba','Gambar yang berbeda',0),(479895,13331,'nl','Andere afbeelding',0),(479896,13331,'fi','Erilainen kuva',0),(479897,13331,'no','Annet bilde',0),(479898,13331,'da','Andet billede',0),(479899,13331,'ko','ë‹¤ë¥¸ ì´ë¯¸ì§€',0),(479900,13331,'he','×ª×ž×•× ×” ×©×•× ×”',0),(479901,13331,'el','Î”Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÎ® ÎµÎ¹ÎºÏŒÎ½Î±',0),(479902,13331,'zh','ä¸åŒçš„å›¾åƒ',0),(479903,13331,'sv','Annan bild',0),(479904,13331,'it','Immagine diversa',0),(479905,13331,'tl','',0),(479906,13331,'th','à¸ à¸²à¸žà¸­à¸·à¹ˆà¸™',0),(479907,13331,'hi','à¤…à¤²à¤— à¤›à¤µà¤¿',0),(479908,13331,'ms','Gambar yang berbeza',0),(479909,13331,'ar','ØµÙˆØ±Ø© Ù…Ø®ØªÙ„ÙØ©',0),(479910,13331,'fr','Image diffÃ©rente',0),(479911,13331,'jp','åˆ¥ã®ç”»åƒ',0),(479912,13331,'pt','Imagem diferente',0),(479913,13331,'ru','Ð Ð°Ð·Ð»Ð¸Ñ‡Ð½Ñ‹Ðµ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(479914,13331,'es','Imagen Diferente',0),(479915,13331,'de','Anderes Bild',0),(479916,13331,'en','Different Image',0),(479917,13332,'is','',0),(479918,13332,'dr','ÙƒØ§Ø±ÙƒØªØ±Ù‡Ø§ÙŠ ØªØµÙˆÙŠØ± Ø§Ù…Ù†ÙŠØªÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(479919,13332,'pr','ÙƒØ§Ø±ÙƒØªØ±Ù‡Ø§ÙŠ ØªØµÙˆÙŠØ± Ø§Ù…Ù†ÙŠØªÙŠ Ø±Ø§ ÙˆØ§Ø±Ø¯ ÙƒÙ†ÙŠØ¯',0),(479920,13332,'tr','BoldSecurity gÃ¶rÃ¼ntÃ¼ metin giriÅŸi',0),(479921,13332,'pl','WejÅ›cie boldSecurity obrazka',0),(479922,13332,'bg','Ð’ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° boldSecurity Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ Ñ‚ÐµÐºÑÑ‚',0),(479923,13332,'ur','Ø¨ÙˆÙ„ÚˆØ³ÛŒÚ©ÙˆØ±Ø§Ù¹ÛŒ ØªØµÙˆÛŒØ± Ù…ØªÙ† Ø§Ù† Ù¾Ù¹',0),(479924,13332,'sr','Ð£Ð½Ð¾Ñ Ð±Ð¾Ð»Ð´Ð¡ÐµÑ†ÑƒÑ€Ð¸Ñ‚y Ñ‚ÐµÐºÑÑ‚ ÑÐ° ÑÐ»Ð¸ÐºÐµ',0),(479925,13332,'vi','BoldSecurity hÃ¬nh áº£nh vÄƒn báº£n Ä‘áº§u vÃ o',0),(479926,13332,'af','Insette van die boldSecurity beeld teks',0),(479927,13332,'ro','Intrare boldSecurity imagine text',0),(479928,13332,'et','Sisend boldSecurity pildi tekst',0),(479929,13332,'si','VloÅ¾ek boldSecurity podoba besedila',0),(479930,13332,'ba','Masukan boldSecurity teks gambar',0),(479931,13332,'nl','Ingang van de boldSecurity afbeelding tekst',0),(479932,13332,'fi','SyÃ¶tÃ¤ kuvan teksti boldSecurity',0),(479933,13332,'no','Input boldSecurity bilde tekst',0),(479934,13332,'da','Input boldSecurity billedtekst',0),(479935,13332,'ko','BoldSecurity ì´ë¯¸ì§€ í…ìŠ¤íŠ¸ ìž…ë ¥',0),(479936,13332,'he','×§×œ×˜ boldSecurity ×©×œ ×ª×ž×•× ×” ×˜×§×¡×˜',0),(479937,13332,'el','Î•Î¹ÏƒÏŒÎ´Î¿Ï… boldSecurity Ï„Î¿ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ Ï„Î·Ï‚ ÎµÎ¹ÎºÏŒÎ½Î±Ï‚',0),(479938,13332,'zh','è¾“å…¥çš„çš„å¤§èƒ†å®‰å…¨å›¾ç‰‡æ–‡å­—',0),(479939,13332,'sv','IngÃ¥ng boldSecurity bild text',0),(479940,13332,'it','BoldSecurity immagini di testo di input',0),(479941,13332,'tl','',0),(479942,13332,'th','à¸›à¹‰à¸­à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥ boldSecurity à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸£à¸¹à¸›à¸ à¸²à¸ž',0),(479943,13332,'hi','BoldSecurity à¤›à¤µà¤¿ à¤ªà¤¾à¤  à¤‡à¤¨à¤ªà¥à¤Ÿ',0),(479944,13332,'ms','Input boldSecurity imej teks',0),(479945,13332,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø¨ÙˆÙ„Ø¯Ø³ÙŠÙƒÙˆØ±ÙŠØªÙŠ Ù†Øµ Ø§Ù„ØµÙˆØ±Ø©',0),(479946,13332,'fr','Entrez le texte de l\'Image de boldSecurity',0),(479947,13332,'jp','BoldSecurity ã®ã‚¤ãƒ¡ãƒ¼ã‚¸ã®ãƒ†ã‚­ã‚¹ãƒˆã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(479948,13332,'pt','Entrada a boldSecurity imagem texto',0),(479949,13332,'ru','Ð’Ð²Ð¾Ð´ boldSecurity Ñ‚ÐµÐºÑÑ‚ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(479950,13332,'es','Introduzca el texto que aparece en negrita de la imagen de seguridad',0),(479951,13332,'de','Eingabe der BoldSecurity Bild-text',0),(479952,13332,'en','Input the boldSecurity Image text',0),(479953,13333,'is','',0),(479954,13333,'dr','Ù…Ù† Ø®ÙˆØ§Ù†Ø¯Ù‡ Ùˆ Ù…ÙˆØ§ÙÙ‚ Ø¨Ù‡ Ø´Ø±Ø§ÛŒØ· Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø®Ø¯Ù…Ø§Øª.',0),(479955,13333,'pr','Ù…Ù† Ø®ÙˆØ§Ù†Ø¯Ù‡ Ùˆ Ù…ÙˆØ§ÙÙ‚ Ø¨Ù‡ Ø´Ø±Ø§ÛŒØ· Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø®Ø¯Ù…Ø§Øª.',0),(479956,13333,'tr','Okudum ve hizmet koÅŸullarÄ±nÄ± kabul ediyorum.',0),(479957,13333,'pl','PrzeczytaÅ‚em i zgadzam siÄ™ na warunki korzystania z usÅ‚ugi.',0),(479958,13333,'bg','ÐÐ· Ð¿Ñ€Ð¾Ñ‡ÐµÑ‚Ð¾Ñ… Ð¸ ÑÐµ ÑÑŠÐ³Ð»Ð°ÑÑÐ²Ð°Ñ‚ Ñ ÑƒÑÐ»Ð¾Ð²Ð¸ÑÑ‚Ð° Ð·Ð° Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ.',0),(479959,13333,'ur','Ù…ÛŒÚº Ù†Û’ Ù¾Ú‘Ú¾Ø§ ÛÛ’ Ø§ÙˆØ± Ø³Ø±ÙˆØ³ Ú©ÛŒ Ø´Ø±Ø§Ø¦Ø· Ø³Û’ Ø§ØªÙØ§Ù‚ Ú©Ø±ØªØ§ ÛÙˆÚº Û”',0),(479960,13333,'sr','ÐˆÐ° Ð¸Ð¼Ð°Ñ‚Ð¸ Ñ‡Ð¸Ñ‚Ð°ÑšÐµ Ð¸ Ð¿Ñ€Ð¸ÑÑ‚Ð°Ñ‚Ð¸ Ð½Ð° ÑƒÑÐ»Ð¾Ð²Ðµ ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐ° ÑƒÑÐ»ÑƒÐ³Ð°.',0),(479961,13333,'vi','TÃ´i Ä‘Ã£ Ä‘á»c vÃ  Ä‘á»“ng Ã½ vá»›i Ä‘iá»u khoáº£n Dá»‹ch vá»¥.',0),(479962,13333,'af','Ek het gelees en toestem tot die terme van die diens.',0),(479963,13333,'ro','Am citit ÅŸi sunt de acord cu termenii de serviciu.',0),(479964,13333,'et','Olen lugenud ja nÃµustute teenusetingimustega.',0),(479965,13333,'si','Prebral sem in se strinjati s pogoji storitve.',0),(479966,13333,'ba','Saya telah membaca dan menyetujui persyaratan layanan.',0),(479967,13333,'nl','Ik heb gelezen en ga akkoord met de Terms of Service.',0),(479968,13333,'fi','Olen lukenut ja hyvÃ¤ksyn kÃ¤yttÃ¶ehdot.',0),(479969,13333,'no','Jeg har lest og godtar vilkÃ¥rene for bruk.',0),(479970,13333,'da','Jeg har lÃ¦st og accepterer Terms of service.',0),(479971,13333,'ko','ì½ê³ ì™€ ì„œë¹„ìŠ¤ ì•½ê´€ì— ë™ì˜ í•©ë‹ˆë‹¤.',0),(479972,13333,'he','×§×¨××ª×™ ×•×× ×™ ×ž×¡×›×™× ×œ×ª× ××™ ×”×©×™×¨×•×ª.',0),(479973,13333,'el','ÎˆÏ‡Ï‰ Î´Î¹Î±Î²Î¬ÏƒÎµÎ¹ ÎºÎ±Î¹ ÏƒÏ…Î¼Ï†Ï‰Î½ÎµÎ¯Ï„Îµ Î¼Îµ Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î·Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±Ï‚.',0),(479974,13333,'zh','æˆ‘å·²é˜…è¯»å¹¶åŒæ„æœåŠ¡æ¡æ¬¾ã€‚',0),(479975,13333,'sv','Jag har lÃ¤st och godkÃ¤nner anvÃ¤ndarvillkoren.',0),(479976,13333,'it','Letto e accetto i termini di servizio.',0),(479977,13333,'tl','',0),(479978,13333,'th','à¸‰à¸±à¸™à¹„à¸”à¹‰à¸­à¹ˆà¸²à¸™ à¹à¸¥à¸°à¸¢à¸­à¸¡à¸£à¸±à¸šà¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸šà¸£à¸´à¸à¸²à¸£',0),(479979,13333,'hi','à¤®à¥ˆà¤‚à¤¨à¥‡ à¤ªà¤¢à¤¼à¤¾ à¤¹à¥ˆ à¤”à¤° à¤¸à¥‡à¤µà¤¾ à¤•à¥€ à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤¸à¥‡ à¤¸à¤¹à¤®à¤¤ à¤¹à¥‚à¤à¥¤',0),(479980,13333,'ms','Saya telah membaca dan bersetuju dengan terma-terma Perkhidmatan.',0),(479981,13333,'ar','Ù„Ù‚Ø¯ Ù‚Ø±Ø£Øª ÙˆØªÙˆØ§ÙÙ‚ Ø¹Ù„Ù‰ \"Ø´Ø±ÙˆØ· Ø§Ù„Ø®Ø¯Ù…Ø©\".',0),(479982,13333,'fr','J\'ai lu et accepte les conditions d\'utilisation.',0),(479983,13333,'jp','èª­ã‚“ã ã“ã¨ãŒã‚ã‚‹ã—ã€ã‚µãƒ¼ãƒ“ã‚¹ã®åˆ©ç”¨è¦ç´„ã«åŒæ„ã—ã¾ã™ã€‚',0),(479984,13333,'pt','Eu li e concordo com os termos de serviÃ§o.',0),(479985,13333,'ru','Ð¯ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ð» Ð¸ ÑÐ¾Ð³Ð»Ð°ÑÐµÐ½ Ñ ÑƒÑÐ»Ð¾Ð²Ð¸ÑÐ¼Ð¸ ÑÐµÑ€Ð²Ð¸ÑÐ°.',0),(479986,13333,'es','He Leido y estoy de acuerdo con los terminos de Servicio',0),(479987,13333,'de','Ich habe gelesen und stimme den allgemeinen GeschÃ¤ftsbedingungen.',0),(479988,13333,'en','I have read and agree to the Terms of Service.',0),(479989,13334,'is','',0),(479990,13334,'dr','Ø¨Ø§Ø±',0),(479991,13334,'pr','Ø¨Ø§Ø±',0),(479992,13334,'tr','YÃ¼kleme',0),(479993,13334,'pl','Åadowanie',0),(479994,13334,'bg','Ð—Ð°Ñ€ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð°',0),(479995,13334,'ur','Ù„ÙˆÚˆ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(479996,13334,'sr','Ð£Ñ‡Ð¸Ñ‚Ð°Ð²Ð°ÑšÐµ',0),(479997,13334,'vi','Táº£i',0),(479998,13334,'af','Laai tans',0),(479999,13334,'ro','ÃŽncÄƒrcare',0),(480000,13334,'et','Laadimine',0),(480001,13334,'si','Nalaganje',0),(480002,13334,'ba','Pemuatan',0),(480003,13334,'nl','Laden',0),(480004,13334,'fi','Lastaus',0),(480005,13334,'no','Lasting',0),(480006,13334,'da','Lastning',0),(480007,13334,'ko','ë¡œë“œ',0),(480008,13334,'he','×˜×¢×™× ×”',0),(480009,13334,'el','Î¦ÏŒÏÏ„Ï‰ÏƒÎ·',0),(480010,13334,'zh','è½½å…¥ä¸­',0),(480011,13334,'sv','Lastning',0),(480012,13334,'it','Caricamento',0),(480013,13334,'tl','',0),(480014,13334,'th','à¹‚à¸«à¸¥à¸”',0),(480015,13334,'hi','à¤²à¥‹à¤¡ à¤¹à¥‹ à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(480016,13334,'ms','Memuatkan',0),(480017,13334,'ar','ØªØ­Ù…ÙŠÙ„',0),(480018,13334,'fr','Chargement',0),(480019,13334,'jp','èª­ã¿è¾¼ã¿',0),(480020,13334,'pt','A carregar',0),(480021,13334,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·ÐºÐ°',0),(480022,13334,'es','Cargando',0),(480023,13334,'de','Laden',0),(480024,13334,'en','Loading',0),(480025,13335,'is','',0),(480026,13335,'dr','16 ÙƒØ§Ø±Ø§ÙƒØªØ±',0),(480027,13335,'pr','ÙÙ‚Ø· Ø­Ø±ÙˆÙ ÙˆØ§Ø¹Ø¯Ø§Ø¯â€”Ø­Ø¯Ø§ÙƒØ«Ø± 16 ÙƒØ§Ø±Ø§ÙƒØªØ±',0),(480028,13335,'tr','Sadece harfler & numaralar--16 en fazla',0),(480029,13335,'pl','Tylko litery & numery--maksymalnie 16',0),(480030,13335,'bg','Ð¡Ð°Ð¼Ð¾ Ð±ÑƒÐºÐ²Ð¸ & Ñ‡Ð¸ÑÐ»Ð°--Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð¾Ñ‚ 16',0),(480031,13335,'ur','ØµØ±Ù Ø®Ø·ÙˆØ· & Ù†Ù…Ø¨Ø± - 16 Ú©ÛŒ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(480032,13335,'sr','Ð¡Ð»Ð¾Ð²Ð° Ð¸ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ð¸ - Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¾ 16 ÑÐ°Ð¼Ð¾',0),(480033,13335,'vi','Chá»‰ thÆ° &amp; sá»‘--tá»‘i Ä‘a 16',0),(480034,13335,'af','Slegs letters en getalle - maksimum van 16',0),(480035,13335,'ro','Doar litere & numere--maxim 16',0),(480036,13335,'et','Ainult tÃ¤hed & numbreid--mitte Ã¼le 16',0),(480037,13335,'si','Le Ärke & Å¡tevilke--najveÄ 16',0),(480038,13335,'ba','Hanya huruf & nomor--maksimum 16',0),(480039,13335,'nl','Alleen brieven & nummers--maximaal 16',0),(480040,13335,'fi','Vain kirjaimet & numerot--enintÃ¤Ã¤n 16',0),(480041,13335,'no','Bare bokstaver & tall, maksimalt 16',0),(480042,13335,'da','Kun bogstaver & numre--hÃ¸jst 16',0),(480043,13335,'ko','ë¬¸ìž & ìˆ«ìž-16ì˜ ìµœëŒ€',0),(480044,13335,'he','×¨×§ ××•×ª×™×•×ª & ×ž×¡×¤×¨×™× ×ž×§×¡×™×ž×œ×™×ª ×©×œ 16',0),(480045,13335,'el','ÎœÏŒÎ½Î¿ Î³ÏÎ¬Î¼Î¼Î±Ï„Î± & Î±ÏÎ¹Î¸Î¼ÏŽÎ½--Ï„Î¿ Î¼Î­Î³Î¹ÏƒÏ„Î¿ Ï„Ï‰Î½ 16',0),(480046,13335,'zh','åªæœ‰å­—æ¯ &amp; æ•°å­— â€” â€” æœ€å¤š 16',0),(480047,13335,'sv','Endast bokstÃ¤ver & nummer--maximalt 16',0),(480048,13335,'it','Solo lettere & numeri--massimi di 16',0),(480049,13335,'tl','',0),(480050,13335,'th','à¹€à¸‰à¸žà¸²à¸°à¸•à¸±à¸§à¸­à¸±à¸à¸©à¸£ & à¹€à¸¥à¸‚ - à¸ˆà¸³à¸™à¸§à¸™ 16',0),(480051,13335,'hi','à¤•à¥‡à¤µà¤² à¤ªà¤¤à¥à¤° & à¤¸à¤‚à¤–à¥à¤¯à¤¾ - 16 à¤•à¥€ à¤…à¤§à¤¿à¤•à¤¤à¤®',0),(480052,13335,'ms','Hanya Surat & nombor--maksimum 16',0),(480053,13335,'ar','ÙÙ‚Ø· Ø±Ø³Ø§Ø¦Ù„ Ø¢Ù†Ø¯ Ø£Ø±Ù‚Ø§Ù…-Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù…Ù† 16',0),(480054,13335,'fr','Seulement les lettres & les nombres--maximale de 16',0),(480055,13335,'jp','æ‰‹ç´™ & ç•ªå·--æœ€å¤§ 16 ã®',0),(480056,13335,'pt','Apenas letras & nÃºmeros..--mÃ¡ximos de 16',0),(480057,13335,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð±ÑƒÐºÐ²Ñ‹ & Ñ‡Ð¸ÑÐµÐ»--Ð¼Ð°ÐºÑÐ¸Ð¼ÑƒÐ¼ 16',0),(480058,13335,'es','*Solamente letras y numeros -- maximo hasta 16',0),(480059,13335,'de','Nur Buchstaben & Zahlen--maximal 16',0),(480060,13335,'en','Only letters & numbers -- maximum of 16',0),(480061,13336,'is','',0),(480062,13336,'dr','Ù‡Ø± Ù…Ø§Ù‡',0),(480063,13336,'pr','Ù‡Ø± Ù…Ø§Ù‡',0),(480064,13336,'tr','Ay baÅŸÄ±na',0),(480065,13336,'pl','MiesiÄ™cznie',0),(480066,13336,'bg','ÐÐ° Ð¼ÐµÑÐµÑ†',0),(480067,13336,'ur','ÙÛŒ Ù…ÛÛŒÙ†Û',0),(480068,13336,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¾',0),(480069,13336,'vi','Má»—i thÃ¡ng',0),(480070,13336,'af','Per maand',0),(480071,13336,'ro','Pe lunÄƒ',0),(480072,13336,'et','Kuus',0),(480073,13336,'si','Na mesec',0),(480074,13336,'ba','Per bulan',0),(480075,13336,'nl','Per maand',0),(480076,13336,'fi','Kuukaudessa',0),(480077,13336,'no','Per mÃ¥ned',0),(480078,13336,'da','Pr. mÃ¥ned',0),(480079,13336,'ko','ë‹¬ ë‹¹',0),(480080,13336,'he','×œ×—×•×“×©',0),(480081,13336,'el','Î‘Î½Î¬ Î¼Î®Î½Î±',0),(480082,13336,'zh','æ¯æœˆ',0),(480083,13336,'sv','Per mÃ¥nad',0),(480084,13336,'it','Al mese',0),(480085,13336,'tl','',0),(480086,13336,'th','à¸•à¹ˆà¸­à¹€à¸”à¸·à¸­à¸™',0),(480087,13336,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤®à¤¾à¤¹',0),(480088,13336,'ms','Setiap bulan',0),(480089,13336,'ar','ÙÙŠ Ø§Ù„Ø´Ù‡Ø±',0),(480090,13336,'fr','Par mois',0),(480091,13336,'jp','1 ãƒ¶æœˆã‚ãŸã‚Š',0),(480092,13336,'pt','Por mÃªs',0),(480093,13336,'ru','Ð’ Ð¼ÐµÑÑÑ†',0),(480094,13336,'es','Por Mes',0),(480095,13336,'de','Pro Monat',0),(480096,13336,'en','Per Month',0),(480097,13337,'is','',0),(480098,13337,'dr','Ù‡Ø± Ø³Ù‡ Ù…Ø§Ù‡',0),(480099,13337,'pr','Ù‡Ø± Ø³Ù‡ Ù…Ø§Ù‡',0),(480100,13337,'tr','ÃœÃ§ aylÄ±k dÃ¶nem',0),(480101,13337,'pl','Na kwartaÅ‚',0),(480102,13337,'bg','ÐÐ° Ñ‚Ñ€Ð¸Ð¼ÐµÑÐµÑ‡Ð¸Ðµ',0),(480103,13337,'ur','Ø³Û Ù…Ø§ÛÛŒ ÙÛŒ',0),(480104,13337,'sr','Ð¢Ñ€Ð¾Ð¼Ñ˜ÐµÑÐµÑ‡Ð½Ð¾',0),(480105,13337,'vi','Má»—i quÃ½',0),(480106,13337,'af','Per kwartaal',0),(480107,13337,'ro','Per trimestru',0),(480108,13337,'et','Kvartalis',0),(480109,13337,'si','Na Äetrtletje',0),(480110,13337,'ba','Per kuartal',0),(480111,13337,'nl','Per kwartaal',0),(480112,13337,'fi','VuosineljÃ¤nneksittÃ¤in',0),(480113,13337,'no','Per kvartal',0),(480114,13337,'da','Pr. kvartal',0),(480115,13337,'ko','ë¶„ê¸° ë§ˆë‹¤',0),(480116,13337,'he','×œ×›×œ ×¨×•×‘×¢',0),(480117,13337,'el','Î‘Î½Î¬ Ï„ÏÎ¯Î¼Î·Î½Î¿',0),(480118,13337,'zh','æ¯ä¸ªå­£åº¦',0),(480119,13337,'sv','Per kvartal',0),(480120,13337,'it','Per il quarto',0),(480121,13337,'tl','',0),(480122,13337,'th','à¸•à¹ˆà¸­à¹„à¸•à¸£à¸¡à¸²à¸ª',0),(480123,13337,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤¤à¤¿à¤®à¤¾à¤¹à¥€',0),(480124,13337,'ms','Setiap suku',0),(480125,13337,'ar','Ø§Ù„ÙˆØ§Ø­Ø¯Ø© ÙˆØ§Ù„Ø±Ø¨Ø¹',0),(480126,13337,'fr','Par trimestre',0),(480127,13337,'jp','å››åŠæœŸã”ã¨',0),(480128,13337,'pt','Por trimestre',0),(480129,13337,'ru','Ð—Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(480130,13337,'es','Por Trimestre',0),(480131,13337,'de','Pro Quartal',0),(480132,13337,'en','Per Quarter',0),(480133,13338,'is','',0),(480134,13338,'dr','Ø¯Ø± Ù‡Ø± Ø³Ø§Ù„',0),(480135,13338,'pr','Ø¯Ø± Ù‡Ø± Ø³Ø§Ù„',0),(480136,13338,'tr','YÄ±l baÅŸÄ±na',0),(480137,13338,'pl','Rocznie',0),(480138,13338,'bg','Ð“Ð¾Ð´Ð¸ÑˆÐ½Ð¾',0),(480139,13338,'ur','ÛØ± Ø³Ø§Ù„',0),(480140,13338,'sr','Ð¡Ð²Ð°ÐºÐµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(480141,13338,'vi','Má»—i nÄƒm',0),(480142,13338,'af','Per jaar',0),(480143,13338,'ro','Pe an',0),(480144,13338,'et','Aastas',0),(480145,13338,'si','Na leto',0),(480146,13338,'ba','Per tahun',0),(480147,13338,'nl','Per jaar',0),(480148,13338,'fi','Vuodessa',0),(480149,13338,'no','Per Ã¥r',0),(480150,13338,'da','Pr. Ã¥r',0),(480151,13338,'ko','ë…„ ë‹¹',0),(480152,13338,'he','×‘×›×œ ×©× ×”',0),(480153,13338,'el','Î‘Î½Î¬ Î­Ï„Î¿Ï‚',0),(480154,13338,'zh','æ¯å¹´',0),(480155,13338,'sv','Per Ã¥r',0),(480156,13338,'it','L\'anno',0),(480157,13338,'tl','',0),(480158,13338,'th','à¸•à¹ˆà¸­à¸›à¸µ',0),(480159,13338,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤·',0),(480160,13338,'ms','Setiap tahun',0),(480161,13338,'ar','ÙÙŠ Ø§Ù„Ø³Ù†Ø©',0),(480162,13338,'fr','Par an',0),(480163,13338,'jp','1 å¹´é–“',0),(480164,13338,'pt','Por ano',0),(480165,13338,'ru','Ð’ Ð³Ð¾Ð´',0),(480166,13338,'es','Por AÃ±o',0),(480167,13338,'de','Pro Jahr',0),(480168,13338,'en','Per Year',0),(480169,13339,'is','',0),(480170,13339,'dr','.',0),(480171,13339,'pr','Ø¢ÛŒØ§ ØµÙØ­Ù‡ Ø±Ø§ Ù†ÙˆØ³Ø§Ø²ÛŒ Ú©Ù†ÛŒØ¯.',0),(480172,13339,'tr','LÃ¼tfen sayfayÄ± yenileyin deÄŸil.',0),(480173,13339,'pl','ProszÄ™ nie odÅ›wieÅ¼yÄ‡ stronÄ™.',0),(480174,13339,'bg','ÐœÐ¾Ð»Ñ Ð½Ðµ Ð¾Ð±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð°.',0),(480175,13339,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒØŒ ØµÙØ­Û’ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(480176,13339,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ, Ð½Ðµ Ð¾ÑÐ²ÐµÐ¶Ð¸Ñ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ.',0),(480177,13339,'vi','Xin vui lÃ²ng, khÃ´ng lÃ m má»›i trang.',0),(480178,13339,'af','Asseblief, nie Verfris die bladsy.',0),(480179,13339,'ro','VÄƒ rugÄƒm, reÃ®mprospÄƒtaÈ›i pagina.',0),(480180,13339,'et','Palun vÃ¤rskendage leht.',0),(480181,13339,'si','Prosim, ne osveÅ¾ite stran.',0),(480182,13339,'ba','Tolong, tidak refresh halaman.',0),(480183,13339,'nl','Alsjeblieft, niet de pagina te vernieuwen.',0),(480184,13339,'fi','Ole hyvÃ¤ Ã„lÃ¤ pÃ¤ivitÃ¤ sivu.',0),(480185,13339,'no','Vennligst ikke Oppdater siden.',0),(480186,13339,'da','Opdater venligst, ikke siden.',0),(480187,13339,'ko','ì œë°œ, íŽ˜ì´ì§€ ìƒˆë¡œ ê³ ì¹˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(480188,13339,'he','. ×‘×‘×§×©×”, ××œ ×ª×¨×¢× ×Ÿ ××ª ×”×“×£.',0),(480189,13339,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ, Î´ÎµÎ½ Î±Î½Î±Î½ÎµÏŽÏƒÎµÏ„Îµ Ï„Î· ÏƒÎµÎ»Î¯Î´Î±.',0),(480190,13339,'zh','è¯·ä¸è¦åˆ·æ–°é¡µé¢ã€‚',0),(480191,13339,'sv','SnÃ¤lla, inte uppdatera sidan.',0),(480192,13339,'it','Per favore, non aggiornare la pagina.',0),(480193,13339,'tl','',0),(480194,13339,'th','à¸à¸£à¸¸à¸“à¸² à¸Ÿà¸·à¹‰à¸™à¸Ÿà¸¹à¸«à¸™à¹‰à¸²',0),(480195,13339,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾, à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‹ à¤¤à¤¾à¤œà¤¼à¤¾ à¤¨à¤¹à¥€à¤‚à¥¤',0),(480196,13339,'ms','Sila refresh halaman.',0),(480197,13339,'ar','Ù„Ø§ØŒ Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„ØµÙØ­Ø©.',0),(480198,13339,'fr','S\'il vous plaÃ®t, ne pas actualiser la page.',0),(480199,13339,'jp','ãã ã•ã„ã€ãƒšãƒ¼ã‚¸ã¯æ›´æ–°ã•ã‚Œã¾ã›ã‚“ã€‚',0),(480200,13339,'pt','Por favor, nÃ£o atualize a pÃ¡gina.',0),(480201,13339,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð½Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ.',0),(480202,13339,'es','Por favor, no actualice la pÃ¡gina.',0),(480203,13339,'de','Aktualisieren Sie die Seite bitte nicht.',0),(480204,13339,'en','Please, do not refresh the page.',0),(480205,13340,'is','',0),(480206,13340,'dr','Ù†ÙˆØ¹ Ø§Ø´ØªØ±Ø§Ùƒ',0),(480207,13340,'pr','Ù†ÙˆØ¹ Ø§Ø´ØªØ±Ø§Ùƒ',0),(480208,13340,'tr','Abonelik tÃ¼rÃ¼',0),(480209,13340,'pl','Typ subskrypcji',0),(480210,13340,'bg','Ð¢Ð¸Ð¿ Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(480211,13340,'ur','Ø±Ú©Ù†ÛŒØª Ú©ÛŒ Ù‚Ø³Ù…',0),(480212,13340,'sr','Ð¢Ð¸Ð¿ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(480213,13340,'vi','Loáº¡i hÃ¬nh thuÃª bao',0),(480214,13340,'af','Intekengeld tipe',0),(480215,13340,'ro','Tip abonament',0),(480216,13340,'et','Tellimuse tÃ¼Ã¼p',0),(480217,13340,'si','Vrsta naroÄnine',0),(480218,13340,'ba','Jenis langganan',0),(480219,13340,'nl','Abonnementstype',0),(480220,13340,'fi','Tilauksen tyyppi',0),(480221,13340,'no','Abonnementstype',0),(480222,13340,'da','Abonnementstype',0),(480223,13340,'ko','êµ¬ë… ìœ í˜•',0),(480224,13340,'he','×¡×•×’ ×”×ž× ×•×™',0),(480225,13340,'el','Î¤ÏÏ€Î¿ Ï„Î·Ï‚ ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®Ï‚',0),(480226,13340,'zh','è®¢é˜…ç±»åž‹',0),(480227,13340,'sv','Typ av prenumeration',0),(480228,13340,'it','Tipo di abbonamento',0),(480229,13340,'tl','',0),(480230,13340,'th','à¸›à¸£à¸°à¹€à¸ à¸—à¸ªà¸¡à¸²à¸Šà¸´à¸',0),(480231,13340,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(480232,13340,'ms','Jenis yuran',0),(480233,13340,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(480234,13340,'fr','Type dâ€™abonnement',0),(480235,13340,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã®ç¨®é¡ž',0),(480236,13340,'pt','Tipo de assinatura',0),(480237,13340,'ru','Ð¢Ð¸Ð¿ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ¸',0),(480238,13340,'es','Tipo de Suscripciones',0),(480239,13340,'de','Abo-Typ',0),(480240,13340,'en','Subscription Type',0),(480241,13341,'is','',0),(480242,13341,'dr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(480243,13341,'pr','Ù„Ø·ÙØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(480244,13341,'tr','Bir ÅŸirket adÄ± girin.',0),(480245,13341,'pl','ProszÄ™ podaÄ‡ nazwÄ™ firmy.',0),(480246,13341,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°.',0),(480247,13341,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(480248,13341,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸Ð¼Ðµ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð°.',0),(480249,13341,'vi','Vui lÃ²ng nháº­p má»™t tÃªn cÃ´ng ty.',0),(480250,13341,'af','Tik asseblief die naam van \'n maatskappy.',0),(480251,13341,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un nume de companie.',0),(480252,13341,'et','Sisestage ettevÃµtte nimi.',0),(480253,13341,'si','Vnesite ime podjetja.',0),(480254,13341,'ba','Harap masukkan nama perusahaan.',0),(480255,13341,'nl','Voer een bedrijfsnaam in.',0),(480256,13341,'fi','Kirjoita yrityksen nimi.',0),(480257,13341,'no','Skriv inn et firmanavn.',0),(480258,13341,'da','Angiv et virksomhedsnavn.',0),(480259,13341,'ko','íšŒì‚¬ ì´ë¦„ì„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤.',0),(480260,13341,'he','×”×–×™× ×• ××ª ×©× ×”×—×‘×¨×”.',0),(480261,13341,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚.',0),(480262,13341,'zh','è¯·è¾“å…¥å…¬å¸åç§°ã€‚',0),(480263,13341,'sv','Ange ett fÃ¶retagsnamn.',0),(480264,13341,'it','Inserisci un nome di azienda.',0),(480265,13341,'tl','',0),(480266,13341,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸—',0),(480267,13341,'hi','à¤à¤• à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(480268,13341,'ms','Sila masukkan nama Syarikat.',0),(480269,13341,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ \"Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ©\".',0),(480270,13341,'fr','Veuillez entrer un nom de sociÃ©tÃ©.',0),(480271,13341,'jp','ä¼šç¤¾åã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(480272,13341,'pt','Por favor insira um nome de empresa.',0),(480273,13341,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸.',0),(480274,13341,'es','Por Favor Entra Un Nombre de La Empresa',0),(480275,13341,'de','Bitte geben Sie einen Firmennamen ein.',0),(480276,13341,'en','Please enter a Company Name.',0),(480277,13342,'is','',0),(480278,13342,'dr','Ù„Ø·ÙØ§ Ú©Ø¯ Ø§Ù…Ù†ÛŒØªÛŒ ØªØµÙˆÛŒØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(480279,13342,'pr','Ù„Ø·ÙØ§ Ú©Ø¯ Ø§Ù…Ù†ÛŒØªÛŒ ØªØµÙˆÛŒØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(480280,13342,'tr','GÃ¶rÃ¼ntÃ¼ gÃ¼venlik kodunu giriniz.',0),(480281,13342,'pl','ProszÄ™ podaÄ‡ kod bezpieczeÅ„stwa obrazu.',0),(480282,13342,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ð´Ð° Ð½Ð° ÑÐ¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾.',0),(480283,13342,'ur','Ù†Ù‚Ø´ Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ Ú©ÙˆÚˆ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(480284,13342,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð±ÐµÐ·Ð±ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ ÑÐ»Ð¸ÐºÐ°.',0),(480285,13342,'vi','Vui lÃ²ng nháº­p mÃ£ báº£o máº­t hÃ¬nh áº£nh.',0),(480286,13342,'af','Tik asseblief die sekuriteit beeld kode.',0),(480287,13342,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i codul de securitate imagine.',0),(480288,13342,'et','Palun sisestage turvalisuse pildi kood.',0),(480289,13342,'si','Vnesite Å¡ifro varnostno sliko.',0),(480290,13342,'ba','Masukkan kode keamanan gambar.',0),(480291,13342,'nl','Voer het beveiligingsvak die code.',0),(480292,13342,'fi','Anna turvallisuus kuvan koodi.',0),(480293,13342,'no','Angi sikkerhetsbildet koden.',0),(480294,13342,'da','Angiv koden sikkerhed billede.',0),(480295,13342,'ko','ë³´ì•ˆ ì´ë¯¸ì§€ ì½”ë“œë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤.',0),(480296,13342,'he','×× × ×”×–×Ÿ ××ª ×§×•×“ ×”××‘×˜×—×” ×”×ª×ž×•× ×”.',0),(480297,13342,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚ ÎµÎ¹ÎºÏŒÎ½Î±Ï‚.',0),(480298,13342,'zh','è¯·è¿›å…¥å®‰å…¨å›¾ç‰‡ä»£ç ã€‚',0),(480299,13342,'sv','VÃ¤nligen ange sÃ¤kerhet bild koden.',0),(480300,13342,'it','Inserisci il codice di sicurezza immagine.',0),(480301,13342,'tl','',0),(480302,13342,'th','à¸à¸£à¸¸à¸“à¸²à¸›à¹‰à¸­à¸™à¸£à¸«à¸±à¸ªà¸„à¸§à¸²à¸¡à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢à¸£à¸¹à¸›',0),(480303,13342,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤›à¤µà¤¿ à¤•à¥‹à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(480304,13342,'ms','Sila masukkan kod imej Keselamatan.',0),(480305,13342,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù…Ø² \"Ø§Ù„ØµÙˆØ±Ø© Ø§Ù„Ø£Ù…Ù†ÙŠØ©\".',0),(480306,13342,'fr','Veuillez entrer le code de l\'Image de la sÃ©curitÃ©.',0),(480307,13342,'jp','ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£ç”»åƒã®ã‚³ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(480308,13342,'pt','Por favor introduza o cÃ³digo de seguranÃ§a de imagem.',0),(480309,13342,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ¾Ð´ Ð±ÐµÐ·Ð¾Ð¿Ð°ÑÐ½Ð¾ÑÑ‚Ð¸ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ.',0),(480310,13342,'es','Por favor, introduzca el cÃ³digo de seguridad de imagen.',0),(480311,13342,'de','Bitte geben Sie den Security-Bild-Code.',0),(480312,13342,'en','Please enter the Security Image code.',0),(480313,13343,'is','',0),(480314,13343,'dr','Ù„Ø·ÙØ§ Ø§ÛŒÙ…ÛŒÙ„ Ø®ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(480315,13343,'pr','Ù„Ø·ÙØ§ Ø§ÛŒÙ…ÛŒÙ„ Ø®ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(480316,13343,'tr','LÃ¼tfen e-posta girin.',0),(480317,13343,'pl','Podaj swÃ³j E-mail.',0),(480318,13343,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ Ð¸Ð¼ÐµÐ¹Ð».',0),(480319,13343,'ur','Ø¢Ù¾ Ú©Ø§ Ø§ÛŒ Ù…ÛŒÙ„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(480320,13343,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð’Ð°Ñˆ Ð•Ð¼Ð°Ð¸Ð».',0),(480321,13343,'vi','Vui lÃ²ng nháº­p Email cá»§a báº¡n.',0),(480322,13343,'af','Voer asb. \'n E-pos in.',0),(480323,13343,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i adresa de Email.',0),(480324,13343,'et','Palun sisesta oma e-posti.',0),(480325,13343,'si','Prosimo, vnesite vaÅ¡ Email.',0),(480326,13343,'ba','Masukkan Email Anda.',0),(480327,13343,'nl','Geef uw e-mailadres.',0),(480328,13343,'fi','SyÃ¶tÃ¤ sÃ¤hkÃ¶postiosoitteesi.',0),(480329,13343,'no','Skriv inn din e-post.',0),(480330,13343,'da','Indtast din E-mail.',0),(480331,13343,'ko','ê·€í•˜ì˜ ì´ë©”ì¼ì„ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤.',0),(480332,13343,'he','×‘×‘×§×©×” ×”×–×Ÿ ××ª ×”×“×•× ×œ ×©×œ×š.',0),(480333,13343,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ Email ÏƒÎ±Ï‚.',0),(480334,13343,'zh','è¯·è¾“å…¥æ‚¨çš„ç”µå­é‚®ä»¶ã€‚',0),(480335,13343,'sv','Skriv in din e-post.',0),(480336,13343,'it','Per favore inserisci la tua Email.',0),(480337,13343,'tl','',0),(480338,13343,'th','à¸à¸£à¸¸à¸“à¸²à¸›à¹‰à¸­à¸™à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(480339,13343,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤ªà¤¨à¥‡ à¤ˆà¤®à¥‡à¤² à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(480340,13343,'ms','Sila masukkan e-mel anda.',0),(480341,13343,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ.',0),(480342,13343,'fr','Veuillez entrer votre adresse Email.',0),(480343,13343,'jp','ã‚ãªãŸã®ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(480344,13343,'pt','Por favor digite o seu E-mail.',0),(480345,13343,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð’Ð°Ñˆ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ð¹ Ð°Ð´Ñ€ÐµÑ.',0),(480346,13343,'es','Por Favor Entra Su Email',0),(480347,13343,'de','Bitte geben Sie Ihre E-Mail.',0),(480348,13343,'en','Please enter your Email.',0),(480349,13344,'is','',0),(480350,13344,'dr','Ù„Ø·ÙØ§Ù‹ Ù†Ø§Ù… Ø®ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(480351,13344,'pr','Ù„Ø·ÙØ§Ù‹ Ù†Ø§Ù… Ø®ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(480352,13344,'tr','LÃ¼tfen adÄ±nÄ±zÄ± girin.',0),(480353,13344,'pl','ProszÄ™ wpisaÄ‡ swoje imiÄ™.',0),(480354,13344,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¾Ñ‚Ð¾ ÑÐ¸ Ð¸Ð¼Ðµ.',0),(480355,13344,'ur','Ø§Ù¾Ù†Ø§ Ù¾ÛÙ„Ø§ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(480356,13344,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ðµ Ð¸Ð¼Ðµ.',0),(480357,13344,'vi','Vui lÃ²ng nháº­p tÃªn cá»§a báº¡n.',0),(480358,13344,'af','Tik asseblief jou eerste naam.',0),(480359,13344,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i prenumele tau.',0),(480360,13344,'et','Sisestage oma eesnimi.',0),(480361,13344,'si','Prosimo vnesite vaÅ¡e ime.',0),(480362,13344,'ba','Masukkan nama pertama Anda.',0),(480363,13344,'nl','Voer uw voornaam in.',0),(480364,13344,'fi','Kirjoita etunimesi.',0),(480365,13344,'no','Skriv inn fornavnet.',0),(480366,13344,'da','Indtast dit fornavn.',0),(480367,13344,'ko','ë‹¹ì‹ ì˜ ì´ë¦„ì„ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤.',0),(480368,13344,'he','×”×–×™× ×• ×‘×‘×§×©×” ××ª ×©×ž×š ×”×¤×¨×˜×™.',0),(480369,13344,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î¬ ÏƒÎ±Ï‚.',0),(480370,13344,'zh','è¯·è¾“å…¥æ‚¨çš„åå­—ã€‚',0),(480371,13344,'sv','VÃ¤nligen ange ditt fÃ¶rnamn.',0),(480372,13344,'it','Inserisci il tuo nome.',0),(480373,13344,'tl','',0),(480374,13344,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(480375,13344,'hi','à¤†à¤ªà¤•à¤¾ à¤ªà¤¹à¤²à¤¾ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(480376,13344,'ms','Sila masukkan nama pertama anda.',0),(480377,13344,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ.',0),(480378,13344,'fr','Veuillez saisir votre prÃ©nom.',0),(480379,13344,'jp','ã‚ãªãŸã®ãƒ•ã‚¡ãƒ¼ã‚¹ãƒˆãƒãƒ¼ãƒ ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(480380,13344,'pt','Por favor, digite seu primeiro nome.',0),(480381,13344,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÐµ Ð¸Ð¼Ñ.',0),(480382,13344,'es','Por Favor Entra Su Nombre',0),(480383,13344,'de','Bitte geben Sie Ihren Vornamen ein.',0),(480384,13344,'en','Please enter your First Name.',0),(480385,13345,'is','',0),(480386,13345,'dr','Ù„Ø·ÙØ§Ù‹ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ø®ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(480387,13345,'pr','Ù„Ø·ÙØ§Ù‹ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ø®ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(480388,13345,'tr','SoyadÄ±nÄ±zÄ± giriniz.',0),(480389,13345,'pl','ProszÄ™ wpisaÄ‡ swoje nazwisko.',0),(480390,13345,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð²Ð°ÑˆÐµÑ‚Ð¾ Ð¸Ð¼Ðµ.',0),(480391,13345,'ur','Ø¢Ù¾ Ú©Ø§ Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Û”',0),(480392,13345,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ðµ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ.',0),(480393,13345,'vi','Vui lÃ²ng nháº­p há» cá»§a báº¡n.',0),(480394,13345,'af','Tik asseblief jou verlede naam.',0),(480395,13345,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i numele dumneavoastrÄƒ de familie.',0),(480396,13345,'et','Palun sisestage oma perekonnanimi.',0),(480397,13345,'si','Vnesite svoj priimek.',0),(480398,13345,'ba','Silahkan masukkan nama terakhir.',0),(480399,13345,'nl','Voer uw achternaam in.',0),(480400,13345,'fi','Kirjoita sukunimesi.',0),(480401,13345,'no','Skriv inn etternavnet.',0),(480402,13345,'da','Indtast dit efternavn.',0),(480403,13345,'ko','ë‹¹ì‹ ì˜ ë§ˆì§€ë§‰ ì´ë¦„ì„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤.',0),(480404,13345,'he','×”×–×™× ×• ××ª ×©× ×”×ž×©×¤×—×” ×©×œ×š.',0),(480405,13345,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ ÎµÏ€ÏŽÎ½Ï…Î¼ÏŒ ÏƒÎ±Ï‚.',0),(480406,13345,'zh','è¯·è¾“å…¥æ‚¨çš„å§“æ°ã€‚',0),(480407,13345,'sv','Ange ditt efternamn.',0),(480408,13345,'it','Inserisci il tuo cognome.',0),(480409,13345,'tl','',0),(480410,13345,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸°à¸šà¸¸à¸™à¸²à¸¡à¸ªà¸à¸¸à¸¥à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(480411,13345,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤ªà¤¨à¤¾ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚à¥¤',0),(480412,13345,'ms','Sila masukkan nama anda.',0),(480413,13345,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ \"Ø§Ø³Ù… Ø§Ù„Ø¹Ø§Ø¦Ù„Ø©\".',0),(480414,13345,'fr','Veuillez entrer votre nom de famille.',0),(480415,13345,'jp','ã‚ãªãŸã®å§“ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(480416,13345,'pt','Por favor digite seu Ãºltimo nome.',0),(480417,13345,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÑƒ Ñ„Ð°Ð¼Ð¸Ð»Ð¸ÑŽ.',0),(480418,13345,'es','Por Favor Entra Su Apellido',0),(480419,13345,'de','Bitte geben Sie Ihren Nachnamen ein.',0),(480420,13345,'en','Please enter your Last Name.',0),(480421,13346,'is','',0),(480422,13346,'dr','Ù„Ø·ÙØ§ Ø¨Ø§ Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø±ÛŒ <i>admin</i> Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø§ÛŒØ¬Ø§Ø¯ Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯ ÙˆØ§Ø±Ø¯ Ø´ÙˆÛŒØ¯.',0),(480423,13346,'pr','Ù„Ø·ÙØ§ Ø¨Ø§ Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø±ÛŒ <i>admin</i> Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø§ÛŒØ¬Ø§Ø¯ Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯ ÙˆØ§Ø±Ø¯ Ø´ÙˆÛŒØ¯.',0),(480424,13346,'tr','LÃ¼tfen kullanÄ±cÄ± adÄ± <i>admin</i> ve oluÅŸturduÄŸunuz parola ile oturum.',0),(480425,13346,'pl','Prosimy o zalogowanie siÄ™ uÅ¼ytkownika <i>admin</i> i hasÅ‚o, ktÃ³re wÅ‚aÅ›nie utworzyÅ‚eÅ›.',0),(480426,13346,'bg','ÐœÐ¾Ð»Ñ, Ð²Ð»ÐµÐ·Ñ‚Ðµ Ñ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ <i>Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€</i> Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð°, ÐºÐ¾ÑÑ‚Ð¾ Ñ‚Ð¾ÐºÑƒ Ñ‰Ð¾ ÑÑŠÐ·Ð´Ð°Ð´Ð¾Ñ…Ñ‚Ðµ.',0),(480427,13346,'ur','<i>Ù…Ù†ØªØ¸Ù…</i> ØµØ§Ø±Ù Ù†Ø§Ù… Ø§ÙˆØ± Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¢Ù¾ ØµØ±Ù ØªØ®Ù„ÛŒÙ‚ Ú©Û’ Ø³Ø§ØªÚ¾ Ù„Ø§Ú¯ Ø¢Ù† ÛÛŒÚº Û”',0),(480428,13346,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° ÑÐµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›Ñƒ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾Ð³ Ð¸Ð¼ÐµÐ½Ð° <i>Ð°Ð´Ð¼Ð¸Ð½</i> Ð¸ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ ÐºÐ¾Ñ˜Ñƒ ÑÑ‚Ðµ ÑƒÐ¿Ñ€Ð°Ð²Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð»Ð¸.',0),(480429,13346,'vi','Xin vui lÃ²ng Ä‘Äƒng nháº­p báº±ng tÃªn ngÆ°á»i dÃ¹ng <i>admin</i> vÃ  máº­t kháº©u báº¡n vá»«a táº¡o ra.',0),(480430,13346,'af','Teken asseblief by die Username <i>admin</i> en die wagwoord wat jy sopas geskep.',0),(480431,13346,'ro','VÄƒ rugÄƒm sÄƒ vÄƒ conectaÅ£i cu numele de utilizator <i>admin</i> si parola pe care tocmai aÅ£i creat.',0),(480432,13346,'et','Palun sisse logida kasutajanimi <i>admin</i> ja parool loodud.',0),(480433,13346,'si','Prijavite se z <i>admin</i> uporabniÅ¡ko ime in geslo, ki ste jo pravkar ustvarili.',0),(480434,13346,'ba','Silakan login dengan Username <i>admin</i> dan password yang baru Anda buat.',0),(480435,13346,'nl','Alstublieft Inloggen met de gebruikersnaam <i>admin</i> en het wachtwoord dat u zojuist hebt gemaakt.',0),(480436,13346,'fi','Kirjaudu sisÃ¤Ã¤n Username <i>admin</i> ja salasana, jonka loit.',0),(480437,13346,'no','Logg inn med brukernavn <i>admin</i> og passordet du nettopp opprettet.',0),(480438,13346,'da','Log venligst ind med Brugernavn <i>admin</i> og adgangskoden du lige har oprettet.',0),(480439,13346,'ko','ì‚¬ìš©ìž ì´ë¦„ <i>ê´€ë¦¬ìž</i> ì™€ ë‹¹ì‹ ì´ ë°©ê¸ˆ ë§Œë“  ì•”í˜¸ë¥¼ ì‚¬ìš© í•˜ ì—¬ ë¡œê·¸ì¸ í•˜ì‹­ì‹œì˜¤.',0),(480440,13346,'he','×”×™×›× ×¡ ×¢× ×©× ×ž×©×ª×ž×© <i>admin</i> ×•×”×¡×™×¡×ž×” ×©×™×¦×¨×ª ×–×” ×¢×ª×”.',0),(480441,13346,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Î¼Îµ Ï„Î¿ <i>admin</i> ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· ÎºÎ±Î¹ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï€Î¿Ï… Î¼ÏŒÎ»Î¹Ï‚ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎ±Ï„Îµ.',0),(480442,13346,'zh','è¯·ç™»å½•ç”¨æˆ·å<I> admin </I>å’Œæ‚¨åˆšåˆšåˆ›å»ºçš„å¯†ç ã€‚',0),(480443,13346,'sv','Logga in med anvÃ¤ndarnamnet <i>admin</i> och lÃ¶senordet du just skapat.',0),(480444,13346,'it','Si prega di accedere con il nome utente <i>admin</i> e la password che avete appena creato.',0),(480445,13346,'tl','',0),(480446,13346,'th','à¹‚à¸›à¸£à¸”à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š à¸”à¹‰à¸§à¸¢à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰<i>admin</i>à¹à¸¥à¸°à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸—à¸µà¹ˆà¸„à¸¸à¸“à¹€à¸žà¸´à¹ˆà¸‡à¸ªà¸£à¹‰à¸²à¸‡',0),(480447,13346,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ <i>à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤•</i> à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤”à¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¤à¥à¤® à¤…à¤­à¥€ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤²à¥‰à¤— à¤‘à¤¨ à¤•à¤°à¥‡à¤‚à¥¤',0),(480448,13346,'ms','Sila log masuk dengan nama pengguna <i>pentadbir</i> dan kata laluan yang baru sahaja anda cipta.',0),(480449,13346,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… <i>admin</i> ÙˆÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„ØªÙŠ Ù‚Ù…Øª Ø¨Ø¥Ù†Ø´Ø§Ø¦Ù‡Ø§ ÙÙ‚Ø·.',0),(480450,13346,'fr','S\'il vous plaÃ®t connectez-vous avec le nom d\'utilisateur <i>admin</i> et le mot de passe que vous venez de crÃ©er.',0),(480451,13346,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼å<i>ç®¡ç†è€…</i>ã¨ä½œæˆã—ãŸãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã§ãƒ­ã‚°ã‚¤ãƒ³ã—ã¦ãã ã•ã„ã€‚',0),(480452,13346,'pt','Por favor fazer login com o nome de usuÃ¡rio <i>admin</i> e a senha que vocÃª acabou de criar.',0),(480453,13346,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð’Ð¾Ð¹Ñ‚Ð¸ Ð¸Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ <i>admin</i> Ð¸ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ Ð²Ñ‹ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ‡Ñ‚Ð¾ ÑÐ¾Ð·Ð´Ð°Ð»Ð¸.',0),(480454,13346,'es','Por favor, inicie sesiÃ³n con el nombre de usuario <i> admin </i> y la contraseÃ±a que acaba de crear.',0),(480455,13346,'de','Bitte melden Sie sich mit dem Benutzernamen <i>Admin</i> und das Passwort, das Sie gerade erstellt haben.',0),(480456,13346,'en','Please log in with the Username <i>admin</i> and the password you just created.',0),(480457,13347,'is','',0),(480458,13347,'dr','Ú©Ø¯ Ø§Ù…Ù†ÛŒØªÛŒ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ ØµØ­ÛŒØ­ Ù†ÛŒØ³Øª.',0),(480459,13347,'pr','Ú©Ø¯ Ø§Ù…Ù†ÛŒØªÛŒ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ ØµØ­ÛŒØ­ Ù†ÛŒØ³Øª.',0),(480460,13347,'tr','Girilen gÃ¼venlik kodunu yanlÄ±ÅŸ.',0),(480461,13347,'pl','Kod wprowadzony byÅ‚ niepoprawny.',0),(480462,13347,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÐ½ ÐºÐ¾Ð´ Ð·Ð° ÑÐ¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚ Ðµ Ð½ÐµÐ¿Ñ€Ð°Ð²Ð¸Ð»ÐµÐ½.',0),(480463,13347,'ur','Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ Ú©ÙˆÚˆ Ø¯Ø§Ø®Ù„ Ú©ÛŒØ§ ØºÙ„Ø· ØªÚ¾Ø§ Û”',0),(480464,13347,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¾ÑÐ½Ð¸ ÐºÐ¾Ð´ ÐºÐ¾Ñ˜Ð¸ ÑÑ‚Ðµ ÑƒÐ½ÐµÐ»Ð¸ Ñ˜Ðµ Ð½ÐµÐ¸ÑÐ¿Ñ€Ð°Ð²Ð½Ð°.',0),(480465,13347,'vi','MÃ£ báº£o vá»‡ vÃ o lÃ  khÃ´ng chÃ­nh xÃ¡c.',0),(480466,13347,'af','Die sekuriteit kode ingesleutel het, is verkeerd.',0),(480467,13347,'ro','Codul de securitate introdus a fost incorectÄƒ.',0),(480468,13347,'et','Sisestada turvakood oli vale.',0),(480469,13347,'si','Vnesli kodo, je bila nepravilna.',0),(480470,13347,'ba','Kode keamanan yang dimasukkan adalah benar.',0),(480471,13347,'nl','De beveiligingscode ingevoerd was onjuist.',0),(480472,13347,'fi','Tuli suojakoodi oli virheellinen.',0),(480473,13347,'no','Sikkerhetskoden inn var feil.',0),(480474,13347,'da','Den sikkerhedskode indtastet var forkert.',0),(480475,13347,'ko','ìž…ë ¥ í•œ ë³´ì•ˆ ì½”ë“œ ìž˜ëª» ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(480476,13347,'he','×§×•×“ ×”××‘×˜×—×” × ×›× ×¡×• ×”×™×ª×” ×©×’×•×™×”.',0),(480477,13347,'el','Î¤Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚ Ï€Î¿Ï… Ï„Î­Î¸Î·ÎºÎµ Î®Ï„Î±Î½ ÎµÏƒÏ†Î±Î»Î¼Î­Î½Î·.',0),(480478,13347,'zh','è¾“å…¥å®‰å…¨ä»£ç æ˜¯ä¸æ­£ç¡®çš„ã€‚',0),(480479,13347,'sv','SÃ¤kerhetskoden anges var felaktig.',0),(480480,13347,'it','Il codice di sicurezza inserito era errato.',0),(480481,13347,'tl','',0),(480482,13347,'th','à¸›à¹‰à¸­à¸™à¸£à¸«à¸±à¸ªà¸„à¸§à¸²à¸¡à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢à¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(480483,13347,'hi','à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤•à¥‹à¤¡ à¤—à¤¼à¤²à¤¤ à¤¥à¤¾à¥¤',0),(480484,13347,'ms','Kod Keselamatan yang dimasukkan tidak betul.',0),(480485,13347,'ar','ÙˆÙƒØ§Ù† Ù‚Ø§Ù†ÙˆÙ† Ø§Ù„Ø£Ù…Ù† Ø¯Ø®Ù„Øª ØºÙŠØ± ØµØ­ÙŠØ­Ø©.',0),(480486,13347,'fr','Le code de sÃ©curitÃ© introduit est incorrect.',0),(480487,13347,'jp','å…¥åŠ›ã•ã‚ŒãŸã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£ ã‚³ãƒ¼ãƒ‰ãŒæ­£ã—ãã‚ã‚Šã¾ã›ã‚“ã€‚',0),(480488,13347,'pt','O cÃ³digo de seguranÃ§a inserido estava incorreto.',0),(480489,13347,'ru','Ð—Ð°Ñ‰Ð¸Ñ‚Ð½Ñ‹Ð¹ ÐºÐ¾Ð´ Ð²Ð²ÐµÐ´ÐµÐ½ Ð½ÐµÐ²ÐµÑ€Ð½Ð¾.',0),(480490,13347,'es','El cÃ³digo de seguridad entrado fue incorrecto',0),(480491,13347,'de','Der Sicherheitscode eingegeben war falsch.',0),(480492,13347,'en','The security code entered was incorrect.',0),(480493,13348,'is','',0),(480494,13348,'dr','Ø§ÛŒÙ† Ù†Ø§Ù… Ø³Ø§ÛŒØª Ù…Ø¬Ø§Ø² Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯.',0),(480495,13348,'pr','Ø§ÛŒÙ† Ù†Ø§Ù… Ø³Ø§ÛŒØª Ù…Ø¬Ø§Ø² Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯.',0),(480496,13348,'tr','Bu Site adÄ± geÃ§erli deÄŸil.',0),(480497,13348,'pl','Nazwa ta strona nie jest dozwolone.',0),(480498,13348,'bg','Ð¢Ð¾Ð²Ð° Ð¸Ð¼Ðµ Ð½Ð° ÑÐ°Ð¹Ñ‚ Ð½Ðµ Ðµ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾.',0),(480499,13348,'ur','Ø§Ø³ Ø³Ø§Ø¦Ù¹ Ú©Û’ Ù†Ø§Ù… Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº ÛÛ’ Û”',0),(480500,13348,'sr','Ð˜Ð¼Ðµ Ð¾Ð²Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð°.',0),(480501,13348,'vi','TÃªn trang web nÃ y lÃ  khÃ´ng Ä‘Æ°á»£c phÃ©p.',0),(480502,13348,'af','Hierdie webwerf naam word toegelaat nie.',0),(480503,13348,'ro','Acest nume de site-ul nu este permis.',0),(480504,13348,'et','Selle saidi nimi pole lubatud.',0),(480505,13348,'si','Ta stran ime ni dovoljeno.',0),(480506,13348,'ba','Nama situs ini tidak diperbolehkan.',0),(480507,13348,'nl','De naam van deze Site is niet toegestaan.',0),(480508,13348,'fi','TÃ¤mÃ¤n sivustonimi ei kelpaa.',0),(480509,13348,'no','Dette omrÃ¥denavnet er ikke tillatt.',0),(480510,13348,'da','Dette webstedsnavn er ikke tilladt.',0),(480511,13348,'ko','ì´ ì‚¬ì´íŠ¸ ì´ë¦„ì€ í—ˆìš© ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(480512,13348,'he','×©× ××ª×¨ ×–×” ××™× ×• ×ž×•×ª×¨.',0),(480513,13348,'el','Î¤Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ Î¹ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î±Ï‚ Î´ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹.',0),(480514,13348,'zh','ä¸å…è®¸æ­¤ç«™ç‚¹çš„åç§°ã€‚',0),(480515,13348,'sv','Detta namn Ã¤r inte tillÃ¥tet.',0),(480516,13348,'it','Nome di questo sito non Ã¨ consentito.',0),(480517,13348,'tl','',0),(480518,13348,'th','à¸Šà¸·à¹ˆà¸­à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¸™à¸µà¹‰à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(480519,13348,'hi','à¤‡à¤¸ à¤¸à¤¾à¤‡à¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤® à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(480520,13348,'ms','Nama laman web ini tidak dibenarkan.',0),(480521,13348,'ar','Ù‡Ø°Ø§ \"Ø§Ø³Ù… Ù…ÙˆÙ‚Ø¹\" ØºÙŠØ± Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡.',0),(480522,13348,'fr','Ce nom de Site n\'est pas autorisÃ©.',0),(480523,13348,'jp','ã“ã®ã‚µã‚¤ãƒˆåã¯è¨±å¯ã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(480524,13348,'pt','O nome do Site nÃ£o Ã© permitido.',0),(480525,13348,'ru','Ð­Ñ‚Ð¾ Ð¸Ð¼Ñ ÑÐ°Ð¹Ñ‚Ð° Ð½Ðµ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ.',0),(480526,13348,'es','Este Nombre de sitio no se permite',0),(480527,13348,'de','Diese Site-Name ist nicht zulÃ¤ssig.',0),(480528,13348,'en','This Site Name is not allowed.',0),(480529,13349,'is','',0),(480530,13349,'dr','Ø³Ø§ÛŒØª Ù…ÛŒØ²Ø¨Ø§Ù† Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª.',0),(480531,13349,'pr','Ø³Ø§ÛŒØª Ù…ÛŒØ²Ø¨Ø§Ù† Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª.',0),(480532,13349,'tr','BarÄ±ndÄ±rÄ±lan site baÅŸarÄ±yla oluÅŸturuldu.',0),(480533,13349,'pl','Witryny hostowane zostaÅ‚ pomyÅ›lnie utworzony.',0),(480534,13349,'bg','Ð’Ð°ÑˆÐ¸ÑÑ‚ Ð´Ð¾Ð¼Ð°ÐºÐ¸Ð½ ÑÐ°Ð¹Ñ‚ Ðµ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(480535,13349,'ur','Ø§Ù¾Ù†ÛŒ Ù…ÛŒØ²Ø¨Ø§Ù† ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(480536,13349,'sr','Ð’Ð°ÑˆÐ° Ñ˜Ð°Ð²Ð½Ð¸Ñ… Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°.',0),(480537,13349,'vi','Trang web lÆ°u trá»¯ trÃªn mÃ¡y cá»§a báº¡n Ä‘Ã£ Ä‘Æ°á»£c táº¡o thÃ nh cÃ´ng.',0),(480538,13349,'af','Jou webwerf gehuisves is suksesvol geskep.',0),(480539,13349,'ro','GÄƒzduit site-ul a fost creat cu succes.',0),(480540,13349,'et','Teie hostitud saidi on edukalt loodud.',0),(480541,13349,'si','GostiÅ¡Äe mesta je bil uspeÅ¡no ustvarjen.',0),(480542,13349,'ba','Situs host Anda telah berhasil menciptakan.',0),(480543,13349,'nl','Uw gehoste site is met succes aangemaakt.',0),(480544,13349,'fi','IsÃ¤nnÃ¶i sivusto on luotu.',0),(480545,13349,'no','Din hosted nettsted er opprettet.',0),(480546,13349,'da','Din hostede site er oprettet.',0),(480547,13349,'ko','í˜¸ìŠ¤íŒ…ëœ ì‚¬ì´íŠ¸ ì„±ê³µì ìœ¼ë¡œ ìƒì„± ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(480548,13349,'he','××ª×¨ ×”×ž×ª××¨×— ×©×œ×š × ×•×¦×¨ ×‘×”×¦×œ×—×”.',0),(480549,13349,'el','Î£Î±Ï‚ Ï†Î¹Î»Î¿Î¾ÎµÎ½ÎµÎ¯Ï„Î±Î¹ Î¹ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î± Î­Ï‡ÎµÎ¹ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±.',0),(480550,13349,'zh','æ‚¨çš„æ‰˜ç®¡ç½‘ç«™å·²æˆåŠŸåˆ›å»ºã€‚',0),(480551,13349,'sv','Din vÃ¤rd platsen har skapats.',0),(480552,13349,'it','Tuo sito ospitato Ã¨ stato creato con successo.',0),(480553,13349,'tl','',0),(480554,13349,'th','à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¹‚à¸®à¸ªà¸•à¹Œà¸‚à¸­à¸‡à¸„à¸¸à¸“à¹à¸¥à¹‰à¸§à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢',0),(480555,13349,'hi','à¤†à¤ªà¤•à¥‡ à¤¹à¥‹à¤¸à¥à¤Ÿà¥‡à¤¡ à¤¸à¤¾à¤‡à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆà¥¤',0),(480556,13349,'ms','Laman web dihos anda telah berjaya dicipta.',0),(480557,13349,'ar','ØªÙ… Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙˆÙ‚Ø¹ Ø§Ø³ØªØ¶Ø§ÙØ© Ø§Ù„ÙˆÙŠØ¨ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø¨Ù†Ø¬Ø§Ø­.',0),(480558,13349,'fr','Votre site hÃ©bergÃ© a Ã©tÃ© crÃ©Ã© avec succÃ¨s.',0),(480559,13349,'jp','ãƒ›ã‚¹ãƒˆã•ã‚Œã¦ã„ã‚‹ã‚µã‚¤ãƒˆãŒæ­£å¸¸ã«ä½œæˆã•ã‚Œã¾ã—ãŸã€‚',0),(480560,13349,'pt','Seu site hospedado foi criado com Ãªxito.',0),(480561,13349,'ru','Ð Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ðµ ÑÐ°Ð¹Ñ‚Ð° Ð±Ñ‹Ð» ÑÐ¾Ð·Ð´Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾.',0),(480562,13349,'es','Su sitio alojado ha sido creado con Ã©xito.',0),(480563,13349,'de','Ihre gehosteten Website wurde erfolgreich erstellt.',0),(480564,13349,'en','Your hosted site has been created successfully.',0),(480565,13350,'is','',0),(480566,13350,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ùˆ ØªØ§ÛŒÛŒØ¯ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¹Ø¨Ù‡ Ù…Ø·Ø§Ø¨Ù‚Øª Ø¯Ø§Ø´ØªÙ‡ Ø§Ø³Øª.',0),(480567,13350,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ Ùˆ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ùˆ ØªØ§ÛŒÛŒØ¯ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¹Ø¨Ù‡ Ù…Ø·Ø§Ø¨Ù‚Øª Ø¯Ø§Ø´ØªÙ‡ Ø§Ø³Øª.',0),(480568,13350,'tr','Bir ÅŸifre girmeniz gerekir ve parola ve parola onayÄ± kutularÄ±na aynÄ± olmalÄ±dÄ±r.',0),(480569,13350,'pl','NaleÅ¼y wprowadziÄ‡ hasÅ‚o i hasÅ‚o i potwierdzenie hasÅ‚a pola muszÄ… byÄ‡ zgodne.',0),(480570,13350,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð¸ Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð°Ñ‚.',0),(480571,13350,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø§ÙˆØ± Ù¾Ø§Ø³ ÙˆØ±Úˆ Ú©Û’ ØªØµØ¯ÛŒÙ‚ Ú©Û’ Ø®Ø§Ù†ÙˆÚº Ø³Û’ Ù…Ø´Ø§Ø¨Û ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’ Û”',0),(480572,13350,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ð¸ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ð¸ Ð¿Ð¾Ñ™Ð° Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ Ð¼Ð¾Ñ€Ð°Ñ˜Ñƒ Ð´Ð° ÑÐµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ.',0),(480573,13350,'vi','Báº¡n pháº£i nháº­p máº­t kháº©u vÃ  máº­t kháº©u vÃ  máº­t kháº©u xÃ¡c nháº­n há»™p pháº£i phÃ¹ há»£p vá»›i.',0),(480574,13350,'af','Jy moet \'n wagwoord intik en die wagwoord en wagwoord bevestiging bokse moet pas.',0),(480575,13350,'ro','Trebuie sÄƒ introduceÅ£i o parolÄƒ ÅŸi parola ÅŸi cutii de confirmare parola trebuie sÄƒ corespundÄƒ.',0),(480576,13350,'et','Sisestage salasÃµna ja parooli ja parooli kinnitamise kastidesse tuleb Ã¼hti.',0),(480577,13350,'si','Vnesti morate geslo in geslo in Potrditev gesla polja se mora ujemati.',0),(480578,13350,'ba','Anda harus memasukkan password dan sandi dan konfirmasi sandi kotak harus cocok.',0),(480579,13350,'nl','U moet een wachtwoord invoeren en het wachtwoord en de vakken van de bevestiging van het wachtwoord moeten overeenkomen.',0),(480580,13350,'fi','Kirjoitat salasanan ja salasana ja salasanan vahvistus laatikot on oltava.',0),(480581,13350,'no','Du mÃ¥ angi et passord og passord og passord bekreftelse boksene mÃ¥ samsvare.',0),(480582,13350,'da','Du skal angive en adgangskode og adgangskode og password bekrÃ¦ftelse bokse skal stemme overens.',0),(480583,13350,'ko','ì•”í˜¸ë¥¼ ìž…ë ¥ í•©ë‹ˆë‹¤ ë° ì•”í˜¸ ë° ì•”í˜¸ í™•ì¸ ìƒìžì— ì¼ì¹˜ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(480584,13350,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×¡×™×¡×ž×” ×•×œ×”×ª××™× ×”×¡×™×¡×ž×” ×•×ª×™×‘×•×ª ××™×©×•×¨ ×¡×™×¡×ž×” ×¢×œ×™×š.',0),(480585,13350,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÎºÎ±Î¹ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÎºÎ±Î¹ Ï„Î± ÎºÎ¿Ï…Ï„Î¹Î¬ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· ÎºÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½.',0),(480586,13350,'zh','æ‚¨å¿…é¡»è¾“å…¥å¯†ç ï¼Œå¯†ç å’Œå¯†ç ç¡®è®¤æ¡†å¿…é¡»åŒ¹é…ã€‚',0),(480587,13350,'sv','Du mÃ¥ste ange ett lÃ¶senord och lÃ¶senord och lÃ¶senord bekrÃ¤ftelse boxarna mÃ¥ste matcha.',0),(480588,13350,'it','Ãˆ necessario immettere una password e la password e caselle di conferma password devono corrispondere.',0),(480589,13350,'tl','',0),(480590,13350,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™ à¹à¸¥à¸°à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¹à¸¥à¸°à¸à¸¥à¹ˆà¸­à¸‡à¸¢à¸·à¸™à¸¢à¸±à¸™à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸•à¹‰à¸­à¸‡à¸•à¸£à¸‡à¸à¸±à¸š',0),(480591,13350,'hi','à¤¤à¥à¤® à¤à¤• à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾ à¤”à¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤”à¤° à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ à¤¬à¤•à¥à¤¸à¥‡ à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤à¥¤',0),(480592,13350,'ms','Anda mesti memasukkan kata laluan dan kata laluan dan kata laluan pengesahan kotak mesti sepadan.',0),(480593,13350,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ±ØŒ ÙˆÙŠØ¬Ø¨ Ø£Ù† ØªØªØ·Ø§Ø¨Ù‚ ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± ÙˆØªØ£ÙƒÙŠØ¯ ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ù…Ø±Ø¨Ø¹Ø§Øª.',0),(480594,13350,'fr','Vous devez entrer un mot de passe et le mot de passe et les boÃ®tes de confirmation de mot de passe doivent correspondre.',0),(480595,13350,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã€ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ãŠã‚ˆã³ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®ç¢ºèªãƒœãƒƒã‚¯ã‚¹ã«ä¸€è‡´ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(480596,13350,'pt','VocÃª deve digitar uma senha e a senha e caixas de confirmaÃ§Ã£o de senha devem corresponder.',0),(480597,13350,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð¸ Ð¿Ð¾Ð»Ñ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð¸ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ñ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐ¾Ð²Ð¿Ð°Ð´Ð°Ñ‚ÑŒ.',0),(480598,13350,'es','Debe entrar el password y las cajas del password y la confirmaciÃ³n del password debe emparejar',0),(480599,13350,'de','Sie mÃ¼ssen ein Kennwort eingeben und den Feldern Kennwort und Kennwort BestÃ¤tigung mÃ¼ssen Ã¼bereinstimmen.',0),(480600,13350,'en','You must enter a password and the password and password confirmation boxes must match.',0),(480601,13351,'is','',0),(480602,13351,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø­Ø¯Ø§Ù‚Ù„ ÛŒÚ© Ø­Ø±Ù Ø±Ø§ Ø¯Ø± Ø³Ø§ÛŒØª Ù†Ø§Ù… Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯.',0),(480603,13351,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø­Ø¯Ø§Ù‚Ù„ ÛŒÚ© Ø­Ø±Ù Ø±Ø§ Ø¯Ø± Ø³Ø§ÛŒØª Ù†Ø§Ù… Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯.',0),(480604,13351,'tr','Site adÄ± olarak en az bir harf olmalÄ±dÄ±r.',0),(480605,13351,'pl','Musisz mieÄ‡ co najmniej jednÄ… literÄ™ w nazwie witryny.',0),(480606,13351,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð°Ñ‚Ðµ Ð¿Ð¾Ð½Ðµ ÐµÐ´Ð½Ð° Ð±ÑƒÐºÐ²Ð° Ð² Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° ÑÐ°Ð¹Ñ‚Ð°.',0),(480607,13351,'ur','Ø¢Ù¾ Ú©Ù… Ø§Ø² Ú©Ù… Ø§ÛŒÚ© Ø®Ø· Ù…ÛŒÚº ÛŒÛ ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ú©Ø§ Ù†Ø§Ù… ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ Û”',0),(480608,13351,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð±Ð°Ñ€ Ñ˜ÐµÐ´Ð½Ð¾ ÑÐ»Ð¾Ð²Ð¾ Ñƒ Ð¸Ð¼ÐµÐ½Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ.',0),(480609,13351,'vi','Báº¡n pháº£i cÃ³ Ã­t nháº¥t má»™t kÃ½ tá»± trong tÃªn trang web.',0),(480610,13351,'af','Jy moet ten minste een letter in die naam van die werf het.',0),(480611,13351,'ro','Trebuie sÄƒ aveÅ£i cel puÅ£in o litere din numele site-ului.',0),(480612,13351,'et','Saidi nimi peab olema vÃ¤hemalt Ã¼ks tÃ¤ht.',0),(480613,13351,'si','V imenu spletnega mesta, morate imeti vsaj eno Ärko.',0),(480614,13351,'ba','Anda harus memiliki setidaknya satu huruf di nama situs.',0),(480615,13351,'nl','U moet minstens Ã©Ã©n letter in de naam van de Site.',0),(480616,13351,'fi','Sinulla on oltava vÃ¤hintÃ¤Ã¤n yksi kirjain sivustonimi.',0),(480617,13351,'no','Du mÃ¥ ha minst Ã©n bokstav i navnet pÃ¥ webomrÃ¥det.',0),(480618,13351,'da','Du skal have mindst Ã©t bogstav i navnet pÃ¥ hjemmesiden.',0),(480619,13351,'ko','ì‚¬ì´íŠ¸ ì´ë¦„ì— ë¬¸ìž ì ì–´ë„ í•˜ë‚˜ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(480620,13351,'he','×“×¨×•×©×” ×œ×š ×œ×¤×—×•×ª ××•×ª ××—×ª ××ª ×©× ×”××ª×¨.',0),(480621,13351,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î­Î½Î± Î³ÏÎ¬Î¼Î¼Î± ÏƒÏ„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ Î¹ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î±Ï‚.',0),(480622,13351,'zh','åœ¨ç«™ç‚¹åç§°ï¼Œæ‚¨å¿…é¡»å…·æœ‰è‡³å°‘ä¸€ä¸ªå­—æ¯ã€‚',0),(480623,13351,'sv','Du mÃ¥ste ha minst en bokstav i webbplatsens namn.',0),(480624,13351,'it','Deve avere almeno una lettera nel nome del sito.',0),(480625,13351,'tl','',0),(480626,13351,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸­à¸¢à¹ˆà¸²à¸‡à¸™à¹‰à¸­à¸¢à¸«à¸™à¸¶à¹ˆà¸‡à¸•à¸±à¸§à¸­à¸±à¸à¸©à¸£à¹ƒà¸™à¸Šà¸·à¹ˆà¸­à¹„à¸‹à¸•à¹Œ',0),(480627,13351,'hi','à¤†à¤ª à¤¸à¤¾à¤‡à¤Ÿ à¤¨à¤¾à¤® à¤®à¥‡à¤‚ à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• à¤ªà¤¤à¥à¤° à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(480628,13351,'ms','Anda mesti mempunyai sekurang-kurangnya satu huruf dalam nama tapak.',0),(480629,13351,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ø±Ø³Ø§Ù„Ø© ÙˆØ§Ø­Ø¯Ø© Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„ ÙÙŠ \"Ø§Ø³Ù… Ø§Ù„Ù…ÙˆÙ‚Ø¹\".',0),(480630,13351,'fr','Vous devez avoir au moins une lettre dans le nom du Site.',0),(480631,13351,'jp','å°‘ãªãã¨ã‚‚ 1 ã¤ã®æ–‡å­—ã¯ã€ã‚µã‚¤ãƒˆåãŒå¿…è¦ã§ã™ã€‚',0),(480632,13351,'pt','VocÃª deve ter pelo menos uma letra no nome do Site.',0),(480633,13351,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¸Ð¼ÐµÑ‚ÑŒ Ð¿Ð¾ ÐºÑ€Ð°Ð¹Ð½ÐµÐ¹ Ð¼ÐµÑ€Ðµ Ð¾Ð´Ð½Ð° Ð±ÑƒÐºÐ²Ð° Ð² Ð¸Ð¼ÐµÐ½Ð¸ ÑÐ°Ð¹Ñ‚Ð°.',0),(480634,13351,'es','Debe tener por lo menos una letra en el Nombre del sitio',0),(480635,13351,'de','Sie mÃ¼ssen mindestens einen Buchstaben in den Namen der Site haben.',0),(480636,13351,'en','You must have at least one letter in the Site Name.',0),(480637,13352,'is','',0),(480638,13352,'dr','ØªØµÙˆÙŠØ± Ø§Ù…Ù†ÙŠØªÙŠ',0),(480639,13352,'pr','ØªØµÙˆÙŠØ± Ø§Ù…Ù†ÙŠØªÙŠ',0),(480640,13352,'tr','GÃ¼venlik resmi',0),(480641,13352,'pl','Obraz bezpieczeÅ„stwa',0),(480642,13352,'bg','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(480643,13352,'ur','Ø³Ù„Ø§Ù…ØªÛŒ Ú©ÛŒ ØªØµÙˆÛŒØ±',0),(480644,13352,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚ ÑÐ»Ð¸ÐºÐµ',0),(480645,13352,'vi','Báº£o máº­t hÃ¬nh áº£nh',0),(480646,13352,'af','Sekuriteit beeld',0),(480647,13352,'ro','Imaginea de securitate',0),(480648,13352,'et','Turvalisuse pilt',0),(480649,13352,'si','Varnostno sliko',0),(480650,13352,'ba','Gambar keamanan',0),(480651,13352,'nl','Beveiligingsvak die',0),(480652,13352,'fi','Security kuva',0),(480653,13352,'no','Sikkerhetsbildet',0),(480654,13352,'da','Sikkerhed billede',0),(480655,13352,'ko','ë³´ì•ˆ ì´ë¯¸ì§€',0),(480656,13352,'he','×ª×ž×•× ×ª ××‘×˜×—×”',0),(480657,13352,'el','Î‘ÏƒÏ†Î¬Î»ÎµÎ¹Î± ÎµÎ¹ÎºÏŒÎ½Î±',0),(480658,13352,'zh','å®‰å…¨å›¾ç‰‡',0),(480659,13352,'sv','SÃ¤kerhet bild',0),(480660,13352,'it','Immagine di sicurezza',0),(480661,13352,'tl','',0),(480662,13352,'th','à¸£à¸±à¸à¸©à¸²à¸„à¸§à¸²à¸¡à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢à¸£à¸¹à¸›',0),(480663,13352,'hi','à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤›à¤µà¤¿',0),(480664,13352,'ms','Gambar Keselamatan',0),(480665,13352,'ar','ØµÙˆØ±Ø© Ø§Ù„Ø£Ù…Ù†',0),(480666,13352,'fr','Image de sÃ©curitÃ©',0),(480667,13352,'jp','ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£ç”»åƒ',0),(480668,13352,'pt','Imagem de seguranÃ§a',0),(480669,13352,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¾Ñ‡Ð½Ð¾Ðµ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(480670,13352,'es','Imagen de Seguridad',0),(480671,13352,'de','Sicherheitsbild',0),(480672,13352,'en','Security Image',0),(480673,13353,'is','',0),(480674,13353,'dr','Ù†Ø§Ø¯ÛŒØ¯Ù‡ Ú¯Ø±ÙØªÙ† Ù‚ÛŒÙ…Øª',0),(480675,13353,'pr','Ù†Ø§Ø¯ÛŒØ¯Ù‡ Ú¯Ø±ÙØªÙ† Ù‚ÛŒÙ…Øª',0),(480676,13353,'tr','FiyatÄ± geÃ§ersiz kÄ±l',0),(480677,13353,'pl','ZastÄ…piÄ‡ cena',0),(480678,13353,'bg','Ð—Ð°Ð¼ÐµÑÑ‚Ð²Ð°Ñ‰Ð° Ñ†ÐµÐ½Ð°',0),(480679,13353,'ur','Ù‚ÛŒÙ…Øª Ø²ÛŒØ± Ú©Ø±ÛŒÚº',0),(480680,13353,'sr','Ð—Ð°Ð¼ÐµÐ½Ð° Ñ†ÐµÐ½Ð°',0),(480681,13353,'vi','Ghi Ä‘Ã¨ giÃ¡',0),(480682,13353,'af','Prys oorheers',0),(480683,13353,'ro','Suprascrie Pret',0),(480684,13353,'et','Alistada hinna',0),(480685,13353,'si','Preglasiti cene',0),(480686,13353,'ba','Menimpa harga',0),(480687,13353,'nl','Prijs negeren',0),(480688,13353,'fi','Ohita hinta',0),(480689,13353,'no','Overstyre prisen',0),(480690,13353,'da','TilsidesÃ¦tte pris',0),(480691,13353,'ko','ê°€ê²© ë¬´ì‹œ',0),(480692,13353,'he','×œ×¢×§×•×£ ××ª ×”×ž×—×™×¨',0),(480693,13353,'el','Î Î±ÏÎ¬ÎºÎ±Î¼ÏˆÎ· Ï„Î¹Î¼Î®Ï‚',0),(480694,13353,'zh','è‡ªå®šä¹‰ä»·æ ¼',0),(480695,13353,'sv','Ã…sidosÃ¤tta pris',0),(480696,13353,'it','Eseguire l\'override di prezzo',0),(480697,13353,'tl','',0),(480698,13353,'th','à¹à¸—à¸™à¸£à¸²à¸„à¸²',0),(480699,13353,'hi','à¤“à¤µà¤°à¤°à¤¾à¤‡à¤¡ à¤®à¥‚à¤²à¥à¤¯',0),(480700,13353,'ms','Mengatasi harga',0),(480701,13353,'ar','ØªØ¬Ø§ÙˆØ² Ø§Ù„Ø³Ø¹Ø±',0),(480702,13353,'fr','Substituer le prix',0),(480703,13353,'jp','ä¾¡æ ¼ã‚’ä¸Šæ›¸ã',0),(480704,13353,'pt','Substituir o preÃ§o',0),(480705,13353,'ru','ÐŸÐµÑ€ÐµÐ¾Ð¿Ñ€ÐµÐ´ÐµÐ»Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ñƒ',0),(480706,13353,'es','Precio de Hacer Caso Omiso',0),(480707,13353,'de','Preis Ã¼berschreiben',0),(480708,13353,'en','Override Price',0),(480709,13354,'is','',0),(480710,13354,'dr','Ø§Ú¯Ø± Ø¬ÙˆÙ‡Ø± Ù…Ø¬Ø§Ø²ÛŒ',0),(480711,13354,'pr','Ø§Ú¯Ø± Ø¬ÙˆÙ‡Ø± Ù…Ø¬Ø§Ø²ÛŒ',0),(480712,13354,'tr','EÄŸer sanal mÃ¼rekkep',0),(480713,13354,'pl','JeÅ›li atrament wirtualne',0),(480714,13354,'bg','ÐÐºÐ¾ Ð²Ð¸Ñ€Ñ‚ÑƒÐ°Ð»Ð½Ð¸ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð¾',0),(480715,13354,'ur','Ø§Ú¯Ø± Ù…Ø¬Ø§Ø²ÛŒ Ø§Ù†Ú©',0),(480716,13354,'sr','ÐÐºÐ¾ Ð²Ð¸Ñ€Ñ‚ÑƒÐ°Ð»Ð½Ð¸ Ð¿ÐµÑ€Ð¾Ð¼',0),(480717,13354,'vi','Náº¿u áº£o má»±c',0),(480718,13354,'af','As virtuele Ink',0),(480719,13354,'ro','DacÄƒ virtuale de cernealÄƒ',0),(480720,13354,'et','Kui virtuaalne tint',0),(480721,13354,'si','ÄŒe virtualni Ärnila',0),(480722,13354,'ba','Jika Virtual tinta',0),(480723,13354,'nl','Als virtuele inkt',0),(480724,13354,'fi','Jos virtuaalinen muste',0),(480725,13354,'no','Hvis virtuelle blekk',0),(480726,13354,'da','Hvis virtuelle blÃ¦k',0),(480727,13354,'ko','ë§Œì•½ ê°€ìƒ ìž‰í¬',0),(480728,13354,'he','×× ×“×™×• ×•×™×¨×˜×•××œ×™',0),(480729,13354,'el','Î‘Î½ Î¼ÎµÎ»Î¬Î½Î¹ ÎµÎ¹ÎºÎ¿Î½Î¹ÎºÏŒ',0),(480730,13354,'zh','å¦‚æžœè™šæ‹Ÿå¢¨æ°´',0),(480731,13354,'sv','Om virtuella blÃ¤ck',0),(480732,13354,'it','Se l\'inchiostro virtuale',0),(480733,13354,'tl','',0),(480734,13354,'th','à¸–à¹‰à¸²à¸«à¸¡à¸¶à¸à¹€à¸ªà¸¡à¸·à¸­à¸™',0),(480735,13354,'hi','à¤¯à¤¦à¤¿ à¤µà¤°à¥à¤šà¥à¤…à¤² à¤¸à¥à¤¯à¤¾à¤¹à¥€',0),(480736,13354,'ms','Jika dakwat maya',0),(480737,13354,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ø­Ø¨Ø± Ø§Ù„Ø¸Ø§Ù‡Ø±ÙŠ',0),(480738,13354,'fr','Si encre virtuelle',0),(480739,13354,'jp','å ´åˆä»®æƒ³ã‚¤ãƒ³ã‚¯',0),(480740,13354,'pt','Se tinta Virtual',0),(480741,13354,'ru','Ð•ÑÐ»Ð¸ Ð²Ð¸Ñ€Ñ‚ÑƒÐ°Ð»ÑŒÐ½Ñ‹Ðµ Ñ‡ÐµÑ€Ð½Ð¸Ð»Ð°',0),(480742,13354,'es','Si es Tinta Virtual',0),(480743,13354,'de','Wenn virtuelle Tinte',0),(480744,13354,'en','If Virtual Ink',0),(480745,13355,'is','',0),(480746,13355,'dr','ØªØ¹Ø¯Ø§Ø¯ ÙˆØ§Ù‚Ø¹ÛŒ Ø¬ÙˆÙ‡Ø± Ù†Ù…Ø§ÛŒÙ†Ø¯Ú¯ÛŒ',0),(480747,13355,'pr','ØªØ¹Ø¯Ø§Ø¯ ÙˆØ§Ù‚Ø¹ÛŒ Ø¬ÙˆÙ‡Ø± Ù†Ù…Ø§ÛŒÙ†Ø¯Ú¯ÛŒ',0),(480748,13355,'tr','GerÃ§ek mÃ¼rekkep temsil sayÄ±sÄ±',0),(480749,13355,'pl','Liczba rzeczywistych farb reprezentowane',0),(480750,13355,'bg','Ð‘Ñ€Ð¾Ð¹ Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²ÐµÐ½Ð¸',0),(480751,13355,'ur','Ø§ØµÙ„ Ø§Ù†Ú©Ø³ Ú©ÛŒ Ù†Ù…Ø§Ø¦Ù†Ø¯Ú¯ÛŒ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(480752,13355,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑÑ‚Ð²Ð°Ñ€Ð½Ð¸Ñ… Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð·Ð°ÑÑ‚ÑƒÐ¿Ñ™ÐµÐ½Ð°',0),(480753,13355,'vi','Sá»‘ lÆ°á»£ng thá»±c táº¿ má»±c Ä‘áº¡i diá»‡n',0),(480754,13355,'af','Aantal werklike ink verteenwoordig',0),(480755,13355,'ro','NumÄƒrul de cerneluri reale reprezentate',0),(480756,13355,'et','Esindatud tegelik tintide arvu',0),(480757,13355,'si','Å tevilo dejanskih Ärnila, ki zastopa',0),(480758,13355,'ba','Jumlah sebenarnya tinta yang mewakili',0),(480759,13355,'nl','Aantal werkelijke inktkleuren vertegenwoordigd',0),(480760,13355,'fi','Todellinen vÃ¤rien edustaa mÃ¤Ã¤rÃ¤',0),(480761,13355,'no','Antallet faktiske blekkfarger representert',0),(480762,13355,'da','Antallet af faktiske trykfarver reprÃ¦senteret',0),(480763,13355,'ko','ì‹¤ì œ ìž‰í¬ ëŒ€í‘œ ë²ˆí˜¸',0),(480764,13355,'he','×ž×¡×¤×¨ ×¡×•×’×™ ×”×“×™×• ×‘×¤×•×¢×œ ×™×™×¦×’',0),(480765,13355,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Ï„Ï‰Î½ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÏŽÎ½ Î¼ÎµÎ»Î¬Î½Î¹Î± Ï€Î¿Ï… ÎµÎºÏ€ÏÎ¿ÏƒÏ‰Ï€Î¿ÏÎ½Ï„Î±Î¹',0),(480766,13355,'zh','å®žé™…çš„å¢¨è¿¹ä»£è¡¨æ•°é‡',0),(480767,13355,'sv','Antalet faktiska blÃ¤ck representerade',0),(480768,13355,'it','Numero di inchiostri effettivi rappresentato',0),(480769,13355,'tl','',0),(480770,13355,'th','à¸ˆà¸³à¸™à¸§à¸™à¸ˆà¸£à¸´à¸‡à¸«à¸¡à¸¶à¸à¹à¸—à¸™',0),(480771,13355,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤•à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿à¤¤à¥à¤µ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(480772,13355,'ms','Bilangan sebenar dakwat yang diwakili',0),(480773,13355,'ar','Ø¹Ø¯Ø¯ Ù…Ù† Ø§Ù„Ø£Ø­Ø¨Ø§Ø± Ø§Ù„ÙØ¹Ù„ÙŠØ© Ø§Ù„ØªÙŠ ØªÙ…Ø«Ù„',0),(480774,13355,'fr','Nombre d\'encres rÃ©els reprÃ©sentÃ©',0),(480775,13355,'jp','è¡¨ã•ã‚Œã‚‹å®Ÿéš›ã®ã‚¤ãƒ³ã‚¯ã®æ•°',0),(480776,13355,'pt','NÃºmero de tintas reais representado',0),(480777,13355,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ€ÐµÐ°Ð»ÑŒÐ½Ñ‹Ñ… ÐºÑ€Ð°ÑÐ¾Ðº Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(480778,13355,'es','NÃºmero de Enlaces Actuales Representados',0),(480779,13355,'de','Anzahl der tatsÃ¤chlichen Farben dargestellt',0),(480780,13355,'en','Number Of Actual Inks Represented',0),(480781,13356,'is','',0),(480782,13356,'dr','Ø§Ù†Ø¬Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§ØªØŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª &amp; Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(480783,13356,'pr','Ø§Ù†Ø¬Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§ØªØŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª &amp; Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(480784,13356,'tr','Fulfillment sipariÅŸler, POS sipariÅŸler & gÃ¶nderiler',0),(480785,13356,'pl','Realizacji zamÃ³wieÅ„, POS zamÃ³wienia & przesyÅ‚ek',0),(480786,13356,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, POS Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ & ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(480787,13356,'ur','ØªÚ©Ù…ÛŒÙ„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§ØªØŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª & ØªØ±Ø³ÛŒÙ„',0),(480788,13356,'sr','Ð˜ÑÐ¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ, ÐŸÐžÐ¡ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ & Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(480789,13356,'vi','Thá»±c hiá»‡n Ä‘Æ¡n Ä‘áº·t hÃ ng, POS Ä‘Æ¡n Ä‘áº·t hÃ ng &amp; lÃ´ hÃ ng',0),(480790,13356,'af','Nakoming Orders, POS bestellings & gestuur',0),(480791,13356,'ro','ÃŽndeplinirea comenzilor, POS comenzi & transporturile',0),(480792,13356,'et','Plaanitud tellimuste, POS tellimuste & saadetised',0),(480793,13356,'si','Izpolnitev naroÄila, POS naroÄila & poÅ¡iljk',0),(480794,13356,'ba','Pemenuhan pesanan, POS perintah & pengiriman',0),(480795,13356,'nl','Vervulling Orders, POS Orders & zendingen',0),(480796,13356,'fi','TÃ¤yttÃ¤minen tilauksia, POS tilauksia & siirtojen',0),(480797,13356,'no','FullfÃ¸ringen bestillinger, POS ordrer & forsendelser',0),(480798,13356,'da','Opfyldelse ordrer, POS ordrer & forsendelser',0),(480799,13356,'ko','í–‰ ì£¼ë¬¸, POS ì£¼ë¬¸ & ì¶œí•˜',0),(480800,13356,'he','×ž×™×ž×•×© ×”×–×ž× ×•×ª, POS ×”×–×ž× ×•×ª & ×ž×©×œ×•×—×™×',0),(480801,13356,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½, POS ÎµÎ½Ï„Î¿Î»Î­Ï‚ & Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(480802,13356,'zh','å±¥è¡Œè®¢å•ã€ POS è®¢å• &amp; å‘è´§',0),(480803,13356,'sv','Uppfyllelse bestÃ¤llningar, POS order & transporter',0),(480804,13356,'it','Evasione ordini, POS ordini & spedizioni',0),(480805,13356,'tl','',0),(480806,13356,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸à¸²à¸£à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸² POS à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ & à¸ªà¹ˆà¸‡',0),(480807,13356,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶, POS à¤†à¤¦à¥‡à¤¶ & à¤²à¤¦à¤¾à¤¨',0),(480808,13356,'ms','Memenuhi perintah, POS pesanan & penghantaran',0),(480809,13356,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„ÙˆÙØ§Ø¡ØŒ ÙˆÙ†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø£ÙˆØ§Ù…Ø± Ø¢Ù†Ø¯ Ø§Ù„Ø´Ø­Ù†Ø§Øª',0),(480810,13356,'fr','Des ordres, POS arrÃªtÃ©s & expÃ©ditions',0),(480811,13356,'jp','ãƒ•ãƒ«ãƒ•ã‚£ãƒ«ãƒ¡ãƒ³ãƒˆ ãƒ» ã‚ªãƒ¼ãƒ€ãƒ¼ã€POS æ³¨æ–‡ & å‡ºè·',0),(480812,13356,'pt','Cumprimento de ordens, POS as ordens & embarques',0),(480813,13356,'ru','Ð’Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð¾Ð², POS Ð·Ð°ÐºÐ°Ð·Ñ‹ & Ð³Ñ€ÑƒÐ·Ð¾Ð²',0),(480814,13356,'es','Pedidos de Cumplimiento, Pedidos PDV & Envios',0),(480815,13356,'de','ErfÃ¼llung Bestellungen, POS AuftrÃ¤ge & Sendungen',0),(480816,13356,'en','Fulfillment Orders, POS Orders & Shipments',0),(480817,13357,'is','',0),(480818,13357,'dr','Ø§Ú¯Ø± Ø¨Ø¯ÙˆÙ† Ø¨Ù„ÙˆÚ© Ø³Ù‡Ø§Ù…',0),(480819,13357,'pr','Ø§Ú¯Ø± Ø¨Ø¯ÙˆÙ† Ø¨Ù„ÙˆÚ© Ø³Ù‡Ø§Ù…',0),(480820,13357,'tr','EÄŸer herhangi bir hisse senedi engelleme',0),(480821,13357,'pl','JeÅ›li nie pieÅ„ bloku',0),(480822,13357,'bg','ÐÐºÐ¾ Ð½ÑÐ¼Ð° Ð±Ð¾Ñ€ÑÐ¾Ð²Ð° Ð±Ð»Ð¾Ðº',0),(480823,13357,'ur','Ø§Ú¯Ø± Ú©ÙˆØ¦ÛŒ Ø§Ø³Ù¹Ø§Ú© Ø¨Ù„Ø§Ú©',0),(480824,13357,'sr','ÐÐºÐ¾ Ð½ÐµÐ¼Ð° Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð±Ð»Ð¾Ðº',0),(480825,13357,'vi','Náº¿u khÃ´ng cÃ³ khá»‘i cá»• phiáº¿u',0),(480826,13357,'af','Indien geen voorraad blok',0),(480827,13357,'ro','ÃŽn cazul Ã®n care nici un bloc stoc',0),(480828,13357,'et','Kui varude plokk',0),(480829,13357,'si','ÄŒe ni zalog blok',0),(480830,13357,'ba','Jika tidak ada saham blok',0),(480831,13357,'nl','Als geen voorraad blok',0),(480832,13357,'fi','Jos varastossa lohko',0),(480833,13357,'no','Hvis ingen lager blokk',0),(480834,13357,'da','Hvis ingen Stock blok',0),(480835,13357,'ko','ë§Œì•½ ìž¬ê³  êµ¬íš ì—†ìŒ',0),(480836,13357,'he','×× ××™×Ÿ ×‘×œ×•×§ ×ž× ×™×•×ª',0),(480837,13357,'el','Î‘Î½ Î´ÎµÎ½ Ï„Î¿ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î¼Ï€Î»Î¿Îº',0),(480838,13357,'zh','å¦‚æžœæ²¡æœ‰è‚¡ç¥¨çš„å—',0),(480839,13357,'sv','Om inga lager Block',0),(480840,13357,'it','Se nessun blocco di magazzino',0),(480841,13357,'tl','',0),(480842,13357,'th','à¸–à¹‰à¸²à¹„à¸¡à¹ˆà¸šà¸¥à¹‡à¸­à¸„à¸«à¸¸à¹‰à¸™',0),(480843,13357,'hi','à¤¯à¤¦à¤¿ à¤•à¥‹à¤ˆ à¤¸à¥à¤Ÿà¥‰à¤• à¤¬à¥à¤²à¥‰à¤•',0),(480844,13357,'ms','Jika tiada blok saham',0),(480845,13357,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø§ ÙŠÙˆØ¬Ø¯ ÙƒØªÙ„Ø© Ø§Ù„Ø£Ø³Ù‡Ù…',0),(480846,13357,'fr','Si aucun bloc de Stock',0),(480847,13357,'jp','å ´åˆãªã„åœ¨åº«ã®ãƒ–ãƒ­ãƒƒã‚¯',0),(480848,13357,'pt','Se nenhum bloco de aÃ§Ãµes',0),(480849,13357,'ru','Ð•ÑÐ»Ð¸ Ð½ÐµÑ‚ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð±Ð»Ð¾ÐºÐ°',0),(480850,13357,'es','Bloquear si no Hay Stock',0),(480851,13357,'de','Wenn kein Lager-Block',0),(480852,13357,'en','If No Stock Block',0),(480853,13358,'is','',0),(480854,13358,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª POS &amp; Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(480855,13358,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª POS &amp; Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(480856,13358,'tr','POS sipariÅŸler & gÃ¶nderiler',0),(480857,13358,'pl','POS zamÃ³wienia & przesyÅ‚ek',0),(480858,13358,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ ÐŸÐžÐ¡ & ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(480859,13358,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª & ØªØ±Ø³ÛŒÙ„',0),(480860,13358,'sr','ÐŸÐžÐ¡ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ & Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(480861,13358,'vi','ÄÆ¡n Ä‘áº·t hÃ ng POS &amp; lÃ´ hÃ ng',0),(480862,13358,'af','POS bestellings & gestuur',0),(480863,13358,'ro','POS comenzi & transporturile',0),(480864,13358,'et','POS tellimuste & saadetised',0),(480865,13358,'si','Nalogi POS & poÅ¡iljk',0),(480866,13358,'ba','POS perintah & pengiriman',0),(480867,13358,'nl','POS Orders & zendingen',0),(480868,13358,'fi','POS tilauksia & siirtojen',0),(480869,13358,'no','POS ordrer & forsendelser',0),(480870,13358,'da','POS ordrer & forsendelser',0),(480871,13358,'ko','POS ì£¼ë¬¸ & ì¶œí•˜',0),(480872,13358,'he','POS ×”×–×ž× ×•×ª & ×ž×©×œ×•×—×™×',0),(480873,13358,'el','POS ÎµÎ½Ï„Î¿Î»Î­Ï‚ & Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(480874,13358,'zh','POS è®¢å• &amp; å‘è´§',0),(480875,13358,'sv','POS order & transporter',0),(480876,13358,'it','Ordini di POS & spedizioni',0),(480877,13358,'tl','',0),(480878,13358,'th','POS à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ & à¸ªà¹ˆà¸‡',0),(480879,13358,'hi','POS à¤†à¤¦à¥‡à¤¶ & à¤²à¤¦à¤¾à¤¨',0),(480880,13358,'ms','Pesanan POS & penghantaran',0),(480881,13358,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨ÙŠØ¹ Ø¢Ù†Ø¯ Ø§Ù„Ø´Ø­Ù†Ø§Øª',0),(480882,13358,'fr','Ordres de POS & expÃ©ditions',0),(480883,13358,'jp','PO ã®å—æ³¨ & å‡ºè·',0),(480884,13358,'pt','Ordens de POS & embarques',0),(480885,13358,'ru','POS Ð·Ð°ÐºÐ°Ð·Ñ‹ & Ð³Ñ€ÑƒÐ·Ð¾Ð²',0),(480886,13358,'es','Pedidos de PDV & Envios',0),(480887,13358,'de','POS AuftrÃ¤ge & Sendungen',0),(480888,13358,'en','POS Orders & Shipments',0),(480889,13359,'is','',0),(480890,13359,'dr','Ø¬Ø¹Ø¨Ù‡ &amp; Ø¬Ø¯Ø§ Ø§Ø²/Ø¨Ù‡',0),(480891,13359,'pr','Ø¬Ø¹Ø¨Ù‡ &amp; Ø¬Ø¯Ø§ Ø§Ø²/Ø¨Ù‡',0),(480892,13359,'tr','Kutu & / ayrÄ±',0),(480893,13359,'pl','Pole & z/do oddzielenia',0),(480894,13359,'bg','ÐšÑƒÑ‚Ð¸Ñ & Ð¾Ñ‚/ÐºÑŠÐ¼ Ð¾Ñ‚Ð´ÐµÐ»Ð½Ð¸',0),(480895,13359,'ur','Ø®Ø§Ù†Û & Ø³Û’/Ø³Û’ Ø§Ù„Ú¯',0),(480896,13359,'sr','Ð£ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ & ÑÐ° Ñ€Ð°Ð·Ð´Ð²Ð¾Ñ˜Ð¸Ñ‚Ð¸',0),(480897,13359,'vi','Há»™p &amp; tá»«/Ä‘áº¿n riÃªng biá»‡t',0),(480898,13359,'af','Box & uit/om te skei',0),(480899,13359,'ro','Box & la separa',0),(480900,13359,'et','Kasti & alates/kuni eraldi',0),(480901,13359,'si','Polje & iz/loÄenih',0),(480902,13359,'ba','Kotak & dari/ke terpisah',0),(480903,13359,'nl','Vak & van/naar scheiden',0),(480904,13359,'fi','Laatikko & / erottaa',0),(480905,13359,'no','Boksen & fra separat',0),(480906,13359,'da','Boksen & fra/til adskille',0),(480907,13359,'ko','ìƒìž & / ë¶„ë¦¬',0),(480908,13359,'he','×ª×™×‘×ª & ×ž/××œ ×œ×”×¤×¨×™×“',0),(480909,13359,'el','ÎšÎ¿Ï…Ï„Î¯ & Î±Ï€ÏŒ/Ï€ÏÎ¿Ï‚ Ï„Î¿ Î´Î¹Î±Ï‡Ï‰ÏÎ¹ÏƒÎ¼ÏŒ',0),(480910,13359,'zh','æ¡†ä¸­ï¼Œ&amp; ä»Žåˆ°åˆ†å¼€',0),(480911,13359,'sv','Box & frÃ¥n/till separat',0),(480912,13359,'it','Casella & da/per separare',0),(480913,13359,'tl','',0),(480914,13359,'th','à¸à¸¥à¹ˆà¸­à¸‡ & à¸ˆà¸²à¸/à¹„à¸›à¸¢à¸±à¸‡à¹à¸¢à¸',0),(480915,13359,'hi','à¤¬à¥‰à¤•à¥à¤¸ & / à¤¸à¥‡ à¤…à¤²à¤—',0),(480916,13359,'ms','Kotak & dari/ke berasingan',0),(480917,13359,'ar','Ù…Ø±Ø¨Ø¹ Ø¢Ù†Ø¯ Ù…Ù† ÙˆØ¥Ù„Ù‰ ÙØµÙ„',0),(480918,13359,'fr','BoÃ®te de & de/Ã  sÃ©parer',0),(480919,13359,'jp','ãƒœãƒƒã‚¯ã‚¹ & ã¸ã®åˆ†é›¢',0),(480920,13359,'pt','Caixa & de separar',0),(480921,13359,'ru','ÐšÐ¾Ñ€Ð¾Ð±ÐºÐ¸ & Ñ Ð¾Ñ‚Ð´ÐµÐ»ÑŒÐ½Ñ‹Ñ…',0),(480922,13359,'es','Separan la Caja y Desde/A',0),(480923,13359,'de','Box & vom/zum Trennen',0),(480924,13359,'en','Box & From/To Separate',0),(480925,13360,'is','',0),(480926,13360,'dr','Ø¬Ø¹Ø¨Ù‡ Ø¨Ø±Ú†Ø³Ø¨ Ù‚Ø§Ù„Ø¨',0),(480927,13360,'pr','Ø¬Ø¹Ø¨Ù‡ Ø¨Ø±Ú†Ø³Ø¨ Ù‚Ø§Ù„Ø¨',0),(480928,13360,'tr','Kutu etiket biÃ§imi',0),(480929,13360,'pl','Format etykiety pola',0),(480930,13360,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚ Ð½Ð° Ð¿Ð¾Ð»Ðµ',0),(480931,13360,'ur','Ø®Ø§Ù†Û Ù„ÛŒØ¨Ù„ ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(480932,13360,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð¾Ð·Ð½Ð°ÐºÐµ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ',0),(480933,13360,'vi','Há»™p nhÃ£n Ä‘á»‹nh dáº¡ng',0),(480934,13360,'af','Posbus etiket formaat',0),(480935,13360,'ro','Format de etichetÄƒ cutie',0),(480936,13360,'et','VÃ¤ljale sildi vorming',0),(480937,13360,'si','Obliko oznake polja',0),(480938,13360,'ba','Format Label kotak',0),(480939,13360,'nl','Vak Labelindeling',0),(480940,13360,'fi','Ruudun selitteen muoto',0),(480941,13360,'no','Boksen Etikettformat',0),(480942,13360,'da','Boks etiketformat',0),(480943,13360,'ko','ìƒìž ë ˆì´ë¸” í˜•ì‹',0),(480944,13360,'he','×¢×™×¦×•×‘ ×ª×•×•×™×ª ×ª×™×‘×ª',0),(480945,13360,'el','ÎšÎ¿Ï…Ï„Î¯ ÎµÏ„Î¹ÎºÎ­Ï„Î± Î¼Î¿ÏÏ†Î®',0),(480946,13360,'zh','æ¡†æ ‡ç­¾æ ¼å¼',0),(480947,13360,'sv','Rutan etikettformat',0),(480948,13360,'it','Casella Formato etichetta',0),(480949,13360,'tl','',0),(480950,13360,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­à¸à¸¥à¹ˆà¸­à¸‡',0),(480951,13360,'hi','à¤²à¥‡à¤¬à¤² à¤¸à¥à¤µà¤°à¥‚à¤ª à¤¬à¥‰à¤•à¥à¤¸',0),(480952,13360,'ms','Format Label Peti',0),(480953,13360,'ar','ØªÙ†Ø³ÙŠÙ‚ ØªØ³Ù…ÙŠØ© Ù…Ø±Ø¨Ø¹',0),(480954,13360,'fr','Format d\'Ã©tiquette de boÃ®te',0),(480955,13360,'jp','ãƒœãƒƒã‚¯ã‚¹ã®ãƒ©ãƒ™ãƒ«ã®æ›¸å¼',0),(480956,13360,'pt','Caixa formato de etiqueta',0),(480957,13360,'ru','ÐŸÐ¾Ð»Ðµ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð¼ÐµÑ‚ÐºÐ¸',0),(480958,13360,'es','Formato de Etiqueta de Caja',0),(480959,13360,'de','Feld-Etikettenformat',0),(480960,13360,'en','Box Label Format',0),(480961,13361,'is','',0),(480962,13361,'dr','Ù¾ÛŒØ§Ù… Ø§Ú¯Ø± ÙˆØ²Ù† Ø¨ÛŒØ´ Ø§Ø² Ø­Ø¯Ø§Ú©Ø«Ø±',0),(480963,13361,'pr','Ù¾ÛŒØ§Ù… Ø§Ú¯Ø± ÙˆØ²Ù† Ø¨ÛŒØ´ Ø§Ø² Ø­Ø¯Ø§Ú©Ø«Ø±',0),(480964,13361,'tr','EÄŸer mesaj Max\'i aÄŸÄ±rlÄ±k',0),(480965,13361,'pl','WiadomoÅ›ci, jeÅ›li waga ponad Max',0),(480966,13361,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð°ÐºÐ¾ Ñ‚ÐµÐ³Ð»Ð¾ Ð½Ð°Ð´ ÐœÐ°ÐºÑ',0),(480967,13361,'ur','Ø§Ú¯Ø± Ù¾ÛŒØºØ§Ù… Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ÙˆØ²Ù†',0),(480968,13361,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐ° Ð°ÐºÐ¾ Ñ‚ÐµÐ¶Ð¸Ð½Ñƒ Ð½Ð° ÐœÐ°x',0),(480969,13361,'vi','Tin nháº¯n náº¿u trá»ng lÆ°á»£ng trÃªn Max',0),(480970,13361,'af','Boodskap as gewig oor Max',0),(480971,13361,'ro','Mesaj dacÄƒ greutatea peste Max',0),(480972,13361,'et','Teade Ã¼le Max kaal',0),(480973,13361,'si','SporoÄilo, Äe teÅ¾o nad Max',0),(480974,13361,'ba','Pesan jika berat atas Max',0),(480975,13361,'nl','Message als gewicht Over Max',0),(480976,13361,'fi','Jos paino yli Max',0),(480977,13361,'no','Meldingen hvis vekt Over Max',0),(480978,13361,'da','Meddelelse, hvis vÃ¦gt Over Max',0),(480979,13361,'ko','ë©”ì‹œì§€ ê²½ìš° ìµœëŒ€ì— ë¬´ê²Œ',0),(480980,13361,'he','. ×”×•×“×¢×” ×× ×ž×©×§×œ ×¢×œ ×ž×§×¡',0),(480981,13361,'el','ÎœÎ®Î½Ï…Î¼Î± ÎµÎ¬Î½ Î²Î¬ÏÎ¿Ï‚ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Max',0),(480982,13361,'zh','æ¶ˆæ¯ï¼Œå¦‚æžœåœ¨æœ€å¤§é‡é‡',0),(480983,13361,'sv','Meddelande om vikt Ã¶ver Max',0),(480984,13361,'it','Messaggio se peso sopra Max',0),(480985,13361,'tl','',0),(480986,13361,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸–à¹‰à¸²à¸™à¹‰à¸³à¸«à¸™à¸±à¸à¹€à¸à¸´à¸™à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(480987,13361,'hi','à¤¯à¤¦à¤¿ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤µà¤œà¤¨',0),(480988,13361,'ms','Mesej jika berat ke atas Max',0),(480989,13361,'ar','Ø§Ù„Ø±Ø³Ø§Ù„Ø© Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„ÙˆØ²Ù† ÙÙˆÙ‚ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰',0),(480990,13361,'fr','Message si poids au Max',0),(480991,13361,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®å ´åˆã¯æœ€å¤§ä¸Šã®é‡é‡',0),(480992,13361,'pt','Mensagem se peso sobre Max',0),(480993,13361,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ, ÐµÑÐ»Ð¸ Ð²ÐµÑ Ð½Ð°Ð´ ÐœÐ°ÐºÑ',0),(480994,13361,'es','Mensaje Si el Peso es MÃ¡s Alto del Maximo',0),(480995,13361,'de','Nachricht, wenn Gewicht Ã¼ber Max',0),(480996,13361,'en','Message If Weight Over Max',0),(480997,13362,'is','',0),(480998,13362,'dr','ÙˆØ²Ù† Ø¨ÛŒØ´ Ø§Ø² Ù†Ù…Ø§ÛŒØ´ Ù¾ÛŒØ§Ù…',0),(480999,13362,'pr','ÙˆØ²Ù† Ø¨ÛŒØ´ Ø§Ø² Ù†Ù…Ø§ÛŒØ´ Ù¾ÛŒØ§Ù…',0),(481000,13362,'tr','Kilo Ã¼zerinde ekran mesaj',0),(481001,13362,'pl','Waga na wyÅ›wietlaczu komunikat',0),(481002,13362,'bg','Ð¢ÐµÐ³Ð»Ð¾ Ð½Ð°Ð´ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(481003,13362,'ur','ÚˆØ³Ù¾Ù„Û’ Ù¾ÛŒØºØ§Ù… Ø²ÛŒØ§Ø¯Û ÙˆØ²Ù†',0),(481004,13362,'sr','Ð¢ÐµÐ¶Ð¸Ð½Ð° Ð¿Ñ€ÐµÐºÐ¾ ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ñ€ÑƒÐºÑƒ',0),(481005,13362,'vi','Trá»ng lÆ°á»£ng hÆ¡n Hiá»ƒn thá»‹ tin nháº¯n',0),(481006,13362,'af','Gewig oor vertoon boodskap',0),(481007,13362,'ro','Greutate peste Display mesaj',0),(481008,13362,'et','Kaalu Ã¼le teate kuvamine',0),(481009,13362,'si','TeÅ¾a nad izloÅ¾ba sporoÄilo',0),(481010,13362,'ba','Berat atas tampilan pesan',0),(481011,13362,'nl','Gewicht Over Display bericht',0),(481012,13362,'fi','Paino yli NÃ¤ytÃ¤ viesti',0),(481013,13362,'no','Vekt Over skjermen melding',0),(481014,13362,'da','VÃ¦gt Over Display besked',0),(481015,13362,'ko','ë””ìŠ¤í”Œë ˆì´ ë©”ì‹œì§€ì— ë¬´ê²Œ',0),(481016,13362,'he','×ž×©×§×œ ×ž×¢×œ ×”×¦×’ ×”×•×“×¢×”',0),(481017,13362,'el','Î’Î¬ÏÎ¿Ï‚ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Ï„Î·Î½ Î¿Î¸ÏŒÎ½Î· Î¼Î®Î½Ï…Î¼Î±',0),(481018,13362,'zh','åœ¨æ˜¾ç¤ºæ¶ˆæ¯çš„é‡é‡',0),(481019,13362,'sv','Vikt Ã¶ver displayen meddelande',0),(481020,13362,'it','Peso sopra il messaggio sul Display',0),(481021,13362,'tl','',0),(481022,13362,'th','à¸™à¹‰à¸³à¸«à¸™à¸±à¸à¸¡à¸²à¸à¸à¸§à¹ˆà¸²à¹à¸ªà¸”à¸‡à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡',0),(481023,13362,'hi','à¤µà¤œà¤¨ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¸à¤‚à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(481024,13362,'ms','Berat ke atas paparan mesej',0),(481025,13362,'ar','Ø§Ù„ÙˆØ²Ù† Ø¹Ù„Ù‰ Ù…Ø¯Ù‰ Ø¹Ø±Ø¶ Ø±Ø³Ø§Ù„Ø©',0),(481026,13362,'fr','Poids au Message Ã  l\'Ã©cran',0),(481027,13362,'jp','ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã®è¡¨ç¤ºä¸Šã®é‡é‡',0),(481028,13362,'pt','Peso sobre apresentaÃ§Ã£o de mensagem',0),(481029,13362,'ru','Ð’ÐµÑ Ð½Ð°Ð´ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð·Ð¸Ñ‚ÑŒ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(481030,13362,'es','Pesa Sobre El Mensaje de Desplega',0),(481031,13362,'de','Gewicht Ã¼ber Meldung anzeigen',0),(481032,13362,'en','Weight Over Display Message',0),(481033,13363,'is','',0),(481034,13363,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ø¬Ø¯ÛŒØ¯ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(481035,13363,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ø¬Ø¯ÛŒØ¯ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(481036,13363,'tr','Yeni kredi oluÅŸturun',0),(481037,13363,'pl','Tworzenie nowych kredytÃ³w',0),(481038,13363,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(481039,13363,'ur','Ù†Ø¦Û’ Ú©Ø±ÛŒÚˆÙ¹ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(481040,13363,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(481041,13363,'vi','Táº¡o má»›i tÃ­n dá»¥ng',0),(481042,13363,'af','Skep nuwe krediet',0),(481043,13363,'ro','CreaÅ£i noul Credit',0),(481044,13363,'et','Saate luua uue krediitkaardi',0),(481045,13363,'si','Ustvarite nove kreditne',0),(481046,13363,'ba','Membuat kredit baru',0),(481047,13363,'nl','Maken nieuw krediet',0),(481048,13363,'fi','Luo uusi luottokortit',0),(481049,13363,'no','Opprette nye kredittkort',0),(481050,13363,'da','Skabe nye kredit',0),(481051,13363,'ko','ìƒˆë¡œìš´ ì‹ ìš©ì„ ë§Œë“œëŠ”',0),(481052,13363,'he','×œ×™×¦×•×¨ ××©×¨××™ ×—×“×©',0),(481053,13363,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Î½Î­Î¿ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ',0),(481054,13363,'zh','åˆ›å»ºæ–°çš„ä¿¡è´·',0),(481055,13363,'sv','Skapa ny kredit',0),(481056,13363,'it','Creare nuovo credito',0),(481057,13363,'tl','',0),(481058,13363,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹€à¸„à¸£à¸”à¸´à¸•à¹ƒà¸«à¸¡à¹ˆ',0),(481059,13363,'hi','à¤¨à¤ˆ à¤•à¥à¤°à¤¡à¤¿à¤Ÿ à¤¬à¤¨à¤¾à¤à¤',0),(481060,13363,'ms','Mencipta kredit baru',0),(481061,13363,'ar','Ø®Ù„Ù‚ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(481062,13363,'fr','CrÃ©er nouveau crÃ©dit',0),(481063,13363,'jp','æ–°ã—ã„ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(481064,13363,'pt','Criar novo crÃ©dito',0),(481065,13363,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(481066,13363,'es','Crear nuevo CrÃ©dito',0),(481067,13363,'de','Erstellen neuen Kredit',0),(481068,13363,'en','Create New Credit',0),(481069,13364,'is','',0),(481070,13364,'dr','Ù„Ø·ÙØ§ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡',0),(481071,13364,'pr','Ù„Ø·ÙØ§ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡',0),(481072,13364,'tr','LÃ¼tfen Ã¶deme iÃ§in girin',0),(481073,13364,'pl','Podaj zapÅ‚aciÄ‡',0),(481074,13364,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð»Ð°Ñ‚Ð¸ Ð·Ð°',0),(481075,13364,'ur','Ø§ÛŒÚ© Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(481076,13364,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð´Ð° Ð¿Ð»Ð°Ñ‚Ðµ',0),(481077,13364,'vi','Vui lÃ²ng nháº­p má»™t tráº£ tiá»n Ä‘á»ƒ',0),(481078,13364,'af','Tik asseblief \'n salaris te',0),(481079,13364,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i o plÄƒteascÄƒ pentru',0),(481080,13364,'et','Palun sisestage tasub',0),(481081,13364,'si','Vnesite plaÄilo za',0),(481082,13364,'ba','Masukkan membayar untuk',0),(481083,13364,'nl','Voer een loon om te',0),(481084,13364,'fi','Kirjoita maksettava',0),(481085,13364,'no','Angi en lÃ¸nn Ã¥',0),(481086,13364,'da','Angiv en lÃ¸n til',0),(481087,13364,'ko','ì— ê¸‰ì—¬ë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(481088,13364,'he','×”×–×™× ×• ×‘×‘×§×©×” ××ª ×”×ª×©×œ×•× ×›×“×™',0),(481089,13364,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î±Î¼Î¿Î¹Î²Î® Î³Î¹Î± Î½Î±',0),(481090,13364,'zh','è¯·è¾“å…¥æ”¶æ¬¾äºº',0),(481091,13364,'sv','Ange en betala till',0),(481092,13364,'it','Per favore inserisci un Pay per',0),(481093,13364,'tl','',0),(481094,13364,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸°à¸šà¸¸à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¹„à¸›',0),(481095,13364,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(481096,13364,'ms','Sila masukkan gaji untuk',0),(481097,13364,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø¯ÙØ¹ Ø¥Ù„Ù‰',0),(481098,13364,'fr','Veuillez entrer un payer pour',0),(481099,13364,'jp','æ”¯æ‰•ã„å…ˆã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(481100,13364,'pt','Por favor insira um pagamento a',0),(481101,13364,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ',0),(481102,13364,'es','Por Favor Entra Un Pagar A',0),(481103,13364,'de','Bitte geben Sie des ZahlungsempfÃ¤ngers',0),(481104,13364,'en','Please Enter A Pay To',0),(481105,13365,'is','',0),(481106,13365,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø±Ø¬Ø¹',0),(481107,13365,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù…Ø±Ø¬Ø¹',0),(481108,13365,'tr','Referans numarasÄ±',0),(481109,13365,'pl','Numer referencyjny',0),(481110,13365,'bg','Ð ÐµÑ„ÐµÑ€ÐµÐ½Ñ‚ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(481111,13365,'ur','Ø­ÙˆØ§Ù„Û Ù†Ù…Ø¨Ø±',0),(481112,13365,'sr','Ð ÐµÑ„ÐµÑ€ÐµÐ½Ñ‚Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(481113,13365,'vi','Sá»‘ tham chiáº¿u',0),(481114,13365,'af','Verwysingsnommer',0),(481115,13365,'ro','NumÄƒrul de referinÈ›Äƒ',0),(481116,13365,'et','Viitenumber',0),(481117,13365,'si','ReferenÄna Å¡tevilka',0),(481118,13365,'ba','Nomor referensi',0),(481119,13365,'nl','Referentienummer',0),(481120,13365,'fi','Viitenumero',0),(481121,13365,'no','Referansenummeret',0),(481122,13365,'da','Referencenummer',0),(481123,13365,'ko','ì°¸ì¡° ë²ˆí˜¸',0),(481124,13365,'he','×ž×¡×¤×¨ ×¡×™×ž×•×›×™×Ÿ',0),(481125,13365,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(481126,13365,'zh','å‚è€ƒç¼–å·',0),(481127,13365,'sv','Referensnummer',0),(481128,13365,'it','Numero di riferimento',0),(481129,13365,'tl','',0),(481130,13365,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸­à¹‰à¸²à¸‡à¸­à¸´à¸‡',0),(481131,13365,'hi','à¤¸à¤‚à¤¦à¤°à¥à¤­ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(481132,13365,'ms','Nombor rujukan',0),(481133,13365,'ar','Ø§Ù„Ø±Ù‚Ù… Ø§Ù„Ù…Ø±Ø¬Ø¹ÙŠ',0),(481134,13365,'fr','NumÃ©ro de rÃ©fÃ©rence',0),(481135,13365,'jp','å‚ç…§ç•ªå·',0),(481136,13365,'pt','NÃºmero de referÃªncia',0),(481137,13365,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑÑ‹Ð»ÐºÐ¸',0),(481138,13365,'es','NÃºmero de Referencia',0),(481139,13365,'de','Referenznummer',0),(481140,13365,'en','Reference Number',0),(481141,13366,'is','',0),(481142,13366,'dr','Ø±ÙˆØ´ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(481143,13366,'pr','Ø±ÙˆØ´ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(481144,13366,'tr','Geri Ã¶deme yÃ¶ntemi',0),(481145,13366,'pl','Metoda zwrotu',0),(481146,13366,'bg','Ð’ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð¼ÐµÑ‚Ð¾Ð´',0),(481147,13366,'ur','Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø±',0),(481148,13366,'sr','ÐœÐµÑ‚Ð¾Ð´ Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°',0),(481149,13366,'vi','PhÆ°Æ¡ng phÃ¡p hoÃ n tráº£',0),(481150,13366,'af','Terugbetaling metode',0),(481151,13366,'ro','Metoda de rambursare',0),(481152,13366,'et','Tagasimakse viis',0),(481153,13366,'si','Nadomestila metoda',0),(481154,13366,'ba','Metode pengembalian dana',0),(481155,13366,'nl','Restitutie methode',0),(481156,13366,'fi','Palauta jÃ¤rjestys',0),(481157,13366,'no','Refusjon-metoden',0),(481158,13366,'da','Restitutionen metode',0),(481159,13366,'ko','í™˜ë¶ˆ ë°©ë²•',0),(481160,13366,'he','×©×™×˜×ª ×”×—×–×¨',0),(481161,13366,'el','Î— Î¼Î­Î¸Î¿Î´Î¿Ï‚ ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚',0),(481162,13366,'zh','é€€æ¬¾æ–¹å¼',0),(481163,13366,'sv','Ã…terbetalning metod',0),(481164,13366,'it','Metodo di rimborso',0),(481165,13366,'tl','',0),(481166,13366,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸„à¸·à¸™à¹€à¸‡à¸´à¸™',0),(481167,13366,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤µà¤¿à¤§à¤¿',0),(481168,13366,'ms','Kaedah bayaran balik',0),(481169,13366,'ar','Ø£Ø³Ù„ÙˆØ¨ Ø§Ø³ØªØ±Ø¯Ø§Ø¯',0),(481170,13366,'fr','MÃ©thode de remboursement',0),(481171,13366,'jp','æ‰•ã„æˆ»ã—æ–¹æ³•',0),(481172,13366,'pt','MÃ©todo de reembolso',0),(481173,13366,'ru','Ð¡Ð¿Ð¾ÑÐ¾Ð± Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð°',0),(481174,13366,'es','Modo de DevoluciÃ³n',0),(481175,13366,'de','RÃ¼ckerstattung-Methode',0),(481176,13366,'en','Refund Method',0),(481177,13367,'is','',0),(481178,13367,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ø¹ØªØ¨Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(481179,13367,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ø¹ØªØ¨Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(481180,13367,'tr','Mevcut kredi kullanma',0),(481181,13367,'pl','UÅ¼yj istniejÄ…cego kredytu',0),(481182,13367,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸',0),(481183,13367,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ú©Ø±ÛŒÚˆÙ¹ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(481184,13367,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(481185,13367,'vi','Sá»­ dá»¥ng tÃ­n dá»¥ng hiá»‡n táº¡i',0),(481186,13367,'af','Gebruik bestaande krediet',0),(481187,13367,'ro','UtilizaÅ£i existente de Credit',0),(481188,13367,'et','Kasutada olemasoleva krediidi',0),(481189,13367,'si','Uporabite obstojeÄe kreditne',0),(481190,13367,'ba','Menggunakan kredit yang sudah ada',0),(481191,13367,'nl','Gebruiken van bestaande krediet',0),(481192,13367,'fi','KÃ¤yttÃ¤Ã¤ olemassa olevia',0),(481193,13367,'no','Bruke eksisterende kreditt',0),(481194,13367,'da','Brug eksisterende kreditkort',0),(481195,13367,'ko','ê¸°ì¡´ ì‹ ìš©ì„ ì‚¬ìš© í•˜ ì—¬',0),(481196,13367,'he','×”×©×ª×ž×© ×”××©×¨××™ ×”×§×™×™×ž×ª',0),(481197,13367,'el','Î§ÏÎ®ÏƒÎ· Ï„Ï‰Î½ Ï…Ï†Î¹ÏƒÏ„Î¬Î¼ÎµÎ½Ï‰Î½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½',0),(481198,13367,'zh','ä½¿ç”¨çŽ°æœ‰çš„ä¿¡è´·',0),(481199,13367,'sv','AnvÃ¤nda befintliga kredit',0),(481200,13367,'it','Utilizzare il credito esistente',0),(481201,13367,'tl','',0),(481202,13367,'th','à¹ƒà¸Šà¹‰à¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(481203,13367,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(481204,13367,'ms','Menggunakan kredit sedia ada',0),(481205,13367,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(481206,13367,'fr','Utiliser le crÃ©dit existant',0),(481207,13367,'jp','æ—¢å­˜ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(481208,13367,'pt','Use o crÃ©dito existente',0),(481209,13367,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(481210,13367,'es','Usar CrÃ©dito Existente',0),(481211,13367,'de','Verwendung bestehenden Kredite',0),(481212,13367,'en','Use Existing Credit',0),(481213,13368,'is','',0),(481214,13368,'dr','Ø´Ø§Ù…Ù„ ØªØ±Ú©ÛŒØ¨',0),(481215,13368,'pr','Ø´Ø§Ù…Ù„ ØªØ±Ú©ÛŒØ¨',0),(481216,13368,'tr','BileÅŸim iÃ§erir',0),(481217,13368,'pl','Zawiera kompozycjÄ™',0),(481218,13368,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÑÑŠÑÑ‚Ð°Ð²',0),(481219,13368,'ur','Ø³Ø§Ø®Øª Ù¾Ø± Ù…Ø´ØªÙ…Ù„ ÛÛ’',0),(481220,13368,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ðµ ÑÐ°ÑÑ‚Ð°Ð²',0),(481221,13368,'vi','Bao gá»“m cÃ¡c thÃ nh pháº§n',0),(481222,13368,'af','Sluit samestelling',0),(481223,13368,'ro','Include compoziÅ£ia',0),(481224,13368,'et','Koostis sisaldab',0),(481225,13368,'si','VkljuÄuje sestavo',0),(481226,13368,'ba','Termasuk komposisi',0),(481227,13368,'nl','Omvat samenstelling',0),(481228,13368,'fi','SisÃ¤ltÃ¤Ã¤ kokoonpano',0),(481229,13368,'no','Inkluderer komposisjon',0),(481230,13368,'da','Omfatter sammensÃ¦tning',0),(481231,13368,'ko','êµ¬ì„± í¬í•¨',0),(481232,13368,'he','×›×•×œ×œ ×”×¨×›×‘',0),(481233,13368,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ ÏƒÏÎ½Î¸ÎµÏƒÎ·',0),(481234,13368,'zh','åŒ…æ‹¬ç»„æˆ',0),(481235,13368,'sv','Inkluderar sammansÃ¤ttning',0),(481236,13368,'it','Include la composizione',0),(481237,13368,'tl','',0),(481238,13368,'th','à¸¡à¸µà¸­à¸‡à¸„à¹Œà¸›à¸£à¸°à¸à¸­à¸š',0),(481239,13368,'hi','à¤°à¤šà¤¨à¤¾ à¤­à¥€ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆ',0),(481240,13368,'ms','Termasuk komposisi',0),(481241,13368,'ar','ÙŠØªØ¶Ù…Ù† Ø§Ù„ØªÙƒÙˆÙŠÙ†',0),(481242,13368,'fr','Comprend la Composition',0),(481243,13368,'jp','ã‚³ãƒ³ãƒã‚¸ã‚·ãƒ§ãƒ³ãŒå«ã¾ã‚Œã¦ã„ã¾ã™',0),(481244,13368,'pt','Inclui a composiÃ§Ã£o',0),(481245,13368,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°ÐµÑ‚ Ð² ÑÐµÐ±Ñ ÐºÐ¾Ð¼Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸',0),(481246,13368,'es','Se Incluye ComposiciÃ³n',0),(481247,13368,'de','Zusammensetzung enthÃ¤lt',0),(481248,13368,'en','Includes Composition',0),(481249,13369,'is','',0),(481250,13369,'dr','Ø´Ø§Ù…Ù„ ØªØ®ÙÛŒÙ Ø¯Ø±ØµØ¯',0),(481251,13369,'pr','Ø´Ø§Ù…Ù„ ØªØ®ÙÛŒÙ Ø¯Ø±ØµØ¯',0),(481252,13369,'tr','Ä°skonto yÃ¼zdesini iÃ§erir.',0),(481253,13369,'pl','Zawiera stawkÄ™ procentowÄ… rabatu',0),(481254,13369,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(481255,13369,'ur','Ø±Ø¹Ø§ÛŒØª ÙÛŒØµØ¯ Ù¾Ø± Ù…Ø´ØªÙ…Ù„ ÛÛ’',0),(481256,13369,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ðµ % Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(481257,13369,'vi','Bao gá»“m pháº§n trÄƒm giáº£m giÃ¡',0),(481258,13369,'af','Sluit afslag persent',0),(481259,13369,'ro','Include Discount la sutÄƒ',0),(481260,13369,'et','Sisaldab hinnaalandi protsenti',0),(481261,13369,'si','VkljuÄuje odstotek popusta',0),(481262,13369,'ba','Termasuk diskon persen',0),(481263,13369,'nl','Omvat kortingspercentage',0),(481264,13369,'fi','SisÃ¤ltÃ¤Ã¤ alennusprosentin',0),(481265,13369,'no','Inneholder rabattprosenten',0),(481266,13369,'da','Omfatter rabatprocenten',0),(481267,13369,'ko','í• ì¸ % í¬í•¨',0),(481268,13369,'he','×›×•×œ×œ ××—×•×– ×”× ×—×”',0),(481269,13369,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Ï„Î¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(481270,13369,'zh','åŒ…æ‹¬æŠ˜æ‰£ç™¾åˆ†æ¯”',0),(481271,13369,'sv','Inkluderar rabattprocent',0),(481272,13369,'it','Include per cento di sconto',0),(481273,13369,'tl','',0),(481274,13369,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸ªà¹ˆà¸§à¸™à¸¥à¸”à¸£à¸§à¸¡',0),(481275,13369,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(481276,13369,'ms','Termasuk peratus diskaun',0),(481277,13369,'ar','ÙˆÙŠØ´Ù…Ù„ Ø§Ù„Ø®ØµÙ… Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(481278,13369,'fr','Comprend pour cent de rÃ©duction',0),(481279,13369,'jp','å‰²å¼•çŽ‡ãŒå«ã¾ã‚Œã¦ã„ã¾ã™',0),(481280,13369,'pt','Inclui por cento de desconto',0),(481281,13369,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°ÐµÑ‚ Ð² ÑÐµÐ±Ñ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ ÑÐºÐ¸Ð´ÐºÐ¸',0),(481282,13369,'es','Se Incluye Porcentaje de Descuento',0),(481283,13369,'de','EnthÃ¤lt Rabattprozentsatz',0),(481284,13369,'en','Includes Discount Percent',0),(481285,13370,'is','',0),(481286,13370,'dr','Ø´Ø§Ù…Ù„ Ø§ØªÙ‡Ø§Ù… Ø±Ø§Ø´',0),(481287,13370,'pr','Ø´Ø§Ù…Ù„ Ø§ØªÙ‡Ø§Ù… Ø±Ø§Ø´',0),(481288,13370,'tr','Rush ÅŸarj iÃ§erir',0),(481289,13370,'pl','Zawiera opÅ‚aty Rush',0),(481290,13370,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Rush Ñ‚Ð°ÐºÑÐ°',0),(481291,13370,'ur','Ø±Ø´ Ø§Ù„Ø²Ø§Ù… Ø¨Ú¾ÛŒ Ø´Ø§Ù…Ù„ ÛÛ’',0),(481292,13370,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ðµ Ð¿ÑƒÑšÐµÑšÐµ Ð ÑƒÑÑ…',0),(481293,13370,'vi','Bao gá»“m phÃ­ Rush',0),(481294,13370,'af','Stormloop las sluit',0),(481295,13370,'ro','Include taxa Rush',0),(481296,13370,'et','Sisaldab Rush Tasuta',0),(481297,13370,'si','VkljuÄuje brezplaÄno hitenja',0),(481298,13370,'ba','Sudah termasuk biaya Rush',0),(481299,13370,'nl','Rush bedrag inbegrepen',0),(481300,13370,'fi','SisÃ¤ltÃ¤Ã¤ Rush ilmaiseksi',0),(481301,13370,'no','Inkluderer Rush kostnad',0),(481302,13370,'da','Omfatter Rush afgift',0),(481303,13370,'ko','ëŸ¬ì‰¬ ìš”ê¸ˆ í¬í•¨',0),(481304,13370,'he','×›×•×œ×œ ×ª×©×œ×•× ×œ×ž×”×¨',0),(481305,13370,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Ï‡ÏÎ­Ï‰ÏƒÎ· Î²Î¹Î±ÏƒÏÎ½Î·',0),(481306,13370,'zh','åŒ…æ‹¬é«˜å³°è´¹ç”¨',0),(481307,13370,'sv','Inkluderar Rush avgift',0),(481308,13370,'it','Rush Ã¨ incluso',0),(481309,13370,'tl','',0),(481310,13370,'th','à¸£à¸§à¸¡à¸„à¹ˆà¸²à¸§à¸´à¹ˆà¸‡',0),(481311,13370,'hi','à¤°à¤¶ à¤šà¤¾à¤°à¥à¤œ à¤­à¥€ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆ',0),(481312,13370,'ms','Termasuk caj tergesa-gesa',0),(481313,13370,'ar','ÙˆÙŠØ´Ù…Ù„ Ø§Ù„Ø§ØªÙ‡Ø§Ù… Ø±Ø§Ø´',0),(481314,13370,'fr','Rush frais inclus',0),(481315,13370,'jp','ãƒ©ãƒƒã‚·ãƒ¥æ–™é‡‘ãŒå«ã¾ã‚Œã¦ã„ã¾ã™',0),(481316,13370,'pt','Inclui a carga de Rush',0),(481317,13370,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°ÐµÑ‚ Ð² ÑÐµÐ±Ñ Ð Ð°Ñˆ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(481318,13370,'es','Se Incluye Cargo de Prisa',0),(481319,13370,'de','EnthÃ¤lt Rush kostenlos',0),(481320,13370,'en','Includes Rush Charge',0),(481321,13371,'is','',0),(481322,13371,'dr','Ø­Ø°Ù Ø¨Ø§Ø±Ú¯ÛŒØ±ÛŒ Ù¾Ø§Ú©Øª',0),(481323,13371,'pr','Ø­Ø°Ù Ø¨Ø§Ø±Ú¯ÛŒØ±ÛŒ Ù¾Ø§Ú©Øª',0),(481324,13371,'tr','HaftalÄ±k ZarfÄ± kaldÄ±rma',0),(481325,13371,'pl','UsunÄ…Ä‡ tygodniowy koperty',0),(481326,13371,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð° Ð¿Ð»Ð¸Ðº',0),(481327,13371,'ur','ÛÙØªÛ ÙˆØ§Ø± Ù„ÙØ§ÙÛ ÛÙ¹Ø§Ø¦ÛŒÚº',0),(481328,13371,'sr','Ð£ÐºÐ»Ð¾Ð½Ð¸Ñ‚Ðµ ÑÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð¸ ÐºÐ¾Ð²ÐµÑ€Ñ‚Ñƒ',0),(481329,13371,'vi','Loáº¡i bá» phong bÃ¬ lÆ°á»£t',0),(481330,13371,'af','Weeklikse koevert verwyder',0),(481331,13371,'ro','Elimina sÄƒptÄƒmÃ¢nal plic',0),(481332,13371,'et','Eemalda iganÃ¤dalane Ã¼mbrik',0),(481333,13371,'si','Odstranite tedenski ovojnica',0),(481334,13371,'ba','Menghapus amplop mingguan',0),(481335,13371,'nl','Per envelop verwijderen',0),(481336,13371,'fi','Poista viikoittainen kirjekuori',0),(481337,13371,'no','Fjern ukentlig konvolutt',0),(481338,13371,'da','Fjerne ugentlige kuvert',0),(481339,13371,'ko','ë§¤ì£¼ ë´‰íˆ¬ ì œê±°',0),(481340,13371,'he','×œ×”×¡×™×¨ ××ª ×”×ž×¢×˜×¤×” ×©×‘×•×¢×™',0),(481341,13371,'el','Î‘Ï†Î±Î¹ÏÎ­ÏƒÏ„Îµ Ï„Î·Î½ ÎµÎ²Î´Î¿Î¼Î±Î´Î¹Î±Î¯Î± Ï†Î¬ÎºÎµÎ»Î¿Ï‚',0),(481342,13371,'zh','åˆ é™¤æ¯å‘¨ä¿¡å°',0),(481343,13371,'sv','Ta bort varje vecka kuvert',0),(481344,13371,'it','Rimuovere la busta settimana',0),(481345,13371,'tl','',0),(481346,13371,'th','à¹€à¸­à¸²à¸‹à¸­à¸‡à¸£à¸²à¸¢à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(481347,13371,'hi','à¤²à¤¿à¤«à¤¼à¤¾à¤«à¤¼à¤¾ à¤¸à¤¾à¤ªà¥à¤¤à¤¾à¤¹à¤¿à¤• à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚',0),(481348,13371,'ms','Keluarkan sampul mingguan',0),(481349,13371,'ar','Ø¥Ø²Ø§Ù„Ø© Ø§Ù„Ù…ØºÙ„Ù Ø§Ù„ØªÙ†Ø²ÙŠÙ„Ø§Øª',0),(481350,13371,'fr','Retirez l\'enveloppe hebdomadaire',0),(481351,13371,'jp','æ¯Žé€±ã®ã‚¨ãƒ³ãƒ™ãƒ­ãƒ¼ãƒ—ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(481352,13371,'pt','Remova o Envelope semanal',0),(481353,13371,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð·Ð° ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚',0),(481354,13371,'es','Eliminar El Sobre Semanal',0),(481355,13371,'de','Pro Umschlag zu entfernen',0),(481356,13371,'en','Remove Weekly Envelope',0),(481357,13372,'is','',0),(481358,13372,'dr','Ù¾Ø³ Ø§Ø² ØªØ§ÛŒÛŒØ¯',0),(481359,13372,'pr','Ù¾Ø³ Ø§Ø² ØªØ§ÛŒÛŒØ¯',0),(481360,13372,'tr','OnaylandÄ±ktan sonra',0),(481361,13372,'pl','Po zatwierdzeniu',0),(481362,13372,'bg','Ð¡Ð»ÐµÐ´ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(481363,13372,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Û’ Ø¨Ø¹Ø¯',0),(481364,13372,'sr','ÐÐ°ÐºÐ¾Ð½ Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐ°',0),(481365,13372,'vi','Sau khi phÃª duyá»‡t',0),(481366,13372,'af','Na goedkeuring',0),(481367,13372,'ro','DupÄƒ aprobarea',0),(481368,13372,'et','PÃ¤rast kinnitamist',0),(481369,13372,'si','Po odobritvi',0),(481370,13372,'ba','Setelah persetujuan',0),(481371,13372,'nl','Na goedkeuring',0),(481372,13372,'fi','HyvÃ¤ksymisen jÃ¤lkeen',0),(481373,13372,'no','Etter godkjenning',0),(481374,13372,'da','Efter godkendelse',0),(481375,13372,'ko','ìŠ¹ì¸ í›„',0),(481376,13372,'he','×œ××—×¨ ××™×©×•×¨',0),(481377,13372,'el','ÎœÎµÏ„Î¬ Ï„Î·Î½ Î­Î³ÎºÏÎ¹ÏƒÎ·',0),(481378,13372,'zh','ç»æ‰¹å‡†åŽ',0),(481379,13372,'sv','Efter godkÃ¤nnande',0),(481380,13372,'it','Dopo l\'approvazione',0),(481381,13372,'tl','',0),(481382,13372,'th','à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(481383,13372,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‡ à¤¬à¤¾à¤¦',0),(481384,13372,'ms','Selepas kelulusan',0),(481385,13372,'ar','ÙˆØ¨Ø¹Ø¯ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰',0),(481386,13372,'fr','AprÃ¨s approbation',0),(481387,13372,'jp','æ‰¿èªå¾Œ',0),(481388,13372,'pt','ApÃ³s a aprovaÃ§Ã£o',0),(481389,13372,'ru','ÐŸÐ¾ÑÐ»Ðµ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(481390,13372,'es','DespuÃ©s la AprobaciÃ³n',0),(481391,13372,'de','Nach der Genehmigung',0),(481392,13372,'en','After Approval',0),(481393,13373,'is','',0),(481394,13373,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ± Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±',0),(481395,13373,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ± Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±',0),(481396,13373,'tr','AyrÄ±ntÄ±lÄ± bilgi iÃ§in iÅŸ',0),(481397,13373,'pl','SzczegÃ³Å‚y dotyczÄ…ce pracy',0),(481398,13373,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(481399,13373,'ur','ØªÙØµÛŒÙ„Ø§Øª Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù„ÛŒÛ’',0),(481400,13373,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(481401,13373,'vi','CÃ¡c chi tiáº¿t cho cÃ´ng viá»‡c',0),(481402,13373,'af','Besonderhede vir werk',0),(481403,13373,'ro','Detalii pentru Job',0),(481404,13373,'et','Projekti Ã¼ksikasjad',0),(481405,13373,'si','Podrobnosti za delo',0),(481406,13373,'ba','Rincian untuk pekerjaan',0),(481407,13373,'nl','Details voor baan',0),(481408,13373,'fi','TyÃ¶n tiedot',0),(481409,13373,'no','Detaljer For jobben',0),(481410,13373,'da','Detaljer For Job',0),(481411,13373,'ko','ìž‘ì—…ì— ëŒ€ í•œ ì„¸ë¶€ ì •ë³´',0),(481412,13373,'he','×¤×¨×˜×™× ×¢×‘×•×¨ ×”×¢×‘×•×“×”',0),(481413,13373,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(481414,13373,'zh','ä½œä¸šçš„è¯¦ç»†ä¿¡æ¯',0),(481415,13373,'sv','Detaljer fÃ¶r jobb',0),(481416,13373,'it','Dettagli per lavoro',0),(481417,13373,'tl','',0),(481418,13373,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸‡à¸²à¸™',0),(481419,13373,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤µà¤°à¤£',0),(481420,13373,'ms','Butir-butir kerja',0),(481421,13373,'ar','ØªÙØ§ØµÙŠÙ„ Ø¹Ù† Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(481422,13373,'fr','DÃ©tails pour l\'emploi',0),(481423,13373,'jp','ã‚¸ãƒ§ãƒ–ã®è©³ç´°',0),(481424,13373,'pt','Detalhes para trabalho',0),(481425,13373,'ru','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð»Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(481426,13373,'es','Detalles Para el Trabajo',0),(481427,13373,'de','Details fÃ¼r Job',0),(481428,13373,'en','Details For Job',0),(481429,13374,'is','',0),(481430,13374,'dr','ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡ Ø­Ù‚ Ø¨ÛŒÙ…Ù‡',0),(481431,13374,'pr','ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡ Ø­Ù‚ Ø¨ÛŒÙ…Ù‡',0),(481432,13374,'tr','Premium Ã¶zel Ã¼rÃ¼nler',0),(481433,13374,'pl','Promocje Premium',0),(481434,13374,'bg','ÐŸÑ€ÐµÐ¼Ð¸Ñ Ð¿Ñ€Ð¾Ð¼Ð¾Ñ†Ð¸Ð¸',0),(481435,13374,'ur','Ù¾Ø±ÛŒÙ…ÛŒÙ… Ø®ØµÙˆØµÛŒ',0),(481436,13374,'sr','ÐŸÑ€ÐµÐ¼Ð¸ÑƒÐ¼ ÑÐ¿ÐµÑ†Ð¸Ñ˜Ð°Ð»Ð¸Ñ‚ÐµÑ‚Ð¸',0),(481437,13374,'vi','PhÃ­ báº£o hiá»ƒm Ä‘áº·c biá»‡t',0),(481438,13374,'af','Premie Specials',0),(481439,13374,'ro','Primei oferte speciale',0),(481440,13374,'et','Premium eripakkumist',0),(481441,13374,'si','Nagrada v akciji',0),(481442,13374,'ba','Premi Khusus',0),(481443,13374,'nl','Premie Specials',0),(481444,13374,'fi','Premium tarjoukset',0),(481445,13374,'no','Premium Specials',0),(481446,13374,'da','Premium Specials',0),(481447,13374,'ko','í”„ë¦¬ë¯¸ì—„ ìŠ¤íŽ˜ì…œ',0),(481448,13374,'he','×¤×¨×™×ž×™×•× ×ž×‘×¦×¢×™×',0),(481449,13374,'el','Î ÏÎ¹Î¼Î¿Î´ÏŒÏ„Î·ÏƒÎ· Î±Ï†Î¹ÎµÏÏŽÎ¼Î±Ï„Î±',0),(481450,13374,'zh','æº¢ä»·ç‰¹ä»·',0),(481451,13374,'sv','Premium Specials',0),(481452,13374,'it','Premio Specials',0),(481453,13374,'tl','',0),(481454,13374,'th','à¸žà¸£à¸µà¹€à¸¡à¸µà¹ˆà¸¢à¸¡à¸žà¸´à¹€à¸¨à¸©',0),(481455,13374,'hi','à¤ªà¥à¤°à¥€à¤®à¤¿à¤¯à¤® à¤¸à¥à¤ªà¥‡à¤¶à¤²',0),(481456,13374,'ms','Istimewa premium',0),(481457,13374,'ar','Ù‚Ø³Ø· Ø¹Ø±ÙˆØ¶ Ø®Ø§ØµØ©',0),(481458,13374,'fr','Prime Specials',0),(481459,13374,'jp','ãƒ—ãƒ¬ãƒŸã‚¢ãƒ  ã‚¹ãƒšã‚·ãƒ£ãƒ«',0),(481460,13374,'pt','Premium especiais',0),(481461,13374,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð¿Ñ€ÐµÐ¼Ð¸Ð¸',0),(481462,13374,'es','Especiales Premios',0),(481463,13374,'de','Premium Specials',0),(481464,13374,'en','Premium Specials',0),(481465,13375,'is','',0),(481466,13375,'dr','Ø§Ú¯Ø± Ù…ØªÙ† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù†ÙˆØ¹ Ø®Ø· Monospace Ø¨Ø±Ø§ÛŒ ÙˆØ±ÙˆØ¯ÛŒ',0),(481467,13375,'pr','Ø§Ú¯Ø± Ù…ØªÙ† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù†ÙˆØ¹ Ø®Ø· Monospace Ø¨Ø±Ø§ÛŒ ÙˆØ±ÙˆØ¯ÛŒ',0),(481468,13375,'tr','Metin giriÅŸi iÃ§in Monospace Font kullanÄ±yorsanÄ±z',0),(481469,13375,'pl','UÅ¼ycie tekstu o staÅ‚ej szerokoÅ›ci czcionki dla danych wejÅ›ciowych',0),(481470,13375,'bg','ÐÐºÐ¾ Ñ‚ÐµÐºÑÑ‚ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° ÑˆÑ€Ð¸Ñ„Ñ‚ Monospace Ð·Ð° Ð²ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ',0),(481471,13375,'ur','Ø§Ú¯Ø± Ù…ØªÙ† Ø§Ù† Ù¾Ù¹ Ø¨Ø±Ø§Ø¦Û’ ÛŒÚ© ÙØ§ØµÙ„ÛŒ Ù†ÙˆÛŒØ³Û Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÛŒÚº Û”',0),(481472,13375,'sr','ÐÐºÐ¾ Ñ‚ÐµÐºÑÑ‚ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¤Ð¾Ð½Ñ‚ ÑÐ° ÑƒÑ‚Ð²Ñ€Ñ’ÐµÐ½Ð¸Ð¼ Ñ€Ð°Ð·Ð¼Ð°ÐºÐ¾Ð¼ Ð·Ð° ÑƒÐ½Ð¾Ñ',0),(481473,13375,'vi','Náº¿u vÄƒn báº£n sá»­ dá»¥ng Monospace Font cho Ä‘áº§u vÃ o',0),(481474,13375,'af','As teks monoruimte Font gebruik vir insette',0),(481475,13375,'ro','DacÄƒ textul utilizare Monospace Font pentru intrare',0),(481476,13375,'et','Kui teksti kasutada Monospace Font sisend',0),(481477,13375,'si','ÄŒe besedilo uporabite Monospace pisavo za vnos',0),(481478,13375,'ba','Jika teks menggunakan Monospace Font untuk Input',0),(481479,13375,'nl','Als tekst niet-proportioneel lettertype voor Input gebruikt',0),(481480,13375,'fi','Jos teksti kÃ¤yttÃ¤Ã¤ Monospace fontilla sisÃ¤Ã¤nmenoon',0),(481481,13375,'no','Hvis tekst bruker Monospace skrifttype For inndata',0),(481482,13375,'da','Hvis tekst bruger Monospace Font For Input',0),(481483,13375,'ko','í…ìŠ¤íŠ¸ ìž…ë ¥ì— ëŒ€ í•œ ê³ ì • í­ ê¸€ê¼´ì„ ì‚¬ìš© í•˜ëŠ” ê²½ìš°',0),(481484,13375,'he','×× ×˜×§×¡×˜ ×”×©×ª×ž×© ×‘×’×•×¤×Ÿ Monospace ×¢×‘×•×¨ ×§×œ×˜',0),(481485,13375,'el','Î•Î¬Î½ Ï„Î¿ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ Ï€Î¿Ï… Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½ Î¼Î· Î±Î½Î±Î»Î¿Î³Î¹ÎºÎ®Ï‚ Î³ÏÎ±Î¼Î¼Î±Ï„Î¿ÏƒÎµÎ¹ÏÎ¬Ï‚ Î³Î¹Î± Ï„Î· ÏƒÏ…Î¼Î²Î¿Î»Î®',0),(481486,13375,'zh','å¦‚æžœè¾“å…¥çš„æ–‡æœ¬ä½¿ç”¨ç­‰å®½å­—ä½“',0),(481487,13375,'sv','Om Text anvÃ¤nder teckensnitt med fast teckenindelning fÃ¶r Input',0),(481488,13375,'it','Se il testo utilizza Font Monospace per ingresso',0),(481489,13375,'tl','',0),(481490,13375,'th','à¸–à¹‰à¸²à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¹ƒà¸Šà¹‰à¹à¸šà¸šà¸­à¸±à¸à¸©à¸£à¸­à¸±à¸à¸‚à¸£à¸°à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸›à¹‰à¸­à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(481491,13375,'hi','à¤¯à¤¦à¤¿ à¤ªà¤¾à¤  à¤‡à¤¨à¤ªà¥à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ Monospace à¤«à¤¼à¥‰à¤¨à¥à¤Ÿ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(481492,13375,'ms','Jika teks menggunakan fon Monospace bagi Input',0),(481493,13375,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ù†Øµ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø®Ø· Ø£Ø­Ø§Ø¯ÙŠ Ø§Ù„Ù…Ø³Ø§ÙØ© Ù„Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(481494,13375,'fr','Si le texte utilise la police monospace pour l\'entrÃ©e',0),(481495,13375,'jp','ãƒ†ã‚­ã‚¹ãƒˆå…¥åŠ›ã®ãƒ¢ãƒŽã‚¹ãƒšãƒ¼ã‚¹ ãƒ•ã‚©ãƒ³ãƒˆã‚’ä½¿ç”¨ã™ã‚‹å ´åˆ',0),(481496,13375,'pt','Se o texto usar fonte monoespaÃ§ada para entrada',0),(481497,13375,'ru','Ð•ÑÐ»Ð¸ Ñ‚ÐµÐºÑÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¼Ð¾Ð½Ð¾ÑˆÐ¸Ñ€Ð¸Ð½Ð½Ñ‹Ð¹ ÑˆÑ€Ð¸Ñ„Ñ‚ Ð´Ð»Ñ Ð²Ð²Ð¾Ð´Ð°',0),(481498,13375,'es','Si es Texto Usa la Fuente Monospace Para Input',0),(481499,13375,'de','Wenn Text Festbreitenschriftart fÃ¼r die Eingabe verwenden',0),(481500,13375,'en','If Text Use Monospace Font For Input',0),(481501,13376,'is','',0),(481502,13376,'dr','Ù†ÙˆØ¹ Ø¨Ø±Ú†Ø³Ø¨',0),(481503,13376,'pr','Ù†ÙˆØ¹ Ø¨Ø±Ú†Ø³Ø¨',0),(481504,13376,'tr','Etiket tÃ¼rÃ¼',0),(481505,13376,'pl','Typ etykiety',0),(481506,13376,'bg','Ð¢Ð¸Ð¿ ÐµÑ‚Ð¸ÐºÐµÑ‚',0),(481507,13376,'ur','Ù„ÛŒØ¨Ù„ Ú©ÛŒ Ù‚Ø³Ù…',0),(481508,13376,'sr','ÐžÐ·Ð½Ð°ÐºÐ° Ñ‚Ð¸Ð¿Ð°',0),(481509,13376,'vi','NhÃ£n loáº¡i',0),(481510,13376,'af','Etiket tipe',0),(481511,13376,'ro','Tip de etichetÄƒ',0),(481512,13376,'et','Sildi tÃ¼Ã¼p',0),(481513,13376,'si','Vrsta oznake',0),(481514,13376,'ba','Label Type',0),(481515,13376,'nl','Etikettype',0),(481516,13376,'fi','Tunnustyyppi',0),(481517,13376,'no','Etikettypen',0),(481518,13376,'da','Etikettypen',0),(481519,13376,'ko','ë ˆì´ë¸” ìœ í˜•',0),(481520,13376,'he','×¡×•×’ ×”×ª×•×•×™×ª',0),(481521,13376,'el','ÎŸ Ï„ÏÏ€Î¿Ï‚ ÎµÏ„Î¹ÎºÎ­Ï„Î±Ï‚',0),(481522,13376,'zh','æ ‡ç­¾ç±»åž‹',0),(481523,13376,'sv','Etikettyp',0),(481524,13376,'it','Tipo di etichetta',0),(481525,13376,'tl','',0),(481526,13376,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­',0),(481527,13376,'hi','à¤²à¥‡à¤¬à¤² à¤ªà¥à¤°à¤•à¤¾à¤°',0),(481528,13376,'ms','Jenis label',0),(481529,13376,'ar','Ù†ÙˆØ¹ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø¹Ù†ÙˆÙ†Ø©',0),(481530,13376,'fr','Type d\'Ã©tiquette',0),(481531,13376,'jp','ãƒ©ãƒ™ãƒ«ã®ç¨®é¡ž',0),(481532,13376,'pt','Tipo de etiqueta',0),(481533,13376,'ru','Ð¢Ð¸Ð¿ Ð¼ÐµÑ‚ÐºÐ¸',0),(481534,13376,'es','Tipo de Etiqueta',0),(481535,13376,'de','Label-Typ',0),(481536,13376,'en','Label Type',0),(481537,13377,'is','',0),(481538,13377,'dr','Ø¨Ø±Ú†Ø³Ø¨ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù…Ø­Ù„ÛŒ',0),(481539,13377,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù…Ø­Ù„ÛŒ',0),(481540,13377,'tr','Yerel SevkÄ±yat etiketi',0),(481541,13377,'pl','Etykiety lokalne wydania',0),(481542,13377,'bg','ÐœÐµÑÑ‚ÐµÐ½ Ð¿Ñ€ÐµÐ²Ð¾Ð· ÐµÑ‚Ð¸ÐºÐµÑ‚',0),(481543,13377,'ur','Ù…Ù‚Ø§Ù…ÛŒ Ú©Ú¾ÛŒÙ¾ Ù„ÛŒØ¨Ù„',0),(481544,13377,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð¾Ð·Ð½Ð°ÐºÐ°',0),(481545,13377,'vi','Äá»‹a phÆ°Æ¡ng lÃ´ hÃ ng nhÃ£n',0),(481546,13377,'af','Plaaslike verskeping etiket',0),(481547,13377,'ro','Eticheta de transport locale',0),(481548,13377,'et','Kohaliku veo silt',0),(481549,13377,'si','Lokalne dobave za okolje',0),(481550,13377,'ba','Pengiriman lokal Label',0),(481551,13377,'nl','Lokale verzending Label',0),(481552,13377,'fi','Paikallinen toimituksen otsikko',0),(481553,13377,'no','Lokal levering etikett',0),(481554,13377,'da','Lokale forsendelse etiket',0),(481555,13377,'ko','í˜„ì§€ ì„ ì  ë ˆì´ë¸”',0),(481556,13377,'he','×ª×•×•×™×ª ×ž×©×œ×•×— ×ž×§×•×ž×™',0),(481557,13377,'el','Î¤Î¿Ï€Î¹ÎºÎ® Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÏ„Î¹ÎºÎ­Ï„Î±',0),(481558,13377,'zh','å½“åœ°å‘è´§æ ‡ç­¾',0),(481559,13377,'sv','Lokala transport Label',0),(481560,13377,'it','Etichetta di spedizione locale',0),(481561,13377,'tl','',0),(481562,13377,'th','à¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ à¸²à¸¢à¹ƒà¸™',0),(481563,13377,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤²à¥‡à¤¬à¤²',0),(481564,13377,'ms','Label penghantaran tempatan',0),(481565,13377,'ar','ØªØ³Ù…ÙŠØ© Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù…Ø­Ù„ÙŠØ©',0),(481566,13377,'fr','Ã‰tiquette de livraison locale',0),(481567,13377,'jp','ãƒ­ãƒ¼ã‚«ãƒ«å‡ºè·ãƒ©ãƒ™ãƒ«',0),(481568,13377,'pt','Etiqueta de remessa local',0),(481569,13377,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·ÐºÐ¸ ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ°',0),(481570,13377,'es','Etiqueta de EnvÃ­o Local',0),(481571,13377,'de','Lokale Sendung Label',0),(481572,13377,'en','Local Shipment Label',0),(481573,13378,'is','',0),(481574,13378,'dr','Ù†Ø§Ù… ÙØ±Ù…',0),(481575,13378,'pr','Ù†Ø§Ù… ÙØ±Ù…',0),(481576,13378,'tr','Form adÄ±',0),(481577,13378,'pl','Nazwa formy',0),(481578,13378,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°',0),(481579,13378,'ur','ÙØ§Ø±Ù… Ú©Û’ Ù†Ø§Ù… Ú©Ø§',0),(481580,13378,'sr','Ð˜Ð¼Ðµ Ð¾Ð±Ñ€Ð°ÑÑ†Ð°',0),(481581,13378,'vi','TÃªn cá»§a biá»ƒu máº«u',0),(481582,13378,'af','Naam van die vorm',0),(481583,13378,'ro','Numele de formular',0),(481584,13378,'et','Vormi nimi',0),(481585,13378,'si','Ime obrazca',0),(481586,13378,'ba','Nama bentuk',0),(481587,13378,'nl','Naam van formulier',0),(481588,13378,'fi','Lomakkeen nimi',0),(481589,13378,'no','Navnet pÃ¥ skjemaet',0),(481590,13378,'da','Navnet pÃ¥ Form',0),(481591,13378,'ko','í¼ì˜ ì´ë¦„',0),(481592,13378,'he','×©×ž×• ×©×œ ×˜×•×¤×¡',0),(481593,13378,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ Ï†ÏŒÏÎ¼Î±Ï‚',0),(481594,13378,'zh','çª—ä½“çš„åç§°',0),(481595,13378,'sv','Namnet pÃ¥ formulÃ¤ret',0),(481596,13378,'it','Nome del modulo',0),(481597,13378,'tl','',0),(481598,13378,'th','à¸Šà¸·à¹ˆà¸­à¸‚à¸­à¸‡à¹à¸šà¸šà¸Ÿà¸­à¸£à¹Œà¸¡',0),(481599,13378,'hi','à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤•à¤¾ à¤¨à¤¾à¤®',0),(481600,13378,'ms','Nama borang',0),(481601,13378,'ar','Ø§Ø³Ù… Ø§Ù„Ù†Ù…ÙˆØ°Ø¬',0),(481602,13378,'fr','Nom du formulaire',0),(481603,13378,'jp','ãƒ•ã‚©ãƒ¼ãƒ ã®åå‰',0),(481604,13378,'pt','Nome do formulÃ¡rio',0),(481605,13378,'ru','Ð˜Ð¼Ñ Ñ„Ð¾Ñ€Ð¼Ñ‹',0),(481606,13378,'es','Nombre de Forma',0),(481607,13378,'de','Namen des Formulars',0),(481608,13378,'en','Name Of Form',0),(481609,13379,'is','',0),(481610,13379,'dr','Ø´Ù…Ø§Ø±Ù‡ Ú¯Ø°Ø§Ø±ÛŒ',0),(481611,13379,'pr','Ø´Ù…Ø§Ø±Ù‡ Ú¯Ø°Ø§Ø±ÛŒ',0),(481612,13379,'tr','NumaralandÄ±rma',0),(481613,13379,'pl','Numeracja',0),(481614,13379,'bg','ÐÐ¾Ð¼ÐµÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(481615,13379,'ur','Ù†Ù…Ø¨Ø± Ú©Ø§Ø±ÛŒ',0),(481616,13379,'sr','ÐÑƒÐ¼ÐµÑ€Ð¸ÑÐ°ÑšÐµ',0),(481617,13379,'vi','ÄÃ¡nh sá»‘',0),(481618,13379,'af','Nommering',0),(481619,13379,'ro','Numerotare',0),(481620,13379,'et','Numeratsioon',0),(481621,13379,'si','Å tevilÄenje',0),(481622,13379,'ba','Penomoran',0),(481623,13379,'nl','Nummering',0),(481624,13379,'fi','Numerointi',0),(481625,13379,'no','Nummerering',0),(481626,13379,'da','Nummerering',0),(481627,13379,'ko','ë²ˆí˜¸ ë§¤ê¸°ê¸°',0),(481628,13379,'he','×ž×¡×¤×•×¨',0),(481629,13379,'el','Î‘ÏÎ¯Î¸Î¼Î·ÏƒÎ·',0),(481630,13379,'zh','ç¼–å·',0),(481631,13379,'sv','Numrering',0),(481632,13379,'it','Numerazione',0),(481633,13379,'tl','',0),(481634,13379,'th','à¸à¸³à¸«à¸™à¸”à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚',0),(481635,13379,'hi','à¤•à¥à¤°à¤®à¤¾à¤‚à¤•à¤¨',0),(481636,13379,'ms','Penomboran',0),(481637,13379,'ar','ØªØ±Ù‚ÙŠÙ…',0),(481638,13379,'fr','NumÃ©rotation',0),(481639,13379,'jp','æ®µè½ç•ªå·',0),(481640,13379,'pt','NumeraÃ§Ã£o',0),(481641,13379,'ru','ÐÑƒÐ¼ÐµÑ€Ð°Ñ†Ð¸Ñ',0),(481642,13379,'es','Numerando',0),(481643,13379,'de','Nummerierung',0),(481644,13379,'en','Numbering',0),(481645,13380,'is','',0),(481646,13380,'dr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÛŒ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(481647,13380,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ù‡Ø§ÛŒ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(481648,13380,'tr','Standart etiket',0),(481649,13380,'pl','O standardowej etykiecie',0),(481650,13380,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ ÐµÑ‚Ð¸ÐºÐµÑ‚',0),(481651,13380,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù„ÛŒØ¨Ù„',0),(481652,13380,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð° Ð¾Ð·Ð½Ð°ÐºÐ°',0),(481653,13380,'vi','NhÃ£n tiÃªu chuáº©n',0),(481654,13380,'af','Standaard etiket',0),(481655,13380,'ro','EtichetÄƒ standard',0),(481656,13380,'et','Standardi',0),(481657,13380,'si','Standardno oznako',0),(481658,13380,'ba','Standar Label',0),(481659,13380,'nl','Standaardetiket',0),(481660,13380,'fi','Vakio-otsikon',0),(481661,13380,'no','Etiketter',0),(481662,13380,'da','Standard etiket',0),(481663,13380,'ko','í‘œì¤€ ë¼ë²¨',0),(481664,13380,'he','×ª×•×•×™×ª ×¡×˜× ×“×¨×˜×™×ª',0),(481665,13380,'el','ÎŸ Ï„Ï…Ï€Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î¿Ï‚',0),(481666,13380,'zh','æ ‡å‡†æ ‡ç­¾',0),(481667,13380,'sv','Standardetikett',0),(481668,13380,'it','Etichetta standard',0),(481669,13380,'tl','',0),(481670,13380,'th','à¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­à¸¡à¸²à¸•à¸£à¸à¸²à¸™',0),(481671,13380,'hi','à¤®à¤¾à¤¨à¤• à¤²à¥‡à¤¬à¤²',0),(481672,13380,'ms','Standard Label',0),(481673,13380,'ar','Ø§Ù„ØªØ³Ù…ÙŠØ© Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(481674,13380,'fr','Label standard',0),(481675,13380,'jp','æ¨™æº–ã®ãƒ©ãƒ™ãƒ«',0),(481676,13380,'pt','RÃ³tulo padrÃ£o',0),(481677,13380,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð°Ñ ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐ°',0),(481678,13380,'es','Etiqueta EstÃ¡ndar',0),(481679,13380,'de','Standard-Label',0),(481680,13380,'en','Standard Label',0),(481681,13381,'is','',0),(481682,13381,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡',0),(481683,13381,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡',0),(481684,13381,'tr','Ä°ndirimdeki Ã¼cretleri',0),(481685,13381,'pl','Specjalne opÅ‚aty',0),(481686,13381,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(481687,13381,'ur','Ø®ØµÙˆØµÛŒ Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(481688,13381,'sr','Ð¡Ð¿ÐµÑ†Ð¸Ñ˜Ð°Ð»Ð¸Ñ‚ÐµÑ‚Ð¸ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(481689,13381,'vi','Chi phÃ­ sáº£n pháº©m Ä‘áº·c biá»‡t',0),(481690,13381,'af','Specials kostes',0),(481691,13381,'ro','Taxe speciale',0),(481692,13381,'et','Eripakkumised tasud',0),(481693,13381,'si','StroÅ¡ki v akciji',0),(481694,13381,'ba','Biaya Spesial',0),(481695,13381,'nl','Specials kosten',0),(481696,13381,'fi','Tarjoukset maksut',0),(481697,13381,'no','Spesialtilbud kostnader',0),(481698,13381,'da','Specials afgifter',0),(481699,13381,'ko','ìŠ¤íŽ˜ì…œ ìš”ê¸ˆ',0),(481700,13381,'he','×”×—×™×•×‘×™× ×ž×‘×¦×¢×™×',0),(481701,13381,'el','Î‘Ï†Î¹ÎµÏÏŽÎ¼Î±Ï„Î± Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(481702,13381,'zh','ç‰¹ä»·æ”¶è´¹',0),(481703,13381,'sv','Specialerbjudanden avgifter',0),(481704,13381,'it','Oneri speciali',0),(481705,13381,'tl','',0),(481706,13381,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸žà¸´à¹€à¸¨à¸©',0),(481707,13381,'hi','à¤¸à¥à¤ªà¥‡à¤¶à¤² à¤ªà¥à¤°à¤­à¤¾à¤°',0),(481708,13381,'ms','Caj-caj istimewa',0),(481709,13381,'ar','Ø±Ø³ÙˆÙ… Ø¹Ø±ÙˆØ¶ Ø®Ø§ØµØ©',0),(481710,13381,'fr','Frais spÃ©ciaux',0),(481711,13381,'jp','ã‚¹ãƒšã‚·ãƒ£ãƒ«æ–™é‡‘',0),(481712,13381,'pt','Cargas especiais',0),(481713,13381,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(481714,13381,'es','Cargos Especiales',0),(481715,13381,'de','Specials-GebÃ¼hren',0),(481716,13381,'en','Specials Charges',0),(481717,13382,'is','',0),(481718,13382,'dr','ØªÙ…Ø§Ù… Ø¨Ø±Ú†Ø³Ø¨ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾',0),(481719,13382,'pr','ØªÙ…Ø§Ù… Ø¨Ø±Ú†Ø³Ø¨ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾',0),(481720,13382,'tr','TÃ¼m etiketleri yazdÄ±rmak iÃ§in sipariÅŸ',0),(481721,13382,'pl','Drukuj wszystkie etykiety na zamÃ³wienie',0),(481722,13382,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(481723,13382,'ur','ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„ÛŒÛ’ ØªÙ…Ø§Ù… Ù„ÛŒØ¨Ù„ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(481724,13382,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑÐ²Ð¸Ñ… Ð¾Ð·Ð½Ð°ÐºÐ° Ð·Ð° Ñ€ÐµÐ´',0),(481725,13382,'vi','Táº¥t cáº£ nhÃ£n in cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(481726,13382,'af','Druk alle etikette vir volgorde',0),(481727,13382,'ro','ImprimaÅ£i toate etichetele pentru comanda',0),(481728,13382,'et','Prindi kÃµik sildid, et',0),(481729,13382,'si','Natisni vse oznake za nalog',0),(481730,13382,'ba','Mencetak semua label untuk Order',0),(481731,13382,'nl','Alle etiketten afdrukken voor Order',0),(481732,13382,'fi','Tulostaa kaikki otsikot tilauksen',0),(481733,13382,'no','Skrive ut alle etikettene For ordre',0),(481734,13382,'da','Udskrive alle etiketter For ordre',0),(481735,13382,'ko','ì£¼ë¬¸ì— ëŒ€ í•œ ëª¨ë“  ë ˆì´ë¸”ì„ ì¸ì‡„í•©ë‹ˆë‹¤',0),(481736,13382,'he','×œ×”×“×¤×™×¡ ××ª ×›×œ ×”×ª×•×•×™×•×ª ×¢×‘×•×¨ ×”×–×ž× ×”',0),(481737,13382,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ ÎµÏ„Î¹ÎºÎµÏ„ÏŽÎ½ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(481738,13382,'zh','ä¸ºè®¢å•æ‰“å°æ‰€æœ‰æ ‡ç­¾',0),(481739,13382,'sv','Skriva ut alla etiketter fÃ¶r bestÃ¤llning',0),(481740,13382,'it','Stampare tutte le etichette per ordine',0),(481741,13382,'tl','',0),(481742,13382,'th','à¸žà¸´à¸¡à¸žà¹Œà¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(481743,13382,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤²à¥‡à¤¬à¤²à¥à¤¸ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(481744,13382,'ms','Mencetak semua label untuk pesanan',0),(481745,13382,'ar','Ø·Ø¨Ø§Ø¹Ø© ÙƒØ§ÙØ© Ø§Ù„ØªØ³Ù…ÙŠØ§Øª Ù„Ù„Ù†Ø¸Ø§Ù…',0),(481746,13382,'fr','Imprimer toutes les Ã©tiquettes pour commander',0),(481747,13382,'jp','æ³¨æ–‡ã®ã™ã¹ã¦ã®ãƒ©ãƒ™ãƒ«ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(481748,13382,'pt','Imprimir todos os rÃ³tulos para a ordem',0),(481749,13382,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð²ÑÐµÑ… Ð½Ð°ÐºÐ»ÐµÐµÐº Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(481750,13382,'es','Imprimir Todas Las Etiquetas Para el Pedido',0),(481751,13382,'de','Drucken Sie alle Etiketten fÃ¼r Bestellung',0),(481752,13382,'en','Print All Labels For Order',0),(481753,13383,'is','',0),(481754,13383,'dr','Ú©Ø¯ Ø§Ø±Ø²',0),(481755,13383,'pr','Ú©Ø¯ Ø§Ø±Ø²',0),(481756,13383,'tr','Para birimi kodu',0),(481757,13383,'pl','Kod waluty',0),(481758,13383,'bg','ÐšÐ¾Ð´ Ð²Ð°Ð»ÑƒÑ‚Ð°',0),(481759,13383,'ur','Ú©Ø±Ù†Ø³ÛŒ Ú©ÙˆÚˆ',0),(481760,13383,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(481761,13383,'vi','MÃ£ tiá»n tá»‡',0),(481762,13383,'af','Geldeenheid Kode',0),(481763,13383,'ro','Cod valutÄƒ',0),(481764,13383,'et','Valuuta tÃ¤his',0),(481765,13383,'si','Å ifra valute',0),(481766,13383,'ba','Kode mata uang',0),(481767,13383,'nl','Valutacode',0),(481768,13383,'fi','Valuuttakoodi',0),(481769,13383,'no','Valutakode',0),(481770,13383,'da','Valutakode',0),(481771,13383,'ko','í†µí™” ì½”ë“œ',0),(481772,13383,'he','×§×•×“ ×ž×˜×‘×¢',0),(481773,13383,'el','ÎšÏ‰Î´Î¹ÎºÏŒ Î½Î¿Î¼Î¯ÏƒÎ¼Î±Ï„Î¿Ï‚',0),(481774,13383,'zh','å¸ç§ä»£ç ',0),(481775,13383,'sv','Valutakod',0),(481776,13383,'it','Codice valuta',0),(481777,13383,'tl','',0),(481778,13383,'th','à¸£à¸«à¸±à¸ªà¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™',0),(481779,13383,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤•à¥‹à¤¡',0),(481780,13383,'ms','Kod Mata Wang',0),(481781,13383,'ar','Ø±Ù…Ø² Ø§Ù„Ø¹Ù…Ù„Ø©',0),(481782,13383,'fr','Code de devise',0),(481783,13383,'jp','é€šè²¨ã‚³ãƒ¼ãƒ‰',0),(481784,13383,'pt','CÃ³digo de moeda',0),(481785,13383,'ru','ÐšÐ¾Ð´ Ð²Ð°Ð»ÑŽÑ‚Ñ‹',0),(481786,13383,'es','CÃ“digo de Moneda',0),(481787,13383,'de','WÃ¤hrungscode',0),(481788,13383,'en','Currency Code',0),(481789,13384,'is','',0),(481790,13384,'dr','Ù…ÙˆØ±Ø¯ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ú©Ø§Ù† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ Ø§Ø³Øª Ø­ØªÙ…Ø§.',0),(481791,13384,'pr','Ù…ÙˆØ±Ø¯ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ú©Ø§Ù† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ Ø§Ø³Øª Ø­ØªÙ…Ø§.',0),(481792,13384,'tr','Madde Bu konum iÃ§in ayarlandÄ±ÄŸÄ±ndan emin olun.',0),(481793,13384,'pl','Upewnij siÄ™, Å¼e element jest ustawiony dla tej lokalizacji.',0),(481794,13384,'bg','Ð¡Ðµ ÑƒÐ²ÐµÑ€ÐµÑ‚Ðµ, Ñ‡Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ðµ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½ Ð·Ð° Ñ‚Ð¾Ð²Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ.',0),(481795,13384,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø´Û’ Ø§Ø³ Ú©Û’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ø§Ù¾ ÛÙˆ Û”',0),(481796,13384,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¾ ÑÐµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ñ˜Ðµ Ð¿Ð¾Ð´ÐµÑˆÐµÐ½ Ð·Ð° Ð¾Ð²Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ.',0),(481797,13384,'vi','Äáº£m báº£o ráº±ng má»¥c Ä‘Æ°á»£c thiáº¿t láº­p cho vá»‹ trÃ­ nÃ y.',0),(481798,13384,'af','Wees seker item opgestel is vir hierdie posisie.',0),(481799,13384,'ro','AsiguraÅ£i-vÄƒ cÄƒ elementul este configurat pentru aceastÄƒ locaÈ›ie.',0),(481800,13384,'et','Kindlasti, kaup on seadistatud selle asukoha jaoks.',0),(481801,13384,'si','Pazite, da artikel nastavljen za to mesto.',0),(481802,13384,'ba','Pastikan item diatur untuk lokasi ini.',0),(481803,13384,'nl','Zorg ervoor dat artikel is ingesteld voor deze locatie.',0),(481804,13384,'fi','Varmista, ettÃ¤ nimike on mÃ¤Ã¤ritetty tÃ¤lle sijainnille.',0),(481805,13384,'no','Pass pÃ¥ at varen er satt opp for denne plasseringen.',0),(481806,13384,'da','SÃ¸rg for varen er sat op til denne placering.',0),(481807,13384,'ko','ì´ ìœ„ì¹˜ì— ëŒ€ í•œ í•­ëª©ì´ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(481808,13384,'he','×•×“× ×¤×¨×™×˜ ×ž×•×’×“×¨ ×¢×‘×•×¨ ×ž×™×§×•× ×–×”.',0),(481809,13384,'el','ÎÎ± ÎµÎ¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î­Ï‡ÎµÎ¹ ÏÏ…Î¸Î¼Î¹ÏƒÏ„ÎµÎ¯ Î³Î¹Î± Î±Ï…Ï„Î®Î½ Ï„Î· Î¸Î­ÏƒÎ·.',0),(481810,13384,'zh','å› æ­¤ï¼Œè¯·åŠ¡å¿…ä¸ºæ­¤ä½ç½®è®¾ç½®é¡¹ç›®ã€‚',0),(481811,13384,'sv','Var noga med artikeln har stÃ¤llts in fÃ¶r den hÃ¤r platsen.',0),(481812,13384,'it','Assicuratevi di elemento Ã¨ configurato per questa posizione.',0),(481813,13384,'tl','',0),(481814,13384,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹ƒà¸«à¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸§à¹ˆà¸² à¸¡à¸µà¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¸³à¸«à¸£à¸±à¸šà¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡à¸™à¸µà¹‰',0),(481815,13384,'hi','à¤†à¤‡à¤Ÿà¤® à¤‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‡à¤Ÿ à¤¹à¥ˆ à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤¹à¥‹à¥¤',0),(481816,13384,'ms','Pastikan item disetkan untuk lokasi ini.',0),(481817,13384,'ar','ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù† Ø§Ù„Ø¹Ù†ØµØ± Ù‡Ùˆ Ø¥Ø¹Ø¯Ø§Ø¯ Ù„Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹.',0),(481818,13384,'fr','Assurez-vous que le point est mis en place pour cet endroit.',0),(481819,13384,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã¯ã“ã®å ´æ‰€ã«è¨­å®šã•ã‚Œã¦ã„ã‚‹ã“ã¨ã‚’å¿…ãšã—ã¦ãã ã•ã„ã€‚',0),(481820,13384,'pt','Certifique-se de que item estÃ¡ definido para este local.',0),(481821,13384,'ru','Ð£Ð±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐ½ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ.',0),(481822,13384,'es','Asegura que el item esta configurado para este local',0),(481823,13384,'de','Achten Sie darauf, dass Element fÃ¼r diesen Standort eingerichtet ist.',0),(481824,13384,'en','Be sure item is set up for this location.',0),(481825,13385,'is','',0),(481826,13385,'dr','Ù‡Ù…Ø§Ù† Ø¢ÛŒØªÙ… Ø¨Ù‡ Ù‡Ù…Ø§Ù† Ù…Ø­Ù„ Ø§Ù†ØªÙ‚Ø§Ù„ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯.',0),(481827,13385,'pr','Ù‡Ù…Ø§Ù† Ø¢ÛŒØªÙ… Ø¨Ù‡ Ù‡Ù…Ø§Ù† Ù…Ø­Ù„ Ø§Ù†ØªÙ‚Ø§Ù„ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯.',0),(481828,13385,'tr','AynÄ± maddeyle aynÄ± yere aktaramazsÄ±nÄ±z.',0),(481829,13385,'pl','Nie moÅ¼na przenieÅ›Ä‡ elementu sam do tej samej lokalizacji.',0),(481830,13385,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»Ñ ÐµÐ´Ð¸Ð½ Ð¸ ÑÑŠÑ‰ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ð° ÑÑŠÑ‰Ð¾Ñ‚Ð¾ Ð¼ÑÑÑ‚Ð¾.',0),(481831,13385,'ur','Ø§ÛŒÚ© ÛÛŒ Ø´Û’ Ø§Ø³ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø± Ù…Ù†ØªÙ‚Ù„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§ Û”',0),(481832,13385,'sr','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€ÐµÐ½ÐµÑÐµ Ð¸ÑÑ‚Ð¾Ð³ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð½Ð° Ð¸ÑÑ‚Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ.',0),(481833,13385,'vi','KhÃ´ng thá»ƒ chuyá»ƒn cÃ¹ng má»™t máº·t hÃ ng vÃ o cÃ¹ng má»™t vá»‹ trÃ­.',0),(481834,13385,'af','Kan dra dieselfde item na dieselfde plek.',0),(481835,13385,'ro','Nu poate transfera acelaÅŸi articol la aceeaÅŸi locaÅ£ie.',0),(481836,13385,'et','Sama Ã¼ksust ei saa Ã¼le kanda samas kohas.',0),(481837,13385,'si','Isti artikel ne morete prenesti na isto mesto.',0),(481838,13385,'ba','Tidak dapat mentransfer item sama ke lokasi yang sama.',0),(481839,13385,'nl','Niet overbrengen hetzelfde item naar dezelfde locatie.',0),(481840,13385,'fi','Samaa kohdetta ei voi siirtÃ¤Ã¤ samaan paikkaan.',0),(481841,13385,'no','Kan ikke overfÃ¸re samme varen til samme sted.',0),(481842,13385,'da','Kan ikke overfÃ¸re samme vare til samme placering.',0),(481843,13385,'ko','ë™ì¼í•œ ìœ„ì¹˜ì— ë™ì¼í•œ í•­ëª©ì„ ì „ì†¡í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(481844,13385,'he','××™ ××¤×©×¨ ×œ×”×¢×‘×™×¨ ××•×ª×• ×¤×¨×™×˜ ×‘××•×ª×• ×ž×™×§×•×.',0),(481845,13385,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î¼ÎµÏ„Î±Ï†Î­ÏÎµÎ¹ Ï„Î¿ Î¯Î´Î¹Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¯Î´Î¹Î± Î¸Î­ÏƒÎ·.',0),(481846,13385,'zh','ä¸èƒ½å°†åŒä¸€é¡¹ç›®è½¬ç§»åˆ°åŒä¸€ä½ç½®ã€‚',0),(481847,13385,'sv','Kan inte Ã¶verfÃ¶ra samma objekt till samma plats.',0),(481848,13385,'it','Non Ã¨ possibile trasferire l\'elemento stesso stesso percorso.',0),(481849,13385,'tl','',0),(481850,13385,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸£à¸²à¸¢à¸à¸²à¸£à¹„à¸›à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¹€à¸”à¸µà¸¢à¸§à¸à¸±à¸™',0),(481851,13385,'hi','à¤à¤• à¤¹à¥€ à¤†à¤‡à¤Ÿà¤® à¤à¤• à¤¹à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤° à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾à¥¤',0),(481852,13385,'ms','Tidak boleh memindahkan harta yang sama ke lokasi sama.',0),(481853,13385,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ù†Ù‚Ù„ Ø§Ù„Ø¹Ù†ØµØ± Ù†ÙØ³Ù‡ Ø¥Ù„Ù‰ Ù†ÙØ³ Ø§Ù„Ù…ÙˆÙ‚Ø¹.',0),(481854,13385,'fr','Impossible de transfÃ©rer mÃªme point au mÃªme endroit.',0),(481855,13385,'jp','åŒã˜å ´æ‰€ã«åŒã˜é …ç›®ã‚’è»¢é€ã§ãã¾ã›ã‚“ã€‚',0),(481856,13385,'pt','NÃ£o Ã© possÃ­vel transferir o mesmo item para o mesmo local.',0),(481857,13385,'ru','ÐÐµÐ²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‚ÑŒ Ð¶Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ð° Ñ‚Ð¾Ð¼ Ð¶Ðµ Ð¼ÐµÑÑ‚Ðµ.',0),(481858,13385,'es','No se puede transferir el mismo Item al mismo local',0),(481859,13385,'de','Dasselbe Element kann nicht an derselben Stelle Ã¼bertragen werden.',0),(481860,13385,'en','Cannot transfer same item to same location.',0),(481861,13386,'is','',0),(481862,13386,'dr','Ø§Ø² Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(481863,13386,'pr','Ø§Ø² Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(481864,13386,'tr','Stok konumundan',0),(481865,13386,'pl','Od lokalizacji zapasÃ³w',0),(481866,13386,'bg','ÐžÑ‚ Ð¼ÑÑÑ‚Ð¾ Ð·Ð° ÑÐºÐ»Ð°Ð´',0),(481867,13386,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø³Û’',0),(481868,13386,'sr','ÐžÐ´ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(481869,13386,'vi','Tá»« vá»‹ trÃ­ hÃ ng tá»“n kho',0),(481870,13386,'af','Uit voorraad ligging',0),(481871,13386,'ro','De inventar locaÅ£ie',0),(481872,13386,'et','Lao asukoha',0),(481873,13386,'si','Iz lokacijo zaloge',0),(481874,13386,'ba','Dari lokasi persediaan',0),(481875,13386,'nl','Van vestiging',0),(481876,13386,'fi','Varaston sijainnista',0),(481877,13386,'no','Fra lagerlokasjon',0),(481878,13386,'da','Fra lagerlokation',0),(481879,13386,'ko','ìž¬ê³  ìœ„ì¹˜ì—ì„œ',0),(481880,13386,'he','×ž×ž×™×§×•× ×ž×œ××™',0),(481881,13386,'el','Î‘Ï€ÏŒ Î±Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(481882,13386,'zh','ä»Žåº“å­˜ä½ç½®',0),(481883,13386,'sv','FrÃ¥n lagerstÃ¤lle',0),(481884,13386,'it','Dall\'ubicazione di inventario',0),(481885,13386,'tl','',0),(481886,13386,'th','à¸ˆà¸²à¸à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(481887,13386,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¥‡',0),(481888,13386,'ms','Dari lokasi inventori',0),(481889,13386,'ar','Ù…Ù† Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(481890,13386,'fr','De l\'emplacement de l\'inventaire',0),(481891,13386,'jp','åœ¨åº«å ´æ‰€ã‹ã‚‰',0),(481892,13386,'pt','LocalizaÃ§Ã£o de inventÃ¡rio',0),(481893,13386,'ru','ÐžÑ‚ ÑÐºÐ»Ð°Ð´Ðµ',0),(481894,13386,'es','De ColocaciÃ³n de Inventario',0),(481895,13386,'de','Von Lagerort',0),(481896,13386,'en','From Inventory Location',0),(481897,13387,'is','',0),(481898,13387,'dr','Ù‡ÛŒÚ† Ù…Ú©Ø§Ù†ÛŒ ÛŒØ§ÙØª',0),(481899,13387,'pr','Ù‡ÛŒÚ† Ù…Ú©Ø§Ù†ÛŒ ÛŒØ§ÙØª',0),(481900,13387,'tr','Bulunan konum',0),(481901,13387,'pl','Nie wyszukanych',0),(481902,13387,'bg','ÐÑÐ¼Ð° Ð¼ÐµÑÑ‚Ð°, Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸',0),(481903,13387,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(481904,13387,'sr','ÐÐ¸Ñ˜ÐµÐ´Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(481905,13387,'vi','KhÃ´ng cÃ³ Ä‘á»‹a Ä‘iá»ƒm tÃ¬m tháº¥y',0),(481906,13387,'af','Geen plekke gevind',0),(481907,13387,'ro','Nici locatii gÄƒsit',0),(481908,13387,'et','Ãœhtki asukohta leida',0),(481909,13387,'si','Nobena lokacija, najti',0),(481910,13387,'ba','Lokasi tidak ditemukan',0),(481911,13387,'nl','Geen locaties gevonden',0),(481912,13387,'fi','Paikkakuntia ei lÃ¶ytynyt.',0),(481913,13387,'no','Ingen steder finner',0),(481914,13387,'da','Ingen steder fundet',0),(481915,13387,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” ìœ„ì¹˜',0),(481916,13387,'he','××™×Ÿ ×ž×§×•×ž×•×ª × ×ž×¦××•',0),(481917,13387,'el','Î”ÎµÎ½ Î¸Î­ÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(481918,13387,'zh','å‘çŽ°æ²¡æœ‰ä½ç½®',0),(481919,13387,'sv','Inga platser hittade',0),(481920,13387,'it','Nessuna localitÃ  trovato',0),(481921,13387,'tl','',0),(481922,13387,'th','à¸ªà¸–à¸²à¸™à¹„à¸¡à¹ˆà¸žà¸š',0),(481923,13387,'hi','à¤•à¥‹à¤ˆ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤¾à¤¯à¤¾',0),(481924,13387,'ms','Tiada lokasi yang ditemui',0),(481925,13387,'ar','Ù…ÙˆØ§Ù‚Ø¹ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(481926,13387,'fr','Aucun emplacement trouvÃ©',0),(481927,13387,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(481928,13387,'pt','NÃ£o hÃ¡ locais encontrados',0),(481929,13387,'ru','ÐœÐµÑÑ‚Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(481930,13387,'es','No Se Encuentra Colocaciones',0),(481931,13387,'de','Keine Orte gefunden',0),(481932,13387,'en','No Locations Found',0),(481933,13388,'is','',0),(481934,13388,'dr','ØªØ¹Ø¯Ø§Ø¯ ÙˆØ§Ø­Ø¯ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(481935,13388,'pr','ØªØ¹Ø¯Ø§Ø¯ ÙˆØ§Ø­Ø¯ Ø¯Ø± Ù‡Ø± ÙˆØ§Ø­Ø¯',0),(481936,13388,'tr','SayÄ±sÄ± baÅŸÄ±na birim iÃ§in birim',0),(481937,13388,'pl','Liczba jednostek na jednostki',0),(481938,13388,'bg','Ð‘Ñ€Ð¾Ð¹ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸ Ð½Ð° Ð¾Ñ‚ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(481939,13388,'ur','Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ ÛŒÙˆÙ†Ù¹Ø³ ÙÛŒ ÛŒÙˆÙ†Ù¹ Ø³Û’',0),(481940,13388,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð´Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð¿Ð¾ Ð¸Ð· Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(481941,13388,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n vá»‹ má»™t tá»« Ä‘Æ¡n vá»‹',0),(481942,13388,'af','Aantal na eenhede Per eenheid van',0),(481943,13388,'ro','NumÄƒrul de unitÄƒÈ›i pe din unitate',0),(481944,13388,'et','Arv, et Ã¼hikud Ã¼ksusest',0),(481945,13388,'si','Å tevilo za enot na iz enote',0),(481946,13388,'ba','Jumlah unit Per Unit',0),(481947,13388,'nl','Aantal eenheden Per van eenheid',0),(481948,13388,'fi','MÃ¤Ã¤rÃ¤ yksikkÃ¶Ã¤ yksikkÃ¶',0),(481949,13388,'no','Antall enheter Per fra-enhet',0),(481950,13388,'da','Antal enheder pr. fra enhed',0),(481951,13388,'ko','ë‹¨ìœ„ ë‹¹ ë‹¨ìœ„ ìˆ˜',0),(481952,13388,'he','×ž×¡×¤×¨ ×™×—×™×“×•×ª ×œ×›×œ ×™×—×™×“×”',0),(481953,13388,'el','Î Î»Î·Î¸ÏŽÏÎ± Î±Ï€ÏŒ Î¼Î¿Î½Î¬Î´Î± ÏƒÎµ Î¼Î¿Î½Î¬Î´ÎµÏ‚ Î±Î½Î¬',0),(481954,13388,'zh','åˆ°æ¯ä¸ªå•ä½çš„å•ä½æ•°ç›®çš„',0),(481955,13388,'sv','Antal enheter Per frÃ¥n enheten',0),(481956,13388,'it','Numero di a unitÃ  Per unitÃ ',0),(481957,13388,'tl','',0),(481958,13388,'th','à¸ˆà¸³à¸™à¸§à¸™à¸‚à¸­à¸‡à¸«à¸™à¹ˆà¸§à¸¢à¸•à¹ˆà¸­à¸ˆà¸²à¸à¸«à¸™à¹ˆà¸§à¸¢',0),(481959,13388,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¸à¥‡ à¤ªà¥à¤°à¤¤à¤¿ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(481960,13388,'ms','Bilangan unit setiap unit',0),(481961,13388,'ar','Ø¹Ø¯Ø¯ ÙˆØ­Ø¯Ø§Øª ÙƒÙ„ Ù…Ù† ÙˆØ­Ø¯Ø©',0),(481962,13388,'fr','Nombre d\'unitÃ©s par unitÃ©',0),(481963,13388,'jp','å˜ä½ã‹ã‚‰å˜ä½ã«æ•°',0),(481964,13388,'pt','NÃºmero de unidades por unidade de',0),(481965,13388,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐµÐ´Ð¸Ð½Ð¸Ñ† Ð² Ð¾Ñ‚ Ð±Ð»Ð¾ÐºÐ°',0),(481966,13388,'es','NÃºmero de Unidades A Por Unidades De',0),(481967,13388,'de','Anzahl der Einheiten pro Unit',0),(481968,13388,'en','Number Of To Units Per From Unit',0),(481969,13389,'is','',0),(481970,13389,'dr','Ø¨Ù‡ Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(481971,13389,'pr','Ø¨Ù‡ Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(481972,13389,'tr','Konumu sayÄ±m yapmak',0),(481973,13389,'pl','Do inwentaryzacji lokalizacji',0),(481974,13389,'bg','Ð—Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(481975,13389,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©ÛŒ Ø³ÛÙˆÙ„ÛŒØ§Øª Ú©Û’ Ù„Ø¦Û’',0),(481976,13389,'sr','Ð£ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(481977,13389,'vi','Äá»ƒ hÃ ng tá»“n kho vá»‹ trÃ­',0),(481978,13389,'af','Om voorraad ligging',0),(481979,13389,'ro','Pentru a locaÅ£ia de inventar',0),(481980,13389,'et','Varude asukoha',0),(481981,13389,'si','Zaloge mesto',0),(481982,13389,'ba','Untuk persediaan lokasi',0),(481983,13389,'nl','Inventariseren van locatie',0),(481984,13389,'fi','Varaston sijainti',0),(481985,13389,'no','Lageret plassering',0),(481986,13389,'da','Lageret placering',0),(481987,13389,'ko','ì¸ë²¤í† ë¦¬ ìœ„ì¹˜',0),(481988,13389,'he','×œ×¢×¨×•×š ×¨×©×™×ž×ª ×ž×œ××™ ×©×œ ×ž×™×§×•×',0),(481989,13389,'el','ÎÎ± Î±Ï€Î¿Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(481990,13389,'zh','åº“å­˜ä½ç½®',0),(481991,13389,'sv','Till lagret lÃ¤ge',0),(481992,13389,'it','Per l\'ubicazione di inventario',0),(481993,13389,'tl','',0),(481994,13389,'th','à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(481995,13389,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¥‚à¤šà¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(481996,13389,'ms','Kepada inventori lokasi',0),(481997,13389,'ar','Ø¥Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ Ù„Ù„Ù…Ø®Ø²ÙˆÙ†',0),(481998,13389,'fr','Ã€ l\'emplacement des stocks',0),(481999,13389,'jp','å ´æ‰€ã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã‚’ä½œæˆã™ã‚‹ã«ã¯',0),(482000,13389,'pt','A localizaÃ§Ã£o do inventÃ¡rio',0),(482001,13389,'ru','Ð”Ð»Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(482002,13389,'es','Al ColocaciÃ³n de Inventario',0),(482003,13389,'de','Lage zu inventarisieren',0),(482004,13389,'en','To Inventory Location',0),(482005,13390,'is','',0),(482006,13390,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø§Ù†ØªÙ‚Ø§Ù„',0),(482007,13390,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø§Ù†ØªÙ‚Ø§Ù„',0),(482008,13390,'tr','AktarÄ±m ayarlarÄ±',0),(482009,13390,'pl','Przeniesienie instalacji',0),(482010,13390,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð½Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½ÐµÑ‚Ð¾',0),(482011,13390,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(482012,13390,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(482013,13390,'vi','Chuyá»ƒn giao thiáº¿t láº­p',0),(482014,13390,'af','Oordrag opstelling',0),(482015,13390,'ro','Transferul Setup',0),(482016,13390,'et','Ãœlekande seadistamine',0),(482017,13390,'si','Prenos nastavitev',0),(482018,13390,'ba','Mentransfer Setup',0),(482019,13390,'nl','Overdracht Setup',0),(482020,13390,'fi','SiirtÃ¤Ã¤ mÃ¤Ã¤ritykset',0),(482021,13390,'no','OverfÃ¸re oppsett',0),(482022,13390,'da','Transfer Setup',0),(482023,13390,'ko','ì „ì†¡ ì„¤ì •',0),(482024,13390,'he','×”×’×“×¨×ª ×”×¢×‘×¨×”',0),(482025,13390,'el','ÎœÎµÏ„Î±Ï†Î­ÏÎµÎ¹ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚',0),(482026,13390,'zh','ä¼ è¾“è®¾ç½®',0),(482027,13390,'sv','Ã–verfÃ¶r Setup',0),(482028,13390,'it','Installazione di trasferimento',0),(482029,13390,'tl','',0),(482030,13390,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(482031,13390,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(482032,13390,'ms','Persediaan pemindahan',0),(482033,13390,'ar','Ù†Ù‚Ù„ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(482034,13390,'fr','TransfÃ©rer le programme d\'installation',0),(482035,13390,'jp','è»¢é€ã®è¨­å®š',0),(482036,13390,'pt','InstalaÃ§Ã£o de transferÃªncia',0),(482037,13390,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(482038,13390,'es','ConfiguraciÃ³n de Transferencias',0),(482039,13390,'de','Transfer-Setup',0),(482040,13390,'en','Transfer Setup',0),(482041,13391,'is','',0),(482042,13391,'dr','ØªØ¨Ø¯ÛŒÙ„ ÙˆØ§Ø­Ø¯',0),(482043,13391,'pr','ØªØ¨Ø¯ÛŒÙ„ ÙˆØ§Ø­Ø¯',0),(482044,13391,'tr','Birim dÃ¶nÃ¼ÅŸtÃ¼rme',0),(482045,13391,'pl','Jednostki konwersji',0),(482046,13391,'bg','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð½Ð° Ð¼ÐµÑ€Ð½Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(482047,13391,'ur','ÛŒÙˆÙ†Ù¹ ØªØ¨Ø§Ø¯Ù„ÙˆÚº Ø³Û’',0),(482048,13391,'sr','ÐšÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(482049,13391,'vi','ÄÆ¡n vá»‹ chuyá»ƒn Ä‘á»•i',0),(482050,13391,'af','Eenheid Omskakeling',0),(482051,13391,'ro','Unitatea de conversie',0),(482052,13391,'et','Ãœhikuteisenduse',0),(482053,13391,'si','Enota preusmeritve',0),(482054,13391,'ba','Konversi unit',0),(482055,13391,'nl','Unit Conversion',0),(482056,13391,'fi','YksikÃ¶n muuntaminen',0),(482057,13391,'no','Enhetsomregning',0),(482058,13391,'da','Unit Conversion',0),(482059,13391,'ko','ë‹¨ìœ„ ë³€í™˜',0),(482060,13391,'he','×™×—×™×“×ª ×”×ž×¨×”',0),(482061,13391,'el','ÎœÎµÏ„Î±Ï„ÏÎ¿Ï€Î® Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(482062,13391,'zh','å•ä½æ¢ç®—',0),(482063,13391,'sv','Enhetskonvertering',0),(482064,13391,'it','Conversione di unitÃ ',0),(482065,13391,'tl','',0),(482066,13391,'th','à¸à¸²à¸£à¹à¸›à¸¥à¸‡à¸«à¸™à¹ˆà¸§à¸¢',0),(482067,13391,'hi','à¤‡à¤•à¤¾à¤ˆ à¤°à¥‚à¤ªà¤¾à¤‚à¤¤à¤°à¤£',0),(482068,13391,'ms','Penukaran unit',0),(482069,13391,'ar','ØªØ­ÙˆÙŠÙ„ Ø§Ù„ÙˆØ­Ø¯Ø©',0),(482070,13391,'fr','Conversion d\'unitÃ©s',0),(482071,13391,'jp','å˜ä½ã®å¤‰æ›',0),(482072,13391,'pt','ConversÃ£o de unidade',0),(482073,13391,'ru','ÐŸÐµÑ€ÐµÑÑ‡ÐµÑ‚ ÐµÐ´Ð¸Ð½Ð¸Ñ†',0),(482074,13391,'es','ConversiÃ³n de Unidad',0),(482075,13391,'de','Einheitenumrechnung',0),(482076,13391,'en','Unit Conversion',0),(482077,13392,'is','',0),(482078,13392,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú¯Ø²Ø§Ø±Ø´ Ø§Ù†ØªÙ‚Ø§Ù„',0),(482079,13392,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú¯Ø²Ø§Ø±Ø´ Ø§Ù†ØªÙ‚Ø§Ù„',0),(482080,13392,'tr','Transfer raporu gÃ¶rÃ¼ntÃ¼le',0),(482081,13392,'pl','Widok przekazania raportu',0),(482082,13392,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚ Ð·Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½ÐµÑ‚Ð¾',0),(482083,13392,'ur','Ù…Ù†Ø¸Ø± Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(482084,13392,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð·Ð²Ñ˜ÐµÑˆÑ‚Ð°Ñ˜ Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(482085,13392,'vi','Xem chuyá»ƒn bÃ¡o cÃ¡o',0),(482086,13392,'af','Bekyk oordrag verslag',0),(482087,13392,'ro','Vizualizare raport de Transfer',0),(482088,13392,'et','Kuva Ã¼leandmise aruanne',0),(482089,13392,'si','Ogled prenosu poroÄila',0),(482090,13392,'ba','Lihat Transfer laporan',0),(482091,13392,'nl','Overdracht rapport weergeven',0),(482092,13392,'fi','NÃ¤ytÃ¤ siirto raportti',0),(482093,13392,'no','Vis overfÃ¸ring rapport',0),(482094,13392,'da','Vis overfÃ¸rslen rapport',0),(482095,13392,'ko','ì´ì „ ë³´ê³ ì„œ ë³´ê¸°',0),(482096,13392,'he','×”×¦×’ ×“×•×— ×”×”×¢×‘×¨×”',0),(482097,13392,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚',0),(482098,13392,'zh','æŸ¥çœ‹è¿ç§»æŠ¥å‘Š',0),(482099,13392,'sv','Visa Ã¶verfÃ¶ring rapport',0),(482100,13392,'it','Visualizza Report di trasferimento',0),(482101,13392,'tl','',0),(482102,13392,'th','à¸”à¸¹à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(482103,13392,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¦à¥‡à¤–à¥‡à¤‚',0),(482104,13392,'ms','Lihat laporan pemindahan',0),(482105,13392,'ar','Ø¹Ø±Ø¶ Ù†Ù‚Ù„ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(482106,13392,'fr','Afficher le rapport transfert',0),(482107,13392,'jp','ä¼é”ãƒ¬ãƒãƒ¼ãƒˆã®è¡¨ç¤º',0),(482108,13392,'pt','Exibir relatÃ³rio de transferÃªncia',0),(482109,13392,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(482110,13392,'es','Visualizar El Informe de Transferencia',0),(482111,13392,'de','Transfer-Bericht anzeigen',0),(482112,13392,'en','View Transfer Report',0),(482113,13393,'is','',0),(482114,13393,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ø¨Ø§Ø²Ú¯Ø´Øª Ù¾Ùˆ',0),(482115,13393,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ø¨Ø§Ø²Ú¯Ø´Øª Ù¾Ùˆ',0),(482116,13393,'tr','DÃ¶nÃ¼ÅŸ PO oluÅŸturun',0),(482117,13393,'pl','Tworzenie powrÃ³t PO',0),(482118,13393,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ PO',0),(482119,13393,'ur','ÙˆØ§Ù¾Ø³ÛŒ Ù¾Ùˆ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(482120,13393,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¿Ð¾Ð²Ñ€Ð°Ñ‚Ð°Ðº ÐŸÐž',0),(482121,13393,'vi','Táº¡o ra lá»£i nhuáº­n PO',0),(482122,13393,'af','Skep terug PO',0),(482123,13393,'ro','Crea Ã®ntoarcerea PO',0),(482124,13393,'et','Loo tulu PO',0),(482125,13393,'si','Ustvarjanje donosa PO',0),(482126,13393,'ba','Menciptakan kembali PO',0),(482127,13393,'nl','Maken van terugkeer PO',0),(482128,13393,'fi','Luo paluu PO',0),(482129,13393,'no','Opprett retur PO',0),(482130,13393,'da','Oprette tilbagevenden PO',0),(482131,13393,'ko','ë°˜í™˜ í¬ ë§Œë“¤ê¸°',0),(482132,13393,'he','×¦×•×¨ ×”×©×™×‘×” ×¤×•',0),(482133,13393,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î® PO',0),(482134,13393,'zh','åˆ›å»ºè¿”å›žå¤§åŸ”',0),(482135,13393,'sv','Skapa avkastning PO',0),(482136,13393,'it','Creare ritorno PO',0),(482137,13393,'tl','',0),(482138,13393,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸„à¸·à¸™ PO',0),(482139,13393,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤ªà¥‹ à¤¬à¤¨à¤¾à¤à¤',0),(482140,13393,'ms','Mencipta kembali PO',0),(482141,13393,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¹ÙˆØ¯Ø© Ø¨Ùˆ',0),(482142,13393,'fr','CrÃ©er retour PO',0),(482143,13393,'jp','PO ã®ãƒªã‚¿ãƒ¼ãƒ³ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(482144,13393,'pt','Criar retorno PO',0),(482145,13393,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð° PO',0),(482146,13393,'es','Crear OC de DevoluciÃ³n',0),(482147,13393,'de','RÃ¼ckkehr PO zu erstellen',0),(482148,13393,'en','Create Return PO',0),(482149,13394,'is','',0),(482150,13394,'dr','Ø¨Ø®Ø´Ù†Ø§Ù…Ù‡',0),(482151,13394,'pr','Ø¨Ø®Ø´Ù†Ø§Ù…Ù‡',0),(482152,13394,'tr','YÃ¶nergesi',0),(482153,13394,'pl','Dyrektywy',0),(482154,13394,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð¸Ð²Ð°',0),(482155,13394,'ur','Ú¾Ø¯Ø§ÛŒØª',0),(482156,13394,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð¸Ð²Ð°',0),(482157,13394,'vi','Chá»‰ thá»‹',0),(482158,13394,'af','Aanwysing',0),(482159,13394,'ro','Directiva',0),(482160,13394,'et','Direktiivi',0),(482161,13394,'si','Direktive',0),(482162,13394,'ba','Direktif',0),(482163,13394,'nl','Richtlijn',0),(482164,13394,'fi','Direktiivin',0),(482165,13394,'no','Direktivet',0),(482166,13394,'da','Direktiv',0),(482167,13394,'ko','ì§€ì‹œë¬¸',0),(482168,13394,'he','×”×•×¨××”',0),(482169,13394,'el','ÎŸÎ´Î·Î³Î¯Î±Ï‚',0),(482170,13394,'zh','æŒ‡ä»¤',0),(482171,13394,'sv','Direktiv',0),(482172,13394,'it','Direttiva',0),(482173,13394,'tl','',0),(482174,13394,'th','à¸„à¸³à¸ªà¸±à¹ˆà¸‡',0),(482175,13394,'hi','à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¤•',0),(482176,13394,'ms','Arahan',0),(482177,13394,'ar','Ø§Ù„ØªÙˆØ¬ÙŠÙ‡',0),(482178,13394,'fr','Directive',0),(482179,13394,'jp','ãƒ‡ã‚£ãƒ¬ã‚¯ãƒ†ã‚£ãƒ–',0),(482180,13394,'pt','Directiva',0),(482181,13394,'ru','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð¸Ð²Ð°',0),(482182,13394,'es','Directivo',0),(482183,13394,'de','Richtlinie',0),(482184,13394,'en','Directive',0),(482185,13395,'is','',0),(482186,13395,'dr','Ù‡ÛŒÚ† Ú†ÛŒØ² Ø¯Ø±ÛŒØ§ÙØª',0),(482187,13395,'pr','Ù‡ÛŒÚ† Ú†ÛŒØ² Ø¯Ø±ÛŒØ§ÙØª',0),(482188,13395,'tr','AlÄ±nan bir ÅŸey yok',0),(482189,13395,'pl','Nic nie otrzymaÅ‚',0),(482190,13395,'bg','ÐÐ¸Ñ‰Ð¾ Ð½Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°',0),(482191,13395,'ur','Ú©Ú†Ú¾ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(482192,13395,'sr','ÐÐ¸ÑˆÑ‚Ð° Ð´Ð¾Ð±Ð¸Ð»Ð°',0),(482193,13395,'vi','KhÃ´ng cÃ³ gÃ¬ Ä‘Ã£ nháº­n Ä‘Æ°á»£c',0),(482194,13395,'af','Niks ontvang',0),(482195,13395,'ro','Nimic nu a primit',0),(482196,13395,'et','Midagi saanud',0),(482197,13395,'si','NiÄ prejel',0),(482198,13395,'ba','Tidak ada yang diterima',0),(482199,13395,'nl','Niets ontvangen',0),(482200,13395,'fi','MitÃ¤Ã¤n saanut',0),(482201,13395,'no','Ingenting mottatt',0),(482202,13395,'da','Intet modtaget',0),(482203,13395,'ko','ì•„ë¬´ê²ƒë„ ë°›ì€',0),(482204,13395,'he','×©×•× ×“×‘×¨ ×œ× ×”×ª×§×‘×œ',0),(482205,13395,'el','Î¤Î¯Ï€Î¿Ï„Î± Î´ÎµÎ½ Î­Î»Î±Î²Îµ',0),(482206,13395,'zh','æ²¡æœ‰æ”¶åˆ°',0),(482207,13395,'sv','Ingenting fick',0),(482208,13395,'it','Niente ricevute',0),(482209,13395,'tl','',0),(482210,13395,'th','à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸£à¸±à¸š',0),(482211,13395,'hi','à¤•à¥à¤› à¤­à¥€ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(482212,13395,'ms','Apa-apa yang diterima',0),(482213,13395,'ar','Ù„Ø§ Ø´ÙŠØ¡ Ø­ØµÙ„',0),(482214,13395,'fr','Rien reÃ§u',0),(482215,13395,'jp','ä½•ã‚‚å—ä¿¡',0),(482216,13395,'pt','Nada recebeu',0),(482217,13395,'ru','ÐÐ¸Ñ‡ÐµÐ³Ð¾ Ð½Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»',0),(482218,13395,'es','Nada Recibido',0),(482219,13395,'de','Nichts empfangen',0),(482220,13395,'en','Nothing Received',0),(482221,13396,'is','',0),(482222,13396,'dr','Ù‡ÛŒÚ† Ù…ÙˆØ±Ø¯ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø¨Ù‡ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482223,13396,'pr','Ù‡ÛŒÚ† Ù…ÙˆØ±Ø¯ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡ Ø¨Ù‡ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482224,13396,'tr','HiÃ§bir Ã¶ÄŸe dÃ¶nmek iÃ§in',0),(482225,13396,'pl','Brak elementÃ³w do zwrotu',0),(482226,13396,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(482227,13396,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(482228,13396,'sr','ÐÐµÐ¼Ð° ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸Ñ… Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚Ð°Ðº',0),(482229,13396,'vi','KhÃ´ng cÃ³ khoáº£n má»¥c Ä‘Æ°á»£c chá»n Ä‘á»ƒ trá»Ÿ láº¡i',0),(482230,13396,'af','Geen Items is gekies om terug te',0),(482231,13396,'ro','Articole selectate pentru a reveni',0),(482232,13396,'et','Tagasi valitud Ã¼ksusi',0),(482233,13396,'si','Ni elementov, ki so izbrani za vrnitev',0),(482234,13396,'ba','Tidak ada item yang dipilih untuk kembali',0),(482235,13396,'nl','Geen Items geselecteerd om terugkeer',0),(482236,13396,'fi','Paluuta ei ole kohteita',0),(482237,13396,'no','Ingen elementer Ã¥ vende',0),(482238,13396,'da','Ingen varer, valgt at vende tilbage',0),(482239,13396,'ko','ë°˜í™˜ í•˜ë„ë¡ ì„ íƒí•œ í•­ëª©ì´ ì—†ìŠµë‹ˆë‹¤',0),(482240,13396,'he','××™×Ÿ ×¤×¨×™×˜×™× × ×‘×—×¨×™× ×›×“×™ ×œ×—×–×•×¨',0),(482241,13396,'el','Î”ÎµÎ½ Î­Ï‡Î¿Ï…Î½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î³Î¹Î± ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(482242,13396,'zh','æ²¡æœ‰è¿”å›žé€‰å®šçš„é¡¹ç›®',0),(482243,13396,'sv','Inga objekt Ã¤r markerade till retur',0),(482244,13396,'it','Nessun elemento selezionato al ritorno',0),(482245,13396,'tl','',0),(482246,13396,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸à¸—à¸µà¹ˆà¸ˆà¸°à¸à¸¥à¸±à¸š',0),(482247,13396,'hi','à¤•à¥‹à¤ˆ à¤†à¤‡à¤Ÿà¤® à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¯à¤¨à¤¿à¤¤',0),(482248,13396,'ms','Tiada item telah dipilih untuk mendapatkan balik',0),(482249,13396,'ar','Ù„Ø§ Ù…Ù† Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…Ø­Ø¯Ø¯Ø© Ù„Ù„Ø¹ÙˆØ¯Ø©',0),(482250,13396,'fr','Aucun article sÃ©lectionnÃ© pour retour',0),(482251,13396,'jp','æˆ»ã‚‹é¸æŠžé …ç›®ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(482252,13396,'pt','Nenhum item selecionado para retorno',0),(482253,13396,'ru','ÐÐµÑ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð², Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð´Ð»Ñ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚Ð°',0),(482254,13396,'es','Ningunos Items Seleccionados Para Devolver',0),(482255,13396,'de','Keine Elemente ausgewÃ¤hlt, um RÃ¼ckkehr',0),(482256,13396,'en','No Items Selected To Return',0),(482257,13397,'is','',0),(482258,13397,'dr','Ù„Ø·ÙØ§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ØµÙ†Ø¯ÙˆÙ‚',0),(482259,13397,'pr','Ù„Ø·ÙØ§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ØµÙ†Ø¯ÙˆÙ‚',0),(482260,13397,'tr','LÃ¼tfen bir PO seÃ§in',0),(482261,13397,'pl','ProszÄ™ wybraÄ‡ PO',0),(482262,13397,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ PO',0),(482263,13397,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Ø§ÛŒÚ© Ù¾Ùˆ',0),(482264,13397,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐŸÐžÐ•Ð',0),(482265,13397,'vi','Vui lÃ²ng chá»n má»™t PO',0),(482266,13397,'af','Kies asseblief \'n PO',0),(482267,13397,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i O PO',0),(482268,13397,'et','Palun valige organisatsioonidesse',0),(482269,13397,'si','Prosimo, izberite PO',0),(482270,13397,'ba','Silakan pilih PO',0),(482271,13397,'nl','Selecteer een PO',0),(482272,13397,'fi','Valitse PO',0),(482273,13397,'no','Velg en PO',0),(482274,13397,'da','VÃ¦lg venligst en PO',0),(482275,13397,'ko','POë¥¼ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(482276,13397,'he','× × ×‘×—×¨ ×ž×—×©×‘',0),(482277,13397,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± PO',0),(482278,13397,'zh','è¯·é€‰æ‹©é‡‡è´­è®¢å•',0),(482279,13397,'sv','VÃ¤nligen vÃ¤lj en PO',0),(482280,13397,'it','Si prega di selezionare un PO',0),(482281,13397,'tl','',0),(482282,13397,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸¥à¸·à¸­à¸à¹à¸šà¸š PO',0),(482283,13397,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• PO à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(482284,13397,'ms','Sila pilih PO yang',0),(482285,13397,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ PO',0),(482286,13397,'fr','Veuillez sÃ©lectionner un PO',0),(482287,13397,'jp','PO ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(482288,13397,'pt','Por favor selecione um PO',0),(482289,13397,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ PO',0),(482290,13397,'es','Por Favor Selecciona Un OC',0),(482291,13397,'de','Bitte wÃ¤hlen Sie eine PO',0),(482292,13397,'en','Please Select A PO',0),(482293,13398,'is','',0),(482294,13398,'dr','POs Ù‚Ø¨Ù„ÛŒ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482295,13398,'pr','POs Ù‚Ø¨Ù„ÛŒ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482296,13398,'tr','Ã–nceki dÃ¶nÃ¼ÅŸ POs',0),(482297,13398,'pl','Poprzedni POs zwrotu',0),(482298,13398,'bg','ÐŸÑ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ Ñ€ÐµÐºÐ»Ð°Ð¼Ð°Ñ†Ð¸Ñ POs',0),(482299,13398,'ur','Ù¾Ú†Ú¾Ù„Ø§ ÙˆØ§Ù¾Ø³ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù†',0),(482300,13398,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¸ Ð¿Ð¾Ð²Ñ€Ð°Ñ‚Ð½Ðµ ÐŸÐžÑ',0),(482301,13398,'vi','POs trá»Ÿ vá» trÆ°á»›c',0),(482302,13398,'af','Vorige terug POs',0),(482303,13398,'ro','POs retur anterioare',0),(482304,13398,'et','Eelmine saatja POs',0),(482305,13398,'si','PrejÅ¡nje vrnitev POs',0),(482306,13398,'ba','Sebelumnya kembali POs',0),(482307,13398,'nl','Vorige terugkeer POs',0),(482308,13398,'fi','Edellisen palautuksen POs',0),(482309,13398,'no','Tidligere retur POs',0),(482310,13398,'da','Tidligere afkast POs',0),(482311,13398,'ko','ì´ì „ ë°˜í™˜ ìˆœìœ„',0),(482312,13398,'he','POs ×”×—×–×¨×” ×”×§×•×“×',0),(482313,13398,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î® POs',0),(482314,13398,'zh','ä»¥å‰è¿”å›ž POs',0),(482315,13398,'sv','Tidigare avkastning POs',0),(482316,13398,'it','Precedente ritorno POs',0),(482317,13398,'tl','',0),(482318,13398,'th','POs à¸„à¸·à¸™à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(482319,13398,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤µà¤¾à¤ªà¤¸à¥€ POs',0),(482320,13398,'ms','Sebelumnya POs kembali',0),(482321,13398,'ar','Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ ÙˆØ¹ÙˆØ¯Ø© Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(482322,13398,'fr','POs retour prÃ©cÃ©dents',0),(482323,13398,'jp','ä»¥å‰ã®æˆ»ã‚Š POs',0),(482324,13398,'pt','POs retorno anteriores',0),(482325,13398,'ru','ÐŸÑ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ð¹ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚ POs',0),(482326,13398,'es','OCs Previamente Regresados',0),(482327,13398,'de','FrÃ¼here RÃ¼ckkehr POs',0),(482328,13398,'en','Previous Return POs',0),(482329,13399,'is','',0),(482330,13399,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù¾ÛŒØ´ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482331,13399,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù¾ÛŒØ´ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482332,13399,'tr','Daha Ã¶nce Ä°ade Mkt.',0),(482333,13399,'pl','IloÅ›Ä‡ wczeÅ›niej powrÃ³ciÅ‚',0),(482334,13399,'bg','ÐšÐ¾Ð» Ð¿Ñ€ÐµÐ´Ð¸ Ñ‚Ð¾Ð²Ð° Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸',0),(482335,13399,'ur','Ù‚Ø¨Ù„ Ø§Ø²ÛŒÚº ÙˆØ§Ù¾Ø³ Ù‚ÛŒ',0),(482336,13399,'sr','ÐšÐ¾Ð» , Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾ ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾',0),(482337,13399,'vi','Qty trÆ°á»›c Ä‘Ã¢y trá»Ÿ láº¡i',0),(482338,13399,'af','Qty voorheen teruggekeer',0),(482339,13399,'ro','Cantit anterior s-a Ã®ntors',0),(482340,13399,'et','Varem tagastatud kogus',0),(482341,13399,'si','KoliÄina prej vrnil',0),(482342,13399,'ba','Qty sebelumnya kembali',0),(482343,13399,'nl','Aantal eerder resultaat',0),(482344,13399,'fi','Aikaisemmin palautettu mÃ¤Ã¤rÃ¤',0),(482345,13399,'no','Antall tidligere returnert',0),(482346,13399,'da','Antal tidligere returneres',0),(482347,13399,'ko','Qty ì´ì „ ë°˜í™˜',0),(482348,13399,'he','×›×ž×•×ª ×‘×¢×‘×¨ ×—×–×¨',0),(482349,13399,'el','Qty ÎµÏ€Î¹ÏƒÏ„ÏÎ¬Ï†Î·ÎºÎµ Ï€ÏÎ¿Î·Î³Î¿Ï…Î¼Î­Î½Ï‰Ï‚',0),(482350,13399,'zh','ä»¥å‰è¿”å›žçš„æ•°é‡',0),(482351,13399,'sv','Antal tidigare Ã¥tervÃ¤nde',0),(482352,13399,'it','Qty precedentemente restituito',0),(482353,13399,'tl','',0),(482354,13399,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¸„à¸·à¸™à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(482355,13399,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤ªà¤¹à¤²à¥‡ à¤²à¥Œà¤Ÿà¥‡',0),(482356,13399,'ms','Qty yang sebelum ini kembali',0),(482357,13399,'ar','Qty Ø³Ø§Ø¨Ù‚Ø§ Ø¹Ø§Ø¯',0),(482358,13399,'fr','Qty retournÃ© prÃ©cÃ©demment',0),(482359,13399,'jp','ä»¥å‰è¿”ã•ã‚ŒãŸæ•°é‡',0),(482360,13399,'pt','Qty anteriormente retornado',0),(482361,13399,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ñ€Ð°Ð½ÐµÐµ Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ',0),(482362,13399,'es','Cantidad Previamente Regresada',0),(482363,13399,'de','Qty vorher zurÃ¼ckgegeben',0),(482364,13399,'en','Qty Previously Returned',0),(482365,13400,'is','',0),(482366,13400,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482367,13400,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482368,13400,'tr','Ä°ade Mkt.',0),(482369,13400,'pl','IloÅ›Ä‡ do powrotu',0),(482370,13400,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð²Ñ€ÑŠÑ‰Ð°Ð½Ðµ',0),(482371,13400,'ur','Ù‚ÛŒ Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ú©Û’ Ù„ÛŒÛ’',0),(482372,13400,'sr','ÐšÐ¾Ð» Ð·Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚Ð°Ðº',0),(482373,13400,'vi','SL Ä‘á»ƒ trá»Ÿ láº¡i',0),(482374,13400,'af','Qty om terug',0),(482375,13400,'ro','Cantit Ã®ntoarcerea',0),(482376,13400,'et','Kogus tulususega',0),(482377,13400,'si','KoliÄina za vrnitev',0),(482378,13400,'ba','Qty kembali',0),(482379,13400,'nl','Aantal terugkeer',0),(482380,13400,'fi','MÃ¤Ã¤rÃ¤ palata',0),(482381,13400,'no','Antall tilbake',0),(482382,13400,'da','Antal til afkast',0),(482383,13400,'ko','ëŒì•„ê°€ê¸° ìˆ˜ëŸ‰',0),(482384,13400,'he','×›×ž×•×ª ×—×–×¨×ª×',0),(482385,13400,'el','Qty ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(482386,13400,'zh','è¿”å›žçš„æ•°é‡',0),(482387,13400,'sv','Kvt att Ã¥tervÃ¤nda',0),(482388,13400,'it','Qty per ritorno',0),(482389,13400,'tl','',0),(482390,13400,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸„à¸·à¸™',0),(482391,13400,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(482392,13400,'ms','Qty untuk mendapatkan balik',0),(482393,13400,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø¥Ù„Ù‰ Ø¹ÙˆØ¯Ø©',0),(482394,13400,'fr','QtÃ© de retour',0),(482395,13400,'jp','Qty ã«æˆ»ã‚‹',0),(482396,13400,'pt','Qtde de retorno',0),(482397,13400,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð´Ð»Ñ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ñ',0),(482398,13400,'es','Cantidad Para Regresar',0),(482399,13400,'de','Qty RÃ¼ckgaberecht',0),(482400,13400,'en','Qty To Return',0),(482401,13401,'is','',0),(482402,13401,'dr','Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†ÛŒ',0),(482403,13401,'pr','Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†ÛŒ',0),(482404,13401,'tr','DeÄŸiÅŸtirme',0),(482405,13401,'pl','Wymiana',0),(482406,13401,'bg','Ð—Ð°Ð¼ÑÐ½Ð°',0),(482407,13401,'ur','Ù…ØªØ¨Ø§Ø¯Ù„',0),(482408,13401,'sr','Ð—Ð°Ð¼ÐµÐ½Ð°',0),(482409,13401,'vi','Thay tháº¿',0),(482410,13401,'af','Vervanging',0),(482411,13401,'ro','ÃŽnlocuire',0),(482412,13401,'et','Asendamine',0),(482413,13401,'si','Zamenjava',0),(482414,13401,'ba','Penggantian',0),(482415,13401,'nl','Vervanging',0),(482416,13401,'fi','Korvaaminen',0),(482417,13401,'no','Erstatning',0),(482418,13401,'da','Udskiftning',0),(482419,13401,'ko','êµì²´',0),(482420,13401,'he','×”×—×œ×¤×ª',0),(482421,13401,'el','Î‘Î½Ï„Î¹ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(482422,13401,'zh','æ›´æ¢',0),(482423,13401,'sv','ErsÃ¤ttare',0),(482424,13401,'it','Ricambio',0),(482425,13401,'tl','',0),(482426,13401,'th','à¹à¸—à¸™',0),(482427,13401,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¸à¥à¤¥à¤¾à¤ªà¤¨',0),(482428,13401,'ms','Penggantian',0),(482429,13401,'ar','Ø§Ø³ØªØ¨Ø¯Ø§Ù„',0),(482430,13401,'fr','Remplacement',0),(482431,13401,'jp','äº¤æ›',0),(482432,13401,'pt','SubstituiÃ§Ã£o',0),(482433,13401,'ru','Ð—Ð°Ð¼ÐµÐ½Ð°',0),(482434,13401,'es','Sustituto',0),(482435,13401,'de','Ersatz',0),(482436,13401,'en','Replacement',0),(482437,13402,'is','',0),(482438,13402,'dr','Ø¨Ø§Ø²Ú¯Ø´Øª &amp; Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¹ØªØ¨Ø§Ø±',0),(482439,13402,'pr','Ø¨Ø§Ø²Ú¯Ø´Øª &amp; Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¹ØªØ¨Ø§Ø±',0),(482440,13402,'tr','DÃ¶nmek & kredi talebi',0),(482441,13402,'pl','PowrÃ³t & wniosek kredyt',0),(482442,13402,'bg','Ð’ÑŠÑ€Ð½ÐµÑ‚Ðµ & Ð¿Ð¾Ð¸ÑÐºÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(482443,13402,'ur','ÙˆØ§Ù¾Ø³ & Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø±ÛŒÚº',0),(482444,13402,'sr','Ð’Ñ€Ð°Ñ‚Ð¸ & Ð·Ð°Ñ‚Ñ€Ð°Ð¶Ð¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(482445,13402,'vi','Trá»Ÿ vá» &amp; yÃªu cáº§u tÃ­n dá»¥ng',0),(482446,13402,'af','Terugkeer & versoek krediet',0),(482447,13402,'ro','Reveni & cerere de Credit',0),(482448,13402,'et','Tagastab & taotleda krediiti',0),(482449,13402,'si','Vrnitev & zahtevajo kreditne',0),(482450,13402,'ba','Kembali & meminta kredit',0),(482451,13402,'nl','Keren & Creditering aanvragen',0),(482452,13402,'fi','Palauttaa & pyytÃ¤Ã¤ luotto',0),(482453,13402,'no','Returnere & be om kreditt',0),(482454,13402,'da','Returnere & anmode om kredit',0),(482455,13402,'ko','ë°˜í™˜ & ì‹ ìš©ì„ ìš”ì²­',0),(482456,13402,'he','×œ×”×—×–×™×¨ & ×‘×§×©×ª ××©×¨××™',0),(482457,13402,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® & Î¶Î·Ï„Î®ÏƒÎµÎ¹ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®',0),(482458,13402,'zh','è¿”å›ž &amp; è¯·æ±‚ä¿¡ç”¨',0),(482459,13402,'sv','Returnera & begÃ¤r kredit',0),(482460,13402,'it','Restituire & richiesta di credito',0),(482461,13402,'tl','',0),(482462,13402,'th','à¸à¸¥à¸±à¸š & à¸‚à¸­à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­',0),(482463,13402,'hi','à¤µà¤¾à¤ªà¤¸à¥€ & à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(482464,13402,'ms','Kembali & meminta kredit',0),(482465,13402,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¢Ù†Ø¯ Ø·Ù„Ø¨ Ø§Ø¦ØªÙ…Ø§Ù†',0),(482466,13402,'fr','Retour & demander le crÃ©dit',0),(482467,13402,'jp','è¿”ã™ & ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚’è¦æ±‚',0),(482468,13402,'pt','Retornar & solicitar crÃ©dito',0),(482469,13402,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ & Ð¿Ñ€Ð¾ÑÐ¸Ñ‚ÑŒ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(482470,13402,'es','Regresar & Pedir CrÃ©dito',0),(482471,13402,'de','ZurÃ¼ck & Kredit anfordern',0),(482472,13402,'en','Return & Request Credit',0),(482473,13403,'is','',0),(482474,13403,'dr','Ø¨Ø§Ø²Ú¯Ø´Øª &amp; Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†ÛŒ',0),(482475,13403,'pr','Ø¨Ø§Ø²Ú¯Ø´Øª &amp; Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†ÛŒ',0),(482476,13403,'tr','DÃ¶nmek & deÄŸiÅŸtirme isteÄŸi',0),(482477,13403,'pl','PowrÃ³t & Å¼Ä…dania wymiany',0),(482478,13403,'bg','Ð’ÑŠÑ€Ð½ÐµÑ‚Ðµ & Ð¿Ð¾Ð¸ÑÐºÐ° Ð·Ð°Ð¼ÑÐ½Ð°',0),(482479,13403,'ur','ÙˆØ§Ù¾Ø³ & Ù…ØªØ¨Ø§Ø¯Ù„ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø±ÛŒÚº',0),(482480,13403,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¸ Ð·Ð°Ñ‚Ñ€Ð°Ð¶Ð¸Ñ‚Ðµ Ð·Ð°Ð¼ÐµÐ½Ñƒ',0),(482481,13403,'vi','Trá»Ÿ vá» &amp; yÃªu cáº§u thay tháº¿',0),(482482,13403,'af','Terugkeer & versoek vervanging',0),(482483,13403,'ro','Reveni & solicita Ã®nlocuirea',0),(482484,13403,'et','Tagastab & taotleda asendamine',0),(482485,13403,'si','Vrnitev & zahteva zamenjavo',0),(482486,13403,'ba','Kembali & meminta penggantian',0),(482487,13403,'nl','Keren & vervangende',0),(482488,13403,'fi','Palauttaa & pyytÃ¤Ã¤ korvaaminen',0),(482489,13403,'no','Returnere & be om erstatning',0),(482490,13403,'da','Returnere & anmode om udskiftning',0),(482491,13403,'ko','ë°˜í™˜ & êµì²´ ìš”ì²­',0),(482492,13403,'he','×œ×”×—×–×™×¨ & ×œ×‘×§×© ×”×—×œ×¤×ª',0),(482493,13403,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® & Î¶Î·Ï„Î®ÏƒÎµÎ¹ Î±Î½Ï„Î¹ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(482494,13403,'zh','è¿”å›ž &amp; è¯·æ±‚æ›¿æ¢',0),(482495,13403,'sv','Returnera & begÃ¤ra ersÃ¤ttning',0),(482496,13403,'it','Restituire & richiedere la sostituzione',0),(482497,13403,'tl','',0),(482498,13403,'th','à¸à¸¥à¸±à¸š & à¸‚à¸­à¹à¸—à¸™',0),(482499,13403,'hi','à¤µà¤¾à¤ªà¤¸à¥€ & à¤ªà¥à¤°à¤¤à¤¿à¤¸à¥à¤¥à¤¾à¤ªà¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(482500,13403,'ms','Kembali & memohon gantian',0),(482501,13403,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¢Ù†Ø¯ Ø·Ù„Ø¨ Ø§Ø³ØªØ¨Ø¯Ø§Ù„',0),(482502,13403,'fr','Retour & de demander le remplacement',0),(482503,13403,'jp','è¿”ã™ & è¦æ±‚ã®ç½®æ›',0),(482504,13403,'pt','Retornar & solicitar substituiÃ§Ã£o',0),(482505,13403,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ & Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð¸Ð¹Ð½ÑƒÑŽ Ð·Ð°Ð¼ÐµÐ½Ñƒ',0),(482506,13403,'es','Regresar & Pedir Un Reemplazo',0),(482507,13403,'de','ZurÃ¼ck & Ersatz anfordern',0),(482508,13403,'en','Return & Request Replacement',0),(482509,13404,'is','',0),(482510,13404,'dr','ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§ÛŒØ¬Ø§Ø¯ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482511,13404,'pr','ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§ÛŒØ¬Ø§Ø¯ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482512,13404,'tr','DÃ¶nÃ¼ÅŸ PO baÅŸarÄ±yla oluÅŸturuldu',0),(482513,13404,'pl','PO powrocie zostaÅ‚ utworzony pomyÅ›lnie',0),(482514,13404,'bg','Ð ÐµÐºÐ»Ð°Ð¼Ð°Ñ†Ð¸Ñ PO, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(482515,13404,'ur','ÙˆØ§Ù¾Ø³ÛŒ Ù¾Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(482516,13404,'sr','Ð¡Ðµ Ð²Ñ€Ð°Ñ‚Ð¸ ÐŸÐž ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°',0),(482517,13404,'vi','Trá»Ÿ vá» PO táº¡o thÃ nh cÃ´ng',0),(482518,13404,'af','Terug PO suksesvol geskep',0),(482519,13404,'ro','ÃŽntoarce op creat cu succes',0),(482520,13404,'et','Tagastab PO on edukalt loodud',0),(482521,13404,'si','Vrnitev PO uspeÅ¡no ustvarjen',0),(482522,13404,'ba','Kembali PO dibuat dengan sukses',0),(482523,13404,'nl','Terugkeer PO met succes gemaakt',0),(482524,13404,'fi','Palauttaa PO luonti onnistui',0),(482525,13404,'no','Returnere PO opprettet',0),(482526,13404,'da','Vende tilbage PO oprettet',0),(482527,13404,'ko','ì„±ê³µì ìœ¼ë¡œ ë§Œë“  í¬ë¥¼ ë°˜í™˜',0),(482528,13404,'he','×¤×• ×”×”×—×–×¨×” × ×•×¦×¨ ×‘×”×¦×œ×—×”',0),(482529,13404,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® PO Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(482530,13404,'zh','è¿”å›žå·²æˆåŠŸåˆ›å»ºçš„é‡‡è´­è®¢å•',0),(482531,13404,'sv','Returnera PO har skapats',0),(482532,13404,'it','Restituire PO creato con successo',0),(482533,13404,'tl','',0),(482534,13404,'th','PO à¸ªà¹ˆà¸‡à¸„à¸·à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸ªà¸£à¹‰à¸²à¸‡à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢',0),(482535,13404,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤ªà¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(482536,13404,'ms','Kembali PO yang berjaya dicipta',0),(482537,13404,'ar','Ø¨Ùˆ Ø§Ù„Ø¥Ø±Ø¬Ø§Ø¹ Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(482538,13404,'fr','Retour PO crÃ©Ã© avec succÃ¨s',0),(482539,13404,'jp','æ­£å¸¸ã«ä½œæˆã•ã‚ŒãŸ PO ã‚’è¿”ã™',0),(482540,13404,'pt','PO retorno criado com sucesso',0),(482541,13404,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ PO, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½',0),(482542,13404,'es','OC de Regreso Creado Exitosamente',0),(482543,13404,'de','Return PO wurde erfolgreich erstellt.',0),(482544,13404,'en','Return PO Created Successfully',0),(482545,13405,'is','',0),(482546,13405,'dr','ØµÙ†Ø¯ÙˆÙ‚ Ø¯Ø±ÛŒØ§ÙØª Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482547,13405,'pr','ØµÙ†Ø¯ÙˆÙ‚ Ø¯Ø±ÛŒØ§ÙØª Ø¨Ø§Ø²Ú¯Ø´Øª',0),(482548,13405,'tr','Ä°ade alÄ±nan PO',0),(482549,13405,'pl','Zwrotu otrzymanych PO',0),(482550,13405,'bg','Ð’Ñ€ÑŠÑ‰Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ PO',0),(482551,13405,'ur','ÙˆØ§Ù¾Ø³ ÙˆØµÙˆÙ„ Ù¾Ùˆ',0),(482552,13405,'sr','Ð’Ñ€Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ ÐŸÐž',0),(482553,13405,'vi','Trá»Ÿ láº¡i nháº­n Ä‘Æ°á»£c PO',0),(482554,13405,'af','Terug ontvang PO',0),(482555,13405,'ro','Retur primit PO',0),(482556,13405,'et','Edasi-tagasi saabunud PO',0),(482557,13405,'si','VraÄanja prejete PO',0),(482558,13405,'ba','Kembali PO diterima',0),(482559,13405,'nl','Terugkeer ontvangen PO',0),(482560,13405,'fi','Paluu sai PO',0),(482561,13405,'no','Returnere mottatt PO',0),(482562,13405,'da','Returnere modtagne PO',0),(482563,13405,'ko','ë°˜í™˜ ë°›ì€ í¬',0),(482564,13405,'he','×œ×”×—×–×™×¨ ××ª ×¤×• ×©×”×ª×§×‘×œ×•',0),(482565,13405,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Î­Î»Î±Î²Îµ PO',0),(482566,13405,'zh','è¿”å›žæŽ¥æ”¶é‡‡è´­è®¢å•',0),(482567,13405,'sv','Returnera mottagna PO',0),(482568,13405,'it','Restituire PO ricevuto',0),(482569,13405,'tl','',0),(482570,13405,'th','à¸à¸¥à¸±à¸šà¹„à¸”à¹‰à¸£à¸±à¸š PO',0),(482571,13405,'hi','à¤µà¤¾à¤ªà¤¸à¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤ªà¥‹',0),(482572,13405,'ms','Kembali diterima PO',0),(482573,13405,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø§Ù„Ù…ØªÙ„Ù‚Ø§Ø© PO',0),(482574,13405,'fr','Retour PO reÃ§u',0),(482575,13405,'jp','å—ä¿¡ã—ãŸ PO ã‚’è¿”ã™',0),(482576,13405,'pt','PO recebido retorno',0),(482577,13405,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÐ¼Ð¾Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð» PO',0),(482578,13405,'es','OC de Regreso Recibido',0),(482579,13405,'de','RÃ¼ckgabe empfangener PO',0),(482580,13405,'en','Return Received PO',0),(482581,13406,'is','',0),(482582,13406,'dr','Ù…ÙˆØ±Ø¯ Ú¯Ø²Ø§Ø±Ø´ Ø§Ù†ØªÙ‚Ø§Ù„',0),(482583,13406,'pr','Ù…ÙˆØ±Ø¯ Ú¯Ø²Ø§Ø±Ø´ Ø§Ù†ØªÙ‚Ø§Ù„',0),(482584,13406,'tr','Madde AktarÄ±m Raporu',0),(482585,13406,'pl','Element raportu transferu',0),(482586,13406,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð·Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(482587,13406,'ur','Ø´Û’ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(482588,13406,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(482589,13406,'vi','Má»¥c chuyá»ƒn bÃ¡o cÃ¡o',0),(482590,13406,'af','Item oordrag verslag',0),(482591,13406,'ro','Raport de Transfer element',0),(482592,13406,'et','Kauba Ã¼leandmise aruanne',0),(482593,13406,'si','Element prenosa poroÄilo',0),(482594,13406,'ba','Item Transfer laporan',0),(482595,13406,'nl','Object Transfer verslag',0),(482596,13406,'fi','Nimikkeen siirtÃ¤minen raportti',0),(482597,13406,'no','Elementet overfÃ¸ring rapport',0),(482598,13406,'da','Vare overfÃ¸rsel rapport',0),(482599,13406,'ko','í•­ëª© ì „ì†¡ ë³´ê³ ì„œ',0),(482600,13406,'he','×“×•×— ×”×¢×‘×¨×ª ×¤×¨×™×˜×™×',0),(482601,13406,'el','Î•Î¯Î´Î¿Ï…Ï‚ Î±Î½Î±Ï†Î¿ÏÎ¬ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚',0),(482602,13406,'zh','é¡¹ç›®è½¬è®©æŠ¥å‘Š',0),(482603,13406,'sv','Objektet Ã¶verfÃ¶ring rapport',0),(482604,13406,'it','Rapporto elemento di trasferimento',0),(482605,13406,'tl','',0),(482606,13406,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(482607,13406,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(482608,13406,'ms','Laporan pindahan butiran',0),(482609,13406,'ar','ØªÙ‚Ø±ÙŠØ± Ù†Ù‚Ù„ Ø§Ù„Ø¹Ù†ØµØ±',0),(482610,13406,'fr','Rapport de transfert de point',0),(482611,13406,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®è»¢é€ãƒ¬ãƒãƒ¼ãƒˆ',0),(482612,13406,'pt','RelatÃ³rio de transferÃªncia de item',0),(482613,13406,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(482614,13406,'es','Informe de Transferencia de Item',0),(482615,13406,'de','Top-Transfer-Bericht',0),(482616,13406,'en','Item Transfer Report',0),(482617,13407,'is','',0),(482618,13407,'dr','Ø¨Ø±Ø±Ø³ÛŒ preprinted Ø³Ù‡Ø§Ù… Ø³Ø¨Ú© #5',0),(482619,13407,'pr','Ø¨Ø±Ø±Ø³ÛŒ preprinted Ø³Ù‡Ø§Ù… Ø³Ø¨Ú© #5',0),(482620,13407,'tr','Ã–nceden basÄ±lmÄ±ÅŸ onay hisse senedi tarzÄ± #5',0),(482621,13407,'pl','Nadrukiem sprawdzanie zapasÃ³w stylu #5',0),(482622,13407,'bg','ÐŸÐ¾ÑÑÐ½Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð° ÑÑ‚Ð¸Ð» #5',0),(482623,13407,'ur','Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹Ø¯ Ú†ÛŒÚ© Ø§Ø³Ù¹Ø§Ú© Ø·Ø±Ø² #5',0),(482624,13407,'sr','Ð¤Ð°Ð±Ñ€Ð¸Ñ‡ÐºÐ¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ñƒ ÑÑ‚Ð¸Ð»Ñƒ #5',0),(482625,13407,'vi','Preprinted phÃ²ng theo phong cÃ¡ch cá»• #5',0),(482626,13407,'af','Preprinted kontroleer voorraad-styl #5',0),(482627,13407,'ro','Selectare pre-imprimate stil stoc #5',0),(482628,13407,'et','ValmistrÃ¼kitud sisse Stock-stiil #5',0),(482629,13407,'si','Nespremenljivo Äek staleÅ¾-Style #5',0),(482630,13407,'ba','Cetakan Periksa saham-gaya #5',0),(482631,13407,'nl','Voorgedrukte selectievakje Stock-Style #5',0),(482632,13407,'fi','Esipainettua uloskirjautuminen Stock-tyylinen #5',0),(482633,13407,'no','Fortrykt av lager-stil #5',0),(482634,13407,'da','Fortrykt Check Stock-stil #5',0),(482635,13407,'ko','ì¸ì‡„ ëœ ìˆ˜ í‘œ ì£¼ì‹-ìŠ¤íƒ€ì¼ #5',0),(482636,13407,'he','×”×¡×™×ž×•×Ÿ ×ž×•×“×¤×¡ ×ž×¨××© ×ž×œ××™ ×‘×¡×’× ×•×Ÿ #5',0),(482637,13407,'el','Î ÏÎ¿Ï„Ï…Ï€Ï‰Î¼Î­Î½ÎµÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÏƒÏ„Î¹Î» #5',0),(482638,13407,'zh','é¢„å…ˆçš„æ£€æŸ¥è‚¡ç¥¨é£Žæ ¼ #5',0),(482639,13407,'sv','FÃ¶rtryckta kontroll lager stil #5',0),(482640,13407,'it','Prestampati Check Stock-stile #5',0),(482641,13407,'tl','',0),(482642,13407,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸žà¸´à¸¡à¸žà¹Œà¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²à¸«à¸¸à¹‰à¸™à¹à¸šà¸š #5',0),(482643,13407,'hi','Preprinted à¤šà¥‡à¤• à¤¶à¥‡à¤¯à¤°-à¤¶à¥ˆà¤²à¥€ #5',0),(482644,13407,'ms','Pracetak semak stok-gaya #5',0),(482645,13407,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù…Ø·Ø¨ÙˆØ¹ Ø¹Ù„Ù‰ ØºØ±Ø§Ø± Ø§Ù„Ø£Ø³Ù‡Ù… #5',0),(482646,13407,'fr','ChÃ¨que prÃ©imprimÃ© Style Stock #5',0),(482647,13407,'jp','ã‚ã‚‰ã‹ã˜ã‚ãƒã‚§ãƒƒã‚¯åœ¨åº«ã‚¹ã‚¿ã‚¤ãƒ« #5',0),(482648,13407,'pt','SeleÃ§Ã£o prÃ©-impresso estilo Stock #5',0),(482649,13407,'ru','ÐŸÐ»Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð°Ð¿Ð°ÑÐ¾Ð² ÑÑ‚Ð¸Ð»ÑŒ #5',0),(482650,13407,'es','Lote-Estilo #5 de Cheques Preimprimidos',0),(482651,13407,'de','Vorgedruckte Check Stock-Style #5',0),(482652,13407,'en','Preprinted Check Stock-Style #5',0),(482653,13408,'is','',0),(482654,13408,'dr','Ø¨Ø±Ø±Ø³ÛŒ preprinted Ø³Ù‡Ø§Ù… Ø³Ø¨Ú© #6',0),(482655,13408,'pr','Ø¨Ø±Ø±Ø³ÛŒ preprinted Ø³Ù‡Ø§Ù… Ø³Ø¨Ú© #6',0),(482656,13408,'tr','Ã–nceden basÄ±lmÄ±ÅŸ onay hisse senedi tarzÄ± #6',0),(482657,13408,'pl','Nadrukiem sprawdzanie zapasÃ³w stylu #6',0),(482658,13408,'bg','ÐŸÐ¾ÑÑÐ½Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð° ÑÑ‚Ð¸Ð» #6',0),(482659,13408,'ur','Ù¾Ø±ÛŒÙ¾Ø±Ø§Ù†Ù¹Ø¯ Ú†ÛŒÚ© Ø§Ø³Ù¹Ø§Ú© Ø·Ø±Ø² #6',0),(482660,13408,'sr','Ð¤Ð°Ð±Ñ€Ð¸Ñ‡ÐºÐ¸ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ñƒ ÑÑ‚Ð¸Ð»Ñƒ #6',0),(482661,13408,'vi','Preprinted phÃ²ng theo phong cÃ¡ch cá»• #6',0),(482662,13408,'af','Preprinted kontroleer voorraad-styl #6',0),(482663,13408,'ro','Selectare pre-imprimate stil stoc #6',0),(482664,13408,'et','ValmistrÃ¼kitud sisse Stock-stiil #6',0),(482665,13408,'si','Nespremenljivo Äek staleÅ¾-Style #6',0),(482666,13408,'ba','Cetakan Check saham-gaya #6',0),(482667,13408,'nl','Voorgedrukte selectievakje Stock-Style #6',0),(482668,13408,'fi','Esipainettua uloskirjautuminen Stock-tyylinen #6',0),(482669,13408,'no','Fortrykt av lager-stil #6',0),(482670,13408,'da','Fortrykt Check Stock-stil #6',0),(482671,13408,'ko','ì¸ì‡„ ëœ ìˆ˜ í‘œ ì£¼ì‹ ìŠ¤íƒ€ì¼ #6',0),(482672,13408,'he','×”×¡×™×ž×•×Ÿ ×ž×•×“×¤×¡ ×ž×¨××© ×ž×œ××™ ×‘×¡×’× ×•×Ÿ #6',0),(482673,13408,'el','Î ÏÎ¿Ï„Ï…Ï€Ï‰Î¼Î­Î½ÎµÏ‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÏƒÏ„Î¹Î» #6',0),(482674,13408,'zh','é¢„å…ˆçš„æ£€æŸ¥è‚¡ç¥¨é£Žæ ¼ #6',0),(482675,13408,'sv','FÃ¶rtryckta kontroll lager stil #6',0),(482676,13408,'it','Prestampati Check Stock-stile #6',0),(482677,13408,'tl','',0),(482678,13408,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸žà¸´à¸¡à¸žà¹Œà¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²à¸«à¸¸à¹‰à¸™à¹à¸šà¸š #6',0),(482679,13408,'hi','Preprinted à¤šà¥‡à¤• à¤¶à¥‡à¤¯à¤°-à¤¶à¥ˆà¤²à¥€ 6 #',0),(482680,13408,'ms','Pracetak semak stok-gaya #6',0),(482681,13408,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ù…Ø·Ø¨ÙˆØ¹ Ø¹Ù„Ù‰ ØºØ±Ø§Ø± Ø§Ù„Ø£Ø³Ù‡Ù… #6',0),(482682,13408,'fr','ChÃ¨que prÃ©imprimÃ© Style Stock #6',0),(482683,13408,'jp','ã‚ã‚‰ã‹ã˜ã‚ãƒã‚§ãƒƒã‚¯åœ¨åº«ã‚¹ã‚¿ã‚¤ãƒ« #6',0),(482684,13408,'pt','SeleÃ§Ã£o prÃ©-impresso estilo Stock #6',0),(482685,13408,'ru','ÐŸÐ»Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð°Ð¿Ð°ÑÐ¾Ð² ÑÑ‚Ð¸Ð»ÑŒ #6',0),(482686,13408,'es','Lote-Estilo #6 de Cheques Preimprimidos',0),(482687,13408,'de','Vorgedruckte Check Stock-Style #6',0),(482688,13408,'en','Preprinted Check Stock-Style #6',0),(482689,13409,'is','',0),(482690,13409,'dr','ØªÙ…Ø§Ù… Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ',0),(482691,13409,'pr','ØªÙ…Ø§Ù… Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ',0),(482692,13409,'tr','TÃ¼m banka hesaplarÄ±',0),(482693,13409,'pl','Wszystkie rachunki bankowe',0),(482694,13409,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(482695,13409,'ur','ØªÙ…Ø§Ù… Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(482696,13409,'sr','Ð¡Ð²Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(482697,13409,'vi','Táº¥t cáº£ cÃ¡c tÃ i khoáº£n ngÃ¢n hÃ ng',0),(482698,13409,'af','Alle Bankrekeninge',0),(482699,13409,'ro','Toate conturile bancare',0),(482700,13409,'et','KÃµik pangakontod',0),(482701,13409,'si','Vseh banÄnih raÄunov',0),(482702,13409,'ba','Semua rekening Bank',0),(482703,13409,'nl','Alle bankrekeningen',0),(482704,13409,'fi','Kaikki pankkitilit',0),(482705,13409,'no','Alle bankkonti',0),(482706,13409,'da','Alle bankkonti',0),(482707,13409,'ko','ëª¨ë“  ì€í–‰ ê³„ì¢Œ',0),(482708,13409,'he','×›×œ ×—×©×‘×•× ×•×ª ×”×‘× ×§',0),(482709,13409,'el','ÎŒÎ»Ï‰Î½ Ï„Ï‰Î½ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŽÎ½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(482710,13409,'zh','æ‰€æœ‰çš„é“¶è¡Œè´¦æˆ·',0),(482711,13409,'sv','Alla bankkonton',0),(482712,13409,'it','Tutti i conti bancari',0),(482713,13409,'tl','',0),(482714,13409,'th','à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(482715,13409,'hi','à¤¸à¤­à¥€ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‡',0),(482716,13409,'ms','Semua akaun Bank',0),(482717,13409,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(482718,13409,'fr','Tous les comptes bancaires',0),(482719,13409,'jp','ã™ã¹ã¦ã®éŠ€è¡Œå£åº§',0),(482720,13409,'pt','Todas as contas de banco',0),(482721,13409,'ru','Ð’ÑÐµ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(482722,13409,'es','Todas Las Cuentas Bancarios',0),(482723,13409,'de','Alle Bankkonten',0),(482724,13409,'en','All Bank Accounts',0),(482725,13410,'is','',0),(482726,13410,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ Ù…Ø¬Ø§Ø²',0),(482727,13410,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ Ù…Ø¬Ø§Ø²',0),(482728,13410,'tr','Banka hesaplarÄ±na girebilir',0),(482729,13410,'pl','Rachunki bankowe dozwolone',0),(482730,13410,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(482731,13410,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(482732,13410,'sr','Ð”Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(482733,13410,'vi','TÃ i khoáº£n ngÃ¢n hÃ ng Ä‘Æ°á»£c phÃ©p',0),(482734,13410,'af','Bankrekeninge Toegelaat',0),(482735,13410,'ro','Conturi bancare permis',0),(482736,13410,'et','Lubatud pangakontod',0),(482737,13410,'si','BanÄni raÄuni, dovoljeno',0),(482738,13410,'ba','Rekening bank yang diperbolehkan',0),(482739,13410,'nl','Bankrekeningen toegestaan',0),(482740,13410,'fi','Internet pankkitilit',0),(482741,13410,'no','Bankkontoer tillatt',0),(482742,13410,'da','Bankkonti tilladt',0),(482743,13410,'ko','ì€í–‰ ê³„ì¢Œë¥¼ í—ˆìš©',0),(482744,13410,'he','×—×©×‘×•× ×•×ª ×‘× ×§ ×ž×•×¨×©×”',0),(482745,13410,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Î¯ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(482746,13410,'zh','å…è®¸çš„é“¶è¡Œè´¦æˆ·',0),(482747,13410,'sv','Bankkonton som tillÃ¥tet',0),(482748,13410,'it','Conti bancari ha permessi',0),(482749,13410,'tl','',0),(482750,13410,'th','à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(482751,13410,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(482752,13410,'ms','Akaun-akaun bank yang dibenarkan',0),(482753,13410,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…ØµØ±ÙÙŠØ© Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(482754,13410,'fr','Comptes bancaires autorisÃ©s',0),(482755,13410,'jp','éŠ€è¡Œå£åº§ã®è¨±å¯',0),(482756,13410,'pt','Contas bancÃ¡rias permitidas',0),(482757,13410,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ ÑÑ‡ÐµÑ‚Ð° Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(482758,13410,'es','Cuentas Bancarias Se Permiten',0),(482759,13410,'de','Bankkonten erlaubt',0),(482760,13410,'en','Bank Accounts Allowed',0),(482761,13411,'is','',0),(482762,13411,'dr','Ù†ÙˆØ¹ ÙˆÛŒÚ˜Ù‡',0),(482763,13411,'pr','Ù†ÙˆØ¹ ÙˆÛŒÚ˜Ù‡',0),(482764,13411,'tr','Ã–zel tÃ¼r',0),(482765,13411,'pl','Typ specjalne',0),(482766,13411,'bg','Ð¢Ð¸Ð¿ Ð½Ð° ÑÐ¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸',0),(482767,13411,'ur','Ø®ØµÙˆØµÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(482768,13411,'sr','Ð’Ñ€ÑÑ‚Ñƒ ÑÐ¿ÐµÑ†Ð¸Ñ˜Ð°Ð»Ð½Ðµ',0),(482769,13411,'vi','Loáº¡i Ä‘áº·c biá»‡t',0),(482770,13411,'af','Tipe van spesiale',0),(482771,13411,'ro','Tip de speciale',0),(482772,13411,'et','Eri tÃ¼Ã¼pi',0),(482773,13411,'si','Vrsta posebnih',0),(482774,13411,'ba','Jenis khusus',0),(482775,13411,'nl','Type van speciale',0),(482776,13411,'fi','Tyyppi erityistÃ¤',0),(482777,13411,'no','Type spesielle',0),(482778,13411,'da','Type af sÃ¦rlige',0),(482779,13411,'ko','íŠ¹ë³„ í•œ ìœ í˜•',0),(482780,13411,'he','×¡×•×’ ×ž×™×•×—×“',0),(482781,13411,'el','Î¤ÏÏ€Î¿ Ï„Ï‰Î½ ÎµÎ¹Î´Î¹ÎºÏŽÎ½',0),(482782,13411,'zh','ç‰¹åˆ«çš„ç±»åž‹',0),(482783,13411,'sv','Typ av sÃ¤rskilda',0),(482784,13411,'it','Tipo di speciale',0),(482785,13411,'tl','',0),(482786,13411,'th','à¸Šà¸™à¸´à¸”à¸žà¸´à¹€à¸¨à¸©',0),(482787,13411,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(482788,13411,'ms','Jenis Khas',0),(482789,13411,'ar','Ù†ÙˆØ¹ Ù…Ù† Ø§Ù„Ø®Ø§Øµ',0),(482790,13411,'fr','Type de spÃ©ciale',0),(482791,13411,'jp','ç‰¹åˆ¥ãªã‚¿ã‚¤ãƒ—',0),(482792,13411,'pt','Tipo de especial',0),(482793,13411,'ru','Ð¢Ð¸Ð¿ Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾',0),(482794,13411,'es','Tio de Especial',0),(482795,13411,'de','Typ Spezial',0),(482796,13411,'en','Type of Special',0),(482797,13412,'is','',0),(482798,13412,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù‚ÛŒÙ…Øª Ú©ØªØ§Ø¨',0),(482799,13412,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù‚ÛŒÙ…Øª Ú©ØªØ§Ø¨',0),(482800,13412,'tr','Kitap fiyat detay',0),(482801,13412,'pl','KsiÄ…Å¼ki cena detal',0),(482802,13412,'bg','ÐšÐ½Ð¸Ð³Ð° Ñ†ÐµÐ½Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚',0),(482803,13412,'ur','Ú©ØªØ§Ø¨ Ú©ÛŒ Ù‚ÛŒÙ…Øª ØªÙØµÛŒÙ„',0),(482804,13412,'sr','ÐšÑšÐ¸Ð³Ð° Ñ†ÐµÐ½Ð° Ð´ÐµÑ‚Ð°Ñ™',0),(482805,13412,'vi','Cuá»‘n sÃ¡ch giÃ¡ chi tiáº¿t',0),(482806,13412,'af','Boek prys Detail',0),(482807,13412,'ro','Detaliu de pret carte',0),(482808,13412,'et','Raamatu hind Detail',0),(482809,13412,'si','Knjiga cena podrobnosti',0),(482810,13412,'ba','Buku Harga Detail',0),(482811,13412,'nl','Boek prijs Detail',0),(482812,13412,'fi','Kirjan hinta yksityiskohtia',0),(482813,13412,'no','Boken pris detaljer',0),(482814,13412,'da','Bog pris detaljer',0),(482815,13412,'ko','ë„ ì„œ ê°€ê²© ì„¸ë¶€ ì‚¬í•­',0),(482816,13412,'he','×¤×™×¨×•×˜ ×ž×—×™×¨ ×”×¡×¤×¨',0),(482817,13412,'el','Î’Î¹Î²Î»Î¯Î¿ Ï„Î¹Î¼Î® Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(482818,13412,'zh','æœ¬ä¹¦ä»·æ ¼çš„ç»†èŠ‚',0),(482819,13412,'sv','Bok pris detalj',0),(482820,13412,'it','Libro prezzo dettaglio',0),(482821,13412,'tl','',0),(482822,13412,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸£à¸²à¸„à¸²à¸ˆà¸­à¸‡',0),(482823,13412,'hi','à¤ªà¥à¤¸à¥à¤¤à¤• à¤®à¥‚à¤²à¥à¤¯ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(482824,13412,'ms','Detail harga buku',0),(482825,13412,'ar','ØªÙØ§ØµÙŠÙ„ Ø³Ø¹Ø± Ø§Ù„ÙƒØªØ§Ø¨',0),(482826,13412,'fr','Livre prix dÃ©tail',0),(482827,13412,'jp','æœ¬ã®ä¾¡æ ¼ã®è©³ç´°',0),(482828,13412,'pt','Detalhes de preÃ§o do livro',0),(482829,13412,'ru','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ñ†ÐµÐ½Ð° ÐºÐ½Ð¸Ð³Ð¸',0),(482830,13412,'es','Detalle de Precio de Libro',0),(482831,13412,'de','BÃ¼cher Preis Details',0),(482832,13412,'en','Book Price Detail',0),(482833,13413,'is','',0),(482834,13413,'dr','Ú©Ø´ØªÛŒ Ø¨Ø±Ø¢ÙˆØ±Ø¯',0),(482835,13413,'pr','Ú©Ø´ØªÛŒ Ø¨Ø±Ø¢ÙˆØ±Ø¯',0),(482836,13413,'tr','Tahmin edilen gemi',0),(482837,13413,'pl','Szacowany statku',0),(482838,13413,'bg','ÐžÐºÐ¾Ð»Ð¾ ÐºÐ¾Ñ€Ð°Ð±Ð°',0),(482839,13413,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¬ÛØ§Ø²',0),(482840,13413,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð±Ñ€Ð¾Ð´',0),(482841,13413,'vi','Æ¯á»›c tÃ­nh tÃ u',0),(482842,13413,'af','Geraamde skip',0),(482843,13413,'ro','EstimatÄƒ navei',0),(482844,13413,'et','Eeldatav laeva',0),(482845,13413,'si','Ocenjena ladje',0),(482846,13413,'ba','Perkiraan kapal',0),(482847,13413,'nl','Geschatte schip',0),(482848,13413,'fi','Arvioitu aluksen',0),(482849,13413,'no','AnslÃ¥tt skipet',0),(482850,13413,'da','AnslÃ¥et skib',0),(482851,13413,'ko','ì˜ˆìƒëœ ë°°',0),(482852,13413,'he','×”×¡×¤×™× ×” ×ž×©×•×¢×¨',0),(482853,13413,'el','Î•ÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Ï€Î»Î¿Î¯Î¿',0),(482854,13413,'zh','é¢„è®¡çš„å‘è´§',0),(482855,13413,'sv','BerÃ¤knad fartyg',0),(482856,13413,'it','Nave stimato',0),(482857,13413,'tl','',0),(482858,13413,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹‚à¸”à¸¢à¸›à¸£à¸°à¸¡à¸²à¸“',0),(482859,13413,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤•à¥‡ à¤…à¤¨à¥à¤¸à¤¾à¤° à¤œà¤¹à¤¾à¤œ',0),(482860,13413,'ms','Anggaran kapal',0),(482861,13413,'ar','Ø³ÙÙŠÙ†Ø© Ø§Ù„Ù…Ù‚Ø¯Ø±Ø©',0),(482862,13413,'fr','Navire estimÃ©e',0),(482863,13413,'jp','æŽ¨å®šå‡ºè·',0),(482864,13413,'pt','Navio estimado',0),(482865,13413,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ð¾Ðµ ÑÑƒÐ´Ð½Ð¾',0),(482866,13413,'es','Envio Estimado',0),(482867,13413,'de','GeschÃ¤tzte Schiff',0),(482868,13413,'en','Estimated Ship',0),(482869,13414,'is','',0),(482870,13414,'dr','Ù¾Ø§Ú©Øª Ù…Ù†Ø¸Ù…',0),(482871,13414,'pr','Ù¾Ø§Ú©Øª Ù…Ù†Ø¸Ù…',0),(482872,13414,'tr','DÃ¼zenli zarflar',0),(482873,13414,'pl','Regularne koperty',0),(482874,13414,'bg','Ð ÐµÐ´Ð¾Ð²Ð½Ð¸ Ð¿Ð»Ð¸ÐºÐ¾Ð²Ðµ',0),(482875,13414,'ur','Ø¨Ø§Ù‚Ø§Ø¹Ø¯Û Ù„ÙØ§ÙÛ’',0),(482876,13414,'sr','Ð ÐµÐ´Ð¾Ð²Ð½Ðµ ÐºÐ¾Ð²ÐµÑ€Ñ‚Ðµ',0),(482877,13414,'vi','ThÆ°á»ng xuyÃªn phong bÃ¬',0),(482878,13414,'af','Gereelde koeverte',0),(482879,13414,'ro','Regulat plicuri',0),(482880,13414,'et','Regulaarne Ã¼mbrikud',0),(482881,13414,'si','Redno ovojnice',0),(482882,13414,'ba','Amplop reguler',0),(482883,13414,'nl','Regelmatige enveloppen',0),(482884,13414,'fi','SÃ¤Ã¤nnÃ¶llinen kirjekuoret',0),(482885,13414,'no','Vanlig konvolutter',0),(482886,13414,'da','RegelmÃ¦ssig konvolutter',0),(482887,13414,'ko','ì¼ë°˜ ë´‰íˆ¬',0),(482888,13414,'he','×ž×¢×˜×¤×•×ª ×¨×’×™×œ×•×ª',0),(482889,13414,'el','Î¤Î±ÎºÏ„Î¹ÎºÎ® Ï†Î¬ÎºÎµÎ»Î¿Î¹',0),(482890,13414,'zh','å®šæœŸçš„ä¿¡å°',0),(482891,13414,'sv','Vanliga kuvert',0),(482892,13414,'it','Regolari buste',0),(482893,13414,'tl','',0),(482894,13414,'th','à¸‹à¸­à¸‡à¸ˆà¸”à¸«à¸¡à¸²à¸¢à¸›à¸à¸•à¸´',0),(482895,13414,'hi','à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤²à¤¿à¤«à¤¾à¤«à¥‡',0),(482896,13414,'ms','Sampul surat biasa',0),(482897,13414,'ar','Ù…ØºÙ„ÙØ§Øª Ø§Ù„Ø¹Ø§Ø¯ÙŠØ©',0),(482898,13414,'fr','Enveloppes ordinaires',0),(482899,13414,'jp','æ­£è¦ã®å°ç­’',0),(482900,13414,'pt','Envelopes regulares',0),(482901,13414,'ru','Ð ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ñ‹Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ñ‹',0),(482902,13414,'es','Sobres Regulares',0),(482903,13414,'de','RegelmÃ¤ÃŸige UmschlÃ¤ge',0),(482904,13414,'en','Regular Envelopes',0),(482905,13415,'is','',0),(482906,13415,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø³ØªÙˆØ± Ù…Ù‚Ø¯Ø§Ø± X / 100',0),(482907,13415,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø¯Ø³ØªÙˆØ± Ù…Ù‚Ø¯Ø§Ø± X / 100',0),(482908,13415,'tr','TutarÄ± X sipariÅŸ toplamÄ± / 100',0),(482909,13415,'pl','Suma zamÃ³wienia kwota X / 100',0),(482910,13415,'bg','Ð ÐµÐ´ Ð¿ÑŠÐ»ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€ X / 100',0),(482911,13415,'ur','Ø±Ù‚Ù… X ØªØ±ØªÛŒØ¨ Ú©Ù„ / 100',0),(482912,13415,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð° Ð¸Ð·Ð½Ð¾Ñ X / 100',0),(482913,13415,'vi','Tá»•ng sá»‘ thá»© tá»± sá»‘ lÆ°á»£ng X / 100',0),(482914,13415,'af','Bedrag X orde totaal / 100',0),(482915,13415,'ro','Total de ordine suma X / 100',0),(482916,13415,'et','Summa X jÃ¤rjekorras Kokku / 100',0),(482917,13415,'si','Znesek X skupnega zneska / 100',0),(482918,13415,'ba','Total Order jumlah X / 100',0),(482919,13415,'nl','Bedrag X Ordertotaal / 100',0),(482920,13415,'fi','MÃ¤Ã¤rÃ¤ X tilauksen summan / 100',0),(482921,13415,'no','BelÃ¸pet X bestillingstotalen / 100',0),(482922,13415,'da','MÃ¦ngden X ordretotal / 100',0),(482923,13415,'ko','ì£¼ë¬¸ í•©ê³„ ê¸ˆì•¡ X / 100',0),(482924,13415,'he','×¡×™×›×•× ×”×–×ž× ×” ×¡×›×•× X / 100',0),(482925,13415,'el','ÎŸÎ»Î¹ÎºÏŒ Ï€Î¿ÏƒÏŒ X Ï€Î¿ÏƒÏŒ / 100',0),(482926,13415,'zh','è®¢å•æ€»é‡‘é¢ X / 100',0),(482927,13415,'sv','Belopp X ordersumman / 100',0),(482928,13415,'it','Totale ordine quantitÃ  X / 100',0),(482929,13415,'tl','',0),(482930,13415,'th','à¸£à¸§à¸¡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸¢à¸­à¸” X / 100',0),(482931,13415,'hi','à¤°à¤¾à¤¶à¤¿ X à¤†à¤¦à¥‡à¤¶ à¤•à¥à¤² / 100',0),(482932,13415,'ms','Jumlah keseluruhan perintah jumlah X / 100',0),(482933,13415,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø·Ù„Ø¨ÙŠØ© Ø§Ù„Ù…Ø¨Ù„Øº Ø³/100',0),(482934,13415,'fr','Montant X Total de la commande / 100',0),(482935,13415,'jp','X ã®é‡æ³¨æ–‡åˆè¨ˆ/100',0),(482936,13415,'pt','Total de ordem quantidade X / 100',0),(482937,13415,'ru','ÐŸÑ€Ð¸ ÑÑƒÐ¼Ð¼Ðµ Ð·Ð°ÐºÐ°Ð·Ð° ÑÑƒÐ¼Ð¼Ð° X / 100',0),(482938,13415,'es','Cantidad X Total de Pedido / 100',0),(482939,13415,'de','Betrag X Gesamtbestellung / 100',0),(482940,13415,'en','Amount X Order Total / 100',0),(482941,13416,'is','',0),(482942,13416,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù‚ÛŒÙ…Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ Ø¨Ø±Ø§ÛŒ AP',0),(482943,13416,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù‚ÛŒÙ…Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ Ø¨Ø±Ø§ÛŒ AP',0),(482944,13416,'tr','PO AP iÃ§in satÄ±cÄ± FiyatlarÄ±nÄ± GÃ¼ncelleÅŸtir',0),(482945,13416,'pl','Aktualizacja cen dostawcÃ³w PO AP',0),(482946,13416,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¸ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð² PO Ð°Ð¿',0),(482947,13416,'ur','ÙˆÛŒÙ†ÚˆØ± Ù‚ÛŒÙ…ØªÙˆÚº Ù¾Ø± Ù¾Ùˆ AP Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(482948,13416,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ñ†ÐµÐ½Ðµ Ñƒ ÐŸÐž Ñƒ ÐÐŸ',0),(482949,13416,'vi','Cáº­p Nháº­t nhÃ  cung cáº¥p giÃ¡ táº¡i PO AP',0),(482950,13416,'af','GP handelaar pryse by Posbus bywerk',0),(482951,13416,'ro','ActualizaÅ£i preÅ£urile de furnizor la PO AP',0),(482952,13416,'et','Uuenda hankija hindu PO AP',0),(482953,13416,'si','Posodobitev cene dobavitelja na pad do AP',0),(482954,13416,'ba','Memperbarui Vendor harga di PO AP',0),(482955,13416,'nl','Vendor prijzen bij PO update naar AP',0),(482956,13416,'fi','PÃ¤ivitÃ¤ toimittajan hinnat ostotilauksen AP',0),(482957,13416,'no','Oppdatere leverandÃ¸rer priser pÃ¥ PO til AP',0),(482958,13416,'da','Opdatere kreditor priser pÃ¥ PO til AP',0),(482959,13416,'ko','APì— í¬ì—ì„œ ì—…ë°ì´íŠ¸ ê³µê¸‰ ì—…ì²´ ê°€ê²©',0),(482960,13416,'he','×œ×¢×“×›×Ÿ ×¡×¤×§×™× ×‘×ž×—×™×¨×™ ×¤×• AP',0),(482961,13416,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Ï„Î¹Î¼ÏŽÎ½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏƒÏ„Î¿ PO Î±Ï€',0),(482962,13416,'zh','æ›´æ–°ä¾›åº”å•†ä»·æ ¼åœ¨å¤§åŸ”åˆ° AP',0),(482963,13416,'sv','Uppdatera leverantÃ¶rens priser pÃ¥ PO AP',0),(482964,13416,'it','Aggiornare i prezzi del venditore presso PO AP',0),(482965,13416,'tl','',0),(482966,13416,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸„à¸²à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸—à¸µà¹ˆ PO AP',0),(482967,13416,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤ªà¥‹ à¤ªà¤° à¤à¤ªà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(482968,13416,'ms','Mengemaskini harga penjual PO ke AP',0),(482969,13416,'ar','ØªØ­Ø¯ÙŠØ« Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ù…ÙˆØ±Ø¯ ÙÙŠ Ø¨Ùˆ Ù„ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(482970,13416,'fr','Mise Ã  jour des prix vendeur PO Ã  AP',0),(482971,13416,'jp','AP ã« PO ã§ä»•å…¥å…ˆä¾¡æ ¼ã®æ›´æ–°',0),(482972,13416,'pt','Atualizar preÃ§os de fornecedor em PO para AP',0),(482973,13416,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð½Ð° PO Ð´Ð»Ñ AP',0),(482974,13416,'es','Actualizar Precios de Proveedores a OC a CP',0),(482975,13416,'de','Update Anbieter Preise am PO mit AP',0),(482976,13416,'en','Update Vendor Prices At PO To AP',0),(482977,13417,'is','',0),(482978,13417,'dr','Ø§Ø¹Ù„Ø§Ù† Ù¾ÛŒØ´ ÙØ±Ø¶ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù†ØªÛŒØ¬Ù‡ Ú†Ø§Ù¾ÛŒ',0),(482979,13417,'pr','Ø§Ø¹Ù„Ø§Ù† Ù¾ÛŒØ´ ÙØ±Ø¶ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù†ØªÛŒØ¬Ù‡ Ú†Ø§Ù¾ÛŒ',0),(482980,13417,'tr','VarsayÄ±lan teklif Ã§Ä±ktÄ± Not',0),(482981,13417,'pl','Uwaga DomyÅ›lnie cytat wydruk',0),(482982,13417,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ„ÐµÑ€Ñ‚Ð° Ñ€Ð°Ð·Ð¿ÐµÑ‡Ð°Ñ‚ÐºÐ° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(482983,13417,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ù‚ØªØ¨Ø§Ø³ Ù…Ø·Ø¨ÙˆØ¹Û Ù†ÙˆÙ¹',0),(482984,13417,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¿Ð¾Ð½ÑƒÐ´Ðµ ÐŸÑ€Ð¸Ð½Ñ‚Ð¾ÑƒÑ‚ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(482985,13417,'vi','Máº·c Ä‘á»‹nh bÃ¡o Printout lÆ°u Ã½',0),(482986,13417,'af','Verstek kwotasie uitdruk Nota',0),(482987,13417,'ro','NotÄƒ de imprimare implicit citat',0),(482988,13417,'et','Pakkumise vÃ¤ljaprindi vaikemÃ¤rkused',0),(482989,13417,'si','Privzeto ponudbo izpisa Opomba',0),(482990,13417,'ba','Standar Penawaran Printout catatan',0),(482991,13417,'nl','Standaard offerte afdruk Opmerking',0),(482992,13417,'fi','Oletuksena lainaus tulosteen Huomautus',0),(482993,13417,'no','Standardmerknader tilbud utskrift',0),(482994,13417,'da','Standard citat udskrift BemÃ¦rk',0),(482995,13417,'ko','ê¸°ë³¸ ê²¬ì  ì¸ì‡„ ì°¸ê³ ',0),(482996,13417,'he','×ž×—×“×œ ×œ×”×¦×¢×ª ×ž×—×™×¨ ×”×ª×“×¤×™×¡ ×”×¢×¨×”',0),(482997,13417,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(482998,13417,'zh','é»˜è®¤æŠ¥ä»·æ‰“å°æ³¨é‡Š',0),(482999,13417,'sv','Standard citat utskriften Obs',0),(483000,13417,'it','Nota di stampa predefinito citazione',0),(483001,13417,'tl','',0),(483002,13417,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(483003,13417,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¬à¥‹à¤²à¥€ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿà¤†à¤‰à¤Ÿ à¤¨à¥‹à¤Ÿ',0),(483004,13417,'ms','Lalai Quote cetakan Nota',0),(483005,13417,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„Ù†Ø³Ø®Ø© Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(483006,13417,'fr','Par dÃ©faut devis imprimÃ© Note',0),(483007,13417,'jp','å¼•ç”¨å°åˆ·ã®æ—¢å®šã®æ³¨è¨˜',0),(483008,13417,'pt','Nota de impressÃ£o padrÃ£o citaÃ§Ã£o',0),(483009,13417,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð° Ñ€Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚ÐºÑƒ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(483010,13417,'es','Nota de ImpresiÃ³n de la CotizaciÃ³n Predeterminado',0),(483011,13417,'de','Standard Angebot Ausdruck Hinweis',0),(483012,13417,'en','Default Quote Printout Note',0),(483013,13418,'is','',0),(483014,13418,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø®Ø· Ù…ÙˆØ±Ø¯ ØªÙˆØªØ§Ù„ Ø¯Ø± Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(483015,13418,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø®Ø· Ù…ÙˆØ±Ø¯ ØªÙˆØªØ§Ù„ Ø¯Ø± Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(483016,13418,'tr','SatÄ±r Ã¶ÄŸesi toplamÄ± esas tÄ±rnak iÅŸaretleri Gizle',0),(483017,13418,'pl','Ukrywanie pozycji w sumie na Cytaty',0),(483018,13418,'bg','Ð¡ÐºÑ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´ Ð¾Ð±Ñ‰Ð¾ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(483019,13418,'ur','Ù„Ø§Ø¦Ù† Ø´Û’ Ú©ÛŒ Ú©Ù„ Ù‚ÛŒÙ…Øª Ù¾Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(483020,13418,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð° ÑƒÐºÑƒÐ¿Ð½Ð¾ Ð½Ð° Ð¿Ð¾Ð½ÑƒÐ´Ð°Ð¼Ð°',0),(483021,13418,'vi','áº¨n táº¥t cáº£ chi tiáº¿t Ä‘Æ¡n hÃ ng ngÃ y bÃ¡o giÃ¡',0),(483022,13418,'af','Versteek lynitem totaal op aanhalings',0),(483023,13418,'ro','Ascunde element rÃ¢nd Total pe citate',0),(483024,13418,'et','Peida reaÃ¼ksuste kogusumma hinnapakkumisi',0),(483025,13418,'si','Skrij vrstiÄne postavke skupaj v ponudbah',0),(483026,13418,'ba','Sembunyikan Item baris Total pada kutipan',0),(483027,13418,'nl','Verbergen regelitem totaal van citaten',0),(483028,13418,'fi','Piilota rivinimikkeiden kokonaissummaa lainauksia',0),(483029,13418,'no','Skjule linjeelementet Totalt pÃ¥ sitater',0),(483030,13418,'da','Skjule linjeelement Total pÃ¥ citater',0),(483031,13418,'ko','ë”°ì˜´í‘œì—ì„œ ì¤„ í•­ëª© í•©ê³„ë¥¼ ìˆ¨ê¸°ê¸°',0),(483032,13418,'he','×”×¡×ª×¨×ª ×¤×¨×™×˜ ×”×©×•×¨×” ×¡×š ×”×›×œ ×¢×œ ×¦×™×˜×•×˜×™×',0),(483033,13418,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ…Î½ÏŒÎ»Î¿Ï… ÏƒÎµ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(483034,13418,'zh','éšè—æŠ¥ä»·è¡Œé¡¹ç›®æ€»è®¡',0),(483035,13418,'sv','DÃ¶lja radelement totalt pÃ¥ citat',0),(483036,13418,'it','Nascondere la voce riga totale su quotazioni',0),(483037,13418,'tl','',0),(483038,13418,'th','à¸‹à¹ˆà¸­à¸™à¸œà¸¥à¸£à¸§à¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(483039,13418,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£ à¤ªà¤° à¤•à¥à¤² à¤°à¥‡à¤–à¤¾ à¤†à¤‡à¤Ÿà¤® à¤›à¥à¤ªà¤¾à¤à¤',0),(483040,13418,'ms','Sembunyi Item garis jumlah pada sebut harga',0),(483041,13418,'ar','Ø¥Ø®ÙØ§Ø¡ Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø¨Ù†Ø¯ Ø¹Ù„Ù‰ Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(483042,13418,'fr','Masquer la ligne Total sur devis',0),(483043,13418,'jp','å¼•ç”¨ç¬¦ã®è¡Œã‚¢ã‚¤ãƒ†ãƒ åˆè¨ˆã®éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(483044,13418,'pt','Esconder Total de Item de linha em citaÃ§Ãµes',0),(483045,13418,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð²ÑÐµÐ³Ð¾ Ð½Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(483046,13418,'es','Esconde Total de Items de linea en las Cotizaciones',0),(483047,13418,'de','Posten Total auf Zitate ausblenden',0),(483048,13418,'en','Hide Line Item Total On Quotes',0),(483049,13419,'is','',0),(483050,13419,'dr','Ø¯Ø±ØµØ¯ Ø¶Ø§ÛŒØ¹Ø§Øª Ù¾ÙˆØ´Ø´',0),(483051,13419,'pr','Ø¯Ø±ØµØ¯ Ø¶Ø§ÛŒØ¹Ø§Øª Ù¾ÙˆØ´Ø´',0),(483052,13419,'tr','Hurda yÃ¼zdesini karÅŸÄ±lamak',0),(483053,13419,'pl','Pokrycie procent odpadkÃ³w',0),(483054,13419,'bg','ÐŸÐ¾ÐºÑ€Ð¸Ð²Ð°Ñ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð±Ñ€Ð°Ðº',0),(483055,13419,'ur','Ø³Ú©Ø±ÛŒÙ¾ ÙÛŒØµØ¯ Ú©Ø§ Ø§Ø­Ø§Ø·Û',0),(483056,13419,'sr','ÐŸÐ¾ÐºÑ€Ð¸Ñ˜ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ ÑˆÐºÐ°Ñ€Ñ‚Ð°',0),(483057,13419,'vi','Bao gá»“m pháº§n trÄƒm pháº¿ liá»‡u',0),(483058,13419,'af','Bedek knipsel persent',0),(483059,13419,'ro','Acoperi resturi la sutÄƒ',0),(483060,13419,'et','Kate Praagi protsent',0),(483061,13419,'si','Odstotek izmeta kritje',0),(483062,13419,'ba','Penutup Scrap persen',0),(483063,13419,'nl','Uitval % dekking',0),(483064,13419,'fi','Kansi hukkaprosentti',0),(483065,13419,'no','Dekke svinnprosenten',0),(483066,13419,'da','DÃ¦kke spildprocent',0),(483067,13419,'ko','ìŠ¤í¬ëž© % ì»¤ë²„',0),(483068,13419,'he','××—×•×– ×’×¨×˜ ×›×™×¡×•×™',0),(483069,13419,'el','ÎšÎ±Î»ÏÏ€Ï„ÎµÎ¹ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï†ÏÏÎ±Ï‚',0),(483070,13419,'zh','è¦†ç›–åºŸ %',0),(483071,13419,'sv','TÃ¤cka kassationsprocenten',0),(483072,13419,'it','Coprire la percentuale di scarti',0),(483073,13419,'tl','',0),(483074,13419,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¹€à¸¨à¸©à¸‹à¸²à¸à¸›à¸°',0),(483075,13419,'hi','à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¥‹ à¤•à¤µà¤°',0),(483076,13419,'ms','Perlindungan sekerap peratus',0),(483077,13419,'ar','ØªØºØ·ÙŠØ© Ø§Ù„Ø®Ø±Ø¯Ø© Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(483078,13419,'fr','Pourcentage de rebut de couverture',0),(483079,13419,'jp','ã‚¹ã‚¯ãƒ©ãƒƒãƒ— ï¼… ã‚’ã‚«ãƒãƒ¼ã—ã¾ã™ã€‚',0),(483080,13419,'pt','Cobrir por cento sucata',0),(483081,13419,'ru','ÐžÐ±Ð»Ð¾Ð¶ÐºÐ° % Ð»Ð¾Ð¼Ð°',0),(483082,13419,'es','Porcentaje de Escombro de CarÃ¡tula',0),(483083,13419,'de','Abdeckung Schrott Prozent',0),(483084,13419,'en','Cover Scrap Percent',0),(483085,13420,'is','',0),(483086,13420,'dr','Ø¶Ø§ÛŒØ¹Ø§Øª ÙˆØ±Ù‚ Ø­Ø¯Ø§Ú©Ø«Ø± Ù¾ÙˆØ´Ø´',0),(483087,13420,'pr','Ø¶Ø§ÛŒØ¹Ø§Øª ÙˆØ±Ù‚ Ø­Ø¯Ø§Ú©Ø«Ø± Ù¾ÙˆØ´Ø´',0),(483088,13420,'tr','Max Ã§arÅŸaf kapak hurda',0),(483089,13420,'pl','Max arkuszy zÅ‚om okÅ‚adka',0),(483090,13420,'bg','ÐœÐ°ÐºÑ Ð»Ð¸ÑÑ‚Ð¾Ð²Ðµ ÑÐºÑ€Ð°Ð¿ ÐºÐ¾Ñ€Ð¸Ñ†Ð°',0),(483091,13420,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø§ÙˆØ±Ø§Ù‚ Ú©ÙˆØ± Ø®ØªÙ…',0),(483092,13420,'sr','ÐœÐ°x Ð»Ð¸ÑÑ‚Ð¾Ð²Ðµ ÑƒÐºÐ¸Ð½Ðµ Ð·Ð°ÐºÐ»Ð¾Ð½',0),(483093,13420,'vi','Pháº¿ liá»‡u tá»‘i Ä‘a tá» bÃ¬a',0),(483094,13420,'af','Max velle afval bedek',0),(483095,13420,'ro','Resturi de foi de Max Cover',0),(483096,13420,'et','Max lehed puru katte',0),(483097,13420,'si','Max listov ostanki kritje',0),(483098,13420,'ba','Max lembar memo Cover',0),(483099,13420,'nl','Max bladen schroot Cover',0),(483100,13420,'fi','Max levyt romu kansi',0),(483101,13420,'no','Max ark skrap Cover',0),(483102,13420,'da','Max ark skrot Cover',0),(483103,13420,'ko','ìµœëŒ€ ì‹œíŠ¸ ì»¤ë²„ ìŠ¤í¬ëž©',0),(483104,13420,'he','×ž×§×¡ ×’×œ×™×•× ×•×ª ×œ×’× ×•×– ××ª ×”×›×™×¡×•×™',0),(483105,13420,'el','Max Ï†ÏÎ»Î»Î± Î¸ÏÎ±ÏÏƒÎ¼Î±Ï„Î± ÎºÎ¬Î»Ï…ÏˆÎ·',0),(483106,13420,'zh','æœ€å¤§åºŠå•åºŸæ–™ç›–',0),(483107,13420,'sv','Max ark skrot Cover',0),(483108,13420,'it','Max fogli rottami di copertura',0),(483109,13420,'tl','',0),(483110,13420,'th','à¹à¸œà¹ˆà¸™à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¹€à¸ªà¸µà¸¢à¸›à¸°',0),(483111,13420,'hi','à¤†à¤µà¤°à¤£ à¤®à¥ˆà¤•à¥à¤¸ à¤¶à¥€à¤Ÿ à¤¸à¥à¤•à¥à¤°à¥ˆà¤ª',0),(483112,13420,'ms','Cadar-cadar Max membatalkan perlindungan',0),(483113,13420,'ar','Ø±ÙƒØ§Ù… Ø£ÙˆØ±Ø§Ù‚ Ù…Ø§ÙƒØ³ Ø§Ù„ØºØ·Ø§Ø¡',0),(483114,13420,'fr','Max feuilles Scrap couverture',0),(483115,13420,'jp','æœ€å¤§ã‚·ãƒ¼ãƒˆ ã‚«ãƒãƒ¼ã‚’ã‚¹ã‚¯ãƒ©ãƒƒãƒ—ã—ã¾ã™ã€‚',0),(483116,13420,'pt','Max folhas sucata capa',0),(483117,13420,'ru','ÐœÐ°ÐºÑ Ð»Ð¸ÑÑ‚Ñ‹ Ð»Ð¾Ð¼ ÐžÐ±Ð»Ð¾Ð¶ÐºÐ°',0),(483118,13420,'es','Max Hojas Tapa de Segundos',0),(483119,13420,'de','Max BlÃ¤tter Schrott Cover',0),(483120,13420,'en','Max Sheets Scrap Cover',0),(483121,13421,'is','',0),(483122,13421,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨Ø±Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(483123,13421,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨Ø±Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(483124,13421,'tr','GÃ¼ncelleÅŸtirmeleri denetlemek iÃ§in',0),(483125,13421,'pl','SprawdÅº Aktualizacje',0),(483126,13421,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(483127,13421,'ur','Ù¾Ú‘ØªØ§Ù„ Ø¨Ø±Ø§Ø¦Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒØ§Úº',0),(483128,13421,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð° Ð»Ð¸',0),(483129,13421,'vi','Kiá»ƒm tra Cáº­p Nháº­t',0),(483130,13421,'af','Kontroleer vir Opdaterings',0),(483131,13421,'ro','A verifica pentru Updates',0),(483132,13421,'et','VÃ¤rskenduste vaatamine',0),(483133,13421,'si','Preveri za posodobitve',0),(483134,13421,'ba','Memeriksa pembaruan',0),(483135,13421,'nl','Controleren op Updates',0),(483136,13421,'fi','Tarkista pÃ¤ivitykset',0),(483137,13421,'no','Se etter oppdateringer',0),(483138,13421,'da','Check For opdateringer',0),(483139,13421,'ko','ì—…ë°ì´íŠ¸ í™•ì¸',0),(483140,13421,'he','×‘×“×•×§ ×× ×§×™×™×ž×™× ×¢×“×›×•× ×™×',0),(483141,13421,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ Î³Î¹Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹Ï‚',0),(483142,13421,'zh','æ£€æŸ¥æœ‰æ›´æ–°',0),(483143,13421,'sv','SÃ¶k efter uppdateringar',0),(483144,13421,'it','Controlla aggiornamenti',0),(483145,13421,'tl','',0),(483146,13421,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(483147,13421,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(483148,13421,'ms','Semak untuk pengemaskinian',0),(483149,13421,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† ÙˆØ¬ÙˆØ¯ ØªØ­Ø¯ÙŠØ«Ø§Øª',0),(483150,13421,'fr','Mises Ã  jour',0),(483151,13421,'jp','æ›´æ–°ãƒ—ãƒ­ã‚°ãƒ©ãƒ ã®ç¢ºèª',0),(483152,13421,'pt','Verificar se hÃ¡ atualizaÃ§Ãµes',0),(483153,13421,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð½Ð°Ð»Ð¸Ñ‡Ð¸Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¹',0),(483154,13421,'es','Comprobar Actualizaciones',0),(483155,13421,'de','Nach Updates suchen',0),(483156,13421,'en','Check For Updates',0),(483157,13422,'is','',0),(483158,13422,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(483159,13422,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(483160,13422,'tr','Fatura gÃ¶rÃ¼ntÃ¼leme',0),(483161,13422,'pl','Zobacz projekt ustawy',0),(483162,13422,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð±Ð¸Ð»',0),(483163,13422,'ur','Ø¨Ù„ Ú©Û’ Ù…Ù†Ø¸Ø±',0),(483164,13422,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð‘Ð¸Ð»',0),(483165,13422,'vi','Xem hÃ³a Ä‘Æ¡n',0),(483166,13422,'af','Wetsontwerp bekyk',0),(483167,13422,'ro','Vezi Bill',0),(483168,13422,'et','Saate vaadata arve',0),(483169,13422,'si','Bill pogled',0),(483170,13422,'ba','Lihat Bill',0),(483171,13422,'nl','Bill bekijken',0),(483172,13422,'fi','View Bill Katso Bill',0),(483173,13422,'no','Vis faktura',0),(483174,13422,'da','Se Bill',0),(483175,13422,'ko','ë·° ë¹Œ',0),(483176,13422,'he','×”×¦×’ ××ª ×‘×™×œ',0),(483177,13422,'el','Î”ÎµÎ¯Ï„Îµ Ï„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(483178,13422,'zh','æŸ¥çœ‹æ¡ä¾‹è‰æ¡ˆ',0),(483179,13422,'sv','Visa Bill',0),(483180,13422,'it','Mostra Bill',0),(483181,13422,'tl','',0),(483182,13422,'th','à¸”à¸¹à¸ªà¸¹à¸•à¸£',0),(483183,13422,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤µà¤¿à¤§à¥‡à¤¯à¤•',0),(483184,13422,'ms','Melihat Rang undang-undang',0),(483185,13422,'ar','Ø¹Ø±Ø¶ Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ†',0),(483186,13422,'fr','Voir facture',0),(483187,13422,'jp','æ³•æ¡ˆã‚’è¦‹ã‚‹',0),(483188,13422,'pt','Ver conta',0),(483189,13422,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÑ‡ÐµÑ‚Ð°',0),(483190,13422,'es','Visualizar la Factura',0),(483191,13422,'de','Bill anzeigen',0),(483192,13422,'en','View Bill',0),(483193,13423,'is','',0),(483194,13423,'dr','ØªØ§Ø±ÛŒØ®Ú†Ù‡ ÙØ¹Ø§Ù„ÛŒØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(483195,13423,'pr','ØªØ§Ø±ÛŒØ®Ú†Ù‡ ÙØ¹Ø§Ù„ÛŒØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(483196,13423,'tr','SatÄ±cÄ± aktivite geÃ§miÅŸ',0),(483197,13423,'pl','Historia dziaÅ‚alnoÅ›ci dostawcy',0),(483198,13423,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°',0),(483199,13423,'ur','ÙˆÛŒÙ†ÚˆØ± Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(483200,13423,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(483201,13423,'vi','Lá»‹ch sá»­ hoáº¡t Ä‘á»™ng cá»§a nhÃ  cung cáº¥p',0),(483202,13423,'af','Handelaar aktiwiteit geskiedenis',0),(483203,13423,'ro','Istoria de activitate furnizor',0),(483204,13423,'et','Hankija tegevuse ajalugu',0),(483205,13423,'si','Prodajalec marljivost zgodovina',0),(483206,13423,'ba','Penjual aktivitas sejarah',0),(483207,13423,'nl','Leverancier activiteitsgeschiedenis',0),(483208,13423,'fi','Toimittajan aktiivisuus historia',0),(483209,13423,'no','LeverandÃ¸ren aktivitetslogg',0),(483210,13423,'da','Kreditor aktivitet historie',0),(483211,13423,'ko','ê³µê¸‰ ì—…ì²´ í™œë™ ì—­ì‚¬',0),(483212,13423,'he','×”×™×¡×˜×•×¨×™×ª ×¤×¢×™×œ×•×ª ×”×¡×¤×§',0),(483213,13423,'el','Î”ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î¹ÏƒÏ„Î¿ÏÎ¯Î±Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(483214,13423,'zh','ä¾›åº”å•†æ´»åŠ¨åŽ†å²è®°å½•',0),(483215,13423,'sv','LeverantÃ¶rens verksamhet historia',0),(483216,13423,'it','Fornitore storico attivitÃ ',0),(483217,13423,'tl','',0),(483218,13423,'th','à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(483219,13423,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(483220,13423,'ms','Sejarah aktiviti penjual.',0),(483221,13423,'ar','ØªØ§Ø±ÙŠØ® Ù†Ø´Ø§Ø· Ø§Ù„Ù…ÙˆØ±Ø¯',0),(483222,13423,'fr','Historique des activitÃ©s du vendeur',0),(483223,13423,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®æ´»å‹•ã®æ­´å²',0),(483224,13423,'pt','HistÃ³rico de atividades do fornecedor',0),(483225,13423,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(483226,13423,'es','Actividad Historico de Proveedores',0),(483227,13423,'de','Hersteller, AktivitÃ¤tsverlauf',0),(483228,13423,'en','Vendor Activity History',0),(483229,13424,'is','',0),(483230,13424,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ù…ÙˆØ¬ÙˆØ¯',0),(483231,13424,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ù…ÙˆØ¬ÙˆØ¯',0),(483232,13424,'tr','Mevcut fatura gizle',0),(483233,13424,'pl','Ukrywanie istniejÄ…cych fakturach',0),(483234,13424,'bg','Ð¡ÐºÑ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(483235,13424,'ur','Ù…ÙˆØ¬ÙˆØ¯Û ÙˆØ¨Ø¬Ù„ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(483236,13424,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(483237,13424,'vi','áº¨n hiá»‡n cÃ³ hoÃ¡ Ä‘Æ¡n',0),(483238,13424,'af','Bestaande fakture versteek',0),(483239,13424,'ro','Ascunde existente facturi',0),(483240,13424,'et','Peida olemasolevate arved',0),(483241,13424,'si','Skrij obstojeÄih raÄunov',0),(483242,13424,'ba','Menyembunyikan faktur yang ada',0),(483243,13424,'nl','Bestaande facturen verbergen',0),(483244,13424,'fi','Piilota aiemmin luoduissa laskuissa',0),(483245,13424,'no','Skjule eksisterende fakturaer',0),(483246,13424,'da','Skjule eksisterende fakturaer',0),(483247,13424,'ko','ê¸°ì¡´ ì²­êµ¬ì„œë¥¼ ìˆ¨ê¸°ê¸°',0),(483248,13424,'he','×œ×”×¡×ª×™×¨ ××ª ×”×—×©×‘×•× ×™×•×ª ×”×§×™×™×ž×•×ª',0),(483249,13424,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Ï…Ï†Î¹ÏƒÏ„Î±Î¼Î­Î½Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(483250,13424,'zh','éšè—çŽ°æœ‰å‘ç¥¨',0),(483251,13424,'sv','DÃ¶lja befintliga fakturor',0),(483252,13424,'it','Nascondere fatture esistenti',0),(483253,13424,'tl','',0),(483254,13424,'th','à¸‹à¹ˆà¸­à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(483255,13424,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤šà¤¾à¤²à¤¾à¤¨ à¤›à¥à¤ªà¤¾à¤à¤',0),(483256,13424,'ms','Sembunyi invois yang sedia ada',0),(483257,13424,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(483258,13424,'fr','Cacher des factures existantes',0),(483259,13424,'jp','æ—¢å­˜ã®è«‹æ±‚æ›¸ã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(483260,13424,'pt','Esconder facturas existentes',0),(483261,13424,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(483262,13424,'es','Esconde Facturas Existentes',0),(483263,13424,'de','Ausblenden der vorhandene Rechnungen',0),(483264,13424,'en','Hide Existing Invoices',0),(483265,13425,'is','',0),(483266,13425,'dr','ÙÙ‚Ø· Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§Ú©ØªÙˆØ± ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ø§Ø¹ØªØ¨Ø§Ø± Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯',0),(483267,13425,'pr','ÙÙ‚Ø· Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§Ú©ØªÙˆØ± ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ø§Ø¹ØªØ¨Ø§Ø± Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯',0),(483268,13425,'tr','Sadece Ã¶denen faturalar-ebilmek-si olmak bir iade faturasÄ± oluÅŸturuldu',0),(483269,13425,'pl','Tylko pÅ‚atne faktury moÅ¼e mieÄ‡ utworzona faktura korygujÄ…ca',0),(483270,13425,'bg','Ð¡Ð°Ð¼Ð¾ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð¼Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(483271,13425,'ur','ØµØ±Ù ØªÙ†Ø®ÙˆØ§Û ÙˆØ¨Ø¬Ù„ÛŒ Ø§ÛŒÚ© Ú©Ø±ÛŒÚˆÙ¹ Ù…ÛŒÙ…Ùˆ Ù¾ÛŒØ¯Ø§ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(483272,13425,'sr','Ð¡Ð°Ð¼Ð¾ Ð¿Ð»Ð°Ñ›ÐµÐ½Ð¸Ñ… Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¼Ð¾Ð¶Ðµ Ð¸Ð¼Ð°Ñ‚Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½',0),(483273,13425,'vi','Chá»‰ tráº£ tiá»n hÃ³a Ä‘Æ¡n cÃ³ thá»ƒ cÃ³ má»™t Memo tÃ­n dá»¥ng táº¡o',0),(483274,13425,'af','Slegs betaalde fakture kan \'n krediet Memo geskep het',0),(483275,13425,'ro','Doar plÄƒtit facturile pot avea o notÄƒ de Credit create',0),(483276,13425,'et','Ainult tasutud arved vÃµivad olla loodud kreeditarve',0),(483277,13425,'si','Lahko le plaÄani raÄuni so ustvarili dobropis',0),(483278,13425,'ba','Hanya dibayar faktur dapat memiliki sebuah Memo kredit yang dibuat',0),(483279,13425,'nl','Alleen betaalde facturen kunnen hebben een creditnota hebt gemaakt',0),(483280,13425,'fi','Vain maksetut laskut voi olla hyvityslasku luotiin',0),(483281,13425,'no','Bare betalte fakturaer kan ha en kreditnota opprettet',0),(483282,13425,'da','Kun betalte fakturaer kan Have en kreditnota, der er oprettet',0),(483283,13425,'ko','ì§€ë¶ˆëœ ì²­êµ¬ì„œë§Œ ë§Œë“  ì‹ ìš© ë©”ëª¨ë¥¼ ê°€ì§ˆ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(483284,13425,'he','×¨×§ ×‘×ª×©×œ×•× ×—×©×‘×•× ×™×•×ª ×™×›×•×œ ×œ×§×‘×œ ×ª×–×›×™×¨ ××©×¨××™ ×©× ×•×¦×¨×•',0),(483285,13425,'el','ÎœÏŒÎ½Î¿ ÎµÏ€Î¯ Ï€Î»Î·ÏÏ‰Î¼Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î­Ï‡ÎµÎ¹ Î­Î½Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ',0),(483286,13425,'zh','å·²ä»˜çš„å‘ç¥¨ä»…èƒ½åˆ›å»ºè´·æ–¹é€šçŸ¥å•',0),(483287,13425,'sv','Endast betalda fakturor kan ha en kreditnota skapas',0),(483288,13425,'it','Solo le fatture pagate possono avere creata una nota di credito',0),(483289,13425,'tl','',0),(483290,13425,'th','à¹€à¸žà¸µà¸¢à¸‡à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹„à¸”à¹‰à¸ªà¸£à¹‰à¸²à¸‡à¸«à¸™à¸µà¹‰',0),(483291,13425,'hi','à¤•à¥‡à¤µà¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤šà¤¾à¤²à¤¾à¤¨ à¤à¤• à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤¹à¥ˆ à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(483292,13425,'ms','Hanya bayar invois boleh Memo kredit yang dicipta',0),(483293,13425,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© ÙÙ‚Ø· ÙŠÙ…ÙƒÙ† Ø£Ù† ÙŠÙƒÙˆÙ† Ù…Ø°ÙƒØ±Ø© Ø§Ø¦ØªÙ…Ø§Ù† ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§',0),(483294,13425,'fr','Seules les factures payÃ©es peuvent avoir un avoir crÃ©Ã©',0),(483295,13425,'jp','æœ‰æ–™ã®è«‹æ±‚æ›¸ã¯ä½œæˆã•ã‚ŒãŸã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã®ãƒ¡ãƒ¢åž‹ã‚’æŒã¤ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(483296,13425,'pt','Apenas facturas pagas podem ter criada uma nota de crÃ©dito',0),(483297,13425,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð° Ð¼Ð¾Ð³ÑƒÑ‚ Ð¸Ð¼ÐµÑ‚ÑŒ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚Ñ‹ ÑÐ¾Ð·Ð´Ð°Ð½Ñ‹',0),(483298,13425,'es','Solo Facturas Pagadas Se Puede Tener Un Memo de CrÃ©dito Creado',0),(483299,13425,'de','Nur bezahlte Rechnungen kÃ¶nnen eine Gutschrift erstellt haben.',0),(483300,13425,'en','Only Paid Invoices Can Have A Credit Memo Created',0),(483301,13426,'is','',0),(483302,13426,'dr','ÙØ§Ú©ØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ unpost Ùˆ Ø­Ø°Ù ÙØ§Ú©ØªÙˆØ± Ù¾Ø³ Ø§Ø² Ú©Ù„ÛŒÚ© Ø±ÙˆÛŒ Ø¯Ú©Ù…Ù‡ ÙˆÛŒØ±Ø§ÛŒØ´ Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ø²Ú¯Ø´Øª Ø³Ù‡Ø§Ù….',0),(483303,13426,'pr','ÙØ§Ú©ØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡ unpost Ùˆ Ø­Ø°Ù ÙØ§Ú©ØªÙˆØ± Ù¾Ø³ Ø§Ø² Ú©Ù„ÛŒÚ© Ø±ÙˆÛŒ Ø¯Ú©Ù…Ù‡ ÙˆÛŒØ±Ø§ÛŒØ´ Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ø²Ú¯Ø´Øª Ø³Ù‡Ø§Ù….',0),(483304,13426,'tr','Ã–denmemiÅŸ faturalar unpost ve fatura DÃ¼zenle dÃ¼ÄŸmesini tÄ±klattÄ±ktan sonra silmek iÃ§in hisse senedi dÃ¶nmek iÃ§in.',0),(483305,13426,'pl','Do zwrotu akcji za NiezapÅ‚acone faktury unpost i UsuÅ„ fakturÄ™ po klikniÄ™ciu przycisku Edytuj.',0),(483306,13426,'bg','Ð—Ð° Ð´Ð° ÑÐµ Ð²ÑŠÑ€Ð½ÐµÑ‚Ðµ ÑÑŠÑÑ‚Ð°Ð² Ð·Ð° Ð½ÐµÐ¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ unpost Ð¸ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÑÐ»ÐµÐ´ ÐºÐ°Ñ‚Ð¾ Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð±ÑƒÑ‚Ð¾Ð½Ð° Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ.',0),(483307,13426,'ur','Ø¨Ù„Ø§ Ù…Ø¹Ø§ÙˆØ¶Û ÙˆØ¨Ø¬Ù„ÛŒ Ø§Ù†Ù¾ÙˆØ³Ù¹ Ø§ÙˆØ± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ ØªØ¯ÙˆÛŒÙ† Ø¨Ù¹Ù† Ù¾Ø± Ú©Ù„Ú© Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ø¹Ø¯ Ø­Ø°Ù Ø§Ø³Ù¹Ø§Ú© ÙˆØ§Ù¾Ø³ Ø¬Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Û”',0),(483308,13426,'sr','Ð”Ð° ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¼ Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð° Ð½ÐµÐ¿Ð»Ð°Ñ›ÐµÐ½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¿Ð¾Ð²ÑƒÐ¸Ðµ Ð¸ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð½Ð°ÐºÐ¾Ð½ ÑˆÑ‚Ð¾ ÐºÐ»Ð¸ÐºÐ½ÐµÑ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð£Ñ€ÐµÐ´Ð¸.',0),(483309,13426,'vi','Äá»ƒ trá»Ÿ vá» chá»©ng khoÃ¡n cho cÃ¡c hoÃ¡ Ä‘Æ¡n chÆ°a thanh toÃ¡n unpost vÃ  xÃ³a hoÃ¡ Ä‘Æ¡n sau khi nháº¥p vÃ o nÃºt chá»‰nh sá»­a.',0),(483310,13426,'af','Terugkeer voorraad vir onbetaalde fakture unpost en skrap die faktuur na die redigeer-knoppie te klik.',0),(483311,13426,'ro','Pentru a reveni stoc pentru facturi neplÄƒtite unpost ÅŸi ÅŸterge facturÄƒ dupÄƒ fÄƒcÃ¢nd clic pe butonul Editare.',0),(483312,13426,'et','Tagasi laos maksmata arvete unpost ja pÃ¤rast nupu Edit arve kustutada.',0),(483313,13426,'si','Vrniti zalog za neplaÄani raÄuni unpost in izbrisati raÄun po kliku na gumb Uredi.',0),(483314,13426,'ba','Untuk kembali saham untuk faktur belum dibayar unpost dan menghapus faktur setelah mengklik tombol Edit.',0),(483315,13426,'nl','Om terug te keren voorraad voor onbetaalde facturen unpost en de factuur verwijderen na het klikken op de knop bewerken.',0),(483316,13426,'fi','Palata varastossa maksamattomien laskujen unpost ja poistaa laskun jÃ¤lkeen napsauttamalla Muokkaa-painiketta.',0),(483317,13426,'no','Returnere lager for ubetalte fakturaer unpost og slette fakturaen etter klikke Rediger.',0),(483318,13426,'da','Til gengÃ¦ld lager for ubetalte fakturaer unpost og slette fakturaen nÃ¥r du klikker pÃ¥ knappen Rediger.',0),(483319,13426,'ko','ë¯¸ë‚©ëœ ì²­êµ¬ì„œ unpost ë° íŽ¸ì§‘ ë‹¨ì¶”ë¥¼ í´ë¦­ í•œ í›„ ì²­êµ¬ì„œë¥¼ ì‚­ì œì— ëŒ€ í•œ ì£¼ì‹ì„ ë°˜í™˜.',0),(483320,13426,'he','×›×“×™ ×œ×”×—×–×™×¨ ××ª ×”×ž× ×™×•×ª ×¢×‘×•×¨ ×—×©×‘×•× ×™×•×ª ×©×œ× ×©×•×œ×ž×• unpost ×•×œ×ž×—×•×§ ××ª ×”×—×©×‘×•× ×™×ª ×œ××—×¨ ×œ×—×™×¦×” ×¢×œ ×”×œ×—×¦×Ÿ \' ×¢×¨×™×›×” \'.',0),(483321,13426,'el','ÎÎ± ÎµÏ€Î¹ÏƒÏ„ÏÎ­ÏˆÎµÎ¹ Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î³Î¹Î± Î±Ï€Î»Î®ÏÏ‰Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± unpost ÎºÎ±Î¹ Î´Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±Ï†Î¿Ï ÎºÎ¬Î½ÎµÏ„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÎºÎ¿Ï…Î¼Ï€Î¯ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±.',0),(483322,13426,'zh','æœªä»˜çš„å‘ç¥¨ unpost å¹¶å•å‡»ç¼–è¾‘æŒ‰é’®åŽåˆ é™¤å‘ç¥¨ï¼Œè¯·è¿”å›žè‚¡ç¥¨ã€‚',0),(483323,13426,'sv','Att Ã¥tervÃ¤nda stock fÃ¶r obetalda fakturor unpost och ta bort fakturan genom att klicka pÃ¥ knappen Redigera.',0),(483324,13426,'it','Per restituire il brodo per fatture non pagate unpost ed eliminare la fattura dopo aver cliccato il pulsante Modifica.',0),(483325,13426,'tl','',0),(483326,13426,'th','à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸„à¸·à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸¢à¸±à¸‡à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸Šà¸³à¸£à¸° unpost à¹à¸¥à¸°à¸¥à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸›à¸¸à¹ˆà¸¡à¹à¸à',0),(483327,13426,'hi','à¤¶à¥‡à¤¯à¤° à¤ªà¤° à¤²à¥Œà¤Ÿà¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤µà¥ˆà¤¤à¤¨à¤¿à¤• à¤šà¤¾à¤²à¤¾à¤¨ unpost à¤”à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¬à¤Ÿà¤¨ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤à¥¤',0),(483328,13426,'ms','Untuk kembali stok untuk invois tidak berbayar unpost dan menghapuskan invois selepas klik butang Edit.',0),(483329,13426,'ar','Ø¥Ù„Ù‰ Ø¹ÙˆØ¯Ø© Ø§Ù„Ø£Ø³Ù‡Ù… Ù„Ù„ÙÙˆØ§ØªÙŠØ± ØºÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© Ø£ÙˆÙ†Ø¨ÙˆØ³Øª ÙˆØ­Ø°Ù Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¨Ø¹Ø¯ Ø§Ù„Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„Ø²Ø± ØªØ­Ø±ÙŠØ±.',0),(483330,13426,'fr','Pour renvoyer le stock pour factures impayÃ©es unpost et supprimer la facture aprÃ¨s avoir cliquÃ© sur le bouton modifier.',0),(483331,13426,'jp','æˆ»ã‚Šã¾ã™æ ªå¼ã®æœªæ‰•ã„ã®è«‹æ±‚æ›¸ã®è¨˜å¸³ã—ã€[ç·¨é›†] ãƒœã‚¿ãƒ³ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ãŸå¾Œã€è«‹æ±‚æ›¸ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(483332,13426,'pt','Para retornar o estoque para faturas nÃ£o-pagas unpost e excluir a factura depois de clicar no botÃ£o Editar.',0),(483333,13426,'ru','Ð”Ð»Ñ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ñ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹ Ð½ÐµÐ¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð² unpost Ð¸ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚ Ð¿Ð¾ÑÐ»Ðµ Ð½Ð°Ð¶Ð°Ñ‚Ð¸Ñ Ð½Ð° ÐºÐ½Ð¾Ð¿ÐºÑƒ Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ.',0),(483334,13426,'es','Para devolver stock para facturas no pagadas, Descontabiliza y eliminar la factura depuÃ©s de hacer clik en el botÃ³n de Edit.',0),(483335,13426,'de','Lager zurÃ¼ckkehren fÃ¼r unbezahlte Rechnungen unpost und lÃ¶schen die Rechnung nach dem Klicken auf die SchaltflÃ¤che \"Bearbeiten\".',0),(483336,13426,'en','To return stock for unpaid invoices unpost and delete the invoice after clicking the Edit button.',0),(483337,13427,'is','',0),(483338,13427,'dr','Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ - Ø³ÙØ§Ø±Ø´ Ø´Ø¯Ù‡ Ø­Ù…Ù„ØŒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ØŒ Ù„ØºÙˆØŒ Ùˆ ÛŒØ§ ÛŒØ§ÙØª Ù†Ø´Ø¯',0),(483339,13427,'pr','Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø­Ø°Ù Ø³ÙØ§Ø±Ø´ - Ø³ÙØ§Ø±Ø´ Ø´Ø¯Ù‡ Ø­Ù…Ù„ØŒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ØŒ Ù„ØºÙˆØŒ Ùˆ ÛŒØ§ ÛŒØ§ÙØª Ù†Ø´Ø¯',0),(483340,13427,'tr','Can\'t Delete emri - sipariÅŸ vardÄ±r be sevk, fatura, iptal veya bulunamadÄ±',0),(483341,13427,'pl','Nie moÅ¼na usunÄ…Ä‡ zamÃ³wienie - ZamÃ³wienie wysÅ‚ane, zapowiadane, anulowanego lub nie znaleziono',0),(483342,13427,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ñ€ÐµÐ´ - Ñ€ÐµÐ´ Ðµ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸, Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸, Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½ Ð¸Ð»Ð¸ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(483343,13427,'ur','Ø³Ú©ØªØ§ Ø­Ø°Ù Ú©Ø±ÛŒÚº Ø¢Ø±ÚˆØ± - Ø¢Ø±ÚˆØ± ÛÛ’ Ú¯ÛŒØ§ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ØŒ Ø¨Ø§Ù„Ù„Ø§Ø¯ØŒ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§ ÛŒØ§ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(483344,13427,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð”ÐµÐ»ÐµÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ - Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ Ð±Ð¸Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸, Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½, Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð° Ð¸Ð»Ð¸ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°',0),(483345,13427,'vi','KhÃ´ng thá»ƒ xÃ³a Ä‘Æ¡n Ä‘áº·t hÃ ng - Ä‘Æ¡n Ä‘áº·t hÃ ng Ä‘Ã£ Ä‘Æ°á»£c váº­n chuyá»ƒn, láº­p hoÃ¡ Ä‘Æ¡n, há»§y bá» hoáº·c khÃ´ng tÃ¬m tháº¥y',0),(483346,13427,'af','Kan nie skrap einde - orde het is Shipped, weerspieÃ«l, gekanselleer of gevind nie',0),(483347,13427,'ro','Nu pot ÅŸterge - ordin a fost livrat, facturat, anulate, sau nu a fost gÄƒsit',0),(483348,13427,'et','Ei saa Kustuta Order - tellimus on tarnitud, arve, tÃ¼histatud vÃµi ei leitud',0),(483349,13427,'si','Ne more izbrisati nalog - nalog je dobavljen, zaraÄunali, preklican, ali ni mogoÄe najti',0),(483350,13427,'ba','Tidak dapat menghapus pesanan - pesanan telah dikirim, ditagih, membatalkan, atau tidak ditemukan',0),(483351,13427,'nl','Verwijderen Order - Order kan niet is verzonden, gefactureerd, geannuleerd, of niet gevonden',0),(483352,13427,'fi','Ei poista - jÃ¤rjestykseen on toimitettu, laskutetaan, peruutettu, tai ei lÃ¶ydy',0),(483353,13427,'no','Slette - rekkefÃ¸lgen kan ikke er levert, fakturert, annullert eller ikke funnet',0),(483354,13427,'da','Slette ordre - ordre kan ikke har vÃ¦ret leveret, faktureret, annulleret eller ikke fundet',0),(483355,13427,'ko','ìˆ˜ ì—†ìŠµë‹ˆë‹¤. ì‚­ì œ ì£¼ë¬¸-ì£¼ë¬¸ ë°°ì†¡, ì²­êµ¬, ì·¨ì†Œ ë˜ì—ˆê±°ë‚˜ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(483356,13427,'he','×œ× ×ž×—×§ - ×¡×“×¨ ×™×© ×›×‘×¨ × ×©×œ×—, ×ž×—×•×™×‘, ×‘×•×˜×œ×” ××• ×œ× × ×ž×¦×',0),(483357,13427,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î”Î¹Î±Î³ÏÎ±Ï†Î® - Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î­Ï‡ÎµÎ¹ Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯, Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹, Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ, Î® Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(483358,13427,'zh','ä¸èƒ½åˆ é™¤è®¢å•-è®¢å•å·²å‘è¿ã€ å¸å•ã€ å–æ¶ˆï¼Œæˆ–æ‰¾ä¸åˆ°',0),(483359,13427,'sv','Ta bort - ordning kan inte har varit levereras, faktureras, annullerats eller hittades inte',0),(483360,13427,'it','Non possono cancellare ordine - ordine Ã¨ stato spedito, fatturati, annullato o non trovato',0),(483361,13427,'tl','',0),(483362,13427,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸¥à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ - à¸ªà¸±à¹ˆà¸‡à¹„à¸”à¹‰à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™ à¸¢à¸à¹€à¸¥à¸´à¸ à¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆà¸žà¸š',0),(483363,13427,'hi','à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡ Delete à¤†à¤¦à¥‡à¤¶ - à¤†à¤¦à¥‡à¤¶ à¤—à¤¯à¤¾ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾, à¤¬à¤¿à¤², à¤•à¥‹ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾, à¤¹à¥ˆ à¤¯à¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(483364,13427,'ms','Tidak dapat Hapus pesanan - pesanan telah dihantar, dibilkan, dibatalkan, atau tidak dijumpai',0),(483365,13427,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø­Ø°Ù Ø£Ù…Ø±-Ø£Ù…Ø± ØªÙ… Ø´Ø­Ù†Ù‡Ø§ØŒ ÙˆÙÙˆØ§ØªÙŠØ±ØŒ ÙˆØ¥Ù„ØºØ§Ø¡ØŒ Ø£Ùˆ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(483366,13427,'fr','Ne peut pas supprimer - ordre a Ã©tÃ© livrÃ©, facturÃ©, annulÃ© ou introuvable',0),(483367,13427,'jp','ã§ãã¾ã›ã‚“å‰Šé™¤é †åº - é †åºãŒã•ã‚Œã¦å‡ºè·ã€è«‹æ±‚ã€ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã€ã¾ãŸã¯è¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(483368,13427,'pt','NÃ£o pode excluir ordem - ordem tem sido enviados, faturado, cancelado ou nÃ£o encontrado',0),(483369,13427,'ru','ÐÐµÐ»ÑŒÐ·Ñ Delete Order - Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð¸Ð¼ÐµÐµÑ‚ Ð±Ñ‹Ð»Ð¸ Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ñ‹, Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚, Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð° Ð¸Ð»Ð¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(483370,13427,'es','No Se Puede Eliminar El Pedido - Pedido Ha Sido Enviado, Facturado, Cancelado O Extraviado',0),(483371,13427,'de','LÃ¶schen Order - Auftrag kann nicht versendet, in Rechnung gestellt, abgebrochen oder wurde nicht gefunden',0),(483372,13427,'en','Cannot Delete Order - Order Has Been Shipped, Billed, Canceled, Or Not Found',0),(483373,13428,'is','',0),(483374,13428,'dr','Ø­Ø°Ù Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(483375,13428,'pr','Ø­Ø°Ù Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(483376,13428,'tr','Teklifleri Sil',0),(483377,13428,'pl','UsuÅ„ Cytaty',0),(483378,13428,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(483379,13428,'ur','ÙˆØ§ÙˆÛŒÙ† Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(483380,13428,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(483381,13428,'vi','XoÃ¡ dáº¥u ngoáº·c kÃ©p',0),(483382,13428,'af','Skrap aanhalings',0),(483383,13428,'ro','ÅžtergeÅ£i citate',0),(483384,13428,'et','Kustutada pakkumised',0),(483385,13428,'si','IzbriÅ¡i ponudbe',0),(483386,13428,'ba','Hapus tanda kutip',0),(483387,13428,'nl','Offertes verwijderen',0),(483388,13428,'fi','Poista tarjoukset',0),(483389,13428,'no','Slette tilbud',0),(483390,13428,'da','Slette tilbud',0),(483391,13428,'ko','ë”°ì˜´í‘œë¥¼ ì‚­ì œ',0),(483392,13428,'he','×œ×ž×—×•×§ ×”×¦×¢×•×ª ×ž×—×™×¨',0),(483393,13428,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï€ÏÎ¿ÏƒÏ†Î¿ÏÏŽÎ½',0),(483394,13428,'zh','åˆ é™¤æŠ¥ä»·',0),(483395,13428,'sv','Ta bort offerter',0),(483396,13428,'it','Eliminare offerte',0),(483397,13428,'tl','',0),(483398,13428,'th','à¸¥à¸šà¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(483399,13428,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£ à¤¹à¤Ÿà¤¾',0),(483400,13428,'ms','Menghapuskan sebut harga',0),(483401,13428,'ar','Ø­Ø°Ù Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³',0),(483402,13428,'fr','Supprimer les guillemets',0),(483403,13428,'jp','å¼•ç”¨ç¬¦ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(483404,13428,'pt','Excluir aspas',0),(483405,13428,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(483406,13428,'es','Eliminar Cotizaciones',0),(483407,13428,'de','Angebote lÃ¶schen',0),(483408,13428,'en','Delete Quotes',0),(483409,13429,'is','',0),(483410,13429,'dr','Ù†Ù‡ Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù†Ø¯',0),(483411,13429,'pr','Ù†Ù‡ Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù†Ø¯',0),(483412,13429,'tr','HayÄ±r tÄ±rnak seÃ§ildi',0),(483413,13429,'pl','Nie oferty zostaÅ‚y wybrane',0),(483414,13429,'bg','ÐÑÐ¼Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð¸ Ð±ÑÑ…Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(483415,13429,'ur','Ú©ÙˆØ¦ÛŒ Ù‚ÛŒÙ…Øª Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ Ú¯ÛŒØ§ ØªÚ¾Ø§',0),(483416,13429,'sr','Ð˜Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸ ÑÑƒ Ð½ÐµÐ¼Ð° Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(483417,13429,'vi','KhÃ´ng cÃ³ dáº¥u ngoáº·c kÃ©p Ä‘Ã£ Ä‘Æ°á»£c lá»±a chá»n',0),(483418,13429,'af','Geen aanhalings is gekies',0),(483419,13429,'ro','Nu citate au fost selectate',0),(483420,13429,'et','No valituks osutusid',0),(483421,13429,'si','So bili izbrani brez narekovajev',0),(483422,13429,'ba','Tanpa tanda kutip yang dipilih',0),(483423,13429,'nl','Geen citaten werden geselecteerd',0),(483424,13429,'fi','Ei lainausmerkkejÃ¤ ei valittu',0),(483425,13429,'no','Ingen sitater ble valgt',0),(483426,13429,'da','Ingen citater blev markeret',0),(483427,13429,'ko','ë”°ì˜´í‘œ ì„ ì • ëë‹¤',0),(483428,13429,'he','×‘×œ×™ ×¦×™×˜×•×˜×™× × ×‘×—×¨×•',0),(483429,13429,'el','Î”ÎµÎ½ Ï„Î± Î±Ï€Î¿Ï†Î¸Î­Î³Î¼Î±Ï„Î± ÎµÏ€ÎµÎ»Î­Î³Î·ÏƒÎ±Î½',0),(483430,13429,'zh','æ²¡æœ‰å¼•å·å…¥é€‰',0),(483431,13429,'sv','Inga citationstecken valdes',0),(483432,13429,'it','Sono stati selezionati senza virgolette',0),(483433,13429,'tl','',0),(483434,13429,'th','à¹€à¸¥à¸·à¸­à¸à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹„à¸¡à¹ˆ',0),(483435,13429,'hi','à¤•à¥‹à¤ˆ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤šà¥à¤¨à¤¾ à¤—à¤¯à¤¾',0),(483436,13429,'ms','Tiada sebut harga telah dipilih',0),(483437,13429,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø§Ø®ØªÙŠØ§Ø± Ù„Ø§ Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³',0),(483438,13429,'fr','Sans les guillemets ont Ã©tÃ© sÃ©lectionnÃ©s',0),(483439,13429,'jp','å¼•ç”¨ç¬¦ãŒé¸æŠžã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(483440,13429,'pt','Selecionaram-se sem aspas',0),(483441,13429,'ru','Ð‘Ñ‹Ð»Ð¸ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð½Ñ‹ Ð±ÐµÐ· ÐºÐ°Ð²Ñ‹Ñ‡ÐµÐº',0),(483442,13429,'es','No se SelecciÃ³nan Ningunas Cotizaciones',0),(483443,13429,'de','Ohne AnfÃ¼hrungszeichen wurden ausgewÃ¤hlt',0),(483444,13429,'en','No Quotes Were Selected',0),(483445,13430,'is','',0),(483446,13430,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(483447,13430,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(483448,13430,'tr','TÄ±rnak baÅŸarÄ±yla silindi',0),(483449,13430,'pl','Cytaty przesâ”‚anie',0),(483450,13430,'bg','ÐšÐ°Ð²Ð¸Ñ‡ÐºÐ¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(483451,13430,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø¯Ø±Ø¬ Ú©Ø±Ù†Û’',0),(483452,13430,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ðµ Ð·Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(483453,13430,'vi','CÃ¡c dáº¥u ngoáº·c kÃ©p xÃ³a thÃ nh cÃ´ng',0),(483454,13430,'af','Aanhalings suksesvol geskrap',0),(483455,13430,'ro','Citate eliminÄƒ cu succes',0),(483456,13430,'et','Hinnapakkumisi edukalt kustutatud',0),(483457,13430,'si','Kotacije, uspeÅ¡no izbrisana',0),(483458,13430,'ba','Kutipan dihapus berhasil',0),(483459,13430,'nl','Citaten met succes verwijderd',0),(483460,13430,'fi','Lainauksia poistettu',0),(483461,13430,'no','Sitater slettet',0),(483462,13430,'da','Citater slettet',0),(483463,13430,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ë”°ì˜´í‘œ',0),(483464,13430,'he','×¦×™×˜×•×˜×™× × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(483465,13430,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(483466,13430,'zh','æŠ¥ä»·å·²æˆåŠŸåˆ é™¤',0),(483467,13430,'sv','Citat raderades',0),(483468,13430,'it','Citazioni eliminati con successo',0),(483469,13430,'tl','',0),(483470,13430,'th','à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¸¥à¸šà¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(483471,13430,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(483472,13430,'ms','Petikan-petikan yang dihapuskan dengan jayanya',0),(483473,13430,'ar','Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(483474,13430,'fr','Citations supprimÃ©es avec succÃ¨s',0),(483475,13430,'jp','å¼•ç”¨ç¬¦ã‚’å‰Šé™¤ã—ã¾ã—ãŸ',0),(483476,13430,'pt','CitaÃ§Ãµes apagadas com sucesso',0),(483477,13430,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ñ‹, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(483478,13430,'es','Cotizaciones Eliminadas Exitosamente',0),(483479,13430,'de','Angebote erfolgreich gelÃ¶scht',0),(483480,13430,'en','Quotes Deleted Successfully',0),(483481,13431,'is','',0),(483482,13431,'dr','Ø¨Ù‡ Ù†Ù‚Ù„ Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯',0),(483483,13431,'pr','Ø¨Ù‡ Ù†Ù‚Ù„ Ø§Ø² Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯',0),(483484,13431,'tr','SeÃ§ili teklifleri silme',0),(483485,13431,'pl','UsuÅ„ wybrane Cytaty',0),(483486,13431,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð¾Ñ„ÐµÑ€Ñ‚Ð¸',0),(483487,13431,'ur','Ù…Ù†ØªØ®Ø¨ Ø§Ù‚ØªØ¨Ø§Ø³Ø§Øª Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(483488,13431,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(483489,13431,'vi','XoÃ¡ dáº¥u ngoáº·c kÃ©p Ä‘Æ°á»£c chá»n',0),(483490,13431,'af','Skrap geselekteerde aanhalings',0),(483491,13431,'ro','Åžterge citate selectatÄƒ',0),(483492,13431,'et','Kustuta valitud tsitaadid',0),(483493,13431,'si','IzbriÅ¡i izbrane ponudbe',0),(483494,13431,'ba','Menghapus dipilih Quotes',0),(483495,13431,'nl','Geselecteerde offertes verwijderen',0),(483496,13431,'fi','Poista valitut tarjoukset',0),(483497,13431,'no','Slett valgte tilbud',0),(483498,13431,'da','Slet markerede citater',0),(483499,13431,'ko','ì‚­ì œ ì„ íƒí•œ ë”°ì˜´í‘œ',0),(483500,13431,'he','×ž×—×™×§×ª ×¦×™×˜×•×˜×™× × ×‘×—×¨×™×',0),(483501,13431,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Ï‰Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(483502,13431,'zh','åˆ é™¤é€‰å®šçš„æŠ¥ä»·',0),(483503,13431,'sv','Ta bort valda citat',0),(483504,13431,'it','Elimina selezionati citazioni',0),(483505,13431,'tl','',0),(483506,13431,'th','à¸¥à¸šà¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(483507,13431,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤‰à¤¦à¥à¤§à¤°à¤£ à¤¹à¤Ÿà¤¾',0),(483508,13431,'ms','Menghapuskan Petikan terpilih',0),(483509,13431,'ar','Ø­Ø°Ù Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³ Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(483510,13431,'fr','Supprimer devis sÃ©lectionnÃ©s',0),(483511,13431,'jp','åŽ³é¸ã•ã‚ŒãŸå¼•ç”¨æ–‡ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(483512,13431,'pt','Excluir citaÃ§Ãµes selecionadas',0),(483513,13431,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(483514,13431,'es','Eliminar Cotizaciones Seleccionadas',0),(483515,13431,'de','AusgewÃ¤hlte Angebote lÃ¶schen',0),(483516,13431,'en','Delete Selected Quotes',0),(483517,13432,'is','',0),(483518,13432,'dr','Ø§Ù†ØªØ®Ø§Ø¨/Ø¹Ø¯Ù… Ø§Ù†ØªØ®Ø§Ø¨ Ù‡Ù…Ù‡ Ø¨Ø±Ø§ÛŒ Ø­Ø°Ù',0),(483519,13432,'pr','Ø§Ù†ØªØ®Ø§Ø¨/Ø¹Ø¯Ù… Ø§Ù†ØªØ®Ø§Ø¨ Ù‡Ù…Ù‡ Ø¨Ø±Ø§ÛŒ Ø­Ø°Ù',0),(483520,13432,'tr','SeÃ§me/seÃ§imini kaldÄ±rma silme iÃ§in',0),(483521,13432,'pl','Zaznacz/Odznacz wszystko do usuniÄ™cia',0),(483522,13432,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ/Ð¼Ð°Ñ…Ð½ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(483523,13432,'ur','Ù…Ù†ØªØ®Ø¨/Ù†Ø§ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Ø®Ø§Ø±Ø¬ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ØªÙ…Ø§Ù…',0),(483524,13432,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸ /Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð¸ Ð¸Ð·Ð±Ð¾Ñ€ ÑÐ²ÐµÐ³Ð° Ð·Ð° Ð±Ñ€Ð¸ÑÐ°ÑšÐµ',0),(483525,13432,'vi','Chá»n/bá» chá»n táº¥t cáº£ Ä‘á»ƒ xÃ³a',0),(483526,13432,'af','Kies/ontkies alles vir skrapping',0),(483527,13432,'ro','Selectare/Deselectare toate pentru ÅŸtergere',0),(483528,13432,'et','Vali/TÃ¼hista kÃµik kustutamisse',0),(483529,13432,'si','Izberite/odznaÄite vse za brisanje',0),(483530,13432,'ba','Pilih/Urung Pilih Semua untuk penghapusan',0),(483531,13432,'nl','Selecteren/deselecteren alle voor verwijdering',0),(483532,13432,'fi','Valitse/Poista kaikki poistettavaksi',0),(483533,13432,'no','Merk/Fjern merking For sletting',0),(483534,13432,'da','VÃ¦lg/FravÃ¦lg alle For sletning',0),(483535,13432,'ko','ëª¨ë‘ ì‚­ì œì— ëŒ€ í•œ ì„ íƒ/ì„ íƒ í•´ì œ',0),(483536,13432,'he','×‘×—×¨/×‘×˜×œ ×‘×—×™×¨×” ×‘×›×œ ×œ×ž×—×™×§×”',0),(483537,13432,'el','Î•Ï€Î¹Î»Î¿Î³Î®/Î‘Ï€Î¿ÎµÏ€Î¹Î»Î¿Î³Î® ÏŒÎ»Ï‰Î½ Î³Î¹Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(483538,13432,'zh','é€‰æ‹©/å–æ¶ˆé€‰æ‹©æ‰€æœ‰è¦åˆ é™¤',0),(483539,13432,'sv','Markera/avmarkera alla fÃ¶r borttagning',0),(483540,13432,'it','Seleziona/Deseleziona tutto per omissione',0),(483541,13432,'tl','',0),(483542,13432,'th','à¹€à¸¥à¸·à¸­à¸/à¸¢à¸à¹€à¸¥à¸´à¸à¹€à¸¥à¸·à¸­à¸à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸¥à¸šà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(483543,13432,'hi','à¤¹à¤Ÿà¤¾à¤ à¤œà¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚/à¤…à¤šà¤¯à¤¨à¤¿à¤¤',0),(483544,13432,'ms','Pilih/Buang semua untuk penghapusan',0),(483545,13432,'ar','ØªØ­Ø¯ÙŠØ¯/Ø¥Ù„ØºØ§Ø¡ ØªØ­Ø¯ÙŠØ¯ ÙƒÙ„ Ø´ÙŠØ¡ Ù„Ù„Ø­Ø°Ù',0),(483546,13432,'fr','SÃ©lectionner/dÃ©sÃ©lectionner tout pour suppression',0),(483547,13432,'jp','å‰Šé™¤ã®ã™ã¹ã¦ã‚’é¸æŠž/é¸æŠžè§£é™¤',0),(483548,13432,'pt','Selecionar/cancelar a seleÃ§Ã£o para exclusÃ£o',0),(483549,13432,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ/Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð´Ð»Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ',0),(483550,13432,'es','Seleccionar/Deseleccionar Tadas Las Eliminaciones',0),(483551,13432,'de','Auswahl alle zum LÃ¶schen',0),(483552,13432,'en','Select/Deselect All For Deletion',0),(483553,13433,'is','',0),(483554,13433,'dr','Ù‡Ø±Ø²Ù‡ Ø®Ø¯Ù…Ø§Øª Ù…Ø´ØªØ±ÛŒ',0),(483555,13433,'pr','Ù‡Ø±Ø²Ù‡ Ø®Ø¯Ù…Ø§Øª Ù…Ø´ØªØ±ÛŒ',0),(483556,13433,'tr','MÃ¼ÅŸteri hizmeti temsilcisi',0),(483557,13433,'pl','Biuro obsÅ‚ugi klienta ryps',0),(483558,13433,'bg','ÐžÐ±ÑÐ»ÑƒÐ¶Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ñ‚ÐµÐ»',0),(483559,13433,'ur','Ú©Ø³Ù¹Ù…Ø± Ø³Ø±ÙˆØ³ Ø¬Ù…ÛÙˆØ±ÛŒÛ',0),(483560,13433,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð¾Ð¿ÐµÑ€Ð°Ñ‚ÐµÑ€Ð°',0),(483561,13433,'vi','Äáº¡i diá»‡n dá»‹ch vá»¥ khÃ¡ch hÃ ng',0),(483562,13433,'af','KliÃ«nt diens verteenwoordiger',0),(483563,13433,'ro','Servicii pentru clienti Rep',0),(483564,13433,'et','Klienditeeninduse Rep',0),(483565,13433,'si','Rep storitve za stranke',0),(483566,13433,'ba','Customer Service Rep',0),(483567,13433,'nl','Customer Service Rep',0),(483568,13433,'fi','Asiakas asepalvelus ripsi',0),(483569,13433,'no','Kundeservice Rep',0),(483570,13433,'da','Kundeservice Rep',0),(483571,13433,'ko','ê³ ê° ì„œë¹„ìŠ¤ ë‹´ë‹¹ìž',0),(483572,13433,'he','× ×¦×™×’ ×©×™×¨×•×ª ×œ×§×•×—×•×ª',0),(483573,13433,'el','ÎŽÏ†Î±ÏƒÎ¼Î± ÎµÎ¾Ï…Ï€Î·ÏÎ­Ï„Î·ÏƒÎ·Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(483574,13433,'zh','å®¢æˆ·æœåŠ¡ä»£è¡¨',0),(483575,13433,'sv','KundtjÃ¤nst Rep',0),(483576,13433,'it','Servizio clienti Rep',0),(483577,13433,'tl','',0),(483578,13433,'th','à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸šà¸£à¸´à¸à¸²à¸£à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(483579,13433,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡à¤µà¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿',0),(483580,13433,'ms','Wakil Perkhidmatan pelanggan',0),(483581,13433,'ar','Ù…Ù†Ø¯ÙˆØ¨ Ø®Ø¯Ù…Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(483582,13433,'fr','Customer Service Rep',0),(483583,13433,'jp','é¡§å®¢ã‚µãƒ¼ãƒ“ã‚¹æ‹…å½“è€…',0),(483584,13433,'pt','Representante de serviÃ§o ao cliente',0),(483585,13433,'ru','Rep Ð¾Ð±ÑÐ»ÑƒÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(483586,13433,'es','Representante de Servicio a Cliente',0),(483587,13433,'de','Customer Service Rep',0),(483588,13433,'en','Customer Service Rep',0),(483589,13434,'is','',0),(483590,13434,'dr','ØªÙˆÙ„ÛŒØ¯',0),(483591,13434,'pr','ØªÙˆÙ„ÛŒØ¯',0),(483592,13434,'tr','OluÅŸturulan',0),(483593,13434,'pl','Generowane',0),(483594,13434,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(483595,13434,'ur','Ù¾ÛŒØ¯Ø§',0),(483596,13434,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ð½Ð¾',0),(483597,13434,'vi','Táº¡o ra',0),(483598,13434,'af','Gegenereer',0),(483599,13434,'ro','Generat',0),(483600,13434,'et','Loodud',0),(483601,13434,'si','Ustvarjeni',0),(483602,13434,'ba','Dihasilkan',0),(483603,13434,'nl','Gegenereerd',0),(483604,13434,'fi','Syntyy',0),(483605,13434,'no','Generert',0),(483606,13434,'da','Genereret',0),(483607,13434,'ko','ìƒì„± ëœ',0),(483608,13434,'he','×©× ×•×¦×¨',0),(483609,13434,'el','Î Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½Ï„Î±Î¹',0),(483610,13434,'zh','ç”Ÿæˆçš„',0),(483611,13434,'sv','Genereras',0),(483612,13434,'it','Generato',0),(483613,13434,'tl','',0),(483614,13434,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸‚à¸¶à¹‰à¸™',0),(483615,13434,'hi','à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨',0),(483616,13434,'ms','Dijana',0),(483617,13434,'ar','ÙˆÙ„Ø¯Øª',0),(483618,13434,'fr','GÃ©nÃ©rÃ©',0),(483619,13434,'jp','ç”Ÿæˆã•ã‚Œã¾ã—ãŸã€‚',0),(483620,13434,'pt','Gerado',0),(483621,13434,'ru','Ð¡Ð¾Ð·Ð´Ð°ÐµÑ‚ÑÑ',0),(483622,13434,'es','Generado',0),(483623,13434,'de','Generiert',0),(483624,13434,'en','Generated',0),(483625,13435,'is','',0),(483626,13435,'dr','Ø¨Ø±Ø§ÛŒ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(483627,13435,'pr','Ø¨Ø±Ø§ÛŒ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(483628,13435,'tr','Geri nakliye iÃ§in',0),(483629,13435,'pl','WrÃ³Ä‡ do wysyÅ‚ki',0),(483630,13435,'bg','ÐÐ°Ð·Ð°Ð´ ÐºÑŠÐ¼ Ñ‚Ñ€Ð°Ð½ÑÐ¿Ð¾Ñ€Ñ‚',0),(483631,13435,'ur','Ø¬ÛØ§Ø² Ø±Ø§Ù†ÛŒ Ú©Û’ Ù„Ø¦Û’ ÙˆØ§Ù¾Ø³',0),(483632,13435,'sr','ÐÐ°Ð·Ð°Ð´ Ð½Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(483633,13435,'vi','Quay láº¡i váº­n chuyá»ƒn',0),(483634,13435,'af','Terug na gestuur',0),(483635,13435,'ro','ÃŽnapoi la livrare',0),(483636,13435,'et','Aastasse laevandus',0),(483637,13435,'si','Nazaj v pomorskem prometu',0),(483638,13435,'ba','Kembali ke pengiriman',0),(483639,13435,'nl','Terug naar verzending',0),(483640,13435,'fi','Palaa merenkulku',0),(483641,13435,'no','Tilbake til Norge',0),(483642,13435,'da','Tilbage til forsendelse',0),(483643,13435,'ko','ë°°ì†¡ì„ ë‹¤ì‹œ',0),(483644,13435,'he','×—×–×¨×” ××œ ×”×ž×©×œ×•×—',0),(483645,13435,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î· Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(483646,13435,'zh','å›žåˆ°èˆªè¿',0),(483647,13435,'sv','Tillbaka till frakt',0),(483648,13435,'it','Torna a spedizione',0),(483649,13435,'tl','',0),(483650,13435,'th','à¸à¸¥à¸±à¸šà¹„à¸›à¸¢à¸±à¸‡à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(483651,13435,'hi','à¤µà¤¾à¤ªà¤¸ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¥‡ à¤²à¤¿à¤',0),(483652,13435,'ms','Kembali kepada penghantaran',0),(483653,13435,'ar','Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ Ù„Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ',0),(483654,13435,'fr','Retour Ã  la navigation',0),(483655,13435,'jp','é€æ–™ã«æˆ»ã‚‹',0),(483656,13435,'pt','Volta para o transporte',0),(483657,13435,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(483658,13435,'es','Regresa a Enviar',0),(483659,13435,'de','ZurÃ¼ck zum Versand',0),(483660,13435,'en','Back To Shipping',0),(483661,13436,'is','',0),(483662,13436,'dr','Ù¾ÙˆØ´Ø´',0),(483663,13436,'pr','Ù¾ÙˆØ´Ø´',0),(483664,13436,'tr','Kapak',0),(483665,13436,'pl','OkÅ‚adka',0),(483666,13436,'bg','ÐšÐ¾Ñ€Ð¸Ñ†Ð°',0),(483667,13436,'ur','Ø§Ø­Ø§Ø·Û',0),(483668,13436,'sr','ÐŸÐ¾ÐºÑ€Ð¸Ð²Ð°Ñ˜',0),(483669,13436,'vi','Bao gá»“m',0),(483670,13436,'af','Bedek',0),(483671,13436,'ro','Acoperi',0),(483672,13436,'et','Kate',0),(483673,13436,'si','Kritje',0),(483674,13436,'ba','Penutup',0),(483675,13436,'nl','Dekking',0),(483676,13436,'fi','Kansi',0),(483677,13436,'no','Dekke',0),(483678,13436,'da','DÃ¦kke',0),(483679,13436,'ko','ì»¤ë²„',0),(483680,13436,'he','×›×™×¡×•×™',0),(483681,13436,'el','ÎšÎ¬Î»Ï…ÏˆÎ·',0),(483682,13436,'zh','å°é¢',0),(483683,13436,'sv','TÃ¤cka',0),(483684,13436,'it','Copertura',0),(483685,13436,'tl','',0),(483686,13436,'th','à¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡',0),(483687,13436,'hi','à¤†à¤µà¤°à¤£',0),(483688,13436,'ms','Perlindungan',0),(483689,13436,'ar','ØºØ·Ø§Ø¡',0),(483690,13436,'fr','Couverture',0),(483691,13436,'jp','ã‚«ãƒãƒ¼',0),(483692,13436,'pt','Capa',0),(483693,13436,'ru','ÐžÐ±Ð»Ð¾Ð¶ÐºÐ°',0),(483694,13436,'es','CarÃ¡tula',0),(483695,13436,'de','Abdeckung',0),(483696,13436,'en','Cover',0),(483697,13437,'is','',0),(483698,13437,'dr','Ø·Ø±Ø§Ø­ÛŒ Ø³ÙØ§Ø±Ø´ÛŒ',0),(483699,13437,'pr','Ø·Ø±Ø§Ø­ÛŒ Ø³ÙØ§Ø±Ø´ÛŒ',0),(483700,13437,'tr','Ã–zel tasarÄ±m',0),(483701,13437,'pl','ZamÃ³wienie',0),(483702,13437,'bg','Ð”Ð¸Ð·Ð°Ð¹Ð½ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(483703,13437,'ur','Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ ÚˆÛŒØ²Ø§Ø¦Ù†',0),(483704,13437,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¸ Ð´Ð¸Ð·Ð°Ñ˜Ð½',0),(483705,13437,'vi','TÃ¹y chá»‰nh thiáº¿t káº¿',0),(483706,13437,'af','Pasgemaakte ontwerp',0),(483707,13437,'ro','Design personalizat',0),(483708,13437,'et','Kohandatud kujundus',0),(483709,13437,'si','Custom Design',0),(483710,13437,'ba','Desain kustom',0),(483711,13437,'nl','Ontwerp op maat',0),(483712,13437,'fi','Custom Design',0),(483713,13437,'no','Tilpasset Design',0),(483714,13437,'da','Custom Design',0),(483715,13437,'ko','ì‚¬ìš©ìž ì •ì˜ ë””ìžì¸',0),(483716,13437,'he','×¢×™×¦×•×‘ ×ž×•×ª×× ××™×©×™×ª',0),(483717,13437,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· ÏƒÏ‡ÎµÎ´Î¯Î±ÏƒÎ·',0),(483718,13437,'zh','è‡ªå®šä¹‰è®¾è®¡',0),(483719,13437,'sv','Custom Design',0),(483720,13437,'it','Design personalizzato',0),(483721,13437,'tl','',0),(483722,13437,'th','à¸­à¸­à¸à¹à¸šà¸šà¹€à¸­à¸‡',0),(483723,13437,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤¡à¤¿à¤œà¤¾à¤‡à¤¨',0),(483724,13437,'ms','Rekabentuk yang',0),(483725,13437,'ar','ØªØµÙ…ÙŠÙ… Ù…Ø®ØµØµ',0),(483726,13437,'fr','Conception sur mesure',0),(483727,13437,'jp','ã‚«ã‚¹ã‚¿ãƒ  ãƒ‡ã‚¶ã‚¤ãƒ³',0),(483728,13437,'pt','Design personalizado',0),(483729,13437,'ru','Ð˜Ð½Ð´Ð¸Ð²Ð¸Ð´ÑƒÐ°Ð»ÑŒÐ½Ñ‹Ð¹ Ð´Ð¸Ð·Ð°Ð¹Ð½',0),(483730,13437,'es','DeseÃ±o Personalizado',0),(483731,13437,'de','Individuelles Design',0),(483732,13437,'en','Custom Design',0),(483733,13438,'is','',0),(483734,13438,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ± Ø¨Ø±Ø§ÛŒ Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(483735,13438,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ± Ø¨Ø±Ø§ÛŒ Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(483736,13438,'tr','Teklif ayrÄ±ntÄ±larÄ±',0),(483737,13438,'pl','SzczegÃ³Å‚y oferty',0),(483738,13438,'bg','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(483739,13438,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(483740,13438,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð·Ð° Ð¿Ð¾Ð½ÑƒÐ´Ñƒ',0),(483741,13438,'vi','CÃ¡c chi tiáº¿t cho bÃ¡o giÃ¡',0),(483742,13438,'af','Besonderhede vir kwotasie',0),(483743,13438,'ro','Detalii pentru oferta',0),(483744,13438,'et','Hinnapakkumise Ã¼ksikasjade',0),(483745,13438,'si','Podrobnosti za ponudbo',0),(483746,13438,'ba','Rincian untuk kutipan',0),(483747,13438,'nl','Details voor offerte',0),(483748,13438,'fi','Tarjouksen',0),(483749,13438,'no','Detaljer om tilbud',0),(483750,13438,'da','Oplysninger om tilbud',0),(483751,13438,'ko','ê²¬ì ì— ëŒ€ í•œ ì„¸ë¶€ ì •ë³´',0),(483752,13438,'he','×¤×¨×˜×™× ×œ×§×‘×œ×ª ×”×¦×¢×ª ×ž×—×™×¨',0),(483753,13438,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(483754,13438,'zh','æŠ¥ä»·å•è¯¦ç»†ä¿¡æ¯',0),(483755,13438,'sv','Detaljer fÃ¶r offert',0),(483756,13438,'it','Dettagli per preventivo',0),(483757,13438,'tl','',0),(483758,13438,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(483759,13438,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤µà¤°à¤£',0),(483760,13438,'ms','Butir-butir untuk Quote',0),(483761,13438,'ar','ØªÙØ§ØµÙŠÙ„ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(483762,13438,'fr','DÃ©tails pour devis',0),(483763,13438,'jp','å¼•ç”¨ã®è©³ç´°',0),(483764,13438,'pt','Detalhes para citaÃ§Ã£o',0),(483765,13438,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð´Ð»Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(483766,13438,'es','Detalles Para la CotizaciÃ³n',0),(483767,13438,'de','AusfÃ¼hrliche Informationen zu Angebot',0),(483768,13438,'en','Details For Quote',0),(483769,13439,'is','',0),(483770,13439,'dr','Ø¨Ù„Ø§ÙØ§ØµÙ„Ù‡ &amp; Ø¨Ù‡ ØªØ¹Ø¯Ø§Ø¯ Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø¨Ø§Ù„Ø§ Ù…Ø±Ø§Ø¬Ø¹Ù‡ Ú©Ù†ÛŒØ¯',0),(483771,13439,'pr','Ø¨Ù„Ø§ÙØ§ØµÙ„Ù‡ &amp; Ø¨Ù‡ ØªØ¹Ø¯Ø§Ø¯ Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø¨Ø§Ù„Ø§ Ù…Ø±Ø§Ø¬Ø¹Ù‡ Ú©Ù†ÛŒØ¯',0),(483772,13439,'tr','Hemen & yukarÄ±daki alÄ±ntÄ± numarasÄ±na baÅŸvuruda',0),(483773,13439,'pl','Od razu & odnoszÄ… siÄ™ do powyÅ¼szego numeru oferty',0),(483774,13439,'bg','Ð’ÐµÐ´Ð½Ð°Ð³Ð° & ÑÐµ Ð¾Ñ‚Ð½Ð°ÑÑ Ð·Ð° Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð°',0),(483775,13439,'ur','ÙÙˆØ±ÛŒ Ø·ÙˆØ± Ù¾Ø± & Ú©Ùˆ Ù…Ù†Ø¯Ø±Ø¬Û Ø¨Ø§Ù„Ø§ Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Û’ Ù†Ù…Ø¨Ø± Ù…ÛŒÚº Ø­ÙˆØ§Ù„Û Ø¯ÛŒØªÛ’ ÛÛŒÚº Û”',0),(483776,13439,'sr','ÐžÐ´Ð¼Ð°Ñ… & ÑÐµ Ð¾Ð´Ð½Ð¾ÑÐµ Ð½Ð° Ð³Ð¾Ñ€Ðµ Ð½Ð°Ð²ÐµÐ´ÐµÐ½Ðµ Ð±Ñ€Ð¾Ñ˜ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(483777,13439,'vi','Ngay láº­p tá»©c &amp; tham kháº£o cho sá»‘ bÃ¡o giÃ¡ á»Ÿ trÃªn',0),(483778,13439,'af','Onmiddellik & verwys na die bogenoemde aanhaling nommer',0),(483779,13439,'ro','Imediat & se referÄƒ la numÄƒrul de citat mai sus',0),(483780,13439,'et','Kohe & viidata eespool nimetatud pakkumise numbrit',0),(483781,13439,'si','Takoj & sklicevati na zgoraj citat Å¡tevilko',0),(483782,13439,'ba','Segera & merujuk ke nomor kutipan di atas',0),(483783,13439,'nl','Onmiddellijk & verwijzen naar de bovenstaande Quotenummer',0),(483784,13439,'fi','VÃ¤littÃ¶mÃ¤sti & viitata edellÃ¤ huoltotarjouksen numero',0),(483785,13439,'no','Umiddelbart & se ovenfor tilbudsnummer',0),(483786,13439,'da','Straks & refererer til den ovenstÃ¥ende citat nummer',0),(483787,13439,'ko','ë°”ë¡œ ìœ„ì˜ ê²¬ì  ë²ˆí˜¸ë¥¼ ì°¸ì¡° í•˜ëŠ” &',0),(483788,13439,'he','×ž×™×“ & ×œ×”×¤× ×•×ª ×ž×¡×¤×¨ ×”×¦×™×˜×•×˜ ×œ×¢×™×œ',0),(483789,13439,'el','Î‘Î¼Î­ÏƒÏ‰Ï‚ & Î±Î½Î±Ï†Î­ÏÎµÏ„Î±Î¹ Î¿ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(483790,13439,'zh','ç«‹å³ &amp; æŒ‡ä¸Šè¿°æŠ¥ä»·ç¼–å·',0),(483791,13439,'sv','Omedelbart & refererar till ovanstÃ¥ende citat nummer',0),(483792,13439,'it','Immediatamente & si riferiscono al numero di citazione sopra',0),(483793,13439,'tl','',0),(483794,13439,'th','à¸—à¸±à¸™à¸—à¸µ & à¸«à¸¡à¸²à¸¢à¸–à¸¶à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸‚à¹‰à¸²à¸‡à¸•à¹‰à¸™',0),(483795,13439,'hi','à¤¤à¥à¤°à¤‚à¤¤ & à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤Šà¤ªà¤° à¤•à¥‹à¤Ÿ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¤¾ à¤¸à¤‚à¤¦à¤°à¥à¤­ à¤²à¥‡à¤‚',0),(483796,13439,'ms','Dengan serta-merta & merujuk kepada jumlah petikan di atas',0),(483797,13439,'ar','ÙÙˆØ±Ø§ Ø¢Ù†Ø¯ ØªØ´ÙŠØ± Ø¥Ù„Ù‰ Ø¹Ø¯Ø¯ Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³ Ø£Ø¹Ù„Ø§Ù‡',0),(483798,13439,'fr','ImmÃ©diatement & correspondent au nombre de citation ci-dessus',0),(483799,13439,'jp','ã™ãã«ä¸Šè¨˜ã®å¼•ç”¨ç•ªå·ã‚’å‚ç…§ã—ã¦ãã ã•ã„ &',0),(483800,13439,'pt','Imediatamente & referem-se ao nÃºmero de citaÃ§Ã£o acima',0),(483801,13439,'ru','Ð¡Ñ€Ð°Ð·Ñƒ Ð¶Ðµ & Ð¾Ñ‚Ð½Ð¾ÑÑÑ‚ÑÑ Ðº Ñ‡Ð¸ÑÐ»Ñƒ Ð²Ñ‹ÑˆÐµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(483802,13439,'es','Inmediatamente & Refiere al NÃºmero de CotizaciÃ³n Arriba',0),(483803,13439,'de','Sofort & beziehen sich auf die oben genannten Angebotsnummer',0),(483804,13439,'en','Immediately & Refer To The Above Quote Number',0),(483805,13440,'is','',0),(483806,13440,'dr','Ø·Ø±Ø§Ø­ÛŒ inhouse',0),(483807,13440,'pr','Ø·Ø±Ø§Ø­ÛŒ inhouse',0),(483808,13440,'tr','Ä°nhouse tasarÄ±m',0),(483809,13440,'pl','Projekt inhouse',0),(483810,13440,'bg','Inhouse Ð´Ð¸Ð·Ð°Ð¹Ð½',0),(483811,13440,'ur','Ø§Ù†ÛÙˆÙˆØ³ÛŒ ÚˆÛŒØ²Ø§Ø¦Ù†',0),(483812,13440,'sr','Ð˜Ð½Ñ…Ð¾ÑƒÑÐµ Ð´Ð¸Ð·Ð°Ñ˜Ð½',0),(483813,13440,'vi','Trong nhÃ  thiáº¿t káº¿',0),(483814,13440,'af','Inhouse ontwerp',0),(483815,13440,'ro','Inhouse Design',0),(483816,13440,'et','Inhouse disain',0),(483817,13440,'si','Inhouse Design',0),(483818,13440,'ba','In-House desain',0),(483819,13440,'nl','Inhouse ontwerp',0),(483820,13440,'fi','Maksulliset Design',0),(483821,13440,'no','Internt Design',0),(483822,13440,'da','Inhouse Design',0),(483823,13440,'ko','ì‚¬ë‚´ ë””ìžì¸',0),(483824,13440,'he','×¢×‘×•×¨ ×¢×™×¦×•×‘',0),(483825,13440,'el','Î£Ï‡ÎµÎ´Î¯Î±ÏƒÎ·Ï‚ Î¼Îµ Î¯Î´Î¹Î± Î¼Î­ÏƒÎ±',0),(483826,13440,'zh','ç‚¹æ’­æœåŠ¡è®¾è®¡',0),(483827,13440,'sv','Inhouse Design',0),(483828,13440,'it','Inhouse Design',0),(483829,13440,'tl','',0),(483830,13440,'th','à¸­à¸­à¸à¹à¸šà¸šà¸«à¹‰à¸­à¸‡',0),(483831,13440,'hi','Inhouse à¤¡à¤¿à¤œà¤¾à¤‡à¤¨',0),(483832,13440,'ms','Reka bentuk dalaman',0),(483833,13440,'ar','Ø§Ù„ØªØµÙ…ÙŠÙ… Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠ',0),(483834,13440,'fr','Conception interne',0),(483835,13440,'jp','ãƒ» ã‚¤ãƒ³ãƒã‚¦ã‚¹ ãƒ» ãƒ‡ã‚¶ã‚¤ãƒ³',0),(483836,13440,'pt','Inhouse Design',0),(483837,13440,'ru','Inhouse Ð”Ð¸Ð·Ð°Ð¹Ð½',0),(483838,13440,'es','DiseÃ±o Dentro de la Compania',0),(483839,13440,'de','Inhouse-Design',0),(483840,13440,'en','Inhouse Design',0),(483841,13441,'is','',0),(483842,13441,'dr','Ø±Ù†Ú¯ Ø¯Ø§Ø®Ù„',0),(483843,13441,'pr','Ø±Ù†Ú¯ Ø¯Ø§Ø®Ù„',0),(483844,13441,'tr','Ä°Ã§ rengi',0),(483845,13441,'pl','WewnÄ…trz kolor',0),(483846,13441,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐµÐ½ Ñ†Ð²ÑÑ‚',0),(483847,13441,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ† Ø±Ù†Ú¯',0),(483848,13441,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ° Ð±Ð¾Ñ˜Ð°',0),(483849,13441,'vi','BÃªn trong mÃ u',0),(483850,13441,'af','Binnekant kleur',0),(483851,13441,'ro','ÃŽn interiorul de culoare',0),(483852,13441,'et','Seest vÃ¤rvi',0),(483853,13441,'si','Notranja barva',0),(483854,13441,'ba','Di dalam warna',0),(483855,13441,'nl','Binnen kleur',0),(483856,13441,'fi','SisÃ¤puolinen vÃ¤ri',0),(483857,13441,'no','Innvendig farge',0),(483858,13441,'da','Indvendig farve',0),(483859,13441,'ko','ë‚´ë¶€ ìƒ‰ìƒ',0),(483860,13441,'he','×¦×‘×¢ ×‘×¤× ×™×',0),(483861,13441,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÏŒ Ï‡ÏÏŽÎ¼Î±',0),(483862,13441,'zh','å†…éƒ¨é¢œè‰²',0),(483863,13441,'sv','Inside fÃ¤rg',0),(483864,13441,'it','Colore interno',0),(483865,13441,'tl','',0),(483866,13441,'th','à¸ªà¸µà¸ à¸²à¸¢à¹ƒà¸™',0),(483867,13441,'hi','à¤…à¤‚à¤¦à¤° à¤°à¤‚à¤—',0),(483868,13441,'ms','Warna dalam',0),(483869,13441,'ar','Ù„ÙˆÙ† Ø§Ù„Ø¯Ø§Ø®Ù„',0),(483870,13441,'fr','Couleur intÃ©rieure',0),(483871,13441,'jp','å†…å´ã®ã‚«ãƒ©ãƒ¼',0),(483872,13441,'pt','Cor de dentro',0),(483873,13441,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ð¹ Ñ†Ð²ÐµÑ‚',0),(483874,13441,'es','Color a Dentro',0),(483875,13441,'de','Innen Farbe',0),(483876,13441,'en','Inside Color',0),(483877,13442,'is','',0),(483878,13442,'dr','Ø±Ù†Ú¯ Ø®Ø§Ø±Ø¬',0),(483879,13442,'pr','Ø±Ù†Ú¯ Ø®Ø§Ø±Ø¬',0),(483880,13442,'tr','DÄ±ÅŸ renk',0),(483881,13442,'pl','Poza kolor',0),(483882,13442,'bg','Ð’ÑŠÐ½ÑˆÐ½Ð¸ Ñ†Ð²ÑÑ‚',0),(483883,13442,'ur','Ø¨Ø§ÛØ± Ø±Ù†Ú¯',0),(483884,13442,'sr','Ð˜Ð·Ð²Ð°Ð½ Ð±Ð¾Ñ˜Ð°',0),(483885,13442,'vi','BÃªn ngoÃ i mÃ u',0),(483886,13442,'af','Buite kleur',0),(483887,13442,'ro','ÃŽn afara de culoare',0),(483888,13442,'et','VÃ¤ljaspool vÃ¤rv',0),(483889,13442,'si','Zunanja barva',0),(483890,13442,'ba','Luar warna',0),(483891,13442,'nl','Buiten kleur',0),(483892,13442,'fi','Ulkopuolinen vÃ¤ri',0),(483893,13442,'no','Farge utenpÃ¥',0),(483894,13442,'da','Udvendige farve',0),(483895,13442,'ko','ì™¸ë¶€ ìƒ‰ìƒ',0),(483896,13442,'he','×¦×‘×¢ ×—×™×¦×•× ×™',0),(483897,13442,'el','Î•Î¾Ï‰Ï„ÎµÏÎ¹ÎºÏŒ Ï‡ÏÏŽÎ¼Î±',0),(483898,13442,'zh','å¤–éƒ¨é¢œè‰²',0),(483899,13442,'sv','UtanfÃ¶r fÃ¤rg',0),(483900,13442,'it','Colore esterno',0),(483901,13442,'tl','',0),(483902,13442,'th','à¸ªà¸µà¸ à¸²à¸¢à¸™à¸­à¸',0),(483903,13442,'hi','à¤¬à¤¾à¤¹à¤°à¥€ à¤°à¤‚à¤—',0),(483904,13442,'ms','Warna di luar',0),(483905,13442,'ar','Ø§Ù„Ù„ÙˆÙ† Ø§Ù„Ø®Ø§Ø±Ø¬ÙŠ',0),(483906,13442,'fr','Couleur extÃ©rieure',0),(483907,13442,'jp','å¤–ã®è‰²',0),(483908,13442,'pt','Cor exterior',0),(483909,13442,'ru','Ð’Ð½ÐµÑˆÐ½Ð¸Ð¹ Ñ†Ð²ÐµÑ‚',0),(483910,13442,'es','Color Afuera',0),(483911,13442,'de','AuÃŸen Farbe',0),(483912,13442,'en','Outside Color',0),(483913,13443,'is','',0),(483914,13443,'dr','Ø¯Ø± Ø²ÛŒØ± Ø´Ø±Ø­ Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø´Ù…Ø§ Ø§Ø³Øª.',0),(483915,13443,'pr','Ø¯Ø± Ø²ÛŒØ± Ø´Ø±Ø­ Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø´Ù…Ø§ Ø§Ø³Øª.',0),(483916,13443,'tr','AÅŸaÄŸÄ±daki alÄ±ntÄ± bir aÃ§Ä±klamasÄ±dÄ±r.',0),(483917,13443,'pl','PoniÅ¼ej przedstawiono opis twÃ³j cytat.',0),(483918,13443,'bg','ÐŸÐ¾-Ð´Ð¾Ð»Ñƒ Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°.',0),(483919,13443,'ur','Ø¢Ù¾ Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ ØªÙØµÛŒÙ„ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ ÛÛ’ Û”',0),(483920,13443,'sr','Ð¡Ð»ÐµÐ´Ð¸ Ð¾Ð¿Ð¸Ñ ÑÐ²Ð¾Ñ˜Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ.',0),(483921,13443,'vi','ÄÃ¢y lÃ  má»™t mÃ´ táº£ cá»§a bÃ¡o giÃ¡ cá»§a báº¡n.',0),(483922,13443,'af','Die volgende is \'n beskrywing van jou aanhaling.',0),(483923,13443,'ro','Aceasta este o descriere a citat dumneavoastrÄƒ.',0),(483924,13443,'et','JÃ¤rgnev on kirjeldus oma hinnapakkumise.',0),(483925,13443,'si','Spodaj je opis vaÅ¡e ponudbe.',0),(483926,13443,'ba','Berikut ini adalah deskripsi dari penawaran Anda.',0),(483927,13443,'nl','Hieronder volgt een beschrijving van uw offerte.',0),(483928,13443,'fi','Seuraavassa on kuvaus tarjouksesi.',0),(483929,13443,'no','FÃ¸lgende er en beskrivelse av tilbud.',0),(483930,13443,'da','FÃ¸lgende er en beskrivelse af dit tilbud.',0),(483931,13443,'ko','ë‹¤ìŒì€ ê²¬ì ì„œì˜ ì„¤ëª…ìž…ë‹ˆë‹¤.',0),(483932,13443,'he','×œ×¤× ×™×›× ×ª×™××•×¨ ×©×œ ×”×¦×¢×ª ×ž×—×™×¨.',0),(483933,13443,'el','Î¤Î¿ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ ÎµÎ¯Î½Î±Î¹ Î¼Î¹Î± Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚ ÏƒÎ±Ï‚.',0),(483934,13443,'zh','ä¸‹é¢æ˜¯æŠ¥ä»·çš„ä¸€ä¸ªæè¿°æ‚¨ã€‚',0),(483935,13443,'sv','FÃ¶ljande Ã¤r en beskrivning av din offert.',0),(483936,13443,'it','Di seguito Ã¨ una descrizione del tuo preventivo.',0),(483937,13443,'tl','',0),(483938,13443,'th','à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¹€à¸›à¹‡à¸™à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¸­à¸‡à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(483939,13443,'hi','à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤…à¤ªà¤¨à¥€ à¤¬à¥‹à¤²à¥€ à¤•à¤¾ à¤µà¤°à¥à¤£à¤¨ à¤¹à¥ˆà¥¤',0),(483940,13443,'ms','Berikut adalah Perihalan mengenai sebut harga anda.',0),(483941,13443,'ar','Ù…Ø§ ÙŠÙ„ÙŠ ÙˆØµÙ Ù„Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ.',0),(483942,13443,'fr','Ce qui suit est une description de votre devis.',0),(483943,13443,'jp','ã‚ãªãŸã®è¦‹ç©ã‚‚ã‚Šé¡ã®èª¬æ˜Žã‚’æ¬¡ã«ç¤ºã—ã¾ã™ã€‚',0),(483944,13443,'pt','A seguir estÃ¡ uma descriÃ§Ã£o de sua citaÃ§Ã£o.',0),(483945,13443,'ru','ÐÐ¸Ð¶Ðµ Ð¿Ñ€Ð¸Ð²Ð¾Ð´Ð¸Ñ‚ÑÑ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð²Ð°ÑˆÐµÐ¹ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð¾Ð¹.',0),(483946,13443,'es','El siguente es una descripciÃ³n de su cotizaciÃ³n',0),(483947,13443,'de','Im folgenden finden eine Beschreibung Ihres Angebots.',0),(483948,13443,'en','The following is a description of your quote.',0),(483949,13444,'is','',0),(483950,13444,'dr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ú©Ø´ØªÛŒ',0),(483951,13444,'pr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ú©Ø´ØªÛŒ',0),(483952,13444,'tr','Gemi Not',0),(483953,13444,'pl','Uwaga statek',0),(483954,13444,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ° Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(483955,13444,'ur','Ø¬ÛØ§Ø² Ù†ÙˆÙ¹',0),(483956,13444,'sr','Ð‘Ñ€Ð¾Ð´ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(483957,13444,'vi','LÆ°u Ã½ tÃ u',0),(483958,13444,'af','Skip Nota',0),(483959,13444,'ro','Nava NotÄƒ',0),(483960,13444,'et','Laeva MÃ¤rkus',0),(483961,13444,'si','Opomba ladje',0),(483962,13444,'ba','Kapal catatan',0),(483963,13444,'nl','Schip Opmerking',0),(483964,13444,'fi','Aluksen Huomautus',0),(483965,13444,'no','Skipet Merk',0),(483966,13444,'da','Skibet BemÃ¦rk',0),(483967,13444,'ko','ë°° ì£¼',0),(483968,13444,'he','×”×¢×¨×” ×”×¡×¤×™× ×”',0),(483969,13444,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· Ï„Î·Ï‚ Ï€Î»Î¿Î¯Î¿',0),(483970,13444,'zh','èˆ¹èˆ¶æ³¨æ„',0),(483971,13444,'sv','Fartyget Obs',0),(483972,13444,'it','Nota nave',0),(483973,13444,'tl','',0),(483974,13444,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(483975,13444,'hi','à¤œà¤¹à¤¾à¤œ à¤¨à¥‹à¤Ÿ',0),(483976,13444,'ms','Nota kapal',0),(483977,13444,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(483978,13444,'fr','Note de navire',0),(483979,13444,'jp','èˆ¹ã®ãƒ¡ãƒ¢',0),(483980,13444,'pt','Nota de navio',0),(483981,13444,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(483982,13444,'es','Nota de EnvÃ­o',0),(483983,13444,'de','Schiff-Hinweis',0),(483984,13444,'en','Ship Note',0),(483985,13445,'is','',0),(483986,13445,'dr','ØµØ§Ø¯Ø±Ø§Øª ÙØ§ÛŒÙ„ Ù‡Ø§ÛŒ Ù†Ø³Ø®Ù‡ Ù‚Ø§Ø¨Ù„ Ú†Ø§Ù¾',0),(483987,13445,'pr','ØµØ§Ø¯Ø±Ø§Øª ÙØ§ÛŒÙ„ Ù‡Ø§ÛŒ Ù†Ø³Ø®Ù‡ Ù‚Ø§Ø¨Ù„ Ú†Ø§Ù¾',0),(483988,13445,'tr','YazdÄ±rma dosyasÄ± dÄ±ÅŸa aktarma',0),(483989,13445,'pl','Drukowania pliku eksportu',0),(483990,13445,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð» Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(483991,13445,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù…Ø³Ù„ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(483992,13445,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(483993,13445,'vi','Xuáº¥t kháº©u táº­p tin in',0),(483994,13445,'af','Druk lÃªer uitvoer',0),(483995,13445,'ro','Exportul fiÅŸier de imprimare',0),(483996,13445,'et','Prindi faili eksportida',0),(483997,13445,'si','Izvoz tiskanje datoteke',0),(483998,13445,'ba','Mengekspor File cetak',0),(483999,13445,'nl','Export afdrukbestand',0),(484000,13445,'fi','Tulostaa tiedoston vieminen',0),(484001,13445,'no','Eksportere utskriftsfilen',0),(484002,13445,'da','Eksportere udskriftsfilen',0),(484003,13445,'ko','ì¸ì‡„ íŒŒì¼ ë‚´ë³´ë‚´ê¸°',0),(484004,13445,'he','×™×™×¦×•× ×§×•×‘×¥ ×”×”×“×¤×¡×”',0),(484005,13445,'el','Î•Î¾Î±Î³Ï‰Î³Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï… ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(484006,13445,'zh','å¯¼å‡ºæ‰“å°æ–‡ä»¶',0),(484007,13445,'sv','Exportera filen',0),(484008,13445,'it','Esportare File di stampa',0),(484009,13445,'tl','',0),(484010,13445,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¹à¸Ÿà¹‰à¸¡à¸à¸²à¸£à¸žà¸´à¸¡à¸žà¹Œ',0),(484011,13445,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(484012,13445,'ms','Eksport fail cetakan',0),(484013,13445,'ar','ØªØµØ¯ÙŠØ± Ù…Ù„Ù Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(484014,13445,'fr','Exporter fichier d\'impression',0),(484015,13445,'jp','å°åˆ·ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(484016,13445,'pt','Exportar arquivo de impressÃ£o',0),(484017,13445,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ñ„Ð°Ð¹Ð»Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(484018,13445,'es','File De ImpresiÃ³n Para Exportar',0),(484019,13445,'de','Export-Druckdatei',0),(484020,13445,'en','Export Print File',0),(484021,13446,'is','',0),(484022,13446,'dr','Ú©ØªØ§Ø¨ Ø¬Ø²Ø¦ÛŒØ§Øª',0),(484023,13446,'pr','Ú©ØªØ§Ø¨ Ø¬Ø²Ø¦ÛŒØ§Øª',0),(484024,13446,'tr','Kitap detayÄ±',0),(484025,13446,'pl','KsiÄ…Å¼ka szczegÃ³Å‚owo',0),(484026,13446,'bg','ÐšÐ½Ð¸Ð³Ð°Ñ‚Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(484027,13446,'ur','Ú©ØªØ§Ø¨ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(484028,13446,'sr','ÐšÑšÐ¸Ð³Ð° Ð´ÐµÑ‚Ð°Ñ™',0),(484029,13446,'vi','Chi tiáº¿t cuá»‘n sÃ¡ch',0),(484030,13446,'af','Boek besonderhede',0),(484031,13446,'ro','Detalii carte',0),(484032,13446,'et','Raamatu andmed',0),(484033,13446,'si','Knjiga podrobnosti',0),(484034,13446,'ba','Buku Detail',0),(484035,13446,'nl','Boek Detail',0),(484036,13446,'fi','Kirja yksityiskohdat',0),(484037,13446,'no','Boken detaljer',0),(484038,13446,'da','Bogen detaljer',0),(484039,13446,'ko','ì±… ì„¸ë¶€ ì‚¬í•­',0),(484040,13446,'he','×¤×™×¨×•×˜ ×‘×¡×¤×¨',0),(484041,13446,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Î²Î¹Î²Î»Î¯Î¿Ï…',0),(484042,13446,'zh','æœ¬ä¹¦è¯¦ç»†ä¿¡æ¯',0),(484043,13446,'sv','Bok i detalj',0),(484044,13446,'it','Dettaglio libro',0),(484045,13446,'tl','',0),(484046,13446,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸«à¸™à¸±à¸‡à¸ªà¸·à¸­',0),(484047,13446,'hi','à¤ªà¥à¤¸à¥à¤¤à¤• à¤µà¤¿à¤µà¤°à¤£',0),(484048,13446,'ms','Butiran buku',0),(484049,13446,'ar','ÙƒØªØ§Ø¨ Ø§Ù„ØªÙØµÙŠÙ„',0),(484050,13446,'fr','DÃ©tail du livre',0),(484051,13446,'jp','æ›¸ç±è©³ç´°',0),(484052,13446,'pt','Detalhe do livro',0),(484053,13446,'ru','ÐšÐ½Ð¸Ð³Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(484054,13446,'es','Detalles de Libro',0),(484055,13446,'de','BÃ¼cher Details',0),(484056,13446,'en','Book Detail',0),(484057,13447,'is','',0),(484058,13447,'dr','Ø¨Ø±Ø¯Ø§Ø´Øª Ù¾ÙˆØ´Ø´',0),(484059,13447,'pr','Ø¨Ø±Ø¯Ø§Ø´Øª Ù¾ÙˆØ´Ø´',0),(484060,13447,'tr','Kapak gÃ¶sterimler',0),(484061,13447,'pl','Pokrycie wyÅ›wietleÅ„',0),(484062,13447,'bg','ÐšÐ¾Ñ€Ð¸Ñ†Ð° Ð¸Ð¼Ð¿Ñ€ÐµÑÐ¸Ð¸',0),(484063,13447,'ur','Ù†Ù‚ÙˆØ´ Ú©Ø§ Ø§Ø­Ø§Ø·Û',0),(484064,13447,'sr','ÐŸÐ¾ÐºÑ€Ð¸Ñ˜ ÑƒÑ‚Ð¸ÑÐºÐµ',0),(484065,13447,'vi','Bao gá»“m sá»‘ láº§n hiá»ƒn thá»‹',0),(484066,13447,'af','Indrukke te bedek',0),(484067,13447,'ro','Acoperi impresii',0),(484068,13447,'et','Kate muljed',0),(484069,13447,'si','Kritje prikazov',0),(484070,13447,'ba','Mencakup tayangan',0),(484071,13447,'nl','Dekking indrukken',0),(484072,13447,'fi','Kansi nÃ¤yttÃ¶kerrat',0),(484073,13447,'no','Dekke visninger',0),(484074,13447,'da','DÃ¦kke visninger',0),(484075,13447,'ko','í‘œì§€ ë…¸ì¶œ',0),(484076,13447,'he','×›×™×¡×•×™ ×¨×©×ž×™×',0),(484077,13447,'el','ÎšÎ¬Î»Ï…ÏˆÎ· ÎµÎ½Ï„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚',0),(484078,13447,'zh','å°é¢å°è±¡',0),(484079,13447,'sv','TÃ¤cka intryck',0),(484080,13447,'it','Impressioni di copertura',0),(484081,13447,'tl','',0),(484082,13447,'th','à¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡à¸„à¸§à¸²à¸¡à¸›à¸£à¸°à¸—à¸±à¸šà¹ƒà¸ˆ',0),(484083,13447,'hi','à¤›à¤¾à¤ªà¥‹à¤‚ à¤•à¥‹ à¤•à¤µà¤°',0),(484084,13447,'ms','Merangkumi tanggapan',0),(484085,13447,'ar','ØªØºØ·ÙŠØ© Ø§Ù„Ø§Ù†Ø·Ø¨Ø§Ø¹Ø§Øª',0),(484086,13447,'fr','Couvrir les Impressions',0),(484087,13447,'jp','å°è±¡ã‚’ã‚«ãƒãƒ¼ã—ã¾ã™ã€‚',0),(484088,13447,'pt','ImpressÃµes de capa',0),(484089,13447,'ru','ÐžÐ±Ð»Ð¾Ð¶ÐºÐ° Ð²Ð¿ÐµÑ‡Ð°Ñ‚Ð»ÐµÐ½Ð¸Ñ',0),(484090,13447,'es','Impresiones de CarÃ¡tula',0),(484091,13447,'de','Abdeckung-Impressionen',0),(484092,13447,'en','Cover Impressions',0),(484093,13448,'is','',0),(484094,13448,'dr','Ø´Ø±Ø­ Ø³ÙØ§Ø±Ø´',0),(484095,13448,'pr','Ø´Ø±Ø­ Ø³ÙØ§Ø±Ø´',0),(484096,13448,'tr','SipariÅŸ aÃ§Ä±klamasÄ±',0),(484097,13448,'pl','Opis zamÃ³wienia',0),(484098,13448,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ñ€ÐµÐ´',0),(484099,13448,'ur','ØªØ±ØªÛŒØ¨ Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(484100,13448,'sr','ÐžÐ¿Ð¸Ñ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(484101,13448,'vi','MÃ´ táº£ vá» Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(484102,13448,'af','Beskrywing van orde',0),(484103,13448,'ro','Descriere a comenzii',0),(484104,13448,'et','Tellimuse kirjeldus',0),(484105,13448,'si','Opis nalog',0),(484106,13448,'ba','Deskripsi Order',0),(484107,13448,'nl','Beschrijving van bestelling',0),(484108,13448,'fi','Tilauksen kuvaus',0),(484109,13448,'no','Beskrivelse av ordre',0),(484110,13448,'da','Beskrivelse af ordre',0),(484111,13448,'ko','ì£¼ë¬¸ ì„¤ëª…',0),(484112,13448,'he','×ª×™××•×¨ ×©×œ ×¡×“×¨',0),(484113,13448,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ Ï„Î¬Î¾Î·Ï‚',0),(484114,13448,'zh','è®¢å•çš„è¯´æ˜Ž',0),(484115,13448,'sv','Beskrivning av Order',0),(484116,13448,'it','Descrizione dell\'ordine',0),(484117,13448,'tl','',0),(484118,13448,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(484119,13448,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(484120,13448,'ms','Penerangan mengenai perintah',0),(484121,13448,'ar','ÙˆØµÙ Ù„Ù„Ù†Ø¸Ø§Ù…',0),(484122,13448,'fr','Description de l\'ordre',0),(484123,13448,'jp','æ³¨æ–‡ã®èª¬æ˜Ž',0),(484124,13448,'pt','DescriÃ§Ã£o da ordem',0),(484125,13448,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(484126,13448,'es','DescripciÃ³n de Pedido',0),(484127,13448,'de','Beschreibung der Ordnung',0),(484128,13448,'en','Description Of Order',0),(484129,13449,'is','',0),(484130,13449,'dr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ø¨Ø±Ø¯Ø§Ø±ÛŒ Ø³ÙØ§Ø±Ø´',0),(484131,13449,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ø¨Ø±Ø¯Ø§Ø±ÛŒ Ø³ÙØ§Ø±Ø´',0),(484132,13449,'tr','ORDER Taker',0),(484133,13449,'pl','PrzyjmujÄ…cy zamÃ³wienie',0),(484134,13449,'bg','Ð ÐµÐ´ Taker',0),(484135,13449,'ur','ØªØ±ØªÛŒØ¨ Ù†Ú¯Ø±Ø§Ù†',0),(484136,13449,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð³Ñ€Ð°Ð±Ñ™Ð¸Ð²Ð¸Ñ†Ð°',0),(484137,13449,'vi','Taker tráº­t tá»±',0),(484138,13449,'af','Order Taker',0),(484139,13449,'ro','Preluat comanda',0),(484140,13449,'et','Tellimuse vastuvÃµtja',0),(484141,13449,'si','Da kupcu',0),(484142,13449,'ba','Pengambil pesanan',0),(484143,13449,'nl','Degene die order aanneemt',0),(484144,13449,'fi','Jotta saaja',0),(484145,13449,'no','Ordrebestilleren',0),(484146,13449,'da','Ordretageren',0),(484147,13449,'ko','ì£¼ë¬¸ ì¦ê¸´ë‹¤',0),(484148,13449,'he','×”××“× ×©×§×™×‘×œ ×”×”×–×ž× ×”',0),(484149,13449,'el','\"Taker Ï„Î¬Î¾Î·Ï‚\"',0),(484150,13449,'zh','ç‚¹å•å‘˜',0),(484151,13449,'sv','Ordermottagaren',0),(484152,13449,'it','Taker ordine',0),(484153,13449,'tl','',0),(484154,13449,'th','à¸­à¸±à¸à¸›à¸£à¸°à¸à¸²à¸¨',0),(484155,13449,'hi','à¤‘à¤°à¥à¤¡à¤° à¤²à¥‡à¤¨à¥‡ à¤µà¤¾à¤²à¤¾',0),(484156,13449,'ms','Pemenang perintah',0),(484157,13449,'ar','Ø£Ø®Ø° Ø§Ù„Ù†Ø¸Ø§Ù…',0),(484158,13449,'fr','Order Taker',0),(484159,13449,'jp','ã‚ªãƒ¼ãƒ€ãƒ¼ä¿‚',0),(484160,13449,'pt','BeneficiÃ¡rio da ordem',0),(484161,13449,'ru','ÐŸÑ€Ð¸Ð½Ð¸Ð¼Ð°ÑŽÑ‰Ð°Ñ Ð·Ð°ÐºÐ°Ð·',0),(484162,13449,'es','El que Toma el Pedido',0),(484163,13449,'de','Order Taker',0),(484164,13449,'en','Order Taker',0),(484165,13450,'is','',0),(484166,13450,'dr','Ø¨Ø¯ÙˆÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ø±Ø§ÛŒ Ø¬ÙˆÙ‡Ø± Ø§ÛŒÙ† ÙÙ‡Ø±Ø³Øª Ù‚ÛŒÙ…Øª',0),(484167,13450,'pr','Ø¨Ø¯ÙˆÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ø±Ø§ÛŒ Ø¬ÙˆÙ‡Ø± Ø§ÛŒÙ† ÙÙ‡Ø±Ø³Øª Ù‚ÛŒÙ…Øª',0),(484168,13450,'tr','HayÄ±r fiyat istemek iÃ§in mÃ¼rekkep bu fiyat listesi',0),(484169,13450,'pl','Bez opÅ‚at za tusze ten Cennik',0),(484170,13450,'bg','Ð‘ÐµÐ· Ñ‚Ð°ÐºÑÐ° Ð·Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ñ‚Ð¾Ð·Ð¸ Ñ†ÐµÐ½Ð¾Ñ€Ð°Ð·Ð¿Ð¸Ñ',0),(484171,13450,'ur','Ø§Ù†Ú©Ø³ Ø§Ø³ Ù¾Ø±Ø§Ú©Ø§Ù„Ø§Ø³Ù¹ Ú©Û’ Ù„Ø¦Û’ Ú©ÙˆØ¦ÛŒ ÙÛŒØ³',0),(484172,13450,'sr','ÐÐµÑ†Ñƒ Ñ‚Ð¸ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð·Ð° Ð¼Ð°ÑÑ‚Ð¸Ð»Ð° Ð¾Ð²Ð°Ñ˜ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(484173,13450,'vi','KhÃ´ng cÃ³ phÃ­ cho má»±c chá»‰nh giÃ¡ nÃ y',0),(484174,13450,'af','Geen las vir ink hierdie Pricelist',0),(484175,13450,'ro','Nici o taxÄƒ pentru cerneluri aceastÄƒ listÄƒ de preÅ£uri',0),(484176,13450,'et','Ei tasu tindid selles hinnakiri',0),(484177,13450,'si','BrezplaÄno za Ärnila ta cenik',0),(484178,13450,'ba','Ada biaya untuk tinta Pricelist ini',0),(484179,13450,'nl','Kosteloos voor inkten deze prijslijst',0),(484180,13450,'fi','PeritÃ¤ musteet tÃ¤mÃ¤ hinnasto',0),(484181,13450,'no','Gratis blekk denne prisliste',0),(484182,13450,'da','Ingen afgift For blÃ¦k denne prisliste',0),(484183,13450,'ko','ìž‰í¬ê°€ì´ ê°€ê²©í‘œì— ëŒ€ í•œ ë¬´ë£Œ',0),(484184,13450,'he','×œ×œ× ×ª×©×œ×•× ×¢×‘×•×¨ ×¦×‘×¢×™ ×“×¤×•×¡ ×–×” ×ž×—×™×¨×•×Ÿ',0),(484185,13450,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Ï‡ÏÎ­Ï‰ÏƒÎ· Î³Î¹Î± Î¼ÎµÎ»Î¬Î½Î¹Î± Î±Ï…Ï„ÏŒ Î¤Î¹Î¼Î¿ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚',0),(484186,13450,'zh','è¿™ä¸ªä»·ç›®è¡¨æ²¹å¢¨ä¸æ”¶å–ä»»ä½•è´¹ç”¨',0),(484187,13450,'sv','Ingen avgift fÃ¶r blÃ¤ck denna prislista',0),(484188,13450,'it','Nessun addebito per inchiostri questo listino prezzi',0),(484189,13450,'tl','',0),(484190,13450,'th','à¹„à¸¡à¹ˆà¹€à¸ªà¸µà¸¢à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸«à¸¡à¸¶à¸à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸²à¸„à¸²à¸™à¸µà¹‰',0),(484191,13450,'hi','à¤¸à¥à¤¯à¤¾à¤¹à¥€ à¤‡à¤¸ pricelist à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤¶à¥à¤²à¥à¤• à¤¨à¤¹à¥€à¤‚',0),(484192,13450,'ms','Tiada caj bagi dakwat senarai ini',0),(484193,13450,'ar','Ø£ÙŠ ØªÙ‡Ù…Ø© Ù„Ø£Ø­Ø¨Ø§Ø± Ù‡Ø°Ù‡ Ø§Ù„ØªØ³Ø¹ÙŠØ±Ø©',0),(484194,13450,'fr','Sans frais pour les encres cette liste de prix',0),(484195,13450,'jp','ã‚¤ãƒ³ã‚¯ã“ã®ä¾¡æ ¼è¡¨ã¯ç„¡å„Ÿ',0),(484196,13450,'pt','Sem nenhum custo para tintas esta lista de preÃ§os',0),(484197,13450,'ru','ÐÐµ Ð²Ð·Ð¸Ð¼Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚Ñƒ Ð·Ð° ÐºÑ€Ð°ÑÐ¾Ðº ÑÑ‚Ð¾Ñ‚ Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(484198,13450,'es','No Hay Cargos Para Tinta en Esta Lista de Precios',0),(484199,13450,'de','Keine GebÃ¼hr fÃ¼r Tinten dieser Preisliste',0),(484200,13450,'en','No Charge For Inks This Pricelist',0),(484201,13451,'is','',0),(484202,13451,'dr','ÙØ§Ú©ØªÙˆØ± Ù…Ø´ØªØ±ÛŒ',0),(484203,13451,'pr','ÙØ§Ú©ØªÙˆØ± Ù…Ø´ØªØ±ÛŒ',0),(484204,13451,'tr','MÃ¼ÅŸteri faturasÄ±',0),(484205,13451,'pl','Faktury',0),(484206,13451,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(484207,13451,'ur','Ú©Ø³Ù¹Ù…Ø± Ø§Ù†ÙˆØ§Ø¦Ø³',0),(484208,13451,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(484209,13451,'vi','KhÃ¡ch hÃ ng hoÃ¡ Ä‘Æ¡n',0),(484210,13451,'af','KliÃ«nt faktuur',0),(484211,13451,'ro','FacturÄƒ client',0),(484212,13451,'et','Kliendi arve',0),(484213,13451,'si','Stranka raÄuna',0),(484214,13451,'ba','Pelanggan faktur',0),(484215,13451,'nl','Factuur van de klant',0),(484216,13451,'fi','Myyntilasku',0),(484217,13451,'no','Kundefaktura',0),(484218,13451,'da','Debitorfaktura',0),(484219,13451,'ko','ê³ ê° ì†¡ìž¥',0),(484220,13451,'he','×—×©×‘×•× ×™×ª ×œ×œ×§×•×—',0),(484221,13451,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(484222,13451,'zh','å®¢æˆ·å‘ç¥¨',0),(484223,13451,'sv','Kundfaktura',0),(484224,13451,'it','Fattura cliente',0),(484225,13451,'tl','',0),(484226,13451,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(484227,13451,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤‡à¤¨à¤µà¥‰à¤‡à¤¸',0),(484228,13451,'ms','Invois pelanggan',0),(484229,13451,'ar','ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(484230,13451,'fr','Facture client',0),(484231,13451,'jp','é¡§å®¢è«‹æ±‚æ›¸',0),(484232,13451,'pt','Nota fiscal de cliente',0),(484233,13451,'ru','Ð¡Ñ‡ÐµÑ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(484234,13451,'es','Factura de Cliente',0),(484235,13451,'de','Kundenrechnung',0),(484236,13451,'en','Customer Invoice',0),(484237,13452,'is','',0),(484238,13452,'dr','GL Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± ÙˆØ±ÙˆØ¯',0),(484239,13452,'pr','GL Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± ÙˆØ±ÙˆØ¯',0),(484240,13452,'tr','Manuel GL giriÅŸ',0),(484241,13452,'pl','RÄ™czne GL wpisu',0),(484242,13452,'bg','Ð ÑŠÑ‡Ð½Ð¾ GL Ð·Ð°Ð¿Ð¸Ñ',0),(484243,13452,'ur','Ø¯Ø³ØªÛŒ Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(484244,13452,'sr','Ð“Ð› Ñ€ÑƒÑ‡Ð½Ð¸ ÑƒÐ½Ð¾Ñ',0),(484245,13452,'vi','HÆ°á»›ng dáº«n sá»­ dá»¥ng GL má»¥c',0),(484246,13452,'af','Handleiding GL inskrywing',0),(484247,13452,'ro','Intrare manualÄƒ GL',0),(484248,13452,'et','KÃ¤sitsi GL kanne',0),(484249,13452,'si','GL roÄni vnos',0),(484250,13452,'ba','Entri manual GL',0),(484251,13452,'nl','Handmatige GL Entry',0),(484252,13452,'fi','Manuaalinen GL merkintÃ¤',0),(484253,13452,'no','Manuell GL oppfÃ¸ring',0),(484254,13452,'da','Manuel GL post',0),(484255,13452,'ko','ìˆ˜ë™ GL í•­ëª©',0),(484256,13452,'he','×›× ×™×¡×” ×™×“× ×™ GL',0),(484257,13452,'el','Î•Î³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î¿ GL ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(484258,13452,'zh','æ‰‹åŠ¨ GL æ¡ç›®',0),(484259,13452,'sv','Manuell GL intrÃ¤de',0),(484260,13452,'it','Immissione manuale GL',0),(484261,13452,'tl','',0),(484262,13452,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(484263,13452,'hi','à¤®à¥ˆà¤¨à¥à¤…à¤² GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(484264,13452,'ms','Manual GL kemasukan',0),(484265,13452,'ar','Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„ÙŠØ¯ÙˆÙŠ GL',0),(484266,13452,'fr','EntrÃ©e manuelle GL',0),(484267,13452,'jp','æ‰‹å‹• GL ã‚¨ãƒ³ãƒˆãƒª',0),(484268,13452,'pt','Entrada manual GL',0),(484269,13452,'ru','Ð ÑƒÑ‡Ð½Ð¾Ð¹ GL Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(484270,13452,'es','Entrad de LM Manual',0),(484271,13452,'de','Manuelle GL-Eintrag',0),(484272,13452,'en','Manual GL Entry',0),(484273,13453,'is','',0),(484274,13453,'dr','Backdating Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(484275,13453,'pr','Backdating Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(484276,13453,'tr','Hareketleri hisse verilmez',0),(484277,13453,'pl','Antydatowania transakcji nie jest dozwolone',0),(484278,13453,'bg','Backdating ÑÐ´ÐµÐ»ÐºÐ¸ Ð½Ðµ Ðµ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(484279,13453,'ur','Ø¨Ø§Ú©ÚˆÛŒÙ¹Ø§Ù†Ú¯ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº ÛÛ’',0),(484280,13453,'sr','Ð‘Ð°Ñ†ÐºÐ´Ð°Ñ‚Ð¸Ð½Ð³ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(484281,13453,'vi','Backdating giao dá»‹ch khÃ´ng Ä‘Æ°á»£c phÃ©p',0),(484282,13453,'af','Backdating transaksies word nie toegelaat nie',0),(484283,13453,'ro','Erelor tranzacÅ£ii nu este permis',0),(484284,13453,'et','Panemine tehingud on lubatud',0),(484285,13453,'si','PoseÄi transakcije ni dovoljeno',0),(484286,13453,'ba','Kasus pengunduran transaksi tidak diperbolehkan',0),(484287,13453,'nl','Antedatering transacties Is niet toegestaan',0),(484288,13453,'fi','Takautumattomuuden tapahtumat sallitaan',0),(484289,13453,'no','Backdating transaksjoner tillates ikke',0),(484290,13453,'da','Tilbagevirkende kraft transaktioner er ikke tilladt',0),(484291,13453,'ko','Backdating ê±°ëž˜ëŠ” í—ˆìš© ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(484292,13453,'he','Backdating ×ª× ×•×¢×•×ª ××™× ×” ×ž×•×ª×¨×ª',0),(484293,13453,'el','Î‘Î½Î±Î´ÏÎ¿Î¼Î¹ÎºÎ®Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ Î´ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(484294,13453,'zh','å›žæº¯äº¤æ˜“è®°å½•ä¸æ˜¯å…è®¸çš„',0),(484295,13453,'sv','Antedatering transaktioner Ã¤r inte tillÃ¥tet',0),(484296,13453,'it','Transazioni di retrodatazione non Ã¨ consentita',0),(484297,13453,'tl','',0),(484298,13453,'th','à¹„à¸¡à¹ˆà¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰ backdating à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡',0),(484299,13453,'hi','Backdating à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(484300,13453,'ms','Backdating urus niaga yang tidak dibenarkan',0),(484301,13453,'ar','Ù„Ø§ ÙŠØ³Ù…Ø­ Ø¨Ø¥Ø±Ø¬Ø§Ø¹ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(484302,13453,'fr','Antidate des Transactions n\'est pas autorisÃ©',0),(484303,13453,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã‚’ãƒãƒƒã‚¯ãƒ‡ãƒ¼ãƒˆã¯è¨±å¯ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(484304,13453,'pt','TransaÃ§Ãµes de aÃ§Ãµes nÃ£o Ã© permitido.',0),(484305,13453,'ru','Ð—Ð°Ð´Ð½Ð¸Ð¼ Ñ‡Ð¸ÑÐ»Ð¾Ð¼ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¹ Ð½Ðµ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(484306,13453,'es','Antedatando las Transacciones No Se Permiten',0),(484307,13453,'de','RÃ¼ckdatierung Transaktionen ist nicht zulÃ¤ssig.',0),(484308,13453,'en','Backdating Transactions Is Not Allowed',0),(484309,13454,'is','',0),(484310,13454,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù‡Ø²ÛŒÙ†Ù‡',0),(484311,13454,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù‡Ø²ÛŒÙ†Ù‡',0),(484312,13454,'tr','Gider raporu',0),(484313,13454,'pl','Raport z wydatkÃ³w',0),(484314,13454,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(484315,13454,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(484316,13454,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð°',0),(484317,13454,'vi','BÃ¡o cÃ¡o chi phÃ­',0),(484318,13454,'af','Uitgawe verslag',0),(484319,13454,'ro','Raport cheltuieli',0),(484320,13454,'et','Kuluaruande',0),(484321,13454,'si','PoroÄilo o stroÅ¡kih',0),(484322,13454,'ba','Biaya laporan',0),(484323,13454,'nl','Onkostendeclaratie',0),(484324,13454,'fi','Kuluraportti',0),(484325,13454,'no','Reiseregningen',0),(484326,13454,'da','Udgiftsrapport',0),(484327,13454,'ko','ê²½ë¹„ ë³´ê³ ì„œ',0),(484328,13454,'he','×“×•×— ×”×•×¦××•×ª',0),(484329,13454,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ ÎµÎ¾ÏŒÎ´Ï‰Î½',0),(484330,13454,'zh','æ”¯å‡ºæŠ¥è¡¨',0),(484331,13454,'sv','Utgiftsrapport',0),(484332,13454,'it','Nota spese',0),(484333,13454,'tl','',0),(484334,13454,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢',0),(484335,13454,'hi','à¤µà¥à¤¯à¤¯ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(484336,13454,'ms','Laporan perbelanjaan',0),(484337,13454,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª',0),(484338,13454,'fr','Note de frais',0),(484339,13454,'jp','çµŒè²»å ±å‘Šæ›¸',0),(484340,13454,'pt','RelatÃ³rio de despesas',0),(484341,13454,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾ Ñ€Ð°ÑÑ…Ð¾Ð´Ð°Ñ….',0),(484342,13454,'es','Informe de Gasto',0),(484343,13454,'de','Spesenabrechnung',0),(484344,13454,'en','Expense Report',0),(484345,13455,'is','',0),(484346,13455,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø§Ø² Ù‡Ø²ÛŒÙ†Ù‡',0),(484347,13455,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø§Ø² Ù‡Ø²ÛŒÙ†Ù‡',0),(484348,13455,'tr','Ä°Ã§in gider raporu',0),(484349,13455,'pl','Raport z wydatkÃ³w na',0),(484350,13455,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð°',0),(484351,13455,'ur','Ú©Û’ Ù„Ø¦Û’ Ø®Ø±Ú† Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(484352,13455,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ð·Ð°',0),(484353,13455,'vi','BÃ¡o cÃ¡o chi phÃ­ cho',0),(484354,13455,'af','Uitgawe verslag vir',0),(484355,13455,'ro','Raport de cheltuieli pentru',0),(484356,13455,'et','Kulude aruande jaoks',0),(484357,13455,'si','ObraÄun stroÅ¡kov za',0),(484358,13455,'ba','Laporan pengeluaran',0),(484359,13455,'nl','Onkostendeclaratie ter',0),(484360,13455,'fi','Kuluraportti kohteelle',0),(484361,13455,'no','Reiseregningen For',0),(484362,13455,'da','Udgiftsrapporten For',0),(484363,13455,'ko','ê²½ë¹„ ë³´ê³ ì„œì— ëŒ€ í•œ',0),(484364,13455,'he','×“×•×— ×”×•×¦××•×ª ×¢×‘×•×¨',0),(484365,13455,'el','ÎˆÎºÎ¸ÎµÏƒÎ· ÎµÎ¾ÏŒÎ´Ï‰Î½ Î³Î¹Î±',0),(484366,13455,'zh','æ”¯å‡ºæŠ¥è¡¨ä»¥ä¾›',0),(484367,13455,'sv','Utgiftsrapport fÃ¶r',0),(484368,13455,'it','Nota spese per',0),(484369,13455,'tl','',0),(484370,13455,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸ªà¸³à¸«à¸£à¸±à¸š',0),(484371,13455,'hi','à¤µà¥à¤¯à¤¯ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤',0),(484372,13455,'ms','Laporan perbelanjaan untuk',0),(484373,13455,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª',0),(484374,13455,'fr','Ã‰tat de dÃ©penses pour',0),(484375,13455,'jp','çµŒè²»å ±å‘Šæ›¸',0),(484376,13455,'pt','RelatÃ³rio de despesas para',0),(484377,13455,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ð°Ñ…',0),(484378,13455,'es','Informe de Gasto Por',0),(484379,13455,'de','Spesenabrechnung fÃ¼r',0),(484380,13455,'en','Expense Report For',0),(484381,13456,'is','',0),(484382,13456,'dr','Num',0),(484383,13456,'pr','Num',0),(484384,13456,'tr','NUM',0),(484385,13456,'pl','NUM',0),(484386,13456,'bg','NUM',0),(484387,13456,'ur','Num',0),(484388,13456,'sr','ÐÐ£Ðœ',0),(484389,13456,'vi','NUM',0),(484390,13456,'af','NUM',0),(484391,13456,'ro','Num',0),(484392,13456,'et','NUM',0),(484393,13456,'si','NUM',0),(484394,13456,'ba','Num',0),(484395,13456,'nl','NUM',0),(484396,13456,'fi','NUM',0),(484397,13456,'no','NUM',0),(484398,13456,'da','NUM',0),(484399,13456,'ko','Num',0),(484400,13456,'he','Num',0),(484401,13456,'el','NUM',0),(484402,13456,'zh','å…¨å›½çŸ¿å·¥å·¥ä¼š',0),(484403,13456,'sv','NUM',0),(484404,13456,'it','Num',0),(484405,13456,'tl','',0),(484406,13456,'th','Num',0),(484407,13456,'hi','Num',0),(484408,13456,'ms','NUM',0),(484409,13456,'ar','Num',0),(484410,13456,'fr','Num',0),(484411,13456,'jp','Num ä»¶',0),(484412,13456,'pt','Num',0),(484413,13456,'ru','Num',0),(484414,13456,'es','Num',0),(484415,13456,'de','NUM',0),(484416,13456,'en','Num',0),(484417,13457,'is','',0),(484418,13457,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø®Ø§Ù„ÛŒ',0),(484419,13457,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø®Ø§Ù„ÛŒ',0),(484420,13457,'tr','Toplam giderleri boÅŸluÄŸu iÃ§in',0),(484421,13457,'pl','OgÃ³Å‚em wydatki Void',0),(484422,13457,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Void',0),(484423,13457,'ur','Ú©Ù„ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø¨Û’ Ø¹Ù‚Ù„ Ú©Û’ Ù„Ø¦Û’',0),(484424,13457,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐ°',0),(484425,13457,'vi','Tá»•ng sá»‘ cho chi phÃ­ khoáº£ng trá»‘ng',0),(484426,13457,'af','Totaal vir uitgawes leemte',0),(484427,13457,'ro','Totalul cheltuielilor Void',0),(484428,13457,'et','Kokku kulud Void',0),(484429,13457,'si','Skupaj za stroÅ¡ke praznino',0),(484430,13457,'ba','Total untuk biaya kekosongan',0),(484431,13457,'nl','Totaal voor uitgaven Void',0),(484432,13457,'fi','YhteensÃ¤ kulut mitÃ¤tÃ¶n',0),(484433,13457,'no','Totalen For utgifter Void',0),(484434,13457,'da','Samlede udgifter tomrum',0),(484435,13457,'ko','ì´ ë¹„ìš© ë¬´íš¨ì— ëŒ€ í•œ',0),(484436,13457,'he','×¡×” ×¢×‘×•×¨ ×”×•×¦××•×ª ×”×—×œ×œ',0),(484437,13457,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î³Î¹Î± Î­Î¾Î¿Î´Î± ÎºÎµÎ½ÏŒ',0),(484438,13457,'zh','æ€»è´¹ç”¨è™šç©º',0),(484439,13457,'sv','Totala kostnader Void',0),(484440,13457,'it','Totale per spese Void',0),(484441,13457,'tl','',0),(484442,13457,'th','à¸œà¸¥à¸£à¸§à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¹‚à¸¡à¸†à¸°',0),(484443,13457,'hi','à¤•à¥à¤² à¤–à¤°à¥à¤š à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¥‡ à¤²à¤¿à¤',0),(484444,13457,'ms','Jumlah bagi perbelanjaan yang tidak',0),(484445,13457,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù†ÙÙ‚Ø§Øª Ø§Ù„ÙØ±Ø§Øº',0),(484446,13457,'fr','Total des dÃ©penses vide',0),(484447,13457,'jp','åˆè¨ˆè²»ç”¨ Void ã‚’',0),(484448,13457,'pt','Total de despesas vazio',0),(484449,13457,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Void',0),(484450,13457,'es','Total Para Gastos Nulo',0),(484451,13457,'de','Insgesamt fÃ¼r Aufwendungen Void',0),(484452,13457,'en','Total For Expenses Void',0),(484453,13458,'is','',0),(484454,13458,'dr','Ø­ÙØ±Ù‡',0),(484455,13458,'pr','Ø­ÙØ±Ù‡',0),(484456,13458,'tr','BoÅŸluklarÄ±',0),(484457,13458,'pl','Pustki',0),(484458,13458,'bg','ÐšÑƒÑ…Ð¸Ð½Ð¸',0),(484459,13458,'ur','Ø¯Ø±Ø¬Ø§Øª',0),(484460,13458,'sr','ÐŸÑ€Ð°Ð·Ð½Ð¸Ð½Ðµ',0),(484461,13458,'vi','Khoáº£ng trá»‘ng',0),(484462,13458,'af','Leemtes',0),(484463,13458,'ro','Golurile',0),(484464,13458,'et','TÃ¼himike',0),(484465,13458,'si','Praznin',0),(484466,13458,'ba','Void',0),(484467,13458,'nl','Vides',0),(484468,13458,'fi','TyhjÃ¤n tilan osuus',0),(484469,13458,'no','Tomrom',0),(484470,13458,'da','Hulrum',0),(484471,13458,'ko','ê¸° ê³µì´',0),(484472,13458,'he','×—×œ×œ×™×',0),(484473,13458,'el','ÎšÎµÎ½Î¬',0),(484474,13458,'zh','ç©ºæ´ž',0),(484475,13458,'sv','HÃ¥ligheter',0),(484476,13458,'it','Vuoti',0),(484477,13458,'tl','',0),(484478,13458,'th','Voids',0),(484479,13458,'hi','Voids',0),(484480,13458,'ms','Lompang',0),(484481,13458,'ar','Ø§Ù„ÙØ±Ø§ØºØ§Øª',0),(484482,13458,'fr','Vides',0),(484483,13458,'jp','ãƒœã‚¤ãƒ‰',0),(484484,13458,'pt','EspaÃ§os vazios',0),(484485,13458,'ru','ÐŸÑƒÑÑ‚Ð¾Ñ‚Ñ‹',0),(484486,13458,'es','Nulos',0),(484487,13458,'de','HohlrÃ¤ume',0),(484488,13458,'en','Voids',0),(484489,13459,'is','',0),(484490,13459,'dr','Ú©Ø¯Ù‡Ø§ÛŒ Ù‡Ø²ÛŒÙ†Ù‡',0),(484491,13459,'pr','Ú©Ø¯Ù‡Ø§ÛŒ Ù‡Ø²ÛŒÙ†Ù‡',0),(484492,13459,'tr','Maliyet kodlarÄ±',0),(484493,13459,'pl','Koszt kody',0),(484494,13459,'bg','ÐšÐ¾Ð´Ð¾Ð²Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(484495,13459,'ur','Ù„Ø§Ú¯Øª Ø±Ù…ÙˆØ²',0),(484496,13459,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÑˆÐ¸Ñ„Ñ€Ðµ',0),(484497,13459,'vi','Chi phÃ­ mÃ£',0),(484498,13459,'af','Koste kodes',0),(484499,13459,'ro','Coduri de cost',0),(484500,13459,'et','Kulu koodid',0),(484501,13459,'si','StroÅ¡kovno kode',0),(484502,13459,'ba','Kode biaya',0),(484503,13459,'nl','Kosten Codes',0),(484504,13459,'fi','Kustannus koodeja',0),(484505,13459,'no','Pris koder',0),(484506,13459,'da','Omkostninger koder',0),(484507,13459,'ko','ë¹„ìš©ëœ ì½”ë“œ',0),(484508,13459,'he','×§×•×“×™ ×¢×œ×•×ª',0),(484509,13459,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚',0),(484510,13459,'zh','æˆæœ¬çš„ä»£ç ',0),(484511,13459,'sv','Kostnad koder',0),(484512,13459,'it','Codici di costo',0),(484513,13459,'tl','',0),(484514,13459,'th','à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(484515,13459,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡à¥à¤¸',0),(484516,13459,'ms','Kod kos',0),(484517,13459,'ar','Ø±Ù…ÙˆØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(484518,13459,'fr','Codes de coÃ»t',0),(484519,13459,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰',0),(484520,13459,'pt','CÃ³digos de custo',0),(484521,13459,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´Ñ‹',0),(484522,13459,'es','CÃ³digos de Costos',0),(484523,13459,'de','Kosten-Codes',0),(484524,13459,'en','Cost Codes',0),(484525,13460,'is','',0),(484526,13460,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù„ÛŒØ³Øª',0),(484527,13460,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù„ÛŒØ³Øª',0),(484528,13460,'tr','GÃ¶rÃ¼nÃ¼m listesi',0),(484529,13460,'pl','Widok listy',0),(484530,13460,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ¿Ð¸ÑÑŠÐºÐ°',0),(484531,13460,'ur','Ù…Ù†Ø¸Ø± ÙÛØ±Ø³Øª',0),(484532,13460,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð»Ð¸ÑÑ‚Ðµ',0),(484533,13460,'vi','Xem danh sÃ¡ch',0),(484534,13460,'af','Bekyk lys',0),(484535,13460,'ro','Vezi lista',0),(484536,13460,'et','Kuva loend',0),(484537,13460,'si','Ogled seznama',0),(484538,13460,'ba','Lihat daftar',0),(484539,13460,'nl','Bekijk de lijst',0),(484540,13460,'fi','NÃ¤ytÃ¤ luettelo',0),(484541,13460,'no','Vis liste',0),(484542,13460,'da','Se liste',0),(484543,13460,'ko','ëª©ë¡ ë³´ê¸°',0),(484544,13460,'he','×”×¦×’ ×¨×©×™×ž×”',0),(484545,13460,'el','Î ÏÎ¿Î²Î¿Î»Î® Î»Î¯ÏƒÏ„Î±Ï‚',0),(484546,13460,'zh','æŸ¥çœ‹åˆ—è¡¨',0),(484547,13460,'sv','Visa lista',0),(484548,13460,'it','Vedi la lista dei',0),(484549,13460,'tl','',0),(484550,13460,'th','à¸”à¸¹à¸£à¸²à¸¢à¸à¸²à¸£',0),(484551,13460,'hi','à¤¸à¥‚à¤šà¥€ à¤¦à¥‡à¤–à¥‡à¤‚',0),(484552,13460,'ms','Lihat senarai',0),(484553,13460,'ar','Ø¹Ø±Ø¶ Ù‚Ø§Ø¦Ù…Ø©',0),(484554,13460,'fr','Liste d\'affichage',0),(484555,13460,'jp','ãƒ“ãƒ¥ãƒ¼ã®ä¸€è¦§',0),(484556,13460,'pt','Ver lista',0),(484557,13460,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(484558,13460,'es','Visualizar la Lista',0),(484559,13460,'de','Anzeigeliste',0),(484560,13460,'en','View List',0),(484561,13461,'is','',0),(484562,13461,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(484563,13461,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(484564,13461,'tr','SatÄ±cÄ± miktar gÃ¼ncelleÅŸtirmede hata fiyatlandÄ±rma',0),(484565,13461,'pl','BÅ‚Ä…d podczas aktualizowania dostawcy iloÅ›Ä‡ cen',0),(484566,13461,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ†ÐµÐ½Ð¸',0),(484567,13461,'ur','ÙˆÛŒÙ†ÚˆØ± Ù…Ù‚Ø¯Ø§Ø± Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ†',0),(484568,13461,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(484569,13461,'vi','Lá»—i Cáº­p Nháº­t nhÃ  cung cáº¥p sá»‘ lÆ°á»£ng giÃ¡ cáº£',0),(484570,13461,'af','Fout verkoper hoeveelheid bywerking pryse',0),(484571,13461,'ro','Eroare la actualizarea furnizor cantitatea de stabilire a preÅ£urilor',0),(484572,13461,'et','TÃµrge hankija sisestamiskogus hinnakujundus',0),(484573,13461,'si','Napaka pri posodabljanju dobavitelja koliÄina cen',0),(484574,13461,'ba','Kesalahan update jumlah Vendor harga',0),(484575,13461,'nl','Fout bij het bijwerken van leverancier hoeveelheid prijzen',0),(484576,13461,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ toimittajan mÃ¤Ã¤rÃ¤ hinnoittelu',0),(484577,13461,'no','Feil leverandÃ¸r oppdateringsantall priser',0),(484578,13461,'da','Fejl under opdatering af kreditor mÃ¦ngde prissÃ¦tning',0),(484579,13461,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ê³µê¸‰ ì—…ì²´ ìˆ˜ëŸ‰ ê°€ê²©',0),(484580,13461,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×”×¡×¤×§ ×›×ž×•×ª ×ª×ž×—×•×¨',0),(484581,13461,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(484582,13461,'zh','æ›´æ–°ä¾›åº”å•†æ•°é‡çš„é”™è¯¯å®šä»·',0),(484583,13461,'sv','Gick inte att uppdatera leverantÃ¶r kvantitet prissÃ¤ttning',0),(484584,13461,'it','Errore di aggiornamento Vendor quantitÃ  prezzi',0),(484585,13461,'tl','',0),(484586,13461,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸µà¹ˆà¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸à¸³à¸«à¸™à¸”à¸£à¸²à¸„à¸²',0),(484587,13461,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(484588,13461,'ms','Ralat dalam mengemas kini pembekal kuantiti harga',0),(484589,13461,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(484590,13461,'fr','Erreur mise Ã  jour de fournisseur quantitÃ© prix',0),(484591,13461,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®æ•°é‡ã®æ›´æ–°ã‚¨ãƒ©ãƒ¼ã®ä¾¡æ ¼',0),(484592,13461,'pt','Erro ao atualizar a quantidade de fornecedores preÃ§os',0),(484593,13461,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ñ†ÐµÐ½Ñ‹',0),(484594,13461,'es','Error Actualizando Precios en Cantidades del Proveedor',0),(484595,13461,'de','Fehler beim Aktualisieren der Anbieter Menge Preise',0),(484596,13461,'en','Error Updating Vendor Quantity Pricing',0),(484597,13462,'is','',0),(484598,13462,'dr','Ø§Ø²/Ø¨Ù‡',0),(484599,13462,'pr','Ø§Ø²/Ø¨Ù‡',0),(484600,13462,'tr','/',0),(484601,13462,'pl','Z/do',0),(484602,13462,'bg','ÐžÑ‚ Ð´Ð¾',0),(484603,13462,'ur','Ø³Û’/Ú©Ø±Ù†Ø§',0),(484604,13462,'sr','Ð¡Ð°',0),(484605,13462,'vi','Tá»«/Ä‘áº¿n',0),(484606,13462,'af','Vanaf/na',0),(484607,13462,'ro','La',0),(484608,13462,'et','Alates/kuni',0),(484609,13462,'si','Od/do',0),(484610,13462,'ba','Dari/ke',0),(484611,13462,'nl','Van/naar',0),(484612,13462,'fi','Edestakainen',0),(484613,13462,'no','Fra',0),(484614,13462,'da','Fra/til',0),(484615,13462,'ko','/',0),(484616,13462,'he','×ž/××œ',0),(484617,13462,'el','Î‘Ï€ÏŒ/Ï€ÏÎ¿Ï‚',0),(484618,13462,'zh','ä»Žåˆ°',0),(484619,13462,'sv','FrÃ¥n/till',0),(484620,13462,'it','Da/per',0),(484621,13462,'tl','',0),(484622,13462,'th','à¸ˆà¸²à¸/à¹„à¸›à¸¢à¸±à¸‡',0),(484623,13462,'hi','à¤¸à¥‡/à¤•à¥‹',0),(484624,13462,'ms','Dari/ke',0),(484625,13462,'ar','Ù…Ù† ÙˆØ¥Ù„Ù‰',0),(484626,13462,'fr','De/Ã ',0),(484627,13462,'jp','/ã¸',0),(484628,13462,'pt','De',0),(484629,13462,'ru','Ð˜Ð·/Ð²',0),(484630,13462,'es','Desde/A',0),(484631,13462,'de','Von/nach',0),(484632,13462,'en','From/To',0),(484633,13463,'is','',0),(484634,13463,'dr','Ø¯Ø± Ø¯Ø³Øª Ù¾Ø³ Ø§Ø²',0),(484635,13463,'pr','Ø¯Ø± Ø¯Ø³Øª Ù¾Ø³ Ø§Ø²',0),(484636,13463,'tr','Sonra taraftan',0),(484637,13463,'pl','Na rÄ™kÄ™ po',0),(484638,13463,'bg','ÐÐ° ÑÐºÐ»Ð°Ð´ ÑÐ»ÐµÐ´',0),(484639,13463,'ur','Ú©Û’ Ø¨Ø¹Ø¯ ÛØ§ØªÚ¾ Ù¾Ø±',0),(484640,13463,'sr','ÐÐ° Ñ€ÑƒÑ†Ð¸ Ð½Ð°ÐºÐ¾Ð½',0),(484641,13463,'vi','Máº·t sau',0),(484642,13463,'af','Op Hand na',0),(484643,13463,'ro','Pe de parte dupÄƒ',0),(484644,13463,'et','Laos pÃ¤rast',0),(484645,13463,'si','Na strani po',0),(484646,13463,'ba','Di tangan setelah',0),(484647,13463,'nl','Aan de kant na',0),(484648,13463,'fi','KÃ¤den jÃ¤lkeen',0),(484649,13463,'no','Beholdningen etter',0),(484650,13463,'da','PÃ¥ hÃ¥nden efter',0),(484651,13463,'ko','í›„ ì†ìœ¼ë¡œ',0),(484652,13463,'he','×¢×œ ×”×™×“ ×œ××—×¨',0),(484653,13463,'el','Î£Ï‡ÎµÏ„Î¹ÎºÎ¬ Î¼Îµ Ï„Î¿ Ï‡Î­ÏÎ¹ Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ',0),(484654,13463,'zh','åŽæ‰‹ä¸Š',0),(484655,13463,'sv','Ã… efter',0),(484656,13463,'it','Sulla mano dopo',0),(484657,13463,'tl','',0),(484658,13463,'th','à¸„à¸£à¸­à¸‡à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸',0),(484659,13463,'hi','à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¹à¤¾à¤¥ à¤ªà¤°',0),(484660,13463,'ms','Bersedia selepas',0),(484661,13463,'ar','ÙˆÙ…Ù† Ù†Ø§Ø­ÙŠØ© Ø¨Ø¹Ø¯',0),(484662,13463,'fr','Part aprÃ¨s',0),(484663,13463,'jp','å¾Œã®æ‰‹ã«',0),(484664,13463,'pt','Na mÃ£o apÃ³s',0),(484665,13463,'ru','ÐÐ° Ñ€ÑƒÐºÐµ Ð¿Ð¾ÑÐ»Ðµ',0),(484666,13463,'es','Disponible DespuÃ©s',0),(484667,13463,'de','Auf der Seite nach',0),(484668,13463,'en','On Hand After',0),(484669,13464,'is','',0),(484670,13464,'dr','Ù‚Ø¨Ù„ÛŒ Ø¯Ø± Ø¯Ø³Øª',0),(484671,13464,'pr','Ù‚Ø¨Ù„ÛŒ Ø¯Ø± Ø¯Ø³Øª',0),(484672,13464,'tr','Ã–nceki elde',0),(484673,13464,'pl','Poprzedniej strony',0),(484674,13464,'bg','ÐŸÑ€ÐµÐ´Ð¸ÑˆÐ½Ð° ÑÑ‚Ñ€Ð°Ð½Ð°',0),(484675,13464,'ur','Ù¾Ú†Ú¾Ù„ÛŒ Ø¬Ø§Ù†Ø¨',0),(484676,13464,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾ Ñƒ Ñ€ÑƒÐºÑƒ',0),(484677,13464,'vi','TrÆ°á»›c máº·t',0),(484678,13464,'af','Vorige op Hand',0),(484679,13464,'ro','Anterior pe mÃ¢nÄƒ',0),(484680,13464,'et','Eelmine kÃ¤si',0),(484681,13464,'si','PrejÅ¡nji strani',0),(484682,13464,'ba','Sebelumnya di tangan',0),(484683,13464,'nl','Vorige op Hand',0),(484684,13464,'fi','Edellinen kÃ¤si',0),(484685,13464,'no','Tidligere pÃ¥ siden',0),(484686,13464,'da','Tidligere pÃ¥ hÃ¥nd',0),(484687,13464,'ko','ë°˜ë©´ì— ì´ì „',0),(484688,13464,'he','×”×§×•×“× ×¢×œ ×”×™×“',0),(484689,13464,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Î±Ï†',0),(484690,13464,'zh','ä»¥å‰åœ¨æ‰‹ä¸Š',0),(484691,13464,'sv','Tidigare Ã¥',0),(484692,13464,'it','Precedente sulla mano',0),(484693,13464,'tl','',0),(484694,13464,'th','à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰à¸„à¸‡',0),(484695,13464,'hi','à¤ªà¤¿à¤›à¤²à¤¾ à¤¹à¤¾à¤¥ à¤ªà¤°',0),(484696,13464,'ms','Lepas pada tangan',0),(484697,13464,'ar','Ø§Ù„Ø³Ø§Ø¨Ù‚Ø© Ø¹Ù„Ù‰ ÙŠØ¯',0),(484698,13464,'fr','PrÃ©cÃ©dente sur la main',0),(484699,13464,'jp','æ‰‹ã®å‰',0),(484700,13464,'pt','Anterior na mÃ£o',0),(484701,13464,'ru','Ð Ð°Ð½ÐµÐµ Ð½Ð° Ñ€ÑƒÐºÐµ',0),(484702,13464,'es','Previos Disponibles',0),(484703,13464,'de','ZurÃ¼ck auf der Seite',0),(484704,13464,'en','Previous On Hand',0),(484705,13465,'is','',0),(484706,13465,'dr','ÙØ§ÛŒÙ„ Ø¢Ù…Ø§Ø¯Ù‡ ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø³Øª',0),(484707,13465,'pr','ÙØ§ÛŒÙ„ Ø¢Ù…Ø§Ø¯Ù‡ ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø³Øª',0),(484708,13465,'tr','DosyalarÄ± aktarmak iÃ§in hazÄ±r',0),(484709,13465,'pl','Pliki nie sÄ… gotowe do importu',0),(484710,13465,'bg','Ð¤Ð°Ð¹Ð»Ð¾Ð²ÐµÑ‚Ðµ ÑÐ° Ð³Ð¾Ñ‚Ð¾Ð²Ð¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(484711,13465,'ur','Ù…Ø³Ù„ÛŒÚº Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ØªÛŒØ§Ø± ÛÛŒÚº Û”',0),(484712,13465,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÑÑƒ ÑÐ¿Ñ€ÐµÐ¼Ð½Ðµ Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(484713,13465,'vi','Táº­p tin Ä‘Ã£ sáºµn sÃ ng Ä‘á»ƒ nháº­p kháº©u',0),(484714,13465,'af','LÃªers is gereed om te voer',0),(484715,13465,'ro','FiÅŸierele sunt gata de Import',0),(484716,13465,'et','Failid on kirjutamiseks valmis Import',0),(484717,13465,'si','Datoteke so pripravljene za uvoz',0),(484718,13465,'ba','File siap untuk impor',0),(484719,13465,'nl','Bestanden zijn klaar om te importeren',0),(484720,13465,'fi','Tiedostot ovat valmiita tuo',0),(484721,13465,'no','Filene er klare for Import',0),(484722,13465,'da','Filerne er klar til Import',0),(484723,13465,'ko','íŒŒì¼ì€ ê°€ì ¸ì˜¤ê¸° ì¤€ë¹„',0),(484724,13465,'he','×§×‘×¦×™× ×ž×•×›× ×™× ×œ×™×™×‘×•×',0),(484725,13465,'el','Î‘ÏÏ‡ÎµÎ¯Î± ÎµÎ¯Î½Î±Î¹ Î­Ï„Î¿Î¹Î¼Î± Î³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(484726,13465,'zh','æ–‡ä»¶å‡†å¤‡å¥½å¯¼å…¥',0),(484727,13465,'sv','Filer Ã¤r redo att importera',0),(484728,13465,'it','I file sono pronti per l\'importazione',0),(484729,13465,'tl','',0),(484730,13465,'th','à¹à¸Ÿà¹‰à¸¡à¸žà¸£à¹‰à¸­à¸¡à¸—à¸µà¹ˆà¸ˆà¸°à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(484731,13465,'hi','à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¯à¤¾à¤° à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚',0),(484732,13465,'ms','Fail yang bersedia untuk Import',0),(484733,13465,'ar','Ù…Ù„ÙØ§Øª Ø¬Ø§Ù‡Ø²Ø© Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(484734,13465,'fr','Fichiers sont prÃªts Ã  l\'importation',0),(484735,13465,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹æº–å‚™ãŒã§ãã¦ã„ã¾ã™ã€‚',0),(484736,13465,'pt','Arquivos estÃ£o prontos para importaÃ§Ã£o',0),(484737,13465,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ Ð³Ð¾Ñ‚Ð¾Ð²Ñ‹ Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(484738,13465,'es','Files Estan Listos Para Importar',0),(484739,13465,'de','Dateien sind bereit, Import',0),(484740,13465,'en','Files Are Ready To Import',0),(484741,13466,'is','',0),(484742,13466,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ÛŒÚ© ÙØ§ÛŒÙ„ Ù¾Ø±Ø´ÛŒÙ† Ø¨Ø§Ù„Ø§ Ùˆ ÛŒØ§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾Ø±Ø¯Ø§Ø²Ø´ ØµØ§Ø¯Ø± Ú©Ø±Ø¯Ù† Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± Ø¨Ø§ Ú©Ù„ÛŒÚ© Ø±ÙˆÛŒ Ø§ÛŒÙ† Ù„ÛŒÙ†Ú©',0),(484743,13466,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ÛŒÚ© ÙØ§ÛŒÙ„ Ù¾Ø±Ø´ÛŒÙ† Ø¨Ø§Ù„Ø§ Ùˆ ÛŒØ§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾Ø±Ø¯Ø§Ø²Ø´ ØµØ§Ø¯Ø± Ú©Ø±Ø¯Ù† Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± Ø¨Ø§ Ú©Ù„ÛŒÚ© Ø±ÙˆÛŒ Ø§ÛŒÙ† Ù„ÛŒÙ†Ú©',0),(484744,13466,'tr','QuickBooks eÄŸe yukarÄ±da almak veya bu baÄŸlantÄ±yÄ± tÄ±klatarak el ile verme iÅŸlemini kullanÄ±n',0),(484745,13466,'pl','Importuj plik QuickBooks powyÅ¼ej lub uÅ¼yj procesu obsÅ‚ugi eksportu klikajÄ…c ten Link',0),(484746,13466,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° QuickBooks Ñ„Ð°Ð¹Ð» Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ Ð¸Ð»Ð¸ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ° Ð½Ð° Ñ€ÑŠÑ‡Ð½Ð¾ ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ñ‚Ð¾ ÐºÐ»Ð¸ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ñ‚Ð°Ð·Ð¸ Ð²Ñ€ÑŠÐ·ÐºÐ°',0),(484747,13466,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ø¨Ø§Ù„Ø§ Ù…Ø³Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº ÛŒØ§ Ø§Ø³ Ù„Ù†Ú© Ù¾Ø± Ú©Ù„Ú© Ú©Ø±Ú©Û’ Ø¯Ø³ØªÛŒ Ø¨Ø±Ø¢Ù…Ø¯ Ø¹Ù…Ù„ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(484748,13466,'sr','Ð£Ð²Ð¾Ð· Ð¸Ð·Ð½Ð°Ð´ QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð¸Ð»Ð¸ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑ Ñ€ÑƒÑ‡Ð½Ð¾Ð³ Ð¸Ð·Ð²Ð¾Ð·Ð° ÐºÐ»Ð¸ÐºÐ¾Ð¼ Ð½Ð° Ð¾Ð²Ð°Ñ˜ Ð›Ð¸Ð½Ðº',0),(484749,13466,'vi','Nháº­p má»™t tá»‡p QuickBooks á»Ÿ trÃªn hoáº·c sá»­ dá»¥ng trÃ¬nh hÆ°á»›ng dáº«n sá»­ dá»¥ng xuáº¥t kháº©u báº±ng cÃ¡ch nháº¥p vÃ o liÃªn káº¿t nÃ y',0),(484750,13466,'af','\'N QuickBooks bogenoemde lÃªer invoer of gebruik die handleiding uitvoerproses deur hierdie skakel te klik',0),(484751,13466,'ro','Import fiÅŸier QuickBooks mai sus sau de a folosi procesul de Manual Export fÄƒcÃ¢nd clic pe acest Link',0),(484752,13466,'et','Ãœlaltoodud QuickBooks faili importimine vÃµi kasutada kÃ¤sitsi Ekspordiprotsess avamiseks klÃµpsake seda linki',0),(484753,13466,'si','Uvozite datoteko QuickBooks zgoraj ali uporabite roÄno izvozom s klikom na to povezavo',0),(484754,13466,'ba','Mengimpor File QuickBooks di atas atau menggunakan proses ekspor Manual dengan mengklik Link ini',0),(484755,13466,'nl','Importeren van een QuickBooks-bestand hierboven of gebruik het handmatige exportproces door te klikken op deze Link',0),(484756,13466,'fi','Tuoda QuickBooks arkistoida edellÃ¤ tai kÃ¤yttÃ¤Ã¤ manuaalinen vientiprosessi klikkaamalla tÃ¤tÃ¤ linkkiÃ¤',0),(484757,13466,'no','Importere en QuickBooks-fil ovenfor eller bruke manuelle prosessen ved Ã¥ klikke',0),(484758,13466,'da','Importere en QuickBooks fil ovenfor eller bruge manuel eksport-processen ved at klikke pÃ¥ dette Link',0),(484759,13466,'ko','ìœ„ì˜ QuickBooks íŒŒì¼ì„ ê°€ì ¸ì˜¤ê¸° ë˜ëŠ” ìˆ˜ë™ ë‚´ë³´ë‚´ê¸° í”„ë¡œì„¸ìŠ¤ë¥¼ ì‚¬ìš© í•˜ ì—¬ì´ ë§í¬ë¥¼ í´ë¦­ í•˜ ì—¬',0),(484760,13466,'he','×™×™×‘×•× ×§×•×‘×¥ QuickBooks ×œ×¢×™×œ ××• ×©×™×ž×•×© ×ª×”×œ×™×š ×”×™×™×¦×•× ×™×“× ×™×ª ×¢×œ-×™×“×™ ×œ×—×™×¦×” ×¢×œ ×§×™×©×•×¨ ×–×”',0),(484761,13466,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÎ½ÏŒÏ‚ Î±ÏÏ‡ÎµÎ¯Î¿Ï… QuickBooks Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ Î® Ï‡ÏÎ®ÏƒÎ· Ï„Î·Ï‚ Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î±Ï‚ Î¼Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ¾Î±Î³Ï‰Î³Î® ÎºÎ¬Î½Î¿Î½Ï„Î±Ï‚ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ',0),(484762,13466,'zh','å¯¼å…¥ä¸Šè¿° QuickBooks æ–‡ä»¶æˆ–é€šè¿‡å•å‡»æ­¤é“¾æŽ¥å¯ä½¿ç”¨æ‰‹åŠ¨å¯¼å‡ºè¿‡ç¨‹',0),(484763,13466,'sv','Importera QuickBooks ovan eller AnvÃ¤nd manuell exporten genom att klicka pÃ¥ denna lÃ¤nk',0),(484764,13466,'it','Importare un File QuickBooks sopra o utilizzare il processo di esportazione manuale cliccando questo Link',0),(484765,13466,'tl','',0),(484766,13466,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹à¸Ÿà¹‰à¸¡ QuickBooks à¸‚à¹‰à¸²à¸‡à¸•à¹‰à¸™ à¸«à¸£à¸·à¸­à¹ƒà¸Šà¹‰à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡ à¹‚à¸”à¸¢à¸„à¸¥à¸´à¸à¸à¸²à¸£à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡à¸™à¸µà¹‰',0),(484767,13466,'hi','à¤à¤• QuickBooks à¤‰à¤ªà¤°à¥‹à¤•à¥à¤¤ à¤«à¤¼à¤¾à¤‡à¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤‡à¤¸ à¤²à¤¿à¤‚à¤• à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¤•à¥‡ à¤®à¥ˆà¤¨à¥à¤…à¤² à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(484768,13466,'ms','Mengimport fail QuickBooks di atas atau menggunakan proses eksport secara Manual dengan mengklik pautan ini',0),(484769,13466,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù„Ù Ù‚Ø±Ø§Ø¡ Ø£Ø¹Ù„Ø§Ù‡ Ø£Ùˆ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¹Ù…Ù„ÙŠØ© ØªØµØ¯ÙŠØ± ÙŠØ¯ÙˆÙŠØ§Ù‹ Ø¨ÙˆØ§Ø³Ø·Ø© Ø§Ù„Ù†Ù‚Ø± ÙÙˆÙ‚ Ù‡Ø°Ø§ Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø·',0),(484770,13466,'fr','Importer un fichier de QuickBooks ci-dessus ou utiliser le processus d\'exportation manuelle en cliquant sur ce lien',0),(484771,13466,'jp','ä¸Šè¨˜ã® QuickBooks ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã¾ãŸã¯ã“ã®ãƒªãƒ³ã‚¯ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦ã€æ‰‹å‹•ã§ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ—ãƒ­ã‚»ã‚¹ã‚’ä½¿ç”¨',0),(484772,13466,'pt','Importar um arquivo de QuickBooks acima ou Use o processo de exportaÃ§Ã£o Manual clicando neste Link',0),(484773,13466,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ñ„Ð°Ð¹Ð»Ð° QuickBooks Ð²Ñ‹ÑˆÐµ Ð¸Ð»Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÑÑ Ñ€ÑƒÑ‡Ð½Ð¾Ð¹ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°, Ð½Ð°Ð¶Ð°Ð² ÑÑ‚Ñƒ ÑÑÑ‹Ð»ÐºÑƒ',0),(484774,13466,'es','Importa a File de Quickbooks Arriba, O Usa el Proceso de ExportaciÃ³n Manual Por Click en Este Enlace',0),(484775,13466,'de','Importieren Sie eine oben genannte QuickBooks-Datei oder verwenden Sie den manuellen Exportprozess durch Klicken auf diesen Link',0),(484776,13466,'en','Import A QuickBooks File Above Or Use The Manual Export Process By Clicking This Link',0),(484777,13467,'is','',0),(484778,13467,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø² ÙØ§ÛŒÙ„ Ù‡Ø§ÛŒ Ø¯ÛŒÚ¯Ø± .qbw',0),(484779,13467,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø² ÙØ§ÛŒÙ„ Ù‡Ø§ÛŒ Ø¯ÛŒÚ¯Ø± .qbw',0),(484780,13467,'tr','BaÅŸka bir .qbw dosyasÄ±ndan iÃ§e aktarma',0),(484781,13467,'pl','Import z innego pliku .qbw',0),(484782,13467,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ñ€ÑƒÐ³ .qbw Ñ„Ð°Ð¹Ð»',0),(484783,13467,'ur','Ø§ÛŒÚ© .qbw Ù…Ø³Ù„ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(484784,13467,'sr','Ð£Ð²Ð¾Ð· Ð¸Ð· Ð´Ñ€ÑƒÐ³Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ .qÐ±w',0),(484785,13467,'vi','Chuyá»ƒn nháº­p tá»« má»™t .qbw táº­p tin',0),(484786,13467,'af','Voer in uit \'n ander .qbw lÃªer',0),(484787,13467,'ro','Import din alt fisier .qbw',0),(484788,13467,'et','Impordi failist teise .qbw',0),(484789,13467,'si','Uvoz iz druge datoteke .qbw',0),(484790,13467,'ba','Impor dari File .qbw lain',0),(484791,13467,'nl','Gegevens importeren uit een ander .qbw bestand',0),(484792,13467,'fi','Tuo toinen .qbw tiedostosta',0),(484793,13467,'no','Import fra en annen .qbw fil',0),(484794,13467,'da','Import fra en anden .qbw fil',0),(484795,13467,'ko','ë‹¤ë¥¸.qbw íŒŒì¼ì—ì„œ ê°€ì ¸ì˜¤ê¸°',0),(484796,13467,'he','×™×™×‘×•× ×ž×§×•×‘×¥ .qbw ××—×¨',0),(484797,13467,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€ÏŒ Î¬Î»Î»Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ .qbw',0),(484798,13467,'zh','ä»Žå¦ä¸€ä¸ª.qbw æ–‡ä»¶å¯¼å…¥',0),(484799,13467,'sv','Importera frÃ¥n en annan .qbw fil',0),(484800,13467,'it','Importazione da un altro File .qbw',0),(484801,13467,'tl','',0),(484802,13467,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸²à¸à¹à¸Ÿà¹‰à¸¡.qbw à¸­à¸·à¹ˆà¸™',0),(484803,13467,'hi','à¤à¤• à¤”à¤° .qbw à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(484804,13467,'ms','Import daripada fail .qbw yang lain',0),(484805,13467,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù† Ù…Ù„Ù.qbw Ø¢Ø®Ø±',0),(484806,13467,'fr','Importation depuis un autre fichier .qbw',0),(484807,13467,'jp','åˆ¥ã® .qbw ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(484808,13467,'pt','ImportaÃ§Ã£o de outro arquivo de .qbw',0),(484809,13467,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¸Ð· Ð´Ñ€ÑƒÐ³Ð¾Ð³Ð¾ Ñ„Ð°Ð¹Ð»Ð° .qbw',0),(484810,13467,'es','Importa De Otro File de .qbw',0),(484811,13467,'de','Import aus einer anderen Datei in .qbw',0),(484812,13467,'en','Import From Another .qbw File',0),(484813,13468,'is','',0),(484814,13468,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø² ÙØ§ÛŒÙ„ .qbw',0),(484815,13468,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø² ÙØ§ÛŒÙ„ .qbw',0),(484816,13468,'tr','.Qbw dosyasÄ±ndan iÃ§e aktarma',0),(484817,13468,'pl','Import z pliku .qbw',0),(484818,13468,'bg','Ð’Ð½Ð¾Ñ Ð¾Ñ‚ .qbw Ñ„Ð°Ð¹Ð»',0),(484819,13468,'ur','.Qbw Ù…Ø³Ù„ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(484820,13468,'sr','Ð£Ð²ÐµÐ·Ð¸ Ð¸Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ .qÐ±w',0),(484821,13468,'vi','Nháº­p kháº©u tá»« .qbw táº­p tin',0),(484822,13468,'af','Voer in vanaf .qbw lÃªer',0),(484823,13468,'ro','Importul din fisierul .qbw',0),(484824,13468,'et','.Qbw faili importimine',0),(484825,13468,'si','Uvoz iz datoteke .qbw',0),(484826,13468,'ba','Impor dari .qbw File',0),(484827,13468,'nl','Importeren uit .qbw bestand',0),(484828,13468,'fi','Tuo .qbw tiedostosta',0),(484829,13468,'no','Import fra .qbw fil',0),(484830,13468,'da','Import fra .qbw fil',0),(484831,13468,'ko','.Qbw íŒŒì¼ì—ì„œ ê°€ì ¸ì˜¤ê¸°',0),(484832,13468,'he','×™×™×‘×•× ×ž×§×•×‘×¥ .qbw',0),(484833,13468,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€ÏŒ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ .qbw',0),(484834,13468,'zh','ä»Ž.qbw æ–‡ä»¶å¯¼å…¥',0),(484835,13468,'sv','Importera frÃ¥n .qbw fil',0),(484836,13468,'it','Importazione da File .qbw',0),(484837,13468,'tl','',0),(484838,13468,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸²à¸à¹à¸Ÿà¹‰à¸¡.qbw',0),(484839,13468,'hi','.Qbw à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(484840,13468,'ms','Import dari fail .qbw',0),(484841,13468,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù† Ù…Ù„Ù.qbw',0),(484842,13468,'fr','Importation du fichier .qbw',0),(484843,13468,'jp','.Qbw ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(484844,13468,'pt','ImportaÃ§Ã£o de arquivo de .qbw',0),(484845,13468,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¸Ð· Ñ„Ð°Ð¹Ð»Ð° .qbw',0),(484846,13468,'es','Importa De File de .qbw',0),(484847,13468,'de','Import von .qbw Datei',0),(484848,13468,'en','Import From .qbw File',0),(484849,13469,'is','',0),(484850,13469,'dr','Ù„Ø·ÙØ§ ÙØ¹Ø§Ù„ ÙØ±Ù…Øª Ø­Ù„Ù‚Ù‡ Ù‚Ø¨Ù„ Ø§Ø² ØªØ¨Ø¯ÛŒÙ„ Ø§Ø² Ù¾Ø±Ø´ÛŒÙ†',0),(484851,13469,'pr','Ù„Ø·ÙØ§ ÙØ¹Ø§Ù„ ÙØ±Ù…Øª Ø­Ù„Ù‚Ù‡ Ù‚Ø¨Ù„ Ø§Ø² ØªØ¨Ø¯ÛŒÙ„ Ø§Ø² Ù¾Ø±Ø´ÛŒÙ†',0),(484852,13469,'tr','QuickBooks dÃ¶nÃ¼ÅŸtÃ¼rmeden Ã¶nce Curl uzatma lÃ¼tfen etkinleÅŸtirmek',0),(484853,13469,'pl','Prosimy aktywowaÄ‡ Curl Extension przed konwersjÄ… z QuickBooks',0),(484854,13469,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð½Ð°Ð²Ð¸Ð¹Ñ‚Ðµ Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¸Ðµ Ð¿Ñ€ÐµÐ´Ð¸ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚ QuickBooks',0),(484855,13469,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ù…ÙˆÚ‘Ù†Ø§ ØªÙˆØ³ÛŒØ¹ Ø³Û’ Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(484856,13469,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¿Ñ€Ð¾ÑˆÐ¸Ñ€ÐµÑšÐµ Ð½Ð° ÑÐ°Ð²Ð¸Ñ˜Ð°ÑšÐµ Ð¿Ñ€Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ð²Ð°ÑšÐ° Ð¸Ð· QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ',0),(484857,13469,'vi','Xin vui lÃ²ng kÃ­ch hoáº¡t pháº§n má»Ÿ rá»™ng Curl trÆ°á»›c khi chuyá»ƒn Ä‘á»•i tá»« QuickBooks',0),(484858,13469,'af','Aktiveer asseblief die krul uitbreiding voor die omskakeling van QuickBooks',0),(484859,13469,'ro','VÄƒ rugÄƒm sÄƒ activaÅ£i extensia Curl Ã®nainte de conversia la QuickBooks',0),(484860,13469,'et','Aktiveerige enne teisendamist QuickBooks Curl laiendamine',0),(484861,13469,'si','Aktivirajte Curl podaljÅ¡anje pred pretvorbo iz QuickBooks',0),(484862,13469,'ba','Silakan Aktifkan ekstensi Curl sebelum mengkonversi dari QuickBooks',0),(484863,13469,'nl','Activeer de Curl uitbreiding voordat u QuickBooks converteert',0),(484864,13469,'fi','Aktivoi Curl laajennus ennen kuin vaihdat QuickBooks',0),(484865,13469,'no','Aktiver Curl forlengelse fÃ¸r konvertering fra QuickBooks',0),(484866,13469,'da','Aktiver venligst Curl udvidelse fÃ¸r konvertering fra QuickBooks',0),(484867,13469,'ko','QuickBooksì—ì„œ ë³€í™˜ í•˜ê¸° ì „ì— ì»¬ í™•ìž¥ í™œì„±í™”',0),(484868,13469,'he','×‘×‘×§×©×” ×œ×”×¤×¢×™×œ ××ª ×”×¡×™×•×ž×ª ×§×•×¨×œ ×œ×¤× ×™ ×‘×™×¦×•×¢ ×”×”×ž×¨×” ×ž- QuickBooks',0),(484869,13469,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î·Î½ ÎµÏ€Î­ÎºÏ„Î±ÏƒÎ· Î¼Ï€Î¿ÏÎºÎ»Î± Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î· Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î® Î±Ï€ÏŒ QuickBooks',0),(484870,13469,'zh','è¯·ä»Ž QuickBooks è½¬æ¢ä¹‹å‰æ¿€æ´» Curl æ‰©å±•',0),(484871,13469,'sv','VÃ¤nligen aktivera tillÃ¤gget Curl innan du konverterar frÃ¥n SPCS',0),(484872,13469,'it','Si prega di attivare l\'estensione Curl prima della conversione da QuickBooks',0),(484873,13469,'tl','',0),(484874,13469,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸ªà¹ˆà¸§à¸™à¸‚à¸¢à¸²à¸¢à¸‚à¸”à¸à¹ˆà¸­à¸™à¹à¸›à¸¥à¸‡à¸ˆà¸²à¸ QuickBooks',0),(484875,13469,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤°à¥à¤² à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤¸à¥‡ QuickBooks à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(484876,13469,'ms','Sila aktifkan sambungan dedah sebelum menukar dari QuickBooks',0),(484877,13469,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªÙ†Ø´ÙŠØ· Ù…Ù„Ø­Ù‚ Ø§Ù„Ø¶ÙÙŠØ±Ø© Ù‚Ø¨Ù„ Ø§Ù„ØªØ­ÙˆÙŠÙ„ Ù…Ù† Ù‚Ø±Ø§Ø¡',0),(484878,13469,'fr','Veuillez activer l\'Extension Curl avant la conversion de QuickBooks',0),(484879,13469,'jp','QuickBooks ã‹ã‚‰å¤‰æ›ã™ã‚‹å‰ã«ã€Curl æ‹¡å¼µãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã‚’æœ‰åŠ¹ã«ã—ã¦ãã ã•ã„ã€‚',0),(484880,13469,'pt','Por favor, ative a extensÃ£o Curl antes da conversÃ£o de QuickBooks',0),(484881,13469,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€ÑƒÐ¹Ñ‚Ðµ Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð¸Ðµ Curl Ð¿ÐµÑ€ÐµÐ´ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸ÐµÐ¼ Ð¸Ð· QuickBooks',0),(484882,13469,'es','Por Favor Activar La ExtensiÃ³n Curl Antes Que Convertir de Quickbooks',0),(484883,13469,'de','Bitte aktivieren Sie die Curl-Erweiterung vor der Umwandlung von QuickBooks',0),(484884,13469,'en','Please Activate The Curl Extension Before Converting From QuickBooks',0),(484885,13470,'is','',0),(484886,13470,'dr','ØµØ§Ø¯Ø± Ú©Ø±Ø¯Ù† Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ù¾Ø±Ø´ÛŒÙ†',0),(484887,13470,'pr','ØµØ§Ø¯Ø± Ú©Ø±Ø¯Ù† Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ù¾Ø±Ø´ÛŒÙ†',0),(484888,13470,'tr','Manuel QuickBooks ihracat',0),(484889,13470,'pl','PodrÄ™cznik programu QuickBooks eksportu',0),(484890,13470,'bg','Ð ÑŠÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ Ð·Ð° QuickBooks Ð¸Ð·Ð½Ð¾Ñ',0),(484891,13470,'ur','Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ ÛØ¯Ø§ÛŒØª Ù†Ø§Ù…Û Ø¨Ø±Ø¢Ù…Ø¯',0),(484892,13470,'sr','QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ Ñ€ÑƒÑ‡Ð½Ð¸ Ð¸Ð·Ð²Ð¾Ð·',0),(484893,13470,'vi','HÆ°á»›ng dáº«n sá»­ dá»¥ng QuickBooks xuáº¥t kháº©u',0),(484894,13470,'af','QuickBooks handleiding uitvoer',0),(484895,13470,'ro','QuickBooks Manual Export',0),(484896,13470,'et','QuickBooksi kÃ¤siraamat ekspordi',0),(484897,13470,'si','Izvoz QuickBooks priroÄnik',0),(484898,13470,'ba','Ekspor QuickBooks Manual',0),(484899,13470,'nl','QuickBooks handleiding exporteren',0),(484900,13470,'fi','QuickBooks kÃ¤sikirja vienti',0),(484901,13470,'no','QuickBooks manuell eksport',0),(484902,13470,'da','QuickBooks manuel eksport',0),(484903,13470,'ko','QuickBooks ë§¤ë‰´ì–¼ ìˆ˜ì¶œ',0),(484904,13470,'he','×™×™×¦×•× QuickBooks ×™×“× ×™',0),(484905,13470,'el','Î•Î³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î¿ QuickBooks ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚',0),(484906,13470,'zh','QuickBooks æ‰‹å†Œå‡ºå£',0),(484907,13470,'sv','QuickBooks Manual Export',0),(484908,13470,'it','QuickBooks manuale esportazione',0),(484909,13470,'tl','',0),(484910,13470,'th','à¸ªà¹ˆà¸‡à¸„à¸¹à¹ˆà¸¡à¸·à¸­ QuickBooks',0),(484911,13470,'hi','QuickBooks à¤®à¥ˆà¤¨à¥à¤…à¤² à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤',0),(484912,13470,'ms','Eksport QuickBooks Manual',0),(484913,13470,'ar','ØªØµØ¯ÙŠØ± Ø¯Ù„ÙŠÙ„ Ù‚Ø±Ø§Ø¡',0),(484914,13470,'fr','Exportation de QuickBooks manuel',0),(484915,13470,'jp','QuickBooks ã®æ‰‹å‹•ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ',0),(484916,13470,'pt','ExportaÃ§Ã£o Manual de QuickBooks',0),(484917,13470,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ QuickBooks Ñ€ÑƒÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(484918,13470,'es','Quickbooks ExportaciÃ³n Manual',0),(484919,13470,'de','QuickBooks-Handbuch-Export',0),(484920,13470,'en','QuickBooks Manual Export',0),(484921,13471,'is','',0),(484922,13471,'dr','Ø§Ø±Ø³Ø§Ù„',0),(484923,13471,'pr','Ø§Ø±Ø³Ø§Ù„',0),(484924,13471,'tr','GÃ¶nderme',0),(484925,13471,'pl','WysyÅ‚anie',0),(484926,13471,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð°',0),(484927,13471,'ur','Ø¨Ú¾ÛŒØ¬ Ø±ÛØ§ ÛÛ’',0),(484928,13471,'sr','Ð¡Ð»Ð°ÑšÐµ',0),(484929,13471,'vi','Gá»­i',0),(484930,13471,'af','Stuur',0),(484931,13471,'ro','Trimiterea',0),(484932,13471,'et','Saatmine',0),(484933,13471,'si','PoÅ¡iljanje',0),(484934,13471,'ba','Pengiriman',0),(484935,13471,'nl','Verzenden',0),(484936,13471,'fi','LÃ¤hettÃ¤minen',0),(484937,13471,'no','Sende',0),(484938,13471,'da','At sende',0),(484939,13471,'ko','ë³´ë‚´ê¸°',0),(484940,13471,'he','×©×œ×™×—×ª',0),(484941,13471,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(484942,13471,'zh','å‘é€',0),(484943,13471,'sv','Skicka',0),(484944,13471,'it','Invio',0),(484945,13471,'tl','',0),(484946,13471,'th','à¸ªà¹ˆà¸‡',0),(484947,13471,'hi','à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¥‡',0),(484948,13471,'ms','Menghantar',0),(484949,13471,'ar','Ø¥Ø±Ø³Ø§Ù„',0),(484950,13471,'fr','Envoi',0),(484951,13471,'jp','é€ä¿¡ã—ã¾ã™ã€‚',0),(484952,13471,'pt','Envio de',0),(484953,13471,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²ÐºÐ°',0),(484954,13471,'es','Enviando',0),(484955,13471,'de','Senden',0),(484956,13471,'en','Sending',0),(484957,13472,'is','',0),(484958,13472,'dr','ÙØ±Ø¢ÛŒÙ†Ø¯ ØªØ¨Ø¯ÛŒÙ„ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ú†Ù†Ø¯ Ø¯Ù‚ÛŒÙ‚Ù‡ Ø·ÙˆÙ„ Ø¨Ú©Ø´Ø¯.',0),(484959,13472,'pr','ÙØ±Ø¢ÛŒÙ†Ø¯ ØªØ¨Ø¯ÛŒÙ„ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ú†Ù†Ø¯ Ø¯Ù‚ÛŒÙ‚Ù‡ Ø·ÙˆÙ„ Ø¨Ú©Ø´Ø¯.',0),(484960,13472,'tr','DÃ¶nÃ¼ÅŸtÃ¼rme iÅŸleminin tamamlanmasÄ± birkaÃ§ dakika sÃ¼rebilir.',0),(484961,13472,'pl','Proces konwersji moÅ¼e upÅ‚ynÄ…Ä‡ kilka minut, aby zakoÅ„czyÄ‡.',0),(484962,13472,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑÑŠÑ‚ Ð½Ð° Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ñ‚Ð½ÐµÐ¼Ðµ Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð¸ Ð´Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸.',0),(484963,13472,'ur','Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ø¨Ø¯Ù„ÛŒ Ú©Ùˆ Ù…Ú©Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ú©Ø¦ÛŒ Ù…Ù†Ù¹ Ù„Û’ Ø³Ú©ØªØ§ ÛÛ’ Û”',0),(484964,13472,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ ÐºÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ Ð¼Ð¾Ð¶Ðµ Ð¿Ð¾Ñ‚Ñ€Ð°Ñ˜Ð°Ñ‚Ð¸ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð° Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐ¸Ð»Ð¸.',0),(484965,13472,'vi','QuÃ¡ trÃ¬nh chuyá»ƒn Ä‘á»•i cÃ³ thá»ƒ máº¥t vÃ i phÃºt Ä‘á»ƒ hoÃ n thÃ nh.',0),(484966,13472,'af','Die omskakeling proses kan verskeie minute neem om te voltooi.',0),(484967,13472,'ro','Procesul de conversie poate dura cÃ¢teva minute pentru a finaliza.',0),(484968,13472,'et','Muundamise protsess vÃµib vÃµtta mitu minutit.',0),(484969,13472,'si','Postopek pretvorbe lahko traja veÄ minut.',0),(484970,13472,'ba','Proses konversi mungkin memakan waktu beberapa menit untuk menyelesaikan.',0),(484971,13472,'nl','De conversieproces kan enige tijd duren om te voltooien.',0),(484972,13472,'fi','Muuntaminen voi kestÃ¤Ã¤ useita minuutteja.',0),(484973,13472,'no','Konverteringsprosessen kan ta flere minutter Ã¥ fullfÃ¸re.',0),(484974,13472,'da','Konverteringen kan tage flere minutter at fuldfÃ¸re.',0),(484975,13472,'ko','ë³€í™˜ í”„ë¡œì„¸ìŠ¤ë¥¼ ì™„ë£Œ í•˜ë ¤ë©´ ëª‡ ë¶„ ì •ë„ ê±¸ë¦´ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(484976,13472,'he','×ª×”×œ×™×š ×”×”×ž×¨×” ×¢×©×•×™ ×œ×”×™×ž×©×š ×ž×¡×¤×¨ ×“×§×•×ª ×›×“×™ ×œ×”×©×œ×™×.',0),(484977,13472,'el','Î¤Î· Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î®Ï‚ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î¹Î±ÏÎºÎ­ÏƒÎµÎ¹ Î±ÏÎºÎµÏ„Î¬ Î»ÎµÏ€Ï„Î¬ Î³Î¹Î± Î½Î± Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯.',0),(484978,13472,'zh','è½¬æ¢è¿‡ç¨‹å¯èƒ½éœ€è¦å‡ åˆ†é’Ÿæ‰èƒ½å®Œæˆã€‚',0),(484979,13472,'sv','Konverteringsprocessen kan ta flera minuter att slutfÃ¶ra.',0),(484980,13472,'it','Il processo di conversione puÃ² richiedere diversi minuti per completare.',0),(484981,13472,'tl','',0),(484982,13472,'th','à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£à¹à¸›à¸¥à¸‡à¸­à¸²à¸ˆà¹ƒà¸Šà¹‰à¹€à¸§à¸¥à¸²à¸«à¸¥à¸²à¸¢à¸™à¸²à¸—à¸µ',0),(484983,13472,'hi','à¤°à¥‚à¤ªà¤¾à¤‚à¤¤à¤°à¤£ à¤•à¥€ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‹ à¤ªà¥‚à¤°à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤ˆ à¤®à¤¿à¤¨à¤Ÿ à¤²à¤— à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(484984,13472,'ms','Proses penukaran ini mungkin mengambil beberapa minit untuk menyelesaikan.',0),(484985,13472,'ar','Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ØªØ­ÙˆÙŠÙ„ Ù‚Ø¯ ÙŠØ³ØªØºØ±Ù‚ Ø¹Ø¯Ø© Ø¯Ù‚Ø§Ø¦Ù‚ Ù„Ø¥ØªÙ…Ø§Ù….',0),(484986,13472,'fr','Le processus de conversion peut prendre plusieurs minutes pour terminer.',0),(484987,13472,'jp','å¤‰æ›ãƒ—ãƒ­ã‚»ã‚¹ã‚’å®Œäº†ã™ã‚‹ã¾ã§ã«æ•°åˆ†ã‚’ã‹ã‹ã‚‹ã“ã¨ãŒã‚ã‚Šã¾ã™ã€‚',0),(484988,13472,'pt','O processo de conversÃ£o pode levar alguns minutos para completar.',0),(484989,13472,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¼Ð¾Ð¶ÐµÑ‚ Ð·Ð°Ð½ÑÑ‚ÑŒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚ Ð´Ð»Ñ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ñ.',0),(484990,13472,'es','El proceso de conversiÃ³n puede tomar unos minutos para complletar',0),(484991,13472,'de','Der Konvertierungsprozess kann mehrere Minuten in Anspruch nehmen.',0),(484992,13472,'en','The conversion process may take several minutes to complete.',0),(484993,13473,'is','',0),(484994,13473,'dr','ÙØ§ÛŒÙ„ Ø´Ø±Ú©Øª Ù¾Ø±Ø´ÛŒÙ† Ø®ÙˆØ¯ Ø±Ø§ Ø§Ø² Ø³Ø±ÙˆØ± Ù…Ø§ Ø¨Ù„Ø§ÙØ§ØµÙ„Ù‡ Ù¾Ø³ Ø§Ø² ØªØ¨Ø¯ÛŒÙ„ Ø­Ø°Ù Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯.',0),(484995,13473,'pr','ÙØ§ÛŒÙ„ Ø´Ø±Ú©Øª Ù¾Ø±Ø´ÛŒÙ† Ø®ÙˆØ¯ Ø±Ø§ Ø§Ø² Ø³Ø±ÙˆØ± Ù…Ø§ Ø¨Ù„Ø§ÙØ§ØµÙ„Ù‡ Ù¾Ø³ Ø§Ø² ØªØ¨Ø¯ÛŒÙ„ Ø­Ø°Ù Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯.',0),(484996,13473,'tr','QuickBooks ÅŸirket dosyanÄ±zÄ± sunucularÄ±mÄ±zdan dÃ¶nÃ¼ÅŸtÃ¼rmeden sonra hemen kaldÄ±rÄ±ldÄ±.',0),(484997,13473,'pl','Pliku firmy w programie QuickBooks zostanÄ… usuniÄ™te z naszych serwerÃ³w natychmiast po konwersji.',0),(484998,13473,'bg','Ð’Ð°ÑˆÐ¸ÑÑ‚ QuickBooks ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ñ„Ð°Ð¹Ð» Ñ‰Ðµ Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸ Ð¾Ñ‚ Ð½Ð°ÑˆÐ¸Ñ‚Ðµ ÑÑŠÑ€Ð²ÑŠÑ€Ð¸ Ð²ÐµÐ´Ð½Ð°Ð³Ð° ÑÐ»ÐµÐ´ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½ÐµÑ‚Ð¾.',0),(484999,13473,'ur','Ø§Ù¾Ù†ÛŒ Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ú©Ù…Ù¾Ù†ÛŒ ÙØ§Ø¦Ù„ ÛÙ…Ø§Ø±Û’ Ø³Ø±ÙˆØ±Ø² Ø³Û’ ÙÙˆØ±ÛŒ Ø·ÙˆØ± Ù¾Ø± Ù…Ø°ÛØ¨ Ú©ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Û’ Ø¨Ø¹Ø¯ ÛÙ¹Ø§ Ø¯ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§ Û”',0),(485000,13473,'sr','Ð¢Ð²Ð¾Ñ˜ QÑƒÐ¸Ñ†ÐºÐ‘Ð¾Ð¾ÐºÑ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ ÑƒÐºÐ»Ð¾ÑšÐµÐ½Ð° ÑÐ° ÑÐ²Ð¾Ñ˜Ð¸Ñ… ÑÐµÑ€Ð²ÐµÑ€Ð° Ð¾Ð´Ð¼Ð°Ñ… Ð½Ð°ÐºÐ¾Ð½ ÐºÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ.',0),(485001,13473,'vi','QuickBooks táº­p tin cÃ´ng ty cá»§a báº¡n sáº½ bá»‹ xoÃ¡ khá»i mÃ¡y chá»§ cá»§a chÃºng tÃ´i ngay láº­p tá»©c sau khi chuyá»ƒn Ä‘á»•i.',0),(485002,13473,'af','U Quickbooks firma lÃªer sal onmiddelik van ons hoofraam verwyder word na omskakeling gedoen is.',0),(485003,13473,'ro','FiÅŸierul QuickBooks companiei va fi eliminat de pe serverele noastre imediat dupÄƒ conversie.',0),(485004,13473,'et','Oma QuickBooksi Ã¼hisfaili eemaldatakse meie serverite vahetult pÃ¤rast teisendamist.',0),(485005,13473,'si','VaÅ¡ QuickBooks podjetje datoteka bo odstranjena iz naÅ¡ih streÅ¾nikih takoj po pretvorbi.',0),(485006,13473,'ba','File perusahaan QuickBooks akan dihapus dari server kami segera setelah konversi.',0),(485007,13473,'nl','Het QuickBooks-bedrijfsbestand zullen worden verwijderd uit onze servers onmiddellijk na conversie.',0),(485008,13473,'fi','QuickBooks yritys tiedosto poistetaan palvelimiltamme vÃ¤littÃ¶mÃ¤sti muuntamisen jÃ¤lkeen.',0),(485009,13473,'no','QuickBooks-firmafilen fjernes fra vÃ¥re servere umiddelbart etter konvertering.',0),(485010,13473,'da','Din QuickBooks-virksomhedsfil vil blive fjernet fra vores servere straks efter konvertering.',0),(485011,13473,'ko','QuickBooks íšŒì‚¬ íŒŒì¼ ë³€í™˜ í›„ ì¦‰ì‹œ ì„œë²„ì—ì„œ ì œê±° ë©ë‹ˆë‹¤.',0),(485012,13473,'he','×§×•×‘×¥ ×”×—×‘×¨×” ×©×œ×š QuickBooks ×™×•×¡×¨×• ×ž×”×©×¨×ª×™× ×©×œ× ×• ×ž×™×“ ×œ××—×¨ ×”×”×ž×¨×”.',0),(485013,13473,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± QuickBooks Î¸Î± ÎºÎ±Ï„Î±ÏÎ³Î·Î¸ÎµÎ¯ Î±Ï€ÏŒ Ï„Î¿Ï…Ï‚ Î´Î¹Î±ÎºÎ¿Î¼Î¹ÏƒÏ„Î­Ï‚ Î¼Î±Ï‚ Î±Î¼Î­ÏƒÏ‰Ï‚ Î¼ÎµÏ„Î¬ Ï„Î· Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î®.',0),(485014,13473,'zh','QuickBooks å…¬å¸æ–‡ä»¶å°†ä»Žæˆ‘ä»¬çš„æœåŠ¡å™¨è½¬æ¢åŽç«‹å³åˆ é™¤ã€‚',0),(485015,13473,'sv','Din QuickBooks-fÃ¶retagsfil tas bort frÃ¥n vÃ¥ra servrar omedelbart efter konvertering.',0),(485016,13473,'it','QuickBooks file azienda verrÃ  rimossi dai nostri server immediatamente dopo la conversione.',0),(485017,13473,'tl','',0),(485018,13473,'th','à¹à¸Ÿà¹‰à¸¡à¸‚à¸­à¸‡à¸šà¸£à¸´à¸©à¸±à¸— QuickBooks à¸ˆà¸°à¸–à¸¹à¸à¹€à¸­à¸²à¸­à¸­à¸à¸ˆà¸²à¸à¹€à¸‹à¸´à¸£à¹Œà¸Ÿà¹€à¸§à¸­à¸£à¹Œà¸‚à¸­à¸‡à¹€à¸£à¸²à¸—à¸±à¸™à¸—à¸µà¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸à¸²à¸£à¹à¸›à¸¥à¸‡',0),(485019,13473,'hi','à¤…à¤ªà¤¨à¥‡ QuickBooks à¤•à¤‚à¤ªà¤¨à¥€ à¤«à¤¼à¤¾à¤‡à¤² à¤°à¥‚à¤ªà¤¾à¤‚à¤¤à¤°à¤£ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¤à¥à¤°à¤‚à¤¤ à¤¹à¤®à¤¾à¤°à¥‡ à¤¸à¤°à¥à¤µà¤° à¤¸à¥‡ à¤¨à¤¿à¤•à¤¾à¤² à¤¦à¤¿à¤ à¤œà¤¾à¤à¤à¤—à¥‡à¥¤',0),(485020,13473,'ms','Fail Syarikat QuickBooks anda akan dihapuskan daripada pelayan kami serta-merta selepas penukaran.',0),(485021,13473,'ar','Ø³ÙŠØªÙ… Ø¥Ø²Ø§Ù„Ø© Ù…Ù„Ù Ø´Ø±ÙƒØ© QuickBooks Ù…Ù† Ø®Ø¯Ù…ØªÙ†Ø§ ÙÙˆØ±Ø§ Ø¨Ø¹Ø¯ Ø§Ù„ØªØ­ÙˆÙŠÙ„.',0),(485022,13473,'fr','Votre fichier de compagnie de QuickBooks disparaÃ®t immÃ©diatement aprÃ¨s la conversion de nos serveurs.',0),(485023,13473,'jp','QuickBooks ä¼šç¤¾ãƒ•ã‚¡ã‚¤ãƒ«ã¯ã€å¤‰æ›å¾Œã™ãã«å¼Šç¤¾ã®ã‚µãƒ¼ãƒãƒ¼ã‹ã‚‰å‰Šé™¤ã•ã‚Œã¾ã™ã€‚',0),(485024,13473,'pt','Sua ficha de empresa de QuickBooks serÃ¡ removida de nossos servidores imediatamente apÃ³s a conversÃ£o.',0),(485025,13473,'ru','Ð’Ð°Ñˆ Ñ„Ð°Ð¹Ð» ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ QuickBooks Ð±ÑƒÐ´ÑƒÑ‚ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹ Ñ Ð½Ð°ÑˆÐ¸Ñ… ÑÐµÑ€Ð²ÐµÑ€Ð¾Ð² ÑÑ€Ð°Ð·Ñƒ Ð¶Ðµ Ð¿Ð¾ÑÐ»Ðµ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ.',0),(485026,13473,'es','Su File de Empresa de Quickbooks serÃ¡ eliminado de nuestros servicios inmediatamente despuÃ©s la conversiÃ³n',0),(485027,13473,'de','Ihre Unternehmensdatei QuickBooks wird sofort nach der Konvertierung von unseren Servern entfernt.',0),(485028,13473,'en','Your QuickBooks company file will be removed from our servers immediately after conversion.',0),(485029,13474,'is','',0),(485030,13474,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¹Ù…ÙˆÙ…ÛŒ Ù„Ø¬Ø± Ù‡Ø²ÛŒÙ†Ù‡',0),(485031,13474,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¹Ù…ÙˆÙ…ÛŒ Ù„Ø¬Ø± Ù‡Ø²ÛŒÙ†Ù‡',0),(485032,13474,'tr','Genel muhasebe gider raporu',0),(485033,13474,'pl','Sprawozdanie ogÃ³lne ksiÄ™gi wydatkÃ³w',0),(485034,13474,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð½Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð» ÐºÐ½Ð¸Ð³Ð° Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(485035,13474,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø®Ø±Ú†Û’ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(485036,13474,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ',0),(485037,13474,'vi','BÃ¡o cÃ¡o tá»•ng há»£p Ledger chi phÃ­',0),(485038,13474,'af','Algemene grootboek uitgawe verslag',0),(485039,13474,'ro','Raport general Ledger cheltuieli',0),(485040,13474,'et','Ãœldised pearaamatu kulude aruande',0),(485041,13474,'si','General Ledger obraÄun stroÅ¡kov',0),(485042,13474,'ba','Laporan General Ledger biaya',0),(485043,13474,'nl','General Ledger onkostendeclaratie',0),(485044,13474,'fi','General Ledger raportti',0),(485045,13474,'no','General Ledger reiseregningen',0),(485046,13474,'da','General Ledger udgiftsrapport',0),(485047,13474,'ko','ì¼ë°˜ íšŒê³„ ìž¥ë¶€ ë¹„ìš© ë³´ê³ ì„œ',0),(485048,13474,'he','×“×•×— ×”×•×¦××•×ª ×¡×¤×¨ ×¨××©×™ ×›×œ×œ×™',0),(485049,13474,'el','Î“ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® ÎµÎ¾ÏŒÎ´Ï‰Î½',0),(485050,13474,'zh','æ€»åˆ†ç±»å¸æ”¯å‡ºæŠ¥è¡¨',0),(485051,13474,'sv','General Ledger utgiftsrapport',0),(485052,13474,'it','Nota spese di General Ledger',0),(485053,13474,'tl','',0),(485054,13474,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(485055,13474,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤µà¥à¤¯à¤¯ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(485056,13474,'ms','Laporan perbelanjaan Lejar Am',0),(485057,13474,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª ÙÙŠ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(485058,13474,'fr','Note de frais de comptabilitÃ© gÃ©nÃ©rale',0),(485059,13474,'jp','ä¸€èˆ¬çš„ãªå…ƒå¸³ã®çµŒè²»å ±å‘Šæ›¸',0),(485060,13474,'pt','RelatÃ³rio de despesas do livro-razÃ£o geral',0),(485061,13474,'ru','Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð“Ðš Ð°Ð²Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(485062,13474,'es','Informe de Gastos del Libro Mayor',0),(485063,13474,'de','General Ledger Spesenabrechnung',0),(485064,13474,'en','General Ledger Expense Report',0),(485065,13475,'is','',0),(485066,13475,'dr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ø¯Ø± AP Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¨Ù‡ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ Ù‚Ø¨Ù„ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ù…Ø´Ù…ÙˆÙ„ÛŒØª',0),(485067,13475,'pr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ø¯Ø± AP Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¨Ù‡ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ Ù‚Ø¨Ù„ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ù…Ø´Ù…ÙˆÙ„ÛŒØª',0),(485068,13475,'tr','Ã–nceki dÃ¶nemlerin AR/AP hareketlerine zemin olamaz',0),(485069,13475,'pl','Nie Backdate transakcji AR/AP do poprzednich okresÃ³w',0),(485070,13475,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Backdate AR/Ð°Ð¿ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ñ Ð¿Ñ€ÐµÐ´Ñ…Ð¾Ð´Ð½Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸',0),(485071,13475,'ur','Ø³Ø§Ø¨Ù‚Û Ø§Ø¯ÙˆØ§Ø± Ú©Û’ Ù„Ø¦Û’ Ø§Ù„Ø±Ø­ÛŒÙ‚/AP Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø¨Ø§Ú©Ú©Ø¯Ø§Ù¹ÛŒ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(485072,13475,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¿Ñ€ÐµÐ¿Ñ€Ð°Ð²Ð¸Ð¼ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐÐ /ÐÐŸ Ð½Ð° Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¸Ñ… Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(485073,13475,'vi','KhÃ´ng Backdate AR/AP giao dá»‹ch trÆ°á»›c khi thá»i gian',0),(485074,13475,'af','AR/GP transaksies vooraf periodes kan Backdate',0),(485075,13475,'ro','Nu pot Backdate AR/AP tranzacÅ£ii pentru perioadele anterioare',0),(485076,13475,'et','Ei saa Backdate AR/AP tehingute eelnevate perioodide',0),(485077,13475,'si','Ne more umakniti AR/AP transakcij na pretekla obdobja',0),(485078,13475,'ba','Tidak Backdate AR AP transaksi periode sebelumnya',0),(485079,13475,'nl','Kan niet achterdeur AR/AP transacties op voorgaande perioden',0),(485080,13475,'fi','Ei voi takautuvasti AR/AP tapahtumat kausilta',0),(485081,13475,'no','Ikke tilbakedatere AR/AP transaksjoner til tidligere perioder',0),(485082,13475,'da','Kan ikke Tilbagedatere AR/AP transaktionerne til forudgÃ¥ende perioder',0),(485083,13475,'ko','AR/AP íŠ¸ëžœìž­ì…˜ì„ ì´ì „ ê¸°ê°„ì„ ì†Œê¸‰ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(485084,13475,'he','×œ× ××§× ×” AR/AP ×ª× ×•×¢×•×ª ×ª×§×•×¤×•×ª ×§×•×“×ž×•×ª',0),(485085,13475,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÎ¸ÎµÎ¯ Î±Î½Î±Î´ÏÎ¿Î¼Î¹ÎºÎ¬ AR/AP ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ Î½Î± Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Ï‰Î½ Ï€ÎµÏÎ¹ÏŒÎ´Ï‰Î½',0),(485086,13475,'zh','ä¸èƒ½è¿½æº¯åˆ°å‰æœŸçš„ AR/AP äº¤æ˜“',0),(485087,13475,'sv','Kan inte antedatera AR/AP transaktioner till tidigare perioder',0),(485088,13475,'it','Non puÃ² retrodatare operazioni AR/AP a periodi precedenti',0),(485089,13475,'tl','',0),(485090,13475,'th','à¹„à¸¡à¹ˆ Backdate AR/AP à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²',0),(485091,13475,'hi','à¤¸à¤®à¤¯ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤. à¤†à¤°. / à¤à¤ªà¥€ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ Backdate à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(485092,13475,'ms','Tidak boleh Backdate AR/AP transaksi untuk tempoh-tempoh sebelumnya',0),(485093,13475,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Backdate Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª AR/AP Ù„ÙØªØ±Ø§Øª Ø³Ø§Ø¨Ù‚Ø©',0),(485094,13475,'fr','Ne peut pas antidater AR/AP Transactions Ã  des exercices antÃ©rieurs',0),(485095,13475,'jp','éŽåŽ»ã®æœŸé–“ã‚’ AR/AP ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ç§»ç±å‰ã®ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(485096,13475,'pt','NÃ£o podemos retroagir AR/AP transaÃ§Ãµes com perÃ­odos anteriores',0),(485097,13475,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ð·Ð°Ð´Ð½Ð¸Ð¼ Ñ‡Ð¸ÑÐ»Ð¾Ð¼ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ AR/AP Ðº Ð¿Ñ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ð¼ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°Ð¼',0),(485098,13475,'es','No Se Puede Antedatar CC/CP Transacciones a PerÃ­odos Anteriores',0),(485099,13475,'de','Kann nicht AR/AP-Transaktionen zu Vorperioden zurÃ¼ckdatieren',0),(485100,13475,'en','Cannot Backdate AR/AP Transactions To Prior Periods',0),(485101,13476,'is','',0),(485102,13476,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ØªØºÛŒÛŒØ± ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù…Ø´ØªØ±ÛŒ',0),(485103,13476,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ØªØºÛŒÛŒØ± ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù…Ø´ØªØ±ÛŒ',0),(485104,13476,'tr','MÃ¼ÅŸteri kredi ayarlarÄ±nÄ± deÄŸiÅŸtiremezsiniz',0),(485105,13476,'pl','Nie moÅ¼na zmieniÄ‡ ustawienia kredytowej klienta',0),(485106,13476,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÑÑ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(485107,13476,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Ø±ÛŒÚˆÙ¹ Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(485108,13476,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚ ÐºÑƒÐ¿Ñ†Ð°',0),(485109,13476,'vi','KhÃ´ng thá»ƒ thay Ä‘á»•i khÃ¡ch hÃ ng tÃ­n dá»¥ng cÃ i Ä‘áº·t',0),(485110,13476,'af','KliÃ«nt krediet instellings kan nie verander',0),(485111,13476,'ro','Nu pot modifica setÄƒrile de Credit client',0),(485112,13476,'et','Kliendile krediidi sÃ¤tteid ei saa muuta',0),(485113,13476,'si','Ne morete spremeniti nastavitve kupca kreditne',0),(485114,13476,'ba','Tidak dapat mengubah pengaturan kredit pelanggan',0),(485115,13476,'nl','Klant krediet-instellingen wijzigen niet',0),(485116,13476,'fi','Asiakkaan luotto asetuksia ei voi muuttaa',0),(485117,13476,'no','Kan ikke endre innstillingene for kunde-kreditt',0),(485118,13476,'da','Kan ikke Ã¦ndre kundens kredit indstillinger',0),(485119,13476,'ko','ê³ ê° ì‹ ìš© ì„¤ì •ì„ ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(485120,13476,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×©× ×•×ª ×”×’×“×¨×•×ª ××©×¨××™ ×œ×§×•×—×•×ª',0),(485121,13476,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î»Î»Î¬Î¾ÎµÎ¹ Ï„Î¹Ï‚ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(485122,13476,'zh','æ— æ³•æ›´æ”¹å®¢æˆ·ä¿¡ç”¨è®¾ç½®',0),(485123,13476,'sv','Kan inte Ã¤ndra instÃ¤llningarna fÃ¶r kunden kredit',0),(485124,13476,'it','Non Ã¨ possibile modificare le impostazioni di credito del cliente',0),(485125,13476,'tl','',0),(485126,13476,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸„à¸£à¸”à¸´à¸•à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(485127,13476,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(485128,13476,'ms','Tidak boleh menukar pengesetan kredit pelanggan',0),(485129,13476,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØºÙŠÙŠØ± Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(485130,13476,'fr','Impossible de modifier les paramÃ¨tres de crÃ©dit client',0),(485131,13476,'jp','é¡§å®¢ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã®è¨­å®šã‚’å¤‰æ›´ã§ãã¾ã›ã‚“ã€‚',0),(485132,13476,'pt','NÃ£o Ã© possÃ­vel alterar as configuraÃ§Ãµes de crÃ©dito do cliente',0),(485133,13476,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹',0),(485134,13476,'es','No Se Puede Cambiar las Configuraciones De CrÃ©dito Del Cliente',0),(485135,13476,'de','Credit Kundeneinstellungen kann nicht geÃ¤ndert werden.',0),(485136,13476,'en','Cannot Change Customer Credit Settings',0),(485137,13477,'is','',0),(485138,13477,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø®ÙˆØ¯Ú©Ø§Ø± Ú©Ø§Ù…Ù„ ØªØ§Ø®ÛŒØ± Ø¯Ø± Ù…ÛŒÙ„ÛŒ Ø«Ø§Ù†ÛŒÙ‡',0),(485139,13477,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø®ÙˆØ¯Ú©Ø§Ø± Ú©Ø§Ù…Ù„ ØªØ§Ø®ÛŒØ± Ø¯Ø± Ù…ÛŒÙ„ÛŒ Ø«Ø§Ù†ÛŒÙ‡',0),(485140,13477,'tr','VarsayÄ±lan otomatik tamamlama gecikme (milisaniye cinsinden)',0),(485141,13477,'pl','DomyÅ›lnie Auto-zgÅ‚aszaÄ‡ reklamacjÄ™ niezwÅ‚ocznie w milisekundach',0),(485142,13477,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð´Ð¾Ð²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ Ð·Ð°Ð±Ð°Ð²ÑÐ½Ðµ Ð² Ð¼Ð¸Ð»Ð¸ÑÐµÐºÑƒÐ½Ð´Ð¸',0),(485143,13477,'ur','Ø·Û’ Ø´Ø¯Û Ø¢Ù¹Ùˆ Ù…Ú©Ù…Ù„ ØªØ§Ø®ÛŒØ±, Milliseconds Ù…ÛŒÚº',0),(485144,13477,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾Ð³ Ð´Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐ° ÐºÐ°ÑˆÑšÐµÑšÐ° Ñƒ Ð¼Ð¸Ð»Ð¸ÑÐµÐºÑƒÐ½Ð´Ð°Ð¼Ð°',0),(485145,13477,'vi','Máº·c Ä‘á»‹nh tá»± Ä‘á»™ng hoÃ n thÃ nh sá»± cháº­m trá»… trong mili giÃ¢y',0),(485146,13477,'af','Verstek Outo-voltooi vertraging In millisekondes',0),(485147,13477,'ro','Implicit Auto-completat Ã®ntÃ¢rziere Ã®n milisecunde',0),(485148,13477,'et','Vaikimisi automaatteksti viivitus millisekundites',0),(485149,13477,'si','Privzete funkcije samodokonÄanja zamude v milisekundah',0),(485150,13477,'ba','Default Auto-lengkap keterlambatan dalam milidetik',0),(485151,13477,'nl','Standaard Auto-volledige vertraging In milliseconden',0),(485152,13477,'fi','LaiminlyÃ¶minen automaattinen tÃ¤ydennys viive millisekunteina',0),(485153,13477,'no','Standard AutofullfÃ¸r-forsinkelsen i millisekunder',0),(485154,13477,'da','Standard bil-hel forsinkelse i millisekunder',0),(485155,13477,'ko','ê¸°ë³¸ ìžë™ ì™„ë£Œ ì§€ì—° (ë°€ë¦¬ì´ˆ)',0),(485156,13477,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×”×©×œ×ž×” ××•×˜×•×ž×˜×™×ª ×”×”×©×”×™×” ×‘××œ×¤×™×•×ª ×©× ×™×”',0),(485157,13477,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î±Ï…Ï„Î¿-Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ½Ï‰ ÎºÎ±Î¸Ï…ÏƒÏ„Î­ÏÎ·ÏƒÎ· ÏƒÎµ Ï‡Î¹Î»Î¹Î¿ÏƒÏ„Î¬ Ï„Î¿Ï… Î´ÎµÏ…Ï„ÎµÏÎ¿Î»Î­Ï€Ï„Î¿Ï…',0),(485158,13477,'zh','é»˜è®¤è‡ªåŠ¨å®Œæˆå»¶è¿Ÿ (æ¯«ç§’)',0),(485159,13477,'sv','Standard Auto-complete fÃ¶rdrÃ¶jning i millisekunder',0),(485160,13477,'it','Ritardo di completamento automatico predefinito In millisecondi',0),(485161,13477,'tl','',0),(485162,13477,'th','à¸«à¸™à¹ˆà¸§à¸‡à¹€à¸§à¸¥à¸²à¸à¸²à¸£à¸—à¸³à¹ƒà¸«à¹‰à¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œà¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹ƒà¸™à¸«à¸™à¹ˆà¸§à¸¢à¸¡à¸´à¸¥à¸¥à¸´à¸§à¸´à¸™à¸²à¸—à¸µ',0),(485163,13477,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥à¤µà¤¤: à¤ªà¥‚à¤°à¥à¤£ à¤®à¤¿à¤¸à¥‡ à¤®à¥‡à¤‚ à¤¦à¥‡à¤°à¥€',0),(485164,13477,'ms','Kelewatan melengkapkan Auto lalai milisaat',0),(485165,13477,'ar','ØªØ£Ø®ÙŠØ± Ø§Ù„Ø¥ÙƒÙ…Ø§Ù„ Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ ÙÙŠ Ù…ÙŠÙ„ÙŠ Ø«Ø§Ù†ÙŠØ©',0),(485166,13477,'fr','DÃ©lai de saisie semi-automatique par dÃ©faut en millisecondes',0),(485167,13477,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã®è‡ªå‹•å®Œäº†é…å»¶ (ãƒŸãƒªç§’å˜ä½)',0),(485168,13477,'pt','PadrÃ£o Auto-completar de atraso em milissegundos',0),(485169,13477,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Auto Ð¿Ð¾Ð»Ð½Ð°Ñ Ð·Ð°Ð´ÐµÑ€Ð¶ÐºÐ° Ð² Ð¼Ð¸Ð»Ð»Ð¸ÑÐµÐºÑƒÐ½Ð´Ð°Ñ…',0),(485170,13477,'es','Tardanza de auto-completar predeterminado en milisegundos',0),(485171,13477,'de','StandardmÃ¤ÃŸigen AutoVervollstÃ¤ndigen-VerzÃ¶gerung In Millisekunden',0),(485172,13477,'en','Default Auto-complete Delay In Milliseconds',0),(485173,13478,'is','',0),(485174,13478,'dr','Backdating Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(485175,13478,'pr','Backdating Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(485176,13478,'tr','Hareketleri hisse verilmez',0),(485177,13478,'pl','Antydatowania transakcji nie jest dozwolone',0),(485178,13478,'bg','Backdating ÑÐ´ÐµÐ»ÐºÐ¸ Ð½Ðµ Ðµ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(485179,13478,'ur','Ø¨Ø§Ú©ÚˆÛŒÙ¹Ø§Ù†Ú¯ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº ÛÛ’',0),(485180,13478,'sr','Ð‘Ð°Ñ†ÐºÐ´Ð°Ñ‚Ð¸Ð½Ð³ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(485181,13478,'vi','Backdating giao dá»‹ch khÃ´ng Ä‘Æ°á»£c phÃ©p',0),(485182,13478,'af','Backdating transaksies word nie toegelaat nie',0),(485183,13478,'ro','Erelor tranzacÅ£ii nu este permis',0),(485184,13478,'et','Panemine tehingud on lubatud',0),(485185,13478,'si','PoseÄi transakcije ni dovoljeno',0),(485186,13478,'ba','Kasus pengunduran transaksi tidak diperbolehkan',0),(485187,13478,'nl','Antedatering transacties Is niet toegestaan',0),(485188,13478,'fi','Takautumattomuuden tapahtumat sallitaan',0),(485189,13478,'no','Backdating transaksjoner tillates ikke',0),(485190,13478,'da','Tilbagevirkende kraft transaktioner er ikke tilladt',0),(485191,13478,'ko','Backdating ê±°ëž˜ëŠ” í—ˆìš© ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(485192,13478,'he','Backdating ×ª× ×•×¢×•×ª ××™× ×” ×ž×•×ª×¨×ª',0),(485193,13478,'el','Î‘Î½Î±Î´ÏÎ¿Î¼Î¹ÎºÎ®Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ Î´ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(485194,13478,'zh','å›žæº¯äº¤æ˜“è®°å½•ä¸æ˜¯å…è®¸çš„',0),(485195,13478,'sv','Antedatering transaktioner Ã¤r inte tillÃ¥tet',0),(485196,13478,'it','Transazioni di retrodatazione non Ã¨ consentita',0),(485197,13478,'tl','',0),(485198,13478,'th','à¹„à¸¡à¹ˆà¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰ backdating à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡',0),(485199,13478,'hi','Backdating à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(485200,13478,'ms','Backdating urus niaga yang tidak dibenarkan',0),(485201,13478,'ar','Ù„Ø§ ÙŠØ³Ù…Ø­ Ø¨Ø¥Ø±Ø¬Ø§Ø¹ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(485202,13478,'fr','Antidate des Transactions n\'est pas autorisÃ©',0),(485203,13478,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã‚’ãƒãƒƒã‚¯ãƒ‡ãƒ¼ãƒˆã¯è¨±å¯ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(485204,13478,'pt','TransaÃ§Ãµes de aÃ§Ãµes nÃ£o Ã© permitido.',0),(485205,13478,'ru','Ð—Ð°Ð´Ð½Ð¸Ð¼ Ñ‡Ð¸ÑÐ»Ð¾Ð¼ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¹ Ð½Ðµ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(485206,13478,'es','Antedatando las Transacciones No Se Permiten',0),(485207,13478,'de','RÃ¼ckdatierung Transaktionen ist nicht zulÃ¤ssig.',0),(485208,13478,'en','Backdating Transactions Is Not Allowed',0),(485209,13479,'is','',0),(485210,13479,'dr','Ú©Ø¯ Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‡Ø²ÛŒÙ†Ù‡',0),(485211,13479,'pr','Ú©Ø¯ Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‡Ø²ÛŒÙ†Ù‡',0),(485212,13479,'tr','VarsayÄ±lan maliyet kodu',0),(485213,13479,'pl','DomyÅ›lny kod kosztu',0),(485214,13479,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÐºÐ¾Ð´ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(485215,13479,'ur','Ø·Û’ Ø´Ø¯Û Ù‚ÛŒÙ…Øª Ú©ÙˆÚˆ',0),(485216,13479,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¨Ð¸Ñ„Ñ€Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·.',0),(485217,13479,'vi','Máº·c Ä‘á»‹nh chi phÃ­ mÃ£',0),(485218,13479,'af','Verstek koste kode',0),(485219,13479,'ro','Codul implicit de Cost',0),(485220,13479,'et','Kulu vaiketÃ¤his',0),(485221,13479,'si','Privzeta Å¡ifra stroÅ¡ka',0),(485222,13479,'ba','Kode biaya standar',0),(485223,13479,'nl','Kosten standaardcode',0),(485224,13479,'fi','Oletuskoodi kustannukset',0),(485225,13479,'no','Standard kostnader kode',0),(485226,13479,'da','Standard pris kode',0),(485227,13479,'ko','ê¸°ë³¸ ë¹„ìš©ëœ ì½”ë“œ',0),(485228,13479,'he','×§×•×“ ×¢×œ×•×ª ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(485229,13479,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï‚ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(485230,13479,'zh','é»˜è®¤æˆæœ¬çš„ä»£ç ',0),(485231,13479,'sv','Kostnad standardkod',0),(485232,13479,'it','Costo codice predefinito',0),(485233,13479,'tl','',0),(485234,13479,'th','à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(485235,13479,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡',0),(485236,13479,'ms','Kod kos lalai',0),(485237,13479,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù„ØªÙƒÙ„ÙØ©',0),(485238,13479,'fr','Code de coÃ»t par dÃ©faut',0),(485239,13479,'jp','æ—¢å®šã®ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰',0),(485240,13479,'pt','CÃ³digo de custo padrÃ£o',0),(485241,13479,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(485242,13479,'es','CÃ³digo de Costo Predeterminado',0),(485243,13479,'de','Standard-Kosten-Code',0),(485244,13479,'en','Default Cost Code',0),(485245,13480,'is','',0),(485246,13480,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ù¾ÛŒ Ø¯ÛŒ Ø§Ù',0),(485247,13480,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ù¾ÛŒ Ø¯ÛŒ Ø§Ù',0),(485248,13480,'tr','PDF indir',0),(485249,13480,'pl','Pobierz PDF',0),(485250,13480,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° PDF',0),(485251,13480,'ur','Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(485252,13480,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¼Ð¸Ñ‚Ðµ ÐŸÐ”Ð¤',0),(485253,13480,'vi','Táº£i vá» PDF',0),(485254,13480,'af','Laai PDF',0),(485255,13480,'ro','Descarca PDF',0),(485256,13480,'et','Lae alla PDF',0),(485257,13480,'si','Download PDF',0),(485258,13480,'ba','Unduh PDF',0),(485259,13480,'nl','Download PDF',0),(485260,13480,'fi','Lataa PDF',0),(485261,13480,'no','Last ned PDF',0),(485262,13480,'da','Download PDF',0),(485263,13480,'ko','PDF ë‹¤ìš´ë¡œë“œ',0),(485264,13480,'he','×”×•×¨×“×ª PDF',0),(485265,13480,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ PDF',0),(485266,13480,'zh','ä¸‹è½½ PDF',0),(485267,13480,'sv','Ladda ner PDF',0),(485268,13480,'it','Scarica il PDF',0),(485269,13480,'tl','',0),(485270,13480,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸” PDF',0),(485271,13480,'hi','à¤ªà¥€à¤¡à¥€à¤à¤« à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(485272,13480,'ms','Muat turun PDF',0),(485273,13480,'ar','ØªÙ†Ø²ÙŠÙ„ Ù‚ÙˆØ§Øª Ø§Ù„Ø¯ÙØ§Ø¹ Ø§Ù„Ø´Ø¹Ø¨ÙŠ',0),(485274,13480,'fr','TÃ©lÃ©charger le PDF',0),(485275,13480,'jp','Pdf ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(485276,13480,'pt','Baixar PDF',0),(485277,13480,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ PDF',0),(485278,13480,'es','Descarga PDF',0),(485279,13480,'de','Download PDF',0),(485280,13480,'en','Download PDF',0),(485281,13481,'is','',0),(485282,13481,'dr','Ù„Ø·ÙØ§ ØµØ¨Ø± Ú©Ù†ÛŒØ¯ Ø¯Ø± Ø­Ø§Ù„ÛŒ Ú©Ù‡ Ø®ÙˆØ¯ Ø±Ø§ Ù¾ÛŒ Ø¯ÛŒ Ø§Ù Ø¢Ù…Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª...',0),(485283,13481,'pr','Ù„Ø·ÙØ§ ØµØ¨Ø± Ú©Ù†ÛŒØ¯ Ø¯Ø± Ø­Ø§Ù„ÛŒ Ú©Ù‡ Ø®ÙˆØ¯ Ø±Ø§ Ù¾ÛŒ Ø¯ÛŒ Ø§Ù Ø¢Ù…Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª...',0),(485284,13481,'tr','PDF hazÄ±r iken lÃ¼tfen bekleyin...',0),(485285,13481,'pl','ProszÃª czekaÃ¦ chwila twÃ³j PDF jest przygotowany...',0),(485286,13481,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ñ‡Ð°ÐºÐ°Ð¹Ñ‚Ðµ, Ð´Ð¾ÐºÐ°Ñ‚Ð¾ Ð²Ð°ÑˆÐ¸Ñ‚Ðµ PDF Ðµ Ð³Ð¾Ñ‚Ð¾Ð²Ð°...',0),(485287,13481,'ur','Ø¬Ø¨Ú©Û Ø¢Ù¾ Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ØªÛŒØ§Ø± ÛÛ’ Ø§Ù†ØªØ¸Ø§Ø± Ú©Ø±ÛŒÚº...',0),(485288,13481,'sr','Ð¡Ð°Ñ‡ÐµÐºÐ°Ñ˜Ñ‚Ðµ Ð´Ð¾Ðº Ñ‚Ð²Ð¾Ñ˜ ÐŸÐ”Ð¤ Ñ˜Ðµ ÑÐ¿Ñ€ÐµÐ¼Ð½Ð°...',0),(485289,13481,'vi','Xin vui lÃ²ng chá» trong khi tá»‡p PDF cá»§a báº¡n Ä‘Æ°á»£c chuáº©n bá»‹...',0),(485290,13481,'af','Wag asseblief terwyl jou PDF voorberei Is...',0),(485291,13481,'ro','VÄƒ rugÄƒm sÄƒ aÅŸteptaÅ£i Ã®n timp ce PDF este pregÄƒtit...',0),(485292,13481,'et','Kui teie PDF-faili on valmis, palun oodake...',0),(485293,13481,'si','Prosim, poÄakajte, medtem ko vaÅ¡ PDF je pripravljen...',0),(485294,13481,'ba','Harap tunggu sementara PDF Anda siap...',0),(485295,13481,'nl','Wees zo goed wachten terwijl uw PDF Is voorbereid...',0),(485296,13481,'fi','Haluta kytÃ¤tÃ¤ jotavastoin PDF valmis...',0),(485297,13481,'no','Vennligst vent mens din PDF er forberedt...',0),(485298,13481,'da','Vent venligst, mens din PDF er forberedt...',0),(485299,13481,'ko','PDFë¥¼ ì¤€ë¹„ í•˜ëŠ” ë™ì•ˆ ê¸°ë‹¤ë ¤ë¥¼ ì£¼ì‹­ì‹œì˜¤...',0),(485300,13481,'he','× × ×”×ž×ª×Ÿ ×‘×–×ž×Ÿ PDF ×©×œ×š ×ž×•×›×Ÿ...',0),(485301,13481,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Ï€ÎµÏÎ¹Î¼Î­Î½ÎµÏ„Îµ ÎµÎ½ÏŽ Ï„Î¿ PDF ÏƒÎ±Ï‚ ÎµÎ¯Î½Î±Î¹ Î­Ï„Î¿Î¹Î¼Î·...',0),(485302,13481,'zh','è™½ç„¶æ‚¨çš„ PDF å‡†å¤‡ï¼Œè¯·ç¨å€™...',0),(485303,13481,'sv','VÃ¤nligen VÃ¤nta medan din PDF Ã¤r beredd...',0),(485304,13481,'it','Si prega di attendere mentre il PDF Ã¨ pronto...',0),(485305,13481,'tl','',0),(485306,13481,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸­à¹ƒà¸™à¸‚à¸“à¸°à¸—à¸µà¹ˆà¸¡à¸µà¹€à¸•à¸£à¸µà¸¢à¸¡à¹„à¸Ÿà¸¥à¹Œ PDF à¸‚à¸­à¸‡à¸„à¸¸à¸“...',0),(485307,13481,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤ªà¥à¤°à¤¤à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¥‡à¤‚ à¤œà¤¬à¤•à¤¿ à¤†à¤ªà¤•à¥‡ PDF à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¯à¤¾à¤° à¤¹à¥ˆ...',0),(485308,13481,'ms','Sila tunggu sementara PDF anda disediakan...',0),(485309,13481,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„Ø§Ù†ØªØ¸Ø§Ø± Ø¨ÙŠÙ†Ù…Ø§ ÙŠØªÙ… Ø¥Ø¹Ø¯Ø§Ø¯ Ù…Ù„Ù PDF Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ...',0),(485310,13481,'fr','Veuillez patienter pendant que votre PDF est prÃªt...',0),(485311,13481,'jp','ãŠå¾…ã¡ã‚’ãã ã•ã„ä¸­ã«ã‚ãªãŸã® pdf ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ç”¨æ„ã—ã¦ã„ã¾ã™.',0),(485312,13481,'pt','Aguarde enquanto seu PDF estÃ¡ preparada...',0),(485313,13481,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ð¾Ð´Ð¾Ð¶Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾ÐºÐ° Ð²Ð°Ñˆ PDF Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ñ‚ÑÑ...',0),(485314,13481,'es','Por Favor Espera Mientras Que Su PDF esta Preparado',0),(485315,13481,'de','Bitte warten Sie wÃ¤hrend Ihrer PDF-Datei bereit ist...',0),(485316,13481,'en','Please Wait While Your PDF Is Prepared...',0),(485317,13482,'is','',0),(485318,13482,'dr','Ù¾ÛŒ Ø¯ÛŒ Ø§Ù Ø®ÙˆØ¯ Ø±Ø§ Ø¢Ù…Ø§Ø¯Ù‡ Ù…ÛŒ...',0),(485319,13482,'pr','Ù¾ÛŒ Ø¯ÛŒ Ø§Ù Ø®ÙˆØ¯ Ø±Ø§ Ø¢Ù…Ø§Ø¯Ù‡ Ù…ÛŒ...',0),(485320,13482,'tr','PDF hazÄ±rlanÄ±yor...',0),(485321,13482,'pl','Przygotowywana jest twÃ³j PDF...',0),(485322,13482,'bg','PDF ÑÐµ Ð¿Ð¾Ð´Ð³Ð¾Ñ‚Ð²Ñ...',0),(485323,13482,'ur','Ø¢Ù¾ Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ Ù…ÛŒÚº ØªÛŒØ§Ø± Ù†ÛÛŒÚº Ú©ÛŒ Ø¬Ø§ Ø±ÛÛŒ ÛÛ’...',0),(485324,13482,'sr','Ð¢Ð²Ð¾Ñ˜ ÐŸÐ”Ð¤ Ñ˜Ðµ Ñƒ Ð¿Ñ€Ð¸Ð¿Ñ€ÐµÐ¼Ð¸...',0),(485325,13482,'vi','Tá»‡p PDF cá»§a báº¡n Ä‘ang Ä‘Æ°á»£c chuáº©n bá»‹...',0),(485326,13482,'af','U PDF Word Voorberei...',0),(485327,13482,'ro','PDF este Ã®n curs de elaborare...',0),(485328,13482,'et','PDF on valmis...',0),(485329,13482,'si','VaÅ¡ PDF se pripravlja...',0),(485330,13482,'ba','PDF Anda sedang dipersiapkan...',0),(485331,13482,'nl','Uw PDF wordt voorbereid...',0),(485332,13482,'fi','PDF on valmis...',0),(485333,13482,'no','PDF-filen er forberedt...',0),(485334,13482,'da','Din PDF er under udarbejdelse...',0),(485335,13482,'ko','PDF ì¤€ë¹„ í•˜ ê³ ...',0),(485336,13482,'he','×ž×¡×ž×š PDF ×‘×”×›× ×”...',0),(485337,13482,'el','PDF ÏƒÎ±Ï‚ ÎµÏ„Î¿Î¹Î¼Î¬Î¶ÎµÏ„Î±Î¹...',0),(485338,13482,'zh','æ­£åœ¨å‡†å¤‡æ‚¨çš„ PDFã€‚',0),(485339,13482,'sv','Din PDF fÃ¶rbereds...',0),(485340,13482,'it','Il PDF Ã¨ in preparazione...',0),(485341,13482,'tl','',0),(485342,13482,'th','à¸à¸³à¸¥à¸±à¸‡à¹€à¸•à¸£à¸µà¸¢à¸¡à¹„à¸Ÿà¸¥à¹Œ PDF à¸‚à¸­à¸‡à¸„à¸¸à¸“...',0),(485343,13482,'hi','à¤…à¤ªà¤¨à¥€ à¤ªà¥€à¤¡à¥€à¤à¤« à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¯à¤¾à¤° à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤°à¤¹à¤¾ à¤¹à¥ˆ...',0),(485344,13482,'ms','PDF anda sedang bersedia...',0),(485345,13482,'ar','ÙˆÙŠØ¬Ø±ÙŠ Ø¥Ø¹Ø¯Ø§Ø¯ Ù…Ù„Ù PDF Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ...',0),(485346,13482,'fr','Votre fichier PDF est en cours de prÃ©paration...',0),(485347,13482,'jp','ã‚ãªãŸã® pdf ãƒ•ã‚¡ã‚¤ãƒ«ã‚’æº–å‚™ã—ã¦ã„ã¾ã™.',0),(485348,13482,'pt','Seu PDF estÃ¡ sendo preparada...',0),(485349,13482,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð³Ð¾Ñ‚Ð¾Ð²Ð¸Ñ‚ÑÑ Ð²Ð°Ñˆ PDF...',0),(485350,13482,'es','Su PDF se Prepara',0),(485351,13482,'de','Ihr PDF-Dokument wird vorbereitet...',0),(485352,13482,'en','Your PDF Is Being Prepared...',0),(485353,13483,'is','',0),(485354,13483,'dr','Intercompany Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ù†ØªÙ‚Ø§Ù„ Ø­Ø³Ø§Ø¨ Ø§ÙØ³Øª',0),(485355,13483,'pr','Intercompany Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ù†ØªÙ‚Ø§Ù„ Ø­Ø³Ø§Ø¨ Ø§ÙØ³Øª',0),(485356,13483,'tr','VarsayÄ±lan ÅŸirketlerarasÄ± Transfer mahsup hesabÄ±',0),(485357,13483,'pl','DomyÅ›lnie miÄ™dzyfirmowe Transfer konta przeciwstawnego',0),(485358,13483,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¼ÐµÐ¶Ð´ÑƒÑ„Ð¸Ñ€Ð¼ÐµÐ½Ð¸ Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ ÐºÐ¾Ð¼Ð¿ÐµÐ½ÑÐ¸Ñ€Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(485359,13483,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ù†Ù¹Ø±Ú©ÙˆÙ…Ù¾Ù†ÛŒ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ø¢ÙØ³Ù¹ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(485360,13483,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¼ÐµÑ’ÑƒÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜ÑÐºÐ¸Ñ… Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€ Ð¿Ð¾Ð¼Ð°ÐºÐ° Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(485361,13483,'vi','Máº·c Ä‘á»‹nh Intercompany chuyá»ƒn bÃ¹ Ä‘áº¯p tÃ i khoáº£n',0),(485362,13483,'af','Verstek Intercompany oordrag Offset rekening',0),(485363,13483,'ro','Inter-companii implicit transferul cont Offset',0),(485364,13483,'et','Vaikimisi kontsernisisese Ã¼lekande vastaskonto',0),(485365,13483,'si','Privzeto znotraj podjetja prenos Offset raÄun',0),(485366,13483,'ba','Default Intercompany Transfer Offset Account',0),(485367,13483,'nl','Standaard IC-Transfer tegenrekening',0),(485368,13483,'fi','Oletusarvoinen konserniyritysten vÃ¤linen siirto vastatili',0),(485369,13483,'no','Standard konserninterne overfÃ¸ring motkontoen',0),(485370,13483,'da','Standard intern overfÃ¸rsel modkonto',0),(485371,13483,'ko','ê¸°ë³¸ íšŒì‚¬ ê°„ ì „ì†¡ ìƒì‡„ ê³„ì •',0),(485372,13483,'he','×”×—×©×‘×•×Ÿ ×”× ×’×“×™ ×©×œ ×”×”×¢×‘×¨×” ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ ×‘×™×Ÿ-×—×‘×¨×ª×™',0),(485373,13483,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ Î´Î¹ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ­Ï‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® ÏŒÏ†ÏƒÎµÏ„ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(485374,13483,'zh','é»˜è®¤å†…éƒ¨è½¬ç§»å¯¹æ–¹çš„ç§‘ç›®',0),(485375,13483,'sv','Standard koncernintern Ã¶verlÃ¥telse motkontot',0),(485376,13483,'it','Conto di contropartita trasferimento Intercompany predefinito',0),(485377,13483,'tl','',0),(485378,13483,'th','à¸šà¸±à¸à¸Šà¸µà¸•à¸£à¸‡à¸‚à¹‰à¸²à¸¡à¸‚à¸­à¸‡à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡ à¸šà¸£à¸´à¸©à¸±à¸—à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(485379,13483,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ Intercompany à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤‘à¤«à¤¼à¤¸à¥‡à¤Ÿ à¤–à¤¾à¤¤à¥‡',0),(485380,13483,'ms','Lalai Intercompany pemindahan akaun mengimbangi',0),(485381,13483,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ù‚Ø§Ø¨Ù„ Ù†Ù‚Ù„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¨ÙŠÙ† Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø´Ù‚ÙŠÙ‚Ø©',0),(485382,13483,'fr','Compte de contrepartie de transfert par dÃ©faut intersociÃ©tÃ©s',0),(485383,13483,'jp','æ—¢å®šã®ä¼šç¤¾é–“è»¢é€ç›¸æ‰‹å‹˜å®š',0),(485384,13483,'pt','Conta de deslocamento padrÃ£o Intercompany transferÃªncia',0),(485385,13483,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð²Ð½ÑƒÑ‚Ñ€Ð¸Ñ…Ð¾Ð»Ð´Ð¸Ð½Ð³Ð¾Ð²Ð¾Ð³Ð¾ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸ ÐºÐ¾Ñ€Ñ€',0),(485386,13483,'es','Cuenta de Ajuste de Transferencia Interempresarial Predeterminado ',0),(485387,13483,'de','Standard Intercompany Transfer Gegenkonto',0),(485388,13483,'en','Default Intercompany Transfer Offset Account',0),(485389,13484,'is','',0),(485390,13484,'dr','Ø­Ø§Ø´ÛŒÙ‡',0),(485391,13484,'pr','Ø­Ø§Ø´ÛŒÙ‡',0),(485392,13484,'tr','Kenar boÅŸluÄŸu',0),(485393,13484,'pl','Margines',0),(485394,13484,'bg','ÐœÐ°Ñ€Ð¶',0),(485395,13484,'ur','Ø­Ø§Ø´ÛŒÛ',0),(485396,13484,'sr','ÐœÐ°Ñ€Ð³Ð¸Ð½Ð°',0),(485397,13484,'vi','Lá»£i nhuáº­n',0),(485398,13484,'af','Marge',0),(485399,13484,'ro','Marja',0),(485400,13484,'et','Marginaal',0),(485401,13484,'si','Stopnja',0),(485402,13484,'ba','Margin',0),(485403,13484,'nl','Marge',0),(485404,13484,'fi','Marginaali',0),(485405,13484,'no','Marg',0),(485406,13484,'da','Margen',0),(485407,13484,'ko','ì—¬ë°±',0),(485408,13484,'he','×©×•×œ×™×™×',0),(485409,13484,'el','Î ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿',0),(485410,13484,'zh','è¾¹è·',0),(485411,13484,'sv','Marginal',0),(485412,13484,'it','Margine',0),(485413,13484,'tl','',0),(485414,13484,'th','à¸‚à¸­à¸š',0),(485415,13484,'hi','à¤®à¤¾à¤°à¥à¤œà¤¿à¤¨',0),(485416,13484,'ms','Margin',0),(485417,13484,'ar','Ø§Ù„Ù‡Ø§Ù…Ø´',0),(485418,13484,'fr','Marge',0),(485419,13484,'jp','ãƒžãƒ¼ã‚¸ãƒ³',0),(485420,13484,'pt','Margem',0),(485421,13484,'ru','ÐœÐ°Ñ€Ð¶Ð°',0),(485422,13484,'es','Margen',0),(485423,13484,'de','Marge',0),(485424,13484,'en','Margin',0),(485425,13485,'is','',0),(485426,13485,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø§Ø±Ø¬ Ø§Ø² Ø­Ø§Ø´ÛŒÙ‡ Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø§Ø³Øª',0),(485427,13485,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø§Ø±Ø¬ Ø§Ø² Ø­Ø§Ø´ÛŒÙ‡ Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø§Ø³Øª',0),(485428,13485,'tr','DÄ±ÅŸ kenar boÅŸluÄŸu aralÄ±ÄŸÄ± emirdir',0),(485429,13485,'pl','KolejnoÅ›Ä‡ jest poza margines zakres',0),(485430,13485,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ðµ Ð¸Ð·Ð²ÑŠÐ½ Ð¿Ð¾Ð»ÐµÑ‚Ð¾ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(485431,13485,'ur','Ø¨ÛŒØ±ÙˆÙ†ÛŒ Ø­Ø§Ø´ÛŒÛ Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ ØªØ±ØªÛŒØ¨ ÛÛ’',0),(485432,13485,'sr','Ð ÐµÐ´ Ñ˜Ðµ Ð¸Ð·Ð²Ð°Ð½ Ð¼Ð°Ñ€Ð³Ð¸Ð½Ð° Ð¾Ð¿ÑÐµÐ³',0),(485433,13485,'vi','Thá»© tá»± lÃ  ngoÃ i lá» pháº¡m vi',0),(485434,13485,'af','Orde Is buite marge reeks',0),(485435,13485,'ro','Ordinea este gama de marja de exterior',0),(485436,13485,'et','Tellimus on vÃ¤ljaspool kasumimarginaal vahemik',0),(485437,13485,'si','Naloga je zunanji rob obseg',0),(485438,13485,'ba','Urutan adalah luar Margin rentang',0),(485439,13485,'nl','Volgorde Is buiten marge bereik',0),(485440,13485,'fi','JÃ¤rjestys on ulkopuolella reunuksen alue',0),(485441,13485,'no','RekkefÃ¸lgen er utenfor margen utvalg',0),(485442,13485,'da','Orden er ydersiden Margin vifte',0),(485443,13485,'ko','ìˆœì„œëŠ” ì™¸ë¶€ ì—¬ë°± ë²”ìœ„',0),(485444,13485,'he','×”×¡×“×¨ ×”×•× ×˜×•×•×— ×©×•×œ×™×™× ×‘×—×•×¥',0),(485445,13485,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÎµÎ¯Î½Î±Î¹ ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÏŒ Ï€ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(485446,13485,'zh','ä»¤å¤–è¾¹è·èŒƒå›´',0),(485447,13485,'sv','Ordern Ã¤r utanfÃ¶r marginalen utbud',0),(485448,13485,'it','Ordine Ã¨ gamma margine esterno',0),(485449,13485,'tl','',0),(485450,13485,'th','à¸ªà¸±à¹ˆà¸‡à¹€à¸›à¹‡à¸™à¸£à¸²à¸„à¸²à¸Šà¹ˆà¸§à¸‡ à¸™à¸­à¸ à¸‚à¸­à¸š',0),(485451,13485,'hi','à¤¬à¤¾à¤¹à¤° à¤®à¤¾à¤°à¥à¤œà¤¿à¤¨ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥à¤°à¤® à¤¹à¥ˆ',0),(485452,13485,'ms','Urutan adalah di luar julat Margin',0),(485453,13485,'ar','Ù‡Ùˆ Ø£Ù…Ø± Ø®Ø§Ø±Ø¬ Ù†Ø·Ø§Ù‚ Ø§Ù„Ù‡Ø§Ù…Ø´',0),(485454,13485,'fr','L\'ordre est la fourchette de marge extÃ©rieur',0),(485455,13485,'jp','é †åºã¯ãƒžãƒ¼ã‚¸ãƒ³ã®å¤–å´ç¯„å›²ã§ã™ã€‚',0),(485456,13485,'pt','A ordem Ã© o intervalo de margem exterior',0),(485457,13485,'ru','Ð—Ð°ÐºÐ°Ð· Ð²Ð½Ðµ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð° Ñ€Ð°Ð·Ð½Ð¸Ñ†Ñ‹',0),(485458,13485,'es','Pedido es Afuera el Rango del Margin',0),(485459,13485,'de','Reihenfolge ist auÃŸen zwischen',0),(485460,13485,'en','Order Is Outside Margin Range',0),(485461,13486,'is','',0),(485462,13486,'dr','Ù…Ù‚Ø¯Ø§Ø± Ú©Ø´ØªÛŒ',0),(485463,13486,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú©Ø´ØªÛŒ',0),(485464,13486,'tr','Gemi tutar',0),(485465,13486,'pl','Kwota statku',0),(485466,13486,'bg','ÐšÐ¾Ñ€Ð°Ð± Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(485467,13486,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ Ø±Ù‚Ù…',0),(485468,13486,'sr','Ð‘Ñ€Ð¾Ð´ Ð¸Ð·Ð½Ð¾Ñ',0),(485469,13486,'vi','Sá»‘ lÆ°á»£ng tÃ u',0),(485470,13486,'af','Skip bedrag',0),(485471,13486,'ro','Nava suma',0),(485472,13486,'et','Laeva suurus',0),(485473,13486,'si','Ladij znesek',0),(485474,13486,'ba','Jumlah kapal',0),(485475,13486,'nl','Schip bedrag',0),(485476,13486,'fi','Aluksen mÃ¤Ã¤rÃ¤',0),(485477,13486,'no','Skipet belÃ¸p',0),(485478,13486,'da','Skibet belÃ¸b',0),(485479,13486,'ko','ë°° ê¸ˆì•¡',0),(485480,13486,'he','×›×ž×•×ª ×”×¡×¤×™× ×”',0),(485481,13486,'el','Î Î»Î¿Î¯Î¿ Ï€Î¿ÏƒÏŒ',0),(485482,13486,'zh','èˆ¹èˆ¶æ•°é‡',0),(485483,13486,'sv','Fartyget belopp',0),(485484,13486,'it','QuantitÃ  di nave',0),(485485,13486,'tl','',0),(485486,13486,'th','à¸¢à¸­à¸”à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(485487,13486,'hi','à¤œà¤¹à¤¾à¤œ à¤°à¤¾à¤¶à¤¿',0),(485488,13486,'ms','Jumlah kapal',0),(485489,13486,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(485490,13486,'fr','Navire montant',0),(485491,13486,'jp','å‡ºè·é¡',0),(485492,13486,'pt','Quantidade de navio',0),(485493,13486,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÑƒÐ´Ð¾Ð²',0),(485494,13486,'es','Cantidad de EnvÃ­o',0),(485495,13486,'de','Schiff-Betrag',0),(485496,13486,'en','Ship Amount',0),(485497,13487,'is','',0),(485498,13487,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ ØªØ§ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(485499,13487,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ ØªØ§ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(485500,13487,'tr','FaturalandÄ±rÄ±lmasÄ±na izin vermek',0),(485501,13487,'pl','UmoÅ¼liwiÄ‡ fakturowanie',0),(485502,13487,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(485503,13487,'ur','Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(485504,13487,'sr','Ð”Ð¾Ð·Ð²Ð¾Ñ™Ð°Ð²Ð°Ñ˜Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(485505,13487,'vi','Cho phÃ©p hoÃ¡ Ä‘Æ¡n',0),(485506,13487,'af','Laat fakturering',0),(485507,13487,'ro','Permite facturarea',0),(485508,13487,'et','Arveldamiseks',0),(485509,13487,'si','Dovoli knjiÅ¾enje',0),(485510,13487,'ba','Memungkinkan faktur',0),(485511,13487,'nl','Toestaan facturering',0),(485512,13487,'fi','Salli laskutus',0),(485513,13487,'no','Tillate fakturering',0),(485514,13487,'da','Giver mulighed for fakturering',0),(485515,13487,'ko','ì¸ë³´ì´ìŠ¤ ë°œí–‰ í—ˆìš©',0),(485516,13487,'he','×œ××¤×©×¨ ×”×¤×§×ª ×—×©×‘×•× ×™×ª',0),(485517,13487,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î·Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(485518,13487,'zh','å…è®¸å¼€ç¥¨',0),(485519,13487,'sv','TillÃ¥ta fakturering',0),(485520,13487,'it','Consentire la fatturazione',0),(485521,13487,'tl','',0),(485522,13487,'th','à¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(485523,13487,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(485524,13487,'ms','Membenarkan invois',0),(485525,13487,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ù„ÙÙˆØªØ±Ø©',0),(485526,13487,'fr','Permettre la facturation',0),(485527,13487,'jp','è«‹æ±‚æ›¸ç™ºè¡Œã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(485528,13487,'pt','Permitir facturaÃ§Ã£o',0),(485529,13487,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(485530,13487,'es','Permitir la FacturaciÃ³n',0),(485531,13487,'de','ErmÃ¶glichen, Rechnungsstellung',0),(485532,13487,'en','Allow Invoicing',0),(485533,13488,'is','',0),(485534,13488,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ Ø¨Ø±Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´Ø§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(485535,13488,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ Ø¨Ø±Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÙØ§Ø±Ø´Ø§Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(485536,13488,'tr','SeÃ§ili sipariÅŸleri faturalama izin ver',0),(485537,13488,'pl','UmoÅ¼liwia wystawianie faktur dla wybranego zamÃ³wienia',0),(485538,13488,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(485539,13488,'ur','Ù…Ù†ØªØ®Ø¨ Ø­Ú©Ù… Ú©Û’ Ù„ÛŒÛ’ Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(485540,13488,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ Ð·Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(485541,13488,'vi','Cho phÃ©p hoÃ¡ Ä‘Æ¡n cho Ä‘Æ¡n Ä‘áº·t hÃ ng Ä‘Ã£ chá»n',0),(485542,13488,'af','Laat vir geselekteerde bestellings fakturering',0),(485543,13488,'ro','Permite facturarea pentru comenzi selectate',0),(485544,13488,'et','Valitud tellimuste arveldamiseks',0),(485545,13488,'si','Dovoli knjiÅ¾enje za izbrane naloge',0),(485546,13488,'ba','Memungkinkan faktur untuk dipilih pesanan',0),(485547,13488,'nl','Facturatie voor geselecteerde Orders toestaan',0),(485548,13488,'fi','Anna laskutuksen valitut tilaukset',0),(485549,13488,'no','Tillate fakturering For valgte ordrer',0),(485550,13488,'da','Giver mulighed for fakturering For de valgte ordrer',0),(485551,13488,'ko','ì„ íƒí•œ ì£¼ë¬¸ Invoicing í—ˆìš©',0),(485552,13488,'he','×œ××¤×©×¨ ×”×¤×§×ª ×—×©×‘×•× ×™×ª ×¢×‘×•×¨ × ×‘×—×¨×•×ª ×œ×”×–×ž× ×•×ª',0),(485553,13488,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î·Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· Î³Î¹Î± ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(485554,13488,'zh','å…è®¸æ‰€é€‰è®¢å•å¼€ç¥¨',0),(485555,13488,'sv','TillÃ¥ta fakturering fÃ¶r valda order',0),(485556,13488,'it','Consentire la fatturazione per gli ordini selezionati',0),(485557,13488,'tl','',0),(485558,13488,'th','à¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(485559,13488,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(485560,13488,'ms','Membenarkan invois untuk Tempahan yang terpilih',0),(485561,13488,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ù„ÙÙˆØªØ±Ø© Ù„Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(485562,13488,'fr','Permettre la facturation des commandes sÃ©lectionnÃ©es',0),(485563,13488,'jp','é¸æŠžã—ãŸæ³¨æ–‡ã®è«‹æ±‚æ›¸ç™ºè¡Œã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(485564,13488,'pt','Permitir facturaÃ§Ã£o para pedidos selecionados',0),(485565,13488,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð² Ð´Ð»Ñ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(485566,13488,'es','Permitir la FacturaciÃ³n Para Pedidos Seleccionados',0),(485567,13488,'de','Rechnungsstellung fÃ¼r ausgewÃ¤hlten AuftrÃ¤ge zu ermÃ¶glichen',0),(485568,13488,'en','Allow Invoicing For Selected Orders',0),(485569,13489,'is','',0),(485570,13489,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø§Ø´ÛŒÙ‡ Ø§Ø³ØªØ«Ù†Ø§',0),(485571,13489,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø§Ø´ÛŒÙ‡ Ø§Ø³ØªØ«Ù†Ø§',0),(485572,13489,'tr','Kenar Ã¶zel durum raporu',0),(485573,13489,'pl','Raport margines',0),(485574,13489,'bg','ÐœÐ°Ñ€Ð¶Ð¸Ð½ Ð¸Ð·ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(485575,13489,'ur','Ø­Ø§Ø´ÛŒÛ Ø§Ø³ØªØ«Ù†Ø§ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(485576,13489,'sr','ÐœÐ°Ñ€Ð³Ð¸Ð½Ðµ Ð¸Ð·ÑƒÐ·ÐµÑ‚Ð°Ðº Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(485577,13489,'vi','Margin ngoáº¡i lá»‡ bÃ¡o cÃ¡o',0),(485578,13489,'af','Marge uitsondering verslag',0),(485579,13489,'ro','Raport de exceptie marja',0),(485580,13489,'et','Marginaali erand aruanne',0),(485581,13489,'si','Stopnja izjema poroÄilo',0),(485582,13489,'ba','Margin pengecualian laporan',0),(485583,13489,'nl','Marge uitzondering verslag',0),(485584,13489,'fi','Marginaali poikkeusraportin',0),(485585,13489,'no','Marg unntaksrapport',0),(485586,13489,'da','Margen undtagelsesrapport',0),(485587,13489,'ko','ì—¬ë°± ì˜ˆì™¸ ë³´ê³ ì„œ',0),(485588,13489,'he','×©×•×œ×™×™× ×—×¨×™×’×” ×“×•×—',0),(485589,13489,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ ÎµÎ¾Î±Î¹ÏÎ­ÏƒÎµÏ‰Î½ Ï€ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿',0),(485590,13489,'zh','ä¿è¯é‡‘çš„å¼‚å¸¸æŠ¥å‘Š',0),(485591,13489,'sv','Marginal undantagsrapport',0),(485592,13489,'it','Relazione di eccezione di margine',0),(485593,13489,'tl','',0),(485594,13489,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸³à¹„à¸£',0),(485595,13489,'hi','à¤®à¤¾à¤°à¥à¤œà¤¿à¤¨ à¤…à¤ªà¤µà¤¾à¤¦ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(485596,13489,'ms','Laporan pengecualian margin',0),(485597,13489,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ø§Ù„Ù‡Ø§Ù…Ø´',0),(485598,13489,'fr','Rapport d\'Exception de marge',0),(485599,13489,'jp','ãƒžãƒ¼ã‚¸ãƒ³ä¾‹å¤–ãƒ¬ãƒãƒ¼ãƒˆ',0),(485600,13489,'pt','RelatÃ³rio de exceÃ§Ã£o de margem',0),(485601,13489,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾Ð± Ð¸ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ð¸ Ð¼Ð°Ñ€Ð¶Ð°',0),(485602,13489,'es','Informe de ExcepciÃ³n de Margen',0),(485603,13489,'de','Marge Ausnahmebericht',0),(485604,13489,'en','Margin Exception Report',0),(485605,13490,'is','',0),(485606,13490,'dr','ÙÙ‚Ø· Ø­Ù…Ù„ Ù…ÙˆØ§Ø±Ø¯ Ú¯Ù†Ø¬Ø§Ù†Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª.',0),(485607,13490,'pr','ÙÙ‚Ø· Ø­Ù…Ù„ Ù…ÙˆØ§Ø±Ø¯ Ú¯Ù†Ø¬Ø§Ù†Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª.',0),(485608,13490,'tr','YalnÄ±zca sevk edilen maddeleri dahil edilir.',0),(485609,13490,'pl','Tylko elementy dostarczane sÄ… wÅ‚Ä…czone.',0),(485610,13490,'bg','Ð’ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ ÑÐ° ÑÐ°Ð¼Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸.',0),(485611,13490,'ur','ØµØ±Ù Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ø§Ø´ÛŒØ§Ø¡ Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”',0),(485612,13490,'sr','Ð£ÐºÑ™ÑƒÑ‡ÐµÐ½Ðµ ÑÑƒ ÑÐ°Ð¼Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ.',0),(485613,13490,'vi','Chá»‰ chuyá»ƒn má»¥c Ä‘Æ°á»£c bao gá»“m.',0),(485614,13490,'af','Net shipped items is ingesluit.',0),(485615,13490,'ro','Doar Articole expediate sunt incluse.',0),(485616,13490,'et','Ainult lÃ¤hetatud kaubad kuuluvad.',0),(485617,13490,'si','Le poÅ¡iljajo postavke so vkljuÄeni.',0),(485618,13490,'ba','Disertakan hanya item dikirim.',0),(485619,13490,'nl','Alleen verzonden artikelen opgenomen zijn.',0),(485620,13490,'fi','Toimitetut nimikkeet sisÃ¤ltyvÃ¤t hintaan.',0),(485621,13490,'no','Bare leverte varene er inkludert.',0),(485622,13490,'da','Kun afsendte varer er inkluderet.',0),(485623,13490,'ko','ì¶œí•˜ ëœ í•­ëª©ë§Œ í¬í•¨ ë˜ì–´ ìžˆìŠµë‹ˆë‹¤.',0),(485624,13490,'he','×¨×§ ×¤×¨×™×˜×™× ×©× ×©×œ×—×” ×”×™× × ×›×œ×•×œ×™×.',0),(485625,13490,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹ Î¼ÏŒÎ½Î¿ Î±Ï€Î¿ÏƒÏ„Î­Î»Î»ÎµÏ„Î±Î¹ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±.',0),(485626,13490,'zh','åªæœ‰è¿åˆ°çš„ç‰©å“æ‰åŒ…æ‹¬åœ¨å†…ã€‚',0),(485627,13490,'sv','Endast levererade artiklar ingÃ¥r.',0),(485628,13490,'it','Solo spedito sono inclusi.',0),(485629,13490,'tl','',0),(485630,13490,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹„à¸”à¹‰',0),(485631,13490,'hi','à¤•à¥‡à¤µà¤² à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤® à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥‹à¤¤à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(485632,13490,'ms','Hanya barang-barang dihantar juga disediakan.',0),(485633,13490,'ar','ÙÙ‚Ø· ÙŠØªÙ… ØªØ¶Ù…ÙŠÙ† Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§.',0),(485634,13490,'fr','Seuls les articles expÃ©diÃ©s sont inclus.',0),(485635,13490,'jp','å‡ºè·ã•ã‚ŒãŸé …ç›®ã®ã¿ãŒå«ã¾ã‚Œã¾ã™ã€‚',0),(485636,13490,'pt','Somente os itens enviados sÃ£o incluÃ­dos.',0),(485637,13490,'ru','Ð’ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ… Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð¾Ð².',0),(485638,13490,'es','Solo items enviados estan incluidos',0),(485639,13490,'de','Nur gelieferten Artikel enthalten sind.',0),(485640,13490,'en','Only shipped items are included.',0),(485641,13491,'is','',0),(485642,13491,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(485643,13491,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(485644,13491,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde sipariÅŸlerini',0),(485645,13491,'pl','ZamÃ³wienia oznaczony jako powodzeniem',0),(485646,13491,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(485647,13491,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù†Ø´Ø§Ù† Ø²Ø¯ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(485648,13491,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(485649,13491,'vi','CÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng Ä‘Æ°á»£c Ä‘Ã¡nh dáº¥u thÃ nh cÃ´ng',0),(485650,13491,'af','Bestellings suksesvol gemerk',0),(485651,13491,'ro','Comenzi marcate cu succes',0),(485652,13491,'et','Tellimused edukalt tÃ¤histatud',0),(485653,13491,'si','Nalogi oznaÄene uspeÅ¡no',0),(485654,13491,'ba','Pesanan ditandai berhasil',0),(485655,13491,'nl','Bestellingen gemarkeerd met succes',0),(485656,13491,'fi','Tilaukset merkitty onnistuneesti',0),(485657,13491,'no','Bestillinger merket vellykket',0),(485658,13491,'da','Ordrer markeret med succes',0),(485659,13491,'ko','ëª…ë ¹ì„ ì„±ê³µì ìœ¼ë¡œ í‘œì‹œ',0),(485660,13491,'he','×”×–×ž× ×•×ª ×ž×¡×•×ž×Ÿ ×‘×”×¦×œ×—×”',0),(485661,13491,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… ÏƒÎ·Î¼ÎµÎ¹ÏŽÎ½Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(485662,13491,'zh','æˆåŠŸæ ‡è®°è®¢å•',0),(485663,13491,'sv','Order mÃ¤rkt framgÃ¥ngsrikt',0),(485664,13491,'it','Ordini contrassegnati con successo',0),(485665,13491,'tl','',0),(485666,13491,'th','à¸ªà¸±à¹ˆà¸‡à¸—à¸³à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(485667,13491,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤',0),(485668,13491,'ms','Perintah-perintah yang ditandakan berjaya',0),(485669,13491,'ar','Ø£ÙˆØ§Ù…Ø± ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(485670,13491,'fr','MarquÃ© avec succÃ¨s les commandes',0),(485671,13491,'jp','æ³¨æ–‡ãŒæ­£å¸¸ã«ãƒžãƒ¼ã‚¯',0),(485672,13491,'pt','Ordens marcadas com sucesso',0),(485673,13491,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹, Ð¾Ñ‚Ð¼ÐµÑ‡ÐµÐ½Ð½Ñ‹Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(485674,13491,'es','Pedidos Marcados Exitosamente',0),(485675,13491,'de','Bestellungen erfolgreich markiert',0),(485676,13491,'en','Orders Marked Successfully',0),(485677,13492,'is','',0),(485678,13492,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø§Ø±Ø¬ Ø§Ø² Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø­Ø§Ø´ÛŒÙ‡',0),(485679,13492,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø§Ø±Ø¬ Ø§Ø² Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø­Ø§Ø´ÛŒÙ‡',0),(485680,13492,'tr','SipariÅŸlerinin marj aralÄ±k dÄ±ÅŸÄ±nda',0),(485681,13492,'pl','Zlecenia poza zakres margines',0),(485682,13492,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¸Ð·Ð²ÑŠÐ½ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð° Ð½Ð° Ð¼Ð°Ñ€Ð¶',0),(485683,13492,'ur','Ø­Ø§Ø´ÛŒÛ Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ø³Û’ Ø¨Ø§ÛØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(485684,13492,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ð¸Ð·Ð²Ð°Ð½ Ð¼Ð°Ñ€Ð³Ð¸Ð½Ð° Ð¾Ð¿ÑÐµÐ³Ð°',0),(485685,13492,'vi','ÄÆ¡n Ä‘áº·t hÃ ng bÃªn ngoÃ i pháº¡m vi Margin',0),(485686,13492,'af','Bestellings buite die kantlyn-reeks',0),(485687,13492,'ro','Comenzi Ã®n afara intervalului de margine',0),(485688,13492,'et','Tellimuste varu vÃ¤ljaspool',0),(485689,13492,'si','NaroÄila izven obmoÄja roba',0),(485690,13492,'ba','Pesanan di luar jangkauan Margin',0),(485691,13492,'nl','Orders buiten het bereik van de marge',0),(485692,13492,'fi','Tilaukset marginaali alueen ulkopuolella',0),(485693,13492,'no','Bestillinger utenfor margen omrÃ¥det',0),(485694,13492,'da','Ordrer uden Margin',0),(485695,13492,'ko','ì—¬ë°± ë²”ìœ„ ì´ì™¸ì˜ ì£¼ë¬¸',0),(485696,13492,'he','×”×–×ž× ×•×ª ×ž×—×•×¥ ×œ×˜×•×•×— ×©×•×œ×™×™×',0),(485697,13492,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÎµÎºÏ„ÏŒÏ‚ Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Ï‡Î®Ï‚ Ï„Î¿Ï… Ï€ÎµÏÎ¹Î¸Ï‰ÏÎ¯Î¿Ï…',0),(485698,13492,'zh','è¾¹è·èŒƒå›´ä»¥å¤–çš„è®¢å•',0),(485699,13492,'sv','BestÃ¤llningar utanfÃ¶r marginalen',0),(485700,13492,'it','Ordini di fuori dell\'intervallo del margine',0),(485701,13492,'tl','',0),(485702,13492,'th','à¸ªà¸±à¹ˆà¸‡à¸™à¸­à¸à¸Šà¹ˆà¸§à¸‡à¸‚à¸­à¸š',0),(485703,13492,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤°à¥à¤œà¤¿à¤¨ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¥‡ à¤¬à¤¾à¤¹à¤°',0),(485704,13492,'ms','Pesanan di luar julat Margin',0),(485705,13492,'ar','Ø£ÙˆØ§Ù…Ø± Ø®Ø§Ø±Ø¬ Ù†Ø·Ø§Ù‚ Ø§Ù„Ù‡Ø§Ù…Ø´',0),(485706,13492,'fr','Ordres en dehors de la fourchette de la marge',0),(485707,13492,'jp','ä½™ç™½ã®ç¯„å›²å¤–ã®å—æ³¨',0),(485708,13492,'pt','Ordens fora do intervalo de margem',0),(485709,13492,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð·Ð° Ð¿Ñ€ÐµÐ´ÐµÐ»Ð°Ð¼Ð¸ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð° Ñ€Ð°Ð·Ð½Ð¸Ñ†Ñ‹',0),(485710,13492,'es','Pedidos Afuera El Rango del Margin',0),(485711,13492,'de','Bestellungen auÃŸerhalb der Margin-Bereich',0),(485712,13492,'en','Orders Outside The Margin Range',0),(485713,13493,'is','',0),(485714,13493,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§ Ø³Ù¾Ø±Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø´Ø§Ù…Ù„ Ù†Ù…ÛŒ Ø´ÙˆØ¯.',0),(485715,13493,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¨Ø§ Ø³Ù¾Ø±Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø´Ø§Ù…Ù„ Ù†Ù…ÛŒ Ø´ÙˆØ¯.',0),(485716,13493,'tr','Emir ile mevduat zaten eklenmez.',0),(485717,13493,'pl','ZamÃ³wienia z depozytÃ³w nie sÄ… juÅ¼ zawarte.',0),(485718,13493,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ñ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸ Ð²ÐµÑ‡Ðµ Ð½Ðµ ÑÐ° Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸.',0),(485719,13493,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ø°Ø®Ø§Ø¦Ø± Ú©Û’ Ø³Ø§ØªÚ¾ Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ø´Ø§Ù…Ù„ Ù†ÛÛŒÚº ÛÛŒÚº Û”',0),(485720,13493,'sr','ÐÐ°Ð»Ð¾Ð³Ðµ ÑÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸Ð¼Ð° Ð²ÐµÑ› Ð½Ð¸ÑÑƒ ÑƒÐºÑ™ÑƒÑ‡ÐµÐ½Ðµ.',0),(485721,13493,'vi','ÄÆ¡n Ä‘áº·t hÃ ng vá»›i tiá»n gá»­i Ä‘Ã£ Ä‘Æ°á»£c khÃ´ng bao gá»“m.',0),(485722,13493,'af','Bestellings met deposito\'s reeds word nie ingesluit nie.',0),(485723,13493,'ro','Comenzi cu depozite, deja, nu sunt incluse.',0),(485724,13493,'et','Tellimused, mille deposiitide juba ei ole kaasatud.',0),(485725,13493,'si','NaroÄila z depoziti Å¾e niso vkljuÄene.',0),(485726,13493,'ba','Pesanan dengan deposito sudah juga tidak disertakan.',0),(485727,13493,'nl','Orders met deposito\'s zijn al niet opgenomen.',0),(485728,13493,'fi','Tilaukset, joissa talletukset eivÃ¤t jo sisÃ¤lly.',0),(485729,13493,'no','Ordrer med innskudd er allerede ikke inkludert.',0),(485730,13493,'da','Ordrer med indskud er allerede ikke inkluderet.',0),(485731,13493,'ko','ì˜ˆê¸ˆ ì£¼ë¬¸ì„ ì´ë¯¸ í¬í•¨ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(485732,13493,'he','×”×–×ž× ×•×ª ×¢× ×”×¤×§×“×•×ª ×›×‘×¨ ××™× × ×›×œ×•×œ×™×.',0),(485733,13493,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î¼Îµ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚ Î´ÎµÎ½ Î­Ï‡Î¿Ï…Î½ Î®Î´Î· Ï€ÎµÏÎ¹Î»Î·Ï†Î¸ÎµÎ¯.',0),(485734,13493,'zh','å·²ç»ä¸Žå­˜æ¬¾çš„è®¢å•åˆä¸åŒ…æ‹¬åœ¨å†…ã€‚',0),(485735,13493,'sv','Order med insÃ¤ttningar ingÃ¥r redan inte.',0),(485736,13493,'it','Gli ordini con i depositi non sono giÃ  inclusi.',0),(485737,13493,'tl','',0),(485738,13493,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆ à¸¡à¸µà¹€à¸‡à¸´à¸™à¸à¸²à¸à¹à¸¥à¹‰à¸§à¹„à¸”à¹‰à¹„à¸¡à¹ˆ',0),(485739,13493,'hi','à¤œà¤®à¤¾ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤¦à¥‡à¤¶ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¶à¤¾à¤®à¤¿à¤² à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¤‚à¥¤',0),(485740,13493,'ms','Pesanan dengan Deposit sudah adalah tidak termasuk.',0),(485741,13493,'ar','Ø§Ù„ÙØ¹Ù„ Ø£ÙˆØ§Ù…Ø± Ù…Ø¹ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ ØºÙŠØ± Ù…Ø´Ù…ÙˆÙ„Ø©.',0),(485742,13493,'fr','DÃ©jÃ  arrÃªtÃ©s par des dÃ©pÃ´ts ne sont pas incluses.',0),(485743,13493,'jp','æ—¢ã«é é‡‘ã®æ³¨æ–‡ã¯å«ã¾ã‚Œã¾ã›ã‚“ã€‚',0),(485744,13493,'pt','Ordens com depÃ³sitos jÃ¡ nÃ£o estÃ£o incluÃ­das.',0),(485745,13493,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ñ Ð¼ÐµÑÑ‚Ð¾Ñ€Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ ÑƒÐ¶Ðµ Ð½Ðµ Ð²ÐºÐ»ÑŽÑ‡Ð°ÑŽÑ‚ÑÑ.',0),(485746,13493,'es','Pedidos co depositos ya no estan incluidos',0),(485747,13493,'de','AuftrÃ¤ge mit Einlagen sind nicht bereits enthalten.',0),(485748,13493,'en','Orders with deposits already are not included.',0),(485749,13494,'is','',0),(485750,13494,'dr','Ø§Ø±Ø²Ø´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ù…Ù‡',0),(485751,13494,'pr','Ø§Ø±Ø²Ø´ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ù…Ù‡',0),(485752,13494,'tr','TÃ¼m gÃ¶nderiler deÄŸeri',0),(485753,13494,'pl','WartoÅ›Ä‡ wszystkich przesyÅ‚ek',0),(485754,13494,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(485755,13494,'ur','ØªÙ…Ø§Ù… ØªØ±Ø³ÛŒÙ„ Ú©ÛŒ Ù‚Ø¯Ø±',0),(485756,13494,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ Ð·Ð° ÑÐ²Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(485757,13494,'vi','GiÃ¡ trá»‹ cá»§a táº¥t cáº£ cÃ¡c lÃ´ hÃ ng',0),(485758,13494,'af','Waarde van alle vervoer',0),(485759,13494,'ro','Valoarea de toate transporturile',0),(485760,13494,'et','KÃµikide saadetiste vÃ¤Ã¤rtust',0),(485761,13494,'si','Vrednost vseh poÅ¡iljk',0),(485762,13494,'ba','Nilai semua pengiriman',0),(485763,13494,'nl','Waarde van alle zendingen',0),(485764,13494,'fi','Kaikki lÃ¤hetykset arvosta',0),(485765,13494,'no','Verdien av alle forsendelser',0),(485766,13494,'da','VÃ¦rdien af alle forsendelser',0),(485767,13494,'ko','ëª¨ë“  í™”ë¬¼ì˜ ê°€ì¹˜',0),(485768,13494,'he','×”×¢×¨×š ×©×œ ×›×œ ×”×ž×©×œ×•×—×™×',0),(485769,13494,'el','Î— Î±Î¾Î¯Î± ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»ÏŽÎ½',0),(485770,13494,'zh','æ‰€æœ‰è´§ç‰©çš„ä»·å€¼',0),(485771,13494,'sv','VÃ¤rdet av alla transporter',0),(485772,13494,'it','Valore di tutte le spedizioni',0),(485773,13494,'tl','',0),(485774,13494,'th','à¸„à¹ˆà¸²à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(485775,13494,'hi','à¤¸à¤­à¥€ à¤²à¤¦à¤¾à¤¨ à¤•à¤¾ à¤®à¤¾à¤¨',0),(485776,13494,'ms','Nilai semua penghantaran',0),(485777,13494,'ar','Ø§Ù„Ù‚ÙŠÙ…Ø© Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´Ø­Ù†Ø§Øª',0),(485778,13494,'fr','Valeur de toutes les expÃ©ditions',0),(485779,13494,'jp','ã™ã¹ã¦ã®è²¨ç‰©ã®ä¾¡å€¤',0),(485780,13494,'pt','Valor de todas as transferÃªncias',0),(485781,13494,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð²ÑÐµÑ… Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¾Ðº',0),(485782,13494,'es','Valor de Todos los EnvÃ­os',0),(485783,13494,'de','Wert aller Sendungen',0),(485784,13494,'en','Value Of All Shipments',0),(485785,13495,'is','',0),(485786,13495,'dr','Ø±Ù†Ú¯ Ú©Ø§Ø¯Ø± ÙØ§ÛŒÙ„',0),(485787,13495,'pr','Ø±Ù†Ú¯ Ú©Ø§Ø¯Ø± ÙØ§ÛŒÙ„',0),(485788,13495,'tr','Renkli kenarlÄ±k dosya',0),(485789,13495,'pl','Kolor obramowania pliku',0),(485790,13495,'bg','Ð¦Ð²ÑÑ‚ Ð³Ñ€Ð°Ð½Ð¸Ñ†Ð° Ñ„Ð°Ð¹Ð»',0),(485791,13495,'ur','Ø±Ù†Ú¯ Ø³Ø±Ø­Ø¯ Ù…Ø³Ù„',0),(485792,13495,'sr','Ð‘Ð¾Ñ˜Ð° Ð¸Ð²Ð¸Ñ†Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(485793,13495,'vi','MÃ u sáº¯c biÃªn giá»›i táº­p tin',0),(485794,13495,'af','Kleur grens lÃªer',0),(485795,13495,'ro','Culoare bordurÄƒ fiÅŸier',0),(485796,13495,'et','VÃ¤rv piirivalve faili',0),(485797,13495,'si','Datoteka Barva obrobe',0),(485798,13495,'ba','File perbatasan warna',0),(485799,13495,'nl','Kleur rand bestand',0),(485800,13495,'fi','VÃ¤rin raja tiedosto',0),(485801,13495,'no','Farge pynteborden',0),(485802,13495,'da','Farve grÃ¦nsen fil',0),(485803,13495,'ko','ì»¬ëŸ¬ í…Œë‘ë¦¬ íŒŒì¼',0),(485804,13495,'he','×¦×‘×¢ ×”×’×‘×•×œ ×§×•×‘×¥',0),(485805,13495,'el','Î§ÏÏŽÎ¼Î± Ï€ÎµÏÎ¹Î³ÏÎ¬Î¼Î¼Î±Ï„Î¿Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿',0),(485806,13495,'zh','å½©è‰²è¾¹æ¡†æ–‡ä»¶',0),(485807,13495,'sv','FÃ¤rg grÃ¤nsen fil',0),(485808,13495,'it','Colore bordo File',0),(485809,13495,'tl','',0),(485810,13495,'th','à¹à¸Ÿà¹‰à¸¡à¸ªà¸µà¹€à¸ªà¹‰à¸™à¸‚à¸­à¸š',0),(485811,13495,'hi','à¤°à¤‚à¤— à¤¸à¥€à¤®à¤¾ à¤«à¤¼à¤¾à¤‡à¤²',0),(485812,13495,'ms','Warna sempadan fail',0),(485813,13495,'ar','Ù…Ù„Ù Ù„ÙˆÙ† Ø§Ù„Ø­Ø¯ÙˆØ¯',0),(485814,13495,'fr','Couleur bordure fichier',0),(485815,13495,'jp','è‰²æž ç·šãƒ•ã‚¡ã‚¤ãƒ«',0),(485816,13495,'pt','Arquivo de borda de cor',0),(485817,13495,'ru','Ð¦Ð²ÐµÑ‚ Ð³Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ñ„Ð°Ð¹Ð»Ð°',0),(485818,13495,'es','Colorea Borde de File',0),(485819,13495,'de','Farbe-Grenze-Datei',0),(485820,13495,'en','Color Border File',0),(485821,13496,'is','',0),(485822,13496,'dr','ÙØ§ÛŒÙ„ Ø·Ø±Ø§Ø­ÛŒ ÙˆÛŒÚ˜Ù‡',0),(485823,13496,'pr','ÙØ§ÛŒÙ„ Ø·Ø±Ø§Ø­ÛŒ ÙˆÛŒÚ˜Ù‡',0),(485824,13496,'tr','Ã–zel tasarÄ±m dosyasÄ±',0),(485825,13496,'pl','Specjalna konstrukcja pliku',0),(485826,13496,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÐµÐ½ Ð´Ð¸Ð·Ð°Ð¹Ð½ Ñ„Ð°Ð¹Ð»',0),(485827,13496,'ur','Ø®ØµÙˆØµÛŒ ÚˆÛŒØ²Ø§Ø¦Ù† ÙØ§Ø¦Ù„',0),(485828,13496,'sr','ÐŸÐ¾ÑÐµÐ±Ð°Ð½ Ð´Ð¸Ð·Ð°Ñ˜Ð½ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(485829,13496,'vi','Thiáº¿t káº¿ Ä‘áº·c biá»‡t táº­p tin',0),(485830,13496,'af','Spesiale ontwerp lÃªer',0),(485831,13496,'ro','Special Design dosar',0),(485832,13496,'et','Erilist disaini faili',0),(485833,13496,'si','Posebna zasnova datoteke',0),(485834,13496,'ba','File desain khusus',0),(485835,13496,'nl','Speciale ontwerp bestand',0),(485836,13496,'fi','Erityinen muotoilu tiedosto',0),(485837,13496,'no','Spesielle Design fil',0),(485838,13496,'da','Specielle designfil',0),(485839,13496,'ko','íŠ¹ë³„ í•œ ë””ìžì¸ íŒŒì¼',0),(485840,13496,'he','×§×•×‘×¥ ×¢×™×¦×•×‘ ×ž×™×•×—×“',0),(485841,13496,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Î½Ï„ÏÎ±Ï€Î­',0),(485842,13496,'zh','ç‰¹æ®Šè®¾è®¡æ–‡ä»¶',0),(485843,13496,'sv','Speciell Design fil',0),(485844,13496,'it','File di disegno speciale',0),(485845,13496,'tl','',0),(485846,13496,'th','à¹à¸Ÿà¹‰à¸¡à¸­à¸­à¸à¹à¸šà¸šà¸žà¸´à¹€à¸¨à¸©',0),(485847,13496,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤¡à¤¿à¤œà¤¾à¤‡à¤¨ à¤«à¤¼à¤¾à¤‡à¤²',0),(485848,13496,'ms','Fail khas rekabentuk',0),(485849,13496,'ar','Ù…Ù„Ù ØªØµÙ…ÙŠÙ… Ø®Ø§Øµ',0),(485850,13496,'fr','Fichier de conception spÃ©ciale',0),(485851,13496,'jp','ç‰¹åˆ¥ãªè¨­è¨ˆãƒ•ã‚¡ã‚¤ãƒ«',0),(485852,13496,'pt','Arquivo de projeto especial',0),(485853,13496,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð´Ð¸Ð·Ð°Ð¹Ð½ Ñ„Ð°Ð¹Ð»',0),(485854,13496,'es','File de DiseÃ±o Especial',0),(485855,13496,'de','Spezielle Design-Datei',0),(485856,13496,'en','Special Design File',0),(485857,13497,'is','',0),(485858,13497,'dr','Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ÙØ§ÛŒÙ„',0),(485859,13497,'pr','Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ ÙØ§ÛŒÙ„',0),(485860,13497,'tr','Standart dosya',0),(485861,13497,'pl','Standardowy plik',0),(485862,13497,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ñ„Ð°Ð¹Ð»',0),(485863,13497,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ù…Ø³Ù„',0),(485864,13497,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ñ„Ð°Ñ˜Ð»',0),(485865,13497,'vi','TiÃªu chuáº©n táº­p tin',0),(485866,13497,'af','Standaard lÃªer',0),(485867,13497,'ro','Standard de fiÅŸier',0),(485868,13497,'et','Standard fail',0),(485869,13497,'si','Standardne datoteke',0),(485870,13497,'ba','File standar',0),(485871,13497,'nl','Standaard bestand',0),(485872,13497,'fi','Standard tiedosto',0),(485873,13497,'no','Standard fil',0),(485874,13497,'da','Standard fil',0),(485875,13497,'ko','í‘œì¤€ íŒŒì¼',0),(485876,13497,'he','×§×•×‘×¥ ×¨×’×™×œ',0),(485877,13497,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(485878,13497,'zh','æ ‡å‡†çš„æ–‡ä»¶',0),(485879,13497,'sv','Standard fil',0),(485880,13497,'it','File standard',0),(485881,13497,'tl','',0),(485882,13497,'th','à¹à¸Ÿà¹‰à¸¡à¸¡à¸²à¸•à¸£à¸à¸²à¸™',0),(485883,13497,'hi','à¤®à¤¾à¤¨à¤• à¤«à¤¼à¤¾à¤‡à¤²',0),(485884,13497,'ms','Fail',0),(485885,13497,'ar','Ù…Ù„Ù Ù‚ÙŠØ§Ø³ÙŠ',0),(485886,13497,'fr','Fichier standard',0),(485887,13497,'jp','æ¨™æº–çš„ãªãƒ•ã‚¡ã‚¤ãƒ«',0),(485888,13497,'pt','Arquivo padrÃ£o',0),(485889,13497,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ñ„Ð°Ð¹Ð»',0),(485890,13497,'es','File EstÃ¡ndar',0),(485891,13497,'de','Standard-Datei',0),(485892,13497,'en','Standard File',0),(485893,13498,'is','',0),(485894,13498,'dr','Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ø² Ú©Ø±Ø¯Ù†',0),(485895,13498,'pr','Ø¨Ø±Ø§ÛŒ Ø¨Ø§Ø² Ú©Ø±Ø¯Ù†',0),(485896,13498,'tr','AÃ§mak iÃ§in',0),(485897,13498,'pl','Aby otworzyÄ‡',0),(485898,13498,'bg','Ð”Ð° ÑÐµ Ð¾Ñ‚Ð²Ð¾Ñ€Ð¸',0),(485899,13498,'ur','Ú©Û’ Ù„Ø¦Û’ Ú©Ú¾Ù„Ø§',0),(485900,13498,'sr','ÐÐ° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾Ð¼',0),(485901,13498,'vi','Äá»ƒ má»Ÿ',0),(485902,13498,'af','Om oop te',0),(485903,13498,'ro','Pentru a deschide',0),(485904,13498,'et','Ava',0),(485905,13498,'si','Za odprto',0),(485906,13498,'ba','Buka',0),(485907,13498,'nl','Open',0),(485908,13498,'fi','Avoin',0),(485909,13498,'no','Ã…pne',0),(485910,13498,'da','At Ã¥bne',0),(485911,13498,'ko','ì—´ê¸°ë¥¼',0),(485912,13498,'he','×¢×œ ×¤×ª×™×—×”',0),(485913,13498,'el','Î£Îµ Î±Î½Î¿Î¹ÎºÏ„Î®',0),(485914,13498,'zh','ä¸ºå¼€æ”¾',0),(485915,13498,'sv','Till Ã¶ppna',0),(485916,13498,'it','Apri',0),(485917,13498,'tl','',0),(485918,13498,'th','à¹€à¸¡à¸·à¹ˆà¸­à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹€à¸›à¸´à¸”',0),(485919,13498,'hi','à¤–à¥‹à¤²à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(485920,13498,'ms','Untuk membuka',0),(485921,13498,'ar','Ù„ÙØªØ­',0),(485922,13498,'fr','Sur Ouvrir',0),(485923,13498,'jp','é–‹ã',0),(485924,13498,'pt','Para abrir',0),(485925,13498,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚ÑŒ',0),(485926,13498,'es','A abrir',0),(485927,13498,'de','Auf Ã–ffnen',0),(485928,13498,'en','To Open',0),(485929,13499,'is','',0),(485930,13499,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ±Ø¯ Ø¨Ù‡ Ø§Ù†ØªÙ‚Ø§Ù„',0),(485931,13499,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù…ÙˆØ±Ø¯ Ø¨Ù‡ Ø§Ù†ØªÙ‚Ø§Ù„',0),(485932,13499,'tr','Transfer iÃ§in Ã¶ÄŸe ekle',0),(485933,13499,'pl','Dodaj element do przenoszenia',0),(485934,13499,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÐºÑŠÐ¼ Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ',0),(485935,13499,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(485936,13499,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(485937,13499,'vi','ThÃªm má»¥c Ä‘á»ƒ chuyá»ƒn',0),(485938,13499,'af','Voeg die Item by oordrag',0),(485939,13499,'ro','AdÄƒugaÅ£i element de Transfer',0),(485940,13499,'et','Lisada kauba Ã¼leandmine',0),(485941,13499,'si','Dodajte element za prenos',0),(485942,13499,'ba','Menambahkan Item ke Transfer',0),(485943,13499,'nl','Item toevoegen aan overdracht',0),(485944,13499,'fi','LisÃ¤Ã¤ siirto',0),(485945,13499,'no','Legge til overfÃ¸ring',0),(485946,13499,'da','FÃ¸j element til overfÃ¸rsel',0),(485947,13499,'ko','ì´ì „ì— í•­ëª©ì„ ì¶”ê°€',0),(485948,13499,'he','×”×•×¡×£ ×¤×¨×™×˜ ×”×¢×‘×¨×”',0),(485949,13499,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï… ÏƒÏ„Î·Î½ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬',0),(485950,13499,'zh','å°†é¡¹ç›®æ·»åŠ åˆ°ä¼ è¾“',0),(485951,13499,'sv','LÃ¤gga till objekt till Ã¶verfÃ¶ra',0),(485952,13499,'it','Aggiungere l\'elemento al trasferimento',0),(485953,13499,'tl','',0),(485954,13499,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(485955,13499,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(485956,13499,'ms','Menambah Item ke pemindahan',0),(485957,13499,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù†ØµØ± Ø¥Ù„Ù‰ Ù†Ù‚Ù„',0),(485958,13499,'fr','Ajouter l\'article au transfert',0),(485959,13499,'jp','è»¢é€ã™ã‚‹é …ç›®ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(485960,13499,'pt','Adicionar Item de transferÃªncia',0),(485961,13499,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð´Ð»Ñ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(485962,13499,'es','Agregar Item Para Transferir',0),(485963,13499,'de','Transfer Artikel hinzufÃ¼gen',0),(485964,13499,'en','Add Item To Transfer',0),(485965,13500,'is','',0),(485966,13500,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ø² Ø´Ø±Ú©Øª',0),(485967,13500,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ø² Ø´Ø±Ú©Øª',0),(485968,13500,'tr','Åžirketten varsayÄ±lan',0),(485969,13500,'pl','DomyÅ›lnie firmy',0),(485970,13500,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚ Ñ„Ð¸Ñ€Ð¼Ð°',0),(485971,13500,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ø³Û’ Ø·Û’ Ø´Ø¯Û',0),(485972,13500,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¸Ð· ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(485973,13500,'vi','Máº·c Ä‘á»‹nh tá»« cÃ´ng ty',0),(485974,13500,'af','Verstek van maatskappy',0),(485975,13500,'ro','Implicit la companie',0),(485976,13500,'et','Firma vaikimisi',0),(485977,13500,'si','Privzeta iz podjetja',0),(485978,13500,'ba','Default dari perusahaan',0),(485979,13500,'nl','Standaard van bedrijf',0),(485980,13500,'fi','Oletusarvo perustuu yhtiÃ¶n',0),(485981,13500,'no','Standard fra selskap',0),(485982,13500,'da','Standard fra virksomheden',0),(485983,13500,'ko','íšŒì‚¬ì—ì„œ ê¸°ë³¸',0),(485984,13500,'he','×‘×¨×™×¨×ª ×ž×—×“×œ ×©×œ ×—×‘×¨×”',0),(485985,13500,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î±Ï€ÏŒ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(485986,13500,'zh','æ¥è‡ªå…¬å¸çš„é»˜è®¤å€¼',0),(485987,13500,'sv','Standard frÃ¥n fÃ¶retag',0),(485988,13500,'it','Predefinito da azienda',0),(485989,13500,'tl','',0),(485990,13500,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ˆà¸²à¸à¸šà¸£à¸´à¸©à¸±à¸—',0),(485991,13500,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥‡ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(485992,13500,'ms','Lalai daripada Syarikat',0),(485993,13500,'ar','Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù…Ù† Ø§Ù„Ø´Ø±ÙƒØ©',0),(485994,13500,'fr','Par dÃ©faut de la compagnie',0),(485995,13500,'jp','æ—¢å®šã®ä¼šç¤¾ã‹ã‚‰',0),(485996,13500,'pt','PadrÃ£o da empresa',0),(485997,13500,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¾Ñ‚ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(485998,13500,'es','Predeterminado Desde la Empresa',0),(485999,13500,'de','Standard-Firma',0),(486000,13500,'en','Default From Company',0),(486001,13501,'is','',0),(486002,13501,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ø² Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(486003,13501,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ø² Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(486004,13501,'tr','Stok konumu varsayÄ±lan',0),(486005,13501,'pl','DomyÅ›lnÄ… lokalizacjÄ… zapasÃ³w',0),(486006,13501,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚ Ð¼ÑÑÑ‚Ð¾ Ð·Ð° ÑÐºÐ»Ð°Ð´',0),(486007,13501,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø³Û’ Ø·Û’ Ø´Ø¯Û',0),(486008,13501,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¸Ð· Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(486009,13501,'vi','Máº·c Ä‘á»‹nh tá»« vá»‹ trÃ­ hÃ ng tá»“n kho',0),(486010,13501,'af','Verstek uit voorraad ligging',0),(486011,13501,'ro','LipsÄƒ la inventar locaÅ£ie',0),(486012,13501,'et','Vaikimisi varude asukoha',0),(486013,13501,'si','Privzeti od lokacijo zaloge',0),(486014,13501,'ba','Default dari lokasi persediaan',0),(486015,13501,'nl','Standaard voorraadvestiging',0),(486016,13501,'fi','Oletus varaston sijainti',0),(486017,13501,'no','Standard fra lagerlokasjon',0),(486018,13501,'da','Standard fra lagerlokation',0),(486019,13501,'ko','ìž¬ê³  ìœ„ì¹˜ì—ì„œ ê¸°ë³¸',0),(486020,13501,'he','×‘×¨×™×¨×ª ×ž×—×“×œ ×ž×”×ž×™×§×•× ×ž×œ××™',0),(486021,13501,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î±Ï€ÏŒ Î±Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(486022,13501,'zh','ä»Žåº“å­˜ä½ç½®çš„é»˜è®¤å€¼',0),(486023,13501,'sv','Standard frÃ¥n lagerstÃ¤lle',0),(486024,13501,'it','Predefinito dall\'ubicazione di inventario',0),(486025,13501,'tl','',0),(486026,13501,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ˆà¸²à¸à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(486027,13501,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¥‡',0),(486028,13501,'ms','Lalai dari lokasi inventori',0),(486029,13501,'ar','Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù…Ù† Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(486030,13501,'fr','Par dÃ©faut de l\'emplacement de l\'inventaire',0),(486031,13501,'jp','æ—¢å®šã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®å ´æ‰€ã‹ã‚‰',0),(486032,13501,'pt','PadrÃ£o de estoque local',0),(486033,13501,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¸Ð· ÑÐºÐ»Ð°Ð´Ðµ',0),(486034,13501,'es','Predeterminado Desde ColocaciÃ³n de Inventario',0),(486035,13501,'de','Standard von Lagerort',0),(486036,13501,'en','Default From Inventory Location',0),(486037,13502,'is','',0),(486038,13502,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ù‡ Ø´Ø±Ú©Øª',0),(486039,13502,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ù‡ Ø´Ø±Ú©Øª',0),(486040,13502,'tr','Åžirket iÃ§in varsayÄ±lan',0),(486041,13502,'pl','DomyÅ›lnie do firmy',0),(486042,13502,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð°',0),(486043,13502,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û',0),(486044,13502,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾ Ñ˜Ðµ Ð´Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(486045,13502,'vi','Máº·c Ä‘á»‹nh cho cÃ´ng ty',0),(486046,13502,'af','Verstek maatskappy',0),(486047,13502,'ro','Implicit la compania',0),(486048,13502,'et','Vaikimisi ettevÃµtte',0),(486049,13502,'si','Privzeto za podjetje',0),(486050,13502,'ba','Default ke perusahaan',0),(486051,13502,'nl','Standaard bedrijf',0),(486052,13502,'fi','Oletusarvon mukaan yritys',0),(486053,13502,'no','Selskapet som standard',0),(486054,13502,'da','Virksomhed som standard',0),(486055,13502,'ko','íšŒì‚¬ë¥¼ ê¸°ë³¸ê°’ìœ¼ë¡œ',0),(486056,13502,'he','×‘×¨×™×¨×ª ×ž×—×“×œ ×œ×—×‘×¨×”',0),(486057,13502,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® ÏƒÎµ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(486058,13502,'zh','é»˜è®¤ä¸ºå…¬å¸',0),(486059,13502,'sv','Standard till fÃ¶retag',0),(486060,13502,'it','Per impostazione predefinita azienda',0),(486061,13502,'tl','',0),(486062,13502,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸à¸±à¸šà¸šà¸£à¸´à¸©à¸±à¸—',0),(486063,13502,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(486064,13502,'ms','Lalai kepada Syarikat',0),(486065,13502,'ar','Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù„Ø´Ø±ÙƒØ©',0),(486066,13502,'fr','Par dÃ©faut Ã  l\'entreprise',0),(486067,13502,'jp','æ—¢å®šã®ä¼šç¤¾ã«',0),(486068,13502,'pt','PadrÃ£o para empresa',0),(486069,13502,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(486070,13502,'es','Predeterminado a la Empresa',0),(486071,13502,'de','Standard fÃ¼r Unternehmen',0),(486072,13502,'en','Default To Company',0),(486073,13503,'is','',0),(486074,13503,'dr','Ø¨Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù…Ú©Ø§Ù† Ù¾ÛŒØ´ ÙØ±Ø¶',0),(486075,13503,'pr','Ø¨Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù…Ú©Ø§Ù† Ù¾ÛŒØ´ ÙØ±Ø¶',0),(486076,13503,'tr','Stok konumu varsayÄ±lan olarak',0),(486077,13503,'pl','DomyÅ›lnÄ… lokalizacjÄ… zapasÃ³w',0),(486078,13503,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(486079,13503,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©ÛŒ Ø³ÛÙˆÙ„ÛŒØ§Øª Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û',0),(486080,13503,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(486081,13503,'vi','Máº·c Ä‘á»‹nh vá»‹ trÃ­ hÃ ng tá»“n kho',0),(486082,13503,'af','Verstek om voorraad ligging',0),(486083,13503,'ro','Implicit pentru a locaÅ£ia de inventar',0),(486084,13503,'et','Vaikimisi varude asukoha',0),(486085,13503,'si','Privzeto lokacijo zaloge',0),(486086,13503,'ba','Default ke persediaan lokasi',0),(486087,13503,'nl','Standaard als u wilt inventariseren locatie',0),(486088,13503,'fi','Oletus varaston sijainti',0),(486089,13503,'no','Som standard lager plassering',0),(486090,13503,'da','Standard for at lageret placering',0),(486091,13503,'ko','ìž¬ê³  ìœ„ì¹˜ë¥¼ ê¸°ë³¸ê°’ìœ¼ë¡œ',0),(486092,13503,'he','×‘×¨×™×¨×ª ×ž×—×“×œ ×œ×¢×¨×•×š ×¨×©×™×ž×ª ×ž×œ××™ ×©×œ ×ž×™×§×•×',0),(486093,13503,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î¸Î± Î±Ï€Î¿Î³ÏÎ±Ï†ÎµÎ¯ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(486094,13503,'zh','ç”¨äºŽåº“å­˜ä½ç½®çš„é»˜è®¤',0),(486095,13503,'sv','Standard fÃ¶r att inventera lÃ¤ge',0),(486096,13503,'it','Default per Ubicazione di inventario',0),(486097,13503,'tl','',0),(486098,13503,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(486099,13503,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(486100,13503,'ms','Lalai untuk inventori lokasi',0),(486101,13503,'ar','Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¥Ù„Ù‰ Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ù„Ù„Ù…Ø®Ø²ÙˆÙ†',0),(486102,13503,'fr','Par dÃ©faut pour l\'emplacement des stocks',0),(486103,13503,'jp','æ—¢å®šã®å ´æ‰€ã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã‚’ä½œæˆã™ã‚‹ã«ã¯',0),(486104,13503,'pt','PadrÃ£o para localizaÃ§Ã£o de estoque',0),(486105,13503,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(486106,13503,'es','Predeterminado a ColocaciÃ³n de Inventario',0),(486107,13503,'de','Standard, um die Lage zu inventarisieren',0),(486108,13503,'en','Default To Inventory Location',0),(486109,13504,'is','',0),(486110,13504,'dr','Ø§Ø² Ø¯Ø³ØªØ±Ø³',0),(486111,13504,'pr','Ø§Ø² Ø¯Ø³ØªØ±Ø³',0),(486112,13504,'tr','Available from',0),(486113,13504,'pl','Z dostÄ™pnych',0),(486114,13504,'bg','ÐžÑ‚ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ',0),(486115,13504,'ur','Ø³Û’ Ø¯Ø³ØªÛŒØ§Ø¨',0),(486116,13504,'sr','ÐžÐ´ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸Ñ…',0),(486117,13504,'vi','Tá»« cÃ³ sáºµn',0),(486118,13504,'af','Uit beskikbare',0),(486119,13504,'ro','La disponibil',0),(486120,13504,'et','Saadaolevate',0),(486121,13504,'si','Iz razpoloÅ¾ljivih',0),(486122,13504,'ba','Dari tersedia',0),(486123,13504,'nl','Van beschikbaar',0),(486124,13504,'fi','ErillÃ¤Ã¤n',0),(486125,13504,'no','Fra tilgjengelig',0),(486126,13504,'da','Fra tilgÃ¦ngelige',0),(486127,13504,'ko','ì‚¬ìš© ê°€ëŠ¥ì—ì„œ',0),(486128,13504,'he','×ž×–×ž×™×Ÿ',0),(486129,13504,'el','Î‘Ï€ÏŒ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î¿Î¹',0),(486130,13504,'zh','ä»Žå¯ç”¨',0),(486131,13504,'sv','FrÃ¥n tillgÃ¤ngliga',0),(486132,13504,'it','Da disponibile',0),(486133,13504,'tl','',0),(486134,13504,'th','à¸ˆà¸²à¸à¸§à¹ˆà¸²à¸‡',0),(486135,13504,'hi','à¤¸à¥‡ à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(486136,13504,'ms','Dari disediakan',0),(486137,13504,'ar','Ù…Ù† Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(486138,13504,'fr','De disponible',0),(486139,13504,'jp','åˆ©ç”¨å¯èƒ½ãªã‹ã‚‰',0),(486140,13504,'pt','De disponÃ­vel',0),(486141,13504,'ru','Ð˜Ð· Ð¸Ð¼ÐµÑŽÑ‰Ð¸Ñ…ÑÑ',0),(486142,13504,'es','De Los Disponibles',0),(486143,13504,'de','Von verfÃ¼gbar',0),(486144,13504,'en','From Available',0),(486145,13505,'is','',0),(486146,13505,'dr','Ø§Ø² Ø´Ø±Ú©Øª',0),(486147,13505,'pr','Ø§Ø² Ø´Ø±Ú©Øª',0),(486148,13505,'tr','Åžirketten',0),(486149,13505,'pl','Od firmy',0),(486150,13505,'bg','ÐžÑ‚ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð°',0),(486151,13505,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ø³Û’',0),(486152,13505,'sr','Ð˜Ð· ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(486153,13505,'vi','Tá»« cÃ´ng ty',0),(486154,13505,'af','Van die maatskappy',0),(486155,13505,'ro','La companie',0),(486156,13505,'et','EttevÃµttest',0),(486157,13505,'si','Iz podjetja',0),(486158,13505,'ba','Dari perusahaan',0),(486159,13505,'nl','Van bedrijf',0),(486160,13505,'fi','Yritys',0),(486161,13505,'no','Fra selskap',0),(486162,13505,'da','Fra virksomheden',0),(486163,13505,'ko','íšŒì‚¬ì—ì„œ',0),(486164,13505,'he','×ž×—×‘×¨×ª',0),(486165,13505,'el','Î‘Ï€ÏŒ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(486166,13505,'zh','ä»Žå…¬å¸',0),(486167,13505,'sv','FrÃ¥n fÃ¶retag',0),(486168,13505,'it','Da azienda',0),(486169,13505,'tl','',0),(486170,13505,'th','à¸ˆà¸²à¸à¸šà¸£à¸´à¸©à¸±à¸—',0),(486171,13505,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥‡',0),(486172,13505,'ms','Dari Syarikat',0),(486173,13505,'ar','Ù…Ù† Ø§Ù„Ø´Ø±ÙƒØ©',0),(486174,13505,'fr','De la sociÃ©tÃ©',0),(486175,13505,'jp','ä¼šç¤¾ã‹ã‚‰',0),(486176,13505,'pt','Da companhia',0),(486177,13505,'ru','ÐžÑ‚ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(486178,13505,'es','Desde La Empresa',0),(486179,13505,'de','Von Firma',0),(486180,13505,'en','From Company',0),(486181,13506,'is','',0),(486182,13506,'dr','Ø§Ø² Ø·Ø±Ù',0),(486183,13506,'pr','Ø§Ø² Ø·Ø±Ù',0),(486184,13506,'tr','Ãœzerinden elde',0),(486185,13506,'pl','Od strony',0),(486186,13506,'bg','ÐžÑ‚ Ð½Ð° Ñ€ÑŠÐºÐ°',0),(486187,13506,'ur','Ø³Û’ ÛØ§ØªÚ¾ Ù¾Ø±',0),(486188,13506,'sr','ÐžÐ´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(486189,13506,'vi','Tá»« máº·t',0),(486190,13506,'af','Uit op Hand',0),(486191,13506,'ro','De pe mana',0),(486192,13506,'et','Alates kÃ¤si',0),(486193,13506,'si','Iz strani',0),(486194,13506,'ba','Dari sisi',0),(486195,13506,'nl','Van aan de kant',0),(486196,13506,'fi','Alkaen kÃ¤sillÃ¤',0),(486197,13506,'no','Fra beholdningen',0),(486198,13506,'da','Fra pÃ¥ hÃ¥nd',0),(486199,13506,'ko','ì†ìœ¼ë¡œ',0),(486200,13506,'he','×ž ×ž×¦×“',0),(486201,13506,'el','Î‘Ï€ÏŒ Î±Ï†',0),(486202,13506,'zh','ä»Žæ‰‹ä¸Š',0),(486203,13506,'sv','FrÃ¥n Ã¥',0),(486204,13506,'it','Dal lato',0),(486205,13506,'tl','',0),(486206,13506,'th','à¸ˆà¸²à¸à¸šà¸™à¸¡à¸·à¸­',0),(486207,13506,'hi','à¤¸à¥‡ à¤¹à¤¾à¤¥ à¤ªà¤°',0),(486208,13506,'ms','Dari segi',0),(486209,13506,'ar','Ù…Ù† Ù†Ø§Ø­ÙŠØ©',0),(486210,13506,'fr','De part',0),(486211,13506,'jp','æ‰‹ã«',0),(486212,13506,'pt','De mÃ£o',0),(486213,13506,'ru','ÐžÑ‚ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(486214,13506,'es','De Disponible',0),(486215,13506,'de','Von Hand',0),(486216,13506,'en','From On Hand',0),(486217,13507,'is','',0),(486218,13507,'dr','Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ù…ÙˆØ±Ø¯ intercompany',0),(486219,13507,'pr','Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ù…ÙˆØ±Ø¯ intercompany',0),(486220,13507,'tr','ÅžirketlerarasÄ± madde',0),(486221,13507,'pl','PrzesuniÄ™cia zapasÃ³w miÄ™dzyfirmowych',0),(486222,13507,'bg','ÐœÐµÐ¶Ð´ÑƒÑ„Ð¸Ñ€Ð¼ÐµÐ½Ð¸Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(486223,13507,'ur','Ø§Ù†Ù¹Ø±Ú©ÙˆÙ…Ù¾Ù†ÛŒ Ø´Û’ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(486224,13507,'sr','ÐœÐµÑ’ÑƒÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜ÑÐºÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(486225,13507,'vi','Intercompany má»¥c chuyá»ƒn',0),(486226,13507,'af','Intercompany Item Oordragte',0),(486227,13507,'ro','Transferurile de articol inter-companii',0),(486228,13507,'et','Kontsernisisese kauba Ã¼leandmise',0),(486229,13507,'si','Prenosov artiklov znotraj podjetja',0),(486230,13507,'ba','Transfer antar Item',0),(486231,13507,'nl','IC-artikeltransfers',0),(486232,13507,'fi','Konsernin sisÃ¤isen nimikkeen siirrot',0),(486233,13507,'no','Konsernintern vare overfÃ¸ringer',0),(486234,13507,'da','IC vare overfÃ¸rsler',0),(486235,13507,'ko','íšŒì‚¬ ê°„ í•­ëª© ì´ë™',0),(486236,13507,'he','×”×¢×‘×¨×•×ª ×¤×¨×™×˜ ×‘×™×Ÿ-×—×‘×¨×ª×™×•×ª',0),(486237,13507,'el','Î”Î¹ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ­Ï‚ Î´Î¹Î±ÎºÎ¹Î½Î®ÏƒÎµÎ¹Ï‚ ÎµÎ¹Î´ÏŽÎ½',0),(486238,13507,'zh','å†…éƒ¨å…¬å¸ç‰©æ–™è½¬ç§»',0),(486239,13507,'sv','Koncerninterna artikelÃ¶verfÃ¶ringar',0),(486240,13507,'it','Trasferimenti di articoli interaziendale',0),(486241,13507,'tl','',0),(486242,13507,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸šà¸£à¸´à¸©à¸±à¸—',0),(486243,13507,'hi','Intercompany à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤¨à¥à¤¤à¤°à¤£',0),(486244,13507,'ms','Item antara Syarikat pemindahan',0),(486245,13507,'ar','Ù†Ù‚Ù„ Ø§Ù„Ø¹Ù†ØµØ± Ø¨ÙŠÙ† Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø´Ù‚ÙŠÙ‚Ø©',0),(486246,13507,'fr','Transferts intersociÃ©tÃ©s point',0),(486247,13507,'jp','ä¼šç¤¾é–“å“ç›®ã®è»¢é€',0),(486248,13507,'pt','Item intercompanhia transferÃªncias',0),(486249,13507,'ru','Ð’Ð½ÑƒÑ‚Ñ€Ð¸Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð½Ñ‹Ñ… Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ð¾Ð² Ð¿ÑƒÐ½ÐºÑ‚',0),(486250,13507,'es','Transferencia Interempresa de Items',0),(486251,13507,'de','Konzerninterne Element Transfers',0),(486252,13507,'en','Intercompany Item Transfers',0),(486253,13508,'is','',0),(486254,13508,'dr','Ù…ÙˆØ±Ø¯ Ø¯Ø± Ø§ÛŒÙ† Ù…Ú©Ø§Ù† ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(486255,13508,'pr','Ù…ÙˆØ±Ø¯ Ø¯Ø± Ø§ÛŒÙ† Ù…Ú©Ø§Ù† ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(486256,13508,'tr','Bu konumda Ã¶ÄŸe yok',0),(486257,13508,'pl','Element nie istnieje w tej lokalizacji',0),(486258,13508,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð° Ð½Ð° Ñ‚Ð¾Ð²Ð° Ð¼ÑÑÑ‚Ð¾',0),(486259,13508,'ur','Ø´Û’ Ø§Ø³ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø± Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(486260,13508,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð½Ð° Ð¾Ð²Ð¾Ñ˜ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸',0),(486261,13508,'vi','Má»¥c khÃ´ng tá»“n táº¡i á»Ÿ vá»‹ trÃ­ nÃ y',0),(486262,13508,'af','Item bestaan nie in hierdie ligging',0),(486263,13508,'ro','Elementul nu existÄƒ la aceastÄƒ locaÅ£ie',0),(486264,13508,'et','Ãœksust pole selles asukohas',0),(486265,13508,'si','Element ne obstaja na tem mestu',0),(486266,13508,'ba','Item tidak ada di lokasi ini',0),(486267,13508,'nl','Object bestaat niet op deze locatie',0),(486268,13508,'fi','Kohdetta ei ole tÃ¤ssÃ¤ sijainnissa',0),(486269,13508,'no','Elementet finnes ikke pÃ¥ denne plasseringen',0),(486270,13508,'da','Elementet findes ikke pÃ¥ denne placering',0),(486271,13508,'ko','ì´ ìœ„ì¹˜ì— í•­ëª©ì´ ì¡´ìž¬ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(486272,13508,'he','×”×¤×¨×™×˜ ××™× ×• ×§×™×™× ×‘×ž×™×§×•× ×–×”',0),(486273,13508,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· Î¸Î­ÏƒÎ·',0),(486274,13508,'zh','é¡¹ç›®åœ¨æ­¤ä½ç½®ä¸å­˜åœ¨',0),(486275,13508,'sv','Objektet finns inte pÃ¥ den hÃ¤r platsen',0),(486276,13508,'it','Elemento non esiste in questa posizione',0),(486277,13508,'tl','',0),(486278,13508,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸²à¸¢à¸à¸²à¸£à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸™à¸µà¹‰',0),(486279,13508,'hi','à¤†à¤‡à¤Ÿà¤® à¤‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤° à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(486280,13508,'ms','Item tidak wujud di lokasi ini',0),(486281,13508,'ar','Ø§Ù„Ø¹Ù†ØµØ± ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(486282,13508,'fr','Ã‰lÃ©ment n\'existe pas Ã  cet endroit',0),(486283,13508,'jp','é …ç›®ãŒã“ã®å ´æ‰€ã«å­˜åœ¨ã—ã¾ã›ã‚“ã€‚',0),(486284,13508,'pt','Item nÃ£o existir neste local',0),(486285,13508,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð² ÑÑ‚Ð¾Ð¼ Ð¼ÐµÑÑ‚Ðµ',0),(486286,13508,'es','Item no Existe en Esta ColocaciÃ³n',0),(486287,13508,'de','Element ist nicht an diesem Speicherort vorhanden.',0),(486288,13508,'en','Item Does Not Exist At This Location',0),(486289,13509,'is','',0),(486290,13509,'dr','Ù…ÙˆØ±Ø¯ Ø¯Ø± Ø§ÛŒÙ† Ù…Ú©Ø§Ù†',0),(486291,13509,'pr','Ù…ÙˆØ±Ø¯ Ø¯Ø± Ø§ÛŒÙ† Ù…Ú©Ø§Ù†',0),(486292,13509,'tr','Ã–ÄŸesi bu konumda deÄŸil',0),(486293,13509,'pl','Element nie w tym miejscu',0),(486294,13509,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ð½Ðµ Ð½Ð° Ñ‚Ð¾Ð²Ð° Ð¼ÑÑÑ‚Ð¾',0),(486295,13509,'ur','Ø§Ø³ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø± Ù†Û Ø´Û’',0),(486296,13509,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð½Ð° Ð¾Ð²Ð¾Ñ˜ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸',0),(486297,13509,'vi','Má»¥c khÃ´ng á»Ÿ vá»‹ trÃ­ nÃ y',0),(486298,13509,'af','Item nie by hierdie posisie',0),(486299,13509,'ro','Elementul nu la aceastÄƒ locaÅ£ie',0),(486300,13509,'et','Ãœksust pole selles asukohas',0),(486301,13509,'si','Element ni na tej lokaciji',0),(486302,13509,'ba','Item tidak di lokasi ini',0),(486303,13509,'nl','Item niet op deze locatie',0),(486304,13509,'fi','Kohteen tÃ¤ssÃ¤ sijainnissa',0),(486305,13509,'no','Varer ikke pÃ¥ denne plasseringen',0),(486306,13509,'da','Varen ikke pÃ¥ denne placering',0),(486307,13509,'ko','ì´ ìœ„ì¹˜ì— í•­ëª©',0),(486308,13509,'he','×”×¤×¨×™×˜ ×œ× ×‘×ž×™×§×•× ×–×”',0),(486309,13509,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î´ÎµÎ½ ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· Î¸Î­ÏƒÎ·',0),(486310,13509,'zh','é¡¹ç›®ä¸åœ¨æ­¤ä½ç½®',0),(486311,13509,'sv','Objektet inte pÃ¥ den hÃ¤r platsen',0),(486312,13509,'it','Elemento non in questa posizione',0),(486313,13509,'tl','',0),(486314,13509,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¹„à¸¡à¹ˆà¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸™à¸µà¹‰',0),(486315,13509,'hi','à¤‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤° à¤¨à¤¹à¥€à¤‚ à¤†à¤‡à¤Ÿà¤®',0),(486316,13509,'ms','Perkara tidak di lokasi ini',0),(486317,13509,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ù„Ø§ ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(486318,13509,'fr','Question pas Ã  cet endroit',0),(486319,13509,'jp','ã“ã®å ´æ‰€ã§ã¯ãªã„é …ç›®',0),(486320,13509,'pt','Item nÃ£o neste local',0),(486321,13509,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð½Ðµ Ð² ÑÑ‚Ð¾Ð¼ Ð¼ÐµÑÑ‚Ðµ',0),(486322,13509,'es','Item no EstÃ¡ en Esta ColocaciÃ³n',0),(486323,13509,'de','Element nicht an dieser Stelle',0),(486324,13509,'en','Item Not At This Location',0),(486325,13510,'is','',0),(486326,13510,'dr','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ø§Ø±Ø³Ø§Ù„',0),(486327,13510,'pr','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ø§Ø±Ø³Ø§Ù„',0),(486328,13510,'tr','Son mesaj tarihi',0),(486329,13510,'pl','Ostatni Post Data',0),(486330,13510,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð¼Ð½ÐµÐ½Ð¸Ðµ Ð´Ð°Ñ‚Ð°',0),(486331,13510,'ur','Ø¢Ø®Ø±ÛŒ Ù¾ÙˆØ³Ù¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(486332,13510,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµÐ³ Ð¿Ð¾ÑÑ‚Ð°',0),(486333,13510,'vi','Cuá»‘i ngÃ y Ä‘Äƒng',0),(486334,13510,'af','Laaste pos datum',0),(486335,13510,'ro','Ultima data de Post',0),(486336,13510,'et','Viimane postitus kuupÃ¤ev',0),(486337,13510,'si','Datum zadnjega Post',0),(486338,13510,'ba','Tanggal posting terakhir',0),(486339,13510,'nl','Datum laatste Post',0),(486340,13510,'fi','Viimeisin viesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(486341,13510,'no','Dato for siste innlegg',0),(486342,13510,'da','Sidste indlÃ¦g dato',0),(486343,13510,'ko','ë§ˆì§€ë§‰ ê²Œì‹œë¬¼ ë‚ ì§œ',0),(486344,13510,'he','×ª××¨×™×š ×”×”×•×“×¢×” ×”××—×¨×•× ×”',0),(486345,13510,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î”Î·Î¼Î¿ÏƒÎ¯ÎµÏ…ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(486346,13510,'zh','æœ€åŽå‘å¸ƒæ—¥æœŸ',0),(486347,13510,'sv','Sista datum',0),(486348,13510,'it','Ultima data del Post',0),(486349,13510,'tl','',0),(486350,13510,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(486351,13510,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(486352,13510,'ms','Tarikh Post',0),(486353,13510,'ar','Ø¢Ø®Ø± Ù…Ø´Ø§Ø±ÙƒØ© Ø¨ØªØ§Ø±ÙŠØ®',0),(486354,13510,'fr','Dernier Post Date',0),(486355,13510,'jp','æœ€å¾Œã®æŠ•ç¨¿æ—¥æ™‚',0),(486356,13510,'pt','Data Ãºltimo Post',0),(486357,13510,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(486358,13510,'es','Fecha de Ultimo Posteo',0),(486359,13510,'de','Datum Letzter Beitrag',0),(486360,13510,'en','Last Post Date',0),(486361,13511,'is','',0),(486362,13511,'dr','Ø®Ø·ÙˆØ· Ø§Ù†ØªÙ‚Ø§Ù„',0),(486363,13511,'pr','Ø®Ø·ÙˆØ· Ø§Ù†ØªÙ‚Ø§Ù„',0),(486364,13511,'tr','Transfer satÄ±rlarÄ±',0),(486365,13511,'pl','Linie przekazane',0),(486366,13511,'bg','Ð›Ð¸Ð½Ð¸Ð¸ Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÐµÐ½Ð¸',0),(486367,13511,'ur','Ù„Ø§Ø¦Ù†ÛŒÚº Ù…Ù†ØªÙ‚Ù„ Ú©Ø± Ø¯ÛŒØ§',0),(486368,13511,'sr','Ð ÐµÐ´Ð¾Ð²Ð¸ Ð¿Ñ€ÐµÐ±Ð°Ñ‡ÐµÐ½',0),(486369,13511,'vi','DÃ²ng chuyá»ƒn',0),(486370,13511,'af','Lyne oorgedra',0),(486371,13511,'ro','Liniile transferate',0),(486372,13511,'et','Read Ã¼le',0),(486373,13511,'si','Vrstice, prenese',0),(486374,13511,'ba','Garis-garis yang ditransfer',0),(486375,13511,'nl','Lijnen overgedragen',0),(486376,13511,'fi','Rivit siirretÃ¤Ã¤n',0),(486377,13511,'no','Linjene overfÃ¸rt',0),(486378,13511,'da','Linjerne overfÃ¸res',0),(486379,13511,'ko','ì „ì†¡ ë¼ì¸',0),(486380,13511,'he','×©×•×¨×•×ª ×©×”×•×¢×‘×¨×•',0),(486381,13511,'el','Î“ÏÎ±Î¼Î¼Î­Ï‚ Ï€Î¿Ï… Î¼ÎµÏ„Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹',0),(486382,13511,'zh','è¡Œè½¬ç§»',0),(486383,13511,'sv','Linjer som Ã¶verfÃ¶rs',0),(486384,13511,'it','Linee trasferiti',0),(486385,13511,'tl','',0),(486386,13511,'th','à¸šà¸£à¸£à¸—à¸±à¸”à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(486387,13511,'hi','à¤¤à¤¬à¤¾à¤¦à¤²à¤¾ à¤²à¤¾à¤‡à¤¨à¥‹à¤‚',0),(486388,13511,'ms','Garis-garis yang dipindahkan',0),(486389,13511,'ar','Ø®Ø·ÙˆØ· Ù†Ù‚Ù„',0),(486390,13511,'fr','Lignes transfÃ©rÃ©es',0),(486391,13511,'jp','è»¢é€ç·š',0),(486392,13511,'pt','Linhas transferidas',0),(486393,13511,'ru','Ð›Ð¸Ð½Ð¸Ð¸ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(486394,13511,'es','Lineas Transferidas',0),(486395,13511,'de','Linien Ã¼bertragen',0),(486396,13511,'en','Lines Transferred',0),(486397,13512,'is','',0),(486398,13512,'dr','Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ø¨Ø¯ÙˆÙ† Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(486399,13512,'pr','Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ø¨Ø¯ÙˆÙ† Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(486400,13512,'tr','HiÃ§bir transfer oluÅŸturduk',0),(486401,13512,'pl','ZostaÅ‚y utworzone Å¼adne transfery',0),(486402,13512,'bg','ÐÑÐ¼Ð° Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸ ÑÐ° Ð±Ð¸Ð»Ð¸ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð¸',0),(486403,13512,'ur','Ú©ÙˆØ¦ÛŒ Ù¹Ø±Ø§Ù†Ø³ÙØ± Ú©Ø¦Û’ Ú¯Ø¦Û’ ÛÛŒÚº',0),(486404,13512,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€ÐµÐ½Ð¾ÑÐ° ÑÑƒ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð¸.',0),(486405,13512,'vi','KhÃ´ng cÃ³ dá»‹ch vá»¥ Ä‘Æ°a Ä‘Ã³n Ä‘Ã£ Ä‘Æ°á»£c táº¡o ra',0),(486406,13512,'af','Geen oordragte geskep',0),(486407,13512,'ro','Nici transferurile au fost create',0),(486408,13512,'et','Ãœlekandeid pole loodud',0),(486409,13512,'si','Å t prenosi so bile ustvarjene',0),(486410,13512,'ba','Transfer tidak telah diciptakan',0),(486411,13512,'nl','Geen Transfers zijn gemaakt',0),(486412,13512,'fi','Siirtoja ei ole luotu',0),(486413,13512,'no','Ingen overfÃ¸ringer er opprettet',0),(486414,13512,'da','Ingen overfÃ¸rsler er blevet oprettet',0),(486415,13512,'ko','ì•„ë¬´ ì „ì†¡ ë§Œë“¤ì—ˆìŠµë‹ˆë‹¤.',0),(486416,13512,'he','×”×¢×‘×¨×•×ª ×œ× × ×•×¦×¨×•',0),(486417,13512,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ­Ï‚ Î´ÎµÎ½ Î­Ï‡Î¿Ï…Î½ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸ÎµÎ¯',0),(486418,13512,'zh','æ²¡æœ‰è½¬è®©å·²åˆ›å»º',0),(486419,13512,'sv','Inga Ã¶verfÃ¶ringar har skapats',0),(486420,13512,'it','Non sono stati creati trasferimenti',0),(486421,13512,'tl','',0),(486422,13512,'th','à¹‚à¸­à¸™à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(486423,13512,'hi','à¤•à¥‹à¤ˆ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¬à¤¨à¤¾ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(486424,13512,'ms','Tiada pemindahan telah diwujudkan',0),(486425,13512,'ar','ÙˆÙ‚Ø¯ Ø£Ù†Ø´Ø¦Øª Ù„Ø§ ØªØ­ÙˆÙŠÙ„Ø§Øª',0),(486426,13512,'fr','Aucuns transferts n\'ont Ã©tÃ© crÃ©Ã©s',0),(486427,13512,'jp','è»¢é€ã¯ä½œæˆã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(486428,13512,'pt','Sem transferÃªncias foram criadas',0),(486429,13512,'ru','ÐÐ¸ÐºÐ°ÐºÐ¾Ð¹ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸ Ð±Ñ‹Ð»Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ñ‹',0),(486430,13512,'es','No las transferencias se han creado',0),(486431,13512,'de','Keine Ãœbertragungen wurden erstellt',0),(486432,13512,'en','No Transfers Have Been Created',0),(486433,13513,'is','',0),(486434,13513,'dr','Ù…Ø·Ù…Ø¦Ù† Ø¨Ø§Ø´ÛŒØ¯ Ú©Ù‡ Ù‡Ù…Ù‡ Ø´Ø±Ú©Øª Ù‡Ø§ Ú†ÛŒØ²ÛŒ Ø¨Ø±Ø§ÛŒ Ø­Ø³Ø§Ø¨ Ø²ÛŒØ± Ø¯Ø± ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¹Ù…ÙˆÙ…ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙˆØ§Ø±Ø¯ Ø´ÙˆÛŒØ¯.',0),(486435,13513,'pr','Ù…Ø·Ù…Ø¦Ù† Ø¨Ø§Ø´ÛŒØ¯ Ú©Ù‡ Ù‡Ù…Ù‡ Ø´Ø±Ú©Øª Ù‡Ø§ Ú†ÛŒØ²ÛŒ Ø¨Ø±Ø§ÛŒ Ø­Ø³Ø§Ø¨ Ø²ÛŒØ± Ø¯Ø± ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¹Ù…ÙˆÙ…ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙˆØ§Ø±Ø¯ Ø´ÙˆÛŒØ¯.',0),(486436,13513,'tr','LÃ¼tfen tÃ¼m ÅŸirketleri envanter Genel Kurulum aÅŸaÄŸÄ±daki hesap iÃ§in girilen bir ÅŸey olduÄŸundan emin olun.',0),(486437,13513,'pl','Upewnij siÄ™, Å¼e wszystkie przedsiÄ™biorstwa majÄ… coÅ› wszedÅ‚ na konto w magazynie General Setup.',0),(486438,13513,'bg','ÐœÐ¾Ð»Ñ, ÑƒÐ²ÐµÑ€ÐµÑ‚Ðµ ÑÐµ, Ñ‡Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ñ€ÑƒÐ¶ÐµÑÑ‚Ð²Ð° Ð¸Ð¼Ð°Ñ‚ Ð½ÐµÑ‰Ð¾ Ð·Ð° ÑÐ»ÐµÐ´Ð½Ð°Ñ‚Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð² ÑÐºÐ»Ð°Ð´Ð° ÐžÐ±Ñ‰Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°.',0),(486439,13513,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û ØªÙ…Ø§Ù… Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ú©Û’ Ù¾Ø§Ø³ Ú©Ú†Ú¾ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¬Ù†Ø±Ù„ Ø³ÛŒÙ¹ Ø§Ù¾ Ù…ÛŒÚº Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø§Ø®Ù„ Ú©ÛŒØ§ ÛÛ’ Û”',0),(486440,13513,'sr','ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð° Ð»Ð¸ ÑÐ²Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸Ð¼Ð°Ñ˜Ñƒ Ð½ÐµÑˆÑ‚Ð¾ Ð·Ð° ÑÐ»ÐµÐ´ÐµÑ›Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð° ÐžÐ¿ÑˆÑ‚Ðµ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÑƒÐ½ÐµÑÐµ.',0),(486441,13513,'vi','HÃ£y cháº¯c cháº¯n ráº±ng táº¥t cáº£ cÃ¡c cÃ´ng ty cÃ³ má»™t cÃ¡i gÃ¬ Ä‘Ã³ Ä‘Ã£ nháº­p cho tÃ i khoáº£n sau Ä‘Ã¢y trong thiáº¿t láº­p tá»•ng há»£p hÃ ng tá»“n kho.',0),(486442,13513,'af','Maak asseblief seker dat alle maatskappye iets ingeskryf vir die volgende rekening in voorraad algemene opstelling.',0),(486443,13513,'ro','AsiguraÈ›i-vÄƒ cÄƒ toate companiile au ceva introdus pentru urmÄƒtorul cont Ã®n Parametrizare stocuri.',0),(486444,13513,'et','Palun veenduge, et kÃµik ettevÃµtted on midagi sisestanud jÃ¤rgmise konto varude Ã¼ldine seadistus.',0),(486445,13513,'si','Poskrbite, da vse druÅ¾be imajo nekaj, vnese naslednje raÄuna v nastavitev zaloge sploÅ¡nega.',0),(486446,13513,'ba','Pastikan semua perusahaan memiliki sesuatu yang masuk untuk account berikut di tetapan umum persediaan.',0),(486447,13513,'nl','Zorg ervoor dat alle bedrijven hebt iets ingevoerd voor het volgend rekeningnummer in voorraad General Setup.',0),(486448,13513,'fi','Varmista, ettÃ¤ kaikki yritykset ovat jotain tuli varaston asennuksen seuraavaa tiliÃ¤.',0),(486449,13513,'no','Kontroller at alle selskaper har noe angitt for fÃ¸lgende konto i lageret generelt oppsett.',0),(486450,13513,'da','Kontroller, at alle virksomheder har noget indtastet for fÃ¸lgende konto i lageret BogfÃ¸ringsopsÃ¦tning.',0),(486451,13513,'ko','ëª¨ë“  íšŒì‚¬ëŠ” ìž¬ê³  ì¼ë°˜ ì„¤ì •ì—ì„œ ë‹¤ìŒê³¼ ê°™ì€ ê³„ì •ì— ëŒ€í•´ ìž…ë ¥ í•œ ë¬´ì–¸ê°€ ë‹¤ëŠ” ê²ƒì„ í™•ì¸ í•˜ì‹­ì‹œì˜¤.',0),(486452,13513,'he','× × ×•×“× ×›×™ ×›×œ ×”×—×‘×¨×•×ª ×™×© ×ž×©×”×• ×©×”×•×–×Ÿ ×¢×‘×•×¨ ×”×—×©×‘×•×Ÿ ×©×œ ×”×‘××™× ×‘×”×’×“×¨×ª ×›×œ×œ×™ ×ž×œ××™.',0),(486453,13513,'el','Î’ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ ÏŒÎ»ÎµÏ‚ Î¿Î¹ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Î­Ï‡Î¿Ï…Î½ ÎºÎ¬Ï„Î¹ Ï„Î¿ Ï„ÎµÎ»Ï‰Î½ÎµÎ¯Î¿ Ï…Ï€Î±Î³Ï‰Î³Î®Ï‚ ÏƒÏ„Î¿Î½ Î±ÎºÏŒÎ»Î¿Ï…Î¸Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÏ„Î·Î½ Ï€Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚.',0),(486454,13513,'zh','è¯·ç¡®ä¿æ‰€æœ‰çš„å…¬å¸éƒ½ä¸ºåº“å­˜ä¸€èˆ¬è®¾ç½®ä¸­çš„ä»¥ä¸‹å¸æˆ·è¾“å…¥çš„ä¸œè¥¿ã€‚',0),(486455,13513,'sv','Se till att alla fÃ¶retag har nÃ¥got anges fÃ¶r fÃ¶ljande konto i lager allmÃ¤n instÃ¤llning.',0),(486456,13513,'it','Assicurarsi che tutte le aziende hanno qualcosa entrato per conto riportato nell\'inventario generale Setup.',0),(486457,13513,'tl','',0),(486458,13513,'th','à¸à¸£à¸¸à¸“à¸²à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸§à¹ˆà¸² à¸—à¸¸à¸à¸šà¸£à¸´à¸©à¸±à¸—à¸¡à¸µà¸šà¸²à¸‡à¸ªà¸´à¹ˆà¸‡à¸—à¸µà¹ˆà¸›à¹‰à¸­à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸±à¸à¸Šà¸µà¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¹ƒà¸™à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸—à¸±à¹ˆà¸§à¹„à¸›à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸',0),(486459,13513,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤¸à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤› à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤œà¤¨à¤°à¤² à¤¸à¥‡à¤Ÿà¤…à¤ª à¤®à¥‡à¤‚ à¤¨à¤¿à¤®à¥à¤¨ à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤µà¥‡à',0),(486460,13513,'ms','Sila pastikan semua syarikat mempunyai sesuatu dimasukkan untuk akaun berikut dalam persediaan umum inventori.',0),(486461,13513,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù† Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´Ø±ÙƒØ§Øª Ù„Ø¯ÙŠÙ‡Ø§ Ø´ÙŠØ¡ Ø¯Ø®Ù„Øª Ù„Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„ØªØ§Ù„ÙŠ ÙÙŠ Ø¥Ø¹Ø¯Ø§Ø¯ Ù‚ÙˆØ§Ø¦Ù… Ø§Ù„Ø¬Ø±Ø¯ Ø§Ù„Ø¹Ø§Ù….',0),(486462,13513,'fr','S\'il vous plaÃ®t assurez-vous que toutes les entreprises ont quelque chose est entrÃ© pour le compte suivant dans le programme d\'installation de l\'inventaire gÃ©nÃ©ral.',0),(486463,13513,'jp','ã™ã¹ã¦ã®ä¼æ¥­ã¯åœ¨åº«ä¸€èˆ¬çš„ãªã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã§æ¬¡ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®å…¥åŠ›ã•ã‚ŒãŸã‚‚ã®ãŒã‚ã‚‹ã‹ã©ã†ã‹ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(486464,13513,'pt','Por favor, certifique-se de que todas as empresas tÃªm algo entrou para a seguinte conta na configuraÃ§Ã£o do inventÃ¡rio geral.',0),(486465,13513,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐ±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾ Ð²ÑÐµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð¼ÐµÑŽÑ‚ Ñ‡Ñ‚Ð¾-Ñ‚Ð¾ Ð´Ð»Ñ Ð½Ð° ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ ÑÑ‡ÐµÑ‚ Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ ÐžÐ±Ñ‰Ð°Ñ ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»Ð°.',0),(486466,13513,'es','Por Favor asegura que todas las empresas tienen algo entrado para el siguente cuenta en la configuraciÃ³n del Inventario General',0),(486467,13513,'de','Bitte stellen Sie sicher, dass alle Unternehmen, die etwas fÃ¼r das folgende Konto im Inventar General Setup eingegeben haben.',0),(486468,13513,'en','Please make sure all companies have something entered for the following account in Inventory General Setup.',0),(486469,13514,'is','',0),(486470,13514,'dr','Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ù‚Ø¨Ù„ÛŒ',0),(486471,13514,'pr','Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ù‚Ø¨Ù„ÛŒ',0),(486472,13514,'tr','Ã–nceki transferleri',0),(486473,13514,'pl','Transfery przed',0),(486474,13514,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(486475,13514,'ur','Ù¾ÛŒØ´Ú¯ÛŒ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(486476,13514,'sr','Ð˜Ð³ÑƒÐ¼Ð°Ð½ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(486477,13514,'vi','TrÆ°á»›c khi chuyá»ƒn',0),(486478,13514,'af','Vooraf Oordragte',0),(486479,13514,'ro','Transferuri prealabilÄƒ',0),(486480,13514,'et','Eelneva Ã¼lekanded',0),(486481,13514,'si','Predhodno prenosi',0),(486482,13514,'ba','Sebelum transfer',0),(486483,13514,'nl','Voorafgaande Transfers',0),(486484,13514,'fi','Ennen siirtoa',0),(486485,13514,'no','Tidligere overfÃ¸ringer',0),(486486,13514,'da','ForudgÃ¥ende overfÃ¸rsler',0),(486487,13514,'ko','ì´ì „ ì „ì†¡',0),(486488,13514,'he','×”×¢×‘×¨×•×ª ×ž×•×§×“×ž×ª',0),(486489,13514,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î· Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Ï‚',0),(486490,13514,'zh','åœ¨å…ˆçš„è½¬è®©',0),(486491,13514,'sv','Tidigare Ã¶verfÃ¶ringar',0),(486492,13514,'it','Trasferimenti precedenti',0),(486493,13514,'tl','',0),(486494,13514,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(486495,13514,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤¨à¥à¤¤à¤°à¤£',0),(486496,13514,'ms','Pemindahan terlebih dahulu',0),(486497,13514,'ar','Ø§Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(486498,13514,'fr','Transferts prÃ©alables',0),(486499,13514,'jp','äº‹å‰è»¢é€',0),(486500,13514,'pt','TransferÃªncias anteriores',0),(486501,13514,'ru','ÐŸÑ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ñ‹',0),(486502,13514,'es','Transferencias Anteriores',0),(486503,13514,'de','Vorherige Transfers',0),(486504,13514,'en','Prior Transfers',0),(486505,13515,'is','',0),(486506,13515,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(486507,13515,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(486508,13515,'tr','Transfer seÃ§in',0),(486509,13515,'pl','Wybierz Transfer',0),(486510,13515,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ \"Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€\"',0),(486511,13515,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(486512,13515,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(486513,13515,'vi','Chá»n chuyá»ƒn',0),(486514,13515,'af','Kies oordrag',0),(486515,13515,'ro','SelectaÅ£i Transfer',0),(486516,13515,'et','Valige Ã¼lekanne',0),(486517,13515,'si','Izberite prenos',0),(486518,13515,'ba','Pilih Transfer',0),(486519,13515,'nl','Selecteer Transfer',0),(486520,13515,'fi','Valitse siirto',0),(486521,13515,'no','Velg overfÃ¸ring',0),(486522,13515,'da','VÃ¦lg overfÃ¸rsel',0),(486523,13515,'ko','ì „ì†¡ ì„ íƒ',0),(486524,13515,'he','×‘×—×¨ ×”×¢×‘×¨×”',0),(486525,13515,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎœÏ„Ï†',0),(486526,13515,'zh','é€‰æ‹©è½¬ç§»',0),(486527,13515,'sv','VÃ¤lj Ã¶verfÃ¶r',0),(486528,13515,'it','Selezionare trasferimento',0),(486529,13515,'tl','',0),(486530,13515,'th','à¹€à¸¥à¸·à¸­à¸à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(486531,13515,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(486532,13515,'ms','Pilih pemindahan',0),(486533,13515,'ar','Ø­Ø¯Ø¯ Ù†Ù‚Ù„',0),(486534,13515,'fr','SÃ©lectionnez transfert',0),(486535,13515,'jp','è»¢é€ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(486536,13515,'pt','Selecione transferÃªncia',0),(486537,13515,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð°',0),(486538,13515,'es','Selecciona La Transferencia',0),(486539,13515,'de','WÃ¤hlen Sie Ã¼bernehmen',0),(486540,13515,'en','Select Transfer',0),(486541,13516,'is','',0),(486542,13516,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ù„ÛŒØ³Øª',0),(486543,13516,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ù„ÛŒØ³Øª',0),(486544,13516,'tr','Transfer listesi',0),(486545,13516,'pl','ListÄ™ transferowÄ…',0),(486546,13516,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(486547,13516,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(486548,13516,'sr','Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€ Ð»Ð¸ÑÑ‚Ñƒ',0),(486549,13516,'vi','Danh sÃ¡ch chuyá»ƒn nhÆ°á»£ng',0),(486550,13516,'af','Oordrag lys',0),(486551,13516,'ro','Lista de transfer',0),(486552,13516,'et','Ãœleandmise nimekirja',0),(486553,13516,'si','Prenos seznama',0),(486554,13516,'ba','Daftar transfer',0),(486555,13516,'nl','Transferlijst',0),(486556,13516,'fi','Siirtolistalle',0),(486557,13516,'no','OverfÃ¸ringslisten',0),(486558,13516,'da','OverfÃ¸rselslisten',0),(486559,13516,'ko','ì „ì†¡ ëª©ë¡',0),(486560,13516,'he','×¨×©×™×ž×ª ×”×¢×‘×¨×”',0),(486561,13516,'el','ÎœÎµÏ„Î±Î³ÏÎ±Ï†Î¹ÎºÏŒ',0),(486562,13516,'zh','è½¬ä¼šåå•',0),(486563,13516,'sv','Ã–verfÃ¶ringslistan',0),(486564,13516,'it','Lista di trasferimento',0),(486565,13516,'tl','',0),(486566,13516,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸£à¸²à¸¢à¸à¸²à¸£',0),(486567,13516,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤¸à¥‚à¤šà¥€',0),(486568,13516,'ms','Senarai pemindahan',0),(486569,13516,'ar','Ù†Ù‚Ù„ Ù‚Ø§Ø¦Ù…Ø©',0),(486570,13516,'fr','Liste des transferts',0),(486571,13516,'jp','è»¢é€ãƒªã‚¹ãƒˆ',0),(486572,13516,'pt','Lista de transferÃªncia',0),(486573,13516,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‡Ð° ÑÐ¿Ð¸ÑÐºÐ°',0),(486574,13516,'es','Lista de Transferencias',0),(486575,13516,'de','Transferliste',0),(486576,13516,'en','Transfer List',0),(486577,13517,'is','',0),(486578,13517,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø¹Ù†ÙˆØ§Ù†',0),(486579,13517,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø¹Ù†ÙˆØ§Ù†',0),(486580,13517,'tr','Transfer baÅŸlÄ±ÄŸÄ±',0),(486581,13517,'pl','TytuÅ‚ przelewu',0),(486582,13517,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð½Ð° Ð·Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ',0),(486583,13517,'ur','Ø¹Ù†ÙˆØ§Ù† Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(486584,13517,'sr','ÐÐ°ÑÐ»Ð¾Ð² Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(486585,13517,'vi','Chuyá»ƒn tiÃªu Ä‘á»',0),(486586,13517,'af','Oordrag titel',0),(486587,13517,'ro','Transfera titlul',0),(486588,13517,'et','OmandiÃµiguse',0),(486589,13517,'si','Prenos naslov',0),(486590,13517,'ba','Mentransfer judul',0),(486591,13517,'nl','Overdracht titel',0),(486592,13517,'fi','Luovuta',0),(486593,13517,'no','OverfÃ¸re tittel',0),(486594,13517,'da','OverfÃ¸re titel',0),(486595,13517,'ko','ì „ì†¡ ì œëª©',0),(486596,13517,'he','×œ×”×¢×‘×™×¨ ××ª ×”×›×•×ª×¨×ª',0),(486597,13517,'el','ÎœÎµÏ„Î±Î²Î¯Î²Î±ÏƒÎ· Ï„Î¯Ï„Î»Î¿Ï…',0),(486598,13517,'zh','è½¬è®©æ‰€æœ‰æƒ',0),(486599,13517,'sv','Ã–verfÃ¶ra titel',0),(486600,13517,'it','Trasferimento titolo',0),(486601,13517,'tl','',0),(486602,13517,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­',0),(486603,13517,'hi','à¤¶à¥€à¤°à¥à¤·à¤• à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£',0),(486604,13517,'ms','Memindahkan hakmilik',0),(486605,13517,'ar','Ù†Ù‚Ù„ Ø§Ù„Ø¹Ù†ÙˆØ§Ù†',0),(486606,13517,'fr','Titre de transfert',0),(486607,13517,'jp','ã‚¿ã‚¤ãƒˆãƒ«ã‚’è»¢é€ã—ã¾ã™ã€‚',0),(486608,13517,'pt','TransferÃªncia de tÃ­tulo',0),(486609,13517,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(486610,13517,'es','Transferir el Titulo',0),(486611,13517,'de','Transfer-Titel',0),(486612,13517,'en','Transfer Title',0),(486613,13518,'is','',0),(486614,13518,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(486615,13518,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(486616,13518,'tr','AktarÄ±m baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(486617,13518,'pl','Transferu pomyÅ›lnie zaktualizowana',0),(486618,13518,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(486619,13518,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(486620,13518,'sr','Ð—Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(486621,13518,'vi','Truyá»n Cáº­p Nháº­t thÃ nh cÃ´ng',0),(486622,13518,'af','Oordrag suksesvol bygewerk',0),(486623,13518,'ro','Transferul actualizat cu succes',0),(486624,13518,'et','VÃ¤rskendatud Ã¼leandmine',0),(486625,13518,'si','Prenos uspeÅ¡no posodobljena',0),(486626,13518,'ba','Transfer berhasil',0),(486627,13518,'nl','Overdracht met succes bijgewerkt',0),(486628,13518,'fi','Siirto pÃ¤ivitetty',0),(486629,13518,'no','OverfÃ¸re oppdatert',0),(486630,13518,'da','OverfÃ¸rsel opdateret',0),(486631,13518,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ì „ì†¡',0),(486632,13518,'he','×”×¢×‘×¨×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(486633,13518,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(486634,13518,'zh','å·²æˆåŠŸæ›´æ–°çš„è½¬è®©',0),(486635,13518,'sv','Ã–verfÃ¶ring uppdaterats',0),(486636,13518,'it','Trasferimento aggiornato con successo',0),(486637,13518,'tl','',0),(486638,13518,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(486639,13518,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(486640,13518,'ms','Pemindahan berjaya dikemas kini',0),(486641,13518,'ar','Ù†Ù‚Ù„ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(486642,13518,'fr','Transfert Ã  jour avec succÃ¨s',0),(486643,13518,'jp','è»¢é€ãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(486644,13518,'pt','TransferÃªncia atualizada com sucesso',0),(486645,13518,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‡Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(486646,13518,'es','Transferencia Actualizada Exitosamente',0),(486647,13518,'de','Ãœbertragung erfolgreich aktualisiert',0),(486648,13518,'en','Transfer Updated Successfully',0),(486649,13519,'is','',0),(486650,13519,'dr','Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ù…ÙˆØ±Ø¯ Intercompany Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§Ù†Ø¬Ø§Ù… Ø¯Ù‡Ø¯',0),(486651,13519,'pr','Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ù…ÙˆØ±Ø¯ Intercompany Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§Ù†Ø¬Ø§Ù… Ø¯Ù‡Ø¯',0),(486652,13519,'tr','ÅžirketlerarasÄ± madde aktarÄ±mÄ± gerÃ§ekleÅŸtirilemiyor',0),(486653,13519,'pl','Nie moÅ¼na wykonaÄ‡ przesuniÄ™cia zapasÃ³w miÄ™dzyfirmowych',0),(486654,13519,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²ÑŠÑ€ÑˆÐ¸ Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð¼ÐµÐ¶Ð´ÑƒÑ„Ð¸Ñ€Ð¼ÐµÐ½Ð°Ñ‚Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(486655,13519,'ur','Ø§Ù†Ù¹Ø±Ú©ÙˆÙ…Ù¾Ù†ÛŒ Ø´Û’ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ø§Ù†Ø¬Ø§Ù… Ù†ÛÛŒÚº Ø¯Û’ Ø³Ú©ØªØ§',0),(486656,13519,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¸Ð·Ð²Ñ€ÑˆÐ¸Ñ‚Ð¸ Ð¼ÐµÑ’ÑƒÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜ÑÐºÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(486657,13519,'vi','KhÃ´ng thá»ƒ thá»±c hiá»‡n giao dá»‹ch chuyá»ƒn khoáº£n má»¥c Intercompany',0),(486658,13519,'af','Intercompany Item oorplasings kan verrig',0),(486659,13519,'ro','Nu se poate efectua transferuri de element inter-companii',0),(486660,13519,'et','Ei saa teostada kontsernisisese kauba Ã¼leandmise',0),(486661,13519,'si','Ne more izvesti prenosov artiklov znotraj podjetja',0),(486662,13519,'ba','Tidak dapat melakukan transfer antar Item',0),(486663,13519,'nl','IC-artikeltransfers uitvoeren niet',0),(486664,13519,'fi','Ei voi suorittaa konsernin sisÃ¤isen nimikkeen siirrot',0),(486665,13519,'no','Kan ikke utfÃ¸re konsernintern vare overfÃ¸ringer',0),(486666,13519,'da','Kan ikke udfÃ¸re interne vare overfÃ¸rsler',0),(486667,13519,'ko','íšŒì‚¬ ê°„ í•­ëª© ì „ì†¡ì„ ìˆ˜í–‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(486668,13519,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×‘×¦×¢ ×”×¢×‘×¨×•×ª ×¤×¨×™×˜ ×‘×™×Ÿ-×—×‘×¨×ª×™×•×ª',0),(486669,13519,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎºÏ„ÎµÎ»Î­ÏƒÎµÎ¹ Ï„Î¹Ï‚ Î´Î¹Î±ÎºÎ¹Î½Î®ÏƒÎµÎ¹Ï‚ Î´Î¹ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ­Ï‚ ÎµÎ¹Î´ÏŽÎ½',0),(486670,13519,'zh','ä¸èƒ½æ‰§è¡Œå†…éƒ¨å…¬å¸ç‰©æ–™ä¼ è¾“',0),(486671,13519,'sv','Kan inte utfÃ¶ra koncerninterna artikelÃ¶verfÃ¶ringar',0),(486672,13519,'it','Non Ã¨ possibile eseguire trasferimenti di articoli interaziendale',0),(486673,13519,'tl','',0),(486674,13519,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸—à¸³à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸šà¸£à¸´à¸©à¸±à¸—',0),(486675,13519,'hi','à¤†à¤‡à¤Ÿà¤® Intercompany à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¨à¤¿à¤·à¥à¤ªà¤¾à¤¦à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(486676,13519,'ms','Tidak dapat melaksanakan perkara antara Syarikat pemindahan',0),(486677,13519,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¬Ø±Ø§Ø¡ Ù†Ù‚Ù„ Ø§Ù„Ø¨Ù†Ø¯ Ø¨ÙŠÙ† Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø´Ù‚ÙŠÙ‚Ø©',0),(486678,13519,'fr','Ne peut pas effectuer des transferts de point intersociÃ©tÃ©s',0),(486679,13519,'jp','ä¼šç¤¾é–“å“ç›®ã®è»¢é€ã‚’å®Ÿè¡Œã§ãã¾ã›ã‚“ã€‚',0),(486680,13519,'pt','NÃ£o Ã© possÃ­vel realizar transferÃªncias de Item interempresas',0),(486681,13519,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð²Ð½ÑƒÑ‚Ñ€Ð¸Ñ…Ð¾Ð»Ð´Ð¸Ð½Ð³Ð¾Ð²Ð¾Ð³Ð¾ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ñ‹',0),(486682,13519,'es','No Se Puede Hacer Transferencias de Items Interempresa',0),(486683,13519,'de','Konzerninterne Element Transfers kann nicht ausgefÃ¼hrt werden.',0),(486684,13519,'en','Cannot Perform Intercompany Item Transfers',0),(486685,13520,'is','',0),(486686,13520,'dr','Ù¾Ø´ØªÛŒØ¨Ø§Ù† Ú¯ÛŒØ±ÛŒ Ù†ØµØ¨ØŒ Ø§ÛŒÙ† Ù…Ù…Ú©Ù† Ø§Ø³Øª Ú†Ù†Ø¯ Ù„Ø­Ø¸Ù‡ Ø·ÙˆÙ„ Ø¨Ú©Ø´Ø¯...',0),(486687,13520,'pr','Ù¾Ø´ØªÛŒØ¨Ø§Ù† Ú¯ÛŒØ±ÛŒ Ù†ØµØ¨ØŒ Ø§ÛŒÙ† Ù…Ù…Ú©Ù† Ø§Ø³Øª Ú†Ù†Ø¯ Ù„Ø­Ø¸Ù‡ Ø·ÙˆÙ„ Ø¨Ú©Ø´Ø¯...',0),(486688,13520,'tr','Geri yÃ¼kleme, bu birkaÃ§ dakika sÃ¼rebilir...',0),(486689,13520,'pl','Kopii zapasowej instalacji, moÅ¼e to potrwaÄ‡ kilka chwil...',0),(486690,13520,'bg','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸ÑÑ‚Ð°, Ñ‚Ð¾Ð²Ð° Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ñ‚Ð½ÐµÐ¼Ðµ Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð¸...',0),(486691,13520,'ur','Ø§Ù¾ Ú©ÛŒ ØªÙ†ØµÛŒØ¨ Ù…Ø¯Ø¯ØŒ Ø§Ø³ Ù…ÛŒÚº Ú©Ú†Ú¾ ÙˆÙ‚Øª Ù„Ú¯ Ø³Ú©ØªØ§...',0),(486692,13520,'sr','Ð˜Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ð° Ñƒ Ñ€Ð¸ÐºÐ²ÐµÑ€Ñ†, Ð¾Ð²Ð¾ Ð¼Ð¾Ð¶Ðµ Ð¿Ð¾Ñ‚Ñ€Ð°Ñ˜Ð°Ñ‚Ð¸ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð°ÐºÐ°...',0),(486693,13520,'vi','Sao lÆ°u cÃ i Ä‘áº·t, Ä‘iá»u nÃ y cÃ³ thá»ƒ máº¥t má»™t vÃ i phÃºt...',0),(486694,13520,'af','Rugsteun installasie, dit kan \'n rukkie duur...',0),(486695,13520,'ro','Backup-ul de instalare, aceasta poate dura cÃ¢teva momente...',0),(486696,13520,'et','Varundamine paigaldus, selleks vÃµib kuluda mÃµni minut...',0),(486697,13520,'si','Varnostno kopiranje namestitev, to lahko traja nekaj trenutkov...',0),(486698,13520,'ba','Back up instalasi, ini mungkin memerlukan beberapa saat...',0),(486699,13520,'nl','Back-up installatie, kan dit duren een paar momenten...',0),(486700,13520,'fi','Varmuuskopiointi asennuksen, tÃ¤mÃ¤ saattaa kestÃ¤Ã¤ hetken...',0),(486701,13520,'no','Sikkerhetskopiere installasjon, kan dette ta en stund...',0),(486702,13520,'da','Sikkerhedskopiering af installationen, kan det tage et par Ã¸jeblikke...',0),(486703,13520,'ko','ì„¤ì¹˜ë¥¼ ë°±ì—… í•˜ëŠ” ëª‡ ë¶„ ê±¸ë¦´ ìˆ˜ ìžˆìŠµë‹ˆë‹¤...',0),(486704,13520,'he','×’×™×‘×•×™ ×”×”×ª×§× ×”, ×¤×¢×•×œ×” ×–×• ×¢×©×•×™×” ×œ×”×™×ž×©×š ×ž×¡×¤×¨ ×¨×’×¢×™×...',0),(486705,13520,'el','Î‘Î½Ï„Î¹Î³ÏÎ¬Ï†Ï‰Î½ Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚, ÎµÎ½Î´Î­Ï‡ÎµÏ„Î±Î¹ Î½Î± Ï‡ÏÎµÎ¹Î±ÏƒÏ„Î¿ÏÎ½ Î»Î¯Î³Î± Î»ÎµÏ€Ï„Î¬...',0),(486706,13520,'zh','å¤‡ä»½å®‰è£…ï¼Œè¿™å¯èƒ½è¦èŠ±å‡ åˆ†é’Ÿ...',0),(486707,13520,'sv','Bakningen upp installation, kan detta ta en stund...',0),(486708,13520,'it','Backup di installazione, l\'operazione potrebbe richiedere alcuni istanti...',0),(486709,13520,'tl','',0),(486710,13520,'th','à¸ªà¸™à¸±à¸šà¸ªà¸™à¸¸à¸™à¸à¸²à¸£à¸•à¸´à¸”à¸•à¸±à¹‰à¸‡ à¸™à¸µà¹‰à¸­à¸²à¸ˆà¹ƒà¸Šà¹‰à¹€à¸§à¸¥à¸²à¸„à¸£à¸¹à¹ˆà¸«à¸™à¸¶à¹ˆà¸‡...',0),(486711,13520,'hi','à¤…à¤§à¤¿à¤·à¥à¤ à¤¾à¤ªà¤¨ à¤Šà¤ªà¤° à¤•à¤¾ à¤¸à¤®à¤°à¥à¤¥à¤¨, à¤¯à¤¹ à¤•à¥à¤› à¤ªà¤² à¤²à¥‡ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ...',0),(486712,13520,'ms','Menyandarkan pemasangan, ini mungkin mengambil masa beberapa ketika...',0),(486713,13520,'ar','Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠ Ù„Ù„ØªØ«Ø¨ÙŠØªØŒ Ù‚Ø¯ ÙŠØ³ØªØºØ±Ù‚ Ù‡Ø°Ø§ Ø¨Ø¶Ø¹ Ù„Ø­Ø¸Ø§Øª...',0),(486714,13520,'fr','Installation de sauvegarde, cela peut prendre quelques instants...',0),(486715,13520,'jp','ã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ«ã‚’ãƒãƒƒã‚¯ã‚¢ãƒƒãƒ—ã™ã‚‹ã€ã“ã‚Œã¯æ•°åˆ†ã‚’ã‹ã‹ã‚‹å¯èƒ½æ€§ãŒã‚ã‚Šã¾ã™.',0),(486716,13520,'pt','Fazendo backup de instalaÃ§Ã£o, isto pode demorar alguns momentos...',0),(486717,13520,'ru','Ð ÐµÐ·ÐµÑ€Ð²Ð½Ð¾Ðµ ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸, ÑÑ‚Ð¾ Ð¼Ð¾Ð¶ÐµÑ‚ Ð·Ð°Ð½ÑÑ‚ÑŒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚...',0),(486718,13520,'es','Respaldando la instalaciÃ³n, Puede tomar unos momentos...',0),(486719,13520,'de','Installation sichern, kann dies einen Moment dauern...',0),(486720,13520,'en','Backing up installation, this may take a few moments...',0),(486721,13521,'is','',0),(486722,13521,'dr','Ù¾Ø´ØªÛŒØ¨Ø§Ù† Ú¯ÛŒØ±ÛŒ Ú©Ø§Ù…Ù„.',0),(486723,13521,'pr','Ù¾Ø´ØªÛŒØ¨Ø§Ù† Ú¯ÛŒØ±ÛŒ Ú©Ø§Ù…Ù„.',0),(486724,13521,'tr','Yedekleme tamamlandÄ±.',0),(486725,13521,'pl','Kompletna kopia zapasowa.',0),(486726,13521,'bg','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸.',0),(486727,13521,'ur','Ù¾Ø´ØªØ§Ø±Û Ù…Ú©Ù…Ù„ ÛÛ’ Û”',0),(486728,13521,'sr','Ð ÐµÐ·ÐµÑ€Ð²Ð½Ð° ÐºÐ¾Ð¿Ð¸Ñ˜Ð° Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾.',0),(486729,13521,'vi','Sao lÆ°u Ä‘áº§y Ä‘á»§.',0),(486730,13521,'af','Rugsteuning Voltooi.',0),(486731,13521,'ro','Copie de rezervÄƒ completÄƒ.',0),(486732,13521,'et','Varundus lÃµpule viidud.',0),(486733,13521,'si','Popolno varnostno kopijo.',0),(486734,13521,'ba','Cadangan lengkap.',0),(486735,13521,'nl','Back-up voltooid.',0),(486736,13521,'fi','Varmuuskopiointi on valmis.',0),(486737,13521,'no','Sikkerhetskopieringen er fullfÃ¸rt.',0),(486738,13521,'da','Backup komplet.',0),(486739,13521,'ko','ë°±ì—… ì™„ë£Œìž…ë‹ˆë‹¤.',0),(486740,13521,'he','×’×™×‘×•×™ ×ž×œ×.',0),(486741,13521,'el','Î Î»Î®ÏÎµÏ‚ Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚.',0),(486742,13521,'zh','å®Œæˆå¤‡ä»½ã€‚',0),(486743,13521,'sv','Backup komplett.',0),(486744,13521,'it','Backup completo.',0),(486745,13521,'tl','',0),(486746,13521,'th','à¸à¸²à¸£à¸ªà¸³à¸£à¸­à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(486747,13521,'hi','à¤¬à¥ˆà¤•à¤…à¤ª à¤ªà¥‚à¤°à¥à¤£à¥¤',0),(486748,13521,'ms','Sandaran lengkap.',0),(486749,13521,'ar','Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠ Ø§Ù„ÙƒØ§Ù…Ù„.',0),(486750,13521,'fr','Sauvegarde complÃ¨te.',0),(486751,13521,'jp','ãƒãƒƒã‚¯ã‚¢ãƒƒãƒ—ãŒå®Œäº†ã—ã¾ã—ãŸã€‚',0),(486752,13521,'pt','Backup completo.',0),(486753,13521,'ru','ÐŸÐ¾Ð»Ð½Ð¾Ðµ Ñ€ÐµÐ·ÐµÑ€Ð²Ð½Ð¾Ðµ ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ.',0),(486754,13521,'es','Respalda Completa',0),(486755,13521,'de','Sicherung abgeschlossen.',0),(486756,13521,'en','Backup Complete.',0),(486757,13522,'is','',0),(486758,13522,'dr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§Ù…ØªØ­Ø§Ù† Ú©Ù†ÛŒØ¯.',0),(486759,13522,'pr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§Ù…ØªØ­Ø§Ù† Ú©Ù†ÛŒØ¯.',0),(486760,13522,'tr','Yeniden denemek iÃ§in burayÄ± tÄ±klatÄ±n.',0),(486761,13522,'pl','Kliknij tutaj, aby sprÃ³bowaÄ‡ ponownie.',0),(486762,13522,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¾Ð¿Ð¸Ñ‚Ð°Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾.',0),(486763,13522,'ur','Ù¾Ú¾Ø± Ú©ÙˆØ´Ø´ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº.',0),(486764,13522,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ð¾ÐºÑƒÑˆÐ°Ð»Ð¸ Ð¿Ð¾Ð½Ð¾Ð²Ð¾.',0),(486765,13522,'vi','Click vÃ o Ä‘Ã¢y Ä‘á»ƒ thá»­ láº¡i.',0),(486766,13522,'af','Klik hier om weer te probeer.',0),(486767,13522,'ro','Click aici pentru a Ã®ncerca din nou.',0),(486768,13522,'et','Uuesti proovimiseks klÃµpsake siin.',0),(486769,13522,'si','Kliknite tukaj, Äe Å¾elite poskusiti znova.',0),(486770,13522,'ba','Klik di sini untuk mencoba lagi.',0),(486771,13522,'nl','Klik hier om opnieuw te proberen.',0),(486772,13522,'fi','YritÃ¤ uudelleen napsauttamalla tÃ¤tÃ¤.',0),(486773,13522,'no','Klikk her for Ã¥ prÃ¸ve pÃ¥ nytt.',0),(486774,13522,'da','Klik her for at prÃ¸ve igen.',0),(486775,13522,'ko','ë‹¤ì‹œ ì‹œë„ í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(486776,13522,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ× ×¡×•×ª ×©×•×‘.',0),(486777,13522,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÎµÏ„Îµ Î¾Î±Î½Î¬.',0),(486778,13522,'zh','å•å‡»æ­¤å¤„å¯å†è¯•ä¸€æ¬¡ã€‚',0),(486779,13522,'sv','Klicka hÃ¤r fÃ¶r att prova igen.',0),(486780,13522,'it','Clicca qui per riprovare.',0),(486781,13522,'tl','',0),(486782,13522,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸¥à¸­à¸‡à¸­à¸µà¸à¸„à¸£à¸±à¹‰à¸‡',0),(486783,13522,'hi','à¤ªà¥à¤¨à¤ƒ à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚à¥¤',0),(486784,13522,'ms','Klik di sini untuk mencuba semula.',0),(486785,13522,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ù„Ù…Ø­Ø§ÙˆÙ„Ø© Ù…Ø±Ø© Ø£Ø®Ø±Ù‰.',0),(486786,13522,'fr','Cliquez ici pour rÃ©essayer.',0),(486787,13522,'jp','ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦ã‚‚ã†ä¸€åº¦ã‚„ã‚Šç›´ã—ã¦ãã ã•ã„ã€‚',0),(486788,13522,'pt','Clique aqui para tentar novamente.',0),(486789,13522,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾Ð¿Ñ€Ð¾Ð±Ð¾Ð²Ð°Ñ‚ÑŒ ÐµÑ‰Ðµ Ñ€Ð°Ð·.',0),(486790,13522,'es','Click aqui para intentar de nuevo',0),(486791,13522,'de','Klicken Sie hier, um noch einmal zu versuchen.',0),(486792,13522,'en','Click here to try again.',0),(486793,13523,'is','',0),(486794,13523,'dr','Ø§ØªØµØ§Ù„ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯ØŒ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§Ù…ØªØ­Ø§Ù† Ú©Ù†ÛŒØ¯.',0),(486795,13523,'pr','Ø§ØªØµØ§Ù„ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯ØŒ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§Ù…ØªØ­Ø§Ù† Ú©Ù†ÛŒØ¯.',0),(486796,13523,'tr','BaÄŸlantÄ± baÅŸarÄ±sÄ±z oldu, yeniden deneyin.',0),(486797,13523,'pl','PoÅ‚Ä…czenie nie powiodÅ‚o siÄ™, sprÃ³buj jeszcze raz.',0),(486798,13523,'bg','Ð’Ñ€ÑŠÐ·ÐºÐ°Ñ‚Ð° Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð°, Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾.',0),(486799,13523,'ur','Ú©Ù†Ú©Ø´Ù† Ù†Ø§Ú©Ø§Ù…ØŒ Ø¯ÙˆØ¨Ø§Ø±Û Ú©ÙˆØ´Ø´ ÛÛ’ Û”',0),(486800,13523,'sr','ÐŸÐ¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾, Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾.',0),(486801,13523,'vi','Káº¿t ná»‘i khÃ´ng thÃ nh cÃ´ng, thá»­ láº¡i.',0),(486802,13523,'af','Verbinding het misluk, probeer weer.',0),(486803,13523,'ro','Conexiunea a eÅŸuat, Ã®ncercaÅ£i din nou.',0),(486804,13523,'et','Ãœhendus ebaÃµnnestus, proovige uuesti.',0),(486805,13523,'si','Povezava ni uspela, poskusite znova.',0),(486806,13523,'ba','Koneksi gagal, coba lagi.',0),(486807,13523,'nl','Verbinding mislukt, probeer het opnieuw.',0),(486808,13523,'fi','Yhteys epÃ¤onnistui, yritÃ¤ uudelleen.',0),(486809,13523,'no','Tilkobling mislyktes, prÃ¸v pÃ¥ nytt.',0),(486810,13523,'da','Tilslutning mislykkedes, prÃ¸v igen.',0),(486811,13523,'ko','ì—°ê²° ì‹¤íŒ¨, ë‹¤ì‹œ ì‹œë„ í•˜ì‹­ì‹œì˜¤.',0),(486812,13523,'he','×—×™×‘×•×¨ × ×›×©×œ, × ×¡×” ×©×•×‘.',0),(486813,13523,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ, Î¾Î±Î½Î±Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ.',0),(486814,13523,'zh','è¿žæŽ¥å¤±è´¥ï¼Œå†è¯•ä¸€æ¬¡ã€‚',0),(486815,13523,'sv','Anslutning misslyckades, fÃ¶rsÃ¶k igen.',0),(486816,13523,'it','Connessione non riuscita, riprovare.',0),(486817,13523,'tl','',0),(486818,13523,'th','à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§ à¸¥à¸­à¸‡à¹ƒà¸«à¸¡à¹ˆà¸­à¸µà¸à¸„à¸£à¸±à¹‰à¸‡',0),(486819,13523,'hi','à¤•à¤¨à¥‡à¤•à¥à¤¶à¤¨ à¤µà¤¿à¤«à¤², à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚à¥¤',0),(486820,13523,'ms','Sambungan yang gagal, cuba lagi.',0),(486821,13523,'ar','Ø§Ù„Ø§ØªØµØ§Ù„ ÙØ´Ù„ØŒ Ø­Ø§ÙˆÙ„ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰.',0),(486822,13523,'fr','Connexion a Ã©chouÃ©, essayez Ã  nouveau.',0),(486823,13523,'jp','æŽ¥ç¶šã«å¤±æ•—ã—ã¾ã—ãŸ, ã‚‚ã†ä¸€åº¦è©¦ã—ã¦ãã ã•ã„ã€‚',0),(486824,13523,'pt','ConexÃ£o falhou, tente novamente.',0),(486825,13523,'ru','ÐŸÐ¾Ð´ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ, Ð¿Ð¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÐµÑ‰Ðµ Ñ€Ð°Ð·.',0),(486826,13523,'es','ConexiÃ³n fallo, intenta de nuevo',0),(486827,13523,'de','Verbindung fehlgeschlagen, versuchen Sie es erneut.',0),(486828,13523,'en','Connection failed, try again.',0),(486829,13524,'is','',0),(486830,13524,'dr','Ù†ÙˆØ´ØªÙ† ÙÙ‡Ø±Ø³Øª Ù…ÙˆÙÙ‚ Ù†Ø¨ÙˆØ¯!',0),(486831,13524,'pr','Ù†ÙˆØ´ØªÙ† ÙÙ‡Ø±Ø³Øª Ù…ÙˆÙÙ‚ Ù†Ø¨ÙˆØ¯!',0),(486832,13524,'tr','Dizin yazma baÅŸarÄ±sÄ±z oldu!',0),(486833,13524,'pl','Katalog zapisu nie powiodÅ‚o siÄ™!',0),(486834,13524,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ñ ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾!',0),(486835,13524,'ur','ÚˆØ§Ø¦Ø±ÛŒÚ©Ù¹Ø±ÛŒ Ù„Ú©Ú¾Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…!',0),(486836,13524,'sr','ÐŸÐ¸ÑÐ°ÑšÐµ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ñ˜ÑƒÐ¼ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾!',0),(486837,13524,'vi','ThÆ° má»¥c ghi tháº¥t báº¡i!',0),(486838,13524,'af','Gids skryf het misluk!',0),(486839,13524,'ro','Director scrie nu a reuÅŸit!',0),(486840,13524,'et','Kataloogi kirjutamine nurjus!',0),(486841,13524,'si','Naslovnik pisanje ni uspelo!',0),(486842,13524,'ba','Direktori menulis gagal!',0),(486843,13524,'nl','Map schrijven mislukt!',0),(486844,13524,'fi','Hakemisto kirjoitus epÃ¤onnistui!',0),(486845,13524,'no','Directory skrivefeil!',0),(486846,13524,'da','Directory skrivningen mislykkedes!',0),(486847,13524,'ko','ë””ë ‰í„°ë¦¬ ì“°ê¸° ì‹¤íŒ¨!',0),(486848,13524,'he','×ž×“×¨×™×š ×›×ª×™×‘×” × ×›×©×œ×”!',0),(486849,13524,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ Î±Ï€Î­Ï„Ï…Ï‡Îµ!',0),(486850,13524,'zh','ç›®å½•å†™å…¥å¤±è´¥ ï¼',0),(486851,13524,'sv','Katalog skrivning misslyckades!',0),(486852,13524,'it','Scrittura di directory non riuscita!',0),(486853,13524,'tl','',0),(486854,13524,'th','à¹€à¸‚à¸µà¸¢à¸™à¹„à¸”à¹€à¸£à¸à¸—à¸­à¸£à¸µà¹„à¸¡à¹ˆà¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(486855,13524,'hi','à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¤¿à¤•à¤¾ à¤²à¤¿à¤–à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤²!',0),(486856,13524,'ms','Direktori tulis gagal!',0),(486857,13524,'ar','ÙØ´Ù„ ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø¯Ù„ÙŠÙ„!',0),(486858,13524,'fr','Ã‰chec de l\'Ã©criture du rÃ©pertoire !',0),(486859,13524,'jp','ãƒ‡ã‚£ãƒ¬ã‚¯ãƒˆãƒªã®æ›¸ãè¾¼ã¿ã«å¤±æ•—ã—ã¾ã—ãŸ ï¼',0),(486860,13524,'pt','GravaÃ§Ã£o de diretÃ³rio falhou!',0),(486861,13524,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³Ð¾Ð² Ð½Ðµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ!',0),(486862,13524,'es','Escribir al directorio fallÃ³',0),(486863,13524,'de','Verzeichnis schreiben fehlgeschlagen!',0),(486864,13524,'en','Directory write failed!',0),(486865,13525,'is','',0),(486866,13525,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ Ù‡Ø§, Ø§ÛŒÙ† Ù…Ù…Ú©Ù† Ø§Ø³Øª Ú†Ù†Ø¯ Ù„Ø­Ø¸Ù‡ Ø·ÙˆÙ„ Ø¨Ú©Ø´Ø¯...',0),(486867,13525,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ Ù‡Ø§, Ø§ÛŒÙ† Ù…Ù…Ú©Ù† Ø§Ø³Øª Ú†Ù†Ø¯ Ù„Ø­Ø¸Ù‡ Ø·ÙˆÙ„ Ø¨Ú©Ø´Ø¯...',0),(486868,13525,'tr','Dosya indirme, bu birkaÃ§ dakika sÃ¼rebilir.',0),(486869,13525,'pl','Pobieranie plikÃ³w, moÅ¼e to potrwaÄ‡ kilka chwil...',0),(486870,13525,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ, Ñ‚Ð¾Ð²Ð° Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ñ‚Ð½ÐµÐ¼Ðµ Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚Ð¸...',0),(486871,13525,'ur','Ù…Ø³Ù„ÛŒÚº ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Ø±Ù†Ø§ØŒ Ø§Ø³ Ù…ÛŒÚº Ú©Ú†Ú¾ ÙˆÙ‚Øª Ù„Ú¯ Ø³Ú©ØªØ§ ÛÛ’...',0),(486872,13525,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°, Ñ‚Ð¾ Ð¼Ð¾Ð¶Ðµ Ð¿Ð¾Ñ‚Ñ€Ð°Ñ˜Ð°Ñ‚Ð¸ Ð½ÐµÐºÐ¾Ð»Ð¸ÐºÐ¾ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð°ÐºÐ°...',0),(486873,13525,'vi','Táº£i táº­p tin xuá»‘ng, Ä‘iá»u nÃ y cÃ³ thá»ƒ máº¥t má»™t vÃ i phÃºt...',0),(486874,13525,'af','Om lÃªers af te laai, kan dit \'n paar oomblikke duur...',0),(486875,13525,'ro','DescÄƒrcarea de fiÅŸiere, aceasta poate dura cÃ¢teva momente...',0),(486876,13525,'et','Failide allalaadimine see vÃµib vÃµtta aega...',0),(486877,13525,'si','Nalaganje datotek, to lahko traja nekaj trenutkov...',0),(486878,13525,'ba','Men-download file, ini mungkin memerlukan beberapa saat...',0),(486879,13525,'nl','Downloaden van bestanden, kan dit duren een paar momenten...',0),(486880,13525,'fi','TÃ¤mÃ¤ saattaa kestÃ¤Ã¤ hetken ladata tiedostoja...',0),(486881,13525,'no','Nedlasting av filer, kan dette ta en stund...',0),(486882,13525,'da','Downloade filer, kan dette tage et par Ã¸jeblikke...',0),(486883,13525,'ko','íŒŒì¼ì„ ë‹¤ìš´ë¡œë“œ, ëª‡ ë¶„ ê±¸ë¦´ ìˆ˜ ìžˆìŠµë‹ˆë‹¤...',0),(486884,13525,'he','×”×•×¨×“×ª ×§×‘×¦×™×, ×¤×¢×•×œ×” ×–×• ×¢×©×•×™×” ×œ×”×™×ž×©×š ×ž×¡×¤×¨ ×¨×’×¢×™×...',0),(486885,13525,'el','ÎšÎ±Ï„Î­Î²Î±ÏƒÎ¼Î± Î±ÏÏ‡ÎµÎ¯Ï‰Î½, Î±Ï…Ï„ÏŒ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î¹Î±ÏÎºÎ­ÏƒÎµÎ¹ Î¼ÎµÏÎ¹ÎºÎ­Ï‚ ÏƒÏ„Î¹Î³Î¼Î­Ï‚...',0),(486886,13525,'zh','ä¸‹è½½æ–‡ä»¶ï¼Œè¿™å¯èƒ½è¦èŠ±å‡ åˆ†é’Ÿ...',0),(486887,13525,'sv','Ladda ner filer, kan detta ta en stund...',0),(486888,13525,'it','Download di file, l\'operazione potrebbe richiedere alcuni istanti...',0),(486889,13525,'tl','',0),(486890,13525,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹à¸Ÿà¹‰à¸¡ à¸™à¸µà¹‰à¸­à¸²à¸ˆà¹ƒà¸Šà¹‰à¹€à¸§à¸¥à¸²à¸„à¸£à¸¹à¹ˆà¸«à¸™à¸¶à¹ˆà¸‡...',0),(486891,13525,'hi','à¤«à¤¼à¤¾à¤‡à¤²à¥‹à¤‚ à¤•à¥‹ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡, à¤¯à¤¹ à¤•à¥à¤› à¤ªà¤² à¤²à¥‡ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ...',0),(486892,13525,'ms','Memuat turun fail, ini mungkin mengambil masa beberapa ketika...',0),(486893,13525,'ar','ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ù…Ù„ÙØ§ØªØŒ Ù‚Ø¯ ÙŠØ³ØªØºØ±Ù‚ Ù‡Ø°Ø§ Ø¨Ø¶Ø¹ Ù„Ø­Ø¸Ø§Øª...',0),(486894,13525,'fr','TÃ©lÃ©chargement de fichiers, cela peut prendre quelques instants...',0),(486895,13525,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã€ã“ã‚Œã¯æ•°åˆ†ã‚’ã‹ã‹ã‚‹å¯èƒ½æ€§ãŒã‚ã‚Šã¾ã™.',0),(486896,13525,'pt','Download de arquivos, isto pode demorar alguns momentos...',0),(486897,13525,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·ÐºÐ° Ñ„Ð°Ð¹Ð»Ð¾Ð², ÑÑ‚Ð¾ Ð¼Ð¾Ð¶ÐµÑ‚ Ð·Ð°Ð½ÑÑ‚ÑŒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð¼Ð¸Ð½ÑƒÑ‚...',0),(486898,13525,'es','Descargando files, se puede tomar unos momentos',0),(486899,13525,'de','Herunterladen von Dateien, kann dies einen Moment dauern...',0),(486900,13525,'en','Downloading files, this may take a few moments...',0),(486901,13526,'is','',0),(486902,13526,'dr','Ø¨Ø§Ø±Ú¯ÛŒØ±ÛŒ Ú©Ø§Ù…Ù„ Ø´Ø¯.',0),(486903,13526,'pr','Ø¨Ø§Ø±Ú¯ÛŒØ±ÛŒ Ú©Ø§Ù…Ù„ Ø´Ø¯.',0),(486904,13526,'tr','Ä°ndirme tamamlandÄ±.',0),(486905,13526,'pl','Pobierz kompletny.',0),(486906,13526,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½ÐµÑ‚Ð¾ Ðµ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¾.',0),(486907,13526,'ur','ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ù…Ú©Ù…Ù„',0),(486908,13526,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾.',0),(486909,13526,'vi','Táº£i xuá»‘ng hoÃ n táº¥t.',0),(486910,13526,'af','Aflaai voltooi.',0),(486911,13526,'ro','Descarca complet.',0),(486912,13526,'et','Allalaadimine on lÃµpule viidud.',0),(486913,13526,'si','Travnato griÄevje celoten.',0),(486914,13526,'ba','Download selesai.',0),(486915,13526,'nl','Download voltooid.',0),(486916,13526,'fi','Lataa tÃ¤ydellinen.',0),(486917,13526,'no','Nedlastingen er fullfÃ¸rt.',0),(486918,13526,'da','Download komplet.',0),(486919,13526,'ko','ë‹¤ìš´ë¡œë“œê°€ ì™„ë£Œ ë˜ ë©´.',0),(486920,13526,'he','×”×”×•×¨×“×” ×”×•×©×œ×ž×”.',0),(486921,13526,'el','Î— Î¼ÎµÏ„Î±Ï†ÏŒÏÏ„Ï‰ÏƒÎ· Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ¸Î·ÎºÎµ.',0),(486922,13526,'zh','å·²å®Œæˆä¸‹è½½ã€‚',0),(486923,13526,'sv','HÃ¤mta komplett.',0),(486924,13526,'it','Scarica completa.',0),(486925,13526,'tl','',0),(486926,13526,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(486927,13526,'hi','à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤ªà¥‚à¤°à¤¾ à¤•à¤°à¥‡à¤‚à¥¤',0),(486928,13526,'ms','Muat turun lengkap.',0),(486929,13526,'ar','Ø§ÙƒØªÙ…Ø§Ù„ Ø§Ù„ØªÙ†Ø²ÙŠÙ„.',0),(486930,13526,'fr','TÃ©lÃ©chargement complet.',0),(486931,13526,'jp','ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ãŒå®Œäº†ã—ã¾ã—ãŸã€‚',0),(486932,13526,'pt','Download concluÃ­do.',0),(486933,13526,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·ÐºÐ° Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°.',0),(486934,13526,'es','Descargar Completo',0),(486935,13526,'de','Download abgeschlossen.',0),(486936,13526,'en','Download Complete.',0),(486937,13527,'is','',0),(486938,13527,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ù†Ø´Ø¯!',0),(486939,13527,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ù†Ø´Ø¯!',0),(486940,13527,'tr','KarÅŸÄ±dan yÃ¼kleme baÅŸarÄ±sÄ±z oldu.',0),(486941,13527,'pl','Pobieranie nie powiodÅ‚o siÄ™!',0),(486942,13527,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ!',0),(486943,13527,'ur','ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§ Ù†Ø§Ú©Ø§Ù…!',0),(486944,13527,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾!',0),(486945,13527,'vi','Táº£i xuá»‘ng khÃ´ng thÃ nh cÃ´ng!',0),(486946,13527,'af','Aflaai kon nie!',0),(486947,13527,'ro','Download nu a reuÅŸit!',0),(486948,13527,'et','Allalaadimine nurjus!',0),(486949,13527,'si','Prenos ni uspel!',0),(486950,13527,'ba','Download gagal!',0),(486951,13527,'nl','Download mislukt!',0),(486952,13527,'fi','Lataus epÃ¤onnistui!',0),(486953,13527,'no','Nedlasting mislyktes!',0),(486954,13527,'da','Download mislykkedes!',0),(486955,13527,'ko','ì‹¤íŒ¨ í•œ ë‹¤ìš´ë¡œë“œ!',0),(486956,13527,'he','×”×”×•×¨×“×” × ×›×©×œ×”!',0),(486957,13527,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÏ„ÏŽÎ½ÎµÎ¹ Î±Ï€Î¿Ï„Ï…Ï‡Î·Î¼Î­Î½Î¿Ï‚!',0),(486958,13527,'zh','ä¸‹è½½å¤±è´¥ ï¼',0),(486959,13527,'sv','Det gick inte att ladda ner!',0),(486960,13527,'it','Download non riuscito!',0),(486961,13527,'tl','',0),(486962,13527,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(486963,13527,'hi','à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾!',0),(486964,13527,'ms','Muat turun gagal!',0),(486965,13527,'ar','ÙØ´Ù„ Ø§Ù„ØªØ­Ù…ÙŠÙ„!',0),(486966,13527,'fr','TÃ©lÃ©chargement Ã©chouÃ© !',0),(486967,13527,'jp','ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã«å¤±æ•—ã—ã¾ã—ãŸ ï¼',0),(486968,13527,'pt','Download falhou!',0),(486969,13527,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸!',0),(486970,13527,'es','Descargar FallÃ³!',0),(486971,13527,'de','Download fehlgeschlagen!',0),(486972,13527,'en','Download Failed!',0),(486973,13528,'is','',0),(486974,13528,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ Ù‡Ø¯Ø± Ù…ÙˆØ±Ø¯.',0),(486975,13528,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ Ù‡Ø¯Ø± Ù…ÙˆØ±Ø¯.',0),(486976,13528,'tr','Madde alma Ã¼stbilgi dosyasÄ±nÄ± indirin.',0),(486977,13528,'pl','Pobierz element nagÅ‚Ã³wka pliku importu.',0),(486978,13528,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð²Ð½Ð¾Ñ Ð³Ð¾Ñ€Ð½Ð¸Ñ Ñ„Ð°Ð¹Ð».',0),(486979,13528,'ur','Ø´Û’ Ø¯Ø±Ø¢Ù…Ø¯ ÛÛŒÚˆØ± ÙØ§Ø¦Ù„ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº Û”',0),(486980,13528,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¼Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ð° ÑƒÐ²Ð¾Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°.',0),(486981,13528,'vi','Táº£i vá» má»¥c nháº­p táº­p tin tiÃªu Ä‘á».',0),(486982,13528,'af','Item invoer kopskrif lÃªer aflaai.',0),(486983,13528,'ro','DescarcÄƒ element de import antetul.',0),(486984,13528,'et','Kauba impordi pÃ¤ises faili alla laadida.',0),(486985,13528,'si','Download element uvozne glavo datoteke.',0),(486986,13528,'ba','Men-download file header barang impor.',0),(486987,13528,'nl','Het item invoer headerbestand downloaden.',0),(486988,13528,'fi','Lataa nimikkeen tuontitiedoston otsikkoon.',0),(486989,13528,'no','Last ned element importfilen topptekst.',0),(486990,13528,'da','Download vare import headerfil.',0),(486991,13528,'ko','í•­ëª© ê°€ì ¸ì˜¤ê¸° í—¤ë” íŒŒì¼ì„ ë‹¤ìš´ë¡œë“œ í•©ë‹ˆë‹¤.',0),(486992,13528,'he','×”×•×¨×“ ×§×•×‘×¥ ×›×•×ª×¨×ª ×¤×¨×™×˜ ×”×™×™×‘×•×.',0),(486993,13528,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ ÎºÎµÏ†Î±Î»Î¯Î´Î± Î±ÏÏ‡ÎµÎ¯Î¿.',0),(486994,13528,'zh','ä¸‹è½½é¡¹ç›®å¯¼å…¥å¤´æ–‡ä»¶ã€‚',0),(486995,13528,'sv','HÃ¤mta artikeln Importera header-fil.',0),(486996,13528,'it','Scarica voce importazione file di intestazione.',0),(486997,13528,'tl','',0),(486998,13528,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹à¸Ÿà¹‰à¸¡à¸«à¸±à¸§à¸ªà¸´à¸™à¸„à¹‰à¸²à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(486999,13528,'hi','à¤†à¤‡à¤Ÿà¤® à¤†à¤¯à¤¾à¤¤ à¤¹à¥ˆà¤¡à¤° à¤«à¤¼à¤¾à¤‡à¤² à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚à¥¤',0),(487000,13528,'ms','Muat turun item import pengepala fail.',0),(487001,13528,'ar','ØªØ­Ù…ÙŠÙ„ Ù…Ù„Ù Ø±Ø£Ø³ Ø¹Ù†ØµØ± Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯.',0),(487002,13528,'fr','TÃ©lÃ©charger le fichier d\'en-tÃªte Ã©lÃ©ment import.',0),(487003,13528,'jp','ã‚¢ã‚¤ãƒ†ãƒ  ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ãƒ˜ãƒƒãƒ€ãƒ¼ ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(487004,13528,'pt','Baixe o arquivo de cabeÃ§alho do item import.',0),(487005,13528,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ð¹Ñ‚Ðµ Ñ„Ð°Ð¹Ð» Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²ÐºÐ° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°.',0),(487006,13528,'es','Descargar item de file de cabecera de importaciones',0),(487007,13528,'de','Download Element Header-Datei importieren.',0),(487008,13528,'en','Download item import header file.',0),(487009,13529,'is','',0),(487010,13529,'dr','Ø¨Ø§ Ø³Ø± ØµÙØ­Ù‡ Ø±Ø¯ÛŒÙ Ù…ÙˆØ¬ÙˆØ¯ ÙˆØ§Ø±Ø¯Ø§Øª!',0),(487011,13529,'pr','Ø¨Ø§ Ø³Ø± ØµÙØ­Ù‡ Ø±Ø¯ÛŒÙ Ù…ÙˆØ¬ÙˆØ¯ ÙˆØ§Ø±Ø¯Ø§Øª!',0),(487012,13529,'tr','Ãœstbilgi satÄ±rÄ± mevcut almayÄ±n!',0),(487013,13529,'pl','Nie Importuj z wiersza nagÅ‚Ã³wka obecny!',0),(487014,13529,'bg','ÐÐµ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð¹ ÑÑŠÑ Ð·Ð°Ð³Ð»Ð°Ð²Ð½Ð¸Ñ Ñ€ÐµÐ´ Ð¿Ñ€Ð¸ÑÑŠÑÑ‚Ð²Ð°!',0),(487015,13529,'ur','Ø³Ø±ØªØ­Ø±ÛŒØ± ØµÙ Ù…ÙˆØ¬ÙˆØ¯ Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº!',0),(487016,13529,'sr','ÐÐµ ÑƒÐ²Ð¾Ð·Ð¸ ÑÐ° Ñ€ÐµÐ´ Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ð° Ð¿Ð¾ÐºÐ»Ð¾Ð½!',0),(487017,13529,'vi','KhÃ´ng nháº­p kháº©u vá»›i hÃ ng tiÃªu Ä‘á» hiá»‡n nay!',0),(487018,13529,'af','Met kop ry teenwoordig voer nie!',0),(487019,13529,'ro','Nu se importÄƒ cu rÃ¢ndul antet prezent!',0),(487020,13529,'et','Impordi koos pÃ¤isereaga kohal!',0),(487021,13529,'si','Ne uvaÅ¾aj z naslovno vrstico prisotni!',0),(487022,13529,'ba','Jangan impor dengan baris header hadir!',0),(487023,13529,'nl','Niet importeren met veldnamenrij aanwezig!',0),(487024,13529,'fi','Ã„lÃ¤ tuo otsikkorivi lÃ¤snÃ¤!',0),(487025,13529,'no','Ikke import med overskriftsraden stede!',0),(487026,13529,'da','Import ikke med overskriftsrÃ¦kken stede!',0),(487027,13529,'ko','í˜„ìž¬ ë¨¸ë¦¬ê¸€ í–‰ì„ ê°€ì ¸ì˜¤ì§€ ì•ŠìŒ!',0),(487028,13529,'he','××œ ×ª×™×™×‘× ×¢× ×©×•×¨×ª ×”×›×•×ª×¨×ª ×”× ×•×›×—×™!',0),(487029,13529,'el','Î”ÎµÎ½ ÎµÎ¹ÏƒÎ¬Î³Î¿Ï…Î½ Î¼Îµ Î³ÏÎ±Î¼Î¼Î® ÎºÎµÏ†Î±Î»Î¯Î´Î±Ï‚ Ï€Î±ÏÏŒÎ½Ï„ÎµÏ‚!',0),(487030,13529,'zh','ä¸å¯¼å…¥ä¸Žæ ‡é¢˜è¡Œæœ¬ ï¼',0),(487031,13529,'sv','Importera inte med rubrikrad nÃ¤rvarande!',0),(487032,13529,'it','Non importare con riga di intestazione presente!',0),(487033,13529,'tl','',0),(487034,13529,'th','à¹„à¸¡à¹ˆà¸™à¸³à¹€à¸‚à¹‰à¸²à¸­à¸¢à¸¹à¹ˆà¹à¸–à¸§à¸«à¸±à¸§',0),(487035,13529,'hi','à¤¶à¥€à¤°à¥à¤· à¤²à¥‡à¤– à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤‰à¤ªà¤¸à¥à¤¥à¤¿à¤¤ à¤†à¤¯à¤¾à¤¤ à¤¨ à¤•à¤°à¥‡à¤‚!',0),(487036,13529,'ms','Import dengan baris kepala sekarang!',0),(487037,13529,'ar','Ø¹Ø¯Ù… Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ø¹ ØµÙ Ø§Ù„Ø±Ø£Ø³ Ø§Ù„Ø­Ø§Ù„ÙŠ!',0),(487038,13529,'fr','N\'importez pas avec la ligne d\'en-tÃªte prÃ©sent !',0),(487039,13529,'jp','ãƒ˜ãƒƒãƒ€ãƒ¼è¡Œã®å­˜åœ¨ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ãªã„ã§ãã ã•ã„ ï¼',0),(487040,13529,'pt','NÃ£o importe com a linha de cabeÃ§alho presente!',0),(487041,13529,'ru','ÐÐµ ÑÐ»ÐµÐ´ÑƒÐµÑ‚ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐ¹ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²ÐºÐ°!',0),(487042,13529,'es','No importar con la fila cabecera presente',0),(487043,13529,'de','Importieren Sie nicht mit Kopfzeile vorhanden!',0),(487044,13529,'en','Do not import with header row present!',0),(487045,13530,'is','',0),(487046,13530,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø§Ø³ØªØ®Ø±Ø§Ø¬ Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ù‡Ø§...',0),(487047,13530,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø§Ø³ØªØ®Ø±Ø§Ø¬ Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ù‡Ø§...',0),(487048,13530,'tr','Dosyalar ayÄ±klanÄ±yor...',0),(487049,13530,'pl','WyodrÄ™bnianie plikÃ³w...',0),(487050,13530,'bg','Ð˜Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ...',0),(487051,13530,'ur','Ù…Ø³Ù„ÛŒÚº Ù†Ú©Ø§Ù„ Ø±ÛØ§ ÛÛ’...',0),(487052,13530,'sr','Ð˜Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°...',0),(487053,13530,'vi','Giáº£i nÃ©n táº­p tin...',0),(487054,13530,'af','Ekstraheer lÃªers...',0),(487055,13530,'ro','Extragerea fiÅŸierelor...',0),(487056,13530,'et','Failide ekstraktimine...',0),(487057,13530,'si','Ekstrahiranje datotek...',0),(487058,13530,'ba','Mengekstrak file...',0),(487059,13530,'nl','Het uitpakken van bestanden...',0),(487060,13530,'fi','Puretaan tiedostoja...',0),(487061,13530,'no','Utpakking av filer...',0),(487062,13530,'da','Selvudpakkende filer...',0),(487063,13530,'ko','íŒŒì¼ ì¶”ì¶œ...',0),(487064,13530,'he','×—×™×œ×•×¥ ×§×‘×¦×™×...',0),(487065,13530,'el','Î•Î¾Î±Î³Ï‰Î³Î® Î±ÏÏ‡ÎµÎ¯Ï‰Î½...',0),(487066,13530,'zh','æ­£åœ¨è§£åŽ‹ç¼©æ–‡ä»¶...',0),(487067,13530,'sv','Extrahering av filer...',0),(487068,13530,'it','Estrazione dei file...',0),(487069,13530,'tl','',0),(487070,13530,'th','à¹à¸¢à¸à¹à¸Ÿà¹‰à¸¡...',0),(487071,13530,'hi','à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤¨à¤¿à¤•à¤¾à¤²à¤¨à¥‡ à¤•à¥‡...',0),(487072,13530,'ms','Mengekstrak fail...',0),(487073,13530,'ar','Ø§Ø³ØªØ®Ø±Ø§Ø¬ Ø§Ù„Ù…Ù„ÙØ§Øª...',0),(487074,13530,'fr','Extraction des fichiers...',0),(487075,13530,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‚’æŠ½å‡ºã™ã‚‹.',0),(487076,13530,'pt','Extrair arquivos...',0),(487077,13530,'ru','Ð˜Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ðµ Ñ„Ð°Ð¹Ð»Ð¾Ð²...',0),(487078,13530,'es','Extrayendo Files',0),(487079,13530,'de','Extrahieren von Dateien...',0),(487080,13530,'en','Extracting files...',0),(487081,13531,'is','',0),(487082,13531,'dr','Ø¹ØµØ§Ø±Ù‡ Ú©Ø§Ù…Ù„.',0),(487083,13531,'pr','Ø¹ØµØ§Ø±Ù‡ Ú©Ø§Ù…Ù„.',0),(487084,13531,'tr','AyÄ±klama tamamlandÄ±.',0),(487085,13531,'pl','Ekstrakt kompletny.',0),(487086,13531,'bg','Ð•ÐºÑÑ‚Ñ€Ð°ÐºÑ‚ Ð¾Ñ‚ Ð¿ÑŠÐ»Ð½Ð°.',0),(487087,13531,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù…Ú©Ù…Ù„ ÛÛ’ Û”',0),(487088,13531,'sr','Ð˜Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾.',0),(487089,13531,'vi','Chiáº¿t xuáº¥t hoÃ n toÃ n.',0),(487090,13531,'af','Uittreksel voltooi.',0),(487091,13531,'ro','Extras complet.',0),(487092,13531,'et','VÃ¤ljavÃµte tÃ¤ielik.',0),(487093,13531,'si','Ekstrakt popolna.',0),(487094,13531,'ba','Ekstrak lengkap.',0),(487095,13531,'nl','Uittreksel compleet.',0),(487096,13531,'fi','Pura tÃ¤ydellinen.',0),(487097,13531,'no','Ekstra fullstendig.',0),(487098,13531,'da','Ekstrakt komplet.',0),(487099,13531,'ko','ì¶”ì¶œ ì™„ë£Œìž…ë‹ˆë‹¤.',0),(487100,13531,'he','×ª×ž×¦×™×ª ×ž×œ××”.',0),(487101,13531,'el','Î Î»Î®ÏÎµÏ‚ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±.',0),(487102,13531,'zh','å®Œæ•´çš„æå–ç‰©ã€‚',0),(487103,13531,'sv','Extraktet komplett.',0),(487104,13531,'it','Estratto completo.',0),(487105,13531,'tl','',0),(487106,13531,'th','à¸ªà¸²à¸£à¸ªà¸à¸±à¸”à¸—à¸µà¹ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(487107,13531,'hi','à¤¨à¤¿à¤•à¤¾à¤²à¤¨à¥‡ à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤—à¤¯à¤¾à¥¤',0),(487108,13531,'ms','Ekstrak yang lengkap.',0),(487109,13531,'ar','Ø§Ø³ØªØ®Ø±Ø§Ø¬ ÙƒØ§Ù…Ù„Ø©.',0),(487110,13531,'fr','Extrait complet.',0),(487111,13531,'jp','æŠ½å‡ºãŒå®Œäº†ã—ã¾ã™ã€‚',0),(487112,13531,'pt','Extrato completo.',0),(487113,13531,'ru','Ð­ÐºÑÑ‚Ñ€Ð°ÐºÑ‚ Ð¿Ð¾Ð»Ð½Ð¾ÑÑ‚ÑŒÑŽ.',0),(487114,13531,'es','ExtracciÃ³n Completa',0),(487115,13531,'de','Auszug abgeschlossen.',0),(487116,13531,'en','Extract Complete.',0),(487117,13532,'is','',0),(487118,13532,'dr','Ø®ÙˆØ§Ù†Ø¯Ù† ÙØ§ÛŒÙ„ Ø²ÛŒÙ¾ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯!',0),(487119,13532,'pr','Ø®ÙˆØ§Ù†Ø¯Ù† ÙØ§ÛŒÙ„ Ø²ÛŒÙ¾ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯!',0),(487120,13532,'tr','Zip dosyasÄ± okunamadÄ±.',0),(487121,13532,'pl','Nie moÅ¼na odczytaÄ‡ pliku zip!',0),(487122,13532,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ñ‡ÐµÑ‚Ðµ zip Ñ„Ð°Ð¹Ð»!',0),(487123,13532,'ur','Ø²Ù¾ Ù…Ø³Ù„ Ú©Ø§ Ù…Ø·Ø§Ù„Ø¹Û Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛÛ’!',0),(487124,13532,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚Ð¸ Ð·Ð¸Ð¿ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ!',0),(487125,13532,'vi','Tháº¥t báº¡i khi Ä‘á»c tá»‡p zip!',0),(487126,13532,'af','Het misluk om die zip lÃªer lees nie!',0),(487127,13532,'ro','Imposibil de citit fiÅŸierul zip!',0),(487128,13532,'et','Zip faili lugemine nurjus!',0),(487129,13532,'si','Branje zip datoteke ni uspelo!',0),(487130,13532,'ba','Gagal untuk membaca zip file!',0),(487131,13532,'nl','Lezen van zip-bestand is mislukt!',0),(487132,13532,'fi','Zip-tiedoston epÃ¤onnistui.',0),(487133,13532,'no','Kunne ikke lese zip arkiv!',0),(487134,13532,'da','Kunne ikke lÃ¦se zipfil!',0),(487135,13532,'ko','Zip íŒŒì¼ì„ ì½ëŠ” ë° ì‹¤íŒ¨ í–ˆìŠµë‹ˆë‹¤!',0),(487136,13532,'he','×§×¨×™××ª ×§×•×‘×¥ ×”-zip × ×›×©×œ×”!',0),(487137,13532,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· Î±Î½Î¬Î³Î½Ï‰ÏƒÎ· Ï„Î¿Ï… Î±ÏÏ‡ÎµÎ¯Î¿Ï… zip!',0),(487138,13532,'zh','æœªèƒ½è¯»å– zip æ–‡ä»¶ ï¼',0),(487139,13532,'sv','Det gick inte att lÃ¤sa zipfilen!',0),(487140,13532,'it','Impossibile leggere file zip!',0),(487141,13532,'tl','',0),(487142,13532,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸­à¹ˆà¸²à¸™à¹à¸Ÿà¹‰à¸¡ zip',0),(487143,13532,'hi','à¤œà¤¼à¤¿à¤ª à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤ªà¤¢à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾!',0),(487144,13532,'ms','Gagal membaca fail zip!',0),(487145,13532,'ar','ÙØ´Ù„ ÙÙŠ Ù‚Ø±Ø§Ø¡Ø© Ù…Ù„Ù Ù…Ø¶ØºÙˆØ·!',0),(487146,13532,'fr','Impossible de lire le fichier zip !',0),(487147,13532,'jp','Zip ãƒ•ã‚¡ã‚¤ãƒ«ã®èª­ã¿å–ã‚Šã«å¤±æ•—ã—ã¾ã—ãŸã€‚',0),(487148,13532,'pt','Falha ao ler o arquivo zip!',0),(487149,13532,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» zip!',0),(487150,13532,'es','FallÃ³ Leer el file zip',0),(487151,13532,'de','Fehler beim Lesen der Zip-Datei!',0),(487152,13532,'en','Failed to read zip file!',0),(487153,13533,'is','',0),(487154,13533,'dr','Ø³ÙˆØ¯ Ù†Ø§Ø®Ø§Ù„Øµ Ø¯ÙˆØ±Ù‡',0),(487155,13533,'pr','Ø³ÙˆØ¯ Ù†Ø§Ø®Ø§Ù„Øµ Ø¯ÙˆØ±Ù‡',0),(487156,13533,'tr','BrÃ¼t kar dÃ¶nemi',0),(487157,13533,'pl','Okresie zysku brutto',0),(487158,13533,'bg','Ð‘Ñ€ÑƒÑ‚Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(487159,13533,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ù…Ù†Ø§ÙØ¹ Ø¯ÙˆØ±',0),(487160,13533,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð° ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(487161,13533,'vi','Thá»i gian lá»£i nhuáº­n gá»™p',0),(487162,13533,'af','Bruto wins tydperk',0),(487163,13533,'ro','Perioada de Profit brut',0),(487164,13533,'et','Brutokasum perioodi',0),(487165,13533,'si','Bruto dobiÄek obdobja',0),(487166,13533,'ba','Periode laba kotor',0),(487167,13533,'nl','Bruto winst periode',0),(487168,13533,'fi','Bruttovoitto ajan',0),(487169,13533,'no','Bruttofortjeneste periode',0),(487170,13533,'da','Bruttofortjeneste periode',0),(487171,13533,'ko','ì´ ê¸°ê°„',0),(487172,13533,'he','×ª×§×•×¤×ª ×¨×•×•×— ×’×•×œ×ž×™',0),(487173,13533,'el','ÎœÎ¹ÎºÏ„ÏŒ ÎºÎ­ÏÎ´Î¿Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(487174,13533,'zh','æ¯›åˆ©æ¶¦æœŸé—´',0),(487175,13533,'sv','Bruttovinst Period',0),(487176,13533,'it','Utile lordo di periodo',0),(487177,13533,'tl','',0),(487178,13533,'th','à¸à¸³à¹„à¸£à¸‚à¸±à¹‰à¸™à¸•à¹‰à¸™à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²',0),(487179,13533,'hi','à¤¸à¤•à¤² à¤²à¤¾à¤­ à¤…à¤µà¤§à¤¿',0),(487180,13533,'ms','Keuntungan kasar tempoh',0),(487181,13533,'ar','Ø§Ù„ÙØªØ±Ø© Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø±Ø¨Ø­',0),(487182,13533,'fr','PÃ©riode de la marge brute',0),(487183,13533,'jp','å£²ä¸Šç·åˆ©ç›Šã®æœŸé–“',0),(487184,13533,'pt','PerÃ­odo de lucro bruto',0),(487185,13533,'ru','Ð’Ð°Ð»Ð¾Ð²Ð°Ñ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(487186,13533,'es','PerÃ­odo de Utilidad Bruto',0),(487187,13533,'de','Brutto-Ergebnis Zeitraum',0),(487188,13533,'en','Gross Profit Period',0),(487189,13534,'is','',0),(487190,13534,'dr','Ø³ÙˆØ¯ Ù†Ø§Ø®Ø§Ù„Øµ YTD',0),(487191,13534,'pr','Ø³ÙˆØ¯ Ù†Ø§Ø®Ø§Ù„Øµ YTD',0),(487192,13534,'tr','BrÃ¼t kar YTD',0),(487193,13534,'pl','Zysk brutto OPR',0),(487194,13534,'bg','Ð‘Ñ€ÑƒÑ‚Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(487195,13534,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ù…Ù†Ø§ÙØ¹ ÛŒÙ¹Ø¯',0),(487196,13534,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(487197,13534,'vi','Lá»£i nhuáº­n gá»™p YTD',0),(487198,13534,'af','Bruto wins YTD',0),(487199,13534,'ro','Profit brut YTD',0),(487200,13534,'et','Brutokasum YTD',0),(487201,13534,'si','Bruto dobiÄek YTD',0),(487202,13534,'ba','Laba kotor YTD',0),(487203,13534,'nl','Bruto winst YTD',0),(487204,13534,'fi','Bruttovoitto vuoden alusta',0),(487205,13534,'no','Bruttofortjeneste YTD',0),(487206,13534,'da','Bruttofortjeneste Ã…TD',0),(487207,13534,'ko','ë§¤ì¶œ ì´ ì´ìµ ëˆ„ê³„',0),(487208,13534,'he','×¨×•×•×— ×’×•×œ×ž×™ ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(487209,13534,'el','ÎœÎ¹ÎºÏ„ÏŒ ÎºÎ­ÏÎ´Î¿Ï‚ YTD',0),(487210,13534,'zh','æ¯›åˆ©æ¶¦ YTD',0),(487211,13534,'sv','Bruttovinst YTD',0),(487212,13534,'it','Profitto lordo YTD',0),(487213,13534,'tl','',0),(487214,13534,'th','à¸à¸³à¹„à¸£à¸‚à¸±à¹‰à¸™à¸•à¹‰à¸™ YTD',0),(487215,13534,'hi','à¤¸à¤•à¤² à¤²à¤¾à¤­ YTD',0),(487216,13534,'ms','Keuntungan kasar THK',0),(487217,13534,'ar','Ø§Ù„Ø±Ø¨Ø­ Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(487218,13534,'fr','Marge brute CDA',0),(487219,13534,'jp','å£²ä¸Šç·åˆ©ç›Šç´¯è¨ˆ',0),(487220,13534,'pt','Lucro bruto acumulado no ano',0),(487221,13534,'ru','Ð’Ð°Ð»Ð¾Ð²Ð°Ñ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ Ñ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð°',0),(487222,13534,'es','Utilidad Bruto AÃ±o a la Fecha',0),(487223,13534,'de','Rohertrag YTD',0),(487224,13534,'en','Gross Profit YTD',0),(487225,13535,'is','',0),(487226,13535,'dr','.htacess Ù†ÙˆØ´ØªÙ† Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯!',0),(487227,13535,'pr','.htacess Ù†ÙˆØ´ØªÙ† Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯!',0),(487228,13535,'tr','.Htacess yazma baÅŸarÄ±sÄ±z oldu!',0),(487229,13535,'pl','.htacess zapis nie powiÃ³dÅ‚ siÄ™!',0),(487230,13535,'bg','.htacess Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð²Ð°Ð»Ð¸!',0),(487231,13535,'ur','.htacess Ù„Ú©Ú¾Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…!',0),(487232,13535,'sr','.Ñ…Ñ‚Ð°Ñ†ÐµÑÑ ÑƒÐ¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾!',0),(487233,13535,'vi','.htacess viáº¿t tháº¥t báº¡i!',0),(487234,13535,'af','.htacess skryf het misluk!',0),(487235,13535,'ro','.htacess scrie nu a reuÅŸit!',0),(487236,13535,'et','.htacess kirjutamine nurjus!',0),(487237,13535,'si','.htacess pisanje ni uspelo!',0),(487238,13535,'ba','menulis .htacess gagal!',0),(487239,13535,'nl','.htacess schrijfbewerkingen zijn mislukt!',0),(487240,13535,'fi','.htacess kirjoitus epÃ¤onnistui!',0),(487241,13535,'no','.Htacess skriving mislyktes!',0),(487242,13535,'da','.Htacess Skriv mislykkedes!',0),(487243,13535,'ko','.htacess ì“°ê¸° ì‹¤íŒ¨!',0),(487244,13535,'he','.htacess ×›×ª×™×‘×” × ×›×©×œ×”!',0),(487245,13535,'el','.htacess ÎµÎ³Î³ÏÎ±Ï†Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ!',0),(487246,13535,'zh','.htacess å†™å…¥å¤±è´¥ ï¼',0),(487247,13535,'sv','.Htacess skrivning misslyckades!',0),(487248,13535,'it','Scrivi .htacess Impossibile!',0),(487249,13535,'tl','',0),(487250,13535,'th','à¹€à¸‚à¸µà¸¢à¸™.htacess à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(487251,13535,'hi','.htacess à¤²à¤¿à¤–à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤²!',0),(487252,13535,'ms','.Htacess tulis gagal!',0),(487253,13535,'ar','ÙØ´Ù„Øª Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ÙƒØªØ§Ø¨Ø©.htacess!',0),(487254,13535,'fr','.htacess Ã©criture a Ã©chouÃ© !',0),(487255,13535,'jp','.htacess ã®æ›¸ãè¾¼ã¿ã«å¤±æ•—ã—ã¾ã—ãŸ ï¼',0),(487256,13535,'pt','htacess gravaÃ§Ã£o falhada!',0),(487257,13535,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸ .htacess!',0),(487258,13535,'es','Escrito de .htaccess se fallÃ³',0),(487259,13535,'de','.htaccess schreiben fehlgeschlagen!',0),(487260,13535,'en','.htacess write failed!',0),(487261,13536,'is','',0),(487262,13536,'dr','Ù†ÙˆØ´ØªÙ† Ø´Ø§Ø®Øµ Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯!',0),(487263,13536,'pr','Ù†ÙˆØ´ØªÙ† Ø´Ø§Ø®Øµ Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯!',0),(487264,13536,'tr','Dizin yazma baÅŸarÄ±sÄ±z oldu!',0),(487265,13536,'pl','Indeks zapis nie powiÃ³dÅ‚ siÄ™!',0),(487266,13536,'bg','Ð˜Ð½Ð´ÐµÐºÑ ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾!',0),(487267,13536,'ur','Ø§Ø´Ø§Ø±ÛŒÛ Ù„Ú©Ú¾Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…!',0),(487268,13536,'sr','Ð˜Ð½Ð´ÐµÐºÑ ÑƒÐ¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾!',0),(487269,13536,'vi','Chá»‰ sá»‘ viáº¿t tháº¥t báº¡i!',0),(487270,13536,'af','Indeks skryf het misluk!',0),(487271,13536,'ro','Indicele scrie nu a reuÅŸit!',0),(487272,13536,'et','Indeksi kirjutamine nurjus!',0),(487273,13536,'si','Indeks pisanje ni uspelo!',0),(487274,13536,'ba','Write indeks gagal!',0),(487275,13536,'nl','Index schrijfbewerkingen zijn mislukt!',0),(487276,13536,'fi','Indeksi kirjoitus epÃ¤onnistui!',0),(487277,13536,'no','Indeks skrivefeil!',0),(487278,13536,'da','Indeks skrivningen mislykkedes!',0),(487279,13536,'ko','ì¸ë±ìŠ¤ ì“°ê¸° ì‹¤íŒ¨!',0),(487280,13536,'he','××™× ×“×§×¡ ×›×ª×™×‘×” × ×›×©×œ×”!',0),(487281,13536,'el','Î”ÎµÎ¯ÎºÏ„Î·Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ!',0),(487282,13536,'zh','ç´¢å¼•å†™å…¥å¤±è´¥ ï¼',0),(487283,13536,'sv','Index skrivning misslyckades!',0),(487284,13536,'it','Scrivi indice Impossibile!',0),(487285,13536,'tl','',0),(487286,13536,'th','à¸”à¸±à¸Šà¸™à¸µà¸à¸²à¸£à¹€à¸‚à¸µà¸¢à¸™à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(487287,13536,'hi','à¤…à¤¨à¥à¤•à¥à¤°à¤®à¤£à¤¿à¤•à¤¾ à¤²à¤¿à¤–à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤²!',0),(487288,13536,'ms','Indeks tulis gagal!',0),(487289,13536,'ar','ÙØ´Ù„ Ù…Ø¤Ø´Ø± Ø§Ù„ÙƒØªØ§Ø¨Ø©!',0),(487290,13536,'fr','Ã‰criture d\'index a Ã©chouÃ© !',0),(487291,13536,'jp','ã‚¤ãƒ³ãƒ‡ãƒƒã‚¯ã‚¹ã®æ›¸ãè¾¼ã¿ã«å¤±æ•—ã—ã¾ã—ãŸ ï¼',0),(487292,13536,'pt','Ãndice de gravaÃ§Ã£o falhada!',0),(487293,13536,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¸Ð½Ð´ÐµÐºÑÐ°!',0),(487294,13536,'es','Escribir el Indice FallÃ³',0),(487295,13536,'de','Index schreiben fehlgeschlagen!',0),(487296,13536,'en','Index write failed!',0),(487297,13537,'is','',0),(487298,13537,'dr','Ø¯Ø± Ù†ÙˆØ´ØªÙ† Ù¾Ø³ØªÛŒ Ù†Ø´Ø¯!',0),(487299,13537,'pr','Ø¯Ø± Ù†ÙˆØ´ØªÙ† Ù¾Ø³ØªÛŒ Ù†Ø´Ø¯!',0),(487300,13537,'tr','ZIP yazma baÅŸarÄ±sÄ±z!',0),(487301,13537,'pl','W zip zapis nie powiÃ³dÅ‚ siÄ™!',0),(487302,13537,'bg','Ð’ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ Ð·Ð°Ð¿Ð¸Ñ Ð½Ðµ ÑƒÑÐ¿Ñ!',0),(487303,13537,'ur','Ø²Ù¾ Ú©ÛŒ ØªØ­Ø±ÛŒØ± Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…!',0),(487304,13537,'sr','Ð£ Ð·Ð¸Ð¿ ÑƒÐ¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾!',0),(487305,13537,'vi','Trong sá»‘ zip viáº¿t tháº¥t báº¡i!',0),(487306,13537,'af','In zip skryf het misluk!',0),(487307,13537,'ro','ÃŽn zip scrie nu a reuÅŸit!',0),(487308,13537,'et','Zip kirjutamine nurjus!',0),(487309,13537,'si','V zip pisanje ni uspelo!',0),(487310,13537,'ba','Dalam menulis zip gagal!',0),(487311,13537,'nl','In zip schrijfbewerkingen zijn mislukt!',0),(487312,13537,'fi','Zip kirjoittaa epÃ¤onnistui!',0),(487313,13537,'no','I zip skriving mislyktes!',0),(487314,13537,'da','I zip skriver mislykkedes!',0),(487315,13537,'ko','ìš°íŽ¸ ì“°ê¸°ì— ì‹¤íŒ¨ í–ˆìŠµë‹ˆë‹¤!',0),(487316,13537,'he','×‘- zip ×›×ª×™×‘×” × ×›×©×œ×”!',0),(487317,13537,'el','Î£Îµ zip ÎµÎ³Î³ÏÎ±Ï†Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ!',0),(487318,13537,'zh','åœ¨ zip å†™å…¥å¤±è´¥ ï¼',0),(487319,13537,'sv','I zip skrivning misslyckades!',0),(487320,13537,'it','Nella scrittura di zip fallito!',0),(487321,13537,'tl','',0),(487322,13537,'th','à¹ƒà¸™à¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œà¹€à¸‚à¸µà¸¢à¸™à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(487323,13537,'hi','à¤œà¤¼à¤¿à¤ª à¤®à¥‡à¤‚ à¤²à¤¿à¤–à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤²!',0),(487324,13537,'ms','Zip tulis gagal!',0),(487325,13537,'ar','ÙØ´Ù„ ÙÙŠ ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ!',0),(487326,13537,'fr','Dans le zip Ã©criture a Ã©chouÃ© !',0),(487327,13537,'jp','Zip ã®æ›¸ãè¾¼ã¿ã«å¤±æ•—ã—ã¾ã—ãŸ!',0),(487328,13537,'pt','Em zip gravaÃ§Ã£o falhada!',0),(487329,13537,'ru','Ð’ Ð¾ÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸ zip!',0),(487330,13537,'es','Escribir en Zip FallÃ³',0),(487331,13537,'de','In Zip schreiben fehlgeschlagen!',0),(487332,13537,'en','In zip write failed!',0),(487333,13538,'is','',0),(487334,13538,'dr','Ù…Ù† Authorize NolaPro Ø¨Ù‡ Ø§ØªÙ‡Ø§Ù… Ù…Ù† Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡.',0),(487335,13538,'pr','Ù…Ù† Authorize NolaPro Ø¨Ù‡ Ø§ØªÙ‡Ø§Ù… Ù…Ù† Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡.',0),(487336,13538,'tr','Ben benim Ã¶deme yÃ¶ntemi bu iÅŸlem iÃ§in dosya Ã¼zerinde ÅŸarj Authorize NolaPro.',0),(487337,13538,'pl','I Autoryzuj NolaPro za moje pÅ‚atnoÅ›ci na plik dla tej transakcji.',0),(487338,13538,'bg','ÐÐ· Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÑ‚Ðµ NolaPro Ð´Ð° Ð¾Ñ‚Ð³Ð¾Ð²Ð°Ñ€Ñ Ð¼ÐµÑ‚Ð¾Ð´ÑŠÑ‚ Ð¼Ð¸ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð» Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ.',0),(487339,13538,'ur','Ù…ÛŒÚº Authorize Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ù…ÛŒØ±ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± Ù¾Ø± Ù…Ø³Ù„ Ø§Ø³ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ù„Ø¦Û’ Ú†Ø§Ø±Ø¬ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’.',0),(487340,13538,'sr','ÐˆÐ° ÐÑƒÑ‚Ñ…Ð¾Ñ€Ð¸Ð·Ðµ ÐÐ¾Ð»Ð°ÐŸÑ€Ð¾ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð¼Ð¾Ñ˜ Ð½Ð°Ñ‡Ð¸Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸ Ð·Ð° Ð¾Ð²Ñƒ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ñƒ.',0),(487341,13538,'vi','TÃ´i Authorize NolaPro tÃ­nh phÃ­ cá»§a tÃ´i Ä‘á»ƒ thanh toÃ¡n cÃ¡c há»“ sÆ¡ cho giao dá»‹ch nÃ y.',0),(487342,13538,'af','Ek magtig NolaPro te hef my betaling metode op lÃªer vir hierdie transaksie.',0),(487343,13538,'ro','Am NolaPro de autorizare a percepe metoda mea de platÄƒ pe dosar pentru aceastÄƒ tranzacÅ£ie.',0),(487344,13538,'et','Ma Authorize NolaPro kÃ¼sida minu faili selle kande makseviis.',0),(487345,13538,'si','Sem pooblasti NolaPro zaraÄunati svoj naÄin plaÄila na datoteko za ta posel.',0),(487346,13538,'ba','Aku NolaPro Authorize untuk mengisi metode pembayaran saya pada file untuk transaksi ini.',0),(487347,13538,'nl','Ik machtigen NolaPro te laden mijn betalingsmethode op bestand voor deze transactie.',0),(487348,13538,'fi','I Valtuuta NolaPro veloittaa valitsemaani maksuvÃ¤linettÃ¤ tiedosto tÃ¤mÃ¤n tapahtuman.',0),(487349,13538,'no','I Godkjenn NolaPro Ã¥ belaste min betalingsmÃ¥te pÃ¥ filen for denne transaksjonen.',0),(487350,13538,'da','Jeg Godkend NolaPro at oplade min betalingsmetode pÃ¥ filen for denne transaktion.',0),(487351,13538,'ko','ë‚˜ ê¶Œí•œ ë¶€ì—¬ NolaPro íŒŒì¼ì—ì´ ê±°ëž˜ì— ëŒ€ í•œ ë‚´ ê²°ì œë¥¼ ì²­êµ¬ í•©ë‹ˆë‹¤.',0),(487352,13538,'he','×× ×™ NolaPro ×œ×ž×•×¢×“×™× ×œ×—×™×™×‘ ××ª ×©×™×˜×ª ×”×ª×©×œ×•× ×©×œ×™ ×¢×œ ×§×•×‘×¥ ×¢×‘×•×¨ ×˜×¨× ×–×§×¦×™×” ×–×•...',0),(487353,13538,'el','Î•Î³ÏŽ NolaPro ÎµÎ¾Î¿Ï…ÏƒÎ¹Î¿Î´ÏŒÏ„Î·ÏƒÎ·, Î½Î± Ï‡ÏÎµÏŽÏƒÎµÏ„Îµ Ï„Î· Î¼Î­Î¸Î¿Î´Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î¼Î¿Ï… ÏƒÏ„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î³Î¹Î± Ï„Î· ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î· ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®.',0),(487354,13538,'zh','æˆ‘æŽˆæƒ NolaPro è´£æˆæˆ‘ä¸ºè¿™å®—äº¤æ˜“çš„æ–‡ä»¶ä¸Šçš„ä»˜æ¬¾æ–¹æ³•ã€‚',0),(487355,13538,'sv','I auktorisera NolaPro att ladda min betalningsmetod pÃ¥ filen fÃ¶r den hÃ¤r transaktionen.',0),(487356,13538,'it','I Authorize NolaPro per caricare il mio metodo di pagamento su file per questa transazione.',0),(487357,13538,'tl','',0),(487358,13538,'th','à¸‰à¸±à¸™ NolaPro Authorize à¸›à¸£à¸°à¸ˆà¸¸à¸‚à¸­à¸‡à¸‰à¸±à¸™à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸™à¹„à¸Ÿà¸¥à¹Œà¸ªà¸³à¸«à¸£à¸±à¸šà¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸™à¸µà¹‰',0),(487359,13538,'hi','à¤®à¥ˆà¤‚ à¤‡à¤¸ à¤¸à¥Œà¤¦à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¤° à¤…à¤ªà¤¨à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¦à¥à¤§à¤¤à¤¿ à¤•à¥‹ à¤šà¤¾à¤°à¥à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤§à¤¿à¤•à¥ƒà¤¤ NolaProà¥¤',0),(487360,13538,'ms','Saya NolaPro Authorize untuk mengenakan saya kaedah pembayaran pada fail untuk transaksi ini.',0),(487361,13538,'ar','Ø£Ù†Ø§ Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ ØªØ®ÙˆÙŠÙ„ Ù„ØªÙˆØ¬ÙŠÙ‡ Ø§Ù„Ø§ØªÙ‡Ø§Ù… Ù„ÙŠ Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹ ÙÙŠ Ø§Ù„Ù…Ù„Ù Ù„Ù‡Ø°Ù‡ Ø§Ù„Ø­Ø±ÙƒØ©.',0),(487362,13538,'fr','J\'ai NolaPro autoriser Ã  prÃ©lever mon dossier pour cette transaction.',0),(487363,13538,'jp','ç§ã¯ã“ã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã®ãŸã‚ã«ç§ã®ãŠæ”¯æ‰•æ–¹æ³•ã‚’è«‹æ±‚ã™ã‚‹æ‰¿èª NolaProã€‚',0),(487364,13538,'pt','Eu autorizar NolaPro cobrar meu mÃ©todo de pagamento em arquivo para esta transaÃ§Ã£o.',0),(487365,13538,'ru','Ð¯ Ð°Ð²Ñ‚Ð¾Ñ€Ð¸Ð·Ð¾Ð²Ð°Ñ‚ÑŒ NolaPro Ð´Ð»Ñ Ð·Ð°Ñ€ÑÐ´ÐºÐ¸ Ð¼Ð¾ÐµÐ³Ð¾ Ð¼ÐµÑ‚Ð¾Ð´Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð½Ð° Ñ„Ð°Ð¹Ð» Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸.',0),(487366,13538,'es','Autorizo a NolaPro cargar mi mÃ©todo de pago archivado para esta transacciÃ³n',0),(487367,13538,'de','Ich autorisieren Artikel auf meine Zahlungsmethode auf Datei fÃ¼r diese Transaktion.',0),(487368,13538,'en','I Authorize NolaPro to charge my payment method on file for this transaction.',0),(487369,13539,'is','',0),(487370,13539,'dr','Ø¶Ø±Ø¨',0),(487371,13539,'pr','Ø¶Ø±Ø¨',0),(487372,13539,'tr','Ã‡arpma',0),(487373,13539,'pl','PomnoÅ¼yÄ‡',0),(487374,13539,'bg','Ð£Ð¼Ð½Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(487375,13539,'ur','Ø¶Ø±Ø¨',0),(487376,13539,'sr','ÐœÐ½Ð¾Ð¶ÐµÑšÐµ',0),(487377,13539,'vi','NhÃ¢n',0),(487378,13539,'af','Vermenigvuldig',0),(487379,13539,'ro','Multiplica',0),(487380,13539,'et','Korruta',0),(487381,13539,'si','PomnoÅ¾ite',0),(487382,13539,'ba','Kalikan',0),(487383,13539,'nl','Vermenigvuldigen',0),(487384,13539,'fi','Kerrotaan',0),(487385,13539,'no','Multiplisere',0),(487386,13539,'da','Formere sig',0),(487387,13539,'ko','ê³±í•˜ê¸°',0),(487388,13539,'he','×”×›×¤×œ',0),(487389,13539,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î¬Î¶Î¿Î½Ï„Î±Î¹',0),(487390,13539,'zh','ç¹æ®–',0),(487391,13539,'sv','Multiplicera',0),(487392,13539,'it','Moltiplicare',0),(487393,13539,'tl','',0),(487394,13539,'th','à¸„à¸¹à¸“',0),(487395,13539,'hi','à¤—à¥à¤£à¤¾ à¤•à¤°à¥‡à¤‚',0),(487396,13539,'ms','Membiak',0),(487397,13539,'ar','Ø¶Ø±Ø¨',0),(487398,13539,'fr','Multiplier',0),(487399,13539,'jp','ä¹—ç®—',0),(487400,13539,'pt','Multiplicar',0),(487401,13539,'ru','Ð£Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚ÑŒ',0),(487402,13539,'es','Multiplicar',0),(487403,13539,'de','Multiplizieren',0),(487404,13539,'en','Multiply',0),(487405,13540,'is','',0),(487406,13540,'dr','ØªÙ…Ø§Ù… Ù…Ù‚Ø§Ø¯ÛŒØ± ØªÙˆØ³Ø· Ø¶Ø±Ø¨',0),(487407,13540,'pr','ØªÙ…Ø§Ù… Ù…Ù‚Ø§Ø¯ÛŒØ± ØªÙˆØ³Ø· Ø¶Ø±Ø¨',0),(487408,13540,'tr','TÃ¼m miktarlar ile Ã§arpÄ±n',0),(487409,13540,'pl','NaleÅ¼y pomnoÅ¼yÄ‡ wszystkie iloÅ›ci przez',0),(487410,13540,'bg','Ð£Ð¼Ð½Ð¾Ð¶Ð°Ð²Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð¾Ñ‚',0),(487411,13540,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªÙ…Ø§Ù… Ù…Ù‚Ø¯Ø§Ø±ÛŒÚº Ø¶Ø±Ø¨',0),(487412,13540,'sr','ÐŸÐ¾Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚Ðµ ÑÐ²Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ Ð¿Ð¾',0),(487413,13540,'vi','NhÃ¢n vá»›i sá»‘ lÆ°á»£ng táº¥t cáº£ bá»Ÿi',0),(487414,13540,'af','Vermenigvuldig Alle Hoeveelhede deur',0),(487415,13540,'ro','Multiplica tuturor cantitÄƒÅ£ilor de',0),(487416,13540,'et','Korrutab kÃµik kogused',0),(487417,13540,'si','PomnoÅ¾ite vse koliÄine, ki jih',0),(487418,13540,'ba','Kalikan semua jumlah oleh',0),(487419,13540,'nl','Alle hoeveelheden door vermenigvuldigen',0),(487420,13540,'fi','Kerro kaikki mÃ¤Ã¤rÃ¤t',0),(487421,13540,'no','Multipliser alle mengder av',0),(487422,13540,'da','Multiplicer alle mÃ¦ngder af',0),(487423,13540,'ko','ë²ˆ ì‹ì— ì˜í•´ ëª¨ë“  ìˆ˜ëŸ‰',0),(487424,13540,'he','×œ×”×›×¤×™×œ ××ª ×›×œ ×”×›×ž×•×™×•×ª ×¢×œ ×™×“×™',0),(487425,13540,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î¬Î¶Î¿Î½Ï„Î±Î¹ ÏŒÎ»ÎµÏ‚ Î¿Î¹ Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚ Î±Ï€ÏŒ',0),(487426,13540,'zh','ç¹æ®–æ‰€æœ‰çš„æ•°é‡',0),(487427,13540,'sv','Multiplicera alla kvantiteter av',0),(487428,13540,'it','Moltiplicare tutti i quantitativi di',0),(487429,13540,'tl','',0),(487430,13540,'th','à¸„à¸¹à¸“à¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¹‚à¸”à¸¢',0),(487431,13540,'hi','à¤¸à¤­à¥€ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤—à¥à¤£à¤¾',0),(487432,13540,'ms','Membiak semua kuantiti oleh',0),(487433,13540,'ar','Ø§Ø¶Ø±Ø¨ ÙƒÙ„ Ø§Ù„ÙƒÙ…ÙŠØ§Øª Ø§Ù„ØªÙŠ',0),(487434,13540,'fr','Multiplier toutes les quantitÃ©s de',0),(487435,13540,'jp','ã«ã‚ˆã£ã¦ã™ã¹ã¦ã®æ•°é‡ã‚’ä¹—ç®—ã—ã¾ã™ã€‚',0),(487436,13540,'pt','Multiplicar as quantidades por',0),(487437,13540,'ru','Ð£Ð¼Ð½Ð¾Ð¶Ð¸Ñ‚ÑŒ Ð²ÑÐµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð¿Ð¾',0),(487438,13540,'es','Multiplicar Todas Las Cantidades Por',0),(487439,13540,'de','Multiplizieren Sie alle Mengen von',0),(487440,13540,'en','Multiply All Quantities By',0),(487441,13541,'is','',0),(487442,13541,'dr','Ø¯Ø±Ø¢Ù…Ø¯ Ø®Ø§Ù„Øµ Ø¯ÙˆØ±Ù‡',0),(487443,13541,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ø®Ø§Ù„Øµ Ø¯ÙˆØ±Ù‡',0),(487444,13541,'tr','DÃ¶nem net gelir',0),(487445,13541,'pl','DochÃ³d netto okresu',0),(487446,13541,'bg','ÐÐµÑ‚ÐµÐ½ Ð´Ð¾Ñ…Ð¾Ð´ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(487447,13541,'ur','Ø®Ø§Ù„Øµ Ø¢Ù…Ø¯Ù†ÛŒ Ú©ÛŒ Ù…Ø¯Øª',0),(487448,13541,'sr','ÐÐµÑ‚Ð¾ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(487449,13541,'vi','Thá»i gian thu nháº­p rÃ²ng',0),(487450,13541,'af','Netto inkomste tydperk',0),(487451,13541,'ro','Venitul net perioada',0),(487452,13541,'et','Puhaskasum perioodi',0),(487453,13541,'si','Obdobju neto dohodek',0),(487454,13541,'ba','Laba periode',0),(487455,13541,'nl','Netto-inkomsten periode',0),(487456,13541,'fi','Tilikauden voitto kauden',0),(487457,13541,'no','Nettoinntekt periode',0),(487458,13541,'da','Nettoindkomst periode',0),(487459,13541,'ko','ë‹¹ê¸° ìˆœì´ìµ ê¸°ê°„',0),(487460,13541,'he','×”×›× ×¡×” × ×˜×• ×œ×ª×§×•×¤×”',0),(487461,13541,'el','ÎšÎ±Î¸Î±ÏÎ¬ ÎºÎ­ÏÎ´Î· Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…',0),(487462,13541,'zh','å‡€æ”¶ç›ŠæœŸ',0),(487463,13541,'sv','NettointÃ¤kter Period',0),(487464,13541,'it','Utile netto di periodo',0),(487465,13541,'tl','',0),(487466,13541,'th','à¸à¸³à¹„à¸£à¸ªà¸¸à¸—à¸˜à¸´à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²',0),(487467,13541,'hi','à¤¶à¥à¤¦à¥à¤§ à¤†à¤¯ à¤•à¥€ à¤…à¤µà¤§à¤¿',0),(487468,13541,'ms','Tempoh pendapatan bersih',0),(487469,13541,'ar','ØµØ§ÙÙŠ Ø¯Ø®Ù„ Ø§Ù„ÙØªØ±Ø©',0),(487470,13541,'fr','PÃ©riode du revenu net',0),(487471,13541,'jp','å½“æœŸç´”åˆ©ç›Šã®æœŸé–“',0),(487472,13541,'pt','PerÃ­odo de lucro lÃ­quido',0),(487473,13541,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´ Ñ‡Ð¸ÑÑ‚Ñ‹Ð¹ Ð´Ð¾Ñ…Ð¾Ð´',0),(487474,13541,'es','Ingreso Neto Por El PerÃ­odo',0),(487475,13541,'de','Ergebnis Zeitraum',0),(487476,13541,'en','Net Income Period',0),(487477,13542,'is','',0),(487478,13542,'dr','Ø¯Ø±Ø¢Ù…Ø¯ Ø®Ø§Ù„Øµ YTD',0),(487479,13542,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ø®Ø§Ù„Øµ YTD',0),(487480,13542,'tr','Net gelir YTD',0),(487481,13542,'pl','DochÃ³d netto OPR',0),(487482,13542,'bg','ÐÐµÑ‚ÐµÐ½ Ð´Ð¾Ñ…Ð¾Ð´ Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(487483,13542,'ur','Ø®Ø§Ù„Øµ Ø¢Ù…Ø¯Ù†ÛŒ ÛŒÙ¹Ø¯',0),(487484,13542,'sr','ÐÐµÑ‚Ð¾ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´ Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(487485,13542,'vi','Thu nháº­p rÃ²ng YTD',0),(487486,13542,'af','Netto inkomste YTD',0),(487487,13542,'ro','Venitul net YTD',0),(487488,13542,'et','Puhastulu YTD',0),(487489,13542,'si','Neto dohodek YTD',0),(487490,13542,'ba','Laba bersih YTD',0),(487491,13542,'nl','Netto-inkomen YTD',0),(487492,13542,'fi','Nettotulos vuoden alusta',0),(487493,13542,'no','Nettoinntekt YTD',0),(487494,13542,'da','Nettoindkomst Ã…TD',0),(487495,13542,'ko','ë‹¹ê¸° ìˆœì´ìµ YTD',0),(487496,13542,'he','×”×›× ×¡×” × ×˜×• ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(487497,13542,'el','ÎšÎ±Î¸Î±ÏÏŒ ÎµÎ¹ÏƒÏŒÎ´Î·Î¼Î± YTD',0),(487498,13542,'zh','YTD çš„å‡€æ”¶å…¥',0),(487499,13542,'sv','NettointÃ¤kter YTD',0),(487500,13542,'it','Reddito netto YTD',0),(487501,13542,'tl','',0),(487502,13542,'th','à¸à¸³à¹„à¸£à¸ªà¸¸à¸—à¸˜à¸´ YTD',0),(487503,13542,'hi','à¤¶à¥à¤¦à¥à¤§ à¤†à¤¯ YTD',0),(487504,13542,'ms','Pendapatan bersih THK',0),(487505,13542,'ar','ØµØ§ÙÙŠ Ø§Ù„Ø¯Ø®Ù„ Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(487506,13542,'fr','BÃ©nÃ©fice net de CDA',0),(487507,13542,'jp','å½“æœŸç´”åˆ©ç›Šç´¯è¨ˆ',0),(487508,13542,'pt','Lucro lÃ­quido acumulado no ano',0),(487509,13542,'ru','Ð§Ð¸ÑÑ‚Ñ‹Ð¹ Ð´Ð¾Ñ…Ð¾Ð´ Ñ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð°',0),(487510,13542,'es','Ingreso Neto AÃ±o a la Fecha',0),(487511,13542,'de','JahresÃ¼berschuss YTD',0),(487512,13542,'en','Net Income YTD',0),(487513,13543,'is','',0),(487514,13543,'dr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ Ø³ÙˆØ¯ Ø¹Ù…Ù„ÛŒØ§ØªÛŒ',0),(487515,13543,'pr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ Ø³ÙˆØ¯ Ø¹Ù…Ù„ÛŒØ§ØªÛŒ',0),(487516,13543,'tr','Faaliyet kar dÃ¶nemi',0),(487517,13543,'pl','Okres zysku operacyjnego',0),(487518,13543,'bg','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(487519,13543,'ur','Ø¢Ù¾Ø±ÛŒÙ¹Ù†Ú¯ Ù…Ù†Ø§ÙØ¹ Ø¯ÙˆØ±',0),(487520,13543,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ð¸ ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(487521,13543,'vi','Hoáº¡t Ä‘á»™ng thá»i gian lá»£i nhuáº­n',0),(487522,13543,'af','Bedryfstelsel wins tydperk',0),(487523,13543,'ro','Profitul perioadei de exploatare',0),(487524,13543,'et','Tegutsevad kasumi perioodi',0),(487525,13543,'si','Obdobju obratovanja dobiÄek',0),(487526,13543,'ba','Periode laba operasi',0),(487527,13543,'nl','Operationele winst periode',0),(487528,13543,'fi','Voitto toimintakauden',0),(487529,13543,'no','Drift fortjeneste periode',0),(487530,13543,'da','Opererer Profit periode',0),(487531,13543,'ko','ìš´ì˜ ì´ìµ ê¸°ê°„',0),(487532,13543,'he','×ª×§×•×¤×ª ×¨×•×•×— ×”×¤×¢×œ×”',0),(487533,13543,'el','ÎšÎ­ÏÎ´Î¿Ï‚ Ï€ÎµÏÎ¯Î¿Î´Î¿Ï‚ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±Ï‚',0),(487534,13543,'zh','ç»è¥ç›ˆåˆ©æœŸ',0),(487535,13543,'sv','Vinst verksamhetsperiod',0),(487536,13543,'it','Periodo di profitto operativo',0),(487537,13543,'tl','',0),(487538,13543,'th','à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸”à¸³à¹€à¸™à¸´à¸™à¸‡à¸²à¸™à¸à¸³à¹„à¸£',0),(487539,13543,'hi','à¤ªà¤°à¤¿à¤šà¤¾à¤²à¤¨ à¤²à¤¾à¤­ à¤…à¤µà¤§à¤¿',0),(487540,13543,'ms','Operasi keuntungan tempoh',0),(487541,13543,'ar','Ø§Ù„ÙØªØ±Ø© Ø±Ø¨Ø­ Ø§Ù„ØªØ´ØºÙŠÙ„',0),(487542,13543,'fr','PÃ©riode de bÃ©nÃ©fice d\'exploitation',0),(487543,13543,'jp','å–¶æ¥­åˆ©ç›Šã®æœŸé–“',0),(487544,13543,'pt','PerÃ­odo de lucro operacional',0),(487545,13543,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´ ÑÐºÑÐ¿Ð»ÑƒÐ°Ñ‚Ð°Ñ†Ð¸Ð¸ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ',0),(487546,13543,'es','PerÃ­odo de Utilidades Operacionales',0),(487547,13543,'de','Operatives Ergebnis Zeitraum',0),(487548,13543,'en','Operating Profit Period',0),(487549,13544,'is','',0),(487550,13544,'dr','Ø³ÙˆØ¯ Ø¹Ù…Ù„ÛŒØ§ØªÛŒ YTD',0),(487551,13544,'pr','Ø³ÙˆØ¯ Ø¹Ù…Ù„ÛŒØ§ØªÛŒ YTD',0),(487552,13544,'tr','Faaliyet karÄ± YTD',0),(487553,13544,'pl','Zysk operacyjny OPR',0),(487554,13544,'bg','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(487555,13544,'ur','Ø¢Ù¾Ø±ÛŒÙ¹Ù†Ú¯ Ù…Ù†Ø§ÙØ¹ ÛŒÙ¹Ø¯',0),(487556,13544,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ‚Ð¸Ð²Ð½Ð¸ ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚ Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(487557,13544,'vi','Lá»£i nhuáº­n hoáº¡t Ä‘á»™ng YTD',0),(487558,13544,'af','Bedryfswins YTD',0),(487559,13544,'ro','Operare Profit YTD',0),(487560,13544,'et','Ã„rikasum YTD',0),(487561,13544,'si','Poslovni izid YTD',0),(487562,13544,'ba','Laba operasi YTD',0),(487563,13544,'nl','Bedrijfsresultaat YTD',0),(487564,13544,'fi','Liikevoitto vuoden alusta',0),(487565,13544,'no','Driftsresultat YTD',0),(487566,13544,'da','Driftsoverskud Ã…TD',0),(487567,13544,'ko','ì˜ì—… ì´ìµ ëˆ„ê³„',0),(487568,13544,'he','×”×¨×•×•×— ×”×ª×¤×¢×•×œ×™ ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(487569,13544,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¹ÎºÎ¬ ÎºÎ­ÏÎ´Î· YTD',0),(487570,13544,'zh','æœ¬å¹´çš„è¥ä¸šåˆ©æ¶¦',0),(487571,13544,'sv','RÃ¶relseresultat YTD',0),(487572,13544,'it','Utile operativo YTD',0),(487573,13544,'tl','',0),(487574,13544,'th','à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸‡à¸²à¸™à¸à¸³à¹„à¸£ YTD',0),(487575,13544,'hi','à¤¸à¤‚à¤šà¤¾à¤²à¤¨ à¤²à¤¾à¤­ YTD',0),(487576,13544,'ms','Keuntungan operasi THK',0),(487577,13544,'ar','Ø£Ø±Ø¨Ø§Ø­ Ø§Ù„ØªØ´ØºÙŠÙ„ Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø¹Ø§Ù…',0),(487578,13544,'fr','BÃ©nÃ©fice d\'exploitation depuis un an',0),(487579,13544,'jp','å–¶æ¥­åˆ©ç›Šç´¯è¨ˆ',0),(487580,13544,'pt','Lucro operacional acumulado no ano',0),(487581,13544,'ru','ÐžÐ¿ÐµÑ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð°Ñ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ Ð·Ð° Ð³Ð¾Ð´',0),(487582,13544,'es','Utilidades Operacionales de AÃ±o a la Fecha',0),(487583,13544,'de','Betriebsgewinn YTD',0),(487584,13544,'en','Operating Profit YTD',0),(487585,13545,'is','',0),(487586,13545,'dr','Ù„Ø·ÙØ§ Ø³Ø·Ø­ Ø¯Ø³ØªØ±Ø³ÛŒ 755',0),(487587,13545,'pr','Ù„Ø·ÙØ§ Ø³Ø·Ø­ Ø¯Ø³ØªØ±Ø³ÛŒ 755',0),(487588,13545,'tr','Chmod 755 lÃ¼tfen',0),(487589,13545,'pl','ProszÄ™ 755 chmod',0),(487590,13545,'bg','755 chmod, Ð¼Ð¾Ð»Ñ',0),(487591,13545,'ur','755 Ú†Ù… Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ',0),(487592,13545,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ 755 Ñ†Ñ…Ð¼Ð¾Ð´',0),(487593,13545,'vi','Xin vui lÃ²ng 755 chmod',0),(487594,13545,'af','Asseblief 755 chmod',0),(487595,13545,'ro','VÄƒ rugÄƒm sÄƒ 755 chmod',0),(487596,13545,'et','Palun 755 chmod',0),(487597,13545,'si','Prosim 755 chmod',0),(487598,13545,'ba','Silahkan 755 chmod',0),(487599,13545,'nl','Gelieve chmod 755',0),(487600,13545,'fi','Ota 755 chmod',0),(487601,13545,'no','Vennligst 755 chmod',0),(487602,13545,'da','Venligst 755 chmod',0),(487603,13545,'ko','755 chmodë¥¼ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(487604,13545,'he','×‘×‘×§×©×” 755 chmod',0),(487605,13545,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ 755 chmod',0),(487606,13545,'zh','è¯· 755 chmod',0),(487607,13545,'sv','VÃ¤nligen 755 chmod',0),(487608,13545,'it','Si prega di chmod 755',0),(487609,13545,'tl','',0),(487610,13545,'th','à¸à¸£à¸¸à¸“à¸² 755 chmod',0),(487611,13545,'hi','755 chmod à¤•à¥ƒà¤ªà¤¯à¤¾',0),(487612,13545,'ms','Sila 755 chmod',0),(487613,13545,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø´Ù…ÙˆØ¯ 755',0),(487614,13545,'fr','S\'il vous plaÃ®t chmod 755',0),(487615,13545,'jp','755 chmod ã—ã¦ãã ã•ã„ã€‚',0),(487616,13545,'pt','Por favor chmod 755',0),(487617,13545,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, 755 chmod',0),(487618,13545,'es','Por Favor 755 chmod',0),(487619,13545,'de','Bitte Chmod 755',0),(487620,13545,'en','Please 755 chmod',0),(487621,13546,'is','',0),(487622,13546,'dr','Ù„Ø·ÙØ§ Ø³Ø·Ø­ Ø¯Ø³ØªØ±Ø³ÛŒ Ø§ÛŒÙ† ÙØ§ÛŒÙ„ Ù‡Ø§ Ø¨Ù‡ 777',0),(487623,13546,'pr','Ù„Ø·ÙØ§ Ø³Ø·Ø­ Ø¯Ø³ØªØ±Ø³ÛŒ Ø§ÛŒÙ† ÙØ§ÛŒÙ„ Ù‡Ø§ Ø¨Ù‡ 777',0),(487624,13546,'tr','Bu dosyalarÄ±n 777 chmod lÃ¼tfen',0),(487625,13546,'pl','ProszÄ™ chmod te pliki do 777',0),(487626,13546,'bg','ÐœÐ¾Ð»Ñ chmod Ñ‚ÐµÐ·Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ Ð½Ð° 777',0),(487627,13546,'ur','Ø§Ù† Ù…Ø³Ù„ÙˆÚº Ú©Ùˆ 777 Ú†Ù… Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ',0),(487628,13546,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ñ†Ñ…Ð¼Ð¾Ð´ Ð¾Ð²Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð½Ð° 777',0),(487629,13546,'vi','Xin vui lÃ²ng chmod nhá»¯ng táº­p tin nÃ y Ä‘á»ƒ 777',0),(487630,13546,'af','Chmod asseblief hierdie lÃªers 777',0),(487631,13546,'ro','VÄƒ rugÄƒm sÄƒ chmod aceste fiÅŸiere la 777',0),(487632,13546,'et','Palun chmod 777 need failid',0),(487633,13546,'si','Prosim chmod te datoteke na 777',0),(487634,13546,'ba','Silahkan chmod file-file ini ke 777',0),(487635,13546,'nl','Gelieve chmod deze bestanden naar 777',0),(487636,13546,'fi','Ota chmod 777 tiedostot',0),(487637,13546,'no','Vennligst chmod filene til 777',0),(487638,13546,'da','Venligst chmod disse filer til 777',0),(487639,13546,'ko','ì œë°œ chmodë¥¼ 777ì´ íŒŒì¼',0),(487640,13546,'he','×‘×‘×§×©×” chmod 777 ×œ×§×‘×¦×™× ×”××œ×”',0),(487641,13546,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ chmod Î±Ï…Ï„Î¬ Ï„Î± Î±ÏÏ‡ÎµÎ¯Î± ÏƒÎµ 777',0),(487642,13546,'zh','è¯· chmod 777 è¿™äº›æ–‡ä»¶',0),(487643,13546,'sv','VÃ¤nligen chmod dessa filer till 777',0),(487644,13546,'it','Si prega di chmod 777 di questi file',0),(487645,13546,'tl','',0),(487646,13546,'th','à¸à¸£à¸¸à¸“à¸² chmod 777 à¹à¸Ÿà¹‰à¸¡à¹€à¸«à¸¥à¹ˆà¸²à¸™à¸µà¹‰',0),(487647,13546,'hi','Chmod 777 à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‡ à¤«à¤¼à¤¾à¤‡à¤²à¥‡à¤‚ à¤•à¥ƒà¤ªà¤¯à¤¾',0),(487648,13546,'ms','Sila chmod fail ini ke 777',0),(487649,13546,'ar','Ù…Ù† ÙØ¶Ù„Ùƒ Ù‡Ø°Ù‡ Ø§Ù„Ù…Ù„ÙØ§Øª Ø¥Ù„Ù‰ 777 chmod',0),(487650,13546,'fr','S\'il vous plaÃ®t chmod 777 de ces fichiers',0),(487651,13546,'jp','ã“ã‚Œã‚‰ã®ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ 777 ã« chmod ã‚’ã—ã¦ãã ã•ã„ã€‚',0),(487652,13546,'pt','Por favor chmod esses arquivos para 777',0),(487653,13546,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° chmod 777 ÑÑ‚Ð¸ Ñ„Ð°Ð¹Ð»Ñ‹',0),(487654,13546,'es','Por Favor chmod Estes Files a 777',0),(487655,13546,'de','Bitte Chmod diese Dateien auf 777',0),(487656,13546,'en','Please chmod these files to 777',0),(487657,13547,'is','',0),(487658,13547,'dr','Ù„Ø·ÙØ§ Ù…Ø¬ÙˆØ²Ù‡Ø§ÛŒ Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø§ÛŒÙ† ØªØ§ÛŒÛŒØ¯',0),(487659,13547,'pr','Ù„Ø·ÙØ§ Ù…Ø¬ÙˆØ²Ù‡Ø§ÛŒ Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø§ÛŒÙ† ØªØ§ÛŒÛŒØ¯',0),(487660,13547,'tr','LÃ¼tfen bu dosyanÄ±n izinleri doÄŸrulayÄ±n',0),(487661,13547,'pl','ProszÄ™ potwierdziÄ‡ te uprawnienia pliku',0),(487662,13547,'bg','ÐœÐ¾Ð»Ñ, Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ Ñ‚ÐµÐ·Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ð¸ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ',0),(487663,13547,'ur','ÛŒÛ Ù…Ø³Ù„ Ø§Ø¬Ø§Ø²ØªÛŒÚº ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(487664,13547,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð¾Ð²Ðµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ðµ Ð·Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(487665,13547,'vi','Xin vui lÃ²ng xÃ¡c nháº­n nhá»¯ng quyá»n háº¡n táº­p tin',0),(487666,13547,'af','Bevestig asseblief hierdie lÃªer toestemmings',0),(487667,13547,'ro','VÄƒ rugÄƒm sÄƒ confirmaÅ£i aceste permisiuni de fiÅŸier',0),(487668,13547,'et','Kinnitage need FailiÃµigused',0),(487669,13547,'si','Prosim potrditi teh dovoljenj datoteke',0),(487670,13547,'ba','Silakan konfirmasi ini file permission',0),(487671,13547,'nl','Bevestig deze bestandsmachtigingen',0),(487672,13547,'fi','Vahvista tiedoston kÃ¤yttÃ¶oikeudet',0),(487673,13547,'no','Kontroller tillatelsene filen',0),(487674,13547,'da','BekrÃ¦ft venligst disse filtilladelser',0),(487675,13547,'ko','ì´ëŸ¬í•œ íŒŒì¼ì˜ ì‚¬ìš© ê¶Œí•œì„ í™•ì¸ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(487676,13547,'he','×× × ××©×¨×• ××ª ×”×¨×©××•×ª ×”×§×•×‘×¥ ××œ×”',0),(487677,13547,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÏ„Îµ Î±Ï…Ï„Î¬ Ï„Î± Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(487678,13547,'zh','è¯·ç¡®è®¤è¿™äº›æ–‡ä»¶æƒé™',0),(487679,13547,'sv','VÃ¤nligen bekrÃ¤fta dessa filbehÃ¶righeter',0),(487680,13547,'it','Si prega di confermare queste autorizzazioni file',0),(487681,13547,'tl','',0),(487682,13547,'th','à¸à¸£à¸¸à¸“à¸²à¸¢à¸·à¸™à¸¢à¸±à¸™à¸ªà¸´à¸—à¸˜à¸´à¹Œà¸‚à¸­à¸‡à¹à¸Ÿà¹‰à¸¡à¹€à¸«à¸¥à¹ˆà¸²à¸™à¸µà¹‰',0),(487683,13547,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¯à¥‡ à¤«à¤¾à¤‡à¤² à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(487684,13547,'ms','Sila sahkan keizinan fail ini',0),(487685,13547,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ£ÙƒÙŠØ¯ Ù‡Ø°Ù‡ Ø£Ø°ÙˆÙ†Ø§Øª Ø§Ù„Ù…Ù„Ù',0),(487686,13547,'fr','S\'il vous plaÃ®t confirmer ces autorisations de fichier',0),(487687,13547,'jp','ã“ã‚Œã‚‰ã®ãƒ•ã‚¡ã‚¤ãƒ«ã®ã‚¢ã‚¯ã‚»ã‚¹è¨±å¯ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(487688,13547,'pt','Por favor, confirmar essas permissÃµes de arquivo',0),(487689,13547,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚Ðµ ÑÑ‚Ð¸ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ñ„Ð°Ð¹Ð»Ð°',0),(487690,13547,'es','Por Favor Confirma Estes Permisos de Files',0),(487691,13547,'de','Bitte bestÃ¤tigen Sie diese Dateiberechtigungen',0),(487692,13547,'en','Please confirm these file permissions',0),(487693,13548,'is','',0),(487694,13548,'dr','Ø®ÙˆØ§Ù†Ø¯Ù† Ùˆ Ù†ÙˆØ´ØªÙ† Ú†Ú© Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯!',0),(487695,13548,'pr','Ø®ÙˆØ§Ù†Ø¯Ù† Ùˆ Ù†ÙˆØ´ØªÙ† Ú†Ú© Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯!',0),(487696,13548,'tr','Okuma/yazma denetimi baÅŸarÄ±sÄ±z oldu.',0),(487697,13548,'pl','Odczytu/zapisu wyboru nie powiodÅ‚o siÄ™!',0),(487698,13548,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð° Ñ‡ÐµÑ‚ÐµÐ½Ðµ/Ð·Ð°Ð¿Ð¸Ñ!',0),(487699,13548,'ur','Ù…Ø·Ø§Ù„Ø¹Û/ØªØ­Ø±ÛŒØ± Ú©ÛŒ Ø¬Ø§Ù†Ú† Ù†Ø§Ú©Ø§Ù… ÛÙˆÚ¯Ø¦ÛŒ!',0),(487700,13548,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð° Ñ‡Ð¸Ñ‚Ð°ÑšÐµ Ð¸ Ð¿Ð¸ÑÐ°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾!',0),(487701,13548,'vi','Äá»c/ghi kiá»ƒm tra tháº¥t báº¡i!',0),(487702,13548,'af','Lees-skryf-check het misluk!',0),(487703,13548,'ro','Citire/scriere de verificare nu a reuÅŸit!',0),(487704,13548,'et','Lugemine/kirjutamine nurjus!',0),(487705,13548,'si','Branje/pisanje Äek ne zadostovati!',0),(487706,13548,'ba','Membaca/menulis cek gagal!',0),(487707,13548,'nl','Lezen/schrijven controle mislukt!',0),(487708,13548,'fi','Luku/kirjoitus epÃ¤onnistui!',0),(487709,13548,'no','Lese/skrive-kontroll mislyktes!',0),(487710,13548,'da','LÃ¦se/skrive kontrol mislykkedes!',0),(487711,13548,'ko','ì½ê¸°/ì“°ê¸° ê²€ì‚¬ì— ì‹¤íŒ¨ í–ˆìŠµë‹ˆë‹¤!',0),(487712,13548,'he','×‘×“×™×§×ª ×§×¨×™××”/×›×ª×™×‘×” × ×›×©×œ×”!',0),(487713,13548,'el','Î‘Î½Î¬Î³Î½Ï‰ÏƒÎ·Ï‚/ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î­Ï„Ï…Ï‡Îµ!',0),(487714,13548,'zh','è¯»/å†™æ£€æŸ¥å¤±è´¥ ï¼',0),(487715,13548,'sv','Det gick inte att lÃ¤sa/skriva check!',0),(487716,13548,'it','Verifica di lettura e scrittura non riuscita!',0),(487717,13548,'tl','',0),(487718,13548,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸­à¹ˆà¸²à¸™/à¹€à¸‚à¸µà¸¢à¸™à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(487719,13548,'hi','à¤ªà¤¢à¤¼à¥‡à¤‚/à¤²à¤¿à¤–à¥‡à¤‚ à¤šà¥‡à¤• à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾!',0),(487720,13548,'ms','Baca/tulis memeriksa gagal!',0),(487721,13548,'ar','ÙØ´Ù„ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ù‚Ø±Ø§Ø¡Ø© ÙˆØ§Ù„ÙƒØªØ§Ø¨Ø©!',0),(487722,13548,'fr','Le test de lecture/Ã©criture a Ã©chouÃ© !',0),(487723,13548,'jp','èª­ã¿å–ã‚Š/æ›¸ãè¾¼ã¿ãƒã‚§ãƒƒã‚¯ã«å¤±æ•—ã—ã¾ã—ãŸ ï¼',0),(487724,13548,'pt','VerificaÃ§Ã£o de leitura/gravaÃ§Ã£o falhada!',0),(487725,13548,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ñ‡Ñ‚ÐµÐ½Ð¸Ñ/Ð·Ð°Ð¿Ð¸ÑÐ¸!',0),(487726,13548,'es','Leer/Escribir Cheque FallÃ³',0),(487727,13548,'de','Lese-Schreib-ÃœberprÃ¼fung fehlgeschlagen!',0),(487728,13548,'en','Read/Write check failed!',0),(487729,13549,'is','',0),(487730,13549,'dr','Ø§Ø¬Ø±Ø§ÛŒ Ø§Ø³Ú©Ø±ÛŒÙ¾Øª Ù†ØµØ¨...',0),(487731,13549,'pr','Ø§Ø¬Ø±Ø§ÛŒ Ø§Ø³Ú©Ø±ÛŒÙ¾Øª Ù†ØµØ¨...',0),(487732,13549,'tr','Ã‡alÄ±ÅŸan komut dosyasÄ± yÃ¼kleyin...',0),(487733,13549,'pl','Uruchomiony skrypt instalacji...',0),(487734,13549,'bg','Ð˜Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐºÑ€Ð¸Ð¿Ñ‚...',0),(487735,13549,'ur','Ø¯ÙˆÚ‘ Ù†ÙˆØ´ØªÛ ØªÙ†ØµÛŒØ¨ Ú©Ø±ÛŒÚº...',0),(487736,13549,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚Ð°ÑšÐµÐ¼ ÑÐºÑ€Ð¸Ð¿Ñ‚Ðµ Ð·Ð° Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ñƒ...',0),(487737,13549,'vi','Cháº¡y ká»‹ch báº£n cÃ i Ä‘áº·t...',0),(487738,13549,'af','Loop skrip installeer...',0),(487739,13549,'ro','Rularea a instala script-ul...',0),(487740,13549,'et','Jooksis install script...',0),(487741,13549,'si','Tekmovanje v teku umestiti scenarij...',0),(487742,13549,'ba','Menjalankan menginstal script...',0),(487743,13549,'nl','Script dat wordt uitgevoerd installeren...',0),(487744,13549,'fi','Jatkuva asettaa kirjoitus...',0),(487745,13549,'no','KjÃ¸rer installere skriften...',0),(487746,13549,'da','KÃ¸rer installationsscript...',0),(487747,13549,'ko','ì‹¤í–‰ ìŠ¤í¬ë¦½íŠ¸ë¥¼ ì„¤ì¹˜...',0),(487748,13549,'he','×¨×™×¦×” ×œ×”×ª×§×™×Ÿ script...',0),(487749,13549,'el','Î¤ÏÎ­Î¾Î¹Î¼Î¿ script ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚...',0),(487750,13549,'zh','è¿è¡Œå®‰è£…è„šæœ¬...',0),(487751,13549,'sv','KÃ¶r installationsskriptet...',0),(487752,13549,'it','Esecuzione script di installazione...',0),(487753,13549,'tl','',0),(487754,13549,'th','à¹€à¸£à¸µà¸¢à¸à¹ƒà¸Šà¹‰à¸ªà¸„à¸£à¸´à¸›à¸•à¹Œà¸à¸²à¸£à¸•à¸´à¸”à¸•à¸±à¹‰à¸‡...',0),(487755,13549,'hi','à¤¸à¥à¤¥à¤¾à¤ªà¤¨à¤¾ à¤¸à¥à¤•à¥à¤°à¤¿à¤ªà¥à¤Ÿ à¤šà¤²à¤¾à¤¨à¤¾...',0),(487756,13549,'ms','Berjalan memasang skrip...',0),(487757,13549,'ar','ØªØ´ØºÙŠÙ„ Ø§Ù„Ø¨Ø±Ù†Ø§Ù…Ø¬ Ø§Ù„Ù†ØµÙŠ Ù„ØªØ«Ø¨ÙŠØª...',0),(487758,13549,'fr','Script d\'installation en cours d\'exÃ©cution...',0),(487759,13549,'jp','ã‚¤ãƒ³ã‚¹ãƒˆãƒ¼ãƒ« ã‚¹ã‚¯ãƒªãƒ—ãƒˆã‚’å®Ÿè¡Œã—ã¦ã„ã‚‹.',0),(487760,13549,'pt','ExecuÃ§Ã£o de script de instalaÃ§Ã£o...',0),(487761,13549,'ru','Ð—Ð°Ð¿ÑƒÑÐº ÑÑ†ÐµÐ½Ð°Ñ€Ð¸Ñ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸...',0),(487762,13549,'es','Comenzando el Script de InstalaciÃ³n',0),(487763,13549,'de','Laufenden Installations-Skript...',0),(487764,13549,'en','Running install script...',0),(487765,13550,'is','',0),(487766,13550,'dr','Ú¯Ø°Ø§Ø´ØªÙ† Ù†ÙˆØ´ØªÙ† Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯! Ù„Ø·ÙØ§ Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÛŒØ¯ Ú©Ù‡ \'exec\' Ù…Ø¬Ø§Ø² Ø§Ø³Øª Ø¯Ø± ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ù¾ÛŒ Ø§Ú† Ù¾ÛŒ.',0),(487767,13550,'pr','Ú¯Ø°Ø§Ø´ØªÙ† Ù†ÙˆØ´ØªÙ† Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯! Ù„Ø·ÙØ§ Ù…Ø·Ù…Ø¦Ù† Ø´ÙˆÛŒØ¯ Ú©Ù‡ \'exec\' Ù…Ø¬Ø§Ø² Ø§Ø³Øª Ø¯Ø± ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ù¾ÛŒ Ø§Ú† Ù¾ÛŒ.',0),(487768,13550,'tr','SQL yazma baÅŸarÄ±sÄ±z oldu! LÃ¼tfen \'exec\' PHP yapÄ±landÄ±rmanÄ±za izin verildiÄŸinden emin olun.',0),(487769,13550,'pl','SQL zapis nie powiÃ³dÅ‚ siÄ™! Upewnij siÄ™, Å¼e \"exec\" jest dozwolone w konfiguracji PHP.',0),(487770,13550,'bg','SQL Ð·Ð°Ð¿Ð¸Ñ Ð½Ðµ ÑƒÑÐ¿Ñ! ÐœÐ¾Ð»Ñ, ÑƒÐ²ÐµÑ€ÐµÑ‚Ðµ ÑÐµ, Ñ‡Ðµ \"exec\" Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾ Ð² ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ð¸Ñ Ñ„Ð°Ð¹Ð».',0),(487771,13550,'ur','SQL Ù„Ú©Ú¾Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…! Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ù¾ÛŒ Ø§ÛŒÚ† Ù¾ÛŒ Ú©ÛŒ ØªØ´Ú©ÛŒÙ„ Ù…ÛŒÚº \'Ú©\' Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª ÛÛ’ Û”',0),(487772,13550,'sr','Ð¡QÐ› ÑƒÐ¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾! Ð£Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÑÐµ Ð´Ð° Ð´Ð° \'Ð¸Ð·Ð²Ñ€ÑÐ½Ð¸\' Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð° Ñƒ ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ñ˜Ð¸ ÐŸÐ¥ÐŸ.',0),(487773,13550,'vi','SQL viáº¿t tháº¥t báº¡i! Xin vui lÃ²ng Ä‘áº£m báº£o ráº±ng \'exec\' Ä‘Æ°á»£c cho phÃ©p trong cáº¥u hÃ¬nh PHP cá»§a báº¡n.',0),(487774,13550,'af','SQL skryf het misluk! Maak asseblief seker dat \'exec\' in jou PHP konfigurasie toegelaat is.',0),(487775,13550,'ro','Scrie SQL nu a reuÈ™it! AsiguraÅ£i-vÄƒ cÄƒ \"exec\" este permisÄƒ Ã®n configuraÈ›ia PHP.',0),(487776,13550,'et','SQL kirjutamine nurjus! Veenduge, et \"exec\" lubatakse sinu PHP konfiguratsiooni.',0),(487777,13550,'si','SQL pisanje ni uspelo! PrepriÄajte se, da je Â»execÂ« dovoljena v PHP konfiguracija.',0),(487778,13550,'ba','Menulis SQL gagal! Pastikan bahwa \'exec\' diperbolehkan dalam konfigurasi PHP Anda.',0),(487779,13550,'nl','SQL schrijfbewerkingen zijn mislukt! Zorg ervoor dat \'exec\' in je PHP configuratie is toegestaan.',0),(487780,13550,'fi','SQL kirjoitus epÃ¤onnistui! Varmista, ettÃ¤ \"exec\" sallitaan PHP kokoonpano.',0),(487781,13550,'no','SQL skrivefeil! Kontroller at \"exec\" er tillatt i PHP-konfigurasjonen.',0),(487782,13550,'da','SQL skrivningen mislykkedes! Kontroller, at \'exec\' er tilladt i din PHP konfiguration.',0),(487783,13550,'ko','SQL ì“°ê¸° ì‹¤íŒ¨! \'Exec\' PHP êµ¬ì„±ì—ì„œ í—ˆìš© í•˜ëŠ” ê²ƒì„ í™•ì¸ í•˜ì‹­ì‹œì˜¤.',0),(487784,13550,'he','SQL ×›×ª×™×‘×” × ×›×©×œ×”! × × ×•×“× ×›×™ \'exec\' ×ž×•×ª×¨ ×‘×ª×¦×•×¨×” PHP.',0),(487785,13550,'el','SQL ÎµÎ³Î³ÏÎ±Ï†Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ! Î’ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ Â«execÂ» ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ ÏƒÏ„Î· ÏÏÎ¸Î¼Î¹ÏƒÎ· Ï€Î±ÏÎ±Î¼Î­Ï„ÏÏ‰Î½ Ï„Î·Ï‚ PHP.',0),(487786,13550,'zh','SQL å†™å…¥å¤±è´¥ ï¼è¯·ç¡®ä¿åœ¨æ‚¨çš„ PHP é…ç½®å…è®¸ \'exec\'ã€‚',0),(487787,13550,'sv','SQL skrivning misslyckades! Se till att \"exec\" Ã¤r tillÃ¥tet i din PHP-konfigurationen.',0),(487788,13550,'it','Scrivi SQL Impossibile! Assicurarsi che \'exec\' Ã¨ consentito nella configurazione del PHP.',0),(487789,13550,'tl','',0),(487790,13550,'th','à¹€à¸‚à¸µà¸¢à¸™ SQL à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§ à¹‚à¸›à¸£à¸”à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸§à¹ˆà¸² \'exec\' à¹„à¸”à¹‰à¹ƒà¸™à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸„à¸­à¸™à¸Ÿà¸´à¸à¸‚à¸­à¸‡ PHP',0),(487791,13550,'hi','SQL à¤²à¤¿à¤–à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤²! à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ªà¤•à¥‡ PHP à¤µà¤¿à¤¨à¥à¤¯à¤¾à¤¸ à¤®à¥‡à¤‚ \'exec\' à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€ à¤¹à¥ˆà¥¤',0),(487792,13550,'ms','SQL tulis gagal! Sila pastikan bahawa \'exec\' adalah dibenarkan dalam konfigurasi PHP anda.',0),(487793,13550,'ar','ÙØ´Ù„Øª Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ÙƒØªØ§Ø¨Ø© SQL! Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù† \'exec\' Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡Ø§ ÙÙŠ Ø§Ù„ØªÙƒÙˆÙŠÙ† Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ PHP.',0),(487794,13550,'fr','Ã‰criture SQL a Ã©chouÃ© ! Veillez Ã  ce que Â« exec Â» est autorisÃ©e dans votre configuration de PHP.',0),(487795,13550,'jp','SQL ã®æ›¸ãè¾¼ã¿ã«å¤±æ•—ã—ã¾ã—ãŸ ï¼\'Exec\' ãŒã€PHP ã®è¨­å®šã§è¨±å¯ã•ã‚Œã‚‹ã“ã¨ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(487796,13550,'pt','GravaÃ§Ã£o SQL falha! Por favor, certifique-se de que \'exec\' Ã© permitido na sua configuraÃ§Ã£o do PHP.',0),(487797,13550,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸ SQL! ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑƒÐ±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾ Â«execÂ» Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ Ð² Ð²Ð°ÑˆÐµÐ¹ ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð°Ñ†Ð¸Ð¸ PHP.',0),(487798,13550,'es','Escrito de SQL fallÃ³!Por Favor Asegura que \'exec\' se permite en su configuraciÃ³n de PHP',0),(487799,13550,'de','SQL schreiben fehlgeschlagen! Bitte stellen Sie sicher, dass \'Exec\' in Ihrer PHP-Konfiguration erlaubt ist.',0),(487800,13550,'en','SQL write failed! Please ensure that \'exec\' is allowed in your PHP configuration.',0),(487801,13551,'is','',0),(487802,13551,'dr','Ú©Ù„ Ø¯ÙˆØ±Ù‡ ÙØ±ÙˆØ´',0),(487803,13551,'pr','Ú©Ù„ Ø¯ÙˆØ±Ù‡ ÙØ±ÙˆØ´',0),(487804,13551,'tr','Toplam satÄ±ÅŸ dÃ¶nemi',0),(487805,13551,'pl','CaÅ‚kowity okres sprzedaÅ¼y',0),(487806,13551,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(487807,13551,'ur','Ú©Ù„ ÙØ±ÙˆØ®Øª Ø¯ÙˆØ±',0),(487808,13551,'sr','Ð£ÐºÑƒÐ¿Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(487809,13551,'vi','Táº¥t cáº£ thá»i gian bÃ¡n hÃ ng',0),(487810,13551,'af','Totale verkope tydperk',0),(487811,13551,'ro','Perioada totalÄƒ de vÃ¢nzÄƒri',0),(487812,13551,'et','Kokku mÃ¼Ã¼giperiood',0),(487813,13551,'si','Skupno prodajno obdobje',0),(487814,13551,'ba','Total penjualan periode',0),(487815,13551,'nl','Totale verkoop periode',0),(487816,13551,'fi','YhteensÃ¤ myynti aika',0),(487817,13551,'no','Totalt salg periode',0),(487818,13551,'da','Samlede salg periode',0),(487819,13551,'ko','ì´ íŒë§¤ ê¸°ê°„',0),(487820,13551,'he','×ž×—×–×•×¨ ×”×ž×›×™×¨×•×ª ×”×›×•×œ×œ',0),(487821,13551,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(487822,13551,'zh','æ€»é”€å”®æœŸ',0),(487823,13551,'sv','Totala fÃ¶rsÃ¤ljningarna Period',0),(487824,13551,'it','Periodo di vendita totale',0),(487825,13551,'tl','',0),(487826,13551,'th','à¸£à¸§à¸¡à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸—à¸µà¹ˆà¸‚à¸²à¸¢',0),(487827,13551,'hi','à¤•à¥à¤² à¤¬à¤¿à¤•à¥à¤°à¥€ à¤…à¤µà¤§à¤¿',0),(487828,13551,'ms','Jumlah tempoh jualan',0),(487829,13551,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„ÙØªØ±Ø©',0),(487830,13551,'fr','PÃ©riode de vente total',0),(487831,13551,'jp','ç·è²©å£²æœŸé–“',0),(487832,13551,'pt','PerÃ­odo de vendas total',0),(487833,13551,'ru','ÐžÐ±Ñ‰Ð¸Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(487834,13551,'es','Total Ventas por PerÃ­odo',0),(487835,13551,'de','Gesamt Periode',0),(487836,13551,'en','Total Sales Period',0),(487837,13552,'is','',0),(487838,13552,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ´ YTD',0),(487839,13552,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ´ YTD',0),(487840,13552,'tr','Toplam satÄ±ÅŸ YTD',0),(487841,13552,'pl','Suma sprzedaÅ¼y od poczÄ…tku roku',0),(487842,13552,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(487843,13552,'ur','Ú©Ù„ ÙØ±ÙˆØ®Øª ÛŒÙ¹Ø¯',0),(487844,13552,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(487845,13552,'vi','Tá»•ng sá»‘ bÃ¡n hÃ ng YTD',0),(487846,13552,'af','Totale verkope YTD',0),(487847,13552,'ro','Total vÃ¢nzÄƒri YTD',0),(487848,13552,'et','Kokku mÃ¼Ã¼k YTD',0),(487849,13552,'si','Prodaja YTD',0),(487850,13552,'ba','Total penjualan YTD',0),(487851,13552,'nl','Totale verkoop YTD',0),(487852,13552,'fi','YhteensÃ¤ myynti vuoden alusta',0),(487853,13552,'no','Totalt salg hittil i Ã¥r',0),(487854,13552,'da','Samlede salg Ã…TD',0),(487855,13552,'ko','ì´ íŒë§¤ ëˆ„ê³„',0),(487856,13552,'he','×¡×” ×› ×ž×›×™×¨×•×ª ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(487857,13552,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ­Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚-ÏƒÏ‰ÏÎµÏ…Ï„Î¹ÎºÏŒ ÎˆÎ¤ÎŸÎ¥Î£',0),(487858,13552,'zh','é›¶å”®ä¸šæ€»é”€è´§æ•°é‡ YTD',0),(487859,13552,'sv','Totala fÃ¶rsÃ¤ljning YTD',0),(487860,13552,'it','Total Sales YTD',0),(487861,13552,'tl','',0),(487862,13552,'th','à¸£à¸§à¸¡à¸‚à¸²à¸¢ YTD',0),(487863,13552,'hi','à¤•à¥à¤² à¤¬à¤¿à¤•à¥à¤°à¥€ YTD',0),(487864,13552,'ms','Jumlah jualan THK',0),(487865,13552,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø¹Ø§Ù…',0),(487866,13552,'fr','Le total des ventes depuis un an',0),(487867,13552,'jp','ç·è²©å£²ç´¯è¨ˆ',0),(487868,13552,'pt','Total de vendas acumulado no ano',0),(487869,13552,'ru','ÐžÐ±Ñ‰Ð¸Ð¹ Ð¾Ð±ÑŠÐµÐ¼ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ñ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð°',0),(487870,13552,'es','Total Ventas AÃ±o a la Fecha',0),(487871,13552,'de','Gesamtumsatz YTD',0),(487872,13552,'en','Total Sales YTD',0),(487873,13553,'is','',0),(487874,13553,'dr','Ø¨Ø±Ø§ÛŒ Ø¯Ø§Ù†Ù„ÙˆØ¯',0),(487875,13553,'pr','Ø¨Ø±Ø§ÛŒ Ø¯Ø§Ù†Ù„ÙˆØ¯',0),(487876,13553,'tr','Ä°ndirmek iÃ§in',0),(487877,13553,'pl','Do pobrania',0),(487878,13553,'bg','Ð—Ð° Ð´Ð° Ð¸Ð·Ñ‚ÐµÐ³Ð»Ð¸Ñ‚Ðµ',0),(487879,13553,'ur','ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(487880,13553,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÐ»Ð¸',0),(487881,13553,'vi','Táº£i vá»',0),(487882,13553,'af','Om af te laai',0),(487883,13553,'ro','Pentru a descÄƒrca',0),(487884,13553,'et','Allalaadimine',0),(487885,13553,'si','Za prenos',0),(487886,13553,'ba','Untuk men-Download',0),(487887,13553,'nl','Om te downloaden',0),(487888,13553,'fi','Lataa',0),(487889,13553,'no','Laste ned',0),(487890,13553,'da','Til Download',0),(487891,13553,'ko','ë‹¤ìš´ë¡œë“œ',0),(487892,13553,'he','×œ×”×•×¨×“×”',0),(487893,13553,'el','ÎÎ± ÎºÎ±Ï„ÎµÎ²Î¬ÏƒÎµÏ„Îµ',0),(487894,13553,'zh','ä¸‹è½½',0),(487895,13553,'sv','Att ladda ner',0),(487896,13553,'it','Scaricare',0),(487897,13553,'tl','',0),(487898,13553,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”',0),(487899,13553,'hi','à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(487900,13553,'ms','Untuk muat turun',0),(487901,13553,'ar','Ù„ØªØ­Ù…ÙŠÙ„',0),(487902,13553,'fr','Pour tÃ©lÃ©charger',0),(487903,13553,'jp','ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(487904,13553,'pt','Para fazer o Download',0),(487905,13553,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ',0),(487906,13553,'es','Al Descargar',0),(487907,13553,'de','Zum Download',0),(487908,13553,'en','To Download',0),(487909,13554,'is','',0),(487910,13554,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ú©Ø§Ù…Ù„! Ø¨Ù‡ Ø±ÙˆØ² Ú©Ø±Ø¯Ù† Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯.',0),(487911,13554,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ú©Ø§Ù…Ù„! Ø¨Ù‡ Ø±ÙˆØ² Ú©Ø±Ø¯Ù† Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯.',0),(487912,13554,'tr','GÃ¼ncelleÅŸtirme tamamlandÄ±! Yenilemek iÃ§in burayÄ± tÄ±klatÄ±n.',0),(487913,13554,'pl','Aktualizacja kompletny! Kliknij tutaj, aby odÅ›wieÅ¼yÄ‡.',0),(487914,13554,'bg','ÐžÐ±Ð½Ð¾Ð²ÑÐ²Ð°Ð½ÐµÑ‚Ð¾ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¾! Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° ÑÐµ Ð¾Ð±Ð½Ð¾Ð²Ð¸.',0),(487915,13554,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…Ú©Ù…Ù„! ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(487916,13554,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾. ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð·Ð° Ð½Ð¾Ð²Ð¸.',0),(487917,13554,'vi','Cáº­p Nháº­t hoÃ n táº¥t! Click vÃ o Ä‘Ã¢y Ä‘á»ƒ lÃ m má»›i.',0),(487918,13554,'af','Bywerking voltooi! Klik hier om te verfris.',0),(487919,13554,'ro','Actualizare completa! Click aici pentru a reÃ®mprospÄƒta.',0),(487920,13554,'et','VÃ¤rskendamine valmis! VÃ¤rskendamiseks klÃµpsake siin.',0),(487921,13554,'si','Posodobitev popolna! Kliknite, Äe Å¾elite osveÅ¾iti.',0),(487922,13554,'ba','Update lengkap! Klik di sini untuk menyegarkan.',0),(487923,13554,'nl','Update compleet! Klik hier om te vernieuwen.',0),(487924,13554,'fi','PÃ¤ivitys valmis! Napsauttamalla PÃ¤ivitÃ¤.',0),(487925,13554,'no','Oppdatering fullfÃ¸rt! Klikk her for Ã¥ oppdatere.',0),(487926,13554,'da','Update fÃ¦rdig! Klik her for at opdatere.',0),(487927,13554,'ko','ì—…ë°ì´íŠ¸ ì™„ë£Œ! ìƒˆë¡œ ê³ ì¹˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(487928,13554,'he','×¢×“×›×•×Ÿ ×ž×œ×! ×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×¨×¢× ×Ÿ.',0),(487929,13554,'el','Î Î»Î®ÏÎ·Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·! ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î±Î½Î±Î½ÎµÏŽÏƒÎµÏ„Îµ.',0),(487930,13554,'zh','æ›´æ–°å®Œæˆ ï¼è‹¥è¦åˆ·æ–°ï¼Œè¯·å•å‡»æ­¤å¤„ã€‚',0),(487931,13554,'sv','Uppdatering komplett! Klicka hÃ¤r om du vill uppdatera.',0),(487932,13554,'it','Aggiornamento completo! Clicca qui per aggiornare.',0),(487933,13554,'tl','',0),(487934,13554,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸Ÿà¸·à¹‰à¸™à¸Ÿà¸¹',0),(487935,13554,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤—à¤¯à¤¾! à¤¤à¤¾à¤œà¤¼à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚à¥¤',0),(487936,13554,'ms','Kemas kini selesai! Klik di sini untuk menyegar semula.',0),(487937,13554,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙƒØ§Ù…Ù„! Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ù„ØªØ­Ø¯ÙŠØ«.',0),(487938,13554,'fr','Mise Ã  jour complÃ¨te ! Cliquez ici pour actualiser.',0),(487939,13554,'jp','æ›´æ–°ãŒå®Œäº†ã—ã¾ã—ãŸ ï¼ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦æ›´æ–°ã—ã¾ã™ã€‚',0),(487940,13554,'pt','AtualizaÃ§Ã£o completa! Clique aqui para atualizar.',0),(487941,13554,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¾! ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ.',0),(487942,13554,'es','ActualizaciÃ³n Completo! Click aqui para refrescar.',0),(487943,13554,'de','Update abgeschlossen! Klicken Sie hier, um zu aktualisieren.',0),(487944,13554,'en','Update complete! Click here to refresh.',0),(487945,13555,'is','',0),(487946,13555,'dr','Ø§Ø±ØªÙ‚Ø§ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø§Ø³Øª. Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ.',0),(487947,13555,'pr','Ø§Ø±ØªÙ‚Ø§ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø§Ø³Øª. Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ.',0),(487948,13555,'tr','YÃ¼kseltme mevcuttur. GÃ¼ncelleÅŸtirmek iÃ§in burayÄ± tÄ±klatÄ±n.',0),(487949,13555,'pl','DostÄ™pne jest uaktualnienie. Kliknij tutaj, aby zaktualizowaÄ‡.',0),(487950,13555,'bg','ÐªÐ¿Ð³Ñ€ÐµÐ¹Ð´ Ðµ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ. Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°.',0),(487951,13555,'ur','Ø¯Ø±Ø¬Û Ø§ÙØ²ÙˆÚº Ø¯Ø³ØªÛŒØ§Ø¨ ÛÛ’ Û” ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº.',0),(487952,13555,'sr','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ñ˜Ðµ Ð½Ð°Ð´Ð¾Ð³Ñ€Ð°Ð´ÑšÐ°. ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð»Ð¸.',0),(487953,13555,'vi','NÃ¢ng cáº¥p cÃ³ sáºµn. Click vÃ o Ä‘Ã¢y Ä‘á»ƒ cáº­p nháº­t.',0),(487954,13555,'af','Opgradering is beskikbaar. Klik hier om te werk.',0),(487955,13555,'ro','Upgrade-ul este disponibil. Click aici pentru a actualiza.',0),(487956,13555,'et','Uuendus on saadaval. VÃ¤rskendamiseks klÃµpsake siin.',0),(487957,13555,'si','Nadgradnja je na voljo. Kliknite tukaj za posodobitev.',0),(487958,13555,'ba','Upgrade tersedia. Klik di sini untuk memperbarui.',0),(487959,13555,'nl','Upgrade is beschikbaar. Klik hier als u wilt bijwerken.',0),(487960,13555,'fi','PÃ¤ivitys on saatavilla. Napsauttamalla PÃ¤ivitÃ¤.',0),(487961,13555,'no','Oppgradering er tilgjengelig. Klikk her for Ã¥ oppdatere.',0),(487962,13555,'da','Opgradering er tilgÃ¦ngelig. Klik her for at opdatere.',0),(487963,13555,'ko','ì—…ê·¸ë ˆì´ë“œëŠ” ì‚¬ìš©í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤. ì—…ë°ì´íŠ¸ í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(487964,13555,'he','×©×“×¨×•×’ ×–×ž×™×Ÿ. ×œ×—×¥ ×›××Ÿ ×œ×¢×“×›×•×Ÿ.',0),(487965,13555,'el','Î‘Î½Î±Î²Î¬Î¸Î¼Î¹ÏƒÎ· ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î·. ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ.',0),(487966,13555,'zh','å‡çº§æ˜¯å¯ç”¨çš„ã€‚è‹¥è¦æ›´æ–°ï¼Œè¯·å•å‡»æ­¤å¤„ã€‚',0),(487967,13555,'sv','Uppgradering Ã¤r tillgÃ¤nglig. Klicka hÃ¤r om du vill uppdatera.',0),(487968,13555,'it','Ãˆ disponibile un aggiornamento. Clicca qui per aggiornare.',0),(487969,13555,'tl','',0),(487970,13555,'th','à¸­à¸±à¸žà¹€à¸à¸£à¸”à¹„à¸”à¹‰ à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(487971,13555,'hi','à¤¨à¤µà¥€à¤¨à¥€à¤•à¤°à¤£ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¹à¥ˆà¥¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚à¥¤',0),(487972,13555,'ms','Naik taraf terdapat di sini. Klik di sini untuk mengemaskini.',0),(487973,13555,'ar','ÙŠØªÙˆÙØ± ØªØ±Ù‚ÙŠØ©. Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ù„ØªØ­Ø¯ÙŠØ«.',0),(487974,13555,'fr','Mise Ã  jour est disponible. Cliquez ici pour mettre Ã  jour.',0),(487975,13555,'jp','ã‚¢ãƒƒãƒ—ã‚°ãƒ¬ãƒ¼ãƒ‰ãŒåˆ©ç”¨å¯èƒ½ã§ã™ã€‚ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦æ›´æ–°ã—ã¾ã™ã€‚',0),(487976,13555,'pt','AtualizaÃ§Ã£o estÃ¡ disponÃ­vel. Clique aqui para atualizar.',0),(487977,13555,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾. ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ.',0),(487978,13555,'es','Nueva versiÃ³n disponible. Clik aqui para actualizar',0),(487979,13555,'de','Upgrade steht zur VerfÃ¼gung. Klicken Sie hier, um zu aktualisieren.',0),(487980,13555,'en','Upgrade is available. Click here to update.',0),(487981,13556,'is','',0),(487982,13556,'dr','Ù†ÙˆØ´ØªÙ† Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯!',0),(487983,13556,'pr','Ù†ÙˆØ´ØªÙ† Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯!',0),(487984,13556,'tr','Yazma baÅŸarÄ±sÄ±z oldu!',0),(487985,13556,'pl','Zapis nie powiÃ³dÅ‚ siÄ™!',0),(487986,13556,'bg','ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾!',0),(487987,13556,'ur','ØªØ­Ø±ÛŒØ± Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…!',0),(487988,13556,'sr','ÐŸÐ¸ÑÐ°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾!',0),(487989,13556,'vi','Viáº¿t khÃ´ng thÃ nh cÃ´ng!',0),(487990,13556,'af','Skryf het misluk!',0),(487991,13556,'ro','Scrie nu a reuÅŸit!',0),(487992,13556,'et','Kirjutamine nurjus!',0),(487993,13556,'si','Pisanje ni uspelo!',0),(487994,13556,'ba','Menulis gagal!',0),(487995,13556,'nl','Schrijven mislukt!',0),(487996,13556,'fi','Kirjoitustoiminto epÃ¤onnistui!',0),(487997,13556,'no','Skrivefeil!',0),(487998,13556,'da','Skrivningen mislykkedes!',0),(487999,13556,'ko','ì‹¤íŒ¨ í•œ ì“°ê¸°!',0),(488000,13556,'he','×›×ª×™×‘×” × ×›×©×œ×”!',0),(488001,13556,'el','Î•Î³Î³ÏÎ±Ï†Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ!',0),(488002,13556,'zh','å†™å…¥å¤±è´¥ ï¼',0),(488003,13556,'sv','Det gick inte att skriva!',0),(488004,13556,'it','Scrittura non riuscita!',0),(488005,13556,'tl','',0),(488006,13556,'th','à¹€à¸‚à¸µà¸¢à¸™à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(488007,13556,'hi','à¤²à¤¿à¤–à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤²!',0),(488008,13556,'ms','Penulisan gagal!',0),(488009,13556,'ar','ÙØ´Ù„Øª Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ÙƒØªØ§Ø¨Ø©!',0),(488010,13556,'fr','Ã‰chec d\'Ã©criture !',0),(488011,13556,'jp','æ›¸ãè¾¼ã¿ã«å¤±æ•—ã—ã¾ã—ãŸ ï¼',0),(488012,13556,'pt','GravaÃ§Ã£o falhou!',0),(488013,13556,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸!',0),(488014,13556,'es','Escribir fallÃ³!',0),(488015,13556,'de','Schreiben fehlgeschlagen!',0),(488016,13556,'en','Write failed!',0),(488017,13557,'is','',0),(488018,13557,'dr','Ù†ÙˆØ´ØªÙ† Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯! Ù¾Ø´ØªÛŒØ¨Ø§Ù† Ú¯ÛŒØ±ÛŒØŒ Ø¨Ù‡ Ø§ÛŒØ¬Ø§Ø¯ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯ Ù„Ø·ÙØ§Ù‹ Ù…Ø¬ÙˆØ² Ø®ÙˆØ§Ù†Ø¯Ù† Ùˆ Ù†ÙˆØ´ØªÙ† Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ú©Ù†ÛŒØ¯.',0),(488019,13557,'pr','Ù†ÙˆØ´ØªÙ† Ø´Ú©Ø³Øª Ø®ÙˆØ±Ø¯! Ù¾Ø´ØªÛŒØ¨Ø§Ù† Ú¯ÛŒØ±ÛŒØŒ Ø¨Ù‡ Ø§ÛŒØ¬Ø§Ø¯ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯ Ù„Ø·ÙØ§Ù‹ Ù…Ø¬ÙˆØ² Ø®ÙˆØ§Ù†Ø¯Ù† Ùˆ Ù†ÙˆØ´ØªÙ† Ø®ÙˆØ¯ Ø±Ø§ Ø¨Ø±Ø±Ø³ÛŒ Ú©Ù†ÛŒØ¯.',0),(488020,13557,'tr','Yazma baÅŸarÄ±sÄ±z oldu! Yedekleme, oluÅŸturamÄ±yor, okuma ve yazma izinlerini gÃ¶zden geÃ§irin.',0),(488021,13557,'pl','Zapis nie powiÃ³dÅ‚ siÄ™! Nie moÅ¼na utworzyÄ‡ kopii zapasowej, SprawdÅº uprawnienia odczytu i zapisu.',0),(488022,13557,'bg','ÐÐ°Ð¿Ð¸ÑˆÐ¸ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾! ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ð³Ñ€ÑŠÐ±, ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð·Ð° Ñ‡ÐµÑ‚ÐµÐ½Ðµ/Ð·Ð°Ð¿Ð¸Ñ.',0),(488023,13557,'ur','ØªØ­Ø±ÛŒØ± Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…! Ù¾Ø´ØªØ§Ø±ÛØŒ Ø¨Ù†Ø§ Ø³Ú©ØªØ§ Ù¾Ú‘Ú¾ÛŒÚº/Ù„Ú©Ú¾ÛŒÚº Ø§Ø¬Ø§Ø²Øª Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº Û”',0),(488024,13557,'sr','ÐŸÐ¸ÑÐ°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾! ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ñ€ÐµÐ·ÐµÑ€Ð²Ð½Ñƒ ÐºÐ¾Ð¿Ð¸Ñ˜Ñƒ, Ð¼Ð¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ðµ Ð·Ð° Ñ‡Ð¸Ñ‚Ð°ÑšÐµ Ð¸ Ð¿Ð¸ÑÐ°ÑšÐµ.',0),(488025,13557,'vi','Viáº¿t khÃ´ng thÃ nh cÃ´ng! KhÃ´ng thá»ƒ táº¡o sao lÆ°u, hÃ£y kiá»ƒm tra quyá»n Ä‘á»c/ghi cá»§a báº¡n.',0),(488026,13557,'af','Skryf het misluk! Kan rugsteun, Kontroleer asseblief jou lees-skryf-toestemming.',0),(488027,13557,'ro','Scrie nu a reuÅŸit! Nu pot crea copie de rezervÄƒ, vÄƒ rugÄƒm sÄƒ verificaÅ£i permisiunile de citire/scriere.',0),(488028,13557,'et','Kirjutamine nurjus! Ei saa luua varukoopia, Palun kontrollige oma lugemis-vÃµi kirjutamisÃµigus.',0),(488029,13557,'si','Pisanje ni uspelo! Ni mogoÄe ustvariti varnostne kopije, preverite, ali imate dovoljenja za branje/pisanje.',0),(488030,13557,'ba','Menulis gagal! Tidak dapat membuat cadangan, silakan cek hak akses baca/tulis Anda.',0),(488031,13557,'nl','Schrijven mislukt! Kan niet maken back-up, Controleer uw lees-/ schrijfrechten.',0),(488032,13557,'fi','Kirjoitustoiminto epÃ¤onnistui! Ei voi luoda varmuuskopiointi, tarkista luku-ja kirjoitusoikeudet.',0),(488033,13557,'no','Skrivefeil! Kan ikke opprette sikkerhetskopien, Kontroller tillatelsene lese/skrive.',0),(488034,13557,'da','Skrivningen mislykkedes! Kan ikke oprette sikkerhedskopi, tjek venligst din lÃ¦se/skrive-tilladelser.',0),(488035,13557,'ko','ì‹¤íŒ¨ í•œ ì“°ê¸°! ë°±ì—…, ë§Œë“¤ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ì½ê¸°/ì“°ê¸° ê¶Œí•œì„ í™•ì¸ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤.',0),(488036,13557,'he','×›×ª×™×‘×” × ×›×©×œ×”! ××™×Ÿ ××¤×©×¨×•×ª ×œ×™×¦×•×¨ ×’×™×‘×•×™, ×× × ×‘×“×•×§ ××ª ×”×¨×©××•×ª ×§×¨×™××”/×›×ª×™×‘×”.',0),(488037,13557,'el','Î•Î³Î³ÏÎ±Ï†Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ! Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Î±Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚, Ï€Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ»Î­Î³Î¾Ï„Îµ Ï„Î± Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î¬ ÏƒÎ±Ï‚ Î³Î¹Î± Î±Î½Î¬Î³Î½Ï‰ÏƒÎ·/ÎµÎ³Î³ÏÎ±Ï†Î®.',0),(488038,13557,'zh','å†™å…¥å¤±è´¥ ï¼æ— æ³•åˆ›å»ºå¤‡ä»½ï¼Œè¯·æ£€æŸ¥æ‚¨çš„è¯»/å†™æƒé™ã€‚',0),(488039,13557,'sv','Det gick inte att skriva! Kan inte skapa backup, vÃ¤nligen kontrollera din LÃ¤s-och skrivbehÃ¶righeter.',0),(488040,13557,'it','Scrittura non riuscita! Non Ã¨ possibile creare backup, si prega di controllare le autorizzazioni di lettura/scrittura.',0),(488041,13557,'tl','',0),(488042,13557,'th','à¹€à¸‚à¸µà¸¢à¸™à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§ à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¸ªà¸³à¸£à¸­à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥ à¹‚à¸›à¸£à¸”à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸ªà¸´à¸—à¸˜à¸´à¹Œà¸à¸²à¸£à¸­à¹ˆà¸²à¸™/à¹€à¸‚à¸µà¸¢à¸™à¹„à¸”à¹‰',0),(488043,13557,'hi','à¤²à¤¿à¤–à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤²! à¤¬à¥ˆà¤•à¤…à¤ª, à¤¬à¤¨à¤¾ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤ªà¤¨à¥‡ à¤ªà¤ à¤¨/à¤²à¥‡à¤–à¤¨ à¤…à¤¨à¥à¤®à¤¤à¤¿à¤¯à¤¾à¤ à¤œà¤¾à¤à¤šà¥‡à¤‚à¥¤',0),(488044,13557,'ms','Penulisan gagal! Tidak boleh mencipta sandaran, sila semak izin anda.',0),(488045,13557,'ar','ÙØ´Ù„Øª Ø¹Ù…Ù„ÙŠØ© Ø§Ù„ÙƒØªØ§Ø¨Ø©! Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠØŒ Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø£Ø°ÙˆÙ†Ø§Øª Ø§Ù„Ù‚Ø±Ø§Ø¡Ø©/Ø§Ù„ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(488046,13557,'fr','Ã‰chec d\'Ã©criture ! Ne peut pas crÃ©er de sauvegarde, s\'il vous plaÃ®t vÃ©rifiez vos autorisations de lecture/Ã©criture.',0),(488047,13557,'jp','æ›¸ãè¾¼ã¿ã«å¤±æ•—ã—ã¾ã—ãŸ ï¼ãƒãƒƒã‚¯ã‚¢ãƒƒãƒ—ã‚’ä½œæˆã§ãã¾ã›ã‚“èª­ã¿å–ã‚Š/æ›¸ãè¾¼ã¿ã®ã‚¢ã‚¯ã‚»ã‚¹è¨±å¯ã‚’ç¢ºèªã—ã¦ãã ã•ã„ã€‚',0),(488048,13557,'pt','GravaÃ§Ã£o falhou! NÃ£o Ã© possÃ­vel criar um backup, por favor, verifique as permissÃµes de leitura/gravaÃ§Ã£o.',0),(488049,13557,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸! ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ñ€ÐµÐ·ÐµÑ€Ð²Ð½ÑƒÑŽ ÐºÐ¾Ð¿Ð¸ÑŽ, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð´Ð»Ñ Ñ‡Ñ‚ÐµÐ½Ð¸Ñ Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸.',0),(488050,13557,'es','Escribir fallÃ³! No se puede crear respalda, por favor revisar su permisos leer/escribir',0),(488051,13557,'de','Schreiben fehlgeschlagen! Kann nicht erstellt backup, Ã¼berprÃ¼fen Sie bitte Ihre Lese-/Schreibberechtigungen.',0),(488052,13557,'en','Write failed! Cannot create backup, please check your read/write permissions.',0),(488053,13558,'is','',0),(488054,13558,'dr','Ø´Ù…Ø§ Ù‡Ù†ÙˆØ² Ø±ØªØ¨Ù‡ Ø¯Ù‡ÛŒ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù¾Ù„Ø§Ú¯ÛŒÙ† Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Ø±Ø¯Ù‡ Ø§Ø³Øª.',0),(488055,13558,'pr','Ø´Ù…Ø§ Ù‡Ù†ÙˆØ² Ø±ØªØ¨Ù‡ Ø¯Ù‡ÛŒ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù¾Ù„Ø§Ú¯ÛŒÙ† Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Ø±Ø¯Ù‡ Ø§Ø³Øª.',0),(488056,13558,'tr','HenÃ¼z stok fiÅŸ satÄ±n deÄŸil.',0),(488057,13558,'pl','Nie nabyli jeszcze spis plug-in.',0),(488058,13558,'bg','Ð’ÑÐµ Ð¾Ñ‰Ðµ Ð½Ðµ ÑÑ‚Ðµ ÐºÑƒÐ¿Ð¸Ð»Ð¸ Ð¾Ð¿Ð¸ÑÐ° plug-in.',0),(488059,13558,'ur','Ø¢Ù¾ Ø§Ø¨Ú¾ÛŒ ØªÚ© Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù¾Ù„Ú¯-Ø§Ù† Ú©Ùˆ Ø®Ø±ÛŒØ¯Ø§ ÛÛ’ Ù†ÛÛŒÚº Û”',0),(488060,13558,'sr','Ð’Ð¸ Ñ˜Ð¾Ñˆ Ð½Ð¸ÑÑ‚Ðµ Ð½Ð°Ð±Ð°Ð²Ð¸Ð»Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°.',0),(488061,13558,'vi','Báº¡n Ä‘Ã£ khÃ´ng Ä‘Æ°á»£c mua hÃ ng tá»“n kho plug-in.',0),(488062,13558,'af','Jy het nie nog gekoop die inpropprogram voorraad.',0),(488063,13558,'ro','Nu ati cumparat inca inventarul plug-in.',0),(488064,13558,'et','Ei ole veel ostetud varude plug-in.',0),(488065,13558,'si','Å e niste kupili plug-in zaloge.',0),(488066,13558,'ba','Anda belum membeli persediaan plug-in.',0),(488067,13558,'nl','U hebt de inventaris plug-in nog niet gekocht.',0),(488068,13558,'fi','Et ole vielÃ¤ ostanut varaston laajennus.',0),(488069,13558,'no','Du ennÃ¥ ikke har kjÃ¸pt lager plug-in.',0),(488070,13558,'da','Du har endnu ikke kÃ¸bt lageret plug-in.',0),(488071,13558,'ko','ìž¬ê³  í”ŒëŸ¬ê·¸ì¸ì„ ì•„ì§ êµ¬ìž… í•˜ì§€ ì•Šì€.',0),(488072,13558,'he','×œ× ×¨×›×©×ª ×¢×“×™×™×Ÿ ××ª ×”×ž×œ××™ plug-in.',0),(488073,13558,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Î±Î³Î¿ÏÎ¬ÏƒÎµÎ¹ Î±ÎºÏŒÎ¼Î· Ï„Î¿ plug-in Î±Ï€Î¿Î³ÏÎ±Ï†Î®.',0),(488074,13558,'zh','å°šæœªè´­ä¹°åº“å­˜æ’ä»¶ã€‚',0),(488075,13558,'sv','Du har Ã¤nnu inte kÃ¶pt lagret plug-in.',0),(488076,13558,'it','Non avete ancora acquistato l\'inventario plug-in.',0),(488077,13558,'tl','',0),(488078,13558,'th','à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸‹à¸·à¹‰à¸­à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸›à¸¥à¸±à¹Šà¸à¸­à¸´à¸™',0),(488079,13558,'hi','à¤¤à¥à¤® à¤…à¤­à¥€ à¤¤à¤• à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤ªà¥à¤²à¤—-à¤‡à¤¨ à¤¨à¤¹à¥€à¤‚ à¤–à¤°à¥€à¤¦à¤¾ à¤¹à¥ˆà¥¤',0),(488080,13558,'ms','Anda tidak lagi membeli inventori plug-in.',0),(488081,13558,'ar','Ù„Ù… ØªÙƒÙ† Ø¨Ø¹Ø¯ Ù‚Ø¯ Ø§Ø´ØªØ±ÙŠØª Ø§Ù„Ù…ÙƒÙˆÙ†Ø§Øª ÙÙŠ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ø±Ø¯.',0),(488082,13558,'fr','Vous n\'avez pas encore achetÃ© le plug-in de l\'inventaire.',0),(488083,13558,'jp','ãƒ—ãƒ©ã‚°ã‚¤ãƒ³ã®åœ¨åº«ã‚’ã¾ã è³¼å…¥ã—ã¦ã„ã¾ã›ã‚“ã€‚',0),(488084,13558,'pt','VocÃª ainda nÃ£o comprou o plug-in de inventÃ¡rio.',0),(488085,13558,'ru','Ð’Ñ‹ ÐµÑ‰Ðµ Ð½Ðµ Ð¿Ñ€Ð¸Ð¾Ð±Ñ€ÐµÐ»Ð¸ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿Ð»Ð°Ð³Ð¸Ð½Ð°.',0),(488086,13558,'es','AÃºn no ha adquirido el inventario plug-in.',0),(488087,13558,'de','Sie haben noch nicht das plug-in Inventar gekauft.',0),(488088,13558,'en','You have not yet purchased the inventory plug-in.',0),(488089,13559,'is','',0),(488090,13559,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø§Ø¬Ø§Ø²Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª.',0),(488091,13559,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø§Ø¬Ø§Ø²Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª.',0),(488092,13559,'tr','Ã–deme yetkilendirmeniz gerekir.',0),(488093,13559,'pl','NaleÅ¼y zezwoliÄ‡ na pÅ‚atnoÅ›Ä‡.',0),(488094,13559,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ñ€Ð°Ð·Ñ€ÐµÑˆÐ¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾.',0),(488095,13559,'ur','Ø¢Ù¾ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¶Ø±ÙˆØ±ÛŒ ÛÛ’ Û”',0),(488096,13559,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð¸ Ð¸ÑÐ¿Ð»Ð°Ñ‚Ñƒ.',0),(488097,13559,'vi','Báº¡n pháº£i cho phÃ©p cÃ¡c khoáº£n thanh toÃ¡n.',0),(488098,13559,'af','U moet die betaling magtig.',0),(488099,13559,'ro','Tu trebuie sÄƒ autorizeze o platÄƒ.',0),(488100,13559,'et','Makse peab lubama.',0),(488101,13559,'si','PlaÄilo je treba dovoliti.',0),(488102,13559,'ba','Melakukan autorisasi pembayaran.',0),(488103,13559,'nl','De betaling moet u machtigen.',0),(488104,13559,'fi','Valtuutat maksun.',0),(488105,13559,'no','Du mÃ¥ godkjenne betalingen.',0),(488106,13559,'da','Du skal godkende betalingen.',0),(488107,13559,'ko','ì§€ë¶ˆì„ ìŠ¹ì¸ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(488108,13559,'he','××ª×” ×—×™×™×‘ ×œ××©×¨ ××ª ×”×ª×©×œ×•×.',0),(488109,13559,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¾Î¿Ï…ÏƒÎ¹Î¿Î´Î¿Ï„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î®.',0),(488110,13559,'zh','æ‚¨å¿…é¡»æŽˆæƒæ”¯ä»˜ã€‚',0),(488111,13559,'sv','Du mÃ¥ste godkÃ¤nna betalningen.',0),(488112,13559,'it','Deve autorizzare il pagamento.',0),(488113,13559,'tl','',0),(488114,13559,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(488115,13559,'hi','à¤†à¤ª à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‹ à¤ªà¥à¤°à¤¾à¤§à¤¿à¤•à¥ƒà¤¤ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(488116,13559,'ms','Anda mesti membenarkan pembayaran.',0),(488117,13559,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªÙÙˆÙŠØ¶ Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ø¯ÙØ¹.',0),(488118,13559,'fr','Vous devez autoriser le paiement.',0),(488119,13559,'jp','æ”¯æ‰•ã„ã‚’æ‰¿èªã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(488120,13559,'pt','VocÃª deve autorizar o pagamento.',0),(488121,13559,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐ°Ð½ÐºÑ†Ð¸Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶.',0),(488122,13559,'es','Debe autorizar el pago',0),(488123,13559,'de','Sie mÃ¼ssen die Zahlung autorisieren.',0),(488124,13559,'en','You must authorize the payment.',0),(488125,13560,'is','',0),(488126,13560,'dr','Ù†ÙˆØ´ØªÙ† Ù¾Ø³ØªÛŒ Ù†Ø´Ø¯!',0),(488127,13560,'pr','Ù†ÙˆØ´ØªÙ† Ù¾Ø³ØªÛŒ Ù†Ø´Ø¯!',0),(488128,13560,'tr','ZIP yazma baÅŸarÄ±sÄ±z oldu!',0),(488129,13560,'pl','Zip zapis nie powiÃ³dÅ‚ siÄ™!',0),(488130,13560,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ Ð·Ð°Ð¿Ð¸Ñ Ð½Ðµ ÑƒÑÐ¿Ñ!',0),(488131,13560,'ur','Ø²Ù¾ Ù„Ú©Ú¾Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…!',0),(488132,13560,'sr','Ð—Ð˜ÐŸ ÑƒÐ¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾!',0),(488133,13560,'vi','Sá»‘ Zip viáº¿t tháº¥t báº¡i!',0),(488134,13560,'af','Zip skryf het misluk!',0),(488135,13560,'ro','Zip scrie nu a reuÅŸit!',0),(488136,13560,'et','ZIP kirjutamine nurjus!',0),(488137,13560,'si','Zip pisanje ni uspelo!',0),(488138,13560,'ba','Zip menulis gagal!',0),(488139,13560,'nl','Zip schrijfbewerkingen zijn mislukt!',0),(488140,13560,'fi','Zip kirjoitus epÃ¤onnistui!',0),(488141,13560,'no','Zip skrivefeil!',0),(488142,13560,'da','Zip skrivningen mislykkedes!',0),(488143,13560,'ko','ìš°íŽ¸ ì“°ê¸° ì‹¤íŒ¨!',0),(488144,13560,'he','Zip ×›×ª×™×‘×” × ×›×©×œ×”!',0),(488145,13560,'el','Zip ÎµÎ³Î³ÏÎ±Ï†Î® Î±Ï€Î­Ï„Ï…Ï‡Îµ!',0),(488146,13560,'zh','é‚®ç¼–å†™å…¥å¤±è´¥ ï¼',0),(488147,13560,'sv','Zip skrivning misslyckades!',0),(488148,13560,'it','Zip Scrivi Impossibile!',0),(488149,13560,'tl','',0),(488150,13560,'th','à¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œà¹€à¸‚à¸µà¸¢à¸™à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(488151,13560,'hi','à¤œà¤¼à¤¿à¤ª à¤µà¤¿à¤²à¤‚à¤¬ à¤²à¥‡à¤–à¤¨ à¤µà¤¿à¤«à¤²!',0),(488152,13560,'ms','Zip tulis gagal!',0),(488153,13560,'ar','ÙØ´Ù„ ÙƒØªØ§Ø¨Ø© Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ!',0),(488154,13560,'fr','Zip Ã©criture a Ã©chouÃ© !',0),(488155,13560,'jp','Zip ã®æ›¸ãè¾¼ã¿ã«å¤±æ•—ã—ã¾ã—ãŸ ï¼',0),(488156,13560,'pt','Zip gravaÃ§Ã£o falhada!',0),(488157,13560,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ¸ zip!',0),(488158,13560,'es','FallÃ³ Escribir a Zip!',0),(488159,13560,'de','ZIP schreiben fehlgeschlagen!',0),(488160,13560,'en','Zip write failed!',0),(488161,13561,'is','',0),(488162,13561,'dr','Ú©Ø¯ Ú©Ø§Ù„Ø§ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ø¨Ø§Ø±Ú©Ø¯. Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø´Ø§Ù…Ù„ Ú©Ø¯ Ú©Ø§Ù„Ø§',0),(488163,13561,'pr','Ú©Ø¯ Ú©Ø§Ù„Ø§ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ø¨Ø§Ø±Ú©Ø¯. Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø´Ø§Ù…Ù„ Ú©Ø¯ Ú©Ø§Ù„Ø§',0),(488164,13561,'tr','Madde kodu Barkod olarak dÃ¶nÃ¼ÅŸtÃ¼rÃ¼lemez. Madde kodu iÃ§eremez',0),(488165,13561,'pl','Nie moÅ¼na przekonwertowaÄ‡ kod towaru do kodÃ³w kreskowych. Nie moÅ¼e zawieraÄ‡ kod towaru',0),(488166,13561,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð° ÐºÐ¾Ð´ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð±Ð°Ñ€ÐºÐ¾Ð´. ÐšÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÑŠÐ´ÑŠÑ€Ð¶Ð°',0),(488167,13561,'ur','Ø´Û’ Ú©ÙˆÚˆ Ø¨Ø§Ø±Ú©ÙˆÚˆ Ú©Ùˆ Ù†ÛÛŒÚº Ø¨Ø¯Ù„ Ø³Ú©ØªØ§ Û” Ø´Û’ Ø¶Ø§Ø¨Ø·Û Ú©ÛŒ Ø­Ø§Ù…Ù„ ÛÙˆ Ø³Ú©ØªÛŒ',0),(488168,13561,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ð²Ð°Ñ‚Ð¸ Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ñƒ Ð±Ð°Ñ€ ÐºÐ¾Ð´Ñƒ. ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐ°Ð´Ñ€Ð¶Ð¸ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(488169,13561,'vi','KhÃ´ng thá»ƒ chuyá»ƒn Ä‘á»•i má»¥c mÃ£ Ä‘á»ƒ mÃ£ váº¡ch. Má»¥c mÃ£ khÃ´ng thá»ƒ chá»©a',0),(488170,13561,'af','Kan omskep in item kode strepieskode. Item kode bevat nie',0),(488171,13561,'ro','Nu poate converti element cod de bare. Cod articol nu conÅ£ine',0),(488172,13561,'et','Ei saa teisendada kaubakoodi, vÃ¶Ã¶tkoodi. Kauba kood ei tohi sisaldada',0),(488173,13561,'si','Å ifra artikla ni mogoÄe pretvoriti v Ärtno kodo. Å ifra artikla ne sme vsebovati',0),(488174,13561,'ba','Tidak dapat mengkonversi kode barang ke barcode. Kode barang tidak boleh berisi',0),(488175,13561,'nl','Niet converteren Artikelcode naar barcode. Artikelcode mag geen bevatten',0),(488176,13561,'fi','Nimikkeen koodi ei voi muuntaa viivakoodi. Nimikkeen koodi voi sisÃ¤ltÃ¤Ã¤',0),(488177,13561,'no','Kan ikke konvertere Varekode til strekkode. Varekode kan ikke inneholde',0),(488178,13561,'da','Kan ikke konvertere varekode til stregkode. Varekoden kan ikke indeholde',0),(488179,13561,'ko','ë°”ì½”ë“œ í•­ëª© ì½”ë“œë¥¼ ë³€í™˜í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤. í•­ëª© ì½”ë“œë¥¼ í¬í•¨í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(488180,13561,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×ž×™×¨ ×§×•×“ ×¤×¨×™×˜ ×‘×¨×§×•×“. ×§×•×“ ×¤×¨×™×˜ ××™× ×• ×™×›×•×œ ×œ×”×›×™×œ',0),(488181,13561,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î¼ÎµÏ„Î±Ï„ÏÎ­ÏˆÎµÏ„Îµ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ barcode. ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï€ÎµÏÎ¹Î­Ï‡ÎµÎ¹',0),(488182,13561,'zh','ä¸èƒ½å°†ç‰©æ–™ä»£ç è½¬æ¢ä¸ºæ¡ç ã€‚é¡¹ç›®ä»£ç ä¸­ä¸èƒ½åŒ…å«',0),(488183,13561,'sv','Kan inte konvertera kod till streckkod. Artikelkoden fÃ¥r inte innehÃ¥lla',0),(488184,13561,'it','Non Ã¨ possibile convertire codice articolo codice a barre. Non puÃ² contenere il codice articolo',0),(488185,13561,'tl','',0),(488186,13561,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹à¸›à¸¥à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸£à¸«à¸±à¸ªà¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸” à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²à¹„à¸¡à¹ˆà¸›à¸£à¸°à¸à¸­à¸šà¸”à¹‰à¸§à¸¢',0),(488187,13561,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤•à¥‹ à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾à¥¤ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¥‡',0),(488188,13561,'ms','Tidak boleh menukar Kod item ke Kod Bar. Kod item tidak boleh mengandungi',0),(488189,13561,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­ÙˆÙŠÙ„ ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù Ù„Ù„Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠ. Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù',0),(488190,13561,'fr','Impossible de convertir un code article en code Ã  barres. Ne peut pas contenir de code article',0),(488191,13561,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã«å•†å“ã‚³ãƒ¼ãƒ‰ã‚’å¤‰æ›ã§ãã¾ã›ã‚“ã€‚é …ç›®ã‚³ãƒ¼ãƒ‰ã‚’å«ã‚ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(488192,13561,'pt','NÃ£o Ã© possÃ­vel converter o cÃ³digo para cÃ³digo de barras. CÃ³digo do artigo nÃ£o pode conter',0),(488193,13561,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð°, ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´. ÐšÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ ÑÐ¾Ð´ÐµÑ€Ð¶Ð°Ñ‚ÑŒ',0),(488194,13561,'es','No se puede convertir cÃ³digo de item a cÃ³digo de barra. CÃ³digo de item no puede contener',0),(488195,13561,'de','Artikelnummer kann nicht Barcode konvertiert werden. Feld-Code kann nicht enthalten',0),(488196,13561,'en','Cannot convert item code to barcode. Item code cannot contain',0),(488197,13562,'is','',0),(488198,13562,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø¶Ø§ÙÛŒ',0),(488199,13562,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø¶Ø§ÙÛŒ',0),(488200,13562,'tr','Ekstra Ã¼cretleri ekleme',0),(488201,13562,'pl','DodaÄ‡ dodatkowe opÅ‚aty',0),(488202,13562,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(488203,13562,'ur','Ø§Ø¶Ø§ÙÛŒ Ú†Ø§Ø±Ø¬Ø² Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(488204,13562,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(488205,13562,'vi','ThÃªm phá»¥ phÃ­',0),(488206,13562,'af','Voeg ekstra kostes',0),(488207,13562,'ro','Adauga costuri suplimentare',0),(488208,13562,'et','Lisatakse lisatasud',0),(488209,13562,'si','Dodajanje dodatnih stroÅ¡kov',0),(488210,13562,'ba','Menambahkan biaya tambahan',0),(488211,13562,'nl','Toevoegen Extra kosten',0),(488212,13562,'fi','LisÃ¤Ã¤ ylimÃ¤Ã¤rÃ¤isiÃ¤ maksuja',0),(488213,13562,'no','Legge til ekstra kostnader',0),(488214,13562,'da','TilfÃ¸je ekstra afgifter',0),(488215,13562,'ko','ì¶”ê°€ ìš”ê¸ˆ ì¶”ê°€',0),(488216,13562,'he','×œ×”×•×¡×™×£ ×ª×©×œ×•× × ×•×¡×£',0),(488217,13562,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(488218,13562,'zh','æ·»åŠ é¢å¤–çš„æ”¶è´¹',0),(488219,13562,'sv','LÃ¤gg till Extra avgifter',0),(488220,13562,'it','Aggiungi spese Extra',0),(488221,13562,'tl','',0),(488222,13562,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸žà¸´à¹€à¸¨à¸©',0),(488223,13562,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¶à¥à¤²à¥à¤• à¤œà¥‹à¤¡à¤¼',0),(488224,13562,'ms','Tambah caj-caj tambahan',0),(488225,13562,'ar','Ø¥Ø¶Ø§ÙØ© Ø±Ø³ÙˆÙ… Ø¥Ø¶Ø§ÙÙŠØ©',0),(488226,13562,'fr','Ajouter des frais supplÃ©mentaires',0),(488227,13562,'jp','è¿½åŠ æ–™é‡‘ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(488228,13562,'pt','Adicionar custos extras',0),(488229,13562,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÐ±Ð¾Ñ€Ñ‹',0),(488230,13562,'es','Agregar Cargos Extras',0),(488231,13562,'de','HinzufÃ¼gen von zusÃ¤tzlichen GebÃ¼hren',0),(488232,13562,'en','Add Extra Charges',0),(488233,13563,'is','',0),(488234,13563,'dr','Ù†Ù…Ø§ÛŒØ´ Ø²ÛŒØ± Ù…Ø¬Ù…ÙˆØ¹Ù‡Ø§ÛŒ',0),(488235,13563,'pr','Ù†Ù…Ø§ÛŒØ´ Ø²ÛŒØ± Ù…Ø¬Ù…ÙˆØ¹Ù‡Ø§ÛŒ',0),(488236,13563,'tr','Alt toplamÄ± gÃ¶ster',0),(488237,13563,'pl','PokaÅ¼ sumy',0),(488238,13563,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð¼ÐµÐ¶Ð´Ð¸Ð½Ð½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(488239,13563,'ur','Ø°ÛŒÙ„ÛŒ Ù…ÛŒØ²Ø§Ù† Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(488240,13563,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾Ð´Ð·Ð±Ð¸Ñ€Ð¾Ð²Ð°',0),(488241,13563,'vi','Hiá»ƒn thá»‹ Subtotal',0),(488242,13563,'af','Wys Subtotal',0),(488243,13563,'ro','AratÄƒ subtotaluri',0),(488244,13563,'et','Kuva vahekokkuvÃµtte',0),(488245,13563,'si','PokaÅ¾i vmesno vsoto',0),(488246,13563,'ba','Tampilkan Subtotal',0),(488247,13563,'nl','Subtotaal weergeven',0),(488248,13563,'fi','NÃ¤ytÃ¤ vÃ¤lisumma',0),(488249,13563,'no','Vis delsum',0),(488250,13563,'da','Vise Subtotal',0),(488251,13563,'ko','ë¶€ë¶„í•© í‘œì‹œ',0),(488252,13563,'he','×”×¦×’ ×¡×›×•× ×‘×™× ×™×™×',0),(488253,13563,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï…Ï€Î¿ÏƒÏ…Î½ÏŒÎ»Î¿Ï…',0),(488254,13563,'zh','æ˜¾ç¤ºå°è®¡',0),(488255,13563,'sv','Visa delsumma',0),(488256,13563,'it','Visualizza il subtotale',0),(488257,13563,'tl','',0),(488258,13563,'th','à¹à¸ªà¸”à¸‡à¸œà¸¥à¸£à¸§à¸¡à¸¢à¹ˆà¸­à¸¢',0),(488259,13563,'hi','à¤‰à¤ª-à¤¯à¥‹à¤— à¤¦à¤¿à¤–à¤¾à¤à¤',0),(488260,13563,'ms','Menunjukkan jumlah kecil',0),(488261,13563,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ',0),(488262,13563,'fr','Afficher le sous-total',0),(488263,13563,'jp','å°è¨ˆã®è¡¨ç¤ºã—ã¾ã™ã€‚',0),(488264,13563,'pt','Mostrar Subtotal',0),(488265,13563,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð˜Ñ‚Ð¾Ð³Ð¾',0),(488266,13563,'es','Muestra Subtotal',0),(488267,13563,'de','Teilergebnis anzeigen',0),(488268,13563,'en','Show Subtotal',0),(488269,13564,'is','',0),(488270,13564,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(488271,13564,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(488272,13564,'tr','SatÄ±ÅŸ temsilcisi toplam',0),(488273,13564,'pl','Sprzedawca Å‚Ä…cznie',0),(488274,13564,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÐµÑ† Ð¾Ð±Ñ‰Ð¾',0),(488275,13564,'ur','Ù¾Ø±Ø³Ù† Ú©Ù„',0),(488276,13564,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ† ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(488277,13564,'vi','Tá»•ng sá»‘ nhÃ¢n viÃªn bÃ¡n hÃ ng',0),(488278,13564,'af','Verkoopspersoon totaal',0),(488279,13564,'ro','Total vÃ¢nzÄƒri',0),(488280,13564,'et','MÃ¼Ã¼giisiku kokku',0),(488281,13564,'si','Prodajalec skupaj',0),(488282,13564,'ba','Total tenaga penjual',0),(488283,13564,'nl','Totaal verkoper',0),(488284,13564,'fi','MyyjÃ¤ yhteensÃ¤',0),(488285,13564,'no','Selger totalt',0),(488286,13564,'da','SÃ¦lger alt',0),(488287,13564,'ko','ì´ íŒë§¤ì›',0),(488288,13564,'he','×¡×š ×ž×›×™×¨×•×ª',0),(488289,13564,'el','Î£ÏÎ½Î¿Î»Î¿ Ï€Ï‰Î»Î·Ï„Î®',0),(488290,13564,'zh','é”€å”®äººå‘˜æ€»æ•°',0),(488291,13564,'sv','SÃ¤ljare totalt',0),(488292,13564,'it','Totale agente',0),(488293,13564,'tl','',0),(488294,13564,'th','à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(488295,13564,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯à¤•à¤°à¥à¤¤à¤¾ à¤•à¥à¤²',0),(488296,13564,'ms','Jumlah jurujual',0),(488297,13564,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(488298,13564,'fr','Total de vendeur',0),(488299,13564,'jp','è²©å£²å“¡ã®åˆè¨ˆ',0),(488300,13564,'pt','Total de vendedor',0),(488301,13564,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(488302,13564,'es','Total de Vendedores',0),(488303,13564,'de','VerkÃ¤ufer Total',0),(488304,13564,'en','Salesperson Total',0),(488305,13565,'is','',0),(488306,13565,'dr','ØªÙˆØ³Ø· ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(488307,13565,'pr','ØªÙˆØ³Ø· ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(488308,13565,'tr','SatÄ±ÅŸ temsilcisine gÃ¶re',0),(488309,13565,'pl','Przez sprzedawcÄ™',0),(488310,13565,'bg','ÐŸÐ¾ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(488311,13565,'ur','Ù¾Ø±Ø³Ù† Ú©ÛŒ Ø·Ø±Ù Ø³Û’',0),(488312,13565,'sr','ÐžÐ´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(488313,13565,'vi','Bá»Ÿi nhÃ¢n viÃªn bÃ¡n hÃ ng',0),(488314,13565,'af','Per Verkoopspersoon',0),(488315,13565,'ro','De agent de vanzari',0),(488316,13565,'et','MÃ¼Ã¼giisiku',0),(488317,13565,'si','Prodajalca',0),(488318,13565,'ba','Oleh Penjual',0),(488319,13565,'nl','Door verkoper',0),(488320,13565,'fi','MyyjÃ¤n',0),(488321,13565,'no','Selger',0),(488322,13565,'da','Efter sÃ¦lger',0),(488323,13565,'ko','ì˜ì—… ì‚¬ì›ì— ì˜í•´',0),(488324,13565,'he','×œ×¤×™ ××™×© ×ž×›×™×¨×•×ª',0),(488325,13565,'el','ÎšÎ±Ï„Î¬ Ï€Ï‰Î»Î·Ï„Î®',0),(488326,13565,'zh','æŒ‰é”€å”®äººå‘˜',0),(488327,13565,'sv','Av sÃ¤ljare',0),(488328,13565,'it','Da venditore',0),(488329,13565,'tl','',0),(488330,13565,'th','à¹‚à¸”à¸¢à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢',0),(488331,13565,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤ªà¥à¤°à¤¤à¤¿à¤¨à¤¿à¤§à¤¿',0),(488332,13565,'ms','Oleh jurujual',0),(488333,13565,'ar','Ø­Ø³Ø¨ Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(488334,13565,'fr','Par vendeur',0),(488335,13565,'jp','è²©å£²å“¡',0),(488336,13565,'pt','Por vendedor',0),(488337,13565,'ru','ÐŸÐ¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°Ð¼',0),(488338,13565,'es','Por Vendedor',0),(488339,13565,'de','Verkaufsberater',0),(488340,13565,'en','By Salesperson',0),(488341,13566,'is','',0),(488342,13566,'dr','Ú©Ù„Ù…Ù‡ Ú©Ù„ÛŒØ¯ÛŒ Ø±Ø§ Ø¯Ø± Ø®Ø· ØªÙˆØ¶ÛŒØ­Ø§Øª ÛŒØ§ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(488343,13566,'pr','Ú©Ù„Ù…Ù‡ Ú©Ù„ÛŒØ¯ÛŒ Ø±Ø§ Ø¯Ø± Ø®Ø· ØªÙˆØ¶ÛŒØ­Ø§Øª ÛŒØ§ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(488344,13566,'tr','SatÄ±r aÃ§Ä±klama veya Not anahtar sÃ¶zcÃ¼k',0),(488345,13566,'pl','SÅ‚owo kluczowe w opis linii lub notatek',0),(488346,13566,'bg','ÐšÐ»ÑŽÑ‡Ð¾Ð²Ð° Ð´ÑƒÐ¼Ð° Ð² Ñ€ÐµÐ´Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¸Ð»Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(488347,13566,'ur','Ù„Ø§Ø¦Ù† Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª ÛŒØ§ Ù†ÙˆÙ¹ Ù…ÛŒÚº Ú©Ù„ÛŒØ¯ÛŒ Ù„ÙØ¸',0),(488348,13566,'sr','ÐšÑ™ÑƒÑ‡Ð½Ðµ Ñ€ÐµÑ‡Ð¸ Ñƒ Ð¾Ð¿Ð¸Ñ Ñ€ÐµÐ´Ð° Ð¸Ð»Ð¸ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(488349,13566,'vi','Tá»« khoÃ¡ trong dÃ²ng mÃ´ táº£ hoáº·c ghi chÃº',0),(488350,13566,'af','Trefwoord In lyn Beskrywing of notas',0),(488351,13566,'ro','Cuvinte cheie In linia de descriere sau note',0),(488352,13566,'et','MÃ¤rksÃµna rea kirjeldus vÃµi mÃ¤rkmete',0),(488353,13566,'si','KljuÄne besede v opis vrstice ali opombe',0),(488354,13566,'ba','Kata kunci dalam baris keterangan atau catatan',0),(488355,13566,'nl','Sleutelwoord In lijn beschrijving of notities',0),(488356,13566,'fi','Avainsanan kuvaus tai muistiinpanoja',0),(488357,13566,'no','NÃ¸kkelordet i linje beskrivelse eller notater',0),(488358,13566,'da','NÃ¸gleord i beskrivelsen eller noter',0),(488359,13566,'ko','ë¼ì¸ ì„¤ëª… ë˜ëŠ” ë©”ëª¨ í‚¤ì›Œë“œ',0),(488360,13566,'he','×ž×™×œ×ª ×ª×™××•×¨ ×©×•×¨×ª ××• ×”×¢×¨×•×ª',0),(488361,13566,'el','Î›Î­Î¾Î·-ÎºÎ»ÎµÎ¹Î´Î¯ ÏƒÏ„Î· Î³ÏÎ±Î¼Î¼Î® Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î® ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(488362,13566,'zh','è¡Œæè¿°æˆ–æ³¨é‡Šä¸­çš„å…³é”®å­—',0),(488363,13566,'sv','Nyckelord i beskrivning eller anteckningar',0),(488364,13566,'it','Parola chiave nella descrizione di linea o note',0),(488365,13566,'tl','',0),(488366,13566,'th','à¸„à¸³à¸ªà¸³à¸„à¸±à¸à¹ƒà¸™à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸£à¸²à¸¢à¸à¸²à¸£à¸«à¸£à¸·à¸­à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸',0),(488367,13566,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤µà¤°à¥à¤£à¤¨ à¤¯à¤¾ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤®à¥‡à¤‚ à¤–à¥‹à¤œà¤¶à¤¬à¥à¤¦',0),(488368,13566,'ms','Kata kunci huraian garis atau Nota-Nota',0),(488369,13566,'ar','Ø§Ù„ÙƒÙ„Ù…Ø© Ø§Ù„Ø£Ø³Ø§Ø³ÙŠØ© ÙÙŠ Ø³Ø·Ø± ÙˆØµÙ Ø£Ùˆ Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(488370,13566,'fr','Mot clÃ© en ligne Description ou Notes',0),(488371,13566,'jp','ã‚­ãƒ¼ãƒ¯ãƒ¼ãƒ‰ã®è¡Œã®èª¬æ˜Žã¾ãŸã¯ãƒ¡ãƒ¢',0),(488372,13566,'pt','Palavra-chave na linha de descriÃ§Ã£o ou notas',0),(488373,13566,'ru','ÐšÐ»ÑŽÑ‡ÐµÐ²Ð¾Ðµ ÑÐ»Ð¾Ð²Ð¾ Ð² ÑÑ‚Ñ€Ð¾ÐºÐµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(488374,13566,'es','Palabra Clave en DescripciÃ³n de Linea O Las Notas',0),(488375,13566,'de','SchlÃ¼sselwort In Zeile Beschreibung oder Anmerkungen',0),(488376,13566,'en','Keyword In Line Description Or Notes',0),(488377,13567,'is','',0),(488378,13567,'dr','Ù¾Ø§ÛŒÛŒÙ† ØªØ±ÛŒÙ† Ù‚ÛŒÙ…Øª Ø¯Ø± Ø¨ÛŒÙ† Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ &amp; Ù…Ø´ØªØ±ÛŒØ§Ù† Ú¯Ø±ÙˆÙ‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(488379,13567,'pr','Ù¾Ø§ÛŒÛŒÙ† ØªØ±ÛŒÙ† Ù‚ÛŒÙ…Øª Ø¯Ø± Ø¨ÛŒÙ† Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ &amp; Ù…Ø´ØªØ±ÛŒØ§Ù† Ú¯Ø±ÙˆÙ‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(488380,13567,'tr','Standart & mÃ¼ÅŸteri grubu arasÄ±nda en dÃ¼ÅŸÃ¼k fiyatÄ± kullanÄ±r',0),(488381,13567,'pl','UÅ¼yje najniÅ¼sza cena miÄ™dzy Standard & grupy klientÃ³w',0),(488382,13567,'bg','Ð©Ðµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð½Ð°Ð¹-Ð½Ð¸ÑÐºÐ°Ñ‚Ð° Ñ†ÐµÐ½Ð° Ð¼ÐµÐ¶Ð´Ñƒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ & Ð³Ñ€ÑƒÐ¿Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(488383,13567,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ & Ú©Ø³Ù¹Ù…Ø± Ú¯Ø±ÙˆÙ¾ Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† Ø³Ø¨ Ø³Û’ Ú©Ù… Ù‚ÛŒÙ…Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Û’ Ú¯Ø§',0),(488384,13567,'sr','Ð‹Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð½Ð°Ñ˜Ð½Ð¸Ð¶Ðµ Ñ†ÐµÐ½Ðµ Ð¸Ð·Ð¼ÐµÑ’Ñƒ Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´ & Ð³Ñ€ÑƒÐ¿Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(488385,13567,'vi','Sáº½ sá»­ dá»¥ng giÃ¡ tháº¥p nháº¥t giá»¯a tiÃªu chuáº©n &amp; khÃ¡ch hÃ ng nhÃ³m',0),(488386,13567,'af','Laagste prys tussen standaard & kliÃ«nt groep sal gebruik',0),(488387,13567,'ro','Va utiliza cel mai mic preÅ£ Ã®ntre Standard & grup de client',0),(488388,13567,'et','Kasutame madalaima hinna vahel standardi & kliendigrupp',0),(488389,13567,'si','NajniÅ¾jo ceno med Standard & skupina kupca',0),(488390,13567,'ba','Akan menggunakan harga yang terendah antara standar & kelompok pelanggan',0),(488391,13567,'nl','Laagste prijs tussen standaard & klantgroep zal gebruiken',0),(488392,13567,'fi','KÃ¤yttÃ¤Ã¤ Alin hinta vÃ¤lillÃ¤ standardi & asiakasryhmÃ¤',0),(488393,13567,'no','Bruke lavest pris mellom Standard & kundegruppe',0),(488394,13567,'da','Vil bruge laveste pris mellem Standard & debitorgruppe',0),(488395,13567,'ko','ìµœì € ê°€ê²© í‘œì¤€ & ê³ ê° ê·¸ë£¹ ì‚¬ì´ ì‚¬ìš© í•©ë‹ˆë‹¤.',0),(488396,13567,'he','×™×©×ª×ž×© ×”×ž×—×™×¨ ×”× ×ž×•×š ×‘×™×•×ª×¨ ×‘×™×Ÿ ×ª×§×Ÿ & ×§×‘×•×¦×ª ×œ×œ×§×•×—',0),(488397,13567,'el','Î˜Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹ Ï‡Î±Î¼Î·Î»ÏŒÏ„ÎµÏÎ· Ï„Î¹Î¼Î® Î¼ÎµÏ„Î±Î¾Ï Ï€ÏÏŒÏ„Ï…Ï€Î¿ & Î¿Î¼Î¬Î´Î± Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(488398,13567,'zh','å°†ä½¿ç”¨æ ‡å‡† &amp; å®¢æˆ·ç¾¤ä¹‹é—´çš„æœ€ä½Žä»·æ ¼',0),(488399,13567,'sv','Kommer att anvÃ¤nda lÃ¤gsta pris mellan Standard & kundgrupp',0),(488400,13567,'it','UtilizzerÃ  il prezzo piÃ¹ basso tra Standard & gruppo di clienti',0),(488401,13567,'tl','',0),(488402,13567,'th','à¸ˆà¸°à¹ƒà¸Šà¹‰à¸£à¸²à¸„à¸²à¸•à¹ˆà¸³à¸ªà¸¸à¸”à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸¡à¸²à¸•à¸£à¸à¸²à¸™ & à¸à¸¥à¸¸à¹ˆà¸¡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(488403,13567,'hi','à¤®à¤¾à¤¨à¤• & à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤®à¥‚à¤¹ à¤•à¥‡ à¤¬à¥€à¤š à¤¸à¤¬à¤¸à¥‡ à¤•à¤® à¤®à¥‚à¤²à¥à¤¯ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤—à¤¾',0),(488404,13567,'ms','Akan menggunakan harga terendah antara Standard & Kumpulan pelanggan',0),(488405,13567,'ar','ÙˆØ³ÙˆÙ ØªØ³ØªØ®Ø¯Ù… Ø£Ø¯Ù†Ù‰ Ø³Ø¹Ø± Ø¨ÙŠÙ† Ø§Ù„Ù…Ø¹ÙŠØ§Ø± Ø¢Ù†Ø¯ Ù…Ø¬Ù…ÙˆØ¹Ø© Ù…Ù† Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(488406,13567,'fr','Utilisera le prix le plus bas entre la norme & groupe client',0),(488407,13567,'jp','æ¨™æº– & é¡§å®¢ã‚°ãƒ«ãƒ¼ãƒ—é–“ã®æœ€ä½Žä¾¡æ ¼ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(488408,13567,'pt','Vai usar o preÃ§o mais baixo entre padrÃ£o & grupo de cliente',0),(488409,13567,'ru','Ð‘ÑƒÐ´ÐµÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ð¸Ð·ÐºÐ¸Ðµ Ñ†ÐµÐ½Ñ‹ Ð¼ÐµÐ¶Ð´Ñƒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ & Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(488410,13567,'es','usarÃ¡ Precio MÃ¡s Bajo Entre El Los Grupos Estandar & Cliente',0),(488411,13567,'de','Niedrigsten Preis zwischen Standard & Kundengruppe wird verwendet werden.',0),(488412,13567,'en','Will Use Lowest Price Between Standard & Customer Group',0),(488413,13568,'is','',0),(488414,13568,'dr','Ù‡Ù…ÛŒØ´Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¨Ù‡ØªØ±ÛŒÙ† Ù‚ÛŒÙ…Øª',0),(488415,13568,'pr','Ù‡Ù…ÛŒØ´Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¨Ù‡ØªØ±ÛŒÙ† Ù‚ÛŒÙ…Øª',0),(488416,13568,'tr','Her zaman en iyi fiyatÄ± kullan',0),(488417,13568,'pl','Zawsze uÅ¼ywaj Najlepsza cena',0),(488418,13568,'bg','Ð’Ð¸Ð½Ð°Ð³Ð¸ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð½Ð°Ð¹-Ð´Ð¾Ð±Ñ€Ð°Ñ‚Ð° Ñ†ÐµÐ½Ð°',0),(488419,13568,'ur','ÛÙ…ÛŒØ´Û Ø¨ÛØªØ±ÛŒÙ† Ù‚ÛŒÙ…Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(488420,13568,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ð¼Ð¾ ÑÐ°Ð¼Ð¾ Ð½Ð°Ñ˜Ð±Ð¾Ñ™Ñƒ Ñ†Ð¸Ñ˜ÐµÐ½Ñƒ',0),(488421,13568,'vi','LuÃ´n luÃ´n sá»­ dá»¥ng giÃ¡ tá»‘t nháº¥t',0),(488422,13568,'af','Gebruik altyd die beste prys',0),(488423,13568,'ro','UtilizaÅ£i Ã®ntotdeauna cel mai bun pret',0),(488424,13568,'et','Kasuta alati parimat hinda',0),(488425,13568,'si','Vedno uporabi najboljÅ¡o ceno',0),(488426,13568,'ba','Selalu menggunakan harga terbaik',0),(488427,13568,'nl','Gebruik altijd de beste prijs',0),(488428,13568,'fi','KÃ¤ytÃ¤ aina paras hinta',0),(488429,13568,'no','Bruk alltid Best pris',0),(488430,13568,'da','Brug altid bedste pris',0),(488431,13568,'ko','í•­ìƒ ìµœê³ ì˜ ê°€ê²©ì„ ì‚¬ìš© í•˜ ì—¬',0),(488432,13568,'he','×”×©×ª×ž×© ×ª×ž×™×“ ×”×ž×—×™×¨ ×”×˜×•×‘ ×‘×™×•×ª×¨',0),(488433,13568,'el','ÎÎ± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Îµ Ï€Î¬Î½Ï„Î± Ï„Î·Î½ ÎºÎ±Î»ÏÏ„ÎµÏÎ· Ï„Î¹Î¼Î®',0),(488434,13568,'zh','æ€»æ˜¯ç”¨æœ€ä¼˜æƒ çš„ä»·æ ¼',0),(488435,13568,'sv','AnvÃ¤nd alltid bÃ¤sta pris',0),(488436,13568,'it','Utilizzare sempre il miglior prezzo',0),(488437,13568,'tl','',0),(488438,13568,'th','à¹ƒà¸Šà¹‰à¸£à¸²à¸„à¸²',0),(488439,13568,'hi','à¤¹à¤®à¥‡à¤¶à¤¾ à¤¸à¤¬à¤¸à¥‡ à¤…à¤šà¥à¤›à¤¾ à¤®à¥‚à¤²à¥à¤¯ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(488440,13568,'ms','Sentiasa menggunakan harga yang terbaik',0),(488441,13568,'ar','Ø§Ø³ØªØ®Ø¯Ù… Ø¯Ø§Ø¦Ù…Ø§Ù‹ Ø£ÙØ¶Ù„ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(488442,13568,'fr','Utilisez toujours le meilleur prix',0),(488443,13568,'jp','å¸¸ã«æœ€é«˜ã®ä¾¡æ ¼ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(488444,13568,'pt','Utilize sempre o melhor preÃ§o',0),(488445,13568,'ru','Ð’ÑÐµÐ³Ð´Ð° Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ð¹',0),(488446,13568,'es','Siempre Utiliza el Mejor Precio',0),(488447,13568,'de','Verwenden Sie immer den besten Preis',0),(488448,13568,'en','Always Use Best Price',0),(488449,13569,'is','',0),(488450,13569,'dr','Ù…Ø§Ù‡ Ú¯Ø°Ø´ØªÙ‡',0),(488451,13569,'pr','Ù…Ø§Ù‡ Ú¯Ø°Ø´ØªÙ‡',0),(488452,13569,'tr','GeÃ§en ay',0),(488453,13569,'pl','W zeszÅ‚ym miesiÄ…cu',0),(488454,13569,'bg','ÐœÐ¸Ð½Ð°Ð»Ð¸Ñ Ð¼ÐµÑÐµÑ†',0),(488455,13569,'ur','Ú¯Ø²Ø´ØªÛ Ù…Ø§Û',0),(488456,13569,'sr','ÐŸÑ€Ð¾ÑˆÐ»Ð¾Ð³ Ð¼ÐµÑÐµÑ†Ð°',0),(488457,13569,'vi','ThÃ¡ng trÆ°á»›c',0),(488458,13569,'af','Verlede maand',0),(488459,13569,'ro','Ultima lunÄƒ',0),(488460,13569,'et','Eelmisel kuul',0),(488461,13569,'si','PrejÅ¡nji mesec',0),(488462,13569,'ba','Bulan lalu',0),(488463,13569,'nl','Vorige maand',0),(488464,13569,'fi','Viime kuussa',0),(488465,13569,'no','Forrige mÃ¥ned',0),(488466,13569,'da','Sidste mÃ¥ned',0),(488467,13569,'ko','ì§€ë‚œ ë‹¬',0),(488468,13569,'he','×‘×—×•×“×© ×©×¢×‘×¨',0),(488469,13569,'el','Î ÎµÏÎ±ÏƒÎ¼Î­Î½Î¿ Î¼Î®Î½Î±',0),(488470,13569,'zh','ä¸Šä¸ªæœˆ',0),(488471,13569,'sv','FÃ¶rra mÃ¥naden',0),(488472,13569,'it','Mese scorso',0),(488473,13569,'tl','',0),(488474,13569,'th','à¹€à¸”à¸·à¸­à¸™à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(488475,13569,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤®à¤¹à¥€à¤¨à¥‡',0),(488476,13569,'ms','Bulan lepas',0),(488477,13569,'ar','Ø§Ù„Ø´Ù‡Ø± Ø§Ù„Ù…Ø§Ø¶ÙŠ',0),(488478,13569,'fr','Mois dernier',0),(488479,13569,'jp','å…ˆæœˆ',0),(488480,13569,'pt','No mÃªs passado',0),(488481,13569,'ru','Ð’ Ð¿Ñ€Ð¾ÑˆÐ»Ð¾Ð¼ Ð¼ÐµÑÑÑ†Ðµ',0),(488482,13569,'es','Ultimo Mes',0),(488483,13569,'de','Letzten Monat',0),(488484,13569,'en','Last Month',0),(488485,13570,'is','',0),(488486,13570,'dr','3 Ù…Ø§Ù‡ Ú¯Ø°Ø´ØªÙ‡',0),(488487,13570,'pr','3 Ù…Ø§Ù‡ Ú¯Ø°Ø´ØªÙ‡',0),(488488,13570,'tr','Son 3 ay',0),(488489,13570,'pl','Ostatnie 3 miesiÄ…ce',0),(488490,13570,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ 3 Ð¼ÐµÑÐµÑ†Ð°',0),(488491,13570,'ur','Ù¾Ú†Ú¾Ù„Û’ 3 Ù…Ø§Û',0),(488492,13570,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ° Ñ‚Ñ€Ð¸ Ð¼ÐµÑÐµÑ†Ð°',0),(488493,13570,'vi','3 thÃ¡ng qua',0),(488494,13570,'af','Laaste 3 maande',0),(488495,13570,'ro','Ultimele 3 luni',0),(488496,13570,'et','Viimase 3 kuu jooksul',0),(488497,13570,'si','Zadnje 3 mesece',0),(488498,13570,'ba','3 bulan terakhir',0),(488499,13570,'nl','Laatste 3 maanden',0),(488500,13570,'fi','Viimeiset 3 kuukautta',0),(488501,13570,'no','Siste 3 mÃ¥neder',0),(488502,13570,'da','Sidste 3 mÃ¥neder',0),(488503,13570,'ko','ì§€ë‚œ 3 ê°œì›”',0),(488504,13570,'he','3 ×—×•×“×©×™×',0),(488505,13570,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿Ï…Ï‚ 3 Î¼Î®Î½ÎµÏ‚',0),(488506,13570,'zh','è¿‡åŽ» 3 ä¸ªæœˆ',0),(488507,13570,'sv','Senaste 3 mÃ¥naderna',0),(488508,13570,'it','Ultimi 3 mesi',0),(488509,13570,'tl','',0),(488510,13570,'th','3 à¹€à¸”à¸·à¸­à¸™à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(488511,13570,'hi','à¤ªà¤¿à¤›à¤²à¥‡ 3 à¤®à¤¾à¤¹',0),(488512,13570,'ms','3 bulan',0),(488513,13570,'ar','Ø¢Ø®Ø± 3 Ø£Ø´Ù‡Ø±',0),(488514,13570,'fr','3 derniers mois',0),(488515,13570,'jp','æœ€å¾Œã® 3ãƒ¶æœˆ',0),(488516,13570,'pt','Ãšltimos 3 meses',0),(488517,13570,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ 3 Ð¼ÐµÑÑÑ†Ð°',0),(488518,13570,'es','Ultimo 3 Meses',0),(488519,13570,'de','Letzten 3 Monate',0),(488520,13570,'en','Last 3 Months',0),(488521,13571,'is','',0),(488522,13571,'dr','Ù‡Ù…Ù‡ Ø±Ø§ Ù¾ÙˆØ´Ø´ Ù…ÛŒ Ø¯Ù‡Ø¯',0),(488523,13571,'pr','Ù‡Ù…Ù‡ Ø±Ø§ Ù¾ÙˆØ´Ø´ Ù…ÛŒ Ø¯Ù‡Ø¯',0),(488524,13571,'tr','TÃ¼m kapaklarÄ±',0),(488525,13571,'pl','Obejmuje wszystkie',0),(488526,13571,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÐºÐ°Ð¿Ð°Ñ†Ð¸',0),(488527,13571,'ur','Ø³Ø¨ Ù¾Ø± Ù…Ø­ÛŒØ·',0),(488528,13571,'sr','Ð¡Ð²Ðµ Ð¿Ð¾ÐºÑ€Ð¸Ð²Ð°.',0),(488529,13571,'vi','Bao gá»“m táº¥t cáº£',0),(488530,13571,'af','Al dek',0),(488531,13571,'ro','AcoperÄƒ toate',0),(488532,13571,'et','KÃµik katted',0),(488533,13571,'si','Vse prevleke',0),(488534,13571,'ba','Semua mencakup',0),(488535,13571,'nl','Alle Covers',0),(488536,13571,'fi','Kaikki kannet',0),(488537,13571,'no','Alle',0),(488538,13571,'da','Alle dÃ¦ksler',0),(488539,13571,'ko','ëª¨ë“  ì»¤ë²„',0),(488540,13571,'he','×›×œ ×¢×˜×™×¤×•×ª',0),(488541,13571,'el','ÎŒÎ»Î± Ï„Î± ÎºÎ±Î»ÏÎ¼Î¼Î±Ï„Î±',0),(488542,13571,'zh','æ‰€æœ‰çš„å°é¢',0),(488543,13571,'sv','Alla omslag',0),(488544,13571,'it','Tutte le copertine',0),(488545,13571,'tl','',0),(488546,13571,'th','à¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(488547,13571,'hi','à¤¸à¤­à¥€ à¤•à¤µà¤°',0),(488548,13571,'ms','Meliputi semua',0),(488549,13571,'ar','ÙŠØºØ·ÙŠ Ø¬Ù…ÙŠØ¹',0),(488550,13571,'fr','Toutes les couvertures',0),(488551,13571,'jp','ã™ã¹ã¦ã®ã‚«ãƒãƒ¼',0),(488552,13571,'pt','Todas as coberturas',0),(488553,13571,'ru','Ð’ÑÐµ Ð¾Ð±Ð»Ð¾Ð¶ÐºÐ¸',0),(488554,13571,'es','Todos Cubiertos',0),(488555,13571,'de','Alle Abdeckungen',0),(488556,13571,'en','All Covers',0),(488557,13572,'is','',0),(488558,13572,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù‡Ø± Ù‚Ø·Ø¹Ù‡ Ø¨Ù‡ Ù¾Ø§ÛŒØ§Ù† Ø±Ø³ÛŒØ¯',0),(488559,13572,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù‡Ø± Ù‚Ø·Ø¹Ù‡ Ø¨Ù‡ Ù¾Ø§ÛŒØ§Ù† Ø±Ø³ÛŒØ¯',0),(488560,13572,'tr','Tamamlanan her parÃ§a miktarÄ±',0),(488561,13572,'pl','Kwota kaÅ¼dego gotowy kawaÅ‚ek',0),(488562,13572,'bg','Ð’ÑÑÐºÐ° ÐºÑ€Ð°Ð¹Ð½Ð¸Ñ Ð¿Ð°Ñ€Ñ‡Ðµ Ð² Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(488563,13572,'ur','ÛØ± Ú©Ø§Ù… Ø®ØªÙ… Ù¹Ú©Ú‘Ø§ Ú©ÛŒ Ø±Ù‚Ù…',0),(488564,13572,'sr','Ð˜Ð·Ð½Ð¾Ñ ÑÐ²Ð°ÐºÐµ Ð³Ð¾Ñ‚Ð¾Ð² ÐºÐ¾Ð¼Ð°Ð´',0),(488565,13572,'vi','Sá»‘ tiá»n má»—i máº£nh hoÃ n thÃ nh',0),(488566,13572,'af','Elke voltooide projek bedrag',0),(488567,13572,'ro','RidicÄƒ fiecare bucatÄƒ finit',0),(488568,13572,'et','Iga tÃ¶Ã¶ lÃµpliku summa',0),(488569,13572,'si','Znesek vsakega konÄnega kos',0),(488570,13572,'ba','Jumlah setiap bagian selesai',0),(488571,13572,'nl','Elk stuk van afgewerkte neerkomen',0),(488572,13572,'fi','MÃ¤Ã¤rÃ¤ kunkin valmis tyÃ¶',0),(488573,13572,'no','BelÃ¸pet hver ferdige stykket',0),(488574,13572,'da','BelÃ¸b hvert fÃ¦rdige stykke',0),(488575,13572,'ko','ì™„ì„± ëœ ê°œë‹¹ ê¸ˆì•¡',0),(488576,13572,'he','×¡×›×•× ×›×œ ×—×ª×™×›×” ×¡×™×™×',0),(488577,13572,'el','Î Î¿ÏƒÏŒ ÎºÎ¬Î¸Îµ Ï„ÎµÎ»Î¹ÎºÎ¿Ï ÎºÎ¿Î¼Î¼Î¬Ï„Î¹',0),(488578,13572,'zh','é‡‘é¢æ¯ä»¶æˆå“',0),(488579,13572,'sv','Belopp varje fÃ¤rdig pjÃ¤s',0),(488580,13572,'it','L\'importo di ogni pezzo finito',0),(488581,13572,'tl','',0),(488582,13572,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¹à¸•à¹ˆà¸¥à¸°à¸Šà¸´à¹‰à¸™à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸´à¹‰à¸™',0),(488583,13572,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤–à¤¤à¥à¤® à¤Ÿà¥à¤•à¤¡à¤¼à¤¾ à¤°à¤¾à¤¶à¤¿',0),(488584,13572,'ms','Jumlah setiap bahagian yang telah siap',0),(488585,13572,'ar','ØªØµÙ„ ÙƒÙ„ Ù‚Ø·Ø¹Ø© Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(488586,13572,'fr','Chaque piÃ¨ce finie s\'Ã©lÃ¨vent',0),(488587,13572,'jp','å„å®Œæˆã—ãŸä½œå“ã‚’é¡ã—ã¾ã™ã€‚',0),(488588,13572,'pt','Quantidade de cada peÃ§a acabada',0),(488589,13572,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÐºÐ°Ð¶Ð´Ð¾Ð³Ð¾ Ð³Ð¾Ñ‚Ð¾Ð²Ð¾Ð³Ð¾ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(488590,13572,'es','Monto de Cada Pieza Terminada',0),(488591,13572,'de','Jedes fertige StÃ¼ck betragen',0),(488592,13572,'en','Amount Each Finished Piece',0),(488593,13573,'is','',0),(488594,13573,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨Ù‡ ØªØµÙˆÛŒØ¨',0),(488595,13573,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨Ù‡ ØªØµÙˆÛŒØ¨',0),(488596,13573,'tr','Onaylamak iÃ§in onay',0),(488597,13573,'pl','Zaznacz, aby zatwierdziÄ‡',0),(488598,13573,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð° Ð¾Ð´Ð¾Ð±Ñ€ÑÐ²Ð°Ð½Ðµ',0),(488599,13573,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(488600,13573,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€Ð¸',0),(488601,13573,'vi','Kiá»ƒm tra Ä‘á»ƒ cháº¥p nháº­n',0),(488602,13573,'af','Kontroleer Vir Goedkeuring',0),(488603,13573,'ro','VerificaÅ£i pentru a aproba',0),(488604,13573,'et','VÃ¤ljaregistreerimine heakskiitmine',0),(488605,13573,'si','Preverjanje odobritev',0),(488606,13573,'ba','Periksa untuk menyetujui',0),(488607,13573,'nl','Selectievakje goed te keuren',0),(488608,13573,'fi','Uloskirjautuminen hyvÃ¤ksymÃ¤Ã¤n',0),(488609,13573,'no','Sjekk Ã¥ godkjenne',0),(488610,13573,'da','Check at godkende',0),(488611,13573,'ko','ìŠ¹ì¸ í™•ì¸',0),(488612,13573,'he','×”×¡×™×ž×•×Ÿ ×›×“×™ ×œ××©×¨',0),(488613,13573,'el','Î•Î»Î­Î³Ï‡Î¿Ï… Î½Î± ÎµÎ³ÎºÏÎ¯Î½ÎµÎ¹',0),(488614,13573,'zh','æ£€æŸ¥ï¼Œä»¥æ‰¹å‡†',0),(488615,13573,'sv','Kontrollera att godkÃ¤nna',0),(488616,13573,'it','Controllo di approvare',0),(488617,13573,'tl','',0),(488618,13573,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹€à¸žà¸·à¹ˆà¸­à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(488619,13573,'hi','à¤šà¥‡à¤• à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¥‡ à¤²à¤¿à¤',0),(488620,13573,'ms','Daftar untuk meluluskan',0),(488621,13573,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰',0),(488622,13573,'fr','Cocher approuver',0),(488623,13573,'jp','æ‰¿èªã‚’ãƒã‚§ãƒƒã‚¯',0),(488624,13573,'pt','SeleÃ§Ã£o para aprovar',0),(488625,13573,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑƒÑ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ',0),(488626,13573,'es','Tachar para Aprobar',0),(488627,13573,'de','ÃœberprÃ¼fen, genehmigen',0),(488628,13573,'en','Check To Approve',0),(488629,13574,'is','',0),(488630,13574,'dr','Ø§ÛŒÙ† Ø®Ø· Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯',0),(488631,13574,'pr','Ø§ÛŒÙ† Ø®Ø· Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯',0),(488632,13574,'tr','Bu satÄ±rÄ± silin',0),(488633,13574,'pl','UsunÄ…Ä‡ ten wiersz',0),(488634,13574,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹Ñ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ñ€ÐµÐ´',0),(488635,13574,'ur','ÛŒÛ Ø³Ù„Ø³Ù„Û Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(488636,13574,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ñ€ÐµÐ´',0),(488637,13574,'vi','XoÃ¡ dÃ²ng nÃ y',0),(488638,13574,'af','Skrap hierdie lyn',0),(488639,13574,'ro','ÅžtergeÅ£i aceastÄƒ linie',0),(488640,13574,'et','Kustutage see rida',0),(488641,13574,'si','IzbriÅ¡ite to vrstico',0),(488642,13574,'ba','Menghapus baris ini',0),(488643,13574,'nl','Deze regel verwijderen',0),(488644,13574,'fi','Poista tÃ¤mÃ¤ rivi',0),(488645,13574,'no','Slette denne linjen',0),(488646,13574,'da','Slet denne linje',0),(488647,13574,'ko','ì´ ë¼ì¸ì„ ì‚­ì œ',0),(488648,13574,'he','×œ×ž×—×•×§ ××ª ×”×§×• ×”×–×”',0),(488649,13574,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Ï…Ï„Î®Ï‚ Ï„Î·Ï‚ Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(488650,13574,'zh','åˆ é™¤è¿™æ¡çº¿',0),(488651,13574,'sv','Ta bort den hÃ¤r raden',0),(488652,13574,'it','Eliminare questa riga',0),(488653,13574,'tl','',0),(488654,13574,'th','à¸¥à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸™à¸µà¹‰',0),(488655,13574,'hi','à¤‡à¤¸ à¤²à¤¾à¤‡à¤¨ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(488656,13574,'ms','Menghapuskan garisan ini',0),(488657,13574,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø³Ø·Ø±',0),(488658,13574,'fr','Supprimez cette ligne',0),(488659,13574,'jp','ã“ã®è¡Œã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(488660,13574,'pt','Apagar esta linha',0),(488661,13574,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ñƒ ÑÑ‚Ñ€Ð¾ÐºÑƒ',0),(488662,13574,'es','Eliminar Esta Linea',0),(488663,13574,'de','LÃ¶schen Sie diese Zeile',0),(488664,13574,'en','Delete This Line',0),(488665,13575,'is','',0),(488666,13575,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ BOM Ø§Ø¶Ø§ÙÛŒ',0),(488667,13575,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ BOM Ø§Ø¶Ø§ÙÛŒ',0),(488668,13575,'tr','ÃœrÃ¼n ReÃ§etesi ekstra dÃ¼zenleme',0),(488669,13575,'pl','Edycja BOM Dodatki',0),(488670,13575,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐšÐ˜ ÐµÐºÑÑ‚Ñ€Ð¸',0),(488671,13575,'ur','Ø¨Ø§Ù… Ù…Ø¹ Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(488672,13575,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸',0),(488673,13575,'vi','Chá»‰nh sá»­a tÃ­nh nÄƒng bá»• sung há»™i Ä‘á»“ng quáº£n trá»‹',0),(488674,13575,'af','Redigeer BOM ekstras',0),(488675,13575,'ro','Editare LM Extras',0),(488676,13575,'et','Muuda Koosluse lisad',0),(488677,13575,'si','Urediti Kosovnico dodatki',0),(488678,13575,'ba','Mengedit BOM ekstra',0),(488679,13575,'nl','BOM Extras bewerken',0),(488680,13575,'fi','Muokkaa Tuoterakenteen extrat',0),(488681,13575,'no','Rediger Stykklistelinje statister',0),(488682,13575,'da','Rediger Styklisten Extras',0),(488683,13575,'ko','BOM ì—‘ìŠ¤íŠ¸ë¼ íŽ¸ì§‘',0),(488684,13575,'he','×¢×¨×™×›×ª BOM ×ª×•×¡×¤×•×ª',0),(488685,13575,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Extras Ï„ÎµÏ‡Î½Î¹ÎºÎ®Ï‚ Î ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚',0),(488686,13575,'zh','ç¼–è¾‘ç‰©æ–™æ¸…å•é™„åŠ åŠŸèƒ½',0),(488687,13575,'sv','Redigera BOM Extras',0),(488688,13575,'it','Modifica extra BOM',0),(488689,13575,'tl','',0),(488690,13575,'th','à¹à¸à¹‰à¹„à¸‚ BOM Extras',0),(488691,13575,'hi','BOM à¤à¤•à¥à¤¸à¥à¤Ÿà¥à¤°à¤¾ à¤•à¤²à¤¾à¤•à¤¾à¤° à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(488692,13575,'ms','Edit BOM tambahan',0),(488693,13575,'ar','ØªØ­Ø±ÙŠØ± Ø´Ø¬Ø±Ø© Ù…ÙˆØ§Ø¯ Ø¥Ø¶Ø§ÙØ§Øª',0),(488694,13575,'fr','Modifier les options BOM',0),(488695,13575,'jp','BOM ã‚¨ã‚¯ã‚¹ãƒˆãƒ©ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(488696,13575,'pt','Editar BOM Extras',0),(488697,13575,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸ ÑÐºÑÑ‚Ñ€Ð°',0),(488698,13575,'es','Editar BOM Extras',0),(488699,13575,'de','Bearbeiten von StÃ¼cklisten-Extras',0),(488700,13575,'en','Edit BOM Extras',0),(488701,13576,'is','',0),(488702,13576,'dr','Ø¯Ø±Ø¢Ù…Ø¯',0),(488703,13576,'pr','Ø¯Ø±Ø¢Ù…Ø¯',0),(488704,13576,'tr','Gelir',0),(488705,13576,'pl','DochÃ³d',0),(488706,13576,'bg','Ð”Ð¾Ñ…Ð¾Ð´',0),(488707,13576,'ur','Ø¢Ù…Ø¯Ù†ÛŒ',0),(488708,13576,'sr','ÐŸÑ€Ð¸Ñ…Ð¾Ð´',0),(488709,13576,'vi','Thu nháº­p',0),(488710,13576,'af','Inkomste',0),(488711,13576,'ro','Venituri',0),(488712,13576,'et','Tulu',0),(488713,13576,'si','Dohodek',0),(488714,13576,'ba','Pendapatan',0),(488715,13576,'nl','Inkomen',0),(488716,13576,'fi','Tulot',0),(488717,13576,'no','Inntekt',0),(488718,13576,'da','Indkomst',0),(488719,13576,'ko','ì†Œë“',0),(488720,13576,'he','×”×›× ×¡×”',0),(488721,13576,'el','Î•Î¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(488722,13576,'zh','æ”¶å…¥',0),(488723,13576,'sv','Inkomst',0),(488724,13576,'it','Reddito',0),(488725,13576,'tl','',0),(488726,13576,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰',0),(488727,13576,'hi','à¤†à¤¯',0),(488728,13576,'ms','Pendapatan',0),(488729,13576,'ar','Ø§Ù„Ø¯Ø®Ù„',0),(488730,13576,'fr','Revenu',0),(488731,13576,'jp','åŽå…¥',0),(488732,13576,'pt','Renda',0),(488733,13576,'ru','Ð”Ð¾Ñ…Ð¾Ð´',0),(488734,13576,'es','Ingreso',0),(488735,13576,'de','Einkommen',0),(488736,13576,'en','Income',0),(488737,13577,'is','',0),(488738,13577,'dr','Ù…Ù†Ø¨Ø¹ Ø¯Ø±Ø¢Ù…Ø¯',0),(488739,13577,'pr','Ù…Ù†Ø¨Ø¹ Ø¯Ø±Ø¢Ù…Ø¯',0),(488740,13577,'tr','Gelir kaynaÄŸÄ±',0),(488741,13577,'pl','Pochodzenia dochodÃ³w',0),(488742,13577,'bg','Ð”Ð¾Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¸Ð·Ñ…Ð¾Ð´',0),(488743,13577,'ur','Ø¢Ù…Ø¯Ù†ÛŒ Ú©Ø§ Ø¢ØºØ§Ø²',0),(488744,13577,'sr','ÐŸÑ€Ð¸Ñ…Ð¾Ð´ Ð¿Ð¾Ñ€ÐµÐºÐ»Ð°',0),(488745,13577,'vi','Thu nháº­p nguá»“n gá»‘c',0),(488746,13577,'af','Inkomste oorsprong',0),(488747,13577,'ro','Venituri origine',0),(488748,13577,'et','Tulude pÃ¤ritolu',0),(488749,13577,'si','Dohodek izvora',0),(488750,13577,'ba','Asal pendapatan',0),(488751,13577,'nl','Oorsprong van inkomen',0),(488752,13577,'fi','Tulojen alkuperÃ¤',0),(488753,13577,'no','Inntekt opprinnelse',0),(488754,13577,'da','Indkomst oprindelse',0),(488755,13577,'ko','ì†Œë“ ê·¼ì›',0),(488756,13577,'he','×ž×§×•×¨ ×”×›× ×¡×”',0),(488757,13577,'el','Î ÏÎ¿Î­Î»ÎµÏ…ÏƒÎ·Ï‚ Ï„Î¿Ï… ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(488758,13577,'zh','æ”¶å…¥æ¥æº',0),(488759,13577,'sv','Inkomst ursprung',0),(488760,13577,'it','Origine del reddito',0),(488761,13577,'tl','',0),(488762,13577,'th','à¸ˆà¸¸à¸”à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸‚à¸­à¸‡à¸£à¸²à¸¢à¹„à¸”à¹‰',0),(488763,13577,'hi','à¤†à¤¯ à¤‰à¤¤à¥à¤ªà¤¤à¥à¤¤à¤¿',0),(488764,13577,'ms','Asal-usul pendapatan',0),(488765,13577,'ar','Ù…ØµØ¯Ø± Ø§Ù„Ø¯Ø®Ù„',0),(488766,13577,'fr','Origine des revenus',0),(488767,13577,'jp','åŽå…¥ã®èµ·æº',0),(488768,13577,'pt','Origem da renda',0),(488769,13577,'ru','ÐŸÑ€Ð¾Ð¸ÑÑ…Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð²',0),(488770,13577,'es','Origin de Ingreso',0),(488771,13577,'de','Einkommen-Herkunft',0),(488772,13577,'en','Income Origin',0),(488773,13578,'is','',0),(488774,13578,'dr','Ø§Ø² Ø¯Ø³Øª Ø¯Ø§Ø¯Ù†',0),(488775,13578,'pr','Ø§Ø² Ø¯Ø³Øª Ø¯Ø§Ø¯Ù†',0),(488776,13578,'tr','KaybÄ±',0),(488777,13578,'pl','Straty',0),(488778,13578,'bg','Ð—Ð°Ð³ÑƒÐ±Ð°',0),(488779,13578,'ur','Ù†Ù‚ØµØ§Ù†',0),(488780,13578,'sr','Ð“ÑƒÐ±Ð¸Ñ‚Ð°Ðº',0),(488781,13578,'vi','Máº¥t',0),(488782,13578,'af','Verlies',0),(488783,13578,'ro','Pierderea',0),(488784,13578,'et','Kaotus',0),(488785,13578,'si','Izguba',0),(488786,13578,'ba','Kehilangan',0),(488787,13578,'nl','Verlies',0),(488788,13578,'fi','Tappio',0),(488789,13578,'no','Tap',0),(488790,13578,'da','Tab',0),(488791,13578,'ko','ì†ì‹¤',0),(488792,13578,'he','××•×‘×“×Ÿ',0),(488793,13578,'el','Î‘Ï€ÏŽÎ»ÎµÎ¹Î±',0),(488794,13578,'zh','æŸå¤±',0),(488795,13578,'sv','FÃ¶rlust',0),(488796,13578,'it','Perdita',0),(488797,13578,'tl','',0),(488798,13578,'th','à¸‚à¸²à¸”à¸—à¸¸à¸™',0),(488799,13578,'hi','à¤¹à¤¾à¤¨à¤¿',0),(488800,13578,'ms','Kerugian',0),(488801,13578,'ar','Ø®Ø³Ø§Ø±Ø©',0),(488802,13578,'fr','Perte',0),(488803,13578,'jp','æå¤±',0),(488804,13578,'pt','Perda',0),(488805,13578,'ru','ÐŸÐ¾Ñ‚ÐµÑ€Ñ',0),(488806,13578,'es','PÃ©rdida',0),(488807,13578,'de','Verlust',0),(488808,13578,'en','Loss',0),(488809,13579,'is','',0),(488810,13579,'dr','Ø¯Ø³ØªÙˆØ±Ø§Øª Ù…Ø¹Ù„Ù‚ Ù…ÙˆØ±Ø¯ ØªØ§ÛŒÛŒØ¯ Ù†ÛŒØ³Øª',0),(488811,13579,'pr','Ø¯Ø³ØªÙˆØ±Ø§Øª Ù…Ø¹Ù„Ù‚ Ù…ÙˆØ±Ø¯ ØªØ§ÛŒÛŒØ¯ Ù†ÛŒØ³Øª',0),(488812,13579,'tr','Bekleyen sipariÅŸler onaylanmadÄ±',0),(488813,13579,'pl','Czasu zamÃ³wienia nie zatwierdzone',0),(488814,13579,'bg','ÐžÑ‚Ð»Ð¾Ð¶ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ðµ ÑÐ° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸',0),(488815,13579,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù†ÛÛŒÚº Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(488816,13579,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð½Ð¸Ñ˜Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½',0),(488817,13579,'vi','Äang chá» xá»­ lÃ½ Ä‘Æ¡n Ä‘áº·t hÃ ng khÃ´ng Ä‘Æ°á»£c cháº¥p thuáº­n',0),(488818,13579,'af','Hangende bestellings nie goedgekeur',0),(488819,13579,'ro','Ordinele Ã®n aÈ™teptare nu aprobat',0),(488820,13579,'et','Ootel kinnitamata tellimused',0),(488821,13579,'si','ÄŒakajoÄa naroÄila, ki niso odobreni',0),(488822,13579,'ba','Pending order yang tidak disetujui',0),(488823,13579,'nl','Onverwerkte bestellingen niet goedgekeurd',0),(488824,13579,'fi','Odottavat toimeksiannot ei hyvÃ¤ksytty',0),(488825,13579,'no','Ventende ordrer ikke godkjent',0),(488826,13579,'da','Afventende ordrer ikke godkendt',0),(488827,13579,'ko','ë³´ë¥˜ ì¤‘ì¸ ì£¼ë¬¸ ìŠ¹ì¸ ë˜ì§€',0),(488828,13579,'he','×”×”×•×¨××•×ª ×”×ž×ž×ª×™× ×•×ª ×œ×•×¢×“×•×ª.',0),(488829,13579,'el','Î•ÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ Î´ÎµÎ½ ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯',0),(488830,13579,'zh','å¾…å¤„ç†è®¢å•æœªèŽ·æ‰¹å‡†',0),(488831,13579,'sv','Avvaktande ordrar som inte godkÃ¤nts',0),(488832,13579,'it','Ordini in sospeso non approvati',0),(488833,13579,'tl','',0),(488834,13579,'th','à¸£à¸­à¸£à¸±à¸šà¸„à¸³à¸ªà¸±à¹ˆà¸‡à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(488835,13579,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶ à¤¨à¤¹à¥€à¤‚ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥‡ à¤¦à¥€',0),(488836,13579,'ms','Pesanan-pesanan bergantung yang tidak diluluskan',0),(488837,13579,'ar','Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…Ø¹Ù„Ù‚Ø© Ø§Ù„ØªÙŠ Ù„Ù… ØªØªÙ… Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø©',0),(488838,13579,'fr','Commandes en attente non approuvÃ©s',0),(488839,13579,'jp','æ‰¿èªã•ã‚Œã¦ã„ãªã„ä¿ç•™ä¸­ã®æ³¨æ–‡',0),(488840,13579,'pt','Ordens pendentes nÃ£o aprovadas',0),(488841,13579,'ru','ÐžÑ‚Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ðµ Ð¾Ñ€Ð´ÐµÑ€Ð° Ð½Ðµ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ñ‹',0),(488842,13579,'es','Pedidos pendientes no aprobados',0),(488843,13579,'de','Offene Bestellungen nicht genehmigt',0),(488844,13579,'en','Pending orders not approved',0),(488845,13580,'is','',0),(488846,13580,'dr','Ú†Ø§Ù¾ Ù†Ø§Ù… &amp; Ø¢Ø¯Ø±Ø³',0),(488847,13580,'pr','Ú†Ø§Ù¾ Ù†Ø§Ù… &amp; Ø¢Ø¯Ø±Ø³',0),(488848,13580,'tr','YazÄ±cÄ± adlarÄ± & adresleri',0),(488849,13580,'pl','Nazwy wydruku & adresy',0),(488850,13580,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ½Ð° & Ð°Ð´Ñ€ÐµÑÐ¸',0),(488851,13580,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù†Ø§Ù… & Ù¾ØªÛ’',0),(488852,13580,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð¼ÐµÐ½Ð° Ð¸ Ð°Ð´Ñ€ÐµÑÐµ',0),(488853,13580,'vi','In tÃªn &amp; Ä‘á»‹a chá»‰',0),(488854,13580,'af','Gedrukte name en adresse',0),(488855,13580,'ro','Nume de imprimare & adrese',0),(488856,13580,'et','Prindi nimed & aadressid',0),(488857,13580,'si','Tiskanje imena & naslove',0),(488858,13580,'ba','Cetak nama & alamat',0),(488859,13580,'nl','Afdrukken namen & adressen',0),(488860,13580,'fi','Tulosta nimet & osoitteet',0),(488861,13580,'no','Skrive ut navn & adresser',0),(488862,13580,'da','Udskrive navne & adresser',0),(488863,13580,'ko','ì¸ì‡„ ì´ë¦„ & ì£¼ì†Œ',0),(488864,13580,'he','×©×ž×•×ª ×”×”×“×¤×¡×” & ×›×ª×•×‘×•×ª',0),(488865,13580,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Î¿Î½ÏŒÎ¼Î±Ï„Î± & Î´Î¹ÎµÏ…Î¸ÏÎ½ÏƒÎµÎ¹Ï‚',0),(488866,13580,'zh','æ‰“å°åç§° &amp; åœ°å€',0),(488867,13580,'sv','Skriv ut namn & adresser',0),(488868,13580,'it','Stampa nomi & indirizzi',0),(488869,13580,'tl','',0),(488870,13580,'th','à¸žà¸´à¸¡à¸žà¹Œà¸Šà¸·à¹ˆà¸­ & à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆ',0),(488871,13580,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤¨à¤¾à¤® & à¤ªà¤¤à¥‡',0),(488872,13580,'ms','Cetakan nama & alamat',0),(488873,13580,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø£Ø³Ù…Ø§Ø¡ Ø¢Ù†Ø¯ Ø¹Ù†Ø§ÙˆÙŠÙ†',0),(488874,13580,'fr','Impression des noms & d\'adresses',0),(488875,13580,'jp','ãƒ—ãƒªãƒ³ãƒˆå & ã‚¢ãƒ‰ãƒ¬ã‚¹',0),(488876,13580,'pt','Nomes de impressÃ£o & endereÃ§os',0),(488877,13580,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ñ & Ð°Ð´Ñ€ÐµÑÐ°',0),(488878,13580,'es','Imprimir Nombres & Direcciones',0),(488879,13580,'de','Drucken Namen & Adressen',0),(488880,13580,'en','Print Names & Addresses',0),(488881,13581,'is','',0),(488882,13581,'dr','ÙÙ‚Ø· Ú†Ø§Ù¾ Ø§Ø³Ø§Ù…ÛŒ',0),(488883,13581,'pr','ÙÙ‚Ø· Ú†Ø§Ù¾ Ø§Ø³Ø§Ù…ÛŒ',0),(488884,13581,'tr','YalnÄ±zca adlarÄ±nÄ± YazdÄ±r',0),(488885,13581,'pl','WydrukowaÄ‡ nazwiska tylko',0),(488886,13581,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ½Ð° ÑÐ°Ð¼Ð¾',0),(488887,13581,'ur','ØµØ±Ù Ù†Ø§Ù… Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(488888,13581,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð¼ÐµÐ½Ð° ÑÐ°Ð¼Ð¾',0),(488889,13581,'vi','In tÃªn chá»‰',0),(488890,13581,'af','Druk net name',0),(488891,13581,'ro','Imprimare numai numele',0),(488892,13581,'et','Prindi ainult nimed',0),(488893,13581,'si','Samo natisniti imena',0),(488894,13581,'ba','Cetak nama hanya',0),(488895,13581,'nl','Namen slechts drukken',0),(488896,13581,'fi','Vain tulostaa nimet',0),(488897,13581,'no','Bare skrive ut navn',0),(488898,13581,'da','Udskrive navne kun',0),(488899,13581,'ko','ì¸ì‡„ ì´ë¦„ë§Œ',0),(488900,13581,'he','×©×ž×•×ª ×”×”×“×¤×¡×” ×‘×œ×‘×“',0),(488901,13581,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Î¿Î½ÏŒÎ¼Î±Ï„Î± Î¼ÏŒÎ½Î¿',0),(488902,13581,'zh','åªæ‰“å°å§“å',0),(488903,13581,'sv','Skriva ut namn endast',0),(488904,13581,'it','Stampare solo nomi',0),(488905,13581,'tl','',0),(488906,13581,'th','à¸žà¸´à¸¡à¸žà¹Œà¸Šà¸·à¹ˆà¸­à¹€à¸‰à¸žà¸²à¸°',0),(488907,13581,'hi','à¤¨à¤¾à¤® à¤•à¥‡à¤µà¤² à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(488908,13581,'ms','Cetakan nama sahaja',0),(488909,13581,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø£Ø³Ù…Ø§Ø¡ ÙÙ‚Ø·',0),(488910,13581,'fr','Imprimer seulement les noms',0),(488911,13581,'jp','ãƒ—ãƒªãƒ³ãƒˆåã®ã¿',0),(488912,13581,'pt','Imprimir nomes sÃ³',0),(488913,13581,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð¸Ð¼ÐµÐ½Ð° Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(488914,13581,'es','Imprimir Solo Nombres',0),(488915,13581,'de','Namen nur Drucken',0),(488916,13581,'en','Print Names Only',0),(488917,13582,'is','',0),(488918,13582,'dr','Ú†Ø§Ù¾ Ú†Ù‡ Ø¯Ø± Ù¾ÙˆØ´Ø´',0),(488919,13582,'pr','Ú†Ø§Ù¾ Ú†Ù‡ Ø¯Ø± Ù¾ÙˆØ´Ø´',0),(488920,13582,'tr','YazdÄ±rÄ±lacak olan kapak',0),(488921,13582,'pl','Drukuj na okÅ‚adkach',0),(488922,13582,'bg','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ð¹ Ð½Ð° Ð¿Ð¾ÐºÑ€Ð¸Ð²Ð°',0),(488923,13582,'ur','Ú©ÛŒØ§ ØºÙ„Ø§Ù Ù¾Ø± Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(488924,13582,'sr','ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð° ÐºÐ¾Ñ€Ð¸Ñ†Ðµ',0),(488925,13582,'vi','In nhá»¯ng gÃ¬ trÃªn bÃ¬a',0),(488926,13582,'af','Druk wat op dek',0),(488927,13582,'ro','Imprimat pe acoperÄƒ',0),(488928,13582,'et','Prinditav kaanel',0),(488929,13582,'si','Kaj tisk na pokrove',0),(488930,13582,'ba','Mencetak apa di sampul',0),(488931,13582,'nl','Afdrukken op Covers',0),(488932,13582,'fi','Tulosta kattaa',0),(488933,13582,'no','Skriv ut pÃ¥ dekker',0),(488934,13582,'da','UdskriftsomrÃ¥de pÃ¥ Covers',0),(488935,13582,'ko','í‘œì§€ì— ì¸ì‡„',0),(488936,13582,'he','×”×“×¤×¡ ×¢×œ ×ž×›×¡×”',0),(488937,13582,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï„Î¹ ÏƒÏ„Î¹Ï‚ ÎºÎ±Î»ÏÏˆÎµÎ¹Ï‚',0),(488938,13582,'zh','åœ¨å°é¢ä¸Šæ‰“å°ä»€ä¹ˆ',0),(488939,13582,'sv','Skriv ut pÃ¥ omslag',0),(488940,13582,'it','Che cosa stampare sulle copertine',0),(488941,13582,'tl','',0),(488942,13582,'th','à¸žà¸´à¸¡à¸žà¹Œà¸—à¸µà¹ˆà¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡',0),(488943,13582,'hi','à¤•à¥à¤¯à¤¾ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¤¾ à¤¹à¥ˆ à¤ªà¤° à¤•à¤µà¤°',0),(488944,13582,'ms','Cetak apa meliputi',0),(488945,13582,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù…Ø§ Ø¹Ù„Ù‰ Ø£ØºÙ„ÙØ©',0),(488946,13582,'fr','Imprimer sur couvertures',0),(488947,13582,'jp','è¡¨ç´™ã«å°åˆ·å¯¾è±¡',0),(488948,13582,'pt','O que imprimir em capas',0),(488949,13582,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð½Ð° Ð¾Ð±Ð»Ð¾Ð¶ÐºÐ°Ñ…',0),(488950,13582,'es','Imprimir Que en Las Cubiertos',0),(488951,13582,'de','Covers drucken',0),(488952,13582,'en','Print What On Covers',0),(488953,13583,'is','',0),(488954,13583,'dr','Ù‡Ø§Ø§ÛŒ Ø¯Ø³ØªÙˆØ±Ø§Øª Ù…Ø¹Ù„Ù‚',0),(488955,13583,'pr','Ù‡Ø§Ø§ÛŒ Ø¯Ø³ØªÙˆØ±Ø§Øª Ù…Ø¹Ù„Ù‚',0),(488956,13583,'tr','OnaylanmamÄ±ÅŸ bekleyen sipariÅŸler',0),(488957,13583,'pl','Niezatwierdzone zamÃ³wieÅ„',0),(488958,13583,'bg','ÐÐµÐ¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸ Ð²Ð¸ÑÑÑ‰Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(488959,13583,'ur','Ø§Ù†ØªØ¸Ø§Ù…ÛŒÛ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(488960,13583,'sr','ÐÐµÐ¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸ ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ°',0),(488961,13583,'vi','KhÃ´ng Ä‘Æ°á»£c cháº¥p thuáº­n Ä‘ang chá» xá»­ lÃ½ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(488962,13583,'af','Goedgekeurde hangende bestellings',0),(488963,13583,'ro','Neaprobate Ã®n aÅŸteptarea comenzilor',0),(488964,13583,'et','Kinnitamata korralduste kuni',0),(488965,13583,'si','Neodobren ÄakajoÄa naroÄila',0),(488966,13583,'ba','Tidak disetujui pending order',0),(488967,13583,'nl','Niet-goedgekeurde in afwachting van orders',0),(488968,13583,'fi','HyvÃ¤ksymÃ¤ttÃ¶mÃ¤t odottavien toimeksiantojen',0),(488969,13583,'no','Godkjent ventende bestillinger',0),(488970,13583,'da','Ikke-godkendte afventende ordrer',0),(488971,13583,'ko','ì£¼ë¬¸ ë³´ë¥˜ ì¤‘ì¸ ìŠ¹ì¸ ë˜ì§€ ì•Šì€',0),(488972,13583,'he','×©×œ× ××•×©×¨×• ×”×•×¨××•×ª ×ž×ž×ª×™× ×•×ª',0),(488973,13583,'el','Î”ÎµÎ½ ÎµÎ³ÎºÏÎ¯Î¸Î·ÎºÎµ ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(488974,13583,'zh','æœªå®¡æ‰¹æŒ‚å•',0),(488975,13583,'sv','Icke godkÃ¤nda avvaktande ordrar',0),(488976,13583,'it','Non approvati ordini pendenti',0),(488977,13583,'tl','',0),(488978,13583,'th','à¹„à¸¡à¹ˆà¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(488979,13583,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤†à¤¦à¥‡à¤¶ à¤…à¤¨à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤',0),(488980,13583,'ms','Tidak menunggu arahan',0),(488981,13583,'ar','ØºÙŠØ± Ù…ÙˆØ§ÙÙ‚ Ø¹Ù„ÙŠÙ‡Ø§ Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(488982,13583,'fr','Non approuvÃ© dans l\'attente de commandes',0),(488983,13583,'jp','è¨±å¯ã•ã‚Œã¦ã„ãªã„ä¿ç•™ä¸­ã®æ³¨æ–‡',0),(488984,13583,'pt','NÃ£o aprovado, ordens pendentes',0),(488985,13583,'ru','ÐÐµÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ Ð¾Ñ‚Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ñ€Ð´ÐµÑ€Ð¾Ð²',0),(488986,13583,'es','Pedidos Pendientes No Aprobados ',0),(488987,13583,'de','Nicht genehmigte noch nicht erledigten AuftrÃ¤ge',0),(488988,13583,'en','Unapproved pending orders',0),(488989,13584,'is','',0),(488990,13584,'dr','Ù…Ù†Ø´Ø§Ø¡ Ù‡Ø²ÛŒÙ†Ù‡',0),(488991,13584,'pr','Ù…Ù†Ø´Ø§Ø¡ Ù‡Ø²ÛŒÙ†Ù‡',0),(488992,13584,'tr','Gider kaynaÄŸÄ±',0),(488993,13584,'pl','Koszt pochodzenia',0),(488994,13584,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð¸Ð·Ñ…Ð¾Ð´',0),(488995,13584,'ur','Ø®Ø±Ú†Û’ Ù†Ú˜Ø§Ø¯',0),(488996,13584,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ð¿Ð¾Ñ€ÐµÐºÐ»Ð°',0),(488997,13584,'vi','Chi phÃ­ nguá»“n gá»‘c',0),(488998,13584,'af','Uitgawe oorsprong',0),(488999,13584,'ro','Cheltuiala origine',0),(489000,13584,'et','Kulu pÃ¤ritolu',0),(489001,13584,'si','StroÅ¡ke izvora',0),(489002,13584,'ba','Biaya asal',0),(489003,13584,'nl','Kosten oorsprong',0),(489004,13584,'fi','Kustannuksella alkuperÃ¤',0),(489005,13584,'no','Bekostning opprinnelse',0),(489006,13584,'da','Udgift oprindelse',0),(489007,13584,'ko','ë¹„ìš© ì¶œì²˜',0),(489008,13584,'he','×”×•×¦××•×ª ×ž×§×•×¨',0),(489009,13584,'el','Î”Î±Ï€Î¬Î½Î· Ï€ÏÎ¿Î­Î»ÎµÏ…ÏƒÎ·Ï‚',0),(489010,13584,'zh','è´¹ç”¨æ¥æº',0),(489011,13584,'sv','Bekostnad ursprung',0),(489012,13584,'it','Origine di spesa',0),(489013,13584,'tl','',0),(489014,13584,'th','à¸ˆà¸¸à¸”à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸‚à¸­à¸‡à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢',0),(489015,13584,'hi','à¤µà¥à¤¯à¤¯ à¤‰à¤¤à¥à¤ªà¤¤à¥à¤¤à¤¿',0),(489016,13584,'ms','Perbelanjaan asal',0),(489017,13584,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£ØµÙ„',0),(489018,13584,'fr','Origine de la dÃ©pense',0),(489019,13584,'jp','çµŒè²»ã®èµ·æº',0),(489020,13584,'pt','Origem da despesa',0),(489021,13584,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð¸ÑÑ…Ð¾Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(489022,13584,'es','Origin de Gasto',0),(489023,13584,'de','Kosten Herkunft',0),(489024,13584,'en','Expense Origin',0),(489025,13585,'is','',0),(489026,13585,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÙØ±Ù…Øª OpenSSL Ù¾ÛŒ Ø§Ú† Ù¾ÛŒ Ø¨Ø±Ø§ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† Ù‚Ø§Ø¨Ù„ÛŒØª Ø±Ø§ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯.',0),(489027,13585,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÙØ±Ù…Øª OpenSSL Ù¾ÛŒ Ø§Ú† Ù¾ÛŒ Ø¨Ø±Ø§ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† Ù‚Ø§Ø¨Ù„ÛŒØª Ø±Ø§ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯.',0),(489028,13585,'tr','Bu Ã¶zelliÄŸi kullanmak iÃ§in PHP OpenSSL uzantÄ±sÄ± olmalÄ±dÄ±r.',0),(489029,13585,'pl','Musi mieÄ‡ rozszerzenie OpenSSL do PHP, aby uÅ¼yÄ‡ tej funkcji.',0),(489030,13585,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð°Ñ‚ Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¸Ðµ Ð½Ð° PHP OpenSSL Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ.',0),(489031,13585,'ur','Ø¢Ù¾ Ú©Ùˆ ÛŒÛ ÙÛŒÚ†Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù¾ÛŒ Ø§ÛŒÚ† Ù¾ÛŒ Ø§ÙˆÙ¾Ø§Ù†Ø³Ø³Ù„ ØªÙˆØ³ÛŒØ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’ Û”',0),(489032,13585,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð¾Ð·Ð½Ð°ÐºÑƒ \"ÐŸÐ¥ÐŸ ÐžÐ¿ÐµÐ½Ð¡Ð¡Ð›\" Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ð»Ð¸ Ð¾Ð²Ñƒ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ñƒ.',0),(489033,13585,'vi','Báº¡n pháº£i cÃ³ pháº§n má»Ÿ rá»™ng PHP OpenSSL Ä‘á»ƒ sá»­ dá»¥ng tÃ­nh nÄƒng nÃ y.',0),(489034,13585,'af','Jy moet die PHP OpenSSL uitbreiding om hierdie kenmerk te gebruik het.',0),(489035,13585,'ro','Trebuie sÄƒ aveÅ£i extensia PHP OpenSSL pentru a utiliza aceastÄƒ caracteristicÄƒ.',0),(489036,13585,'et','PHP OpenSSL laiendamist selle funktsiooni kasutamiseks peab teil olema.',0),(489037,13585,'si','PHP OpenSSL podaljÅ¡anje za uporabo te funkcije morate imeti.',0),(489038,13585,'ba','Anda harus memiliki ekstensi PHP OpenSSL untuk menggunakan fitur ini.',0),(489039,13585,'nl','Moet u de PHP OpenSSL extensie om deze functie te gebruiken.',0),(489040,13585,'fi','TÃ¤tÃ¤ toimintoa PHP OpenSSL-tunnisteen on oltava.',0),(489041,13585,'no','Du mÃ¥ ha PHP OpenSSL forlengelsen Ã¥ bruke denne funksjonen.',0),(489042,13585,'da','Du skal have filtypenavnet PHP OpenSSL til at bruge denne funktion.',0),(489043,13585,'ko','ì´ ê¸°ëŠ¥ì„ ì‚¬ìš© í•˜ë ¤ë©´ PHP OpenSSL í™•ìž¥ëª…ì´ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(489044,13585,'he','×™×© ××ª ×”×¡×™×•×ž×ª PHP OpenSSL ×›×“×™ ×œ×”×©×ª×ž×© ×‘×ª×›×•× ×” ×–×•.',0),(489045,13585,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Ï„Î·Î½ ÎµÏ€Î­ÎºÏ„Î±ÏƒÎ· PHP OpenSSL Î³Î¹Î± Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î· Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„Î±.',0),(489046,13585,'zh','ä½ å¿…é¡»è¦ä½¿ç”¨æ­¤åŠŸèƒ½çš„ PHP OpenSSL æ‰©å±•ã€‚',0),(489047,13585,'sv','Du mÃ¥ste ha filtillÃ¤gget PHP OpenSSL till anvÃ¤nda den hÃ¤r funktionen.',0),(489048,13585,'it','Deve avere l\'estensione PHP OpenSSL per utilizzare questa funzionalitÃ .',0),(489049,13585,'tl','',0),(489050,13585,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸™à¸²à¸¡à¸ªà¸à¸¸à¸¥ PHP OpenSSL à¸ˆà¸°à¹ƒà¸Šà¹‰à¸„à¸¸à¸“à¸¥à¸±à¸à¸©à¸“à¸°à¸™à¸µà¹‰',0),(489051,13585,'hi','à¤†à¤ª à¤‡à¤¸ à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ PHP à¤“à¤ªà¤¨à¤à¤¸à¤à¤¸à¤à¤² à¤à¤•à¥à¤¸à¤Ÿà¥‡à¤‚à¤¶à¤¨ à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(489052,13585,'ms','Anda mesti mempunyai sambungan PHP OpenSSL untuk menggunakan ciri ini.',0),(489053,13585,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù…Ù„Ø­Ù‚ OpenSSL Ø¨ÙŠ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù‡Ø°Ù‡ Ø§Ù„Ù…ÙŠØ²Ø©.',0),(489054,13585,'fr','Vous devez avoir l\'extension PHP OpenSSL pour utiliser cette fonctionnalitÃ©.',0),(489055,13585,'jp','ã“ã®æ©Ÿèƒ½ã‚’ä½¿ç”¨ã™ã‚‹ PHP OpenSSL æ‹¡å¼µãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ãŒå¿…è¦ã§ã™ã€‚',0),(489056,13585,'pt','VocÃª deve ter a extensÃ£o PHP OpenSSL para usar esse recurso.',0),(489057,13585,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¸Ð¼ÐµÑ‚ÑŒ Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð¸Ðµ PHP OpenSSL Ð´Ð»Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ ÑÑ‚Ð¾Ð¹ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸.',0),(489058,13585,'es','Debe tener la PHP OpenSSL extensiÃ³n para usar esta caracterÃ­stica',0),(489059,13585,'de','Sie mÃ¼ssen die PHP OpenSSL-Erweiterung um diese Funktion nutzen.',0),(489060,13585,'en','You must have the PHP OpenSSL extension to use this feature.',0),(489061,13586,'is','',0),(489062,13586,'dr','12 Ù…Ø§Ù‡ Ú¯Ø°Ø´ØªÙ‡',0),(489063,13586,'pr','12 Ù…Ø§Ù‡ Ú¯Ø°Ø´ØªÙ‡',0),(489064,13586,'tr','Son 12 ay',0),(489065,13586,'pl','Ostatnich 12 miesiÄ™cy',0),(489066,13586,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ 12 Ð¼ÐµÑÐµÑ†Ð°',0),(489067,13586,'ur','Ú¯Ø°Ø´ØªÛ 12 Ù…Ø§Û',0),(489068,13586,'sr','Ð—Ð°Ð´ÑšÐ¸Ñ… 12 Ð¼ÐµÑÐµÑ†Ð¸',0),(489069,13586,'vi','12 thÃ¡ng qua',0),(489070,13586,'af','Afgelope 12 maande',0),(489071,13586,'ro','Ultimele 12 luni',0),(489072,13586,'et','Viimase 12 kuu jooksul',0),(489073,13586,'si','Zadnjih 12 mesecih',0),(489074,13586,'ba','12 bulan terakhir',0),(489075,13586,'nl','Afgelopen 12 maanden',0),(489076,13586,'fi','Viimeisten 12 kuukauden aikana',0),(489077,13586,'no','Siste 12 mÃ¥neder',0),(489078,13586,'da','Seneste 12 mÃ¥neder',0),(489079,13586,'ko','ì§€ë‚œ 12 ê°œì›”',0),(489080,13586,'he','12 ×”×—×•×“×©×™× ×”××—×¨×•× ×™×',0),(489081,13586,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿Ï…Ï‚ 12 Î¼Î®Î½ÎµÏ‚',0),(489082,13586,'zh','è¿‡åŽ» 12 ä¸ªæœˆ',0),(489083,13586,'sv','Senaste 12 mÃ¥naderna',0),(489084,13586,'it','Ultimi 12 mesi',0),(489085,13586,'tl','',0),(489086,13586,'th','à¹€à¸”à¸·à¸­à¸™à¸—à¸µà¹ˆ 12',0),(489087,13586,'hi','à¤ªà¤¿à¤›à¤²à¥‡ 12 à¤®à¤¾à¤¹',0),(489088,13586,'ms','12 bulan yang lepas',0),(489089,13586,'ar','Ø§Ù„Ø£Ø´Ù‡Ø± Ø§Ù„Ø¥Ø«Ù†ÙŠ Ø¹Ø´Ø± Ø§Ù„Ù…Ø§Ø¶ÙŠØ©',0),(489090,13586,'fr','12 derniers mois',0),(489091,13586,'jp','éŽåŽ» 12 ãƒ¶æœˆ',0),(489092,13586,'pt','Ãšltimos 12 meses',0),(489093,13586,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ 12 Ð¼ÐµÑÑÑ†ÐµÐ²',0),(489094,13586,'es','Ultimo 12 Meses',0),(489095,13586,'de','Letzten 12 Monate',0),(489096,13586,'en','Last 12 Months',0),(489097,13587,'is','',0),(489098,13587,'dr','Ú©Ø¯ Ú©Ø§Ù„Ø§ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ø¨Ø§Ø±Ú©Ø¯. Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø´Ø§Ù…Ù„ Ú©Ø¯ Ú©Ø§Ù„Ø§',0),(489099,13587,'pr','Ú©Ø¯ Ú©Ø§Ù„Ø§ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ø¨Ø§Ø±Ú©Ø¯. Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø´Ø§Ù…Ù„ Ú©Ø¯ Ú©Ø§Ù„Ø§',0),(489100,13587,'tr','Madde kodu Barkod olarak dÃ¶nÃ¼ÅŸtÃ¼rÃ¼lemez. Madde kodu iÃ§eremez',0),(489101,13587,'pl','Nie moÅ¼na przekonwertowaÄ‡ kod towaru do kodÃ³w kreskowych. Nie moÅ¼e zawieraÄ‡ kod towaru',0),(489102,13587,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð° ÐºÐ¾Ð´ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð±Ð°Ñ€ÐºÐ¾Ð´. ÐšÐ¾Ð´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÑŠÐ´ÑŠÑ€Ð¶Ð°',0),(489103,13587,'ur','Ø´Û’ Ú©ÙˆÚˆ Ø¨Ø§Ø±Ú©ÙˆÚˆ Ú©Ùˆ Ù†ÛÛŒÚº Ø¨Ø¯Ù„ Ø³Ú©ØªØ§ Û” Ø´Û’ Ø¶Ø§Ø¨Ø·Û Ú©ÛŒ Ø­Ø§Ù…Ù„ ÛÙˆ Ø³Ú©ØªÛŒ',0),(489104,13587,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ð²Ð°Ñ‚Ð¸ Ð¨Ð¸Ñ„Ñ€Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ñƒ Ð±Ð°Ñ€ ÐºÐ¾Ð´Ñƒ. ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐ°Ð´Ñ€Ð¶Ð¸ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(489105,13587,'vi','KhÃ´ng thá»ƒ chuyá»ƒn Ä‘á»•i má»¥c mÃ£ Ä‘á»ƒ mÃ£ váº¡ch. Má»¥c mÃ£ khÃ´ng thá»ƒ chá»©a',0),(489106,13587,'af','Kan omskep in item kode strepieskode. Item kode bevat nie',0),(489107,13587,'ro','Nu poate converti element cod de bare. Cod articol nu conÅ£ine',0),(489108,13587,'et','Ei saa teisendada kaubakoodi, vÃ¶Ã¶tkoodi. Kauba kood ei tohi sisaldada',0),(489109,13587,'si','Å ifra artikla ni mogoÄe pretvoriti v Ärtno kodo. Å ifra artikla ne sme vsebovati',0),(489110,13587,'ba','Tidak dapat mengkonversi kode barang ke barcode. Kode barang tidak boleh berisi',0),(489111,13587,'nl','Niet converteren Artikelcode naar barcode. Artikelcode mag geen bevatten',0),(489112,13587,'fi','Nimikkeen koodi ei voi muuntaa viivakoodi. Nimikkeen koodi voi sisÃ¤ltÃ¤Ã¤',0),(489113,13587,'no','Kan ikke konvertere Varekode til strekkode. Varekode kan ikke inneholde',0),(489114,13587,'da','Kan ikke konvertere varekode til stregkode. Varekoden kan ikke indeholde',0),(489115,13587,'ko','ë°”ì½”ë“œ í•­ëª© ì½”ë“œë¥¼ ë³€í™˜í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤. í•­ëª© ì½”ë“œë¥¼ í¬í•¨í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(489116,13587,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×ž×™×¨ ×§×•×“ ×¤×¨×™×˜ ×‘×¨×§×•×“. ×§×•×“ ×¤×¨×™×˜ ××™× ×• ×™×›×•×œ ×œ×”×›×™×œ',0),(489117,13587,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î¼ÎµÏ„Î±Ï„ÏÎ­ÏˆÎµÏ„Îµ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ barcode. ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Ï€ÎµÏÎ¹Î­Ï‡ÎµÎ¹',0),(489118,13587,'zh','ä¸èƒ½å°†ç‰©æ–™ä»£ç è½¬æ¢ä¸ºæ¡ç ã€‚é¡¹ç›®ä»£ç ä¸­ä¸èƒ½åŒ…å«',0),(489119,13587,'sv','Kan inte konvertera kod till streckkod. Artikelkoden fÃ¥r inte innehÃ¥lla',0),(489120,13587,'it','Non Ã¨ possibile convertire codice articolo codice a barre. Non puÃ² contenere il codice articolo',0),(489121,13587,'tl','',0),(489122,13587,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹à¸›à¸¥à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸£à¸«à¸±à¸ªà¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸” à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²à¹„à¸¡à¹ˆà¸›à¸£à¸°à¸à¸­à¸šà¸”à¹‰à¸§à¸¢',0),(489123,13587,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤•à¥‹ à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾à¥¤ à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¥‡',0),(489124,13587,'ms','Tidak boleh menukar Kod item ke Kod Bar. Kod item tidak boleh mengandungi',0),(489125,13587,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­ÙˆÙŠÙ„ ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù Ù„Ù„Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠ. Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† ØªØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù',0),(489126,13587,'fr','Impossible de convertir un code article en code Ã  barres. Ne peut pas contenir de code article',0),(489127,13587,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã«å•†å“ã‚³ãƒ¼ãƒ‰ã‚’å¤‰æ›ã§ãã¾ã›ã‚“ã€‚é …ç›®ã‚³ãƒ¼ãƒ‰ã‚’å«ã‚ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(489128,13587,'pt','NÃ£o Ã© possÃ­vel converter o cÃ³digo para cÃ³digo de barras. CÃ³digo do artigo nÃ£o pode conter',0),(489129,13587,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð°, ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´. ÐšÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ ÑÐ¾Ð´ÐµÑ€Ð¶Ð°Ñ‚ÑŒ',0),(489130,13587,'es','No se puede convertir cÃ³digo de artÃ­culo para cÃ³digo de barras. No puede contener el cÃ³digo del artÃ­culo',0),(489131,13587,'de','Artikelnummer kann nicht Barcode konvertiert werden. Feld-Code kann nicht enthalten',0),(489132,13587,'en','Cannot convert item code to barcode. Item code cannot contain',0),(489133,13588,'is','',0),(489134,13588,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ´ ØªÙ†Ø¸ÛŒÙ…',0),(489135,13588,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ±ÙˆØ´ ØªÙ†Ø¸ÛŒÙ…',0),(489136,13588,'tr','SatÄ±ÅŸ ayarlamalar toplam',0),(489137,13588,'pl','Korekty sprzedaÅ¼y ogÃ³Å‚em',0),(489138,13588,'bg','ÐžÐ±Ñ‰Ð¾ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(489139,13588,'ur','Ø³ÛŒÙ„Ø² Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©ÛŒ Ú©Ù„',0),(489140,13588,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(489141,13588,'vi','BÃ¡n hÃ ng Ä‘iá»u chá»‰nh tá»•ng sá»‘',0),(489142,13588,'af','Totale verkope aanpassings',0),(489143,13588,'ro','Total vÃ¢nzÄƒri ajustÄƒri',0),(489144,13588,'et','MÃ¼Ã¼gi korrigeerimised kokku',0),(489145,13588,'si','Skupaj prodaja prilagoditve',0),(489146,13588,'ba','Total penjualan penyesuaian',0),(489147,13588,'nl','Verkoop aanpassingen totaal',0),(489148,13588,'fi','Myynnin muutokset yhteensÃ¤',0),(489149,13588,'no','Salg justeringer totalt',0),(489150,13588,'da','Salg justeringer i alt',0),(489151,13588,'ko','íŒë§¤ ì¡°ì • ì´',0),(489152,13588,'he','×¡×” ×› ×”×ª××ž×•×ª ×ž×›×™×¨×•×ª',0),(489153,13588,'el','Î£ÏÎ½Î¿Î»Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚',0),(489154,13588,'zh','é”€å”®è°ƒæ•´æ€»æ•°',0),(489155,13588,'sv','FÃ¶rsÃ¤ljning justeringar totalt',0),(489156,13588,'it','Vendita rettifiche totale',0),(489157,13588,'tl','',0),(489158,13588,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸‚à¸²à¸¢à¸£à¸§à¸¡',0),(489159,13588,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤•à¥à¤²',0),(489160,13588,'ms','Jumlah pelarasan jualan',0),(489161,13588,'ar','Ù…Ø¬Ù…ÙˆØ¹ ØªØ³ÙˆÙŠØ§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(489162,13588,'fr','Ajustements ventes Total',0),(489163,13588,'jp','è²©å£²èª¿æ•´åˆè¨ˆ',0),(489164,13588,'pt','Total de vendas de ajustes',0),(489165,13588,'ru','Ð’ÑÐµÐ³Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(489166,13588,'es','Total de Ajustes de Ventas',0),(489167,13588,'de','Vertrieb Anpassungen Total',0),(489168,13588,'en','Sales Adjustments Total',0),(489169,13589,'is','',0),(489170,13589,'dr','Ø³ÛŒØ§Ø³Øª Ø­ÙØ¸ Ø­Ø±ÛŒÙ… Ø®ØµÙˆØµÛŒ',0),(489171,13589,'pr','Ø³ÛŒØ§Ø³Øª Ø­ÙØ¸ Ø­Ø±ÛŒÙ… Ø®ØµÙˆØµÛŒ',0),(489172,13589,'tr','Gizlilik PolitikasÄ±',0),(489173,13589,'pl','Polityka prywatnoÅ›ci',0),(489174,13589,'bg','ÐŸÑ€Ð°Ð²Ð¸Ð»Ð° Ð·Ð° Ð¿Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ÑÑ‚',0),(489175,13589,'ur','Ø±Ø§Ø² Ø¯Ø§Ø±ÛŒ Ú©ÛŒ Ù¾Ø§Ù„ÛŒØ³ÛŒ',0),(489176,13589,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð¾ Ð¿Ñ€Ð¸Ð²Ð°Ñ‚Ð½Ð¾ÑÑ‚Ð¸',0),(489177,13589,'vi','ChÃ­nh sÃ¡ch báº£o máº­t',0),(489178,13589,'af','Privaatheid beleid',0),(489179,13589,'ro','Politica de confidenÅ£ialitate',0),(489180,13589,'et','Privaatsus',0),(489181,13589,'si','Pravilnik o zasebnosti',0),(489182,13589,'ba','Kebijakan Privasi',0),(489183,13589,'nl','Privacybeleid',0),(489184,13589,'fi','Yksityisyyden suoja',0),(489185,13589,'no','Personvern',0),(489186,13589,'da','Privacy Policy',0),(489187,13589,'ko','ê°œì¸ ì •ë³´ ë³´í˜¸ ì •ì±…',0),(489188,13589,'he','×ž×“×™× ×™×•×ª ×¤×¨×˜×™×•×ª',0),(489189,13589,'el','Î Î¿Î»Î¹Ï„Î¹ÎºÎ® Ï€ÏÎ¿ÏƒÏ„Î±ÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÏŽÎ½ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(489190,13589,'zh','éšç§æƒæ”¿ç­–',0),(489191,13589,'sv','Sekretesspolicy',0),(489192,13589,'it','Informativa sulla privacy',0),(489193,13589,'tl','',0),(489194,13589,'th','à¸™à¹‚à¸¢à¸šà¸²à¸¢à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¸ªà¹ˆà¸§à¸™à¸•à¸±à¸§',0),(489195,13589,'hi','à¤—à¥‹à¤ªà¤¨à¥€à¤¯à¤¤à¤¾ à¤¨à¥€à¤¤à¤¿',0),(489196,13589,'ms','Dasar privasi',0),(489197,13589,'ar','Ø³ÙŠØ§Ø³Ø© Ø§Ù„Ø®ØµÙˆØµÙŠØ©',0),(489198,13589,'fr','Politique de confidentialitÃ©',0),(489199,13589,'jp','ãƒ—ãƒ©ã‚¤ãƒã‚·ãƒ¼ ãƒãƒªã‚·ãƒ¼',0),(489200,13589,'pt','PolÃ­tica de privacidade',0),(489201,13589,'ru','ÐŸÐ¾Ð»Ð¸Ñ‚Ð¸ÐºÐ° ÐºÐ¾Ð½Ñ„Ð¸Ð´ÐµÐ½Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(489202,13589,'es','PolÃ­tica de privacidad',0),(489203,13589,'de','Privacy Policy',0),(489204,13589,'en','Privacy Policy',0),(489205,13590,'is','',0),(489206,13590,'dr','Ù…ÙˆØ§Ø±Ø¯ Ù¾Ø±Ø¯Ø§Ø²Ø´',0),(489207,13590,'pr','Ù…ÙˆØ§Ø±Ø¯ Ù¾Ø±Ø¯Ø§Ø²Ø´',0),(489208,13590,'tr','Ä°ÅŸlenen Ã¶ÄŸeler',0),(489209,13590,'pl','Przetworzonych pozycji',0),(489210,13590,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸',0),(489211,13590,'ur','Ù¾Ø±Ø§Ø³Ø³ Ø´Ø¯Û Ø§Ø´ÛŒØ§Ø¡',0),(489212,13590,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð¾Ð±Ñ€Ð°Ñ’ÑƒÑ˜Ñƒ',0),(489213,13590,'vi','Máº·t hÃ ng cháº¿ biáº¿n',0),(489214,13590,'af','Items verwerk',0),(489215,13590,'ro','Articole prelucrate',0),(489216,13590,'et','TÃ¶Ã¶deldud Ã¼ksused',0),(489217,13590,'si','Artikle, obdelane',0),(489218,13590,'ba','Item diproses',0),(489219,13590,'nl','Items verwerkt',0),(489220,13590,'fi','NimikkeitÃ¤ kÃ¤siteltÃ¤vÃ¤ksi',0),(489221,13590,'no','Elementer som er behandlet',0),(489222,13590,'da','Varer forarbejdet',0),(489223,13590,'ko','í•­ëª© ì²˜ë¦¬',0),(489224,13590,'he','×¤×¨×™×˜×™× ×ž×¢×•×‘×“×™×',0),(489225,13590,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Ï…Ï€Î¿Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ ÏƒÎµ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(489226,13590,'zh','å¤„ç†é¡¹ç›®',0),(489227,13590,'sv','Artiklar som bearbetas',0),(489228,13590,'it','Elementi elaborati',0),(489229,13590,'tl','',0),(489230,13590,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥',0),(489231,13590,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤',0),(489232,13590,'ms','Item-item yang diproses',0),(489233,13590,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…Ø¬Ù‡Ø²Ø©',0),(489234,13590,'fr','Ã‰lÃ©ments traitÃ©s',0),(489235,13590,'jp','å‡¦ç†ã•ã‚ŒãŸé …ç›®',0),(489236,13590,'pt','Itens processados',0),(489237,13590,'ru','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½Ð½Ñ‹Ñ… ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(489238,13590,'es','Items Procesados',0),(489239,13590,'de','Verarbeiteten Elemente',0),(489240,13590,'en','Items Processed',0),(489241,13591,'is','',0),(489242,13591,'dr','Ù…ÛŒØ§Ù†Ú¯ÛŒÙ† Ù…Ø§Ù‡',0),(489243,13591,'pr','Ù…ÛŒØ§Ù†Ú¯ÛŒÙ† Ù…Ø§Ù‡',0),(489244,13591,'tr','Ay Avg',0),(489245,13591,'pl','MiesiÄ…c Avg',0),(489246,13591,'bg','ÐœÐµÑÐµÑ† Avg',0),(489247,13591,'ur','Ù…Ø§Û Ø§ÙˆØ³Ø·',0),(489248,13591,'sr','ÐœÐµÑÐµÑ† Ð´Ð°Ð½Ð° ÐÐ²Ð³',0),(489249,13591,'vi','ThÃ¡ng Avg',0),(489250,13591,'af','Maand Avg',0),(489251,13591,'ro','Luna Avg',0),(489252,13591,'et','Kuu Avg',0),(489253,13591,'si','Mesec Avg',0),(489254,13591,'ba','Bulan Avg',0),(489255,13591,'nl','Maand Avg',0),(489256,13591,'fi','Kuukauden Avg',0),(489257,13591,'no','MÃ¥ned Avg',0),(489258,13591,'da','MÃ¥ned Avg',0),(489259,13591,'ko','ì›” í‰ê· ',0),(489260,13591,'he','×—×•×“×© Avg',0),(489261,13591,'el','Avg Î¼Î®Î½Î±',0),(489262,13591,'zh','æœˆå¹³å‡å®¢æˆ¿ç§Ÿé‡‘',0),(489263,13591,'sv','MÃ¥nad Avg',0),(489264,13591,'it','Mese Avg',0),(489265,13591,'tl','',0),(489266,13591,'th','Avg à¹€à¸”à¸·à¸­à¸™',0),(489267,13591,'hi','à¤®à¤¾à¤¹ à¤”à¤¸à¤¤',0),(489268,13591,'ms','Avg bulan',0),(489269,13591,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„Ø´Ù‡Ø±',0),(489270,13591,'fr','Mois Avg',0),(489271,13591,'jp','ãƒ¶æœˆå¹³å‡',0),(489272,13591,'pt','MÃªs Avg',0),(489273,13591,'ru','ÐœÐµÑÑÑ† Avg',0),(489274,13591,'es','Promedio Mensual',0),(489275,13591,'de','Monat Avg',0),(489276,13591,'en','Month Avg',0),(489277,13592,'is','',0),(489278,13592,'dr','Ú©Ù„ Ù…Ø§Ù‡',0),(489279,13592,'pr','Ú©Ù„ Ù…Ø§Ù‡',0),(489280,13592,'tr','Toplam ay',0),(489281,13592,'pl','CaÅ‚kowita miesiÄ™cy',0),(489282,13592,'bg','ÐžÐ±Ñ‰Ð¾ Ð¼ÐµÑÐµÑ†Ð°',0),(489283,13592,'ur','Ú©Ù„ Ù…Ø§Û',0),(489284,13592,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¼ÐµÑÐµÑ†Ð¸',0),(489285,13592,'vi','Táº¥t cáº£ thÃ¡ng',0),(489286,13592,'af','Totale maande',0),(489287,13592,'ro','Total luni',0),(489288,13592,'et','Kokku kuu',0),(489289,13592,'si','Skupno mesecev',0),(489290,13592,'ba','Total bulan',0),(489291,13592,'nl','Totale maanden',0),(489292,13592,'fi','YhteensÃ¤ kuukauden',0),(489293,13592,'no','Totalt antall mÃ¥neder',0),(489294,13592,'da','Samlede mÃ¥neder',0),(489295,13592,'ko','ì´ ê°œì›”',0),(489296,13592,'he','×¡×” ×› ×—×•×“×©×™×',0),(489297,13592,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ® Î¼Î®Î½ÎµÏ‚',0),(489298,13592,'zh','æ€»ä¸ªæœˆ',0),(489299,13592,'sv','Totala mÃ¥nader',0),(489300,13592,'it','Totale mesi',0),(489301,13592,'tl','',0),(489302,13592,'th','à¹€à¸”à¸·à¸­à¸™à¸£à¸§à¸¡',0),(489303,13592,'hi','à¤•à¥à¤² à¤®à¤¹à¥€à¤¨à¥‹à¤‚',0),(489304,13592,'ms','Bulan jumlah',0),(489305,13592,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø£Ø´Ù‡Ø±',0),(489306,13592,'fr','Nombre total de mois',0),(489307,13592,'jp','åˆè¨ˆãƒ¶æœˆ',0),(489308,13592,'pt','Meses totais',0),(489309,13592,'ru','ÐžÐ±Ñ‰ÐµÐµ Ñ‡Ð¸ÑÐ»Ð¾ Ð¼ÐµÑÑÑ†ÐµÐ²',0),(489310,13592,'es','Total Meses',0),(489311,13592,'de','Insgesamt Monate',0),(489312,13592,'en','Total Months',0),(489313,13593,'is','',0),(489314,13593,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÛŒØ´ ÙØ±Ø¶',0),(489315,13593,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÛŒØ´ ÙØ±Ø¶',0),(489316,13593,'tr','VarsayÄ±lan miktar',0),(489317,13593,'pl','DomyÅ›lna iloÅ›Ä‡',0),(489318,13593,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(489319,13593,'ur','Ø·Û’ Ø´Ø¯Û Ù…Ù‚Ø¯Ø§Ø±',0),(489320,13593,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(489321,13593,'vi','Sá»‘ lÆ°á»£ng máº·c Ä‘á»‹nh',0),(489322,13593,'af','Verstek hoeveelheid',0),(489323,13593,'ro','Implicit cantitatea',0),(489324,13593,'et','Vaikekogus',0),(489325,13593,'si','Privzeta koliÄina',0),(489326,13593,'ba','Kuantitas standar',0),(489327,13593,'nl','Standaard hoeveelheid',0),(489328,13593,'fi','OletusmÃ¤Ã¤rÃ¤',0),(489329,13593,'no','Standardantallet',0),(489330,13593,'da','Standardantallet',0),(489331,13593,'ko','ê¸°ë³¸ ìˆ˜ëŸ‰',0),(489332,13593,'he','×›×ž×•×ª ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(489333,13593,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(489334,13593,'zh','é»˜è®¤æ•°é‡',0),(489335,13593,'sv','Standardkvantiteten',0),(489336,13593,'it','QuantitÃ  predefinita',0),(489337,13593,'tl','',0),(489338,13593,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(489339,13593,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(489340,13593,'ms','Kuantiti lalai',0),(489341,13593,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(489342,13593,'fr','QuantitÃ© par dÃ©faut',0),(489343,13593,'jp','æ—¢å®šã®æ•°é‡',0),(489344,13593,'pt','Quantidade padrÃ£o',0),(489345,13593,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(489346,13593,'es','Cantidad Predeterminada',0),(489347,13593,'de','Standardmenge',0),(489348,13593,'en','Default Quantity',0),(489349,13594,'is','',0),(489350,13594,'dr','Ø§Ù…Ù†ÛŒØª ÙˆØ±ÙˆØ¯ÛŒ ØªØµÙˆÛŒØ±',0),(489351,13594,'pr','Ø§Ù…Ù†ÛŒØª ÙˆØ±ÙˆØ¯ÛŒ ØªØµÙˆÛŒØ±',0),(489352,13594,'tr','GiriÅŸ gÃ¼venlik gÃ¶rÃ¼ntÃ¼',0),(489353,13594,'pl','Obraz wejÅ›ciowy bezpieczeÅ„stwa',0),(489354,13594,'bg','Ð’Ñ…Ð¾Ð´ÐµÐ½ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(489355,13594,'ur','Ø§Ù† Ù¾Ù¹ Ø³Ù„Ø§Ù…ØªÛŒ Ú©ÛŒ ØªØµÙˆÛŒØ±',0),(489356,13594,'sr','Ð¡Ð»Ð¸ÐºÐ° Ð·Ð° ÑƒÐ½Ð¾Ñ Ð±ÐµÐ·Ð±ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(489357,13594,'vi','HÃ¬nh áº£nh Ä‘áº§u vÃ o an ninh',0),(489358,13594,'af','Insette sekuriteit beeld',0),(489359,13594,'ro','Imagine de intrare de securitate',0),(489360,13594,'et','Sisendi turvalisuse pilt',0),(489361,13594,'si','Vhodni varnostno sliko',0),(489362,13594,'ba','Gambar masukan keamanan',0),(489363,13594,'nl','Beveiligingsvak die invoer',0),(489364,13594,'fi','Tuotantopanosten turvallisuuden kuva',0),(489365,13594,'no','Input sikkerhetsbildet',0),(489366,13594,'da','Input-afbildning',0),(489367,13594,'ko','ìž…ë ¥ëœ ë³´ì•ˆ ì´ë¯¸ì§€',0),(489368,13594,'he','×ª×ž×•× ×ª ××‘×˜×—×” ×§×œ×˜',0),(489369,13594,'el','Î•Î¹ÏƒÏŒÎ´Î¿Ï… Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚ ÎµÎ¹ÎºÏŒÎ½Î±Ï‚',0),(489370,13594,'zh','è¾“å…¥å®‰å…¨å›¾ç‰‡',0),(489371,13594,'sv','IngÃ¥ng sÃ¤kerhet bild',0),(489372,13594,'it','Immagine di ingresso di sicurezza',0),(489373,13594,'tl','',0),(489374,13594,'th','à¸›à¹‰à¸­à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸„à¸§à¸²à¸¡à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢à¸£à¸¹à¸›',0),(489375,13594,'hi','à¤‡à¤¨à¤ªà¥à¤Ÿ à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤›à¤µà¤¿',0),(489376,13594,'ms','Gambar Keselamatan input',0),(489377,13594,'ar','ØµÙˆØ±Ø© Ø§Ù„Ø£Ù…Ù† Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(489378,13594,'fr','Image de sÃ©curitÃ© d\'entrÃ©e',0),(489379,13594,'jp','å…¥åŠ›ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£ç”»åƒ',0),(489380,13594,'pt','Imagem de seguranÃ§a de entrada',0),(489381,13594,'ru','Ð‘ÐµÐ·Ð¾Ð¿Ð°ÑÐ½Ð¾ÑÑ‚Ð¸ Ð²Ð²Ð¾Ð´Ð° Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(489382,13594,'es','Imagen de entrada de seguridad',0),(489383,13594,'de','Sicherheit-Bild',0),(489384,13594,'en','Input Security Image',0),(489385,13595,'is','',0),(489386,13595,'dr','Ø«Ø¨Øª',0),(489387,13595,'pr','Ø«Ø¨Øª',0),(489388,13595,'tr','Ãœye ol',0),(489389,13595,'pl','Zarejestruj siÄ™',0),(489390,13595,'bg','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ ÑÐµ',0),(489391,13595,'ur','Ø±Ø¬Ø³Ù¹Ø± Ú©Ø±ÛŒÚº',0),(489392,13595,'sr','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº',0),(489393,13595,'vi','ÄÄƒng kÃ½',0),(489394,13595,'af','Register',0),(489395,13595,'ro','ÃŽnregistreazÄƒ-te',0),(489396,13595,'et','Registreeru',0),(489397,13595,'si','Registracija',0),(489398,13595,'ba','Daftar',0),(489399,13595,'nl','Registreren',0),(489400,13595,'fi','RekisterÃ¶idy',0),(489401,13595,'no','Registrering',0),(489402,13595,'da','Registrer',0),(489403,13595,'ko','ë“±ë¡',0),(489404,13595,'he','×”×§×•×¤×”',0),(489405,13595,'el','Î•Î³Î³ÏÎ¬ÏˆÎ¿Ï…',0),(489406,13595,'zh','æ³¨å†Œ',0),(489407,13595,'sv','Registrera dig',0),(489408,13595,'it','Registro',0),(489409,13595,'tl','',0),(489410,13595,'th','à¸¥à¸‡à¸—à¸°à¹€à¸šà¸µà¸¢à¸™',0),(489411,13595,'hi','à¤ªà¤‚à¤œà¥€à¤•à¥ƒà¤¤ à¤•à¤°à¥‡à¤‚',0),(489412,13595,'ms','Mendaftar',0),(489413,13595,'ar','Ø³Ø¬Ù„',0),(489414,13595,'fr','S\'inscrire',0),(489415,13595,'jp','ç™»éŒ²',0),(489416,13595,'pt','Registre-se',0),(489417,13595,'ru','Ð—Ð°Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒÑÑ',0),(489418,13595,'es','Registro',0),(489419,13595,'de','Registrieren',0),(489420,13595,'en','Register',0),(489421,13596,'is','',0),(489422,13596,'dr','ØªØºÛŒÛŒØ± Ù…Ù‚Ø¯Ø§Ø± ØªØ®Øª',0),(489423,13596,'pr','ØªØºÛŒÛŒØ± Ù…Ù‚Ø¯Ø§Ø± ØªØ®Øª',0),(489424,13596,'tr','DÃ¼z bir miktar DeÄŸiÅŸtir',0),(489425,13596,'pl','Zmiana kwoty pÅ‚aski',0),(489426,13596,'bg','ÐŸÐ»Ð¾ÑÑŠÐº Ñ€Ð°Ð·Ð¼ÐµÑ€ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(489427,13596,'ur','ÙÙ„ÛŒÙ¹ Ø±Ù‚Ù… ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(489428,13596,'sr','Ð Ð°Ð²Ð°Ð½ Ð¸Ð·Ð½Ð¾Ñ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(489429,13596,'vi','CÄƒn há»™ sá»‘ tiá»n thay Ä‘á»•i',0),(489430,13596,'af','Plat bedrag verander',0),(489431,13596,'ro','Schimbare plat suma',0),(489432,13596,'et','Korter suuruse muutmine',0),(489433,13596,'si','Ravno znesek spremembe',0),(489434,13596,'ba','Perubahan jumlah datar',0),(489435,13596,'nl','Platte bedrag wijzigen',0),(489436,13596,'fi','KiinteÃ¤ summa muutos',0),(489437,13596,'no','Flat belÃ¸pet endring',0),(489438,13596,'da','Flad belÃ¸b Ã¦ndring',0),(489439,13596,'ko','í‰ë©´ ê¸ˆì•¡ ë³€ê²½',0),(489440,13596,'he','×©×™× ×•×™ ×›×ž×•×ª ×©×˜×•×—',0),(489441,13596,'el','Î•Ï€Î¯Ï€ÎµÎ´Î· Ï€Î¿ÏƒÏŒ Î±Î»Î»Î±Î³Î®',0),(489442,13596,'zh','å¹³é‡å˜åŒ–',0),(489443,13596,'sv','Platt belopp fÃ¶rÃ¤ndring',0),(489444,13596,'it','Modifica importo piatta',0),(489445,13596,'tl','',0),(489446,13596,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸„à¸‡à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™',0),(489447,13596,'hi','à¤«à¥à¤²à¥ˆà¤Ÿ à¤°à¤¾à¤¶à¤¿ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(489448,13596,'ms','Perubahan jumlah rata',0),(489449,13596,'ar','ØªØºÙŠÙŠØ± Ù…Ù‚Ø¯Ø§Ø± Ù…Ø³Ø·Ø­',0),(489450,13596,'fr','Changement d\'un montant fixe',0),(489451,13596,'jp','å¹³ã‚‰ãªé‡ã®å¤‰åŒ–',0),(489452,13596,'pt','MudanÃ§a de valor fixo',0),(489453,13596,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ñ„Ð¸ÐºÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð¾Ð¹ ÑÑƒÐ¼Ð¼Ñ‹',0),(489454,13596,'es','Monto de Cargo Fijo',0),(489455,13596,'de','Pauschalbetrag Ã¤ndern',0),(489456,13596,'en','Flat Amount Change',0),(489457,13597,'is','',0),(489458,13597,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø±Ø¯Ù‡ Ù‚ÛŒÙ…Øª Ø§Ù‚Ù„Ø§Ù…',0),(489459,13597,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø±Ø¯Ù‡ Ù‚ÛŒÙ…Øª Ø§Ù‚Ù„Ø§Ù…',0),(489460,13597,'tr','Ã–ÄŸelerin fiyatlarÄ± Kategori DÃ¼zenle',0),(489461,13597,'pl','Elementy ceny kategorii edycji',0),(489462,13597,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ñ†ÐµÐ½Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(489463,13597,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ù‚ÛŒÙ…ØªÛŒÚº Ø²Ù…Ø±Û ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(489464,13597,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ñ†ÐµÐ½Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(489465,13597,'vi','Chá»‰nh sá»­a má»¥c giÃ¡ cáº£ thá»ƒ loáº¡i',0),(489466,13597,'af','Items pryse kategorie redigeer',0),(489467,13597,'ro','Elemente de preÅ£uri categoria Edit',0),(489468,13597,'et','Kaupade hinnad kategooria redigeerimine',0),(489469,13597,'si','Elementi cene Kategorija Uredi',0),(489470,13597,'ba','Item harga kategori Edit',0),(489471,13597,'nl','Items prijzen categorie bewerken',0),(489472,13597,'fi','Nimikkeiden hinnat luokka muokkaus',0),(489473,13597,'no','Elementer priser kategorien Rediger',0),(489474,13597,'da','Elementer priser kategori Rediger',0),(489475,13597,'ko','í•­ëª© ê°€ê²© ì¹´í…Œê³ ë¦¬ íŽ¸ì§‘',0),(489476,13597,'he','×¤×¨×™×˜×™× ×”×ž×—×™×¨×™× ×‘×§×˜×’×•×¨×™×” ×¢×¨×™×›×”',0),(489477,13597,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î¹Î¼ÏŽÎ½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(489478,13597,'zh','é¡¹ç›®ä»·æ ¼ç±»åˆ«ç¼–è¾‘',0),(489479,13597,'sv','Objekt priser kategorin redigera',0),(489480,13597,'it','Modifica di categoria prezzi articoli',0),(489481,13597,'tl','',0),(489482,13597,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸£à¸²à¸„à¸²à¸›à¸£à¸°à¹€à¸ à¸—à¹à¸à¹‰à¹„à¸‚',0),(489483,13597,'hi','à¤µà¤¸à¥à¤¤à¥à¤“à¤‚ à¤•à¥€ à¤•à¥€à¤®à¤¤à¥‡à¤‚ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(489484,13597,'ms','Mengedit kategori harga barangan',0),(489485,13597,'ar','ØªØ­Ø±ÙŠØ± ÙØ¦Ø© Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¨Ù†ÙˆØ¯',0),(489486,13597,'fr','Ã‰lÃ©ments prix catÃ©gorie Edit',0),(489487,13597,'jp','é …ç›®ä¾¡æ ¼ã‚«ãƒ†ã‚´ãƒªãƒ¼ç·¨é›†',0),(489488,13597,'pt','EdiÃ§Ã£o de categoria de preÃ§os de itens',0),(489489,13597,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ Ñ†ÐµÐ½Ñ‹',0),(489490,13597,'es','Editar CategorÃ­a de Precios de Items',0),(489491,13597,'de','Artikel Preise Kategorie bearbeiten',0),(489492,13597,'en','Items Prices Category Edit',0),(489493,13598,'is','',0),(489494,13598,'dr','Ø¯Ø±ØµØ¯ ØªØºÛŒÛŒØ±',0),(489495,13598,'pr','Ø¯Ø±ØµØ¯ ØªØºÛŒÛŒØ±',0),(489496,13598,'tr','YÃ¼zde deÄŸiÅŸim',0),(489497,13598,'pl','Zmiana procentowa',0),(489498,13598,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(489499,13598,'ur','ÙÛŒ ØµØ¯ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(489500,13598,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ÑƒÐ°Ð»Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(489501,13598,'vi','Pháº§n trÄƒm thay Ä‘á»•i',0),(489502,13598,'af','Persentasie verandering',0),(489503,13598,'ro','Procent de schimbare',0),(489504,13598,'et','Protsentuaalne muutus',0),(489505,13598,'si','Odstotkov sprememb',0),(489506,13598,'ba','Persentase perubahan',0),(489507,13598,'nl','Percentage wijzigen',0),(489508,13598,'fi','Prosentuaalinen muutos',0),(489509,13598,'no','Prosentvis forandring',0),(489510,13598,'da','Procentvis Ã¦ndring',0),(489511,13598,'ko','ë°±ë¶„ìœ¨ ë³€ê²½',0),(489512,13598,'he','×©×™×¢×•×¨ ×©×™× ×•×™',0),(489513,13598,'el','Î Î¿ÏƒÎ¿ÏƒÏ„Î¹Î±Î¯Î± Î±Î»Î»Î±Î³Î®',0),(489514,13598,'zh','å˜åŒ–ç™¾åˆ†æ¯”',0),(489515,13598,'sv','Procentuell fÃ¶rÃ¤ndring',0),(489516,13598,'it','Variazione percentuale',0),(489517,13598,'tl','',0),(489518,13598,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(489519,13598,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(489520,13598,'ms','Peratus perubahan',0),(489521,13598,'ar','ØªØºÙŠØ± Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ©',0),(489522,13598,'fr','Variation en pourcentage',0),(489523,13598,'jp','å¤‰åŒ–çŽ‡',0),(489524,13598,'pt','Porcentagem de mudanÃ§a',0),(489525,13598,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ð¾Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(489526,13598,'es','Porciento de Cambio',0),(489527,13598,'de','Prozentuale Ã„nderung',0),(489528,13598,'en','Percent Change',0),(489529,13599,'is','',0),(489530,13599,'dr','Ù„Ø·ÙØ§ ØªÙ†Ø¸ÛŒÙ… Ø¯Ø±ØµØ¯ ÛŒØ§ Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(489531,13599,'pr','Ù„Ø·ÙØ§ ØªÙ†Ø¸ÛŒÙ… Ø¯Ø±ØµØ¯ ÛŒØ§ Ù…Ù‚Ø¯Ø§Ø± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(489532,13599,'tr','AyarÄ± yÃ¼zde veya tutar giriniz',0),(489533,13599,'pl','ProszÄ™ wprowadziÄ‡ korekty procent lub kwota',0),(489534,13599,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ ÑÑƒÐ¼Ð°',0),(489535,13599,'ur','Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ ÙÛŒØµØ¯ ÛŒØ§ Ø±Ù‚Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(489536,13599,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð¸Ð»Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(489537,13599,'vi','Vui lÃ²ng nháº­p má»™t Ä‘iá»u chá»‰nh pháº§n trÄƒm hoáº·c sá»‘ tiá»n',0),(489538,13599,'af','Tik asseblief \'n aanpassing persent of bedrag',0),(489539,13599,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i o ajustare la sutÄƒ sau suma',0),(489540,13599,'et','Palun sisestage korrigeerimise protsendi vÃµi summa',0),(489541,13599,'si','Prosimo, vnesite popravek odstotek ali znesek',0),(489542,13599,'ba','Masukkan penyesuaian persen atau jumlah',0),(489543,13599,'nl','Voer een aanpassing percentage of bedrag',0),(489544,13599,'fi','Anna oikaisu prosenttia tai mÃ¤Ã¤rÃ¤',0),(489545,13599,'no','Angi en justering prosent eller belÃ¸p',0),(489546,13599,'da','Angiv en justering procent eller belÃ¸b',0),(489547,13599,'ko','ì¡°ì • % ë˜ëŠ” ê¸ˆì•¡ì„ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(489548,13599,'he','×œ×§×œ×” ×•×¤×©×•×˜×”-×”×–×™× ×• ××ª ×”×ª××ž×ª ××—×•×– ××• ×¡×›×•×',0),(489549,13599,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼Î¹Î± Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Î® Ï€Î¿ÏƒÏŒ',0),(489550,13599,'zh','è¯·è¾“å…¥è°ƒæ•´ %æˆ–é‡‘é¢',0),(489551,13599,'sv','Ange en justering procent eller belopp',0),(489552,13599,'it','Inserisci una regolazione percentuale o importo',0),(489553,13599,'tl','',0),(489554,13599,'th','à¹‚à¸›à¸£à¸”à¸£à¸°à¸šà¸¸à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸«à¸£à¸·à¸­à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™',0),(489555,13599,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤¯à¤¾ à¤°à¤¾à¤¶à¤¿ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(489556,13599,'ms','Sila masukkan satu pelarasan peratus atau jumlah',0),(489557,13599,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø£Ø¯Ø®Ù„ Ø§Ù„ØªÙƒÙŠÙ ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ø£Ùˆ Ø§Ù„Ù…Ø¨Ù„Øº',0),(489558,13599,'fr','Veuillez saisir un ajustement pour cent ou le montant',0),(489559,13599,'jp','èª¿æ•´ % ã¾ãŸã¯é‡‘é¡ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(489560,13599,'pt','Por favor insira um por cento de ajuste ou quantidade',0),(489561,13599,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¿ÐµÑ€ÐµÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð² Ð¸Ð»Ð¸ ÑÑƒÐ¼Ð¼Ñ‹',0),(489562,13599,'es','Por Favor Entra Un Por Ciento de Ajuste o Cantidad',0),(489563,13599,'de','Bitte geben Sie eine Anpassung Prozent oder Betrag',0),(489564,13599,'en','Please Enter An Adjustment Percent Or Amount',0),(489565,13600,'is','',0),(489566,13600,'dr','Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(489567,13600,'pr','Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(489568,13600,'tr','FiyatlandÄ±rma baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(489569,13600,'pl','Cennik zaktualizowany',0),(489570,13600,'bg','Ð¦ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(489571,13600,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(489572,13600,'sr','Ð¦ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(489573,13600,'vi','Báº£ng giÃ¡ Cáº­p Nháº­t thÃ nh cÃ´ng',0),(489574,13600,'af','Pryse suksesvol bygewerk',0),(489575,13600,'ro','Preturi actualizate cu succes',0),(489576,13600,'et','Hinnakujunduse vÃ¤rskendatud',0),(489577,13600,'si','Cenitev uspeÅ¡no posodobljena',0),(489578,13600,'ba','Harga diperbarui berhasil',0),(489579,13600,'nl','Prijzen bijgewerkt',0),(489580,13600,'fi','Hinnoittelu pÃ¤ivitetty',0),(489581,13600,'no','Priser oppdatert',0),(489582,13600,'da','Priser opdateret',0),(489583,13600,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ê°€ê²©',0),(489584,13600,'he','×ª×ž×—×•×¨ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(489585,13600,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(489586,13600,'zh','å®šä»·å·²æˆåŠŸæ›´æ–°',0),(489587,13600,'sv','PrissÃ¤ttning uppdaterats',0),(489588,13600,'it','Prezzi aggiornato con successo',0),(489589,13600,'tl','',0),(489590,13600,'th','à¸£à¸²à¸„à¸²à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(489591,13600,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(489592,13600,'ms','Harga dikemaskini berjaya',0),(489593,13600,'ar','ØªØ³Ø¹ÙŠØ± ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(489594,13600,'fr','Prix mis Ã  jour avec succÃ¨s',0),(489595,13600,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸä¾¡æ ¼',0),(489596,13600,'pt','PreÃ§os atualizados com sucesso',0),(489597,13600,'ru','Ð¦ÐµÐ½Ñ‹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(489598,13600,'es','Precios Actualizados Exitosamente',0),(489599,13600,'de','Preise aktualisiert erfolgreich',0),(489600,13600,'en','Pricing Updated Successfully',0),(489601,13601,'is','',0),(489602,13601,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¯Ø³ØªÙ‡ Ø¨Ù†Ø¯ÛŒ',0),(489603,13601,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¯Ø³ØªÙ‡ Ø¨Ù†Ø¯ÛŒ',0),(489604,13601,'tr','Kategorileri seÃ§in',0),(489605,13601,'pl','Wybierz kategorie',0),(489606,13601,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(489607,13601,'ur','Ø²Ù…Ø±Û Ø¬Ø§Øª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(489608,13601,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(489609,13601,'vi','Chá»n thá»ƒ loáº¡i',0),(489610,13601,'af','Kies kategorieÃ«',0),(489611,13601,'ro','SelectaÅ£i categoriile',0),(489612,13601,'et','Valige Kategooriad',0),(489613,13601,'si','Izberite kategorije',0),(489614,13601,'ba','Pilih kategori',0),(489615,13601,'nl','Selecteer CategorieÃ«n',0),(489616,13601,'fi','Valitse Luokat',0),(489617,13601,'no','Velge kategorier',0),(489618,13601,'da','VÃ¦lg kategorier',0),(489619,13601,'ko','ë²”ì£¼ ì„ íƒ',0),(489620,13601,'he','×‘×—×¨ ×§×˜×’×•×¨×™×•×ª',0),(489621,13601,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(489622,13601,'zh','é€‰æ‹©ç±»åˆ«',0),(489623,13601,'sv','VÃ¤lj kategorier',0),(489624,13601,'it','Selezionare le categorie',0),(489625,13601,'tl','',0),(489626,13601,'th','à¹€à¸¥à¸·à¸­à¸à¸›à¸£à¸°à¹€à¸ à¸—',0),(489627,13601,'hi','à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(489628,13601,'ms','Pilih kategori',0),(489629,13601,'ar','Ø­Ø¯Ø¯ ÙØ¦Ø§Øª',0),(489630,13601,'fr','SÃ©lectionnez les catÃ©gories',0),(489631,13601,'jp','ã‚«ãƒ†ã‚´ãƒªã‚’é¸æŠžã—ã¾ã™ã€‚',0),(489632,13601,'pt','Selecionar categorias',0),(489633,13601,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(489634,13601,'es','Selecciona CategorÃ­as',0),(489635,13601,'de','WÃ¤hlen Sie Kategorien',0),(489636,13601,'en','Select Categories',0),(489637,13602,'is','',0),(489638,13602,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³Ø·Ø­ Ù‚ÛŒÙ…Øª',0),(489639,13602,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³Ø·Ø­ Ù‚ÛŒÙ…Øª',0),(489640,13602,'tr','Fiyat dÃ¼zeyi seÃ§in',0),(489641,13602,'pl','Wybierz poziom cen',0),(489642,13602,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ†ÐµÐ½Ð¾Ð²Ð¸ Ð½Ð¸Ð²Ð°',0),(489643,13602,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ Ø³Ø·Ø­ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(489644,13602,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð°',0),(489645,13602,'vi','Chá»n má»©c giÃ¡',0),(489646,13602,'af','Kies prys vlakke',0),(489647,13602,'ro','SelectaÈ›i nivelurile de preÅ£',0),(489648,13602,'et','Valige hinnatasemete',0),(489649,13602,'si','Izberite ravni cen',0),(489650,13602,'ba','Pilih tingkat harga',0),(489651,13602,'nl','Selecteer prijsniveaus',0),(489652,13602,'fi','Valitse hintataso',0),(489653,13602,'no','Velg prisnivÃ¥',0),(489654,13602,'da','VÃ¦lg prisniveau',0),(489655,13602,'ko','ê°€ê²© ìˆ˜ì¤€ ì„ íƒ',0),(489656,13602,'he','×‘×—×¨ ×¨×ž×•×ª ×ž×—×™×¨',0),(489657,13602,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î± ÎµÏ€Î¯Ï€ÎµÎ´Î± Ï„Î¹Î¼ÏŽÎ½',0),(489658,13602,'zh','é€‰æ‹©ä»·æ ¼æ°´å¹³',0),(489659,13602,'sv','VÃ¤lj prisnivÃ¥er',0),(489660,13602,'it','Selezionare i livelli di prezzo',0),(489661,13602,'tl','',0),(489662,13602,'th','à¹€à¸¥à¸·à¸­à¸à¸£à¸°à¸”à¸±à¸šà¸£à¸²à¸„à¸²',0),(489663,13602,'hi','à¤•à¥€à¤®à¤¤ à¤•à¥‡ à¤¸à¥à¤¤à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(489664,13602,'ms','Pilih paras harga',0),(489665,13602,'ar','Ø­Ø¯Ø¯ Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(489666,13602,'fr','SÃ©lectionnez les niveaux de prix',0),(489667,13602,'jp','ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(489668,13602,'pt','Selecione os nÃ­veis de preÃ§o',0),(489669,13602,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ñ†ÐµÐ½',0),(489670,13602,'es','Selecciona Niveles de Precios',0),(489671,13602,'de','WÃ¤hlen Sie Preisniveau',0),(489672,13602,'en','Select Price Levels',0),(489673,13603,'is','',0),(489674,13603,'dr','Ù‚ÛŒÙ…Øª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(489675,13603,'pr','Ù‚ÛŒÙ…Øª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(489676,13603,'tr','Fiyat gÃ¼ncelleÅŸtirme',0),(489677,13603,'pl','Aktualizacja cen',0),(489678,13603,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¸',0),(489679,13603,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(489680,13603,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ†ÐµÐ½Ðµ',0),(489681,13603,'vi','Cáº­p Nháº­t giÃ¡ cáº£',0),(489682,13603,'af','Werk pryse',0),(489683,13603,'ro','Actualizare de stabilire a preÅ£urilor',0),(489684,13603,'et','Uuendatud hinnakujundus',0),(489685,13603,'si','Posodobitev cene',0),(489686,13603,'ba','Memperbarui harga',0),(489687,13603,'nl','Update prijzen',0),(489688,13603,'fi','PÃ¤ivitÃ¤ hinnoittelu',0),(489689,13603,'no','Oppdatere priser',0),(489690,13603,'da','Opdatere priser',0),(489691,13603,'ko','ê°€ê²© ì—…ë°ì´íŠ¸',0),(489692,13603,'he','×¢×“×›×•×Ÿ ×ž×—×™×¨×™×',0),(489693,13603,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¹Î¼ÏŽÎ½',0),(489694,13603,'zh','æ›´æ–°å®šä»·',0),(489695,13603,'sv','Uppdatera prissÃ¤ttning',0),(489696,13603,'it','Aggiornamento prezzi',0),(489697,13603,'tl','',0),(489698,13603,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸„à¸²',0),(489699,13603,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(489700,13603,'ms','Kemaskini Terakhir harga',0),(489701,13603,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(489702,13603,'fr','Mise Ã  jour des prix',0),(489703,13603,'jp','ä¾¡æ ¼ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(489704,13603,'pt','AtualizaÃ§Ã£o de preÃ§os',0),(489705,13603,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ñ†ÐµÐ½',0),(489706,13603,'es','Actualizar Precios',0),(489707,13603,'de','Preise aktualisieren',0),(489708,13603,'en','Update Pricing',0),(489709,13604,'is','',0),(489710,13604,'dr','Ø­Ø¯Ø§Ù‚Ù„ ÛŒÚ© Ø±Ø¯Ù‡ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆØ¯',0),(489711,13604,'pr','Ø­Ø¯Ø§Ù‚Ù„ ÛŒÚ© Ø±Ø¯Ù‡ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆØ¯',0),(489712,13604,'tr','En az bir kategori seÃ§ilmelidir',0),(489713,13604,'pl','NaleÅ¼y wybraÄ‡ przynajmniej jednÄ… kategoriÄ™',0),(489714,13604,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ð½Ðµ ÐµÐ´Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(489715,13604,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø§ÛŒÚ© Ø²Ù…Ø±Û Ù…Ù†ØªØ®Ø¨ Ú©ÛŒ Ø¬Ø§Ù†ÛŒ Ú†Ø§ÛÛŒÛ’',0),(489716,13604,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ñ‚Ð¸ Ð±Ð°Ñ€ Ñ˜ÐµÐ´Ð½Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ',0),(489717,13604,'vi','Pháº£i chá»n Ã­t nháº¥t má»™t thá»ƒ loáº¡i',0),(489718,13604,'af','Ten minste een kategorie moet gekies word',0),(489719,13604,'ro','Trebuie selectatÄƒ cel puÈ›in o categorie',0),(489720,13604,'et','Tuleb valida vÃ¤hemalt Ã¼ks kategooria',0),(489721,13604,'si','Izbrati morate vsaj eno kategorijo',0),(489722,13604,'ba','Setidaknya satu kategori harus dipilih',0),(489723,13604,'nl','Ten minste Ã©Ã©n categorie moet worden geselecteerd',0),(489724,13604,'fi','VÃ¤hintÃ¤Ã¤n yksi luokka on valittava',0),(489725,13604,'no','Minst Ã©n kategori mÃ¥ velges',0),(489726,13604,'da','Der skal vÃ¦lges mindst Ã©n kategori',0),(489727,13604,'ko','í•˜ë‚˜ ì´ìƒì˜ ë²”ì£¼ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(489728,13604,'he','×™×© ×œ×‘×—×•×¨ ×œ×¤×—×•×ª ×§×˜×’×•×¨×™×” ××—×ª',0),(489729,13604,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ Î¼Î¯Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(489730,13604,'zh','å¿…é¡»é€‰æ‹©è‡³å°‘ä¸€ä¸ªç±»åˆ«',0),(489731,13604,'sv','Minst en kategori mÃ¥ste vÃ¤ljas',0),(489732,13604,'it','Ãˆ necessario selezionare almeno una categoria',0),(489733,13604,'tl','',0),(489734,13604,'th','à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸­à¸¢à¹ˆà¸²à¸‡à¸™à¹‰à¸­à¸¢à¸«à¸™à¸¶à¹ˆà¸‡à¸›à¸£à¸°à¹€à¸ à¸—',0),(489735,13604,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤šà¤¯à¤¨à¤¿à¤¤ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(489736,13604,'ms','Sekurang-kurangnya satu kategori mesti dipilih',0),(489737,13604,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØªÙ… ØªØ­Ø¯ÙŠØ¯ ÙØ¦Ø© ÙˆØ§Ø­Ø¯Ø© Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„',0),(489738,13604,'fr','Au moins une catÃ©gorie doit Ãªtre sÃ©lectionnÃ©e',0),(489739,13604,'jp','å°‘ãªãã¨ã‚‚ 1 ã¤ã®ã‚«ãƒ†ã‚´ãƒªã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(489740,13604,'pt','Pelo menos uma categoria deve ser selecionada',0),(489741,13604,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½ Ð¿Ð¾ ÐºÑ€Ð°Ð¹Ð½ÐµÐ¹ Ð¼ÐµÑ€Ðµ Ð¾Ð´Ð½Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ',0),(489742,13604,'es','Por Lo Menos Una CategorÃ­a Debe Estar Seleccionada',0),(489743,13604,'de','Mindestens eine Kategorie muss ausgewÃ¤hlt werden',0),(489744,13604,'en','At Least One Category Must Be Selected',0),(489745,13605,'is','',0),(489746,13605,'dr','Ø¯Ø± Ø§Ø¬Ø§Ø±Ù‡ ÛŒÚ© Ø³Ø·Ø­ Ù‚ÛŒÙ…Øª Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆØ¯',0),(489747,13605,'pr','Ø¯Ø± Ø§Ø¬Ø§Ø±Ù‡ ÛŒÚ© Ø³Ø·Ø­ Ù‚ÛŒÙ…Øª Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ø´ÙˆØ¯',0),(489748,13605,'tr','Kira bir fiyat dÃ¼zeyinde seÃ§ilmesi gerekir',0),(489749,13605,'pl','W leasing, naleÅ¼y wybraÄ‡ jeden poziom cen',0),(489750,13605,'bg','ÐÐ°Ð¹-Ð»Ð¸Ð·Ð¸Ð½Ð³ ÐµÐ´Ð¸Ð½ Ñ†ÐµÐ½Ð¾Ð²Ð¾ Ð½Ð¸Ð²Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½',0),(489751,13605,'ur','Ù„ÛŒØ² Ù¾Ø± Ù‚ÛŒÙ…Øª Ú©Ùˆ Ø§ÛŒÚ© Ø³Ø·Ø­ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒ Ø¬Ø§Ù†ÛŒ Ú†Ø§ÛÛŒÛ’',0),(489752,13605,'sr','Ð£ Ð·Ð°ÐºÑƒÐ¿ Ñ˜ÐµÐ´Ð°Ð½ Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½.',0),(489753,13605,'vi','Táº¡i thuÃª má»™t má»©c giÃ¡ pháº£i Ä‘Æ°á»£c chá»n',0),(489754,13605,'af','By huurkontrak een prys vlak moet gekies word',0),(489755,13605,'ro','La leasing trebuie selectat un nivel de preÅ£',0),(489756,13605,'et','Liising Ã¼he hinnatase tuleb valida',0),(489757,13605,'si','V zakup se izbere eno raven cen',0),(489758,13605,'ba','Di sewa satu tingkat harga harus dipilih',0),(489759,13605,'nl','Bij Lease moet een prijsniveau worden geselecteerd',0),(489760,13605,'fi','Klo vuokrasopimuksen yksi hintataso on valittava',0),(489761,13605,'no','PÃ¥ Lease mÃ¥ ett prisnivÃ¥et velges',0),(489762,13605,'da','PÃ¥ leasing skal et prisniveau vÃ¦lges',0),(489763,13605,'ko','ìž„ëŒ€ì— í•œ ê°€ê²© ë ˆë²¨ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(489764,13605,'he','×œ×¤×—×•×ª ×™×© ×œ×‘×—×•×¨ ×¨×ž×ª ×ž×—×™×¨ ××—×“',0),(489765,13605,'el','Î Î¬ÏƒÎ· Ï€ÎµÏÎ¹Ï€Ï„ÏŽÏƒÎµÎ¹, Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï„Î¹Î¼ÏŽÎ½',0),(489766,13605,'zh','å¿…é¡»è‡³å°‘é€‰æ‹©ä¸€ä¸ªä»·æ ¼æ°´å¹³',0),(489767,13605,'sv','Vid leasing mÃ¥ste en prisnivÃ¥ vÃ¤ljas',0),(489768,13605,'it','Al contratto di locazione deve essere selezionato un livello di prezzo',0),(489769,13605,'tl','',0),(489770,13605,'th','à¸—à¸µà¹ˆà¹€à¸Šà¹ˆà¸² à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸£à¸°à¸”à¸±à¸šà¸£à¸²à¸„à¸²à¸«à¸™à¸¶à¹ˆà¸‡',0),(489771,13605,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤ªà¤° à¤à¤• à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤šà¤¯à¤¨à¤¿à¤¤ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(489772,13605,'ms','Pada pajakan satu paras harga perlu dipilih',0),(489773,13605,'ar','ÙŠØ¬Ø¨ ØªØ­Ø¯ÙŠØ¯ Ù…Ø³ØªÙˆÙ‰ Ø³Ø¹Ø± ÙˆØ§Ø­Ø¯ ÙÙŠ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(489774,13605,'fr','Au moins un niveau de prix doit Ãªtre sÃ©lectionnÃ©',0),(489775,13605,'jp','è³ƒè²¸å€Ÿå¥‘ç´„ã§ 1 ã¤ã®ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(489776,13605,'pt','A locaÃ§Ã£o deve ser selecionado um nÃ­vel de preÃ§o',0),(489777,13605,'ru','Ð’ Ð°Ñ€ÐµÐ½Ð´Ñƒ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½ Ð¾Ð´Ð¸Ð½ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ñ†ÐµÐ½',0),(489778,13605,'es','Por Lo Menos Un Nivel de Precios Debe Estar Seleccionado',0),(489779,13605,'de','An der Miete muss ein Preisniveau ausgewÃ¤hlt werden',0),(489780,13605,'en','At Lease One Price Level Must Be Selected',0),(489781,13606,'is','',0),(489782,13606,'dr','ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª ÙØ±Ø³ØªØ§Ø¯Ù‡',0),(489783,13606,'pr','ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª ÙØ±Ø³ØªØ§Ø¯Ù‡',0),(489784,13606,'tr','BasÄ±nla gÃ¶nderilmeyen sipariÅŸ onaylandÄ±',0),(489785,13606,'pl','Zatwierdza zamÃ³wienia nie sÄ… wysyÅ‚ane do prasy',0),(489786,13606,'bg','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ðµ ÑÐµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð° Ð´Ð¾ Ð¿Ñ€ÐµÑÐ°Ñ‚Ð°',0),(489787,13606,'ur','Ù¾Ø±ÛŒØ³ Ú©Û’ Ù„ÛŒÛ’ Ù†ÛÛŒÚº Ø¨Ú¾ÛŒØ¬Ø§ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ',0),(489788,13606,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð½Ðµ ÑˆÐ°Ñ™Ñƒ Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ',0),(489789,13606,'vi','Cháº¥p thuáº­n Ä‘Æ¡n Ä‘áº·t hÃ ng khÃ´ng Ä‘Æ°á»£c gá»­i cho bÃ¡o chÃ­',0),(489790,13606,'af','Goedgekeurde bestellings nie gestuur om te druk',0),(489791,13606,'ro','Aprobat ordinele nu trimis la presÄƒ',0),(489792,13606,'et','Kinnitatud tellimusi ei edastata Press',0),(489793,13606,'si','Odobreni naroÄila ne poÅ¡ljejo Press',0),(489794,13606,'ba','Disetujui pesanan yang tidak dikirim ke pers',0),(489795,13606,'nl','Goedgekeurde bestellingen niet te druk op',0),(489796,13606,'fi','HyvÃ¤ksytty tilaukset eivÃ¤t lÃ¤hetetÃ¤Ã¤n painamalla',0),(489797,13606,'no','Godkjent ordrer ikke sendt til trykk',0),(489798,13606,'da','Godkendt ordrer ikke sendt til pressen',0),(489799,13606,'ko','ì–¸ë¡ ì— ë³´ë‚´ì§€ ì£¼ë¬¸ ìŠ¹ì¸',0),(489800,13606,'he','××•×©×¨×• ×”×–×ž× ×•×ª ×œ× × ×©×œ×— ×œ×¢×™×ª×•× ×•×ª',0),(489801,13606,'el','Î•Î³ÎºÏÎ¯Î½ÎµÎ¹ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Ï„Î·Ï‚ Î±Ï€ÎµÏ…Î¸ÏÎ½Î¿Ï…Î½ Î´ÎµÎ½ Ï„ÏÏ€Î¿Ï…',0),(489802,13606,'zh','æ‰¹å‡†è®¢å•ä¸ä¼šå‘é€åˆ°æ–°é—»',0),(489803,13606,'sv','GodkÃ¤nd order skickas inte till pressen',0),(489804,13606,'it','Approvati gli ordini non inviati alla stampa',0),(489805,13606,'tl','',0),(489806,13606,'th','à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹„à¸¡à¹ˆà¹„à¸›à¸à¸”',0),(489807,13606,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¹à¥€à¤‚ à¤­à¥‡à¤œà¤¾ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥€',0),(489808,13606,'ms','Pesanan tidak dihantar kepada penerbit yang diluluskan',0),(489809,13606,'ar','Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø± Ù„Ù… ØªØ±Ø³Ù„ Ø¥Ù„Ù‰ Ø§Ù„ØµØ­Ø§ÙØ©',0),(489810,13606,'fr','ApprouvÃ© les ordres ne pas transmis Ã  la presse',0),(489811,13606,'jp','ãƒ—ãƒ¬ã‚¹ã¸ã®ãªã„æ³¨æ–‡ã‚’æ‰¿èª',0),(489812,13606,'pt','Aprovados pedidos nÃ£o enviados Ã  imprensa',0),(489813,13606,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ñ‹ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð½Ðµ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÑÑŽÑ‚ÑÑ Ð² Ð¿Ñ€ÐµÑÑÐµ',0),(489814,13606,'es','Pedidos Aprobados No Se Mandan Para Imprimir',0),(489815,13606,'de','Bestellungen, die nicht an Presse genehmigt',0),(489816,13606,'en','Approved Orders Not Sent To Press',0),(489817,13607,'is','',0),(489818,13607,'dr','ØªØ¹Ø¯Ø§Ø¯ ØªÙ…Ø§Ù… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(489819,13607,'pr','ØªØ¹Ø¯Ø§Ø¯ ØªÙ…Ø§Ù… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(489820,13607,'tr','TÃ¼m miktar fatura',0),(489821,13607,'pl','ILOÅšÄ† wszystkie zapowiadane',0),(489822,13607,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(489823,13607,'ur','ØªÙ…Ø§Ù… Ù‚ÛŒ Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(489824,13607,'sr','Ð¡Ð²Ð¸ ÐšÐ¾Ð» Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(489825,13607,'vi','Táº¥t cáº£ QTY láº­p hoÃ¡ Ä‘Æ¡n',0),(489826,13607,'af','Alle QTY weerspieÃ«l',0),(489827,13607,'ro','Toate CANTIT facturat',0),(489828,13607,'et','Arve kogus',0),(489829,13607,'si','Vse kol zaraÄunali',0),(489830,13607,'ba','Semua QTY ditagih',0),(489831,13607,'nl','Alle QTY gefactureerd',0),(489832,13607,'fi','Kaikki mÃ¤Ã¤rÃ¤ laskutetaan',0),(489833,13607,'no','Alle antall som er fakturert',0),(489834,13607,'da','Alle QTY faktureret',0),(489835,13607,'ko','ëª¨ë“  ìˆ˜ëŸ‰ ì²­êµ¬',0),(489836,13607,'he','×›×œ ×›×ž×•×ª ×©×œ ×”×—×™×•×‘',0),(489837,13607,'el','ÎŒÎ»Î± QTY Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹',0),(489838,13607,'zh','æ‰€æœ‰æ•°é‡è®¡è´¹',0),(489839,13607,'sv','Alla antal faktureras',0),(489840,13607,'it','Tutti QTÃ€ fatturata',0),(489841,13607,'tl','',0),(489842,13607,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸—à¸µà¹ˆà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(489843,13607,'hi','à¤¸à¤­à¥€ à¤¬à¤¿à¤² à¤•à¥€ à¤—à¤ˆ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(489844,13607,'ms','Semua QTY yang dibilkan',0),(489845,13607,'ar','QTY Ø¬Ù…ÙŠØ¹ ÙÙˆØ§ØªÙŠØ±',0),(489846,13607,'fr','Toute quantitÃ© facturÃ©e',0),(489847,13607,'jp','ã™ã¹ã¦ã®æ•°é‡ã®è«‹æ±‚',0),(489848,13607,'pt','QTY todos de bico',0),(489849,13607,'ru','Ð’ÑÐµ QTY Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚',0),(489850,13607,'es','Toda Cantidad Facturada',0),(489851,13607,'de','Alle Menge in Rechnung gestellt',0),(489852,13607,'en','All QTY Billed',0),(489853,13608,'is','',0),(489854,13608,'dr','Ø³ÙØ§Ø±Ø´ ÙØ§Ú©ØªÙˆØ± Ù†Ù…ÛŒ',0),(489855,13608,'pr','Ø³ÙØ§Ø±Ø´ ÙØ§Ú©ØªÙˆØ± Ù†Ù…ÛŒ',0),(489856,13608,'tr','SipariÅŸ faturalayamazsÄ±nÄ±z',0),(489857,13608,'pl','Nie moÅ¼na zafakturowaÄ‡ zamÃ³wienia',0),(489858,13608,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(489859,13608,'ur','ØªØ±ØªÛŒØ¨ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0);
INSERT INTO `langdef` VALUES (489860,13608,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(489861,13608,'vi','KhÃ´ng thá»ƒ hoÃ¡ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(489862,13608,'af','Kan invoice orde',0),(489863,13608,'ro','Nu se poate comanda factura',0),(489864,13608,'et','Ei saa arvele',0),(489865,13608,'si','Ne morete fakturirati nalog',0),(489866,13608,'ba','Tidak faktur pesanan',0),(489867,13608,'nl','Kan niet order factureert',0),(489868,13608,'fi','Voi laskuttaa tilauksen',0),(489869,13608,'no','Kan fakturere for',0),(489870,13608,'da','Kan ikke fakturere ordren',0),(489871,13608,'ko','ì£¼ë¬¸ ì†¡ìž¥ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(489872,13608,'he','×œ× ×—×©×‘×•× ×™×ª ×¡×“×¨',0),(489873,13608,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ Î³Î¹Î±',0),(489874,13608,'zh','ä¸èƒ½å¼€å‘ç¥¨è®¢å•',0),(489875,13608,'sv','Kan inte fakturera fÃ¶r',0),(489876,13608,'it','Non Ã¨ possibile fatturare un ordine',0),(489877,13608,'tl','',0),(489878,13608,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(489879,13608,'hi','à¤•à¥à¤°à¤® à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(489880,13608,'ms','Tidak dapat invois pesanan',0),(489881,13608,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ÙÙˆØªØ±Ø© Ø£Ù…Ø±',0),(489882,13608,'fr','Ne facturez commande',0),(489883,13608,'jp','æ³¨æ–‡ã‚’è«‹æ±‚ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(489884,13608,'pt','NÃ£o posso faturar a ordem',0),(489885,13608,'ru','ÐÐµÐ»ÑŒÐ·Ñ ÑÑ‡ÐµÑ‚Ð° Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°',0),(489886,13608,'es','No se Puede Facturar Pedido',0),(489887,13608,'de','Auftrag-Rechnung kann nicht',0),(489888,13608,'en','Cannot invoice order',0),(489889,13609,'is','',0),(489890,13609,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ ÙˆØ¶Ø¹ÛŒØª ÙØ§Ú©ØªÙˆØ± Ù†Ù…ÛŒ',0),(489891,13609,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ø§ ÙˆØ¶Ø¹ÛŒØª ÙØ§Ú©ØªÙˆØ± Ù†Ù…ÛŒ',0),(489892,13609,'tr','SipariÅŸ durumu faturalayamazsÄ±nÄ±z',0),(489893,13609,'pl','Nie moÅ¼na zafakturowaÄ‡ zamÃ³wienia o statusie',0),(489894,13609,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÑÑŠÑ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(489895,13609,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ Ø­ÛŒØ«ÛŒØª Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(489896,13609,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ Ð½Ð°Ð»Ð¾Ð³ ÑÐ° ÑÑ‚Ð°Ñ‚ÑƒÑÐ¾Ð¼',0),(489897,13609,'vi','KhÃ´ng thá»ƒ hoÃ¡ Ä‘Æ¡n Ä‘áº·t hÃ ng vá»›i tÃ¬nh tráº¡ng',0),(489898,13609,'af','Kan invoice orde met status',0),(489899,13609,'ro','Nu se poate comanda cu statut de factura',0),(489900,13609,'et','Ei saa arveldada tellimuse olek',0),(489901,13609,'si','Ne morete fakturirati nalog s statusom',0),(489902,13609,'ba','Tidak faktur pesanan dengan status',0),(489903,13609,'nl','Order met de status kan niet factureert',0),(489904,13609,'fi','Voi laskuttaa tilauksen tila',0),(489905,13609,'no','Kan fakturere for status',0),(489906,13609,'da','Kan ikke fakturere ordren med status',0),(489907,13609,'ko','ì£¼ë¬¸ ìƒíƒœë¥¼ ì†¡ìž¥ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(489908,13609,'he','×œ× ×—×©×‘×•× ×™×ª ×”×¡×“×¨ ×¢× ×ž×¦×‘',0),(489909,13609,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ Î³Î¹Î± Î¼Îµ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(489910,13609,'zh','ä¸èƒ½å¼€å…·å‘ç¥¨çŠ¶æ€è®¢å•',0),(489911,13609,'sv','Kan inte fakturera order med status',0),(489912,13609,'it','Non Ã¨ possibile fatturare un ordine con status',0),(489913,13609,'tl','',0),(489914,13609,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ à¸¡à¸µà¸ªà¸–à¸²à¸™à¸°',0),(489915,13609,'hi','à¤‘à¤°à¥à¤¡à¤° à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(489916,13609,'ms','Tidak dapat invois pesanan dengan status',0),(489917,13609,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ÙÙˆØªØ±Ø© Ø£Ù…Ø± Ù…Ø¹ Ø§Ù„Ù…Ø±ÙƒØ²',0),(489918,13609,'fr','Ne peut pas facturer la commande dont l\'Ã‰tat',0),(489919,13609,'jp','çŠ¶æ…‹ã§æ³¨æ–‡ã‚’è«‹æ±‚ã§ãã¾ã›ã‚“ã€‚',0),(489920,13609,'pt','NÃ£o pode facturar ordem com status',0),(489921,13609,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ Ð·Ð°ÐºÐ°Ð· ÑÐ¾ ÑÑ‚Ð°Ñ‚ÑƒÑÐ¾Ð¼',0),(489922,13609,'es','No se Puede Facturar Pedido con Estatus',0),(489923,13609,'de','Kann nicht mit Status Rechnung',0),(489924,13609,'en','Cannot invoice order with status',0),(489925,13610,'is','',0),(489926,13610,'dr','ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(489927,13610,'pr','ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(489928,13610,'tr','Teklife geri dÃ¶nÃ¼ÅŸtÃ¼rme',0),(489929,13610,'pl','Konwersja do oferty',0),(489930,13610,'bg','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾ Ð² Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(489931,13610,'ur','ÙˆØ§Ù¾Ø³ Ø§Ù‚ØªØ¨Ø§Ø³ Ù…ÛŒÚº Ø¨Ø¯Ù„ÛŒÚº',0),(489932,13610,'sr','ÐŸÑ€ÐµÑ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ñƒ Ð·Ð°',0),(489933,13610,'vi','Chuyá»ƒn Ä‘á»•i trá»Ÿ láº¡i Ä‘á»ƒ bÃ¡o giÃ¡',0),(489934,13610,'af','Omskep terug na aanhaling',0),(489935,13610,'ro','Conversia Ã®napoi la citat',0),(489936,13610,'et','Teisenda tsitaat',0),(489937,13610,'si','Spremeniti nazaj v ponudbi',0),(489938,13610,'ba','Mengkonversi kembali ke kutipan',0),(489939,13610,'nl','Offerte terug omzetten',0),(489940,13610,'fi','Muuntaa takaisin lainaus',0),(489941,13610,'no','Konvertere tilbake til tilbud',0),(489942,13610,'da','Konvertere tilbage til citat',0),(489943,13610,'ko','ê²¬ì  ë‹¤ì‹œ ë³€í™˜',0),(489944,13610,'he','×œ×”×ž×™×¨ ×—×–×¨×” ×œ×”×¦×¢×ª ×ž×—×™×¨',0),(489945,13610,'el','ÎœÎµÏ„Î±Ï„ÏÎ¿Ï€Î® Ï€Î¯ÏƒÏ‰ ÏƒÏ„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(489946,13610,'zh','å°†è½¬æ¢å›žæŠ¥ä»·',0),(489947,13610,'sv','Konvertera tillbaka till citat',0),(489948,13610,'it','Riconvertire in citazione',0),(489949,13610,'tl','',0),(489950,13610,'th','à¹à¸›à¸¥à¸‡à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹„à¸›',0),(489951,13610,'hi','à¤‰à¤¦à¥à¤§à¥ƒà¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤ªà¤¸ à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(489952,13610,'ms','Menukar kembali kepada sebut harga',0),(489953,13610,'ar','ØªØ­ÙˆÙŠÙ„ Ø¥Ù„Ù‰ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(489954,13610,'fr','Reconvertir en citation',0),(489955,13610,'jp','å¼•ç”¨ã™ã‚‹å¤‰æ›ã—ã¾ã™ã€‚',0),(489956,13610,'pt','Converter de volta para citaÃ§Ã£o',0),(489957,13610,'ru','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾ Ð² Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(489958,13610,'es','Convierte Atras a la CotizaciÃ³n',0),(489959,13610,'de','ZurÃ¼ck zum Zitat zu konvertieren',0),(489960,13610,'en','Convert Back To Quote',0),(489961,13611,'is','',0),(489962,13611,'dr','ÙØ§Ú©ØªÙˆØ± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ù†Ø¸ÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(489963,13611,'pr','ÙØ§Ú©ØªÙˆØ± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ù†Ø¸ÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(489964,13611,'tr','Bu sipariÅŸin faturasÄ± zaten var',0),(489965,13611,'pl','Faktury dla tego zamÃ³wienia juÅ¼ istnieje',0),(489966,13611,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(489967,13611,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(489968,13611,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(489969,13611,'vi','HÃ³a Ä‘Æ¡n cho bá»™ nÃ y Ä‘Ã£ tá»“n táº¡i',0),(489970,13611,'af','Faktuur vir hierdie orde bestaan reeds',0),(489971,13611,'ro','Factura pentru aceastÄƒ comandÄƒ existÄƒ deja',0),(489972,13611,'et','Selle tellimuse arve on juba olemas',0),(489973,13611,'si','RaÄun za naroÄilo Å¾e obstaja',0),(489974,13611,'ba','Faktur untuk pesanan ini sudah ada',0),(489975,13611,'nl','Factuur voor deze order bestaat al',0),(489976,13611,'fi','TÃ¤mÃ¤ lasku on jo olemassa',0),(489977,13611,'no','Fakturaen for denne ordren finnes allerede',0),(489978,13611,'da','Faktura for ordren findes allerede',0),(489979,13611,'ko','ì´ ìˆœì„œì— ëŒ€ í•œ ì²­êµ¬ì„œê°€ ì´ë¯¸',0),(489980,13611,'he','×—×©×‘×•× ×™×ª ×¢×‘×•×¨ ×”×–×ž× ×” ×–×• ×›×‘×¨ ×§×™×™×ž×ª',0),(489981,13611,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î³Î¹Î± Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Ï…Ï„Î® Î®Î´Î· Ï…Ï€Î¬ÏÏ‡ÎµÎ¹',0),(489982,13611,'zh','æ­¤è®¢å•å‘ç¥¨å·²å­˜åœ¨',0),(489983,13611,'sv','Fakturan fÃ¶r den hÃ¤r ordern finns redan',0),(489984,13611,'it','Fattura per questo ordine esiste giÃ ',0),(489985,13611,'tl','',0),(489986,13611,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(489987,13611,'hi','à¤‡à¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(489988,13611,'ms','Invois pesanan telah wujud',0),(489989,13611,'ar','ÙØ§ØªÙˆØ±Ø© Ù„Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„',0),(489990,13611,'fr','Facture pour cette commande existe dÃ©jÃ ',0),(489991,13611,'jp','ã“ã®æ³¨æ–‡ã®è«‹æ±‚æ›¸ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™',0),(489992,13611,'pt','Fatura para esta ordem jÃ¡ existe',0),(489993,13611,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(489994,13611,'es','Factura De Este Orden Ya Existe',0),(489995,13611,'de','Rechnung fÃ¼r diese Bestellung ist bereits vorhanden.',0),(489996,13611,'en','Invoice for this order already exists',0),(489997,13612,'is','',0),(489998,13612,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ø± Ø±ÙˆÛŒ Ø¯Ø§Ø´Ø¨ÙˆØ±Ø¯',0),(489999,13612,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ø± Ø±ÙˆÛŒ Ø¯Ø§Ø´Ø¨ÙˆØ±Ø¯',0),(490000,13612,'tr','GÃ¶sterge gÃ¶ster',0),(490001,13612,'pl','PokaÅ¼ na desce rozdzielczej',0),(490002,13612,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¾Ñ‚Ð¾',0),(490003,13612,'ur','ÚˆÛŒØ´ Ø¨ÙˆØ±Úˆ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(490004,13612,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð° ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ð¾Ñ˜ Ñ‚Ð°Ð±Ð»Ð¸',0),(490005,13612,'vi','Hiá»ƒn thá»‹ trÃªn trang tá»•ng quan',0),(490006,13612,'af','Wys op die paneelbord',0),(490007,13612,'ro','AratÄƒ pe tabloul de bord',0),(490008,13612,'et','Kuva armatuurlaud',0),(490009,13612,'si','PrikaÅ¾i na armaturni ploÅ¡Äi',0),(490010,13612,'ba','Tampilkan di dashboard',0),(490011,13612,'nl','Toon op dashboard',0),(490012,13612,'fi','NÃ¤ytÃ¤ Dashboard',0),(490013,13612,'no','Vis pÃ¥ dashbordet',0),(490014,13612,'da','Vis pÃ¥ dashboard',0),(490015,13612,'ko','ê³„ê¸°íŒì— í‘œì‹œ',0),(490016,13612,'he','×”×¦×’ ×¢×œ ×œ×•×— ×”×ž×—×•×•× ×™×',0),(490017,13612,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÏ„Î¿ Ï„Î±Î¼Ï€Î»ÏŒ',0),(490018,13612,'zh','åœ¨ä»ªè¡¨æ¿ä¸Šæ˜¾ç¤º',0),(490019,13612,'sv','Visa pÃ¥ instrumentpanelen',0),(490020,13612,'it','Visualizza sul cruscotto',0),(490021,13612,'tl','',0),(490022,13612,'th','à¹à¸ªà¸”à¸‡à¸šà¸™à¹à¸”à¸Šà¸šà¸­à¸£à¹Œà¸”',0),(490023,13612,'hi','à¤¡à¥ˆà¤¶à¤¬à¥‹à¤°à¥à¤¡ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(490024,13612,'ms','Tunjukkan pada dashboard',0),(490025,13612,'ar','ÙˆØªØ¸Ù‡Ø± ÙÙŠ Ù„ÙˆØ­Ø© Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(490026,13612,'fr','Afficher sur le tableau de bord',0),(490027,13612,'jp','ãƒ€ãƒƒã‚·ãƒ¥ ãƒœãƒ¼ãƒ‰ã«è¡¨ç¤ºã—ã¾ã™ã€‚',0),(490028,13612,'pt','Mostrar no painel de controle',0),(490029,13612,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½Ð° Ð¿Ñ€Ð¸Ð±Ð¾Ñ€Ð½Ð¾Ð¹ Ð¿Ð°Ð½ÐµÐ»Ð¸',0),(490030,13612,'es','Muestra en el Dashboard',0),(490031,13612,'de','Auf Dashboard anzeigen',0),(490032,13612,'en','Show on dashboard',0),(490033,13613,'is','',0),(490034,13613,'dr','Ù…Ø±Ú©Ø² Ø§Ø³Ù†Ø§Ø¯',0),(490035,13613,'pr','Ù…Ø±Ú©Ø² Ø§Ø³Ù†Ø§Ø¯',0),(490036,13613,'tr','Belge Merkezi',0),(490037,13613,'pl','Centrum dokumentÃ³w',0),(490038,13613,'bg','Ð¦ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(490039,13613,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Û’ Ù…Ø±Ú©Ø²',0),(490040,13613,'sr','Ð¦ÐµÐ½Ñ‚Ð°Ñ€ Ð·Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ðµ',0),(490041,13613,'vi','Trung tÃ¢m tÃ i liá»‡u',0),(490042,13613,'af','Dokument Sentrum',0),(490043,13613,'ro','Centrul de document',0),(490044,13613,'et','Dokumendi Center',0),(490045,13613,'si','Dokumentno srediÅ¡Äe',0),(490046,13613,'ba','Pusat dokumen',0),(490047,13613,'nl','Document Center',0),(490048,13613,'fi','Document Center',0),(490049,13613,'no','Dokumentsentral',0),(490050,13613,'da','Dokumentcenter',0),(490051,13613,'ko','ë¬¸ì„œ ì„¼í„°',0),(490052,13613,'he','×ž×¨×›×– ×”×ž×¡×ž×›×™×',0),(490053,13613,'el','ÎšÎ­Î½Ï„ÏÎ¿ ÎµÎ³Î³ÏÎ¬Ï†Ï‰Î½ Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(490054,13613,'zh','æ–‡æ¡£ä¸­å¿ƒ',0),(490055,13613,'sv','Dokumentcenter',0),(490056,13613,'it','Centro documenti',0),(490057,13613,'tl','',0),(490058,13613,'th','à¸¨à¸¹à¸™à¸¢à¹Œà¹€à¸­à¸à¸ªà¸²à¸£',0),(490059,13613,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(490060,13613,'ms','Pusat dokumen',0),(490061,13613,'ar','Ù…Ø±ÙƒØ² Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª',0),(490062,13613,'fr','Document Centre',0),(490063,13613,'jp','ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼',0),(490064,13613,'pt','Central de documentos',0),(490065,13613,'ru','Ð¦ÐµÐ½Ñ‚Ñ€ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(490066,13613,'es','Centro de Documentos',0),(490067,13613,'de','Document Center',0),(490068,13613,'en','Document Center',0),(490069,13614,'is','',0),(490070,13614,'dr','Ø§Ø³Ù†Ø§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ Ù†Ø´Ø¯Ù‡',0),(490071,13614,'pr','Ø§Ø³Ù†Ø§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ Ù†Ø´Ø¯Ù‡',0),(490072,13614,'tr','Varolan atanmamÄ±ÅŸ belgeleri',0),(490073,13614,'pl','IstniejÄ…cym nieprzypisane dokumentÃ³w',0),(490074,13614,'bg','Ð¡ÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ Ð½ÐµÐºÐ»Ð°ÑÐ¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(490075,13614,'ur','Ù…ÙˆØ¬ÙˆØ¯Û ØºÛŒØ± ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(490076,13614,'sr','ÐÐµÐ´Ð¾Ð´ÐµÑ™ÐµÐ½Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ðµ',0),(490077,13614,'vi','TÃ i liá»‡u vÃ o chÆ°a cáº¥p phÃ¡t hiá»‡n cÃ³',0),(490078,13614,'af','Bestaande Unassigned dokumente',0),(490079,13614,'ro','Documente existente neasociatÄƒ',0),(490080,13614,'et','Olemasolevate mÃ¤Ã¤ramata dokumendid',0),(490081,13614,'si','ObstojeÄe Slobodna dokumentov',0),(490082,13614,'ba','Ada Unassigned dokumen',0),(490083,13614,'nl','Bestaande niet-toegewezen documenten',0),(490084,13614,'fi','MÃ¤Ã¤rittÃ¤mÃ¤ttÃ¶mÃ¤t asiakirjoihin',0),(490085,13614,'no','Ikke tilordnede dokumenter',0),(490086,13614,'da','Eksisterende ikke-tildelt dokumenter',0),(490087,13614,'ko','ê¸°ì¡´ì˜ í• ë‹¹ ë˜ì§€ ì•Šì€ ë¬¸ì„œ',0),(490088,13614,'he','×ž×¡×ž×›×™× ×©×œ× ×”×•×§×¦×• ×§×™×™×ž×™×',0),(490089,13614,'el','Î¥Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± ÎœÎ· ÎµÎºÏ‡Ï‰ÏÎ·Î¼Î­Î½Î± Î­Î³Î³ÏÎ±Ï†Î±',0),(490090,13614,'zh','æœªåˆ†é…çš„çŽ°æœ‰æ–‡æ¡£',0),(490091,13614,'sv','Befintliga otilldelade dokument',0),(490092,13614,'it','Documenti esistenti non assegnati',0),(490093,13614,'tl','',0),(490094,13614,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¹„à¸¡à¹ˆ',0),(490095,13614,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤…à¤¨à¤…à¤¸à¤¾à¤‡à¤¨à¥à¤¡ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚',0),(490096,13614,'ms','Dokumen-dokumen multisiar yang sedia ada',0),(490097,13614,'ar','Ø§Ù„ÙˆØ«Ø§Ø¦Ù‚ ØºÙŠØ± Ø§Ù„Ù…Ø¹ÙŠÙ†Ø© Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(490098,13614,'fr','Documents existants non assignÃ©s',0),(490099,13614,'jp','å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ãªã„æ—¢å­˜ã®ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ',0),(490100,13614,'pt','Documentos existentes nÃ£o atribuÃ­dos',0),(490101,13614,'ru','Ð˜Ð¼ÐµÑŽÑ‰Ð¸ÐµÑÑ ÐÐµÑ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ñ‹Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(490102,13614,'es','Documentos No Asignados Existentes',0),(490103,13614,'de','Vorhandene nicht zugewiesenen Dokumente',0),(490104,13614,'en','Existing Unassigned Documents',0),(490105,13615,'is','',0),(490106,13615,'dr','Ø§Ø±Ø³Ø§Ù„ Ø§Ø³Ù†Ø§Ø¯ Ø¬Ø¯ÛŒØ¯',0),(490107,13615,'pr','Ø§Ø±Ø³Ø§Ù„ Ø§Ø³Ù†Ø§Ø¯ Ø¬Ø¯ÛŒØ¯',0),(490108,13615,'tr','Yeni belgeyi karÅŸÄ±ya yÃ¼kle',0),(490109,13615,'pl','PrzesyÅ‚anie nowych dokumentÃ³w',0),(490110,13615,'bg','ÐšÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(490111,13615,'ur','Ù†Ø¦ÛŒ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(490112,13615,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð¸ Ð½Ð¾Ð²Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ðµ',0),(490113,13615,'vi','Táº£i lÃªn cÃ¡c tÃ i liá»‡u má»›i',0),(490114,13615,'af','Nuwe dokumente oplaai',0),(490115,13615,'ro','ÃŽncÄƒrcaÅ£i documente noi',0),(490116,13615,'et','Ãœles laadida uusi dokumente',0),(490117,13615,'si','Upload nove dokumente',0),(490118,13615,'ba','Meng-upload dokumen baru',0),(490119,13615,'nl','Nieuwe documenten uploaden',0),(490120,13615,'fi','Ladata uusia asiakirjoja',0),(490121,13615,'no','Laste opp nye dokumenter',0),(490122,13615,'da','Uploade nye dokumenter',0),(490123,13615,'ko','ìƒˆ ë¬¸ì„œë¥¼ ì—…ë¡œë“œ',0),(490124,13615,'he','×œ×”×¢×œ×•×ª ×ž×¡×ž×›×™× ×—×“×©×™×',0),(490125,13615,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Î½Î­Ï‰Î½ ÎµÎ³Î³ÏÎ¬Ï†Ï‰Î½',0),(490126,13615,'zh','å°†æ–°æ–‡æ¡£ä¸Šè½½',0),(490127,13615,'sv','Ã–verfÃ¶ra nya dokument',0),(490128,13615,'it','Caricare nuovi documenti',0),(490129,13615,'tl','',0),(490130,13615,'th','à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¹€à¸­à¸à¸ªà¸²à¸£à¹ƒà¸«à¸¡à¹ˆ',0),(490131,13615,'hi','à¤¨à¤ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼à¥‹à¤‚ à¤•à¥‹ à¤…à¤ªà¤²à¥‹à¤¡',0),(490132,13615,'ms','Muat naik dokumen-dokumen baru',0),(490133,13615,'ar','ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(490134,13615,'fr','TÃ©lÃ©charger les nouveaux Documents',0),(490135,13615,'jp','æ–°ã—ã„ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã‚’ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(490136,13615,'pt','Fazer upload de novos documentos',0),(490137,13615,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(490138,13615,'es','Subir Nuevos Documentos',0),(490139,13615,'de','Neue Dokumente hochladen',0),(490140,13615,'en','Upload New Documents',0),(490141,13616,'is','',0),(490142,13616,'dr','Ú©Ø´ØªÛŒ ØªØ§Ø±ÛŒØ® Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(490143,13616,'pr','Ú©Ø´ØªÛŒ ØªØ§Ø±ÛŒØ® Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(490144,13616,'tr','Talep edilen sevk tarihi',0),(490145,13616,'pl','ZgÅ‚oszony Data wysyÅ‚ki',0),(490146,13616,'bg','Ð˜ÑÐºÐ°Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(490147,13616,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ',0),(490148,13616,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ðµ',0),(490149,13616,'vi','YÃªu cáº§u tÃ u ngÃ y',0),(490150,13616,'af','Versoek skip datum',0),(490151,13616,'ro','Solicitat data navei',0),(490152,13616,'et','Plaanitud lÃ¤hetuskuupÃ¤ev',0),(490153,13616,'si','Zahtevani datum ladje',0),(490154,13616,'ba','Diminta kapal tanggal',0),(490155,13616,'nl','Gewenste datum van schip',0),(490156,13616,'fi','Pyydetty lÃ¤hetyspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(490157,13616,'no','Ã˜nsket forsendelsesdato',0),(490158,13616,'da','Anmodet afsendelsesdato',0),(490159,13616,'ko','ë°°ì†¡ ë‚ ì§œ ìš”ì²­',0),(490160,13616,'he','×‘×™×§×© ×ª××¨×™×š ×ž×©×œ×•×—',0),(490161,13616,'el','Î–Î®Ï„Î·ÏƒÎµ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(490162,13616,'zh','ä¸ºè¦æ±‚è£…è¿æ—¥æœŸ',0),(490163,13616,'sv','BegÃ¤rt transportdatum',0),(490164,13616,'it','Richiesto la data di spedizione',0),(490165,13616,'tl','',0),(490166,13616,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸—à¸µà¹ˆà¸£à¹‰à¸­à¸‡à¸‚à¸­',0),(490167,13616,'hi','à¤¶à¤¿à¤ª à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤…à¤¨à¥à¤°à¥‹à¤§',0),(490168,13616,'ms','Diminta tarikh kapal',0),(490169,13616,'ar','Ø·Ù„Ø¨ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(490170,13616,'fr','DemandÃ© la Date d\'expÃ©dition',0),(490171,13616,'jp','è¦æ±‚ã•ã‚ŒãŸå‡ºè·æ—¥',0),(490172,13616,'pt','Navio data solicitada',0),(490173,13616,'ru','ÐŸÑ€Ð¾ÑÐ¸Ð»Ð° Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(490174,13616,'es','Pedir Fecha de EnvÃ­o',0),(490175,13616,'de','Lieferdatum angefordert',0),(490176,13616,'en','Requested Ship Date',0),(490177,13617,'is','',0),(490178,13617,'dr','Ø§ÛŒØ¬Ø§Ø¯',0),(490179,13617,'pr','Ø§ÛŒØ¬Ø§Ø¯',0),(490180,13617,'tr','OluÅŸturmak',0),(490181,13617,'pl','Tworzenie',0),(490182,13617,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð°',0),(490183,13617,'ur','Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(490184,13617,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ',0),(490185,13617,'vi','Táº¡o',0),(490186,13617,'af','Skep',0),(490187,13617,'ro','Crea',0),(490188,13617,'et','Loo',0),(490189,13617,'si','Ustvarjanje',0),(490190,13617,'ba','Membuat',0),(490191,13617,'nl','Maken',0),(490192,13617,'fi','Luo',0),(490193,13617,'no','Opprette',0),(490194,13617,'da','Oprette',0),(490195,13617,'ko','ë§Œë“¤ê¸°',0),(490196,13617,'he','×¦×•×¨',0),(490197,13617,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±',0),(490198,13617,'zh','åˆ›å»º',0),(490199,13617,'sv','Skapa',0),(490200,13617,'it','Creare',0),(490201,13617,'tl','',0),(490202,13617,'th','à¸ªà¸£à¹‰à¸²à¸‡',0),(490203,13617,'hi','à¤¬à¤¨à¤¾à¤à¤',0),(490204,13617,'ms','Mencipta',0),(490205,13617,'ar','Ø¥Ù†Ø´Ø§Ø¡',0),(490206,13617,'fr','CrÃ©er',0),(490207,13617,'jp','ä½œæˆã—ã¾ã™ã€‚',0),(490208,13617,'pt','Criar',0),(490209,13617,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ',0),(490210,13617,'es','Crear',0),(490211,13617,'de','Erstellen',0),(490212,13617,'en','Create',0),(490213,13618,'is','',0),(490214,13618,'dr','30 Ø±ÙˆØ²<b>Ø¢Ø²Ø§Ø¯</b> Ø³Ù¾Ø³',0),(490215,13618,'pr','30 Ø±ÙˆØ²<b>Ø¢Ø²Ø§Ø¯</b> Ø³Ù¾Ø³',0),(490216,13618,'tr','30 gÃ¼n<b>Ã¼cretsiz</b> sonra',0),(490217,13618,'pl','30 dni<b>wolne</b> , a nastÄ™pnie',0),(490218,13618,'bg','30 Ð´Ð½Ð¸<b>Ð±ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð¾</b> ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð°',0),(490219,13618,'ur','30 Ø¯Ù†<b>Ø¢Ø²Ø§Ø¯</b> Ù¾Ú¾Ø±',0),(490220,13618,'sr','30 Ð´Ð°Ð½Ð°<b>ÑÐ»Ð¾Ð±Ð¾Ð´Ð½Ð¾Ð³</b> Ð¾Ð½Ð´Ð°',0),(490221,13618,'vi','30 ngÃ y<b>miá»…n phÃ­</b> sau Ä‘Ã³',0),(490222,13618,'af','30 dae<b>Gratis</b> dan',0),(490223,13618,'ro','30 de zile<b>gratuit</b> apoi',0),(490224,13618,'et','30 pÃ¤eva<b>tasuta</b> siis',0),(490225,13618,'si','<b>30 dni potem</b>',0),(490226,13618,'ba','30 hari<b>gratis</b> kemudian',0),(490227,13618,'nl','30 dagen<b>vrije</b> vervolgens',0),(490228,13618,'fi','30 pÃ¤ivÃ¤Ã¤<b>ilmaiseksi</b> sitten',0),(490229,13618,'no','30 dager<b>gratis</b>',0),(490230,13618,'da','30 dage<b>gratis</b> derefter',0),(490231,13618,'ko','ë‹¤ìŒ 30 ì¼<b>ë¬´ë£Œ</b>',0),(490232,13618,'he','30 ×™×•×<b>×—×™× ×</b> ××–',0),(490233,13618,'el','30 Î·Î¼Î­ÏÎµÏ‚<b>Î´Ï‰ÏÎµÎ¬Î½</b> ÏƒÏ„Î· ÏƒÏ…Î½Î­Ï‡ÎµÎ¹Î±',0),(490234,13618,'zh','30å¤©<B>å…è´¹</B> ç„¶åŽ',0),(490235,13618,'sv','30 dagar<b>gratis</b> sedan',0),(490236,13618,'it','30 giorni<b>liberi</b> , quindi',0),(490237,13618,'tl','',0),(490238,13618,'th','30 à¸§à¸±à¸™<b>à¸Ÿà¸£à¸µ</b>à¹à¸¥à¹‰à¸§',0),(490239,13618,'hi','30 à¤¦à¤¿à¤¨à¥‹à¤‚<b>à¤®à¥à¤•à¥à¤¤</b> à¤¤à¤¬',0),(490240,13618,'ms','30 hari<b>percuma</b> kemudian',0),(490241,13618,'ar','30 Ø£ÙŠØ§Ù…<b>Ø­Ø±Ø©</b> Ø«Ù…',0),(490242,13618,'fr','30 jours<b>gratuit</b> puis',0),(490243,13618,'jp','30 æ—¥é–“<b>ç„¡æ–™</b>ã—',0),(490244,13618,'pt','30 dias<b>grÃ¡tis</b>',0),(490245,13618,'ru','Ð·Ð°Ñ‚ÐµÐ¼ 30 Ð´Ð½ÐµÐ¹<b>Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾</b>',0),(490246,13618,'es','30 dÃ­as  <b> gratis </b> a continuaciÃ³n,',0),(490247,13618,'de','30 Tage<b>Gratis</b> dann',0),(490248,13618,'en','30 days<b>Free</b> then',0),(490249,13619,'is','',0),(490250,13619,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(490251,13619,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(490252,13619,'tr','Otomatik GÃ¼ncelleÅŸtirmeler',0),(490253,13619,'pl','Automatyczne aktualizacje',0),(490254,13619,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(490255,13619,'ur','Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒØ§Úº',0),(490256,13619,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(490257,13619,'vi','Cáº­p nháº­t tá»± Ä‘á»™ng',0),(490258,13619,'af','Outomatiese Opdaterings',0),(490259,13619,'ro','ActualizÄƒri automate',0),(490260,13619,'et','Automaatsed uuendused',0),(490261,13619,'si','Samodejne posodobitve',0),(490262,13619,'ba','Pembaruan otomatis',0),(490263,13619,'nl','Automatische Updates',0),(490264,13619,'fi','Automaattiset pÃ¤ivitykset',0),(490265,13619,'no','Automatiske oppdateringer',0),(490266,13619,'da','Automatiske opdateringer',0),(490267,13619,'ko','ìžë™ ì—…ë°ì´íŠ¸',0),(490268,13619,'he','×¢×“×›×•× ×™× ××•×˜×•×ž×˜×™×™×',0),(490269,13619,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„ÎµÏ‚ ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹Ï‚',0),(490270,13619,'zh','è‡ªåŠ¨æ›´æ–°',0),(490271,13619,'sv','Automatiska uppdateringar',0),(490272,13619,'it','Aggiornamenti automatici',0),(490273,13619,'tl','',0),(490274,13619,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(490275,13619,'hi','à¤¸à¥à¤µà¤¤: à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(490276,13619,'ms','Pengemaskinian automatik',0),(490277,13619,'ar','Ø§Ù„ØªØ­Ø¯ÙŠØ«Ø§Øª Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠØ©',0),(490278,13619,'fr','Mises Ã  jour automatiques',0),(490279,13619,'jp','è‡ªå‹•æ›´æ–°',0),(490280,13619,'pt','AtualizaÃ§Ãµes automÃ¡ticas',0),(490281,13619,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(490282,13619,'es','actualizaciones automÃ¡ticas',0),(490283,13619,'de','Automatische Updates',0),(490284,13619,'en','Automatic Updates',0),(490285,13620,'is','',0),(490286,13620,'dr','Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª (Ø¹Ù„ÛŒØ±Ø¶Ø§)',0),(490287,13620,'pr','Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª (Ø¹Ù„ÛŒØ±Ø¶Ø§)',0),(490288,13620,'tr','Fatura (AR)',0),(490289,13620,'pl','PÅ‚atnoÅ›ci (AR)',0),(490290,13620,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ (AR)',0),(490291,13620,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ (Ø§Ù„Ø±Ø­ÛŒÙ‚)',0),(490292,13620,'sr','ÐÐ°Ð¿Ð»Ð°Ñ‚Ðµ (ÐÐ )',0),(490293,13620,'vi','Thanh toÃ¡n (AR)',0),(490294,13620,'af','Fakturering (AR)',0),(490295,13620,'ro','Facturare (AR)',0),(490296,13620,'et','Arved (AR)',0),(490297,13620,'si','ZaraÄunavanje (AR)',0),(490298,13620,'ba','Penagihan (AR)',0),(490299,13620,'nl','Facturering (AR)',0),(490300,13620,'fi','Laskutus (AR)',0),(490301,13620,'no','Fakturering (AR)',0),(490302,13620,'da','Fakturering (AR)',0),(490303,13620,'ko','ê²°ì œ (ì•„ì¹¸ì†Œ ì£¼)',0),(490304,13620,'he','×—×™×•×‘ (AR)',0),(490305,13620,'el','Î§ÏÎ­Ï‰ÏƒÎ·Ï‚ (AR)',0),(490306,13620,'zh','è®¡è´¹ï¼ˆARï¼‰',0),(490307,13620,'sv','Fakturering (AR)',0),(490308,13620,'it','Fatturazione (AR)',0),(490309,13620,'tl','',0),(490310,13620,'th','à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™ (AR)',0),(490311,13620,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— (AR)',0),(490312,13620,'ms','Bil (AR)',0),(490313,13620,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± (AR)',0),(490314,13620,'fr','Facturation (AR)',0),(490315,13620,'jp','è«‹æ±‚ ï¼ˆARï¼‰',0),(490316,13620,'pt','Faturamento (AR)',0),(490317,13620,'ru','Ð‘Ð¸Ð»Ð»Ð¸Ð½Ð³ (AR)',0),(490318,13620,'es','FacturaciÃ³n (AR)',0),(490319,13620,'de','Abrechnung (AR)',0),(490320,13620,'en','Billing (AR)',0),(490321,13621,'is','',0),(490322,13621,'dr','Ø´Ø±Ú©Øª Ú©ØªØ§Ø¨ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø¬Ø§Ø²',0),(490323,13621,'pr','Ø´Ø±Ú©Øª Ú©ØªØ§Ø¨ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø¬Ø§Ø²',0),(490324,13621,'tr','Ä°zin verilen ÅŸirket kitap setleri',0),(490325,13621,'pl','Firma ksiÄ…Å¼ki zestawy dozwolone',0),(490326,13621,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° ÐºÐ½Ð¸Ð³Ð° ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¸ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(490327,13621,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ú©ØªØ§Ø¨ Ø³ÛŒÙ¹ÙˆÚº Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(490328,13621,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° ÐºÑšÐ¸Ð³Ñƒ ÑÐºÑƒÐ¿Ð¾Ð²Ð° Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(490329,13621,'vi','CÃ´ng ty sÃ¡ch bá»™ cho phÃ©p',0),(490330,13621,'af','Maatskappy boek stelle toegelaat',0),(490331,13621,'ro','Seturi de carte companie permise',0),(490332,13621,'et','EttevÃµtte raamat komplekti lubatud',0),(490333,13621,'si','Podjetje knjigo doloÄa dovoljene',0),(490334,13621,'ba','Set buku perusahaan diperbolehkan',0),(490335,13621,'nl','Bedrijf boek Sets toegestaan',0),(490336,13621,'fi','Yritys varaa asetetaan Internet',0),(490337,13621,'no','Selskapet bok sett tillatt',0),(490338,13621,'da','Virksomheden bog sÃ¦t tilladt',0),(490339,13621,'ko','íšŒì‚¬ë„ ì„œ ì„¸íŠ¸ í—ˆìš©',0),(490340,13621,'he','×”×—×‘×¨×” ×•×¡×˜×™× ×ž×•×ª×¨',0),(490341,13621,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± Î²Î¹Î²Î»Î¯Î¿ ÏƒÏÎ½Î¿Î»Î± ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(490342,13621,'zh','å…¬å¸è¯»ç‰©å¥—è£…å® ç‰©',0),(490343,13621,'sv','FÃ¶retaget bok uppsÃ¤ttningar tillÃ¥tet',0),(490344,13621,'it','Azienda libro set consentito',0),(490345,13621,'tl','',0),(490346,13621,'th','à¸Šà¸¸à¸”à¸šà¸±à¸à¸Šà¸µà¸šà¸£à¸´à¸©à¸±à¸—à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(490347,13621,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤ªà¥à¤¸à¥à¤¤à¤¿à¤•à¤¾ à¤¸à¥‡à¤Ÿ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(490348,13621,'ms','Set buku Syarikat yang dibenarkan',0),(490349,13621,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø¯ÙØªØ± Ø§Ù„Ø´Ø±ÙƒØ© ÙŠØ³Ù…Ø­',0),(490350,13621,'fr','Ensembles de livre de compagnie autorisÃ©s',0),(490351,13621,'jp','è¨±å¯ã•ã‚Œã‚‹ä¼šç¤¾ã®æœ¬ã‚»ãƒƒãƒˆ',0),(490352,13621,'pt','Empresa livro conjuntos permitidos',0),(490353,13621,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ñ‹ ÐºÐ½Ð¸Ð³ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(490354,13621,'es','Book Company Establece animales',0),(490355,13621,'de','Firma Buch Sets erlaubt',0),(490356,13621,'en','Company Book Sets Allowed',0),(490357,13622,'is','',0),(490358,13622,'dr','Ù…Ù‚Ø§ÛŒØ³Ù‡ Ù†Ø³Ø®Ù‡ Ù‡Ø§ÛŒ',0),(490359,13622,'pr','Ù…Ù‚Ø§ÛŒØ³Ù‡ Ù†Ø³Ø®Ù‡ Ù‡Ø§ÛŒ',0),(490360,13622,'tr','SÃ¼rÃ¼mleri KarÅŸÄ±laÅŸtÄ±r',0),(490361,13622,'pl','PorÃ³wnaj wersje',0),(490362,13622,'bg','Ð¡Ñ€Ð°Ð²Ð½ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð²ÐµÑ€ÑÐ¸Ð¸',0),(490363,13622,'ur','ÙˆØ±Ú˜Ù†ÙˆÚº Ú©Ø§ Ù…ÙˆØ§Ø²Ù†Û Ú©Ø±ÛŒÚº',0),(490364,13622,'sr','Ð£Ð¿Ð¾Ñ€ÐµÐ´Ð¸ Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ',0),(490365,13622,'vi','HÃ£y so sÃ¡nh cÃ¡c phiÃªn báº£n',0),(490366,13622,'af','Vergelyk Weergawes',0),(490367,13622,'ro','Comparare versiuni',0),(490368,13622,'et','VÃµrdle versioone',0),(490369,13622,'si','Primerja razliÄice',0),(490370,13622,'ba','Membandingkan versi',0),(490371,13622,'nl','Versies vergelijken',0),(490372,13622,'fi','Vertaa versioita',0),(490373,13622,'no','Sammenlign versjoner',0),(490374,13622,'da','Sammenlign versioner',0),(490375,13622,'ko','ë²„ì „ ë¹„êµ',0),(490376,13622,'he','×œ×”×©×•×•×ª ×’×™×¨×¡××•×ª',0),(490377,13622,'el','Î£ÏÎ³ÎºÏÎ¹ÏƒÎ· ÎµÎºÎ´ÏŒÏƒÎµÏ‰Î½',0),(490378,13622,'zh','æ¯”è¾ƒç‰ˆæœ¬',0),(490379,13622,'sv','JÃ¤mfÃ¶ra versioner',0),(490380,13622,'it','Confrontare le versioni',0),(490381,13622,'tl','',0),(490382,13622,'th','à¹€à¸›à¸£à¸µà¸¢à¸šà¹€à¸—à¸µà¸¢à¸šà¸£à¸¸à¹ˆà¸™',0),(490383,13622,'hi','à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£à¥‹à¤‚ à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾ à¤•à¤°à¥‡à¤‚',0),(490384,13622,'ms','Bandingkan versi',0),(490385,13622,'ar','Ù…Ù‚Ø§Ø±Ù†Ø© Ø§Ù„Ø¥ØµØ¯Ø§Ø±Ø§Øª',0),(490386,13622,'fr','Comparer les Versions',0),(490387,13622,'jp','ãƒãƒ¼ã‚¸ãƒ§ãƒ³ã‚’æ¯”è¼ƒã—ã¾ã™ã€‚',0),(490388,13622,'pt','Compare as versÃµes',0),(490389,13622,'ru','Ð¡Ñ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ Ð²ÐµÑ€ÑÐ¸Ð¹',0),(490390,13622,'es','Comparar versiones',0),(490391,13622,'de','Versionsvergleich',0),(490392,13622,'en','Compare Versions',0),(490393,13623,'is','',0),(490394,13623,'dr','Ù¾Ø§ÛŒÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§',0),(490395,13623,'pr','Ù¾Ø§ÛŒÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§',0),(490396,13623,'tr','KiÅŸi veritabanÄ±',0),(490397,13623,'pl','Bazy danych kontaktÃ³w',0),(490398,13623,'bg','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸ Ñ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(490399,13623,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ Ø³Û’ Ø±Ø§Ø¨Ø·Û',0),(490400,13623,'sr','Ð‘Ð°Ð·Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÐºÐ¾Ð½Ñ‚Ð°ÐºÐ°Ñ‚Ð°',0),(490401,13623,'vi','LiÃªn há»‡ vá»›i cÆ¡ sá»Ÿ dá»¯ liá»‡u',0),(490402,13623,'af','Kontakte Databasis',0),(490403,13623,'ro','Date de contact',0),(490404,13623,'et','Kontaktide andmebaas',0),(490405,13623,'si','Podatkovna zbirka stikov',0),(490406,13623,'ba','Database kontak',0),(490407,13623,'nl','Database met contactpersonen',0),(490408,13623,'fi','Yhteystiedot-tietokanta',0),(490409,13623,'no','Kontaktdatabasen',0),(490410,13623,'da','Kontaktdatabase',0),(490411,13623,'ko','ì—°ë½ì²˜ ë°ì´í„°ë² ì´ìŠ¤',0),(490412,13623,'he','×ž×¡×“ × ×ª×•× ×™× ×©×œ ×× ×©×™ ×§×©×¨',0),(490413,13623,'el','Î’Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ ÎµÏ€Î±Ï†ÏŽÎ½',0),(490414,13623,'zh','è”ç³»äººæ•°æ®åº“',0),(490415,13623,'sv','Databasen kontakter',0),(490416,13623,'it','Database di contatti',0),(490417,13623,'tl','',0),(490418,13623,'th','à¸•à¸´à¸”à¸•à¹ˆà¸­à¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(490419,13623,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤•à¥‹à¤‚ à¤•à¥‡ à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸',0),(490420,13623,'ms','Pangkalan data kenalan',0),(490421,13623,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø¬Ù‡Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„',0),(490422,13623,'fr','Base de donnÃ©es de contacts',0),(490423,13623,'jp','é€£çµ¡å…ˆç®¡ç†ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹',0),(490424,13623,'pt','Banco de dados de contatos',0),(490425,13623,'ru','Ð‘Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ… ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¾Ð²',0),(490426,13623,'es','Contactos de base de datos',0),(490427,13623,'de','Kontaktdatenbank',0),(490428,13623,'en','Contacts Database',0),(490429,13624,'is','',0),(490430,13624,'dr','Ù…Ø´ØªØ±ÛŒØ§Ù† Ù…Ø¬Ø§Ø²',0),(490431,13624,'pr','Ù…Ø´ØªØ±ÛŒØ§Ù† Ù…Ø¬Ø§Ø²',0),(490432,13624,'tr','MÃ¼ÅŸteriler izin',0),(490433,13624,'pl','Klienci mogÄ…',0),(490434,13624,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(490435,13624,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(490436,13624,'sr','ÐšÑƒÐ¿Ñ†Ð¸ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(490437,13624,'vi','KhÃ¡ch Ä‘Æ°á»£c phÃ©p',0),(490438,13624,'af','KliÃ«nte toegelaat',0),(490439,13624,'ro','ClienÅ£ii permis',0),(490440,13624,'et','Hotelli lubatud',0),(490441,13624,'si','Uporabniki, ki so dovoljene',0),(490442,13624,'ba','Pelanggan yang diperbolehkan',0),(490443,13624,'nl','Klanten toegestaan',0),(490444,13624,'fi','Asiakkaat saa',0),(490445,13624,'no','Kundene er tillatt',0),(490446,13624,'da','Kunder tilladt',0),(490447,13624,'ko','í—ˆìš© í•˜ëŠ” ê³ ê°',0),(490448,13624,'he','×”×œ×§×•×—×•×ª ×ž×•×ª×¨',0),(490449,13624,'el','Î¤Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(490450,13624,'zh','å®¢æˆ·å® ç‰©',0),(490451,13624,'sv','Kunder fÃ¥r',0),(490452,13624,'it','Clienti autorizzati',0),(490453,13624,'tl','',0),(490454,13624,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(490455,13624,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(490456,13624,'ms','Pelanggan yang dibenarkan',0),(490457,13624,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(490458,13624,'fr','Clients autorisÃ©s',0),(490459,13624,'jp','ãŠå®¢æ§˜ã®è¨±å¯',0),(490460,13624,'pt','Clientes podem',0),(490461,13624,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ð¾Ð·Ð²Ð¾Ð»Ð¸Ð»',0),(490462,13624,'es','Numero de Clientes',0),(490463,13624,'de','Kunden erlaubt',0),(490464,13624,'en','Customers Allowed',0),(490465,13625,'is','',0),(490466,13625,'dr','Ú©Ø§Ø±Ú©Ù†Ø§Ù† Ù…Ø¬Ø§Ø²',0),(490467,13625,'pr','Ú©Ø§Ø±Ú©Ù†Ø§Ù† Ù…Ø¬Ø§Ø²',0),(490468,13625,'tr','Ä°zin verilen Ã§alÄ±ÅŸanlarÄ±',0),(490469,13625,'pl','Pracownicy mogÄ…',0),(490470,13625,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(490471,13625,'ur','Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(490472,13625,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ð¼Ð° Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(490473,13625,'vi','NhÃ¢n viÃªn Ä‘Æ°á»£c phÃ©p',0),(490474,13625,'af','Werknemers toegelaat',0),(490475,13625,'ro','Permis de angajaÅ£i',0),(490476,13625,'et','Lubatud tÃ¶Ã¶tajate',0),(490477,13625,'si','Zaposlenih, dovoljeno',0),(490478,13625,'ba','Karyawan yang diperbolehkan',0),(490479,13625,'nl','Werknemers toegestaan',0),(490480,13625,'fi','TyÃ¶ntekijÃ¶iden Internet',0),(490481,13625,'no','Ansatte tillatt',0),(490482,13625,'da','Medarbejdere mÃ¥',0),(490483,13625,'ko','ì§ì› ìˆ˜',0),(490484,13625,'he','×¢×•×‘×“×™× ×ž×•×¨×©×™×',0),(490485,13625,'el','Î•ÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Î¹ Ï€Î¿Ï… ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(490486,13625,'zh','å‘˜å·¥å¯ä»¥',0),(490487,13625,'sv','AnstÃ¤llda fÃ¥r',0),(490488,13625,'it','Dipendenti ammessi',0),(490489,13625,'tl','',0),(490490,13625,'th','à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(490491,13625,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(490492,13625,'ms','Kakitangan yang dibenarkan',0),(490493,13625,'ar','ÙŠØ³Ù…Ø­ Ù„Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(490494,13625,'fr','EmployÃ©s autorisÃ©s',0),(490495,13625,'jp','å¾“æ¥­å“¡ã®è¨±å¯',0),(490496,13625,'pt','FuncionÃ¡rios autorizados',0),(490497,13625,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¸ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(490498,13625,'es','Numero de Empleados',0),(490499,13625,'de','Mitarbeiter zulÃ¤ssig',0),(490500,13625,'en','Employees Allowed',0),(490501,13626,'is','',0),(490502,13626,'dr','Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ø§ÛŒÙ…ÛŒÙ„ Ø±Ø§ÛŒÚ¯Ø§Ù† 30 Ø±ÙˆØ²',0),(490503,13626,'pr','Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ Ø§ÛŒÙ…ÛŒÙ„ Ø±Ø§ÛŒÚ¯Ø§Ù† 30 Ø±ÙˆØ²',0),(490504,13626,'tr','Ãœcretsiz 30 gÃ¼nlÃ¼k e-posta desteÄŸi',0),(490505,13626,'pl','Wsparcie e-mail wolne 30 dni',0),(490506,13626,'bg','Ð¡Ð²Ð¾Ð±Ð¾Ð´ÐµÐ½ 30 Ð´ÐµÐ½ Ð¿Ð¾Ð´ÐºÑ€ÐµÐ¿Ð° Ð¸Ð¼ÐµÐ¹Ð»',0),(490507,13626,'ur','Ù…ÙØª 30 Ø¯Ù† Ø§ÛŒ Ù…ÛŒÙ„ Ù…Ø¹Ø§ÙˆÙ†Øª',0),(490508,13626,'sr','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾ 30 Ð´Ð°Ð½Ð° ÐµÐ¼Ð°Ð¸Ð» Ð¿Ð¾Ð´Ñ€ÑˆÐºÐ°',0),(490509,13626,'vi','Há»— trá»£ email miá»…n phÃ­ 30 ngÃ y',0),(490510,13626,'af','Gratis 30 dae e-pos ondersteuning',0),(490511,13626,'ro','Suport de e-mail gratuit 30 zile',0),(490512,13626,'et','Tasuta 30-pÃ¤evase e-posti tugi',0),(490513,13626,'si','BrezplaÄno 30-dnevno email podpora',0),(490514,13626,'ba','Dukungan email gratis 30 hari',0),(490515,13626,'nl','Gratis 30 dagen e-mail ondersteuning',0),(490516,13626,'fi','Ilmainen 30 pÃ¤ivÃ¤n sÃ¤hkÃ¶postituki',0),(490517,13626,'no','Gratis 30 dagers e-stÃ¸tte',0),(490518,13626,'da','Gratis 30 dages e-mail support',0),(490519,13626,'ko','30 ì¼ ë¬´ë£Œ ì „ìž ë©”ì¼ ì§€ì›',0),(490520,13626,'he','30 ×™×•× ×—×™× × ×“×•× ×œ ×ª×ž×™×›×”',0),(490521,13626,'el','Î¥Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… ÎµÎ»ÎµÏÎ¸ÎµÏÎ· 30 Î·Î¼ÎµÏÏŽÎ½',0),(490522,13626,'zh','30å¤©çš„å…è´¹ç”µå­é‚®ä»¶æ”¯æŒ',0),(490523,13626,'sv','Fri 30 dag e-support',0),(490524,13626,'it','Supporto email gratuita di 30 giorni',0),(490525,13626,'tl','',0),(490526,13626,'th','à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸Ÿà¸£à¸µ 30 à¸§à¸±à¸™',0),(490527,13626,'hi','30 à¤¦à¤¿à¤¨ à¤•à¥‡ à¤®à¥à¤«à¤¼à¥à¤¤ à¤ˆà¤®à¥‡à¤² à¤•à¤¾ à¤¸à¤®à¤°à¥à¤¥à¤¨',0),(490528,13626,'ms','Sokongan e-mel percuma 30 hari',0),(490529,13626,'ar','Ø¯Ø¹Ù… Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù…Ø¬Ø§Ù†Ø§Ù‹ 30 ÙŠÙˆÙ…Ø§',0),(490530,13626,'fr','Support par email gratuit de 30 jours',0),(490531,13626,'jp','30 æ—¥é–“ç„¡æ–™ãƒ¡ãƒ¼ãƒ« ã‚µãƒãƒ¼ãƒˆ',0),(490532,13626,'pt','Suporte de e-mail livre de 30 dias',0),(490533,13626,'ru','ÐŸÐ¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ° Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ 30 Ð´Ð½ÐµÐ¹ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(490534,13626,'es','Email gratuita 30 dÃ­as de soporte',0),(490535,13626,'de','Kostenlose 30-Tage-Email-support',0),(490536,13626,'en','Free 30 day email support',0),(490537,13627,'is','',0),(490538,13627,'dr','Ù„Ø¬Ø± Ø¹Ù…ÙˆÙ…ÛŒ (GL)',0),(490539,13627,'pr','Ù„Ø¬Ø± Ø¹Ù…ÙˆÙ…ÛŒ (GL)',0),(490540,13627,'tr','Genel muhasebe (GL)',0),(490541,13627,'pl','KsiÄ™gi gÅ‚Ã³wnej (GL)',0),(490542,13627,'bg','Ð¡Ñ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ (GL)',0),(490543,13627,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ (Ø¬ÛŒØ¬Û’)',0),(490544,13627,'sr','Ð“Ð»Ð°Ð²Ð½Ð° ÐºÑšÐ¸Ð³Ð° (Ð“Ð›)',0),(490545,13627,'vi','Tá»•ng sá»• káº¿ toÃ¡n (GL)',0),(490546,13627,'af','Algemene grootboek (GL)',0),(490547,13627,'ro','Contabilitate (GL)',0),(490548,13627,'et','Pearaamat (GL)',0),(490549,13627,'si','Glavna knjiga (GL)',0),(490550,13627,'ba','General Ledger (GL)',0),(490551,13627,'nl','General Ledger (GL)',0),(490552,13627,'fi','General Ledger (GrÃ¶nlanti)',0),(490553,13627,'no','Finans (GL)',0),(490554,13627,'da','General Ledger (GL)',0),(490555,13627,'ko','ì´ê³„ì • ì›ìž¥ (GL)',0),(490556,13627,'he','×”×¡×¤×¨ ×”×¨××©×™ (GL)',0),(490557,13627,'el','Î“ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® (GL)',0),(490558,13627,'zh','æ€»å¸ï¼ˆGLï¼‰',0),(490559,13627,'sv','Redovisning (GL)',0),(490560,13627,'it','ContabilitÃ  generale (GL)',0),(490561,13627,'tl','',0),(490562,13627,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸— (GL)',0),(490563,13627,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤²à¥‡à¤œà¤¼à¤° (GL)',0),(490564,13627,'ms','Lejar Am (GL)',0),(490565,13627,'ar','Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù… (GL)',0),(490566,13627,'fr','Grand livre gÃ©nÃ©ral (GL)',0),(490567,13627,'jp','ç·å‹˜å®šå…ƒå¸³ (GL)',0),(490568,13627,'pt','General Ledger (GL)',0),(490569,13627,'ru','Ð“Ðš (GL)',0),(490570,13627,'es','General Ledger (GL)',0),(490571,13627,'de','Finanzbuchhaltung (GL)',0),(490572,13627,'en','General Ledger (GL)',0),(490573,13628,'is','',0),(490574,13628,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù…Ø¬Ø§Ø²',0),(490575,13628,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù…Ø¬Ø§Ø²',0),(490576,13628,'tr','Stok izin',0),(490577,13628,'pl','Spis dozwolone',0),(490578,13628,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(490579,13628,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(490580,13628,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(490581,13628,'vi','HÃ ng tá»“n kho cho phÃ©p',0),(490582,13628,'af','Inventaris toegelaat',0),(490583,13628,'ro','Inventarul permis',0),(490584,13628,'et','Varude lubatud',0),(490585,13628,'si','Zaloge, dovoljeno',0),(490586,13628,'ba','Persediaan yang diperbolehkan',0),(490587,13628,'nl','Inventaris toegestaan',0),(490588,13628,'fi','Varaston Internet',0),(490589,13628,'no','Lager tillatt',0),(490590,13628,'da','Lager tilladt',0),(490591,13628,'ko','ìž¬ê³  í—ˆìš©',0),(490592,13628,'he','×ž×œ××™ ×ž×•×ª×¨×•×ª',0),(490593,13628,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(490594,13628,'zh','åº“å­˜å® ç‰©',0),(490595,13628,'sv','Lagret fÃ¥r',0),(490596,13628,'it','Inventario ha permesso',0),(490597,13628,'tl','',0),(490598,13628,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¹„à¸”à¹‰',0),(490599,13628,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(490600,13628,'ms','Inventori yang dibenarkan',0),(490601,13628,'ar','Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ÙŠØ³Ù…Ø­',0),(490602,13628,'fr','Inventaire a permis',0),(490603,13628,'jp','åœ¨åº«è¨±å¯',0),(490604,13628,'pt','InventÃ¡rio permitido',0),(490605,13628,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(490606,13628,'es','No. Articulos en Inventario',0),(490607,13628,'de','Inventur zulÃ¤ssig',0),(490608,13628,'en','Inventory Allowed',0),(490609,13629,'is','',0),(490610,13629,'dr','Ø±Ø¯ÛŒØ§Ø¨ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(490611,13629,'pr','Ø±Ø¯ÛŒØ§Ø¨ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(490612,13629,'tr','Stok Takibi',0),(490613,13629,'pl','Zapasy w handlu holowanie',0),(490614,13629,'bg','ÐžÐ¿Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(490615,13629,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø³Ø±Ø§Øº Ú©Ø§Ø±ÛŒ',0),(490616,13629,'sr','ÐŸÑ€Ð°Ñ›ÐµÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(490617,13629,'vi','HÃ ng tá»“n kho theo dÃµi',0),(490618,13629,'af','Inventaris dop',0),(490619,13629,'ro','Inventar de urmÄƒrire',0),(490620,13629,'et','Laoseisu jÃ¤lgimine',0),(490621,13629,'si','Inventar tir',0),(490622,13629,'ba','Pelacakan inventaris',0),(490623,13629,'nl','Inventaris het volgen',0),(490624,13629,'fi','Varaston seuranta',0),(490625,13629,'no','Inventarliste sporing',0),(490626,13629,'da','Lagersporing',0),(490627,13629,'ko','ìž¬ê³  ì¶”ì ',0),(490628,13629,'he','× ×™×”×•×œ ×ž×¢×§×‘ ××—×¨ ×ž×¦××™',0),(490629,13629,'el','Î Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(490630,13629,'zh','åº“å­˜è·Ÿè¸ª',0),(490631,13629,'sv','Inventering spÃ¥rning',0),(490632,13629,'it','Inventario di rilevamento',0),(490633,13629,'tl','',0),(490634,13629,'th','à¸•à¸´à¸”à¸•à¸²à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(490635,13629,'hi','à¤¸à¥‚à¤šà¥€ à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤—',0),(490636,13629,'ms','Penjejakan Inventori',0),(490637,13629,'ar','ØªØ¹Ù‚Ø¨ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(490638,13629,'fr','Suivi de l\'inventaire',0),(490639,13629,'jp','åœ¨åº«ã‚’è¿½è·¡ã—ã¾ã™ã€‚',0),(490640,13629,'pt','Controle de estoque',0),(490641,13629,'ru','ÐžÑ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(490642,13629,'es','Control de inventario',0),(490643,13629,'de','Bestandsverfolgung',0),(490644,13629,'en','Inventory Tracking',0),(490645,13630,'is','',0),(490646,13630,'dr','Ù†Ø±Ø® Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(490647,13630,'pr','Ù†Ø±Ø® Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(490648,13630,'tr','AylÄ±k oranÄ±',0),(490649,13630,'pl','MiesiÄ™czny kurs',0),(490650,13630,'bg','ÐœÐµÑÐµÑ‡ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(490651,13630,'ur','Ù…Ø§ÛØ§Ù†Û Ú©ÛŒ Ø´Ø±Ø­',0),(490652,13630,'sr','ÐœÐµÑÐµÑ‡Ð½Ð° ÑÑ‚Ð¾Ð¿Ð°',0),(490653,13630,'vi','Tá»· lá»‡ hÃ ng thÃ¡ng',0),(490654,13630,'af','Maandelikse tarief',0),(490655,13630,'ro','Rata lunarÄƒ',0),(490656,13630,'et','KuumÃ¤Ã¤r',0),(490657,13630,'si','MeseÄni teÄaj',0),(490658,13630,'ba','Tingkat bulanan',0),(490659,13630,'nl','Maandtarief',0),(490660,13630,'fi','Kuukausimaksu',0),(490661,13630,'no','MÃ¥nedlig rente',0),(490662,13630,'da','MÃ¥nedlig sats',0),(490663,13630,'ko','ì›”ë³„ ìš”ê¸ˆ',0),(490664,13630,'he','×ª×¢×¨×™×£ ×—×•×“×©×™',0),(490665,13630,'el','ÎœÎ·Î½Î¹Î±Î¯Î± Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(490666,13630,'zh','æœˆè´¹',0),(490667,13630,'sv','MÃ¥nadskostnad',0),(490668,13630,'it','Tasso mensile',0),(490669,13630,'tl','',0),(490670,13630,'th','à¸­à¸±à¸•à¸£à¸²à¸£à¸²à¸¢à¹€à¸”à¸·à¸­à¸™',0),(490671,13630,'hi','à¤®à¤¾à¤¸à¤¿à¤• à¤¦à¤°',0),(490672,13630,'ms','Kadar bulanan',0),(490673,13630,'ar','Ø§Ù„Ù…Ø¹Ø¯Ù„ Ø§Ù„Ø´Ù‡Ø±ÙŠ',0),(490674,13630,'fr','Tarif mensuel',0),(490675,13630,'jp','æœˆé¡æ–™é‡‘',0),(490676,13630,'pt','Taxa mensal',0),(490677,13630,'ru','ÐœÐµÑÑÑ‡Ð½Ð°Ñ ÑÑ‚Ð°Ð²ÐºÐ°',0),(490678,13630,'es','Costo Mensual',0),(490679,13630,'de','Monatliche Rate',0),(490680,13630,'en','Monthly Rate',0),(490681,13631,'is','',0),(490682,13631,'dr','Ù¾Ø´ØªÛŒØ¨Ø§Ù† Ú¯ÛŒØ±ÛŒ Ø´Ø¨Ø§Ù†Ù‡',0),(490683,13631,'pr','Ù¾Ø´ØªÛŒØ¨Ø§Ù† Ú¯ÛŒØ±ÛŒ Ø´Ø¨Ø§Ù†Ù‡',0),(490684,13631,'tr','Gecelik yedekleme',0),(490685,13631,'pl','Cejrowski kopii zapasowych',0),(490686,13631,'bg','Ð’ÑÑÐºÐ° Ð²ÐµÑ‡ÐµÑ€ Ð°Ñ€Ñ…Ð¸Ð²Ð¸',0),(490687,13631,'ur','Ø±Ø§Øª Ù¾Ø´ØªØ§Ø±ÙˆÚº',0),(490688,13631,'sr','ÐÐ¾Ñ›Ð½Ð¾ Ñ€ÐµÐ·ÐµÑ€Ð²Ð½Ðµ ÐºÐ¾Ð¿Ð¸Ñ˜Ðµ',0),(490689,13631,'vi','ÄÃªm sao lÆ°u',0),(490690,13631,'af','Elke aand rugsteune',0),(490691,13631,'ro','Noapte de backup',0),(490692,13631,'et','Ã–ine varukoopiaid',0),(490693,13631,'si','Dnevnih izdelav varnostnih kopij',0),(490694,13631,'ba','Malam backup',0),(490695,13631,'nl','Nachtelijke back-ups',0),(490696,13631,'fi','Ã–isin varmuuskopiot',0),(490697,13631,'no','Nattlig backuper',0),(490698,13631,'da','Natlig sikkerhedskopier',0),(490699,13631,'ko','ì•¼ê°„ ë°±ì—…',0),(490700,13631,'he','×’×™×‘×•×™×™× ×œ×™×œ×™×™×',0),(490701,13631,'el','ÎšÎ¬Î¸Îµ Î²ÏÎ¬Î´Ï… Ï€Î»Î¬Ï„Î·',0),(490702,13631,'zh','å¤œé—´å¤‡ä»½',0),(490703,13631,'sv','Nattliga sÃ¤kerhetskopieringar',0),(490704,13631,'it','Backup notturno',0),(490705,13631,'tl','',0),(490706,13631,'th','à¸„à¸·à¸™à¸ªà¸³à¸£à¸­à¸‡',0),(490707,13631,'hi','à¤¹à¤° à¤°à¤¾à¤¤ à¤¬à¥ˆà¤•à¤…à¤ª',0),(490708,13631,'ms','Sandaran setiap malam',0),(490709,13631,'ar','Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠ Ù„ÙŠÙ„Ø§',0),(490710,13631,'fr','Sauvegardes nocturnes',0),(490711,13631,'jp','å¤œé–“ãƒãƒƒã‚¯ã‚¢ãƒƒãƒ—',0),(490712,13631,'pt','Backups noturnos',0),(490713,13631,'ru','ÐÐ¾Ñ‡Ð½Ñ‹Ðµ Ñ€ÐµÐ·ÐµÑ€Ð²Ð½Ñ‹Ðµ ÐºÐ¾Ð¿Ð¸Ð¸',0),(490714,13631,'es','Copias de seguridad nocturnas',0),(490715,13631,'de','NÃ¤chtliche Backups',0),(490716,13631,'en','Nightly Backups',0),(490717,13632,'is','',0),(490718,13632,'dr','Payables (Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³)',0),(490719,13632,'pr','Payables (Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³)',0),(490720,13632,'tr','BorÃ§lar (AP)',0),(490721,13632,'pl','ZobowiÄ…zania (AP)',0),(490722,13632,'bg','Ð—Ð°Ð´ÑŠÐ»Ð¶ÐµÐ½Ð¸Ñ (AP)',0),(490723,13632,'ur','Ù¾Ø§ÛŒØ§Ø¨Ù„Ø§Ø³ (AP)',0),(490724,13632,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° (ÐÐŸ)',0),(490725,13632,'vi','Payables (AP)',0),(490726,13632,'af','Waardedalingstoetse (GP)',0),(490727,13632,'ro','Datorii (AP)',0),(490728,13632,'et','VÃµlad (AP)',0),(490729,13632,'si','Obveznosti (AP)',0),(490730,13632,'ba','Hutang (AP)',0),(490731,13632,'nl','Schulden (AP)',0),(490732,13632,'fi','Velat (AP)',0),(490733,13632,'no','LeverandÃ¸rgjeld (AP)',0),(490734,13632,'da','GÃ¦ld (AP)',0),(490735,13632,'ko','ë¯¸ì§€ê¸‰ê¸ˆ (ap = ì—°í•© ë‰´ìŠ¤)',0),(490736,13632,'he','×–×›××™× (AP)',0),(490737,13632,'el','Î Î»Î·ÏÏ‰Ï„Î­Ï‰Î½ (AP)',0),(490738,13632,'zh','åº”ä»˜å¸æ¬¾ï¼ˆAPï¼‰',0),(490739,13632,'sv','LeverantÃ¶rsskulder (AP)',0),(490740,13632,'it','Debiti (AP)',0),(490741,13632,'tl','',0),(490742,13632,'th','à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰ (AP)',0),(490743,13632,'hi','Payables (à¤à¤ªà¥€)',0),(490744,13632,'ms','Pemiutang (AP)',0),(490745,13632,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹ (Ø£ ÙØ¨)',0),(490746,13632,'fr','Comptes fournisseurs (AP)',0),(490747,13632,'jp','è²·æŽ›é‡‘ ï¼ˆap é€šä¿¡ï¼‰',0),(490748,13632,'pt','Contas a pagar (AP)',0),(490749,13632,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð¾Ñ€ÑÐºÐ°Ñ Ð·Ð°Ð´Ð¾Ð»Ð¶ÐµÐ½Ð½Ð¾ÑÑ‚ÑŒ (AP)',0),(490750,13632,'es','Cuentas por pagar (AP)',0),(490751,13632,'de','Verbindlichkeiten (AP)',0),(490752,13632,'en','Payables (AP)',0),(490753,13633,'is','',0),(490754,13633,'dr','ÙˆØ§Ø­Ø¯ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(490755,13633,'pr','ÙˆØ§Ø­Ø¯ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(490756,13633,'tr','Bordro modÃ¼lÃ¼',0),(490757,13633,'pl','ModuÅ‚ pÅ‚ace',0),(490758,13633,'bg','Ð¢Ð Ð— Ð¼Ð¾Ð´ÑƒÐ»',0),(490759,13633,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù…Ø§ÚˆÛŒÙˆÙ„',0),(490760,13633,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð¼Ð¾Ð´ÑƒÐ»Ð°',0),(490761,13633,'vi','BiÃªn cháº¿ mÃ´-Ä‘un',0),(490762,13633,'af','Salarisstelsel Module',0),(490763,13633,'ro','Modulul de salarizare',0),(490764,13633,'et','Palgaarvestuse moodul',0),(490765,13633,'si','IzplaÄane plaÄe modul',0),(490766,13633,'ba','Modul penggajian',0),(490767,13633,'nl','Payroll Module',0),(490768,13633,'fi','Palkanlaskenta-moduuli',0),(490769,13633,'no','LÃ¸nn-modulen',0),(490770,13633,'da','LÃ¸nningslisten modul',0),(490771,13633,'ko','ê¸‰ì—¬ ëª¨ë“ˆ',0),(490772,13633,'he','×ž×•×“×•×œ ×”×©×›×¨',0),(490773,13633,'el','ÎœÎ¿Î½Î¬Î´Î± Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(490774,13633,'zh','è–ªèµ„æ¨¡å—',0),(490775,13633,'sv','LÃ¶nelistan modul',0),(490776,13633,'it','Modulo paghe',0),(490777,13633,'tl','',0),(490778,13633,'th','à¹‚à¸¡à¸”à¸¹à¸¥à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(490779,13633,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤²',0),(490780,13633,'ms','Gaji modul',0),(490781,13633,'ar','ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(490782,13633,'fr','Module de paie',0),(490783,13633,'jp','çµ¦ä¸Žæ”¯æ‰•ã„ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«',0),(490784,13633,'pt','MÃ³dulo de folha de pagamento',0),(490785,13633,'ru','ÐœÐ¾Ð´ÑƒÐ»ÑŒ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(490786,13633,'es','MÃ³dulo de NÃ³mina',0),(490787,13633,'de','Abrechnung-Modul',0),(490788,13633,'en','Payroll Module',0),(490789,13634,'is','',0),(490790,13634,'dr','Ø¢Ù† Ø§Ø² Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ (POS)',0),(490791,13634,'pr','Ø¢Ù† Ø§Ø² Ù†Ù‚Ø·Ù‡ ÙØ±ÙˆØ´ (POS)',0),(490792,13634,'tr','SatÄ±ÅŸ noktasÄ± (POS)',0),(490793,13634,'pl','Punkt sprzedaÅ¼y (POS)',0),(490794,13634,'bg','Ð¢Ð¾Ñ‡ÐºÐ° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° (POS)',0),(490795,13634,'ur','ÛŒØ§ Ø¯Ú©Ø§Ù†ÙˆÚº (Ù¾ÙˆØ²ÛŒØ´Ù† Ù…ØªØ­Ø¯Û)',0),(490796,13634,'sr','ÐŸÐžÐ¡ (ÐŸÐžÐ¡)',0),(490797,13634,'vi','Point-of-Sale (POS)',0),(490798,13634,'af','Point-of-Sale (POS)',0),(490799,13634,'ro','La punctul de vÃ¢nzare (POS)',0),(490800,13634,'et','MÃ¼Ã¼gikohtades (POS)',0),(490801,13634,'si','Prodajnih mestih (POS)',0),(490802,13634,'ba','Point-of-Sale (POS)',0),(490803,13634,'nl','Verkooppunt (POS)',0),(490804,13634,'fi','Point-of-Sale (POS)',0),(490805,13634,'no','Point-of-Sale (POS)',0),(490806,13634,'da','Point-of-Sale (POS)',0),(490807,13634,'ko','íŒë§¤ ì´‰ì§„ í˜• (POS)',0),(490808,13634,'he','× ×§×•×“×ª ×”×ž×›×™×¨×” (POS)',0),(490809,13634,'el','Î£Î·Î¼ÎµÎ¯Î¿ Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚ (POS)',0),(490810,13634,'zh','é”€å”®ç‚¹ï¼ˆPOSï¼‰',0),(490811,13634,'sv','Point of Sale (POS)',0),(490812,13634,'it','Point of sale (POS)',0),(490813,13634,'tl','',0),(490814,13634,'th','à¸£à¸°à¸šà¸šà¸‚à¸²à¸¢à¸«à¸™à¹‰à¸²à¸£à¹‰à¸²à¸™ (POS)',0),(490815,13634,'hi','à¤¬à¤¿à¤‚à¤¦à¥ à¤•à¤¾ à¤¬à¤¿à¤•à¥à¤°à¥€ (POS)',0),(490816,13634,'ms','Point-of-Sale (POS)',0),(490817,13634,'ar','Ù†Ù‚Ø·Ø© Ø§Ù„Ø¨ÙŠØ¹ (POS)',0),(490818,13634,'fr','Point de vente (POS)',0),(490819,13634,'jp','POS (è²©å£²)',0),(490820,13634,'pt','Ponto de venda (POS)',0),(490821,13634,'ru','ÐšÐ°ÑÑÐ¾Ð²Ñ‹Ñ… Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð°Ð»Ð¾Ð² (POS)',0),(490822,13634,'es','Punto-de-Venta (POS)',0),(490823,13634,'de','Point of Sale (POS)',0),(490824,13634,'en','Point-of-Sale (POS)',0),(490825,13635,'is','',0),(490826,13635,'dr','Ø­Ø±ÙÙ‡ Ø§ÛŒ Ø­Ø³Ø§Ø¨Ø±Ø³ÛŒ',0),(490827,13635,'pr','Ø­Ø±ÙÙ‡ Ø§ÛŒ Ø­Ø³Ø§Ø¨Ø±Ø³ÛŒ',0),(490828,13635,'tr','Profesyonel denetleme',0),(490829,13635,'pl','Profesjonalny audyt',0),(490830,13635,'bg','ÐŸÑ€Ð¾Ñ„ÐµÑÐ¸Ð¾Ð½Ð°Ð»ÐµÐ½ Ð¾Ð´Ð¸Ñ‚',0),(490831,13635,'ur','Ù¾Ø±ÙˆÙÛŒØ´Ù†Ù„ Ø¢ÚˆÙ¹',0),(490832,13635,'sr','ÐŸÑ€Ð¾Ñ„ÐµÑÐ¸Ð¾Ð½Ð°Ð»Ð½Ð¸ Ð½Ð°Ð´Ð·Ð¾Ñ€',0),(490833,13635,'vi','ChuyÃªn nghiá»‡p kiá»ƒm toÃ¡n',0),(490834,13635,'af','Professionele ouditering',0),(490835,13635,'ro','Profesionale de audit',0),(490836,13635,'et','Professional auditeerimine',0),(490837,13635,'si','Strokovni nadzor',0),(490838,13635,'ba','Profesional audit',0),(490839,13635,'nl','Professionele controle',0),(490840,13635,'fi','Professional valvonta',0),(490841,13635,'no','Profesjonell overvÃ¥king',0),(490842,13635,'da','Professionel revision',0),(490843,13635,'ko','ê°ì‚¬ ì „ë¬¸',0),(490844,13635,'he','×‘×™×§×•×¨×ª ×ž×§×¦×•×¢×™×ª',0),(490845,13635,'el','Î•Ï€Î±Î³Î³ÎµÎ»Î¼Î±Ï„Î¹ÎºÎ® Î­Î»ÎµÎ³Ï‡Î¿Ï‚',0),(490846,13635,'zh','å®¡è®¡ä¸“ä¸š',0),(490847,13635,'sv','Professionell granskning',0),(490848,13635,'it','Professional audit',0),(490849,13635,'tl','',0),(490850,13635,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸¡à¸·à¸­à¸­à¸²à¸Šà¸µà¸ž',0),(490851,13635,'hi','à¤ªà¥‡à¤¶à¥‡à¤µà¤° à¤²à¥‡à¤–à¤¾ à¤ªà¤°à¥€à¤•à¥à¤·à¤¾',0),(490852,13635,'ms','Profesional pengauditan',0),(490853,13635,'ar','Ø§Ù„ÙÙ†ÙŠØ© Ø§Ù„ØªØ¯Ù‚ÙŠÙ‚',0),(490854,13635,'fr','Professionnel de l\'audit',0),(490855,13635,'jp','ç›£æŸ»ãƒ—ãƒ­ãƒ•ã‚§ãƒƒã‚·ãƒ§ãƒŠãƒ«',0),(490856,13635,'pt','Profissional de auditoria',0),(490857,13635,'ru','ÐŸÑ€Ð¾Ñ„ÐµÑÑÐ¸Ð¾Ð½Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð°ÑƒÐ´Ð¸Ñ‚',0),(490858,13635,'es','profesionales de auditorÃ­a',0),(490859,13635,'de','Professionelle Ãœberwachung',0),(490860,13635,'en','Professional Auditing',0),(490861,13636,'is','',0),(490862,13636,'dr','Ø®Ø¯Ù…Ø§Øª &amp; Ù…ÙˆØ±Ø¯ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(490863,13636,'pr','Ø®Ø¯Ù…Ø§Øª &amp; Ù…ÙˆØ±Ø¯ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(490864,13636,'tr','Hizmet & madde sipariÅŸleri',0),(490865,13636,'pl','UsÅ‚uga & przedmiotu zamÃ³wienia',0),(490866,13636,'bg','Ð¡ÐµÑ€Ð²Ð¸Ð· & ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(490867,13636,'ur','Ø®Ø¯Ù…Øª & Ø´Û’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(490868,13636,'sr','Ð¡ÐµÑ€Ð²Ð¸Ñ & Ð½Ð°Ð»Ð¾Ð³Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(490869,13636,'vi','Dá»‹ch vá»¥ &amp; má»¥c Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(490870,13636,'af','Diens & Item bestellings',0),(490871,13636,'ro','Serviciul & element comenzi',0),(490872,13636,'et','Teenuse & kauba tellimusi',0),(490873,13636,'si','Storitev & element naroÄila',0),(490874,13636,'ba','Layanan & Item pesanan',0),(490875,13636,'nl','Service & Item Orders',0),(490876,13636,'fi','Palvelun & nimikkeen tilaukset',0),(490877,13636,'no','Tjenesten & element ordrer',0),(490878,13636,'da','Service & vare ordrer',0),(490879,13636,'ko','ì„œë¹„ìŠ¤ & í•­ëª© ì£¼ë¬¸',0),(490880,13636,'he','×©×™×¨×•×ª & ×¤×¨×™×˜ ×¤×§×•×“×•×ª',0),(490881,13636,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± & ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(490882,13636,'zh','æœåŠ¡ä¸Žäº§å“è®¢å•',0),(490883,13636,'sv','TjÃ¤nsten & objekt order',0),(490884,13636,'it','Servizio & voce ordini',0),(490885,13636,'tl','',0),(490886,13636,'th','à¸šà¸£à¸´à¸à¸²à¸£ & à¸ªà¸±à¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(490887,13636,'hi','à¤¸à¥‡à¤µà¤¾ & à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(490888,13636,'ms','Perkhidmatan & Item pesanan',0),(490889,13636,'ar','Ø®Ø¯Ù…Ø© Ø¢Ù†Ø¯ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨Ù†Ø¯',0),(490890,13636,'fr','Service & de commandes de l\'Ã©lÃ©ment',0),(490891,13636,'jp','ã‚µãƒ¼ãƒ“ã‚¹ & é …ç›®ã®æ³¨æ–‡',0),(490892,13636,'pt','ServiÃ§o & ordens de Item',0),(490893,13636,'ru','Ð¡Ð»ÑƒÐ¶Ð±Ð° & Ð¿ÑƒÐ½ÐºÑ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(490894,13636,'es','Servicio y Ã“rdenes del artÃ­culo',0),(490895,13636,'de','Service & Element-Bestellungen',0),(490896,13636,'en','Service & Item Orders',0),(490897,13637,'is','',0),(490898,13637,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ù…Ø¬Ø§Ø²',0),(490899,13637,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ù…Ø¬Ø§Ø²',0),(490900,13637,'tr','Ä°zin verilen satÄ±cÄ±lar',0),(490901,13637,'pl','Sprzedawcy mogÄ…',0),(490902,13637,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(490903,13637,'ur','Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(490904,13637,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(490905,13637,'vi','CÃ¡c nhÃ  cung cáº¥p Ä‘Æ°á»£c phÃ©p',0),(490906,13637,'af','Handelaars toegelaat',0),(490907,13637,'ro','VÃ¢nzÄƒtorii de permis',0),(490908,13637,'et','Hankijate lubatud',0),(490909,13637,'si','Prodajalci, dovoljeno',0),(490910,13637,'ba','Vendor yang diizinkan',0),(490911,13637,'nl','Leveranciers toegestaan',0),(490912,13637,'fi','Toimittajien saa',0),(490913,13637,'no','LeverandÃ¸rer tillatt',0),(490914,13637,'da','Kreditorer tilladt',0),(490915,13637,'ko','í—ˆìš© í•˜ëŠ” ê³µê¸‰ ì—…ì²´',0),(490916,13637,'he','×¡×¤×§×™× ×ž×•×¨×©×™×',0),(490917,13637,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(490918,13637,'zh','ä¾›åº”å•†å® ç‰©',0),(490919,13637,'sv','LeverantÃ¶rer fÃ¥r',0),(490920,13637,'it','Fornitori autorizzati',0),(490921,13637,'tl','',0),(490922,13637,'th','à¸œà¸¹à¹‰à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(490923,13637,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(490924,13637,'ms','Vendor yang dibenarkan',0),(490925,13637,'ar','ÙŠØ³Ù…Ø­ Ù„Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ†',0),(490926,13637,'fr','Vendeurs autorisÃ©s',0),(490927,13637,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¨±å¯',0),(490928,13637,'pt','Vendedores autorizados',0),(490929,13637,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(490930,13637,'es','Numeros de Vendedores',0),(490931,13637,'de','Anbieter erlaubt',0),(490932,13637,'en','Vendors Allowed',0),(490933,13638,'is','',0),(490934,13638,'dr','Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ø¢Ø³Ø§Ù†',0),(490935,13638,'pr','Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ø¢Ø³Ø§Ù†',0),(490936,13638,'tr','Kolay defter tutma',0),(490937,13638,'pl','Åatwe prowadzenie ksiÄ…g',0),(490938,13638,'bg','Ð›ÐµÑÐ½Ð¾ ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(490939,13638,'ur','Ø¢Ø³Ø§Ù† Ú©ÛŒÙ¾Ù†Ú¯',0),(490940,13638,'sr','Ð›Ð°ÐºÐ¾ ÐºÑšÐ¸Ð³Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(490941,13638,'vi','Sá»• sÃ¡ch káº¿ toÃ¡n dá»… dÃ ng',0),(490942,13638,'af','Maklik boekhouding',0),(490943,13638,'ro','Contabilitate usor',0),(490944,13638,'et','Lihtne raamatupidamine',0),(490945,13638,'si','Enostavno knjigovodstvo',0),(490946,13638,'ba','Mudah pembukuan',0),(490947,13638,'nl','Gemakkelijk boekhouding',0),(490948,13638,'fi','Helppoa kirjanpito',0),(490949,13638,'no','Enkel bokfÃ¸ring',0),(490950,13638,'da','Let bogholderi',0),(490951,13638,'ko','ì‰½ê²Œ ë¶€ ê¸°',0),(490952,13638,'he','×”× ×”×œ×ª ×—×©×‘×•× ×•×ª ×§×œ',0),(490953,13638,'el','Î•ÏÎºÎ¿Î»Î· Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®Ï‚',0),(490954,13638,'zh','æ˜“ç°¿è®°',0),(490955,13638,'sv','Enkel bokfÃ¶ring',0),(490956,13638,'it','ContabilitÃ  facile',0),(490957,13638,'tl','',0),(490958,13638,'th','à¸—à¸³à¸‡à¹ˆà¸²à¸¢',0),(490959,13638,'hi','à¤†à¤¸à¤¾à¤¨ à¤¬à¤¹à¥€à¤–à¤¾à¤¤à¤¾ à¤ªà¤¦à¥à¤§à¤¤à¤¿',0),(490960,13638,'ms','Mudah Simpan kira',0),(490961,13638,'ar','Ù…Ø³Ùƒ Ø§Ù„Ø¯ÙØ§ØªØ± Ø³Ù‡Ù„Ø©',0),(490962,13638,'fr','ComptabilitÃ© facile',0),(490963,13638,'jp','ç°¡å˜ãªç°¿è¨˜',0),(490964,13638,'pt','Contabilidade fÃ¡cil',0),(490965,13638,'ru','ÐŸÑ€Ð¾ÑÑ‚Ð¾Ð¹ Ð±ÑƒÑ…Ð³Ð°Ð»Ñ‚ÐµÑ€Ð¸Ð¸',0),(490966,13638,'es','Contabilidad FÃ¡cil',0),(490967,13638,'de','Einfache Buchhaltung',0),(490968,13638,'en','Easy Bookkeeping',0),(490969,13639,'is','',0),(490970,13639,'dr','Ø¹Ù…Ù‚ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ',0),(490971,13639,'pr','Ø¹Ù…Ù‚ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ',0),(490972,13639,'tr','AyrÄ±ntÄ±lÄ± hesap',0),(490973,13639,'pl','SzczegÃ³Å‚owej rachunkowoÅ›ci',0),(490974,13639,'bg','Ð—Ð°Ð´ÑŠÐ»Ð±Ð¾Ñ‡ÐµÐ½Ð¾ Ð¾Ñ‚Ñ‡Ð¸Ñ‚Ð°Ð½Ðµ',0),(490975,13639,'ur','ØªÙØµÛŒÙ„ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹Ù†Ú¯',0),(490976,13639,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð½Ð¸Ñ˜Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(490977,13639,'vi','Káº¿ toÃ¡n chuyÃªn sÃ¢u',0),(490978,13639,'af','Diepgaande rekeningkundige',0),(490979,13639,'ro','Contabilitate aprofundatÄƒ',0),(490980,13639,'et','PÃµhjalik raamatupidamise',0),(490981,13639,'si','Poglobljeni raÄunovodski',0),(490982,13639,'ba','Mendalam akuntansi',0),(490983,13639,'nl','Diepgaande Accounting',0),(490984,13639,'fi','Perusteellinen kirjanpito',0),(490985,13639,'no','Detaljert regnskapsfÃ¸ring',0),(490986,13639,'da','DybdegÃ¥ende regnskabsmÃ¦ssige',0),(490987,13639,'ko','ê¹Šì´ ìžˆëŠ” íšŒê³„',0),(490988,13639,'he','×—×©×‘×•× ××•×ª ×ž×¢×ž×™×§',0),(490989,13639,'el','Î£Îµ Î²Î¬Î¸Î¿Ï‚ Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®',0),(490990,13639,'zh','åœ¨æ·±åº¦ä¼šè®¡',0),(490991,13639,'sv','FÃ¶rdjupad redovisning',0),(490992,13639,'it','ContabilitÃ  approfondita',0),(490993,13639,'tl','',0),(490994,13639,'th','à¸šà¸±à¸à¸Šà¸µà¹ƒà¸™à¹€à¸Šà¸´à¸‡à¸¥à¸¶à¸',0),(490995,13639,'hi','à¤—à¤¹à¤°à¤¾à¤ˆ à¤®à¥‡à¤‚ à¤²à¥‡à¤–à¤¾',0),(490996,13639,'ms','Perakaunan dengan lebih mendalam',0),(490997,13639,'ar','Ù…Ø­Ø§Ø³Ø¨Ø© Ù…Ø¹Ù…Ù‚Ø©',0),(490998,13639,'fr','ComptabilitÃ© approfondie',0),(490999,13639,'jp','è©³ç´°ãªä¼šè¨ˆ',0),(491000,13639,'pt','Contabilidade em profundidade',0),(491001,13639,'ru','Ð£Ð³Ð»ÑƒÐ±Ð»ÐµÐ½Ð½Ð¾Ð³Ð¾ ÑƒÑ‡ÐµÑ‚Ð°',0),(491002,13639,'es','En profundidad de Contabilidad',0),(491003,13639,'de','AusfÃ¼hrliche Buchhaltung',0),(491004,13639,'en','In-Depth Accounting',0),(491005,13640,'is','',0),(491006,13640,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ú©Ø´ØªÛŒ Ø¨Ø±Ø¢ÙˆØ±Ø¯ ØªØ§Ø±ÛŒØ® ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´',0),(491007,13640,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ú©Ø´ØªÛŒ Ø¨Ø±Ø¢ÙˆØ±Ø¯ ØªØ§Ø±ÛŒØ® ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´',0),(491008,13640,'tr','SipariÅŸ teyidi olarak tahmin edilen sevk tarihi gizle',0),(491009,13640,'pl','Ukryj szacowana Data wysyÅ‚ki na potwierdzenie zamÃ³wienia',0),(491010,13640,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¾ÐºÐ¾Ð»Ð¾ ÐºÐ¾Ñ€Ð°Ð±Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(491011,13640,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø¬ÛØ§Ø² ØªØ§Ø±ÛŒØ® Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ùˆ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(491012,13640,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð¿Ñ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ðµ Ð½Ð° ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(491013,13640,'vi','Hide Æ°á»›c tÃ­nh tÃ u ngÃ y trÃªn xÃ¡c nháº­n Ä‘áº·t hÃ ng',0),(491014,13640,'af','Versteek Geraamde skip datum op bestelling bevestiging',0),(491015,13640,'ro','Ascunde estimat data navei pe confirmarea comenzii',0),(491016,13640,'et','Peida Eeldatav tarnekuupÃ¤ev tellimuse kinnituses',0),(491017,13640,'si','Skrij ocenjena ladja datum potrditve naroÄila',0),(491018,13640,'ba','Sembunyikan kapal perkiraan tanggal pada konfirmasi Order',0),(491019,13640,'nl','Geschatte verzenddatum op orderbevestiging verbergen',0),(491020,13640,'fi','Piilota arvioidun toimituspÃ¤ivÃ¤n vahvistus',0),(491021,13640,'no','Skjul antatt forsendelsesdato pÃ¥ ordrebekreftelsen',0),(491022,13640,'da','Skjule anslÃ¥ede afsendelsesdato pÃ¥ ordrebekrÃ¦ftelse',0),(491023,13640,'ko','ì£¼ë¬¸ í™•ì¸ ì„œì— ì˜ˆìƒëœ ë°°ì†¡ì¼ì„ ìˆ¨ê¸°ê¸°',0),(491024,13640,'he','×”×¡×ª×¨ ×ž×•×¢×¨×š ×ª××¨×™×š ×ž×©×œ×•×— ×¢×œ ××™×©×•×¨ ×”×–×ž× ×”',0),(491025,13640,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÎµÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Î³Î¹Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(491026,13640,'zh','éšè—åœ¨è®¢å•ç¡®è®¤é¢„è®¡çš„å‘è´§æ—¥æœŸ',0),(491027,13640,'sv','DÃ¶lja berÃ¤knade leveransdatum pÃ¥ orderbekrÃ¤ftelse',0),(491028,13640,'it','Nascondere la data di spedizione stimata sulla conferma d\'ordine',0),(491029,13640,'tl','',0),(491030,13640,'th','à¸‹à¹ˆà¸­à¸™à¸§à¸±à¸™à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹‚à¸”à¸¢à¸›à¸£à¸°à¸¡à¸²à¸“à¹ƒà¸™à¸à¸²à¸£à¸¢à¸·à¸™à¸¢à¸±à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(491031,13640,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨ à¤•à¥‡ à¤…à¤¨à¥à¤¸à¤¾à¤° à¤œà¤¹à¤¾à¤œ à¤¤à¤¿à¤¥à¤¿ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤ªà¤° à¤›à¥à¤ªà¤¾à¤à¤',0),(491032,13640,'ms','Sembunyi kapal anggaran tarikh pengesahan Order',0),(491033,13640,'ar','Ø¥Ø®ÙØ§Ø¡ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ù…Ù‚Ø¯Ø±Ø© Ø¹Ù„Ù‰ ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø·Ù„Ø¨',0),(491034,13640,'fr','Cacher la Date d\'expÃ©dition estimÃ©e sur la Confirmation de commande',0),(491035,13640,'jp','æŽ¨å®šå‡ºè·æ—¥ã”æ³¨æ–‡ã®ç¢ºèªã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(491036,13640,'pt','Ocultar a data de envio estimado na confirmaÃ§Ã£o da encomenda',0),(491037,13640,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð´Ð°Ñ‚Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð½Ð° Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ð¸ Ð·Ð°ÐºÐ°Ð·Ð°',0),(491038,13640,'es','Esconde Fecha Estimado EnvÃ­o en el Pedido de ConfirmaciÃ³n ',0),(491039,13640,'de','Voraussichtliches Lieferdatum auf AuftragsbestÃ¤tigung ausblenden',0),(491040,13640,'en','Hide Estimated Ship Date On Order Confirmation',0),(491041,13641,'is','',0),(491042,13641,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… Ø¨Ø§ ÛŒÚ© Ø­Ø³Ø§Ø¨ Google',0),(491043,13641,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… Ø¨Ø§ ÛŒÚ© Ø­Ø³Ø§Ø¨ Google',0),(491044,13641,'tr','Bir Google hesabÄ± ile oturum',0),(491045,13641,'pl','Zaloguj siÄ™ na konto Google',0),(491046,13641,'bg','Ð’Ð»ÐµÐ·Ñ‚Ðµ Ñ Ð¿Ñ€Ð¾Ñ„Ð¸Ð»Ð° Ð² Google',0),(491047,13641,'ur','Google Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ø³Ø§ØªÚ¾ Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº',0),(491048,13641,'sr','Ð”Ð° ÑÐµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›Ñƒ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð·Ð° Ð“Ð¾Ð¾Ð³Ð»Ðµ',0),(491049,13641,'vi','ÄÄƒng nháº­p báº±ng tÃ i khoáº£n Google',0),(491050,13641,'af','Teken aan met \'n Google-rekening',0),(491051,13641,'ro','Log in cu un cont Google',0),(491052,13641,'et','Logige sisse Google\'i kontoga',0),(491053,13641,'si','Prijavite se v Google raÄun',0),(491054,13641,'ba','Login dengan akun Google',0),(491055,13641,'nl','Meld u aan met een Google-Account',0),(491056,13641,'fi','Kirjautuminen Google-tilin',0),(491057,13641,'no','Logge pÃ¥ med en Google-konto',0),(491058,13641,'da','Logge ind med en Google-konto',0),(491059,13641,'ko','Google ê³„ì •ìœ¼ë¡œ ë¡œê·¸ì¸',0),(491060,13641,'he','×œ×”×™×›× ×¡ ×œ×ž×¢×¨×›×ª ×‘××ž×¦×¢×•×ª ×—×©×‘×•×Ÿ ×’×•×’×œ',0),(491061,13641,'el','Î£Ï…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Î¼Îµ Î­Î½Î±Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Google',0),(491062,13641,'zh','ä½¿ç”¨ Google å¸æˆ·ç™»å½•',0),(491063,13641,'sv','Logga in med ett Google-konto',0),(491064,13641,'it','Accedi con un Account Google',0),(491065,13641,'tl','',0),(491066,13641,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š à¸”à¹‰à¸§à¸¢à¸šà¸±à¸à¸Šà¸µ Google',0),(491067,13641,'hi','Google à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤²à¥‰à¤— à¤‘à¤¨',0),(491068,13641,'ms','Log masuk dengan akaun Google',0),(491069,13641,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ø³Ø§Ø¨ Google',0),(491070,13641,'fr','Connectez-vous avec un compte Google',0),(491071,13641,'jp','Google ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã§ãƒ­ã‚°ã‚¤ãƒ³',0),(491072,13641,'pt','FaÃ§a logon com uma conta do Google',0),(491073,13641,'ru','Ð’Ð¾Ð¹Ð´Ð¸Ñ‚Ðµ Ð² Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚ Google',0),(491074,13641,'es','Login con Cuenta de Google',0),(491075,13641,'de','Loggen Sie sich mit einem Google-Konto',0),(491076,13641,'en','Log in with a Google Account',0),(491077,13642,'is','',0),(491078,13642,'dr','Ø§ÛŒÙ† Ø³Ø§ÛŒØª ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(491079,13642,'pr','Ø§ÛŒÙ† Ø³Ø§ÛŒØª ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(491080,13642,'tr','Bu site yok',0),(491081,13642,'pl','Ta strona nie istnieje',0),(491082,13642,'bg','Ð¢Ð¾Ð·Ð¸ ÑÐ°Ð¹Ñ‚ Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(491083,13642,'ur','Ø§Ø³ Ø³Ø§Ø¦Ù¹ Ú©Ø§ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(491084,13642,'sr','ÐžÐ²Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(491085,13642,'vi','Trang web nÃ y khÃ´ng tá»“n táº¡i',0),(491086,13642,'af','Hierdie webwerf bestaan nie',0),(491087,13642,'ro','Acest site nu existÄƒ',0),(491088,13642,'et','Sellel saidil pole olemas',0),(491089,13642,'si','Ta stran ne obstaja',0),(491090,13642,'ba','Situs ini tidak ada',0),(491091,13642,'nl','Deze site bestaat niet',0),(491092,13642,'fi','TÃ¤mÃ¤ sivusto ei ole',0),(491093,13642,'no','Dette omrÃ¥det finnes ikke',0),(491094,13642,'da','Dette websted findes ikke',0),(491095,13642,'ko','ì´ ì‚¬ì´íŠ¸ëŠ” ì¡´ìž¬ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(491096,13642,'he','××ª×¨ ×–×” ××™× ×• ×§×™×™×',0),(491097,13642,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ site Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹',0),(491098,13642,'zh','æœ¬ç½‘ç«™ä¸å­˜åœ¨',0),(491099,13642,'sv','Denna webbplats finns inte',0),(491100,13642,'it','Questo sito non esiste',0),(491101,13642,'tl','',0),(491102,13642,'th','à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(491103,13642,'hi','à¤‡à¤¸ à¤¸à¤¾à¤‡à¤Ÿ à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(491104,13642,'ms','Laman web ini tidak wujud',0),(491105,13642,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(491106,13642,'fr','Ce site n\'existe pas',0),(491107,13642,'jp','ã“ã®ã‚µã‚¤ãƒˆã¯å­˜åœ¨ã—ã¾ã›ã‚“',0),(491108,13642,'pt','Este site nÃ£o existe',0),(491109,13642,'ru','Ð­Ñ‚Ð¾Ñ‚ ÑÐ°Ð¹Ñ‚ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(491110,13642,'es','Este sitio no existe',0),(491111,13642,'de','Diese Seite existiert nicht',0),(491112,13642,'en','This site does not exist',0),(491113,13643,'is','',0),(491114,13643,'dr','Ø±Ù…Ø² ÙˆØ±ÙˆØ¯ Ø®ÙˆØ¯ Ø±Ø§ ÙØ±Ø§Ù…ÙˆØ´ Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯?',0),(491115,13643,'pr','Ø±Ù…Ø² ÙˆØ±ÙˆØ¯ Ø®ÙˆØ¯ Ø±Ø§ ÙØ±Ø§Ù…ÙˆØ´ Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯?',0),(491116,13643,'tr','Åžifrenizi mi unuttunuz?',0),(491117,13643,'pl','Nie pamiÄ™tasz hasÅ‚a?',0),(491118,13643,'bg','Ð—Ð°Ð±Ñ€Ð°Ð²Ð¸Ð»Ð¸ ÑÑ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð°Ñ‚Ð° ÑÐ¸?',0),(491119,13643,'ur','Ø¢Ù¾ Ú©Ø§ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¨Ú¾ÙˆÙ„ Ú¯Ø¦Û’ ÛÛŒÚºØŸ',0),(491120,13643,'sr','Ð—Ð°Ð±Ð¾Ñ€Ð°Ð²Ð¸Ð»Ð¸ ÑÑ‚Ðµ ÑÐ²Ð¾Ñ˜Ñƒ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ?',0),(491121,13643,'vi','QuÃªn Máº­t kháº©u?',0),(491122,13643,'af','Jou wagwoord vergeet?',0),(491123,13643,'ro','Ai uitat parola?',0),(491124,13643,'et','Kas unustasid parooli?',0),(491125,13643,'si','Ste pozabili geslo?',0),(491126,13643,'ba','Lupa Kata Sandi Anda?',0),(491127,13643,'nl','Vergat uw wachtwoord?',0),(491128,13643,'fi','Unohditko salasanasi?',0),(491129,13643,'no','Har du glemt passordet?',0),(491130,13643,'da','Glemt din adgangskode?',0),(491131,13643,'ko','ë¹„ë°€ ë²ˆí˜¸ë¥¼ ìžŠìœ¼ì…¨ë‚˜ìš”?',0),(491132,13643,'he','×©×›×—×ª ×”×¡×™×¡×ž×?',0),(491133,13643,'el','ÎžÎ­Ï‡Î±ÏƒÎµÏ‚ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚?',0),(491134,13643,'zh','æ‚¨å¿˜è®°å¯†ç äº†å—ï¼Ÿ',0),(491135,13643,'sv','GlÃ¶mt ditt lÃ¶senord?',0),(491136,13643,'it','Hai dimenticato la password?',0),(491137,13643,'tl','',0),(491138,13643,'th','à¸¥à¸·à¸¡à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™',0),(491139,13643,'hi','à¤…à¤ªà¤¨à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤­à¥‚à¤² à¤—à¤?',0),(491140,13643,'ms','Lupa kata laluan anda?',0),(491141,13643,'ar','Ù‡Ù„ Ù†Ø³ÙŠØª ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø®Ø§ØµØ© Ø¨ÙƒØŸ',0),(491142,13643,'fr','Vous avez oubliÃ© votre mot de passe ?',0),(491143,13643,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’ãŠå¿˜ã‚Œã§ã™ã‹ï¼Ÿ',0),(491144,13643,'pt','Esqueceu sua senha?',0),(491145,13643,'ru','Ð—Ð°Ð±Ñ‹Ð»Ð¸ Ð²Ð°Ñˆ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ?',0),(491146,13643,'es','Se OlvidÃ³ su Password?',0),(491147,13643,'de','Passwort vergessen?',0),(491148,13643,'en','Forgot your password?',0),(491149,13644,'is','',0),(491150,13644,'dr','Ø´Ù…Ø§ Ø¨Ø±Ø§ÛŒ Ø¬Ø³ØªØ¬Ùˆ ÙˆØ§Ø±Ø¯ Ù…ÛŒ Ø´ÙˆØ¯ Ø¨Ø§ÛŒØ¯ Ø¯Ø±',0),(491151,13644,'pr','Ø´Ù…Ø§ Ø¨Ø±Ø§ÛŒ Ø¬Ø³ØªØ¬Ùˆ ÙˆØ§Ø±Ø¯ Ù…ÛŒ Ø´ÙˆØ¯ Ø¨Ø§ÛŒØ¯ Ø¯Ø±',0),(491152,13644,'tr','Arama yapmak iÃ§in oturum gerekir',0),(491153,13644,'pl','Musisz byÄ‡ zalogowany do wyszukiwania',0),(491154,13644,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑ‚Ðµ Ð»Ð¾Ð³Ð½Ð°Ñ‚Ð¸ Ð·Ð° Ð´Ð° Ñ‚ÑŠÑ€ÑÐ¸Ñ‚Ðµ',0),(491155,13644,'ur','Ø¢Ù¾ Ú©ÛŒ ØªÙ„Ø§Ø´ Ú©Û’ Ù„ÛŒÛ’ Ù„Ø§Ú¯ Ø§Ù† ÛÙˆÙ†Û’ Ù…ÛŒÚº',0),(491156,13644,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð¸ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(491157,13644,'vi','Báº¡n pháº£i Ä‘Äƒng nháº­p Ä‘á»ƒ tÃ¬m kiáº¿m',0),(491158,13644,'af','Jy moet aangeteken word om te soek',0),(491159,13644,'ro','Tu trebuie sa fii logat pentru a cÄƒuta',0),(491160,13644,'et','Sa pead olema sisselogitud, et otsida',0),(491161,13644,'si','Morate biti prijavljeni iskanje',0),(491162,13644,'ba','Anda harus login untuk mencari',0),(491163,13644,'nl','U moet ingelogd zijn om te zoeken',0),(491164,13644,'fi','Sinun tÃ¤ytyy olla kirjautuneena Etsi',0),(491165,13644,'no','Du mÃ¥ vÃ¦re logget inn for Ã¥ sÃ¸ke',0),(491166,13644,'da','Du skal vÃ¦re logget ind for at sÃ¸ge',0),(491167,13644,'ko','ë‹¹ì‹ ì´ ê²€ìƒ‰ ë¡œê·¸ì¸ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(491168,13644,'he','×¢×œ×™×š ×œ×”×™×•×ª ×ž×—×•×‘×¨ ×›×“×™ ×œ×—×¤×©',0),(491169,13644,'el','Î£Î±Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Î³Î¹Î± Î½Î± ÎºÎ¬Î½ÎµÏ„Îµ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(491170,13644,'zh','æ‚¨å¿…é¡»ç™»å½•åˆ°æœç´¢',0),(491171,13644,'sv','Du mÃ¥ste vara inloggad fÃ¶r att sÃ¶ka',0),(491172,13644,'it','Devi essere loggato per la ricerca',0),(491173,13644,'tl','',0),(491174,13644,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¹ƒà¸™à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²',0),(491175,13644,'hi','à¤†à¤ª à¤–à¥‹à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥‡à¤‚ à¤²à¥‰à¤— à¤‡à¤¨ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(491176,13644,'ms','Anda mesti log masuk untuk mencari',0),(491177,13644,'ar','ÙŠØ¬Ø¨ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¨Ø­Ø«',0),(491178,13644,'fr','Vous devez Ãªtre connectÃ© pour rechercher',0),(491179,13644,'jp','æ¤œç´¢ã™ã‚‹ã¯ãƒ­ã‚°ã‚¤ãƒ³ãŒå¿…è¦',0),(491180,13644,'pt','VocÃª deve estar logado para Pesquisar',0),(491181,13644,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð°Ð²Ñ‚Ð¾Ñ€Ð¸Ð·Ð¾Ð²Ð°Ñ‚ÑŒÑÑ Ð´Ð»Ñ Ð¿Ð¾Ð¸ÑÐºÐ°',0),(491182,13644,'es','Debes estar registrado para buscar',0),(491183,13644,'de','Sie mÃ¼ssen angemeldet sein, um zu suchen',0),(491184,13644,'en','You must be logged in to search',0),(491185,13645,'is','',0),(491186,13645,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù…ÙÙ‚ÙˆØ¯',0),(491187,13645,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù…ÙÙ‚ÙˆØ¯',0),(491188,13645,'tr','KayÄ±p ÅŸifre',0),(491189,13645,'pl','Brak hasÅ‚a',0),(491190,13645,'bg','Ð›Ð¸Ð¿ÑÐ²Ð°Ñ‰Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(491191,13645,'ur','ØºØ§Ø¦Ø¨ Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(491192,13645,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ° Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ',0),(491193,13645,'vi','Máº¥t máº­t kháº©u',0),(491194,13645,'af','Vermiste wagwoord',0),(491195,13645,'ro','ParolÄƒ lipsÄƒ',0),(491196,13645,'et','Parool puudub',0),(491197,13645,'si','ManjkajoÄe geslo',0),(491198,13645,'ba','Kehilangan Password',0),(491199,13645,'nl','Ontbrekende wachtwoord',0),(491200,13645,'fi','Salasana puuttuu',0),(491201,13645,'no','Mangler passord',0),(491202,13645,'da','Mangler adgangskode',0),(491203,13645,'ko','ëˆ„ë½ ëœ ì•”í˜¸',0),(491204,13645,'he','×—×¡×¨ ×¡×™×¡×ž×”',0),(491205,13645,'el','Î§Î±Î¼Î­Î½Î¿Ï‚ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚',0),(491206,13645,'zh','é—å¤±å¯†ç ',0),(491207,13645,'sv','Saknas lÃ¶senord',0),(491208,13645,'it','Password mancante',0),(491209,13645,'tl','',0),(491210,13645,'th','à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸«à¸²à¸¢à¹„à¸›',0),(491211,13645,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤—à¥à¤®',0),(491212,13645,'ms','Hilang kata laluan',0),(491213,13645,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ù…ÙÙ‚ÙˆØ¯Ø©',0),(491214,13645,'fr','Mot de passe manquant',0),(491215,13645,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(491216,13645,'pt','Falta a senha',0),(491217,13645,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ',0),(491218,13645,'es','Falta contraseÃ±a',0),(491219,13645,'de','Passwort fehlt',0),(491220,13645,'en','Missing Password',0),(491221,13646,'is','',0),(491222,13646,'dr','Ù†Ø§Ù… Ø³Ø§ÛŒØª Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡',0),(491223,13646,'pr','Ù†Ø§Ù… Ø³Ø§ÛŒØª Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡',0),(491224,13646,'tr','Site adÄ± eksik',0),(491225,13646,'pl','Brak nazwy witryny',0),(491226,13646,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° Ð¸Ð¼Ðµ Ð½Ð° ÑÐ°Ð¹Ñ‚',0),(491227,13646,'ur','ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ú©Ø§ Ù†Ø§Ù… ØºØ§Ø¦Ø¨',0),(491228,13646,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ð½Ð°Ð·Ð¸Ð² Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(491229,13646,'vi','Thiáº¿u tÃªn trang web',0),(491230,13646,'af','Webwerf naam ontbreek',0),(491231,13646,'ro','LipseÈ™te numele de site-ul',0),(491232,13646,'et','Puuduva saidi nimi',0),(491233,13646,'si','Manjka ime mesta',0),(491234,13646,'ba','Nama situs yang hilang',0),(491235,13646,'nl','Ontbrekende sitenaam',0),(491236,13646,'fi','Sivustonimi puuttuu',0),(491237,13646,'no','Mangler navn',0),(491238,13646,'da','Manglende navn pÃ¥ websted',0),(491239,13646,'ko','ëˆ„ë½ ëœ ì‚¬ì´íŠ¸ ì´ë¦„',0),(491240,13646,'he','×—×¡×¨×™× ×©× ×”××ª×¨',0),(491241,13646,'el','Î›ÎµÎ¯Ï€ÎµÎ¹ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±Ï‚',0),(491242,13646,'zh','ç¼ºå°‘ç«™ç‚¹åç§°',0),(491243,13646,'sv','Webbplatsnamn saknas',0),(491244,13646,'it','Manca il nome del sito',0),(491245,13646,'tl','',0),(491246,13646,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸Šà¸·à¹ˆà¸­à¹„à¸‹à¸•à¹Œ',0),(491247,13646,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤¨à¤¾à¤® à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§',0),(491248,13646,'ms','Nama tapak yang hilang',0),(491249,13646,'ar','Ø§Ø³Ù… Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ù…ÙÙ‚ÙˆØ¯',0),(491250,13646,'fr','Nom de Site manquant',0),(491251,13646,'jp','ã‚µã‚¤ãƒˆåãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(491252,13646,'pt','Falta o nome do Site',0),(491253,13646,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¸Ð¼Ñ ÑÐ°Ð¹Ñ‚Ð°',0),(491254,13646,'es','Falta el nombre del sitio',0),(491255,13646,'de','Site-Name fehlt',0),(491256,13646,'en','Missing Site Name',0),(491257,13647,'is','',0),(491258,13647,'dr','Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø± Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡',0),(491259,13647,'pr','Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø± Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡',0),(491260,13647,'tr','KullanÄ±cÄ± adÄ± eksik',0),(491261,13647,'pl','Brakuje nazwy uÅ¼ytkownika',0),(491262,13647,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ',0),(491263,13647,'ur','ØµØ§Ø±Ù Ù†Ø§Ù… ØºØ§Ø¦Ø¨',0),(491264,13647,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ',0),(491265,13647,'vi','Thiáº¿u tÃªn ngÆ°á»i dÃ¹ng',0),(491266,13647,'af','Gebruiker naam ontbreek',0),(491267,13647,'ro','LipseÈ™te numele de utilizator',0),(491268,13647,'et','Kasutajanimi on puudu',0),(491269,13647,'si','ManjkajoÄe uporabniÅ¡ko ime',0),(491270,13647,'ba','Nama pengguna hilang',0),(491271,13647,'nl','Ontbrekende gebruikersnaam',0),(491272,13647,'fi','KÃ¤yttÃ¤jÃ¤nimi puuttuu',0),(491273,13647,'no','Mangler brukernavn',0),(491274,13647,'da','Manglende Brugernavn',0),(491275,13647,'ko','ëˆ„ë½ ëœ ì‚¬ìš©ìž ì´ë¦„',0),(491276,13647,'he','×—×¡×¨×™× ×©× ×ž×©×ª×ž×©',0),(491277,13647,'el','Î›ÎµÎ¯Ï€ÎµÎ¹ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î·',0),(491278,13647,'zh','ç¼ºå°‘ç”¨æˆ·å',0),(491279,13647,'sv','AnvÃ¤ndarnamn saknas',0),(491280,13647,'it','Nome utente mancante',0),(491281,13647,'tl','',0),(491282,13647,'th','à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸—à¸µà¹ˆà¸‚à¸²à¸”à¸«à¸²à¸¢à¹„à¸›',0),(491283,13647,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§',0),(491284,13647,'ms','Nama pengguna yang hilang',0),(491285,13647,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù…ÙÙ‚ÙˆØ¯',0),(491286,13647,'fr','Nom d\'utilisateur manquant',0),(491287,13647,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼åãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(491288,13647,'pt','Faltando nome de usuÃ¡rio',0),(491289,13647,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¸Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(491290,13647,'es','Falta el nombre de usuario',0),(491291,13647,'de','Benutzername fehlt',0),(491292,13647,'en','Missing User Name',0),(491293,13648,'is','',0),(491294,13648,'dr','Ø§ÛŒÙ† Ø³Ø§ÛŒØª ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(491295,13648,'pr','Ø§ÛŒÙ† Ø³Ø§ÛŒØª ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(491296,13648,'tr','Bu site yok',0),(491297,13648,'pl','Ta strona nie istnieje',0),(491298,13648,'bg','Ð¢Ð¾Ð·Ð¸ ÑÐ°Ð¹Ñ‚ Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(491299,13648,'ur','Ø§Ø³ Ø³Ø§Ø¦Ù¹ Ú©Ø§ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(491300,13648,'sr','ÐžÐ²Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(491301,13648,'vi','Trang web nÃ y khÃ´ng tá»“n táº¡i',0),(491302,13648,'af','Hierdie webwerf bestaan nie',0),(491303,13648,'ro','Acest site nu existÄƒ',0),(491304,13648,'et','Sellel saidil pole olemas',0),(491305,13648,'si','Ta stran ne obstaja',0),(491306,13648,'ba','Situs ini tidak ada',0),(491307,13648,'nl','Deze site bestaat niet',0),(491308,13648,'fi','TÃ¤mÃ¤ sivusto ei ole',0),(491309,13648,'no','Dette omrÃ¥det finnes ikke',0),(491310,13648,'da','Dette websted findes ikke',0),(491311,13648,'ko','ì´ ì‚¬ì´íŠ¸ëŠ” ì¡´ìž¬ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(491312,13648,'he','××ª×¨ ×–×” ××™× ×• ×§×™×™×',0),(491313,13648,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ site Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹',0),(491314,13648,'zh','æœ¬ç½‘ç«™ä¸å­˜åœ¨',0),(491315,13648,'sv','Denna webbplats finns inte',0),(491316,13648,'it','Questo sito non esiste',0),(491317,13648,'tl','',0),(491318,13648,'th','à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(491319,13648,'hi','à¤‡à¤¸ à¤¸à¤¾à¤‡à¤Ÿ à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(491320,13648,'ms','Laman web ini tidak wujud',0),(491321,13648,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(491322,13648,'fr','Ce site n\'existe pas',0),(491323,13648,'jp','ã“ã®ã‚µã‚¤ãƒˆã¯å­˜åœ¨ã—ã¾ã›ã‚“',0),(491324,13648,'pt','Este site nÃ£o existe',0),(491325,13648,'ru','Ð­Ñ‚Ð¾Ñ‚ ÑÐ°Ð¹Ñ‚ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(491326,13648,'es','Este sitio no existe',0),(491327,13648,'de','Diese Seite existiert nicht',0),(491328,13648,'en','This site does not exist',0),(491329,13649,'is','',0),(491330,13649,'dr','Ø§Ø³Ø§Ø³ÛŒ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ',0),(491331,13649,'pr','Ø§Ø³Ø§Ø³ÛŒ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ',0),(491332,13649,'tr','Temel muhasebe',0),(491333,13649,'pl','KsiÄ™gowoÅ›Ä‡ podstawowa',0),(491334,13649,'bg','ÐžÑÐ½Ð¾Ð²Ð½Ð¸ ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´Ð½Ð¸',0),(491335,13649,'ur','Ø¨Ù†ÛŒØ§Ø¯ÛŒ Ú©ÛŒÙ¾Ù†Ú¯',0),(491336,13649,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð¸ ÐºÑšÐ¸Ð³Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(491337,13649,'vi','Sá»• sÃ¡ch káº¿ toÃ¡n cÆ¡ báº£n',0),(491338,13649,'af','Basiese boekhouding',0),(491339,13649,'ro','BazÄƒ contabilitate',0),(491340,13649,'et','Lihtne raamatupidamine',0),(491341,13649,'si','Osnovnih knjigovodstvu',0),(491342,13649,'ba','Pembukuan dasar',0),(491343,13649,'nl','Fundamentele boekhouding',0),(491344,13649,'fi','Perus kirjanpito',0),(491345,13649,'no','Grunnleggende bokfÃ¸ring',0),(491346,13649,'da','GrundlÃ¦ggende bogholderi',0),(491347,13649,'ko','ê¸°ë³¸ ë¶€ ê¸°',0),(491348,13649,'he','×”× ×”×œ×ª ×—×©×‘×•× ×•×ª ×‘×¡×™×¡×™',0),(491349,13649,'el','Î’Î±ÏƒÎ¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®',0),(491350,13649,'zh','åŸºæœ¬çš„ç°¿è®°',0),(491351,13649,'sv','GrundlÃ¤ggande bokfÃ¶ring',0),(491352,13649,'it','ContabilitÃ  di base',0),(491353,13649,'tl','',0),(491354,13649,'th','à¸ˆà¸±à¸”à¸—à¸³à¸šà¸±à¸à¸Šà¸µà¸žà¸·à¹‰à¸™à¸à¸²à¸™',0),(491355,13649,'hi','à¤†à¤§à¤¾à¤°à¤­à¥‚à¤¤ à¤¬à¤¹à¥€à¤–à¤¾à¤¤à¤¾ à¤ªà¤¦à¥à¤§à¤¤à¤¿',0),(491356,13649,'ms','Asas perakaunan',0),(491357,13649,'ar','Ø§Ù„Ø£Ø³Ø§Ø³ÙŠØ© ÙˆÙ…Ø³Ùƒ Ø§Ù„Ø¯ÙØ§ØªØ±',0),(491358,13649,'fr','ComptabilitÃ© de base',0),(491359,13649,'jp','åŸºæœ¬çš„ãªç°¿è¨˜',0),(491360,13649,'pt','Contabilidade bÃ¡sica',0),(491361,13649,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ðµ Ð±ÑƒÑ…Ð³Ð°Ð»Ñ‚ÐµÑ€ÑÐºÐ¸Ðµ',0),(491362,13649,'es','Contabilidad Basica',0),(491363,13649,'de','Grundlegende Buchhaltung',0),(491364,13649,'en','Basic bookkeeping',0),(491365,13650,'is','',0),(491366,13650,'dr','Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(491367,13650,'pr','Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(491368,13650,'tr','GeliÅŸmiÅŸ defter tutma',0),(491369,13650,'pl','KsiÄ™gowoÅ›Ä‡ zaawansowanych',0),(491370,13650,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¾ ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(491371,13650,'ur','Ø§Ø¹Ù„ÛŒ Ú©ÛŒÙ¾Ù†Ú¯',0),(491372,13650,'sr','Ð’Ð¸ÑˆÐµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð·Ð° ÐºÑšÐ¸Ð³Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(491373,13650,'vi','Sá»• sÃ¡ch káº¿ toÃ¡n nÃ¢ng cao',0),(491374,13650,'af','Gevorderde boekhouding',0),(491375,13650,'ro','Avansate de contabilitate',0),(491376,13650,'et','TÃ¤iustatud raamatupidamine',0),(491377,13650,'si','Napredno knjigovodstvo',0),(491378,13650,'ba','Lanjutan pembukuan',0),(491379,13650,'nl','Geavanceerde boekhouding',0),(491380,13650,'fi','Kehittynyt kirjanpito',0),(491381,13650,'no','Avansert bokfÃ¸ring',0),(491382,13650,'da','Avanceret bogholderi',0),(491383,13650,'ko','ê³ ê¸‰ ë¶€ ê¸°',0),(491384,13650,'he','×”× ×”×œ×ª ×—×©×‘×•× ×•×ª ×ž×ª×§×“×ž×ª',0),(491385,13650,'el','Î ÏÎ¿Ï‡Ï‰ÏÎ·Î¼Î­Î½Î· Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®',0),(491386,13650,'zh','é«˜çº§çš„ç°¿è®°',0),(491387,13650,'sv','Avancerad bokfÃ¶ring',0),(491388,13650,'it','ContabilitÃ  avanzata',0),(491389,13650,'tl','',0),(491390,13650,'th','à¸ˆà¸±à¸”à¸—à¸³à¸šà¸±à¸à¸Šà¸µà¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡',0),(491391,13650,'hi','à¤‰à¤¨à¥à¤¨à¤¤ à¤¬à¤¹à¥€à¤–à¤¾à¤¤à¤¾ à¤ªà¤¦à¥à¤§à¤¤à¤¿',0),(491392,13650,'ms','Lanjutan perakaunan',0),(491393,13650,'ar','Ø§Ù„Ù…Ø­Ø§Ø³Ø¨Ø© Ø§Ù„Ù…ØªÙ‚Ø¯Ù…Ø©',0),(491394,13650,'fr','ComptabilitÃ© avancÃ©e',0),(491395,13650,'jp','é«˜åº¦ãªç°¿è¨˜',0),(491396,13650,'pt','Contabilidade avanÃ§ada',0),(491397,13650,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð±ÑƒÑ…Ð³Ð°Ð»Ñ‚ÐµÑ€ÑÐºÐ¸Ðµ',0),(491398,13650,'es','Contabilidad Avanzada',0),(491399,13650,'de','Erweiterte Buchhaltung',0),(491400,13650,'en','Advanced Bookkeeping',0),(491401,13651,'is','',0),(491402,13651,'dr','Ù…Ù‚Ø§ÛŒØ³Ù‡ Ù…Ø­ØµÙˆÙ„Ø§Øª',0),(491403,13651,'pr','Ù…Ù‚Ø§ÛŒØ³Ù‡ Ù…Ø­ØµÙˆÙ„Ø§Øª',0),(491404,13651,'tr','ÃœrÃ¼n karÅŸÄ±laÅŸtÄ±rma',0),(491405,13651,'pl','PorÃ³wnanie produktÃ³w',0),(491406,13651,'bg','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚ ÑÑ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ',0),(491407,13651,'ur','Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©Û’ Ù…Ù‚Ø§Ø¨Ù„Û’',0),(491408,13651,'sr','ÐŸÐ¾Ñ€ÐµÑ’ÐµÑšÐµ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(491409,13651,'vi','So sÃ¡nh sáº£n pháº©m',0),(491410,13651,'af','Produk vergelyking',0),(491411,13651,'ro','Produs de comparare',0),(491412,13651,'et','Toote vÃµrdlus',0),(491413,13651,'si','ZmnoÅ¾ek primerjava',0),(491414,13651,'ba','Perbandingan produk',0),(491415,13651,'nl','Productvergelijking',0),(491416,13651,'fi','Tuotteiden vertailu',0),(491417,13651,'no','Fabrikat sammenligningen',0),(491418,13651,'da','Produktsammenligning',0),(491419,13651,'ko','ì œí’ˆ ë¹„êµ',0),(491420,13651,'he','×”×©×•×•××ª',0),(491421,13651,'el','Î£ÏÎ³ÎºÏÎ¹ÏƒÎ· Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Ï‰Î½',0),(491422,13651,'zh','äº§å“æ¯”è¾ƒ',0),(491423,13651,'sv','ProduktjÃ¤mfÃ¶relse',0),(491424,13651,'it','Confronto prodotti',0),(491425,13651,'tl','',0),(491426,13651,'th','à¹€à¸›à¸£à¸µà¸¢à¸šà¹€à¸—à¸µà¸¢à¸šà¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œ',0),(491427,13651,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤¤à¥à¤²à¤¨à¤¾',0),(491428,13651,'ms','Perbandingan produk',0),(491429,13651,'ar','Ù…Ù‚Ø§Ø±Ù†Ø© Ø§Ù„Ù…Ù†ØªØ¬',0),(491430,13651,'fr','Comparaison des produits',0),(491431,13651,'jp','è£½å“ã®æ¯”è¼ƒ',0),(491432,13651,'pt','ComparaÃ§Ã£o de produtos',0),(491433,13651,'ru','Ð¡Ñ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð²',0),(491434,13651,'es','ComparaciÃ³n de Productos',0),(491435,13651,'de','Produktvergleich',0),(491436,13651,'en','Product comparison',0),(491437,13652,'is','',0),(491438,13652,'dr','Ø¹Ù…Ù„ Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(491439,13652,'pr','Ø¹Ù…Ù„ Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(491440,13652,'tr','Sevkiyat yapÄ±lÄ±rken varsayÄ±lan eylem',0),(491441,13652,'pl','Akcja domyÅ›lna podczas wysyÅ‚ki',0),(491442,13652,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€Ð¸ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ñ',0),(491443,13652,'ur','Ø¬Ø¨ Ø´Ù¾Ù†Ú¯ Ø·Û’ Ø´Ø¯Û Ú©Ø§Ø±Ø±ÙˆØ§Ø¦ÛŒ',0),(491444,13652,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ñ€Ð°Ð´ÑšÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(491445,13652,'vi','HÃ nh Ä‘á»™ng máº·c Ä‘á»‹nh khi váº­n chuyá»ƒn',0),(491446,13652,'af','Verstekaksie toe gestuur',0),(491447,13652,'ro','AcÅ£iune Ã®n mod implicit atunci cÃ¢nd de transport maritim',0),(491448,13652,'et','Vaiketoimingu lÃ¤hetamisel',0),(491449,13652,'si','Privzeto dejanje pri dobavi',0),(491450,13652,'ba','Aksi default saat pengiriman',0),(491451,13652,'nl','De standaardactie bij verzending',0),(491452,13652,'fi','Oletustoiminnon toimitettaessa',0),(491453,13652,'no','Standardhandlingen nÃ¥r du sender',0),(491454,13652,'da','Standard aktionen ved forsendelse',0),(491455,13652,'ko','ë°°ì†¡ í•˜ëŠ” ê²½ìš°ì˜ ê¸°ë³¸ ë™ìž‘',0),(491456,13652,'he','×¤×¢×•×œ×ª ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×‘×¢×ª ×ž×©×œ×•×—',0),(491457,13652,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎµÎ½Î­ÏÎ³ÎµÎ¹Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(491458,13652,'zh','åœ¨è£…è¿æ—¶çš„é»˜è®¤æ“ä½œ',0),(491459,13652,'sv','StandardÃ¥tgÃ¤rden vid transport',0),(491460,13652,'it','Azione predefinita quando la spedizione',0),(491461,13652,'tl','',0),(491462,13652,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¹€à¸¡à¸·à¹ˆà¸­à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(491463,13652,'hi','à¤œà¤¬ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤•à¥à¤°à¤¿à¤¯à¤¾',0),(491464,13652,'ms','Tindakan lalai apabila penghantaran',0),(491465,13652,'ar','Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¹Ù†Ø¯ Ø§Ù„Ø´Ø­Ù†',0),(491466,13652,'fr','Action par dÃ©faut lorsque vous expÃ©diez',0),(491467,13652,'jp','å‡ºè·æ™‚ã®æ—¢å®šã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(491468,13652,'pt','AÃ§Ã£o padrÃ£o quando o transporte',0),(491469,13652,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¿Ñ€Ð¸ Ñ‚Ñ€Ð°Ð½ÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐµ',0),(491470,13652,'es','AcciÃ³n por Defecto Cuando Enviar',0),(491471,13652,'de','Standardaktion beim Versand',0),(491472,13652,'en','Default Action When Shipping',0),(491473,13653,'is','',0),(491474,13653,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ ÙˆÙ‚ØªÛŒ Ú©Ù‡ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù‡Ù…Ù‡ Ù…ÙˆØ§Ø±Ø¯ Ø±Ø§ Ø¨Ù‡ Ú©Ø§Ù…Ù„',0),(491475,13653,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ ÙˆÙ‚ØªÛŒ Ú©Ù‡ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù‡Ù…Ù‡ Ù…ÙˆØ§Ø±Ø¯ Ø±Ø§ Ø¨Ù‡ Ú©Ø§Ù…Ù„',0),(491476,13653,'tr','Zaman tÃ¼m maddeler sevk tamamlamak iÃ§in varsayÄ±lan',0),(491477,13653,'pl','DomyÅ›lne do peÅ‚na, gdy wszystkie elementy wysÅ‚ane',0),(491478,13653,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(491479,13653,'ur','Ø¬Ø¨ ØªÙ…Ø§Ù… Ø§Ø´ÛŒØ§Ø¡ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ù…Ú©Ù…Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û',0),(491480,13653,'sr','ÐÐ° ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ ÐºÐ°Ð´Ð° ÑÐ²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÑƒÑ˜Ñƒ',0),(491481,13653,'vi','Máº·c Ä‘á»‹nh Ä‘á»ƒ hoÃ n thÃ nh khi táº¥t cáº£ cÃ¡c má»¥c váº­n chuyá»ƒn',0),(491482,13653,'af','Verstek te voltooi wanneer alle Items Shipped',0),(491483,13653,'ro','Implicit la completÄƒ atunci cÃ¢nd toate elementele expediate',0),(491484,13653,'et','Vaikimisi tÃ¤ielik kui kÃµik kaubad lÃ¤hetada',0),(491485,13653,'si','Privzeto za popolno, kadar dobavljeni vsi artikli',0),(491486,13653,'ba','Default ke lengkap ketika semua item dikirim',0),(491487,13653,'nl','Standaard te vullen wanneer alle Items verzonden',0),(491488,13653,'fi','Oletusarvo on tÃ¤ydellinen kun kaikki nimikkeet',0),(491489,13653,'no','Standard fullstendig nÃ¥r alle varene leveres',0),(491490,13653,'da','Standard komplet nÃ¥r alle varer leveret',0),(491491,13653,'ko','ëª¨ë“  í’ˆëª©ì€ ë°œì†¡ í•˜ëŠ” ê²½ìš° ê¸°ë³¸ì ìœ¼ë¡œ ì™„ë£Œ',0),(491492,13653,'he','×›×‘×¨×™×¨×ª ×ž×—×“×œ ×ž×œ××” ×›××©×¨ ×›×œ ×”×¤×¨×™×˜×™× ×©× ×©×œ×—×•',0),(491493,13653,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î½Î± ÎµÎ¯Î½Î±Î¹ Ï€Î»Î®ÏÎ·Ï‚, ÏŒÏ„Î±Î½ ÏŒÎ»Î± Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(491494,13653,'zh','é»˜è®¤ä¸ºå®Œæˆæ‰€æœ‰é¡¹ç›®éƒ½å‘è´§æ—¶',0),(491495,13653,'sv','StandardvÃ¤rdet Ã¤r komplett nÃ¤r alla objekt levereras',0),(491496,13653,'it','Predefinito al completo quando tutti gli articoli spediti',0),(491497,13653,'tl','',0),(491498,13653,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ˆà¸°à¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œà¹€à¸¡à¸·à¹ˆà¸­à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(491499,13653,'hi','à¤œà¤¬ à¤¸à¤­à¥€ à¤†à¤‡à¤Ÿà¤® à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤ªà¥‚à¤°à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(491500,13653,'ms','Lalai untuk selesai apabila semua item dihantar',0),(491501,13653,'ar','Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ø¨Ø§Ù„ÙƒØ§Ù…Ù„ Ø¹Ù†Ø¯ Ø´Ø­Ù† Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(491502,13653,'fr','Par dÃ©faut Ã  complÃ¨te lorsque tous les articles expÃ©diÃ©s',0),(491503,13653,'jp','å®Œå…¨ãªã™ã¹ã¦ã®é …ç›®ã®å‡ºè·æ™‚ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã—ã¾ã™ã€‚',0),(491504,13653,'pt','O padrÃ£o completo quando todos os itens enviados',0),(491505,13653,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¿Ð¾Ð»Ð½Ð¾Ðµ, ÐºÐ¾Ð³Ð´Ð° Ð²ÑÐµ Ñ‚Ð¾Ð²Ð°Ñ€Ñ‹ Ð´Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(491506,13653,'es','AcciÃ³n por Defecto Cuando Enviar Todos Los Items',0),(491507,13653,'de','Standard, komplett, wenn alle Einzelteile',0),(491508,13653,'en','Default To Complete When All Items Shipped',0),(491509,13654,'is','',0),(491510,13654,'dr','Ù‡Ù…ÛŒØ´Ù‡ Ø¨Ù‡ Ù†Ø§Ù‚Øµ Ù¾ÛŒØ´ ÙØ±Ø¶',0),(491511,13654,'pr','Ù‡Ù…ÛŒØ´Ù‡ Ø¨Ù‡ Ù†Ø§Ù‚Øµ Ù¾ÛŒØ´ ÙØ±Ø¶',0),(491512,13654,'tr','Her zaman eksik iÃ§in varsayÄ±lan',0),(491513,13654,'pl','DomyÅ›lnie niekompletne zawsze',0),(491514,13654,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð½ÐµÐ¿ÑŠÐ»Ð½Ð¸ Ð²Ð¸Ð½Ð°Ð³Ð¸',0),(491515,13654,'ur','Ù†Ø§Ù…Ú©Ù…Ù„ Ú©Ùˆ ÛÙ…ÛŒØ´Û Ø·Û’ Ø´Ø¯Û',0),(491516,13654,'sr','Ð£Ð²ÐµÐº Ð½Ð° Ð½ÐµÐ¿Ð¾Ñ‚Ð¿ÑƒÐ½Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸',0),(491517,13654,'vi','Máº·c Ä‘á»‹nh khÃ´ng Ä‘áº§y Ä‘á»§ luÃ´n luÃ´n',0),(491518,13654,'af','Verstek altyd om onvolledige',0),(491519,13654,'ro','Implicit la incomplet Ã®ntotdeauna',0),(491520,13654,'et','Vaikimisi puudulik alati',0),(491521,13654,'si','Nepopolna vedno privzeto',0),(491522,13654,'ba','Default ke lengkap selalu',0),(491523,13654,'nl','Standaard ingesteld op onvolledige altijd',0),(491524,13654,'fi','Oletusarvon mukaan epÃ¤tÃ¤ydellinen aina',0),(491525,13654,'no','Standard ufullstendig alltid',0),(491526,13654,'da','Standard til ufuldstÃ¦ndige altid',0),(491527,13654,'ko','í•­ìƒ ê¸°ë³¸ì ìœ¼ë¡œ ë¶ˆì™„ì „ í•œ',0),(491528,13654,'he','×›×‘×¨×™×¨×ª ×ž×—×“×œ ×œ× ×©×œ× ×ª×ž×™×“',0),(491529,13654,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® ÏƒÎµ ÎµÎ»Î»Î¹Ï€Î® Ï€Î¬Î½Ï„Î±',0),(491530,13654,'zh','æ€»æ˜¯é»˜è®¤ä¸ºä¸å®Œæ•´',0),(491531,13654,'sv','Standard till ofullstÃ¤ndig alltid',0),(491532,13654,'it','Default sempre a incompleta',0),(491533,13654,'tl','',0),(491534,13654,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ˆà¸°à¹„à¸¡à¹ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œà¹€à¸ªà¸¡à¸­',0),(491535,13654,'hi','à¤¹à¤®à¥‡à¤¶à¤¾ à¤…à¤§à¥‚à¤°à¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(491536,13654,'ms','Lalai untuk tidak lengkap sentiasa',0),(491537,13654,'ar','Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¥Ù„Ù‰ Ù†Ø§Ù‚ØµØ© Ø¯Ø§Ø¦Ù…Ø§Ù‹',0),(491538,13654,'fr','Par dÃ©faut Ã  incomplet toujours',0),(491539,13654,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã®ä¸å®Œå…¨å¸¸ã«',0),(491540,13654,'pt','PadrÃ£o sempre incompleta',0),(491541,13654,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ Ð½ÐµÐ¿Ð¾Ð»Ð½Ð¾Ð¹ Ð²ÑÐµÐ³Ð´Ð°',0),(491542,13654,'es','AcciÃ³n por Defecto Para no Completar Siempre',0),(491543,13654,'de','StandardmÃ¤ÃŸig auf unvollstÃ¤ndige immer',0),(491544,13654,'en','Default To Incomplete Always',0),(491545,13655,'is','',0),(491546,13655,'dr','Ù†Ù…Ø§ÛŒØ´ Ù‡Ù…Ù‡ Ù…ÙˆØ§Ø±Ø¯ Ø§Ø² Ø¬Ù…Ù„Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø­Ù…Ù„',0),(491547,13655,'pr','Ù†Ù…Ø§ÛŒØ´ Ù‡Ù…Ù‡ Ù…ÙˆØ§Ø±Ø¯ Ø§Ø² Ø¬Ù…Ù„Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø­Ù…Ù„',0),(491548,13655,'tr','Sevk dahil olmak Ã¼zere tÃ¼m Ã¶ÄŸeleri gÃ¶ster',0),(491549,13655,'pl','PokaÅ¼ wszystkie elementy w tym juÅ¼ wysÅ‚ane',0),(491550,13655,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð²ÐµÑ‡Ðµ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸',0),(491551,13655,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ø³Ù…ÛŒØª ØªÙ…Ø§Ù… Ø§Ø´ÛŒØ§ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(491552,13655,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ, ÑƒÐºÑ™ÑƒÑ‡ÑƒÑ˜ÑƒÑ›Ð¸ Ð¸ Ð²ÐµÑ› Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ðµ',0),(491553,13655,'vi','Hiá»‡n má»i khoáº£n má»¥c bao gá»“m Ä‘Ã£ váº­n chuyá»ƒn',0),(491554,13655,'af','Wys alle Items insluitend reeds Shipped',0),(491555,13655,'ro','AratÄƒ toate elementele inclusiv deja expediate',0),(491556,13655,'et','Kuva kÃµik Ã¼ksused, sealhulgas juba tarnitud',0),(491557,13655,'si','PrikaÅ¾i vse elemente, vkljuÄno z Å¾e dobavljen',0),(491558,13655,'ba','Tampilkan semua item, termasuk sudah dikirimkan',0),(491559,13655,'nl','Toon alle objecten, inclusief reeds verzonden',0),(491560,13655,'fi','NÃ¤ytÃ¤ kaikki kohteet kuten aiemmin toimitettu',0),(491561,13655,'no','Vis alle elementer inkludert allerede sendt',0),(491562,13655,'da','Vis alle varer herunder allerede afsendt',0),(491563,13655,'ko','ì´ë¯¸ ë°°ì†¡ì„ í¬í•¨ í•œ ëª¨ë“  í•­ëª© í‘œì‹œ',0),(491564,13655,'he','×”×¦×’ ××ª ×›×œ ×”×¤×¨×™×˜×™× ×›×•×œ×œ ×ž×›×¨×” ×›×‘×¨',0),(491565,13655,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î±Î½Î¿Î¼Î­Î½Ï‰Î½ Ï„Ï‰Î½ Î®Î´Î· Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯',0),(491566,13655,'zh','æ˜¾ç¤ºæ‰€æœ‰é¡¹ç›®ï¼ŒåŒ…æ‹¬å·²ç»å‘è¿',0),(491567,13655,'sv','Visa alla artiklar inklusive redan levereras',0),(491568,13655,'it','Visualizza tutti gli articoli compresi giÃ  spediti',0),(491569,13655,'tl','',0),(491570,13655,'th','à¹à¸ªà¸”à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸£à¸§à¸¡à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹à¸¥à¹‰à¸§',0),(491571,13655,'hi','à¤ªà¤¹à¤²à¥‡ à¤¹à¥€ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤¸à¤¹à¤¿à¤¤ à¤¸à¤­à¥€ à¤†à¤‡à¤Ÿà¤® à¤¦à¤¿à¤–à¤¾à¤à¤',0),(491572,13655,'ms','Tunjuk semua butiran termasuk sudah dihantar',0),(491573,13655,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙƒØ§ÙØ© Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø¨Ù…Ø§ ÙÙŠ Ø°Ù„Ùƒ Ø´Ø­Ù†Øª Ø¨Ø§Ù„ÙØ¹Ù„',0),(491574,13655,'fr','Afficher tous les Ã©lÃ©ments y compris dÃ©jÃ  expÃ©diÃ©',0),(491575,13655,'jp','æ—¢ã«å‡ºè·ã‚’å«ã‚€ã™ã¹ã¦ã®ã‚¢ã‚¤ãƒ†ãƒ ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(491576,13655,'pt','Mostrar todos os itens inclusive jÃ¡ embarcado',0),(491577,13655,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð²ÑÐµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹, Ð²ÐºÐ»ÑŽÑ‡Ð°Ñ ÑƒÐ¶Ðµ Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½Ñ‹',0),(491578,13655,'es','Muestra Todos los Items Incluyendo Las Cosas Ya Enviados',0),(491579,13655,'de','Zeigen Sie alle Elemente einschlieÃŸlich bereits ausgeliefert',0),(491580,13655,'en','Show All Items Including Already Shipped',0),(491581,13656,'is','',0),(491582,13656,'dr','Ù†Ù…Ø§ÛŒØ´ Ù…ÙˆØ§Ø±Ø¯ ØªÙ†Ù‡Ø§ Ø¨Ù‡ Ø­Ù…Ù„ Ø´ÙˆØ¯',0),(491583,13656,'pr','Ù†Ù…Ø§ÛŒØ´ Ù…ÙˆØ§Ø±Ø¯ ØªÙ†Ù‡Ø§ Ø¨Ù‡ Ø­Ù…Ù„ Ø´ÙˆØ¯',0),(491584,13656,'tr','Sadece sevk edilecek Ã¶ÄŸeleri',0),(491585,13656,'pl','PokaÅ¼ tylko przedmioty majÄ… byÄ‡ wysÅ‚ane',0),(491586,13656,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸',0),(491587,13656,'ur','ØµØ±Ù Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø´ÛŒØ§ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(491588,13656,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÑÑ‚Ð°Ð²ÐºÐµ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(491589,13656,'vi','Hiá»ƒn thá»‹ cÃ¡c chá»‰ má»¥c Ä‘Æ°á»£c váº­n chuyá»ƒn',0),(491590,13656,'af','Wys slegs Items word Shipped',0),(491591,13656,'ro','AfiÈ™are elemente numai pentru a fi livrate',0),(491592,13656,'et','NÃ¤ita ainult saadetisi lÃ¤hetatakse',0),(491593,13656,'si','PokaÅ¾i samo elemente Å¾elite dobaviti',0),(491594,13656,'ba','Tampilkan hanya item untuk dikirim',0),(491595,13656,'nl','Toon alleen Items worden verzonden',0),(491596,13656,'fi','NÃ¤ytÃ¤ toimitettavien nimikkeiden',0),(491597,13656,'no','Vis bare elementer sendes',0),(491598,13656,'da','Vis kun elementer, der skal leveres',0),(491599,13656,'ko','ë°°ì†¡ í•­ëª©ë§Œ í‘œì‹œ',0),(491600,13656,'he','×”×¦×’ ×¨×§ ×¤×¨×™×˜×™× ×©×™×© ×œ×©×œ×•×—',0),(491601,13656,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ ÎµÎ¯Î´Î· Ï€Î¿Ï… Î¸Î± Î±Ï€Î¿ÏƒÏ„Î±Î»Î¿ÏÎ½',0),(491602,13656,'zh','æ˜¾ç¤ºä»…é¡¹ç›®è¢«è¿',0),(491603,13656,'sv','Visa endast objekt som ska levereras',0),(491604,13656,'it','Visualizza solo gli elementi per essere spediti',0),(491605,13656,'tl','',0),(491606,13656,'th','à¹à¸ªà¸”à¸‡à¹€à¸‰à¸žà¸²à¸°à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¸ˆà¸±à¸”',0),(491607,13656,'hi','à¤†à¤‡à¤Ÿà¤® à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‡à¤µà¤² à¤¦à¤¿à¤–à¤¾à¤à¤',0),(491608,13656,'ms','Menunjukkan hanya barang-barang untuk dihantar',0),(491609,13656,'ar','ØªØ¸Ù‡Ø± \"ÙÙ‚Ø· Ø§Ù„Ø¹Ù†Ø§ØµØ±\" Ø§Ù„ØªÙŠ Ø³ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(491610,13656,'fr','Afficher seulement les articles Ã  livrer',0),(491611,13656,'jp','å‡ºè·ã™ã‚‹ã‚¢ã‚¤ãƒ†ãƒ ã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(491612,13656,'pt','Mostrar apenas os itens a ser enviado',0),(491613,13656,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð±Ñ‹Ñ‚ÑŒ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(491614,13656,'es','Muestra Solo Items Para Enviar',0),(491615,13656,'de','Zeigen Sie nur Artikel zu versendende an',0),(491616,13656,'en','Show Only Items to be Shipped',0),(491617,13657,'is','',0),(491618,13657,'dr','Ø¢Ù†Ú†Ù‡ Ø¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù„ÛŒØ· Ù†Ù…Ø§ÛŒØ´',0),(491619,13657,'pr','Ø¢Ù†Ú†Ù‡ Ø¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù„ÛŒØ· Ù†Ù…Ø§ÛŒØ´',0),(491620,13657,'tr','Ne seÃ§im bilet gÃ¶ster',0),(491621,13657,'pl','PokaÅ¼ co odebraÄ‡ bilety',0),(491622,13657,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ°ÐºÐ²Ð¾ Ð½Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð±Ð¸Ð»ÐµÑ‚Ð¸',0),(491623,13657,'ur','Ú©ÛŒØ§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù¹Ú©Ù¹ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(491624,13657,'sr','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑˆÑ‚Ð° Ð½Ð° Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ðµ',0),(491625,13657,'vi','Hiá»ƒn thá»‹ nhá»¯ng gÃ¬ trÃªn chá»n vÃ©',0),(491626,13657,'af','Wys wat op Pick kaartjies',0),(491627,13657,'ro','Ceea ce AratÄƒ biletele de Pick',0),(491628,13657,'et','NÃ¤ita mida noppimise piletid',0),(491629,13657,'si','Kaj kaÅ¾ejo na Pick vstopnice',0),(491630,13657,'ba','Menunjukkan apa mengambil tiket',0),(491631,13657,'nl','Toon wat op Pick Tickets',0),(491632,13657,'fi','NÃ¤yttÃ¤Ã¤ mitÃ¤ poimia lippuja',0),(491633,13657,'no','Vise hva pÃ¥ plukke billetter',0),(491634,13657,'da','Vis hvad pÃ¥ Pick billetter',0),(491635,13657,'ko','ì„ íƒ í‹°ì¼“ì— ë¬´ì—‡ì„ í‘œì‹œí•©ë‹ˆë‹¤',0),(491636,13657,'he','××¨××” ×ž×” ×œ××¡×•×£ ×›×¨×˜×™×¡×™×',0),(491637,13657,'el','Î¤Î¹ Î´ÎµÎ¯Ï‡Î½Î¿Ï…Î½ ÏƒÏ„Î¿ Pick ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î±',0),(491638,13657,'zh','åœ¨æŒ‘é€‰ç¥¨ä¸Šæ˜¾ç¤ºä»€ä¹ˆ',0),(491639,13657,'sv','Visa vad pÃ¥ Pick biljetter',0),(491640,13657,'it','Mostrare che cosa sui Pick biglietti',0),(491641,13657,'tl','',0),(491642,13657,'th','à¹à¸ªà¸”à¸‡à¸§à¹ˆà¸²à¹ƒà¸šà¸£à¸±à¸šà¸‚à¸­à¸‡',0),(491643,13657,'hi','à¤•à¥à¤¯à¤¾ à¤‰à¤ à¤¾à¤“ à¤Ÿà¤¿à¤•à¤Ÿ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(491644,13657,'ms','Tunjuk apa Tiket-Tiket pengangkutan',0),(491645,13657,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù…Ø§ ÙÙŠ ØªØ°Ø§ÙƒØ± Ø¨ÙŠÙƒ',0),(491646,13657,'fr','Montrer ce que sur les Tickets de prÃ©lÃ¨vement',0),(491647,13657,'jp','ãƒ”ãƒƒã‚¯ã®ãƒã‚±ãƒƒãƒˆã«ä½•ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(491648,13657,'pt','Mostrar que no picador de bilhetes',0),(491649,13657,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ, Ñ‡Ñ‚Ð¾ Ð½Ð° Ð·Ð°Ð±Ñ€Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚Ñ‹',0),(491650,13657,'es','Muestra Que en Boletos de Pick',0),(491651,13657,'de','Was auf Pick-Tickets anzeigen',0),(491652,13657,'en','Show What on Pick Tickets',0),(491653,13658,'is','',0),(491654,13658,'dr','Ú©Ø§Ø± Ø¨Ù„ÛŒØ· Ù¾Ø§ÛŒÛŒÙ† Ù…ØªÙ†',0),(491655,13658,'pr','Ú©Ø§Ø± Ø¨Ù„ÛŒØ· Ù¾Ø§ÛŒÛŒÙ† Ù…ØªÙ†',0),(491656,13658,'tr','Ä°ÅŸ bilet alt metin',0),(491657,13658,'pl','Tekst na dole strony bilet zadania',0),(491658,13658,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð±Ð¸Ð»ÐµÑ‚ Ð¾Ñ‚Ð´Ð¾Ð»Ñƒ Ñ‚ÐµÐºÑÑ‚',0),(491659,13658,'ur','Ø¬Ø§Ø¨ Ù¹Ú©Ù¹ Ù¾Ø§ÛŒØ§Ù† Ù…ØªÙ†',0),(491660,13658,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÐºÐ°Ñ€Ñ‚Ð° Ð´Ð½Ð° Ñ‚ÐµÐºÑÑ‚',0),(491661,13658,'vi','Viá»‡c lÃ m lo vÃ© dÆ°á»›i cÃ¹ng vÄƒn báº£n',0),(491662,13658,'af','Werk kaartjie onderste teks',0),(491663,13658,'ro','Job Ticket jos Text',0),(491664,13658,'et','TÃ¶Ã¶ Piletite alt tekst',0),(491665,13658,'si','Delo vozovnice dno besedila',0),(491666,13658,'ba','Pekerjaan tiket bawah teks',0),(491667,13658,'nl','Job Ticket onder tekst',0),(491668,13658,'fi','TyÃ¶ lippu alhaalla teksti',0),(491669,13658,'no','Jobb billett bunnen tekst',0),(491670,13658,'da','Job billet nederste tekst',0),(491671,13658,'ko','ìž‘ì—… í‹°ì¼“ í•˜ë‹¨ í…ìŠ¤íŠ¸',0),(491672,13658,'he','×˜×§×¡×˜ ×ª×—×ª×•×Ÿ ×›×¨×˜×™×¡ ×¢×‘×•×“×”',0),(491673,13658,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿ ÎºÎ¬Ï„Ï‰ ÎºÎµÎ¯Î¼ÎµÎ½Î¿',0),(491674,13658,'zh','å·¥ä½œç¥¨ä¸Šä¸‹åž‹çŽ¯ç»•æ–‡å­—',0),(491675,13658,'sv','Jobb biljett botten Text',0),(491676,13658,'it','Job Ticket fondo testo',0),(491677,13658,'tl','',0),(491678,13658,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡à¸‚à¸­à¸‡à¸šà¸±à¸•à¸£à¸‡à¸²à¸™',0),(491679,13658,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤Ÿà¤¿à¤•à¤Ÿ à¤¨à¥€à¤šà¥‡ à¤ªà¤¾à¤ ',0),(491680,13658,'ms','Kerja Tiket bawah teks',0),(491681,13658,'ar','ÙˆØ¸ÙŠÙØ© Ø­Ø¬Ø² Ø§Ù„ØªØ°Ø§ÙƒØ± Ø£Ø³ÙÙ„ Ø§Ù„Ù†Øµ',0),(491682,13658,'fr','Job Ticket fond texte',0),(491683,13658,'jp','ã‚¸ãƒ§ãƒ– ãƒã‚±ãƒƒãƒˆã®ä¸‹ã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(491684,13658,'pt','Trabalho passagem inferior texto',0),(491685,13658,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð±Ð¸Ð»ÐµÑ‚ Ð½Ð¸Ð¶Ð½Ð¸Ð¹ Ñ‚ÐµÐºÑÑ‚',0),(491686,13658,'es','Texto Abajo del Boleto de Trabajo',0),(491687,13658,'de','Job Ticket unteren Text',0),(491688,13658,'en','Job Ticket Bottom Text',0),(491689,13659,'is','',0),(491690,13659,'dr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ø§Ø¹ØªØ¨Ø§Ø±',0),(491691,13659,'pr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ø§Ø¹ØªØ¨Ø§Ø±',0),(491692,13659,'tr','Alacak dekontu',0),(491693,13659,'pl','Faktury korygujÄ…cej',0),(491694,13659,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ðµ',0),(491695,13659,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ù†ÙˆÙ¹',0),(491696,13659,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÑšÐµ',0),(491697,13659,'vi','TÃ­n dá»¥ng lÆ°u Ã½',0),(491698,13659,'af','Kredietnota',0),(491699,13659,'ro','NotÄƒ de credit',0),(491700,13659,'et','Kreeditarve',0),(491701,13659,'si','Dobropisa',0),(491702,13659,'ba','Catatan kredit',0),(491703,13659,'nl','Tegoedbon',0),(491704,13659,'fi','Hyvityslasku',0),(491705,13659,'no','Kreditnota',0),(491706,13659,'da','Kreditnota',0),(491707,13659,'ko','ì‹ ìš© ì°¸ê³ ',0),(491708,13659,'he','×ª×¢×•×“×ª ×–×™×›×•×™',0),(491709,13659,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ ÏƒÎ·Î¼ÎµÎ¯Ï‰Î¼Î±',0),(491710,13659,'zh','è´·æ–¹é€šçŸ¥å•',0),(491711,13659,'sv','Kreditfaktura',0),(491712,13659,'it','Nota di accredito',0),(491713,13659,'tl','',0),(491714,13659,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­',0),(491715,13659,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¨à¥‹à¤Ÿ',0),(491716,13659,'ms','Nota kredit',0),(491717,13659,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø¯Ø§Ø¦Ù†',0),(491718,13659,'fr','Note de crÃ©dit',0),(491719,13659,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ãƒ¡ãƒ¢',0),(491720,13659,'pt','Nota de crÃ©dito',0),(491721,13659,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚-Ð½Ð¾Ñ‚Ð°',0),(491722,13659,'es','Nota de CrÃ©dito',0),(491723,13659,'de','Gutschrift',0),(491724,13659,'en','Credit Note',0),(491725,13660,'is','',0),(491726,13660,'dr','ØªØ¬Ø§Ø±ÛŒ',0),(491727,13660,'pr','ØªØ¬Ø§Ø±ÛŒ',0),(491728,13660,'tr','Ticari',0),(491729,13660,'pl','Handlowych',0),(491730,13660,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸',0),(491731,13660,'ur','ØªØ¬Ø§Ø±ØªÛŒ',0),(491732,13660,'sr','ÐšÐ¾Ð¼ÐµÑ€Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸',0),(491733,13660,'vi','ThÆ°Æ¡ng máº¡i',0),(491734,13660,'af','KommersiÃ«le',0),(491735,13660,'ro','Comerciale',0),(491736,13660,'et','Kaubik',0),(491737,13660,'si','Komercialni',0),(491738,13660,'ba','Komersial',0),(491739,13660,'nl','CommerciÃ«le',0),(491740,13660,'fi','Kaupallinen',0),(491741,13660,'no','Kommersielle',0),(491742,13660,'da','Kommercielle',0),(491743,13660,'ko','ìƒì—…',0),(491744,13660,'he','×ž×¡×—×¨×™',0),(491745,13660,'el','Î•Î¼Ï€Î¿ÏÎ¹ÎºÎ®',0),(491746,13660,'zh','å•†ä¸š',0),(491747,13660,'sv','Kommersiella',0),(491748,13660,'it','Commerciale',0),(491749,13660,'tl','',0),(491750,13660,'th','à¸žà¸²à¸“à¸´à¸Šà¸¢à¹Œ',0),(491751,13660,'hi','à¤µà¤¾à¤£à¤¿à¤œà¥à¤¯à¤¿à¤•',0),(491752,13660,'ms','Komersil',0),(491753,13660,'ar','Ø§Ù„ØªØ¬Ø§Ø±ÙŠ',0),(491754,13660,'fr','Commercial',0),(491755,13660,'jp','å•†æ¥­',0),(491756,13660,'pt','Comercial',0),(491757,13660,'ru','ÐšÐ¾Ð¼Ð¼ÐµÑ€Ñ‡ÐµÑÐºÐ¸Ðµ',0),(491758,13660,'es','Comercial',0),(491759,13660,'de','Kommerzielle',0),(491760,13660,'en','Commercial',0),(491761,13661,'is','',0),(491762,13661,'dr','Ø¨Ø§Ø²Ø±Ú¯Ø§Ù†ÛŒ ÛŒØ§ Ù…Ø³Ú©ÙˆÙ†ÛŒ',0),(491763,13661,'pr','Ø¨Ø§Ø²Ø±Ú¯Ø§Ù†ÛŒ ÛŒØ§ Ù…Ø³Ú©ÙˆÙ†ÛŒ',0),(491764,13661,'tr','Ticari veya konut',0),(491765,13661,'pl','Komercyjnych i mieszkalnych',0),(491766,13661,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¸Ð»Ð¸ Ð¶Ð¸Ð»Ð¸Ñ‰Ð½Ð¸',0),(491767,13661,'ur','Ú©ÙˆÙ…Ø±Ø§Ú©Ø§Ù„ ÛŒØ§ Ø±ÛØ§Ø¦Ø´ÛŒ',0),(491768,13661,'sr','Ð¦Ð¾Ð¼Ð¼ÐµÑ€Ð¸Ñ†Ð°Ð» Ð¸Ð»Ð¸ ÑÑ‚Ð°Ð¼Ð±ÐµÐ½Ð¾',0),(491769,13661,'vi','ThÆ°Æ¡ng máº¡i hoáº·c khu dÃ¢n cÆ°',0),(491770,13661,'af','KommersiÃ«el of ResidensiÃ«el',0),(491771,13661,'ro','Comerciale sau rezidenÅ£iale',0),(491772,13661,'et','Turul tekkivale vÃµi elamu',0),(491773,13661,'si','Komercialni ali stanovanjski',0),(491774,13661,'ba','Komersial atau perumahan',0),(491775,13661,'nl','CommerciÃ«le of residentiÃ«le',0),(491776,13661,'fi','Kaupallisen tai asuin',0),(491777,13661,'no','Kommersielle eller bolig',0),(491778,13661,'da','Kommercielle eller bolig',0),(491779,13661,'ko','ìƒì—… ë˜ëŠ” ì£¼ê±°',0),(491780,13661,'he','×ž×¡×—×¨×™ ××• ×ž×’×•×¨×™×',0),(491781,13661,'el','Commerical Î® Î¿Î¹ÎºÎ¹ÏƒÏ„Î¹ÎºÎ®',0),(491782,13661,'zh','å•†ä¸šæˆ–ä½å®…',0),(491783,13661,'sv','Kommersiella eller bostadsomrÃ¥den',0),(491784,13661,'it','Commerciale o residenziale',0),(491785,13661,'tl','',0),(491786,13661,'th','à¸à¸²à¸£ à¸«à¸£à¸·à¸­à¸­à¸¢à¸¹à¹ˆà¸­à¸²à¸¨à¸±à¸¢',0),(491787,13661,'hi','à¤µà¤¾à¤£à¤¿à¤œà¥à¤¯à¤¿à¤• à¤¯à¤¾ à¤†à¤µà¤¾à¤¸à¥€à¤¯',0),(491788,13661,'ms','Dengan kemampuan atau kediaman',0),(491789,13661,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ¬Ø§Ø±ÙŠØ© Ø£Ùˆ Ø³ÙƒÙ†ÙŠØ©',0),(491790,13661,'fr','Commercial ou rÃ©sidentiel',0),(491791,13661,'jp','å•†æ¥­ã‹ä½å®…',0),(491792,13661,'pt','Comercial ou residencial',0),(491793,13661,'ru','ÐšÐ¾Ð¼Ð¼ÐµÑ€Ñ‡ÐµÑÐºÐ¸Ðµ Ð¸Ð»Ð¸ Ð¶Ð¸Ð»Ñ‹Ðµ',0),(491794,13661,'es','Comercial o Residencial',0),(491795,13661,'de','Kommerzielle oder private',0),(491796,13661,'en','Commerical or Residential',0),(491797,13662,'is','',0),(491798,13662,'dr','Ù…Ø³Ú©ÙˆÙ†ÛŒ',0),(491799,13662,'pr','Ù…Ø³Ú©ÙˆÙ†ÛŒ',0),(491800,13662,'tr','Konut',0),(491801,13662,'pl','Mieszkalnych',0),(491802,13662,'bg','Ð–Ð¸Ð»Ð¸Ñ‰Ð½Ð¸',0),(491803,13662,'ur','Ø±ÛØ§Ø¦Ø´ÛŒ',0),(491804,13662,'sr','Ð¡Ñ‚Ð°Ð¼Ð±ÐµÐ½Ð¸',0),(491805,13662,'vi','Khu dÃ¢n cÆ°',0),(491806,13662,'af','ResidensiÃ«le',0),(491807,13662,'ro','Rezidential',0),(491808,13662,'et','Elamu',0),(491809,13662,'si','Stanovanjskih',0),(491810,13662,'ba','Perumahan',0),(491811,13662,'nl','ResidentiÃ«le',0),(491812,13662,'fi','Asuin',0),(491813,13662,'no','Bolig',0),(491814,13662,'da','Bolig',0),(491815,13662,'ko','ì£¼ê±°',0),(491816,13662,'he','×ž×’×•×¨×™×',0),(491817,13662,'el','ÎšÎ±Ï„Î¿Î¹ÎºÎ·Î¼Î­Î½Î·',0),(491818,13662,'zh','ä½å®…',0),(491819,13662,'sv','BostÃ¤der',0),(491820,13662,'it','Residenziale',0),(491821,13662,'tl','',0),(491822,13662,'th','à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸­à¸²à¸¨à¸±à¸¢',0),(491823,13662,'hi','à¤†à¤µà¤¾à¤¸à¥€à¤¯',0),(491824,13662,'ms','Kediaman',0),(491825,13662,'ar','Ø§Ù„Ø³ÙƒÙ†ÙŠØ©',0),(491826,13662,'fr','RÃ©sidentiel',0),(491827,13662,'jp','ä½å®…',0),(491828,13662,'pt','Residencial',0),(491829,13662,'ru','Ð–Ð¸Ð»Ð¾Ð¹',0),(491830,13662,'es','Residencial',0),(491831,13662,'de','Wohn',0),(491832,13662,'en','Residential',0),(491833,13663,'is','',0),(491834,13663,'dr','Ú©ÙˆÙ¾Ù† Ù‡Ø§ÛŒ ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ',0),(491835,13663,'pr','Ú©ÙˆÙ¾Ù† Ù‡Ø§ÛŒ ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ',0),(491836,13663,'tr','Tasarruf kupon',0),(491837,13663,'pl','Kupon oszczÄ™dnoÅ›ci',0),(491838,13663,'bg','ÐšÑƒÐ¿Ð¾Ð½ ÑÐ¿ÐµÑÑ‚ÑÐ²Ð°Ð½Ð¸Ñ',0),(491839,13663,'ur','Ø¨Ú†Øª Ú©ÙˆÙ¾Ù†',0),(491840,13663,'sr','ÐšÑƒÐ¿Ð¾Ð½ Ð·Ð° ÑˆÑ‚ÐµÐ´ÑšÑƒ',0),(491841,13663,'vi','Phiáº¿u giáº£m giÃ¡ tiáº¿t kiá»‡m',0),(491842,13663,'af','Spaar koepon',0),(491843,13663,'ro','Cupon de economii',0),(491844,13663,'et','Kokkuhoid kupong',0),(491845,13663,'si','Prihrankov bon',0),(491846,13663,'ba','Tabungan kupon',0),(491847,13663,'nl','Besparingen Coupon',0),(491848,13663,'fi','SÃ¤Ã¤stÃ¶t kaappaus',0),(491849,13663,'no','Savings Coupon',0),(491850,13663,'da','Besparelser Coupon',0),(491851,13663,'ko','ì ˆì•½ ì¿ í°',0),(491852,13663,'he','×§×•×¤×•×Ÿ ×—×™×¡×›×•×Ÿ',0),(491853,13663,'el','Î•Î¾Î¿Î¹ÎºÎ¿Î½ÏŒÎ¼Î·ÏƒÎ· ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(491854,13663,'zh','å‚¨è“„åˆ¸',0),(491855,13663,'sv','Besparingar Kupong',0),(491856,13663,'it','Risparmio Coupon',0),(491857,13663,'tl','',0),(491858,13663,'th','à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸­à¸­à¸¡à¸—à¸£à¸±à¸žà¸¢à¹Œ',0),(491859,13663,'hi','à¤¬à¤šà¤¤ à¤•à¥‚à¤ªà¤¨',0),(491860,13663,'ms','Kupon penjimatan',0),(491861,13663,'ar','ÙˆÙÙˆØ±Ø§Øª Ø§Ù„Ù‚Ø³ÙŠÙ…Ø©',0),(491862,13663,'fr','Coupon d\'Ã©pargne',0),(491863,13663,'jp','è²¯è“„ã®ã‚¯ãƒ¼ãƒãƒ³',0),(491864,13663,'pt','Cupom de poupanÃ§a',0),(491865,13663,'ru','Ð­ÐºÐ¾Ð½Ð¾Ð¼Ð¸Ñ ÐºÑƒÐ¿Ð¾Ð½',0),(491866,13663,'es','Cupones de Ahorro',0),(491867,13663,'de','Einsparungen Gutschein',0),(491868,13663,'en','Savings Coupon',0),(491869,13664,'is','',0),(491870,13664,'dr','Ú©ÙˆÙ¾Ù†',0),(491871,13664,'pr','Ú©ÙˆÙ¾Ù†',0),(491872,13664,'tr','Kupon',0),(491873,13664,'pl','Kupon',0),(491874,13664,'bg','ÐšÑƒÐ¿Ð¾Ð½',0),(491875,13664,'ur','Ú©ÙˆÙ¾Ù†',0),(491876,13664,'sr','ÐšÑƒÐ¿Ð¾Ð½',0),(491877,13664,'vi','Phiáº¿u giáº£m giÃ¡',0),(491878,13664,'af','Koepon',0),(491879,13664,'ro','Cupon',0),(491880,13664,'et','Kupong',0),(491881,13664,'si','Kupon',0),(491882,13664,'ba','Kupon',0),(491883,13664,'nl','Coupon',0),(491884,13664,'fi','Kuponki',0),(491885,13664,'no','Kupong',0),(491886,13664,'da','Kupon',0),(491887,13664,'ko','ì¿ í°',0),(491888,13664,'he','×§×•×¤×•×Ÿ',0),(491889,13664,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(491890,13664,'zh','ä¼˜æƒ åˆ¸',0),(491891,13664,'sv','Kupong',0),(491892,13664,'it','Cedola',0),(491893,13664,'tl','',0),(491894,13664,'th','à¸„à¸¹à¸›à¸­à¸‡',0),(491895,13664,'hi','à¤•à¥‚à¤ªà¤¨',0),(491896,13664,'ms','Kupon',0),(491897,13664,'ar','Ø§Ù„Ù‚Ø³ÙŠÙ…Ø©',0),(491898,13664,'fr','Coupon',0),(491899,13664,'jp','ã‚¯ãƒ¼ãƒãƒ³',0),(491900,13664,'pt','Cupom',0),(491901,13664,'ru','ÐšÑƒÐ¿Ð¾Ð½',0),(491902,13664,'es','CupÃ³n',0),(491903,13664,'de','Gutschein',0),(491904,13664,'en','Coupon',0),(491905,13665,'is','',0),(491906,13665,'dr','Ø¯Ø± Ø¨Ø§Ù„Ø§ Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ù†Ø´Ø¯Ù‡',0),(491907,13665,'pr','Ø¯Ø± Ø¨Ø§Ù„Ø§ Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ù†Ø´Ø¯Ù‡',0),(491908,13665,'tr','AlÄ±ntÄ± dahil deÄŸil',0),(491909,13665,'pl','Nie zawarte w powyÅ¼szy cytat',0),(491910,13665,'bg','ÐÐµ ÑÐ° Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ Ð² Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(491911,13665,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø¨Ø§Ù„Ø§ Ø§Ù‚ØªØ¨Ø§Ø³ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ Ù†ÛÛŒÚº',0),(491912,13665,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÐºÑ™ÑƒÑ‡ÐµÐ½Ð¾ Ñƒ Ð¸Ð·Ð½Ð°Ð´ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(491913,13665,'vi','KhÃ´ng Ä‘Æ°á»£c bao gá»“m trong trÃªn bÃ¡o',0),(491914,13665,'af','Nie ingesluit bogenoemde aanhaling',0),(491915,13665,'ro','Nu sunt incluse Ã®n citat de mai sus',0),(491916,13665,'et','Quote eespool nimetamata',0),(491917,13665,'si','Niso vkljuÄeni v zgoraj citat',0),(491918,13665,'ba','Tidak termasuk dalam di atas kutipan',0),(491919,13665,'nl','Niet opgenomen In bovenstaande citaat',0),(491920,13665,'fi','SisÃ¤lly edellÃ¤ lainaus',0),(491921,13665,'no','Ikke inkludert i over tilbud',0),(491922,13665,'da','Ikke inkluderet i ovenstÃ¥ende citat',0),(491923,13665,'ko','ìœ„ì˜ ê²¬ì ì— í¬í•¨ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(491924,13665,'he','×œ× × ×›×œ×œ ×ž×¢×œ ×”×¦×¢×ª ×ž×—×™×¨',0),(491925,13665,'el','Î”ÎµÎ½ Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÏ„Î±Î¹ ÏƒÏ„Î¿ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(491926,13665,'zh','ä»¥ä¸ŠæŠ¥ä»·ä¸åŒ…å«åœ¨',0),(491927,13665,'sv','Inte ingÃ¥r i ovan citat',0),(491928,13665,'it','Non incluso sopra citazione',0),(491929,13665,'tl','',0),(491930,13665,'th','à¹„à¸¡à¹ˆà¸£à¸§à¸¡à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸šà¸£à¸´à¸à¸²à¸£à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(491931,13665,'hi','à¤Šà¤ªà¤° à¤¬à¥‹à¤²à¥€ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¨à¤¹à¥€à¤‚',0),(491932,13665,'ms','Tidak termasuk dalam di atas Quote',0),(491933,13665,'ar','ØºÙŠØ± Ø§Ù„Ù…Ø¯Ø±Ø¬Ø© ÙÙŠ Ø£Ø¹Ù„Ø§Ù‡ Ø§Ù‚ØªØ¨Ø§Ø³',0),(491934,13665,'fr','Non inclus dans ci-dessus Devis',0),(491935,13665,'jp','å¼•ç”¨ä¸Šè¨˜ã«å«ã¾ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(491936,13665,'pt','NÃ£o constam acima citaÃ§Ã£o',0),(491937,13665,'ru','ÐÐµ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹ Ð² Ð²Ñ‹ÑˆÐµ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°',0),(491938,13665,'es','No Incluido en CotizaciÃ³n Arriba',0),(491939,13665,'de','Nicht inbegriffen oben Zitat',0),(491940,13665,'en','Not Included In Above Quote',0),(491941,13666,'is','',0),(491942,13666,'dr','ØªØ­ÙˆÛŒÙ„ Ù…Ø³Ú©ÙˆÙ†ÛŒ',0),(491943,13666,'pr','ØªØ­ÙˆÛŒÙ„ Ù…Ø³Ú©ÙˆÙ†ÛŒ',0),(491944,13666,'tr','Konut teslim',0),(491945,13666,'pl','Mieszkalnych dostawy',0),(491946,13666,'bg','Ð–Ð¸Ð»Ð¸Ñ‰Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(491947,13666,'ur','Ø±ÛØ§Ø¦Ø´ÛŒ Ø­ÙˆØ§Ù„Ú¯ÛŒ',0),(491948,13666,'sr','Ð¡Ñ‚Ð°Ð¼Ð±ÐµÐ½Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ð°',0),(491949,13666,'vi','Giao hÃ ng táº­n nÆ¡i dÃ¢n cÆ°',0),(491950,13666,'af','ResidensiÃ«le dienslewering',0),(491951,13666,'ro','RezidenÅ£iale de livrare',0),(491952,13666,'et','Elamu tarne',0),(491953,13666,'si','Stanovanjskih dostave',0),(491954,13666,'ba','Perumahan pengiriman',0),(491955,13666,'nl','ResidentiÃ«le levering',0),(491956,13666,'fi','Asuin toimitus',0),(491957,13666,'no','Bolig levering',0),(491958,13666,'da','Bolig levering',0),(491959,13666,'ko','ì£¼ê±° ë‚©í’ˆ',0),(491960,13666,'he','×ž×©×œ×•×— ×ž×’×•×¨×™×',0),(491961,13666,'el','ÎŸÎ¹ÎºÎ¹ÏƒÏ„Î¹ÎºÎ® Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·',0),(491962,13666,'zh','ä½å®…äº¤ä»˜',0),(491963,13666,'sv','BostÃ¤der leverans',0),(491964,13666,'it','Consegna residenziale',0),(491965,13666,'tl','',0),(491966,13666,'th','à¸ªà¹ˆà¸‡à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸­à¸²à¸¨à¸±à¸¢',0),(491967,13666,'hi','à¤†à¤µà¤¾à¤¸à¥€à¤¯ à¤µà¤¿à¤¤à¤°à¤£',0),(491968,13666,'ms','Penghantaran kediaman',0),(491969,13666,'ar','ØªØ³Ù„ÙŠÙ… Ø§Ù„Ø³ÙƒÙ†ÙŠØ©',0),(491970,13666,'fr','Livraison rÃ©sidentielle',0),(491971,13666,'jp','ä½å®…ã®é…ä¿¡',0),(491972,13666,'pt','Entrega residencial',0),(491973,13666,'ru','Ð–Ð¸Ð»Ð¾Ð¹ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(491974,13666,'es','Entrega Residencial',0),(491975,13666,'de','Wohn-Lieferung',0),(491976,13666,'en','Residential Delivery',0),(491977,13667,'is','',0),(491978,13667,'dr','Ú©ÙˆÙ¾Ù† Ù‡Ø§ÛŒ ØªØ®ÙÛŒÙ',0),(491979,13667,'pr','Ú©ÙˆÙ¾Ù† Ù‡Ø§ÛŒ ØªØ®ÙÛŒÙ',0),(491980,13667,'tr','Ä°ndirim kupon',0),(491981,13667,'pl','Kupon rabatowy',0),(491982,13667,'bg','ÐšÑƒÐ¿Ð¾Ð½ Ð·Ð° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(491983,13667,'ur','ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹ Ú©ÙˆÙ¾Ù†',0),(491984,13667,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ ÐºÑƒÐ¿Ð¾Ð½',0),(491985,13667,'vi','Phiáº¿u giáº£m giÃ¡ giáº£m giÃ¡',0),(491986,13667,'af','Afslag koepon',0),(491987,13667,'ro','Cupon de reducere',0),(491988,13667,'et','Allahindlust kupong',0),(491989,13667,'si','Popust kupon',0),(491990,13667,'ba','Kupon diskon',0),(491991,13667,'nl','Kortingsbon',0),(491992,13667,'fi','Alennuskuponki',0),(491993,13667,'no','Rabatt kupong',0),(491994,13667,'da','Rabat kupon',0),(491995,13667,'ko','í• ì¸ ì¿ í°',0),(491996,13667,'he','×§×•×¤×•×Ÿ ×”× ×—×”',0),(491997,13667,'el','Î•ÎºÏ€Ï„Ï‰Ï„Î¹ÎºÏŒ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(491998,13667,'zh','æŠ˜æ‰£ä¼˜æƒ ',0),(491999,13667,'sv','Rabatt kupong',0),(492000,13667,'it','Coupon sconto',0),(492001,13667,'tl','',0),(492002,13667,'th','à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¸„à¸¹à¸›à¸­à¸‡',0),(492003,13667,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤•à¥‚à¤ªà¤¨',0),(492004,13667,'ms','Kupon diskaun',0),(492005,13667,'ar','Ø®ØµÙ… Ø§Ù„Ù‚Ø³ÙŠÙ…Ø©',0),(492006,13667,'fr','Coupon de rÃ©duction',0),(492007,13667,'jp','å‰²å¼•ã‚¯ãƒ¼ãƒãƒ³',0),(492008,13667,'pt','Cupom de desconto',0),(492009,13667,'ru','ÐšÑƒÐ¿Ð¾Ð½ Ð½Ð° ÑÐºÐ¸Ð´ÐºÑƒ',0),(492010,13667,'es','CupÃ³n de Descuento',0),(492011,13667,'de','Rabatt-Coupon',0),(492012,13667,'en','Discount Coupon',0),(492013,13668,'is','',0),(492014,13668,'dr','ØªØ®ÙÛŒÙ Ù…Ø¬Ù…ÙˆØ¹',0),(492015,13668,'pr','ØªØ®ÙÛŒÙ Ù…Ø¬Ù…ÙˆØ¹',0),(492016,13668,'tr','Toplam iskonto',0),(492017,13668,'pl','Rabat ogÃ³Å‚em',0),(492018,13668,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð¾Ð±Ñ‰Ð¾',0),(492019,13668,'ur','Ú©Ù„ ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(492020,13668,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(492021,13668,'vi','Giáº£m tá»•ng sá»‘',0),(492022,13668,'af','Afslag totaal',0),(492023,13668,'ro','Discount Total',0),(492024,13668,'et','Allahindlus kokku',0),(492025,13668,'si','Popust skupaj',0),(492026,13668,'ba','DISKON TERBAIK untuk Total',0),(492027,13668,'nl','Totale korting',0),(492028,13668,'fi','Alennus yhteensÃ¤',0),(492029,13668,'no','Rabatt totalt',0),(492030,13668,'da','Rabat alt',0),(492031,13668,'ko','ì´ í• ì¸',0),(492032,13668,'he','×¡×” ×› ×”× ×—×”',0),(492033,13668,'el','Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(492034,13668,'zh','æŠ˜æ‰£æ€»é¢',0),(492035,13668,'sv','Rabatt totalt',0),(492036,13668,'it','Sconto totale',0),(492037,13668,'tl','',0),(492038,13668,'th','à¸¥à¸”à¸£à¸²à¸„à¸²à¸£à¸§à¸¡',0),(492039,13668,'hi','à¤•à¥à¤² à¤›à¥‚à¤Ÿ',0),(492040,13668,'ms','Diskaun sebanyak',0),(492041,13668,'ar','Ø§Ù„Ø®ØµÙ… Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(492042,13668,'fr','Discount Total',0),(492043,13668,'jp','åˆè¨ˆã‚’å‰²å¼•ã—ã¾ã™ã€‚',0),(492044,13668,'pt','Desconto Total',0),(492045,13668,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð²ÑÐµÐ³Ð¾',0),(492046,13668,'es','Descuento Total',0),(492047,13668,'de','Rabatt insgesamt',0),(492048,13668,'en','Discount Total',0),(492049,13669,'is','',0),(492050,13669,'dr','Ú†Ø§Ù¾ Ø¨Ø± Ø±ÙˆÛŒ Ù‡Ø± Ø®Ø±ÙˆØ¬ÛŒ',0),(492051,13669,'pr','Ú†Ø§Ù¾ Ø¨Ø± Ø±ÙˆÛŒ Ù‡Ø± Ø®Ø±ÙˆØ¬ÛŒ',0),(492052,13669,'tr','Herhangi bir Ã§Ä±kÄ±ÅŸ yazdÄ±rÄ±lmÄ±yor.',0),(492053,13669,'pl','Nie Drukuj na wszelkie wyjÅ›cia',0),(492054,13669,'bg','ÐÐµ Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¸Ð·Ñ…Ð¾Ð´Ð¸',0),(492055,13669,'ur','Ú©ÙˆØ¦ÛŒ Ù†ØªØ§Ø¦Ø¬ Ù¾Ø± Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(492056,13669,'sr','ÐÐµ ÑˆÑ‚Ð°Ð¼Ð¿Ð° Ð½Ð° Ð¸Ð·Ð»Ð°Ð·Ð°',0),(492057,13669,'vi','KhÃ´ng in trÃªn báº¥t ká»³ káº¿t quáº£ Ä‘áº§u ra',0),(492058,13669,'af','Nie druk op enige uitsette',0),(492059,13669,'ro','Nu imprima pe orice ieÅŸiri',0),(492060,13669,'et','Prindi kÃµik vÃ¤ljundid',0),(492061,13669,'si','Natisne na izhodov',0),(492062,13669,'ba','Tidak mencetak pada output apapun',0),(492063,13669,'nl','Niet worden afgedrukt op elke uitgangen',0),(492064,13669,'fi','Tulosta kaikki lÃ¤hdÃ¶t',0),(492065,13669,'no','Ikke skrives ut pÃ¥ alle utganger',0),(492066,13669,'da','Ikke udskrive pÃ¥ alle udgange',0),(492067,13669,'ko','ëª¨ë“  ì¶œë ¥ì— ì¸ì‡„ ë˜ì§€',0),(492068,13669,'he','×ª×“×¤×™×¡ ×¢×œ ×¤×œ×˜×™×',0),(492069,13669,'el','Î”ÎµÎ½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î¹Ï‚ ÎµÎ¾ÏŒÎ´Î¿Ï…Ï‚',0),(492070,13669,'zh','ä¸æ‰“å°ä»»ä½•è¾“å‡º',0),(492071,13669,'sv','Inte skrivs ut pÃ¥ alla utgÃ¥ngar',0),(492072,13669,'it','Non stampare su qualsiasi uscite',0),(492073,13669,'tl','',0),(492074,13669,'th','à¸žà¸´à¸¡à¸žà¹Œà¹„à¸¡à¹ˆà¹à¸ªà¸”à¸‡à¸œà¸¥à¹ƒà¸” à¹†',0),(492075,13669,'hi','à¤•à¤¿à¤¸à¥€ à¤­à¥€ Outputs à¤ªà¤° à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚',0),(492076,13669,'ms','Dicetak pada output mana-mana',0),(492077,13669,'ar','Ù„Ø§ ÙŠØªÙ… Ø·Ø¨Ø§Ø¹Ø© Ø¹Ù„Ù‰ Ø£ÙŠ Ù†ÙˆØ§ØªØ¬',0),(492078,13669,'fr','Ne pas s\'imprimer sur n\'importe quel sorties',0),(492079,13669,'jp','ä»»æ„ã®å‡ºåŠ›ã«å°åˆ·ã•ã‚Œã¾ã›ã‚“ã€‚',0),(492080,13669,'pt','NÃ£o imprimir em quaisquer saÃ­das',0),(492081,13669,'ru','ÐÐµ Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð½Ð° Ð»ÑŽÐ±Ñ‹Ñ… Ð¼ÐµÑ€Ð¾Ð¿Ñ€Ð¸ÑÑ‚Ð¸Ð¹',0),(492082,13669,'es','No Imprimir en Ninguno Outputs',0),(492083,13669,'de','Drucken Sie nicht auf alle AusgÃ¤nge',0),(492084,13669,'en','Not Print On Any Outputs',0),(492085,13670,'is','',0),(492086,13670,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ Ú©Ø§Ø±Ø¨Ø± Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(492087,13670,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ Ú©Ø§Ø±Ø¨Ø± Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(492088,13670,'tr','KullanÄ±cÄ± geÃ§ersiz bir miktar izin ver',0),(492089,13670,'pl','UmoÅ¼liwia nadpisanie uÅ¼ytkownika kwoty',0),(492090,13670,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»ÑÐ²Ð°Ñ‚ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ Ð¿Ñ€ÐµÐ½ÐµÐ±Ñ€ÐµÐ³Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑƒÐ¼Ð°',0),(492091,13670,'ur','ØµØ§Ø±Ù Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ø³Û’ ØªØ¬Ø§ÙˆØ² Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(492092,13670,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÑƒ Ð¿Ñ€ÐµÐ¼Ð¾ÑˆÑ›Ð°Ð²Ð°ÑšÐµ Ð¸Ð·Ð½Ð¾ÑÐ°',0),(492093,13670,'vi','Cho phÃ©p ngÆ°á»i dÃ¹ng ghi Ä‘Ã¨ cá»§a sá»‘ tiá»n',0),(492094,13670,'af','Laat gebruiker oorheersing van bedrag',0),(492095,13670,'ro','Permite utilizatorului suprascrie de suma',0),(492096,13670,'et','Luba kasutaja alistamine summa',0),(492097,13670,'si','OmoguÄiti uporabnik override zneska',0),(492098,13670,'ba','Memungkinkan pengguna menimpa jumlah',0),(492099,13670,'nl','Toestaan dat gebruiker overschrijven van bedrag',0),(492100,13670,'fi','Salli kÃ¤yttÃ¤jÃ¤n ohitus mÃ¤Ã¤rÃ¤n',0),(492101,13670,'no','Tillate bruker overstyring av belÃ¸p',0),(492102,13670,'da','Tillad brugeren tilsidesÃ¦ttelse af belÃ¸b',0),(492103,13670,'ko','ê¸ˆì•¡ì˜ ì‚¬ìš©ìž ìž¬ì •ì˜ í—ˆìš©',0),(492104,13670,'he','×œ××¤×©×¨ ×œ×ž×©×ª×ž×© ×¢×§×™×¤×” ×©×œ ×›×ž×•×ª',0),(492105,13670,'el','Î•Ï€Î¹Ï„ÏÎ­ÏˆÎµÎ¹ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î· Ï…Ï€ÎµÏÎºÎ¬Î»Ï…ÏˆÎ· Ï„Î¿Ï… Ï€Î¿ÏƒÎ¿Ï',0),(492106,13670,'zh','å…è®¸ç”¨æˆ·é‡å†™çš„é‡‘é¢',0),(492107,13670,'sv','TillÃ¥t anvÃ¤ndaren omstÃ¤llning av belopp',0),(492108,13670,'it','Consentire l\'override utente di importo',0),(492109,13670,'tl','',0),(492110,13670,'th','à¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹à¸—à¸™à¸ˆà¸³à¸™à¸§à¸™',0),(492111,13670,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤“à¤µà¤°à¤°à¤¾à¤‡à¤¡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(492112,13670,'ms','Membenarkan pengguna menimpa jumlah',0),(492113,13670,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù… ØªØ¬Ø§ÙˆØ² Ø§Ù„Ù…Ø¨Ù„Øº',0),(492114,13670,'fr','Permettre la substitution d\'utilisateur de montant',0),(492115,13670,'jp','é‡ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«ã‚ˆã‚‹ä¸Šæ›¸ãã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(492116,13670,'pt','Permitir a substituiÃ§Ã£o de usuÃ¡rio de quantidade',0),(492117,13670,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÐ¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑÐ¼Ð¸ ÑÑƒÐ¼Ð¼Ñ‹',0),(492118,13670,'es','Permitir Pasar a Modo Manual la Cantidad',0),(492119,13670,'de','AuÃŸerkraftsetzung des Betrags durch Benutzer erlauben',0),(492120,13670,'en','Allow user override of amount',0),(492121,13671,'is','',0),(492122,13671,'dr','Ú©Ø¯ Ú©ÙˆÙ¾Ù†',0),(492123,13671,'pr','Ú©Ø¯ Ú©ÙˆÙ¾Ù†',0),(492124,13671,'tr','Kupon ÅŸifre',0),(492125,13671,'pl','Kod kuponu',0),(492126,13671,'bg','ÐšÑƒÐ¿Ð¾Ð½ ÐºÐ¾Ð´',0),(492127,13671,'ur','Ú©ÙˆÙ¾Ù† Ú©ÙˆÚˆ',0),(492128,13671,'sr','Ð¨Ð¸Ñ„Ñ€Ð° ÐºÑƒÐ¿Ð¾Ð½Ð°',0),(492129,13671,'vi','Phiáº¿u mua hÃ ng mÃ£',0),(492130,13671,'af','Koeponkode',0),(492131,13671,'ro','Codul promoÅ£ional',0),(492132,13671,'et','Kupongi kood',0),(492133,13671,'si','Bon zbornik',0),(492134,13671,'ba','Kode kupon',0),(492135,13671,'nl','Couponcode',0),(492136,13671,'fi','Kaappaus ilmaista koodikielellÃ¤',0),(492137,13671,'no','Merke koden',0),(492138,13671,'da','Kuponkode',0),(492139,13671,'ko','ì¿ í° ì½”ë“œ',0),(492140,13671,'he','×§×•×“ ×§×•×¤×•×Ÿ',0),(492141,13671,'el','ÎšÏ‰Î´Î¹ÎºÏŒ ÎºÎ¿Ï…Ï€Î¿Î½Î¹Î¿Ï',0),(492142,13671,'zh','ä¼˜æƒ åˆ¸ä»£ç ',0),(492143,13671,'sv','Kupongkod',0),(492144,13671,'it','Codice coupon',0),(492145,13671,'tl','',0),(492146,13671,'th','à¸£à¸«à¸±à¸ªà¸„à¸¹à¸›à¸­à¸‡',0),(492147,13671,'hi','à¤•à¥‚à¤ªà¤¨ à¤•à¥‹à¤¡',0),(492148,13671,'ms','Kod kupon',0),(492149,13671,'ar','Ø±Ù…Ø² Ø§Ù„Ù‚Ø³ÙŠÙ…Ø©',0),(492150,13671,'fr','Code Promo',0),(492151,13671,'jp','ã‚¯ãƒ¼ãƒãƒ³ ã‚³ãƒ¼ãƒ‰',0),(492152,13671,'pt','CÃ³digo de cupom',0),(492153,13671,'ru','ÐšÐ¾Ð´ ÐºÑƒÐ¿Ð¾Ð½Ð°',0),(492154,13671,'es','CÃ³digo de CupÃ³n',0),(492155,13671,'de','Gutschein-Code',0),(492156,13671,'en','Coupon Code',0),(492157,13672,'is','',0),(492158,13672,'dr','Ø´Ø±Ø­ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯',0),(492159,13672,'pr','Ø´Ø±Ø­ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯',0),(492160,13672,'tr','Teklif aÃ§Ä±klamasÄ±',0),(492161,13672,'pl','Opis oferty',0),(492162,13672,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð°',0),(492163,13672,'ur','Ù¾ÛŒØ´Ú©Ø´ Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(492164,13672,'sr','ÐžÐ¿Ð¸Ñ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(492165,13672,'vi','MÃ´ táº£ vá» Æ°u Ä‘Ã£i',0),(492166,13672,'af','Beskrywing van aanbod',0),(492167,13672,'ro','Descriere oferta',0),(492168,13672,'et','Pakkumise kirjeldus',0),(492169,13672,'si','Opis ponudbe',0),(492170,13672,'ba','Deskripsi Penawaran',0),(492171,13672,'nl','Beschrijving van aanbieding',0),(492172,13672,'fi','Tarjouksen kuvaus',0),(492173,13672,'no','Beskrivelse av tilbud',0),(492174,13672,'da','Beskrivelse af tilbud',0),(492175,13672,'ko','ì œì•ˆ ì„¤ëª…',0),(492176,13672,'he','×ª×™××•×¨ ×©×œ ×”×”×¦×¢×”',0),(492177,13672,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î·Ï‚ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬Ï‚',0),(492178,13672,'zh','æä¾›çš„è¯´æ˜Ž',0),(492179,13672,'sv','Beskrivning av erbjudandet',0),(492180,13672,'it','Descrizione dell\'offerta',0),(492181,13672,'tl','',0),(492182,13672,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¸­à¸‡à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­',0),(492183,13672,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤•à¥€ à¤ªà¥‡à¤¶à¤•à¤¶ à¤•à¥€',0),(492184,13672,'ms','Keterangan tawaran',0),(492185,13672,'ar','ÙˆØµÙ Ø§Ù„Ø¹Ø±Ø¶',0),(492186,13672,'fr','Description de l\'offre',0),(492187,13672,'jp','ã‚ªãƒ•ã‚¡ãƒ¼ã®èª¬æ˜Ž',0),(492188,13672,'pt','DescriÃ§Ã£o da oferta',0),(492189,13672,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(492190,13672,'es','DescripciÃ³n de la Oferta',0),(492191,13672,'de','Beschreibung des Angebots',0),(492192,13672,'en','Description of Offer',0),(492193,13673,'is','',0),(492194,13673,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ®ÙÛŒÙ',0),(492195,13673,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ®ÙÛŒÙ',0),(492196,13673,'tr','Maksimum iskonto tutarÄ±',0),(492197,13673,'pl','Kwota rabatu max',0),(492198,13673,'bg','ÐœÐ°ÐºÑ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(492199,13673,'ur','ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø±Ù‚Ù…',0),(492200,13673,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð° Ð½Ð° ÐœÐ°x',0),(492201,13673,'vi','Sá»‘ tiá»n giáº£m giÃ¡ tá»‘i Ä‘a',0),(492202,13673,'af','Max afslag bedrag',0),(492203,13673,'ro','Valoarea discountului Max',0),(492204,13673,'et','Max allahindlussumma',0),(492205,13673,'si','Max popust',0),(492206,13673,'ba','Max diskon jumlah',0),(492207,13673,'nl','Max kortingsbedrag',0),(492208,13673,'fi','Max alennussumma',0),(492209,13673,'no','Max rabattbelÃ¸p',0),(492210,13673,'da','Max rabatbelÃ¸b',0),(492211,13673,'ko','ìµœëŒ€ í• ì¸ ê¸ˆì•¡',0),(492212,13673,'he','×¡×›×•× ×ž×§×¡×™×ž×•× ×”× ×—×”',0),(492213,13673,'el','Î Î¿ÏƒÏŒ Max Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(492214,13673,'zh','æœ€å¤§æŠ˜æ‰£é‡‘é¢',0),(492215,13673,'sv','Max rabattbeloppet',0),(492216,13673,'it','Importo dello sconto max',0),(492217,13673,'tl','',0),(492218,13673,'th','à¸¢à¸­à¸”à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(492219,13673,'hi','à¤®à¥ˆà¤•à¥à¤¸ à¤›à¥‚à¤Ÿ à¤°à¤¾à¤¶à¤¿',0),(492220,13673,'ms','Jumlah Diskaun maksimum',0),(492221,13673,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø®ØµÙ… Ù…Ø§ÙƒØ³',0),(492222,13673,'fr','Montant de l\'escompte de Max',0),(492223,13673,'jp','æœ€å¤§å‰²å¼•é‡‘é¡',0),(492224,13673,'pt','Max desconto quantidade',0),(492225,13673,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÐºÐ¸Ð´ÐºÐ¸ ÐœÐ°ÐºÑ',0),(492226,13673,'es','Cantidad de Descuento Maximo',0),(492227,13673,'de','Max Rabattbetrag',0),(492228,13673,'en','Max Discount Amount',0),(492229,13674,'is','',0),(492230,13674,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú†Ø§Ù¾ Ú©ÙˆÙ¾Ù†',0),(492231,13674,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú†Ø§Ù¾ Ú©ÙˆÙ¾Ù†',0),(492232,13674,'tr','BaskÄ± kuponlar Ekle',0),(492233,13674,'pl','DodaÄ‡ wydruku kuponÃ³w',0),(492234,13674,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ ÐºÑƒÐ¿Ð¾Ð½Ð¸',0),(492235,13674,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©ÙˆÙ¾Ù† Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(492236,13674,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐºÑƒÐ¿Ð¾Ð½Ð°',0),(492237,13674,'vi','Phiáº¿u giáº£m giÃ¡ in thÃªm',0),(492238,13674,'af','Druk Coupons voeg',0),(492239,13674,'ro','Adauga Cupoane de imprimare',0),(492240,13674,'et','Prindi kupongid lisamine',0),(492241,13674,'si','Dodaj tiskanje kuponov',0),(492242,13674,'ba','Tambahkan Cetak kupon',0),(492243,13674,'nl','Afdrukken Coupons toevoegen',0),(492244,13674,'fi','Tulosta kuponkeja lisÃ¤Ã¤',0),(492245,13674,'no','Skrive ut kuponger legge',0),(492246,13674,'da','Print Kuponer tilfÃ¸je',0),(492247,13674,'ko','ì¸ì‡„ ì¿ í° ì¶”ê°€',0),(492248,13674,'he','×”×•×¡×¤×ª ×œ×”×“×¤×™×¡ ×§×•×¤×•× ×™×',0),(492249,13674,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î±',0),(492250,13674,'zh','æ‰“å°ä¼˜æƒ åˆ¸æ·»åŠ ',0),(492251,13674,'sv','Skriva ut kuponger lÃ¤gga till',0),(492252,13674,'it','Aggiungi stampa coupon',0),(492253,13674,'tl','',0),(492254,13674,'th','à¸„à¸¹à¸›à¸­à¸‡à¸žà¸´à¸¡à¸žà¹Œà¹€à¸žà¸´à¹ˆà¸¡',0),(492255,13674,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¥‚à¤ªà¤¨ à¤œà¥‹à¤¡à¤¼',0),(492256,13674,'ms','Cetak kupon Tambah',0),(492257,13674,'ar','Ø¥Ø¶Ø§ÙØ© ÙƒÙˆØ¨ÙˆÙ†Ø§Øª Ø·Ø¨Ø§Ø¹Ø©',0),(492258,13674,'fr','Ajouter des Coupons imprimÃ©s',0),(492259,13674,'jp','ãƒ—ãƒªãƒ³ãƒˆ ã‚¯ãƒ¼ãƒãƒ³ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(492260,13674,'pt','Adicionar imprimir cupons',0),(492261,13674,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ ÐºÑƒÐ¿Ð¾Ð½Ð¾Ð²',0),(492262,13674,'es','Agregar Cupones Para Imprimir',0),(492263,13674,'de','Drucken Gutscheine hinzufÃ¼gen',0),(492264,13674,'en','Print Coupons Add',0),(492265,13675,'is','',0),(492266,13675,'dr','Ú©ÙˆÙ¾Ù† Ù‡Ø§ÛŒ',0),(492267,13675,'pr','Ú©ÙˆÙ¾Ù† Ù‡Ø§ÛŒ',0),(492268,13675,'tr','Kuponlar',0),(492269,13675,'pl','Kupony',0),(492270,13675,'bg','ÐšÑƒÐ¿Ð¾Ð½Ð¸',0),(492271,13675,'ur','Ú©ÙˆÙ¾Ù†',0),(492272,13675,'sr','ÐšÑƒÐ¿Ð¾Ð½Ð¸',0),(492273,13675,'vi','Phiáº¿u giáº£m giÃ¡',0),(492274,13675,'af','Coupons',0),(492275,13675,'ro','Cupoane',0),(492276,13675,'et','Kupongid',0),(492277,13675,'si','Kuponi',0),(492278,13675,'ba','Kupon',0),(492279,13675,'nl','Coupons',0),(492280,13675,'fi','Kupongit',0),(492281,13675,'no','Kuponger',0),(492282,13675,'da','Kuponer',0),(492283,13675,'ko','ì¿ í°',0),(492284,13675,'he','×§×•×¤×•× ×™×',0),(492285,13675,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹Î±',0),(492286,13675,'zh','ä¼˜æƒ åˆ¸',0),(492287,13675,'sv','Kuponger',0),(492288,13675,'it','Tagliandi',0),(492289,13675,'tl','',0),(492290,13675,'th','à¸„à¸¹à¸›à¸­à¸‡',0),(492291,13675,'hi','à¤•à¥‚à¤ªà¤¨',0),(492292,13675,'ms','Kupon',0),(492293,13675,'ar','ÙƒÙˆØ¨ÙˆÙ†Ø§Øª',0),(492294,13675,'fr','Bons de rÃ©duction',0),(492295,13675,'jp','ã‚¯ãƒ¼ãƒãƒ³',0),(492296,13675,'pt','Cupons',0),(492297,13675,'ru','ÐšÑƒÐ¿Ð¾Ð½Ñ‹',0),(492298,13675,'es','Cupones',0),(492299,13675,'de','Gutscheine',0),(492300,13675,'en','Coupons',0),(492301,13676,'is','',0),(492302,13676,'dr','Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ú©ÙˆÙ¾Ù† Ù‡Ø§ÛŒ ØªØ®ÙÛŒÙ',0),(492303,13676,'pr','Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ú©ÙˆÙ¾Ù† Ù‡Ø§ÛŒ ØªØ®ÙÛŒÙ',0),(492304,13676,'tr','Ä°ndirim kupon gÃ¼ncelleÅŸtirme',0),(492305,13676,'pl','ZniÅ¼ki kupon aktualizacji',0),(492306,13676,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° ÐºÑƒÐ¿Ð¾Ð½ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(492307,13676,'ur','ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹ Ú©ÙˆÙ¾Ù† Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(492308,13676,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÐºÑƒÐ¿Ð¾Ð½Ð° ÑÐ° Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð°',0),(492309,13676,'vi','Giáº£m giÃ¡ phiáº¿u giáº£m giÃ¡ Cáº­p Nháº­t',0),(492310,13676,'af','Afslag koepon bywerking',0),(492311,13676,'ro','Reducere cupon Update',0),(492312,13676,'et','Discount kupongi Update',0),(492313,13676,'si','Popust kupon posodabljanje',0),(492314,13676,'ba','Diskon kupon Update terbaik untuk',0),(492315,13676,'nl','Korting Coupon Update',0),(492316,13676,'fi','Alennus kuponki pÃ¤ivitys',0),(492317,13676,'no','Rabatt kupong oppdatering',0),(492318,13676,'da','Rabat kupon opdatering',0),(492319,13676,'ko','í• ì¸ ì¿ í° ì—…ë°ì´íŠ¸',0),(492320,13676,'he','×”× ×—×” ×§×•×¤×•×Ÿ ×¢×“×›×•×Ÿ',0),(492321,13676,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(492322,13676,'zh','æŠ˜æ‰£ä¼˜æƒ åˆ¸æ›´æ–°',0),(492323,13676,'sv','Rabatt kupong uppdatering',0),(492324,13676,'it','Sconto Coupon aggiornamento',0),(492325,13676,'tl','',0),(492326,13676,'th','à¸¥à¸”à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(492327,13676,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤•à¥‚à¤ªà¤¨ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(492328,13676,'ms','Diskaun kupon Kemaskini',0),(492329,13676,'ar','Ø®ØµÙ… Ø§Ù„Ù‚Ø³ÙŠÙ…Ø© Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(492330,13676,'fr','Mise Ã  jour du Coupon de rÃ©duction',0),(492331,13676,'jp','å‰²å¼•ã‚¯ãƒ¼ãƒãƒ³æ›´æ–°',0),(492332,13676,'pt','AtualizaÃ§Ã£o de cupom de desconto',0),(492333,13676,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° ÐºÑƒÐ¿Ð¾Ð½ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(492334,13676,'es','ActualizaciÃ³n de CupÃ³n de Descuento',0),(492335,13676,'de','Rabatt Coupon Update',0),(492336,13676,'en','Discount Coupon Update',0),(492337,13677,'is','',0),(492338,13677,'dr','Ùˆ ÛŒÚ©ÛŒ Ø§Ø²',0),(492339,13677,'pr','Ùˆ ÛŒÚ©ÛŒ Ø§Ø²',0),(492340,13677,'tr','ve bir',0),(492341,13677,'pl','i jeden z',0),(492342,13677,'bg','Ð¸ ÐµÐ´Ð¸Ð½ Ð¾Ñ‚',0),(492343,13677,'ur','Ø§ÙˆØ± Ù…ÛŒÚº Ø³Û’ Ø§ÛŒÚ©',0),(492344,13677,'sr','Ð¸ Ñ˜ÐµÐ´Ð°Ð½ Ð¾Ð´',0),(492345,13677,'vi','vÃ  má»™t trong',0),(492346,13677,'af','en een van',0),(492347,13677,'ro','ÅŸi unul dintre',0),(492348,13677,'et','ja Ã¼ks',0),(492349,13677,'si','in eden od',0),(492350,13677,'ba','dan salah satu',0),(492351,13677,'nl','en een van',0),(492352,13677,'fi','ja yksi',0),(492353,13677,'no','og en av',0),(492354,13677,'da','og en af',0),(492355,13677,'ko','ì¤‘ í•˜ë‚˜',0),(492356,13677,'he','×•××—×“',0),(492357,13677,'el','ÎºÎ±Î¹ Î­Î½Î± Î±Ï€ÏŒ',0),(492358,13677,'zh','ä¹‹ä¸€',0),(492359,13677,'sv','och en av',0),(492360,13677,'it','e uno dei',0),(492361,13677,'tl','',0),(492362,13677,'th','à¹à¸¥à¸°à¸«à¸™à¸¶à¹ˆà¸‡',0),(492363,13677,'hi','à¤”à¤° à¤®à¥‡à¤‚ à¤¸à¥‡ à¤à¤•',0),(492364,13677,'ms','dan salah satu',0),(492365,13677,'ar','ÙˆÙˆØ§Ø­Ø¯ Ù…Ù†',0),(492366,13677,'fr','et l\'un des',0),(492367,13677,'jp','1 ã¤',0),(492368,13677,'pt','e um dos',0),(492369,13677,'ru','Ð¸ Ð¾Ð´Ð¸Ð½ Ð¸Ð·',0),(492370,13677,'es','Y Uno De',0),(492371,13677,'de','und einer der',0),(492372,13677,'en','and one of',0),(492373,13678,'is','',0),(492374,13678,'dr','Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¢Ø²Ø§Ø¯ÛŒ Ø¨Ù‡ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª',0),(492375,13678,'pr','Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¢Ø²Ø§Ø¯ÛŒ Ø¨Ù‡ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª',0),(492376,13678,'tr','SÄ±kÄ±ÅŸtÄ±rma serbest bÄ±rakmak iÃ§in tÄ±klatÄ±n',0),(492377,13678,'pl','Kliknij, aby zwolniÄ‡ do prasy',0),(492378,13678,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð·Ð° Ð¿Ñ€ÐµÑÐ°Ñ‚Ð°',0),(492379,13678,'ur','Ø±ÛØ§Ø¦ÛŒ Ø¯Ø¨Ø§Ø¦ÛŒÚº Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(492380,13678,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð¾Ñ‚Ð¿ÑƒÑÑ‚Ð¸Ñ‚Ðµ Ð´Ð° Ð¿Ñ€Ð¸Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ',0),(492381,13678,'vi','Nháº¥p chuá»™t Ä‘á»ƒ phÃ¡t hÃ nh cho bÃ¡o chÃ­',0),(492382,13678,'af','Klik om vrylating te druk',0),(492383,13678,'ro','FaceÅ£i clic pentru a elibera presei',0),(492384,13678,'et','Vabastamiseks vajutage nuppu',0),(492385,13678,'si','Kliknite za javnost, da',0),(492386,13678,'ba','Klik untuk melepaskan tekan',0),(492387,13678,'nl','Klik om te laat om druk op',0),(492388,13678,'fi','Napsauta vapauttamaan painaa',0),(492389,13678,'no','Klikk for Ã¥ lÃ¸slate Ã¥ trykke',0),(492390,13678,'da','Klik for at frigive for at trykke pÃ¥',0),(492391,13678,'ko','ì–¸ë¡ ì— ê³µê°œ í•©ë‹ˆë‹¤',0),(492392,13678,'he','×œ×—×¥ ×›×“×™ ×œ×©×—×¨×¨ ×œ×—×¥',0),(492393,13678,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î±Ï€ÎµÎ»ÎµÏ…Î¸ÎµÏÏŽÏƒÎµÎ¹ Î½Î± Ï€Î±Ï„Î®ÏƒÎµÏ„Îµ',0),(492394,13678,'zh','å•å‡»å°†å…¶é‡Šæ”¾ï¼ŒæŒ‰',0),(492395,13678,'sv','Klicka fÃ¶r att slÃ¤ppa fÃ¶r att trycka',0),(492396,13678,'it','Clicca per rilasciare per premere',0),(492397,13678,'tl','',0),(492398,13678,'th','à¸•à¹‰à¸­à¸‡à¸›à¸¥à¹ˆà¸­à¸¢à¹ƒà¸«à¹‰à¸à¸”',0),(492399,13678,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤•à¥‹ à¤œà¤¾à¤°à¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(492400,13678,'ms','Klik untuk melepaskan untuk menekan',0),(492401,13678,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ù„Ø¥ÙØ±Ø§Ø¬ Ø¹Ù† Ø§Ù„Ø¶ØºØ·',0),(492402,13678,'fr','Cliquez ici pour le communiquÃ© de presse',0),(492403,13678,'jp','æŠ¼ã—ã¦ãƒªãƒªãƒ¼ã‚¹ã™ã‚‹ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(492404,13678,'pt','Clique para liberar para a imprensa',0),(492405,13678,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð´Ð¸Ñ‚ÑŒ Ð½Ð°Ð¶Ð°Ñ‚ÑŒ',0),(492406,13678,'es','Hace Clik Para Mandar Imprimir',0),(492407,13678,'de','Hier klicken, um zum press release',0),(492408,13678,'en','Click to release to press',0),(492409,13679,'is','',0),(492410,13679,'dr','Ù†Ù…Ø§ÛŒØ´ Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ù‡Ø§ÛŒ Ù‡Ù…Ù‡',0),(492411,13679,'pr','Ù†Ù…Ø§ÛŒØ´ Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ù‡Ø§ÛŒ Ù‡Ù…Ù‡',0),(492412,13679,'tr','TÃ¼m eklentileri gÃ¶ster',0),(492413,13679,'pl','PokaÅ¼ wszystkie dodatki',0),(492414,13679,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(492415,13679,'ur','ØªÙ…Ø§Ù… Ø¨Ø±-Ø§Ø¶Ø§ÙÛ Ø¬Ø§Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(492416,13679,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ²Ðµ Ð´Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(492417,13679,'vi','Hiá»ƒn thá»‹ táº¥t cáº£ Tiá»‡n Ã­ch',0),(492418,13679,'af','Wys alle byvoegsels',0),(492419,13679,'ro','AratÄƒ toate programele de completare',0),(492420,13679,'et','Kuva kÃµiki lisandmooduleid',0),(492421,13679,'si','PrikaÅ¾i vse dodatke',0),(492422,13679,'ba','Tampilkan Semua Pengaya',0),(492423,13679,'nl','Alle Add-Ons weergeven',0),(492424,13679,'fi','NÃ¤ytÃ¤ kaikki lisÃ¤osat',0),(492425,13679,'no','Vis alle tillegg',0),(492426,13679,'da','Vis alle tilfÃ¸jelser',0),(492427,13679,'ko','ëª¨ë“  ì¶”ê°€ ê¸°ëŠ¥ì„ í‘œì‹œ',0),(492428,13679,'he','×”×¦×’ ××ª ×›×œ ×”×”×¨×—×‘×•×ª',0),(492429,13679,'el','Î”ÎµÎ¯Ï„Îµ ÏŒÎ»Î± Ï„Î± Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î±:',0),(492430,13679,'zh','æ˜¾ç¤ºæ‰€æœ‰åŠ è½½é¡¹',0),(492431,13679,'sv','Visa alla tillÃ¤gg',0),(492432,13679,'it','Visualizza tutti i componenti aggiuntivi',0),(492433,13679,'tl','',0),(492434,13679,'th','à¹à¸ªà¸”à¸‡ Add-on à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(492435,13679,'hi','à¤¸à¤­à¥€ à¤à¤¡-à¤‘à¤¨ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(492436,13679,'ms','Menunjukkan Semua tambahan',0),(492437,13679,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙƒØ§ÙØ© Ø§Ù„ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(492438,13679,'fr','Afficher tous les modules complÃ©mentaires',0),(492439,13679,'jp','ã™ã¹ã¦ã®ã‚¢ãƒ‰ã‚ªãƒ³ã‚’è¦‹ã‚‹',0),(492440,13679,'pt','Mostrar todos os Complementos',0),(492441,13679,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð²ÑÐµ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(492442,13679,'es','Muestra Todos Los Add-Ons',0),(492443,13679,'de','Alle Add-ons anzeigen',0),(492444,13679,'en','Show All Add-Ons',0),(492445,13680,'is','',0),(492446,13680,'dr','ÙÙ‚Ø· ÙÙ‡Ø±Ø³Øª ÙØ¹Ø§Ù„ Ù‡Ø§',0),(492447,13680,'pr','ÙÙ‚Ø· ÙÙ‡Ø±Ø³Øª ÙØ¹Ø§Ù„ Ù‡Ø§',0),(492448,13680,'tr','YalnÄ±zca etkin gÃ¶ster',0),(492449,13680,'pl','PokaÅ¼ tylko aktywne',0),(492450,13680,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸',0),(492451,13680,'ur','ØµØ±Ù Ø²ÛŒØ± Ø¹Ù…Ù„ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(492452,13680,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸',0),(492453,13680,'vi','Hiá»ƒn thá»‹ chá»‰ hoáº¡t Ä‘á»™ng',0),(492454,13680,'af','Wys slegs aktiewe',0),(492455,13680,'ro','AfiÈ™eazÄƒ numai activ',0),(492456,13680,'et','NÃ¤ita ainult aktiivseid',0),(492457,13680,'si','PrikaÅ¾i samo aktivne',0),(492458,13680,'ba','Tampilkan hanya aktif',0),(492459,13680,'nl','Alleen actieve weergeven',0),(492460,13680,'fi','NÃ¤ytÃ¤ vain aktiiviset',0),(492461,13680,'no','Vis bare aktiv',0),(492462,13680,'da','Vis kun aktive',0),(492463,13680,'ko','í™œì„±ë§Œ í‘œì‹œ',0),(492464,13680,'he','×”×¦×’ ×¨×§ ×¤×¢×™×œ',0),(492465,13680,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ ÎµÎ½ÎµÏÎ³ÏŒ',0),(492466,13680,'zh','ä»…æ˜¾ç¤ºæ´»åŠ¨',0),(492467,13680,'sv','Visa endast aktiva',0),(492468,13680,'it','Visualizza solo attivo',0),(492469,13680,'tl','',0),(492470,13680,'th','à¹à¸ªà¸”à¸‡à¹€à¸‰à¸žà¸²à¸°à¸—à¸µà¹ˆà¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸­à¸¢à¸¹à¹ˆ',0),(492471,13680,'hi','à¤•à¥‡à¤µà¤² à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(492472,13680,'ms','Menunjukkan hanya aktif',0),(492473,13680,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙÙ‚Ø· Ù†Ø´Ø·',0),(492474,13680,'fr','N\'afficher qu\'actif',0),(492475,13680,'jp','ã®ã¿ã‚’è¡¨ç¤ºã™ã‚‹ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã§ã™',0),(492476,13680,'pt','Mostrar somente ativo',0),(492477,13680,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ',0),(492478,13680,'es','Muestra Solo Activos',0),(492479,13680,'de','Nur aktive anzeigen',0),(492480,13680,'en','Show Only Active',0),(492481,13681,'is','',0),(492482,13681,'dr','ÙÙ‚Ø· Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ ØºÛŒØ± ÙØ¹Ø§Ù„',0),(492483,13681,'pr','ÙÙ‚Ø· Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ ØºÛŒØ± ÙØ¹Ø§Ù„',0),(492484,13681,'tr','YalnÄ±zca etkin olmayan gÃ¶ster',0),(492485,13681,'pl','PokaÅ¼ tylko nieaktywne',0),(492486,13681,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸Ñ‚Ðµ',0),(492487,13681,'ur','ØµØ±Ù ØºÛŒØ± ÙØ¹Ø§Ù„ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(492488,13681,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¾',0),(492489,13681,'vi','Hiá»ƒn thá»‹ chá»‰ khÃ´ng hoáº¡t Ä‘á»™ng',0),(492490,13681,'af','Wys net onaktief',0),(492491,13681,'ro','AratÄƒ doar inactiv',0),(492492,13681,'et','NÃ¤ita ainult passiivne',0),(492493,13681,'si','PokaÅ¾i samo neaktivne',0),(492494,13681,'ba','Tampilkan hanya tidak aktif',0),(492495,13681,'nl','Toon alleen inactief',0),(492496,13681,'fi','NÃ¤ytÃ¤ passiiviset',0),(492497,13681,'no','Vis bare inaktiv',0),(492498,13681,'da','Vis kun inaktive',0),(492499,13681,'ko','ë¹„í™œì„±ë§Œ í‘œì‹œ',0),(492500,13681,'he','×”×¦×’ ×¨×§ ×œ× ×¤×¢×™×œ',0),(492501,13681,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ Î±Î½ÎµÎ½ÎµÏÎ³ÏŒ',0),(492502,13681,'zh','ä»…æ˜¾ç¤ºå¤„äºŽéžæ´»åŠ¨çŠ¶æ€',0),(492503,13681,'sv','Visa endast inaktiva',0),(492504,13681,'it','Visualizza solo inattivo',0),(492505,13681,'tl','',0),(492506,13681,'th','à¹à¸ªà¸”à¸‡à¹€à¸‰à¸žà¸²à¸°à¸‡à¸²à¸™',0),(492507,13681,'hi','à¤•à¥‡à¤µà¤² à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(492508,13681,'ms','Menunjukkan hanya aktif',0),(492509,13681,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙÙ‚Ø· ØºÙŠØ± Ù†Ø´Ø·',0),(492510,13681,'fr','N\'afficher qu\'inactif',0),(492511,13681,'jp','ã®ã¿ã‚’è¡¨ç¤ºã™ã‚‹éžã‚¢ã‚¯ãƒ†ã‚£ãƒ–',0),(492512,13681,'pt','Mostrar apenas inativo',0),(492513,13681,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ',0),(492514,13681,'es','Muestra Sola Inactivas',0),(492515,13681,'de','Nur inaktive anzeigen',0),(492516,13681,'en','Show Only Inactive',0),(492517,13682,'is','',0),(492518,13682,'dr','Ù†Ù…Ø§ÛŒØ´ ØªÙ†Ù‡Ø§ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ø´Ø¯Ù‡',0),(492519,13682,'pr','Ù†Ù…Ø§ÛŒØ´ ØªÙ†Ù‡Ø§ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ø´Ø¯Ù‡',0),(492520,13682,'tr','GÃ¶steri sadece satÄ±n',0),(492521,13682,'pl','PokaÅ¼ tylko zakupione',0),(492522,13682,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð·Ð°ÐºÑƒÐ¿ÐµÐ½Ð¸',0),(492523,13682,'ur','ØµØ±Ù Ø®Ø±ÛŒØ¯ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(492524,13682,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÐºÑƒÐ¿Ð¸Ð»Ð¸',0),(492525,13682,'vi','Hiá»ƒn thá»‹ chá»‰ mua',0),(492526,13682,'af','Wys net gekoop',0),(492527,13682,'ro','AratÄƒ doar achiziÅ£ionate',0),(492528,13682,'et','NÃ¤ita ainult ostetud',0),(492529,13682,'si','PrikaÅ¾i samo kupljene',0),(492530,13682,'ba','Tampilkan hanya dibeli',0),(492531,13682,'nl','Toon alleen gekocht',0),(492532,13682,'fi','NÃ¤ytÃ¤ vain ostaa',0),(492533,13682,'no','Vis bare kjÃ¸pt',0),(492534,13682,'da','Vis kun kÃ¸bt',0),(492535,13682,'ko','í‘œì‹œë§Œ êµ¬ìž…',0),(492536,13682,'he','×”×¦×’ ×œ×¨×›×•×© ×¨×§',0),(492537,13682,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ Î±Î³Î¿ÏÎ¬Î¶Î¿Î½Ï„Î±Î¹',0),(492538,13682,'zh','æ˜¾ç¤ºåªè´­ä¹°äº†',0),(492539,13682,'sv','Visa endast kÃ¶pt',0),(492540,13682,'it','Visualizza solo acquistato',0),(492541,13682,'tl','',0),(492542,13682,'th','à¸”à¸¹à¸—à¸µà¹ˆà¸‹à¸·à¹‰à¸­à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(492543,13682,'hi','à¤•à¥‡à¤µà¤² à¤–à¤°à¥€à¤¦à¥€ à¤¶à¥‹',0),(492544,13682,'ms','Papar hanya dibeli',0),(492545,13682,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙÙ‚Ø· ØªÙ… Ø´Ø±Ø§Ø¤Ù‡Ø§',0),(492546,13682,'fr','Spectacle seulement achetÃ©',0),(492547,13682,'jp','ã‚·ãƒ§ãƒ¼ã®ã¿è³¼å…¥',0),(492548,13682,'pt','Mostrar sÃ³ comprado',0),(492549,13682,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐºÑƒÐ¿Ð¸Ð»',0),(492550,13682,'es','Muestra Solo Cosas Compradas',0),(492551,13682,'de','Karte nur gekauft',0),(492552,13682,'en','Show Only Purchased',0),(492553,13683,'is','',0),(492554,13683,'dr','Ù†Ù…Ø§ÛŒØ´ ØªÙ†Ù‡Ø§ Unpurchased',0),(492555,13683,'pr','Ù†Ù…Ø§ÛŒØ´ ØªÙ†Ù‡Ø§ Unpurchased',0),(492556,13683,'tr','Sadece Unpurchased gÃ¶ster',0),(492557,13683,'pl','PokaÅ¼ tylko Unpurchased',0),(492558,13683,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Unpurchased',0),(492559,13683,'ur','ØµØ±Ù Ø§Ù†Ù¾Ø±Ú†Ø§Ø³Ø§Ø¯ Ø´Ùˆ',0),(492560,13683,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÐºÑ€Ð°Ð´ÐµÐ½Ðµ',0),(492561,13683,'vi','Hiá»ƒn thá»‹ chá»‰ Unpurchased',0),(492562,13683,'af','Wys slegs Unpurchased',0),(492563,13683,'ro','AratÄƒ doar Unpurchased',0),(492564,13683,'et','NÃ¤ita ainult Unpurchased',0),(492565,13683,'si','PrikaÅ¾i samo Unpurchased',0),(492566,13683,'ba','Tampilkan hanya Unpurchased',0),(492567,13683,'nl','Toon alleen Unpurchased',0),(492568,13683,'fi','NÃ¤ytÃ¤ vain Unpurchased',0),(492569,13683,'no','Vis bare Unpurchased',0),(492570,13683,'da','Vis kun Unpurchased',0),(492571,13683,'ko','í‘œì‹œë§Œ Unpurchased',0),(492572,13683,'he','×”×¦×’ ×¨×§ ×›×©×‘×¨××©',0),(492573,13683,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ Unpurchased',0),(492574,13683,'zh','æ˜¾ç¤ºä»…æ— ä»·',0),(492575,13683,'sv','Visa endast okÃ¶pta',0),(492576,13683,'it','Visualizza solo Unpurchased',0),(492577,13683,'tl','',0),(492578,13683,'th','à¸”à¸¹à¸—à¸µà¹ˆ Unpurchased à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(492579,13683,'hi','à¤•à¥‡à¤µà¤² Unpurchased à¤¶à¥‹',0),(492580,13683,'ms','Papar hanya penghitungan',0),(492581,13683,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙÙ‚Ø· Ø£ÙˆÙ†Ø¨ÙˆØ±ØªØ´Ø§Ø³ÙŠØ¯',0),(492582,13683,'fr','Spectacle seulement dÃ©sÃ©lectionnÃ©',0),(492583,13683,'jp','ã®ã¿ Unpurchased ã‚·ãƒ§ãƒ¼',0),(492584,13683,'pt','Mostrar apenas Unpurchased',0),(492585,13683,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ñ€Ð¸Ð¾Ð±Ñ€ÐµÑ‚ÐµÐ½Ð½Ñ‹Ðµ',0),(492586,13683,'es','Muestra Solo No Comprados',0),(492587,13683,'de','Karte nur Unpurchased',0),(492588,13683,'en','Show Only Unpurchased',0),(492589,13684,'is','',0),(492590,13684,'dr','Ù¾Ø§ÛŒØ§Ù† Ø³Ø§Ù„',0),(492591,13684,'pr','Ù¾Ø§ÛŒØ§Ù† Ø³Ø§Ù„',0),(492592,13684,'tr','YÄ±l sonu',0),(492593,13684,'pl','Koniec roku',0),(492594,13684,'bg','ÐšÑ€Ð°Ð¹ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(492595,13684,'ur','Ø³Ø§Ù„ Ø§Ø®ØªØªØ§Ù…',0),(492596,13684,'sr','ÐšÑ€Ð°Ñ˜ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(492597,13684,'vi','Cuá»‘i nÄƒm',0),(492598,13684,'af','Einde van jaar',0),(492599,13684,'ro','SfÃ¢rÅŸitul anului',0),(492600,13684,'et','LÃµpp aasta',0),(492601,13684,'si','Koncu leta',0),(492602,13684,'ba','Akhir tahun',0),(492603,13684,'nl','Einde jaar',0),(492604,13684,'fi','Vuoden',0),(492605,13684,'no','SluttÃ¥ret',0),(492606,13684,'da','Udgangen Ã¥r',0),(492607,13684,'ko','ì—°ë§',0),(492608,13684,'he','×¡×•×£ ×©× ×”',0),(492609,13684,'el','Î¤Î­Î»Î¿Ï‚ Î­Ï„Î¿Ï…Ï‚',0),(492610,13684,'zh','ç»“æŸå¹´ä»½',0),(492611,13684,'sv','Ã…rets slut',0),(492612,13684,'it','Fine anno',0),(492613,13684,'tl','',0),(492614,13684,'th','à¸›à¸µà¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(492615,13684,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤…à¤‚à¤¤',0),(492616,13684,'ms','Akhir tahun',0),(492617,13684,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(492618,13684,'fr','Fin annÃ©e',0),(492619,13684,'jp','çµ‚äº†å¹´',0),(492620,13684,'pt','Ano de fim',0),(492621,13684,'ru','ÐÐ° ÐºÐ¾Ð½ÐµÑ† Ð³Ð¾Ð´Ð°',0),(492622,13684,'es','Fine de AÃ±o',0),(492623,13684,'de','Ende Jahr',0),(492624,13684,'en','End Year',0),(492625,13685,'is','',0),(492626,13685,'dr','Ø§ÛŒÙ† Ù¾Ø§ÛŒØ§Ù† Ø³Ø§Ù„ Ù†Ø²Ø¯ÛŒÚ© Ø§Ø³ØªØŸ',0),(492627,13685,'pr','Ø§ÛŒÙ† Ù¾Ø§ÛŒØ§Ù† Ø³Ø§Ù„ Ù†Ø²Ø¯ÛŒÚ© Ø§Ø³ØªØŸ',0),(492628,13685,'tr','Bu yÄ±l sonu yakÄ±n mÄ±?',0),(492629,13685,'pl','Czy to koniec roku blisko?',0),(492630,13685,'bg','Ð• Ñ‚Ð°Ð·Ð¸ ÐºÑ€Ð°Ñ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð±Ð»Ð¸Ð·Ð¾?',0),(492631,13685,'ur','Ø§Ø³ Ø³Ø§Ù„ Ú©Û’ Ø§Ø®ØªØªØ§Ù… Ú©Û’ Ù‚Ø±ÛŒØ¨ ÛÛ’ØŸ',0),(492632,13685,'sr','Ð”Ð° Ð»Ð¸ Ñ˜Ðµ Ð¾Ð²Ð¾ ÐºÑ€Ð°Ñ˜ Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð±Ð»Ð¸Ð·Ñƒ?',0),(492633,13685,'vi','LÃ  nÃ y cuá»‘i nÄƒm Ä‘Ã³ng?',0),(492634,13685,'af','Naby die einde van die jaar is?',0),(492635,13685,'ro','Este acest scop an aproape?',0),(492636,13685,'et','On kÃ¤esoleva aasta lÃµpuks sulgeda?',0),(492637,13685,'si','Je to konec leta blizu?',0),(492638,13685,'ba','Apakah ini akhir tahun menutup?',0),(492639,13685,'nl','Is dit einde van jaar dicht?',0),(492640,13685,'fi','On vuoden lopussa lÃ¤hellÃ¤?',0),(492641,13685,'no','Er dette slutten av Ã¥ret tett?',0),(492642,13685,'da','Er dette slutningen af Ã¥r tÃ¦t?',0),(492643,13685,'ko','ì˜¬í•´ì˜ì´ ëì´ ê°€ê¹Œì´ìž…ë‹ˆë‹¤?',0),(492644,13685,'he','? ×”×× ×–×• ×¡×•×£ ×©× ×” ×§×¨×•×‘',0),(492645,13685,'el','Î•Î¯Î½Î±Î¹ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï„Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î­Ï„Î¿Ï…Ï‚ ÎºÎ¿Î½Ï„Î¬;',0),(492646,13685,'zh','æ˜¯è¿™å¹´åº•å…³é—­å—ï¼Ÿ',0),(492647,13685,'sv','Ã„r detta slutet av Ã¥ret i nÃ¤rheten?',0),(492648,13685,'it','Ãˆ questa fine dell\'anno nelle vicinanze?',0),(492649,13685,'tl','',0),(492650,13685,'th','à¸„à¸·à¸­à¸ªà¸´à¹‰à¸™à¸›à¸µà¸™à¸µà¹‰à¸›à¸´à¸”',0),(492651,13685,'hi','à¤¸à¤¾à¤² à¤•à¥‡ à¤‡à¤¸ à¤…à¤‚à¤¤ à¤•à¥‡ à¤•à¤°à¥€à¤¬ à¤¹à¥ˆ?',0),(492652,13685,'ms','Adakah ini penghujung tahun tutup?',0),(492653,13685,'ar','Ù‡Ùˆ Ù†Ù‡Ø§ÙŠØ© Ù‡Ø°Ù‡ Ø§Ù„Ø³Ù†Ø© Ù‚Ø±ÙŠØ¨Ø©ØŸ',0),(492654,13685,'fr','Ã‰tait prÃ¨s de cette fin d\'annÃ©e ?',0),(492655,13685,'jp','ã“ã®å¹´æœ«ã¾ã§ã™ãè¿‘ãã«ã‚ã‚Šã¾ã™ã‹ï¼Ÿ',0),(492656,13685,'pt','Este final de ano Ã© perto?',0),(492657,13685,'ru','Ð¯Ð²Ð»ÑÐµÑ‚ÑÑ ÑÑ‚Ð¾Ñ‚ ÐºÐ¾Ð½ÐµÑ† Ð³Ð¾Ð´Ð° Ð·Ð°ÐºÑ€Ñ‹Ñ‚ÑŒ?',0),(492658,13685,'es','Este es La Cierre del AÃ±o?',0),(492659,13685,'de','Ist diese zum Jahresende schlieÃŸen?',0),(492660,13685,'en','Is this end of year close?',0),(492661,13686,'is','',0),(492662,13686,'dr','Ú©ÙˆÙ¾Ù† Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…ÙˆØ±Ø® Ù‚Ø¨Ù„ Ø§Ø² ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† Ù†Ø²Ø¯ÛŒÚ© Ø±Ø¯',0),(492663,13686,'pr','Ú©ÙˆÙ¾Ù† Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…ÙˆØ±Ø® Ù‚Ø¨Ù„ Ø§Ø² ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† Ù†Ø²Ø¯ÛŒÚ© Ø±Ø¯',0),(492664,13686,'tr','Son kapanÄ±ÅŸ tarihi daha Ã¶nce Ã§Ä±ktÄ±ÄŸÄ±m gibi atlanÄ±r fiÅŸlerini',0),(492665,13686,'pl','Bony pomijane jako dnia przed ostatni dzieÅ„ blisko',0),(492666,13686,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€Ð¸ Ð¾Ñ‚ÑÑ‚Ñ€Ð°Ð½ÑÐ²Ð°Ñ‚ ÐºÐ¾Ð»ÐºÐ¾Ñ‚Ð¾ Ð´Ð°Ñ‚Ð° Ð¿Ñ€ÐµÐ´Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ',0),(492667,13686,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ Ø´Ú©Ù„ Ù…ÛŒÚº Ø¬ÛŒØ³Û’ Ø¨Ù†Ø¯ Ú©Û’ Ø¢Ø®Ø±ÛŒ ØªØ§Ø±ÛŒØ® Ø³Û’ Ù¾ÛÙ„Û’ Ù…Ø¤Ø±Ø®Û Ø§Ú†Ù¹ Ø¯ÛŒ Û”',0),(492668,13686,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€Ð¸ Ð¿Ñ€ÐµÑÐºÐ¾Ñ‡ÐµÐ½Ðµ ÐºÐ°Ð¾ Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾Ð³ Ð·Ð°Ð´ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐ°',0),(492669,13686,'vi','Chá»©ng tá»« bá» qua nhÆ° ngÃ y trÆ°á»›c cuá»‘i ngÃ y Ä‘Ã³ng',0),(492670,13686,'af','Bewyse soos gedateer voor laaste sluit datum oorgeslaan',0),(492671,13686,'ro','Bonuri de sarit, datat Ã®nainte de ultima data de aproape',0),(492672,13686,'et','Kannete vahele nagu kuupÃ¤eva enne viimase sulgemise kuupÃ¤ev',0),(492673,13686,'si','Bonov preskoÄila kot izpred zadnjih zakljuÄni datum',0),(492674,13686,'ba','Voucher melewatkan seperti tertanggal sebelum tanggal dekat terakhir',0),(492675,13686,'nl','Bonnen overgeslagen als gedateerd vÃ³Ã³r de laatste nauwe',0),(492676,13686,'fi','Tositteet ohitetaan kuin ennen viime pÃ¤ivÃ¤',0),(492677,13686,'no','Bilag hoppet som datert fÃ¸r siste dato',0),(492678,13686,'da','Gavekort sprunget som dateres fÃ¸r sidste afslutningsdato',0),(492679,13686,'ko','ìƒí’ˆê¶Œìœ¼ë¡œ ë§ˆì§€ë§‰ ë‹«ê¸° ë‚ ì§œ ì´ì „ì˜ ìƒëžµ',0),(492680,13686,'he','×©×•×‘×¨×™× ×“×™×œ×’ ×›×¤×™ ×™×¦× ××™×ª×” ×œ×¤× ×™ ×”×ª××¨×™×š ×”××—×¨×•×Ÿ ×§×¨×•×‘',0),(492681,13686,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹Î± ÎºÎ±ÏÎ±Î²Î¿ÎºÏÏÎ·Ï‚ ÏŒÏ€Ï‰Ï‚ Ï‡ÏÎ¿Î½Î¿Î»Î¿Î³ÎµÎ¯Ï„Î±Î¹ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ»ÎµÎ¹ÏƒÎ¯Î¼Î±Ï„Î¿Ï‚',0),(492682,13686,'zh','è·³è¿‡ï¼Œå› ä¸ºåœ¨æœ€åŽæˆªæ­¢æ—¥æœŸä¹‹å‰æ—¥çš„å‡­è¯',0),(492683,13686,'sv','Kuponger hoppade som dateras innan senaste stÃ¤ngningsdatumet',0),(492684,13686,'it','Buoni saltati come datato prima data ultima stretta',0),(492685,13686,'tl','',0),(492686,13686,'th','à¸‚à¹‰à¸²à¸¡à¹€à¸›à¹‡à¸™à¸§à¸±à¸™à¸à¹ˆà¸­à¸™à¸§à¸±à¸™à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢à¸›à¸´à¸”à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸',0),(492687,13686,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤ªà¤¿à¤›à¤²à¥‡ à¤•à¤°à¥€à¤¬ à¤¤à¤¾à¤°à¥€à¤– à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•à¤¿à¤¤ à¤›à¥‹à¤¡à¤¼à¥€ à¤—à¤ˆ',0),(492688,13686,'ms','Baucar yang dilangkau seperti yang bertarikh sebelum tarikh tutup',0),(492689,13686,'ar','Ù‚Ø³Ø§Ø¦Ù… ØªØ®Ø·ÙŠ ÙƒÙ…Ø§ Ù…Ø¤Ø±Ø®Ø© Ù‚Ø¨Ù„ ØªØ§Ø±ÙŠØ® Ø¥ØºÙ„Ø§Ù‚ Ø¢Ø®Ø±',0),(492690,13686,'fr','Bons ignorÃ©s que datÃ© d\'avant la date de clÃ´ture du dernier',0),(492691,13686,'jp','ãƒã‚¦ãƒãƒ£ãƒ¼ã®æœ€å¾Œã®çµ‚äº†æ—¥ã®å‰ã«æ—¥ã‚’ã‚¹ã‚­ãƒƒãƒ—',0),(492692,13686,'pt','Os vouchers ignorada como datada antes da Ãºltima data de fechamento',0),(492693,13686,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€Ñ‹ Ð¿Ñ€Ð¾Ð¿ÑƒÑ‰ÐµÐ½ ÐºÐ°Ðº Ð´Ð¾ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ¹ Ð´Ð°Ñ‚Ðµ Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¸Ñ',0),(492694,13686,'es','Vouchers saltados como fechados antes de la cirre de la ultima fecha',0),(492695,13686,'de','Gutscheine Ã¼bersprungen werden, wie vor dem letzten Abschlussdatum datiert',0),(492696,13686,'en','Vouchers skipped as dated before last close date',0),(492697,13687,'is','',0),(492698,13687,'dr','Ø®Ø±Ù…Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(492699,13687,'pr','Ø®Ø±Ù…Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(492700,13687,'tr','Tarihler baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(492701,13687,'pl','Daty pomyÅ›lnie zaktualizowane',0),(492702,13687,'bg','Ð”Ð°Ñ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½',0),(492703,13687,'ur','ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(492704,13687,'sr','Ð”Ð°Ñ‚ÑƒÐ¼Ð¸ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½.',0),(492705,13687,'vi','NgÃ y cáº­p nháº­t thÃ nh cÃ´ng',0),(492706,13687,'af','Datums Suksesvol Opdateer',0),(492707,13687,'ro','Datele actualizate cu succes',0),(492708,13687,'et','KuupÃ¤evad on vÃ¤rskendatud',0),(492709,13687,'si','Datumi uspeÅ¡no posodobljen',0),(492710,13687,'ba','Tanggal berhasil diperbarui',0),(492711,13687,'nl','Datums met succes bijgewerkt',0),(492712,13687,'fi','PÃ¤ivitetty pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(492713,13687,'no','Datoer er oppdatert',0),(492714,13687,'da','Datoer opdateret',0),(492715,13687,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•œ ë‚ ì§œ',0),(492716,13687,'he','×ª××¨×™×›×™ ×ž×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(492717,13687,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚ Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(492718,13687,'zh','å·²æˆåŠŸæ›´æ–°çš„æ—¥æœŸ',0),(492719,13687,'sv','Datum har uppdaterats',0),(492720,13687,'it','Date aggiornate correttamente',0),(492721,13687,'tl','',0),(492722,13687,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(492723,13687,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤',0),(492724,13687,'ms','Tarikh yang berjaya dikemaskini',0),(492725,13687,'ar','Ù…ÙˆØ§Ø¹ÙŠØ¯ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(492726,13687,'fr','Dates mis Ã  jour',0),(492727,13687,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸæ—¥ä»˜',0),(492728,13687,'pt','Datas atualizadas com sucesso',0),(492729,13687,'ru','Ð”Ð°Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(492730,13687,'es','Fechas Actualizadas Exitosamente',0),(492731,13687,'de','Daten erfolgreich aktualisiert',0),(492732,13687,'en','Dates Successfully Updated',0),(492733,13688,'is','',0),(492734,13688,'dr','ÙˆØ±ÙˆØ¯ÛŒÙ‡Ø§ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø± Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² ØªØ§Ø±ÛŒØ® Ø§Ø®ÛŒØ± Ù†Ø²Ø¯ÛŒÚ©',0),(492735,13688,'pr','ÙˆØ±ÙˆØ¯ÛŒÙ‡Ø§ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø± Ø±Ø§ Ù‚Ø¨Ù„ Ø§Ø² ØªØ§Ø±ÛŒØ® Ø§Ø®ÛŒØ± Ù†Ø²Ø¯ÛŒÚ©',0),(492736,13688,'tr','GÃ¼nlÃ¼k girdileri en son kapanÄ±ÅŸ tarihi Ã¶ncesinde',0),(492737,13688,'pl','Wpisy do dziennika w najnowszej daty blisko',0),(492738,13688,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ° Ð½Ð° Ð¿Ñ€ÐµÐ´Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð²Ð°Ð½Ðµ',0),(492739,13688,'ur','ØªØ§Ø²Û ØªØ±ÛŒÙ† Ù‚Ø±ÛŒØ¨ÛŒ ØªØ§Ø±ÛŒØ® Ø³Û’ Ù¾ÛÙ„Û’ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(492740,13688,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ Ñ˜Ðµ ÑƒÐ¾Ñ‡Ð¸ Ð½Ð°Ñ˜Ð½Ð¾Ð²Ð¸Ñ˜Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐ°',0),(492741,13688,'vi','Cá»§a táº¡p chÃ­ entries trÆ°á»›c khi Ä‘áº·t gáº§n ngÃ y',0),(492742,13688,'af','Se joernaalinskrywings voor mees onlangse sluit datum',0),(492743,13688,'ro','Jurnal datei aproape cele mai recente',0),(492744,13688,'et','TÃ¶Ã¶lehe kandeid enne viimase sulgemise kuupÃ¤ev',0),(492745,13688,'si','Dnevnik pred zadnji zakljuÄni datum',0),(492746,13688,'ba','Jurnal sebelum Pemesanan tanggal tutup',0),(492747,13688,'nl','Logboekitems voorafgaand aan de meest recente afsluitdatum',0),(492748,13688,'fi','PÃ¤ivyrimerkintÃ¶jen ennen Viimeisin pÃ¤ivÃ¤',0),(492749,13688,'no','LoggoppfÃ¸ringer fÃ¸r siste dato',0),(492750,13688,'da','Journaloptegnelser fÃ¸r de seneste afslutningsdato',0),(492751,13688,'ko','ê°€ìž¥ ìµœê·¼ ê°€ê¹Œìš´ ë‚ ì§œ ì´ì „ ì €ë„ì˜ í•­ëª©',0),(492752,13688,'he','×¢×¨×›×™ ×©×œ ×”×™×•×ž×Ÿ ×”××—×¨×•× ×” ×œ×ª××¨×™×š ×§×¨×•×‘',0),(492753,13688,'el','Î•Ï†Î·Î¼ÎµÏÎ¯Î´Î± Ï„Î¿Ï… ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Ï€Î¹Î¿ Ï€ÏÏŒÏƒÏ†Î±Ï„Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ»ÎµÎ¹ÏƒÎ¯Î¼Î±Ï„Î¿Ï‚',0),(492754,13688,'zh','æ—¥è®°åœ¨æœ€è¿‘çš„ç»“æŸæ—¥æœŸä¹‹å‰',0),(492755,13688,'sv','Journalposter fÃ¶re senaste nÃ¤ra',0),(492756,13688,'it','Voci del diario prima della data di chiusura piÃ¹ recente',0),(492757,13688,'tl','',0),(492758,13688,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸‚à¸­à¸‡à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¸à¹ˆà¸­à¸™à¸§à¸±à¸™à¸›à¸´à¸”à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(492759,13688,'hi','à¤¸à¤¬à¤¸à¥‡ à¤¹à¤¾à¤² à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤•à¤°à¥€à¤¬ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¹à¥ˆ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(492760,13688,'ms','Entri jurnal sebelum tarikh tutup yang',0),(492761,13688,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ© Ù‚Ø¨Ù„ ØªØ§Ø±ÙŠØ® Ø¥ØºÙ„Ø§Ù‚ Ø¢Ø®Ø±',0),(492762,13688,'fr','EntrÃ©es du journal avant la date de clÃ´ture du plus rÃ©cente',0),(492763,13688,'jp','æœ€ã‚‚æœ€è¿‘ã®ã‚¯ãƒ­ãƒ¼ã‚ºæ—¥ã®å‰ã«ä»•è¨³å¸³ã®ã‚¨ãƒ³ãƒˆãƒª',0),(492764,13688,'pt','Entradas de diÃ¡rio, antes da data de fechamento mais recente',0),(492765,13688,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð¾ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ¹ Ð´Ð°Ñ‚Ðµ Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¸Ñ',0),(492766,13688,'es','Entradas de Diario Antes de Fecha de Cierre MÃ¡s Recente',0),(492767,13688,'de','JournaleintrÃ¤ge vor dem aktuellen Datum',0),(492768,13688,'en','Journal\'s entries prior to most recent close date',0),(492769,13689,'is','',0),(492770,13689,'dr','ØªØ§Ø±ÛŒØ® Ø§ØµÙ„ÛŒ',0),(492771,13689,'pr','ØªØ§Ø±ÛŒØ® Ø§ØµÙ„ÛŒ',0),(492772,13689,'tr','Orijinal Tarih',0),(492773,13689,'pl','Pierwotny datowaÄ‡',0),(492774,13689,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(492775,13689,'ur','Ø§ØµÙ„ ØªØ§Ø±ÛŒØ®',0),(492776,13689,'sr','ÐžÑ€Ð¸Ð³Ð¸Ð½Ð°Ð»Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(492777,13689,'vi','NgÃ y ban Ä‘áº§u',0),(492778,13689,'af','Oorspronklike datum',0),(492779,13689,'ro','Original data',0),(492780,13689,'et','AlgkuupÃ¤ev',0),(492781,13689,'si','Izvirni datum',0),(492782,13689,'ba','Tanggal asli',0),(492783,13689,'nl','Oorspronkelijke datum',0),(492784,13689,'fi','AlkuperÃ¤inen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(492785,13689,'no','Opprinnelig dato',0),(492786,13689,'da','Oprindelige dato',0),(492787,13689,'ko','ì›ëž˜ ë‚ ì§œ',0),(492788,13689,'he','×ª××¨×™×š ×”×™×¦×™××” ×”×ž×§×•×¨×™',0),(492789,13689,'el','Î‘ÏÏ‡Î¹ÎºÎ® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(492790,13689,'zh','åŽŸå§‹æ—¥æœŸ',0),(492791,13689,'sv','Ursprungligt datum',0),(492792,13689,'it','Data originale',0),(492793,13689,'tl','',0),(492794,13689,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(492795,13689,'hi','à¤®à¥‚à¤² à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(492796,13689,'ms','Tarikh asal',0),(492797,13689,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø£ØµÙ„ÙŠ',0),(492798,13689,'fr','Date d\'origine',0),(492799,13689,'jp','å…ƒã®æ—¥ä»˜',0),(492800,13689,'pt','Data original',0),(492801,13689,'ru','Ð˜ÑÑ…Ð¾Ð´Ð½Ð°Ñ Ð´Ð°Ñ‚Ð°',0),(492802,13689,'es','Fecha Original',0),(492803,13689,'de','Originaldatum',0),(492804,13689,'en','Original Date',0),(492805,13690,'is','',0),(492806,13690,'dr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± ØªØ§Ø±ÛŒØ®Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯',0),(492807,13690,'pr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± ØªØ§Ø±ÛŒØ®Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯',0),(492808,13690,'tr','Yeni tarihleri kaydetmek',0),(492809,13690,'pl','Zapisz nowe terminy',0),(492810,13690,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¸',0),(492811,13690,'ur','Ù†Ø¦ÛŒ ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(492812,13690,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ‚Ð¸ Ð½Ð¾Ð²Ðµ Ð´Ð°Ñ‚ÑƒÐ¼Ðµ',0),(492813,13690,'vi','Tiáº¿t kiá»‡m má»›i ngÃ y',0),(492814,13690,'af','Stoor nuwe datums',0),(492815,13690,'ro','Salva noi date',0),(492816,13690,'et','Salvesta uued kuupÃ¤evad',0),(492817,13690,'si','Shranite nove datume',0),(492818,13690,'ba','Simpan tanggal baru',0),(492819,13690,'nl','Nieuwe data opslaan',0),(492820,13690,'fi','Tallenna uudet pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(492821,13690,'no','Lagre nye datoer',0),(492822,13690,'da','Gem nye datoer',0),(492823,13690,'ko','ìƒˆë¡œìš´ ë‚ ì§œë¥¼ ì €ìž¥',0),(492824,13690,'he','×œ×”×¦×™×œ ××ª ×”×ª××¨×™×›×™× ×”×—×“×©×™×',0),(492825,13690,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï„Î¹Ï‚ Î½Î­ÎµÏ‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(492826,13690,'zh','ä¿å­˜æ–°çš„æ—¥æœŸ',0),(492827,13690,'sv','Spara nya datum',0),(492828,13690,'it','Salvare le nuove date',0),(492829,13690,'tl','',0),(492830,13690,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸§à¸±à¸™à¸—à¸µà¹ˆà¹ƒà¸«à¸¡à¹ˆ',0),(492831,13690,'hi','à¤¨à¤ˆ à¤¤à¤¾à¤°à¥€à¤–à¥‹à¤‚ à¤•à¥‹ à¤¬à¤šà¤¾à¤¨à¥‡',0),(492832,13690,'ms','Simpan tarikh baru',0),(492833,13690,'ar','Ø­ÙØ¸ Ø§Ù„ØªÙˆØ§Ø±ÙŠØ® Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(492834,13690,'fr','Enregistrez les nouvelles Dates',0),(492835,13690,'jp','æ–°ã—ã„æ—¥ä»˜ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(492836,13690,'pt','Salvar novas datas',0),(492837,13690,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ðµ Ð´Ð°Ñ‚Ñ‹',0),(492838,13690,'es','Guardar Nuevas Fechas',0),(492839,13690,'de','Neue Termine speichern',0),(492840,13690,'en','Save New Dates',0),(492841,13691,'is','',0),(492842,13691,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯',0),(492843,13691,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯',0),(492844,13691,'tr','GÃ¼ncelleÅŸtirme baÅŸarÄ±sÄ±z oldu',0),(492845,13691,'pl','Aktualizacji nie powiodÅ‚o siÄ™',0),(492846,13691,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(492847,13691,'ur','Ù†Ø§Ú©Ø§Ù… Ø§Ù¾ ÚˆÛŒÙ¹Ø³',0),(492848,13691,'sr','Ð˜ÑÐ¿Ñ€Ð°Ð²ÐºÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(492849,13691,'vi','CÃ¡c báº£n Cáº­p Nháº­t khÃ´ng thÃ nh cÃ´ng',0),(492850,13691,'af','Bywerkings het misluk',0),(492851,13691,'ro','ActualizÄƒri nu a reuÈ™it',0),(492852,13691,'et','Uuendused nurjus',0),(492853,13691,'si','Modernizirati ne zadostovati',0),(492854,13691,'ba','Update gagal',0),(492855,13691,'nl','Updates mislukt',0),(492856,13691,'fi','PÃ¤ivityksiÃ¤ epÃ¤onnistui',0),(492857,13691,'no','Oppdaterer mislykkes',0),(492858,13691,'da','Opdateringer mislykkedes',0),(492859,13691,'ko','ì—…ë°ì´íŠ¸ ì‹¤íŒ¨',0),(492860,13691,'he','×”×¢×“×›×•× ×™× × ×›×©×œ',0),(492861,13691,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹Ï‚ Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(492862,13691,'zh','æ›´æ–°å¤±è´¥',0),(492863,13691,'sv','Uppdateringar misslyckades',0),(492864,13691,'it','Aggiornamenti non riusciti',0),(492865,13691,'tl','',0),(492866,13691,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(492867,13691,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(492868,13691,'ms','Kemas kini yang gagal',0),(492869,13691,'ar','ÙØ´Ù„ Ø§Ù„ØªØ­Ø¯ÙŠØ«Ø§Øª',0),(492870,13691,'fr','Mises Ã  jour a Ã©chouÃ©',0),(492871,13691,'jp','æ›´æ–°ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(492872,13691,'pt','AtualizaÃ§Ãµes falhadas',0),(492873,13691,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(492874,13691,'es','Actualizaciones Fallaron',0),(492875,13691,'de','Updates fehlgeschlagen',0),(492876,13691,'en','Updates Failed',0),(492877,13692,'is','',0),(492878,13692,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¢ÛŒØªÙ… Ø´Ù…Ø§Ø±Ù‡',0),(492879,13692,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¢ÛŒØªÙ… Ø´Ù…Ø§Ø±Ù‡',0),(492880,13692,'tr','SatÄ±cÄ± Madde numarasÄ±',0),(492881,13692,'pl','Dostawcy towaru',0),(492882,13692,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(492883,13692,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¢Ø¦Ù¹Ù… Ù†Ù…Ø¨Ø±',0),(492884,13692,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°.',0),(492885,13692,'vi','Sá»‘ lÆ°á»£ng bÃ¡n hÃ ng',0),(492886,13692,'af','Handelaar Item nommer',0),(492887,13692,'ro','NumÄƒrul de articol furnizor',0),(492888,13692,'et','Hankija kaubakood',0),(492889,13692,'si','Å tevilka artikla dobavitelja',0),(492890,13692,'ba','Penjual Item nomor',0),(492891,13692,'nl','Het artikelnummer leverancier',0),(492892,13692,'fi','Toimittajan nimikenro',0),(492893,13692,'no','LeverandÃ¸rens varenummer',0),(492894,13692,'da','LeverandÃ¸rens varenummer',0),(492895,13692,'ko','ê³µê¸‰ ì—…ì²´ í•­ëª© ë²ˆí˜¸',0),(492896,13692,'he','×ž×¡×¤×¨ ×¤×¨×™×˜ ×”×¡×¤×§',0),(492897,13692,'el','Î•Î¯Î´Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(492898,13692,'zh','ä¾›åº”å•†ç‰©æ–™ç¼–å·',0),(492899,13692,'sv','LeverantÃ¶rens artikelnummer',0),(492900,13692,'it','Numero articolo fornitore',0),(492901,13692,'tl','',0),(492902,13692,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸ªà¸´à¸™à¸„à¹‰à¸²à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(492903,13692,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤†à¤‡à¤Ÿà¤® à¤¨à¤‚à¤¬à¤°',0),(492904,13692,'ms','Penjual Item nombor',0),(492905,13692,'ar','Ø±Ù‚Ù… Ø§Ù„ØµÙ†Ù Ø§Ù„Ù…ÙˆØ±Ø¯',0),(492906,13692,'fr','NumÃ©ro d\'article fournisseur',0),(492907,13692,'jp','ä»•å…¥å…ˆã®å“ç›®ç•ªå·',0),(492908,13692,'pt','NÃºmero de artigo do fornecedor',0),(492909,13692,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¿ÑƒÐ½ÐºÑ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(492910,13692,'es','Proveedor NÃºmero de Item',0),(492911,13692,'de','Lieferanten-Artikelnummer',0),(492912,13692,'en','Vendor Item Number',0),(492913,13693,'is','',0),(492914,13693,'dr','Ù‡Ø²ÛŒÙ†Ù‡ ØµØ§Ø¯Ø±Ø§Øª Ùˆ Ø³Ø·Ø­ Ø¬ÙˆØ±Ø§Ø¨ Ø²Ù†Ø§Ù†Ù‡ Ø³Ø§Ù‚Ù‡ Ø¨Ù„Ù†Ø¯',0),(492915,13693,'pr','Ù‡Ø²ÛŒÙ†Ù‡ ØµØ§Ø¯Ø±Ø§Øª Ùˆ Ø³Ø·Ø­ Ø¬ÙˆØ±Ø§Ø¨ Ø²Ù†Ø§Ù†Ù‡ Ø³Ø§Ù‚Ù‡ Ø¨Ù„Ù†Ø¯',0),(492916,13693,'tr','Ä°hracat maliyetlerini ve Ã§orap dÃ¼zeyleri',0),(492917,13693,'pl','Koszty wywozu i poziomy zapasÃ³w',0),(492918,13693,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ Ð¸ Ð¾Ñ‚Ð³Ð»ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð¸Ð²Ð°',0),(492919,13693,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø§ÙˆØ± Ø°Ø®ÛŒØ±Û Ú©Ø±Ù†Û’ Ú©ÛŒ Ø³Ø·Ø­ Ø¨Ø±Ø¢Ù…Ø¯',0),(492920,13693,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð¸Ð·Ð²Ð¾Ð·Ð° Ð¸ Ð¸Ð°Ñ€Ð°Ð¿Ñƒ Ð½Ð¸Ð²Ð¾Ð°',0),(492921,13693,'vi','Chi phÃ­ xuáº¥t kháº©u vÃ  tháº£ cáº¥p',0),(492922,13693,'af','Uitvoer koste en kous vlakke',0),(492923,13693,'ro','Costurile de export ÅŸi nivelurile de stocare',0),(492924,13693,'et','Ekspordi kulusid ja loomkoormuse tasemed',0),(492925,13693,'si','Izvozne stroÅ¡ke in obremenitve ravni',0),(492926,13693,'ba','Biaya ekspor dan tingkat stoking',0),(492927,13693,'nl','Kosten en kous niveaus exporteren',0),(492928,13693,'fi','Vientikustannukset ja sileÃ¤Ã¤ tasoilla',0),(492929,13693,'no','Eksportere kostnader og strÃ¸mpe nivÃ¥er',0),(492930,13693,'da','Eksportere omkostninger og strÃ¸mpe niveauer',0),(492931,13693,'ko','ìˆ˜ì¶œ ë¹„ìš© ë° ìŠ¤íƒ€í‚¹ ìˆ˜ì¤€',0),(492932,13693,'he','×¢×œ×•×™×•×ª ×”×™×™×¦×•× ×•×¨×ž×•×ª ×’×¨×‘',0),(492933,13693,'el','Î¤o ÎºÏŒÏƒÏ„oÏ‚ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ ÎºÎ±Î¹ Ï„Î± ÎµÏ€Î¯Ï€ÎµÎ´Î± Ï„Î¿Ï… Î´ÎµÎ¯ÎºÏ„Î·',0),(492934,13693,'zh','å‡ºå£æˆæœ¬å’Œåº“å­˜é‡',0),(492935,13693,'sv','Exportkostnader och strumpan nivÃ¥er',0),(492936,13693,'it','Esportazione costi e livelli di stoccaggio',0),(492937,13693,'tl','',0),(492938,13693,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸à¹à¸¥à¸°à¸£à¸°à¸”à¸±à¸šà¸à¸²à¸£à¹€à¸à¹‡à¸šà¸ªà¸•à¹‡à¸­à¸',0),(492939,13693,'hi','à¤²à¤¾à¤—à¤¤ à¤”à¤° à¤®à¥‹à¤œà¤¾ à¤¸à¥à¤¤à¤°à¥‹à¤‚ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(492940,13693,'ms','Kos eksport dan tahap stok',0),(492941,13693,'ar','ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„ØªØµØ¯ÙŠØ± ÙˆÙ…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(492942,13693,'fr','CoÃ»ts d\'exportation et de niveaux de stockage',0),(492943,13693,'jp','è¼¸å‡ºè²»ç”¨ã¨ã‚¹ãƒˆãƒƒã‚­ãƒ³ã‚°ã®ãƒ¬ãƒ™ãƒ«',0),(492944,13693,'pt','Custos de exportaÃ§Ã£o e os nÃ­veis de lotaÃ§Ã£o',0),(492945,13693,'ru','Ð—Ð°Ñ‚Ñ€Ð°Ñ‚ Ð¸ Ñ€Ñ‹Ð½Ð¾Ñ‡Ð½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°',0),(492946,13693,'es','Costos de ExportaciÃ³n y Niveles de Almacenamiento',0),(492947,13693,'de','Kosten und Strumpf Ebenen exportieren',0),(492948,13693,'en','Export Costs and Stocking Levels',0),(492949,13694,'is','',0),(492950,13694,'dr','ÙØµÙ„ 1 Ø­Ø¯Ø§Ú©Ø«Ø±',0),(492951,13694,'pr','ÙØµÙ„ 1 Ø­Ø¯Ø§Ú©Ø«Ø±',0),(492952,13694,'tr','Sezon 1 Max',0),(492953,13694,'pl','Max sezon 1',0),(492954,13694,'bg','Ð¡ÐµÐ·Ð¾Ð½ 1 ÐœÐ°ÐºÑ',0),(492955,13694,'ur','Ù…ÛŒÚ©Ø³ Ù…ÙˆØ³Ù… 1',0),(492956,13694,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 1 ÐœÐ°x',0),(492957,13694,'vi','Max mÃ¹a 1',0),(492958,13694,'af','Seisoen 1 Max',0),(492959,13694,'ro','Sezonul 1 Max',0),(492960,13694,'et','Season 1 Max',0),(492961,13694,'si','Sezona 1 Max',0),(492962,13694,'ba','Musim 1 Max',0),(492963,13694,'nl','Seizoen 1 Max',0),(492964,13694,'fi','Kausi 1 Max',0),(492965,13694,'no','Sesong 1 Max',0),(492966,13694,'da','SÃ¦son 1 Max',0),(492967,13694,'ko','ì‹œì¦Œ 1 ìµœëŒ€',0),(492968,13694,'he','×ž×§×¡ ×¢×•× ×” 1',0),(492969,13694,'el','Max ÏƒÎµÎ¶ÏŒÎ½ 1',0),(492970,13694,'zh','ç¬¬ 1 å­£æœ€å¤§',0),(492971,13694,'sv','SÃ¤song 1 Max',0),(492972,13694,'it','Max stagione 1',0),(492973,13694,'tl','',0),(492974,13694,'th','à¸¤à¸”à¸¹à¸à¸²à¸¥à¸—à¸µà¹ˆ 1 à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(492975,13694,'hi','à¤®à¥ˆà¤•à¥à¤¸ 1 à¤®à¥Œà¤¸à¤®',0),(492976,13694,'ms','Max musim 1',0),(492977,13694,'ar','Ù…Ø§ÙƒØ³ Ø§Ù„Ù…ÙˆØ³Ù… 1',0),(492978,13694,'fr','Max saison 1',0),(492979,13694,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 1 Max',0),(492980,13694,'pt','Max temporada 1',0),(492981,13694,'ru','ÐœÐ°ÐºÑ ÑÐµÐ·Ð¾Ð½ 1',0),(492982,13694,'es','Temporada 1 MÃ¡ximo',0),(492983,13694,'de','Staffel 1-Max',0),(492984,13694,'en','Season 1 Max',0),(492985,13695,'is','',0),(492986,13695,'dr','ÙØµÙ„ 1 Ø¯Ù‚ÛŒÙ‚Ù‡',0),(492987,13695,'pr','ÙØµÙ„ 1 Ø¯Ù‚ÛŒÙ‚Ù‡',0),(492988,13695,'tr','Sezon 1 dk',0),(492989,13695,'pl','Sezon 1 Min',0),(492990,13695,'bg','Ð¡ÐµÐ·Ð¾Ð½ 1 Ð¼Ð¸Ð½.',0),(492991,13695,'ur','Ù…ÙˆØ³Ù… 1 Ù…Ù†Ù¹',0),(492992,13695,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 1 ÐœÐ¸Ð½',0),(492993,13695,'vi','MÃ¹a 1 phÃºt',0),(492994,13695,'af','Geur 1 Min',0),(492995,13695,'ro','Sezonul 1 Min',0),(492996,13695,'et','Season 1 Min',0),(492997,13695,'si','Sezona 1 Min',0),(492998,13695,'ba','Musim 1 Min',0),(492999,13695,'nl','Seizoen 1 Min',0),(493000,13695,'fi','Kausi 1 Min',0),(493001,13695,'no','Sesong 1 Min',0),(493002,13695,'da','SÃ¦son 1 Min',0),(493003,13695,'ko','ì‹œì¦Œ 1 ë¶„',0),(493004,13695,'he','×¢×•× ×” 1 ×“×§×•×ª',0),(493005,13695,'el','Î£ÎµÎ¶ÏŒÎ½ 1 Min',0),(493006,13695,'zh','å­£èŠ‚ 1 åˆ†é’Ÿ',0),(493007,13695,'sv','SÃ¤song 1 Min',0),(493008,13695,'it','Stagione 1 Min',0),(493009,13695,'tl','',0),(493010,13695,'th','à¸‹à¸µà¸‹à¸±à¹ˆà¸™ 1 à¸™à¸²à¸—à¸µ',0),(493011,13695,'hi','à¤¸à¥€à¤œà¤¨ 1 à¤®à¤¿à¤¨à¤Ÿ',0),(493012,13695,'ms','Musim 1 Min',0),(493013,13695,'ar','Ø§Ù„Ù…ÙˆØ³Ù… 1 Ø¯Ù‚ÙŠÙ‚Ø©',0),(493014,13695,'fr','Saison 1 Min',0),(493015,13695,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 1 åˆ†',0),(493016,13695,'pt','Temporada 1 Min',0),(493017,13695,'ru','Ð¡ÐµÐ·Ð¾Ð½ 1 Ð¼Ð¸Ð½',0),(493018,13695,'es','Temporada 1 MÃ­nimo',0),(493019,13695,'de','Staffel 1 Min',0),(493020,13695,'en','Season 1 Min',0),(493021,13696,'is','',0),(493022,13696,'dr','Ù†Ø§Ù… ÙØµÙ„ 1',0),(493023,13696,'pr','Ù†Ø§Ù… ÙØµÙ„ 1',0),(493024,13696,'tr','Sezon 1 adÄ±',0),(493025,13696,'pl','Nazwa sezon 1',0),(493026,13696,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 1',0),(493027,13696,'ur','Ù†Ø§Ù… Ù…ÙˆØ³Ù… 1',0),(493028,13696,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 1 Ð¸Ð¼Ðµ',0),(493029,13696,'vi','MÃ¹a 1 tÃªn',0),(493030,13696,'af','Seisoen 1 naam',0),(493031,13696,'ro','Sezonul 1 nume',0),(493032,13696,'et','Season 1 nimi',0),(493033,13696,'si','Sezona 1 ime',0),(493034,13696,'ba','Musim 1 nama',0),(493035,13696,'nl','Seizoen 1 naam',0),(493036,13696,'fi','Kausi 1 nimi',0),(493037,13696,'no','Sesong 1 navn',0),(493038,13696,'da','SÃ¦son 1 navn',0),(493039,13696,'ko','ì‹œì¦Œ 1 ì´ë¦„',0),(493040,13696,'he','×”×©× ×¢×•× ×” 1',0),(493041,13696,'el','Î£ÎµÎ¶ÏŒÎ½ 1 ÏŒÎ½Î¿Î¼Î±',0),(493042,13696,'zh','ç¬¬ 1 å­£çš„åå­—',0),(493043,13696,'sv','SÃ¤song 1 namn',0),(493044,13696,'it','Nome stagione 1',0),(493045,13696,'tl','',0),(493046,13696,'th','à¸Šà¸·à¹ˆà¸­à¸¤à¸”à¸¹à¸à¸²à¸¥à¸—à¸µà¹ˆ 1',0),(493047,13696,'hi','à¤¸à¥€à¤œà¤¨ 1 à¤¨à¤¾à¤®',0),(493048,13696,'ms','Musim 1 nama',0),(493049,13696,'ar','Ø§Ø³Ù… Ø§Ù„Ù…ÙˆØ³Ù… 1',0),(493050,13696,'fr','Nom de la saison 1',0),(493051,13696,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 1 å',0),(493052,13696,'pt','Nome da temporada 1',0),(493053,13696,'ru','Ð¡ÐµÐ·Ð¾Ð½ 1 Ð¸Ð¼Ñ',0),(493054,13696,'es','Temporada 1 Nombre',0),(493055,13696,'de','Staffel 1-Name',0),(493056,13696,'en','Season 1 Name',0),(493057,13697,'is','',0),(493058,13697,'dr','ÙØµÙ„ 1 ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´',0),(493059,13697,'pr','ÙØµÙ„ 1 ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´',0),(493060,13697,'tr','Sezon 1 sipariÅŸ Mkt.',0),(493061,13697,'pl','Sezon 1 iloÅ›Ä‡ zamÃ³wienia',0),(493062,13697,'bg','Ð¡ÐµÐ·Ð¾Ð½ 1 Ñ€ÐµÐ´ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(493063,13697,'ur','Ù…ÙˆØ³Ù… 1 Ø§Ù…Ø§Ù† Ú©Û’ Ù‚ÛŒ',0),(493064,13697,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 1 Ñ€ÐµÐ´ ÐšÐ¾Ð».',0),(493065,13697,'vi','MÃ¹a 1 thá»© tá»± Qty',0),(493066,13697,'af','Seisoen 1 orde Qty',0),(493067,13697,'ro','Cantitate de ordinul 1 sezon',0),(493068,13697,'et','Season 1 tellimuse kogus',0),(493069,13697,'si','Sezona 1 koliÄina naloga',0),(493070,13697,'ba','Musim 1 Order Qty',0),(493071,13697,'nl','Seizoen 1 afname',0),(493072,13697,'fi','Kausi 1 tilauksen mÃ¤Ã¤rÃ¤',0),(493073,13697,'no','Sesong 1 rekkefÃ¸lgen antall',0),(493074,13697,'da','SÃ¦son 1 ordre antal',0),(493075,13697,'ko','ì‹œì¦Œ 1 ìˆœì„œ Qty',0),(493076,13697,'he','×¢×•× ×” 1 ×›×ž×•×ª ×”×–×ž× ×”',0),(493077,13697,'el','Î£ÎµÎ¶ÏŒÎ½ 1 Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(493078,13697,'zh','èµ›å­£ 1 è®¢è´­æ•°é‡',0),(493079,13697,'sv','SÃ¤song 1 ordning Kvt',0),(493080,13697,'it','Stagione 1 ordine Qty',0),(493081,13697,'tl','',0),(493082,13697,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ 1 à¸¤à¸”à¸¹à¸à¸²à¸¥',0),(493083,13697,'hi','à¤¸à¥€à¤œà¤¨ 1 à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(493084,13697,'ms','Qty pesanan 1 musim',0),(493085,13697,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© 1 ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…ÙˆØ³Ù…',0),(493086,13697,'fr','Saison 1 Order Qty',0),(493087,13697,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 1 ã®æ³¨æ–‡æ•°é‡',0),(493088,13697,'pt','Qty da ordem 1 temporada',0),(493089,13697,'ru','1 ÑÐµÐ·Ð¾Ð½ Ð¿Ð¾ Ð·Ð°ÐºÐ°Ð·Ñƒ',0),(493090,13697,'es','Temporada 1 Cantidad de la Orden',0),(493091,13697,'de','Saison 1 Bestellmenge',0),(493092,13697,'en','Season 1 Order Qty',0),(493093,13698,'is','',0),(493094,13698,'dr','Ø­Ø¯Ø§Ú©Ø«Ø± ÙØµÙ„ 2',0),(493095,13698,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± ÙØµÙ„ 2',0),(493096,13698,'tr','Sezon 2 Max',0),(493097,13698,'pl','Max sezon 2',0),(493098,13698,'bg','Ð¡ÐµÐ·Ð¾Ð½ 2 ÐœÐ°ÐºÑ',0),(493099,13698,'ur','Ø§ÙˆÙ¾Ø± 2 Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(493100,13698,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 2 ÐœÐ°x',0),(493101,13698,'vi','MÃ¹a 2 Max',0),(493102,13698,'af','Seisoen 2 Max',0),(493103,13698,'ro','Sezonul 2 Max',0),(493104,13698,'et','Season 2 Max',0),(493105,13698,'si','Sezona 2 Max',0),(493106,13698,'ba','Musim 2 Max',0),(493107,13698,'nl','Seizoen 2 Max',0),(493108,13698,'fi','Kausi 2 Max',0),(493109,13698,'no','Sesong 2 Max',0),(493110,13698,'da','SÃ¦son 2 Max',0),(493111,13698,'ko','ì‹œì¦Œ 2 ë§¥ìŠ¤',0),(493112,13698,'he','×ž×§×¡ ×¢×•× ×” 2',0),(493113,13698,'el','Î£ÎµÎ¶ÏŒÎ½ 2 Max',0),(493114,13698,'zh','ç¬¬ 2 å­£æœ€å¤§',0),(493115,13698,'sv','SÃ¤song 2 Max',0),(493116,13698,'it','Max stagione 2',0),(493117,13698,'tl','',0),(493118,13698,'th','à¸¤à¸”à¸¹à¸à¸²à¸¥à¸—à¸µà¹ˆ 2 à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(493119,13698,'hi','à¤¸à¥€à¤œà¤¨ 2 Max',0),(493120,13698,'ms','Max musim ke-2',0),(493121,13698,'ar','Ù…Ø§ÙƒØ³ Ø§Ù„Ù…ÙˆØ³Ù… 2',0),(493122,13698,'fr','Max saison 2',0),(493123,13698,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 2 ãƒžãƒƒã‚¯ã‚¹',0),(493124,13698,'pt','Max temporada 2',0),(493125,13698,'ru','ÐœÐ°ÐºÑ 2 ÑÐµÐ·Ð¾Ð½',0),(493126,13698,'es','Temporada 2 MÃ¡ximo',0),(493127,13698,'de','Staffel 2 Max',0),(493128,13698,'en','Season 2 Max',0),(493129,13699,'is','',0),(493130,13699,'dr','ÙØµÙ„ 2 Ø¯Ù‚ÛŒÙ‚Ù‡',0),(493131,13699,'pr','ÙØµÙ„ 2 Ø¯Ù‚ÛŒÙ‚Ù‡',0),(493132,13699,'tr','Sezon 2 dk',0),(493133,13699,'pl','Sezon 2 Min',0),(493134,13699,'bg','Ð¡ÐµÐ·Ð¾Ð½ 2 Ð¼Ð¸Ð½.',0),(493135,13699,'ur','Ù…ÙˆØ³Ù… 2 Ù…Ù†Ù¹',0),(493136,13699,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 2 ÐœÐ¸Ð½',0),(493137,13699,'vi','MÃ¹a 2 phÃºt',0),(493138,13699,'af','Geur 2 Min',0),(493139,13699,'ro','Sezonul 2 Min',0),(493140,13699,'et','Season 2 Min',0),(493141,13699,'si','Sezona 2 Min',0),(493142,13699,'ba','Musim 2 Min',0),(493143,13699,'nl','Seizoen 2 Min',0),(493144,13699,'fi','Season 2 Min',0),(493145,13699,'no','Sesong 2 Min',0),(493146,13699,'da','SÃ¦son 2 Min',0),(493147,13699,'ko','ì‹œì¦Œ 2 ë¶„',0),(493148,13699,'he','×¢×•× ×” 2 ×“×§×•×ª',0),(493149,13699,'el','Î£ÎµÎ¶ÏŒÎ½ 2 Min',0),(493150,13699,'zh','å­£èŠ‚ 2 åˆ†é’Ÿ',0),(493151,13699,'sv','SÃ¤song 2 Min',0),(493152,13699,'it','Stagione 2 Min',0),(493153,13699,'tl','',0),(493154,13699,'th','à¸‹à¸µà¸‹à¸±à¹ˆà¸™ 2 à¸™à¸²à¸—à¸µ',0),(493155,13699,'hi','à¤¸à¥€à¤œà¤¨ 2 Min',0),(493156,13699,'ms','Musim 2 Min',0),(493157,13699,'ar','Ø§Ù„Ù…ÙˆØ³Ù… 2 Ø¯Ù‚ÙŠÙ‚Ø©',0),(493158,13699,'fr','Saison 2 Min',0),(493159,13699,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 2 åˆ†',0),(493160,13699,'pt','Temporada 2 Min',0),(493161,13699,'ru','Ð¡ÐµÐ·Ð¾Ð½ 2 Ð¼Ð¸Ð½',0),(493162,13699,'es','Temporada 2 MÃ­nimo',0),(493163,13699,'de','Staffel 2 Min',0),(493164,13699,'en','Season 2 Min',0),(493165,13700,'is','',0),(493166,13700,'dr','Ù†Ø§Ù… ÙØµÙ„ 2',0),(493167,13700,'pr','Ù†Ø§Ù… ÙØµÙ„ 2',0),(493168,13700,'tr','Sezon 2 adÄ±',0),(493169,13700,'pl','Nazwa sezon 2',0),(493170,13700,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 2',0),(493171,13700,'ur','Ø§ÙˆÙ¾Ø± 2 Ù†Ø§Ù…',0),(493172,13700,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 2 Ð¸Ð¼Ðµ',0),(493173,13700,'vi','MÃ¹a 2 tÃªn',0),(493174,13700,'af','Seisoen 2 naam',0),(493175,13700,'ro','Sezonul 2 nume',0),(493176,13700,'et','Season 2 nimi',0),(493177,13700,'si','Sezona 2 ime',0),(493178,13700,'ba','Musim 2 nama',0),(493179,13700,'nl','Seizoen 2 naam',0),(493180,13700,'fi','Kausi 2 nimi',0),(493181,13700,'no','Sesong 2 navn',0),(493182,13700,'da','SÃ¦son 2 navn',0),(493183,13700,'ko','ì‹œì¦Œ 2 ì´ë¦„',0),(493184,13700,'he','×”×©× ×¢×•× ×” 2',0),(493185,13700,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏ€Î¿Ï‡Î®Ï‚ 2',0),(493186,13700,'zh','å­£èŠ‚ 2 çš„åç§°',0),(493187,13700,'sv','SÃ¤song 2 namn',0),(493188,13700,'it','Nome stagione 2',0),(493189,13700,'tl','',0),(493190,13700,'th','à¸Šà¸·à¹ˆà¸­à¸¤à¸”à¸¹à¸à¸²à¸¥à¸—à¸µà¹ˆ 2',0),(493191,13700,'hi','à¤¸à¥€à¤œà¤¨ 2 à¤•à¤¾ à¤¨à¤¾à¤®',0),(493192,13700,'ms','Nama musim ke-2',0),(493193,13700,'ar','Ø§Ø³Ù… Ø§Ù„Ù…ÙˆØ³Ù… 2',0),(493194,13700,'fr','Nom de la saison 2',0),(493195,13700,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 2 å',0),(493196,13700,'pt','Temporada 2 nome',0),(493197,13700,'ru','Ð˜Ð¼Ñ 2 ÑÐµÐ·Ð¾Ð½',0),(493198,13700,'es','Temporada 2 Nombre',0),(493199,13700,'de','Staffel 2 Namen',0),(493200,13700,'en','Season 2 Name',0),(493201,13701,'is','',0),(493202,13701,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´ ÙØµÙ„ 2',0),(493203,13701,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´ ÙØµÙ„ 2',0),(493204,13701,'tr','Sezon 2 sipariÅŸ Mkt.',0),(493205,13701,'pl','IloÅ›Ä‡ zamÃ³wienia sezon 2',0),(493206,13701,'bg','Ð¡ÐµÐ·Ð¾Ð½ 2 Ñ€ÐµÐ´ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(493207,13701,'ur','Ø§ÙˆÙ¾Ø± 2 ØªØ±ØªÛŒØ¨ Ù‚ÛŒ',0),(493208,13701,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 2 Ð½Ð°Ð»Ð¾Ð³Ð° ÐšÐ¾Ð».',0),(493209,13701,'vi','MÃ¹a 2 Ä‘áº·t hÃ ng SL',0),(493210,13701,'af','Seisoen 2 orde Qty',0),(493211,13701,'ro','Cantit Ã®n ordinea sezonul 2',0),(493212,13701,'et','Season 2 tellimuse kogus',0),(493213,13701,'si','KoliÄina naloga sezona 2',0),(493214,13701,'ba','Musim 2 Order Qty',0),(493215,13701,'nl','Seizoen 2 afname',0),(493216,13701,'fi','Kausi 2 jÃ¤rjestys mÃ¤Ã¤rÃ¤',0),(493217,13701,'no','Sesong 2 for antall',0),(493218,13701,'da','SÃ¦son 2 ordre antal',0),(493219,13701,'ko','ì‹œì¦Œ 2 ìˆœì„œ Qty',0),(493220,13701,'he','×›×ž×•×ª ×”×–×ž× ×” ×¢×•× ×” 2',0),(493221,13701,'el','Î£ÎµÎ¶ÏŒÎ½ 2 Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(493222,13701,'zh','ç¬¬ 2 å­£è®¢è´­æ•°é‡',0),(493223,13701,'sv','SÃ¤song 2 ordning Kvt',0),(493224,13701,'it','Stagione 2 ordine Qty',0),(493225,13701,'tl','',0),(493226,13701,'th','à¸¤à¸”à¸¹à¸à¸²à¸¥à¸—à¸µà¹ˆ 2 à¸›à¸£à¸´à¸¡à¸²à¸“à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(493227,13701,'hi','à¤¸à¥€à¤œà¤¨ 2 à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(493228,13701,'ms','Qty pesanan musim ke-2',0),(493229,13701,'ar','Qty ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…ÙˆØ³Ù… 2',0),(493230,13701,'fr','QuantitÃ© d\'ordre saison 2',0),(493231,13701,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 2 æ³¨æ–‡æ•°é‡',0),(493232,13701,'pt','Qty da ordem de 2 Âª temporada',0),(493233,13701,'ru','Ð—Ð°ÐºÐ°Ð·Ñƒ ÑÐµÐ·Ð¾Ð½ 2',0),(493234,13701,'es','Temporada 2 Cantidad de la Orden',0),(493235,13701,'de','Staffel 2-Bestellmenge',0),(493236,13701,'en','Season 2 Order Qty',0),(493237,13702,'is','',0),(493238,13702,'dr','ÙØµÙ„ 3 Ø­Ø¯Ø§Ú©Ø«Ø±',0),(493239,13702,'pr','ÙØµÙ„ 3 Ø­Ø¯Ø§Ú©Ø«Ø±',0),(493240,13702,'tr','Sezon 3 Max',0),(493241,13702,'pl','Max sezon 3',0),(493242,13702,'bg','Ð¡ÐµÐ·Ð¾Ð½ 3 ÐœÐ°ÐºÑ',0),(493243,13702,'ur','Ù…ÙˆØ³Ù… 3 Ù…ÛŒÚ©Ø³',0),(493244,13702,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 3 ÐœÐ°x',0),(493245,13702,'vi','MÃ¹a 3 Max',0),(493246,13702,'af','Seisoen 3 Max',0),(493247,13702,'ro','Sezonul 3 Max',0),(493248,13702,'et','Season 3 Max',0),(493249,13702,'si','Sezona 3 Max',0),(493250,13702,'ba','Musim 3 Max',0),(493251,13702,'nl','Seizoen 3 Max',0),(493252,13702,'fi','Kausi 3 Max',0),(493253,13702,'no','Sesong 3 Max',0),(493254,13702,'da','SÃ¦son 3 Max',0),(493255,13702,'ko','ì‹œì¦Œ 3 ë§¥ìŠ¤',0),(493256,13702,'he','×ž×§×¡ ×¢×•× ×” 3',0),(493257,13702,'el','Î£ÎµÎ¶ÏŒÎ½ 3 Max',0),(493258,13702,'zh','ç¬¬ä¸‰å­£æœ€å¤§',0),(493259,13702,'sv','SÃ¤song 3 Max',0),(493260,13702,'it','Max stagione 3',0),(493261,13702,'tl','',0),(493262,13702,'th','à¸¤à¸”à¸¹à¸à¸²à¸¥à¸—à¸µà¹ˆ 3 à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(493263,13702,'hi','à¤®à¥Œà¤¸à¤® 3 à¤…à¤§à¤¿à¤•à¤¤à¤®',0),(493264,13702,'ms','Max musim 3',0),(493265,13702,'ar','Ù…Ø§ÙƒØ³ Ø§Ù„Ù…ÙˆØ³Ù… 3',0),(493266,13702,'fr','Max saison 3',0),(493267,13702,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 3 ãƒžãƒƒã‚¯ã‚¹',0),(493268,13702,'pt','Temporada 3 Max',0),(493269,13702,'ru','ÐœÐ°ÐºÑ 3 ÑÐµÐ·Ð¾Ð½',0),(493270,13702,'es','Temporada 3 MÃ¡ximo',0),(493271,13702,'de','Staffel 3 Max',0),(493272,13702,'en','Season 3 Max',0),(493273,13703,'is','',0),(493274,13703,'dr','ÙØµÙ„ 3 Ø¯Ù‚ÛŒÙ‚Ù‡',0),(493275,13703,'pr','ÙØµÙ„ 3 Ø¯Ù‚ÛŒÙ‚Ù‡',0),(493276,13703,'tr','Sezon 3 dk.',0),(493277,13703,'pl','Sezon 3 Min',0),(493278,13703,'bg','Ð¡ÐµÐ·Ð¾Ð½ 3 Min',0),(493279,13703,'ur','Ù…ÙˆØ³Ù… 3 Ù…Ù†Ù¹',0),(493280,13703,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 3 ÐœÐ¸Ð½',0),(493281,13703,'vi','MÃ¹a 3 phÃºt',0),(493282,13703,'af','3 Min geur',0),(493283,13703,'ro','Sezonul 3 Min',0),(493284,13703,'et','Season 3 Min',0),(493285,13703,'si','Sezona 3 Min',0),(493286,13703,'ba','Musim 3 Min',0),(493287,13703,'nl','Seizoen 3 Min',0),(493288,13703,'fi','Kausi 3 Min',0),(493289,13703,'no','Sesong 3 Min',0),(493290,13703,'da','SÃ¦son 3 Min',0),(493291,13703,'ko','ì‹œì¦Œ 3 ë¶„',0),(493292,13703,'he','×¢×•× ×” 3 ×“×§×•×ª',0),(493293,13703,'el','Î£ÎµÎ¶ÏŒÎ½ 3 Min',0),(493294,13703,'zh','å­£èŠ‚ 3 åˆ†é’Ÿ',0),(493295,13703,'sv','SÃ¤song 3 Min',0),(493296,13703,'it','Stagione 3 Min',0),(493297,13703,'tl','',0),(493298,13703,'th','à¸‹à¸µà¸‹à¸±à¹ˆà¸™ 3 à¸™à¸²à¸—à¸µ',0),(493299,13703,'hi','à¤¸à¥€à¤œà¤¨ 3 Min',0),(493300,13703,'ms','Musim 3 Min',0),(493301,13703,'ar','Ø§Ù„Ù…ÙˆØ³Ù… 3 Ø¯Ù‚ÙŠÙ‚Ø©',0),(493302,13703,'fr','Saison 3 Min',0),(493303,13703,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 3 åˆ†',0),(493304,13703,'pt','Temporada 3 Min',0),(493305,13703,'ru','Ð¡ÐµÐ·Ð¾Ð½ 3 Ð¼Ð¸Ð½',0),(493306,13703,'es','Temporada 3 MÃ­nimo',0),(493307,13703,'de','Staffel 3 Min',0),(493308,13703,'en','Season 3 Min',0),(493309,13704,'is','',0),(493310,13704,'dr','Ù†Ø§Ù… ÙØµÙ„ 3',0),(493311,13704,'pr','Ù†Ø§Ù… ÙØµÙ„ 3',0),(493312,13704,'tr','Sezon 3 adÄ±',0),(493313,13704,'pl','Nazwa sezon 3',0),(493314,13704,'bg','Ð¡ÐµÐ·Ð¾Ð½ 3 Ð¸Ð¼Ðµ',0),(493315,13704,'ur','Ù…ÙˆØ³Ù… 3 Ù†Ø§Ù…',0),(493316,13704,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 3 Ð¸Ð¼Ðµ',0),(493317,13704,'vi','MÃ¹a 3 tÃªn',0),(493318,13704,'af','Seisoen 3 naam',0),(493319,13704,'ro','Sezonul 3 nume',0),(493320,13704,'et','Season 3 nimi',0),(493321,13704,'si','Sezona 3 ime',0),(493322,13704,'ba','Musim 3 nama',0),(493323,13704,'nl','Seizoen 3 naam',0),(493324,13704,'fi','Kauden nimi',0),(493325,13704,'no','Sesong 3 navn',0),(493326,13704,'da','SÃ¦son 3 navn',0),(493327,13704,'ko','ì‹œì¦Œ 3 ì´ë¦„',0),(493328,13704,'he','×”×©× ×¢×•× ×” 3',0),(493329,13704,'el','ÎŒÎ½Î¿Î¼Î± Season 3',0),(493330,13704,'zh','ç¬¬ä¸‰å­£çš„åå­—',0),(493331,13704,'sv','SÃ¤song 3 namn',0),(493332,13704,'it','Nome stagione 3',0),(493333,13704,'tl','',0),(493334,13704,'th','à¸¤à¸”à¸¹à¸à¸²à¸¥à¸—à¸µà¹ˆ 3 à¸Šà¸·à¹ˆà¸­',0),(493335,13704,'hi','à¤®à¥Œà¤¸à¤® 3 à¤¨à¤¾à¤®',0),(493336,13704,'ms','Nama musim 3',0),(493337,13704,'ar','Ø§Ø³Ù… Ø§Ù„Ù…ÙˆØ³Ù… 3',0),(493338,13704,'fr','Nom de la saison 3',0),(493339,13704,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 3 å',0),(493340,13704,'pt','Nome de 3 Âª temporada',0),(493341,13704,'ru','Ð˜Ð¼Ñ 3 ÑÐµÐ·Ð¾Ð½',0),(493342,13704,'es','Temporada 3 Nombre',0),(493343,13704,'de','Staffel 3-Name',0),(493344,13704,'en','Season 3 Name',0),(493345,13705,'is','',0),(493346,13705,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´ ÙØµÙ„ 3',0),(493347,13705,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´ ÙØµÙ„ 3',0),(493348,13705,'tr','Sezon 3 sipariÅŸ Mkt.',0),(493349,13705,'pl','IloÅ›Ä‡ zamÃ³wienia sezon 3',0),(493350,13705,'bg','Ð¡ÐµÐ·Ð¾Ð½ 3 Ñ€ÐµÐ´ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(493351,13705,'ur','Ù…ÙˆØ³Ù… 3 Ø§Ù…Ø§Ù† Ú©Û’ Ù‚ÛŒ',0),(493352,13705,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 3 Ð½Ð°Ð»Ð¾Ð³Ð° ÐšÐ¾Ð».',0),(493353,13705,'vi','MÃ¹a 3 Ä‘áº·t hÃ ng SL',0),(493354,13705,'af','Seisoen 3 orde Qty',0),(493355,13705,'ro','Cantit Ã®n ordinea sezonul 3',0),(493356,13705,'et','Season 3 tellimuse kogus',0),(493357,13705,'si','Sezona 3 nalog kol',0),(493358,13705,'ba','Musim 3 urutan Qty',0),(493359,13705,'nl','Seizoen 3 afname',0),(493360,13705,'fi','Kausi 3 tilauksen mÃ¤Ã¤rÃ¤',0),(493361,13705,'no','Sesong 3 for antall',0),(493362,13705,'da','SÃ¦son 3 ordre antal',0),(493363,13705,'ko','ì‹œì¦Œ 3 ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(493364,13705,'he','×›×ž×•×ª ×”×–×ž× ×” ×¢×•× ×” 3',0),(493365,13705,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Season 3',0),(493366,13705,'zh','ç¬¬ 3 å­£è®¢è´­æ•°é‡',0),(493367,13705,'sv','SÃ¤song 3 ordning Kvt',0),(493368,13705,'it','Stagione 3 ordine Qty',0),(493369,13705,'tl','',0),(493370,13705,'th','à¸¤à¸”à¸¹à¸à¸²à¸¥à¸—à¸µà¹ˆ 3 à¸›à¸£à¸´à¸¡à¸²à¸“à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(493371,13705,'hi','à¤®à¥Œà¤¸à¤® 3 à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(493372,13705,'ms','Qty pesanan musim 3',0),(493373,13705,'ar','Qty ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…ÙˆØ³Ù… 3',0),(493374,13705,'fr','QuantitÃ© d\'ordre saison 3',0),(493375,13705,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 3 ã®é †åº Qty',0),(493376,13705,'pt','Qty da ordem de 3 Âª temporada',0),(493377,13705,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° 3 ÑÐµÐ·Ð¾Ð½',0),(493378,13705,'es','Temporada 3 Cantidad de la Orden',0),(493379,13705,'de','Staffel 3-Bestellmenge',0),(493380,13705,'en','Season 3 Order Qty',0),(493381,13706,'is','',0),(493382,13706,'dr','Ø­Ø¯Ø§Ú©Ø«Ø± ÙØµÙ„ 4',0),(493383,13706,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± ÙØµÙ„ 4',0),(493384,13706,'tr','Sezon 4 Max',0),(493385,13706,'pl','Max sezon 4',0),(493386,13706,'bg','Ð¡ÐµÐ·Ð¾Ð½ 4 ÐœÐ°ÐºÑ',0),(493387,13706,'ur','Ù…ÙˆØ³Ù… 4 Ù…ÛŒÚ©Ø³',0),(493388,13706,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 4 ÐœÐ°x.',0),(493389,13706,'vi','MÃ¹a 4 Max',0),(493390,13706,'af','Seisoen 4 Max',0),(493391,13706,'ro','Sezonul 4 Max',0),(493392,13706,'et','Season 4 Max',0),(493393,13706,'si','Sezona 4 Max',0),(493394,13706,'ba','Musim 4 Max',0),(493395,13706,'nl','Seizoen 4-Max',0),(493396,13706,'fi','Season 4 Max',0),(493397,13706,'no','Sesong 4 Max',0),(493398,13706,'da','SÃ¦son 4 Max',0),(493399,13706,'ko','ì‹œì¦Œ 4 ìµœëŒ€',0),(493400,13706,'he','×ž×§×¡ ×¢×•× ×” 4',0),(493401,13706,'el','Î£ÎµÎ¶ÏŒÎ½ 4 Max',0),(493402,13706,'zh','ç¬¬ 4 å­£æœ€å¤§',0),(493403,13706,'sv','SÃ¤song 4 Max',0),(493404,13706,'it','Max stagione 4',0),(493405,13706,'tl','',0),(493406,13706,'th','à¸¤à¸”à¸¹à¸à¸²à¸¥à¸—à¸µà¹ˆ 4 à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(493407,13706,'hi','à¤¸à¥€à¤œà¤¨ 4 à¤®à¥ˆà¤•à¥à¤¸',0),(493408,13706,'ms','Max musim 4',0),(493409,13706,'ar','Ù…Ø§ÙƒØ³ Ø§Ù„Ù…ÙˆØ³Ù… 4',0),(493410,13706,'fr','Saison 4 Max',0),(493411,13706,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 4 Max',0),(493412,13706,'pt','Max 4 Âª temporada',0),(493413,13706,'ru','ÐœÐ°ÐºÑ 4 ÑÐµÐ·Ð¾Ð½Ð°',0),(493414,13706,'es','Temporada 4 MÃ¡ximo',0),(493415,13706,'de','Staffel 4-Max',0),(493416,13706,'en','Season 4 Max',0),(493417,13707,'is','',0),(493418,13707,'dr','ÙØµÙ„ 4 Ø¯Ù‚ÙŠÙ‚Ù‡',0),(493419,13707,'pr','ÙØµÙ„ 4 Ø¯Ù‚ÙŠÙ‚Ù‡',0),(493420,13707,'tr','Sezon 4 dk',0),(493421,13707,'pl','Sezon 4 Min',0),(493422,13707,'bg','Ð¡ÐµÐ·Ð¾Ð½ 4 Ð¼Ð¸Ð½.',0),(493423,13707,'ur','Ù…ÙˆØ³Ù… 4 Ù…Ù†Ù¹',0),(493424,13707,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 4 ÐœÐ¸Ð½',0),(493425,13707,'vi','MÃ¹a 4 Min',0),(493426,13707,'af','4 Min geur',0),(493427,13707,'ro','Sezonul 4 Min',0),(493428,13707,'et','Season 4 Min',0),(493429,13707,'si','Sezona 4 Min',0),(493430,13707,'ba','Musim 4 menit',0),(493431,13707,'nl','Seizoen 4 Min',0),(493432,13707,'fi','Kausi 4 Min',0),(493433,13707,'no','Sesong 4 Min',0),(493434,13707,'da','SÃ¦son 4 Min',0),(493435,13707,'ko','ì‹œì¦Œ 4 ë¶„',0),(493436,13707,'he','×¢×•× ×” 4 ×“×§×•×ª',0),(493437,13707,'el','Î£ÎµÎ¶ÏŒÎ½ 4 Min',0),(493438,13707,'zh','å­£èŠ‚ 4 åˆ†é’Ÿ',0),(493439,13707,'sv','SÃ¤song 4 Min',0),(493440,13707,'it','Stagione 4 Min',0),(493441,13707,'tl','',0),(493442,13707,'th','à¸‹à¸µà¸‹à¸±à¹ˆà¸™ 4 à¸™à¸²à¸—à¸µ',0),(493443,13707,'hi','à¤¸à¥€à¤œà¤¨ 4 à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤®',0),(493444,13707,'ms','Musim 4 Min',0),(493445,13707,'ar','Ø§Ù„Ù…ÙˆØ³Ù… 4 Ø¯Ù‚ÙŠÙ‚Ø©',0),(493446,13707,'fr','Saison 4 Min',0),(493447,13707,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 4 åˆ†',0),(493448,13707,'pt','Temporada 4 Min',0),(493449,13707,'ru','Ð¡ÐµÐ·Ð¾Ð½ 4 Ð¼Ð¸Ð½',0),(493450,13707,'es','Temporada 4 MÃ­nimo',0),(493451,13707,'de','Staffel 4 Min',0),(493452,13707,'en','Season 4 Min',0),(493453,13708,'is','',0),(493454,13708,'dr','Ù†Ø§Ù… ÙØµÙ„ 4',0),(493455,13708,'pr','Ù†Ø§Ù… ÙØµÙ„ 4',0),(493456,13708,'tr','Sezon 4 ad',0),(493457,13708,'pl','Nazwa sezon 4',0),(493458,13708,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐµÐ·Ð¾Ð½ 4',0),(493459,13708,'ur','Ù…ÙˆØ³Ù… 4 Ù†Ø§Ù…',0),(493460,13708,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 4 Ð¸Ð¼Ðµ',0),(493461,13708,'vi','MÃ¹a 4 tÃªn',0),(493462,13708,'af','Seisoen 4 naam',0),(493463,13708,'ro','Sezonul 4 nume',0),(493464,13708,'et','Season 4 nime',0),(493465,13708,'si','Sezona 4 ime',0),(493466,13708,'ba','Musim 4 nama',0),(493467,13708,'nl','Seizoen 4 naam',0),(493468,13708,'fi','Season 4 nimi',0),(493469,13708,'no','Sesong 4 navn',0),(493470,13708,'da','SÃ¦son 4 navn',0),(493471,13708,'ko','ì‹œì¦Œ 4 ì´ë¦„',0),(493472,13708,'he','×”×©× ×¢×•× ×” 4',0),(493473,13708,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏ€Î¿Ï‡Î®Ï‚ 4',0),(493474,13708,'zh','ç¬¬ 4 å­£çš„åå­—',0),(493475,13708,'sv','SÃ¤song 4 namn',0),(493476,13708,'it','Nome stagione 4',0),(493477,13708,'tl','',0),(493478,13708,'th','à¸¤à¸”à¸¹à¸à¸²à¸¥à¸—à¸µà¹ˆ 4 à¸Šà¸·à¹ˆà¸­',0),(493479,13708,'hi','4 à¤¸à¥€à¤œà¤¨ à¤•à¤¾ à¤¨à¤¾à¤®',0),(493480,13708,'ms','Nama musim 4',0),(493481,13708,'ar','Ø§Ø³Ù… Ø§Ù„Ù…ÙˆØ³Ù… 4',0),(493482,13708,'fr','Nom de la saison 4',0),(493483,13708,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 4 å',0),(493484,13708,'pt','Nome da 4 Âª temporada',0),(493485,13708,'ru','Ð˜Ð¼Ñ 4 ÑÐµÐ·Ð¾Ð½Ð°',0),(493486,13708,'es','Temporada 4 Nombre',0),(493487,13708,'de','Staffel 4 Namen',0),(493488,13708,'en','Season 4 Name',0),(493489,13709,'is','',0),(493490,13709,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´ ÙØµÙ„ 4',0),(493491,13709,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´ ÙØµÙ„ 4',0),(493492,13709,'tr','Sezon 4 sipariÅŸ Mkt.',0),(493493,13709,'pl','IloÅ›Ä‡ zamÃ³wienia sezon 4',0),(493494,13709,'bg','Ð¡ÐµÐ·Ð¾Ð½ 4 Ñ€ÐµÐ´ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(493495,13709,'ur','Ù…ÙˆØ³Ù… 4 Ø§Ù…Ø§Ù† Ú©Û’ Ù‚ÛŒ',0),(493496,13709,'sr','Ð¡ÐµÐ·Ð¾Ð½Ð° 4 Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÐšÐ¾Ð».',0),(493497,13709,'vi','MÃ¹a 4 Ä‘áº·t hÃ ng SL',0),(493498,13709,'af','Seisoen 4 orde Qty',0),(493499,13709,'ro','Cantit Ã®n ordinea sezonul 4',0),(493500,13709,'et','Season 4 tellimuse kogus',0),(493501,13709,'si','KoliÄina naloga sezona 4',0),(493502,13709,'ba','Musim 4 Order Qty',0),(493503,13709,'nl','Seizoen 4 afname',0),(493504,13709,'fi','Season 4 tilauksen mÃ¤Ã¤rÃ¤',0),(493505,13709,'no','Sesong 4 for antall',0),(493506,13709,'da','SÃ¦son 4 ordre antal',0),(493507,13709,'ko','ì‹œì¦Œ 4 ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(493508,13709,'he','×›×ž×•×ª ×”×–×ž× ×” ×¢×•× ×” 4',0),(493509,13709,'el','Î£ÎµÎ¶ÏŒÎ½ 4 Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(493510,13709,'zh','ç¬¬ 4 å­£è®¢è´­æ•°é‡',0),(493511,13709,'sv','SÃ¤song 4 ordning Kvt',0),(493512,13709,'it','Stagione 4 ordine Qty',0),(493513,13709,'tl','',0),(493514,13709,'th','à¸¤à¸”à¸¹à¸à¸²à¸¥à¸—à¸µà¹ˆ 4 à¸›à¸£à¸´à¸¡à¸²à¸“à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(493515,13709,'hi','à¤¸à¥€à¤œà¤¨ 4 à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(493516,13709,'ms','Qty pesanan musim 4',0),(493517,13709,'ar','Qty ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…ÙˆØ³Ù… 4',0),(493518,13709,'fr','QuantitÃ© d\'ordre saison 4',0),(493519,13709,'jp','ã‚·ãƒ¼ã‚ºãƒ³ 4 ã®é †åº Qty',0),(493520,13709,'pt','Qty da ordem de 4 Âª temporada',0),(493521,13709,'ru','Ð—Ð°ÐºÐ°Ð·Ñƒ 4 ÑÐµÐ·Ð¾Ð½Ð°',0),(493522,13709,'es','Temporada 4 Cantidad de la Orden',0),(493523,13709,'de','Staffel 4-Bestellmenge',0),(493524,13709,'en','Season 4 Order Qty',0),(493525,13710,'is','',0),(493526,13710,'dr','Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø±ÛŒ Admin',0),(493527,13710,'pr','Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø±ÛŒ Admin',0),(493528,13710,'tr','Admin kullanÄ±cÄ± adÄ±',0),(493529,13710,'pl','Nazwa uÅ¼ytkownika admin',0),(493530,13710,'bg','Admin Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ',0),(493531,13710,'ur','Ù…Ù†ØªØ¸Ù… ØµØ§Ø±Ù Ù†Ø§Ù…',0),(493532,13710,'sr','ÐÐ´Ð¼Ð¸Ð½ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ',0),(493533,13710,'vi','TÃªn ngÆ°á»i dÃ¹ng: admin',0),(493534,13710,'af','Admin Gebruikersnaam',0),(493535,13710,'ro','Numele de utilizator admin',0),(493536,13710,'et','Admin kasutajanimi',0),(493537,13710,'si','Admin uporabniÅ¡ko ime',0),(493538,13710,'ba','Admin Username',0),(493539,13710,'nl','Admin gebruikersnaam',0),(493540,13710,'fi','Admin kÃ¤yttÃ¤jÃ¤tunnus',0),(493541,13710,'no','Admin brukernavn',0),(493542,13710,'da','Admin Username',0),(493543,13710,'ko','ê´€ë¦¬ìž ì‚¬ìš©ìž ì´ë¦„',0),(493544,13710,'he','×©× ×ž×©×ª×ž×© Admin',0),(493545,13710,'el','ÎŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· admin',0),(493546,13710,'zh','ç®¡ç†å‘˜ç”¨æˆ·å',0),(493547,13710,'sv','Admin anvÃ¤ndarnamn',0),(493548,13710,'it','Nome utente admin',0),(493549,13710,'tl','',0),(493550,13710,'th','à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰ Admin',0),(493551,13710,'hi','à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾à¤ªà¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¾à¤®',0),(493552,13710,'ms','Admin Username',0),(493553,13710,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Admin',0),(493554,13710,'fr','Nom d\'utilisateur admin',0),(493555,13710,'jp','ç®¡ç†è€…ã®ãƒ¦ãƒ¼ã‚¶å',0),(493556,13710,'pt','Nome de usuÃ¡rio admin',0),(493557,13710,'ru','Ð˜Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð°',0),(493558,13710,'es','Admin Nombre de Usuario',0),(493559,13710,'de','Admin Username',0),(493560,13710,'en','Admin Username',0),(493561,13711,'is','',0),(493562,13711,'dr','ÙÛŒÙ„ØªØ± Ø§Ø¶Ø§ÙÛŒ Ø¬Ø³ØªØ¬Ùˆ',0),(493563,13711,'pr','ÙÛŒÙ„ØªØ± Ø§Ø¶Ø§ÙÛŒ Ø¬Ø³ØªØ¬Ùˆ',0),(493564,13711,'tr','Ek arama filtreleri',0),(493565,13711,'pl','Dodatkowych filtrÃ³w',0),(493566,13711,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ„Ð¸Ð»Ñ‚Ñ€Ð¸',0),(493567,13711,'ur','Ø§Ø¶Ø§ÙÛŒ ØªÙ„Ø§Ø´ ÙÙ„Ù¹Ø±',0),(493568,13711,'sr','Ð¤Ð¸Ð»Ñ‚ÐµÑ€Ð¸ Ð·Ð° Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ðµ',0),(493569,13711,'vi','TÃ¬m thÃªm bá»™ lá»c',0),(493570,13711,'af','Bykomende soek Filters',0),(493571,13711,'ro','Filtrele de cÄƒutare suplimentare',0),(493572,13711,'et','TÃ¤iendav otsingufiltreid',0),(493573,13711,'si','Dodatne iskalne filtre',0),(493574,13711,'ba','Filter pencarian tambahan',0),(493575,13711,'nl','Extra zoekfilters',0),(493576,13711,'fi','YlimÃ¤Ã¤rÃ¤isiÃ¤ Etsi suodattimet',0),(493577,13711,'no','Flere sÃ¸kefiltre',0),(493578,13711,'da','Yderligere sÃ¸gefiltre',0),(493579,13711,'ko','ì¶”ê°€ ê²€ìƒ‰ í•„í„°',0),(493580,13711,'he','×ž×¡× × ×™ ×—×™×¤×•×© × ×•×¡×¤×™×',0),(493581,13711,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î ÏÏŒÏƒÎ¸ÎµÏ„Î± Ï†Î¯Î»Ï„ÏÎ±',0),(493582,13711,'zh','é™„åŠ çš„æœç´¢ç­›é€‰å™¨',0),(493583,13711,'sv','Ytterligare sÃ¶kfilter',0),(493584,13711,'it','Filtri di ricerca aggiuntivi',0),(493585,13711,'tl','',0),(493586,13711,'th','à¸•à¸±à¸§à¸à¸£à¸­à¸‡à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(493587,13711,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤–à¥‹à¤œ à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤°',0),(493588,13711,'ms','Penapis tambahan Cari',0),(493589,13711,'ar','Ù…Ø±Ø´Ø­Ø§Øª Ø¨Ø­Ø« Ø¥Ø¶Ø§ÙÙŠØ©',0),(493590,13711,'fr','Filtres de recherche supplÃ©mentaires',0),(493591,13711,'jp','è¿½åŠ ã®æ¤œç´¢ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼',0),(493592,13711,'pt','Filtros de pesquisa adicionais',0),(493593,13711,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¿Ð¾Ð¸ÑÐºÐ¾Ð²Ñ‹Ðµ Ñ„Ð¸Ð»ÑŒÑ‚Ñ€Ñ‹',0),(493594,13711,'es','Filtros de Busqueda Adicionales',0),(493595,13711,'de','ZusÃ¤tzliche Suchfilter',0),(493596,13711,'en','Additional Search Filters',0),(493597,13712,'is','',0),(493598,13712,'dr','Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(493599,13712,'pr','Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(493600,13712,'tr','GeliÅŸmiÅŸ SeÃ§enekler',0),(493601,13712,'pl','Zaawansowane opcje',0),(493602,13712,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(493603,13712,'ur','Ø§Ø¹Ù„ÛŒ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(493604,13712,'sr','ÐÐ°Ð¿Ñ€ÐµÐ´Ð½Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(493605,13712,'vi','TÃ¹y chá»n chuyÃªn sÃ¢u',0),(493606,13712,'af','Gevorderde Opsies',0),(493607,13712,'ro','OpÅ£iuni avansate',0),(493608,13712,'et','TÃ¤psemad suvandid',0),(493609,13712,'si','Dodatne moÅ¾nosti',0),(493610,13712,'ba','Opsi lanjutan',0),(493611,13712,'nl','Geavanceerde opties',0),(493612,13712,'fi','LisÃ¤asetukset',0),(493613,13712,'no','Avanserte alternativer',0),(493614,13712,'da','Avancerede indstillinger',0),(493615,13712,'ko','ê³ ê¸‰ ì˜µì…˜',0),(493616,13712,'he','××¤×©×¨×•×™×•×ª ×ž×ª×§×“×ž×•×ª',0),(493617,13712,'el','Î ÏÎ¿Î·Î³Î¼Î­Î½ÎµÏ‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(493618,13712,'zh','é«˜çº§çš„é€‰é¡¹',0),(493619,13712,'sv','Avancerade alternativ',0),(493620,13712,'it','Opzioni avanzate',0),(493621,13712,'tl','',0),(493622,13712,'th','à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡',0),(493623,13712,'hi','à¤‰à¤¨à¥à¤¨à¤¤ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(493624,13712,'ms','Opsyen lebih maju',0),(493625,13712,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ù…ØªÙ‚Ø¯Ù…Ø©',0),(493626,13712,'fr','Options avancÃ©es',0),(493627,13712,'jp','é«˜åº¦ãªã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(493628,13712,'pt','OpÃ§Ãµes avanÃ§adas',0),(493629,13712,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(493630,13712,'es','Opciones Avanzadas',0),(493631,13712,'de','Erweiterte Optionen',0),(493632,13712,'en','Advanced Options',0),(493633,13713,'is','',0),(493634,13713,'dr','Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø§Ø² Ù†Ùˆ Ø®Ù„Ù‚ Ú©Ø±Ø¯Ù† Ù…Ù†Ùˆ Ù¾Ø³ Ø§Ø² Ø´Ù…Ø§ Ø±Ø§ Ø³Ø§Ø®ØªÙ‡ Ø§Ù†Ø¯ ØªØºÛŒÛŒØ±Ø§Øª Ø¨Ù‡ Ú©Ù„Ù…Ø§Øª Ø¯Ø± Ù…Ù†ÙˆÛŒ',0),(493635,13713,'pr','Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø§Ø² Ù†Ùˆ Ø®Ù„Ù‚ Ú©Ø±Ø¯Ù† Ù…Ù†Ùˆ Ù¾Ø³ Ø§Ø² Ø´Ù…Ø§ Ø±Ø§ Ø³Ø§Ø®ØªÙ‡ Ø§Ù†Ø¯ ØªØºÛŒÛŒØ±Ø§Øª Ø¨Ù‡ Ú©Ù„Ù…Ø§Øª Ø¯Ø± Ù…Ù†ÙˆÛŒ',0),(493636,13713,'tr','TÄ±klayÄ±n yeniden menÃ¼ menÃ¼sÃ¼nde kelime deÄŸiÅŸiklikleri yaptÄ±ktan sonra',0),(493637,13713,'pl','Kliknij przycisk UtwÃ³rz menu po wprowadzeniu zmian do sÅ‚Ã³w w menu',0),(493638,13713,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð¡ÑŠÐ·Ð´Ð°Ð¹ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð¼ÐµÐ½ÑŽ, ÑÐ»ÐµÐ´ ÐºÐ°Ñ‚Ð¾ ÑÑ‚Ðµ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð½Ð° Ð´ÑƒÐ¼Ð¸ Ð² Ð¼ÐµÐ½ÑŽÑ‚Ð¾',0),(493639,13713,'ur','Ú©Ù„Ú© Ú©Ùˆ Ø¯ÙˆØ¨Ø§Ø±Û ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº Ù…ÛŒÙ†ÛŒÙˆ Ú©Û’ Ø¨Ø¹Ø¯ Ø¢Ù¾ Ú©Ùˆ Ù…ÛŒÙ†ÛŒÙˆ Ù…ÛŒÚº Ø§Ù„ÙØ§Ø¸ Ú©Û’ Ù„ÛŒÛ’ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ú©ÛŒ ÛÛŒÚº',0),(493640,13713,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð¼ÐµÐ½Ð¸, Ð½Ð°ÐºÐ¾Ð½ ÑˆÑ‚Ð¾ ÑÑ‚Ðµ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ð»Ð¸ Ñ€ÐµÑ‡Ð¸ Ñƒ Ð¸Ð·Ð±Ð¾Ñ€Ð½Ð¸ÐºÑƒ',0),(493641,13713,'vi','Nháº¥p vÃ o táº¡o láº¡i Ä‘Æ¡n sau khi báº¡n Ä‘Ã£ thay Ä‘á»•i tá»« trong trÃ¬nh Ä‘Æ¡n',0),(493642,13713,'af','Klik herskep kieslys nadat jy het veranderinge aangebring aan die woorde in die kieslys',0),(493643,13713,'ro','FaceÅ£i clic pe recrea meniu dupÄƒ ce aÅ£i fÄƒcut modificÄƒri la cuvinte Ã®n meniul',0),(493644,13713,'et','KlÃµpsake uuesti menÃ¼Ã¼ pÃ¤rast seda, kui olete muutnud sÃµnad menÃ¼Ã¼st',0),(493645,13713,'si','Kliknite znova menu, ko ste spremenili besedilo, v meniju',0),(493646,13713,'ba','Klik menciptakan menu setelah Anda telah membuat perubahan kata-kata dalam menu',0),(493647,13713,'nl','Klik op menu opnieuw nadat u wijzigingen hebt aangebracht in woorden in het menu',0),(493648,13713,'fi','Napsauta uudelleen menu jÃ¤lkeen olet tehnyt muutoksia sanoja valikosta',0),(493649,13713,'no','Klikker du Opprett menyen nÃ¥r du har gjort endringer i ord i menyen',0),(493650,13713,'da','Klik genoprette menu efter du har foretaget Ã¦ndringer til ord i menuen',0),(493651,13713,'ko','í´ë¦­ ë³€ê²½ ë©”ë‰´ì—ì„œ ë‹¨ì–´ë¥¼ ë§Œë“  í›„ ë©”ë‰´ë¥¼ ë‹¤ì‹œ ë§Œë“­ë‹ˆë‹¤.',0),(493652,13713,'he','×œ×—×¥ ×¢×œ ×”××¤×©×¨×•×ª ×¦×•×¨ ×ª×¤×¨×™×˜ ×œ××—×¨ ×©×‘×™×¦×¢×ª ×©×™× ×•×™×™× ×ž×™×œ×™× ×‘×ª×¤×¨×™×˜',0),(493653,13713,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î±Î½Î±Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Î¼ÎµÎ½Î¿Ï Î±Ï†Î¿Ï Î­Ï‡Î¿Ï…Î½ ÎºÎ¬Î½ÎµÎ¹ Î±Î»Î»Î±Î³Î­Ï‚ ÏƒÎµ Î»Î­Î¾ÎµÎ¹Ï‚ ÏƒÏ„Î¿ Î¼ÎµÎ½Î¿Ï',0),(493654,13713,'zh','å•å‡»é‡æ–°åˆ›å»ºèœå•åŽæ›´æ”¹äº†èœå•ä¸­çš„å•è¯',0),(493655,13713,'sv','Klicka pÃ¥ Ã¥terskapa menyn nÃ¤r du har gjort Ã¤ndringar pÃ¥ ord i menyn',0),(493656,13713,'it','Clic ricreare menu dopo aver apportato modifiche alle parole nel menu',0),(493657,13713,'tl','',0),(493658,13713,'th','à¸„à¸¥à¸´à¸à¸ªà¸£à¹‰à¸²à¸‡à¹€à¸¡à¸™à¸¹à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸—à¸µà¹ˆà¸„à¸¸à¸“à¹„à¸”à¹‰à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸„à¸³à¹ƒà¸™à¹€à¸¡à¸™à¸¹',0),(493659,13713,'hi','à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤†à¤ª à¤®à¥‡à¤¨à¥‚ à¤®à¥‡à¤‚ à¤¶à¤¬à¥à¤¦ à¤•à¥‹ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤¿à¤ à¤¹à¥ˆà¤‚ à¤®à¥‡à¤¨à¥‚ à¤ªà¥à¤¨: à¤¬à¤¨à¤¾à¤à¤',0),(493660,13713,'ms','Klik mencipta menu selepas anda telah membuat perubahan kepada kata-kata dalam menu',0),(493661,13713,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø¥Ø¹Ø§Ø¯Ø© Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø¹Ø¯ Ù‚Ù…Øª Ø¨Ø¥Ø¬Ø±Ø§Ø¡ ØªØºÙŠÙŠØ±Ø§Øª Ø¥Ù„Ù‰ Ø§Ù„ÙƒÙ„Ù…Ø§Øª ÙÙŠ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(493662,13713,'fr','Cliquez sur recrÃ©er menu aprÃ¨s que vous avez apportÃ© des modifications Ã  des mots dans le menu',0),(493663,13713,'jp','ãƒ¡ãƒ‹ãƒ¥ãƒ¼å†…ã®å˜èªžã«å¤‰æ›´ã‚’è¡Œã£ãŸå¾Œã€å†ä½œæˆ] ãƒ¡ãƒ‹ãƒ¥ãƒ¼ã® [ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(493664,13713,'pt','Clique em recriar o menu depois de ter feito alteraÃ§Ãµes de palavras no menu',0),(493665,13713,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐºÐ½Ð¾Ð¿ÐºÑƒ Ð²Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¼ÐµÐ½ÑŽ Ð¿Ð¾ÑÐ»Ðµ Ñ‚Ð¾Ð³Ð¾, ÐºÐ°Ðº Ð²Ñ‹ Ð²Ð½ÐµÑÐ»Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð² ÑÐ»Ð¾Ð²Ð° Ð² Ð¼ÐµÐ½ÑŽ',0),(493666,13713,'es','Hace Clik en Recrear MenÃº DepuÃ©s de Hacer Cambios a las Palabras en el MenÃº',0),(493667,13713,'de','Klicken Sie auf neu im MenÃ¼ erstellen, nachdem Sie Ã„nderungen vorgenommen haben, auf Worte im MenÃ¼',0),(493668,13713,'en','Click recreate menu after you have made changes to words in the menu',0),(493669,13714,'is','',0),(493670,13714,'dr','ØªØ¹Ø±ÛŒÙ',0),(493671,13714,'pr','ØªØ¹Ø±ÛŒÙ',0),(493672,13714,'tr','TanÄ±mÄ±',0),(493673,13714,'pl','Definicja',0),(493674,13714,'bg','Ð”ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ',0),(493675,13714,'ur','ØªØ¹Ø±ÛŒÙ',0),(493676,13714,'sr','Ð”ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð°',0),(493677,13714,'vi','Äá»‹nh nghÄ©a',0),(493678,13714,'af','Definisie',0),(493679,13714,'ro','DefiniÅ£ie',0),(493680,13714,'et','MÃ¤Ã¤ratlus',0),(493681,13714,'si','Opredelitev',0),(493682,13714,'ba','Definisi',0),(493683,13714,'nl','Definitie',0),(493684,13714,'fi','MÃ¤Ã¤ritelmÃ¤',0),(493685,13714,'no','Definisjon',0),(493686,13714,'da','Definition',0),(493687,13714,'ko','ì •ì˜',0),(493688,13714,'he','×”×’×“×¨×”',0),(493689,13714,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚',0),(493690,13714,'zh','å®šä¹‰',0),(493691,13714,'sv','Definition',0),(493692,13714,'it','Definizione',0),(493693,13714,'tl','',0),(493694,13714,'th','à¸„à¸³à¸ˆà¸³à¸à¸±à¸”à¸„à¸§à¸²à¸¡',0),(493695,13714,'hi','à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾',0),(493696,13714,'ms','Definisi',0),(493697,13714,'ar','ØªØ¹Ø±ÙŠÙ',0),(493698,13714,'fr','DÃ©finition',0),(493699,13714,'jp','å®šç¾©',0),(493700,13714,'pt','DefiniÃ§Ã£o',0),(493701,13714,'ru','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(493702,13714,'es','DefiniciÃ³n',0),(493703,13714,'de','Definition',0),(493704,13714,'en','Definition',0),(493705,13715,'is','',0),(493706,13715,'dr','ØµØ§Ø¯Ø±Ø§Øª ØªØ±Ø¬Ù…Ù‡',0),(493707,13715,'pr','ØµØ§Ø¯Ø±Ø§Øª ØªØ±Ø¬Ù…Ù‡',0),(493708,13715,'tr','Ã‡eviri vermek',0),(493709,13715,'pl','Eksportowanie tÅ‚umaczenia',0),(493710,13715,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ²Ð¾Ð´Ð¸',0),(493711,13715,'ur','ØªØ±Ø¬Ù…Û Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(493712,13715,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¿Ñ€ÐµÐ²Ð¾Ñ’ÐµÑšÐ°',0),(493713,13715,'vi','Xuáº¥t kháº©u dá»‹ch',0),(493714,13715,'af','Uitvoer van vertaling',0),(493715,13715,'ro','Traducere de export',0),(493716,13715,'et','Ekspordi tÃµlge',0),(493717,13715,'si','Izvoz prevajanje',0),(493718,13715,'ba','Ekspor terjemahan',0),(493719,13715,'nl','Exporteren van vertaling',0),(493720,13715,'fi','Vienti kÃ¤Ã¤nnÃ¶s',0),(493721,13715,'no','Eksportere oversettelse',0),(493722,13715,'da','Eksport OversÃ¦ttelse',0),(493723,13715,'ko','ë²ˆì—­ ìˆ˜ì¶œ',0),(493724,13715,'he','×™×¦× ×ª×¨×’×•×',0),(493725,13715,'el','Î•Î¾Î±Î³Ï‰Î³Î® Î¼ÎµÏ„Î¬Ï†ÏÎ±ÏƒÎ·',0),(493726,13715,'zh','å¯¼å‡ºç¿»è¯‘',0),(493727,13715,'sv','Exportera Ã–versÃ¤ttning',0),(493728,13715,'it','Traduzione di esportazione',0),(493729,13715,'tl','',0),(493730,13715,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸à¸²à¸£à¹à¸›à¸¥',0),(493731,13715,'hi','à¤…à¤¨à¥à¤µà¤¾à¤¦ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(493732,13715,'ms','Eksport penterjemahan',0),(493733,13715,'ar','ØªØµØ¯ÙŠØ± Ø§Ù„ØªØ±Ø¬Ù…Ø©',0),(493734,13715,'fr','Traduction de l\'exportation',0),(493735,13715,'jp','ç¿»è¨³ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(493736,13715,'pt','TraduÃ§Ã£o de exportaÃ§Ã£o',0),(493737,13715,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´',0),(493738,13715,'es','TranslaciÃ³n de Exportaciones',0),(493739,13715,'de','Export-Ãœbersetzung',0),(493740,13715,'en','Export Translation',0),(493741,13716,'is','',0),(493742,13716,'dr','ØªØ¹Ø±ÛŒÙ Ú©Ù†ÛŒØ¯',0),(493743,13716,'pr','ØªØ¹Ø±ÛŒÙ Ú©Ù†ÛŒØ¯',0),(493744,13716,'tr','TanÄ±mlarÄ± almak',0),(493745,13716,'pl','UzyskaÄ‡ definicje',0),(493746,13716,'bg','Ð’Ð·ÐµÐ¼Ð¸ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ð¸',0),(493747,13716,'ur','ØªØ¹Ø±ÛŒÙ Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(493748,13716,'sr','ÐŸÐ¾ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ðµ',0),(493749,13716,'vi','Nháº­n Ä‘Æ°á»£c Ä‘á»‹nh nghÄ©a',0),(493750,13716,'af','Kry definisies',0),(493751,13716,'ro','ObÅ£ine definiÅ£ii',0),(493752,13716,'et','Saada mÃµisted',0),(493753,13716,'si','ZasluÅ¾iti opredelitev',0),(493754,13716,'ba','Mendapatkan definisi',0),(493755,13716,'nl','Krijgen definities',0),(493756,13716,'fi','Saada mÃ¤Ã¤ritelmÃ¤t',0),(493757,13716,'no','FÃ¥ definisjoner',0),(493758,13716,'da','FÃ¥ definitioner',0),(493759,13716,'ko','ì •ì˜ ì–»ì„',0),(493760,13716,'he','×œ×§×‘×œ ×”×’×“×¨×•×ª',0),(493761,13716,'el','Î Î¬ÏÎµÏ„Îµ Î¿ÏÎ¹ÏƒÎ¼Î¿Î¯',0),(493762,13716,'zh','èŽ·å–å®šä¹‰',0),(493763,13716,'sv','FÃ¥ definitioner',0),(493764,13716,'it','Ottenere le definizioni',0),(493765,13716,'tl','',0),(493766,13716,'th','à¹„à¸”à¹‰à¸£à¸±à¸šà¸„à¸³à¸™à¸´à¸¢à¸²à¸¡',0),(493767,13716,'hi','à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾à¤à¤ à¤¹à¥‹ à¤œà¤¾à¤“',0),(493768,13716,'ms','Dapatkan definisi',0),(493769,13716,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„ØªØ¹Ø§Ø±ÙŠÙ',0),(493770,13716,'fr','TÃ©lÃ©chargez les dÃ©finitions',0),(493771,13716,'jp','å®šç¾©ã‚’å–å¾—ã—ã¾ã™ã€‚',0),(493772,13716,'pt','Obter definiÃ§Ãµes',0),(493773,13716,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ',0),(493774,13716,'es','Agarrar Definiciones',0),(493775,13716,'de','Definitionen zu erhalten',0),(493776,13716,'en','Get Definitions',0),(493777,13717,'is','',0),(493778,13717,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù†',0),(493779,13717,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù†',0),(493780,13717,'tr','Gizle',0),(493781,13717,'pl','Ukryj',0),(493782,13717,'bg','Ð¡ÐºÑ€Ð¸Ð¹',0),(493783,13717,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(493784,13717,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜',0),(493785,13717,'vi','áº¨n',0),(493786,13717,'af','Versteek',0),(493787,13717,'ro','Ascunde',0),(493788,13717,'et','Peida',0),(493789,13717,'si','Skrij',0),(493790,13717,'ba','Sembunyikan',0),(493791,13717,'nl','Verbergen',0),(493792,13717,'fi','Piilota',0),(493793,13717,'no','Skjul',0),(493794,13717,'da','Skjul',0),(493795,13717,'ko','ìˆ¨ê¸°ê¸°',0),(493796,13717,'he','×”×¡×ª×¨',0),(493797,13717,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ·',0),(493798,13717,'zh','éšè—',0),(493799,13717,'sv','DÃ¶lja',0),(493800,13717,'it','Nascondere',0),(493801,13717,'tl','',0),(493802,13717,'th','à¸‹à¹ˆà¸­à¸™',0),(493803,13717,'hi','à¤›à¤¿à¤ªà¤¾à¤à¤',0),(493804,13717,'ms','Sembunyi',0),(493805,13717,'ar','Ø¥Ø®ÙØ§Ø¡',0),(493806,13717,'fr','Cacher',0),(493807,13717,'jp','éžè¡¨ç¤ºã«ã—ã¾ã™ã€‚',0),(493808,13717,'pt','Esconder',0),(493809,13717,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ',0),(493810,13717,'es','Esconder',0),(493811,13717,'de','Ausblenden',0),(493812,13717,'en','Hide',0),(493813,13718,'is','',0),(493814,13718,'dr','Ø¹Ø¨Ø§Ø±Øª Ù‡Ø§ÛŒ Ø¯Ø§Ø®Ù„ÛŒ',0),(493815,13718,'pr','Ø¹Ø¨Ø§Ø±Øª Ù‡Ø§ÛŒ Ø¯Ø§Ø®Ù„ÛŒ',0),(493816,13718,'tr','Ä°Ã§ ifade',0),(493817,13718,'pl','WewnÄ™trznego wyraÅ¼enie',0),(493818,13718,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ Ñ„Ñ€Ð°Ð·Ð°',0),(493819,13718,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ ÙÙ‚Ø±Û',0),(493820,13718,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐ° Ñ„Ñ€Ð°Ð·Ñƒ',0),(493821,13718,'vi','Cá»¥m tá»« ná»™i bá»™',0),(493822,13718,'af','Interne frase',0),(493823,13718,'ro','Fraza interne',0),(493824,13718,'et','Sisemine fraas',0),(493825,13718,'si','Notranji frazo',0),(493826,13718,'ba','Internal frase',0),(493827,13718,'nl','Interne zin',0),(493828,13718,'fi','SisÃ¤inen lause',0),(493829,13718,'no','Intern uttrykk',0),(493830,13718,'da','Interne sÃ¦tning',0),(493831,13718,'ko','ë‚´ë¶€ êµ¬ë¬¸',0),(493832,13718,'he','×¦×™×¨×•×£ ×¤× ×™×ž×™',0),(493833,13718,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® Ï†ÏÎ¬ÏƒÎ·',0),(493834,13718,'zh','å†…éƒ¨çš„çŸ­è¯­',0),(493835,13718,'sv','Inre fras',0),(493836,13718,'it','Frase interna',0),(493837,13718,'tl','',0),(493838,13718,'th','à¸§à¸¥à¸µà¸ à¸²à¸¢à¹ƒà¸™',0),(493839,13718,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤µà¤¾à¤•à¥à¤¯à¤¾à¤‚à¤¶',0),(493840,13718,'ms','Frasa dalaman',0),(493841,13718,'ar','Ø§Ù„Ø¹Ø¨Ø§Ø±Ø© Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(493842,13718,'fr','Expression interne',0),(493843,13718,'jp','å†…éƒ¨ãƒ•ãƒ¬ãƒ¼ã‚º',0),(493844,13718,'pt','Frase interna',0),(493845,13718,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÑÑ Ñ„Ñ€Ð°Ð·Ð°',0),(493846,13718,'es','Frase Internal',0),(493847,13718,'de','Interne Phrase',0),(493848,13718,'en','Internal Phrase',0),(493849,13719,'is','',0),(493850,13719,'dr','ØªÙ†Ù‡Ø§ Ø¨Ù‡ Ø¯Ù†Ø¨Ø§Ù„ Ø¹Ø¨Ø§Ø±Ø§Øª Ø¬Ø³ØªØ¬Ùˆ Ø±Ø§ Ø¯Ø± ØµÙØ­Ø§Øª Ø²ÛŒØ± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(493851,13719,'pr','ØªÙ†Ù‡Ø§ Ø¨Ù‡ Ø¯Ù†Ø¨Ø§Ù„ Ø¹Ø¨Ø§Ø±Ø§Øª Ø¬Ø³ØªØ¬Ùˆ Ø±Ø§ Ø¯Ø± ØµÙØ­Ø§Øª Ø²ÛŒØ± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(493852,13719,'tr','YalnÄ±zca aÅŸaÄŸÄ±da seÃ§ili sayfalarda arama terimleri iÃ§in bak',0),(493853,13719,'pl','Tylko szukaÄ‡ haseÅ‚ na stronach wybrane poniÅ¼ej',0),(493854,13719,'bg','Ð¡Ð°Ð¼Ð¾ Ð¿Ð¾Ð³Ð»ÐµÐ´Ð½ÐµÑ‚Ðµ Ð·Ð° Ð´ÑƒÐ¼Ð¸Ñ‚Ðµ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð² ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸Ñ‚Ðµ, Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ',0),(493855,13719,'ur','Ù†ÛŒÚ†Û’ Ù…Ù†ØªØ®Ø¨ ØµÙØ­Ø§Øª Ù…ÛŒÚº ØªÙ„Ø§Ø´ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ú©Û’ Ù„Ø¦Û’ ØµØ±Ù Ù†Ø¸Ø±',0),(493856,13719,'sr','Ð¢Ñ€Ð°Ð¶Ðµ ÑÐ°Ð¼Ð¾ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð° Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ð¼Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð¸ÑÐ¿Ð¾Ð´',0),(493857,13719,'vi','Chá»‰ tÃ¬m kiáº¿m cá»¥m tá»« tÃ¬m kiáº¿m trong cÃ¡c trang Ä‘Æ°á»£c chá»n dÆ°á»›i Ä‘Ã¢y',0),(493858,13719,'af','Kyk net vir soekterme in die bladsye wat hieronder geselekteer is',0),(493859,13719,'ro','Doar uita-te pentru termenii de cÄƒutare Ã®n paginile selectate mai jos',0),(493860,13719,'et','Ainult otsida otsingu tingimusi allpool valitud lehekÃ¼ljed',0),(493861,13719,'si','Samo Poglej za iskalne izraze v spodaj izbrane strani',0),(493862,13719,'ba','Hanya mencari istilah pencarian di halaman-halaman yang dipilih di bawah ini',0),(493863,13719,'nl','Alleen zoeken naar zoektermen in de pagina\'s geselecteerd onder',0),(493864,13719,'fi','Vain etsiÃ¤ etsiÃ¤ ehdot alla valitut sivut',0),(493865,13719,'no','Bare se etter sÃ¸keord pÃ¥ sidene valgt under',0),(493866,13719,'da','Kun kigge efter sÃ¸geord i de sider, der er markeret nedenfor',0),(493867,13719,'ko','ì•„ëž˜ ì„ íƒí•œ íŽ˜ì´ì§€ì—ì„œ ê²€ìƒ‰ì–´ì— ëŒ€ í•œ ìœ ì¼í•œ ëª¨ìŠµ',0),(493868,13719,'he','×¨×§ ×œ×”×¡×ª×›×œ ×¢×œ ×ª× ××™ ×—×™×¤×•×© ×‘×¢×ž×•×“ ×©× ×‘×—×¨ ×œ×”×œ×Ÿ',0),(493869,13719,'el','Î‘Ï€Î»Î¬ ÎºÎ¿Î¹Ï„Î¬Î¾Ï„Îµ Î³Î¹Î± Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚ ÏƒÏ„Î¹Ï‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚ ÏƒÏ„Î¹Ï‚ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚',0),(493870,13719,'zh','ä»…æŸ¥æ‰¾æœç´¢æ¡ä»¶åœ¨ä¸‹é¢æ‰€é€‰çš„é¡µé¢',0),(493871,13719,'sv','Bara leta efter sÃ¶kord i sidor markerad nedan',0),(493872,13719,'it','Solo cercare di termini di ricerca nelle pagine selezionate di seguito',0),(493873,13719,'tl','',0),(493874,13719,'th','à¸¥à¸±à¸à¸©à¸“à¸°à¹€à¸‰à¸žà¸²à¸°à¸ªà¸³à¸«à¸£à¸±à¸šà¸„à¹‰à¸™à¸«à¸²à¹ƒà¸™à¸«à¸™à¹‰à¸²à¹€à¸¥à¸·à¸­à¸à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡',0),(493875,13719,'hi','à¤•à¥‡à¤µà¤² à¤¨à¤¿à¤®à¥à¤¨ à¤šà¤¯à¤¨à¤¿à¤¤ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤®à¥‡à¤‚ à¤–à¥‹à¤œ à¤¶à¤¬à¥à¤¦à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¦à¥‡à¤–à¥‹',0),(493876,13719,'ms','Hanya mencari istilah carian di halaman-halaman yang dipilih di bawah',0),(493877,13719,'ar','Ø§Ø¨Ø­Ø« ÙÙ‚Ø· Ø¹Ù† Ù…ØµØ·Ù„Ø­Ø§Øª Ø§Ù„Ø¨Ø­Ø« ÙÙŠ Ø§Ù„ØµÙØ­Ø§Øª Ø§Ù„Ù…Ø­Ø¯Ø¯Ø© Ø£Ø¯Ù†Ø§Ù‡',0),(493878,13719,'fr','Seulement trouver des termes de recherche dans les pages sÃ©lectionnÃ©es ci-dessous',0),(493879,13719,'jp','ä»¥ä¸‹ã§é¸æŠžã—ãŸãƒšãƒ¼ã‚¸å†…ã®æ¤œç´¢èªžå¥ã‚’æ¤œç´¢ã™ã‚‹ã ã‘',0),(493880,13719,'pt','Olha sÃ³ para termos de busca nas pÃ¡ginas selecionadas abaixo',0),(493881,13719,'ru','Ð˜ÑÐºÐ°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¿Ð¾Ð¸ÑÐºÐ° Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ…, Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð½Ð¸Ð¶Ðµ',0),(493882,13719,'es','Solo Busca los TÃ©rminos de Busqueda en las PÃ¡ginas Seleccionadas Abajo',0),(493883,13719,'de','Nur Suchbegriffe in den unten ausgewÃ¤hlten Seiten suchen',0),(493884,13719,'en','Only look for search terms in the pages selected below',0),(493885,13720,'is','',0),(493886,13720,'dr','ØµÙØ­Ù‡ Ù…Ø³Ø§Ø¨Ù‚Ø§Øª',0),(493887,13720,'pr','ØµÙØ­Ù‡ Ù…Ø³Ø§Ø¨Ù‚Ø§Øª',0),(493888,13720,'tr','Sayfa maÃ§lar',0),(493889,13720,'pl','Pasuje do strony',0),(493890,13720,'bg','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¼Ð°Ñ‡Ð¾Ð²Ðµ',0),(493891,13720,'ur','ØµÙØ­Û Ù…Ø´Ø§Ø¨Û Ú©Ø±ØªØ§ ÛÛ’',0),(493892,13720,'sr','ÐŸÐ¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐµ ÑÐ° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(493893,13720,'vi','Trang phÃ¹ há»£p vá»›i',0),(493894,13720,'af','Bladsy pas',0),(493895,13720,'ro','Pagina de meciuri',0),(493896,13720,'et','Lehe vastet',0),(493897,13720,'si','Stran tekme',0),(493898,13720,'ba','Halaman pertandingan',0),(493899,13720,'nl','Pagina Matches',0),(493900,13720,'fi','Sivun ottelut',0),(493901,13720,'no','Siden kamper',0),(493902,13720,'da','Side kampe',0),(493903,13720,'ko','ì¼ì¹˜ í•˜ëŠ” íŽ˜ì´ì§€',0),(493904,13720,'he','×“×£ ×ª×•××',0),(493905,13720,'el','Î£ÎµÎ»Î¯Î´Î± Î±Î³ÏŽÎ½ÎµÏ‚',0),(493906,13720,'zh','é¡µé¢åŒ¹é…',0),(493907,13720,'sv','Sidan matchar',0),(493908,13720,'it','Pagina corrisponde',0),(493909,13720,'tl','',0),(493910,13720,'th','à¸«à¸™à¹‰à¸²à¸•à¸£à¸‡',0),(493911,13720,'hi','à¤ªà¥‡à¤œ à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¤à¤¾',0),(493912,13720,'ms','Padanan Laman',0),(493913,13720,'ar','ØµÙØ­Ø© Ø§Ù„Ù…Ø¨Ø§Ø±ÙŠØ§Øª',0),(493914,13720,'fr','Page correspond Ã ',0),(493915,13720,'jp','ãƒšãƒ¼ã‚¸ã¨ä¸€è‡´ã—ã¾ã™ã€‚',0),(493916,13720,'pt','PÃ¡gina corresponde',0),(493917,13720,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÑÐ¾Ð²Ð¿Ð°Ð´Ð°ÐµÑ‚',0),(493918,13720,'es','Empareja de PÃ¡ginas',0),(493919,13720,'de','AusgefÃ¼llter',0),(493920,13720,'en','Page Matches',0),(493921,13721,'is','',0),(493922,13721,'dr','Ù…Ù†Ùˆ Ø§Ø² Ù†Ùˆ Ø®Ù„Ù‚ Ú©Ø±Ø¯Ù†',0),(493923,13721,'pr','Ù…Ù†Ùˆ Ø§Ø² Ù†Ùˆ Ø®Ù„Ù‚ Ú©Ø±Ø¯Ù†',0),(493924,13721,'tr','MenÃ¼yÃ¼ yeniden oluÅŸturun',0),(493925,13721,'pl','Odtworzenie Menu',0),(493926,13721,'bg','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¼ÐµÐ½ÑŽ',0),(493927,13721,'ur','Ù…ÛŒÙ†Ùˆ Ú©Ùˆ Ø¯ÙˆØ¨Ø§Ø±Û ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(493928,13721,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¼ÐµÐ½Ð¸Ñ˜Ð°',0),(493929,13721,'vi','Táº¡o láº¡i Menu',0),(493930,13721,'af','Herskep kieslys',0),(493931,13721,'ro','Recrea meniu',0),(493932,13721,'et','Loo menÃ¼Ã¼',0),(493933,13721,'si','Znova ustvarite meni',0),(493934,13721,'ba','Menciptakan Menu',0),(493935,13721,'nl','Menu opnieuw',0),(493936,13721,'fi','Luo valikko',0),(493937,13721,'no','Gjenskape menyen',0),(493938,13721,'da','Genskabe Menu',0),(493939,13721,'ko','ë©”ë‰´ë¥¼ ë‹¤ì‹œ',0),(493940,13721,'he','×œ×©×—×–×¨ ××ª ×”×ª×¤×¨×™×˜',0),(493941,13721,'el','Î‘Î½Î±Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Î¼ÎµÎ½Î¿Ï',0),(493942,13721,'zh','é‡æ–°åˆ›å»ºèœå•',0),(493943,13721,'sv','Ã…terskapa menyn',0),(493944,13721,'it','Ricreare Menu',0),(493945,13721,'tl','',0),(493946,13721,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹€à¸¡à¸™à¸¹',0),(493947,13721,'hi','à¤®à¥‡à¤¨à¥‚ à¤ªà¥à¤¨: à¤¬à¤¨à¤¾à¤à¤',0),(493948,13721,'ms','Mencipta Menu',0),(493949,13721,'ar','Ù‚Ù… Ø¨Ø¥Ø¹Ø§Ø¯Ø© Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(493950,13721,'fr','RecrÃ©er le Menu',0),(493951,13721,'jp','ãƒ¡ãƒ‹ãƒ¥ãƒ¼ã®å†ä½œæˆã—ã¾ã™ã€‚',0),(493952,13721,'pt','Recriar o Menu',0),(493953,13721,'ru','Ð’Ð¾ÑÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¼ÐµÐ½ÑŽ',0),(493954,13721,'es','Recrear el MenÃº',0),(493955,13721,'de','Neu im MenÃ¼',0),(493956,13721,'en','Recreate Menu',0),(493957,13722,'is','',0),(493958,13722,'dr','Ø¨Ø§Ø²Ø¯Ù‡ ØªÙ†Ù‡Ø§ ØªØ¹Ø§Ø±ÛŒÙ Ø¨Ø±Ø§ÛŒ Ø²Ø¨Ø§Ù† Ø´Ù…Ø§ Ø®Ø§Ù„ÛŒ',0),(493959,13722,'pr','Ø¨Ø§Ø²Ø¯Ù‡ ØªÙ†Ù‡Ø§ ØªØ¹Ø§Ø±ÛŒÙ Ø¨Ø±Ø§ÛŒ Ø²Ø¨Ø§Ù† Ø´Ù…Ø§ Ø®Ø§Ù„ÛŒ',0),(493960,13722,'tr','DÃ¶ner, yalnÄ±zca dil tanÄ±mlarÄ±nda boÅŸ',0),(493961,13722,'pl','Zwraca tylko puste definicje dla danego jÄ™zyka',0),(493962,13722,'bg','Ð’Ñ€ÑŠÑ‰Ð° ÑÐ°Ð¼Ð¾ Ð¿Ñ€Ð°Ð·Ð½Ð¸ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ð¸ Ð·Ð° Ð²Ð°ÑˆÐ¸Ñ ÐµÐ·Ð¸Ðº',0),(493963,13722,'ur','ÙˆØ§Ù¾Ø³ Ú©Ø±ØªØ§ ÛÛ’ ØµØ±Ù Ø¢Ù¾ Ú©ÛŒ Ø²Ø¨Ø§Ù† Ú©ÛŒ ØªØ¹Ø±ÛŒÙÛŒÚº Ø®Ø§Ù„ÛŒ',0),(493964,13722,'sr','Ð”Ð°Ñ˜Ðµ ÑÐ°Ð¼Ð¾ Ð¿Ñ€Ð°Ð·Ð°Ð½ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ðµ Ð·Ð° Ð²Ð°Ñˆ Ñ˜ÐµÐ·Ð¸Ðº',0),(493965,13722,'vi','Lá»£i nhuáº­n chá»‰ trá»‘ng Ä‘á»‹nh nghÄ©a cho ngÃ´n ngá»¯ cá»§a báº¡n',0),(493966,13722,'af','Opbrengste net blanko definisies vir jou taal',0),(493967,13722,'ro','ReturneazÄƒ doar martor definiÈ›ii pentru limba dvs.',0),(493968,13722,'et','Tagastab ainult tÃ¼hi oma keele mÃµisted',0),(493969,13722,'si','Vrne prazno le opredelitve za vaÅ¡ jezik',0),(493970,13722,'ba','Kembali hanya kosong definisi untuk bahasa Anda',0),(493971,13722,'nl','Geeft als resultaat alleen lege definities voor uw taal',0),(493972,13722,'fi','Palauttaa vain tyhjÃ¤ mÃ¤Ã¤ritelmÃ¤t kieli',0),(493973,13722,'no','Returnerer bare tomme definisjoner For ditt sprÃ¥k',0),(493974,13722,'da','Returnerer kun Tom definitioner For dit sprog',0),(493975,13722,'ko','ë°˜í™˜ë§Œ ë¹ˆ ë‹¹ì‹ ì˜ ì–¸ì–´ì— ëŒ€ í•œ ì •ì˜',0),(493976,13722,'he','×”×—×–×¨×” ×¨×™×§ ×¨×§ ×”×’×“×¨×•×ª ×¢×‘×•×¨ ×”×©×¤×” ×©×œ×š',0),(493977,13722,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ­Ï†ÎµÎ¹ ÎºÎµÎ½ÏŒ Î¼ÏŒÎ½Î¿ Î¿ÏÎ¹ÏƒÎ¼Î¿Î¯ Î³Î¹Î± Ï„Î· Î³Î»ÏŽÏƒÏƒÎ± ÏƒÎ±Ï‚',0),(493978,13722,'zh','è¿”å›žä»…é™ç©ºå®šä¹‰ä¸ºæ‚¨çš„è¯­è¨€',0),(493979,13722,'sv','Returnerar endast tomma definitioner fÃ¶r ditt sprÃ¥k',0),(493980,13722,'it','Restituisce solo vuoto definizioni per la tua lingua',0),(493981,13722,'tl','',0),(493982,13722,'th','à¸à¸¥à¸±à¸šà¸§à¹ˆà¸²à¸‡à¹€à¸›à¸¥à¹ˆà¸²à¸„à¸³à¸™à¸´à¸¢à¸²à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸ à¸²à¸©à¸²à¹€à¸‰à¸žà¸²à¸°',0),(493983,13722,'hi','à¤°à¤¿à¤Ÿà¤°à¥à¤¨ à¤•à¥‡à¤µà¤² à¤…à¤ªà¤¨à¥€ à¤­à¤¾à¤·à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾à¤à¤ à¤°à¤¿à¤•à¥à¤¤',0),(493984,13722,'ms','Pulangan hanya kosong definisi bahasa anda',0),(493985,13722,'ar','Ø¥Ø±Ø¬Ø§Ø¹ ÙØ§Ø±ØºØ© ÙÙ‚Ø· ØªØ¹Ø±ÙŠÙØ§Øª Ù„Ù„ØºØ© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ',0),(493986,13722,'fr','Retourne seulement vierges dÃ©finitions correspondant Ã  votre langue',0),(493987,13722,'jp','ç©ºã®ã‚ãªãŸã®è¨€èªžã®å®šç¾©ã®ã¿ã‚’è¿”ã—ã¾ã™',0),(493988,13722,'pt','Retorna somente em branco as definiÃ§Ãµes para o seu idioma',0),(493989,13722,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÑ‚ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿ÑƒÑÑ‚Ð¾Ð¹ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ð¹ Ð´Ð»Ñ Ð²Ð°ÑˆÐµÐ³Ð¾ ÑÐ·Ñ‹ÐºÐ°',0),(493990,13722,'es','Se Da Sola Definiciones en Blanco Para Su Idioma',0),(493991,13722,'de','Gibt nur Blank Definitionen fÃ¼r Ihre Sprache',0),(493992,13722,'en','Returns Only Blank Definitions For Your Language',0),(493993,13723,'is','',0),(493994,13723,'dr','Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÛŒ Ù…Ø¯Øª Ø¨Ø§Ù„Ø§ Ø¯Ø± Ù‡Ø± Ø¯Ùˆ Ø¹Ø¨Ø§Ø±Øª Ø¯Ø§Ø®Ù„ÛŒ ÛŒØ§ ØªØ¹Ø±ÛŒÙ',0),(493995,13723,'pr','Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÛŒ Ù…Ø¯Øª Ø¨Ø§Ù„Ø§ Ø¯Ø± Ù‡Ø± Ø¯Ùˆ Ø¹Ø¨Ø§Ø±Øª Ø¯Ø§Ø®Ù„ÛŒ ÛŒØ§ ØªØ¹Ø±ÛŒÙ',0),(493996,13723,'tr','Terim ya da iÃ§ tÃ¼mcecik aramak veya tanÄ±mÄ±',0),(493997,13723,'pl','Wyszukaj termin powyÅ¼ej albo wewnÄ™trznego wyraÅ¼enie lub definicji',0),(493998,13723,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð° Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ Ð² Ð¸Ð»Ð¸ Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸ Ñ„Ñ€Ð°Ð·Ð° Ð¸Ð»Ð¸ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(493999,13723,'ur','Ø§Ø³ Ø§ØµØ·Ù„Ø§Ø­ Ú©Û’ Ø§ÙˆÙ¾Ø± ÛŒØ§ Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ ÙÙ‚Ø±Û ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº ÛŒØ§ ØªØ¹Ø±ÛŒÙ',0),(494000,13723,'sr','Ð¢Ñ€Ð°Ð¶ÐµÑšÐµ Ñ‚ÐµÑ€Ð¼Ð¸Ð½ Ð¸Ð·Ð½Ð°Ð´ Ñƒ Ð½Ð¸ ÑƒÐ½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐµ Ñ„Ñ€Ð°Ð·Ñƒ Ð¸Ð»Ð¸ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð°',0),(494001,13723,'vi','TÃ¬m kiáº¿m cá»¥m tá»« á»Ÿ trÃªn trong má»™t cá»¥m tá»« ná»™i bá»™ hoáº·c Ä‘á»‹nh nghÄ©a',0),(494002,13723,'af','Soek vir die term bo in Ã³f die interne frase of definisie',0),(494003,13723,'ro','CautÄƒ termenul mai sus fie fraza interne sau definirea',0),(494004,13723,'et','Otsida sÃµna kohal kas sisemine fraas vÃµi mÃ¤Ã¤ratlus',0),(494005,13723,'si','Iskanje izraz zgoraj v bodisi notranja stavek ali opredelitev',0),(494006,13723,'ba','Cari istilah di atas dalam frase internal atau definisi',0),(494007,13723,'nl','Zoeken naar de term boven in ofwel de interne zin of definitie',0),(494008,13723,'fi','Etsi termiÃ¤ joko sisÃ¤inen lause tai mÃ¤Ã¤ritelmÃ¤',0),(494009,13723,'no','SÃ¸ker pÃ¥ ordet over enten interne uttrykket eller definisjon',0),(494010,13723,'da','SÃ¸ge efter udtrykket ovenfor i enten den interne sÃ¦tning eller definition',0),(494011,13723,'ko','ìœ„ì˜ ê¸°ê°„ ì¤‘ ë‚´ë¶€ êµ¬ë¬¸ ê²€ìƒ‰ ë˜ëŠ” ì •ì˜',0),(494012,13723,'he','×—×¤×© ××ª ×”×ž×•× ×— ×ž×¢×œ ×’× ×”×‘×™×˜×•×™ ×”×¤× ×™×ž×™ ××• ×”×’×“×¨×”',0),(494013,13723,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± Ï„Î¿Î½ ÏŒÏÎ¿ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® Ï†ÏÎ¬ÏƒÎ· Î® Î¿ÏÎ¹ÏƒÎ¼ÏŒ',0),(494014,13723,'zh','æœç´¢è¯ä»¥ä¸Šä»»ä¸€å†…éƒ¨çŸ­è¯­æˆ–å®šä¹‰',0),(494015,13723,'sv','SÃ¶k pÃ¥ sikt Ã¶ver antingen inre frasen eller definition',0),(494016,13723,'it','Ricerca per il termine sopra in entrambi la frase interna o definizione',0),(494017,13723,'tl','',0),(494018,13723,'th','à¸„à¹‰à¸™à¸«à¸²à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚à¸‚à¹‰à¸²à¸‡à¸•à¹‰à¸™à¹ƒà¸™à¸ à¸²à¸¢à¹ƒà¸™à¸§à¸¥à¸µ à¸«à¸£à¸·à¸­à¸„à¸³à¸ˆà¸³à¸à¸±à¸”à¸„à¸§à¸²à¸¡',0),(494019,13723,'hi','à¤‡à¤¸à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤¶à¤¬à¥à¤¦ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¾ à¤¤à¥‹ à¤®à¥‡à¤‚ à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤µà¤¾à¤•à¥à¤¯à¤¾à¤‚à¤¶ à¤–à¥‹à¤œ à¤¯à¤¾ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾',0),(494020,13723,'ms','Mencari istilah di atas sama ada frasa dalaman atau definisi',0),(494021,13723,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ù…ØµØ·Ù„Ø­ Ø£Ø¹Ù„Ø§Ù‡ ÙÙŠ Ø£Ù…Ø§ Ø¹Ø¨Ø§Ø±Ø© Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ© Ø£Ùˆ ØªØ¹Ø±ÙŠÙ',0),(494022,13723,'fr','Rechercher le terme ci-dessus soit dans l\'expression interne ou dÃ©finition',0),(494023,13723,'jp','å†…éƒ¨ãƒ•ãƒ¬ãƒ¼ã‚ºã„ãšã‚Œã‹ã§ä¸Šè¨˜ã®ç”¨èªžã‚’æ¤œç´¢ã¾ãŸã¯å®šç¾©',0),(494024,13723,'pt','Pesquisa para o termo acima em qualquer um a frase interna ou definiÃ§Ã£o',0),(494025,13723,'ru','ÐŸÐ¾Ð¸ÑÐº Ð½Ð° ÑÑ€Ð¾Ðº Ð²Ñ‹ÑˆÐµ Ð»Ð¸Ð±Ð¾ Ð²Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÐµÐ¹ Ñ„Ñ€Ð°Ð·Ñ‹ Ð¸Ð»Ð¸ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(494026,13723,'es','Buscar para el TÃ©rmino arriba eno el Frase internal o la definiciÃ³n',0),(494027,13723,'de','Suchen nach dem Begriff oben entweder die interne Phrase oder Definition',0),(494028,13723,'en','Search for the term above in either the internal phrase Or definition',0),(494029,13724,'is','',0),(494030,13724,'dr','Ø¬Ø³ØªØ¬Ùˆ Ø¯Ø± ØªØ¹Ø±ÛŒÙ Ø¨Ø§ÛŒØ¯',0),(494031,13724,'pr','Ø¬Ø³ØªØ¬Ùˆ Ø¯Ø± ØªØ¹Ø±ÛŒÙ Ø¨Ø§ÛŒØ¯',0),(494032,13724,'tr','Arama terimi tanÄ±mÄ±nda bulunmalÄ±dÄ±rlar',0),(494033,13724,'pl','Szukana fraza musi mieÄ‡ w definicji',0),(494034,13724,'bg','ÐšÐ»ÑŽÑ‡Ð¾Ð²Ð°Ñ‚Ð° Ð´ÑƒÐ¼Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð² Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ',0),(494035,13724,'ur','ØªÙ„Ø§Ø´ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­ Ù…ÛŒÚº ØªØ¹Ø±ÛŒÙ ÛÙˆÙ†ÛŒ Ú†Ø§ÛÛŒÛ’',0),(494036,13724,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ñ˜Ðµ Ñ‚ÐµÑ€Ð¼Ð¸Ð½ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ Ñƒ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð¸',0),(494037,13724,'vi','Cá»¥m tá»« tÃ¬m kiáº¿m pháº£i náº±m trong Ä‘á»‹nh nghÄ©a',0),(494038,13724,'af','Soekterm moet word in die definisie',0),(494039,13724,'ro','Termen de cÄƒutare trebuie sÄƒ fie Ã®n definirea',0),(494040,13724,'et','Otsitav sÃµna peab olema mÃ¤Ã¤ratlus',0),(494041,13724,'si','Iskalni izraz mora biti v definiciji',0),(494042,13724,'ba','Istilah pencarian harus dalam definisi',0),(494043,13724,'nl','Zoekterm moet in definitie worden',0),(494044,13724,'fi','Hakusanan tulee olla mÃ¤Ã¤ritelmÃ¤',0),(494045,13724,'no','SÃ¸kestrengen mÃ¥ vÃ¦re i definisjonen',0),(494046,13724,'da','SÃ¸geordet skal vÃ¦re i definition',0),(494047,13724,'ko','ê²€ìƒ‰ ìš©ì–´ ì •ì˜ì— ìžˆì–´ì•¼',0),(494048,13724,'he','×ž×•× ×— ×—×™×¤×•×© ×—×™×™×‘ ×œ×”×™×•×ª ×”×’×“×¨×ª',0),(494049,13724,'el','ÎŒÏÎ¿Ï‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÏƒÏ„Î¿Î½ Î¿ÏÎ¹ÏƒÎ¼ÏŒ',0),(494050,13724,'zh','æœç´¢è¯å¿…é¡»åœ¨å®šä¹‰',0),(494051,13724,'sv','SÃ¶kordet mÃ¥ste vara i definitionen',0),(494052,13724,'it','Termine di ricerca deve essere in definizione',0),(494053,13724,'tl','',0),(494054,13724,'th','à¸„à¸³à¸„à¹‰à¸™à¸«à¸²à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸„à¸³à¸ˆà¸³à¸à¸±à¸”à¸„à¸§à¸²à¸¡',0),(494055,13724,'hi','à¤–à¥‹à¤œ à¤¶à¤¬à¥à¤¦ à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾ à¤¹à¥‹à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(494056,13724,'ms','Istilah carian harus dalam definisi',0),(494057,13724,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù…ØµØ·Ù„Ø­ Ø§Ù„Ø¨Ø­Ø« ÙÙŠ ØªØ¹Ø±ÙŠÙ',0),(494058,13724,'fr','Terme de recherche doit Ãªtre dans la dÃ©finition',0),(494059,13724,'jp','æ¤œç´¢ç”¨èªžã®å®šç¾©ã§ã‚ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(494060,13724,'pt','Termo de pesquisa deve ser na definiÃ§Ã£o',0),(494061,13724,'ru','ÐŸÐ¾Ð¸ÑÐºÐ¾Ð²Ñ‹Ð¹ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð² Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ð¸',0),(494062,13724,'es','TÃ©rmino de busqueda debe ser la definiciÃ³n',0),(494063,13724,'de','Suchbegriff muss in der Definition enthalten.',0),(494064,13724,'en','Search term must be in definition',0),(494065,13725,'is','',0),(494066,13725,'dr','Ø¬Ø³ØªØ¬Ùˆ Ø¯Ø± Ø¹Ø¨Ø§Ø±Øª Ø¯Ø§Ø®Ù„ÛŒ Ø¨Ø§ÛŒØ¯',0),(494067,13725,'pr','Ø¬Ø³ØªØ¬Ùˆ Ø¯Ø± Ø¹Ø¨Ø§Ø±Øª Ø¯Ø§Ø®Ù„ÛŒ Ø¨Ø§ÛŒØ¯',0),(494068,13725,'tr','Arama terimi iÃ§ ifade olmalÄ±dÄ±r',0),(494069,13725,'pl','Szukana fraza musi mieÄ‡ w wewnÄ™trznego wyraÅ¼enie',0),(494070,13725,'bg','ÐšÐ»ÑŽÑ‡Ð¾Ð²Ð°Ñ‚Ð° Ð´ÑƒÐ¼Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð²ÑŠÐ² Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸Ñ Ñ„Ñ€Ð°Ð·Ð°',0),(494071,13725,'ur','ØªÙ„Ø§Ø´ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­ Ù…ÛŒÚº Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ ÙÙ‚Ø±Û ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(494072,13725,'sr','Ð¢ÐµÑ€Ð¼Ð¸Ð½ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ñƒ ÑƒÐ½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐµ Ñ„Ñ€Ð°Ð·Ñƒ',0),(494073,13725,'vi','Cá»¥m tá»« tÃ¬m kiáº¿m pháº£i trong ná»™i bá»™ cá»¥m tá»«',0),(494074,13725,'af','Soekterm moet word in interne frase',0),(494075,13725,'ro','Termen de cÄƒutare trebuie sÄƒ fie Ã®n fraza interne',0),(494076,13725,'et','Otsitav sÃµna peab olema sisemine fraas',0),(494077,13725,'si','Iskalni izraz mora biti v notranji frazo',0),(494078,13725,'ba','Istilah pencarian harus dalam frase internal',0),(494079,13725,'nl','Zoekterm moet in interne zin worden',0),(494080,13725,'fi','Hakusanan tulee olla sisÃ¤inen lause',0),(494081,13725,'no','SÃ¸kestrengen mÃ¥ vÃ¦re i interne uttrykk',0),(494082,13725,'da','SÃ¸geordet skal vÃ¦re i indre sÃ¦tning',0),(494083,13725,'ko','ë‚´ë¶€ ë¬¸êµ¬ì— ê²€ìƒ‰ì–´ ë˜ì–´ì•¼ í•©ë‹ˆë‹¤.',0),(494084,13725,'he','×ž×•× ×— ×—×™×¤×•×© ×‘×˜×— ×‘×ž×©×¤×˜ ×”×¤× ×™×ž×™',0),(494085,13725,'el','ÎŒÏÎ¿Ï‚ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÏƒÏ„Î·Î½ ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ® Ï†ÏÎ¬ÏƒÎ·',0),(494086,13725,'zh','æœç´¢è¯å¿…é¡»åœ¨å†…éƒ¨çŸ­è¯­',0),(494087,13725,'sv','SÃ¶kordet mÃ¥ste vara i inre fras',0),(494088,13725,'it','Termine di ricerca deve essere nella frase interna',0),(494089,13725,'tl','',0),(494090,13725,'th','à¸„à¸³à¸„à¹‰à¸™à¸«à¸²à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸§à¸¥à¸µà¸ à¸²à¸¢à¹ƒà¸™',0),(494091,13725,'hi','à¤–à¥‹à¤œ à¤¶à¤¬à¥à¤¦ à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤µà¤¾à¤•à¥à¤¯à¤¾à¤‚à¤¶ à¤®à¥‡à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(494092,13725,'ms','Istilah carian harus dalam frasa dalaman',0),(494093,13725,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù…ØµØ·Ù„Ø­ Ø§Ù„Ø¨Ø­Ø« ÙÙŠ Ø§Ù„Ø¹Ø¨Ø§Ø±Ø© Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(494094,13725,'fr','Terme de recherche doit Ãªtre dans l\'expression interne',0),(494095,13725,'jp','å†…éƒ¨ãƒ•ãƒ¬ãƒ¼ã‚ºã§æ¤œç´¢ç”¨èªžãŒã‚ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(494096,13725,'pt','Termo de pesquisa deve estar na frase interna',0),(494097,13725,'ru','ÐŸÐ¾Ð¸ÑÐºÐ¾Ð²Ñ‹Ð¹ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð²Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÐµÐ¹ Ñ„Ñ€Ð°Ð·Ñ‹',0),(494098,13725,'es','TÃ©rmino de busqueda debe ser en el frase internal',0),(494099,13725,'de','Suchbegriff muss im internen Ausdruck enthalten.',0),(494100,13725,'en','Search term must be in internal phrase',0),(494101,13726,'is','',0),(494102,13726,'dr','ØªÙ…Ø§Ù… ØµÙØ­Ø§Øª Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ ÛŒÚ© Ú©Ù„Ù…Ù‡ ÛŒØ§ Ø¹Ø¨Ø§Ø±Øª Ø±Ø§ Ø¯Ø± Ù†Ø¸Ø± Ù…ÛŒ Ø±Ø³Ø¯',0),(494103,13726,'pr','ØªÙ…Ø§Ù… ØµÙØ­Ø§Øª Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ ÛŒÚ© Ú©Ù„Ù…Ù‡ ÛŒØ§ Ø¹Ø¨Ø§Ø±Øª Ø±Ø§ Ø¯Ø± Ù†Ø¸Ø± Ù…ÛŒ Ø±Ø³Ø¯',0),(494104,13726,'tr','Bir sÃ¶zcÃ¼k veya tÃ¼mcecik gÃ¶rÃ¼nÃ¼r tÃ¼m sayfalarÄ± gÃ¶sterir',0),(494105,13726,'pl','Pokazuje wszystkie strony, Å¼e sÅ‚owo lub zdanie pojawia siÄ™ na',0),(494106,13726,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ Ð½Ð° Ð´ÑƒÐ¼Ð° Ð¸Ð»Ð¸ Ñ„Ñ€Ð°Ð·Ð° ÑÐµ Ð¿Ð¾ÑÐ²ÑÐ²Ð° Ð½Ð°',0),(494107,13726,'ur','Ø§ÛŒÚ© Ù„ÙØ¸ ÛŒØ§ ÙÙ‚Ø±Û Ù¾Ø± Ø¸Ø§ÛØ± ÛÙˆØªØ§ ÛÛ’ ØªÙ…Ø§Ù… ØµÙØ­Ø§Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ØªØ§ ÛÛ’',0),(494108,13726,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·ÑƒÑ˜Ðµ ÑÐ²Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ñ€ÐµÑ‡ Ð¸Ð»Ð¸ Ñ„Ñ€Ð°Ð·Ð° ÑÐµ Ð¿Ð¾Ñ˜Ð°Ð²Ñ™ÑƒÑ˜Ðµ Ð½Ð°',0),(494109,13726,'vi','Cho tháº¥y táº¥t cáº£ cÃ¡c trang má»™t tá»« hoáº·c cá»¥m tá»« xuáº¥t hiá»‡n trÃªn',0),(494110,13726,'af','Alle bladsye toon \'n woord of frase verskyn op',0),(494111,13726,'ro','AfiÅŸeazÄƒ toate paginile un cuvÃ¢nt sau o frazÄƒ apare pe',0),(494112,13726,'et','Kuvatakse kÃµik lehed sÃµna vÃµi fraas',0),(494113,13726,'si','Prikazuje vse strani besedo ali frazo, ki se pojavi na',0),(494114,13726,'ba','Menunjukkan semua halaman kata atau frase muncul di',0),(494115,13726,'nl','Alle pagina\'s ziet u dat een woord of woordgroep ziet op',0),(494116,13726,'fi','NÃ¤yttÃ¤Ã¤ kaikki sivut sana tai lause nÃ¤kyy',0),(494117,13726,'no','Viser alle sidene et ord eller uttrykk vises pÃ¥',0),(494118,13726,'da','Viser alle sider en ord eller denne sÃƒÂ¦tning vises pÃ¥',0),(494119,13726,'ko','ë‹¨ì–´ ë˜ëŠ” êµ¬ë¬¸ì— ë‚˜íƒ€ë‚˜ëŠ” ëª¨ë“  íŽ˜ì´ì§€ì— í‘œì‹œ',0),(494120,13726,'he','×ž×¦×™×’×” ××ª ×›×œ ×”×“×¤×™× ×©×ž×™×œ×” ××• ×‘×™×˜×•×™ ×ž×•×¤×™×¢',0),(494121,13726,'el','Î•Î¼Ï†Î±Î½Î¯Î¶ÎµÎ¹ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚, Î¼Î¹Î± Î»Î­Î¾Î· Î® Ï†ÏÎ¬ÏƒÎ· Ï€Î¿Ï… ÎµÎ¼Ï†Î±Î½Î¯Î¶ÎµÏ„Î±Î¹ ÏƒÏ„Î·Î½',0),(494122,13726,'zh','æ˜¾ç¤ºæ‰€æœ‰é¡µä¸Šæ˜¾ç¤ºçš„å•è¯æˆ–çŸ­è¯­',0),(494123,13726,'sv','Visar alla sidor ett ord eller en fras visas pÃ¥',0),(494124,13726,'it','Mostra tutte le pagine di che una parola o una frase appare su',0),(494125,13726,'tl','',0),(494126,13726,'th','à¹à¸ªà¸”à¸‡à¸—à¸¸à¸à¸«à¸™à¹‰à¸²à¸‚à¸­à¸‡à¸„à¸³à¸«à¸£à¸·à¸­à¸§à¸¥à¸µà¸—à¸µà¹ˆà¸›à¸£à¸²à¸à¸à¸­à¸¢à¸¹à¹ˆà¸šà¸™',0),(494127,13726,'hi','à¤¸à¤­à¥€ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤ªà¤° à¤ªà¥à¤°à¤•à¤Ÿ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ à¤à¤• à¤¶à¤¬à¥à¤¦ à¤¯à¤¾ à¤µà¤¾à¤•à¥à¤¯à¤¾à¤‚à¤¶ à¤¸à¥‡ à¤ªà¤¤à¤¾ à¤šà¤²à¤¤à¤¾ à¤¹à¥ˆ',0),(494128,13726,'ms','Menunjukkan semua halaman perkataan atau frasa yang muncul di',0),(494129,13726,'ar','ØªØ¹Ø±Ø¶ ÙƒØ§ÙØ© ØµÙØ­Ø§Øª ØªØ¸Ù‡Ø± ÙƒÙ„Ù…Ø© Ø£Ùˆ Ø¹Ø¨Ø§Ø±Ø© ÙÙŠ',0),(494130,13726,'fr','Montre toutes les pages Ã  qu\'un mot ou une phrase apparaÃ®t sur',0),(494131,13726,'jp','å˜èªžã¾ãŸã¯èªžå¥ã§è¡¨ç¤ºã™ã¹ã¦ã®ãƒšãƒ¼ã‚¸ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(494132,13726,'pt','Mostra todas as pÃ¡ginas de que uma palavra ou frase aparece na',0),(494133,13726,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°ÐµÑ‚ Ð²ÑÐµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ð½Ð° Ð¿Ð¾ÑÐ²Ð»ÑÐµÑ‚ÑÑ ÑÐ»Ð¾Ð²Ð¾ Ð¸Ð»Ð¸ Ñ„Ñ€Ð°Ð·Ñƒ',0),(494134,13726,'es','Muestra Todas Las PÃ¡ginas en Donde Aparece una Palabra o Frase',0),(494135,13726,'de','Zeigt alle Seiten eines Worts oder Ausdrucks auf angezeigt wird',0),(494136,13726,'en','Shows all pages a word or phrase appears on',0),(494137,13727,'is','',0),(494138,13727,'dr','Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ ØªÙ†Ù‡Ø§ Ø´Ø§Ù‡Ø¯',0),(494139,13727,'pr','Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ ØªÙ†Ù‡Ø§ Ø´Ø§Ù‡Ø¯',0),(494140,13727,'tr','Sadece boÅŸluklarÄ± gÃ¶ster',0),(494141,13727,'pl','PokaÅ¼ tylko puste',0),(494142,13727,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð·Ð°Ð³Ð¾Ñ‚Ð¾Ð²ÐºÐ¸',0),(494143,13727,'ur','ØµØ±Ù Ø®Ø§Ù„ÛŒ Ø¬Ú¯ÛÛŒÚº Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(494144,13727,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð¿Ñ€Ð°Ð·Ð½Ðµ Ñ›ÐµÐ»Ð¸Ñ˜Ðµ',0),(494145,13727,'vi','Hiá»ƒn thá»‹ chá»‰ khoáº£ng trá»‘ng',0),(494146,13727,'af','Wys net blanko spasies',0),(494147,13727,'ro','AratÄƒ numai necompletate',0),(494148,13727,'et','NÃ¤ita ainult toorikud',0),(494149,13727,'si','PokaÅ¾i le prazne',0),(494150,13727,'ba','Tampilkan hanya kosong',0),(494151,13727,'nl','Toon alleen spaties',0),(494152,13727,'fi','NÃ¤ytÃ¤ vain tyhjÃ¤t',0),(494153,13727,'no','Vis bare tomme',0),(494154,13727,'da','Vis kun tomme',0),(494155,13727,'ko','ë§Œ ê³µë°± í‘œì‹œ',0),(494156,13727,'he','×”×¦×’ ×¨×§ ×›×“×•×¨×™ ×¡×¨×§',0),(494157,13727,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ ÎºÎµÎ½Î¬',0),(494158,13727,'zh','æ˜¾ç¤ºåªæœ‰ç©ºç™½',0),(494159,13727,'sv','Visa endast tomma',0),(494160,13727,'it','Visualizza solo gli spazi vuoti',0),(494161,13727,'tl','',0),(494162,13727,'th','à¹à¸ªà¸”à¸‡à¸Šà¹ˆà¸­à¸‡à¸§à¹ˆà¸²à¸‡à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(494163,13727,'hi','à¤•à¥‡à¤µà¤² à¤°à¤¿à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤ à¤¦à¤¿à¤–à¤¾à¤¨à¥‡',0),(494164,13727,'ms','Menunjukkan hanya kosong',0),(494165,13727,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙØ±Ø§ØºØ§Øª ÙÙ‚Ø·',0),(494166,13727,'fr','Montrer seulement les flans',0),(494167,13727,'jp','ç©ºç™½ã ã‘ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(494168,13727,'pt','Mostrar somente espaÃ§os em branco',0),(494169,13727,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð·Ð°Ð³Ð¾Ñ‚Ð¾Ð²Ð¾Ðº',0),(494170,13727,'es','Muestra Solo Blancos',0),(494171,13727,'de','Zeigen nur Leerzeichen',0),(494172,13727,'en','Show Only Blanks',0),(494173,13728,'is','',0),(494174,13728,'dr','Ú©Ù„Ù…Ø§Øª &amp; Ø¹Ø¨Ø§Ø±Ø§Øª',0),(494175,13728,'pr','Ú©Ù„Ù…Ø§Øª &amp; Ø¹Ø¨Ø§Ø±Ø§Øª',0),(494176,13728,'tr','Kelimeler & ifadeler',0),(494177,13728,'pl','SÅ‚owa & wyraÅ¼enia',0),(494178,13728,'bg','Ð”ÑƒÐ¼Ð¸ & Ñ„Ñ€Ð°Ð·Ð¸',0),(494179,13728,'ur','Ø§Ù„ÙØ§Ø¸ & Ø¬Ù…Ù„Û’',0),(494180,13728,'sr','Ð ÐµÑ‡Ð¸ Ð¸ Ñ„Ñ€Ð°Ð·Ðµ',0),(494181,13728,'vi','Tá»« &amp; cá»¥m tá»«',0),(494182,13728,'af','Woorde en frases',0),(494183,13728,'ro','Cuvinte & fraze',0),(494184,13728,'et','SÃµnad & laused',0),(494185,13728,'si','Besede & stavki',0),(494186,13728,'ba','Kata-kata & frase',0),(494187,13728,'nl','Woorden & zinnen',0),(494188,13728,'fi','Sanoja & lauseita',0),(494189,13728,'no','Ord & uttrykk',0),(494190,13728,'da','Ord & sÃ¦tninger',0),(494191,13728,'ko','ë‹¨ì–´ & ë¬¸êµ¬',0),(494192,13728,'he','×ž×™×œ×™× ×‘×™×˜×•×™×™× &',0),(494193,13728,'el','Î›Î­Î¾ÎµÎ¹Ï‚ & Ï†ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(494194,13728,'zh','&amp; è¯è¯­',0),(494195,13728,'sv','Ord & fraser',0),(494196,13728,'it','Parole frasi &',0),(494197,13728,'tl','',0),(494198,13728,'th','à¸„à¸³à¸§à¸¥à¸µ &',0),(494199,13728,'hi','à¤¶à¤¬à¥à¤¦ & à¤µà¤¾à¤•à¥à¤¯à¤¾à¤‚à¤¶',0),(494200,13728,'ms','Kata-kata & frasa',0),(494201,13728,'ar','Ø¹Ø¨Ø§Ø±Ø§Øª Ø¢Ù†Ø¯ Ø§Ù„ÙƒÙ„Ù…Ø§Øª',0),(494202,13728,'fr','Mots des expressions &',0),(494203,13728,'jp','& èªžå¥',0),(494204,13728,'pt','Frases de palavras &',0),(494205,13728,'ru','Ð¡Ð»Ð¾Ð²Ð° & Ñ„Ñ€Ð°Ð·Ñ‹',0),(494206,13728,'es','Palabras & Fraser',0),(494207,13728,'de','WÃ¶rter & Phrasen',0),(494208,13728,'en','Words & Phrases',0),(494209,13729,'is','',0),(494210,13729,'dr','ØªØµØ­ÛŒØ­ ØªØ§Ø±ÛŒØ® Ù…Ø¬Ù„Ù‡',0),(494211,13729,'pr','ØªØµØ­ÛŒØ­ ØªØ§Ø±ÛŒØ® Ù…Ø¬Ù„Ù‡',0),(494212,13729,'tr','GÃ¼nlÃ¼k tarihleri dÃ¼zeltmek',0),(494213,13729,'pl','Dziennik prawidÅ‚owe daty',0),(494214,13729,'bg','ÐšÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð½ÐµÐ²Ð½Ð¸Ðº Ð´Ð°Ñ‚Ð¸',0),(494215,13729,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û ØªØ§Ø±ÛŒØ®ÛŒÚº ØµØ­ÛŒØ­',0),(494216,13729,'sr','Ð˜ÑÐ¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(494217,13729,'vi','Táº¡p chÃ­ chÃ­nh xÃ¡c ngÃ y',0),(494218,13729,'af','Korrekte tydskrif datums',0),(494219,13729,'ro','CorectaÈ›i datele de jurnal',0),(494220,13729,'et','Ã•ige tÃ¶Ã¶lehe kuupÃ¤evad',0),(494221,13729,'si','Popravite datume Journal',0),(494222,13729,'ba','Jurnal benar tanggal',0),(494223,13729,'nl','Juiste Journal datums',0),(494224,13729,'fi','Oikea kirjauskansion pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(494225,13729,'no','Riktig Journal datoer',0),(494226,13729,'da','Korrekte Journal datoer',0),(494227,13729,'ko','ì €ë„ ë‚ ì§œ ìˆ˜ì •',0),(494228,13729,'he','×›×ª×‘ ×”×¢×ª ×”× ×›×•× ×” ×ª××¨×™×›×™×',0),(494229,13729,'el','Î•Ï†Î·Î¼ÎµÏÎ¯Î´Î± ÏƒÏ‰ÏƒÏ„Î­Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(494230,13729,'zh','æ­£ç¡®æ—¥å¿—æ—¥æœŸ',0),(494231,13729,'sv','RÃ¤tt tidning datum',0),(494232,13729,'it','Correggere i dati del giornale',0),(494233,13729,'tl','',0),(494234,13729,'th','à¹à¸à¹‰à¹„à¸‚à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡',0),(494235,13729,'hi','à¤¸à¤¹à¥€ à¤œà¤°à¥à¤¨à¤² à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤',0),(494236,13729,'ms','Jurnal betul tarikh',0),(494237,13729,'ar','ØªØµØ­ÙŠØ­ Ø§Ù„ØªÙˆØ§Ø±ÙŠØ® Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(494238,13729,'fr','Registre exact Dates',0),(494239,13729,'jp','æ­£ã—ã„å±¥æ­´æ—¥ä»˜',0),(494240,13729,'pt','Corrigir as datas do diÃ¡rio',0),(494241,13729,'ru','ÐŸÑ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ñ‹Ð¹ Ð¶ÑƒÑ€Ð½Ð°Ð» Ð´Ð°Ñ‚Ñ‹',0),(494242,13729,'es','Corregir Fechas de Diario',0),(494243,13729,'de','Richtige Journal-Termine',0),(494244,13729,'en','Correct Journal Dates',0),(494245,13730,'is','',0),(494246,13730,'dr','Ú©ÙˆÙ¾Ù† Ù‡Ø§ÛŒ ØªØ®ÙÛŒÙ',0),(494247,13730,'pr','Ú©ÙˆÙ¾Ù† Ù‡Ø§ÛŒ ØªØ®ÙÛŒÙ',0),(494248,13730,'tr','Ä°ndirim kuponlarÄ±',0),(494249,13730,'pl','Kupony rabatowe',0),(494250,13730,'bg','ÐšÑƒÐ¿Ð¾Ð½Ð¸ Ð·Ð° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(494251,13730,'ur','ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹ Ú©ÙˆÙ¾Ù†',0),(494252,13730,'sr','ÐšÑƒÐ¿Ð¾Ð½Ð¸ Ð·Ð° Ð¿Ð¾Ð¿ÑƒÑÑ‚',0),(494253,13730,'vi','Phiáº¿u giáº£m giÃ¡',0),(494254,13730,'af','Afslag Coupons',0),(494255,13730,'ro','Cupon de reducere',0),(494256,13730,'et','Allahindluse kupongid',0),(494257,13730,'si','Kuponi za popust',0),(494258,13730,'ba','Kupon diskon',0),(494259,13730,'nl','Kortingsbonnen',0),(494260,13730,'fi','Alennuskupongit',0),(494261,13730,'no','Tilbudskode',0),(494262,13730,'da','Rabat kuponer',0),(494263,13730,'ko','í• ì¸ ì¿ í°',0),(494264,13730,'he','×§×•×¤×•× ×™ ×”× ×—×”',0),(494265,13730,'el','Î•ÎºÏ€Ï„Ï‰Ï„Î¹ÎºÎ¬ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î±',0),(494266,13730,'zh','æŠ˜æ‰£ä¼˜æƒ åˆ¸',0),(494267,13730,'sv','Rabattkuponger',0),(494268,13730,'it','Buoni sconto',0),(494269,13730,'tl','',0),(494270,13730,'th','à¸¥à¸”à¸£à¸²à¸„à¸²à¸„à¸¹à¸›à¸­à¸‡',0),(494271,13730,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤•à¥‚à¤ªà¤¨',0),(494272,13730,'ms','Kupon diskaun',0),(494273,13730,'ar','ÙƒÙˆØ¨ÙˆÙ†Ø§Øª Ø§Ù„Ø®ØµÙ…',0),(494274,13730,'fr','Coupons-rabais',0),(494275,13730,'jp','å‰²å¼•ã‚¯ãƒ¼ãƒãƒ³',0),(494276,13730,'pt','Cupons de desconto',0),(494277,13730,'ru','ÐšÑƒÐ¿Ð¾Ð½Ñ‹ Ð½Ð° ÑÐºÐ¸Ð´ÐºÑƒ',0),(494278,13730,'es','Cupones de Descuento',0),(494279,13730,'de','Rabatt-Coupons',0),(494280,13730,'en','Discount Coupons',0),(494281,13731,'is','',0),(494282,13731,'dr','Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(494283,13731,'pr','Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(494284,13731,'tr','GÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klatÄ±n',0),(494285,13731,'pl','Kliknij, aby pokazaÄ‡',0),(494286,13731,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð·Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ',0),(494287,13731,'ur','Ø¯Ú©Ú¾Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(494288,13731,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸',0),(494289,13731,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ hiá»ƒn thá»‹',0),(494290,13731,'af','Klik om te wys',0),(494291,13731,'ro','Clic pentru afiÅŸare',0),(494292,13731,'et','Kuvamiseks klÃµpsake',0),(494293,13731,'si','Kliknite za prikaz',0),(494294,13731,'ba','Klik untuk menampilkan',0),(494295,13731,'nl','Klik om te tonen',0),(494296,13731,'fi','NÃ¤ytÃ¤ napsauttamalla',0),(494297,13731,'no','Klikk for Ã¥ vise',0),(494298,13731,'da','Klik for at vise',0),(494299,13731,'ko','í‘œì‹œë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(494300,13731,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’',0),(494301,13731,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Î´ÎµÎ¯Î¾ÎµÎ¹',0),(494302,13731,'zh','å•å‡»æ­¤å¤„å¯æ˜¾ç¤º',0),(494303,13731,'sv','Klicka fÃ¶r att Visa',0),(494304,13731,'it','Clicca per visualizzare',0),(494305,13731,'tl','',0),(494306,13731,'th','à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­à¹à¸ªà¸”à¸‡',0),(494307,13731,'hi','à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(494308,13731,'ms','Klik untuk Papar',0),(494309,13731,'ar','Ø§Ù†Ù‚Ø± Ù„Ø¥Ø¸Ù‡Ø§Ø±',0),(494310,13731,'fr','Cliquez pour afficher',0),(494311,13731,'jp','ã‚¯ãƒªãƒƒã‚¯ã™ã‚‹ã¨è¡¨ç¤º',0),(494312,13731,'pt','Clique para Visualizar',0),(494313,13731,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ',0),(494314,13731,'es','Hace Clik Para Mostrar',0),(494315,13731,'de','Hier klicken, um zu zeigen',0),(494316,13731,'en','Click to show',0),(494317,13732,'is','',0),(494318,13732,'dr','Ú©Ø§Ù†Ø§Ø¯Ø§ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±ÛŒØ²ÛŒ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÛŒ',0),(494319,13732,'pr','Ú©Ø§Ù†Ø§Ø¯Ø§ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±ÛŒØ²ÛŒ Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÛŒ',0),(494320,13732,'tr','Kanada emeklilik planÄ±',0),(494321,13732,'pl','Canada Pension Plan',0),(494322,13732,'bg','ÐšÐ°Ð½Ð°Ð´Ð° Ð¿ÐµÐ½ÑÐ¸Ð¾Ð½ÐµÐ½ Ð¿Ð»Ð°Ð½',0),(494323,13732,'ur','Ú©ÛŒÙ†ÛŒÚˆØ§ Ù¾ÛŒÙ†Ø´Ù† Ù¾Ù„Ø§Ù†',0),(494324,13732,'sr','ÐšÐ°Ð½Ð°Ð´Ð° Ð¿ÐµÐ½Ð·Ð¸Ñ˜Ð¾Ð¼',0),(494325,13732,'vi','Canada Pension káº¿ hoáº¡ch',0),(494326,13732,'af','Kanada pensioen Plan',0),(494327,13732,'ro','Canada Pension Plan',0),(494328,13732,'et','Kanada pensioniplaan',0),(494329,13732,'si','Canada Pension Plan',0),(494330,13732,'ba','Kanada program pensiun',0),(494331,13732,'nl','Canada pensioenplan',0),(494332,13732,'fi','Kanadan Pension Plan',0),(494333,13732,'no','Canada Pension Plan',0),(494334,13732,'da','Canada Pension Plan',0),(494335,13732,'ko','ìºë‚˜ë‹¤ ì—°ê¸ˆ ê³„íš',0),(494336,13732,'he','×ª×•×›× ×™×ª ×¤× ×¡×™×” ×‘×§× ×“×”',0),(494337,13732,'el','ÎšÎ±Î½Î±Î´Î¬Ï‚ ÏƒÏ…Î½Ï„Î±Î¾Î¹Î¿Î´Î¿Ï„Î¹ÎºÏŒ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î±',0),(494338,13732,'zh','åŠ æ‹¿å¤§å…»æ¤é‡‘è®¡åˆ’',0),(494339,13732,'sv','Kanada pensionsplan',0),(494340,13732,'it','Canada Pension Plan',0),(494341,13732,'tl','',0),(494342,13732,'th','à¹à¸œà¸™à¹€à¸‡à¸´à¸™à¸šà¸³à¸™à¸²à¸à¸‚à¸­à¸‡à¸›à¸£à¸°à¹€à¸—à¸¨à¹à¸„à¸™à¸²à¸”à¸²',0),(494343,13732,'hi','à¤•à¤¨à¤¾à¤¡à¤¾ à¤ªà¥‡à¤‚à¤¶à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾',0),(494344,13732,'ms','Pelan pencen Kanada',0),(494345,13732,'ar','Ø®Ø·Ø© Ø§Ù„Ù…Ø¹Ø§Ø´Ø§Øª Ø§Ù„ØªÙ‚Ø§Ø¹Ø¯ÙŠØ© ÙÙŠ ÙƒÙ†Ø¯Ø§',0),(494346,13732,'fr','RÃ©gime de pensions du Canada',0),(494347,13732,'jp','ã‚«ãƒŠãƒ€ã®å¹´é‡‘',0),(494348,13732,'pt','Plano de pensÃ£o de CanadÃ¡',0),(494349,13732,'ru','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ¸Ð¹ Ð¿ÐµÐ½ÑÐ¸Ð¾Ð½Ð½Ñ‹Ð¹ Ð¿Ð»Ð°Ð½',0),(494350,13732,'es','Plan de pensiones de CanadÃ¡',0),(494351,13732,'de','Canada Pensionsplan',0),(494352,13732,'en','Canada Pension Plan',0),(494353,13733,'is','',0),(494354,13733,'dr','Ø¨ÛŒÙ…Ù‡ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ú©Ø§Ù†Ø§Ø¯Ø§',0),(494355,13733,'pr','Ø¨ÛŒÙ…Ù‡ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ú©Ø§Ù†Ø§Ø¯Ø§',0),(494356,13733,'tr','Kanada istihdam sigorta',0),(494357,13733,'pl','Kanadyjski zatrudnienia ubezpieczenia',0),(494358,13733,'bg','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ¸ Ð·Ð°ÐµÑ‚Ð¾ÑÑ‚ Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ðµ',0),(494359,13733,'ur','Ú©ÛŒÙ†ÛŒÚˆÛŒÙ† Ù…Ù„Ø§Ø²Ù…Øª Ú©Ø§ Ø¨ÛŒÙ…Û',0),(494360,13733,'sr','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ¸ Ð·Ð°Ð¿Ð¾ÑˆÑ™Ð°Ð²Ð°ÑšÐµ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐµ',0),(494361,13733,'vi','Báº£o hiá»ƒm viá»‡c lÃ m Canada',0),(494362,13733,'af','Kanadese indiensneming versekering',0),(494363,13733,'ro','Ocuparea forÅ£ei de muncÄƒ canadian de asigurare',0),(494364,13733,'et','Kanada tÃ¶Ã¶hÃµive kindlustus',0),(494365,13733,'si','Kanadski zaposlovanje zavarovanja',0),(494366,13733,'ba','Asuransi tenaga kerja Kanada',0),(494367,13733,'nl','Canadese werkgelegenheid verzekering',0),(494368,13733,'fi','Kanadan tyÃ¶llisyys vakuutus',0),(494369,13733,'no','Kanadiske sysselsetting forsikring',0),(494370,13733,'da','Canadiske beskÃ¦ftigelse forsikring',0),(494371,13733,'ko','ìºë‚˜ë‹¤ ê³ ìš© ë³´í—˜',0),(494372,13733,'he','×‘×™×˜×•×— ×ª×¢×¡×•×§×” ×§× ×“×™',0),(494373,13733,'el','ÎšÎ±Î½Î±Î´Î¹ÎºÎ® Î±Ï€Î±ÏƒÏ‡ÏŒÎ»Î·ÏƒÎ· Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·',0),(494374,13733,'zh','åŠ æ‹¿å¤§å°±ä¸šä¿é™©',0),(494375,13733,'sv','Kanadensiska sysselsÃ¤ttning fÃ¶rsÃ¤kring',0),(494376,13733,'it','Assicurazione di occupazione canadese',0),(494377,13733,'tl','',0),(494378,13733,'th','à¸›à¸£à¸°à¸à¸±à¸™à¸à¸²à¸£à¸ˆà¹‰à¸²à¸‡à¸‡à¸²à¸™à¸—à¸µà¹ˆà¹à¸„à¸™à¸²à¸”à¸²',0),(494379,13733,'hi','à¤•à¤¨à¤¾à¤¡à¤¾ à¤°à¥‹à¤œà¤—à¤¾à¤° à¤¬à¥€à¤®à¤¾',0),(494380,13733,'ms','Insurans pekerjaan Kanada',0),(494381,13733,'ar','Ø§Ù„ØªØ£Ù…ÙŠÙ† Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ù…Ø§Ù„Ø© Ø§Ù„ÙƒÙ†Ø¯ÙŠØ©',0),(494382,13733,'fr','Assurance-emploi canadien',0),(494383,13733,'jp','ã‚«ãƒŠãƒ€é›‡ç”¨ä¿é™º',0),(494384,13733,'pt','Seguro-desemprego canadense',0),(494385,13733,'ru','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ¸Ðµ Ð·Ð°Ð½ÑÑ‚Ð¾ÑÑ‚Ð¸ ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(494386,13733,'es','Seguro de empleo canadiense',0),(494387,13733,'de','Kanadische Arbeitslosenversicherung',0),(494388,13733,'en','Canadian Employment Insurance',0),(494389,13734,'is','',0),(494390,13734,'dr','Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494391,13734,'pr','Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494392,13734,'tr','EI',0),(494393,13734,'pl','EI',0),(494394,13734,'bg','EI',0),(494395,13734,'ur','EI',0),(494396,13734,'sr','Ð•Ð›',0),(494397,13734,'vi','EI',0),(494398,13734,'af','EI',0),(494399,13734,'ro','EI',0),(494400,13734,'et','EI',0),(494401,13734,'si','EI',0),(494402,13734,'ba','EI',0),(494403,13734,'nl','EI',0),(494404,13734,'fi','EI',0),(494405,13734,'no','EI',0),(494406,13734,'da','EI',0),(494407,13734,'ko','EI',0),(494408,13734,'he','EI',0),(494409,13734,'el','EI',0),(494410,13734,'zh','EI',0),(494411,13734,'sv','EI',0),(494412,13734,'it','EI',0),(494413,13734,'tl','',0),(494414,13734,'th','EI',0),(494415,13734,'hi','EI',0),(494416,13734,'ms','ITEM LUAR BIASA',0),(494417,13734,'ar','Ø§Ù„ØµÙ†Ø§Ø¹Ø§Øª Ø§Ù„Ø§Ø³ØªØ®Ø±Ø§Ø¬ÙŠØ©',0),(494418,13734,'fr','ASSURANCE-EMPLOI',0),(494419,13734,'jp','EI',0),(494420,13734,'pt','EI',0),(494421,13734,'ru','EI',0),(494422,13734,'es','IE',0),(494423,13734,'de','EI',0),(494424,13734,'en','EI',0),(494425,13735,'is','',0),(494426,13735,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494427,13735,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494428,13735,'tr','EI satÄ±cÄ±',0),(494429,13735,'pl','EI dostawcy',0),(494430,13735,'bg','EI Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(494431,13735,'ur','EI ÙØ±ÙˆØ´Ù†Ø¯Û',0),(494432,13735,'sr','Ð•Ð» Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(494433,13735,'vi','EI Vendor',0),(494434,13735,'af','EI handelaar',0),(494435,13735,'ro','Furnizor de EI',0),(494436,13735,'et','EI hankija',0),(494437,13735,'si','EI dobavitelja',0),(494438,13735,'ba','EI Vendor',0),(494439,13735,'nl','EI leverancier',0),(494440,13735,'fi','EI toimittaja',0),(494441,13735,'no','EI leverandÃ¸r',0),(494442,13735,'da','EI leverandÃ¸r',0),(494443,13735,'ko','ì´ ê³µê¸‰ ì—…ì²´',0),(494444,13735,'he','×”×¡×¤×§ EI',0),(494445,13735,'el','EI Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(494446,13735,'zh','EI ä¾›åº”å•†',0),(494447,13735,'sv','EI leverantÃ¶r',0),(494448,13735,'it','EI Vendor',0),(494449,13735,'tl','',0),(494450,13735,'th','EI à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(494451,13735,'hi','EI à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(494452,13735,'ms','Penjual item luar biasa',0),(494453,13735,'ar','Ø¨Ø§Ø¦Ø¹ Ø§Ù„ØµÙ†Ø§Ø¹Ø§Øª Ø§Ù„Ø§Ø³ØªØ®Ø±Ø§Ø¬ÙŠØ©',0),(494454,13735,'fr','Fournisseur de l\'assurance-emploi',0),(494455,13735,'jp','EI ãƒ™ãƒ³ãƒ€ãƒ¼',0),(494456,13735,'pt','EI fornecedor',0),(494457,13735,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº EI',0),(494458,13735,'es','EI proveedor',0),(494459,13735,'de','EI-Hersteller',0),(494460,13735,'en','EI Vendor',0),(494461,13736,'is','',0),(494462,13736,'dr','Ù‡ÙŠØ¬Ø§Ù†ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø±Ø§Ø¬Ø¹Ù‡',0),(494463,13736,'pr','Ù‡ÙŠØ¬Ø§Ù†ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø±Ø§Ø¬Ø¹Ù‡',0),(494464,13736,'tr','EI satÄ±cÄ± arama',0),(494465,13736,'pl','EI dostawcy wyszukiwania',0),(494466,13736,'bg','EI Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(494467,13736,'ur','EI ÙˆÛŒÙ†ÚˆØ± Ù¾Ø± Ù†Ø¸Ø± Ø¯ÙˆÚ‘Ø§Ø¦ÛŒÚº',0),(494468,13736,'sr','Ð•Ð» Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð½Ð°Ð»Ð°Ð¶ÐµÑšÐµ',0),(494469,13736,'vi','EI Vendor Lookup',0),(494470,13736,'af','EI handelaar opsoek',0),(494471,13736,'ro','EI furnizor de cÄƒutare',0),(494472,13736,'et','EI hankija otsing',0),(494473,13736,'si','EI dobavitelja za iskanje',0),(494474,13736,'ba','EI Vendor Lookup',0),(494475,13736,'nl','EI leverancier opzoeken',0),(494476,13736,'fi','EI toimittajan valinta',0),(494477,13736,'no','EI leverandÃ¸r oppslag',0),(494478,13736,'da','EI kreditor opslag',0),(494479,13736,'ko','ì´ ê³µê¸‰ ì—…ì²´ ì¡°íšŒ',0),(494480,13736,'he','×‘×“×™×§×ª ×¡×¤×§ EI',0),(494481,13736,'el','EI Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(494482,13736,'zh','EI ä¾›åº”å•†æŸ¥æ‰¾',0),(494483,13736,'sv','EI leverantÃ¶r Lookup',0),(494484,13736,'it','EI ricerca fornitore',0),(494485,13736,'tl','',0),(494486,13736,'th','à¸„à¹‰à¸™à¸«à¸²à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢ EI',0),(494487,13736,'hi','EI à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤²à¥à¤•à¤…à¤ª',0),(494488,13736,'ms','EI penjual Lookup',0),(494489,13736,'ar','Ø¨Ø­Ø« Ø¨Ø§Ø¦Ø¹ Ø§Ù„ØµÙ†Ø§Ø¹Ø§Øª Ø§Ù„Ø§Ø³ØªØ®Ø±Ø§Ø¬ÙŠØ©',0),(494490,13736,'fr','L\'IE vendeur Lookup',0),(494491,13736,'jp','EI ã®ä»•å…¥å…ˆã®ãƒ«ãƒƒã‚¯ã‚¢ãƒƒãƒ—',0),(494492,13736,'pt','EI pesquisa de fornecedor',0),(494493,13736,'ru','EI Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¿Ð¾Ð¸ÑÐºÐ°',0),(494494,13736,'es','BÃºsqueda de proveedores de IE',0),(494495,13736,'de','EI-Anbieter-Suche',0),(494496,13736,'en','EI Vendor Lookup',0),(494497,13737,'is','',0),(494498,13737,'dr','Ø§Ø³ØªØ§Ù†ÛŒ',0),(494499,13737,'pr','Ø§Ø³ØªØ§Ù†ÛŒ',0),(494500,13737,'tr','Ä°l',0),(494501,13737,'pl','WojewÃ³dzkiego',0),(494502,13737,'bg','ÐŸÑ€Ð¾Ð²Ð¸Ð½Ñ†Ð¸Ñ',0),(494503,13737,'ur','ØµÙˆØ¨Ø§Ø¦ÛŒ',0),(494504,13737,'sr','ÐŸÐ¾ÐºÑ€Ð°Ñ˜Ð¸Ð½ÑÐºÐ¸',0),(494505,13737,'vi','Tá»‰nh',0),(494506,13737,'af','Provinsiale',0),(494507,13737,'ro','Provinciale',0),(494508,13737,'et','Provincial',0),(494509,13737,'si','Pokrajinski',0),(494510,13737,'ba','Provinsi',0),(494511,13737,'nl','Provinciaal',0),(494512,13737,'fi','Maakunnan',0),(494513,13737,'no','Provinsielle',0),(494514,13737,'da','Provincial',0),(494515,13737,'ko','ì„±',0),(494516,13737,'he','×ž×—×•×–×™',0),(494517,13737,'el','Î•Ï€Î±ÏÏ‡Î¹Î±ÎºÏŒ',0),(494518,13737,'zh','çœçº§',0),(494519,13737,'sv','Provincial',0),(494520,13737,'it','Provinciale',0),(494521,13737,'tl','',0),(494522,13737,'th','à¸ˆà¸±à¸‡à¸«à¸§à¸±à¸”',0),(494523,13737,'hi','à¤ªà¥à¤°à¤¾à¤‚à¤¤à¥€à¤¯',0),(494524,13737,'ms','Wilayah',0),(494525,13737,'ar','Ø§Ù„Ù…Ù‚Ø§Ø·Ø¹Ø©',0),(494526,13737,'fr','Provincial',0),(494527,13737,'jp','åœ°æ–¹',0),(494528,13737,'pt','Provincial',0),(494529,13737,'ru','ÐŸÑ€Ð¾Ð²Ð¸Ð½Ñ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹',0),(494530,13737,'es','Provincial',0),(494531,13737,'de','Provinzial',0),(494532,13737,'en','Provincial',0),(494533,13738,'is','',0),(494534,13738,'dr','Ù…Ø§Ù„ÛŒØ§Øª Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494535,13738,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494536,13738,'tr','EI vergi',0),(494537,13738,'pl','EI podatku',0),(494538,13738,'bg','EI Ð´Ð°Ð½ÑŠÐº',0),(494539,13738,'ur','EI Ù¹ÛŒÚ©Ø³',0),(494540,13738,'sr','Ð•Ð» Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(494541,13738,'vi','EI thuáº¿',0),(494542,13738,'af','EI belasting',0),(494543,13738,'ro','EI taxa',0),(494544,13738,'et','EI maks',0),(494545,13738,'si','EI davka',0),(494546,13738,'ba','EI pajak',0),(494547,13738,'nl','EI belasting',0),(494548,13738,'fi','EI veroa',0),(494549,13738,'no','EI skatt',0),(494550,13738,'da','EI skat',0),(494551,13738,'ko','ì´ ì„¸ê¸ˆ',0),(494552,13738,'he','EI ×ž×¡',0),(494553,13738,'el','EI Ï†ÏŒÏÎ¿Ï…',0),(494554,13738,'zh','EI ç¨Ž',0),(494555,13738,'sv','EI skatt',0),(494556,13738,'it','EI fiscale',0),(494557,13738,'tl','',0),(494558,13738,'th','à¸ à¸²à¸©à¸µ EI',0),(494559,13738,'hi','EI à¤Ÿà¥ˆà¤•à¥à¤¸',0),(494560,13738,'ms','Item luar biasa cukai',0),(494561,13738,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„ØµÙ†Ø§Ø¹Ø§Øª Ø§Ù„Ø§Ø³ØªØ®Ø±Ø§Ø¬ÙŠØ©',0),(494562,13738,'fr','Taxe sur l\'assurance-emploi',0),(494563,13738,'jp','EI ç¨Ž',0),(494564,13738,'pt','EI imposto',0),(494565,13738,'ru','EI Ð½Ð°Ð»Ð¾Ð³',0),(494566,13738,'es','EI impuesto',0),(494567,13738,'de','EI-Steuer',0),(494568,13738,'en','EI Tax',0),(494569,13739,'is','',0),(494570,13739,'dr','Ù…Ø§Ù„ÛŒØ§Øª ÙØ¯Ø±Ø§Ù„ Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494571,13739,'pr','Ù…Ø§Ù„ÛŒØ§Øª ÙØ¯Ø±Ø§Ù„ Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494572,13739,'tr','Federal EI vergi',0),(494573,13739,'pl','EI federalnego podatku',0),(494574,13739,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð° EI Ð´Ð°Ð½ÑŠÐº',0),(494575,13739,'ur','EI ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³',0),(494576,13739,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð•Ð» Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(494577,13739,'vi','Thuáº¿ liÃªn bang EI',0),(494578,13739,'af','Federale EI belasting',0),(494579,13739,'ro','Impozitului federal EI',0),(494580,13739,'et','FÃ¶deraalne EI maks',0),(494581,13739,'si','EI zvezne davÄne',0),(494582,13739,'ba','Pajak Federal EI',0),(494583,13739,'nl','Federale EI belasting',0),(494584,13739,'fi','Liittovaltion EI veroa',0),(494585,13739,'no','FÃ¸derale EI skatt',0),(494586,13739,'da','FÃ¸derale EI skat',0),(494587,13739,'ko','ì—°ë°©ì´ ì„¸ê¸ˆ',0),(494588,13739,'he','×ž×¡ ×¤×“×¨×œ×™ EI',0),(494589,13739,'el','EI Î¿Î¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï…',0),(494590,13739,'zh','è”é‚¦ EI ç¨Ž',0),(494591,13739,'sv','Federala EI skatt',0),(494592,13739,'it','Fiscale federale EI',0),(494593,13739,'tl','',0),(494594,13739,'th','à¸ à¸²à¸©à¸µà¸£à¸±à¸à¸šà¸²à¸¥à¸à¸¥à¸²à¸‡ EI',0),(494595,13739,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤ˆà¤†à¤‡ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(494596,13739,'ms','Cukai Persekutuan EI',0),(494597,13739,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© ÙÙŠ Ø§Ù„ØµÙ†Ø§Ø¹Ø§Øª Ø§Ù„Ø§Ø³ØªØ®Ø±Ø§Ø¬ÙŠØ©',0),(494598,13739,'fr','ImpÃ´t fÃ©dÃ©ral AE',0),(494599,13739,'jp','é€£é‚¦ EI ç¨Ž',0),(494600,13739,'pt','Imposto federal EI',0),(494601,13739,'ru','EI Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(494602,13739,'es','Fiscales federales Ie',0),(494603,13739,'de','Bundesrepublik EI Tax',0),(494604,13739,'en','Federal EI Tax',0),(494605,13740,'is','',0),(494606,13740,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ø§Ø³ØªØ§Ù† Ø¨Ø±Ø§ÛŒ Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(494607,13740,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¬Ø¯Ø§ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ø§Ø³ØªØ§Ù† Ø¨Ø±Ø§ÛŒ Ø³Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(494608,13740,'tr','SeÃ§ilen yÄ±l iÃ§in il vergi tablolarÄ± gÃ¼ncelleÅŸtirmek',0),(494609,13740,'pl','Aktualizowanie tabel podatku prowincji roku wybrany',0),(494610,13740,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²Ð¸Ð½Ñ†Ð¸Ñ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð¸ Ð·Ð° Ð´Ð°Ð½ÑŠÐº Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½',0),(494611,13740,'ur','Ø³Ø§Ù„ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ ØµÙˆØ¨Û Ù¹ÛŒÚ©Ø³ Ø¬Ø¯ÙˆÙ„ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(494612,13740,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾ÐºÑ€Ð°Ñ˜Ð¸Ð½Ð° Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° ÑÑ‚Ð¾Ð»Ð¾Ð²Ð¸Ð¼Ð° Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(494613,13740,'vi','Cáº­p Nháº­t báº£ng thuáº¿ tá»‰nh nÄƒm lá»±a chá»n',0),(494614,13740,'af','Bywerking Provinsie belastingtabelle vir jaar gekies',0),(494615,13740,'ro','Update provincia fiscale tabele pentru anul selectate',0),(494616,13740,'et','Uuendada provintsis tulumaksu tabelid aastaks valitud',0),(494617,13740,'si','Posodobitev tabel Province davka za leto izbrali',0),(494618,13740,'ba','Provinsi update tabel pajak untuk tahun yang dipilih',0),(494619,13740,'nl','Update provincie belasting tabellen voor jaar geselecteerd',0),(494620,13740,'fi','PÃ¤ivitys maakunnassa verotaulut valitun vuoden',0),(494621,13740,'no','Oppdatere provinsen skattetabeller Ã¥r valgt',0),(494622,13740,'da','Opdatere provinsen momstabeller For Ã¥r valgt',0),(494623,13740,'ko','ì„ íƒ ë…„ ì§€ë°© ì„¸ê¸ˆ í…Œì´ë¸” ì—…ë°ì´íŠ¸',0),(494624,13740,'he','×ž×—×•×– ×¢×“×›×•×Ÿ ×˜×‘×œ××•×ª ×ž×¡ ×œ×©× ×” ×©× ×‘×—×¨×•',0),(494625,13740,'el','Î Î¯Î½Î±ÎºÎµÏ‚ Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î±ÏÏ‡Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î¾Î±Ï„Îµ',0),(494626,13740,'zh','ä»Šå¹´é€‰å®šçš„æ›´æ–°çœç¨Žè¡¨',0),(494627,13740,'sv','Uppdatera provinsen skatt tabeller fÃ¶r Ã¥r valt',0),(494628,13740,'it','Aggiornare le tabelle fiscali di provincia per l\'anno selezionato',0),(494629,13740,'tl','',0),(494630,13740,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸•à¸²à¸£à¸²à¸‡à¸ à¸²à¸©à¸µà¸ˆà¸±à¸‡à¸«à¸§à¸±à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸µà¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(494631,13740,'hi','à¤ªà¥à¤°à¤¾à¤‚à¤¤ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¤à¤¾à¤²à¤¿à¤•à¤¾à¤à¤ à¤•à¤¾ à¤šà¤¯à¤¨ à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(494632,13740,'ms','Wilayah Kemaskini Jadual cukai bagi tahun yang dipilih',0),(494633,13740,'ar','ØªØ­Ø¯ÙŠØ« Ø¬Ø¯Ø§ÙˆÙ„ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ù‚Ø§Ø·Ø¹Ø© Ù„Ø³Ù†ÙˆØ§Øª Ù…Ø®ØªØ§Ø±Ø©',0),(494634,13740,'fr','Mettre Ã  jour les Tables d\'impÃ´t de la Province pour l\'annÃ©e sÃ©lectionnÃ©e',0),(494635,13740,'jp','é¸æŠžã—ãŸå¹´ã®ãŸã‚ã®å·žç¨Žãƒ†ãƒ¼ãƒ–ãƒ«ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(494636,13740,'pt','Atualizar tabelas de imposto de provÃ­ncia para o ano selecionado',0),(494637,13740,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ† Ð¿Ñ€Ð¾Ð²Ð¸Ð½Ñ†Ð¸Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð³Ð¾Ð´ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(494638,13740,'es','Provincia de actualizaciÃ³n tributaria tablas por aÃ±o seleccionado',0),(494639,13740,'de','Update-Provinz-Steuertabellen fÃ¼r Jahr ausgewÃ¤hlt',0),(494640,13740,'en','Update Province Tax Tables For Year Selected',0),(494641,13741,'is','',0),(494642,13741,'dr','Ù…Ø§Ù„ÛŒØ§Øª Ø´Ø±Ú©Øª Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494643,13741,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ø´Ø±Ú©Øª Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494644,13741,'tr','Co EI vergi',0),(494645,13741,'pl','Co EI podatku',0),(494646,13741,'bg','Co EI Ð´Ð°Ð½ÑŠÐº',0),(494647,13741,'ur','Co EI Ù¹ÛŒÚ©Ø³',0),(494648,13741,'sr','Ð•Ð» Ñ†Ð¾ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(494649,13741,'vi','Co EI thuáº¿',0),(494650,13741,'af','Co EI belasting',0),(494651,13741,'ro','Co EI fiscale',0),(494652,13741,'et','Co EI maks',0),(494653,13741,'si','Co EI davka',0),(494654,13741,'ba','Co EI pajak',0),(494655,13741,'nl','Co EI belasting',0),(494656,13741,'fi','Co EI veroa',0),(494657,13741,'no','Co EI skatt',0),(494658,13741,'da','Co EI skat',0),(494659,13741,'ko','ê³µë™ì´ ì„¸ê¸ˆ',0),(494660,13741,'he','Co EI ×ž×¡',0),(494661,13741,'el','Co EI Ï†ÏŒÏÎ¿Ï…',0),(494662,13741,'zh','Co EI ç¨Ž',0),(494663,13741,'sv','Co EI skatt',0),(494664,13741,'it','Co EI fiscale',0),(494665,13741,'tl','',0),(494666,13741,'th','à¸ à¸²à¸©à¸µ Co EI',0),(494667,13741,'hi','à¤¸à¤¹ à¤ˆà¤†à¤‡ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(494668,13741,'ms','Co EI cukai',0),(494669,13741,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø´Ø±ÙƒØ© Ø§Ù„ØµÙ†Ø§Ø¹Ø§Øª Ø§Ù„Ø§Ø³ØªØ®Ø±Ø§Ø¬ÙŠØ©',0),(494670,13741,'fr','Taxe co EI',0),(494671,13741,'jp','Co EI ç¨Ž',0),(494672,13741,'pt','EI co imposto',0),(494673,13741,'ru','Co EI Ð½Ð°Ð»Ð¾Ð³',0),(494674,13741,'es','La IE co impuestos',0),(494675,13741,'de','Co EI Tax',0),(494676,13741,'en','Co EI Tax',0),(494677,13742,'is','',0),(494678,13742,'dr','Ø®ÙˆØ¯Ø¯Ø§Ø±ÛŒ CPP',0),(494679,13742,'pr','Ø®ÙˆØ¯Ø¯Ø§Ø±ÛŒ CPP',0),(494680,13742,'tr','CPP stopaj',0),(494681,13742,'pl','Wstrzymanie CPP',0),(494682,13742,'bg','CPP Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(494683,13742,'ur','Ú©Ù¾ Ø±ÙˆÚ©Ù†Ø§',0),(494684,13742,'sr','Ð¦ÐŸÐŸ Ð¿Ñ€Ð¸ÐºÑ€Ð¸Ð²Ð°ÑšÐµ.',0),(494685,13742,'vi','CPP giá»¯ láº¡i',0),(494686,13742,'af','Dr weerhouding',0),(494687,13742,'ro','CPP reÅ£inerea',0),(494688,13742,'et','CPP kinnipeetava',0),(494689,13742,'si','CPP odtegljaj',0),(494690,13742,'ba','CPP pemotongan',0),(494691,13742,'nl','CPP achterhouden',0),(494692,13742,'fi','CPP ennakonpidÃ¤tys',0),(494693,13742,'no','CPP forskuddstrekk',0),(494694,13742,'da','CPP tilbageholdelse',0),(494695,13742,'ko','CPP ì›ì²œ ì§•ìˆ˜',0),(494696,13742,'he','×”×œ× ×ª CPP',0),(494697,13742,'el','Î Î±ÏÎ±ÎºÏÎ¬Ï„Î·ÏƒÎ· CPP',0),(494698,13742,'zh','CPP æ‰£ç¼´',0),(494699,13742,'sv','CPP kÃ¤llskatt',0),(494700,13742,'it','CPP alla fonte',0),(494701,13742,'tl','',0),(494702,13742,'th','CPP à¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(494703,13742,'hi','à¤¸à¥€à¤ªà¥€à¤ªà¥€ à¤°à¥‹à¤•',0),(494704,13742,'ms','CPP penangguhan',0),(494705,13742,'ar','Ø­Ø¬Ø¨ Ø­Ø²Ø¨ Ø§Ù„Ø´Ø¹Ø¨ Ø§Ù„ÙƒÙ…Ø¨ÙˆØ¯ÙŠ',0),(494706,13742,'fr','Retenue du RPC',0),(494707,13742,'jp','CPP ã®æºæ³‰å¾´åŽ',0),(494708,13742,'pt','RetenÃ§Ã£o na fonte do CPP',0),(494709,13742,'ru','Ð£Ð´ÐµÑ€Ð¶Ð°Ð½Ð¸Ðµ CPP',0),(494710,13742,'es','RetenciÃ³n de CPP',0),(494711,13742,'de','CPP zurÃ¼ckhalten',0),(494712,13742,'en','CPP Withholding',0),(494713,13743,'is','',0),(494714,13743,'dr','Ø¹Ù„Øª Ù…Ù‚Ø¯Ø§Ø±',0),(494715,13743,'pr','Ø¹Ù„Øª Ù…Ù‚Ø¯Ø§Ø±',0),(494716,13743,'tr','BorÃ§lu tutarÄ±',0),(494717,13743,'pl','Kwot naleÅ¼nych',0),(494718,13743,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð¼Ð° ÑÑƒÐ¼Ð°',0),(494719,13743,'ur','Ø±Ù‚Ù… ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§',0),(494720,13743,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð´ÑƒÐ³Ð¾Ð²Ð°Ñ‚Ð¸.',0),(494721,13743,'vi','Sá»‘ tiá»n do',0),(494722,13743,'af','Bedrag verskuldig',0),(494723,13743,'ro','Suma datoritÄƒ',0),(494724,13743,'et','VÃµlgnetava summa',0),(494725,13743,'si','Zneska, dolgovanega',0),(494726,13743,'ba','Karena jumlah',0),(494727,13743,'nl','Bedrag ten gevolge van',0),(494728,13743,'fi','Tarkoitettujen saatavien',0),(494729,13743,'no','BelÃ¸pet pÃ¥ grunn',0),(494730,13743,'da','Skyldige belÃ¸b',0),(494731,13743,'ko','ê¸ˆì•¡',0),(494732,13743,'he','×¡×›×•× ×—×™×™×‘',0),(494733,13743,'el','Î Î¿ÏƒÎ¿Ï Î¿Ï†ÎµÎ¹Î»Î¿Î¼Î­Î½Î¿Ï…',0),(494734,13743,'zh','æ‰€æ¬ é‡‘é¢',0),(494735,13743,'sv','Belopp pÃ¥ grund av',0),(494736,13743,'it','Crediti dovuti',0),(494737,13743,'tl','',0),(494738,13743,'th','à¸¢à¸­à¸” Owing',0),(494739,13743,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤•à¤¾à¤°à¤£',0),(494740,13743,'ms','Amaun yang terhutang',0),(494741,13743,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø³ØªØ­Ù‚',0),(494742,13743,'fr','Montant dÃ»',0),(494743,13743,'jp','ãŠã‹ã’ã§é‡',0),(494744,13743,'pt','Montante devido',0),(494745,13743,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¸Ð·-Ð·Ð°',0),(494746,13743,'es','Importe debido',0),(494747,13743,'de','Geschuldeten Betrag',0),(494748,13743,'en','Amount Owing',0),(494749,13744,'is','',0),(494750,13744,'dr','Ù…Ø¨Ù„Øº Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ',0),(494751,13744,'pr','Ù…Ø¨Ù„Øº Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ',0),(494752,13744,'tr','Ã–denmiÅŸ miktar',0),(494753,13744,'pl','Kwota zapÅ‚acona za',0),(494754,13744,'bg','ÐŸÐ»Ð°Ñ‚ÐµÐ½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð·Ð°',0),(494755,13744,'ur','Ø±Ù‚Ù… Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(494756,13744,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(494757,13744,'vi','Sá»‘ tiá»n thanh toÃ¡n cho',0),(494758,13744,'af','Die bedrag betaal vir',0),(494759,13744,'ro','Suma plÄƒtitÄƒ pentru',0),(494760,13744,'et','Eest makstud summa',0),(494761,13744,'si','PlaÄanega zneska za',0),(494762,13744,'ba','Jumlah yang dibayar untuk',0),(494763,13744,'nl','Bedrag betaald voor',0),(494764,13744,'fi','Summasta',0),(494765,13744,'no','Betalt For',0),(494766,13744,'da','BelÃ¸b betalt For',0),(494767,13744,'ko','ê¸ˆì•¡ ì§€ë¶ˆ',0),(494768,13744,'he','×”×¡×›×•× ×©×©×•×œ× ×¢×‘×•×¨',0),(494769,13744,'el','Î Î¿ÏƒÏŒ Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹ Î³Î¹Î±',0),(494770,13744,'zh','æ”¯ä»˜é‡‘é¢',0),(494771,13744,'sv','Belopp som betalats fÃ¶r',0),(494772,13744,'it','Importo pagato per',0),(494773,13744,'tl','',0),(494774,13744,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸Šà¸³à¸£à¸°',0),(494775,13744,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤°à¤¾à¤¶à¤¿',0),(494776,13744,'ms','Jumlah yang dibayar',0),(494777,13744,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¯ÙÙˆØ¹',0),(494778,13744,'fr','Somme versÃ©e pour',0),(494779,13744,'jp','ã‚’æ”¯æ‰•é¡',0),(494780,13744,'pt','Valor pago pelo',0),(494781,13744,'ru','Ð¡ÑƒÐ¼Ð¼Ð°, ÑƒÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ð°Ñ Ð·Ð°',0),(494782,13744,'es','Importe pagado por',0),(494783,13744,'de','Kaufpreis',0),(494784,13744,'en','Amount Paid For',0),(494785,13745,'is','',0),(494786,13745,'dr','ØªÙˆØ§Ø²Ù† Ø¯Ø± Ø¢Ø®Ø±ÛŒÙ† Ø¨ÛŒØ§Ù†ÛŒÙ‡',0),(494787,13745,'pr','ØªÙˆØ§Ø²Ù† Ø¯Ø± Ø¢Ø®Ø±ÛŒÙ† Ø¨ÛŒØ§Ù†ÛŒÙ‡',0),(494788,13745,'tr','Son deyim bakiyelere',0),(494789,13745,'pl','Salda na ostatniej instrukcja',0),(494790,13745,'bg','Ð¡Ð°Ð»Ð´Ð° Ð¿Ð¾ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(494791,13745,'ur','Ø¢Ø®Ø±ÛŒ Ø¨ÛŒØ§Ù† Ù¾Ø±',0),(494792,13745,'sr','Ð¡Ð°Ð»Ð´Ð° Ð½Ð° Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÑƒ Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(494793,13745,'vi','Sá»‘ dÆ° trÃªn báº£ng sao kÃª cuá»‘i',0),(494794,13745,'af','Balanse Op Laaste Staat',0),(494795,13745,'ro','Soldurile ultima declaraÅ£ie',0),(494796,13745,'et','Viimase vÃ¤ljavÃµtte saldo',0),(494797,13745,'si','Saldo zadnjega izpiska',0),(494798,13745,'ba','Saldo pada pernyataan terakhir',0),(494799,13745,'nl','Saldi op de laatste instructie',0),(494800,13745,'fi','Viimeisen tiliotteen saldot',0),(494801,13745,'no','Saldoer for siste setningen',0),(494802,13745,'da','Saldi pÃ¥ sidste sÃ¦tning',0),(494803,13745,'ko','ë§ˆì§€ë§‰ ì§„ìˆ ì— ê· í˜•',0),(494804,13745,'he','×™×ª×¨×•×ª ×¢×œ ×”×ž×©×¤×˜ ×”××—×¨×•×Ÿ',0),(494805,13745,'el','Î¤Î± Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î± Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î´Î®Î»Ï‰ÏƒÎ·',0),(494806,13745,'zh','åœ¨æœ€åŽä¸€æ¡è¯­å¥ä¸Šçš„ä½™é¢',0),(494807,13745,'sv','Saldon pÃ¥ sista uttalande',0),(494808,13745,'it','Saldi su ultima istruzione',0),(494809,13745,'tl','',0),(494810,13745,'th','à¸”à¸¸à¸¥à¹ƒà¸™à¸‡à¸šà¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(494811,13745,'hi','à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤ªà¤¿à¤›à¤²à¥‡ à¤¬à¤¯à¤¾à¤¨ à¤ªà¤°',0),(494812,13745,'ms','Baki pada tarikh penyata',0),(494813,13745,'ar','Ø§Ù„Ø£Ø±ØµØ¯Ø© ÙÙŠ Ø§Ù„Ø¨ÙŠØ§Ù† Ø§Ù„Ø£Ø®ÙŠØ±',0),(494814,13745,'fr','Soldes sur la derniÃ¨re dÃ©claration',0),(494815,13745,'jp','æœ€å¾Œã®ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã®æ®‹é«˜',0),(494816,13745,'pt','Saldos na Ãºltima instruÃ§Ã£o',0),(494817,13745,'ru','ÐžÑÑ‚Ð°Ñ‚ÐºÐ¸ Ð½Ð° ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(494818,13745,'es','Saldos en la Ãºltima declaraciÃ³n',0),(494819,13745,'de','Salden aus dem letzten Anweisung',0),(494820,13745,'en','Balances On Last Statement',0),(494821,13746,'is','',0),(494822,13746,'dr','Ø³Ù‡Ù… CPP',0),(494823,13746,'pr','Ø³Ù‡Ù… CPP',0),(494824,13746,'tr','CPP katkÄ±larÄ±',0),(494825,13746,'pl','CPP skÅ‚adki',0),(494826,13746,'bg','CPP Ð²Ð½Ð¾ÑÐºÐ¸',0),(494827,13746,'ur','Ú©Ù¾ Ú©ÛŒ Ø§Ø¹Ø§Ù†Øª',0),(494828,13746,'sr','Ð¦ÐŸÐŸ Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾Ñ',0),(494829,13746,'vi','ÄÃ³ng gÃ³p CPP',0),(494830,13746,'af','Dr bydraes',0),(494831,13746,'ro','CPP contribuÅ£ii',0),(494832,13746,'et','CPP sissemaksed',0),(494833,13746,'si','CPP prispevkov',0),(494834,13746,'ba','CPP kontribusi',0),(494835,13746,'nl','CPP bijdragen',0),(494836,13746,'fi','CPP maksuja',0),(494837,13746,'no','CPP bidrag',0),(494838,13746,'da','CPP bidrag',0),(494839,13746,'ko','CPP ê¸°ì—¬',0),(494840,13746,'he','×ª×¨×•×ž×•×ª CPP',0),(494841,13746,'el','CPP ÏƒÏ…Î½ÎµÎ¹ÏƒÏ†Î¿ÏÎ­Ï‚',0),(494842,13746,'zh','CPP ä¾›æ¬¾',0),(494843,13746,'sv','CPP bidrag',0),(494844,13746,'it','Contributi di CPP',0),(494845,13746,'tl','',0),(494846,13746,'th','à¸œà¸¥à¸‡à¸²à¸™ CPP',0),(494847,13746,'hi','à¤¸à¥€à¤ªà¥€à¤ªà¥€ à¤¯à¥‹à¤—à¤¦à¤¾à¤¨',0),(494848,13746,'ms','CPP sumbangan',0),(494849,13746,'ar','Ù…Ø³Ø§Ù‡Ù…Ø§Øª Ø­Ø²Ø¨ Ø§Ù„Ø´Ø¹Ø¨ Ø§Ù„ÙƒÙ…Ø¨ÙˆØ¯ÙŠ',0),(494850,13746,'fr','Cotisations au RPC',0),(494851,13746,'jp','CPP ã®è²¢çŒ®',0),(494852,13746,'pt','ContribuiÃ§Ãµes do CPP',0),(494853,13746,'ru','CPP Ð²Ð·Ð½Ð¾ÑÐ¾Ð²',0),(494854,13746,'es','Contribuciones de CPP',0),(494855,13746,'de','CPP-BeitrÃ¤ge',0),(494856,13746,'en','CPP Contributions',0),(494857,13747,'is','',0),(494858,13747,'dr','ØªÙˆØ§Ø²Ù† Ú©Ù†ÙˆÙ†ÛŒ',0),(494859,13747,'pr','ØªÙˆØ§Ø²Ù† Ú©Ù†ÙˆÙ†ÛŒ',0),(494860,13747,'tr','GeÃ§erli bakiyeleri',0),(494861,13747,'pl','BieÅ¼Ä…cego salda',0),(494862,13747,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ ÑÐ°Ð»Ð´Ð°',0),(494863,13747,'ur','Ø­Ø§Ù„ÛŒÛ Ø¨ÛŒÙ„Ù†Ø³',0),(494864,13747,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(494865,13747,'vi','Sá»‘ dÆ° hiá»‡n táº¡i',0),(494866,13747,'af','Huidige Balanse',0),(494867,13747,'ro','Curent solduri',0),(494868,13747,'et','Saate praegused saldod',0),(494869,13747,'si','Trenutnega stanja',0),(494870,13747,'ba','Saldo saat ini',0),(494871,13747,'nl','Huidige saldi',0),(494872,13747,'fi','Nykyiset saldot',0),(494873,13747,'no','Gjeldende saldo',0),(494874,13747,'da','Aktuelle saldi',0),(494875,13747,'ko','í˜„ìž¬ ìž”ì•¡',0),(494876,13747,'he','×™×ª×¨×•×ª × ×•×›×—×™×•×ª',0),(494877,13747,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯ÎµÏ‚',0),(494878,13747,'zh','å½“å‰ä½™é¢',0),(494879,13747,'sv','Aktuella saldon',0),(494880,13747,'it','Attuali equilibri',0),(494881,13747,'tl','',0),(494882,13747,'th','à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(494883,13747,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿',0),(494884,13747,'ms','Baki semasa',0),(494885,13747,'ar','Ø§Ù„Ø£Ø±ØµØ¯Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(494886,13747,'fr','Soldes courants',0),(494887,13747,'jp','ç¾åœ¨ã®æ®‹é«˜',0),(494888,13747,'pt','Saldo atual',0),(494889,13747,'ru','Ð¢ÐµÐºÑƒÑ‰ÐµÐµ ÑÐ°Ð»ÑŒÐ´Ð¾',0),(494890,13747,'es','Saldos actuales',0),(494891,13747,'de','Aktuellen Salden',0),(494892,13747,'en','Current Balances',0),(494893,13748,'is','',0),(494894,13748,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ¹Ù„ÛŒ',0),(494895,13748,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ¹Ù„ÛŒ',0),(494896,13748,'tr','GeÃ§erli Ã¶deme',0),(494897,13748,'pl','BieÅ¼Ä…ce pÅ‚atnoÅ›ci',0),(494898,13748,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(494899,13748,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(494900,13748,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(494901,13748,'vi','Thanh toÃ¡n hiá»‡n táº¡i',0),(494902,13748,'af','Huidige Betaling',0),(494903,13748,'ro','Plata curent',0),(494904,13748,'et','Praeguse makse',0),(494905,13748,'si','TekoÄega plaÄila',0),(494906,13748,'ba','Pembayaran saat ini',0),(494907,13748,'nl','Huidige betaling',0),(494908,13748,'fi','NykyisessÃ¤ maksussa',0),(494909,13748,'no','Gjeldende betalingen',0),(494910,13748,'da','NuvÃ¦rende betaling',0),(494911,13748,'ko','í˜„ìž¬ ê²°ì œ',0),(494912,13748,'he','×”×ª×©×œ×•× ×”× ×•×›×—×™',0),(494913,13748,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(494914,13748,'zh','å½“å‰ä»˜æ¬¾',0),(494915,13748,'sv','Aktuella betalningen',0),(494916,13748,'it','Pagamento corrente',0),(494917,13748,'tl','',0),(494918,13748,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(494919,13748,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(494920,13748,'ms','Semasa pembayaran',0),(494921,13748,'ar','Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(494922,13748,'fr','Paiement actuel',0),(494923,13748,'jp','ç¾åœ¨ã®æ”¯æ‰•ã„',0),(494924,13748,'pt','Pagamento atual',0),(494925,13748,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(494926,13748,'es','Pago actual',0),(494927,13748,'de','Aktuelle Zahlung',0),(494928,13748,'en','Current Payment',0),(494929,13749,'is','',0),(494930,13749,'dr','Ø­Ù‚ Ø¨ÛŒÙ…Ù‡ Ù‡Ø§ÛŒ Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494931,13749,'pr','Ø­Ù‚ Ø¨ÛŒÙ…Ù‡ Ù‡Ø§ÛŒ Ù‡ÙŠØ¬Ø§Ù†ÛŒ',0),(494932,13749,'tr','EI primler',0),(494933,13749,'pl','EI skÅ‚adek',0),(494934,13749,'bg','EI Ð¿Ñ€ÐµÐ¼Ð¸Ð¸',0),(494935,13749,'ur','EI Ù¾Ø±ÛŒÙ…ÛŒÙ…',0),(494936,13749,'sr','Ð•Ð» Ð¿Ñ€ÐµÐ¼Ð¸Ñ˜Ðµ',0),(494937,13749,'vi','Tiá»n Ä‘Ã³ng báº£o hiá»ƒm EI',0),(494938,13749,'af','EI premies',0),(494939,13749,'ro','Primele EI',0),(494940,13749,'et','EI maksete',0),(494941,13749,'si','EI premije',0),(494942,13749,'ba','EI premi',0),(494943,13749,'nl','EI premies',0),(494944,13749,'fi','EI palkkioita',0),(494945,13749,'no','EI bonuser',0),(494946,13749,'da','EI prÃ¦mier',0),(494947,13749,'ko','EI ë³´í—˜ë£Œ',0),(494948,13749,'he','EI ×¤×¨×ž×™×•×ª',0),(494949,13749,'el','EI Î±ÏƒÏ†Î¬Î»Î¹ÏƒÏ„ÏÎ±',0),(494950,13749,'zh','EI ä¿è´¹',0),(494951,13749,'sv','EI Premier',0),(494952,13749,'it','EI premi',0),(494953,13749,'tl','',0),(494954,13749,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸žà¸´à¹€à¸¨à¸© EI',0),(494955,13749,'hi','à¤ˆà¤†à¤‡ à¤ªà¥à¤°à¥€à¤®à¤¿à¤¯à¤®',0),(494956,13749,'ms','Premium item luar biasa',0),(494957,13749,'ar','Ø£Ù‚Ø³Ø§Ø· Ø§Ù„ØµÙ†Ø§Ø¹Ø§Øª Ø§Ù„Ø§Ø³ØªØ®Ø±Ø§Ø¬ÙŠØ©',0),(494958,13749,'fr','Cotisations Ã  l\'AE',0),(494959,13749,'jp','EI ã®ä¿é™ºæ–™',0),(494960,13749,'pt','EI prÃ©mios',0),(494961,13749,'ru','EI Ð¿Ñ€ÐµÐ¼Ð¸Ð¸',0),(494962,13749,'es','Primas de IE',0),(494963,13749,'de','EI-PrÃ¤mien',0),(494964,13749,'en','EI Premiums',0),(494965,13750,'is','',0),(494966,13750,'dr','Ù¾Ø§ÛŒØ§Ù† Ø¯ÙˆØ±Ù‡ Remitting Ø¨Ø±Ø§ÛŒ Ú©Ù‡ Ú©Ø³Ø± Ú©Ø³Ø± Ú©Ø±Ø¯Ù‡ Ø¨ÙˆØ¯Ù†Ø¯',0),(494967,13750,'pr','Ù¾Ø§ÛŒØ§Ù† Ø¯ÙˆØ±Ù‡ Remitting Ø¨Ø±Ø§ÛŒ Ú©Ù‡ Ú©Ø³Ø± Ú©Ø³Ø± Ú©Ø±Ø¯Ù‡ Ø¨ÙˆØ¯Ù†Ø¯',0),(494968,13750,'tr','DÃ¶nemi iÃ§in hangi kesintiler havaleleri sonunda tevkif',0),(494969,13750,'pl','Koniec przelewÃ³w okres dla ktÃ³rego odliczeÅ„ zostaÅ‚y wstrzymane',0),(494970,13750,'bg','ÐšÑ€Ð°Ð¹ Ð½Ð° Ñ€ÐµÐ¼Ð¸Ñ‚ÐµÐ½Ñ‚Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð·Ð° ÐºÐ¾Ð¹Ñ‚Ð¾ ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸ ÑÐ° Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ð¸',0),(494971,13750,'ur','ØªÚ¾Û’ Ø¯ÙˆØ± Ø¬Ø³ Ú©ÛŒ ØªÙ„Ø§ÙÛŒ Ú©Û’ Ø±ÛŒÙ…ÛŒÙ¹Ø§Ù†Ú¯ Ú©Ø§ Ø®Ø§ØªÙ…Û Ú†Ø§ÛØªÛŒ ØªÚ¾ÛŒÚº',0),(494972,13750,'sr','ÐšÑ€Ð°Ñ˜ Ñ€ÐµÐ¼Ð¸Ñ‚Ð¸Ñ€Ð°Ñ˜ÑƒÑ›Ð¸ ÐŸÐµÑ€Ð¸Ð¾Ð´ Ð·Ð° ÐºÐ¾Ñ˜Ð¸ Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ Ð±Ð¸Ð»Ð¸ ÑÐºÑ€Ð¸Ð²Ð°Ð¾.',0),(494973,13750,'vi','Cuá»‘i thá»i gian chuyá»ƒn tiá»n cho cÃ¡c khoáº£n kháº¥u trá»« nÃ o Ä‘Ã£ Ä‘Æ°á»£c giáº¥u kÃ­n',0),(494974,13750,'af','Einde van die Remitting tydperk vir watter aftrekkings was weerhou',0),(494975,13750,'ro','SfÃ¢rÅŸitul remisivÄƒ perioada deduceri care au fost reÅ£inute',0),(494976,13750,'et','PangaÃ¼lekande perioodi milliseid mahaarvamisi lÃµpus olid kinni',0),(494977,13750,'si','Koncem nakazovanju obdobje za kateri odtegljaji so bili zadrÅ¾ani',0),(494978,13750,'ba','Akhir Remitting periode untuk pemotongan yang sedang ditahan',0),(494979,13750,'nl','Einde van de periode voor welke inhoudingen Remitting werden ingehouden',0),(494980,13750,'fi','Loppuun palautuksen aikana mitÃ¤ vÃ¤hennyksiÃ¤ pidÃ¤tettiin',0),(494981,13750,'no','Slutten av remittering periode For som fradrag ble holdt tilbake',0),(494982,13750,'da','Slutningen af remitterende periode For hvilke fradrag blev tilbageholdt',0),(494983,13750,'ko','ê³µì œ ê¸°ê°„ì„ ì†¡ê¸ˆì˜ ëì€ ì›ì²œ ì§•ìˆ˜',0),(494984,13750,'he','×¡×™×•× ×”×¢×‘×¨×ª ×ª×§×•×¤×” ×¢×‘×•×¨ ××™×œ×• × ×™×›×•×™×™× ×”×™×• ×©× ×•×›×” ×‘×ž×§×•×¨',0),(494985,13750,'el','Î¤Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î´Î¹Î±Î»ÎµÎ¯Ï€Î¿Ï…ÏƒÎ± Ï€ÎµÏÎ¯Î¿Î´Î¿ Î³Î¹Î± Ï„Î¹Ï‚ ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… ÎµÎ¯Ï‡Î±Î½ Ï€Î±ÏÎ±ÎºÏÎ±Ï„Î·Î¸ÎµÎ¯',0),(494986,13750,'zh','ç¼“è§£æœŸä¸ºå“ªäº›ç¨Žæ”¶å‡å…æ”¿ç­–å¹´åº•è¢«æ‰£ç•™',0),(494987,13750,'sv','Slutet av remittering Period fÃ¶r vilken avdrag var inne',0),(494988,13750,'it','Fine del periodo di rimessa per cui deduzioni sono stati trattenuti',0),(494989,13750,'tl','',0),(494990,13750,'th','à¸ˆà¸¸à¸”à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸‚à¸­à¸‡à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¸œà¹ˆà¸²à¸™à¸˜à¸™à¸²à¸„à¸²à¸£à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸«à¸±à¸à¸¥à¸”à¸—à¸µà¹ˆà¸–à¸¹à¸à¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(494991,13750,'hi','à¤¥à¥‡ à¤œà¥‹ à¤•à¥€ à¤•à¤Ÿà¥Œà¤¤à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤µà¤§à¤¿ Remitting à¤•à¥‡ à¤…à¤‚à¤¤ à¤ªà¤° à¤°à¥‹à¤• à¤²à¤—à¤¾à¤ˆ',0),(494992,13750,'ms','Penghujung tempoh pungutan bagi potongan yang telah ditahan',0),(494993,13750,'ar','Ù†Ù‡Ø§ÙŠØ© Ù„ØªØ­ÙˆÙŠÙ„ ÙØªØ±Ø© Ù„Ù„Ø®ØµÙˆÙ…Ø§Øª Ø§Ù„ØªÙŠ ÙƒØ§Ù†Øª ØªØ­Ø¬Ø¨',0),(494994,13750,'fr','Fin de pÃ©riode le versement pour les retenues ont Ã©tÃ© retenus',0),(494995,13750,'jp','ã©ã®æŽ§é™¤ã®ãŸã‚ã®æœŸé–“ã®é€é‡‘ã®çµ‚ã‚ã‚ŠãŒå·®ã—æŽ§ãˆã‚‰ã‚Œã¾ã—ãŸã€‚',0),(494996,13750,'pt','Fim do remitente perÃ­odo para o quais as deduÃ§Ãµes foram retidos',0),(494997,13750,'ru','ÐšÐ¾Ð½ÐµÑ† Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð´Ð»Ñ ÐºÐ¾Ñ‚Ð¾Ñ€Ð¾Ð³Ð¾ Ð²Ñ‹Ñ‡ÐµÑ‚Ñ‹ Ð±Ñ‹Ð»Ð¸ ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ñ‹',0),(494998,13750,'es','Final del remitente periodo para que las deducciones fueron retenidos',0),(494999,13750,'de','Ende der Periode fÃ¼r die AbzÃ¼ge remittierender zurÃ¼ckgehalten wurden',0),(495000,13750,'en','End Of Remitting Period For Which Deductions Were Withheld',0),(495001,13751,'is','',0),(495002,13751,'dr','ØªÙˆØ¶ÛŒØ­ Ø§Ø² ØªØºÛŒÛŒØ±Ø§Øª',0),(495003,13751,'pr','ØªÙˆØ¶ÛŒØ­ Ø§Ø² ØªØºÛŒÛŒØ±Ø§Øª',0),(495004,13751,'tr','DeÄŸiÅŸiklikleri aÃ§Ä±klamasÄ±',0),(495005,13751,'pl','WyjaÅ›nienie zmian',0),(495006,13751,'bg','ÐžÐ±ÑÑÐ½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ',0),(495007,13751,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(495008,13751,'sr','ÐžÐ±Ñ˜Ð°ÑˆÑšÐµÑšÐµ Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°Ð¼Ð°',0),(495009,13751,'vi','Giáº£i thÃ­ch vá» nhá»¯ng thay Ä‘á»•i',0),(495010,13751,'af','Verduideliking van veranderinge',0),(495011,13751,'ro','ExplicaÅ£ie a modificÄƒrilor',0),(495012,13751,'et','Muudatuste selgitamine',0),(495013,13751,'si','Razlaga spremembe',0),(495014,13751,'ba','Penjelasan tentang perubahan',0),(495015,13751,'nl','Verklaring van wijzigingen',0),(495016,13751,'fi','Selitys muutoksista',0),(495017,13751,'no','Forklaring av endringer',0),(495018,13751,'da','Forklaring af Ã¦ndringer',0),(495019,13751,'ko','ë³€ê²½ ë‚´ìš© ì„¤ëª…',0),(495020,13751,'he','×”×¡×‘×¨ ×¢×œ ×©×™× ×•×™×™×',0),(495021,13751,'el','Î•Î¾Î®Î³Î·ÏƒÎ· Ï„Ï‰Î½ Î±Î»Î»Î±Î³ÏŽÎ½',0),(495022,13751,'zh','æ›´æ”¹çš„è¯´æ˜Ž',0),(495023,13751,'sv','FÃ¶rklaring av fÃ¶rÃ¤ndringar',0),(495024,13751,'it','Spiegazione delle modifiche',0),(495025,13751,'tl','',0),(495026,13751,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¸­à¸‡à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(495027,13751,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤¾ à¤µà¤¿à¤µà¤°à¤£',0),(495028,13751,'ms','Penjelasan mengenai perubahan',0),(495029,13751,'ar','Ø´Ø±Ø­ Ù„Ù„ØªØºÙŠÙŠØ±Ø§Øª',0),(495030,13751,'fr','Explication des changements',0),(495031,13751,'jp','å¤‰æ›´ã®èª¬æ˜Ž',0),(495032,13751,'pt','ExplicaÃ§Ã£o das mudanÃ§as',0),(495033,13751,'ru','ÐžÐ±ÑŠÑÑÐ½ÐµÐ½Ð¸Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(495034,13751,'es','ExplicaciÃ³n de los cambios',0),(495035,13751,'de','ErlÃ¤uterung der Ã„nderungen',0),(495036,13751,'en','Explanation Of Changes',0),(495037,13752,'is','',0),(495038,13752,'dr','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§Ø®Ø§Ù„Øµ',0),(495039,13752,'pr','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§Ø®Ø§Ù„Øµ',0),(495040,13752,'tr','BrÃ¼t maaÅŸ',0),(495041,13752,'pl','Listy pÅ‚ac brutto',0),(495042,13752,'bg','Ð‘Ñ€ÑƒÑ‚Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(495043,13752,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ù¾Û’ Ø±ÙˆÙ„',0),(495044,13752,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ',0),(495045,13752,'vi','Tá»•ng biÃªn cháº¿',0),(495046,13752,'af','Bruto Loonrol',0),(495047,13752,'ro','Salarii brute',0),(495048,13752,'et','Bruto palga',0),(495049,13752,'si','IzplaÄane bruto plaÄe',0),(495050,13752,'ba','Gaji Bruto',0),(495051,13752,'nl','Bruto Payroll',0),(495052,13752,'fi','Brutto palkka',0),(495053,13752,'no','Brutto lÃ¸nn',0),(495054,13752,'da','Brutto lÃ¸n',0),(495055,13752,'ko','ì´ ê¸‰ì—¬',0),(495056,13752,'he','×©×›×¨ ×‘×¨×•×˜×•',0),(495057,13752,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î¿ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(495058,13752,'zh','å·¥èµ„æ€»é¢',0),(495059,13752,'sv','Brutto lÃ¶n',0),(495060,13752,'it','Retribuzioni lorde',0),(495061,13752,'tl','',0),(495062,13752,'th','à¸£à¸§à¸¡à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(495063,13752,'hi','à¤¸à¤•à¤² à¤ªà¥‡à¤°à¥‹à¤²',0),(495064,13752,'ms','Gaji kasar',0),(495065,13752,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(495066,13752,'fr','Masse salariale brute',0),(495067,13752,'jp','ç·çµ¦ä¸Ž',0),(495068,13752,'pt','Folha de pagamento bruta',0),(495069,13752,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(495070,13752,'es','NÃ³mina bruta',0),(495071,13752,'de','Brutto-Lohn-und Gehaltsabrechnung',0),(495072,13752,'en','Gross Payroll',0),(495073,13753,'is','',0),(495074,13753,'dr','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§Ø®Ø§Ù„Øµ Ø¯Ø± Remitting Ø¯Ù„Ø§Ø± ØªÙ†Ù‡Ø§ Ø¯ÙˆØ±Ù‡',0),(495075,13753,'pr','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§Ø®Ø§Ù„Øµ Ø¯Ø± Remitting Ø¯Ù„Ø§Ø± ØªÙ†Ù‡Ø§ Ø¯ÙˆØ±Ù‡',0),(495076,13753,'tr','Sadece dÃ¶nem dolar havaleleri maaÅŸ BrÃ¼t',0),(495077,13753,'pl','Brutto wynagrodzenia w przelewÃ³w dolarach okres tylko',0),(495078,13753,'bg','Ð‘Ñ€ÑƒÑ‚Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð² Ñ€ÐµÐ¼Ð¸Ñ‚ÐµÐ½Ñ‚Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð´Ð¾Ð»Ð°Ñ€Ð° ÑÐ°Ð¼Ð¾',0),(495079,13753,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ø³Ø§Ù…Ù†Ø§ ÛÙˆØªØ§ Ø­Ø¯ Ø¯Ø±Ø¬Û Ø¯ÙˆØ± ÚˆØ§Ù„Ø± ØµØ±Ù Ø±ÛŒÙ…ÛŒÙ¹Ø§Ù†Ú¯ Ù…ÛŒÚº',0),(495080,13753,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ Ñƒ Ñ€ÐµÐ¼Ð¸Ñ‚Ð¸Ñ€Ð°Ñ˜ÑƒÑ›Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð´Ð¾Ð»Ð°Ñ€Ð° ÑÐ°Ð¼Ð¾',0),(495081,13753,'vi','Tá»•ng biÃªn cháº¿ trong thá»i ká»³ Ä‘Ã´ la chá»‰ chuyá»ƒn tiá»n',0),(495082,13753,'af','Bruto heeltydse In die Remitting tydperk dollar net',0),(495083,13753,'ro','Brut de salarizare Ã®n remisivÄƒ perioada de dolari numai',0),(495084,13753,'et','Bruto palga pangaÃ¼lekande perioodi dollarit ainult',0),(495085,13753,'si','Bruto izplaÄane plaÄe v nakazovanju obdobje dolarjev samo',0),(495086,13753,'ba','Kotor penggajian dalam Remitting periode dolar hanya',0),(495087,13753,'nl','Bruto Payroll In Remitting periode Dollars alleen',0),(495088,13753,'fi','Brutto palkka palautuksen aikana dollaria vain',0),(495089,13753,'no','Brutto lÃ¸nn i remittering perioden dollar bare',0),(495090,13753,'da','Brutto lÃ¸n i remitterende periode Dollars kun',0),(495091,13753,'ko','ê¸‰ì—¬ ê¸°ê°„ ë‹¬ëŸ¬ë§Œ ì†¡ê¸ˆì— ì´',0),(495092,13753,'he','×‘×¨×•×˜×• ×©×›×¨ ×‘×”×¢×‘×¨×ª ×ª×§×•×¤×” ×“×•×œ×¨ ×‘×œ×‘×“',0),(495093,13753,'el','Î£Îµ Î´Î¹Î±Î»ÎµÎ¯Ï€Î¿Ï…ÏƒÎ± Ï€ÎµÏÎ¯Î¿Î´Î¿ Î´Î¿Î»Î¬ÏÎ¹Î± Î¼ÏŒÎ½Î¿ Î±ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„Î¿Ï…Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(495094,13753,'zh','åœ¨ç¼“è§£æœŸç¾Žå…ƒåªæ¯›å·¥èµ„',0),(495095,13753,'sv','Brutto lÃ¶n i remittering Period dollar bara',0),(495096,13753,'it','Lorda sui salari nel periodo dollari solo di rimessa',0),(495097,13753,'tl','',0),(495098,13753,'th','à¸£à¸§à¸¡à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¹ƒà¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸œà¹ˆà¸²à¸™à¸˜à¸™à¸²à¸„à¸²à¸£à¸”à¸­à¸¥à¸¥à¸²à¸£à¹Œà¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¹€à¸‰à¸žà¸²à¸°',0),(495099,13753,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤…à¤µà¤§à¤¿ à¤¡à¥‰à¤²à¤° à¤¹à¥€ à¤¦à¥‡à¤¨ à¤®à¥‡à¤‚ à¤¸à¤•à¤²',0),(495100,13753,'ms','Kasar gaji dalam pungutan tempoh ringgit sahaja',0),(495101,13753,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø±ÙˆØ§ØªØ¨ ÙÙŠ ØªØ­ÙˆÙŠÙ„ Ø§Ù„ÙØªØ±Ø© Ø¯ÙˆÙ„Ø§Ø± ÙÙ‚Ø·',0),(495102,13753,'fr','Brut de paie en remettant la pÃ©riode Dollars seulement',0),(495103,13753,'jp','çµ¦ä¸ŽæœŸé–“ã®ãƒ‰ãƒ«ã ã‘ã®æŒ¯ã‚Šè¾¼ã¿ã«ç·ã—ã¾ã™ã€‚',0),(495104,13753,'pt','Bruto da folha de pagamento em remitente perÃ­odos dÃ³lares apenas',0),(495105,13753,'ru','Ð’Ð°Ð»Ð¾Ð²Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð² Ñ€ÐµÐ¼Ð¸Ñ‚ÐµÐ½Ñ‚ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð´Ð¾Ð»Ð»Ð°Ñ€Ð¾Ð² Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(495106,13753,'es','Bruto nÃ³mina de remitente perÃ­odos dÃ³lares solamente',0),(495107,13753,'de','Brutto-Lohn-und Gehaltsabrechnung In remittierender Zeitraum Dollar nur',0),(495108,13753,'en','Gross Payroll In Remitting Period Dollars Only',0),(495109,13754,'is','',0),(495110,13754,'dr','Ù†Ù‡. Ø§Ø² Ú©Ø§Ø±Ú©Ù†Ø§Ù† Ø¯Ø± Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ Ú¯Ø°Ø´ØªÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(495111,13754,'pr','Ù†Ù‡. Ø§Ø² Ú©Ø§Ø±Ú©Ù†Ø§Ù† Ø¯Ø± Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ Ú¯Ø°Ø´ØªÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(495112,13754,'tr','No Son Ã¶deme dÃ¶nemde Ã§alÄ±ÅŸanlarÄ±nÄ±n',0),(495113,13754,'pl','Nr. PracownikÃ³w w ostatnim okresie rozliczeniowym',0),(495114,13754,'bg','ÐÐµ. ÐÐ° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð² Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð½Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(495115,13754,'ur','Ù†ÛÙŠÚº. Ù…Ù„Ø§Ø²Ù…ÛŒÙ† Ú©ÛŒ ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ø¢Ø®Ø±ÛŒ Ø¯ÙˆØ± Ù…ÛŒÚº',0),(495116,13754,'sr','Ð½Ðµ. Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ñƒ Ñ€Ð¾ÐºÐ¾Ð¼ Ð¸ÑÐ¿Ð»Ð°Ñ‚Ðµ Ð¿Ð»Ð°Ñ‚Ð°',0),(495117,13754,'vi','CÆ°á»i to NhÃ¢n viÃªn táº¡i ká»³ tráº£ tiá»n cuá»‘i cÃ¹ng',0),(495118,13754,'af','Nee. Van werknemers In die laaste tydperk betaal',0),(495119,13754,'ro','nu. De angajaÅ£i Ã®n ultima perioadÄƒ de platÄƒ',0),(495120,13754,'et','Ei. Eelmise makseperioodi tÃ¶Ã¶tajate',0),(495121,13754,'si','ne. Zaposlenih v plaÄi zadnja',0),(495122,13754,'ba','Tidak. Karyawan di zaman membayar',0),(495123,13754,'nl','Nr. Van de werknemers In de laatste periode van de beloning',0),(495124,13754,'fi','Ei. TyÃ¶ntekijÃ¶iden viime maksukauden',0),(495125,13754,'no','nei. Ansatte i lÃ¸nnsperioden',0),(495126,13754,'da','CoC Medarbejdere i sidste lÃ¸nperiode',0),(495127,13754,'ko','Lol ë§ˆì§€ë§‰ ì§€ë¶ˆ ê¸°ê°„ì— ìžˆëŠ” ì§ì›ì˜',0),(495128,13754,'he','×œ×. ×”×¢×•×‘×“×™× ×‘×ª×§×•×¤×ª ×”×ª×©×œ×•× ×”××—×¨×•×Ÿ',0),(495129,13754,'el','ÎŒÏ‡Î¹. Î¤Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ ÏƒÏ„Î·Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Ï€ÎµÏÎ¯Î¿Î´Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(495130,13754,'zh','å“ˆå“ˆæœ€åŽçš„ä»˜è–ªæœŸé—´ä¸­çš„å‘˜å·¥',0),(495131,13754,'sv','Nej. AnstÃ¤llda i senaste lÃ¶neperiod',0),(495132,13754,'it','Lol Dei dipendenti nell\'ultimo periodo di paga',0),(495133,13754,'tl','',0),(495134,13754,'th','à¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆ à¸‚à¸­à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¹ƒà¸™à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(495135,13754,'hi','à¤¨à¤¹à¥€à¤‚. à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤…à¤‚à¤¤à¤¿à¤® à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿ à¤®à¥‡à¤‚',0),(495136,13754,'ms','tidak. Pekerja dalam tempoh pembayaran gaji terakhir',0),(495137,13754,'ar','Ø±Ù‚Ù… Ù…Ù† Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ† ÙÙŠ ÙØªØ±Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(495138,13754,'fr','No Des employÃ©s de la derniÃ¨re pÃ©riode de paie',0),(495139,13754,'jp','å·æœ€å¾Œã®æ”¯æ‰•ã„æœŸé–“ã®å¾“æ¥­å“¡ã®',0),(495140,13754,'pt','N. Âº Dos trabalhadores no Ãºltimo perÃ­odo de pagamento',0),(495141,13754,'ru','â„– Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² Ð² Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(495142,13754,'es','No. De los empleados en el Ãºltimo perÃ­odo de pago',0),(495143,13754,'de','Nein. Mitarbeiter In letzte Zahlungsperiode',0),(495144,13754,'en','No. Of Employees In Last Pay Period',0),(495145,13755,'is','',0),(495146,13755,'dr','PD7A',0),(495147,13755,'pr','PD7A',0),(495148,13755,'tr','PD7A',0),(495149,13755,'pl','PD7A',0),(495150,13755,'bg','PD7A',0),(495151,13755,'ur','PD7A',0),(495152,13755,'sr','ÐŸÐ”7Ð',0),(495153,13755,'vi','PD7A',0),(495154,13755,'af','PD7A',0),(495155,13755,'ro','PD7A',0),(495156,13755,'et','PD7A',0),(495157,13755,'si','PD7A',0),(495158,13755,'ba','PD7A',0),(495159,13755,'nl','PD7A',0),(495160,13755,'fi','PD7A',0),(495161,13755,'no','PD7A',0),(495162,13755,'da','PD7A',0),(495163,13755,'ko','PD7A',0),(495164,13755,'he','PD7A',0),(495165,13755,'el','PD7A',0),(495166,13755,'zh','PD7A',0),(495167,13755,'sv','PD7A',0),(495168,13755,'it','PD7A',0),(495169,13755,'tl','',0),(495170,13755,'th','PD7A',0),(495171,13755,'hi','PD7A',0),(495172,13755,'ms','PD7A',0),(495173,13755,'ar','PD7A',0),(495174,13755,'fr','PD7A',0),(495175,13755,'jp','PD7A',0),(495176,13755,'pt','PD7A',0),(495177,13755,'ru','PD7A',0),(495178,13755,'es','PD7A',0),(495179,13755,'de','PD7A',0),(495180,13755,'en','PD7A',0),(495181,13756,'is','',0),(495182,13756,'dr','Ú©Ø³Ø± Ù…Ø§Ù„ÛŒØ§Øª',0),(495183,13756,'pr','Ú©Ø³Ø± Ù…Ø§Ù„ÛŒØ§Øª',0),(495184,13756,'tr','Vergi indirimleri',0),(495185,13756,'pl','Ulg podatkowych',0),(495186,13756,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ñ',0),(495187,13756,'ur','Ù¹ÛŒÚ©Ø³ Ú©Ù¹ÙˆØªÛŒ',0),(495188,13756,'sr','ÐžÐ´Ð±Ð¸Ñ‚ÐºÐµ Ð¾Ð´ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(495189,13756,'vi','Khoáº£n kháº¥u trá»« thuáº¿',0),(495190,13756,'af','Belasting aftrekkings',0),(495191,13756,'ro','Deduceri fiscale',0),(495192,13756,'et','Maksusoodustuste kehtestamine',0),(495193,13756,'si','DavÄne olajÅ¡ave',0),(495194,13756,'ba','Pengurangan pajak',0),(495195,13756,'nl','Belastingaftrek',0),(495196,13756,'fi','VerovÃ¤hennyksiÃ¤',0),(495197,13756,'no','Skattefradrag',0),(495198,13756,'da','Skattefradrag',0),(495199,13756,'ko','ì„¸ê¸ˆ ê³µì œ',0),(495200,13756,'he','× ×™×›×•×™×™ ×”×ž×¡',0),(495201,13756,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ­Ï‚ ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚',0),(495202,13756,'zh','ç¨Žæ”¶å‡å…',0),(495203,13756,'sv','Skatteavdrag',0),(495204,13756,'it','Detrazioni fiscali',0),(495205,13756,'tl','',0),(495206,13756,'th','à¸à¸²à¸£à¸«à¸±à¸à¸ à¸²à¸©à¸µ',0),(495207,13756,'hi','à¤•à¤° à¤•à¤Ÿà¥Œà¤¤à¥€',0),(495208,13756,'ms','Potongan cukai',0),(495209,13756,'ar','Ø§Ù„ØªØ®ÙÙŠØ¶Ø§Øª Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©',0),(495210,13756,'fr','Retenues d\'impÃ´t',0),(495211,13756,'jp','ç¨ŽæŽ§é™¤',0),(495212,13756,'pt','DeduÃ§Ãµes fiscais',0),(495213,13756,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð²Ñ‹Ñ‡ÐµÑ‚Ñ‹',0),(495214,13756,'es','Deducciones fiscales',0),(495215,13756,'de','SteuerabzÃ¼ge',0),(495216,13756,'en','Tax Deductions',0),(495217,13757,'is','',0),(495218,13757,'dr','Ú†Ø§Ù¾ Ø§Ø·Ù„Ø§Ø¹Ø§Øª PD7A',0),(495219,13757,'pr','Ú†Ø§Ù¾ Ø§Ø·Ù„Ø§Ø¹Ø§Øª PD7A',0),(495220,13757,'tr','PD7A bilgilerini yazdÄ±r',0),(495221,13757,'pl','Drukowanie informacji o PD7A',0),(495222,13757,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° PD7A Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(495223,13757,'ur','PD7A Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(495224,13757,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ ÐŸÐ”7Ð',0),(495225,13757,'vi','In thÃ´ng tin PD7A',0),(495226,13757,'af','Druk PD7A inligting',0),(495227,13757,'ro','ImprimaÅ£i informaÅ£ii PD7A',0),(495228,13757,'et','PD7A teabe printimiseks',0),(495229,13757,'si','Tiskanje podatkov PD7A',0),(495230,13757,'ba','Mencetak informasi PD7A',0),(495231,13757,'nl','PD7A informatie afdrukken',0),(495232,13757,'fi','Tulostaa PD7A tiedot',0),(495233,13757,'no','Skrive ut PD7A informasjon',0),(495234,13757,'da','Udskrive PD7A oplysninger',0),(495235,13757,'ko','PD7A ì •ë³´ ì¸ì‡„',0),(495236,13757,'he','×”×“×¤×¡ ×ž×™×“×¢ ××•×“×•×ª PD7A',0),(495237,13757,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ PD7A',0),(495238,13757,'zh','æ‰“å° PD7A ä¿¡æ¯',0),(495239,13757,'sv','Skriva ut PD7A Information',0),(495240,13757,'it','Stampare informazioni PD7A',0),(495241,13757,'tl','',0),(495242,13757,'th','à¸žà¸´à¸¡à¸žà¹Œà¸‚à¹‰à¸­à¸¡à¸¹à¸¥ PD7A',0),(495243,13757,'hi','à¤®à¥à¤¦à¥à¤°à¤£ PD7A à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(495244,13757,'ms','Cetak maklumat PD7A',0),(495245,13757,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª PD7A',0),(495246,13757,'fr','Imprimer les informations PD7A',0),(495247,13757,'jp','PD7A æƒ…å ±ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(495248,13757,'pt','Imprimir informaÃ§Ãµes de PD7A',0),(495249,13757,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ PD7A',0),(495250,13757,'es','Imprimir informaciÃ³n de PD7A',0),(495251,13757,'de','PD7A Informationen drucken',0),(495252,13757,'en','Print PD7A Information',0),(495253,13758,'is','',0),(495254,13758,'dr','Ù‡Ø²ÛŒÙ†Ù‡ ØµØ¯ÙˆØ± ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨',0),(495255,13758,'pr','Ù‡Ø²ÛŒÙ†Ù‡ ØµØ¯ÙˆØ± ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨',0),(495256,13758,'tr','Fatura maliyet',0),(495257,13758,'pl','Rozliczanie kosztÃ³w',0),(495258,13758,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(495259,13758,'ur','Ù„Ø§Ú¯Øª Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±Ù†Ø§',0),(495260,13758,'sr','ÐžÐ±Ñ€Ð°Ñ‡ÑƒÐ½ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(495261,13758,'vi','Thanh toÃ¡n chi phÃ­',0),(495262,13758,'af','Fakturering koste',0),(495263,13758,'ro','Costul de facturare',0),(495264,13758,'et','Arvete kulu',0),(495265,13758,'si','ZaraÄunavanje stroÅ¡kov',0),(495266,13758,'ba','Penagihan biaya',0),(495267,13758,'nl','Facturering kosten',0),(495268,13758,'fi','Laskutuksen kustannukset',0),(495269,13758,'no','Fakturering kostnader',0),(495270,13758,'da','Fakturering omkostninger',0),(495271,13758,'ko','ê²°ì œ ë¹„ìš©',0),(495272,13758,'he','×—×™×•×‘ ×¢×œ×•×ª',0),(495273,13758,'el','Î¤Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(495274,13758,'zh','è®¡è´¹æˆæœ¬',0),(495275,13758,'sv','Fakturering kostnad',0),(495276,13758,'it','Costo di fatturazione',0),(495277,13758,'tl','',0),(495278,13758,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(495279,13758,'hi','à¤²à¤¾à¤—à¤¤ à¤¬à¤¿à¤² à¤¸à¤®à¥à¤¬à¤‚à¤§à¥€',0),(495280,13758,'ms','Bil kos',0),(495281,13758,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(495282,13758,'fr','CoÃ»t de la facturation',0),(495283,13758,'jp','è²»ç”¨ã®è«‹æ±‚',0),(495284,13758,'pt','Custo de faturamento',0),(495285,13758,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(495286,13758,'es','Precio de Venta',0),(495287,13758,'de','Abrechnung Kosten',0),(495288,13758,'en','Billing Cost',0),(495289,13759,'is','',0),(495290,13759,'dr','Ø´Ø±Ú©Øª Ù‡Ø§ÛŒ Ù…Ø¬Ø§Ø²',0),(495291,13759,'pr','Ø´Ø±Ú©Øª Ù‡Ø§ÛŒ Ù…Ø¬Ø§Ø²',0),(495292,13759,'tr','Ä°zin verilen ÅŸirketler',0),(495293,13759,'pl','Firmy mogÄ…',0),(495294,13759,'bg','Ð”Ñ€ÑƒÐ¶ÐµÑÑ‚Ð²Ð°Ñ‚Ð° Ð¼Ð¾Ð³Ð°Ñ‚',0),(495295,13759,'ur','Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(495296,13759,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(495297,13759,'vi','CÃ´ng ty cho phÃ©p',0),(495298,13759,'af','Maatskappye toegelaat',0),(495299,13759,'ro','Companii de permis',0),(495300,13759,'et','Lubatud ettevÃµtted',0),(495301,13759,'si','Podjetja, dovoljeno',0),(495302,13759,'ba','Perusahaan-perusahaan yang diperbolehkan',0),(495303,13759,'nl','Bedrijven toegestaan',0),(495304,13759,'fi','Sallittu yritysten',0),(495305,13759,'no','Selskaper tillatt',0),(495306,13759,'da','Selskaber tilladt',0),(495307,13759,'ko','íšŒì‚¬ í—ˆìš©',0),(495308,13759,'he','×—×‘×¨×•×ª ×ž×•×ª×¨',0),(495309,13759,'el','Î•Ï„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Ï€Î¿Ï… ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(495310,13759,'zh','å…¬å¸å…è®¸',0),(495311,13759,'sv','FÃ¶retag fÃ¥r',0),(495312,13759,'it','Aziende ha permise',0),(495313,13759,'tl','',0),(495314,13759,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(495315,13759,'hi','à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(495316,13759,'ms','Syarikat-syarikat yang dibenarkan',0),(495317,13759,'ar','ÙŠØ³Ù…Ø­ Ù„Ù„Ø´Ø±ÙƒØ§Øª',0),(495318,13759,'fr','SociÃ©tÃ©s autorisÃ©es',0),(495319,13759,'jp','è¨±å¯ã®ä¼æ¥­',0),(495320,13759,'pt','Empresas podem',0),(495321,13759,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¹',0),(495322,13759,'es','Empresas Permitidas',0),(495323,13759,'de','Unternehmen erlaubt',0),(495324,13759,'en','Companies Allowed',0),(495325,13760,'is','',0),(495326,13760,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù…Ø­ØµÙˆÙ„',0),(495327,13760,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù…Ø­ØµÙˆÙ„',0),(495328,13760,'tr','ÃœrÃ¼n ayrÄ±ntÄ±larÄ±',0),(495329,13760,'pl','SzczegÃ³Å‚y produktu',0),(495330,13760,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(495331,13760,'ur','Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ ØªÙØµÛŒÙ„',0),(495332,13760,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð¾ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(495333,13760,'vi','Chi tiáº¿t sáº£n pháº©m',0),(495334,13760,'af','Produk besonderhede',0),(495335,13760,'ro','Detalii produs',0),(495336,13760,'et','Toote Ã¼ksikasjad',0),(495337,13760,'si','Product Details',0),(495338,13760,'ba','Detail produk',0),(495339,13760,'nl','Productdetails',0),(495340,13760,'fi','Tuotetiedot',0),(495341,13760,'no','Produktdetaljer',0),(495342,13760,'da','Produktdetaljer',0),(495343,13760,'ko','ì œí’ˆ ì„¸ë¶€ ì‚¬í•­',0),(495344,13760,'he','×¤×¨×˜×™ ×”×ž×•×¦×¨',0),(495345,13760,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚',0),(495346,13760,'zh','äº§å“è¯¦ç»†ä¿¡æ¯',0),(495347,13760,'sv','Produktinformation',0),(495348,13760,'it','Dettagli sul prodotto',0),(495349,13760,'tl','',0),(495350,13760,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(495351,13760,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤µà¤¿à¤µà¤°à¤£',0),(495352,13760,'ms','Maklumat produk',0),(495353,13760,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ù†ØªØ¬',0),(495354,13760,'fr','DÃ©tails du produit',0),(495355,13760,'jp','è£½å“ã®è©³ç´°',0),(495356,13760,'pt','Detalhes do produto',0),(495357,13760,'ru','Ð¡Ð²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ðµ',0),(495358,13760,'es','Comparativa de Productos',0),(495359,13760,'de','Produktdetails',0),(495360,13760,'en','Product Details',0),(495361,13761,'is','',0),(495362,13761,'dr','Ù‚Ø§Ù„Ø¨ Ø¯Ùˆ Ù¾Ù†Ø¬Ø±Ù‡',0),(495363,13761,'pr','Ù‚Ø§Ù„Ø¨ Ø¯Ùˆ Ù¾Ù†Ø¬Ø±Ù‡',0),(495364,13761,'tr','Ã‡ift pencere Format',0),(495365,13761,'pl','Format okna podwÃ³jne',0),(495366,13761,'bg','Ð”Ð²Ð¾ÐµÐ½ ÐŸÑ€Ð¾Ð·Ð¾Ñ€ÐµÑ† Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(495367,13761,'ur','ÚˆØ¨Ù„ Ø¯Ø±ÛŒÚ†Û ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(495368,13761,'sr','Ð”ÑƒÐ¿Ð»Ð¸ Ð¿Ñ€Ð¾Ð·Ð¾Ñ€ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(495369,13761,'vi','Äá»‹nh dáº¡ng cá»­a sá»• Ä‘Ã´i',0),(495370,13761,'af','Dubbele venster formaat',0),(495371,13761,'ro','Format dublu fereastra',0),(495372,13761,'et','Double aken formaadis',0),(495373,13761,'si','Dvojno okno Format',0),(495374,13761,'ba','Format jendela ganda',0),(495375,13761,'nl','Dubbel venster Format',0),(495376,13761,'fi','Kaksinkertainen ikkuna muodossa',0),(495377,13761,'no','Doble vinduet Format',0),(495378,13761,'da','Dobbelt vindue Format',0),(495379,13761,'ko','ë‘ ë°° ì°½ í˜•ì‹',0),(495380,13761,'he','×¢×™×¦×•×‘ ×—×œ×•×Ÿ ×–×•×’×™',0),(495381,13761,'el','ÎœÎ¿ÏÏ†Î® Î´Î¹Ï€Î»ÏŒ Ï€Î±ÏÎ¬Î¸Ï…ÏÎ¿',0),(495382,13761,'zh','åŒçª—å£æ ¼å¼',0),(495383,13761,'sv','Dubbla fÃ¶nster Format',0),(495384,13761,'it','Doppia finestra formato',0),(495385,13761,'tl','',0),(495386,13761,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¸«à¸™à¹‰à¸²à¸•à¹ˆà¸²à¸‡à¸„à¸¹à¹ˆ',0),(495387,13761,'hi','à¤¡à¤¬à¤² à¤µà¤¿à¤‚à¤¡à¥‹ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(495388,13761,'ms','Format Double tetingkap',0),(495389,13761,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø¥Ø·Ø§Ø± Ù…Ø²Ø¯ÙˆØ¬',0),(495390,13761,'fr','FenÃªtre double Format',0),(495391,13761,'jp','ãƒ€ãƒ–ãƒ« ã‚¦ã‚£ãƒ³ãƒ‰ã‚¦ ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(495392,13761,'pt','Formato de janela dupla',0),(495393,13761,'ru','Ð”Ð²Ð¾Ð¹Ð½Ð¾Ðµ Ð¾ÐºÐ½Ð¾ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(495394,13761,'es','Formato doble ventana',0),(495395,13761,'de','Doppelfenster-Format',0),(495396,13761,'en','Double Window Format',0),(495397,13762,'is','',0),(495398,13762,'dr','Ú¯ÛŒØ±Ù†Ø¯Ù‡ ØªÙ…Ø§Ù… Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ù‡',0),(495399,13762,'pr','Ú¯ÛŒØ±Ù†Ø¯Ù‡ ØªÙ…Ø§Ù… Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ù‡',0),(495400,13762,'tr','TÃ¼m e-postalar iÃ§in gizli',0),(495401,13762,'pl','Wszystkie e-maile do BCC',0),(495402,13762,'bg','Ð¡Ðš, Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¸Ð¼ÐµÐ¹Ð»Ð¸, Ð·Ð° Ð´Ð°',0),(495403,13762,'ur','ØªÙ…Ø§Ù… Ø§ÛŒ Ù…ÛŒÙ„Ø² Ú©Û’ Ù„ÛŒÛ’ Ø¨ÛŒ Ø³ÛŒ Ø³ÛŒ',0),(495404,13762,'sr','Ð‘Ð¦Ð¦ ÑÐ²Ðµ Ðµ-Ð¿Ð¾Ñ€ÑƒÐºÐµ Ð´Ð°',0),(495405,13762,'vi','BCC táº¥t cáº£ email Ä‘á»ƒ',0),(495406,13762,'af','BCC alle e-pos na',0),(495407,13762,'ro','BCC toate email-uri Ã®n',0),(495408,13762,'et','KÃµik kirju BCC',0),(495409,13762,'si','BCC vse Emails v',0),(495410,13762,'ba','BCC semua email ke',0),(495411,13762,'nl','BCC alle E-mails naar',0),(495412,13762,'fi','Kaikki sÃ¤hkÃ¶postit Piilokopio',0),(495413,13762,'no','Blindkopi alle e-post til',0),(495414,13762,'da','BCC alle E-mails til',0),(495415,13762,'ko','ëª¨ë“  ì´ë©”ì¼ ìˆ¨ì€ ì°¸ì¡°',0),(495416,13762,'he','×¢×•×ª×§ ×ž×•×¡×ª×¨ ×›×œ ×ž×™×™×œ×™×',0),(495417,13762,'el','\"Î™Î´Î¹Î±Î¯Ï„.\" ÏŒÎ»Î± Ï„Î± Î¼Î·Î½ÏÎ¼Î±Ï„Î± ÏƒÎµ',0),(495418,13762,'zh','æ‰€æœ‰å‘ç”µå­é‚®ä»¶çš„å¯†ä»¶æŠ„é€',0),(495419,13762,'sv','BCC alla e-postmeddelanden till',0),(495420,13762,'it','BCC tutte le email a',0),(495421,13762,'tl','',0),(495422,13762,'th','à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸à¸²à¸£à¸ªà¸³à¹€à¸™à¸²à¸¥à¸±à¸šà¸–à¸¶à¸‡',0),(495423,13762,'hi','à¤—à¥à¤ªà¥à¤¤ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¸à¤­à¥€ à¤ˆà¤®à¥‡à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(495424,13762,'ms','Skt semua e-mel',0),(495425,13762,'ar','ÙƒØ§ÙØ© Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¥Ù„Ù‰ Ù…Ø®ÙÙŠØ©',0),(495426,13762,'fr','BCC tous les Emails Ã ',0),(495427,13762,'jp','ã™ã¹ã¦ã®ãƒ¡ãƒ¼ãƒ«ã« BCC',0),(495428,13762,'pt','BCC todos E-mails para',0),(495429,13762,'ru','Ð¡Ðš, Ð²ÑÐµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ðµ Ð¿Ð¸ÑÑŒÐ¼Ð°',0),(495430,13762,'es','Todos los correos electrÃ³nicos de BCC',0),(495431,13762,'de','Alle E-Mails an BCC',0),(495432,13762,'en','BCC All Emails To',0),(495433,13763,'is','',0),(495434,13763,'dr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØªÙ…Ø§Ù…',0),(495435,13763,'pr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØªÙ…Ø§Ù…',0),(495436,13763,'tr','TÃ¼mÃ¼nÃ¼ gÃ¶rÃ¼ntÃ¼lemek iÃ§in tÄ±klayÄ±nÄ±z',0),(495437,13763,'pl','Kliknij tutaj, aby wyÅ›wietliÄ‡ wszystkie',0),(495438,13763,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸',0),(495439,13763,'ur','Ø³Ø¨ Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(495440,13763,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ ÑÐ²Ðµ',0),(495441,13763,'vi','Click vÃ o Ä‘Ã¢y Ä‘á»ƒ xem táº¥t cáº£',0),(495442,13763,'af','Kliek hier om te sien al',0),(495443,13763,'ro','Click aici pentru a vizualiza toate',0),(495444,13763,'et','Vajuta siia, et vaadata kÃµiki',0),(495445,13763,'si','Kliknite tukaj za ogled vseh',0),(495446,13763,'ba','Klik di sini untuk melihat semua',0),(495447,13763,'nl','Klik hier om te bekijken alle',0),(495448,13763,'fi','Klikkaa tÃ¤stÃ¤ nÃ¤hdÃ¤ksesi kaikki',0),(495449,13763,'no','Klikk her for Ã¥ vise alle',0),(495450,13763,'da','Klik her for at se alle',0),(495451,13763,'ko','ëª¨ë‘ ë³´ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(495452,13763,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×”×¦×™×’ ××ª ×›×œ',0),(495453,13763,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ, Î³Î¹Î± Î½Î± Ï„Î± Î´ÎµÎ¯Ï„Îµ ÏŒÎ»Î±',0),(495454,13763,'zh','å•å‡»æ­¤å¤„ä»¥æŸ¥çœ‹æ‰€æœ‰',0),(495455,13763,'sv','Klicka hÃ¤r fÃ¶r att visa alla',0),(495456,13763,'it','Clicca qui per visualizzare tutti',0),(495457,13763,'tl','',0),(495458,13763,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(495459,13763,'hi','à¤¸à¤­à¥€ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(495460,13763,'ms','Klik di sini untuk melihat semua',0),(495461,13763,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ù„Ø¹Ø±Ø¶ Ø§Ù„ÙƒÙ„',0),(495462,13763,'fr','Cliquez ici pour visualiser l\'ensemble',0),(495463,13763,'jp','ã™ã¹ã¦ã‚’è¡¨ç¤ºã™ã‚‹ã«ã¯ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯',0),(495464,13763,'pt','Clique aqui para ver todos os',0),(495465,13763,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð²ÑÐµ',0),(495466,13763,'es','Haga clic aquÃ­ para ver todos',0),(495467,13763,'de','Klicken Sie hier, um alle anzuzeigen',0),(495468,13763,'en','Click Here To View All',0),(495469,13764,'is','',0),(495470,13764,'dr','Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ¹Ø¯Ø§Ø¯ Ø±Ú©ÙˆØ±Ø¯ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(495471,13764,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ¹Ø¯Ø§Ø¯ Ø±Ú©ÙˆØ±Ø¯ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(495472,13764,'tr','En fazla kayÄ±t sayÄ±sÄ± gÃ¶sterilir',0),(495473,13764,'pl','Maksymalna liczba rekordÃ³w sÄ… wyÅ›wietlane',0),(495474,13764,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ Ð±Ñ€Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÐ° Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½Ð¸',0),(495475,13764,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©ÛŒ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ØªØ¹Ø¯Ø§Ø¯ Ø¯Ú©Ú¾Ø§Ø¦Û’ Ú¯Ø¦Û’ ÛÛŒÚº',0),(495476,13764,'sr','ÐœÐ°x Ð±Ñ€Ð¾Ñ˜ Ð·Ð°Ð¿Ð¸ÑÐ° ÑÑƒ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½Ð¸.',0),(495477,13764,'vi','Tá»‘i Ä‘a sá»‘ lÆ°á»£ng há»“ sÆ¡ Ä‘Æ°á»£c hiá»ƒn thá»‹',0),(495478,13764,'af','Maksimum aantal rekords getoon is',0),(495479,13764,'ro','NumÄƒrul maxim de Ã®nregistrÄƒri sunt afiÅŸate',0),(495480,13764,'et','Kirjete Max arv kuvatakse',0),(495481,13764,'si','Max Å¡tevilo zapisov, ki so prikazani',0),(495482,13764,'ba','Max jumlah record yang ditampilkan',0),(495483,13764,'nl','Max aantal Records worden weergegeven',0),(495484,13764,'fi','Tietueiden enimmÃ¤ismÃ¤Ã¤rÃ¤ nÃ¤kyvÃ¤t',0),(495485,13764,'no','Maksimalt antall poster vises',0),(495486,13764,'da','Max antal poster er vist',0),(495487,13764,'ko','í‘œì‹œ ë˜ëŠ” ë ˆì½”ë“œì˜ ìµœëŒ€ ìˆ˜',0),(495488,13764,'he','×ž×¡×¤×¨ ×ž×¨×‘×™ ×©×œ ×¨×©×•×ž×•×ª ×ž×•×¦×’×•×ª',0),(495489,13764,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î¿Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ Ï€Î¿Ï… ÎµÎ¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹',0),(495490,13764,'zh','æ˜¾ç¤ºè®°å½•çš„æœ€å¤§æ•°ç›®',0),(495491,13764,'sv','Max antal poster visas',0),(495492,13764,'it','Max numero di record sono mostrati',0),(495493,13764,'tl','',0),(495494,13764,'th','à¸ˆà¸³à¸™à¸§à¸™à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¸‚à¸­à¸‡à¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”à¸—à¸µà¹ˆà¸ˆà¸°à¹à¸ªà¸”à¸‡',0),(495495,13764,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤•à¥€ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤¿à¤–à¤¾à¤ˆ à¤œà¤¾à¤¤à¥€ à¤¹à¥ˆà¤‚',0),(495496,13764,'ms','Max bilangan rekod yang ditunjukkan',0),(495497,13764,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ø§Ù„ØªÙŠ ØªØ¸Ù‡Ø±',0),(495498,13764,'fr','Nombre maximum d\'enregistrements sont affichÃ©s',0),(495499,13764,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ã®æœ€å¤§æ•°ãŒè¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(495500,13764,'pt','NÃºmero mÃ¡ximo de registros sÃ£o mostrados',0),(495501,13764,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ð½Ð¾ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(495502,13764,'es','NÃºmero mÃ¡ximo de registros se muestran',0),(495503,13764,'de','Max Anzahl der DatensÃ¤tze werden angezeigt',0),(495504,13764,'en','Max Number Of Records Are Shown',0),(495505,13765,'is','',0),(495506,13765,'dr','ÙØ§Ú©ØªÙˆØ± &amp; Ø§ÛŒÙ…ÛŒÙ„ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ø­Ù…Ù„',0),(495507,13765,'pr','ÙØ§Ú©ØªÙˆØ± &amp; Ø§ÛŒÙ…ÛŒÙ„ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ø­Ù…Ù„',0),(495508,13765,'tr','Fatura & gÃ¶nderilen e-posta',0),(495509,13765,'pl','Faktura & E-mail gdy wysÅ‚ane',0),(495510,13765,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° & Ð¸Ð¼ÐµÐ¹Ð» Ð¿Ñ€Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð°',0),(495511,13765,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ & Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ø¬Ø¨ Ø§ÛŒ Ù…ÛŒÙ„',0),(495512,13765,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ & Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ ÐºÐ°Ð´Ð° Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½',0),(495513,13765,'vi','HoÃ¡ Ä‘Æ¡n &amp; Email khi váº­n chuyá»ƒn',0),(495514,13765,'af','Faktuur & e-pos wanneer Shipped',0),(495515,13765,'ro','FacturÄƒ & E-mail atunci cÃ¢nd expediate',0),(495516,13765,'et','Arve & e-maili kui lÃ¤hetatud',0),(495517,13765,'si','RaÄun & Email pri dobavi',0),(495518,13765,'ba','Email ketika dikirimkan & faktur',0),(495519,13765,'nl','Factuur & E-mail wanneer verzonden',0),(495520,13765,'fi','Laskun & sÃ¤hkÃ¶posti toimituksen',0),(495521,13765,'no','Faktura & Email nÃ¥r levert',0),(495522,13765,'da','Faktura & E-mail nÃ¥r afsendt',0),(495523,13765,'ko','ì†¡ìž¥ & ì´ë©”ì¼ ë°œì†¡ í•˜ëŠ” ê²½ìš°',0),(495524,13765,'he','×—×©×‘×•× ×™×ª & ×“×•× ×œ ×›××©×¨ × ×©×œ×—',0),(495525,13765,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ & Email ÏŒÏ„Î±Î½ Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹',0),(495526,13765,'zh','å‘ç¥¨ &amp; å‘è´§æ—¶çš„ç”µå­é‚®ä»¶',0),(495527,13765,'sv','Faktura & e-post nÃ¤r levereras',0),(495528,13765,'it','Fattura & Email quando spedito',0),(495529,13765,'tl','',0),(495530,13765,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ & à¸­à¸µà¹€à¸¡à¸¥à¹Œà¹€à¸¡à¸·à¹ˆà¸­à¸ªà¹ˆà¸‡',0),(495531,13765,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ & à¤œà¤¬ à¤­à¥‡à¤œ à¤ˆà¤®à¥‡à¤²',0),(495532,13765,'ms','Invois & e-mel apabila dihantar',0),(495533,13765,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¢Ù†Ø¯ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¹Ù†Ø¯Ù…Ø§ ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§',0),(495534,13765,'fr','Facture & Email lors de l\'expÃ©dition',0),(495535,13765,'jp','è«‹æ±‚æ›¸ & e ãƒ¡ãƒ¼ãƒ«å‡ºè·æ™‚',0),(495536,13765,'pt','Fatura & E-mail quando enviados',0),(495537,13765,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° & ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð¿Ñ€Ð¸ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐµ',0),(495538,13765,'es','Factura &amp; correo electrÃ³nico cuando se envÃ­an',0),(495539,13765,'de','Rechnung & Email bei Versand',0),(495540,13765,'en','Invoice & Email When Shipped',0),(495541,13766,'is','',0),(495542,13766,'dr','Ù‡Ø±Ú¯Ø²',0),(495543,13766,'pr','Ù‡Ø±Ú¯Ø²',0),(495544,13766,'tr','Asla',0),(495545,13766,'pl','Nigdy nie',0),(495546,13766,'bg','ÐÐ¸ÐºÐ¾Ð³Ð° Ð½Ðµ',0),(495547,13766,'ur','Ú©Ø¨Ú¾ÛŒ Ù†ÛÛŒÚº',0),(495548,13766,'sr','ÐÐ¸ÐºÐ°Ð´',0),(495549,13766,'vi','KhÃ´ng bao giá»',0),(495550,13766,'af','Nooit',0),(495551,13766,'ro','NiciodatÄƒ',0),(495552,13766,'et','Kunagi',0),(495553,13766,'si','Nikoli ne',0),(495554,13766,'ba','Tidak pernah',0),(495555,13766,'nl','Nooit',0),(495556,13766,'fi','Koskaan',0),(495557,13766,'no','Aldri',0),(495558,13766,'da','Aldrig',0),(495559,13766,'ko','ê²°ì½”',0),(495560,13766,'he','. ×ž×¢×•×œ× ×œ×',0),(495561,13766,'el','Î Î¿Ï„Î­ Î´ÎµÎ½',0),(495562,13766,'zh','æ°¸è¿œä¸ä¼š',0),(495563,13766,'sv','Aldrig',0),(495564,13766,'it','Mai',0),(495565,13766,'tl','',0),(495566,13766,'th','à¹„à¸¡à¹ˆà¹€à¸„à¸¢',0),(495567,13766,'hi','à¤•à¤­à¥€ à¤¨à¤¹à¥€à¤‚',0),(495568,13766,'ms','Jangan sekali-kali',0),(495569,13766,'ar','Ø§Ø¨Ø¯Ø£',0),(495570,13766,'fr','Jamais',0),(495571,13766,'jp','æ±ºã—ã¦',0),(495572,13766,'pt','Nunca',0),(495573,13766,'ru','ÐÐ¸ÐºÐ¾Ð³Ð´Ð° Ð½Ðµ',0),(495574,13766,'es','Nunca',0),(495575,13766,'de','Nie',0),(495576,13766,'en','Never',0),(495577,13767,'is','',0),(495578,13767,'dr','ÙÙ‚Ø· Ú©Ø§Ù…Ù„ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(495579,13767,'pr','ÙÙ‚Ø· Ú©Ø§Ù…Ù„ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(495580,13767,'tr','YalnÄ±zca tam gÃ¶nderiler',0),(495581,13767,'pl','Tylko kompletny przesyÅ‚ek',0),(495582,13767,'bg','Ð¡Ð°Ð¼Ð¾ Ñ†ÑÐ»Ð¾ÑÑ‚Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(495583,13767,'ur','ØµØ±Ù Ù…Ú©Ù…Ù„ ØªØ±Ø³ÛŒÙ„',0),(495584,13767,'sr','Ð¡Ð°Ð¼Ð¾ Ð¿Ð¾Ñ‚Ð¿ÑƒÐ½Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(495585,13767,'vi','CÃ¡c lÃ´ hÃ ng Ä‘Æ°á»£c hoÃ n thÃ nh chá»‰',0),(495586,13767,'af','Voltooi slegs vervoer',0),(495587,13767,'ro','Doar completaÅ£i transporturile',0),(495588,13767,'et','Ainult tÃ¤ielike lÃ¤hetuste',0),(495589,13767,'si','Le popolne dobave',0),(495590,13767,'ba','Hanya lengkap pengiriman',0),(495591,13767,'nl','Alleen volledige verzendingen',0),(495592,13767,'fi','Vain tÃ¤ydellisissÃ¤ toimituksissa',0),(495593,13767,'no','Bare fullstendige leveringer',0),(495594,13767,'da','Kun komplet forsendelser',0),(495595,13767,'ko','ë§Œ ì¶œí•˜ ì™„ë£Œ',0),(495596,13767,'he','×¨×§ ×œ×”×©×œ×™× ×ž×©×œ×•×—×™×',0),(495597,13767,'el','ÎœÏŒÎ½Î¿ Ï€Î»Î®ÏÎµÎ¹Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(495598,13767,'zh','åªæœ‰å®Œæˆè£…è¿',0),(495599,13767,'sv','Endast kompletta leveranser',0),(495600,13767,'it','Solo completare le spedizioni',0),(495601,13767,'tl','',0),(495602,13767,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(495603,13767,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥‚à¤°à¥à¤£ à¤²à¤¦à¤¾à¤¨',0),(495604,13767,'ms','Sahaja selesai penghantaran',0),(495605,13767,'ar','Ø£ÙƒÙ…Ù„ ÙÙ‚Ø· Ø§Ù„Ø´Ø­Ù†Ø§Øª',0),(495606,13767,'fr','Seules les expÃ©ditions complÃ¨tes',0),(495607,13767,'jp','å‡ºè·ã‚’å®Œäº†ã®ã¿',0),(495608,13767,'pt','Apenas as transferÃªncias completas',0),(495609,13767,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ð¾Ð»Ð½Ñ‹Ðµ Ð³Ñ€ÑƒÐ·Ñ‹',0),(495610,13767,'es','SÃ³lo los envÃ­os completos',0),(495611,13767,'de','Nur komplette Sendungen',0),(495612,13767,'en','Only Complete Shipments',0),(495613,13768,'is','',0),(495614,13768,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ Ø¬Ø²Ø¦ÛŒ &amp; Ú©Ø§Ù…Ù„',0),(495615,13768,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ Ø¬Ø²Ø¦ÛŒ &amp; Ú©Ø§Ù…Ù„',0),(495616,13768,'tr','KÄ±smi & tam gÃ¶nderiler',0),(495617,13768,'pl','PrzesyÅ‚ki czÄ™Å›ciowe & peÅ‚ne',0),(495618,13768,'bg','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ & Ð¿ÑŠÐ»ÐµÐ½ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(495619,13768,'ur','Ø¬Ø²ÙˆÛŒ & Ù¾ÙˆØ±ÛŒ ØªØ±Ø³ÛŒÙ„',0),(495620,13768,'sr','Ð”ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð° & Ð¿ÑƒÐ½Ñƒ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(495621,13768,'vi','LÃ´ hÃ ng má»™t pháº§n &amp; Ä‘áº§y Ä‘á»§',0),(495622,13768,'af','Gedeeltelike & volle gestuur',0),(495623,13768,'ro','LivrÄƒri parÅ£iale & plin',0),(495624,13768,'et','Osaline & tÃ¤ielikku saadetiste',0),(495625,13768,'si','Delno & polno poÅ¡iljk',0),(495626,13768,'ba','Pengiriman parsial & penuh',0),(495627,13768,'nl','Gedeeltelijke & volledige verzendingen',0),(495628,13768,'fi','Osittainen & koko siirrot',0),(495629,13768,'no','Delvis & Full forsendelser',0),(495630,13768,'da','Delvis & fuld forsendelser',0),(495631,13768,'ko','ë¶€ë¶„ & ì „ì²´ ì¶œí•˜ ëŸ‰',0),(495632,13768,'he','×ž×©×œ×•×—×™× ×—×œ×§×™×™× & ×ž×œ×',0),(495633,13768,'el','ÎœÎµÏÎ¹ÎºÎ® & Ï€Î»Î®ÏÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(495634,13768,'zh','éƒ¨åˆ† &amp; å…¨éƒ¨å‡ºè´§',0),(495635,13768,'sv','Partiell & Full transporter',0),(495636,13768,'it','Spedizioni parziali & completa',0),(495637,13768,'tl','',0),(495638,13768,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸šà¸²à¸‡à¸ªà¹ˆà¸§à¸™ & à¹€à¸•à¹‡à¸¡',0),(495639,13768,'hi','à¤†à¤‚à¤¶à¤¿à¤• & à¤ªà¥‚à¤°à¥à¤£ à¤²à¤¦à¤¾à¤¨',0),(495640,13768,'ms','Penghantaran separa & penuh',0),(495641,13768,'ar','Ø´Ø­Ù†Ø§Øª Ø¬Ø²Ø¦ÙŠØ© Ø¢Ù†Ø¯ ÙƒØ§Ù…Ù„',0),(495642,13768,'fr','Livraisons partielles & complets',0),(495643,13768,'jp','éƒ¨åˆ†çš„ãª & å®Œå…¨å‡ºè·',0),(495644,13768,'pt','Embarques parciais & completo',0),(495645,13768,'ru','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾Ðµ & Ð¿Ð¾Ð»Ð½Ð¾Ð¹ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(495646,13768,'es','EnvÃ­os parciales &amp; completo',0),(495647,13768,'de','Partielle & vollstÃ¤ndige Sendungen',0),(495648,13768,'en','Partial & Full Shipments',0),(495649,13769,'is','',0),(495650,13769,'dr','ØªØºÛŒÛŒØ± ÙˆØ¶Ø¹ÛŒØª Ø¨Ù‡ ØªØ­ÙˆÛŒÙ„ Ø¯Ø§Ø¯Ù‡',0),(495651,13769,'pr','ØªØºÛŒÛŒØ± ÙˆØ¶Ø¹ÛŒØª Ø¨Ù‡ ØªØ­ÙˆÛŒÙ„ Ø¯Ø§Ø¯Ù‡',0),(495652,13769,'tr','Teslim durumu DeÄŸiÅŸtir',0),(495653,13769,'pl','Zmiana stanu nie dostarczone',0),(495654,13769,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²ÑÑ‚',0),(495655,13769,'ur','Ù†Û Ø­ÙˆØ§Ù„Û’ Ø¬Ø§Ù†Û’ Ú©ÛŒ Ø­Ø§Ù„Øª Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(495656,13769,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð´Ð° Ð½Ð¸Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð°',0),(495657,13769,'vi','Thay Ä‘á»•i tráº¡ng thÃ¡i sáº½ khÃ´ng chuyá»ƒn giao',0),(495658,13769,'af','Verander die Status om nie gelewer',0),(495659,13769,'ro','Schimba Status nu livrate',0),(495660,13769,'et','Muuda olekut ei ole esitanud',0),(495661,13769,'si','Spremeni stanje ni podal',0),(495662,13769,'ba','Mengubah Status tidak disampaikan',0),(495663,13769,'nl','Wijzigingsstatus niet afgeleverd',0),(495664,13769,'fi','Muuta tilaksi toimittamatta',0),(495665,13769,'no','Endre Status ikke leveres',0),(495666,13769,'da','Skift Status til ikke leveret',0),(495667,13769,'ko','í•˜ì§€ ë°°ë‹¬ ìƒíƒœ ë³€ê²½',0),(495668,13769,'he','×©×™× ×•×™ ×¡×˜×˜×•×¡ ×›×“×™ ×œ× ×œ×”×¢×‘×™×¨',0),(495669,13769,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î¼ÎµÏ„Î±Î²Î¿Î»Î®Ï‚ Î½Î± Ï€Î±ÏÎ±Î´Î¯Î´Î¿Î½Ï„Î±Î¹ Î´ÎµÎ½',0),(495670,13769,'zh','å°†çŠ¶æ€æ›´æ”¹ä¸ºæœªé€è¾¾',0),(495671,13769,'sv','Ã„ndra Status som inte levereras',0),(495672,13769,'it','Modifica stato non consegnare',0),(495673,13769,'tl','',0),(495674,13769,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸ªà¸–à¸²à¸™à¸°à¹€à¸›à¹‡à¸™à¹„à¸¡à¹ˆà¸ªà¹ˆà¸‡',0),(495675,13769,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¡à¤¿à¤²à¥€à¤µà¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(495676,13769,'ms','Menukar Status yang tidak dihantar',0),(495677,13769,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø­Ø§Ù„Ø© Ø¹Ø¯Ù… ØªØ³Ù„ÙŠÙ…',0),(495678,13769,'fr','Modifier le statut non livrÃ©s',0),(495679,13769,'jp','é…ä¿¡ã•ã‚Œãªã„ã™ã‚‹ã«ã¯ã€ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã®å¤‰æ›´',0),(495680,13769,'pt','Alterar Status nÃ£o entregues',0),(495681,13769,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑ‚Ð°Ñ‚ÑƒÑ Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½',0),(495682,13769,'es','Cambiar estado a no entregado',0),(495683,13769,'de','Ã„nderungsstand nicht geliefert',0),(495684,13769,'en','Change Status To Not Delivered',0),(495685,13770,'is','',0),(495686,13770,'dr','ØªØ­ÙˆÛŒÙ„',0),(495687,13770,'pr','ØªØ­ÙˆÛŒÙ„',0),(495688,13770,'tr','Teslimatlar',0),(495689,13770,'pl','Dostawy',0),(495690,13770,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(495691,13770,'ur','ÙØ±Ø§ÛÙ…ÛŒ',0),(495692,13770,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(495693,13770,'vi','Viá»‡c giao hÃ ng',0),(495694,13770,'af','Lewerings',0),(495695,13770,'ro','LivrÄƒri',0),(495696,13770,'et','Tarned',0),(495697,13770,'si','Dobave',0),(495698,13770,'ba','Pengiriman',0),(495699,13770,'nl','Leveringen',0),(495700,13770,'fi','Toimitukset',0),(495701,13770,'no','Leveranser',0),(495702,13770,'da','Leverancer',0),(495703,13770,'ko','ë°°ë‹¬',0),(495704,13770,'he','×ž×©×œ×•×—×™×',0),(495705,13770,'el','Î Î±ÏÎ±Î´ÏŒÏƒÎµÎ¹Ï‚',0),(495706,13770,'zh','äº¤ä»˜',0),(495707,13770,'sv','Leveranser',0),(495708,13770,'it','Consegne',0),(495709,13770,'tl','',0),(495710,13770,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(495711,13770,'hi','à¤ªà¥à¤°à¤¸à¤µ',0),(495712,13770,'ms','Penghantaran',0),(495713,13770,'ar','Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(495714,13770,'fr','Livraisons',0),(495715,13770,'jp','é…é”',0),(495716,13770,'pt','Entregas',0),(495717,13770,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(495718,13770,'es','Entregas',0),(495719,13770,'de','Lieferungen',0),(495720,13770,'en','Deliveries',0),(495721,13771,'is','',0),(495722,13771,'dr','ØªØ­ÙˆÛŒÙ„ Ù…ÙˆÙÙ‚ÛŒØª',0),(495723,13771,'pr','ØªØ­ÙˆÛŒÙ„ Ù…ÙˆÙÙ‚ÛŒØª',0),(495724,13771,'tr','DaÄŸÄ±tÄ±m baÅŸarÄ±yla eklendi',0),(495725,13771,'pl','Dostawy dodano pomyÅ›lnie',0),(495726,13771,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(495727,13771,'ur','Ø­ÙˆØ§Ù„Ú¯ÛŒ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(495728,13771,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(495729,13771,'vi','Giao hÃ ng Ä‘Æ°á»£c gá»­i thÃ nh cÃ´ng',0),(495730,13771,'af','Aflewering suksesvol bygevoeg',0),(495731,13771,'ro','Livrare adÄƒugat cu succes',0),(495732,13771,'et','Lisatud tarne',0),(495733,13771,'si','Dostava dodane uspeÅ¡no',0),(495734,13771,'ba','Pengiriman ditambahkan berhasil',0),(495735,13771,'nl','Levering met succes toegevoegd',0),(495736,13771,'fi','Toimitus lisÃ¤Ã¤minen onnistui',0),(495737,13771,'no','Levering lagt',0),(495738,13771,'da','Levering tilfÃ¸jet',0),(495739,13771,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ë‚©í’ˆ',0),(495740,13771,'he','×ž×©×œ×•×— × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(495741,13771,'el','Î Î±ÏÎ¬Î´Î¿ÏƒÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(495742,13771,'zh','å·²æˆåŠŸæ·»åŠ çš„äº¤ä»˜',0),(495743,13771,'sv','Leverans lagts',0),(495744,13771,'it','Consegna aggiunto con successo',0),(495745,13771,'tl','',0),(495746,13771,'th','à¸ªà¹ˆà¸‡à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(495747,13771,'hi','à¤¡à¤¿à¤²à¤¿à¤µà¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(495748,13771,'ms','Penghantaran berjaya menambah',0),(495749,13771,'ar','Ø§Ù„ØªØ³Ù„ÙŠÙ… Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(495750,13771,'fr','Livraison ajoutÃ© avec succÃ¨s',0),(495751,13771,'jp','é…ä¿¡ã‚’æ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(495752,13771,'pt','Entrega adicionada com sucesso',0),(495753,13771,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(495754,13771,'es','Entrega se ha agregado correctamente',0),(495755,13771,'de','Lieferung erfolgreich hinzugefÃ¼gt',0),(495756,13771,'en','Delivery Added Successfully',0),(495757,13772,'is','',0),(495758,13772,'dr','ØªØ§Ø±ÛŒØ® ØªØ­ÙˆÛŒÙ„',0),(495759,13772,'pr','ØªØ§Ø±ÛŒØ® ØªØ­ÙˆÛŒÙ„',0),(495760,13772,'tr','Teslim tarihi',0),(495761,13772,'pl','Data dostawy',0),(495762,13772,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(495763,13772,'ur','Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(495764,13772,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð´Ð¾ÑÑ‚Ð°Ð²Ðµ',0),(495765,13772,'vi','NgÃ y giao hÃ ng',0),(495766,13772,'af','Afleweringsdatum',0),(495767,13772,'ro','Data de livrare',0),(495768,13772,'et','Tarne kuupÃ¤ev',0),(495769,13772,'si','Datum dostave',0),(495770,13772,'ba','Tanggal pengiriman',0),(495771,13772,'nl','Leverdatum',0),(495772,13772,'fi','ToimituspÃ¤ivÃ¤',0),(495773,13772,'no','Leveringsdato',0),(495774,13772,'da','Leveringsdato',0),(495775,13772,'ko','ë°°ë‹¬ ë‚ ì§œ',0),(495776,13772,'he','×ª××¨×™×š ×ž×¡×™×¨×”',0),(495777,13772,'el','Î—Î¼/Î½Î¯Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(495778,13772,'zh','äº¤è´§æ—¥æœŸ',0),(495779,13772,'sv','Leveransdatum',0),(495780,13772,'it','Data di consegna',0),(495781,13772,'tl','',0),(495782,13772,'th','à¸§à¸±à¸™à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(495783,13772,'hi','à¤¡à¤¿à¤²à¥€à¤µà¤°à¥€ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(495784,13772,'ms','Tarikh penghantaran',0),(495785,13772,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(495786,13772,'fr','Date de livraison',0),(495787,13772,'jp','ç´æœŸ',0),(495788,13772,'pt','Data de entrega',0),(495789,13772,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(495790,13772,'es','Fecha de entrega',0),(495791,13772,'de','Liefertermin',0),(495792,13772,'en','Delivery Date',0),(495793,13773,'is','',0),(495794,13773,'dr','ØªØ­ÙˆÛŒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(495795,13773,'pr','ØªØ­ÙˆÛŒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(495796,13773,'tr','DaÄŸÄ±tÄ±m baÅŸarÄ±yla silindi',0),(495797,13773,'pl','Dostawy przesâ”‚anie',0),(495798,13773,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(495799,13773,'ur','Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(495800,13773,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(495801,13773,'vi','Giao hÃ ng táº­n nÆ¡i xÃ³a thÃ nh cÃ´ng',0),(495802,13773,'af','Aflewering Suksesvol Uitgewis',0),(495803,13773,'ro','Livrare eliminÄƒ cu succes',0),(495804,13773,'et','Kohaletoimetamise edukalt kustutatud',0),(495805,13773,'si','Dostava uspeÅ¡no izbrisana',0),(495806,13773,'ba','Pengiriman dihapus berhasil',0),(495807,13773,'nl','Levering met succes verwijderd',0),(495808,13773,'fi','Toimitus poistettu',0),(495809,13773,'no','Levering slettet',0),(495810,13773,'da','Levering slettet',0),(495811,13773,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ ë°°ë‹¬',0),(495812,13773,'he','×ž×©×œ×•×— × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(495813,13773,'el','Î Î±ÏÎ¬Î´Î¿ÏƒÎ· Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(495814,13773,'zh','å·²æˆåŠŸåˆ é™¤çš„äº¤ä»˜',0),(495815,13773,'sv','Leverans raderades',0),(495816,13773,'it','Consegna eliminato con successo',0),(495817,13773,'tl','',0),(495818,13773,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§à¸¥à¸š',0),(495819,13773,'hi','à¤¡à¤¿à¤²à¥€à¤µà¤°à¥€ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(495820,13773,'ms','Penghantaran dihapuskan dengan jayanya',0),(495821,13773,'ar','Ø§Ù„ØªØ³Ù„ÙŠÙ… Ø¨Ù†Ø¬Ø§Ø­ Ø­Ø°Ù',0),(495822,13773,'fr','Prestation supprimÃ©e avec succÃ¨s',0),(495823,13773,'jp','é…ä¿¡ã‚’æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(495824,13773,'pt','Entrega apagada com sucesso',0),(495825,13773,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(495826,13773,'es','Entrega eliminado satisfactoriamente',0),(495827,13773,'de','Lieferung erfolgreich gelÃ¶scht',0),(495828,13773,'en','Delivery Deleted Successfully',0),(495829,13774,'is','',0),(495830,13774,'dr','ØªØ­ÙˆÛŒÙ„ Ø´Ù†Ø§Ø³Ù‡',0),(495831,13774,'pr','ØªØ­ÙˆÛŒÙ„ Ø´Ù†Ø§Ø³Ù‡',0),(495832,13774,'tr','DaÄŸÄ±tÄ±m numarasÄ±',0),(495833,13774,'pl','Identyfikator dostawy',0),(495834,13774,'bg','Ð˜Ð” Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(495835,13774,'ur','Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(495836,13774,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð° Ð˜Ð”',0),(495837,13774,'vi','Gá»­i ID',0),(495838,13774,'af','Aflewerings ID',0),(495839,13774,'ro','Livrare ID',0),(495840,13774,'et','Kohaletoimetamise ID',0),(495841,13774,'si','Dostava ID',0),(495842,13774,'ba','Pengiriman ID',0),(495843,13774,'nl','Oplevering ID',0),(495844,13774,'fi','Toimituksen tunnus',0),(495845,13774,'no','Levering ID',0),(495846,13774,'da','Levering-ID',0),(495847,13774,'ko','ì „ë‹¬ ID',0),(495848,13774,'he','×ž×–×”×” ×ž×©×œ×•×—',0),(495849,13774,'el','Î Î±ÏÎ¬Î´Î¿ÏƒÎ· ID',0),(495850,13774,'zh','ä¼ é€’ ID',0),(495851,13774,'sv','Leverans-ID',0),(495852,13774,'it','ID consegna',0),(495853,13774,'tl','',0),(495854,13774,'th','ID à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(495855,13774,'hi','à¤¡à¤¿à¤²à¤¿à¤µà¤°à¥€ ID',0),(495856,13774,'ms','ID penghantaran',0),(495857,13774,'ar','Ù…Ø¹Ø±Ù Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(495858,13774,'fr','ID de la livraison',0),(495859,13774,'jp','é…ä¿¡ ID',0),(495860,13774,'pt','ID de entrega',0),(495861,13774,'ru','ID Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(495862,13774,'es','Entrega ID',0),(495863,13774,'de','Lieferungs ID',0),(495864,13774,'en','Delivery ID',0),(495865,13775,'is','',0),(495866,13775,'dr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª ØªØ­ÙˆÛŒÙ„',0),(495867,13775,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª ØªØ­ÙˆÛŒÙ„',0),(495868,13775,'tr','Teslimat notlarÄ±',0),(495869,13775,'pl','Dostawy',0),(495870,13775,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(495871,13775,'ur','ÚˆÛŒÙ„ÛŒÙˆØ±ÛŒ Ù†ÙˆÙ¹Ø³',0),(495872,13775,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(495873,13775,'vi','Giao hÃ ng ghi chÃº',0),(495874,13775,'af','Afleweringsnotas',0),(495875,13775,'ro','Note de livrare',0),(495876,13775,'et','Saatelehed',0),(495877,13775,'si','Dobavnicah',0),(495878,13775,'ba','Catatan pengiriman',0),(495879,13775,'nl','Pakbonnen',0),(495880,13775,'fi','Toimitus',0),(495881,13775,'no','Tenkt',0),(495882,13775,'da','FÃ¸lgesedler',0),(495883,13775,'ko','ë°°ë‹¬ ë…¸íŠ¸',0),(495884,13775,'he','×ž×¦×™×™×Ÿ ×ž×©×œ×•×—',0),(495885,13775,'el','Î”ÎµÎ»Ï„Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(495886,13775,'zh','äº¤è´§å•',0),(495887,13775,'sv','FÃ¶ljesedlar',0),(495888,13775,'it','Note di consegna',0),(495889,13775,'tl','',0),(495890,13775,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(495891,13775,'hi','à¤¡à¤¿à¤²à¤¿à¤µà¤°à¥€ à¤¨à¥‹à¤Ÿ',0),(495892,13775,'ms','Nota penghantaran',0),(495893,13775,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(495894,13775,'fr','Bulletins de livraison',0),(495895,13775,'jp','é…é€ãƒŽãƒ¼ãƒˆ',0),(495896,13775,'pt','Notas de entrega',0),(495897,13775,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(495898,13775,'es','Notas de entrega',0),(495899,13775,'de','Lieferscheine',0),(495900,13775,'en','Delivery Notes',0),(495901,13776,'is','',0),(495902,13776,'dr','ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(495903,13776,'pr','ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(495904,13776,'tr','Girilen',0),(495905,13776,'pl','WszedÅ‚',0),(495906,13776,'bg','Ð’Ð¿Ð¸ÑÐ°Ð½Ð¸ Ð²',0),(495907,13776,'ur','Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(495908,13776,'sr','ÐšÐ¾Ñ˜Ð¸ Ñ˜Ðµ ÑƒÐ½ÐµÑ‚ Ñƒ',0),(495909,13776,'vi','VÃ o ngÃ y',0),(495910,13776,'af','Ingeskryf',0),(495911,13776,'ro','Intrat',0),(495912,13776,'et','Kantud',0),(495913,13776,'si','Vpisana',0),(495914,13776,'ba','Masuk pada',0),(495915,13776,'nl','Ingevoerd op',0),(495916,13776,'fi','Tuli',0),(495917,13776,'no','Angitt pÃ¥',0),(495918,13776,'da','Angivet pÃ¥',0),(495919,13776,'ko','ìž…ë ¥ í•œ',0),(495920,13776,'he','× ×›× ×¡×• ×‘',0),(495921,13776,'el','Î†ÏÏ‡Î¹ÏƒÎµ Ï„Î·Î½',0),(495922,13776,'zh','åœ¨è¾“å…¥',0),(495923,13776,'sv','Anges pÃ¥',0),(495924,13776,'it','Entrato il',0),(495925,13776,'tl','',0),(495926,13776,'th','à¸›à¹‰à¸­à¸™à¹ƒà¸™',0),(495927,13776,'hi','à¤ªà¤° à¤¦à¤°à¥à¤œ',0),(495928,13776,'ms','Dimasukkan pada',0),(495929,13776,'ar','Ø¯Ø®Ù„Øª',0),(495930,13776,'fr','EntrÃ© le',0),(495931,13776,'jp','å…¥åŠ›ã•ã‚Œã¾ã—ãŸã€‚',0),(495932,13776,'pt','Entrou',0),(495933,13776,'ru','Ð’ÑÑ‚ÑƒÐ¿Ð¸Ð»',0),(495934,13776,'es','EntrÃ³ el',0),(495935,13776,'de','Getreten ist',0),(495936,13776,'en','Entered On',0),(495937,13777,'is','',0),(495938,13777,'dr','Ø¨ÛŒØ´ØªØ± ØªØ­ÙˆÛŒÙ„ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(495939,13777,'pr','Ø¨ÛŒØ´ØªØ± ØªØ­ÙˆÛŒÙ„ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(495940,13777,'tr','Daha fazla teslimatlar gerekli',0),(495941,13777,'pl','WiÄ™cej dostaw potrzebne',0),(495942,13777,'bg','ÐŸÐ¾Ð²ÐµÑ‡Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ðµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾',0),(495943,13777,'ur','Ù…Ø²ÛŒØ¯ ÙØ±Ø§ÛÙ…ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(495944,13777,'sr','ÐŸÑƒÐ½Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ',0),(495945,13777,'vi','Viá»‡c giao hÃ ng thÃªm cáº§n thiáº¿t',0),(495946,13777,'af','Meer aflewerings benodig',0),(495947,13777,'ro','Mai multe livrÄƒri necesare',0),(495948,13777,'et','Vaja rohkem tarned',0),(495949,13777,'si','VeÄ dobave potrebne',0),(495950,13777,'ba','Pengiriman lain yang diperlukan',0),(495951,13777,'nl','Meer leveringen nodig',0),(495952,13777,'fi','LisÃ¤Ã¤ toimitusten tarvitaan',0),(495953,13777,'no','Flere leveringer nÃ¸dvendig',0),(495954,13777,'da','Flere leverancer nÃ¸dvendige',0),(495955,13777,'ko','ë” ë§Žì€ ë°°ë‹¬ í•„ìš”',0),(495956,13777,'he','×¦×¨×™×š ×¢×•×“ ×ž×©×œ×•×—×™×',0),(495957,13777,'el','Î ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Ï€Î±ÏÎ±Î´ÏŒÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(495958,13777,'zh','éœ€è¦æ›´å¤šçš„åˆ†å¨©',0),(495959,13777,'sv','Fler leveranser behÃ¶vs',0),(495960,13777,'it','Consegne piÃ¹ necessari',0),(495961,13777,'tl','',0),(495962,13777,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸—à¸µà¹ˆà¸ˆà¸³à¹€à¸›à¹‡à¸™',0),(495963,13777,'hi','à¤…à¤§à¤¿à¤• à¤ªà¥à¤°à¤¸à¤µ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(495964,13777,'ms','Lebih banyak penghantaran yang diperlukan',0),(495965,13777,'ar','ØªØ³Ù„ÙŠÙ… Ø£ÙƒØ«Ø± Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰',0),(495966,13777,'fr','Livraisons plus nÃ©cessaires',0),(495967,13777,'jp','å¿…è¦ãªã‚ˆã‚Šå¤šãã®é…é”',0),(495968,13777,'pt','Mais entregas necessÃ¡rias',0),(495969,13777,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ñ‹Ñ…',0),(495970,13777,'es','MÃ¡s entregas necesitadas',0),(495971,13777,'de','Weitere Lieferungen benÃ¶tigt',0),(495972,13777,'en','More Deliveries Needed',0),(495973,13778,'is','',0),(495974,13778,'dr','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(495975,13778,'pr','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(495976,13778,'tr','Girilen hiÃ§bir miktarlarÄ±',0),(495977,13778,'pl','Nie iloÅ›ci wprowadzonych',0),(495978,13778,'bg','ÐÐµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°Ñ‚Ð°, Ð²Ð¿Ð¸ÑÐ°Ð½Ð¸',0),(495979,13778,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø§Ø®Ù„',0),(495980,13778,'sr','ÐÐµÐ¼Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ ÑƒÐ½ÐµÑ‚Ðµ',0),(495981,13778,'vi','KhÃ´ng cÃ³ sá»‘ lÆ°á»£ng nháº­p',0),(495982,13778,'af','Geen hoeveelhede ingetik',0),(495983,13778,'ro','Nici cantitÄƒÅ£ilor Ã®nscrise',0),(495984,13778,'et','Ei ole lubatud kogused',0),(495985,13778,'si','Ni vnesenih koliÄin',0),(495986,13778,'ba','Tidak ada jumlah yang memasuki',0),(495987,13778,'nl','Geen productiequotumattesten vermelde hoeveelheden',0),(495988,13778,'fi','Luovutetut mÃ¤Ã¤rÃ¤t',0),(495989,13778,'no','Ingen antallene som er angitt',0),(495990,13778,'da','Ingen mÃ¦ngder angivet',0),(495991,13778,'ko','ì•„ë‹ˆ ìˆ˜ëŸ‰ ìž…ë ¥',0),(495992,13778,'he','××™×Ÿ ×›×ž×•×™×•×ª × ×›× ×¡×•',0),(495993,13778,'el','Î”ÎµÎ½ Ï€Î¿ÏƒÎ¿Ï„Î®Ï„Ï‰Î½ Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ ÎµÎ³Î³ÎµÎ³ÏÎ±Î¼Î¼Î­Î½ÎµÏ‚',0),(495994,13778,'zh','æ²¡æœ‰è¾“å…¥çš„æ•°é‡',0),(495995,13778,'sv','Inga kvantiteter anges',0),(495996,13778,'it','No quantitativi iscritti',0),(495997,13778,'tl','',0),(495998,13778,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹„à¸¡à¹ˆà¸›à¹‰à¸­à¸™',0),(495999,13778,'hi','à¤•à¥‹à¤ˆ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(496000,13778,'ms','Tiada kuantiti yang dimasukkan',0),(496001,13778,'ar','Ù„Ø§ Ø§Ù„ÙƒÙ…ÙŠØ§Øª Ø§Ù„ØªÙŠ Ø¯Ø®Ù„Øª',0),(496002,13778,'fr','Aucune quantitÃ© entrÃ©e',0),(496003,13778,'jp','ãªã„æ•°é‡å…¥åŠ›',0),(496004,13778,'pt','NÃ£o hÃ¡ quantidades inseridas',0),(496005,13778,'ru','ÐÐµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»',0),(496006,13778,'es','No hay cantidades estipuladas',0),(496007,13778,'de','Keine Mengen eingegeben',0),(496008,13778,'en','No Quantities Entered',0),(496009,13779,'is','',0),(496010,13779,'dr','Ú†Ø§Ù¾ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(496011,13779,'pr','Ú†Ø§Ù¾ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(496012,13779,'tr','KullanÄ±labilir yazdÄ±rma yok',0),(496013,13779,'pl','Drukowanie nie dostÄ™pna',0),(496014,13779,'bg','ÐÐµ Ð¿ÐµÑ‡Ð°Ñ‚ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸',0),(496015,13779,'ur','Ø·Ø¨Ø§Ø¹Øª Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº',0),(496016,13779,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½',0),(496017,13779,'vi','In áº¥n khÃ´ng cÃ³ sáºµn',0),(496018,13779,'af','Druk nie beskikbaar nie',0),(496019,13779,'ro','Imprimarea nu disponibile',0),(496020,13779,'et','Printimine pole saadaval',0),(496021,13779,'si','Tiskanje ni na voljo',0),(496022,13779,'ba','Percetakan tidak tersedia',0),(496023,13779,'nl','Afdrukken niet beschikbaar',0),(496024,13779,'fi','Tulostaminen ei ole kÃ¤ytettÃ¤vissÃ¤',0),(496025,13779,'no','Utskrift ikke tilgjengelig',0),(496026,13779,'da','Udskrivning ikke tilgÃ¦ngelig',0),(496027,13779,'ko','í”„ë¦°íŠ¸ ê°€ëŠ¥',0),(496028,13779,'he','×”×“×¤×¡×” ×œ× ×–×ž×™×Ÿ',0),(496029,13779,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î·',0),(496030,13779,'zh','æ— æ³•æ‰“å°å¯ç”¨',0),(496031,13779,'sv','Utskrift inte tillgÃ¤nglig',0),(496032,13779,'it','Stampa non disponibile',0),(496033,13779,'tl','',0),(496034,13779,'th','à¸žà¸´à¸¡à¸žà¹Œà¹„à¸¡à¹ˆà¸¡à¸µ',0),(496035,13779,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚',0),(496036,13779,'ms','Percetakan tidak disediakan',0),(496037,13779,'ar','Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© ØºÙŠØ± Ù…ØªÙˆÙØ±Ø©',0),(496038,13779,'fr','Impression non disponible',0),(496039,13779,'jp','åˆ©ç”¨ã§ãã‚‹å°åˆ·ã•ã‚Œã¾ã›ã‚“ã€‚',0),(496040,13779,'pt','ImpressÃ£o nÃ£o disponÃ­vel',0),(496041,13779,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð½Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹',0),(496042,13779,'es','ImpresiÃ³n no disponible',0),(496043,13779,'de','Drucken nicht verfÃ¼gbar',0),(496044,13779,'en','Printing Not Available',0),(496045,13780,'is','',0),(496046,13780,'dr','Ù‚Ø¨Ù„ Ø§Ø² ØªØ­ÙˆÛŒÙ„',0),(496047,13780,'pr','Ù‚Ø¨Ù„ Ø§Ø² ØªØ­ÙˆÛŒÙ„',0),(496048,13780,'tr','Ã–nceden teslim',0),(496049,13780,'pl','Dostarczone przed',0),(496050,13780,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð¸',0),(496051,13780,'ur','Ø­ÙˆØ§Ù„Û’ Ø³Û’ Ù¾ÛÙ„Û’',0),(496052,13780,'sr','Ð˜Ð³ÑƒÐ¼Ð°Ð½ Ñ˜Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ð¸Ð¾',0),(496053,13780,'vi','TrÆ°á»›c khi gá»­i',0),(496054,13780,'af','Vooraf gelewer',0),(496055,13780,'ro','Prealabil livrate',0),(496056,13780,'et','Eelnevalt on esitatud',0),(496057,13780,'si','Predhodno podano',0),(496058,13780,'ba','Sebelumnya disampaikan',0),(496059,13780,'nl','Voorafgaande geleverd',0),(496060,13780,'fi','EtukÃ¤teen annettu',0),(496061,13780,'no','Tidligere levert',0),(496062,13780,'da','ForudgÃ¥ende leveret',0),(496063,13780,'ko','ì‚¬ì „ ì „ë‹¬',0),(496064,13780,'he','×¨××© ×”×ž× ×–×¨ ×ž×•×¢×‘×¨×™×',0),(496065,13780,'el','Î ÏÎ¹Î½ Ï€Î±ÏÎ±Î´Î¿Î¸ÎµÎ¯',0),(496066,13780,'zh','äº‹å…ˆäº¤ä»˜',0),(496067,13780,'sv','Tidigare levererade',0),(496068,13780,'it','Priore consegnato',0),(496069,13780,'tl','',0),(496070,13780,'th','à¸à¹ˆà¸­à¸™à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(496071,13780,'hi','à¤ªà¥à¤°à¤¾à¤¯à¤° à¤µà¤¿à¤¤à¤°à¤¿à¤¤',0),(496072,13780,'ms','Sebelum dihantar',0),(496073,13780,'ar','Ù‚Ø¨Ù„ ØªØ³Ù„ÙŠÙ…Ù‡Ø§',0),(496074,13780,'fr','Avant le prononcÃ©',0),(496075,13780,'jp','å‰ã«é…ä¿¡',0),(496076,13780,'pt','Antes da entrega',0),(496077,13780,'ru','Ð Ð°Ð½ÐµÐµ Ð´Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½',0),(496078,13780,'es','Antes de entrega',0),(496079,13780,'de','Vorherige geliefert',0),(496080,13780,'en','Prior Delivered',0),(496081,13781,'is','',0),(496082,13781,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø§ÛŒÙ† ØªØ­ÙˆÛŒÙ„',0),(496083,13781,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø§ÛŒÙ† ØªØ­ÙˆÛŒÙ„',0),(496084,13781,'tr','Miktar bu teslimat',0),(496085,13781,'pl','IloÅ›Ä‡ tej dostawy',0),(496086,13781,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ‚Ð°Ð·Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(496087,13781,'ur','Ù‚ÛŒ Ø§Ø³ Ø­ÙˆØ§Ù„Ú¯ÛŒ',0),(496088,13781,'sr','ÐžÐ²Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(496089,13781,'vi','Qty giao hÃ ng nÃ y',0),(496090,13781,'af','Qty hierdie aflewering',0),(496091,13781,'ro','Cantit aceastÄƒ livrare',0),(496092,13781,'et','Kogus Ã¼leandmine',0),(496093,13781,'si','KoliÄina tega dostave',0),(496094,13781,'ba','Qty pengiriman ini',0),(496095,13781,'nl','Aantal deze levering',0),(496096,13781,'fi','MÃ¤Ã¤rÃ¤ toimitus',0),(496097,13781,'no','Antall denne levering',0),(496098,13781,'da','Antal denne levering',0),(496099,13781,'ko','ìˆ˜ëŸ‰ì´ì´ ë°°ë‹¬',0),(496100,13781,'he','×›×ž×•×ª ×”×ž×©×œ×•×— ×”×–×”',0),(496101,13781,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Ï…Ï„Î® Ï„Î·Î½ Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·',0),(496102,13781,'zh','è¿™äº¤è´§æ•°é‡',0),(496103,13781,'sv','Antal denna leverans',0),(496104,13781,'it','Q. tÃ  questa consegna',0),(496105,13781,'tl','',0),(496106,13781,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸™à¸µà¹‰',0),(496107,13781,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤‡à¤¸ à¤¡à¤¿à¤²à¥€à¤µà¤°à¥€',0),(496108,13781,'ms','Qty penghantaran ini',0),(496109,13781,'ar','Qty Ù‡Ø°Ø§ Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(496110,13781,'fr','Qty cette livraison',0),(496111,13781,'jp','Qty ã“ã®é…ä¿¡',0),(496112,13781,'pt','Qty esta entrega',0),(496113,13781,'ru','ÐšÐ¾Ð»-Ð²Ð¾ ÑÑ‚Ð¾Ð¹ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(496114,13781,'es','Qty esta entrega',0),(496115,13781,'de','Menge: diese Lieferung',0),(496116,13781,'en','Qty This Delivery',0),(496117,13782,'is','',0),(496118,13782,'dr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± ØªØ­ÙˆÛŒÙ„',0),(496119,13782,'pr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± ØªØ­ÙˆÛŒÙ„',0),(496120,13782,'tr','Teslimat Kaydet',0),(496121,13782,'pl','Zapisz dostawy',0),(496122,13782,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(496123,13782,'ur','Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú©Ùˆ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(496124,13782,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð´Ð¾ÑÑ‚Ð°Ð²Ð°',0),(496125,13782,'vi','Tiáº¿t kiá»‡m cung cáº¥p',0),(496126,13782,'af','Stoor aflewering',0),(496127,13782,'ro','SalvaÅ£i de livrare',0),(496128,13782,'et','Salvesta tarne',0),(496129,13782,'si','Shranite dostave',0),(496130,13782,'ba','Menyimpan pengiriman',0),(496131,13782,'nl','Opslaan van levering',0),(496132,13782,'fi','Tallenna toimitus',0),(496133,13782,'no','Lagre levering',0),(496134,13782,'da','Spar levering',0),(496135,13782,'ko','ì €ìž¥ ë°°ë‹¬',0),(496136,13782,'he','×œ×”×¦×™×œ ××ª ×”×ž×¡×™×¨×”',0),(496137,13782,'el','Î£ÏŽÏƒÎµÎ¹ Ï„Î·Î½ Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·',0),(496138,13782,'zh','ä¿å­˜äº¤è´§',0),(496139,13782,'sv','Spara leverans',0),(496140,13782,'it','Salvare la consegna',0),(496141,13782,'tl','',0),(496142,13782,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(496143,13782,'hi','à¤¡à¤¿à¤²à¤¿à¤µà¤°à¥€ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(496144,13782,'ms','Simpan penghantaran',0),(496145,13782,'ar','Ø­ÙØ¸ Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(496146,13782,'fr','Sauver la livraison',0),(496147,13782,'jp','é…ä¿¡ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(496148,13782,'pt','Salvar entrega',0),(496149,13782,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(496150,13782,'es','Guardar entrega',0),(496151,13782,'de','Sichern Lieferung',0),(496152,13782,'en','Save Delivery',0),(496153,13783,'is','',0),(496154,13783,'dr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ØªØºÛŒÛŒØ± ÙˆØ¶Ø¹ÛŒØª',0),(496155,13783,'pr','Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ØªØºÛŒÛŒØ± ÙˆØ¶Ø¹ÛŒØª',0),(496156,13783,'tr','Durum baÅŸarÄ±yla deÄŸiÅŸtirildi',0),(496157,13783,'pl','Stan zostaÅ‚ zmieniony pomyÅ›lnie',0),(496158,13783,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(496159,13783,'ur','Ø­Ø§Ù„Øª Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(496160,13783,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½',0),(496161,13783,'vi','TÃ¬nh tráº¡ng thay Ä‘á»•i thÃ nh cÃ´ng',0),(496162,13783,'af','Status verander suksesvol',0),(496163,13783,'ro','Statutul de schimbat cu succes',0),(496164,13783,'et','Olekuks on seatud edukalt',0),(496165,13783,'si','Stanje spremenjeno uspeÅ¡no',0),(496166,13783,'ba','Status berubah berhasil',0),(496167,13783,'nl','Status met succes gewijzigd',0),(496168,13783,'fi','Tila muutettu',0),(496169,13783,'no','Statusen endret',0),(496170,13783,'da','Status er Ã¦ndret med succes',0),(496171,13783,'ko','ì„±ê³µì ìœ¼ë¡œ ë³€ê²½ ëœ ìƒíƒœ',0),(496172,13783,'he','×”×ž×¦×‘ ×”×©×ª× ×” ×‘×”×¦×œ×—×”',0),(496173,13783,'el','Î— ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î¬Î»Î»Î±Î¾Îµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(496174,13783,'zh','å·²æˆåŠŸæ›´æ”¹çŠ¶æ€',0),(496175,13783,'sv','Status Ã¤ndrats framgÃ¥ngsrikt',0),(496176,13783,'it','Stato modificato con successo',0),(496177,13783,'tl','',0),(496178,13783,'th','à¸ªà¸–à¸²à¸™à¸°à¸–à¸¹à¸à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(496179,13783,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(496180,13783,'ms','Berjaya diubah status',0),(496181,13783,'ar','Ø§Ù„Ø­Ø§Ù„Ø© ØªØºÙŠØ±Øª Ø¨Ù†Ø¬Ø§Ø­',0),(496182,13783,'fr','Statut changÃ© avec succÃ¨s',0),(496183,13783,'jp','çŠ¶æ…‹ãŒæ­£å¸¸ã«å¤‰æ›´ã•ã‚Œã¾ã—ãŸ',0),(496184,13783,'pt','Status alterado com sucesso',0),(496185,13783,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½',0),(496186,13783,'es','Estado cambiado correctamente',0),(496187,13783,'de','StatusÃ¤nderung erfolgreich',0),(496188,13783,'en','Status Changed Successfully',0),(496189,13784,'is','',0),(496190,13784,'dr','ØªØ­ÙˆÛŒÙ„ ØªÚ©Ù…ÛŒÙ„',0),(496191,13784,'pr','ØªØ­ÙˆÛŒÙ„ ØªÚ©Ù…ÛŒÙ„',0),(496192,13784,'tr','Teslimatlar tamamlanmÄ±ÅŸ',0),(496193,13784,'pl','Dostawy zakoÅ„czone',0),(496194,13784,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½',0),(496195,13784,'ur','Ù…Ú©Ù…Ù„ ÙØ±Ø§ÛÙ…ÛŒ',0),(496196,13784,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð·Ð°Ð²Ñ€ÑˆÐµÐ½Ð°',0),(496197,13784,'vi','Viá»‡c giao hÃ ng hoÃ n thÃ nh',0),(496198,13784,'af','Lewerings voltooi',0),(496199,13784,'ro','LivrÄƒrile realizate',0),(496200,13784,'et','LÃµpetanud tarned',0),(496201,13784,'si','Dobave, ki so zakljuÄili',0),(496202,13784,'ba','Pengiriman selesai',0),(496203,13784,'nl','Leveringen voltooid',0),(496204,13784,'fi','Toimitukset, valmis',0),(496205,13784,'no','Leveranser fullfÃ¸rt',0),(496206,13784,'da','Leverancer gennemfÃ¸rt',0),(496207,13784,'ko','ë°°ë‹¬ ì™„ë£Œ',0),(496208,13784,'he','×ž×©×œ×•×—×™× ×”×•×©×œ×ž×”',0),(496209,13784,'el','Î Î±ÏÎ±Î´ÏŒÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(496210,13784,'zh','äº¤ä»˜å®Œæ¯•',0),(496211,13784,'sv','Leveranser klar',0),(496212,13784,'it','Consegne completate',0),(496213,13784,'tl','',0),(496214,13784,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(496215,13784,'hi','à¤ªà¥à¤°à¤¸à¤µ à¤ªà¥‚à¤°à¥à¤£',0),(496216,13784,'ms','Siap penghantaran',0),(496217,13784,'ar','Ø§Ù„ÙˆÙ„Ø§Ø¯Ø§Øª Ø§Ù„ØªÙŠ Ø£Ù†Ø¬Ø²Øª',0),(496218,13784,'fr','Livraisons terminÃ©s',0),(496219,13784,'jp','é…é”å®Œäº†',0),(496220,13784,'pt','Entregas concluÃ­das',0),(496221,13784,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð°',0),(496222,13784,'es','Entregas completadas',0),(496223,13784,'de','Lieferungen abgeschlossen',0),(496224,13784,'en','Deliveries Completed',0),(496225,13785,'is','',0),(496226,13785,'dr','ØªØ­ÙˆÛŒÙ„ Ø§Ù†ØªØ¸Ø§Ø±',0),(496227,13785,'pr','ØªØ­ÙˆÛŒÙ„ Ø§Ù†ØªØ¸Ø§Ø±',0),(496228,13785,'tr','Teslimatlar bekleyen',0),(496229,13785,'pl','Dostawy do czasu',0),(496230,13785,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð¾',0),(496231,13785,'ur','ÙØ±Ø§ÛÙ…ÛŒ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(496232,13785,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð° Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(496233,13785,'vi','Viá»‡c giao hÃ ng Ä‘ang chá» giáº£i quyáº¿t',0),(496234,13785,'af','Lewerings hangende',0),(496235,13785,'ro','LivrÄƒri Ã®n aÅŸteptarea',0),(496236,13785,'et','Tarned kuni',0),(496237,13785,'si','Dobave do',0),(496238,13785,'ba','Pengiriman tertunda',0),(496239,13785,'nl','Leveringen in afwachting van',0),(496240,13785,'fi','Toimitukset ennen',0),(496241,13785,'no','Leveranser venter',0),(496242,13785,'da','Leverancer indtil',0),(496243,13785,'ko','ë°°ì†¡ ë³´ë¥˜',0),(496244,13785,'he','×ž×©×œ×•×—×™× ×‘×”×ž×ª× ×”',0),(496245,13785,'el','Î Î±ÏÎ±Î´ÏŒÏƒÎµÎ¹Ï‚, ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î®',0),(496246,13785,'zh','æŒ‚èµ·çš„äº¤ä»˜',0),(496247,13785,'sv','Leveranser i avvaktan',0),(496248,13785,'it','Consegne in attesa',0),(496249,13785,'tl','',0),(496250,13785,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(496251,13785,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤ªà¥à¤°à¤¸à¤µ',0),(496252,13785,'ms','Penghantaran yang belum selesai',0),(496253,13785,'ar','Ø´Ø­Ù†Ø§Øª Ù…Ø¹Ù„Ù‚Ø©',0),(496254,13785,'fr','Livraisons en attente',0),(496255,13785,'jp','ä¿ç•™ä¸­ã®é…é”',0),(496256,13785,'pt','Entregas pendentes',0),(496257,13785,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð² Ð¾Ð¶Ð¸Ð´Ð°Ð½Ð¸Ð¸',0),(496258,13785,'es','Entregas pendientes',0),(496259,13785,'de','Ausstehende Lieferungen',0),(496260,13785,'en','Deliveries Pending',0),(496261,13786,'is','',0),(496262,13786,'dr','ØªØ­ÙˆÛŒÙ„',0),(496263,13786,'pr','ØªØ­ÙˆÛŒÙ„',0),(496264,13786,'tr','Teslim',0),(496265,13786,'pl','Dostarczane',0),(496266,13786,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð¸',0),(496267,13786,'ur','Ø­ÙˆØ§Ù„Û',0),(496268,13786,'sr','Ð”Ð¾ÑÑ‚Ð°Ð²Ð¸Ð¾',0),(496269,13786,'vi','Chuyá»ƒn giao',0),(496270,13786,'af','Gelewer',0),(496271,13786,'ro','Livrate',0),(496272,13786,'et','On esitatud',0),(496273,13786,'si','Podal',0),(496274,13786,'ba','Disampaikan',0),(496275,13786,'nl','Geleverd',0),(496276,13786,'fi','Toimitetaan',0),(496277,13786,'no','Levert',0),(496278,13786,'da','Leveret',0),(496279,13786,'ko','ë°°ë‹¬',0),(496280,13786,'he','×ž×©×œ×•×—',0),(496281,13786,'el','Î Î±ÏÎ±Î´Î¯Î´Î¿Î½Ï„Î±Î¹',0),(496282,13786,'zh','äº¤ä»˜',0),(496283,13786,'sv','Levereras',0),(496284,13786,'it','Consegnato',0),(496285,13786,'tl','',0),(496286,13786,'th','à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(496287,13786,'hi','à¤µà¤¿à¤¤à¤°à¤¿à¤¤',0),(496288,13786,'ms','Dihantar',0),(496289,13786,'ar','ØªØ³Ù„ÙŠÙ…',0),(496290,13786,'fr','LivrÃ©',0),(496291,13786,'jp','é…ä¿¡',0),(496292,13786,'pt','Entregue',0),(496293,13786,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¾',0),(496294,13786,'es','Entregado',0),(496295,13786,'de','Geliefert',0),(496296,13786,'en','Delivered',0),(496297,13787,'is','',0),(496298,13787,'dr','ÙˆØ¶Ø¹ÛŒØª ØªØ­ÙˆÛŒÙ„',0),(496299,13787,'pr','ÙˆØ¶Ø¹ÛŒØª ØªØ­ÙˆÛŒÙ„',0),(496300,13787,'tr','Teslimat durumu',0),(496301,13787,'pl','Stan dostawy',0),(496302,13787,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð¿Ñ€Ð°Ñ‚ÐºÐ°',0),(496303,13787,'ur','Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú©ÛŒÙÛŒØª',0),(496304,13787,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(496305,13787,'vi','Tráº¡ng thÃ¡i gá»­i',0),(496306,13787,'af','Afleweringsstatus',0),(496307,13787,'ro','Starea livrÄƒrii',0),(496308,13787,'et','Kohaletoimetamise seisund',0),(496309,13787,'si','Stanje dostave',0),(496310,13787,'ba','Status pengiriman',0),(496311,13787,'nl','Leveringsstatus',0),(496312,13787,'fi','LÃ¤hetyksen tila',0),(496313,13787,'no','Leveringsstatus',0),(496314,13787,'da','Leveringsstatus',0),(496315,13787,'ko','ë°°ë‹¬ ìƒíƒœ',0),(496316,13787,'he','×¡×˜×˜×•×¡ ×ž×©×œ×•×—',0),(496317,13787,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(496318,13787,'zh','äº¤è´§çŠ¶æ€',0),(496319,13787,'sv','Leveransstatus',0),(496320,13787,'it','Condizione di consegna',0),(496321,13787,'tl','',0),(496322,13787,'th','à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(496323,13787,'hi','à¤¡à¤¿à¤²à¥€à¤µà¤°à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(496324,13787,'ms','Status penghantaran',0),(496325,13787,'ar','Ø­Ø§Ù„Ø© Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(496326,13787,'fr','Ã‰tat de livraison',0),(496327,13787,'jp','é…ä¿¡ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(496328,13787,'pt','Status de entrega',0),(496329,13787,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(496330,13787,'es','Estado de entrega',0),(496331,13787,'de','Lieferstatus',0),(496332,13787,'en','Delivery Status',0),(496333,13788,'is','',0),(496334,13788,'dr','ØªØ­ÙˆÛŒÙ„ Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡',0),(496335,13788,'pr','ØªØ­ÙˆÛŒÙ„ Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡',0),(496336,13788,'tr','Teslim edilmeyen',0),(496337,13788,'pl','Nie dostarczone',0),(496338,13788,'bg','ÐÐµ ÑÐ° Ð´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð¸',0),(496339,13788,'ur','Ù†Ø§ Ø³Ù¾Ø±Ø¯ Ú©Ø±Ø¯Û',0),(496340,13788,'sr','ÐÐ¸Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¾',0),(496341,13788,'vi','Giao hÃ ng',0),(496342,13788,'af','Nie gelewer',0),(496343,13788,'ro','Nu emis',0),(496344,13788,'et','Tarnimata',0),(496345,13788,'si','Ni podal',0),(496346,13788,'ba','Tidak disampaikan',0),(496347,13788,'nl','Niet afgeleverd',0),(496348,13788,'fi','Ole antanut',0),(496349,13788,'no','Ikke levert',0),(496350,13788,'da','Ikke leverede',0),(496351,13788,'ko','ë°°ë‹¬ ë˜ì§€ ì•ŠëŠ”ë‹¤',0),(496352,13788,'he','××™×Ÿ ×œ×ž×¡×•×¨',0),(496353,13788,'el','Î Î±ÏÎ±Î´Î¿Î¸ÎµÎ¯Ï‚',0),(496354,13788,'zh','æœªé€è¾¾',0),(496355,13788,'sv','Inte-levererad',0),(496356,13788,'it','Non consegnati',0),(496357,13788,'tl','',0),(496358,13788,'th','à¹„à¸¡à¹ˆà¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(496359,13788,'hi','à¤¡à¤¿à¤²à¥€à¤µà¤° à¤¨à¤¹à¥€à¤‚',0),(496360,13788,'ms','Tidak dihantar',0),(496361,13788,'ar','Ù„Ù… ÙŠØªÙ… ØªØ³Ù„ÙŠÙ…Ù‡Ø§',0),(496362,13788,'fr','Non livrÃ©es',0),(496363,13788,'jp','é…ä¿¡ã•ã‚Œã¾ã›ã‚“ã€‚',0),(496364,13788,'pt','NÃ£o entregue',0),(496365,13788,'ru','ÐÐµ Ð´Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¾',0),(496366,13788,'es','No entregado',0),(496367,13788,'de','Nicht geliefert',0),(496368,13788,'en','Not Delivered',0),(496369,13789,'is','',0),(496370,13789,'dr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ ØªØ­ÙˆÛŒÙ„',0),(496371,13789,'pr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ ØªØ­ÙˆÛŒÙ„',0),(496372,13789,'tr','Teslimat notu',0),(496373,13789,'pl','WysyÅ‚kowej',0),(496374,13789,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ°Ñ‚Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(496375,13789,'ur','Ø­ÙˆØ§Ù„Ú¯ÛŒ Ù†ÙˆÙ¹',0),(496376,13789,'sr','ÐŸÐ¾Ð¿Ð¸ÑÐ½Ð¾Ð¼',0),(496377,13789,'vi','LÆ°u Ã½ giao hÃ ng',0),(496378,13789,'af','Afleweringsnota',0),(496379,13789,'ro','Nota de livrare',0),(496380,13789,'et','Saatelehele',0),(496381,13789,'si','Dobavnico',0),(496382,13789,'ba','Pengiriman Catatan',0),(496383,13789,'nl','Pakbon',0),(496384,13789,'fi','LÃ¤hetysluettelo',0),(496385,13789,'no','Leveringsmerknad',0),(496386,13789,'da','FÃ¸lgeseddel',0),(496387,13789,'ko','ë‚©í’ˆ',0),(496388,13789,'he','×ª×¢×•×“×ª ×ž×¡×™×¨×”',0),(496389,13789,'el','Î”ÎµÎ»Ï„Î¯Î¿ Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(496390,13789,'zh','é€è´§å•',0),(496391,13789,'sv','FÃ¶ljesedel',0),(496392,13789,'it','Nota di consegna',0),(496393,13789,'tl','',0),(496394,13789,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(496395,13789,'hi','à¤¡à¤¿à¤²à¤¿à¤µà¤°à¥€ à¤¨à¥‹à¤Ÿ',0),(496396,13789,'ms','Nota penghantaran',0),(496397,13789,'ar','Ù…Ø°ÙƒØ±Ø© Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(496398,13789,'fr','Bordereau de livraison',0),(496399,13789,'jp','é…é€ãƒŽãƒ¼ãƒˆ',0),(496400,13789,'pt','Nota de entrega',0),(496401,13789,'ru','ÐÐ°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(496402,13789,'es','Nota de entrega',0),(496403,13789,'de','Lieferschein',0),(496404,13789,'en','Delivery Note',0),(496405,13790,'is','',0),(496406,13790,'dr','Ø§Ø¹Ù„Ø§Ù† Ù‡Ø§ÛŒ Ø¹Ù„ÛŒØ±Ø¶Ø§',0),(496407,13790,'pr','Ø§Ø¹Ù„Ø§Ù† Ù‡Ø§ÛŒ Ø¹Ù„ÛŒØ±Ø¶Ø§',0),(496408,13790,'tr','AR bildirimleri',0),(496409,13790,'pl','AR powiadomienia',0),(496410,13790,'bg','AR Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ñ',0),(496411,13790,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(496412,13790,'sr','ÐÐ  Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ°',0),(496413,13790,'vi','AR thÃ´ng bÃ¡o',0),(496414,13790,'af','AR kennisgewings',0),(496415,13790,'ro','AR notificÄƒri',0),(496416,13790,'et','AR teated',0),(496417,13790,'si','AR obvestila',0),(496418,13790,'ba','AR pemberitahuan',0),(496419,13790,'nl','AR meldingen',0),(496420,13790,'fi','AR ilmoitukset',0),(496421,13790,'no','AR varsler',0),(496422,13790,'da','AR anmeldelser',0),(496423,13790,'ko','ì•„ì¹¸ì†Œ ì•Œë¦¼',0),(496424,13790,'he','AR ×”×•×“×¢×•×ª',0),(496425,13790,'el','AR ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚',0),(496426,13790,'zh','åº”æ”¶å¸æ¬¾çš„é€šçŸ¥',0),(496427,13790,'sv','AR anmÃ¤lningar',0),(496428,13790,'it','Notifiche di AR',0),(496429,13790,'tl','',0),(496430,13790,'th','à¹à¸ˆà¹‰à¸‡à¹€à¸•à¸·à¸­à¸™ AR',0),(496431,13790,'hi','AR à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤',0),(496432,13790,'ms','Pemberitahuan AR',0),(496433,13790,'ar','Ø¥Ø¹Ù„Ø§Ù…Ø§Øª AR',0),(496434,13790,'fr','Notifications de l\'AR',0),(496435,13790,'jp','AR ã®é€šçŸ¥',0),(496436,13790,'pt','NotificaÃ§Ãµes de AR',0),(496437,13790,'ru','AR ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(496438,13790,'es','Notificaciones de AR',0),(496439,13790,'de','AR-Benachrichtigungen',0),(496440,13790,'en','AR Notifications',0),(496441,13791,'is','',0),(496442,13791,'dr','Ø¬Ù‡Øª Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¬Ø²Ø¦ÛŒØ§Øª Ù‡Ø± Ø§Ø¹Ù„Ø§Ù† Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(496443,13791,'pr','Ø¬Ù‡Øª Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¬Ø²Ø¦ÛŒØ§Øª Ù‡Ø± Ø§Ø¹Ù„Ø§Ù† Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(496444,13791,'tr','Her bildirim iÃ§in ayrÄ±ntÄ±larÄ± gÃ¶rÃ¼ntÃ¼le\'yi tÄ±klatÄ±n',0),(496445,13791,'pl','Kliknij kaÅ¼de zgÅ‚oszenie do widoku szczegÃ³Å‚Ã³w',0),(496446,13791,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð²ÑÑÐºÐ° Ð½Ð¾Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(496447,13791,'ur','ÛØ± Ø§ÛŒÚ© Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹ Ù…Ù†Ø¸Ø± Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(496448,13791,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° ÑÐ²Ð°ÐºÐ¸ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµ Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð´ÐµÑ‚Ð°Ñ™Ð°',0),(496449,13791,'vi','Báº¥m vÃ o má»—i thÃ´ng bÃ¡o Ä‘á»ƒ xem chi tiáº¿t',0),(496450,13791,'af','Klik op elke kennisgewing aan bekyk Details',0),(496451,13791,'ro','FaceÅ£i clic pe fiecare notificare sÄƒ Vezi detalii',0),(496452,13791,'et','KlÃµpsake iga teatise Ã¼ksikasjade vaatamine',0),(496453,13791,'si','Kliknite posamezno obvestilo za ogled podrobnosti',0),(496454,13791,'ba','Klik setiap pemberitahuan untuk Lihat rincian',0),(496455,13791,'nl','Klik op elke kennisgeving aan Details bekijken',0),(496456,13791,'fi','Valitse kustakin ilmoituksesta tarkasteleminen',0),(496457,13791,'no','Klikk hver melding til visningsdetaljer',0),(496458,13791,'da','Klik pÃ¥ hver notifikation at Vis detaljer',0),(496459,13791,'ko','ê° ì•Œë¦¼ ì„¸ë¶€ ì •ë³´ ë³´ê¸°ë¥¼ í´ë¦­',0),(496460,13791,'he','×œ×—×¥ ×¢×œ ×›×œ ×”×•×“×¢×” ×¢×œ ×”×¦×’×ª ×¤×¨×˜×™×',0),(496461,13791,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® Î ÏÎ¿Î²Î¿Î»Î® Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½ ÎºÎ¬Î¸Îµ ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(496462,13791,'zh','å•å‡»æ¯ä¸ªæŸ¥çœ‹è¯¦æƒ…çš„é€šçŸ¥',0),(496463,13791,'sv','Klicka pÃ¥ varje anmÃ¤lan till Visa Detaljer',0),(496464,13791,'it','Fare clic su ogni notifica per visualizzare i dettagli',0),(496465,13791,'tl','',0),(496466,13791,'th','à¸„à¸¥à¸´à¸à¸à¸²à¸£à¹à¸ˆà¹‰à¸‡à¹€à¸•à¸·à¸­à¸™à¹à¸•à¹ˆà¸¥à¸°à¹€à¸¡à¸·à¹ˆà¸­à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸”à¸¹à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”',0),(496467,13791,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤¸à¥‚à¤šà¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤µà¤°à¤£ à¤¦à¥‡à¤–à¥‡à¤‚ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(496468,13791,'ms','Klik setiap pemberitahuan untuk lihat butiran',0),(496469,13791,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ ÙƒÙ„ Ø§Ù„Ø¥Ø¹Ù„Ø§Ù… Ù„Ø¹Ø±Ø¶ Ø§Ù„ØªÙØ§ØµÙŠÙ„',0),(496470,13791,'fr','Cliquez sur chaque Notification pour voir les dÃ©tails',0),(496471,13791,'jp','å„é€šçŸ¥ã®è©³ç´°ã‚’è¡¨ç¤ºã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦ãã ã•ã„ã€‚',0),(496472,13791,'pt','Clique em cada notificaÃ§Ã£o para exibir detalhes',0),(496473,13791,'ru','Ð©ÐµÐ»ÐºÐ½Ð¸Ñ‚Ðµ ÐºÐ°Ð¶Ð´Ð¾Ðµ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½ÐµÐµ',0),(496474,13791,'es','Haga clic en cada notificaciÃ³n para ver detalles',0),(496475,13791,'de','Klicken Sie auf jede Benachrichtigung auf Details anzeigen',0),(496476,13791,'en','Click Each Notification To View Details',0),(496477,13792,'is','',0),(496478,13792,'dr','ÙØ§Ú©ØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡',0),(496479,13792,'pr','ÙØ§Ú©ØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø´Ø¯Ù‡',0),(496480,13792,'tr','Ã–denen faturalar',0),(496481,13792,'pl','Faktur niezapÅ‚aconych',0),(496482,13792,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð½Ðµ Ð¸Ð·Ð¿Ð»Ð°Ñ‰Ð°',0),(496483,13792,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø§Ø¯Ø§ Ù†ÛÛŒÚº Ú©ÛŒ',0),(496484,13792,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(496485,13792,'vi','HoÃ¡ Ä‘Æ¡n chÆ°a thanh toÃ¡n',0),(496486,13792,'af','Fakture nie betaal',0),(496487,13792,'ro','Facturile neplÄƒtite',0),(496488,13792,'et','Maksmata arved',0),(496489,13792,'si','RaÄune ne plaÄa',0),(496490,13792,'ba','Faktur tidak dibayar',0),(496491,13792,'nl','Facturen niet betaald',0),(496492,13792,'fi','Laskuja ei makseta',0),(496493,13792,'no','Fakturaer ikke betalt',0),(496494,13792,'da','Fakturaer ikke betalt',0),(496495,13792,'ko','ì²­êµ¬ì„œë¥¼ ì§€ë¶ˆ í•˜ì§€',0),(496496,13792,'he','×—×©×‘×•× ×™×•×ª ×©×œ× ×©×•×œ×ž×•',0),(496497,13792,'el','Î”ÎµÎ½ Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¬',0),(496498,13792,'zh','æœªæ”¯ä»˜çš„å‘ç¥¨',0),(496499,13792,'sv','Fakturor som inte betalas',0),(496500,13792,'it','Fatture non pagate',0),(496501,13792,'tl','',0),(496502,13792,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸Šà¸³à¸£à¸°à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(496503,13792,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚',0),(496504,13792,'ms','Invois-invois yang tidak dibayar',0),(496505,13792,'ar','ÙÙˆØ§ØªÙŠØ± Ù„Ù… ØªØ³Ø¯Ø¯ Ø¨Ø¹Ø¯',0),(496506,13792,'fr','Factures non payÃ©es',0),(496507,13792,'jp','æ”¯æ‰•ã‚ã‚Œãªã‹ã£ãŸè«‹æ±‚',0),(496508,13792,'pt','Faturas nÃ£o pagas',0),(496509,13792,'ru','ÐÐµÐ¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(496510,13792,'es','Facturas no pagadas',0),(496511,13792,'de','Rechnungen nicht bezahlt',0),(496512,13792,'en','Invoices Not Paid',0),(496513,13793,'is','',0),(496514,13793,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø§ Ø§Ù†ØªØ¸Ø§Ø± ØªØ­ÙˆÛŒÙ„',0),(496515,13793,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø§ Ø§Ù†ØªØ¸Ø§Ø± ØªØ­ÙˆÛŒÙ„',0),(496516,13793,'tr','Teslimatlar bekleyen faturalarÄ± ile',0),(496517,13793,'pl','Faktury z czasu dostawy',0),(496518,13793,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ñ Ð¾Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(496519,13793,'ur','Ú©Û’ Ø³Ø§ØªÚ¾ ÙˆØ¨Ø¬Ù„ÛŒ ÙØ±Ø§ÛÙ…ÛŒ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§',0),(496520,13793,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° ÑÐ° ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(496521,13793,'vi','HoÃ¡ Ä‘Æ¡n vá»›i Ä‘ang chá» giao hÃ ng',0),(496522,13793,'af','Fakture met hangende aflewerings',0),(496523,13793,'ro','Facturi cu pÃ¢nÄƒ la livrÄƒri',0),(496524,13793,'et','Arved kuni tarned',0),(496525,13793,'si','RaÄunov z do dobave',0),(496526,13793,'ba','Faktur dengan menunggu pengiriman',0),(496527,13793,'nl','Facturen met in afwachting van leveringen',0),(496528,13793,'fi','Laskut ennen toimitusten',0),(496529,13793,'no','Fakturaer med ventende leveranser',0),(496530,13793,'da','Fakturaer med ventende leverancer',0),(496531,13793,'ko','ë°°ë‹¬ ë³´ë¥˜ ëœ ì†¡ìž¥',0),(496532,13793,'he','×—×©×‘×•× ×™×•×ª ×¢× ×ž×ž×ª×™× ×™× ×ž×©×œ×•×—×™×',0),(496533,13793,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î¼Îµ ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ Ï€Î±ÏÎ±Î´ÏŒÏƒÎµÎ¹Ï‚',0),(496534,13793,'zh','å¾…äº¤ä»˜çš„å‘ç¥¨',0),(496535,13793,'sv','Fakturor med pÃ¥gÃ¥ende leveranser',0),(496536,13793,'it','Fatture con pendenti consegne',0),(496537,13793,'tl','',0),(496538,13793,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸à¸±à¸šà¸£à¸­à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(496539,13793,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¹à¥€ à¤ªà¥à¤°à¤¸à¤µ à¤²à¤‚à¤¬à¤¿à¤¤',0),(496540,13793,'ms','Invois dengan menunggu penghantaran',0),(496541,13793,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ù…Ø¹ Ø§Ù†ØªØ¸Ø§Ø± Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(496542,13793,'fr','Factures avec dans l\'attente de livraisons',0),(496543,13793,'jp','ä¿ç•™ä¸­ã®é…é€ã¨è«‹æ±‚',0),(496544,13793,'pt','Facturas com pendente entregas',0),(496545,13793,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ñ Ð´Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(496546,13793,'es','Facturas con pendientes de entregas',0),(496547,13793,'de','Rechnungen mit ausstehenden Lieferungen',0),(496548,13793,'en','Invoices With Pending Deliveries',0),(496549,13794,'is','',0),(496550,13794,'dr','Ø®Ø±ÛŒØ¯ Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø§ÛŒÙ† Ø­Ø³Ø§Ø¨ ÙØ¹Ø§Ù„ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª.  Ø¨Ø±Ø§ÛŒ Ú©Ø³Ø¨ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ± Ø¨Ø§ Ø§Ø±Ø§Ø¦Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡ Ø­Ø³Ø§Ø¨ Ø®ÙˆØ¯ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯.',0),(496551,13794,'pr','Ø®Ø±ÛŒØ¯ Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ø§ÛŒÙ† Ø­Ø³Ø§Ø¨ ÙØ¹Ø§Ù„ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª.  Ø¨Ø±Ø§ÛŒ Ú©Ø³Ø¨ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ± Ø¨Ø§ Ø§Ø±Ø§Ø¦Ù‡ Ø¯Ù‡Ù†Ø¯Ù‡ Ø­Ø³Ø§Ø¨ Ø®ÙˆØ¯ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯.',0),(496552,13794,'tr','Eklenti satÄ±n alma iÃ§in bu hesabÄ± etkin deÄŸil.  LÃ¼tfen daha fazla ayrÄ±ntÄ± iÃ§in hesabÄ±nÄ±n saÄŸlayÄ±cÄ±nÄ±za baÅŸvurun.',0),(496553,13794,'pl','O dodatku zakup nie jest wÅ‚Ä…czone dla tego konta.  Aby uzyskaÄ‡ wiÄ™cej informacji, skontaktuj siÄ™ z dostawcy konta.',0),(496554,13794,'bg','Ð—Ð°ÐºÑƒÐ¿ÑƒÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾Ð±Ð°Ð²ÐºÐ°Ñ‚Ð° Ð½Ðµ Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚.  Ð—Ð° Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÑÐµ Ð¾Ð±ÑŠÑ€Ð½ÐµÑ‚Ðµ ÐºÑŠÐ¼ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð°.',0),(496555,13794,'ur','Ø¨Ø±-Ø§ Ø¶Ø§ÙÛ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ùˆ Ø§ÛÙ„ Ù†ÛÛŒÚº ÛÛ’ Û”  Ù…Ø²ÛŒØ¯ ØªÙØµÛŒÙ„Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ø¢Ù¾ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù…ÛÛŒØ§ Ú©Ø§Ø± Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº Û”',0),(496556,13794,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð°Ðº Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÑƒ Ð½Ð¸Ñ˜Ðµ Ð¾Ð¼Ð¾Ð³ÑƒÑ›ÐµÐ½ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½.  ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð¾Ð±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ñƒ Ñ€Ð°Ñ‡ÑƒÐ½ Ð·Ð° Ð²Ð¸ÑˆÐµ Ð´ÐµÑ‚Ð°Ñ™Ð°.',0),(496557,13794,'vi','Tiá»‡n Ã­ch mua khÃ´ng Ä‘Æ°á»£c phÃ©p cho trÆ°Æ¡ng má»¥c nÃ y.  Xin vui lÃ²ng liÃªn há»‡ vá»›i nhÃ  cung cáº¥p tÃ i khoáº£n cá»§a báº¡n Ä‘á»ƒ biáº¿t thÃªm chi tiáº¿t.',0),(496558,13794,'af','Byvoegsel aankoop is nie geaktiveer vir hierdie rekening.  Kontak asseblief jou verskaffer van die rekening vir meer besonderhede.',0),(496559,13794,'ro','Supliment de cumpÄƒrare nu este activatÄƒ pentru acest cont.  Pentru mai multe detalii, contacteazÄƒ furnizorul contului.',0),(496560,13794,'et','Selle konto jaoks pole lubatud lisandmooduli ostmine.  Lisateabe saamiseks pÃ¶Ã¶rduge oma kontoteenuse pakkuja.',0),(496561,13794,'si','Dodatek nakup ni omogoÄena za ta raÄun.  VeÄ podrobnosti, se obrnite na ponudnika raÄuna.',0),(496562,13794,'ba','Pembelian add-On tidak diaktifkan untuk account ini.  Hubungi penyedia account Anda untuk rincian lebih lanjut.',0),(496563,13794,'nl','Add-On aankoop is niet ingeschakeld voor deze account.  Neem contact op met uw accountprovider voor meer informatie.',0),(496564,13794,'fi','LisÃ¤osan ostaa ei ole kÃ¤ytÃ¶ssÃ¤ tÃ¤lle tilille.  PyydÃ¤ lisÃ¤tietoja tilin palveluntarjoaja.',0),(496565,13794,'no','Tillegg kjÃ¸pe er ikke aktivert for denne kontoen.  Kontakt kontoleverandÃ¸ren for mer informasjon.',0),(496566,13794,'da','TilfÃ¸jelse kÃ¸ber er ikke aktiveret for denne konto.  Kontakt venligst din konto udbyder for flere detaljer.',0),(496567,13794,'ko','ì¶”ê°€ êµ¬ìž…ì´ ê³„ì •ì— ëŒ€í•´ ì‚¬ìš© ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.  ìžì„¸í•œ ë‚´ìš©ì€ ê³„ì • ê³µê¸‰ìžì— ê²Œ ë¬¸ì˜ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤.',0),(496568,13794,'he','×¨×›×™×©×ª ×”×”×¨×—×‘×” ××™× ×• ×–×ž×™×Ÿ ×¢×‘×•×¨ ×—×©×‘×•×Ÿ ×–×”.  ×× × ×¦×¨×• ×§×©×¨ ×¢× ×¡×¤×§ ×”×—×©×‘×•×Ÿ ×©×œ×š ×œ×§×‘×œ×ª ×¤×¨×˜×™× × ×•×¡×¤×™×.',0),(496569,13794,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î¿ Î±Î³Î¿ÏÎ¬ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î· Î³Î¹Î± Î±Ï…Ï„ÏŒÎ½ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ.  Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î®ÏƒÏ„Îµ Î¼Îµ Ï„Î¿ Ï†Î¿ÏÎ­Î± Ï€Î±ÏÎ¿Ï‡Î®Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½ ÏƒÎ±Ï‚ Î³Î¹Î± Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ',0),(496570,13794,'zh','ä¸ºæ­¤å¸æˆ·æ²¡æœ‰å¯ç”¨åŠ è½½é¡¹é‡‡è´­ã€‚è¯·æ›´å¤šè¯¦æƒ…è”ç³»æ‚¨çš„å¸æˆ·æä¾›å•†ã€‚',0),(496571,13794,'sv','TillÃ¤gg inkÃ¶p Ã¤r inte aktiverat fÃ¶r det hÃ¤r kontot.  FÃ¶r mer information kontakta kontoleverantÃ¶ren.',0),(496572,13794,'it','L\'acquisto di componente aggiuntivo non Ã¨ abilitato per questo account.  Contattate il vostro fornitore di conto per maggiori dettagli.',0),(496573,13794,'tl','',0),(496574,13794,'th','à¹„à¸¡à¹ˆà¹ƒà¸Šà¹‰à¸à¸²à¸£à¸‹à¸·à¹‰à¸­à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸±à¸à¸Šà¸µà¸™à¸µà¹‰  à¹‚à¸›à¸£à¸”à¸•à¸´à¸”à¸•à¹ˆà¸­à¸œà¸¹à¹‰à¹ƒà¸«à¹‰à¸šà¸£à¸´à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸‚à¸­à¸‡à¸„à¸¸à¸“à¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à',0),(496575,13794,'hi','à¤à¤¡-à¤‘à¤¨ à¤•à¥€ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹ à¤–à¤¾à¤¤à¤¾ à¤¸à¤•à¥à¤·à¤® à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤  à¤…à¤§à¤¿à¤• à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤ªà¤¨à¥‡ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤¦à¤¾à¤¤à¤¾ à¤¸à¥‡ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥',0),(496576,13794,'ms','Tambahan pembelian tidak didayakan untuk akaun ini.  Sila hubungi pembekal akaun anda untuk maklumat lanjut.',0),(496577,13794,'ar','Ù„Ù… ÙŠØªÙ… ØªÙ…ÙƒÙŠÙ† Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ© Ø´Ø±Ø§Ø¡ Ù„Ù‡Ø°Ø§ Ø§Ù„Ø­Ø³Ø§Ø¨.  Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„Ø§ØªØµØ§Ù„ Ø¨Ù…ÙˆÙØ± Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù…Ø²ÙŠØ¯ Ù…Ù† Ø§Ù„ØªÙØ§ØµÙŠÙ„.',0),(496578,13794,'fr','Le module d\'achat n\'est pas activÃ© pour ce compte.  Pour plus de dÃ©tails, veuillez communiquer avec votre fournisseur de compte.',0),(496579,13794,'jp','ã“ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ ã‚¢ãƒ‰ã‚ªãƒ³ã‚’è³¼å…¥ã™ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚è©³ç´°ã«ã¤ã„ã¦ã¯ã€ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ ãƒ—ãƒ­ãƒã‚¤ãƒ€ãƒ¼ã«å•ã„åˆã‚ã›ã¦ãã ã•ã„ã€‚',0),(496580,13794,'pt','Complemento de compra nÃ£o estÃ¡ habilitado para esta conta.  Entre em contato com seu provedor de conta para mais detalhes.',0),(496581,13794,'ru','Ðž Ð¿Ð¾ÐºÑƒÐ¿ÐºÐµ Ð½Ðµ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½ Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸.  Ð”Ð»Ñ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð±Ð¾Ð»ÐµÐµ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾Ð¹ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑÐ²ÑÐ¶Ð¸Ñ‚ÐµÑÑŒ Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð¼ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ',0),(496582,13794,'es','Compra Add-On no estÃ¡ habilitado para esta cuenta. Por favor, pÃ³ngase en contacto con su proveedor de cuenta para mÃ¡s detalles.',0),(496583,13794,'de','Kauf von Add-on ist fÃ¼r dieses Konto nicht aktiviert.  Kontaktieren Sie fÃ¼r weitere Details bitte Ihre Konto-Provider.',0),(496584,13794,'en','Add-On purchasing is not enabled for this account.  Please contact your account provider for more details.',0),(496585,13795,'is','',0),(496586,13795,'dr','Ù†Ø§Ù… Ø¨Ø±Ø§ÛŒ Ø¯ÛŒØ¯Ù† ØªÙˆØ¶ÛŒØ­Ø§Øª ÛŒØ§ Ø¨Ù‡ ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(496587,13795,'pr','Ù†Ø§Ù… Ø¨Ø±Ø§ÛŒ Ø¯ÛŒØ¯Ù† ØªÙˆØ¶ÛŒØ­Ø§Øª ÛŒØ§ Ø¨Ù‡ ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(496588,13795,'tr','AÃ§Ä±klama veya etkinleÅŸtirmek iÃ§in tÄ±klatÄ±n',0),(496589,13795,'pl','Kliknij nazwÄ™, aby zobaczyÄ‡ opis, lub w celu aktywacji',0),(496590,13795,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð¸Ð¼ÐµÑ‚Ð¾, Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸ÐµÑ‚Ð¾ Ð¸Ð»Ð¸ Ð´Ð° Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ',0),(496591,13795,'ur','ØªØµØ±ÛŒØ­ Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ÛŒØ§ Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ù†Û’ Ú©Û’ Ù†Ø§Ù… Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(496592,13795,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð¸Ð¼Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð²Ð¸Ð´ÐµÐ»Ð¸ Ð¾Ð¿Ð¸Ñ Ð¸Ð»Ð¸ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð»Ð¸',0),(496593,13795,'vi','Nháº¥p vÃ o tÃªn Ä‘á»ƒ xem mÃ´ táº£ hoáº·c Ä‘á»ƒ kÃ­ch hoáº¡t',0),(496594,13795,'af','Klik op die naam om te sien die beskrywing of om te aktiveer',0),(496595,13795,'ro','FaceÅ£i clic pe numele pentru a vedea Descrierea sau pentru a activa',0),(496596,13795,'et','KlÃµpsake nime, kirjelduse vÃµi Aktiveeri',0),(496597,13795,'si','Kliknite ime, Äe Å¾elite videti opis ali Activate',0),(496598,13795,'ba','Klik nama untuk melihat Deskripsi atau untuk mengaktifkan',0),(496599,13795,'nl','Klik op de naam om de beschrijving te zien of om te activeren',0),(496600,13795,'fi','Valitse kuvaus tai aktivoida',0),(496601,13795,'no','Klikk navnet se beskrivelsen eller aktivere',0),(496602,13795,'da','Klik pÃ¥ navnet Se beskrivelsen eller aktivere',0),(496603,13795,'ko','ì´ë¦„ ì„¤ëª…ì„ ì°¸ì¡° í•˜ê±°ë‚˜ í™œì„±í™”ë¥¼ í´ë¦­ í•©ë‹ˆë‹¤',0),(496604,13795,'he','×œ×—×¥ ×¢×œ ×©× ×›×“×™ ×œ×¨××•×ª ××ª ×”×ª×™××•×¨ ××• ×›×“×™ ×œ×”×¤×¢×™×œ',0),(496605,13795,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ ÏŒÎ½Î¿Î¼Î± Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î® ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹ÏŽ',0),(496606,13795,'zh','å•å‡»è¦æŸ¥çœ‹çš„è¯´æ˜Žï¼Œæˆ–æ¿€æ´»çš„åç§°',0),(496607,13795,'sv','Klicka pÃ¥ namnet att se beskrivningen eller aktivera',0),(496608,13795,'it','Fare clic sul nome per vedere la descrizione o per attivare',0),(496609,13795,'tl','',0),(496610,13795,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸Šà¸·à¹ˆà¸­ à¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢ à¸«à¸£à¸·à¸­ à¹€à¸žà¸·à¹ˆà¸­à¹€à¸£à¸µà¸¢à¸à¹ƒà¸Šà¹‰',0),(496611,13795,'hi','à¤¨à¤¾à¤® à¤¯à¤¾ à¤µà¤°à¥à¤£à¤¨ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(496612,13795,'ms','Klik nama untuk lihat keterangan atau untuk mengaktifkan',0),(496613,13795,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„Ø§Ø³Ù… Ù„Ù…Ø´Ø§Ù‡Ø¯Ø© Ø§Ù„ÙˆØµÙ Ø£Ùˆ Ù„ØªÙ†Ø´ÙŠØ·',0),(496614,13795,'fr','Cliquez sur le nom pour voir la Description ou d\'activer',0),(496615,13795,'jp','èª¬æ˜Žè¡¨ç¤ºã™ã‚‹ã€ã¾ãŸã¯ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã«ã™ã‚‹åå‰ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(496616,13795,'pt','Clique no nome para ver a descriÃ§Ã£o ou ativar',0),(496617,13795,'ru','Ð©ÐµÐ»ÐºÐ½Ð¸Ñ‚Ðµ Ð¸Ð¼Ñ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑƒÐ²Ð¸Ð´ÐµÑ‚ÑŒ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¸Ð»Ð¸ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(496618,13795,'es','Haga clic en el nombre para ver la descripciÃ³n o para activar',0),(496619,13795,'de','Klicken Sie auf den Namen um die Beschreibung anzuzeigen oder zu aktivieren',0),(496620,13795,'en','Click The Name To See The Description Or To Activate',0),(496621,13796,'is','',0),(496622,13796,'dr','Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ù‡Ø§ÛŒ Ø±Ø§ÛŒÚ¯Ø§Ù†',0),(496623,13796,'pr','Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ù‡Ø§ÛŒ Ø±Ø§ÛŒÚ¯Ø§Ù†',0),(496624,13796,'tr','Ãœcretsiz eklentiler',0),(496625,13796,'pl','Darmowe Dodatki',0),(496626,13796,'bg','Ð‘ÐµÐ·Ð¿Ð»Ð°Ñ‚Ð½Ð¸ Ð´Ð¾Ð±Ð°Ð²ÐºÐ¸',0),(496627,13796,'ur','Ù…ÙØª Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº ons',0),(496628,13796,'sr','Ð”Ð¾Ð´Ð°Ñ†Ð¸ Ð·Ð° Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾',0),(496629,13796,'vi','Miá»…n phÃ­ tiá»‡n Ã­ch',0),(496630,13796,'af','Gratis byvoegsels',0),(496631,13796,'ro','Drum liber Suplimente',0),(496632,13796,'et','Vaba lisandmooduleid',0),(496633,13796,'si','Brez dodatkov',0),(496634,13796,'ba','Add-on gratis',0),(496635,13796,'nl','Gratis Add-Ons',0),(496636,13796,'fi','Ilmaisia pÃ¤Ã¤stÃ¶oikeuksia',0),(496637,13796,'no','Gratis tillegg',0),(496638,13796,'da','Gratis tilfÃ¸jelser',0),(496639,13796,'ko','ë¬´ë£Œ ì¶”ê°€ ê¸°ëŠ¥',0),(496640,13796,'he','×ª×•×¡×¤×•×ª ×œ×œ× ×ª×©×œ×•×',0),(496641,13796,'el','Î”Ï‰ÏÎµÎ¬Î½ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î±',0),(496642,13796,'zh','å…è´¹çš„åŠ è½½é¡¹',0),(496643,13796,'sv','Gratis tillÃ¤gg',0),(496644,13796,'it','Add-on gratuiti',0),(496645,13796,'tl','',0),(496646,13796,'th','à¸Ÿà¸£à¸µà¹‚à¸›à¸£à¹à¸à¸£à¸¡ Add-on',0),(496647,13796,'hi','à¤®à¥à¤«à¥à¤¤ à¤à¤¡-à¤‘à¤¨',0),(496648,13796,'ms','Tambahan percuma',0),(496649,13796,'ar','Ø¥Ø¶Ø§ÙØ§Øª Ù…Ø¬Ø§Ù†ÙŠØ©',0),(496650,13796,'fr','Add-ons gratuits',0),(496651,13796,'jp','ç„¡æ–™ã®ã‚¢ãƒ‰ã‚ªãƒ³',0),(496652,13796,'pt','Complementos grÃ¡tis',0),(496653,13796,'ru','Ð‘ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ñ‹Ðµ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(496654,13796,'es','Complementos gratis',0),(496655,13796,'de','Kostenlose Add-ons',0),(496656,13796,'en','Free Add-Ons',0),(496657,13797,'is','',0),(496658,13797,'dr','Ú©ØªØ§Ø¨Ú†Ù‡ Ù‡Ø§ÛŒ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ &amp; Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ',0),(496659,13797,'pr','Ú©ØªØ§Ø¨Ú†Ù‡ Ù‡Ø§ÛŒ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ &amp; Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ',0),(496660,13797,'tr','KÄ±lavuzlarÄ± & destek',0),(496661,13797,'pl','PodrÄ™czniki & wsparcie',0),(496662,13797,'bg','ÐÐ°Ñ€ÑŠÑ‡Ð½Ð¸Ñ†Ð¸ & Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(496663,13797,'ur','Ú©ØªØ§Ø¨Ú†Û’ & Ø­Ù…Ø§ÛŒØª',0),(496664,13797,'sr','ÐŸÑ€Ð¸Ñ€ÑƒÑ‡Ð½Ð¸ÐºÐ° Ð¸ Ð¿Ð¾Ð´Ñ€ÑˆÐºÐ°',0),(496665,13797,'vi','HÆ°á»›ng dáº«n sá»­ dá»¥ng &amp; há»— trá»£',0),(496666,13797,'af','Handleidings & ondersteuning',0),(496667,13797,'ro','Manuale & suport',0),(496668,13797,'et','KÃ¤siraamatute & tugi',0),(496669,13797,'si','PriroÄniki & podporo',0),(496670,13797,'ba','Manual & dukungan',0),(496671,13797,'nl','Handleidingen & ondersteuning',0),(496672,13797,'fi','KÃ¤sikirjat & tuki',0),(496673,13797,'no','Manualer & stÃ¸tte',0),(496674,13797,'da','Manualer & stÃ¸tte',0),(496675,13797,'ko','ë§¤ë‰´ì–¼ & ì§€ì›',0),(496676,13797,'he','×ž×“×¨×™×›×™× & ×ª×ž×™×›×”',0),(496677,13797,'el','Î•Î³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î± & Ï…Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î·',0),(496678,13797,'zh','æ‰‹å†Œ &amp; æ”¯æŒ',0),(496679,13797,'sv','Manualer & stÃ¶d',0),(496680,13797,'it','Manuali di supporto &',0),(496681,13797,'tl','',0),(496682,13797,'th','à¸„à¸¹à¹ˆà¸¡à¸·à¸­ & à¸ªà¸™à¸±à¸šà¸ªà¸™à¸¸à¸™',0),(496683,13797,'hi','à¤¨à¤¿à¤¯à¤®à¤¾à¤µà¤²à¥€ & à¤¸à¤®à¤°à¥à¤¥à¤¨',0),(496684,13797,'ms','Manual & sokongan',0),(496685,13797,'ar','ÙƒØªÙŠØ¨Ø§Øª Ø§Ù„Ø¯Ø¹Ù… Ø¢Ù†Ø¯',0),(496686,13797,'fr','Manuels & Support',0),(496687,13797,'jp','ãƒžãƒ‹ãƒ¥ã‚¢ãƒ« & ã‚µãƒãƒ¼ãƒˆ',0),(496688,13797,'pt','Suporte & manuais',0),(496689,13797,'ru','& ÐŸÐ¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ° Ñ€ÑƒÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð°',0),(496690,13797,'es','Manuales de apoyo &amp;',0),(496691,13797,'de','HandbÃ¼cher- & -UnterstÃ¼tzung',0),(496692,13797,'en','Manuals & Support',0),(496693,13798,'is','',0),(496694,13798,'dr','Ø¨ Ø¨Ø±Ù†Ø§Ù…Ù‡ 941 Ø¨Ø§Ø±Ú¯ÛŒØ±ÛŒ Ø¯Ø± Ø§ÛŒÙ† Ù‡ÙØªÙ‡',0),(496695,13798,'pr','Ø¨ Ø¨Ø±Ù†Ø§Ù…Ù‡ 941 Ø¨Ø§Ø±Ú¯ÛŒØ±ÛŒ Ø¯Ø± Ø§ÛŒÙ† Ù‡ÙØªÙ‡',0),(496696,13798,'tr','941 zamanlama B haftalÄ±k',0),(496697,13798,'pl','B 941 harmonogram tygodniowy',0),(496698,13798,'bg','941 ÑÑ…ÐµÐ¼Ð° Ð‘ ÑÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð¾',0),(496699,13798,'ur','ÛÙØªÛ ÙˆØ§Ø± 941 Ø´ÛŒÚˆÙˆÙ„ B',0),(496700,13798,'sr','941 Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´ Ð‘ ÑÐµÐ´Ð¼Ð¸Ñ‡Ð½Ð¾',0),(496701,13798,'vi','B 941 lá»‹ch trÃ¬nh hÃ ng tuáº§n',0),(496702,13798,'af','941 Skedule B Weekliks',0),(496703,13798,'ro','B 941 program sÄƒptÄƒmÃ¢nal',0),(496704,13798,'et','B iganÃ¤dalane 941 loend',0),(496705,13798,'si','941 urnik B tedensko',0),(496706,13798,'ba','B 941 jadwal mingguan',0),(496707,13798,'nl','941 schema B wekelijks',0),(496708,13798,'fi','941 luettelo B viikoittain',0),(496709,13798,'no','941 plan B ukentlig',0),(496710,13798,'da','941 skema B ugentligt',0),(496711,13798,'ko','ë§¤ì£¼ 941 ì¼ì • B',0),(496712,13798,'he','B 941 ×œ×•×— ×–×ž× ×™× ×©×‘×•×¢×™',0),(496713,13798,'el','941 ÏƒÏ‡ÎµÎ´Î¯Î¿Ï… Î’ ÎµÎ²Î´Î¿Î¼Î±Î´Î¹Î±Î¯Î±',0),(496714,13798,'zh','941 é™„è¡¨ B æ¯å‘¨',0),(496715,13798,'sv','941 lista B varje vecka',0),(496716,13798,'it','B 941 pianificazione settimanale',0),(496717,13798,'tl','',0),(496718,13798,'th','B 941 à¸à¸³à¸«à¸™à¸”à¸à¸²à¸£à¸£à¸²à¸¢à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(496719,13798,'hi','941 à¤…à¤¨à¥à¤¸à¥‚à¤šà¥€ à¤¬à¥€ à¤¸à¤¾à¤ªà¥à¤¤à¤¾à¤¹à¤¿à¤•',0),(496720,13798,'ms','B 941 Jadual mingguan',0),(496721,13798,'ar','Ø¨ 941 Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ÙŠ',0),(496722,13798,'fr','Annexe 941 B par semaine',0),(496723,13798,'jp','941 ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ« B æ¯Žé€±',0),(496724,13798,'pt','B 941 agenda semanal',0),(496725,13798,'ru','941 Ð Ð°ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ B Ð·Ð° Ð½ÐµÐ´ÐµÐ»ÑŽ',0),(496726,13798,'es','B 941 horario semanal',0),(496727,13798,'de','941 Zeitplan B wÃ¶chentlich',0),(496728,13798,'en','941 Schedule B Weekly',0),(496729,13799,'is','',0),(496730,13799,'dr','ØªÙ‚ÙˆÛŒÙ… Ø³Ø§Ù„',0),(496731,13799,'pr','ØªÙ‚ÙˆÛŒÙ… Ø³Ø§Ù„',0),(496732,13799,'tr','Takvim yÄ±lÄ±',0),(496733,13799,'pl','Rok kalendarzowy',0),(496734,13799,'bg','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(496735,13799,'ur','Ú©ÛŒÙ„Ù†ÚˆØ± Ø³Ø§Ù„',0),(496736,13799,'sr','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€ÑÐºÐµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(496737,13799,'vi','NÄƒm dÆ°Æ¡ng lá»‹ch',0),(496738,13799,'af','Kalender Jaar',0),(496739,13799,'ro','An calendaristic',0),(496740,13799,'et','Kalendriaasta',0),(496741,13799,'si','Koledarsko leto',0),(496742,13799,'ba','Tahun kalender',0),(496743,13799,'nl','Kalenderjaar',0),(496744,13799,'fi','Kalenterivuoden',0),(496745,13799,'no','KalenderÃ¥ret',0),(496746,13799,'da','KalenderÃ¥r',0),(496747,13799,'ko','ì—­ ë…„',0),(496748,13799,'he','×œ×•×— ×©× ×”',0),(496749,13799,'el','Î—Î¼ÎµÏÎ¿Î»Î¿Î³Î¹Î±ÎºÏŒ Î­Ï„Î¿Ï‚',0),(496750,13799,'zh','æ—¥åŽ†å¹´åº¦',0),(496751,13799,'sv','KalenderÃ¥r',0),(496752,13799,'it','Calendario anno',0),(496753,13799,'tl','',0),(496754,13799,'th','à¸›à¸µà¸›à¸à¸´à¸—à¸´à¸™',0),(496755,13799,'hi','à¤•à¥ˆà¤²à¥‡à¤‚à¤¡à¤° à¤µà¤°à¥à¤·',0),(496756,13799,'ms','Tahun kalendar',0),(496757,13799,'ar','Ø§Ù„Ø³Ù†Ø© Ø§Ù„ØªÙ‚ÙˆÙŠÙ…ÙŠØ©',0),(496758,13799,'fr','AnnÃ©e civile',0),(496759,13799,'jp','æš¦å¹´',0),(496760,13799,'pt','Ano civil',0),(496761,13799,'ru','ÐšÐ°Ð»ÐµÐ½Ð´Ð°Ñ€Ð½Ñ‹Ð¹ Ð³Ð¾Ð´',0),(496762,13799,'es','AÃ±o calendario',0),(496763,13799,'de','Kalenderjahr',0),(496764,13799,'en','Calendar Year',0),(496765,13800,'is','',0),(496766,13800,'dr','EIN',0),(496767,13800,'pr','EIN',0),(496768,13800,'tr','EIN',0),(496769,13800,'pl','EIN',0),(496770,13800,'bg','EIN',0),(496771,13800,'ur','Ø¨Ø¯Ú¯Ù…Ø§Ù†ÛŒ',0),(496772,13800,'sr','Ð•Ð˜Ð',0),(496773,13800,'vi','EIN',0),(496774,13800,'af','EIN',0),(496775,13800,'ro','EIN',0),(496776,13800,'et','EIN',0),(496777,13800,'si','EIN',0),(496778,13800,'ba','EIN',0),(496779,13800,'nl','EIN',0),(496780,13800,'fi','EIN',0),(496781,13800,'no','EIN',0),(496782,13800,'da','EIN',0),(496783,13800,'ko','EIN',0),(496784,13800,'he','×¢×™×Ÿ',0),(496785,13800,'el','EIN',0),(496786,13800,'zh','è‰¾å› ',0),(496787,13800,'sv','EIN',0),(496788,13800,'it','EIN',0),(496789,13800,'tl','',0),(496790,13800,'th','à¹„à¸­à¸™à¹Œ',0),(496791,13800,'hi','à¤ˆà¤†à¤ˆà¤à¤¨',0),(496792,13800,'ms','EIN',0),(496793,13800,'ar','Ø¹ÙŠÙ†',0),(496794,13800,'fr','EIN',0),(496795,13800,'jp','ã‚¢ã‚¤ãƒ³',0),(496796,13800,'pt','EIN',0),(496797,13800,'ru','Ð­Ð™Ð',0),(496798,13800,'es','EIN',0),(496799,13800,'de','EIN',0),(496800,13800,'en','EIN',0),(496801,13801,'is','',0),(496802,13801,'dr','Ø¨ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¨Ø±Ø§ÛŒ 941',0),(496803,13801,'pr','Ø¨ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¨Ø±Ø§ÛŒ 941',0),(496804,13801,'tr','941 iÃ§in zamanlama B veri',0),(496805,13801,'pl','Harmonogram B danych dla 941',0),(496806,13801,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð‘ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° 941',0),(496807,13801,'ur','941 Ú©Û’ Ù„ÛŒÛ’ Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ÛŒ B Ú©ÙˆØ§Ø¦Ù',0),(496808,13801,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸ Ð¾ Ð·Ð°ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÑƒ Ð‘ Ð·Ð° 941',0),(496809,13801,'vi','Lá»‹ch B dá»¯ liá»‡u cho 941',0),(496810,13801,'af','Bylae B Data vir 941',0),(496811,13801,'ro','Programul B date pentru 941',0),(496812,13801,'et','Ajakava B andmete 941',0),(496813,13801,'si','Urnik B podatkov za 941',0),(496814,13801,'ba','Jadwal B Data untuk 941',0),(496815,13801,'nl','De gegevens van schema B voor 941',0),(496816,13801,'fi','Luettelo B tiedot 941',0),(496817,13801,'no','B plandata For 941',0),(496818,13801,'da','Skema B Data For 941',0),(496819,13801,'ko','941 ë°ì´í„°ê°€ ì¼ì • B',0),(496820,13801,'he','× ×ª×•× ×™ ×œ×•×— ×”×–×ž× ×™× B ×¢×‘×•×¨ 941',0),(496821,13801,'el','Î’ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î³Î¹Î± 941',0),(496822,13801,'zh','é™„è¡¨ B æ•°æ®ä¸º 941 çš„',0),(496823,13801,'sv','B schemadata fÃ¶r 941',0),(496824,13801,'it','Calendario B dati per 941',0),(496825,13801,'tl','',0),(496826,13801,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸³à¸«à¸™à¸”à¸à¸²à¸£ B 941',0),(496827,13801,'hi','941 à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤¸à¥‚à¤šà¥€ à¤¬à¥€ à¤¡à¥‡à¤Ÿà¤¾',0),(496828,13801,'ms','Data-Data Jadual B 941',0),(496829,13801,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø²Ù…Ù†ÙŠ Ø¨ 941',0),(496830,13801,'fr','DonnÃ©es de l\'annexe B pour 941',0),(496831,13801,'jp','941 ã®ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ« B ãƒ‡ãƒ¼ã‚¿',0),(496832,13801,'pt','Dados de agendamento B para 941',0),(496833,13801,'ru','Ð Ð°ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ B Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð´Ð»Ñ 941',0),(496834,13801,'es','Datos de plan B de 941',0),(496835,13801,'de','B Daten fÃ¼r 941',0),(496836,13801,'en','Schedule B Data For 941',0),(496837,13802,'is','',0),(496838,13802,'dr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¨ Ø¨Ø±Ø§ÛŒ 941',0),(496839,13802,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¨ Ø¨Ø±Ø§ÛŒ 941',0),(496840,13802,'tr','941 B programi',0),(496841,13802,'pl','Plan B dla 941',0),(496842,13802,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð‘ Ð·Ð° 941',0),(496843,13802,'ur','941 Ú©Û’ Ù„Ø¦Û’ Ø´ÛŒÚˆÙˆÙ„ B',0),(496844,13802,'sr','Ð Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´ Ð‘ Ð·Ð° 941',0),(496845,13802,'vi','Káº¿ hoáº¡ch B 941',0),(496846,13802,'af','Bylae B vir 941',0),(496847,13802,'ro','Programul B pentru 941',0),(496848,13802,'et','B loend 941',0),(496849,13802,'si','Urnik B za 941',0),(496850,13802,'ba','Jadwal B 941',0),(496851,13802,'nl','Schema B voor 941',0),(496852,13802,'fi','Luettelo B 941',0),(496853,13802,'no','Plan B For 941',0),(496854,13802,'da','Skema B For 941',0),(496855,13802,'ko','ì¼ì • B 941',0),(496856,13802,'he','×œ×•×— ×”×–×ž× ×™× B 941',0),(496857,13802,'el','Î’ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Î³Î¹Î± 941',0),(496858,13802,'zh','é™„è¡¨ B ä¸º 941',0),(496859,13802,'sv','Schema B fÃ¶r 941',0),(496860,13802,'it','Calendario B per 941',0),(496861,13802,'tl','',0),(496862,13802,'th','à¸•à¸²à¸£à¸²à¸‡ B à¸ªà¸³à¸«à¸£à¸±à¸š 941',0),(496863,13802,'hi','941 à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤¸à¥‚à¤šà¥€ à¤¬à¥€',0),(496864,13802,'ms','Jadual B 941',0),(496865,13802,'ar','Ø¬Ø¯ÙˆÙ„ Ø¨ 941',0),(496866,13802,'fr','Annexe B pour 941',0),(496867,13802,'jp','ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ« B 941',0),(496868,13802,'pt','Plano B para 941',0),(496869,13802,'ru','Ð Ð°ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ B 941',0),(496870,13802,'es','Plan B para 941',0),(496871,13802,'de','Plan B fÃ¼r 941',0),(496872,13802,'en','Schedule B For 941',0),(496873,13803,'is','',0),(496874,13803,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø³Ù‡ Ù…Ø§Ù‡Ù‡',0),(496875,13803,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³Ù‡ Ù…Ø§Ù‡Ù‡',0),(496876,13803,'tr','ÃœÃ§ aylÄ±k dÃ¶nem iÃ§in toplam',0),(496877,13803,'pl','ÅÄ…cznie za kwartaÅ‚',0),(496878,13803,'bg','ÐžÐ±Ñ‰Ð¾ Ð·Ð° Ñ‚Ñ€Ð¸Ð¼ÐµÑÐµÑ‡Ð¸Ðµ',0),(496879,13803,'ur','Ø³Û Ù…Ø§ÛÛŒ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„',0),(496880,13803,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð·Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(496881,13803,'vi','Tá»•ng sá»‘ cho quÃ½',0),(496882,13803,'af','Totaal vir kwartaal',0),(496883,13803,'ro','Total trimestru',0),(496884,13803,'et','Kokku kvartali',0),(496885,13803,'si','Skupaj za Äetrtino',0),(496886,13803,'ba','Total untuk kuartal',0),(496887,13803,'nl','Totaal voor kwartaal',0),(496888,13803,'fi','YhteensÃ¤ vuosineljÃ¤nneksen',0),(496889,13803,'no','Totalt kvartal',0),(496890,13803,'da','Alt For kvartal',0),(496891,13803,'ko','ë¶„ê¸°ì— ëŒ€ í•œ ì´',0),(496892,13803,'he','×¡×š ×”×›×œ ×¨×‘×¢×•×Ÿ',0),(496893,13803,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î³Î¹Î± Ï„Î¿ Ï„Î­Ï„Î±ÏÏ„Î¿',0),(496894,13803,'zh','å­£åº¦åˆè®¡',0),(496895,13803,'sv','Totalt fÃ¶r kvartalet',0),(496896,13803,'it','Totale per trimestre',0),(496897,13803,'tl','',0),(496898,13803,'th','à¸¢à¸­à¸”à¸£à¸§à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¹„à¸•à¸£à¸¡à¸²à¸ª',0),(496899,13803,'hi','à¤¤à¤¿à¤®à¤¾à¤¹à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²',0),(496900,13803,'ms','Jumlah keseluruhan bagi suku',0),(496901,13803,'ar','Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ù„Ù„Ø±Ø¨Ø¹',0),(496902,13803,'fr','Total pour le trimestre',0),(496903,13803,'jp','å››åŠæœŸã®åˆè¨ˆ',0),(496904,13803,'pt','Total por trimestre',0),(496905,13803,'ru','Ð’ÑÐµÐ³Ð¾ Ð·Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»',0),(496906,13803,'es','Total para el trimestre',0),(496907,13803,'de','Insgesamt fÃ¼r das Quartal',0),(496908,13803,'en','Total For Quarter',0),(496909,13804,'is','',0),(496910,13804,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙˆØ¨ Ø³Ø§ÛŒØª',0),(496911,13804,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙˆØ¨ Ø³Ø§ÛŒØª',0),(496912,13804,'tr','Web sitesi Ekle',0),(496913,13804,'pl','Dodaj stronÄ™',0),(496914,13804,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ ÑÐ°Ð¹Ñ‚',0),(496915,13804,'ur','ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(496916,13804,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ WÐµÐ± Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(496917,13804,'vi','ThÃªm trang web',0),(496918,13804,'af','Voeg webwerf',0),(496919,13804,'ro','Adauga site-ul',0),(496920,13804,'et','Lisa veebileht',0),(496921,13804,'si','Dodajte spletno mesto',0),(496922,13804,'ba','Tambahkan Website',0),(496923,13804,'nl','Website toevoegen',0),(496924,13804,'fi','LisÃ¤Ã¤ sivusto',0),(496925,13804,'no','Legge til nettsted',0),(496926,13804,'da','TilfÃ¸j hjemmeside',0),(496927,13804,'ko','ì›¹ì‚¬ì´íŠ¸ ì¶”ê°€',0),(496928,13804,'he','×œ×”×•×¡×™×£ ××ª ×”××ª×¨',0),(496929,13804,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ Î¹ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î±',0),(496930,13804,'zh','æ·»åŠ ç½‘ç«™',0),(496931,13804,'sv','LÃ¤gg till webbplats',0),(496932,13804,'it','Aggiungi sito Web',0),(496933,13804,'tl','',0),(496934,13804,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ',0),(496935,13804,'hi','à¤µà¥‡à¤¬à¤¸à¤¾à¤‡à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(496936,13804,'ms','Tambah laman web',0),(496937,13804,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆÙ‚Ø¹ ÙˆÙŠØ¨',0),(496938,13804,'fr','Ajouter site Web',0),(496939,13804,'jp','ã‚¦ã‚§ãƒ–ã‚µã‚¤ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(496940,13804,'pt','Adicionar site',0),(496941,13804,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð²ÐµÐ±-ÑÐ°Ð¹Ñ‚',0),(496942,13804,'es','AÃ±adir sitio web',0),(496943,13804,'de','Webseite hinzufÃ¼gen',0),(496944,13804,'en','Add Website',0),(496945,13805,'is','',0),(496946,13805,'dr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚',0),(496947,13805,'pr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙØ±ÙˆØ´ Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚',0),(496948,13805,'tr','SatÄ±ÅŸ sipariÅŸi numarasÄ± PO Ã¼zerinde gÃ¶sterme',0),(496949,13805,'pl','Nie pokazuje numeru zamÃ³wienia sprzedaÅ¼y na PO',0),(496950,13805,'bg','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð½Ð° PO',0),(496951,13805,'ur','Ø³ÛŒÙ„Ø² Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ù¾Ø± Ù¾Ùˆ Ù†Ù…Ø§ÛŒØ´ Ù†Û Ú©Ø±ÛŒÚº Û”',0),(496952,13805,'sr','ÐÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜ Ð±Ñ€Ð¾Ñ˜ ÑƒÐ»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð½Ð° Ð¿Ð¾-Ð°',0),(496953,13805,'vi','KhÃ´ng hiá»ƒn thá»‹ sá»‘ bÃ¡n hÃ ng thá»© tá»± trÃªn PO',0),(496954,13805,'af','Verkope bestelling nommer op PO wys nie',0),(496955,13805,'ro','Nu aratÄƒ numÄƒrul de vÃ¢nzÄƒri ordine pe PO',0),(496956,13805,'et','NÃ¤ita ostutellimuse numbri PO',0),(496957,13805,'si','Ne PokaÅ¾i Å¡tevilko prodajnega naloga PO',0),(496958,13805,'ba','Tidak menunjukkan jumlah Order penjualan pada PO',0),(496959,13805,'nl','Vertonen geen verkoopordernummer op PO',0),(496960,13805,'fi','NÃ¤ytÃ¤ myyntitilauksen numero PO',0),(496961,13805,'no','Ikke Vis salgsordrenummeret pÃ¥ PO',0),(496962,13805,'da','Vis ikke salgsordrenummer pÃ¥ PO',0),(496963,13805,'ko','í¬ì— íŒë§¤ ì£¼ë¬¸ ë²ˆí˜¸ê°€ í‘œì‹œ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(496964,13805,'he','××œ ×ª×¦×™×’ ××ª ×ž×¡×¤×¨ ×”×–×ž× ×ª ×”×ž×›×™×¨×” ×‘×¤×•',0),(496965,13805,'el','ÎÎ± Î¼Î·Î½ ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ ÏƒÎµ PO',0),(496966,13805,'zh','å¡ä¸Šä¸ä¼šæ˜¾ç¤ºä»»ä½•é”€å”®è®¢å•ç¼–å·',0),(496967,13805,'sv','Inte Visa FÃ¶rsÃ¤ljningsordernumret pÃ¥ PO',0),(496968,13805,'it','Non mostrare il numero di ordine di vendita sul PO',0),(496969,13805,'tl','',0),(496970,13805,'th','à¹à¸ªà¸”à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‚à¸²à¸¢à¹ƒà¸™ PO',0),(496971,13805,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤° à¤ªà¥‹ à¤¨ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(496972,13805,'ms','Tidak menunjukkan nombor pesanan jualan pada PO',0),(496973,13805,'ar','Ø¹Ø¯Ù… Ø¥Ø¸Ù‡Ø§Ø± Ø±Ù‚Ù… Ø£Ù…Ø± Ø§Ù„ØªÙˆØ±ÙŠØ¯ ÙÙŠ Ø¨Ùˆ',0),(496974,13805,'fr','Ne prÃ©sentent pas de numÃ©ro de commande client par PO',0),(496975,13805,'jp','PO ã®å—æ³¨ç•ªå·ã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(496976,13805,'pt','NÃ£o mostrar o nÃºmero de ordem de venda no PO',0),(496977,13805,'ru','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ñƒ Ð½Ð° PO',0),(496978,13805,'es','No muestra el nÃºmero de orden de venta en PO',0),(496979,13805,'de','Zeigen Sie keine Auftragsnummer am PO',0),(496980,13805,'en','Do Not Show Sales Order Number On PO',0),(496981,13806,'is','',0),(496982,13806,'dr','ØªØ®ÙÛŒÙ',0),(496983,13806,'pr','ØªØ®ÙÛŒÙ',0),(496984,13806,'tr','Ä°ndirim',0),(496985,13806,'pl','Rabat',0),(496986,13806,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(496987,13806,'ur','Ú†Ú¾ÙˆÙ¹',0),(496988,13806,'sr','Ð Ð°Ð±Ð°Ñ‚',0),(496989,13806,'vi','Giáº£m giÃ¡',0),(496990,13806,'af','Korting',0),(496991,13806,'ro','Rabat',0),(496992,13806,'et','Tagasimakse',0),(496993,13806,'si','Rabat',0),(496994,13806,'ba','Rebate',0),(496995,13806,'nl','Korting',0),(496996,13806,'fi','Alennus',0),(496997,13806,'no','Rabatt',0),(496998,13806,'da','Rabat',0),(496999,13806,'ko','ë¦¬ë² ì´íŠ¸',0),(497000,13806,'he','×”× ×—×”',0),(497001,13806,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ·',0),(497002,13806,'zh','é€€ç¨Ž',0),(497003,13806,'sv','Rabatten',0),(497004,13806,'it','Sconto',0),(497005,13806,'tl','',0),(497006,13806,'th','à¹€à¸‡à¸´à¸™à¸„à¸·à¸™',0),(497007,13806,'hi','à¤›à¥‚à¤Ÿ',0),(497008,13806,'ms','Rebat',0),(497009,13806,'ar','Ø§Ù„Ø®ØµÙ…',0),(497010,13806,'fr','Remboursement',0),(497011,13806,'jp','ãƒªãƒ™ãƒ¼ãƒˆ',0),(497012,13806,'pt','Desconto',0),(497013,13806,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ¸',0),(497014,13806,'es','Descuento',0),(497015,13806,'de','Rabatt',0),(497016,13806,'en','Rebate',0),(497017,13807,'is','',0),(497018,13807,'dr','Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡',0),(497019,13807,'pr','Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ù…ÙÙ‚ÙˆØ¯ Ø´Ø¯Ù‡',0),(497020,13807,'tr','Eksik dosya',0),(497021,13807,'pl','Brak pliku',0),(497022,13807,'bg','Ð¤Ð°Ð¹Ð» Ð»Ð¸Ð¿ÑÐ²Ð°',0),(497023,13807,'ur','Ù…Ø³Ù„ØŒ ØºØ§Ø¦Ø¨',0),(497024,13807,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(497025,13807,'vi','Tá»‡p thiáº¿u',0),(497026,13807,'af','LÃªer ontbreek',0),(497027,13807,'ro','FiÅŸier lipsÄƒ',0),(497028,13807,'et','Puuduv fail',0),(497029,13807,'si','ManjkajoÄa datoteka',0),(497030,13807,'ba','File hilang',0),(497031,13807,'nl','Bestand ontbreekt',0),(497032,13807,'fi','Tiedosto puuttuu',0),(497033,13807,'no','Fil mangler',0),(497034,13807,'da','Fil mangler',0),(497035,13807,'ko','íŒŒì¼ ëˆ„ë½',0),(497036,13807,'he','×§×•×‘×¥ ×—×¡×¨',0),(497037,13807,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Ï€Î¿Ï… Î»ÎµÎ¯Ï€ÎµÎ¹',0),(497038,13807,'zh','æ‰¾ä¸åˆ°æ–‡ä»¶',0),(497039,13807,'sv','Fil saknas',0),(497040,13807,'it','File mancante',0),(497041,13807,'tl','',0),(497042,13807,'th','à¹„à¸¡à¹ˆà¸žà¸šà¹à¸Ÿà¹‰à¸¡',0),(497043,13807,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤—à¥à¤® à¤¹à¥ˆ',0),(497044,13807,'ms','Fail hilang',0),(497045,13807,'ar','Ù…Ù„Ù Ù…ÙÙ‚ÙˆØ¯',0),(497046,13807,'fr','Fichier manquant',0),(497047,13807,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ãŒè¦‹ã¤ã‹ã‚‰ãªã„',0),(497048,13807,'pt','Arquivo ausente',0),(497049,13807,'ru','Ð¤Ð°Ð¹Ð» Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚',0),(497050,13807,'es','Falta el archivo',0),(497051,13807,'de','Datei fehlt',0),(497052,13807,'en','File Missing',0),(497053,13808,'is','',0),(497054,13808,'dr','ØªØ®ÙÛŒÙ Ùˆ ÛŒØ§ ØªØ®ÙÛŒÙ',0),(497055,13808,'pr','ØªØ®ÙÛŒÙ Ùˆ ÛŒØ§ ØªØ®ÙÛŒÙ',0),(497056,13808,'tr','Ä°ndirim veya indirim',0),(497057,13808,'pl','ZniÅ¼ki lub rabat',0),(497058,13808,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð¸Ð»Ð¸ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(497059,13808,'ur','Ø±Ø¹Ø§ÛŒØª ÛŒØ§ Ú†Ú¾ÙˆÙ¹',0),(497060,13808,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð¸Ð»Ð¸ Ñ€Ð°Ð±Ð°Ñ‚',0),(497061,13808,'vi','Giáº£m giÃ¡ hoáº·c giáº£m giÃ¡',0),(497062,13808,'af','Afslag of korting',0),(497063,13808,'ro','Discount sau reduceri',0),(497064,13808,'et','Soodushinnaga vÃµi tagasimakse',0),(497065,13808,'si','Popust ali popust',0),(497066,13808,'ba','Diskon atau Rebate',0),(497067,13808,'nl','Korting of korting',0),(497068,13808,'fi','Alennus tai alennus',0),(497069,13808,'no','Rabatt eller rabatt',0),(497070,13808,'da','Rabat eller rabat',0),(497071,13808,'ko','í• ì¸ ë˜ëŠ” ë¦¬ë² ì´íŠ¸',0),(497072,13808,'he','×”× ×—×•×ª ××• ×”× ×—×”',0),(497073,13808,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Î® ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®',0),(497074,13808,'zh','äº«å—æŠ˜æ‰£æˆ–å›žæ‰£',0),(497075,13808,'sv','Rabatt eller rabatten',0),(497076,13808,'it','Sconto o abbuono',0),(497077,13808,'tl','',0),(497078,13808,'th','à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¸«à¸£à¸·à¸­à¹€à¸‡à¸´à¸™à¸„à¸·à¸™',0),(497079,13808,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤¯à¤¾ à¤›à¥‚à¤Ÿ',0),(497080,13808,'ms','Diskaun atau rebat',0),(497081,13808,'ar','Ø§Ù„Ø®ØµÙ… Ø£Ùˆ Ø§Ù„Ø®ØµÙ…',0),(497082,13808,'fr','RÃ©duction ou remboursement',0),(497083,13808,'jp','å‰²å¼•ã‚„ãƒªãƒ™ãƒ¼ãƒˆ',0),(497084,13808,'pt','Desconto ou abatimento',0),(497085,13808,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ¸ Ð¸Ð»Ð¸ ÑÐºÐ¸Ð´ÐºÐ¸',0),(497086,13808,'es','Descuento o rebaja',0),(497087,13808,'de','Preisnachlass oder Rabatt',0),(497088,13808,'en','Discount Or Rebate',0),(497089,13809,'is','',0),(497090,13809,'dr','Ú©Ø§Ù…Ù„ Ø´Ø§Ù…Ù„ Ø­Ø°Ù &amp; Ø­Ø°Ù Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª',0),(497091,13809,'pr','Ú©Ø§Ù…Ù„ Ø´Ø§Ù…Ù„ Ø­Ø°Ù &amp; Ø­Ø°Ù Ø³ÙØ§Ø±Ø´Ø§Øª Ø³Ø§Ø®Øª',0),(497092,13809,'tr','Tam silme iÃ§erir & sipariÅŸlerini siler oluÅŸturmak',0),(497093,13809,'pl','PeÅ‚ne obejmuje usuwanie & usuwa budowaÄ‡ zamÃ³wienia',0),(497094,13809,'bg','ÐŸÑŠÐ»ÐµÐ½ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ & Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð° Ð¸Ð·Ð³Ñ€Ð°Ð´Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(497095,13809,'ur','Ù…Ú©Ù…Ù„ Ø­Ø°Ù Ø¨Ú¾ÛŒ Ø´Ø§Ù…Ù„ ÛÛ’ Û” & ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±ØªØ§ ÛÛ’',0),(497096,13809,'sr','ÐŸÑƒÐ½ ÑƒÐºÑ™ÑƒÑ‡ÑƒÑ˜Ðµ Ð±Ñ€Ð¸ÑÐ°ÑšÐµ & Ð±Ñ€Ð¸ÑˆÐµ Ð¸Ð·Ð³Ñ€Ð°Ð´Ð¸ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(497097,13809,'vi','Äáº§y Ä‘á»§ bao gá»“m xÃ³a &amp; Deletes xÃ¢y dá»±ng Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(497098,13809,'af','Volle sluit skrap & skrap bou bestellings',0),(497099,13809,'ro','Complet include ÅŸterge & ÅŸterge construi comenzi',0),(497100,13809,'et','Kogu sisaldab Delete & kustutab ehitada tellimused',0),(497101,13809,'si','Celoti vkljuÄuje Delete & izbriÅ¡e zgradiÅ¡ naroÄila',0),(497102,13809,'ba','Penuh termasuk menghapus & menghapus membangun perintah',0),(497103,13809,'nl','Volledige omvat verwijderen & verwijdert bouwen Orders',0),(497104,13809,'fi','Full sisÃ¤ltÃ¤Ã¤ Poista & poistaa rakentaa tilaukset',0),(497105,13809,'no','Fullt inkluderer Slett & sletter bygge bestillinger',0),(497106,13809,'da','Fuld indeholder slet & sletter bygge ordrer',0),(497107,13809,'ko','ì‚­ì œë¥¼ í¬í•¨ í•˜ëŠ” ì „ì²´ & ì‚­ì œ ë¹Œë“œ ì˜¤ë”',0),(497108,13809,'he','×ž×œ× ×›×•×œ×œ ×ž×—×™×§×” & ×ž×•×—×§ ×œ×‘× ×•×ª ×”×–×ž× ×•×ª',0),(497109,13809,'el','Î Î»Î®ÏÎ·Ï‚ Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Î´Î¹Î±Î³ÏÎ±Ï†Î® & Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î´Î¹Î±Î³ÏÎ¬Ï†ÎµÎ¹ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(497110,13809,'zh','å…¨æ–‡åŒ…æ‹¬åˆ é™¤ &amp; ä¸­åˆ é™¤ç”Ÿæˆè®¢å•',0),(497111,13809,'sv','Full inkluderar Delete & tar bort bygga order',0),(497112,13809,'it','Full include Delete & eliminazioni costruire ordini',0),(497113,13809,'tl','',0),(497114,13809,'th','à¹€à¸•à¹‡à¸¡à¸¥à¸šà¸£à¸§à¸¡ & à¸¥à¸šà¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(497115,13809,'hi','à¤ªà¥‚à¤°à¥à¤£ Delete à¤­à¥€ à¤¶à¤¾à¤®à¤¿à¤² & à¤¨à¤·à¥à¤Ÿà¤•à¤°à¤£ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(497116,13809,'ms','Penuh termasuk Delete & memadam membina pesanan',0),(497117,13809,'ar','ÙˆÙŠØ´Ù…Ù„ ÙƒØ§Ù…Ù„ Ø­Ø°Ù Ø¢Ù†Ø¯ ÙŠØ­Ø°Ù Ø¨Ù†Ø§Ø¡ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø±',0),(497118,13809,'fr','IntÃ©gral comprend Delete & suppressions crÃ©er des ordres',0),(497119,13809,'jp','å®Œå…¨ã«å‰Šé™¤ãŒå«ã¾ã‚Œã¦ã„ã¾ã™ & ãƒ“ãƒ«ãƒ‰æ³¨æ–‡ã‚’å‰Šé™¤ã—ã¾ã™',0),(497120,13809,'pt','Completo inclui excluir & exclusÃµes ordens de construÃ§Ã£o',0),(497121,13809,'ru','ÐŸÐ¾Ð»Ð½Ð¾ÑÑ‚ÑŒÑŽ Ð²ÐºÐ»ÑŽÑ‡Ð°ÐµÑ‚ Ð² ÑÐµÐ±Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ðµ & Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(497122,13809,'es','Completo incluye eliminar &amp; elimina construir Ã³rdenes',0),(497123,13809,'de','Voll enthÃ¤lt lÃ¶schen & LÃ¶schvorgÃ¤nge erstellen Bestellungen',0),(497124,13809,'en','Full Includes Delete & Deletes Build Orders',0),(497125,13810,'is','',0),(497126,13810,'dr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ ÙØ±ÙˆØ´',0),(497127,13810,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ ÙØ±ÙˆØ´',0),(497128,13810,'tr','Tahmini satÄ±ÅŸ',0),(497129,13810,'pl','Szacunkowej wielkoÅ›ci sprzedaÅ¼y',0),(497130,13810,'bg','ÐŸÑ€Ð¾Ð³Ð½Ð¾Ð·Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(497131,13810,'ur','ØªØ®Ù…ÛŒÙ†ÛŒ ÙØ±ÙˆØ®Øª',0),(497132,13810,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(497133,13810,'vi','Æ¯á»›c tÃ­nh bÃ¡n hÃ ng',0),(497134,13810,'af','Geskatte verkope',0),(497135,13810,'ro','VÃ¢nzÄƒrile estimate',0),(497136,13810,'et','Hinnanguline mÃ¼Ã¼k',0),(497137,13810,'si','Ocenjena prodaja',0),(497138,13810,'ba','Diperkirakan penjualan',0),(497139,13810,'nl','Geschatte verkoop',0),(497140,13810,'fi','Arvioitu liikevaihto',0),(497141,13810,'no','Beregnet mva',0),(497142,13810,'da','AnslÃ¥ede salg',0),(497143,13810,'ko','ì˜ˆìƒëœ íŒë§¤',0),(497144,13810,'he','×ž×›×™×¨×•×ª ×ž×©×•×¢×¨',0),(497145,13810,'el','Î•ÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(497146,13810,'zh','ä¼°è®¡çš„é”€å”®',0),(497147,13810,'sv','Uppskattad fÃ¶rsÃ¤ljning',0),(497148,13810,'it','Stima vendite',0),(497149,13810,'tl','',0),(497150,13810,'th','à¸‚à¸²à¸¢à¸›à¸£à¸°à¸¡à¸²à¸“',0),(497151,13810,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(497152,13810,'ms','Anggaran jualan',0),(497153,13810,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ù…Ù‚Ø¯Ø±Ø©',0),(497154,13810,'fr','Ventes estimÃ©es',0),(497155,13810,'jp','äºˆæƒ³å£²ã‚Šä¸Šã’é«˜',0),(497156,13810,'pt','Vendas estimadas',0),(497157,13810,'ru','ÐŸÐ¾ Ð¾Ñ†ÐµÐ½ÐºÐ°Ð¼ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(497158,13810,'es','Ventas estimadas',0),(497159,13810,'de','GeschÃ¤tzte Umsatz',0),(497160,13810,'en','Estimated Sales',0),(497161,13811,'is','',0),(497162,13811,'dr','ÙˆØ¶Ø¹ÛŒØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…ÙˆØ±Ø¯',0),(497163,13811,'pr','ÙˆØ¶Ø¹ÛŒØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…ÙˆØ±Ø¯',0),(497164,13811,'tr','Madde SatÄ±cÄ± durumu',0),(497165,13811,'pl','Status dostawcy towaru',0),(497166,13811,'bg','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(497167,13811,'ur','Ø´Û’ ÙˆÛŒÙ†ÚˆØ± Ø­Ø§Ù„Øª',0),(497168,13811,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÑÑ‚Ð°Ð²ÐºÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(497169,13811,'vi','Má»¥c nhÃ  cung cáº¥p tráº¡ng thÃ¡i',0),(497170,13811,'af','Item handelaar Status',0),(497171,13811,'ro','Statutul de furnizor articol',0),(497172,13811,'et','Kauba hankija olek',0),(497173,13811,'si','Stanje artikla dobavitelja',0),(497174,13811,'ba','Item Vendor Status',0),(497175,13811,'nl','Leverancier artikelstatus',0),(497176,13811,'fi','Nimikkeen toimittajan tila',0),(497177,13811,'no','Elementet leverandÃ¸r Status',0),(497178,13811,'da','Vendor varestatus',0),(497179,13811,'ko','í•­ëª© ê³µê¸‰ ì—…ì²´ ìƒíƒœ',0),(497180,13811,'he','×ž×¦×‘ ×©×œ ×¡×¤×§ ×¤×¨×™×˜',0),(497181,13811,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï€Ï‰Î»Î·Ï„Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(497182,13811,'zh','é¡¹ç›®ä¾›åº”å•†çŠ¶æ€',0),(497183,13811,'sv','Artikeln leverantÃ¶r Status',0),(497184,13811,'it','Stato dell\'elemento Vendor',0),(497185,13811,'tl','',0),(497186,13811,'th','à¸ªà¸–à¸²à¸™à¸°à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(497187,13811,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(497188,13811,'ms','Status penjual item',0),(497189,13811,'ar','Ø­Ø§Ù„Ø© Ø§Ù„ØµÙ†Ù Ø§Ù„Ù…ÙˆØ±Ø¯',0),(497190,13811,'fr','Statut de fournisseur de point',0),(497191,13811,'jp','é …ç›®ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã®çŠ¶æ³',0),(497192,13811,'pt','Status do item de fornecedor',0),(497193,13811,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(497194,13811,'es','Estado artÃ­culo proveedor',0),(497195,13811,'de','Hersteller des Status von Elementen',0),(497196,13811,'en','Item Vendor Status',0),(497197,13812,'is','',0),(497198,13812,'dr','Ø³Ø§Ù„ Ú¯Ø°Ø´ØªÙ‡ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ø´Ø¯Ù‡',0),(497199,13812,'pr','Ø³Ø§Ù„ Ú¯Ø°Ø´ØªÙ‡ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ø´Ø¯Ù‡',0),(497200,13812,'tr','GeÃ§en yÄ±l satÄ±n',0),(497201,13812,'pl','ZeszÅ‚ym roku kupiÅ‚',0),(497202,13812,'bg','ÐœÐ¸Ð½Ð°Ð»Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð·Ð°ÐºÑƒÐ¿Ð¸Ð»Ð¸',0),(497203,13812,'ur','Ú¯Ø²Ø´ØªÛ Ø³Ø§Ù„ Ø®Ø±ÛŒØ¯Ø§',0),(497204,13812,'sr','ÐŸÑ€Ð¾ÑˆÐ»Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ ÐºÑƒÐ¿Ð¸Ð»Ð¸',0),(497205,13812,'vi','Cuá»‘i nÄƒm mua',0),(497206,13812,'af','Verlede jaar gekoop',0),(497207,13812,'ro','Anul trecut achiziÅ£ionate',0),(497208,13812,'et','Eelmisel aastal ostetud',0),(497209,13812,'si','Lani kupila',0),(497210,13812,'ba','Tahun lalu yang dibeli',0),(497211,13812,'nl','Vorig jaar kocht',0),(497212,13812,'fi','Viime vuonna ostettu',0),(497213,13812,'no','I fjor kjÃ¸pte',0),(497214,13812,'da','Sidste Ã¥r kÃ¸bt',0),(497215,13812,'ko','ìž‘ë…„ì— êµ¬ìž…í•œ',0),(497216,13812,'he','×‘×©× ×” ×©×¢×‘×¨×” ×¨×›×©',0),(497217,13812,'el','Î Î­ÏÏ…ÏƒÎ¹ Î±Î³ÏŒÏÎ±ÏƒÎ±',0),(497218,13812,'zh','åŽ»å¹´è´­ä¹°',0),(497219,13812,'sv','FÃ¶rra Ã¥ret kÃ¶pte',0),(497220,13812,'it','Acquistato l\'anno scorso',0),(497221,13812,'tl','',0),(497222,13812,'th','à¸›à¸µà¸—à¸µà¹ˆà¸‹à¸·à¹‰à¸­',0),(497223,13812,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤¸à¤¾à¤² à¤–à¤°à¥€à¤¦à¥€',0),(497224,13812,'ms','Tahun lepas yang dibeli',0),(497225,13812,'ar','ÙÙŠ Ø§Ù„Ø¹Ø§Ù… Ø§Ù„Ù…Ø§Ø¶ÙŠ ØªÙ… Ø´Ø±Ø§Ø¤Ù‡Ø§',0),(497226,13812,'fr','AchetÃ© l\'an dernier',0),(497227,13812,'jp','æ˜¨å¹´è³¼å…¥ã—ã¾ã—ãŸã€‚',0),(497228,13812,'pt','No ano passado comprou',0),(497229,13812,'ru','Ð’ Ð¿Ñ€Ð¾ÑˆÐ»Ð¾Ð¼ Ð³Ð¾Ð´Ñƒ ÐºÑƒÐ¿Ð¸Ð»',0),(497230,13812,'es','AÃ±o pasado comprÃ³',0),(497231,13812,'de','Letztes Jahr gekauft',0),(497232,13812,'en','Last Year Purchased',0),(497233,13813,'is','',0),(497234,13813,'dr','Ù…Ø­Ù„ Ø§Ù†Ø¨Ø§Ø±',0),(497235,13813,'pr','Ù…Ø­Ù„ Ø§Ù†Ø¨Ø§Ø±',0),(497236,13813,'tr','Ambar yeri',0),(497237,13813,'pl','Lokalizacja w magazynie',0),(497238,13813,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð² ÑÐºÐ»Ð°Ð´Ð°',0),(497239,13813,'ur','Ú¯ÙˆØ¯Ø§Ù… Ù…ÛŒÚº Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(497240,13813,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ñƒ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ñƒ',0),(497241,13813,'vi','Vá»‹ trÃ­ trong nhÃ  kho',0),(497242,13813,'af','Ligging In die pakhuis',0),(497243,13813,'ro','LocaÅ£ie Ã®n depozit',0),(497244,13813,'et','Asukoht laos',0),(497245,13813,'si','Lokacijo v skladiÅ¡Äu',0),(497246,13813,'ba','Lokasi di gudang',0),(497247,13813,'nl','Locatie In magazijn',0),(497248,13813,'fi','Sijainti varastossa',0),(497249,13813,'no','Plassering pÃ¥ lageret',0),(497250,13813,'da','Placering i lageret',0),(497251,13813,'ko','ì°½ ê³  ìœ„ì¹˜',0),(497252,13813,'he','×ž×™×§×•× ×‘×ž×—×¡×Ÿ',0),(497253,13813,'el','Î˜Î­ÏƒÎ· ÏƒÎµ Î±Ï€Î¿Î¸Î®ÎºÎ·',0),(497254,13813,'zh','åœ¨ä»“åº“ä¸­çš„ä½ç½®',0),(497255,13813,'sv','LÃ¤ge i lager',0),(497256,13813,'it','Posizione In magazzino',0),(497257,13813,'tl','',0),(497258,13813,'th','à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¹ƒà¸™à¸„à¸¥à¸±à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(497259,13813,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤®à¥‡à¤‚ à¤¸à¥à¤¥à¤¾à¤¨',0),(497260,13813,'ms','Lokasi di gudang',0),(497261,13813,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ ÙÙŠ Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹',0),(497262,13813,'fr','Emplacement de l\'entrepÃ´t',0),(497263,13813,'jp','å€‰åº«å†…ã®å ´æ‰€',0),(497264,13813,'pt','LocalizaÃ§Ã£o no armazÃ©m',0),(497265,13813,'ru','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´Ðµ',0),(497266,13813,'es','UbicaciÃ³n en almacÃ©n',0),(497267,13813,'de','Lage im Warehouse',0),(497268,13813,'en','Location In Warehouse',0),(497269,13814,'is','',0),(497270,13814,'dr','Ø¯Ø± Ø¯Ø³Øª Ú©Ù…ÛŒØª',0),(497271,13814,'pr','Ø¯Ø± Ø¯Ø³Øª Ú©Ù…ÛŒØª',0),(497272,13814,'tr','El miktarÄ±',0),(497273,13814,'pl','Na iloÅ›Ä‡',0),(497274,13814,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(497275,13814,'ur','ÛØ§ØªÚ¾ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±',0),(497276,13814,'sr','ÐÐ° Ñ€ÑƒÑ†Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(497277,13814,'vi','TrÃªn bÃ n tay sá»‘ lÆ°á»£ng',0),(497278,13814,'af','Op Hand hoeveelheid',0),(497279,13814,'ro','Cantitatea de mÃ¢nÄƒ',0),(497280,13814,'et','Vaba varu kohta',0),(497281,13814,'si','Na roko koliÄina',0),(497282,13814,'ba','Pada tangan kuantitas',0),(497283,13814,'nl','Op Hand hoeveelheid',0),(497284,13814,'fi','JÃ¤senen kÃ¤ytettÃ¤vissÃ¤ oleva mÃ¤Ã¤rÃ¤',0),(497285,13814,'no','PÃ¥ beholdningsantall',0),(497286,13814,'da','PÃ¥ beholdning',0),(497287,13814,'ko','ì† ìˆ˜ëŸ‰ì—',0),(497288,13814,'he','×¢×œ ×”×™×“ ×›×ž×•×ª',0),(497289,13814,'el','Î¤Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï„Î¿Ï… Ï‡ÎµÏÎ¹Î¿Ï',0),(497290,13814,'zh','æ‰‹æ•°é‡',0),(497291,13814,'sv','PÃ¥ kvantitet',0),(497292,13814,'it','Sulla quantitÃ  di mano',0),(497293,13814,'tl','',0),(497294,13814,'th','à¹ƒà¸™à¸›à¸£à¸´à¸¡à¸²à¸“à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(497295,13814,'hi','à¤ªà¤° à¤¹à¤¾à¤¥ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(497296,13814,'ms','Pada tangan kuantiti',0),(497297,13814,'ar','Ø¹Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ÙØ¹Ù„ÙŠØ©',0),(497298,13814,'fr','QuantitÃ© disponible',0),(497299,13814,'jp','æ‰‹ã®æ•°é‡',0),(497300,13814,'pt','Na quantidade de mÃ£o',0),(497301,13814,'ru','ÐŸÐ¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ñƒ Ñ€ÑƒÐº',0),(497302,13814,'es','En la cantidad de mano',0),(497303,13814,'de','Auf Hand-Menge',0),(497304,13814,'en','On Hand Quantity',0),(497305,13815,'is','',0),(497306,13815,'dr','Ù…Ù†Ø¸ÙˆØ± Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…ÙˆØ¬ÙˆØ¯',0),(497307,13815,'pr','Ù…Ù†Ø¸ÙˆØ± Ø¨Ø¹Ù„Ø§ÙˆÙ‡ Ù…ÙˆØ¬ÙˆØ¯',0),(497308,13815,'tr','SipariÅŸ Ã¼zerine artÄ± mevcuttur',0),(497309,13815,'pl','Na zamÃ³wienie Plus dostÄ™pne',0),(497310,13815,'bg','ÐŸÐ¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¿Ð»ÑŽÑ Ð½Ð° Ñ€Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(497311,13815,'ur','Ø¢Ø±ÚˆØ± Ù¾Ø± Ù¾Ù„Ø³ Ø¯Ø³ØªÛŒØ§Ø¨',0),(497312,13815,'sr','Ð£ Ð½Ð°Ð»Ð¾Ð³Ñƒ ÐŸÐ»ÑƒÑ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½',0),(497313,13815,'vi','Äáº·t hÃ ng cá»™ng vá»›i cÃ³ sáºµn',0),(497314,13815,'af','Op bestelling Plus beskikbaar',0),(497315,13815,'ro','Comanda Plus disponibil',0),(497316,13815,'et','Tellimus pluss saadaval',0),(497317,13815,'si','Na naroÄilo tabber na voljo',0),(497318,13815,'ba','Urutan ditambah tersedia',0),(497319,13815,'nl','Op bestelling Plus beschikbaar',0),(497320,13815,'fi','Tilauksesta Plus saatavilla',0),(497321,13815,'no','PÃ¥ bestilling Plus er tilgjengelig',0),(497322,13815,'da','PÃ¥ ordre Plus tilgÃ¦ngelige',0),(497323,13815,'ko','ì£¼ë¬¸ì— í”ŒëŸ¬ìŠ¤ ì‚¬ìš©í•  ìˆ˜',0),(497324,13815,'he','×‘×”×–×ž× ×” ×¤×œ×•×¡ ×–×ž×™×Ÿ',0),(497325,13815,'el','Î£Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÏ…Î½ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î±',0),(497326,13815,'zh','åœ¨è®¢å•ä¸ŠåŠ ä¸Šå¯ç”¨',0),(497327,13815,'sv','PÃ¥ bestÃ¤llning Plus tillgÃ¤nglig',0),(497328,13815,'it','Su ordine Plus disponibile',0),(497329,13815,'tl','',0),(497330,13815,'th','à¹ƒà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ à¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰',0),(497331,13815,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤…à¤§à¤¿à¤• à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(497332,13815,'ms','Dengan arahan Plus tersedia',0),(497333,13815,'ar','Ø¹Ù„Ù‰ Ø§Ù„ØªØ±ØªÙŠØ¨ Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ù…ØªØ§Ø­',0),(497334,13815,'fr','Sur commande, Plus disponible',0),(497335,13815,'jp','é †åºãƒ—ãƒ©ã‚¹ä½¿ç”¨å¯èƒ½',0),(497336,13815,'pt','Na ordem Plus estÃ¡ disponÃ­vel',0),(497337,13815,'ru','ÐÐ° Ð·Ð°ÐºÐ°Ð· Ð¿Ð»ÑŽÑ Ð² Ð½Ð°Ð»Ð¸Ñ‡Ð¸Ð¸',0),(497338,13815,'es','En orden mÃ¡s disponible',0),(497339,13815,'de','Auf Bestellung Plus verfÃ¼gbar',0),(497340,13815,'en','On Order Plus Available',0),(497341,13816,'is','',0),(497342,13816,'dr','Ø¯Ø± ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´',0),(497343,13816,'pr','Ø¯Ø± ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´',0),(497344,13816,'tr','Ãœzerinde sipariÅŸ Mkt.',0),(497345,13816,'pl','Na iloÅ›Ä‡ zamÃ³wienia',0),(497346,13816,'bg','ÐŸÐ¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÐºÐ¾Ð»',0),(497347,13816,'ur','Ù¾Ø± Ø§Ù…Ø§Ù† Ú©Û’ Ù‚ÛŒ',0),(497348,13816,'sr','ÐÐ° Ñ€ÐµÐ´ ÐšÐ¾Ð».',0),(497349,13816,'vi','NgÃ y Ä‘áº·t hÃ ng SL',0),(497350,13816,'af','Op bestelling Qty',0),(497351,13816,'ro','Pe comanda cantit',0),(497352,13816,'et','Linna tellimuse kogus',0),(497353,13816,'si','Na vrstni red kol',0),(497354,13816,'ba','On Order Qty',0),(497355,13816,'nl','Op de afname',0),(497356,13816,'fi','JÃ¤senen tilauksen mÃ¤Ã¤rÃ¤',0),(497357,13816,'no','PÃ¥ ordre Ant',0),(497358,13816,'da','PÃ¥ ordre antal',0),(497359,13816,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰ì—',0),(497360,13816,'he','×¢×œ ×›×ž×•×ª ×”×–×ž× ×”',0),(497361,13816,'el','Î“Î¹Î± Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(497362,13816,'zh','åœ¨è®¢è´­æ•°é‡',0),(497363,13816,'sv','PÃ¥ bestÃ¤llning Kvt',0),(497364,13816,'it','Su ordine Qty',0),(497365,13816,'tl','',0),(497366,13816,'th','à¹ƒà¸™à¸›à¸£à¸´à¸¡à¸²à¸“à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡',0),(497367,13816,'hi','à¤ªà¤° à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(497368,13816,'ms','Pada Qty pesanan',0),(497369,13816,'ar','ÙÙŠ ØªØ±ØªÙŠØ¨ Qty',0),(497370,13816,'fr','Sur la quantitÃ© d\'ordre',0),(497371,13816,'jp','æ³¨æ–‡æ•°é‡ã«',0),(497372,13816,'pt','Na ordem Qty',0),(497373,13816,'ru','ÐŸÐ¾ Ð·Ð°ÐºÐ°Ð·Ñƒ',0),(497374,13816,'es','En el orden Qty',0),(497375,13816,'de','Auf Bestellmenge',0),(497376,13816,'en','On Order Qty',0),(497377,13817,'is','',0),(497378,13817,'dr','Ø¨ÛŒØ´ Ø§Ø²/Ø²ÛŒØ±',0),(497379,13817,'pr','Ø¨ÛŒØ´ Ø§Ø²/Ø²ÛŒØ±',0),(497380,13817,'tr','AltÄ±/Ã¼stÃ¼',0),(497381,13817,'pl','PowyÅ¼ej/poniÅ¼ej',0),(497382,13817,'bg','ÐÐ°Ð´/Ð¿Ð¾Ð´',0),(497383,13817,'ur','Ø§ÙˆÙˆØ±/Ú©Û’ ØªØ­Øª',0),(497384,13817,'sr','Ð˜Ð·Ð½Ð°Ð´/Ð¸ÑÐ¿Ð¾Ð´',0),(497385,13817,'vi','TrÃªn/dÆ°á»›i',0),(497386,13817,'af','Oor/onder',0),(497387,13817,'ro','Peste/sub',0),(497388,13817,'et','Ãœle',0),(497389,13817,'si','PreveÄ/premalo',0),(497390,13817,'ba','Over/Under',0),(497391,13817,'nl','Over/onder',0),(497392,13817,'fi','Yli/alle',0),(497393,13817,'no','Over/Under',0),(497394,13817,'da','Over/Under',0),(497395,13817,'ko','ì˜¤ë²„/ì–¸ë”',0),(497396,13817,'he','×ž×¢×œ ×•×ž×ª×—×ª',0),(497397,13817,'el','Î Î¬Î½Ï‰/ÎºÎ¬Ï„Ï‰',0),(497398,13817,'zh','ä»¥ä¸Šä¸‹',0),(497399,13817,'sv','Ã–ver/Under',0),(497400,13817,'it','Sopra/sotto',0),(497401,13817,'tl','',0),(497402,13817,'th','à¸¡à¸²à¸/à¸™à¹‰à¸­à¸¢à¹€à¸à¸´à¸™',0),(497403,13817,'hi','à¤¸à¥‡ à¤…à¤§à¤¿à¤•/à¤¤à¤¹à¤¤',0),(497404,13817,'ms','Atas/di bawah',0),(497405,13817,'ar','Ø£ÙƒØ«Ø± Ù…Ù†/ØªØ­Øª',0),(497406,13817,'fr','Dessus/dessous',0),(497407,13817,'jp','ä¸Š/ä¸‹',0),(497408,13817,'pt','Sobre/sob',0),(497409,13817,'ru','ÐÐ°Ð´/Ð¿Ð¾Ð´',0),(497410,13817,'es','Over/Under',0),(497411,13817,'de','Ãœber/unter',0),(497412,13817,'en','Over/Under',0),(497413,13818,'is','',0),(497414,13818,'dr','Ø­Ø§Ø´ÛŒÙ‡ Ø³ÙˆØ¯',0),(497415,13818,'pr','Ø­Ø§Ø´ÛŒÙ‡ Ø³ÙˆØ¯',0),(497416,13818,'tr','Kar marjÄ±',0),(497417,13818,'pl','MarÅ¼a zysku',0),(497418,13818,'bg','ÐœÐ°Ñ€Ð¶ Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°Ñ‚Ð°',0),(497419,13818,'ur','Ù¾ÛŒÚ†ÛŒØ¯Û',0),(497420,13818,'sr','ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚Ð½Ð° Ð¼Ð°Ñ€Ð¶Ð°',0),(497421,13818,'vi','Lá»£i nhuáº­n',0),(497422,13818,'af','Winsmarge',0),(497423,13818,'ro','Marja de profit',0),(497424,13818,'et','Kasumimarginaal',0),(497425,13818,'si','Stopnja dobiÄka',0),(497426,13818,'ba','Margin keuntungan',0),(497427,13818,'nl','Winstmarge',0),(497428,13818,'fi','Voittomarginaali',0),(497429,13818,'no','Fortjenestemargin',0),(497430,13818,'da','Fortjenstmargen',0),(497431,13818,'ko','ì´ìµ ë§ˆì§„',0),(497432,13818,'he','×©×•×œ×™ ×¨×•×•×—',0),(497433,13818,'el','Î ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ ÎºÎ­ÏÎ´Î¿Ï…Ï‚',0),(497434,13818,'zh','åˆ©æ¶¦çŽ‡',0),(497435,13818,'sv','Vinstmarginal',0),(497436,13818,'it','Margine di profitto',0),(497437,13818,'tl','',0),(497438,13818,'th','à¸à¸³à¹„à¸£à¸‚à¸±à¹‰à¸™à¸•à¹‰à¸™',0),(497439,13818,'hi','à¤²à¤¾à¤­ à¤®à¤¾à¤°à¥à¤œà¤¿à¤¨',0),(497440,13818,'ms','Margin keuntungan',0),(497441,13818,'ar','Ù‡Ø§Ù…Ø´ Ø§Ù„Ø±Ø¨Ø­',0),(497442,13818,'fr','Marge bÃ©nÃ©ficiaire',0),(497443,13818,'jp','åˆ©ç›ŠçŽ‡',0),(497444,13818,'pt','Margem de lucro',0),(497445,13818,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ',0),(497446,13818,'es','Margen de ganancia',0),(497447,13818,'de','Gewinnspanne',0),(497448,13818,'en','Profit Margin',0),(497449,13819,'is','',0),(497450,13819,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…ÙˆØ±Ø¯ Ø¨Ø³ØªÙ‡',0),(497451,13819,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…ÙˆØ±Ø¯ Ø¨Ø³ØªÙ‡',0),(497452,13819,'tr','SatÄ±cÄ± durumda paketi',0),(497453,13819,'pl','Dostawcy Sprawa Pack',0),(497454,13819,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ»ÑƒÑ‡Ð°Ð¹ Ð¿Ð°ÐºÐµÑ‚',0),(497455,13819,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒØ³ Ù¾ÛŒÚ©',0),(497456,13819,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð° ÐŸÐ°Ñ†Ðº',0),(497457,13819,'vi','GÃ³i trÆ°á»ng há»£p nhÃ  cung cáº¥p',0),(497458,13819,'af','Handelaar geval pak',0),(497459,13819,'ro','Furnizor cauza Pack',0),(497460,13819,'et','Hankija puhul Pack',0),(497461,13819,'si','Prodajalec zadeva Pack',0),(497462,13819,'ba','Penjual kasus Pack',0),(497463,13819,'nl','Leverancier zaak Pack',0),(497464,13819,'fi','Toimittajan asia Pack',0),(497465,13819,'no','LeverandÃ¸ren Case Pack',0),(497466,13819,'da','Kreditor sag Pack',0),(497467,13819,'ko','ê³µê¸‰ ì—…ì²´ ì¼€ì´ìŠ¤ íŒ©',0),(497468,13819,'he','×—×‘×™×œ×ª ×‘×ž×§×¨×” ×©×œ ×¡×¤×§',0),(497469,13819,'el','Î ÎµÏÎ¯Ï€Ï„Ï‰ÏƒÎ· Pack Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(497470,13819,'zh','ä¾›åº”å•†è£…ç®±',0),(497471,13819,'sv','LeverantÃ¶r mÃ¥l Pack',0),(497472,13819,'it','Venditore caso Pack',0),(497473,13819,'tl','',0),(497474,13819,'th','à¸Šà¸¸à¸”à¸à¸£à¸“à¸µà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(497475,13819,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤°à¤£ à¤ªà¥ˆà¤•',0),(497476,13819,'ms','Pek kes penjual.',0),(497477,13819,'ar','Ø­Ø²Ù…Ø© Ø­Ø§Ù„Ø© Ø§Ù„Ù…ÙˆØ±Ø¯',0),(497478,13819,'fr','Vendeur affaire Pack',0),(497479,13819,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ã‚±ãƒ¼ã‚¹ ãƒ‘ãƒƒã‚¯',0),(497480,13819,'pt','Fornecedor caso Pack',0),(497481,13819,'ru','Ð¡Ð»ÑƒÑ‡Ð°Ðµ Ð¿Ð°ÐºÐµÑ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(497482,13819,'es','Paquete del caso proveedor',0),(497483,13819,'de','Hersteller Case Pack',0),(497484,13819,'en','Vendor Case Pack',0),(497485,13820,'is','',0),(497486,13820,'dr','Ø¨Ù‡Ù†Ú¯Ø§Ù… Ú©Ø±Ø¯Ù† Ù‡Ù…Ù‡ Ù…ÙˆØ§Ø±Ø¯ Ø±Ø§ Ø¨Ø§ Ù‚ÛŒÙ…Øª Ù‡Ø§ÛŒ ÙØ¹Ù„ÛŒ',0),(497487,13820,'pr','Ø¨Ù‡Ù†Ú¯Ø§Ù… Ú©Ø±Ø¯Ù† Ù‡Ù…Ù‡ Ù…ÙˆØ§Ø±Ø¯ Ø±Ø§ Ø¨Ø§ Ù‚ÛŒÙ…Øª Ù‡Ø§ÛŒ ÙØ¹Ù„ÛŒ',0),(497488,13820,'tr','TÃ¼m Ã¶ÄŸeleri geÃ§erli fiyat gÃ¼ncelleÅŸtirme',0),(497489,13820,'pl','Aktualizacja wszystkich elementÃ³w z aktualnych cen',0),(497490,13820,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð¹ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ñ Ñ‚ÐµÐºÑƒÑ‰Ð¸ Ñ†ÐµÐ½Ð¸',0),(497491,13820,'ur','ØªÙ…Ø§Ù… Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ù…ÙˆØ¬ÙˆØ¯Û Ù‚ÛŒÙ…ØªÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(497492,13820,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ ÑÐ²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ ÑÐ° Ð²Ð°Ð¶ÐµÑ›Ð¸Ð¼ Ñ†Ð¸Ñ˜ÐµÐ½Ð°Ð¼Ð°',0),(497493,13820,'vi','Cáº­p Nháº­t táº¥t cáº£ cÃ¡c má»¥c vá»›i cÃ¡c má»©c giÃ¡ hiá»‡n táº¡i',0),(497494,13820,'af','Dateer alle Items met huidige pryse',0),(497495,13820,'ro','ActualizaÅ£i toate elementele cu preÅ£uri curente',0),(497496,13820,'et','VÃ¤rskenda kÃµik Ã¼ksused jooksevhindades',0),(497497,13820,'si','Posodobi vse artikle z tekoÄih cenah',0),(497498,13820,'ba','Memperbarui semua item dengan harga saat ini',0),(497499,13820,'nl','Alle Items bijwerken met de huidige prijzen',0),(497500,13820,'fi','PÃ¤ivitÃ¤ kaikki kohteet kÃ¤ypinÃ¤ hintoina',0),(497501,13820,'no','Oppdatere alle elementer med gjeldende priser',0),(497502,13820,'da','Opdater alle elementer med de nuvÃ¦rende priser',0),(497503,13820,'ko','í˜„ìž¬ ê°€ê²©ìœ¼ë¡œ ëª¨ë“  í•­ëª©ì„ ì—…ë°ì´íŠ¸',0),(497504,13820,'he','×œ×¢×“×›×Ÿ ×›×œ ×”×¤×¨×™×˜×™× ×‘×ž×—×™×¨×™× ×©×•×˜×¤×™×',0),(497505,13820,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î¼Îµ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎµÏ‚ Ï„Î¹Î¼Î­Ï‚',0),(497506,13820,'zh','ç›®å‰çš„ä»·æ ¼æ›´æ–°æ‰€æœ‰é¡¹ç›®',0),(497507,13820,'sv','Uppdatera alla objekt med aktuella priser',0),(497508,13820,'it','Aggiornare tutti gli articoli con i prezzi correnti',0),(497509,13820,'tl','',0),(497510,13820,'th','à¸­à¸±à¸žà¹€à¸”à¸•à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸à¸±à¸šà¸£à¸²à¸„à¸²à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(497511,13820,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤­à¥€ à¤†à¤‡à¤Ÿà¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(497512,13820,'ms','Mengemaskini semua item dengan harga semasa',0),(497513,13820,'ar','ØªØ­Ø¯ÙŠØ« ÙƒØ§ÙØ© Ø§Ù„Ø£ØµÙ†Ø§Ù Ù…Ø¹ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(497514,13820,'fr','Mettre Ã  jour tous les Ã©lÃ©ments avec les prix actuels',0),(497515,13820,'jp','ç¾åœ¨ã®ä¾¡æ ¼ã¨ã™ã¹ã¦ã®ã‚¢ã‚¤ãƒ†ãƒ ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(497516,13820,'pt','Atualizar todos os itens com preÃ§os correntes',0),(497517,13820,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð²ÑÐµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ñ Ñ‚ÐµÐºÑƒÑ‰ÐµÐ¹ Ñ†ÐµÐ½Ñ‹',0),(497518,13820,'es','Actualizar todos los artÃ­culos con precios actuales',0),(497519,13820,'de','Aktualisieren Sie alle Elemente mit aktuellen Preisen',0),(497520,13820,'en','Update All Items With Current Prices',0),(497521,13821,'is','',0),(497522,13821,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù‚ÛŒÙ…Øª',0),(497523,13821,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù‚ÛŒÙ…Øª',0),(497524,13821,'tr','GÃ¼ncelleme fiyatlarÄ±',0),(497525,13821,'pl','Aktualizacja cen',0),(497526,13821,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¸',0),(497527,13821,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(497528,13821,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ†ÐµÐ½Ð°',0),(497529,13821,'vi','Cáº­p Nháº­t giÃ¡',0),(497530,13821,'af','Bywerking pryse',0),(497531,13821,'ro','ActualizaÅ£i preÅ£urile',0),(497532,13821,'et','Uuendada hindu',0),(497533,13821,'si','Posodobitev cene',0),(497534,13821,'ba','Memperbarui harga',0),(497535,13821,'nl','Prijzen bijwerken',0),(497536,13821,'fi','PÃ¤ivitÃ¤ hinnat',0),(497537,13821,'no','Oppdatere priser',0),(497538,13821,'da','Opdatere priser',0),(497539,13821,'ko','ê°€ê²© ì—…ë°ì´íŠ¸',0),(497540,13821,'he','×œ×¢×“×›×Ÿ ××ª ×”×ž×—×™×¨×™×',0),(497541,13821,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Ï„Î¹Î¼ÏŽÎ½',0),(497542,13821,'zh','æ›´æ–°ä»·æ ¼',0),(497543,13821,'sv','Uppdatera priser',0),(497544,13821,'it','Aggiornamento prezzi',0),(497545,13821,'tl','',0),(497546,13821,'th','à¸­à¸±à¸žà¹€à¸”à¸•à¸£à¸²à¸„à¸²',0),(497547,13821,'hi','à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(497548,13821,'ms','Kemaskini harga',0),(497549,13821,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(497550,13821,'fr','Mise Ã  jour des prix',0),(497551,13821,'jp','ä¾¡æ ¼ã®æ›´æ–°',0),(497552,13821,'pt','AtualizaÃ§Ã£o de preÃ§os',0),(497553,13821,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½',0),(497554,13821,'es','Actualizar precios',0),(497555,13821,'de','Preise aktualisieren',0),(497556,13821,'en','Update Prices',0),(497557,13822,'is','',0),(497558,13822,'dr','Ø¹Ù„Øª Ø´Ø§ÛŒØ¹ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø§Ø³Øª Ú©Ù‡ Ø§ÛŒÙ† Ù…ÙˆØ±Ø¯ Ø¯Ø± Ø§ÛŒÙ† Ù…Ú©Ø§Ù† ØªÙ†Ø¸ÛŒÙ… Ø´Ø¯Ù‡ Ø§Ø³Øª.',0),(497559,13822,'pr','Ø¹Ù„Øª Ø´Ø§ÛŒØ¹ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø§Ø³Øª Ú©Ù‡ Ø§ÛŒÙ† Ù…ÙˆØ±Ø¯ Ø¯Ø± Ø§ÛŒÙ† Ù…Ú©Ø§Ù† ØªÙ†Ø¸ÛŒÙ… Ø´Ø¯Ù‡ Ø§Ø³Øª.',0),(497560,13822,'tr','SÄ±k rastlanan nedeni Ã¶ÄŸesi bu konumda kurulmuÅŸ olan deÄŸil ki bu.',0),(497561,13822,'pl','CzÄ™stÄ… przyczynÄ… tego jest to, Å¼e element nie zostaÅ‚y skonfigurowane w tym miejscu.',0),(497562,13822,'bg','Ð’ÐµÑ€Ð¾ÑÑ‚Ð½Ð°Ñ‚Ð° Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð° Ð·Ð° Ñ‚Ð¾Ð²Ð° Ðµ, Ñ‡Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐ½Ð° Ð½Ð° Ñ‚Ð¾Ð²Ð° Ð¼ÑÑÑ‚Ð¾.',0),(497563,13822,'ur','Ø§Ø³ Ú©Û’ Ù„Ø¦Û’ Ù…Ø´ØªØ±Ú©Û Ù…Ù‚ØµØ¯ Ø´Û’ Ø§Ø³ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø± ØªØ±ØªÛŒØ¨ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Ù†Û Ú©Û ÛÛ’ Û”',0),(497564,13822,'sr','Ð£Ð¾Ð±Ð¸Ñ‡Ð°Ñ˜ÐµÐ½Ð¸ ÑƒÐ·Ñ€Ð¾Ðº Ð¾Ð²Ð¾Ð¼Ðµ Ñ˜Ðµ Ð´Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾Ð´ÐµÑˆÐµÐ½Ð° Ð½Ð° Ð¾Ð²Ð¾Ñ˜ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸.',0),(497565,13822,'vi','CÃ¡c nguyÃªn nhÃ¢n phá»• biáº¿n cho Ä‘iá»u nÃ y lÃ  ráº±ng má»¥c Ä‘Ã£ khÃ´ng Ä‘Æ°á»£c thiáº¿t láº­p táº¡i Ä‘iá»ƒm nÃ y.',0),(497566,13822,'af','Algemene oorsaak hiervoor is dat die item is nie opgestel nie in hierdie ligging.',0),(497567,13822,'ro','Cauza comunÄƒ pentru aceasta este cÄƒ elementul nu a fost stabilit la aceastÄƒ locaÅ£ie.',0),(497568,13822,'et','Levinud pÃµhjuseks on, et kaup ei ole seadistatud selles asukohas.',0),(497569,13822,'si','Pogost vzrok za to je, da artikla ni nastavljena na tej lokaciji.',0),(497570,13822,'ba','Penyebab umum untuk ini adalah bahwa item tidak telah ditetapkan di lokasi ini.',0),(497571,13822,'nl','Voorkomende oorzaak voor dit is dat het item niet op deze locatie heeft zijn ingesteld.',0),(497572,13822,'fi','TÃ¤mÃ¤ on, ettÃ¤ kohde ei ollut mÃ¤Ã¤ritetty tÃ¤ssÃ¤ sijainnissa.',0),(497573,13822,'no','Vanlig Ã¥rsak til dette er at varen ikke er satt pÃ¥ denne plasseringen.',0),(497574,13822,'da','Almindelige Ã¥rsag til dette er, at varen ikke er blevet sat op pÃ¥ denne placering.',0),(497575,13822,'ko','ì´ê²ƒì„ ìœ„í•œ ì¼ë°˜ì ì¸ ì›ì¸ì€ í•­ëª©ì—ì„œì´ ìœ„ì¹˜ ì„¤ì • ë˜ì§€ ì•Šì€ ê²ƒìž…ë‹ˆë‹¤.',0),(497576,13822,'he','×”×¡×™×‘×” ×”× ×¤×•×¦×” ×œ×›×š ×”×•× ×›×™ ×”×¤×¨×™×˜ ×œ× ×”×•×’×“×¨×” ×‘×ž×™×§×•× ×–×”.',0),(497577,13822,'el','Î£Ï…Î½Î·Î¸Î¹ÏƒÎ¼Î­Î½Î· Î±Î¹Ï„Î¯Î± Î³Î¹Î± Î±Ï…Ï„ÏŒ ÎµÎ¯Î½Î±Î¹ ÏŒÏ„Î¹ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ ÏƒÎµ Î±Ï…Ï„Î® Ï„Î· Î¸Î­ÏƒÎ·.',0),(497578,13822,'zh','å¸¸è§çš„åŽŸå› ï¼Œè¿™æ˜¯è¯¥é¡¹ç›®ä¸åœ¨æ­¤ä½ç½®è®¾ç½®ã€‚',0),(497579,13822,'sv','Vanlig orsak till detta Ã¤r att objektet inte har stÃ¤llts in pÃ¥ den hÃ¤r platsen.',0),(497580,13822,'it','Causa comune di questo Ã¨ che l\'elemento non Ã¨ stato impostato in questa posizione.',0),(497581,13822,'tl','',0),(497582,13822,'th','à¸›à¸±à¸à¸«à¸²à¸­à¸¢à¸¹à¹ˆà¸—à¸µà¹ˆà¸ªà¸´à¸™à¸„à¹‰à¸²à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸™à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸™à¸µà¹‰',0),(497583,13822,'hi','à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾à¤°à¤£ à¤†à¤® à¤†à¤‡à¤Ÿà¤® à¤‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¤° à¤•à¤¿ à¤¸à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¥¤',0),(497584,13822,'ms','Punca umum untuk ini adalah bahawa item tidak ditubuhkan di lokasi ini.',0),(497585,13822,'ar','Ø³Ø¨Ø¨ Ø´Ø§Ø¦Ø¹ Ù„Ù‡Ø°Ø§ Ø£Ù† Ù‡Ø°Ø§ Ø§Ù„Ø¨Ù†Ø¯ Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹.',0),(497586,13822,'fr','Cela, c\'est que l\'Ã©lÃ©ment n\'a pas Ã©tÃ© crÃ©Ã© Ã  cet endroit.',0),(497587,13822,'jp','ã“ã‚Œã®ãŸã‚ã®ä¸€èˆ¬çš„ãªåŽŸå› ã¯ã€é …ç›®ãŒè¨­å®šã•ã‚Œã¦ã„ãªã„ã“ã¨ã“ã®å ´æ‰€ã§ã€‚',0),(497588,13822,'pt','Uma causa comum para isso Ã© que o item nÃ£o foi definido neste local.',0),(497589,13822,'ru','Ð Ð°ÑÐ¿Ñ€Ð¾ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð½Ð¾Ð¹ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð¾Ð¹ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÑÐ²Ð»ÑÐµÑ‚ÑÑ, Ñ‡Ñ‚Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ðµ Ð±Ñ‹Ð» ÑÐ¾Ð·Ð´Ð°Ð½ Ð² ÑÑ‚Ð¾Ð¼ Ð¼ÐµÑÑ‚Ðµ.',0),(497590,13822,'es','Causa comÃºn para esto es que el artÃ­culo no se ha establecido para arriba en este lugar.',0),(497591,13822,'de','HÃ¤ufige Ursache dafÃ¼r ist, dass das Element an dieser Stelle nicht eingerichtet wurde.',0),(497592,13822,'en','Common cause for this is that the item has not been set up at this location.',0),(497593,13823,'is','',0),(497594,13823,'dr','Ù†Ù‡ Ú©Ø§Ù‡Ø´ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù…ÙˆØ±Ø¯',0),(497595,13823,'pr','Ù†Ù‡ Ú©Ø§Ù‡Ø´ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù…ÙˆØ±Ø¯',0),(497596,13823,'tr','Madde iÃ§in stok azaltabilir deÄŸil',0),(497597,13823,'pl','Nie moÅ¼e zmniejszyÄ‡ zapasÃ³w pozycji',0),(497598,13823,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼Ð°Ð»Ð¸ ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(497599,13823,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù… Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªÛ’ Û”',0),(497600,13823,'sr','ÐÐµ ÑÐ¼Ð°ÑšÐ¸ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»',0),(497601,13823,'vi','KhÃ´ng cÃ³ thá»ƒ lÃ m giáº£m hÃ ng tá»“n kho cho khoáº£n má»¥c',0),(497602,13823,'af','Kon nie verminder voorraad vir Item',0),(497603,13823,'ro','Nu ar putea Reduce inventar pentru articol',0),(497604,13823,'et','VÃµib vÃ¤hendada lao kirje',0),(497605,13823,'si','Lahko zmanjÅ¡a zaloge za artikel',0),(497606,13823,'ba','Tidak bisa mengurangi persediaan untuk Item',0),(497607,13823,'nl','Kon niet verminderen inventaris voor object',0),(497608,13823,'fi','Ei vÃ¤hennÃ¤ varaston nimikkeelle',0),(497609,13823,'no','Kan ikke redusere beholdningen For varen',0),(497610,13823,'da','Kunne ikke reducere lagerbeholdningen For vare',0),(497611,13823,'ko','í•­ëª©ì— ëŒ€ í•œ ìž¬ê³ ë¥¼ ì¤„ì¼ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(497612,13823,'he','×œ× ×™×›×•×œ ×œ×”×¤×—×™×ª ××ª ×ž×œ××™ ×¢×‘×•×¨ ×¤×¨×™×˜',0),(497613,13823,'el','Î”ÎµÎ½ Î¸Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î· Î¼ÎµÎ¯Ï‰ÏƒÎ· Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î³Î¹Î± Ï„Î¿ ÎµÎ¯Î´Î¿Ï‚',0),(497614,13823,'zh','å¹¶ä¸èƒ½é™ä½Žåº“å­˜ç‰©æ–™',0),(497615,13823,'sv','Kunde inte minska inventering fÃ¶r artikeln',0),(497616,13823,'it','Non potrebbe ridurre le scorte per elemento',0),(497617,13823,'tl','',0),(497618,13823,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¸¥à¸”à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²',0),(497619,13823,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤® à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(497620,13823,'ms','Dapat mengurangkan inventori bagi Item',0),(497621,13823,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ®ÙÙŠØ¶ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù„Ù„ØµÙ†Ù',0),(497622,13823,'fr','Pourrait pas rÃ©duire l\'inventaire pour l\'article',0),(497623,13823,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã®åœ¨åº«ã‚’æ¸›ã‚‰ã™ã“ã¨ãŒã§ãã‚‹ãªã„ã§ã™ã€‚',0),(497624,13823,'pt','NÃ£o poderia reduzir o estoque por Item',0),(497625,13823,'ru','ÐÐµ Ð¼Ð¾Ð³Ð»Ð¸ Ð±Ñ‹ ÑƒÐ¼ÐµÐ½ÑŒÑˆÐ¸Ñ‚ÑŒ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð´Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(497626,13823,'es','No podrÃ­a reducir inventario por artÃ­culo',0),(497627,13823,'de','Inventar konnte nicht fÃ¼r Element reduziert werden.',0),(497628,13823,'en','Could Not Reduce Inventory For Item',0),(497629,13824,'is','',0),(497630,13824,'dr','Ù…Ú©Ø§Ù† ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(497631,13824,'pr','Ù…Ú©Ø§Ù† ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(497632,13824,'tr','Konum yok',0),(497633,13824,'pl','Lokalizacja nie istnieje',0),(497634,13824,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(497635,13824,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(497636,13824,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(497637,13824,'vi','Vá»‹ trÃ­ khÃ´ng tá»“n táº¡i',0),(497638,13824,'af','Ligging nie bestaan',0),(497639,13824,'ro','LocaÅ£ia nu exista',0),(497640,13824,'et','Asukohta pole olemas',0),(497641,13824,'si','Mesto ne obstaja',0),(497642,13824,'ba','Lokasi tidak ada',0),(497643,13824,'nl','Locatie bestaat niet',0),(497644,13824,'fi','Sijaintia ei ole olemassa',0),(497645,13824,'no','Plasseringen finnes ikke',0),(497646,13824,'da','Beliggenhed findes ikke',0),(497647,13824,'ko','ìœ„ì¹˜ê°€ ì¡´ìž¬ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(497648,13824,'he','×”×ž×™×§×•× ××™× ×• ×§×™×™×',0),(497649,13824,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(497650,13824,'zh','ä½ç½®ä¸å­˜åœ¨',0),(497651,13824,'sv','Plats finns inte',0),(497652,13824,'it','Posizione non esiste',0),(497653,13824,'tl','',0),(497654,13824,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸•à¸³à¹à¸«à¸™à¹ˆà¸‡',0),(497655,13824,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(497656,13824,'ms','Lokasi tidak wujud',0),(497657,13824,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(497658,13824,'fr','Emplacement n\'existe pas',0),(497659,13824,'jp','å ´æ‰€ã¯å­˜åœ¨ã—ã¾ã›ã‚“',0),(497660,13824,'pt','LocalizaÃ§Ã£o nÃ£o existe',0),(497661,13824,'ru','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(497662,13824,'es','UbicaciÃ³n no existe',0),(497663,13824,'de','Lage ist nicht vorhanden.',0),(497664,13824,'en','Location Does Not Exist',0),(497665,13825,'is','',0),(497666,13825,'dr','Ø§ÛŒÙ† Ù…ÙˆØ±Ø¯ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(497667,13825,'pr','Ø§ÛŒÙ† Ù…ÙˆØ±Ø¯ ÙˆØ¬ÙˆØ¯ Ù†Ø¯Ø§Ø±Ø¯',0),(497668,13825,'tr','Bu Ã¶ÄŸe yok',0),(497669,13825,'pl','Ten element nie istnieje',0),(497670,13825,'bg','Ð¢Ð¾Ð·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(497671,13825,'ur','ÛŒÛ Ø´Û’ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº',0),(497672,13825,'sr','ÐžÐ²Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(497673,13825,'vi','Khoáº£n má»¥c nÃ y khÃ´ng tá»“n táº¡i',0),(497674,13825,'af','Hierdie Item bestaan nie',0),(497675,13825,'ro','Acest element nu exista',0),(497676,13825,'et','Seda Ã¼ksust pole olemas',0),(497677,13825,'si','Ta element ne obstaja',0),(497678,13825,'ba','Item ini tidak ada',0),(497679,13825,'nl','Dit object bestaat niet',0),(497680,13825,'fi','TÃ¤tÃ¤ kohdetta ei ole',0),(497681,13825,'no','Dette elementet finnes ikke',0),(497682,13825,'da','Dette element findes ikke',0),(497683,13825,'ko','ì´ í•­ëª©ì´ ì¡´ìž¬ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(497684,13825,'he','×¤×¨×™×˜ ×–×” ××™× ×• ×§×™×™×',0),(497685,13825,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹',0),(497686,13825,'zh','æ­¤é¡¹ä¸å­˜åœ¨',0),(497687,13825,'sv','Objektet finns inte',0),(497688,13825,'it','Questo elemento non esiste',0),(497689,13825,'tl','',0),(497690,13825,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸²à¸¢à¸à¸²à¸£à¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆ',0),(497691,13825,'hi','à¤¯à¤¹ à¤†à¤‡à¤Ÿà¤® à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(497692,13825,'ms','Perkara ini tidak wujud',0),(497693,13825,'ar','Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù†ØµØ± ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯',0),(497694,13825,'fr','Cet Ã©lÃ©ment n\'existe pas',0),(497695,13825,'jp','ã“ã®é …ç›®ã¯å­˜åœ¨ã—ã¾ã›ã‚“',0),(497696,13825,'pt','Este Item nÃ£o existe',0),(497697,13825,'ru','Ð­Ñ‚Ð¾Ñ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(497698,13825,'es','Este elemento no existe',0),(497699,13825,'de','Dieses Element ist nicht vorhanden',0),(497700,13825,'en','This Item Does Not Exist',0),(497701,13826,'is','',0),(497702,13826,'dr','ØªÙˆÙ„ÛŒØ¯ Ø®ÙˆØ¯Ú©Ø§Ø± Ø´Ù…Ø§Ø±Ù‡ Ú©ÙˆÙ¾Ù†',0),(497703,13826,'pr','ØªÙˆÙ„ÛŒØ¯ Ø®ÙˆØ¯Ú©Ø§Ø± Ø´Ù…Ø§Ø±Ù‡ Ú©ÙˆÙ¾Ù†',0),(497704,13826,'tr','FiÅŸ numarasÄ± otomatik olarak oluÅŸtur',0),(497705,13826,'pl','Automatyczne generowanie numeru zaÅ‚Ä…cznika',0),(497706,13826,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(497707,13826,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø®ÙˆØ¯ Ù¾ÛŒØ¯Ø§',0),(497708,13826,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð³ÐµÐ½ÐµÑ€Ð¸ÑÐ°ÑšÐµ Ð±Ñ€Ð¾Ñ˜ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(497709,13826,'vi','Tá»± Ä‘á»™ng táº¡o ra chá»©ng tá»« sá»‘',0),(497710,13826,'af','Outo-genereer bewys nommer',0),(497711,13826,'ro','NumÄƒrul de Voucher auto-genera',0),(497712,13826,'et','Loo kande Number',0),(497713,13826,'si','Samodejno ustvari Å¡tevilko kupona',0),(497714,13826,'ba','Auto-menghasilkan nomor Voucher',0),(497715,13826,'nl','Bonnummer automatisch genereren',0),(497716,13826,'fi','Luo automaattisesti tositenumero',0),(497717,13826,'no','Automatisk generere bilagsnummeret',0),(497718,13826,'da','Auto-generering af bilagsnummer',0),(497719,13826,'ko','ë°”ìš°ì²˜ ë²ˆí˜¸ ìžë™ ìƒì„±',0),(497720,13826,'he','×ž×¡×¤×¨ ×©×•×‘×¨ ×©× ×•×¦×¨×• ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(497721,13826,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î±ÏÎ¹Î¸Î¼ÏŒ Voucher',0),(497722,13826,'zh','è‡ªåŠ¨ç”Ÿæˆå‡­è¯å·',0),(497723,13826,'sv','Automatiskt skapa verifikationsnummer',0),(497724,13826,'it','Numero Voucher auto-generare',0),(497725,13826,'tl','',0),(497726,13826,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸—à¸µà¹ˆà¸ªà¸£à¹‰à¸²à¸‡à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(497727,13826,'hi','à¤‘à¤Ÿà¥‹ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨-à¤µà¤¾à¤‰à¤šà¤° à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(497728,13826,'ms','Auto-menjana nombor baucer',0),(497729,13826,'ar','Ø¥Ù†Ø´Ø§Ø¡ ØªÙ„Ù‚Ø§Ø¦ÙŠ Ù„Ø±Ù‚Ù… Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(497730,13826,'fr','GÃ©nÃ©rer automatiquement le numÃ©ro de coupon',0),(497731,13826,'jp','ä¼ç¥¨ç•ªå·ã‚’è‡ªå‹•ç”Ÿæˆã—ã¾ã™ã€‚',0),(497732,13826,'pt','Gerar automaticamente o nÃºmero do comprovante',0),(497733,13826,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(497734,13826,'es','GeneraciÃ³n automÃ¡tica de nÃºmero de comprobante',0),(497735,13826,'de','Automatisches Generieren von Gutschein-Nummer',0),(497736,13826,'en','Auto-Generate Voucher Number',0),(497737,13827,'is','',0),(497738,13827,'dr','Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(497739,13827,'pr','Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(497740,13827,'tr','Yeni kredi kartÄ± satÄ±n',0),(497741,13827,'pl','Nowy zakup kartÄ… kredytowÄ…',0),(497742,13827,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(497743,13827,'ur','Ù†Ø¦Û’ Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(497744,13827,'sr','ÐÐ¾Ð²Ñƒ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(497745,13827,'vi','Má»›i tháº» tÃ­n dá»¥ng mua hÃ ng',0),(497746,13827,'af','Nuwe kredietkaart aankoop',0),(497747,13827,'ro','Noul Card de Credit cumpÄƒrare',0),(497748,13827,'et','Uue krediitkaardi ostu',0),(497749,13827,'si','Nov nakup kreditni kartici',0),(497750,13827,'ba','Pembelian kartu kredit baru',0),(497751,13827,'nl','Nieuwe creditcard aankoop',0),(497752,13827,'fi','Uuden luottokortin hankinta',0),(497753,13827,'no','Nye kredittkort kjÃ¸p',0),(497754,13827,'da','Nye kreditkort kÃ¸b',0),(497755,13827,'ko','ìƒˆë¡œìš´ ì‹ ìš© ì¹´ë“œ êµ¬ìž…',0),(497756,13827,'he','×¨×›×™×©×ª ×›×¨×˜×™×¡ ××©×¨××™ ×—×“×©',0),(497757,13827,'el','ÎÎ­Î± Î±Î³Î¿ÏÎ¬ Î¼Î­ÏƒÏ‰ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(497758,13827,'zh','æ–°çš„ä¿¡ç”¨å¡è´­ä¹°',0),(497759,13827,'sv','Nya kreditkort kÃ¶p',0),(497760,13827,'it','Nuovo acquisto di carta di credito',0),(497761,13827,'tl','',0),(497762,13827,'th','à¸‹à¸·à¹‰à¸­à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¹ƒà¸«à¸¡à¹ˆ',0),(497763,13827,'hi','à¤¨à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦',0),(497764,13827,'ms','Baru kad kredit pembelian',0),(497765,13827,'ar','Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù† Ø¬Ø¯ÙŠØ¯Ø©',0),(497766,13827,'fr','Nouvel achat de carte de crÃ©dit',0),(497767,13827,'jp','æ–°ã—ã„ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã§è³¼å…¥',0),(497768,13827,'pt','Nova compra de cartÃ£o de crÃ©dito',0),(497769,13827,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÑƒ Ð½Ð¾Ð²Ñ‹Ñ… ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(497770,13827,'es','Nueva compra de tarjeta de crÃ©dito',0),(497771,13827,'de','Neue Kreditkarte kaufen',0),(497772,13827,'en','New Credit Card Purchase',0),(497773,13828,'is','',0),(497774,13828,'dr','ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÛŒ Ø§ÛŒÙ…ÛŒÙ„ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(497775,13828,'pr','ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÛŒ Ø§ÛŒÙ…ÛŒÙ„ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(497776,13828,'tr','E-postayla PO',0),(497777,13828,'pl','PO e-mailem',0),(497778,13828,'bg','PO ÐµÐ¼Ð°Ð¹Ð»',0),(497779,13828,'ur','Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© Ù¾Ùˆ',0),(497780,13828,'sr','ÐŸÐž Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð»',0),(497781,13828,'vi','PO gá»­i qua email',0),(497782,13828,'af','Posbus per e-pos',0),(497783,13828,'ro','PO prin E-mail',0),(497784,13828,'et','PO meilitsi',0),(497785,13828,'si','PO po e-poÅ¡ti',0),(497786,13828,'ba','PO diemail',0),(497787,13828,'nl','PO per E-mail',0),(497788,13828,'fi','PO sÃ¤hkÃ¶postitse',0),(497789,13828,'no','PO sendt',0),(497790,13828,'da','PO mailede',0),(497791,13828,'ko','ì´ë©”ì¼ë¡œ í¬',0),(497792,13828,'he','×¤×• ×‘×“×•×',0),(497793,13828,'el','PO Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(497794,13828,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€çš„å®',0),(497795,13828,'sv','PO mailade',0),(497796,13828,'it','PO via E-mail',0),(497797,13828,'tl','',0),(497798,13828,'th','PO à¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥',0),(497799,13828,'hi','à¤ˆà¤®à¥‡à¤² à¤ªà¥‹',0),(497800,13828,'ms','PO melalui e-mel',0),(497801,13828,'ar','Øµ. Ø¨. Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(497802,13828,'fr','PO par courriel',0),(497803,13828,'jp','PO ã‚’ãƒ¡ãƒ¼ãƒ«ã§é€ä¿¡',0),(497804,13828,'pt','PO por E-mail',0),(497805,13828,'ru','ÐŸÐž ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(497806,13828,'es','PO por correo electrÃ³nico',0),(497807,13828,'de','PO per E-Mail',0),(497808,13828,'en','PO Emailed',0),(497809,13829,'is','',0),(497810,13829,'dr','Ú¯Ø²Ø§Ø±Ø´ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(497811,13829,'pr','Ú¯Ø²Ø§Ø±Ø´ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(497812,13829,'tr','Not raporu',0),(497813,13829,'pl','Raport stwierdza',0),(497814,13829,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð·Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(497815,13829,'ur','Ù†ÙˆÙ¹ Ø±Ù¾ÙˆØ±Ù¹',0),(497816,13829,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(497817,13829,'vi','BÃ¡o cÃ¡o ghi chÃº',0),(497818,13829,'af','Notas verslag',0),(497819,13829,'ro','Notele de raport',0),(497820,13829,'et','MÃ¤rgib aruanne',0),(497821,13829,'si','Ugotavlja poroÄilo',0),(497822,13829,'ba','Catatan laporan',0),(497823,13829,'nl','Notities verslag',0),(497824,13829,'fi','Huomautuksia raportissa',0),(497825,13829,'no','Notater rapport',0),(497826,13829,'da','Noter rapport',0),(497827,13829,'ko','ë©”ëª¨ ë³´ê³ ì„œ',0),(497828,13829,'he','×”×¢×¨×•×ª ×“×• ×—',0),(497829,13829,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î­ÎºÎ¸ÎµÏƒÎ·',0),(497830,13829,'zh','æ³¨æ„åˆ°æŠ¥å‘Š',0),(497831,13829,'sv','Anteckningar rapport',0),(497832,13829,'it','Relazione di note',0),(497833,13829,'tl','',0),(497834,13829,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(497835,13829,'hi','à¤¨à¥‹à¤Ÿ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(497836,13829,'ms','Laporan Nota-Nota',0),(497837,13829,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(497838,13829,'fr','Rapport de notes',0),(497839,13829,'jp','ãƒ¡ãƒ¢ ãƒ¬ãƒãƒ¼ãƒˆ',0),(497840,13829,'pt','RelatÃ³rio de notas',0),(497841,13829,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(497842,13829,'es','Informe de notas',0),(497843,13829,'de','Notizen-Bericht',0),(497844,13829,'en','Notes Report',0),(497845,13830,'is','',0),(497846,13830,'dr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ú©Ù„Ù…Ù‡ Ú©Ù„ÛŒØ¯ÛŒ',0),(497847,13830,'pr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ú©Ù„Ù…Ù‡ Ú©Ù„ÛŒØ¯ÛŒ',0),(497848,13830,'tr','Not anahtar sÃ¶zcÃ¼k',0),(497849,13830,'pl','Uwaga sÅ‚owa kluczowego',0),(497850,13830,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° ÐºÐ»ÑŽÑ‡Ð¾Ð²Ð° Ð´ÑƒÐ¼Ð°',0),(497851,13830,'ur','Ù†ÙˆÙ¹ Ú©Ù„ÛŒØ¯ÛŒ Ù„ÙØ¸',0),(497852,13830,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° ÐºÑ™ÑƒÑ‡Ð½Ñƒ Ñ€ÐµÑ‡',0),(497853,13830,'vi','LÆ°u Ã½ tá»« khÃ³a',0),(497854,13830,'af','Nota trefwoord',0),(497855,13830,'ro','NotÄƒ de cuvinte cheie',0),(497856,13830,'et','Lisa mÃ¤rksÃµna',0),(497857,13830,'si','Opomba kljuÄno besedo',0),(497858,13830,'ba','Kunci Catatan',0),(497859,13830,'nl','Opmerking trefwoord',0),(497860,13830,'fi','Huomautus avainsana',0),(497861,13830,'no','Merk nÃ¸kkelordet',0),(497862,13830,'da','BemÃ¦rk nÃ¸gleordet',0),(497863,13830,'ko','ì°¸ê³  í‚¤ì›Œë“œ',0),(497864,13830,'he','×”×¢×¨×” ×ž×™×œ×ª ×ž×¤×ª×—',0),(497865,13830,'el','Î›Î­Î¾Î·-ÎºÎ»ÎµÎ¹Î´Î¯ Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(497866,13830,'zh','æ³¨æ„å…³é”®å­—',0),(497867,13830,'sv','Obs sÃ¶kord',0),(497868,13830,'it','Parola chiave nota',0),(497869,13830,'tl','',0),(497870,13830,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸ªà¸³à¸„à¸±à¸',0),(497871,13830,'hi','à¤¨à¥‹à¤Ÿ à¤•à¥€à¤µà¤°à¥à¤¡',0),(497872,13830,'ms','Nota kata kunci',0),(497873,13830,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„ÙƒÙ„Ù…Ø© Ø§Ù„Ø£Ø³Ø§Ø³ÙŠØ©',0),(497874,13830,'fr','Remarque mot-clÃ©',0),(497875,13830,'jp','ãƒ¡ãƒ¢ ã‚­ãƒ¼ãƒ¯ãƒ¼ãƒ‰',0),(497876,13830,'pt','Palavra-chave nota',0),(497877,13830,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ ÐºÐ»ÑŽÑ‡ÐµÐ²Ð¾Ðµ ÑÐ»Ð¾Ð²Ð¾',0),(497878,13830,'es','Nota clave',0),(497879,13830,'de','Hinweis-SchlÃ¼sselwort',0),(497880,13830,'en','Note Keyword',0),(497881,13831,'is','',0),(497882,13831,'dr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ù†ÙˆØ¹',0),(497883,13831,'pr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ù†ÙˆØ¹',0),(497884,13831,'tr','Not tÃ¼rÃ¼nÃ¼',0),(497885,13831,'pl','Uwaga typu',0),(497886,13831,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° Ñ‚Ð¸Ð¿',0),(497887,13831,'ur','Ù†ÙˆÙ¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(497888,13831,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° Ñ‚Ð¸Ð¿Ð°',0),(497889,13831,'vi','LÆ°u Ã½ loáº¡i',0),(497890,13831,'af','Nota tipe',0),(497891,13831,'ro','NotÄƒ tipul',0),(497892,13831,'et','MÃ¤rkuse tÃ¼Ã¼p',0),(497893,13831,'si','Vrsta opombe',0),(497894,13831,'ba','Jenis catatan',0),(497895,13831,'nl','Opmerking Type',0),(497896,13831,'fi','Huomautuksen tyyppi',0),(497897,13831,'no','Merknadstypen',0),(497898,13831,'da','BemÃ¦rk Type',0),(497899,13831,'ko','ì°¸ê³  ìœ í˜•',0),(497900,13831,'he','×¡×•×’ ×”×¢×¨×”',0),(497901,13831,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· Ï„ÏÏ€Î¿Ï…',0),(497902,13831,'zh','æ³¨é‡Šç±»åž‹',0),(497903,13831,'sv','Obs typ',0),(497904,13831,'it','Tipo di nota',0),(497905,13831,'tl','',0),(497906,13831,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸',0),(497907,13831,'hi','à¤¨à¥‹à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(497908,13831,'ms','Jenis Nota',0),(497909,13831,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ù†ÙˆØ¹',0),(497910,13831,'fr','Type de note',0),(497911,13831,'jp','ãƒ¡ãƒ¢åž‹',0),(497912,13831,'pt','Tipo de nota',0),(497913,13831,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ Ð¢Ð¸Ð¿',0),(497914,13831,'es','Tipo de nota',0),(497915,13831,'de','Hinweis-Typ',0),(497916,13831,'en','Note Type',0),(497917,13832,'is','',0),(497918,13832,'dr','Ù†Ù…Ø§ÛŒØ´ Ú©Ø§Ù…Ù„ ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯',0),(497919,13832,'pr','Ù†Ù…Ø§ÛŒØ´ Ú©Ø§Ù…Ù„ ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯',0),(497920,13832,'tr','Tam not gÃ¶ster',0),(497921,13832,'pl','PokaÅ¼ peÅ‚ne notatki',0),(497922,13832,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿ÑŠÐ»Ð½Ð°Ñ‚Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(497923,13832,'ur','Ù…Ú©Ù…Ù„ Ù†ÙˆÙ¹ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(497924,13832,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿ÑƒÐ½Ñƒ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(497925,13832,'vi','LÆ°u Ã½ Ä‘áº§y Ä‘á»§ Hiá»ƒn thá»‹',0),(497926,13832,'af','Wys volledige Nota',0),(497927,13832,'ro','AratÄƒ complet NotÄƒ',0),(497928,13832,'et','NÃ¤ita tÃ¤is MÃ¤rkus',0),(497929,13832,'si','PrikaÅ¾i polno Opomba',0),(497930,13832,'ba','Tampilkan catatan lengkap',0),(497931,13832,'nl','Toon volledige opmerking',0),(497932,13832,'fi','NÃ¤ytÃ¤ koko Huomautus',0),(497933,13832,'no','Vis Full notat',0),(497934,13832,'da','Vis fuld BemÃ¦rk',0),(497935,13832,'ko','ì „ì²´ ë…¸íŠ¸ ë³´ê¸°',0),(497936,13832,'he','×”×¦×’ ×”×¢×¨×” ×ž×œ×',0),(497937,13832,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Î»Î®ÏÎ¿Ï…Ï‚ Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(497938,13832,'zh','æ˜¾ç¤ºå®Œæ•´çš„æ³¨é‡Š',0),(497939,13832,'sv','Visa Full Obs',0),(497940,13832,'it','Visualizza la nota completa',0),(497941,13832,'tl','',0),(497942,13832,'th','à¹à¸ªà¸”à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¹€à¸•à¹‡à¸¡',0),(497943,13832,'hi','à¤ªà¥‚à¤°à¤¾ à¤¨à¥‹à¤Ÿ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(497944,13832,'ms','Menunjukkan Nota penuh',0),(497945,13832,'ar','ÙˆØªØ¨ÙŠÙ† Ø§Ù„Ù…Ø°ÙƒØ±Ø© ÙƒØ§Ù…Ù„Ø©',0),(497946,13832,'fr','Voir la Note complÃ¨te',0),(497947,13832,'jp','å®Œå…¨ãªãƒ¡ãƒ¢ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(497948,13832,'pt','Mostrar nota completa',0),(497949,13832,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ð¾Ð»Ð½Ð¾ÑÑ‚ÑŒÑŽ',0),(497950,13832,'es','Ver nota completa',0),(497951,13832,'de','VollstÃ¤ndige Notiz anzeigen',0),(497952,13832,'en','Show Full Note',0),(497953,13833,'is','',0),(497954,13833,'dr','Workstep',0),(497955,13833,'pr','Workstep',0),(497956,13833,'tr','Workstep',0),(497957,13833,'pl','Workstep',0),(497958,13833,'bg','Workstep',0),(497959,13833,'ur','ÙˆØ§Ø±Ú©Ø³Ù¹Ù¾',0),(497960,13833,'sr','WÐ¾Ñ€ÐºÑÑ‚ÐµÐ¿',0),(497961,13833,'vi','Workstep',0),(497962,13833,'af','Workstep',0),(497963,13833,'ro','Workstep',0),(497964,13833,'et','Workstep',0),(497965,13833,'si','Workstep',0),(497966,13833,'ba','Workstep',0),(497967,13833,'nl','Workstep',0),(497968,13833,'fi','Workstep',0),(497969,13833,'no','Workstep',0),(497970,13833,'da','Workstep',0),(497971,13833,'ko','Workstep',0),(497972,13833,'he','Workstep',0),(497973,13833,'el','Workstep',0),(497974,13833,'zh','Workstep',0),(497975,13833,'sv','Workstep',0),(497976,13833,'it','Workstep',0),(497977,13833,'tl','',0),(497978,13833,'th','Workstep',0),(497979,13833,'hi','Workstep',0),(497980,13833,'ms','Workstep',0),(497981,13833,'ar','ÙˆÙŠØ±ÙƒØ³ØªØ¨',0),(497982,13833,'fr','Workstep',0),(497983,13833,'jp','Workstep',0),(497984,13833,'pt','Workstep',0),(497985,13833,'ru','Ð£ÐžÐ ÐšÐ¡Ð¢Ð•ÐŸ',0),(497986,13833,'es','Workstep',0),(497987,13833,'de','Arbeitsschritt',0),(497988,13833,'en','Workstep',0),(497989,13834,'is','',0),(497990,13834,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Worksteps',0),(497991,13834,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Worksteps',0),(497992,13834,'tr','Worksteps Ekle',0),(497993,13834,'pl','Dodaj Worksteps',0),(497994,13834,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Worksteps',0),(497995,13834,'ur','ÙˆÙˆØ±Ú©Ø³Ù¹ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(497996,13834,'sr','Ð”Ð¾Ð´Ð°Ñ˜ WÐ¾Ñ€ÐºÑÑ‚ÐµÐ¿Ñ',0),(497997,13834,'vi','Worksteps thÃªm',0),(497998,13834,'af','Worksteps voeg',0),(497999,13834,'ro','Adauga Worksteps',0),(498000,13834,'et','Worksteps lisamine',0),(498001,13834,'si','Dodaj Worksteps',0),(498002,13834,'ba','Tambahkan Worksteps',0),(498003,13834,'nl','Worksteps toevoegen',0),(498004,13834,'fi','Worksteps lisÃ¤Ã¤',0),(498005,13834,'no','Worksteps legge til',0),(498006,13834,'da','Worksteps tilfÃ¸je',0),(498007,13834,'ko','Worksteps ì¶”ê°€',0),(498008,13834,'he','×”×•×¡×¤×ª Worksteps',0),(498009,13834,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Worksteps',0),(498010,13834,'zh','Worksteps æ·»åŠ ',0),(498011,13834,'sv','Worksteps LÃ¤gg till',0),(498012,13834,'it','Aggiungi tappo',0),(498013,13834,'tl','',0),(498014,13834,'th','à¹€à¸žà¸´à¹ˆà¸¡ Worksteps',0),(498015,13834,'hi','Worksteps à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(498016,13834,'ms','Tambah Worksteps',0),(498017,13834,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆÙˆØ±ÙƒØ³ØªÙŠØ¨Ø³',0),(498018,13834,'fr','Ajouter des embouts',0),(498019,13834,'jp','Worksteps è¿½åŠ ã—ã¾ã™ã€‚',0),(498020,13834,'pt','Adicionar Worksteps',0),(498021,13834,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Worksteps',0),(498022,13834,'es','Agregar Worksteps',0),(498023,13834,'de','Arbeitsstufen hinzufÃ¼gen',0),(498024,13834,'en','Worksteps Add',0),(498025,13835,'is','',0),(498026,13835,'dr','Ø­Ø¯Ø§Ù‚Ù„ Ù…Ø¨Ù„Øº Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø³Ø§Ù„ Ø´Ø§Ù…Ù„',0),(498027,13835,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ù…Ø¨Ù„Øº Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø³Ø§Ù„ Ø´Ø§Ù…Ù„',0),(498028,13835,'tr','Minimum tutar dahil etmek yÄ±l iÃ§in Ã¶denen',0),(498029,13835,'pl','Minimalne kwoty zapÅ‚aconej za rok do',0),(498030,13835,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°, Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð° Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð° ÑÐµ Ð²ÐºÐ»ÑŽÑ‡Ð°Ñ‚',0),(498031,13835,'ur','Ú©Ù… Ø³Û’ Ú©Ù… Ø±Ù‚Ù… Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø³Ø§Ù„ Ø§Ø¯Ø§ Ú©ÛŒØ§',0),(498032,13835,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð° Ð´Ð° ÑÐµ ÑƒÐºÑ™ÑƒÑ‡Ð¸',0),(498033,13835,'vi','Tá»‘i thiá»ƒu sá»‘ tiá»n tráº£ cho nÄƒm Ä‘á»ƒ bao gá»“m',0),(498034,13835,'af','Minimum bedrag betaal vir die jaar in te sluit',0),(498035,13835,'ro','Suma minimÄƒ plÄƒtitÄƒ pentru anul sÄƒ includÄƒ',0),(498036,13835,'et','Minimaalne summa eest aastaks hÃµlmavad',0),(498037,13835,'si','Minimalni znesek plaÄanih za leto vkljuÄujejo',0),(498038,13835,'ba','Jumlah minimum yang dibayar untuk tahun untuk memasukkan',0),(498039,13835,'nl','Minimum bedrag betaald voor jaar op te nemen',0),(498040,13835,'fi','Pienin summa maksetaan sisÃ¤llytettÃ¤vÃ¤t vuoden',0),(498041,13835,'no','MinimumsbelÃ¸pet betalt for Ã¥ret som skal inkluderes',0),(498042,13835,'da','Minimum belÃ¸b betalt for Ã¥r at medtage',0),(498043,13835,'ko','ìµœì†Œ ê¸ˆì•¡ì„ í¬í•¨ í•´ ì§€ê¸‰',0),(498044,13835,'he','×”×¡×›×•× ×”×ž×™× ×™×ž×œ×™ ×©×™×œ×ž×ª×™ ×©× ×” ×œ×›×œ×•×œ',0),(498045,13835,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î¿ Ï€Î¿ÏƒÏŒ Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»ÎµÏ„Î±Î¹ Î³Î¹Î± Ï„Î¿ Ï‡ÏÏŒÎ½Î¿ Î½Î± Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½',0),(498046,13835,'zh','å¹´ï¼Œä»¥åŒ…æ‹¬æ”¯ä»˜çš„æœ€ä½Žé‡‘é¢',0),(498047,13835,'sv','LÃ¤gsta belopp som betalats fÃ¶r Ã¥r till att omfatta',0),(498048,13835,'it','Importo minimo pagato per anno includere',0),(498049,13835,'tl','',0),(498050,13835,'th','à¹€à¸‡à¸´à¸™à¸‚à¸±à¹‰à¸™à¸•à¹ˆà¸³à¹ƒà¸™à¸›à¸µà¸—à¸µà¹ˆà¸ˆà¸°à¸£à¸§à¸¡',0),(498051,13835,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤°à¥à¤· à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾',0),(498052,13835,'ms','Jumlah minimum yang dibayar bagi tahun termasuk',0),(498053,13835,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù„Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¯ÙÙˆØ¹ Ù„Ù…Ø¯Ø© Ø³Ù†Ø© ØªØ´Ù…Ù„',0),(498054,13835,'fr','Montant minimum versÃ© pour l\'annÃ©e Ã  inclure',0),(498055,13835,'jp','æœ€å°é™ã‚’å«ã‚ã‚‹å¹´ã«æ”¯æ‰•ã‚',0),(498056,13835,'pt','Quantidade mÃ­nima paga por ano incluir',0),(498057,13835,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ ÑÑƒÐ¼Ð¼Ð°, ÑƒÐ¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ð°Ñ Ð·Ð° Ð³Ð¾Ð´ Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ',0),(498058,13835,'es','Monto mÃ­nimo pagado por aÃ±o para incluir',0),(498059,13835,'de','Mindestbetrag fÃ¼r Jahr gehÃ¶ren bezahlt',0),(498060,13835,'en','Minimum Amount Paid for Year to Include',0),(498061,13836,'is','',0),(498062,13836,'dr','Ù…Ø´ØªØ±ÛŒ Ùˆ ÙØ§Ú©ØªÙˆØ±',0),(498063,13836,'pr','Ù…Ø´ØªØ±ÛŒ Ùˆ ÙØ§Ú©ØªÙˆØ±',0),(498064,13836,'tr','MÃ¼ÅŸteri ve fatura',0),(498065,13836,'pl','Klienta i faktury',0),(498066,13836,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(498067,13836,'ur','Ú¯Ø§ÛÚ© Ø§ÙˆØ± Ø§Ù†ÙˆØ§Ø¦Ø³',0),(498068,13836,'sr','ÐšÑƒÐ¿Ð°Ñ†Ð° Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(498069,13836,'vi','KhÃ¡ch hÃ ng vÃ  hÃ³a Ä‘Æ¡n',0),(498070,13836,'af','KliÃ«nt en faktuur',0),(498071,13836,'ro','Client si factura',0),(498072,13836,'et','Kliendi ja arve',0),(498073,13836,'si','Kupca in raÄun',0),(498074,13836,'ba','Pelanggan dan faktur',0),(498075,13836,'nl','Klant en factuur',0),(498076,13836,'fi','Asiakas- ja laskutilastot',0),(498077,13836,'no','Kunde og faktura',0),(498078,13836,'da','Kunde og faktura',0),(498079,13836,'ko','ê³ ê° ë° ì†¡ìž¥',0),(498080,13836,'he','×—×©×‘×•× ×™×•×ª ×©×œ ×œ×§×•×—×•×ª',0),(498081,13836,'el','Î ÎµÎ»Î¬Ï„Î· ÎºÎ±Î¹ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(498082,13836,'zh','å®¢æˆ·å’Œå‘ç¥¨',0),(498083,13836,'sv','Kund och faktura',0),(498084,13836,'it','Cliente e fattura',0),(498085,13836,'tl','',0),(498086,13836,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹à¸¥à¸°à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(498087,13836,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤”à¤° à¤šà¤¾à¤²à¤¾à¤¨',0),(498088,13836,'ms','Pelanggan dan invois',0),(498089,13836,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ÙˆØ§Ù„ÙØ§ØªÙˆØ±Ø©',0),(498090,13836,'fr','Client et facture',0),(498091,13836,'jp','é¡§å®¢ã‚„è«‹æ±‚æ›¸',0),(498092,13836,'pt','Cliente e fatura',0),(498093,13836,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸ ÑÑ‡ÐµÑ‚Ð°',0),(498094,13836,'es','AtenciÃ³n al cliente y facturaciÃ³n',0),(498095,13836,'de','Kunden- und Rechnung',0),(498096,13836,'en','Customer and Invoice',0),(498097,13837,'is','',0),(498098,13837,'dr','Ø§ÛŒÙ…ÛŒÙ„ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(498099,13837,'pr','Ø§ÛŒÙ…ÛŒÙ„ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(498100,13837,'tr','E-posta faturalar',0),(498101,13837,'pl','Poczty elektronicznej faktury',0),(498102,13837,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð¸Ð¼ÐµÐ¹Ð»',0),(498103,13837,'ur','Ø§ÛŒ Ù…ÛŒÙ„ ÙˆØ¨Ø¬Ù„ÛŒ',0),(498104,13837,'sr','Ð•Ð¼Ð°Ð¸Ð» Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(498105,13837,'vi','Email hÃ³a Ä‘Æ¡n',0),(498106,13837,'af','E-pos fakture',0),(498107,13837,'ro','Facturi de e-mail',0),(498108,13837,'et','E-post arvete',0),(498109,13837,'si','E-poÅ¡tni raÄuni',0),(498110,13837,'ba','Email faktur',0),(498111,13837,'nl','E-facturen',0),(498112,13837,'fi','SÃ¤hkÃ¶postilaskutusta',0),(498113,13837,'no','E-faktura',0),(498114,13837,'da','E-mail-fakturaer',0),(498115,13837,'ko','ì´ë©”ì¼ ì²­êµ¬ì„œ',0),(498116,13837,'he','×—×©×‘×•× ×™×•×ª ×“×•×',0),(498117,13837,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(498118,13837,'zh','ç”µå­é‚®ä»¶å‘ç¥¨',0),(498119,13837,'sv','E-fakturor',0),(498120,13837,'it','E-mail fatture',0),(498121,13837,'tl','',0),(498122,13837,'th','à¸­à¸µà¹€à¸¡à¸¥à¹Œà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(498123,13837,'hi','à¤ˆà¤®à¥‡à¤² à¤šà¤¾à¤²à¤¾à¤¨',0),(498124,13837,'ms','E-mel invois',0),(498125,13837,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(498126,13837,'fr','Factures par courriel',0),(498127,13837,'jp','è«‹æ±‚æ›¸ãƒ¡ãƒ¼ãƒ«',0),(498128,13837,'pt','E-mail facturas',0),(498129,13837,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(498130,13837,'es','Correo electrÃ³nico de facturas',0),(498131,13837,'de','E-Mail-Rechnungen',0),(498132,13837,'en','Email Invoices',0),(498133,13838,'is','',0),(498134,13838,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø§ÛŒÙ…ÛŒÙ„',0),(498135,13838,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø§ÛŒÙ…ÛŒÙ„',0),(498136,13838,'tr','Fatura e-postayla gÃ¶nderilmesi',0),(498137,13838,'pl','Faktury zostaÅ‚y wysÅ‚ane',0),(498138,13838,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ‚Ðµ ÑÐ° Ð±Ð¸Ð»Ð¸ ÐµÐ¼Ð°Ð¹Ð»',0),(498139,13838,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© Ú¯ÛŒØ§ ÛÛ’',0),(498140,13838,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð´Ð° Ð³Ð° Ð¿Ð¾Ñ™Ð°Ñ™ÐµÐ¼',0),(498141,13838,'vi','HoÃ¡ Ä‘Æ¡n Ä‘Ã£ Ä‘Æ°á»£c gá»­i qua email',0),(498142,13838,'af','Fakture het is per e-pos',0),(498143,13838,'ro','Facturile au fost trimise prin E-mail',0),(498144,13838,'et','Arved saadetakse',0),(498145,13838,'si','RaÄuni so bili po e-poÅ¡ti',0),(498146,13838,'ba','Faktur telah diemail',0),(498147,13838,'nl','Facturen hebben per e-mail gestuurd',0),(498148,13838,'fi','Laskut sÃ¤hkÃ¶postitse',0),(498149,13838,'no','Fakturaene har blitt sendt',0),(498150,13838,'da','Fakturaer er blevet sendt',0),(498151,13838,'ko','ì²­êµ¬ì„œ ì´ë©”ì¼ë¡œ ì „ì†¡',0),(498152,13838,'he','×—×©×‘×•× ×™×•×ª ×™×© ×›×‘×¨ ×‘×“×•×',0),(498153,13838,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î­Ï‡Î¿Ï…Î½ ÎµÏƒÏ„Î¬Î»Î· Î·Î»ÎµÎºÏÎ¿Î½Î¹ÎºÎ¬',0),(498154,13838,'zh','å‘ç¥¨å·²å‘é€',0),(498155,13838,'sv','Fakturor har varit mailade',0),(498156,13838,'it','Fatture sono stati inviati via email',0),(498157,13838,'tl','',0),(498158,13838,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸¡à¸µà¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥',0),(498159,13838,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤ˆà¤®à¥‡à¤² à¤•à¤° à¤¦à¥€ à¤—à¤ˆ à¤¹à¥ˆ',0),(498160,13838,'ms','Invois telah telah melalui e-mel',0),(498161,13838,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ ÙˆØ§Ù„ÙÙˆØ§ØªÙŠØ±',0),(498162,13838,'fr','Factures ont Ã©tÃ© envoyÃ©es par courriel',0),(498163,13838,'jp','è«‹æ±‚æ›¸ã‚’ãƒ¡ãƒ¼ãƒ«ã§é€ä¿¡ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(498164,13838,'pt','As facturas tÃªm sido enviadas',0),(498165,13838,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð±Ñ‹Ð»Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(498166,13838,'es','Facturas han sido enviado por correo electrÃ³nico',0),(498167,13838,'de','Rechnungen haben per E-Mail wurde',0),(498168,13838,'en','Invoices Have Been Emailed',0),(498169,13839,'is','',0),(498170,13839,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(498171,13839,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(498172,13839,'tr','Fatura gÃ¶nderilecektir',0),(498173,13839,'pl','Faktury zostanie wysÅ‚ane',0),(498174,13839,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ‚Ðµ Ñ‰Ðµ Ð±ÑŠÐ´Ð°Ñ‚ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð¿Ð¾ Ð¸Ð¼ÐµÐ¹Ð»',0),(498175,13839,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© ÛÙˆ Ú¯Ø§',0),(498176,13839,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð»',0),(498177,13839,'vi','HÃ³a Ä‘Æ¡n sáº½ Ä‘Æ°á»£c gá»­i qua email',0),(498178,13839,'af','Fakture sal word per e-pos',0),(498179,13839,'ro','Facturile vor fi trimise prin email',0),(498180,13839,'et','Arved saadetakse',0),(498181,13839,'si','RaÄuni se bodo po e-poÅ¡ti',0),(498182,13839,'ba','Faktur akan melalui email',0),(498183,13839,'nl','Facturen zal worden gemaild',0),(498184,13839,'fi','Laskut lÃ¤hetetÃ¤Ã¤n sÃ¤hkÃ¶postitse',0),(498185,13839,'no','Fakturaer skal sendes',0),(498186,13839,'da','Fakturaer vil blive sendt',0),(498187,13839,'ko','ì²­êµ¬ì„œë¥¼ ì´ë©”ì¼ë¡œ ì „ì†¡ ë©ë‹ˆë‹¤.',0),(498188,13839,'he','×—×©×‘×•× ×™×•×ª ×ª×™×©×œ×—',0),(498189,13839,'el','Î˜Î± ÏƒÏ„Î±Î»Î¿ÏÎ½ Î¼Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(498190,13839,'zh','å‘ç¥¨å°†é€šè¿‡ç”µå­é‚®ä»¶å‘é€',0),(498191,13839,'sv','Fakturor kommer att skickas',0),(498192,13839,'it','Fatture saranno inviate',0),(498193,13839,'tl','',0),(498194,13839,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸ˆà¸°à¸ªà¸²à¸¡à¸²à¸£à¸–à¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥',0),(498195,13839,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤ˆà¤®à¥‡à¤² à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾',0),(498196,13839,'ms','Invois akan dihantar melalui email',0),(498197,13839,'ar','ÙˆØ³ÙˆÙ ØªÙƒÙˆÙ† Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ ÙˆØ§Ù„ÙÙˆØ§ØªÙŠØ±',0),(498198,13839,'fr','Factures seront envoyÃ©s',0),(498199,13839,'jp','è«‹æ±‚æ›¸ãŒãƒ¡ãƒ¼ãƒ«ã§é€ä¿¡ã•ã‚Œã¾ã™ã€‚',0),(498200,13839,'pt','Facturas serÃ£o enviadas',0),(498201,13839,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð±ÑƒÐ´ÐµÑ‚ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½',0),(498202,13839,'es','Se enviarÃ¡ las facturas',0),(498203,13839,'de','Rechnungen werden per E-Mail',0),(498204,13839,'en','Invoices Will be Emailed',0),(498205,13840,'is','',0),(498206,13840,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ù†Ø®ÙˆØ§Ù‡Ø¯ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(498207,13840,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ù†Ø®ÙˆØ§Ù‡Ø¯ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(498208,13840,'tr','Faturalar yok edecek e-postayla olabilir',0),(498209,13840,'pl','Faktury nie bÄ™dÄ… wysÅ‚ane',0),(498210,13840,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð½ÑÐ¼Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð¿Ð¾ Ð¸Ð¼ÐµÐ¹Ð»',0),(498211,13840,'ur','Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© ÙˆØ¨Ø¬Ù„ÛŒ Ú¯Ø§ Ù†Û ÛÙˆ',0),(498212,13840,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ›Ðµ Ð½Ðµ Ð±Ð¸ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð»',0),(498213,13840,'vi','HÃ³a Ä‘Æ¡n sáº½ khÃ´ng Ä‘Æ°á»£c gá»­i qua email',0),(498214,13840,'af','Fakture sal nie word per e-pos',0),(498215,13840,'ro','Facturile nu vor fi trimise prin email',0),(498216,13840,'et','Arved on mitte olla emailitaks',0),(498217,13840,'si','RaÄunov ne bo poslano',0),(498218,13840,'ba','Tagihan tidak akan dikirim melalui email',0),(498219,13840,'nl','Facturen zullen niet per e-mail worden verstuurd',0),(498220,13840,'fi','Laskuja ei sÃ¤hkÃ¶postitse',0),(498221,13840,'no','Fakturaer vil ikke bli sendt',0),(498222,13840,'da','Fakturaer vil ikke blive sendt',0),(498223,13840,'ko','ì´ë©”ì¼ë¡œ ì†¡ìž¥ í•˜ì§€ ì•Šì„ ê²ƒ ì´ë‹¤',0),(498224,13840,'he','×—×©×‘×•× ×™×•×ª ×œ× ×™×™×©×œ×— ×‘×“×•×',0),(498225,13840,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î´ÎµÎ½ Î¸Î± ÏƒÏ„Î±Î»Î¿ÏÎ½ Î¼Îµ email',0),(498226,13840,'zh','å‘ç¥¨å°†ä¸ä¼šé€šè¿‡ç”µå­é‚®ä»¶å‘é€',0),(498227,13840,'sv','Fakturor kommer inte att skickas',0),(498228,13840,'it','Fatture non sarÃ  inviato via email',0),(498229,13840,'tl','',0),(498230,13840,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸ˆà¸°à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥',0),(498231,13840,'hi','à¤ˆà¤®à¥‡à¤² à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤°à¥‡à¤—à¤¾ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¨à¤¾',0),(498232,13840,'ms','Invois tidak akan dihantar melalui email',0),(498233,13840,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± \"ÙˆØ³ÙˆÙ Ù„Ø§\" ØªÙƒÙˆÙ† Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(498234,13840,'fr','Factures ne seront ne pas Ãªtre envoyÃ©es par courriel',0),(498235,13840,'jp','è«‹æ±‚æ›¸ã¯ãªã„é›»å­ãƒ¡ãƒ¼ãƒ«ã§é€ä¿¡ã—ã¾ã™ã€‚',0),(498236,13840,'pt','Facturas nÃ£o vai ser enviado por email',0),(498237,13840,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð½Ðµ Ð±ÑƒÐ´ÐµÑ‚ Ð²Ñ‹ÑÐ»Ð°Ð½',0),(498238,13840,'es','Las facturas no se enviarÃ¡ por correo electrÃ³nico',0),(498239,13840,'de','Rechnungen werden nicht per E-Mail',0),(498240,13840,'en','Invoices Will NOT be Emailed',0),(498241,13841,'is','',0),(498242,13841,'dr','Ø´Ù…Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± Ø§ÛŒÙ…ÛŒÙ„ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(498243,13841,'pr','Ø´Ù…Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø±Ø¯Ù‡ Ø§ÛŒØ¯ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± Ø§ÛŒÙ…ÛŒÙ„ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(498244,13841,'tr','Otomatik olarak fatura Email deÄŸil seÃ§tiniz',0),(498245,13841,'pl','Wybrano nie automatycznie E-mail faktur',0),(498246,13841,'bg','Ð˜Ð·Ð±Ñ€Ð°Ð»Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð½Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¸Ð¼ÐµÐ¹Ð» Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(498247,13841,'ur','Ø¢Ù¾ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ÙˆØ¨Ø¬Ù„ÛŒ Ø§ÛŒ Ù…ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©ÛŒØ§',0),(498248,13841,'sr','ÐžÐ´Ð°Ð±Ñ€Ð°Ð»Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð½Ðµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ðµ-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(498249,13841,'vi','Báº¡n Ä‘Ã£ chá»n khÃ´ng Ä‘á»ƒ tá»± Ä‘á»™ng gá»­i Email hÃ³a Ä‘Æ¡n',0),(498250,13841,'af','Jy het gekies om nie outomaties e-pos fakture',0),(498251,13841,'ro','AÈ›i ales sÄƒ nu E-mail automat facturi',0),(498252,13841,'et','On otsustanud mitte automaatselt e-arved',0),(498253,13841,'si','Izbrali ste ne samodejno Email raÄuni',0),(498254,13841,'ba','Anda telah memilih untuk tidak secara otomatis Email faktur',0),(498255,13841,'nl','U hebt niet automatisch e-facturen',0),(498256,13841,'fi','Olet valinnut ei sÃ¤hkÃ¶postia automaattisesti laskujen',0),(498257,13841,'no','Du har valgt ikke Ã¥ automatisk sende fakturaer',0),(498258,13841,'da','Du har valgt ikke at automatisk E-mail-fakturaer',0),(498259,13841,'ko','ìžë™ìœ¼ë¡œ ì´ë©”ì¼ ì²­êµ¬ì„œ ì•ˆ ì„ íƒ í–ˆìŠµë‹ˆë‹¤.',0),(498260,13841,'he','×‘×—×¨×ª ×œ× ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™ ×“×•××¨ ××œ×§×˜×¨×•× ×™ ×—×©×‘×•× ×™×•×ª',0),(498261,13841,'el','Î•Ï€Î¹Î»Î­Î¾Î±Ï„Îµ Î½Î± Î¼Î·Î½ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î± Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(498262,13841,'zh','æ‚¨å·²é€‰æ‹©ä¸è‡ªåŠ¨é€šè¿‡ç”µå­é‚®ä»¶å‘é€å‘ç¥¨',0),(498263,13841,'sv','Du har valt att inte automatiskt e-fakturor',0),(498264,13841,'it','Hai deciso di non automaticamente un\'Email fatture',0),(498265,13841,'tl','',0),(498266,13841,'th','à¸„à¸¸à¸“à¹„à¸”à¹‰à¹€à¸¥à¸·à¸­à¸à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸ªà¹ˆà¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(498267,13841,'hi','à¤†à¤ª à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤ˆà¤®à¥‡à¤² à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¥à¤¨à¤¾ à¤¹à¥ˆ',0),(498268,13841,'ms','Anda telah memilih untuk tidak invois e-mel secara automatik',0),(498269,13841,'ar','Ù„Ù‚Ø¯ Ø§Ø®ØªØ±Øª Ø¹Ø¯Ù… ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(498270,13841,'fr','Vous avez choisi de ne pas envoyer automatiquement les factures',0),(498271,13841,'jp','è‡ªå‹•çš„ã«è«‹æ±‚æ›¸ã‚’ãƒ¡ãƒ¼ãƒ«ã«ãªã„åˆ†é‡Žã—ã¾ã™ã€‚',0),(498272,13841,'pt','VocÃª optou por nÃ£o automaticamente E-mail facturas',0),(498273,13841,'ru','Ð’Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ð»Ð¸ Ð½Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(498274,13841,'es','Usted ha elegido no automÃ¡ticamente un correo electrÃ³nico a facturas',0),(498275,13841,'de','Sie mÃ¶chten nicht automatisch E-Mail-Rechnungen',0),(498276,13841,'en','You Have Chosen NOT to Automatically Email Invoices',0),(498277,13842,'is','',0),(498278,13842,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ù¾Ø§ÛŒØ§Ù†',0),(498279,13842,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ù¾Ø§ÛŒØ§Ù†',0),(498280,13842,'tr','TamamlanmÄ±ÅŸ sipariÅŸleri',0),(498281,13842,'pl','ZamÃ³wienia w',0),(498282,13842,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½ Ð¿Ñ€ÐµÐ·',0),(498283,13842,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ù…Ú©Ù…Ù„',0),(498284,13842,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ñƒ Ð·Ð°Ð²Ñ€ÑˆÐ¸Ð»Ð°',0),(498285,13842,'vi','CÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng hoÃ n thÃ nh',0),(498286,13842,'af','Bestellings voltooi In',0),(498287,13842,'ro','Comenzi finalizate Ã®n',0),(498288,13842,'et','Korraldusi tÃ¤ita',0),(498289,13842,'si','NaroÄila v',0),(498290,13842,'ba','Perintah yang diselesaikan dalam',0),(498291,13842,'nl','Bestellingen ingevuld',0),(498292,13842,'fi','Tilaukset valmistunut',0),(498293,13842,'no','Bestillinger i',0),(498294,13842,'da','Ordrer afsluttet i',0),(498295,13842,'ko','ì£¼ë¬¸ ì™„ë£Œ',0),(498296,13842,'he','×”×–×ž× ×•×ª ×”×•×©×œ×ž×” ×‘',0),(498297,13842,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯ ÏƒÎµ',0),(498298,13842,'zh','åœ¨å·²å®Œæˆçš„è®¢å•',0),(498299,13842,'sv','Order fÃ¤rdigstÃ¤lldes',0),(498300,13842,'it','Ordini completati In',0),(498301,13842,'tl','',0),(498302,13842,'th','à¹ƒà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(498303,13842,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾',0),(498304,13842,'ms','Perintah-perintah yang siap dibina pada',0),(498305,13842,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ù†Ø¬Ø²Ø© ÙÙŠ',0),(498306,13842,'fr','Commandes achevÃ©s en',0),(498307,13842,'jp','æ³¨æ–‡ã®å®Œäº†',0),(498308,13842,'pt','Ordens, concluÃ­das em',0),(498309,13842,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹, Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¾ Ð²',0),(498310,13842,'es','Completado en pedidos',0),(498311,13842,'de','Abgeschlossene Bestellungen',0),(498312,13842,'en','Orders Completed In',0),(498313,13843,'is','',0),(498314,13843,'dr','Ø§ØªÙ…Ø§Ù…',0),(498315,13843,'pr','Ø§ØªÙ…Ø§Ù…',0),(498316,13843,'tr','Tamamlama',0),(498317,13843,'pl','ZakoÅ„czenie',0),(498318,13843,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ',0),(498319,13843,'ur','ØªÚ©Ù…ÛŒÙ„',0),(498320,13843,'sr','Ð—Ð°Ð²Ñ€ÑˆÐµÑ‚Ð°Ðº',0),(498321,13843,'vi','HoÃ n thÃ nh',0),(498322,13843,'af','Voltooiing',0),(498323,13843,'ro','Finalizarea',0),(498324,13843,'et','LÃµpuleviimine',0),(498325,13843,'si','ZakljuÄek',0),(498326,13843,'ba','Penyelesaian',0),(498327,13843,'nl','Voltooiing',0),(498328,13843,'fi','Loppuun',0),(498329,13843,'no','Ferdigstillelse',0),(498330,13843,'da','FÃ¦rdiggÃ¸relse',0),(498331,13843,'ko','ì™„ë£Œ',0),(498332,13843,'he','×”×©×œ×ž×ª',0),(498333,13843,'el','ÎŸÎ»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ·',0),(498334,13843,'zh','å®Œæˆ',0),(498335,13843,'sv','Avslutad',0),(498336,13843,'it','Completamento',0),(498337,13843,'tl','',0),(498338,13843,'th','à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(498339,13843,'hi','à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹à¤¨à¥‡',0),(498340,13843,'ms','Siap',0),(498341,13843,'ar','Ø¥Ù†Ø¬Ø§Ø²',0),(498342,13843,'fr','AchÃ¨vement',0),(498343,13843,'jp','å®Œäº†',0),(498344,13843,'pt','ConclusÃ£o',0),(498345,13843,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ðµ',0),(498346,13843,'es','TerminaciÃ³n',0),(498347,13843,'de','Abschluss',0),(498348,13843,'en','Completion',0),(498349,13844,'is','',0),(498350,13844,'dr','Ø®ÙˆØ¨ Ø¨Ø±Ø§ÛŒ Ú†Ø§Ù¾',0),(498351,13844,'pr','Ø®ÙˆØ¨ Ø¨Ø±Ø§ÛŒ Ú†Ø§Ù¾',0),(498352,13844,'tr','Tamam yazdÄ±rmak iÃ§in',0),(498353,13844,'pl','OK, aby wydrukowaÄ‡',0),(498354,13844,'bg','ÐžÐš, Ð·Ð° Ð´Ð° Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚Ðµ',0),(498355,13844,'ur','Ù¹Ú¾ÛŒÚ© ÛÛ’ Ú†Ú¾Ø§Ù¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’',0),(498356,13844,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(498357,13844,'vi','OK Ã±eÃ¥ in',0),(498358,13844,'af','OK om te druk',0),(498359,13844,'ro','OK pentru a imprima',0),(498360,13844,'et','OK seda Print',0),(498361,13844,'si','OK za tiskanje',0),(498362,13844,'ba','OK untuk mencetak',0),(498363,13844,'nl','OK om af te drukken',0),(498364,13844,'fi','Haluatko tulostaa',0),(498365,13844,'no','OK for Ã¥ skrive ut',0),(498366,13844,'da','OK for at udskrive',0),(498367,13844,'ko','í™•ì¸ í•˜ ì—¬ ì¸ì‡„',0),(498368,13844,'he','×‘×¨×¦×•× ×š ×œ×”×“×¤×™×¡',0),(498369,13844,'el','Î•Î½Ï„Î¬Î¾ÎµÎ¹ Î³Î¹Î± Î½Î± ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÏ„Îµ',0),(498370,13844,'zh','å¥½å§è¦æ‰“å°',0),(498371,13844,'sv','OK fÃ¶r att skriva ut',0),(498372,13844,'it','OK per stampare',0),(498373,13844,'tl','',0),(498374,13844,'th','à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸žà¸´à¸¡à¸žà¹Œ',0),(498375,13844,'hi','à¤ à¥€à¤• à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(498376,13844,'ms','OK untuk mencetak',0),(498377,13844,'ar','\"Ù…ÙˆØ§ÙÙ‚\" Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(498378,13844,'fr','OK pour imprimer',0),(498379,13844,'jp','[Ok] ã‚’å°åˆ·ã™ã‚‹ã«ã¯',0),(498380,13844,'pt','OK para imprimir',0),(498381,13844,'ru','OK Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(498382,13844,'es','OK para imprimir',0),(498383,13844,'de','OK, um zu drucken',0),(498384,13844,'en','OK to Print',0),(498385,13845,'is','',0),(498386,13845,'dr','Ø¨Ù‡ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª Ù…Ù†ØªØ´Ø±',0),(498387,13845,'pr','Ø¨Ù‡ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª Ù…Ù†ØªØ´Ø±',0),(498388,13845,'tr','BasÄ±n iÃ§in serbest',0),(498389,13845,'pl','Wydany do prasy',0),(498390,13845,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð° Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚',0),(498391,13845,'ur','Ù¾Ø±ÛŒØ³ Ú©Ùˆ Ø±ÛØ§ Ú©Ø± Ø¯ÛŒØ§',0),(498392,13845,'sr','ÐžÐ±Ñ˜Ð°Ð²Ð¸Ð¾ Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ð¸Ð¼Ð°',0),(498393,13845,'vi','PhÃ¡t hÃ nh bÃ¡o chÃ­',0),(498394,13845,'af','Vrygestel om te druk',0),(498395,13845,'ro','Presa a lansat',0),(498396,13845,'et','Avaldatud Press',0),(498397,13845,'si','Izpust v tisku',0),(498398,13845,'ba','Rilis pers',0),(498399,13845,'nl','Vrijgegeven aan pers',0),(498400,13845,'fi','Luovutettu Press',0),(498401,13845,'no','Utgitt i trykken',0),(498402,13845,'da','Frigivet til pressen',0),(498403,13845,'ko','ì–¸ë¡ ì— ë°œí‘œ',0),(498404,13845,'he','×©×•×—×¨×¨ ×œ×¢×™×ª×•× ×•×ª',0),(498405,13845,'el','ÎšÏ…ÎºÎ»Î¿Ï†ÏŒÏÎ·ÏƒÎµ Ï„ÏÏ€Î¿',0),(498406,13845,'zh','æŠ¥ç« å‘è¡¨',0),(498407,13845,'sv','Ut till pressen',0),(498408,13845,'it','Rilasciato alla stampa',0),(498409,13845,'tl','',0),(498410,13845,'th','à¸­à¸­à¸à¸‚à¹ˆà¸²à¸§',0),(498411,13845,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤°à¥€',0),(498412,13845,'ms','Dikeluarkan kepada akhbar',0),(498413,13845,'ar','ØµØ¯Ø± Ù„Ù„ØµØ­Ø§ÙØ©',0),(498414,13845,'fr','Sorti de presse',0),(498415,13845,'jp','ãƒ—ãƒ¬ã‚¹ ãƒªãƒªãƒ¼ã‚¹',0),(498416,13845,'pt','Para imprensa',0),(498417,13845,'ru','Ð’Ñ‹Ð¿ÑƒÑ‰ÐµÐ½ Ð¿Ñ€ÐµÑÑ',0),(498418,13845,'es','Libertad de prensa',0),(498419,13845,'de','Presse verÃ¶ffentlicht',0),(498420,13845,'en','Released to Press',0),(498421,13846,'is','',0),(498422,13846,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÛŒÛŒØ¯ Ù†Ù…ÛŒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(498423,13846,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ØªØ§ÛŒÛŒØ¯ Ù†Ù…ÛŒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(498424,13846,'tr','OnaylanmÄ±ÅŸ sipariÅŸler deÄŸil faturalandÄ±rÄ±lÄ±r',0),(498425,13846,'pl','Zatwierdzonych zamÃ³wieÅ„ nie rozliczone',0),(498426,13846,'bg','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ðµ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸',0),(498427,13846,'ur','Ù…Ù†Ø¸ÙˆØ± Ø´Ø¯Û Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù†ÛÛŒÚº Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(498428,13846,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð½Ð¸Ñ˜Ðµ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(498429,13846,'vi','ÄÆ¡n Ä‘áº·t hÃ ng Ä‘Æ°á»£c cháº¥p thuáº­n khÃ´ng láº­p hoÃ¡ Ä‘Æ¡n',0),(498430,13846,'af','Goedgekeurde bestellings nie weerspieÃ«l',0),(498431,13846,'ro','Aprobat ordinele nu facturat',0),(498432,13846,'et','Kinnitatud tellimused mitte arve',0),(498433,13846,'si','Odobrenega naroÄila ne zaraÄunavajo',0),(498434,13846,'ba','Disetujui pesanan tidak ditagih',0),(498435,13846,'nl','Goedgekeurde Orders niet gefactureerd',0),(498436,13846,'fi','HyvÃ¤ksyttyjen tilausten ei laskutettu',0),(498437,13846,'no','Godkjente ordrer ikke fakturert',0),(498438,13846,'da','Godkendte ordrer ikke faktureret',0),(498439,13846,'ko','ìŠ¹ì¸ ëœ ì£¼ë¬¸ ë¹„ìš©ì´ ì²­êµ¬ ë˜ì§€',0),(498440,13846,'he','×”×–×ž× ×•×ª ×©××•×©×¨×• ×”×—×™×•×‘ ××™× ×• ×ž×™×™×“×™',0),(498441,13846,'el','Î•Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î´ÎµÎ½ Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹',0),(498442,13846,'zh','æ‰¹å‡†çš„è®¢å•ä¸æ”¶è´¹',0),(498443,13846,'sv','GodkÃ¤nda bestÃ¤llningar faktureras inte',0),(498444,13846,'it','Approvati gli ordini non fatturati',0),(498445,13846,'tl','',0),(498446,13846,'th','à¸ªà¸±à¹ˆà¸‡à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(498447,13846,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¬à¤¿à¤² à¤•à¤¿à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶',0),(498448,13846,'ms','Perintah-perintah yang diluluskan yang tidak dibilkan',0),(498449,13846,'ar','Ø§Ù„Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…ÙˆØ§ÙÙ‚ Ø¹Ù„ÙŠÙ‡Ø§ Ù„Ø§ ØªÙˆØµÙ',0),(498450,13846,'fr','DÃ©crets approuvÃ©s ne pas facturÃ©s',0),(498451,13846,'jp','æ‰¿èªã•ã‚ŒãŸæ³¨æ–‡è«‹æ±‚ã•ã‚Œã¾ã›ã‚“ã€‚',0),(498452,13846,'pt','Aprovados pedidos nÃ£o faturados',0),(498453,13846,'ru','Ð£Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ðµ Ñ‚Ð°Ñ€Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€ÑƒÐµÑ‚ÑÑ',0),(498454,13846,'es','Pedidos aprobados no facturados',0),(498455,13846,'de','Genehmigte Bestellungen nicht in Rechnung gestellt',0),(498456,13846,'en','Approved Orders Not Billed',0),(498457,13847,'is','',0),(498458,13847,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª Ø³Ù‡Ø§Ù…',0),(498459,13847,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª Ø³Ù‡Ø§Ù…',0),(498460,13847,'tr','BasÄ±n hisse senedi dÃ¼zenlemek',0),(498461,13847,'pl','Edycja fotografii prasowej',0),(498462,13847,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð°Ñ‚Ð¸ÑÐ½ÐµÑ‚Ðµ ÑÑŠÑÑ‚Ð°Ð²',0),(498463,13847,'ur','Ù¾Ø±ÛŒØ³ Ø§Ø³Ù¹Ø§Ú© Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(498464,13847,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð° Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ',0),(498465,13847,'vi','Chá»‰nh sá»­a bÃ¡o chÃ­ cá»•',0),(498466,13847,'af','Redigeer Press voorraad',0),(498467,13847,'ro','Editare presa stoc',0),(498468,13847,'et','Redigeeri Press Stock',0),(498469,13847,'si','Urejanje parka Press',0),(498470,13847,'ba','Mengedit tekan saham',0),(498471,13847,'nl','Druk op voorraad bewerken',0),(498472,13847,'fi','Muokkaa paina varastossa',0),(498473,13847,'no','Redigere trykk lager',0),(498474,13847,'da','Redigere Tryk pÃ¥ lager',0),(498475,13847,'ko','ë³´ë„ ì‚¬ì§„ íŽ¸ì§‘',0),(498476,13847,'he','×¢×¨×™×›×ª ×ž×œ××™ ×”×¢×™×ª×•× ×•×ª',0),(498477,13847,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÏ€Î¿Ï… Î±Ï€ÏŒÎ¸ÎµÎ¼Î±',0),(498478,13847,'zh','ç¼–è¾‘æ–°é—»è‚¡ç¥¨',0),(498479,13847,'sv','Redigera tryck pÃ¥ lager',0),(498480,13847,'it','Modifica stampa Stock',0),(498481,13847,'tl','',0),(498482,13847,'th','à¹à¸à¹‰à¹„à¸‚à¸‚à¹ˆà¸²à¸§à¸«à¸¸à¹‰à¸™',0),(498483,13847,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤¶à¥‡à¤¯à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(498484,13847,'ms','Edit stok Seluar',0),(498485,13847,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„ØµØ­Ø§ÙØ© Ø§Ù„Ø£Ø³Ù‡Ù…',0),(498486,13847,'fr','Edit presse Stock',0),(498487,13847,'jp','ãƒ—ãƒ¬ã‚¹åœ¨åº«ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(498488,13847,'pt','Editar aÃ§Ãµes de imprensa',0),(498489,13847,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€ÐµÑÑ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¹',0),(498490,13847,'es','Editar acciones de prensa',0),(498491,13847,'de','Presse-Lager bearbeiten',0),(498492,13847,'en','Edit Press Stock',0),(498493,13848,'is','',0),(498494,13848,'dr','Ù…Ù†ØªØ´Ø± Ø´Ø¯',0),(498495,13848,'pr','Ù…Ù†ØªØ´Ø± Ø´Ø¯',0),(498496,13848,'tr','Serbest bÄ±rakmak',0),(498497,13848,'pl','Wydany',0),(498498,13848,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð´ÐµÐ½',0),(498499,13848,'ur','Ø¬Ø§Ø±ÛŒ',0),(498500,13848,'sr','ÐžÐ±Ñ˜Ð°Ð²Ð¸Ð¾',0),(498501,13848,'vi','PhÃ¡t hÃ nh',0),(498502,13848,'af','Vrygestel',0),(498503,13848,'ro','Lansat',0),(498504,13848,'et','VÃ¤lja lastud',0),(498505,13848,'si','Sprosti',0),(498506,13848,'ba','Dirilis',0),(498507,13848,'nl','Uitgebracht',0),(498508,13848,'fi','Julkaistu',0),(498509,13848,'no','Utgitt',0),(498510,13848,'da','Udgivet',0),(498511,13848,'ko','ì¶œì‹œ',0),(498512,13848,'he','×©×•×—×¨×¨',0),(498513,13848,'el','ÎšÏ…ÎºÎ»Î¿Ï†ÏŒÏÎ·ÏƒÎµ',0),(498514,13848,'zh','é‡Šæ”¾',0),(498515,13848,'sv','SlÃ¤ppt',0),(498516,13848,'it','Rilasciato',0),(498517,13848,'tl','',0),(498518,13848,'th','à¸™à¸³à¸­à¸­à¸à¹ƒà¸Šà¹‰',0),(498519,13848,'hi','à¤œà¤¾à¤°à¥€ à¤•à¥€',0),(498520,13848,'ms','Tarikh keluaran',0),(498521,13848,'ar','ØµØ¯Ø±',0),(498522,13848,'fr','LibÃ©rÃ©',0),(498523,13848,'jp','ãƒªãƒªãƒ¼ã‚¹',0),(498524,13848,'pt','LanÃ§ado',0),(498525,13848,'ru','Ð”Ð°Ñ‚Ð° Ð²Ñ‹Ð¿ÑƒÑÐºÐ°',0),(498526,13848,'es','Liberado',0),(498527,13848,'de','VerÃ¶ffentlicht',0),(498528,13848,'en','Released',0),(498529,13849,'is','',0),(498530,13849,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ÙØ§ÛŒÙ„',0),(498531,13849,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ÙØ§ÛŒÙ„',0),(498532,13849,'tr','DosyasÄ± gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(498533,13849,'pl','BÅ‚Ä…d podczas aktualizowania pliku',0),(498534,13849,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(498535,13849,'ur','Ù…Ø³Ù„ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(498536,13849,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(498537,13849,'vi','Lá»—i Cáº­p Nháº­t táº­p tin',0),(498538,13849,'af','Fout opdatering lÃªer',0),(498539,13849,'ro','Eroare la actualizarea fiÅŸierului',0),(498540,13849,'et','VÃ¤rskendamise faili tÃµrge',0),(498541,13849,'si','Napaka pri posodabljanju datoteke',0),(498542,13849,'ba','Memperbarui File kesalahan',0),(498543,13849,'nl','Fout bij het bijwerken van bestand',0),(498544,13849,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tiedostoa',0),(498545,13849,'no','Feil under oppdatering av filen',0),(498546,13849,'da','Fejl under opdatering af fil',0),(498547,13849,'ko','íŒŒì¼ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(498548,13849,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×§×•×‘×¥',0),(498549,13849,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(498550,13849,'zh','æ›´æ–°æ–‡ä»¶æ—¶å‡ºé”™',0),(498551,13849,'sv','Gick inte att uppdatera filen',0),(498552,13849,'it','Errore durante l\'aggiornamento dei File',0),(498553,13849,'tl','',0),(498554,13849,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹à¸Ÿà¹‰à¸¡',0),(498555,13849,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(498556,13849,'ms','Ralat dalam mengemas kini fail',0),(498557,13849,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù…Ù„Ù',0),(498558,13849,'fr','Erreur mise Ã  jour du fichier',0),(498559,13849,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(498560,13849,'pt','Erro ao atualizar arquivo',0),(498561,13849,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ Ñ„Ð°Ð¹Ð»Ð°',0),(498562,13849,'es','Error al actualizar archivo',0),(498563,13849,'de','Fehler beim Aktualisieren der Datei',0),(498564,13849,'en','Error Updating File',0),(498565,13850,'is','',0),(498566,13850,'dr','Ø³Ù‡Ø§Ù… Ø¨Ø±Ø§ÛŒ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª',0),(498567,13850,'pr','Ø³Ù‡Ø§Ù… Ø¨Ø±Ø§ÛŒ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª',0),(498568,13850,'tr','BasÄ±n iÃ§in stok',0),(498569,13850,'pl','Czas dla prasy',0),(498570,13850,'bg','Ð¡ÑŠÑÑ‚Ð°Ð² Ð·Ð° Ð¿Ñ€ÐµÑÐ°Ñ‚Ð°',0),(498571,13850,'ur','Ù¾Ø±ÛŒØ³ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³Ù¹Ø§Ú©',0),(498572,13850,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ð·Ð° Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ðµ',0),(498573,13850,'vi','Cá»• phiáº¿u cho bÃ¡o chÃ­',0),(498574,13850,'af','Voorraad vir Press',0),(498575,13850,'ro','Stoc pentru presÄƒ',0),(498576,13850,'et','Varu arvutamiseks vajutage',0),(498577,13850,'si','Parka za tisk',0),(498578,13850,'ba','Stok untuk pers',0),(498579,13850,'nl','Voorraad voor pers',0),(498580,13850,'fi','Kaluston Press',0),(498581,13850,'no','Lager For trykk',0),(498582,13850,'da','Lager For pressen',0),(498583,13850,'ko','ë³´ë„ ëŒ€ í•œ ìž¬ê³ ',0),(498584,13850,'he','×ž×œ××™ ×¢×‘×•×¨ ×”×¢×™×ª×•× ×•×ª',0),(498585,13850,'el','Î¥Î»Î¹ÎºÏŒ Î³Î¹Î± Ï„Î¿Î½ Ï„ÏÏ€Î¿',0),(498586,13850,'zh','å‡ºç‰ˆç¤¾çš„åº“å­˜',0),(498587,13850,'sv','Lager fÃ¶r Press',0),(498588,13850,'it','Magazzino per la stampa',0),(498589,13850,'tl','',0),(498590,13850,'th','à¸«à¸¸à¹‰à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸”',0),(498591,13850,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¥‡à¤¯à¤°',0),(498592,13850,'ms','Saham untuk Seluar',0),(498593,13850,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… Ù„Ù„ØµØ­Ø§ÙØ©',0),(498594,13850,'fr','Stock pour la presse',0),(498595,13850,'jp','ãƒ—ãƒ¬ã‚¹ã®ãŸã‚ã®æ ªå¼',0),(498596,13850,'pt','Estoque para imprensa',0),(498597,13850,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€ÑŒ Ð´Ð»Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(498598,13850,'es','Acciones para la prensa',0),(498599,13850,'de','Lager fÃ¼r Presse',0),(498600,13850,'en','Stock For Press',0),(498601,13851,'is','',0),(498602,13851,'dr','Worksteps Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(498603,13851,'pr','Worksteps Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(498604,13851,'tr','Worksteps gÃ¼ncelleme',0),(498605,13851,'pl','Aktualizacja Worksteps',0),(498606,13851,'bg','Worksteps Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(498607,13851,'ur','ÙˆÙˆØ±Ú©Ø³Ù¹ÛŒ Ø§Ù¾ ÚˆÛŒÙ¹',0),(498608,13851,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ WÐ¾Ñ€ÐºÑÑ‚ÐµÐ¿Ñ',0),(498609,13851,'vi','Cáº­p Nháº­t Worksteps',0),(498610,13851,'af','Worksteps bywerking',0),(498611,13851,'ro','Worksteps actualizare',0),(498612,13851,'et','Worksteps vÃ¤rskendamine',0),(498613,13851,'si','Worksteps posodobitev',0),(498614,13851,'ba','Worksteps pembaruan',0),(498615,13851,'nl','Worksteps Update',0),(498616,13851,'fi','Worksteps pÃ¤ivitys',0),(498617,13851,'no','Worksteps oppdatering',0),(498618,13851,'da','Worksteps opdatering',0),(498619,13851,'ko','Worksteps ì—…ë°ì´íŠ¸',0),(498620,13851,'he','×¢×“×›×•×Ÿ Worksteps',0),(498621,13851,'el','Worksteps ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(498622,13851,'zh','Worksteps æ›´æ–°',0),(498623,13851,'sv','Worksteps uppdatering',0),(498624,13851,'it','Tappo aggiornamento',0),(498625,13851,'tl','',0),(498626,13851,'th','à¸­à¸±à¸žà¹€à¸” Worksteps',0),(498627,13851,'hi','Worksteps à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(498628,13851,'ms','Kemas kini Worksteps',0),(498629,13851,'ar','ØªØ­Ø¯ÙŠØ« ÙˆÙˆØ±ÙƒØ³ØªÙŠØ¨Ø³',0),(498630,13851,'fr','Mise Ã  jour des embouts',0),(498631,13851,'jp','Worksteps æ›´æ–°',0),(498632,13851,'pt','AtualizaÃ§Ã£o Worksteps',0),(498633,13851,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Worksteps',0),(498634,13851,'es','ActualizaciÃ³n de Worksteps',0),(498635,13851,'de','Arbeitsstufen Update',0),(498636,13851,'en','Worksteps Update',0),(498637,13852,'is','',0),(498638,13852,'dr','Ø¨Ø±Ø§ÛŒ Ù¾Ø§Ú©Øª Ø§ÛŒÙ† Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ø®ÙˆØ¯Ú©Ø§Ø± Ù¾Ø± Ú©Ø±Ø¯Ù†--ÛŒÚ© ÙˆØ±ÙˆØ¯ÛŒ Ø±Ø§ Ø±Ø§',0),(498639,13852,'pr','Ø¨Ø±Ø§ÛŒ Ù¾Ø§Ú©Øª Ø§ÛŒÙ† Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ø®ÙˆØ¯Ú©Ø§Ø± Ù¾Ø± Ú©Ø±Ø¯Ù†--ÛŒÚ© ÙˆØ±ÙˆØ¯ÛŒ Ø±Ø§ Ø±Ø§',0),(498640,13852,'tr','Zarflar bu Will otomatik doldur... iÃ§in bir giriÅŸ yapmayÄ±n',0),(498641,13852,'pl','Do koperty to bÄ™dzie Auto-Fill - nie rÃ³b wpisu',0),(498642,13852,'bg','Ð—Ð° Ð¿Ð»Ð¸ÐºÐ¾Ð²Ðµ Ñ‚Ð¾Ð²Ð° Ñ‰Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¿Ð¾Ð¿ÑŠÐ»Ð²Ð°Ð½Ðµ--Ð½Ðµ Ð¿Ñ€Ð°Ð²ÐµÑ‚Ðµ Ð·Ð°Ð¿Ð¸Ñ',0),(498643,13852,'ur','Ù„ÙØ§ÙÙˆÚº Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ Ù…Ø±Ø¶ÛŒ Ø®ÙˆØ¯Ú©Ø§Ø±-Ø¨Ú¾Ø±ÛŒÚº - Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù†Û Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(498644,13852,'sr','Ð—Ð° ÐºÐ¾Ð²ÐµÑ€Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ñ‚ÐµÑÑ‚Ð°Ð¼ÐµÐ½Ñ‚ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ--Ð½ÐµÐ¼Ð¾Ñ˜Ñ‚Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ',0),(498645,13852,'vi','Cho phong bÃ¬ nÃ y sáº½ tá»± Ä‘á»™ng Ä‘iá»n - khÃ´ng lÃ m cho má»™t má»¥c',0),(498646,13852,'af','Vir koeverte hierdie sal Outo-vul - nie maak \'n inskrywing',0),(498647,13852,'ro','Pentru plicuri acest va Auto-Fill--nu face o intrare',0),(498648,13852,'et','Ãœmbrikele selle tahte Auto-tÃ¤itke--ei tee kannet',0),(498649,13852,'si','Za ovojnice ta bo Auto-Fill--ne zemljiÅ¡ka knjiga',0),(498650,13852,'ba','Untuk amplop ini akan otomatis mengisi--tidak membuat entri',0),(498651,13852,'nl','Voor enveloppen dit zal Auto-Fill--Maak niet een vermelding',0),(498652,13852,'fi','Kirjekuorien tÃ¤mÃ¤ on automaattinen tÃ¤yttÃ¶--ei tehdÃ¤ merkintÃ¤',0),(498653,13852,'no','For konvolutter dette vil automatisk fylle - gjÃ¸r ikke en oppfÃ¸ring',0),(498654,13852,'da','Konvolutter dette vil Auto-fyld--gÃ¸r ikke en post',0),(498655,13852,'ko','ì´ ìžë™-ì±„ìš°ê¸°-ë´‰íˆ¬ì— ëŒ€ í•œ ë§Œë“¤ì§€ ì•ŠëŠ”ë‹¤ í•­ëª©',0),(498656,13852,'he','×¢×‘×•×¨ ×ž×¢×˜×¤×•×ª ×œ×ž×œ× ××•×˜×•×ž×˜×™×ª ××ª ×•×•×™×œ--×œ× ×¢×•×©×™× ×›× ×™×¡×”',0),(498657,13852,'el','Î“Î¹Î± Ï†Î±ÎºÎ­Î»Î¿Ï…Ï‚ Î±Ï…Ï„ÏŒ Î¸Î± Auto-ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÏƒÏ„Îµ--Î´ÎµÎ½ ÎºÎ¬Î½Î¿Ï…Î½ Î¼Î¹Î± ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·',0),(498658,13852,'zh','ä¸ºä¿¡å°è¿™å°†è‡ªåŠ¨å¡«å…… â€” â€” ä¸åšä¸€ä¸ªæ¡ç›®',0),(498659,13852,'sv','FÃ¶r kuvert hÃ¤r kommer Auto-Fill--gÃ¶r inte en post',0),(498660,13852,'it','Non fare una voce per buste questa volontÃ  Auto-Fill...',0),(498661,13852,'tl','',0),(498662,13852,'th','à¸‹à¸­à¸‡à¸™à¸µà¹‰à¸ˆà¸°à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¹€à¸•à¸´à¸¡ - à¸—à¸³à¸à¸²à¸£à¸£à¸²à¸¢à¸à¸²à¸£',0),(498663,13852,'hi','à¤‡à¤¸ à¤µà¤¿à¤² à¤‘à¤Ÿà¥‹-à¤­à¤°à¤£ - à¤²à¤¿à¤«à¤¼à¤¾à¤«à¤¼à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¨à¤¹à¥€à¤‚ à¤¬à¤¨à¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(498664,13852,'ms','Bagi sampul surat ini akan mengisi--tidak membuat entri',0),(498665,13852,'ar','Ù„Ø§ ØªØ¬Ø¹Ù„ Ø¥Ø¯Ø®Ø§Ù„Ø§Ù‹ Ù…ØºÙ„ÙØ§Øª Ù‡Ø°Ù‡ Ø§Ù„Ø¥Ø±Ø§Ø¯Ø© Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª-Ø§Ù„ØªØ¹Ø¨Ø¦Ø©-',0),(498666,13852,'fr','Pour les enveloppes remplir automatiquement cette volontÃ©--ne font pas une entrÃ©e',0),(498667,13852,'jp','å°ç­’ã¯ã®è‡ªå‹•å…¥åŠ›ã§ã™ãŒ--ã‚¨ãƒ³ãƒˆãƒªã‚’ä½œæˆã—ã¾ã›ã‚“ã€‚',0),(498668,13852,'pt','Para Envelopes esta vontade Auto-preenchimento..--nÃ£o faÃ§a uma entrada',0),(498669,13852,'ru','Ð”Ð»Ñ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ð² Auto Ð·Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð²Ð¾Ð»Ñ--Ð½Ðµ Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(498670,13852,'es','Para los sobres esta voluntad Auto-Fill--no hacen una entrada',0),(498671,13852,'de','Machen Sie fÃ¼r UmschlÃ¤ge dieser Will Auto-Fill--keinen Eintrag',0),(498672,13852,'en','For Envelopes This Will Auto-Fill -- Do Not Make An Entry',0),(498673,13853,'is','',0),(498674,13853,'dr','Ù„ØºÙˆ Ø³ÙØ§Ø±Ø´',0),(498675,13853,'pr','Ù„ØºÙˆ Ø³ÙØ§Ø±Ø´',0),(498676,13853,'tr','SipariÅŸi iptal et',0),(498677,13853,'pl','Anulowanie zamÃ³wienia',0),(498678,13853,'bg','ÐžÑ‚Ð¼ÐµÐ½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(498679,13853,'ur','Ø¢Ø±ÚˆØ± Ù…Ù†Ø³ÙˆØ® Ú©Ø±ÛŒÚº',0),(498680,13853,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(498681,13853,'vi','Há»§y bá» Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(498682,13853,'af','Bestelling te kanselleer',0),(498683,13853,'ro','Ordinea revocare',0),(498684,13853,'et','Tellimuse tÃ¼histamine',0),(498685,13853,'si','PrekliÄi naroÄilo',0),(498686,13853,'ba','Membatalkan pesanan',0),(498687,13853,'nl','Bestelling annuleren',0),(498688,13853,'fi','Peruuta tilaus',0),(498689,13853,'no','Kansellere bestilling',0),(498690,13853,'da','Annuller ordre',0),(498691,13853,'ko','ì£¼ë¬¸ ì·¨ì†Œ',0),(498692,13853,'he','×‘×™×˜×•×œ ×”×–×ž× ×”',0),(498693,13853,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(498694,13853,'zh','å–æ¶ˆè®¢å•',0),(498695,13853,'sv','Annullera Order',0),(498696,13853,'it','Annullare ordine',0),(498697,13853,'tl','',0),(498698,13853,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(498699,13853,'hi','à¤‘à¤°à¥à¤¡à¤° à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚',0),(498700,13853,'ms','Membatalkan perintah',0),(498701,13853,'ar','Ø¥Ù„ØºØ§Ø¡ Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(498702,13853,'fr','Annuler commande',0),(498703,13853,'jp','æ³¨æ–‡ã®ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(498704,13853,'pt','Cancelar pedido',0),(498705,13853,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(498706,13853,'es','Cancelar pedido',0),(498707,13853,'de','Bestellung stornieren',0),(498708,13853,'en','Cancel Order',0),(498709,13854,'is','',0),(498710,13854,'dr','Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾',0),(498711,13854,'pr','Ø³ÙØ§Ø±Ø´ Ú†Ø§Ù¾',0),(498712,13854,'tr','SipariÅŸ ayrÄ±ntÄ±larÄ±nÄ± yazdÄ±rma',0),(498713,13854,'pl','Drukowanie szczegÃ³Å‚Ã³w zamÃ³wienia',0),(498714,13854,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(498715,13854,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(498716,13854,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(498717,13854,'vi','In chi tiáº¿t Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(498718,13854,'af','Druk bestelling besonderhede',0),(498719,13854,'ro','Imprima detalii comanda',0),(498720,13854,'et','Printida Tellimuse Ã¼ksikasjad',0),(498721,13854,'si','Vrstni red tiskanja podrobnosti',0),(498722,13854,'ba','Cetak rincian pesanan',0),(498723,13854,'nl','Afdrukvolgorde Details',0),(498724,13854,'fi','Tulostaa Tilaustiedot',0),(498725,13854,'no','UtskriftsrekkefÃ¸lge detaljer',0),(498726,13854,'da','Udskrive ordreoplysninger',0),(498727,13854,'ko','ì£¼ë¬¸ ì •ë³´ë¥¼ ì¸ì‡„',0),(498728,13854,'he','×œ×”×“×¤×™×¡ ××ª ×¤×¨×˜×™ ×”×”×–×ž× ×”',0),(498729,13854,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(498730,13854,'zh','æ‰“å°è®¢å•çš„è¯¦ç»†ä¿¡æ¯',0),(498731,13854,'sv','Utskriftsordning Detaljer',0),(498732,13854,'it','Stampa i dettagli dell\'ordine',0),(498733,13854,'tl','',0),(498734,13854,'th','à¸žà¸´à¸¡à¸žà¹Œà¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(498735,13854,'hi','à¤‘à¤°à¥à¤¡à¤° à¤µà¤¿à¤µà¤°à¤£ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(498736,13854,'ms','Butir-butir pesanan cetakan',0),(498737,13854,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(498738,13854,'fr','Imprimer les dÃ©tails de la commande',0),(498739,13854,'jp','æ³¨æ–‡ã®è©³ç´°ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(498740,13854,'pt','Imprimir detalhes do pedido',0),(498741,13854,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ð¹ Ð¾ Ð·Ð°ÐºÐ°Ð·Ðµ',0),(498742,13854,'es','Imprimir detalles del pedido',0),(498743,13854,'de','Print Order Details',0),(498744,13854,'en','Print Order Details',0),(498745,13855,'is','',0),(498746,13855,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù‡Ø§ÛŒ ØªØ£ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡',0),(498747,13855,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù‡Ø§ÛŒ ØªØ£ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡',0),(498748,13855,'tr','DoÄŸrulanmamÄ±ÅŸ DÃ¼zenle',0),(498749,13855,'pl','Edycja niepotwierdzone',0),(498750,13855,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½ÐµÐ¿Ð¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÐ½Ð¸',0),(498751,13855,'ur','ØºÛŒØ± Ù…ØµØ¯Ù‚Û ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(498752,13855,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½ÐµÐ¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ðµ',0),(498753,13855,'vi','Chá»‰nh sá»­a chÆ°a Ä‘Æ°á»£c xÃ¡c nháº­n',0),(498754,13855,'af','Redigeer onbevestigde',0),(498755,13855,'ro','Editare neconfirmate',0),(498756,13855,'et','Redigeeri kinnitamata',0),(498757,13855,'si','Urejanje nepotrjeno',0),(498758,13855,'ba','Edit yang belum dikonfirmasi',0),(498759,13855,'nl','Onbevestigde bewerken',0),(498760,13855,'fi','Muokkaa vahvistamaton',0),(498761,13855,'no','Rediger ubekreftet',0),(498762,13855,'da','Rediger ubekrÃ¦ftet',0),(498763,13855,'ko','ë¯¸í™•ì¸ íŽ¸ì§‘',0),(498764,13855,'he','×¢×¨×™×›×” ×œ× ×ž××•×©×¨×™×.',0),(498765,13855,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Î½ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰Ï„ÎµÏ‚',0),(498766,13855,'zh','æœªç»è¯å®žçš„ç¼–è¾‘',0),(498767,13855,'sv','Redigera obekrÃ¤ftade',0),(498768,13855,'it','Modifica non confermato',0),(498769,13855,'tl','',0),(498770,13855,'th','à¹à¸à¹‰à¹„à¸‚à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(498771,13855,'hi','à¤…à¤ªà¥à¤·à¥à¤Ÿ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(498772,13855,'ms','Edit yang belum disahkan',0),(498773,13855,'ar','ØªØ­Ø±ÙŠØ± ØºÙŠØ± Ù…Ø¤ÙƒØ¯Ø©',0),(498774,13855,'fr','Edit non confirmÃ©e',0),(498775,13855,'jp','æœªç¢ºèªã®ç·¨é›†',0),(498776,13855,'pt','Editar nÃ£o confirmado',0),(498777,13855,'ru','ÐŸÑ€Ð°Ð²ÐºÐ° Ð½ÐµÐ¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ',0),(498778,13855,'es','EdiciÃ³n sin confirmar',0),(498779,13855,'de','UnbestÃ¤tigte bearbeiten',0),(498780,13855,'en','Edit Unconfirmed',0),(498781,13856,'is','',0),(498782,13856,'dr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± Ø²Ø¨Ø§Ù† Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯.',0),(498783,13856,'pr','ÙˆÙŠØ±Ø§ÙŠØ´Ú¯Ø± Ø²Ø¨Ø§Ù† Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯.',0),(498784,13856,'tr','Dil editÃ¶rÃ¼ kullanÄ±lamaz',0),(498785,13856,'pl','Edytor jÄ™zyka nie jest dostÄ™pny',0),(498786,13856,'bg','Ð•Ð·Ð¸Ðº Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¾Ñ€ Ð½Ðµ Ðµ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð°',0),(498787,13856,'ur','Ø²Ø¨Ø§Ù† ØªØ¯ÙˆÛŒÙ† Ú©Ø§Ø± Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº ÛÛ’',0),(498788,13856,'sr','Ð£Ñ€ÐµÐ´Ð½Ð¸Ðº Ñ˜ÐµÐ·Ð¸Ðº Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½',0),(498789,13856,'vi','CÃ¡c biÃªn táº­p viÃªn ngÃ´n ngá»¯ lÃ  khÃ´ng cÃ³ sáºµn',0),(498790,13856,'af','Die taalversorger Is nie beskikbaar nie',0),(498791,13856,'ro','Editor limba nu este disponibil',0),(498792,13856,'et','Keelte redaktor pole saadaval',0),(498793,13856,'si','Urednik jezik ni na voljo',0),(498794,13856,'ba','Editor bahasa tidak tersedia',0),(498795,13856,'nl','De taalredacteur Is niet beschikbaar',0),(498796,13856,'fi','KielellÃ¤ editori ei ole kÃ¤ytettÃ¤vissÃ¤',0),(498797,13856,'no','Redigeringsprogrammet for sprÃ¥k er ikke tilgjengelig',0),(498798,13856,'da','Sprog Editor er ikke tilgÃ¦ngelig',0),(498799,13856,'ko','ì–¸ì–´ íŽ¸ì§‘ê¸°ëŠ” ì‚¬ìš©í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(498800,13856,'he','×”×¢×•×¨×š ×”×©×¤×” ××™× ×” ×–×ž×™× ×”',0),(498801,13856,'el','Î¤Î¿ Editor Î³Î»ÏŽÏƒÏƒÎ± Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î·',0),(498802,13856,'zh','è¯­è¨€ç¼–è¾‘å™¨ä¸å¯ç”¨',0),(498803,13856,'sv','SprÃ¥k redaktÃ¶r Ã¤r inte tillgÃ¤nglig',0),(498804,13856,'it','L\'Editor di lingua non Ã¨ disponibile',0),(498805,13856,'tl','',0),(498806,13856,'th','à¹à¸à¹‰à¹„à¸‚à¸ à¸²à¸©à¸²à¹„à¸¡à¹ˆà¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(498807,13856,'hi','à¤­à¤¾à¤·à¤¾ à¤¸à¤‚à¤ªà¤¾à¤¦à¤• à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(498808,13856,'ms','Editor Bahasa tidak disediakan',0),(498809,13856,'ar','Ù…Ø­Ø±Ø± Ø§Ù„Ù„ØºØ© ØºÙŠØ± Ù…ØªÙˆÙØ±Ø©',0),(498810,13856,'fr','L\'Ã©diteur de langue n\'est pas disponible',0),(498811,13856,'jp','è¨€èªžã‚¨ãƒ‡ã‚£ã‚¿ãƒ¼ã¯ä½¿ç”¨ã§ãã¾ã›ã‚“ã€‚',0),(498812,13856,'pt','O Editor de idioma nÃ£o estÃ¡ disponÃ­vel',0),(498813,13856,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¾Ñ€ ÑÐ·Ñ‹ÐºÐ° Ð½Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿ÐµÐ½',0),(498814,13856,'es','El Editor de idioma no estÃ¡ disponible',0),(498815,13856,'de','Der Language-Editor ist nicht verfÃ¼gbar',0),(498816,13856,'en','The Language Editor Is Not Available',0),(498817,13857,'is','',0),(498818,13857,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø¯Ú©Ù…Ù‡ Ø§Ù‡Ø¯Ø§',0),(498819,13857,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø¯Ú©Ù…Ù‡ Ø§Ù‡Ø¯Ø§',0),(498820,13857,'tr','Gizle dÃ¼ÄŸmesi baÄŸÄ±ÅŸ',0),(498821,13857,'pl','Ukryj przycisk darowaÄ‡',0),(498822,13857,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð´Ð°Ñ€Ð¸ Ð±ÑƒÑ‚Ð¾Ð½',0),(498823,13857,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº Ø¨Ù¹Ù† Ø¹Ø·ÛŒÛ',0),(498824,13857,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð´Ð¾Ð½Ð¸Ñ€Ð°Ñ‚Ð¸ Ð´ÑƒÐ³Ð¼Ðµ',0),(498825,13857,'vi','áº¨n táº·ng nÃºt',0),(498826,13857,'af','Versteek skenk knoppie',0),(498827,13857,'ro','Ascunde butonul doneze',0),(498828,13857,'et','Peida annetada nuppu',0),(498829,13857,'si','Skrij darovati gumb',0),(498830,13857,'ba','Sembunyikan Donasi Button',0),(498831,13857,'nl','Verbergen doneren knop',0),(498832,13857,'fi','Piilota Lahjoita-painiketta',0),(498833,13857,'no','Skjul donere knappen',0),(498834,13857,'da','Skjul donere knap',0),(498835,13857,'ko','ìˆ¨ê¸°ê¸° ê¸°ë¶€ ë²„íŠ¼',0),(498836,13857,'he','×”×¡×ª×¨ ×”×›×¤×ª×•×¨ ×ª×¨×•×',0),(498837,13857,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÎºÎ¿Ï…Î¼Ï€Î¯ Î´Ï‰ÏÎ¯ÏƒÎ¿Ï…Î½',0),(498838,13857,'zh','éšè—æèµ æŒ‰é’®',0),(498839,13857,'sv','DÃ¶lj donera knappen',0),(498840,13857,'it','Nascondi donare pulsante',0),(498841,13857,'tl','',0),(498842,13857,'th','à¸‹à¹ˆà¸­à¸™à¸›à¸¸à¹ˆà¸¡à¸šà¸£à¸´à¸ˆà¸²à¸„',0),(498843,13857,'hi','à¤›à¥à¤ªà¤¾à¤à¤ à¤¦à¤¾à¤¨ à¤¬à¤Ÿà¤¨',0),(498844,13857,'ms','Sembunyi menderma butang',0),(498845,13857,'ar','Ø§Ù„ØªØ¨Ø±Ø¹ Ø¨Ø¥Ø®ÙØ§Ø¡ Ø²Ø±',0),(498846,13857,'fr','Masquer un don bouton',0),(498847,13857,'jp','éš ã™ãƒœã‚¿ãƒ³ã‚’å¯„ä»˜ã—ã¾ã™ã€‚',0),(498848,13857,'pt','Ocultar botÃ£o de doar',0),(498849,13857,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÐºÐ½Ð¾Ð¿ÐºÑƒ Ð¿Ð¾Ð¶ÐµÑ€Ñ‚Ð²Ð¾Ð²Ð°Ñ‚ÑŒ',0),(498850,13857,'es','Ocultar donar botÃ³n',0),(498851,13857,'de','Ausblenden Spenden Button',0),(498852,13857,'en','Hide Donate Button',0),(498853,13858,'is','',0),(498854,13858,'dr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ù‡Ø§',0),(498855,13858,'pr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ù‡Ø§',0),(498856,13858,'tr','Eklemeler',0),(498857,13858,'pl','Dodatki',0),(498858,13858,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ñ',0),(498859,13858,'ur','Ø§Ø¶Ø§ÙÛ',0),(498860,13858,'sr','Ð”Ð¾Ð´Ð°Ñ†Ð¸',0),(498861,13858,'vi','Bá»• sung',0),(498862,13858,'af','Toevoegings',0),(498863,13858,'ro','CompletÄƒrile',0),(498864,13858,'et','TÃ¤iendused',0),(498865,13858,'si','Dodatki',0),(498866,13858,'ba','Penambahan',0),(498867,13858,'nl','Toevoegingen',0),(498868,13858,'fi','LisÃ¤ykset',0),(498869,13858,'no','Tillegg',0),(498870,13858,'da','TilfÃ¸jelser',0),(498871,13858,'ko','ì¶”ê°€',0),(498872,13858,'he','×ª×•×¡×¤×•×ª',0),(498873,13858,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎµÏ‚',0),(498874,13858,'zh','æ·»åŠ ',0),(498875,13858,'sv','TillÃ¤gg',0),(498876,13858,'it','Aggiunte',0),(498877,13858,'tl','',0),(498878,13858,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(498879,13858,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤§à¤¨',0),(498880,13858,'ms','Penambahan',0),(498881,13858,'ar','Ø¥Ø¶Ø§ÙØ§Øª',0),(498882,13858,'fr','Ajouts',0),(498883,13858,'jp','è¿½åŠ æ©Ÿèƒ½',0),(498884,13858,'pt','AdiÃ§Ãµes',0),(498885,13858,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(498886,13858,'es','Adicional',0),(498887,13858,'de','ErgÃ¤nzungen',0),(498888,13858,'en','Additions',0),(498889,13859,'is','',0),(498890,13859,'dr','ØªØ¹Ø§Ø¯Ù„ Ø§Ù†ØªØ¸Ø§Ø± Ù…ÛŒ Ø±ÙˆØ¯',0),(498891,13859,'pr','ØªØ¹Ø§Ø¯Ù„ Ø§Ù†ØªØ¸Ø§Ø± Ù…ÛŒ Ø±ÙˆØ¯',0),(498892,13859,'tr','Beklenen bakiye',0),(498893,13859,'pl','Przewidywany bilans',0),(498894,13859,'bg','ÐžÑ‡Ð°ÐºÐ²Ð°Ð½Ð¸Ñ‚Ðµ ÑÑƒÐ¼Ð¸',0),(498895,13859,'ur','Ù…ØªÙˆÙ‚Ø¹ ØªÙˆØ§Ø²Ù†',0),(498896,13859,'sr','ÐžÑ‡ÐµÐºÐ¸Ð²Ð°Ð½Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(498897,13859,'vi','Dá»± kiáº¿n sá»‘ dÆ°',0),(498898,13859,'af','Verwagte balans',0),(498899,13859,'ro','AÅŸteptat echilibru',0),(498900,13859,'et','Eeldatav bilanss',0),(498901,13859,'si','PriÄakovano stanje',0),(498902,13859,'ba','Diharapkan keseimbangan',0),(498903,13859,'nl','Saldo verwacht',0),(498904,13859,'fi','Odotettu tasapaino',0),(498905,13859,'no','Forventet balanse',0),(498906,13859,'da','Forventet Balance',0),(498907,13859,'ko','ì˜ˆìƒëœ ìž”ì•¡',0),(498908,13859,'he','×”××™×–×•×Ÿ ×”×¦×¤×•×™',0),(498909,13859,'el','Î‘Î½Î±Î¼ÎµÎ½ÏŒÎ¼ÎµÎ½Î· Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±',0),(498910,13859,'zh','é¢„æœŸçš„å¹³è¡¡',0),(498911,13859,'sv','FÃ¶rvÃ¤ntade balansen',0),(498912,13859,'it','Equilibrio previsto',0),(498913,13859,'tl','',0),(498914,13859,'th','à¸”à¸¸à¸¥à¸—à¸µà¹ˆà¸„à¸²à¸”à¹„à¸§à¹‰',0),(498915,13859,'hi','à¤‰à¤®à¥à¤®à¥€à¤¦ à¤•à¥€ à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿',0),(498916,13859,'ms','Baki yang dijangka',0),(498917,13859,'ar','Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ù…ØªÙˆÙ‚Ø¹',0),(498918,13859,'fr','Solde attendu',0),(498919,13859,'jp','äºˆæƒ³ã•ã‚Œã‚‹ãƒãƒ©ãƒ³ã‚¹',0),(498920,13859,'pt','EquilÃ­brio esperado',0),(498921,13859,'ru','ÐžÐ¶Ð¸Ð´Ð°ÐµÐ¼Ñ‹Ð¹ Ð¾ÑÑ‚Ð°Ñ‚Ð¾Ðº',0),(498922,13859,'es','Balance esperado',0),(498923,13859,'de','Erwartete Gleichgewicht',0),(498924,13859,'en','Expected Balance',0),(498925,13860,'is','',0),(498926,13860,'dr','Subtractions',0),(498927,13860,'pr','Subtractions',0),(498928,13860,'tr','Subtractions',0),(498929,13860,'pl','Odejmowanie',0),(498930,13860,'bg','Ð˜Ð·Ð²Ð°Ð¶Ð´Ð°Ð½Ðµ',0),(498931,13860,'ur','Ø³Ø¨Ù¹Ø±ÛŒÚ©Ù¹Ø§Ù†Ø³',0),(498932,13860,'sr','Ð¡ÑƒÐ±Ñ‚Ñ€Ð°Ñ†Ñ‚Ð¸Ð¾Ð½Ñ',0),(498933,13860,'vi','Subtractions',0),(498934,13860,'af','Aftrek',0),(498935,13860,'ro','Scaderi',0),(498936,13860,'et','Subtractions',0),(498937,13860,'si','Subtractions',0),(498938,13860,'ba','Pengurangan',0),(498939,13860,'nl','Aftrekken',0),(498940,13860,'fi','VÃ¤hennyslaskua',0),(498941,13860,'no','Subtractions',0),(498942,13860,'da','Fradrag',0),(498943,13860,'ko','ê°ì‚°',0),(498944,13860,'he','×”×ž×ª×—×•×œ×œ×•×ª',0),(498945,13860,'el','Î‘Ï†Î±Î¹ÏÎ­ÏƒÎµÎ¹Ï‚',0),(498946,13860,'zh','å¢žå‡',0),(498947,13860,'sv','Subtraktioner',0),(498948,13860,'it','Sottrazioni',0),(498949,13860,'tl','',0),(498950,13860,'th','à¸¥à¸š',0),(498951,13860,'hi','Subtractions à¤¬à¤¸',0),(498952,13860,'ms','Subtractions',0),(498953,13860,'ar','Ø§Ù„Ø·Ø±Ø­',0),(498954,13860,'fr','Soustractions',0),(498955,13860,'jp','åŠ æ¸›ç®—',0),(498956,13860,'pt','SubtraÃ§Ãµes',0),(498957,13860,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚Ñ‹',0),(498958,13860,'es','Restas',0),(498959,13860,'de','Subtraktionen',0),(498960,13860,'en','Subtractions',0),(498961,13861,'is','',0),(498962,13861,'dr','ØªØºÛŒÛŒØ±',0),(498963,13861,'pr','ØªØºÛŒÛŒØ±',0),(498964,13861,'tr','DeÄŸiÅŸtir',0),(498965,13861,'pl','Zmiana',0),(498966,13861,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð°',0),(498967,13861,'ur','ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(498968,13861,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð°',0),(498969,13861,'vi','Thay Ä‘á»•i',0),(498970,13861,'af','Verandering',0),(498971,13861,'ro','Schimbare',0),(498972,13861,'et','Muutus',0),(498973,13861,'si','Sprememba',0),(498974,13861,'ba','Perubahan',0),(498975,13861,'nl','Wijzigen',0),(498976,13861,'fi','Muutos',0),(498977,13861,'no','Endre',0),(498978,13861,'da','Ã†ndring',0),(498979,13861,'ko','ë³€ê²½',0),(498980,13861,'he','×©×™× ×•×™',0),(498981,13861,'el','Î‘Î»Î»Î±Î³Î®',0),(498982,13861,'zh','å˜åŒ–',0),(498983,13861,'sv','Ã„ndra',0),(498984,13861,'it','Cambiamento',0),(498985,13861,'tl','',0),(498986,13861,'th','à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(498987,13861,'hi','à¤¬à¤¦à¤²à¥‡à¤‚',0),(498988,13861,'ms','Perubahan',0),(498989,13861,'ar','Ø§Ù„ØªØºÙŠÙŠØ±',0),(498990,13861,'fr','Changement',0),(498991,13861,'jp','å¤‰æ›´',0),(498992,13861,'pt','MudanÃ§a',0),(498993,13861,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(498994,13861,'es','Cambio',0),(498995,13861,'de','Ã„nderung',0),(498996,13861,'en','Change',0),(498997,13862,'is','',0),(498998,13862,'dr','Tendered',0),(498999,13862,'pr','Tendered',0),(499000,13862,'tr','Ä°hale',0),(499001,13862,'pl','Przetargu',0),(499002,13862,'bg','Ð¢ÑŠÑ€Ð³',0),(499003,13862,'ur','Ø·Ø±Ø­ Ø¯Ù„Ú©Ø´',0),(499004,13862,'sr','ÐŸÐ¾Ð´Ð½ÐµÐ¾',0),(499005,13862,'vi','Äáº¥u tháº§u',0),(499006,13862,'af','Aangebied',0),(499007,13862,'ro','Licitat',0),(499008,13862,'et','Pakutud',0),(499009,13862,'si','Ponujeni',0),(499010,13862,'ba','Ditenderkan',0),(499011,13862,'nl','In het bod ingebracht',0),(499012,13862,'fi','Tarjottu',0),(499013,13862,'no','ForeslÃ¥s',0),(499014,13862,'da','Tilbudte',0),(499015,13862,'ko','ìœ„íƒ',0),(499016,13862,'he','×”×’×©×ª',0),(499017,13862,'el','Î ÏÎ¿ÏƒÏ†ÎµÏÏŒÎ¼ÎµÎ½Î·',0),(499018,13862,'zh','æ‹›æ ‡',0),(499019,13862,'sv','InlÃ¤mnade',0),(499020,13862,'it','Appaltate',0),(499021,13862,'tl','',0),(499022,13862,'th','à¸Šà¸³à¸£à¸°à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(499023,13862,'hi','à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤',0),(499024,13862,'ms','Ditender',0),(499025,13862,'ar','Ø¹Ø·Ø§Ø¡Ø§Øª',0),(499026,13862,'fr','Offerte',0),(499027,13862,'jp','å¿œå‹Ÿ',0),(499028,13862,'pt','Adjudicados',0),(499029,13862,'ru','Ð¢Ð¾Ñ€Ð³Ð¸',0),(499030,13862,'es','Licitado',0),(499031,13862,'de','Ausgeschrieben',0),(499032,13862,'en','Tendered',0),(499033,13863,'is','',0),(499034,13863,'dr','BOM Ø®ÙˆØ¯Ú©Ø§Ø± Ø³Ø§Ø®Øª',0),(499035,13863,'pr','BOM Ø®ÙˆØ¯Ú©Ø§Ø± Ø³Ø§Ø®Øª',0),(499036,13863,'tr','ÃœrÃ¼n ReÃ§etesi otomatik oluÅŸtur',0),(499037,13863,'pl','BOM Auto budowaÄ‡',0),(499038,13863,'bg','Auto-Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° ÐšÐ˜',0),(499039,13863,'ur','Ø¨Ø§Ù… Ø®ÙˆØ¯ ØªØ¹Ù…ÛŒØ±',0),(499040,13863,'sr','Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ ÐÑƒÑ‚Ð¾-Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÑƒ',0),(499041,13863,'vi','BOM Auto-xÃ¢y dá»±ng',0),(499042,13863,'af','BOM Outo-bou',0),(499043,13863,'ro','LM Auto-Build',0),(499044,13863,'et','Koosluse Auto-Build',0),(499045,13863,'si','Auto-graditi Kosovnice',0),(499046,13863,'ba','BOM Auto-membangun',0),(499047,13863,'nl','BOM Auto-Build',0),(499048,13863,'fi','Tuoterakenteen Auto-Build',0),(499049,13863,'no','Stykklisten Auto-bygge',0),(499050,13863,'da','Styklisten Auto-Build',0),(499051,13863,'ko','BOM ìžë™ ë¹Œë“œ',0),(499052,13863,'he','BOM ××•×˜×•×ž×˜×™-×œ×‘× ×•×ª',0),(499053,13863,'el','Auto-ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Ï„ÎµÏ‡Î½Î¹ÎºÏŽÎ½ Ï€ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†ÏŽÎ½',0),(499054,13863,'zh','ç‰©æ–™æ¸…å•è‡ªåŠ¨ç”Ÿæˆ',0),(499055,13863,'sv','BOM Auto-Build',0),(499056,13863,'it','BOM Auto-compilazione',0),(499057,13863,'tl','',0),(499058,13863,'th','à¸ªà¸£à¹‰à¸²à¸‡ BOM à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(499059,13863,'hi','BOM à¤‘à¤Ÿà¥‹-à¤¬à¤¿à¤²à¥à¤¡',0),(499060,13863,'ms','BOM Auto-membina',0),(499061,13863,'ar','Ø´Ø¬Ø±Ø© Ø§Ù„Ù…ÙˆØ§Ø¯ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª-Ø§Ù„Ø¨Ù†Ø§Ø¡',0),(499062,13863,'fr','BOM Auto-construction',0),(499063,13863,'jp','BOM ã®è‡ªå‹•æ§‹ç¯‰',0),(499064,13863,'pt','BOM Auto-construÃ§Ã£o',0),(499065,13863,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸ Auto ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ',0),(499066,13863,'es','BOM Auto-Build',0),(499067,13863,'de','BOM Auto-Build',0),(499068,13863,'en','BOM Auto-Build',0),(499069,13864,'is','',0),(499070,13864,'dr','Stationers Ù…ØªØ­Ø¯Ù‡ Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(499071,13864,'pr','Stationers Ù…ØªØ­Ø¯Ù‡ Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(499072,13864,'tr','BirleÅŸik KÄ±rtasiyeler teklif alÄ±n',0),(499073,13864,'pl','Pobierz ofertÄ™ United Stationers',0),(499074,13864,'bg','ÐžÐ±ÐµÐ´Ð¸Ð½ÐµÐ½Ð° Stationers Ð¾Ñ„ÐµÑ€Ñ‚Ð°',0),(499075,13864,'ur','Ù…ØªØ­Ø¯Û Ø³Ù¹ÛŒÙ¹Ø§ÙˆÙ†Ø±Ø³ Ú©ÙˆÙ¹ÛŒØ´Ù†',0),(499076,13864,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð¸ ÑƒÑ˜ÐµÐ´Ð¸ÑšÐµÐ½Ð¸ Ð¿Ð¾Ð·Ð¸Ð²Ð½Ð¸Ñ†Ð°Ð¼Ð° Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(499077,13864,'vi','Nháº­n bÃ¡o giÃ¡ Hoa Stationers',0),(499078,13864,'af','Verenigde skryfbehoeftewinkels kwotasie kry',0),(499079,13864,'ro','Ia Unit Stationers citat',0),(499080,13864,'et','Saada Ameerika Stationers tsitaat',0),(499081,13864,'si','Dobili ponudbo ZdruÅ¾eno Stationers',0),(499082,13864,'ba','Dapatkan penawaran Inggris Stationers',0),(499083,13864,'nl','Vraag offerte aan Verenigde Stationers',0),(499084,13864,'fi','Iso Stationers tarjouspyyntÃ¶',0),(499085,13864,'no','FÃ¥ United Stationers tilbud',0),(499086,13864,'da','FÃ¥ forenet Stationers tilbud',0),(499087,13864,'ko','ë¯¸êµ­ëœ ë™ë„¤ ê²¬ì ',0),(499088,13864,'he','×œ×§×‘×œ ×”×¦×¢×ª ×ž×—×™×¨ Stationers ×™×•× ×™×™×˜×“',0),(499089,13864,'el','Î–Î·Ï„Î®ÏƒÏ„Îµ Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ ÎµÎ½Ï‰Î¼Î­Î½Î· Ï‡Î±ÏÏ„Î¿Ï€Ï‰Î»ÎµÎ¯Î±',0),(499090,13864,'zh','èŽ·å¾—è”åˆå›½çš„æ–‡å…·åº—æŠ¥ä»·',0),(499091,13864,'sv','FÃ¥ FÃ¶renade Stationers offert',0),(499092,13864,'it','Richiedi preventivo United Stationers',0),(499093,13864,'tl','',0),(499094,13864,'th','à¹„à¸”à¹‰à¸£à¸±à¸šà¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸² Stationers à¸ªà¸«à¸£à¸±à¸',0),(499095,13864,'hi','à¤¯à¥‚à¤¨à¤¾à¤‡à¤Ÿà¥‡à¤¡ Stationers à¤‰à¤¦à¥à¤§à¤°à¤£ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¥‡à¤‚',0),(499096,13864,'ms','Mendapatkan sebut harga Stationers Bersatu',0),(499097,13864,'ar','Ø§Ø­ØµÙ„ Ø¹Ù„Ù‰ Ø¹Ø±Ø¶ Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ù…ØªØ­Ø¯Ø© Ù…ÙƒØªØ¨ØªÙ‡Ø§',0),(499098,13864,'fr','Demander un devis papeterie unie',0),(499099,13864,'jp','ã‚¢ãƒ¡ãƒªã‚«åˆè¡†å›½ã®æ–‡æˆ¿å…·ã®è¦‹ç©ã‚‚ã‚Šã‚’å–å¾—ã—ã¾ã™ã€‚',0),(499100,13864,'pt','Obter cotaÃ§Ã£o de papelarias Unidos',0),(499101,13864,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° ÐžÑ€Ð³Ð°Ð½Ð¸Ð·Ð°Ñ†Ð¸Ð¸ ÐºÐ°Ð½Ñ†ÐµÐ»ÑÑ€ÑÐºÐ¸Ñ… Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(499102,13864,'es','United Stationers cotizar',0),(499103,13864,'de','United Stationers Sofortangebot',0),(499104,13864,'en','Get United Stationers Quote',0),(499105,13865,'is','',0),(499106,13865,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ù…Ú©Ø§Ù† Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(499107,13865,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ù…Ú©Ø§Ù† Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(499108,13865,'tr','VarsayÄ±lan stok konumu seÃ§melisiniz',0),(499109,13865,'pl','Musisz wybraÄ‡ domyÅ›lnÄ… lokalizacjÄ™ magazynu',0),(499110,13865,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(499111,13865,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø·Û’ Ø´Ø¯Û Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(499112,13865,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ñ‚Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(499113,13865,'vi','Báº¡n pháº£i chá»n vá»‹ trÃ­ máº·c Ä‘á»‹nh hÃ ng tá»“n kho',0),(499114,13865,'af','Jy moet kies \'n verstek voorraad ligging',0),(499115,13865,'ro','Trebuie sÄƒ selectaÅ£i o locaÅ£ie de inventar implicit',0),(499116,13865,'et','Valige varude vaikeasukohta',0),(499117,13865,'si','Izbrati morate privzeto lokacijo zaloge',0),(499118,13865,'ba','Anda harus memilih lokasi persediaan Default',0),(499119,13865,'nl','U moet een standaardlocatie voorraad selecteren',0),(499120,13865,'fi','Valitse oletussijainti varasto',0),(499121,13865,'no','Du mÃ¥ velge en standard lagerlokasjon',0),(499122,13865,'da','Du skal vÃ¦lge en standard lagerlokation',0),(499123,13865,'ko','ê¸°ë³¸ ì¸ë²¤í† ë¦¬ ìœ„ì¹˜ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(499124,13865,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×ž×™×§×•× ×”×ž×œ××™ ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(499125,13865,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î¼Î¹Î± Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î±Ï€Î¿Î¸Î®ÎºÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(499126,13865,'zh','æ‚¨å¿…é¡»é€‰æ‹©ä¸€ä¸ªé»˜è®¤åº“å­˜ä½ç½®',0),(499127,13865,'sv','Du mÃ¥ste vÃ¤lja en standard lagerstÃ¤lle',0),(499128,13865,'it','Ãˆ necessario selezionare un percorso di inventario predefinito',0),(499129,13865,'tl','',0),(499130,13865,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(499131,13865,'hi','à¤†à¤ªà¤•à¥‹ à¤•à¤¿à¤¸à¥€ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(499132,13865,'ms','Anda mesti memilih lokasi inventori lalai',0),(499133,13865,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ­Ø¯ÙŠØ¯ Ù…ÙˆÙ‚Ø¹ Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(499134,13865,'fr','Vous devez sÃ©lectionner un emplacement d\'inventaire par dÃ©faut',0),(499135,13865,'jp','æ—¢å®šã®åœ¨åº«å ´æ‰€ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(499136,13865,'pt','VocÃª deve selecionar um local de estoque padrÃ£o',0),(499137,13865,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(499138,13865,'es','Debe seleccionar una ubicaciÃ³n de inventario predeterminado',0),(499139,13865,'de','Sie mÃ¼ssen einen Standardspeicherort Inventar auswÃ¤hlen.',0),(499140,13865,'en','You Must Select A Default Inventory Location',0),(499141,13866,'is','',0),(499142,13866,'dr','Ø¯Ø±ØµØ¯ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(499143,13866,'pr','Ø¯Ø±ØµØ¯ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(499144,13866,'tr','Navlun yÃ¼zde',0),(499145,13866,'pl','Procent towarÃ³w',0),(499146,13866,'bg','Ð¢Ð¾Ð²Ð°Ñ€ÐµÐ½ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(499147,13866,'ur','ÙØ±Ø§Ø¦Ù¹ ÙÛŒØµØ¯',0),(499148,13866,'sr','Ð¢ÐµÑ€ÐµÑ‚Ð½Ð¸ Ð¿Ð¾ÑÑ‚Ð¾',0),(499149,13866,'vi','Váº­n chuyá»ƒn hÃ ng hÃ³a pháº§n trÄƒm',0),(499150,13866,'af','Vrag persent',0),(499151,13866,'ro','Transportul de mÄƒrfuri la sutÄƒ',0),(499152,13866,'et','Kaubaveo protsenti',0),(499153,13866,'si','Odstotkov tovora',0),(499154,13866,'ba','Persen kargo',0),(499155,13866,'nl','Vracht procent',0),(499156,13866,'fi','Tavaraliikenteen prosenttia',0),(499157,13866,'no','Frakt prosent',0),(499158,13866,'da','Fragt procent',0),(499159,13866,'ko','í™”ë¬¼ %',0),(499160,13866,'he','×”×•×‘×œ×” ××—×•×–×™×',0),(499161,13866,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï„Ï‰Î½ ÎµÎ¼Ï€Î¿ÏÎµÏ…Î¼Î±Ï„Î¹ÎºÏŽÎ½ Î¼ÎµÏ„Î±Ï†Î¿ÏÏŽÎ½',0),(499162,13866,'zh','è´§è¿ %',0),(499163,13866,'sv','Frakt procent',0),(499164,13866,'it','Per cento del trasporto',0),(499165,13866,'tl','',0),(499166,13866,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸„à¹ˆà¸²à¸‚à¸™à¸ªà¹ˆà¸‡',0),(499167,13866,'hi','à¤®à¤¾à¤² à¤¢à¥à¤²à¤¾à¤ˆ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(499168,13866,'ms','Peratus pengangkutan',0),(499169,13866,'ar','Ø§Ù„Ø´Ø­Ù† Ø¨Ø§Ù„Ù…Ø¦Ø©',0),(499170,13866,'fr','Fret pour cent',0),(499171,13866,'jp','è²¨ç‰©ã®ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆ',0),(499172,13866,'pt','Por cento do frete',0),(499173,13866,'ru','Ð¡Ñ‚Ð°Ð²ÐºÐ¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð°',0),(499174,13866,'es','Por ciento de la carga',0),(499175,13866,'de','Fracht Prozent',0),(499176,13866,'en','Freight Percent',0),(499177,13867,'is','',0),(499178,13867,'dr','Ø¨Ø§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‚ÛŒÙ…Øª Markups Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(499179,13867,'pr','Ø¨Ø§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‚ÛŒÙ…Øª Markups Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(499180,13867,'tr','SatÄ±cÄ± maliyet fiyatÄ± iÅŸaretlemeleri ile kullanÄ±lan',0),(499181,13867,'pl','W przypadku dostawcy koszt znacznikÃ³w',0),(499182,13867,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ñ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐµÐ±ÐµÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ñ‚Ð° ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸',0),(499183,13867,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ Ù‚ÛŒÙ…Øª Ù…Ø¢Ø±Ú©Ùˆ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§',0),(499184,13867,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÑÐ° ÐœÐ°Ñ€ÐºÑƒÐ¿Ñ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ñ†ÐµÐ½Ñƒ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(499185,13867,'vi','ÄÆ°á»£c sá»­ dá»¥ng vá»›i nhÃ  cung cáº¥p chi phÃ­ giÃ¡ Markups',0),(499186,13867,'af','Gebruik met handelaar kosprys Markups',0),(499187,13867,'ro','Folosit cu marcaje de preÅ£ul de Cost furnizor',0),(499188,13867,'et','Kasutada hankija omahind mÃµÃµtmismÃ¤rkeid',0),(499189,13867,'si','Uporablja s pribitki ceno dobavitelja',0),(499190,13867,'ba','Digunakan dengan Vendor harga markup',0),(499191,13867,'nl','Gebruikt in combinatie met leverancier kostprijs markeringen',0),(499192,13867,'fi','KÃ¤yttÃ¤Ã¤ toimittajan kustannushinta katteet',0),(499193,13867,'no','Brukes med leverandÃ¸ren kostpris markeringer',0),(499194,13867,'da','Bruges med kreditor kostpris opmÃ¦rkninger',0),(499195,13867,'ko','ê³µê¸‰ ì—…ì²´ ë¹„ìš© ê°€ê²© ë§ˆí¬ì—… ì‚¬ìš©',0),(499196,13867,'he','×‘×©×™×ž×•×© ×¢× ×¡×¤×§ ×ž×—×™×¨ ×¢×œ×•×ª ×¡×™×ž×•× ×™×',0),(499197,13867,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î¼Îµ Ï„Î¹Î¼Î® ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÏ‰Î½ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(499198,13867,'zh','ä¸Žä¾›åº”å•†æˆæœ¬ä»·æ ¼æ ‡è®°ä¸€èµ·ä½¿ç”¨',0),(499199,13867,'sv','AnvÃ¤nds med leverantÃ¶rens sjÃ¤lvkostnad markeringar',0),(499200,13867,'it','Utilizzato con marcature di costo prezzo fornitore',0),(499201,13867,'tl','',0),(499202,13867,'th','à¹ƒà¸Šà¹‰à¸à¸±à¸šà¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸£à¸²à¸„à¸²à¸•à¹‰à¸™à¸—à¸¸à¸™ Markups',0),(499203,13867,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤²à¤¾à¤—à¤¤ à¤®à¥‚à¤²à¥à¤¯ Markups à¤•à¥‡ à¤¸à¤¾à¤¥ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(499204,13867,'ms','Digunakan dengan penjual kos sedia',0),(499205,13867,'ar','ÙŠØ³ØªØ®Ø¯Ù… Ù…Ø¹ Ù‡ÙˆØ§Ù…Ø´ Ø§Ù„Ø±Ø¨Ø­ ÙÙŠ Ø³Ø¹Ø± ØªÙƒÙ„ÙØ© Ø§Ù„Ù…ÙˆØ±Ø¯',0),(499206,13867,'fr','UtilisÃ© avec les majorations de prix de revient du vendeur',0),(499207,13867,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®ã‚³ã‚¹ãƒˆä¾¡æ ¼ã®å€¤ä¸Šã’ã‚’ä½¿ç”¨',0),(499208,13867,'pt','Usado com marcaÃ§Ãµes de preÃ§o de custo do fornecedor',0),(499209,13867,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ñ Ð½Ð°Ñ†ÐµÐ½ÐºÐ¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ†ÐµÐ½Ð°',0),(499210,13867,'es','Utilizado con marcas de precio vendedor',0),(499211,13867,'de','Mit Vendor Einstandspreis Markups verwendet',0),(499212,13867,'en','Used With Vendor Cost Price Markups',0),(499213,13868,'is','',0),(499214,13868,'dr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† 10 Ø³Ù†Øª',0),(499215,13868,'pr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† 10 Ø³Ù†Øª',0),(499216,13868,'tr','En yakÄ±n 10 sent',0),(499217,13868,'pl','NajbliÅ¼szego 10 centÃ³w',0),(499218,13868,'bg','ÐÐ°Ð¹-Ð±Ð»Ð¸Ð·ÐºÐ°Ñ‚Ð° 10 Ñ†ÐµÐ½Ñ‚Ð°',0),(499219,13868,'ur','Ù‚Ø±ÛŒØ¨ 10 Ø³ÛŒÙ†Ù¹',0),(499220,13868,'sr','ÐÐ°Ñ˜Ð±Ð»Ð¸Ð¶Ð¸ 10 Ñ†ÐµÐ½Ñ‚Ð¸',0),(499221,13868,'vi','Gáº§n nháº¥t 10 cent',0),(499222,13868,'af','Naaste 10 sent',0),(499223,13868,'ro','Cel mai apropiat de 10 de cenÅ£i',0),(499224,13868,'et','LÃ¤hima 10 senti',0),(499225,13868,'si','NajbliÅ¾je 10 centov',0),(499226,13868,'ba','10 sen terdekat',0),(499227,13868,'nl','Dichtstbijzijnde 10 cent',0),(499228,13868,'fi','LÃ¤hin 10 senttiÃ¤',0),(499229,13868,'no','NÃ¦rmeste 10 cent',0),(499230,13868,'da','NÃ¦rmeste 10 cent',0),(499231,13868,'ko','ê°€ìž¥ ê°€ê¹Œìš´ 10 ì„¼íŠ¸',0),(499232,13868,'he','×”×§×¨×•×‘ 10 ×¡× ×˜',0),(499233,13868,'el','Î Î»Î·ÏƒÎ¹Î­ÏƒÏ„ÎµÏÎ¿ 10 ÏƒÎµÎ½Ï„Ï‚',0),(499234,13868,'zh','æœ€è¿‘çš„ 10 ç¾Žåˆ†',0),(499235,13868,'sv','NÃ¤rmaste 10 cent',0),(499236,13868,'it','PiÃ¹ vicine 10 centesimi',0),(499237,13868,'tl','',0),(499238,13868,'th','10 à¹€à¸‹à¸™à¸•à¹Œ à¸—à¸µà¹ˆà¹ƒà¸à¸¥à¹‰à¸—à¸µà¹ˆà¸ªà¸¸à¸”',0),(499239,13868,'hi','à¤¨à¤¿à¤•à¤Ÿà¤¤à¤® 10 à¤¸à¥‡à¤‚à¤Ÿ',0),(499240,13868,'ms','Terdekat 10 sen',0),(499241,13868,'ar','Ø£Ù‚Ø±Ø¨ 10 Ø³Ù†ØªØ§Øª',0),(499242,13868,'fr','Multiple de 10 Cents',0),(499243,13868,'jp','æœ€ã‚‚è¿‘ã„ 10 ã‚»ãƒ³ãƒˆ',0),(499244,13868,'pt','Mais prÃ³ximos 10 centavos',0),(499245,13868,'ru','Ð‘Ð»Ð¸Ð¶Ð°Ð¹ÑˆÐ¸Ð¹ 10 Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(499246,13868,'es','10 centavos mÃ¡s cercanos',0),(499247,13868,'de','NÃ¤chsten 10 Cent',0),(499248,13868,'en','Nearest 10 Cents',0),(499249,13869,'is','',0),(499250,13869,'dr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† 25 Ø³Ù†Øª',0),(499251,13869,'pr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† 25 Ø³Ù†Øª',0),(499252,13869,'tr','YakÄ±n 25 sent',0),(499253,13869,'pl','NajbliÅ¼szy 25 centÃ³w',0),(499254,13869,'bg','ÐÐ°Ð¹-Ð±Ð»Ð¸Ð·ÐºÐ°Ñ‚Ð° 25 Ñ†ÐµÐ½Ñ‚Ð°',0),(499255,13869,'ur','Ù‚Ø±ÛŒØ¨ ØªØ±ÛŒÙ† 25 Ø³ÛŒÙ†Ù¹',0),(499256,13869,'sr','ÐÐ°Ñ˜Ð±Ð»Ð¸Ð¶Ð¸ 25 Ñ†ÐµÐ½Ñ‚Ð¸',0),(499257,13869,'vi','Gáº§n nháº¥t 25 cent',0),(499258,13869,'af','Naaste 25 sent',0),(499259,13869,'ro','Cel mai apropiat de 25 de centi',0),(499260,13869,'et','LÃ¤hima 25 senti',0),(499261,13869,'si','NajbliÅ¾je 25 centov',0),(499262,13869,'ba','25 sen terdekat',0),(499263,13869,'nl','Dichtstbijzijnde 25 cent',0),(499264,13869,'fi','LÃ¤hin 25 senttiÃ¤',0),(499265,13869,'no','NÃ¦rmeste 25 cent',0),(499266,13869,'da','NÃ¦rmeste 25 cent',0),(499267,13869,'ko','ê°€ìž¥ ê°€ê¹Œìš´ 25 ì„¼íŠ¸',0),(499268,13869,'he','×”×§×¨×•×‘ 25 ×¡× ×˜',0),(499269,13869,'el','Î Î»Î·ÏƒÎ¹Î­ÏƒÏ„ÎµÏÎ¿ ÏƒÎµÎ½Ï„ 25',0),(499270,13869,'zh','æœ€è¿‘ 25 ç¾Žåˆ†',0),(499271,13869,'sv','NÃ¤rmaste 25 cent',0),(499272,13869,'it','PiÃ¹ vicine 25 centesimi',0),(499273,13869,'tl','',0),(499274,13869,'th','à¸—à¸µà¹ˆà¹ƒà¸à¸¥à¹‰à¸—à¸µà¹ˆà¸ªà¸¸à¸” 25 à¹€à¸‹à¸™à¸•à¹Œ',0),(499275,13869,'hi','à¤¨à¤¿à¤•à¤Ÿà¤¤à¤® 25 à¤¸à¥‡à¤‚à¤Ÿ',0),(499276,13869,'ms','Terdekat 25 sen',0),(499277,13869,'ar','Ø£Ù‚Ø±Ø¨ 25 Ø³Ù†ØªØ§',0),(499278,13869,'fr','Multiple de 25 Cents',0),(499279,13869,'jp','æœ€ã‚‚è¿‘ã„ 25 ã‚»ãƒ³ãƒˆ',0),(499280,13869,'pt','Mais prÃ³ximos 25 centavos',0),(499281,13869,'ru','Ð‘Ð»Ð¸Ð¶Ð°Ð¹ÑˆÐ¸Ðµ 25 Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(499282,13869,'es','25 centavos mÃ¡s cercanos',0),(499283,13869,'de','NÃ¤chste 25 Cent',0),(499284,13869,'en','Nearest 25 Cents',0),(499285,13870,'is','',0),(499286,13870,'dr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† 5 Ø³Ù†Øª',0),(499287,13870,'pr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† 5 Ø³Ù†Øª',0),(499288,13870,'tr','En yakÄ±n 5 kuruÅŸ',0),(499289,13870,'pl','NajbliÅ¼sze 5 groszy',0),(499290,13870,'bg','ÐÐ°Ð¹-Ð±Ð»Ð¸Ð·ÐºÐ°Ñ‚Ð° 5 Ñ†ÐµÐ½Ñ‚Ð°',0),(499291,13870,'ur','Ù‚Ø±ÛŒØ¨ ØªØ±ÛŒÙ† 5 Ø³ÛŒÙ†Ù¹',0),(499292,13870,'sr','ÐÐ°Ñ˜Ð±Ð»Ð¸Ð¶Ðµ 5 Ñ†ÐµÐ½Ñ‚Ð¸',0),(499293,13870,'vi','Gáº§n nháº¥t 5 cent',0),(499294,13870,'af','Naaste 5 sent',0),(499295,13870,'ro','Cel mai apropiat 5 centi',0),(499296,13870,'et','LÃ¤hima 5 senti',0),(499297,13870,'si','NajbliÅ¾je 5 centov',0),(499298,13870,'ba','5 sen terdekat',0),(499299,13870,'nl','Dichtstbijzijnde 5 cent',0),(499300,13870,'fi','LÃ¤himpÃ¤Ã¤n viiteen senttiin',0),(499301,13870,'no','NÃ¦rmeste 5 Cents',0),(499302,13870,'da','NÃ¦rmeste 5 Cents',0),(499303,13870,'ko','ê°€ìž¥ ê°€ê¹Œìš´ 5 ê°œ ì„¼íŠ¸',0),(499304,13870,'he','×”×§×¨×•×‘ 5 ×¡× ×˜',0),(499305,13870,'el','Î Î»Î·ÏƒÎ¹Î­ÏƒÏ„ÎµÏÎ¿ 5 ÏƒÎµÎ½Ï„Ï‚',0),(499306,13870,'zh','æœ€è¿‘ 5 ç¾Žåˆ†',0),(499307,13870,'sv','NÃ¤rmaste 5 cent',0),(499308,13870,'it','PiÃ¹ vicine 5 centesimi',0),(499309,13870,'tl','',0),(499310,13870,'th','5 à¹€à¸‹à¸™à¸•à¹Œ à¸—à¸µà¹ˆà¹ƒà¸à¸¥à¹‰à¸—à¸µà¹ˆà¸ªà¸¸à¸”',0),(499311,13870,'hi','à¤ªà¤¾à¤¸ 5 à¤¸à¥‡à¤‚à¤Ÿ',0),(499312,13870,'ms','5 sen yang terdekat',0),(499313,13870,'ar','Ø£Ù‚Ø±Ø¨ 5 Ø³Ù†ØªØ§Øª',0),(499314,13870,'fr','Multiple de 5 Cents',0),(499315,13870,'jp','æœ€ã‚‚è¿‘ã„ 5 ã‚»ãƒ³ãƒˆ',0),(499316,13870,'pt','5 centavos de dÃ³lar mais prÃ³ximos',0),(499317,13870,'ru','Ð‘Ð»Ð¸Ð¶Ð°Ð¹ÑˆÐ¸Ðµ 5 Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(499318,13870,'es','5 centavos mÃ¡s cercanos',0),(499319,13870,'de','NÃ¤chsten 5 Cent',0),(499320,13870,'en','Nearest 5 Cents',0),(499321,13871,'is','',0),(499322,13871,'dr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† ÙˆØ§Ø­Ø¯ Ù¾ÙˆÙ„ Ú©Ù„ 5',0),(499323,13871,'pr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† ÙˆØ§Ø­Ø¯ Ù¾ÙˆÙ„ Ú©Ù„ 5',0),(499324,13871,'tr','En yakÄ±n 5 tÃ¼m para birimi',0),(499325,13871,'pl','NajbliÅ¼sze 5 jednostki waluty caÅ‚ego',0),(499326,13871,'bg','ÐÐ°Ð¹-Ð±Ð»Ð¸Ð·ÑŠÐº 5 Ñ†ÑÐ»Ð°Ñ‚Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(499327,13871,'ur','5 Ù¾ÙˆØ±Û’ Ú©Ø±Ù†Ø³ÛŒ Ø§Ú©Ø§Ø¦ÛŒ Ù‚Ø±ÛŒØ¨ÛŒ',0),(499328,13871,'sr','ÐÐ°Ñ˜Ð±Ð»Ð¸Ð¶Ð¸ 5 Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° ÑÐ²Ðµ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(499329,13871,'vi','Gáº§n nháº¥t 5 Ä‘Æ¡n vá»‹ tiá»n tá»‡ toÃ n bá»™',0),(499330,13871,'af','Naaste 5 hele geldeenheid eenheid',0),(499331,13871,'ro','Cel mai apropiat 5 moneda Ã®ntreg',0),(499332,13871,'et','LÃ¤hima 5 kogu rahaÃ¼hik',0),(499333,13871,'si','NajbliÅ¾je 5 celotni denarni enoti',0),(499334,13871,'ba','Terdekat 5 Unit mata uang seluruh',0),(499335,13871,'nl','Dichtstbijzijnde 5 hele valuta eenheid',0),(499336,13871,'fi','LÃ¤hin 5 koko rahayksikkÃ¶',0),(499337,13871,'no','NÃ¦rmeste 5 hele valutaenhet',0),(499338,13871,'da','NÃ¦rmeste 5 hele valutaenhed',0),(499339,13871,'ko','5 ì „ì²´ í†µí™” ë‹¨ìœ„ì— ê°€ìž¥ ê°€ê¹Œìš´',0),(499340,13871,'he','×”×§×¨×•×‘ ×™×—×™×“×ª ×ž×˜×‘×¢ ×›×œ 5',0),(499341,13871,'el','Î Î»Î·ÏƒÎ¹Î­ÏƒÏ„ÎµÏÎ¿ 5 Î¿Î»ÏŒÎºÎ»Î·ÏÎ¿ Î½Î¿Î¼Î¹ÏƒÎ¼Î±Ï„Î¹ÎºÎ® Î¼Î¿Î½Î¬Î´Î±',0),(499342,13871,'zh','æœ€è¿‘ 5 æ•´ä¸ªè´§å¸å•ä½',0),(499343,13871,'sv','NÃ¤rmaste 5 hela valutaenheten',0),(499344,13871,'it','PiÃ¹ vicina 5 unitÃ  monetaria intera',0),(499345,13871,'tl','',0),(499346,13871,'th','à¹ƒà¸à¸¥à¹‰à¸«à¸™à¹ˆà¸§à¸¢à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸” 5',0),(499347,13871,'hi','5 à¤ªà¥‚à¤°à¥‡ à¤®à¥à¤¦à¥à¤°à¤¾ à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¿à¤•à¤Ÿà¤¤à¤®',0),(499348,13871,'ms','Terdekat 5 Unit matawang seluruh',0),(499349,13871,'ar','Ø£Ù‚Ø±Ø¨ ÙˆØ­Ø¯Ø© Ø§Ù„Ø¹Ù…Ù„Ø© ÙƒÙ„Ù‡ 5',0),(499350,13871,'fr','5 unitÃ© de devise entiÃ¨re la plus proche',0),(499351,13871,'jp','æœ€å¯„ã‚Šã® 5 å…¨ä½“ã®é€šè²¨å˜ä½',0),(499352,13871,'pt','Mais prÃ³ximo de 5 moeda toda unidade',0),(499353,13871,'ru','Ð‘Ð»Ð¸Ð¶Ð°Ð¹ÑˆÐ¸Ðµ 5 Ð²ÑÑ Ð´ÐµÐ½ÐµÐ¶Ð½Ð°Ñ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(499354,13871,'es','MÃ¡s cercano a 5 unidad monetaria todo',0),(499355,13871,'de','NÃ¤chste 5 ganze WÃ¤hrungseinheit',0),(499356,13871,'en','Nearest 5 Whole Currency Unit',0),(499357,13872,'is','',0),(499358,13872,'dr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† 99 Ø³Ù†Øª',0),(499359,13872,'pr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† 99 Ø³Ù†Øª',0),(499360,13872,'tr','YakÄ±n 99 cent',0),(499361,13872,'pl','DokÅ‚adnoÅ›ciÄ… 99 centÃ³w',0),(499362,13872,'bg','ÐÐ°Ð¹-Ð±Ð»Ð¸Ð·ÐºÐ°Ñ‚Ð° 99 Ñ†ÐµÐ½Ñ‚Ð°',0),(499363,13872,'ur','Ù‚Ø±ÛŒØ¨ ØªØ±ÛŒÙ† 99 Ø³ÛŒÙ†Ù¹',0),(499364,13872,'sr','ÐÐ°Ñ˜Ð±Ð»Ð¸Ð¶Ð¸ 99 Ñ†ÐµÐ½Ñ‚Ð¸',0),(499365,13872,'vi','Gáº§n nháº¥t 99 cent',0),(499366,13872,'af','Naaste 99 sent',0),(499367,13872,'ro','Cel mai apropiat 99 de cenÅ£i',0),(499368,13872,'et','LÃ¤hima 99 senti',0),(499369,13872,'si','NajbliÅ¾je 99 centov',0),(499370,13872,'ba','99 sen terdekat',0),(499371,13872,'nl','Dichtstbijzijnde 99 centen',0),(499372,13872,'fi','LÃ¤hin 99 senttiÃ¤',0),(499373,13872,'no','NÃ¦rmeste 99 cent',0),(499374,13872,'da','NÃ¦rmeste 99 Cents',0),(499375,13872,'ko','ê°€ê¹Œìš´ 99 ì„¼íŠ¸',0),(499376,13872,'he','×”×§×¨×•×‘ 99 ×¡× ×˜',0),(499377,13872,'el','Î Î»Î·ÏƒÎ¹Î­ÏƒÏ„ÎµÏÎ¿ 99 ÏƒÎµÎ½Ï„',0),(499378,13872,'zh','æœ€è¿‘çš„ 99 ç¾Žåˆ†',0),(499379,13872,'sv','NÃ¤rmaste 99 cent',0),(499380,13872,'it','PiÃ¹ vicini 99 centesimi',0),(499381,13872,'tl','',0),(499382,13872,'th','99 à¹€à¸‹à¸™à¸•à¹Œ à¸—à¸µà¹ˆà¹ƒà¸à¸¥à¹‰à¸—à¸µà¹ˆà¸ªà¸¸à¸”',0),(499383,13872,'hi','99 à¤¸à¥‡à¤‚à¤Ÿ à¤•à¥‡ à¤¨à¤¿à¤•à¤Ÿà¤¤à¤®',0),(499384,13872,'ms','99 sen terdekat',0),(499385,13872,'ar','Ø£Ù‚Ø±Ø¨ 99 Ø³Ù†ØªØ§',0),(499386,13872,'fr','Multiple de 99 Cents',0),(499387,13872,'jp','æœ€ã‚‚è¿‘ã„ 99 ã‚»ãƒ³ãƒˆ',0),(499388,13872,'pt','Mais prÃ³ximos 99 centavos',0),(499389,13872,'ru','Ð‘Ð»Ð¸Ð¶Ð°Ð¹ÑˆÐ¸Ð¹ 99 Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(499390,13872,'es','99 cÃ©ntimos de euro mÃ¡s cercanos',0),(499391,13872,'de','NÃ¤chste 99 Cent',0),(499392,13872,'en','Nearest 99 Cents',0),(499393,13873,'is','',0),(499394,13873,'dr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† 9 Ùˆ 99 Ø³Ù†Øª',0),(499395,13873,'pr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† 9 Ùˆ 99 Ø³Ù†Øª',0),(499396,13873,'tr','En yakÄ±n 9 ve 99 sent',0),(499397,13873,'pl','NajbliÅ¼szy 9 i 99 groszy',0),(499398,13873,'bg','ÐÐ°Ð¹-Ð±Ð»Ð¸Ð·ÐºÐ° 9 Ð¸ 99 Ñ†ÐµÐ½Ñ‚Ð°',0),(499399,13873,'ur','9 Ø§ÙˆØ± 99 Ø³ÛŒÙ†Ù¹ Ù‚Ø±ÛŒØ¨ÛŒ',0),(499400,13873,'sr','ÐÐ°Ñ˜Ð±Ð»Ð¸Ð¶Ð¸ 9 Ð¸ 99 Ñ†ÐµÐ½Ñ‚Ð¸',0),(499401,13873,'vi','Gáº§n nháº¥t 9 vÃ  99 cent',0),(499402,13873,'af','Naaste 9 en 99 sent',0),(499403,13873,'ro','Cel mai apropiat de 9 si 99 de cenÅ£i',0),(499404,13873,'et','LÃ¤him 9-99 senti',0),(499405,13873,'si','NajbliÅ¾je 9 in 99 centov',0),(499406,13873,'ba','Terdekat 9 dan 99 sen',0),(499407,13873,'nl','Dichtstbijzijnde 9 en 99 cent',0),(499408,13873,'fi','LÃ¤hin 9-99 senttiÃ¤',0),(499409,13873,'no','NÃ¦rmeste 9 og 99 cent',0),(499410,13873,'da','NÃ¦rmeste 9 og 99 Cents',0),(499411,13873,'ko','9, 99 ì„¼íŠ¸ì— ê°€ìž¥ ê°€ê¹Œìš´',0),(499412,13873,'he','×”×§×¨×•×‘ 9 ×• 99 ×¡× ×˜',0),(499413,13873,'el','Î Î»Î·ÏƒÎ¹Î­ÏƒÏ„ÎµÏÎ¿ 9 ÎºÎ±Î¹ 99 ÏƒÎµÎ½Ï„',0),(499414,13873,'zh','æœ€è¿‘ 9 ç¾Žåˆ†åˆ° 99 ç¾Žåˆ†',0),(499415,13873,'sv','NÃ¤rmaste 9 och 99 cent',0),(499416,13873,'it','PiÃ¹ vicino a 9 e 99 centesimi',0),(499417,13873,'tl','',0),(499418,13873,'th','à¹ƒà¸à¸¥à¹‰à¹€à¸‹à¸™à¸•à¹Œ 99 à¹à¸¥à¸° 9',0),(499419,13873,'hi','9 à¤”à¤° 99 à¤¸à¥‡à¤‚à¤Ÿ à¤¨à¤¿à¤•à¤Ÿà¤¤à¤®',0),(499420,13873,'ms','Terdekat 9 dan 99 sen',0),(499421,13873,'ar','Ø£Ù‚Ø±Ø¨ 9 Ùˆ 99 Ø³Ù†ØªØ§',0),(499422,13873,'fr','Le plus proche de 9 Ã  99 Cents',0),(499423,13873,'jp','æœ€å¯„ã‚Šã® 9 ã¨ 99 ã‚»ãƒ³ãƒˆ',0),(499424,13873,'pt','Mais prÃ³ximo de 9 e 99 centavos',0),(499425,13873,'ru','Ð‘Ð»Ð¸Ð¶Ð°Ð¹ÑˆÐ°Ñ 9 Ð¸ 99 Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(499426,13873,'es','MÃ¡s cercano a 9 y 99 centavos',0),(499427,13873,'de','NÃ¤chste 9 und 99 Cent',0),(499428,13873,'en','Nearest 9 and 99 Cents',0),(499429,13874,'is','',0),(499430,13874,'dr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† ÙˆØ§Ø­Ø¯ Ù¾ÙˆÙ„ Ú©Ù„ 9',0),(499431,13874,'pr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† ÙˆØ§Ø­Ø¯ Ù¾ÙˆÙ„ Ú©Ù„ 9',0),(499432,13874,'tr','En yakÄ±n 9 tÃ¼m para birimi',0),(499433,13874,'pl','NajbliÅ¼szy 9 jednostki waluty caÅ‚ego',0),(499434,13874,'bg','ÐÐ°Ð¹-Ð±Ð»Ð¸Ð·ÐºÐ°Ñ‚Ð° 9 Ñ†ÑÐ»Ð°Ñ‚Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(499435,13874,'ur','Ù‚Ø±ÛŒØ¨ÛŒ Ù¾ÙˆØ±Û’ Ú©Ø±Ù†Ø³ÛŒ Ø§Ú©Ø§Ø¦ÛŒ Ù…ÛŒÚº 9',0),(499436,13874,'sr','ÐÐ°Ñ˜Ð±Ð»Ð¸Ð¶Ð¸ 9 Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ð·Ð° ÑÐ²Ðµ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(499437,13874,'vi','Gáº§n nháº¥t 9 Ä‘Æ¡n vá»‹ tiá»n tá»‡ toÃ n bá»™',0),(499438,13874,'af','Naaste 9 hele geldeenheid eenheid',0),(499439,13874,'ro','Cel mai apropiat 9 moneda Ã®ntreg',0),(499440,13874,'et','LÃ¤him 9 kogu rahaÃ¼hik',0),(499441,13874,'si','NajbliÅ¾je 9 celotno valutno enoto',0),(499442,13874,'ba','Terdekat 9 Unit mata uang seluruh',0),(499443,13874,'nl','Dichtstbijzijnde 9 hele valuta eenheid',0),(499444,13874,'fi','LÃ¤hin 9 koko rahayksikkÃ¶',0),(499445,13874,'no','NÃ¦rmeste 9 hele valutaenhet',0),(499446,13874,'da','NÃ¦rmeste 9 hele valutaenhed',0),(499447,13874,'ko','9 ì „ì²´ í†µí™” ë‹¨ìœ„ì— ê°€ìž¥ ê°€ê¹Œìš´',0),(499448,13874,'he','×”×§×¨×•×‘ ×™×—×™×“×ª ×ž×˜×‘×¢ ×›×œ 9',0),(499449,13874,'el','Î Î»Î·ÏƒÎ¹Î­ÏƒÏ„ÎµÏÎ¿ 9 Î¿Î»ÏŒÎºÎ»Î·ÏÎ¿ Î½Î¿Î¼Î¹ÏƒÎ¼Î±Ï„Î¹ÎºÎ® Î¼Î¿Î½Î¬Î´Î±',0),(499450,13874,'zh','æœ€è¿‘ 9 æ•´ä¸ªè´§å¸å•ä½',0),(499451,13874,'sv','NÃ¤rmaste 9 hela valutaenheten',0),(499452,13874,'it','PiÃ¹ vicino a 9 unitÃ  monetaria intera',0),(499453,13874,'tl','',0),(499454,13874,'th','à¹ƒà¸à¸¥à¹‰à¸«à¸™à¹ˆà¸§à¸¢à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸” 9',0),(499455,13874,'hi','9 à¤ªà¥‚à¤°à¥‡ à¤®à¥à¤¦à¥à¤°à¤¾ à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¿à¤•à¤Ÿà¤¤à¤®',0),(499456,13874,'ms','Terdekat 9 Unit matawang seluruh',0),(499457,13874,'ar','Ø£Ù‚Ø±Ø¨ ÙˆØ­Ø¯Ø© Ø§Ù„Ø¹Ù…Ù„Ø© ÙƒÙ„Ù‡ 9',0),(499458,13874,'fr','9 unitÃ© de devise entiÃ¨re la plus proche',0),(499459,13874,'jp','æœ€å¯„ã‚Šã® 9 ã®å…¨ä½“ã®é€šè²¨å˜ä½',0),(499460,13874,'pt','Mais prÃ³ximo da unidade de moeda toda 9',0),(499461,13874,'ru','Ð‘Ð»Ð¸Ð¶Ð°Ð¹ÑˆÐ°Ñ 9 Ð²ÑÑ Ð´ÐµÐ½ÐµÐ¶Ð½Ð°Ñ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(499462,13874,'es','MÃ¡s cercano a 9 unidad monetaria todo',0),(499463,13874,'de','NÃ¤chste 9 ganze WÃ¤hrungseinheit',0),(499464,13874,'en','Nearest 9 Whole Currency Unit',0),(499465,13875,'is','',0),(499466,13875,'dr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† ÙˆØ§Ø­Ø¯ Ù¾ÙˆÙ„ Ú©Ù„',0),(499467,13875,'pr','Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† ÙˆØ§Ø­Ø¯ Ù¾ÙˆÙ„ Ú©Ù„',0),(499468,13875,'tr','En yakÄ±n tÃ¼m para birimi',0),(499469,13875,'pl','NajbliÅ¼sza jednostka waluty caÅ‚ego',0),(499470,13875,'bg','ÐÐ°Ð¹-Ð±Ð»Ð¸Ð·ÐºÐ°Ñ‚Ð° Ñ†ÑÐ»Ð° Ð²Ð°Ð»ÑƒÑ‚Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(499471,13875,'ur','Ù¾ÙˆØ±Û’ Ú©Ø±Ù†Ø³ÛŒ Ø§Ú©Ø§Ø¦ÛŒ Ù…ÛŒÚº Ù‚Ø±ÛŒØ¨ÛŒ',0),(499472,13875,'sr','ÐÐ°Ñ˜Ð±Ð»Ð¸Ð¶Ð¸ Ñ†ÐµÐ¾ Ð²Ð°Ð»ÑƒÑ‚Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(499473,13875,'vi','Gáº§n nháº¥t Ä‘Æ¡n vá»‹ tiá»n tá»‡ toÃ n bá»™',0),(499474,13875,'af','Naaste hele geldeenheid eenheid',0),(499475,13875,'ro','Cel mai apropiat Ã®ntreg moneda',0),(499476,13875,'et','LÃ¤him kogu rahaÃ¼hik',0),(499477,13875,'si','NajbliÅ¾ja cela valutno enoto',0),(499478,13875,'ba','Terdekat Unit seluruh mata uang',0),(499479,13875,'nl','Dichtstbijzijnde hele valuta eenheid',0),(499480,13875,'fi','LÃ¤hin koko rahayksikkÃ¶',0),(499481,13875,'no','NÃ¦rmeste hele valutaenhet',0),(499482,13875,'da','NÃ¦rmeste hele valutaenhed',0),(499483,13875,'ko','ì „ì²´ í†µí™” ë‹¨ìœ„ì— ê°€ìž¥ ê°€ê¹Œìš´',0),(499484,13875,'he','×”×§×¨×•×‘ ×™×—×™×“×ª ×ž×˜×‘×¢ ×©×œ×',0),(499485,13875,'el','Î Î»Î·ÏƒÎ¹Î­ÏƒÏ„ÎµÏÎ¿ Î¿Î»ÏŒÎºÎ»Î·ÏÎ¿ Î½Î¿Î¼Î¹ÏƒÎ¼Î±Ï„Î¹ÎºÎ® Î¼Î¿Î½Î¬Î´Î±',0),(499486,13875,'zh','æœ€è¿‘æ•´ä¸ªè´§å¸å•ä½',0),(499487,13875,'sv','NÃ¤rmaste hela valutaenheten',0),(499488,13875,'it','PiÃ¹ vicina unitÃ  monetaria intera',0),(499489,13875,'tl','',0),(499490,13875,'th','à¹ƒà¸à¸¥à¹‰à¸«à¸™à¹ˆà¸§à¸¢à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(499491,13875,'hi','à¤¨à¤¿à¤•à¤Ÿà¤¤à¤® à¤ªà¥‚à¤°à¥‡ à¤®à¥à¤¦à¥à¤°à¤¾ à¤‡à¤•à¤¾à¤ˆ',0),(499492,13875,'ms','Hampir keseluruhan Mata Wang Unit',0),(499493,13875,'ar','Ø£Ù‚Ø±Ø¨ ÙˆØ­Ø¯Ø© Ø§Ù„Ø¹Ù…Ù„Ø© ÙƒÙ„Ù‡',0),(499494,13875,'fr','UnitÃ© monÃ©taire entiÃ¨re la plus proche',0),(499495,13875,'jp','æœ€å¯„ã‚Šã®å…¨ä½“ã®é€šè²¨å˜ä½',0),(499496,13875,'pt','Mais prÃ³ximo da unidade monetÃ¡ria de toda',0),(499497,13875,'ru','Ð‘Ð»Ð¸Ð¶Ð°Ð¹ÑˆÐ°Ñ Ð²ÑÑ Ð´ÐµÐ½ÐµÐ¶Ð½Ð°Ñ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(499498,13875,'es','MÃ¡s cercana de la unidad monetaria todo',0),(499499,13875,'de','NÃ¤chstgrÃ¶ÃŸere ganze WÃ¤hrungseinheit',0),(499500,13875,'en','Nearest Whole Currency Unit',0),(499501,13876,'is','',0),(499502,13876,'dr','Ù‚ÛŒÙ…Øª Ø¯ÙˆØ± ØªØ§',0),(499503,13876,'pr','Ù‚ÛŒÙ…Øª Ø¯ÙˆØ± ØªØ§',0),(499504,13876,'tr','Tur fiyatÄ±',0),(499505,13876,'pl','Rundy cena do',0),(499506,13876,'bg','ÐšÑ€ÑŠÐ³Ð»Ð° Ñ†ÐµÐ½Ð° Ð´Ð¾',0),(499507,13876,'ur','Ø§Ù¾ Ú©Û’ Ù„Ø¦Û’ Ú†Ø§Ø±ÙˆÚº Ø·Ø±Ù Ù‚ÛŒÙ…Øª',0),(499508,13876,'sr','ÐžÐºÑ€ÑƒÐ³Ð»Ð° Ñ†ÐµÐ½Ð° Ð´Ð° Ð±Ð¸ ÑÐµ',0),(499509,13876,'vi','VÃ²ng giÃ¡ tá»‘i Ä‘a',0),(499510,13876,'af','Ronde prys tot',0),(499511,13876,'ro','PreÅ£ul rundÄƒ pÃ¢nÄƒ la',0),(499512,13876,'et','Vooru hind kuni',0),(499513,13876,'si','Okrogle cene do',0),(499514,13876,'ba','Harga bulat hingga',0),(499515,13876,'nl','Ronde prijs tot',0),(499516,13876,'fi','Kierroksen hinta',0),(499517,13876,'no','Runde prisen til',0),(499518,13876,'da','Runde prisen op til',0),(499519,13876,'ko','ìµœëŒ€ ë¼ìš´ë“œ ê°€ê²©',0),(499520,13876,'he','×ž×—×™×¨ ×¢×’×•×œ ×¢×“',0),(499521,13876,'el','Î“ÏÏÎ¿ Ï„Î¹Î¼Î® Î¼Î­Ï‡ÏÎ¹',0),(499522,13876,'zh','åœ†ä»·æ ¼',0),(499523,13876,'sv','Runda pris upp till',0),(499524,13876,'it','Prezzo tondo fino al',0),(499525,13876,'tl','',0),(499526,13876,'th','à¸£à¸²à¸„à¸²à¸£à¸­à¸šà¸‚à¸¶à¹‰à¸™',0),(499527,13876,'hi','à¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥‹à¤² à¤®à¥‚à¤²à¥à¤¯',0),(499528,13876,'ms','Pusingan harga sehingga',0),(499529,13876,'ar','Ø³Ø¹Ø± Ø§Ù„Ø¬ÙˆÙ„Ø© ØªØµÙ„ Ø¥Ù„Ù‰',0),(499530,13876,'fr','Prix rond jusqu\'au',0),(499531,13876,'jp','ãƒ©ã‚¦ãƒ³ãƒ‰ä¾¡æ ¼',0),(499532,13876,'pt','PreÃ§o redondo para',0),(499533,13876,'ru','ÐšÑ€ÑƒÐ³Ð»Ð°Ñ Ð¦ÐµÐ½Ð° Ð´Ð¾',0),(499534,13876,'es','Precio ronda hasta',0),(499535,13876,'de','Runde Preis bis zu',0),(499536,13876,'en','Round Price Up To',0),(499537,13877,'is','',0),(499538,13877,'dr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ',0),(499539,13877,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ',0),(499540,13877,'tr','Ek notlar',0),(499541,13877,'pl','Uwagi dodatkowe',0),(499542,13877,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(499543,13877,'ur','Ø§Ø¶Ø§ÙÛŒ Ù†ÙˆÙ¹',0),(499544,13877,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(499545,13877,'vi','ThÃªm ghi chÃº',0),(499546,13877,'af','Addisionele Notas',0),(499547,13877,'ro','Note suplimentare',0),(499548,13877,'et','TÃ¤iendavad mÃ¤rkused',0),(499549,13877,'si','Dodatne opombe',0),(499550,13877,'ba','Catatan tambahan',0),(499551,13877,'nl','Aanvullende opmerkingen',0),(499552,13877,'fi','Additional Notes',0),(499553,13877,'no','Flere merknader',0),(499554,13877,'da','Supplerende noter',0),(499555,13877,'ko','ì¶”ê°€ ì°¸ê³  ì‚¬í•­',0),(499556,13877,'he','×”×¢×¨×•×ª × ×•×¡×¤×•×ª',0),(499557,13877,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏ‰Î¼Î±Ï„Î¹ÎºÎ­Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(499558,13877,'zh','é™„åŠ æ³¨é‡Š',0),(499559,13877,'sv','Ytterligare anmÃ¤rkningar',0),(499560,13877,'it','Note aggiuntive',0),(499561,13877,'tl','',0),(499562,13877,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(499563,13877,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(499564,13877,'ms','Nota-Nota tambahan',0),(499565,13877,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ©',0),(499566,13877,'fr','Notes complÃ©mentaires',0),(499567,13877,'jp','è¿½åŠ ã®æ³¨æ„äº‹é …',0),(499568,13877,'pt','Notas adicionais',0),(499569,13877,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(499570,13877,'es','Notas Adicionales',0),(499571,13877,'de','ZusÃ¤tzliche Hinweise',0),(499572,13877,'en','Additional Notes',0),(499573,13878,'is','',0),(499574,13878,'dr','ÙˆÛŒØ±Ø§Ø³Øª ASN Ø§Ø±Ø³Ø§Ù„',0),(499575,13878,'pr','ÙˆÛŒØ±Ø§Ø³Øª ASN Ø§Ø±Ø³Ø§Ù„',0),(499576,13878,'tr','EDI Ã–SB gÃ¶nder',0),(499577,13878,'pl','WyÅ›lij WPW EDI',0),(499578,13878,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ EDI ASN',0),(499579,13878,'ur','Ø§ÛŒØ¯Ø§ Ø§Ø³Ù† Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(499580,13878,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð•Ð”Ð˜ ÐÐ¡Ð',0),(499581,13878,'vi','Gá»­i EDI ASN',0),(499582,13878,'af','Stuur EDI ASN',0),(499583,13878,'ro','Trimite EDI ASN',0),(499584,13878,'et','Saada EDI ASN',0),(499585,13878,'si','PoÅ¡lji EDI ASN',0),(499586,13878,'ba','Kirim EDI ASN',0),(499587,13878,'nl','EDI ASN verzenden',0),(499588,13878,'fi','LÃ¤hetÃ¤ LÃ¤hetysilmoitus EDI',0),(499589,13878,'no','Sende EDI ASN',0),(499590,13878,'da','Sende EDI ASN',0),(499591,13878,'ko','EDI ASN ë³´ë‚´ê¸°',0),(499592,13878,'he','×©×œ×— EDI ASN',0),(499593,13878,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ EDI ASN',0),(499594,13878,'zh','å‘é€ EDI ASN',0),(499595,13878,'sv','Skicka EDI ASN',0),(499596,13878,'it','Invia EDI ASN',0),(499597,13878,'tl','',0),(499598,13878,'th','à¸ªà¹ˆà¸‡ EDI ASN',0),(499599,13878,'hi','EDI ASN à¤­à¥‡à¤œà¥‡à¤‚',0),(499600,13878,'ms','Menghantar EDI ASN',0),(499601,13878,'ar','Ø¥Ø±Ø³Ø§Ù„ ASN Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(499602,13878,'fr','Envoyer EDI ASN',0),(499603,13878,'jp','é€ä¿¡ EDI ASN',0),(499604,13878,'pt','Enviar EDI ASN',0),(499605,13878,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ EDI ASN',0),(499606,13878,'es','Enviar EDI ASN',0),(499607,13878,'de','Senden von EDI-ASN',0),(499608,13878,'en','Send EDI ASN',0),(499609,13879,'is','',0),(499610,13879,'dr','Ø§Ø±Ø³Ø§Ù„ Ù¾ÛŒØ´ ÙØ§Ú©ØªÙˆØ± ÙˆÛŒØ±Ø§Ø³Øª',0),(499611,13879,'pr','Ø§Ø±Ø³Ø§Ù„ Ù¾ÛŒØ´ ÙØ§Ú©ØªÙˆØ± ÙˆÛŒØ±Ø§Ø³Øª',0),(499612,13879,'tr','EDI faturasÄ± gÃ¶nder',0),(499613,13879,'pl','WyÅ›lij fakturÄ™ EDI',0),(499614,13879,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ EDI Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(499615,13879,'ur','Ø§ÛŒØ¯Ø§ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(499616,13879,'sr','ÐŸÐ¾ÑÐ»Ð°Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð•Ð”Ð˜ÐˆÐ',0),(499617,13879,'vi','Gá»­i hoÃ¡ Ä‘Æ¡n EDI',0),(499618,13879,'af','EDI faktuur stuur',0),(499619,13879,'ro','Trimite factura EDI',0),(499620,13879,'et','EDI arve',0),(499621,13879,'si','Izstavite raÄun EDI',0),(499622,13879,'ba','Mengirim faktur EDI',0),(499623,13879,'nl','EDI-factuur sturen',0),(499624,13879,'fi','LÃ¤hettÃ¤Ã¤ EDI laskun',0),(499625,13879,'no','Sende EDI faktura',0),(499626,13879,'da','Sende EDI faktura',0),(499627,13879,'ko','EDI ì²­êµ¬ì„œ ë³´ë‚¼',0),(499628,13879,'he','×©×œ×— EDI ×—×©×‘×•× ×™×ª',0),(499629,13879,'el','Î‘Ï€Î¿ÏƒÏ„ÎµÎ¯Î»ÎµÏ„Îµ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ EDI',0),(499630,13879,'zh','å‘é€ EDI å‘ç¥¨',0),(499631,13879,'sv','Skicka EDI-faktura',0),(499632,13879,'it','Inviare la fattura EDI',0),(499633,13879,'tl','',0),(499634,13879,'th','à¸ªà¹ˆà¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸‚à¸­à¸‡ EDI',0),(499635,13879,'hi','EDI à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥‡à¤œà¤¨à¥‡',0),(499636,13879,'ms','Inbois import',0),(499637,13879,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„ØªØ¨Ø§Ø¯Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(499638,13879,'fr','Envoyer la facture EDI',0),(499639,13879,'jp','EDI ã®è«‹æ±‚æ›¸ã‚’é€ä»˜ã—ã¾ã™ã€‚',0),(499640,13879,'pt','Enviar a factura EDI',0),(499641,13879,'ru','Ð˜Ð½Ð²Ð¾Ð¹Ñ Ð­ÐžÐ”',0),(499642,13879,'es','Enviar factura EDI',0),(499643,13879,'de','Senden von EDI-Rechnung',0),(499644,13879,'en','Send EDI Invoice',0),(499645,13880,'is','',0),(499646,13880,'dr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø¨Ø±Ø±Ø³ÛŒ.',0),(499647,13880,'pr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø¨Ø±Ø±Ø³ÛŒ.',0),(499648,13880,'tr','Ankete eriÅŸmek iÃ§in burayÄ± tÄ±klatÄ±n.',0),(499649,13880,'pl','Kliknij tutaj, aby uzyskaÄ‡ dostÄ™p do ankiety.',0),(499650,13880,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ð²Ð°ÑˆÐ¸Ñ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½ÐµÑ‚Ð¾.',0),(499651,13880,'ur','Ø§Ù¾Ù†Û’ Ø³Ø±ÙˆÛ’ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº Û”',0),(499652,13880,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð¸Ð»Ð¸ Ñ‚Ð²Ð¾Ñ˜Ðµ Ð¸ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ.',0),(499653,13880,'vi','Click vÃ o Ä‘Ã¢y Ä‘á»ƒ truy cáº­p vÃ o kháº£o sÃ¡t cá»§a báº¡n.',0),(499654,13880,'af','Klik hier vir toegang tot jou opname.',0),(499655,13880,'ro','Click aici pentru a accesa sondaj dumneavoastrÄƒ.',0),(499656,13880,'et','Kliki siia access teie uuring.',0),(499657,13880,'si','Kliknite tukaj za dostop do ankete.',0),(499658,13880,'ba','Klik di sini untuk mengakses survei Anda.',0),(499659,13880,'nl','Klik hier voor toegang tot uw enquÃªte.',0),(499660,13880,'fi','Klikkaa tÃ¤stÃ¤ pÃ¤Ã¤stÃ¤ksesi kyselyn.',0),(499661,13880,'no','Klikk her for Ã¥ fÃ¥ tilgang til undersÃ¸kelsen.',0),(499662,13880,'da','Klik her for at fÃ¥ adgang til din undersÃ¸gelse.',0),(499663,13880,'ko','ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤ ì„¤ë¬¸ ì¡°ì‚¬ì— ì•¡ì„¸ìŠ¤í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(499664,13880,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×’×©×ª ×”×¡×§×¨ ×©×œ×š.',0),(499665,13880,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î±Ï€Î¿ÎºÏ„Î®ÏƒÎµÏ„Îµ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎ±Ï‚ Î­ÏÎµÏ…Î½Î±.',0),(499666,13880,'zh','å•å‡»æ­¤å¤„è®¿é—®æ‚¨çš„è°ƒæŸ¥ã€‚',0),(499667,13880,'sv','Klicka hÃ¤r fÃ¶r att komma Ã¥t din undersÃ¶kning.',0),(499668,13880,'it','Clicca qui per accedere la tua indagine.',0),(499669,13880,'tl','',0),(499670,13880,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¹à¸šà¸šà¸ªà¸³à¸£à¸§à¸ˆà¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(499671,13880,'hi','à¤…à¤ªà¤¨à¥‡ à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚à¥¤',0),(499672,13880,'ms','Klik di sini untuk kaji selidik anda.',0),(499673,13880,'ar','Ø§Ù†Ù‚Ø± Ù‡Ù†Ø§ Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ø¯Ø±Ø§Ø³Ø© Ø§Ù„Ø§Ø³ØªÙ‚ØµØ§Ø¦ÙŠØ© Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(499674,13880,'fr','Cliquez ici pour accÃ©der Ã  votre enquÃªte.',0),(499675,13880,'jp','ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¦ã€ã‚¢ãƒ³ã‚±ãƒ¼ãƒˆã«ã‚¢ã‚¯ã‚»ã‚¹ã—ã¾ã™ã€‚',0),(499676,13880,'pt','Clique aqui para acessar o questionÃ¡rio.',0),(499677,13880,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ Ð´Ð»Ñ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ðº Ð²Ð°ÑˆÐµÐ³Ð¾ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ñ.',0),(499678,13880,'es','Haga clic aquÃ­ para acceder a la encuesta.',0),(499679,13880,'de','Klicken Sie hier fÃ¼r Ihre Umfrage.',0),(499680,13880,'en','Click here to access your survey.',0),(499681,13881,'is','',0),(499682,13881,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ú©Ø§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª.',0),(499683,13881,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ú©Ø§Ù…Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª.',0),(499684,13881,'tr','Bir anket tamamlandÄ±.',0),(499685,13881,'pl','Badanie zostaÅ‚o zakoÅ„czone.',0),(499686,13881,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½ÐµÑ‚Ð¾ Ðµ Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸Ð»Ð¾.',0),(499687,13881,'ur','Ø§ÛŒÚ© Ø³Ø±ÙˆÛ’ Ù…Ú©Ù…Ù„ Ú©Ø± Ù„ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Û”',0),(499688,13881,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾.',0),(499689,13881,'vi','Má»™t cuá»™c kháº£o sÃ¡t Ä‘Ã£ Ä‘Æ°á»£c hoÃ n thÃ nh.',0),(499690,13881,'af','\'N opname afgehandel is.',0),(499691,13881,'ro','Un sondaj a fost finalizat.',0),(499692,13881,'et','Ãœlevaatus on lÃµpule viidud.',0),(499693,13881,'si','Raziskava je bila dokonÄana.',0),(499694,13881,'ba','Survei telah selesai.',0),(499695,13881,'nl','Een enquÃªte is voltooid.',0),(499696,13881,'fi','Tutkimus on saatu pÃ¤Ã¤tÃ¶kseen.',0),(499697,13881,'no','En undersÃ¸kelse er fullfÃ¸rt.',0),(499698,13881,'da','En undersÃ¸gelse er afsluttet.',0),(499699,13881,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ì™„ë£Œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(499700,13881,'he','×¡×§×¨ ×”×•×©×œ×ž×”.',0),(499701,13881,'el','ÎœÎ¹Î± Î­ÏÎµÏ…Î½Î± Î­Ï‡ÎµÎ¹ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯.',0),(499702,13881,'zh','å·²å®Œæˆè°ƒæŸ¥ã€‚',0),(499703,13881,'sv','En undersÃ¶kning har genomfÃ¶rts.',0),(499704,13881,'it','Un\'indagine Ã¨ stata completata.',0),(499705,13881,'tl','',0),(499706,13881,'th','à¸à¸²à¸£à¸ªà¸³à¸£à¸§à¸ˆà¹„à¸”à¹‰à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(499707,13881,'hi','à¤à¤• à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤ªà¥‚à¤°à¤¾ à¤¹à¥‹ à¤šà¥à¤•à¤¾ à¤¹à¥ˆà¥¤',0),(499708,13881,'ms','Kaji selidik yang telah siap.',0),(499709,13881,'ar','ÙˆÙ‚Ø¯ Ø§ÙƒØªÙ…Ù„ Ù…Ø³Ø­.',0),(499710,13881,'fr','Une enquÃªte a Ã©tÃ© achevÃ©e.',0),(499711,13881,'jp','èª¿æŸ»ãŒå®Œäº†ã—ã¾ã—ãŸã€‚',0),(499712,13881,'pt','Uma pesquisa foi concluÃ­da.',0),(499713,13881,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ð¾ Ð¾Ð±ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ð½Ð¸Ðµ.',0),(499714,13881,'es','Una encuesta se ha completado.',0),(499715,13881,'de','Eine Umfrage ist abgeschlossen.',0),(499716,13881,'en','A survey has been completed.',0),(499717,13882,'is','',0),(499718,13882,'dr','Ù…Ø±Ø§Ø­Ù„ Ú©Ø§Ø± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(499719,13882,'pr','Ù…Ø±Ø§Ø­Ù„ Ú©Ø§Ø± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(499720,13882,'tr','Ä°ÅŸ adÄ±mlarÄ± girin',0),(499721,13882,'pl','WprowadÅº kroki pracy',0),(499722,13882,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ ÑÑ‚ÑŠÐ¿ÐºÐ¸',0),(499723,13882,'ur','Ú©Ø§Ù… Ú©Û’ Ù…Ø±Ø§Ø­Ù„ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(499724,13882,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÐºÐ¾Ñ€Ð°ÐºÐµ Ð·Ð° Ñ€Ð°Ð´',0),(499725,13882,'vi','ThÃªm cÃ´ng viá»‡c bÆ°á»›c',0),(499726,13882,'af','Tik werk stappe',0),(499727,13882,'ro','IntroduceÅ£i paÅŸii de lucru',0),(499728,13882,'et','Sisestage tÃ¶Ã¶etappide',0),(499729,13882,'si','Vnesite korake dela',0),(499730,13882,'ba','Masukkan langkah kerja',0),(499731,13882,'nl','Geef werk stappen',0),(499732,13882,'fi','MÃ¤Ã¤rittÃ¤Ã¤ tyÃ¶n vaiheet',0),(499733,13882,'no','Angi arbeidstrinn',0),(499734,13882,'da','Angiv arbejde trin',0),(499735,13882,'ko','ìž‘ì—… ë‹¨ê³„ë¥¼ ìž…ë ¥',0),(499736,13882,'he','×”×–×Ÿ ××ª ×©×œ×‘×™ ×”×¢×‘×•×“×”',0),(499737,13882,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Î²Î®Î¼Î±Ï„Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(499738,13882,'zh','è¾“å…¥å·¥ä½œæ­¥éª¤',0),(499739,13882,'sv','Ange arbete steg',0),(499740,13882,'it','Inserisci lavoro passi',0),(499741,13882,'tl','',0),(499742,13882,'th','à¹ƒà¸ªà¹ˆà¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™',0),(499743,13882,'hi','à¤•à¤¾à¤® à¤•à¥‡ à¤šà¤°à¤£à¥‹à¤‚ à¤•à¥‹ à¤¦à¤°à¥à¤œ',0),(499744,13882,'ms','Masukkan langkah-langkah kerja',0),(499745,13882,'ar','Ø£Ø¯Ø®Ù„ Ø®Ø·ÙˆØ§Øª Ø§Ù„Ø¹Ù…Ù„',0),(499746,13882,'fr','Entrez les Ã©tapes de travail',0),(499747,13882,'jp','ä½œæ¥­æ‰‹é †ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(499748,13882,'pt','Insira as etapas de trabalho',0),(499749,13882,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑˆÐ°Ð³Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(499750,13882,'es','Entrar en pasos de trabajo',0),(499751,13882,'de','Geben Sie die Arbeitsschritte',0),(499752,13882,'en','Enter Work Steps',0),(499753,13883,'is','',0),(499754,13883,'dr','ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´',0),(499755,13883,'pr','ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´',0),(499756,13883,'tr','OK sipariÅŸler',0),(499757,13883,'pl','OK zamÃ³wienia',0),(499758,13883,'bg','ÐžÐš Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(499759,13883,'ur','Ù¹Ú¾ÛŒÚ© ÛÛ’ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(499760,13883,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(499761,13883,'vi','OK cÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(499762,13883,'af','OK bestellings',0),(499763,13883,'ro','OK comenzile',0),(499764,13883,'et','OK tellimused',0),(499765,13883,'si','OK naroÄila',0),(499766,13883,'ba','OK pesanan',0),(499767,13883,'nl','OK Orders',0),(499768,13883,'fi','OK tilaukset',0),(499769,13883,'no','OK ordrer',0),(499770,13883,'da','OK ordrer',0),(499771,13883,'ko','í™•ì¸ ìˆœì„œ',0),(499772,13883,'he','×”×–×ž× ×•×ª ×‘×¡×“×¨',0),(499773,13883,'el','Î•Î½Ï„Î¬Î¾ÎµÎ¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(499774,13883,'zh','ç¡®å®šè®¢å•',0),(499775,13883,'sv','OK order',0),(499776,13883,'it','Ordini OK',0),(499777,13883,'tl','',0),(499778,13883,'th','à¸•à¸à¸¥à¸‡à¸ªà¸±à¹ˆà¸‡',0),(499779,13883,'hi','à¤ à¥€à¤• à¤†à¤¦à¥‡à¤¶',0),(499780,13883,'ms','Perintah-perintah OK',0),(499781,13883,'ar','Ø£ÙˆØ§Ù…Ø± Ù…ÙˆØ§ÙÙ‚',0),(499782,13883,'fr','Commandes OK',0),(499783,13883,'jp','[Ok] ã‚’æ³¨æ–‡',0),(499784,13883,'pt','Ordens OK',0),(499785,13883,'ru','ÐžÐš Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(499786,13883,'es','Aceptables Ã³rdenes',0),(499787,13883,'de','OK Bestellungen',0),(499788,13883,'en','OK Orders',0),(499789,13884,'is','',0),(499790,13884,'dr','Ø¢Ø²Ø§Ø¯ÛŒ Ø¨Ù‡ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª',0),(499791,13884,'pr','Ø¢Ø²Ø§Ø¯ÛŒ Ø¨Ù‡ Ù…Ø·Ø¨ÙˆØ¹Ø§Øª',0),(499792,13884,'tr','BasÄ±n yayÄ±n',0),(499793,13884,'pl','Dopuszczenia do prasy',0),(499794,13884,'bg','Ð¡ÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð·Ð° Ð¿Ñ€ÐµÑÐ°Ñ‚Ð°',0),(499795,13884,'ur','Ù¾Ø±ÛŒØ³ Ø±ÛŒÙ„ÛŒØ²',0),(499796,13884,'sr','ÐŸÑƒÑˆÑ‚Ð°ÑšÐµ Ð½Ð¾Ð²Ð¸Ð½Ð°Ñ€Ð¸Ð¼Ð°',0),(499797,13884,'vi','PhÃ¡t hÃ nh cho bÃ¡o chÃ­',0),(499798,13884,'af','Vrylating te druk',0),(499799,13884,'ro','Comunicat presa',0),(499800,13884,'et','Release Press',0),(499801,13884,'si','Pritisnite za javnost',0),(499802,13884,'ba','Rilis pers',0),(499803,13884,'nl','Vrij te geven aan de pers',0),(499804,13884,'fi','Release Press',0),(499805,13884,'no','Utgivelsen pressen',0),(499806,13884,'da','Frigivelse til pressen',0),(499807,13884,'ko','í”„ë ˆìŠ¤ ë¦´ë¦¬ìŠ¤',0),(499808,13884,'he','×©×—×¨×•×¨ ×œ×¢×™×ª×•× ×•×ª',0),(499809,13884,'el','Î‘Ï€ÎµÎ»ÎµÏ…Î¸Î­ÏÏ‰ÏƒÎ· Ï„ÏÏ€Î¿',0),(499810,13884,'zh','æ–°é—»å‘å¸ƒ',0),(499811,13884,'sv','Ã–vergÃ¥ng till pressen',0),(499812,13884,'it','Comunicato stampa',0),(499813,13884,'tl','',0),(499814,13884,'th','à¸›à¸¥à¹ˆà¸­à¸¢à¹ƒà¸«à¹‰à¸à¸”',0),(499815,13884,'hi','à¤ªà¥à¤°à¥‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¤¿à¤²à¥€à¤œ',0),(499816,13884,'ms','Keluaran kepada akhbar',0),(499817,13884,'ar','Ø¨ÙŠØ§Ù† Ù„Ù„ØµØ­Ø§ÙØ©',0),(499818,13884,'fr','CommuniquÃ© de presse',0),(499819,13884,'jp','ãƒ—ãƒ¬ã‚¹ ãƒªãƒªãƒ¼ã‚¹',0),(499820,13884,'pt','Comunicado de imprensa',0),(499821,13884,'ru','ÐŸÑ€ÐµÑÑ-Ñ€ÐµÐ»Ð¸Ð·',0),(499822,13884,'es','Comunicado de prensa',0),(499823,13884,'de','Press Release',0),(499824,13884,'en','Release To Press',0),(499825,13885,'is','',0),(499826,13885,'dr','ØªÙ†Ø¸ÛŒÙ… Ù…Ø±Ø§Ø­Ù„ Ú©Ø§Ø±',0),(499827,13885,'pr','ØªÙ†Ø¸ÛŒÙ… Ù…Ø±Ø§Ø­Ù„ Ú©Ø§Ø±',0),(499828,13885,'tr','Ä°ÅŸ adÄ±mlarÄ± ayarla',0),(499829,13885,'pl','Zestaw do pracy kroki',0),(499830,13885,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ ÑÑ‚ÑŠÐ¿ÐºÐ¸',0),(499831,13885,'ur','Ú©Ø§Ù… Ú©Û’ Ù…Ø±Ø§Ø­Ù„ Ø§Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(499832,13885,'sr','ÐŸÐ¾Ð´ÐµÑÐ¸Ñ‚Ð¸ Ñ€Ð°Ð´ ÐºÐ¾Ñ€Ð°ÐºÐµ',0),(499833,13885,'vi','Thiáº¿t láº­p cÃ´ng viá»‡c bÆ°á»›c',0),(499834,13885,'af','Stel werk stappe',0),(499835,13885,'ro','ÃŽnfiinÅ£at de paÅŸi de lucru',0),(499836,13885,'et','Saate seadistada tÃ¶Ã¶etappide',0),(499837,13885,'si','Nastavite dela korake',0),(499838,13885,'ba','Mengatur langkah kerja',0),(499839,13885,'nl','Werk stappen instellen',0),(499840,13885,'fi','MÃ¤Ã¤ritÃ¤ tyÃ¶vaiheet',0),(499841,13885,'no','Definere arbeidstrinn',0),(499842,13885,'da','Oprette arbejde trin',0),(499843,13885,'ko','ìž‘ì—… ë‹¨ê³„ë¥¼ ì„¤ì •',0),(499844,13885,'he','×œ×”×’×“×™×¨ ××ª ×©×œ×‘×™ ×”×¢×‘×•×“×”',0),(499845,13885,'el','ÎˆÏ‡ÎµÎ¹ ÏƒÏ…ÏƒÏ„Î±Î¸ÎµÎ¯ Î²Î®Î¼Î±Ï„Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(499846,13885,'zh','è®¾ç½®å·¥ä½œæ­¥éª¤',0),(499847,13885,'sv','StÃ¤ll in arbete steg',0),(499848,13885,'it','Impostare le fasi di lavoro',0),(499849,13885,'tl','',0),(499850,13885,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™',0),(499851,13885,'hi','à¤¸à¥‡à¤Ÿ à¤…à¤ª à¤•à¤¾à¤® à¤•à¤¦à¤®',0),(499852,13885,'ms','Menyediakan langkah-langkah kerja',0),(499853,13885,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø®Ø·ÙˆØ§Øª Ø§Ù„Ø¹Ù…Ù„',0),(499854,13885,'fr','Mettre en place les Ã©tapes de travail',0),(499855,13885,'jp','ä½œæ¥­æ‰‹é †ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(499856,13885,'pt','Configurar as etapas de trabalho',0),(499857,13885,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑˆÐ°Ð³Ð¸',0),(499858,13885,'es','Establecer pasos de trabajo',0),(499859,13885,'de','Richten Sie Arbeitsschritte',0),(499860,13885,'en','Set Up Work Steps',0),(499861,13886,'is','',0),(499862,13886,'dr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø®Ø±ÛŒØ¯ Ø§Ø³Ù†Ø§Ø¯',0),(499863,13886,'pr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø®Ø±ÛŒØ¯ Ø§Ø³Ù†Ø§Ø¯',0),(499864,13886,'tr','Kredi kartÄ± satÄ±nalma belgeleri',0),(499865,13886,'pl','Dokumenty zakupu karty kredytowej',0),(499866,13886,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(499867,13886,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(499868,13886,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾ Ð½Ð°Ð±Ð°Ð²Ñ†Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(499869,13886,'vi','Tháº» tÃ­n dá»¥ng mua tÃ i liá»‡u',0),(499870,13886,'af','Kredietkaart Aankoop Dokumente',0),(499871,13886,'ro','Documentele de cumpÄƒrare Card de credit',0),(499872,13886,'et','Krediitkaardi ostudokumentide',0),(499873,13886,'si','Kreditne kartice nabavnih dokumentov',0),(499874,13886,'ba','Kartu kredit pembelian dokumen',0),(499875,13886,'nl','Creditcard inkoopdocumenten',0),(499876,13886,'fi','Luottokortin ostoasiakirjoissa',0),(499877,13886,'no','Kredittkort kjÃ¸psdokumenter',0),(499878,13886,'da','Kreditkort kÃ¸bsdokumenter',0),(499879,13886,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ ë¬¸ì„œ',0),(499880,13886,'he','×ž×¡×ž×›×™ ×¨×›×™×©×” ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(499881,13886,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Ï€Î±ÏÎ±ÏƒÏ„Î±Ï„Î¹ÎºÎ¬ Î±Î³Î¿ÏÏŽÎ½',0),(499882,13886,'zh','ä¿¡ç”¨å¡é‡‡è´­å•æ®',0),(499883,13886,'sv','Kreditkort inkÃ¶psdokument',0),(499884,13886,'it','Documenti di acquisto di carta di credito',0),(499885,13886,'tl','',0),(499886,13886,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¹€à¸­à¸à¸ªà¸²à¸£à¸à¸²à¸£à¸‹à¸·à¹‰à¸­',0),(499887,13886,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚',0),(499888,13886,'ms','Dokumen-dokumen pembelian kad kredit',0),(499889,13886,'ar','Ù…Ø³ØªÙ†Ø¯Ø§Øª Ø§Ù„Ø´Ø±Ø§Ø¡ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(499890,13886,'fr','Documents d\'achat de carte de crÃ©dit',0),(499891,13886,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰è³¼å…¥æ›¸é¡ž',0),(499892,13886,'pt','Documentos de compra de cartÃ£o de crÃ©dito',0),(499893,13886,'ru','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(499894,13886,'es','Documentos de compra de tarjeta de crÃ©dito',0),(499895,13886,'de','Kreditkarte-Einkaufsbelege',0),(499896,13886,'en','Credit Card Purchase Documents',0),(499897,13887,'is','',0),(499898,13887,'dr','Ú©Ù…Ú© Ù…Ø§Ù„ÛŒ',0),(499899,13887,'pr','Ú©Ù…Ú© Ù…Ø§Ù„ÛŒ',0),(499900,13887,'tr','BaÄŸÄ±ÅŸ yapÄ±n',0),(499901,13887,'pl','DarowaÄ‡',0),(499902,13887,'bg','Ð”Ð°Ñ€Ð¸',0),(499903,13887,'ur','Ø¹Ø·ÛŒÛ',0),(499904,13887,'sr','Ð”Ð¾Ð½Ð¸Ñ€Ð°Ñ‚Ð¸',0),(499905,13887,'vi','QuyÃªn gÃ³p',0),(499906,13887,'af','Skenk',0),(499907,13887,'ro','Dona',0),(499908,13887,'et','Kingi',0),(499909,13887,'si','Darovati',0),(499910,13887,'ba','Menyumbang',0),(499911,13887,'nl','Doneren',0),(499912,13887,'fi','Lahjoita',0),(499913,13887,'no','Donere',0),(499914,13887,'da','Donere',0),(499915,13887,'ko','ê¸°ë¶€',0),(499916,13887,'he','×ª×¨×•×',0),(499917,13887,'el','Î”Ï‰ÏÎ¯ÏƒÎ¿Ï…Î½',0),(499918,13887,'zh','æèµ ',0),(499919,13887,'sv','Donera',0),(499920,13887,'it','Donare',0),(499921,13887,'tl','',0),(499922,13887,'th','à¸šà¸£à¸´à¸ˆà¸²à¸„',0),(499923,13887,'hi','à¤¦à¤¾à¤¨',0),(499924,13887,'ms','Menderma',0),(499925,13887,'ar','Ø§Ù„ØªØ¨Ø±Ø¹',0),(499926,13887,'fr','Faire un don',0),(499927,13887,'jp','å¯„ä»˜',0),(499928,13887,'pt','Doar',0),(499929,13887,'ru','ÐŸÐ¾Ð¶ÐµÑ€Ñ‚Ð²Ð¾Ð²Ð°Ñ‚ÑŒ',0),(499930,13887,'es','Donar',0),(499931,13887,'de','Spenden',0),(499932,13887,'en','Donate',0),(499933,13888,'is','',0),(499934,13888,'dr','Ù…Ø±Ø§Ø­Ù„ Ú©Ø§Ø±',0),(499935,13888,'pr','Ù…Ø±Ø§Ø­Ù„ Ú©Ø§Ø±',0),(499936,13888,'tr','Ä°ÅŸ adÄ±mlarÄ±',0),(499937,13888,'pl','Kroki pracy',0),(499938,13888,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ ÑÑ‚ÑŠÐ¿ÐºÐ¸',0),(499939,13888,'ur','Ú©Ø§Ù… Ú©Û’ Ù…Ø±Ø§Ø­Ù„',0),(499940,13888,'sr','Ð Ð°Ð´ ÐºÐ¾Ñ€Ð°ÐºÐ°',0),(499941,13888,'vi','LÃ m viá»‡c bÆ°á»›c',0),(499942,13888,'af','Werk stappe',0),(499943,13888,'ro','PaÅŸi de lucru',0),(499944,13888,'et','Toimi jÃ¤rgmiselt.',0),(499945,13888,'si','Korake dela',0),(499946,13888,'ba','Langkah kerja',0),(499947,13888,'nl','Werk stappen',0),(499948,13888,'fi','TyÃ¶vaiheet',0),(499949,13888,'no','Arbeidstrinn',0),(499950,13888,'da','Arbejde trin',0),(499951,13888,'ko','ìž‘ì—… ë‹¨ê³„',0),(499952,13888,'he','×©×œ×‘×™ ×”×¢×‘×•×“×”',0),(499953,13888,'el','Î’Î®Î¼Î±Ï„Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(499954,13888,'zh','å·¥ä½œæ­¥éª¤',0),(499955,13888,'sv','Arbete steg',0),(499956,13888,'it','Fasi di lavoro',0),(499957,13888,'tl','',0),(499958,13888,'th','à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™',0),(499959,13888,'hi','à¤•à¤¦à¤® à¤•à¤¾à¤®',0),(499960,13888,'ms','Langkah-langkah kerja',0),(499961,13888,'ar','Ø®Ø·ÙˆØ§Øª Ø§Ù„Ø¹Ù…Ù„',0),(499962,13888,'fr','Ã‰tapes de travail',0),(499963,13888,'jp','ä½œæ¥­æ‰‹é †',0),(499964,13888,'pt','Etapas de trabalho',0),(499965,13888,'ru','Ð­Ñ‚Ð°Ð¿Ñ‹ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(499966,13888,'es','Pasos de trabajo',0),(499967,13888,'de','Arbeitsschritte',0),(499968,13888,'en','Work Steps',0),(499969,13889,'is','',0),(499970,13889,'dr','Ø¢ÙØ±ÛŒÙ‚Ø§',0),(499971,13889,'pr','Ø¢ÙØ±ÛŒÙ‚Ø§',0),(499972,13889,'tr','Afrika',0),(499973,13889,'pl','Afryka',0),(499974,13889,'bg','ÐÑ„Ñ€Ð¸ÐºÐ°',0),(499975,13889,'ur','Ø§ÙØ±ÛŒÙ‚Û',0),(499976,13889,'sr','ÐÑ„Ñ€Ð¸ÐºÐ°',0),(499977,13889,'vi','Africa',0),(499978,13889,'af','Afrika',0),(499979,13889,'ro','Africa',0),(499980,13889,'et','Africa',0),(499981,13889,'si','Afrika',0),(499982,13889,'ba','Afrika',0),(499983,13889,'nl','Afrika',0),(499984,13889,'fi','Afrikka',0),(499985,13889,'no','Afrika',0),(499986,13889,'da','Afrika',0),(499987,13889,'ko','ì•„í”„ë¦¬ì¹´',0),(499988,13889,'he','××¤×¨×™×§×”',0),(499989,13889,'el','Î‘Ï†ÏÎ¹ÎºÎ®',0),(499990,13889,'zh','éžæ´²',0),(499991,13889,'sv','Afrika',0),(499992,13889,'it','Africa',0),(499993,13889,'tl','',0),(499994,13889,'th','à¹à¸­à¸Ÿà¸£à¸´à¸à¸²',0),(499995,13889,'hi','à¤…à¤«à¥à¤°à¥€à¤•à¤¾',0),(499996,13889,'ms','Afrika',0),(499997,13889,'ar','Ø£ÙØ±ÙŠÙ‚ÙŠØ§',0),(499998,13889,'fr','Afrique',0),(499999,13889,'jp','ã‚¢ãƒ•ãƒªã‚«',0),(500000,13889,'pt','Ãfrica',0),(500001,13889,'ru','ÐÑ„Ñ€Ð¸ÐºÐ°',0),(500002,13889,'es','Ãfrica',0),(500003,13889,'de','Afrika',0),(500004,13889,'en','Africa',0),(500005,13890,'is','',0),(500006,13890,'dr','Ù‚Ø·Ø¨ Ø¬Ù†ÙˆØ¨',0),(500007,13890,'pr','Ù‚Ø·Ø¨ Ø¬Ù†ÙˆØ¨',0),(500008,13890,'tr','Antarktika',0),(500009,13890,'pl','Antarktyda',0),(500010,13890,'bg','ÐÐ½Ñ‚Ð°Ñ€ÐºÑ‚Ð¸ÐºÐ°',0),(500011,13890,'ur','Ø§Ù†Ù¹Ø§Ø±Ú©Ù¹ÛŒÚ©Ø§',0),(500012,13890,'sr','ÐÐ½Ñ‚Ð°Ñ€ÐºÑ‚Ð¸Ðº',0),(500013,13890,'vi','Antarctica',0),(500014,13890,'af','Antarctica',0),(500015,13890,'ro','Antarctica',0),(500016,13890,'et','Antarktikas',0),(500017,13890,'si','Antarktika',0),(500018,13890,'ba','Antartika',0),(500019,13890,'nl','Antarctica',0),(500020,13890,'fi','EtelÃ¤manner',0),(500021,13890,'no','Antarktis',0),(500022,13890,'da','Antarktis',0),(500023,13890,'ko','ë‚¨ê·¹ ëŒ€ë¥™',0),(500024,13890,'he','×× ×˜××¨×§×˜×™×§×”',0),(500025,13890,'el','Î‘Î½Ï„Î±ÏÎºÏ„Î¹ÎºÎ®',0),(500026,13890,'zh','å—æžæ´²',0),(500027,13890,'sv','Antarktis',0),(500028,13890,'it','Antartide',0),(500029,13890,'tl','',0),(500030,13890,'th','à¸—à¸§à¸µà¸›à¹à¸­à¸™à¸•à¸²à¸£à¹Œà¸à¸•à¸´à¸à¸²',0),(500031,13890,'hi','à¤…à¤‚à¤Ÿà¤¾à¤°à¥à¤•à¤Ÿà¤¿à¤•à¤¾',0),(500032,13890,'ms','Antartika',0),(500033,13890,'ar','Ø§Ù„Ù‚Ø§Ø±Ø© Ø§Ù„Ù‚Ø·Ø¨ÙŠØ© Ø§Ù„Ø¬Ù†ÙˆØ¨ÙŠØ©',0),(500034,13890,'fr','L\'Antarctique',0),(500035,13890,'jp','å—æ¥µå¤§é™¸',0),(500036,13890,'pt','AntÃ¡rtica',0),(500037,13890,'ru','ÐÐ½Ñ‚Ð°Ñ€ÐºÑ‚Ð¸Ð´Ð°',0),(500038,13890,'es','La AntÃ¡rtida',0),(500039,13890,'de','Antarktis',0),(500040,13890,'en','Antarctica',0),(500041,13891,'is','',0),(500042,13891,'dr','Ø¢Ø³ÛŒØ§',0),(500043,13891,'pr','Ø¢Ø³ÛŒØ§',0),(500044,13891,'tr','Asya',0),(500045,13891,'pl','Asia',0),(500046,13891,'bg','ÐÐ·Ð¸Ñ',0),(500047,13891,'ur','Ø§ÛŒØ´ÛŒØ§',0),(500048,13891,'sr','ÐÑÐ¸Ð°',0),(500049,13891,'vi','Asia',0),(500050,13891,'af','AsiÃ«',0),(500051,13891,'ro','Asia',0),(500052,13891,'et','Asia',0),(500053,13891,'si','Aziji',0),(500054,13891,'ba','Asia',0),(500055,13891,'nl','Asia',0),(500056,13891,'fi','Aasia',0),(500057,13891,'no','Asia',0),(500058,13891,'da','Asien',0),(500059,13891,'ko','ì•„ì‹œì•„',0),(500060,13891,'he','××¡×™×”',0),(500061,13891,'el','Î‘ÏƒÎ¯Î±',0),(500062,13891,'zh','äºšæ´²',0),(500063,13891,'sv','Asien',0),(500064,13891,'it','Asia',0),(500065,13891,'tl','',0),(500066,13891,'th','à¹€à¸­à¹€à¸Šà¸µà¸¢',0),(500067,13891,'hi','à¤à¤¶à¤¿à¤¯à¤¾',0),(500068,13891,'ms','Asia',0),(500069,13891,'ar','Ø¢Ø³ÙŠØ§',0),(500070,13891,'fr','Asie',0),(500071,13891,'jp','ã‚¢ã‚¸ã‚¢',0),(500072,13891,'pt','Ãsia',0),(500073,13891,'ru','ÐÐ·Ð¸Ñ',0),(500074,13891,'es','Asia',0),(500075,13891,'de','Asien',0),(500076,13891,'en','Asia',0),(500077,13892,'is','',0),(500078,13892,'dr','Ø§Ø±ÙˆÙ¾Ø§',0),(500079,13892,'pr','Ø§Ø±ÙˆÙ¾Ø§',0),(500080,13892,'tr','Europe',0),(500081,13892,'pl','Europa',0),(500082,13892,'bg','Ð•Ð²Ñ€Ð¾Ð¿Ð°',0),(500083,13892,'ur','ÛŒÙˆØ±Ù¾',0),(500084,13892,'sr','Ð•ÑƒÑ€Ð¾Ð¿Ðµ',0),(500085,13892,'vi','Europe',0),(500086,13892,'af','Europa',0),(500087,13892,'ro','Europa',0),(500088,13892,'et','Euroopa',0),(500089,13892,'si','Evropi',0),(500090,13892,'ba','Europe',0),(500091,13892,'nl','Europa',0),(500092,13892,'fi','Euroopan',0),(500093,13892,'no','Europa',0),(500094,13892,'da','Europa',0),(500095,13892,'ko','ìœ ëŸ½',0),(500096,13892,'he','××™×¨×•×¤×”',0),(500097,13892,'el','Î•Ï…ÏÏŽÏ€Î·',0),(500098,13892,'zh','æ¬§æ´²',0),(500099,13892,'sv','Europa',0),(500100,13892,'it','Europa',0),(500101,13892,'tl','',0),(500102,13892,'th','à¸¢à¸¸à¹‚à¸£à¸›',0),(500103,13892,'hi','à¤¯à¥‚à¤°à¥‹à¤ª',0),(500104,13892,'ms','Europe',0),(500105,13892,'ar','Ø£ÙˆØ±ÙˆØ¨Ø§',0),(500106,13892,'fr','Europe',0),(500107,13892,'jp','ãƒ¨ãƒ¼ãƒ­ãƒƒãƒ‘',0),(500108,13892,'pt','Europa',0),(500109,13892,'ru','Ð•Ð²Ñ€Ð¾Ð¿Ð°',0),(500110,13892,'es','Europa',0),(500111,13892,'de','Europa',0),(500112,13892,'en','Europe',0),(500113,13893,'is','',0),(500114,13893,'dr','Ø¢Ù…Ø±ÛŒÚ©Ø§ÛŒ Ø´Ù…Ø§Ù„ÛŒ',0),(500115,13893,'pr','Ø¢Ù…Ø±ÛŒÚ©Ø§ÛŒ Ø´Ù…Ø§Ù„ÛŒ',0),(500116,13893,'tr','Kuzey Amerika',0),(500117,13893,'pl','Ameryka PÃ³Å‚nocna',0),(500118,13893,'bg','Ð¡ÐµÐ²ÐµÑ€Ð½Ð° ÐÐ¼ÐµÑ€Ð¸ÐºÐ°',0),(500119,13893,'ur','Ø´Ù…Ø§Ù„ÛŒ Ø§Ù…Ø±ÛŒÚ©Û',0),(500120,13893,'sr','Ð¡ÐµÐ²ÐµÑ€Ð½Ð° ÐÐ¼ÐµÑ€Ð¸ÐºÐ°',0),(500121,13893,'vi','Báº¯c Má»¹',0),(500122,13893,'af','Noord-Amerika',0),(500123,13893,'ro','America de Nord',0),(500124,13893,'et','PÃµhja-Ameerikas',0),(500125,13893,'si','Severna Amerika',0),(500126,13893,'ba','Amerika Utara',0),(500127,13893,'nl','Noord-Amerika',0),(500128,13893,'fi','Pohjois-Amerikka',0),(500129,13893,'no','Nord-Amerika',0),(500130,13893,'da','Nordamerika',0),(500131,13893,'ko','ë¶ë¯¸ ì§€ì—­',0),(500132,13893,'he','×¦×¤×•×Ÿ ××ž×¨×™×§×”',0),(500133,13893,'el','Î’ÏŒÏÎµÎ¹Î± Î‘Î¼ÎµÏÎ¹ÎºÎ®',0),(500134,13893,'zh','åŒ—ç¾Žåœ°åŒº',0),(500135,13893,'sv','Nordamerika',0),(500136,13893,'it','America del Nord',0),(500137,13893,'tl','',0),(500138,13893,'th','à¸­à¹€à¸¡à¸£à¸´à¸à¸²à¹€à¸«à¸™à¸·à¸­',0),(500139,13893,'hi','à¤‰à¤¤à¥à¤¤à¤° à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾',0),(500140,13893,'ms','Amerika Utara',0),(500141,13893,'ar','Ø£Ù…Ø±ÙŠÙƒØ§ Ø§Ù„Ø´Ù…Ø§Ù„ÙŠØ©',0),(500142,13893,'fr','AmÃ©rique du Nord',0),(500143,13893,'jp','åŒ—ã‚¢ãƒ¡ãƒªã‚«',0),(500144,13893,'pt','AmÃ©rica do Norte',0),(500145,13893,'ru','Ð¡ÐµÐ²ÐµÑ€Ð½Ð°Ñ ÐÐ¼ÐµÑ€Ð¸ÐºÐ°',0),(500146,13893,'es','AmÃ©rica del norte',0),(500147,13893,'de','Nordamerika',0),(500148,13893,'en','North America',0),(500149,13894,'is','',0),(500150,13894,'dr','Ø§Ù‚ÛŒØ§Ù†ÙˆØ³ÛŒÙ‡',0),(500151,13894,'pr','Ø§Ù‚ÛŒØ§Ù†ÙˆØ³ÛŒÙ‡',0),(500152,13894,'tr','Oceania',0),(500153,13894,'pl','Oceania',0),(500154,13894,'bg','ÐžÐºÐµÐ°Ð½Ð¸Ñ',0),(500155,13894,'ur','ÙˆØ´Ù†ÛŒØ§',0),(500156,13894,'sr','ÐžÑ†ÐµÐ°Ð½Ð¸Ð°',0),(500157,13894,'vi','Oceania',0),(500158,13894,'af','Oceania',0),(500159,13894,'ro','Oceania',0),(500160,13894,'et','Hotelli Oceania',0),(500161,13894,'si','Oceanija',0),(500162,13894,'ba','Oceania',0),(500163,13894,'nl','OceaniÃ«',0),(500164,13894,'fi','Oseania',0),(500165,13894,'no','Oceania',0),(500166,13894,'da','Oceanien',0),(500167,13894,'ko','ì˜¤ì„¸ì•„ë‹ˆì•„',0),(500168,13894,'he','××•×§×™×× ×™×”',0),(500169,13894,'el','Î©ÎºÎµÎ±Î½Î¯Î±',0),(500170,13894,'zh','å¤§æ´‹æ´²',0),(500171,13894,'sv','Oceanien',0),(500172,13894,'it','Oceania',0),(500173,13894,'tl','',0),(500174,13894,'th','à¹‚à¸­à¹€à¸Šà¸µà¸¢à¹€à¸™à¸µà¸¢',0),(500175,13894,'hi','à¤“à¤¶à¤¿à¤¨à¤¿à¤¯à¤¾',0),(500176,13894,'ms','Oceania',0),(500177,13894,'ar','Ø£ÙˆÙ‚ÙŠØ§Ù†ÙˆØ³ÙŠØ§',0),(500178,13894,'fr','OcÃ©anie',0),(500179,13894,'jp','ã‚ªã‚»ã‚¢ãƒ‹ã‚¢',0),(500180,13894,'pt','Oceania',0),(500181,13894,'ru','ÐžÐºÐµÐ°Ð½Ð¸Ñ',0),(500182,13894,'es','OceanÃ­a',0),(500183,13894,'de','Oceania',0),(500184,13894,'en','Oceania',0),(500185,13895,'is','',0),(500186,13895,'dr','Ú©Ø´ÙˆØ± Ø®ÙˆØ¯ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨',0),(500187,13895,'pr','Ú©Ø´ÙˆØ± Ø®ÙˆØ¯ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨',0),(500188,13895,'tr','Ãœlkenizi seÃ§in',0),(500189,13895,'pl','Wybierz swÃ³j kraj',0),(500190,13895,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð°',0),(500191,13895,'ur','Ø¢Ù¾ Ú©Û’ Ù…Ù„Ú© Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(500192,13895,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ²Ð¾Ñ˜Ñƒ Ð´Ñ€Ð¶Ð°Ð²Ñƒ',0),(500193,13895,'vi','Chá»n quá»‘c gia',0),(500194,13895,'af','Kies jou land',0),(500195,13895,'ro','Selectati tara',0),(500196,13895,'et','Vali riik',0),(500197,13895,'si','Izberite svojo drÅ¾avo',0),(500198,13895,'ba','Pilih negara Anda',0),(500199,13895,'nl','Selecteer uw land',0),(500200,13895,'fi','Valitse maa',0),(500201,13895,'no','Velg ditt land',0),(500202,13895,'da','VÃ¦lg dit land',0),(500203,13895,'ko','êµ­ê°€ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(500204,13895,'he','×‘×—×¨ ××ª ×”×ž×“×™× ×” ×©×œ×š',0),(500205,13895,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î· Ï‡ÏŽÏÎ± ÏƒÎ±Ï‚',0),(500206,13895,'zh','é€‰æ‹©æ‚¨çš„å›½å®¶',0),(500207,13895,'sv','VÃ¤lj ditt land',0),(500208,13895,'it','Seleziona il tuo paese',0),(500209,13895,'tl','',0),(500210,13895,'th','à¹€à¸¥à¸·à¸­à¸à¸›à¸£à¸°à¹€à¸—à¸¨à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(500211,13895,'hi','à¤…à¤ªà¤¨à¥‡ à¤¦à¥‡à¤¶ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(500212,13895,'ms','Pilih negara anda',0),(500213,13895,'ar','Ø­Ø¯Ø¯ Ø¨Ù„Ø¯Ùƒ',0),(500214,13895,'fr','SÃ©lectionnez votre pays',0),(500215,13895,'jp','ã‚ãªãŸã®å›½ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(500216,13895,'pt','Selecione seu paÃ­s',0),(500217,13895,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÑƒ ÑÑ‚Ñ€Ð°Ð½Ñƒ',0),(500218,13895,'es','Seleccione su paÃ­s',0),(500219,13895,'de','WÃ¤hlen Sie Ihr Land',0),(500220,13895,'en','Select Your Country',0),(500221,13896,'is','',0),(500222,13896,'dr','Ø¬Ù†ÙˆØ¨ Ø§Ù…Ø±ÛŒÚ©Ø§',0),(500223,13896,'pr','Ø¬Ù†ÙˆØ¨ Ø§Ù…Ø±ÛŒÚ©Ø§',0),(500224,13896,'tr','GÃ¼ney Amerika',0),(500225,13896,'pl','Ameryka PoÅ‚udniowa',0),(500226,13896,'bg','Ð®Ð¶Ð½Ð° ÐÐ¼ÐµÑ€Ð¸ÐºÐ°',0),(500227,13896,'ur','Ø¬Ù†ÙˆØ¨ÛŒ Ø§Ù…Ø±ÛŒÚ©Û',0),(500228,13896,'sr','ÐˆÑƒÐ¶Ð½Ðµ ÐÐ¼ÐµÑ€Ð¸ÐºÐµ',0),(500229,13896,'vi','Nam Má»¹',0),(500230,13896,'af','Suid-Amerika',0),(500231,13896,'ro','America de Sud',0),(500232,13896,'et','LÃµuna-Ameerika',0),(500233,13896,'si','JuÅ¾na Amerika',0),(500234,13896,'ba','Amerika Selatan',0),(500235,13896,'nl','Zuid-Amerika',0),(500236,13896,'fi','EtelÃ¤-Amerikka',0),(500237,13896,'no','SÃ¸r-Amerika',0),(500238,13896,'da','Sydamerika',0),(500239,13896,'ko','ë‚¨ ì•„ë©”ë¦¬ì¹´',0),(500240,13896,'he','×“×¨×•× ××ž×¨×™×§×”',0),(500241,13896,'el','ÎÏŒÏ„Î¹Î± Î‘Î¼ÎµÏÎ¹ÎºÎ®',0),(500242,13896,'zh','å—åŒ—ç¾Žæ´²',0),(500243,13896,'sv','Sydamerika',0),(500244,13896,'it','Sud America',0),(500245,13896,'tl','',0),(500246,13896,'th','à¸­à¹€à¸¡à¸£à¸´à¸à¸²à¹ƒà¸•à¹‰',0),(500247,13896,'hi','à¤¦à¤•à¥à¤·à¤¿à¤£ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾',0),(500248,13896,'ms','Amerika Selatan',0),(500249,13896,'ar','Ø£Ù…Ø±ÙŠÙƒØ§ Ø§Ù„Ø¬Ù†ÙˆØ¨ÙŠØ©',0),(500250,13896,'fr','L\'AmÃ©rique du Sud',0),(500251,13896,'jp','å—ã‚¢ãƒ¡ãƒªã‚«',0),(500252,13896,'pt','AmÃ©rica do Sul',0),(500253,13896,'ru','Ð®Ð¶Ð½Ð°Ñ ÐÐ¼ÐµÑ€Ð¸ÐºÐ°',0),(500254,13896,'es','AmÃ©rica del sur',0),(500255,13896,'de','SÃ¼damerika',0),(500256,13896,'en','South America',0),(500257,13897,'is','',0),(500258,13897,'dr','Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø®ÛŒÙ„ÛŒ Ú©ÙˆØªØ§Ù‡',0),(500259,13897,'pr','Ù†Ø§Ù… Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø®ÛŒÙ„ÛŒ Ú©ÙˆØªØ§Ù‡',0),(500260,13897,'tr','KullanÄ±cÄ± adÄ± Ã§ok kÄ±sa',0),(500261,13897,'pl','Nazwa uÅ¼ytkownika zbyt krÃ³tki',0),(500262,13897,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¾ Ð¸Ð¼Ðµ Ñ‚Ð²ÑŠÑ€Ð´Ðµ ÐºÑ€Ð°Ñ‚ÐºÐ¾',0),(500263,13897,'ur','ØµØ§Ø±Ù Ú©Ø§ Ù†Ø§Ù… Ø¨ÛØª Ú†Ú¾ÙˆÙ¹Ø§',0),(500264,13897,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ð¸Ð¼Ðµ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚Ð°Ðº',0),(500265,13897,'vi','TÃªn ngÆ°á»i dÃ¹ng quÃ¡ ngáº¯n',0),(500266,13897,'af','Gebruikernaam Te Kort',0),(500267,13897,'ro','Numele de utilizator prea scurt',0),(500268,13897,'et','Kasutajanimi liiga lÃ¼hike',0),(500269,13897,'si','UporabniÅ¡ko ime prekratek',0),(500270,13897,'ba','Nama pengguna terlalu pendek',0),(500271,13897,'nl','Gebruikersnaam te kort',0),(500272,13897,'fi','KÃ¤yttÃ¤jÃ¤tunnus liian lyhyt',0),(500273,13897,'no','Brukernavn for kort',0),(500274,13897,'da','Brugernavnet for kort',0),(500275,13897,'ko','ì‚¬ìš©ìž ì´ë¦„ ë„ˆë¬´ ì§§ì€',0),(500276,13897,'he','×©× ×ž×©×ª×ž×© ×§×¦×¨ ×ž×“×™',0),(500277,13897,'el','ÎŒÎ½Î¿Î¼Î± Ï‡ÏÎ®ÏƒÏ„Î· Ï€Î¿Î»Ï Î¼Î¹ÎºÏÎ®',0),(500278,13897,'zh','ç”¨æˆ·åå¤ªçŸ­',0),(500279,13897,'sv','AnvÃ¤ndarnamn fÃ¶r kort',0),(500280,13897,'it','Username troppo breve',0),(500281,13897,'tl','',0),(500282,13897,'th','à¸Šà¸·à¹ˆà¸­à¸ªà¸±à¹‰à¸™à¹€à¸à¸´à¸™à¹„à¸›',0),(500283,13897,'hi','à¤ªà¥à¤°à¤¯à¥‹à¤•à¥à¤¤à¤¾ à¤¨à¤¾à¤® à¤¬à¤¹à¥à¤¤ à¤›à¥‹à¤Ÿà¤¾',0),(500284,13897,'ms','Nama pengguna terlalu pendek',0),(500285,13897,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù‚ØµÙŠØ± Ø¬Ø¯Ø§Ù‹',0),(500286,13897,'fr','Nom d\'utilisateur trop court',0),(500287,13897,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼åãŒçŸ­ã™ãŽã¾ã™ã€‚',0),(500288,13897,'pt','Nome de utilizador demasiado curto',0),(500289,13897,'ru','Ð˜Ð¼Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ ÑÐ»Ð¸ÑˆÐºÐ¾Ð¼ ÐºÐ¾Ñ€Ð¾Ñ‚ÐºÐ¾Ðµ',0),(500290,13897,'es','Nombre de usuario demasiado corto',0),(500291,13897,'de','Benutzername zu kurz',0),(500292,13897,'en','Username Too Short',0),(500293,13898,'is','',0),(500294,13898,'dr','ØªØ®ÙÛŒÙ',0),(500295,13898,'pr','ØªØ®ÙÛŒÙ',0),(500296,13898,'tr','Ä°ndirim konusu',0),(500297,13898,'pl','Rabat w wysokoÅ›ci',0),(500298,13898,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð¾Ñ‚',0),(500299,13898,'ur','Ú©ÛŒ Ø±Ø¹Ø§ÛŒØª',0),(500300,13898,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð¾Ð´',0),(500301,13898,'vi','Giáº£m giÃ¡',0),(500302,13898,'af','Afslag van',0),(500303,13898,'ro','Reducere de',0),(500304,13898,'et','Allahindlus',0),(500305,13898,'si','Popust',0),(500306,13898,'ba','Diskon',0),(500307,13898,'nl','Korting van',0),(500308,13898,'fi','Alennus',0),(500309,13898,'no','Rabatt pÃ¥',0),(500310,13898,'da','Rabat pÃ¥',0),(500311,13898,'ko','í• ì¸',0),(500312,13898,'he','×”× ×—×” ×©×œ',0),(500313,13898,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ·',0),(500314,13898,'zh','æŠ˜æ‰£',0),(500315,13898,'sv','Rabatt pÃ¥',0),(500316,13898,'it','Sconto di',0),(500317,13898,'tl','',0),(500318,13898,'th','à¸ªà¹ˆà¸§à¸™à¸¥à¸”',0),(500319,13898,'hi','à¤•à¥€ à¤›à¥‚à¤Ÿ',0),(500320,13898,'ms','Diskaun',0),(500321,13898,'ar','Ø§Ù„Ø®ØµÙ… Ù…Ù†',0),(500322,13898,'fr','Rabais de',0),(500323,13898,'jp','å‰²å¼•',0),(500324,13898,'pt','Desconto de',0),(500325,13898,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ°',0),(500326,13898,'es','Descuento de',0),(500327,13898,'de','Rabatt in HÃ¶he von',0),(500328,13898,'en','Discount of',0),(500329,13899,'is','',0),(500330,13899,'dr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(500331,13899,'pr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(500332,13899,'tr','SeÃ§ili sipariÅŸ vermeyen',0),(500333,13899,'pl','Nie zamÃ³wienia wybranych',0),(500334,13899,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(500335,13899,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø§Ø±ÛŒ',0),(500336,13899,'sr','ÐÐ¸ÐºÐ°ÐºÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(500337,13899,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n Ä‘áº·t hÃ ng Ä‘Ã£ chá»n',0),(500338,13899,'af','Geen bestellings gekies',0),(500339,13899,'ro','Comenzi selectate',0),(500340,13899,'et','Pole valitud tellimused',0),(500341,13899,'si','Brez naroÄil, izbrana',0),(500342,13899,'ba','Tidak ada order yang dipilih',0),(500343,13899,'nl','Geen Orders geselecteerd',0),(500344,13899,'fi','Valitut tilaukset',0),(500345,13899,'no','Ingen ordrer valgt',0),(500346,13899,'da','Ingen ordrer, valgt',0),(500347,13899,'ko','ì•„ë‹ˆ ì£¼ë¬¸ ì„ íƒ',0),(500348,13899,'he','×¤×§×•×“×•×ª ×©× ×‘×—×¨×•',0),(500349,13899,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯',0),(500350,13899,'zh','æ²¡æœ‰é€‰å®šçš„å‘½ä»¤',0),(500351,13899,'sv','Inga order markerad',0),(500352,13899,'it','Nessun ordine selezionato',0),(500353,13899,'tl','',0),(500354,13899,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(500355,13899,'hi','à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤šà¤¯à¤¨à¤¿à¤¤',0),(500356,13899,'ms','Tiada perintah yang dipilih',0),(500357,13899,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙˆØ§Ù…Ø± Ù…Ø­Ø¯Ø¯Ø©',0),(500358,13899,'fr','Aucune commande sÃ©lectionnÃ©e',0),(500359,13899,'jp','é¸æŠžã•ã‚ŒãŸæ³¨æ–‡ã®ãªã„ã§ã™ã€‚',0),(500360,13899,'pt','Nenhuma ordem selecionada',0),(500361,13899,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(500362,13899,'es','Ninguna orden seleccionada',0),(500363,13899,'de','Keine Bestellungen ausgewÃ¤hlt',0),(500364,13899,'en','No Orders Selected',0),(500365,13900,'is','',0),(500366,13900,'dr','Ø¯Ø± Ù‡Ø± Ø³ÙØ§Ø±Ø´',0),(500367,13900,'pr','Ø¯Ø± Ù‡Ø± Ø³ÙØ§Ø±Ø´',0),(500368,13900,'tr','SipariÅŸ iÃ§in',0),(500369,13900,'pl','Na zamÃ³wienie',0),(500370,13900,'bg','ÐÐ° Ñ€ÐµÐ´',0),(500371,13900,'ur','ÙÛŒ Ø§Ù…Ø§Ù†',0),(500372,13900,'sr','ÐŸÐ¾ Ð½Ð°Ð»Ð¾Ð³Ñƒ',0),(500373,13900,'vi','Má»™t Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(500374,13900,'af','Per bestelling',0),(500375,13900,'ro','Pe comanda',0),(500376,13900,'et','Tellimuse kohta',0),(500377,13900,'si','Na naroÄilo',0),(500378,13900,'ba','Per pesanan',0),(500379,13900,'nl','Per bestelling',0),(500380,13900,'fi','Per tilaus',0),(500381,13900,'no','Per bestilling',0),(500382,13900,'da','Pr. ordre',0),(500383,13900,'ko','ìˆœì„œ ë‹¹',0),(500384,13900,'he','×œ×›×œ ×”×–×ž× ×”',0),(500385,13900,'el','Î‘Î½Î¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(500386,13900,'zh','æ¯ä¸ªè®¢å•',0),(500387,13900,'sv','Per bestÃ¤llning',0),(500388,13900,'it','Per ogni ordine',0),(500389,13900,'tl','',0),(500390,13900,'th','à¸•à¹ˆà¸­à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(500391,13900,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶',0),(500392,13900,'ms','Setiap pesanan',0),(500393,13900,'ar','ÙƒÙ„ Ø£Ù…Ø±',0),(500394,13900,'fr','Par commande',0),(500395,13900,'jp','æ³¨æ–‡ã‚ãŸã‚Š',0),(500396,13900,'pt','Por ordem',0),(500397,13900,'ru','ÐÐ° Ð·Ð°ÐºÐ°Ð·',0),(500398,13900,'es','Por orden',0),(500399,13900,'de','Pro Bestellung',0),(500400,13900,'en','Per Order',0),(500401,13901,'is','',0),(500402,13901,'dr','Ù…Ø·Ø¨ÙˆØ¹Ø§Øª Ù…ØªØ´Ú©Ù„ Ø§Ø²',0),(500403,13901,'pr','Ù…Ø·Ø¨ÙˆØ¹Ø§Øª Ù…ØªØ´Ú©Ù„ Ø§Ø²',0),(500404,13901,'tr','BasÄ±lÄ± malzeme oluÅŸan',0),(500405,13901,'pl','Druki skÅ‚adajÄ…ce siÄ™ z',0),(500406,13901,'bg','ÐŸÐµÑ‡Ð°Ñ‚Ð½Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð¸, ÑÑŠÑÑ‚Ð¾ÑÑ‰Ð¸ ÑÐµ Ð¾Ñ‚',0),(500407,13901,'ur','Printed Ù…Ø§Ø¯Û’ Ù¾Ø± Ù…Ø´ØªÙ…Ù„',0),(500408,13901,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ð¼Ð°Ñ‚ÐµÑ€Ð¸Ñ˜Ð°Ð» ÐºÐ¾Ñ˜Ð¸ ÑÐµ ÑÐ°ÑÑ‚Ð¾Ñ˜Ð¸ Ð¾Ð´',0),(500409,13901,'vi','CÃ¡c áº¥n báº£n bao gá»“m',0),(500410,13901,'af','Gedruk saak wat bestaan uit',0),(500411,13901,'ro','Materialele tipÄƒrite constÃ¢nd din',0),(500412,13901,'et','Koosnevad trÃ¼kised',0),(500413,13901,'si','Tiskovine, ki sestoji iz',0),(500414,13901,'ba','Cetakan yang terdiri dari',0),(500415,13901,'nl','Drukwerk, bestaande uit',0),(500416,13901,'fi','Painotuotteet koostuu',0),(500417,13901,'no','Trykksaker bestÃ¥ende av',0),(500418,13901,'da','Tryksager bestÃ¥ende af',0),(500419,13901,'ko','ì¸ì‡„ë¬¼ì˜ êµ¬ì„±',0),(500420,13901,'he','×—×•×ž×¨ ×ž×•×“×¤×¡ ×”×ž×•×¨×›×‘',0),(500421,13901,'el','ÎˆÎ½Ï„Ï…Ï€Î¿ Ï…Î»Î¹ÎºÏŒ Ï€Î¿Ï… Î±Ï€Î¿Ï„ÎµÎ»ÎµÎ¯Ï„Î±Î¹ Î±Ï€ÏŒ',0),(500422,13901,'zh','å°åˆ·å“ç»„æˆçš„',0),(500423,13901,'sv','Trycksaker som bestÃ¥r av',0),(500424,13901,'it','Stampati costituito',0),(500425,13901,'tl','',0),(500426,13901,'th','à¸ªà¸´à¹ˆà¸‡à¸žà¸´à¸¡à¸žà¹Œà¸›à¸£à¸°à¸à¸­à¸šà¸”à¹‰à¸§à¸¢',0),(500427,13901,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤¬à¤¾à¤¤ à¤¸à¥‡ à¤®à¤¿à¤²à¤•à¤°',0),(500428,13901,'ms','Perkara bercetak yang terdiri daripada',0),(500429,13901,'ar','Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø§Øª Ø§Ù„ØªÙŠ ØªØªÙƒÙˆÙ† Ù…Ù†',0),(500430,13901,'fr','ImprimÃ©s consistant en',0),(500431,13901,'jp','å°åˆ·ç‰©ã‹ã‚‰æˆã‚‹',0),(500432,13901,'pt','Consistindo de material impresso',0),(500433,13901,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð½Ð°Ñ, ÑÐ¾ÑÑ‚Ð¾ÑÑ‰Ð¸Ð¹ Ð¸Ð·',0),(500434,13901,'es','Material impreso consiste en',0),(500435,13901,'de','Drucksachen, bestehend aus',0),(500436,13901,'en','Printed Matter Consisting of',0),(500437,13902,'is','',0),(500438,13902,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…Ø§Ù„ÛŒØ§Øª',0),(500439,13902,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…Ø§Ù„ÛŒØ§Øª',0),(500440,13902,'tr','Stok kullanÄ±m vergisi',0),(500441,13902,'pl','Podatek nienaliczony zapasÃ³w',0),(500442,13902,'bg','Ð”Ð°Ð½ÑŠÐº Ð·Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(500443,13902,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù¹ÛŒÚ©Ø³',0),(500444,13902,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(500445,13902,'vi','HÃ ng tá»“n kho sá»­ dá»¥ng thuáº¿',0),(500446,13902,'af','Voorraad gebruik belasting',0),(500447,13902,'ro','Taxa de utilizare inventar',0),(500448,13902,'et','Varude kasutamise maksu',0),(500449,13902,'si','Davek od uporabe zaloge',0),(500450,13902,'ba','Persediaan penggunaan pajak',0),(500451,13902,'nl','Inventaris Use Tax',0),(500452,13902,'fi','Varaston kÃ¤yttÃ¶vero',0),(500453,13902,'no','Lager Use Tax',0),(500454,13902,'da','Lageret importmoms',0),(500455,13902,'ko','ìž¬ê³  ì‚¬ìš© ì„¸ê¸ˆ',0),(500456,13902,'he','×ž×œ××™ ×”×©×ª×ž×© ×‘×ž×¡',0),(500457,13902,'el','Î¦ÏŒÏÎ¿Ï‚ Ï‡ÏÎ®ÏƒÎ·Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(500458,13902,'zh','åº“å­˜ä½¿ç”¨ç¨Ž',0),(500459,13902,'sv','Inventering AnvÃ¤nd skatt',0),(500460,13902,'it','Tassa di uso magazzino',0),(500461,13902,'tl','',0),(500462,13902,'th','à¸ à¸²à¸©à¸µà¸à¸²à¸£à¹ƒà¸Šà¹‰à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(500463,13902,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°',0),(500464,13902,'ms','Cukai penggunaan inventori',0),(500465,13902,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(500466,13902,'fr','L\'inventaire utilisation fiscale',0),(500467,13902,'jp','åœ¨åº«ã®ä½¿ç”¨ç¨Ž',0),(500468,13902,'pt','Imposto de uso do inventÃ¡rio',0),(500469,13902,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð½Ð°Ð»Ð¾Ð³',0),(500470,13902,'es','Impuesto al uso de inventario',0),(500471,13902,'de','Inventar-Verbrauchssteuer',0),(500472,13902,'en','Inventory Use Tax',0),(500473,13903,'is','',0),(500474,13903,'dr','Ù¾Ø§Ø³Ø® Ø¨Ù‡',0),(500475,13903,'pr','Ù¾Ø§Ø³Ø® Ø¨Ù‡',0),(500476,13903,'tr','YanÄ±tlama',0),(500477,13903,'pl','Odpowiedzi',0),(500478,13903,'bg','ÐžÑ‚Ð³Ð¾Ð²Ð¾Ñ€ Ð½Ð°',0),(500479,13903,'ur','Ø¬ÙˆØ§Ø¨ Ø¯ÛŒÚº',0),(500480,13903,'sr','ÐžÐ´Ð³Ð¾Ð²Ð°Ñ€Ð°ÑšÐµ Ð½Ð°',0),(500481,13903,'vi','Tráº£ lá»i',0),(500482,13903,'af','Om te antwoord',0),(500483,13903,'ro','RÄƒspunde la',0),(500484,13903,'et','SÃµnumile vastamine',0),(500485,13903,'si','Odgovoriti',0),(500486,13903,'ba','Membalas',0),(500487,13903,'nl','Beantwoorden',0),(500488,13903,'fi','Vastata',0),(500489,13903,'no','Svare pÃ¥',0),(500490,13903,'da','Besvare',0),(500491,13903,'ko','ì— ì‘ë‹µ',0),(500492,13903,'he','×œ×”×©×™×‘',0),(500493,13903,'el','Î‘Ï€Î¬Î½Ï„Î·ÏƒÎ· ÏƒÎµ',0),(500494,13903,'zh','å›žå¤',0),(500495,13903,'sv','Svara pÃ¥',0),(500496,13903,'it','Risposta a',0),(500497,13903,'tl','',0),(500498,13903,'th','à¸•à¸­à¸šà¸à¸¥à¸±à¸š',0),(500499,13903,'hi','à¤‰à¤¤à¥à¤¤à¤° à¤¦à¥‡à¤‚',0),(500500,13903,'ms','Membalas',0),(500501,13903,'ar','Ø§Ù„Ø±Ø¯ Ø¹Ù„Ù‰',0),(500502,13903,'fr','RÃ©pondre Ã ',0),(500503,13903,'jp','è¿”ä¿¡ã™ã‚‹ã«ã¯',0),(500504,13903,'pt','Resposta para',0),(500505,13903,'ru','ÐžÑ‚Ð²ÐµÑ‚Ð¸Ñ‚ÑŒ',0),(500506,13903,'es','Responder a',0),(500507,13903,'de','Antwort auf',0),(500508,13903,'en','Reply To',0),(500509,13904,'is','',0),(500510,13904,'dr','Ù¾ÙˆØ´Ø´ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ù†Ø¨Ø§Ø±',0),(500511,13904,'pr','Ù¾ÙˆØ´Ø´ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ù†Ø¨Ø§Ø±',0),(500512,13904,'tr','Kapak stok stok',0),(500513,13904,'pl','Czas inwentaryzacji pokrycia',0),(500514,13904,'bg','ÐœÐ°Ñ‚ÐµÑ€Ð¸Ð°Ð»Ð½Ð°Ñ‚Ð° Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²ÐºÐ°Ñ‚Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(500515,13904,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø³Ù¹Ø§Ú© Ú©Ø§ Ø§Ø­Ø§Ø·Û',0),(500516,13904,'sr','ÐŸÐ¾ÐºÑ€Ð¸Ñ˜ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(500517,13904,'vi','Bao gá»“m chá»©ng khoÃ¡n hÃ ng tá»“n kho',0),(500518,13904,'af','Bedek voorraad voorraad',0),(500519,13904,'ro','Valori de inventar coperta',0),(500520,13904,'et','Varude varu katta',0),(500521,13904,'si','Kritje zalog zalog',0),(500522,13904,'ba','Penutup inventarisasi Stock',0),(500523,13904,'nl','Inventaris boekbandpapier',0),(500524,13904,'fi','Varaston kartongille',0),(500525,13904,'no','Trekket lager lager',0),(500526,13904,'da','Lageret omslagspapir',0),(500527,13904,'ko','í‘œì§€ ìž¬ê³  ìž¬ê³ ',0),(500528,13904,'he','×›×™×¡×•×™ ×ž×œ××™ ×”×ž× ×™×•×ª',0),(500529,13904,'el','ÎšÎ¬Î»Ï…ÏˆÎ· Î±Ï€Î¿Î³ÏÎ±Ï†Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(500530,13904,'zh','ç›–åº“å­˜',0),(500531,13904,'sv','TÃ¤cka lager lager',0),(500532,13904,'it','Copertura magazzino Stock',0),(500533,13904,'tl','',0),(500534,13904,'th','à¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡à¸«à¸¥à¸±à¸à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(500535,13904,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¶à¥‡à¤¯à¤° à¤•à¥‹ à¤•à¤µà¤°',0),(500536,13904,'ms','Merangkumi stok inventori',0),(500537,13904,'ar','ØªØºØ·ÙŠØ© Ø±ØµÙŠØ¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(500538,13904,'fr','La couverture de l\'inventaire Stock',0),(500539,13904,'jp','ã‚«ãƒãƒ¼åœ¨åº«',0),(500540,13904,'pt','Tampa do inventÃ¡rio de estoque',0),(500541,13904,'ru','ÐžÐ±Ð»Ð¾Ð¶ÐºÐ° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(500542,13904,'es','Cubierta de inventario Stock',0),(500543,13904,'de','Abdeckung Inventur Lager',0),(500544,13904,'en','Cover Inventory Stock',0),(500545,13905,'is','',0),(500546,13905,'dr','Ù¾Ø§Ú©Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ù†Ø¨Ø§Ø±',0),(500547,13905,'pr','Ù¾Ø§Ú©Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ù†Ø¨Ø§Ø±',0),(500548,13905,'tr','Zarf stok stok',0),(500549,13905,'pl','Koperta inwentaryzacji zapasÃ³w',0),(500550,13905,'bg','ÐŸÐ»Ð¸Ðº Ð¾Ð¿Ð¸Ñ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð°',0),(500551,13905,'ur','Ù„ÙØ§ÙÛ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø³Ù¹Ø§Ú©',0),(500552,13905,'sr','ÐšÐ¾Ð²ÐµÑ€Ñ‚Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(500553,13905,'vi','Phong bÃ¬ hÃ ng tá»“n kho cá»• phiáº¿u',0),(500554,13905,'af','Koevert voorraad voorraad',0),(500555,13905,'ro','Valori de inventar plic',0),(500556,13905,'et','Ãœmbrik laovaru laos',0),(500557,13905,'si','Ovojnica popis zalog',0),(500558,13905,'ba','Amplop inventarisasi Stock',0),(500559,13905,'nl','Envelop inventaris voorraad',0),(500560,13905,'fi','Varaston kirjekuorivaihtoehto',0),(500561,13905,'no','Konvolutt lager lager',0),(500562,13905,'da','Kuvert lager lager',0),(500563,13905,'ko','ë´‰íˆ¬ ìž¬ê³  ì‚¬ì§„',0),(500564,13905,'he','×ž×¢×˜×¤×” ×ž×œ××™ ×”×ž× ×™×•×ª',0),(500565,13905,'el','Î¦Î¬ÎºÎµÎ»Î¿Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(500566,13905,'zh','ä¿¡å°åº“å­˜',0),(500567,13905,'sv','Kuvertutskrift inventering',0),(500568,13905,'it','Busta inventario magazzino',0),(500569,13905,'tl','',0),(500570,13905,'th','à¸ªà¸•à¹‡à¸­à¸à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸‚à¸­à¸‡à¸‹à¸­à¸‡à¸ˆà¸”à¸«à¸¡à¸²à¸¢',0),(500571,13905,'hi','à¤²à¤¿à¤«à¤¼à¤¾à¤«à¤¼à¤¾ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¶à¥‡à¤¯à¤°',0),(500572,13905,'ms','Stok inventori sampul surat',0),(500573,13905,'ar','Ù…ØºÙ„Ù Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(500574,13905,'fr','Enveloppe l\'inventaire Stock',0),(500575,13905,'jp','å°ç­’ã®åœ¨åº«',0),(500576,13905,'pt','Envelope estoque de inventÃ¡rio',0),(500577,13905,'ru','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(500578,13905,'es','Envolvente inventario Stock',0),(500579,13905,'de','Umschlag-Lager-Lager',0),(500580,13905,'en','Envelope Inventory Stock',0),(500581,13906,'is','',0),(500582,13906,'dr','Ù¾ÙˆÙ†Ø¯ Ø¯Ø± Ù‡Ø± Cutoffs 1000 Ø¬Ù„Ø¯',0),(500583,13906,'pr','Ù¾ÙˆÙ†Ø¯ Ø¯Ø± Ù‡Ø± Cutoffs 1000 Ø¬Ù„Ø¯',0),(500584,13906,'tr','Libre baÅŸÄ±na 1000 Cutoffs kapaklarÄ±',0),(500585,13906,'pl','Lbs. za 1000 spodenki dla okÅ‚adki',0),(500586,13906,'bg','LBS. Ð½Ð° 1000 Cutoffs Ð·Ð° Ð¿Ð¾ÐºÑ€Ð¸Ð²Ð°',0),(500587,13906,'ur','ØªØ¹Ø§Ù„ÛŒ ÙÛŒ 1000 Ú©ÙˆÙ¹ÙÙØ³ Ù¾Ø± Ù…Ø­ÛŒØ· Ú©Û’ Ù„Ø¦Û’',0),(500588,13906,'sr','Ð¢Ñ€Ð¸ÑÑ‚Ð° Ð¿Ð¾ 1000 Ð¾Ð´ Ñ„Ð°Ñ€Ð¼ÐµÑ€Ð¸Ñ†Ð° Ð·Ð° Ð·Ð°ÐºÐ»Ð¾Ð½Ðµ',0),(500589,13906,'vi','Lbs. má»—i 1000 Cutoffs bÃ¬a',0),(500590,13906,'af','LBS. per 1000 Cutoffs vir dek',0),(500591,13906,'ro','Lbs. per 1000 Cutoffs pentru capace',0),(500592,13906,'et','Lbs. eest 1000 Cutoffs katted',0),(500593,13906,'si','Lbs. na 1000 Cutoffs za prevleke',0),(500594,13906,'ba','Lbs. per 1000 celana pendek untuk meliputi',0),(500595,13906,'nl','Lbs. per 1000 Cutoffs voor Covers',0),(500596,13906,'fi','Lbs. / 1000 muutokset Cutoffs kattaa',0),(500597,13906,'no','Lbs. per 1000 konsentrasjon for dekker',0),(500598,13906,'da','Lbs. pr. 1000 Cutoffs for dÃ¦kker',0),(500599,13906,'ko','ì»¤ë²„ 1000 ì°¨ë‹¨ ë‹¹ íŒŒìš´ë“œ.',0),(500600,13906,'he','×§ ×’ ×œ×›×œ 1000 ×”×ž×›× ×¡×•× ×™× ×›×¨×™×›×•×ª',0),(500601,13906,'el','Î›Î¯Î²ÏÎµÏ‚ Î±Î½Î¬ 1000 Cutoffs Î³Î¹Î± Ï„Î¹Ï‚ ÎºÎ±Î»ÏÏˆÎµÎ¹Ï‚',0),(500602,13906,'zh','ç£…æ¯ 1000å¹´æ–­æµå™¨ç›–',0),(500603,13906,'sv','Lbs. per 1000 Cutoffs fÃ¶r omslag',0),(500604,13906,'it','Libbre per ogni 1000 tagli per coperture',0),(500605,13906,'tl','',0),(500606,13906,'th','à¸«à¸™à¹ˆà¸§à¸¢à¸›à¸­à¸™à¸”à¹Œà¸•à¹ˆà¸­ 1000 Cutoffs à¸ªà¸³à¸«à¸£à¸±à¸šà¸„à¸£à¸­à¸šà¸„à¸¥à¸¸à¸¡',0),(500607,13906,'hi','à¤•à¤µà¤° à¤•à¥‡ à¤²à¤¿à¤ 1000 Cutoffs à¤ªà¥à¤°à¤¤à¤¿ lbs.',0),(500608,13906,'ms','Lbs. setiap 1000 Cutoffs bagi meliputi',0),(500609,13906,'ar','Ø±Ø·Ù„Ø§ ÙƒÙ„ Ù‚Ø·Ø¹ 1000 Ù„ÙŠØºØ·ÙŠ',0),(500610,13906,'fr','Lb / 1000 les seuils pour couvertures',0),(500611,13906,'jp','ã‚«ãƒãƒ¼ã®ãŸã‚ã® 1000 Cutoffs ãƒãƒ³ãƒ‰',0),(500612,13906,'pt','Lbs por 1000 pontos de corte para cobre',0),(500613,13906,'ru','Ð¤ÑƒÐ½Ñ‚Ð¾Ð² Ð·Ð° 1000 Ð¿Ñ€ÐµÐ´Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÐµÐ»Ð¸ Ð´Ð»Ñ Ð¾Ð±Ð»Ð¾Ð¶ÐµÐº',0),(500614,13906,'es','Libras por 1000 umbrales para cubiertas',0),(500615,13906,'de','Lbs pro 1000 Cutoffs fÃ¼r Abdeckungen',0),(500616,13906,'en','Lbs. per 1000 Cutoffs for Covers',0),(500617,13907,'is','',0),(500618,13907,'dr','Ù¾Ø§Ù†Ø¯ Ø¯Ø± Ù‡Ø± 1000 Cutoffs Ø¨Ø±Ø§ÛŒ Ù¾Ø§Ú©ØªÙ‡Ø§',0),(500619,13907,'pr','Ù¾Ø§Ù†Ø¯ Ø¯Ø± Ù‡Ø± 1000 Cutoffs Ø¨Ø±Ø§ÛŒ Ù¾Ø§Ú©ØªÙ‡Ø§',0),(500620,13907,'tr','Libre baÅŸÄ±na 1000 Cutoffs zarflar iÃ§in',0),(500621,13907,'pl','Lbs. za 1000 spodenki dla kopert',0),(500622,13907,'bg','LBS. Ð½Ð° 1000 Cutoffs Ð·Ð° Ð¿Ð»Ð¸ÐºÐ¾Ð²Ðµ',0),(500623,13907,'ur','Ù„ÙØ§ÙÙˆÚº Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© ÛØ²Ø§Ø± Ú©ÙˆÙ¹ÙÙØ³ ÙÛŒ ØªØ¹Ø§Ù„ÛŒ',0),(500624,13907,'sr','Ð¢Ñ€Ð¸ÑÑ‚Ð° Ð¿Ð¾ 1000 Ð¾Ð´ Ñ„Ð°Ñ€Ð¼ÐµÑ€Ð¸Ñ†Ð° Ð·Ð° ÐºÐ¾Ð²ÐµÑ€Ñ‚Ðµ',0),(500625,13907,'vi','Lbs. má»—i 1000 Cutoffs cho phong bÃ¬',0),(500626,13907,'af','LBS. per 1000 Cutoffs vir koeverte',0),(500627,13907,'ro','Lbs. per 1000 Cutoffs pentru plicuri',0),(500628,13907,'et','Lbs. eest 1000 Cutoffs Ã¼mbrikud',0),(500629,13907,'si','Lbs. na 1000 Cutoffs za ovojnice',0),(500630,13907,'ba','Lbs. per 1000 celana pendek untuk amplop',0),(500631,13907,'nl','Lbs. per 1000 Cutoffs voor enveloppen',0),(500632,13907,'fi','Lbs. / 1000 muutokset Cutoffs kirjekuorille',0),(500633,13907,'no','Lbs. per 1000 konsentrasjon for konvolutter',0),(500634,13907,'da','Lbs. pr. 1000 Cutoffs for konvolutter',0),(500635,13907,'ko','ë´‰íˆ¬ì— ëŒ€ í•œ 1000 ì°¨ë‹¨ ë‹¹ íŒŒìš´ë“œ.',0),(500636,13907,'he','×§ ×’ ×œ×›×œ 1000 ×”×ž×›× ×¡×•× ×™× ×¢×‘×•×¨ ×ž×¢×˜×¤×•×ª',0),(500637,13907,'el','Î›Î¯Î²ÏÎµÏ‚ Î±Î½Î¬ 1000 Cutoffs Î³Î¹Î± Ï†Î±ÎºÎ­Î»Î¿Ï…Ï‚',0),(500638,13907,'zh','ç£…æ¯ 1000å¹´æ–­æµå™¨ä¿¡å°',0),(500639,13907,'sv','Lbs. per 1000 Cutoffs fÃ¶r kuvert',0),(500640,13907,'it','Libbre per ogni 1000 tagli per buste',0),(500641,13907,'tl','',0),(500642,13907,'th','à¸«à¸™à¹ˆà¸§à¸¢à¸›à¸­à¸™à¸”à¹Œà¸•à¹ˆà¸­ 1000 Cutoffs à¸šà¸™à¸‹à¸­à¸‡à¸ˆà¸”à¸«à¸¡à¸²à¸¢',0),(500643,13907,'hi','à¤²à¤¿à¤«à¤¼à¤¾à¤«à¤¼à¥‡ à¤•à¥‡ à¤²à¤¿à¤ 1000 Cutoffs à¤ªà¥à¤°à¤¤à¤¿ lbs.',0),(500644,13907,'ms','Lbs. setiap 1000 Cutoffs bagi sampul surat',0),(500645,13907,'ar','Ø±Ø·Ù„Ø§ ÙƒÙ„ Ù‚Ø·Ø¹ 1000 Ù„Ù„Ù…ØºÙ„ÙØ§Øª',0),(500646,13907,'fr','Lb / 1000 les seuils pour enveloppes',0),(500647,13907,'jp','å°ç­’ç”¨ 1000 Cutoffs ãƒãƒ³ãƒ‰',0),(500648,13907,'pt','Lbs por 1000 cortes para Envelopes',0),(500649,13907,'ru','Ð¤ÑƒÐ½Ñ‚Ð¾Ð² Ð·Ð° 1000 Ð¿Ñ€ÐµÐ´Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÐµÐ»Ð¸ Ð´Ð»Ñ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ð²',0),(500650,13907,'es','Libras por 1000 umbrales para sobres',0),(500651,13907,'de','Lbs pro 1000 Cutoffs fÃ¼r UmschlÃ¤ge',0),(500652,13907,'en','Lbs. per 1000 Cutoffs for Envelopes',0),(500653,13908,'is','',0),(500654,13908,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ú©Ø§Øª',0),(500655,13908,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ú©Ø§Øª',0),(500656,13908,'tr','Ã–deme notlarÄ±',0),(500657,13908,'pl','PÅ‚atnoÅ›ci notatki',0),(500658,13908,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð¿Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾',0),(500659,13908,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù†ÙˆÙ¹',0),(500660,13908,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ',0),(500661,13908,'vi','Thanh toÃ¡n ghi chÃº',0),(500662,13908,'af','Betaling notas',0),(500663,13908,'ro','Notele de platÄƒ',0),(500664,13908,'et','Makse mÃ¤rkmed',0),(500665,13908,'si','PlaÄilo opombe',0),(500666,13908,'ba','Catatan',0),(500667,13908,'nl','Betaling notities',0),(500668,13908,'fi','Maksun huomautukset',0),(500669,13908,'no','Betaling notater',0),(500670,13908,'da','Betaling noter',0),(500671,13908,'ko','ì§€ë¶ˆ ì •ë³´',0),(500672,13908,'he','×”×ª×©×œ×•× ×”×¢×¨×•×ª',0),(500673,13908,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î®',0),(500674,13908,'zh','ä»˜æ¬¾è¯´æ˜Ž',0),(500675,13908,'sv','Betalning anteckningar',0),(500676,13908,'it','Note di pagamento',0),(500677,13908,'tl','',0),(500678,13908,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(500679,13908,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¨à¥‹à¤Ÿà¥ à¤¸',0),(500680,13908,'ms','Nota-Nota pembayaran',0),(500681,13908,'ar','ÙˆØªÙ„Ø§Ø­Ø¸ Ø§Ù„Ø¯ÙØ¹',0),(500682,13908,'fr','Notes de paiement',0),(500683,13908,'jp','æ”¯æ‰•ãƒŽãƒ¼ãƒˆ',0),(500684,13908,'pt','Notas de pagamento',0),(500685,13908,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(500686,13908,'es','Notas de pago',0),(500687,13908,'de','Zahlung-Notes',0),(500688,13908,'en','Payment Notes',0),(500689,13909,'is','',0),(500690,13909,'dr','Ú©ÙˆÙ¾Ù† Ù¾Ø±Ø¯Ø§Ø®Øª',0),(500691,13909,'pr','Ú©ÙˆÙ¾Ù† Ù¾Ø±Ø¯Ø§Ø®Øª',0),(500692,13909,'tr','Ã–deme fiÅŸi',0),(500693,13909,'pl','Payment Voucher',0),(500694,13909,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(500695,13909,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ ÙˆØ§Ø¤Ú†Ø±',0),(500696,13909,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð·Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ñƒ',0),(500697,13909,'vi','Thanh toÃ¡n chá»©ng tá»«',0),(500698,13909,'af','Bewys van betaling',0),(500699,13909,'ro','PlatÄƒ Voucher',0),(500700,13909,'et','Tasumise kande',0),(500701,13909,'si','PlaÄilo kupona',0),(500702,13909,'ba','Voucher pembayaran',0),(500703,13909,'nl','Betaling Voucher',0),(500704,13909,'fi','Tositteen',0),(500705,13909,'no','Betaling bilag',0),(500706,13909,'da','Betaling kupon',0),(500707,13909,'ko','ì§€ë¶ˆ ë°”ìš°ì²˜',0),(500708,13909,'he','×”×ª×©×œ×•× ×‘×©×•×‘×¨ ×ª×©×œ×•×',0),(500709,13909,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(500710,13909,'zh','ä»˜æ¬¾å‡­è¯',0),(500711,13909,'sv','Betalningsverifikation',0),(500712,13909,'it','Pagamento Voucher',0),(500713,13909,'tl','',0),(500714,13909,'th','à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸ˆà¹ˆà¸²à¸¢',0),(500715,13909,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¾à¤‰à¤šà¤°',0),(500716,13909,'ms','Baucer bayaran',0),(500717,13909,'ar','Ù‚Ø³ÙŠÙ…Ø© Ø§Ù„Ø³Ø¯Ø§Ø¯',0),(500718,13909,'fr','PiÃ¨ce justificative de paiement',0),(500719,13909,'jp','æ”¯æ‰•ä¼ç¥¨',0),(500720,13909,'pt','Comprovante de pagamento',0),(500721,13909,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð½Ð¾Ð³Ð¾',0),(500722,13909,'es','Comprobante de pago',0),(500723,13909,'de','Zahlungsbeleg',0),(500724,13909,'en','Payment Voucher',0),(500725,13910,'is','',0),(500726,13910,'dr','Ø¢Ø¯Ø±Ø³/ÙØ§ÛŒÙ„ Ø¨Ø±Ø§ÛŒ Ù„ÙˆÚ¯Ùˆ',0),(500727,13910,'pr','Ø¢Ø¯Ø±Ø³/ÙØ§ÛŒÙ„ Ø¨Ø±Ø§ÛŒ Ù„ÙˆÚ¯Ùˆ',0),(500728,13910,'tr','URL/dosya iÃ§in Logo',0),(500729,13910,'pl','Plik/URL logo',0),(500730,13910,'bg','URL Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° Ð·Ð° Ð»Ð¾Ð³Ð¾',0),(500731,13910,'ur','Ø¹Ù„Ø§Ù…Øª (Ù„ÙˆÚ¯Ùˆ) Ú©Û’ Ù„ÛŒÛ’ URL/ÙØ§Ø¦Ù„',0),(500732,13910,'sr','Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð·Ð° Ð›Ð¾Ð³Ð¾',0),(500733,13910,'vi','URL/táº­p tin cho biá»ƒu tÆ°á»£ng',0),(500734,13910,'af','URL/lÃªer vir Logo',0),(500735,13910,'ro','URL-ul/fiÅŸier pentru logo-ul',0),(500736,13910,'et','URL/faili Logo',0),(500737,13910,'si','URL/datoteke za logotip',0),(500738,13910,'ba','URL/File untuk Logo',0),(500739,13910,'nl','URL/bestand voor Logo',0),(500740,13910,'fi','URL-osoitteen tai tiedoston Logo',0),(500741,13910,'no','URL/fil for Logo',0),(500742,13910,'da','URL/fil for Logo',0),(500743,13910,'ko','ë¡œê³ ì— ëŒ€ í•œ URL ë˜ëŠ” íŒŒì¼',0),(500744,13910,'he','×›×ª×•×‘×ª URL/×§×•×‘×¥ ×¢×‘×•×¨ ×œ×•×’×•',0),(500745,13910,'el','Î‘ÏÏ‡ÎµÎ¯Î¿/URL Î³Î¹Î± Ï„Î¿ Î»Î¿Î³ÏŒÏ„Ï…Ï€Î¿',0),(500746,13910,'zh','å¾½æ ‡çš„ URL/æ–‡ä»¶',0),(500747,13910,'sv','URL/fil fÃ¶r Logo',0),(500748,13910,'it','File/URL per Logo',0),(500749,13910,'tl','',0),(500750,13910,'th','URL/à¹„à¸Ÿà¸¥à¹Œ à¹‚à¸¥à¹‚à¸à¹‰',0),(500751,13910,'hi','à¤²à¥‹à¤—à¥‹ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¥‚à¤†à¤°à¤à¤²/à¤«à¤¼à¤¾à¤‡à¤²',0),(500752,13910,'ms','URL/fail logo',0),(500753,13910,'ar','URL/Ù…Ù„Ù Ù„Ù„Ø´Ø¹Ø§Ø±',0),(500754,13910,'fr','Fichier/URL pour Logo',0),(500755,13910,'jp','ãƒ­ã‚´ã® URL/ãƒ•ã‚¡ã‚¤ãƒ«',0),(500756,13910,'pt','Arquivo/URL para o logotipo',0),(500757,13910,'ru','Ð¤Ð°Ð¹Ð»/URL Ð´Ð»Ñ Ð»Ð¾Ð³Ð¾Ñ‚Ð¸Ð¿Ð°',0),(500758,13910,'es','URL/archivo de logotipo',0),(500759,13910,'de','URL/Datei fÃ¼r Logo',0),(500760,13910,'en','URL/File for Logo',0),(500761,13911,'is','',0),(500762,13911,'dr','ØªØºÛŒÛŒØ± Ù…Ø´ØªØ±ÛŒ',0),(500763,13911,'pr','ØªØºÛŒÛŒØ± Ù…Ø´ØªØ±ÛŒ',0),(500764,13911,'tr','MÃ¼ÅŸteri DeÄŸiÅŸtir',0),(500765,13911,'pl','Zmiana klienta',0),(500766,13911,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(500767,13911,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú¯Ø§ÛÚ©',0),(500768,13911,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ ÐºÑƒÐ¿Ñ†Ð°',0),(500769,13911,'vi','KhÃ¡ch hÃ ng thay Ä‘á»•i',0),(500770,13911,'af','Verandering kliÃ«nt',0),(500771,13911,'ro','Schimbare client',0),(500772,13911,'et','Muuda klienti',0),(500773,13911,'si','Zamenjaj kupca',0),(500774,13911,'ba','Perubahan pelanggan',0),(500775,13911,'nl','Klant wijzigen',0),(500776,13911,'fi','Vaihda asiakas',0),(500777,13911,'no','Skift kunde',0),(500778,13911,'da','Ã†ndring af kunden',0),(500779,13911,'ko','ë³€ê²½ ê³ ê°',0),(500780,13911,'he','×©×™× ×•×™ ×œ×§×•×—',0),(500781,13911,'el','Î‘Î»Î»Î±Î³Î® Ï€ÎµÎ»Î¬Ï„Î·',0),(500782,13911,'zh','æ›´æ”¹å®¢æˆ·',0),(500783,13911,'sv','Ã„ndra kund',0),(500784,13911,'it','Cambio cliente',0),(500785,13911,'tl','',0),(500786,13911,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(500787,13911,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(500788,13911,'ms','Pelanggan perubahan',0),(500789,13911,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(500790,13911,'fr','Changement de client',0),(500791,13911,'jp','å¤‰æ›´ã®é¡§å®¢',0),(500792,13911,'pt','Alterar cliente',0),(500793,13911,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(500794,13911,'es','El cambio al cliente',0),(500795,13911,'de','Debitor Ã¤ndern',0),(500796,13911,'en','Change Customer',0),(500797,13912,'is','',0),(500798,13912,'dr','Ù…Ø´ØªØ±ÛŒØ§Ù† Ú©Ù†ÙˆÙ†ÛŒ',0),(500799,13912,'pr','Ù…Ø´ØªØ±ÛŒØ§Ù† Ú©Ù†ÙˆÙ†ÛŒ',0),(500800,13912,'tr','GeÃ§erli mÃ¼ÅŸteri',0),(500801,13912,'pl','Obecnego klienta',0),(500802,13912,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(500803,13912,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ú©Ø³Ù¹Ù…Ø±',0),(500804,13912,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ ÐºÑƒÐ¿Ñ†Ð°',0),(500805,13912,'vi','KhÃ¡ch hÃ ng hiá»‡n táº¡i',0),(500806,13912,'af','Huidige KliÃ«nt',0),(500807,13912,'ro','Curent clientului',0),(500808,13912,'et','Praeguselt kliendilt',0),(500809,13912,'si','Trenutnemu kupcu',0),(500810,13912,'ba','Pelanggan saat ini',0),(500811,13912,'nl','Huidige klant',0),(500812,13912,'fi','Nykyinen asiakas',0),(500813,13912,'no','Gjeldende kunde',0),(500814,13912,'da','NuvÃ¦rende kunde',0),(500815,13912,'ko','í˜„ìž¬ ê³ ê°',0),(500816,13912,'he','×”×œ×§×•×— ×”× ×•×›×—×™',0),(500817,13912,'el','Î¤ÏÎ­Ï‡Î¿Î½Ï„Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(500818,13912,'zh','å½“å‰å®¢æˆ·',0),(500819,13912,'sv','Aktuell kund',0),(500820,13912,'it','Cliente attuale',0),(500821,13912,'tl','',0),(500822,13912,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(500823,13912,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(500824,13912,'ms','Pelanggan semasa',0),(500825,13912,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(500826,13912,'fr','Client actuel',0),(500827,13912,'jp','ç¾åœ¨ã®é¡§å®¢',0),(500828,13912,'pt','Cliente atual',0),(500829,13912,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(500830,13912,'es','Cliente actual',0),(500831,13912,'de','Aktuelle Kunden',0),(500832,13912,'en','Current Customer',0),(500833,13913,'is','',0),(500834,13913,'dr','Ù…Ø´ØªØ±ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ØªØºÛŒÛŒØ±',0),(500835,13913,'pr','Ù…Ø´ØªØ±ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ØªØºÛŒÛŒØ±',0),(500836,13913,'tr','MÃ¼ÅŸteri baÅŸarÄ±yla deÄŸiÅŸtirildi',0),(500837,13913,'pl','Klient pomyÅ›lnie zmieniony',0),(500838,13913,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(500839,13913,'ur','Ú¯Ø§ÛÚ© Ù†Û’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(500840,13913,'sr','ÐšÑƒÐ¿Ð°Ñ† Ñ˜Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(500841,13913,'vi','KhÃ¡ch hÃ ng thay Ä‘á»•i thÃ nh cÃ´ng',0),(500842,13913,'af','KliÃ«nt suksesvol verander',0),(500843,13913,'ro','Clientului schimbat cu succes',0),(500844,13913,'et','Klient muudetud',0),(500845,13913,'si','Stranke, ki so uspeÅ¡no',0),(500846,13913,'ba','Pelanggan yang berhasil diubah',0),(500847,13913,'nl','Klant met succes gewijzigd',0),(500848,13913,'fi','Asiakas vaihdettu',0),(500849,13913,'no','Kunden endret',0),(500850,13913,'da','Kunden skiftede med succes',0),(500851,13913,'ko','ì„±ê³µì ìœ¼ë¡œ ë³€ê²½ í•˜ëŠ” ê³ ê°',0),(500852,13913,'he','×œ×§×•×—×•×ª ×”×©×ª× ×” ×‘×”×¦×œ×—×”',0),(500853,13913,'el','Î ÎµÎ»Î¬Ï„Î· Î±Î»Î»Î¬Î¾ÎµÎ¹ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(500854,13913,'zh','å®¢æˆ·å·²æˆåŠŸæ›´æ”¹',0),(500855,13913,'sv','Kunden Ã¤ndrat framgÃ¥ngsrikt',0),(500856,13913,'it','Cliente cambiato con successo',0),(500857,13913,'tl','',0),(500858,13913,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(500859,13913,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¦à¤² à¤—à¤¯à¤¾',0),(500860,13913,'ms','Pelanggan yang berjaya diubah',0),(500861,13913,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ ØªØºÙŠÙŠØ±Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(500862,13913,'fr','Client changÃ© avec succÃ¨s',0),(500863,13913,'jp','æ­£å¸¸ã«å¤‰æ›´ã•ã‚ŒãŸé¡§å®¢',0),(500864,13913,'pt','Cliente alterado com sucesso',0),(500865,13913,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½',0),(500866,13913,'es','Cliente cambiado correctamente',0),(500867,13913,'de','Kunden, die erfolgreich geÃ¤ndert',0),(500868,13913,'en','Customer Changed Successfully',0),(500869,13914,'is','',0),(500870,13914,'dr','Ø®Ø·Ø§ Ù‡Ù†Ú¯Ø§Ù… Ø§ÙØ²ÙˆØ¯Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ ÙØ§Ú©ØªÙˆØ±',0),(500871,13914,'pr','Ø®Ø·Ø§ Ù‡Ù†Ú¯Ø§Ù… Ø§ÙØ²ÙˆØ¯Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ ÙØ§Ú©ØªÙˆØ±',0),(500872,13914,'tr','Fatura notlar ekleme hatasÄ±',0),(500873,13914,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas dodawania faktury Notes',0),(500874,13914,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(500875,13914,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÙˆÙ¹ÙˆÚº Ú©Û’ Ø§Ø¶Ø§ÙÛ Ù…ÛŒÚº Ù†Ù‚Øµ',0),(500876,13914,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(500877,13914,'vi','Lá»—i thÃªm hÃ³a Ä‘Æ¡n ghi chÃº',0),(500878,13914,'af','Fout faktuur notas by te voeg',0),(500879,13914,'ro','Eroare la adÄƒugarea de note de facturÄƒ',0),(500880,13914,'et','TÃµrge arve mÃ¤rkmete lisamine',0),(500881,13914,'si','Napaka pri dodajanju opombe raÄuna',0),(500882,13914,'ba','Kesalahan menambahkan catatan faktur',0),(500883,13914,'nl','Fout factuur notities toevoegen',0),(500884,13914,'fi','Virhe laskun huomautuksille',0),(500885,13914,'no','Feil under tillegging av faktura notater',0),(500886,13914,'da','Fejl ved tilfÃ¸jelse af faktura noter',0),(500887,13914,'ko','ì†¡ìž¥ ë…¸íŠ¸ ì¶”ê°€ ì˜¤ë¥˜',0),(500888,13914,'he','×©×’×™××” ×‘×¢×ª ×”×•×¡×¤×ª ×”×¢×¨×•×ª ×—×©×‘×•× ×™×ª',0),(500889,13914,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(500890,13914,'zh','æ·»åŠ å‘ç¥¨æ¸…å•æ—¶å‡ºé”™',0),(500891,13914,'sv','Fel att lÃ¤gga till faktura anteckningar',0),(500892,13914,'it','Errore aggiungendo note fattura',0),(500893,13914,'tl','',0),(500894,13914,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸‚à¸­à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(500895,13914,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(500896,13914,'ms','Ralat yang menambah Nota-Nota invois',0),(500897,13914,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(500898,13914,'fr','Erreur en ajoutant des informations sur la facture',0),(500899,13914,'jp','è«‹æ±‚æ›¸ãƒŽãƒ¼ãƒˆã®è¿½åŠ ã‚¨ãƒ©ãƒ¼',0),(500900,13914,'pt','Erro ao adicionar notas de factura',0),(500901,13914,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ð¸ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸ ÑÑ‡ÐµÑ‚Ð°',0),(500902,13914,'es','Error al agregar notas de factura',0),(500903,13914,'de','Fehler beim HinzufÃ¼gen der Rechnung Notizen',0),(500904,13914,'en','Error Adding Invoice Notes',0),(500905,13915,'is','',0),(500906,13915,'dr','Ù„Ø·ÙØ§ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø± Ø±ÙˆÛŒ Ú†Ú©',0),(500907,13915,'pr','Ù„Ø·ÙØ§ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø± Ø±ÙˆÛŒ Ú†Ú©',0),(500908,13915,'tr','Hesap numarasÄ±nÄ±n Ã§eke koyun lÃ¼tfen',0),(500909,13915,'pl','Podaj numer konta na wyboru',0),(500910,13915,'bg','ÐœÐ¾Ð»Ñ Ð¾Ñ‚Ð±ÐµÐ»ÐµÐ¶ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(500911,13915,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ú†ÛŒÚ© Ù¾Ø± ÚˆØ§Ù„ Ø¯ÛŒØ§',0),(500912,13915,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ, ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð½Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(500913,13915,'vi','Xin vui lÃ²ng Ä‘áº·t tÃ i khoáº£n sá»‘ vá» kiá»ƒm tra',0),(500914,13915,'af','Sit asseblief rekeningnommer op kontroleer',0),(500915,13915,'ro','VÄƒ rugÄƒm sÄƒ pune numarul de cont pe Check',0),(500916,13915,'et','Palun asetage kood sisse',0),(500917,13915,'si','Prosimo, da Å¡tevilko raÄuna na preverjanje',0),(500918,13915,'ba','Silakan memasukkan nomor akun pada cek',0),(500919,13915,'nl','Gelieve te zetten rekeningnummer op selectievakje',0),(500920,13915,'fi','Laittakaa tarkistaa tilin numero',0),(500921,13915,'no','Vennligst legg kontonummeret pÃ¥ sjekk',0),(500922,13915,'da','Venligst sÃ¦tte kontonummer pÃ¥ Check',0),(500923,13915,'ko','ì²´í¬ì— ê³„ì¢Œ ë²ˆí˜¸ë¥¼ ë„£ì–´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(500924,13915,'he','×‘×‘×§×©×” ×ª×©×™× ×ž×¡×¤×¨ ×—×©×‘×•×Ÿ ×¢×œ ×¡×™×ž×•×Ÿ',0),(500925,13915,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Î½Î± Î²Î¬Î»ÎµÏ„Îµ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î³Î¹Î± Î­Î»ÎµÎ³Ï‡Î¿',0),(500926,13915,'zh','è¯·å°†å¸å·æ”¾æ£€æŸ¥',0),(500927,13915,'sv','LÃ¤gg kontonummer pÃ¥ Check',0),(500928,13915,'it','Numero di conto si prega di mettere il Check',0),(500929,13915,'tl','',0),(500930,13915,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µà¹€à¸Šà¹‡à¸„',0),(500931,13915,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤° à¤œà¤¾à¤‚à¤š à¤¡à¤¾à¤²',0),(500932,13915,'ms','Sila masukkan nombor akaun pada Daftar',0),(500933,13915,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ÙˆØ¶Ø¹ Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ø¹Ù„Ù‰ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(500934,13915,'fr','S\'il vous plaÃ®t mettre numÃ©ro de compte sur chÃ¨que',0),(500935,13915,'jp','å£åº§ç•ªå·ãƒã‚§ãƒƒã‚¯ã‚’å…¥ã‚Œã¦ãã ã•ã„ã€‚',0),(500936,13915,'pt','Por favor, coloque o nÃºmero da conta no cheque',0),(500937,13915,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ð¾ÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð½Ð° Ñ‡ÐµÐºÐµ',0),(500938,13915,'es','Por favor, pÃ³nganse cheque nÃºmero de cuenta',0),(500939,13915,'de','Bitte setzen Sie Kontonummer auf Check',0),(500940,13915,'en','Please Put Account Number On Check',0),(500941,13916,'is','',0),(500942,13916,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(500943,13916,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(500944,13916,'tr','Stok maliyeti',0),(500945,13916,'pl','Koszt zapasÃ³w',0),(500946,13916,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(500947,13916,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(500948,13916,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(500949,13916,'vi','Chi phÃ­ hÃ ng tá»“n kho',0),(500950,13916,'af','Koste van voorraad',0),(500951,13916,'ro','ÃŽnreg. Cost stocuri',0),(500952,13916,'et','Varude maksumus',0),(500953,13916,'si','StroÅ¡ek zaloge',0),(500954,13916,'ba','Biaya persediaan',0),(500955,13916,'nl','Voorraadwaarde',0),(500956,13916,'fi','Varaston kustannus',0),(500957,13916,'no','Inventar kostnad',0),(500958,13916,'da','Lagerregulering',0),(500959,13916,'ko','ìž¬ê³  ë¹„ìš©',0),(500960,13916,'he','×¢×œ×•×ª ×”×ž×œ××™',0),(500961,13916,'el','ÎšÏŒÏƒÏ„Î¿Ï…Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(500962,13916,'zh','åº“å­˜æˆæœ¬',0),(500963,13916,'sv','Lagerkostnad',0),(500964,13916,'it','Costi di inventario',0),(500965,13916,'tl','',0),(500966,13916,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(500967,13916,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¥à¤°à¥€ à¤²à¤¾à¤—à¤¤',0),(500968,13916,'ms','Kos inventori',0),(500969,13916,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(500970,13916,'fr','CoÃ»t de l\'inventaire',0),(500971,13916,'jp','åœ¨åº«ã‚³ã‚¹ãƒˆ',0),(500972,13916,'pt','Custo de inventÃ¡rio',0),(500973,13916,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(500974,13916,'es','Coste de inventario',0),(500975,13916,'de','Lagerregulierung',0),(500976,13916,'en','Inventory Cost',0),(500977,13917,'is','',0),(500978,13917,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(500979,13917,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(500980,13917,'tr','YayÄ±nlanan numarasÄ±',0),(500981,13917,'pl','Numer wysÅ‚any',0),(500982,13917,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½',0),(500983,13917,'ur','Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø±',0),(500984,13917,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ',0),(500985,13917,'vi','Sá»‘ Ä‘Äƒng',0),(500986,13917,'af','Nommer gepos',0),(500987,13917,'ro','NumÄƒrul postat',0),(500988,13917,'et','Sisestatud number',0),(500989,13917,'si','Å tevilko, objavljeno',0),(500990,13917,'ba','Nomor diposting',0),(500991,13917,'nl','Aantal geplaatst',0),(500992,13917,'fi','Kirjattu numero',0),(500993,13917,'no','Antall postet',0),(500994,13917,'da','Antal indsendt',0),(500995,13917,'ko','ê²Œì‹œ ë²ˆí˜¸',0),(500996,13917,'he','×ž×¡×¤×¨ ×¤×•×¨×¡×',0),(500997,13917,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Ï€Î¿Ï… Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Ï„Î±Î¹',0),(500998,13917,'zh','è¿‡å¸çš„æ•°é‡',0),(500999,13917,'sv','Antal Inlagd',0),(501000,13917,'it','Numero inviato',0),(501001,13917,'tl','',0),(501002,13917,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸à¸²à¸£à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(501003,13917,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(501004,13917,'ms','Nombor yang diletakkan',0),(501005,13917,'ar','Ø¹Ø¯Ø¯ Ù†Ø´Ø±Øª',0),(501006,13917,'fr','NumÃ©ro de publication',0),(501007,13917,'jp','æŠ•ç¨¿æ•°',0),(501008,13917,'pt','NÃºmero Postado',0),(501009,13917,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(501010,13917,'es','NÃºmero publicado',0),(501011,13917,'de','Anzahl erschienen',0),(501012,13917,'en','Number Posted',0),(501013,13918,'is','',0),(501014,13918,'dr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(501015,13918,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(501016,13918,'tr','Deftere nakledilen Ã¶deme planlarÄ±',0),(501017,13918,'pl','PlanÃ³w pÅ‚atnoÅ›ci zostaÅ‚y zamieszczone',0),(501018,13918,'bg','Ð¡Ñ…ÐµÐ¼Ð¸ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÑÐ° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸',0),(501019,13918,'ur','Ù¾Û’ Ù…Ù†Ù¹ Ù¾Ù„Ø§Ù† Ù¾ÙˆØ³Ù¹ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(501020,13918,'sr','ÐŸÐ»Ð°Ð½ Ð¾Ñ‚Ð¿Ð»Ð°Ñ‚Ðµ ÑÑƒ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸.',0),(501021,13918,'vi','Káº¿ hoáº¡ch thanh toÃ¡n Ä‘Ã£ Ä‘Æ°á»£c Ä‘Äƒng',0),(501022,13918,'af','Betaling planne gepos is',0),(501023,13918,'ro','Au fost postate planuri de platÄƒ',0),(501024,13918,'et','Maksete plaanid Posted',0),(501025,13918,'si','PlaÄila naÄrti so bili napoteni',0),(501026,13918,'ba','Rencana pembayaran telah diposting',0),(501027,13918,'nl','Betaling plannen zijn geboekt',0),(501028,13918,'fi','Maksusuunnitelmat on kirjattu',0),(501029,13918,'no','Betalingsplaner er bokfÃ¸rt',0),(501030,13918,'da','Betaling planer er bogfÃ¸rt',0),(501031,13918,'ko','ì§€ë¶ˆ ê³„íš ê²Œì‹œ ë¨',0),(501032,13918,'he','×”×¡×“×¨×™ ×ª×©×œ×•×ž×™× × ×¨×©×ž×•',0),(501033,13918,'el','Î£Ï‡Î­Î´Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î­Ï‡Î¿Ï…Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¸ÎµÎ¯',0),(501034,13918,'zh','å·²è¿‡å¸ä»˜æ¬¾è®¡åˆ’',0),(501035,13918,'sv','Betalningsplaner har bokfÃ¶rts',0),(501036,13918,'it','Sono stati pubblicati i piani di pagamento',0),(501037,13918,'tl','',0),(501038,13918,'th','à¹à¸œà¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹„à¸”à¹‰à¸–à¸¹à¸à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(501039,13918,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾ à¤¤à¥ˆà¤¨à¤¾à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(501040,13918,'ms','Pelan pembayaran telah hantar',0),(501041,13918,'ar','ÙˆÙ‚Ø¯ ÙˆØ¶Ø¹Øª Ø®Ø·Ø· Ù„Ù„Ø³Ø¯Ø§Ø¯',0),(501042,13918,'fr','Plans de paiement ont Ã©tÃ© affichÃ©s',0),(501043,13918,'jp','ãŠæ”¯æ‰•ã„ãƒ—ãƒ©ãƒ³ã‚’æŽ²è¼‰ã—ã¦ã„ã¾ã™ã€‚',0),(501044,13918,'pt','Planos de pagamento tem sido postados',0),(501045,13918,'ru','Ð‘Ñ‹Ð»Ð¸ Ð¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ñ‹ Ð¿Ð»Ð°Ð½Ñ‹ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚',0),(501046,13918,'es','Planes de pago han sido escritos',0),(501047,13918,'de','ZahlungsplÃ¤ne wurden verÃ¶ffentlicht',0),(501048,13918,'en','Payment Plans Have Been Posted',0),(501049,13919,'is','',0),(501050,13919,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù‚ÛŒÙ…Øª',0),(501051,13919,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù‚ÛŒÙ…Øª',0),(501052,13919,'tr','Fiyat detay',0),(501053,13919,'pl','Cena detal',0),(501054,13919,'bg','Ð¦ÐµÐ½Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚',0),(501055,13919,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ØªÙØµÛŒÙ„',0),(501056,13919,'sr','Ð¦ÐµÐ½Ð° Ð´ÐµÑ‚Ð°Ñ™',0),(501057,13919,'vi','GiÃ¡ chi tiáº¿t',0),(501058,13919,'af','Prys Detail',0),(501059,13919,'ro','Detalii Pret',0),(501060,13919,'et','Hind Detail',0),(501061,13919,'si','Cena podrobnosti',0),(501062,13919,'ba','Harga Detail',0),(501063,13919,'nl','Prijs Detail',0),(501064,13919,'fi','Hinta yksityiskohtia',0),(501065,13919,'no','Pris detaljer',0),(501066,13919,'da','Pris detaljer',0),(501067,13919,'ko','ê°€ê²© ì„¸ë¶€ ì‚¬í•­',0),(501068,13919,'he','×¤×™×¨×•×˜ ×”×ž×—×™×¨',0),(501069,13919,'el','Î¤Î¹Î¼Î® Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(501070,13919,'zh','ä»·æ ¼çš„ç»†èŠ‚',0),(501071,13919,'sv','Pris detalj',0),(501072,13919,'it','Prezzo dettaglio',0),(501073,13919,'tl','',0),(501074,13919,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸£à¸²à¸„à¸²',0),(501075,13919,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(501076,13919,'ms','Harga terperinci',0),(501077,13919,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(501078,13919,'fr','DÃ©tail de prix',0),(501079,13919,'jp','ä¾¡æ ¼ã®è©³ç´°',0),(501080,13919,'pt','Detalhes do preÃ§o',0),(501081,13919,'ru','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ Ñ†ÐµÐ½Ð°',0),(501082,13919,'es','Precio detalle',0),(501083,13919,'de','Preis Details',0),(501084,13919,'en','Price Detail',0),(501085,13920,'is','',0),(501086,13920,'dr','Ù¾Ø§Ú©Øª',0),(501087,13920,'pr','Ù¾Ø§Ú©Øª',0),(501088,13920,'tr','Zarflar',0),(501089,13920,'pl','Koperty',0),(501090,13920,'bg','ÐŸÐ»Ð¸ÐºÐ¾Ð²Ðµ',0),(501091,13920,'ur','Ù„ÙØ§ÙÛ’',0),(501092,13920,'sr','ÐšÐ¾Ð²ÐµÑ€Ñ‚Ðµ',0),(501093,13920,'vi','Phong bÃ¬',0),(501094,13920,'af','Koeverte',0),(501095,13920,'ro','Plicuri',0),(501096,13920,'et','Ãœmbrikud',0),(501097,13920,'si','Ovojnice',0),(501098,13920,'ba','Amplop',0),(501099,13920,'nl','Enveloppen',0),(501100,13920,'fi','Kirjekuoret',0),(501101,13920,'no','Konvolutter',0),(501102,13920,'da','Konvolutter',0),(501103,13920,'ko','ë´‰íˆ¬',0),(501104,13920,'he','×ž×¢×˜×¤×•×ª',0),(501105,13920,'el','Î¦Î¬ÎºÎµÎ»Î¿Î¹',0),(501106,13920,'zh','ä¿¡å°',0),(501107,13920,'sv','Kuvert',0),(501108,13920,'it','Buste',0),(501109,13920,'tl','',0),(501110,13920,'th','à¸‹à¸­à¸‡à¸ˆà¸”à¸«à¸¡à¸²à¸¢',0),(501111,13920,'hi','à¤²à¤¿à¤«à¤¾à¤«à¥‡',0),(501112,13920,'ms','Sampul surat',0),(501113,13920,'ar','Ù…ØºÙ„ÙØ§Øª',0),(501114,13920,'fr','Enveloppes',0),(501115,13920,'jp','å°ç­’',0),(501116,13920,'pt','Envelopes',0),(501117,13920,'ru','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚Ñ‹',0),(501118,13920,'es','Sobres',0),(501119,13920,'de','UmschlÃ¤ge',0),(501120,13920,'en','Envelopes',0),(501121,13921,'is','',0),(501122,13921,'dr','Ù¾Ø§Ú©Øª Ø¯Ø± Ù‡Ø± Ú©ØªØ§Ø¨',0),(501123,13921,'pr','Ù¾Ø§Ú©Øª Ø¯Ø± Ù‡Ø± Ú©ØªØ§Ø¨',0),(501124,13921,'tr','Zarflarda kitap baÅŸÄ±',0),(501125,13921,'pl','Koperty na ksiÄ…Å¼ki',0),(501126,13921,'bg','ÐŸÐ»Ð¸ÐºÐ¾Ð²Ðµ Ð·Ð° ÐºÐ½Ð¸Ð³Ð°',0),(501127,13921,'ur','Ú©ØªØ§Ø¨ ÙÛŒ Ù„ÙØ§ÙÛ’',0),(501128,13921,'sr','ÐšÐ¾Ð²ÐµÑ€Ñ‚Ðµ Ð¿Ð¾ ÐºÑšÐ¸Ð·Ð¸',0),(501129,13921,'vi','Phong bÃ¬ má»™t cuá»‘n sÃ¡ch',0),(501130,13921,'af','Koeverte Per boek',0),(501131,13921,'ro','Plicuri pe carte',0),(501132,13921,'et','Ãœmbrikud iga raamatu kohta',0),(501133,13921,'si','Na knjigo ovojnic',0),(501134,13921,'ba','Amplop Per buku',0),(501135,13921,'nl','Enveloppen Per boek',0),(501136,13921,'fi','Kirjekuoret / kirja',0),(501137,13921,'no','Konvolutter Per bok',0),(501138,13921,'da','Kuverter pr. bog',0),(501139,13921,'ko','ë„ ì„œ ë‹¹ ë´‰íˆ¬',0),(501140,13921,'he','×ž×¢×˜×¤×•×ª ×œ×¤×™ ×”×¡×¤×¨',0),(501141,13921,'el','Î¦Î¬ÎºÎµÎ»Î¿Î¹ Î±Î½Î¬ Î²Î¹Î²Î»Î¯Î¿',0),(501142,13921,'zh','æ¯æœ¬ä¹¦çš„ä¿¡å°',0),(501143,13921,'sv','Kuvert Per bok',0),(501144,13921,'it','Buste Per libro',0),(501145,13921,'tl','',0),(501146,13921,'th','à¸‹à¸­à¸‡à¸•à¹ˆà¸­à¸«à¸™à¸±à¸‡à¸ªà¸·à¸­',0),(501147,13921,'hi','à¤ªà¥à¤¸à¥à¤¤à¤• à¤ªà¥à¤°à¤¤à¤¿ à¤²à¤¿à¤«à¤¾à¤«à¥‡',0),(501148,13921,'ms','Sampul buku',0),(501149,13921,'ar','Ù…ØºÙ„ÙØ§Øª ÙƒÙ„ ÙƒØªØ§Ø¨',0),(501150,13921,'fr','Enveloppes par livre',0),(501151,13921,'jp','1 æœ¬ã‚ãŸã‚Šã®å°ç­’',0),(501152,13921,'pt','Envelopes por livro',0),(501153,13921,'ru','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚Ñ‹ Ð·Ð° ÐºÐ½Ð¸Ð³Ñƒ',0),(501154,13921,'es','Sobres por libro',0),(501155,13921,'de','BriefumschlÃ¤ge pro Buch',0),(501156,13921,'en','Envelopes Per Book',0),(501157,13922,'is','',0),(501158,13922,'dr','Ù…Ù†Ø¸Ù…',0),(501159,13922,'pr','Ù…Ù†Ø¸Ù…',0),(501160,13922,'tr','DÃ¼zenli',0),(501161,13922,'pl','Regularne',0),(501162,13922,'bg','Ð ÐµÐ´Ð¾Ð²Ð½Ð¸',0),(501163,13922,'ur','Ø¨Ø§Ù‚Ø§Ø¹Ø¯Û',0),(501164,13922,'sr','Ð ÐµÐ´Ð¾Ð²Ð½Ðµ',0),(501165,13922,'vi','ThÆ°á»ng xuyÃªn',0),(501166,13922,'af','Gereelde',0),(501167,13922,'ro','Regulate',0),(501168,13922,'et','Regulaarne',0),(501169,13922,'si','Redno',0),(501170,13922,'ba','Reguler',0),(501171,13922,'nl','Regelmatige',0),(501172,13922,'fi','SÃ¤Ã¤nnÃ¶llisesti',0),(501173,13922,'no','Vanlig',0),(501174,13922,'da','RegelmÃ¦ssig',0),(501175,13922,'ko','ì¼ë°˜',0),(501176,13922,'he','×¨×’×™×œ',0),(501177,13922,'el','Î¤Î±ÎºÏ„Î¹ÎºÎ®',0),(501178,13922,'zh','å®šæœŸ',0),(501179,13922,'sv','Regelbundna',0),(501180,13922,'it','Regolari',0),(501181,13922,'tl','',0),(501182,13922,'th','à¸›à¸à¸•à¸´',0),(501183,13922,'hi','à¤¨à¤¿à¤¯à¤®à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡',0),(501184,13922,'ms','Tetap',0),(501185,13922,'ar','Ø§Ù„Ø¹Ø§Ø¯ÙŠØ©',0),(501186,13922,'fr','RÃ©gulier',0),(501187,13922,'jp','æ­£è¦',0),(501188,13922,'pt','Regular',0),(501189,13922,'ru','Ð ÐµÐ³ÑƒÐ»ÑÑ€Ð½Ñ‹Ðµ',0),(501190,13922,'es','Regular',0),(501191,13922,'de','RegelmÃ¤ÃŸige',0),(501192,13922,'en','Regular',0),(501193,13923,'is','',0),(501194,13923,'dr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø§Ø±ØªÙ‚Ø§Ø¡ Ø±Ø³ØªÚ¯Ø§Ø±',0),(501195,13923,'pr','Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ø§Ø±ØªÙ‚Ø§Ø¡ Ø±Ø³ØªÚ¯Ø§Ø±',0),(501196,13923,'tr','YÃ¼kseltme iÃ§in geliÅŸmek iÃ§in tÄ±klayÄ±nÄ±z',0),(501197,13923,'pl','Kliknij tutaj, aby uaktualniÄ‡ wobec rozwijaÄ‡',0),(501198,13923,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº, Ð·Ð° Ð´Ð° ÑŠÐ¿Ð³Ñ€ÐµÐ¹Ð´ Ð´Ð° Ð¿Ñ€Ð¾ÑÐ¿ÐµÑ€Ð¸Ñ€Ð°',0),(501199,13923,'ur','ÙÙ„Ø§Ø­ Ú©Û’ Ù„Ø¦Û’ Ù¾ÛŒØ´ Ù‚Ø¯Ù…ÛŒ Ú©Û’ Ù„ÛŒÛ’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(501200,13923,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð½Ð°Ð´Ð¾Ð³Ñ€Ð°Ð´ÑšÑƒ Ð´Ð° Ð½Ð°Ð¿Ñ€ÐµÐ´ÑƒÑ˜Ñƒ',0),(501201,13923,'vi','Click vÃ o Ä‘Ã¢y Ä‘á»ƒ nÃ¢ng cáº¥p Ä‘á»ƒ thá»‹nh vÆ°á»£ng',0),(501202,13923,'af','Klik hier om sy bydrae tot Vrystaatrugby opgradering',0),(501203,13923,'ro','Click aici pentru a face Upgrade sÄƒ prospere',0),(501204,13923,'et','Vajuta siia, et uuendada Ãµitseda',0),(501205,13923,'si','Kliknite tukaj za nadgradnjo na Prosper',0),(501206,13923,'ba','Klik di sini untuk Upgrade ke Prosper',0),(501207,13923,'nl','Klik hier om te upgraden tot bloei',0),(501208,13923,'fi','Klikkaa tÃ¤stÃ¤ pÃ¤ivittÃ¤Ã¤ Prosper',0),(501209,13923,'no','Klikk her for Ã¥ oppgradere Ã¥ blomstre',0),(501210,13923,'da','Klik her for at opgradere til Prosper',0),(501211,13923,'ko','ë²ˆì˜ë¡œ ì—…ê·¸ë ˆì´ ë“œ í•˜ë ¤ë©´ ì—¬ê¸°ë¥¼ í´ë¦­í•©ë‹ˆë‹¤',0),(501212,13923,'he','×œ×—×¥ ×›××Ÿ ×›×“×™ ×œ×©×“×¨×’ ×œ×©×’×©×’',0),(501213,13923,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î½Î± Î±Î½Î±Î²Î¬Î¸Î¼Î¹ÏƒÎ· Î½Î± ÎµÏ…Î·Î¼ÎµÏÎ®ÏƒÎ¿Ï…Î½',0),(501214,13923,'zh','ç‚¹å‡»è¿™é‡Œåˆ°ç¹è£çš„å‡çº§',0),(501215,13923,'sv','Klicka hÃ¤r fÃ¶r att uppgradera till Prosper',0),(501216,13923,'it','Clicca qui per l\'aggiornamento a prosperare',0),(501217,13923,'tl','',0),(501218,13923,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸›à¸£à¸±à¸šà¸£à¸¸à¹ˆà¸™à¸ à¸´à¸à¹‚à¸',0),(501219,13923,'hi','à¤¸à¤®à¥ƒà¤¦à¥à¤§ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤µà¥€à¤¨à¥€à¤•à¤°à¤£ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(501220,13923,'ms','Klik di sini untuk menaik-taraf senang',0),(501221,13923,'ar','Ø§Ø¶ØºØ· Ù‡Ù†Ø§ Ù„ØªØ±Ù‚ÙŠØ© Ø§Ù„Ø§Ø²Ø¯Ù‡Ø§Ø±',0),(501222,13923,'fr','Cliquez ici pour mettre Ã  niveau Ã  prospÃ©rer',0),(501223,13923,'jp','ç¹æ „ã¸ã®ã‚¢ãƒƒãƒ—ã‚°ãƒ¬ãƒ¼ãƒ‰ã«ã¯ã“ã“ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™ã€‚',0),(501224,13923,'pt','Clique aqui para atualizar para prosperar',0),(501225,13923,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ñ†Ð²ÐµÑ‚Ð°Ñ‚ÑŒ',0),(501226,13923,'es','Haga clic aquÃ­ para actualizar a prosperar',0),(501227,13923,'de','Klicken Sie hier fÃ¼r eine Aktualisierung auf Prosper',0),(501228,13923,'en','Click Here To Upgrade To Prosper',0),(501229,13924,'is','',0),(501230,13924,'dr','ØªØ®ÙÛŒÙ Ø¨Ø³ØªÙ‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±ÛŒ',0),(501231,13924,'pr','ØªØ®ÙÛŒÙ Ø¨Ø³ØªÙ‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±ÛŒ',0),(501232,13924,'tr','Indirimli paketler',0),(501233,13924,'pl','Rabat wiÄ…zki',0),(501234,13924,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð²Ñ€ÑŠÐ·ÐºÐ¸',0),(501235,13924,'ur','ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†ÚˆÙ„Ø²',0),(501236,13924,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° ÑÐ½Ð¾Ð¿Ð¾Ð²Ðµ',0),(501237,13924,'vi','Giáº£m giÃ¡ bÃ³',0),(501238,13924,'af','Afslag bundels',0),(501239,13924,'ro','Reducere pachete',0),(501240,13924,'et','Soodus kimbud',0),(501241,13924,'si','Popust sveÅ¾njev',0),(501242,13924,'ba','Diskon terbaik bundel untuk',0),(501243,13924,'nl','Goedkope bundels',0),(501244,13924,'fi','Alennus nippuja',0),(501245,13924,'no','Rabatt pakker',0),(501246,13924,'da','Discount bundter',0),(501247,13924,'ko','ë²ˆë“¤ í• ì¸',0),(501248,13924,'he','×”× ×—×” ×—×‘×™×œ×•×ª',0),(501249,13924,'el','Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Î´Î­ÏƒÎ¼ÎµÏ‚',0),(501250,13924,'zh','æŠ˜æ‰£æŸ',0),(501251,13924,'sv','Rabatt buntar',0),(501252,13924,'it','Sconto bundle',0),(501253,13924,'tl','',0),(501254,13924,'th','à¸¥à¸”à¸à¸²à¸£à¸£à¸§à¸¡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(501255,13924,'hi','à¤¬à¤‚à¤¡à¤²à¥‹à¤‚ à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ',0),(501256,13924,'ms','Diskaun pakej',0),(501257,13924,'ar','Ø®ØµÙ… Ø­Ø²Ù…',0),(501258,13924,'fr','Remise des faisceaux',0),(501259,13924,'jp','ãƒãƒ³ãƒ‰ãƒ«ã‚’å‰²å¼•ã—ã¾ã™ã€‚',0),(501260,13924,'pt','Desconto pacotes',0),(501261,13924,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ¸ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ñ‹',0),(501262,13924,'es','Paquetes y ofertas',0),(501263,13924,'de','GÃ¼nstige Bundles',0),(501264,13924,'en','Discount Bundles',0),(501265,13925,'is','',0),(501266,13925,'dr','ØªØ¬Ø§Ø±Øª Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ© &amp; CRM',0),(501267,13925,'pr','ØªØ¬Ø§Ø±Øª Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ© &amp; CRM',0),(501268,13925,'tr','E-ticaret & CRM',0),(501269,13925,'pl','E-commerce & CRM',0),(501270,13925,'bg','Ð•Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²Ð¸Ñ & CRM',0),(501271,13925,'ur','Ecommerce & Ú©',0),(501272,13925,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð½Ð¸Ñ†Ð° & Ð¦Ð Ðœ',0),(501273,13925,'vi','ThÆ°Æ¡ng máº¡i Ä‘iá»‡n tá»­ &amp; CRM',0),(501274,13925,'af','E-handel & CRM',0),(501275,13925,'ro','ECommerce & CRM',0),(501276,13925,'et','E-kaubanduse & CRM',0),(501277,13925,'si','ECommerce & CRM',0),(501278,13925,'ba','E-commerce & CRM',0),(501279,13925,'nl','E-commerce & CRM',0),(501280,13925,'fi','Verkkokaupan & CRM',0),(501281,13925,'no','ECommerce & CRM',0),(501282,13925,'da','ECommerce & CRM',0),(501283,13925,'ko','ì „ìž ìƒê±°ëž˜ & CRM',0),(501284,13925,'he','CRM & ×ž×¡×—×¨ ××œ×§×˜×¨×•× ×™',0),(501285,13925,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ ÎµÎ¼Ï€ÏŒÏÎ¹Î¿ & CRM',0),(501286,13925,'zh','ç”µå­å•†åŠ¡ &amp; CRM',0),(501287,13925,'sv','E-handel & CRM',0),(501288,13925,'it','CRM di e-commerce &',0),(501289,13925,'tl','',0),(501290,13925,'th','à¸­à¸µà¸„à¸­à¸¡à¹€à¸¡à¸´à¸£à¹Œà¸‹ & CRM',0),(501291,13925,'hi','Ecommerce & CRM',0),(501292,13925,'ms','E-dagang & CRM',0),(501293,13925,'ar','CRM Ø¢Ù†Ø¯ Ø§Ù„ØªØ¬Ø§Ø±Ø© Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠØ©',0),(501294,13925,'fr','ECommerce & CRM',0),(501295,13925,'jp','E ã‚³ãƒžãƒ¼ã‚¹ & CRM',0),(501296,13925,'pt','Ecommerce & CRM',0),(501297,13925,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ ÐºÐ¾Ð¼Ð¼ÐµÑ€Ñ†Ð¸Ð¸ & CRM',0),(501298,13925,'es','Ecommerce &amp; CRM',0),(501299,13925,'de','E-Commerce- & -CRM',0),(501300,13925,'en','Ecommerce & CRM',0),(501301,13926,'is','',0),(501302,13926,'dr','Ø§Ø±ØªÙ‚Ø§Ø¡ Ø±Ø³ØªÚ¯Ø§Ø±',0),(501303,13926,'pr','Ø§Ø±ØªÙ‚Ø§Ø¡ Ø±Ø³ØªÚ¯Ø§Ø±',0),(501304,13926,'tr','YÃ¼kseltme baÅŸarÄ±lÄ± ol',0),(501305,13926,'pl','Uaktualnienie do Prosper',0),(501306,13926,'bg','ÐÐ°Ð´ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð° Ð¿Ñ€Ð¾ÑÐ¿ÐµÑ€Ð¸Ñ‚ÐµÑ‚Ð° Ð½Ð°',0),(501307,13926,'ur','ÙÙ„Ø§Ø­ Ú©Û’ Ù„Ø¦Û’ Ø§Ù¾ Ú¯Ø±ÛŒÚˆ',0),(501308,13926,'sr','ÐÐ°Ð´Ð¾Ð³Ñ€Ð°Ð´ÑšÐ° Ð´Ð° Ð½Ð°Ð¿Ñ€ÐµÐ´ÑƒÑ˜Ñƒ',0),(501309,13926,'vi','NÃ¢ng cáº¥p Ä‘á»ƒ thá»‹nh vÆ°á»£ng',0),(501310,13926,'af','Opgradering tot Vrystaatrugby',0),(501311,13926,'ro','Upgrade-ul sÄƒ prospere',0),(501312,13926,'et','Uuendage Ãµitseda',0),(501313,13926,'si','Nadgradnja za blaginjo',0),(501314,13926,'ba','Upgrade ke Prosper',0),(501315,13926,'nl','Upgrade naar Prosper',0),(501316,13926,'fi','Ksi Prosper',0),(501317,13926,'no','Oppgradering til Prosper',0),(501318,13926,'da','Opgradering til Prosper',0),(501319,13926,'ko','ë²ˆì˜ë¡œ ì—…ê·¸ë ˆì´ë“œ',0),(501320,13926,'he','×©×“×¨×•×’ ×œ×©×’×©×’',0),(501321,13926,'el','Î‘Î½Î±Î²Î¬Î¸Î¼Î¹ÏƒÎ· Î½Î± ÎµÏ…Î·Î¼ÎµÏÎ®ÏƒÎ¿Ï…Î½',0),(501322,13926,'zh','å‡çº§æˆåŠŸ',0),(501323,13926,'sv','Uppgradering till Prosper',0),(501324,13926,'it','Aggiornamento a prosperare',0),(501325,13926,'tl','',0),(501326,13926,'th','à¸£à¸¸à¹ˆà¸™à¸ à¸´à¸à¹‚à¸',0),(501327,13926,'hi','à¤¸à¤®à¥ƒà¤¦à¥à¤§ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤µà¥€à¤¨à¥€à¤•à¤°à¤£',0),(501328,13926,'ms','Naik taraf untuk maju',0),(501329,13926,'ar','Ø§Ù„ØªØ±Ù‚ÙŠØ© Ø§Ù„Ø§Ø²Ø¯Ù‡Ø§Ø±',0),(501330,13926,'fr','Mise Ã  niveau de prospÃ©rer',0),(501331,13926,'jp','ç¹æ „ã¸ã®ã‚¢ãƒƒãƒ—ã‚°ãƒ¬ãƒ¼ãƒ‰',0),(501332,13926,'pt','Upgrade para prosperar',0),(501333,13926,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¾Ñ†Ð²ÐµÑ‚Ð°Ñ‚ÑŒ',0),(501334,13926,'es','ActualizaciÃ³n a prosperar',0),(501335,13926,'de','Upgrade zu gedeihen',0),(501336,13926,'en','Upgrade To Prosper',0),(501337,13927,'is','',0),(501338,13927,'dr','ØªÙˆØ¯Ù‡ ÙˆÛŒØ±Ø§ÛŒØ´ Ø¹Ø¯Ù… ØªØ¹Ø§Ø¯Ù„',0),(501339,13927,'pr','ØªÙˆØ¯Ù‡ ÙˆÛŒØ±Ø§ÛŒØ´ Ø¹Ø¯Ù… ØªØ¹Ø§Ø¯Ù„',0),(501340,13927,'tr','Toplu dÃ¼zenleme dengelemek baÅŸarÄ±sÄ±z oldu',0),(501341,13927,'pl','Masowej edycji udaÅ‚o siÄ™ zrÃ³wnowaÅ¼yÄ‡',0),(501342,13927,'bg','ÐœÐ°ÑÐ° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ðµ ÑƒÑÐ¿Ñ Ð´Ð° ÑÐµ Ð±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð°Ñ‚',0),(501343,13927,'ur','Ø¨Ú‘Û’ Ù¾ÛŒÙ…Ø§Ù†Û’ Ù¾Ø± ØªØ¯ÙˆÛŒÙ† ØªÙˆØ§Ø²Ù† Ù‚Ø§Ø¦Ù… Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛÛ’',0),(501344,13927,'sr','ÐœÐ°ÑÐ¾Ð²Ð½Ð¾ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÐ»Ð¾ ÑÐ°Ð»Ð´Ð¾',0),(501345,13927,'vi','Chá»‰nh sá»­a hÃ ng loáº¡t tháº¥t báº¡i trong viá»‡c cÃ¢n báº±ng',0),(501346,13927,'af','Massa redigeer kon balanseer',0),(501347,13927,'ro','Editare masÄƒ nu a reuÅŸit sÄƒ echilibreze',0),(501348,13927,'et','Massilise Edit suutnud tasakaalustada',0),(501349,13927,'si','MnoÅ¾iÄno urejanje uspelo ravnovesje',0),(501350,13927,'ba','Edit massa gagal untuk menyeimbangkan',0),(501351,13927,'nl','Massa bewerken om evenwicht te brengen is mislukt',0),(501352,13927,'fi','Massasta Edit epÃ¤onnistui tasapaino',0),(501353,13927,'no','Masse Edit mislyktes Ã¥ balansere',0),(501354,13927,'da','Masse Rediger undladt at Balance',0),(501355,13927,'ko','ëŒ€ëŸ‰ íŽ¸ì§‘ ê· í˜• ì‹¤íŒ¨',0),(501356,13927,'he','×¢×¨×™×›×” ×”×ž×•× ×™×ª ×œ× ×”×¦×œ×™×— ×œ××–×Ÿ',0),(501357,13927,'el','ÎœÎ±Î¶Î¹ÎºÎ® ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Ï€Î­Ï„Ï…Ï‡Îµ Î½Î± Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±',0),(501358,13927,'zh','æ‰¹é‡ç¼–è¾‘å¤±è´¥æ¥å¹³è¡¡',0),(501359,13927,'sv','Det gick inte att balansera massa redigera',0),(501360,13927,'it','Modifica di massa non Ã¨ riuscito a bilanciare',0),(501361,13927,'tl','',0),(501362,13927,'th','à¹à¸à¹‰à¹„à¸‚à¹‚à¸”à¸¢à¸£à¸§à¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§à¸”à¸¸à¸¥',0),(501363,13927,'hi','à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¨ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(501364,13927,'ms','Jisim Edit yang gagal untuk baki',0),(501365,13927,'ar','ÙØ´Ù„ ÙÙŠ ØªØ­Ø±ÙŠØ± Ø¬Ù…Ø§Ø¹ÙŠ Ù„ØªØ­Ù‚ÙŠÙ‚ Ø§Ù„ØªÙˆØ§Ø²Ù† Ø¨ÙŠÙ†',0),(501366,13927,'fr','Edit de masse n\'a pas d\'Ã©quilibrer',0),(501367,13927,'jp','ä¸€æ‹¬ç·¨é›†ã®ãƒãƒ©ãƒ³ã‚¹ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(501368,13927,'pt','Editar em massa nÃ£o conseguiu equilibrar',0),(501369,13927,'ru','ÐœÐ°ÑÑÐ¾Ð²Ð¾Ð³Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ ÑÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(501370,13927,'es','EdiciÃ³n masiva no ha podido equilibrar',0),(501371,13927,'de','Mass Edit Failed To Balance',0),(501372,13927,'en','Mass Edit Failed To Balance',0),(501373,13928,'is','',0),(501374,13928,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù…ÙˆØ±Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø«Ø§Ø¨Øª Ù‡Ø²ÛŒÙ†Ù‡',0),(501375,13928,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù…ÙˆØ±Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø«Ø§Ø¨Øª Ù‡Ø²ÛŒÙ†Ù‡',0),(501376,13928,'tr','VarsayÄ±lan madde maliyetlerinin statik maliyet',0),(501377,13928,'pl','DomyÅ›lnie element kosztÃ³w do kosztÃ³w statyczne',0),(501378,13928,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÐºÑŠÐ¼ ÑÑ‚Ð°Ñ‚Ð¸Ñ‡Ð½Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(501379,13928,'ur','Ø·Û’ Ø´Ø¯Û Ø´Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø¬Ø§Ù…Ø¯ Ù„Ø§Ú¯Øª',0),(501380,13928,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ñƒ ÑÑ‚Ð°Ñ‚Ð¸Ñ‡ÐºÐ¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(501381,13928,'vi','Chi phÃ­ má»¥c máº·c Ä‘á»‹nh Ä‘á»ƒ tÄ©nh chi phÃ­',0),(501382,13928,'af','Verstek Item koste om statiese koste',0),(501383,13928,'ro','Costurile de element implicit Cost statice',0),(501384,13928,'et','Vaikimisi kauba kulud staatiline kulu',0),(501385,13928,'si','Privzeti element stroÅ¡kov statiÄno stroÅ¡ki',0),(501386,13928,'ba','Default Item biaya biaya statis',0),(501387,13928,'nl','Standaarditem kosten aan statische kosten',0),(501388,13928,'fi','Oletuksena nimikekustannukset staattinen kustannukset',0),(501389,13928,'no','Standard kostnader statisk kostnader',0),(501390,13928,'da','Standard vareomkostninger statisk omkostninger',0),(501391,13928,'ko','ê¸°ë³¸ í•­ëª© ë¹„ìš© ê³ ì • ë¹„ìš©ì„',0),(501392,13928,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×œ×•×™×•×ª ×¤×¨×™×˜ ×œ×¢×œ×•×ª ×¡×˜×˜×™',0),(501393,13928,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÏƒÏ„Î±Ï„Î¹ÎºÎ® ÎºÏŒÏƒÏ„Î¿Ï‚',0),(501394,13928,'zh','é»˜è®¤çš„é™æ€æˆæœ¬çš„ç‰©æ–™æˆæœ¬',0),(501395,13928,'sv','Standard artikelkostnader till statiska kostnad',0),(501396,13928,'it','Costi di elemento predefinito statico dei costi',0),(501397,13928,'tl','',0),(501398,13928,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸•à¹‰à¸™à¸—à¸¸à¸™à¸„à¸‡à¸—à¸µà¹ˆ',0),(501399,13928,'hi','à¤¸à¥à¤¥à¤¿à¤° à¤²à¤¾à¤—à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤†à¤‡à¤Ÿà¤® à¤²à¤¾à¤—à¤¤',0),(501400,13928,'ms','Kos perkara lalai untuk kos statik',0),(501401,13928,'ar','Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¹Ù†ØµØ± Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ø¥Ù„Ù‰ ØªÙƒØ§Ù„ÙŠÙ Ø«Ø§Ø¨ØªØ©',0),(501402,13928,'fr','CoÃ»ts d\'article par dÃ©faut statique coÃ»t',0),(501403,13928,'jp','é™çš„ãªã‚³ã‚¹ãƒˆã«ã‚³ã‚¹ãƒˆã§æ—¢å®šã‚¢ã‚¤ãƒ†ãƒ ',0),(501404,13928,'pt','Custos de Item padrÃ£o de custo estÃ¡tico',0),(501405,13928,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð² ÑÑ‚Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸',0),(501406,13928,'es','Por defecto del artÃ­culo costos costo estÃ¡tico',0),(501407,13928,'de','Element VerzugsschÃ¤den zu statischen Kosten',0),(501408,13928,'en','Default Item Costs To Static Cost',0),(501409,13929,'is','',0),(501410,13929,'dr','Ù†Ù…Ø§ÛŒØ´ Ø³ÙˆØ¯ Ù‡Ø± Ø®Ø· Ù…ÙˆØ±Ø¯',0),(501411,13929,'pr','Ù†Ù…Ø§ÛŒØ´ Ø³ÙˆØ¯ Ù‡Ø± Ø®Ø· Ù…ÙˆØ±Ø¯',0),(501412,13929,'tr','Kar satÄ±rÄ± Ã¶ÄŸe baÅŸÄ±na gÃ¶rÃ¼ntÃ¼leme',0),(501413,13929,'pl','WyÅ›wietl zysk na pozycji',0),(501414,13929,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(501415,13929,'ur','Ù„Ø§Ø¦Ù† Ø´Û’ ÙÛŒ Ù…Ù†Ø§ÙØ¹ Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(501416,13929,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚ Ð¿Ð¾ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(501417,13929,'vi','Hiá»ƒn thá»‹ cÃ¡c lá»£i nhuáº­n má»™t chi tiáº¿t Ä‘Æ¡n hÃ ng',0),(501418,13929,'af','Wins Per lyn-Item vertoon',0),(501419,13929,'ro','AfiÅŸeazÄƒ profitul pe element rÃ¢nd',0),(501420,13929,'et','Kuva kasumi reale kauba kohta',0),(501421,13929,'si','Prikaz dobiÄka na postavko',0),(501422,13929,'ba','Menampilkan keuntungan Per Item baris',0),(501423,13929,'nl','Winst Per Line Item weergeven',0),(501424,13929,'fi','NÃ¤yttÃ¤Ã¤ voittoa Per nimike',0),(501425,13929,'no','Vise fortjeneste Per linje',0),(501426,13929,'da','FÃ¥ vist overskud pr. linjeelement',0),(501427,13929,'ko','í‘œì‹œ í’ˆëª© ë‹¹ ì´ìµ',0),(501428,13929,'he','×œ×”×¦×™×’ ×¨×•×•×— ×œ×¤×™ ×¤×¨×™×˜ ×©×•×¨×”',0),(501429,13929,'el','ÎŸÎ¸ÏŒÎ½Î· ÎºÎ­ÏÎ´Î¿Ï‚ Î±Î½Î¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(501430,13929,'zh','æ˜¾ç¤ºæ¯ä¸ªè¡Œé¡¹ç›®çš„åˆ©æ¶¦',0),(501431,13929,'sv','Visa vinst Per post',0),(501432,13929,'it','Visualizzare il profitto per ogni elemento di linea',0),(501433,13929,'tl','',0),(501434,13929,'th','à¹à¸ªà¸”à¸‡à¸à¸³à¹„à¸£à¸•à¹ˆà¸­à¸£à¸²à¸¢à¸à¸²à¸£',0),(501435,13929,'hi','à¤²à¤¾à¤­ à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(501436,13929,'ms','Paparan keuntungan setiap baris perkara',0),(501437,13929,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø±Ø¨Ø§Ø­ ÙƒÙ„ Ø¨Ù†Ø¯ Ø³Ø·Ø±',0),(501438,13929,'fr','Profit d\'affichage par rubrique',0),(501439,13929,'jp','å“ç›®ã‚ãŸã‚Šã®åˆ©ç›Šã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(501440,13929,'pt','Exibir lucro por Item de linha',0),(501441,13929,'ru','ÐžÑ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ Ð½Ð° Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸',0),(501442,13929,'es','Mostrar beneficios por rubro',0),(501443,13929,'de','Gewinn pro Einzelposten anzeigen',0),(501444,13929,'en','Display Profit Per Line Item',0),(501445,13930,'is','',0),(501446,13930,'dr','Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù‚Ø±Ø§Ø± Ú¯ÛŒØ±Ø¯ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù¾Ø§ÛŒÙ‡ Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÛŒ',0),(501447,13930,'pr','Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù‚Ø±Ø§Ø± Ú¯ÛŒØ±Ø¯ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù¾Ø§ÛŒÙ‡ Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÛŒ',0),(501448,13930,'tr','BiÃ§imlendirme temeli olarak kullanÄ±labilir',0),(501449,13930,'pl','MoÅ¼e sÅ‚uÅ¼yÄ‡ jako podstawa do znacznikÃ³w',0),(501450,13930,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° ÐºÐ°Ñ‚Ð¾ Ð¾ÑÐ½Ð¾Ð²Ð° Ð·Ð° Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(501451,13930,'ur','Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§',0),(501452,13930,'sr','ÐœÐ¾Ð¶Ðµ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ ÐºÐ°Ð¾ Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð°Ð·Ð½Ð°ÐºÐµ',0),(501453,13930,'vi','CÃ³ thá»ƒ Ä‘Æ°á»£c sá»­ dá»¥ng nhÆ° lÃ  cÆ¡ sá»Ÿ Ä‘Ã¡nh dáº¥u',0),(501454,13930,'af','As Markup Basis gebruik kan word',0),(501455,13930,'ro','Poate fi folosit ca bazÄƒ de marcare',0),(501456,13930,'et','Saab kasutada mÃ¤rked aluse',0),(501457,13930,'si','Lahko uporabijo kot podlaga Markup',0),(501458,13930,'ba','Dapat digunakan sebagai dasar Markup',0),(501459,13930,'nl','Kan worden gebruikt als Markup Basis',0),(501460,13930,'fi','Markup perustana kÃ¤ytettÃ¤vÃ¤n',0),(501461,13930,'no','Kan brukes som grunnlag for markering',0),(501462,13930,'da','Kan bruges som Markup grundlag',0),(501463,13930,'ko','íƒœê·¸ ê¸°ë°˜ìœ¼ë¡œ ì‚¬ìš©í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(501464,13930,'he','×™×›×•×œ ×œ×©×ž×© ×›×‘×¡×™×¡ ×¡×™×ž×•×Ÿ',0),(501465,13930,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯ Ï‰Ï‚ Î²Î¬ÏƒÎ· ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(501466,13930,'zh','å¯ä»¥ç”¨ä½œæ ‡è®°çš„åŸºç¡€',0),(501467,13930,'sv','Kan anvÃ¤ndas som markering grund',0),(501468,13930,'it','PuÃ² essere utilizzato come base di Markup',0),(501469,13930,'tl','',0),(501470,13930,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¹ƒà¸Šà¹‰à¹€à¸›à¹‡à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸žà¸·à¹‰à¸™à¸à¸²à¸™à¸‚à¸­à¸‡à¸¡à¸²à¸£à¹Œà¸à¸­à¸±à¸›',0),(501471,13930,'hi','à¤®à¤¾à¤°à¥à¤•à¤…à¤ª à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(501472,13930,'ms','Boleh digunakan sebagai penanda asas',0),(501473,13930,'ar','ÙŠÙ…ÙƒÙ† Ø£Ù† ØªØ³ØªØ®Ø¯Ù… ÙƒØ£Ø³Ø§Ø³ Ø§Ù„ØªÙˆØµÙŠÙ',0),(501474,13930,'fr','Peut Ãªtre utilisÃ© comme base de balisage',0),(501475,13930,'jp','ãƒžãƒ¼ã‚¯ã‚¢ãƒƒãƒ—ã®åŸºç¤Žã¨ã—ã¦ä½¿ç”¨ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(501476,13930,'pt','Pode ser usado como base de marcaÃ§Ã£o',0),(501477,13930,'ru','ÐœÐ¾Ð¶ÐµÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒÑÑ Ð² ÐºÐ°Ñ‡ÐµÑÑ‚Ð²Ðµ Ð¾ÑÐ½Ð¾Ð²Ñ‹ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(501478,13930,'es','Puede utilizarse como base de marcado',0),(501479,13930,'de','Einsetzbar als Markup-Basis',0),(501480,13930,'en','Can Be Used As Markup Basis',0),(501481,13931,'is','',0),(501482,13931,'dr','Ù†Ù‡ ØªØ­Øª ØªØ§Ø«ÛŒØ± ÙØ¹Ø§Ù„ÛŒØª Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(501483,13931,'pr','Ù†Ù‡ ØªØ­Øª ØªØ§Ø«ÛŒØ± ÙØ¹Ø§Ù„ÛŒØª Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(501484,13931,'tr','Stok hareket tarafÄ±ndan etkilenmez',0),(501485,13931,'pl','Nie dotyczy: aktywnoÅ›Ä‡ zapasÃ³w',0),(501486,13931,'bg','ÐÐµ ÑÐµ Ð²Ð»Ð¸ÑÐµ Ð¾Ñ‚ ÑÐºÐ»Ð°Ð´Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(501487,13931,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒÙˆÚº Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…ØªØ§Ø«Ø± Ù†ÛÛŒÚº',0),(501488,13931,'sr','ÐÐµ ÑƒÑ‚Ð¸Ñ‡Ðµ Ð½Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(501489,13931,'vi','KhÃ´ng bá»‹ áº£nh hÆ°á»Ÿng bá»Ÿi hoáº¡t Ä‘á»™ng hÃ ng tá»“n kho',0),(501490,13931,'af','Nie geraak deur voorraad aktiwiteit',0),(501491,13931,'ro','Nu sunt afectate de activitatea de inventar',0),(501492,13931,'et','Ei mÃµjuta lao tegevus',0),(501493,13931,'si','Ne vpliva na zalogo dejavnost',0),(501494,13931,'ba','Tidak terpengaruh oleh aktivitas persediaan',0),(501495,13931,'nl','Niet beÃ¯nvloed door inventaris activiteit',0),(501496,13931,'fi','Ei vaikuta varaston toiminta',0),(501497,13931,'no','PÃ¥virkes ikke av lager aktivitet',0),(501498,13931,'da','Ikke pÃ¥virket af lageret aktivitet',0),(501499,13931,'ko','ì¸ë²¤í† ë¦¬ ìž‘ì—…ì˜ ì˜í–¥ì„ ë°›ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(501500,13931,'he','××™× ×• ×ž×•×©×¤×¢ ×ž×œ××™ ×¤×¢×™×œ×•×ª',0),(501501,13931,'el','Î”ÎµÎ½ ÎµÏ€Î·ÏÎµÎ¬Î¶ÎµÏ„Î±Î¹ Î±Ï€ÏŒ Ï„Î· Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(501502,13931,'zh','ä¸å—åº“å­˜æ´»åŠ¨',0),(501503,13931,'sv','Inte pÃ¥verkas av inventering aktivitet',0),(501504,13931,'it','Non interessati da attivitÃ  di inventario',0),(501505,13931,'tl','',0),(501506,13931,'th','à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸œà¸¥à¸à¸£à¸°à¸—à¸šà¸ˆà¸²à¸à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(501507,13931,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥à¤°à¤­à¤¾à¤µà¤¿à¤¤ à¤¨à¤¹à¥€à¤‚',0),(501508,13931,'ms','Tidak terjejas oleh aktiviti inventori',0),(501509,13931,'ar','Ù„Ø§ ØªØªØ£Ø«Ø± Ø¨Ø§Ù„Ù†Ø´Ø§Ø· Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(501510,13931,'fr','Pas touchÃ©s par l\'activitÃ© de l\'inventaire',0),(501511,13931,'jp','åœ¨åº«ã®æ´»å‹•ã«ã‚ˆã£ã¦å½±éŸ¿ã‚’å—ã‘ã¾ã›ã‚“',0),(501512,13931,'pt','NÃ£o afetada pela atividade de inventÃ¡rio',0),(501513,13931,'ru','ÐÐµ Ð²Ð»Ð¸ÑÐµÑ‚ Ð½Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(501514,13931,'es','No afectado por la actividad de inventario',0),(501515,13931,'de','Nicht betroffen von Inventar-AktivitÃ¤t',0),(501516,13931,'en','Not Affected By Inventory Activity',0),(501517,13932,'is','',0),(501518,13932,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø«Ø§Ø¨Øª',0),(501519,13932,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø«Ø§Ø¨Øª',0),(501520,13932,'tr','Statik maliyet',0),(501521,13932,'pl','Koszt statyczne',0),(501522,13932,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸Ñ‡Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(501523,13932,'ur','Ø¬Ø§Ù…Ø¯ Ù„Ø§Ú¯Øª',0),(501524,13932,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸Ñ‡ÐºÐ¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(501525,13932,'vi','TÄ©nh chi phÃ­',0),(501526,13932,'af','Statiese koste',0),(501527,13932,'ro','Costul statice',0),(501528,13932,'et','Staatiline kulu',0),(501529,13932,'si','StatiÄni stroÅ¡kov',0),(501530,13932,'ba','Biaya statis',0),(501531,13932,'nl','Statische kosten',0),(501532,13932,'fi','Staattinen kustannukset',0),(501533,13932,'no','Statisk kostnader',0),(501534,13932,'da','Statisk omkostninger',0),(501535,13932,'ko','ê³ ì • ë¹„ìš©',0),(501536,13932,'he','×¢×œ×•×ª ×¡×˜×˜×™',0),(501537,13932,'el','Î£Ï„Î±Ï„Î¹ÎºÎ® ÎºÏŒÏƒÏ„Î¿Ï‚',0),(501538,13932,'zh','é™æ€æˆæœ¬',0),(501539,13932,'sv','Statiska kostnad',0),(501540,13932,'it','Costo statico',0),(501541,13932,'tl','',0),(501542,13932,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸„à¸‡à¸—à¸µà¹ˆ',0),(501543,13932,'hi','à¤¸à¥à¤¥à¤¿à¤° à¤²à¤¾à¤—à¤¤',0),(501544,13932,'ms','Kos statik',0),(501545,13932,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ø«Ø§Ø¨ØªØ©',0),(501546,13932,'fr','CoÃ»t statique',0),(501547,13932,'jp','é™çš„ãªã‚³ã‚¹ãƒˆ',0),(501548,13932,'pt','Custo estÃ¡tico',0),(501549,13932,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(501550,13932,'es','Costo estÃ¡tico',0),(501551,13932,'de','Statische Kosten',0),(501552,13932,'en','Static Cost',0),(501553,13933,'is','',0),(501554,13933,'dr','ØªØ§Ø±ÛŒØ® Ù‚ÛŒÙ…Øª',0),(501555,13933,'pr','ØªØ§Ø±ÛŒØ® Ù‚ÛŒÙ…Øª',0),(501556,13933,'tr','Fiyat geÃ§miÅŸi',0),(501557,13933,'pl','Cena historia',0),(501558,13933,'bg','Ð¦ÐµÐ½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(501559,13933,'ur','Ù‚ÛŒÙ…Øª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(501560,13933,'sr','Ð¦ÐµÐ½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(501561,13933,'vi','Price History',0),(501562,13933,'af','Prys geskiedenis',0),(501563,13933,'ro','Pret istorie',0),(501564,13933,'et','Hind ajalugu',0),(501565,13933,'si','Cena zgodovina',0),(501566,13933,'ba','Sejarah harga',0),(501567,13933,'nl','Price History',0),(501568,13933,'fi','Hinnan historia',0),(501569,13933,'no','Prisen historie',0),(501570,13933,'da','Pris historie',0),(501571,13933,'ko','ê°€ê²© ì—­ì‚¬',0),(501572,13933,'he','×”×™×¡×˜×•×¨×™×™×ª ×ž×—×™×¨',0),(501573,13933,'el','Î— Î¹ÏƒÏ„Î¿ÏÎ¯Î± Ï„Î¹Î¼ÏŽÎ½',0),(501574,13933,'zh','ä»·æ ¼åŽ†å²è®°å½•',0),(501575,13933,'sv','PrissÃ¤ttahistorien',0),(501576,13933,'it','Storia di prezzi',0),(501577,13933,'tl','',0),(501578,13933,'th','à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸£à¸²à¸„à¸²',0),(501579,13933,'hi','à¤•à¥€à¤®à¤¤ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(501580,13933,'ms','Sejarah harga',0),(501581,13933,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø³Ø¹Ø±',0),(501582,13933,'fr','Historique des prix',0),(501583,13933,'jp','ä¾¡æ ¼ã®æ­´å²',0),(501584,13933,'pt','HistÃ³rico de preÃ§os',0),(501585,13933,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ñ†ÐµÐ½',0),(501586,13933,'es','Historia del precio',0),(501587,13933,'de','Kursverlauf',0),(501588,13933,'en','Price History',0),(501589,13934,'is','',0),(501590,13934,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…ÙˆØ±Ø¯ Ù‚ÛŒÙ…Øª ØªØ§Ø±ÛŒØ®',0),(501591,13934,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…ÙˆØ±Ø¯ Ù‚ÛŒÙ…Øª ØªØ§Ø±ÛŒØ®',0),(501592,13934,'tr','SatÄ±cÄ± Madde fiyat geÃ§miÅŸi',0),(501593,13934,'pl','Historia cena towaru dostawcy',0),(501594,13934,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ñ†ÐµÐ½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(501595,13934,'ur','ÙˆÛŒÙ†ÚˆØ± Ø´Û’ Ù‚ÛŒÙ…Øª ØªØ§Ø±ÛŒØ®',0),(501596,13934,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ñ†ÐµÐ½Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(501597,13934,'vi','NgÆ°á»i bÃ¡n hÃ ng má»¥c Price History',0),(501598,13934,'af','Handelaar Item prys geskiedenis',0),(501599,13934,'ro','Furnizor de element de preÅ£ul istorie',0),(501600,13934,'et','Hankija kauba hind ajalugu',0),(501601,13934,'si','Prodajalec artikla cena zgodovina',0),(501602,13934,'ba','Penjual Item harga sejarah',0),(501603,13934,'nl','Leverancier Item Price History',0),(501604,13934,'fi','Toimittajan nimikkeen hinnan historia',0),(501605,13934,'no','LeverandÃ¸ren Elementhistorikk pris',0),(501606,13934,'da','SÃ¦lger varen pris historie',0),(501607,13934,'ko','ê³µê¸‰ ì—…ì²´ í•­ëª© ê°€ê²© ì—­ì‚¬',0),(501608,13934,'he','×”×™×¡×˜×•×¨×™×™×ª ×ž×—×™×¨ ×”×¤×¨×™×˜ ×”×¡×¤×§',0),(501609,13934,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Ï„Î¹Î¼ÏŽÎ½ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(501610,13934,'zh','ä¾›åº”å•†é¡¹ç›®çš„ä»·æ ¼åŽ†å²è®°å½•',0),(501611,13934,'sv','Artikel pris leverantÃ¶rshistorik',0),(501612,13934,'it','Fornitore elemento prezzo storia',0),(501613,13934,'tl','',0),(501614,13934,'th','à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²à¸£à¸²à¸„à¸²',0),(501615,13934,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤†à¤‡à¤Ÿà¤® à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(501616,13934,'ms','Penjual barang harga sejarah',0),(501617,13934,'ar','ØªØ§Ø±ÙŠØ® Ø³Ø¹Ø± Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(501618,13934,'fr','Historique des prix du point du vendeur',0),(501619,13934,'jp','ä»•å…¥å…ˆã®ã‚¢ã‚¤ãƒ†ãƒ ã®ä¾¡æ ¼ã®æ­´å²',0),(501620,13934,'pt','HistÃ³rico de preÃ§os do fornecedor Item',0),(501621,13934,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ñ‚Ð¾Ð²Ð°Ñ€Ð° Ð¦ÐµÐ½Ð° Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(501622,13934,'es','Vendedor del artÃ­culo historia del precio',0),(501623,13934,'de','Hersteller Preis Versionsgeschichte',0),(501624,13934,'en','Vendor Item Price History',0),(501625,13935,'is','',0),(501626,13935,'dr','Ù‚ÛŒÙ…Øª Ø¨Ø±Ø§ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¢Ù† Ø±Ø§ Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ ÙØ¹Ù„ÛŒ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(501627,13935,'pr','Ù‚ÛŒÙ…Øª Ø¨Ø±Ø§ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¢Ù† Ø±Ø§ Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ ÙØ¹Ù„ÛŒ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(501628,13935,'tr','Bir fiyat Ã¼zerinde geÃ§erli PO kullanmak iÃ§in tÄ±klatÄ±n',0),(501629,13935,'pl','Kliknij cenÄ™ go uÅ¼ywaÄ‡ na bieÅ¼Ä…cym PO',0),(501630,13935,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ñ†ÐµÐ½Ð°, Ð·Ð° Ð´Ð° Ð³Ð¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð½Ð° Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° PO',0),(501631,13935,'ur','ÛŒÛ Ø­Ø§Ù„ÛŒÛ Ù¾ÙˆØ³Ù¹ Ù¾Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ù‚ÛŒÙ…Øª Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(501632,13935,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ñ†ÐµÐ½Ð° ÐºÐ¾Ñ˜Ð° ÑÐµ Ð¼Ð¾Ñ€Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð½Ð° Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ñƒ ÐŸÐž',0),(501633,13935,'vi','Báº¥m vÃ o má»™t giÃ¡ Ä‘á»ƒ sá»­ dá»¥ng nÃ³ trÃªn sÃ´ng PO hiá»‡n táº¡i',0),(501634,13935,'af','Klik \'n prys om dit te gebruik op die huidige PO',0),(501635,13935,'ro','FaceÅ£i clic pe un preÅ£ pentru a folosi pe PO curent',0),(501636,13935,'et','Kliki hind kasutusvÃµimaluste kohta praeguse PO',0),(501637,13935,'si','Kliknite cene za uporabo na trenutni PO',0),(501638,13935,'ba','Klik harga menggunakannya pada PO saat ini',0),(501639,13935,'nl','Klik op een prijs om te gebruiken op de huidige PO',0),(501640,13935,'fi','Sitten hinta kÃ¤yttÃ¤Ã¤ sitÃ¤ nykyisen PO',0),(501641,13935,'no','Klikk en pris for Ã¥ bruke den pÃ¥ gjeldende PO',0),(501642,13935,'da','Klik pÃ¥ en pris for at bruge det pÃ¥ det nuvÃ¦rende PO',0),(501643,13935,'ko','í˜„ìž¬ í¬ì— ì‚¬ìš© í•˜ ì—¬ ê°€ê²©ì„ í´ë¦­',0),(501644,13935,'he','×œ×—×¥ ×¢×œ ×ž×—×™×¨ ×œ×”×©×ª×ž×© ×‘×–×” ×¢×œ ×”×¨×›×© ×”× ×•×›×—×™×ª',0),(501645,13935,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÎµ Î¼Î¹Î± Ï„Î¹Î¼Î® Î³Î¹Î± Î½Î± Ï„Î¿ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹ Î³Î¹Î± Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± PO',0),(501646,13935,'zh','å•å‡»ä»·æ ¼å¹¶ä½¿ç”¨å®ƒåœ¨å½“å‰ PO',0),(501647,13935,'sv','Klicka pÃ¥ ett pris fÃ¶r att anvÃ¤nda den pÃ¥ nuvarande PO',0),(501648,13935,'it','Fare clic su un prezzo per usarlo sul PO corrente',0),(501649,13935,'tl','',0),(501650,13935,'th','à¸„à¸¥à¸´à¸à¸£à¸²à¸„à¸²à¸ˆà¸°à¹ƒà¸Šà¹‰à¹ƒà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(501651,13935,'hi','à¤¯à¤¹ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ªà¥‹ à¤ªà¤° à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤®à¥‚à¤²à¥à¤¯ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(501652,13935,'ms','Klik harga untuk menggunakannya pada PO semasa',0),(501653,13935,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø«Ù…Ù†Ø§Ù‹ Ø§Ø³ØªØ®Ø¯Ø§Ù…Ù‡ ÙÙŠ Ø¨Ùˆ Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(501654,13935,'fr','Cliquez sur un prix pour l\'utiliser sur le PO actuel',0),(501655,13935,'jp','ç¾åœ¨ã®æ³¨æ–‡æ›¸ã§ä½¿ç”¨ã™ã‚‹ä¾¡æ ¼ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™ã€‚',0),(501656,13935,'pt','Clique em um preÃ§o para usÃ¡-lo na atual PO',0),(501657,13935,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ñƒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÐµÐ³Ð¾ Ð½Ð° Ñ‚ÐµÐºÑƒÑ‰ÐµÐ¼ PO',0),(501658,13935,'es','Un precio para usarlo en la posiciÃ³n actual, haga clic en',0),(501659,13935,'de','Klicken Sie auf einen Preis um es auf den aktuellen PO verwenden',0),(501660,13935,'en','Click A Price To Use It On The Current PO',0),(501661,13936,'is','',0),(501662,13936,'dr','Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´ ÙØ±Ø¶',0),(501663,13936,'pr','Ù‚ÛŒÙ…Øª Ù¾ÛŒØ´ ÙØ±Ø¶',0),(501664,13936,'tr','VarsayÄ±lan fiyat',0),(501665,13936,'pl','DomyÅ›lna cena',0),(501666,13936,'bg','Ð¦ÐµÐ½Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(501667,13936,'ur','Ø·Û’ Ø´Ø¯Û Ù‚ÛŒÙ…Øª',0),(501668,13936,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ñ†ÐµÐ½Ð°',0),(501669,13936,'vi','Máº·c Ä‘á»‹nh giÃ¡',0),(501670,13936,'af','Verstek prys',0),(501671,13936,'ro','Implicit de preÅ£',0),(501672,13936,'et','Vaike hind',0),(501673,13936,'si','Privzeti cenik',0),(501674,13936,'ba','Standar harga',0),(501675,13936,'nl','Standaard prijs',0),(501676,13936,'fi','Default hinta',0),(501677,13936,'no','Standardpris',0),(501678,13936,'da','Standardpris',0),(501679,13936,'ko','ê¸°ë³¸ ê°€ê²©',0),(501680,13936,'he','×ž×—×™×¨ ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(501681,13936,'el','Î¤Î¹Î¼Î® Î’Îœ',0),(501682,13936,'zh','é»˜è®¤ä»·æ ¼',0),(501683,13936,'sv','Standard pris',0),(501684,13936,'it','Prezzo predefinito',0),(501685,13936,'tl','',0),(501686,13936,'th','à¸£à¸²à¸„à¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(501687,13936,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¥‚à¤²à¥à¤¯',0),(501688,13936,'ms','Harga lalai',0),(501689,13936,'ar','Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(501690,13936,'fr','Prix par dÃ©faut',0),(501691,13936,'jp','æ¨™æº–ä¾¡æ ¼',0),(501692,13936,'pt','PreÃ§o padrÃ£o',0),(501693,13936,'ru','Ð¦ÐµÐ½Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(501694,13936,'es','Precio por defecto',0),(501695,13936,'de','Standardpreis',0),(501696,13936,'en','Default Price',0),(501697,13937,'is','',0),(501698,13937,'dr','Ù‡ÛŒÚ† Ø®Ø±ÛŒØ¯ Ù‚Ø¨Ù„ÛŒ',0),(501699,13937,'pr','Ù‡ÛŒÚ† Ø®Ø±ÛŒØ¯ Ù‚Ø¨Ù„ÛŒ',0),(501700,13937,'tr','HiÃ§bir Ã¶nceki alÄ±mlarÄ±',0),(501701,13937,'pl','Nie poprzednich zakupÃ³w',0),(501702,13937,'bg','ÐÑÐ¼Ð° Ð¿Ñ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(501703,13937,'ur','Ú©ÙˆØ¦ÛŒ Ø³Ø§Ø¨Ù‚Û Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(501704,13937,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ðµ Ð½Ð°Ð±Ð°Ð²ÐºÐ¸',0),(501705,13937,'vi','KhÃ´ng mua trÆ°á»›c',0),(501706,13937,'af','Geen vorige aankope',0),(501707,13937,'ro','Nici achiziÅ£iile anterioare',0),(501708,13937,'et','Eelmiste ostude',0),(501709,13937,'si','Ni prejÅ¡njih nakupov',0),(501710,13937,'ba','Tidak ada pembelian sebelumnya',0),(501711,13937,'nl','Geen eerdere aankopen',0),(501712,13937,'fi','Aiempien ostosten',0),(501713,13937,'no','Ingen tidligere kjÃ¸p',0),(501714,13937,'da','Ingen tidligere kÃ¸b',0),(501715,13937,'ko','ì•„ë‹ˆ ì´ì „ êµ¬ë§¤',0),(501716,13937,'he','×‘×œ×™ ×¨×›×™×©×•×ª ×§×•×“×ž×•×ª',0),(501717,13937,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ Î±Î³Î¿ÏÎ­Ï‚ Î´ÎµÎ½',0),(501718,13937,'zh','æ²¡æœ‰ä»¥å‰çš„è´­ä¹°',0),(501719,13937,'sv','Ingen tidigare kÃ¶p',0),(501720,13937,'it','Nessun precedenti acquisti',0),(501721,13937,'tl','',0),(501722,13937,'th','à¹„à¸¡à¹ˆà¸‹à¸·à¹‰à¸­à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(501723,13937,'hi','à¤•à¥‹à¤ˆ à¤ªà¤¿à¤›à¤²à¥‡ à¤–à¤°à¥€à¤¦',0),(501724,13937,'ms','Sebarang pembelian sebelumnya',0),(501725,13937,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø´Ø±Ø§Ø¡ Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(501726,13937,'fr','Aucun achats antÃ©rieurs',0),(501727,13937,'jp','ä»¥å‰ã®è³¼å…¥ã§ã¯ãªã„ã§ã™ã€‚',0),(501728,13937,'pt','Sem as compras anteriores',0),(501729,13937,'ru','ÐÐµÑ‚ Ð¿Ñ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ñ… Ð¿Ð¾ÐºÑƒÐ¿Ð¾Ðº',0),(501730,13937,'es','No hay compras anteriores',0),(501731,13937,'de','Keine vorherige KÃ¤ufe',0),(501732,13937,'en','No Previous Purchases',0),(501733,13938,'is','',0),(501734,13938,'dr','Ù‡ÛŒÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(501735,13938,'pr','Ù‡ÛŒÚ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(501736,13938,'tr','SeÃ§ili satÄ±cÄ±',0),(501737,13938,'pl','Å»aden inny dostawca nie wybrany',0),(501738,13938,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(501739,13938,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(501740,13938,'sr','ÐÐµÐ¼Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾',0),(501741,13938,'vi','KhÃ´ng cÃ³ nhÃ  bÃ¡n Ä‘Æ°á»£c chá»n',0),(501742,13938,'af','Geen handelaar gekies',0),(501743,13938,'ro','Nici un furnizor selectate',0),(501744,13938,'et','Pole valitud hankija',0),(501745,13938,'si','Ni dobavitelj izbran',0),(501746,13938,'ba','Tidak ada Vendor yang dipilih',0),(501747,13938,'nl','Geen leverancier geselecteerd',0),(501748,13938,'fi','Valitun toimittajan',0),(501749,13938,'no','Ingen leverandÃ¸rer valgt',0),(501750,13938,'da','Ingen sÃ¦lger valgt',0),(501751,13938,'ko','ì•„ë¬´ ê³µê¸‰ ì—…ì²´ ì„ ì •',0),(501752,13938,'he','××™×Ÿ ×¡×¤×§ × ×‘×—×¨',0),(501753,13938,'el','Î”ÎµÎ½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(501754,13938,'zh','æ²¡æœ‰é€‰å®šçš„ä¾›åº”å•†',0),(501755,13938,'sv','Ingen leverantÃ¶r valts',0),(501756,13938,'it','Nessun fornitore selezionato',0),(501757,13938,'tl','',0),(501758,13938,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(501759,13938,'hi','à¤•à¥‹à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤šà¤¯à¤¨à¤¿à¤¤',0),(501760,13938,'ms','Tiada penjual yang dipilih',0),(501761,13938,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(501762,13938,'fr','Aucun fournisseur sÃ©lectionnÃ©',0),(501763,13938,'jp','é¸æŠžã—ãŸãƒ™ãƒ³ãƒ€ãƒ¼',0),(501764,13938,'pt','Nenhum fornecedor selecionado',0),(501765,13938,'ru','ÐÐ¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(501766,13938,'es','NingÃºn proveedor seleccionado',0),(501767,13938,'de','Kein Anbieter ausgewÃ¤hlt',0),(501768,13938,'en','No Vendor Selected',0),(501769,13939,'is','',0),(501770,13939,'dr','Ù…Ø´ØªØ±ÛŒ Ù…ÙˆØ±Ø¯ Ù‚ÛŒÙ…Øª ØªØ§Ø±ÛŒØ®',0),(501771,13939,'pr','Ù…Ø´ØªØ±ÛŒ Ù…ÙˆØ±Ø¯ Ù‚ÛŒÙ…Øª ØªØ§Ø±ÛŒØ®',0),(501772,13939,'tr','MÃ¼ÅŸteri madde fiyatÄ± geÃ§miÅŸi',0),(501773,13939,'pl','Historia cena towaru nabywcy',0),(501774,13939,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ñ†ÐµÐ½Ð° Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(501775,13939,'ur','Ú©Ø³Ù¹Ù…Ø± Ø´Û’ Ù‚ÛŒÙ…Øª ØªØ§Ø±ÛŒØ®',0),(501776,13939,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ñ†ÐµÐ½Ð° ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑƒÐ¿Ñ†Ð°',0),(501777,13939,'vi','KhÃ¡ch hÃ ng má»¥c Price History',0),(501778,13939,'af','KliÃ«nt Item prys geskiedenis',0),(501779,13939,'ro','Client articol Pret istorie',0),(501780,13939,'et','Kliendi kauba hind ajalugu',0),(501781,13939,'si','Zgodovina cena artikla kupcu',0),(501782,13939,'ba','Sejarah harga Item pelanggan',0),(501783,13939,'nl','Klant Item Price History',0),(501784,13939,'fi','Asiakkaan nimikkeen hinnan historia',0),(501785,13939,'no','Kundehistorikk elementet pris',0),(501786,13939,'da','Customer varen pris historie',0),(501787,13939,'ko','ê³ ê° í•­ëª© ê°€ê²© ì—­ì‚¬',0),(501788,13939,'he','×”×™×¡×˜×•×¨×™×™×ª ×ž×—×™×¨ ×”×¤×¨×™×˜ ×œ×§×•×—',0),(501789,13939,'el','Î ÎµÎ»Î¬Ï„Î· Î¹ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Ï„Î¹Î¼Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(501790,13939,'zh','å®¢æˆ·é¡¹ç›®çš„ä»·æ ¼åŽ†å²è®°å½•',0),(501791,13939,'sv','Kunden objektet pris historia',0),(501792,13939,'it','Cliente elemento prezzo storia',0),(501793,13939,'tl','',0),(501794,13939,'th','à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸£à¸²à¸„à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(501795,13939,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¤¦ à¤•à¥€à¤®à¤¤ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(501796,13939,'ms','Baca Item harga sejarah',0),(501797,13939,'ar','ØªØ§Ø±ÙŠØ® Ø³Ø¹Ø± Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(501798,13939,'fr','Historique des prix client point',0),(501799,13939,'jp','ãŠå®¢æ§˜ã®ã‚¢ã‚¤ãƒ†ãƒ ã®ä¾¡æ ¼ã®æ­´å²',0),(501800,13939,'pt','HistÃ³rico de preÃ§os de Item do cliente',0),(501801,13939,'ru','Ð¦ÐµÐ½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(501802,13939,'es','Historia del precio del artÃ­culo del cliente',0),(501803,13939,'de','Artikel Preis Kundenhistorie',0),(501804,13939,'en','Customer Item Price History',0),(501805,13940,'is','',0),(501806,13940,'dr','Ù‚ÛŒÙ…Øª Ø¨Ø±Ø§ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¢Ù† Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø³ÙØ§Ø±Ø´ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(501807,13940,'pr','Ù‚ÛŒÙ…Øª Ø¨Ø±Ø§ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¢Ù† Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø³ÙØ§Ø±Ø´ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(501808,13940,'tr','Bir fiyat geÃ§erli sipariÅŸte kullanmak iÃ§in tÄ±klatÄ±n',0),(501809,13940,'pl','Kliknij cenÄ™ go uÅ¼ywaÄ‡ w bieÅ¼Ä…cym porzÄ…dku',0),(501810,13940,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ñ†ÐµÐ½Ð°, Ð·Ð° Ð´Ð° Ð³Ð¾ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Ð·Ð° Ñ‚ÐµÐºÑƒÑ‰Ð¸Ñ Ñ€ÐµÐ´',0),(501811,13940,'ur','Ø§Ø³ Ø­Ø§Ù„ÛŒÛ Ø¢Ø±ÚˆØ± Ù¾Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ù‚ÛŒÙ…Øª Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(501812,13940,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ñ†ÐµÐ½Ð° ÐºÐ¾Ñ˜Ð° ÑÐµ Ð¼Ð¾Ñ€Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸ Ð½Ð° Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾Ð¼ Ð½Ð°Ð»Ð¾Ð³Ñƒ',0),(501813,13940,'vi','Báº¥m vÃ o má»™t giÃ¡ Ä‘á»ƒ sá»­ dá»¥ng nÃ³ trÃªn bá»™ hiá»‡n táº¡i',0),(501814,13940,'af','Klik \'n prys om dit te gebruik op die huidige orde',0),(501815,13940,'ro','FaceÅ£i clic pe un preÅ£ sÄƒ-l foloseascÄƒ pe comanda curentÄƒ',0),(501816,13940,'et','KlÃµpsake kasutusvÃµimaluste kohta praeguse tellimuse hind',0),(501817,13940,'si','Kliknite cene za uporabo na trenutni vrstni red',0),(501818,13940,'ba','Klik harga untuk menggunakannya pada susunan saat ini',0),(501819,13940,'nl','Klik op een prijs om het te gebruiken op de huidige Order',0),(501820,13940,'fi','Sitten kÃ¤yttÃ¤Ã¤ sitÃ¤ nykyisen tilauksen hinta',0),(501821,13940,'no','Klikk en pris for Ã¥ bruke den i den gjeldende ordren',0),(501822,13940,'da','Klik pÃ¥ en pris for at bruge det pÃ¥ den aktuelle ordre',0),(501823,13940,'ko','í˜„ìž¬ ìˆœì„œì— ê·¸ê²ƒì„ ì‚¬ìš© í•˜ ì—¬ ê°€ê²©ì„ í´ë¦­',0),(501824,13940,'he','×œ×—×¥ ×¢×œ ×ž×—×™×¨ ×œ×”×©×ª×ž×© ×‘×–×” ×¢×œ ×”×”×–×ž× ×” ×”× ×•×›×—×™×ª',0),(501825,13940,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÎµ Î¼Î¹Î± Ï„Î¹Î¼Î® Î³Î¹Î± Î½Î± Ï„Î¿ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹ Î³Î¹Î± Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(501826,13940,'zh','å•å‡»è¦ä½¿ç”¨åœ¨å½“å‰è®¢å•ä¸Šçš„ä»·æ ¼',0),(501827,13940,'sv','Klicka pÃ¥ ett pris fÃ¶r att anvÃ¤nda det pÃ¥ den aktuella ordern',0),(501828,13940,'it','Fare clic su un prezzo per usarlo sull\'ordine corrente',0),(501829,13940,'tl','',0),(501830,13940,'th','à¸„à¸¥à¸´à¸à¸£à¸²à¸„à¸²à¸ˆà¸°à¹ƒà¸Šà¹‰à¸šà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(501831,13940,'hi','à¤¯à¤¹ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤®à¥‚à¤²à¥à¤¯ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(501832,13940,'ms','Klik harga untuk menggunakannya dengan arahan semasa',0),(501833,13940,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø«Ù…Ù†Ø§Ù‹ Ø§Ø³ØªØ®Ø¯Ø§Ù…Ù‡ ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(501834,13940,'fr','Cliquez sur un prix pour l\'utiliser sur la commande actuelle',0),(501835,13940,'jp','ç¾åœ¨ã®é †åºã«ä½¿ç”¨ã™ã‚‹ä¾¡æ ¼ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™ã€‚',0),(501836,13940,'pt','Clique em um preÃ§o para usÃ¡-lo na atual ordem',0),(501837,13940,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ñƒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÐµÐ³Ð¾ Ð½Ð° Ñ‚ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð·Ð°ÐºÐ°Ð·',0),(501838,13940,'es','Un precio para usarlo en el orden actual, haga clic en',0),(501839,13940,'de','Klicken Sie auf einen Preis um es auf die aktuelle Reihenfolge zu verwenden',0),(501840,13940,'en','Click A Price To Use It On The Current Order',0),(501841,13941,'is','',0),(501842,13941,'dr','Ù‡ÛŒÚ† Ù…Ø´ØªØ±ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(501843,13941,'pr','Ù‡ÛŒÚ† Ù…Ø´ØªØ±ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(501844,13941,'tr','SeÃ§ili mÃ¼ÅŸteri',0),(501845,13941,'pl','Nie klienta',0),(501846,13941,'bg','ÐÑÐ¼Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(501847,13941,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ú¯Ø§ÛÚ©',0),(501848,13941,'sr','ÐÐµÐ¼Ð° ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(501849,13941,'vi','KhÃ´ng cÃ³ khÃ¡ch hÃ ng Ä‘Ã£ chá»n',0),(501850,13941,'af','Geen kliÃ«nt gekies',0),(501851,13941,'ro','Nici un client selectat',0),(501852,13941,'et','No kliendi valitud',0),(501853,13941,'si','Nobenega kupca, izbrana',0),(501854,13941,'ba','Tidak ada pelanggan yang dipilih',0),(501855,13941,'nl','Geen klant geselecteerd',0),(501856,13941,'fi','Valitun asiakkaan',0),(501857,13941,'no','Ingen kunde valgt',0),(501858,13941,'da','Ingen kunde valgt',0),(501859,13941,'ko','ì•„ë‹ˆ ê³ ê° ì„ ì •',0),(501860,13941,'he','××™×Ÿ ×œ×§×•×—×•×ª × ×‘×—×¨×™×',0),(501861,13941,'el','Î”ÎµÎ½ Ï€ÎµÎ»Î¬Ï„Î·Ï‚ ÎµÏ€Î¹Î»Î­Î¾ÎµÎ¹',0),(501862,13941,'zh','æœªé€‰å®šå®¢æˆ·',0),(501863,13941,'sv','Ingen kund som valt',0),(501864,13941,'it','Nessun cliente selezionato',0),(501865,13941,'tl','',0),(501866,13941,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹„à¸¡à¹ˆà¹€à¸¥à¸·à¸­à¸',0),(501867,13941,'hi','à¤•à¥‹à¤ˆ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤šà¤¯à¤¨à¤¿à¤¤',0),(501868,13941,'ms','Tiada pelanggan yang dipilih',0),(501869,13941,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªØ­Ø¯ÙŠØ¯',0),(501870,13941,'fr','Aucun client sÃ©lectionnÃ©',0),(501871,13941,'jp','é¸æŠžã•ã‚ŒãŸé¡§å®¢ãªã—',0),(501872,13941,'pt','NÃ£o Ã© um cliente selecionado',0),(501873,13941,'ru','ÐÐµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(501874,13941,'es','NingÃºn cliente seleccionado',0),(501875,13941,'de','Kein Kunde ausgewÃ¤hlt',0),(501876,13941,'en','No Customer Selected',0),(501877,13942,'is','',0),(501878,13942,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø­Ø§Ù…Ù„ Ù…ÙˆØ¬ÙˆØ¯',0),(501879,13942,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø­Ø§Ù…Ù„ Ù…ÙˆØ¬ÙˆØ¯',0),(501880,13942,'tr','Mevcut taÅŸÄ±yÄ±cÄ± dÃ¼zenleme',0),(501881,13942,'pl','Edycja istniejÄ…cego przewoÅºnika',0),(501882,13942,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(501883,13942,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ú©ÛŒØ±ÛŒØ¦Ø± Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(501884,13942,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð½Ð¾ÑÐ°Ñ‡',0),(501885,13942,'vi','Chá»‰nh sá»­a trÃªn tÃ u sÃ¢n bay hiá»‡n táº¡i',0),(501886,13942,'af','Redigeer bestaande draer',0),(501887,13942,'ro','Editare existente de transport',0),(501888,13942,'et','Saate redigeerida olemasolevaid vedaja',0),(501889,13942,'si','Urejanje obstojeÄe prevoznik',0),(501890,13942,'ba','Mengedit yang sudah ada pembawa',0),(501891,13942,'nl','Bewerken van bestaande Carrier',0),(501892,13942,'fi','Muokkaa nykyisen kantaja',0),(501893,13942,'no','Redigere eksisterende Carrier',0),(501894,13942,'da','Redigere eksisterende luftfartsselskab',0),(501895,13942,'ko','íŽ¸ì§‘ ê¸°ì¡´ ìºë¦¬ì–´',0),(501896,13942,'he','×¢×¨×™×›×ª ×”×¡×¤×§ ×”×§×™×™×',0),(501897,13942,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(501898,13942,'zh','ç¼–è¾‘çŽ°æœ‰çš„è½½ä½“',0),(501899,13942,'sv','Redigera befintliga bÃ¤rare',0),(501900,13942,'it','Modificare il vettore esistente',0),(501901,13942,'tl','',0),(501902,13942,'th','à¹à¸à¹‰à¹„à¸‚à¸œà¸¹à¹‰à¸‚à¸™à¸ªà¹ˆà¸‡à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(501903,13942,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤•à¥ˆà¤°à¤¿à¤¯à¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(501904,13942,'ms','Edit pesawat yang sedia ada',0),(501905,13942,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ù†Ø§Ù‚Ù„ Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(501906,13942,'fr','Edit transporteur existant',0),(501907,13942,'jp','ç·¨é›†æ—¢å­˜ã®ã‚­ãƒ£ãƒªã‚¢',0),(501908,13942,'pt','Editar transportadora existente',0),(501909,13942,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº',0),(501910,13942,'es','Editar portador existente',0),(501911,13942,'de','Bearbeiten von vorhandenen Carrier',0),(501912,13942,'en','Edit Existing Carrier',0),(501913,13943,'is','',0),(501914,13943,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒÚ© Ø­Ø§Ù…Ù„ Ø±Ø§',0),(501915,13943,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒÚ© Ø­Ø§Ù…Ù„ Ø±Ø§',0),(501916,13943,'tr','SatÄ±cÄ± A taÅŸÄ±yÄ±cÄ± olun',0),(501917,13943,'pl','Aby dostawcy A przewoÅºnik',0),(501918,13943,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº A Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(501919,13943,'ur','ÙˆÛŒÙ†ÚˆØ± A Ú©ÛŒØ±ÛŒØ¦Ø± Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(501920,13943,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð Ð½Ð¾ÑÐ°Ñ‡',0),(501921,13943,'vi','LÃ m cho tÃ u sÃ¢n bay Vendor A',0),(501922,13943,'af','Maak handelaar \'n draer',0),(501923,13943,'ro','Face furnizor A transportatorului',0),(501924,13943,'et','Veenduge mÃ¼Ã¼ja A vedaja',0),(501925,13943,'si','Bo prevoznik dobavitelja A',0),(501926,13943,'ba','Membuat Penjual A Carrier',0),(501927,13943,'nl','Maken van leverancier A Carrier',0),(501928,13943,'fi','TehdÃ¤ toimittaja A harjoittaja',0),(501929,13943,'no','GjÃ¸re leverandÃ¸r A Carrier',0),(501930,13943,'da','GÃ¸re leverandÃ¸r A luftfartsselskab',0),(501931,13943,'ko','ê³µê¸‰ ì—…ì²´ëŠ” ì´ë™ í†µì‹ ì‚¬ë¥¼ í™•ì¸',0),(501932,13943,'he','×œ×”×¤×•×š ××ª ×”×¡×¤×§ ×©×œ ×”×¡×¤×§',0),(501933,13943,'el','ÎšÎ¬Î½ÎµÎ¹ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î‘ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(501934,13943,'zh','ä½¿ä¾›åº”å•† A æ‰¿è¿äºº',0),(501935,13943,'sv','GÃ¶ra leverantÃ¶r A transportÃ¶r',0),(501936,13943,'it','Fare il venditore A Carrier',0),(501937,13943,'tl','',0),(501938,13943,'th','à¸—à¸³à¹ƒà¸«à¹‰à¸œà¸¹à¹‰à¸‚à¸™à¸ªà¹ˆà¸‡à¸œà¸¹à¹‰à¸‚à¸²à¸¢ A',0),(501939,13943,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤à¤• à¤µà¤¾à¤¹à¤• à¤¬à¤¨à¤¾',0),(501940,13943,'ms','Membuat penerbangan penjual A',0),(501941,13943,'ar','ØªØ¬Ø¹Ù„ Ø§Ù„Ù†Ø§Ù‚Ù„ Ø§Ù„Ù…ÙˆØ±Ø¯ A',0),(501942,13943,'fr','Faire du vendeur A transporteur',0),(501943,13943,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ A ã‚­ãƒ£ãƒªã‚¢ã‚’ä½œã‚‹',0),(501944,13943,'pt','Fazer o fornecedor A transportadora',0),(501945,13943,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº Ð¿Ñ€Ð¾Ð´Ð°Ð²ÐµÑ† A',0),(501946,13943,'es','Hacer vendedor A Carrier',0),(501947,13943,'de','Anbieter A Carrier zu machen',0),(501948,13943,'en','Make Vendor A Carrier',0),(501949,13944,'is','',0),(501950,13944,'dr','Ù†Ù…Ø§ÛŒØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(501951,13944,'pr','Ù†Ù…Ø§ÛŒØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(501952,13944,'tr','SevkÄ±yat bilgisini gÃ¶ster',0),(501953,13944,'pl','PokaÅ¼ Info wysyÅ‚ki',0),(501954,13944,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(501955,13944,'ur','Ú©Ú¾ÛŒÙ¾ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(501956,13944,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ†Ð¸',0),(501957,13944,'vi','Hiá»ƒn thá»‹ thÃ´ng tin lÃ´ hÃ ng',0),(501958,13944,'af','Wys verskeping Info',0),(501959,13944,'ro','AratÄƒ informaÅ£ii de livrare',0),(501960,13944,'et','NÃ¤ita saatmise Info',0),(501961,13944,'si','KaÅ¾ejo podatki o dobavi',0),(501962,13944,'ba','Tampilkan Info pengiriman',0),(501963,13944,'nl','Verzending Info tonen',0),(501964,13944,'fi','NÃ¤ytÃ¤ lÃ¤hetyksen tiedot',0),(501965,13944,'no','Vis levering Info',0),(501966,13944,'da','Vis oplysninger om forsendelsen',0),(501967,13944,'ko','ë°°ì†¡ ì •ë³´ ë³´ê¸°',0),(501968,13944,'he','×”×¦×’ ××ª ×¤×¨×˜×™ ×”×ž×©×œ×•×—',0),(501969,13944,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Î´ÎµÎ¯Ï‡Î½Î¿Ï…Î½',0),(501970,13944,'zh','æ˜¾ç¤ºè£…è¿ä¿¡æ¯',0),(501971,13944,'sv','Visa leverans Info',0),(501972,13944,'it','Visualizza informazioni di spedizione',0),(501973,13944,'tl','',0),(501974,13944,'th','à¹à¸ªà¸”à¸‡à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(501975,13944,'hi','à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤•à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(501976,13944,'ms','Menunjukkan maklumat penghantaran',0),(501977,13944,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø­Ù†',0),(501978,13944,'fr','Afficher les infos de livraison',0),(501979,13944,'jp','å‡ºè·æƒ…å ±ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(501980,13944,'pt','Mostrar informaÃ§Ã£o de expediÃ§Ã£o',0),(501981,13944,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(501982,13944,'es','Mostrar informaciÃ³n del envÃ­o',0),(501983,13944,'de','Versand-Infos anzeigen',0),(501984,13944,'en','Show Shipment Info',0),(501985,13945,'is','',0),(501986,13945,'dr','Ø³Ø§Ø¨Ù‚Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒ Ø¯ÛŒ Ø§Ù Ø¨Ø±Ø§ÛŒ Ú†Ø§Ù¾ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(501987,13945,'pr','Ø³Ø§Ø¨Ù‚Ù‡ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒ Ø¯ÛŒ Ø§Ù Ø¨Ø±Ø§ÛŒ Ú†Ø§Ù¾ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(501988,13945,'tr','Arka planda PDF Standart baskÄ±lar iÃ§in kullanÄ±n',0),(501989,13945,'pl','UÅ¼yj tÅ‚o PDF dla standardowych wydrukÃ³w',0),(501990,13945,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ„Ð¾Ð½ PDF Ð·Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ñ€Ð°Ð·Ð¿ÐµÑ‡Ð°Ñ‚ÐºÐ¸',0),(501991,13945,'ur','Ù¾Ø³ Ù…Ù†Ø¸Ø±ÛŒ PDF Ù…Ø¹ÛŒØ§Ø±ÛŒ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Û”',0),(501992,13945,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¿Ð¾Ð·Ð°Ð´Ð¸Ð½Ñƒ ÐŸÐ”Ð¤ Ð·Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð¾Ñ‚Ð¸ÑÐºÐµ',0),(501993,13945,'vi','Sá»­ dá»¥ng ná»n PDF cho tiÃªu chuáº©n báº£n in',0),(501994,13945,'af','Gebruik agtergrond PDF vir standaard afdrukke',0),(501995,13945,'ro','Utilizarea fundal PDF pentru printuri Standard',0),(501996,13945,'et','Kasutage tausta PDF Standard pildid',0),(501997,13945,'si','Uporaba ozadje PDF za Standard tiskanja',0),(501998,13945,'ba','Menggunakan latar belakang PDF untuk standar cetakan',0),(501999,13945,'nl','Gebruik achtergrond PDF voor standaard afdrukken',0),(502000,13945,'fi','KÃ¤ytÃ¤ taustaa PDF standardi tulosteita',0),(502001,13945,'no','Bruke bakgrunn PDF For Standard utskrifter',0),(502002,13945,'da','Brug baggrund PDF For Standard udskrifter',0),(502003,13945,'ko','ë°°ê²½ PDFë¥¼ ì‚¬ìš© í•˜ ì—¬ í‘œì¤€ ì¶œë ¥ì— ëŒ€ í•œ',0),(502004,13945,'he','×”×©×ª×ž×© ×‘×¨×§×¢ PDF ×¢×‘×•×¨ ×˜×‘×™×¢×•×ª ×¡×˜× ×“×¨×˜×™×•×ª',0),(502005,13945,'el','Î§ÏÎ®ÏƒÎ· Ï†ÏŒÎ½Ï„Î¿ PDF Î³Î¹Î± Ï€ÏÏŒÏ„Ï…Ï€Î¿ ÎµÎºÏ„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚',0),(502006,13945,'zh','ä½¿ç”¨èƒŒæ™¯ä¸ºæ ‡å‡†æ‰“å°çš„ PDF',0),(502007,13945,'sv','AnvÃ¤nd bakgrund PDF fÃ¶r vanliga utskrifter',0),(502008,13945,'it','Sfondo uso PDF per stampe Standard',0),(502009,13945,'tl','',0),(502010,13945,'th','à¹ƒà¸Šà¹‰à¸žà¸·à¹‰à¸™à¸«à¸¥à¸±à¸‡ PDF à¸ªà¸³à¸«à¸£à¸±à¸šà¸žà¸´à¸¡à¸žà¹Œà¸¡à¸²à¸•à¸£à¸à¸²à¸™',0),(502011,13945,'hi','à¤®à¤¾à¤¨à¤• à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥ƒà¤·à¥à¤ à¤­à¥‚à¤®à¤¿ PDF à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(502012,13945,'ms','Menggunakan latar belakang PDF untuk cetakan Standard',0),(502013,13945,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø®Ù„ÙÙŠØ© PDF Ù„Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(502014,13945,'fr','Utiliser PDF de fond pour les tirages Standard',0),(502015,13945,'jp','æ¨™æº–çš„ãªå°åˆ·ç”¨ PDF ã®èƒŒæ™¯ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(502016,13945,'pt','Use o fundo PDF para impressÃµes padrÃ£o',0),(502017,13945,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ñ„Ð¾Ð½ PDF Ð´Ð»Ñ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¾Ð¹ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(502018,13945,'es','Uso fondo PDF para impresiones estÃ¡ndar',0),(502019,13945,'de','Hintergrund verwenden PDF fÃ¼r Standard-Drucke',0),(502020,13945,'en','Use Background PDF For Standard Prints',0),(502021,13946,'is','',0),(502022,13946,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø¬Ø¯ÛŒØ¯',0),(502023,13946,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø¬Ø¯ÛŒØ¯',0),(502024,13946,'tr','Yeni e-posta ÅŸablonu ekleme',0),(502025,13946,'pl','DodaÄ‡ nowy szablon wiadomoÅ›ci Email',0),(502026,13946,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¸Ð¼ÐµÐ¹Ð» ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(502027,13946,'ur','Ù†ÛŒØ§ Ø§ÛŒ Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(502028,13946,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(502029,13946,'vi','ThÃªm máº«u thÆ° Ä‘iá»‡n tá»­ má»›i',0),(502030,13946,'af','Voeg nuwe e-pos sjabloon',0),(502031,13946,'ro','Adauga noi E-mail ÅŸablon',0),(502032,13946,'et','Uue meilisÃµnumi malli lisamine',0),(502033,13946,'si','Dodajte nov Email predloga',0),(502034,13946,'ba','Tambahkan Template Email baru',0),(502035,13946,'nl','Nieuwe E-mail sjabloon toevoegen',0),(502036,13946,'fi','LisÃ¤Ã¤ uusi sÃ¤hkÃ¶postimalli',0),(502037,13946,'no','Legge til nye e-malen',0),(502038,13946,'da','TilfÃ¸j nye E-mail-skabelon',0),(502039,13946,'ko','ìƒˆ ì „ìž ë©”ì¼ ì„œì‹ íŒŒì¼ ì¶”ê°€',0),(502040,13946,'he','×”×•×¡×¤×ª ×ª×‘× ×™×ª ×”×“×•× ×œ ×”×—×“×©×”',0),(502041,13946,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(502042,13946,'zh','æ·»åŠ æ–°çš„ç”µå­é‚®ä»¶æ¨¡æ¿',0),(502043,13946,'sv','LÃ¤gga till nya e-mall',0),(502044,13946,'it','Aggiungere il nuovo modello di E-mail',0),(502045,13946,'tl','',0),(502046,13946,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥à¹ƒà¸«à¸¡à¹ˆ',0),(502047,13946,'hi','à¤¨à¤¯à¤¾ à¤ˆà¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(502048,13946,'ms','Tambah baru e-mel Template',0),(502049,13946,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ù„Ø¨ Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¬Ø¯ÙŠØ¯',0),(502050,13946,'fr','Ajouter le nouveau modÃ¨le d\'E-mail',0),(502051,13946,'jp','æ–°ã—ã„é›»å­ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(502052,13946,'pt','Adicionar novo Template de Email',0),(502053,13946,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ ÑˆÐ°Ð±Ð»Ð¾Ð½ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(502054,13946,'es','Agregar Nueva Plantilla Email',0),(502055,13946,'de','Neue E-Mail-Vorlage hinzufÃ¼gen',0),(502056,13946,'en','Add New Email Template',0),(502057,13947,'is','',0),(502058,13947,'dr','Ù†ÙˆØ¹ Ø§Ù„Ú¯Ùˆ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(502059,13947,'pr','Ù†ÙˆØ¹ Ø§Ù„Ú¯Ùˆ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(502060,13947,'tr','Bir ÅŸablon tÃ¼rÃ¼nÃ¼ seÃ§in',0),(502061,13947,'pl','Wybierz typ szablonu',0),(502062,13947,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ‚Ð¸Ð¿ Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½Ð°',0),(502063,13947,'ur','Ø§ÛŒÚ© Ø³Ø§Ù†Ú†Ø§ Ù‚Ø³Ù… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(502064,13947,'sr','Ð˜Ð·Ð±Ð¾Ñ€ Ñ‚Ð¸Ð¿Ð° Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ°',0),(502065,13947,'vi','Chá»n má»™t loáº¡i máº«u',0),(502066,13947,'af','Kies \'n sjabloon tipe',0),(502067,13947,'ro','SelectaÅ£i un tip de ÅŸablon',0),(502068,13947,'et','Saate valida malli tÃ¼Ã¼p',0),(502069,13947,'si','Izberite vrsto predloge',0),(502070,13947,'ba','Pilih jenis Template',0),(502071,13947,'nl','Selecteer een sjabloontype',0),(502072,13947,'fi','Valitse mallityyppi',0),(502073,13947,'no','Velg en maltype',0),(502074,13947,'da','VÃ¦lg en skabelontype',0),(502075,13947,'ko','í…œí”Œë¦¿ í˜•ì‹ ì„ íƒ',0),(502076,13947,'he','×‘×—×¨ ×¡×•×’ ×ª×‘× ×™×ª',0),(502077,13947,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Ï€ÏÏŒÏ„Ï…Ï€Î¿ Ï„ÏÏ€Î¿Ï…',0),(502078,13947,'zh','é€‰æ‹©ä¸€ç§æ¨¡æ¿ç±»åž‹',0),(502079,13947,'sv','VÃ¤lj en Malltyp',0),(502080,13947,'it','Selezionare un tipo di modello',0),(502081,13947,'tl','',0),(502082,13947,'th','à¹€à¸¥à¸·à¸­à¸à¸Šà¸™à¸´à¸”à¹à¸¡à¹ˆà¹à¸šà¸š',0),(502083,13947,'hi','à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(502084,13947,'ms','Pilih jenis Template',0),(502085,13947,'ar','Ø­Ø¯Ø¯ Ù†ÙˆØ¹ Ù‚Ø§Ù„Ø¨',0),(502086,13947,'fr','SÃ©lectionnez un Type de modÃ¨le',0),(502087,13947,'jp','ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã®ç¨®é¡žã‚’é¸æŠžã—ã¾ã™ã€‚',0),(502088,13947,'pt','Selecione um tipo de modelo',0),(502089,13947,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ‚Ð¸Ð¿ ÑˆÐ°Ð±Ð»Ð¾Ð½Ð°',0),(502090,13947,'es','Seleccione un tipo de plantilla',0),(502091,13947,'de','WÃ¤hlen Sie einen Vorlagentyp',0),(502092,13947,'en','Select A Template Type',0),(502093,13948,'is','',0),(502094,13948,'dr','Ù‚Ø§Ù„Ø¨',0),(502095,13948,'pr','Ù‚Ø§Ù„Ø¨',0),(502096,13948,'tr','Åžablon',0),(502097,13948,'pl','Szablon',0),(502098,13948,'bg','Ð¨Ð°Ð±Ð»Ð¾Ð½',0),(502099,13948,'ur','Ø³Ø§Ù†Ú†Ø§',0),(502100,13948,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº',0),(502101,13948,'vi','TiÃªu báº£n',0),(502102,13948,'af','Sjabloon',0),(502103,13948,'ro','Åžablon',0),(502104,13948,'et','Mall',0),(502105,13948,'si','Predloga',0),(502106,13948,'ba','Template',0),(502107,13948,'nl','Sjabloon',0),(502108,13948,'fi','Malli',0),(502109,13948,'no','Mal',0),(502110,13948,'da','Skabelon',0),(502111,13948,'ko','ì„œì‹ íŒŒì¼',0),(502112,13948,'he','×ª×‘× ×™×ª',0),(502113,13948,'el','Î ÏÏŒÏ„Ï…Ï€Î¿',0),(502114,13948,'zh','æ¨¡æ¿',0),(502115,13948,'sv','Mall',0),(502116,13948,'it','Modello',0),(502117,13948,'tl','',0),(502118,13948,'th','à¹à¸¡à¹ˆà¹à¸šà¸š',0),(502119,13948,'hi','à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ',0),(502120,13948,'ms','Template',0),(502121,13948,'ar','Ù‚Ø§Ù„Ø¨',0),(502122,13948,'fr','ModÃ¨le',0),(502123,13948,'jp','ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ',0),(502124,13948,'pt','Modelo',0),(502125,13948,'ru','Ð¨Ð°Ð±Ð»Ð¾Ð½',0),(502126,13948,'es','Plantilla',0),(502127,13948,'de','Vorlage',0),(502128,13948,'en','Template',0),(502129,13949,'is','',0),(502130,13949,'dr','Ù†ÙˆØ¹ Ø§Ù„Ú¯Ùˆ',0),(502131,13949,'pr','Ù†ÙˆØ¹ Ø§Ù„Ú¯Ùˆ',0),(502132,13949,'tr','Åžablon tÃ¼rÃ¼',0),(502133,13949,'pl','Typ szablonu',0),(502134,13949,'bg','Ð¢Ð¸Ð¿ ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(502135,13949,'ur','Ø³Ø§Ù†Ú†Ø§ Ù‚Ø³Ù…',0),(502136,13949,'sr','Ð¢Ð¸Ð¿ Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ°',0),(502137,13949,'vi','Loáº¡i máº«u',0),(502138,13949,'af','Sjabloon tipe',0),(502139,13949,'ro','Tip de È™ablon',0),(502140,13949,'et','Malli tÃ¼Ã¼p',0),(502141,13949,'si','Vrsta predloge',0),(502142,13949,'ba','Jenis template',0),(502143,13949,'nl','Sjabloontype',0),(502144,13949,'fi','Mallityyppi',0),(502145,13949,'no','Maltype',0),(502146,13949,'da','Skabelontypen',0),(502147,13949,'ko','í…œí”Œë¦¿ í˜•ì‹',0),(502148,13949,'he','×¡×•×’ ×”×ª×‘× ×™×ª',0),(502149,13949,'el','Î¤ÏÏ€Î¿ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï…',0),(502150,13949,'zh','æ¨¡æ¿ç±»åž‹',0),(502151,13949,'sv','Malltypen',0),(502152,13949,'it','Tipo di modello',0),(502153,13949,'tl','',0),(502154,13949,'th','à¸Šà¸™à¸´à¸”à¹à¸¡à¹ˆà¹à¸šà¸š',0),(502155,13949,'hi','à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(502156,13949,'ms','Jenis template',0),(502157,13949,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù„Ø¨',0),(502158,13949,'fr','Type de modÃ¨le',0),(502159,13949,'jp','ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã®ç¨®é¡ž',0),(502160,13949,'pt','Tipo de modelo',0),(502161,13949,'ru','Ð¢Ð¸Ð¿ ÑˆÐ°Ð±Ð»Ð¾Ð½Ð°',0),(502162,13949,'es','Tipo de plantilla',0),(502163,13949,'de','Vorlagentyp',0),(502164,13949,'en','Template Type',0),(502165,13950,'is','',0),(502166,13950,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ù†Ø§Ù… Ø§Ù„Ú¯Ùˆ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(502167,13950,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ù†Ø§Ù… Ø§Ù„Ú¯Ùˆ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯.',0),(502168,13950,'tr','Bir ÅŸablon adÄ± girmeniz gerekir.',0),(502169,13950,'pl','NaleÅ¼y wprowadziÄ‡ nazwÄ™ szablonu.',0),(502170,13950,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½.',0),(502171,13950,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø³Ø§Ù†Ú†Ø§ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’ Û”',0),(502172,13950,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ°.',0),(502173,13950,'vi','Báº¡n pháº£i nháº­p tÃªn máº«u.',0),(502174,13950,'af','U moet \'n Sjabloomnaam (\"Template Name\") invoer',0),(502175,13950,'ro','Trebuie sÄƒ introduceÅ£i un nume ÅŸablon.',0),(502176,13950,'et','Sisestage malli nimi.',0),(502177,13950,'si','Vnesite ime predloge.',0),(502178,13950,'ba','Anda harus memasukkan nama Template.',0),(502179,13950,'nl','U moet de naam van een sjabloon opgeven.',0),(502180,13950,'fi','Kirjoita mallin nimi.',0),(502181,13950,'no','Du mÃ¥ angi et malnavn.',0),(502182,13950,'da','Du skal angive et skabelonnavn.',0),(502183,13950,'ko','ì„œì‹ íŒŒì¼ ì´ë¦„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(502184,13950,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×©× ×ª×‘× ×™×ª.',0),(502185,13950,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï….',0),(502186,13950,'zh','æ‚¨å¿…é¡»è¾“å…¥æ¨¡æ¿åç§°ã€‚',0),(502187,13950,'sv','Du mÃ¥ste ange ett namn pÃ¥ mallen.',0),(502188,13950,'it','Ãˆ necessario immettere un nome di modello.',0),(502189,13950,'tl','',0),(502190,13950,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸Šà¸·à¹ˆà¸­à¸•à¹‰à¸™à¹à¸šà¸š',0),(502191,13950,'hi','à¤†à¤ª à¤•à¤¿à¤¸à¥€ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(502192,13950,'ms','Anda harus masukkan nama Template.',0),(502193,13950,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ \"Ø§Ø³Ù… Ø§Ù„Ù‚Ø§Ù„Ø¨\".',0),(502194,13950,'fr','Vous devez entrer un nom de modÃ¨le.',0),(502195,13950,'jp','ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆåã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(502196,13950,'pt','VocÃª deve digitar um nome de modelo.',0),(502197,13950,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¸Ð¼Ñ ÑˆÐ°Ð±Ð»Ð¾Ð½Ð°.',0),(502198,13950,'es','Debe introducir un nombre de plantilla.',0),(502199,13950,'de','Sie mÃ¼ssen einen Namen eingeben.',0),(502200,13950,'en','You must enter a Template Name.',0),(502201,13951,'is','',0),(502202,13951,'dr','Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(502203,13951,'pr','Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(502204,13951,'tr','Bir e-posta ÅŸablonu seÃ§in',0),(502205,13951,'pl','Wybierz szablon wiadomoÅ›ci Email',0),(502206,13951,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð·Ð° Ð¸Ð¼ÐµÐ¹Ð»',0),(502207,13951,'ur','Ø§ÛŒÚ© Ø§ÛŒ Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Ø§ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(502208,13951,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ð·Ð° Ðµ-Ð¿Ð¾ÑˆÑ‚Ñƒ',0),(502209,13951,'vi','Chá»n má»™t máº«u thÆ° Ä‘iá»‡n tá»­',0),(502210,13951,'af','Kies \'n e-pos sjabloon',0),(502211,13951,'ro','SelectaÅ£i un ÅŸablon de poÅŸtÄƒ electronicÄƒ',0),(502212,13951,'et','Valige meilisÃµnumi malli',0),(502213,13951,'si','Izberite predlogo e-poÅ¡te',0),(502214,13951,'ba','Pilih Template Email',0),(502215,13951,'nl','Een e-mailtemplate selecteren',0),(502216,13951,'fi','Valitse sÃ¤hkÃ¶postimalli',0),(502217,13951,'no','Velg en e-mal',0),(502218,13951,'da','VÃ¦lg en E-mail-skabelon',0),(502219,13951,'ko','ì´ë©”ì¼ í…œí”Œë¦¿ ì„ íƒ',0),(502220,13951,'he','×‘×—×¨ ×ª×‘× ×™×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™',0),(502221,13951,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î± Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(502222,13951,'zh','é€‰æ‹©ç”µå­é‚®ä»¶æ¨¡æ¿',0),(502223,13951,'sv','VÃ¤lj en e-postmall',0),(502224,13951,'it','Selezionare un modello di E-mail',0),(502225,13951,'tl','',0),(502226,13951,'th','à¹€à¸¥à¸·à¸­à¸à¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥',0),(502227,13951,'hi','à¤à¤• à¤ˆà¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(502228,13951,'ms','Pilih Template e-mel yang',0),(502229,13951,'ar','Ø­Ø¯Ø¯ Ù‚Ø§Ù„Ø¨ Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(502230,13951,'fr','SÃ©lectionnez un modÃ¨le d\'E-mail',0),(502231,13951,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã‚’é¸æŠžã—ã¾ã™',0),(502232,13951,'pt','Selecione um modelo de Email',0),(502233,13951,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑˆÐ°Ð±Ð»Ð¾Ð½ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(502234,13951,'es','Seleccione una plantilla de correo electrÃ³nico',0),(502235,13951,'de','WÃ¤hlen Sie eine E-Mail-Vorlage',0),(502236,13951,'en','Select An Email Template',0),(502237,13952,'is','',0),(502238,13952,'dr','Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¨Ø§ Ø¯Ø³ØªÙˆØ±Ø§Øª ÛŒØ§ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø§Ø²',0),(502239,13952,'pr','Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¨Ø§ Ø¯Ø³ØªÙˆØ±Ø§Øª ÛŒØ§ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø§Ø²',0),(502240,13952,'tr','MÃ¼ÅŸteriler sipariÅŸ veya faturalarÄ± beri',0),(502241,13952,'pl','Klienci z zamÃ³wienia lub faktury od',0),(502242,13952,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ñ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¸Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¾Ñ‚',0),(502243,13952,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª ÛŒØ§ Ø¨Ø¹Ø¯ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾',0),(502244,13952,'sr','ÐšÑƒÐ¿Ñ†Ð¸ ÑÐ° Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð° Ð¸Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð° Ð¾Ð´',0),(502245,13952,'vi','KhÃ¡ch hÃ ng vá»›i cÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng hoáº·c hÃ³a Ä‘Æ¡n tá»«',0),(502246,13952,'af','KliÃ«nte met bestellings of fakture sedert',0),(502247,13952,'ro','ClienÅ£ii cu comenzi sau facturi de',0),(502248,13952,'et','Klientidele tellimuste vÃµi arvete alates',0),(502249,13952,'si','Stranke z naloge ali raÄune od',0),(502250,13952,'ba','Pelanggan dengan pesanan atau faktur sejak',0),(502251,13952,'nl','Klanten met Orders of facturen sinds',0),(502252,13952,'fi','Asiakkaiden tilausten tai laskujen jÃ¤lkeen',0),(502253,13952,'no','Kunder med bestillinger eller fakturaer siden',0),(502254,13952,'da','Kunder med ordrer eller fakturaer siden',0),(502255,13952,'ko','ê³ ê° ì£¼ë¬¸ ë˜ëŠ” ì†¡ìž¥ ì´í›„',0),(502256,13952,'he','×œ×§×•×—×•×ª ×‘×¢×œ×™ ×”×–×ž× ×•×ª ××• ×—×©×‘×•× ×™×•×ª ×ž××–',0),(502257,13952,'el','Î¤Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î¼Îµ Ï„Î¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î® Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î±Ï€ÏŒ',0),(502258,13952,'zh','å®¢æˆ·è®¢å•æˆ–å‘ç¥¨ä»¥æ¥',0),(502259,13952,'sv','Kunder med order eller fakturor sedan',0),(502260,13952,'it','Clienti con ordini o fatture dal',0),(502261,13952,'tl','',0),(502262,13952,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆ à¸¡à¸µà¸«à¸™à¸µà¹‰à¸•à¸±à¹‰à¸‡à¹à¸•à¹ˆ',0),(502263,13952,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤†à¤¦à¥‡à¤¶ à¤¯à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥‡',0),(502264,13952,'ms','Pelanggan dengan pesanan atau invois sejak',0),(502265,13952,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…Ø¹ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡ Ø£Ùˆ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ù…Ù†Ø°',0),(502266,13952,'fr','Clients dotÃ©s de commandes ou factures depuis',0),(502267,13952,'jp','ç™ºæ³¨ã¾ãŸã¯è«‹æ±‚æ›¸ä»¥æ¥ã®ãŠå®¢æ§˜',0),(502268,13952,'pt','Clientes com pedidos ou faturas desde',0),(502269,13952,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð², Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð¸Ð»Ð¸ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ñ',0),(502270,13952,'es','Clientes con pedidos o facturas desde',0),(502271,13952,'de','Kunden mit Bestellungen oder Rechnungen seit',0),(502272,13952,'en','Customers With Orders Or Invoices Since',0),(502273,13953,'is','',0),(502274,13953,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙˆØ§Ø±Ø¯',0),(502275,13953,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙˆØ§Ø±Ø¯',0),(502276,13953,'tr','MÃ¼ÅŸteri verileri baÅŸarÄ±yla alÄ±ndÄ±',0),(502277,13953,'pl','PomyÅ›lnie zaimportowane dane klienta',0),(502278,13953,'bg','Ð”Ð°Ð½Ð½Ð¸ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(502279,13953,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆØ§Ø¦Ù Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯',0),(502280,13953,'sr','ÐšÑƒÐ¿Ñ†Ð° Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ ÐºÐ¾Ñ˜Ð¸ ÑÑƒ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸',0),(502281,13953,'vi','Dá»¯ liá»‡u khÃ¡ch hÃ ng nháº­p thÃ nh cÃ´ng',0),(502282,13953,'af','KliÃ«nt Data suksesvol ingevoer',0),(502283,13953,'ro','Client datele importate cu succes',0),(502284,13953,'et','Kliendi andmed edukalt imporditud',0),(502285,13953,'si','UspeÅ¡no uvoÅ¾eni podatki o strankah',0),(502286,13953,'ba','Data Pelanggan yang berhasil diimpor',0),(502287,13953,'nl','Klantgegevens geÃ¯mporteerd',0),(502288,13953,'fi','Asiakastietojen tuonti onnistui',0),(502289,13953,'no','Kundedata importert',0),(502290,13953,'da','Kundedata importeret',0),(502291,13953,'ko','ì„±ê³µì ìœ¼ë¡œ ê°€ì ¸ì˜¨ ê³ ê° ë°ì´í„°',0),(502292,13953,'he','× ×ª×•× ×™ ×œ×§×•×— ×™×•×‘××• ×‘×”×¦×œ×—×”',0),(502293,13953,'el','Î•Î¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î± Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï„Ï‰Î½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(502294,13953,'zh','å·²æˆåŠŸå¯¼å…¥å®¢æˆ·æ•°æ®',0),(502295,13953,'sv','Kunddata har importerats',0),(502296,13953,'it','Importato correttamente i dati dei clienti',0),(502297,13953,'tl','',0),(502298,13953,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(502299,13953,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤¯à¤¾à¤¤',0),(502300,13953,'ms','Data pelanggan yang berjaya diimport',0),(502301,13953,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(502302,13953,'fr','DonnÃ©es clients ont bien Ã©tÃ© importÃ©es',0),(502303,13953,'jp','é¡§å®¢ãƒ‡ãƒ¼ã‚¿ãŒæ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã¾ã—ãŸ',0),(502304,13953,'pt','Dados de cliente importados com Ãªxito',0),(502305,13953,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð², ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½',0),(502306,13953,'es','Importado con Ã©xito los datos del cliente',0),(502307,13953,'de','Kundendaten, die erfolgreich importiert',0),(502308,13953,'en','Customer Data Imported Successfully',0),(502309,13954,'is','',0),(502310,13954,'dr','Ù…Ø´ØªØ±ÛŒØ§Ù† ØµØ§Ø¯Ø±Ø§Øª / ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø¨Ø²Ø§Ø± ÙˆÛŒØ±Ø§ÛŒØ´',0),(502311,13954,'pr','Ù…Ø´ØªØ±ÛŒØ§Ù† ØµØ§Ø¯Ø±Ø§Øª / ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø¨Ø²Ø§Ø± ÙˆÛŒØ±Ø§ÛŒØ´',0),(502312,13954,'tr','MÃ¼ÅŸteri ihracat / ithalat dÃ¼zenleme aracÄ±',0),(502313,13954,'pl','Klienta eksportu / importu narzÄ™dzie Edycja',0),(502314,13954,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ / Ð²Ð½Ð¾Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚',0),(502315,13954,'ur','Ú©Ø³Ù¹Ù…Ø± Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº / ØªØ¯ÙˆÛŒÙ† ÛØªÚ¾ÛŒØ§Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(502316,13954,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð¸Ð·Ð²Ð¾Ð·Ð½Ð¾ / ÑƒÐ²Ð¾Ð·Ð½Ð¸Ñ… Ð°Ð»Ð°Ñ‚ÐºÐµ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(502317,13954,'vi','KhÃ¡ch hÃ ng xuáº¥t kháº©u / nháº­p kháº©u cÃ´ng cá»¥ chá»‰nh sá»­a',0),(502318,13954,'af','KliÃ«nt uitvoer / invoer redigeer instrument',0),(502319,13954,'ro','Client de Export / Import instrument de editare',0),(502320,13954,'et','Kliendi ekspordi / impordi redigeerida tÃ¶Ã¶riist',0),(502321,13954,'si','Kupec izvoz / uvoz orodje za urejanje',0),(502322,13954,'ba','Pelanggan ekspor / impor alat Edit',0),(502323,13954,'nl','Klant exporteren / importeren Edit-hulpmiddel',0),(502324,13954,'fi','Asiakkaan vienti / tuonti muokata tyÃ¶kalu',0),(502325,13954,'no','Kunden eksportere / importere redigere verktÃ¸yet',0),(502326,13954,'da','Kunde eksport / Import Rediger vÃ¦rktÃ¸j',0),(502327,13954,'ko','ê³ ê° ë‚´ë³´ë‚´ê¸°/ê°€ì ¸ì˜¤ê¸° íŽ¸ì§‘ ë„êµ¬',0),(502328,13954,'he','×œ×§×•×—×•×ª ×™×¦×•× / ×™×‘×•× ×›×œ×™ ×¢×¨×™×›×”',0),(502329,13954,'el','Î ÎµÎ»Î¬Ï„Î· ÎµÎ¾Î±Î³Ï‰Î³Î® / ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÏÎ³Î±Î»ÎµÎ¯Î¿',0),(502330,13954,'zh','å®¢æˆ·å‡ºå£/è¿›å£ç¼–è¾‘å·¥å…·',0),(502331,13954,'sv','Kunden Exportera / importera redigera verktyg',0),(502332,13954,'it','Cliente l\'esportazione / importazione strumento Edit',0),(502333,13954,'tl','',0),(502334,13954,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸ªà¹ˆà¸‡à¸­à¸­à¸ / à¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¹à¸à¹‰à¹„à¸‚',0),(502335,13954,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ / à¤†à¤¯à¤¾à¤¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤‰à¤ªà¤•à¤°à¤£',0),(502336,13954,'ms','Pelanggan Eksport / Import alat Edit',0),(502337,13954,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ØªØµØ¯ÙŠØ±/Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£Ø¯Ø§Ø© ØªØ­Ø±ÙŠØ±',0),(502338,13954,'fr','Client Export / Import outil d\'Ã©dition',0),(502339,13954,'jp','é¡§å®¢ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ/ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®ç·¨é›†ãƒ„ãƒ¼ãƒ«',0),(502340,13954,'pt','Cliente exportar / importar ferramenta editar',0),(502341,13954,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° / Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(502342,13954,'es','ExportaciÃ³n / importaciÃ³n herramienta de ediciÃ³n de cliente',0),(502343,13954,'de','Kunden exportieren / importieren-Bearbeiten-Werkzeug',0),(502344,13954,'en','Customer Export / Import Edit Tool',0),(502345,13955,'is','',0),(502346,13955,'dr','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØµØ§Ø¯Ø±Ø§Øª',0),(502347,13955,'pr','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØµØ§Ø¯Ø±Ø§Øª',0),(502348,13955,'tr','Gemi iÃ§in bilgi verme',0),(502349,13955,'pl','Eksport statku info',0),(502350,13955,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±-Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(502351,13955,'ur','Ú©Ø´ØªÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(502352,13955,'sr','Ð˜Ð·Ð²ÐµÐ·Ð¸ Ð±Ñ€Ð¾Ð´ Ñƒ Ð˜Ð½Ñ„Ð¾',0),(502353,13955,'vi','Xuáº¥t kháº©u tÃ u Ä‘á»ƒ thÃ´ng tin',0),(502354,13955,'af','Skip na Info uitvoer',0),(502355,13955,'ro','NavÄƒ de export la Info',0),(502356,13955,'et','Ekspordi laeva Info',0),(502357,13955,'si','Ladje izvoznih info',0),(502358,13955,'ba','Ekspor kapal untuk Info',0),(502359,13955,'nl','Exporteren van schip naar Info',0),(502360,13955,'fi','Aluksen vieminen Info',0),(502361,13955,'no','Eksportere skipet til Info',0),(502362,13955,'da','Eksportere skib til Info',0),(502363,13955,'ko','ìˆ˜ì¶œ ë°° ì •ë³´ë¥¼',0),(502364,13955,'he','×™×™×¦×•× ×œ×ž×©×œ×•×— ×ž×™×“×¢',0),(502365,13955,'el','Î•Î¾Î±Î³Ï‰Î³Î® Ï€Î»Î¿Î¯Î¿ ÏƒÎµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(502366,13955,'zh','å‡ºå£èˆ¹èˆ¶ä¿¡æ¯',0),(502367,13955,'sv','Exportera fartyg till information',0),(502368,13955,'it','Esportazione nave info',0),(502369,13955,'tl','',0),(502370,13955,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(502371,13955,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(502372,13955,'ms','Mengeksport kapal ke Info',0),(502373,13955,'ar','ØªØµØ¯ÙŠØ± Ø§Ù„Ø³ÙÙ† Ù„Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(502374,13955,'fr','Exportation de navire-info',0),(502375,13955,'jp','èˆ¹ã®æƒ…å ±ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(502376,13955,'pt','Navio de exportaÃ§Ã£o de informaÃ§Ã£o',0),(502377,13955,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð² Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(502378,13955,'es','Nave de exportaciÃ³n a Info',0),(502379,13955,'de','Export-Schiff zu Info',0),(502380,13955,'en','Export Ship To Info',0),(502381,13956,'is','',0),(502382,13956,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ù‚Ø¨Ù„ Ù…Ø´ØªØ±ÛŒ Ù¾Ø±ÙˆÙ†Ø¯Ù‡ ØµØ§Ø¯Ø± Ú©Ø±Ø¯Ù†',0),(502383,13956,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ù‚Ø¨Ù„ Ù…Ø´ØªØ±ÛŒ Ù¾Ø±ÙˆÙ†Ø¯Ù‡ ØµØ§Ø¯Ø± Ú©Ø±Ø¯Ù†',0),(502384,13956,'tr','Ã–nceki mÃ¼ÅŸteri verme dosyasÄ± al',0),(502385,13956,'pl','Plik eksportu importu przed klienta',0),(502386,13956,'bg','Ð’Ð½Ð¾Ñ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚ÐµÐ½ Ñ„Ð°Ð¹Ð»',0),(502387,13956,'ur','Ù¾ÛÙ„Û’ Ú¯Ø§ÛÚ© Ø¨Ø±Ø¢Ù…Ø¯ Ù…Ø³Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(502388,13956,'sr','Ð˜Ð³ÑƒÐ¼Ð°Ð½ ÐºÑƒÐ¿Ñ†Ð° ÑƒÐ²Ð¾Ð· Ð¸Ð·Ð²Ð¾Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(502389,13956,'vi','Nháº­p trÆ°á»›c khi khÃ¡ch hÃ ng xuáº¥t kháº©u táº­p tin',0),(502390,13956,'af','Voer vooraf kliÃ«nt uitvoer lÃªer',0),(502391,13956,'ro','FiÅŸier de Export import prealabilÄƒ client',0),(502392,13956,'et','Impordi eelneva kliendi ekspordi fail',0),(502393,13956,'si','Izvoz datoteke za uvoz predhodno kupca',0),(502394,13956,'ba','File sebelumnya pelanggan ekspor impor',0),(502395,13956,'nl','Import voorafgaande klant exportbestand',0),(502396,13956,'fi','Tuontitiedoston ennen asiakkaan vienti',0),(502397,13956,'no','Importer tidligere kunde eksportfilen',0),(502398,13956,'da','Importer forudgÃ¥ende kunde eksportfil',0),(502399,13956,'ko','ê°€ì ¸ì˜¤ê¸° ì‚¬ì „ ê³ ê° ë‚´ë³´ë‚´ê¸° íŒŒì¼',0),(502400,13956,'he','×™×™×‘×•× ×§×•×‘×¥ ×”×™×™×¦×•× ×œ×§×•×—×•×ª ×§×•×“×ž×™×',0),(502401,13956,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï… ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ ÎµÎº Ï„Ï‰Î½ Ï€ÏÎ¿Ï„Î­ÏÏ‰Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(502402,13956,'zh','å¯¼å…¥äº‹å…ˆå®¢æˆ·å¯¼å‡ºæ–‡ä»¶',0),(502403,13956,'sv','Import Export-tidigare kundregister',0),(502404,13956,'it','Importazione File di esportazione preventiva del cliente',0),(502405,13956,'tl','',0),(502406,13956,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸¥à¸¹à¸à¸„à¹‰à¸²à¸à¹ˆà¸­à¸™à¸ªà¹ˆà¸‡à¸­à¸­à¸à¹à¸Ÿà¹‰à¸¡',0),(502407,13956,'hi','à¤†à¤¯à¤¾à¤¤ à¤ªà¥‚à¤°à¥à¤µ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤²',0),(502408,13956,'ms','Fail eksport import pelanggan terlebih dahulu',0),(502409,13956,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù„Ù Ø§Ù„ØªØµØ¯ÙŠØ± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(502410,13956,'fr','Fichier d\'exportation importation prÃ©alable client',0),(502411,13956,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆå‰ã«é¡§å®¢ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«',0),(502412,13956,'pt','Arquivo de exportaÃ§Ã£o importaÃ§Ã£o prÃ©via do cliente',0),(502413,13956,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ñ„Ð°Ð¹Ð»Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° Ð´Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(502414,13956,'es','Archivo de exportaciÃ³n importaciÃ³n previa del cliente',0),(502415,13956,'de','Vorherige Kunden-Export-Datei importieren',0),(502416,13956,'en','Import Prior Customer Export File',0),(502417,13957,'is','',0),(502418,13957,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† Ø§Ø¨Ø²Ø§Ø± Ø¨Ù‡ ØµØ§Ø¯Ø±Ø§Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ Ø®ÙˆØ¯ Ø±Ø§ Ø¯Ø± ÙØ±Ù…Øª CSV Ø§ÛŒØ¬Ø§Ø¯ ØªØºÛŒÛŒØ±Ø§Øª Ùˆ reimport.',0),(502419,13957,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§ÛŒÙ† Ø§Ø¨Ø²Ø§Ø± Ø¨Ù‡ ØµØ§Ø¯Ø±Ø§Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ Ø®ÙˆØ¯ Ø±Ø§ Ø¯Ø± ÙØ±Ù…Øª CSV Ø§ÛŒØ¬Ø§Ø¯ ØªØºÛŒÛŒØ±Ø§Øª Ùˆ reimport.',0),(502420,13957,'tr','MÃ¼ÅŸteri verileri CSV biÃ§iminde verin, deÄŸiÅŸiklikleri yapÄ±n ve reimport iÃ§in bu aracÄ± kullanÄ±n.',0),(502421,13957,'pl','NarzÄ™dzie to sÅ‚uÅ¼y do eksportowania danych klienta w formacie CSV, zmiany i ponownie zaimportowaÄ‡.',0),(502422,13957,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚, Ð·Ð° Ð´Ð° ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ Ð´Ð°Ð½Ð½Ð¸ Ð² CSV Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚, Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¸ Ð²Ð½ÐµÑÐµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾.',0),(502423,13957,'ur','CSV ÙˆØ¶Ø¹ Ù…ÛŒÚº Ø§Ù¾Ù†Û’ Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆØ§Ø¦Ù Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚºØŒ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø±ÛŒØ§Ù…Ù¾ÙˆØ±Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ Ù¹ÙˆÙ„ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Û”',0),(502424,13957,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ð°Ð»Ð°Ñ‚ Ð·Ð° Ð¸Ð·Ð²Ð¾Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñƒ Ð¦Ð¡Ð’ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ ÐºÑƒÐ¿Ñ†Ð°, Ð¸Ð·Ð¼ÐµÐ½Ðµ Ð¸ Ð¿Ð¾Ð½Ð¾Ð²Ð¾ ÑƒÐ²Ð¾Ð·Ð¸Ñ‚Ðµ.',0),(502425,13957,'vi','Sá»­ dá»¥ng cÃ´ng cá»¥ nÃ y Ä‘á»ƒ xuáº¥t kháº©u dá»¯ liá»‡u khÃ¡ch hÃ ng cá»§a báº¡n á»Ÿ Ä‘á»‹nh dáº¡ng CSV, thá»±c hiá»‡n thay Ä‘á»•i vÃ  reimport.',0),(502426,13957,'af','Gebruik hierdie instrument om jou kliÃ«nt se data in CSV formaat uitvoer, maak veranderinge en reimport.',0),(502427,13957,'ro','UtilizaÅ£i acest instrument pentru a exporta datele clientului Ã®n CSV format, a face modificÄƒri ÅŸi reimportaÅ£i.',0),(502428,13957,'et','Selle tÃ¶Ã¶riistaga saate eksportida oma klientide andmeid CSV-vormingus, teha muudatusi ja importige uuesti.',0),(502429,13957,'si','Uporabite to orodje za izvoz kupca podatkov v CSV format, spreminjati in znova uvozite.',0),(502430,13957,'ba','Gunakan tool ini untuk mengekspor data pelanggan dalam CSV format, membuat perubahan dan reimport.',0),(502431,13957,'nl','Gebruik dit hulpmiddel om uw klantgegevens in CSV-indeling exporteren, wijzigingen aanbrengen en opnieuw importeren.',0),(502432,13957,'fi','TÃ¤mÃ¤n tyÃ¶kalun avulla voit viedÃ¤ asiakkaan tiedot CSV-muodossa, muuttaa ja tuoda uudelleen.',0),(502433,13957,'no','Bruk dette verktÃ¸yet til Ã¥ eksportere kundedataene i CSV-format, gjÃ¸r endringene og importerer.',0),(502434,13957,'da','Brug dette vÃ¦rktÃ¸j til at eksportere dine kundedata i CSV-format, foretage Ã¦ndringer og importere igen.',0),(502435,13957,'ko','ì´ ë„êµ¬ë¥¼ ì‚¬ìš© í•˜ ì—¬ CSV í˜•ì‹ìœ¼ë¡œ ê³ ê° ë°ì´í„° ë‚´ë³´ë‚´ê¸°, ë³€ê²½ ë° ë‹¤ì‹œ ê°€ì ¸ì˜µë‹ˆë‹¤.',0),(502436,13957,'he','×”×©×ª×ž×© ×‘×›×œ×™ ×–×” ×›×“×™ ×œ×™×™×¦× ××ª ×”× ×ª×•× ×™× ×œ×œ×§×•×— ×©×œ×š ×‘×ª×‘× ×™×ª CSV, ×©×™× ×•×™×™×, ×œ×™×™×‘× ×ž×—×“×©.',0),(502437,13957,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ Î³Î¹Î± Î½Î± ÎµÎ¾Î±Î³Î¬Î³ÎµÏ„Îµ Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· ÏƒÎµ Î¼Î¿ÏÏ†Î® CSV, ÎµÏ€Î¹Ï†Î­ÏÎ¿Ï…Î¼Îµ Î±Î»Î»Î±Î³Î­Ï‚ ÎºÎ±Î¹ ÎµÏ€Î±Î½Î±Î»Î¬Î²ÎµÏ„Îµ Ï„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®.',0),(502438,13957,'zh','ä½¿ç”¨æ­¤å·¥å…·å¯å¯¼å‡º CSV æ ¼å¼æ‚¨å®¢æˆ·æ•°æ®ã€ æ›´æ”¹å’Œé‡æ–°å¯¼å…¥ã€‚',0),(502439,13957,'sv','Det hÃ¤r verktyget exportera dina kunddata i CSV-format, gÃ¶ra Ã¤ndringar och importera igen.',0),(502440,13957,'it','Utilizzare questo strumento per esportare i dati del cliente in formato CSV, apportare modifiche e reimportare.',0),(502441,13957,'tl','',0),(502442,13957,'th','à¹ƒà¸Šà¹‰à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¸™à¸µà¹‰à¹€à¸žà¸·à¹ˆà¸­à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸™à¸£à¸¹à¸›à¹à¸šà¸š CSV à¸—à¸³à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡ à¹à¸¥à¸°à¸™à¸³à¹€à¸‚à¹‰à¸²à¸­à¸µà¸à¸„à¸£à¸±à¹‰à¸‡',0),(502443,13957,'hi','à¤‡à¤¸ à¤‰à¤ªà¤•à¤°à¤£ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤ªà¤•à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¡à¥‡à¤Ÿà¤¾ CSV à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚, à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤° à¤”à¤° à¤ªà¥à¤¨à¤°à¥à¤¨à¤¿à¤',0),(502444,13957,'ms','Menggunakan alat ini untuk mengeksport data pelanggan anda dalam CSV format, membuat perubahan dan reimport.',0),(502445,13957,'ar','Ø§Ø³ØªØ®Ø¯Ù… Ù‡Ø°Ù‡ Ø§Ù„Ø£Ø¯Ø§Ø© Ù„ØªØµØ¯ÙŠØ± Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ ÙÙŠ ØªÙ†Ø³ÙŠÙ‚ CSVØŒ ÙˆØ¥Ø¬Ø±Ø§Ø¡ ØªØºÙŠÙŠØ±Ø§Øª ÙˆÙ‚Ù…Øª Ø¨Ø¥Ø¹Ø§Ø¯Ø© Ø§Ø³ØªÙŠØ±Ø§Ø¯.',0),(502446,13957,'fr','Utilisez cet outil pour exporter vos donnÃ©es de client au format CSV, d\'apporter des modifications et de rÃ©importer.',0),(502447,13957,'jp','CSV å½¢å¼ã§é¡§å®¢ãƒ‡ãƒ¼ã‚¿ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã€å¤‰æ›´ã€å†ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹ã«ã¯ã€ã“ã®ãƒ„ãƒ¼ãƒ«ã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(502448,13957,'pt','Use esta ferramenta para exportar seus dados de cliente no formato CSV, fazer alteraÃ§Ãµes e reimportar.',0),(502449,13957,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ ÑÑ‚Ð¾Ñ‚ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ Ð´Ð»Ñ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° Ð²Ð°ÑˆÐ¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð² Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ CSV, Ð²Ð½ÐµÑÑ‚Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¸ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐ¹Ñ‚Ðµ.',0),(502450,13957,'es','Utilice esta herramienta para exportar los datos de sus clientes en formato CSV, realizar cambios y volver a importar.',0),(502451,13957,'de','Mithilfe dieses Tools kÃ¶nnen Sie Ihre Kundendaten im CSV-Format exportieren, Ã„nderungen vornehmen und neu importieren.',0),(502452,13957,'en','Use this tool to export your customer data in CSV format, make changes and reimport.',0),(502453,13958,'is','',0),(502454,13958,'dr','Ø´Ø±Ø­ Ø§ÛŒÙ…ÛŒÙ„ ÛŒÚ©ÛŒ',0),(502455,13958,'pr','Ø´Ø±Ø­ Ø§ÛŒÙ…ÛŒÙ„ ÛŒÚ©ÛŒ',0),(502456,13958,'tr','Bir e-posta aÃ§Ä±klamasÄ±',0),(502457,13958,'pl','Napisz jeden opis',0),(502458,13958,'bg','ÐŸÐ¸ÑˆÐµÑ‚Ðµ ÐµÐ´Ð½Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(502459,13958,'ur','Ø§ÛŒÚ© ÙˆØ¶Ø§Ø­Øª Ú©Ùˆ Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(502460,13958,'sr','Ð• -Ð¿Ð¾ÑˆÑ‚Ð° Ñ˜ÐµÐ´Ð°Ð½ Ð¾Ð¿Ð¸Ñ',0),(502461,13958,'vi','Gá»­i email cho má»™t mÃ´ táº£',0),(502462,13958,'af','E-pos een Beskrywing',0),(502463,13958,'ro','E-mail o descriere',0),(502464,13958,'et','Kirjuta Ã¼ks kirjeldus',0),(502465,13958,'si','Email en opis',0),(502466,13958,'ba','Email satu Deskripsi',0),(502467,13958,'nl','E een beschrijving',0),(502468,13958,'fi','LÃ¤hetÃ¤ yksi kuvaus',0),(502469,13958,'no','E-post en beskrivelse',0),(502470,13958,'da','Email en beskrivelse',0),(502471,13958,'ko','ì´ë©”ì¼ í•˜ë‚˜ ì„¤ëª…',0),(502472,13958,'he','×ª×™××•×¨ ××™×ž×™×™×œ ××—×“',0),(502473,13958,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î­Î½Î± email',0),(502474,13958,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€ä¸€ä¸ªæè¿°',0),(502475,13958,'sv','E en beskrivning',0),(502476,13958,'it','E-mail una descrizione',0),(502477,13958,'tl','',0),(502478,13958,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸«à¸™à¸¶à¹ˆà¸‡',0),(502479,13958,'hi','à¤ˆà¤®à¥‡à¤² à¤à¤• à¤µà¤¿à¤µà¤°à¤£',0),(502480,13958,'ms','E-mel satu keterangan',0),(502481,13958,'ar','ÙˆØµÙ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ ÙˆØ§Ø­Ø¯',0),(502482,13958,'fr','Envoyez une Description',0),(502483,13958,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« 1 ã®èª¬æ˜Ž',0),(502484,13958,'pt','E-mail uma descriÃ§Ã£o',0),(502485,13958,'ru','ÐžÐ´Ð½Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(502486,13958,'es','Correo electrÃ³nico una descripciÃ³n',0),(502487,13958,'de','E-Mail Beschreibung',0),(502488,13958,'en','Email One Description',0),(502489,13959,'is','',0),(502490,13959,'dr','ØªÙ„ÙÙ† 4 Ù†Ø¸Ø±',0),(502491,13959,'pr','ØªÙ„ÙÙ† 4 Ù†Ø¸Ø±',0),(502492,13959,'tr','DÃ¶rt yorum telefon',0),(502493,13959,'pl','Telefon cztery komentarz',0),(502494,13959,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ Ñ‡ÐµÑ‚Ð¸Ñ€Ð¸ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(502495,13959,'ur','Ú†Ø§Ø± ØªØ¨ØµØ±Û ÙÙˆÙ†',0),(502496,13959,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 4 ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð°',0),(502497,13959,'vi','Äiá»‡n thoáº¡i 4 bÃ¬nh luáº­n',0),(502498,13959,'af','Bel vier kommentaar',0),(502499,13959,'ro','Telefon patru comentariu',0),(502500,13959,'et','Telefoni 4 kommentaari',0),(502501,13959,'si','Telefon Å¡tiri komentar',0),(502502,13959,'ba','Telepon empat komentar',0),(502503,13959,'nl','Telefoon vier commentaar',0),(502504,13959,'fi','Puhelimen neljÃ¤ kommentti',0),(502505,13959,'no','Telefonen fire kommentar',0),(502506,13959,'da','Telefon fire kommentar',0),(502507,13959,'ko','ì „í™” 4 ê°œì˜ ëŒ“ê¸€',0),(502508,13959,'he','×˜×œ×¤×•×Ÿ ×ª×’×•×‘×” 4',0),(502509,13959,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ Ï„Î­ÏƒÏƒÎµÏÎ¹Ï‚ ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(502510,13959,'zh','ç”µè¯å››è¯„è®º',0),(502511,13959,'sv','Telefon fyra kommentar',0),(502512,13959,'it','Telefono quattro commento',0),(502513,13959,'tl','',0),(502514,13959,'th','à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œà¸„à¸´à¸” 4',0),(502515,13959,'hi','à¤šà¤¾à¤° à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤«à¥‹à¤¨',0),(502516,13959,'ms','Telefon empat komen',0),(502517,13959,'ar','Ù‡Ø§ØªÙ ØªØ¹Ù„ÙŠÙ‚ Ø£Ø±Ø¨Ø¹',0),(502518,13959,'fr','TÃ©lÃ©phone quatre commentaire',0),(502519,13959,'jp','é›»è©±ã® 4 ã¤ã®ã‚³ãƒ¡ãƒ³ãƒˆ',0),(502520,13959,'pt','Telefone 4 comentÃ¡rio',0),(502521,13959,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ Ñ‡ÐµÑ‚Ñ‹Ñ€Ðµ ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹',0),(502522,13959,'es','TelÃ©fono cuatro comentario',0),(502523,13959,'de','Telefon vier Kommentar',0),(502524,13959,'en','Phone Four Comment',0),(502525,13960,'is','',0),(502526,13960,'dr','ØªÙ„ÙÙ† Ø³Ù‡ Ù†Ø¸Ø±',0),(502527,13960,'pr','ØªÙ„ÙÙ† Ø³Ù‡ Ù†Ø¸Ø±',0),(502528,13960,'tr','ÃœÃ§ yorum telefon',0),(502529,13960,'pl','Telefon 3 komentarz',0),(502530,13960,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ Ñ‚Ñ€Ð¸ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(502531,13960,'ur','ØªÛŒÙ† ØªØ¨ØµØ±Û ÙÙˆÙ†',0),(502532,13960,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 3 ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð°',0),(502533,13960,'vi','Äiá»‡n thoáº¡i ba bÃ¬nh luáº­n',0),(502534,13960,'af','Bel drie kommentaar',0),(502535,13960,'ro','Telefon trei comentariu',0),(502536,13960,'et','Telefoni kolm kommentaari',0),(502537,13960,'si','Telefon tri komentar',0),(502538,13960,'ba','Telepon tiga komentar',0),(502539,13960,'nl','Telefoon drie commentaar',0),(502540,13960,'fi','Puhelimen kolme kommentti',0),(502541,13960,'no','Telefon tre kommentar',0),(502542,13960,'da','Telefon tre kommentar',0),(502543,13960,'ko','ì „í™” 3 ì½”ë©˜íŠ¸',0),(502544,13960,'he','×˜×œ×¤×•×Ÿ ×ª×’×•×‘×” 3',0),(502545,13960,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ Ï„ÏÎµÎ¹Ï‚ ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(502546,13960,'zh','ç”µè¯ä¸‰ä¸ªè¯„è®º',0),(502547,13960,'sv','Telefon tre kommentar',0),(502548,13960,'it','Telefono tre commento',0),(502549,13960,'tl','',0),(502550,13960,'th','à¸„à¸§à¸²à¸¡à¸„à¸´à¸”à¹€à¸«à¹‡à¸™ 3 à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œ',0),(502551,13960,'hi','à¤¤à¥€à¤¨ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤«à¥‹à¤¨',0),(502552,13960,'ms','Telefon tiga komen',0),(502553,13960,'ar','Ù‡Ø§ØªÙ Ø§Ù„ØªØ¹Ù„ÙŠÙ‚ Ø«Ù„Ø§Ø«Ø©',0),(502554,13960,'fr','TÃ©lÃ©phone trois commentaire',0),(502555,13960,'jp','é›»è©±ã® 3 ã¤ã®ã‚³ãƒ¡ãƒ³ãƒˆ',0),(502556,13960,'pt','Telefone trÃªs comentÃ¡rio',0),(502557,13960,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ Ñ‚Ñ€Ð¸ ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ñ',0),(502558,13960,'es','TelÃ©fono tres comentario',0),(502559,13960,'de','Telefon drei Kommentar',0),(502560,13960,'en','Phone Three Comment',0),(502561,13961,'is','',0),(502562,13961,'dr','Ú©Ø´ØªÛŒ Ø¨Ù‡ ID',0),(502563,13961,'pr','Ú©Ø´ØªÛŒ Ø¨Ù‡ ID',0),(502564,13961,'tr','KimliÄŸi iÃ§in gemi',0),(502565,13961,'pl','Statek do ID',0),(502566,13961,'bg','ÐšÐ¾Ñ€Ð°Ð± ÐºÑŠÐ¼ Ð˜Ð”',0),(502567,13961,'ur','Ø´Ù†Ø§Ø®Øª Ú©Û’ Ù„Ø¦Û’ Ø¬ÛØ§Ø²',0),(502568,13961,'sr','Ð‘Ñ€Ð¾Ð´ Ð·Ð° Ð·Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ',0),(502569,13961,'vi','Gá»­i Ä‘áº¿n ID',0),(502570,13961,'af','Skip na ID',0),(502571,13961,'ro','NavÄƒ la ID',0),(502572,13961,'et','Kauba saaja ID',0),(502573,13961,'si','Dostava â€“ ID',0),(502574,13961,'ba','Kapal ke ID',0),(502575,13961,'nl','Verzenden naar ID',0),(502576,13961,'fi','Toimitusosoitteen tunnus',0),(502577,13961,'no','Sender ID',0),(502578,13961,'da','Skib til ID',0),(502579,13961,'ko','Id ì œê³µ',0),(502580,13961,'he','×œ×ž×©×œ×•×— ×ž×–×”×”',0),(502581,13961,'el','Î Î»Î¿Î¯Î¿ Î½Î± ID',0),(502582,13961,'zh','èˆ¹åˆ° ID',0),(502583,13961,'sv','Fartyget till ID',0),(502584,13961,'it','Spedire a ID',0),(502585,13961,'tl','',0),(502586,13961,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸£à¸«à¸±à¸ª',0),(502587,13961,'hi','à¤†à¤ˆà¤¡à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(502588,13961,'ms','Kapal ke ID',0),(502589,13961,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ù…Ø¹Ø±Ù',0),(502590,13961,'fr','ExpÃ©dier Ã  ID',0),(502591,13961,'jp','ID ã«å‡ºè·ã—ã¾ã™ã€‚',0),(502592,13961,'pt','Navio para ID',0),(502593,13961,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ ID',0),(502594,13961,'es','Enviar ID',0),(502595,13961,'de','Ship To ID',0),(502596,13961,'en','Ship To ID',0),(502597,13962,'is','',0),(502598,13962,'dr','Ø¬Ù„Ø¯ ÙØ§ÛŒÙ„',0),(502599,13962,'pr','Ø¬Ù„Ø¯ ÙØ§ÛŒÙ„',0),(502600,13962,'tr','Kapak dosyasÄ±',0),(502601,13962,'pl','Pokrycie pliku',0),(502602,13962,'bg','Ð¤Ð°Ð¹Ð» Ñ Ñ‚Ð¸Ñ‚ÑƒÐ»Ð½Ð°',0),(502603,13962,'ur','Ù…Ø³Ù„ Ú©Ø§ Ø§Ø­Ø§Ø·Û',0),(502604,13962,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð½Ð°ÑÐ»Ð¾Ð²Ð½Ðµ',0),(502605,13962,'vi','Bao gá»“m cÃ¡c táº­p tin',0),(502606,13962,'af','Bedek lÃªer',0),(502607,13962,'ro','Coperta dosar',0),(502608,13962,'et','Kate faili',0),(502609,13962,'si','Kritje datoteke',0),(502610,13962,'ba','Sampul File',0),(502611,13962,'nl','Dekking van bestand',0),(502612,13962,'fi','Kansi tiedosto',0),(502613,13962,'no','Dekke fil',0),(502614,13962,'da','DÃ¦kke fil',0),(502615,13962,'ko','í‘œì§€ íŒŒì¼',0),(502616,13962,'he','×œ×›×¡×•×ª ××ª ×”×§×•×‘×¥',0),(502617,13962,'el','ÎšÎ¬Î»Ï…ÏˆÎ· Î±ÏÏ‡ÎµÎ¯Î¿',0),(502618,13962,'zh','å°é¢æ–‡ä»¶',0),(502619,13962,'sv','TÃ¤cka fil',0),(502620,13962,'it','Copertina File',0),(502621,13962,'tl','',0),(502622,13962,'th','à¹à¸Ÿà¹‰à¸¡à¹ƒà¸šà¸›à¸°à¸«à¸™à¹‰à¸²',0),(502623,13962,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤•à¤µà¤°',0),(502624,13962,'ms','Melindungi fail',0),(502625,13962,'ar','ØªØºØ·ÙŠØ© Ø§Ù„Ù…Ù„Ù',0),(502626,13962,'fr','Couverture de fichier',0),(502627,13962,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ã‚«ãƒãƒ¼ã—ã¾ã™ã€‚',0),(502628,13962,'pt','Arquivo de capa',0),(502629,13962,'ru','Ð¤Ð°Ð¹Ð» Ð¾Ð±Ð»Ð¾Ð¶ÐºÐ¸',0),(502630,13962,'es','Cubierta de archivo',0),(502631,13962,'de','Cover-Datei',0),(502632,13962,'en','Cover File',0),(502633,13963,'is','',0),(502634,13963,'dr','Ù¾Ø³Øª Ù…Ø§Ù‡ Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(502635,13963,'pr','Ù¾Ø³Øª Ù…Ø§Ù‡ Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(502636,13963,'tr','Ay geÃ§ersiz mesaja',0),(502637,13963,'pl','Po miesiÄ…cu nieprawidÅ‚owe',0),(502638,13963,'bg','ÐŸÐ¾ÑÑ‚ Ð·Ð° Ð¼ÐµÑÐµÑ† Ð½ÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½',0),(502639,13963,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ù…ÛÛŒÙ†Û Ú©Ùˆ Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº',0),(502640,13963,'sr','ÐžÐ±Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ð½Ð° Ð¼ÐµÑÐµÑ† Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð¸',0),(502641,13963,'vi','ÄÄƒng thÃ¡ng khÃ´ng há»£p lá»‡',0),(502642,13963,'af','Pos aan maand ongeldig',0),(502643,13963,'ro','Post pentru luna nevalidÄƒ',0),(502644,13963,'et','Post kuu on kehtetu',0),(502645,13963,'si','Post na mesec neveljaven',0),(502646,13963,'ba','Posting ke bulan valid',0),(502647,13963,'nl','Post naar maand ongeldig',0),(502648,13963,'fi','Post kuukauden virheellinen',0),(502649,13963,'no','Post til mÃ¥ned ugyldig',0),(502650,13963,'da','IndlÃ¦g til mÃ¥ned ugyldig',0),(502651,13963,'ko','ë‹¬ ìž˜ëª» ëœ ê²Œì‹œë¬¼',0),(502652,13963,'he','×¤×•×¡×˜ ×—×•×“×© ×œ× ×›×™×',0),(502653,13963,'el','Î˜Î­ÏƒÎ· Î½Î± Î¼Î®Î½Î± Î¬ÎºÏ…ÏÎ¿',0),(502654,13963,'zh','å‘˜é¢æ”¹æœˆæ— æ•ˆ',0),(502655,13963,'sv','Post till mÃ¥nad ogiltigt',0),(502656,13963,'it','Post per mese invalido',0),(502657,13963,'tl','',0),(502658,13963,'th','à¸›à¸£à¸°à¸à¸²à¸¨à¹€à¸”à¸·à¸­à¸™à¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(502659,13963,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤®à¤¹à¥€à¤¨à¥‡ à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(502660,13963,'ms','Pos ke bulan tidak sah',0),(502661,13963,'ar','ÙˆØ¸ÙŠÙØ© Ù„ØµØ§Ù„Ø­ Ø§Ù„Ø´Ù‡Ø±',0),(502662,13963,'fr','Post Ã  mois invalide',0),(502663,13963,'jp','ç„¡åŠ¹ãªæœˆã«ãƒã‚¹ãƒˆ',0),(502664,13963,'pt','Post para mÃªs invÃ¡lido',0),(502665,13963,'ru','ÐŸÐ¾ÑÑ‚ Ð² Ð¼ÐµÑÑÑ† Ð½ÐµÐ´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼',0),(502666,13963,'es','Post al mes invÃ¡lido',0),(502667,13963,'de','Beitrag Monat ungÃ¼ltig',0),(502668,13963,'en','Post To Month Invalid',0),(502669,13964,'is','',0),(502670,13964,'dr','Ø­Ø§Ø´ÛŒÙ‡ Ø³ÙˆØ¯ Ø­Ø¯Ø§Ù‚Ù„ Ù‚ÛŒÙ…Øª ØªØºÛŒÛŒØ± Ù…Ø³Ø¯ÙˆØ¯ Ú©Ø±Ø¯Ù†',0),(502671,13964,'pr','Ø­Ø§Ø´ÛŒÙ‡ Ø³ÙˆØ¯ Ø­Ø¯Ø§Ù‚Ù„ Ù‚ÛŒÙ…Øª ØªØºÛŒÛŒØ± Ù…Ø³Ø¯ÙˆØ¯ Ú©Ø±Ø¯Ù†',0),(502672,13964,'tr','En dÃ¼ÅŸÃ¼k kar marjÄ± iÃ§in fiyat deÄŸiÅŸtirme engelleme',0),(502673,13964,'pl','Minimalnej marÅ¼y zysku za cenÄ™ zmiany, blokowanie',0),(502674,13964,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° Ð·Ð° Ñ†ÐµÐ½Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(502675,13964,'ur','Ú©ÛŒ Ù‚ÛŒÙ…Øª Ú©Û’ Ù„Ø¦Û’ Ú©Ù… Ø§Ø² Ú©Ù… Ù¾ÛŒÚ†ÛŒØ¯Û ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù„Ø§Ú© Ú©Ø± Ø±ÛÛŒ',0),(502676,13964,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° ÑÑ‚Ð¾Ð¿Ð° Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð° Ð·Ð° Ñ†ÐµÐ½Ñƒ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ð¸ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°',0),(502677,13964,'vi','Tá»‘i thiá»ƒu lá»£i nhuáº­n cho giÃ¡ thay Ä‘á»•i cháº·n',0),(502678,13964,'af','Minimum winsmarge vir prys verander blokkeer',0),(502679,13964,'ro','Marja de Profit minim pentru preÅ£ schimba blocarea',0),(502680,13964,'et','Minimaalne kasumimarginaal hinna muutus blokeerimine',0),(502681,13964,'si','Minimalne stopnje dobiÄka za ceno spremeniti blokiranje',0),(502682,13964,'ba','Margin keuntungan minimum untuk harga mengubah memblokir',0),(502683,13964,'nl','Minimale winstmarge voor prijs wijzigen blokkeren',0),(502684,13964,'fi','VÃ¤himmÃ¤isvoittomarginaalia hinta muuttaa esto',0),(502685,13964,'no','Minimum fortjenestemargin For pris endre blokkerer',0),(502686,13964,'da','Mindste fortjenstmargen For pris Ã¦ndres blokering',0),(502687,13964,'ko','ê°€ê²©ì— ëŒ€ í•œ ìµœì†Œ ì´ìµ ë§ˆì§„ ë³€ê²½ ì°¨ë‹¨',0),(502688,13964,'he','×©×•×œ×™ ×”×¨×•×•×— ×”×ž×™× ×™×ž×œ×™ ×¢×‘×•×¨ ×ž×—×™×¨ ×œ×©× ×•×ª ×—×•×¡×',0),(502689,13964,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î¿ Ï€ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ ÎºÎ­ÏÎ´Î¿Ï…Ï‚ Î³Î¹Î± Ï„Î¹Î¼Î® Î±Î»Î»Î¬Î¾ÎµÎ¹ ÎºÎ»ÎµÎ¯Î´Ï‰Î¼Î±',0),(502690,13964,'zh','ä»·æ ¼æœ€ä½Žåˆ©æ¶¦çŽ‡å˜åŒ–é˜»å¡ž',0),(502691,13964,'sv','Minsta vinstmarginal fÃ¶r pris Ã¤ndra blockering',0),(502692,13964,'it','Minimo margine di profitto per il prezzo cambia blocco',0),(502693,13964,'tl','',0),(502694,13964,'th','à¸à¸³à¹„à¸£à¸‚à¸±à¹‰à¸™à¸•à¹‰à¸™à¸—à¸µà¹ˆà¸•à¹ˆà¸³à¸ªà¸¸à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¸²à¸„à¸²à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸šà¸¥à¹‡à¸­à¸',0),(502695,13964,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤²à¤¾à¤­ à¤®à¤¾à¤°à¥à¤œà¤¿à¤¨ à¤¬à¤¦à¤²à¤¨à¥‡ à¤•à¥‹ à¤…à¤µà¤°à¥à¤¦à¥à¤§',0),(502696,13964,'ms','Margin keuntungan minimum bagi harga Tukar menyekat',0),(502697,13964,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† Ù‡Ø§Ù…Ø´ Ø§Ù„Ø±Ø¨Ø­ Ù„Ù„Ø£Ø³Ø¹Ø§Ø± Ø­Ø¬Ø¨',0),(502698,13964,'fr','Marge bÃ©nÃ©ficiaire minimale pour prix changer bloquant',0),(502699,13964,'jp','ä¾¡æ ¼ã®ãŸã‚ã®æœ€ä½Žé™ã®åˆ©ç›ŠçŽ‡å¤‰æ›´ãƒ–ãƒ­ãƒƒã‚¯',0),(502700,13964,'pt','Margem de lucro mÃ­nima por preÃ§o alterar bloqueio',0),(502701,13964,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð¼Ð°Ñ€Ð¶Ð° Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸ Ð¿Ð¾ Ñ†ÐµÐ½Ðµ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²ÐºÑƒ',0),(502702,13964,'es','MÃ­nimo margen de ganancia para el precio cambia de bloqueo',0),(502703,13964,'de','Minimale Gewinnspanne fÃ¼r Preis zu Ã¤ndern, Sperren',0),(502704,13964,'en','Minimum Profit Margin For Price Change Blocking',0),(502705,13965,'is','',0),(502706,13965,'dr','Ø¯Ø± Ø±Ø§Ø¨Ø·Ù‡ Ø¨Ø§ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ú©Ø§Ø±Ø¨Ø± Ø¨Ø±Ø§ÛŒ Ø¬Ù„ÙˆÚ¯ÛŒØ±ÛŒ Ø§Ø² ØªØºÛŒÛŒØ±Ø§Øª Ù‚ÛŒÙ…Øª Ø²ÛŒØ± Ø­Ø¯Ø§Ù‚Ù„ Ø­Ø§Ø´ÛŒÙ‡ Ø³ÙˆØ¯ Ø§Ø³ØªÙØ§Ø¯Ù‡',0),(502707,13965,'pr','Ø¯Ø± Ø±Ø§Ø¨Ø·Ù‡ Ø¨Ø§ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ú©Ø§Ø±Ø¨Ø± Ø¨Ø±Ø§ÛŒ Ø¬Ù„ÙˆÚ¯ÛŒØ±ÛŒ Ø§Ø² ØªØºÛŒÛŒØ±Ø§Øª Ù‚ÛŒÙ…Øª Ø²ÛŒØ± Ø­Ø¯Ø§Ù‚Ù„ Ø­Ø§Ø´ÛŒÙ‡ Ø³ÙˆØ¯ Ø§Ø³ØªÙØ§Ø¯Ù‡',0),(502708,13965,'tr','KullanÄ±cÄ± ayarÄ± ile birlikte en dÃ¼ÅŸÃ¼k kar marjÄ± aÅŸaÄŸÄ±daki fiyat deÄŸiÅŸiklikleri engellemek iÃ§in kullanÄ±lÄ±r',0),(502709,13965,'pl','UÅ¼ywane w poÅ‚Ä…czeniu z ustawienia uÅ¼ytkownika blokowaÄ‡ zmiany cen poniÅ¼ej minimalnej marÅ¼y zysku',0),(502710,13965,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ð¸ Ð²ÑŠÐ² Ð²Ñ€ÑŠÐ·ÐºÐ° Ñ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð·Ð° Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¾Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¿Ð¾Ð´ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(502711,13965,'ur','ØµØ§Ø±Ù Ø³ÛŒÙ¹Ù†Ú¯ Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ù„ Ú©Ø± Ø§ÛŒÚ© Ú©Ù… Ø§Ø² Ú©Ù… Ù¾ÛŒÚ†ÛŒØ¯Û Ù†ÛŒÚ†Û’ Ù‚ÛŒÙ…Øª ØªØ¨Ø¯ÛŒÙ„ÛŒÙˆÚº Ú©Ùˆ Ø¨Ù„Ø§Ú© Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§',0),(502712,13965,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÑÐ° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸Ñ… Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð° Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð°ÑšÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ñ†ÐµÐ½Ð° Ð¸ÑÐ¿Ð¾Ð´ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ðµ ÑÑ‚Ð¾Ð¿Ð° Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð°',0),(502713,13965,'vi','Sá»­ dá»¥ng káº¿t há»£p vá»›i ngÆ°á»i dÃ¹ng thiáº¿t láº­p Ä‘á»ƒ cháº·n thay Ä‘á»•i giÃ¡ dÆ°á»›i má»™t lá»£i nhuáº­n tá»‘i thiá»ƒu',0),(502714,13965,'af','Gebruik in samewerking met gebruiker instelling blokkeer prys veranderinge onder \'n minimum winsmarge',0),(502715,13965,'ro','Folosit Ã®n combinaÅ£ie cu setarea utilizator sÄƒ blocheze modificÄƒrile de preÅ£ mai jos o marjÄƒ de profit minim',0),(502716,13965,'et','Kasutatakse koos kasutaja sÃ¤tted blokeerida hinnamuutuste allapoole minimaalne kasumimarginaal',0),(502717,13965,'si','Uporablja v povezavi z nastavitev uporabnika blokirate spremembe cen pod minimalno stopnjo dobiÄka',0),(502718,13965,'ba','Digunakan dalam hubungannya dengan settingan pemakai untuk memblokir perubahan harga di bawah margin keuntungan yang minimal',0),(502719,13965,'nl','Gebruikt in combinatie met de gebruikersinstelling blokkeren prijsveranderingen onder een minimale winstmarge',0),(502720,13965,'fi','KÃ¤ytetÃ¤Ã¤n yhdessÃ¤ kÃ¤yttÃ¤jÃ¤n asetus estÃ¤Ã¤ hinnanmuutokset alla pienin voittomarginaali',0),(502721,13965,'no','Brukes sammen med brukerinnstillinger blokkere endringer under en minste fortjenestemargin',0),(502722,13965,'da','Bruges sammen med brugerindstilling blokerer for prisÃ¦ndringer under en mindste fortjeneste',0),(502723,13965,'ko','ìµœì†Œ ì´ìµë¥  ì•„ëž˜ ê°€ê²© ë³€ê²½ ì°¨ë‹¨ ì‚¬ìš©ìž ì„¤ì • í•¨ê»˜ ì‚¬ìš©',0),(502724,13965,'he','×‘×©×™×œ×•×‘ ×¢× ×”×’×“×¨×ª ×”×ž×©×ª×ž×© ×›×“×™ ×œ×—×¡×•× ××ª ×©×™× ×•×™×™ ×”×ž×—×™×¨×™× ×œ×”×œ×Ÿ ×©×•×œ×™ ×¨×•×•×— ×ž×™× ×™×ž×œ×™',0),(502725,13965,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ ÏƒÎµ ÏƒÏ…Î½Î´Ï…Î±ÏƒÎ¼ÏŒ Î¼Îµ ÏÏÎ¸Î¼Î¹ÏƒÎ· Ï‡ÏÎ®ÏƒÏ„Î· Î½Î± Î¼Ï€Î»Î¿ÎºÎ¬ÏÎµÎ¹ Ï„Î¹Ï‚ Î±Î»Î»Î±Î³Î­Ï‚ Ï„Ï‰Î½ Ï„Î¹Î¼ÏŽÎ½ ÎºÎ¬Ï„Ï‰ Î±Ï€ÏŒ Î­Î½Î± ÎµÎ»Î¬Ï‡Î¹ÏƒÏ„Î¿ Ï€ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ ÎºÎ­ÏÎ´Î¿Ï…Ï‚',0),(502726,13965,'zh','ä¸Žç”¨æˆ·è®¾ç½®ä¸€èµ·ä½¿ç”¨æ¥é˜»æ­¢ä»·æ ¼ä½ŽäºŽæœ€ä½Žåˆ©æ¶¦çŽ‡çš„å˜åŒ–',0),(502727,13965,'sv','AnvÃ¤nds i samband med anvÃ¤ndarens instÃ¤llning fÃ¶r att blockera prisfÃ¶rÃ¤ndringar under en minsta vinstmarginal',0),(502728,13965,'it','Utilizzato in combinazione con l\'impostazione utente di bloccare le variazioni di prezzo di sotto un minimo margine di profitto',0),(502729,13965,'tl','',0),(502730,13965,'th','à¹ƒà¸Šà¹‰à¸£à¹ˆà¸§à¸¡à¸à¸±à¸šà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸žà¸·à¹ˆà¸­à¸šà¸¥à¹‡à¸­à¸à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸£à¸²à¸„à¸²à¸•à¹ˆà¸³à¸à¸³à¹„à¸£à¸‚à¸±à¹‰à¸™à¸•à¹‰à¸™à¸•à¹ˆà¸³',0),(502731,13965,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤à¤• à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤²à¤¾à¤­ à¤®à¤¾à¤°à¥à¤œà¤¿à¤¨ à¤•à¥‡ à¤¨à¥€à¤šà¥‡ à¤…à¤µà¤°à¥‹à¤§à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤— à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤‚à¤¯à¥‹à¤',0),(502732,13965,'ms','Digunakan bersama-sama dengan persekitaran pengguna untuk menyekat perubahan harga di bawah margin keuntungan minimum',0),(502733,13965,'ar','ØªØ³ØªØ®Ø¯Ù… Ø¨Ø§Ù„Ø§Ù‚ØªØ±Ø§Ù† Ù…Ø¹ Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø¥Ù„Ù‰ ÙƒØªÙ„Ø© ØªØºÙŠØ±Ø§Øª Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø£Ø¯Ù†Ø§Ù‡ Ø§Ù„Ø­Ø¯ Ø£Ø¯Ù†Ù‰ Ù…Ù† Ù‡Ø§Ù…Ø´ Ø§Ù„Ø±Ø¨Ø­',0),(502734,13965,'fr','UtilisÃ© conjointement avec le paramÃ¨tre utilisateur pour bloquer les changements de prix ci-dessous une marge bÃ©nÃ©ficiaire minimale',0),(502735,13965,'jp','æœ€å°åˆ©ç›Šä»¥ä¸‹ã®ä¾¡æ ¼ã®å¤‰æ›´ã‚’ãƒ–ãƒ­ãƒƒã‚¯ã™ã‚‹ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®è¨­å®šã¨çµ„ã¿åˆã‚ã›ã¦ä½¿ç”¨',0),(502736,13965,'pt','Usado em conjunto com a configuraÃ§Ã£o de usuÃ¡rio para bloquear as mudanÃ§as de preÃ§os abaixo de uma margem de lucro mÃ­nima',0),(502737,13965,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð² ÑÐ¾Ñ‡ÐµÑ‚Ð°Ð½Ð¸Ð¸ Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ð¹ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ñ†ÐµÐ½ Ð½Ð¸Ð¶Ðµ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ð¹ Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸',0),(502738,13965,'es','Utilizado conjuntamente con la configuraciÃ³n del usuario para bloquear los cambios de precios por debajo de un mÃ­nimo margen de ganancia',0),(502739,13965,'de','Verwendet in Verbindung mit Benutzereinstellung PreisÃ¤nderungen unterhalb einer minimalen Gewinnspanne zu blockieren',0),(502740,13965,'en','Used in conjunction with user setting to block price changes below a minimum profit margin',0),(502741,13966,'is','',0),(502742,13966,'dr','Ø´Ù…Ø§ Ù…Ø¬Ø§Ø² Ø¨Ù‡ ØªØºÛŒÛŒØ± Ù‚ÛŒÙ…Øª Ø¨Ù‡ Ø§ÛŒÙ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³Øª.',0),(502743,13966,'pr','Ø´Ù…Ø§ Ù…Ø¬Ø§Ø² Ø¨Ù‡ ØªØºÛŒÛŒØ± Ù‚ÛŒÙ…Øª Ø¨Ù‡ Ø§ÛŒÙ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ø³Øª.',0),(502744,13966,'tr','Bu miktar fiyatÄ± deÄŸiÅŸtirmek iÃ§in yetkiniz yok.',0),(502745,13966,'pl','UÅ¼ytkownik nie jest upowaÅ¼niony do zmiany ceny do tej kwoty.',0),(502746,13966,'bg','ÐÐµ ÑÑ‚Ðµ ÑƒÐ¿ÑŠÐ»Ð½Ð¾Ð¼Ð¾Ñ‰ÐµÐ½Ð¸ Ð´Ð° ÑÐµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ñ†ÐµÐ½Ð°Ñ‚Ð° Ð½Ð° Ñ‚Ð°Ð·Ð¸ ÑÑƒÐ¼Ð°.',0),(502747,13966,'ur','Ø¢Ù¾ Ú©ÛŒ Ù‚ÛŒÙ…Øª Ø§Ø³ Ø±Ù‚Ù… Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø¬Ø§Ø² Ù†ÛÛŒÚº ÛÛŒÚº Û”',0),(502748,13966,'sr','ÐÐ¸ÑÑ‚Ðµ Ð¾Ð²Ð»Ð°ÑˆÑ‚ÐµÐ½Ð¸ Ð´Ð° Ð¼Ð¸Ñ˜ÐµÑšÐ° Ñ†Ð¸Ñ˜ÐµÐ½Ñƒ Ð½Ð° Ð¾Ð²Ð°Ñ˜ Ð¸Ð·Ð½Ð¾Ñ.',0),(502749,13966,'vi','Báº¡n khÃ´ng cÃ³ quyá»n thay Ä‘á»•i giÃ¡ Ä‘á»ƒ sá»‘ tiá»n nÃ y.',0),(502750,13966,'af','Jy is nie gemagtig om die prys om hierdie bedrag te verander.',0),(502751,13966,'ro','Nu sunt autorizate sÄƒ schimbe preÅ£ul pentru aceastÄƒ sumÄƒ.',0),(502752,13966,'et','Teil pole Ãµigust muuta hinda seda summat.',0),(502753,13966,'si','Niste pooblaÅ¡Äeni spremeniti ceno za ta znesek.',0),(502754,13966,'ba','Anda tidak diizinkan untuk mengubah harga untuk jumlah ini.',0),(502755,13966,'nl','U bent niet gemachtigd om de prijs aan dit bedrag veranderen.',0),(502756,13966,'fi','Saa muuttaa hintaa tÃ¤hÃ¤n mÃ¤Ã¤rÃ¤Ã¤n.',0),(502757,13966,'no','Du har ikke tillatelse til Ã¥ endre prisen til dette belÃ¸pet.',0),(502758,13966,'da','Du har ikke tilladelse til at Ã¦ndre prisen til dette belÃ¸b.',0),(502759,13966,'ko','ì´ ê¸ˆì•¡ì—ëŠ” ê°€ê²©ì„ ë³€ê²½í•  ê¶Œí•œì´ ì—†ìŠµë‹ˆë‹¤.',0),(502760,13966,'he','××ª×” ×œ× ×ž×•×¨×©×” ×œ×©× ×•×ª ××ª ×”×ž×—×™×¨ ×¡×›×•× ×–×”.',0),(502761,13966,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ ÎµÎ¾Î¿Ï…ÏƒÎ¹Î¿Î´Î®Ï„Î·ÏƒÎ· Î½Î± Î±Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î·Î½ Ï„Î¹Î¼Î® ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Ï€Î¿ÏƒÏŒ.',0),(502762,13966,'zh','æ‚¨æ— æƒæ›´æ”¹ä»·æ ¼ä¸ºè¿™ä¸€æ•°é¢ã€‚',0),(502763,13966,'sv','Du har inte behÃ¶righet att Ã¤ndra priset till detta belopp.',0),(502764,13966,'it','Non siete autorizzati a modificare il prezzo di questo importo.',0),(502765,13966,'tl','',0),(502766,13966,'th','à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸„à¹ˆà¸²à¹€à¸‡à¸´à¸™',0),(502767,13966,'hi','à¤¤à¥à¤® à¤•à¥€à¤®à¤¤ à¤‡à¤¸ à¤°à¤¾à¤¶à¤¿ à¤•à¥‹ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤§à¤¿à¤•à¥ƒà¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¤‚à¥¤',0),(502768,13966,'ms','Anda tidak dibenarkan untuk menukar harga untuk jumlah ini.',0),(502769,13966,'ar','ØºÙŠØ± Ù…Ø³Ù…ÙˆØ­ Ù„Ùƒ ØªØºÙŠÙŠØ± Ø§Ù„Ø³Ø¹Ø± Ù„Ù‡Ø°Ø§ Ø§Ù„Ù…Ø¨Ù„Øº.',0),(502770,13966,'fr','Vous n\'Ãªtes pas autorisÃ© Ã  modifier le prix de ce montant.',0),(502771,13966,'jp','ã“ã®é‡‘é¡ã«ä¾¡æ ¼ã‚’å¤‰æ›´ã™ã‚‹æ¨©é™ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(502772,13966,'pt','VocÃª nÃ£o estÃ¡ autorizado a alterar o preÃ§o para esta quantidade.',0),(502773,13966,'ru','Ð’Ñ‹ Ð½Ðµ Ð°Ð²Ñ‚Ð¾Ñ€Ð¸Ð·Ð¾Ð²Ð°Ð½Ñ‹ Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ñ†ÐµÐ½Ñƒ Ð½Ð° ÑÑ‚Ñƒ ÑÑƒÐ¼Ð¼Ñƒ.',0),(502774,13966,'es','Usted no estÃ¡ autorizado a modificar el precio de esta cantidad.',0),(502775,13966,'de','Sie sind nicht berechtigt, den Preis um diesen Betrag zu Ã¤ndern.',0),(502776,13966,'en','You are not authorized to change the price to this amount.',0),(502777,13967,'is','',0),(502778,13967,'dr','Ù‡Ø´Ø¯Ø§Ø± Ø§Ù…Ù†ÛŒØªÛŒ - ePay MD5 Ù‡Ø´ Ø§Ø² Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ Ú©Ù†Ø¯ Ù†Ù‡ Ø¨Ø§Ø²ÛŒ',0),(502779,13967,'pr','Ù‡Ø´Ø¯Ø§Ø± Ø§Ù…Ù†ÛŒØªÛŒ - ePay MD5 Ù‡Ø´ Ø§Ø² Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ Ú©Ù†Ø¯ Ù†Ù‡ Ø¨Ø§Ø²ÛŒ',0),(502780,13967,'tr','GÃ¼venlik UyarÄ±sÄ± - MD5 Hash den ABD ePay Does deÄŸil maÃ§',0),(502781,13967,'pl','OstrzeÅ¼enie o zabezpieczeniach - ePay MD5 Hash z USA nie zgadza',0),(502782,13967,'bg','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð·Ð°Ñ‰Ð¸Ñ‚Ð°Ñ‚Ð° - MD5 Ñ…ÐµÑˆ Ð¾Ñ‚ Ð¡ÐÐ© ePay Does Ð½Ðµ Ð¼Ð°Ñ‡',0),(502783,13967,'ur','Ø³Ù„Ø§Ù…ØªÛŒ ØªÙ†Ø¨ÛŒÛ - MD5 ÛÛŒØ´ Ø³Û’ Ø§Ù…Ø±ÛŒÚ©Û Ø§ÛŒÙ¾Ø¢ÛŒ Ù…ÛŒÚ† Ù†ÛÛŒÚº Ú©Ø±ØªÛŒ',0),(502784,13967,'sr','Ð£Ð¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ Ð¾ Ð±ÐµÐ·Ð±ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ - ÐœÐ”5 Ð¥Ð°ÑÑ… Ð¸Ð· Ð£Ð¡Ð ÐµÐŸÐ°y ÑÐµ Ð½Ðµ Ð¿Ð¾ÐºÐ»Ð°Ð¿Ð°',0),(502785,13967,'vi','Cáº£nh bÃ¡o báº£o máº­t - MD5 Hash tá»« Má»¹ ePay hiá»‡n khÃ´ng phÃ¹ há»£p vá»›i',0),(502786,13967,'af','Sekuriteitswaarskuwing - MD5 huts uit VSA ePay nie nie pas',0),(502787,13967,'ro','Avertisment de securitate - MD5 Hash din SUA ePay are nu meci',0),(502788,13967,'et','Security Warning - MD5 Hash: USA ePay ei ole vastet',0),(502789,13967,'si','Varnostno opozorilo - MD5 haÅ¡e iz ZDA ePay Does ne vÅ¾igalica',0),(502790,13967,'ba','Peringatan keamanan - MD5 Hash dari USA ePay Apakah tidak cocok',0),(502791,13967,'nl','Beveiligingswaarschuwing - MD5 Hash van VS ePay is niet Match',0),(502792,13967,'fi','Suojausvaroitus - MD5 Hash Yhdysvalloissa ePay onko Match',0),(502793,13967,'no','Sikkerhetsadvarsel - MD5 Hash fra USA andre betalingsmÃ¥ter er ikke passer',0),(502794,13967,'da','Sikkerhedsadvarsel - MD5 Hash fra USA ePay gÃ¸r ikke Match',0),(502795,13967,'ko','ë³´ì•ˆ ê²½ê³ -ë¯¸êµ­ì—ì„œ MD5 í•´ì‹œ ePay ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(502796,13967,'he','××–×”×¨×ª ××‘×˜×—×” - MD5 Hash ×©×œ ××¨×” ×‘ ePay ×¢×•×©×” ×œ× ×”×ª××ž×”',0),(502797,13967,'el','Î ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î±ÏƒÏ†Î±Î»ÎµÎ¯Î±Ï‚ - MD5 Hash Î±Ï€ÏŒ Î—Î Î‘ ePay ÎºÎ¬Î½ÎµÎ¹ Î±Î³ÏŽÎ½Î±',0),(502798,13967,'zh','å®‰å…¨è­¦å‘Š-ePay ä»Žç¾Žå›½ MD5 å“ˆå¸Œå€¼å¹¶ä¸åŒ¹é…',0),(502799,13967,'sv','SÃ¤kerhetsvarning - MD5 Hash frÃ¥n USA ePay gÃ¶r inte matchen',0),(502800,13967,'it','Avviso di sicurezza - MD5 Hash da USA ePay fa Match',0),(502801,13967,'tl','',0),(502802,13967,'th','à¹€à¸•à¸·à¸­à¸™à¹€à¸à¸µà¹ˆà¸¢à¸§à¸à¸±à¸šà¸„à¸§à¸²à¸¡à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢ - ePay à¹à¸® MD5 à¸ˆà¸²à¸à¸›à¸£à¸°à¹€à¸—à¸¨à¸ªà¸«à¸£à¸±à¸à¸­à¹€à¸¡à¸£à¸´à¸à¸²à¸ˆà¸°à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸™',0),(502803,13967,'hi','à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤šà¥‡à¤¤à¤¾à¤µà¤¨à¥€ - MD5 à¤¹à¥ˆà¤¶ à¤¸à¤‚à¤¯à¥à¤•à¥à¤¤ à¤°à¤¾à¤œà¥à¤¯ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ à¤¸à¥‡ ePay à¤¨à¤¹à¥€à¤‚ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤®à¤¿à¤²à¤¾à¤¨',0),(502804,13967,'ms','Amaran Keselamatan - ePay MD5 Hash daripada Amerika Syarikat tidak tidak sepadan dengan',0),(502805,13967,'ar','ØªØ­Ø°ÙŠØ± Ø£Ù…Ø§Ù†-\"ØªØ¬Ø²Ø¦Ø© MD5 Ù…Ù† Ø§Ù„ÙˆÙ„Ø§ÙŠØ§Øª Ø§Ù„Ù…ØªØ­Ø¯Ø© Ø§Ù„Ø£Ù…Ø±ÙŠÙƒÙŠØ©\" ePay \"Ø¹Ø¯Ù… ØªØ·Ø§Ø¨Ù‚\"',0),(502806,13967,'fr','Avertissement de sÃ©curitÃ© - MD5 Hash de USA ePay ne correspond pas',0),(502807,13967,'jp','ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£è­¦å‘Š - MD5 ãƒãƒƒã‚·ãƒ¥ã‹ã‚‰ç±³å›½ ePay ã¨ä¸€è‡´ã—ã¾ã›ã‚“ã€‚',0),(502808,13967,'pt','Aviso de seguranÃ§a - ePay MD5 Hash de EUA nÃ£o corresponde',0),(502809,13967,'ru','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹ Ð±ÐµÐ·Ð¾Ð¿Ð°ÑÐ½Ð¾ÑÑ‚Ð¸ - MD5 Ñ…ÑÑˆ Ð¸Ð· Ð¡Ð¨Ð ePay Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚',0),(502810,13967,'es','ADVERTENCIA de seguridad - Hash MD5 de los E.e.u.u. ePay hace no coincide',0),(502811,13967,'de','Sicherheitswarnung - MD5 Hash aus USA ePay stimmt nicht mit',0),(502812,13967,'en','Security Warning - MD5 Hash From USA ePay Does Not Match',0),(502813,13968,'is','',0),(502814,13968,'dr','Ø³Ù‡Ù„ Ø¢Ù…ÙˆØ² ØªÙ†Ø¸ÛŒÙ…',0),(502815,13968,'pr','Ø³Ù‡Ù„ Ø¢Ù…ÙˆØ² ØªÙ†Ø¸ÛŒÙ…',0),(502816,13968,'tr','Kurulum SihirbazÄ±',0),(502817,13968,'pl','Kreator konfiguracji',0),(502818,13968,'bg','Ð¡ÑŠÐ²ÐµÑ‚Ð½Ð¸Ðº Ð·Ð° Ð¸Ð½ÑÑ‚Ð°Ð»Ð¸Ñ€Ð°Ð½Ðµ',0),(502819,13968,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ Ù…Ø¯Ø¯Ú¯Ø§Ø±',0),(502820,13968,'sr','Ð§Ð°Ñ€Ð¾Ð±ÑšÐ°Ðº Ð·Ð° Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(502821,13968,'vi','Thuáº­t sÄ© thiáº¿t láº­p',0),(502822,13968,'af','Netwerkopstelling-Ghoeroe',0),(502823,13968,'ro','Expertul de instalare',0),(502824,13968,'et','HÃ¤Ã¤lestusviisard',0),(502825,13968,'si','ÄŒarovnik za namestitev',0),(502826,13968,'ba','Wizard Pengaturan',0),(502827,13968,'nl','Wizard Setup',0),(502828,13968,'fi','Ohjattu asennus',0),(502829,13968,'no','Installasjonsveiviseren',0),(502830,13968,'da','Installationsguiden',0),(502831,13968,'ko','ì„¤ì¹˜ ë§ˆë²•ì‚¬',0),(502832,13968,'he','××©×£ ×”×”×ª×§× ×”',0),(502833,13968,'el','\"ÎŸÎ´Î·Î³ÏŒÏ‚ ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚\"',0),(502834,13968,'zh','å®‰è£…å‘å¯¼',0),(502835,13968,'sv','Installationsguiden',0),(502836,13968,'it','Installazione guidata',0),(502837,13968,'tl','',0),(502838,13968,'th','à¸•à¸±à¸§à¸Šà¹ˆà¸§à¸¢à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²',0),(502839,13968,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª à¤µà¤¿à¤œà¤¼à¤¾à¤°à¥à¤¡',0),(502840,13968,'ms','Wizard persediaan',0),(502841,13968,'ar','Ù…Ø¹Ø§Ù„Ø¬ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(502842,13968,'fr','Assistant d\'installation',0),(502843,13968,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ã‚¦ã‚£ã‚¶ãƒ¼ãƒ‰',0),(502844,13968,'pt','Assistente de configuraÃ§Ã£o',0),(502845,13968,'ru','ÐœÐ°ÑÑ‚ÐµÑ€ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸',0),(502846,13968,'es','Asistente de configuraciÃ³n',0),(502847,13968,'de','Setup-Assistent',0),(502848,13968,'en','Setup Wizard',0),(502849,13969,'is','',0),(502850,13969,'dr','Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ù†Ø§Ù… Ø¢Ø®Ø±ÛŒÙ† &amp; Ø§ÙˆÙ„ Ø§Ú¯Ø± Ù‡ÛŒÚ† Ø´Ø±Ú©Øª',0),(502851,13969,'pr','Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ù†Ø§Ù… Ø¢Ø®Ø±ÛŒÙ† &amp; Ø§ÙˆÙ„ Ø§Ú¯Ø± Ù‡ÛŒÚ† Ø´Ø±Ú©Øª',0),(502852,13969,'tr','Åžirket adÄ± veya ilk & son bÄ±rakÄ±lÄ±rsa hiÃ§bir ÅŸirket adÄ±',0),(502853,13969,'pl','Nazwa firmy lub pierwszy & ostatni jeÅ›li Å¼adna firma',0),(502854,13969,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð° Ð¸Ð»Ð¸ Ð¿ÑŠÑ€Ð²Ð¾Ñ‚Ð¾ & Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ, Ð°ÐºÐ¾ Ð½ÑÐ¼Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(502855,13969,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… ÛŒØ§ Ø§Ú¯Ø± Ú©ÙˆØ¦ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ & Ø¢Ø®Ø±ÛŒ',0),(502856,13969,'sr','Ð˜Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸Ð»Ð¸ Ð¿Ñ€Ð²Ð¾ Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð¸Ð¼Ðµ Ð°ÐºÐ¾ Ð½ÐµÐ¼Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(502857,13969,'vi','TÃªn cÃ´ng ty hoáº·c tÃªn Ä‘áº§u tiÃªn &amp; cuá»‘i cÃ¹ng náº¿u khÃ´ng cÃ³ cÃ´ng ty',0),(502858,13969,'af','Maatskappy naam of eerste & laaste as geen maatskappy',0),(502859,13969,'ro','Numele de companie sau prima & ultima dacÄƒ nici o companie',0),(502860,13969,'et','Firma nime vÃµi esimesel & viimasel nimi kui Ã¼kski Ã¤riÃ¼hing',0),(502861,13969,'si','Ime podjetja ali prvi & priimek Äe nobena druÅ¾ba',0),(502862,13969,'ba','Nama perusahaan atau nama pertama & terakhir jika ada perusahaan',0),(502863,13969,'nl','Bedrijfsnaam of de naam van de eerste & laatste als geen enkel bedrijf',0),(502864,13969,'fi','Yrityksen nimi tai ensimmÃ¤inen & viimeinen nimi jos yksikÃ¤Ã¤n yritys',0),(502865,13969,'no','Firmanavn eller fÃ¸rste & siste navn hvis ingen',0),(502866,13969,'da','Virksomhedens navn eller fÃ¸rste & sidste navn hvis ingen virksomhed',0),(502867,13969,'ko','íšŒì‚¬ ì´ë¦„ ë˜ëŠ” ì²« ë²ˆì§¸ & ë§ˆì§€ë§‰ ì´ë¦„ ê²½ìš° íšŒì‚¬',0),(502868,13969,'he','×©× ×—×‘×¨×” ××• ×©× ×¨××©×•×Ÿ ××—×¨×•×Ÿ & ×× ××™×Ÿ ×—×‘×¨×”',0),(502869,13969,'el','Î¤Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î® ÏŒÎ½Î¿Î¼Î± Ï€ÏÏŽÏ„Î¿ & Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿, Î±Î½ Î´ÎµÎ½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(502870,13969,'zh','å…¬å¸åç§°æˆ–ç¬¬ä¸€ä¸ª &amp; æœ€åŽä¸€ä¸ªåç§°ï¼Œå¦‚æžœæ²¡æœ‰ä¸€å®¶å…¬å¸',0),(502871,13969,'sv','FÃ¶retagets namn eller namnet pÃ¥ fÃ¶rsta & sista om inget fÃ¶retag',0),(502872,13969,'it','Nome societÃ  o nome cognome & se nessuna azienda',0),(502873,13969,'tl','',0),(502874,13969,'th','à¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸—à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢ & à¹à¸£à¸à¸–à¹‰à¸²à¹„à¸¡à¹ˆà¸¡à¸µà¸šà¸£à¸´à¸©à¸±à¸—',0),(502875,13969,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® & à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤…à¤—à¤° à¤•à¥‹à¤ˆ à¤•à¤‚à¤ªà¤¨à¥€',0),(502876,13969,'ms','Nama Syarikat atau nama pertama & terakhir jika tidak Syarikat',0),(502877,13969,'ar','Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø£Ùˆ Ø§Ø³Ù… Ø£ÙˆÙ„ Ø¢Ù†Ø¯ Ø¢Ø®Ø± Ø¥Ø°Ø§ ÙƒØ§Ù† Ù„Ø§ Ø´Ø±ÙƒØ©',0),(502878,13969,'fr','Nom de sociÃ©tÃ© ou premier & dernier si aucune entreprise',0),(502879,13969,'jp','ä¼šç¤¾åã¾ãŸã¯å…ˆé ­ & æœ€å¾Œåå ´åˆãªã„ä¼šç¤¾',0),(502880,13969,'pt','Nome da empresa ou nome de primeiro & Ãºltimo caso nenhuma empresa',0),(502881,13969,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð»Ð¸ Ð¸Ð¼Ñ Ð¿ÐµÑ€Ð²Ð¾Ð³Ð¾ & Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾, ÐµÑÐ»Ð¸ Ð½Ð¸ Ð¾Ð´Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(502882,13969,'es','Nombre de empresa o nombre del primero al Ãºltimo &amp; si ninguna empresa',0),(502883,13969,'de','Firmennamen oder Vorname & Nachname wenn kein Unternehmen',0),(502884,13969,'en','Company Name Or First & Last Name If No Company',0),(502885,13970,'is','',0),(502886,13970,'dr','Ù†Ø§Ù… Ù…Ø´ØªØ±ÛŒ',0),(502887,13970,'pr','Ù†Ø§Ù… Ù…Ø´ØªØ±ÛŒ',0),(502888,13970,'tr','MÃ¼ÅŸteri adÄ±',0),(502889,13970,'pl','ImiÄ™ odbiorcy',0),(502890,13970,'bg','ÐŸÑŠÑ€Ð²Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(502891,13970,'ur','Ú©Ø³Ù¹Ù…Ø± Ù¾ÛÙ„Ø§ Ù†Ø§Ù…',0),(502892,13970,'sr','ÐŸÑ€Ð²Ð¾ Ð¸Ð¼Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(502893,13970,'vi','KhÃ¡ch hÃ ng Ä‘áº§u tiÃªn tÃªn',0),(502894,13970,'af','KliÃ«nt eerste naam',0),(502895,13970,'ro','Client nume',0),(502896,13970,'et','Kliendi eesnimi',0),(502897,13970,'si','Ime kupca',0),(502898,13970,'ba','Nama pelanggan',0),(502899,13970,'nl','Voornaam van klant',0),(502900,13970,'fi','Asiakkaan etunimi',0),(502901,13970,'no','Kunden fornavn',0),(502902,13970,'da','Kunde fornavn',0),(502903,13970,'ko','ê³ ê° ì´ë¦„',0),(502904,13970,'he','×©× ×¤×¨×˜×™ ×œ×§×•×—',0),(502905,13970,'el','ÎŒÎ½Î¿Î¼Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(502906,13970,'zh','å®¢æˆ·åå­—',0),(502907,13970,'sv','Kundens fÃ¶rnamn',0),(502908,13970,'it','Nome cliente',0),(502909,13970,'tl','',0),(502910,13970,'th','à¸Šà¸·à¹ˆà¸­à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(502911,13970,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤¹à¤²à¥‡ à¤¨à¤¾à¤®',0),(502912,13970,'ms','Nama pertama pelanggan',0),(502913,13970,'ar','Ø§Ø³Ù… Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø£ÙˆÙ„',0),(502914,13970,'fr','PrÃ©nom client',0),(502915,13970,'jp','ãŠå®¢æ§˜ã®ãŠåå‰',0),(502916,13970,'pt','Nome do cliente',0),(502917,13970,'ru','Ð˜Ð¼Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(502918,13970,'es','Nombre del cliente',0),(502919,13970,'de','Kunden-Vorname',0),(502920,13970,'en','Customer First Name',0),(502921,13971,'is','',0),(502922,13971,'dr','Ù†Ø§Ù… Ù…Ø´ØªØ±ÛŒ',0),(502923,13971,'pr','Ù†Ø§Ù… Ù…Ø´ØªØ±ÛŒ',0),(502924,13971,'tr','MÃ¼ÅŸterinin soyadÄ±',0),(502925,13971,'pl','Nazwisko klienta',0),(502926,13971,'bg','Ð¤Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(502927,13971,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù…',0),(502928,13971,'sr','ÐŸÑ€ÐµÐ·Ð¸Ð¼Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(502929,13971,'vi','KhÃ¡ch hÃ ng cuá»‘i cÃ¹ng tÃªn',0),(502930,13971,'af','KliÃ«nt verlede naam',0),(502931,13971,'ro','Client nume',0),(502932,13971,'et','Kliendi perekonnanimi',0),(502933,13971,'si','Priimek kupca',0),(502934,13971,'ba','Nama pelanggan',0),(502935,13971,'nl','Achternaam van de klant',0),(502936,13971,'fi','Asiakkaan sukunimi',0),(502937,13971,'no','Kunden etternavn',0),(502938,13971,'da','Kunde efternavn',0),(502939,13971,'ko','ê³ ê° ì„±',0),(502940,13971,'he','×©× ×”×ž×©×¤×—×” ×©×œ ×”×œ×§×•×—',0),(502941,13971,'el','Î•Ï€ÏŽÎ½Ï…Î¼Î¿ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(502942,13971,'zh','å®¢æˆ·å§“æ°',0),(502943,13971,'sv','Kundens efternamn',0),(502944,13971,'it','Cognome del cliente',0),(502945,13971,'tl','',0),(502946,13971,'th','à¸™à¸²à¸¡à¸ªà¸à¸¸à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(502947,13971,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤®',0),(502948,13971,'ms','Baca nama',0),(502949,13971,'ar','Ø§Ø³Ù… Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø£Ø®ÙŠØ±',0),(502950,13971,'fr','PrÃ©nom du client',0),(502951,13971,'jp','é¡§å®¢ã®å§“',0),(502952,13971,'pt','Sobrenome do cliente',0),(502953,13971,'ru','Ð¤Ð°Ð¼Ð¸Ð»Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(502954,13971,'es','Apellido del cliente',0),(502955,13971,'de','Nachname Kunden',0),(502956,13971,'en','Customer Last Name',0),(502957,13972,'is','',0),(502958,13972,'dr','Ø¨Ù‡ Ø¹Ù„Øª ÙØ§Ú©ØªÙˆØ± Ø±ÙˆØ²',0),(502959,13972,'pr','Ø¨Ù‡ Ø¹Ù„Øª ÙØ§Ú©ØªÙˆØ± Ø±ÙˆØ²',0),(502960,13972,'tr','Fatura vade gÃ¼nÃ¼',0),(502961,13972,'pl','Faktura odpowiednim dzieÅ„',0),(502962,13972,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾ Ð´ÐµÐ½',0),(502963,13972,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…Ù‚Ø±Ø±Û Ø¯Ù†',0),(502964,13972,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ð½',0),(502965,13972,'vi','HoÃ¡ Ä‘Æ¡n do ngÃ y',0),(502966,13972,'af','Faktuur sperdatum dag',0),(502967,13972,'ro','Factura cuvenit zi',0),(502968,13972,'et','Arve nÃµuetekohase pÃ¤ev',0),(502969,13972,'si','RaÄun zaradi dan',0),(502970,13972,'ba','Faktur jatuh tempo hari',0),(502971,13972,'nl','Vervaldatum factuur dag',0),(502972,13972,'fi','Laskun erÃ¤pÃ¤ivÃ¤n pÃ¤ivÃ¤',0),(502973,13972,'no','Fakturaen forfallsdato dag',0),(502974,13972,'da','Fakturere Due dag',0),(502975,13972,'ko','ì¸í•´ ì†¡ìž¥ ë‚ ',0),(502976,13972,'he','×—×©×‘×•× ×™×ª ×‘×©×œ ×”×™×•×',0),(502977,13972,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼Î­ÏÎ±',0),(502978,13972,'zh','å‘ç¥¨åˆ°æœŸçš„ä¸€å¤©',0),(502979,13972,'sv','Fakturera vederbÃ¶rlig dag',0),(502980,13972,'it','Fattura scadenza giorno',0),(502981,13972,'tl','',0),(502982,13972,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™',0),(502983,13972,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤µà¤¸',0),(502984,13972,'ms','Invois habis tempoh hari',0),(502985,13972,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„ÙˆØ§Ø¬Ø¨ Ø§Ù„ÙŠÙˆÙ…',0),(502986,13972,'fr','Facture rÃ©guliÃ¨re jour',0),(502987,13972,'jp','è«‹æ±‚æ›¸ã®æœŸé™æ—¥',0),(502988,13972,'pt','Fatura devida dia',0),(502989,13972,'ru','Ð¡Ñ‡ÐµÑ‚ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð¹ Ð´ÐµÐ½ÑŒ',0),(502990,13972,'es','Factura debida dÃ­a',0),(502991,13972,'de','Rechnung fÃ¤llig Tag',0),(502992,13972,'en','Invoice Due Day',0),(502993,13973,'is','',0),(502994,13973,'dr','Ø±ÙˆØ² Ø³ÙØ§Ø±Ø´',0),(502995,13973,'pr','Ø±ÙˆØ² Ø³ÙØ§Ø±Ø´',0),(502996,13973,'tr','GÃ¼n sipariÅŸ',0),(502997,13973,'pl','PorzÄ…dek dnia',0),(502998,13973,'bg','Ð”Ð½ÐµÐ²ÐµÐ½ Ñ€ÐµÐ´',0),(502999,13973,'ur','Ø±ÙˆØ²Û Ú©Ø§ Ø­Ú©Ù…',0),(503000,13973,'sr','ÐÐ°Ð»Ð¾Ð³ Ð´Ð°Ð½',0),(503001,13973,'vi','Äáº·t hÃ ng ngÃ y',0),(503002,13973,'af','Dag bestel',0),(503003,13973,'ro','Ordinea de zi',0),(503004,13973,'et','KuupÃ¤ev',0),(503005,13973,'si','Naloga dan',0),(503006,13973,'ba','Urutan hari',0),(503007,13973,'nl','Bestelling dag',0),(503008,13973,'fi','TilauspÃ¤ivÃ¤',0),(503009,13973,'no','RekkefÃ¸lgen dagen',0),(503010,13973,'da','Dagens orden',0),(503011,13973,'ko','ì¼ ì£¼ë¬¸',0),(503012,13973,'he','×¡×“×¨ ×™×•×',0),(503013,13973,'el','Î£ÎµÎ¹ÏÎ¬ Î·Î¼Î­ÏÎ±Ï‚',0),(503014,13973,'zh','è®¢è´­çš„ä¸€å¤©',0),(503015,13973,'sv','Ordningen dagen',0),(503016,13973,'it','Ordine giorno',0),(503017,13973,'tl','',0),(503018,13973,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸ªà¸±à¹ˆà¸‡',0),(503019,13973,'hi','à¤¦à¤¿à¤¨ à¤†à¤¦à¥‡à¤¶',0),(503020,13973,'ms','Hari perintah',0),(503021,13973,'ar','Ø£Ù…Ø± Ø§Ù„ÙŠÙˆÙ…',0),(503022,13973,'fr','Ordre jour',0),(503023,13973,'jp','æ³¨æ–‡æ—¥',0),(503024,13973,'pt','Ordem dia',0),(503025,13973,'ru','Ð”ÐµÐ½ÑŒ Ð·Ð°ÐºÐ°Ð·Ð°',0),(503026,13973,'es','Orden dÃ­a',0),(503027,13973,'de','Tagesordnung',0),(503028,13973,'en','Order Day',0),(503029,13974,'is','',0),(503030,13974,'dr','Ø¹Ù„Øª Ø³ÙØ§Ø±Ø´ ØªØ§Ø±ÛŒØ®',0),(503031,13974,'pr','Ø¹Ù„Øª Ø³ÙØ§Ø±Ø´ ØªØ§Ø±ÛŒØ®',0),(503032,13974,'tr','SipariÅŸ vade tarihi',0),(503033,13974,'pl','ZamÃ³w naleÅ¼ytÄ… Data',0),(503034,13974,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(503035,13974,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(503036,13974,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(503037,13974,'vi','Tá»± do ngÃ y',0),(503038,13974,'af','Bestel verskuldigde datum',0),(503039,13974,'ro','Comanda datoritÄƒ data',0),(503040,13974,'et','Tellimuse tÃ¤htaeg kuupÃ¤ev',0),(503041,13974,'si','NaroÄite zaradi datuma',0),(503042,13974,'ba','Memesan Due Date',0),(503043,13974,'nl','Bestel Due datum',0),(503044,13974,'fi','Tilaa asianmukaisesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(503045,13974,'no','Bestille grunn dato',0),(503046,13974,'da','Bestil Due dato',0),(503047,13974,'ko','ì¸í•´ ì£¼ë¬¸ ë‚ ì§œ',0),(503048,13974,'he','×¡×“×¨ ×™×¢×“ ×ª××¨×™×š',0),(503049,13974,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(503050,13974,'zh','è®¢è´­åˆ°æœŸæ—¥æœŸ',0),(503051,13974,'sv','BestÃ¤ll Due Date',0),(503052,13974,'it','Ordinare la scadenza Data',0),(503053,13974,'tl','',0),(503054,13974,'th','à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™',0),(503055,13974,'hi','à¤†à¤¦à¥‡à¤¶ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(503056,13974,'ms','Pesanan akhir tarikh',0),(503057,13974,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(503058,13974,'fr','Commander Due Date',0),(503059,13974,'jp','æ³¨æ–‡ç· ã‚åˆ‡ã‚Šæ—¥',0),(503060,13974,'pt','Ordem devida Data',0),(503061,13974,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾ Ð”Ð°Ñ‚Ð°',0),(503062,13974,'es','Orden legal fecha',0),(503063,13974,'de','Bestellen Sie Due Date',0),(503064,13974,'en','Order Due Date',0),(503065,13975,'is','',0),(503066,13975,'dr','Ø¹Ù„Øª Ø³ÙØ§Ø±Ø´ Ø±ÙˆØ²',0),(503067,13975,'pr','Ø¹Ù„Øª Ø³ÙØ§Ø±Ø´ Ø±ÙˆØ²',0),(503068,13975,'tr','SipariÅŸ vade gÃ¼nÃ¼',0),(503069,13975,'pl','ZamÃ³w naleÅ¼ytÄ… dzieÅ„',0),(503070,13975,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾ Ð´ÐµÐ½',0),(503071,13975,'ur','Ø¢Ø±ÚˆØ± Ù…Ù‚Ø±Ø±Û Ø¯Ù†',0),(503072,13975,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ð½',0),(503073,13975,'vi','Tá»± do ngÃ y',0),(503074,13975,'af','Bestel sperdatum dag',0),(503075,13975,'ro','Comanda cuvenit zi',0),(503076,13975,'et','Korralduse nÃµuetekohase pÃ¤ev',0),(503077,13975,'si','NaroÄite zaradi dan',0),(503078,13975,'ba','Memesan jatuh tempo hari',0),(503079,13975,'nl','Bestel Due dag',0),(503080,13975,'fi','Tilaa asianmukaisesti pÃ¤ivÃ¤',0),(503081,13975,'no','Bestille grunn dag',0),(503082,13975,'da','Bestil Due dag',0),(503083,13975,'ko','ì¸í•´ ì£¼ë¬¸ ì¼',0),(503084,13975,'he','×¡×“×¨ ×ª×§×™×Ÿ ×”×™×•×',0),(503085,13975,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼Î­ÏÎ±',0),(503086,13975,'zh','è®¢è´­åˆ°æœŸçš„ä¸€å¤©',0),(503087,13975,'sv','BestÃ¤ll vederbÃ¶rlig dag',0),(503088,13975,'it','Ordinare Due giorno',0),(503089,13975,'tl','',0),(503090,13975,'th','à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™',0),(503091,13975,'hi','à¤†à¤¦à¥‡à¤¶ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨',0),(503092,13975,'ms','Perintah habis tempoh hari',0),(503093,13975,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø§Ù„ÙŠÙˆÙ…',0),(503094,13975,'fr','Commander Due jour',0),(503095,13975,'jp','æ³¨æ–‡ç· ã‚åˆ‡ã‚Šæ—¥',0),(503096,13975,'pt','Ordem devida dia',0),(503097,13975,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾ Ð´ÐµÐ½ÑŒ',0),(503098,13975,'es','Orden debido dÃ­a',0),(503099,13975,'de','Bestellen Sie Due Day',0),(503100,13975,'en','Order Due Day',0),(503101,13976,'is','',0),(503102,13976,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø¹Ù„Øª Ù…Ø§Ù‡',0),(503103,13976,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø¹Ù„Øª Ù…Ø§Ù‡',0),(503104,13976,'tr','SipariÅŸ son ay',0),(503105,13976,'pl','ZamÃ³w naleÅ¼ytÄ… miesiÄ…ca',0),(503106,13976,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾ Ð¼ÐµÑÐµÑ†',0),(503107,13976,'ur','Ø¢Ø±ÚˆØ± Ù…Ù‚Ø±Ø±Û Ù…ÛÛŒÙ†Û’',0),(503108,13976,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð¼ÐµÑÐµÑ†Ð°',0),(503109,13976,'vi','Äáº·t hÃ ng do thÃ¡ng',0),(503110,13976,'af','Bestel sperdatum maand',0),(503111,13976,'ro','Comanda cuvenit luna',0),(503112,13976,'et','Tellimuse tÃ¤htaeg kuu',0),(503113,13976,'si','NaroÄite ustreznem mesecu',0),(503114,13976,'ba','Memesan karena bulan',0),(503115,13976,'nl','Bestel Due maand',0),(503116,13976,'fi','Tilaa asianmukaisesti kuukauden',0),(503117,13976,'no','Bestille grunn mÃ¥ned',0),(503118,13976,'da','Bestil Due mÃ¥ned',0),(503119,13976,'ko','ì£¼ë¬¸ ì¸í•´ ë‹¬',0),(503120,13976,'he','×¡×“×¨ ×¤×™×¨×¢×•×Ÿ ×‘×—×•×“×©',0),(503121,13976,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î¼Î®Î½Î±',0),(503122,13976,'zh','è®¢è´­åˆ°æœŸæœˆä»½',0),(503123,13976,'sv','BestÃ¤ll vederbÃ¶rlig mÃ¥nad',0),(503124,13976,'it','Ordinare Due mese',0),(503125,13976,'tl','',0),(503126,13976,'th','à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¹€à¸”à¸·à¸­à¸™',0),(503127,13976,'hi','à¤†à¤¦à¥‡à¤¶ à¤¨à¤¿à¤¯à¤¤ à¤®à¤¾à¤¹',0),(503128,13976,'ms','Pesanan akhir bulan',0),(503129,13976,'ar','ØªØ£Ù…Ø± Ø§Ù„ÙˆØ§Ø¬Ø¨Ø© Ø§Ù„Ø´Ù‡Ø±',0),(503130,13976,'fr','Commander Due mois',0),(503131,13976,'jp','æ³¨æ–‡ç· ã‚åˆ‡ã‚Š 1 ãƒ¶æœˆ',0),(503132,13976,'pt','Ordem devida mÃªs',0),(503133,13976,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾ Ð¼ÐµÑÑÑ†',0),(503134,13976,'es','Orden debido mes',0),(503135,13976,'de','Bestellen Sie Due Monat',0),(503136,13976,'en','Order Due Month',0),(503137,13977,'is','',0),(503138,13977,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø¹Ù„Øª Ø³Ø§Ù„',0),(503139,13977,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø¹Ù„Øª Ø³Ø§Ù„',0),(503140,13977,'tr','SipariÅŸ son yÄ±l',0),(503141,13977,'pl','ZamÃ³w naleÅ¼ytÄ… roku',0),(503142,13977,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(503143,13977,'ur','Ø¢Ø±ÚˆØ± Ù…Ù‚Ø±Ø±Û Ø³Ø§Ù„',0),(503144,13977,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(503145,13977,'vi','Tá»± do nÄƒm',0),(503146,13977,'af','Bestel sperdatum jaar',0),(503147,13977,'ro','Comanda cuvenit an',0),(503148,13977,'et','Tellimuse tÃ¤htaeg aasta',0),(503149,13977,'si','Odredi ustrezno leto',0),(503150,13977,'ba','Memesan Due tahun',0),(503151,13977,'nl','Bestel Due jaar',0),(503152,13977,'fi','Tilaa asianmukaisesti vuoden',0),(503153,13977,'no','Bestille grunn Ã¥r',0),(503154,13977,'da','Bestil Due Ã¥r',0),(503155,13977,'ko','ì¸í•´ ì£¼ë¬¸ ë…„',0),(503156,13977,'he','×¡×“×¨ ×ª×§×™×Ÿ ×”×©× ×”',0),(503157,13977,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ ÎµÏÎ¸ÎµÏ„Î¿ Ï‡ÏÏŒÎ½Î¿',0),(503158,13977,'zh','è®¢è´­åˆ°æœŸå¹´',0),(503159,13977,'sv','BestÃ¤ll vederbÃ¶rlig Ã¥r',0),(503160,13977,'it','Ordinare Due anno',0),(503161,13977,'tl','',0),(503162,13977,'th','à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸›à¸µ',0),(503163,13977,'hi','à¤†à¤¦à¥‡à¤¶ à¤¨à¤¿à¤¯à¤¤ à¤µà¤°à¥à¤·',0),(503164,13977,'ms','Pesanan akhir tahun',0),(503165,13977,'ar','Ø§Ù„ÙˆØ§Ø¬Ø¨ Ù…Ù† Ø£Ø¬Ù„ Ø§Ù„Ø³Ù†Ø©',0),(503166,13977,'fr','Commander Due an',0),(503167,13977,'jp','æ³¨æ–‡ç· ã‚åˆ‡ã‚Šå¹´',0),(503168,13977,'pt','Ordem devida ano',0),(503169,13977,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾ Ð³Ð¾Ð´',0),(503170,13977,'es','Orden debido aÃ±o',0),(503171,13977,'de','Bestellen Sie Due Jahr',0),(503172,13977,'en','Order Due Year',0),(503173,13978,'is','',0),(503174,13978,'dr','Ù…Ø§Ù‡ Ø³ÙØ§Ø±Ø´',0),(503175,13978,'pr','Ù…Ø§Ù‡ Ø³ÙØ§Ø±Ø´',0),(503176,13978,'tr','SipariÅŸ ay',0),(503177,13978,'pl','ZamÃ³wienie miesiÄ…ca',0),(503178,13978,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¼ÐµÑÐµÑ†',0),(503179,13978,'ur','ØªØ±ØªÛŒØ¨ Ù…ÛÛŒÙ†Û’',0),(503180,13978,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ Ð¼ÐµÑÐµÑ†Ð°',0),(503181,13978,'vi','Äáº·t hÃ ng thÃ¡ng',0),(503182,13978,'af','Orde maand',0),(503183,13978,'ro','Ordinul luna',0),(503184,13978,'et','Korra kuus',0),(503185,13978,'si','Naloga meseca',0),(503186,13978,'ba','Urutan bulan',0),(503187,13978,'nl','Volgorde maand',0),(503188,13978,'fi','Tilauksen kuukauden',0),(503189,13978,'no','For mÃ¥neden',0),(503190,13978,'da','Bestil mÃ¥ned',0),(503191,13978,'ko','ìˆœì„œ ëŒ€ë¡œ ë‹¬',0),(503192,13978,'he','×”×¡×“×¨ ×—×•×“×©',0),(503193,13978,'el','Î£ÎµÎ¹ÏÎ¬ Î¼Î®Î½Î±',0),(503194,13978,'zh','è®¢è´­æœˆä»½',0),(503195,13978,'sv','Ordning mÃ¥nad',0),(503196,13978,'it','Ordine mese',0),(503197,13978,'tl','',0),(503198,13978,'th','à¸ªà¸±à¹ˆà¸‡à¹€à¸”à¸·à¸­à¸™',0),(503199,13978,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(503200,13978,'ms','Bulan perintah',0),(503201,13978,'ar','Ø§Ù„ØªØ±ØªÙŠØ¨ Ø§Ù„Ø´Ù‡Ø±',0),(503202,13978,'fr','Mois de l\'ordonnance',0),(503203,13978,'jp','æ³¨æ–‡æœˆ',0),(503204,13978,'pt','MÃªs de fim',0),(503205,13978,'ru','Ð—Ð°ÐºÐ°Ð· Ð¼ÐµÑÑÑ†',0),(503206,13978,'es','Mes de la orden',0),(503207,13978,'de','Reihenfolge Monat',0),(503208,13978,'en','Order Month',0),(503209,13979,'is','',0),(503210,13979,'dr','Ø±ÙˆØ² Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(503211,13979,'pr','Ø±ÙˆØ² Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(503212,13979,'tr','Teklif gÃ¼nÃ¼',0),(503213,13979,'pl','Cytat dnia',0),(503214,13979,'bg','Ð¦Ð¸Ñ‚Ð°Ñ‚ Ð´ÐµÐ½',0),(503215,13979,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©Û’ Ø¯Ù†',0),(503216,13979,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð´Ð°Ð½',0),(503217,13979,'vi','BÃ¡o ngÃ y',0),(503218,13979,'af','Aanhaling dag',0),(503219,13979,'ro','Citat de zi',0),(503220,13979,'et','PÃ¤eva tsitaat',0),(503221,13979,'si','Citat dneva',0),(503222,13979,'ba','Kutipan hari',0),(503223,13979,'nl','Citaat van de dag',0),(503224,13979,'fi','Lainaus pÃ¤ivÃ¤n',0),(503225,13979,'no','Tilbud dag',0),(503226,13979,'da','Citat dag',0),(503227,13979,'ko','ê²¬ì  í•˜ë£¨',0),(503228,13979,'he','×¦×™×˜×•×˜ ×”×™×•×',0),(503229,13979,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î·Î¼Î­ÏÎ±Ï‚',0),(503230,13979,'zh','æŠ¥ä»·çš„ä¸€å¤©',0),(503231,13979,'sv','Citat dagen',0),(503232,13979,'it','Giorno di quotazione',0),(503233,13979,'tl','',0),(503234,13979,'th','à¸§à¸±à¸™à¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(503235,13979,'hi','à¤¦à¤¿à¤µà¤¸ à¤•à¥‡ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(503236,13979,'ms','Quote hari',0),(503237,13979,'ar','Ø§Ù‚ØªØ¨Ø³ Ù…Ù† Ø§Ù„ÙŠÙˆÙ…',0),(503238,13979,'fr','Citation jour',0),(503239,13979,'jp','æ—¥ã‚’å¼•ç”¨ã—ã¾ã™ã€‚',0),(503240,13979,'pt','CitaÃ§Ã£o do dia',0),(503241,13979,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð´Ð½Ñ',0),(503242,13979,'es','DÃ­a de cotizaciÃ³n',0),(503243,13979,'de','Zitat-Tag',0),(503244,13979,'en','Quote Day',0),(503245,13980,'is','',0),(503246,13980,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ù†Ù‚Ø¶Ø§ÛŒ ØªØ§Ø±ÛŒØ®',0),(503247,13980,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ù†Ù‚Ø¶Ø§ÛŒ ØªØ§Ø±ÛŒØ®',0),(503248,13980,'tr','Teklif Expires Tarih',0),(503249,13980,'pl','Oferta wygasa dnia',0),(503250,13980,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð°Ñ‚Ð° Ð¸Ð·Ñ‚Ð¸Ñ‡Ð° Ð´Ð°Ñ‚Ð°',0),(503251,13980,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø²Ø§ÛŒØ¯ Ù…ÛŒØ¹Ø§Ø¯ Ø§Ø² ØªØ§Ø±ÛŒØ®',0),(503252,13980,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð¸ÑÑ‚Ð¸Ñ‡Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(503253,13980,'vi','BÃ¡o háº¿t háº¡n ngÃ y',0),(503254,13980,'af','Aanhaling verval datum',0),(503255,13980,'ro','Oferta expirÄƒ data',0),(503256,13980,'et','Hinnapakkumise kehtivuse kuupÃ¤ev',0),(503257,13980,'si','Ponudba poteÄe datum',0),(503258,13980,'ba','Penawaran berakhir tanggal',0),(503259,13980,'nl','Offerte vervallen datum',0),(503260,13980,'fi','Tarjous umpeutuu pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(503261,13980,'no','Tilbud utlÃ¸per dato',0),(503262,13980,'da','Tilbud udlÃ¸ber dato',0),(503263,13980,'ko','ê²¬ì  ë§Œë£Œ ë‚ ì§œ',0),(503264,13980,'he','×”×¦×¢×ª ×ž×—×™×¨ ×¤×’ ×ª×•×§×£ ×ª××¨×™×š',0),(503265,13980,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î»Î®Î³ÎµÎ¹ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(503266,13980,'zh','æŠ¥ä»·è¿‡æœŸæ—¥æœŸ',0),(503267,13980,'sv','Citat upphÃ¶r datum',0),(503268,13980,'it','Citazione scadenza Data',0),(503269,13980,'tl','',0),(503270,13980,'th','à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¸§à¸±à¸™',0),(503271,13980,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥€ à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(503272,13980,'ms','Quote luput tarikh',0),(503273,13980,'ar','Ø§Ù†ØªÙ‡Ø§Ø¡ ØµÙ„Ø§Ø­ÙŠØ© Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(503274,13980,'fr','Citation expire Date',0),(503275,13980,'jp','è¦‹ç©ã‚Šæœ‰åŠ¹æœŸé™ãŒåˆ‡ã‚Œã‚‹æ—¥ä»˜',0),(503276,13980,'pt','CitaÃ§Ã£o expira data',0),(503277,13980,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð¸ÑÑ‚ÐµÐºÐ°ÐµÑ‚ Ð”Ð°Ñ‚Ð°',0),(503278,13980,'es','Citar expira fecha',0),(503279,13980,'de','Angebot gÃ¼ltig bis Datum',0),(503280,13980,'en','Quote Expires Date',0),(503281,13981,'is','',0),(503282,13981,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ù…Ù†Ù‚Ø¶ÛŒ Ù…ÛŒ Ø´ÙˆØ¯ Ø±ÙˆØ²',0),(503283,13981,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ù…Ù†Ù‚Ø¶ÛŒ Ù…ÛŒ Ø´ÙˆØ¯ Ø±ÙˆØ²',0),(503284,13981,'tr','Teklif sÃ¼resi gÃ¼n',0),(503285,13981,'pl','Oferta wygasa dnia',0),(503286,13981,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð°Ñ‚Ð° Ð¸Ð·Ñ‚Ð¸Ñ‡Ð° Ð´ÐµÐ½',0),(503287,13981,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø²Ø§ÛŒØ¯ Ù…ÛŒØ¹Ø§Ø¯ Ø§Ø² Ø¯Ù†',0),(503288,13981,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð¸ÑÑ‚Ð¸Ñ‡Ðµ Ð´Ð°Ð½Ð°',0),(503289,13981,'vi','BÃ¡o háº¿t háº¡n ngÃ y',0),(503290,13981,'af','Aanhaling verval dag',0),(503291,13981,'ro','Oferta expirÄƒ zi',0),(503292,13981,'et','Hinnapakkumise kehtivuse pÃ¤ev',0),(503293,13981,'si','Ponudba poteÄe dan',0),(503294,13981,'ba','Penawaran berakhir hari',0),(503295,13981,'nl','Offerte verloopt dag',0),(503296,13981,'fi','Tarjous umpeutuu pÃ¤ivÃ¤',0),(503297,13981,'no','Tilbud utlÃ¸per dagen',0),(503298,13981,'da','Tilbud udlÃ¸ber dagen',0),(503299,13981,'ko','ê²¬ì  ë§Œë£Œ í•˜ë£¨',0),(503300,13981,'he','×”×¦×¢×ª ×”×ž×—×™×¨ ×™×¤×•×’ ×”×™×•×',0),(503301,13981,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î»Î®Î³ÎµÎ¹ Î·Î¼Î­ÏÎ±',0),(503302,13981,'zh','æŠ¥ä»·è¿‡æœŸä¸€å¤©',0),(503303,13981,'sv','Citat upphÃ¶r att gÃ¤lla dagen',0),(503304,13981,'it','Citazione scade giorno',0),(503305,13981,'tl','',0),(503306,13981,'th','à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¸§à¸±à¸™',0),(503307,13981,'hi','à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤…à¤µà¤¸à¤¾à¤¨ à¤¦à¤¿à¤µà¤¸',0),(503308,13981,'ms','Quote tamat tempoh hari',0),(503309,13981,'ar','Ø§Ù†ØªÙ‡Ø§Ø¡ ØµÙ„Ø§Ø­ÙŠØ© Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„ÙŠÙˆÙ…',0),(503310,13981,'fr','Citation expire Day',0),(503311,13981,'jp','è¦‹ç©ã‚Šæœ‰åŠ¹æœŸé™ãŒåˆ‡ã‚Œã‚‹æ—¥',0),(503312,13981,'pt','CitaÃ§Ã£o expira dia',0),(503313,13981,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð·Ð°ÐºÐ°Ð½Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ Ð´ÐµÐ½ÑŒ',0),(503314,13981,'es','Citar expira dÃ­a',0),(503315,13981,'de','Angebot gÃ¼ltig bis Tag',0),(503316,13981,'en','Quote Expires Day',0),(503317,13982,'is','',0),(503318,13982,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ù†Ù‚Ø¶Ø§ÛŒ Ù…Ø§Ù‡',0),(503319,13982,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ù†Ù‚Ø¶Ø§ÛŒ Ù…Ø§Ù‡',0),(503320,13982,'tr','Teklif sÃ¼resi ay',0),(503321,13982,'pl','Oferta wygasa miesiÄ…ca',0),(503322,13982,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð°Ñ‚Ð° Ð¸Ð·Ñ‚ÐµÑ‡Ðµ Ð¼ÐµÑÐµÑ†',0),(503323,13982,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø²Ø§ÛŒØ¯ Ù…ÛŒØ¹Ø§Ø¯ Ø§Ø² Ù…ÛÛŒÙ†Û',0),(503324,13982,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð¸ÑÑ‚Ð¸Ñ‡Ðµ Ð¼ÐµÑÐµÑ†Ð°',0),(503325,13982,'vi','BÃ¡o háº¿t háº¡n thÃ¡ng',0),(503326,13982,'af','Aanhaling verval maand',0),(503327,13982,'ro','Oferta expira luna',0),(503328,13982,'et','Hinnapakkumise kehtivuse kuus',0),(503329,13982,'si','Ponudba poteÄe meseca',0),(503330,13982,'ba','Penawaran berakhir bulan',0),(503331,13982,'nl','Offerte verloopt maand',0),(503332,13982,'fi','Tarjous umpeutuu kuun',0),(503333,13982,'no','Tilbud opphÃ¸rer mÃ¥ned',0),(503334,13982,'da','Tilbud udlÃ¸ber mÃ¥ned',0),(503335,13982,'ko','ê²¬ì  ë§Œë£Œ ë‹¬',0),(503336,13982,'he','×”×¦×¢×ª ×”×ž×—×™×¨ ×™×¤×•×’ ×‘×—×•×“×©',0),(503337,13982,'el','Î›Î®Î³ÎµÎ¹ Î· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î¼Î®Î½Î±',0),(503338,13982,'zh','æŠ¥ä»·å•åˆ°æœŸæœˆä»½',0),(503339,13982,'sv','Citat upphÃ¶r mÃ¥nad',0),(503340,13982,'it','Citazione scade mese',0),(503341,13982,'tl','',0),(503342,13982,'th','à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¹€à¸”à¸·à¸­à¸™',0),(503343,13982,'hi','à¤­à¤¾à¤µ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤…à¤µà¤¸à¤¾à¤¨ à¤®à¤¾à¤¹',0),(503344,13982,'ms','Quote tamat tempoh bulan',0),(503345,13982,'ar','Ø§Ù†ØªÙ‡Ø§Ø¡ ØµÙ„Ø§Ø­ÙŠØ© Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ÙÙŠ Ø§Ù„Ø´Ù‡Ø±',0),(503346,13982,'fr','Citation expire mois',0),(503347,13982,'jp','è¦‹ç©ã‚Šæœ‰åŠ¹æœŸé™ãŒåˆ‡ã‚Œã‚‹ 1 ãƒ¶æœˆ',0),(503348,13982,'pt','CitaÃ§Ã£o expira mÃªs',0),(503349,13982,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð¸ÑÑ‚ÐµÑ‡ÐµÑ‚ Ð¼ÐµÑÑÑ†',0),(503350,13982,'es','Citar expira mes',0),(503351,13982,'de','Angebot gÃ¼ltig bis Monat',0),(503352,13982,'en','Quote Expires Month',0),(503353,13983,'is','',0),(503354,13983,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ù†Ù‚Ø¶Ø§ÛŒ Ø³Ø§Ù„',0),(503355,13983,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø§Ù†Ù‚Ø¶Ø§ÛŒ Ø³Ø§Ù„',0),(503356,13983,'tr','Teklif sÃ¼resi yÄ±l',0),(503357,13983,'pl','Oferta wygasa rok',0),(503358,13983,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð°Ñ‚Ð° Ð¸Ð·Ñ‚Ð¸Ñ‡Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(503359,13983,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ø²Ø§ÛŒØ¯ Ù…ÛŒØ¹Ø§Ø¯ Ø§Ø² Ø³Ø§Ù„',0),(503360,13983,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð¸ÑÑ‚Ð¸Ñ‡Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(503361,13983,'vi','BÃ¡o háº¿t háº¡n nÄƒm',0),(503362,13983,'af','Aanhaling verval jaar',0),(503363,13983,'ro','Oferta expirÄƒ anul',0),(503364,13983,'et','Hinnapakkumise kehtivuse aasta',0),(503365,13983,'si','Ponudba poteÄe leto',0),(503366,13983,'ba','Penawaran berakhir tahun',0),(503367,13983,'nl','Offerte verloopt jaar',0),(503368,13983,'fi','Tarjous umpeutuu vuoden',0),(503369,13983,'no','Tilbud opphÃ¸rer Ã¥r',0),(503370,13983,'da','Tilbud udlÃ¸ber Ã¥r',0),(503371,13983,'ko','ê²¬ì  ë§Œë£Œ ë…„',0),(503372,13983,'he','×”×¦×¢×ª ×”×ž×—×™×¨ ×™×¤×•×’ ×‘×©× ×”',0),(503373,13983,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î»Î®Î³ÎµÎ¹ Ï„Î¿ Î­Ï„Î¿Ï‚',0),(503374,13983,'zh','æŠ¥ä»·è¿‡æœŸä¸€å¹´',0),(503375,13983,'sv','Citat lÃ¶per ut Ã¥r',0),(503376,13983,'it','Citazione scade anno',0),(503377,13983,'tl','',0),(503378,13983,'th','à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¸›à¸µ',0),(503379,13983,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥€ à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤µà¤°à¥à¤·',0),(503380,13983,'ms','Quote tamat tempoh tahun',0),(503381,13983,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± ÙˆØªÙ†ØªÙ‡ÙŠ Ø§Ù„Ø³Ù†Ø©',0),(503382,13983,'fr','Citation expire l\'annÃ©e',0),(503383,13983,'jp','è¦‹ç©ã‚Šæœ‰åŠ¹æœŸé™ãŒåˆ‡ã‚Œã‚‹ 1 å¹´',0),(503384,13983,'pt','CitaÃ§Ã£o expira ano',0),(503385,13983,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð¸ÑÑ‚ÐµÐºÐ°ÐµÑ‚ Ð³Ð¾Ð´',0),(503386,13983,'es','Citar expira el aÃ±o',0),(503387,13983,'de','Angebot gÃ¼ltig bis Jahr',0),(503388,13983,'en','Quote Expires Year',0),(503389,13984,'is','',0),(503390,13984,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ù…Ø§Ù‡',0),(503391,13984,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ù…Ø§Ù‡',0),(503392,13984,'tr','Ay alÄ±ntÄ±',0),(503393,13984,'pl','Cytat miesiÄ…ca',0),(503394,13984,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð¼ÐµÑÐµÑ†',0),(503395,13984,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ù…ÛÛŒÙ†Û',0),(503396,13984,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(503397,13984,'vi','BÃ¡o thÃ¡ng',0),(503398,13984,'af','Aanhaling maand',0),(503399,13984,'ro','Oferta lunii',0),(503400,13984,'et','Kuu tsitaat',0),(503401,13984,'si','Citat meseca',0),(503402,13984,'ba','Mengutip bulan',0),(503403,13984,'nl','Citaat van de maand',0),(503404,13984,'fi','Kuukauden tarjous',0),(503405,13984,'no','Tilbud mÃ¥ned',0),(503406,13984,'da','Citat mÃ¥ned',0),(503407,13984,'ko','ë‹¬ ì¸ìš©',0),(503408,13984,'he','×”×¦×¢×ª ×ž×—×™×¨ ×—×•×“×©',0),(503409,13984,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Î¼Î®Î½Î±',0),(503410,13984,'zh','æŠ¥ä»·æœˆ',0),(503411,13984,'sv','Citera mÃ¥nad',0),(503412,13984,'it','Citazione mese',0),(503413,13984,'tl','',0),(503414,13984,'th','à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¹€à¸”à¸·à¸­à¸™',0),(503415,13984,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤®à¤¹à¥€à¤¨à¥‡',0),(503416,13984,'ms','Sebut harga bulan',0),(503417,13984,'ar','Ø§Ù‚ØªØ¨Ø³ Ø§Ù„Ø´Ù‡Ø±',0),(503418,13984,'fr','Cite mois',0),(503419,13984,'jp','è¦‹ç©ã‚‚ã‚Šæœˆ',0),(503420,13984,'pt','CitaÃ§Ã£o do mÃªs',0),(503421,13984,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð¼ÐµÑÑÑ†Ð°',0),(503422,13984,'es','Mes de cotizaciÃ³n',0),(503423,13984,'de','Angebot Monat',0),(503424,13984,'en','Quote Month',0),(503425,13985,'is','',0),(503426,13985,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø³Ø§Ù„',0),(503427,13985,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø³Ø§Ù„',0),(503428,13985,'tr','YÄ±l alÄ±ntÄ±',0),(503429,13985,'pl','Cytat roku',0),(503430,13985,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(503431,13985,'ur','Ø³Ø§Ù„ Ø§Ù‚ØªØ¨Ø§Ø³',0),(503432,13985,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(503433,13985,'vi','BÃ¡o nÄƒm',0),(503434,13985,'af','Aanhaling jaar',0),(503435,13985,'ro','Citat an',0),(503436,13985,'et','Pakkumise aasta',0),(503437,13985,'si','Ponudba leto',0),(503438,13985,'ba','Mengutip tahun',0),(503439,13985,'nl','Offerte jaar',0),(503440,13985,'fi','Tarjouksen vuoden',0),(503441,13985,'no','Tilbud Ã¥r',0),(503442,13985,'da','Citat Ã¥r',0),(503443,13985,'ko','ê²¬ì  í•´',0),(503444,13985,'he','×”×¦×¢×ª ×ž×—×™×¨ ×‘×©× ×”',0),(503445,13985,'el','Î‘Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î± Î­Ï„Î¿Ï‚',0),(503446,13985,'zh','å¼•è¿°ä¸€å¹´',0),(503447,13985,'sv','Citera Ã¥r',0),(503448,13985,'it','Citazione anno',0),(503449,13985,'tl','',0),(503450,13985,'th','à¸›à¸µà¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(503451,13985,'hi','à¤¬à¥‹à¤²à¥€ à¤•à¥‡ à¤µà¤°à¥à¤·',0),(503452,13985,'ms','Sila nyatakan tahun',0),(503453,13985,'ar','Ø³Ù†Ø© Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³',0),(503454,13985,'fr','AnnÃ©e de soumission',0),(503455,13985,'jp','å¹´ã‚’å¼•ç”¨ã—ã¾ã™ã€‚',0),(503456,13985,'pt','Ano de citaÃ§Ã£o',0),(503457,13985,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð°',0),(503458,13985,'es','Presupuesto aÃ±o',0),(503459,13985,'de','Zitat von Jahr',0),(503460,13985,'en','Quote Year',0),(503461,13986,'is','',0),(503462,13986,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ØªØºÛŒÛŒØ± Ù‚ÛŒÙ…Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø²ÛŒØ± Ù…ÙˆØ±Ø¯ Ø­Ø¯Ø§Ù‚Ù„ Ø­Ø§Ø´ÛŒÙ‡ Ø³ÙˆØ¯',0),(503463,13986,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ ØªØºÛŒÛŒØ± Ù‚ÛŒÙ…Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø²ÛŒØ± Ù…ÙˆØ±Ø¯ Ø­Ø¯Ø§Ù‚Ù„ Ø­Ø§Ø´ÛŒÙ‡ Ø³ÙˆØ¯',0),(503464,13986,'tr','POS fiyatlarÄ± aÅŸaÄŸÄ±da Minimum madde kar marjÄ± deÄŸiÅŸtiremezsiniz',0),(503465,13986,'pl','Nie moÅ¼na zmieniÄ‡ POS ceny poniÅ¼ej pozycji minimalnej marÅ¼y zysku',0),(503466,13986,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÑÑ‚Ðµ POS Ñ†ÐµÐ½Ð¸ Ð¿Ð¾Ð´ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð¸Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(503467,13986,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©ÛŒ Ù‚ÛŒÙ…ØªÛŒÚº Ú©Ù… Ø³Û’ Ú©Ù… Ø¢Ø¦Ù¹Ù… Ù¾ÛŒÚ†ÛŒØ¯Û Ù†ÛŒÚ†Û’ ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(503468,13986,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ð¸ ÐŸÐžÐ¡ Ñ†ÐµÐ½Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° ÐŸÑ€Ð¾Ñ„Ð¸Ñ‚Ð½Ð° Ð¼Ð°Ñ€Ð¶Ð°',0),(503469,13986,'vi','KhÃ´ng thá»ƒ thay Ä‘á»•i POS giÃ¡ dÆ°á»›i má»¥c tá»‘i thiá»ƒu lá»£i nhuáº­n',0),(503470,13986,'af','POS pryse onder Minimum Item wins marge kan verander',0),(503471,13986,'ro','Imposibil de modificat POS preÅ£uri sub marja de Profit minim element',0),(503472,13986,'et','POS hindu alla vÃ¤ikseim Ã¼ksus kasumimarginaali ei saa muuta',0),(503473,13986,'si','Ne morete spremeniti POS cene, pod minimalno element dobiÄka',0),(503474,13986,'ba','Tidak dapat mengubah POS harga di bawah Minimum Item Margin keuntungan',0),(503475,13986,'nl','POS prijzen onder minimale Item winstmarge wijzigen niet',0),(503476,13986,'fi','Ei voi muuttaa POS hinnoilla vÃ¤hintÃ¤Ã¤n kohteen voittomarginaali',0),(503477,13986,'no','Kan ikke endre POS priser under Minimum element fortjenestemargin',0),(503478,13986,'da','Kan ikke Ã¦ndre POS priser under Minimum vare fortjenstmargen',0),(503479,13986,'ko','ìµœì†Œ í•­ëª© ì´ìœ¤í­ ì´í•˜ì˜ ë‹¨ë§ê¸° ê°€ê²©ì„ ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(503480,13986,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×©× ×•×ª POS ×”×ž×—×™×¨×™× ×œ×ž×˜×” ×©×•×œ×™ ×¨×•×•×— ×”×ž×™× ×™×ž×œ×™×•×ª ×”×¤×¨×™×˜',0),(503481,13986,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Î±Î»Î»Î¬Î¾Ï‰ Ï„Î¿ POS Ï„Î¹Î¼Î­Ï‚ Ï‡Î±Î¼Î·Î»ÏŒÏ„ÎµÏÎµÏ‚ Î±Ï€ÏŒ Ï„Î¿ ÎµÎ»Î¬Ï‡Î¹ÏƒÏ„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ ÎºÎ­ÏÎ´Î¿Ï…Ï‚',0),(503482,13986,'zh','ä¸èƒ½æ›´æ”¹ POS ä»·æ ¼ä½ŽäºŽæœ€ä½Žé¡¹ç›®åˆ©æ¶¦çŽ‡',0),(503483,13986,'sv','Kan inte Ã¤ndra POS priser under lÃ¤gsta punkt vinstmarginal',0),(503484,13986,'it','Non Ã¨ possibile modificare POS prezzi inferiori elemento minimo margine di profitto',0),(503485,13986,'tl','',0),(503486,13986,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡ POS à¸£à¸²à¸„à¸²à¸•à¹ˆà¸³à¸à¸³à¹„à¸£à¸ªà¸´à¸™à¸„à¹‰à¸²à¸•à¹ˆà¸³à¸ªà¸¸à¸”',0),(503487,13986,'hi','POS à¤•à¥€à¤®à¤¤à¥‡à¤‚ à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤†à¤‡à¤Ÿà¤® à¤²à¤¾à¤­ à¤®à¤¾à¤°à¥à¤œà¤¿à¤¨ à¤¨à¥€à¤šà¥‡ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(503488,13986,'ms','Tidak boleh menukar harga POS di bawah Margin keuntungan minima Item',0),(503489,13986,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØºÙŠÙŠØ± Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ø¨ÙŠØ¹ ØªØ­Øª Ø¨Ù†Ø¯ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† Ù‡Ø§Ù…Ø´ Ø§Ù„Ø±Ø¨Ø­',0),(503490,13986,'fr','Ne pouvez pas modifier le prix de POS infÃ©rieurs Ã  la marge bÃ©nÃ©ficiaire minimale de point',0),(503491,13986,'jp','æœ€å°ã‚¢ã‚¤ãƒ†ãƒ åˆ©ç›Šä»¥ä¸‹ POS ã®ä¾¡æ ¼ã‚’å¤‰æ›´ã§ãã¾ã›ã‚“ã€‚',0),(503492,13986,'pt','NÃ£o Ã© possÃ­vel alterar preÃ§os POS abaixo da margem de lucro mÃ­nima de Item',0),(503493,13986,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ POS Ñ†ÐµÐ½Ñ‹ Ð½Ð¸Ð¶Ðµ Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸',0),(503494,13986,'es','No se puede cambiar POS precios por debajo del margen de beneficio mÃ­nimo elemento',0),(503495,13986,'de','POS Preise unterhalb Gewinnspanne minimale Element kann nicht geÃ¤ndert werden.',0),(503496,13986,'en','Cannot Change POS Prices Below Minimum Item Profit Margin',0),(503497,13987,'is','',0),(503498,13987,'dr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø³Ø§Ø®Øª',0),(503499,13987,'pr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø³Ø§Ø®Øª',0),(503500,13987,'tr','Otomatik oluÅŸturma',0),(503501,13987,'pl','Auto budowaÄ‡',0),(503502,13987,'bg','ÐÐ²Ñ‚Ð¾ Ð‘Ð¸Ð»Ð´',0),(503503,13987,'ur','Ø®ÙˆØ¯ ØªØ¹Ù…ÛŒØ±',0),(503504,13987,'sr','ÐÑƒÑ‚Ð¾ Ð‘ÑƒÐ¸Ð»Ð´',0),(503505,13987,'vi','Tá»± Ä‘á»™ng xÃ¢y dá»±ng',0),(503506,13987,'af','Outomatiese bou',0),(503507,13987,'ro','Auto Build',0),(503508,13987,'et','Auto ehitada',0),(503509,13987,'si','Build avto',0),(503510,13987,'ba','Auto membangun',0),(503511,13987,'nl','Auto Build',0),(503512,13987,'fi','Auto rakentaa',0),(503513,13987,'no','Auto Bygg',0),(503514,13987,'da','Auto Byg',0),(503515,13987,'ko','ìžë™ ë¹Œë“œ',0),(503516,13987,'he','×œ×‘× ×•×ª ××•×˜×•×ž×˜×™',0),(503517,13987,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î®',0),(503518,13987,'zh','è‡ªåŠ¨ç”Ÿæˆ',0),(503519,13987,'sv','Auto bygga',0),(503520,13987,'it','Compilazione automatica',0),(503521,13987,'tl','',0),(503522,13987,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(503523,13987,'hi','à¤‘à¤Ÿà¥‹ à¤¬à¤¨à¤¾à¤à¤',0),(503524,13987,'ms','Membina auto',0),(503525,13987,'ar','Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(503526,13987,'fr','GÃ©nÃ©ration automatique',0),(503527,13987,'jp','è‡ªå‹•æ§‹ç¯‰',0),(503528,13987,'pt','CompilaÃ§Ã£o de auto',0),(503529,13987,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ðµ',0),(503530,13987,'es','Auto construcciÃ³n',0),(503531,13987,'de','Automatisch erstellen',0),(503532,13987,'en','Auto Build',0),(503533,13988,'is','',0),(503534,13988,'dr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø®ÙˆØ¯Ú©Ø§Ø±',0),(503535,13988,'pr','Ø³ÙØ§Ø±Ø´ Ø³Ø§Ø®Øª Ø®ÙˆØ¯Ú©Ø§Ø±',0),(503536,13988,'tr','Otomatik yapÄ± sipariÅŸi',0),(503537,13988,'pl','Auto Build Order',0),(503538,13988,'bg','ÐÐ²Ñ‚Ð¾ Ð‘Ð¸Ð»Ð´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(503539,13988,'ur','Ø®ÙˆØ¯ ØªØ¹Ù…ÛŒØ± ØªØ±ØªÛŒØ¨',0),(503540,13988,'sr','ÐÑƒÑ‚Ð¾ Ð‘ÑƒÐ¸Ð»Ð´ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(503541,13988,'vi','Tá»± Ä‘á»™ng xÃ¢y dá»±ng thá»© tá»±',0),(503542,13988,'af','Outomatiese bou orde',0),(503543,13988,'ro','Ordinul de a construi auto',0),(503544,13988,'et','Auto ehitada jÃ¤rjekorras',0),(503545,13988,'si','Auto izgradnje',0),(503546,13988,'ba','Auto membangun Order',0),(503547,13988,'nl','Auto opbouwvolgorde',0),(503548,13988,'fi','Automaattinen tilauksen mukaan',0),(503549,13988,'no','Bygge AutorekkefÃ¸lge',0),(503550,13988,'da','Auto Byg efter ordre',0),(503551,13988,'ko','ìžë™ ë¹Œë“œ ìˆœì„œ',0),(503552,13988,'he','×¡×“×¨ ×œ×‘× ×•×ª ××•×˜×•×ž×˜×™',0),(503553,13988,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® ÏƒÎµÎ¹ÏÎ¬',0),(503554,13988,'zh','è‡ªåŠ¨ç”Ÿæˆé¡ºåº',0),(503555,13988,'sv','Auto bygga Order',0),(503556,13988,'it','Ordine di compilazione automatica',0),(503557,13988,'tl','',0),(503558,13988,'th','à¸ªà¸±à¹ˆà¸‡à¸ªà¸£à¹‰à¸²à¸‡à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(503559,13988,'hi','à¤‘à¤Ÿà¥‹ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤•à¥‡ à¤•à¥à¤°à¤®',0),(503560,13988,'ms','Perintah membina auto',0),(503561,13988,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(503562,13988,'fr','Ordre de compilation automatique',0),(503563,13988,'jp','è‡ªå‹•ãƒ“ãƒ«ãƒ‰é †åº',0),(503564,13988,'pt','Ordem de compilaÃ§Ã£o automÃ¡tica',0),(503565,13988,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ Ð°Ð²Ñ‚Ð¾',0),(503566,13988,'es','Auto Build Order',0),(503567,13988,'de','Auto Buildreihenfolge',0),(503568,13988,'en','Auto Build Order',0),(503569,13989,'is','',0),(503570,13989,'dr','Ø´Ø®ØµÛŒØª',0),(503571,13989,'pr','Ø´Ø®ØµÛŒØª',0),(503572,13989,'tr','Karakterler',0),(503573,13989,'pl','Znaki',0),(503574,13989,'bg','Ð“ÐµÑ€Ð¾Ð¸',0),(503575,13989,'ur','Ú©Ø±ÛŒÚ©Ù¹Ø±',0),(503576,13989,'sr','Ð—Ð½Ð°ÐºÐ¾Ð²Ð¸',0),(503577,13989,'vi','NhÃ¢n váº­t',0),(503578,13989,'af','Karakters',0),(503579,13989,'ro','Caractere',0),(503580,13989,'et','MÃ¤rgid',0),(503581,13989,'si','Znakov',0),(503582,13989,'ba','Karakter',0),(503583,13989,'nl','Tekens',0),(503584,13989,'fi','MerkkiÃ¤',0),(503585,13989,'no','Tegn',0),(503586,13989,'da','Tegn',0),(503587,13989,'ko','ë¬¸ìž',0),(503588,13989,'he','×ª×•×•×™×',0),(503589,13989,'el','Î§Î±ÏÎ±ÎºÏ„Î®ÏÎµÏ‚',0),(503590,13989,'zh','å­—ç¬¦',0),(503591,13989,'sv','Tecken',0),(503592,13989,'it','Caratteri',0),(503593,13989,'tl','',0),(503594,13989,'th','à¸­à¸±à¸à¸‚à¸£à¸°',0),(503595,13989,'hi','à¤…à¤•à¥à¤·à¤°',0),(503596,13989,'ms','Watak-watak',0),(503597,13989,'ar','Ø§Ù„Ø£Ø­Ø±Ù',0),(503598,13989,'fr','CaractÃ¨res',0),(503599,13989,'jp','æ–‡å­—',0),(503600,13989,'pt','Personagens',0),(503601,13989,'ru','ÐŸÐµÑ€ÑÐ¾Ð½Ð°Ð¶Ð¸',0),(503602,13989,'es','Personajes',0),(503603,13989,'de','Zeichen',0),(503604,13989,'en','Characters',0),(503605,13990,'is','',0),(503606,13990,'dr','Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ù‡Ø± ÛŒÚ© Ø§Ø² Ù…Ø§Ú˜ÙˆÙ„ Ø¯Ø± 3 Ø³Ø·Ø­ Ø§Ø¹Ø·Ø§ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(503607,13990,'pr','Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ù‡Ø± ÛŒÚ© Ø§Ø² Ù…Ø§Ú˜ÙˆÙ„ Ø¯Ø± 3 Ø³Ø·Ø­ Ø§Ø¹Ø·Ø§ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(503608,13990,'tr','Her modÃ¼l iÃ§in 3 dÃ¼zeyde duyulur',0),(503609,13990,'pl','DostÄ™p do kaÅ¼dego moduÅ‚u jest udzielany na 3 poziomy',0),(503610,13990,'bg','Ð”Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ð²ÑÐµÐºÐ¸ Ð¼Ð¾Ð´ÑƒÐ» ÑÐµ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ñ Ð½Ð° 3 Ð½Ð¸Ð²Ð°',0),(503611,13990,'ur','3 Ø³Ø·Ø­ Ù¾Ø± ÛØ± Ù…Ø§ÚˆÛŒÙˆÙ„ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ø¯Û’ Ø¯ÛŒ ÛÛ’',0),(503612,13990,'sr','Ð¡Ð²Ð°ÐºÐ¸ Ð¼Ð¾Ð´ÑƒÐ» Ñ˜Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½ Ð½Ð° 3 Ð½Ð¸Ð²Ð¾Ð°',0),(503613,13990,'vi','Truy cáº­p vÃ o má»—i mÃ´-Ä‘un Ä‘Æ°á»£c cáº¥p trÃªn 3 má»©c Ä‘á»™',0),(503614,13990,'af','Toegang tot elke Module toegestaan word op 3 vlakke',0),(503615,13990,'ro','Se acordÄƒ acces la fiecare modul pe 3 nivele',0),(503616,13990,'et','Iga moodul vÃµimaldatakse kolmeastmeline',0),(503617,13990,'si','3 ravni dodeli dostop do vsakega modula',0),(503618,13990,'ba','Akses ke setiap modul diberikan pada 3 tingkat',0),(503619,13990,'nl','Toegang tot elke Module wordt verleend op 3 niveaus',0),(503620,13990,'fi','Kunkin moduulin kÃ¤yttÃ¶oikeus 3 tasossa',0),(503621,13990,'no','Tilgang til hver modul gis pÃ¥ tre nivÃ¥er',0),(503622,13990,'da','Der gives adgang til hvert modul pÃ¥ 3 niveauer',0),(503623,13990,'ko','3 ë ˆë²¨ì— ê° ëª¨ë“ˆì— ëŒ€ í•œ ì•¡ì„¸ìŠ¤ ë¶€ì—¬',0),(503624,13990,'he','×”×¨×©××ª ×’×™×©×” ××œ ×›×œ ×ž×•×“×•×œ ×‘-3 ×¨×ž×•×ª',0),(503625,13990,'el','Î ÏÏŒÏƒÎ²Î±ÏƒÎ· ÎºÎ¬Î¸Îµ ÎµÎ½ÏŒÏ„Î·Ï„Î± Ï€Î±ÏÎ­Ï‡ÎµÏ„Î±Î¹ ÏƒÎµ 3 ÎµÏ€Î¯Ï€ÎµÎ´Î±',0),(503626,13990,'zh','åœ¨ 3 ä¸ªçº§åˆ«ä¸ŠæŽˆäºˆå¯¹æ¯ä¸ªæ¨¡å—è®¿é—®æƒé™',0),(503627,13990,'sv','TillgÃ¥ng till varje modul ges pÃ¥ 3 nivÃ¥er',0),(503628,13990,'it','Accesso ad ogni modulo Ã¨ concesso su 3 livelli',0),(503629,13990,'tl','',0),(503630,13990,'th','à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¹à¸•à¹ˆà¸¥à¸°à¹‚à¸¡à¸”à¸¹à¸¥à¹ƒà¸«à¹‰ 3 à¸£à¸°à¸”à¸±à¸š',0),(503631,13990,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤¯à¥‹à¤— 3 à¤¸à¥à¤¤à¤°à¥‹à¤‚ à¤ªà¤° à¤¦à¥€ à¤œà¤¾à¤¤à¥€ à¤¹à¥ˆ',0),(503632,13990,'ms','Akses untuk setiap modul yang diberikan pada tahap 3',0),(503633,13990,'ar','ÙŠØªÙ… Ù…Ù†Ø­ Ø­Ù‚ Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ ÙƒÙ„ ÙˆØ­Ø¯Ø© Ø¹Ù„Ù‰ 3 Ù…Ø³ØªÙˆÙŠØ§Øª',0),(503634,13990,'fr','AccÃ¨s Ã  chaque Module sur 3 niveaux',0),(503635,13990,'jp','3 ã¤ã®ãƒ¬ãƒ™ãƒ«ã§å„ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã«ã‚¢ã‚¯ã‚»ã‚¹ã—ã¾ã™ã€‚',0),(503636,13990,'pt','O acesso a cada mÃ³dulo Ã© concedido em 3 nÃ­veis',0),(503637,13990,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿ Ðº ÐºÐ°Ð¶Ð´Ð¾Ð¼Ñƒ Ð¼Ð¾Ð´ÑƒÐ»ÑŽ Ð½Ð° 3 ÑƒÑ€Ð¾Ð²Ð½ÑÑ…',0),(503638,13990,'es','Se concede el acceso a cada mÃ³dulo en 3 niveles',0),(503639,13990,'de','Zugriff auf jedes Modul ist auf 3 Ebenen',0),(503640,13990,'en','Access To Each Module Is Granted On 3 Levels',0),(503641,13991,'is','',0),(503642,13991,'dr','Ù†Ø§Ø¯ÛŒØ¯Ù‡ Ú¯Ø±ÙØªÙ†',0),(503643,13991,'pr','Ù†Ø§Ø¯ÛŒØ¯Ù‡ Ú¯Ø±ÙØªÙ†',0),(503644,13991,'tr','Yoksay',0),(503645,13991,'pl','Ignoruj',0),(503646,13991,'bg','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð°Ð¹',0),(503647,13991,'ur','Ù†Ø¸Ø± Ø§Ù†Ø¯Ø§Ø² Ú©Ø±ÛŒÚº',0),(503648,13991,'sr','Ð—Ð°Ð½ÐµÐ¼Ð°Ñ€Ð¸',0),(503649,13991,'vi','Bá» qua',0),(503650,13991,'af','Ignoreer',0),(503651,13991,'ro','Ignora',0),(503652,13991,'et','Ignoreeri',0),(503653,13991,'si','Prezri',0),(503654,13991,'ba','Mengabaikan',0),(503655,13991,'nl','Negeren',0),(503656,13991,'fi','Ohita',0),(503657,13991,'no','Ignorere',0),(503658,13991,'da','Ignorere',0),(503659,13991,'ko','ë¬´ì‹œ',0),(503660,13991,'he','×œ×”×ª×¢×œ×',0),(503661,13991,'el','Î Î±ÏÎ¬Î²Î»ÎµÏˆÎ·',0),(503662,13991,'zh','å¿½ç•¥',0),(503663,13991,'sv','Ignorera',0),(503664,13991,'it','Ignorare',0),(503665,13991,'tl','',0),(503666,13991,'th','à¸¥à¸°à¹€à¸§à¹‰à¸™',0),(503667,13991,'hi','à¤ªà¤° à¤§à¥à¤¯à¤¾à¤¨ à¤¨ à¤¦à¥‡à¤‚',0),(503668,13991,'ms','Abaikan',0),(503669,13991,'ar','ØªØ¬Ø§Ù‡Ù„',0),(503670,13991,'fr','Ignorer',0),(503671,13991,'jp','ç„¡è¦–ã—ã¾ã™ã€‚',0),(503672,13991,'pt','Ignorar',0),(503673,13991,'ru','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(503674,13991,'es','Ignorar',0),(503675,13991,'de','Ignorieren',0),(503676,13991,'en','Ignore',0),(503677,13992,'is','',0),(503678,13992,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ±',0),(503679,13992,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÛŒØ´ØªØ±',0),(503680,13992,'tr','Daha fazla bilgi',0),(503681,13992,'pl','WiÄ™cej informacji',0),(503682,13992,'bg','ÐŸÐ¾Ð²ÐµÑ‡Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(503683,13992,'ur','Ù…Ø²ÛŒØ¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(503684,13992,'sr','Ð’Ð¸ÑˆÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°',0),(503685,13992,'vi','Biáº¿t thÃªm thÃ´ng tin',0),(503686,13992,'af','Meer inligting',0),(503687,13992,'ro','Mai multe informaÅ£ii',0),(503688,13992,'et','Lisateabe saamiseks',0),(503689,13992,'si','VeÄ informacij',0),(503690,13992,'ba','Informasi lebih lanjut',0),(503691,13992,'nl','Meer informatie',0),(503692,13992,'fi','LisÃ¤tietoja',0),(503693,13992,'no','Mer informasjon',0),(503694,13992,'da','Flere oplysninger',0),(503695,13992,'ko','ìžì„¸í•œ ë‚´ìš©',0),(503696,13992,'he','×ž×™×“×¢ × ×•×¡×£',0),(503697,13992,'el','Î ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(503698,13992,'zh','æ›´å¤šçš„ä¿¡æ¯',0),(503699,13992,'sv','Mer Information',0),(503700,13992,'it','Ulteriori informazioni',0),(503701,13992,'tl','',0),(503702,13992,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(503703,13992,'hi','à¤…à¤§à¤¿à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(503704,13992,'ms','Maklumat lanjut',0),(503705,13992,'ar','Ù…Ø²ÙŠØ¯ Ù…Ù† Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(503706,13992,'fr','Plus d\'informations',0),(503707,13992,'jp','è©³ç´°ã«ã¤ã„ã¦ã¯',0),(503708,13992,'pt','Mais informaÃ§Ãµes',0),(503709,13992,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(503710,13992,'es','MÃ¡s informaciÃ³n',0),(503711,13992,'de','Weitere Informationen',0),(503712,13992,'en','More Information',0),(503713,13993,'is','',0),(503714,13993,'dr','Ø´Ù…Ø§ Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø³Ø·Ø­ Ø¯Ø³ØªØ±Ø³ÛŒ Ù…Ø§Ú˜ÙˆÙ„ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯.  Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ ØªÙˆØ¶ÛŒØ­ Ø¯Ø³ØªØ±Ø³ÛŒ Ù…Ø§Ú˜ÙˆÙ„.',0),(503715,13993,'pr','Ø´Ù…Ø§ Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø³Ø·Ø­ Ø¯Ø³ØªØ±Ø³ÛŒ Ù…Ø§Ú˜ÙˆÙ„ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯.  Ø§ÛŒÙ†Ø¬Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ ØªÙˆØ¶ÛŒØ­ Ø¯Ø³ØªØ±Ø³ÛŒ Ù…Ø§Ú˜ÙˆÙ„.',0),(503716,13993,'tr','ModÃ¼l eriÅŸim dÃ¼zeyini belirtmek gerekir.  ModÃ¼l eriÅŸim aÃ§Ä±klamasÄ± iÃ§in tÄ±klayÄ±nÄ±z.',0),(503717,13993,'pl','Trzeba wskazaÄ‡ poziom dostÄ™pu do moduÅ‚u.  Kliknij tutaj, aby wyjaÅ›nienie moduÅ‚ dostÄ™pu.',0),(503718,13993,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¿Ð¾ÑÐ¾Ñ‡Ð°Ñ‚ Ð½Ð¸Ð²Ð¾Ñ‚Ð¾ Ð½Ð° Ð¼Ð¾Ð´ÑƒÐ» Ð´Ð¾ÑÑ‚ÑŠÐ¿.  Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ñ‚ÑƒÐº Ð·Ð° Ð¾Ð±ÑÑÐ½ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¼Ð¾Ð´ÑƒÐ» Ð´Ð¾ÑÑ‚ÑŠÐ¿.',0),(503719,13993,'ur','Ø¢Ù¾ Ù…Ø§ÚˆÛŒÙˆÙ„ Ø±Ø³Ø§Ø¦ÛŒ Ø³Ø·Ø­ Ú©Ùˆ Ø¸Ø§ÛØ± Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”  Ù…Ø§ÚˆÛŒÙˆÙ„ Ø±Ø³Ø§Ø¦ÛŒ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª Ú©Û’ Ù„Ø¦Û’ ÛŒÛØ§Úº Ú©Ù„Ú© Ú©Ø±ÛŒÚº.',0),(503720,13993,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð½Ð°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚Ðµ Ð½Ð¸Ð²Ð¾ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð° Ð¼Ð¾Ð´ÑƒÐ».  ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð´Ñ˜Ðµ Ð·Ð° Ð¾Ð±Ñ˜Ð°ÑˆÑšÐµÑšÐµ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð° Ð°Ñ†Ñ†ÐµÑÑ Ð¼Ð¾Ð´ÑƒÐ».',0),(503721,13993,'vi','Báº¡n cáº§n pháº£i chá»‰ ra má»©c Ä‘á»™ truy cáº­p mÃ´-Ä‘un.  Click vÃ o Ä‘Ã¢y cho má»™t lá»i giáº£i thÃ­ch cá»§a mÃ´-Ä‘un truy cáº­p.',0),(503722,13993,'af','Jy moet die module toegang vlak aandui.  Klik hier vir \'n verduideliking van module toegang.',0),(503723,13993,'ro','AveÅ£i nevoie pentru a indica nivelul de acces modulul.  Click aici pentru o explicaÅ£ie a modul de acces.',0),(503724,13993,'et','Tuleb mÃ¤rkida moodul juurdepÃ¤Ã¤su tase.  Siit moodul juurdepÃ¤Ã¤su selgitus.',0),(503725,13993,'si','Navesti morate modul raven dostopa.  Kliknite tukaj za razlago modula dostop.',0),(503726,13993,'ba','Anda perlu menunjukkan tingkat akses modul.  Klik di sini untuk penjelasan tentang modul akses.',0),(503727,13993,'nl','U nodig hebt om aan te geven het toegangsniveau module.  Klik hier voor een uitleg van de module toegang.',0),(503728,13993,'fi','Sinun tÃ¤ytyy ilmoittaa moduulin kÃ¤yttÃ¶oikeustaso.  Klikkaa tÃ¤stÃ¤ moduuli kÃ¤yttÃ¤Ã¤ selitystÃ¤.',0),(503729,13993,'no','Du mÃ¥ angi tilgangsnivÃ¥et modul.  Klikk her for en forklaring pÃ¥ modulen tilgang.',0),(503730,13993,'da','Du skal angive, hvilket modul adgangsniveau.  Klik her for en forklaring af modul adgang.',0),(503731,13993,'ko','ëª¨ë“ˆì˜ ì•¡ì„¸ìŠ¤ ìˆ˜ì¤€ì„ ì§€ì • í•´ì•¼ í•©ë‹ˆë‹¤.  ëª¨ë“ˆ ì•¡ì„¸ìŠ¤ì— ëŒ€ í•œ ì„¤ëª…ì— ëŒ€ í•œ ì—¬ê¸°ë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤.',0),(503732,13993,'he','×¢×œ×™×š ×œ×¦×™×™×Ÿ ××ª ×¨×ž×ª ×”×’×™×©×” ×©×œ ×ž×•×“×•×œ.  ×œ×—×¥ ×›××Ÿ ×œ×§×‘×œ×ª ×”×¡×‘×¨ ×¢×œ ×ž×•×“×•×œ ×’×™×©×”.',0),(503733,13993,'el','Î§ÏÎµÎ¹Î¬Î¶ÎµÏ„Î±Î¹ Î½Î± Ï…Ï€Î¿Î´ÎµÎ¯Î¾ÎµÏ„Îµ Ï„Î¿ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÎµÎ½ÏŒÏ„Î·Ï„Î±.  ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÎµÎ´ÏŽ Î³Î¹Î± Î¼Î¹Î± ÎµÎ¾Î®Î³Î·ÏƒÎ· ÎµÎ½ÏŒÏ„Î·Ï„Î± Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚.',0),(503734,13993,'zh','æ‚¨éœ€è¦æŒ‡ç¤ºæ¨¡å—çš„è®¿é—®çº§åˆ«ã€‚è§£é‡Šæ¨¡å—è®¿é—®ï¼Œè¯·å•å‡»æ­¤å¤„ã€‚',0),(503735,13993,'sv','Du mÃ¥ste ange Ã¥tkomstnivÃ¥n modul.  Klicka hÃ¤r fÃ¶r en fÃ¶rklaring av modulen tillgÃ¥ng.',0),(503736,13993,'it','Ãˆ necessario indicare il livello di accesso del modulo.  Clicca qui per una spiegazione di accesso del modulo.',0),(503737,13993,'tl','',0),(503738,13993,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸£à¸°à¸šà¸¸à¸£à¸°à¸”à¸±à¸šà¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¹‚à¸¡à¸”à¸¹à¸¥  à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸™à¸µà¹ˆà¸ªà¸³à¸«à¸£à¸±à¸šà¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸‚à¸­à¸‡à¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¹‚à¸¡à¸”à¸¹à¸¥',0),(503739,13993,'hi','à¤†à¤ª à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤ªà¤¹à¥à¤à¤š à¤¸à¥à¤¤à¤° à¤‡à¤‚à¤—à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤ à¤¹à¥ˆà¥¤  à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤² à¤ªà¤¹à¥à¤à¤š à¤•à¤¾ à¤à¤• à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¹à¤¾à¤ à¤•à¥à¤²à¤¿à¤• à¤•',0),(503740,13993,'ms','Anda perlu menunjukkan tahap capaian modul.  Klik di sini untuk penjelasan modul akses.',0),(503741,13993,'ar','ÙƒÙ†Øª Ø¨Ø­Ø§Ø¬Ø© Ù„Ù„Ø¥Ø´Ø§Ø±Ø© Ø¥Ù„Ù‰ Ù…Ø³ØªÙˆÙ‰ Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ­Ø¯Ø© Ø§Ù„Ù†Ù…Ø·ÙŠØ©.  Ø§Ø¶ØºØ· Ù‡Ù†Ø§ Ù„Ø´Ø±Ø­ Ù„Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„ÙˆØ­Ø¯Ø© Ø§Ù„Ù†Ù…Ø·ÙŠØ©.',0),(503742,13993,'fr','Vous devez indiquer le niveau d\'accÃ¨s de module.  Cliquez ici pour obtenir une explication de l\'accÃ¨s au module.',0),(503743,13993,'jp','ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã®ã‚¢ã‚¯ã‚»ã‚¹ ãƒ¬ãƒ™ãƒ«ã‚’ç¤ºã™å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«ã®ã‚¢ã‚¯ã‚»ã‚¹ã®è©³ç´°ã«ã¤ã„ã¦ã¯ã€ã“ã¡ã‚‰ã‚’ã”è¦§ãã ã•ã„ã€‚',0),(503744,13993,'pt','VocÃª precisa indicar o nÃ­vel de acesso do mÃ³dulo.  Clique aqui para obter uma explicaÃ§Ã£o de acesso do mÃ³dulo.',0),(503745,13993,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ ÑƒÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ðº Ð¼Ð¾Ð´ÑƒÐ»ÑŽ.  Ð©ÐµÐ»ÐºÐ½Ð¸Ñ‚Ðµ Ð·Ð´ÐµÑÑŒ Ð´Ð»Ñ Ð¾Ð±ÑŠÑÑÐ½ÐµÐ½Ð¸Ñ Ð¼Ð¾Ð´ÑƒÐ»Ñ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°.',0),(503746,13993,'es','Hay que indicar el nivel de acceso del mÃ³dulo.  Haga clic aquÃ­ para obtener una explicaciÃ³n de acceso del mÃ³dulo.',0),(503747,13993,'de','Sie mÃ¼ssen die Modul-Zugriffsebene angeben.  Hier finden Sie eine ErlÃ¤uterung der Modul-Zugang.',0),(503748,13993,'en','You need to indicate the module access level.  Click here for an explanation of module access.',0),(503749,13994,'is','',0),(503750,13994,'dr','Ù¾Ø§ÛŒÙ‡',0),(503751,13994,'pr','Ù¾Ø§ÛŒÙ‡',0),(503752,13994,'tr','Temel',0),(503753,13994,'pl','Podstawowe',0),(503754,13994,'bg','ÐžÑÐ½Ð¾Ð²Ð½Ð¸',0),(503755,13994,'ur','Ø¨Ù†ÛŒØ§Ø¯ÛŒ',0),(503756,13994,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ðµ',0),(503757,13994,'vi','CÆ¡ báº£n',0),(503758,13994,'af','Basies',0),(503759,13994,'ro','BazÄƒ',0),(503760,13994,'et','PÃµhilised',0),(503761,13994,'si','Osnovne',0),(503762,13994,'ba','Dasar',0),(503763,13994,'nl','Fundamentele',0),(503764,13994,'fi','Perus',0),(503765,13994,'no','Grunnleggende',0),(503766,13994,'da','GrundlÃ¦ggende',0),(503767,13994,'ko','ê¸°ë³¸',0),(503768,13994,'he','×‘×¡×™×¡×™',0),(503769,13994,'el','Î’Î±ÏƒÎ¹ÎºÎ­Ï‚',0),(503770,13994,'zh','åŸºæœ¬',0),(503771,13994,'sv','GrundlÃ¤ggande',0),(503772,13994,'it','Base',0),(503773,13994,'tl','',0),(503774,13994,'th','à¸žà¸·à¹‰à¸™à¸à¸²à¸™',0),(503775,13994,'hi','à¤¬à¥à¤¨à¤¿à¤¯à¤¾à¤¦à¥€',0),(503776,13994,'ms','Asas',0),(503777,13994,'ar','Ø§Ù„Ø£Ø³Ø§Ø³ÙŠØ©',0),(503778,13994,'fr','Base',0),(503779,13994,'jp','åŸºæœ¬çš„ã§ã™',0),(503780,13994,'pt','BÃ¡sico',0),(503781,13994,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ñ‹Ðµ',0),(503782,13994,'es','BÃ¡sico',0),(503783,13994,'de','Grundlegende',0),(503784,13994,'en','Basic',0),(503785,13995,'is','',0),(503786,13995,'dr','Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÛŒ',0),(503787,13995,'pr','Ù‚Ø§Ù„Ø¨ Ø¨Ù†Ø¯ÛŒ',0),(503788,13995,'tr','BiÃ§imlendirme',0),(503789,13995,'pl','Formatowanie',0),(503790,13995,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(503791,13995,'ur','ÙˆØ¶Ø¹ Ú©Ø§Ø±ÛŒ',0),(503792,13995,'sr','ÐžÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°ÑšÐµ',0),(503793,13995,'vi','Äá»‹nh dáº¡ng',0),(503794,13995,'af','Formatering',0),(503795,13995,'ro','Formatare',0),(503796,13995,'et','Vormindamine',0),(503797,13995,'si','Oblikovanje',0),(503798,13995,'ba','Format',0),(503799,13995,'nl','Opmaak',0),(503800,13995,'fi','Muotoilu',0),(503801,13995,'no','Formatering',0),(503802,13995,'da','Formatering',0),(503803,13995,'ko','ì„œì‹ ì§€ì •',0),(503804,13995,'he','×¢×™×¦×•×‘',0),(503805,13995,'el','ÎœÎ¿ÏÏ†Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(503806,13995,'zh','æ ¼å¼è®¾ç½®',0),(503807,13995,'sv','Formatering',0),(503808,13995,'it','Formattazione',0),(503809,13995,'tl','',0),(503810,13995,'th','à¸ˆà¸±à¸”à¸£à¸¹à¸›à¹à¸šà¸š',0),(503811,13995,'hi','à¤¸à¥à¤µà¤°à¥‚à¤ªà¤£',0),(503812,13995,'ms','Format',0),(503813,13995,'ar','ØªÙ†Ø³ÙŠÙ‚',0),(503814,13995,'fr','Mise en forme',0),(503815,13995,'jp','æ›¸å¼è¨­å®š',0),(503816,13995,'pt','FormataÃ§Ã£o',0),(503817,13995,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(503818,13995,'es','Formato',0),(503819,13995,'de','Formatierung',0),(503820,13995,'en','Formatting',0),(503821,13996,'is','',0),(503822,13996,'dr','Ø³Ø± ØµÙØ­Ù‡ Ù‚Ø·Ø¹Ù‡ Ø¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù„ÛŒØ·',0),(503823,13996,'pr','Ø³Ø± ØµÙØ­Ù‡ Ù‚Ø·Ø¹Ù‡ Ø¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù„ÛŒØ·',0),(503824,13996,'tr','Pick bilet Ã¼zerinde blok baÅŸlÄ±ÄŸÄ±',0),(503825,13996,'pl','NagÅ‚Ã³wek bloku na pobranie biletu',0),(503826,13996,'bg','Ð—Ð°Ð³Ð»Ð°Ð²ÐºÐ° Ð½Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð±Ð¸Ð»ÐµÑ‚',0),(503827,13996,'ur','Ø§Ù†ØªØ®Ø§Ø¨ Ú©Û’ Ù¹Ú©Ù¹ Ù¾Ø± Ø¨Ù„Ø§Ú© Ø³Ø±ØªØ­Ø±ÛŒØ±',0),(503828,13996,'sr','Ð‘Ð»Ð¾Ðº Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ð° Ð½Ð° Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(503829,13996,'vi','Khá»‘i tiÃªu Ä‘á» trÃªn chá»n vÃ©',0),(503830,13996,'af','Blok kop op Pick kaartjie',0),(503831,13996,'ro','Antet bloc pe bilet de Pick',0),(503832,13996,'et','Teabeploki pÃ¤is noppimise pilet',0),(503833,13996,'si','Blok glavo na Pick vozovnice',0),(503834,13996,'ba','Blok Header pada tiket Pick',0),(503835,13996,'nl','Blok Header op Pick Ticket',0),(503836,13996,'fi','Tietolohkon otsikko valinta lippu',0),(503837,13996,'no','Blokk hodet pÃ¥ plukke billett',0),(503838,13996,'da','Blok Header pÃ¥ Pick billet',0),(503839,13996,'ko','ë¸”ë¡ í—¤ë” ì„ íƒ í‹°ì¼“',0),(503840,13996,'he','×›×•×ª×¨×ª ×‘×œ×•×§ ×¤×™×§ ×“×• ×—',0),(503841,13996,'el','ÎœÏ€Î»Î¿Îº ÎºÎµÏ†Î±Î»Î¯Î´Î±Ï‚ Î³Î¹Î± Pick ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(503842,13996,'zh','æ‹¿ç¥¨ä¸Šçš„å—æ ‡å¤´',0),(503843,13996,'sv','Block huvudet pÃ¥ Pick biljett',0),(503844,13996,'it','Blocco di intestazione sul biglietto Pick',0),(503845,13996,'tl','',0),(503846,13996,'th','à¸«à¸±à¸§à¸‚à¹‰à¸­à¸šà¸¥à¹‡à¸­à¸à¸šà¸™à¸£à¸±à¸šà¸•à¸±à¹‹à¸§',0),(503847,13996,'hi','à¤‰à¤ à¤¾à¤“ à¤Ÿà¤¿à¤•à¤Ÿ à¤ªà¤° à¤–à¤‚à¤¡ à¤¶à¥€à¤°à¥à¤· à¤²à¥‡à¤–',0),(503848,13996,'ms','Blok Header atas Tiket pengangkutan',0),(503849,13996,'ar','Ø±Ø£Ø³ ÙƒØªÙ„Ø© Ø¹Ù„Ù‰ Ø§Ù„ØªØ°Ø§ÙƒØ± Ø¨ÙŠÙƒ',0),(503850,13996,'fr','En-tÃªte de bloc sur billet choix',0),(503851,13996,'jp','ãƒ”ãƒƒã‚¯ã®ãƒã‚±ãƒƒãƒˆã®ãƒ–ãƒ­ãƒƒã‚¯ ãƒ˜ãƒƒãƒ€ãƒ¼',0),(503852,13996,'pt','CabeÃ§alho de bloco no bilhete de Pick',0),(503853,13996,'ru','Ð‘Ð»Ð¾Ðº Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²ÐºÐ° Ð½Ð° Ð·Ð°Ð±Ñ€Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚',0),(503854,13996,'es','Bloque encabezado en billete Pick',0),(503855,13996,'de','Block-Header auf Pick-Ticket',0),(503856,13996,'en','Block Header On Pick Ticket',0),(503857,13997,'is','',0),(503858,13997,'dr','Ø¨Ù„ÙˆÚ© Ù…ÙˆØ±Ø¯ Ø¨Ø§Ø±Ú©Ø¯ Ø¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù„ÛŒØ·',0),(503859,13997,'pr','Ø¨Ù„ÙˆÚ© Ù…ÙˆØ±Ø¯ Ø¨Ø§Ø±Ú©Ø¯ Ø¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù„ÛŒØ·',0),(503860,13997,'tr','Blok Ã¶ÄŸenin barkod Pick bilet Ã¼zerinde',0),(503861,13997,'pl','Blok elementu kodu kreskowego na pobranie biletu',0),(503862,13997,'bg','Ð‘Ð»Ð¾Ðº ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð±Ð°Ñ€ÐºÐ¾Ð´ Ð½Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð±Ð¸Ð»ÐµÑ‚',0),(503863,13997,'ur','Ø¨Ù„Ø§Ú© Ø´Û’ Ø¨Ø§Ø±Ú©ÙˆÚˆ Ø§Ù†ØªØ®Ø§Ø¨ Ù¹Ú©Ù¹ Ù¾Ø±',0),(503864,13997,'sr','Ð‘Ð°Ñ€Ñ†Ð¾Ð´Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð±Ð»Ð¾Ðº Ð½Ð° Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(503865,13997,'vi','Khá»‘i má»¥c mÃ£ váº¡ch trÃªn chá»n vÃ©',0),(503866,13997,'af','Blok Item strepieskode op Pick kaartjie',0),(503867,13997,'ro','Element de coduri de bare de bloc pe bilet de Pick',0),(503868,13997,'et','Block Ã¼ksuse vÃ¶Ã¶tkoodi noppimise pilet',0),(503869,13997,'si','Blok elementa Ärtne kode na Pick vozovnice',0),(503870,13997,'ba','Blok Item Barcode pada tiket Pick',0),(503871,13997,'nl','Blok Item Barcode op Pick Ticket',0),(503872,13997,'fi','EstÃ¤Ã¤ nimikkeen viivakoodi valinta lippu',0),(503873,13997,'no','Blokk element strekkode pÃ¥ plukke billett',0),(503874,13997,'da','Blok vare stregkode pÃ¥ Pick billet',0),(503875,13997,'ko','ë¸”ë¡ í•­ëª© ë°”ì½”ë“œ ì„ íƒ í‹°ì¼“',0),(503876,13997,'he','×œ×—×¡×•× ×‘×¨×§×•×“ ×”×¤×¨×™×˜ ×¤×™×§ ×“×• ×—',0),(503877,13997,'el','Barcode ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¼Ï€Î»Î¿Îº Î³Î¹Î± Pick ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(503878,13997,'zh','å—ç‰©æ–™æ¡ç ä¸Šæ¡ç¥¨',0),(503879,13997,'sv','Block post streckkod pÃ¥ Pick biljett',0),(503880,13997,'it','Blocco elemento Barcode sul biglietto Pick',0),(503881,13997,'tl','',0),(503882,13997,'th','à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”à¸ªà¸´à¸™à¸„à¹‰à¸²à¸šà¸¥à¹‡à¸­à¸à¸šà¸™à¸£à¸±à¸šà¸•à¸±à¹‹à¸§',0),(503883,13997,'hi','à¤¬à¥à¤²à¥‰à¤• à¤†à¤‡à¤Ÿà¤® à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤‰à¤ à¤¾à¤“ à¤Ÿà¤¿à¤•à¤Ÿ à¤ªà¤°',0),(503884,13997,'ms','Blok Item Kod Bar atas Tiket pengangkutan',0),(503885,13997,'ar','ÙƒØªÙ„Ø© Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠ Ø¹Ù„Ù‰ Ø§Ù„ØªØ°Ø§ÙƒØ± Ø¨ÙŠÙƒ',0),(503886,13997,'fr','Bloc Item Barcode sur billet choix',0),(503887,13997,'jp','ãƒ”ãƒƒã‚¯ã®ãƒã‚±ãƒƒãƒˆã®ãƒ–ãƒ­ãƒƒã‚¯ã®é …ç›®ãƒãƒ¼ã‚³ãƒ¼ãƒ‰',0),(503888,13997,'pt','Bloco Item cÃ³digo de barras no bilhete de Pick',0),(503889,13997,'ru','Ð¨Ñ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð±Ð»Ð¾ÐºÐ° Ð½Ð° Ð·Ð°Ð±Ñ€Ð°Ñ‚ÑŒ Ð±Ð¸Ð»ÐµÑ‚',0),(503890,13997,'es','Bloque artÃ­culo cÃ³digo de barras de billete Pick',0),(503891,13997,'de','Block-Element-Barcode auf Pick-Ticket',0),(503892,13997,'en','Block Item Barcode On Pick Ticket',0),(503893,13998,'is','',0),(503894,13998,'dr','Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÛŒØ´ ÙØ±Ø¶',0),(503895,13998,'pr','Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÛŒØ´ ÙØ±Ø¶',0),(503896,13998,'tr','VarsayÄ±lan ayarlarÄ±',0),(503897,13998,'pl','Ustawienia domyÅ›lne',0),(503898,13998,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(503899,13998,'ur','Ø·Û’ Ø´Ø¯Û',0),(503900,13998,'sr','Ð—Ð°Ð´Ð°Ð½Ðµ Ð²Ñ€Ð¸Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(503901,13998,'vi','GiÃ¡ trá»‹ máº·c Ä‘á»‹nh',0),(503902,13998,'af','Verstek',0),(503903,13998,'ro','Valorile implicite',0),(503904,13998,'et','VaikesÃ¤tted',0),(503905,13998,'si','Privzete nastavitve',0),(503906,13998,'ba','Default',0),(503907,13998,'nl','Standaardwaarden',0),(503908,13998,'fi','Oletukset',0),(503909,13998,'no','Standard',0),(503910,13998,'da','Som standard',0),(503911,13998,'ko','ê¸°ë³¸ê°’',0),(503912,13998,'he','×‘×¨×™×¨×•×ª ×ž×—×“×œ',0),(503913,13998,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(503914,13998,'zh','é»˜è®¤å€¼',0),(503915,13998,'sv','Som standard',0),(503916,13998,'it','Impostazioni predefinite',0),(503917,13998,'tl','',0),(503918,13998,'th','à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(503919,13998,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿà¥ à¤¸',0),(503920,13998,'ms','Lalai',0),(503921,13998,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(503922,13998,'fr','Valeurs par dÃ©faut',0),(503923,13998,'jp','æ—¢å®šå€¤',0),(503924,13998,'pt','PadrÃµes',0),(503925,13998,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(503926,13998,'es','Valores predeterminados',0),(503927,13998,'de','Standardwerte',0),(503928,13998,'en','Defaults',0),(503929,13999,'is','',0),(503930,13999,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ &amp; Ø³ÙØ§Ø±Ø´',0),(503931,13999,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ &amp; Ø³ÙØ§Ø±Ø´',0),(503932,13999,'tr','Faturalama & sipariÅŸ',0),(503933,13999,'pl','Fakturowanie & zamawiania',0),(503934,13999,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ & Ð¿Ð¾Ñ€ÑŠÑ‡Ð²Ð°Ð½Ðµ',0),(503935,13999,'ur','Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯ & ØªØ±ØªÛŒØ¨',0),(503936,13999,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ & Ð½Ð°Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐµ',0),(503937,13999,'vi','HoÃ¡ Ä‘Æ¡n &amp; Ä‘áº·t hÃ ng',0),(503938,13999,'af','Fakturering & bestel',0),(503939,13999,'ro','Facturare & comanda',0),(503940,13999,'et','Arveldamine & tellimine',0),(503941,13999,'si','Fakturiranje & naroÄanje',0),(503942,13999,'ba','Faktur & memesan',0),(503943,13999,'nl','Facturatie & bestellen',0),(503944,13999,'fi','Laskutus & tilaaminen',0),(503945,13999,'no','Fakturering & bestilling',0),(503946,13999,'da','Fakturering & bestilling',0),(503947,13999,'ko','ì¸ë³´ì´ìŠ¤ & ì£¼ë¬¸',0),(503948,13999,'he','×”×¤×§×ª ×—×©×‘×•× ×™×ª & ×ž×¦×•×•×”',0),(503949,13999,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· & Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(503950,13999,'zh','å¼€ç¥¨ &amp; è®¢è´­',0),(503951,13999,'sv','Fakturering & bestÃ¤llning',0),(503952,13999,'it','Fatturazione & ordinamento',0),(503953,13999,'tl','',0),(503954,13999,'th','à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ & à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(503955,13999,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ & à¤†à¤¦à¥‡à¤¶',0),(503956,13999,'ms','Invois & pesanan',0),(503957,13999,'ar','Ø§Ù„ÙÙˆØªØ±Ø© Ø¢Ù†Ø¯ ÙŠØ£Ù…Ø±',0),(503958,13999,'fr','Facturation & commande',0),(503959,13999,'jp','è«‹æ±‚æ›¸ç™ºè¡Œ & é †åº',0),(503960,13999,'pt','FacturaÃ§Ã£o & ordenaÃ§Ã£o',0),(503961,13999,'ru','Ð’Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ & Ð·Ð°ÐºÐ°Ð·',0),(503962,13999,'es','FacturaciÃ³n &amp; pedido',0),(503963,13999,'de','Fakturierung & bestellen',0),(503964,13999,'en','Invoicing & Ordering',0),(503965,14000,'is','',0),(503966,14000,'dr','Ù‚Ù„Ù…Ø±Ùˆ Ú©Ù…ÛŒØ³ÛŒÙˆÙ† ÙØ±ÙˆØ´ Ø¨Ø± Ø§Ø³Ø§Ø³',0),(503967,14000,'pr','Ù‚Ù„Ù…Ø±Ùˆ Ú©Ù…ÛŒØ³ÛŒÙˆÙ† ÙØ±ÙˆØ´ Ø¨Ø± Ø§Ø³Ø§Ø³',0),(503968,14000,'tr','Komisyonlar dayalÄ± bÃ¶lgesi',0),(503969,14000,'pl','Terytorium prowizji sprzedaÅ¼y oparte',0),(503970,14000,'bg','Ð¢ÐµÑ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð¸ Ð½Ð° Ð±Ð°Ð·Ð°',0),(503971,14000,'ur','Ø³ÛŒÙ„Ø² Ú©Ù…ÛŒØ´Ù†ÙˆÚº Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ø¹Ù„Ø§Ù‚Û',0),(503972,14000,'sr','Ð¢ÐµÑ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð¿Ñ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ',0),(503973,14000,'vi','LÃ£nh thá»• Hoa há»“ng bÃ¡n hÃ ng dá»±a',0),(503974,14000,'af','Verkope Kommissie gebied gebaseer',0),(503975,14000,'ro','VÃ¢nzÄƒri comisioane teritoriul bazat',0),(503976,14000,'et','MÃ¼Ã¼gi komisjonitasu territooriumil pÃµhineva',0),(503977,14000,'si','Prodajno ozemlje provizije temelji',0),(503978,14000,'ba','Wilayah komisi penjualan yang berbasis',0),(503979,14000,'nl','Verkoopregio commissies op basis',0),(503980,14000,'fi','Myynti palkkiot alueella kotipaikka',0),(503981,14000,'no','SalgsomrÃ¥de provisjon basert',0),(503982,14000,'da','Salget provisioner omrÃ¥de baseret',0),(503983,14000,'ko','ê¸°ë°˜ìœ¼ë¡œ í•˜ëŠ” íŒë§¤ ìˆ˜ìˆ˜ë£Œ ì˜í† ',0),(503984,14000,'he','××–×•×¨ ×¢×ž×œ×•×ª ×ž×›×™×¨×•×ª ×ž×‘×•×¡×¡',0),(503985,14000,'el','Î ÎµÏÎ¹Ï†Î­ÏÎµÎ¹Î± Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î²Î¬ÏƒÎµÎ¹',0),(503986,14000,'zh','åŸºäºŽé”€å”®ä½£é‡‘é¢†åœŸ',0),(503987,14000,'sv','FÃ¶rsÃ¤ljning provisioner territorium baserat',0),(503988,14000,'it','Territorio di commissioni di vendita basato',0),(503989,14000,'tl','',0),(503990,14000,'th','à¹€à¸‚à¸•à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¹ˆà¸™à¸à¸²à¸£à¸‚à¸²à¸¢à¸•à¸²à¸¡',0),(503991,14000,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤†à¤¯à¥‹à¤—à¥‹à¤‚ à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(503992,14000,'ms','Wilayah komisen jualan berdasarkan',0),(503993,14000,'ar','Ø¥Ù‚Ù„ÙŠÙ… Ù„Ø¬Ø§Ù† Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³',0),(503994,14000,'fr','Territoire de Commissions de vente base',0),(503995,14000,'jp','è²©å£²æ‰‹æ•°æ–™é ˜åœŸãƒ™ãƒ¼ã‚¹',0),(503996,14000,'pt','TerritÃ³rio de comissÃµes de vendas com base',0),(503997,14000,'ru','Ð¢ÐµÑ€Ñ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¹ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ',0),(503998,14000,'es','Territorio de las comisiones de ventas basado en',0),(503999,14000,'de','Verkaufsgebiet Provisionen basierend',0),(504000,14000,'en','Sales Commissions Territory Based',0),(504001,14001,'is','',0),(504002,14001,'dr','Ø¬Ø³ØªØ¬ÙˆÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(504003,14001,'pr','Ø¬Ø³ØªØ¬ÙˆÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(504004,14001,'tr','GeliÅŸmiÅŸ',0),(504005,14001,'pl','Zaawansowane',0),(504006,14001,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¾',0),(504007,14001,'ur','Ø§Ø¹Ù„ÛŒ Ø¯Ø±Ø¬Û’ Ú©ÛŒ',0),(504008,14001,'sr','Ð’Ð¸ÑˆÐµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð°',0),(504009,14001,'vi','NÃ¢ng cao',0),(504010,14001,'af','Gevorderd',0),(504011,14001,'ro','Avansate',0),(504012,14001,'et','TÃ¤psem',0),(504013,14001,'si','Napredno',0),(504014,14001,'ba','Lanjutan',0),(504015,14001,'nl','Geavanceerde',0),(504016,14001,'fi','Advanced',0),(504017,14001,'no','Avansert',0),(504018,14001,'da','Avanceret',0),(504019,14001,'ko','ê³ ê¸‰',0),(504020,14001,'he','×ž×ª×§×“×',0),(504021,14001,'el','Î“Î¹Î± Ï€ÏÎ¿Ï‡Ï‰ÏÎ·Î¼Î­Î½Î¿Ï…Ï‚',0),(504022,14001,'zh','å…ˆè¿›çš„',0),(504023,14001,'sv','Avancerad',0),(504024,14001,'it','Avanzata',0),(504025,14001,'tl','',0),(504026,14001,'th','à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡',0),(504027,14001,'hi','à¤‰à¤¨à¥à¤¨à¤¤',0),(504028,14001,'ms','Lanjutan',0),(504029,14001,'ar','Ù…ØªÙ‚Ø¯Ù…',0),(504030,14001,'fr','Advanced',0),(504031,14001,'jp','é«˜åº¦ãª',0),(504032,14001,'pt','AvanÃ§ado',0),(504033,14001,'ru','Ð Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ð¹',0),(504034,14001,'es','Avanzado',0),(504035,14001,'de','Erweiterte',0),(504036,14001,'en','Advanced',0),(504037,14002,'is','',0),(504038,14002,'dr','Ø­Ø¯Ø§Ú©Ø«Ø± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(504039,14002,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(504040,14002,'tr','Maksimum Ã¶deme',0),(504041,14002,'pl','Maksymalne wynagrodzenie',0),(504042,14002,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¾Ñ‚Ð¾ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(504043,14002,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ØªÙ†Ø®ÙˆØ§Û',0),(504044,14002,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð¿Ð»Ð°Ñ‚Ðµ',0),(504045,14002,'vi','Tá»‘i Ä‘a pháº£i tráº£',0),(504046,14002,'af','Maksimum betaal',0),(504047,14002,'ro','Maxime Pay',0),(504048,14002,'et','Maksimaalne tasu',0),(504049,14002,'si','Maksimalno plaÄilo',0),(504050,14002,'ba','Membayar maksimum',0),(504051,14002,'nl','Maximale Pay',0),(504052,14002,'fi','EnimmÃ¤ispalkan',0),(504053,14002,'no','Maksimal lÃ¸nn',0),(504054,14002,'da','Maksimal lÃ¸n',0),(504055,14002,'ko','ìµœëŒ€ ì§€ë¶ˆ',0),(504056,14002,'he','×©×›×¨ ×ž×§×¡×™×ž×•×',0),(504057,14002,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Î±Î¼Î¿Î¹Î²Î®',0),(504058,14002,'zh','æœ€é«˜è–ªé…¬',0),(504059,14002,'sv','HÃ¶gst lÃ¶n',0),(504060,14002,'it','Retribuzione massima',0),(504061,14002,'tl','',0),(504062,14002,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(504063,14002,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤µà¥‡à¤¤à¤¨',0),(504064,14002,'ms','Gaji maksimum',0),(504065,14002,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø£Ù‚ØµÙ‰',0),(504066,14002,'fr','IndemnitÃ©s maximales',0),(504067,14002,'jp','æœ€é«˜ã®æ”¯æ‰•',0),(504068,14002,'pt','Pagamento mÃ¡ximo',0),(504069,14002,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ð°',0),(504070,14002,'es','Pago mÃ¡ximo',0),(504071,14002,'de','Maximale Pay',0),(504072,14002,'en','Maximum Pay',0),(504073,14003,'is','',0),(504074,14003,'dr','Ø¸Ø§Ù‡Ø±',0),(504075,14003,'pr','Ø¸Ø§Ù‡Ø±',0),(504076,14003,'tr','GÃ¶rÃ¼nÃ¼m',0),(504077,14003,'pl','WyglÄ…d',0),(504078,14003,'bg','Ð’ÑŠÐ½ÑˆÐµÐ½ Ð²Ð¸Ð´',0),(504079,14003,'ur','Ø¸Ø§ÛØ±ÛŒ Ø´Ú©Ù„',0),(504080,14003,'sr','Ð˜Ð·Ð³Ð»ÐµÐ´',0),(504081,14003,'vi','Xuáº¥t hiá»‡n',0),(504082,14003,'af','Voorkoms',0),(504083,14003,'ro','Aspectul',0),(504084,14003,'et','VÃ¤limus',0),(504085,14003,'si','Videz',0),(504086,14003,'ba','Penampilan',0),(504087,14003,'nl','Uiterlijk',0),(504088,14003,'fi','UlkonÃ¤kÃ¶',0),(504089,14003,'no','Utseende',0),(504090,14003,'da','Udseende',0),(504091,14003,'ko','ì™¸ê´€',0),(504092,14003,'he','×”×ž×¨××”',0),(504093,14003,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·',0),(504094,14003,'zh','å¤–è§‚',0),(504095,14003,'sv','Utseende',0),(504096,14003,'it','Aspetto',0),(504097,14003,'tl','',0),(504098,14003,'th','à¸¥à¸±à¸à¸©à¸“à¸°à¸—à¸µà¹ˆà¸›à¸£à¸²à¸à¸',0),(504099,14003,'hi','à¤ªà¥à¤°à¤•à¤Ÿà¤¨',0),(504100,14003,'ms','Penampilan',0),(504101,14003,'ar','Ù…Ø¸Ù‡Ø±',0),(504102,14003,'fr','Apparence',0),(504103,14003,'jp','å¤–è¦³',0),(504104,14003,'pt','AparÃªncia',0),(504105,14003,'ru','Ð’Ð½ÐµÑˆÐ½Ð¸Ð¹ Ð²Ð¸Ð´',0),(504106,14003,'es','Aspecto',0),(504107,14003,'de','Darstellung',0),(504108,14003,'en','Appearance',0),(504109,14004,'is','',0),(504110,14004,'dr','Ø±ÙØªØ§Ø±',0),(504111,14004,'pr','Ø±ÙØªØ§Ø±',0),(504112,14004,'tr','DavranÄ±ÅŸ',0),(504113,14004,'pl','Zachowanie',0),(504114,14004,'bg','ÐŸÐ¾Ð²ÐµÐ´ÐµÐ½Ð¸Ðµ',0),(504115,14004,'ur','Ø±ÙˆÛŒÛ',0),(504116,14004,'sr','ÐŸÐ¾Ð½Ð°ÑˆÐ°ÑšÐµ',0),(504117,14004,'vi','HÃ nh vi',0),(504118,14004,'af','Gedrag',0),(504119,14004,'ro','Comportamentul',0),(504120,14004,'et','KÃ¤itumine',0),(504121,14004,'si','Vedenje',0),(504122,14004,'ba','Perilaku',0),(504123,14004,'nl','Gedrag',0),(504124,14004,'fi','KÃ¤yttÃ¤ytyminen',0),(504125,14004,'no','Atferd',0),(504126,14004,'da','AdfÃ¦rd',0),(504127,14004,'ko','ë™ìž‘',0),(504128,14004,'he','×”×ª× ×”×’×•×ª',0),(504129,14004,'el','Î£Ï…Î¼Ï€ÎµÏÎ¹Ï†Î¿ÏÎ¬',0),(504130,14004,'zh','è¡Œä¸º',0),(504131,14004,'sv','Beteende',0),(504132,14004,'it','Comportamento',0),(504133,14004,'tl','',0),(504134,14004,'th','à¸¥à¸±à¸à¸©à¸“à¸°à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™',0),(504135,14004,'hi','à¤µà¥à¤¯à¤µà¤¹à¤¾à¤°',0),(504136,14004,'ms','Tingkah laku',0),(504137,14004,'ar','Ø§Ù„Ø³Ù„ÙˆÙƒ',0),(504138,14004,'fr','Comportement',0),(504139,14004,'jp','å‹•ä½œ',0),(504140,14004,'pt','Comportamento',0),(504141,14004,'ru','ÐŸÐ¾Ð²ÐµÐ´ÐµÐ½Ð¸Ðµ',0),(504142,14004,'es','Comportamiento',0),(504143,14004,'de','Verhalten',0),(504144,14004,'en','Behavior',0),(504145,14005,'is','',0),(504146,14005,'dr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(504147,14005,'pr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(504148,14005,'tr','GeliÅŸmiÅŸ SeÃ§enekleri gizle',0),(504149,14005,'pl','Ukryj opcje zaawansowane',0),(504150,14005,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(504151,14005,'ur','Ø§Ø¹Ù„ÛŒ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(504152,14005,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð½Ð°Ð¿Ñ€ÐµÐ´Ð½Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(504153,14005,'vi','áº¨n tÃ¹y chá»n nÃ¢ng cao',0),(504154,14005,'af','Verskuil gevorderde opsies',0),(504155,14005,'ro','Ascunde opÅ£iunile avansate',0),(504156,14005,'et','Peidab tÃ¤psemad suvandid',0),(504157,14005,'si','Skrij dodatne moÅ¾nosti',0),(504158,14005,'ba','Menyembunyikan Opsi lanjutan',0),(504159,14005,'nl','Geavanceerde opties verbergen',0),(504160,14005,'fi','Piilota LisÃ¤valinnat',0),(504161,14005,'no','Skjul avanserte alternativer',0),(504162,14005,'da','Skjule avancerede indstillinger',0),(504163,14005,'ko','ê³ ê¸‰ ì˜µì…˜ ìˆ¨ê¸°ê¸°',0),(504164,14005,'he','×”×¡×ª×¨ ××¤×©×¨×•×™×•×ª ×ž×ª×§×“×ž×•×ª',0),(504165,14005,'el','Î§Ï‰ÏÎ¯Ï‚ Ï„Î¹s Ï€ÏÎ¿Î·Î³Î¼Î­Î½ÎµÏ‚ ÎµÏ€Î¹Î»Î¿Î³ÎµÏ‚',0),(504166,14005,'zh','éšè—é«˜çº§çš„é€‰é¡¹',0),(504167,14005,'sv','DÃ¶lj avancerade alternativ',0),(504168,14005,'it','Nascondi opzioni avanzate',0),(504169,14005,'tl','',0),(504170,14005,'th','à¸‹à¹ˆà¸­à¸™à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡',0),(504171,14005,'hi','à¤‰à¤¨à¥ à¤¨à¤¤ à¤µà¤¿à¤•à¤²à¥ à¤ªà¥‹à¤‚ à¤•à¥‹ à¤›à¤¿à¤ªà¤¾à¤¨à¥‡',0),(504172,14005,'ms','Sembunyi opsyen lebih maju',0),(504173,14005,'ar','Ø¥Ø®ÙØ§Ø¡ Ø®ÙŠØ§Ø±Ø§Øª Ù…ØªÙ‚Ø¯Ù…Ø©',0),(504174,14005,'fr','Cacher les Options avancÃ©es',0),(504175,14005,'jp','ã‚¢ãƒ‰ãƒãƒ³ã‚¹è¨­å®šã‚’éš ã™',0),(504176,14005,'pt','Ocultar opÃ§Ãµes avanÃ§adas',0),(504177,14005,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(504178,14005,'es','Ocultar opciones avanzadas',0),(504179,14005,'de','Erweiterte Optionen ausblenden',0),(504180,14005,'en','Hide Advanced Options',0),(504181,14006,'is','',0),(504182,14006,'dr','ØªØ±Ø¬Ù…Ù‡ Ú¯ÙˆÚ¯Ù„ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ B2B',0),(504183,14006,'pr','ØªØ±Ø¬Ù…Ù‡ Ú¯ÙˆÚ¯Ù„ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ B2B',0),(504184,14006,'tr','KullanÄ±m Google Translate B2B iÃ§in',0),(504185,14006,'pl','UÅ¼yj Google Translate B2B',0),(504186,14006,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Google Translate Ð·Ð° B2B',0),(504187,14006,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú¯ÙˆÚ¯Ù„ ØªØ±Ø¬Ù…Û Ú©Û’ Ù„ÛŒÛ’ B2B',0),(504188,14006,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð“Ð¾Ð¾Ð³Ð»Ðµ Ð¿Ñ€ÐµÐ²ÐµÑÑ‚Ð¸ Ð‘2Ð‘',0),(504189,14006,'vi','Sá»­ dá»¥ng Google dá»‹ch cho B2B',0),(504190,14006,'af','Gebruik Google Translate vir B2B',0),(504191,14006,'ro','UtilizaÅ£i Google Translate pentru B2B',0),(504192,14006,'et','Kasuta Google Translate B2B',0),(504193,14006,'si','Uporabi Google Translate za B2B',0),(504194,14006,'ba','Gunakan Google menerjemahkan untuk B2B',0),(504195,14006,'nl','Gebruik Google vertalen voor B2B',0),(504196,14006,'fi','KÃ¤ytÃ¤ Google kÃ¤Ã¤ntÃ¤Ã¤ B2B',0),(504197,14006,'no','Bruk Google oversette For B2B',0),(504198,14006,'da','Brug Google OversÃ¦t For B2B',0),(504199,14006,'ko','B2Bë¥¼ ìœ„í•œ ì‚¬ìš© Google ë²ˆì—­',0),(504200,14006,'he','×”×©×ª×ž×© ×‘- Google ×ª×¨×’× ×¢×‘×•×¨ B2B',0),(504201,14006,'el','Î§ÏÎ®ÏƒÎ· Google Î¼ÎµÏ„Î±Ï†ÏÎ¬Î¶ÎµÎ¹ Î³Î¹Î± Ï„Î¹Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯ÎµÏ‚ B2B',0),(504202,14006,'zh','ä½¿ç”¨è°·æ­Œç¿»è¯‘ä¸º B2B',0),(504203,14006,'sv','AnvÃ¤nd Google Translate fÃ¶r B2B',0),(504204,14006,'it','Usa Google Translate per B2B',0),(504205,14006,'tl','',0),(504206,14006,'th','à¹ƒà¸Šà¹‰ Google à¹à¸›à¸¥à¸ªà¸³à¸«à¸£à¸±à¸š B2B',0),(504207,14006,'hi','à¤•à¤¾ à¤ªà¥à¤°à¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚ Google à¤…à¤¨à¥à¤µà¤¾à¤¦ à¤•à¥‡ à¤²à¤¿à¤ B2B',0),(504208,14006,'ms','Penggunaan Google Translate untuk B2B',0),(504209,14006,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¬ÙˆØ¬Ù„ ØªØ±Ø¬Ù…Ø© Ù„ B2B',0),(504210,14006,'fr','Utiliser Google Translate pour B2B',0),(504211,14006,'jp','B2B å‘ã‘ä½¿ç”¨ Google ç¿»è¨³ã—ã¾ã™ã€‚',0),(504212,14006,'pt','Uso o Google Translate para B2B',0),(504213,14006,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Google Translate Ð´Ð»Ñ B2B',0),(504214,14006,'es','Uso de Google Translate para B2B',0),(504215,14006,'de','Mit Google Ã¼bersetzen fÃ¼r B2B',0),(504216,14006,'en','Use Google Translate For B2B',0),(504217,14007,'is','',0),(504218,14007,'dr','Ù†Ù…Ø§ÛŒÙ†Ø¯Ù‡ ÛŒ ÙØ±ÙˆØ´',0),(504219,14007,'pr','Ù†Ù…Ø§ÛŒÙ†Ø¯Ù‡ ÛŒ ÙØ±ÙˆØ´',0),(504220,14007,'tr','Bayi',0),(504221,14007,'pl','Sprzedawcy',0),(504222,14007,'bg','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¾Ñ€',0),(504223,14007,'ur','Ø±ÛŒØ³ÛŒÙ„Ø±',0),(504224,14007,'sr','Ð ÐµÑÐµÐ»Ð»ÐµÑ€',0),(504225,14007,'vi','Äáº¡i lÃ½ bÃ¡n láº»',0),(504226,14007,'af','Herverkoper',0),(504227,14007,'ro','Reseller',0),(504228,14007,'et','EdasimÃ¼Ã¼ja',0),(504229,14007,'si','Preprodajalec',0),(504230,14007,'ba','Reseller',0),(504231,14007,'nl','Reseller',0),(504232,14007,'fi','JÃ¤lleenmyyjÃ¤',0),(504233,14007,'no','Forhandler',0),(504234,14007,'da','Forhandler',0),(504235,14007,'ko','ë¦¬ì…€ëŸ¬',0),(504236,14007,'he','×ž×©×•×•×§',0),(504237,14007,'el','ÎœÎµÏ„Î±Ï€Ï‰Î»Î·Ï„Î®',0),(504238,14007,'zh','è½¬é”€å•†',0),(504239,14007,'sv','Ã…terfÃ¶rsÃ¤ljare',0),(504240,14007,'it','Rivenditore',0),(504241,14007,'tl','',0),(504242,14007,'th','à¸•à¸±à¸§à¹à¸—à¸™à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(504243,14007,'hi','à¤ªà¥à¤¨à¤°à¥à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(504244,14007,'ms','Wakil jualan',0),(504245,14007,'ar','Ù…ÙˆØ²Ø¹',0),(504246,14007,'fr','Revendeur',0),(504247,14007,'jp','ãƒªã‚»ãƒ©ãƒ¼',0),(504248,14007,'pt','Revendedor',0),(504249,14007,'ru','Ð ÐµÑÐµÐ»Ð»ÐµÑ€',0),(504250,14007,'es','Revendedor',0),(504251,14007,'de','WiederverkÃ¤ufer',0),(504252,14007,'en','Reseller',0),(504253,14008,'is','',0),(504254,14008,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÛŒ',0),(504255,14008,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø¶Ø§ÙÛŒ',0),(504256,14008,'tr','Ek bilgi:',0),(504257,14008,'pl','Dodatkowe Info',0),(504258,14008,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(504259,14008,'ur','Ø§Ø¶Ø§ÙÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(504260,14008,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ',0),(504261,14008,'vi','ThÃ´ng tin bá»• sung',0),(504262,14008,'af','Addisionele Inligting',0),(504263,14008,'ro','Informatii suplimentare',0),(504264,14008,'et','Lisainfo',0),(504265,14008,'si','Dodatne Info',0),(504266,14008,'ba','Info tambahan',0),(504267,14008,'nl','Extra Info',0),(504268,14008,'fi','LisÃ¤tiedot',0),(504269,14008,'no','Ytterligere Info',0),(504270,14008,'da','Yderligere Info',0),(504271,14008,'ko','ì¶”ê°€ ì •ë³´',0),(504272,14008,'he','×ž×™×“×¢ × ×•×¡×£',0),(504273,14008,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(504274,14008,'zh','é™„åŠ ä¿¡æ¯',0),(504275,14008,'sv','Ytterligare information',0),(504276,14008,'it','Ulteriori Info',0),(504277,14008,'tl','',0),(504278,14008,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(504279,14008,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(504280,14008,'ms','Maklumat tambahan',0),(504281,14008,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ©',0),(504282,14008,'fr','Plus d\'infos',0),(504283,14008,'jp','è¿½åŠ æƒ…å ±',0),(504284,14008,'pt','InformaÃ§Ã£o adicional',0),(504285,14008,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(504286,14008,'es','Info adicional',0),(504287,14008,'de','ZusÃ¤tzliche Info',0),(504288,14008,'en','Additional Info',0),(504289,14009,'is','',0),(504290,14009,'dr','ØªØ§Ø±ÛŒØ® restock',0),(504291,14009,'pr','ØªØ§Ø±ÛŒØ® restock',0),(504292,14009,'tr','Tarihi eksikleri tamamlamak',0),(504293,14009,'pl','Odnawiania Data',0),(504294,14009,'bg','ÐŸÑ€ÐµÐ·Ð°Ð¿Ð°ÑÑÐ²Ð°Ð¼ Ð´Ð°Ñ‚Ð°',0),(504295,14009,'ur','ØªØ§Ø±ÛŒØ® Ø±ÛŒØ³Ù¹ÙˆÚ©',0),(504296,14009,'sr','ÐŸÐ° Ð¾Ð½Ð´Ð° Ð¸Ð·Ð²Ð°Ð´Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(504297,14009,'vi','Trá»“ng cÃ¢y láº¡i ngÃ y',0),(504298,14009,'af','Restock datum',0),(504299,14009,'ro','Repopula data',0),(504300,14009,'et','TÃ¤iendab kuupÃ¤ev',0),(504301,14009,'si','Obnovo datuma',0),(504302,14009,'ba','Memperlengkapi tanggal',0),(504303,14009,'nl','Voorraadbericht datum',0),(504304,14009,'fi','TÃ¤ydentÃ¤minen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(504305,14009,'no','Restock dato',0),(504306,14009,'da','GenpÃ¥fyldning dato',0),(504307,14009,'ko','ë‚ ì§œë¥¼ ìƒˆë¡œ ì‚¬ë“¤ì´ ë‹¤',0),(504308,14009,'he','×œ×ž×œ× ×ª××¨×™×š',0),(504309,14009,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(504310,14009,'zh','è¿›è´§æ—¥æœŸ',0),(504311,14009,'sv','FÃ¶rnya datum',0),(504312,14009,'it','Rifornire la data',0),(504313,14009,'tl','',0),(504314,14009,'th','à¹€à¸•à¸´à¸¡à¸ªà¸•à¹‡à¸­à¸à¸§à¸±à¸™à¸—à¸µà¹ˆ',0),(504315,14009,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤«à¤¿à¤° à¤¸à¥‡ à¤‡à¤•à¤Ÿà¥à¤ à¤¾ à¤•à¤°à¤¨à¤¾',0),(504316,14009,'ms','Restock tarikh',0),(504317,14009,'ar','ØªÙ‚ØªÙ†ÙŠ ØªØ§Ø±ÙŠØ®',0),(504318,14009,'fr','Date de rÃ©approvisionnement',0),(504319,14009,'jp','æ—¥å†å…¥è·ã—ã¾ã™ã€‚',0),(504320,14009,'pt','Reabastecer a data',0),(504321,14009,'ru','ÐŸÐ¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð”Ð°Ñ‚Ð°',0),(504322,14009,'es','Reponer fecha',0),(504323,14009,'de','AuffÃ¼llen von Datum',0),(504324,14009,'en','Restock Date',0),(504325,14010,'is','',0),(504326,14010,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø±ÙƒØª Ù†Ù…Ø§ÛŒØ´',0),(504327,14010,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ø±ÙƒØª Ù†Ù…Ø§ÛŒØ´',0),(504328,14010,'tr','Ekran firma bilgileri',0),(504329,14010,'pl','Informacje o firmie wyÅ›wietlacz',0),(504330,14010,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ñ„Ð¸Ñ€Ð¼Ð° Ð¸Ð½Ñ„Ð¾',0),(504331,14010,'ur','ÚˆØ³Ù¾Ù„Û’ Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(504332,14010,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸ Ð¾ Ñ„Ð¸Ñ€Ð¼Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°',0),(504333,14010,'vi','CÃ´ng ty Hiá»ƒn thá»‹ thÃ´ng tin',0),(504334,14010,'af','Vertoon maatskappy inligting',0),(504335,14010,'ro','Compania display Info',0),(504336,14010,'et','Kuva Firmast',0),(504337,14010,'si','Prikaz druÅ¾ba Info',0),(504338,14010,'ba','Info Perusahaan tampilan',0),(504339,14010,'nl','Weergave bedrijf Info',0),(504340,14010,'fi','NÃ¤yttÃ¶ Yritysinfo',0),(504341,14010,'no','Vise firmainformasjon',0),(504342,14010,'da','Display firma Info',0),(504343,14010,'ko','ë””ìŠ¤í”Œë ˆì´ íšŒì‚¬ ì†Œê°œ',0),(504344,14010,'he','×¤×¨×˜×™ ×—×‘×¨×ª ×ª×¦×•×’×”',0),(504345,14010,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ ÎµÏ„Î±Î¹ÏÎ¯Î± Î¿Î¸ÏŒÎ½Î·',0),(504346,14010,'zh','æ˜¾ç¤ºå…¬å¸ä¿¡æ¯',0),(504347,14010,'sv','Visa fÃ¶retag information',0),(504348,14010,'it','Visualizzazione azienda Info',0),(504349,14010,'tl','',0),(504350,14010,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¹à¸ªà¸”à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(504351,14010,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤•à¤‚à¤ªà¤¨à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(504352,14010,'ms','Syarikat paparan maklumat',0),(504353,14010,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø¹Ø±Ø¶',0),(504354,14010,'fr','Infos sociÃ©tÃ© Ã©cran',0),(504355,14010,'jp','ãƒ‡ã‚£ã‚¹ãƒ—ãƒ¬ã‚¤ä¼šç¤¾æƒ…å ±',0),(504356,14010,'pt','Empresa de exibiÃ§Ã£o informaÃ§Ã£o',0),(504357,14010,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð´Ð¸ÑÐ¿Ð»ÐµÐ¹',0),(504358,14010,'es','InformaciÃ³n de la compaÃ±Ã­a de exhibiciÃ³n',0),(504359,14010,'de','Display-Impressum',0),(504360,14010,'en','Display Company Info',0),(504361,14011,'is','',0),(504362,14011,'dr','Ù†Ù…Ø§ÛŒØ´ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­Ù„ Ø³Ú©ÙˆÙ†Øª',0),(504363,14011,'pr','Ù†Ù…Ø§ÛŒØ´ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­Ù„ Ø³Ú©ÙˆÙ†Øª',0),(504364,14011,'tr','GÃ¶rÃ¼ntÃ¼ stok konum bilgisi',0),(504365,14011,'pl','WyÅ›wietl informacje o lokalizacji zapasÃ³w',0),(504366,14011,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð´Ð¸ÑÐ¿Ð»ÐµÑ Ð·Ð°Ð¿Ð°ÑÐ¸',0),(504367,14011,'ur','ÚˆØ³Ù¾Ù„Û’ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(504368,14011,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(504369,14011,'vi','ThÃ´ng tin vá»‹ trÃ­ Hiá»ƒn thá»‹ hÃ ng tá»“n kho',0),(504370,14011,'af','Vertoon voorraad ligging-inligting',0),(504371,14011,'ro','AfiÅŸare inventar locaÅ£ie Info',0),(504372,14011,'et','Kuva lao asukoha Info',0),(504373,14011,'si','Prikaz zaloge lokacijo Info',0),(504374,14011,'ba','Tampilan Info lokasi persediaan',0),(504375,14011,'nl','Weergave voorraad locatie Info',0),(504376,14011,'fi','NÃ¤yttÃ¤Ã¤ varaston sijainnin Info',0),(504377,14011,'no','Vise lager posisjonsinformasjon',0),(504378,14011,'da','Display beholdning placering Info',0),(504379,14011,'ko','ë””ìŠ¤í”Œë ˆì´ ìž¬ê³  ìœ„ì¹˜ ì •ë³´',0);
INSERT INTO `langdef` VALUES (504380,14011,'he','×”×¦×’×ª ×¤×¨×˜×™ ×ž×™×§×•× ×”×ž×œ××™',0),(504381,14011,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¸Î­ÏƒÎ·Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î® Î¿Î¸ÏŒÎ½Î·',0),(504382,14011,'zh','æ˜¾ç¤ºåº“å­˜ä½ç½®ä¿¡æ¯',0),(504383,14011,'sv','Visa lager plats Info',0),(504384,14011,'it','Visualizzazione inventario informazioni geografiche',0),(504385,14011,'tl','',0),(504386,14011,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¹à¸ªà¸”à¸‡',0),(504387,14011,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(504388,14011,'ms','Paparan maklumat lokasi inventori',0),(504389,14011,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(504390,14011,'fr','Affichage infos d\'emplacement d\'inventaire',0),(504391,14011,'jp','åœ¨åº«å ´æ‰€ã®æƒ…å ±ã‚’è¡¨ç¤º',0),(504392,14011,'pt','Exibir informaÃ§Ãµes de localizaÃ§Ã£o de inventÃ¡rio',0),(504393,14011,'ru','ÐžÑ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ð¹ Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(504394,14011,'es','Pantalla inventario localizaciÃ³n Info',0),(504395,14011,'de','Anzeige Inventar Ortsangaben',0),(504396,14011,'en','Display Inventory Location Info',0),(504397,14012,'is','',0),(504398,14012,'dr','ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡ Ø¯Ø±',0),(504399,14012,'pr','ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡ Ø¯Ø±',0),(504400,14012,'tr','Ãœzerinde oluÅŸturulan',0),(504401,14012,'pl','Generowane na',0),(504402,14012,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ð° Ð½Ð°',0),(504403,14012,'ur','Ù¾Ø± Ù¾ÛŒØ¯Ø§',0),(504404,14012,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²ÐµÐ´ÐµÐ½Ð° Ð½Ð°',0),(504405,14012,'vi','ÄÆ°á»£c táº¡o ra trÃªn',0),(504406,14012,'af','Gegenereer op',0),(504407,14012,'ro','Generat pe',0),(504408,14012,'et','Genereeritud',0),(504409,14012,'si','Ustvarjeni v',0),(504410,14012,'ba','Dihasilkan pada',0),(504411,14012,'nl','Gegenereerd op',0),(504412,14012,'fi','Luotu',0),(504413,14012,'no','Generert pÃ¥',0),(504414,14012,'da','Genereret pÃ¥',0),(504415,14012,'ko','ì— ìƒì„± ëœ',0),(504416,14012,'he','× ×•×¦×¨ ×‘-',0),(504417,14012,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯Ï„Î±Î¹ ÏƒÏ„Î¿',0),(504418,14012,'zh','åœ¨ç”Ÿæˆ',0),(504419,14012,'sv','Genereras pÃ¥',0),(504420,14012,'it','Generato su',0),(504421,14012,'tl','',0),(504422,14012,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸‚à¸¶à¹‰à¸™à¸šà¸™',0),(504423,14012,'hi','à¤ªà¤° à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨',0),(504424,14012,'ms','Dihasilkan di',0),(504425,14012,'ar','ÙˆÙ„Ø¯Øª ÙÙŠ',0),(504426,14012,'fr','September',0),(504427,14012,'jp','ç”Ÿæˆã•ã‚Œã¾ã—ãŸã€‚',0),(504428,14012,'pt','Gerado em',0),(504429,14012,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð½Ð°',0),(504430,14012,'es','Generado en',0),(504431,14012,'de','Erstellt am',0),(504432,14012,'en','Generated On',0),(504433,14013,'is','',0),(504434,14013,'dr','Ø³Ø±Ø¨Ø±Ú¯ ØªÙ†Ø¸ÛŒÙ…Ø§Øª',0),(504435,14013,'pr','Ø³Ø±Ø¨Ø±Ú¯ ØªÙ†Ø¸ÛŒÙ…Ø§Øª',0),(504436,14013,'tr','Ãœstbilgi tercihleri',0),(504437,14013,'pl','Ustawienia nagÅ‚Ã³wka',0),(504438,14013,'bg','Ð“Ð¾Ñ€ÐµÐ½ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½Ð¸Ñ',0),(504439,14013,'ur','ÛÛŒÚˆØ± Ú©ÛŒ ØªØ±Ø¬ÛŒØ­Ø§Øª',0),(504440,14013,'sr','Ð–ÐµÑ™ÐµÐ½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ð°',0),(504441,14013,'vi','TiÃªu Ä‘á» tÃ¹y chá»n',0),(504442,14013,'af','Kop voorkeure',0),(504443,14013,'ro','Antet PreferinÅ£e',0),(504444,14013,'et','PÃ¤ise eelistused',0),(504445,14013,'si','Glava nastavitve',0),(504446,14013,'ba','Header preferensi',0),(504447,14013,'nl','Koptekst voorkeuren',0),(504448,14013,'fi','Otsikon asetukset',0),(504449,14013,'no','Topp valg',0),(504450,14013,'da','Header prÃ¦ferencer',0),(504451,14013,'ko','í—¤ë” ê¸°ë³¸ ì„¤ì •',0),(504452,14013,'he','×”×¢×“×¤×•×ª ×¢×œ×™×•× ×”',0),(504453,14013,'el','ÎšÎµÏ†Î±Î»Î¯Î´Î± Ï€ÏÎ¿Ï„Î¹Î¼Î®ÏƒÎµÎ¹Ï‚',0),(504454,14013,'zh','æ ‡å¤´çš„é¦–é€‰é¡¹',0),(504455,14013,'sv','Rubriken instÃ¤llningar',0),(504456,14013,'it','Intestazione preferenze',0),(504457,14013,'tl','',0),(504458,14013,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¹ˆà¸§à¸™à¸«à¸±à¸§',0),(504459,14013,'hi','à¤¶à¥€à¤°à¥à¤· à¤²à¥‡à¤– à¤ªà¤¸à¤¨à¥à¤¦',0),(504460,14013,'ms','Tajuk pilihan',0),(504461,14013,'ar','ØªÙØ¶ÙŠÙ„Ø§Øª Ø±Ø£Ø³',0),(504462,14013,'fr','PrÃ©fÃ©rences de l\'en-tÃªte',0),(504463,14013,'jp','ãƒ˜ãƒƒãƒ€ãƒ¼ã®è¨­å®š',0),(504464,14013,'pt','PreferÃªncias de cabeÃ§alho',0),(504465,14013,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²ÐºÐ¾Ð²',0),(504466,14013,'es','Preferencias de encabezado',0),(504467,14013,'de','Header-Einstellungen',0),(504468,14013,'en','Header Preferences',0),(504469,14014,'is','',0),(504470,14014,'dr','Ù…ÙˆØ±Ø¯ Ú©Ø¯ Ù…Ø­Ø¯ÙˆØ¯Ù‡',0),(504471,14014,'pr','Ù…ÙˆØ±Ø¯ Ú©Ø¯ Ù…Ø­Ø¯ÙˆØ¯Ù‡',0),(504472,14014,'tr','Madde kodu aralÄ±ÄŸÄ±',0),(504473,14014,'pl','Zakres kodu towaru',0),(504474,14014,'bg','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ ÐºÐ¾Ð´',0),(504475,14014,'ur','Ø´Û’ Ú©ÙˆÚˆ Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(504476,14014,'sr','ÐžÐ¿ÑÐµÐ³ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(504477,14014,'vi','Má»¥c mÃ£ pháº¡m vi',0),(504478,14014,'af','Item kode reeks',0),(504479,14014,'ro','Gama de cod articol',0),(504480,14014,'et','Kauba kood vahemik',0),(504481,14014,'si','Artikel koda obsega',0),(504482,14014,'ba','Item kode kisaran',0),(504483,14014,'nl','Object Code bereik',0),(504484,14014,'fi','Koodi nimikevÃ¤lin',0),(504485,14014,'no','Element kode utvalg',0),(504486,14014,'da','Kode vareinterval',0),(504487,14014,'ko','í’ˆëª© ì½”ë“œ ë²”ìœ„',0),(504488,14014,'he','×˜×•×•×— ×§×•×“ ×¤×¨×™×˜',0),(504489,14014,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï†Î¬ÏƒÎ¼Î±',0),(504490,14014,'zh','é¡¹ç›®ä»£ç èŒƒå›´',0),(504491,14014,'sv','Objektet koden utbud',0),(504492,14014,'it','Articolo codice gamma',0),(504493,14014,'tl','',0),(504494,14014,'th','à¸Šà¹ˆà¸§à¸‡à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²',0),(504495,14014,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ à¤°à¥‡à¤‚à¤œ',0),(504496,14014,'ms','Pelbagai kod item',0),(504497,14014,'ar','Ø¹Ù†ØµØ± Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ©',0),(504498,14014,'fr','Plage de codes d\'article',0),(504499,14014,'jp','é …ç›®ã‚³ãƒ¼ãƒ‰ã®ç¯„å›²',0),(504500,14014,'pt','Intervalo de cÃ³digo do item',0),(504501,14014,'ru','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ ÐºÐ¾Ð´Ð° Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(504502,14014,'es','ArtÃ­culo cÃ³digo gama',0),(504503,14014,'de','Code Artikelbereich',0),(504504,14014,'en','Item Code Range',0),(504505,14015,'is','',0),(504506,14015,'dr','Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù„ÛŒØ³Øª Ù‚ÛŒÙ…Øª',0),(504507,14015,'pr','Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù„ÛŒØ³Øª Ù‚ÛŒÙ…Øª',0),(504508,14015,'tr','ÃœrÃ¼n fiyat listesi',0),(504509,14015,'pl','Element Cennik',0),(504510,14015,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ Ñ†ÐµÐ½Ð¾Ð²Ð° Ð»Ð¸ÑÑ‚Ð°',0),(504511,14015,'ur','Ø´Û’ Ù‚ÛŒÙ…Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(504512,14015,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸ÐºÐ°',0),(504513,14015,'vi','Danh sÃ¡ch giÃ¡ má»¥c',0),(504514,14015,'af','Item prys lys',0),(504515,14015,'ro','Lista de pret element',0),(504516,14015,'et','Kauba hinnakiri',0),(504517,14015,'si','Element cenika',0),(504518,14015,'ba','Daftar Harga item',0),(504519,14015,'nl','Prijslijst',0),(504520,14015,'fi','Nimikkeen hinnasto',0),(504521,14015,'no','Elementet prisliste',0),(504522,14015,'da','Vare prisliste',0),(504523,14015,'ko','í•­ëª© ê°€ê²© ëª©ë¡',0),(504524,14015,'he','×¤×¨×™×˜ ×ž×—×™×¨×•×Ÿ',0),(504525,14015,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î¿ÎºÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï…',0),(504526,14015,'zh','é¡¹ç›®ä»·æ ¼åˆ—è¡¨',0),(504527,14015,'sv','Objektet prislista',0),(504528,14015,'it','Listino prezzi articolo',0),(504529,14015,'tl','',0),(504530,14015,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸²à¸„à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(504531,14015,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤®',0),(504532,14015,'ms','Senarai harga barangan',0),(504533,14015,'ar','Ø¹Ù†ØµØ± Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(504534,14015,'fr','Liste de prix des Ã©lÃ©ments',0),(504535,14015,'jp','é …ç›®ä¾¡æ ¼ãƒªã‚¹ãƒˆ',0),(504536,14015,'pt','Lista de preÃ§o de itens',0),(504537,14015,'ru','ÐŸÑƒÐ½ÐºÑ‚-Ð¿Ñ€Ð°Ð¹Ñ-Ð»Ð¸ÑÑ‚',0),(504538,14015,'es','Lista de precios',0),(504539,14015,'de','Element-Preisliste',0),(504540,14015,'en','Item Price List',0),(504541,14016,'is','',0),(504542,14016,'dr','Ù…Ø­ØµÙˆÙ„Ø§Øª Ø§ÛŒÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(504543,14016,'pr','Ù…Ø­ØµÙˆÙ„Ø§Øª Ø§ÛŒÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(504544,14016,'tr','Bu satÄ±cÄ±dan alÄ±nan Ã¼rÃ¼nler',0),(504545,14016,'pl','ProduktÃ³w od dostawcy',0),(504546,14016,'bg','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚Ð¸Ñ‚Ðµ Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(504547,14016,'ur','ÛŒÛ ÙØ±ÙˆØ´Ù†Ø¯Û Ø³Û’ Ù¾Ø±ÙˆÚˆÚ©Ù¹Ø³',0),(504548,14016,'sr','ÐŸÑ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸ Ð¸Ð· Ð¾Ð²Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(504549,14016,'vi','CÃ¡c sáº£n pháº©m tá»« nhÃ  cung cáº¥p nÃ y',0),(504550,14016,'af','Produkte van hierdie handelaar',0),(504551,14016,'ro','Produse din acest furnizor',0),(504552,14016,'et','Toodete sellelt hankijalt',0),(504553,14016,'si','Proizvodi iz tega dobavitelja',0),(504554,14016,'ba','Produk dari Penjual ini',0),(504555,14016,'nl','Producten van deze leverancier',0),(504556,14016,'fi','Tuotteita tÃ¤ltÃ¤ toimittajalta',0),(504557,14016,'no','Produkter fra denne leverandÃ¸ren',0),(504558,14016,'da','Produkter fra denne leverandÃ¸r',0),(504559,14016,'ko','ì´ ê³µê¸‰ ì—…ì²´ ë¡œë¶€í„° ì œí’ˆ',0),(504560,14016,'he','×ž×•×¦×¨×™× ×ž×™×¦×¨×Ÿ ×”×–×”',0),(504561,14016,'el','Î ÏÎ¿ÏŠÏŒÎ½Ï„Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎ¯Î±Ï‚',0),(504562,14016,'zh','è¿™ä¸ªä¾›åº”å•†çš„äº§å“',0),(504563,14016,'sv','Produkter frÃ¥n leverantÃ¶ren',0),(504564,14016,'it','Prodotti da questo venditore',0),(504565,14016,'tl','',0),(504566,14016,'th','à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¸ˆà¸²à¸à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸™à¸µà¹‰',0),(504567,14016,'hi','à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¥‡ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¥‹à¤‚',0),(504568,14016,'ms','Produk-produk dari Vendor ini',0),(504569,14016,'ar','Ù…Ù†ØªØ¬Ø§Øª Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(504570,14016,'fr','Produits de ce fournisseur',0),(504571,14016,'jp','ã“ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã‹ã‚‰ã®è£½å“',0),(504572,14016,'pt','Produtos deste fornecedor',0),(504573,14016,'ru','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ†Ð¸Ñ Ð´Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»Ñ',0),(504574,14016,'es','Productos de este proveedor',0),(504575,14016,'de','Produkte von diesem Hersteller',0),(504576,14016,'en','Products From This Vendor',0),(504577,14017,'is','',0),(504578,14017,'dr','Ù†Ù…Ø§ÛŒØ´ ØªØ§Ø±ÛŒØ®',0),(504579,14017,'pr','Ù†Ù…Ø§ÛŒØ´ ØªØ§Ø±ÛŒØ®',0),(504580,14017,'tr','Tarihi gÃ¶ster',0),(504581,14017,'pl','PokaÅ¼ datÄ™',0),(504582,14017,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð° Ð´Ð°Ñ‚Ð°',0),(504583,14017,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(504584,14017,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(504585,14017,'vi','Hiá»ƒn thá»‹ ngÃ y',0),(504586,14017,'af','Skou datum',0),(504587,14017,'ro','AratÄƒ data',0),(504588,14017,'et','NÃ¤ita kuupÃ¤eva',0),(504589,14017,'si','PokaÅ¾e datum',0),(504590,14017,'ba','Tampilkan tanggal',0),(504591,14017,'nl','Datum weergeven',0),(504592,14017,'fi','NÃ¤ytÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(504593,14017,'no','Vis dato',0),(504594,14017,'da','Vis dato',0),(504595,14017,'ko','ë‚ ì§œ í‘œì‹œ',0),(504596,14017,'he','×”×¦×’ ×ª××¨×™×š',0),(504597,14017,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚',0),(504598,14017,'zh','æ˜¾ç¤ºæ—¥æœŸ',0),(504599,14017,'sv','Visa datum',0),(504600,14017,'it','Visualizza Data',0),(504601,14017,'tl','',0),(504602,14017,'th','à¹à¸ªà¸”à¸‡à¸§à¸±à¸™',0),(504603,14017,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¦à¤¿à¤–à¤¾à¤à¤',0),(504604,14017,'ms','Tarikh Papar',0),(504605,14017,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(504606,14017,'fr','Voir la Date',0),(504607,14017,'jp','æ—¥ä»˜ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(504608,14017,'pt','Mostrar data',0),(504609,14017,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð´Ð°Ñ‚Ñƒ',0),(504610,14017,'es','Mostrar fecha',0),(504611,14017,'de','Datum anzeigen',0),(504612,14017,'en','Show Date',0),(504613,14018,'is','',0),(504614,14018,'dr','Ù†Ù…Ø§ÛŒØ´ Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÛŒ ØµÙØ­Ù‡',0),(504615,14018,'pr','Ù†Ù…Ø§ÛŒØ´ Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÛŒ ØµÙØ­Ù‡',0),(504616,14018,'tr','Sayfa numaralarÄ±nÄ± gÃ¶sterme',0),(504617,14018,'pl','PokaÅ¼ numery stron',0),(504618,14018,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð½Ð¾Ð¼ÐµÑ€Ð°Ñ‚Ð° Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸Ñ‚Ðµ',0),(504619,14018,'ur','ØµÙØ­Û Ù†Ù…Ø¨Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(504620,14018,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(504621,14018,'vi','Hiá»ƒn thá»‹ sá»‘ trang',0),(504622,14018,'af','Wys bladsynommers',0),(504623,14018,'ro','Numere de paginÄƒ AratÄƒ',0),(504624,14018,'et','Kuva lehekÃ¼ljenumbrid',0),(504625,14018,'si','PrikaÅ¾i Å¡tevilke strani',0),(504626,14018,'ba','Tampilkan nomor halaman',0),(504627,14018,'nl','Paginanummers weergeven',0),(504628,14018,'fi','NÃ¤ytÃ¤ sivunumerot',0),(504629,14018,'no','Vise sidetall',0),(504630,14018,'da','Vis sidetal',0),(504631,14018,'ko','íŽ˜ì´ì§€ ë²ˆí˜¸ í‘œì‹œ',0),(504632,14018,'he','×”×¦×’ ×ž×¡×¤×¨×™ ×¢×ž×•×“×™×',0),(504633,14018,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î±ÏÎ¹Î¸Î¼ÏŽÎ½ ÏƒÎµÎ»Î¯Î´Ï‰Î½',0),(504634,14018,'zh','æ˜¾ç¤ºé¡µç ',0),(504635,14018,'sv','Visa sidnummer',0),(504636,14018,'it','Visualizza i numeri di pagina',0),(504637,14018,'tl','',0),(504638,14018,'th','à¹à¸ªà¸”à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸«à¸™à¹‰à¸²',0),(504639,14018,'hi','à¤ªà¥ƒà¤·à¥à¤  à¤•à¥à¤°à¤®à¤¾à¤‚à¤• à¤¦à¤¿à¤–à¤¾à¤à¤',0),(504640,14018,'ms','Menunjukkan nombor halaman',0),(504641,14018,'ar','ÙˆØªØ¸Ù‡Ø± Ø£Ø±Ù‚Ø§Ù… Ø§Ù„ØµÙØ­Ø§Øª',0),(504642,14018,'fr','Afficher les numÃ©ros de Page',0),(504643,14018,'jp','ãƒšãƒ¼ã‚¸ç•ªå·ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(504644,14018,'pt','Mostrar nÃºmeros de pÃ¡gina',0),(504645,14018,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†',0),(504646,14018,'es','Mostrar nÃºmeros de pÃ¡gina',0),(504647,14018,'de','Anzeigen von Seitenzahlen',0),(504648,14018,'en','Show Page Numbers',0),(504649,14019,'is','',0),(504650,14019,'dr','Ù†Ù…Ø§ÛŒØ´ Ø³Ø·ÙˆØ­ Ù‚ÛŒÙ…Øª',0),(504651,14019,'pr','Ù†Ù…Ø§ÛŒØ´ Ø³Ø·ÙˆØ­ Ù‚ÛŒÙ…Øª',0),(504652,14019,'tr','Fiyat dÃ¼zeyi gÃ¶ster',0),(504653,14019,'pl','PokaÅ¼ poziom cen',0),(504654,14019,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾',0),(504655,14019,'ur','Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº Ø³Ø·Ø­ Ù‚ÛŒÙ…Øª',0),(504656,14019,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð¸Ð²Ð¾ Ñ†ÐµÐ½Ð°',0),(504657,14019,'vi','Hiá»ƒn thá»‹ má»©c giÃ¡',0),(504658,14019,'af','Wys prys vlak',0),(504659,14019,'ro','Nivel de preÅ£ AratÄƒ',0),(504660,14019,'et','NÃ¤ita hinnatase',0),(504661,14019,'si','PokaÅ¾i raven cen',0),(504662,14019,'ba','Menunjukkan tingkat harga',0),(504663,14019,'nl','Toon prijsniveau',0),(504664,14019,'fi','NÃ¤ytÃ¤ hinnat',0),(504665,14019,'no','Vis prisnivÃ¥',0),(504666,14019,'da','Vis prisniveau',0),(504667,14019,'ko','í‘œì‹œ ê°€ê²© ìˆ˜ì¤€',0),(504668,14019,'he','×”×¦×’ ××ª ×¨×ž×ª ×ž×—×™×¨',0),(504669,14019,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎµÏ€Î¹Ï€Î­Î´Î¿Ï… Ï„Î¹Î¼ÏŽÎ½',0),(504670,14019,'zh','æ˜¾ç¤ºä»·æ ¼æ°´å¹³',0),(504671,14019,'sv','Visa prisnivÃ¥n',0),(504672,14019,'it','Visualizza il livello di prezzo',0),(504673,14019,'tl','',0),(504674,14019,'th','à¹à¸ªà¸”à¸‡à¸£à¸°à¸”à¸±à¸šà¸£à¸²à¸„à¸²',0),(504675,14019,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(504676,14019,'ms','Menunjukkan paras harga',0),(504677,14019,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(504678,14019,'fr','Afficher le niveau de prix',0),(504679,14019,'jp','ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(504680,14019,'pt','Mostrar nÃ­vel de preÃ§o',0),(504681,14019,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ñ†ÐµÐ½',0),(504682,14019,'es','Mostrar el nivel de precios',0),(504683,14019,'de','Karte-Preisniveau',0),(504684,14019,'en','Show Price Level',0),(504685,14020,'is','',0),(504686,14020,'dr','Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙˆØ§Ø­Ø¯',0),(504687,14020,'pr','Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙˆØ§Ø­Ø¯',0),(504688,14020,'tr','Birim fiyat gÃ¶ster',0),(504689,14020,'pl','PokaÅ¼ ceny jednostek',0),(504690,14020,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ñ†ÐµÐ½Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(504691,14020,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(504692,14020,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(504693,14020,'vi','Hiá»ƒn thá»‹ giÃ¡ Ä‘Æ¡n vá»‹',0),(504694,14020,'af','Wys pryse eenhede',0),(504695,14020,'ro','AratÄƒ unitÄƒÅ£i de stabilire a preÅ£urilor',0),(504696,14020,'et','Kuva hinnakujunduse Ã¼hikut',0),(504697,14020,'si','PokaÅ¾i cen enot',0),(504698,14020,'ba','Tampilkan harga unit',0),(504699,14020,'nl','Toon prijzen eenheden',0),(504700,14020,'fi','NÃ¤yttÃ¤Ã¤ hinnoitteluun yksikÃ¶t',0),(504701,14020,'no','Vis priser enheter',0),(504702,14020,'da','Vis prissÃ¦tning enheder',0),(504703,14020,'ko','ë‹¨ìœ„ ê°€ê²© í‘œì‹œ',0),(504704,14020,'he','×”×¦×’ ×ž×—×™×¨×™× ×™×—×™×“×•×ª',0),(504705,14020,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î¹Î¼ÏŽÎ½ Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(504706,14020,'zh','æ˜¾ç¤ºä»·æ ¼å•ä½',0),(504707,14020,'sv','Visa prissÃ¤ttning enheter',0),(504708,14020,'it','Visualizza prezzi unitÃ ',0),(504709,14020,'tl','',0),(504710,14020,'th','à¹à¸ªà¸”à¸‡à¸«à¸™à¹ˆà¸§à¸¢à¸£à¸²à¸„à¸²',0),(504711,14020,'hi','à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤¦à¤¿à¤–à¤¾',0),(504712,14020,'ms','Menunjukkan harga unit',0),(504713,14020,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø£Ø³Ø¹Ø§Ø± Ø§Ù„ÙˆØ­Ø¯Ø§Øª',0),(504714,14020,'fr','Voir la tarification des unitÃ©s',0),(504715,14020,'jp','ä¾¡æ ¼å˜ä½ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(504716,14020,'pt','Mostrar unidades de preÃ§os',0),(504717,14020,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‹ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(504718,14020,'es','Mostrar precios unidades',0),(504719,14020,'de','Zeige Preise Einheiten',0),(504720,14020,'en','Show Pricing Units',0),(504721,14021,'is','',0),(504722,14021,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø¬Ø§Ø²',0),(504723,14021,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø¬Ø§Ø²',0),(504724,14021,'tr','VarsayÄ±lan satÄ±cÄ± Ã¶deme tÃ¼rÃ¼ izin',0),(504725,14021,'pl','DomyÅ›lny typ pÅ‚atnoÅ›ci dostawcy dozwolone',0),(504726,14021,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð²Ð¸Ð´ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(504727,14021,'ur','Ø·Û’ Ø´Ø¯Û ÙˆÛŒÙ†ÚˆØ± Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù‚Ø³Ù… Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(504728,14021,'sr','Ð”Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾ Ñ˜Ðµ Ð²Ñ€ÑÑ‚Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(504729,14021,'vi','Máº·c Ä‘á»‹nh nhÃ  cung cáº¥p hÃ¬nh thá»©c thanh toÃ¡n Ä‘Æ°á»£c phÃ©p',0),(504730,14021,'af','Handelaar betaling ontfoutingstipe toegelaat',0),(504731,14021,'ro','Furnizor de platÄƒ tipul implicit de permis',0),(504732,14021,'et','Vaikimisi hankija makse tÃ¼Ã¼p lubatud',0),(504733,14021,'si','Privzeta vrsta dobavitelja plaÄila dovoljeno',0),(504734,14021,'ba','Jenis pembayaran default Vendor yang diizinkan',0),(504735,14021,'nl','Standaard fabrikanttype betaling toegestaan',0),(504736,14021,'fi','Oletusarvoisesti toimittajan tyyppi Internet',0),(504737,14021,'no','Standard leverandÃ¸r betalingstype tillatt',0),(504738,14021,'da','Standard kreditor betalingstype tilladt',0),(504739,14021,'ko','ê¸°ë³¸ ê³µê¸‰ ì—…ì²´ ì§€ë¶ˆ ìœ í˜•ì„ í—ˆìš©',0),(504740,14021,'he','×¡×•×’ ×”×ª×©×œ×•× ×©×œ ×”×¡×¤×§ ×‘×¨×™×¨×ª ×ž×—×“×œ ×ž×•×ª×¨',0),(504741,14021,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï‚ Ï„ÏÏ€Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½ Ï€Î¿Ï… ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(504742,14021,'zh','å…è®¸çš„é»˜è®¤ä¾›åº”å•†ä»˜æ¬¾ç±»åž‹',0),(504743,14021,'sv','Standard betalning leverantÃ¶rstyp tillÃ¥tet',0),(504744,14021,'it','Tipo di pagamento fornitore predefinito consentito',0),(504745,14021,'tl','',0),(504746,14021,'th','à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹„à¸”à¹‰',0),(504747,14021,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(504748,14021,'ms','Jenis bayaran penjual lalai yang dibenarkan',0),(504749,14021,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ ÙŠØ³Ù…Ø­',0),(504750,14021,'fr','Type de paiement de fournisseur par dÃ©faut a permis',0),(504751,14021,'jp','è¨±å¯ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆä»•å…¥å…ˆæ”¯æ‰•ã‚¿ã‚¤ãƒ—',0),(504752,14021,'pt','Tipo de pagamento de fornecedor padrÃ£o permitido',0),(504753,14021,'ru','Ð”Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ Ñ‚Ð¸Ð¿ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(504754,14021,'es','Tipo de pago proveedor predeterminado permitida',0),(504755,14021,'de','Kreditor Zahlung Standardtyp erlaubt',0),(504756,14021,'en','Default Vendor Payment Type Allowed',0),(504757,14022,'is','',0),(504758,14022,'dr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(504759,14022,'pr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(504760,14022,'tr','Ã–nerilen',0),(504761,14022,'pl','Zalecane',0),(504762,14022,'bg','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑŠÑ‡Ð²Ð°',0),(504763,14022,'ur','Ø³ÙØ§Ø±Ø´ Ú©ÛŒ Ø¬Ø§ØªÛŒ',0),(504764,14022,'sr','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑƒÑ‡ÑƒÑ˜Ðµ ÑÐµ',0),(504765,14022,'vi','Khuyáº¿n cÃ¡o',0),(504766,14022,'af','Aanbeveel',0),(504767,14022,'ro','Recomandat',0),(504768,14022,'et','Soovitatav',0),(504769,14022,'si','PriporoÄa',0),(504770,14022,'ba','Direkomendasikan',0),(504771,14022,'nl','Aanbevolen',0),(504772,14022,'fi','Suositellut',0),(504773,14022,'no','Anbefalt',0),(504774,14022,'da','Anbefalet',0),(504775,14022,'ko','ê¶Œìž¥',0),(504776,14022,'he','×ž×•×ž×œ×¥',0),(504777,14022,'el','Î£Ï…Î½Î¹ÏƒÏ„Î¬Ï„Î±Î¹',0),(504778,14022,'zh','å»ºè®®',0),(504779,14022,'sv','Rekommenderas',0),(504780,14022,'it','Consigliato',0),(504781,14022,'tl','',0),(504782,14022,'th','à¸‚à¸­à¹à¸™à¸°à¸™à¸³',0),(504783,14022,'hi','à¤•à¥€ à¤¸à¤¿à¤«à¤¾à¤°à¤¿à¤¶ à¤•à¥€',0),(504784,14022,'ms','Disyorkan',0),(504785,14022,'ar','ÙˆØ£ÙˆØµÙ‰',0),(504786,14022,'fr','RecommandÃ©',0),(504787,14022,'jp','ãŠå‹§ã‚ã—ã¾ã™',0),(504788,14022,'pt','Recomendado',0),(504789,14022,'ru','Ð ÐµÐºÐ¾Ð¼ÐµÐ½Ð´ÑƒÐµÑ‚ÑÑ',0),(504790,14022,'es','Se recomienda',0),(504791,14022,'de','Empfohlen',0),(504792,14022,'en','Recommended',0),(504793,14023,'is','',0),(504794,14023,'dr','Ø«Ø¨Øª Ù†Ø§Ù… Ø¨Ø±Ø§ÛŒ Ù¾Ø°ÛŒØ±Ø´ Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(504795,14023,'pr','Ø«Ø¨Øª Ù†Ø§Ù… Ø¨Ø±Ø§ÛŒ Ù¾Ø°ÛŒØ±Ø´ Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(504796,14023,'tr','Kredi kartlarÄ±nÄ± kabul iÃ§in kaydolun',0),(504797,14023,'pl','Zarejestruj siÄ™, aby zaakceptowaÄ‡ kart kredytowych',0),(504798,14023,'bg','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¸ÐµÐ¼Ð°Ñ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(504799,14023,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù‚Ø¨ÙˆÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø³Ø§Ø¦Ù† Ø§Ù¾ Ú©Ø±ÛŒÚº',0),(504800,14023,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ ÑÐµ Ð´Ð° Ð¿Ñ€Ð¸Ð¼Ð°Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(504801,14023,'vi','ÄÄƒng kÃ½ Ä‘á»ƒ cháº¥p nháº­n tháº» tÃ­n dá»¥ng',0),(504802,14023,'af','Teken in om te aanvaar kredietkaarte',0),(504803,14023,'ro','ÃŽnscrieÅ£i-vÄƒ pentru a accepta carduri de Credit',0),(504804,14023,'et','Registreeru krediitkaardid',0),(504805,14023,'si','Prijavite se, da sprejemamo kreditne kartice',0),(504806,14023,'ba','Mendaftar untuk menerima kartu kredit',0),(504807,14023,'nl','Meld u nu aan accepteren Credit Cards',0),(504808,14023,'fi','RekisterÃ¶idy ja hyvÃ¤ksy luottokortteja',0),(504809,14023,'no','Registrer deg for kredittkort',0),(504810,14023,'da','Tilmeld dig til at acceptere kreditkort',0),(504811,14023,'ko','ì‹ ìš© ì¹´ë“œ ê°€ìž…',0),(504812,14023,'he','×œ×”×™×¨×©× ×‘×›×¨×˜×™×¡×™ ××©×¨××™',0),(504813,14023,'el','Î•Î³Î³ÏÎ±Ï†ÎµÎ¯Ï„Îµ Î³Î¹Î± Î½Î± Î´Î­Ï‡Î¿Î½Ï„Î±Î¹ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(504814,14023,'zh','æŠ¥åæŽ¥å—ä¿¡ç”¨å¡ä»˜æ¬¾',0),(504815,14023,'sv','Registrera fÃ¶r att kunna acceptera kreditkort',0),(504816,14023,'it','Iscriviti per accettare carte di credito',0),(504817,14023,'tl','',0),(504818,14023,'th','à¸¥à¸‡à¸—à¸°à¹€à¸šà¸µà¸¢à¸™à¹€à¸žà¸·à¹ˆà¸­à¸£à¸±à¸šà¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(504819,14023,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¾à¤‡à¤¨ à¤…à¤ª à¤•à¤°à¥‡à¤‚',0),(504820,14023,'ms','Mendaftar untuk menerima kad kredit',0),(504821,14023,'ar','Ù‚Ù… Ø¨Ø§Ù„ØªØ³Ø¬ÙŠÙ„ Ù„Ù‚Ø¨ÙˆÙ„ Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(504822,14023,'fr','Inscrivez-vous pour accepter les cartes de crÃ©dit',0),(504823,14023,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã‚’å—ã‘å…¥ã‚Œã‚‹ãŸã‚ã«ã‚µã‚¤ãƒ³ã‚¢ãƒƒãƒ—ã—ã¾ã™ã€‚',0),(504824,14023,'pt','Cadastre-se para aceitar cartÃµes de crÃ©dito',0),(504825,14023,'ru','Ð—Ð°Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€ÑƒÐ¹Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ñ€Ð¸Ð½Ð¸Ð¼Ð°Ñ‚ÑŒ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(504826,14023,'es','RegÃ­strese para aceptar tarjetas de crÃ©dito',0),(504827,14023,'de','Melden Sie sich fÃ¼r Kreditkarten',0),(504828,14023,'en','Sign Up To Accept Credit Cards',0),(504829,14024,'is','',0),(504830,14024,'dr','Ø¯Ø³ØªØ±Ø³ÛŒ Ø¹Ù…ÙˆÙ…ÛŒ',0),(504831,14024,'pr','Ø¯Ø³ØªØ±Ø³ÛŒ Ø¹Ù…ÙˆÙ…ÛŒ',0),(504832,14024,'tr','Genel eriÅŸim',0),(504833,14024,'pl','OgÃ³lny dostÄ™p',0),(504834,14024,'bg','ÐžÐ±Ñ‰Ð¸ Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(504835,14024,'ur','Ø¬Ù†Ø±Ù„ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ',0),(504836,14024,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð°',0),(504837,14024,'vi','Tá»•ng truy cáº­p',0),(504838,14024,'af','Algemene toegang',0),(504839,14024,'ro','Acces general',0),(504840,14024,'et','Ãœldine juurdepÃ¤Ã¤s',0),(504841,14024,'si','SploÅ¡ni dostop',0),(504842,14024,'ba','Akses umum',0),(504843,14024,'nl','Algemene toegang',0),(504844,14024,'fi','Yleinen yhteys',0),(504845,14024,'no','General tilgang',0),(504846,14024,'da','General adgang',0),(504847,14024,'ko','ì¼ë°˜ ì•¡ì„¸ìŠ¤',0),(504848,14024,'he','×”×’×™×©×” ×”×›×œ×œ×™×ª',0),(504849,14024,'el','Î“ÎµÎ½Î¹ÎºÎ® Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·',0),(504850,14024,'zh','é€šç”¨è®¿é—®',0),(504851,14024,'sv','AllmÃ¤n tillgÃ¥ng',0),(504852,14024,'it','Accesso generale',0),(504853,14024,'tl','',0),(504854,14024,'th','à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(504855,14024,'hi','à¤œà¤¨à¤°à¤² à¤à¤•à¥à¤¸à¥‡à¤¸',0),(504856,14024,'ms','Capaian umum',0),(504857,14024,'ar','Ø§Ù„ÙˆØµÙˆÙ„ Ø§Ù„Ø¹Ø§Ù…Ø©',0),(504858,14024,'fr','AccÃ¨s gÃ©nÃ©ral',0),(504859,14024,'jp','ä¸€èˆ¬çš„ãªã‚¢ã‚¯ã‚»ã‚¹',0),(504860,14024,'pt','Acesso geral',0),(504861,14024,'ru','ÐžÐ±Ñ‰ÐµÐ³Ð¾ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°',0),(504862,14024,'es','Acceso general',0),(504863,14024,'de','General Access',0),(504864,14024,'en','General Access',0),(504865,14025,'is','',0),(504866,14025,'dr','ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ',0),(504867,14025,'pr','ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ',0),(504868,14025,'tr','Ek Ã¶zellikleri',0),(504869,14025,'pl','Dodatkowe cechy',0),(504870,14025,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ…Ð°Ñ€Ð°ÐºÑ‚ÐµÑ€Ð¸ÑÑ‚Ð¸ÐºÐ¸',0),(504871,14025,'ur','Ø§Ø¶Ø§ÙÛŒ Ø®ØµÙˆØµÛŒØ§Øª',0),(504872,14025,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ð°ÐºÑ‚ÐµÑ€Ð¸ÑÑ‚Ð¸ÐºÐµ',0),(504873,14025,'vi','ThÃªm Ä‘áº·c Ä‘iá»ƒm',0),(504874,14025,'af','Bykomende kenmerke',0),(504875,14025,'ro','Caracteristici suplimentare',0),(504876,14025,'et','TÃ¤iendavad omadused',0),(504877,14025,'si','Dodatne lastnosti',0),(504878,14025,'ba','Karakteristik tambahan',0),(504879,14025,'nl','Aanvullende kenmerken',0),(504880,14025,'fi','Muita ominaisuuksia',0),(504881,14025,'no','Ytterligere egenskaper',0),(504882,14025,'da','Yderligere egenskaber',0),(504883,14025,'ko','ì¶”ê°€ íŠ¹ì„±',0),(504884,14025,'he','×ž××¤×™×™× ×™× × ×•×¡×¤×™×',0),(504885,14025,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î± Ï‡Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬',0),(504886,14025,'zh','é™„åŠ ç‰¹æ€§',0),(504887,14025,'sv','Ytterligare egenskaper',0),(504888,14025,'it','Caratteristiche aggiuntive',0),(504889,14025,'tl','',0),(504890,14025,'th','à¸¥à¸±à¸à¸©à¸“à¸°à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(504891,14025,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤²à¤•à¥à¤·à¤£',0),(504892,14025,'ms','Ciri-ciri tambahan',0),(504893,14025,'ar','Ø®ØµØ§Ø¦Øµ Ø¥Ø¶Ø§ÙÙŠØ©',0),(504894,14025,'fr','CaractÃ©ristiques supplÃ©mentaires',0),(504895,14025,'jp','ä»˜åŠ çš„ãªç‰¹å¾´',0),(504896,14025,'pt','CaracterÃ­sticas adicionais',0),(504897,14025,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ñ…Ð°Ñ€Ð°ÐºÑ‚ÐµÑ€Ð¸ÑÑ‚Ð¸ÐºÐ¸',0),(504898,14025,'es','CaracterÃ­sticas adicionales',0),(504899,14025,'de','ZusÃ¤tzliche Merkmale',0),(504900,14025,'en','Additional Characteristics',0),(504901,14026,'is','',0),(504902,14026,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡ Ø³Ø¨Ø¯ Ø®Ø±ÛŒØ¯',0),(504903,14026,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø¨Ù‡ Ø³Ø¨Ø¯ Ø®Ø±ÛŒØ¯',0),(504904,14026,'tr','Sepete Ekle',0),(504905,14026,'pl','Dodaj do koszyka',0),(504906,14026,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð² ÐºÐ¾ÑˆÐ½Ð¸Ñ†Ð°Ñ‚Ð°',0),(504907,14026,'ur','Ú¯Ø§Ú‘ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(504908,14026,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ñƒ ÐºÐ¾Ñ€Ð¿Ñƒ',0),(504909,14026,'vi','ThÃªm vÃ o giá»',0),(504910,14026,'af','Voeg by Cart',0),(504911,14026,'ro','AdaugÄƒ la coÅŸ',0),(504912,14026,'et','Lisa ostukorvi',0),(504913,14026,'si','Dodaj v nakupovalni voziÄek',0),(504914,14026,'ba','Tambah ke ketere',0),(504915,14026,'nl','Voeg toe aan winkelmandje',0),(504916,14026,'fi','LisÃ¤Ã¤ ostoskoriin',0),(504917,14026,'no','Legg til i handlekurv',0),(504918,14026,'da','LÃ¦g i vogn',0),(504919,14026,'ko','ìž¥ë°”êµ¬ë‹ˆì— ì¶”ê°€',0),(504920,14026,'he','×”×•×¡×£ ×œ×¢×’×œ×ª ×”×§× ×™×•×ª',0),(504921,14026,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î¿ ÎºÎ±Î»Î¬Î¸Î¹',0),(504922,14026,'zh','æ·»åŠ åˆ°è´­ç‰©è½¦',0),(504923,14026,'sv','LÃ¤gg till i vagnen',0),(504924,14026,'it','Aggiungi al carrello',0),(504925,14026,'tl','',0),(504926,14026,'th','à¸£à¸–à¹€à¸‚à¹‡à¸™',0),(504927,14026,'hi','à¤•à¤¾à¤°à¥à¤Ÿ à¤®à¥‡à¤‚ à¤¡à¤¾à¤²à¥‡à¤‚',0),(504928,14026,'ms','ADD To Cart',0),(504929,14026,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø¹Ø±Ø¨Ø©',0),(504930,14026,'fr','Ajouter au panier',0),(504931,14026,'jp','ã‚«ãƒ¼ãƒˆã«å…¥ã‚Œã‚‹',0),(504932,14026,'pt','Adicionar ao carrinho',0),(504933,14026,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð² ÐºÐ¾Ñ€Ð·Ð¸Ð½Ñƒ',0),(504934,14026,'es','AÃ±adir a la cesta',0),(504935,14026,'de','In den Warenkorb',0),(504936,14026,'en','Add To Cart',0),(504937,14027,'is','',0),(504938,14027,'dr','Ø³Ø¨Ø¯ Ø®Ø±ÛŒØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(504939,14027,'pr','Ø³Ø¨Ø¯ Ø®Ø±ÛŒØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(504940,14027,'tr','Sepeti baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(504941,14027,'pl','Koszyk pomyÅ›lnie zaktualizowana',0),(504942,14027,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐºÐ°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(504943,14027,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ø±Ú©Ù† Ú©ÛŒ Ù†Ù…Ø§Ø¦Ù†Ø¯Û',0),(504944,14027,'sr','ÐšÐ¾Ð»Ð¸Ñ†Ð° ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(504945,14027,'vi','Giá» hÃ ng Cáº­p Nháº­t thÃ nh cÃ´ng',0),(504946,14027,'af','Cart suksesvol bygewerk',0),(504947,14027,'ro','Cos actualizat cu succes',0),(504948,14027,'et','VÃ¤rskendamine Ãµnnestus ostukorvi',0),(504949,14027,'si','VoziÄek uspeÅ¡no posodobljena',0),(504950,14027,'ba','Keranjang diperbarui berhasil',0),(504951,14027,'nl','Kar met succes bijgewerkt',0),(504952,14027,'fi','PÃ¤ivitetty Ostoskori',0),(504953,14027,'no','Handlevogn oppdatert',0),(504954,14027,'da','Vogn opdateret',0),(504955,14027,'ko','ìž¥ë°”êµ¬ë‹ˆ ì—…ë°ì´íŠ¸ ë˜ì—ˆìŠµë‹ˆë‹¤',0),(504956,14027,'he','×¢×’×œ×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(504957,14027,'el','ÎšÎ±Î»Î¬Î¸Î¹ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(504958,14027,'zh','å·²æˆåŠŸæ›´æ–°è´­ç‰©è½¦',0),(504959,14027,'sv','Vagn uppdaterats',0),(504960,14027,'it','Carrello aggiornato con successo',0),(504961,14027,'tl','',0),(504962,14027,'th','à¸£à¸–à¹€à¸‚à¹‡à¸™à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(504963,14027,'hi','à¤—à¤¾à¤¡à¤¼à¥€ à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(504964,14027,'ms','Troli yang berjaya dikemas kini',0),(504965,14027,'ar','Ø¹Ø±Ø¨Ø© ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(504966,14027,'fr','Chariot de mise Ã  jour avec succÃ¨s',0),(504967,14027,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸã‚«ãƒ¼ãƒˆ',0),(504968,14027,'pt','Carrinho atualizado com sucesso',0),(504969,14027,'ru','ÐšÐ¾Ñ€Ð·Ð¸Ð½Ð°, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(504970,14027,'es','Carrito actualizado correctamente',0),(504971,14027,'de','Warenkorb erfolgreich aktualisiert',0),(504972,14027,'en','Cart Updated Successfully',0),(504973,14028,'is','',0),(504974,14028,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù…ÙˆØ±Ø¯',0),(504975,14028,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù…ÙˆØ±Ø¯',0),(504976,14028,'tr','Ã–ÄŸenin ayrÄ±ntÄ±',0),(504977,14028,'pl','SzczegÃ³Å‚y przedmiotu',0),(504978,14028,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð» Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(504979,14028,'ur','Ø´Û’ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(504980,14028,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð´ÐµÑ‚Ð°Ñ™Ð°',0),(504981,14028,'vi','Chi tiáº¿t má»¥c',0),(504982,14028,'af','Item besonderhede',0),(504983,14028,'ro','Element de detaliu',0),(504984,14028,'et','KategooriaÃ¼ksuste Ã¼ksikasjade',0),(504985,14028,'si','Podrobnost',0),(504986,14028,'ba','Item Detail',0),(504987,14028,'nl','Objectgegevens',0),(504988,14028,'fi','Osan tietojen',0),(504989,14028,'no','Element detaljer',0),(504990,14028,'da','Vare detaljer',0),(504991,14028,'ko','í•­ëª© ì„¸ë¶€ ì •ë³´',0),(504992,14028,'he','×¤×™×¨×•×˜ ×¤×¨×™×˜',0),(504993,14028,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(504994,14028,'zh','é¡¹ç›®è¯¦ç»†ä¿¡æ¯',0),(504995,14028,'sv','Artikeln i detalj',0),(504996,14028,'it','Dettaglio articolo',0),(504997,14028,'tl','',0),(504998,14028,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(504999,14028,'hi','à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤µà¤°à¤£',0),(505000,14028,'ms','Butiran terperinci',0),(505001,14028,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¹Ù†ØµØ±',0),(505002,14028,'fr','DÃ©tail d\'article',0),(505003,14028,'jp','é …ç›®ã®è©³ç´°',0),(505004,14028,'pt','Detalhes do item',0),(505005,14028,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾',0),(505006,14028,'es','Detalle del artÃ­culo',0),(505007,14028,'de','Artikeldetails',0),(505008,14028,'en','Item Detail',0),(505009,14029,'is','',0),(505010,14029,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ±Ø¯',0),(505011,14029,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ±Ø¯',0),(505012,14029,'tr','Ã–ÄŸe bilgisi',0),(505013,14029,'pl','Element informacji',0),(505014,14029,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(505015,14029,'ur','Ø´Û’ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(505016,14029,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ñƒ',0),(505017,14029,'vi','Má»¥c thÃ´ng tin',0),(505018,14029,'af','Item Info',0),(505019,14029,'ro','Element Info',0),(505020,14029,'et','Kauba Info',0),(505021,14029,'si','Info toÄka',0),(505022,14029,'ba','Info barang',0),(505023,14029,'nl','Item Info',0),(505024,14029,'fi','Kohteen tiedot',0),(505025,14029,'no','Elementet Info',0),(505026,14029,'da','Vare Info',0),(505027,14029,'ko','í•­ëª© ì •ë³´',0),(505028,14029,'he','×¤×¨×™×˜ ×ž×™×“×¢',0),(505029,14029,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(505030,14029,'zh','é¡¹ç›®ä¿¡æ¯',0),(505031,14029,'sv','Artikel information',0),(505032,14029,'it','Elemento Info',0),(505033,14029,'tl','',0),(505034,14029,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(505035,14029,'hi','à¤†à¤‡à¤Ÿà¤® à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(505036,14029,'ms','Maklumat item',0),(505037,14029,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¨Ù†Ø¯',0),(505038,14029,'fr','Point Info',0),(505039,14029,'jp','é …ç›®æƒ…å ±',0),(505040,14029,'pt','InformaÃ§Ã£o do item',0),(505041,14029,'ru','ÐŸÑƒÐ½ÐºÑ‚ Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(505042,14029,'es','InformaciÃ³n del artÃ­culo',0),(505043,14029,'de','Produkt-Info',0),(505044,14029,'en','Item Info',0),(505045,14030,'is','',0),(505046,14030,'dr','Ú©Ù„Ù…Ù‡ Ú©Ù„ÛŒØ¯ÛŒ',0),(505047,14030,'pr','Ú©Ù„Ù…Ù‡ Ú©Ù„ÛŒØ¯ÛŒ',0),(505048,14030,'tr','Anahtar kelime',0),(505049,14030,'pl','SÅ‚owo kluczowe',0),(505050,14030,'bg','ÐšÐ»ÑŽÑ‡Ð¾Ð²Ð° Ð´ÑƒÐ¼Ð°',0),(505051,14030,'ur','Ú©Ù„ÛŒØ¯ÛŒ Ø§Ù„ÙØ§Ø¸',0),(505052,14030,'sr','ÐšÑ™ÑƒÑ‡Ð½Ð° Ñ€ÐµÑ‡',0),(505053,14030,'vi','Tá»« khÃ³a',0),(505054,14030,'af','Trefwoord',0),(505055,14030,'ro','Cuvinte cheie',0),(505056,14030,'et','MÃ¤rksÃµna',0),(505057,14030,'si','KljuÄne besede',0),(505058,14030,'ba','Kata kunci',0),(505059,14030,'nl','Trefwoord',0),(505060,14030,'fi','Avainsana',0),(505061,14030,'no','SÃ¸keord',0),(505062,14030,'da','NÃ¸gleordet',0),(505063,14030,'ko','í‚¤ì›Œë“œ',0),(505064,14030,'he','×ž×™×œ×ª ×ž×¤×ª×—',0),(505065,14030,'el','Î›Î­Î¾Î·-ÎºÎ»ÎµÎ¹Î´Î¯',0),(505066,14030,'zh','å…³é”®å­—',0),(505067,14030,'sv','SÃ¶kord',0),(505068,14030,'it','Parola chiave',0),(505069,14030,'tl','',0),(505070,14030,'th','à¸„à¸³à¸ªà¸³à¸„à¸±à¸',0),(505071,14030,'hi','à¤–à¥‹à¤œà¤¶à¤¬à¥à¤¦',0),(505072,14030,'ms','Kata kunci',0),(505073,14030,'ar','Ø§Ù„ÙƒÙ„Ù…Ø§Øª Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(505074,14030,'fr','Mot clÃ©',0),(505075,14030,'jp','ã‚­ãƒ¼ãƒ¯ãƒ¼ãƒ‰',0),(505076,14030,'pt','Palavra-chave',0),(505077,14030,'ru','ÐšÐ»ÑŽÑ‡ÐµÐ²Ð¾Ðµ ÑÐ»Ð¾Ð²Ð¾',0),(505078,14030,'es','Palabra clave',0),(505079,14030,'de','Stichwort',0),(505080,14030,'en','Keyword',0),(505081,14031,'is','',0),(505082,14031,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ú¯Ø±ÙˆÙ‡ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ÛŒØ§ ÛŒÚ© Ú©Ù„Ù…Ù‡ Ú©Ù„ÛŒØ¯ÛŒ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(505083,14031,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ú¯Ø±ÙˆÙ‡ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ÛŒØ§ ÛŒÚ© Ú©Ù„Ù…Ù‡ Ú©Ù„ÛŒØ¯ÛŒ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(505084,14031,'tr','LÃ¼tfen bir kategori seÃ§in veya bir anahtar sÃ¶zcÃ¼k girin',0),(505085,14031,'pl','ProszÄ™ wybraÄ‡ kategoriÄ™ lub wprowadÅº sÅ‚owo kluczowe',0),(505086,14031,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¸Ð»Ð¸ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ»ÑŽÑ‡Ð¾Ð²Ð° Ð´ÑƒÐ¼Ð°',0),(505087,14031,'ur','Ø§ÛŒÚ© Ø²Ù…Ø±Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº ÛŒØ§ Ø§ÛŒÚ© Ú©Ù„ÛŒØ¯ÛŒ Ù„ÙØ¸ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(505088,14031,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¸Ð»Ð¸ ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ ÐºÑ™ÑƒÑ‡Ð½Ñƒ Ñ€ÐµÑ‡',0),(505089,14031,'vi','Xin vui lÃ²ng chá»n má»™t danh má»¥c hoáº·c nháº­p má»™t tá»« khÃ³a',0),(505090,14031,'af','Kies \'n kategorie asseblief of tik \'n sleutelwoord',0),(505091,14031,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i o categorie sau introduceÅ£i un cuvÃ¢nt cheie',0),(505092,14031,'et','Palun valige kategooria vÃµi sisestage mÃ¤rksÃµna',0),(505093,14031,'si','Prosimo izberite kategorijo ali vnesite kljuÄno besedo',0),(505094,14031,'ba','Silahkan pilih sebuah kategori atau masukkan kata kunci',0),(505095,14031,'nl','Selecteer een categorie of voer een trefwoord',0),(505096,14031,'fi','Valitse luokka tai kirjoita avainsana',0),(505097,14031,'no','Velg en kategori eller angi et nÃ¸kkelord',0),(505098,14031,'da','VÃ¦lg en kategori eller indtaste et nÃ¸gleord',0),(505099,14031,'ko','í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤ ë²”ì£¼ë¥¼ ì„ íƒ í•˜ê±°ë‚˜ í‚¤ì›Œë“œë¥¼ ìž…ë ¥',0),(505100,14031,'he','×× × ×‘×—×¨ ×§×˜×’×•×¨×™×” ××• ×”×–×Ÿ ×ž×™×œ×ª',0),(505101,14031,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î® Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÏ„Îµ Î¼Î¹Î± Î»Î­Î¾Î·-ÎºÎ»ÎµÎ¹Î´Î¯',0),(505102,14031,'zh','è¯·é€‰æ‹©ä¸€ä¸ªç±»åˆ«æˆ–è¾“å…¥ä¸€ä¸ªå…³é”®å­—',0),(505103,14031,'sv','VÃ¤lj en kategori eller ange ett sÃ¶kord',0),(505104,14031,'it','Seleziona una categoria o Inserisci una parola chiave',0),(505105,14031,'tl','',0),(505106,14031,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸¥à¸·à¸­à¸à¸›à¸£à¸°à¹€à¸ à¸— à¸«à¸£à¸·à¸­à¹ƒà¸ªà¹ˆà¸„à¸³à¸ªà¸³à¸„à¸±à¸',0),(505107,14031,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤•à¥‹à¤ˆ à¤•à¥€à¤µà¤°à¥à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(505108,14031,'ms','Sila pilih kategori atau masukkan kata kunci',0),(505109,14031,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ø®ØªÙŠØ§Ø± ÙØ¦Ø© Ø£Ùˆ Ø£Ø¯Ø®Ù„ ÙƒÙ„Ù…Ø© Ø£Ø³Ø§Ø³ÙŠØ©',0),(505110,14031,'fr','Veuillez sÃ©lectionner une catÃ©gorie ou tapez un mot-clÃ©',0),(505111,14031,'jp','ã‚«ãƒ†ã‚´ãƒªã‚’é¸æŠžã¾ãŸã¯ã‚­ãƒ¼ãƒ¯ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(505112,14031,'pt','Por favor, selecione uma categoria ou digite uma palavra-chave',0),(505113,14031,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑŽ Ð¸Ð»Ð¸ Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ»ÑŽÑ‡ÐµÐ²Ð¾Ðµ ÑÐ»Ð¾Ð²Ð¾',0),(505114,14031,'es','Por favor, seleccione una categorÃ­a o escriba una palabra clave',0),(505115,14031,'de','Bitte wÃ¤hlen Sie eine Kategorie oder geben Sie ein Stichwort',0),(505116,14031,'en','Please Select A Category Or Enter A Keyword',0),(505117,14032,'is','',0),(505118,14032,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(505119,14032,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(505120,14032,'tr','KullanÄ±labilir miktar',0),(505121,14032,'pl','DostÄ™pna iloÅ›Ä‡',0),(505122,14032,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(505123,14032,'ur','Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø³ØªÛŒØ§Ø¨',0),(505124,14032,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð°',0),(505125,14032,'vi','Sá»‘ lÆ°á»£ng cÃ³ sáºµn',0),(505126,14032,'af','Hoeveelheid beskikbaar',0),(505127,14032,'ro','Cantitatea disponibilÄƒ',0),(505128,14032,'et','Saadaolev kogus',0),(505129,14032,'si','RazpoloÅ¾ljiva koliÄina',0),(505130,14032,'ba','Kuantitas yang tersedia',0),(505131,14032,'nl','Beschikbare hoeveelheid',0),(505132,14032,'fi','KÃ¤ytettÃ¤vissÃ¤ oleva mÃ¤Ã¤rÃ¤',0),(505133,14032,'no','Tilgjengelige',0),(505134,14032,'da','Disponibelt antal',0),(505135,14032,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” ìˆ˜ëŸ‰',0),(505136,14032,'he','×›×ž×•×ª ×–×ž×™× ×”',0),(505137,14032,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(505138,14032,'zh','å¯ç”¨æ•°é‡',0),(505139,14032,'sv','TillgÃ¤ngliga kvantiteten',0),(505140,14032,'it','QuantitÃ  disponibile',0),(505141,14032,'tl','',0),(505142,14032,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(505143,14032,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¹à¥ˆ',0),(505144,14032,'ms','Kuantiti yang disediakan',0),(505145,14032,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(505146,14032,'fr','QuantitÃ© disponible',0),(505147,14032,'jp','ä½¿ç”¨å¯èƒ½ãªæ•°é‡',0),(505148,14032,'pt','Quantidade disponÃ­vel',0),(505149,14032,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(505150,14032,'es','Cantidad disponible',0),(505151,14032,'de','VerfÃ¼gbare Menge',0),(505152,14032,'en','Quantity Available',0),(505153,14033,'is','',0),(505154,14033,'dr','Ø´Ø±ÙˆØ¹ ÛŒÚ© Ø³ÙØ§Ø±Ø´',0),(505155,14033,'pr','Ø´Ø±ÙˆØ¹ ÛŒÚ© Ø³ÙØ§Ø±Ø´',0),(505156,14033,'tr','SipariÅŸ baÅŸlatmak',0),(505157,14033,'pl','Rozpocznij zamÃ³wienie',0),(505158,14033,'bg','Ð¡Ñ‚Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð¹ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(505159,14033,'ur','Ø§ÛŒÚ© Ø­Ú©Ù… Ú©Ø§ Ø¢ØºØ§Ø²',0),(505160,14033,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸Ñ‚Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ñƒ',0),(505161,14033,'vi','Báº¯t Ä‘áº§u má»™t Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(505162,14033,'af','Begin \'n bevel',0),(505163,14033,'ro','ÃŽncepe o comandÄƒ',0),(505164,14033,'et','Alustada tellimuse',0),(505165,14033,'si','ZaÄetek nalog',0),(505166,14033,'ba','Memulai perintah',0),(505167,14033,'nl','Start een Order',0),(505168,14033,'fi','Aloita tilaus',0),(505169,14033,'no','Starte en ordre',0),(505170,14033,'da','Starte en ordre',0),(505171,14033,'ko','ì£¼ë¬¸ ì‹œìž‘',0),(505172,14033,'he','×”×¤×¢×œ×ª ×¤×§×•×“×”',0),(505173,14033,'el','ÎœÎ¹Î± ÏƒÎµÎ¹ÏÎ¬ ÎµÎºÎºÎ¯Î½Î·ÏƒÎ·Ï‚',0),(505174,14033,'zh','å¯åŠ¨é¡ºåº',0),(505175,14033,'sv','Starta en Order',0),(505176,14033,'it','Iniziare un ordine',0),(505177,14033,'tl','',0),(505178,14033,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(505179,14033,'hi','à¤à¤• à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤•à¤°à¥‡à¤‚',0),(505180,14033,'ms','Memulakan suatu perintah',0),(505181,14033,'ar','Ø¨Ø¯Ø¡ ØªØ´ØºÙŠÙ„ Ø£Ù…Ø±',0),(505182,14033,'fr','Lancer une commande',0),(505183,14033,'jp','æ³¨æ–‡ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(505184,14033,'pt','Iniciar uma ordem',0),(505185,14033,'ru','ÐÐ°Ñ‡Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(505186,14033,'es','Empezar una orden',0),(505187,14033,'de','Starten Sie einen Auftrag',0),(505188,14033,'en','Start An Order',0),(505189,14034,'is','',0),(505190,14034,'dr','Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø³Ø¨Ø¯ Ø®Ø±ÛŒØ¯',0),(505191,14034,'pr','Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø³Ø¨Ø¯ Ø®Ø±ÛŒØ¯',0),(505192,14034,'tr','AlÄ±ÅŸveriÅŸ sepetini GÃ¼ncelleÅŸtir',0),(505193,14034,'pl','Aktualizacji koszyka',0),(505194,14034,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐºÐ°',0),(505195,14034,'ur','Ø±Ú©Ù† Ú©ÛŒ Ù†Ù…Ø§Ø¦Ù†Ø¯Û Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(505196,14034,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÐºÐ¾Ð»Ð¸Ñ†Ð°',0),(505197,14034,'vi','Cáº­p nháº­t giá» hÃ ng',0),(505198,14034,'af','Bywerking Cart',0),(505199,14034,'ro','Actualizare cos',0),(505200,14034,'et','Uuenda ostukorvi',0),(505201,14034,'si','Posodobitev voziÄek',0),(505202,14034,'ba','Update pesanan',0),(505203,14034,'nl','Pas het winkelmandje',0),(505204,14034,'fi','PÃ¤ivitÃ¤ Ostoskori',0),(505205,14034,'no','Oppdater handlekurv',0),(505206,14034,'da','Opdatere vogn',0),(505207,14034,'ko','ì¹´íŠ¸ë¥¼ ì—…ë°ì´íŠ¸',0),(505208,14034,'he','×œ×¢×“×›×Ÿ ××ª ×”×¢×’×œ×”',0),(505209,14034,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ Cart',0),(505210,14034,'zh','æ›´æ–°è´­ç‰©è½¦',0),(505211,14034,'sv','Uppdatera kundvagn',0),(505212,14034,'it','Aggiornamento carrello',0),(505213,14034,'tl','',0),(505214,14034,'th','à¸­à¸±à¸žà¹€à¸”à¸•à¸£à¸–à¹€à¸‚à¹‡à¸™',0),(505215,14034,'hi','à¤—à¤¾à¤¡à¤¼à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(505216,14034,'ms','Kemaskini Terakhir Cart',0),(505217,14034,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø³Ù„Ø©',0),(505218,14034,'fr','Mise Ã  jour panier',0),(505219,14034,'jp','ã‚«ãƒ¼ãƒˆã¸',0),(505220,14034,'pt','Atualizar carrinho',0),(505221,14034,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐºÐ¾Ñ€Ð·Ð¸Ð½Ñƒ',0),(505222,14034,'es','Actualizar carrito',0),(505223,14034,'de','Warenkorb aktualisieren',0),(505224,14034,'en','Update Cart',0),(505225,14035,'is','',0),(505226,14035,'dr','Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÛŒ Ø§Ù‚Ù„Ø§Ù…',0),(505227,14035,'pr','Ø¬Ø³ØªØ¬Ùˆ Ø¨Ø±Ø§ÛŒ Ø§Ù‚Ù„Ø§Ù…',0),(505228,14035,'tr','Ã–ÄŸeleri ara',0),(505229,14035,'pl','Wyszukiwanie elementÃ³w',0),(505230,14035,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(505231,14035,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(505232,14035,'sr','Ð¢Ñ€Ð°Ð¶ÐµÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(505233,14035,'vi','TÃ¬m kiáº¿m cÃ¡c má»¥c',0),(505234,14035,'af','Soek vir Items',0),(505235,14035,'ro','CÄƒutare pentru elemente',0),(505236,14035,'et','Otsi Ã¼ksusi',0),(505237,14035,'si','IÅ¡Äi elemente',0),(505238,14035,'ba','Pencarian untuk item',0),(505239,14035,'nl','Zoeken naar Items',0),(505240,14035,'fi','Kohteiden etsiminen',0),(505241,14035,'no','SÃ¸k etter elementer',0),(505242,14035,'da','SÃ¸ge efter emner',0),(505243,14035,'ko','í•­ëª©ì— ëŒ€ í•œ ê²€ìƒ‰',0),(505244,14035,'he','×”×—×™×¤×•×© ××—×¨ ×¤×¨×™×˜×™×',0),(505245,14035,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(505246,14035,'zh','æœç´¢é¡¹ç›®',0),(505247,14035,'sv','SÃ¶k efter objekt',0),(505248,14035,'it','Ricerca di oggetti',0),(505249,14035,'tl','',0),(505250,14035,'th','à¸„à¹‰à¸™à¸«à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(505251,14035,'hi','à¤®à¤¦à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ',0),(505252,14035,'ms','Cari perkara-perkara',0),(505253,14035,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(505254,14035,'fr','Rechercher des Ã©lÃ©ments',0),(505255,14035,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã‚’æ¤œç´¢ã—ã¾ã™ã€‚',0),(505256,14035,'pt','Procure por itens',0),(505257,14035,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð¾Ð²',0),(505258,14035,'es','BÃºsqueda de artÃ­culos',0),(505259,14035,'de','Suche nach Artikeln',0),(505260,14035,'en','Search For Items',0),(505261,14036,'is','',0),(505262,14036,'dr','Ø§ØªØ§',0),(505263,14036,'pr','Ø§ØªØ§',0),(505264,14036,'tr','ETA',0),(505265,14036,'pl','ETA',0),(505266,14036,'bg','Ð•Ð¢Ð',0),(505267,14036,'ur','Ø§ÙˆØ±',0),(505268,14036,'sr','Ð•Ð¢Ð',0),(505269,14036,'vi','ETA',0),(505270,14036,'af','ETA',0),(505271,14036,'ro','ETA',0),(505272,14036,'et','ETA',0),(505273,14036,'si','ETA',0),(505274,14036,'ba','ETA',0),(505275,14036,'nl','ETA',0),(505276,14036,'fi','ETA: N',0),(505277,14036,'no','ETA',0),(505278,14036,'da','ETA',0),(505279,14036,'ko','ë„ì°© ì˜ˆì • ì‹œê°„',0),(505280,14036,'he','. ×–×ž×Ÿ ×”×’×¢×” ×ž×©×•×¢×¨',0),(505281,14036,'el','ETA',0),(505282,14036,'zh','åŸƒå¡”',0),(505283,14036,'sv','ETA',0),(505284,14036,'it','ETA',0),(505285,14036,'tl','',0),(505286,14036,'th','à¹€à¸­à¸•à¸²à¸',0),(505287,14036,'hi','à¤ˆà¤Ÿà¥€à¤',0),(505288,14036,'ms','RECOMMENDATIONS',0),(505289,14036,'ar','Ù…Ù†Ø¸Ù…Ø© Ø¥ÙŠØªØ§',0),(505290,14036,'fr','ETA',0),(505291,14036,'jp','ETA',0),(505292,14036,'pt','ETA',0),(505293,14036,'ru','ETA',0),(505294,14036,'es','ETA',0),(505295,14036,'de','ETA',0),(505296,14036,'en','ETA',0),(505297,14037,'is','',0),(505298,14037,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú©Ø§Ù…Ù„ Ú©Ø´ØªÛŒ/ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ Ø±Ø§ Ø¨Ù‡ Ø¬Ø¹Ø¨Ù‡ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(505299,14037,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ Ú©Ø§Ù…Ù„ Ú©Ø´ØªÛŒ/ÙØ±ÙˆØ®ØªÙ‡ Ø´Ø¯Ù‡ Ø±Ø§ Ø¨Ù‡ Ø¬Ø¹Ø¨Ù‡ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(505300,14037,'tr','Tam boyutlu gemi/satÄ±lan gÃ¶stermek iÃ§in kutu',0),(505301,14037,'pl','PokaÅ¼ peÅ‚ny sklejony statku/sprzedawane na polu',0),(505302,14037,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿ÑŠÐ»ÐµÐ½ Ñ€Ð°Ð·Ð¼ÐµÑ€ ÐºÐ¾Ñ€Ð°Ð±/Ð¿Ñ€Ð¾Ð´Ð°Ð´ÐµÐ½ ÐºÑƒÑ‚Ð¸Ñ',0),(505303,14037,'ur','Ù…Ú©Ù…Ù„ Ø³Ø§Ø¦Ø² Ø¬ÛØ§Ø²/ÙØ±ÙˆØ®Øª Ø®Ø§Ù†Û Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(505304,14037,'sr','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ð´ÑƒÐ³Ð°Ñ‡Ð°Ðº Ð±Ñ€Ð¾Ð´/Ð¿Ñ€Ð¾Ð´Ð°Ð»Ð¸ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ',0),(505305,14037,'vi','Hiá»ƒn thá»‹ Ä‘áº§y Ä‘á»§ kÃ­ch cá»¡ tÃ u/bÃ¡n há»™p',0),(505306,14037,'af','Wys volgrootte skip/verkoop aan boks',0),(505307,14037,'ro','AratÄƒ plin-Sized nava/vÃ¢ndut la cutie',0),(505308,14037,'et','NÃ¤ita kasti tÃ¤is-suurusega laeva/mÃ¼Ã¼dud',0),(505309,14037,'si','PrikaÅ¾i polni velikosti ladje/prodajajo polje',0),(505310,14037,'ba','Tampilkan berukuran penuh kapal/dijual ke kotak',0),(505311,14037,'nl','Full-Sized schip/verkocht aan vak tonen',0),(505312,14037,'fi','NÃ¤ytÃ¤ tÃ¤ysikokoinen aluksen/myytyjen ruutuun',0),(505313,14037,'no','Vis store skipet/solgt til boksen',0),(505314,14037,'da','Vis fuld stÃ¸rrelse skib/solgt til boks',0),(505315,14037,'ko','ì „ì²´ í¬ê¸°ì˜ ë°°/íŒë§¤ ìƒìž í‘œì‹œ',0),(505316,14037,'he','×”×¦×’ ×‘×’×•×“×œ ×ž×œ× ×”×¡×¤×™× ×”/×ž×›×¨ ×ª×™×‘×ª',0),(505317,14037,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Î»Î®ÏÎ¿Ï…Ï‚ Î¼ÎµÎ³Î­Î¸Î¿Ï…Ï‚ Ï€Î»Î¿Î¯Î¿Ï…/Ï€Ï‰Î»Î¿ÏÎ½Ï„Î±Î¹ ÏƒÏ„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿',0),(505318,14037,'zh','æ˜¾ç¤ºå…¨å°ºå¯¸èˆ¹/å–åˆ°æ¡†',0),(505319,14037,'sv','Visa Full storlek fartyg/sÃ¥lt till Box',0),(505320,14037,'it','Visualizza la grandezza nave/venduto alla casella',0),(505321,14037,'tl','',0),(505322,14037,'th','à¹à¸ªà¸”à¸‡à¸‚à¸™à¸²à¸”à¹€à¸•à¹‡à¸¡à¹€à¸£à¸·à¸­/à¸‚à¸²à¸¢à¸à¸¥à¹ˆà¸­à¸‡',0),(505323,14037,'hi','à¤ªà¥‚à¤°à¥à¤£ à¤†à¤•à¤¾à¤° à¤œà¤¹à¤¾à¤œ/à¤¬à¥‡à¤šà¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥‰à¤•à¥à¤¸ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(505324,14037,'ms','Menunjukkan saiz penuh kapal/dijual kepada peti',0),(505325,14037,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø­Ø¬Ù… Ø§Ù„ÙƒØ§Ù…Ù„ Ø§Ù„Ø³ÙÙŠÙ†Ø©/ØªØ¨Ø§Ø¹ Ø¥Ù„Ù‰ Ù…Ø±Ø¨Ø¹',0),(505326,14037,'fr','Voir la pleine grandeur navire/vendu Ã  boÃ®te',0),(505327,14037,'jp','å¤§åž‹èˆ¹/è²©å£²ãƒœãƒƒã‚¯ã‚¹ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(505328,14037,'pt','Mostrar tamanho navio/vendeu a caixa',0),(505329,14037,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ-Ð¿Ð¾Ð»Ð½Ð¾Ñ€Ð°Ð·Ð¼ÐµÑ€Ð½Ð¾Ðµ ÑÑƒÐ´Ð½Ð¾/Ð¿Ñ€Ð¾Ð´Ð°Ð½ Ð² ÐºÐ¾Ñ€Ð¾Ð±ÐºÐµ',0),(505330,14037,'es','Mostrar tamaÃ±o completo nave/vendido a la caja',0),(505331,14037,'de','Box zeigen Sie groÃŸes Schiff/verkauft',0),(505332,14037,'en','Show Full-Sized Ship/Sold To Box',0),(505333,14038,'is','',0),(505334,14038,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø­Ø¯Ø§Ú©Ø«Ø± Ø³Ø·Ø­ Ø¬ÙˆØ±Ø§Ø¨ Ø²Ù†Ø§Ù†Ù‡ Ø³Ø§Ù‚Ù‡ Ø¨Ù„Ù†Ø¯ Ø¨Ø±Ø§ÛŒ ØªØ¹ÛŒÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´',0),(505335,14038,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø­Ø¯Ø§Ú©Ø«Ø± Ø³Ø·Ø­ Ø¬ÙˆØ±Ø§Ø¨ Ø²Ù†Ø§Ù†Ù‡ Ø³Ø§Ù‚Ù‡ Ø¨Ù„Ù†Ø¯ Ø¨Ø±Ø§ÛŒ ØªØ¹ÛŒÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´',0),(505336,14038,'tr','Ã‡orap dÃ¼zeyi maksimum sipariÅŸ miktarÄ± belirlemek iÃ§in kullanÄ±n.',0),(505337,14038,'pl','UmoÅ¼liwia okreÅ›lenie kolejnoÅ›ci iloÅ›Ä‡ Max poziom obsady',0),(505338,14038,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÐœÐ°ÐºÑ Ð½Ð¸Ð²Ð¾ Ð½Ð° Ð±Ð¸Ð¾Ð¼Ð°ÑÐ°Ñ‚Ð°, Ð·Ð° Ð´Ð° Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»Ð¸ Ñ€ÐµÐ´ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(505339,14038,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø³Ø·Ø­ Ú©Ùˆ Ø°Ø®ÛŒØ±Û Ú©Ø±Ù†Û’ ØªØ±ØªÛŒØ¨ Ù‚ÛŒ Ú©Ø§ ØªØ¹ÛŒÙ† Ú©Ø±Ù†Û’ Ú©ÛŒÙ„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(505340,14038,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÐœÐ°x Ð¿Ñ€Ð¸Ð¿Ñ€ÐµÐ¼Ð¸Ð»Ðµ Ð½Ð¸Ð²Ð¾ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¾Ð´Ñ€ÐµÐ´Ð¸Ð»Ð¸ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÐšÐ¾Ð».',0),(505341,14038,'vi','Sá»­ dá»¥ng Max tháº£ cáº¥p Ä‘á»ƒ xÃ¡c Ä‘á»‹nh thá»© tá»± Qty',0),(505342,14038,'af','Max voorraad vlak bepaal orde Qty gebruik',0),(505343,14038,'ro','UtilizaÅ£i Max nivel de stocare pentru a determina ordinea cantit',0),(505344,14038,'et','Max loomkoormus tase abil saate mÃ¤Ã¤ratleda tellimuse kogus',0),(505345,14038,'si','Uporabite Max naselitve ravni doloÄiti vrstni red kol',0),(505346,14038,'ba','Gunakan Max Stocking tingkat untuk menentukan urutan Qty',0),(505347,14038,'nl','Max tricotst niveau gebruiken om te bepalen van afname',0),(505348,14038,'fi','Max tiheys avulla mÃ¤Ã¤rittÃ¤Ã¤ tilauksen mÃ¤Ã¤rÃ¤',0),(505349,14038,'no','Bruke Max strÃ¸mpe plan flate Ã¥ bestemme rekkefÃ¸lgen antall',0),(505350,14038,'da','Bruge Max strÃ¸mpe niveau til at bestemme rÃ¦kkefÃ¸lgen Qty',0),(505351,14038,'ko','ìŠ¤íƒ€í‚¹ ìˆ˜ì¤€ ìµœëŒ€ë¥¼ ì‚¬ìš© í•˜ ì—¬ ì£¼ë¬¸ ìˆ˜ëŸ‰ ê²°ì •',0),(505352,14038,'he','×”×©×ª×ž×© Max ×’×¨×‘ ×¨×ž×” ×›×“×™ ×œ×§×‘×•×¢ ×¡×“×¨ ×›×ž×•×ª',0),(505353,14038,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î· ÏƒÏ…Î½Î¬ÏÏ„Î·ÏƒÎ· MÎ‘Î§ ÎµÎºÏ„ÏÎ¿Ï†Î®Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Î½Î± ÎºÎ±Î¸Î¿ÏÎ¯ÏƒÎµÎ¹ Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Î Î¿Ïƒ.',0),(505354,14038,'zh','ä½¿ç”¨æœ€å¤§åº“å­˜æ°´å¹³æ¥ç¡®å®šè®¢è´­æ•°é‡',0),(505355,14038,'sv','AnvÃ¤nda Max krontÃ¤ckning att avgÃ¶ra ordning Kvt',0),(505356,14038,'it','Utilizzare Max livello di stoccaggio per determinare l\'ordine Qty',0),(505357,14038,'tl','',0),(505358,14038,'th','à¹ƒà¸Šà¹‰à¸–à¸¸à¸‡à¸™à¹ˆà¸­à¸‡à¸£à¸°à¸”à¸±à¸šà¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¹€à¸žà¸·à¹ˆà¸­à¸à¸³à¸«à¸™à¸”à¸›à¸£à¸´à¸¡à¸²à¸“à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(505359,14038,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¥à¤¤à¤° à¤®à¥‹à¤œà¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(505360,14038,'ms','Menggunakan stok tahap Max untuk menentukan Qty pesanan',0),(505361,14038,'ar','Ø§Ø³ØªØ®Ø¯Ù… Ù…Ø§ÙƒØ³ ØªØ®Ø²ÙŠÙ† Ù…Ø³ØªÙˆÙ‰ Ù„ØªØ­Ø¯ÙŠØ¯ ÙƒÙ…ÙŠØ© Ø£Ù…Ø±',0),(505362,14038,'fr','Max bas niveau permet de dÃ©terminer la quantitÃ© d\'ordre',0),(505363,14038,'jp','ã‚¹ãƒˆãƒƒã‚­ãƒ³ã‚°ã®ãƒ¬ãƒ™ãƒ« Max æ³¨æ–‡æ•°é‡ã‚’ç¢ºèªã™ã‚‹ã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(505364,14038,'pt','Usar Max lotaÃ§Ã£o de nÃ­vel para determinar a ordem Qty',0),(505365,14038,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÐœÐ°ÐºÑ Ñ‡ÑƒÐ»Ð¾Ðº ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð´Ð»Ñ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ ÐšÐ¾Ð»-Ð²Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(505366,14038,'es','MÃ¡ximo nivel de siembra se utiliza para determinar el orden Qty',0),(505367,14038,'de','Verwenden Sie Max glatt Ebene, um die Bestellmenge zu ermitteln',0),(505368,14038,'en','Use Max Stocking Level To Determine Order Qty',0),(505369,14039,'is','',0),(505370,14039,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø¯Ø³ØªÛŒ',0),(505371,14039,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø¯Ø³ØªÛŒ',0),(505372,14039,'tr','El ile yapÄ±lan Ã¶demeler',0),(505373,14039,'pl','ObsÅ‚ugi pÅ‚atnoÅ›ci',0),(505374,14039,'bg','Ð ÑŠÑ‡Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(505375,14039,'ur','Ø¯Ø³ØªÛŒ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(505376,14039,'sr','Ð ÑƒÑ‡Ð½Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(505377,14039,'vi','Thanh toÃ¡n thá»§ cÃ´ng',0),(505378,14039,'af','Handleiding betalings',0),(505379,14039,'ro','PlÄƒÅ£i manuale',0),(505380,14039,'et','KÃ¤sitsi maksed',0),(505381,14039,'si','RoÄna plaÄila',0),(505382,14039,'ba','Pembayaran manual',0),(505383,14039,'nl','Handmatige betalingen',0),(505384,14039,'fi','Manuaaliset maksut',0),(505385,14039,'no','Manuell betalinger',0),(505386,14039,'da','Manuelle betalinger',0),(505387,14039,'ko','ìˆ˜ë™ ê²°ì œ',0),(505388,14039,'he','×ª×©×œ×•×ž×™× ×™×“× ×™×ª',0),(505389,14039,'el','ÎœÎ· Î±Ï…Ï„ÏŒÎ¼Î±Ï„ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(505390,14039,'zh','äººå·¥ä»˜æ¬¾',0),(505391,14039,'sv','Manuella betalningar',0),(505392,14039,'it','Pagamenti manuali',0),(505393,14039,'tl','',0),(505394,14039,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(505395,14039,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(505396,14039,'ms','Pembayaran secara manual',0),(505397,14039,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„ÙŠØ¯ÙˆÙŠØ©',0),(505398,14039,'fr','Paiements manuels',0),(505399,14039,'jp','æ‰‹å‹•ã®ãŠæ”¯æ‰•ã„',0),(505400,14039,'pt','Pagamentos manuais',0),(505401,14039,'ru','Ð ÑƒÑ‡Ð½Ñ‹Ðµ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹',0),(505402,14039,'es','Pagos manuales',0),(505403,14039,'de','Manuelle Zahlungen',0),(505404,14039,'en','Manual Payments',0),(505405,14040,'is','',0),(505406,14040,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§ÛŒØ¬Ø§Ø¯',0),(505407,14040,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§ÛŒØ¬Ø§Ø¯',0),(505408,14040,'tr','El ile yapÄ±lan Ã¶deme baÅŸarÄ±yla oluÅŸturuldu',0),(505409,14040,'pl','ObsÅ‚ugi pÅ‚atnoÅ›ci zostaÅ‚ utworzony pomyÅ›lnie',0),(505410,14040,'bg','Ð ÑŠÑ‡Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ, ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(505411,14040,'ur','Ø¯Ø³ØªÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(505412,14040,'sr','Ð ÑƒÑ‡Ð½Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°',0),(505413,14040,'vi','HÆ°á»›ng dáº«n sá»­ dá»¥ng thanh toÃ¡n táº¡o thÃ nh cÃ´ng',0),(505414,14040,'af','Handleiding betaling suksesvol geskep',0),(505415,14040,'ro','Plata manuala creat cu succes',0),(505416,14040,'et','KÃ¤sitsi makse on edukalt loodud',0),(505417,14040,'si','RoÄnega plaÄila uspeÅ¡no ustvarjen',0),(505418,14040,'ba','Metode pembayaran manual yang dibuat dengan sukses',0),(505419,14040,'nl','Handmatige betaling met succes gemaakt',0),(505420,14040,'fi','Manuaalinen maksun luominen onnistui',0),(505421,14040,'no','Manuell betaling opprettet',0),(505422,14040,'da','Manuel betaling oprettet',0),(505423,14040,'ko','ì„±ê³µì ìœ¼ë¡œ ìƒì„± í•˜ëŠ” ìˆ˜ë™ ê²°ì œ',0),(505424,14040,'he','×ª×©×œ×•× ×™×“× ×™ × ×•×¦×¨×• ×‘×”×¦×œ×—×”',0),(505425,14040,'el','ÎœÎ· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Ï€Î»Î·ÏÏ‰Î¼Î® Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(505426,14040,'zh','å·²æˆåŠŸåˆ›å»ºçš„æ‰‹åŠ¨ä»˜æ¬¾',0),(505427,14040,'sv','Manuell betalning har skapats',0),(505428,14040,'it','Pagamento manuale creato con successo',0),(505429,14040,'tl','',0),(505430,14040,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡à¸—à¸µà¹ˆà¸ªà¸£à¹‰à¸²à¸‡à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢',0),(505431,14040,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(505432,14040,'ms','Manual pembayaran yang berjaya dicipta',0),(505433,14040,'ar','Ø¯Ù„ÙŠÙ„ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(505434,14040,'fr','Paiement manuel crÃ©Ã© avec succÃ¨s',0),(505435,14040,'jp','æ‰‹å‹•ã®ãŠæ”¯æ‰•ã„ãŒæ­£å¸¸ã«ä½œæˆã•ã‚Œã¾ã—ãŸ',0),(505436,14040,'pt','Pagamento manual criado com sucesso',0),(505437,14040,'ru','Ð ÑƒÑ‡Ð½Ð°Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½',0),(505438,14040,'es','Pago manual creado con Ã©xito',0),(505439,14040,'de','Manuelle Zahlung wurde erfolgreich erstellt.',0),(505440,14040,'en','Manual Payment Created Successfully',0),(505441,14041,'is','',0),(505442,14041,'dr','ØªØ±ØªÛŒØ¨ Ú†Ø§Ù¾ Ø³Ù¾Ø±Ø¯Ù‡',0),(505443,14041,'pr','ØªØ±ØªÛŒØ¨ Ú†Ø§Ù¾ Ø³Ù¾Ø±Ø¯Ù‡',0),(505444,14041,'tr','YazdÄ±rma sÄ±rasÄ±nÄ± mevduat',0),(505445,14041,'pl','Zlecenia druku wpÅ‚aty',0),(505446,14041,'bg','Ð ÐµÐ´ Ð½Ð° Ð¿ÐµÑ‡Ð°Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸',0),(505447,14041,'ur','Ø­Ú©Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ø°Ø®Ø§Ø¦Ø±',0),(505448,14041,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ðµ',0),(505449,14041,'vi','In tiá»n gá»­i Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(505450,14041,'af','Druk orde deposito\'s',0),(505451,14041,'ro','Depozite de ordine de imprimare',0),(505452,14041,'et','Prindi korra hoiuseid',0),(505453,14041,'si','Vrstni red tiskanja vloge',0),(505454,14041,'ba','Pesanan cetakan deposito',0),(505455,14041,'nl','Afdrukvolgorde deposito \'s',0),(505456,14041,'fi','TulostusjÃ¤rjestyksen talletukset',0),(505457,14041,'no','UtskriftsrekkefÃ¸lge innskudd',0),(505458,14041,'da','Udskrive ordre indskud',0),(505459,14041,'ko','ì¸ì‡„ ì£¼ë¬¸ ìž…ê¸ˆ',0),(505460,14041,'he','×¡×“×¨ ×”×”×“×¤×¡×” ×¤×™×§×“×•× ×•×ª',0),(505461,14041,'el','ÎšÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(505462,14041,'zh','æ‰“å°é¡ºåºå­˜æ¬¾',0),(505463,14041,'sv','Utskriftsordning insÃ¤ttningar',0),(505464,14041,'it','Ordine di stampa depositi',0),(505465,14041,'tl','',0),(505466,14041,'th','à¸à¸²à¸à¸ªà¸±à¹ˆà¸‡à¸žà¸´à¸¡à¸žà¹Œ',0),(505467,14041,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤•à¥à¤°à¤® à¤œà¤®à¤¾',0),(505468,14041,'ms','Deposit cetak',0),(505469,14041,'ar','Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø£Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(505470,14041,'fr','DÃ©pÃ´ts de l\'ordre d\'impression',0),(505471,14041,'jp','å°åˆ·é †åºã‚’é é‡‘',0),(505472,14041,'pt','DepÃ³sitos de ordem de impressÃ£o',0),(505473,14041,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹',0),(505474,14041,'es','DepÃ³sitos de la orden de impresiÃ³n',0),(505475,14041,'de','Druckreihenfolge Einlagen',0),(505476,14041,'en','Print Order Deposits',0),(505477,14042,'is','',0),(505478,14042,'dr','Ø´Ø±Ú©Øª ÛŒØ§ Ù†Ø§Ù… Ø´Ø®Øµ',0),(505479,14042,'pr','Ø´Ø±Ú©Øª ÛŒØ§ Ù†Ø§Ù… Ø´Ø®Øµ',0),(505480,14042,'tr','Åžirket veya kiÅŸi adÄ±',0),(505481,14042,'pl','Firma lub nazwisko osoby',0),(505482,14042,'bg','Ð¤Ð¸Ñ€Ð¼Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ð»Ð¸Ñ†Ðµ',0),(505483,14042,'ur','Ú©Ù…Ù¾Ù†ÛŒ ÛŒØ§ Ø´Ø®Øµ Ú©Ø§ Ù†Ø§Ù…',0),(505484,14042,'sr','ÐŸÑ€ÐµÐ´ÑƒÐ·ÐµÑ›Ðµ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð¾ÑÐ¾Ð±Ðµ',0),(505485,14042,'vi','CÃ´ng ty hoáº·c tÃªn ngÆ°á»i',0),(505486,14042,'af','Maatskappy of persoon naam',0),(505487,14042,'ro','Firma sau numele persoanei',0),(505488,14042,'et','Firma vÃµi isiku nimi',0),(505489,14042,'si','Podjetje ali oseba ime',0),(505490,14042,'ba','Perusahaan atau nama orang',0),(505491,14042,'nl','Bedrijf of persoonsnaam',0),(505492,14042,'fi','Yrityksen tai HenkilÃ¶nimi',0),(505493,14042,'no','Selskapet eller personnavn',0),(505494,14042,'da','Virksomhed eller personnavn',0),(505495,14042,'ko','íšŒì‚¬ ë˜ëŠ” ì‚¬ëžŒ ì´ë¦„',0),(505496,14042,'he','×©× ×”××“× ××• ×”×—×‘×¨×”',0),(505497,14042,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î® ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿ÏƒÏŽÏ€Î¿Ï…',0),(505498,14042,'zh','å…¬å¸æˆ–äººçš„åå­—',0),(505499,14042,'sv','FÃ¶retag eller personnamn',0),(505500,14042,'it','Nome di persona o azienda',0),(505501,14042,'tl','',0),(505502,14042,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸šà¸¸à¸„à¸„à¸¥',0),(505503,14042,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¯à¤¾ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(505504,14042,'ms','Syarikat atau nama individu',0),(505505,14042,'ar','Ø§Ø³Ù… Ø§Ù„Ø´Ø®Øµ Ø£Ùˆ Ø§Ù„Ø´Ø±ÙƒØ©',0),(505506,14042,'fr','SociÃ©tÃ© ou nom de la personne',0),(505507,14042,'jp','ä¼šç¤¾ã¾ãŸã¯å€‹äººå',0),(505508,14042,'pt','Empresa ou nome de pessoa',0),(505509,14042,'ru','Ð˜Ð¼Ñ Ð»Ð¸Ñ†Ð° Ð¸Ð»Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(505510,14042,'es','Empresa o nombre de la persona',0),(505511,14042,'de','Personenname der Firma oder',0),(505512,14042,'en','Company Or Person Name',0),(505513,14043,'is','',0),(505514,14043,'dr','Ù…Ø­Ø±ÙˆÙ… Ú©Ø±Ø¯Ù† Ù…Ø´ØªØ±ÛŒØ§Ù† Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù†Ø¯Ø§Ø±Ø¯',0),(505515,14043,'pr','Ù…Ø­Ø±ÙˆÙ… Ú©Ø±Ø¯Ù† Ù…Ø´ØªØ±ÛŒØ§Ù† Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù†Ø¯Ø§Ø±Ø¯',0),(505516,14043,'tr','HayÄ±r Kredi mÃ¼ÅŸterileri hariÃ§ tut',0),(505517,14043,'pl','Nie kredytowej klientÃ³w',0),(505518,14043,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð¸ Ð½ÑÐ¼Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(505519,14043,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú¯Ø§ÛÚ©ÙˆÚº Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(505520,14043,'sr','Ð˜ÑÐºÑ™ÑƒÑ‡Ð¸ ÐºÑƒÐ¿Ñ†Ðµ Ð±ÐµÐ· ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(505521,14043,'vi','Loáº¡i trá»« khÃ´ng cÃ³ khÃ¡ch hÃ ng tÃ­n dá»¥ng',0),(505522,14043,'af','Geen krediet kliÃ«nte sluit',0),(505523,14043,'ro','Excluderea nu Credit clienÅ£ii',0),(505524,14043,'et','JÃ¤tta krediidi kliente',0),(505525,14043,'si','IzkljuÄuje kreditne kupcev',0),(505526,14043,'ba','Mengecualikan tidak kredit pelanggan',0),(505527,14043,'nl','Uitsluiten geen krediet-klanten',0),(505528,14043,'fi','Ei ole luotto-asiakkaita',0),(505529,14043,'no','Ekskluder ingen kreditt-kunder',0),(505530,14043,'da','Udelukke ingen kredit kunder',0),(505531,14043,'ko','ì•„ë‹ˆ ì‹ ìš© ê³ ê° ì œì™¸',0),(505532,14043,'he','××œ ×ª×›×œ×•×œ ×œ×§×•×—×•×ª ××©×¨××™',0),(505533,14043,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¯Î¿Ï…Î½ ÎºÎ±Î½Î­Î½Î± Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½',0),(505534,14043,'zh','æŽ’é™¤æ²¡æœ‰ä¿¡è´·å®¢æˆ·',0),(505535,14043,'sv','Utesluta ingen kredit kunder',0),(505536,14043,'it','Non escludere nessun credito clienti',0),(505537,14043,'tl','',0),(505538,14043,'th','à¹„à¸¡à¹ˆà¸£à¸§à¸¡à¸¥à¸¹à¸à¸„à¹‰à¸²à¹„à¸¡à¹ˆà¸¡à¸µà¹€à¸„à¸£à¸”à¸´à¸•',0),(505539,14043,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤¬à¤¾à¤¹à¤°',0),(505540,14043,'ms','Tidak termasuk pelanggan kredit tidak',0),(505541,14043,'ar','Ø§Ø³ØªØ¨Ø¹Ø§Ø¯ Ù„Ø§ Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(505542,14043,'fr','N\'exclure aucun crÃ©dit clients',0),(505543,14043,'jp','ä¿¡ç”¨é¡§å®¢ã‚’é™¤å¤–ãªã—',0),(505544,14043,'pt','NÃ£o excluir nenhum crÃ©dito clientes',0),(505545,14043,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð½Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(505546,14043,'es','No excluir ningÃºn crÃ©dito clientes',0),(505547,14043,'de','SchlieÃŸen Sie keine Kredit-Kunden',0),(505548,14043,'en','Exclude No Credit Customers',0),(505549,14044,'is','',0),(505550,14044,'dr','Ø´Ù†Ø§Ø³Ù‡ Ø±Ø¯Ù‡ ÙØ±ÙˆØ´ Ø¢Ù† Ø´Ø±Ú©Øª',0),(505551,14044,'pr','Ø´Ù†Ø§Ø³Ù‡ Ø±Ø¯Ù‡ ÙØ±ÙˆØ´ Ø¢Ù† Ø´Ø±Ú©Øª',0),(505552,14044,'tr','SatÄ±ÅŸ Kategori o ÅŸirket kimliÄŸi',0),(505553,14044,'pl','Identyfikator sprzedaÅ¼y kategorii czasu firmy',0),(505554,14044,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ñ‚Ð¾Ð³Ð°Ð²Ð° Ñ„Ð¸Ñ€Ð¼ÐµÐ½ Ð˜Ð”',0),(505555,14044,'ur','Ø³ÛŒÙ„Ø² Ø²Ù…Ø±Û Ù¾Ú¾Ø± Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(505556,14044,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ñ‚Ð°Ð´Ð° ÐœÐ°Ñ‚Ð¸Ñ‡Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(505557,14044,'vi','BÃ¡n hÃ ng thá»ƒ loáº¡i Ä‘Ã³ cÃ´ng ty ID',0),(505558,14044,'af','Verkope kategorie dan maatskappy ID',0),(505559,14044,'ro','VÃ¢nzÄƒri Categorie atunci compania ID',0),(505560,14044,'et','MÃ¼Ã¼k kategooria ajast ettevÃµtte ID',0),(505561,14044,'si','Prodaja kategorije takrat druÅ¾ba ID',0),(505562,14044,'ba','Penjualan kategori kemudian perusahaan ID',0),(505563,14044,'nl','Verkoop categorie dan bedrijfs-ID',0),(505564,14044,'fi','Myynti luokka sitten yrityksen tunnus',0),(505565,14044,'no','Salg kategori da firma-ID',0),(505566,14044,'da','Salg kategori da firma-ID',0),(505567,14044,'ko','íŒë§¤ ì¹´í…Œê³ ë¦¬ ê·¸ë•Œ íšŒì‚¬ ID',0),(505568,14044,'he','×ž×–×”×” ×”×ž×›×™×¨×•×ª ×§×˜×’×•×¨×™×” ××– ×—×‘×¨×”',0),(505569,14044,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï„ÏŒÏ„Îµ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ID',0),(505570,14044,'zh','é”€å”®ç±»åˆ«ç„¶åŽå…¬å¸ ID',0),(505571,14044,'sv','FÃ¶rsÃ¤ljning kategori dÃ¥ fÃ¶retags-ID',0),(505572,14044,'it','Vendite categoria allora azienda ID',0),(505573,14044,'tl','',0),(505574,14044,'th','à¸‚à¸²à¸¢à¸›à¸£à¸°à¹€à¸ à¸—à¸™à¸±à¹‰à¸™à¸›à¸£à¸°à¸Šà¸²à¸Šà¸™',0),(505575,14044,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¤à¤¬ à¤•à¤‚à¤ªà¤¨à¥€ ID',0),(505576,14044,'ms','ID syarikat itu kategori jualan',0),(505577,14044,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ø´Ø±ÙƒØ© Ø«Ù… ÙØ¦Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(505578,14044,'fr','Ventes catÃ©gorie alors sociÃ©tÃ© ID',0),(505579,14044,'jp','è²©å£²ã‚«ãƒ†ã‚´ãƒªã€ä¼šç¤¾ ID',0),(505580,14044,'pt','Vendas categoria entÃ£o empresa ID',0),(505581,14044,'ru','Ð—Ð°Ñ‚ÐµÐ¼ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ ID',0),(505582,14044,'es','Ventas CategorÃ­a entonces empresa ID',0),(505583,14044,'de','Verkauf Kategorie dann Firmenkennung',0),(505584,14044,'en','Sales Category Then Company ID',0),(505585,14045,'is','',0),(505586,14045,'dr','Ù…Ø±ØªØ¨ Ø§Ø¸Ù‡Ø§Ø±Ø§Øª',0),(505587,14045,'pr','Ù…Ø±ØªØ¨ Ø§Ø¸Ù‡Ø§Ø±Ø§Øª',0),(505588,14045,'tr','SÄ±ralama dÃ¼zeni iÃ§in tablolar',0),(505589,14045,'pl','KolejnoÅ›Ä‡ sortowania dla instrukcji',0),(505590,14045,'bg','Ð ÐµÐ´ Ð½Ð° ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(505591,14045,'ur','Ø¨ÛŒØ§Ù†Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ú†Ú¾Ø§Ù†Ù¹ ØªØ±ØªÛŒØ¨',0),(505592,14045,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°ÑšÐ° Ð·Ð° Ð¸Ð·Ñ˜Ð°Ð²Ðµ',0),(505593,14045,'vi','Thá»© tá»± sáº¯p xáº¿p cho bÃ¡o cÃ¡o',0),(505594,14045,'af','Ordeningsvolgorde vir state',0),(505595,14045,'ro','Ordinea de sortare pentru situaÅ£iile de',0),(505596,14045,'et','SortimisjÃ¤rjestuse ametikohta',0),(505597,14045,'si','Vrstni red za izjave',0),(505598,14045,'ba','Urutan untuk pernyataan',0),(505599,14045,'nl','Sorteervolgorde voor verklaringen',0),(505600,14045,'fi','LajittelujÃ¤rjestyksen lausunnot',0),(505601,14045,'no','SorteringsrekkefÃ¸lgen For uttalelser',0),(505602,14045,'da','SorteringsrÃ¦kkefÃ¸lgen For udtalelser',0),(505603,14045,'ko','ë¬¸ì— ëŒ€ í•œ ì •ë ¬ ìˆœì„œ',0),(505604,14045,'he','×¡×“×¨ ×ž×™×•×Ÿ ×¢×‘×•×¨ ×”×¦×”×¨×•×ª',0),(505605,14045,'el','Î£ÎµÎ¹ÏÎ¬ Ï„Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ·Ï‚ Î³Î¹Î± Î´Î·Î»ÏŽÏƒÎµÎ¹Ï‚',0),(505606,14045,'zh','è¯­å¥æŽ’åºé¡ºåº',0),(505607,14045,'sv','Sorteringsordning fÃ¶r meddelanden',0),(505608,14045,'it','Ordinamento per dichiarazioni',0),(505609,14045,'tl','',0),(505610,14045,'th','à¹€à¸£à¸µà¸¢à¸‡à¸¥à¸³à¸”à¸±à¸šà¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸¢à¸­à¸”',0),(505611,14045,'hi','à¤¬à¤¯à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶',0),(505612,14045,'ms','Susun mengikut penyata',0),(505613,14045,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„ÙØ±Ø² Ù„Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(505614,14045,'fr','Ordre de tri pour les dÃ©clarations',0),(505615,14045,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã®ä¸¦ã¹æ›¿ãˆé †åº',0),(505616,14045,'pt','Ordem de classificaÃ§Ã£o para demonstraÃ§Ãµes',0),(505617,14045,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð´Ð»Ñ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€Ð¾Ð²',0),(505618,14045,'es','Criterio de ordenaciÃ³n para las declaraciones',0),(505619,14045,'de','Sortierreihenfolge fÃ¼r Anweisungen',0),(505620,14045,'en','Sort Order For Statements',0),(505621,14046,'is','',0),(505622,14046,'dr','Ø¹Ø¯Ù… Ù†Ù…Ø§ÛŒØ´ Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§ Ù‡ÛŒÚ† Ù…Ù†Ø¸ÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø±Ø²Ø´',0),(505623,14046,'pr','Ø¹Ø¯Ù… Ù†Ù…Ø§ÛŒØ´ Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§ Ù‡ÛŒÚ† Ù…Ù†Ø¸ÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø±Ø²Ø´',0),(505624,14046,'tr','Gizlenecek Ã¶ÄŸeler ile hiÃ§bir sipariÅŸ ÅŸimdi deÄŸeri',0),(505625,14046,'pl','Ukrywanie elementÃ³w z zamÃ³wienia, nie ma teraz wartoÅ›Ä‡',0),(505626,14046,'bg','Ð¡ÐºÑ€Ð¸Ð¹ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ñ Ð½Ð¸ÐºÐ°ÐºÑŠÐ² Ñ€ÐµÐ´ ÑÐµÐ³Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(505627,14046,'ur','Ø§Ø´ÛŒØ§Ø¡ Ù†ÛÛŒÚº ØªØ±ØªÛŒØ¨ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ø¨ Ù‚Ø¯Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(505628,14046,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÑÑ‚Ð°Ð²ÐºÐµ Ð±ÐµÐ· Ð²Ð¾Ð´Ðµ ÑÐ°Ð´Ð° Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(505629,14046,'vi','áº¨n má»¥c khÃ´ng cÃ³ thá»© tá»± bÃ¢y giá» giÃ¡ trá»‹',0),(505630,14046,'af','Versteek Items met geen bestelling nou waarde',0),(505631,14046,'ro','Ascunde elementele cu nici o ordine acum valoarea',0),(505632,14046,'et','Peida Ã¼ksused pole, et nÃ¼Ã¼d vÃ¤Ã¤rtus',0),(505633,14046,'si','Skriti elementi s ne naloga zdaj vrednost',0),(505634,14046,'ba','Sembunyikan item dengan urutan sekarang nilai',0),(505635,14046,'nl','Verbergen van Items met geen orde nu waarde',0),(505636,14046,'fi','Piilottaa kohteita ei missÃ¤Ã¤n jÃ¤rjestyksessÃ¤ nyt arvon',0),(505637,14046,'no','Skjule elementer med ingen rekkefÃ¸lge nÃ¥ verdien',0),(505638,14046,'da','Skjule elementer med ingen ordre nu vÃ¦rdi',0),(505639,14046,'ko','í•­ëª© ìˆœì„œ ì—†ì´ ì§€ê¸ˆ ê°’ ìˆ¨ê¸°ê¸°',0),(505640,14046,'he','×”×¡×ª×¨ ×¤×¨×™×˜×™× ×¢× ××™×Ÿ ×¡×“×¨ ×¢×›×©×™×• ×¢×¨×š',0),(505641,14046,'el','Î‘Ï€Î¿ÎºÏÏÏˆÎµÏ„Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î¼Îµ ÎºÎ±Î¼Î¯Î± Î´Î¹Î±Ï„Î±Î³Î® Ï„ÏŽÏÎ± Î±Î¾Î¯Î±',0),(505642,14046,'zh','éšè—æ²¡æœ‰é¡ºåºçš„é¡¹ç›®çŽ°åœ¨å€¼',0),(505643,14046,'sv','DÃ¶lja objekt med nÃ¥gon ordning nu vÃ¤rde',0),(505644,14046,'it','Nascondere oggetti con nessun ordine ora valore',0),(505645,14046,'tl','',0),(505646,14046,'th','à¸‹à¹ˆà¸­à¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸à¸±à¸šà¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸•à¸­à¸™à¸™à¸µà¹‰à¸„à¹ˆà¸²',0),(505647,14046,'hi','à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤…à¤¬ à¤®à¤¾à¤¨ à¤›à¥à¤ªà¤¾à¤à¤',0),(505648,14046,'ms','Sembunyi item dengan tiada perintah sekarang nilai',0),(505649,14046,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ù…Ø¹ Ù„Ø§ Ø£Ù…Ø± Ø§Ù„Ø¢Ù† Ù‚ÙŠÙ…Ø©',0),(505650,14046,'fr','Masquer des Ã©lÃ©ments sans ordonnance maintenant valeur',0),(505651,14046,'jp','é …ç›®ã®é †åºç„¡ã—ã§ä»Šå€¤ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(505652,14046,'pt','Ocultar itens com nenhuma ordem agora valor',0),(505653,14046,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ñ Ð½Ðµ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ñ‚ÐµÐ¿ÐµÑ€ÑŒ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(505654,14046,'es','Ocultar elementos sin orden valor',0),(505655,14046,'de','Ausblenden von Elementen mit keiner Reihenfolge jetzt Wert',0),(505656,14046,'en','Hide Items With No Order Now Value',0),(505657,14047,'is','',0),(505658,14047,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¯ÙˆÙ† Ø§ÙˆÙ„ÛŒÙ† Ù‚Ø¨Ø¶ ÙˆØ±ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(505659,14047,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¯ÙˆÙ† Ø§ÙˆÙ„ÛŒÙ† Ù‚Ø¨Ø¶ ÙˆØ±ÙˆØ¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(505660,14047,'tr','Ä°lk giren fatura Ã¶demeyi girin',0),(505661,14047,'pl','WprowadÅº pÅ‚atnoÅ›ci bez pierwszego wprowadzania ustawy',0),(505662,14047,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð±ÐµÐ· Ð¿ÑŠÑ€Ð²Ð¾ Ð²Ð»Ð¸Ð·Ð°Ñ‚ Ð±Ð¸Ð»',0),(505663,14047,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø¯Ø§Ø®Ù„ ÛÙˆÙ†Û’ Ø¨Ù„ Ø¨ØºÛŒØ± Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(505664,14047,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð±ÐµÐ· Ð¿Ñ€Ð²Ð¸ ÑƒÐ»Ð°Ð·Ð¸ Ñƒ Ñ€Ð°Ñ‡ÑƒÐ½',0),(505665,14047,'vi','Nháº­p cÃ¡c thanh toÃ¡n mÃ  khÃ´ng cáº§n Ä‘áº§u tiÃªn vÃ o Bill',0),(505666,14047,'af','Tik betaling sonder eerste betree Wetsontwerp',0),(505667,14047,'ro','IntroduceÅ£i platÄƒ fÄƒrÄƒ prima lege intrÄƒ',0),(505668,14047,'et','Sisestage makse ilma esimest sisenemist Bill',0),(505669,14047,'si','Vnesite plaÄilo brez prvega vstopa Bill',0),(505670,14047,'ba','Masukkan pembayaran tanpa pertama memasuki Bill',0),(505671,14047,'nl','Betaling zonder eerste invoeren Bill invoeren',0),(505672,14047,'fi','Kirjoita maksun ilman ensimmÃ¤inen syÃ¶ttÃ¤minen lasku',0),(505673,14047,'no','Angi betaling uten fÃ¸rste inn Bill',0),(505674,14047,'da','Angive betaling uden fÃ¸rst at indtaste Bill',0),(505675,14047,'ko','ì²« ë²ˆì§¸ ìž…ë ¥ ë¹Œ ì—†ì´ ì§€ë¶ˆ ìž…ë ¥',0),(505676,14047,'he','×”×–×Ÿ ××ª ×”×ª×©×œ×•× ×œ×œ× ×”×–× ×ª ×”×¦×¢×ª ×”×—×•×§ ×”×¨××©×•× ×”',0),(505677,14047,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï€Î»Î·ÏÏ‰Î¼Î® Ï‡Ï‰ÏÎ¯Ï‚ Ï„Î·Î½ Ï€ÏÏŽÏ„Î· ÎµÎ¯ÏƒÎ¿Î´Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(505678,14047,'zh','è¾“å…¥ä»˜æ¬¾å¦‚æžœæ²¡æœ‰ç¬¬ä¸€æ¬¡è¿›å…¥æ¡ä¾‹è‰æ¡ˆ',0),(505679,14047,'sv','Ange utbetalning utan fÃ¶rsta inmatning faktura',0),(505680,14047,'it','Inserire il pagamento senza prima entrano nella fattura',0),(505681,14047,'tl','',0),(505682,14047,'th','à¸›à¹‰à¸­à¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹‚à¸”à¸¢à¹„à¸¡à¹ˆà¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸£à¸²à¸¢à¸à¸²à¸£à¹à¸£à¸',0),(505683,14047,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¹à¤²à¥‡ à¤¦à¤°à¥à¤œ à¤¬à¤¿à¤² à¤¬à¤¿à¤¨à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(505684,14047,'ms','Masukkan pembayaran tanpa pertama Rang undang-undang yang memasuki',0),(505685,14047,'ar','Ø£Ø¯Ø®Ù„ Ø§Ù„Ø¯ÙØ¹ Ø¯ÙˆÙ† Ø¨ÙŠÙ„ Ø¯Ø®ÙˆÙ„ Ø£ÙˆÙ„',0),(505686,14047,'fr','Entrez le paiement sans premiÃ¨re facture entrant',0),(505687,14047,'jp','æœ€åˆã®å…¥åŠ›è«‹æ±‚æ›¸ã›ãšæ”¯æ‰•ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(505688,14047,'pt','Digite pagamento sem Bill entrando no primeiro',0),(505689,14047,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð±ÐµÐ· Ð¿ÐµÑ€Ð²Ð¾Ð³Ð¾ Ð²Ð²Ð¾Ð´Ð° Ð‘Ð¸Ð»Ð»',0),(505690,14047,'es','Introduzca el pago sin Bill entrando en primera',0),(505691,14047,'de','Zahlung ohne erste Eingabe Rechnung eingeben',0),(505692,14047,'en','Enter Payment Without First Entering Bill',0),(505693,14048,'is','',0),(505694,14048,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‡ÛŒÚ†Ú©Ø¯Ø§Ù…',0),(505695,14048,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‡ÛŒÚ†Ú©Ø¯Ø§Ù…',0),(505696,14048,'tr','HiÃ§birini SeÃ§me',0),(505697,14048,'pl','Wybierz opcjÄ™ Brak',0),(505698,14048,'bg','ÐÐµ Ð˜Ð·Ð±Ð¸Ñ€Ð°Ð¹ Ð½Ð¸Ñ‰Ð¾',0),(505699,14048,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº',0),(505700,14048,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ Ð½Ð¸Ñ˜ÐµÐ´Ð½Ð¾',0),(505701,14048,'vi','Chá»n khÃ´ng',0),(505702,14048,'af','Kies geen',0),(505703,14048,'ro','Selectare vidÄƒ',0),(505704,14048,'et','Valige None',0),(505705,14048,'si','Izberite brez',0),(505706,14048,'ba','Pilih None',0),(505707,14048,'nl','Selecteer geen',0),(505708,14048,'fi','Valitse ei mitÃ¤Ã¤n',0),(505709,14048,'no','Velg ingen',0),(505710,14048,'da','VÃ¦lg ingen',0),(505711,14048,'ko','ì—†ìŒ ì„ íƒ',0),(505712,14048,'he','×‘×—×¨ ×‘××¤×©×¨×•×ª ×œ×œ×',0),(505713,14048,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ \"ÎºÎ±Î½Î­Î½Î±\"',0),(505714,14048,'zh','é€‰æ‹©æ— ',0),(505715,14048,'sv','VÃ¤lj ingen',0),(505716,14048,'it','Selezionare Nessuno',0),(505717,14048,'tl','',0),(505718,14048,'th','à¹€à¸¥à¸·à¸­à¸à¹„à¸¡à¹ˆà¸¡à¸µ',0),(505719,14048,'hi','à¤•à¥‹à¤ˆ à¤¨à¤¹à¥€à¤‚ à¤šà¥à¤¨à¥‡à¤‚',0),(505720,14048,'ms','Pilih tiada',0),(505721,14048,'ar','Ø­Ø¯Ø¯ Ø¨Ù„Ø§',0),(505722,14048,'fr','SÃ©lectionnez aucun',0),(505723,14048,'jp','[ãªã—] ã‚’é¸æŠžã—ã¾ã™',0),(505724,14048,'pt','Selecionar nenhum',0),(505725,14048,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐÐµÑ‚',0),(505726,14048,'es','No seleccionar ninguno',0),(505727,14048,'de','WÃ¤hlen Sie keine',0),(505728,14048,'en','Select None',0),(505729,14049,'is','',0),(505730,14049,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø¹Ù„Øª ØªØ§Ø±ÛŒØ® ÙØ§Ú©ØªÙˆØ±',0),(505731,14049,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø¹Ù„Øª ØªØ§Ø±ÛŒØ® ÙØ§Ú©ØªÙˆØ±',0),(505732,14049,'tr','Gelince hide fatura tarihi',0),(505733,14049,'pl','Ukryj odpowiednim datÄ™ faktury',0),(505734,14049,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¿Ð°Ð´ÐµÐ¶ Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(505735,14049,'ur','Ø­Ù‚ Ú©Ùˆ Ú†Ú¾Ù¾Ø§Ù†Û’ Ù¾Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(505736,14049,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(505737,14049,'vi','áº¨n do ngÃ y thÃ¡ng trÃªn hÃ³a Ä‘Æ¡n',0),(505738,14049,'af','Versteek verskuldigde datum op die faktuur',0),(505739,14049,'ro','Ascunde cuvenit data facturÄƒ',0),(505740,14049,'et','Peida nÃµuetekohase arve kuupÃ¤ev',0),(505741,14049,'si','Skriti zaradi datum na raÄunu',0),(505742,14049,'ba','Menyembunyikan Due tanggal faktur',0),(505743,14049,'nl','Verbergen Due datum op factuur',0),(505744,14049,'fi','Piilota erÃ¤pÃ¤ivÃ¤ laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(505745,14049,'no','Skjule grunn datoen pÃ¥ fakturaen',0),(505746,14049,'da','Skjule Due dato pÃ¥ fakturaen',0),(505747,14049,'ko','ìˆ¨ê¸°ê¸° ë•Œë¬¸ì— ì†¡ìž¥ ë‚ ì§œ',0),(505748,14049,'he','×œ×”×¡×ª×™×¨ ××ª ×™×¢×“ ×ª××¨×™×š ×‘×—×©×‘×•× ×™×ª',0),(505749,14049,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(505750,14049,'zh','éšè—é€‚å½“å‘ç¥¨æ—¥æœŸ',0),(505751,14049,'sv','DÃ¶lja vederbÃ¶rlig datum pÃ¥ fakturan',0),(505752,14049,'it','Nascondere il debito Data fattura',0),(505753,14049,'tl','',0),(505754,14049,'th','à¸‹à¹ˆà¸­à¸™à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™à¸—à¸µà¹ˆà¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(505755,14049,'hi','à¤¨à¤¿à¤¯à¤¤ à¤›à¥à¤ªà¤¾à¤à¤ à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¤° à¤¤à¤¾à¤°à¥€à¤–',0),(505756,14049,'ms','Sembunyi habis tempoh pada tarikh invois',0),(505757,14049,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„ÙˆØ§Ø¬Ø¨Ø© ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(505758,14049,'fr','Cacher Due Date sur la facture',0),(505759,14049,'jp','éžè¡¨ç¤ºæœŸé™ã®æ—¥ä»˜ã®è«‹æ±‚æ›¸ã‚’',0),(505760,14049,'pt','Esconder a devida Data na factura',0),(505761,14049,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÐ²Ð¾Ðµ Ð”Ð°Ñ‚Ð° Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(505762,14049,'es','Ocultar debida fecha de factura',0),(505763,14049,'de','Ausblenden Due Date auf Rechnung',0),(505764,14049,'en','Hide Due Date On Invoice',0),(505765,14050,'is','',0),(505766,14050,'dr','Authorize.net CIM',0),(505767,14050,'pr','Authorize.net CIM',0),(505768,14050,'tr','Authorize.NET CIM',0),(505769,14050,'pl','Authorize.net CIM',0),(505770,14050,'bg','Authorize.net CIM',0),(505771,14050,'ur','Authorize.net Ú©Ù…',0),(505772,14050,'sr','Authorize.NET Ð¦Ð˜Ðœ',0),(505773,14050,'vi','Authorize.net CIM',0),(505774,14050,'af','Authorize.net CIM',0),(505775,14050,'ro','Authorize.net CIM',0),(505776,14050,'et','Authorize.net CIM',0),(505777,14050,'si','Authorize.net CIM',0),(505778,14050,'ba','Authorize.net CIM',0),(505779,14050,'nl','Authorize.net CIM',0),(505780,14050,'fi','Authorize.net CIM',0),(505781,14050,'no','Authorize.net CIM',0),(505782,14050,'da','Authorize.net CIM',0),(505783,14050,'ko','Authorize.net CIM',0),(505784,14050,'he','Authorize.net CIM',0),(505785,14050,'el','Authorize.net CIM',0),(505786,14050,'zh','Authorize.net CIM',0),(505787,14050,'sv','Authorize.net CIM',0),(505788,14050,'it','Authorize.NET CIM',0),(505789,14050,'tl','',0),(505790,14050,'th','à¹€à¸«à¸¥à¸·à¸­à¸‡ Authorize.net',0),(505791,14050,'hi','Authorize.net CIM',0),(505792,14050,'ms','Authorize.net CIM',0),(505793,14050,'ar','Authorize.net CIM',0),(505794,14050,'fr','Authorize.net CIM',0),(505795,14050,'jp','Authorize.net CIM',0),(505796,14050,'pt','Authorize.net CIM',0),(505797,14050,'ru','Authorize.NET CIM',0),(505798,14050,'es','Authorize.net CIM',0),(505799,14050,'de','Authorize.net CIM',0),(505800,14050,'en','Authorize.net CIM',0),(505801,14051,'is','',0),(505802,14051,'dr','Authorize.net Ú©Ù„ÛŒØ¯ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø±Ø§ Ù¾ÛŒØ¯Ø§ Ú©Ù†Ø¯',0),(505803,14051,'pr','Authorize.net Ú©Ù„ÛŒØ¯ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø±Ø§ Ù¾ÛŒØ¯Ø§ Ú©Ù†Ø¯',0),(505804,14051,'tr','Authorize.NET hareket anahtar bulunamadÄ±',0),(505805,14051,'pl','Nie moÅ¼na odnaleÅºÄ‡ transakcji Authorize.net klucz',0),(505806,14051,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Authorize.net Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ ÐºÐ»ÑŽÑ‡',0),(505807,14051,'ur','Authorize.net Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Ù„ÛŒØ¯ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§',0),(505808,14051,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Authorize.net Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐºÑ™ÑƒÑ‡',0),(505809,14051,'vi','KhÃ´ng thá»ƒ tÃ¬m tháº¥y Authorize.net giao dá»‹ch Key',0),(505810,14051,'af','Kon Authorize.net transaksie sleutel vind nie',0),(505811,14051,'ro','Nu am putut gÄƒsi cheia de tranzacÅ£ie Authorize.net',0),(505812,14051,'et','Ei leia Authorize.net tehingu vÃµti',0),(505813,14051,'si','Authorize.net transakcije kljuÄa ni bilo mogoÄe najti.',0),(505814,14051,'ba','Tidak dapat menemukan Authorize.net transaksi kunci',0),(505815,14051,'nl','Konden niet vondst Authorize.net transactie sleutel',0),(505816,14051,'fi','Ei lÃ¶ytÃ¤nyt Authorize.net tapahtuman avain',0),(505817,14051,'no','Finner ikke Authorize.net transaksjonsnÃ¸kkel',0),(505818,14051,'da','Kunne ikke finde Authorize.net transaktionsnÃ¸gle',0),(505819,14051,'ko','Authorize.net íŠ¸ëžœìž­ì…˜ í‚¤ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(505820,14051,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×”×ž×¤×ª×— ×¢×¡×§×ª Authorize.net',0),(505821,14051,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Authorize.net ÏƒÏ…Î½Î±Î»Î»Î±Î³Î® ÎºÎ»ÎµÎ¹Î´Î¯',0),(505822,14051,'zh','æ‰¾ä¸åˆ° Authorize.net äº¤æ˜“çš„å…³é”®',0),(505823,14051,'sv','Kunde inte hitta Authorize.net transaktionsnyckel',0),(505824,14051,'it','Non poteva trovare Authorize.net transazione chiave',0),(505825,14051,'tl','',0),(505826,14051,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸„à¸µà¸¢à¹Œà¸˜à¸¸à¸£à¸à¸£à¸£à¸¡ Authorize.net',0),(505827,14051,'hi','Authorize.net à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤•à¥à¤‚à¤œà¥€ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(505828,14051,'ms','Tidak dapat mencari Authorize.net urus niaga utama',0),(505829,14051,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…ÙØªØ§Ø­ Ø§Ù„Ø­Ø±ÙƒØ© Authorize.net',0),(505830,14051,'fr','N\'a pas trouvÃ© la clÃ© de Transaction Authorize.net',0),(505831,14051,'jp','Authorize.net ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ãƒ» ã‚­ãƒ¼ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(505832,14051,'pt','NÃ£o conseguia encontrar a chave de transaÃ§Ã£o Authorize.net',0),(505833,14051,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ ÐºÐ»ÑŽÑ‡ Authorize.net Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹',0),(505834,14051,'es','No pudo encontrar la llave de transacciÃ³n Authorize.net',0),(505835,14051,'de','VorgangsschlÃ¼ssel Authorize.net konnte nicht gefunden werden.',0),(505836,14051,'en','Could Not Find Authorize.net Transaction Key',0),(505837,14052,'is','',0),(505838,14052,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ØªØµØ§Ù„ Ø¨Ù‡ Authorize.net',0),(505839,14052,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ØªØµØ§Ù„ Ø¨Ù‡ Authorize.net',0),(505840,14052,'tr','Authorize.NET iÃ§in baÄŸlanÄ±rken hata oluÅŸtu',0),(505841,14052,'pl','BÅ‚Ä…d podczas Å‚Ä…czenia z Authorize.net',0),(505842,14052,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÐ²ÑŠÑ€Ð·Ð²Ð°Ð½Ðµ ÐºÑŠÐ¼ Authorize.net',0),(505843,14052,'ur','Ù†Ù‚Øµ Authorize.net Ø³Û’ Ø¬Ú‘ Ø±ÛØ§ ÛÛ’',0),(505844,14052,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÑƒ ÑÐ° Authorize.net',0),(505845,14052,'vi','Lá»—i káº¿t ná»‘i vá»›i Authorize.net',0),(505846,14052,'af','Fout verbind Authorize.net',0),(505847,14052,'ro','Eroare de conectare la Authorize.net',0),(505848,14052,'et','Viga Ã¼hendamisel Authorize.net',0),(505849,14052,'si','Napake pri povezovanju s Authorize.net',0),(505850,14052,'ba','Galat yang menghubungkan ke Authorize.net',0),(505851,14052,'nl','Error Connecting To Authorize.net',0),(505852,14052,'fi','Virhe muodostettaessa yhteyttÃ¤ Authorize.net',0),(505853,14052,'no','Feil under tilkobling til Authorize.net',0),(505854,14052,'da','Fejl tilslutning til Authorize.net',0),(505855,14052,'ko','Authorize.netì— ì—°ê²° ì˜¤ë¥˜',0),(505856,14052,'he','×©×’×™××” ×‘×”×ª×—×‘×¨×•×ª Authorize.net',0),(505857,14052,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î· ÏƒÏÎ½Î´ÎµÏƒÎ· ÏƒÎµ Authorize.net',0),(505858,14052,'zh','è¿žæŽ¥åˆ° Authorize.net æ—¶å‡ºé”™',0),(505859,14052,'sv','Fel vid anslutning till Authorize.net',0),(505860,14052,'it','Errore durante la connessione al Authorize.net',0),(505861,14052,'tl','',0),(505862,14052,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¸à¸±à¸š Authorize.net',0),(505863,14052,'hi','Authorize.net à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¨à¥‡à¤•à¥à¤Ÿ à¤¹à¥‹à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(505864,14052,'ms','Ralat sambungan ke Authorize.net',0),(505865,14052,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ù„Ø§ØªØµØ§Ù„ Ø¥Ù„Ù‰ Authorize.net',0),(505866,14052,'fr','Erreur de connexion Ã  Authorize.net',0),(505867,14052,'jp','Authorize.net ã¸ã®æŽ¥ç¶šã‚¨ãƒ©ãƒ¼',0),(505868,14052,'pt','Erro ao conectar a Authorize.net',0),(505869,14052,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð´ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ð¸ Ðº Authorize.net',0),(505870,14052,'es','Error al conectarse Authorize.net',0),(505871,14052,'de','Fehler bei Verbindung mit Authorize.net',0),(505872,14052,'en','Error Connecting To Authorize.net',0),(505873,14053,'is','',0),(505874,14053,'dr','Ù‡ÛŒÚ† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(505875,14053,'pr','Ù‡ÛŒÚ† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(505876,14053,'tr','HiÃ§bir mÃ¼ÅŸteri kimliÄŸi kÃ¼mesi',0),(505877,14053,'pl','Nie zestaw ID klienta',0),(505878,14053,'bg','ÐÑÐ¼Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ ID Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸',0),(505879,14053,'ur','Ú©ÙˆØ¦ÛŒ Ú¯Ø§ÛÚ© ID Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(505880,14053,'sr','ÐÐµÐ¼Ð° Ð¡ÐµÑ‚ Ð˜Ð” ÐºÑƒÐ¿Ñ†Ð°',0),(505881,14053,'vi','KhÃ´ng cÃ³ thiáº¿t láº­p ID khÃ¡ch hÃ ng',0),(505882,14053,'af','Geen kliÃ«nt ID stel',0),(505883,14053,'ro','Nici un Set de ID client',0),(505884,14053,'et','Pole kliendi ID komplekt',0),(505885,14053,'si','Ni nastavljenega ID kupca',0),(505886,14053,'ba','No Set ID pelanggan',0),(505887,14053,'nl','Geen klant ID Set',0),(505888,14053,'fi','Ei asiakkaan tunnus asetettu',0),(505889,14053,'no','Ingen kunde ID sett',0),(505890,14053,'da','Ingen kunde-ID angivet',0),(505891,14053,'ko','ê³ ê° ID ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(505892,14053,'he','×œ× ×”×•×’×“×¨×• ×ž×–×”×” ×”×œ×§×•×—',0),(505893,14053,'el','ÎšÎ±Î½Î­Î½Î± ÏƒÏÎ½Î¿Î»Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(505894,14053,'zh','æ²¡æœ‰å®¢æˆ· ID è®¾ç½®',0),(505895,14053,'sv','Ingen kund-ID Set',0),(505896,14053,'it','Nessun Set di ID cliente',0),(505897,14053,'tl','',0),(505898,14053,'th','à¹„à¸¡à¹ˆà¸Šà¸¸à¸” ID à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(505899,14053,'hi','à¤•à¥‹à¤ˆ à¤—à¥à¤°à¤¾à¤¹à¤• ID à¤¸à¥‡à¤Ÿ',0),(505900,14053,'ms','Set ID pelanggan tidak',0),(505901,14053,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ø¹Ø±Ù Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(505902,14053,'fr','Aucun ensemble d\'ID de client',0),(505903,14053,'jp','é¡§å®¢ ID ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(505904,14053,'pt','Nenhum conjunto de ID do cliente',0),(505905,14053,'ru','ÐÐµ Ð½Ð°Ð±Ð¾Ñ€ ID ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(505906,14053,'es','NingÃºn conjunto de ID de cliente',0),(505907,14053,'de','Keine Kunden-ID-Set',0),(505908,14053,'en','No Customer ID Set',0),(505909,14054,'is','',0),(505910,14054,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø­Ø³Ø§Ø¨ Ù„Ø·ÙØ§',0),(505911,14054,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø­Ø³Ø§Ø¨ Ù„Ø·ÙØ§',0),(505912,14054,'tr','Hesap Kurulumu kontrol edin',0),(505913,14054,'pl','ProszÄ™ sprawdziÄ‡ ustawienia konta',0),(505914,14054,'bg','ÐœÐ¾Ð»Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°Ñ‚Ð° Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(505915,14054,'ur','Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ Ø§Ù¾',0),(505916,14054,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(505917,14054,'vi','Vui lÃ²ng kiá»ƒm tra thiáº¿t láº­p tÃ i khoáº£n',0),(505918,14054,'af','Kontroleer asseblief rekening opstelling',0),(505919,14054,'ro','VÄƒ rugÄƒm sÄƒ verificaÅ£i configurarea contului',0),(505920,14054,'et','Kontrollige konto seadistamine',0),(505921,14054,'si','Preverite nastavitev raÄuna',0),(505922,14054,'ba','Periksa pengaturan Account',0),(505923,14054,'nl','Controleer Account Setup',0),(505924,14054,'fi','Tarkista tilin asetukset',0),(505925,14054,'no','Kontroller kontooppsett',0),(505926,14054,'da','Tjek venligst kontoopsÃ¦tning',0),(505927,14054,'ko','ê³„ì • ì„¤ì • í™•ì¸ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(505928,14054,'he','×‘×“×•×§ ××ª ×”×’×“×¨×ª ×—×©×‘×•×Ÿ',0),(505929,14054,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÎµÎ»Î­Î³Î¾ÎµÏ„Îµ ÏÏÎ¸Î¼Î¹ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(505930,14054,'zh','è¯·æ£€æŸ¥å¸æˆ·çš„è®¾ç½®',0),(505931,14054,'sv','VÃ¤nligen kontrollera kontoinstÃ¤llningarna',0),(505932,14054,'it','Per favore verifica configurazione Account',0),(505933,14054,'tl','',0),(505934,14054,'th','à¸à¸£à¸¸à¸“à¸²à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸±à¸à¸Šà¸µ',0),(505935,14054,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(505936,14054,'ms','Sila semak persediaan akaun',0),(505937,14054,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(505938,14054,'fr','Veuillez vÃ©rifier la configuration du compte',0),(505939,14054,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã‚’ç¢ºèªã—ã¦ãã ã•ã„',0),(505940,14054,'pt','Por favor, verifique a configuraÃ§Ã£o de conta',0),(505941,14054,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¿Ñ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(505942,14054,'es','Por favor comprueba la configuraciÃ³n de la cuenta',0),(505943,14054,'de','ÃœberprÃ¼fen Sie die Kontoeinrichtung',0),(505944,14054,'en','Please Check Account Setup',0),(505945,14055,'is','',0),(505946,14055,'dr','Ø§ÙØ²ÙˆØ¯Ù†/ÙˆÛŒØ±Ø§ÛŒØ´ Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡ Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(505947,14055,'pr','Ø§ÙØ²ÙˆØ¯Ù†/ÙˆÛŒØ±Ø§ÛŒØ´ Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡ Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(505948,14055,'tr','SaklÄ± kredi kartlarÄ± Ekle/DÃ¼zenle',0),(505949,14055,'pl','Dodaj/Edytuj przechowywane karty kredytowe',0),(505950,14055,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(505951,14055,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ¯ÙˆÛŒÙ† Ø°Ø®ÛŒØ±Û',0),(505952,14055,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑƒÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚ÐµÐ½Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(505953,14055,'vi','ThÃªm/chá»‰nh sá»­a tháº» tÃ­n dá»¥ng Ä‘Æ°á»£c lÆ°u trá»¯',0),(505954,14055,'af','Voeg programme by/redigeer gestoorde kredietkaarte',0),(505955,14055,'ro','AdÄƒugare/Editare stocate carduri de Credit',0),(505956,14055,'et','Lisa/Muuda talletatud krediitkaardid',0),(505957,14055,'si','Dodaj/Uredi shranjeni kreditne kartice',0),(505958,14055,'ba','Menambah/mengedit disimpan kartu kredit',0),(505959,14055,'nl','Opgeslagen creditcards toevoegen/bewerken',0),(505960,14055,'fi','LisÃ¤Ã¤ tai Muokkaa tallennettuja luottokortit',0),(505961,14055,'no','Legg til/Rediger lagret kredittkort',0),(505962,14055,'da','TilfÃ¸j/Rediger gemte kreditkort',0),(505963,14055,'ko','ì €ìž¥ ëœ ì‹ ìš© ì¹´ë“œ ì¶”ê°€/íŽ¸ì§‘',0),(505964,14055,'he','×”×•×¡×¤×”/×¢×¨×™×›×” ×©×œ ×›×¨×˜×™×¡×™ ××©×¨××™ ×ž××•×—×¡×Ÿ',0),(505965,14055,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Î¼Î­Î½ÎµÏ‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(505966,14055,'zh','æ·»åŠ ç¼–è¾‘å­˜å‚¨çš„ä¿¡ç”¨å¡',0),(505967,14055,'sv','LÃ¤gg till/redigera lagras kreditkort',0),(505968,14055,'it','Aggiungi/modifica carte di credito memorizzati',0),(505969,14055,'tl','',0),(505970,14055,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¹€à¸à¹‡à¸šà¹„à¸§à¹‰',0),(505971,14055,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹à¤¿à¤¤ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(505972,14055,'ms','Tambah/Edit kad-kad kredit yang disimpan',0),(505973,14055,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø±ÙŠØ± ØªØ®Ø²ÙŠÙ† Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(505974,14055,'fr','Ajouter/modifier les cartes de crÃ©dit stockÃ©e',0),(505975,14055,'jp','ä¿å­˜æ¸ˆã¿ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è¿½åŠ /ç·¨é›†',0),(505976,14055,'pt','Adicionar/editar cartÃµes de crÃ©dito armazenados',0),(505977,14055,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ…Ñ€Ð°Ð½ÑÑ‚ÑÑ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(505978,14055,'es','AÃ±adir/Editar Tarjeta de credito',0),(505979,14055,'de','Gespeicherte Kreditkarten hinzufÃ¼gen/bearbeiten',0),(505980,14055,'en','Add/Edit Stored Credit Cards',0),(505981,14056,'is','',0),(505982,14056,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡',0),(505983,14056,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡',0),(505984,14056,'tr','SaklÄ± kartÄ± kullanÄ±n',0),(505985,14056,'pl','UÅ¼yj karty przechowywane',0),(505986,14056,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÑÑŠÑ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ‚Ðµ ÐºÐ°Ñ€Ñ‚Ð°',0),(505987,14056,'ur','Ø°Ø®ÛŒØ±Û Ø´Ø¯Û Ú©Ø§Ø±Úˆ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(505988,14056,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑƒÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚ÐµÐ½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(505989,14056,'vi','Sá»­ dá»¥ng tháº» lÆ°u trá»¯',0),(505990,14056,'af','Gestoorde kaart gebruik',0),(505991,14056,'ro','Cardul stocate',0),(505992,14056,'et','Salvestatud kaarti kasutada',0),(505993,14056,'si','Uporabite shranjena kartica',0),(505994,14056,'ba','Menggunakan kartu disimpan',0),(505995,14056,'nl','Gebruik opgeslagen kaart',0),(505996,14056,'fi','KÃ¤ytÃ¤ tallennettuja kortti',0),(505997,14056,'no','Bruk lagrede kort',0),(505998,14056,'da','Bruge lagrede kort',0),(505999,14056,'ko','ì €ìž¥ëœ ì¹´ë“œë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(506000,14056,'he','×”×©×ª×ž×© ×‘×›×¨×˜×™×¡ ×ž××•×—×¡× ×ª',0),(506001,14056,'el','Î§ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Î¼Î­Î½Ï‰Î½ ÎºÎ¬ÏÏ„Î±',0),(506002,14056,'zh','ä½¿ç”¨å­˜å‚¨çš„å¡',0),(506003,14056,'sv','AnvÃ¤nda lagrade kort',0),(506004,14056,'it','Utilizzare carta memorizzato',0),(506005,14056,'tl','',0),(506006,14056,'th','à¹ƒà¸Šà¹‰à¸à¸²à¸£à¹Œà¸”à¹€à¸à¹‡à¸šà¹„à¸§à¹‰',0),(506007,14056,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹à¤¿à¤¤ à¤•à¤¾à¤°à¥à¤¡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(506008,14056,'ms','Menggunakan Kad yang disimpan',0),(506009,14056,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ù…Ø®Ø²Ù†',0),(506010,14056,'fr','Utiliser la carte stockÃ©e',0),(506011,14056,'jp','ã‚¹ãƒˆã‚¢ãƒ‰ã®ã‚«ãƒ¼ãƒ‰ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(506012,14056,'pt','Usar cartÃ£o armazenado',0),(506013,14056,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(506014,14056,'es','Uso de la tarjeta almacenados',0),(506015,14056,'de','Verwenden Sie gespeicherte Karte',0),(506016,14056,'en','Use Stored Card',0),(506017,14057,'is','',0),(506018,14057,'dr','ØªØ±Ø§Ø² Ø¨Ù‡ Ù…Ø±Ú©Ø²',0),(506019,14057,'pr','ØªØ±Ø§Ø² Ø¨Ù‡ Ù…Ø±Ú©Ø²',0),(506020,14057,'tr','Ortaya Hizala',0),(506021,14057,'pl','Wyjustuj do Å›rodka',0),(506022,14057,'bg','ÐŸÐ¾Ð´Ñ€Ð°Ð²Ð½Ð¸ Ð² ÑÑ€ÐµÐ´Ð°Ñ‚Ð° Ñ†ÐµÐ½Ñ‚Ñ€Ð¸Ñ€Ð°Ð½Ð¾',0),(506023,14057,'ur','Ø¨Ù…Ø±Ú©Ø² Ø³ÛŒØ¯Ú¾ Ú©Ø±ÛŒÚº',0),(506024,14057,'sr','ÐŸÐ¾Ñ€Ð°Ð²Ð½Ð°Ñ˜ Ñƒ Ñ†ÐµÐ½Ñ‚Ñ€Ñƒ',0),(506025,14057,'vi','CÄƒn Trung tÃ¢m',0),(506026,14057,'af','Sentrum Belyn',0),(506027,14057,'ro','Aliniere la centru',0),(506028,14057,'et','Joonda keskele',0),(506029,14057,'si','Poravnaj na sredino',0),(506030,14057,'ba','Align Pusat',0),(506031,14057,'nl','Centreren',0),(506032,14057,'fi','Tasaa keskelle',0),(506033,14057,'no','Midtstill',0),(506034,14057,'da','Juster centreret',0),(506035,14057,'ko','ì„¼í„° ì •ë ¬',0),(506036,14057,'he','×™×©×¨ ×œ×ž×¨×›×–',0),(506037,14057,'el','Î Î»Î®ÏÎ·Ï‚ ÏƒÏ„Î¿Î¯Ï‡Î¹ÏƒÎ· ÏƒÏ„Î¿ ÎºÎ­Î½Ï„ÏÎ¿',0),(506038,14057,'zh','å±…ä¸­å¯¹é½',0),(506039,14057,'sv','Centrera',0),(506040,14057,'it','Allineare il centro',0),(506041,14057,'tl','',0),(506042,14057,'th','à¸ˆà¸±à¸”à¸à¸¶à¹ˆà¸‡à¸à¸¥à¸²à¸‡',0),(506043,14057,'hi','à¤®à¤§à¥à¤¯ à¤¸à¤‚à¤°à¥‡à¤–à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(506044,14057,'ms','Menyelaraskan Pusat',0),(506045,14057,'ar','Ù…Ø­Ø§Ø°Ø§Ø© Ù„Ù„ÙˆØ³Ø·',0),(506046,14057,'fr','Centrer',0),(506047,14057,'jp','ä¸­å¤®ã‚’æƒãˆ',0),(506048,14057,'pt','Alinhar Centro',0),(506049,14057,'ru','Ð’Ñ‹Ñ€Ð¾Ð²Ð½ÑÑ‚ÑŒ Ð¿Ð¾ Ñ†ÐµÐ½Ñ‚Ñ€Ñƒ',0),(506050,14057,'es','Alinee el centro',0),(506051,14057,'de','Align Center',0),(506052,14057,'en','Align Center',0),(506053,14058,'is','',0),(506054,14058,'dr','ØªØ±Ø§Ø² Ø¨Ù‡ Ú†Ù¾',0),(506055,14058,'pr','ØªØ±Ø§Ø² Ø¨Ù‡ Ú†Ù¾',0),(506056,14058,'tr','Sola Hizala',0),(506057,14058,'pl','WyrÃ³wnaj do lewej',0),(506058,14058,'bg','ÐŸÐ¾Ð´Ñ€Ð°Ð²Ð½Ð¸ Ð¾Ñ‚Ð»ÑÐ²Ð¾',0),(506059,14058,'ur','Ø¨Ø§Ø¦ÛŒÚº Ø³ÛŒØ¯Ú¾ Ú©Ø±ÛŒÚº',0),(506060,14058,'sr','ÐŸÐ¾Ñ€Ð°Ð²Ð½Ð°Ñ˜ Ð»ÐµÐ²Ð¾',0),(506061,14058,'vi','CÄƒn trÃ¡i',0),(506062,14058,'af','Rig links',0),(506063,14058,'ro','Aliniere la stÃ¢nga',0),(506064,14058,'et','Joonda vasakule',0),(506065,14058,'si','Poravnaj levo',0),(506066,14058,'ba','Rata kiri',0),(506067,14058,'nl','Links uitlijnen',0),(506068,14058,'fi','Tasaa vasemmalle',0),(506069,14058,'no','Venstrejuster',0),(506070,14058,'da','Juster venstre',0),(506071,14058,'ko','ì™¼ìª½ ì •ë ¬',0),(506072,14058,'he','×œ×™×™×©×¨ ×©×ž××œ×”',0),(506073,14058,'el','Î£Ï„Î¿Î¯Ï‡Î¹ÏƒÎ· Î±ÏÎ¹ÏƒÏ„ÎµÏÎ¬',0),(506074,14058,'zh','å·¦å¯¹é½',0),(506075,14058,'sv','VÃ¤nsterjustera',0),(506076,14058,'it','Allinea a sinistra',0),(506077,14058,'tl','',0),(506078,14058,'th','à¸ˆà¸±à¸”à¸Šà¸´à¸”à¸‹à¹‰à¸²à¸¢',0),(506079,14058,'hi','à¤¬à¤¾à¤à¤ à¤¸à¤‚à¤°à¥‡à¤–à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(506080,14058,'ms','Santak kiri',0),(506081,14058,'ar','Ù…Ø­Ø§Ø°Ø§Ø© Ø¥Ù„Ù‰ Ø§Ù„ÙŠØ³Ø§Ø±',0),(506082,14058,'fr','Aligner Ã  gauche',0),(506083,14058,'jp','å·¦ã‚’æƒãˆ',0),(506084,14058,'pt','Alinhar Ã  esquerda',0),(506085,14058,'ru','Ð’Ñ‹Ñ€Ð¾Ð²Ð½ÑÑ‚ÑŒ Ð¿Ð¾ Ð»ÐµÐ²Ð¾Ð¼Ñƒ ÐºÑ€Ð°ÑŽ',0),(506086,14058,'es','Alinear izquierda',0),(506087,14058,'de','LinksbÃ¼ndig',0),(506088,14058,'en','Align Left',0),(506089,14059,'is','',0),(506090,14059,'dr','ØªØ±Ø§Ø² Ø¨Ù‡ Ø±Ø§Ø³Øª',0),(506091,14059,'pr','ØªØ±Ø§Ø² Ø¨Ù‡ Ø±Ø§Ø³Øª',0),(506092,14059,'tr','SaÄŸa Hizala',0),(506093,14059,'pl','WyrÃ³wnaj do prawej',0),(506094,14059,'bg','ÐŸÐ¾Ð´Ñ€Ð°Ð²Ð½Ð¸ Ð¾Ñ‚Ð´ÑÑÐ½Ð¾',0),(506095,14059,'ur','Ø¯Ø§Ø¦ÛŒÚº Ø·Ø±Ù Ø¬Ú¾Ú©Ø§Ø¦ÙŠÚº',0),(506096,14059,'sr','ÐŸÐ¾Ñ€Ð°Ð²Ð½Ð°Ñ˜ Ð´ÐµÑÐ½Ð¾',0),(506097,14059,'vi','Canh pháº£i',0),(506098,14059,'af','Rig regs',0),(506099,14059,'ro','Aliniere la dreapta',0),(506100,14059,'et','Joonda paremale',0),(506101,14059,'si','Poravnaj desno',0),(506102,14059,'ba','Rata kanan',0),(506103,14059,'nl','Rechts uitlijnen',0),(506104,14059,'fi','Tasaa oikealle',0),(506105,14059,'no','Juster hÃ¸yre',0),(506106,14059,'da','Juster til hÃ¸jre',0),(506107,14059,'ko','ì˜¤ë¥¸ìª½ ì •ë ¬',0),(506108,14059,'he','×™×©×¨ ×œ×™×ž×™×Ÿ',0),(506109,14059,'el','Î£Ï„Î¿Î¯Ï‡Î¹ÏƒÎ· Î´ÎµÎ¾Î¹Î¬',0),(506110,14059,'zh','å³å¯¹é½',0),(506111,14059,'sv','HÃ¶gerjustera',0),(506112,14059,'it','Allinea a destra',0),(506113,14059,'tl','',0),(506114,14059,'th','à¸ˆà¸±à¸”à¸Šà¸´à¸”à¸‚à¸§à¸²',0),(506115,14059,'hi','à¤¦à¤¾à¤à¤ à¤¸à¤‚à¤°à¥‡à¤–à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(506116,14059,'ms','Menyelaraskan hak',0),(506117,14059,'ar','Ù…Ø­Ø§Ø°Ø§Ø© Ø¥Ù„Ù‰ Ø§Ù„ÙŠÙ…ÙŠÙ†',0),(506118,14059,'fr','Aligner Ã  droite',0),(506119,14059,'jp','å³ã‚’æƒãˆ',0),(506120,14059,'pt','Alinhar a direita',0),(506121,14059,'ru','Ð’Ñ‹Ñ€Ð¾Ð²Ð½ÑÑ‚ÑŒ Ð¿Ð¾ Ð¿Ñ€Ð°Ð²Ð¾Ð¼Ñƒ ÐºÑ€Ð°ÑŽ',0),(506122,14059,'es','Alinear derecha',0),(506123,14059,'de','RechtsbÃ¼ndig',0),(506124,14059,'en','Align Right',0),(506125,14060,'is','',0),(506126,14060,'dr','ØªÙˆÙ¾Ø±',0),(506127,14060,'pr','ØªÙˆÙ¾Ø±',0),(506128,14060,'tr','KalÄ±n',0),(506129,14060,'pl','Pogrubienie',0),(506130,14060,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÑ€',0),(506131,14060,'ur','Ù†ÚˆØ±',0),(506132,14060,'sr','ÐŸÐ¾Ð´ÐµÐ±Ñ™Ð°Ð½Ð¸ Ñ‚ÐµÐºÑÑ‚',0),(506133,14060,'vi','Äáº­m',0),(506134,14060,'af','Vetdruk',0),(506135,14060,'ro','Bold',0),(506136,14060,'et','Paks kiri',0),(506137,14060,'si','Krepko',0),(506138,14060,'ba','Bold',0),(506139,14060,'nl','Vet',0),(506140,14060,'fi','Lihavointi',0),(506141,14060,'no','Fet',0),(506142,14060,'da','Fed',0),(506143,14060,'ko','êµµê²Œ',0),(506144,14060,'he','×ž×•×“×’×©',0),(506145,14060,'el','Î¤Î¿Î»Î¼Î·ÏÎ®',0),(506146,14060,'zh','ç²—ä½“',0),(506147,14060,'sv','Fet',0),(506148,14060,'it','Grassetto',0),(506149,14060,'tl','',0),(506150,14060,'th','à¸•à¸±à¸§à¸«à¸™à¸²',0),(506151,14060,'hi','à¤¬à¥‹à¤²à¥à¤¡',0),(506152,14060,'ms','Tebal',0),(506153,14060,'ar','ØºØ§Ù…Ù‚',0),(506154,14060,'fr','\"BOLD\"',0),(506155,14060,'jp','å¤ªå­—',0),(506156,14060,'pt','Bold (realce)',0),(506157,14060,'ru','Ð–Ð¸Ñ€Ð½Ñ‹Ð¹',0),(506158,14060,'es','Negrita',0),(506159,14060,'de','KÃ¼hn',0),(506160,14060,'en','Bold',0),(506161,14061,'is','',0),(506162,14061,'dr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙÙˆÙ†Øª',0),(506163,14061,'pr','Ø§Ù†Ø¯Ø§Ø²Ù‡ ÙÙˆÙ†Øª',0),(506164,14061,'tr','YazÄ± tipi boyutu',0),(506165,14061,'pl','Rozmiar czcionki',0),(506166,14061,'bg','Ð Ð°Ð·Ð¼ÐµÑ€ Ð½Ð° ÑˆÑ€Ð¸Ñ„Ñ‚Ð°',0),(506167,14061,'ur','ÙØ§Ù†Ù¹ Ø³Ø§Ø¦Ø²',0),(506168,14061,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ñ„Ð¾Ð½Ñ‚Ð°',0),(506169,14061,'vi','KÃ­ch thÆ°á»›c phÃ´ng chá»¯',0),(506170,14061,'af','Fontgrootte',0),(506171,14061,'ro','Dimensiunea fontului',0),(506172,14061,'et','Fondi suurus',0),(506173,14061,'si','Velikost pisave',0),(506174,14061,'ba','Ukuran font',0),(506175,14061,'nl','Tekengrootte',0),(506176,14061,'fi','Fonttikoko',0),(506177,14061,'no','SkriftstÃ¸rrelse',0),(506178,14061,'da','SkriftstÃ¸rrelse',0),(506179,14061,'ko','ê¸€ê¼´ í¬ê¸°',0),(506180,14061,'he','×’×•×“×œ ×’×•×¤×Ÿ',0),(506181,14061,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Î³ÏÎ±Î¼Î¼Î±Ï„Î¿ÏƒÎµÎ¹ÏÎ¬Ï‚',0),(506182,14061,'zh','å­—ä½“å¤§å°',0),(506183,14061,'sv','Teckenstorlek',0),(506184,14061,'it','Dimensione carattere',0),(506185,14061,'tl','',0),(506186,14061,'th','à¸‚à¸™à¸²à¸”à¹à¸šà¸šà¸­à¸±à¸à¸©à¸£',0),(506187,14061,'hi','à¤«à¤¼à¥‰à¤¨à¥à¤Ÿ à¤•à¤¾ à¤†à¤•à¤¾à¤°',0),(506188,14061,'ms','Saiz fon',0),(506189,14061,'ar','Ø­Ø¬Ù… Ø§Ù„Ø®Ø·',0),(506190,14061,'fr','Taille de police',0),(506191,14061,'jp','ãƒ•ã‚©ãƒ³ãƒˆ ã‚µã‚¤ã‚º',0),(506192,14061,'pt','Tamanho da fonte',0),(506193,14061,'ru','Ð Ð°Ð·Ð¼ÐµÑ€ ÑˆÑ€Ð¸Ñ„Ñ‚Ð°',0),(506194,14061,'es','TamaÃ±o de la fuente',0),(506195,14061,'de','SchriftgrÃ¶ÃŸe',0),(506196,14061,'en','Font Size',0),(506197,14062,'is','',0),(506198,14062,'dr','Ú©Ø¬',0),(506199,14062,'pr','Ú©Ø¬',0),(506200,14062,'tr','Ä°talik',0),(506201,14062,'pl','Kursywa',0),(506202,14062,'bg','ÐšÑƒÑ€ÑÐ¸Ð²',0),(506203,14062,'ur','Ø§Ù¹Ø§Ù„Ú©',0),(506204,14062,'sr','ÐšÑƒÑ€Ð·Ð¸Ð²',0),(506205,14062,'vi','NghiÃªng',0),(506206,14062,'af','(Kursief)',0),(506207,14062,'ro','Cursiv',0),(506208,14062,'et','Kursiiv',0),(506209,14062,'si','LeÅ¾eÄe',0),(506210,14062,'ba','Miring',0),(506211,14062,'nl','Cursief',0),(506212,14062,'fi','Kursivoitu',0),(506213,14062,'no','Kursiv',0),(506214,14062,'da','Kursiv',0),(506215,14062,'ko','ê¸°ìš¸ìž„ê¼´',0),(506216,14062,'he','× ×˜×•×™',0),(506217,14062,'el','Î Î»Î¬Î³Î¹Î± Î³ÏÎ±Ï†Î®',0),(506218,14062,'zh','æ–œä½“',0),(506219,14062,'sv','Kursiv',0),(506220,14062,'it','Corsivo',0),(506221,14062,'tl','',0),(506222,14062,'th','à¸•à¸±à¸§à¹€à¸­à¸µà¸¢à¸‡',0),(506223,14062,'hi','à¤‡à¤Ÿà¥ˆà¤²à¤¿à¤•',0),(506224,14062,'ms','Huruf',0),(506225,14062,'ar','Ù…Ø§Ø¦Ù„',0),(506226,14062,'fr','Italic',0),(506227,14062,'jp','æ–œä½“',0),(506228,14062,'pt','ItÃ¡lico',0),(506229,14062,'ru','ÐšÑƒÑ€ÑÐ¸Ð²',0),(506230,14062,'es','Italic',0),(506231,14062,'de','Italic',0),(506232,14062,'en','Italic',0),(506233,14063,'is','',0),(506234,14063,'dr','Ù„ÛŒØ³Øª Ø¢ÛŒØªÙ…',0),(506235,14063,'pr','Ù„ÛŒØ³Øª Ø¢ÛŒØªÙ…',0),(506236,14063,'tr','Liste Ã¶ÄŸesi',0),(506237,14063,'pl','Element listy',0),(506238,14063,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº',0),(506239,14063,'ur','Ø´Û’ ÙÛØ±Ø³Øª',0),(506240,14063,'sr','Ð›Ð¸ÑÑ‚Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(506241,14063,'vi','Danh má»¥c',0),(506242,14063,'af','Lys Item',0),(506243,14063,'ro','Element listÄƒ',0),(506244,14063,'et','LoendiÃ¼ksuse',0),(506245,14063,'si','Element seznama',0),(506246,14063,'ba','Daftar Item',0),(506247,14063,'nl','Item in de lijst',0),(506248,14063,'fi','Luettelokohde',0),(506249,14063,'no','Listeelement',0),(506250,14063,'da','Listeelementet',0),(506251,14063,'ko','ëª©ë¡ í•­ëª©',0),(506252,14063,'he','×¤×¨×™×˜ ×¨×©×™×ž×”',0),(506253,14063,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î»Î¯ÏƒÏ„Î±Ï‚',0),(506254,14063,'zh','åˆ—è¡¨é¡¹',0),(506255,14063,'sv','Listobjekt',0),(506256,14063,'it','Voce elenco',0),(506257,14063,'tl','',0),(506258,14063,'th','à¸£à¸²à¸¢à¸à¸²à¸£',0),(506259,14063,'hi','à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤®',0),(506260,14063,'ms','Item senarai',0),(506261,14063,'ar','Ø¹Ù†ØµØ± Ù‚Ø§Ø¦Ù…Ø©',0),(506262,14063,'fr','Ã‰lÃ©ment de liste',0),(506263,14063,'jp','ãƒªã‚¹ãƒˆ ã‚¢ã‚¤ãƒ†ãƒ ',0),(506264,14063,'pt','Item de lista',0),(506265,14063,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÑÐ¿Ð¸ÑÐºÐ°',0),(506266,14063,'es','Elemento de la lista',0),(506267,14063,'de','Listenelement',0),(506268,14063,'en','List Item',0),(506269,14064,'is','',0),(506270,14064,'dr','Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´',0),(506271,14064,'pr','Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´',0),(506272,14064,'tr','SÄ±ralÄ± liste',0),(506273,14064,'pl','UporzÄ…dkowana lista',0),(506274,14064,'bg','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½ ÑÐ¿Ð¸ÑÑŠÐº',0),(506275,14064,'ur','ÙÛØ±Ø³Øª Ú©Ø§ Ø­Ú©Ù… Ø¯ÛŒØ§',0),(506276,14064,'sr','Ð›Ð¸ÑÑ‚Ð° Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾',0),(506277,14064,'vi','Ra lá»‡nh cho danh sÃ¡ch',0),(506278,14064,'af','Bestel lys',0),(506279,14064,'ro','Ordonat lista',0),(506280,14064,'et','JÃ¤rjestatud nimekiri',0),(506281,14064,'si','Seznam naroÄil',0),(506282,14064,'ba','Daftar dengan nomor',0),(506283,14064,'nl','Geordende lijst',0),(506284,14064,'fi','JÃ¤rjestetty luettelo',0),(506285,14064,'no','Sortert liste',0),(506286,14064,'da','Bestilt liste',0),(506287,14064,'ko','ì£¼ë¬¸ ëª©ë¡',0),(506288,14064,'he','×¨×©×™×ž×” ×ž×ž×•×¡×¤×¨×ª',0),(506289,14064,'el','Î¤Î±Î¾Î¹Î½Î¿Î¼Î·Î¼Î­Î½Î· Î»Î¯ÏƒÏ„Î±',0),(506290,14064,'zh','ç»è¿‡æŽ’åºçš„åˆ—è¡¨',0),(506291,14064,'sv','Sorterad lista',0),(506292,14064,'it','Elenco ordinato',0),(506293,14064,'tl','',0),(506294,14064,'th','à¸ªà¸±à¹ˆà¸‡à¸£à¸²à¸¢à¸à¸²à¸£',0),(506295,14064,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¤¾ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾',0),(506296,14064,'ms','Mengarahkan senarai',0),(506297,14064,'ar','Ø£Ù…Ø± Ù‚Ø§Ø¦Ù…Ø©',0),(506298,14064,'fr','ClassÃ©s en liste',0),(506299,14064,'jp','é †åºæŒ‡å®šã•ã‚ŒãŸä¸€è¦§',0),(506300,14064,'pt','Lista ordenada',0),(506301,14064,'ru','Ð£Ð¿Ð¾Ñ€ÑÐ´Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(506302,14064,'es','Lista ordenada',0),(506303,14064,'de','Geordnete Liste',0),(506304,14064,'en','Ordered List',0),(506305,14065,'is','',0),(506306,14065,'dr','Ø±Ù†Ú¯ Ù…ØªÙ†',0),(506307,14065,'pr','Ø±Ù†Ú¯ Ù…ØªÙ†',0),(506308,14065,'tr','Metin rengi',0),(506309,14065,'pl','Kolor tekstu',0),(506310,14065,'bg','Ð¦Ð²ÑÑ‚ Ð½Ð° Ñ‚ÐµÐºÑÑ‚Ð°',0),(506311,14065,'ur','Ù…ØªÙ† Ø±Ù†Ú¯',0),(506312,14065,'sr','Ð‘Ð¾Ñ˜Ð° Ñ‚ÐµÐºÑÑ‚Ð°',0),(506313,14065,'vi','VÄƒn báº£n mÃ u',0),(506314,14065,'af','Teks kleur',0),(506315,14065,'ro','Culoarea textului',0),(506316,14065,'et','Teksti vÃ¤rv',0),(506317,14065,'si','Barva besedila',0),(506318,14065,'ba','Warna teks',0),(506319,14065,'nl','Tekstkleur',0),(506320,14065,'fi','TekstivÃ¤ri',0),(506321,14065,'no','Tekstfargen',0),(506322,14065,'da','Tekstfarve',0),(506323,14065,'ko','í…ìŠ¤íŠ¸ ìƒ‰',0),(506324,14065,'he','×¦×‘×¢ ×˜×§×¡×˜',0),(506325,14065,'el','Î§ÏÏŽÎ¼Î± ÎºÎµÎ¹Î¼Î­Î½Î¿Ï…',0),(506326,14065,'zh','æ–‡æœ¬é¢œè‰²',0),(506327,14065,'sv','TextfÃ¤rg',0),(506328,14065,'it','Colore del testo',0),(506329,14065,'tl','',0),(506330,14065,'th','à¸ªà¸µà¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡',0),(506331,14065,'hi','à¤ªà¤¾à¤  à¤•à¤¾ à¤°à¤‚à¤—',0),(506332,14065,'ms','Warna teks',0),(506333,14065,'ar','Ù„ÙˆÙ† Ø§Ù„Ù†Øµ',0),(506334,14065,'fr','Couleur du texte',0),(506335,14065,'jp','ãƒ†ã‚­ã‚¹ãƒˆã®è‰²',0),(506336,14065,'pt','Cor do texto',0),(506337,14065,'ru','Ð¦Ð²ÐµÑ‚ Ñ‚ÐµÐºÑÑ‚Ð°',0),(506338,14065,'es','Color del texto',0),(506339,14065,'de','Textfarbe',0),(506340,14065,'en','Text Color',0),(506341,14066,'is','',0),(506342,14066,'dr','Ù„ÛŒØ³Øª Ù†Ø§ Ù…Ø±ØªØ¨',0),(506343,14066,'pr','Ù„ÛŒØ³Øª Ù†Ø§ Ù…Ø±ØªØ¨',0),(506344,14066,'tr','SÄ±rasÄ±z liste',0),(506345,14066,'pl','Lista nieuporzÄ…dkowana',0),(506346,14066,'bg','ÐÐµÐ¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº',0),(506347,14066,'ur','Ø§Ù†ÙˆØ±Ø¯Ø±Ø§Ø¯ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(506348,14066,'sr','ÐÐµÑƒÑ€ÐµÑ’ÐµÐ½Ñƒ Ð»Ð¸ÑÑ‚Ð°',0),(506349,14066,'vi','Danh sÃ¡ch cÃ³ thá»© tá»±',0),(506350,14066,'af','Unordered lys',0),(506351,14066,'ro','ListÄƒ neordonatÄƒ',0),(506352,14066,'et','JÃ¤rjestamata loend',0),(506353,14066,'si','Neurejen seznam',0),(506354,14066,'ba','Daftar unordered',0),(506355,14066,'nl','Niet-geordende lijst',0),(506356,14066,'fi','JÃ¤rjestÃ¤mÃ¤tÃ¶n lista',0),(506357,14066,'no','Sorterte liste',0),(506358,14066,'da','Uordnet liste',0),(506359,14066,'ko','ìˆœì„œ ì—†ëŠ” ëª©ë¡',0),(506360,14066,'he','×¨×©×™×ž×” ×©××™× ×” ×ž×¡×•×“×¨×ª',0),(506361,14066,'el','ÎœÎ· Ï„Î±Î¾Î¹Î½Î¿Î¼Î·Î¼Î­Î½Î· Î»Î¯ÏƒÏ„Î±',0),(506362,14066,'zh','æ— åºçš„åˆ—è¡¨',0),(506363,14066,'sv','Oordnad lista',0),(506364,14066,'it','Elenco non ordinato',0),(506365,14066,'tl','',0),(506366,14066,'th','à¹‚à¸”à¸¢à¸›à¸à¸•à¸´',0),(506367,14066,'hi','Unordered à¤¸à¥‚à¤šà¥€',0),(506368,14066,'ms','Senarai',0),(506369,14066,'ar','Ù‚Ø§Ø¦Ù…Ø© ØºÙŠØ± Ù…Ø±ØªØ¨Ø©',0),(506370,14066,'fr','Liste non ordonnÃ©e',0),(506371,14066,'jp','é †ä¸åŒãƒªã‚¹ãƒˆ',0),(506372,14066,'pt','Lista nÃ£o ordenada',0),(506373,14066,'ru','ÐÐµÑƒÐ¿Ð¾Ñ€ÑÐ´Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(506374,14066,'es','Lista desordenada',0),(506375,14066,'de','Ungeordnete Liste',0),(506376,14066,'en','Unordered List',0),(506377,14067,'is','',0),(506378,14067,'dr','ØªØ±Ø¬Ù…Ù‡ Ø®ÙˆØ¯ Ø±Ø§ Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø± ØªØµÙˆÛŒØ¨ ØªÙˆØ³Ø· ÛŒÚ©ÛŒ Ø§Ø² Ù…Ø¯ÛŒØ±Ø§Ù† Ù…Ø§ Ø§Ø³Øª.',0),(506379,14067,'pr','ØªØ±Ø¬Ù…Ù‡ Ø®ÙˆØ¯ Ø±Ø§ Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø± ØªØµÙˆÛŒØ¨ ØªÙˆØ³Ø· ÛŒÚ©ÛŒ Ø§Ø² Ù…Ø¯ÛŒØ±Ø§Ù† Ù…Ø§ Ø§Ø³Øª.',0),(506380,14067,'tr','Bir bizim yÃ¶neticiler tarafÄ±ndan onay bekleyen Ã§evrilmiÅŸtir.',0),(506381,14067,'pl','Twoje tÅ‚umaczenie jest do czasu zatwierdzenia przez jeden z naszych administratorÃ³w.',0),(506382,14067,'bg','Ð’Ð°ÑˆÐ¸ÑÑ‚ Ð¿Ñ€ÐµÐ²Ð¾Ð´ Ðµ Ð§Ð°ÐºÐ°Ñ‰Ð¾ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ ÐµÐ´Ð¸Ð½ Ð¾Ñ‚ Ð½Ð°ÑˆÐ¸Ñ‚Ðµ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð¸.',0),(506383,14067,'ur','Ø¢Ù¾ Ú©Ø§ ØªØ±Ø¬Ù…Û ÛÙ…Ø§Ø±Û’ Ú©Û’ Ù…Ù†ØªØ¸Ù…ÛŒÙ† Ù…ÛŒÚº Ø³Û’ Ø§ÛŒÚ© Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø²ÛŒØ±Ù Ø§Ù„ØªÙˆØ§ ÛÛ’ Û”',0),(506384,14067,'sr','Ð¢Ð²Ð¾Ñ˜ ÐŸÑ€ÐµÐ²Ð¾Ð´ Ñ‡ÐµÐºÐ° Ð½Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð½Ð°Ð¼ Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð¸.',0),(506385,14067,'vi','Báº£n dá»‹ch cá»§a báº¡n Ä‘ang chá» phÃª duyá»‡t bá»Ÿi má»™t quáº£n trá»‹ viÃªn cá»§a chÃºng tÃ´i.',0),(506386,14067,'af','Jou vertaling is hangende goedkeuring deur een van ons administrateurs.',0),(506387,14067,'ro','Traducerea este Ã®n aÅŸteptarea aprobÄƒrii de cÄƒtre unul dintre administratorii nostru.',0),(506388,14067,'et','Teie tÃµlge ootab kinnitamist Ã¼he meie administraatorite poolt.',0),(506389,14067,'si','Prevajanju Äaka na odobritev s strani ene od naÅ¡ih skrbnikov.',0),(506390,14067,'ba','Terjemahan Anda adalah menunggu persetujuan oleh salah satu administrator kami.',0),(506391,14067,'nl','Uw vertaling is in afwachting van goedkeuring door een van onze beheerders.',0),(506392,14067,'fi','KÃ¤Ã¤nnÃ¶s odottaa hyvÃ¤ksyntÃ¤Ã¤ yksi meidÃ¤n jÃ¤rjestelmÃ¤nvalvojille.',0),(506393,14067,'no','Oversettingen er venter pÃ¥ godkjennelse hos en av vÃ¥re administratorer.',0),(506394,14067,'da','Din oversÃ¦ttelse er afventer godkendelse af en af vores administratorer.',0),(506395,14067,'ko','ë²ˆì—­ì€ ìš°ë¦¬ì˜ ê´€ë¦¬ìž ì¤‘ í•˜ë‚˜ì— ì˜í•´ ìŠ¹ì¸ì„ ë³´ë¥˜ ì¤‘ì¸.',0),(506396,14067,'he','×”×ª×¨×’×•× ×©×œ×š ×˜×¢×•× ×” ××™×©×•×¨ ×ž××—×“ ×”×ž× ×”×œ×™× ×©×œ× ×•.',0),(506397,14067,'el','ÎœÎµÏ„Î¬Ï†ÏÎ±ÏƒÎ· ÏƒÎ±Ï‚ ÎµÎ¯Î½Î±Î¹ ÎµÎ½ Î±Î½Î±Î¼Î¿Î½Î® Ï„Î·Ï‚ Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚ Î±Ï€ÏŒ Î­Î½Î±Î½ Î±Ï€ÏŒ Ï„Î¿Ï…Ï‚ Î´Î¹Î±Ï‡ÎµÎ¹ÏÎ¹ÏƒÏ„Î­Ï‚ Î¼Î±Ï‚.',0),(506398,14067,'zh','ä½ çš„ç¿»è¯‘æ˜¯ç”±æˆ‘ä»¬çš„ç®¡ç†å‘˜ä¹‹ä¸€å¾…æ‰¹ã€‚',0),(506399,14067,'sv','Din Ã¶versÃ¤ttning Ã¤r vÃ¤ntar pÃ¥ godkÃ¤nnande av en av vÃ¥ra administratÃ¶rer.',0),(506400,14067,'it','La traduzione Ã¨ in attesa di approvazione da parte di uno dei nostri amministratori.',0),(506401,14067,'tl','',0),(506402,14067,'th','à¹à¸›à¸¥à¸‚à¸­à¸‡à¸„à¸¸à¸“à¸­à¸¢à¸¹à¹ˆà¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸žà¸´à¸ˆà¸²à¸£à¸“à¸²à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¹‚à¸”à¸¢à¸œà¸¹à¹‰à¸”à¸¹à¹à¸¥à¸£à¸°à¸šà¸šà¸‚à¸­à¸‡à¹€à¸£à¸²',0),(506403,14067,'hi','à¤†à¤ªà¤•à¥‡ à¤…à¤¨à¥à¤µà¤¾à¤¦ à¤¹à¤®à¤¾à¤°à¥‡ à¤ªà¥à¤°à¤¶à¤¾à¤¸à¤•à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¸à¥‡ à¤à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤²à¤‚à¤¬à¤¿à¤¤ à¤¹à¥ˆà¥¤',0),(506404,14067,'ms','Terjemahan adalah tertakluk kepada kelulusan oleh salah seorang pentadbir kami.',0),(506405,14067,'ar','Ø§Ù„ØªØ±Ø¬Ù…Ø© Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ø¨Ø§Ù†ØªØ¸Ø§Ø± Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„ÙŠÙ‡ Ø¨Ø£Ø­Ø¯ Ù…Ù† Ø§Ù„Ù…Ø³Ø¤ÙˆÙ„ÙŠÙ† Ù„Ø¯ÙŠÙ†Ø§.',0),(506406,14067,'fr','Votre traduction est soumise pour approbation Ã  l\'un de nos administrateurs.',0),(506407,14067,'jp','ã‚ãªãŸã®ç¿»è¨³ã¯ç§ãŸã¡ã®ç®¡ç†è€…ã®ã„ãšã‚Œã‹ã«ã‚ˆã£ã¦æ‰¿èªå¾…ã¡ã§ã™ã€‚',0),(506408,14067,'pt','Sua traduÃ§Ã£o estÃ¡ pendente de aprovaÃ§Ã£o de um dos nossos administradores.',0),(506409,14067,'ru','Ð’Ð°Ñˆ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´ Ð¿Ð¾Ð´Ð»ÐµÐ¶Ð¸Ñ‚ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸ÑŽ Ð¾Ð´Ð¸Ð½ Ð¸Ð· Ð½Ð°ÑˆÐ¸Ñ… Ð°Ð´Ð¼Ð¸Ð½Ð¸ÑÑ‚Ñ€Ð°Ñ‚Ð¾Ñ€Ð¾Ð².',0),(506410,14067,'es','La traducciÃ³n estÃ¡ pendiente de aprobaciÃ³n por parte de uno de nuestros administradores.',0),(506411,14067,'de','Ihre Ãœbersetzung ist bis zur Genehmigung durch einen unserer Administratoren.',0),(506412,14067,'en','Your translation is pending approval by one of our administrators.',0),(506413,14068,'is','',0),(506414,14068,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªØ®ÙÛŒÙ',0),(506415,14068,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªØ®ÙÛŒÙ',0),(506416,14068,'tr','Ä°skontosunu Hesapla',0),(506417,14068,'pl','ObliczyÄ‡ rabat',0),(506418,14068,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»Ð¸ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(506419,14068,'ur','Ø±Ø¹Ø§ÛŒØª Ú©Ø§ Ø­Ø³Ø§Ø¨ Ú©Ø±ÛŒÚº',0),(506420,14068,'sr','ÐžÐ±Ñ€Ð°Ñ‡ÑƒÐ½ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(506421,14068,'vi','TÃ­nh toÃ¡n giáº£m giÃ¡',0),(506422,14068,'af','Afslag bereken',0),(506423,14068,'ro','Se calculeazÄƒ Discount',0),(506424,14068,'et','Hinnaalandi arvutamiseks',0),(506425,14068,'si','IzraÄuna popust',0),(506426,14068,'ba','Menghitung DISKON',0),(506427,14068,'nl','Korting berekenen',0),(506428,14068,'fi','Laske alennus',0),(506429,14068,'no','Beregn rabatt',0),(506430,14068,'da','Beregne rabat',0),(506431,14068,'ko','í• ì¸ ê³„ì‚°',0),(506432,14068,'he','×—×©×‘ ×”× ×—×”',0),(506433,14068,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯ÏƒÏ„Îµ Ï„Î·Î½ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·',0),(506434,14068,'zh','è®¡ç®—æŠ˜æ‰£',0),(506435,14068,'sv','BerÃ¤kna',0),(506436,14068,'it','Calcolare sconto',0),(506437,14068,'tl','',0),(506438,14068,'th','à¸„à¸³à¸™à¸§à¸“à¸ªà¹ˆà¸§à¸™à¸¥à¸”',0),(506439,14068,'hi','à¤›à¥‚à¤Ÿ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(506440,14068,'ms','Menghitung diskaun',0),(506441,14068,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø®ØµÙ…',0),(506442,14068,'fr','Calculer la rÃ©duction',0),(506443,14068,'jp','å‰²å¼•ã‚’è¨ˆç®—ã—ã¾ã™ã€‚',0),(506444,14068,'pt','Calcular desconto',0),(506445,14068,'ru','Ð Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ ÑÐºÐ¸Ð´ÐºÑƒ',0),(506446,14068,'es','Calcular el descuento',0),(506447,14068,'de','Rabatt berechnen',0),(506448,14068,'en','Calculate Discount',0),(506449,14069,'is','',0),(506450,14069,'dr','ØªØ®ÙÛŒÙ Ù…Ù†Ø¸ÙˆØ± ÙØ¹Ù„ÛŒ ØªÙˆØ³Ø·',0),(506451,14069,'pr','ØªØ®ÙÛŒÙ Ù…Ù†Ø¸ÙˆØ± ÙØ¹Ù„ÛŒ ØªÙˆØ³Ø·',0),(506452,14069,'tr','GeÃ§erli sipariÅŸe gÃ¶re indirim',0),(506453,14069,'pl','Rabat bieÅ¼Ä…cego zamÃ³wienia przez',0),(506454,14069,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚',0),(506455,14069,'ur','Ù…ÙˆØ¬ÙˆØ¯Û ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø­Ø§Ø¸ Ø³Û’ ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(506456,14069,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ ÐžÑ€Ð´ÐµÑ€ Ð‘y',0),(506457,14069,'vi','Giáº£m giÃ¡ hiá»‡n táº¡i sáº¯p xáº¿p theo',0),(506458,14069,'af','Huidige orde deur afslag',0),(506459,14069,'ro','Comanda curentÄƒ de reducere',0),(506460,14069,'et','Soodus praeguse tellimuse jÃ¤rgi',0),(506461,14069,'si','Popust trenutni vrstni red po',0),(506462,14069,'ba','Diskon terbaik saat ini diurutkan sesuai untuk',0),(506463,14069,'nl','Goedkope huidige Order By',0),(506464,14069,'fi','Alennus nykyiseen jÃ¤rjestys',0),(506465,14069,'no','Rabatt gjeldende ordre av',0),(506466,14069,'da','Discount aktuelle ordre af',0),(506467,14069,'ko','í˜„ìž¬ ì£¼ë¬¸ í• ì¸',0),(506468,14069,'he','×”× ×—×” ×”×”×–×ž× ×” ×”× ×•×›×—×™×ª ×¢×œ-×™×“×™',0),(506469,14069,'el','Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Ï€ÏŒ',0),(506470,14069,'zh','ç”±å½“å‰è®¢å•çš„æŠ˜æ‰£',0),(506471,14069,'sv','Rabatt nuvarande ordning av',0),(506472,14069,'it','Sconto ordine attuale di',0),(506473,14069,'tl','',0),(506474,14069,'th','à¸¥à¸”à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¹‚à¸”à¸¢',0),(506475,14069,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤†à¤¦à¥‡à¤¶ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤›à¥‚à¤Ÿ',0),(506476,14069,'ms','Diskaun semasa perintah oleh',0),(506477,14069,'ar','Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø­Ø§Ù„ÙŠ Ø¨Ø®ØµÙ…',0),(506478,14069,'fr','RÃ©duction pour cours de',0),(506479,14069,'jp','å‰²å¼•ç¾åœ¨é †',0),(506480,14069,'pt','Desconto atual ordem por',0),(506481,14069,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ñ‚ÐµÐºÑƒÑ‰ÐµÐ³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(506482,14069,'es','Descuento actual orden por',0),(506483,14069,'de','Rabatt aktuelle Bestellung von',0),(506484,14069,'en','Discount Current Order By',0),(506485,14070,'is','',0),(506486,14070,'dr','Ù‡ÛŒÚ† Ø­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡',0),(506487,14070,'pr','Ù‡ÛŒÚ† Ø­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡',0),(506488,14070,'tr','Kaydedilen Ã¶deme hesabÄ± yok',0),(506489,14070,'pl','Nie zapisany pÅ‚atnoÅ›ci rachunkÃ³w',0),(506490,14070,'bg','ÐÑÐ¼Ð° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸ Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(506491,14070,'ur','Ù…Ø­ÙÙˆØ¸ Ø´Ø¯Û Ø±Ù‚Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†ÛÛŒÚº',0),(506492,14070,'sr','ÐÐµÐ¼Ð° ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½Ð¸Ñ… Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(506493,14070,'vi','KhÃ´ng cÃ³ tÃ i khoáº£n thanh toÃ¡n Ä‘Ã£ lÆ°u',0),(506494,14070,'af','Geen gestoorde betaling rekeninge',0),(506495,14070,'ro','Nu conturile de platÄƒ salvat',0),(506496,14070,'et','Salvestatud kontod',0),(506497,14070,'si','Ni shranjena plaÄila raÄunov',0),(506498,14070,'ba','Ada account pembayaran disimpan',0),(506499,14070,'nl','Geen opgeslagen betaalrekeningen',0),(506500,14070,'fi','Ei ole tallennettu maksutilit',0),(506501,14070,'no','Ingen lagrede betalingskontoer',0),(506502,14070,'da','Ingen gemte betalingskonti',0),(506503,14070,'ko','ì•„ë‹ˆ ì €ìž¥ ëœ ì§€ë¶ˆ ê³„ì •',0),(506504,14070,'he','××™×Ÿ ×—×©×‘×•× ×•×ª ×œ×ª×©×œ×•× ×©× ×©×ž×¨',0),(506505,14070,'el','Î”ÎµÎ½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Î¼Î­Î½Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(506506,14070,'zh','æ²¡æœ‰ä»»ä½•å·²ä¿å­˜çš„ä»˜æ¬¾å¸æˆ·',0),(506507,14070,'sv','Inga sparade betalkonton',0),(506508,14070,'it','Senza conti di pagamento salvato',0),(506509,14070,'tl','',0),(506510,14070,'th','à¹„à¸¡à¹ˆà¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸šà¸±à¸™à¸—à¸¶à¸à¸šà¸±à¸à¸Šà¸µ',0),(506511,14070,'hi','à¤•à¥‹à¤ˆ à¤¸à¤¹à¥‡à¤œà¥€ à¤—à¤ˆ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤–à¤¾à¤¤à¥‹à¤‚',0),(506512,14070,'ms','Tiada akaun pembayaran disimpan',0),(506513,14070,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø©',0),(506514,14070,'fr','Aucun compte de paiement enregistrÃ©s',0),(506515,14070,'jp','ä¿å­˜ã•ã‚Œã¦ã„ã‚‹ãŠæ”¯æ‰•ã„ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(506516,14070,'pt','Sem contas de pagamento salvo',0),(506517,14070,'ru','ÐÐµ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(506518,14070,'es','Sin cuentas de pago guardados',0),(506519,14070,'de','Keine gespeicherten Zahlungskonten',0),(506520,14070,'en','No Saved Payment Accounts',0),(506521,14071,'is','',0),(506522,14071,'dr','NDMS Ø¹Ø¶Ùˆ Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯.',0),(506523,14071,'pr','NDMS Ø¹Ø¶Ùˆ Ù¾Ø´ØªÛŒØ¨Ø§Ù†ÛŒ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯.',0),(506524,14071,'tr','NDMS Ã¼yelik desteÄŸi sizinle irtibata geÃ§ecektir.',0),(506525,14071,'pl','NDMS wsparcie PaÅ„stwa skontaktujemy.',0),(506526,14071,'bg','Ð§Ð»ÐµÐ½ Ð½Ð° NDMS Ð¿Ð¾Ð´ÐºÑ€ÐµÐ¿Ð° Ñ‰Ðµ ÑÐµ ÑÐ²ÑŠÑ€Ð¶ÐµÐ¼ Ñ Ð²Ð°Ñ.',0),(506527,14071,'ur','Ø§ÛŒÚ© Ù†ÚˆÙ…Ø³ Ú©ÛŒ Ø­Ù…Ø§ÛŒØª Ø±Ú©Ù† Ø¢Ù¾ Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±Û’ Ú¯Ø§ Û”',0),(506528,14071,'sr','Ð§Ð»Ð°Ð½ ÐÐ”ÐœÐ¡ Ð¿Ð¾Ð´Ñ€ÑˆÐºÐ° Ñ›Ðµ Ð²Ð°Ñ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ð¸.',0),(506529,14071,'vi','Má»™t thÃ nh viÃªn há»— trá»£ NDMS sáº½ liÃªn láº¡c vá»›i báº¡n.',0),(506530,14071,'af','\'N NDMS ondersteuning lid sal kontak.',0),(506531,14071,'ro','Un membru de sprijin NDMS va va contacta.',0),(506532,14071,'et','NDMS support liige vÃµtab sinuga Ã¼hendust.',0),(506533,14071,'si','NDMS podporni Älan bo stik z vami.',0),(506534,14071,'ba','Anggota dukungan NDMS akan menghubungi Anda.',0),(506535,14071,'nl','Een lid van NDMS ondersteuning zal contact met u opnemen.',0),(506536,14071,'fi','NDMS tuki jÃ¤sen ottaa sinuun.',0),(506537,14071,'no','En NDMS stÃ¸tte medlem vil kontakte deg.',0),(506538,14071,'da','En NDMS stÃ¸tte medlem vil kontakte dig.',0),(506539,14071,'ko','NDMS ì§€ì› íšŒì› ì—°ë½ ë“œë¦¬ê² ìŠµë‹ˆë‹¤.',0),(506540,14071,'he','×—×‘×¨ ×ª×ž×™×›×” NDMS ×§×©×¨.',0),(506541,14071,'el','ÎˆÎ½Î± Î¼Î­Î»Î¿Ï‚ Ï„Î·Ï‚ Ï…Ï€Î¿ÏƒÏ„Î®ÏÎ¹Î¾Î·Ï‚ NDMS Î¸Î± ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î®ÏƒÎµÎ¹ Î¼Î±Î¶Î¯ ÏƒÎ±Ï‚.',0),(506542,14071,'zh','åŠ¨æ€æ”¯æŒæˆå‘˜å°†ä¸Žæ‚¨è”ç³»ã€‚',0),(506543,14071,'sv','En NDMS stÃ¶dmedlem kontaktar dig.',0),(506544,14071,'it','Un membro di supporto NDMS ti contatterÃ .',0),(506545,14071,'tl','',0),(506546,14071,'th','à¸ªà¸¡à¸²à¸Šà¸´à¸à¸ªà¸™à¸±à¸šà¸ªà¸™à¸¸à¸™ NDMS à¸•à¸´à¸”à¸•à¹ˆà¸­à¸„à¸¸à¸“',0),(506547,14071,'hi','à¤à¤• NDMS à¤¸à¤®à¤°à¥à¤¥à¤¨ à¤¸à¤¦à¤¸à¥à¤¯ à¤†à¤ªà¤¸à¥‡ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚à¤—à¥‡à¥¤',0),(506548,14071,'ms','Ahli sokongan NDMS akan menghubungi anda.',0),(506549,14071,'ar','Ø³ÙˆÙ Ù†ØªØµÙ„ Ø£Ø¹Ø¶Ø§Ø¡ Ø¯Ø¹Ù… Ø¨Ù„Ø¯ÙŠØ©.',0),(506550,14071,'fr','Un membre de soutien SNAC communiquera avec vous.',0),(506551,14071,'jp','NDMS ã‚µãƒãƒ¼ãƒˆã®ãƒ¡ãƒ³ãƒãƒ¼ã«é€£çµ¡ã—ã¾ã™ã€‚',0),(506552,14071,'pt','Um membro de apoio NDMS entrarÃ¡ em contato.',0),(506553,14071,'ru','ÐÐ°ÑÐ¾Ñ ÐÐ”ÐœÐ¡ Ñ‡Ð»ÐµÐ½ Ð¿Ð¾Ð´Ð´ÐµÑ€Ð¶ÐºÐ¸ ÑÐ²ÑÐ¶ÐµÑ‚ÑÑ Ñ Ð²Ð°Ð¼Ð¸.',0),(506554,14071,'es','Un miembro de apoyo NDMS contactarÃ¡ con usted.',0),(506555,14071,'de','Ein Support-NDMS-Mitglied werden Sie kontaktieren.',0),(506556,14071,'en','An NDMS support member will contact you.',0),(506557,14072,'is','',0),(506558,14072,'dr','Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ù‚Ø§Ø¨Ù„ Ø§Ø¹ØªÙ…Ø§Ø¯ Ø¨Ø§ Ù†Ø±Ø® Ù…ØªÙˆØ³Ø·.',0),(506559,14072,'pr','Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ù‚Ø§Ø¨Ù„ Ø§Ø¹ØªÙ…Ø§Ø¯ Ø¨Ø§ Ù†Ø±Ø® Ù…ØªÙˆØ³Ø·.',0),(506560,14072,'tr','Ortalama oranlar gÃ¼venilir iÅŸlemci.',0),(506561,14072,'pl','Niezawodny procesor z Å›rednia cena.',0),(506562,14072,'bg','ÐÐ°Ð´ÐµÐ¶Ð´Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€ ÑÑŠÑ ÑÑ€ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸.',0),(506563,14072,'ur','Ø§ÙˆØ³Ø· Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø´Ø±Ø­ Ú©Û’ Ø³Ø§ØªÚ¾ Ù‚Ø§Ø¨Ù„ Ø§Ø¹ØªÙ…Ø§Ø¯ Ù¾Ø±ÙˆØ³ÛŒØ³Ø±.',0),(506564,14072,'sr','ÐŸÐ¾ÑƒÐ·Ð´Ð°Ð½ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€ ÑÐ° Ð¿Ñ€Ð¾ÑÐµÑ‡Ð½Ðµ ÑÑ‚Ð¾Ð¿Ðµ.',0),(506565,14072,'vi','Bá»™ xá»­ lÃ½ Ä‘Ã¡ng tin cáº­y vá»›i má»©c trung bÃ¬nh.',0),(506566,14072,'af','Betroubare verwerker met gemiddelde koerse.',0),(506567,14072,'ro','Procesor, fiabil cu ratele medii.',0),(506568,14072,'et','UsaldusvÃ¤Ã¤rne protsessor keskmised mÃ¤Ã¤rad.',0),(506569,14072,'si','Zanesljivo procesor z povpreÄne stopnje.',0),(506570,14072,'ba','Prosesor yang dapat diandalkan dengan harga rata-rata.',0),(506571,14072,'nl','Betrouwbare processor met gemiddelde percentages.',0),(506572,14072,'fi','Luotettava prosessori keskikursseja.',0),(506573,14072,'no','PÃ¥litelig prosessor med gjennomsnittlig priser.',0),(506574,14072,'da','PÃ¥lidelig processor med gennemsnitlige priser.',0),(506575,14072,'ko','í‰ê·  ì†ë„ì™€ ì•ˆì •ì ì¸ í”„ë¡œì„¸ì„œìž…ë‹ˆë‹¤.',0),(506576,14072,'he','×ž×¢×‘×“ ××ž×™×Ÿ ×¢× ×ž×ž×•×¦×¢ ×”×ž×—×™×¨×™×.',0),(506577,14072,'el','Î‘Î¾Î¹ÏŒÏ€Î¹ÏƒÏ„Î¿ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î® Î¼Îµ Î¼Î­ÏƒÎµÏ‚ Ï„Î¹Î¼Î­Ï‚.',0),(506578,14072,'zh','ä¸Žå¹³å‡çŽ‡çš„å¯é å¤„ç†å™¨ã€‚',0),(506579,14072,'sv','TillfÃ¶rlitlig processor med genomsnittliga priser.',0),(506580,14072,'it','Processore affidabile con tassi medi.',0),(506581,14072,'tl','',0),(506582,14072,'th','à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¸—à¸µà¹ˆà¸™à¹ˆà¸²à¹€à¸Šà¸·à¹ˆà¸­à¸–à¸·à¸­ à¸”à¹‰à¸§à¸¢à¸£à¸²à¸„à¸²à¹€à¸‰à¸¥à¸µà¹ˆà¸¢',0),(506583,14072,'hi','à¤”à¤¸à¤¤ à¤¦à¤°à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤µà¤¿à¤¶à¥à¤µà¤¸à¤¨à¥€à¤¯ à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤°à¥¤',0),(506584,14072,'ms','Pemproses boleh dipercayai dengan kadar purata.',0),(506585,14072,'ar','Ù…Ø¹Ø§Ù„Ø¬ Ù…ÙˆØ«ÙˆÙ‚ Ø¨Ù‡Ø§ Ù…Ø¹ Ù…Ø¹Ø¯Ù„Ø§Øª Ù…ØªÙˆØ³Ø·.',0),(506586,14072,'fr','Processeur fiable avec des taux moyens.',0),(506587,14072,'jp','å¹³å‡ãƒ¬ãƒ¼ãƒˆã§ä¿¡é ¼æ€§ã®é«˜ã„ãƒ—ãƒ­ã‚»ãƒƒã‚µã§ã™ã€‚',0),(506588,14072,'pt','Processador confiÃ¡vel com taxas mÃ©dias.',0),(506589,14072,'ru','ÐÐ°Ð´ÐµÐ¶Ð½Ñ‹Ð¹ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€ Ñ ÑÑ€ÐµÐ´Ð½Ð¸Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸.',0),(506590,14072,'es','Procesador confiable con tasas promedio.',0),(506591,14072,'de','ZuverlÃ¤ssige Prozessor mit durchschnittlichen Wachstumsraten.',0),(506592,14072,'en','Reliable processor with average rates.',0),(506593,14073,'is','',0),(506594,14073,'dr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ - NDMS Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¯Ø±ÙˆØ§Ø²Ù‡ ePay Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ Ùˆ <b>Ù¾Ø§ÛŒÛŒÙ† ØªØ±ÛŒÙ†</b> Ù†Ø±Ø® Ø±Ø§ Ø§Ø±Ø§Ø¦Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯.',0),(506595,14073,'pr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ - NDMS Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø¯Ø±ÙˆØ§Ø²Ù‡ ePay Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ Ùˆ <b>Ù¾Ø§ÛŒÛŒÙ† ØªØ±ÛŒÙ†</b> Ù†Ø±Ø® Ø±Ø§ Ø§Ø±Ø§Ø¦Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯.',0),(506596,14073,'tr','Ã–nerilen - NDMS ABD ePay aÄŸ geÃ§idi kullanÄ±r ve <b>En dÃ¼ÅŸÃ¼k</b> fiyatlar sunuyor.',0),(506597,14073,'pl','Zalecane - NDMS uÅ¼ywa bramy ePay USA i oferuje <b>najniÅ¼sze</b> ceny.',0),(506598,14073,'bg','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑŠÑ‡Ð¸Ñ‚ÐµÐ»Ð½Ð¸ - NDMS Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð¡ÐÐ© ePay gateway Ð¸ Ð¿Ñ€ÐµÐ´Ð»Ð°Ð³Ð° Ð½Ð°Ð¹ <b>-Ð½Ð¸ÑÐºÐ¸</b> Ñ†ÐµÐ½Ð¸.',0),(506599,14073,'ur','Ø³ÙØ§Ø±Ø´ Ú©ÛŒ Ø¬Ø§ØªÛŒ ÛÛ’ - Ù†ÚˆÙ…Ø³ Ø§ÛŒÙ¾Ø¢ÛŒ Ú¯ÛŒÙ¹ ÙˆÛ’ USA Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªØ§ ÛÛ’ Ø§ÙˆØ± <b>Ø³Ø¨ Ø³Û’ Ú©Ù…</b> Ù‚ÛŒÙ…ØªÛŒÚº ÙØ±Ø§ÛÙ… Ú©Ø±ØªØ§ ÛÛ’ Û”',0),(506600,14073,'sr','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑƒÑ‡ÑƒÑ˜Ðµ ÑÐµ - ÐÐ”ÐœÐ¡ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¼Ñ€ÐµÐ¶Ð½Ð¸ Ð¿Ñ€Ð¾Ð»Ð°Ð· ÐµÐŸÐ°y Ð£Ð¡Ð Ð¸ Ð½ÑƒÐ´Ð¸ <b>Ð½Ð°Ñ˜Ð½Ð¸Ð¶Ðµ</b> ÑÑ‚Ð¾Ð¿Ðµ.',0),(506601,14073,'vi','Giá»›i thiá»‡u - NDMS sá»­ dá»¥ng cá»­a ngÃµ ePay Má»¹ vÃ  cung cáº¥p cÃ¡c má»©c giÃ¡ <b>tháº¥p nháº¥t</b> .',0),(506602,14073,'af','Aanbeveel - NDMS gebruik die VSA ePay deurgang en bied die <b>laagste</b> tariewe.',0),(506603,14073,'ro','Recomandat - NDMS foloseÅŸte SUA ePay gateway ÅŸi oferÄƒ cele <b>mai mici</b> tarife.',0),(506604,14073,'et','Soovituslik - NDMS kasutab USA ePay lÃ¼Ã¼si ja pakub <b>madalamaid</b> intressimÃ¤Ã¤rasid.',0),(506605,14073,'si','PriporoÄena - NDMS uporablja ZDA ePay prehoda in ponuja <b>najniÅ¾je</b> stopnje.',0),(506606,14073,'ba','Direkomendasikan - NDMS menggunakan USA ePay gateway dan menawarkan harga <b>terendah</b> .',0),(506607,14073,'nl','Aanbevolen - NDMS gebruikt de VS ePay gateway en biedt de <b>laagste</b> tarieven.',0),(506608,14073,'fi','Suositeltava - NDMS kÃ¤yttÃ¤Ã¤ USA ePay gateway ja <b>tarjoaa</b> .',0),(506609,14073,'no','Anbefalt - NDMS bruker USA andre betalingsmÃ¥ter gateway og tilbyr den <b>laveste</b> prisen.',0),(506610,14073,'da','Anbefalet - NDMS bruger USA ePay gateway og tilbyder de <b>laveste</b> rater.',0),(506611,14073,'ko','ê¶Œìž¥-NDMS ë¯¸êµ­ ePay ê²Œì´íŠ¸ì›¨ì´ ì‚¬ìš© í•˜ ê³  <b>ìµœì €</b> ìš”ê¸ˆì„ ì œê³µ í•©ë‹ˆë‹¤.',0),(506612,14073,'he','×ž×•×ž×œ×¥ - NDMS ×ž×©×ª×ž×©×ª ×”×©×¢×¨ ePay ×‘××¨×” ×‘, ×ž×¦×™×¢×” ××ª ×”×ž×—×™×¨×™× ×”× ×ž×•×›×™× <b>×‘×™×•×ª×¨</b> .',0),(506613,14073,'el','Î£Ï…Î½Î¹ÏƒÏ„Î¬Ï„Î±Î¹ - NDMS Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯ Ï„Î·Î½ Ï€ÏÎ»Î· ePay Î—Î Î‘ ÎºÎ±Î¹ Î½Î± Ï€ÏÎ¿ÏƒÏ†Î­ÏÎµÎ¹ Ï„Î¹Ï‚ <b>Ï‡Î±Î¼Î·Î»ÏŒÏ„ÎµÏÎµÏ‚</b> Ï„Î¹Î¼Î­Ï‚.',0),(506614,14073,'zh','æŽ¨è-åŠ¨æ€ä½¿ç”¨ç¾Žå›½ ePay ç½‘å…³ï¼Œå¹¶æä¾›<b>æœ€ä½Ž</b>ã€‚',0),(506615,14073,'sv','Rekommenderas - NDMS anvÃ¤nds USA ePay gateway och erbjuder de <b>lÃ¤gsta</b> priserna.',0),(506616,14073,'it','Consigliato - NDMS utilizza il gateway ePay USA e offre le tariffe <b>piÃ¹ basse</b> .',0),(506617,14073,'tl','',0),(506618,14073,'th','à¹à¸™à¸°à¸™à¸³ - NDMS à¹ƒà¸Šà¹‰à¹€à¸à¸•à¹€à¸§à¸¢à¹Œ ePay à¸ªà¸«à¸£à¸±à¸à¸­à¹€à¸¡à¸£à¸´à¸à¸² à¹à¸¥à¸°<b>à¸£à¸²à¸„à¸²</b>',0),(506619,14073,'hi','à¤•à¥€ à¤¸à¤¿à¤«à¤¾à¤°à¤¿à¤¶ à¤•à¥€ - NDMS à¤¸à¤‚à¤¯à¥à¤•à¥à¤¤ à¤°à¤¾à¤œà¥à¤¯ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ ePay à¤—à¥‡à¤Ÿà¤µà¥‡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤”à¤° <b>à¤¸à¤¬à¤¸à¥‡ à¤•à¤®</b> à¤¦à¤°à¥‹à¤‚ à¤•à¥€ à¤ªà¥‡à¤¶à¤•à¤¶à¥¤',0),(506620,14073,'ms','Disyorkan - NDMS menggunakan get laluan ePay USA dan menawarkan kadar <b>paling rendah</b> .',0),(506621,14073,'ar','ÙˆØ£ÙˆØµÙ‰--Ø¨Ù„Ø¯ÙŠØ© ÙŠØ³ØªØ®Ø¯Ù… Ø¨ÙˆØ§Ø¨Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ ÙÙŠ Ø§Ù„ÙˆÙ„Ø§ÙŠØ§Øª Ø§Ù„Ù…ØªØ­Ø¯Ø© Ø§Ù„Ø£Ù…Ø±ÙŠÙƒÙŠØ© ÙˆÙŠÙˆÙØ± <b>Ø£Ø¯Ù†Ù‰</b> Ø§Ù„Ù…Ø¹Ø¯Ù„Ø§Øª.',0),(506622,14073,'fr','RecommandÃ© - SNAC utilise la passerelle de PmtE USA et propose les taux les <b>plus bas</b> .',0),(506623,14073,'jp','æŽ¨å¥¨ - NDMS ç±³å›½ ePay ã‚²ãƒ¼ãƒˆã‚¦ã‚§ã‚¤ã‚’ä½¿ç”¨ã—ã€<b>æœ€ã‚‚ä½Žã„</b>æ–™é‡‘ã‚’æä¾›ã—ã¦ã„ã¾ã™ã€‚',0),(506624,14073,'pt','Recomenda - NDMS usa o gateway de ePay EUA e oferece as <b>menores</b> taxas.',0),(506625,14073,'ru','Ð ÐµÐºÐ¾Ð¼ÐµÐ½Ð´ÑƒÐµÑ‚ÑÑ - Ð½Ð°ÑÐ¾Ñ ÐÐ”ÐœÐ¡ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ ÑˆÐ»ÑŽÐ· ePay Ð¡Ð¨Ð Ð¸ Ð¿Ñ€ÐµÐ´Ð»Ð°Ð³Ð°ÐµÑ‚ <b>Ð½Ð¸Ð·ÐºÐ¸Ðµ</b> Ñ†ÐµÐ½Ñ‹.',0),(506626,14073,'es','Recomienda - NDMS utiliza la pasarela de pago electrÃ³nico USA y ofrece las tarifas <b>mÃ¡s bajas</b> .',0),(506627,14073,'de','Empfohlen - NDMS verwendet den USA ePay Gateway und bietet die <b>niedrigsten</b> Preise.',0),(506628,14073,'en','Recommended - NDMS uses the USA ePay gateway and offers the <b>lowest</b> rates.',0),(506629,14074,'is','',0),(506630,14074,'dr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¯Ø³ØªÛŒ Ø§Ø² Ø·Ø±ÛŒÙ‚ Ø¯Ø±ÙˆØ§Ø²Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø®ÙˆØ¯ Ø±Ø§.',0),(506631,14074,'pr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¯Ø³ØªÛŒ Ø§Ø² Ø·Ø±ÛŒÙ‚ Ø¯Ø±ÙˆØ§Ø²Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø®ÙˆØ¯ Ø±Ø§.',0),(506632,14074,'tr','Kredi kartÄ± iÅŸlemleri, Ã¶deme aÄŸ geÃ§idi Ã¼zerinden el iÅŸleme.',0),(506633,14074,'pl','Transakcje kartami kredytowymi rÄ™cznie przetwarzane przez bramy pÅ‚atnoÅ›ci.',0),(506634,14074,'bg','Ð ÑŠÑ‡Ð½Ð¾ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½Ð¸ Ñ‡Ñ€ÐµÐ· Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð²Ñ…Ð¾Ð´ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸.',0),(506635,14074,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø¢Ù¾ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú¯ÛŒÙ¹ ÙˆÛ’ Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ø¯Ø³ØªÛŒ Ø·ÙˆØ± Ù¾Ø± Ø¹Ù…Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’ Û”',0),(506636,14074,'sr','Ð¢Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°Ð¼Ð° Ñ€ÑƒÑ‡Ð½Ð¾ Ð¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð° ÐºÑ€Ð¾Ð· Ñ‚Ð²Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð»Ð°Ð· Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°.',0),(506637,14074,'vi','Tháº» tÃ­n dá»¥ng giao dá»‹ch báº±ng tay xá»­ lÃ½ thÃ´ng qua cá»•ng thanh toÃ¡n cá»§a báº¡n.',0),(506638,14074,'af','Kredietkaart-transaksies per hand verwerk deur jou betaling portaal.',0),(506639,14074,'ro','Card de credit tranzacÅ£ii procesate manual prin intermediul gateway-ul de platÄƒ.',0),(506640,14074,'et','Krediitkaardiga makstes makse gateway kaudu kÃ¤sitsi tÃ¶Ã¶deldud.',0),(506641,14074,'si','Transakcije s kreditnimi karticami roÄno obdelanih preko plaÄilnih prehodom.',0),(506642,14074,'ba','Transaksi kartu kredit secara manual diproses melalui gateway pembayaran.',0),(506643,14074,'nl','Credit card transacties handmatig verwerkt via de betalingsgateway van uw.',0),(506644,14074,'fi','Luottokorttitapahtumia manuaalisesti kÃ¤sitelty maksu yhdyskÃ¤ytÃ¤vÃ¤.',0),(506645,14074,'no','Kredittkorttransaksjoner manuelt behandlet gjennom din betalingsleverandâ”œâ••r.',0),(506646,14074,'da','Kreditkorttransaktioner manuelt behandles gennem din betalingsgateway.',0),(506647,14074,'ko','ì‹ ìš© ì¹´ë“œ ê±°ëž˜ ìˆ˜ë™ìœ¼ë¡œ ì§€ë¶ˆ ê²Œì´íŠ¸ì›¨ì´ í†µí•´ ì²˜ë¦¬ í•©ë‹ˆë‹¤.',0),(506648,14074,'he','×ª× ×•×¢×•×ª ×‘×›×¨×˜×™×¡ ××©×¨××™ ×‘××•×¤×Ÿ ×™×“× ×™ ×ž×¢×•×‘×“ ×“×¨×š ×©×¢×¨ ×”×ª×©×œ×•× ×©×œ×š.',0),(506649,14074,'el','Î£Ï…Î½Î±Î»Î»Î±Î³Î­Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½ Î¼Îµ Ï„Î¿ Ï‡Î­ÏÎ¹ ÏƒÎµ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼Î­ÏƒÏ‰ ÏƒÎ±Ï‚ Ï€ÏÎ»Î· Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚.',0),(506650,14074,'zh','ä¿¡ç”¨å¡äº¤æ˜“è®°å½•æ‰‹åŠ¨å¤„ç†é€šè¿‡æ‚¨çš„æ”¯ä»˜ç½‘å…³ã€‚',0),(506651,14074,'sv','Kreditkortstransaktioner behandlas manuellt via din betalning gateway.',0),(506652,14074,'it','Transazioni con carta di credito elaborate manualmente tramite il gateway di pagamento.',0),(506653,14074,'tl','',0),(506654,14074,'th','à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸µà¹ˆà¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸œà¹ˆà¸²à¸™à¹€à¸à¸•à¹€à¸§à¸¢à¹Œà¸‚à¸­à¸‡à¸„à¸¸à¸“à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(506655,14074,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤°à¥‚à¤ª à¤¸à¥‡ à¤†à¤ªà¤•à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤¦à¥à¤µà¤¾à¤° à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨à¥¤',0),(506656,14074,'ms','Transaksi kad kredit secara manual diproses melalui gerbang pembayaran anda.',0),(506657,14074,'ar','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ù…Ø¹Ø§Ù„Ø¬ØªÙ‡Ø§ ÙŠØ¯ÙˆÙŠØ§Ù‹ Ù…Ù† Ø®Ù„Ø§Ù„ Ø¨ÙˆØ§Ø¨Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ.',0),(506658,14074,'fr','Transactions par carte de crÃ©dit transformÃ©es manuellement par le biais de votre passerelle de paiement.',0),(506659,14074,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰å–å¼•ã¯ã€æ‰‹å‹•ã§ãŠæ”¯æ‰•ã„ã‚²ãƒ¼ãƒˆã‚¦ã‚§ã‚¤ã‚’é€šã˜ã¦å‡¦ç†ã•ã‚Œã¾ã™ã€‚',0),(506660,14074,'pt','TransaÃ§Ãµes com cartÃ£o de crÃ©dito processadas manualmente atravÃ©s de seu gateway de pagamento.',0),(506661,14074,'ru','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð¿Ð¾ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¼ ÐºÐ°Ñ€Ñ‚Ð°Ð¼ Ð¾Ð±Ñ€Ð°Ð±Ð°Ñ‚Ñ‹Ð²Ð°ÑŽÑ‚ÑÑ Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ Ñ‡ÐµÑ€ÐµÐ· Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÑˆÐ»ÑŽÐ·.',0),(506662,14074,'es','Transacciones de tarjeta de crÃ©dito procesadas manualmente a travÃ©s de su pasarela de pago.',0),(506663,14074,'de','Kreditkarten-Transaktionen Ã¼ber Ihre Zahlungs-Gateway manuell verarbeitet.',0),(506664,14074,'en','Credit card transactions manually processed through your payment gateway.',0),(506665,14075,'is','',0),(506666,14075,'dr','Ú©Ø§Ù†Ø§Ø¯Ø§ Ø¨Ø± Ø§Ø³Ø§Ø³ Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ø¨Ø§ Ù†Ø±Ø® Ù…ØªÙˆØ³Ø·.',0),(506667,14075,'pr','Ú©Ø§Ù†Ø§Ø¯Ø§ Ø¨Ø± Ø§Ø³Ø§Ø³ Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ø¨Ø§ Ù†Ø±Ø® Ù…ØªÙˆØ³Ø·.',0),(506668,14075,'tr','Ortalama oranlar KanadalÄ± tabanlÄ± iÅŸlemci.',0),(506669,14075,'pl','Kanadyjski oparty procesor z Å›rednia cena.',0),(506670,14075,'bg','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ¸ Ð±Ð°Ð·Ð¸Ñ€Ð°Ð½Ð¸ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€ ÑÑŠÑ ÑÑ€ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸.',0),(506671,14075,'ur','Ù¾Ø±ÙˆØ³ÛŒØ³Ø± Ø³Û’ Ø§ÙˆØ³Ø· Ø´Ø±Ø­ Ø³Û’ Ú©ÛŒÙ†ÛŒÚˆØ§ Ù…ÛŒÚº Ù…Ù‚ÛŒÙ… ÛÛŒÚº Û”',0),(506672,14075,'sr','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ¸ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€ ÑÐ° Ð¿Ñ€Ð¾ÑÐµÑ‡Ð½Ðµ ÑÑ‚Ð¾Ð¿Ðµ.',0),(506673,14075,'vi','Canada dá»±a trÃªn bá»™ xá»­ lÃ½ vá»›i má»©c trung bÃ¬nh.',0),(506674,14075,'af','Kanadees-gebaseerde verwerker met \'n gemiddelde pryse.',0),(506675,14075,'ro','Canadiana procesor cu ratele medii.',0),(506676,14075,'et','Kanada pÃµhinev protsessor keskmised mÃ¤Ã¤rad.',0),(506677,14075,'si','Kanadsko-osnova predelovalec s povpreÄne stopnje.',0),(506678,14075,'ba','Kanada prosesor dengan harga rata-rata.',0),(506679,14075,'nl','Canadees-gebaseerde bewerker met gemiddelde percentages.',0),(506680,14075,'fi','Kanadalainen prosessori keskikursseja.',0),(506681,14075,'no','Canadisk-baserte prosessor med gjennomsnittlig priser.',0),(506682,14075,'da','Canadisk-baseret processor med gennemsnitlige priser.',0),(506683,14075,'ko','í‰ê·  ìš”ê¸ˆ ìºë‚˜ë‹¤-ê¸°ë°˜ í”„ë¡œì„¸ì„œìž…ë‹ˆë‹¤.',0),(506684,14075,'he','×ž×¢×‘×“ ×ž×‘×•×¡×¡ ×§× ×“×™ ×¢× ×ž×ž×•×¦×¢ ×”×ž×—×™×¨×™×.',0),(506685,14075,'el','ÎšÎ±Î½Î±Î´Î¹ÎºÎ® Ï€Î¿Ï… Î²Î±ÏƒÎ¯Î¶ÎµÏ„Î±Î¹ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î® Î¼Îµ Î¼Î­ÏƒÎµÏ‚ Ï„Î¹Î¼Î­Ï‚.',0),(506686,14075,'zh','ä»¥åŠ æ‹¿å¤§ä¸ºåŸºåœ°çš„å¤„ç†å™¨å¹³å‡çŽ‡ã€‚',0),(506687,14075,'sv','Kanada-baserat processorn med genomsnittliga priser.',0),(506688,14075,'it','Processore basato su canadese con tassi medi.',0),(506689,14075,'tl','',0),(506690,14075,'th','à¹‚à¸›à¸£à¹€à¸‹à¸ªà¹€à¸‹à¸­à¸£à¹Œà¸—à¸µà¹ˆà¹à¸„à¸™à¸²à¸”à¸²à¹‚à¸”à¸¢ à¸¡à¸µà¸£à¸²à¸„à¸²à¹€à¸‰à¸¥à¸µà¹ˆà¸¢',0),(506691,14075,'hi','à¤•à¤¨à¤¾à¤¡à¤¾-à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤° à¤”à¤¸à¤¤ à¤¦à¤°à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥à¥¤',0),(506692,14075,'ms','Pemproses berasaskan Kanada dengan kadar purata.',0),(506693,14075,'ar','Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬ Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø© Ø¥Ù„Ù‰ Ø§Ù„ÙƒÙ†Ø¯ÙŠØ© Ù…Ø¹ Ù…Ø¹Ø¯Ù„Ø§Øª Ù…ØªÙˆØ³Ø·.',0),(506694,14075,'fr','Processeur basÃ©e au Canada avec des taux moyens.',0),(506695,14075,'jp','å¹³å‡æ–™é‡‘ã§ã‚«ãƒŠãƒ€ ãƒ™ãƒ¼ã‚¹ã®ãƒ—ãƒ­ã‚»ãƒƒã‚µã€‚',0),(506696,14075,'pt','CanadÃ¡-baseado processador com taxas mÃ©dias.',0),(506697,14075,'ru','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ°Ñ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€ Ñ ÑÑ€ÐµÐ´Ð½Ð¸Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸.',0),(506698,14075,'es','Procesador canadiense con tasas promedio.',0),(506699,14075,'de','Canadian basierender Prozessor mit durchschnittlichen Wachstumsraten.',0),(506700,14075,'en','Canadian-based processor with average rates.',0),(506701,14076,'is','',0),(506702,14076,'dr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ú©Ù‡ Ø´Ù…Ø§ ÛŒÚ© Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ \"Ú©Ø§Ø±Øª Ø­Ø§Ø¶Ø± Ù†ÛŒØ³Øª\" Ùˆ Ù‡Ù…Ú†Ù†ÛŒÙ† Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§Ù†Ø¬Ø§Ù… Ù…Ø¹Ø§Ù…Ù„Ø§Øª \"Ú©Ø§Ø±Øª Ø­Ø¶ÙˆØ±\" ØªÙ†Ø¸ÛŒÙ….',0),(506703,14076,'pr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ú©Ù‡ Ø´Ù…Ø§ ÛŒÚ© Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ \"Ú©Ø§Ø±Øª Ø­Ø§Ø¶Ø± Ù†ÛŒØ³Øª\" Ùˆ Ù‡Ù…Ú†Ù†ÛŒÙ† Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§Ù†Ø¬Ø§Ù… Ù…Ø¹Ø§Ù…Ù„Ø§Øª \"Ú©Ø§Ø±Øª Ø­Ø¶ÙˆØ±\" ØªÙ†Ø¸ÛŒÙ….',0),(506704,14076,'tr','Bu size bir iÅŸlemciye kadar \"Kart mevcut deÄŸil iÃ§in\" hem de \"Kart mevcut\" iÅŸlemler iÃ§in bir iÅŸlemci ayarlamanÄ±z Ã¶nerilir.',0),(506705,14076,'pl','Zalecane jest, Å¼e ustawisz siÄ™ procesor dla \"Karty nie obecny\" oraz procesor dla \"Karty obecny\" transakcji.',0),(506706,14076,'bg','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑŠÑ‡Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ðµ Ð´Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€ Ð·Ð° \"ÐšÐ°Ñ€Ñ‚Ð¸ Ð½Ðµ Ð¿Ñ€Ð¸ÑÑŠÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰\" ÐºÐ°ÐºÑ‚Ð¾ Ð¸ ÐµÐ´Ð¸Ð½ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€ Ð·Ð° \"ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸ ÐºÐ°Ñ€Ñ‚Ð°\" ÑÐ´ÐµÐ»ÐºÐ¸.',0),(506707,14076,'ur','ÛŒÛ Ø³ÙØ§Ø±Ø´ Ú©ÛŒ Ø¬Ø§ØªÛŒ ÛÛ’ Ø§Ù¾ Ø§ÛŒÚ© Ù¾Ø±ÙˆØ³ÛŒØ³Ø± \"Ú©Ø§Ø±Úˆ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛÛŒÚº Ú©Û’ Ù„Ø¦Û’\" Ú©Û’ Ø³Ø§ØªÚ¾ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ù¾Ø±ÙˆØ³ÛŒØ³Ø± \"Ù…ÙˆØ¬ÙˆØ¯ Ú©Ø§Ø±Úˆ\" Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ù„Ø¦Û’ Ú©Û Ø¢Ù¾ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Û”',0),(506708,14076,'sr','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑƒÑ‡Ñ™Ð¸Ð²Ð¾ Ñ˜Ðµ Ð´Ð° Ð¿Ð¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€ Ð·Ð°\"ÐšÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¸ÑÑƒÑ‚Ð°Ð½\" ÐºÐ°Ð¾ Ð¸ Ð·Ð° Ð¾Ð±Ñ€Ð°Ð´Ñƒ Ñ‚ÐµÐºÑÑ‚Ð° Ð·Ð°\"ÐŸÐ¾ÐºÐ»Ð¾Ð½ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°\" Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ.',0),(506709,14076,'vi','ÄÃ³ khuyáº¿n cÃ¡o ráº±ng báº¡n thiáº¿t láº­p má»™t bá»™ xá»­ lÃ½ cho \"Tháº» khÃ´ng cÃ³\" cÅ©ng nhÆ° má»™t bá»™ xá»­ lÃ½ cho cÃ¡c giao dá»‹ch \"Tháº» hiá»‡n táº¡i\".',0),(506710,14076,'af','Dit word aanbeveel dat jy stel \'n verwerker vir \"Kaart nie teenwoordig nie\" asook \'n verwerker vir \"Kaart teenwoordig\" transaksies.',0),(506711,14076,'ro','Este recomandat sÄƒ setaÅ£i pÃ¢nÄƒ un procesor pentru \"Card nu este prezent\", precum ÅŸi un procesor pentru tranzacÅ£iile de \"Carte de prezent\".',0),(506712,14076,'et','Soovitatav on seadistada tÃ¶Ã¶tleja puhul \"Kaart ei esine\" ning \"Kaardi kohal\" tehingute protsessor.',0),(506713,14076,'si','PriporoÄljivo je, da nastavite procesor za \"Kartica ni prisotna\" ter procesor za \"Kartico prisotna\" transakcije.',0),(506714,14076,'ba','Dianjurkan bahwa Anda mengatur sebuah prosesor untuk \"Kartu tidak ada\" serta prosesor untuk \"Kartu hadir\" transaksi.',0),(506715,14076,'nl','Het is aanbevolen dat u een processor voor ingesteld \"Card niet aanwezig\" evenals een processor voor \"Kaart aanwezig\" transacties.',0),(506716,14076,'fi','On suositeltavaa, ettÃ¤ mÃ¤Ã¤ritÃ¤t prosessori \"Kortti ei lÃ¤snÃ¤\" sekÃ¤ prosessori \"Kortti lÃ¤snÃ¤\" tapahtumat.',0),(506717,14076,'no','Det anbefales at du setter opp en prosessor for \"Kort ikke tilstede\" og en prosessor for \"Kort tilstede\" transaksjoner.',0),(506718,14076,'da','Det anbefales, at du konfigurerer en processor til \"Kort ikke til stede\" samt en processor til \"Kort til stede\" transaktioner.',0),(506719,14076,'ko','ì„¤ì • í•˜ëŠ” í”„ë¡œì„¸ì„œë¥¼ \"ì¹´ë“œ ì—†ëŠ”\" \"ì¹´ë“œ í˜„ìž¬\" ê±°ëž˜ì— ëŒ€ í•œ í”„ë¡œì„¸ì„œ ë¿ë§Œ ì•„ë‹ˆë¼ í•˜ëŠ” ê²ƒì´ ì¢‹ìŠµë‹ˆë‹¤.',0),(506720,14076,'he','×ž×•×ž×œ×¥ ×œ×”×’×“×™×¨ ×ž×¢×‘×“ ×¢×‘×•×¨ \"×”×›×¨×˜×™×¡ ××™× ×• ×§×™×™×\" ×›×ž×• ×’× ×ž×¢×‘×“ ×¢×‘×•×¨ ×ª× ×•×¢×•×ª \"×›×¨×˜×™×¡ ×ž×ª× ×”\".',0),(506721,14076,'el','Î£Ï…Î½Î¹ÏƒÏ„Î¬Ï„Î±Î¹ ÏŒÏ„Î¹ ÏÏ…Î¸Î¼Î¯Î¶ÎµÏ„Îµ Î­Î½Î±Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î® Î³Î¹Î± Ï„Î·Î½ \"ÎšÎ¬ÏÏ„Î± ÏŒÏ‡Î¹ Ï€Î±ÏÎ¿Ï…ÏƒÎ¯Î±\" ÎºÎ±Î¸ÏŽÏ‚ ÎºÎ±Î¹ Î­Î½Î±Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î® Î³Î¹Î± Ï„Î·Î½ \"ÎšÎ¬ÏÏ„Î± Ï€Î±ÏÏŒÎ½\" Ï€ÏÎ¬Î¾ÎµÎ¹Ï‚.',0),(506722,14076,'zh','å»ºè®®æ‚¨è®¾ç½®ä¸€ä¸ªå¤„ç†å™¨ä¸º\"å¡ä¸å­˜åœ¨\"ä»¥åŠ\"å¡å‡ºå¸­\"äº¤æ˜“çš„å¤„ç†å™¨ã€‚',0),(506723,14076,'sv','Det rekommenderas att du stÃ¤ller in en processor fÃ¶r \"Kort inte nÃ¤rvarande\" samt en processor fÃ¶r \"Kort nÃ¤rvarande\" transaktioner.',0),(506724,14076,'it','Si consiglia di impostare un processore per \"Carta non presente\" oltre a un processore per transazioni \"Presente carta\".',0),(506725,14076,'tl','',0),(506726,14076,'th','à¸‚à¸­à¹à¸™à¸°à¸™à¸³à¹ƒà¸«à¹‰ à¸„à¸¸à¸“à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸•à¸±à¸§à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¸ªà¸³à¸«à¸£à¸±à¸š \"à¸šà¸±à¸•à¸£à¹„à¸¡à¹ˆà¸¡à¸µ\" à¹€à¸Šà¹ˆà¸™à¹€à¸”à¸µà¸¢à¸§à¸à¸±à¸šà¸•à¸±à¸§à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¸ªà¸³à¸«à¸£à¸±à¸šà¸˜à¸¸à¸£à¸à¸£à¸£à¸¡ \"à¸',0),(506727,14076,'hi','à¤¯à¤¹ à¤…à¤¨à¥à¤¶à¤‚à¤¸à¤¿à¤¤ à¤¹à¥ˆ à¤•à¤¿ à¤†à¤ª à¤à¤• à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤° à¤…à¤ª \"à¤•à¤¾à¤°à¥à¤¡ à¤¨à¤¹à¥€à¤‚ à¤®à¥Œà¤œà¥‚à¤¦ à¤•à¥‡ à¤²à¤¿à¤\" \"à¤•à¤¾à¤°à¥à¤¡ à¤®à¥Œà¤œà¥‚à¤¦\" à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸',0),(506728,14076,'ms','Adalah disyorkan bahawa anda menyediakan pemproses untuk \"Kad tidak hadir\" serta pemproses untuk transaksi \"Kad sekarang\".',0),(506729,14076,'ar','Ù…Ù† Ø§Ù„Ù…Ø³ØªØ­Ø³Ù† Ù„Ùƒ Ø¥Ø¹Ø¯Ø§Ø¯ Ù…Ø¹Ø§Ù„Ø¬ Ù„Ø¨Ø·Ø§Ù‚Ø© \"ØºÙŠØ± Ù…ÙˆØ¬ÙˆØ¯\" ÙØ¶Ù„Ø§ Ø¹Ù† Ù…Ø¹Ø§Ù„Ø¬ Ù„Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª \"Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø­Ø§Ù„ÙŠ\".',0),(506730,14076,'fr','Il est recommandÃ© que vous configuriez un processeur pour la Â« Carte non prÃ©sente Â» ainsi que d\'un processeur pour les transactions Â« Carte prÃ©sente Â».',0),(506731,14076,'jp','ãƒ—ãƒ­ã‚»ãƒƒã‚µã‚’ã€Œã‚«ãƒ¼ãƒ‰ç¾åœ¨ã®ã€ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã®ãƒ—ãƒ­ã‚»ãƒƒã‚µã ã‘ã§ãªãã€ã€Œã‚«ãƒ¼ãƒ‰ãªã„ç¾åœ¨ã€ã‚’è¨­å®šã™ã‚‹ã“ã¨ã‚’ãŠå‹§ã‚ã—ã¾ã™ã€‚',0),(506732,14076,'pt','Ã‰ recomendÃ¡vel que vocÃª configure um processador para \"CartÃ£o nÃ£o presente\" assim como um processador de transaÃ§Ãµes \"CartÃ£o presente\".',0),(506733,14076,'ru','Ð ÐµÐºÐ¾Ð¼ÐµÐ½Ð´ÑƒÐµÑ‚ÑÑ, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€ Ð´Ð»Ñ Â«ÐšÐ°Ñ€Ñ‚Ñ‹ Ð½Ðµ Ð¿Ñ€Ð¸ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚Â» Ð° Ñ‚Ð°ÐºÐ¶Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€ Ð´Ð»Ñ Â«ÐšÐ°Ñ€Ñ‚Ñ‹ Ð¿Ð¾Ð´Ð°Ñ€Ð¾ÐºÂ» ÑÐ´ÐµÐ»Ð¾Ðº.',0),(506734,14076,'es','Se recomienda que configura un procesador para \"Tarjeta no presente\" asÃ­ como un procesador para las transacciones \"Tarjeta regalo\".',0),(506735,14076,'de','Es wird empfohlen, dass Sie einen Prozessor fÃ¼r \"Karte nicht vorhanden\" sowie einen Prozessor fÃ¼r \"Card Present\" Transaktionen einrichten.',0),(506736,14076,'en','It is recommended that you set up a processor for \"Card Not Present\" as well as a processor for \"Card Present\" transactions.',0),(506737,14077,'is','',0),(506738,14077,'dr','Ù…Ù† Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÛŒÚ© Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ø§Ø³Øª.',0),(506739,14077,'pr','Ù…Ù† Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÛŒÚ© Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡ Ø§Ø³Øª.',0),(506740,14077,'tr','Bir iÅŸlemci var zaten.',0),(506741,14077,'pl','Mam juÅ¼ procesor.',0),(506742,14077,'bg','ÐÐ· Ð²ÐµÑ‡Ðµ Ð¸Ð¼Ð°Ð¼ ÐµÐ´Ð¸Ð½ Ð¿Ñ€Ð¾Ñ†ÐµÑÐ¾Ñ€.',0),(506743,14077,'ur','Ù…ÛŒÚº Ù¾ÛÙ„Û’ ÛÛŒ Ø§ÛŒÚ© Ù¾Ø±ÙˆØ³ÛŒØ³Ø± ÛÛ’.',0),(506744,14077,'sr','Ð’ÐµÑ› Ð¸Ð¼Ð°Ð¼ Ð·Ð° Ð¾Ð±Ñ€Ð°Ð´Ñƒ Ñ‚ÐµÐºÑÑ‚Ð°.',0),(506745,14077,'vi','TÃ´i Ä‘Ã£ cÃ³ má»™t bá»™ xá»­ lÃ½.',0),(506746,14077,'af','Ek het reeds \'n verwerker.',0),(506747,14077,'ro','Am deja un procesor.',0),(506748,14077,'et','Mul juba on protsessor.',0),(506749,14077,'si','Imam Å¾e procesor.',0),(506750,14077,'ba','Saya sudah memiliki prosesor.',0),(506751,14077,'nl','Ik heb al een processor.',0),(506752,14077,'fi','Olen jo prosessori.',0),(506753,14077,'no','Jeg har allerede en prosessor.',0),(506754,14077,'da','Jeg har allerede en processor.',0),(506755,14077,'ko','ë‚œ ì´ë¯¸ í”„ë¡œì„¸ì„œ.',0),(506756,14077,'he','×™×© ×œ×™ ×›×‘×¨ ×ž×¢×‘×“.',0),(506757,14077,'el','ÎˆÏ‡Ï‰ Î®Î´Î· Î­Î½Î±Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î®.',0),(506758,14077,'zh','æˆ‘å·²ç»æœ‰ä¸€ä¸ªå¤„ç†å™¨ã€‚',0),(506759,14077,'sv','Jag har redan en processor.',0),(506760,14077,'it','Ho giÃ  un processore.',0),(506761,14077,'tl','',0),(506762,14077,'th','à¸œà¸¡à¸¡à¸µà¸•à¸±à¸§à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥',0),(506763,14077,'hi','à¤®à¥ˆà¤‚ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤à¤• à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤° à¤¹à¥ˆà¥¤',0),(506764,14077,'ms','Saya sudah mempunyai pemproses.',0),(506765,14077,'ar','Ù„Ø¯Ù‰ Ø¨Ø§Ù„ÙØ¹Ù„ Ù…Ø¹Ø§Ù„Ø¬.',0),(506766,14077,'fr','J\'ai dÃ©jÃ  un processeur.',0),(506767,14077,'jp','ç§ã¯ã™ã§ã«ãƒ—ãƒ­ã‚»ãƒƒã‚µã‚’æŒã£ã¦ã„ã¾ã™ã€‚',0),(506768,14077,'pt','Eu jÃ¡ tenho um processador.',0),(506769,14077,'ru','Ð£ Ð¼ÐµÐ½Ñ ÑƒÐ¶Ðµ ÐµÑÑ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€.',0),(506770,14077,'es','Ya tengo un procesador.',0),(506771,14077,'de','Ich habe bereits einen Prozessor.',0),(506772,14077,'en','I already have a processor.',0),(506773,14078,'is','',0),(506774,14078,'dr','Ø«Ø¨Øª Ù†Ø§Ù…',0),(506775,14078,'pr','Ø«Ø¨Øª Ù†Ø§Ù…',0),(506776,14078,'tr','Kaydol',0),(506777,14078,'pl','Zarejestruj siÄ™',0),(506778,14078,'bg','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ ÑÐµ',0),(506779,14078,'ur','Ø³Ø§Ø¦Ù† Ø§Ù¾ Ú©Ø±ÛŒÚº',0),(506780,14078,'sr','Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸ ÑÐµ',0),(506781,14078,'vi','ÄÄƒng kÃ½',0),(506782,14078,'af','Teken in',0),(506783,14078,'ro','Ã®nscrie-te',0),(506784,14078,'et','Pane nimi kirja',0),(506785,14078,'si','prijava',0),(506786,14078,'ba','Tandatangan',0),(506787,14078,'nl','Aanmelden',0),(506788,14078,'fi','KiinnittÃ¤Ã¤',0),(506789,14078,'no','melde seg pÃ¥',0),(506790,14078,'da','Tilmeld dig',0),(506791,14078,'ko','ê³„ì • ì‹ ì²­',0),(506792,14078,'he','×”×™×¨×©×',0),(506793,14078,'el','Î•Î³Î³ÏÎ±Ï†Î®',0),(506794,14078,'zh','ç™»è®°',0),(506795,14078,'sv','Registrera sig',0),(506796,14078,'it','Registrati',0),(506797,14078,'tl','',0),(506798,14078,'th','à¹„à¸‹à¸™à¹Œà¸­à¸±à¸ž',0),(506799,14078,'hi','à¤¨à¤¾à¤® à¤²à¤¿à¤–à¥‹',0),(506800,14078,'ms','mendaftar',0),(506801,14078,'ar','Ø§Ù„ØªØ³Ø¬ÙŠÙ„',0),(506802,14078,'fr','Inscrivez-vous',0),(506803,14078,'jp','ã‚µã‚¤ãƒ³ã‚¢ãƒƒãƒ—',0),(506804,14078,'pt','InscriÃ§Ã£o',0),(506805,14078,'ru','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ',0),(506806,14078,'es','Ãšnete',0),(506807,14078,'de','Anmelden',0),(506808,14078,'en','Sign Up',0),(506809,14079,'is','',0),(506810,14079,'dr','Ø§Ø³ØªØ­Ú©Ø§Ù… Ú¯Ø°Ø±ÙˆØ§Ú˜Ù‡ 2 ÛŒØ§ Ø¨ÛŒØ´ØªØ± Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ø§Ø³Øª.',0),(506811,14079,'pr','Ø§Ø³ØªØ­Ú©Ø§Ù… Ú¯Ø°Ø±ÙˆØ§Ú˜Ù‡ 2 ÛŒØ§ Ø¨ÛŒØ´ØªØ± Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ø§Ø³Øª.',0),(506812,14079,'tr','Parola gÃ¼venlik dÃ¼zeyi 2 veya daha gereklidir.',0),(506813,14079,'pl','Wymagana siÅ‚a hasÅ‚a 2 lub wiÄ™cej.',0),(506814,14079,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð° ÑÐºÐ¾ÑÑ‚ Ð½Ð° 2 Ð¸Ð»Ð¸ Ð¿Ð¾Ð²ÐµÑ‡Ðµ ÑÐµ Ð¸Ð·Ð¸ÑÐºÐ²Ð°.',0),(506815,14079,'ur','Ø§ÛŒÚ© Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø·Ø§Ù‚Øª 2 ÛŒØ§ Ø§Ø³ Ø³Û’ Ø²ÛŒØ§Ø¯Û Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(506816,14079,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ñ˜Ðµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐ° ÑÐ½Ð°Ð³Ñƒ Ð¾Ð´ 2 Ð¸Ð»Ð¸ Ð²Ð¸ÑˆÐµ.',0),(506817,14079,'vi','Má»™t máº­t kháº©u máº¡nh cá»§a 2 hoáº·c nhiá»u hÆ¡n lÃ  cáº§n thiáº¿t.',0),(506818,14079,'af','\'N wagwoord krag van 2 of meer is nodig.',0),(506819,14079,'ro','O rezistenÅ£Äƒ de parola de 2 sau mai mult este necesar.',0),(506820,14079,'et','Parooli tugevuse 2 vÃµi rohkem on vaja.',0),(506821,14079,'si','Geslo moÄ 2 ali veÄ je potrebno.',0),(506822,14079,'ba','Diperlukan kekuatan sandi 2 atau lebih.',0),(506823,14079,'nl','De sterkte van een wachtwoord van 2 of meer is vereist.',0),(506824,14079,'fi','Salasanan vahvuus 2 tai enemmÃ¤n tarvitaan.',0),(506825,14079,'no','Det kreves et Passordstyrke av 2 eller flere.',0),(506826,14079,'da','En styrke for adgangskode af 2 eller flere er pÃ¥krÃ¦vet.',0),(506827,14079,'ko','2 ê°œ ì´ìƒì˜ ì•”í˜¸ íž˜ì´ í•„ìš” í•©ë‹ˆë‹¤.',0),(506828,14079,'he','×—×•×–×§ ×”×¡×™×¡×ž×” ×©×œ 2 ××• ×™×•×ª×¨ × ×“×¨×©.',0),(506829,14079,'el','Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î¼Î¹Î± Î´ÏÎ½Î±Î¼Î· ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ 2 Î® Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ±.',0),(506830,14079,'zh','2 åæˆ–æ›´å¤šçš„å¯†ç å¼ºåº¦æ˜¯å¿…éœ€çš„ã€‚',0),(506831,14079,'sv','Det krÃ¤vs ett lÃ¶senordsstyrka pÃ¥ 2 eller mer.',0),(506832,14079,'it','Una forza di password di 2 o piÃ¹ Ã¨ necessaria.',0),(506833,14079,'tl','',0),(506834,14079,'th','à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸„à¸§à¸²à¸¡à¹à¸£à¸‡à¸‚à¸­à¸‡ 2 à¸«à¸£à¸·à¸­à¸¡à¸²à¸à¸à¸§à¹ˆà¸²à¸™à¸±à¹‰à¸™à¸ˆà¸³à¹€à¸›à¹‡à¸™à¸•à¹‰à¸­à¸‡',0),(506835,14079,'hi','à¤à¤• à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¤à¤¾à¤•à¤¤ 2 à¤¯à¤¾ à¤…à¤§à¤¿à¤• à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(506836,14079,'ms','Kekuatan kata laluan 2 atau lebih adalah diperlukan.',0),(506837,14079,'ar','Ù…Ø·Ù„ÙˆØ¨ Ù‚ÙˆØ© ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ù…Ù† 2 Ø£Ùˆ Ø£ÙƒØ«Ø±.',0),(506838,14079,'fr','Il faut une force de mot de passe de 2 ou plus.',0),(506839,14079,'jp','2 ã¤ä»¥ä¸Šã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®å¼·åº¦ãŒå¿…è¦ã§ã™ã€‚',0),(506840,14079,'pt','Uma forÃ§a de senha de 2 ou mais Ã© necessÃ¡ria.',0),(506841,14079,'ru','ÐÐ°Ð´ÐµÐ¶Ð½Ð¾ÑÑ‚ÑŒ Ð¿Ð°Ñ€Ð¾Ð»Ñ 2 Ð¸Ð»Ð¸ Ð±Ð¾Ð»ÑŒÑˆÐµ Ð½Ðµ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ.',0),(506842,14079,'es','Se requiere una contraseÃ±a de 2 o mÃ¡s.',0),(506843,14079,'de','Eine PasswortstÃ¤rke von 2 oder mehr ist erforderlich.',0),(506844,14079,'en','A password strength of 2 or more is required.',0),(506845,14080,'is','',0),(506846,14080,'dr','Ø§Ø³ØªØ­Ú©Ø§Ù… Ú¯Ø°Ø±ÙˆØ§Ú˜Ù‡',0),(506847,14080,'pr','Ø§Ø³ØªØ­Ú©Ø§Ù… Ú¯Ø°Ø±ÙˆØ§Ú˜Ù‡',0),(506848,14080,'tr','Parola gÃ¼venlik dÃ¼zeyi',0),(506849,14080,'pl','SiÅ‚a hasÅ‚a',0),(506850,14080,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð° ÑÐºÐ¾ÑÑ‚',0),(506851,14080,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ú©ÛŒ Ø·Ø§Ù‚Øª',0),(506852,14080,'sr','Ð¡Ð½Ð°Ð³Ð° ÑˆÐ¸Ñ„Ñ€Ð¾Ð²Ð°ÑšÐ° Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ',0),(506853,14080,'vi','Máº­t kháº©u sá»©c máº¡nh',0),(506854,14080,'af','Wagwoord krag',0),(506855,14080,'ro','Puterea parola',0),(506856,14080,'et','SalasÃµna tugevus',0),(506857,14080,'si','Geslo moÄ',0),(506858,14080,'ba','Kekuatan kata sandi',0),(506859,14080,'nl','Wachtwoordsterkte',0),(506860,14080,'fi','Salasanan vahvuus',0),(506861,14080,'no','Passordstyrke',0),(506862,14080,'da','Styrke for adgangskode',0),(506863,14080,'ko','ì•”í˜¸ ê°•ë„',0),(506864,14080,'he','×—×•×–×§ ×¡×™×¡×ž××•×ª',0),(506865,14080,'el','Î™ÏƒÏ‡ÏÏ‚ ÎºÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(506866,14080,'zh','å¯†ç å¼ºåº¦',0),(506867,14080,'sv','LÃ¶senordsstyrka',0),(506868,14080,'it','Forza password',0),(506869,14080,'tl','',0),(506870,14080,'th','à¸„à¸§à¸²à¸¡à¹à¸£à¸‡à¸‚à¸­à¸‡à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™',0),(506871,14080,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¤à¤¾à¤•à¤¤',0),(506872,14080,'ms','Kekuatan kata laluan',0),(506873,14080,'ar','Ù‚ÙˆØ© ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ±',0),(506874,14080,'fr','Force de mot de passe',0),(506875,14080,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®å¼·åº¦',0),(506876,14080,'pt','ForÃ§a da senha',0),(506877,14080,'ru','ÐÐ°Ð´ÐµÐ¶Ð½Ð¾ÑÑ‚ÑŒ Ð¿Ð°Ñ€Ð¾Ð»Ñ',0),(506878,14080,'es','ContraseÃ±a',0),(506879,14080,'de','PasswortstÃ¤rke',0),(506880,14080,'en','Password Strength',0),(506881,14081,'is','',0),(506882,14081,'dr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ ØªÙ…Ø§Ø³',0),(506883,14081,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ ØªÙ…Ø§Ø³',0),(506884,14081,'tr','KiÅŸi notlarÄ±',0),(506885,14081,'pl','Notatki o kontaktach',0),(506886,14081,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(506887,14081,'ur','Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯ Ù†ÙˆÙ¹',0),(506888,14081,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(506889,14081,'vi','LiÃªn há»‡ ghi chÃº',0),(506890,14081,'af','Kontak notas',0),(506891,14081,'ro','Note de contact',0),(506892,14081,'et','KontaktimÃ¤rkmed',0),(506893,14081,'si','Kontaktne opombe',0),(506894,14081,'ba','Catatan kontak',0),(506895,14081,'nl','Contact notities',0),(506896,14081,'fi','YhteyshenkilÃ¶n muistiinpanot',0),(506897,14081,'no','Kontaktnotater',0),(506898,14081,'da','Kontakt noter',0),(506899,14081,'ko','ì—°ë½ì²˜ ë…¸íŠ¸',0),(506900,14081,'he','×¤×ª×§×™ ××™×© ×§×©×¨',0),(506901,14081,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ ÎµÏ€Î±Ï†ÏŽÎ½',0),(506902,14081,'zh','è”ç³»äººç¬”è®°',0),(506903,14081,'sv','Kontaktanteckningar',0),(506904,14081,'it','Note contatti',0),(506905,14081,'tl','',0),(506906,14081,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸•à¸´à¸”à¸•à¹ˆà¸­',0),(506907,14081,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤¨à¥‹à¤Ÿà¥à¤¸',0),(506908,14081,'ms','Nota-Nota berhubung',0),(506909,14081,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø¬Ù‡Ø© Ø§Ù„Ø§ØªØµØ§Ù„',0),(506910,14081,'fr','Contact Notes',0),(506911,14081,'jp','é€£çµ¡å…ˆãƒŽãƒ¼ãƒˆ',0),(506912,14081,'pt','Contatos notas',0),(506913,14081,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð°Ñ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(506914,14081,'es','Notas de contacto',0),(506915,14081,'de','Kontakt Hinweise',0),(506916,14081,'en','Contact Notes',0),(506917,14082,'is','',0),(506918,14082,'dr','ØªÙˆØ¬Ù‡ Ø¨Ù‡ Ú¯Ø³ØªØ±Ø´ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(506919,14082,'pr','ØªÙˆØ¬Ù‡ Ø¨Ù‡ Ú¯Ø³ØªØ±Ø´ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(506920,14082,'tr','Not geniÅŸletmek iÃ§in tÄ±klatÄ±n',0),(506921,14082,'pl','Uwaga kliknij, aby rozwinÄ…Ä‡',0),(506922,14082,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð·Ð°Ð¿Ð¸ÑÐºÐ°Ñ‚Ð° Ð·Ð° Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÑÐ²Ð°Ð½Ðµ',0),(506923,14082,'ur','ØªÙˆØ³ÛŒØ¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù†ÙˆÙ¹ Ú©Ø±ÛŒÚº Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(506924,14082,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑƒÐºÑƒ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¾ÑˆÐ¸Ñ€Ð¸Ð»Ð¸',0),(506925,14082,'vi','Nháº¥p vÃ o lÆ°u Ã½ Ä‘á»ƒ má»Ÿ rá»™ng',0),(506926,14082,'af','Klik daarop uit te brei',0),(506927,14082,'ro','FaceÅ£i clic pe NotÄƒ pentru a extinde',0),(506928,14082,'et','MÃ¤rkus laiendamiseks klÃµpsake',0),(506929,14082,'si','Kliknite Opomba razÅ¡iriti',0),(506930,14082,'ba','Catatan klik untuk memperluas',0),(506931,14082,'nl','Klik op notitie om uit te breiden',0),(506932,14082,'fi','Valitse huomautus laajentaa',0),(506933,14082,'no','Klikk notat Ã¥ utvide',0),(506934,14082,'da','Klik pÃ¥ Note at udvide',0),(506935,14082,'ko','í™•ìž¥ í•˜ë ¤ë©´ í´ë¦­ í•˜ì‹­ì‹œì˜¤. ì°¸ê³ ',0),(506936,14082,'he','×œ×—×¥ ×¢×œ ×”×¢×¨×” ×›×“×™ ×œ×”×¨×—×™×‘',0),(506937,14082,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î·Î½ ÎµÎ½Ï„Î¿Î»Î® ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ· Î³Î¹Î± Ï„Î·Î½ ÎµÏ€Î­ÎºÏ„Î±ÏƒÎ·',0),(506938,14082,'zh','å•å‡»ä¾¿ç¬ºæ‰©å¤§',0),(506939,14082,'sv','Klicka pÃ¥ anteckning att expandera',0),(506940,14082,'it','Nota fare clic per espandere',0),(506941,14082,'tl','',0),(506942,14082,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸„à¸¥à¸´à¸à¸‚à¸¢à¸²à¸¢',0),(506943,14082,'hi','à¤¨à¥‹à¤Ÿ à¤•à¤¾ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(506944,14082,'ms','Klik Nota untuk mengembangkan',0),(506945,14082,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ ØªÙˆØ³ÙŠØ¹',0),(506946,14082,'fr','Cliquez sur la Note d\'Ã©largir',0),(506947,14082,'jp','ãƒ¡ãƒ¢ã‚’å±•é–‹ã™ã‚‹ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(506948,14082,'pt','Nota clique para expandir',0),(506949,14082,'ru','Ð©ÐµÐ»ÐºÐ½Ð¸Ñ‚Ðµ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ Ð´Ð»Ñ Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð¸Ñ',0),(506950,14082,'es','Nota haga clic para ampliar',0),(506951,14082,'de','Klicken Sie auf Notiz zu erweitern',0),(506952,14082,'en','Click Note To Expand',0),(506953,14083,'is','',0),(506954,14083,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(506955,14083,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(506956,14083,'tr','VarsayÄ±lan satÄ±cÄ± iÃ§in sipariÅŸleri',0),(506957,14083,'pl','DomyÅ›lny dostawca zamÃ³wieÅ„',0),(506958,14083,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(506959,14083,'ur','Ø­Ú©Ù… Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û ÙØ±ÙˆØ´Ù†Ø¯Û',0),(506960,14083,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(506961,14083,'vi','NhÃ  cung cáº¥p máº·c Ä‘á»‹nh cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(506962,14083,'af','Verstek handelaar vir bestellings',0),(506963,14083,'ro','Furnizor implicit pentru comenzi',0),(506964,14083,'et','Vaikimisi hankija tellimused',0),(506965,14083,'si','Privzetega dobavitelja za naroÄila',0),(506966,14083,'ba','Default Vendor untuk pesanan',0),(506967,14083,'nl','Standaard leverancier voor bestellingen',0),(506968,14083,'fi','Toimittajan tilauksia',0),(506969,14083,'no','StandardleverandÃ¸r For ordrer',0),(506970,14083,'da','StandardleverandÃ¸ren For ordrer',0),(506971,14083,'ko','ì£¼ë¬¸ì— ëŒ€ í•œ ê¸°ë³¸ ê³µê¸‰ ì—…ì²´',0),(506972,14083,'he','×¡×¤×§ ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×‘×•×¨ ×”×–×ž× ×•×ª',0),(506973,14083,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®Ï‚ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(506974,14083,'zh','é»˜è®¤ä¾›åº”å•†è®¢å•',0),(506975,14083,'sv','StandardleverantÃ¶r fÃ¶r order',0),(506976,14083,'it','Fornitore predefinito per gli ordini',0),(506977,14083,'tl','',0),(506978,14083,'th','à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(506979,14083,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(506980,14083,'ms','Penjual lalai untuk Tempahan',0),(506981,14083,'ar','Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ø£ÙˆØ§Ù…Ø±',0),(506982,14083,'fr','Fournisseur par dÃ©faut pour les commandes',0),(506983,14083,'jp','æ—¢å®šã®ä»•å…¥å…ˆã®æ³¨æ–‡',0),(506984,14083,'pt','Fornecedor padrÃ£o para encomendas',0),(506985,14083,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(506986,14083,'es','Proveedor predeterminado para pedidos',0),(506987,14083,'de','Standardlieferant fÃ¼r Bestellungen',0),(506988,14083,'en','Default Vendor For Orders',0),(506989,14084,'is','',0),(506990,14084,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ Ø®Ø¯Ù…Ø§Øª Ø³ÙØ§Ø±Ø´ ØµÙØ­Ù‡ Ù†Ù…Ø§ÛŒØ´',0),(506991,14084,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ Ø®Ø¯Ù…Ø§Øª Ø³ÙØ§Ø±Ø´ ØµÙØ­Ù‡ Ù†Ù…Ø§ÛŒØ´',0),(506992,14084,'tr','Servis sipariÅŸindeki mÃ¼ÅŸterinin notlarÄ± dÃ¼zenlemek ekran gÃ¶ster',0),(506993,14084,'pl','PokaÅ¼, Å¼e ekran Edit klienta Notes na zlecenie serwisowe',0),(506994,14084,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸Ñ‚Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð· Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ ÐµÐºÑ€Ð°Ð½',0),(506995,14084,'ur','Ú©Ø³Ù¹Ù…Ø± Ù†ÙˆÙ¹Ø³ Ú©ÛŒ Ø®Ø¯Ù…Øª Ú©Û’ Ø­Ú©Ù… Ù¾Ø± Ø³Ú©Ø±ÛŒÙ† ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(506996,14084,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð±ÐµÐ»ÐµÑˆÐºÐµ ÐºÑƒÐ¿Ñ†Ð° Ñƒ Ð½Ð°Ð»Ð¾Ð³Ñƒ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ Ð£Ñ€ÐµÐ´Ð¸ ÐµÐºÑ€Ð°Ð½Ð°',0),(506997,14084,'vi','Hiá»ƒn thá»‹ khÃ¡ch hÃ ng ghi chÃº vá» Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥ chá»‰nh sá»­a mÃ n hÃ¬nh',0),(506998,14084,'af','KliÃ«nt notas op diens bestel redigeer skerm wys',0),(506999,14084,'ro','AratÄƒ Note client pe comanda de Service edita ecran',0),(507000,14084,'et','NÃ¤ita kliendi mÃ¤rgib hooldustellimusel muuta ekraani',0),(507001,14084,'si','PokaÅ¾i kupca pojasnilih servisni nalog Edit zaslon',0),(507002,14084,'ba','Tampilkan catatan pelanggan pada layanan agar layar Edit',0),(507003,14084,'nl','Toon klant notities op serviceorder bewerken scherm',0),(507004,14084,'fi','NÃ¤ytÃ¤ asiakkaan huomautuksia huoltotilauksen muokata nÃ¤ytÃ¶n',0),(507005,14084,'no','Vis kunde notater pÃ¥ serviceordren Rediger skjermen',0),(507006,14084,'da','Vis kunde noter pÃ¥ serviceordren redigere skÃ¦rm',0),(507007,14084,'ko','ê³ ê° ì„œë¹„ìŠ¤ ì£¼ë¬¸ì— ë©”ëª¨ íŽ¸ì§‘ í™”ë©´ í‘œì‹œ',0),(507008,14084,'he','×”×¦×’ ×”×¢×¨×•×ª ×”×œ×§×•×— ×¢×œ ×”×–×ž× ×ª ×©×™×¨×•×ª ×¢×¨×™×›×ª ×ž×¡×š',0),(507009,14084,'el','Î”ÎµÎ¯Ï„Îµ Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Ï€ÎµÎ»Î¬Ï„Î· ÏƒÏ„Î·Î½ ÎµÎ½Ï„Î¿Î»Î® Ï„ / ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î¿Î¸ÏŒÎ½Î·',0),(507010,14084,'zh','æ˜¾ç¤ºæœåŠ¡è®¢å•ä¸Šçš„å®¢æˆ·æ³¨é‡Šç¼–è¾‘å±å¹•',0),(507011,14084,'sv','Visa kunden anteckningar pÃ¥ serviceorder redigera skÃ¤rmen',0),(507012,14084,'it','Visualizza note su ordine di servizio di cliente modifica schermo',0),(507013,14084,'tl','',0),(507014,14084,'th','à¹à¸ªà¸”à¸‡à¸«à¸™à¹‰à¸²à¸ˆà¸­à¹à¸à¹‰à¹„à¸‚à¸•à¸±à¹‹à¸§à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸šà¸£à¸´à¸à¸²à¸£',0),(507015,14084,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤ à¤¸à¥à¤•à¥à¤°à¥€à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡à¤µà¤¾ à¤•à¥à¤°à¤® à¤ªà¤° à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(507016,14084,'ms','Menunjukkan Baca Nota-nota pada pesanan Perkhidmatan mengedit skrin',0),(507017,14084,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¹Ù„Ù‰ Ø®Ø¯Ù…Ø© Ø§Ù„Ù†Ø¸Ø§Ù… ØªØ­Ø±ÙŠØ± Ø§Ù„Ø´Ø§Ø´Ø©',0),(507018,14084,'fr','Afficher l\'Ã©cran d\'Ã©dition client Notes relatives Ã  l\'ordre de Service',0),(507019,14084,'jp','ã‚µãƒ¼ãƒ“ã‚¹æ³¨æ–‡ã«é¡§å®¢ã®ãƒŽãƒ¼ãƒˆç·¨é›†ç”»é¢ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(507020,14084,'pt','Mostrar notas do cliente na ordem de serviÃ§o editar tela',0),(507021,14084,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð½Ð° Ð·Ð°ÐºÐ°Ð· Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÐºÑ€Ð°Ð½',0),(507022,14084,'es','Mostrar pantalla ediciÃ³n cliente notas sobre la orden de servicio',0),(507023,14084,'de','Zeigen Sie, dass Kunden Hinweise zum Serviceauftrag Bildschirm bearbeiten',0),(507024,14084,'en','Show Customer Notes On Service Order Edit Screen',0),(507025,14085,'is','',0),(507026,14085,'dr','Ù¾Ø°ÛŒØ±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(507027,14085,'pr','Ù¾Ø°ÛŒØ±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(507028,14085,'tr','Kabul',0),(507029,14085,'pl','Akceptowane',0),(507030,14085,'bg','ÐŸÑ€Ð¸ÐµÑ‚Ð¾',0),(507031,14085,'ur','Ù‚Ø¨ÙˆÙ„ Ú©Ø± Ù„ÛŒ',0),(507032,14085,'sr','ÐŸÑ€Ð¸Ñ…Ð²Ð°Ñ›ÐµÐ½Ð°',0),(507033,14085,'vi','Cháº¥p nháº­n',0),(507034,14085,'af','Aanvaar',0),(507035,14085,'ro','Acceptate',0),(507036,14085,'et','Aktsepteeritud',0),(507037,14085,'si','Sprejeta',0),(507038,14085,'ba','Diterima',0),(507039,14085,'nl','Geaccepteerd',0),(507040,14085,'fi','HyvÃ¤ksytty',0),(507041,14085,'no','Akseptert',0),(507042,14085,'da','Accepteret',0),(507043,14085,'ko','í—ˆìš©',0),(507044,14085,'he','×”×ª×§×‘×œ×”',0),(507045,14085,'el','Î‘Ï€Î¿Î´ÎµÎºÏ„Î®',0),(507046,14085,'zh','æŽ¥å—',0),(507047,14085,'sv','Accepterat',0),(507048,14085,'it','Accettato',0),(507049,14085,'tl','',0),(507050,14085,'th','à¸¢à¸­à¸¡à¸£à¸±à¸š',0),(507051,14085,'hi','à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤¿à¤ à¤œà¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(507052,14085,'ms','Diterima',0),(507053,14085,'ar','Ù‚Ø¨Ù„Øª',0),(507054,14085,'fr','AcceptÃ©',0),(507055,14085,'jp','å—ã‘å…¥ã‚Œã‚‰ã‚Œã‚‹',0),(507056,14085,'pt','Aceite',0),(507057,14085,'ru','ÐŸÑ€Ð¸Ð½ÑÑ‚Ð¾',0),(507058,14085,'es','Aceptado',0),(507059,14085,'de','Akzeptiert',0),(507060,14085,'en','Accepted',0),(507061,14086,'is','',0),(507062,14086,'dr','Ø±ÙˆÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù† Ù…Ø·Ø§Ø¨Ù‚',0),(507063,14086,'pr','Ø±ÙˆÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù† Ù…Ø·Ø§Ø¨Ù‚',0),(507064,14086,'tr','EÅŸleÅŸen MÃ¼ÅŸteri tÄ±klayÄ±n',0),(507065,14086,'pl','Kliknij na pasujÄ…ce klienta',0),(507066,14086,'bg','ÐšÐ»Ð¸ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(507067,14086,'ur','Ø§ÛŒÚ© Ù…Ø´Ø§Ø¨Û Ú¯Ø§ÛÚ© Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(507068,14086,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð°Ñ˜ÑƒÑ›Ð¸ ÐºÑƒÐ¿Ð°Ñ†',0),(507069,14086,'vi','Nháº¥p chuá»™t vÃ o má»™t khÃ¡ch hÃ ng káº¿t há»£p',0),(507070,14086,'af','Klik op \'n bypassende kliÃ«nt',0),(507071,14086,'ro','FaceÅ£i clic pe un client potrivire',0),(507072,14086,'et','KlÃµpsake kÃ¤sku sobitamine kliendi',0),(507073,14086,'si','Kliknite na ujemanje kupca',0),(507074,14086,'ba','Klik pada pencocokan pelanggan',0),(507075,14086,'nl','Klik op een overeenkomende klant',0),(507076,14086,'fi','Klikkaa vastaavaa asiakkaan',0),(507077,14086,'no','Klikk pÃ¥ en samsvarende kunde',0),(507078,14086,'da','Klik pÃ¥ matchende kunde',0),(507079,14086,'ko','ì¼ì¹˜ í•˜ëŠ” ê³ ê°ì„ í´ë¦­',0),(507080,14086,'he','×œ×—×¥ ×¢×œ ×”×ª××ž×ª ×œ×§×•×—',0),(507081,14086,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ Î±Î½Ï„Î¯ÏƒÏ„Î¿Î¹Ï‡Î¿ Ï€ÎµÎ»Î¬Ï„Î·',0),(507082,14086,'zh','å•å‡»ä¸€ä¸ªåŒ¹é…çš„å®¢æˆ·',0),(507083,14086,'sv','Klicka pÃ¥ en matchande kund',0),(507084,14086,'it','Fare clic su un cliente corrispondente',0),(507085,14086,'tl','',0),(507086,14086,'th','à¸„à¸¥à¸´à¸à¸—à¸µà¹ˆà¸¥à¸¹à¸à¸„à¹‰à¸²à¸•à¸£à¸‡',0),(507087,14086,'hi','à¤à¤• à¤®à¥‡à¤² à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(507088,14086,'ms','Klik pada pelanggan yang sepadan',0),(507089,14086,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø¹Ù…ÙŠÙ„ Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(507090,14086,'fr','Cliquez sur un client correspondant',0),(507091,14086,'jp','ä¸€è‡´ã™ã‚‹ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(507092,14086,'pt','Clique em um cliente correspondente',0),(507093,14086,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ Ð½Ð° ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ð¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(507094,14086,'es','Haga clic en un cliente que empareja',0),(507095,14086,'de','Klicken Sie auf einen passenden Kunden',0),(507096,14086,'en','Click On A Matching Customer',0),(507097,14087,'is','',0),(507098,14087,'dr','Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯ Ø¨Ø§ Ø§Ù…Ú©Ø§Ù† ØªØ·Ø¨ÛŒÙ‚ Ø¯Ø§Ø¯Ù‡ Ø§ÛŒØ¬Ø§Ø¯',0),(507099,14087,'pr','Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯ Ø¨Ø§ Ø§Ù…Ú©Ø§Ù† ØªØ·Ø¨ÛŒÙ‚ Ø¯Ø§Ø¯Ù‡ Ø§ÛŒØ¬Ø§Ø¯',0),(507100,14087,'tr','Veri eÅŸleÅŸtirme mÃ¼mkÃ¼n olan yeni mÃ¼ÅŸteri oluÅŸtur',0),(507101,14087,'pl','Tworzenie nowego klienta z moÅ¼liwoÅ›ciÄ… dopasowania danych',0),(507102,14087,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ñ Ð²ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð¾ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸',0),(507103,14087,'ur','Ù†Ø¦Û’ Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾ Ú©ÙˆØ§Ø¦Ù Ù…Ø´Ø§Ø¨Û Ù…Ù…Ú©Ù† Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(507104,14087,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð° ÑÐ° Ð¼Ð¾Ð³ÑƒÑ›Ð¾Ð¼ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜ÑƒÑ›Ð¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸',0),(507105,14087,'vi','Táº¡o ra cÃ¡c khÃ¡ch hÃ ng má»›i vá»›i cÃ³ thá»ƒ phÃ¹ há»£p vá»›i dá»¯ liá»‡u',0),(507106,14087,'af','Skep nuwe kliÃ«nt met moontlik ooreenstem met Data',0),(507107,14087,'ro','Creare client nou cu posibil date de potrivire',0),(507108,14087,'et','Loo uus klient vÃµimalik vastavad andmed',0),(507109,14087,'si','Ustvarite novo stranko z moÅ¾nimi ujemanje podatkov',0),(507110,14087,'ba','Membuat pelanggan baru dengan mungkin cocok Data',0),(507111,14087,'nl','Nieuwe klant maken met mogelijk overeenkomende gegevens',0),(507112,14087,'fi','Luo uusi asiakas mahdollisia vastaavia tietoja',0),(507113,14087,'no','Opprett ny kunde med mulig sammenligne Data',0),(507114,14087,'da','Opret ny kunde med muligt matchende Data',0),(507115,14087,'ko','ê°€ëŠ¥í•œ ì¼ì¹˜ í•˜ëŠ” ë°ì´í„°ê°€ ìƒˆë¡œìš´ ê³ ê°ì„ ë§Œë“¤',0),(507116,14087,'he','×™×¦×™×¨×ª ×œ×§×•×— ×—×“×© ×¢× ×”××¤×©×¨ × ×ª×•× ×™× ×ª×•××ž×™×',0),(507117,14087,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î½Î­Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· Î¼Îµ Î´Ï…Î½Î±Ï„ÏŒ Ï„Î±Î¯ÏÎ¹Î±ÏƒÎ¼Î± Ï„Ï‰Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(507118,14087,'zh','ä¸Žå¯èƒ½åŒ¹é…çš„æ•°æ®åˆ›å»ºæ–°å®¢æˆ·',0),(507119,14087,'sv','Skapa ny kund med matchande Data som mÃ¶jligt',0),(507120,14087,'it','Crea nuovo cliente con possibile abbinamento dati',0),(507121,14087,'tl','',0),(507122,14087,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸«à¸¡à¹ˆà¹„à¸”à¹‰à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸µà¹ˆà¸•à¸£à¸‡à¸à¸±à¸™',0),(507123,14087,'hi','à¤¨à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤‚à¤­à¤µ à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¬à¤¨à¤¾à¤à¤',0),(507124,14087,'ms','Mewujudkan pelanggan baru dengan mungkin Data yang sepadan',0),(507125,14087,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¹Ù…ÙŠÙ„ Ø¬Ø¯ÙŠØ¯ Ù…Ø¹ Ù…Ù…ÙƒÙ† Ù…Ø·Ø§Ø¨Ù‚Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(507126,14087,'fr','CrÃ©er nouveau client avec Possible des donnÃ©es correspondantes',0),(507127,14087,'jp','å¯èƒ½ãªé™ã‚Šä¸€è‡´ã™ã‚‹ãƒ‡ãƒ¼ã‚¿ã‚’æŒã¤æ–°ã—ã„é¡§å®¢ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(507128,14087,'pt','Criar novo cliente com possÃ­vel dados correspondentes',0),(507129,14087,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ñ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ñ‹Ð¼ ÑÐ¾Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(507130,14087,'es','Crear a nuevo cliente con posible coincidencia de datos',0),(507131,14087,'de','Erstellen Sie neuen Kunde mÃ¶gl. Ã¼bereinstimmende Daten',0),(507132,14087,'en','Create New Customer With Possible Matching Data',0),(507133,14088,'is','',0),(507134,14088,'dr','Ù…Ø³Ø§Ø¨Ù‚Ø§Øª ÙÙˆÙ‚ Ø±Ø§ Ù†Ø§Ø¯ÛŒØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ùˆ Ø§ÛŒØ¬Ø§Ø¯ Ø±Ú©ÙˆØ±Ø¯ Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(507135,14088,'pr','Ù…Ø³Ø§Ø¨Ù‚Ø§Øª ÙÙˆÙ‚ Ø±Ø§ Ù†Ø§Ø¯ÛŒØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ùˆ Ø§ÛŒØ¬Ø§Ø¯ Ø±Ú©ÙˆØ±Ø¯ Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(507136,14088,'tr','YukarÄ±daki maÃ§lar yok sayÄ±p yeni mÃ¼ÅŸteri kaydÄ± oluÅŸturma',0),(507137,14088,'pl','Ignoruj mecze powyÅ¼ej i utworzyÄ‡ nowy rekord klienta',0),(507138,14088,'bg','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ñ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ Ð¸ Ð´Ð° ÑÐµ ÑÑŠÐ·Ð´Ð°Ð´Ðµ Ð½Ð¾Ð² Ð·Ð°Ð¿Ð¸Ñ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(507139,14088,'ur','Ù…ÛŒÚ† Ú©Û’ Ø§ÙˆÙ¾Ø± Ù†Ø¸Ø±Ø§Ù†Ø¯Ø§Ø² Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù†Ø¦Û’ Ú¯Ø§ÛÚ© Ø±ÛŒÚ©Ø§Ø±Úˆ ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(507140,14088,'sr','Ð—Ð°Ð½ÐµÐ¼Ð°Ñ€Ð¸ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° Ð¸Ð·Ð½Ð°Ð´ Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð° Ð½Ð¾Ð²Ð¸ Ð·Ð°Ð¿Ð¸Ñ ÐºÑƒÐ¿Ñ†Ð°',0),(507141,14088,'vi','Bá» qua tráº­n Ä‘áº¥u á»Ÿ trÃªn vÃ  táº¡o há»“ sÆ¡ khÃ¡ch hÃ ng má»›i',0),(507142,14088,'af','Pas bogenoemde ignoreer en skep nuwe kliÃ«nt rekord',0),(507143,14088,'ro','Ignora meciuri mai sus ÅŸi de a crea nou Record de client',0),(507144,14088,'et','Ignoreeri vasted eespool ja uue kliendi kirje loomine',0),(507145,14088,'si','Prezri tekme zgoraj in ustvari nov zapis za stranko',0),(507146,14088,'ba','Mengabaikan pertandingan di atas dan membuat catatan pelanggan baru',0),(507147,14088,'nl','Negeren Matches hierboven en nieuwe klantrecord te maken',0),(507148,14088,'fi','Ohita vastineet edellÃ¤ ja luo uusi tietue',0),(507149,14088,'no','Ignorere kamper over og opprette nye kundepost',0),(507150,14088,'da','Ignorere kampe ovenfor og oprette ny kundepost',0),(507151,14088,'ko','ìœ„ì˜ ì¼ì¹˜ë¥¼ ë¬´ì‹œ í•˜ ê³  ìƒˆ ê³ ê° ë ˆì½”ë“œ ë§Œë“¤ê¸°',0),(507152,14088,'he','×œ×”×ª×¢×œ× ×’×¤×¨×•×¨×™× ×œ×¢×™×œ, ×œ×™×¦×•×¨ ×¨×©×•×ž×ª ×”×œ×§×•×— ×”×—×“×©',0),(507153,14088,'el','Î‘Î³Î½Î¿Î®ÏƒÏ„Îµ Î±Î³ÏŽÎ½ÎµÏ‚ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ ÎºÎ±Î¹ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î½Î­Î± ÎµÎ³Î³ÏÎ±Ï†Î® Ï€ÎµÎ»Î¬Ï„Î·',0),(507154,14088,'zh','å¿½ç•¥åŒ¹é…é¡¹ä»¥ä¸Šå’Œåˆ›å»ºæ–°çš„å®¢æˆ·è®°å½•',0),(507155,14088,'sv','Ignorera matcher ovan och skapa ny kundpost',0),(507156,14088,'it','Ignorare partite sopra e creare nuovi Record del cliente',0),(507157,14088,'tl','',0),(507158,14088,'th','à¸¥à¸°à¹€à¸§à¹‰à¸™à¸à¸²à¸£à¹à¸‚à¹ˆà¸‡à¸‚à¸±à¸™à¸‚à¹‰à¸²à¸‡à¸•à¹‰à¸™ à¹à¸¥à¸°à¸ªà¸£à¹‰à¸²à¸‡à¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”à¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸«à¸¡à¹ˆ',0),(507159,14088,'hi','à¤‰à¤ªà¤°à¥‹à¤•à¥à¤¤ à¤®à¥ˆà¤šà¥‹à¤‚ à¤ªà¤° à¤§à¥à¤¯à¤¾à¤¨ à¤¨ à¤¦à¥‡à¤‚ à¤”à¤° à¤¨à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤¬à¤¨à¤¾à¤à¤',0),(507160,14088,'ms','Abaikan perlawanan di atas dan mencipta rekod pelanggan baru',0),(507161,14088,'ar','ØªØ¬Ø§Ù‡Ù„ Ø§Ù„Ù…Ø¨Ø§Ø±ÙŠØ§Øª Ø§Ù„Ù…Ø°ÙƒÙˆØ±Ø© Ø£Ø¹Ù„Ø§Ù‡ØŒ ÙˆØ¥Ù†Ø´Ø§Ø¡ Ø³Ø¬Ù„ Ø¹Ù…ÙŠÙ„ Ø¬Ø¯ÙŠØ¯',0),(507162,14088,'fr','Ignorer les correspondances ci-dessus et crÃ©er nouvel enregistrement de client',0),(507163,14088,'jp','ä¸Šè¨˜ã®ä¸€è‡´ã‚’ç„¡è¦–ã—ã€æ–°ã—ã„é¡§å®¢ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(507164,14088,'pt','Ignorar os jogos acima e criar novo registro de cliente',0),(507165,14088,'ru','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¼Ð°Ñ‚Ñ‡Ð¸ Ð²Ñ‹ÑˆÐµ Ð¸ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(507166,14088,'es','Ignorar a los partidos anteriores y crear nuevo registro de cliente',0),(507167,14088,'de','Ignorieren Sie Treffern oben und erstellen Sie neuer Kundendatensatz',0),(507168,14088,'en','Ignore Matches Above And Create New Customer Record',0),(507169,14089,'is','',0),(507170,14089,'dr','Ù‡ÛŒÚ† ØªÚ©Ø±Ø§Ø±ÛŒ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(507171,14089,'pr','Ù‡ÛŒÚ† ØªÚ©Ø±Ø§Ø±ÛŒ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(507172,14089,'tr','Yinelenen yok bulundu',0),(507173,14089,'pl','Nie ma duplikatÃ³w znalezionych',0),(507174,14089,'bg','Ð”ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ‚Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(507175,14089,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ø«Ù†ÛŒ Ù¾Ø§ÛŒØ§',0),(507176,14089,'sr','ÐÐµÐ¼Ð° Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚Ð° Ð¿Ñ€Ð¾Ð½Ð°ÑˆÐ°Ð¾',0),(507177,14089,'vi','KhÃ´ng cÃ³ báº£n sao Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(507178,14089,'af','Geen duplikate gevind',0),(507179,14089,'ro','FÄƒrÄƒ dubluri gÄƒsite',0),(507180,14089,'et','Tuvastatud duplikaadid',0),(507181,14089,'si','Ni najdenih dvojnikov',0),(507182,14089,'ba','Tidak duplikat ditemukan',0),(507183,14089,'nl','Geen duplicaten gevonden',0),(507184,14089,'fi','Kaksoisarvoja ei lÃ¶ytynyt',0),(507185,14089,'no','Ingen duplikater funnet',0),(507186,14089,'da','Ingen dubletter fundet',0),(507187,14089,'ko','ì¤‘ë³µ ë°œê²¬',0),(507188,14089,'he','×œ× × ×ž×¦××• ×›×¤×™×œ×•×™×•×ª',0),(507189,14089,'el','Î”ÎµÎ½ Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€Ï‰Î½ ÎµÏ€Î±Ï†ÏŽÎ½ Ï€Î¿Ï… ÎµÎ½Ï„Î¿Ï€Î¯ÏƒÏ„Î·ÎºÎ±Î½',0),(507190,14089,'zh','æ‰¾åˆ°ä»»ä½•é‡å¤é¡¹',0),(507191,14089,'sv','Inga dubbletter hittade',0),(507192,14089,'it','Senza duplicati trovati',0),(507193,14089,'tl','',0),(507194,14089,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‹à¹‰à¸³',0),(507195,14089,'hi','à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(507196,14089,'ms','Tiada pendua yang ditemui',0),(507197,14089,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ ØªÙƒØ±Ø§Ø±Ø§Øª Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(507198,14089,'fr','Aucun doublon trouvÃ©',0),(507199,14089,'jp','é‡è¤‡ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(507200,14089,'pt','NÃ£o hÃ¡ duplicatas encontradas',0),(507201,14089,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹ Ð´ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ‚Ñ‹',0),(507202,14089,'es','Sin duplicados encontrados',0),(507203,14089,'de','Keine Duplikate gefunden',0),(507204,14089,'en','No Duplicates Found',0),(507205,14090,'is','',0),(507206,14090,'dr','ØªÚ©Ø±Ø§Ø±ÛŒ Ù…Ø´ØªØ±ÛŒ Ø§Ù…Ú©Ø§Ù† Ù¾Ø°ÛŒØ± Ø§Ø³Øª',0),(507207,14090,'pr','ØªÚ©Ø±Ø§Ø±ÛŒ Ù…Ø´ØªØ±ÛŒ Ø§Ù…Ú©Ø§Ù† Ù¾Ø°ÛŒØ± Ø§Ø³Øª',0),(507208,14090,'tr','OlasÄ± mÃ¼ÅŸteri Ã§oÄŸaltmalarÄ±',0),(507209,14090,'pl','Klienta moÅ¼liwe duplikaty',0),(507210,14090,'bg','Ð’ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð´ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ‚Ð¸',0),(507211,14090,'ur','Ù…Ù…Ú©Ù†Û Ú¯Ø§ÛÚ© Ù…Ø«Ù†ÛŒ',0),(507212,14090,'sr','ÐœÐ¾Ð³ÑƒÑ›Ð¸ ÐºÑƒÐ¿Ð°Ñ† Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚Ðµ',0),(507213,14090,'vi','KhÃ¡ch hÃ ng cÃ³ thá»ƒ trÃ¹ng láº·p',0),(507214,14090,'af','Moontlike kliÃ«nt duplikate',0),(507215,14090,'ro','PosibilÄƒ client duplicate',0),(507216,14090,'et','VÃµimalik klient duplikaadid',0),(507217,14090,'si','MoÅ¾ni kupec dvojnike',0),(507218,14090,'ba','Pelanggan mungkin duplikat',0),(507219,14090,'nl','Mogelijke klant duplicaten',0),(507220,14090,'fi','Mahdollinen asiakas kaksoiskappaleet',0),(507221,14090,'no','Mulig kunde duplikater',0),(507222,14090,'da','Muligt kunde dubletter',0),(507223,14090,'ko','ê³ ê° ì¤‘ë³µ',0),(507224,14090,'he','×œ×§×•×— ××¤×©×¨×™ ×›×¤×™×œ×•×™×•×ª',0),(507225,14090,'el','Î”Î¹Ï€Î»ÏŒÏ„Ï…Ï€Î± Ï€Î¹Î¸Î±Î½ÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(507226,14090,'zh','å¯èƒ½çš„å®¢æˆ·é‡å¤é¡¹',0),(507227,14090,'sv','MÃ¶jligt kunden dubbletter',0),(507228,14090,'it','Cliente possibili duplicati',0),(507229,14090,'tl','',0),(507230,14090,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸ªà¸²à¸¡à¸²à¸£à¸–à¸‹à¹‰à¸³',0),(507231,14090,'hi','à¤¸à¤‚à¤­à¤µ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ',0),(507232,14090,'ms','Pelanggan pendua',0),(507233,14090,'ar','Ø§Ù„ØªÙƒØ±Ø§Ø±Ø§Øª Ù…Ù…ÙƒÙ†Ø© Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(507234,14090,'fr','Doublons de client possible',0),(507235,14090,'jp','å¯èƒ½ãªé™ã‚Šé¡§å®¢ã®é‡è¤‡',0),(507236,14090,'pt','PossÃ­vel cliente duplicatas',0),(507237,14090,'ru','Ð”ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ‚Ñ‹ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(507238,14090,'es','Cliente posibles duplicados',0),(507239,14090,'de','Kunden-Duplikate',0),(507240,14090,'en','Possible Customer Duplicates',0),(507241,14091,'is','',0),(507242,14091,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù„Ú¯Ùˆ Ø§ÛŒÙ…ÛŒÙ„',0),(507243,14091,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ø§Ù„Ú¯Ùˆ Ø§ÛŒÙ…ÛŒÙ„',0),(507244,14091,'tr','E-posta ÅŸablonu ekleme',0),(507245,14091,'pl','DodaÄ‡ szablon wiadomoÅ›ci Email',0),(507246,14091,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¸Ð¼ÐµÐ¹Ð» ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(507247,14091,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(507248,14091,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(507249,14091,'vi','ThÃªm Email máº«u',0),(507250,14091,'af','Voeg e-pos sjabloon',0),(507251,14091,'ro','Adauga E-mail ÅŸablon',0),(507252,14091,'et','MeilisÃµnumi malli lisamine',0),(507253,14091,'si','Dodaj Email predloga',0),(507254,14091,'ba','Tambahkan Email Template',0),(507255,14091,'nl','E-mailtemplate toevoegen',0),(507256,14091,'fi','LisÃ¤Ã¤ sÃ¤hkÃ¶postimalli',0),(507257,14091,'no','Legge til e-mal',0),(507258,14091,'da','TilfÃ¸je E-mail-skabelon',0),(507259,14091,'ko','ì´ë©”ì¼ í…œí”Œë¦¿ ì¶”ê°€',0),(507260,14091,'he','×œ×”×•×¡×™×£ ×ª×‘× ×™×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™',0),(507261,14091,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(507262,14091,'zh','æ·»åŠ ç”µå­é‚®ä»¶æ¨¡æ¿',0),(507263,14091,'sv','LÃ¤gga till e-mall',0),(507264,14091,'it','Aggiungi modello E-mail',0),(507265,14091,'tl','',0),(507266,14091,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥',0),(507267,14091,'hi','à¤ˆà¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(507268,14091,'ms','Tambah Template e-mel',0),(507269,14091,'ar','Ø¥Ø¶Ø§ÙØ© Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(507270,14091,'fr','Ajouter le modÃ¨le d\'E-mail',0),(507271,14091,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(507272,14091,'pt','Adicionar modelo de Email',0),(507273,14091,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑˆÐ°Ð±Ð»Ð¾Ð½ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(507274,14091,'es','Agregar Plantilla de Email',0),(507275,14091,'de','HinzufÃ¼gen von E-Mail-Vorlage',0),(507276,14091,'en','Add Email Template',0),(507277,14092,'is','',0),(507278,14092,'dr','Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„',0),(507279,14092,'pr','Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„',0),(507280,14092,'tr','E-posta ÅŸablonu',0),(507281,14092,'pl','Szablon wiadomoÅ›ci email',0),(507282,14092,'bg','Ð¨Ð°Ð±Ð»Ð¾Ð½ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð»',0),(507283,14092,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ø³Ø§Ù†Ú†Û’',0),(507284,14092,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(507285,14092,'vi','ThÆ° Ä‘iá»‡n tá»­ máº«u',0),(507286,14092,'af','E-pos sjabloon',0),(507287,14092,'ro','E-mail ÅŸablon',0),(507288,14092,'et','MeilisÃµnumi malli',0),(507289,14092,'si','Email predloga',0),(507290,14092,'ba','Email Template',0),(507291,14092,'nl','E-mailtemplate',0),(507292,14092,'fi','SÃ¤hkÃ¶postimalli',0),(507293,14092,'no','E-mal',0),(507294,14092,'da','E-mail-skabelon',0),(507295,14092,'ko','ì´ë©”ì¼ í…œí”Œë¦¿',0),(507296,14092,'he','×ª×‘× ×™×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™',0),(507297,14092,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(507298,14092,'zh','ç”µå­é‚®ä»¶æ¨¡æ¿',0),(507299,14092,'sv','E-mall',0),(507300,14092,'it','Modello e-mail',0),(507301,14092,'tl','',0),(507302,14092,'th','à¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥',0),(507303,14092,'hi','à¤ˆà¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ',0),(507304,14092,'ms','Template e-mel',0),(507305,14092,'ar','Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(507306,14092,'fr','ModÃ¨le d\'e-mail',0),(507307,14092,'jp','ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ',0),(507308,14092,'pt','Modelo de email',0),(507309,14092,'ru','Ð¨Ð°Ð±Ð»Ð¾Ð½ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(507310,14092,'es','Plantilla de correo electrÃ³nico',0),(507311,14092,'de','E-Mail-Vorlage',0),(507312,14092,'en','Email Template',0),(507313,14093,'is','',0),(507314,14093,'dr','Ù‡ÛŒÚ† Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(507315,14093,'pr','Ù‡ÛŒÚ† Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(507316,14093,'tr','SeÃ§ili herhangi bir e-posta ÅŸablonu',0),(507317,14093,'pl','Wybrano nie szablon wiadomoÅ›ci Email',0),(507318,14093,'bg','ÐÑÐ¼Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð» Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð½',0),(507319,14093,'ur','Ú©ÙˆØ¦ÛŒ Ø§ÛŒ Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Ø§ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(507320,14093,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(507321,14093,'vi','KhÃ´ng cÃ³ Email máº«u Ä‘Ã£ Ä‘Æ°á»£c lá»±a chá»n',0),(507322,14093,'af','Geen e-pos sjabloon is gekies',0),(507323,14093,'ro','A fost selectat nici un ÅŸablon de poÅŸtÄƒ electronicÄƒ',0),(507324,14093,'et','MeilisÃµnumi malli valitud',0),(507325,14093,'si','Ne Email predloga je bil izbran',0),(507326,14093,'ba','Ada Template Email telah dipilih',0),(507327,14093,'nl','Geen e-mailtemplate is geselecteerd',0),(507328,14093,'fi','Email mallia ei ole valittu',0),(507329,14093,'no','Ingen e-mal er valgt',0),(507330,14093,'da','Ingen E-mail-skabelon, der er valgt',0),(507331,14093,'ko','ì•„ë‹ˆ ì´ë©”ì¼ í…œí”Œë¦¿ ì„ íƒ',0),(507332,14093,'he','××™×Ÿ ×ª×‘× ×™×ª ×”×“×•× ×œ × ×‘×—×¨',0),(507333,14093,'el','ÎˆÏ‡ÎµÎ¹ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ ÎºÎ±Î½Î­Î½Î± Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(507334,14093,'zh','åœ¨é€‰æ‹©äº†æ²¡æœ‰ç”µå­é‚®ä»¶æ¨¡æ¿',0),(507335,14093,'sv','Ingen e-postmall har valts',0),(507336,14093,'it','Nessun modello di E-mail Ã¨ stato selezionato',0),(507337,14093,'tl','',0),(507338,14093,'th','à¸¡à¸µà¸à¸²à¸£à¹€à¸¥à¸·à¸­à¸à¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(507339,14093,'hi','à¤•à¥‹à¤ˆ à¤ˆà¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(507340,14093,'ms','Tiada Template e-mel telah dipilih',0),(507341,14093,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø§Ø®ØªÙŠØ§Ø± Ø£ÙŠ Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(507342,14093,'fr','Aucun modÃ¨le d\'E-mail n\'a Ã©tÃ© sÃ©lectionnÃ©',0),(507343,14093,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆãŒé¸æŠžã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(507344,14093,'pt','Nenhum modelo de E-mail foi selecionado',0),(507345,14093,'ru','ÐÐµ ÑˆÐ°Ð±Ð»Ð¾Ð½ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð±Ñ‹Ð» Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(507346,14093,'es','No se ha seleccionado ninguna plantilla de correo electrÃ³nico',0),(507347,14093,'de','Keine E-Mail-Vorlage es wurde ausgewÃ¤hlt',0),(507348,14093,'en','No Email Template Has Been Selected',0),(507349,14094,'is','',0),(507350,14094,'dr','Ù…Ù…Ú©Ù† Ø§Ø³Øª Ù…Ø´ØªØ±ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(507351,14094,'pr','Ù…Ù…Ú©Ù† Ø§Ø³Øª Ù…Ø´ØªØ±ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(507352,14094,'tr','OlasÄ± yinelenen mÃ¼ÅŸteri bulundu',0),(507353,14094,'pl','MoÅ¼liwe zduplikowane klientÃ³w znalezionych',0),(507354,14094,'bg','Ð’ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð¸ Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ñ‰Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(507355,14094,'ur','Ù…Ù…Ú©Ù† Ù…Ø«Ù†ÛŒ Ú©Ø³Ù¹Ù…Ø± Ù¾Ø§ÛŒØ§',0),(507356,14094,'sr','ÐœÐ¾Ð³ÑƒÑ›Ð¸ Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚ ÐºÑƒÐ¿Ñ†Ð° Ð½Ð°ÑˆÐ»Ð¸',0),(507357,14094,'vi','KhÃ¡ch hÃ ng trÃ¹ng láº·p cÃ³ thá»ƒ tÃ¬m tháº¥y',0),(507358,14094,'af','Moontlike duplikaat kliÃ«nt gevind',0),(507359,14094,'ro','PosibilÄƒ client dubluri gÄƒsite',0),(507360,14094,'et','VÃµimalik duplikaat kliendi leitud',0),(507361,14094,'si','MoÅ¾no stranko dvojnik naÅ¡el',0),(507362,14094,'ba','Mungkin pelanggan duplikat ditemukan',0),(507363,14094,'nl','Mogelijke dubbele klant gevonden',0),(507364,14094,'fi','Mahdollisia kaksoiskappaleita asiakas lÃ¶ytyi',0),(507365,14094,'no','Mulig duplikat kunde funnet',0),(507366,14094,'da','Mulige dubletter kunde fundet',0),(507367,14094,'ko','ì¤‘ë³µ ê³ ê° ë°œê²¬',0),(507368,14094,'he','××¤×©×¨×™ ×›×¤×•×œ×•×ª ×œ×œ×§×•×—×•×ª ×œ×ž×¦×•×',0),(507369,14094,'el','Î Î¹Î¸Î±Î½Î­Ï‚ Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€ÎµÏ‚ Ï€ÎµÎ»Î¬Ï„Î· Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(507370,14094,'zh','å‘çŽ°çš„å¯èƒ½é‡å¤å®¢æˆ·',0),(507371,14094,'sv','MÃ¶jligt duplikat kund hittade',0),(507372,14094,'it','Possibili clienti duplicati trovati',0),(507373,14094,'tl','',0),(507374,14094,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸‹à¹‰à¸³à¹„à¸”à¹‰à¸žà¸š',0),(507375,14094,'hi','à¤¸à¤‚à¤­à¤µ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤ªà¤¾à¤¯à¤¾',0),(507376,14094,'ms','Mendapati pelanggan pendua',0),(507377,14094,'ar','Ù…Ù…ÙƒÙ†Ø© Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…ÙƒØ±Ø±Ø© ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(507378,14094,'fr','Client de doublon possible trouvÃ©',0),(507379,14094,'jp','å¯èƒ½ãªé™ã‚Šé‡è¤‡ã™ã‚‹é¡§å®¢ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(507380,14094,'pt','PossÃ­vel cliente duplicado encontrado',0),(507381,14094,'ru','ÐÐ°Ð¹Ð´ÐµÐ½Ñ‹ Ð´ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ‚Ñ‹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(507382,14094,'es','Posible cliente duplicado encontrado',0),(507383,14094,'de','Doppelte Kunden gefunden',0),(507384,14094,'en','Possible Duplicate Customer Found',0),(507385,14095,'is','',0),(507386,14095,'dr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª POS Ø¯Ø± FO Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ø§Ø¯',0),(507387,14095,'pr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª POS Ø¯Ø± FO Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ø§Ø¯',0),(507388,14095,'tr','POS/FO sipariÅŸler iÃ§in aÃ§Ä±klama deÄŸiÅŸtiremezsiniz',0),(507389,14095,'pl','Nie moÅ¼na zmieniÄ‡ opis zamÃ³wienia POS/FO',0),(507390,14095,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÑÑ‚Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸ÐµÑ‚Ð¾ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÐŸÐžÐ¡/Ð¤Ð¾',0),(507391,14095,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù†/Ø¯ÙØªØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ù„ÛŒÛ’ ØªØµØ±ÛŒØ­ ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(507392,14095,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ð¸ Ð¾Ð¿Ð¸Ñ Ð·Ð° ÐŸÐžÐ¡/Ð¤Ðž Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(507393,14095,'vi','KhÃ´ng thá»ƒ thay Ä‘á»•i cÃ¡c mÃ´ táº£ cho Ä‘Æ¡n Ä‘áº·t hÃ ng POS/FO',0),(507394,14095,'af','Beskrywing vir POS/FO bestellings kan verander',0),(507395,14095,'ro','Nu puteÅ£i modifica Descriere pentru POS/FO comenzi',0),(507396,14095,'et','POS/FO tellimuste kirjeldust ei saa muuta',0),(507397,14095,'si','Ne morete spremeniti opis naloge POS/FO',0),(507398,14095,'ba','Tidak dapat mengubah Deskripsi untuk pesanan POS FO',0),(507399,14095,'nl','Beschrijving voor POS/FO Orders kan niet wijzigen',0),(507400,14095,'fi','Kuvausta POS/FO tilauksia ei voi muuttaa',0),(507401,14095,'no','Kan ikke endre beskrivelsen For POS/for bestillinger',0),(507402,14095,'da','Kan ikke Ã¦ndre beskrivelsen For POS/FO ordrer',0),(507403,14095,'ko','POS/FO ì£¼ë¬¸ì— ëŒ€ í•œ ì„¤ëª…ì„ ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(507404,14095,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×©× ×•×ª ×ª×™××•×¨ ×¢×‘×•×¨ ×§×•×¤×”/FO ×”×–×ž× ×•×ª',0),(507405,14095,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î»Î»Î¬Î¾ÎµÎ¹ Ï„Î·Î½ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ POS/FO',0),(507406,14095,'zh','ä¸èƒ½æ›´æ”¹ POS/FO è®¢å•è¯´æ˜Ž',0),(507407,14095,'sv','Kan inte Ã¤ndra beskrivning fÃ¶r POS/FO order',0),(507408,14095,'it','Non Ã¨ possibile modificare la descrizione per ordini POS/FO',0),(507409,14095,'tl','',0),(507410,14095,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‚à¸­à¸‡ POS/à¸£à¸§à¸” à¹€à¸£à¹‡à¸§',0),(507411,14095,'hi','POS/FO à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤°à¥à¤£à¤¨ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(507412,14095,'ms','Tidak boleh mengubah keterangan bagi pesanan POS/FO',0),(507413,14095,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØºÙŠÙŠØ± Ø§Ù„ÙˆØµÙ Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨ÙŠØ¹/FO',0),(507414,14095,'fr','Ne peut pas modifier le libellÃ© pour les commandes de POS/FO',0),(507415,14095,'jp','POS/FO æ³¨æ–‡ã®èª¬æ˜Žã‚’å¤‰æ›´ã§ãã¾ã›ã‚“ã€‚',0),(507416,14095,'pt','NÃ£o Ã© possÃ­vel alterar a descriÃ§Ã£o para ordens de POS/FO',0),(507417,14095,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² POS/FO',0),(507418,14095,'es','No se puede cambiar la descripciÃ³n de las Ã³rdenes de POS/FO',0),(507419,14095,'de','Beschreibung fÃ¼r POS/FO Bestellungen kann nicht geÃ¤ndert werden.',0),(507420,14095,'en','Cannot Change Description For POS/FO Orders',0),(507421,14096,'is','',0),(507422,14096,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª POS Ø¯Ø± FO Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù†Ù…ÛŒ',0),(507423,14096,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª POS Ø¯Ø± FO Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù†Ù…ÛŒ',0),(507424,14096,'tr','POS/FO sipariÅŸler iÃ§in maliyet gÃ¶rÃ¼ntÃ¼leyemiyorsunuz',0),(507425,14096,'pl','Nie moÅ¼na wyÅ›wietliÄ‡ koszt zamÃ³wienia POS/FO',0),(507426,14096,'bg','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÐŸÐžÐ¡/Ð¤Ð¾',0),(507427,14096,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù†/Ø¯ÙØªØ± Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ Ù„Ø§Ú¯Øª Ù†Ø¸Ø± Ù†ÛÛŒÚº Ø¢Ø¦Û’ Ú¯Ø§',0),(507428,14096,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð¶ÐµÐ¼ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ð·Ð° ÐŸÐžÐ¡/Ð¤Ðž Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(507429,14096,'vi','KhÃ´ng thá»ƒ xem cÃ¡c chi phÃ­ cho Ä‘Æ¡n Ä‘áº·t hÃ ng POS/FO',0),(507430,14096,'af','Koste vir POS/FO bestellings kan bekyk',0),(507431,14096,'ro','Nu pot vizualiza costurile pentru POS/FO comenzi',0),(507432,14096,'et','Muretsete kulude POS/FO tellimuste',0),(507433,14096,'si','Ne morete ogledati stroÅ¡ke za POS/FO naroÄila',0),(507434,14096,'ba','Tidak dapat melihat biaya untuk pesanan POS FO',0),(507435,14096,'nl','Geen bekijken kosten voor POS/FO bestellingen',0),(507436,14096,'fi','Ei NÃ¤ytÃ¤ kustannus POS/FO tilaukset',0),(507437,14096,'no','Kan ikke vise kostnadene For POS/for ordrer',0),(507438,14096,'da','Kan ikke se prisen For POS/FO ordrer',0),(507439,14096,'ko','POS/FO ì£¼ë¬¸ì— ëŒ€ í•œ ë¹„ìš©ì„ ë³¼ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(507440,14096,'he','××™×Ÿ ×‘××¤×©×¨×•×ª×š ×œ×”×¦×™×’ ×¢×œ×•×™×•×ª ×¢×‘×•×¨ ×§×•×¤×”/FO ×”×–×ž× ×•×ª',0),(507441,14096,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Ï€ÏÎ¿Î²Î¬Î»Ï‰ ÎºÏŒÏƒÏ„Î¿Ï‚ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ POS/FO',0),(507442,14096,'zh','ä¸èƒ½æŸ¥çœ‹çš„ POS/FO è®¢å•çš„æˆæœ¬',0),(507443,14096,'sv','Kan inte Visa kostnaden fÃ¶r POS/FO order',0),(507444,14096,'it','Non Ã¨ possibile visualizzare il costo per gli ordini POS/FO',0),(507445,14096,'tl','',0),(507446,14096,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸”à¸¹à¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‚à¸­à¸‡ POS/à¸£à¸§à¸” à¹€à¸£à¹‡à¸§',0),(507447,14096,'hi','POS/FO à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¤¤ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(507448,14096,'ms','Tidak dapat melihat kos pesanan POS/FO',0),(507449,14096,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¹Ø±Ø¶ Ø§Ù„ØªÙƒÙ„ÙØ© Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨ÙŠØ¹/FO',0),(507450,14096,'fr','Impossible d\'afficher le coÃ»t pour les commandes de POS/FO',0),(507451,14096,'jp','POS/FO ã®æ³¨æ–‡ã®ãŸã‚ã®ã‚³ã‚¹ãƒˆã‚’è¡¨ç¤ºã§ãã¾ã›ã‚“ã€‚',0),(507452,14096,'pt','NÃ£o pode ver os custos por ordens de POS/FO',0),(507453,14096,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² POS/FO',0),(507454,14096,'es','No puede ver los costos por Ã³rdenes de POS/FO',0),(507455,14096,'de','Kosten fÃ¼r POS/FO Bestellungen kann nicht angezeigt werden.',0),(507456,14096,'en','Cannot View Cost For POS/FO Orders',0),(507457,14097,'is','',0),(507458,14097,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ ØªØ®ÙÛŒÙ Ø¨Ø±Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¯Ø± ØµÙØ­Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(507459,14097,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ ØªØ®ÙÛŒÙ Ø¨Ø±Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¯Ø± ØµÙØ­Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(507460,14097,'tr','Ä°ade faturalarÄ±nÄ± Ã¶deme sayfasÄ±nda izin veren',0),(507461,14097,'pl','UmoÅ¼liwiÄ‡ Rabaty faktur kredytowych na stronie pÅ‚atnoÅ›ci',0),(507462,14097,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð½Ð° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(507463,14097,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ ØµÙØ­Û’ Ù¾Ø± Ú©Ø±ÛŒÚˆÙ¹ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø±Ø¹Ø§ÛŒØª Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª',0),(507464,14097,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð·Ð°',0),(507465,14097,'vi','Cho phÃ©p giáº£m giÃ¡ cho tÃ­n dá»¥ng hÃ³a Ä‘Æ¡n trÃªn trang thanh toÃ¡n',0),(507466,14097,'af','Laat afslag vir krediet fakture op betaling bladsy',0),(507467,14097,'ro','Permite reduceri pentru Credit facturi pe pagina de plÄƒÅ£i',0),(507468,14097,'et','VÃµimaldada allahindlusi krediidi arvete maksmise lehele',0),(507469,14097,'si','Dovoljujejo popuste za kreditne raÄune na strani plaÄila',0),(507470,14097,'ba','Memungkinkan diskon untuk faktur kredit pada halaman pembayaran',0),(507471,14097,'nl','Kortingen toestaan voor creditcard facturen op betalingspagina',0),(507472,14097,'fi','TinkiÃ¤ luotto laskujen maksu sivulle',0),(507473,14097,'no','Tillate rabatter For kreditt fakturaer pÃ¥ betalingssiden',0),(507474,14097,'da','Tillad rabatter For kredit fakturaer pÃ¥ siden Betalingsformer',0),(507475,14097,'ko','ê²°ì œ íŽ˜ì´ì§€ì—ì„œ ì‹ ìš© ì²­êµ¬ì„œ í• ì¸ í—ˆìš©',0),(507476,14097,'he','×œ××¤×©×¨ ×”× ×—×•×ª ×¢×‘×•×¨ ×—×©×‘×•× ×™×•×ª ××©×¨××™ ×‘×“×£ ×”×ª×©×œ×•×',0),(507477,14097,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ¬ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÏƒÏ„Î· ÏƒÎµÎ»Î¯Î´Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï„Î¿Ï…',0),(507478,14097,'zh','å…è®¸çš„æŠ˜æ‰£ä¸ºä¿¡è´·å‘ç¥¨ä»˜æ¬¾é¡µé¢ä¸Š',0),(507479,14097,'sv','MÃ¶jliggÃ¶r kredit fakturor pÃ¥ betalningssidan rabatter',0),(507480,14097,'it','Concedere sconti per le fatture di credito sulla pagina di pagamento',0),(507481,14097,'tl','',0),(507482,14097,'th','à¹ƒà¸«à¹‰à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸šà¸¥à¸”à¸«à¸™à¸µà¹‰à¸«à¸™à¹‰à¸²à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(507483,14097,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥‡à¤œ à¤ªà¤° à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤›à¥‚à¤Ÿ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(507484,14097,'ms','Membolehkan diskaun kredit invois di halaman pembayaran',0),(507485,14097,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨Ø®ØµÙˆÙ…Ø§Øª Ø¹Ù„Ù‰ ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø¹Ù„Ù‰ ØµÙØ­Ø© Ø§Ù„Ø¯ÙØ¹',0),(507486,14097,'fr','Permettent des rÃ©ductions pour des factures de crÃ©dit sur la Page de paiement',0),(507487,14097,'jp','æ”¯æ‰•ã„ãƒšãƒ¼ã‚¸ã§ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆè«‹æ±‚æ›¸ã®å‰²å¼•ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(507488,14097,'pt','Permitir descontos para facturas de crÃ©dito na pÃ¡gina de pagamento',0),(507489,14097,'ru','ÐŸÑ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÑÐµÐ¼ ÑÐºÐ¸Ð´ÐºÐ¸ Ð´Ð»Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚-ÑÑ‡ÐµÑ‚Ð¾Ð² Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ ÐžÐ¿Ð»Ð°Ñ‚Ð°',0),(507490,14097,'es','Permite descuentos de facturas de crÃ©dito en la pÃ¡gina de pago',0),(507491,14097,'de','ERMÃ„SSIGUNGEN fÃ¼r Kreditkarten-Rechnungen auf Seite \"Zahlung\" zu ermÃ¶glichen',0),(507492,14097,'en','Allow Discounts For Credit Invoices On Payment Page',0),(507493,14098,'is','',0),(507494,14098,'dr','ØªØ®ÙÛŒÙ Ù‡Ø§ÛŒ ÙˆØ±ÙˆØ¯ÛŒ',0),(507495,14098,'pr','ØªØ®ÙÛŒÙ Ù‡Ø§ÛŒ ÙˆØ±ÙˆØ¯ÛŒ',0),(507496,14098,'tr','Ä°ndirimler giriÅŸ',0),(507497,14098,'pl','Rabaty wpisu',0),(507498,14098,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ð·Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(507499,14098,'ur','Ø¢Ø®Ø± Ù…ÛŒÚº Ú†Ú¾ÙˆÙ¹ Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(507500,14098,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚Ð¸ Ð½Ð° ÑƒÐ½Ð¾Ñ',0),(507501,14098,'vi','Giáº£m giÃ¡ nháº­p cáº£nh',0),(507502,14098,'af','Afslag inskrywing',0),(507503,14098,'ro','Reduceri la intrare',0),(507504,14098,'et','Allahindlused kanne',0),(507505,14098,'si','Vnos popustov',0),(507506,14098,'ba','Diskon entri',0),(507507,14098,'nl','Kortingen Entry',0),(507508,14098,'fi','Alennukset merkintÃ¤',0),(507509,14098,'no','Rabatter oppfÃ¸ring',0),(507510,14098,'da','Rabatter post',0),(507511,14098,'ko','í• ì¸ í•­ëª©',0),(507512,14098,'he','×”× ×—×•×ª ×”×–× ×”',0),(507513,14098,'el','Î•ÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ Î¾ÎµÎ½Î¿Î´Î¿Ï‡ÎµÎ¯Ï‰Î½ ÏƒÎµ ÎµÎ³Î³ÏÎ±Ï†Î®',0),(507514,14098,'zh','æŠ˜æ‰£æ¡ç›®',0),(507515,14098,'sv','Rabatter intrÃ¤de',0),(507516,14098,'it','Voce SCONTI',0),(507517,14098,'tl','',0),(507518,14098,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¹ˆà¸§à¸™à¸¥à¸”',0),(507519,14098,'hi','à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(507520,14098,'ms','Diskaun penyertaan',0),(507521,14098,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª',0),(507522,14098,'fr','Tarifs entrÃ©e',0),(507523,14098,'jp','ã‚¨ãƒ³ãƒˆãƒªã‚’å‰²å¼•ã—ã¾ã™ã€‚',0),(507524,14098,'pt','Entrada de descontos',0),(507525,14098,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(507526,14098,'es','Descuentos de entrada',0),(507527,14098,'de','ERMÃ„SSIGUNGEN-Eintrag',0),(507528,14098,'en','Discounts Entry',0),(507529,14099,'is','',0),(507530,14099,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† ØªÙ†Ù‡Ø§ ØªØ®ÙÛŒÙ Ù…Ù†Ø¸ÙˆØ± Ú©Ù„ Ù…Ø·Ù„Ø¨',0),(507531,14099,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† ØªÙ†Ù‡Ø§ ØªØ®ÙÛŒÙ Ù…Ù†Ø¸ÙˆØ± Ú©Ù„ Ù…Ø·Ù„Ø¨',0),(507532,14099,'tr','YalnÄ±zca tÃ¼m sipariÅŸ giriÅŸi indirimler gizle',0),(507533,14099,'pl','Ukryj tylko caÅ‚e zamÃ³wienie rabaty wpisu',0),(507534,14099,'bg','Ð¡ÐºÑ€Ð¸Ð¹ ÑÐ°Ð¼Ð¾ Ñ†ÑÐ»Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ð·Ð°Ð¿Ð¸Ñ',0),(507535,14099,'ur','Ù¾ÙˆØ±ÛŒ Ù†Ø¸Ù… Ù…ÛŒÚº Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú†Ú¾ÙˆÙ¹ ØµØ±Ù Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(507536,14099,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð·Ð° Ñ†ÐµÐ¾ Ð½Ð°Ð»Ð¾Ð³ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð¸ Ð½Ð° ÑƒÐ½Ð¾Ñ',0),(507537,14099,'vi','áº¨n chá»‰ toÃ n bá»™ Ä‘á»ƒ giáº£m giÃ¡ nháº­p cáº£nh',0),(507538,14099,'af','Versteek net hele orde kortings inskrywing',0),(507539,14099,'ro','Ascunde numai Ã®ntreaga ordine reduceri la intrare',0),(507540,14099,'et','Peida ainult kogu tellimuse hinnaalandid kanne',0),(507541,14099,'si','Skrij samo celotno naroÄilo popusti vstop',0),(507542,14099,'ba','Menyembunyikan hanya seluruh Order diskon entri',0),(507543,14099,'nl','Verberg alleen gehele Order Entry kortingen',0),(507544,14099,'fi','Piilota vain koko tilaus alennukset merkintÃ¤',0),(507545,14099,'no','Skjule bare hele bestillingen rabatter oppfÃ¸ring',0),(507546,14099,'da','Skjul kun hele ordren rabatter post',0),(507547,14099,'ko','ë§Œ ì „ì²´ ì£¼ë¬¸ í• ì¸ í•­ëª© ìˆ¨ê¸°ê¸°',0),(507548,14099,'he','×”×¡×ª×¨ ×¨×§ ×¡×“×¨ ×›×œ ×”× ×—×•×ª ×”×–× ×”',0),(507549,14099,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î¼ÏŒÎ½Î¿ Ï„Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï„Î·Ï‚ Ï„Î¬Î¾Î·Ï‚ ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(507550,14099,'zh','éšè—åªæœ‰æ•´ä¸ªè®¢å•æŠ˜æ‰£æ¡ç›®',0),(507551,14099,'sv','DÃ¶lja bara hela bestÃ¤llningen rabatter intrÃ¤de',0),(507552,14099,'it','Nascondere solo l\'intero ordine SCONTI ingresso',0),(507553,14099,'tl','',0),(507554,14099,'th','à¸‹à¹ˆà¸­à¸™à¹€à¸‰à¸žà¸²à¸°à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¹ƒà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(507555,14099,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥‚à¤°à¥‡ à¤•à¥à¤°à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤›à¥‚à¤Ÿ à¤›à¥à¤ªà¤¾à¤à¤',0),(507556,14099,'ms','Sembunyi sahaja seluruh perintah diskaun penyertaan',0),(507557,14099,'ar','Ø¥Ø®ÙØ§Ø¡ ÙÙ‚Ø· Ø§Ù„Ù†Ø¸Ø§Ù… ÙƒÙ„Ù‡ Ø®ØµÙˆÙ…Ø§Øª Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(507558,14099,'fr','Masquer seulement de l\'ensemble de la commande rÃ©duction entrÃ©e',0),(507559,14099,'jp','æ³¨æ–‡å…¨ä½“ã®ã‚¨ãƒ³ãƒˆãƒªã®å‰²å¼•ã ã‘ã§éžè¡¨ç¤ºã«ã—ã¾ã™ã€‚',0),(507560,14099,'pt','Ocultar, somente descontos de toda ordem entrada',0),(507561,14099,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð²ÐµÑÑŒ Ð·Ð°ÐºÐ°Ð· ÑÐºÐ¸Ð´ÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(507562,14099,'es','Ocultar sÃ³lo descuentos de todo orden entrada',0),(507563,14099,'de','Nur ganze Order Entry Rabatte ausblenden',0),(507564,14099,'en','Hide Only Whole Order Discounts Entry',0),(507565,14100,'is','',0),(507566,14100,'dr','Ù†Ù…Ø§ÛŒØ´ ÙˆØ±ÙˆØ¯ÛŒ ØªØ®ÙÛŒÙ',0),(507567,14100,'pr','Ù†Ù…Ø§ÛŒØ´ ÙˆØ±ÙˆØ¯ÛŒ ØªØ®ÙÛŒÙ',0),(507568,14100,'tr','Show indirimler giriÅŸ',0),(507569,14100,'pl','PokaÅ¼ wpis rabaty',0),(507570,14100,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸',0),(507571,14100,'ur','Ø¢Ø®Ø± Ù…ÛŒÚº Ú†Ú¾ÙˆÙ¹ Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(507572,14100,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ðµ Ð½Ð° ÑƒÐ½Ð¾Ñ',0),(507573,14100,'vi','Hiá»ƒn thá»‹ giáº£m giÃ¡ nháº­p cáº£nh',0),(507574,14100,'af','Wys afslag inskrywing',0),(507575,14100,'ro','AratÄƒ reduceri la intrare',0),(507576,14100,'et','Kuva allahindlusi kanne',0),(507577,14100,'si','PrikaÅ¾i vstop popusti',0),(507578,14100,'ba','Tampilkan Entry DISKON',0),(507579,14100,'nl','Toon kortingen Entry',0),(507580,14100,'fi','Alennukset merkintÃ¤',0),(507581,14100,'no','Vis rabatter oppfÃ¸ring',0),(507582,14100,'da','Vis rabatter post',0),(507583,14100,'ko','í• ì¸ í•­ëª© í‘œì‹œ',0),(507584,14100,'he','×”×¦×’ ×”× ×—×•×ª ×”×–× ×”',0),(507585,14100,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚',0),(507586,14100,'zh','æ˜¾ç¤ºæŠ˜æ‰£æ¡ç›®',0),(507587,14100,'sv','Visa rabatter intrÃ¤de',0),(507588,14100,'it','Visualizza sconti ingresso',0),(507589,14100,'tl','',0),(507590,14100,'th','à¹à¸ªà¸”à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¹ˆà¸§à¸™à¸¥à¸”',0),(507591,14100,'hi','à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(507592,14100,'ms','Menunjukkan diskaun penyertaan',0),(507593,14100,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª',0),(507594,14100,'fr','Voir la rÃ©duction entrÃ©e',0),(507595,14100,'jp','å‰²å¼•ã®ã‚¨ãƒ³ãƒˆãƒªã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(507596,14100,'pt','Mostrar entrada de descontos',0),(507597,14100,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ ÑÐºÐ¸Ð´ÐºÐ¸',0),(507598,14100,'es','Mostrar descuentos de entrada',0),(507599,14100,'de','Karte Rabatte Eintrag',0),(507600,14100,'en','Show Discounts Entry',0),(507601,14101,'is','',0),(507602,14101,'dr','Ø³Ù‡Ø§Ù… Ø´Ø±Ú©Øª Ù‡Ø§ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø§Ø²',0),(507603,14101,'pr','Ø³Ù‡Ø§Ù… Ø´Ø±Ú©Øª Ù‡Ø§ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø§Ø²',0),(507604,14101,'tr','VarsayÄ±lan gÃ¶rÃ¼nÃ¼mÃ¼ stok--dan ÅŸirketlere',0),(507605,14101,'pl','DomyÅ›lnie firm na widok fotografii z',0),(507606,14101,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ ÐºÑŠÐ¼ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´ Ð·Ð°Ð¿Ð°Ñ Ð¾Ñ‚',0),(507607,14101,'ur','Ù…Ù†Ø¸Ø± Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ø³Û’ Ø§Ø³Ù¹Ø§Ú©',0),(507608,14101,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð´Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð°ÐºÑ†Ð¸Ñ˜Ðµ Ð¸Ð·',0),(507609,14101,'vi','Máº·c Ä‘á»‹nh cÃ´ng ty Ä‘á»ƒ xem chá»©ng khoÃ¡n tá»«',0),(507610,14101,'af','Verstek maatskappye te bekyk voorraad van',0),(507611,14101,'ro','Implicit companii sÄƒ Vezi stocul de',0),(507612,14101,'et','Vaikimisi ettevÃµtetel vaade varu:',0),(507613,14101,'si','Podjetja privzeti pogled zaloge iz',0),(507614,14101,'ba','Standar perusahaan untuk lihat saham dari',0),(507615,14101,'nl','Standaard bedrijven naar de weergave voorraad van',0),(507616,14101,'fi','Oletus yritykset NÃ¤ytÃ¤ kannan',0),(507617,14101,'no','Standard selskaper Ã¥ utsikt lager fra',0),(507618,14101,'da','Standard virksomheder at se bestanden fra',0),(507619,14101,'ko','ê¸°ë³¸ íšŒì‚¬ì—ì„œ ë³´ê¸° ìž¬ê³ ',0),(507620,14101,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×—×‘×¨×•×ª ×ž× ×™×•×ª ×ª×¦×•×’×” ×ž',0),(507621,14101,'el','Î•Ï„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï€ÏÎ¿Î²Î¿Î»Î® Î±Ï€ÏŒÎ¸ÎµÎ¼Î± Î±Ï€ÏŒ',0),(507622,14101,'zh','åˆ°è§†å›¾çš„é»˜è®¤å…¬å¸è‚¡ç¥¨ä»Ž',0),(507623,14101,'sv','Standard fÃ¶retag att visa lager frÃ¥n',0),(507624,14101,'it','Aziende predefinito a Stock vista da',0),(507625,14101,'tl','',0),(507626,14101,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™ à¸šà¸£à¸´à¸©à¸±à¸—à¸ˆà¸°à¸”à¸¹à¸ˆà¸²à¸',0),(507627,14101,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¦à¥ƒà¤¶à¥à¤¯ à¤¸à¥‡ à¤¶à¥‡à¤¯à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¤¾à¤‚',0),(507628,14101,'ms','Syarikat-syarikat lalai untuk melihat stok dari',0),(507629,14101,'ar','Ù„Ø¹Ø±Ø¶ Ø§Ù„Ø£ÙˆØ±Ø§Ù‚ Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ù…Ù† Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(507630,14101,'fr','Entreprises par dÃ©faut Ã  la vue des stocks de',0),(507631,14101,'jp','ãƒ“ãƒ¥ãƒ¼ã‚’æ—¢å®šã®ä¼šç¤¾ã‹ã‚‰ã‚’ã‚¹ãƒˆãƒƒã‚¯ã—ã¾ã™ã€‚',0),(507632,14101,'pt','PadrÃ£o de empresas para aÃ§Ãµes de exibiÃ§Ã£o de',0),(507633,14101,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¹ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° ÑÑ‚Ð¾Ðº Ð¾Ñ‚',0),(507634,14101,'es','Por defecto las empresas ver acciones de',0),(507635,14101,'de','Standard-Firmen in Ansicht bestand aus',0),(507636,14101,'en','Default Companies To View Stock From',0),(507637,14102,'is','',0),(507638,14102,'dr','Ø¨Ø±Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ ÛŒØ§ Ø¹Ø¯Ù… Ø§Ù†ØªØ®Ø§Ø¨ ØªÙ…Ø§Ù… Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø³ÛŒ Ø³ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø±ÙˆØ² Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(507639,14102,'pr','Ø¨Ø±Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ ÛŒØ§ Ø¹Ø¯Ù… Ø§Ù†ØªØ®Ø§Ø¨ ØªÙ…Ø§Ù… Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø³ÛŒ Ø³ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø±ÙˆØ² Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(507640,14102,'tr','TÄ±klatÄ±p seÃ§in veya tÃ¼m bilgi giriÅŸleri bu gÃ¼n iÃ§in seÃ§imini kaldÄ±rÄ±n.',0),(507641,14102,'pl','Kliknij, aby zaznaczyÄ‡ lub usunÄ…Ä‡ zaznaczenie wszystkich wpisÃ³w CC na ten dzieÅ„',0),(507642,14102,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð½ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ CC Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð´ÐµÐ½',0),(507643,14102,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº ÛŒØ§ Ø§Ø³ Ø¯Ù† Ú©Û’ Ù„Ø¦Û’ ØªÙ…Ø§Ù… CC Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ø®ØªÙ… Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(507644,14102,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸ Ð¸Ð»Ð¸ ÐŸÐ¾Ð½Ð¸ÑˆÑ‚Ð¸ Ð¸Ð·Ð±Ð¾Ñ€ ÑÐ²Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¦Ð¦ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð´Ð°Ð½',0),(507645,14102,'vi','Báº¥m vÃ o Ä‘á»ƒ chá»n hoáº·c bá» chá»n táº¥t cáº£ CC Entries cho ngÃ y nÃ y',0),(507646,14102,'af','Klik om te kies of Deselekteer alle CC inskrywings vir hierdie dag',0),(507647,14102,'ro','FaceÅ£i clic pentru a selecta sau deselecta toate intrÄƒrile de CC pentru aceastÄƒ zi',0),(507648,14102,'et','KlÃµpsake, et valida ega valikut tÃ¼histada kÃµik CC kanded sel pÃ¤eval',0),(507649,14102,'si','Kliknite, da potrdite ali poÄistite vse CC vnose za ta dan',0),(507650,14102,'ba','Klik untuk centang atau Hapus centang semua CC entri untuk hari ini',0),(507651,14102,'nl','Klik om te selecteren of deselecteren van alle CC inzendingen voor deze dag',0),(507652,14102,'fi','Valitse tai poista kaikki CC merkinnÃ¤t tÃ¤mÃ¤n pÃ¤ivÃ¤n',0),(507653,14102,'no','Klikk for Ã¥ velge eller velge bort alle CC oppfÃ¸ringer For denne dagen',0),(507654,14102,'da','Klik for at vÃ¦lge eller fravÃ¦lge alle CC poster For denne dag',0),(507655,14102,'ko','ì´ ë‚ ì— ëŒ€ í•œ ëª¨ë“  ì°¸ì¡° í•­ëª©ì„ ì„ íƒ ì·¨ì†Œ í•˜ê±°ë‚˜ ì„ íƒ í•˜ë ¤ë©´ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(507656,14102,'he','×œ×—×¥ ×›×“×™ ×œ×‘×—×•×¨ ××• ×œ×‘×˜×œ ××ª ×”×‘×—×™×¨×” ×›×œ ×”×¢×¨×›×™× CC ×œ×™×•× ×”×–×”',0),(507657,14102,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î® Î½Î± ÎºÎ±Ï„Î±ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÏ‰Î½ CC Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î·Î½ Î·Î¼Î­ÏÎ±',0),(507658,14102,'zh','å•å‡»ä»¥é€‰æ‹©æˆ–å–æ¶ˆé€‰æ‹©æ‰€æœ‰ CC æ¡ç›®ä¸ºè¿™ä¸€å¤©',0),(507659,14102,'sv','Markera eller avmarkera alla CC poster fÃ¶r denna dag',0),(507660,14102,'it','Fare clic per selezionare o deselezionare tutte le voci CC per questo giorno',0),(507661,14102,'tl','',0),(507662,14102,'th','à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­à¹€à¸¥à¸·à¸­à¸ à¸«à¸£à¸·à¸­à¸¢à¸à¹€à¸¥à¸´à¸à¹€à¸¥à¸·à¸­à¸à¸£à¸²à¸¢à¸à¸²à¸£ CC à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¸§à¸±à¸™à¸™à¸µà¹‰',0),(507663,14102,'hi','à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤¸à¤­à¥€ CC à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤¦à¤¿à¤¨ à¤…à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(507664,14102,'ms','Klik untuk memilih atau buang semua CC entri untuk hari ini',0),(507665,14102,'ar','Ø§Ù†Ù‚Ø± Ù„ØªØ­Ø¯ÙŠØ¯ Ø£Ùˆ Ù‚Ù… Ø¨Ø¥Ù„ØºØ§Ø¡ ØªØ­Ø¯ÙŠØ¯ ÙƒØ§ÙØ© Ø¥Ø¯Ø®Ø§Ù„Ø§Øª \"Ù†Ø³Ø®Ø©\" Ù„Ù‡Ø°Ø§ Ø§Ù„ÙŠÙˆÙ…',0),(507666,14102,'fr','Cliquez pour sÃ©lectionner ou dÃ©sÃ©lectionner toutes les entrÃ©es CC pour cette journÃ©e',0),(507667,14102,'jp','é¸æŠžã¾ãŸã¯ã“ã®æ—¥ã® CC ã‚¨ãƒ³ãƒˆãƒªã‚’ã™ã¹ã¦é¸æŠžè§£é™¤] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(507668,14102,'pt','Clique para selecionar ou desmarcar todas as entradas CC para este dia',0),(507669,14102,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¸Ð»Ð¸ Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð±Ð¾Ñ€ Ð²ÑÐµÑ… CC Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ Ð·Ð° ÑÑ‚Ð¾Ñ‚ Ð´ÐµÐ½ÑŒ',0),(507670,14102,'es','Haga clic para seleccionar o deseleccionar todas las entradas de CC para este dÃ­a',0),(507671,14102,'de','Aktivieren oder deaktivieren alle CC-EintrÃ¤ge fÃ¼r diesen Tag',0),(507672,14102,'en','Click To Select or Deselect All CC Entries For This Day',0),(507673,14103,'is','',0),(507674,14103,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø±ÙˆØ²Ø§Ù†Ù‡',0),(507675,14103,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø±ÙˆØ²Ø§Ù†Ù‡',0),(507676,14103,'tr','Toplam gÃ¼n',0),(507677,14103,'pl','Codziennie Å‚Ä…cznie',0),(507678,14103,'bg','Ð•Ð¶ÐµÐ´Ð½ÐµÐ²Ð½Ð¾ Ð¾Ð±Ñ‰Ð¾',0),(507679,14103,'ur','Ø±ÙˆØ² Ù…Ø±Û Ú©ÛŒ Ú©Ù„',0),(507680,14103,'sr','Ð”Ð½ÐµÐ²Ð½Ð¸ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(507681,14103,'vi','Tá»•ng sá»‘ hÃ ng ngÃ y',0),(507682,14103,'af','Daaglikse totaal',0),(507683,14103,'ro','Total zilnic',0),(507684,14103,'et','Iga pÃ¤ev Kokku',0),(507685,14103,'si','Dnevno skupaj',0),(507686,14103,'ba','Harian Total',0),(507687,14103,'nl','Dagelijks totaal',0),(507688,14103,'fi','PÃ¤ivittÃ¤inen yhteenlaskettu mÃ¤Ã¤rÃ¤',0),(507689,14103,'no','Daglig Total',0),(507690,14103,'da','Dagligt i alt',0),(507691,14103,'ko','ì¼ì¼ ì´',0),(507692,14103,'he','×¡×” ×› ×™×•×ž×™×ª',0),(507693,14103,'el','ÎšÎ±Î¸Î·Î¼ÎµÏÎ¹Î½Î® ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(507694,14103,'zh','æ¯æ—¥åˆè®¡',0),(507695,14103,'sv','Dagliga totalt',0),(507696,14103,'it','Totale giornaliero',0),(507697,14103,'tl','',0),(507698,14103,'th','à¸œà¸¥à¸£à¸§à¸¡à¸£à¸²à¸¢à¸§à¸±à¸™',0),(507699,14103,'hi','à¤¦à¥ˆà¤¨à¤¿à¤• à¤•à¥à¤²',0),(507700,14103,'ms','Jumlah harian',0),(507701,14103,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(507702,14103,'fr','Total journalier',0),(507703,14103,'jp','æ¯Žæ—¥ã®åˆè¨ˆ',0),(507704,14103,'pt','Total diÃ¡ria',0),(507705,14103,'ru','Ð˜Ñ‚Ð¾Ð³ Ð´Ð½Ñ',0),(507706,14103,'es','Total diaria',0),(507707,14103,'de','TÃ¤gliche Gesamt',0),(507708,14103,'en','Daily Total',0),(507709,14104,'is','',0),(507710,14104,'dr','Ù…ÙˆØ±Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÛŒØ§Ù„',0),(507711,14104,'pr','Ù…ÙˆØ±Ø¯ Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÛŒØ§Ù„',0),(507712,14104,'tr','Madde seri numaralarÄ±',0),(507713,14104,'pl','Numery seryjne',0),(507714,14104,'bg','Ð¡ÐµÑ€Ð¸Ð¹Ð½Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(507715,14104,'ur','Ø´Û’ Ø³ÛŒØ±ÛŒÙ„ Ù†Ù…Ø¨Ø±',0),(507716,14104,'sr','Ð¡ÐµÑ€Ð¸Ñ˜ÑÐºÐµ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(507717,14104,'vi','Sá»‘ má»¥c',0),(507718,14104,'af','Item serie nommers',0),(507719,14104,'ro','Numere de serie articol',0),(507720,14104,'et','Kauba seerianumbrite',0),(507721,14104,'si','Serijske Å¡tevilke artiklov',0),(507722,14104,'ba','Item nomor seri',0),(507723,14104,'nl','Item serienummers',0),(507724,14104,'fi','Nimikkeen sarjanumeroiden',0),(507725,14104,'no','Elementet serienumre',0),(507726,14104,'da','Seriel varenumre',0),(507727,14104,'ko','ì¼ë ¨ ë²ˆí˜¸',0),(507728,14104,'he','×ž×¡×¤×¨×™× ×¡×™×“×•×¨×™×™× ×¤×¨×™×˜',0),(507729,14104,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±ÏÎ¾Î¿Î½Ï„ÎµÏ‚ Î±ÏÎ¹Î¸Î¼Î¿ÏÏ‚',0),(507730,14104,'zh','é¡¹ç›®ç¼–å·',0),(507731,14104,'sv','Objektet serienummer',0),(507732,14104,'it','Numeri di serie di elemento',0),(507733,14104,'tl','',0),(507734,14104,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸›à¸£à¸°à¸ˆà¸³à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(507735,14104,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¥€à¤°à¤¿à¤¯à¤² à¤¨à¤‚à¤¬à¤°',0),(507736,14104,'ms','Nombor siri barang',0),(507737,14104,'ar','Ø§Ù„Ø£Ø±Ù‚Ø§Ù… Ø§Ù„ØªØ³Ù„Ø³Ù„ÙŠØ© Ø§Ù„Ø¨Ù†Ø¯',0),(507738,14104,'fr','NumÃ©ros de sÃ©rie',0),(507739,14104,'jp','å“ç›®ã®ã‚·ãƒªã‚¢ãƒ«ç•ªå·',0),(507740,14104,'pt','NÃºmeros de sÃ©rie do item',0),(507741,14104,'ru','ÐŸÑƒÐ½ÐºÑ‚ ÑÐµÑ€Ð¸Ð¹Ð½Ñ‹Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(507742,14104,'es','NÃºmeros de serie',0),(507743,14104,'de','Artikel-Seriennummern',0),(507744,14104,'en','Item Serial Numbers',0),(507745,14105,'is','',0),(507746,14105,'dr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÛŒØ§Ù„ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(507747,14105,'pr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÛŒØ§Ù„ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(507748,14105,'tr','Seri numaralarÄ± giriniz',0),(507749,14105,'pl','ProszÄ™ wprowadziÄ‡ numery seryjne',0),(507750,14105,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÐµÑ€Ð¸Ð¹Ð½Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(507751,14105,'ur','Ø³ÛŒØ±ÛŒÙ„ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(507752,14105,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑÐµÑ€Ð¸Ñ˜ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(507753,14105,'vi','Vui lÃ²ng nháº­p sá»‘ Serial',0),(507754,14105,'af','Tik asseblief serie nommers',0),(507755,14105,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i numerele de serie',0),(507756,14105,'et','Palun sisestage seerianumber',0),(507757,14105,'si','Vnesite serijske Å¡tevilke',0),(507758,14105,'ba','Masukkan nomor seri',0),(507759,14105,'nl','Voer de serienummers',0),(507760,14105,'fi','SyÃ¶tÃ¤ sarja-runo',0),(507761,14105,'no','Angi serienumrene',0),(507762,14105,'da','Angiv serienumrene',0),(507763,14105,'ko','ì¼ë ¨ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(507764,14105,'he','×× × ×”×–×Ÿ ×ž×¡×¤×¨×™× ×¡×™×“×•×¨×™×™×',0),(507765,14105,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î±ÏÎ¾Î¿Î½Ï„ÎµÏ‚ Î±ÏÎ¹Î¸Î¼Î¿ÏÏ‚',0),(507766,14105,'zh','è¯·è¾“å…¥åºåˆ—å·',0),(507767,14105,'sv','Ange serienummer',0),(507768,14105,'it','Inserisci i numeri di serie',0),(507769,14105,'tl','',0),(507770,14105,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸°à¸šà¸¸à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸¥à¸³à¸”à¸±à¸šà¸›à¸£à¸°à¸ˆà¸³à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(507771,14105,'hi','à¤…à¤¨à¥à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾à¤à¤ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(507772,14105,'ms','Sila masukkan nombor siri',0),(507773,14105,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø£Ø±Ù‚Ø§Ù… Ø§Ù„ØªØ³Ù„Ø³Ù„ÙŠØ©',0),(507774,14105,'fr','Veuillez entrer les numÃ©ros de sÃ©rie',0),(507775,14105,'jp','ã‚·ãƒªã‚¢ãƒ«ç•ªå·ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(507776,14105,'pt','Por favor, digite os nÃºmeros de sÃ©rie',0),(507777,14105,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÐµÑ€Ð¸Ð¹Ð½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(507778,14105,'es','Por favor, introduzca los nÃºmeros de serie',0),(507779,14105,'de','Bitte geben Sie Seriennummern',0),(507780,14105,'en','Please Enter Serial Numbers',0),(507781,14106,'is','',0),(507782,14106,'dr','ØªÙ…Ø§Ù… Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÛŒØ§Ù„ Ø¬Ø¹Ø¨Ù‡ Ú©Ù‡ Ø¨Ø§ÛŒØ¯ Ù¾Ø± Ø´ÙˆÛŒØ¯',0),(507783,14106,'pr','ØªÙ…Ø§Ù… Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÛŒØ§Ù„ Ø¬Ø¹Ø¨Ù‡ Ú©Ù‡ Ø¨Ø§ÛŒØ¯ Ù¾Ø± Ø´ÙˆÛŒØ¯',0),(507784,14106,'tr','TÃ¼m seri numarasÄ± kutularÄ±nÄ± doldurulmalÄ±dÄ±r',0),(507785,14106,'pl','NaleÅ¼y wypeÅ‚niÄ‡ wszystkie pola numer seryjny',0),(507786,14106,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ð¾Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð½Ð° ÑÐµÑ€Ð¸ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(507787,14106,'ur','ØªÙ…Ø§Ù… Ø³ÛŒØ±ÛŒÙ„ Ù†Ù…Ø¨Ø± Ø¨Ø§Ú©Ø³ÛŒØ² Ù¾Ø± ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(507788,14106,'sr','ÐœÐ¾Ñ€Ð°Ñ˜Ñƒ Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾Ð¿ÑƒÑšÐµÐ½Ð° ÑÐ²Ð° Ð¿Ð¾Ñ™Ð° Ð·Ð° ÑÐµÑ€Ð¸Ñ˜ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(507789,14106,'vi','Táº¥t cáº£ sá»‘ sÃª-ri há»™p pháº£i Ä‘Æ°á»£c Ä‘iá»n vÃ o',0),(507790,14106,'af','Alle reeksnommer bokse moet ingevul word',0),(507791,14106,'ro','Trebuie completate toate casetele numÄƒr Ã®n serie',0),(507792,14106,'et','KÃµik seerianumber lahtrid tuleb tÃ¤ita',0),(507793,14106,'si','Morate izpolniti vsa polja serijska Å¡tevilka',0),(507794,14106,'ba','Semua kotak-kotak nomor seri harus diisi',0),(507795,14106,'nl','Alle serienummer vakken moeten worden ingevuld',0),(507796,14106,'fi','Kaikki sarjanumero laatikot ovat pakollisia',0),(507797,14106,'no','Alle lÃ¸penummer bokser mÃ¥ fylles ut',0),(507798,14106,'da','Alle serienummer bokse skal udfyldes',0),(507799,14106,'ko','ëª¨ë“  ì¼ë ¨ ë²ˆí˜¸ ìƒìž ê°€ë“ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(507800,14106,'he','×›×œ ×ª×™×‘×•×ª ×ž×¡×¤×¨ ×¡×™×“×•×¨×™ ×™×© ×œ×ž×œ×',0),(507801,14106,'el','ÎÎ± ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÏƒÎµÏ„Îµ ÏŒÎ»Î± Ï„Î± Ï€Î»Î±Î¯ÏƒÎ¹Î± Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(507802,14106,'zh','å¿…é¡»å¡«å†™æ‰€æœ‰çš„åºåˆ—å·æ¡†',0),(507803,14106,'sv','Alla serienummer rutor mÃ¥ste fyllas i',0),(507804,14106,'it','Tutte le caselle di numero di serie devono essere compilate',0),(507805,14106,'tl','',0),(507806,14106,'th','à¸•à¹‰à¸­à¸‡à¸à¸£à¸­à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸¥à¸³à¸”à¸±à¸šà¸›à¸£à¸°à¸ˆà¸³à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸¸à¸à¸à¸¥à¹ˆà¸­à¸‡',0),(507807,14106,'hi','à¤¸à¤­à¥€ à¤¸à¥€à¤°à¤¿à¤¯à¤² à¤¨à¤‚à¤¬à¤° à¤¬à¥‰à¤•à¥à¤¸ à¤­à¤°à¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(507808,14106,'ms','Semua nombor siri kotak harus diisi dengan',0),(507809,14106,'ar','ÙŠØ¬Ø¨ Ù…Ù„Ø¡ Ø¬Ù…ÙŠØ¹ Ø®Ø§Ù†Ø§Øª Ø§Ù„Ø±Ù‚Ù… Ø§Ù„ØªØ³Ù„Ø³Ù„ÙŠ',0),(507810,14106,'fr','Toutes les boÃ®tes de numÃ©ro de sÃ©rie doivent Ãªtre renseignÃ©s',0),(507811,14106,'jp','ã‚·ãƒªã‚¢ãƒ«ç•ªå·ã®ã™ã¹ã¦ã®ãƒœãƒƒã‚¯ã‚¹ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(507812,14106,'pt','Todas as caixas de nÃºmero de sÃ©rie devem ser preenchidas',0),(507813,14106,'ru','Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ Ð·Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ñ‹ Ð²ÑÐµ Ð¿Ð¾Ð»Ñ Ð¡ÐµÑ€Ð¸Ð¹Ð½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(507814,14106,'es','Deben rellenarse todos los cuadros de nÃºmero de serie',0),(507815,14106,'de','Seriennummer Felder mÃ¼ssen ausgefÃ¼llt werden',0),(507816,14106,'en','All Serial Number Boxes Must Be Filled In',0),(507817,14107,'is','',0),(507818,14107,'dr','Ø®Ø·ÙˆØ· Ø²ÛŒØ± Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÛŒØ§Ù„',0),(507819,14107,'pr','Ø®Ø·ÙˆØ· Ø²ÛŒØ± Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ø³Ø±ÛŒØ§Ù„',0),(507820,14107,'tr','AÅŸaÄŸÄ±daki satÄ±rlarÄ± seri numaralarÄ± lazÄ±m',0),(507821,14107,'pl','NastÄ™pujÄ…ce wiersze potrzebowaÄ‡ powieÅ›Ä‡ w odcinkach liczby',0),(507822,14107,'bg','Ð¡Ð»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ñ€ÐµÐ´Ð¾Ð²Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° ÑÐµÑ€Ð¸Ð¹Ð½Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(507823,14107,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ù„Ø§Ø¦Ù†ÙˆÚº Ú©Ùˆ Ø³ÛŒØ±ÛŒÙ„ Ù†Ù…Ø¨Ø± Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(507824,14107,'sr','Ð¡Ñ™ÐµÐ´ÐµÑ›Ðµ Ñ‚Ñ€ÐµÐ±Ð° ÑÐµÑ€Ð¸Ñ˜ÑÐºÐµ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ðµ',0),(507825,14107,'vi','Nhá»¯ng dÃ²ng cáº§n sá»‘ Serial',0),(507826,14107,'af','Die volgende reÃ«ls moet serie nommers',0),(507827,14107,'ro','UrmÄƒtoarele linii nevoie de numere de serie',0),(507828,14107,'et','JÃ¤rgmised read vajavad seerianumbrid',0),(507829,14107,'si','Naslednje vrstice potrebujejo serijske Å¡tevilke',0),(507830,14107,'ba','Baris berikut perlu nomor seri',0),(507831,14107,'nl','De volgende regels moeten serienummers',0),(507832,14107,'fi','Seuraavat rivit on sarjanumerot',0),(507833,14107,'no','FÃ¸lgende linjer trenger serienumre',0),(507834,14107,'da','FÃ¸lgende linjer skal serienumre',0),(507835,14107,'ko','ë‹¤ìŒ ì¤„ ì¼ë ¨ ë²ˆí˜¸ í•„ìš”',0),(507836,14107,'he','×”×©×•×¨×•×ª ×”×‘××•×ª ×¦×¨×™×š ×ž×¡×¤×¨×™× ×¡×™×“×•×¨×™×™×',0),(507837,14107,'el','Î¤Î¹Ï‚ Î±ÎºÏŒÎ»Î¿Ï…Î¸ÎµÏ‚ Î³ÏÎ±Î¼Î¼Î­Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î±ÏÎ¾Î¿Î½Ï„ÎµÏ‚ Î±ÏÎ¹Î¸Î¼Î¿ÏÏ‚',0),(507838,14107,'zh','ä»¥ä¸‹å„è¡Œéœ€è¦çš„åºåˆ—å·',0),(507839,14107,'sv','FÃ¶ljande rader behÃ¶ver serienummer',0),(507840,14107,'it','Le linee seguenti devono essere numeri seriali',0),(507841,14107,'tl','',0),(507842,14107,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸›à¸£à¸°à¸ˆà¸³à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ˆà¸³à¹€à¸›à¹‡à¸™à¸šà¸£à¸£à¸—à¸±à¸”à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰',0),(507843,14107,'hi','à¤¨à¤¿à¤®à¥à¤¨ à¤ªà¤‚à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤ à¤¸à¥€à¤°à¤¿à¤¯à¤² à¤¨à¤‚à¤¬à¤° à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(507844,14107,'ms','Baris berikut perlu nombor siri',0),(507845,14107,'ar','Ø§Ù„Ø£Ø³Ø·Ø± Ø§Ù„ØªØ§Ù„ÙŠØ© ØªØ­ØªØ§Ø¬ Ø¥Ù„Ù‰ Ø£Ø±Ù‚Ø§Ù… ØªØ³Ù„Ø³Ù„ÙŠØ©',0),(507846,14107,'fr','Les lignes suivantes ont besoin des numÃ©ros de sÃ©rie',0),(507847,14107,'jp','æ¬¡ã®è¡Œã®ã‚·ãƒªã‚¢ãƒ«ç•ªå·ãŒå¿…è¦',0),(507848,14107,'pt','As linhas a seguir precisam de nÃºmeros de sÃ©rie',0),(507849,14107,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐµÑ€Ð¸Ð¹Ð½Ñ‹Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(507850,14107,'es','Las siguientes lÃ­neas necesitan nÃºmeros de serie',0),(507851,14107,'de','Die folgenden Zeilen benÃ¶tigen Seriennummern',0),(507852,14107,'en','The Following Lines Need Serial Numbers',0),(507853,14108,'is','',0),(507854,14108,'dr','Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ù„ÛŒÙ†Ú© Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø§Ù‡ØŒ ØªÙ†Ù‡Ø§',0),(507855,14108,'pr','Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ù„ÛŒÙ†Ú© Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø§Ù‡ØŒ ØªÙ†Ù‡Ø§',0),(507856,14108,'tr','Sadece bu ay iÃ§in olasÄ± baÄŸlantÄ±larÄ± gÃ¶ster',0),(507857,14108,'pl','PokaÅ¼ moÅ¼liwych powiÄ…zaÅ„ w tym miesiÄ…cu tylko',0),(507858,14108,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð¸Ñ‚Ðµ Ð²Ñ€ÑŠÐ·ÐºÐ¸ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð¼ÐµÑÐµÑ† ÑÐ°Ð¼Ð¾',0),(507859,14108,'ur','Ø§Ø³ Ù…Ø§Û Ú©Û’ Ù„Ø¦Û’ ØµØ±Ù Ù…Ù…Ú©Ù†Û Ø±ÙˆØ§Ø¨Ø· Ù†Ù…Ø§ÛŒØ´',0),(507860,14108,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð²ÐµÐ·Ðµ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð¼ÐµÑÐµÑ†, ÑÐ°Ð¼Ð¾',0),(507861,14108,'vi','Hiá»ƒn thá»‹ cÃ³ thá»ƒ liÃªn káº¿t cho thÃ¡ng nÃ y chá»‰',0),(507862,14108,'af','Slegs moontlike skakels vir hierdie maand wys',0),(507863,14108,'ro','AratÄƒ legaturi posibile pentru aceastÄƒ lunÄƒ numai',0),(507864,14108,'et','Kuva vÃµimalike seoste sel kuul ainult',0),(507865,14108,'si','Prikaz moÅ¾ne povezave za ta mesec le',0),(507866,14108,'ba','Menunjukkan mungkin link untuk bulan ini hanya',0),(507867,14108,'nl','Mogelijke koppelingen alleen voor deze maand weergeven',0),(507868,14108,'fi','NÃ¤ytÃ¤ mahdollisia yhteyksiÃ¤ tÃ¤ssÃ¤ kuussa vain',0),(507869,14108,'no','Vis mulig koblinger For denne mÃ¥neden bare',0),(507870,14108,'da','Vis mulige forbindelser For denne mÃ¥ned kun',0),(507871,14108,'ko','ì´ë²ˆ ë‹¬ë§Œ í‘œì‹œ ê°€ëŠ¥í•œ ë§í¬',0),(507872,14108,'he','×”×¦×’ ×§×™×©×•×¨×™× ××¤×©×¨×™×™× ×¢×‘×•×¨ ×”×—×•×“×© ×‘×œ×‘×“',0),(507873,14108,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Î¹Î¸Î±Î½ÏŽÎ½ Î´ÎµÏƒÎ¼ÏŽÎ½ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ Î¼Î®Î½Î± Î¼ÏŒÎ½Î¿',0),(507874,14108,'zh','ä»…è¿™ä¸ªæœˆæ˜¾ç¤ºå¯èƒ½å­˜åœ¨çš„è”ç³»',0),(507875,14108,'sv','Visa mÃ¶jliga LÃ¤nkar fÃ¶r denna mÃ¥nad endast',0),(507876,14108,'it','Visualizza collegamenti possibili solo per questo mese',0),(507877,14108,'tl','',0),(507878,14108,'th','à¹à¸ªà¸”à¸‡à¸à¸²à¸£à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡à¹„à¸”à¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¹€à¸”à¸·à¸­à¸™à¸™à¸µà¹‰à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(507879,14108,'hi','à¤‡à¤¸ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¥€ à¤¸à¤‚à¤­à¤µ à¤²à¤¿à¤‚à¤• à¤¦à¤¿à¤–à¤¾à¤à¤',0),(507880,14108,'ms','Tayang pautan yang mungkin untuk bulan ini sahaja',0),(507881,14108,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ØµÙ„Ø§Øª Ø§Ù„Ù…Ø­ØªÙ…Ù„Ø© Ù„Ù‡Ø°Ø§ Ø§Ù„Ø´Ù‡Ø± ÙÙ‚Ø·',0),(507882,14108,'fr','N\'afficher que les liens possibles pour ce mois-ci',0),(507883,14108,'jp','ä»Šæœˆã ã‘ã®ãŸã‚ã®å¯èƒ½ãªãƒªãƒ³ã‚¯ã‚’è¡¨ç¤º',0),(507884,14108,'pt','Mostrar Links possÃ­veis para este mÃªs sÃ³',0),(507885,14108,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ñ‹Ðµ ÑÑÑ‹Ð»ÐºÐ¸ Ð² ÑÑ‚Ð¾Ð¼ Ð¼ÐµÑÑÑ†Ðµ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(507886,14108,'es','Mostrar vÃ­nculos posibles para este mes sÃ³lo',0),(507887,14108,'de','Zeigen Sie mÃ¶gliche Verbindungen fÃ¼r diesen Monat nur',0),(507888,14108,'en','Show Possible Links For This Month Only',0),(507889,14109,'is','',0),(507890,14109,'dr','ÙÙ‚Ø· Ù…Ù†ÙÛŒ Ø±ÙˆÛŒ Ø¯Ø³Øª Ù…ÙˆØ§Ø±Ø¯ Ø¹Ø¨Ø§Ø±ØªÙ†Ø¯ Ø§Ø²:',0),(507891,14109,'pr','ÙÙ‚Ø· Ù…Ù†ÙÛŒ Ø±ÙˆÛŒ Ø¯Ø³Øª Ù…ÙˆØ§Ø±Ø¯ Ø¹Ø¨Ø§Ø±ØªÙ†Ø¯ Ø§Ø²:',0),(507892,14109,'tr','YalnÄ±zca el kalemlerde negatif dahil',0),(507893,14109,'pl','ObejmujÄ… wyÅ‚Ä…cznie negatywne elementy strony',0),(507894,14109,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÑÐ°Ð¼Ð¾ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»Ð½Ð¸ Ð½Ð° Ñ€ÑŠÐºÐ° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(507895,14109,'ur','ØµØ±Ù Ù…Ù†ÙÛŒ Ù¾Ø± ÛØ§ØªÚ¾ Ø§Ø´ÛŒØ§ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(507896,14109,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÑÐ°Ð¼Ð¾ Ð½ÐµÐ³Ð°Ñ‚Ð¸Ð²Ð½Ðµ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð¸Ð¼Ð° Ð·Ð° Ñ€ÑƒÐºÑƒ',0),(507897,14109,'vi','Bao gá»“m cÃ¡c chá»‰ tiÃªu cá»±c vÃ o cÃ¡c máº·t hÃ ng tay',0),(507898,14109,'af','Sluit slegs negatiewe op Hand Items',0),(507899,14109,'ro','Doar includ negativ pe elemente de mÃ¢nÄƒ',0),(507900,14109,'et','Sisaldama ainult negatiivne kÃ¤si esemed',0),(507901,14109,'si','VkljuÄujejo le negativne na roko elementov',0),(507902,14109,'ba','Mencakup hanya negatif pada tangan item',0),(507903,14109,'nl','Omvatten alleen negatief over Hand Items',0),(507904,14109,'fi','SisÃ¤ltyvÃ¤t vain negatiivinen kÃ¤ytettÃ¤vissÃ¤ olevia nimikkeitÃ¤',0),(507905,14109,'no','Inkluder bare Negative hÃ¥nd gjenstander',0),(507906,14109,'da','Omfatte kun Negative pÃ¥ hÃ¥nd elementer',0),(507907,14109,'ko','ë¶€ì •ì ì¸ ì† í•­ëª©ì— í¬í•¨',0),(507908,14109,'he','×›×•×œ×œ×™× ×¨×§ ×©×œ×™×œ×™ ×¢×œ ×™×“ ×¤×¨×™×˜×™×',0),(507909,14109,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î¼ÏŒÎ½Î¿ Î±ÏÎ½Î·Ï„Î¹ÎºÏŒ ÏƒÏ„Î¿ Ï‡Î­ÏÎ¹ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(507910,14109,'zh','åªåŒ…æ‹¬è´Ÿæ‰‹é¡¹ç›®',0),(507911,14109,'sv','Inkludera endast negativa pÃ¥ Hand artiklar',0),(507912,14109,'it','Includere solo negativo sugli elementi di mano',0),(507913,14109,'tl','',0),(507914,14109,'th','à¸£à¸§à¸¡à¸„à¹ˆà¸²à¸¥à¸šà¹ƒà¸™à¸¡à¸·à¸­',0),(507915,14109,'hi','à¤•à¥‡à¤µà¤² à¤¹à¤¾à¤¥ à¤®à¤¦à¥‹à¤‚ à¤ªà¤° à¤¨à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(507916,14109,'ms','Termasuk hanya negatif pada tangan item',0),(507917,14109,'ar','ÙˆØªØ´Ù…Ù„ ÙÙ‚Ø· Ø§Ù„Ø³Ù„Ø¨ÙŠØ© Ø¹Ù„Ù‰ ÙŠØ¯ Ø¹Ù†Ø§ØµØ±',0),(507918,14109,'fr','Inclure uniquement nÃ©gative sur les points de la main',0),(507919,14109,'jp','æ‰‹é …ç›®ã§è² ã®ã¿å«ã‚ã‚‹',0),(507920,14109,'pt','Incluir somente negativo na mÃ£o itens',0),(507921,14109,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¾Ñ‚Ñ€Ð¸Ñ†Ð°Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(507922,14109,'es','Incluir sÃ³lo negativo sobre artÃ­culos de mano',0),(507923,14109,'de','Enthalten Sie nur negativ fÃ¼r Hand-Elemente',0),(507924,14109,'en','Include Only Negative On Hand Items',0),(507925,14110,'is','',0),(507926,14110,'dr','Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†ÛŒ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù‚ÛŒÙ…Øª Ù…ØªÙ† Ø§Ú¯Ø± Ù‚ÛŒÙ…Øª Overridden',0),(507927,14110,'pr','Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†ÛŒ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù‚ÛŒÙ…Øª Ù…ØªÙ† Ø§Ú¯Ø± Ù‚ÛŒÙ…Øª Overridden',0),(507928,14110,'tr','GeÃ§ersiz kÄ±lma gÃ¶stermek fiyat metin varsa fiyatÄ± geÃ§ersiz kÄ±lÄ±ndÄ±',0),(507929,14110,'pl','PokaÅ¼ Override cena tekst, jeÅ›li zastÄ…pienie ceny',0),(507930,14110,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð·Ð°Ð¼ÐµÐ½Ð¸ Ñ†ÐµÐ½Ð° Ñ‚ÐµÐºÑÑ‚, Ð°ÐºÐ¾ Ð½Ð¾Ð²Ð° Ñ†ÐµÐ½Ð°',0),(507931,14110,'ur','ØªØ¬Ø§ÙˆØ² Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº Ù‚ÛŒÙ…Øª Ù…ØªÙ† ØªÙˆ Ù‚ÛŒÙ…Øª Ø³Ø¨Ù‚Øª Ù„Û’',0),(507932,14110,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐžÐ²ÐµÑ€Ñ€Ð¸Ð´Ðµ Ñ†ÐµÐ½Ð° Ñ‚ÐµÐºÑÑ‚ Ð°ÐºÐ¾ Ð·Ð°Ð¼ÐµÑšÐµÐ½Ð° Ñ†ÐµÐ½Ð°',0),(507933,14110,'vi','Hiá»ƒn thá»‹ ghi Ä‘Ã¨ giÃ¡ vÄƒn báº£n náº¿u giÃ¡ ghi Ä‘Ã¨',0),(507934,14110,'af','Wys oorheersing prys teks as prys Overridden',0),(507935,14110,'ro','AratÄƒ suprascrie Pret Text dacÄƒ preÅ£ul suprascrise',0),(507936,14110,'et','Kuva alistamise hind teksti, kui hind on alistatud',0),(507937,14110,'si','Preglasi privzeto nastavitev prikaza cena besedilo, Äe cena nadomeÅ¡Äena',0),(507938,14110,'ba','Tampilkan Override harga teks jika harga ditimpa',0),(507939,14110,'nl','Override Toon tekst prijs als prijs overschreven',0),(507940,14110,'fi','NÃ¤yttÃ¶Ã¶n hinnasta teksti, jos hinnan korjaus',0),(507941,14110,'no','Vis overstyre pris tekst hvis overstyrt pris',0),(507942,14110,'da','Vis Override pris tekst, hvis pris tilsidesat',0),(507943,14110,'ko','ìž¬ì •ì˜ í‘œì‹œ í•˜ëŠ” ê²½ìš° í…ìŠ¤íŠ¸ë¥¼ ê°€ê²© ìž¬ì •ì˜ ê°€ê²©',0),(507944,14110,'he','×”×¦×’×ª ×ž×—×™×¨ ×˜×§×¡×˜ ×× ×”×ž×—×™×¨ × ×¢×§×£',0),(507945,14110,'el','Î ÏÎ¿Î²Î¿Î»Î®Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚ Ï„Î¹Î¼Î® ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… ÎµÎ¬Î½ Î Î±ÏÎ¬ÎºÎ±Î¼ÏˆÎ· Ï„Î¹Î¼Î®Ï‚',0),(507946,14110,'zh','æ˜¾ç¤ºè¦†ç›–æ–‡æœ¬çš„ä»·æ ¼ï¼Œå¦‚æžœä»·æ ¼ä¸­é‡å†™',0),(507947,14110,'sv','Visa Ã¥sidosÃ¤ttning pris Text om pris Ã¥sidosÃ¤tts',0),(507948,14110,'it','Visualizza Override prezzo testo se prezzo viene sottoposto a override',0),(507949,14110,'tl','',0),(507950,14110,'th','à¹à¸ªà¸”à¸‡à¹à¸—à¸™à¸£à¸²à¸„à¸²à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸–à¹‰à¸²à¸£à¸²à¸„à¸²à¹à¸—à¸™',0),(507951,14110,'hi','à¤“à¤µà¤°à¤°à¤¾à¤‡à¤¡ à¤¦à¤¿à¤–à¤¾à¤à¤ à¤ªà¤¾à¤  à¤•à¥€à¤®à¤¤ à¤•à¥€ à¤¯à¤¦à¤¿ à¤“à¤µà¤°à¤°à¤¾à¤‡à¤¡ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤®à¥‚à¤²à¥à¤¯',0),(507952,14110,'ms','Menunjukkan menimpa harga teks jika harga yang diganti',0),(507953,14110,'ar','ØªØ¬Ø§ÙˆØ² Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ù†Øµ Ø¥Ø°Ø§ ØªØ¬Ø§ÙˆØ² Ø³Ø¹Ø±',0),(507954,14110,'fr','Voir la substitution de prix texte si prix substituÃ©e',0),(507955,14110,'jp','ã‚ªãƒ¼ãƒãƒ¼ãƒ©ã‚¤ãƒ‰ã‚’è¡¨ç¤ºå ´åˆãƒ†ã‚­ã‚¹ãƒˆã®ä¾¡æ ¼ä¾¡æ ¼ã®ä¸Šæ›¸ã',0),(507956,14110,'pt','Mostrar substituir texto de preÃ§o se preÃ§o substituÃ­do',0),(507957,14110,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÐ¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ Ð¦ÐµÐ½Ð° Ñ‚ÐµÐºÑÑ‚, ÐµÑÐ»Ð¸ Ñ†ÐµÐ½Ð° Ð¿ÐµÑ€ÐµÐ¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½',0),(507958,14110,'es','AnulaciÃ³n de Mostrar texto de precios si precio se reemplaza',0),(507959,14110,'de','Zeigen Override Preis Text, wenn Preis Ã¼berschreiben',0),(507960,14110,'en','Show Override Price Text If Price Overridden',0),(507961,14111,'is','',0),(507962,14111,'dr','Ø´Ø§Ù…Ù„ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ù…ÙˆØ±Ø¯ Ú©Ø§Ø¯Ø± Ø¬Ø³ØªØ¬Ùˆ',0),(507963,14111,'pr','Ø´Ø§Ù…Ù„ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¯Ø± Ù…ÙˆØ±Ø¯ Ú©Ø§Ø¯Ø± Ø¬Ø³ØªØ¬Ùˆ',0),(507964,14111,'tr','SatÄ±cÄ± Ã¼rÃ¼n kodunu madde arama kutusuna eklemek',0),(507965,14111,'pl','Zawiera kod produktu dostawcy w polu wyszukiwania elementu',0),(507966,14111,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÐºÐ¾Ð´ Ð½Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð² Ð¿Ð¾Ð»ÐµÑ‚Ð¾ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(507967,14111,'ur','ÙˆÛŒÙ†ÚˆØ± Ù¾Ø±ÙˆÚˆÚ©Ù¹ Ú©ÙˆÚˆ Ø´Û’ ØªÙ„Ø§Ø´ Ú©Ø§ Ø®Ø§Ù†Û Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº Û”',0),(507968,14111,'sr','ÐžÐ±ÑƒÑ…Ð²Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¨Ð¸Ñ„Ñ€Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(507969,14111,'vi','Bao gá»“m nhÃ  cung cáº¥p sáº£n pháº©m mÃ£ trong há»™p tÃ¬m kiáº¿m má»¥c',0),(507970,14111,'af','Handelaar produk kode sluit In Item Soekkassie',0),(507971,14111,'ro','IncludÄƒ codul de produs furnizor Ã®n caseta de cÄƒutare element',0),(507972,14111,'et','Sisaldab hankija kood kauba otsingukasti',0),(507973,14111,'si','VkljuÄujejo kodo dobavitelja izdelka v polje za iskanje artikla',0),(507974,14111,'ba','Termasuk Vendor produk kode di kotak pencarian Item',0),(507975,14111,'nl','Leverancier productcode opnemen In het vak Item zoeken',0),(507976,14111,'fi','Toimittajan Tuotekoodi sisÃ¤llyttÃ¤Ã¤ nimikkeen hakukenttÃ¤Ã¤n',0),(507977,14111,'no','Inkluder leverandÃ¸r produktkoden i elementet sÃ¸keboksen',0),(507978,14111,'da','Omfatte kreditor produktkode i elementet ransage boks',0),(507979,14111,'ko','ê³µê¸‰ ì—…ì²´ ì œí’ˆ ì½”ë“œë¥¼ í¬í•¨ í•˜ëŠ” í•­ëª© ê²€ìƒ‰ ìƒìžì—ì„œ',0),(507980,14111,'he','×›×œ×•×œ ×§×•×“ ×”×ž×•×¦×¨ ×¡×¤×§ ×¤×¨×™×˜ ×‘×ª×™×‘×ª ×”×—×™×¤×•×©',0),(507981,14111,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚ ÏƒÏ„Î¿ Ï€Î»Î±Î¯ÏƒÎ¹Î¿ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚ Ï„Î¿Ï… ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(507982,14111,'zh','åœ¨æœç´¢æ¡†ä¸­é¡¹ç›®åŒ…æ‹¬ä¾›åº”å•†çš„äº§å“ä»£ç ',0),(507983,14111,'sv','Inkludera leverantÃ¶rens produktkod i artikeln sÃ¶ka lÃ¥da',0),(507984,14111,'it','Includere il codice prodotto del fornitore nella casella Search Item',0),(507985,14111,'tl','',0),(507986,14111,'th','à¸£à¸§à¸¡à¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²à¹ƒà¸™à¸Šà¹ˆà¸­à¸‡à¸„à¹‰à¸™à¸«à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(507987,14111,'hi','à¤†à¤‡à¤Ÿà¤® à¤–à¥‹à¤œ à¤¬à¥‰à¤•à¥à¤¸ à¤®à¥‡à¤‚ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤•à¥‹à¤¡ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(507988,14111,'ms','Memasukkan kod produk penjual dalam kotak gelintar Item',0),(507989,14111,'ar','ØªØªØ¶Ù…Ù† Ø±Ù…Ø² Ø§Ù„Ù…Ù†ØªØ¬ Ø§Ù„Ù…ÙˆØ±Ø¯ ÙÙŠ Ù…Ø±Ø¨Ø¹ Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø¹Ù†ØµØ±',0),(507990,14111,'fr','Inclure un Code produit fabricant dans la zone de recherche de point',0),(507991,14111,'jp','é …ç›®æ¤œç´¢ãƒœãƒƒã‚¯ã‚¹ã«ã¯ãƒ™ãƒ³ãƒ€ãƒ¼ã®è£½å“ã‚³ãƒ¼ãƒ‰ãŒå«ã¾ã‚Œã¦',0),(507992,14111,'pt','Incluir o cÃ³digo de produto do fornecedor na caixa de pesquisa do Item',0),(507993,14111,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° ÐºÐ¾Ð´ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° Ð² Ð¿Ð¾Ð»Ðµ Ð¿Ð¾Ð¸ÑÐºÐ° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(507994,14111,'es','Incluya el cÃ³digo de producto vendedor en elemento buscador',0),(507995,14111,'de','Umfassen Sie Vendor Produktcode im Suchfeld \"Titel\"',0),(507996,14111,'en','Include Vendor Product Code In Item Search Box',0),(507997,14112,'is','',0),(507998,14112,'dr','Ù†Ù…Ø§ÛŒØ´ Ø®Ø· Ø§Ù…Ø¶Ø§ Ø¯Ø± Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÛŒ Ø±Ø³ÛŒØ¯',0),(507999,14112,'pr','Ù†Ù…Ø§ÛŒØ´ Ø®Ø· Ø§Ù…Ø¶Ø§ Ø¯Ø± Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÛŒ Ø±Ø³ÛŒØ¯',0),(508000,14112,'tr','Sevk irsaliyesinde imza satÄ±rÄ±nÄ± gÃ¶ster',0),(508001,14112,'pl','PokaÅ¼ wiersz podpisu na dostawy',0),(508002,14112,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´ Ð·Ð° Ð¿Ð¾Ð´Ð¿Ð¸Ñ Ð·Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð½Ð° ÑÑŠÐ´ÑŠÑ€Ð¶Ð°Ð½Ð¸ÐµÑ‚Ð¾',0),(508003,14112,'ur','Ù¾ÛŒÚ©Ù†Ú¯ Ù¾Ø±Ú†ÛŒ Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ù„Ø§Ø¦Ù† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(508004,14112,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ñ‚Ð¿Ð¸Ñ Ð½Ð° Ð¿Ð°ÐºÐ¾Ð²Ð°ÑšÐµ',0),(508005,14112,'vi','Hiá»ƒn thá»‹ dÃ²ng chá»¯ kÃ½ trÃªn bao bÃ¬ phiáº¿u',0),(508006,14112,'af','Handtekening lyn op verpakking strokie wys',0),(508007,14112,'ro','Linia de semnÄƒturÄƒ AratÄƒ pe ambalare alunecare',0),(508008,14112,'et','NÃ¤ita saatelehe allkirjarida',0),(508009,14112,'si','Vrstica s podpisom kaÅ¾ejo na dobavnico',0),(508010,14112,'ba','Menunjukkan garis tanda tangan pada Slip pengepakan',0),(508011,14112,'nl','Toon handtekeningregel op de pakbon',0),(508012,14112,'fi','NÃ¤ytÃ¤ allekirjoituksen rivi pakkausluettelon',0),(508013,14112,'no','Vis signaturlinje pÃ¥ fÃ¸lgeseddelen',0),(508014,14112,'da','Vises signaturlinjen pÃ¥ fÃ¸lgesedlen',0),(508015,14112,'ko','í¬ìž¥ ëª…ì„¸ì„œì— í‘œì‹œ ì„œëª…ëž€',0),(508016,14112,'he','×”×¦×’ ××ª ×©×•×¨×ª ×—×ª×™×ž×” ×¢×œ ×ª×¢×•×“×ª ×”×ž×©×œ×•×—',0),(508017,14112,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î³ÏÎ±Î¼Î¼Î® Ï…Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚ ÏƒÏ„Î¿ Î´ÎµÎ»Ï„Î¯Î¿ ÏƒÏ…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î±',0),(508018,14112,'zh','åœ¨è£…ç®±å•ä¸Šæ˜¾ç¤ºç­¾åè¡Œ',0),(508019,14112,'sv','Visa signatur linje pÃ¥ fÃ¶ljesedel',0),(508020,14112,'it','Visualizza la riga della firma sulla distinta di imballaggio',0),(508021,14112,'tl','',0),(508022,14112,'th','à¹à¸ªà¸”à¸‡à¸šà¸£à¸£à¸—à¸±à¸”à¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™à¸šà¸™à¸šà¸±à¸™à¸—à¸¶à¸à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(508023,14112,'hi','à¤ªà¥ˆà¤•à¤¿à¤‚à¤— à¤ªà¤°à¥à¤šà¥€ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(508024,14112,'ms','Menunjukkan garisan tandatangan pada Slip pembungkusan',0),(508025,14112,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø³Ø·Ø± Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ ÙÙŠ ÙƒØ´Ù Ø§Ù„ØªØ¹Ø¨Ø¦Ø©',0),(508026,14112,'fr','Voir la ligne de Signature sur le bordereau d\'expÃ©dition',0),(508027,14112,'jp','æ¢±åŒ…æ˜Žç´°ã«ç½²åæ¬„ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(508028,14112,'pt','Mostrar a linha de assinatura na guia de remessa',0),(508029,14112,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾ÐºÑƒ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸ Ð½Ð° Ð¾Ñ‚Ð±Ð¾Ñ€Ð¾Ñ‡Ð½Ð¾Ð¹ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(508030,14112,'es','Mostrar firma lÃ­nea de albarÃ¡n',0),(508031,14112,'de','Signaturzeile auf Lieferschein anzeigen',0),(508032,14112,'en','Show Signature Line On Packing Slip',0),(508033,14113,'is','',0),(508034,14113,'dr','Ø§ÛŒÙ…ÛŒÙ„ SMTP',0),(508035,14113,'pr','Ø§ÛŒÙ…ÛŒÙ„ SMTP',0),(508036,14113,'tr','E-posta SMTP',0),(508037,14113,'pl','E-mail SMTP',0),(508038,14113,'bg','SMTP Ð¸Ð¼ÐµÐ¹Ð»',0),(508039,14113,'ur','Ø§ÛŒ Ù…ÛŒÙ„ SMTP',0),(508040,14113,'sr','Ð¡ÐœÐ¢ÐŸ Ðµ-Ð¿Ð¾ÑˆÑ‚Ð°',0),(508041,14113,'vi','Email SMTP',0),(508042,14113,'af','E-pos SMTP',0),(508043,14113,'ro','E-mail SMTP',0),(508044,14113,'et','E-posti SMTP',0),(508045,14113,'si','E-poÅ¡te SMTP',0),(508046,14113,'ba','Email SMTP',0),(508047,14113,'nl','E-mail SMTP',0),(508048,14113,'fi','SÃ¤hkÃ¶posti SMTP',0),(508049,14113,'no','E-post SMTP',0),(508050,14113,'da','E-mail SMTP',0),(508051,14113,'ko','ì´ë©”ì¼ì˜ SMTP',0),(508052,14113,'he','×”×“×•××¨ ×”××œ×§×˜×¨×•× ×™ SMTP',0),(508053,14113,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… SMTP',0),(508054,14113,'zh','SMTP ç”µå­é‚®ä»¶',0),(508055,14113,'sv','E-post SMTP',0),(508056,14113,'it','E-mail SMTP',0),(508057,14113,'tl','',0),(508058,14113,'th','à¸­à¸µà¹€à¸¡à¸¥ SMTP',0),(508059,14113,'hi','à¤ˆà¤®à¥‡à¤² SMTP',0),(508060,14113,'ms','E-mel SMTP',0),(508061,14113,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ SMTP',0),(508062,14113,'fr','Courrier Ã©lectronique SMTP',0),(508063,14113,'jp','SMTP ãƒ¡ãƒ¼ãƒ«',0),(508064,14113,'pt','E-mail SMTP',0),(508065,14113,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ SMTP',0),(508066,14113,'es','Correo electrÃ³nico SMTP',0),(508067,14113,'de','Email-SMTP',0),(508068,14113,'en','Email SMTP',0),(508069,14114,'is','',0),(508070,14114,'dr','Ø¯Ø± Ø´Ø±Ø§ÛŒØ· Ø®ÙˆØ¨ Ø¨Ø§ Ø¯Ø±ÛŒØ§ÙØª',0),(508071,14114,'pr','Ø¯Ø± Ø´Ø±Ø§ÛŒØ· Ø®ÙˆØ¨ Ø¨Ø§ Ø¯Ø±ÛŒØ§ÙØª',0),(508072,14114,'tr','Ä°yi durumda tarafÄ±ndan alÄ±nan',0),(508073,14114,'pl','W dobrym stanie przez',0),(508074,14114,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð° Ð² Ð´Ð¾Ð±Ñ€Ð¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð¾Ñ‚',0),(508075,14114,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ú†Ú¾ÛŒ Ø­Ø§Ù„Øª Ù…ÛŒÚº Ù…Ù„ÛŒ',0),(508076,14114,'sr','ÐŸÑ€Ð¸Ð¼Ñ™ÐµÐ½Ð° Ñƒ Ð´Ð¾Ð±Ñ€Ð¾Ð¼ ÑÑ‚Ð°ÑšÑƒ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(508077,14114,'vi','Nháº­n Ä‘Æ°á»£c trong tÃ¬nh tráº¡ng tá»‘t bá»Ÿi',0),(508078,14114,'af','Ontvang In \'n goeie toestand deur',0),(508079,14114,'ro','Primit In stare buna de',0),(508080,14114,'et','Heas korras teel saadud',0),(508081,14114,'si','Prejel v dobrem stanju z',0),(508082,14114,'ba','Diterima dalam kondisi baik oleh',0),(508083,14114,'nl','Ontvangen In goede conditie door',0),(508084,14114,'fi','Saanut hyvÃ¤Ã¤ kuntoa',0),(508085,14114,'no','Mottatt i god stand av',0),(508086,14114,'da','Modtaget i god stand af',0),(508087,14114,'ko','ì¢‹ì€ ìƒíƒœì—ì„œ ë°›ì€',0),(508088,14114,'he','×”×ª×§×‘×œ ×‘×ž×¦×‘ ×˜×•×‘ ×¢×œ-×™×“×™',0),(508089,14114,'el','ÎˆÎ»Î±Î²Îµ ÏƒÎµ ÎºÎ±Î»Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Ï€ÏŒ',0),(508090,14114,'zh','æ”¶åˆ°ç”±çŠ¶å†µè‰¯å¥½',0),(508091,14114,'sv','Fick i gott skick av',0),(508092,14114,'it','Ricevuto In buone condizioni di',0),(508093,14114,'tl','',0),(508094,14114,'th','à¹„à¸”à¹‰à¸£à¸±à¸šà¹ƒà¸™à¸ªà¸ à¸²à¸žà¸—à¸µà¹ˆà¸”à¸µà¹‚à¸”à¸¢',0),(508095,14114,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤…à¤šà¥à¤›à¥€ à¤¹à¤¾à¤²à¤¤ à¤®à¥‡à¤‚ à¤®à¤¿à¤²à¤¾',0),(508096,14114,'ms','Diterima dalam keadaan baik oleh',0),(508097,14114,'ar','ÙˆØªÙ„Ù‚Ù‰ ÙÙŠ Ø­Ø§Ù„Ø© Ø¬ÙŠØ¯Ø© Ù‚Ø¨Ù„',0),(508098,14114,'fr','ReÃ§u en bon Ã©tat de',0),(508099,14114,'jp','ã«ã‚ˆã£ã¦è‰¯å¥½ãªçŠ¶æ…‹ã§å—ä¿¡',0),(508100,14114,'pt','Recebido em bom estado por',0),(508101,14114,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ð» Ð² Ñ…Ð¾Ñ€Ð¾ÑˆÐµÐ¼ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ð¸',0),(508102,14114,'es','Recibido en buenas condiciones por',0),(508103,14114,'de','In gutem Zustand von empfangen',0),(508104,14114,'en','Received In Good Condition By',0),(508105,14115,'is','',0),(508106,14115,'dr','Ø§Ù…Ø¶Ø§',0),(508107,14115,'pr','Ø§Ù…Ø¶Ø§',0),(508108,14115,'tr','Ä°mzaladÄ±',0),(508109,14115,'pl','Podpisane',0),(508110,14115,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(508111,14115,'ur','Ø¯Ø³ØªØ®Ø· Ø´Ø¯Û',0),(508112,14115,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ°Ð¾',0),(508113,14115,'vi','ÄÃ£ kÃ½',0),(508114,14115,'af','Onderteken',0),(508115,14115,'ro','Semnat',0),(508116,14115,'et','Allkirjastatud',0),(508117,14115,'si','Podpisan',0),(508118,14115,'ba','Ditandatangani',0),(508119,14115,'nl','Ondertekend',0),(508120,14115,'fi','Allekirjoitettu',0),(508121,14115,'no','Signert',0),(508122,14115,'da','Underskrevet',0),(508123,14115,'ko','ì„œëª…',0),(508124,14115,'he','×—×ª×•×',0),(508125,14115,'el','Î¥Ï€Î­Î³ÏÎ±ÏˆÎµ',0),(508126,14115,'zh','ç­¾ç½²',0),(508127,14115,'sv','Undertecknat',0),(508128,14115,'it','Firmato',0),(508129,14115,'tl','',0),(508130,14115,'th','à¸¥à¸‡à¸™à¸²à¸¡',0),(508131,14115,'hi','à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤¿à¤',0),(508132,14115,'ms','Ditandatangani',0),(508133,14115,'ar','ØªÙˆÙ‚ÙŠØ¹',0),(508134,14115,'fr','SignÃ©',0),(508135,14115,'jp','ç½²å',0),(508136,14115,'pt','Assinado',0),(508137,14115,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¾',0),(508138,14115,'es','Firmado',0),(508139,14115,'de','Unterzeichnet',0),(508140,14115,'en','Signed',0),(508141,14116,'is','',0),(508142,14116,'dr','Ù„Ø§ÛŒØ­Ù‡ Ø¨Ù‡ Ø·ÙˆØ± Ù…Ø¯Ø§ÙˆÙ…',0),(508143,14116,'pr','Ù„Ø§ÛŒØ­Ù‡ Ø¨Ù‡ Ø·ÙˆØ± Ù…Ø¯Ø§ÙˆÙ…',0),(508144,14116,'tr','Bill sÃ¼rekli',0),(508145,14116,'pl','Bill ciÄ…gle',0),(508146,14116,'bg','Ð‘Ð¸Ð» Ð½ÐµÐ¿Ñ€ÐµÐºÑŠÑÐ½Ð°Ñ‚Ð¾',0),(508147,14116,'ur','Ø¨Ù„ Ù…Ø³Ù„Ø³Ù„',0),(508148,14116,'sr','Ð‘Ð¸Ð» Ð½ÐµÐ¿Ñ€ÐµÐºÐ¸Ð´Ð½Ð¾',0),(508149,14116,'vi','Bill liÃªn tá»¥c',0),(508150,14116,'af','Wetsontwerp voortdurend',0),(508151,14116,'ro','Bill continuu',0),(508152,14116,'et','Bill pidevalt',0),(508153,14116,'si','Bill neprekinjeno',0),(508154,14116,'ba','Bill terus-menerus',0),(508155,14116,'nl','Bill voortdurend',0),(508156,14116,'fi','Bill jatkuvasti',0),(508157,14116,'no','Bill kontinuerlig',0),(508158,14116,'da','Bill lÃ¸bende',0),(508159,14116,'ko','ì§€ì†ì ìœ¼ë¡œ ë¹Œ',0),(508160,14116,'he','×‘×™×œ ×‘×¨×¦×™×¤×•×ª',0),(508161,14116,'el','Bill ÏƒÏ…Î½ÎµÏ‡ÏŽÏ‚',0),(508162,14116,'zh','æ¡ä¾‹è‰æ¡ˆä¸æ–­',0),(508163,14116,'sv','Bill kontinuerligt',0),(508164,14116,'it','Bill continuamente',0),(508165,14116,'tl','',0),(508166,14116,'th','à¸•à¸±à¹‹à¸§à¸­à¸¢à¹ˆà¸²à¸‡à¸•à¹ˆà¸­à¹€à¸™à¸·à¹ˆà¸­à¸‡',0),(508167,14116,'hi','à¤¬à¤¿à¤² à¤²à¤—à¤¾à¤¤à¤¾à¤°',0),(508168,14116,'ms','Rang undang-undang secara berterusan',0),(508169,14116,'ar','Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ø¨Ø§Ø³ØªÙ…Ø±Ø§Ø±',0),(508170,14116,'fr','Projet de loi en continu',0),(508171,14116,'jp','æ³•æ¡ˆã‚’ç¶™ç¶šçš„ã«',0),(508172,14116,'pt','Bill continuamente',0),(508173,14116,'ru','Ð‘Ð¸Ð»Ð» Ð½ÐµÐ¿Ñ€ÐµÑ€Ñ‹Ð²Ð½Ð¾',0),(508174,14116,'es','Bill continuamente',0),(508175,14116,'de','Bill kontinuierlich',0),(508176,14116,'en','Bill Continuously',0),(508177,14117,'is','',0),(508178,14117,'dr','Ø¨Ù†Ø¯Ø±',0),(508179,14117,'pr','Ø¨Ù†Ø¯Ø±',0),(508180,14117,'tr','BaÄŸlantÄ± noktasÄ±',0),(508181,14117,'pl','Portu',0),(508182,14117,'bg','ÐŸÐ¾Ñ€Ñ‚',0),(508183,14117,'ur','Ø¯ÛØ§Ù†Û',0),(508184,14117,'sr','ÐŸÑ€Ð¸ÐºÑ™ÑƒÑ‡Ð°Ðº',0),(508185,14117,'vi','Cá»•ng',0),(508186,14117,'af','Poort',0),(508187,14117,'ro','Port',0),(508188,14117,'et','Port',0),(508189,14117,'si','PristaniÅ¡Äa',0),(508190,14117,'ba','Port',0),(508191,14117,'nl','Poort',0),(508192,14117,'fi','Port',0),(508193,14117,'no','Port',0),(508194,14117,'da','Port',0),(508195,14117,'ko','í¬íŠ¸',0),(508196,14117,'he','×™×¦×™××”',0),(508197,14117,'el','Î›Î¹Î¼Î¬Î½Î¹',0),(508198,14117,'zh','ç«¯å£',0),(508199,14117,'sv','Port',0),(508200,14117,'it','Porta',0),(508201,14117,'tl','',0),(508202,14117,'th','à¸žà¸­à¸£à¹Œà¸•',0),(508203,14117,'hi','à¤ªà¥‹à¤°à¥à¤Ÿ',0),(508204,14117,'ms','Port',0),(508205,14117,'ar','Ù…Ù†ÙØ°',0),(508206,14117,'fr','Port',0),(508207,14117,'jp','ãƒãƒ¼ãƒˆ',0),(508208,14117,'pt','Porto',0),(508209,14117,'ru','ÐŸÐ¾Ñ€Ñ‚',0),(508210,14117,'es','Puerto',0),(508211,14117,'de','Port',0),(508212,14117,'en','Port',0),(508213,14118,'is','',0),(508214,14118,'dr','Ø§Ù…Ù†',0),(508215,14118,'pr','Ø§Ù…Ù†',0),(508216,14118,'tr','GÃ¼venli',0),(508217,14118,'pl','Bezpieczne',0),(508218,14118,'bg','Ð—Ð°Ñ‰Ð¸Ñ‚ÐµÐ½Ð¾',0),(508219,14118,'ur','Ù…Ø­ÙÙˆØ¸',0),(508220,14118,'sr','ÐžÑÐ¸Ð³ÑƒÑ€Ð°Ñ˜Ñ‚Ðµ',0),(508221,14118,'vi','An toÃ n',0),(508222,14118,'af','Beveilig',0),(508223,14118,'ro','Sigur',0),(508224,14118,'et','Turvaline',0),(508225,14118,'si','Secure',0),(508226,14118,'ba','Aman',0),(508227,14118,'nl','Beveiligen',0),(508228,14118,'fi','Secure',0),(508229,14118,'no','Sikre',0),(508230,14118,'da','Sikre',0),(508231,14118,'ko','ë³´ì•ˆ',0),(508232,14118,'he','×ž××•×‘×˜×—',0),(508233,14118,'el','Î‘ÏƒÏ†Î±Î»Î®Ï‚',0),(508234,14118,'zh','å®‰å…¨',0),(508235,14118,'sv','SÃ¤kra',0),(508236,14118,'it','Garantire la',0),(508237,14118,'tl','',0),(508238,14118,'th','à¸ˆà¸­à¸‡à¸«à¹‰à¸­à¸‡à¸žà¸±à¸',0),(508239,14118,'hi','à¤¸à¥à¤°à¤•à¥à¤·à¤¿à¤¤',0),(508240,14118,'ms','Selamat',0),(508241,14118,'ar','ØªØ£Ù…ÙŠÙ†',0),(508242,14118,'fr','Secure',0),(508243,14118,'jp','ã‚»ã‚­ãƒ¥ãƒªãƒ†ã‚£ã§ä¿è­·ã•ã‚Œã¾ã—ãŸã€‚',0),(508244,14118,'pt','Secure',0),(508245,14118,'ru','Ð‘ÐµÐ·Ð¾Ð¿Ð°ÑÐ½Ñ‹Ð¹',0),(508246,14118,'es','Secure',0),(508247,14118,'de','Sichern',0),(508248,14118,'en','Secure',0),(508249,14119,'is','',0),(508250,14119,'dr','SMTP Ø±Ø§ ÙØ¹Ø§Ù„ Ú©Ù†ÛŒØ¯',0),(508251,14119,'pr','SMTP Ø±Ø§ ÙØ¹Ø§Ù„ Ú©Ù†ÛŒØ¯',0),(508252,14119,'tr','SMTP etkin',0),(508253,14119,'pl','SMTP wÅ‚Ä…czone',0),(508254,14119,'bg','SMTP Ð¿Ð¾Ð´Ð´Ñ€ÑŠÐ¶ÐºÐ°',0),(508255,14119,'ur','SMTP ÙØ¹Ø§Ù„',0),(508256,14119,'sr','Ð¡ÐœÐ¢ÐŸ Ð¾Ð¼Ð¾Ð³ÑƒÑ›ÐµÐ½',0),(508257,14119,'vi','SMTP Ä‘Æ°á»£c kÃ­ch hoáº¡t',0),(508258,14119,'af','SMTP geaktiveer',0),(508259,14119,'ro','SMTP activat',0),(508260,14119,'et','SMTP lubatud',0),(508261,14119,'si','SMTP, omogoÄeno',0),(508262,14119,'ba','SMTP diaktifkan',0),(508263,14119,'nl','SMTP ingeschakeld',0),(508264,14119,'fi','SMTP kÃ¤ytÃ¶ssÃ¤',0),(508265,14119,'no','SMTP aktivert',0),(508266,14119,'da','SMTP aktiveret',0),(508267,14119,'ko','SMTP ì‚¬ìš©',0),(508268,14119,'he','SMTP ×ž×•×¤×¢×œ×ª',0),(508269,14119,'el','SMTP ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î·',0),(508270,14119,'zh','å¯ç”¨ SMTP',0),(508271,14119,'sv','SMTP aktiveras',0),(508272,14119,'it','SMTP abilitato',0),(508273,14119,'tl','',0),(508274,14119,'th','à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™ SMTP',0),(508275,14119,'hi','SMTP à¤¸à¤•à¥à¤·à¤® à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(508276,14119,'ms','SMTP yang membolehkan',0),(508277,14119,'ar','SMTP ØªÙ…ÙƒÙŠÙ†',0),(508278,14119,'fr','SMTP activÃ©',0),(508279,14119,'jp','SMTP ãŒæœ‰åŠ¹ã«ãªã£ã¦ã„ã¾ã™ã€‚',0),(508280,14119,'pt','SMTP habilitado',0),(508281,14119,'ru','SMTP Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð°',0),(508282,14119,'es','SMTP habilitado',0),(508283,14119,'de','SMTP aktiviert',0),(508284,14119,'en','SMTP Enabled',0),(508285,14120,'is','',0),(508286,14120,'dr','SMTP Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø§Ø­Ø±Ø§Ø² Ù‡ÙˆÛŒØª',0),(508287,14120,'pr','SMTP Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø§Ø­Ø±Ø§Ø² Ù‡ÙˆÛŒØª',0),(508288,14120,'tr','SMTP kimlik doÄŸrulamasÄ± gerektiriyor',0),(508289,14120,'pl','SMTP wymaga uwierzytelniania',0),(508290,14120,'bg','SMTP Ð¸Ð·Ð¸ÑÐºÐ²Ð° ÑƒÐ´Ð¾ÑÑ‚Ð¾Ð²ÐµÑ€ÑÐ²Ð°Ð½Ðµ',0),(508291,14120,'ur','SMTP ØªØµØ¯ÛŒÙ‚ Ø¯Ø±Ú©Ø§Ø± ÛÙˆØªÛŒ ÛÛ’ Û”',0),(508292,14120,'sr','Ð¡ÐœÐ¢ÐŸ Ð·Ð°Ñ…Ñ‚Ð¸Ñ˜ÐµÐ²Ð° Ð¿Ñ€Ð¾Ð²Ñ˜ÐµÑ€Ñƒ Ð°ÑƒÑ‚ÐµÐ½Ñ‚Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸',0),(508293,14120,'vi','SMTP yÃªu cáº§u xÃ¡c thá»±c',0),(508294,14120,'af','SMTP vereis waarmerking',0),(508295,14120,'ro','SMTP necesitÄƒ autentificare',0),(508296,14120,'et','SMTP autentimist',0),(508297,14120,'si','SMTP zahteva preverjanje pristnosti',0),(508298,14120,'ba','SMTP memerlukan otentikasi',0),(508299,14120,'nl','SMTP vereist verificatie',0),(508300,14120,'fi','SMTP todennusta',0),(508301,14120,'no','SMTP krever godkjenning',0),(508302,14120,'da','SMTP krÃ¦ver godkendelse',0),(508303,14120,'ko','SMTP ì¸ì¦ í•„ìš”',0),(508304,14120,'he','SMTP ×“×•×¨×© ××™×ž×•×ª',0),(508305,14120,'el','SMTP Î±Ï€Î±Î¹Ï„ÎµÎ¯ Î­Î»ÎµÎ³Ï‡Î¿ Ï„Î±Ï…Ï„ÏŒÏ„Î·Ï„Î±Ï‚',0),(508306,14120,'zh','SMTP è¦æ±‚èº«ä»½éªŒè¯',0),(508307,14120,'sv','SMTP krÃ¤ver autentisering',0),(508308,14120,'it','SMTP richiede l\'autenticazione',0),(508309,14120,'tl','',0),(508310,14120,'th','SMTP à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸à¸²à¸£à¸£à¸±à¸šà¸£à¸­à¸‡à¸„à¸§à¸²à¸¡à¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(508311,14120,'hi','SMTP à¤ªà¥à¤°à¤®à¤¾à¤£à¤¨ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(508312,14120,'ms','SMTP memerlukan pengesahan',0),(508313,14120,'ar','SMTP ÙŠØªØ·Ù„Ø¨ Ù…ØµØ§Ø¯Ù‚Ø©',0),(508314,14120,'fr','SMTP requiert une authentification',0),(508315,14120,'jp','SMTP èªè¨¼ãŒå¿…è¦ã§ã™ã€‚',0),(508316,14120,'pt','SMTP requer autenticaÃ§Ã£o',0),(508317,14120,'ru','SMTP Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ Ð°ÑƒÑ‚ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(508318,14120,'es','SMTP requiere autenticaciÃ³n',0),(508319,14120,'de','SMTP erfordert Authentifizierung',0),(508320,14120,'en','SMTP Requires Authentication',0),(508321,14121,'is','',0),(508322,14121,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ¬ÙˆØ¯',0),(508323,14121,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ¬ÙˆØ¯',0),(508324,14121,'tr','KullanÄ±labilir miktar',0),(508325,14121,'pl','DostÄ™pna iloÅ›Ä‡',0),(508326,14121,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¸ ÐºÐ¾Ð»',0),(508327,14121,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ Ù‚ÛŒ',0),(508328,14121,'sr','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸ ÐšÐ¾Ð».',0),(508329,14121,'vi','Qty cÃ³ sáºµn',0),(508330,14121,'af','Beskikbaar Qty',0),(508331,14121,'ro','Cantit disponibilÄƒ',0),(508332,14121,'et','KÃ¤ttesaadav kogus',0),(508333,14121,'si','Na voljo kol',0),(508334,14121,'ba','Tersedia Qty',0),(508335,14121,'nl','Beschikbaar aantal',0),(508336,14121,'fi','Saatavilla mÃ¤Ã¤rÃ¤',0),(508337,14121,'no','Tilgjengelig antall',0),(508338,14121,'da','TilgÃ¦ngelige Qty',0),(508339,14121,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” ìˆ˜ëŸ‰',0),(508340,14121,'he','×›×ž×•×ª ×–×ž×™× ×”',0),(508341,14121,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(508342,14121,'zh','å¯ç”¨æ•°é‡',0),(508343,14121,'sv','TillgÃ¤nglig kvantitet',0),(508344,14121,'it','Q. tÃ  disponibile',0),(508345,14121,'tl','',0),(508346,14121,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸µà¹ˆà¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(508347,14121,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(508348,14121,'ms','Qty disediakan',0),(508349,14121,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(508350,14121,'fr','QtÃ© disponible',0),(508351,14121,'jp','åˆ©ç”¨å¯èƒ½ãªæ•°é‡',0),(508352,14121,'pt','Qty disponÃ­vel',0),(508353,14121,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ ÑˆÑ‚',0),(508354,14121,'es','Cantidad disponible',0),(508355,14121,'de','VerfÃ¼gbare Menge:',0),(508356,14121,'en','Available Qty',0),(508357,14122,'is','',0),(508358,14122,'dr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(508359,14122,'pr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(508360,14122,'tr','Emir seÃ§ilmedi',0),(508361,14122,'pl','ZamÃ³wienia nie zostaÅ‚y wybrane',0),(508362,14122,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(508363,14122,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(508364,14122,'sr','ÐÐ¸ÐºÐ°ÐºÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ° ÑÑƒ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸',0),(508365,14122,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n Ä‘áº·t hÃ ng Ä‘Ã£ Ä‘Æ°á»£c lá»±a chá»n',0),(508366,14122,'af','Geen bestellings gekies het',0),(508367,14122,'ro','Comenzi nu au fost selectate',0),(508368,14122,'et','Pole tellimusi valitud',0),(508369,14122,'si','Brez naroÄil, so bile izbrane',0),(508370,14122,'ba','Ada pesanan telah dipilih',0),(508371,14122,'nl','Geen Orders zijn geselecteerd',0),(508372,14122,'fi','Tilauksia ei ole valittu',0),(508373,14122,'no','Ingen bestillinger er valgt',0),(508374,14122,'da','Ingen ordrer er blevet udvalgt',0),(508375,14122,'ko','ì•„ë‹ˆ ì£¼ë¬¸ ì„ íƒ',0),(508376,14122,'he','×¤×§×•×“×•×ª × ×‘×—×¨×•',0),(508377,14122,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ Î­Ï‡Î¿Ï…Î½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯',0),(508378,14122,'zh','æ²¡æœ‰è®¢å•å·²é€‰å®š',0),(508379,14122,'sv','Inga order har valts',0),(508380,14122,'it','Nessun ordini sono stato selezionato',0),(508381,14122,'tl','',0),(508382,14122,'th','à¸ªà¸±à¹ˆà¸‡à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¹à¸¥à¹‰à¸§',0),(508383,14122,'hi','à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(508384,14122,'ms','Tiada perintah telah dipilih',0),(508385,14122,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø§Ø®ØªÙŠØ§Ø± Ù„Ø§ Ø£ÙˆØ§Ù…Ø±',0),(508386,14122,'fr','Aucuns commandes n\'ont Ã©tÃ© sÃ©lectionnÃ©s',0),(508387,14122,'jp','æ³¨æ–‡ãŒé¸æŠžã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(508388,14122,'pt','NÃ£o hÃ¡ ordens foram selecionados',0),(508389,14122,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð½Ðµ Ð±Ñ‹Ð»Ð¸ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ñ‹',0),(508390,14122,'es','No hay Ã³rdenes han sido seleccionados',0),(508391,14122,'de','Keine AuftrÃ¤ge wurden ausgewÃ¤hlt',0),(508392,14122,'en','No Orders Have Been Selected',0),(508393,14123,'is','',0),(508394,14123,'dr','Ú†Ø§Ù¾ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(508395,14123,'pr','Ú†Ø§Ù¾ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(508396,14123,'tr','SeÃ§ili yazdÄ±rma',0),(508397,14123,'pl','Drukuj wybrany',0),(508398,14123,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(508399,14123,'ur','Ú†Ú¾Ø§Ù¾ÛŒÚº Ù…Ù†ØªØ®Ø¨',0),(508400,14123,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ',0),(508401,14123,'vi','In chá»n',0),(508402,14123,'af','Druk gekies',0),(508403,14123,'ro','Imprimare selectat',0),(508404,14123,'et','Prindi valitud',0),(508405,14123,'si','Natisni izbrani',0),(508406,14123,'ba','Cetak yang dipilih',0),(508407,14123,'nl','Print geselecteerd',0),(508408,14123,'fi','Tulosta valitut',0),(508409,14123,'no','Skriv ut valgte',0),(508410,14123,'da','Udskriv valgt',0),(508411,14123,'ko','ì¸ì‡„ ì„ íƒ',0),(508412,14123,'he','×”×“×¤×¡×” ×©× ×‘×—×¨×•',0),(508413,14123,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯',0),(508414,14123,'zh','æ‰“å°é€‰å®š',0),(508415,14123,'sv','Skriv ut markerade',0),(508416,14123,'it','Stampa selezionata',0),(508417,14123,'tl','',0),(508418,14123,'th','à¸žà¸´à¸¡à¸žà¹Œà¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(508419,14123,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤®à¥à¤¦à¥à¤°à¤£',0),(508420,14123,'ms','Cetak yang dipilih',0),(508421,14123,'ar','Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(508422,14123,'fr','Impression sÃ©lectionnÃ©e',0),(508423,14123,'jp','é¸æŠžã—ãŸå°åˆ·',0),(508424,14123,'pt','Imprimir selecionado',0),(508425,14123,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ…',0),(508426,14123,'es','ImpresiÃ³n seleccionada',0),(508427,14123,'de','Drucken ausgewÃ¤hlt',0),(508428,14123,'en','Print Selected',0),(508429,14124,'is','',0),(508430,14124,'dr','Ú†Ø§Ù¾ Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§ÛŒÛŒØ¯',0),(508431,14124,'pr','Ú†Ø§Ù¾ Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§ÛŒÛŒØ¯',0),(508432,14124,'tr','SeÃ§ili onayÄ± YazdÄ±r',0),(508433,14124,'pl','Wydrukuj wybrane potwierdzenie',0),(508434,14124,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð°Ñ‚Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(508435,14124,'ur','Ù…Ù†ØªØ®Ø¨ ØªØµØ¯ÛŒÙ‚ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(508436,14124,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð°',0),(508437,14124,'vi','In chá»n xÃ¡c nháº­n',0),(508438,14124,'af','Druk die geselekteerde bevestiging',0),(508439,14124,'ro','Imprimare selectat confirmare',0),(508440,14124,'et','Prindi valitud kinnitus',0),(508441,14124,'si','Natisniti izbrano potrditev',0),(508442,14124,'ba','Mencetak konfirmasi dipilih',0),(508443,14124,'nl','Afdrukken van geselecteerde bevestiging',0),(508444,14124,'fi','Tulosta valittu vahvistus',0),(508445,14124,'no','Skrive ut merkede bekreftelse',0),(508446,14124,'da','Udskrive valgte bekrÃ¦ftelse',0),(508447,14124,'ko','ì¸ì‡„ ì„ íƒ í™•ì¸',0),(508448,14124,'he','×”×“×¤×¡ ××ª ××™×©×•×¨ ×©× ×‘×—×¨×•',0),(508449,14124,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï… ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·',0),(508450,14124,'zh','æ‰“å°é€‰å®šçš„ç¡®è®¤',0),(508451,14124,'sv','Skriva ut valda bekrÃ¤ftelse',0),(508452,14124,'it','Stampa selezionato conferma',0),(508453,14124,'tl','',0),(508454,14124,'th','à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸šà¸¢à¸·à¸™à¸¢à¸±à¸™à¸à¸²à¸£à¹€à¸¥à¸·à¸­à¸',0),(508455,14124,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(508456,14124,'ms','Cetak pengesahan terpilih',0),(508457,14124,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªØ£ÙƒÙŠØ¯ Ù…Ø®ØªØ§Ø±Ø©',0),(508458,14124,'fr','Imprimer la Confirmation sÃ©lectionnÃ©e',0),(508459,14124,'jp','é¸æŠžã•ã‚Œã¦ã„ã‚‹ç¢ºèªã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(508460,14124,'pt','Imprimir confirmaÃ§Ã£o selecionada',0),(508461,14124,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(508462,14124,'es','Imprimir confirmaciÃ³n seleccionado',0),(508463,14124,'de','Drucken ausgewÃ¤hlt BestÃ¤tigung',0),(508464,14124,'en','Print Selected Confirmation',0),(508465,14125,'is','',0),(508466,14125,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± ØµÙØ­Ù‡ Ø³Ø§Ø¨Ù‚Ù‡ Ù‚ÙŠÙ…Øª Ù‡Ù†Ú¯Ø§Ù… Ø³ÙØ§Ø±Ø´',0),(508467,14125,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± ØµÙØ­Ù‡ Ø³Ø§Ø¨Ù‚Ù‡ Ù‚ÙŠÙ…Øª Ù‡Ù†Ú¯Ø§Ù… Ø³ÙØ§Ø±Ø´',0),(508468,14125,'tr','Otomatik olarak ne zaman sipariÅŸ fiyat GeÃ§miÅŸ sayfasÄ±nÄ± gÃ¶ster',0),(508469,14125,'pl','Automatycznie PokaÅ¼ strony historii cena przy zamÃ³wieniu',0),(508470,14125,'bg','Ð¦ÐµÐ½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° ÑÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ñ‚ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¿Ñ€Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡Ð²Ð°Ð½Ðµ',0),(508471,14125,'ur','Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ Ù‚ÛŒÙ…Øª ØªØ§Ø±ÛŒØ® ØµÙØ­Û Ø¬Ø¨ ØªØ±ØªÛŒØ¨ Ú©Ø§Ø±ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(508472,14125,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ†ÐµÐ½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ ÐºÐ°Ð´Ð° Ð½Ð°Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐµ',0),(508473,14125,'vi','Tá»± Ä‘á»™ng hiá»ƒn thá»‹ trang lá»‹ch sá»­ giÃ¡ khi Ä‘áº·t hÃ ng',0),(508474,14125,'af','Wys outomaties prys geskiedenis bladsy wanneer bestel',0),(508475,14125,'ro','Automat AratÄƒ pagina de istorie preÅ£urilor la comanda',0),(508476,14125,'et','Automaatselt kuvada hinna ajaloo lehe tellimisel',0),(508477,14125,'si','Samodejno PrikaÅ¾i ceno Zgodovina strani pri naroÄanju',0),(508478,14125,'ba','Menampilkan laman Riwayat Harga secara otomatis ketika memesan',0),(508479,14125,'nl','Prijs geschiedenis pagina automatisch weergegeven wanneer u bestellen',0),(508480,14125,'fi','NÃ¤ytÃ¤ historia sivulle automaattisesti tilattaessa',0),(508481,14125,'no','Automatisk Vis historie siden ved bestilling',0),(508482,14125,'da','Automatisk vise pris historie side ved bestilling',0),(508483,14125,'ko','ì£¼ë¬¸ ì‹œ ê°€ê²© ì—­ì‚¬ íŽ˜ì´ì§€ë¥¼ ìžë™ìœ¼ë¡œ í‘œì‹œ',0),(508484,14125,'he','×”×¦×’×” ××•×˜×•×ž×˜×™×ª ×“×£ ×”×™×¡×˜×•×¨×™×” ×ž×—×™×¨ ×‘×”×–×ž× ×ª',0),(508485,14125,'el','Î•Î¼Ï†Î±Î½Î¯Î¶ÎµÎ¹ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î± Ï„Î· ÏƒÎµÎ»Î¯Î´Î± Î¹ÏƒÏ„Î¿ÏÎ¯Î± Ï„Î¹Î¼ÏŽÎ½ ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(508486,14125,'zh','åœ¨è®¢è´­æ—¶è‡ªåŠ¨æ˜¾ç¤ºçš„ä»·æ ¼åŽ†å²è®°å½•é¡µ',0),(508487,14125,'sv','Automatiskt Visa historia sida vid bestÃ¤llning',0),(508488,14125,'it','Automaticamente Visualizza pagina di cronologia del prezzo al momento dell\'ordine',0),(508489,14125,'tl','',0),(508490,14125,'th','à¹à¸ªà¸”à¸‡à¸«à¸™à¹‰à¸²à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸£à¸²à¸„à¸²à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¹€à¸¡à¸·à¹ˆà¸­à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(508491,14125,'hi','à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤œà¤¬ à¤†à¤¦à¥‡à¤¶ à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤ªà¥ƒà¤·à¥à¤  à¤¦à¤¿à¤–à¤¾à¤à¤',0),(508492,14125,'ms','Secara automatik muncul Laman sejarah harga apabila membuat pesanan',0),(508493,14125,'ar','Ø¥Ø¸Ù‡Ø§Ø± ØµÙØ­Ø© Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø³Ø¹Ø± ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¹Ù†Ø¯Ù…Ø§ ÙŠØ£Ù…Ø±',0),(508494,14125,'fr','Afficher automatiquement la Page historique des prix lors de la commande',0),(508495,14125,'jp','ã”æ³¨æ–‡ã®éš›ã«ä¾¡æ ¼å±¥æ­´ãƒšãƒ¼ã‚¸ãŒè‡ªå‹•çš„ã«è¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(508496,14125,'pt','Mostrar automaticamente a pÃ¡gina de histÃ³rico de preÃ§o quando encomendar',0),(508497,14125,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸ Ñ†ÐµÐ½ Ð¿Ñ€Ð¸ Ð·Ð°ÐºÐ°Ð·Ðµ',0),(508498,14125,'es','Mostrar precio historia pÃ¡gina automÃ¡ticamente al hacer el pedido',0),(508499,14125,'de','Zeigen Sie Preis Geschichte Seite automatisch an, bei der Bestellung',0),(508500,14125,'en','Automatically Show Price History Page When Ordering',0),(508501,14126,'is','',0),(508502,14126,'dr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø§ÛŒÙ…ÛŒÙ„ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ø­Ù…Ù„ Ø³Ø¨Ú©',0),(508503,14126,'pr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø§ÛŒÙ…ÛŒÙ„ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ø­Ù…Ù„ Ø³Ø¨Ú©',0),(508504,14126,'tr','Otomatik e-posta ne zaman sevk stili',0),(508505,14126,'pl','Auto E-mail gdy wysÅ‚ane styl',0),(508506,14126,'bg','ÐÐ²Ñ‚Ð¾ Ð¸Ð¼ÐµÐ¹Ð» Ð¿Ñ€Ð¸ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸ ÑÑ‚Ð¸Ð»',0),(508507,14126,'ur','Ø¢Ù¹Ùˆ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ø¬Ø¨ Ø§ÛŒ Ù…ÛŒÙ„ Ø·Ø±Ø²',0),(508508,14126,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ° Ðµ-Ð¿Ð¾ÑˆÑ‚Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸ ÑÑ‚Ð¸Ð»',0),(508509,14126,'vi','Tá»± Ä‘á»™ng Email khi váº­n chuyá»ƒn phong cÃ¡ch',0),(508510,14126,'af','Outomatiese e-pos wanneer Shipped styl',0),(508511,14126,'ro','Auto E-mail atunci cÃ¢nd expediate stil',0),(508512,14126,'et','Automaatne e-maili kui lÃ¤hetatud stiil',0),(508513,14126,'si','Avto Email Äas, slog',0),(508514,14126,'ba','Auto Email ketika dikirim gaya',0),(508515,14126,'nl','Automatische E-mail wanneer verzonden stijl',0),(508516,14126,'fi','Automaattinen sÃ¤hkÃ¶posti toimituksen tyyli',0),(508517,14126,'no','Automatisk e-post nÃ¥r levert stil',0),(508518,14126,'da','Automatisk E-mail nÃ¥r afsendt stil',0),(508519,14126,'ko','ìžë™ ì´ë©”ì¼ ë°œì†¡ ë•Œ ìŠ¤íƒ€ì¼',0),(508520,14126,'he','×“×•× ×œ ×›××©×¨ × ×©×œ×— ××•×˜×•×ž×˜×™×ª ×¡×’× ×•×Ÿ',0),(508521,14126,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ ÏŒÏ„Î±Î½ Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ ÏƒÏ„Ï…Î»',0),(508522,14126,'zh','è‡ªåŠ¨ç”µå­é‚®ä»¶å‘è´§æ—¶æ ·å¼',0),(508523,14126,'sv','Automatisk e-post nÃ¤r levereras stil',0),(508524,14126,'it','Auto Email quando spedito stile',0),(508525,14126,'tl','',0),(508526,14126,'th','à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¹€à¸¡à¸·à¹ˆà¸­à¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸£à¸¹à¸›à¹à¸šà¸š',0),(508527,14126,'hi','à¤‘à¤Ÿà¥‹ à¤œà¤¬ à¤œà¤¹à¤¾à¤œ à¤ˆà¤®à¥‡à¤² à¤¶à¥ˆà¤²à¥€',0),(508528,14126,'ms','Auto Email apabila dihantar gaya',0),(508529,14126,'ar','Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¹Ù†Ø¯Ù…Ø§ ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ù†Ù…Ø·',0),(508530,14126,'fr','Auto Email lors de l\'expÃ©dition Style',0),(508531,14126,'jp','å‡ºè·æ™‚ã«ãƒ¡ãƒ¼ãƒ«ã‚’è‡ªå‹•ã‚¹ã‚¿ã‚¤ãƒ«',0),(508532,14126,'pt','E-mail quando enviados de auto estilo',0),(508533,14126,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð¿Ñ€Ð¸ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐµ ÑÑ‚Ð¸Ð»ÑŒ',0),(508534,14126,'es','AutomÃ¡tico de correo electrÃ³nico cuando se envÃ­an estilo',0),(508535,14126,'de','Automatische Email bei Versand Stil',0),(508536,14126,'en','Auto Email When Shipped Style',0),(508537,14127,'is','',0),(508538,14127,'dr','Ù‚ÛŒÙ…Øª Ø­Ø¯Ø§Ú©Ø«Ø± Ø±Ú©ÙˆØ±Ø¯Ù‡Ø§ÛŒ ØªØ§Ø±ÛŒØ® Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(508539,14127,'pr','Ù‚ÛŒÙ…Øª Ø­Ø¯Ø§Ú©Ø«Ø± Ø±Ú©ÙˆØ±Ø¯Ù‡Ø§ÛŒ ØªØ§Ø±ÛŒØ® Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(508540,14127,'tr','Max fiyat geÃ§miÅŸ kayÄ±tlarÄ± gÃ¶stermek iÃ§in',0),(508541,14127,'pl','Cena Max rekordy historia PokaÅ¼',0),(508542,14127,'bg','ÐœÐ°ÐºÑ Ñ†ÐµÐ½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ',0),(508543,14127,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù‚ÛŒÙ…Øª Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ùˆ Ø´Ùˆ',0),(508544,14127,'sr','Ð¦ÐµÐ½Ð° Ð´Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ Ð·Ð°Ð¿Ð¸ÑÐ° Ð½Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ñƒ',0),(508545,14127,'vi','Max giÃ¡ lá»‹ch sá»­ Records Ä‘á»ƒ hiá»ƒn thá»‹',0),(508546,14127,'af','Max prys geskiedenis rekords om te wys',0),(508547,14127,'ro','Max Pret istoria Ã®nregistrÄƒrile AratÄƒ',0),(508548,14127,'et','Max hind arhiivi show',0),(508549,14127,'si','Cena Max zgodovina anali pokazati',0),(508550,14127,'ba','Max harga catatan sejarah menunjukkan',0),(508551,14127,'nl','Max prijs geschiedenis Records naar Show',0),(508552,14127,'fi','Max hinta historia tietueet NÃ¤ytÃ¤',0),(508553,14127,'no','Max historie poster til Show',0),(508554,14127,'da','Max pris historie poster til Show',0),(508555,14127,'ko','ìµœê³  ê°€ê²© ê¸°ë¡ ë ˆì½”ë“œ í‘œì‹œ',0),(508556,14127,'he','×ž×—×™×¨ ×ž×§×¡×™×ž×œ×™ ×”×™×¡×˜×•×¨×™×” ×¨×©×•×ž×•×ª ×œ×”×¦×’×”',0),(508557,14127,'el','Î‘ÏÏ‡ÎµÎ¯Î± Î¹ÏƒÏ„Î¿ÏÎ¯Î±Ï‚ Î¼Î­Î³Î¹ÏƒÏ„Î· Ï„Î¹Î¼Î® Î³Î¹Î± Ï„Î·Î½ ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ·',0),(508558,14127,'zh','æ˜¾ç¤ºçš„æœ€é«˜ä»·æ ¼åŽ†å²è®°å½•',0),(508559,14127,'sv','Max pris historikposter att Visa',0),(508560,14127,'it','Max prezzo record di storia da spettacolo',0),(508561,14127,'tl','',0),(508562,14127,'th','à¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸£à¸²à¸„à¸²à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¹ƒà¸™à¸à¸²à¸£à¹à¸ªà¸”à¸‡',0),(508563,14127,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤®à¥‚à¤²à¥à¤¯ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤¦à¤¿à¤–à¤¾à¤à¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(508564,14127,'ms','Rekod sejarah harga Max untuk Papar',0),(508565,14127,'ar','Ù…Ø§ÙƒØ³ Ø§Ù„Ø³Ø¹Ø± Ø³Ø¬Ù„Ø§Øª Ø§Ù„ØªØ§Ø±ÙŠØ® Ù„Ø¥Ø¸Ù‡Ø§Ø±',0),(508566,14127,'fr','Prix Max enregistrements d\'historique pour voir la',0),(508567,14127,'jp','æœ€å¤§ä¾¡æ ¼å±¥æ­´è¨˜éŒ²ã‚·ãƒ§ãƒ¼',0),(508568,14127,'pt','Max preÃ§o histÃ³ria registros para mostrar',0),(508569,14127,'ru','ÐœÐ°ÐºÑ Ñ†ÐµÐ½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ ÑˆÐ¾Ñƒ',0),(508570,14127,'es','Precio mÃ¡ximo historia registros para mostrar',0),(508571,14127,'de','Max Preis Geschichte DatensÃ¤tze anzeigen',0),(508572,14127,'en','Max Price History Records To Show',0),(508573,14128,'is','',0),(508574,14128,'dr','Ú©ÙˆÚ†Ú©',0),(508575,14128,'pr','Ú©ÙˆÚ†Ú©',0),(508576,14128,'tr','KÃ¼Ã§Ã¼k',0),(508577,14128,'pl','MaÅ‚e',0),(508578,14128,'bg','ÐœÐ°Ð»ÐºÐ¸',0),(508579,14128,'ur','Ú†Ú¾ÙˆÙ¹Ø§',0),(508580,14128,'sr','ÐœÐ°Ð»Ð¸',0),(508581,14128,'vi','Nhá»',0),(508582,14128,'af','Klein',0),(508583,14128,'ro','Mici',0),(508584,14128,'et','VÃ¤ike',0),(508585,14128,'si','Mala',0),(508586,14128,'ba','Kecil',0),(508587,14128,'nl','Kleine',0),(508588,14128,'fi','Pieni',0),(508589,14128,'no','Liten',0),(508590,14128,'da','Lille',0),(508591,14128,'ko','ìž‘ì€',0),(508592,14128,'he','×§×˜×Ÿ',0),(508593,14128,'el','ÎœÎ¹ÎºÏÏŒ',0),(508594,14128,'zh','å°',0),(508595,14128,'sv','SmÃ¥',0),(508596,14128,'it','Piccolo',0),(508597,14128,'tl','',0),(508598,14128,'th','à¸‚à¸™à¸²à¸”à¹€à¸¥à¹‡à¸',0),(508599,14128,'hi','à¤›à¥‹à¤Ÿà¤¾ à¤¸à¤¾',0),(508600,14128,'ms','Kecil',0),(508601,14128,'ar','Ø§Ù„ØµØºÙŠØ±Ø©',0),(508602,14128,'fr','Petit',0),(508603,14128,'jp','å°ã•ãª',0),(508604,14128,'pt','Pequeno',0),(508605,14128,'ru','ÐœÐ°Ð»ÐµÐ½ÑŒÐºÐ¸Ð¹',0),(508606,14128,'es','PequeÃ±o',0),(508607,14128,'de','Kleine',0),(508608,14128,'en','Small',0),(508609,14129,'is','',0),(508610,14129,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¬Ø¹Ø¨Ù‡ Ø­Ø³Ø§Ø¨ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³ Ø¯Ø± Ú©Ø´ØªÛŒ Ø¨Ù‡ ÙˆÛŒØ±Ø§ÛŒØ´',0),(508611,14129,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¬Ø¹Ø¨Ù‡ Ø­Ø³Ø§Ø¨ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³ Ø¯Ø± Ú©Ø´ØªÛŒ Ø¨Ù‡ ÙˆÛŒØ±Ø§ÛŒØ´',0),(508612,14129,'tr','GÃ¶nderilecek UPS Hesap kutularÄ±nÄ± dÃ¼zenlemek gÃ¶ster',0),(508613,14129,'pl','PokaÅ¼ okna konta UPS na statek, aby edytowaÄ‡',0),(508614,14129,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑˆÐ¾ÑƒÑ‚Ð¾ UPS Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð²ÑŠÑ€Ñ…Ñƒ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(508615,14129,'ur','UPS Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø®Ø§Ù†ÙˆÚº Ù¾Ø± Ø¬ÛØ§Ø² Ú©Ùˆ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(508616,14129,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð£ÐŸÐ¡ Ñ€Ð°Ñ‡ÑƒÐ½ ÐºÑƒÑ‚Ð¸Ñ˜Ðµ Ð½Ð° Ð¿Ñ€Ð¸Ð¼Ð°Ð¾Ñ†Ð°',0),(508617,14129,'vi','Hiá»ƒn thá»‹ tÃ i khoáº£n UPS há»™p trÃªn tÃ u Ä‘á»ƒ chá»‰nh sá»­a',0),(508618,14129,'af','Wys UPS rekening boksies op die skip-om te redigeer',0),(508619,14129,'ro','Cutii de cont UPS AratÄƒ navei pentru a edita',0),(508620,14129,'et','Kuva UPS konto vÃ¤ljad saaja redigeerimine',0),(508621,14129,'si','PokaÅ¾i UPS raÄun Å¡katle na ladjo za urejanje',0),(508622,14129,'ba','Tampilkan UPS Account kotak di kapal-untuk mengedit',0),(508623,14129,'nl','Toon UPS-klantennummer vakken op verzendadres bewerken',0),(508624,14129,'fi','NÃ¤ytÃ¤ UPS-asiakasnumero laatikoiden toimitusosoitteen muokkaaminen',0),(508625,14129,'no','Vis UPS-konto bokser pÃ¥ lever til-redigere',0),(508626,14129,'da','Vis UPS konto bokse pÃ¥ skibet for at redigere',0),(508627,14129,'ko','ë°°ì†¡ì— UPS ê³„ì • ìƒìž íŽ¸ì§‘ í‘œì‹œ',0),(508628,14129,'he','×”×¦×’ ×ª×™×‘×•×ª ×—×©×‘×•×Ÿ UPS ×¢×œ ×œ×ž×©×œ×•×— ×œ×¢×¨×•×š',0),(508629,14129,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ UPS ÎºÎ¿Ï…Ï„Î¹Î¬ Î³Î¹Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏƒÎµ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(508630,14129,'zh','æ˜¾ç¤ºçš„ UPS å¸æˆ·æ¡† Ship To ç¼–è¾‘',0),(508631,14129,'sv','Visa UPS-konto lÃ¥dor pÃ¥ leveransadressen redigera',0),(508632,14129,'it','Visualizza Account UPS caselle di spedire a modificare',0),(508633,14129,'tl','',0),(508634,14129,'th','à¹à¸ªà¸”à¸‡à¸šà¸±à¸à¸Šà¸µ UPS à¸à¸¥à¹ˆà¸­à¸‡à¸šà¸™à¸›à¸¥à¸²à¸¢à¸—à¸²à¸‡à¹à¸à¹‰à¹„à¸‚',0),(508635,14129,'hi','à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤ªà¤° à¤‰à¤¤à¤¾à¤° à¤–à¤¾à¤¤à¤¾ à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤',0),(508636,14129,'ms','Menunjukkan akaun up kotak atas kapal untuk Edit',0),(508637,14129,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø®Ø§Ù†Ø§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ UPS Ø¹Ù„Ù‰ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù„ØªØ­Ø±ÙŠØ±',0),(508638,14129,'fr','Voir l\'Ã©tablissement compte UPS boÃ®tes sur le navire-Ã  modifier',0),(508639,14129,'jp','å‡ºè·å…ˆã® UPS ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ ãƒœãƒƒã‚¯ã‚¹ã®ç·¨é›†ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(508640,14129,'pt','Mostrar caixas de conta UPS de navio para editar',0),(508641,14129,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚ UPS ÐºÐ¾Ñ€Ð¾Ð±ÐºÐ¸ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(508642,14129,'es','Mostrar cuenta UPS cajas en barco-para editar',0),(508643,14129,'de','Karte UPS Kundennummer Felder auf Lieferadresse bearbeiten',0),(508644,14129,'en','Show UPS Account Boxes On Ship-To Edit',0),(508645,14130,'is','',0),(508646,14130,'dr','IRS 1099 Ù…ØªÙØ±Ù‚Ù‡ Ø¨Ù‡ ÙØ§ÛŒÙ„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(508647,14130,'pr','IRS 1099 Ù…ØªÙØ±Ù‚Ù‡ Ø¨Ù‡ ÙØ§ÛŒÙ„ Ø§Ù„Ú©ØªØ±ÙˆÙ†ÛŒÚ©ÛŒ',0),(508648,14130,'tr','IRS 1099-Ã§eÅŸitli elektronik dosya',0),(508649,14130,'pl','Plik IRS 1099-MISC elektronicznie',0),(508650,14130,'bg','Ð¤Ð°Ð¹Ð» IRS 1099-Ð¿Ñ€ÐµÑ‚ÑŠÑ€Ð¿ÑÐ²Ð°Ð¼ Ð¿Ð¾ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÐµÐ½ Ð¿ÑŠÑ‚',0),(508651,14130,'ur','Ø§ 1099 Ù…ØªÙØ±Ù‚ Ø§Ù„ÛŒÚ©Ù¹Ø±Ø§Ù†Ú© ÙØ§Ø¦Ù„',0),(508652,14130,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð˜Ð Ð¡ 1099 ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð°-ÐœÐ˜Ð¡Ð¦ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½ÑÐºÐ¸Ð¼ Ð¿ÑƒÑ‚ÐµÐ¼',0),(508653,14130,'vi','KÃ­ch IRS 1099 â€“ MISC Ä‘iá»‡n tá»­',0),(508654,14130,'af','LÃªer IRS 1099-MISC elektronies',0),(508655,14130,'ro','FiÅŸier IRS 1099-MISC format electronic',0),(508656,14130,'et','Elektrooniliselt esitada IRS-ile 1099-VARIA',0),(508657,14130,'si','Elektronsko datoteko IRS 1099-Razno',0),(508658,14130,'ba','Berkas elektronik IRS 1099-MISC',0),(508659,14130,'nl','IRS 1099-MISC elektronisch bestand',0),(508660,14130,'fi','Tiedoston IRS 1099-MISC sÃ¤hkÃ¶isesti',0),(508661,14130,'no','Filen IRS 1099-MISC elektronisk',0),(508662,14130,'da','Fil IRS 1099-MISC elektronisk',0),(508663,14130,'ko','êµ­ì„¸ì²­ 1099-ê¸°íƒ€ ì „ìžì  íŒŒì¼',0),(508664,14130,'he','×§×•×‘×¥ ×ž×¡ ×”×›× ×¡×” 1099-MISC ××œ×§×˜×¨×•× ×™×ª',0),(508665,14130,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ IRS 1099-MISC Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¬',0),(508666,14130,'zh','ç”µå­æ–‡ä»¶å›½ç¨Žå±€ 1099-MISC',0),(508667,14130,'sv','Fil IRS 1099-MISC elektroniskt',0),(508668,14130,'it','File elettronicamente IRS 1099-MISC',0),(508669,14130,'tl','',0),(508670,14130,'th','à¸¢à¸·à¹ˆà¸™ IRS 1099-à¹€à¸šà¹‡à¸”à¹€à¸•à¸¥à¹‡à¸”à¸—à¸²à¸‡à¸­à¸´à¹€à¸¥à¹‡à¸à¸—à¸£à¸­à¸™à¸´à¸à¸ªà¹Œ',0),(508671,14130,'hi','à¤†à¤ˆà¤†à¤°à¤à¤¸ 1099-à¤µà¤¿à¤µà¤¿à¤§ à¤‡à¤²à¥‡à¤•à¥à¤Ÿà¥à¤°à¥‰à¤¨à¤¿à¤• à¤«à¤¼à¤¾à¤‡à¤²',0),(508672,14130,'ms','Fail IRS 1099-MISC secara elektronik',0),(508673,14130,'ar','Ù…Ù„Ù IRS 1099-Ù…ØªÙØ±Ù‚Ø§Øª Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠØ§',0),(508674,14130,'fr','Produire par voie Ã©lectronique les IRS 1099-MISC',0),(508675,14130,'jp','IRS 1099-MISC ã‚’é›»å­çš„ã«ãƒ•ã‚¡ã‚¤ãƒ«ã—ã¾ã™ã€‚',0),(508676,14130,'pt','Arquivo IRS 1099-MISC eletronicamente',0),(508677,14130,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¼ Ð²Ð¸Ð´Ðµ Ñ„Ð°Ð¹Ð»Ð° IRS 1099-Ð Ð°Ð·Ð½Ð¾Ðµ',0),(508678,14130,'es','File del IRS 1099-MISC electrÃ³nicamente',0),(508679,14130,'de','Datei IRS 1099-MISC elektronisch',0),(508680,14130,'en','File IRS 1099-MISC Electronically',0),(508681,14131,'is','',0),(508682,14131,'dr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ÙˆØ²Ù†',0),(508683,14131,'pr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ÙˆØ²Ù†',0),(508684,14131,'tr','AÄŸÄ±rlÄ±k gÃ¶ster',0),(508685,14131,'pl','PokaÅ¼ wagi',0),(508686,14131,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ñ‚ÐµÐ³Ð»Ð¾',0),(508687,14131,'ur','ÙˆØ²Ù† Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(508688,14131,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ‚ÐµÐ¶Ð¸Ð½Ð°',0),(508689,14131,'vi','Trá»ng lÆ°á»£ng hiá»ƒn thá»‹',0),(508690,14131,'af','Gewig wys',0),(508691,14131,'ro','AratÄƒ greutatea',0),(508692,14131,'et','NÃ¤ita kaal',0),(508693,14131,'si','Prikaz teÅ¾e',0),(508694,14131,'ba','Menunjukkan berat',0),(508695,14131,'nl','Toon gewicht',0),(508696,14131,'fi','NÃ¤ytÃ¤ paino',0),(508697,14131,'no','Vis vekt',0),(508698,14131,'da','Vis vÃ¦gt',0),(508699,14131,'ko','ì¤‘ëŸ‰ í‘œì‹œ',0),(508700,14131,'he','×”×¦×’ ×ž×©×§×œ',0),(508701,14131,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î²Î¬ÏÎ¿Ï‚',0),(508702,14131,'zh','æ˜¾ç¤ºé‡é‡',0),(508703,14131,'sv','Visa vikt',0),(508704,14131,'it','Visualizza peso',0),(508705,14131,'tl','',0),(508706,14131,'th','à¹à¸ªà¸”à¸‡à¸™à¹‰à¸³à¸«à¸™à¸±à¸',0),(508707,14131,'hi','à¤µà¤œà¤¨ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(508708,14131,'ms','Menunjukkan berat',0),(508709,14131,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙˆØ²Ù†',0),(508710,14131,'fr','Voir la poids',0),(508711,14131,'jp','é‡é‡ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(508712,14131,'pt','Show de peso',0),(508713,14131,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð²ÐµÑ',0),(508714,14131,'es','Peso',0),(508715,14131,'de','Karte-Gewicht',0),(508716,14131,'en','Show Weight',0),(508717,14132,'is','',0),(508718,14132,'dr','ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Unbilled 3dcart Ø¨Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø§Ø±Ø³Ø§Ù„',0),(508719,14132,'pr','ØªÙ…Ø§Ù… Ø³ÙØ§Ø±Ø´Ø§Øª Unbilled 3dcart Ø¨Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø§Ø±Ø³Ø§Ù„',0),(508720,14132,'tr','TÃ¼m faturalandÄ±rÄ±lmamÄ±ÅŸ 3dcart sipariÅŸleri faturalama iÃ§in GÃ¶nder',0),(508721,14132,'pl','WyÅ›lij wszystkie zamÃ³wienia 3dcart nieopÅ‚aconych do fakturowania',0),(508722,14132,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Unbilled 3dcart Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(508723,14132,'ur','ÛŒÙˆÙ†Ø¨Ø§Ù„Ù„ 3dcart Ú©Û’ ØªÙ…Ø§Ù… Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯ Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬',0),(508724,14132,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ ÑÐ²Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° Ð£Ð½Ð±Ð¸Ð»Ð»ÐµÐ´ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(508725,14132,'vi','Gá»­i táº¥t cáº£ Unbilled 3dcart lá»‡nh Ä‘á»ƒ láº­p hÃ³a Ä‘Æ¡n',0),(508726,14132,'af','Stuur alle Unbilled 3dcart bestellings fakturering',0),(508727,14132,'ro','Trimite toate Unbilled 3dcart comenzile pentru facturare',0),(508728,14132,'et','Saada kÃµik arveldamata 3dcart tellimused arveldamine',0),(508729,14132,'si','PoÅ¡lji vse Unbilled 3dcart nalogi, fakturiranje',0),(508730,14132,'ba','Mengirimkan semua pesanan tertagih 3dcart ke faktur',0),(508731,14132,'nl','Alle ongefactureerde 3dcart Orders verzenden facturering',0),(508732,14132,'fi','LÃ¤hettÃ¤Ã¤ kaikki Unbilled 3dcart tilaukset laskutukseen',0),(508733,14132,'no','Send alle fakturert 3dcart ordrer til fakturering',0),(508734,14132,'da','Send alle faktureret 3dcart ordrer til fakturering',0),(508735,14132,'ko','ëª¨ë“  ë° 3dcart ì£¼ë¬¸ ì¸ë³´ì´ìŠ¤ ë³´ë‚´ê¸°',0),(508736,14132,'he','×œ×©×œ×•×— ××ª ×›×œ ×”×”×–×ž× ×•×ª Unbilled 3dcart ×œ×”×¤×§×ª ×—×©×‘×•× ×™×ª',0),(508737,14132,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Î±Î½ÎµÎ¯ÏƒÏ€ÏÎ±ÎºÏ„Î· 3dcart ÏƒÏ„Î·Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(508738,14132,'zh','é€ç»™æ‰€æœ‰çš„æœªå‘å•çš„ 3dcart è®¢å•å¼€ç¥¨',0),(508739,14132,'sv','Skicka alla relaterade 3dcart order till fakturering',0),(508740,14132,'it','Inviare tutte le attivitÃ  non ancora fatturate 3dcart ordini alla fatturazione',0),(508741,14132,'tl','',0),(508742,14132,'th','à¸ªà¹ˆà¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸¥à¸” 3dcart à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¹€à¸žà¸·à¹ˆà¸­à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(508743,14132,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ Unbilled 3dcart à¤†à¤¦à¥‡à¤¶ à¤­à¥‡à¤œà¥‡à¤‚',0),(508744,14132,'ms','Menghantar semua lepas 3dcart pesanan kepada invois',0),(508745,14132,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¬Ù…ÙŠØ¹ 3dcart ØºÙŠØ± ÙÙˆØ§ØªÙŠØ± Ø£ÙˆØ§Ù…Ø± Ù„Ù„ÙÙˆØªØ±Ø©',0),(508746,14132,'fr','Transmettre tous les ordres de 3dcart non facturÃ©s Ã  la facturation',0),(508747,14132,'jp','è«‹æ±‚æ›¸ç™ºè¡Œã‚’æœªæ”¯æ‰• 3dcart ã®ã™ã¹ã¦ã®æ³¨æ–‡ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(508748,14132,'pt','Enviar todas as encomendas da 3dcart nÃ£o faturadas para facturaÃ§Ã£o',0),(508749,14132,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð½ÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… 3dcart Ð´Ð»Ñ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(508750,14132,'es','Enviar todos los pedidos facturados 3dcart a facturaciÃ³n',0),(508751,14132,'de','Liefern Sie alle noch nicht fakturierte 3dcart fÃ¼r die Rechnungsstellung',0),(508752,14132,'en','Send All Unbilled 3dcart Orders To Invoicing',0),(508753,14133,'is','',0),(508754,14133,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¨Ø³ØªÙ‡',0),(508755,14133,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¨Ø³ØªÙ‡',0),(508756,14133,'tr','Paket ekleme',0),(508757,14133,'pl','DodaÄ‡ pakiet',0),(508758,14133,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð°ÐºÐµÑ‚',0),(508759,14133,'ur','Ù¾ÛŒÚ©ÛŒØ¬ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(508760,14133,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð°ÐºÐµÑ‚Ð°',0),(508761,14133,'vi','ThÃªm gÃ³i',0),(508762,14133,'af','Voeg pakket',0),(508763,14133,'ro','Adauga pachetul',0),(508764,14133,'et','Paketi lisamine',0),(508765,14133,'si','Dodajanje paketa',0),(508766,14133,'ba','Tambahkan paket',0),(508767,14133,'nl','Pakket toevoegen',0),(508768,14133,'fi','LisÃ¤Ã¤ Paketti',0),(508769,14133,'no','Legg til pakke',0),(508770,14133,'da','TilfÃ¸j pakke',0),(508771,14133,'ko','íŒ¨í‚¤ì§€ ì¶”ê°€',0),(508772,14133,'he','×œ×”×•×¡×™×£ ×—×‘×™×œ×”',0),(508773,14133,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï€Î±ÎºÎ­Ï„Î¿',0),(508774,14133,'zh','æ·»åŠ è½¯ä»¶åŒ…',0),(508775,14133,'sv','LÃ¤gga till paketet',0),(508776,14133,'it','Aggiungere il pacchetto',0),(508777,14133,'tl','',0),(508778,14133,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹à¸žà¸„à¹€à¸à¸ˆ',0),(508779,14133,'hi','à¤ªà¥ˆà¤•à¥‡à¤œ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(508780,14133,'ms','Tambah pakej',0),(508781,14133,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø²Ù…Ø©',0),(508782,14133,'fr','Ajouter Package',0),(508783,14133,'jp','ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(508784,14133,'pt','Adicionar pacote',0),(508785,14133,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð°ÐºÐµÑ‚',0),(508786,14133,'es','Agregar Paquete',0),(508787,14133,'de','Paket hinzufÃ¼gen',0),(508788,14133,'en','Add Package',0),(508789,14134,'is','',0),(508790,14134,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³',0),(508791,14134,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³',0),(508792,14134,'tr','UPS Hesap numarasÄ±',0),(508793,14134,'pl','Numer klienta UPS',0),(508794,14134,'bg','UPS Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(508795,14134,'ur','UPS Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø±',0),(508796,14134,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð£ÐŸÐ¡-Ð°',0),(508797,14134,'vi','Sá»‘ tÃ i khoáº£n UPS',0),(508798,14134,'af','Onderbrekinglose Kragtoevoer rekeningnommer',0),(508799,14134,'ro','NumÄƒrul de cont UPS',0),(508800,14134,'et','UPS kontonumber',0),(508801,14134,'si','Å tevilka raÄuna UPS',0),(508802,14134,'ba','Nomor rekening UPS',0),(508803,14134,'nl','UPS rekeningnummer',0),(508804,14134,'fi','UPS tilinumero',0),(508805,14134,'no','UPS kontonummeret',0),(508806,14134,'da','UPS kontonummer',0),(508807,14134,'ko','UPS ê³„ì • ë²ˆí˜¸',0),(508808,14134,'he','×ž×¡×¤×¨ ×—×©×‘×•×Ÿ UPS',0),(508809,14134,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï UPS',0),(508810,14134,'zh','UPS å¸å·',0),(508811,14134,'sv','UPS kontonummer',0),(508812,14134,'it','Numero di conto UPS',0),(508813,14134,'tl','',0),(508814,14134,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µ UPS',0),(508815,14134,'hi','UPS à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(508816,14134,'ms','Nombor akaun up',0),(508817,14134,'ar','ÙŠÙˆ Ø¨ÙŠ Ø¥Ø³ Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(508818,14134,'fr','NumÃ©ro de compte UPS',0),(508819,14134,'jp','UPS å£åº§ç•ªå·',0),(508820,14134,'pt','NÃºmero de conta UPS',0),(508821,14134,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° UPS',0),(508822,14134,'es','NÃºmero de cuenta de UPS',0),(508823,14134,'de','UPS-Kontonummer',0),(508824,14134,'en','UPS Account Number',0),(508825,14135,'is','',0),(508826,14135,'dr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³',0),(508827,14135,'pr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³',0),(508828,14135,'tr','UPS Hesap tÃ¼rÃ¼',0),(508829,14135,'pl','Typ konta UPS',0),(508830,14135,'bg','Ð¢Ð¸Ð¿ UPS Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(508831,14135,'ur','UPS Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(508832,14135,'sr','Ð¢Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³Ð° Ð£ÐŸÐ¡-Ð°',0),(508833,14135,'vi','Loáº¡i tÃ i khoáº£n UPS',0),(508834,14135,'af','Onderbrekinglose Kragtoevoer rekeningtipe',0),(508835,14135,'ro','Tip de cont UPS',0),(508836,14135,'et','UPS kontotÃ¼Ã¼p',0),(508837,14135,'si','Vrsta konta UPS',0),(508838,14135,'ba','Jenis UPS Account',0),(508839,14135,'nl','UPS-klantennummer Type',0),(508840,14135,'fi','UPS tilityyppi',0),(508841,14135,'no','UPS-kontotype',0),(508842,14135,'da','UPS kontotype',0),(508843,14135,'ko','UPS ê³„ì • ìœ í˜•',0),(508844,14135,'he','×¡×•×’ ×—×©×‘×•×Ÿ UPS',0),(508845,14135,'el','Î¤ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï UPS',0),(508846,14135,'zh','UPS å¸æˆ·ç±»åž‹',0),(508847,14135,'sv','UPS-konto typ',0),(508848,14135,'it','Tipo di Account UPS',0),(508849,14135,'tl','',0),(508850,14135,'th','à¸Šà¸™à¸´à¸”à¸šà¸±à¸à¸Šà¸µ UPS',0),(508851,14135,'hi','UPS à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(508852,14135,'ms','Jenis akaun up',0),(508853,14135,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨ UPS',0),(508854,14135,'fr','Type de compte UPS',0),(508855,14135,'jp','UPS ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ç¨®é¡ž',0),(508856,14135,'pt','Tipo de conta UPS',0),(508857,14135,'ru','Ð¢Ð¸Ð¿ ÑÑ‡ÐµÑ‚Ð° UPS',0),(508858,14135,'es','Tipo de cuenta de UPS',0),(508859,14135,'de','UPS Kontotyp',0),(508860,14135,'en','UPS Account Type',0),(508861,14136,'is','',0),(508862,14136,'dr','1099s',0),(508863,14136,'pr','1099s',0),(508864,14136,'tr','1099s',0),(508865,14136,'pl','1099s',0),(508866,14136,'bg','1099s',0),(508867,14136,'ur','1099s',0),(508868,14136,'sr','1099Ñ',0),(508869,14136,'vi','1099s',0),(508870,14136,'af','1099s',0),(508871,14136,'ro','1099s',0),(508872,14136,'et','1099s',0),(508873,14136,'si','1099s',0),(508874,14136,'ba','1099s',0),(508875,14136,'nl','1099s',0),(508876,14136,'fi','valmisteveroja (1099)',0),(508877,14136,'no','1099s',0),(508878,14136,'da','1099S',0),(508879,14136,'ko','1099s',0),(508880,14136,'he','1099s',0),(508881,14136,'el','1099s',0),(508882,14136,'zh','1099s',0),(508883,14136,'sv','1099-rapportering',0),(508884,14136,'it','1099s',0),(508885,14136,'tl','',0),(508886,14136,'th','1099s',0),(508887,14136,'hi','1099s',0),(508888,14136,'ms','1099s',0),(508889,14136,'ar','1099s',0),(508890,14136,'fr','1099 s',0),(508891,14136,'jp','1099s',0),(508892,14136,'pt','1099s',0),(508893,14136,'ru','1099s',0),(508894,14136,'es','1099s',0),(508895,14136,'de','Fortgeschrittene',0),(508896,14136,'en','1099s',0),(508897,14137,'is','',0),(508898,14137,'dr','Consignee ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(508899,14137,'pr','Consignee ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(508900,14137,'tr','Fatura alÄ±cÄ±',0),(508901,14137,'pl','Odbiorcy rozliczani',0),(508902,14137,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»Ñ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸',0),(508903,14137,'ur','Ø¨Ø§Ù„Ù„Ø§Ø¯ Ú©ÙˆÙ†Ø³Ú¯Ù†ÛŒ',0),(508904,14137,'sr','Ð¦Ð¾Ð½ÑÐ¸Ð³Ð½ÐµÐµ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½',0),(508905,14137,'vi','NgÆ°á»i láº­p hoÃ¡ Ä‘Æ¡n',0),(508906,14137,'af','Geadresseerde weerspieÃ«l',0),(508907,14137,'ro','Destinatarul facturat',0),(508908,14137,'et','Arve saaja',0),(508909,14137,'si','Prejemnik zaraÄunali',0),(508910,14137,'ba','Consignee ditagih',0),(508911,14137,'nl','Geadresseerde gefactureerd',0),(508912,14137,'fi','Vastaanottajan laskutetaan',0),(508913,14137,'no','Mottaker fakturert',0),(508914,14137,'da','Modtageren faktureret',0),(508915,14137,'ko','ìˆ˜ì·¨ì¸ ì²­êµ¬',0),(508916,14137,'he','×‘×•×•×™×˜×‘×™ ×”×—×™×•×‘',0),(508917,14137,'el','Î Î±ÏÎ±Î»Î®Ï€Ï„Î· Ï€Î¿Ï… Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹',0),(508918,14137,'zh','æ”¶è´§è®°å¸',0),(508919,14137,'sv','Mottagaren faktureras',0),(508920,14137,'it','Destinatario fatturato',0),(508921,14137,'tl','',0),(508922,14137,'th','Consignee à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(508923,14137,'hi','à¤ªà¤°à¥‡à¤·à¤¿à¤¤à¥€ à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾',0),(508924,14137,'ms','Perisian yang dibilkan',0),(508925,14137,'ar','Ø§Ù„Ù…Ø±Ø³Ù„ Ø¥Ù„ÙŠÙ‡ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(508926,14137,'fr','Destinataire facturÃ©',0),(508927,14137,'jp','è·å—äººè«‹æ±‚',0),(508928,14137,'pt','DestinatÃ¡rio de bico',0),(508929,14137,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»Ñ',0),(508930,14137,'es','Consignatario facturado',0),(508931,14137,'de','EmpfÃ¤nger in Rechnung gestellt',0),(508932,14137,'en','Consignee Billed',0),(508933,14138,'is','',0),(508934,14138,'dr','Ø´Ø±Ú©Øª Ú©Ø´ØªÛŒØ±Ø§Ù†ÛŒ',0),(508935,14138,'pr','Ø´Ø±Ú©Øª Ú©Ø´ØªÛŒØ±Ø§Ù†ÛŒ',0),(508936,14138,'tr','Nakliyeci',0),(508937,14138,'pl','Nadawcy',0),(508938,14138,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ñ‡Ð°',0),(508939,14138,'ur','Ø²ÛŒØ±ÙÙ‚ÛŒØ§Ø¯Øª',0),(508940,14138,'sr','Ð¨Ð¿ÐµÐ´Ð¸Ñ‚ÐµÑ€Ð°',0),(508941,14138,'vi','NgÆ°á»i gá»­i',0),(508942,14138,'af','Shipper',0),(508943,14138,'ro','Expeditor',0),(508944,14138,'et','Saatja',0),(508945,14138,'si','PoÅ¡iljatelj',0),(508946,14138,'ba','Pengirim',0),(508947,14138,'nl','Verzender',0),(508948,14138,'fi','LÃ¤hettÃ¤jÃ¤',0),(508949,14138,'no','Avsender',0),(508950,14138,'da','Afsender',0),(508951,14138,'ko','í™”ì£¼',0),(508952,14138,'he','×”×©×•×œ×—',0),(508953,14138,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î­Î±',0),(508954,14138,'zh','æ‰˜è¿äºº',0),(508955,14138,'sv','AvsÃ¤ndaren',0),(508956,14138,'it','Spedizioniere',0),(508957,14138,'tl','',0),(508958,14138,'th','à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(508959,14138,'hi','Shipper',0),(508960,14138,'ms','Pengirim',0),(508961,14138,'ar','Ø§Ù„Ø´Ø§Ø­Ù†',0),(508962,14138,'fr','ExpÃ©diteur',0),(508963,14138,'jp','è·é€äºº',0),(508964,14138,'pt','Expedidor',0),(508965,14138,'ru','Ð“Ñ€ÑƒÐ·Ð¾Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÐµÐ»ÑŒ',0),(508966,14138,'es','Embarcador',0),(508967,14138,'de','Absender',0),(508968,14138,'en','Shipper',0),(508969,14139,'is','',0),(508970,14139,'dr','Ø´Ø®Øµ Ø«Ø§Ù„Ø«',0),(508971,14139,'pr','Ø´Ø®Øµ Ø«Ø§Ù„Ø«',0),(508972,14139,'tr','ÃœÃ§Ã¼ncÃ¼ taraf',0),(508973,14139,'pl','Trzeciej',0),(508974,14139,'bg','Ð¢Ñ€ÐµÑ‚Ð¾ Ð»Ð¸Ñ†Ðµ',0),(508975,14139,'ur','ØªÛŒØ³Ø±ÛŒ Ù¾Ø§Ø±Ù¹ÛŒ',0),(508976,14139,'sr','Ð¢Ñ€ÐµÑ›Ð° ÑÑ‚Ñ€Ð°Ð½Ð°',0),(508977,14139,'vi','BÃªn thá»© ba',0),(508978,14139,'af','Derde Party',0),(508979,14139,'ro','TerÅ£e pÄƒrÅ£i',0),(508980,14139,'et','Kolmanda isiku',0),(508981,14139,'si','Tretja oseba',0),(508982,14139,'ba','Pihak ketiga',0),(508983,14139,'nl','Derde partij',0),(508984,14139,'fi','Kolmannen osapuolen',0),(508985,14139,'no','Tredjepart',0),(508986,14139,'da','Tredjepart',0),(508987,14139,'ko','ì œ 3 ìž',0),(508988,14139,'he','×¦×“ ×©×œ×™×©×™',0),(508989,14139,'el','Î¤ÏÎ¯Ï„Î¿ Î¼Î­ÏÎ¿Ï‚',0),(508990,14139,'zh','ç¬¬ä¸‰æ–¹',0),(508991,14139,'sv','Tredje part',0),(508992,14139,'it','Terze parti',0),(508993,14139,'tl','',0),(508994,14139,'th','à¸šà¸¸à¸„à¸„à¸¥à¸—à¸µà¹ˆà¸ªà¸²à¸¡',0),(508995,14139,'hi','à¤¤à¥ƒà¤¤à¥€à¤¯ à¤ªà¤•à¥à¤·',0),(508996,14139,'ms','Pihak ketiga',0),(508997,14139,'ar','Ø§Ù„Ø·Ø±Ù Ø§Ù„Ø«Ø§Ù„Ø«',0),(508998,14139,'fr','Tierce partie',0),(508999,14139,'jp','ã‚µãƒ¼ãƒ‰ ãƒ‘ãƒ¼ãƒ†ã‚£',0),(509000,14139,'pt','Terceira parte',0),(509001,14139,'ru','Ð¢Ñ€ÐµÑ‚ÑŒÑ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ð°',0),(509002,14139,'es','Tercero',0),(509003,14139,'de','Dritter',0),(509004,14139,'en','Third Party',0),(509005,14140,'is','',0),(509006,14140,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¯Ø± Ø®Ù„Ø§ØµÙ‡ Ø§ÛŒ Ø§Ø² ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ &amp; Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙØ±ÙˆØ´ ØªØ§Ø±ÛŒØ® Ú¯Ø²Ø§Ø±Ø´ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù†Ù…ÛŒ',0),(509007,14140,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¯Ø± Ø®Ù„Ø§ØµÙ‡ Ø§ÛŒ Ø§Ø² ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ &amp; Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙØ±ÙˆØ´ ØªØ§Ø±ÛŒØ® Ú¯Ø²Ø§Ø±Ø´ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù†Ù…ÛŒ',0),(509008,14140,'tr','Maliyet faturalar & stok SatÄ±ÅŸ GeÃ§miÅŸi raporu Ã–zeti gÃ¶rÃ¼ntÃ¼leyemiyorsunuz',0),(509009,14140,'pl','Nie moÅ¼na wyÅ›wietliÄ‡ koszty na Podsumowanie faktury & raporty historia sprzedaÅ¼y zapasÃ³w',0),(509010,14140,'bg','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð½Ð° Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ & ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸ Ð·Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(509011,14140,'ur','Ù„Ø§Ú¯Øª Ù¾Ø± ÙˆØ¨Ø¬Ù„ÛŒ & Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø³ÛŒÙ„Ø² ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø®Ø¨Ø±ÙˆÚº Ú©Ø§ Ø®Ù„Ø§ØµÛ Ù†Ø¸Ø± Ù†ÛÛŒÚº Ø¢Ø¦Û’ Ú¯Ø§',0),(509012,14140,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð¶ÐµÐ¼ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ð½Ð° Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ & Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ',0),(509013,14140,'vi','KhÃ´ng thá»ƒ xem chi phÃ­ trÃªn báº£n tÃ³m táº¯t cá»§a hoÃ¡ Ä‘Æ¡n &amp; hÃ ng tá»“n kho bÃ¡n hÃ ng lá»‹ch sá»­ bÃ¡o cÃ¡o',0),(509014,14140,'af','Koste kan bekyk op opsomming van fakture en voorraad verkope geskiedenis verslae',0),(509015,14140,'ro','Nu pot vizualiza Cost pe rezumat al facturilor & inventarul istoric vÃ¢nzÄƒri rapoarte',0),(509016,14140,'et','Ei saa vaadata kulu arvete & varude mÃ¼Ã¼giajaloo aruande KokkuvÃµte',0),(509017,14140,'si','Ne morete ogledati stroÅ¡kov na Povzetek raÄunov & zaloge Zgodovina prodaje poroÄila',0),(509018,14140,'ba','Tidak dapat melihat biaya pada ringkasan tagihan & persediaan sejarah penjualan laporan',0),(509019,14140,'nl','Kosten weergeven op samenvatting van facturen & Verkoophistorie voorraadrapporten niet',0),(509020,14140,'fi','Voi tarkastella kustannusten Yhteenveto laskujen & Myyntihistoria raportteja',0),(509021,14140,'no','Kan ikke vise kostnadene pÃ¥ oppsummering av fakturaer & Salgshistorikk Beholdningsrapporter',0),(509022,14140,'da','Kan ikke se prisen pÃ¥ ResumÃ© af fakturaer & lagerrapporter salgshistorik',0),(509023,14140,'ko','ì†¡ìž¥ & ìž¬ê³  íŒë§¤ ë‚´ì—­ ë³´ê³ ì„œì˜ ìš”ì•½ì— ë¹„ìš©ì„ ë³¼ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(509024,14140,'he','××™×Ÿ ×‘××¤×©×¨×•×ª×š ×œ×”×¦×™×’ ××ª ×”×¢×œ×•×ª ×¢×œ ×¡×™×›×•× ×©×œ ×—×©×‘×•× ×™×•×ª & ×“×•×—×•×ª ×”×™×¡×˜×•×¨×™×™×ª ×ž×›×™×¨×•×ª ×ž×œ××™',0),(509025,14140,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Ï€ÏÎ¿Î²Î¬Î»Ï‰ ÎºÏŒÏƒÏ„Î¿Ï‚ ÏƒÏ„Î·Î½ Ï€ÎµÏÎ¯Î»Î·ÏˆÎ· Ï„Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½ & ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î¹ÏƒÏ„Î¿ÏÎ¯Î± Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(509026,14140,'zh','æ— æ³•æŸ¥çœ‹æˆæœ¬ä¸Šçš„å‘ç¥¨ &amp; åº“å­˜é”€å”®åŽ†å²è®°å½•æŠ¥å‘Šæ‘˜è¦',0),(509027,14140,'sv','Kan inte Visa kostnad pÃ¥ Sammanfattning av fakturor & FÃ¶rsÃ¤ljningshistorik inventarierapporter',0),(509028,14140,'it','Non Ã¨ possibile visualizzare il costo su riepilogo delle fatture & report cronologia delle vendite scorte',0),(509029,14140,'tl','',0),(509030,14140,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸”à¸¹à¸•à¹‰à¸™à¸—à¸¸à¸™à¸šà¸™à¸ªà¸£à¸¸à¸›à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ & à¸£à¸²à¸¢à¸‡à¸²à¸™à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸à¸²à¸£à¸‚à¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(509031,14140,'hi','à¤²à¤¾à¤—à¤¤ à¤ªà¤° à¤šà¤¾à¤²à¤¾à¤¨ & à¤¸à¥‚à¤šà¥€ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤•à¥‡ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(509032,14140,'ms','Tidak dapat melihat kos ringkasan invois & laporan-laporan sejarah jualan inventori',0),(509033,14140,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¹Ø±Ø¶ Ø§Ù„ØªÙƒÙ„ÙØ© ÙÙŠ Ù…Ù„Ø®Øµ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø¢Ù†Ø¯ ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„Ø¬Ø±Ø¯ ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(509034,14140,'fr','Impossible d\'afficher coÃ»t sur RÃ©sumÃ© des factures & rapports d\'inventaire historique des ventes',0),(509035,14140,'jp','ã‚³ã‚¹ãƒˆè«‹æ±‚æ›¸ & åœ¨åº«è²©å£²å±¥æ­´ãƒ¬ãƒãƒ¼ãƒˆã®è¦ç´„ã‚’è¡¨ç¤ºã§ãã¾ã›ã‚“ã€‚',0),(509036,14140,'pt','NÃ£o pode ver os custos no Resumo de facturas & relatÃ³rios de inventÃ¡rio de histÃ³rico de vendas',0),(509037,14140,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€ & Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¾Ð² Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(509038,14140,'es','Puede ver el costo de Resumen de facturas &amp; informes de ventas de la historia del inventario',0),(509039,14140,'de','Kosten nicht auf Zusammenfassung der Rechnungen & Vertriebshistorie Inventurberichte angezeigt werden.',0),(509040,14140,'en','Cannot View Cost On Summary Of Invoices & Inventory Sales History Reports',0),(509041,14141,'is','',0),(509042,14141,'dr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ø¬Ø¹Ø¨Ù‡ Ø¨Ù‡ Ø§ØªÙ‡Ø§Ù… Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø§Ú¯Ø± Ú¯ÛŒØ±Ù†Ø¯Ù‡ Ø´Ø®Øµ Ø«Ø§Ù„Ø« Ùˆ ÛŒØ§ Consignee Ø§Ù†ØªØ®Ø§Ø¨ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³',0),(509043,14141,'pr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ø¬Ø¹Ø¨Ù‡ Ø¨Ù‡ Ø§ØªÙ‡Ø§Ù… Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø§Ú¯Ø± Ú¯ÛŒØ±Ù†Ø¯Ù‡ Ø´Ø®Øµ Ø«Ø§Ù„Ø« Ùˆ ÛŒØ§ Consignee Ø§Ù†ØªØ®Ø§Ø¨ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³',0),(509044,14141,'tr','AlÄ±cÄ±, Ã¼Ã§Ã¼ncÃ¼ taraf veya alÄ±cÄ± seÃ§ilmiÅŸ nakliye giderleri kutularÄ±nÄ± gizle UPS',0),(509045,14141,'pl','Ukryj WysyÅ‚ka za pola, jeÅ›li UPS odbiornik, strony trzeciej lub wybranego odbiorcy',0),(509046,14141,'bg','Ð¡ÐºÑ€Ð¸Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ñ‚Ð°ÐºÑÐ° ÐºÑƒÑ‚Ð¸Ð¸, Ð°ÐºÐ¾ UPS Ð¿Ñ€Ð¸ÐµÐ¼Ð½Ð¸Ðº, Ñ‚Ñ€ÐµÑ‚Ð° ÑÑ‚Ñ€Ð°Ð½Ð° Ð¸Ð»Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»Ñ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(509047,14141,'ur','Ø§Ú¯Ø± Ú†Ø§Ø±Ø¬ Ø®Ø§Ù†ÙˆÚº Ø´Ù¾Ù†Ú¯ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº Ø±Ø³ÛŒÙˆØ±ØŒ ØªÛŒØ³Ø±ÛŒ Ù¾Ø§Ø±Ù¹ÛŒ ÛŒØ§ Ú©ÙˆÙ†Ø³Ú¯Ù†ÛŒ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ UPS',0),(509048,14141,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð¿ÑƒÑšÐµÑšÐµ ÐºÑƒÑ‚Ð¸Ñ˜Ðµ ÑƒÐºÐ¾Ð»Ð¸ÐºÐ¾ ÐÐ¿Ñ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ðº, Ñ‚Ñ€ÐµÑ›Ðµ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð¸Ð»Ð¸ Ð¦Ð¾Ð½ÑÐ¸Ð³Ð½ÐµÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸',0),(509049,14141,'vi','áº¨n váº­n chuyá»ƒn phÃ­ há»™p náº¿u up nháº­n, bÃªn thá»© ba hoáº·c ngÆ°á»i Ä‘Æ°á»£c lá»±a chá»n',0),(509050,14141,'af','Versteek las bokse gestuur as UPS ontvanger, derdeparty of geadresseerde gekies',0),(509051,14141,'ro','Ascunde casetele de taxa de expediere dacÄƒ UPS receptor, terÅ£e pÄƒrÅ£i, sau destinatarul ales',0),(509052,14141,'et','Peida laevandus tasu karbid, kui UPS vastuvÃµtja, kolmanda isiku vÃµi kaubasaaja valitud',0),(509053,14141,'si','Skrij ladijskega prometa stroÅ¡ek Å¡katle, Äe UPS sprejemnik, tretje stranke ali prejemnika izbere',0),(509054,14141,'ba','Sembunyikan kotak biaya pengiriman jika UPS Receiver, pihak ketiga, atau Consignee dipilih',0),(509055,14141,'nl','Verbergen verzendkosten gratis vakken als UPS ontvanger, derden of geadresseerde gekozen',0),(509056,14141,'fi','Piilota ilmaiseksi lÃ¤hetyslaatikoita jos UPS vastaanotin, kolmannen osapuolen tai vastaanottajan valittu',0),(509057,14141,'no','Skjul frakt kostnader boksene Hvis UPS mottaker eller tredjepart mottaker valgt',0),(509058,14141,'da','Skjul Shipping gebyr kasser Hvis UPS Receiver, tredjemand eller modtageren valgt',0),(509059,14141,'ko','ìˆ¨ê¸°ê¸° ê²½ìš° ì¶©ì „ ë°•ìŠ¤ ë°°ì†¡ ì—… ìˆ˜ì‹ ê¸°, ì œ 3 ìž ë˜ëŠ” ìˆ˜ì·¨ì¸ ì„ íƒ',0),(509060,14141,'he','×”×¡×ª×¨ ×ž×©×œ×•×— ×ª×©×œ×•× ×ª×™×‘×•×ª ×× ×§×•×¤×¦×™× ×ž×§×œ×˜, ×¦×“ ×©×œ×™×©×™ ××• × ×‘×—×¨×™× ×‘×•×•×™×˜×‘×™',0),(509061,14141,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î½Î±Ï…Ï„Î¹Î»Î¯Î± Ï‡ÏÎ­Ï‰ÏƒÎ· ÎºÎ¿Ï…Ï„Î¹Î¬ Î±Î½ UPS Î´Î­ÎºÏ„Î·, Ï„ÏÎ¯Ï„Î¿ Î¼Î­ÏÎ¿Ï‚, Î® Ï€Î±ÏÎ±Î»Î®Ï€Ï„Î· ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯',0),(509062,14141,'zh','éšè—èˆªè¿æ”¶è´¹ç®±ï¼Œå¦‚æžœ UPS æŽ¥æ”¶æœºã€ ç¬¬ä¸‰æ–¹æˆ–æ”¶è´§äººé€‰æ‹©',0),(509063,14141,'sv','DÃ¶lj frakt avgift lÃ¥dor om UPS mottagare, tredje part eller mottagaren valt',0),(509064,14141,'it','Nascondi carica scatole di spedizione se UPS ricevitore, terze parti o destinatario scelto',0),(509065,14141,'tl','',0),(509066,14141,'th','à¸‹à¹ˆà¸­à¸™à¸à¸¥à¹ˆà¸­à¸‡à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸–à¹‰à¸² UPS à¸•à¸±à¸§à¸£à¸±à¸šà¸ªà¸±à¸à¸à¸²à¸“ à¸šà¸¸à¸„à¸„à¸¥ à¸«à¸£à¸·à¸­à¹€à¸¥à¸·à¸­à¸ Consignee',0),(509067,14141,'hi','à¤¯à¤¦à¤¿ à¤†à¤°à¥‹à¤ª à¤¬à¤•à¥à¤¸à¥‡ à¤¨à¥Œà¤µà¤¹à¤¨ à¤›à¥à¤ªà¤¾à¤à¤ à¤‰à¤¤à¤¾à¤° à¤•à¥‡ à¤°à¤¿à¤¸à¥€à¤µà¤°, à¤¤à¥ƒà¤¤à¥€à¤¯ à¤ªà¤•à¥à¤·, à¤¯à¤¾ à¤ªà¤°à¥‡à¤·à¤¿à¤¤à¥€ à¤šà¥à¤¨à¤¾',0),(509068,14141,'ms','Sembunyi penghantaran kotak caj jika UPS penerima, pihak ketiga atau perisian yang dipilih',0),(509069,14141,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø´Ø­Ù† Ø®Ø§Ù†Ø§Øª Ø§Ù„ØªÙ‡Ù…Ø© Ø¥Ø°Ø§ Ø´ÙƒØ§ Ø§Ù„Ù…ØªÙ„Ù‚ÙŠ Ø£Ùˆ Ø·Ø±Ù Ø«Ø§Ù„Ø«ØŒ Ø£Ùˆ Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù…Ø±Ø³Ù„ Ø¥Ù„ÙŠÙ‡',0),(509070,14141,'fr','Masquer boÃ®tes de frais d\'expÃ©dition si UPS rÃ©cepteur, tiers ou destinataire choisi',0),(509071,14141,'jp','éžè¡¨ç¤ºã®å ´åˆã¯æ–™é‡‘ç®±ã‚’å‡ºè· UPS ãƒ¬ã‚·ãƒ¼ãƒãƒ¼ã€ç¬¬ä¸‰è€…ã¾ãŸã¯è·å—äººã®é¸ã°ã‚Œã¾ã—ãŸã€‚',0),(509072,14141,'pt','Ocultar enviar caixas de carga se levanta receptor, terceiros ou destinatÃ¡rio escolhido',0),(509073,14141,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÐºÐ¾Ñ€Ð¾Ð±ÐºÐ¸ Ð·Ð°Ñ€ÑÐ´, ÐµÑÐ»Ð¸ Ð˜Ð‘ÐŸ Ð¿Ñ€Ð¸ÐµÐ¼Ð½Ð¸ÐºÐ°, Ñ‚Ñ€ÐµÑ‚ÑŒÐµÐ¹ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹ Ð¸Ð»Ð¸ Ð³Ñ€ÑƒÐ·Ð¾Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ñ‚ÐµÐ»Ñ Ð²Ñ‹Ð±Ñ€Ð°Ð»Ð¸',0),(509074,14141,'es','Ocultar las cajas de carga de envÃ­o si UPS receptor, terceras personas o destinatario elegido',0),(509075,14141,'de','Ausblenden, die Lieferung kostenlos-Boxen, wenn UPS, Receiver, Dritter oder EmpfÃ¤nger ausgewÃ¤hlt',0),(509076,14141,'en','Hide Shipping Charge Boxes If UPS Receiver, Third Party, or Consignee Chosen',0),(509077,14142,'is','',0),(509078,14142,'dr','Ø´Ø±Ø§ÛŒØ· ØªØ®ÙÛŒÙ Ù…Ø¨Ù„Øº Ø¯Ø± Ù…Ø¬Ù…ÙˆØ¹ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(509079,14142,'pr','Ø´Ø±Ø§ÛŒØ· ØªØ®ÙÛŒÙ Ù…Ø¨Ù„Øº Ø¯Ø± Ù…Ø¬Ù…ÙˆØ¹ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(509080,14142,'tr','Åžartlar iskonto tutarÄ± toplam gÃ¶ster',0),(509081,14142,'pl','PokaÅ¼, Å¼e warunki rabatu kwota w sum',0),(509082,14142,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ° ÑÑƒÐ¼Ð° Ð² ÑÑƒÐ¼Ð¸Ñ‚Ðµ',0),(509083,14142,'ur','Ù…ÛŒØ²Ø§Ù† Ù…ÛŒÚº Ø±Ù‚Ù… Ø´Ø±Ø§Ø¦Ø· ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(509084,14142,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑƒÑÐ»Ð¾Ð²Ðµ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð° Ð¸Ð·Ð½Ð¾Ñ Ñƒ Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(509085,14142,'vi','Hiá»ƒn thá»‹ Ä‘iá»u khoáº£n giáº£m sá»‘ tiá»n trong tá»•ng sá»‘',0),(509086,14142,'af','Wys terme afslag bedrag In totale',0),(509087,14142,'ro','AratÄƒ termeni Discount suma Ã®n totaluri',0),(509088,14142,'et','Kuva tingimuste allahindlussumma kokku',0),(509089,14142,'si','PrikaÅ¾i pogoje popusta znesek v vsotah',0),(509090,14142,'ba','Menunjukkan istilah DISKON TERBAIK untuk jumlah total',0),(509091,14142,'nl','Toon termen korting bedrag In totalen',0),(509092,14142,'fi','NÃ¤ytÃ¤ ehdot alennussumma yhteensÃ¤',0),(509093,14142,'no','Vis vilkÃ¥r rabattbelÃ¸p i totaler',0),(509094,14142,'da','Vis vilkÃ¥r rabatbelÃ¸b i totaler',0),(509095,14142,'ko','ê¸°ê°„ í• ì¸ ê¸ˆì•¡ í•©ê³„ í‘œì‹œ',0),(509096,14142,'he','×”×¦×’ ×¡×›×•× ×‘×¡×™×›×•×ž×™× ×”× ×—×ª ×ª× ××™',0),(509097,14142,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏŒÏÏ‰Î½ Î­ÎºÏ€Ï„Ï‰ÏƒÎ· Ï€Î¿ÏƒÏŒ ÏƒÏ„Î± ÏƒÏÎ½Î¿Î»Î±',0),(509098,14142,'zh','æ˜¾ç¤ºæ¡æ¬¾æŠ˜æ‰£é‡‘é¢æ€»è®¡',0),(509099,14142,'sv','Visa villkor rabattbelopp i summor',0),(509100,14142,'it','Visualizza termini sconto quantitÃ  nei totali',0),(509101,14142,'tl','',0),(509102,14142,'th','à¹à¸ªà¸”à¸‡à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚à¸¥à¸”à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸œà¸¥à¸£à¸§à¸¡',0),(509103,14142,'hi','à¤¨à¤¿à¤¯à¤® à¤›à¥‚à¤Ÿ à¤°à¤¾à¤¶à¤¿ à¤¯à¥‹à¤—à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(509104,14142,'ms','Menunjukkan terma diskaun amaun dalam jumlah',0),(509105,14142,'ar','ØªØ¸Ù‡Ø± Ø´Ø±ÙˆØ· Ø®ØµÙ… Ø§Ù„Ù…Ø¨Ù„Øº ÙÙŠ Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹',0),(509106,14142,'fr','Afficher les termes montant dans les totaux de remise',0),(509107,14142,'jp','ç”¨èªžå‰²å¼•é¡ã®åˆè¨ˆã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(509108,14142,'pt','Mostrar termos desconto de quantidade em totais',0),(509109,14142,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑƒÑÐ»Ð¾Ð²Ð¸Ñ ÑÐºÐ¸Ð´ÐºÐ¸ ÑÑƒÐ¼Ð¼Ð° Ð¸Ñ‚Ð¾Ð³Ð¾Ð²',0),(509110,14142,'es','Mostrar tÃ©rminos descuento cantidad en los totales',0),(509111,14142,'de','Zeigen Sie, dass Begriffe Betrag In Summen Rabatt',0),(509112,14142,'en','Show Terms Discount Amount In Totals',0),(509113,14143,'is','',0),(509114,14143,'dr','Ø´Ø±Ø§ÛŒØ· ØªØ®ÙÛŒÙ',0),(509115,14143,'pr','Ø´Ø±Ø§ÛŒØ· ØªØ®ÙÛŒÙ',0),(509116,14143,'tr','Åžartlar indirim',0),(509117,14143,'pl','Warunki rabatu',0),(509118,14143,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(509119,14143,'ur','Ø´Ø±Ø§Ø¦Ø· Ú©ÛŒ Ø±Ø¹Ø§ÛŒØª',0),(509120,14143,'sr','Ð£ÑÐ»Ð¾Ð²Ðµ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(509121,14143,'vi','Äiá»u khoáº£n giáº£m giÃ¡',0),(509122,14143,'af','Terme afslag',0),(509123,14143,'ro','Reducere de termeni',0),(509124,14143,'et','MÃµttes soodushinnaga',0),(509125,14143,'si','Pogoje popusta',0),(509126,14143,'ba','Istilah DISKON',0),(509127,14143,'nl','Voorwaarden korting',0),(509128,14143,'fi','Ehdot alennus',0),(509129,14143,'no','VilkÃ¥rene rabatt',0),(509130,14143,'da','VilkÃ¥r rabat',0),(509131,14143,'ko','ê¸°ê°„ í• ì¸',0),(509132,14143,'he','×ª× ××™ ×”× ×—×”',0),(509133,14143,'el','ÎŒÏÎ¿Ï…Ï‚ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(509134,14143,'zh','æ¡æ¬¾æŠ˜æ‰£',0),(509135,14143,'sv','Villkor rabatt',0),(509136,14143,'it','Termini di sconto',0),(509137,14143,'tl','',0),(509138,14143,'th','à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚à¸ªà¹ˆà¸§à¸™à¸¥à¸”',0),(509139,14143,'hi','à¤¶à¤°à¥à¤¤à¥‹à¤‚ à¤•à¥‡ à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ',0),(509140,14143,'ms','Syarat diskaun',0),(509141,14143,'ar','Ø´Ø±ÙˆØ· Ø§Ù„Ø®ØµÙ…',0),(509142,14143,'fr','Escomptes',0),(509143,14143,'jp','ç”¨èªžã®å‰²å¼•',0),(509144,14143,'pt','Desconto termos',0),(509145,14143,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ ÑÐºÐ¸Ð´ÐºÐ¸',0),(509146,14143,'es','Descuento de tÃ©rminos',0),(509147,14143,'de','Begriffe-Rabatt',0),(509148,14143,'en','Terms Discount',0),(509149,14144,'is','',0),(509150,14144,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÛŒØ´ ÙØ±Ø¶ Ú©Ù¾ÛŒ Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÛŒ Ø±Ø³ÛŒØ¯',0),(509151,14144,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÛŒØ´ ÙØ±Ø¶ Ú©Ù¾ÛŒ Ø¨Ø³ØªÙ‡ Ø¨Ù†Ø¯ÛŒ Ø±Ø³ÛŒØ¯',0),(509152,14144,'tr','VarsayÄ±lan paketleme koÃ§anÄ± kopya sayÄ±sÄ±',0),(509153,14144,'pl','DomyÅ›lny numer opakowania dostawy kopii',0),(509154,14144,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð±Ñ€Ð¾ÑÑ‚ Ð½Ð° Ð¾Ð¿Ð°ÐºÐ¾Ð²Ð°Ð½Ðµ Ð¿Ñ€Ð¸Ð¿Ð»ÑŠÐ·Ð²Ð°Ð½Ðµ ÐºÐ¾Ð¿Ð¸Ñ',0),(509155,14144,'ur','Ø·Û’ Ø´Ø¯Û ØªØ¹Ø¯Ø§Ø¯ Ù¾ÛŒÚ©Ù†Ú¯ Ù¾Ø±Ú†ÛŒ Ù†Ù‚ÙˆÙ„',0),(509156,14144,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜ ÐºÐ¾Ð¿Ð¸Ñ˜Ð° Ð¿Ð°ÐºÐ¾Ð²Ð°ÑšÐµ Ð¡Ð»Ð¸Ð¿',0),(509157,14144,'vi','Sá»‘ lÆ°á»£ng bao bÃ¬ phiáº¿u báº£n máº·c Ä‘á»‹nh',0),(509158,14144,'af','Verstek aantal pak strokie afskrifte',0),(509159,14144,'ro','Implicit numÄƒrul de ambalare alunecare copii',0),(509160,14144,'et','Vaikimisi pakkimine kviitungikoopiate arv',0),(509161,14144,'si','Privzeto Å¡tevilo kopij Slip pakiranje',0),(509162,14144,'ba','Nomor default salinan Slip pengepakan',0),(509163,14144,'nl','Default Number Of verpakking Slip kopieÃ«n',0),(509164,14144,'fi','OletusmÃ¤Ã¤rÃ¤ pakkausluettelon kopiot',0),(509165,14144,'no','Standardantall pakking talongkopier',0),(509166,14144,'da','Standardantallet af pakning Slip kopier',0),(509167,14144,'ko','íŒ¨í‚¹ ìŠ¬ë¦½ ì‚¬ë³¸ì˜ ê¸°ë³¸ ìˆ˜',0),(509168,14144,'he','×ž×¡×¤×¨ ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×ª×¢×•×“×ª ×ž×©×œ×•×— ×¢×•×ª×§×™×',0),(509169,14144,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Î±Î½Ï„Î¹Î³ÏÎ¬Ï†Ï‰Î½ Î¿Î»Î¯ÏƒÎ¸Î·ÏƒÎ·Ï‚ ÏƒÏ…ÏƒÎºÎµÏ…Î±ÏƒÎ¯Î±Ï‚',0),(509170,14144,'zh','è£…ç®±å•å‰¯æœ¬çš„é»˜è®¤æ•°ç›®',0),(509171,14144,'sv','Standardantalet packning talonger',0),(509172,14144,'it','Numero predefinito di imballaggio Slip copie',0),(509173,14144,'tl','',0),(509174,14144,'th','à¸ˆà¸³à¸™à¸§à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸šà¸±à¸™à¸—à¸¶à¸à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸³à¹€à¸™à¸²',0),(509175,14144,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤ªà¥ˆà¤•à¤¿à¤‚à¤— à¤ªà¤°à¥à¤šà¥€ à¤ªà¥à¤°à¤¤à¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(509176,14144,'ms','Nombor lalai salinan Slip pembungkusan',0),(509177,14144,'ar','Ø§Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù…Ù† Ù†Ø³Ø® ÙƒØ´Ù Ø§Ù„ØªØ¹Ø¨Ø¦Ø©',0),(509178,14144,'fr','Nombre de Copies de bordereau d\'emballage par dÃ©faut',0),(509179,14144,'jp','æ¢±åŒ…æ˜Žç´°ã®ã‚³ãƒ”ãƒ¼ã®æ—¢å®šã®ç•ªå·',0),(509180,14144,'pt','NÃºmero padrÃ£o de cÃ³pias de deslizamento de embalagem',0),(509181,14144,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑƒÐ¿Ð°ÐºÐ¾Ð²ÐºÐ¸ ÑÐºÐ¾Ð»ÑŒÐ¶ÐµÐ½Ð¸Ñ ÐºÐ¾Ð¿Ð¸Ð¹',0),(509182,14144,'es','NÃºmero predeterminado de copias de resbalÃ³n de embalaje',0),(509183,14144,'de','Standardanzahl von Packing Slip Kopien',0),(509184,14144,'en','Default Number Of Packing Slip Copies',0),(509185,14145,'is','',0),(509186,14145,'dr','Ù…Ø¯ÛŒÚ©Ø± Ø¯Ø±ØµØ¯ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(509187,14145,'pr','Ù…Ø¯ÛŒÚ©Ø± Ø¯Ø±ØµØ¯ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(509188,14145,'tr','Medicare yÃ¼zde Ã§alÄ±ÅŸan',0),(509189,14145,'pl','Medicare procent pracownika',0),(509190,14145,'bg','Medicare Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(509191,14145,'ur','Ù…ÛŒÚˆÛŒ ÙÛŒ ØµØ¯ Ù…Ù„Ø§Ø²Ù…',0),(509192,14145,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(509193,14145,'vi','Medicare pháº§n trÄƒm nhÃ¢n viÃªn',0),(509194,14145,'af','Medicare persent werknemer',0),(509195,14145,'ro','Medicare angajat la sutÄƒ',0),(509196,14145,'et','Medicare protsenti tÃ¶Ã¶taja',0),(509197,14145,'si','Medicare odstotkov zaposlenih',0),(509198,14145,'ba','Medicare persen karyawan',0),(509199,14145,'nl','Medicare percentage werknemer',0),(509200,14145,'fi','Medicare prosenttia tyÃ¶ntekijÃ¤n',0),(509201,14145,'no','Medicare prosent ansatt',0),(509202,14145,'da','Medicare procent medarbejder',0),(509203,14145,'ko','ë©”ë””ì¼€ì–´ % ì§ì›',0),(509204,14145,'he','×”×¢×•×‘×“ ××—×•×– ×ž×“×™×§×¨',0),(509205,14145,'el','Medicare Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(509206,14145,'zh','åŒ»ç–—ä¿é™© %å‘˜å·¥',0),(509207,14145,'sv','Medicare procent anstÃ¤lld',0),(509208,14145,'it','Medicare percentuale dipendente',0),(509209,14145,'tl','',0),(509210,14145,'th','à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸£à¹‰à¸­à¸¢à¸¥à¸°à¹€à¸¡à¸”à¸´à¹à¸„à¸£à¹Œ',0),(509211,14145,'hi','à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤° à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(509212,14145,'ms','Medicare peratus pekerja',0),(509213,14145,'ar','Ø§Ù„Ù…ÙˆØ¸Ù Ù†Ø³Ø¨Ø© Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(509214,14145,'fr','EmployÃ© pour cent de l\'assurance-maladie',0),(509215,14145,'jp','ãƒ¡ãƒ‡ã‚£ã‚±ã‚¢ ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆå¾“æ¥­å“¡',0),(509216,14145,'pt','Empregado por cento de Medicare',0),(509217,14145,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð² Medicare',0),(509218,14145,'es','Medicare empleado por ciento',0),(509219,14145,'de','Medicare Prozent Mitarbeiter',0),(509220,14145,'en','Medicare Percent Employee',0),(509221,14146,'is','',0),(509222,14146,'dr','Ù¾Ø³ Ù…Ù†Ø¸ÙˆØ± Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯ Ø®Ø·Ø§ÛŒÛŒ Ø±Ø® Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª',0),(509223,14146,'pr','Ù¾Ø³ Ù…Ù†Ø¸ÙˆØ± Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯ Ø®Ø·Ø§ÛŒÛŒ Ø±Ø® Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª',0),(509224,14146,'tr','SÄ±rasÄ± deÄŸil sunuldu bÃ¶ylece hata oluÅŸtu',0),(509225,14146,'pl','WystÄ…piÅ‚ bÅ‚Ä…d, wiÄ™c kolejnoÅ›Ä‡ nie przedstawiÅ‚',0),(509226,14146,'bg','Ð’ÑŠÐ·Ð½Ð¸ÐºÐ½Ð°Ð»Ð° Ðµ Ð³Ñ€ÐµÑˆÐºÐ°, Ñ‚Ð°ÐºÐ° Ñ‡Ðµ Ð½Ðµ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(509227,14146,'ur','Ù„ÛØ°Ø§ Ø­Ú©Ù… Ù†ÛÛŒÚº Ø¹Ø±Ø¶ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ø§ÛŒÚ© Ù†Ù‚Øµ ÛÙˆ Ú¯ÛŒØ§ Û”',0),(509228,14146,'sr','Ð”Ð¾ÑˆÐ»Ð¾ Ñ˜Ðµ Ð´Ð¾ Ð³Ñ€ÐµÑˆÐºÐµ Ñ‚Ð°ÐºÐ¾ Ð´Ð° Ð½Ðµ Ð¿Ñ€Ð¾ÑÐ»ÐµÑ’Ð¸Ð²Ð°ÑšÐ° Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(509229,14146,'vi','Lá»—i Ä‘Ã£ xáº£y ra Ä‘á»ƒ Ä‘Æ¡n Ä‘áº·t hÃ ng khÃ´ng Ä‘Ã£ Ä‘Æ°á»£c gá»­i',0),(509230,14146,'af','\'N Fout het voorgekom sodat die volgorde Was nie voorgelÃª',0),(509231,14146,'ro','Eroare astfel Ã®ncÃ¢t comanda nu a fost prezentat',0),(509232,14146,'et','Ilmnes tÃµrge, nii ei edastatud tellimus',0),(509233,14146,'si','Napaka tako ne predloÅ¾itve naroÄila',0),(509234,14146,'ba','Terjadi kesalahan sehingga pesanan tidak disampaikan',0),(509235,14146,'nl','Er is een fout opgetreden zodat de bestelling is niet verzonden',0),(509236,14146,'fi','Ilmeni virhe, joten tilaus ei ole toimitettu',0),(509237,14146,'no','Feil sÃ¥ ordren ikke ble sendt',0),(509238,14146,'da','Der opstod en fejl, sÃ¥ rÃ¦kkefÃ¸lgen ikke var indsendt',0),(509239,14146,'ko','ìˆœì„œ ì•„ë‹ˆ ì—ˆ ì œì¶œ ì˜¤ë¥˜ê°€ ë°œìƒ í–ˆìŠµë‹ˆë‹¤.',0),(509240,14146,'he','××™×¨×¢×” ×©×’×™××” ××– ×”×”×–×ž× ×” ×œ× × ×©×œ×—×”',0),(509241,14146,'el','Î Î±ÏÎ¿Ï…ÏƒÎ¹Î¬ÏƒÏ„Î·ÎºÎµ ÏƒÏ†Î¬Î»Î¼Î± Î­Ï„ÏƒÎ¹ Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Ï…Ï€Î¿Î²Î»Î·Î¸ÎµÎ¯',0),(509242,14146,'zh','æ‰€ä»¥ä¸æäº¤è®¢å•æ—¶å‡ºé”™',0),(509243,14146,'sv','Ett fel uppstod sÃ¥ ordern inte lÃ¤mnades',0),(509244,14146,'it','Errore quindi l\'ordine non Ã¨ stata presentata',0),(509245,14146,'tl','',0),(509246,14146,'th','à¹€à¸à¸´à¸”à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹€à¸žà¸·à¹ˆà¸­à¹„à¸¡à¹ˆà¸ªà¹ˆà¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(509247,14146,'hi','à¤‘à¤°à¥à¤¡à¤° à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¤à¥‹ à¤à¤• à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨ à¤¹à¥à¤ˆ',0),(509248,14146,'ms','Satu ralat berlaku supaya perintah itu tidak diserahkan',0),(509249,14146,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø­ÙŠØ« Ù„Ù… ÙŠÙ‚Ø¯Ù… Ø§Ù„Ù†Ø¸Ø§Ù…',0),(509250,14146,'fr','Une erreur s\'est produite alors que l\'ordre n\'a pas Ã©tÃ© soumis',0),(509251,14146,'jp','ã‚¨ãƒ©ãƒ¼ãŒç™ºç”Ÿã—ãŸãŸã‚ã€æ³¨æ–‡ã¯é€ä¿¡ã•ã‚Œã¾ã›ã‚“ã§ã—ãŸã€‚',0),(509252,14146,'pt','Ocorreu um erro, entÃ£o a ordem nÃ£o foi apresentada',0),(509253,14146,'ru','ÐŸÑ€Ð¾Ð¸Ð·Ð¾ÑˆÐ»Ð° Ð¾ÑˆÐ¸Ð±ÐºÐ°, Ñ‚Ð°Ðº Ñ‡Ñ‚Ð¾ Ð·Ð°ÐºÐ°Ð· Ð½Ðµ Ð±Ñ‹Ð» Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½',0),(509254,14146,'es','Se produjo un Error para que la orden no se presentÃ³',0),(509255,14146,'de','Ist ein Fehler aufgetreten, so dass die Reihenfolge nicht verspÃ¤tet',0),(509256,14146,'en','An Error Occurred So The Order Was Not Submitted',0),(509257,14147,'is','',0),(509258,14147,'dr','A &amp; Ù…Ù† Ù…Ø­ØµÙˆÙ„Ø§Øª Ø§Ù†ØªÙ‚Ø§Ù„',0),(509259,14147,'pr','A &amp; Ù…Ù† Ù…Ø­ØµÙˆÙ„Ø§Øª Ø§Ù†ØªÙ‚Ø§Ù„',0),(509260,14147,'tr','A & ben Ã¼rÃ¼nleri aktarma',0),(509261,14147,'pl','A & I produkty transferu',0),(509262,14147,'bg','Ð & I Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸, Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ',0),(509263,14147,'ur','A & Ù…ÛŒÚº Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(509264,14147,'sr','Ð Ð¸ ÑÐ°Ð¼ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸ Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(509265,14147,'vi','A &amp; tÃ´i sáº£n pháº©m chuyá»ƒn',0),(509266,14147,'af','\'N & ek produkte dra',0),(509267,14147,'ro','A & am produse de Transfer',0),(509268,14147,'et','A & I toodete Ã¼leandmine',0),(509269,14147,'si','A & I proizvodi prenos',0),(509270,14147,'ba','A & saya produk Transfer',0),(509271,14147,'nl','A & I producten overdragen',0),(509272,14147,'fi','A & olen tuotteiden siirtÃ¤minen',0),(509273,14147,'no','A & jeg produkter overfÃ¸re',0),(509274,14147,'da','A & jeg produkter overfÃ¸re',0),(509275,14147,'ko','A & ë‚˜ ì œí’ˆ ì „ì†¡',0),(509276,14147,'he','A & ×× ×™ ×ž×•×¦×¨×™× ×”×¢×‘×¨×”',0),(509277,14147,'el','A & ÎµÎ³ÏŽ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚',0),(509278,14147,'zh','A &amp; äº§å“è½¬ç§»',0),(509279,14147,'sv','A & jag produkter Ã¶verfÃ¶ra',0),(509280,14147,'it','A & I prodotti di trasferimento',0),(509281,14147,'tl','',0),(509282,14147,'th','A & à¸œà¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(509283,14147,'hi','A & à¤®à¥ˆà¤‚ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¥‹à¤‚ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£',0),(509284,14147,'ms','A & saya produk pemindahan',0),(509285,14147,'ar','A Ø¢Ù†Ø¯ Ø£Ù†Ø§ Ù…Ù†ØªØ¬Ø§Øª Ù†Ù‚Ù„',0),(509286,14147,'fr','A & j\'ai produits transfert',0),(509287,14147,'jp','A & ç§ã¯è£½å“ã‚’è»¢é€',0),(509288,14147,'pt','A & eu produtos de transferÃªncia',0),(509289,14147,'ru','A & Ñ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ñ‹ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(509290,14147,'es','A &amp; que los productos de transferencia',0),(509291,14147,'de','A & I Produkte Ã¼bertragen',0),(509292,14147,'en','A&I Products Transfer',0),(509293,14148,'is','',0),(509294,14148,'dr','Ù‡ÛŒÚ† Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø§Ø±Ø³Ø§Ù„',0),(509295,14148,'pr','Ù‡ÛŒÚ† Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø§Ø±Ø³Ø§Ù„',0),(509296,14148,'tr','GÃ¶nderilen hiÃ§bir sipariÅŸ numarasÄ±',0),(509297,14148,'pl','Nie numeru zamÃ³wienia wysÅ‚ane',0),(509298,14148,'bg','ÐÑÐ¼Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(509299,14148,'ur','Ú©ÙˆØ¦ÛŒ Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(509300,14148,'sr','ÐÐµÐ¼Ð° Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° ÐºÐ¾Ñ˜Ð¸ Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(509301,14148,'vi','KhÃ´ng cÃ³ sá»‘ thá»© tá»± gá»­i',0),(509302,14148,'af','Geen bestelling nommer gestuur',0),(509303,14148,'ro','Nici un numÄƒr de ordine a trimis',0),(509304,14148,'et','No jÃ¤rjekorranumber on saadetud',0),(509305,14148,'si','Ni zaporedno Å¡tevilko poslano',0),(509306,14148,'ba','Tidak ada nomor pesanan dikirim',0),(509307,14148,'nl','Geen ordernummer verzonden',0),(509308,14148,'fi','Ei lÃ¤hettÃ¤nyt numero',0),(509309,14148,'no','Ingen ordrenummer sendt',0),(509310,14148,'da','Ingen ordrenummer, sendt',0),(509311,14148,'ko','ì „ì†¡ ìˆœì„œ ë²ˆí˜¸',0),(509312,14148,'he','××™×Ÿ ×ž×¡×¤×¨ ×”×”×–×ž× ×” ×©×œ×—',0),(509313,14148,'el','Î”ÎµÎ½ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ Î­ÏƒÏ„ÎµÎ¹Î»Îµ',0),(509314,14148,'zh','æ²¡æœ‰å‘é€çš„è®¢å•å·',0),(509315,14148,'sv','Inget ordernummer skickas',0),(509316,14148,'it','Nessun numero ordine inviato',0),(509317,14148,'tl','',0),(509318,14148,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¹„à¸›',0),(509319,14148,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤­à¥‡à¤œà¤¾',0),(509320,14148,'ms','Tiada nombor pesanan yang dihantar',0),(509321,14148,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø±Ù‚Ù… Ø£Ù…Ø± Ø¥Ø±Ø³Ø§Ù„',0),(509322,14148,'fr','Aucun numÃ©ro de commande envoyÃ©',0),(509323,14148,'jp','é€ä¿¡ã•ã‚ŒãŸæ³¨æ–‡ç•ªå·ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(509324,14148,'pt','Nenhum nÃºmero de pedido enviado',0),(509325,14148,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°, Ð½Ðµ Ð¿Ð¾ÑÐ»Ð°Ð»',0),(509326,14148,'es','NingÃºn nÃºmero de pedido enviado',0),(509327,14148,'de','Keine Bestellnummer gesendet',0),(509328,14148,'en','No Order Number Sent',0),(509329,14149,'is','',0),(509330,14149,'dr','ÙØ§ÛŒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø±Ø³Ø§Ù„',0),(509331,14149,'pr','ÙØ§ÛŒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø§Ø±Ø³Ø§Ù„',0),(509332,14149,'tr','Dosya baÅŸarÄ±yla karÅŸÄ±ya yÃ¼klendi',0),(509333,14149,'pl','PrzesÅ‚any plik pomyÅ›lnie',0),(509334,14149,'bg','ÐšÐ°Ñ‡ÐµÐ½ Ñ„Ð°Ð¹Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(509335,14149,'ur','ÙØ§Ø¦Ù„ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ Ù„ÙˆÚˆ ÛÙˆØªÛŒ Û”',0),(509336,14149,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(509337,14149,'vi','Táº£i lÃªn táº­p tin thÃ nh cÃ´ng',0),(509338,14149,'af','LÃªer suksesvol opgelaai',0),(509339,14149,'ro','ÃŽncÄƒrcat dosar cu succes',0),(509340,14149,'et','Faili Ã¼leslaadimine Ãµnnestus',0),(509341,14149,'si','Uploaded pila uspeÅ¡no',0),(509342,14149,'ba','Upload File berhasil',0),(509343,14149,'nl','Bestand geÃ¼pload',0),(509344,14149,'fi','Ladattu tiedosto',0),(509345,14149,'no','Lastet opp filen',0),(509346,14149,'da','Uploadet filen med succes',0),(509347,14149,'ko','ì„±ê³µì ìœ¼ë¡œ íŒŒì¼ì„ ì—…ë¡œë“œ',0),(509348,14149,'he','×©×”×¢×œ××ª ×”×§×•×‘×¥',0),(509349,14149,'el','Î¦Î¿ÏÏ„ÏŽÎ¸Î·ÎºÎµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(509350,14149,'zh','å·²æˆåŠŸä¸Šè½½æ–‡ä»¶',0),(509351,14149,'sv','Belastat upp arkivera lyckosam',0),(509352,14149,'it','Caricato il File correttamente',0),(509353,14149,'tl','',0),(509354,14149,'th','à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¹à¸Ÿà¹‰à¸¡à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(509355,14149,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(509356,14149,'ms','Fail dimuat naik dengan jayanya',0),(509357,14149,'ar','ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ù…Ù„Ù Ø¨Ù†Ø¬Ø§Ø­',0),(509358,14149,'fr','TÃ©lÃ©chargÃ© le fichier avec succÃ¨s',0),(509359,14149,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ãŒæ­£å¸¸ã«ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã•ã‚Œã¾ã—ãŸã€‚',0),(509360,14149,'pt','Carregado o arquivo com Ãªxito',0),(509361,14149,'ru','Ð¤Ð°Ð¹Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð·Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½',0),(509362,14149,'es','Subido el archivo con Ã©xito',0),(509363,14149,'de','Datei erfolgreich hochgeladen',0),(509364,14149,'en','Uploaded File Successfully',0),(509365,14150,'is','',0),(509366,14150,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú©Ø§Ø±Øª Ø¬Ø¯ÛŒØ¯',0),(509367,14150,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú©Ø§Ø±Øª Ø¬Ø¯ÛŒØ¯',0),(509368,14150,'tr','Yeni kart Ekle',0),(509369,14150,'pl','Dodaj nowÄ… kartÄ™',0),(509370,14150,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(509371,14150,'ur','Ù†Ø¦Û’ Ú©Ø§Ø±Úˆ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(509372,14150,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(509373,14150,'vi','ThÃªm tháº» má»›i',0),(509374,14150,'af','Voeg nuwe kaart',0),(509375,14150,'ro','Adauga nou Card',0),(509376,14150,'et','Lisada uus kaart',0),(509377,14150,'si','Dodate novo kartico',0),(509378,14150,'ba','Menambahkan kartu baru',0),(509379,14150,'nl','Nieuwe kaart toevoegen',0),(509380,14150,'fi','LisÃ¤Ã¤ uusi kortti',0),(509381,14150,'no','Legge til nye Card',0),(509382,14150,'da','TilfÃ¸j nyt kort',0),(509383,14150,'ko','ìƒˆ ì¹´ë“œë¥¼ ì¶”ê°€',0),(509384,14150,'he','×œ×”×•×¡×™×£ ×›×¨×˜×™×¡ ×—×“×©',0),(509385,14150,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± ÎºÎ¬ÏÏ„Î±',0),(509386,14150,'zh','æ·»åŠ æ–°å¡',0),(509387,14150,'sv','LÃ¤gga till nya kort',0),(509388,14150,'it','Aggiungi nuova scheda',0),(509389,14150,'tl','',0),(509390,14150,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸±à¸•à¸£à¹ƒà¸«à¸¡à¹ˆ',0),(509391,14150,'hi','à¤¨à¤ à¤•à¤¾à¤°à¥à¤¡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(509392,14150,'ms','Menambah kad baru',0),(509393,14150,'ar','Ø£Ø¶Ù Ø¨Ø·Ø§Ù‚Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(509394,14150,'fr','Ajoutez la nouvelle carte',0),(509395,14150,'jp','æ–°ã—ã„ã‚«ãƒ¼ãƒ‰ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(509396,14150,'pt','Adicionar nova placa',0),(509397,14150,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(509398,14150,'es','AÃ±adir nueva tarjeta',0),(509399,14150,'de','Neue Karte hinzufÃ¼gen',0),(509400,14150,'en','Add New Card',0),(509401,14151,'is','',0),(509402,14151,'dr','Ú©Ø§Ø±Øª Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(509403,14151,'pr','Ú©Ø§Ø±Øª Ø§Ø¶Ø§ÙÙ‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(509404,14151,'tr','Kart eklenmedi',0),(509405,14151,'pl','Karta nie dodaje',0),(509406,14151,'bg','ÐšÐ°Ñ€Ñ‚Ð°Ñ‚Ð° Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¾',0),(509407,14151,'ur','Ú©Ø§Ø±Úˆ Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©ÛŒØ§',0),(509408,14151,'sr','ÐšÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ñ‚',0),(509409,14151,'vi','Tháº» khÃ´ng thÃªm',0),(509410,14151,'af','Kaart nie bygevoeg',0),(509411,14151,'ro','Cardul nu adÄƒugat',0),(509412,14151,'et','Ei saa lisada kaart',0),(509413,14151,'si','Kartica ne doda',0),(509414,14151,'ba','Kartu yang tidak ditambahkan',0),(509415,14151,'nl','Kaart niet toegevoegd',0),(509416,14151,'fi','Kortti ei lisÃ¤tÃ¤',0),(509417,14151,'no','Kortet ikke lagt',0),(509418,14151,'da','Kortet ikke tilfÃ¸jet',0),(509419,14151,'ko','ì¹´ë“œ ì¶”ê°€ ë˜ì§€',0),(509420,14151,'he','×›×¨×˜×™×¡ ×œ× ×”×•×¡×™×£',0),(509421,14151,'el','ÎšÎ¬ÏÏ„Î± Î´ÎµÎ½ Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯',0),(509422,14151,'zh','ä¸ä¼šæ·»åŠ çš„å¡',0),(509423,14151,'sv','Kort inte lÃ¤ggas',0),(509424,14151,'it','Carta non aggiunto',0),(509425,14151,'tl','',0),(509426,14151,'th','à¸šà¸±à¸•à¸£à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¹€à¸žà¸´à¹ˆà¸¡',0),(509427,14151,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(509428,14151,'ms','Kad yang tidak ditambah',0),(509429,14151,'ar','Ù„Ù… ØªØªÙ… Ø¥Ø¶Ø§ÙØ© Ø¨Ø·Ø§Ù‚Ø©',0),(509430,14151,'fr','Carte ne pas ajoutÃ©',0),(509431,14151,'jp','ã‚«ãƒ¼ãƒ‰ã‚’è¿½åŠ ã—ã¦ã„ã¾ã›ã‚“',0),(509432,14151,'pt','CartÃ£o nÃ£o adicionado',0),(509433,14151,'ru','ÐšÐ°Ñ€Ñ‚Ð° Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(509434,14151,'es','Tarjeta no aÃ±adido',0),(509435,14151,'de','Karte nicht hinzugefÃ¼gt',0),(509436,14151,'en','Card Not Added',0),(509437,14152,'is','',0),(509438,14152,'dr','Ú©Ø§Ø±Øª Ø­Ø°Ù Ø´Ø¯',0),(509439,14152,'pr','Ú©Ø§Ø±Øª Ø­Ø°Ù Ø´Ø¯',0),(509440,14152,'tr','Kart silinmedi',0),(509441,14152,'pl','Karta nie zostaÅ‚a usuniÄ™ta.',0),(509442,14152,'bg','ÐšÐ°Ñ€Ñ‚Ð°Ñ‚Ð° Ð½Ðµ Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚',0),(509443,14152,'ur','Ú©Ø§Ø±Úˆ Ø­Ø°Ù Ù†ÛÛŒÚº Ú©ÛŒ Ú¯Ø¦ÛŒ',0),(509444,14152,'sr','ÐšÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð½Ð¸Ñ˜Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½',0),(509445,14152,'vi','Tháº» khÃ´ng Ä‘Æ°á»£c xÃ³a bá»',0),(509446,14152,'af','Kaart is nie geskrap nie',0),(509447,14152,'ro','Cardul nu a fost ÅŸters',0),(509448,14152,'et','Kaart on kustutatud',0),(509449,14152,'si','Kartice ni bil izbrisan',0),(509450,14152,'ba','Kartu tidak dihapus',0),(509451,14152,'nl','Kaart werd niet verwijderd',0),(509452,14152,'fi','Kortti poistettu',0),(509453,14152,'no','Kortet ble ikke slettet',0),(509454,14152,'da','Kortet blev ikke slettet',0),(509455,14152,'ko','ì¹´ë“œëŠ” ì‚­ì œ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(509456,14152,'he','×›×¨×˜×™×¡ ×œ× × ×ž×—×§',0),(509457,14152,'el','ÎšÎ¬ÏÏ„Î± Î´ÎµÎ½ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ',0),(509458,14152,'zh','å¡æœªè¢«åˆ é™¤',0),(509459,14152,'sv','Kortet togs inte bort',0),(509460,14152,'it','Carta non Ã¨ stato eliminato',0),(509461,14152,'tl','',0),(509462,14152,'th','à¸šà¸±à¸•à¸£à¹„à¸¡à¹ˆà¸–à¸¹à¸à¸¥à¸š',0),(509463,14152,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤¨à¤¹à¥€à¤‚ à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(509464,14152,'ms','Kad tidak dihapuskan',0),(509465,14152,'ar','Ù„Ù… ÙŠØªÙ… Ø­Ø°Ù Ø§Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(509466,14152,'fr','Carte n\'a pas Ã©tÃ© supprimÃ©.',0),(509467,14152,'jp','ã‚«ãƒ¼ãƒ‰ã‚’å‰Šé™¤ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(509468,14152,'pt','CartÃ£o nÃ£o foi excluÃ­do',0),(509469,14152,'ru','ÐšÐ°Ñ€Ñ‚Ñ‹ Ð½Ðµ Ð±Ñ‹Ð» ÑƒÐ´Ð°Ð»ÐµÐ½',0),(509470,14152,'es','Tarjeta no fue borrado',0),(509471,14152,'de','Karte wurde nicht gelÃ¶scht.',0),(509472,14152,'en','Card Was Not Deleted',0),(509473,14153,'is','',0),(509474,14153,'dr','Ù†Ù‡ Ù¾ÛŒØ¯Ø§ Ø¯Ø± Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ ePay Ù…Ù†Ø¨Ø¹ Ú©Ù„ÛŒØ¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯',0),(509475,14153,'pr','Ù†Ù‡ Ù¾ÛŒØ¯Ø§ Ø¯Ø± Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ ePay Ù…Ù†Ø¨Ø¹ Ú©Ù„ÛŒØ¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯',0),(509476,14153,'tr','Bul ABD ePay kaynak anahtarÄ± olabilir',0),(509477,14153,'pl','Kulisy nie znaleÅºÄ‡ USA ePay ÅºrÃ³dÅ‚a klucz',0),(509478,14153,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð½Ðµ Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð¡ÐÐ© ePay Ð¸Ð·Ñ‚Ð¾Ñ‡Ð½Ð¸Ðº ÐºÐ»ÑŽÑ‡',0),(509479,14153,'ur','Ù†Û ÚˆÚ¾ÙˆÙ†Úˆ USA Ø§ÛŒÙ¾Ø¢ÛŒ Ù…Ø§Ø®Ø° Ú©Ù„ÛŒØ¯ Ø³Ú©Ø§',0),(509480,14153,'sr','ÐœÐ¾Ð³Ð°Ð¾ ÐµÐŸÐ°y Ð½Ðµ Ð£Ð¡Ð Ð½Ð°Ñ›Ð¸ Ð¸Ð·Ð²Ð¾Ñ€ ÐºÑ™ÑƒÑ‡',0),(509481,14153,'vi','CÃ³ thá»ƒ khÃ´ng tÃ¬m tháº¥y Má»¹ ePay nguá»“n chÃ­nh',0),(509482,14153,'af','Kan nie vind VSA ePay bron sleutel',0),(509483,14153,'ro','Ar putea gÄƒsi SUA ePay sursÄƒ cheie',0),(509484,14153,'et','VÃµib leida USA ePay allikas vÃµti',0),(509485,14153,'si','Strjena lava ne odkriti ZDA ePay vir zakleniti',0),(509486,14153,'ba','Bisa tidak menemukan USA ePay kunci sumber',0),(509487,14153,'nl','Kan niet vinden VS ePay brontoets',0),(509488,14153,'fi','Voisi lÃ¶ytÃ¤Ã¤ USA ePay lÃ¤hdeavain',0),(509489,14153,'no','Kunne ikke finne USA andre betalingsmÃ¥ter kildenÃ¸kkel',0),(509490,14153,'da','Kunne ikke finde USA ePay Source nÃ¸gle',0),(509491,14153,'ko','ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ì°¾ì„ ë¯¸êµ­ ePay ì†ŒìŠ¤ í‚¤',0),(509492,14153,'he','×™×›×•×œ ePay ×œ× ××¨×” ×‘ ×œ×ž×¦×•× ×ž×§×•×¨ ×ž×¤×ª×—',0),(509493,14153,'el','Î˜Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î²ÏÎµÎ¯Ï„Îµ Î—Î Î‘ ePay Ï€Î·Î³Î® ÎºÎ»ÎµÎ¹Î´Î¯',0),(509494,14153,'zh','å¯ä»¥ä¸æ‰¾ç¾Žå›½ ePay æºé”®',0),(509495,14153,'sv','Kunde inte hitta USA ePay Source nyckel',0),(509496,14153,'it','Potrebbe non trovare USA ePay tasto sorgente',0),(509497,14153,'tl','',0),(509498,14153,'th','à¸­à¸²à¸ˆà¹„à¸¡à¹ˆà¸žà¸šà¸ªà¸«à¸£à¸±à¸à¸­à¹€à¸¡à¸£à¸´à¸à¸² ePay à¸„à¸µà¸¢à¹Œà¸•à¹‰à¸™à¸‰à¸šà¸±à¸š',0),(509499,14153,'hi','à¤¸à¤•à¤¾ à¤¨à¤¹à¥€à¤‚ à¤–à¥‹à¤œà¥‡à¤‚ à¤¯à¥‚à¤à¤¸à¤ ePay à¤¸à¥à¤°à¥‹à¤¤ à¤•à¥à¤‚à¤œà¥€',0),(509500,14153,'ms','Boleh tidak mencari USA ePay sumber utama',0),(509501,14153,'ar','ÙˆÙŠÙ…ÙƒÙ† Ø£Ù† \"Ù„Ø§ ØªØ¬Ø¯ Ø§Ù„ÙˆÙ„Ø§ÙŠØ§Øª Ø§Ù„Ù…ØªØ­Ø¯Ø© Ø§Ù„Ø£Ù…Ø±ÙŠÙƒÙŠØ©\" ePay \"Ù…ÙØªØ§Ø­ Ø§Ù„Ù…ØµØ¯Ø±\"',0),(509502,14153,'fr','Pourrait pas trouver USA PmtE touche Source',0),(509503,14153,'jp','ç±³å›½ã®ãªã„è¦‹ã¤ã‘ã‚‹ ePay ã‚½ãƒ¼ã‚¹ ã‚­ãƒ¼å¯èƒ½æ€§ãŒã‚ã‚Šã¾ã™ã€‚',0),(509504,14153,'pt','Poderia nÃ£o encontrar EUA ePay fonte chave',0),(509505,14153,'ru','ÐœÐ¾Ð¶ÐµÑ‚ Ð½Ðµ Ð½Ð°Ð¹Ñ‚Ð¸ Ð¡Ð¨Ð ePay Ð¸ÑÑ…Ð¾Ð´Ð½Ð¾Ð³Ð¾ ÐºÐ»ÑŽÑ‡Ð°',0),(509506,14153,'es','PodrÃ­a no encontrar los E.e.u.u. ePay fuente clave',0),(509507,14153,'de','Konnte nicht finden USA ePay Taste Quelle',0),(509508,14153,'en','Could Not Find USA ePay Source Key',0),(509509,14154,'is','',0),(509510,14154,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§ØªØµØ§Ù„ Ø¨Ù‡ Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ ePay',0),(509511,14154,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§ØªØµØ§Ù„ Ø¨Ù‡ Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ ePay',0),(509512,14154,'tr','Hata baÄŸlama iÃ§in ABD ePay',0),(509513,14154,'pl','BÅ‚Ä…d Å‚Ä…czenia do USA ePay',0),(509514,14154,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÐ²ÑŠÑ€Ð·Ð²Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð¡ÐÐ© ePay',0),(509515,14154,'ur','Ù†Ù‚Øµ Ø¬Ú‘Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ù…Ø±ÛŒÚ©Û Ø§ÛŒÙ¾Ø¢ÛŒ',0),(509516,14154,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÑƒ Ð´Ð° Ð£Ð¡Ð ÐµÐŸÐ°y',0),(509517,14154,'vi','Lá»—i káº¿t ná»‘i Ä‘áº¿n Hoa Ká»³ ePay',0),(509518,14154,'af','Fout verbind om VSA ePay',0),(509519,14154,'ro','Eroare de legÄƒturÄƒ pentru SUA ePay',0),(509520,14154,'et','Error Connecting USA ePay',0),(509521,14154,'si','Napaka pri povezovanju v ZDA ePay',0),(509522,14154,'ba','Kesalahan menghubungkan ke USA ePay',0),(509523,14154,'nl','Fout aansluiten aan de V.S. ePay',0),(509524,14154,'fi','Virhe yhteyden USA ePay',0),(509525,14154,'no','Feil tilkobling til USA andre betalingsmÃ¥ter',0),(509526,14154,'da','Fejl tilslutning til USA ePay',0),(509527,14154,'ko','ì˜¤ë¥˜ ì—°ê²°ì„ ë¯¸êµ­ ePay',0),(509528,14154,'he','×©×’×™××ª ×”×ª×—×‘×¨×•×ª ×œ××¨×” ×‘ ePay',0),(509529,14154,'el','Î£Ï†Î¬Î»Î¼Î± ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ Î½Î± Î—Î Î‘ ePay',0),(509530,14154,'zh','é”™è¯¯è¿žæŽ¥åˆ°ç¾Žå›½ ePay',0),(509531,14154,'sv','Fel ansluter till USA ePay',0),(509532,14154,'it','Errore di collegamento a USA ePay',0),(509533,14154,'tl','',0),(509534,14154,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¸à¸²à¸£à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¸à¸±à¸šà¸­à¹€à¸¡à¸£à¸´à¸à¸² ePay',0),(509535,14154,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤‚à¤¯à¥à¤•à¥à¤¤ à¤°à¤¾à¤œà¥à¤¯ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¨à¥‡à¤•à¥à¤Ÿ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ ePay',0),(509536,14154,'ms','Ralat sambungan ke USA ePay',0),(509537,14154,'ar','Ø®Ø·Ø£ ÙÙŠ \"Ø§Ù„Ø§ØªØµØ§Ù„ Ø¥Ù„Ù‰ Ø§Ù„ÙˆÙ„Ø§ÙŠØ§Øª Ø§Ù„Ù…ØªØ­Ø¯Ø© Ø§Ù„Ø£Ù…Ø±ÙŠÙƒÙŠØ©\" Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(509538,14154,'fr','Erreur connexion Ã  USA PmtE',0),(509539,14154,'jp','ã‚¨ãƒ©ãƒ¼ç±³å›½ã‚’æŽ¥ç¶šã™ã‚‹ ePay',0),(509540,14154,'pt','Erro conectando ao EUA ePay',0),(509541,14154,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾Ð´ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ Ðº Ð¡Ð¨Ð ePay',0),(509542,14154,'es','Error conectando a USA ePay',0),(509543,14154,'de','Fehler nach USA verbinden ePay',0),(509544,14154,'en','Error Connecting To USA ePay',0),(509545,14155,'is','',0),(509546,14155,'dr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(509547,14155,'pr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(509548,14155,'tr','Ã–deme yÃ¶ntemi baÅŸarÄ±yla eklendi',0),(509549,14155,'pl','PomyÅ›lnie dodano metodÄ™ pÅ‚atnoÅ›ci',0),(509550,14155,'bg','ÐœÐµÑ‚Ð¾Ð´ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(509551,14155,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(509552,14155,'sr','ÐÐ°Ñ‡Ð¸Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(509553,14155,'vi','PhÆ°Æ¡ng thá»©c thanh toÃ¡n thÃªm thÃ nh cÃ´ng',0),(509554,14155,'af','Betaling metode suksesvol bygevoeg',0),(509555,14155,'ro','MetodÄƒ de platÄƒ adÄƒugat cu succes',0),(509556,14155,'et','Lisatud makseviis',0),(509557,14155,'si','NaÄin plaÄila uspeÅ¡no dodani',0),(509558,14155,'ba','Metode pembayaran yang ditambahkan berhasil',0),(509559,14155,'nl','Betalingsmethode toegevoegd',0),(509560,14155,'fi','Maksutavan lisÃ¤Ã¤minen onnistui',0),(509561,14155,'no','BetalingsmÃ¥ten ble lagt til',0),(509562,14155,'da','Betalingsmetode tilfÃ¸jet',0),(509563,14155,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ ì§€ë¶ˆ ë°©ë²•',0),(509564,14155,'he','×©×™×˜×ª ×ª×©×œ×•× × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(509565,14155,'el','ÎœÎ­Î¸Î¿Î´Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(509566,14155,'zh','ä»˜æ¬¾æ–¹å¼å·²æˆåŠŸæ·»åŠ ',0),(509567,14155,'sv','Betalningsmetod som lagts',0),(509568,14155,'it','Metodo di pagamento aggiunto con successo',0),(509569,14155,'tl','',0),(509570,14155,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(509571,14155,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¦à¥à¤§à¤¤à¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(509572,14155,'ms','Kaedah pembayaran yang berjaya menambah',0),(509573,14155,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(509574,14155,'fr','Mode de paiement ajoutÃ© avec succÃ¨s',0),(509575,14155,'jp','ãŠæ”¯æ‰•æ–¹æ³•ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(509576,14155,'pt','MÃ©todo de pagamento adicionado com sucesso',0),(509577,14155,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹ ÑÐ¿Ð¾ÑÐ¾Ð±Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(509578,14155,'es','MÃ©todo de pago se ha agregado correctamente',0),(509579,14155,'de','Zahlungsmethode erfolgreich hinzugefÃ¼gt',0),(509580,14155,'en','Payment Method Added Successfully',0),(509581,14156,'is','',0),(509582,14156,'dr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(509583,14156,'pr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(509584,14156,'tr','Ã–deme yÃ¶ntemi baÅŸarÄ±yla silindi',0),(509585,14156,'pl','Metoda pÅ‚atnoÅ›ci przesâ”‚anie',0),(509586,14156,'bg','ÐœÐµÑ‚Ð¾Ð´ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(509587,14156,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(509588,14156,'sr','ÐÐ°Ñ‡Ð¸Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð°',0),(509589,14156,'vi','PhÆ°Æ¡ng thá»©c thanh toÃ¡n Ä‘Ã£ xÃ³a thÃ nh cÃ´ng',0),(509590,14156,'af','Betaling metode suksesvol geskrap',0),(509591,14156,'ro','MetodÄƒ de platÄƒ eliminÄƒ cu succes',0),(509592,14156,'et','Edukalt kustutatud makseviis',0),(509593,14156,'si','NaÄin plaÄila uspeÅ¡no izbrisana',0),(509594,14156,'ba','Metode pembayaran yang berhasil dihapus',0),(509595,14156,'nl','Betalingsmethode verwijderd',0),(509596,14156,'fi','Poistettu maksutapa',0),(509597,14156,'no','BetalingsmÃ¥ten ble slettet',0),(509598,14156,'da','Betalingsmetode slettet',0),(509599,14156,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ì§€ë¶ˆ ë°©ë²•',0),(509600,14156,'he','×©×™×˜×ª ×”×ª×©×œ×•× × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(509601,14156,'el','ÎœÎ­Î¸Î¿Î´Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(509602,14156,'zh','å·²æˆåŠŸåˆ é™¤çš„ä»˜æ¬¾æ–¹å¼',0),(509603,14156,'sv','Betalningsmetod som raderades',0),(509604,14156,'it','Metodo di pagamento eliminato con successo',0),(509605,14156,'tl','',0),(509606,14156,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸–à¸¹à¸à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(509607,14156,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤§à¤¿ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(509608,14156,'ms','Kaedah pembayaran yang dihapuskan dengan jayanya',0),(509609,14156,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹ Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(509610,14156,'fr','Mode de paiement supprimÃ© avec succÃ¨s',0),(509611,14156,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸãŠæ”¯æ‰•æ–¹æ³•',0),(509612,14156,'pt','MÃ©todo de pagamento excluÃ­do com sucesso',0),(509613,14156,'ru','ÐœÐµÑ‚Ð¾Ð´ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(509614,14156,'es','MÃ©todo de pago eliminado satisfactoriamente',0),(509615,14156,'de','Zahlungsmethode erfolgreich gelÃ¶scht',0),(509616,14156,'en','Payment Method Deleted Successfully',0),(509617,14157,'is','',0),(509618,14157,'dr','EPay Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ Ù¾Ø§ÛŒÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(509619,14157,'pr','EPay Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ Ù¾Ø§ÛŒÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(509620,14157,'tr','ABD ePay mÃ¼ÅŸteri veritabanÄ±',0),(509621,14157,'pl','EPay USA bazy danych klienta',0),(509622,14157,'bg','Ð¡ÐÐ© ePay ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(509623,14157,'ur','Ø§Ù…Ø±ÛŒÚ©Û Ø§ÛŒÙ¾Ø¢ÛŒ Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆØ§Ø¦ÙÛŒÛ',0),(509624,14157,'sr','Ð£Ð¡Ð ÐµÐŸÐ°y Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÐºÐ»Ð¸Ñ˜ÐµÐ½Ð°Ñ‚Ð°',0),(509625,14157,'vi','Má»¹ ePay cÆ¡ sá»Ÿ dá»¯ liá»‡u khÃ¡ch hÃ ng',0),(509626,14157,'af','VSA ePay kliÃ«nt databasis',0),(509627,14157,'ro','SUA ePay bazÄƒ de date client',0),(509628,14157,'et','USA ePay kliendiandmebaasi',0),(509629,14157,'si','ZDA ePay baze podatkov o strankah',0),(509630,14157,'ba','USA ePay Database pelanggan',0),(509631,14157,'nl','USA ePay klantendatabase',0),(509632,14157,'fi','USA ePay asiakastietokanta',0),(509633,14157,'no','USA andre betalingsmÃ¥ter kundedatabase',0),(509634,14157,'da','USA ePay kundedatabase',0),(509635,14157,'ko','ë¯¸êµ­ ePay ê³ ê° ë°ì´í„°ë² ì´ìŠ¤',0),(509636,14157,'he','×‘××¨×” ×‘ ePay ×©×œ ×ž×¡×“ × ×ª×•× ×™ ×”×œ×§×•×—×•×ª',0),(509637,14157,'el','Î—Î Î‘ ePay Î²Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï„Ï‰Î½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(509638,14157,'zh','ç¾Žå›½ ePay å®¢æˆ·æ•°æ®åº“',0),(509639,14157,'sv','USA ePay kunddatabas',0),(509640,14157,'it','EPay USA Database clienti',0),(509641,14157,'tl','',0),(509642,14157,'th','à¸ªà¸«à¸£à¸±à¸à¸­à¹€à¸¡à¸£à¸´à¸à¸² ePay à¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(509643,14157,'hi','à¤¸à¤‚à¤¯à¥à¤•à¥à¤¤ à¤°à¤¾à¤œà¥à¤¯ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ ePay à¤—à¥à¤°à¤¾à¤¹à¤• à¤¡à¤¾à¤Ÿà¤¾à¤¬à¥‡à¤¸',0),(509644,14157,'ms','EPay USA pangkalan data pelanggan',0),(509645,14157,'ar','Ø§Ù„ÙˆÙ„Ø§ÙŠØ§Øª Ø§Ù„Ù…ØªØ­Ø¯Ø© Ø§Ù„Ø£Ù…Ø±ÙŠÙƒÙŠØ© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ \"Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡\"',0),(509646,14157,'fr','USA PmtE client de base de donnÃ©es',0),(509647,14157,'jp','ç±³å›½ ePay é¡§å®¢ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹',0),(509648,14157,'pt','EPay USA banco de dados do cliente',0),(509649,14157,'ru','Ð¡Ð¨Ð ePay Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(509650,14157,'es','Estados Unidos ePay base de clientes',0),(509651,14157,'de','EPay USA Kundendatenbank',0),(509652,14157,'en','USA ePay Customer Database',0),(509653,14158,'is','',0),(509654,14158,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¨Ø± Ø§Ø³Ø§Ø³ ÙØ±Ø¯ ÙØ±ÙˆØ´',0),(509655,14158,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¨Ø± Ø§Ø³Ø§Ø³ ÙØ±Ø¯ ÙØ±ÙˆØ´',0),(509656,14158,'tr','SatÄ±ÅŸ elemanÄ± tarafÄ±ndan gÃ¶rÃ¼nÃ¼m',0),(509657,14158,'pl','Widok przez osobÄ™ sprzedaÅ¼y',0),(509658,14158,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ‡',0),(509659,14158,'ur','Ø³ÛŒÙ„Ø² Ø´Ø®Øµ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù†Ø¸Ø±',0),(509660,14158,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð¸ Ð¾ÑÐ¾Ð±Ð°',0),(509661,14158,'vi','Xem cá»§a ngÆ°á»i bÃ¡n hÃ ng',0),(509662,14158,'af','Bekyk deur verkope persoon',0),(509663,14158,'ro','Vezi de persoanÄƒ de vÃ¢nzÄƒri',0),(509664,14158,'et','Vaade mÃ¼Ã¼giesindaja kaupa',0),(509665,14158,'si','Pogled z pultom',0),(509666,14158,'ba','Lihat orang penjualan',0),(509667,14158,'nl','Bekijken op verkoper',0),(509668,14158,'fi','NÃ¤ytÃ¤ myyjÃ¤',0),(509669,14158,'no','Vis etter selger',0),(509670,14158,'da','Visning af sÃ¦lger',0),(509671,14158,'ko','íŒë§¤ ì‚¬ëžŒì— ì˜í•´ ë³´ê¸°',0),(509672,14158,'he','×ª×¦×•×’×” ×œ×¤×™ ××™×© ×ž×›×™×¨×•×ª',0),(509673,14158,'el','Î˜Î­Î± Î±Ï€ÏŒ Ï„Î¿ Ï€ÏÏŒÏƒÏ‰Ï€Î¿ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(509674,14158,'zh','æŒ‰é”€å”®äººå‘˜æŸ¥çœ‹',0),(509675,14158,'sv','Visa efter fÃ¶rsÃ¤ljare',0),(509676,14158,'it','Vista di persona di vendite',0),(509677,14158,'tl','',0),(509678,14158,'th','à¸”à¸¹à¸•à¸²à¸¡à¸„à¸™à¸‚à¸²à¸¢',0),(509679,14158,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤µà¥à¤¯à¤•à¥à¤¤à¤¿ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(509680,14158,'ms','Paparan Ikut orang jualan',0),(509681,14158,'ar','Ø¹Ø±Ø¶ Ø­Ø³Ø¨ Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(509682,14158,'fr','Vue par le vendeur',0),(509683,14158,'jp','å–¶æ¥­æ‹…å½“è€…åˆ¥ã«è¡¨ç¤º',0),(509684,14158,'pt','Vista por uma pessoa de vendas',0),(509685,14158,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð¿Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°Ð¼',0),(509686,14158,'es','Vista por persona de las ventas',0),(509687,14158,'de','Ansicht von VerkÃ¤ufer',0),(509688,14158,'en','View By Sales Person',0),(509689,14159,'is','',0),(509690,14159,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ù…Ø´ØªØ±ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(509691,14159,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ù…Ø´ØªØ±ÛŒ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(509692,14159,'tr','E-posta mÃ¼ÅŸteri seÃ§melisiniz',0),(509693,14159,'pl','NaleÅ¼y wybraÄ‡ klienta E-mail',0),(509694,14159,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð·Ð° ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ð¿Ð¾Ñ‰Ð°',0),(509695,14159,'ur','Ø¢Ù¾ Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ú¯Ø§ÛÚ© Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(509696,14159,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð° Ðµ-Ð¿Ð¾ÑˆÑ‚Ð¸',0),(509697,14159,'vi','Báº¡n pháº£i chá»n má»™t khÃ¡ch hÃ ng email',0),(509698,14159,'af','Jy moet \'n kliÃ«nt om te e-pos kies',0),(509699,14159,'ro','Trebuie sÄƒ selectaÅ£i un client email',0),(509700,14159,'et','Valige e-posti klient',0),(509701,14159,'si','Izbrati morate stranko na Email',0),(509702,14159,'ba','Anda harus memilih pelanggan ke Email',0),(509703,14159,'nl','U moet een klant E-mail selecteren',0),(509704,14159,'fi','Sinun on valittava asiakas sÃ¤hkÃ¶posti',0),(509705,14159,'no','Du mÃ¥ velge en kunde e-post',0),(509706,14159,'da','Du skal vÃ¦lge en kunde til E-mail',0),(509707,14159,'ko','ì´ë©”ì¼ ê³ ê°ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(509708,14159,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×œ×§×•×— ×”×“×•×',0),(509709,14159,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î±Î½ Ï€ÎµÎ»Î¬Ï„Î· ÏƒÏ„Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(509710,14159,'zh','æ‚¨å¿…é¡»é€‰æ‹©å®¢æˆ·çš„ç”µå­é‚®ä»¶',0),(509711,14159,'sv','Du mÃ¥ste vÃ¤lja en kund till e-post',0),(509712,14159,'it','Ãˆ necessario selezionare un cliente di E-mail',0),(509713,14159,'tl','',0),(509714,14159,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸¥à¸¹à¸à¸„à¹‰à¸²à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(509715,14159,'hi','à¤†à¤ªà¤•à¥‹ à¤ˆà¤®à¥‡à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(509716,14159,'ms','Anda mesti memilih pelanggan untuk e-mel',0),(509717,14159,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ­Ø¯ÙŠØ¯ Ø£Ø­Ø¯ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù„Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(509718,14159,'fr','Vous devez sÃ©lectionner un client de courriel',0),(509719,14159,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«ã«é¡§å®¢ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(509720,14159,'pt','VocÃª deve selecionar um cliente de E-mail',0),(509721,14159,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(509722,14159,'es','Debe seleccionar a un cliente de correo electrÃ³nico',0),(509723,14159,'de','Sie mÃ¼ssen ein Kunde E-Mail auswÃ¤hlen.',0),(509724,14159,'en','You Must Select A Customer To Email',0),(509725,14160,'is','',0),(509726,14160,'dr','Ø³Ø§Ø®Øª &amp; Ù…Ù† Ù…Ø­ØµÙˆÙ„Ø§Øª Ù¾Ùˆ',0),(509727,14160,'pr','Ø³Ø§Ø®Øª &amp; Ù…Ù† Ù…Ø­ØµÙˆÙ„Ø§Øª Ù¾Ùˆ',0),(509728,14160,'tr','Make A & ben Ã¼rÃ¼nleri PO',0),(509729,14160,'pl','Marka & I produkty PO',0),(509730,14160,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ & I Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸ PO',0),(509731,14160,'ur','Ø¨Ù†Ø§Ø¦ÛŒÚº Ø§ÛŒÚ© & Ù…ÛŒÚº Ù…ØµÙ†ÙˆØ¹Ø§Øª Ù¾Ùˆ',0),(509732,14160,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ð & ÑÐ°Ð¼ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸ ÐŸÐž',0),(509733,14160,'vi','Make A &amp; tÃ´i sáº£n pháº©m PO',0),(509734,14160,'af','Maak \'n & ek produkte PO',0),(509735,14160,'ro','Face un & am produse PO',0),(509736,14160,'et','Make A & I toodete PO',0),(509737,14160,'si','Make A & I proizvodi PO',0),(509738,14160,'ba','Membuat & saya produk PO',0),(509739,14160,'nl','Make A & I producten PO',0),(509740,14160,'fi','Tee & olen tuotteiden PO',0),(509741,14160,'no','Make A & jeg produkter PO',0),(509742,14160,'da','Make A & jeg produkter PO',0),(509743,14160,'ko','ë§Œë“¤ê¸° & ë‚˜ ì œí’ˆ í¬',0),(509744,14160,'he','×œ×¢×©×•×ª ××™×© & ×× ×™ ×ž×•×¦×¨×™× ×¤×•',0),(509745,14160,'el','ÎšÎ¬Î½ÎµÎ¹ Î­Î½Î±Î½ & ÎµÎ³ÏŽ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î± PO',0),(509746,14160,'zh','è®¸äº†ä¸€ä¸ª &amp; äº§å“å®',0),(509747,14160,'sv','GÃ¶r en & jag produkter PO',0),(509748,14160,'it','Fare A & I prodotti PO',0),(509749,14160,'tl','',0),(509750,14160,'th','à¸—à¸³à¹ƒà¸«à¹‰ A & à¸‰à¸±à¸™à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œ PO',0),(509751,14160,'hi','à¤à¤• & à¤®à¥ˆà¤‚ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¥‹à¤‚ à¤ªà¥‹',0),(509752,14160,'ms','Make A & saya produk PO',0),(509753,14160,'ar','Ø¬Ø¹Ù„ Ø¬Ù‡Ø§Ø² Ø¢Ù†Ø¯ Ø£Ù†Ø§ Ù…Ù†ØªØ¬Ø§Øª Ø¨Ùˆ',0),(509754,14160,'fr','Make A & j\'ai produits PO',0),(509755,14160,'jp','Make A & ç§ã¯ PO ã®è£½å“',0),(509756,14160,'pt','Fazer A & eu produtos PO',0),(509757,14160,'ru','Make A & Ñ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ñ‹ PO',0),(509758,14160,'es','Hacer un &amp; me productos PO',0),(509759,14160,'de','Make A & I Produkte PO',0),(509760,14160,'en','Make A&I Products PO',0),(509761,14161,'is','',0),(509762,14161,'dr','Ø´Ø±ÙˆØ¹ ØµÙ†Ø¯ÙˆÙ‚',0),(509763,14161,'pr','Ø´Ø±ÙˆØ¹ ØµÙ†Ø¯ÙˆÙ‚',0),(509764,14161,'tr','BaÅŸlangÄ±Ã§ A PO',0),(509765,14161,'pl','RozpoczÄ…Ä‡ PO',0),(509766,14161,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ PO',0),(509767,14161,'ur','Ø§ÛŒÚ© Ù¾Ùˆ Ø´Ø±ÙˆØ¹ Ú©Ø±ÛŒÚº',0),(509768,14161,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸Ñ‚Ðµ ÐŸÐžÐ•Ð',0),(509769,14161,'vi','Báº¯t Ä‘áº§u má»™t PO',0),(509770,14161,'af','Begin \'n PO',0),(509771,14161,'ro','ÃŽncepe O PO',0),(509772,14161,'et','Start A PO',0),(509773,14161,'si','Start A PO',0),(509774,14161,'ba','Mulai PO',0),(509775,14161,'nl','Start A PO',0),(509776,14161,'fi','Aloittaa PO',0),(509777,14161,'no','Starte en PO',0),(509778,14161,'da','Starte en PO',0),(509779,14161,'ko','POë¥¼ ì‹œìž‘',0),(509780,14161,'he','×”×ª×—×œ×” ×©×œ ×¤×•',0),(509781,14161,'el','ÎžÎµÎºÎ¹Î½Î®ÏƒÏ„Îµ PO',0),(509782,14161,'zh','å¼€å§‹æ—¶é—´ A å®',0),(509783,14161,'sv','Starta en PO',0),(509784,14161,'it','Avviare un PO',0),(509785,14161,'tl','',0),(509786,14161,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™ PO',0),(509787,14161,'hi','à¤¶à¥à¤°à¥‚ à¤®à¥‡à¤‚ à¤à¤• PO',0),(509788,14161,'ms','Mula PO yang',0),(509789,14161,'ar','Øµ. Ø¨Ø§Ø¨Ø¯Ø§.',0),(509790,14161,'fr','DÃ©marrer un PO',0),(509791,14161,'jp','PO ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(509792,14161,'pt','ComeÃ§ar um PO',0),(509793,14161,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ PO',0),(509794,14161,'es','Iniciar una PO',0),(509795,14161,'de','Start A PO',0),(509796,14161,'en','Start A PO',0),(509797,14162,'is','',0),(509798,14162,'dr','Ø¯Ø±Ø¢Ù…Ø¯ Ø§Ø¶Ø§ÙÛŒ',0),(509799,14162,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ø§Ø¶Ø§ÙÛŒ',0),(509800,14162,'tr','AÅŸÄ±rÄ± kazanÃ§',0),(509801,14162,'pl','Nadmiar zarobki',0),(509802,14162,'bg','Ð¡Ð²Ñ€ÑŠÑ… Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(509803,14162,'ur','Ø§Ø¶Ø§ÙÛŒ Ø¢Ù…Ø¯Ù†ÛŒ',0),(509804,14162,'sr','Ð’Ð¸ÑˆÐ°Ðº Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(509805,14162,'vi','CÃ¡c khoáº£n thu nháº­p dÆ° thá»«a',0),(509806,14162,'af','Oortollige verdienste',0),(509807,14162,'ro','CÃ¢ÅŸtigurile de exces',0),(509808,14162,'et','Liigse kasumi',0),(509809,14162,'si','PreseÅ¾ek prihodkov',0),(509810,14162,'ba','Kelebihan penghasilan',0),(509811,14162,'nl','Overtollige inkomsten',0),(509812,14162,'fi','YlimÃ¤Ã¤rÃ¤inen tulos',0),(509813,14162,'no','OverflÃ¸dig inntekter',0),(509814,14162,'da','Overskydende indtjening',0),(509815,14162,'ko','ì´ˆê³¼ ìˆ˜ìž…',0),(509816,14162,'he','×”×¨×•×•×—×™× ×”×¢×•×“×¤×™×',0),(509817,14162,'el','Î ÎµÏÎ¯ÏƒÏƒÎµÎ¹Î± ÎºÎ­ÏÎ´Î·',0),(509818,14162,'zh','è¶…é¢æ”¶ç›Š',0),(509819,14162,'sv','Ã–verskjutande inkomster',0),(509820,14162,'it','Guadagni in eccesso',0),(509821,14162,'tl','',0),(509822,14162,'th','à¸à¸³à¹„à¸£à¸ªà¹ˆà¸§à¸™à¹€à¸à¸´à¸™',0),(509823,14162,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤†à¤¯',0),(509824,14162,'ms','Lebihan pendapatan',0),(509825,14162,'ar','Ø§Ù„Ø£Ø±Ø¨Ø§Ø­ Ø§Ù„Ø²Ø§Ø¦Ø¯Ø©',0),(509826,14162,'fr','Gains excÃ©dentaires',0),(509827,14162,'jp','ä½™åˆ†ãªåˆ©ç›Š',0),(509828,14162,'pt','Ganhos em excesso',0),(509829,14162,'ru','Ð˜Ð·Ð±Ñ‹Ñ‚Ð¾Ðº Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð²',0),(509830,14162,'es','Excesiva ganancias',0),(509831,14162,'de','Excess Earnings',0),(509832,14162,'en','Excess Earnings',0),(509833,14163,'is','',0),(509834,14163,'dr','FUTA',0),(509835,14163,'pr','FUTA',0),(509836,14163,'tr','FUTA',0),(509837,14163,'pl','FUTA',0),(509838,14163,'bg','Ð¡ÐÐœÐ£Ð˜Ð›',0),(509839,14163,'ur','ÙØª',0),(509840,14163,'sr','Ð¤Ð£Ð¢Ð',0),(509841,14163,'vi','FUTA',0),(509842,14163,'af','FUTA',0),(509843,14163,'ro','DANY',0),(509844,14163,'et','FUTA',0),(509845,14163,'si','FUTA',0),(509846,14163,'ba','FUTA',0),(509847,14163,'nl','FUTA',0),(509848,14163,'fi','FUTA',0),(509849,14163,'no','FUTA',0),(509850,14163,'da','FUTA',0),(509851,14163,'ko','ë§Œë£Œì¼',0),(509852,14163,'he','×¤×•×˜×”',0),(509853,14163,'el','FUTA',0),(509854,14163,'zh','å¯Œå¡”',0),(509855,14163,'sv','FUTA',0),(509856,14163,'it','FUTA',0),(509857,14163,'tl','',0),(509858,14163,'th','FUTA',0),(509859,14163,'hi','FUTA',0),(509860,14163,'ms','FUTA',0),(509861,14163,'ar','ÙÙˆØªØ§',0),(509862,14163,'fr','FUTA',0),(509863,14163,'jp','ãƒ•ã‚¿ãƒŠãƒªå¯¾å¥³',0),(509864,14163,'pt','FUTA',0),(509865,14163,'ru','Ð¤Ð£Ð¢Ð',0),(509866,14163,'es','FUTA',0),(509867,14163,'de','FUTA',0),(509868,14163,'en','FUTA',0),(509869,14164,'is','',0),(509870,14164,'dr','Ú¯Ø²Ø§Ø±Ø´ FUTA',0),(509871,14164,'pr','Ú¯Ø²Ø§Ø±Ø´ FUTA',0),(509872,14164,'tr','FUTA raporu',0),(509873,14164,'pl','Raport FUTA',0),(509874,14164,'bg','Ð¡ÐÐœÐ£Ð˜Ð› Ð´Ð¾ÐºÐ»Ð°Ð´',0),(509875,14164,'ur','ÙØª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(509876,14164,'sr','Ð¤Ð£Ð¢Ð Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(509877,14164,'vi','FUTA bÃ¡o cÃ¡o',0),(509878,14164,'af','FUTA verslag',0),(509879,14164,'ro','FUTA raport',0),(509880,14164,'et','FUTA aruanne',0),(509881,14164,'si','PoroÄilo FUTA',0),(509882,14164,'ba','FUTA laporan',0),(509883,14164,'nl','FUTA verslag',0),(509884,14164,'fi','FUTA raportti',0),(509885,14164,'no','FUTA rapport',0),(509886,14164,'da','FUTA rapport',0),(509887,14164,'ko','ë§Œë£Œì¼ ë³´ê³ ì„œ',0),(509888,14164,'he','×“×•×— ×¤×•×˜×”',0),(509889,14164,'el','ÎˆÎºÎ¸ÎµÏƒÎ· FUTA',0),(509890,14164,'zh','å¯Œå¡”æŠ¥å‘Š',0),(509891,14164,'sv','FUTA rapport',0),(509892,14164,'it','Relazione FUTA',0),(509893,14164,'tl','',0),(509894,14164,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™ FUTA',0),(509895,14164,'hi','FUTA à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(509896,14164,'ms','Laporan FUTA',0),(509897,14164,'ar','ØªÙ‚Ø±ÙŠØ± ÙÙˆØªØ§',0),(509898,14164,'fr','Rapport FUTA',0),(509899,14164,'jp','ãƒ•ã‚¿ãƒŠãƒªå¯¾ãƒ•ã‚¿ãƒŠãƒª ãƒ¬ãƒãƒ¼ãƒˆ',0),(509900,14164,'pt','RelatÃ³rio FUTA',0),(509901,14164,'ru','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð¤Ð£Ð¢Ð',0),(509902,14164,'es','Informe FUTA',0),(509903,14164,'de','FUTA-Bericht',0),(509904,14164,'en','FUTA Report',0),(509905,14165,'is','',0),(509906,14165,'dr','Ù…Ø§Ù„ÛŒØ§Øª FUTA',0),(509907,14165,'pr','Ù…Ø§Ù„ÛŒØ§Øª FUTA',0),(509908,14165,'tr','FUTA vergi',0),(509909,14165,'pl','FUTA podatku',0),(509910,14165,'bg','Ð¡ÐÐœÐ£Ð˜Ð› Ð´Ð°Ð½ÑŠÐº',0),(509911,14165,'ur','ÙØª Ù¹ÛŒÚ©Ø³',0),(509912,14165,'sr','Ð¤Ð£Ð¢Ð Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(509913,14165,'vi','FUTA thuáº¿',0),(509914,14165,'af','FUTA belasting',0),(509915,14165,'ro','FUTA fiscale',0),(509916,14165,'et','FUTA maksu',0),(509917,14165,'si','FUTA davka',0),(509918,14165,'ba','FUTA pajak',0),(509919,14165,'nl','FUTA belasting',0),(509920,14165,'fi','FUTA vero',0),(509921,14165,'no','FUTA skatt',0),(509922,14165,'da','FUTA skat',0),(509923,14165,'ko','ë§Œë£Œì¼ ì„¸ê¸ˆ',0),(509924,14165,'he','×ž×¡ ×¤×•×˜×”',0),(509925,14165,'el','Î¦ÏŒÏÎ¿Ï… FUTA',0),(509926,14165,'zh','å¯Œå¤šç¨Ž',0),(509927,14165,'sv','FUTA skatt',0),(509928,14165,'it','FUTA fiscale',0),(509929,14165,'tl','',0),(509930,14165,'th','à¸ à¸²à¸©à¸µ FUTA',0),(509931,14165,'hi','FUTA à¤•à¤°',0),(509932,14165,'ms','Cukai FUTA',0),(509933,14165,'ar','Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ© ÙÙŠ ÙÙˆØªØ§',0),(509934,14165,'fr','Taxe FUTA',0),(509935,14165,'jp','ãƒ•ã‚¿ãƒŠãƒªå¯¾ãƒ•ã‚¿ãƒŠãƒªç¨Ž',0),(509936,14165,'pt','Imposto FUTA',0),(509937,14165,'ru','ÐÐ°Ð»Ð¾Ð³ Ð¤Ð£Ð¢Ð',0),(509938,14165,'es','Impuesto FUTA',0),(509939,14165,'de','FUTA Steuern',0),(509940,14165,'en','FUTA Tax',0),(509941,14166,'is','',0),(509942,14166,'dr','Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(509943,14166,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(509944,14166,'tr','Vergiye tabi kazanÃ§',0),(509945,14166,'pl','Opodatkowania dochodÃ³w',0),(509946,14166,'bg','ÐžÐ±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ‚Ð° Ð¿ÐµÑ‡Ð°Ð»Ð±Ð°',0),(509947,14166,'ur','Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ Ø¢Ù…Ø¯Ù†ÛŒ',0),(509948,14166,'sr','ÐžÐ¿Ð¾Ñ€ÐµÐ·Ð¸Ð² Ð·Ð°Ñ€Ð°Ð´Ðµ',0),(509949,14166,'vi','CÃ¡c khoáº£n thu nháº­p chá»‹u thuáº¿',0),(509950,14166,'af','Belasbare verdienste',0),(509951,14166,'ro','Venitul impozabil',0),(509952,14166,'et','Maksustatav tulu',0),(509953,14166,'si','ObdavÄljivi dohodki',0),(509954,14166,'ba','Penghasilan kena pajak',0),(509955,14166,'nl','Belastbare winst',0),(509956,14166,'fi','Veron tulos',0),(509957,14166,'no','Skattepliktig inntekter',0),(509958,14166,'da','Skattepligtig indtjening',0),(509959,14166,'ko','ê³¼ì„¸ ìˆ˜ìž…',0),(509960,14166,'he','×”×›× ×¡×•×ª ×—×™×™×‘×•×ª ×‘×ž×¡',0),(509961,14166,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­Î± ÎºÎ­ÏÎ´Î·',0),(509962,14166,'zh','åº”çº³ç¨Žæ”¶å…¥',0),(509963,14166,'sv','Skattepliktiga inkomster',0),(509964,14166,'it','Guadagni passivi',0),(509965,14166,'tl','',0),(509966,14166,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µ',0),(509967,14166,'hi','à¤•à¤° à¤¯à¥‹à¤—à¥ à¤¯ à¤†à¤¯',0),(509968,14166,'ms','Pendapatan yang boleh dikenakan cukai',0),(509969,14166,'ar','Ø§Ù„Ø¯Ø®Ù„ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(509970,14166,'fr','BÃ©nÃ©fice imposable',0),(509971,14166,'jp','èª²ç¨Žå¯¾è±¡åŽç›Š',0),(509972,14166,'pt','Lucro tributÃ¡vel',0),(509973,14166,'ru','ÐžÐ±Ð»Ð°Ð³Ð°ÐµÐ¼Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼ Ð´Ð¾Ñ…Ð¾Ð´',0),(509974,14166,'es','Ganancias gravables',0),(509975,14166,'de','Zu versteuerndes Ergebnis',0),(509976,14166,'en','Taxable Earnings',0),(509977,14167,'is','',0),(509978,14167,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø³ØªÙ…Ø²Ø¯',0),(509979,14167,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø³ØªÙ…Ø²Ø¯',0),(509980,14167,'tr','Ã–denen Ã¼cretler',0),(509981,14167,'pl','PÅ‚ace',0),(509982,14167,'bg','Ð’ÑŠÐ·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ñ, Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸',0),(509983,14167,'ur','Ø§Ø¬Ø±Øª Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(509984,14167,'sr','ÐŸÐ»Ð°Ñ‚Ð°Ð¼Ð°',0),(509985,14167,'vi','Tiá»n lÆ°Æ¡ng tráº£ tiá»n',0),(509986,14167,'af','Lone betaal',0),(509987,14167,'ro','Salariile plÄƒtite',0),(509988,14167,'et','Makstav',0),(509989,14167,'si','PlaÄe',0),(509990,14167,'ba','Upah yang dibayar',0),(509991,14167,'nl','Lonen betaald',0),(509992,14167,'fi','Maksettujen palkkojen',0),(509993,14167,'no','LÃ¸nn',0),(509994,14167,'da','LÃ¸n udbetalt',0),(509995,14167,'ko','ìž„ê¸ˆ ì§€ê¸‰',0),(509996,14167,'he','×”×©×›×¨ ×”×ž×©×•×œ×',0),(509997,14167,'el','ÎœÎ¹ÏƒÎ¸Î¿ÏÏ‚ Ï„Ï‰Î½',0),(509998,14167,'zh','å·¥èµ„',0),(509999,14167,'sv','LÃ¶nerna betalas',0),(510000,14167,'it','Stipendi pagati',0),(510001,14167,'tl','',0),(510002,14167,'th','à¸Šà¸³à¸£à¸°à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(510003,14167,'hi','à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(510004,14167,'ms','Upah yang dibayar',0),(510005,14167,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(510006,14167,'fr','Salaires versÃ©s',0),(510007,14167,'jp','æ”¯æ‰•ã‚ã‚Œã‚‹è³ƒé‡‘',0),(510008,14167,'pt','SalÃ¡rios pagos',0),(510009,14167,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(510010,14167,'es','Salarios pagados',0),(510011,14167,'de','LÃ¶hne',0),(510012,14167,'en','Wages Paid',0),(510013,14168,'is','',0),(510014,14168,'dr','SUTA',0),(510015,14168,'pr','SUTA',0),(510016,14168,'tr','SUTA',0),(510017,14168,'pl','SUTA',0),(510018,14168,'bg','SUTA',0),(510019,14168,'ur','Ø³Øª',0),(510020,14168,'sr','Ð¡Ð£Ð¢Ð',0),(510021,14168,'vi','SUTA',0),(510022,14168,'af','SUTA',0),(510023,14168,'ro','SUTA',0),(510024,14168,'et','SUTA',0),(510025,14168,'si','SUTA',0),(510026,14168,'ba','SUTA',0),(510027,14168,'nl','SUTA',0),(510028,14168,'fi','SUTA',0),(510029,14168,'no','SUTA',0),(510030,14168,'da','SUTA',0),(510031,14168,'ko','SUTA',0),(510032,14168,'he','SUTA',0),(510033,14168,'el','SUTA',0),(510034,14168,'zh','SUTA',0),(510035,14168,'sv','SUTA',0),(510036,14168,'it','SUTA',0),(510037,14168,'tl','',0),(510038,14168,'th','SUTA',0),(510039,14168,'hi','SUTA',0),(510040,14168,'ms','SUTA',0),(510041,14168,'ar','Ø³ÙˆØªØ§',0),(510042,14168,'fr','SUTA',0),(510043,14168,'jp','ã‚¹ã‚¿',0),(510044,14168,'pt','SUTA',0),(510045,14168,'ru','Ð¡Ð£Ð¢Ð',0),(510046,14168,'es','SUTA',0),(510047,14168,'de','SUTA',0),(510048,14168,'en','SUTA',0),(510049,14169,'is','',0),(510050,14169,'dr','Ú¯Ø²Ø§Ø±Ø´ SUTA',0),(510051,14169,'pr','Ú¯Ø²Ø§Ø±Ø´ SUTA',0),(510052,14169,'tr','SUTA raporu',0),(510053,14169,'pl','Raport SUTA',0),(510054,14169,'bg','SUTA Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(510055,14169,'ur','Ø³Øª Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(510056,14169,'sr','Ð¡Ð£Ð¢Ð Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(510057,14169,'vi','SUTA bÃ¡o cÃ¡o',0),(510058,14169,'af','SUTA verslag',0),(510059,14169,'ro','SUTA raport',0),(510060,14169,'et','SUTA aruanne',0),(510061,14169,'si','SUTA poroÄilo',0),(510062,14169,'ba','SUTA laporan',0),(510063,14169,'nl','SUTA verslag',0),(510064,14169,'fi','SUTA raportti',0),(510065,14169,'no','SUTA rapport',0),(510066,14169,'da','SUTA betÃ¦nkning',0),(510067,14169,'ko','SUTA ë³´ê³ ì„œ',0),(510068,14169,'he','SUTA ×—',0),(510069,14169,'el','ÎˆÎºÎ¸ÎµÏƒÎ· SUTA',0),(510070,14169,'zh','SUTA æŠ¥å‘Š',0),(510071,14169,'sv','SUTA rapport',0),(510072,14169,'it','SUTA relazione',0),(510073,14169,'tl','',0),(510074,14169,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™ SUTA',0),(510075,14169,'hi','SUTA à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(510076,14169,'ms','SUTA Laporan',0),(510077,14169,'ar','ØªÙ‚Ø±ÙŠØ± Ø³ÙˆØªØ§',0),(510078,14169,'fr','Rapport SUTA',0),(510079,14169,'jp','ã‚¹ã‚¿ ãƒ¬ãƒãƒ¼ãƒˆ',0),(510080,14169,'pt','RelatÃ³rio SUTA',0),(510081,14169,'ru','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð¡ÑƒÑ‚Ð°',0),(510082,14169,'es','Informe SUTA',0),(510083,14169,'de','SUTA-Bericht',0),(510084,14169,'en','SUTA Report',0),(510085,14170,'is','',0),(510086,14170,'dr','Ù…Ø§Ù„ÛŒØ§Øª SUTA',0),(510087,14170,'pr','Ù…Ø§Ù„ÛŒØ§Øª SUTA',0),(510088,14170,'tr','SUTA vergi',0),(510089,14170,'pl','SUTA podatku',0),(510090,14170,'bg','SUTA Ð´Ð°Ð½ÑŠÐº',0),(510091,14170,'ur','Ø³Øª Ù¹ÛŒÚ©Ø³',0),(510092,14170,'sr','Ð¡Ð£Ð¢Ð Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(510093,14170,'vi','SUTA thuáº¿',0),(510094,14170,'af','SUTA belasting',0),(510095,14170,'ro','SUTA fiscale',0),(510096,14170,'et','SUTA maksu',0),(510097,14170,'si','SUTA davka',0),(510098,14170,'ba','SUTA pajak',0),(510099,14170,'nl','SUTA belasting',0),(510100,14170,'fi','SUTA vero',0),(510101,14170,'no','SUTA skatt',0),(510102,14170,'da','SUTA skat',0),(510103,14170,'ko','SUTA ì„¸ê¸ˆ',0),(510104,14170,'he','SUTA ×ž×¡',0),(510105,14170,'el','Î¦ÏŒÏÎ¿Ï… SUTA',0),(510106,14170,'zh','SUTA ç¨Ž',0),(510107,14170,'sv','SUTA skatt',0),(510108,14170,'it','SUTA fiscale',0),(510109,14170,'tl','',0),(510110,14170,'th','à¸ à¸²à¸©à¸µ SUTA',0),(510111,14170,'hi','SUTA à¤Ÿà¥ˆà¤•à¥à¤¸',0),(510112,14170,'ms','SUTA cukai',0),(510113,14170,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø³ÙˆØªØ§',0),(510114,14170,'fr','Taxe SUTA',0),(510115,14170,'jp','ã‚¹ã‚¿ç¨Ž',0),(510116,14170,'pt','SUTA imposto',0),(510117,14170,'ru','ÐÐ°Ð»Ð¾Ð³ Ð¡ÑƒÑ‚Ð°',0),(510118,14170,'es','Impuesto de SUTA',0),(510119,14170,'de','SUTA Steuer',0),(510120,14170,'en','SUTA Tax',0),(510121,14171,'is','',0),(510122,14171,'dr','Ø­Ø¯Ø§Ù‚Ù„ ÙØ±ÙˆØ´',0),(510123,14171,'pr','Ø­Ø¯Ø§Ù‚Ù„ ÙØ±ÙˆØ´',0),(510124,14171,'tr','Asgari satÄ±ÅŸ',0),(510125,14171,'pl','Minimalnej sprzedaÅ¼y',0),(510126,14171,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(510127,14171,'ur','Ú©Ù… Ø§Ø² Ú©Ù… ÙØ±ÙˆØ®Øª',0),(510128,14171,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð°',0),(510129,14171,'vi','BÃ¡n hÃ ng tá»‘i thiá»ƒu',0),(510130,14171,'af','Minimum verkope',0),(510131,14171,'ro','Prag minim',0),(510132,14171,'et','Minimaalne mÃ¼Ã¼k',0),(510133,14171,'si','Minimalno prodaje',0),(510134,14171,'ba','Minimal penjualan',0),(510135,14171,'nl','Minimale verkoop',0),(510136,14171,'fi','Myynti',0),(510137,14171,'no','Minst salg',0),(510138,14171,'da','Minimum salg',0),(510139,14171,'ko','ìµœì†Œ íŒë§¤',0),(510140,14171,'he','×ž×›×™×¨×•×ª ×ž×™× ×™×ž×œ×™',0),(510141,14171,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚',0),(510142,14171,'zh','æœ€ä½Žé”€å”®é¢',0),(510143,14171,'sv','Minsta fÃ¶rsÃ¤ljning',0),(510144,14171,'it','Vendite minime',0),(510145,14171,'tl','',0),(510146,14171,'th','à¸‚à¸²à¸¢à¸‚à¸±à¹‰à¸™à¸•à¹ˆà¸³',0),(510147,14171,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤¬à¤¿à¤•à¥à¤°à¥€',0),(510148,14171,'ms','Jualan minimum',0),(510149,14171,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(510150,14171,'fr','Vente minimum',0),(510151,14171,'jp','æœ€å°ã®è²©å£²',0),(510152,14171,'pt','Vendas mÃ­nimas',0),(510153,14171,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð°',0),(510154,14171,'es','Ventas mÃ­nimas',0),(510155,14171,'de','Mindestumsatz',0),(510156,14171,'en','Minimum Sales',0),(510157,14172,'is','',0),(510158,14172,'dr','Ø®Ø§Ù„Øµ Ø¹Ù„Øª ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† Ù…Ø§Ù‡ Ø¨Ù‡ Ù‡Ù…Ø±Ø§Ù‡',0),(510159,14172,'pr','Ø®Ø§Ù„Øµ Ø¹Ù„Øª ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† Ù…Ø§Ù‡ Ø¨Ù‡ Ù‡Ù…Ø±Ø§Ù‡',0),(510160,14172,'tr','Ay sonu tarihi nedeniyle net artÄ±',0),(510161,14172,'pl','Netto naleÅ¼ne Data koÅ„ca miesiÄ…ca Plus',0),(510162,14172,'bg','ÐÐµÑ‚Ð¾ Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð° ÐºÑ€Ð°Ð¹ Ð½Ð° Ð¼ÐµÑÐµÑ† Ð¿Ð»ÑŽÑ',0),(510163,14172,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ù…ÛÛŒÙ†Û Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ø®Ø§Ù„Øµ Ù¾Ù„Ø³',0),(510164,14172,'sr','ÐÐµÑ‚Ð¾ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ ÐºÑ€Ð°Ñ˜Ð° Ð¼ÐµÑÐµÑ†Ð° ÐŸÐ»ÑƒÑ',0),(510165,14172,'vi','Net do ngÃ y cuá»‘i cá»§a thÃ¡ng cá»™ng vá»›i',0),(510166,14172,'af','Netto verskuldigde datum einde van maand Plus',0),(510167,14172,'ro','NetÄƒ datoratÄƒ data sfÃ¢rÅŸitul luni Plus',0),(510168,14172,'et','Net tÃµttu kuu lÃµpu kuupÃ¤ev pluss',0),(510169,14172,'si','Neto zaradi datum konca meseca Plus',0),(510170,14172,'ba','Bersih karena tanggal akhir bulan ditambah',0),(510171,14172,'nl','Netto verschuldigde datum einde van de maand Plus',0),(510172,14172,'fi','NET koska kuukauden loppuun mennessÃ¤ sekÃ¤',0),(510173,14172,'no','Netto grunn dato slutten av mÃ¥neden pluss',0),(510174,14172,'da','Netto grund dato slutningen af mÃ¥neden Plus',0),(510175,14172,'ko','ë‹¬ì˜ ë‚ ì§œ ë ì¸ ìˆœ í”ŒëŸ¬ìŠ¤',0),(510176,14172,'he','× ×˜×• ×¢×§×‘ ×ª××¨×™×š ×¡×•×£ ×”×—×•×“×© ×¤×œ×•×¡',0),(510177,14172,'el','ÎšÎ±Î¸Î±ÏÏŒ Î»ÏŒÎ³Ï‰ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î¼Î®Î½Î± ÏƒÏ…Î½',0),(510178,14172,'zh','åˆ°æœŸæ—¥æœŸæœˆåº•å‡€é¢åŠ ä¸Š',0),(510179,14172,'sv','Net Due Date slutet av mÃ¥nad Plus',0),(510180,14172,'it','Netto dovuto data fine del mese, piÃ¹',0),(510181,14172,'tl','',0),(510182,14172,'th','à¸ªà¸¸à¸—à¸˜à¸´à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸ªà¸´à¹‰à¸™à¹€à¸”à¸·à¸­à¸™à¸§à¸±à¸™ à¸žà¸£à¹‰à¸­à¸¡',0),(510183,14172,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤…à¤‚à¤¤ à¤®à¥‡à¤‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¨à¤¿à¤¯à¤¤ à¤¨à¥‡à¤Ÿ à¤ªà¥à¤²à¤¸',0),(510184,14172,'ms','Bersih kerana tarikh akhir bulan Plus',0),(510185,14172,'ar','ØµØ§ÙÙŠ Ø§Ù„Ù…Ø³ØªØ­Ù‚ ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø´Ù‡Ø± Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰',0),(510186,14172,'fr','NET Due Date de la fin du mois Plus',0),(510187,14172,'jp','æœˆæœ«æ—¥ã¾ã§äºˆå®šãƒãƒƒãƒˆ ãƒ—ãƒ©ã‚¹',0),(510188,14172,'pt','NET Data fim de mÃªs e mais',0),(510189,14172,'ru','NET Ð¸Ð·-Ð·Ð° Ð´Ð°Ñ‚Ñ‹ ÐºÐ¾Ð½Ñ†Ð° Ð¼ÐµÑÑÑ†Ð° Ð¿Ð»ÑŽÑ',0),(510190,14172,'es','Neta debida fecha final de mes Plus',0),(510191,14172,'de','Due Date Ende des Monats netto Plus',0),(510192,14172,'en','Net Due Date End Of Month Plus',0),(510193,14173,'is','',0),(510194,14173,'dr','Ø§Ø² Ø³Ø§Ø¹Øª Ú©Ø§Ø± Ù…ÛŒ Ú©Ø±Ø¯',0),(510195,14173,'pr','Ø§Ø² Ø³Ø§Ø¹Øª Ú©Ø§Ø± Ù…ÛŒ Ú©Ø±Ø¯',0),(510196,14173,'tr','Dan itibaren hariÃ§ Ã§alÄ±ÅŸtÄ±',0),(510197,14173,'pl','WykluczyÄ‡ z godziny pracowaÅ‚',0),(510198,14173,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð¸ Ð¾Ñ‚ Ñ‡Ð°ÑÐ° Ñ€Ð°Ð±Ð¾Ñ‚Ð¸',0),(510199,14173,'ur','Ú¯Ú¾Ù†Ù¹ÙˆÚº Ø³Û’ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº Ú©Ø§Ù… Ú©ÛŒØ§ Û”',0),(510200,14173,'sr','Ð˜ÑÐºÑ™ÑƒÑ‡Ð¸Ð²Ð°ÑšÐµ Ð¸Ð· ÑÐ°Ñ‚Ð° Ñ€Ð°Ð´Ð¸Ð¾',0),(510201,14173,'vi','Loáº¡i trá»« tá»« giá» lÃ m viá»‡c',0),(510202,14173,'af','Uitsluit van ure gewerk',0),(510203,14173,'ro','Excluderea de la ore a lucrat',0),(510204,14173,'et','Tundi vÃ¤lja tÃ¶Ã¶tanud',0),(510205,14173,'si','IzkljuÄi iz ur delali',0),(510206,14173,'ba','Mengecualikan dari jam bekerja',0),(510207,14173,'nl','Uitsluiten van uren gewerkt',0),(510208,14173,'fi','Ulkopuolelle tuntia tyÃ¶ntekijÃ¤',0),(510209,14173,'no','Utelate fra timer arbeidet',0),(510210,14173,'da','Udelukke fra timer arbejdede',0),(510211,14173,'ko','ì‹œê°„ì—ì„œ ì œì™¸ í–ˆìŠµë‹ˆë‹¤',0),(510212,14173,'he','××œ ×ª×›×œ×•×œ ×©×¢×•×ª ×¢×‘×“',0),(510213,14173,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¯ÏƒÎµÎ¹ Î±Ï€ÏŒ ÏŽÏÎµÏ‚ Î»ÎµÎ¹Ï„Î¿ÏÏÎ³Î·ÏƒÎµ',0),(510214,14173,'zh','ä»Žå°æ—¶æŽ’é™¤å·¥ä½œ',0),(510215,14173,'sv','Utesluta frÃ¥n timmar arbetade',0),(510216,14173,'it','Escludere dalle ore lavorato',0),(510217,14173,'tl','',0),(510218,14173,'th','à¹à¸¢à¸à¸ˆà¸²à¸à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¸—à¸³à¸‡à¸²à¸™',0),(510219,14173,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤¨à¤¿à¤•à¤¾à¤²à¤¨à¥‡ à¤•à¤¾à¤® à¤•à¤¿à¤¯à¤¾',0),(510220,14173,'ms','Dikecualikan daripada waktu bekerja',0),(510221,14173,'ar','Ø§Ø³ØªØ¨Ø¹Ø§Ø¯ Ù…Ù† Ø³Ø§Ø¹Ø§Øª Ø¹Ù…Ù„',0),(510222,14173,'fr','Exclure des heures travaillÃ©es',0),(510223,14173,'jp','æ™‚é–“ã‹ã‚‰é™¤å¤–åƒã„ãŸ',0),(510224,14173,'pt','Excluir de horas trabalhado',0),(510225,14173,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð¸Ð· Ñ‡Ð°ÑÐ¾Ð² Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð»',0),(510226,14173,'es','Excluir de horas trabajado',0),(510227,14173,'de','AusschlieÃŸen von Stunden gearbeitet',0),(510228,14173,'en','Exclude From Hours Worked',0),(510229,14174,'is','',0),(510230,14174,'dr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† 4',0),(510231,14174,'pr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† 4',0),(510232,14174,'tr','Son 4',0),(510233,14174,'pl','Ostatnie 4',0),(510234,14174,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ 4',0),(510235,14174,'ur','Ú¯Ø²Ø´ØªÛ 4',0),(510236,14174,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐµ 4',0),(510237,14174,'vi','4 cuá»‘i',0),(510238,14174,'af','Laaste 4',0),(510239,14174,'ro','Ultimele 4',0),(510240,14174,'et','Viimase 4',0),(510241,14174,'si','Zadnje 4',0),(510242,14174,'ba','Terakhir 4',0),(510243,14174,'nl','Laatste 4',0),(510244,14174,'fi','Viimeiset 4',0),(510245,14174,'no','4 siste',0),(510246,14174,'da','Sidste 4',0),(510247,14174,'ko','ë§ˆì§€ë§‰ 4',0),(510248,14174,'he','4 ×”××—×¨×•×Ÿ',0),(510249,14174,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± 4',0),(510250,14174,'zh','æœ€åŽ 4',0),(510251,14174,'sv','Senaste 4',0),(510252,14174,'it','Ultimi 4',0),(510253,14174,'tl','',0),(510254,14174,'th','4 à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(510255,14174,'hi','à¤ªà¤¿à¤›à¤²à¥‡ 4',0),(510256,14174,'ms','Lepas 4',0),(510257,14174,'ar','4 Ø§Ù„Ø£Ø®ÙŠØ±',0),(510258,14174,'fr','4 derniers',0),(510259,14174,'jp','æœ€å¾Œã® 4',0),(510260,14174,'pt','Ãšltimos 4',0),(510261,14174,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ 4',0),(510262,14174,'es','Ãšltimos 4',0),(510263,14174,'de','Letzten 4',0),(510264,14174,'en','Last 4',0),(510265,14175,'is','',0),(510266,14175,'dr','Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡',0),(510267,14175,'pr','Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡',0),(510268,14175,'tr','SaklÄ± kredi kartlarÄ±',0),(510269,14175,'pl','Przechowywane karty kredytowe',0),(510270,14175,'bg','Ð¡ÑŠÑ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ‚Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(510271,14175,'ur','Ø°Ø®ÛŒØ±Û Ø´Ø¯Û Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ',0),(510272,14175,'sr','Ð£ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚ÐµÐ½Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(510273,14175,'vi','LÆ°u trá»¯ tháº» tÃ­n dá»¥ng',0),(510274,14175,'af','Gestoorde kredietkaarte',0),(510275,14175,'ro','Carduri de Credit stocate',0),(510276,14175,'et','Salvestatud krediitkaardid',0),(510277,14175,'si','Shranjene kreditne kartice',0),(510278,14175,'ba','Kartu kredit disimpan',0),(510279,14175,'nl','Opgeslagen creditcards',0),(510280,14175,'fi','Tallennettu luottokortit',0),(510281,14175,'no','Lagrede kredittkort',0),(510282,14175,'da','Lagrede kreditkort',0),(510283,14175,'ko','ì €ìž¥ ëœ ì‹ ìš© ì¹´ë“œ',0),(510284,14175,'he','×›×¨×˜×™×¡×™ ××©×¨××™ ×ž××•×—×¡×Ÿ',0),(510285,14175,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏ…Î¼Î­Î½ÎµÏ‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(510286,14175,'zh','å­˜å‚¨çš„ä¿¡ç”¨å¡',0),(510287,14175,'sv','Lagrade kreditkort',0),(510288,14175,'it','Carte di credito memorizzati',0),(510289,14175,'tl','',0),(510290,14175,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¹„à¸§à¹‰',0),(510291,14175,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹à¤¿à¤¤ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡',0),(510292,14175,'ms','Kad-kad kredit yang disimpan',0),(510293,14175,'ar','Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ù…Ø®Ø²Ù†',0),(510294,14175,'fr','Cartes de crÃ©dit stockÃ©e',0),(510295,14175,'jp','ä¿å­˜æ¸ˆã¿ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰',0),(510296,14175,'pt','CartÃµes de crÃ©dito armazenados',0),(510297,14175,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(510298,14175,'es','Tarjetas de crÃ©dito almacenada',0),(510299,14175,'de','Gespeicherte Kreditkarten',0),(510300,14175,'en','Stored Credit Cards',0),(510301,14176,'is','',0),(510302,14176,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø³Ø®Ù‡ Ù…ØªÙ†ÛŒ Ù¾Ùˆ Ù†Ø´Ø§Ù† Ù†Ù…ÛŒ Ø¯Ù‡Ø¯',0),(510303,14176,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø³Ø®Ù‡ Ù…ØªÙ†ÛŒ Ù¾Ùˆ Ù†Ø´Ø§Ù† Ù†Ù…ÛŒ Ø¯Ù‡Ø¯',0),(510304,14176,'tr','HTML PO sÃ¼rÃ¼m seÃ§eneÄŸi gÃ¶rÃ¼nmÃ¼yor',0),(510305,14176,'pl','Nie pokazuj opcja PO w wersji HTML',0),(510306,14176,'bg','ÐÐµ ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð¾Ð¿Ñ†Ð¸ÑÑ‚Ð° Ð·Ð° Ð²ÐµÑ€ÑÐ¸Ñ Ð½Ð° HTML PO',0),(510307,14176,'ur','HTML Ù¾Ùˆ ÙˆØ±Ú˜Ù† Ø§Ø®ØªÛŒØ§Ø± Ù…Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(510308,14176,'sr','ÐÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜ Ð¥Ð¢ÐœÐ› ÐŸÐž Ð²ÐµÑ€Ð·Ð¸Ñ˜Ð¸ Ð¾Ð¿Ñ†Ð¸Ñ˜Ñƒ',0),(510309,14176,'vi','KhÃ´ng hiá»ƒn thá»‹ tÃ¹y chá»n phiÃªn báº£n HTML PO',0),(510310,14176,'af','HTML PO weergawe opsie wys nie',0),(510311,14176,'ro','Nu aratÄƒ opÅ£iunea de versiunea HTML PO',0),(510312,14176,'et','NÃ¤ita HTML PO versioon vÃµimalust',0),(510313,14176,'si','Ne kaÅ¾ejo HTML PO razliÄica moÅ¾nost',0),(510314,14176,'ba','Tidak menunjukkan HTML PO versi pilihan',0),(510315,14176,'nl','HTML-PO versie optie niet meer weergeven',0),(510316,14176,'fi','Ã„lÃ¤ NÃ¤ytÃ¤ HTML-PO Versiovaihtoehto',0),(510317,14176,'no','Ikke Vis HTML PO alternativet',0),(510318,14176,'da','Vis ikke HTML-PO Version mulighed',0),(510319,14176,'ko','HTML í¬ ë²„ì „ ì˜µì…˜ì„ í‘œì‹œ í•˜ì§€ ì•ŠìŒ',0),(510320,14176,'he','××œ ×ª×¦×™×’ ××ª ×”××¤×©×¨×•×ª ×’×¨×¡×ª HTML ×¤×•',0),(510321,14176,'el','ÎÎ± Î¼Î·Î½ ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ ÎµÏ€Î¹Î»Î¿Î³Î® Î­ÎºÎ´Î¿ÏƒÎ· PO HTML',0),(510322,14176,'zh','ä¸æ˜¾ç¤º HTML å¤§åŸ”ç‰ˆæœ¬é€‰é¡¹',0),(510323,14176,'sv','Visa inte HTML-PO Version alternativet',0),(510324,14176,'it','Non mostrare l\'opzione versione HTML PO',0),(510325,14176,'tl','',0),(510326,14176,'th','à¹„à¸¡à¹ˆà¹à¸ªà¸”à¸‡à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸ HTML PO à¸£à¸¸à¹ˆà¸™',0),(510327,14176,'hi','HTML à¤ªà¥‹ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¨à¤¹à¥€à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(510328,14176,'ms','Jangan Tunjukkan opsyen versi HTML PO',0),(510329,14176,'ar','Ø¹Ø¯Ù… Ø¥Ø¸Ù‡Ø§Ø± Ø®ÙŠØ§Ø± Ø§Ù„Ø¥ØµØ¯Ø§Ø± HTML Ø¨Ùˆ',0),(510330,14176,'fr','Ne pas afficher l\'Option Version HTML PO',0),(510331,14176,'jp','HTML PO ãƒãƒ¼ã‚¸ãƒ§ãƒ³ ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(510332,14176,'pt','NÃ£o mostra a opÃ§Ã£o de versÃ£o HTML PO',0),(510333,14176,'ru','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚ Ð²ÐµÑ€ÑÐ¸Ð¸ HTML PO',0),(510334,14176,'es','No mostrar HTML PO versiÃ³n opciÃ³n',0),(510335,14176,'de','HTML-PO-Version-Option nicht anzeigen',0),(510336,14176,'en','Do Not Show HTML PO Version Option',0),(510337,14177,'is','',0),(510338,14177,'dr','Ù†Ù…Ø§ÛŒØ´ Ú©Ø¯ Ø¯Ø§Ø®Ù„ÛŒ Ú©Ø§Ù„Ø§ Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚',0),(510339,14177,'pr','Ù†Ù…Ø§ÛŒØ´ Ú©Ø¯ Ø¯Ø§Ø®Ù„ÛŒ Ú©Ø§Ù„Ø§ Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚',0),(510340,14177,'tr','Dahili madde kodu PO gÃ¶ster:',0),(510341,14177,'pl','PokaÅ¼ kod wewnÄ™trzny element na PO',0),(510342,14177,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð’ÑŠÑ‚Ñ€ÐµÑˆÐµÐ½ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» ÐºÐ¾Ð´ Ð½Ð° PO',0),(510343,14177,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ø´Û’ Ú©ÙˆÚˆ Ù¾Ø± Ù¾Ùˆ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(510344,14177,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð½Ñ‚ÐµÑ€Ð½Ðµ Ð¿Ð¾ÑˆÐ¸Ñ™ÐºÐµ Ð½Ð° Ð¿Ð¾-Ð°',0),(510345,14177,'vi','Hiá»ƒn thá»‹ ná»™i bá»™ má»¥c mÃ£ trÃªn PO',0),(510346,14177,'af','Interne Item kode wys op PO',0),(510347,14177,'ro','AratÄƒ cod intern articol pe PO',0),(510348,14177,'et','Kuva sisemised kaubakood PO',0),(510349,14177,'si','PrikaÅ¾i interna koda na PO',0),(510350,14177,'ba','Tampilkan kode barang Internal di PO',0),(510351,14177,'nl','Interne Artikelcode Toon op PO',0),(510352,14177,'fi','NÃ¤ytÃ¤ sisÃ¤iset Nimikekoodi PO',0),(510353,14177,'no','Vis intern Varekode pÃ¥ PO',0),(510354,14177,'da','Vis interne varekode pÃ¥ PO',0),(510355,14177,'ko','ì‚¬ì„œí•¨ì— ë‚´ë¶€ í•­ëª© ì½”ë“œ í‘œì‹œ',0),(510356,14177,'he','×”×¦×’ ×§×•×“ ×¤×¨×™×˜ ×¤× ×™×ž×™ ×¢×œ ×¤×•',0),(510357,14177,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ®Ï‚ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ ÏƒÎµ PO',0),(510358,14177,'zh','åœ¨å¡ä¸Šæ˜¾ç¤ºå†…éƒ¨ç‰©æ–™ä»£ç ',0),(510359,14177,'sv','Visa interna Artikelkod pÃ¥ PO',0),(510360,14177,'it','Visualizza il codice articolo interno sul PO',0),(510361,14177,'tl','',0),(510362,14177,'th','à¹à¸ªà¸”à¸‡à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²à¸ à¸²à¸¢à¹ƒà¸™ PO',0),(510363,14177,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤®à¤¦ à¤•à¥‹à¤¡ à¤ªà¥‹ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(510364,14177,'ms','Menunjukkan kod Item dalaman pada PO',0),(510365,14177,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø© Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ù„Ø¹Ù†ØµØ± Ø¯Ø§Ø®Ù„ÙŠ ÙÙŠ Ø¨Ùˆ',0),(510366,14177,'fr','Afficher le Code article interne sur PO',0),(510367,14177,'jp','PO ã®å†…éƒ¨ã®å•†å“ã‚³ãƒ¼ãƒ‰ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(510368,14177,'pt','Mostrar cÃ³digo interno no PO',0),(510369,14177,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ¾Ð´ Ð²Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÐµÐ³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð½Ð° PO',0),(510370,14177,'es','Mostrar cÃ³digo interno del artÃ­culo en PO',0),(510371,14177,'de','Interne Artikelnummer auf PO anzeigen',0),(510372,14177,'en','Show Internal Item Code On PO',0),(510373,14178,'is','',0),(510374,14178,'dr','Ú©Ø´ØªÛŒ Ú†Ú©',0),(510375,14178,'pr','Ú©Ø´ØªÛŒ Ú†Ú©',0),(510376,14178,'tr','Gemiyi kontrol',0),(510377,14178,'pl','Statek sprawdzone',0),(510378,14178,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¸',0),(510379,14178,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ Ø¬Ø§Ù†Ú† Ù¾Ú‘ØªØ§Ù„',0),(510380,14178,'sr','Ð‘Ñ€Ð¾Ð´ Ñ˜Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ð¾',0),(510381,14178,'vi','TÃ u kiá»ƒm tra',0),(510382,14178,'af','Skip gekontroleer',0),(510383,14178,'ro','Nava verificate',0),(510384,14178,'et','Kontrollitud laeva',0),(510385,14178,'si','Ladje, ki preverja',0),(510386,14178,'ba','Kapal Diperiksa',0),(510387,14178,'nl','Schip gecontroleerd',0),(510388,14178,'fi','Alus tarkastetaan',0),(510389,14178,'no','Skipet sjekket',0),(510390,14178,'da','Skibet tjekket',0),(510391,14178,'ko','ì„ ë°• ê²€ì‚¬',0),(510392,14178,'he','×‘×“×§×• ××ª ×”×¡×¤×™× ×”',0),(510393,14178,'el','Î Î»Î¿Î¯Î¿ Ï€Î¿Ï… ÎµÎ»Î­Î³Ï‡Î¿Î½Ï„Î±Î¹',0),(510394,14178,'zh','èˆ¹èˆ¶æ£€æŸ¥',0),(510395,14178,'sv','Fartyget kontrolleras',0),(510396,14178,'it','Nave controllato',0),(510397,14178,'tl','',0),(510398,14178,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(510399,14178,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(510400,14178,'ms','Kapal yang didaftar',0),(510401,14178,'ar','ÙØ­Øµ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(510402,14178,'fr','Navire vÃ©rifiÃ©',0),(510403,14178,'jp','èˆ¹ã‚’ãƒã‚§ãƒƒã‚¯',0),(510404,14178,'pt','Nave verificados',0),(510405,14178,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ð»',0),(510406,14178,'es','Nave comprobado',0),(510407,14178,'de','Schiff Ã¼berprÃ¼ft',0),(510408,14178,'en','Ship Checked',0),(510409,14179,'is','',0),(510410,14179,'dr','Ù„ÛŒØ³Øª ØµÙ†Ø¯ÙˆÙ‚',0),(510411,14179,'pr','Ù„ÛŒØ³Øª ØµÙ†Ø¯ÙˆÙ‚',0),(510412,14179,'tr','Posta listesi',0),(510413,14179,'pl','PO liÅ›cie',0),(510414,14179,'bg','PO ÑÐ¿Ð¸ÑÑŠÐº',0),(510415,14179,'ur','Ù¾Ùˆ ÙÛØ±Ø³Øª',0),(510416,14179,'sr','ÐŸÐž Ð»Ð¸ÑÑ‚Ð¸',0),(510417,14179,'vi','Danh sÃ¡ch PO',0),(510418,14179,'af','Posbus lys',0),(510419,14179,'ro','Lista de PO',0),(510420,14179,'et','PO loend',0),(510421,14179,'si','PO seznamu',0),(510422,14179,'ba','Daftar PO',0),(510423,14179,'nl','PO lijst',0),(510424,14179,'fi','PO luettelo',0),(510425,14179,'no','PO liste',0),(510426,14179,'da','PO liste',0),(510427,14179,'ko','í¬ ëª©ë¡',0),(510428,14179,'he','×¨×©×™×ž×ª ×¤×•',0),(510429,14179,'el','Î›Î¯ÏƒÏ„Î± PO',0),(510430,14179,'zh','å¤§åŸ”åˆ—è¡¨',0),(510431,14179,'sv','PO lista',0),(510432,14179,'it','Elenco PO',0),(510433,14179,'tl','',0),(510434,14179,'th','à¸£à¸²à¸¢à¸à¸²à¸£ PO',0),(510435,14179,'hi','PO à¤¸à¥‚à¤šà¥€',0),(510436,14179,'ms','Senarai PO',0),(510437,14179,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø±ÙŠØ¯',0),(510438,14179,'fr','Liste de PO',0),(510439,14179,'jp','PO ãƒªã‚¹ãƒˆ',0),(510440,14179,'pt','Lista de PO',0),(510441,14179,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº PO',0),(510442,14179,'es','Lista de PO',0),(510443,14179,'de','PO-Liste',0),(510444,14179,'en','PO List',0),(510445,14180,'is','',0),(510446,14180,'dr','Ú©Ø¯ Ù…Ø§',0),(510447,14180,'pr','Ú©Ø¯ Ù…Ø§',0),(510448,14180,'tr','Bizim kodu',0),(510449,14180,'pl','Nasz kod',0),(510450,14180,'bg','ÐÐ°ÑˆÐ¸ÑÑ‚ ÐºÐ¾Ð´',0),(510451,14180,'ur','ÛÙ…Ø§Ø±Û’ Ø¶Ø§Ø¨Ø·Û',0),(510452,14180,'sr','ÐÐ°Ñˆ ÐºÐ¾Ð´',0),(510453,14180,'vi','MÃ£ cá»§a chÃºng tÃ´i',0),(510454,14180,'af','Ons kode',0),(510455,14180,'ro','Codul nostru',0),(510456,14180,'et','Meie kood',0),(510457,14180,'si','NaÅ¡o kodo',0),(510458,14180,'ba','Kode kita',0),(510459,14180,'nl','Onze Code',0),(510460,14180,'fi','MeidÃ¤n koodi',0),(510461,14180,'no','VÃ¥r kode',0),(510462,14180,'da','Vores kode',0),(510463,14180,'ko','ìš°ë¦¬ì˜ ì½”ë“œ',0),(510464,14180,'he','×”×§×•×“ ×©×œ× ×•',0),(510465,14180,'el','ÎœÎ±Ï‚ ÎºÏŽÎ´Î¹ÎºÎ±',0),(510466,14180,'zh','æˆ‘ä»¬çš„ä»£ç ',0),(510467,14180,'sv','VÃ¥r kod',0),(510468,14180,'it','Il nostro codice',0),(510469,14180,'tl','',0),(510470,14180,'th','à¸£à¸«à¸±à¸ªà¸‚à¸­à¸‡à¹€à¸£à¸²',0),(510471,14180,'hi','à¤¹à¤®à¤¾à¤°à¥‡ à¤•à¥‹à¤¡',0),(510472,14180,'ms','Kod kami',0),(510473,14180,'ar','Ù„Ø¯ÙŠÙ†Ø§ Ù…Ø¯ÙˆÙ†Ø©',0),(510474,14180,'fr','Notre Code',0),(510475,14180,'jp','ç§ãŸã¡ã®ã‚³ãƒ¼ãƒ‰',0),(510476,14180,'pt','Nosso cÃ³digo',0),(510477,14180,'ru','ÐÐ°Ñˆ ÐºÐ¾Ð´',0),(510478,14180,'es','Nuestro cÃ³digo',0),(510479,14180,'de','Unser Code',0),(510480,14180,'en','Our Code',0),(510481,14181,'is','',0),(510482,14181,'dr','Ú¯Ø±ÙˆÙ‡ Ø³ÙØ§Ø±Ø´Ø§Øª Ú©Ø´ØªÛŒ',0),(510483,14181,'pr','Ú¯Ø±ÙˆÙ‡ Ø³ÙØ§Ø±Ø´Ø§Øª Ú©Ø´ØªÛŒ',0),(510484,14181,'tr','Gemi sipariÅŸleri gruplandÄ±rma',0),(510485,14181,'pl','Grupa zamÃ³wienia',0),(510486,14181,'bg','Ð“Ñ€ÑƒÐ¿Ð° ÐºÐ¾Ñ€Ð°Ð±Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(510487,14181,'ur','Ú¯Ø±ÙˆÙ¾ Ú©Û’ Ø¬ÛØ§Ø² Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(510488,14181,'sr','Ð“Ñ€ÑƒÐ¿Ð° Ð±Ñ€Ð¾Ð´ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(510489,14181,'vi','NhÃ³m tÃ u Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(510490,14181,'af','Groep skip bestellings',0),(510491,14181,'ro','Grupa navei comenzi',0),(510492,14181,'et','RÃ¼hma laeva tellimusi',0),(510493,14181,'si','Skupina naroÄil za ladje',0),(510494,14181,'ba','Kelompok kapal pesanan',0),(510495,14181,'nl','Groep schip bestellingen',0),(510496,14181,'fi','Aluksen tilausten ryhmittely',0),(510497,14181,'no','Gruppe bestillinger',0),(510498,14181,'da','Gruppe skibsordrer',0),(510499,14181,'ko','ê·¸ë£¹ ë°° ì£¼ë¬¸',0),(510500,14181,'he','×§×‘×•×¦×” ×”×¡×¤×™× ×” ×”×–×ž× ×•×ª',0),(510501,14181,'el','ÎŸÎ¼Î¬Î´Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€Î»Î¿Î¯Ï‰Î½',0),(510502,14181,'zh','èˆ¹èˆ¶è®¢å•è¿›è¡Œåˆ†ç»„',0),(510503,14181,'sv','Grupp fartyget order',0),(510504,14181,'it','Gruppo nave ordini',0),(510505,14181,'tl','',0),(510506,14181,'th','à¸ˆà¸±à¸”à¸à¸¥à¸¸à¹ˆà¸¡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(510507,14181,'hi','à¤¸à¤®à¥‚à¤¹ à¤œà¤¹à¤¾à¤œ à¤†à¤¦à¥‡à¤¶',0),(510508,14181,'ms','Kumpulan kapal pesanan',0),(510509,14181,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(510510,14181,'fr','Commandes de navires de groupe',0),(510511,14181,'jp','ã‚°ãƒ«ãƒ¼ãƒ—ã®èˆ¹èˆ¶å—æ³¨',0),(510512,14181,'pt','Grupo envia ordens',0),(510513,14181,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(510514,14181,'es','Grupo nave ordenes',0),(510515,14181,'de','Gruppenbestellungen Schiff',0),(510516,14181,'en','Group Ship Orders',0),(510517,14182,'is','',0),(510518,14182,'dr','Ú¯Ø²Ø§Ø±Ø´ EFT',0),(510519,14182,'pr','Ú¯Ø²Ø§Ø±Ø´ EFT',0),(510520,14182,'tr','EFT raporu',0),(510521,14182,'pl','Raport EFT',0),(510522,14182,'bg','EFT Ð´Ð¾ÐºÐ»Ð°Ð´',0),(510523,14182,'ur','EFT Ø±Ù¾ÙˆØ±Ù¹',0),(510524,14182,'sr','Ð•Ð¤Ð¢ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(510525,14182,'vi','EFT bÃ¡o cÃ¡o',0),(510526,14182,'af','EFT verslag',0),(510527,14182,'ro','EFT raport',0),(510528,14182,'et','EFT aruanne',0),(510529,14182,'si','EFT poroÄilo',0),(510530,14182,'ba','TDE laporan',0),(510531,14182,'nl','EFT verslag',0),(510532,14182,'fi','EFT raportti',0),(510533,14182,'no','EFT rapport',0),(510534,14182,'da','EFT rapport',0),(510535,14182,'ko','ì „ìž ì†¡ê¸ˆ ë³´ê³ ì„œ',0),(510536,14182,'he','EFT ×—',0),(510537,14182,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï„Î¿Ï… EFT',0),(510538,14182,'zh','EFT æŠ¥å‘Š',0),(510539,14182,'sv','EFT betÃ¤nkande',0),(510540,14182,'it','Relazione EFT',0),(510541,14182,'tl','',0),(510542,14182,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™ EFT',0),(510543,14182,'hi','à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(510544,14182,'ms','Laporan EFT',0),(510545,14182,'ar','ØªÙ‚Ø±ÙŠØ± EFT',0),(510546,14182,'fr','Rapport de l\'EFT',0),(510547,14182,'jp','éŠ€è¡Œå£åº§æŒ¯è¾¼ãƒ¬ãƒãƒ¼ãƒˆ',0),(510548,14182,'pt','RelatÃ³rio EFT',0),(510549,14182,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´Ðµ',0),(510550,14182,'es','Informe EFT',0),(510551,14182,'de','EFT-Bericht',0),(510552,14182,'en','EFT Report',0),(510553,14183,'is','',0),(510554,14183,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø§ÛŒØ¬Ø§Ø¯',0),(510555,14183,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø§ÛŒØ¬Ø§Ø¯',0),(510556,14183,'tr','Dosya oluÅŸturma numarasÄ±',0),(510557,14183,'pl','Numer tworzenie pliku',0),(510558,14183,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(510559,14183,'ur','ÙØ§Ø¦Ù„ ØªØ®Ù„ÛŒÙ‚ Ù†Ù…Ø¨Ø±',0),(510560,14183,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐ° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(510561,14183,'vi','Táº¡o ra sá»‘',0),(510562,14183,'af','LÃªer skepping nommer',0),(510563,14183,'ro','NumÄƒrul de crearea fiÅŸierului',0),(510564,14183,'et','Faili loomine Number',0),(510565,14183,'si','Å tevilka za ustvarjanje datoteke',0),(510566,14183,'ba','Nomor penciptaan file',0),(510567,14183,'nl','Oprichting dossiernummer',0),(510568,14183,'fi','Tiedoston luominen numero',0),(510569,14183,'no','Etableringen filnummer',0),(510570,14183,'da','Oprettelse journalnummer',0),(510571,14183,'ko','íŒŒì¼ ìƒì„± ë²ˆí˜¸',0),(510572,14183,'he','×ž×¡×¤×¨ ×™×¦×™×¨×ª ×”×§×•×‘×¥',0),(510573,14183,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(510574,14183,'zh','æ–‡ä»¶åˆ›å»ºç¼–å·',0),(510575,14183,'sv','Skapa filnummer',0),(510576,14183,'it','Numero di creazione del file',0),(510577,14183,'tl','',0),(510578,14183,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹à¸Ÿà¹‰à¸¡à¸ªà¸£à¹‰à¸²à¸‡',0),(510579,14183,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(510580,14183,'ms','Nombor penciptaan fail',0),(510581,14183,'ar','Ø±Ù‚Ù… Ø¥Ù†Ø´Ø§Ø¡ Ù…Ù„Ù',0),(510582,14183,'fr','CrÃ©ation de dossier',0),(510583,14183,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®ä½œæˆæ•°',0),(510584,14183,'pt','NÃºmero de criaÃ§Ã£o de arquivo',0),(510585,14183,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ Ñ„Ð°Ð¹Ð»Ð°',0),(510586,14183,'es','NÃºmero de creaciÃ³n de archivo',0),(510587,14183,'de','Erstellung Dateinummer',0),(510588,14183,'en','File Creation Number',0),(510589,14184,'is','',0),(510590,14184,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø±Ú©ÙˆØ±Ø¯Ù‡Ø§',0),(510591,14184,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø±Ú©ÙˆØ±Ø¯Ù‡Ø§',0),(510592,14184,'tr','KayÄ±t sayÄ±sÄ±',0),(510593,14184,'pl','Liczba rekordÃ³w',0),(510594,14184,'bg','Ð‘Ñ€Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(510595,14184,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§ Ù†Ù…Ø¨Ø±',0),(510596,14184,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð·Ð°Ð¿Ð¸ÑÐ°',0),(510597,14184,'vi','Sá»‘ lÆ°á»£ng há»“ sÆ¡',0),(510598,14184,'af','Aantal rekords',0),(510599,14184,'ro','NumÄƒrul de Ã®nregistrÄƒri',0),(510600,14184,'et','Kirjete arv',0),(510601,14184,'si','Å tevilo zapisov',0),(510602,14184,'ba','Jumlah record',0),(510603,14184,'nl','Aantal Records',0),(510604,14184,'fi','Tietueiden mÃ¤Ã¤rÃ¤',0),(510605,14184,'no','Antall poster',0),(510606,14184,'da','Antallet af poster',0),(510607,14184,'ko','ë ˆì½”ë“œ ìˆ˜',0),(510608,14184,'he','×ž×¡×¤×¨ ×”×¨×©×•×ž×•×ª',0),(510609,14184,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(510610,14184,'zh','è®°å½•æ•°',0),(510611,14184,'sv','Antal poster',0),(510612,14184,'it','Numero di record',0),(510613,14184,'tl','',0),(510614,14184,'th','à¸ˆà¸³à¸™à¸§à¸™à¸‚à¸­à¸‡à¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”',0),(510615,14184,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡à¥à¤¸ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(510616,14184,'ms','Bilangan rekod',0),(510617,14184,'ar','Ø¹Ø¯Ø¯ Ø§Ù„Ø³Ø¬Ù„Ø§Øª',0),(510618,14184,'fr','Nombre d\'enregistrements',0),(510619,14184,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ã®æ•°',0),(510620,14184,'pt','NÃºmero de registros',0),(510621,14184,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(510622,14184,'es','NÃºmero de registros',0),(510623,14184,'de','Anzahl der DatensÃ¤tze',0),(510624,14184,'en','Number Of Records',0),(510625,14185,'is','',0),(510626,14185,'dr','Ù…Ù‚Ø¯Ø§Ø± Ú©Ù„',0),(510627,14185,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú©Ù„',0),(510628,14185,'tr','Toplam tutar',0),(510629,14185,'pl','CaÅ‚kowita kwota',0),(510630,14185,'bg','ÐžÐ±Ñ‰Ð° ÑÑƒÐ¼Ð°',0),(510631,14185,'ur','Ú©Ù„ Ø±Ù‚Ù…',0),(510632,14185,'sr','Ð£ÐºÑƒÐ¿Ð°Ð½ Ð¸Ð·Ð½Ð¾Ñ',0),(510633,14185,'vi','Tá»•ng sá»‘ tiá»n',0),(510634,14185,'af','Totale bedrag',0),(510635,14185,'ro','Suma totalÄƒ',0),(510636,14185,'et','Kogusumma',0),(510637,14185,'si','Skupni znesek',0),(510638,14185,'ba','Jumlah total',0),(510639,14185,'nl','Totaalbedrag',0),(510640,14185,'fi','Kokonaissumma',0),(510641,14185,'no','TotalbelÃ¸p',0),(510642,14185,'da','Samlede belÃ¸b',0),(510643,14185,'ko','ì´ ê¸ˆì•¡',0),(510644,14185,'he','×”×¡×›×•× ×”×›×•×œ×œ',0),(510645,14185,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Ï€Î¿ÏƒÏŒ',0),(510646,14185,'zh','æ€»é‡‘é¢',0),(510647,14185,'sv','Totalt belopp',0),(510648,14185,'it','Importo totale',0),(510649,14185,'tl','',0),(510650,14185,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸£à¸§à¸¡',0),(510651,14185,'hi','à¤•à¥à¤² à¤°à¤¾à¤¶à¤¿',0),(510652,14185,'ms','Jumlah amaun',0),(510653,14185,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(510654,14185,'fr','Montant total',0),(510655,14185,'jp','åˆè¨ˆé‡‘é¡',0),(510656,14185,'pt','Montante total',0),(510657,14185,'ru','ÐžÐ±Ñ‰Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(510658,14185,'es','Cantidad total',0),(510659,14185,'de','Gesamtbetrag',0),(510660,14185,'en','Total Amount',0),(510661,14186,'is','',0),(510662,14186,'dr','Ú©Ù„ÛŒØ¯ API Ø¯Ø± npimport.php Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(510663,14186,'pr','Ú©Ù„ÛŒØ¯ API Ø¯Ø± npimport.php Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(510664,14186,'tr','API anahtarÄ± iÃ§inde npimport.php dosyasÄ±',0),(510665,14186,'pl','Klucz API w npimport.php pliku',0),(510666,14186,'bg','API ÐºÐ»ÑŽÑ‡ Ð² npimport.php Ñ„Ð°Ð¹Ð»',0),(510667,14186,'ur','API Ú©Ù„ÛŒØ¯ Ù…ÛŒÚº npimport.php Ù…Ø³Ù„',0),(510668,14186,'sr','ÐÐ¿Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚.Ð¿Ñ…Ð¿ ÐÐŸÐ˜ ÐºÑ™ÑƒÑ‡ Ñƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(510669,14186,'vi','API Key trong npimport.php táº­p tin',0),(510670,14186,'af','API sleutel In npimport.php lÃªer',0),(510671,14186,'ro','API cheie Ã®n npimport.php fiÅŸier',0),(510672,14186,'et','API vÃµti on npimport.php fail',0),(510673,14186,'si','API zakleniti v npimport.php datoteko',0),(510674,14186,'ba','API Key dalam npimport.php File',0),(510675,14186,'nl','API sleutel In npimport.php bestand',0),(510676,14186,'fi','API avain kotona npimport.php arkistoida',0),(510677,14186,'no','API nÃ¸kkel i npimport.php fil',0),(510678,14186,'da','API nÃ¸glen i npimport.php fil',0),(510679,14186,'ko','API í‚¤ì— npimport.php íŒŒì¼',0),(510680,14186,'he','API ×ž×¤×ª×— ×‘ npimport.php ×§×•×‘×¥',0),(510681,14186,'el','API ÎºÎ»ÎµÎ¹Î´Î¯ ÏƒÏ„Î¿ npimport.php Î±ÏÏ‡ÎµÎ¯Î¿',0),(510682,14186,'zh','API å¯†é’¥åœ¨ npimport.php æ–‡ä»¶',0),(510683,14186,'sv','API nyckel i npimport.php fil',0),(510684,14186,'it','API Key In npimport.php File',0),(510685,14186,'tl','',0),(510686,14186,'th','à¹„à¸Ÿà¸¥à¹Œ API à¸„à¸µà¸¢à¹Œà¹ƒà¸™ npimport.php',0),(510687,14186,'hi','Npimport.php à¤«à¤¼à¤¾à¤‡à¤² API à¤•à¥à¤‚à¤œà¥€ à¤®à¥‡à¤‚',0),(510688,14186,'ms','Kekunci API di npimport.php fail',0),(510689,14186,'ar','Npimport.php API Ø§Ù„Ù…ÙØªØ§Ø­ ÙÙŠ Ù…Ù„Ù',0),(510690,14186,'fr','API Key In npimport.php fichier',0),(510691,14186,'jp','Npimport.php API ã‚­ãƒ¼ã®ãƒ•ã‚¡ã‚¤ãƒ«',0),(510692,14186,'pt','Chave de API em npimport.php arquivo',0),(510693,14186,'ru','API ÐºÐ»ÑŽÑ‡ Ð² npimport.php Ñ„Ð°Ð¹Ð»',0),(510694,14186,'es','API Key en npimport.php archivo',0),(510695,14186,'de','API-SchlÃ¼ssel In npimport.php Datei',0),(510696,14186,'en','API Key In npimport.php File',0),(510697,14187,'is','',0),(510698,14187,'dr','Ø¢Ø®Ø±ÛŒÙ† Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙˆØ§Ø±Ø¯',0),(510699,14187,'pr','Ø¢Ø®Ø±ÛŒÙ† Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ ÙˆØ§Ø±Ø¯',0),(510700,14187,'tr','AlÄ±nan son sipariÅŸ numarasÄ±',0),(510701,14187,'pl','Ostatni numer zamÃ³wienia importowane',0),(510702,14187,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ÑÑ‚ Ñ€ÐµÐ´ Ð½Ð¾Ð¼ÐµÑ€ Ð²Ð½ÐµÑÐµÐ½Ð¸',0),(510703,14187,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø¢Ø®Ø±ÛŒ Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø±',0),(510704,14187,'sr','Ð—Ð°Ð´ÑšÐ¸ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° ÐºÐ¾Ñ˜Ð¸ ÑÐµ ÑƒÐ²Ð¾Ð·Ðµ',0),(510705,14187,'vi','Sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng cuá»‘i cÃ¹ng nháº­p kháº©u',0),(510706,14187,'af','Laaste bestelling nommer ingevoer',0),(510707,14187,'ro','Ultimul numÄƒr de ordine importate',0),(510708,14187,'et','Viimase numbri imporditud',0),(510709,14187,'si','Zadnja Å¡tevilka naloga, uvoÅ¾enih',0),(510710,14187,'ba','Nomor pesanan terakhir diimpor',0),(510711,14187,'nl','Laatste ordernummer ingevoerd',0),(510712,14187,'fi','Viimeinen tilausnumero tuotu',0),(510713,14187,'no','Siste ordrenummer importert',0),(510714,14187,'da','Sidste ordrenummer importeret',0),(510715,14187,'ko','ê°€ì ¸ì˜¨ ë§ˆì§€ë§‰ ì£¼ë¬¸ ë²ˆí˜¸',0),(510716,14187,'he','×ž×¡×¤×¨ ×”×”×–×ž× ×” ×”××—×¨×•× ×” ×ž×™×•×‘××™×',0),(510717,14187,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(510718,14187,'zh','æœ€åŽä¸€ä¸ªå¯¼å…¥çš„è®¢å•ç¼–å·',0),(510719,14187,'sv','Sista ordernumret som importeras',0),(510720,14187,'it','Ultimo numero d\'ordine importato',0),(510721,14187,'tl','',0),(510722,14187,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸¥à¹ˆà¸²à¸ªà¸¸à¸”à¸—à¸µà¹ˆà¸™à¸³à¹€à¸‚à¹‰à¸²',0),(510723,14187,'hi','à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ à¤ªà¤¿à¤›à¤²à¥‡ à¤†à¤¦à¥‡à¤¶ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(510724,14187,'ms','Nombor pesanan terakhir yang diimport',0),(510725,14187,'ar','Ø¢Ø®Ø± Ø±Ù‚Ù… Ø£Ù…Ø± Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(510726,14187,'fr','Dernier numÃ©ro de commande importÃ©',0),(510727,14187,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚ŒãŸæœ€å¾Œã®æ³¨æ–‡ç•ªå·',0),(510728,14187,'pt','Ãšltimo nÃºmero de ordem importado',0),(510729,14187,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ¾Ð²Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(510730,14187,'es','Ãšltimo nÃºmero de la orden importado',0),(510731,14187,'de','Letzte Bestellnummer importiert',0),(510732,14187,'en','Last Order Number Imported',0),(510733,14188,'is','',0),(510734,14188,'dr','Ù…Ú©Ø§Ù† Ù‡Ø§ÛŒ npimport.php ÙØ§ÛŒÙ„',0),(510735,14188,'pr','Ù…Ú©Ø§Ù† Ù‡Ø§ÛŒ npimport.php ÙØ§ÛŒÙ„',0),(510736,14188,'tr','Konumu ve dosya npimport.php',0),(510737,14188,'pl','Lokalizacja z npimport.php pliku',0),(510738,14188,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° npimport.php Ñ„Ð°Ð¹Ð»',0),(510739,14188,'ur','Npimport.php Ù…Ø³Ù„ Ú©Ø§ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(510740,14188,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð¾Ð´ Ð½Ð¿Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚.Ð¿Ñ…Ð¿ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(510741,14188,'vi','Vá»‹ trÃ­ cá»§a npimport.php táº­p tin',0),(510742,14188,'af','Ligging van die npimport.php lÃªer',0),(510743,14188,'ro','LocaÅ£ie de npimport.php fiÅŸier',0),(510744,14188,'et','Asukoht ning npimport.php faili',0),(510745,14188,'si','Mesto za npimport.php datoteke',0),(510746,14188,'ba','Lokasi dari npimport.php File',0),(510747,14188,'nl','Locatie van de npimport.php bestand',0),(510748,14188,'fi','Sijainti ja npimport.php tiedosto',0),(510749,14188,'no','Plassering av npimport.php fil',0),(510750,14188,'da','Placering af npimport.php filen',0),(510751,14188,'ko','Npimport.php íŒŒì¼ì˜ ìœ„ì¹˜',0),(510752,14188,'he','×”×ž×™×§×•× ×©×œ npimport.php ×”×§×•×‘×¥',0),(510753,14188,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Ï„Î¿Ï… Ï„Î¿ npimport.php Î±ÏÏ‡ÎµÎ¯Î¿',0),(510754,14188,'zh','ä½ç½®çš„ npimport.php æ–‡ä»¶',0),(510755,14188,'sv','LÃ¤ge av npimport.php fil',0),(510756,14188,'it','Posizione di npimport.php File',0),(510757,14188,'tl','',0),(510758,14188,'th','à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡à¸‚à¸­à¸‡ npimport.php à¹à¸Ÿà¹‰à¸¡',0),(510759,14188,'hi','Npimport.php à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤¸à¥à¤¥à¤¾à¤¨',0),(510760,14188,'ms','Lokasi di npimport.php fail',0),(510761,14188,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ù…Ù† npimport.php Ø§Ù„Ù…Ù„Ù',0),(510762,14188,'fr','Emplacement de la npimport.php fichier',0),(510763,14188,'jp','Npimport.php ãƒ•ã‚¡ã‚¤ãƒ«ã®å ´æ‰€',0),(510764,14188,'pt','LocalizaÃ§Ã£o do npimport.php arquivo',0),(510765,14188,'ru','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¸Ð· npimport.php Ñ„Ð°Ð¹Ð»Ð°',0),(510766,14188,'es','UbicaciÃ³n de la npimport.php archivo',0),(510767,14188,'de','Lage der npimport.php Datei',0),(510768,14188,'en','Location Of The npimport.php File',0),(510769,14189,'is','',0),(510770,14189,'dr','ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± ÙˆØ§Ø±Ø¯Ø§Øª',0),(510771,14189,'pr','ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± ÙˆØ§Ø±Ø¯Ø§Øª',0),(510772,14189,'tr','AyarlarÄ± el ile al',0),(510773,14189,'pl','Ustawienia rÄ™cznego importu',0),(510774,14189,'bg','Ð ÑŠÑ‡Ð½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸',0),(510775,14189,'ur','Ø¯Ø³ØªÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº',0),(510776,14189,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐºÐµ Ñ€ÑƒÑ‡Ð½Ð¾ ÑƒÐ²Ð¾Ð·Ð°',0),(510777,14189,'vi','CÃ i Ä‘áº·t hÆ°á»›ng dáº«n sá»­ dá»¥ng nháº­p kháº©u',0),(510778,14189,'af','Handmatige invoer-instellings',0),(510779,14189,'ro','Manual Import setÄƒrile',0),(510780,14189,'et','KÃ¤sitsi importimise sÃ¤tted',0),(510781,14189,'si','RoÄni uvoz nastavitev',0),(510782,14189,'ba','Manual impor pengaturan',0),(510783,14189,'nl','Instellingen voor handmatige invoer',0),(510784,14189,'fi','Manuaalinen tuontiasetukset',0),(510785,14189,'no','Manuell importinnstillinger',0),(510786,14189,'da','Manuel importindstillinger',0),(510787,14189,'ko','ìˆ˜ë™ ê°€ì ¸ì˜¤ê¸° ì„¤ì •',0),(510788,14189,'he','×”×’×“×¨×•×ª ×™×™×‘×•× ×™×“× ×™×ª',0),(510789,14189,'el','Î§ÎµÎ¹ÏÎ¿ÎºÎ¯Î½Î·Ï„Î· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® ÏÏ…Î¸Î¼Î¯ÏƒÎµÏ‰Î½',0),(510790,14189,'zh','æ‰‹åŠ¨å¯¼å…¥è®¾ç½®',0),(510791,14189,'sv','Manuell Import-instÃ¤llningar',0),(510792,14189,'it','Impostazioni di importazione manuale',0),(510793,14189,'tl','',0),(510794,14189,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸™à¸³à¹€à¸‚à¹‰à¸²à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(510795,14189,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤†à¤¯à¤¾à¤¤ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸',0),(510796,14189,'ms','Pengesetan manual Import',0),(510797,14189,'ar','Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„ÙŠØ¯ÙˆÙŠ',0),(510798,14189,'fr','ParamÃ¨tres d\'importation manuelle',0),(510799,14189,'jp','æ‰‹å‹•ã«ã‚ˆã‚‹ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®è¨­å®š',0),(510800,14189,'pt','ConfiguraÃ§Ãµes de importaÃ§Ã£o manual',0),(510801,14189,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ',0),(510802,14189,'es','ConfiguraciÃ³n de importaciÃ³n manual',0),(510803,14189,'de','Manuelle Importeinstellungen',0),(510804,14189,'en','Manual Import Settings',0),(510805,14190,'is','',0),(510806,14190,'dr','Ø¯Ù‚ÛŒÙ‚Ù‡ 20 Ú©Ø§Ø±Ø§Ú©ØªØ±',0),(510807,14190,'pr','Ø¯Ù‚ÛŒÙ‚Ù‡ 20 Ú©Ø§Ø±Ø§Ú©ØªØ±',0),(510808,14190,'tr','En az 20 karakter',0),(510809,14190,'pl','Min 20 znakÃ³w',0),(510810,14190,'bg','Min 20 ÑÐ¸Ð¼Ð²Ð¾Ð»Ð°',0),(510811,14190,'ur','Ú©Ù… Ø§Ø² Ú©Ù… 20 Ú©Ø±ÛŒÚ©Ù¹Ø±',0),(510812,14190,'sr','ÐœÐ¸Ð½ 20 Ð·Ð½Ð°ÐºÐ¾Ð²Ð°',0),(510813,14190,'vi','PhÃºt 20 kÃ½ tá»±',0),(510814,14190,'af','Min 20 karakters',0),(510815,14190,'ro','Min 20 caractere',0),(510816,14190,'et','Min 20 tÃ¤hemÃ¤rki',0),(510817,14190,'si','Min 20 znakov',0),(510818,14190,'ba','Min 20 karakter',0),(510819,14190,'nl','Min. 20 tekens',0),(510820,14190,'fi','Min 20 merkkiÃ¤',0),(510821,14190,'no','Min 20 tegn',0),(510822,14190,'da','Min 20 tegn',0),(510823,14190,'ko','ìµœì†Œ 20 ë¬¸ìž',0),(510824,14190,'he','×ž×™× ×™×ž×•× 20 ×ª×•×•×™×',0),(510825,14190,'el','Min 20 Chars',0),(510826,14190,'zh','20 æœ€å°å­—ç¬¦æ•°',0),(510827,14190,'sv','Min 20 tecken',0),(510828,14190,'it','Min 20 caratteri',0),(510829,14190,'tl','',0),(510830,14190,'th','à¸‚à¸±à¹‰à¸™à¸•à¹ˆà¸³ 20 à¸•à¸±à¸§à¸­à¸±à¸à¸©à¸£',0),(510831,14190,'hi','20 à¤®à¤¿à¤¨ Chars',0),(510832,14190,'ms','Min 20 aksara',0),(510833,14190,'ar','Ø­Ø±ÙˆÙ Ø¯Ù‚ÙŠÙ‚Ø© 20',0),(510834,14190,'fr','Min 20 caractÃ¨res',0),(510835,14190,'jp','20 ã®æœ€å°æ–‡å­—æ•°ã—ã¾ã™ã€‚',0),(510836,14190,'pt','Min 20 Chars',0),(510837,14190,'ru','ÐœÐ¸Ð½ 20 ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¾Ð²',0),(510838,14190,'es','Min 20 caracteres',0),(510839,14190,'de','Mind. 20 Zeichen',0),(510840,14190,'en','Min 20 Chars',0),(510841,14191,'is','',0),(510842,14191,'dr','osCom ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† URL',0),(510843,14191,'pr','osCom ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† URL',0),(510844,14191,'tr','osCom alma URL\'si',0),(510845,14191,'pl','osCom Import URL',0),(510846,14191,'bg','osCom Ð²Ð½Ð¾Ñ URL',0),(510847,14191,'ur','Ø¹Ø«Ú©Ø§ÙˆÙ… Ø¯Ø±Ø¢Ù…Ø¯ URL',0),(510848,14191,'sr','Ð¾ÑÐ¦Ð¾Ð¼ Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° ÑƒÐ²Ð¾Ð·Ð°',0),(510849,14191,'vi','osCom nháº­p kháº©u URL',0),(510850,14191,'af','osCom invoer URL',0),(510851,14191,'ro','osCom Import URL',0),(510852,14191,'et','osCom impordi URL',0),(510853,14191,'si','osCom uvoz URL',0),(510854,14191,'ba','osCom impor URL',0),(510855,14191,'nl','osCom Import URL',0),(510856,14191,'fi','osCom URLIT',0),(510857,14191,'no','osCom Import URL',0),(510858,14191,'da','osCom Import URL',0),(510859,14191,'ko','osCom ê°€ì ¸ì˜¤ê¸° URL',0),(510860,14191,'he','osCom ×™×™×‘×•× ×›×ª×•×‘×ª URL',0),(510861,14191,'el','osCom ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ URL',0),(510862,14191,'zh','osCom å¯¼å…¥ URL',0),(510863,14191,'sv','osCom Import URL',0),(510864,14191,'it','osCom Import URL',0),(510865,14191,'tl','',0),(510866,14191,'th','osCom à¸™à¸³à¹€à¸‚à¹‰à¸² URL',0),(510867,14191,'hi','osCom à¤†à¤¯à¤¾à¤¤ à¤¯à¥‚à¤†à¤°à¤à¤²',0),(510868,14191,'ms','osCom Import URL',0),(510869,14191,'ar','Ø£ÙˆØ³ÙˆÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯ URL',0),(510870,14191,'fr','osCom importation URL',0),(510871,14191,'jp','osCom ã‚¤ãƒ³ãƒãƒ¼ãƒˆ URL',0),(510872,14191,'pt','osCom importaÃ§Ã£o URL',0),(510873,14191,'ru','osCom Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° URL',0),(510874,14191,'es','osCom importaciÃ³n URL',0),(510875,14191,'de','OsCom Import URL',0),(510876,14191,'en','osCom Import URL',0),(510877,14192,'is','',0),(510878,14192,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ EFT',0),(510879,14192,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ EFT',0),(510880,14192,'tr','EFT dosya indirmek',0),(510881,14192,'pl','Pobierz plik EFT',0),(510882,14192,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð° Ð½Ð° Ð•ÐŸÐ¡',0),(510883,14192,'ur','EFT ÙØ§Ø¦Ù„ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(510884,14192,'sr','ÐžÐ´Ð¼Ð°Ñ… Ð¿Ñ€ÐµÑƒÐ·Ð¼Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð•Ð¤Ð¢',0),(510885,14192,'vi','Táº£i vá» táº­p tin EFT',0),(510886,14192,'af','EFT lÃªer aflaai',0),(510887,14192,'ro','DescarcÄƒ EFT',0),(510888,14192,'et','EFT faili alla laadida',0),(510889,14192,'si','EFT datoteko prenesite',0),(510890,14192,'ba','Download File TDE',0),(510891,14192,'nl','EFT bestand downloaden',0),(510892,14192,'fi','Lataa EFT tiedosto',0),(510893,14192,'no','DataoverfÃ¸re EFT arkiv',0),(510894,14192,'da','Download EFT-filen',0),(510895,14192,'ko','ì „ìž ì†¡ê¸ˆ íŒŒì¼ ë‹¤ìš´ë¡œë“œ',0),(510896,14192,'he','×”×•×¨×“ ×§×•×‘×¥ EFT',0),(510897,14192,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï„Î¿Ï… EFT',0),(510898,14192,'zh','EFT æ–‡ä»¶ä¸‹è½½',0),(510899,14192,'sv','HÃ¤mta EFT filen',0),(510900,14192,'it','Scarica File EFT',0),(510901,14192,'tl','',0),(510902,14192,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹„à¸Ÿà¸¥à¹Œ EFT',0),(510903,14192,'hi','à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤«à¤¼à¤¾à¤‡à¤² à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(510904,14192,'ms','Muat turun fail EFT',0),(510905,14192,'ar','ØªØ­Ù…ÙŠÙ„ Ù…Ù„Ù EFT',0),(510906,14192,'fr','TÃ©lÃ©charger le fichier de l\'EFT',0),(510907,14192,'jp','EFT ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(510908,14192,'pt','Baixar arquivo EFT',0),(510909,14192,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ Ñ„Ð°Ð¹Ð» EFT',0),(510910,14192,'es','Descargar archivo EFT',0),(510911,14192,'de','EFT-Datei herunterladen',0),(510912,14192,'en','Download EFT File',0),(510913,14193,'is','',0),(510914,14193,'dr','Ù‡ÛŒÚ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ú©ÛŒ',0),(510915,14193,'pr','Ù‡ÛŒÚ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ú©ÛŒ',0),(510916,14193,'tr','HiÃ§bir banka hesaplarÄ±mÄ±z',0),(510917,14193,'pl','Brak informacji bankowych',0),(510918,14193,'bg','ÐÑÐ¼Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(510919,14193,'ur','Ú©ÙˆØ¦ÛŒ Ø¨ÛŒÙ†Ú© Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(510920,14193,'sr','ÐÐµÐ¼Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ Ð±Ð°Ð½Ñ†Ð¸',0),(510921,14193,'vi','KhÃ´ng cÃ³ thÃ´ng tin ngÃ¢n hÃ ng',0),(510922,14193,'af','Geen Bank Info',0),(510923,14193,'ro','Nu Banca de informatii',0),(510924,14193,'et','Panga Info',0),(510925,14193,'si','Nobena banka Info',0),(510926,14193,'ba','Tidak ada Info Bank',0),(510927,14193,'nl','Geen Bank Info',0),(510928,14193,'fi','Ei pankki Info',0),(510929,14193,'no','Ingen Bank Info',0),(510930,14193,'da','Ingen Bank Info',0),(510931,14193,'ko','ì•„ë‹ˆ ì€í–‰ ì •ë³´',0),(510932,14193,'he','××™×Ÿ ×ž×™×“×¢ ×‘×‘× ×§',0),(510933,14193,'el','Î”ÎµÎ½ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï„ÏÎ¬Ï€ÎµÎ¶Î±',0),(510934,14193,'zh','æ²¡æœ‰é“¶è¡Œä¿¡æ¯',0),(510935,14193,'sv','Ingen Bank Info',0),(510936,14193,'it','Nessuna banca Info',0),(510937,14193,'tl','',0),(510938,14193,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸˜à¸™à¸²à¸„à¸²à¸£à¹„à¸¡à¹ˆ',0),(510939,14193,'hi','à¤•à¥‹à¤ˆ à¤¬à¥ˆà¤‚à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(510940,14193,'ms','Tiada maklumat Bank',0),(510941,14193,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¨Ù†Ùƒ',0),(510942,14193,'fr','Aucune Info de la Banque',0),(510943,14193,'jp','éŠ€è¡Œæƒ…å ±ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(510944,14193,'pt','Nenhuma informaÃ§Ã£o bancÃ¡ria',0),(510945,14193,'ru','ÐÐµÑ‚ Ð±Ð°Ð½Ðº Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(510946,14193,'es','No hay informaciÃ³n de banco',0),(510947,14193,'de','Kein Bankinfo',0),(510948,14193,'en','No Bank Info',0),(510949,14194,'is','',0),(510950,14194,'dr','Ø§ÛŒØ¬Ø§Ø¯ ÙØ§ÛŒÙ„ EFT',0),(510951,14194,'pr','Ø§ÛŒØ¬Ø§Ø¯ ÙØ§ÛŒÙ„ EFT',0),(510952,14194,'tr','EFT dosyasÄ± oluÅŸturma',0),(510953,14194,'pl','UtwÃ³rz plik EFT',0),(510954,14194,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ Ñ„Ð°Ð¹Ð» Ñ Ð•ÐŸÐ¡',0),(510955,14194,'ur','EFT Ù…Ø³Ù„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(510956,14194,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð•Ð¤Ð¢',0),(510957,14194,'vi','Táº¡o táº­p tin EFT',0),(510958,14194,'af','EFT-lÃªer skep nie',0),(510959,14194,'ro','CreaÅ£i EFT fiÅŸier',0),(510960,14194,'et','EFT faili loomine',0),(510961,14194,'si','Ustvarite datoteko EFT',0),(510962,14194,'ba','Membuat File TDE',0),(510963,14194,'nl','EFT bestand maken',0),(510964,14194,'fi','EFT-tiedoston luominen',0),(510965,14194,'no','Opprette EFT fil',0),(510966,14194,'da','Oprette EFT-filen',0),(510967,14194,'ko','ì „ìž ì†¡ê¸ˆ íŒŒì¼ ë§Œë“¤ê¸°',0),(510968,14194,'he','×™×¦×™×¨×ª ×§×•×‘×¥ EFT',0),(510969,14194,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï… EFT',0),(510970,14194,'zh','åˆ›å»º EFT æ–‡ä»¶',0),(510971,14194,'sv','Skapa EFT-fil',0),(510972,14194,'it','Creare File EFT',0),(510973,14194,'tl','',0),(510974,14194,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹à¸Ÿà¹‰à¸¡ EFT',0),(510975,14194,'hi','à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤«à¤¼à¤¾à¤‡à¤² à¤¬à¤¨à¤¾à¤à¤',0),(510976,14194,'ms','Mencipta fail EFT',0),(510977,14194,'ar','Ù‚Ù… Ø¨Ø¥Ù†Ø´Ø§Ø¡ Ù…Ù„Ù ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø£Ù…ÙˆØ§Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(510978,14194,'fr','CrÃ©er le fichier de l\'EFT',0),(510979,14194,'jp','EFT ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(510980,14194,'pt','Criar arquivo EFT',0),(510981,14194,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ñ„Ð°Ð¹Ð» EFT',0),(510982,14194,'es','Crear archivo de EFT',0),(510983,14194,'de','EFT-Datei erstellen',0),(510984,14194,'en','Create EFT File',0),(510985,14195,'is','',0),(510986,14195,'dr','Ù…ÙˆØ¹Ø¯ Ù…Ù‚Ø±Ø± Ø¯Ø± ÛŒØ§ Ù‚Ø¨Ù„ Ø§Ø²',0),(510987,14195,'pr','Ù…ÙˆØ¹Ø¯ Ù…Ù‚Ø±Ø± Ø¯Ø± ÛŒØ§ Ù‚Ø¨Ù„ Ø§Ø²',0),(510988,14195,'tr','BitiÅŸ Tarihi eÅŸittir veya Ã¶nce',0),(510989,14195,'pl','Termin na lub przed',0),(510990,14195,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶ Ð½Ð° Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐ´Ð¸',0),(510991,14195,'ur','ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ ØªØ§Ø±ÛŒØ® Ù¾Ø± ÛŒØ§ Ø§Ø³ Ø³Û’ Ù¾ÛÙ„Û’',0),(510992,14195,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº Ð´Ð¾ Ð¸Ð»Ð¸ Ð¿Ñ€Ðµ',0),(510993,14195,'vi','NgÃ y Ä‘Ã¡o háº¡n vÃ o hoáº·c trÆ°á»›c',0),(510994,14195,'af','Sperdatum voor of op',0),(510995,14195,'ro','ScadenÈ›Äƒ sau Ã®nainte',0),(510996,14195,'et','TÃ¤htaeg kuupÃ¤eval vÃµi enne',0),(510997,14195,'si','Rok do ali pred',0),(510998,14195,'ba','Pada atau sebelum jatuh tempo',0),(510999,14195,'nl','Vervaldatum op of vÃ³Ã³r',0),(511000,14195,'fi','MÃ¤Ã¤rÃ¤pÃ¤ivÃ¤ viimeistÃ¤Ã¤n',0),(511001,14195,'no','Forfallsdato pÃ¥ eller fÃ¸r',0),(511002,14195,'da','Forfaldsdato pÃ¥ eller fÃ¸r',0),(511003,14195,'ko','ë§Œê¸°ì¼ ë˜ëŠ” ê·¸ ì´ì „ì—',0),(511004,14195,'he','×ª××¨×™×š ×™×¢×“ ××• ×œ×¤× ×™×•',0),(511005,14195,'el','Î—Î¼/Î½Î¯Î± ÎºÎ±Ï„Î¬ Î® Ï€ÏÎ¹Î½ Î±Ï€ÏŒ',0),(511006,14195,'zh','åˆ°æœŸæ—¥æˆ–ä¹‹å‰',0),(511007,14195,'sv','FÃ¶rfallodatumet pÃ¥ eller fÃ¶re',0),(511008,14195,'it','Data di scadenza o prima',0),(511009,14195,'tl','',0),(511010,14195,'th','à¸§à¸±à¸™à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸” à¸«à¸£à¸·à¸­à¸à¹ˆà¸­à¸™',0),(511011,14195,'hi','à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‹ à¤¯à¤¾ à¤‡à¤¸à¤•à¥‡ à¤ªà¤¹à¤²à¥‡',0),(511012,14195,'ms','Tarikh kena dibayar pada atau sebelum',0),(511013,14195,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ ÙÙŠ Ø£Ùˆ Ù‚Ø¨Ù„',0),(511014,14195,'fr','Date d\'Ã©chÃ©ance ou avant',0),(511015,14195,'jp','æœŸæ—¥ã¾ã§ã«',0),(511016,14195,'pt','Data de vencimento em ou antes de',0),(511017,14195,'ru','Ð¡Ñ€Ð¾Ðº Ð¸Ð»Ð¸ Ð´Ð¾',0),(511018,14195,'es','Fecha de vencimiento o antes',0),(511019,14195,'de','FÃ¤lligkeit am oder vor',0),(511020,14195,'en','Due Date On Or Before',0),(511021,14196,'is','',0),(511022,14196,'dr','EFT Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(511023,14196,'pr','EFT Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(511024,14196,'tr','EFT dosyasÄ± oluÅŸturuldu',0),(511025,14196,'pl','EFT plik zostaÅ‚ utworzony',0),(511026,14196,'bg','EFT Ñ„Ð°Ð¹Ð» Ðµ Ð±Ð¸Ð» ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½',0),(511027,14196,'ur','EFT Ù…Ø³Ù„ Ø¨Ù†Ø§Ø¦ÛŒ Ú¯Ø¦ÛŒ ÛÛ’',0),(511028,14196,'sr','Ð•Ð¤Ð¢ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ñ˜Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°',0),(511029,14196,'vi','EFT táº­p tin Ä‘Ã£ Ä‘Æ°á»£c táº¡o ra',0),(511030,14196,'af','EFT lÃªer geskep het',0),(511031,14196,'ro','EFT fiÅŸier a fost creat',0),(511032,14196,'et','Nupuikoon EFT faili',0),(511033,14196,'si','Ustvarjena je bila datoteka EFT',0),(511034,14196,'ba','TDE File telah dibuat',0),(511035,14196,'nl','EFT bestand is gemaakt',0),(511036,14196,'fi','EFT on luotu',0),(511037,14196,'no','EFT-filen er opprettet',0),(511038,14196,'da','EFT-filen er blevet oprettet',0),(511039,14196,'ko','ì „ìž ì†¡ê¸ˆ íŒŒì¼ì´ ìƒì„± ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(511040,14196,'he','EFT ×”×§×•×‘×¥ × ×•×¦×¨',0),(511041,14196,'el','EFT Î±ÏÏ‡ÎµÎ¯Î¿ Î­Ï‡ÎµÎ¹ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸ÎµÎ¯',0),(511042,14196,'zh','EFT æ–‡ä»¶å·²åˆ›å»º',0),(511043,14196,'sv','EFT-filen har skapats',0),(511044,14196,'it','Ãˆ stato creato il File EFT',0),(511045,14196,'tl','',0),(511046,14196,'th','à¸¡à¸µà¸à¸²à¸£à¸ªà¸£à¹‰à¸²à¸‡à¹„à¸Ÿà¸¥à¹Œ EFT',0),(511047,14196,'hi','à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤«à¤¼à¤¾à¤‡à¤² à¤¬à¤¨à¤¾à¤ˆ à¤—à¤ˆ à¤¹à¥ˆ',0),(511048,14196,'ms','Fail EFT telah dicipta',0),(511049,14196,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ù…Ù„Ù EFT',0),(511050,14196,'fr','EFT fichier a Ã©tÃ© crÃ©Ã©',0),(511051,14196,'jp','EFT ãƒ•ã‚¡ã‚¤ãƒ«ãŒä½œæˆã•ã‚Œã¾ã—ãŸ',0),(511052,14196,'pt','Arquivo EFT foi criado',0),(511053,14196,'ru','EFT Ñ„Ð°Ð¹Ð» Ð±Ñ‹Ð» ÑÐ¾Ð·Ð´Ð°Ð½',0),(511054,14196,'es','Se ha creado el archivo EFT',0),(511055,14196,'de','EFT-Datei wurde erstellt',0),(511056,14196,'en','EFT File Has Been Created',0),(511057,14197,'is','',0),(511058,14197,'dr','EFT Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(511059,14197,'pr','EFT Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(511060,14197,'tr','EFT Ã¶demelerini girin',0),(511061,14197,'pl','WprowadÅº EFT pÅ‚atnoÅ›ci',0),(511062,14197,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ EFT Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(511063,14197,'ur','EFT Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(511064,14197,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð•Ð¤Ð¢ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(511065,14197,'vi','Nháº­p EFT thanh toÃ¡n',0),(511066,14197,'af','Tik EFT betalings',0),(511067,14197,'ro','IntroduceÅ£i EFT plÄƒÅ£i',0),(511068,14197,'et','EFT maksete tasakaalustamisel',0),(511069,14197,'si','Vnesite EFT plaÄila',0),(511070,14197,'ba','Masukkan pembayaran TDE',0),(511071,14197,'nl','EFT betalingen invoeren',0),(511072,14197,'fi','SyÃ¶tÃ¤ EFT-maksut',0),(511073,14197,'no','Angi EFT betalinger',0),(511074,14197,'da','Angiv EFT betalinger',0),(511075,14197,'ko','ì „ìž ì†¡ê¸ˆ ì§€ë¶ˆì„ ìž…ë ¥',0),(511076,14197,'he','×”×–×Ÿ ×ª×©×œ×•×ž×™ EFT',0),(511077,14197,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î—ÎœÎ§',0),(511078,14197,'zh','è¾“å…¥ EFT ä»˜æ¬¾',0),(511079,14197,'sv','Ange EFT betalningar',0),(511080,14197,'it','Immettere pagamenti EFT',0),(511081,14197,'tl','',0),(511082,14197,'th','à¸›à¹‰à¸­à¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ EFT',0),(511083,14197,'hi','à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶',0),(511084,14197,'ms','Masukkan pembayaran EFT',0),(511085,14197,'ar','Ø£Ø¯Ø®Ù„ ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø£Ù…ÙˆØ§Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(511086,14197,'fr','Entrer les paiements EFT',0),(511087,14197,'jp','éŠ€è¡Œå£åº§æŒ¯è¾¼ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(511088,14197,'pt','Digite EFT pagamentos',0),(511089,14197,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(511090,14197,'es','Ingresar los pagos EFT',0),(511091,14197,'de','Geben Sie EFT Zahlungen',0),(511092,14197,'en','Enter EFT Payments',0),(511093,14198,'is','',0),(511094,14198,'dr','Ø¨Ø¯ÙˆÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ù†ØªØ®Ø§Ø¨',0),(511095,14198,'pr','Ø¨Ø¯ÙˆÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ù†ØªØ®Ø§Ø¨',0),(511096,14198,'tr','SeÃ§ili Ã¶deme yok',0),(511097,14198,'pl','PÅ‚atnoÅ›ci, nie wybrany',0),(511098,14198,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(511099,14198,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(511100,14198,'sr','ÐÐµÐ¼Ð° Ð¸ÑÐ¿Ð»Ð°Ñ‚Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(511101,14198,'vi','KhÃ´ng cÃ³ thanh toÃ¡n chá»n',0),(511102,14198,'af','Geen betalings gekies',0),(511103,14198,'ro','Nici o platÄƒ selectate',0),(511104,14198,'et','Valitud vÃ¤ljamakseid',0),(511105,14198,'si','Brez plaÄila, izbrana',0),(511106,14198,'ba','Tidak ada pembayaran yang dipilih',0),(511107,14198,'nl','Geen betalingen geselecteerd',0),(511108,14198,'fi','Maksuja ei ole valittu',0),(511109,14198,'no','Ingen betalinger valgt',0),(511110,14198,'da','Ingen betalinger, der er valgt',0),(511111,14198,'ko','ì•„ë‹ˆ ê²°ì œ ì„ íƒ',0),(511112,14198,'he','×œ×œ× ×ª×©×œ×•×ž×™× ×©× ×‘×—×¨×•',0),(511113,14198,'el','ÎšÎ±Î¼Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î® Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(511114,14198,'zh','æ²¡æœ‰é€‰å®šçš„ä»˜æ¬¾',0),(511115,14198,'sv','Inga betalningar som valts',0),(511116,14198,'it','Nessun pagamento selezionato',0),(511117,14198,'tl','',0),(511118,14198,'th','à¹„à¸¡à¹ˆà¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(511119,14198,'hi','à¤•à¥‹à¤ˆ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤¿à¤¯à¤¾',0),(511120,14198,'ms','Tiada bayaran yang dipilih',0),(511121,14198,'ar','Ø£ÙŠ Ù…Ø¯ÙÙˆØ¹Ø§Øª Ù…Ø­Ø¯Ø¯Ø©',0),(511122,14198,'fr','Aucun paiement sÃ©lectionnÃ©',0),(511123,14198,'jp','é¸æŠžã—ãŸãŠæ”¯æ‰•ä¸è¦',0),(511124,14198,'pt','NÃ£o hÃ¡ pagamentos selecionados',0),(511125,14198,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(511126,14198,'es','No hay pagos seleccionados',0),(511127,14198,'de','Keine Zahlungen ausgewÃ¤hlt',0),(511128,14198,'en','No Payments Selected',0),(511129,14199,'is','',0),(511130,14199,'dr','Ú†Ø§Ù¾ ÙØ§Ú©ØªÙˆØ± Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…ÛŒ Ø´ÙˆØ¯',0),(511131,14199,'pr','Ú†Ø§Ù¾ ÙØ§Ú©ØªÙˆØ± Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…ÛŒ Ø´ÙˆØ¯',0),(511132,14199,'tr','Ã–denmiÅŸ faturalar yazdÄ±rÄ±n',0),(511133,14199,'pl','WydrukowaÄ‡ faktury pÅ‚atne',0),(511134,14199,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(511135,14199,'ur','ØªÙ†Ø®ÙˆØ§Û ÙˆØ¨Ø¬Ù„ÛŒ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(511136,14199,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›ÐµÐ½Ð¸Ñ… Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(511137,14199,'vi','In tráº£ tiá»n hÃ³a Ä‘Æ¡n',0),(511138,14199,'af','Betaalde fakture te druk',0),(511139,14199,'ro','TipÄƒriÅ£i facturi plÄƒtite',0),(511140,14199,'et','Prindi tasutud arved',0),(511141,14199,'si','Natisni plaÄal faktur',0),(511142,14199,'ba','Mencetak faktur dibayar',0),(511143,14199,'nl','Betaalde facturen afdrukken',0),(511144,14199,'fi','Tulostaa maksettujen laskujen',0),(511145,14199,'no','Skrive ut betalt fakturaer',0),(511146,14199,'da','Udskrive betalte fakturaer',0),(511147,14199,'ko','ì§€ë¶ˆëœ ì¸ë³´ì´ìŠ¤ë¥¼ ì¸ì‡„',0),(511148,14199,'he','×œ×”×“×¤×™×¡ ×—×©×‘×•× ×™×•×ª ×©×©×•×œ×ž×•',0),(511149,14199,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÎ¾ÏŒÏ†Î»Î·ÏƒÎµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(511150,14199,'zh','æ‰“å°å·²ä»˜çš„å‘ç¥¨',0),(511151,14199,'sv','Skriva ut betalda fakturor',0),(511152,14199,'it','Stampare le fatture pagate',0),(511153,14199,'tl','',0),(511154,14199,'th','à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(511155,14199,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(511156,14199,'ms','Mencetak invois dibayar',0),(511157,14199,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(511158,14199,'fr','Imprimer des factures payÃ©es',0),(511159,14199,'jp','æ”¯æ‰•ã„æ¸ˆã¿è«‹æ±‚æ›¸ã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(511160,14199,'pt','Imprimir facturas pagas',0),(511161,14199,'ru','Ð Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚Ð°Ñ‚ÑŒ Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(511162,14199,'es','Imprimir facturas pagadas',0),(511163,14199,'de','Bezahlte Rechnungen drucken',0),(511164,14199,'en','Print Paid Invoices',0),(511165,14200,'is','',0),(511166,14200,'dr','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…ÛŒÙ† Ù„Ø§ÛŒØ­Ù‡ ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±.',0),(511167,14200,'pr','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…ÛŒÙ† Ù„Ø§ÛŒØ­Ù‡ ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±.',0),(511168,14200,'tr','Ek satÄ±r Ã¶ÄŸeleri aynÄ± tasarÄ± sadece satÄ±cÄ± adÄ± ve fatura numarasÄ± gerekir.',0),(511169,14200,'pl','Dodatkowe pozycje w tym samym rachunku wystarczy nazwÄ™ producenta oraz numer faktury.',0),(511170,14200,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ð² ÐµÐ´Ð½Ð° Ð¸ ÑÑŠÑ‰Ð° Ð±Ð¸Ð» Ñ‚Ñ€ÑÐ±Ð²Ð° ÑÐ°Ð¼Ð¾ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°.',0),(511171,14200,'ur','Ø§Ø¶Ø§ÙÛŒ Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§Ø¡ Ø§ÛŒÚ© ÛÛŒ Ø¨Ù„ Ù…ÛŒÚº ØµØ±Ù Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø§ÙˆØ± ÙØ±ÙˆØ´Ù†Ø¯Û Ù†Ø§Ù… Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(511172,14200,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ñ€ÐµÐ´Ñƒ Ñƒ Ð¸ÑÑ‚Ð¸ Ð½Ð°Ñ†Ñ€Ñ‚ Ñ‚Ñ€ÐµÐ±Ð°Ñ˜Ñƒ ÑÐ°Ð¼Ð¾ Ð¸Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ.',0),(511173,14200,'vi','ThÃªm chi tiáº¿t Ä‘Æ¡n hÃ ng trong hÃ³a Ä‘Æ¡n cÃ¹ng má»™t chá»‰ cáº§n nhÃ  cung cáº¥p tÃªn vÃ  sá»‘ hÃ³a Ä‘Æ¡n.',0),(511174,14200,'af','Bykomende lyn items in die dieselfde Wetsontwerp hoef net die verkoper se naam en nommer van die faktuur.',0),(511175,14200,'ro','Elemente suplimentare de linie Ã®n acelaÅŸi bill nevoie doar de numele furnizorului ÅŸi numÄƒrul facturii.',0),(511176,14200,'et','Sama bill tÃ¤iendavaid kirjeid tuleb ainult hankija nimi ja arve number.',0),(511177,14200,'si','Dodatne vrstiÄne postavke v isti raÄun morate le ime dobavitelja in Å¡tevilko raÄuna.',0),(511178,14200,'ba','Item baris tambahan dalam undang-undang sama hanya memerlukan nama Penjual dan nomor faktur.',0),(511179,14200,'nl','Extra regelitems in de dezelfde factuur hoeft alleen de naam van de verkoper en het factuurnummer.',0),(511180,14200,'fi','Muita eriÃ¤ samasta tuoterakenteesta tarvitsee vain toimittajan nimi ja numero.',0),(511181,14200,'no','Flere linjeelementer i samme bill trenger bare leverandÃ¸rnavnet og fakturanummeret.',0),(511182,14200,'da','Yderligere linjeelementer i den samme bill behÃ¸ver kun kreditornavnet og fakturanummeret.',0),(511183,14200,'ko','ê°™ì€ ë²•ì•ˆì— ì¶”ê°€ í’ˆëª© ê³µê¸‰ ì—…ì²´ ì´ë¦„ ë° ì†¡ìž¥ ë²ˆí˜¸ í•„ìš”í•©ë‹ˆë‹¤.',0),(511184,14200,'he','×¤×¨×™×˜×™ ×©×•×¨×” × ×•×¡×¤×™× ×‘×”×¦×¢×ª ×”×—×•×§ ××•×ª×• ×¨×§ ×¦×¨×™×š ××ª ×©× ×”×¡×¤×§ ×•××ª ×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª.',0),(511185,14200,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ„Î¿ Î¯Î´Î¹Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï€ÏÎ­Ï€ÎµÎ¹ Î¼ÏŒÎ½Î¿ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÎºÎ±Î¹ Î¿ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï….',0),(511186,14200,'zh','é¢å¤–çš„è¡Œé¡¹ç›®ä¸­çš„åŒä¸€é¡¹æ³•æ¡ˆåªéœ€è¦ä¾›åº”å•†åç§°å’Œå‘ç¥¨ç¼–å·ã€‚',0),(511187,14200,'sv','Ytterligare poster i den samma fakturan behÃ¶ver bara leverantÃ¶rens namn och fakturanummer.',0),(511188,14200,'it','Voci aggiuntive nella stessa fattura Ã¨ sufficiente il nome del fornitore e il numero di fattura.',0),(511189,14200,'tl','',0),(511190,14200,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸™à¸šà¸´à¸¥à¹€à¸”à¸µà¸¢à¸§à¸à¸±à¸™à¸ªà¸²à¸¡à¸²à¸£à¸–à¹ƒà¸Šà¹‰à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¹à¸¥à¸°à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(511191,14200,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤°à¥‡à¤–à¤¾ à¤†à¤‡à¤Ÿà¤® à¤à¤• à¤¹à¥€ à¤¬à¤¿à¤² à¤®à¥‡à¤‚ à¤•à¥‡à¤µà¤² à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤”à¤° à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¨à¤¾à¤® à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥ˆà¥¤',0),(511192,14200,'ms','Item-item tambahan garisan dalam Rang undang-undang sama hanya perlu nama penjual dan nombor invois.',0),(511193,14200,'ar','Ø¨Ù†ÙˆØ¯ Ø¥Ø¶Ø§ÙÙŠØ© ÙÙŠ Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ù†ÙØ³Ù‡ ÙÙ‚Ø· Ø¨Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰ Ø§Ø³Ù… Ø§Ù„Ù…ÙˆØ±Ø¯ ÙˆØ±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©.',0),(511194,14200,'fr','Postes supplÃ©mentaires dans le mÃªme projet de loi a seulement besoin du nom du vendeur et le numÃ©ro de la facture.',0),(511195,14200,'jp','åŒã˜ãƒ“ãƒ«å†…ã®è¿½åŠ ã®è¡Œã‚¢ã‚¤ãƒ†ãƒ ã«ã¯ã€ãƒ™ãƒ³ãƒ€ãƒ¼ã®åå‰ã¨è«‹æ±‚æ›¸ç•ªå·ã®ã¿å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(511196,14200,'pt','Linhas de itens adicionais na mesma conta precisa apenas o nome do fornecedor e o nÃºmero da factura.',0),(511197,14200,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð² Ñ‚Ð¾Ð¼ Ð¶Ðµ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ðµ Ð½ÑƒÐ¶Ð½Ð¾ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¸Ð¼Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¸ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹.',0),(511198,14200,'es','Partidas adicionales en el mismo proyecto de ley sÃ³lo necesita el nombre del proveedor y el nÃºmero de factura.',0),(511199,14200,'de','ZusÃ¤tzliche Posten in der gleichen Rechnung brauchen nur den Herstellernamen und die Rechnungsnummer an.',0),(511200,14200,'en','Additional line items in the same bill only need the vendor name and the invoice number.',0),(511201,14201,'is','',0),(511202,14201,'dr','Ø³ØªÙˆÙ† Ù‡Ø§ÛŒ Ø¨ÛŒÙ„',0),(511203,14201,'pr','Ø³ØªÙˆÙ† Ù‡Ø§ÛŒ Ø¨ÛŒÙ„',0),(511204,14201,'tr','Bill sÃ¼tunlar',0),(511205,14201,'pl','Bill kolumny',0),(511206,14201,'bg','Ð‘Ð¸Ð» ÐºÐ¾Ð»Ð¾Ð½Ð¸',0),(511207,14201,'ur','Ø¨Ù„ Ú©Ø§Ù„Ù…',0),(511208,14201,'sr','Ð‘Ð¸Ð» ÐºÐ¾Ð»Ð¾Ð½Ðµ',0),(511209,14201,'vi','Bill cá»™t',0),(511210,14201,'af','Wetsontwerp kolomme',0),(511211,14201,'ro','Bill coloane',0),(511212,14201,'et','Bill veerud',0),(511213,14201,'si','Bill stolpcev',0),(511214,14201,'ba','Bill kolom',0),(511215,14201,'nl','Bill kolommen',0),(511216,14201,'fi','Bill sarakkeet',0),(511217,14201,'no','Bill kolonner',0),(511218,14201,'da','Bill kolonner',0),(511219,14201,'ko','ê³„ì‚° ì—´',0),(511220,14201,'he','×‘×™×œ ×¢×ž×•×“×•×ª',0),(511221,14201,'el','Bill ÏƒÏ„Î®Î»ÎµÏ‚',0),(511222,14201,'zh','æ¡ä¾‹è‰æ¡ˆåˆ—',0),(511223,14201,'sv','Bill kolumner',0),(511224,14201,'it','Bill colonne',0),(511225,14201,'tl','',0),(511226,14201,'th','à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œà¸£à¸²à¸¢à¸à¸²à¸£',0),(511227,14201,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤•à¥‰à¤²à¤®',0),(511228,14201,'ms','Kolum Rang undang-undang',0),(511229,14201,'ar','Ø£Ø¹Ù…Ø¯Ø© Ø¨ÙŠÙ„',0),(511230,14201,'fr','Colonnes de Bill',0),(511231,14201,'jp','ãƒ“ãƒ«ã®åˆ—',0),(511232,14201,'pt','Colunas de Bill',0),(511233,14201,'ru','Ð‘Ð¸Ð»Ð» ÑÑ‚Ð¾Ð»Ð±Ñ†Ñ‹',0),(511234,14201,'es','Bill columnas',0),(511235,14201,'de','Bill Spalten',0),(511236,14201,'en','Bill Columns',0),(511237,14202,'is','',0),(511238,14202,'dr','ÙØ§ÛŒÙ„ CSV Ø¨ÛŒÙ„',0),(511239,14202,'pr','ÙØ§ÛŒÙ„ CSV Ø¨ÛŒÙ„',0),(511240,14202,'tr','Bill CSV dosya',0),(511241,14202,'pl','Pliku Bill CSV',0),(511242,14202,'bg','Ð‘Ð¸Ð» CSV Ñ„Ð°Ð¹Ð»',0),(511243,14202,'ur','Ø¨Ù„ CSV ÙØ§Ø¦Ù„',0),(511244,14202,'sr','Ð‘Ð¸Ð»Ð» Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(511245,14202,'vi','Bill CSV File',0),(511246,14202,'af','Wetsontwerp CSV-lÃªer',0),(511247,14202,'ro','Bill CSV dosar',0),(511248,14202,'et','Bill CSV-faili',0),(511249,14202,'si','Bill CSV datoteke',0),(511250,14202,'ba','File Bill CSV',0),(511251,14202,'nl','Bill CSV-bestand',0),(511252,14202,'fi','Bill CSV-tiedosto',0),(511253,14202,'no','Bill CSV-fil',0),(511254,14202,'da','Bill CSV-fil',0),(511255,14202,'ko','ë¹Œ CSV íŒŒì¼',0),(511256,14202,'he','×§×•×‘×¥ CSV ×‘×™×œ',0),(511257,14202,'el','Bill CSV Î±ÏÏ‡ÎµÎ¯Î¿',0),(511258,14202,'zh','æ¡ä¾‹è‰æ¡ˆ CSV æ–‡ä»¶',0),(511259,14202,'sv','Bill CSV-filen',0),(511260,14202,'it','File CSV di Bill',0),(511261,14202,'tl','',0),(511262,14202,'th','à¹„à¸Ÿà¸¥à¹Œ CSV à¸•à¸±à¹‹à¸§',0),(511263,14202,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• CSV à¤«à¤¼à¤¾à¤‡à¤²',0),(511264,14202,'ms','Fail CSV Rang undang-undang',0),(511265,14202,'ar','Ù…Ù„Ù CSV Ø¨ÙŠÙ„',0),(511266,14202,'fr','Fichier CSV de Bill',0),(511267,14202,'jp','ãƒ“ãƒ«ã® CSV ãƒ•ã‚¡ã‚¤ãƒ«',0),(511268,14202,'pt','Arquivo CSV Bill',0),(511269,14202,'ru','Ð‘Ð¸Ð»Ð» CSV-Ñ„Ð°Ð¹Ð»Ð°',0),(511270,14202,'es','Archivo CSV Bill',0),(511271,14202,'de','Bill CSV-Datei',0),(511272,14202,'en','Bill CSV File',0),(511273,14203,'is','',0),(511274,14203,'dr','Ø³ØªÙˆÙ†',0),(511275,14203,'pr','Ø³ØªÙˆÙ†',0),(511276,14203,'tr','SÃ¼tun',0),(511277,14203,'pl','Kolumna',0),(511278,14203,'bg','ÐšÐ¾Ð»Ð¾Ð½Ð°',0),(511279,14203,'ur','Ú©Ø§Ù„Ù…',0),(511280,14203,'sr','ÐšÐ¾Ð»Ð¾Ð½Ð°',0),(511281,14203,'vi','Cá»™t',0),(511282,14203,'af','Kolom',0),(511283,14203,'ro','ColoanÄƒ',0),(511284,14203,'et','Veerg',0),(511285,14203,'si','Stolpec',0),(511286,14203,'ba','Kolom',0),(511287,14203,'nl','Kolom',0),(511288,14203,'fi','Sarake',0),(511289,14203,'no','Kolonne',0),(511290,14203,'da','Kolonne',0),(511291,14203,'ko','ì—´',0),(511292,14203,'he','×˜×•×¨',0),(511293,14203,'el','Î£Ï„Î®Î»Î·',0),(511294,14203,'zh','åˆ—',0),(511295,14203,'sv','Kolumn',0),(511296,14203,'it','Colonna',0),(511297,14203,'tl','',0),(511298,14203,'th','à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œ',0),(511299,14203,'hi','à¤¸à¥à¤¤à¤‚à¤­',0),(511300,14203,'ms','Kolum',0),(511301,14203,'ar','Ø¹Ù…ÙˆØ¯',0),(511302,14203,'fr','Colonne',0),(511303,14203,'jp','åˆ—',0),(511304,14203,'pt','Coluna',0),(511305,14203,'ru','ÐšÐ¾Ð»Ð¾Ð½ÐºÐ°',0),(511306,14203,'es','Columna',0),(511307,14203,'de','Spalte',0),(511308,14203,'en','Column',0),(511309,14204,'is','',0),(511310,14204,'dr','Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ù‡ Ø¬Ø±ÛŒØ§Ù† ØªØ§Ø±ÛŒØ® Ø§Ú¯Ø± Ù†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(511311,14204,'pr','Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ù‡ Ø¬Ø±ÛŒØ§Ù† ØªØ§Ø±ÛŒØ® Ø§Ú¯Ø± Ù†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(511312,14204,'tr','VarsayÄ±lan deÄŸerler geÃ§erli tarih deÄŸilse ayarla',0),(511313,14204,'pl','DomyÅ›lnie bieÅ¼Ä…cego dnia, jeÅ›li nie zestaw',0),(511314,14204,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ðµ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°, Ð°ÐºÐ¾ Ð½Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ',0),(511315,14204,'ur','Ø­Ø§Ù„ÛŒÛ Ø·Û’ Ø´Ø¯Û ØªØ§Ø±ÛŒØ® Ù†ÛÛŒÚº ØªÙˆ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(511316,14204,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ñ‚ÐµÐºÑƒÑ›Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð°ÐºÐ¾ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸',0),(511317,14204,'vi','Máº·c Ä‘á»‹nh hiá»‡n táº¡i ngÃ y náº¿u khÃ´ng thiáº¿t láº­p',0),(511318,14204,'af','Verstek by huidige datum indien nie stel',0),(511319,14204,'ro','Implicite curent datÄƒ dacÄƒ nu setaÅ£i',0),(511320,14204,'et','VaikevÃ¤Ã¤rtus on praegune kuupÃ¤ev kui mitte seada',0),(511321,14204,'si','NeplaÄil trenutni datum, Äe ne nastavite',0),(511322,14204,'ba','Default ke arus tanggal jika tidak diatur',0),(511323,14204,'nl','Wordt standaard ingesteld op de huidige datum als niet ingesteld',0),(511324,14204,'fi','Oletusarvo on nykyinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤, jos ei ole asetettu',0),(511325,14204,'no','Standarder til gjeldende dato hvis ikke satt',0),(511326,14204,'da','Standardindstillinger til aktuelle dato hvis ikke indstillet',0),(511327,14204,'ko','ê¸°ë³¸ê°’: í˜„ìž¬ ë‚ ì§œ ì„¤ì • ë˜ì§€ ì•Šì€ ê²½ìš°',0),(511328,14204,'he','×¢×¨×š ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×”× ×•×›×—×™ ×ª××¨×™×š ×× ×œ× ×ž×•×’×“×¨',0),(511329,14204,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚ Î³Î¹Î± Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î½ Î´ÎµÎ½ Î¿ÏÎ¯ÏƒÎµÏ„Îµ',0),(511330,14204,'zh','æ²¡æœ‰è®¾ç½®é»˜è®¤ä¸ºå½“å‰æ—¥æœŸ',0),(511331,14204,'sv','StandardvÃ¤rdet Ã¤r aktuell datum om inte ange',0),(511332,14204,'it','Impostazioni predefinite alla corrente data se non impostato',0),(511333,14204,'tl','',0),(511334,14204,'th','à¸„à¹ˆà¸²à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¸§à¸±à¸™à¸–à¹‰à¸² à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡',0),(511335,14204,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ªà¤° à¤¤à¤¾à¤°à¥€à¤– à¤¨à¤¹à¥€à¤‚ à¤¤à¥‹ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(511336,14204,'ms','Lalai kepada semasa tarikh jika tidak Set',0),(511337,14204,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ø§Ù„Ø­Ø§Ù„ÙŠØ© ÙˆØ­ØªÙ‰ Ø§Ù„Ø¢Ù† Ù„Ù… ÙŠÙƒÙ† ØªØ¹ÙŠÙŠÙ†',0),(511338,14204,'fr','La valeur par dÃ©faut actuelle Date si elle n\'est pas dÃ©finie',0),(511339,14204,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã¯ç¾åœ¨ã®æ—¥ä»˜ã®è¨­å®šã•ã‚Œã¦ã„ãªã„å ´åˆ',0),(511340,14204,'pt','O padrÃ£o atual data se nÃ£o definida',0),(511341,14204,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ Ñ‚ÐµÐºÑƒÑ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹, ÐµÑÐ»Ð¸ Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(511342,14204,'es','Por defecto actual fecha si no se establece',0),(511343,14204,'de','Standardwert Current Date wenn nicht festgelegt',0),(511344,14204,'en','Defaults To Current Date If Not Set',0),(511345,14205,'is','',0),(511346,14205,'dr','Ø´Ø±Ø­ Ø¨ÛŒÙ„ Ú©Ù„',0),(511347,14205,'pr','Ø´Ø±Ø­ Ø¨ÛŒÙ„ Ú©Ù„',0),(511348,14205,'tr','TÃ¼m faturasÄ± iÃ§in aÃ§Ä±klama',0),(511349,14205,'pl','Opis caÅ‚ego projektu ustawy',0),(511350,14205,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð·Ð° Ñ†ÐµÐ»Ð¸Ñ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(511351,14205,'ur','Ø§Ø³ Ù¾ÙˆØ±Û’ Ø¨Ù„ Ú©Û’ Ù„ÛŒÛ’ ØªØµØ±ÛŒØ­',0),(511352,14205,'sr','ÐžÐ¿Ð¸Ñ Ð·Ð° Ñ†ÐµÐ¾ Ð´ÑƒÐ³',0),(511353,14205,'vi','MÃ´ táº£ cho cÃ¡c hÃ³a Ä‘Æ¡n toÃ n bá»™',0),(511354,14205,'af','Beskrywing vir die hele Wetsontwerp',0),(511355,14205,'ro','Descriere pentru intreaga lege',0),(511356,14205,'et','Kogu arve kirjeldus',0),(511357,14205,'si','Opis za celoten obraÄun',0),(511358,14205,'ba','Deskripsi seluruh tagihan',0),(511359,14205,'nl','Beschrijving voor de gehele Bill',0),(511360,14205,'fi','Kuvaus koko laskun',0),(511361,14205,'no','Beskrivelse For hele regningen',0),(511362,14205,'da','Beskrivelse af hele regningen',0),(511363,14205,'ko','ì „ì²´ ë²•ì•ˆì— ëŒ€ í•œ ì„¤ëª…',0),(511364,14205,'he','×ª×™××•×¨ ×¢×‘×•×¨ ×”×—×©×‘×•×Ÿ ×›×•×œ×•',0),(511365,14205,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Î³Î¹Î± Ï„Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï„Î¿Ï… Î½Î¿Î¼Î¿ÏƒÏ‡ÎµÎ´Î¯Î¿Ï…',0),(511366,14205,'zh','æ•´æ¡æ¡ä¾‹è‰æ¡ˆçš„è¯´æ˜Ž',0),(511367,14205,'sv','Beskrivning fÃ¶r hela notan',0),(511368,14205,'it','Descrizione per l\'intero disegno di legge',0),(511369,14205,'tl','',0),(511370,14205,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(511371,14205,'hi','à¤ªà¥‚à¤°à¥‡ à¤¬à¤¿à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤µà¤°à¤£',0),(511372,14205,'ms','Perihalan untuk keseluruhan Rang undang-undang',0),(511373,14205,'ar','ÙˆØµÙ Ù„Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† ÙƒØ§Ù…Ù„',0),(511374,14205,'fr','Description du projet de loi complet',0),(511375,14205,'jp','æ³•æ¡ˆã¯ã€å…¨ä½“ã®èª¬æ˜Ž',0),(511376,14205,'pt','DescriÃ§Ã£o para o projeto inteiro',0),(511377,14205,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð´Ð»Ñ Ð²ÑÐµÐ³Ð¾ Ð‘Ð¸Ð»Ð»',0),(511378,14205,'es','DescripciÃ³n para el billete entero',0),(511379,14205,'de','Beschreibung fÃ¼r die gesamte Rechnung',0),(511380,14205,'en','Description For The Entire Bill',0),(511381,14206,'is','',0),(511382,14206,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ù‚Ø§Ù„Ø¨ Ø¯Ø§Ù†Ù„ÙˆØ¯',0),(511383,14206,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ù‚Ø§Ù„Ø¨ Ø¯Ø§Ù†Ù„ÙˆØ¯',0),(511384,14206,'tr','Åžablon Al indir',0),(511385,14206,'pl','Pobierz szablon importu',0),(511386,14206,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(511387,14206,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø³Ø§Ù†Ú†Ø§ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(511388,14206,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(511389,14206,'vi','Táº£i vá» báº£n máº«u nháº­p kháº©u',0),(511390,14206,'af','Aflaai invoer sjabloon',0),(511391,14206,'ro','DescÄƒrca ÅŸablon de Import',0),(511392,14206,'et','Lae impordi Mall',0),(511393,14206,'si','Prenesite predlogo za uvoz',0),(511394,14206,'ba','Men-download Template impor',0),(511395,14206,'nl','Download sjabloon importeren',0),(511396,14206,'fi','Lataa tuontimalli',0),(511397,14206,'no','Laste ned malen for Import',0),(511398,14206,'da','Download skabelon til Import',0),(511399,14206,'ko','ê°€ì ¸ì˜¤ê¸° ì„œì‹ íŒŒì¼ ë‹¤ìš´ë¡œë“œ',0),(511400,14206,'he','×”×•×¨×“×” ×ª×‘× ×™×ª ×™×™×‘×•×',0),(511401,14206,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(511402,14206,'zh','å¯¼å…¥æ¨¡æ¿ä¸‹è½½',0),(511403,14206,'sv','HÃ¤mta importera mall',0),(511404,14206,'it','Scarica il modello di importazione',0),(511405,14206,'tl','',0),(511406,14206,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹à¸¡à¹ˆà¹à¸šà¸šà¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(511407,14206,'hi','à¤†à¤¯à¤¾à¤¤ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(511408,14206,'ms','Muat turun Import Template',0),(511409,14206,'ar','ØªØ­Ù…ÙŠÙ„ Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(511410,14206,'fr','TÃ©lÃ©charger le modÃ¨le d\'importation',0),(511411,14206,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(511412,14206,'pt','Baixar modelo de importaÃ§Ã£o',0),(511413,14206,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(511414,14206,'es','Descargar plantilla de importaciÃ³n',0),(511415,14206,'de','Download Vorlage importieren',0),(511416,14206,'en','Download Import Template',0),(511417,14207,'is','',0),(511418,14207,'dr','Ø§Ú¯Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡ØŒ ØªØ§Ø±ÛŒØ® Ø±Ø§ Ø¨Ø± Ø§Ø³Ø§Ø³ Ø´Ø±Ø§ÛŒØ· Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(511419,14207,'pr','Ø§Ú¯Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡ØŒ ØªØ§Ø±ÛŒØ® Ø±Ø§ Ø¨Ø± Ø§Ø³Ø§Ø³ Ø´Ø±Ø§ÛŒØ· Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(511420,14207,'tr','EÄŸer deÄŸil kÃ¼me, bir tarihi temel terimler kullanÄ±lÄ±r',0),(511421,14207,'pl','JeÅ›li nie zestaw, datÄ™ na podstawie warunkÃ³w jest uÅ¼ywany',0),(511422,14207,'bg','ÐÐºÐ¾ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼, Ð´Ð°Ñ‚Ð° Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð½Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°',0),(511423,14207,'ur','Ù†ÛÛŒÚº Ø³ÛŒÙ¹ØŒ ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø± Ø§Ú¯Ø± Ø´Ø±Ø§Ø¦Ø· Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(511424,14207,'sr','ÐÐ¸Ñ˜Ðµ ÑÐºÑƒÐ¿, ÑÐ°ÑÑ‚Ð°Ð½Ð°Ðº Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ð° ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð°ÐºÐ¾',0),(511425,14207,'vi','Náº¿u khÃ´ng cÃ³ thiáº¿t láº­p, má»™t ngÃ y dá»±a trÃªn Ä‘iá»u khoáº£n Ä‘Æ°á»£c sá»­ dá»¥ng',0),(511426,14207,'af','Indien nie stel, \'n datum gebaseer op terme gebruik Is',0),(511427,14207,'ro','DacÄƒ nu Set, O datÄƒ pe baza termenilor este utilizat',0),(511428,14207,'et','Kui ei ole mÃ¤Ã¤ratud, kuupÃ¤ev termineid kasutatakse',0),(511429,14207,'si','ÄŒe ne niz, zmenek na podlagi pogojev se uporablja',0),(511430,14207,'ba','Jika tidak Set, tanggal berdasarkan istilah yang digunakan',0),(511431,14207,'nl','Als niet Set, een datum op basis van voorwaarden wordt gebruikt',0),(511432,14207,'fi','Jos ei ole asetettu, pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ perustuu termit',0),(511433,14207,'no','Hvis ikke satt, en dato basert pÃ¥ vilkÃ¥rene brukes',0),(511434,14207,'da','Hvis ikke sÃ¦t, en dato baseret pÃ¥ termer bruges',0),(511435,14207,'ko','ì„¤ì •, ë‚ ì§œì— ë”°ë¼ ìš©ì–´ ì‚¬ìš©',0),(511436,14207,'he','×× ×œ× ×¢×¨×›×ª, ×ª××¨×™×š ×‘×”×ª×‘×¡×¡ ×¢×œ ×ª× ××™ ×ž×©×ž×©',0),(511437,14207,'el','Î‘Î½ Î´ÎµÎ½ Ï„Î¿ ÏƒÏÎ½Î¿Î»Î¿, Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹',0),(511438,14207,'zh','å¦‚æžœä¸è®¾ç½®ï¼Œæ—¥æœŸåŸºäºŽæœ¯è¯­',0),(511439,14207,'sv','Om inte Set, ett datum utifrÃ¥n termer anvÃ¤nds',0),(511440,14207,'it','Se non insieme, una data base termini viene utilizzato',0),(511441,14207,'tl','',0),(511442,14207,'th','à¸–à¹‰à¸²à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡ à¸§à¸±à¸™ à¸‚à¸¶à¹‰à¸™à¸­à¸¢à¸¹à¹ˆà¸à¸±à¸š à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚à¹ƒà¸Šà¹‰',0),(511443,14207,'hi','à¤…à¤—à¤° à¤¨à¤¹à¥€à¤‚ à¤¸à¥‡à¤Ÿ, à¤à¤• à¤¤à¤¿à¤¥à¤¿ à¤ªà¤° à¤†à¤§à¤¾à¤°à¤¿à¤¤ à¤¶à¤¬à¥à¤¦à¥‹à¤‚ à¤ªà¥à¤°à¤¯à¥‹à¤— à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¹à¥ˆ',0),(511444,14207,'ms','Jika tidak Set, tarikh berdasarkan terma-terma yang digunakan',0),(511445,14207,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³ Ù…Ø¬Ù…ÙˆØ¹Ø©ØŒ ØªØ§Ø±ÙŠØ®Ø§Ù‹ ÙˆÙ„Ø§ Ù‡Ùˆ Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…ØµØ·Ù„Ø­Ø§Øª',0),(511446,14207,'fr','Si pas ensemble, une Date basÃ©e sur les termes est utilisÃ©',0),(511447,14207,'jp','æ—¥ä»˜ã®ã‚»ãƒƒãƒˆã«åŸºã¥ã„ã¦ã„ã‚‹å ´åˆã¯ã€ã“ã‚Œã‚‰ã®ç”¨èªžã—ã¾ã™ã€‚',0),(511448,14207,'pt','Se nÃ£o definido, uma data baseada em termos Ã© usado',0),(511449,14207,'ru','Ð•ÑÐ»Ð¸ Ð½Ðµ Ð½Ð°Ð±Ð¾Ñ€, Ð”Ð°Ñ‚Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ñ‚ÐµÑ€Ð¼Ð¸Ð½Ñ‹',0),(511450,14207,'es','Si no juego, una cita basada en tÃ©rminos se utiliza',0),(511451,14207,'de','Bedingungen wird verwendet, wenn nicht gesetzt, wird ein Datum auf der Grundlage',0),(511452,14207,'en','If Not Set, A Date Based On Terms Is Used',0),(511453,14208,'is','',0),(511454,14208,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(511455,14208,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(511456,14208,'tr','Fatura numarasÄ± zaten kullanÄ±lÄ±yor',0),(511457,14208,'pl','Numer faktury juÅ¼ uÅ¼ywane',0),(511458,14208,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð²ÐµÑ‡Ðµ',0),(511459,14208,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù¾ÛÙ„Û’ ÛÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§',0),(511460,14208,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð²ÐµÑ› ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(511461,14208,'vi','Sá»‘ hÃ³a Ä‘Æ¡n Ä‘Ã£ Ä‘Æ°á»£c sá»­ dá»¥ng',0),(511462,14208,'af','Faktuur nommer reeds gebruik',0),(511463,14208,'ro','NumÄƒrul facturii folosit deja',0),(511464,14208,'et','Arve Number juba kasutatud',0),(511465,14208,'si','Å tevilka raÄuna, ki Å¾e uporabljajo',0),(511466,14208,'ba','Faktur jumlah sudah digunakan',0),(511467,14208,'nl','Factuurnummer al gebruikt',0),(511468,14208,'fi','Laskunumero kÃ¤ytÃ¶ssÃ¤',0),(511469,14208,'no','Fakturanummeret allerede brukt',0),(511470,14208,'da','Fakturanummeret allerede bruges',0),(511471,14208,'ko','ì´ë¯¸ ì‚¬ìš© í•˜ëŠ” ì†¡ìž¥ ë²ˆí˜¸',0),(511472,14208,'he','×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª ×›×‘×¨ ×‘×©×™×ž×•×©',0),(511473,14208,'el','Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹ Î®Î´Î·',0),(511474,14208,'zh','å·²ä½¿ç”¨çš„å‘ç¥¨ç¼–å·',0),(511475,14208,'sv','Fakturanummer som redan anvÃ¤nds',0),(511476,14208,'it','Numero di fattura giÃ  utilizzato',0),(511477,14208,'tl','',0),(511478,14208,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¹ƒà¸Šà¹‰à¹à¸¥à¹‰à¸§',0),(511479,14208,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤° à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(511480,14208,'ms','Nombor invois yang telah digunakan',0),(511481,14208,'ar','Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„ØªÙŠ Ø§Ø³ØªØ®Ø¯Ù…Øª Ø¨Ø§Ù„ÙØ¹Ù„',0),(511482,14208,'fr','NumÃ©ro de la facture dÃ©jÃ  utilisÃ©',0),(511483,14208,'jp','æ—¢ã«ä½¿ç”¨ã•ã‚Œã¦ã„ã‚‹è«‹æ±‚æ›¸ç•ªå·',0),(511484,14208,'pt','NÃºmero de factura jÃ¡ usado',0),(511485,14208,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ ÑƒÐ¶Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ',0),(511486,14208,'es','NÃºmero de factura ya utilizado',0),(511487,14208,'de','Rechnungsnummer, die bereits verwendet',0),(511488,14208,'en','Invoice Number Already Used',0),(511489,14209,'is','',0),(511490,14209,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø®Ø· Ù…ÙˆØ±Ø¯',0),(511491,14209,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø®Ø· Ù…ÙˆØ±Ø¯',0),(511492,14209,'tr','Kalem tutarÄ±',0),(511493,14209,'pl','IloÅ›Ä‡ pozycji',0),(511494,14209,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(511495,14209,'ur','Ù„Ø§Ø¦Ù† Ø´Û’ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø±',0),(511496,14209,'sr','Ð˜Ð·Ð½Ð¾Ñ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(511497,14209,'vi','Sá»‘ tiá»n chi tiáº¿t Ä‘Æ¡n hÃ ng',0),(511498,14209,'af','Lyn-Item bedrag',0),(511499,14209,'ro','Cantitatea de element rÃ¢nd',0),(511500,14209,'et','ReaÃ¼ksuste kogusumma',0),(511501,14209,'si','Znesek vrstiÄne postavke',0),(511502,14209,'ba','Jumlah Item baris',0),(511503,14209,'nl','Lijn Artikelbedrag',0),(511504,14209,'fi','Rivinimikkeen summa',0),(511505,14209,'no','LinjeelementbelÃ¸p',0),(511506,14209,'da','Linjepost belÃ¸b',0),(511507,14209,'ko','í’ˆëª© ê¸ˆì•¡',0),(511508,14209,'he','×¡×›×•× ×¤×¨×™×˜ ×©×•×¨×”',0),(511509,14209,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚ Ï€Î¿ÏƒÏŒ',0),(511510,14209,'zh','æ˜Žç»†é¡¹ç›®é‡‘é¢',0),(511511,14209,'sv','Radartikel belopp',0),(511512,14209,'it','QuantitÃ  di elemento pubblicitario',0),(511513,14209,'tl','',0),(511514,14209,'th','à¸ˆà¸³à¸™à¸§à¸™à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸£à¸²à¸¢à¸à¸²à¸£',0),(511515,14209,'hi','à¤°à¥‡à¤–à¤¾ à¤†à¤‡à¤Ÿà¤® à¤°à¤¾à¤¶à¤¿',0),(511516,14209,'ms','Laluan Item jumlah',0),(511517,14209,'ar','Ù…Ø¨Ù„Øº Ø¨Ù†Ø¯',0),(511518,14209,'fr','Montant de la ligne de facturation',0),(511519,14209,'jp','å“ç›®ã®é¡',0),(511520,14209,'pt','Quantidade de Item de linha',0),(511521,14209,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÑ‚Ñ€Ð¾ÐºÐ¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(511522,14209,'es','Cantidad de la lÃ­nea de artÃ­culo',0),(511523,14209,'de','Positionszeile Betrag',0),(511524,14209,'en','Line Item Amount',0),(511525,14210,'is','',0),(511526,14210,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø®Ø· Ù…ÙˆØ±Ø¯ GL',0),(511527,14210,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø®Ø· Ù…ÙˆØ±Ø¯ GL',0),(511528,14210,'tr','Kalem GL hesap numarasÄ±',0),(511529,14210,'pl','Pozycja numer konta GL',0),(511530,14210,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° GL Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(511531,14210,'ur','Ù„Ø§Ø¦Ù† Ø´Û’ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø±',0),(511532,14210,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÐ¾Ð½Ñ‚Ð° Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(511533,14210,'vi','Sá»‘ tÃ i khoáº£n chi tiáº¿t Ä‘Æ¡n hÃ ng GL',0),(511534,14210,'af','Lyn-Item GL rekeningnommer',0),(511535,14210,'ro','NumÄƒrul de cont al articolului de linie GL',0),(511536,14210,'et','ReaÃ¼ksuse GL kontonumber',0),(511537,14210,'si','Å tevilka vrstiÄne postavke GL',0),(511538,14210,'ba','Item baris nomor rekening GL',0),(511539,14210,'nl','Regelitem GL rekeningnummer',0),(511540,14210,'fi','Rivinimikkeen GL tilinumero',0),(511541,14210,'no','Kontonummer for linje-GL',0),(511542,14210,'da','Linjepost GL kontonummer',0),(511543,14210,'ko','í’ˆëª© GL ê³„ì • ë²ˆí˜¸',0),(511544,14210,'he','×ž×¡×¤×¨ ×”×—×©×‘×•×Ÿ ×©×œ ×¤×¨×™×˜ ×©×•×¨×” GL',0),(511545,14210,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚ GL Î±ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(511546,14210,'zh','æ˜Žç»†é¡¹ç›® GL å¸æˆ·ç¼–å·',0),(511547,14210,'sv','GL konto artikelnummer',0),(511548,14210,'it','Numero di conto voce GL',0),(511549,14210,'tl','',0),(511550,14210,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸£à¸²à¸¢à¸à¸²à¸£',0),(511551,14210,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® GL à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(511552,14210,'ms','Nombor akaun talian Item GL',0),(511553,14210,'ar','Ø¨Ù†Ø¯ Ø±Ù‚Ù… Ø­Ø³Ø§Ø¨ GL',0),(511554,14210,'fr','NumÃ©ro de compte GL rubrique',0),(511555,14210,'jp','å“ç›® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå·',0),(511556,14210,'pt','NÃºmero de conta do Item de linha GL',0),(511557,14210,'ru','ÐŸÐ¾Ð·Ð¸Ñ†Ð¸Ñ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° GL',0),(511558,14210,'es','NÃºmero de artÃ­culo de lÃ­nea GL cuenta',0),(511559,14210,'de','Einzelposten GL-Kontonummer',0),(511560,14210,'en','Line Item GL Account Number',0),(511561,14211,'is','',0),(511562,14211,'dr','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø¨Ù„Øº Ùˆ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±',0),(511563,14211,'pr','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø¨Ù„Øº Ùˆ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±',0),(511564,14211,'tr','Fatura numarasÄ±, satÄ±cÄ± adÄ±, miktarÄ± ve geÃ§erli hesap numarasÄ± olmalÄ±dÄ±r',0),(511565,14211,'pl','Musi mieÄ‡ numer faktury, nazwa sprzedawcy, kwotÄ™ i poprawny numer konta',0),(511566,14211,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°, Ð¸Ð¼Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, ÑÑƒÐ¼Ð° Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(511567,14211,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø±ØŒ ÙˆÛŒÙ†ÚˆØ± Ù†Ø§Ù…ØŒ Ù…Ù‚Ø¯Ø§Ø± Ø§ÙˆØ± Ø¯Ø±Ø³Øª Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(511568,14211,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ \",\"Ð¸Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° \",\" Ð˜Ð·Ð½Ð¾Ñ \"Ð¸\" Ð±Ñ€Ð¾Ñ˜ Ð²Ð°Ð¶ÐµÑ›Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(511569,14211,'vi','Pháº£i cÃ³ hoÃ¡ Ä‘Æ¡n sá»‘, nhÃ  cung cáº¥p tÃªn, sá»‘ tiá»n vÃ  sá»‘ tÃ i khoáº£n há»£p lá»‡',0),(511570,14211,'af','Faktuur nommer, naam van handelaar, bedrag en geldige rekeningnommer moet hÃª',0),(511571,14211,'ro','Trebuie sÄƒ aveÅ£i numÄƒrul facturii, furnizor de nume, cantitate ÅŸi numÄƒr de cont Valid',0),(511572,14211,'et','Peab olema arve Number, mÃ¼Ã¼ja nimi, summa ja kehtiv konto Number',0),(511573,14211,'si','Mora imeti Å¡tevilko raÄuna, ime prodajalca, koliÄino in veljaven raÄun',0),(511574,14211,'ba','Harus memiliki nomor Invoice, nama Penjual, jumlah dan nomor rekening berlaku',0),(511575,14211,'nl','Moet beschikken over factuurnummer leverancier naam, bedrag en geldig rekeningnummer',0),(511576,14211,'fi','TÃ¤ytyy olla laskunumero, toimittajan nimi, mÃ¤Ã¤rÃ¤ ja voimassa tilinumero',0),(511577,14211,'no','MÃ¥ ha fakturanummer, LeverandÃ¸rnavn, belÃ¸p og gyldig kontonummer',0),(511578,14211,'da','Skal Have fakturanummer, kreditornavnet, belÃ¸b og gyldigt kontonummer',0),(511579,14211,'ko','ìœ íš¨í•œ ê³„ì¢Œ ë²ˆí˜¸, ê¸ˆì•¡, ê³µê¸‰ ì—…ì²´ ì´ë¦„, ì†¡ìž¥ ë²ˆí˜¸ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(511580,14211,'he','×—×™×™×‘ ×œ×”×™×•×ª ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª, ×©× ×”×¡×¤×§, ×›×ž×•×ª ×•×ž×¡×¤×¨ ×—×©×‘×•×Ÿ ×—×•×§×™',0),(511581,14211,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡Î¿Ï…Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…, ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®, Ï€Î¿ÏƒÏŒ ÎºÎ±Î¹ Î­Î³ÎºÏ…ÏÎ¿ Î±ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(511582,14211,'zh','å¿…é¡»å…·æœ‰å‘ç¥¨ç¼–å·ã€ ä¾›åº”å•†çš„åç§°ã€ æ•°é‡å’Œæ— æ•ˆçš„å¸æˆ·ç¼–å·',0),(511583,14211,'sv','MÃ¥ste ha fakturanummer, LeverantÃ¶rsnamn, belopp och giltigt kontonummer',0),(511584,14211,'it','Deve avere il numero di fattura, nome fornitore, quantitÃ  e numero di Account valido',0),(511585,14211,'tl','',0),(511586,14211,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¸‚à¸²à¸¢ à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™ à¹à¸¥à¸°à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µà¸—à¸µà¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(511587,14211,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¨à¤‚à¤¬à¤°, à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤¨à¤¾à¤®, à¤°à¤¾à¤¶à¤¿ à¤”à¤° à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¹à¥‹à¤¨à¥€ à¤šà¤¾à¤¹à¤¿à¤',0),(511588,14211,'ms','Mesti mempunyai nombor invois, jumlah, nama penjual dan nombor akaun yang sah',0),(511589,14211,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©ØŒ Ø§Ø³Ù… Ø§Ù„Ù…ÙˆØ±Ø¯ØŒ ÙˆØ§Ù„Ù…Ø¨Ù„Øº ÙˆØ±Ù‚Ù… Ø­Ø³Ø§Ø¨ ØµØ§Ù„Ø­',0),(511590,14211,'fr','Doit avoir le numÃ©ro de facture, nom du vendeur, montant et le numÃ©ro de compte valide',0),(511591,14211,'jp','è«‹æ±‚æ›¸ç•ªå·ã€ãƒ™ãƒ³ãƒ€ãƒ¼åã€é‡ãŠã‚ˆã³æœ‰åŠ¹ãªå£åº§ç•ªå·ãŒå¿…è¦',0),(511592,14211,'pt','Deve ter o nÃºmero da nota fiscal, nome do fornecedor, quantidade e nÃºmero de conta vÃ¡lido',0),(511593,14211,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð¼ÐµÑ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°, Ð¸Ð¼Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°, ÑÑƒÐ¼Ð¼Ð° Ð¸ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹',0),(511594,14211,'es','Debe tener el nÃºmero de factura, nombre del proveedor, cantidad y nÃºmero de cuenta vÃ¡lido',0),(511595,14211,'de','Rechnungsnummer, Herstellernamen, Betrag und gÃ¼ltige Kontonummer mÃ¼ssen',0),(511596,14211,'en','Must Have Invoice Number, Vendor Name, Amount And Valid Account Number',0),(511597,14212,'is','',0),(511598,14212,'dr','ØªÙ†Ù‡Ø§ Ø§Ú¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(511599,14212,'pr','ØªÙ†Ù‡Ø§ Ø§Ú¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(511600,14212,'tr','KÃ¼me yalnÄ±zca varolan sunucularÄ± gÃ¼ncelleÅŸtirme',0),(511601,14212,'pl','Tylko zestaw, jeÅ›li aktualizacja istniejÄ…cych dostawcÃ³w',0),(511602,14212,'bg','Ð—Ð°Ð´Ð°Ð´ÐµÐ½Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(511603,14212,'ur','ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯Û Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’ Ø§Ú¯Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(511604,14212,'sr','Ð¡Ð°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¿Ð¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸Ð¼ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸Ð¼Ð°',0),(511605,14212,'vi','Chá»‰ Ä‘áº·t náº¿u Cáº­p Nháº­t nhÃ  cung cáº¥p hiá»‡n táº¡i',0),(511606,14212,'af','Stel slegs indien bestaande verskaffers bywerking',0),(511607,14212,'ro','Setate numai dacÄƒ actualizarea existente furnizori',0),(511608,14212,'et','Seada ainult kui ajakohastamist olemasolevate hankijate',0),(511609,14212,'si','Nastaviti le, Äe posodabljanje obstojeÄe dobavitelje',0),(511610,14212,'ba','Hanya ditetapkan jika memperbarui vendor yang ada',0),(511611,14212,'nl','Alleen ingesteld als bestaande leveranciers wilt bijwerken',0),(511612,14212,'fi','MÃ¤Ã¤rittÃ¤Ã¤ vain jos pÃ¤ivittÃ¤Ã¤ olemassa olevat toimittajat',0),(511613,14212,'no','Bare angi hvis oppdaterer eksisterende leverandÃ¸rer',0),(511614,14212,'da','Eneste sÃ¦t hvis opdaterer eksisterende kreditorer',0),(511615,14212,'ko','ê¸°ì¡´ ê³µê¸‰ ì—…ì²´ë¥¼ ì—…ë°ì´íŠ¸ í•˜ëŠ” ê²½ìš°ì— ì„¤ì •',0),(511616,14212,'he','×¨×§ ×œ×§×‘×•×¢ ×× ×œ×¢×“×›×Ÿ ×¡×¤×§×™× ×§×™×™×ž×™×',0),(511617,14212,'el','ÎœÏŒÎ½Î¿ Ï€Î¿Ï… Î±Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„ÎµÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚',0),(511618,14212,'zh','å¦‚æžœæ›´æ–°çŽ°æœ‰çš„ä¾›åº”å•†ï¼Œåˆ™åªè®¾ç½®',0),(511619,14212,'sv','Bara stÃ¤lla om uppdaterar befintliga leverantÃ¶rer',0),(511620,14212,'it','Impostare solo se aggiornando i fornitori esistenti',0),(511621,14212,'tl','',0),(511622,14212,'th','à¸Šà¸¸à¸”à¹€à¸”à¸µà¸¢à¸§à¸–à¹‰à¸²à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(511623,14212,'hi','à¤•à¥‡à¤µà¤² à¤¯à¤¦à¤¿ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(511624,14212,'ms','Hanya menetapkan jika pengemaskinian vendor sedia ada',0),(511625,14212,'ar','ØªØ¹ÙŠÙŠÙ† ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ†',0),(511626,14212,'fr','DÃ©finie uniquement si la mise Ã  jour des fournisseurs existants',0),(511627,14212,'jp','æ—¢å­˜ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’æ›´æ–°ã™ã‚‹å ´åˆã«ã®ã¿è¨­å®šã—ã¾ã™ã€‚',0),(511628,14212,'pt','Apenas definir se atualizando fornecedores existentes',0),(511629,14212,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(511630,14212,'es','SÃ³lo establecer si actualizaciÃ³n proveedores existentes',0),(511631,14212,'de','Nur festgelegt, wenn die vorhandenen Anbieter aktualisieren',0),(511632,14212,'en','Only Set If Updating Existing Vendors',0),(511633,14213,'is','',0),(511634,14213,'dr','Ù„Ø·ÙØ§ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙˆØ§Ø±Ø¯Ø§Øª Ù‚Ø§Ù„Ø¨',0),(511635,14213,'pr','Ù„Ø·ÙØ§ Ø¯Ø§Ù†Ù„ÙˆØ¯ ÙˆØ§Ø±Ø¯Ø§Øª Ù‚Ø§Ù„Ø¨',0),(511636,14213,'tr','LÃ¼tfen ÅŸablon al indir',0),(511637,14213,'pl','Pobierz szablon importu',0),(511638,14213,'bg','ÐœÐ¾Ð»Ñ, Ð¸Ð·Ñ‚ÐµÐ³Ð»ÐµÑ‚Ðµ ÑˆÐ°Ð±Ð»Ð¾Ð½Ð° Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð°',0),(511639,14213,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ø³Ø§Ù†Ú†Ø§ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(511640,14213,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° Ð¿Ñ€ÐµÑƒÐ·Ð¼ÐµÑ‚Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(511641,14213,'vi','Xin vui lÃ²ng táº£i máº«u nháº­p kháº©u',0),(511642,14213,'af','Laai asseblief die sjabloon vir invoer',0),(511643,14213,'ro','VÄƒ rugÄƒm sÄƒ descÄƒrcaÅ£i ÅŸablonul de Import',0),(511644,14213,'et','Palun lae impordi Mall',0),(511645,14213,'si','Prenesite predlogo za uvoz',0),(511646,14213,'ba','Silahkan Download Template impor',0),(511647,14213,'nl','Download de sjabloon importeren',0),(511648,14213,'fi','Lataa tuontimalli',0),(511649,14213,'no','Last ned malen Import',0),(511650,14213,'da','Download venligst importskabelonen',0),(511651,14213,'ko','ê°€ì ¸ì˜¤ê¸° ì„œì‹ íŒŒì¼ì„ ë‹¤ìš´ë¡œë“œ í•˜ì‹­ì‹œì˜¤',0),(511652,14213,'he','× × ×œ×”×•×¨×™×“ ××ª ×ª×‘× ×™×ª ×™×™×‘×•×',0),(511653,14213,'el','ÎœÏ€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± ÎºÎ±Ï„ÎµÎ²Î¬ÏƒÎµÏ„Îµ Ï„Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(511654,14213,'zh','è¯·ä¸‹è½½å¯¼å…¥æ¨¡æ¿',0),(511655,14213,'sv','VÃ¤nligen ladda ner importera mall',0),(511656,14213,'it','Si prega di scaricare il modello di importazione',0),(511657,14213,'tl','',0),(511658,14213,'th','à¸à¸£à¸¸à¸“à¸²à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹à¸šà¸šà¸™à¸³à¹€à¸‚à¹‰à¸²',0),(511659,14213,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤†à¤¯à¤¾à¤¤ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(511660,14213,'ms','Sila muat turun Import Template',0),(511661,14213,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ù…ÙŠÙ„ Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(511662,14213,'fr','S\'il vous plaÃ®t tÃ©lÃ©charger le modÃ¨le d\'importation',0),(511663,14213,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¦ãã ã•ã„ã€‚',0),(511664,14213,'pt','FaÃ§a o Download do modelo de importaÃ§Ã£o',0),(511665,14213,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑÐºÐ°Ñ‡Ð°Ð¹Ñ‚Ðµ ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(511666,14213,'es','Por favor, descargue la plantilla de importaciÃ³n',0),(511667,14213,'de','Bitte laden Sie die Vorlage importieren',0),(511668,14213,'en','Please Download The Import Template',0),(511669,14214,'is','',0),(511670,14214,'dr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¬Ø¯ÛŒØ¯',0),(511671,14214,'pr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¬Ø¯ÛŒØ¯',0),(511672,14214,'tr','Yeni satÄ±cÄ±lar iÃ§in Ã¶nerilen',0),(511673,14214,'pl','Zalecane dla nowych dostawcÃ³w',0),(511674,14214,'bg','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑŠÑ‡Ð²Ð° ÑÐµ Ð·Ð° Ð½Ð¾Ð²Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(511675,14214,'ur','Ù†Ø¦Û’ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©Û’ Ù„Ø¦Û’ Ø³ÙØ§Ø±Ø´ Ú©ÛŒ Ø¬Ø§ØªÛŒ ÛÛ’',0),(511676,14214,'sr','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑƒÑ‡ÑƒÑ˜Ðµ ÑÐµ Ð·Ð° Ð½Ð¾Ð²Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(511677,14214,'vi','Khuyáº¿n khÃ­ch cho cÃ¡c nhÃ  cung cáº¥p má»›i',0),(511678,14214,'af','Aanbeveel vir nuwe verkopers',0),(511679,14214,'ro','Recomandat pentru noi furnizori',0),(511680,14214,'et','Soovitatud uue mÃ¼Ã¼jad',0),(511681,14214,'si','PriporoÄljivo za nove dobavitelje',0),(511682,14214,'ba','Direkomendasikan untuk vendor baru',0),(511683,14214,'nl','Aanbevolen voor nieuwe leveranciers',0),(511684,14214,'fi','Uusia toimittajia suositellaan',0),(511685,14214,'no','Anbefales For nye leverandÃ¸rer',0),(511686,14214,'da','Anbefales til nye leverandÃ¸rer',0),(511687,14214,'ko','ìƒˆë¡œìš´ ê³µê¸‰ ì—…ì²´ì— ëŒ€ í•œ ê¶Œìž¥',0),(511688,14214,'he','×ž×•×ž×œ×¥ ×¢×‘×•×¨ ×¡×¤×§×™× ×—×“×©×™×',0),(511689,14214,'el','Î£Ï…Î½Î¹ÏƒÏ„Î¬Ï„Î±Î¹ Î³Î¹Î± Î½Î­Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚',0),(511690,14214,'zh','æŽ¨èæ–°çš„ä¾›åº”å•†',0),(511691,14214,'sv','Rekommenderas fÃ¶r nya leverantÃ¶rer',0),(511692,14214,'it','Consigliato per i nuovi fornitori',0),(511693,14214,'tl','',0),(511694,14214,'th','à¹à¸™à¸°à¸™à¸³à¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹ƒà¸«à¸¡à¹ˆ',0),(511695,14214,'hi','à¤¨à¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤¶à¤‚à¤¸à¤¿à¤¤',0),(511696,14214,'ms','Disyorkan untuk pembekal baru',0),(511697,14214,'ar','ÙˆØ£ÙˆØµØª Ù„Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ† Ø§Ù„Ø¬Ø¯Ø¯',0),(511698,14214,'fr','RecommandÃ© pour les nouveaux fournisseurs',0),(511699,14214,'jp','æ–°ã—ã„ãƒ™ãƒ³ãƒ€ãƒ¼ã®æŽ¨å¥¨',0),(511700,14214,'pt','Recomendado para novos fornecedores',0),(511701,14214,'ru','Ð ÐµÐºÐ¾Ð¼ÐµÐ½Ð´ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ Ð½Ð¾Ð²Ñ‹Ñ… Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(511702,14214,'es','Recomendado para nuevos vendedores',0),(511703,14214,'de','Empfohlen fÃ¼r neue Anbieter',0),(511704,14214,'en','Recommended For New Vendors',0),(511705,14215,'is','',0),(511706,14215,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§Ú¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ ØªØ±ØªÛŒØ¨ Ø§Ø² Ù…Ø®ØªÙ„Ù Ù‡Ø³ØªÙ†Ø¯ Ùˆ',0),(511707,14215,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§Ú¯Ø± Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ ØªØ±ØªÛŒØ¨ Ø§Ø² Ù…Ø®ØªÙ„Ù Ù‡Ø³ØªÙ†Ø¯ Ùˆ',0),(511708,14215,'tr','Ayarlamak iÃ§in Ã¶deme ve sipariÅŸten farklÄ± ise',0),(511709,14215,'pl','Zestaw czy zamÃ³wiÄ‡ i zapÅ‚aciÄ‡ sÄ… rÃ³Å¼ne',0),(511710,14215,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð°ÐºÐ¾ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ ÑÐ° Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð¸',0),(511711,14215,'ur','Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ø§Ú¯Ø± ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ù„ÛŒÛ’ Ø§Ù…Ù† Ùˆ Ø§Ù…Ø§Ù† Ø³Û’ Ù…Ø®ØªÙ„Ù ÛÛŒÚº',0),(511712,14215,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð°ÐºÐ¾ Ñ€ÐµÐ´ Ð¸Ð· Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ Ð´Ð° Ñ€Ð°Ð·Ð»Ð¸ÐºÑƒÑ˜Ñƒ ÑÐµ',0),(511713,14215,'vi','Thiáº¿t láº­p náº¿u tráº£ tiá»n Ä‘á»ƒ vÃ  Ä‘Æ¡n Ä‘áº·t hÃ ng tá»« lÃ  khÃ¡c nhau',0),(511714,14215,'af','Stel as betaal aan en volgorde van verskillende is',0),(511715,14215,'ro','SetaÅ£i DacÄƒ plÄƒtiÅ£i pentru ÅŸi ordinea din sunt diferite',0),(511716,14215,'et','MÃ¤Ã¤ra kui maksma ja tellida on erinevad',0),(511717,14215,'si','Nastavite Äe plaÄilo za in nalog iz so razliÄne',0),(511718,14215,'ba','Menetapkan jika membayar untuk dan urutan dari yang berbeda',0),(511719,14215,'nl','Instellen als betalen aan en volgorde van verschillende zijn',0),(511720,14215,'fi','MÃ¤Ã¤ritÃ¤ jos maksaa ja tilata ovat erilaisia',0),(511721,14215,'no','Angi om lÃ¸nn Ã¥ og bestille fra er forskjellige',0),(511722,14215,'da','Indstille hvis lÃ¸n til og bestille fra er forskellige',0),(511723,14215,'ko','ì„¤ì • ì§€ë¶ˆ ë°ì—ì„œ ìˆœì„œëŠ” ë‹¤ë¥¸ ê²½ìš°',0),(511724,14215,'he','×§×‘×¢ ×× ×œ×©×œ× ×•×¡×“×¨ ×ž ×”× ×©×•× ×™×',0),(511725,14215,'el','ÎŸÏÎ¯ÏƒÎµÏ„Îµ Î±Î½ Ï€Î»Î·ÏÏŽÎ½Î¿Ï…Î½ Î³Î¹Î± Î½Î± ÎºÎ±Î¹ ÏƒÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ Î´Î¹Î±Ï†Î­ÏÎ¿Ï…Î½',0),(511726,14215,'zh','è®¾ç½®å¦‚æžœä»˜ç»™å’Œä»Žé¡ºåºæ˜¯ä¸ä¸€æ ·',0),(511727,14215,'sv','Ange om lÃ¶n till och bestÃ¤lla frÃ¥n Ã¤r olika',0),(511728,14215,'it','Impostare se paga e ordine da sono diversi',0),(511729,14215,'tl','',0),(511730,14215,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¹ƒà¸«à¹‰à¹à¸¥à¸°à¸ªà¸±à¹ˆà¸‡à¸ˆà¸²à¸à¸ˆà¸°à¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸à¸±à¸™',0),(511731,14215,'hi','à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚ à¤¯à¤¦à¤¿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤”à¤° à¤•à¥à¤°à¤® à¤¸à¥‡ à¤…à¤²à¤— à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚',0),(511732,14215,'ms','Menetapkan jika membayar untuk dan perintah dari adalah berbeza',0),(511733,14215,'ar','ØªØ¹ÙŠÙŠÙ† Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ø£Ø¬Ø± Ø¥Ù„Ù‰ ÙˆØ£Ù…Ø± Ù…Ù† Ø§Ù„Ù…Ø®ØªÙ„ÙØ©',0),(511734,14215,'fr','DÃ©finir si payante Ã  et sont diffÃ©rents',0),(511735,14215,'jp','è¨­å®šã‚’æ”¯æ‰•ã†ã¨ã‹ã‚‰ã®é †åºãŒç•°ãªã‚‹ã‹ã©ã†ã‹',0),(511736,14215,'pt','Definir se pagar para e da ordem de sÃ£o diferentes',0),(511737,14215,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐµÑÐ»Ð¸ Ð²Ñ‹Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð¾Ñ‚ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ñ‹Ñ…',0),(511738,14215,'es','Establecer si paga y pedido de son diferentes',0),(511739,14215,'de','Legen Sie wenn zu zahlen, und Ordnung von unterschiedlich sind',0),(511740,14215,'en','Set If Pay To And Order From Are Different',0),(511741,14216,'is','',0),(511742,14216,'dr','Ù¾Ø±Ø´ Ø±Ø¯ÛŒÙ',0),(511743,14216,'pr','Ù¾Ø±Ø´ Ø±Ø¯ÛŒÙ',0),(511744,14216,'tr','SatÄ±r atlanÄ±yor',0),(511745,14216,'pl','Pomijanie wierszy',0),(511746,14216,'bg','ÐŸÑ€Ð¾Ð¿ÑƒÑÐºÐ°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´',0),(511747,14216,'ur','ØµÙ Ø§Ú†Ù¹ Ø±ÛØ§ ÛÛ’ Û”',0),(511748,14216,'sr','ÐŸÑ€ÐµÑÐºÐ°ÐºÐ°ÑšÐµ Ñ€ÐµÐ´Ð°',0),(511749,14216,'vi','Bá» qua hÃ ng',0),(511750,14216,'af','Huppel ry',0),(511751,14216,'ro','SÄƒrind peste rÃ¢nd',0),(511752,14216,'et','Rida vahele',0),(511753,14216,'si','Preskakovanje vrstice',0),(511754,14216,'ba','Melewatkan baris',0),(511755,14216,'nl','Rij overslaan',0),(511756,14216,'fi','Ohita rivi',0),(511757,14216,'no','Hopper over rad',0),(511758,14216,'da','Springe over rÃ¦kken',0),(511759,14216,'ko','í–‰ì„ ê±´ë„ˆë›°ëŠ”',0),(511760,14216,'he','×ž×“×œ×’ ×¢×œ ×©×•×¨×”',0),(511761,14216,'el','Î Î±ÏÎ±ÎºÎ¬Î¼Ï€Ï„Î¿Î½Ï„Î±Ï‚ Ï„Î· Î³ÏÎ±Î¼Î¼Î®',0),(511762,14216,'zh','è·³è¿‡è¡Œ',0),(511763,14216,'sv','Hoppa Ã¶ver raden',0),(511764,14216,'it','Saltando la fila',0),(511765,14216,'tl','',0),(511766,14216,'th','à¸‚à¹‰à¸²à¸¡à¹à¸–à¸§',0),(511767,14216,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤²à¤‚à¤˜à¤¨',0),(511768,14216,'ms','Ponteng berturut-turut',0),(511769,14216,'ar','ØªØ®Ø·ÙŠ Ø§Ù„ØµÙÙˆÙ',0),(511770,14216,'fr','Saut de ligne',0),(511771,14216,'jp','è¡Œã‚’ã‚¹ã‚­ãƒƒãƒ—ã—ã¾ã™ã€‚',0),(511772,14216,'pt','Pular linha',0),(511773,14216,'ru','ÐŸÑ€Ð¾Ð¿ÑƒÑÐº ÑÑ‚Ñ€Ð¾ÐºÐ¸',0),(511774,14216,'es','Saltarse la fila',0),(511775,14216,'de','Zeile Ã¼berspringen',0),(511776,14216,'en','Skipping Row',0),(511777,14217,'is','',0),(511778,14217,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ú¯Ø± Ù†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(511779,14217,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ú¯Ø± Ù†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(511780,14217,'tr','KullandÄ±ÄŸÄ± satÄ±cÄ± varsayÄ±lan deÄŸilse ayarla',0),(511781,14217,'pl','UÅ¼ywa dostawca domyÅ›lny, jeÅ›li nie zestaw',0),(511782,14217,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ, Ð°ÐºÐ¾ Ð½Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ',0),(511783,14217,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ ÙˆÛŒÙ†ÚˆØ± Ø·Û’ Ø´Ø¯Û Ù†ÛÛŒÚº ØªÙˆ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(511784,14217,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð°ÐºÐ¾ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸',0),(511785,14217,'vi','NgÆ°á»i bÃ¡n hÃ ng sá»­ dá»¥ng máº·c Ä‘á»‹nh náº¿u khÃ´ng thiáº¿t láº­p',0),(511786,14217,'af','Gebruike handelaar verstek indien nie stel',0),(511787,14217,'ro','Utilizeaza furnizorul implicit dacÄƒ nu setaÅ£i',0),(511788,14217,'et','Kasutab hankija vaikimisi kui mitte seada',0),(511789,14217,'si','Dobavitelj uporablja privzeto, Äe ne nastavite',0),(511790,14217,'ba','Menggunakan Vendor Default jika tidak diatur',0),(511791,14217,'nl','Gebruik leverancier standaard als niet is ingesteld',0),(511792,14217,'fi','KÃ¤yttÃ¤Ã¤ toimittajan oletus, jos ei ole asetettu',0),(511793,14217,'no','Bruker leverandÃ¸ren standard hvis ikke satt',0),(511794,14217,'da','Bruger kreditor standard hvis ikke indstillet',0),(511795,14217,'ko','ì‚¬ìš© ì—…ì²´ ê¸°ë³¸ ì„¤ì • ë˜ì§€ ì•Šì€ ê²½ìš°',0),(511796,14217,'he','×”×¡×¤×§ ×ž×©×ª×ž×© ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×× ×œ× ×ž×•×’×“×¨',0),(511797,14217,'el','Î§ÏÎ®ÏƒÎµÎ¹Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î±Î½ Î´ÎµÎ½ Î¿ÏÎ¯ÏƒÎµÏ„Îµ',0),(511798,14217,'zh','ä½¿ç”¨ä¾›åº”å•†é»˜è®¤å€¼ï¼Œå¦‚æžœæœªè®¾ç½®',0),(511799,14217,'sv','AnvÃ¤nder leverantÃ¶rens standard om inte ange',0),(511800,14217,'it','Fornitore utilizza di Default se non impostato',0),(511801,14217,'tl','',0),(511802,14217,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸–à¹‰à¸² à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡',0),(511803,14217,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤…à¤—à¤° à¤¨à¤¹à¥€à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(511804,14217,'ms','Kegunaan penjual lalai jika tidak Set',0),(511805,14217,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù…Ø§Øª Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¥Ø°Ø§ Ù„Ù… ØªØ¹ÙŠÙŠÙ†',0),(511806,14217,'fr','Utilisations du vendeur par dÃ©faut si elle n\'est pas dÃ©finie',0),(511807,14217,'jp','ä½¿ç”¨ã™ã‚‹ãƒ™ãƒ³ãƒ€ãƒ¼ ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆè¨­å®šã•ã‚Œã¦ã„ãªã„å ´åˆ',0),(511808,14217,'pt','Fornecedor de usos padrÃ£o se nÃ£o definida',0),(511809,14217,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ, ÐµÑÐ»Ð¸ Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(511810,14217,'es','Proveedor utiliza por defecto si no establece',0),(511811,14217,'de','Verwendungen Hersteller Standard, wenn nicht festgelegt',0),(511812,14217,'en','Uses Vendor Default If Not Set',0),(511813,14218,'is','',0),(511814,14218,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ù‚Ø§Ù„Ø¨ Ø¨Ø§Ù„Ø§ Ø±Ø§ ÙØ§ÛŒÙ„ Ø®ÙˆØ¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(511815,14218,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ù‚Ø§Ù„Ø¨ Ø¨Ø§Ù„Ø§ Ø±Ø§ ÙØ§ÛŒÙ„ Ø®ÙˆØ¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(511816,14218,'tr','DosyanÄ±zÄ± yapmak iÃ§in yukarÄ±daki alma ÅŸablonu kullan',0),(511817,14218,'pl','UÅ¼yj powyÅ¼szych szablon importu do pliku',0),(511818,14218,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÑˆÐ°Ð±Ð»Ð¾Ð½Ð° Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ, Ð·Ð° Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ Ñ„Ð°Ð¹Ð»',0),(511819,14218,'ur','Ø¢Ù¾ Ú©ÛŒ Ù…Ø³Ù„ Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§ÙˆÙ¾Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ø³Ø§Ù†Ú†Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(511820,14218,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº ÑƒÐ²Ð¾Ð·Ð°, ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð¸Ð·Ð½Ð°Ð´ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(511821,14218,'vi','Sá»­ dá»¥ng nháº­p kháº©u máº«u á»Ÿ trÃªn Ä‘á»ƒ lÃ m cho táº­p tin cá»§a báº¡n',0),(511822,14218,'af','Gebruik die bogenoemde invoer sjabloon maak jou lÃªer',0),(511823,14218,'ro','UtilizaÅ£i ÅŸablonul de Import de mai sus pentru a face fiÅŸierul dumneavoastrÄƒ',0),(511824,14218,'et','Kasuta impordi malli eespool faili',0),(511825,14218,'si','Uporabite uvozno predlogo zgoraj, da bi datoteko',0),(511826,14218,'ba','Menggunakan Template impor di atas untuk membuat File Anda',0),(511827,14218,'nl','Gebruik de sjabloon importeren hierboven om uw bestand te maken',0),(511828,14218,'fi','Tuontimalli edellÃ¤ avulla tiedoston',0),(511829,14218,'no','Bruk malen Import over Ã¥ gjÃ¸re filen',0),(511830,14218,'da','Brug Importer skabelon ovenstÃ¥ende at gÃ¸re din fil',0),(511831,14218,'ko','ìœ„ì˜ ê°€ì ¸ì˜¤ê¸° í…œí”Œë¦¿ì„ ì‚¬ìš© í•˜ ì—¬ íŒŒì¼ì„ ë§Œë“¤',0),(511832,14218,'he','×”×©×ª×ž×© ×‘×ª×‘× ×™×ª ×™×™×‘×•× ×œ×¢×™×œ ×›×“×™ ×œ×”×¤×•×š ××ª ×”×§×•×‘×¥ ×©×œ×š',0),(511833,14218,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ Î½Î± ÏƒÎ±Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿',0),(511834,14218,'zh','ä½¿ç”¨ä¸Šè¿°å¯¼å…¥æ¨¡æ¿ï¼Œä»¥ä½¿æ‚¨çš„æ–‡ä»¶',0),(511835,14218,'sv','AnvÃ¤nda importeringsmallen ovan att gÃ¶ra din fil',0),(511836,14218,'it','Utilizzare il modello di importazione sopra per rendere il File',0),(511837,14218,'tl','',0),(511838,14218,'th','à¹ƒà¸Šà¹‰à¹à¸šà¸šà¸™à¸³à¹€à¸‚à¹‰à¸²à¸‚à¹‰à¸²à¸‡à¹€à¸žà¸·à¹ˆà¸­à¸—à¸³à¹ƒà¸«à¹‰à¹à¸Ÿà¹‰à¸¡à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(511839,14218,'hi','à¤†à¤ªà¤•à¥€ à¤«à¤¼à¤¾à¤‡à¤² à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸à¤•à¥‡ à¤¬à¤¾à¤¦ à¤•à¥‡ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤†à¤¯à¤¾à¤¤ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(511840,14218,'ms','Menggunakan Template Import di atas untuk membuat fail anda',0),(511841,14218,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù‚Ø§Ù„Ø¨ Ø£Ø¹Ù„Ø§Ù‡ Ù„Ø¬Ø¹Ù„ Ø§Ù„Ù…Ù„Ù Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(511842,14218,'fr','Utilisez l\'importation du modÃ¨le ci-dessus pour faire votre fichier',0),(511843,14218,'jp','ä¸Šè¨˜ã®ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆã‚’ä½¿ç”¨ã—ã¦ã€ãƒ•ã‚¡ã‚¤ãƒ«ã‚’',0),(511844,14218,'pt','Usar o modelo de importaÃ§Ã£o acima para fazer seu arquivo',0),(511845,14218,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ð¿Ñ€Ð¸Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ð¹ Ð²Ñ‹ÑˆÐµ ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ Ð²Ð°Ñˆ Ñ„Ð°Ð¹Ð»',0),(511846,14218,'es','Utilice la plantilla de importaciÃ³n anterior para hacer tu archivo',0),(511847,14218,'de','Verwenden Sie die Importvorlage oben zu Ihrer Datei',0),(511848,14218,'en','Use The Import Template Above To Make Your File',0),(511849,14219,'is','',0),(511850,14219,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù„Ø§ÛŒØ­Ù‡ ÙˆØ§Ø±Ø¯Ø§Øª',0),(511851,14219,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù„Ø§ÛŒØ­Ù‡ ÙˆØ§Ø±Ø¯Ø§Øª',0),(511852,14219,'tr','SatÄ±cÄ± fatura alma',0),(511853,14219,'pl','Dostawcy Bill Import',0),(511854,14219,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð±Ð¸Ð» Ð²Ð½Ð¾Ñ',0),(511855,14219,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(511856,14219,'sr','Ð£Ð²Ð¾Ð· Ñ€Ð°Ñ‡ÑƒÐ½ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(511857,14219,'vi','NhÃ  cung cáº¥p hÃ³a Ä‘Æ¡n nháº­p kháº©u',0),(511858,14219,'af','Handelaar Wetsontwerp invoer',0),(511859,14219,'ro','Import de factura furnizor',0),(511860,14219,'et','Hankija arve Import',0),(511861,14219,'si','Uvoz raÄun dobavitelja',0),(511862,14219,'ba','Penjual Bill impor',0),(511863,14219,'nl','Leverancier Bill importeren',0),(511864,14219,'fi','Toimittajan laskun tuonti',0),(511865,14219,'no','LeverandÃ¸ren Bill Import',0),(511866,14219,'da','Kreditor Bill Import',0),(511867,14219,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ ê°€ì ¸ì˜¤ê¸°',0),(511868,14219,'he','×™×™×‘×•× ×—×©×‘×•×Ÿ ×¡×¤×§',0),(511869,14219,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Bill ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(511870,14219,'zh','ä¾›åº”å•†æ¯”å°”å¯¼å…¥',0),(511871,14219,'sv','LeverantÃ¶r Bill Import',0),(511872,14219,'it','Importazione di fattura fornitore',0),(511873,14219,'tl','',0),(511874,14219,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸•à¸±à¹‹à¸§',0),(511875,14219,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤†à¤¯à¤¾à¤¤',0),(511876,14219,'ms','Penjual bil Import',0),(511877,14219,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…ÙˆØ±Ø¯',0),(511878,14219,'fr','Importation de facture fournisseur',0),(511879,14219,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(511880,14219,'pt','ImportaÃ§Ã£o de conta de fornecedor',0),(511881,14219,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð‘Ð¸Ð»Ð» Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(511882,14219,'es','ImportaciÃ³n de factura de proveedor',0),(511883,14219,'de','Hersteller Bill Import',0),(511884,14219,'en','Vendor Bill Import',0),(511885,14220,'is','',0),(511886,14220,'dr','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ù†Ø§Ù… Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±.',0),(511887,14220,'pr','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ù†Ø§Ù… Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±.',0),(511888,14220,'tr','Ek satÄ±r Ã¶ÄŸeleri aynÄ± fatura yalnÄ±zca ÅŸirket adÄ± veya ad ve soyadÄ± ve fatura numarasÄ± gerekir.',0),(511889,14220,'pl','Dodatkowe pozycje w samej faktury wystarczy nazwa firmy lub imiÄ™ i nazwisko oraz numer faktury.',0),(511890,14220,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ð² ÐµÐ´Ð½Ð° Ð¸ ÑÑŠÑ‰Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° ÑÐ°Ð¼Ð¾ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°.',0),(511891,14220,'ur','Ø§Ø¶Ø§ÙÛŒ Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§ Ø§Ø³ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…ÛŒÚº ØµØ±Ù Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… ÛŒØ§ Ù¾ÛÙ„Û’ Ø§ÙˆØ± Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ø§ÙˆØ± ØªØ¹Ø¯Ø§Ø¯ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(511892,14220,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ñ€ÐµÐ´Ñƒ Ñƒ Ð¸ÑÑ‚Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ñ˜Ðµ ÑÐ°Ð¼Ð¾ Ð¸Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð¸ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ.',0),(511893,14220,'vi','ThÃªm chi tiáº¿t Ä‘Æ¡n hÃ ng hoÃ¡ Ä‘Æ¡n cÃ¹ng má»™t chá»‰ cáº§n tÃªn cÃ´ng ty hoáº·c Ä‘áº§u tiÃªn vÃ  cuá»‘i cÃ¹ng tÃªn vÃ  sá»‘ hÃ³a Ä‘Æ¡n.',0),(511894,14220,'af','Bykomende lyn items in die dieselfde faktuur moet slegs die maatskappynaam of eerste en laaste naam en nommer van die faktuur.',0),(511895,14220,'ro','Elemente suplimentare de linie Ã®n aceeaÅŸi facturÄƒ nevoie doar de numele firmei sau prenumele ÅŸi numÄƒrul facturii.',0),(511896,14220,'et','TÃ¤iendavaid kirjeid sama arve tuleb ainult ettevÃµtte nimi vÃµi ees- ja perekonnanimi ning arve number.',0),(511897,14220,'si','Dodatne vrstiÄne postavke v isti raÄun Å¡ele potreba firma ali ime in priimek in Å¡tevilko raÄuna.',0),(511898,14220,'ba','Item baris tambahan di faktur sama hanya memerlukan nama perusahaan atau nama pertama dan terakhir dan nomor faktur.',0),(511899,14220,'nl','Extra regelitems in dezelfde factuur hoeft alleen de naam van het bedrijf of eerste en laatste naam en het factuurnummer.',0),(511900,14220,'fi','Muita eriÃ¤ samaan laskuun tarvitsee vain yrityksen nimi tai etu- ja sukunimi ja laskunumero.',0),(511901,14220,'no','Flere linjeelementer i samme faktura trenger bare firmanavnet eller fornavn og etternavn og fakturanummeret.',0),(511902,14220,'da','Yderligere linjeelementer i den samme faktura behÃ¸ver kun firmanavnet eller fÃ¸rste og sidste navn og fakturanummeret.',0),(511903,14220,'ko','ê°™ì€ ì¸ë³´ì´ìŠ¤ì— ì¶”ê°€ í’ˆëª© íšŒì‚¬ ì´ë¦„ ë˜ëŠ” ì´ë¦„ ë° ì†¡ìž¥ ë²ˆí˜¸ í•„ìš”í•©ë‹ˆë‹¤.',0),(511904,14220,'he','×¤×¨×™×˜×™× × ×•×¡×¤×™× ×©×•×¨×” ×‘×—×©×‘×•× ×™×ª ××•×ª×• ×¨×§ ×¦×¨×™×š ××ª ×©× ×”×—×‘×¨×” ××• ×”×¤×¨×˜×™ ×•×©× ×”×ž×©×¤×—×” ×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª.',0),(511905,14220,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ„Î¿ Î¯Î´Î¹Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÏÎ­Ï€ÎµÎ¹ Î¼ÏŒÎ½Î¿ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î® ÏŒÎ½Î¿Î¼Î± ÎºÎ±Î¹ Ï„Î¿ ÎµÏ€ÏŽÎ½Ï…Î¼Î¿ ÎºÎ±Î¹ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï….',0),(511906,14220,'zh','åœ¨åŒä¸€å‘ç¥¨çš„é™„åŠ è¡Œé¡¹ç›®åªéœ€è¦å…¬å¸åç§°æˆ–åå­—å’Œå§“æ°å’Œå‘ç¥¨ç¼–å·ã€‚',0),(511907,14220,'sv','Ytterligare artiklar i samma faktura behÃ¶ver bara fÃ¶retagsnamnet eller fÃ¶r- och efternamn och fakturanummer.',0),(511908,14220,'it','Voci aggiuntive nella stessa fattura Ã¨ sufficiente il nome dell\'azienda o nome e cognome e il numero di fattura.',0),(511909,14220,'tl','',0),(511910,14220,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸”à¸µà¸¢à¸§à¸à¸±à¸™à¸ªà¸²à¸¡à¸²à¸£à¸–à¹ƒà¸Šà¹‰à¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸— à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­ à¹à¸¥à¸°à¸™à¸²à¸¡à¸ªà¸à¸¸à¸¥ à¹à¸¥à¸°à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸š',0),(511911,14220,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤°à¥‡à¤–à¤¾ à¤†à¤‡à¤Ÿà¤® à¤à¤• à¤¹à¥€ à¤šà¤¾à¤²à¤¾à¤¨ à¤®à¥‡à¤‚ à¤•à¥‡à¤µà¤² à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® à¤”à¤° à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤”à¤° à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥€ à¤œà¤°à¥‚à',0),(511912,14220,'ms','Item-item tambahan garisan dalam invois yang sama hanya perlu nama Syarikat atau nama pertama dan akhir dan nombor invois.',0),(511913,14220,'ar','ÙÙ‚Ø· ØªØ­ØªØ§Ø¬ Ø¨Ù†ÙˆØ¯ Ø¥Ø¶Ø§ÙÙŠØ© ÙÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù†ÙØ³ Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø£Ùˆ Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„ ÙˆØ§Ù„Ø£Ø®ÙŠØ± ÙˆØ±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©.',0),(511914,14220,'fr','Des rubriques supplÃ©mentaires sur la mÃªme facture suffit la dÃ©nomination sociale ou nom et prÃ©nom et le numÃ©ro de la facture.',0),(511915,14220,'jp','åŒã˜è«‹æ±‚æ›¸ã«è¿½åŠ ã®è¡Œã‚¢ã‚¤ãƒ†ãƒ ã§ã¯ã€ä¼šç¤¾åã€ã¾ãŸã¯å§“ã¨åã¨è«‹æ±‚æ›¸ç•ªå·ã®ã¿å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(511916,14220,'pt','Linhas de itens adicionais na mesma fatura sÃ³ precisa do nome da empresa ou primeiro e Ãºltimo nome e o nÃºmero da factura.',0),(511917,14220,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð² Ñ‚Ð¾Ð¼ Ð¶Ðµ ÑÑ‡ÐµÑ‚Ðµ Ð½ÑƒÐ¶Ð½Ð¾ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð»Ð¸ Ð¸Ð¼Ñ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸ÑŽ Ð¸ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹.',0),(511918,14220,'es','ArtÃ­culos de lÃ­nea adicionales en la misma factura sÃ³lo necesita el nombre de la empresa o nombre y apellido y el nÃºmero de factura.',0),(511919,14220,'de','ZusÃ¤tzliche Posten in derselben Rechnung brauchen nur den Firmennamen oder vor- und Nachname und die Rechnungsnummer an.',0),(511920,14220,'en','Additional line items in the same invoice only need the company name or first and last name and the invoice number.',0),(511921,14221,'is','',0),(511922,14221,'dr','Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ù†Ø§Ù… Ø§ÙˆÙ„ &amp; Ø¢Ø®Ø±ÛŒÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(511923,14221,'pr','Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ù†Ø§Ù… Ø§ÙˆÙ„ &amp; Ø¢Ø®Ø±ÛŒÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(511924,14221,'tr','Åžirket adÄ± veya ilk & son adÄ± olabilir',0),(511925,14221,'pl','MoÅ¼e byÄ‡ nazwa firmy lub pierwszy & Ostatni',0),(511926,14221,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿ÑŠÑ€Ð²Ð¾Ñ‚Ð¾ & Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(511927,14221,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… ÛŒØ§ Ù¾ÛÙ„ÛŒ & Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… ÛÙˆ Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(511928,14221,'sr','ÐœÐ¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð²Ð¾ Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð¸Ð¼Ðµ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(511929,14221,'vi','CÃ³ thá»ƒ lÃ  tÃªn cÃ´ng ty hoáº·c Ä‘áº§u tiÃªn &amp; cuá»‘i cÃ¹ng tÃªn',0),(511930,14221,'af','Maatskappy naam of eerste & laaste kan wees',0),(511931,14221,'ro','Poate fi numele de companie sau prima & ultima',0),(511932,14221,'et','VÃµib olla ettevÃµte vÃµi esimesel & viimasel nimi',0),(511933,14221,'si','Lahko prvi & zadnjikrat ime ali ime podjetja',0),(511934,14221,'ba','Dapat nama perusahaan atau nama pertama & terakhir',0),(511935,14221,'nl','Bedrijfsnaam of eerste & laatste naam kan worden',0),(511936,14221,'fi','Voi olla yrityksen nimi tai ensimmÃ¤inen & viimeinen nimi',0),(511937,14221,'no','Kan vÃ¦re firmanavnet eller fÃ¸rste & siste navn',0),(511938,14221,'da','Kan vÃ¦re virksomhedens navn eller fÃ¸rste & sidste navn',0),(511939,14221,'ko','íšŒì‚¬ ì´ë¦„ ë˜ëŠ” ì²« ë²ˆì§¸ & ë§ˆì§€ë§‰ ì´ë¦„ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(511940,14221,'he','×™×›×•×œ ×œ×”×™×•×ª ×©× ×—×‘×¨×” ××• ×©× ×¨××©×•×Ÿ ××—×¨×•×Ÿ &',0),(511941,14221,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î® Ï€ÏÏŽÏ„Î¿ & Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ ÏŒÎ½Î¿Î¼Î±',0),(511942,14221,'zh','å¯ä»¥æ˜¯å…¬å¸åç§°æˆ–ç¬¬ä¸€ä¸ª &amp; æœ€åŽä¸€ä¸ªåç§°',0),(511943,14221,'sv','Kan vara fÃ¶rsta & sista namn eller fÃ¶retagsnamn',0),(511944,14221,'it','PuÃ² essere il nome di azienda o & cognome',0),(511945,14221,'tl','',0),(511946,14221,'th','à¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸—à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢ & à¹à¸£à¸',0),(511947,14221,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® & à¤†à¤–à¤¿à¤°à¥€ à¤¨à¤¾à¤® à¤¹à¥‹ à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(511948,14221,'ms','Boleh nama Syarikat atau nama pertama & akhir',0),(511949,14221,'ar','ÙŠÙ…ÙƒÙ† Ø£Ù† ÙŠÙƒÙˆÙ† Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø£Ùˆ Ø§Ø³Ù… Ø£ÙˆÙ„ Ø¢Ù†Ø¯ Ø¢Ø®Ø±',0),(511950,14221,'fr','Peut Ãªtre le nom de la sociÃ©tÃ© ou le nom de premier & dernier',0),(511951,14221,'jp','ä¼šç¤¾åã¾ãŸã¯ & æœ€å¾Œã®æœ€åˆã®åå‰ã«ã™ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(511952,14221,'pt','Pode ser o primeiro & Ãºltimo nome ou nome da empresa',0),(511953,14221,'ru','ÐœÐ¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ, Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð»Ð¸ Ð¸Ð¼Ñ Ð¿ÐµÑ€Ð²Ð¾Ð³Ð¾ & Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾',0),(511954,14221,'es','Puede ser el nombre de empresa o nombre del primero al Ãºltimo &amp;',0),(511955,14221,'de','Kann Firma Name oder Vorname & Nachname',0),(511956,14221,'en','Can Be Company Name Or First & Last Name',0),(511957,14222,'is','',0),(511958,14222,'dr','Ø³ØªÙˆÙ† Ù‡Ø§ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(511959,14222,'pr','Ø³ØªÙˆÙ† Ù‡Ø§ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(511960,14222,'tr','Fatura sÃ¼tunlar',0),(511961,14222,'pl','Kolumny faktury',0),(511962,14222,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° ÐºÐ¾Ð»Ð¾Ð½Ð¸',0),(511963,14222,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ø§Ù„Ù…',0),(511964,14222,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÐ¾Ð»Ð¾Ð½Ðµ',0),(511965,14222,'vi','HoÃ¡ Ä‘Æ¡n cá»™t',0),(511966,14222,'af','Faktuur kolomme',0),(511967,14222,'ro','FacturÄƒ coloane',0),(511968,14222,'et','Arve veerud',0),(511969,14222,'si','RaÄun stolpcev',0),(511970,14222,'ba','Faktur kolom',0),(511971,14222,'nl','Factuur kolommen',0),(511972,14222,'fi','Laskun sarakkeet',0),(511973,14222,'no','Faktura kolonner',0),(511974,14222,'da','Faktura kolonner',0),(511975,14222,'ko','ì†¡ìž¥ ì—´',0),(511976,14222,'he','×¢×ž×•×“×•×ª ×—×©×‘×•× ×™×ª',0),(511977,14222,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÏ„Î®Î»ÎµÏ‚',0),(511978,14222,'zh','å‘ç¥¨åˆ—',0),(511979,14222,'sv','Faktura kolumner',0),(511980,14222,'it','Colonne di fattura',0),(511981,14222,'tl','',0),(511982,14222,'th','à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œà¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œ',0),(511983,14222,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‰à¤²à¤®',0),(511984,14222,'ms','Lajur invois',0),(511985,14222,'ar','Ø£Ø¹Ù…Ø¯Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(511986,14222,'fr','Colonnes de facture',0),(511987,14222,'jp','è«‹æ±‚æ›¸åˆ—',0),(511988,14222,'pt','Colunas de factura',0),(511989,14222,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐºÐ¾Ð»Ð¾Ð½Ð½Ñ‹',0),(511990,14222,'es','Columnas de factura',0),(511991,14222,'de','Rechnung-Spalten',0),(511992,14222,'en','Invoice Columns',0),(511993,14223,'is','',0),(511994,14223,'dr','ÙØ§ÛŒÙ„ CSV ÙØ§Ú©ØªÙˆØ±',0),(511995,14223,'pr','ÙØ§ÛŒÙ„ CSV ÙØ§Ú©ØªÙˆØ±',0),(511996,14223,'tr','Fatura CSV dosya',0),(511997,14223,'pl','Plik CSV faktury',0),(511998,14223,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° CSV Ñ„Ð°Ð¹Ð»',0),(511999,14223,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ CSV ÙØ§Ø¦Ù„',0),(512000,14223,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(512001,14223,'vi','HoÃ¡ Ä‘Æ¡n tá»‡p CSV',0),(512002,14223,'af','Faktuur CSV-lÃªer',0),(512003,14223,'ro','FacturÄƒ CSV dosar',0),(512004,14223,'et','Arve CSV-faili',0),(512005,14223,'si','Datoteka CSV raÄuna',0),(512006,14223,'ba','File CSV faktur',0),(512007,14223,'nl','Factuur CSV-bestand',0),(512008,14223,'fi','Laskun CSV-tiedosto',0),(512009,14223,'no','Faktura CSV-fil',0),(512010,14223,'da','Faktura CSV-fil',0),(512011,14223,'ko','ì†¡ìž¥ CSV íŒŒì¼',0),(512012,14223,'he','×§×•×‘×¥ ×”-CSV ×—×©×‘×•× ×™×ª',0),(512013,14223,'el','Î¤Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ CSV Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(512014,14223,'zh','å‘ç¥¨çš„ CSV æ–‡ä»¶',0),(512015,14223,'sv','Faktura CSV-filen',0),(512016,14223,'it','Fattura CSV file.',0),(512017,14223,'tl','',0),(512018,14223,'th','à¹„à¸Ÿà¸¥à¹Œ CSV à¸‚à¸­à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(512019,14223,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ CSV à¤«à¤¼à¤¾à¤‡à¤²',0),(512020,14223,'ms','Fail CSV invois',0),(512021,14223,'ar','Ù…Ù„Ù CSV Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(512022,14223,'fr','Fichier CSV de facture',0),(512023,14223,'jp','è«‹æ±‚æ›¸ã® CSV ãƒ•ã‚¡ã‚¤ãƒ«',0),(512024,14223,'pt','Arquivo CSV de factura',0),(512025,14223,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ CSV-Ñ„Ð°Ð¹Ð»Ð°',0),(512026,14223,'es','Factura un archivo CSV',0),(512027,14223,'de','Rechnung-CSV-Datei',0),(512028,14223,'en','Invoice CSV File',0),(512029,14224,'is','',0),(512030,14224,'dr','ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª',0),(512031,14224,'pr','ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª',0),(512032,14224,'tr','Fatura alma',0),(512033,14224,'pl','Faktura Import',0),(512034,14224,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(512035,14224,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(512036,14224,'sr','Ð£Ð²Ð¾Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(512037,14224,'vi','HoÃ¡ Ä‘Æ¡n nháº­p kháº©u',0),(512038,14224,'af','Faktuur invoer',0),(512039,14224,'ro','Factura de Import',0),(512040,14224,'et','Arvete Import',0),(512041,14224,'si','Uvoznega raÄuna',0),(512042,14224,'ba','Faktur impor',0),(512043,14224,'nl','Factuur importeren',0),(512044,14224,'fi','Laskun tuonti',0),(512045,14224,'no','Faktura Import',0),(512046,14224,'da','Faktura Import',0),(512047,14224,'ko','ì¸ë³´ì´ìŠ¤ ê°€ì ¸ì˜¤ê¸°',0),(512048,14224,'he','×™×‘× ×—×©×‘×•× ×™×ª',0),(512049,14224,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(512050,14224,'zh','å¯¼å…¥å‘ç¥¨',0),(512051,14224,'sv','Faktura Import',0),(512052,14224,'it','Fattura importazione',0),(512053,14224,'tl','',0),(512054,14224,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(512055,14224,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤†à¤¯à¤¾à¤¤',0),(512056,14224,'ms','Import invois',0),(512057,14224,'ar','ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(512058,14224,'fr','Importation de factures',0),(512059,14224,'jp','è«‹æ±‚æ›¸ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(512060,14224,'pt','Factura de importaÃ§Ã£o',0),(512061,14224,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(512062,14224,'es','Factura de importaciÃ³n',0),(512063,14224,'de','Rechnung-Import',0),(512064,14224,'en','Invoice Import',0),(512065,14225,'is','',0),(512066,14225,'dr','Ø¨Ø§ÛŒØ¯ Ø¨Ø§ÛŒØ¯ ÙØ§Ú©ØªÙˆØ± Ø´Ù…Ø§Ø±Ù‡ Ø´Ø±Ú©Øª Ùˆ ÛŒØ§ Ù†Ø§Ù… Ø§ÙˆÙ„ &amp; Ø¢Ø®Ø±ÛŒÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(512067,14225,'pr','Ø¨Ø§ÛŒØ¯ Ø¨Ø§ÛŒØ¯ ÙØ§Ú©ØªÙˆØ± Ø´Ù…Ø§Ø±Ù‡ Ø´Ø±Ú©Øª Ùˆ ÛŒØ§ Ù†Ø§Ù… Ø§ÙˆÙ„ &amp; Ø¢Ø®Ø±ÛŒÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(512068,14225,'tr','Have fatura numarasÄ± ve ÅŸirket adÄ± veya ilk & son adÄ± olmalÄ±dÄ±r',0),(512069,14225,'pl','Musi mieÄ‡ faktury numer i firma nazwisko lub pierwszy & Ostatni',0),(512070,14225,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð¸Ð¼Ðµ Ð¸Ð»Ð¸ Ð¿ÑŠÑ€Ð²Ð¾ & Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(512071,14225,'ur','ÛÛ’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø± Ø§ÙˆØ± Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… ÛŒØ§ Ù¾ÛÙ„ÛŒ & Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ú†Ø§ÛÛŒÛ’',0),(512072,14225,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¸Ð¼Ð°Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð±Ñ€Ð¾Ñ˜ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¸ Ð¸Ð¼Ðµ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð¿Ñ€Ð²Ðµ Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ',0),(512073,14225,'vi','Pháº£i cÃ³ hoÃ¡ Ä‘Æ¡n sá»‘ vÃ  tÃªn cÃ´ng ty hoáº·c Ä‘áº§u tiÃªn &amp; cuá»‘i cÃ¹ng tÃªn',0),(512074,14225,'af','Moet hÃª faktuur nommer en maatskappy naam of eerste en laaste',0),(512075,14225,'ro','Trebuie sÄƒ au factura numÄƒr ÅŸi Nume companie sau primul & ultimul nume',0),(512076,14225,'et','Peab olema arve Number ja firma nimi vÃµi esimesel & viimasel',0),(512077,14225,'si','Mora imeti raÄun Å¡tevilka in ime podjetja ali prvi & zadnjikrat ime',0),(512078,14225,'ba','Harus memiliki faktur nomor dan perusahaan atau nama pertama & terakhir',0),(512079,14225,'nl','Moet hebben factuur nummer en bedrijfsnaam of eerste & laatste naam',0),(512080,14225,'fi','On saada laskun numero ja yrityksen nimi tai ensimmÃ¤inen & sukunimi',0),(512081,14225,'no','MÃ¥ ha tall og fakturafirmaet navn eller fÃ¸rste & siste',0),(512082,14225,'da','Skal Have faktura nummer og virksomhedens navn eller fÃ¸rste & sidste navn',0),(512083,14225,'ko','ì´ ì†¡ìž¥ ë²ˆí˜¸ì™€ íšŒì‚¬ ì´ë¦„ ë˜ëŠ” ì²« ë²ˆì§¸ & ë§ˆì§€ë§‰ ì´ë¦„ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(512084,14225,'he','×‘×˜×— ×™×© ×—×©×‘×•× ×™×ª ×ž×¡×¤×¨ ×—×‘×¨×” ××• ×©× ×¨××©×•×Ÿ ××—×¨×•×Ÿ &',0),(512085,14225,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡Î¿Ï…Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ ÎºÎ±Î¹ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÏŒÎ½Î¿Î¼Î± Î® ÏŒÎ½Î¿Î¼Î± Ï€ÏÏŽÏ„Î· & Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î±',0),(512086,14225,'zh','å¿…é¡»æœ‰å‘ç¥¨å·ç å’Œå…¬å¸åç§°æˆ–ç¬¬ä¸€ä¸ª &amp; æœ€åŽä¸€ä¸ªåç§°',0),(512087,14225,'sv','MÃ¥ste ha nummer och fakturafÃ¶retaget eller fÃ¶rsta & sista namn',0),(512088,14225,'it','Deve avere fattura numero e nome o & cognome',0),(512089,14225,'tl','',0),(512090,14225,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ à¹à¸¥à¸° à¸šà¸£à¸´à¸©à¸±à¸—à¸Šà¸·à¹ˆà¸­à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢ & à¹à¸£à¸',0),(512091,14225,'hi','à¤ªà¤¾à¤¸ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤”à¤° à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® & à¤†à¤–à¤¿à¤°à¥€ à¤¨à¤¾à¤® à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(512092,14225,'ms','Mesti mempunyai invois nombor dan Syarikat atau nama pertama & terakhir',0),(512093,14225,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø±Ù‚Ù… Ø§Ù„Ø´Ø±ÙƒØ© ÙˆØ§Ù„Ø§Ø³Ù… Ø£Ùˆ Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„ Ø¢Ù†Ø¯ Ø§Ù„Ø£Ø®ÙŠØ±',0),(512094,14225,'fr','Doit le nom de compagnie et numÃ©ro de facture Have ou premier & dernier',0),(512095,14225,'jp','æŒã£ã¦ã„ã‚‹è«‹æ±‚æ›¸ç•ªå·ã€ä¼šç¤¾åã¾ãŸã¯ & åå­—ã®æœ€åˆã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(512096,14225,'pt','Deve ter nota fiscal nÃºmero e empresa nome ou nome de primeiro & Ãºltimo',0),(512097,14225,'ru','Ð”Ð¾Ð»Ð¶Ð½Ñ‹ Ð¸Ð¼ÐµÑ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð¼Ñ Ð¸Ð»Ð¸ Ð¸Ð¼Ñ Ð¿ÐµÑ€Ð²Ð¾Ð³Ð¾ & Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾',0),(512098,14225,'es','Debe tener factura nÃºmero y nombre de compaÃ±Ã­a o nombre del primero al Ãºltimo &amp;',0),(512099,14225,'de','Muss Have Rechnung Nummer und Firmennamen oder Vorname & Nachname',0),(512100,14225,'en','Must Have Invoice Number And Company Name Or First & Last Name',0),(512101,14226,'is','',0),(512102,14226,'dr','Ù†Ø§Ù… Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(512103,14226,'pr','Ù†Ø§Ù… Ù…Ø­Ù„ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(512104,14226,'tr','Stok konumunun adÄ±nÄ±',0),(512105,14226,'pl','Nazwa lokalizacji zapasÃ³w',0),(512106,14226,'bg','Ð˜Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°',0),(512107,14226,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ù…Ù‚Ø§Ù… Ú©Ø§ Ù†Ø§Ù…',0),(512108,14226,'sr','Ð˜Ð¼Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(512109,14226,'vi','TÃªn cá»§a vá»‹ trÃ­ hÃ ng tá»“n kho',0),(512110,14226,'af','Naam van die ligging van voorraad',0),(512111,14226,'ro','Numele locaÅ£iei stocurilor',0),(512112,14226,'et','Lao asukoha nime',0),(512113,14226,'si','Ime lokacijo zaloge',0),(512114,14226,'ba','Nama lokasi persediaan',0),(512115,14226,'nl','Naam van de vestiging',0),(512116,14226,'fi','Varastosijainnin nimi',0),(512117,14226,'no','Navnet pÃ¥ lagerlokasjonen',0),(512118,14226,'da','Navnet pÃ¥ lagerlokation',0),(512119,14226,'ko','ìž¬ê³  ìœ„ì¹˜ ì´ë¦„',0),(512120,14226,'he','×©× ×”×ž×™×§×•× ×ž×œ××™',0),(512121,14226,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎ·',0),(512122,14226,'zh','åº“å­˜ä½ç½®çš„åç§°',0),(512123,14226,'sv','Namnet pÃ¥ lagerstÃ¤lle',0),(512124,14226,'it','Nome della localitÃ  inventario',0),(512125,14226,'tl','',0),(512126,14226,'th','à¸Šà¸·à¹ˆà¸­à¸‚à¸­à¸‡à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(512127,14226,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¤¾ à¤¨à¤¾à¤®',0),(512128,14226,'ms','Nama lokasi inventori',0),(512129,14226,'ar','Ø§Ø³Ù… Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(512130,14226,'fr','Nom de l\'emplacement de l\'inventaire',0),(512131,14226,'jp','åœ¨åº«å ´æ‰€ã®åå‰',0),(512132,14226,'pt','Nome do local de inventÃ¡rio',0),(512133,14226,'ru','Ð˜Ð¼Ñ Ð½Ð° ÑÐºÐ»Ð°Ð´Ðµ',0),(512134,14226,'es','Nombre de la ubicaciÃ³n de inventario',0),(512135,14226,'de','Name des Standortes Warenbestand',0),(512136,14226,'en','Name Of The Inventory Location',0),(512137,14227,'is','',0),(512138,14227,'dr','Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(512139,14227,'pr','Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(512140,14227,'tr','SatÄ±ÅŸ temsilcisinin adÄ±',0),(512141,14227,'pl','Nazwa sprzedawcy',0),(512142,14227,'bg','Ð˜Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†Ð°',0),(512143,14227,'ur','Ù¾Ø±Ø³Ù† Ú©Û’ Ù†Ø§Ù…',0),(512144,14227,'sr','Ð˜Ð¼Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(512145,14227,'vi','TÃªn cá»§a nhÃ¢n viÃªn bÃ¡n hÃ ng',0),(512146,14227,'af','Naam van die verkoopspersoon',0),(512147,14227,'ro','Numele agentului de vÃ¢nzÄƒri',0),(512148,14227,'et','MÃ¼Ã¼giesindaja nimi',0),(512149,14227,'si','Ime prodajalca',0),(512150,14227,'ba','Nama Penjual',0),(512151,14227,'nl','Naam van de verkoper',0),(512152,14227,'fi','MyyjÃ¤n nimi',0),(512153,14227,'no','Navnet pÃ¥ selgeren',0),(512154,14227,'da','Navnet pÃ¥ sÃ¦lgeren',0),(512155,14227,'ko','íŒë§¤ ì§ì›ì˜ ì´ë¦„',0),(512156,14227,'he','×©×ž×• ×©×œ ××™×© ×”×ž×›×™×¨×•×ª',0),(512157,14227,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Ï€Ï‰Î»Î·Ï„Î®',0),(512158,14227,'zh','é”€å”®å‘˜çš„åå­—',0),(512159,14227,'sv','Namnet pÃ¥ sÃ¤ljaren',0),(512160,14227,'it','Nome del venditore',0),(512161,14227,'tl','',0),(512162,14227,'th','à¸Šà¸·à¹ˆà¸­à¸‚à¸­à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢',0),(512163,14227,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤¨à¤¾à¤®',0),(512164,14227,'ms','Nama jurujual',0),(512165,14227,'ar','Ø§Ø³Ù… Ù…Ù†Ø¯ÙˆØ¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(512166,14227,'fr','Nom du vendeur',0),(512167,14227,'jp','è²©å£²å“¡ã®åå‰',0),(512168,14227,'pt','Nome do vendedor',0),(512169,14227,'ru','Ð˜Ð¼Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(512170,14227,'es','Nombre del vendedor',0),(512171,14227,'de','Name des VerkÃ¤ufers',0),(512172,14227,'en','Name Of The Salesperson',0),(512173,14228,'is','',0),(512174,14228,'dr','Ù†Ø§Ù… Ø±Ø¯Ù‡ ÙØ±ÙˆØ´',0),(512175,14228,'pr','Ù†Ø§Ù… Ø±Ø¯Ù‡ ÙØ±ÙˆØ´',0),(512176,14228,'tr','SatÄ±ÅŸ Kategori adÄ±',0),(512177,14228,'pl','Nazwa kategorii sprzedaÅ¼y',0),(512178,14228,'bg','Ð˜Ð¼ÐµÑ‚Ð¾ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÑ‚Ð°, Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(512179,14228,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø²Ù…Ø±Û’ Ú©Û’ Ù†Ø§Ù…',0),(512180,14228,'sr','Ð˜Ð¼Ðµ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(512181,14228,'vi','TÃªn cá»§a cÃ¡c loáº¡i bÃ¡n hÃ ng',0),(512182,14228,'af','Naam van die verkope kategorie',0),(512183,14228,'ro','Denumirea categoriei din vÃ¢nzÄƒri',0),(512184,14228,'et','MÃ¼Ã¼k kategooria nimi',0),(512185,14228,'si','Ime zvrsti, prodaje',0),(512186,14228,'ba','Nama kategori penjualan',0),(512187,14228,'nl','Naam van de verkoop categorie',0),(512188,14228,'fi','Myynti luokan nimi',0),(512189,14228,'no','Navnet pÃ¥ kategorien salg',0),(512190,14228,'da','Navnet pÃ¥ kategorien salg',0),(512191,14228,'ko','íŒë§¤ ì¹´í…Œê³ ë¦¬ì˜ ì´ë¦„',0),(512192,14228,'he','×”×©× ×©×œ ×”×§×˜×’×•×¨×™×” ×ž×›×™×¨×•×ª',0),(512193,14228,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(512194,14228,'zh','é”€å”®ç±»åˆ«çš„åç§°',0),(512195,14228,'sv','Namnet pÃ¥ kategorin fÃ¶rsÃ¤ljning',0),(512196,14228,'it','Nome della categoria vendita',0),(512197,14228,'tl','',0),(512198,14228,'th','à¸Šà¸·à¹ˆà¸­à¸‚à¸­à¸‡à¸›à¸£à¸°à¹€à¸ à¸—à¸à¸²à¸£à¸‚à¸²à¸¢',0),(512199,14228,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤¨à¤¾à¤®',0),(512200,14228,'ms','Nama kategori jualan',0),(512201,14228,'ar','Ø§Ø³Ù… ÙØ¦Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(512202,14228,'fr','Nom de la catÃ©gorie vente',0),(512203,14228,'jp','è²©å£²ã‚«ãƒ†ã‚´ãƒªã®åå‰',0),(512204,14228,'pt','Nome da categoria vendas',0),(512205,14228,'ru','Ð˜Ð¼Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(512206,14228,'es','Nombre de la categorÃ­a de ventas',0),(512207,14228,'de','Name der Kategorie, Vertrieb',0),(512208,14228,'en','Name Of The Sales Category',0),(512209,14229,'is','',0),(512210,14229,'dr','Ù†Ø§Ù… Ù…Ø§Ù„ÛŒØ§Øª Ø¯Ø± Ø³ÛŒØ³ØªÙ…',0),(512211,14229,'pr','Ù†Ø§Ù… Ù…Ø§Ù„ÛŒØ§Øª Ø¯Ø± Ø³ÛŒØ³ØªÙ…',0),(512212,14229,'tr','Vergi sistemi adÄ±',0),(512213,14229,'pl','Nazwa podatku w systemie',0),(512214,14229,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð´Ð°Ð½ÑŠÐºÐ° Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(512215,14229,'ur','Ø§Ø³ Ù¹ÛŒÚ©Ø³ Ú©Û’ Ù†Ø¸Ø§Ù… Ù…ÛŒÚº Ú©Û’ Ù†Ø§Ù…',0),(512216,14229,'sr','Ð˜Ð¼Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ',0),(512217,14229,'vi','TÃªn cá»§a thuáº¿ trong há»‡ thá»‘ng',0),(512218,14229,'af','Naam van die belasting In die stelsel',0),(512219,14229,'ro','Numele de TVA Ã®n sistem',0),(512220,14229,'et','Maksu sÃ¼steemi nimetus',0),(512221,14229,'si','Ime davka v sistem',0),(512222,14229,'ba','Nama pajak dalam sistem',0),(512223,14229,'nl','Naam van de belasting In het systeem',0),(512224,14229,'fi','Nimi verotuksen jÃ¤rjestelmÃ¤',0),(512225,14229,'no','Navnet pÃ¥ skatten i systemet',0),(512226,14229,'da','Navnet pÃ¥ skat i systemet',0),(512227,14229,'ko','ì‹œìŠ¤í…œì— ì„¸ê¸ˆì˜ ì´ë¦„',0),(512228,14229,'he','×©×ž×• ×©×œ ×”×ž×¡ ×‘×ž×¢×¨×›×ª',0),(512229,14229,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï… ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(512230,14229,'zh','ç¨ŽåŠ¡ç³»ç»Ÿä¸­çš„åç§°',0),(512231,14229,'sv','Namn av skatt i systemet',0),(512232,14229,'it','Nome dell\'imposta nel sistema',0),(512233,14229,'tl','',0),(512234,14229,'th','à¸Šà¸·à¹ˆà¸­à¸‚à¸­à¸‡à¸ à¸²à¸©à¸µà¹ƒà¸™à¸£à¸°à¸šà¸š',0),(512235,14229,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤®à¥‡à¤‚ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¤¾ à¤¨à¤¾à¤®',0),(512236,14229,'ms','Nama cukai dalam sistem',0),(512237,14229,'ar','Ø§Ø³Ù… Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(512238,14229,'fr','Nom de l\'impÃ´t dans le systÃ¨me',0),(512239,14229,'jp','ã‚·ã‚¹ãƒ†ãƒ ç¨Žã®åå‰',0),(512240,14229,'pt','Nome do imposto no sistema',0),(512241,14229,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ðµ',0),(512242,14229,'es','Nombre del impuesto en el sistema',0),(512243,14229,'de','Bezeichnung der Steuer im System',0),(512244,14229,'en','Name Of The Tax In The System',0),(512245,14230,'is','',0),(512246,14230,'dr','ØªÙ†Ù‡Ø§ Ø§Ú¯Ø± Ù…Ø´ØªØ±ÛŒØ§Ù† Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ØªÙ†Ø¸ÛŒÙ…',0),(512247,14230,'pr','ØªÙ†Ù‡Ø§ Ø§Ú¯Ø± Ù…Ø´ØªØ±ÛŒØ§Ù† Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ØªÙ†Ø¸ÛŒÙ…',0),(512248,14230,'tr','YalnÄ±zca varolan mÃ¼ÅŸteriler gÃ¼ncelleÅŸtirme kÃ¼me',0),(512249,14230,'pl','Tylko zestaw, jeÅ›li aktualizacja istniejÄ…cych klientÃ³w',0),(512250,14230,'bg','Ð—Ð°Ð´Ð°Ð´ÐµÐ½Ð¸ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(512251,14230,'ur','ØµØ±Ù Ù…ÙˆØ¬ÙˆØ¯Û Ú¯Ø§ÛÚ©ÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’ Ø§Ú¯Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(512252,14230,'sr','Ð¡Ð°Ð¼Ð¾ Ð°ÐºÐ¾ Ð¿Ð¾Ð´ÐµÑÐ¸Ñ‚Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸Ñ… ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(512253,14230,'vi','Chá»‰ Ä‘áº·t náº¿u Cáº­p nháº­t cÃ¡c khÃ¡ch hÃ ng hiá»‡n táº¡i',0),(512254,14230,'af','Stel slegs indien bywerking van bestaande kliÃ«nte',0),(512255,14230,'ro','Setate numai dacÄƒ actualizarea clienÅ£ii existente',0),(512256,14230,'et','Seada ainult kui ajakohastamist olemasolevate klientide',0),(512257,14230,'si','Nastaviti le, Äe posodabljanje obstojeÄe stranke',0),(512258,14230,'ba','Hanya ditetapkan jika memperbarui Pelanggan yang sudah ada',0),(512259,14230,'nl','Alleen ingesteld als bestaande klanten wilt bijwerken',0),(512260,14230,'fi','MÃ¤Ã¤rittÃ¤Ã¤ vain jos pÃ¤ivittÃ¤Ã¤ olemassa olevat asiakkaat',0),(512261,14230,'no','Bare angi hvis oppdaterer eksisterende kunder',0),(512262,14230,'da','Eneste sÃ¦t hvis opdatering af eksisterende kunder',0),(512263,14230,'ko','ê¸°ì¡´ ê³ ê°ì„ ì—…ë°ì´íŠ¸ í•˜ëŠ” ê²½ìš°ì— ì„¤ì •',0),(512264,14230,'he','×¨×§ ×œ×§×‘×•×¢ ×× ×¢×“×›×•×Ÿ ×œ×§×•×—×•×ª ×§×™×™×ž×™×',0),(512265,14230,'el','ÎœÏŒÎ½Î¿ Ï€Î¿Ï… Î±Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„ÎµÏ‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(512266,14230,'zh','å¦‚æžœæ›´æ–°çŽ°æœ‰çš„å®¢æˆ·ï¼Œåˆ™åªè®¾ç½®',0),(512267,14230,'sv','Bara stÃ¤lla om uppdaterar befintliga kunder',0),(512268,14230,'it','Impostare solo se aggiornando i clienti esistenti',0),(512269,14230,'tl','',0),(512270,14230,'th','à¸Šà¸¸à¸”à¹€à¸”à¸µà¸¢à¸§à¸–à¹‰à¸²à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(512271,14230,'hi','à¤•à¥‡à¤µà¤² à¤¯à¤¦à¤¿ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(512272,14230,'ms','Hanya menetapkan jika mengemaskini pelanggan sedia ada',0),(512273,14230,'ar','ØªØ¹ÙŠÙŠÙ† ÙÙ‚Ø· Ø¥Ø°Ø§ ÙƒØ§Ù† ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø­Ø§Ù„ÙŠÙŠÙ†',0),(512274,14230,'fr','DÃ©finie uniquement si la mise Ã  jour de clients existants',0),(512275,14230,'jp','æ—¢å­˜ã®é¡§å®¢ã‚’æ›´æ–°ã™ã‚‹å ´åˆã«ã®ã¿è¨­å®šã—ã¾ã™ã€‚',0),(512276,14230,'pt','Apenas definir se atualizando clientes existentes',0),(512277,14230,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐµÑÐ»Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(512278,14230,'es','SÃ³lo establecer si actualizando a los clientes existentes',0),(512279,14230,'de','Nur festgelegt, wenn bestehende Kunden aktualisieren',0),(512280,14230,'en','Only Set If Updating Existing Customers',0),(512281,14231,'is','',0),(512282,14231,'dr','Ù†Ø³Ø®Ù‡ Ù‚Ø§Ø¨Ù„ Ú†Ø§Ù¾ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ ÙˆØ§Ø±Ø¯Ø§ØªÛŒ',0),(512283,14231,'pr','Ù†Ø³Ø®Ù‡ Ù‚Ø§Ø¨Ù„ Ú†Ø§Ù¾ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ ÙˆØ§Ø±Ø¯Ø§ØªÛŒ',0),(512284,14231,'tr','AlÄ±nan fatura yazdÄ±r',0),(512285,14231,'pl','Drukowanie faktur importowane',0),(512286,14231,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð²Ð½Ð¾Ñ',0),(512287,14231,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û ÙˆØ¨Ø¬Ù„ÛŒ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(512288,14231,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÑƒÐ²Ð¾Ð·Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(512289,14231,'vi','In hÃ³a Ä‘Æ¡n nháº­p kháº©u',0),(512290,14231,'af','Ingevoerde fakture te druk',0),(512291,14231,'ro','TipÄƒriÅ£i facturi importate',0),(512292,14231,'et','Prindi imporditud arved',0),(512293,14231,'si','Tiskanje uvoÅ¾enih raÄunov',0),(512294,14231,'ba','Mencetak faktur impor',0),(512295,14231,'nl','GeÃ¯mporteerde facturen afdrukken',0),(512296,14231,'fi','Tulostaa tuodut laskuja',0),(512297,14231,'no','Skrive ut importerte fakturaer',0),(512298,14231,'da','Udskrive importerede fakturaer',0),(512299,14231,'ko','ìˆ˜ìž…ëœ ì†¡ìž¥ ì¸ì‡„',0),(512300,14231,'he','×œ×”×“×¤×™×¡ ×—×©×‘×•× ×™×•×ª ×ž×™×•×‘××™×',0),(512301,14231,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎµÎ¹ÏƒÎ±Î³ÏŒÎ¼ÎµÎ½Î±',0),(512302,14231,'zh','æ‰“å°å¯¼å…¥çš„å‘ç¥¨',0),(512303,14231,'sv','Skriva ut importerade fakturor',0),(512304,14231,'it','Stampa fatture importate',0),(512305,14231,'tl','',0),(512306,14231,'th','à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(512307,14231,'hi','à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(512308,14231,'ms','Mencetak invois yang diimport',0),(512309,14231,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(512310,14231,'fr','Imprimer des factures importÃ©s',0),(512311,14231,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚ŒãŸè«‹æ±‚æ›¸ã®å°åˆ·ã—ã¾ã™ã€‚',0),(512312,14231,'pt','Imprimir facturas importadas',0),(512313,14231,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(512314,14231,'es','Imprimir facturas importadas',0),(512315,14231,'de','Importierte Rechnungen drucken',0),(512316,14231,'en','Print Imported Invoices',0),(512317,14232,'is','',0),(512318,14232,'dr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¬Ø¯ÛŒØ¯',0),(512319,14232,'pr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¬Ø¯ÛŒØ¯',0),(512320,14232,'tr','Yeni mÃ¼ÅŸteriler iÃ§in Ã¶nerilen',0),(512321,14232,'pl','Zalecane dla nowych klientÃ³w',0),(512322,14232,'bg','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑŠÑ‡Ð²Ð° ÑÐµ Ð·Ð° Ð½Ð¾Ð²Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(512323,14232,'ur','Ù†Ø¦Û’ ØµØ§Ø±ÙÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø³ÙØ§Ø±Ø´ Ú©ÛŒ Ø¬Ø§ØªÛŒ ÛÛ’',0),(512324,14232,'sr','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑƒÑ‡ÑƒÑ˜Ðµ ÑÐµ Ð·Ð° Ð½Ð¾Ð²Ðµ ÐºÑƒÐ¿Ñ†Ðµ',0),(512325,14232,'vi','Khuyáº¿n khÃ­ch cho cÃ¡c khÃ¡ch hÃ ng má»›i',0),(512326,14232,'af','Aanbeveel vir nuwe kliÃ«nte',0),(512327,14232,'ro','Recomandat pentru clientii noi',0),(512328,14232,'et','Soovitatav uutele klientidele',0),(512329,14232,'si','PriporoÄljivo za nove stranke',0),(512330,14232,'ba','Direkomendasikan untuk pelanggan baru',0),(512331,14232,'nl','Aanbevolen voor nieuwe klanten',0),(512332,14232,'fi','Suositeltavaa uusille asiakkaille',0),(512333,14232,'no','Anbefales For nye kunder',0),(512334,14232,'da','Anbefales til nye kunder',0),(512335,14232,'ko','ì‹ ê·œ ê³ ê°ì— ëŒ€ í•œ ê¶Œìž¥',0),(512336,14232,'he','×ž×•×ž×œ×¥ ×¢×‘×•×¨ ×œ×§×•×—×•×ª ×—×“×©×™×',0),(512337,14232,'el','Î£Ï…Î½Î¹ÏƒÏ„Î¬Ï„Î±Î¹ Î³Î¹Î± Î½Î­Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(512338,14232,'zh','æŽ¨èç»™æ–°å®¢æˆ·',0),(512339,14232,'sv','Rekommenderas fÃ¶r nya kunder',0),(512340,14232,'it','Consigliato per i nuovi clienti',0),(512341,14232,'tl','',0),(512342,14232,'th','à¹à¸™à¸°à¸™à¸³à¸ªà¸³à¸«à¸£à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸«à¸¡à¹ˆ',0),(512343,14232,'hi','à¤¨à¤ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤¶à¤‚à¤¸à¤¿à¤¤',0),(512344,14232,'ms','Disyorkan untuk pelanggan baru',0),(512345,14232,'ar','ÙˆØ£ÙˆØµØª Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø¬Ø¯Ø¯',0),(512346,14232,'fr','RecommandÃ© pour les nouveaux clients',0),(512347,14232,'jp','æ–°ã—ã„ãŠå®¢æ§˜ã«ãŠå‹§ã‚',0),(512348,14232,'pt','Recomendado para novos clientes',0),(512349,14232,'ru','Ð ÐµÐºÐ¾Ð¼ÐµÐ½Ð´ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ Ð½Ð¾Ð²Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(512350,14232,'es','Recomendado para los nuevos clientes',0),(512351,14232,'de','Empfohlen fÃ¼r Neukunden',0),(512352,14232,'en','Recommended For New Customers',0),(512353,14233,'is','',0),(512354,14233,'dr','Ù…Ú¯Ø± Ø¯Ø± Ù…ÙˆØ§Ø±Ø¯ÛŒ Ú©Ù‡ Ù†Ø§Ù… Ø´Ø±Ú©Øª ØªÙ†Ø¸ÛŒÙ… Ø´Ø¯Ù‡ Ø§Ø³Øª Ù„Ø§Ø²Ù…',0),(512355,14233,'pr','Ù…Ú¯Ø± Ø¯Ø± Ù…ÙˆØ§Ø±Ø¯ÛŒ Ú©Ù‡ Ù†Ø§Ù… Ø´Ø±Ú©Øª ØªÙ†Ø¸ÛŒÙ… Ø´Ø¯Ù‡ Ø§Ø³Øª Ù„Ø§Ø²Ù…',0),(512356,14233,'tr','Åžirket adÄ± ayarlanmadÄ±ÄŸÄ± sÃ¼rece gerekli',0),(512357,14233,'pl','Wymagane, chyba Å¼e znajduje siÄ™ nazwa firmy',0),(512358,14233,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ð¾ÑÐ²ÐµÐ½ Ð°ÐºÐ¾ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð° Ðµ Ñ€Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½',0),(512359,14233,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… Ù…Ù‚Ø±Ø± Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Ø¬Ø¨ ØªÚ© Ú©Û Ù…Ø·Ù„ÙˆØ¨Û',0),(512360,14233,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð° , Ð¾ÑÐ¸Ð¼ Ð°ÐºÐ¾ Ð½Ð°Ð·Ð¸Ð² Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ð° Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(512361,14233,'vi','YÃªu cáº§u trá»« khi tÃªn cÃ´ng ty Ä‘Æ°á»£c thiáº¿t láº­p',0),(512362,14233,'af','Vereis tensy maatskappy naam Is opgestel',0),(512363,14233,'ro','Necesare dacÄƒ numele companiei este setatÄƒ',0),(512364,14233,'et','Vajalik kui firma nimi on seatud',0),(512365,14233,'si','Potrebno, razen Äe ime podjetja nastavljena',0),(512366,14233,'ba','Diperlukan kecuali nama perusahaan diatur',0),(512367,14233,'nl','Vereist tenzij bedrijfsnaam Is ingesteld',0),(512368,14233,'fi','Pakollinen ellei yrityksen nimi on mÃ¤Ã¤ritetty',0),(512369,14233,'no','Kreves med mindre firmanavnet er satt',0),(512370,14233,'da','PÃ¥krÃ¦vet, medmindre selskabet navn er angivet',0),(512371,14233,'ko','íšŒì‚¬ ì´ë¦„ì´ ì„¤ì • ë˜ì–´ ìžˆì§€ ì•Šìœ¼ë©´ í•„ìš”í•œ',0),(512372,14233,'he','× ×“×¨×©×™× ××œ× ×× ×›×Ÿ × ×§×‘×¢ ×©× ×”×—×‘×¨×”',0),(512373,14233,'el','Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹, ÎµÎºÏ„ÏŒÏ‚ ÎµÎ¬Î½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(512374,14233,'zh','å¿…å¡«ï¼Œé™¤éžå…¬å¸åç§°è®¾ç½®',0),(512375,14233,'sv','KrÃ¤vs om inte fÃ¶retagets namn Ã¤r instÃ¤lld',0),(512376,14233,'it','Necessaria a meno che il nome della societÃ  Ã¨ impostata',0),(512377,14233,'tl','',0),(512378,14233,'th','à¸ˆà¸³à¹€à¸›à¹‡à¸™à¹€à¸§à¹‰à¸™à¹à¸•à¹ˆà¸ˆà¸°à¸•à¸±à¹‰à¸‡à¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸—',0),(512379,14233,'hi','à¤œà¤¬ à¤¤à¤• à¤•à¤¿ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¸à¥à¤¥à¤¾à¤ªà¤¿à¤¤ à¤¹à¥ˆ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(512380,14233,'ms','Diperlukan kecuali nama Syarikat terletak',0),(512381,14233,'ar','Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© Ù…Ø§ Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ©',0),(512382,14233,'fr','Requis sauf si le nom de l\'entreprise est',0),(512383,14233,'jp','ä¼šç¤¾åãŒè¨­å®šã•ã‚Œã¦ã„ãªã„å ´åˆã«å¿…è¦ãª',0),(512384,14233,'pt','NecessÃ¡ria a menos que o nome da empresa Ã© definido',0),(512385,14233,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ, ÐµÑÐ»Ð¸ Ð½Ðµ Ð·Ð°Ð´Ð°Ð½Ð¾ Ð¸Ð¼Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(512386,14233,'es','Obligatorio a menos que se establece el nombre de la empresa',0),(512387,14233,'de','Erforderlich, wenn Firmenname festgelegt ist',0),(512388,14233,'en','Required Unless Company Name Is Set',0),(512389,14234,'is','',0),(512390,14234,'dr','Ù…Ú¯Ø± Ø¯Ø± Ù…ÙˆØ§Ø±Ø¯ÛŒ Ú©Ù‡ Ù†Ø§Ù… Ø§ÙˆÙ„ÛŒÙ† &amp; Ú¯Ø°Ø´ØªÙ‡ ØªØ¹ÛŒÛŒÙ† Ù†ÛŒØ§Ø²',0),(512391,14234,'pr','Ù…Ú¯Ø± Ø¯Ø± Ù…ÙˆØ§Ø±Ø¯ÛŒ Ú©Ù‡ Ù†Ø§Ù… Ø§ÙˆÙ„ÛŒÙ† &amp; Ú¯Ø°Ø´ØªÙ‡ ØªØ¹ÛŒÛŒÙ† Ù†ÛŒØ§Ø²',0),(512392,14234,'tr','Ä°lk & son adÄ± ayarlanÄ±r sÃ¼rece gerekli',0),(512393,14234,'pl','Wymagane, chyba Å¼e znajdujÄ… siÄ™ nazwa pierwszego & Ostatni',0),(512394,14234,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ð¾ÑÐ²ÐµÐ½ Ð°ÐºÐ¾ Ð¿ÑŠÑ€Ð²Ð°Ñ‚Ð° & Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ ÑÐ° Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¸',0),(512395,14234,'ur','Ø¬Ø¨ ØªÚ© Ú©Û Ù¾ÛÙ„ÛŒ & Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ø³ÛŒÙ¹ ÛÛŒÚº Ø¯Ø±Ú©Ø§Ø±',0),(512396,14234,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð¾ÑÐ¸Ð¼ Ð°ÐºÐ¾ Ð¿Ñ€Ð²Ð¾ Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð¸Ð¼Ðµ ÑÑƒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ðµ.',0),(512397,14234,'vi','YÃªu cáº§u trá»« khi tÃªn Ä‘áº§u tiÃªn &amp; cuá»‘i cÃ¹ng Ä‘Æ°á»£c thiáº¿t láº­p',0),(512398,14234,'af','Vereis tensy eerste & verlede naam is opgestel',0),(512399,14234,'ro','NecesarÄƒ dacÄƒ nu prima & ultima nume sunt stabilite',0),(512400,14234,'et','NÃµutav kui esimene & viimase nime mÃ¤Ã¤ratud',0),(512401,14234,'si','Potrebna, razen Äe so doloÄene prvi & zadnje ime',0),(512402,14234,'ba','Diperlukan kecuali nama pertama & terakhir ditetapkan',0),(512403,14234,'nl','Vereist tenzij eerste & laatste naam zijn ingesteld',0),(512404,14234,'fi','Pakollinen ellei ensimmÃ¤inen & viimeinen nimi on mÃ¤Ã¤ritetty',0),(512405,14234,'no','Kreves hvis ikke fÃ¸rste & siste navn er angitt',0),(512406,14234,'da','PÃ¥krÃ¦vet, medmindre fÃ¸rste & sidste navn angives',0),(512407,14234,'ko','ì²« ë²ˆì§¸ & ë§ˆì§€ë§‰ ì´ë¦„ ì„¤ì • í•„ìš”',0),(512408,14234,'he','× ×“×¨×©×™× ××œ× ×× ×›×Ÿ ×”×¨××©×•×Ÿ & ×”××—×¨×•×Ÿ ×©× × ×§×‘×¢×™×',0),(512409,14234,'el','Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹, ÎµÎºÏ„ÏŒÏ‚ ÎµÎ¬Î½ ÎºÎ±Î¸Î¿ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹ Ï€ÏÏŽÏ„Î· & Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ ÏŒÎ½Î¿Î¼Î±',0),(512410,14234,'zh','å¿…å¡«ï¼Œé™¤éžç¬¬ä¸€ &amp; æœ€åŽåç§°è®¾ç½®',0),(512411,14234,'sv','KrÃ¤vs om inte fÃ¶rsta & fÃ¶rra namn anges',0),(512412,14234,'it','Obbligatorio se non sono impostati prima & ultimo nome',0),(512413,14234,'tl','',0),(512414,14234,'th','à¸ˆà¸³à¹€à¸›à¹‡à¸™à¹€à¸§à¹‰à¸™à¹à¸•à¹ˆà¸ˆà¸°à¸¡à¸µà¸•à¸±à¹‰à¸‡à¸Šà¸·à¹ˆà¸­à¸„à¸£à¸±à¹‰à¸‡à¹à¸£à¸ & à¸„à¸£à¸±à¹‰à¸‡à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(512415,14234,'hi','à¤œà¤¬ à¤¤à¤• à¤•à¤¿ à¤ªà¤¹à¤²à¥€ & à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¸à¥à¤¥à¤¾à¤ªà¤¿à¤¤ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(512416,14234,'ms','Diperlukan kecuali nama pertama & tarikh ditetapkan',0),(512417,14234,'ar','Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© Ù…Ø§ Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„ Ø¢Ù†Ø¯ Ø§Ù„Ù…Ø§Ø¶ÙŠ',0),(512418,14234,'fr','Requis, sauf si le nom de premier & dernier sont dÃ©finies',0),(512419,14234,'jp','æœ€åˆ & æœ€å¾Œã®åå‰ãŒè¨­å®šã•ã‚Œã¦ã„ãªã„ãŸã‚ã«å¿…è¦ãª',0),(512420,14234,'pt','NecessÃ¡rio a menos que primeiro & Ãºltimo nome sÃ£o definidas',0),(512421,14234,'ru','Ð•ÑÐ»Ð¸ Ð¿ÐµÑ€Ð²Ñ‹Ð¹ & ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ Ð¸Ð¼Ñ Ð½Ð°Ð±Ð¾Ñ€Ð°',0),(512422,14234,'es','Obligatorio a menos que primero &amp; Ãºltimo nombre se establecen',0),(512423,14234,'de','Erforderlich, wenn die ersten & letzten Namen werden festgelegt',0),(512424,14234,'en','Required Unless First & Last Name Are Set',0),(512425,14235,'is','',0),(512426,14235,'dr','Ù…Ø³Ø¦ÙˆÙ„ Ø®Ø±ÙŠØ¯ Ú©Ù„ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(512427,14235,'pr','Ù…Ø³Ø¦ÙˆÙ„ Ø®Ø±ÙŠØ¯ Ú©Ù„ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(512428,14235,'tr','Kargo Ã¼creti her sipariÅŸ iÃ§in',0),(512429,14235,'pl','OpÅ‚aty za przesyÅ‚ki dla caÅ‚ego Zakonu',0),(512430,14235,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð° Ñ†ÑÐ»Ð°Ñ‚Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(512431,14235,'ur','Ø§Ø³ Ù¾ÙˆØ±ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’ Ú†Ø§Ø±Ø¬ Ø´Ù¾Ù†Ú¯',0),(512432,14235,'sr','ÐŸÑƒÑšÐµÑšÐµ Ð·Ð° Ñ†ÐµÐ¾ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(512433,14235,'vi','Váº­n chuyá»ƒn phÃ­ bá»™ toÃ n bá»™',0),(512434,14235,'af','Koste vir die hele bestelling gestuur',0),(512435,14235,'ro','Taxa de transport maritim pentru ordine Ã®ntregi',0),(512436,14235,'et','Laevandus tasuta kogu tellimus',0),(512437,14235,'si','Ladijski promet odgovoren za celotno naroÄilo',0),(512438,14235,'ba','Biaya pengiriman untuk pesanan seluruh',0),(512439,14235,'nl','Verzendkosten voor de gehele Order',0),(512440,14235,'fi','Rahtikuluja varten koko tilaus',0),(512441,14235,'no','Frakt kostnader For hele bestillingen',0),(512442,14235,'da','Leveringsgebyr For hele ordren',0),(512443,14235,'ko','ì „ì²´ ì£¼ë¬¸ì— ëŒ€ í•œ ìš´ì†¡ ìš”ê¸ˆ',0),(512444,14235,'he','×¢×œ×•×ª ×”×ž×©×œ×•×— ×¢×‘×•×¨ ×›×œ ×”×–×ž× ×ª',0),(512445,14235,'el','ÎšÎŸÎ£Î¤ÎŸÎ£ Î‘Î ÎŸÎ£Î¤ÎŸÎ›Î—Î£ Î³Î¹Î± Ï„Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï„Î·Ï‚ Ï„Î¬Î¾Î·Ï‚',0),(512446,14235,'zh','æ•´ä¸ªè®¢å•æ”¶å–è¿è´¹',0),(512447,14235,'sv','Fraktkostnad fÃ¶r hela bestÃ¤llningen',0),(512448,14235,'it','Spese di spedizione per l\'intero ordine',0),(512449,14235,'tl','',0),(512450,14235,'th','à¸„à¹ˆà¸²à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(512451,14235,'hi','à¤ªà¥‚à¤°à¥‡ à¤•à¥à¤°à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤¶à¥à¤²à¥à¤•',0),(512452,14235,'ms','Caj penghantaran untuk pesanan seluruh',0),(512453,14235,'ar','Ù…ØµØ§Ø±ÙŠÙ Ø§Ù„Ø´Ø­Ù† Ù„Ø£Ù…Ø± ÙƒÙ„Ù‡',0),(512454,14235,'fr','Pour l\'ensemble de la commande, les frais de livraison',0),(512455,14235,'jp','æ³¨æ–‡å…¨ä½“ã«å¯¾ã™ã‚‹é€æ–™',0),(512456,14235,'pt','Taxa de envio para toda a ordem',0),(512457,14235,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð²ÑÐµÐ³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(512458,14235,'es','Gastos de envÃ­o para todo el orden',0),(512459,14235,'de','Versandkosten fÃ¼r die gesamte Bestellung',0),(512460,14235,'en','Shipping Charge For The Whole Order',0),(512461,14236,'is','',0),(512462,14236,'dr','Ù…Ø´ØªØ±ÛŒ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ú¯Ø± Ù†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(512463,14236,'pr','Ù…Ø´ØªØ±ÛŒ Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ú¯Ø± Ù†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(512464,14236,'tr','Kullanan mÃ¼ÅŸteri varsayÄ±lan deÄŸilse ayarla',0),(512465,14236,'pl','Klient uÅ¼ywa domyÅ›lnie, jeÅ›li nie zestaw',0),(512466,14236,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ, Ð°ÐºÐ¾ Ð½Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ',0),(512467,14236,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø³Ù¹Ù…Ø± Ø·Û’ Ø´Ø¯Û Ù†ÛÛŒÚº ØªÙˆ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(512468,14236,'sr','ÐšÑƒÐ¿Ð°Ñ† ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð°ÐºÐ¾ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸',0),(512469,14236,'vi','KhÃ¡ch hÃ ng sá»­ dá»¥ng máº·c Ä‘á»‹nh náº¿u khÃ´ng thiáº¿t láº­p',0),(512470,14236,'af','Gebruike kliÃ«nt verstek indien nie stel',0),(512471,14236,'ro','UtilizÄƒri clientul implicit dacÄƒ nu setaÅ£i',0),(512472,14236,'et','Kasutab klient vaikimisi kui mitte seada',0),(512473,14236,'si','Kupec uporablja privzeto, Äe ne nastavite',0),(512474,14236,'ba','Pelanggan menggunakan Default jika tidak diatur',0),(512475,14236,'nl','Gebruik klant standaard als niet is ingesteld',0),(512476,14236,'fi','KÃ¤yttÃ¤Ã¤ asiakkaan oletus, jos ei ole asetettu',0),(512477,14236,'no','Bruker kunden standard hvis ikke satt',0),(512478,14236,'da','Bruger kunden standard hvis ikke indstillet',0),(512479,14236,'ko','ì‚¬ìš© í•˜ ì—¬ ê³ ê° ê¸°ë³¸ ì„¤ì • ë˜ì§€ ì•Šì€ ê²½ìš°',0),(512480,14236,'he','×”×œ×§×•×— ×ž×©×ª×ž×© ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×× ×œ× ×ž×•×’×“×¨',0),(512481,14236,'el','Î§ÏÎ®ÏƒÎµÎ¹Ï‚ Ï€ÎµÎ»Î¬Ï„Î· Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î±Î½ Î´ÎµÎ½ Î¿ÏÎ¯ÏƒÎµÏ„Îµ',0),(512482,14236,'zh','ä½¿ç”¨å®¢æˆ·é»˜è®¤å€¼ï¼Œå¦‚æžœæœªè®¾ç½®',0),(512483,14236,'sv','AnvÃ¤nder kunden standard om inte ange',0),(512484,14236,'it','Il cliente utilizza di Default se non impostato',0),(512485,14236,'tl','',0),(512486,14236,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸Šà¹‰à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸–à¹‰à¸² à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡',0),(512487,14236,'hi','à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤…à¤—à¤° à¤¨à¤¹à¥€à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(512488,14236,'ms','Kegunaan pelanggan lalai jika tidak Set',0),(512489,14236,'ar','ÙŠØ³ØªØ®Ø¯Ù… Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¥Ø°Ø§ Ù„Ù… ØªØ¹ÙŠÙŠÙ†',0),(512490,14236,'fr','Client utilise par dÃ©faut si elle n\'est pas dÃ©finie',0),(512491,14236,'jp','ä½¿ç”¨é¡§å®¢ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆè¨­å®šã•ã‚Œã¦ã„ãªã„å ´åˆ',0),(512492,14236,'pt','Usos do cliente padrÃ£o se nÃ£o definida',0),(512493,14236,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ, ÐµÑÐ»Ð¸ Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(512494,14236,'es','Usos del cliente por defecto si no se establece',0),(512495,14236,'de','Verwendungen Kunden Standard, wenn nicht festgelegt',0),(512496,14236,'en','Uses Customer Default If Not Set',0),(512497,14237,'is','',0),(512498,14237,'dr','Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒØ´ ÙØ±Ø¶ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ú¯Ø± Ù†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(512499,14237,'pr','Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒØ´ ÙØ±Ø¶ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ú¯Ø± Ù†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(512500,14237,'tr','KullandÄ±ÄŸÄ± varsayÄ±lan kÃ¼me deÄŸilse, stok',0),(512501,14237,'pl','Korzysta domyÅ›lnie z zapasÃ³w, jeÅ›li nie zestaw',0),(512502,14237,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚ ÑÐºÐ»Ð°Ð´Ð°, Ð°ÐºÐ¾ Ð½Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ',0),(512503,14237,'ur','Ø·Û’ Ø´Ø¯Û Ø³Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªØ§ ÛÛ’ Ø³ÛÙˆÙ„ÛŒØ§Øª Ù†ÛÛŒÚº ØªÙˆ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(512504,14237,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¸Ð· Ð·Ð°Ð»Ð¸Ñ…Ð°, Ð°ÐºÐ¾ Ð½Ðµ Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸',0),(512505,14237,'vi','Sá»­ dá»¥ng máº·c Ä‘á»‹nh tá»« hÃ ng tá»“n kho náº¿u khÃ´ng thiáº¿t láº­p',0),(512506,14237,'af','Gebruik verstek uit voorraad indien nie stel',0),(512507,14237,'ro','UtilizeazÄƒ implicit la inventar, dacÄƒ nu setaÅ£i',0),(512508,14237,'et','Vaikimisi saatja kasutab varude, kui ei ole sÃ¤testatud',0),(512509,14237,'si','Uporablja privzeto iz zaloge, Äe ne nastavite',0),(512510,14237,'ba','Menggunakan Default dari persediaan jika tidak diatur',0),(512511,14237,'nl','Maakt gebruik van standaard uit voorraad als niet is ingesteld',0),(512512,14237,'fi','KÃ¤yttÃ¤Ã¤ oletusarvoisen LÃ¤hettÃ¤jÃ¤ varaston, jos sitÃ¤ ei ole asetettu',0),(512513,14237,'no','Bruker standard fra lageret hvis ikke satt',0),(512514,14237,'da','Bruger standard fra lageret, hvis ikke indstillet',0),(512515,14237,'ko','ê¸°ë³¸ê°’ì„ ì‚¬ìš© í•˜ ì—¬ ì„¤ì • ë˜ì§€ ì•Šì€ ê²½ìš° ìž¬ê³ ',0),(512516,14237,'he','×ž×©×ª×ž×© ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×ž×œ××™ ×× ×œ× ×ž×•×’×“×¨',0),(512517,14237,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯ Ï„Î·Î½ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î±Ï€ÏŒ Î±Ï€Î¿Î³ÏÎ±Ï†Î®, Î±Î½ Î´ÎµÎ½ Î¿ÏÎ¯ÏƒÎµÏ„Îµ',0),(512518,14237,'zh','ä½¿ç”¨é»˜è®¤å€¼ä»Žåº“å­˜ï¼Œå¦‚æžœæœªè®¾ç½®',0),(512519,14237,'sv','AnvÃ¤nder standard frÃ¥n inventering om inte ange',0),(512520,14237,'it','Usa predefinito dall\'inventario, se non impostato',0),(512521,14237,'tl','',0),(512522,14237,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ˆà¸²à¸à¹ƒà¸Šà¹‰à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸–à¹‰à¸² à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸•à¸±à¹‰à¸‡',0),(512523,14237,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤°à¥‚à¤ª à¤¸à¥‡ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ à¤¯à¤¦à¤¿ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤¸à¥‚à¤šà¥€',0),(512524,14237,'ms','Menggunakan lalai dari inventori jika tidak Set',0),(512525,14237,'ar','ÙŠØ³ØªØ®Ø¯Ù… Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù…Ù† Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø°ÙŠ Ù„Ù… ÙŠÙƒÙ† ØªØ¹ÙŠÙŠÙ†',0),(512526,14237,'fr','Utilise par dÃ©faut de l\'inventaire si il n\'est pas dÃ©finie',0),(512527,14237,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã‚’ä½¿ç”¨ã—ã¦ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã‚’è¨­å®šã—ãªã„å ´åˆ',0),(512528,14237,'pt','Usa o padrÃ£o de inventÃ¡rio se nÃ£o definida',0),(512529,14237,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ, ÐµÑÐ»Ð¸ Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(512530,14237,'es','Utiliza el valor predeterminado de inventario si no establece',0),(512531,14237,'de','Verwendet Standard-Inventar, wenn nicht festgelegt',0),(512532,14237,'en','Uses Default From Inventory If Not Set',0),(512533,14238,'is','',0),(512534,14238,'dr','Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ú¯Ø± Ù†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(512535,14238,'pr','Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒØ´ ÙØ±Ø¶ Ø§Ú¯Ø± Ù†Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(512536,14238,'tr','KullandÄ±ÄŸÄ± varsayÄ±lan deÄŸilse ayarla',0),(512537,14238,'pl','UÅ¼ywa domyÅ›lnego, jeÅ›li nie zestaw',0),(512538,14238,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ, Ð°ÐºÐ¾ Ð½Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ',0),(512539,14238,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªØ§ ÛÛ’ Ø·Û’ Ø´Ø¯Û Ù†ÛÛŒÚº ØªÙˆ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(512540,14238,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð°ÐºÐ¾ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸',0),(512541,14238,'vi','Sá»­ dá»¥ng máº·c Ä‘á»‹nh náº¿u khÃ´ng thiáº¿t láº­p',0),(512542,14238,'af','Gebruik verstek indien nie stel',0),(512543,14238,'ro','UtilizeazÄƒ implicit dacÄƒ nu setaÅ£i',0),(512544,14238,'et','Kasutab vaikimisi kui mitte seada',0),(512545,14238,'si','Uporablja privzeto, Äe ne nastavite',0),(512546,14238,'ba','Menggunakan Default jika tidak diatur',0),(512547,14238,'nl','Gebruik standaard als niet is ingesteld',0),(512548,14238,'fi','KÃ¤yttÃ¤Ã¤ oletuksena, jos ei ole asetettu',0),(512549,14238,'no','Bruker standard hvis ikke satt',0),(512550,14238,'da','Bruger standard hvis ikke indstillet',0),(512551,14238,'ko','ì‚¬ìš© í•˜ ì—¬ ê¸°ë³¸ ì„¤ì • ë˜ì§€ ì•Šì€ ê²½ìš°',0),(512552,14238,'he','×ž×©×ª×ž×© ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×× ×œ× ×ž×•×’×“×¨',0),(512553,14238,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î±Î½ Î´ÎµÎ½ Î¿ÏÎ¯ÏƒÎµÏ„Îµ',0),(512554,14238,'zh','ä½¿ç”¨é»˜è®¤å€¼ï¼Œå¦‚æžœæœªè®¾ç½®',0),(512555,14238,'sv','AnvÃ¤nder standard om inte ange',0),(512556,14238,'it','Usi di Default se non impostato',0),(512557,14238,'tl','',0),(512558,14238,'th','à¹ƒà¸Šà¹‰à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸–à¹‰à¸² à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡',0),(512559,14238,'hi','à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¤à¤¾ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤…à¤—à¤° à¤¨à¤¹à¥€à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(512560,14238,'ms','Kegunaan lalai jika tidak Set',0),(512561,14238,'ar','ÙŠØ³ØªØ®Ø¯Ù… Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¥Ø°Ø§ Ù„Ù… ØªØ¹ÙŠÙŠÙ†',0),(512562,14238,'fr','Utilise par dÃ©faut si elle n\'est pas dÃ©finie',0),(512563,14238,'jp','ä½¿ç”¨ã—ã¦æ—¢å®šã®è¨­å®šã•ã‚Œã¦ã„ãªã„å ´åˆ',0),(512564,14238,'pt','Usos padrÃ£o se nÃ£o definida',0),(512565,14238,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ, ÐµÑÐ»Ð¸ Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(512566,14238,'es','Utiliza por defecto si no se establece',0),(512567,14238,'de','Verwendet Standard-wenn nicht festgelegt',0),(512568,14238,'en','Uses Default If Not Set',0),(512569,14239,'is','',0),(512570,14239,'dr','ØªÙ†Ø¸ÛŒÙ… ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¢Ù‡Ù†Ú¯ ØªÙˆÙ„Ø¯',0),(512571,14239,'pr','ØªÙ†Ø¸ÛŒÙ… ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¢Ù‡Ù†Ú¯ ØªÙˆÙ„Ø¯',0),(512572,14239,'tr','OsCommerce ayarlarÄ±nÄ± yapma',0),(512573,14239,'pl','Ustawienia osCommerce',0),(512574,14239,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹Ñ‚Ðµ osCommerce Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸',0),(512575,14239,'ur','Ø¹Ø«Ú©ÙˆÙ…Ù…Ø±Ø³ÛŒ Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº Ù…Ø·Ø§Ø¨Ù‚ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(512576,14239,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð¾ÑÐ¦Ð¾Ð¼Ð¼ÐµÑ€Ñ†Ðµ',0),(512577,14239,'vi','Äiá»u chá»‰nh cÃ i Ä‘áº·t osCommerce',0),(512578,14239,'af','Verstel osCommerce instellings',0),(512579,14239,'ro','ReglaÈ›i setÄƒrile de osCommerce',0),(512580,14239,'et','OsCommerce sÃ¤tete kohandamine',0),(512581,14239,'si','Prilagodite nastavitve osCommerce',0),(512582,14239,'ba','Menyesuaikan pengaturan osCommerce',0),(512583,14239,'nl','OsCommerce instellingen aanpassen',0),(512584,14239,'fi','OsCommerce sÃ¤Ã¤tÃ¤minen',0),(512585,14239,'no','Justere innstillingene for osCommerce',0),(512586,14239,'da','Justere indstillingerne for osCommerce',0),(512587,14239,'ko','OsCommerce ì„¤ì •ì„ ì¡°ì •í•©ë‹ˆë‹¤',0),(512588,14239,'he','×œ×›×•×•× ×Ÿ ×”×’×“×¨×•×ª osCommerce',0),(512589,14239,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® ÏÏ…Î¸Î¼Î¯ÏƒÎµÏ‰Î½ osCommerce',0),(512590,14239,'zh','è°ƒæ•´çº¿ä¸Šè´­ç‰©è®¾ç½®',0),(512591,14239,'sv','Justera instÃ¤llningarna fÃ¶r osCommerce',0),(512592,14239,'it','Regolare le impostazioni di osCommerce',0),(512593,14239,'tl','',0),(512594,14239,'th','à¸›à¸£à¸±à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² osCommerce',0),(512595,14239,'hi','OsCommerce à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(512596,14239,'ms','Laras seting osCommerce',0),(512597,14239,'ar','Ø¶Ø¨Ø· Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø¨ÙˆØ±ØµØ© Ù…ØµØ±',0),(512598,14239,'fr','Ajuster les rÃ©glages d\'osCommerce',0),(512599,14239,'jp','OsCommerce ã®è¨­å®šã‚’èª¿æ•´ã—ã¾ã™ã€‚',0),(512600,14239,'pt','Ajustar configuraÃ§Ãµes de osCommerce',0),(512601,14239,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð² Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚-Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð°',0),(512602,14239,'es','Ajustar la configuraciÃ³n de osCommerce',0),(512603,14239,'de','OsCommerce-Einstellungen anpassen',0),(512604,14239,'en','Adjust osCommerce Settings',0),(512605,14240,'is','',0),(512606,14240,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(512607,14240,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(512608,14240,'tr','Ä°thalat sipariÅŸleri beri sipariÅŸ numarasÄ±',0),(512609,14240,'pl','ZamÃ³wieÅ„ przywozowych od numeru zamÃ³wienia',0),(512610,14240,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸Ñ‚Ðµ Ð·Ð° Ð²Ð½Ð¾Ñ Ð¾Ñ‚ Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(512611,14240,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ø³Û’ Ø§Ø¨ ØªÚ© Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(512612,14240,'sr','Ð£Ð²Ð¾Ð· Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ° Ð¾Ð´ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(512613,14240,'vi','ÄÆ¡n Ä‘áº·t hÃ ng nháº­p kháº©u tá»« sá»‘ thá»© tá»±',0),(512614,14240,'af','Voer bestellings sedert orde nommer',0),(512615,14240,'ro','Comenzi de import de la numÄƒrul de ordine',0),(512616,14240,'et','Impordi tellimused alates tellimuse kood',0),(512617,14240,'si','Uvoz naroÄil od zaporedno Å¡tevilko',0),(512618,14240,'ba','Impor perintah sejak nomor pesanan',0),(512619,14240,'nl','Import Orders sinds ordernummer',0),(512620,14240,'fi','Tuo tilaukset vuodesta tilausnumero',0),(512621,14240,'no','Importer bestillinger siden ordrenummer',0),(512622,14240,'da','Import ordrer siden ordrenummer',0),(512623,14240,'ko','ì£¼ë¬¸ ë²ˆí˜¸ë¶€í„° ê°€ì ¸ì˜¤ê¸° ëª…ë ¹',0),(512624,14240,'he','×”×™×™×‘×•× ×”×–×ž× ×•×ª ×ž××– ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(512625,14240,'el','Î•Î½Ï„Î¿Î»Î­Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Î±Ï€ÏŒ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(512626,14240,'zh','å¯¼å…¥è®¢å•ä»¥æ¥è®¢å•ç¼–å·',0),(512627,14240,'sv','BestÃ¤llning sedan ordernummer',0),(512628,14240,'it','Importazione ordini dal numero d\'ordine',0),(512629,14240,'tl','',0),(512630,14240,'th','à¸ªà¸±à¹ˆà¸‡à¸™à¸³à¹€à¸‚à¹‰à¸²à¸•à¸±à¹‰à¸‡à¹à¸•à¹ˆà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(512631,14240,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤†à¤¦à¥‡à¤¶',0),(512632,14240,'ms','Pesanan import sejak nombor pesanan',0),(512633,14240,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù†Ø° Ø¹Ø¯Ø¯ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(512634,14240,'fr','Commandes d\'importation depuis le numÃ©ro de commande',0),(512635,14240,'jp','æ³¨æ–‡ç•ªå·ã‹ã‚‰ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®é †åº',0),(512636,14240,'pt','Ordens de importaÃ§Ã£o, desde que o nÃºmero de ordem',0),(512637,14240,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ñ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ¾Ð²Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(512638,14240,'es','Pedidos de importaciÃ³n desde el nÃºmero de pedido',0),(512639,14240,'de','Import AuftrÃ¤ge seit Bestellnummer',0),(512640,14240,'en','Import Orders Since Order Number',0),(512641,14241,'is','',0),(512642,14241,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø¢Ù‡Ù†Ú¯ ØªÙˆÙ„Ø¯',0),(512643,14241,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø³ÙØ§Ø±Ø´Ø§Øª Ø¢Ù‡Ù†Ú¯ ØªÙˆÙ„Ø¯',0),(512644,14241,'tr','OsCommerce emir alma',0),(512645,14241,'pl','ZamÃ³wieÅ„ przywozowych osCommerce',0),(512646,14241,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° osCommerce Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(512647,14241,'ur','Ø¹Ø«Ú©ÙˆÙ…Ù…Ø±Ø³ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(512648,14241,'sr','Ð£Ð²Ð¾Ð· Ð¾ÑÐ¦Ð¾Ð¼Ð¼ÐµÑ€Ñ†Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(512649,14241,'vi','Nháº­p kháº©u osCommerce Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(512650,14241,'af','Voer osCommerce bestellings',0),(512651,14241,'ro','Importa ordinele de osCommerce',0),(512652,14241,'et','Impordi osCommerce tellimused',0),(512653,14241,'si','Uvoz naroÄil osCommerce',0),(512654,14241,'ba','Impor osCommerce pesanan',0),(512655,14241,'nl','OsCommerce Orders importeren',0),(512656,14241,'fi','Tuo osCommerce tilaukset',0),(512657,14241,'no','Importere osCommerce ordrer',0),(512658,14241,'da','Importere osCommerce ordrer',0),(512659,14241,'ko','ê°€ì ¸ì˜¤ê¸° osCommerce ì£¼ë¬¸',0),(512660,14241,'he','×™×™×‘×•× osCommerce ×”×–×ž× ×•×ª',0),(512661,14241,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ osCommerce',0),(512662,14241,'zh','å¯¼å…¥çº¿ä¸Šè´­ç‰©è®¢å•',0),(512663,14241,'sv','OsCommerce bestÃ¤llning',0),(512664,14241,'it','Importazione ordini di osCommerce',0),(512665,14241,'tl','',0),(512666,14241,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ªà¸±à¹ˆà¸‡ osCommerce',0),(512667,14241,'hi','OsCommerce à¤†à¤¦à¥‡à¤¶ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(512668,14241,'ms','Perintah-perintah osCommerce import',0),(512669,14241,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£ÙˆØ§Ù…Ø± Ø¨ÙˆØ±ØµØ© Ù…ØµØ±',0),(512670,14241,'fr','Import osCommerce arrÃªtÃ©s',0),(512671,14241,'jp','OsCommerce å—æ³¨ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(512672,14241,'pt','ImportaÃ§Ã£o de ordens de osCommerce',0),(512673,14241,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚-Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð°',0),(512674,14241,'es','Pedidos de importaciÃ³n osCommerce',0),(512675,14241,'de','OsCommerce Bestellungen importieren',0),(512676,14241,'en','Import osCommerce Orders',0),(512677,14242,'is','',0),(512678,14242,'dr','Ú©Ù„ÛŒØ¯ API Ù†Ø§',0),(512679,14242,'pr','Ú©Ù„ÛŒØ¯ API Ù†Ø§',0),(512680,14242,'tr','Uyumsuz API anahtarÄ±',0),(512681,14242,'pl','Niedopasowane klucz API',0),(512682,14242,'bg','ÐÐµÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð°Ñ‰Ð¸ API ÐºÐ»ÑŽÑ‡',0),(512683,14242,'ur','Ø³Û’ Ù…ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ú¾Ø§ØªÛŒÚº API Ú©Ù„ÛŒØ¯',0),(512684,14242,'sr','ÐÐµÐ¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð½Ðµ ÐÐŸÐ˜ ÐºÑ™ÑƒÑ‡',0),(512685,14242,'vi','KhÃ³a API khÃ´ng khá»›p',0),(512686,14242,'af','Onpaar API sleutel',0),(512687,14242,'ro','Nepotrivite API-cheie',0),(512688,14242,'et','Sobimatud API vÃµti',0),(512689,14242,'si','Neusklajeno API kljuÄ',0),(512690,14242,'ba','Serasi kunci API',0),(512691,14242,'nl','Niet-overeenkomende API-sleutel',0),(512692,14242,'fi','Virheellinen API-avain',0),(512693,14242,'no','-API-nÃ¸kkel',0),(512694,14242,'da','Uoverensstemmelse mellem API-nÃ¸gle',0),(512695,14242,'ko','ì¼ì¹˜ í•˜ì§€ ì•ŠëŠ” API í‚¤',0),(512696,14242,'he','×ž×¤×ª×— API ×œ× ×ª×•××ž×ª',0),(512697,14242,'el','Î‘Ï„Î±Î¯ÏÎ¹Î±ÏƒÏ„Î· API ÎºÎ»ÎµÎ¹Î´Î¯',0),(512698,14242,'zh','ä¸åŒ¹é…çš„ API å¯†é’¥',0),(512699,14242,'sv','Inkompatibla API-nyckel',0),(512700,14242,'it','Chiave API non corrispondenti',0),(512701,14242,'tl','',0),(512702,14242,'th','API à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸„à¸µà¸¢à¹Œ',0),(512703,14242,'hi','à¤¬à¥‡à¤®à¥‡à¤² API à¤•à¥à¤‚à¤œà¥€',0),(512704,14242,'ms','Tag API kekunci',0),(512705,14242,'ar','Ù…ÙØªØ§Ø­ API ØºÙŠØ± Ù…ØªØ·Ø§Ø¨Ù‚Ø©',0),(512706,14242,'fr','ClÃ© d\'API ne correspondent pas',0),(512707,14242,'jp','API ã‚­ãƒ¼ã®ä¸ä¸€è‡´',0),(512708,14242,'pt','Chave de API incompatÃ­veis',0),(512709,14242,'ru','ÐÐµÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¸Ðµ ÐºÐ»ÑŽÑ‡Ð° API',0),(512710,14242,'es','Clave de API no coincidentes',0),(512711,14242,'de','Nicht Ã¼bereinstimmende API-SchlÃ¼ssel',0),(512712,14242,'en','Mismatched API Key',0),(512713,14243,'is','',0),(512714,14243,'dr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø¬Ø¯ÛŒØ¯ Ù¾ÛŒØ¯Ø§ Ú©Ø±Ø¯Ù…',0),(512715,14243,'pr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø¬Ø¯ÛŒØ¯ Ù¾ÛŒØ¯Ø§ Ú©Ø±Ø¯Ù…',0),(512716,14243,'tr','Yeni emir bulundu',0),(512717,14243,'pl','Nie ma nowych zamÃ³wieÅ„, Znalezione',0),(512718,14243,'bg','ÐÑÐ¼Ð° Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(512719,14243,'ur','Ú©ÙˆØ¦ÛŒ Ù†ÛŒØ§ Ø­Ú©Ù… Ù¾Ø§ÛŒØ§',0),(512720,14243,'sr','ÐÐµÐ¼Ð° Ð½Ð¾Ð²Ð¸Ñ… Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(512721,14243,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n Ä‘áº·t hÃ ng má»›i tÃ¬m tháº¥y',0),(512722,14243,'af','Geen nuwe bestellings gevind',0),(512723,14243,'ro','Noi comenzi gÄƒsit',0),(512724,14243,'et','Ei leidnud uued tellimused',0),(512725,14243,'si','Ni novih naroÄil naÅ¡el',0),(512726,14243,'ba','Pesanan baru tidak ditemukan',0),(512727,14243,'nl','Geen nieuwe Orders gevonden',0),(512728,14243,'fi','Uusia tilauksia ei lÃ¶ytynyt',0),(512729,14243,'no','Ingen nye ordrer funnet',0),(512730,14243,'da','Ingen nye ordrer fundet',0),(512731,14243,'ko','ì•„ë‹ˆ ìƒˆë¡œìš´ ì£¼ë¬¸ì„ ë°œê²¬í•©ë‹ˆë‹¤',0),(512732,14243,'he','××™×Ÿ ×¤×§×•×“×•×ª ×—×“×©×•×ª × ×ž×¦××•',0),(512733,14243,'el','Î”ÎµÎ½ Î½Î­ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(512734,14243,'zh','å‘çŽ°æ²¡æœ‰æ–°è®¢å•',0),(512735,14243,'sv','Inga nya order hittade',0),(512736,14243,'it','Nessun nuovo ordine trovato',0),(512737,14243,'tl','',0),(512738,14243,'th','à¹„à¸¡à¹ˆà¸žà¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹ƒà¸«à¸¡à¹ˆ',0),(512739,14243,'hi','à¤•à¥‹à¤ˆ à¤¨à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶ à¤ªà¤¾à¤¯à¤¾',0),(512740,14243,'ms','Tidak ada perintah baru yang ditemui',0),(512741,14243,'ar','Ù„Ø§ Ø£ÙˆØ§Ù…Ø± Ø¬Ø¯ÙŠØ¯Ø© ÙˆØ¬Ø¯Øª',0),(512742,14243,'fr','Aucune nouvelle commande trouvÃ©',0),(512743,14243,'jp','æ–°ã—ã„æ³¨æ–‡ã¯ã‚ã‚Šã¾ã›ã‚“ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(512744,14243,'pt','NÃ£o hÃ¡ novas ordens encontradas',0),(512745,14243,'ru','ÐÐ¸ÐºÐ°ÐºÐ¸Ñ… Ð½Ð¾Ð²Ñ‹Ñ… Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð¾Ð² Ð½Ð°ÑˆÐ»Ð¸',0),(512746,14243,'es','No hay nuevas Ã³rdenes encontrados',0),(512747,14243,'de','Keine neuen AuftrÃ¤ge gefunden',0),(512748,14243,'en','No New Orders Found',0),(512749,14244,'is','',0),(512750,14244,'dr','Ø¢Ù‡Ù†Ú¯ ØªÙˆÙ„Ø¯ Ø³ÙØ§Ø±Ø´',0),(512751,14244,'pr','Ø¢Ù‡Ù†Ú¯ ØªÙˆÙ„Ø¯ Ø³ÙØ§Ø±Ø´',0),(512752,14244,'tr','osCommerce sipariÅŸ',0),(512753,14244,'pl','osCommerce zamÃ³wienia',0),(512754,14244,'bg','osCommerce Ñ€ÐµÐ´',0),(512755,14244,'ur','Ø¹Ø«Ú©ÙˆÙ…Ù…Ø±Ø³ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(512756,14244,'sr','Ð¾ÑÐ¦Ð¾Ð¼Ð¼ÐµÑ€Ñ†Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(512757,14244,'vi','osCommerce Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(512758,14244,'af','osCommerce orde',0),(512759,14244,'ro','osCommerce ordine',0),(512760,14244,'et','osCommerce jÃ¤rjekorras',0),(512761,14244,'si','osCommerce nalog',0),(512762,14244,'ba','osCommerce Order',0),(512763,14244,'nl','osCommerce volgorde',0),(512764,14244,'fi','osCommerce jÃ¤rjestyksessÃ¤',0),(512765,14244,'no','osCommerce rekkefÃ¸lge',0),(512766,14244,'da','osCommerce rÃ¦kkefÃ¸lge',0),(512767,14244,'ko','osCommerce ìˆœì„œ',0),(512768,14244,'he','osCommerce ×¡×“×¨',0),(512769,14244,'el','osCommerce Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(512770,14244,'zh','çº¿ä¸Šè´­ç‰©è®¢å•',0),(512771,14244,'sv','osCommerce ordning',0),(512772,14244,'it','Ordine di osCommerce',0),(512773,14244,'tl','',0),(512774,14244,'th','osCommerce à¸ªà¸±à¹ˆà¸‡',0),(512775,14244,'hi','osCommerce à¤•à¥à¤°à¤®',0),(512776,14244,'ms','osCommerce perintah',0),(512777,14244,'ar','Ø¨ÙˆØ±ØµØ© Ù…ØµØ± Ø£Ù…Ø±',0),(512778,14244,'fr','osCommerce ordre',0),(512779,14244,'jp','osCommerce ã®é †åº',0),(512780,14244,'pt','osCommerce ordem',0),(512781,14244,'ru','Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚-Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð° Ð·Ð°ÐºÐ°Ð·',0),(512782,14244,'es','osCommerce orden',0),(512783,14244,'de','OsCommerce bestellen',0),(512784,14244,'en','osCommerce Order',0),(512785,14245,'is','',0),(512786,14245,'dr','Ù„Ø·ÙØ§ osCom Ø¢Ø¯Ø±Ø³ ÙˆØ§Ø±Ø¯Ø§Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ù†Ù…Ø§ÛŒÛŒØ¯',0),(512787,14245,'pr','Ù„Ø·ÙØ§ osCom Ø¢Ø¯Ø±Ø³ ÙˆØ§Ø±Ø¯Ø§Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ù†Ù…Ø§ÛŒÛŒØ¯',0),(512788,14245,'tr','LÃ¼tfen osCom ithalat URL girin',0),(512789,14245,'pl','Podaj osCom Import URL',0),(512790,14245,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ osCom Ð²Ð½Ð¾Ñ URL',0),(512791,14245,'ur','Ø¹Ø«Ú©Ø§ÙˆÙ… Ø¯Ø±Ø¢Ù…Ø¯ URL Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(512792,14245,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¾ÑÐ¦Ð¾Ð¼ Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ° ÑƒÐ²Ð¾Ð·Ð°',0),(512793,14245,'vi','Vui lÃ²ng nháº­p osCom nháº­p kháº©u URL',0),(512794,14245,'af','Tik asseblief die osCom invoer URL',0),(512795,14245,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i osCom Import URL',0),(512796,14245,'et','Palun sisestage osCom impordi URL',0),(512797,14245,'si','VpiÅ¡ite osCom uvoza URL',0),(512798,14245,'ba','Masukkan osCom impor URL',0),(512799,14245,'nl','Voer de osCom Import URL',0),(512800,14245,'fi','Anna osCom URLIT',0),(512801,14245,'no','Angi osCom Import URL',0),(512802,14245,'da','Angiv osCom Import URL',0),(512803,14245,'ko','OsCom ê°€ì ¸ì˜¤ê¸° URLì„ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(512804,14245,'he','×”×–×™× ×• ×‘×‘×§×©×” ××ª osCom ×™×™×‘×•× ×›×ª×•×‘×ª URL',0),(512805,14245,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ osCom URL ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(512806,14245,'zh','è¯·è¾“å…¥ osCom å¯¼å…¥ URL',0),(512807,14245,'sv','VÃ¤nligen ange osCom Import URL',0),(512808,14245,'it','Per favore inserisci il osCom Import URL',0),(512809,14245,'tl','',0),(512810,14245,'th','à¸à¸£à¸¸à¸“à¸²à¸›à¹‰à¸­à¸™ osCom à¸™à¸³ URL',0),(512811,14245,'hi','OsCom à¤†à¤¯à¤¾à¤¤ URL à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(512812,14245,'ms','Sila masukkan osCom Import URL',0),(512813,14245,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø£ÙˆØ³ÙˆÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯ URL',0),(512814,14245,'fr','S\'il vous plaÃ®t entrez l\'osCom importation URL',0),(512815,14245,'jp','OsCom ã‚¤ãƒ³ãƒãƒ¼ãƒˆ URL ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(512816,14245,'pt','Por favor, digite a URL de importaÃ§Ã£o osCom',0),(512817,14245,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ osCom Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° URL',0),(512818,14245,'es','Introduzca la direcciÃ³n URL de importaciÃ³n osCom',0),(512819,14245,'de','Bitte geben Sie die OsCom Import URL',0),(512820,14245,'en','Please Enter The osCom Import URL',0),(512821,14246,'is','',0),(512822,14246,'dr','Ø´Ù…Ø§ Ø¢Ø¯Ø±Ø³ Ø¯Ø±Ø³Øª ÙˆØ§Ø±Ø¯ Ø§Ø¶Ø§Ù',0),(512823,14246,'pr','Ø´Ù…Ø§ Ø¢Ø¯Ø±Ø³ Ø¯Ø±Ø³Øª ÙˆØ§Ø±Ø¯ Ø§Ø¶Ø§Ù',0),(512824,14246,'tr','Girilen URL\'nin doÄŸru sahip DoÄŸrulama',0),(512825,14246,'pl','SprawdÅº, czy masz wpisany poprawny adres URL',0),(512826,14246,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¸Ð¼Ð°Ñ‚Ðµ Ð¿Ñ€Ð°Ð²Ð¸Ð»ÐµÐ½ URL Ð²Ð»ÐµÐ·Ðµ',0),(512827,14246,'ur','ØªÙˆØ«ÛŒÙ‚ Ú©Ø±ÛŒÚº Ø¢Ù¾ ØµØ­ÛŒØ­ URL Ø¯Ø§Ø®Ù„ ÛÛ’',0),(512828,14246,'sr','ÐŸÑ€Ð¾Ð²Ñ˜ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð° Ð¸Ð¼Ð°Ñ‚Ðµ Ð¸ÑÐ¿Ñ€Ð°Ð²Ð°Ð½ Ð£Ð Ð› ÑƒÑˆÐ°Ð¾',0),(512829,14246,'vi','Kiá»ƒm tra xem báº¡n cÃ³ URL chÃ­nh xÃ¡c nháº­p',0),(512830,14246,'af','Verifieer dat jy die korrekte URL ingetik het',0),(512831,14246,'ro','VerificaÅ£i dacÄƒ aveÅ£i adresa URL corectÄƒ a intrat',0),(512832,14246,'et','Veenduge, et olete sisestanud Ãµige URL',0),(512833,14246,'si','Preverite, ali imate pravilen URL vnesli',0),(512834,14246,'ba','Pastikan Anda memiliki URL yang benar masuk',0),(512835,14246,'nl','Controleer of dat u beschikt over de juiste URL ingevoerd',0),(512836,14246,'fi','Varmista, sinulla on tullut oikea URL-osoite',0),(512837,14246,'no','Kontroller du har riktig URL-adresse angitt',0),(512838,14246,'da','Kontroller du har den korrekte webadresse indtastet',0),(512839,14246,'ko','ì˜¬ë°”ë¥¸ URLì„ ìž…ë ¥ í•œ í™•ì¸',0),(512840,14246,'he','×•×“× ×©×™×© ×œ×š ×œ×ª×§×Ÿ ××ª ×›×ª×•×‘×ª ×”××ª×¨ × ×›× ×¡',0),(512841,14246,'el','Î’ÎµÎ²Î±Î¹Ï‰Î¸ÎµÎ¯Ï„Îµ ÏŒÏ„Î¹ Î­Ï‡ÎµÏ„Îµ Ï„Î· ÏƒÏ‰ÏƒÏ„Î® Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· URL Ï€Î¿Ï… Ï„Î­Î¸Î·ÎºÎµ',0),(512842,14246,'zh','è¯·éªŒè¯æ‚¨å·²è¾“å…¥æ­£ç¡®çš„ URL',0),(512843,14246,'sv','Kontrollera att du har angett rÃ¤tt URL',0),(512844,14246,'it','Verificare il corretto URL immesso',0),(512845,14246,'tl','',0),(512846,14246,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸§à¹ˆà¸² à¸„à¸¸à¸“à¸¡à¸µà¸›à¹‰à¸­à¸™ URL à¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(512847,14246,'hi','à¤†à¤ª à¤¸à¤¹à¥€ URL à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(512848,14246,'ms','Tentu anda mempunyai URL betul masukkan',0),(512849,14246,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø£Ù† Ù„Ø¯ÙŠÙƒ Ø¹Ù†ÙˆØ§Ù† URL Ø§Ù„ØµØ­ÙŠØ­ Ø¯Ø®Ù„Øª',0),(512850,14246,'fr','VÃ©rifiez que vous avez l\'URL correcte est entrÃ©',0),(512851,14246,'jp','ã‚ãªãŸãŒå…¥åŠ›ã—ãŸ URL ãŒæ­£ã—ã„ã“ã¨ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(512852,14246,'pt','Verifique se que vocÃª tem a URL correta entrou',0),(512853,14246,'ru','Ð£Ð±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾ Ñƒ Ð²Ð°Ñ Ð¿Ñ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ð¾ Ð²Ð²ÐµÐ´ÐµÐ½Ð½Ñ‹Ð¹ URL-Ð°Ð´Ñ€ÐµÑ',0),(512854,14246,'es','Verificar que tienes la URL correcta entrÃ³ en',0),(512855,14246,'de','ÃœberprÃ¼fen Sie, ob Sie die richtige URL eingegeben haben',0),(512856,14246,'en','Verify You Have The Correct URL Entered',0),(512857,14247,'is','',0),(512858,14247,'dr','A &amp; Ù…Ù† Ù…Ø­ØµÙˆÙ„Ø§Øª Ø¯Ø± Ø¯Ø³Øª',0),(512859,14247,'pr','A &amp; Ù…Ù† Ù…Ø­ØµÙˆÙ„Ø§Øª Ø¯Ø± Ø¯Ø³Øª',0),(512860,14247,'tr','A & Ben el Ã¼rÃ¼nleri',0),(512861,14247,'pl','A & I produkty na rÄ™kÄ™',0),(512862,14247,'bg','Ð & I Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(512863,14247,'ur','A & Ù…ÛŒÚº ÛØ§ØªÚ¾ Ù¾Ø± Ù…ØµÙ†ÙˆØ¹Ø§Øª',0),(512864,14247,'sr','Ð Ð¸ Ñ˜Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð° Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(512865,14247,'vi','A &amp; tÃ´i sáº£n pháº©m trÃªn tay',0),(512866,14247,'af','\'N & ek produkte op Hand',0),(512867,14247,'ro','A & am produse pe mÃ¢nÄƒ',0),(512868,14247,'et','A & I tooted laos',0),(512869,14247,'si','A & sem izdelkov na strani',0),(512870,14247,'ba','A & saya produk di tangan',0),(512871,14247,'nl','A & I producten aan de kant',0),(512872,14247,'fi','A & olen tuotteet kÃ¤sillÃ¤',0),(512873,14247,'no','A & jeg produkter pÃ¥ hÃ¥nden',0),(512874,14247,'da','A & jeg produkter pÃ¥ hÃ¥nd',0),(512875,14247,'ko','A & ë‚˜ ì†ìœ¼ë¡œ ì œí’ˆ',0),(512876,14247,'he','A & ×× ×™ ×ž×•×¦×¨×™× ×¢×œ ×”×™×“',0),(512877,14247,'el','A & ÎµÎ³ÏŽ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î± Î±Ï†',0),(512878,14247,'zh','A &amp; æˆ‘æ‰‹ä¸Šçš„äº§å“',0),(512879,14247,'sv','A & jag produkter pÃ¥ Hand',0),(512880,14247,'it','A & I prodotti sulla mano',0),(512881,14247,'tl','',0),(512882,14247,'th','A & à¸œà¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸„à¸‡à¹€à¸«à¸¥à¸·à¸­',0),(512883,14247,'hi','A & à¤®à¥ˆà¤‚ à¤¹à¤¾à¤¥ à¤ªà¤° à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¥‹à¤‚',0),(512884,14247,'ms','A & saya produk di tangan',0),(512885,14247,'ar','A Ø¢Ù†Ø¯ Ø£Ù†Ø§ Ø§Ù„Ù…Ù†ØªØ¬Ø§Øª ÙÙŠ Ù…ØªÙ†Ø§ÙˆÙ„ Ø§Ù„ÙŠØ¯',0),(512886,14247,'fr','A & j\'ai produits part',0),(512887,14247,'jp','A & ç§ã¯æ‰‹ã®è£½å“',0),(512888,14247,'pt','A & eu produtos na mÃ£o',0),(512889,14247,'ru','A & Ñ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð² Ð½Ð° Ñ€ÑƒÐºÐµ',0),(512890,14247,'es','A &amp; le productos en mano',0),(512891,14247,'de','A & I Produkte auf Seite',0),(512892,14247,'en','A&I Products On Hand',0),(512893,14248,'is','',0),(512894,14248,'dr','Ø¯Ø±ÛŒØ§ÙØª ÛŒÚ© &amp; Ù…Ù† Ø¯Ø± Ø¯Ø³Øª',0),(512895,14248,'pr','Ø¯Ø±ÛŒØ§ÙØª ÛŒÚ© &amp; Ù…Ù† Ø¯Ø± Ø¯Ø³Øª',0),(512896,14248,'tr','Get A & Ben elde',0),(512897,14248,'pl','Get A & I na rÄ™kÄ™',0),(512898,14248,'bg','Get A & Ð°Ð· Ð½Ð° Ñ€ÑŠÐºÐ°',0),(512899,14248,'ur','Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº A & Ù…ÛŒÚº ÛØ§ØªÚ¾ Ù¾Ø±',0),(512900,14248,'sr','Ð£Ð·Ð¼Ð¸ Ð & ÑÐ°Ð¼ Ð½Ð° Ñ€ÑƒÑ†Ð¸',0),(512901,14248,'vi','Get A &amp; tÃ´i máº·t',0),(512902,14248,'af','Kry \'n & ek op Hand',0),(512903,14248,'ro','Ia un & am pe mana',0),(512904,14248,'et','Get A & ma kÃ¤si',0),(512905,14248,'si','Get A & I na roko',0),(512906,14248,'ba','Get A & saya di tangan',0),(512907,14248,'nl','Get A & ik aan de kant',0),(512908,14248,'fi','Get A & olen kÃ¤si',0),(512909,14248,'no','FÃ¥ A & I pÃ¥ hÃ¥nden',0),(512910,14248,'da','Get A & jeg pÃ¥ hÃ¥nd',0),(512911,14248,'ko','Get A & ì†ì— ë‚˜',0),(512912,14248,'he','Get A & ×œ×™ ×¢×œ ×”×™×“',0),(512913,14248,'el','Get A & ÎµÎ³ÏŽ Î±Ï†',0),(512914,14248,'zh','å¾—åˆ° A &amp; æˆ‘æ‰‹ä¸Š',0),(512915,14248,'sv','FÃ¥ en & jag Ã¥',0),(512916,14248,'it','Get A & I sulla mano',0),(512917,14248,'tl','',0),(512918,14248,'th','à¸£à¸±à¸š A & à¸‰à¸±à¸™à¸„à¸‡',0),(512919,14248,'hi','à¤œà¤¾à¤“ à¤à¤• & à¤®à¥ˆà¤‚ à¤¹à¤¾à¤¥ à¤ªà¤°',0),(512920,14248,'ms','Dapatkan & I pada tangan',0),(512921,14248,'ar','Ø§Ø­ØµÙ„ Ø¹Ù„Ù‰ Ø£Ù„Ù Ø¢Ù†Ø¯ Ø£Ù†Ø§ ÙÙŠ Ø§Ù„ÙŠØ¯',0),(512922,14248,'fr','Get A & je part',0),(512923,14248,'jp','å–å¾— & ä¸€æ–¹ã§ç§ã¯',0),(512924,14248,'pt','Get A & eu na mÃ£o',0),(512925,14248,'ru','Get A & Ñ Ð½Ð° Ñ€ÑƒÐºÐµ',0),(512926,14248,'es','Llegar A &amp; en mano',0),(512927,14248,'de','Get A & ich auf der Seite',0),(512928,14248,'en','Get A&I On Hand',0),(512929,14249,'is','',0),(512930,14249,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(512931,14249,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(512932,14249,'tr','KullanÄ±labilir deÄŸeri',0),(512933,14249,'pl','DostÄ™pne wartoÅ›ci',0),(512934,14249,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(512935,14249,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ Ù‚Ø¯Ø±',0),(512936,14249,'sr','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(512937,14249,'vi','CÃ³ giÃ¡ trá»‹',0),(512938,14249,'af','Beskikbare waarde',0),(512939,14249,'ro','Valoare disponibile',0),(512940,14249,'et','Saadaval vÃ¤Ã¤rtus',0),(512941,14249,'si','Na voljo vrednost',0),(512942,14249,'ba','Nilai yang tersedia',0),(512943,14249,'nl','Beschikbare waarde',0),(512944,14249,'fi','Arvo',0),(512945,14249,'no','Tilgjengelige verdi',0),(512946,14249,'da','TilgÃ¦ngelige vÃ¦rdi',0),(512947,14249,'ko','ì‚¬ìš© ê°€ëŠ¥í•œ ê°’',0),(512948,14249,'he','×¢×¨×š ×–×ž×™× ×™×',0),(512949,14249,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î¿ Ï„Î¹Î¼Î®',0),(512950,14249,'zh','å¯ç”¨å€¼',0),(512951,14249,'sv','TillgÃ¤ngliga vÃ¤rdet',0),(512952,14249,'it','Valore disponibile',0),(512953,14249,'tl','',0),(512954,14249,'th','à¸„à¹ˆà¸²à¸§à¹ˆà¸²à¸‡',0),(512955,14249,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤®à¤¾à¤¨',0),(512956,14249,'ms','Didapati nilai',0),(512957,14249,'ar','Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(512958,14249,'fr','Valeur disponible',0),(512959,14249,'jp','ä½¿ç”¨å¯èƒ½ãªå€¤',0),(512960,14249,'pt','Valor disponÃ­vel',0),(512961,14249,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(512962,14249,'es','Valor disponible',0),(512963,14249,'de','VerfÃ¼gbaren Wert',0),(512964,14249,'en','Available Value',0),(512965,14250,'is','',0),(512966,14250,'dr','Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù‡Ø²ÛŒÙ†Ù‡',0),(512967,14250,'pr','Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù‡Ø²ÛŒÙ†Ù‡',0),(512968,14250,'tr','Madde maliyeti',0),(512969,14250,'pl','Element kosztÃ³w',0),(512970,14250,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(512971,14250,'ur','Ø´Û’ Ú©ÛŒ Ù‚ÛŒÙ…Øª',0),(512972,14250,'sr','Ð¢Ñ€Ð¾ÑˆÐ°Ðº Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(512973,14250,'vi','Má»¥c chi phÃ­',0),(512974,14250,'af','Item koste',0),(512975,14250,'ro','Element de Cost',0),(512976,14250,'et','Kauba kulu',0),(512977,14250,'si','StroÅ¡ek artikla',0),(512978,14250,'ba','Item biaya',0),(512979,14250,'nl','Kostprijs',0),(512980,14250,'fi','Nimikekustannus',0),(512981,14250,'no','Varekostnader',0),(512982,14250,'da','Kostpris)',0),(512983,14250,'ko','í•­ëª© ë¹„ìš©',0),(512984,14250,'he','×ž×—×™×¨ ×œ×™×—×™×“×”',0),(512985,14250,'el','ÎšÏŒÏƒÏ„Î¿Ï…Ï‚ ÎµÎ¯Î´Î¿Ï…Ï‚',0),(512986,14250,'zh','ç‰©æ–™æˆæœ¬',0),(512987,14250,'sv','Artikelkostnad',0),(512988,14250,'it','Costo articolo',0),(512989,14250,'tl','',0),(512990,14250,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(512991,14250,'hi','à¤†à¤‡à¤Ÿà¤® à¤²à¤¾à¤—à¤¤',0),(512992,14250,'ms','Perkara kos',0),(512993,14250,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„ØµÙ†Ù',0),(512994,14250,'fr','CoÃ»t de l\'article',0),(512995,14250,'jp','é …ç›®ã®ã‚³ã‚¹ãƒˆ',0),(512996,14250,'pt','Item de custo',0),(512997,14250,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ‚Ð¾Ð²Ð°Ñ€Ð°',0),(512998,14250,'es','Costo del artÃ­culo',0),(512999,14250,'de','Artikelkosten',0),(513000,14250,'en','Item Cost',0),(513001,14251,'is','',0),(513002,14251,'dr','Ø¨Ø§ÛŒØ¯ Ù…Ø­Ù„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(513003,14251,'pr','Ø¨Ø§ÛŒØ¯ Ù…Ø­Ù„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(513004,14251,'tr','Konumu seÃ§melisiniz',0),(513005,14251,'pl','NaleÅ¼y wybraÄ‡ lokalizacjÄ™',0),(513006,14251,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(513007,14251,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(513008,14251,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(513009,14251,'vi','Pháº£i chá»n vá»‹ trÃ­',0),(513010,14251,'af','Moet kies ligging',0),(513011,14251,'ro','Trebuie sÄƒ selectaÅ£i locaÅ£ia',0),(513012,14251,'et','Peate valima asukoha',0),(513013,14251,'si','Morate izbrati mesto',0),(513014,14251,'ba','Pilih lokasi',0),(513015,14251,'nl','Locatie moet selecteren',0),(513016,14251,'fi','Valitse sijainti',0),(513017,14251,'no','MÃ¥ velge plassering',0),(513018,14251,'da','Skal vÃ¦lge placering',0),(513019,14251,'ko','ìœ„ì¹˜ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(513020,14251,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×ž×™×§×•×',0),(513021,14251,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(513022,14251,'zh','å¿…é¡»é€‰æ‹©ä½ç½®',0),(513023,14251,'sv','MÃ¥ste vÃ¤lja lÃ¤ge',0),(513024,14251,'it','Necessario selezionare la posizione',0),(513025,14251,'tl','',0),(513026,14251,'th','à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸•à¸±à¹‰à¸‡',0),(513027,14251,'hi','à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(513028,14251,'ms','Mesti pilih lokasi',0),(513029,14251,'ar','ÙŠØ¬Ø¨ ØªØ­Ø¯ÙŠØ¯ Ù…ÙˆÙ‚Ø¹',0),(513030,14251,'fr','Devez sÃ©lectionner emplacement',0),(513031,14251,'jp','å ´æ‰€ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(513032,14251,'pt','Deve selecionar localizaÃ§Ã£o',0),(513033,14251,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(513034,14251,'es','Debe seleccionar ubicaciÃ³n',0),(513035,14251,'de','Location muss ausgewÃ¤hlt werden.',0),(513036,14251,'en','Must Select Location',0),(513037,14252,'is','',0),(513038,14252,'dr','Ø¯Ø± Ø¯Ø³Øª Ø§Ø±Ø²Ø´',0),(513039,14252,'pr','Ø¯Ø± Ø¯Ø³Øª Ø§Ø±Ø²Ø´',0),(513040,14252,'tr','El deÄŸeri',0),(513041,14252,'pl','Na wartoÅ›Ä‡ rÄ™cznie',0),(513042,14252,'bg','ÐÐ° Ñ€ÑŠÐºÐ° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(513043,14252,'ur','ÛØ§ØªÚ¾ Ú©ÛŒ Ù‚Ø¯Ø±',0),(513044,14252,'sr','ÐÐ° Ñ€ÑƒÑ†Ð¸ Ð²Ñ€Ð¸Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚',0),(513045,14252,'vi','TrÃªn tay giÃ¡ trá»‹',0),(513046,14252,'af','Op Hand-waarde',0),(513047,14252,'ro','Valoarea de mÃ¢nÄƒ',0),(513048,14252,'et','Linna esmane vÃ¤Ã¤rtus',0),(513049,14252,'si','Na roko vrednost',0),(513050,14252,'ba','Pada nilai tangan',0),(513051,14252,'nl','Op handwaarde',0),(513052,14252,'fi','Korttien arvo',0),(513053,14252,'no','PÃ¥ verdien pÃ¥',0),(513054,14252,'da','PÃ¥ hÃ¥nd vÃ¦rdi',0),(513055,14252,'ko','ì† ê°€ì¹˜ì—',0),(513056,14252,'he','×¢×œ ×™×“ ×¢×¨×š',0),(513057,14252,'el','Î¤Î·Î½ Î±Î¾Î¯Î± Ï„Î¿Ï… Ï‡ÎµÏÎ¹Î¿Ï',0),(513058,14252,'zh','æ‰‹çš„ä»·å€¼',0),(513059,14252,'sv','PÃ¥ Hand vÃ¤rdet',0),(513060,14252,'it','Il valore della mano',0),(513061,14252,'tl','',0),(513062,14252,'th','à¸„à¹ˆà¸²à¸¡à¸·à¸­',0),(513063,14252,'hi','à¤ªà¤° à¤¹à¤¾à¤¥ à¤®à¤¾à¤¨',0),(513064,14252,'ms','Nilai tangan',0),(513065,14252,'ar','Ø¹Ù„Ù‰ Ù‚ÙŠÙ…Ø© Ø§Ù„ÙŠØ¯',0),(513066,14252,'fr','Sur la valeur de la main',0),(513067,14252,'jp','æ‰‹ã®å€¤',0),(513068,14252,'pt','No valor da mÃ£o',0),(513069,14252,'ru','ÐÐ° Ñ€ÑƒÐºÐµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(513070,14252,'es','El valor de la mano',0),(513071,14252,'de','Am Wert des Anfangsblattes',0),(513072,14252,'en','On Hand Value',0),(513073,14253,'is','',0),(513074,14253,'dr','ØªÙØ§ÙˆØª Ø¯Ø± Ù‡Ø²ÛŒÙ†Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡',0),(513075,14253,'pr','ØªÙØ§ÙˆØª Ø¯Ø± Ù‡Ø²ÛŒÙ†Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡',0),(513076,14253,'tr','Hesaplanan maliyet farkÄ±',0),(513077,14253,'pl','RÃ³Å¼nica w kosztach obliczany',0),(513078,14253,'bg','Ð Ð°Ð·Ð»Ð¸ÐºÐ° Ð² Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(513079,14253,'ur','Ù…Ø­Ø³ÙˆØ¨ Ù‚ÛŒÙ…Øª Ù…ÛŒÚº ÙØ±Ù‚',0),(513080,14253,'sr','Ð Ð°Ð·Ð»Ð¸ÐºÐ° Ñƒ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚Ð¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº',0),(513081,14253,'vi','Sá»± khÃ¡c biá»‡t trong tÃ­nh toÃ¡n chi phÃ­',0),(513082,14253,'af','Verskil In berekende koste',0),(513083,14253,'ro','DiferenÈ›a de Cost calculate',0),(513084,14253,'et','Erinevust arvestusliku maksumuse',0),(513085,14253,'si','Razlika v izraÄunan stroÅ¡ek',0),(513086,14253,'ba','Perbedaan dalam biaya dihitung',0),(513087,14253,'nl','Verschil In berekende kosten',0),(513088,14253,'fi','Laskettujen kustannusten ero',0),(513089,14253,'no','Forskjellen i beregnet kostnad',0),(513090,14253,'da','Forskellen i beregnede omkostninger',0),(513091,14253,'ko','ê³„ì‚° ëœ ë¹„ìš©ì˜ ì°¨ì´',0),(513092,14253,'he','×”×‘×“×œ×™ ×¢×œ×•×ª ×ž×—×•×©×‘×ª',0),(513093,14253,'el','Î”Î¹Î±Ï†Î¿ÏÎ¬ ÏƒÏ„Î¿ Ï…Ï€Î¿Î»Î¿Î³Î¹Î¶ÏŒÎ¼ÎµÎ½Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(513094,14253,'zh','åœ¨è®¡ç®—å‡ºçš„æˆæœ¬å·®å¼‚',0),(513095,14253,'sv','Skillnaden i berÃ¤knad kostnad',0),(513096,14253,'it','Differenza di costo calcolato',0),(513097,14253,'tl','',0),(513098,14253,'th','à¸„à¸§à¸²à¸¡à¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¹ƒà¸™à¸•à¹‰à¸™à¸—à¸¸à¸™à¸—à¸µà¹ˆà¸„à¸³à¸™à¸§à¸“à¹„à¸”à¹‰',0),(513099,14253,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¿à¤¤ à¤²à¤¾à¤—à¤¤ à¤®à¥‡à¤‚ à¤…à¤‚à¤¤à¤°',0),(513100,14253,'ms','Perbezaan dalam kos dikira',0),(513101,14253,'ar','Ø§Ù„ÙØ±Ù‚ ÙÙŠ Ø§Ù„ØªÙƒÙ„ÙØ© Ø§Ù„Ù…Ø­Ø³ÙˆØ¨Ø©',0),(513102,14253,'fr','DiffÃ©rence de coÃ»t calculÃ©',0),(513103,14253,'jp','è¨ˆç®—ã‚³ã‚¹ãƒˆã®å·®',0),(513104,14253,'pt','DiferenÃ§a de custo calculado',0),(513105,14253,'ru','Ð Ð°Ð·Ð½Ð¸Ñ†Ð° Ð² ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(513106,14253,'es','Diferencia en costo calculado',0),(513107,14253,'de','Unterschied In der berechneten Kosten',0),(513108,14253,'en','Difference In Calculated Cost',0),(513109,14254,'is','',0),(513110,14254,'dr','A &amp; Ù…Ù† Ø³Ø·Ø­',0),(513111,14254,'pr','A &amp; Ù…Ù† Ø³Ø·Ø­',0),(513112,14254,'tr','A & Ben seviye',0),(513113,14254,'pl','A & I poziom',0),(513114,14254,'bg','Ð & I Ð½Ð¸Ð²Ð¾',0),(513115,14254,'ur','A & Ù…ÛŒÚº Ø¯Ø±Ø¬Û',0),(513116,14254,'sr','Ð Ð¸ ÑÐ°Ð¼ Ð½Ð¸Ð²Ð¾',0),(513117,14254,'vi','A &amp; tÃ´i cáº¥p',0),(513118,14254,'af','\'N & ek vlak',0),(513119,14254,'ro','A & am nivel',0),(513120,14254,'et','A & I tase',0),(513121,14254,'si','A & sem ravni',0),(513122,14254,'ba','A & saya tingkat',0),(513123,14254,'nl','A & ik niveau',0),(513124,14254,'fi','A & I taso',0),(513125,14254,'no','A & jeg nivÃ¥',0),(513126,14254,'da','A & jeg niveau',0),(513127,14254,'ko','A & ë ˆë²¨ ë‚œ',0),(513128,14254,'he','A & ×× ×™ ×¨×ž×”',0),(513129,14254,'el','A & ÎµÎ³ÏŽ ÎµÏ€Î¯Ï€ÎµÎ´Î¿',0),(513130,14254,'zh','A &amp; æˆ‘æ°´å¹³',0),(513131,14254,'sv','A & jag nivÃ¥',0),(513132,14254,'it','A & sono di livello',0),(513133,14254,'tl','',0),(513134,14254,'th','A & à¸œà¸¡à¸£à¸°à¸”à¸±à¸š',0),(513135,14254,'hi','A & à¤®à¥ˆà¤‚ à¤¸à¥à¤¤à¤°',0),(513136,14254,'ms','A & saya aras',0),(513137,14254,'ar','A Ø¢Ù†Ø¯ Ø£Ù†Ø§ Ù…Ù† Ø§Ù„Ù…Ø³ØªÙˆÙ‰',0),(513138,14254,'fr','A & j\'ai niveau',0),(513139,14254,'jp','A & ç§ãƒ¬ãƒ™ãƒ«',0),(513140,14254,'pt','A & que o nÃ­vel',0),(513141,14254,'ru','A & Ñ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ',0),(513142,14254,'es','A &amp; que nivel',0),(513143,14254,'de','A & ich Stufe',0),(513144,14254,'en','A&I Level',0),(513145,14255,'is','',0),(513146,14255,'dr','Ù‡ÛŒÚ† Ù…Ø­ØµÙˆÙ„ÛŒ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(513147,14255,'pr','Ù‡ÛŒÚ† Ù…Ø­ØµÙˆÙ„ÛŒ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(513148,14255,'tr','Herhangi bir Ã¼rÃ¼n satÄ±cÄ± iÃ§in bulundu',0),(513149,14255,'pl','Å»aden produkt dla dostawcy',0),(513150,14255,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(513151,14255,'ur','Ú©ÙˆØ¦ÛŒ Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©Û’ Ù„Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± Ù¾Ø§ÛŒØ§',0),(513152,14255,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð° Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(513153,14255,'vi','KhÃ´ng cÃ³ sáº£n pháº©m tÃ¬m tháº¥y cho nhÃ  cung cáº¥p',0),(513154,14255,'af','Geen produk vir handelaar gevind',0),(513155,14255,'ro','Nici un produs pentru furnizor',0),(513156,14255,'et','Hankija ei leitud toodet',0),(513157,14255,'si','Noben izdelek za dobavitelja',0),(513158,14255,'ba','Tidak ada produk yang ditemukan untuk Vendor',0),(513159,14255,'nl','Geen Product gevonden voor leverancier',0),(513160,14255,'fi','Tuote lÃ¶ytyy toimittajan',0),(513161,14255,'no','Ingen produkter funnet For leverandÃ¸r',0),(513162,14255,'da','Ingen produkter fundet For kreditor',0),(513163,14255,'ko','ì œí’ˆ ê³µê¸‰ ì—…ì²´ì— ëŒ€ í•œ ë°œê²¬',0),(513164,14255,'he','××™×Ÿ ×ž×•×¦×¨ ×©× ×ž×¦××• ×¢×‘×•×¨ ×¡×¤×§×™×',0),(513165,14255,'el','Î¤Î¿ Ï€ÏÎ¿ÏŠÏŒÎ½ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ Î³Î¹Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(513166,14255,'zh','æ²¡æœ‰æ‰¾ä¸åˆ°ä¾›åº”å•†çš„äº§å“',0),(513167,14255,'sv','Ingen produkt som hittade fÃ¶r leverantÃ¶r',0),(513168,14255,'it','Nessun prodotto trovato per fornitore',0),(513169,14255,'tl','',0),(513170,14255,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸à¸²à¸£à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œ',0),(513171,14255,'hi','à¤•à¥‹à¤ˆ à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(513172,14255,'ms','Tiada produk yang ditemui untuk penjual.',0),(513173,14255,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…Ù†ØªØ¬ ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(513174,14255,'fr','Aucun produit trouvÃ© pour fournisseur',0),(513175,14255,'jp','ã„ã„ãˆè£½å“ã®ãƒ™ãƒ³ãƒ€ãƒ¼ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(513176,14255,'pt','Nenhum produto encontrado para fornecedor',0),(513177,14255,'ru','ÐÐ¸ Ð¾Ð´Ð¸Ð½ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚, Ð½Ð°Ð¹Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(513178,14255,'es','NingÃºn producto para proveedores',0),(513179,14255,'de','Kein Produkt gefunden fÃ¼r Anbieter',0),(513180,14255,'en','No Product Found For Vendor',0),(513181,14256,'is','',0),(513182,14256,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù„ØºÙˆ Ø¨Ø±Ø±Ø³ÛŒ Ùˆ Ú©ÙˆÙ¾Ù†',0),(513183,14256,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù„ØºÙˆ Ø¨Ø±Ø±Ø³ÛŒ Ùˆ Ú©ÙˆÙ¾Ù†',0),(513184,14256,'tr','Zaten iptal onay fiÅŸi',0),(513185,14256,'pl','Wyboru kupon juÅ¼ anulowane',0),(513186,14256,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð²ÐµÑ‡Ðµ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½',0),(513187,14256,'ur','Ú†ÛŒÚ© ÙˆØ§Ø¤Ú†Ø± Ù¾ÛÙ„Û’ ÛÛŒ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(513188,14256,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð²ÐµÑ› Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð¾.',0),(513189,14256,'vi','PhÃ²ng phiáº¿u Ä‘Ã£ há»§y bá»',0),(513190,14256,'af','Kontroleer bewys reeds gekanselleer',0),(513191,14256,'ro','Voucher verifica deja anulat',0),(513192,14256,'et','Sisse kanne juba tÃ¼histatud',0),(513193,14256,'si','Pregled bon Å¾e preklican',0),(513194,14256,'ba','Check Voucher sudah dibatalkan',0),(513195,14256,'nl','Selectievakje Voucher al geannuleerd',0),(513196,14256,'fi','Uloskirjautuminen tositteen jo peruutettu',0),(513197,14256,'no','Sjekk bilaget allerede avlyst',0),(513198,14256,'da','Check Voucher allerede annulleret',0),(513199,14256,'ko','ì´ë¯¸ ì·¨ì†Œ í™•ì¸ ë°”ìš°ì²˜',0),(513200,14256,'he','×”×¡×™×ž×•×Ÿ ×”×©×•×‘×¨ ×›×‘×¨ ×‘×•×˜×œ',0),(513201,14256,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î®Î´Î· Î±ÎºÏ…ÏÏ‰Î¸ÎµÎ¯',0),(513202,14256,'zh','æ£€æŸ¥å‡­è¯å·²å–æ¶ˆ',0),(513203,14256,'sv','Kontrollera verifikationen redan avbrutits',0),(513204,14256,'it','Controllo Voucher giÃ  annullato',0),(513205,14256,'tl','',0),(513206,14256,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸—à¸µà¹ˆà¸¢à¸à¹€à¸¥à¸´à¸à¹à¸¥à¹‰à¸§',0),(513207,14256,'hi','à¤ªà¤¹à¤²à¥‡ à¤¹à¥€ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤šà¥‡à¤• à¤µà¤¾à¤‰à¤šà¤°',0),(513208,14256,'ms','Daftar baucer yang telah dibatalkan',0),(513209,14256,'ar','Ù‚Ø³ÙŠÙ…Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø¥Ù„ØºØ§Ø¡ Ø§Ù„ÙØ¹Ù„',0),(513210,14256,'fr','Coupon dÃ©jÃ  annulÃ©',0),(513211,14256,'jp','æ—¢ã«ã‚­ãƒ£ãƒ³ã‚»ãƒ« ãƒã‚§ãƒƒã‚¯ä¼ç¥¨',0),(513212,14256,'pt','SeleÃ§Ã£o Voucher jÃ¡ cancelado',0),(513213,14256,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð²Ð°ÑƒÑ‡ÐµÑ€ ÑƒÐ¶Ðµ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½',0),(513214,14256,'es','Voucher cheque cancelado ya',0),(513215,14256,'de','Check Gutschein bereits abgebrochen',0),(513216,14256,'en','Check Voucher Already Canceled',0),(513217,14257,'is','',0),(513218,14257,'dr','Ù†ÙˆØ¹ Ú©Ø§Ø± Ø³Ø±ÙˆÛŒØ³ Ù¾ÛŒØ´ ÙØ±Ø¶',0),(513219,14257,'pr','Ù†ÙˆØ¹ Ú©Ø§Ø± Ø³Ø±ÙˆÛŒØ³ Ù¾ÛŒØ´ ÙØ±Ø¶',0),(513220,14257,'tr','VarsayÄ±lan hizmet iÅŸ tÃ¼rÃ¼',0),(513221,14257,'pl','DomyÅ›lnie usÅ‚uga pracy typu',0),(513222,14257,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÑƒÑÐ»ÑƒÐ³Ð°Ñ‚Ð° Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(513223,14257,'ur','Ø·Û’ Ø´Ø¯Û Ø®Ø¯Ù…Øª Ú©Ø§Ù… Ù‚Ø³Ù…',0),(513224,14257,'sr','Ð’Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ ÑƒÑÐ»ÑƒÐ³Ðµ',0),(513225,14257,'vi','Loáº¡i cÃ´ng viá»‡c dá»‹ch vá»¥ máº·c Ä‘á»‹nh',0),(513226,14257,'af','Verstek diens werk tipe',0),(513227,14257,'ro','Tipul de lucru implicit serviciu',0),(513228,14257,'et','Vaikimisi teenuse tÃ¶Ã¶ tÃ¼Ã¼p',0),(513229,14257,'si','Delo vrsta privzete storitve',0),(513230,14257,'ba','Default layanan jenis pekerjaan',0),(513231,14257,'nl','Standaardtype Service werk',0),(513232,14257,'fi','Palvelu tyÃ¶tÃ¤ oletustyyppi',0),(513233,14257,'no','Standard tjenestetype arbeid',0),(513234,14257,'da','Standard Service arbejdstype',0),(513235,14257,'ko','ê¸°ë³¸ ì„œë¹„ìŠ¤ ìž‘ì—… í˜•ì‹',0),(513236,14257,'he','×¡×•×’ ×”×¢×‘×•×“×” ×©×™×¨×•×ª ×”×ž×•×’×“×¨ ×›×‘×¨×™×¨×ª ×ž×—×“×œ',0),(513237,14257,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï‚ Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï…Ï€Î·ÏÎµÏƒÎ¯Î±',0),(513238,14257,'zh','é»˜è®¤æœåŠ¡å·¥ä½œç±»åž‹',0),(513239,14257,'sv','Typ av standardtjÃ¤nst arbete',0),(513240,14257,'it','Tipo di lavoro di servizio predefinito',0),(513241,14257,'tl','',0),(513242,14257,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸šà¸£à¸´à¸à¸²à¸£à¸‡à¸²à¸™à¸Šà¸™à¸´à¸”',0),(513243,14257,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥‡à¤µà¤¾ à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤°',0),(513244,14257,'ms','Jenis kerja Perkhidmatan lalai',0),(513245,14257,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø®Ø¯Ù…Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(513246,14257,'fr','Type de travail pour le Service par dÃ©faut',0),(513247,14257,'jp','ã‚µãƒ¼ãƒ“ã‚¹ä½œæ¥­ã®æ—¢å®šã®ç¨®é¡ž',0),(513248,14257,'pt','Tipo de trabalho de serviÃ§o padrÃ£o',0),(513249,14257,'ru','Ð¢Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ ÑÐ»ÑƒÐ¶Ð±Ñ‹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(513250,14257,'es','Tipo de trabajo de servicio predeterminado',0),(513251,14257,'de','Standarddiensttyp Arbeit',0),(513252,14257,'en','Default Service Work Type',0),(513253,14258,'is','',0),(513254,14258,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(513255,14258,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(513256,14258,'tr','Fatura alma',0),(513257,14258,'pl','Importu faktur',0),(513258,14258,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð²Ð½Ð¾Ñ',0),(513259,14258,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(513260,14258,'sr','Ð£Ð²Ð¾Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(513261,14258,'vi','Nháº­p hÃ³a Ä‘Æ¡n',0),(513262,14258,'af','Fakture invoer',0),(513263,14258,'ro','Facturi de import',0),(513264,14258,'et','Arvete import',0),(513265,14258,'si','Uvoznih faktur',0),(513266,14258,'ba','Impor faktur',0),(513267,14258,'nl','Importeren van facturen',0),(513268,14258,'fi','Tuonnin laskuja',0),(513269,14258,'no','Fakturaer med import',0),(513270,14258,'da','Importere fakturaer',0),(513271,14258,'ko','ì¸ë³´ì´ìŠ¤ ê°€ì ¸ì˜¤ê¸°',0),(513272,14258,'he','×™×™×‘×•× ×—×©×‘×•× ×™×•×ª',0),(513273,14258,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³ÏŽÎ½',0),(513274,14258,'zh','å¯¼å…¥å‘ç¥¨',0),(513275,14258,'sv','Importera fakturor',0),(513276,14258,'it','Importazione fatture',0),(513277,14258,'tl','',0),(513278,14258,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(513279,14258,'hi','à¤†à¤¯à¤¾à¤¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(513280,14258,'ms','Import invois',0),(513281,14258,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(513282,14258,'fr','Importation de factures',0),(513283,14258,'jp','è«‹æ±‚æ›¸ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(513284,14258,'pt','Importar faturas',0),(513285,14258,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(513286,14258,'es','Facturas de importaciÃ³n',0),(513287,14258,'de','Importieren von Rechnungen',0),(513288,14258,'en','Import Invoices',0),(513289,14259,'is','',0),(513290,14259,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø§Ø² ÙØ§ÛŒÙ„ CSV',0),(513291,14259,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø§Ø² ÙØ§ÛŒÙ„ CSV',0),(513292,14259,'tr','Faturalar CSV dosyasÄ±ndan iÃ§e aktarma',0),(513293,14259,'pl','Importu faktur z pliku CSV',0),(513294,14259,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¾Ñ‚ CSV Ñ„Ð°Ð¹Ð»',0),(513295,14259,'ur','ÙˆØ¨Ø¬Ù„ÛŒ CSV Ù…Ø³Ù„ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(513296,14259,'sr','Ð£Ð²Ð¾Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸Ð· Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(513297,14259,'vi','HoÃ¡ Ä‘Æ¡n chuyá»ƒn nháº­p tá»« tá»‡p CSV',0),(513298,14259,'af','Fakture vanaf CSV-lÃªer invoer',0),(513299,14259,'ro','Facturi de import din fiÅŸier CSV',0),(513300,14259,'et','Arvete importimine CSV-faili',0),(513301,14259,'si','Uvoznih faktur iz datoteke CSV',0),(513302,14259,'ba','Faktur impor dari CSV File',0),(513303,14259,'nl','Facturen importeren uit CSV-bestand',0),(513304,14259,'fi','Laskujen tuominen CSV-tiedostosta',0),(513305,14259,'no','Fakturaer med import fra CSV-fil',0),(513306,14259,'da','Importere fakturaer fra CSV-fil',0),(513307,14259,'ko','ì†¡ìž¥ CSV íŒŒì¼ì—ì„œ ê°€ì ¸ì˜¤ê¸°',0),(513308,14259,'he','×—×©×‘×•× ×™×•×ª ×™×™×‘×•× ×ž×§×•×‘×¥ CSV',0),(513309,14259,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³ÏŽÎ½ Î±Ï€ÏŒ Î±ÏÏ‡ÎµÎ¯Î¿ CSV',0),(513310,14259,'zh','ä»Ž CSV æ–‡ä»¶å¯¼å…¥å‘ç¥¨',0),(513311,14259,'sv','Importera fakturor frÃ¥n CSV-filen',0),(513312,14259,'it','Fatture di importazione da File CSV',0),(513313,14259,'tl','',0),(513314,14259,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸²à¸à¹„à¸Ÿà¸¥à¹Œ CSV',0),(513315,14259,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¥‡ CSV à¤«à¤¼à¤¾à¤‡à¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(513316,14259,'ms','Mengimport invois dari fail CSV',0),(513317,14259,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù† Ù…Ù„Ù CSV',0),(513318,14259,'fr','Factures d\'importation de fichier CSV',0),(513319,14259,'jp','è«‹æ±‚æ›¸ CSV ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(513320,14259,'pt','Faturas de importaÃ§Ã£o de arquivo CSV',0),(513321,14259,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¸Ð· CSV-Ñ„Ð°Ð¹Ð»Ð° ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(513322,14259,'es','Facturas de importaciÃ³n de un archivo CSV',0),(513323,14259,'de','Rechnungen aus CSV-Datei importieren',0),(513324,14259,'en','Import Invoices From CSV File',0),(513325,14260,'is','',0),(513326,14260,'dr','ÙˆØ§Ø±Ø¯Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø³Ú©Ù†Ø§Ø³',0),(513327,14260,'pr','ÙˆØ§Ø±Ø¯Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø³Ú©Ù†Ø§Ø³',0),(513328,14260,'tr','SatÄ±cÄ± faturalarÄ± almak',0),(513329,14260,'pl','PrzywÃ³z dostawcy rachunki',0),(513330,14260,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(513331,14260,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(513332,14260,'sr','Ð£Ð²Ð¾Ð· Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(513333,14260,'vi','Nháº­p kháº©u nhÃ  cung cáº¥p hÃ³a Ä‘Æ¡n',0),(513334,14260,'af','Voer handelaar rekeninge',0),(513335,14260,'ro','Furnizor facturi de import',0),(513336,14260,'et','Hankija arvete import',0),(513337,14260,'si','RaÄune dobavitelja za uvoz',0),(513338,14260,'ba','Impor Vendor tagihan',0),(513339,14260,'nl','Importeren van facturen van de leverancier',0),(513340,14260,'fi','Tuo toimittajan laskut',0),(513341,14260,'no','Importere leverandÃ¸r regninger',0),(513342,14260,'da','Importere kreditor regninger',0),(513343,14260,'ko','ê°€ì ¸ì˜¤ê¸° ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ',0),(513344,14260,'he','×œ×™×™×‘× ×—×©×‘×•× ×•×ª ×¡×¤×§×™×',0),(513345,14260,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(513346,14260,'zh','å¯¼å…¥ä¾›åº”å•†è´¦å•',0),(513347,14260,'sv','Importera leverantÃ¶rs rÃ¤kningar',0),(513348,14260,'it','Importare le fatture fornitore',0),(513349,14260,'tl','',0),(513350,14260,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸•à¸±à¹‹à¸§',0),(513351,14260,'hi','à¤†à¤¯à¤¾à¤¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤²',0),(513352,14260,'ms','Import bil-bil Vendor',0),(513353,14260,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙˆØ±Ø¯',0),(513354,14260,'fr','Facture des importations du vendeur',0),(513355,14260,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(513356,14260,'pt','Importar contas de fornecedor',0),(513357,14260,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(513358,14260,'es','ImportaciÃ³n de facturas de proveedor',0),(513359,14260,'de','Import-Lieferanten-Rechnungen',0),(513360,14260,'en','Import Vendor Bills',0),(513361,14261,'is','',0),(513362,14261,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø² ÙØ§ÛŒÙ„ CSV',0),(513363,14261,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø² ÙØ§ÛŒÙ„ CSV',0),(513364,14261,'tr','SatÄ±cÄ± faturalarÄ± CSV dosyasÄ±ndan iÃ§e aktarma',0),(513365,14261,'pl','Rachunki dostawcy importu z pliku CSV',0),(513366,14261,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¾Ñ‚ CSV Ñ„Ð°Ð¹Ð»',0),(513367,14261,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ CSV Ù…Ø³Ù„ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(513368,14261,'sr','Ð£Ð²Ð¾Ð· Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸Ð· Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(513369,14261,'vi','Nháº­p nhÃ  cung cáº¥p hÃ³a Ä‘Æ¡n tá»« tá»‡p CSV',0),(513370,14261,'af','Handelaar rekeninge vanaf CSV-lÃªer invoer',0),(513371,14261,'ro','Furnizor facturi de import din fiÅŸier CSV',0),(513372,14261,'et','Hankija arveid importida CSV-faili',0),(513373,14261,'si','RaÄune dobavitelja za uvoz iz datoteke CSV',0),(513374,14261,'ba','Tagihan Vendor impor dari CSV File',0),(513375,14261,'nl','Leverancier facturen importeren uit CSV-bestand',0),(513376,14261,'fi','Toimittajan laskut tuominen CSV-tiedostosta',0),(513377,14261,'no','Importere leverandÃ¸r regninger fra CSV-fil',0),(513378,14261,'da','Importere kreditor regninger fra CSV-fil',0),(513379,14261,'ko','CSV íŒŒì¼ì—ì„œ ê°€ì ¸ì˜¤ê¸° ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ',0),(513380,14261,'he','×œ×™×™×‘× ×—×©×‘×•× ×•×ª ×¡×¤×§ ×ž×§×•×‘×¥ CSV',0),(513381,14261,'el','Î¤Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ ÎµÎ¹ÏƒÎ±Î³ÏŒÎ¼ÎµÎ½Î·Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î±Ï€ÏŒ Î±ÏÏ‡ÎµÎ¯Î¿ CSV',0),(513382,14261,'zh','ä»Ž CSV æ–‡ä»¶å¯¼å…¥ä¾›åº”å•†è´¦å•',0),(513383,14261,'sv','Importera leverantÃ¶rs rÃ¤kningar frÃ¥n CSV-filen',0),(513384,14261,'it','Fatture fornitore di importazione da File CSV',0),(513385,14261,'tl','',0),(513386,14261,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸²à¸à¹„à¸Ÿà¸¥à¹Œ CSV',0),(513387,14261,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² CSV à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(513388,14261,'ms','Mengimport bil Vendor dari fail CSV',0),(513389,14261,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙˆØ±Ø¯ Ù…Ù† Ù…Ù„Ù CSV',0),(513390,14261,'fr','Factures fournisseur Import de fichier CSV',0),(513391,14261,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸ CSV ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(513392,14261,'pt','Contas de fornecedores de importaÃ§Ã£o de arquivo CSV',0),(513393,14261,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð° Ð¸Ð· CSV-Ñ„Ð°Ð¹Ð»Ð°',0),(513394,14261,'es','Importar facturas de proveedores desde un archivo CSV',0),(513395,14261,'de','Lieferanten-Rechnungen aus CSV-Datei importieren',0),(513396,14261,'en','Import Vendor Bills From CSV File',0),(513397,14262,'is','',0),(513398,14262,'dr','Ø´Ø±ÙˆØ¹ Ø¨Ù‡ ØªØ§ÛŒÙ¾ Ú©Ø±Ø¯Ù† Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(513399,14262,'pr','Ø´Ø±ÙˆØ¹ Ø¨Ù‡ ØªØ§ÛŒÙ¾ Ú©Ø±Ø¯Ù† Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(513400,14262,'tr','SeÃ§mek iÃ§in yazmaya baÅŸlayÄ±n',0),(513401,14262,'pl','Rozpocznij wpisywanie, aby wybraÄ‡',0),(513402,14262,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð´Ð° Ð¿Ð¸ÑˆÐµÑ‚Ðµ Ð·Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ',0),(513403,14262,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù¹Ø§Ø¦Ù¾ Ú©Ø§Ø±ÛŒ Ø´Ø±ÙˆØ¹',0),(513404,14262,'sr','ÐŸÐ¾Ñ‡Ð½Ð¸Ñ‚Ðµ Ð´Ð° ÐºÑƒÑ†Ð°Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸',0),(513405,14262,'vi','Báº¯t Ä‘áº§u nháº­p Ä‘á»ƒ chá»n',0),(513406,14262,'af','Begin tik om te kies',0),(513407,14262,'ro','ÃŽncepeÅ£i sÄƒ tastaÅ£i pentru a selecta',0),(513408,14262,'et','Alustage tippimist valige',0),(513409,14262,'si','ZaÄnite vnaÅ¡ati besedilo, izberite',0),(513410,14262,'ba','Mulai mengetik untuk Pilih',0),(513411,14262,'nl','Begin met typen om te selecteren',0),(513412,14262,'fi','Kirjoita Valitse',0),(513413,14262,'no','Begynn Ã¥ skrive for Ã¥ velge',0),(513414,14262,'da','Begynd at skrive for at vÃ¦lge',0),(513415,14262,'ko','ì„ íƒ ìž…ë ¥',0),(513416,14262,'he','×”×ª×—×œ ×œ×”×§×œ×™×“ ×›×“×™ ×œ×‘×—×•×¨',0),(513417,14262,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Î½Î± Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³ÎµÎ¯Ï„Îµ ÎºÎ±Î¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ',0),(513418,14262,'zh','å¼€å§‹é”®å…¥è¦é€‰æ‹©',0),(513419,14262,'sv','BÃ¶rja skriva fÃ¶r att vÃ¤lja',0),(513420,14262,'it','Iniziare a digitare per selezionare',0),(513421,14262,'tl','',0),(513422,14262,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸«à¹‰à¹€à¸¥à¸·à¸­à¸',0),(513423,14262,'hi','à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¿à¤–à¤¨à¤¾ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤•à¤°à¥‡à¤‚',0),(513424,14262,'ms','Mula menaip untuk memilih',0),(513425,14262,'ar','Ø§Ø¨Ø¯Ø£ Ø§Ù„ÙƒØªØ§Ø¨Ø© Ù„ØªØ­Ø¯ÙŠØ¯',0),(513426,14262,'fr','Commencez Ã  taper pour sÃ©lectionner',0),(513427,14262,'jp','å…¥åŠ›é¸æŠžã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(513428,14262,'pt','Comece a digitar para selecionar',0),(513429,14262,'ru','ÐÐ°Ñ‡Ð½Ð¸Ñ‚Ðµ Ð²Ð²Ð¾Ð´ Ð´Ð»Ñ Ð²Ñ‹Ð±Ð¾Ñ€Ð°',0),(513430,14262,'es','Comienza a escribir para seleccionar',0),(513431,14262,'de','Tippen Sie zum AuswÃ¤hlen',0),(513432,14262,'en','Start typing to select',0),(513433,14263,'is','',0),(513434,14263,'dr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ ØµÙ†Ø¯ÙˆÙ‚ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(513435,14263,'pr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ ØµÙ†Ø¯ÙˆÙ‚ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(513436,14263,'tr','Bir PO numarasÄ± girin',0),(513437,14263,'pl','ProszÄ™ wpisaÄ‡ numer zamÃ³wienia',0),(513438,14263,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° PO',0),(513439,14263,'ur','Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(513440,14263,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ ÐŸÐž',0),(513441,14263,'vi','Vui lÃ²ng nháº­p má»™t sá»‘ PO',0),(513442,14263,'af','Tik asseblief \'n PO nommer',0),(513443,14263,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un numÄƒr PO',0),(513444,14263,'et','Palun sisestage PO',0),(513445,14263,'si','Vnesite Å¡tevilko PO',0),(513446,14263,'ba','Masukkan nomor PO',0),(513447,14263,'nl','Voer een PO-nummer',0),(513448,14263,'fi','Anna Ostotilauksen numero',0),(513449,14263,'no','Angi et PO-nummer',0),(513450,14263,'da','Angiv et PO-nummer',0),(513451,14263,'ko','ì£¼ë¬¸ì„œ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(513452,14263,'he','×”×–×™× ×• ××ª ×ž×¡×¤×¨ ×”×–×ž× ×ª ×”×¨×›×™×©×”',0),(513453,14263,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± PO Number',0),(513454,14263,'zh','è¯·è¾“å…¥é‡‡è´­è®¢å•ç¼–å·',0),(513455,14263,'sv','Ange ett inkÃ¶psordernummer',0),(513456,14263,'it','Per favore inserisci un numero di PO',0),(513457,14263,'tl','',0),(513458,14263,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ PO',0),(513459,14263,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• PO à¤¨à¤‚à¤¬à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(513460,14263,'ms','Sila masukkan nombor PO',0),(513461,14263,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø¨Ùˆ',0),(513462,14263,'fr','Veuillez entrer un numÃ©ro d\'ordre d\'achat',0),(513463,14263,'jp','PO ç•ªå·ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(513464,14263,'pt','Introduza um nÃºmero de PO',0),(513465,14263,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(513466,14263,'es','Por favor ingrese un nÃºmero de PO',0),(513467,14263,'de','Bitte geben Sie eine Bestellnummer',0),(513468,14263,'en','Please Enter A PO Number',0),(513469,14264,'is','',0),(513470,14264,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ ØªØ­Ù‚Ù‚ Ù†Ø¸Ù… Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø³Ø§ÛŒØª B2B',0),(513471,14264,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ ØªØ­Ù‚Ù‚ Ù†Ø¸Ù… Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø³Ø§ÛŒØª B2B',0),(513472,14264,'tr','VarsayÄ±lan yerine getirilmesi sipariÅŸ Ã¶deme yÃ¶ntemini B2B sitesi',0),(513473,14264,'pl','DomyÅ›lne realizacji zamÃ³wienia pÅ‚atnoÅ›ci na stronie B2B',0),(513474,14264,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð°Ñ‡Ð¸Ð½ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° B2B ÑÐ°Ð¹Ñ‚',0),(513475,14264,'ur','Ø·Û’ Ø´Ø¯Û Ø·Ù…Ø§Ù†ÛŒØª Ùˆ Ø³Ø±Ø´Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± B2B ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ù¾Ø±',0),(513476,14264,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð°Ñ‡Ð¸Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð‘2Ð‘',0),(513477,14264,'vi','PhÆ°Æ¡ng thá»©c thanh toÃ¡n máº·c Ä‘á»‹nh thá»±c hiá»‡n Ä‘Æ¡n Ä‘áº·t hÃ ng trÃªn trang web B2B',0),(513478,14264,'af','Verstek vervulling orde betalingsmetode op B2B werf',0),(513479,14264,'ro','Implicit Ã®ndeplinirea comenzii metoda de plata pe site-ul B2B',0),(513480,14264,'et','Vaikimisi plaanitud tellimuse makseviisi B2B kohapeal',0),(513481,14264,'si','Privzeto izpolnitev nalog naÄin plaÄila na B2B strani',0),(513482,14264,'ba','Default pemenuhan Order pembayaran situs B2B',0),(513483,14264,'nl','Standaardmethode vervulling volgorde betaling op B2B Site',0),(513484,14264,'fi','TÃ¤yttÃ¤mistÃ¤ jÃ¤rjestyksessÃ¤ oletusmaksutapa B2B pÃ¤Ã¤llÃ¤',0),(513485,14264,'no','Standard oppfyllelse for betalingsmÃ¥te pÃ¥ B2B nettsted',0),(513486,14264,'da','Standard opfyldelse ordre betalingsmetode pÃ¥ B2B Site',0),(513487,14264,'ko','B2B ì‚¬ì´íŠ¸ì— ê¸°ë³¸ í–‰ ìˆœì„œ ì§€ë¶ˆ ë°©ë²•',0),(513488,14264,'he','×©×™×˜×ª ×”×ª×©×œ×•× ×©×œ ×¡×“×¨ ×”×’×©×ž×” ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×‘××ª×¨ B2B',0),(513489,14264,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î¼Î­Î¸Î¿Î´Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ ÎµÏ€Î¹Ï„ÏŒÏ€Î¿Ï… B2B',0),(513490,14264,'zh','é»˜è®¤å®žçŽ°è®¢å•ä»˜æ¬¾æ–¹å¼ä¸Š B2B ç½‘ç«™',0),(513491,14264,'sv','Uppfyllelse ordning standardbetalningsmetod pÃ¥ B2B webbplats',0),(513492,14264,'it','Metodo di pagamento predefinito evasione ordine sul sito B2B',0),(513493,14264,'tl','',0),(513494,14264,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸šà¸™à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ B2B',0),(513495,14264,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤†à¤¦à¥‡à¤¶ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤§à¤¿ B2B à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤°',0),(513496,14264,'ms','Lalai memenuhi perintah pembayaran kaedah lokasi B2B',0),(513497,14264,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹ Ø£Ù…Ø± ÙˆÙØ§Ø¡ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ø¹Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ B2B',0),(513498,14264,'fr','Mode de paiement par dÃ©faut Fulfillment ordonnance sur le Site B2B',0),(513499,14264,'jp','B2B ã‚µã‚¤ãƒˆä¸Šã®ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆå±¥è¡Œæ³¨æ–‡ãŠæ”¯æ‰•ã„æ–¹æ³•',0),(513500,14264,'pt','MÃ©todo de pagamento de ordem de cumprimento de padrÃ£o B2B site',0),(513501,14264,'ru','ÐœÐµÑ‚Ð¾Ð´ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð° Ð½Ð° ÑÐ°Ð¹Ñ‚Ðµ B2B',0),(513502,14264,'es','MÃ©todo de pago por defecto cumplimiento orden en sitio B2B',0),(513503,14264,'de','Standardmethode ErfÃ¼llung Bestellung Zahlung auf B2B-Website',0),(513504,14264,'en','Default Fulfillment Order Payment Method On B2B Site',0),(513505,14265,'is','',0),(513506,14265,'dr','Ù†ÛŒØ§Ø² Ø¨Ù‡ ØªØ¹Ø¯Ø§Ø¯ ØµÙ†Ø¯ÙˆÙ‚ Ø¬Ù‡Øª ÙˆØ±ÙˆØ¯ Ø¯Ø± Ø³Ø§ÛŒØª B2B',0),(513507,14265,'pr','Ù†ÛŒØ§Ø² Ø¨Ù‡ ØªØ¹Ø¯Ø§Ø¯ ØµÙ†Ø¯ÙˆÙ‚ Ø¬Ù‡Øª ÙˆØ±ÙˆØ¯ Ø¯Ø± Ø³Ø§ÛŒØª B2B',0),(513508,14265,'tr','B2B sitesi Ã¼zerinde sipariÅŸ iÃ§in PO numarasÄ± girmelerini',0),(513509,14265,'pl','Wymaga szeregu PO kolejnoÅ›ci wpisu na stronie B2B',0),(513510,14265,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð²Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° B2B ÑÐ°Ð¹Ñ‚',0),(513511,14265,'ur','B2B Ø³Ø§Ø¦Ù¹ Ù¾Ø± Ø¢Ø±ÚˆØ± Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(513512,14265,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð±Ñ€Ð¾Ñ˜ ÐŸÐž Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ñƒ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð‘2Ð‘',0),(513513,14265,'vi','YÃªu cáº§u má»™t sá»‘ PO cho Ä‘Æ¡n Ä‘áº·t hÃ ng nháº­p cáº£nh vÃ o B2B trang web',0),(513514,14265,'af','\'N PO-nommer vereis vir orde inskrywing op B2B werf',0),(513515,14265,'ro','NecesitÄƒ un numÄƒr PO pentru ordinea de intrare pe site-ul B2B',0),(513516,14265,'et','NÃµuab mitmete PO tellimuse sisestamiseks B2B kohapeal',0),(513517,14265,'si','Zahtevajo Å¡tevilka NaroÄilnice za naroÄila na B2B strani',0),(513518,14265,'ba','Memerlukan nomor PO untuk masuk pesanan situs B2B',0),(513519,14265,'nl','Vereisen een inkoopordernummer voor orderinvoer op B2B Site',0),(513520,14265,'fi','Vaatia Ostosopimusnumeron tilaustenkÃ¤sittelyyn B2B pÃ¤Ã¤llÃ¤',0),(513521,14265,'no','Krev et innkjÃ¸psordrenummer For bestilling pÃ¥ B2B nettsted',0),(513522,14265,'da','KrÃ¦ve et PO-nummer For ordreindtastning pÃ¥ B2B Site',0),(513523,14265,'ko','B2B ì‚¬ì´íŠ¸ì— ì£¼ë¬¸ í•­ëª©ì— ëŒ€ í•œ í¬ ìˆ˜ë¥¼ í•„ìš”ë¡œ',0),(513524,14265,'he','×“×¨×•×© ×ž×¡×¤×¨ ×ž×©×œ×•×— ×¢×‘×•×¨ Order Entry ×‘××ª×¨ B2B',0),(513525,14265,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½ Î­Î½Î± PO Number Î³Î¹Î± Ï„Î·Î½ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏƒÏ„Î¿ Ï‡ÏŽÏÎ¿ Ï„Î¿Ï… B2B',0),(513526,14265,'zh','åœ¨ B2B ç½‘ç«™ä¸Šçš„è®¢å•æ¡ç›®éœ€è¦é‡‡è´­è®¢å•ç¼–å·',0),(513527,14265,'sv','KrÃ¤v ett inkÃ¶psordernummer fÃ¶r orderlÃ¤ggning pÃ¥ B2B webbplats',0),(513528,14265,'it','Richiedono un numero di ordine per iscrizione di ordine sul sito di B2B',0),(513529,14265,'tl','',0),(513530,14265,'th','à¸•à¹‰à¸­à¸‡à¹ƒà¸Šà¹‰à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ PO à¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹ƒà¸™à¹„à¸‹à¸•à¹Œ B2B',0),(513531,14265,'hi','B2B à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤° à¤•à¥à¤°à¤® à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• PO à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥‹à¤¤à¥€ à¤¹à¥ˆ',0),(513532,14265,'ms','Memerlukan beberapa PO untuk kemasukan pesanan lokasi B2B',0),(513533,14265,'ar','ØªØªØ·Ù„Ø¨ Ø¹Ø¯Ø¯ Ø¨Ùˆ Ù„Ø¥Ø¯Ø®Ø§Ù„ Ø£Ù…Ø± Ø¹Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ B2B',0),(513534,14265,'fr','Besoin d\'un numÃ©ro d\'ordre d\'achat pour la saisie de la commande sur le Site B2B',0),(513535,14265,'jp','B2B ã‚µã‚¤ãƒˆã®æ³¨æ–‡ã‚¨ãƒ³ãƒˆãƒªã® PO ç•ªå·ãŒå¿…è¦ã§ã™ã€‚',0),(513536,14265,'pt','Exigem um nÃºmero de PO para entrada de pedidos B2B site',0),(513537,14265,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ PO Ð½Ð¾Ð¼ÐµÑ€ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð° Ð²Ñ…Ð¾Ð´ Ð½Ð° ÑÐ°Ð¹Ñ‚ B2B',0),(513538,14265,'es','Requieren un nÃºmero de PO por entrada de orden en el sitio B2B',0),(513539,14265,'de','BenÃ¶tigen Sie eine Bestellnummer fÃ¼r Auftragserfassung auf B2B-Website',0),(513540,14265,'en','Require A PO Number For Order Entry On B2B Site',0),(513541,14266,'is','',0),(513542,14266,'dr','Ø®Ø· Ù…ÙˆØ±Ø¯ ÙØ§ÛŒÙ„ CSV',0),(513543,14266,'pr','Ø®Ø· Ù…ÙˆØ±Ø¯ ÙØ§ÛŒÙ„ CSV',0),(513544,14266,'tr','SatÄ±r Ã¶ÄŸesi CSV dosya',0),(513545,14266,'pl','Pozycja pliku CSV',0),(513546,14266,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ CSV Ñ„Ð°Ð¹Ð»',0),(513547,14266,'ur','Ù„Ø§Ø¦Ù† Ø´Û’ CSV ÙØ§Ø¦Ù„',0),(513548,14266,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð° Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(513549,14266,'vi','Chi tiáº¿t Ä‘Æ¡n hÃ ng tá»‡p CSV',0),(513550,14266,'af','Lyn-Item CSV-lÃªer',0),(513551,14266,'ro','Element rÃ¢nd CSV dosar',0),(513552,14266,'et','ReaÃ¼ksuse CSV-faili',0),(513553,14266,'si','Datoteka CSV vrstiÄne postavke',0),(513554,14266,'ba','Item baris File CSV',0),(513555,14266,'nl','Regelitem CSV-bestand',0),(513556,14266,'fi','Rivinimikkeen CSV-tiedosto',0),(513557,14266,'no','Linjeelement CSV-fil',0),(513558,14266,'da','Linjepost CSV-fil',0),(513559,14266,'ko','CSV íŒŒì¼ì˜ í–‰ í•­ëª©',0),(513560,14266,'he','×§×•×‘×¥ ×”-CSV ×¤×¨×™×˜ ×©×•×¨×”',0),(513561,14266,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿ CSV',0),(513562,14266,'zh','è¡Œé¡¹ç›® CSV æ–‡ä»¶',0),(513563,14266,'sv','Radartikel CSV-filen',0),(513564,14266,'it','Voce File CSV',0),(513565,14266,'tl','',0),(513566,14266,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹à¸Ÿà¹‰à¸¡ CSV',0),(513567,14266,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® CSV à¤«à¤¼à¤¾à¤‡à¤²',0),(513568,14266,'ms','Fail CSV Line Item',0),(513569,14266,'ar','Ø¨Ù†Ø¯ Ù…Ù„Ù CSV',0),(513570,14266,'fr','Fichier CSV rubrique',0),(513571,14266,'jp','CSV ãƒ•ã‚¡ã‚¤ãƒ«ã®è¡Œã‚¢ã‚¤ãƒ†ãƒ ',0),(513572,14266,'pt','Arquivo CSV de Item de linha',0),(513573,14266,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ ÑÑ‚Ñ€Ð¾ÐºÐ¸ CSV-Ñ„Ð°Ð¹Ð»Ð°',0),(513574,14266,'es','RenglÃ³n un archivo CSV',0),(513575,14266,'de','Einzelposten-CSV-Datei',0),(513576,14266,'en','Line Item CSV File',0),(513577,14267,'is','',0),(513578,14267,'dr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø³ÙØ§Ø±Ø´ Ø¨Ù„ÛŒØ·',0),(513579,14267,'pr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø³ÙØ§Ø±Ø´ Ø¨Ù„ÛŒØ·',0),(513580,14267,'tr','SipariÅŸ bilet Ã¼zerinde sipariÅŸ deÄŸeri gÃ¶ster',0),(513581,14267,'pl','PokaÅ¼ wartoÅ›Ä‡ zamÃ³wienie na zamÃ³wienie biletu',0),(513582,14267,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´ ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð±Ð¸Ð»ÐµÑ‚',0),(513583,14267,'ur','Ù†Ø¸Ù… Ú©ÛŒ Ù‚Ø¯Ø± ØªØ±ØªÛŒØ¨ Ú©Û’ Ù¹Ú©Ù¹ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(513584,14267,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð½Ð° Ð½Ð°Ð»Ð¾Ð³ ÐºÐ°Ñ€Ñ‚Ñƒ',0),(513585,14267,'vi','Hiá»ƒn thá»‹ thá»© tá»± giÃ¡ trá»‹ trÃªn Ä‘áº·t hÃ ng vÃ©',0),(513586,14267,'af','Orde waarde wys op bestelling kaartjie',0),(513587,14267,'ro','AratÄƒ valoarea comenzii pe bilet de ordine',0),(513588,14267,'et','Kuva vÃ¤Ã¤rtus korra pilet',0),(513589,14267,'si','PrikaÅ¾i vrednost vrstnega reda na naroÄilo vstopnic',0),(513590,14267,'ba','Menunjukkan nilai Order pesanan Tiket',0),(513591,14267,'nl','Toon bestelwaarde op volgorde Ticket',0),(513592,14267,'fi','NÃ¤ytÃ¤ tilauksen arvo jotta lippu',0),(513593,14267,'no','Vis bestillingsverdi pÃ¥ ordre billett',0),(513594,14267,'da','Vis ordrevÃ¦rdi pÃ¥ Bestil billet',0),(513595,14267,'ko','ì£¼ë¬¸ í‹°ì¼“ ê°’ì„ í‘œì‹œ',0),(513596,14267,'he','×”×¦×’ ××ª ×”×¡×“×¨ ×¢×¨×š ×¢×œ ×”×–×ž× ×ª ×›×¨×˜×™×¡×™×',0),(513597,14267,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î±Î¾Î¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ ÏƒÎµ ÏƒÎµÎ¹ÏÎ¬ ÎµÎ¹ÏƒÎ¹Ï„Î®ÏÎ¹Î¿',0),(513598,14267,'zh','åœ¨è®¢æœºç¥¨ä¸Šæ˜¾ç¤ºè®¢å•ä»·å€¼',0),(513599,14267,'sv','Visa ordervÃ¤rde pÃ¥ bestÃ¤lla biljett',0),(513600,14267,'it','Visualizza ordine valore ordine biglietto',0),(513601,14267,'tl','',0),(513602,14267,'th','à¹à¸ªà¸”à¸‡à¸„à¹ˆà¸²à¸„à¸³à¸ªà¸±à¹ˆà¸‡à¹ƒà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ˆà¸­à¸‡à¸•à¸±à¹‹à¸§',0),(513603,14267,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¥‡ à¤Ÿà¤¿à¤•à¤Ÿ à¤ªà¤° à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¨ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(513604,14267,'ms','Menunjukkan nilai perintah atas Tiket perintah',0),(513605,14267,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù‚ÙŠÙ…Ø© Ø§Ù„Ù†Ø¸Ø§Ù… ÙÙŠ ØªØ±ØªÙŠØ¨ Ø­Ø¬Ø² Ø§Ù„ØªØ°Ø§ÙƒØ±',0),(513606,14267,'fr','Voir la valeur de l\'ordre sur ordre billet',0),(513607,14267,'jp','â€» æ•´ç†åˆ¸ã®é †åºã®å€¤ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(513608,14267,'pt','Mostrar o valor da ordem no bilhete de ordem',0),(513609,14267,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ð½Ð° Ð·Ð°ÐºÐ°Ð· Ð±Ð¸Ð»ÐµÑ‚Ð°',0),(513610,14267,'es','Mostrar valor de la orden en orden boleto',0),(513611,14267,'de','Bestellwert auf Bestellung anzeigen',0),(513612,14267,'en','Show Order Value On Order Ticket',0),(513613,14268,'is','',0),(513614,14268,'dr','EPay Ú†Ø§Ù¾ Ø¨Ù‡ EFT Ø§Ø±Ø³Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´',0),(513615,14268,'pr','EPay Ú†Ø§Ù¾ Ø¨Ù‡ EFT Ø§Ø±Ø³Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ Ø±Ø§ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´',0),(513616,14268,'tr','EFT gÃ¶ndermek YazdÄ±r Ã¶demelerin iÃ§in ABD ePay iÅŸleme iÃ§in tÄ±klayÄ±n',0),(513617,14268,'pl','Kliknij ePay EFT wydruku do wysyÅ‚ania pÅ‚atnoÅ›ci do USA dla przetwarzania',0),(513618,14268,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿ÐµÑ‡Ð°Ñ‚ Ð´Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ EFT Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ ÐºÑŠÐ¼ Ð¡ÐÐ© ePay Ð·Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(513619,14268,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’ EFT Ú©ÛŒ Ø¨Ú¾ÛŒØ¬ÛŒÚº Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Û’ Ù„ÛŒÛ’ Ø§Ù…Ø±ÛŒÚ©Û Ø§ÛŒÙ¾Ø¢ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(513620,14268,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð•Ð¤Ð¢ Ð´Ð° Ð¿Ð¾ÑˆÐ°Ñ™ÐµÑ‚Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ñƒ Ð£Ð¡Ð ÐµÐŸÐ°y Ð·Ð° Ð¾Ð±Ñ€Ð°Ð´Ñƒ',0),(513621,14268,'vi','Báº¥m vÃ o in Ä‘á»ƒ gá»­i EFT thanh toÃ¡n Ä‘á»ƒ Hoa Ká»³ ePay cho cháº¿ biáº¿n',0),(513622,14268,'af','Klik druk te stuur EFT betalings aan VSA ePay vir verwerking',0),(513623,14268,'ro','FaceÅ£i clic pe imprimare pentru a trimite EFT plÄƒÅ£i pentru SUA ePay pentru prelucrare',0),(513624,14268,'et','KlÃµpsake Prindi saada EFT maksete suhtes USA ePay tÃ¶Ã¶tlemise',0),(513625,14268,'si','Kliknite Natisni PoÅ¡lji EFT plaÄila za ZDA ePay za predelavo',0),(513626,14268,'ba','Klik cetak untuk mengirim TDE pembayaran untuk USA ePay untuk pengolahan',0),(513627,14268,'nl','Klik op afdrukken om te verzenden EFT betalingen aan de V.S. ePay voor verwerking',0),(513628,14268,'fi','Valitse Tulosta EFT lÃ¤hettÃ¤Ã¤ maksut USA ePay kÃ¤sittelyssÃ¤',0),(513629,14268,'no','Klikk Skriv ut Ã¥ sende EFT betalinger til USA andre betalingsmÃ¥ter For behandling',0),(513630,14268,'da','Klik pÃ¥ Print at sende EFT betalinger til USA ePay For behandling',0),(513631,14268,'ko','í´ë¦­ ì¸ì‡„ë¥¼ ë³´ë‚¼ ì „ìž ì†¡ê¸ˆ ì§€ë¶ˆì„ ë¯¸êµ­ ePayì— ëŒ€ í•œ ì²˜ë¦¬',0),(513632,14268,'he','×œ×—×¥ ×¢×œ ePay ×”×“×¤×¡×” ×©×œ×— EFT ×¢×œ ×ª×©×œ×•×ž×™× ×‘××¨×” ×¢×‘×•×¨ ×¢×™×‘×•×“',0),(513633,14268,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î»Î¿Î³Î® Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î½Î± ÏƒÏ„ÎµÎ¯Î»ÎµÏ„Îµ EFT Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î½Î± Î—Î Î‘ ePay Î³Î¹Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(513634,14268,'zh','å•å‡»æ‰“å°å‘é€ç”µå­è½¬è´¦ä»˜æ¬¾æ¥åˆ°ç¾Žå›½ ePay çš„å¤„ç†',0),(513635,14268,'sv','Klicka pÃ¥ Skriv ut att skicka EFT betalningar till USA ePay fÃ¶r bearbetning',0),(513636,14268,'it','Fare clic su stampa di EFT di inviare pagamenti a USA ePay per elaborazione',0),(513637,14268,'tl','',0),(513638,14268,'th','à¸„à¸¥à¸´à¸à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸žà¸´à¸¡à¸žà¹Œà¸à¸²à¸£à¸ªà¹ˆà¸‡ EFT à¹€à¸žà¸·à¹ˆà¸­à¸ªà¸«à¸£à¸±à¸à¸­à¹€à¸¡à¸£à¸´à¸à¸² ePay à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥',0),(513639,14268,'hi','à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤­à¥‡à¤œ à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚ à¤¸à¤‚à¤¯à¥à¤•à¥à¤¤ à¤°à¤¾à¤œà¥à¤¯ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ à¤•à¥‡ à¤²à¤¿à¤ ePay à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(513640,14268,'ms','Klik Print untuk menghantar EFT bayaran ke USA ePay bagi pemprosesan',0),(513641,14268,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ EFT Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ù„Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¥Ù„Ù‰ Ø§Ù„ÙˆÙ„Ø§ÙŠØ§Øª Ø§Ù„Ù…ØªØ­Ø¯Ø© Ø§Ù„Ø£Ù…Ø±ÙŠÙƒÙŠØ© Ù„ØªØ¬Ù‡ÙŠØ²',0),(513642,14268,'fr','Cliquez sur Imprimer pour envoyer EFT paiements aux USA PmtE pour traitement',0),(513643,14268,'jp','å°åˆ·ã™ã‚‹é€ä¿¡éŠ€è¡Œå£åº§æŒ¯è¾¼ã®æ”¯æ‰•ã„ã‚’ç±³å›½ ePay ã‚’å‡¦ç†] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(513644,14268,'pt','Clique em Print para EFT enviar pagamentos para EUA ePay para processamento',0),(513645,14268,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐºÐ½Ð¾Ð¿ÐºÑƒ ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð´Ð»Ñ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð´Ð»Ñ Ð¡Ð¨Ð ePay Ð´Ð»Ñ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸',0),(513646,14268,'es','Haga clic en imprimir para EFT enviar pagos a USA ePay para procesamiento',0),(513647,14268,'de','Klicken Sie auf Drucken, senden EFT Zahlungen nach USA ePay fÃ¼r Verarbeitung',0),(513648,14268,'en','Click Print To Send EFT Payments To USA ePay For Processing',0),(513649,14269,'is','',0),(513650,14269,'dr','Ø§Ø±Ø³Ø§Ù„ ePay EFT Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ù‡ Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§',0),(513651,14269,'pr','Ø§Ø±Ø³Ø§Ù„ ePay EFT Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ù‡ Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§',0),(513652,14269,'tr','EFT haberdar etmek iÃ§in ABD ePay gÃ¶nder',0),(513653,14269,'pl','WyÅ›lij Info EFT do USA ePay',0),(513654,14269,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ EFT Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¡ÐÐ© ePay',0),(513655,14269,'ur','EFT Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù…Ø±ÛŒÚ©Û Ú©Ùˆ Ø§ÛŒÙ¾Ø¢ÛŒ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(513656,14269,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ ÐµÐŸÐ°y Ð•Ð¤Ð¢ Ð˜Ð½Ñ„Ð¾-Ð£Ð¡Ð',0),(513657,14269,'vi','Gá»­i thÃ´ng tin EFT Ä‘á»ƒ Hoa Ká»³ ePay',0),(513658,14269,'af','Stuur EFT Info na VSA ePay',0),(513659,14269,'ro','Trimite ePay EFT Info pentru SUA',0),(513660,14269,'et','Saada EFT Info-USA ePay',0),(513661,14269,'si','PoÅ¡lji ePay EFT Info za ZDA',0),(513662,14269,'ba','Kirim TDE Info untuk USA ePay',0),(513663,14269,'nl','EFT Info aan de V.S. ePay verzenden',0),(513664,14269,'fi','LÃ¤hetÃ¤ EFT Info USA ePay',0),(513665,14269,'no','Sende EFT Info til USA andre betalingsmÃ¥ter',0),(513666,14269,'da','Send elektronisk PENGEOVERFÃ˜RSEL Info til USA ePay',0),(513667,14269,'ko','ì†¡ê¸ˆ ì •ë³´ë¥¼ ë¯¸êµ­ ePay ë³´ë‚´ê¸°',0),(513668,14269,'he','×©×œ×— EFT ×¤×¨×˜×™ ×›×“×™ ×‘××¨×” ×‘ ePay',0),(513669,14269,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Ï„Î¿Ï… ePay EFT Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Î—Î Î‘',0),(513670,14269,'zh','å‘é€åˆ°ç¾Žå›½ EFT ä¿¡æ¯ ePay',0),(513671,14269,'sv','Skicka EFT information till USA ePay',0),(513672,14269,'it','Inviare Info EFT a USA ePay',0),(513673,14269,'tl','',0),(513674,14269,'th','à¸ªà¹ˆà¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥ EFT à¹€à¸žà¸·à¹ˆà¸­à¸ªà¸«à¸£à¸±à¸à¸­à¹€à¸¡à¸£à¸´à¸à¸² ePay',0),(513675,14269,'hi','à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤‚à¤¯à¥à¤•à¥à¤¤ à¤°à¤¾à¤œà¥à¤¯ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ à¤•à¥‡ à¤²à¤¿à¤ ePay à¤­à¥‡à¤œà¥‡à¤‚',0),(513676,14269,'ms','Menghantar ePay EFT Info ke Amerika Syarikat',0),(513677,14269,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ EFT \"Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¥Ù„Ù‰ Ø§Ù„ÙˆÙ„Ø§ÙŠØ§Øª Ø§Ù„Ù…ØªØ­Ø¯Ø© Ø§Ù„Ø£Ù…Ø±ÙŠÙƒÙŠØ©\"',0),(513678,14269,'fr','Envoyer PmtE EFT Info aux Ã©.-u.',0),(513679,14269,'jp','éŠ€è¡Œå£åº§æƒ…å ±ã‚’ç±³ ePay ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(513680,14269,'pt','Enviar informaÃ§Ã£o EFT para EUA ePay',0),(513681,14269,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ ePay EFT Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð´Ð»Ñ Ð¡Ð¨Ð',0),(513682,14269,'es','Enviar Info a USA EFT ePay',0),(513683,14269,'de','Senden Sie EFT Info nach USA ePay',0),(513684,14269,'en','Send EFT Info To USA ePay',0),(513685,14270,'is','',0),(513686,14270,'dr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(513687,14270,'pr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(513688,14270,'tr','Ã–deme zaten gÃ¶nderilmiÅŸ',0),(513689,14270,'pl','PÅ‚atnoÅ›ci juÅ¼ przekazywane',0),(513690,14270,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð²ÐµÑ‡Ðµ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²ÐµÐ½Ð¸',0),(513691,14270,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ø¹Ø±Ø¶ Ú©ÛŒØ§ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(513692,14270,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐµ Ð²ÐµÑ› Ð¿Ñ€ÐµÐ´Ð°Ð»Ð°',0),(513693,14270,'vi','Thanh toÃ¡n Ä‘Ã£ Ä‘Æ°á»£c gá»­i Ä‘i',0),(513694,14270,'af','Betaling reeds ingedien',0),(513695,14270,'ro','Plata deja transmise',0),(513696,14270,'et','Makse on juba esitanud',0),(513697,14270,'si','PlaÄilo na Å¾e',0),(513698,14270,'ba','Pembayaran yang sudah diserahkan',0),(513699,14270,'nl','Betaling reeds ingediend',0),(513700,14270,'fi','Maksu jo',0),(513701,14270,'no','Betaling allerede sendt',0),(513702,14270,'da','Betaling allerede indsendt',0),(513703,14270,'ko','ì´ë¯¸ ì œì¶œ ì§€ë¶ˆ',0),(513704,14270,'he','×”×ª×©×œ×•× ×›×‘×¨ × ××¡×¤×•',0),(513705,14270,'el','Î Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î®Î´Î· Ï…Ï€Î¿Î²Î¬Î»ÎµÎ¹',0),(513706,14270,'zh','å·²ç»æäº¤çš„ä»˜æ¬¾',0),(513707,14270,'sv','Betalning redan lÃ¤mnats in',0),(513708,14270,'it','Pagamento giÃ  inserita',0),(513709,14270,'tl','',0),(513710,14270,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹à¸¥à¹‰à¸§à¸ªà¹ˆà¸‡',0),(513711,14270,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¹à¤²à¥‡ à¤¹à¥€ à¤ªà¥‡à¤¶ à¤•à¥€ à¤¹à¥ˆà¤‚:',0),(513712,14270,'ms','Pembayaran yang telah dikemukakan',0),(513713,14270,'ar','Ø§Ù„Ø¯ÙØ¹ Ø§Ù„ØªÙŠ Ù‚Ø¯Ù…Øª Ø¨Ø§Ù„ÙØ¹Ù„',0),(513714,14270,'fr','Paiement dÃ©jÃ  soumis',0),(513715,14270,'jp','æ—¢ã«æå‡ºã•ã‚ŒãŸæ”¯æ‰•ã„',0),(513716,14270,'pt','Pagamento jÃ¡ enviado',0),(513717,14270,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑƒÐ¶Ðµ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸',0),(513718,14270,'es','Pago ya presentado',0),(513719,14270,'de','Zahlung bereits eingereicht',0),(513720,14270,'en','Payment Already Submitted',0),(513721,14271,'is','',0),(513722,14271,'dr','Ø±Ø§Ù‡ Ø±ÙØªÙ† ÙØ±ÙˆØ´ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÙˆÙ„',0),(513723,14271,'pr','Ø±Ø§Ù‡ Ø±ÙØªÙ† ÙØ±ÙˆØ´ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÙˆÙ„',0),(513724,14271,'tr','Walk-In satÄ±ÅŸ vergileri ilk ayarlayÄ±n',0),(513725,14271,'pl','Zestaw Walk-In podatek',0),(513726,14271,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð¿ÑŠÑ€Ð²Ð¾ Ð¿Ð¾Ð´Ð²Ð¸Ð¶ÐµÐ½ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(513727,14271,'ur','Ø§Ù„Ù…Ø§Ø±ÛŒ Ù…ÛŒÚº ÙˆØ§Ú© Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ù¾ÛÙ„Û’ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(513728,14271,'sr','ÐŸÑ€Ð²Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ñ„Ñ€Ð¸Ñ›Ð¸Ð´ÐµÑ€ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð¿Ð¾Ñ€ÐµÐ·',0),(513729,14271,'vi','Thiáº¿t láº­p láº§n Ä‘áº§u tiÃªn Ä‘i bá»™ trong bÃ¡n hÃ ng thuáº¿',0),(513730,14271,'af','Walk-In verkope belastings eerste stel',0),(513731,14271,'ro','Primul set de taxa la vÃ¢nzÄƒri Walk-In',0),(513732,14271,'et','MÃ¤Ã¤ra Walk-In kÃ¤ibemaksude esmalt',0),(513733,14271,'si','Najprej nastavite Walk-In prometnega davka',0),(513734,14271,'ba','Menetapkan pajak penjualan bilik pertama',0),(513735,14271,'nl','Belastingen op de verkoop Walk-In eerst ingesteld',0),(513736,14271,'fi','Ensin mÃ¤Ã¤rittÃ¤Ã¤ Walk-In arvonlisÃ¤verot',0),(513737,14271,'no','Angi Walk-In merverdiavgift fÃ¸rst',0),(513738,14271,'da','Angive Walk-In moms fÃ¸rste',0),(513739,14271,'ko','ë¨¼ì € ëŒ€í˜• íŒë§¤ ì„¸ê¸ˆ ì„¤ì •',0),(513740,14271,'he','×¨××©×™×ª ×œ×”×’×“×™×¨ ×ž×¢ ×ž ×œ×œ× ×”×–×ž× ×”',0),(513741,14271,'el','Î£ÏÎ½Î¿Î»Î¿ Ï†ÏŒÏÎ¿Î¹ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Walk-In Ï€ÏÏŽÏ„Î±',0),(513742,14271,'zh','é¦–å…ˆè®¾ç½®æ­¥å…¥å¼é”€å”®ç¨Žé‡‘',0),(513743,14271,'sv','FÃ¶rst ange Walk-In moms',0),(513744,14271,'it','Prima di impostare le imposte sulle vendite di cabina',0),(513745,14271,'tl','',0),(513746,14271,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢à¸à¸±à¸à¸šà¸±à¸§à¹à¸¢à¸à¸à¸±à¸™à¸à¹ˆà¸­à¸™',0),(513747,14271,'hi','à¤µà¤¾à¤²à¥à¤•-à¤‡à¤¨ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥‹à¤‚ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡à¤Ÿ',0),(513748,14271,'ms','Menetapkan cukai jualan bilik pertama',0),(513749,14271,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù…Ù‚ØµÙˆØ±Ø© Ø£ÙˆÙ„Ø§Ù‹',0),(513750,14271,'fr','Tout d\'abord la valeur des Taxes de vente Walk-in',0),(513751,14271,'jp','ã‚¦ã‚©ãƒ¼ã‚¯ã‚¤ãƒ³å–¶æ¥­ç¨Žã‚’æœ€åˆã«è¨­å®šã—ã¾ã™ã€‚',0),(513752,14271,'pt','Conjunto de impostos sobre vendas de walk-in primeiro',0),(513753,14271,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Walk-In Ð½Ð°Ð»Ð¾Ð³Ð¸',0),(513754,14271,'es','Fije primero el vestidor impuestos',0),(513755,14271,'de','Legen Sie zuerst fest Walk-Umsatzsteuer',0),(513756,14271,'en','Set Walk-In Sales Taxes First',0),(513757,14272,'is','',0),(513758,14272,'dr','Ù‡ÛŒÚ† Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ Ù…ÙˆØ¬ÙˆØ¯',0),(513759,14272,'pr','Ù‡ÛŒÚ† Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ Ù…ÙˆØ¬ÙˆØ¯',0),(513760,14272,'tr','Ne mevcut banka hesabÄ±',0),(513761,14272,'pl','Nie ma dostÄ™pnych rachunkÃ³w bankowych',0),(513762,14272,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸ Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(513763,14272,'ur','Ú©ÙˆØ¦ÛŒ Ø¯Ø³ØªÛŒØ§Ø¨ Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(513764,14272,'sr','ÐÐµÐ¼Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸Ñ… Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(513765,14272,'vi','KhÃ´ng cÃ³ tÃ i khoáº£n ngÃ¢n hÃ ng cÃ³ sáºµn',0),(513766,14272,'af','Geen beskikbare bankrekeninge',0),(513767,14272,'ro','Nici o dispoziÅ£ie conturi bancare',0),(513768,14272,'et','Ei ole saadaval pangakontod',0),(513769,14272,'si','Ni razpoloÅ¾ljivih banÄnih raÄunov',0),(513770,14272,'ba','Rekening Bank tidak tersedia',0),(513771,14272,'nl','Geen beschikbare bankrekeningen',0),(513772,14272,'fi','Ei ole saatavilla pankkitiliÃ¤',0),(513773,14272,'no','Ingen tilgjengelig bankkonti',0),(513774,14272,'da','Ingen tilgÃ¦ngelige bankkonti',0),(513775,14272,'ko','ì—†ìŒ ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” ì€í–‰ ê³„ì¢Œ',0),(513776,14272,'he','×œ× ×–×ž×™×Ÿ ×—×©×‘×•× ×•×ª ×‘× ×§.',0),(513777,14272,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ Î´ÎµÎ½',0),(513778,14272,'zh','æ²¡æœ‰å¯ç”¨çš„é“¶è¡Œå¸æˆ·',0),(513779,14272,'sv','Inga tillgÃ¤ngliga bankkonton',0),(513780,14272,'it','Senza conti bancari disponibili',0),(513781,14272,'tl','',0),(513782,14272,'th','à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£à¹„à¸¡à¹ˆà¸§à¹ˆà¸²à¸‡',0),(513783,14272,'hi','à¤•à¥‹à¤ˆ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‹à¤‚',0),(513784,14272,'ms','Mempunyai akaun Bank yang disediakan',0),(513785,14272,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø­Ø³Ø§Ø¨Ø§Øª Ù…ØµØ±ÙÙŠØ© Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(513786,14272,'fr','Aucun compte bancaire disponible',0),(513787,14272,'jp','åˆ©ç”¨å¯èƒ½ãªéŠ€è¡Œã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(513788,14272,'pt','Sem contas bancÃ¡rias disponÃ­veis',0),(513789,14272,'ru','ÐÐµÑ‚ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ñ… Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(513790,14272,'es','No hay cuentas bancarias disponibles',0),(513791,14272,'de','Keine verfÃ¼gbaren Bankkonten',0),(513792,14272,'en','No Available Bank Accounts',0),(513793,14273,'is','',0),(513794,14273,'dr','Ø±ÙˆÙ†Ø¯ ØµØ¯ÙˆØ± ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(513795,14273,'pr','Ø±ÙˆÙ†Ø¯ ØµØ¯ÙˆØ± ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(513796,14273,'tr','Otomatik fatura iÅŸleme',0),(513797,14273,'pl','Proces Auto-Billing',0),(513798,14273,'bg','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚Ð²Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ðµ',0),(513799,14273,'ur','Ø®ÙˆØ¯Ú©Ø§Ø±-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù¾Ø± Ø¹Ù…Ù„',0),(513800,14273,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾Ð³-Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(513801,14273,'vi','Xá»­ lÃ½ thanh toÃ¡n tá»± Ä‘á»™ng',0),(513802,14273,'af','Proses Outo-fakturering',0),(513803,14273,'ro','Procesul de Auto-facturare',0),(513804,14273,'et','Protsessi Auto-arved',0),(513805,14273,'si','Proces Auto-obraÄun',0),(513806,14273,'ba','Proses Auto-penagihan',0),(513807,14273,'nl','Proces Auto-Billing',0),(513808,14273,'fi','Prosessin automaattisen laskutuksen',0),(513809,14273,'no','Behandle Auto-fakturering',0),(513810,14273,'da','Processen Auto-fakturering',0),(513811,14273,'ko','í”„ë¡œì„¸ìŠ¤ ìžë™ ê²°ì œ',0),(513812,14273,'he','×ª×”×œ×™×š ××•×˜×•×ž×˜×™-×—×™×•×‘',0),(513813,14273,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î·Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(513814,14273,'zh','è¿‡ç¨‹è‡ªåŠ¨è®¡è´¹',0),(513815,14273,'sv','Processen Auto-fakturering',0),(513816,14273,'it','Processo di Auto-fatturazione',0),(513817,14273,'tl','',0),(513818,14273,'th','à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(513819,14273,'hi','à¤‘à¤Ÿà¥‹-à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾',0),(513820,14273,'ms','Memproses bil automatik',0),(513821,14273,'ar','Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª-Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(513822,14273,'fr','Processus Auto-facturation',0),(513823,14273,'jp','è‡ªå‹•è«‹æ±‚å‡¦ç†ã—ã¾ã™ã€‚',0),(513824,14273,'pt','Processo de Auto-facturaÃ§Ã£o',0),(513825,14273,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ Auto Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³',0),(513826,14273,'es','Proceso automÃ¡tico de facturaciÃ³n',0),(513827,14273,'de','Auto-Billing zu verarbeiten',0),(513828,14273,'en','Process Auto-Billing',0),(513829,14274,'is','',0),(513830,14274,'dr','Ø§ÛŒÙ† Ø´Ø±Ú©Øª Ø¯Ø± Ø±ÙˆÙ†Ø¯ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ACH Ù¾ÛŒÚ©Ø±Ø¨Ù†Ø¯ÛŒ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(513831,14274,'pr','Ø§ÛŒÙ† Ø´Ø±Ú©Øª Ø¯Ø± Ø±ÙˆÙ†Ø¯ Ù…Ø¹Ø§Ù…Ù„Ø§Øª ACH Ù¾ÛŒÚ©Ø±Ø¨Ù†Ø¯ÛŒ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(513832,14274,'tr','Bu ÅŸirketin iÅŸlem ACH hareketleri iÃ§in yapÄ±landÄ±rÄ±lmamÄ±ÅŸ',0),(513833,14274,'pl','Ta firma nie jest skonfigurowany do procesu ACH transakcji',0),(513834,14274,'bg','Ð¢Ð°Ð·Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð½Ðµ Ðµ ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð¸Ñ€Ð°Ð½ Ð´Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑ ACH Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(513835,14274,'ur','ÛŒÛ Ú©Ù…Ù¾Ù†ÛŒ Ø¹Ù…Ù„ Ø§Ú† Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ØªØ´Ú©ÛŒÙ„ Ù†ÛÛŒÚº ÛÛ’ Û”',0),(513836,14274,'sr','ÐžÐ²Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ ÐºÐ¾Ð½Ñ„Ð¸Ð³ÑƒÑ€Ð¸ÑÐ°Ð½ Ð´Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑ ÐÑ… Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(513837,14274,'vi','CÃ´ng ty nÃ y khÃ´ng Ä‘Æ°á»£c cáº¥u hÃ¬nh Ä‘á»ƒ quÃ¡ trÃ¬nh ACH giao dá»‹ch',0),(513838,14274,'af','Hierdie maatskappy Is nie gekonfigureer om proses ACH transaksies',0),(513839,14274,'ro','AceastÄƒ companie nu este configurat pentru tranzacÅ£iile de ACH procesul',0),(513840,14274,'et','See ettevÃµte on konfigureeritud protsessi ACH tehingute',0),(513841,14274,'si','To podjetje ni konfiguriran za proces ACH transakcije',0),(513842,14274,'ba','Perusahaan ini tidak dikonfigurasi untuk proses transaksi ACH',0),(513843,14274,'nl','Dit bedrijf Is niet geconfigureerd voor het proces ACH transacties',0),(513844,14274,'fi','TÃ¤mÃ¤ yritys ei ole mÃ¤Ã¤ritetty ACH tapahtumien kÃ¤sittely',0),(513845,14274,'no','Dette selskapet er ikke konfigurert til Ã¥ behandle ACH transaksjoner',0),(513846,14274,'da','Dette selskab er ikke konfigureret til processen ACH transaktioner',0),(513847,14274,'ko','ì´ íšŒì‚¬ëŠ” í”„ë¡œì„¸ìŠ¤ ACH ê±°ëž˜ í•˜ë„ë¡ êµ¬ì„± ë˜ì§€ ì•Šì€',0),(513848,14274,'he','×”×—×‘×¨×” ×”×–××ª ×œ× × ×§×‘×¢×” ×ª×”×œ×™×š ACH ×¢×¡×§××•×ª',0),(513849,14274,'el','Î‘Ï…Ï„Î® Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ ÏÏ…Î¸Î¼Î¹ÏƒÏ„ÎµÎ¯ Î½Î± Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± ACH ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚',0),(513850,14274,'zh','æœ¬å…¬å¸æœªé…ç½®è¿‡ç¨‹ ACH äº¤æ˜“',0),(513851,14274,'sv','Detta fÃ¶retag har inte konfigurerats att bearbeta ACH transaktioner',0),(513852,14274,'it','Questa azienda non Ã¨ configurata per processo ACH transazioni',0),(513853,14274,'tl','',0),(513854,14274,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸à¸³à¸«à¸™à¸”à¸„à¹ˆà¸²à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡ ACH',0),(513855,14274,'hi','à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥€ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ ACH à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‰à¤¨à¥à¤«à¤¼à¤¿à¤—à¤° à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(513856,14274,'ms','Syarikat ini tidak dikonfigurasikan untuk proses men transaksi',0),(513857,14274,'ar','Ù„Ù… ÙŠØªÙ… ØªÙƒÙˆÙŠÙ† Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ© Ø¥Ù„Ù‰ Ø¹Ù…Ù„ÙŠØ© Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(513858,14274,'fr','Cette sociÃ©tÃ© n\'est pas configurÃ©e pour traiter les Transactions de ACH',0),(513859,14274,'jp','ã“ã®ä¼šç¤¾ã¯ ACH ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã‚’å‡¦ç†ã™ã‚‹æ§‹æˆã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(513860,14274,'pt','Esta empresa nÃ£o estÃ¡ configurada para transaÃ§Ãµes de ACH do processo',0),(513861,14274,'ru','Ð­Ñ‚Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð½Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐ½ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ° ACH ÑÐ´ÐµÐ»Ð¾Ðº',0),(513862,14274,'es','Esta empresa no estÃ¡ configurada para procesar transacciones ACH',0),(513863,14274,'de','Diese Firma ist nicht auf Prozess ACH Transaktionen konfiguriert.',0),(513864,14274,'en','This Company Is Not Configured To Process ACH Transactions',0),(513865,14275,'is','',0),(513866,14275,'dr','Ù…ÛŒØ²Ø§Ù† Ø´Ø§Ø±Ú˜ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(513867,14275,'pr','Ù…ÛŒØ²Ø§Ù† Ø´Ø§Ø±Ú˜ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(513868,14275,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde Ã¼cret tutarÄ±',0),(513869,14275,'pl','Kwota pobierana pomyÅ›lnie',0),(513870,14275,'bg','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(513871,14275,'ur','Ø±Ù‚Ù… Ú†Ø§Ø±Ø¬ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’',0),(513872,14275,'sr','Ð˜Ð·Ð½Ð¾Ñ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾ Ð½Ð°Ð¿Ð»Ð°Ñ›ÑƒÑ˜Ðµ',0),(513873,14275,'vi','Sá»‘ tiá»n Ä‘Ã£ tÃ­nh phÃ­',0),(513874,14275,'af','Bedrag gehef suksesvol',0),(513875,14275,'ro','Suma perceputÄƒ cu succes',0),(513876,14275,'et','Summa edukalt',0),(513877,14275,'si','UspeÅ¡no zaraÄunanega zneska',0),(513878,14275,'ba','Jumlah yang berhasil dikenai biaya',0),(513879,14275,'nl','Bedrag met succes in rekening gebracht',0),(513880,14275,'fi','PerittÃ¤vÃ¤ summa onnistuneesti',0),(513881,14275,'no','BelÃ¸p belastet',0),(513882,14275,'da','Med held opkrÃ¦vede belÃ¸b',0),(513883,14275,'ko','ì„±ê³µì ìœ¼ë¡œ ì²­êµ¬ ê¸ˆì•¡',0),(513884,14275,'he','×‘×”×¦×œ×—×” ×©×™×—×•×™×‘',0),(513885,14275,'el','Î Î¿ÏƒÏŒ Ï€Î¿Ï… Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(513886,14275,'zh','æˆåŠŸæ”¶å–é‡‘é¢',0),(513887,14275,'sv','Summa som framgÃ¥ngsrikt debiteras',0),(513888,14275,'it','Importo addebitato con successo',0),(513889,14275,'tl','',0),(513890,14275,'th','à¸¢à¸­à¸”à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(513891,14275,'hi','à¤°à¤¾à¤¶à¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤•à¤¾ à¤†à¤°à¥‹à¤ª',0),(513892,14275,'ms','Jumlah yang berjaya dikenakan',0),(513893,14275,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø¨Ù†Ø¬Ø§Ø­',0),(513894,14275,'fr','Montant facturÃ© avec succÃ¨s',0),(513895,14275,'jp','æ­£å¸¸ã«è«‹æ±‚é¡',0),(513896,14275,'pt','Valor cobrado com sucesso',0),(513897,14275,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð½Ð¾Ð¹',0),(513898,14275,'es','Cantidad cargada con Ã©xito',0),(513899,14275,'de','Erfolgreich Betrag',0),(513900,14275,'en','Amount Successfully Charged',0),(513901,14276,'is','',0),(513902,14276,'dr','Ø®ÙˆØ¯Ú©Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ú¯Ø²Ø§Ø±Ø´',0),(513903,14276,'pr','Ø®ÙˆØ¯Ú©Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ú¯Ø²Ø§Ø±Ø´',0),(513904,14276,'tr','Otomatik fatura raporu',0),(513905,14276,'pl','Auto rozliczenia raport',0),(513906,14276,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(513907,14276,'ur','Ø®ÙˆØ¯Ú©Ø§Ø±-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(513908,14276,'sr','ÐÑƒÑ‚Ð¾ -Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(513909,14276,'vi','BÃ¡o cÃ¡o thanh toÃ¡n tá»± Ä‘á»™ng',0),(513910,14276,'af','Outo-fakturering verslag',0),(513911,14276,'ro','Raport de auto-facturare',0),(513912,14276,'et','Automaatne arvete aruanne',0),(513913,14276,'si','Auto-obraÄun poroÄilo',0),(513914,14276,'ba','Auto-penagihan laporan',0),(513915,14276,'nl','Auto-Billing verslag',0),(513916,14276,'fi','Automaattisen laskutuksen raportti',0),(513917,14276,'no','Auto-fakturering rapport',0),(513918,14276,'da','Auto-fakturering rapport',0),(513919,14276,'ko','ìžë™ ì²­êµ¬ ë³´ê³ ì„œ',0),(513920,14276,'he','×“×•×— ××•×˜×•×ž×˜×™-×—×™×•×‘',0),(513921,14276,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Auto-Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(513922,14276,'zh','è‡ªåŠ¨è®¡è´¹æŠ¥å‘Š',0),(513923,14276,'sv','Auto-fakturering rapport',0),(513924,14276,'it','Relazione di auto-fatturazione',0),(513925,14276,'tl','',0),(513926,14276,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(513927,14276,'hi','à¤‘à¤Ÿà¥‹-à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(513928,14276,'ms','Laporan bil automatik',0),(513929,14276,'ar','ØªÙ‚Ø±ÙŠØ± ØªÙ„Ù‚Ø§Ø¦ÙŠ-Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(513930,14276,'fr','Rapport de facturation automatique',0),(513931,14276,'jp','è‡ªå‹•è«‹æ±‚ãƒ¬ãƒãƒ¼ãƒˆ',0),(513932,14276,'pt','RelatÃ³rio de auto-facturaÃ§Ã£o',0),(513933,14276,'ru','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð°Ð²Ñ‚Ð¾ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³',0),(513934,14276,'es','Informe automÃ¡tico de facturaciÃ³n',0),(513935,14276,'de','Auto-Billing-Bericht',0),(513936,14276,'en','Auto-Billing Report',0),(513937,14277,'is','',0),(513938,14277,'dr','Ø¯Ø³ØªÙ‡',0),(513939,14277,'pr','Ø¯Ø³ØªÙ‡',0),(513940,14277,'tr','Toplu iÅŸ',0),(513941,14277,'pl','Partia',0),(513942,14277,'bg','ÐŸÐ°ÐºÐµÑ‚Ð½Ð¾',0),(513943,14277,'ur','Ø¨ÛŒÚ†',0),(513944,14277,'sr','Ð“Ñ€ÑƒÐ¿Ð½Ðµ Ð¾Ð±Ñ€Ð°Ð´Ðµ',0),(513945,14277,'vi','LÃ´',0),(513946,14277,'af','Bondel',0),(513947,14277,'ro','Lot',0),(513948,14277,'et','Partii',0),(513949,14277,'si','Serija',0),(513950,14277,'ba','Batch',0),(513951,14277,'nl','Batch',0),(513952,14277,'fi','ErÃ¤',0),(513953,14277,'no','Satsvis',0),(513954,14277,'da','Batch',0),(513955,14277,'ko','ì¼ê´„ ì²˜ë¦¬',0),(513956,14277,'he','××¦×•×•×”',0),(513957,14277,'el','ÎœÎ±Î¶Î¹ÎºÎ®',0),(513958,14277,'zh','æ‰¹å¤„ç†',0),(513959,14277,'sv','Batch',0),(513960,14277,'it','Lotto',0),(513961,14277,'tl','',0),(513962,14277,'th','à¸Šà¸¸à¸”',0),(513963,14277,'hi','à¤¬à¥ˆà¤š',0),(513964,14277,'ms','Kumpulan',0),(513965,14277,'ar','Ø¯ÙØ¹Ø©',0),(513966,14277,'fr','Lot',0),(513967,14277,'jp','ãƒãƒƒãƒ',0),(513968,14277,'pt','Lote',0),(513969,14277,'ru','ÐŸÐ°ÐºÐµÑ‚Ð½Ñ‹Ð¹',0),(513970,14277,'es','Lote',0),(513971,14277,'de','Batch',0),(513972,14277,'en','Batch',0),(513973,14278,'is','',0),(513974,14278,'dr','Ù„Ø·ÙØ§ Ø§Ù†ØªØ®Ø§Ø¨ Ø¯Ø³ØªÙ‡ Ø§ÛŒ ÛŒØ§ Ø´Ù…Ø§Ø±Ù‡ ØªØ§ÛŒÛŒØ¯ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(513975,14278,'pr','Ù„Ø·ÙØ§ Ø§Ù†ØªØ®Ø§Ø¨ Ø¯Ø³ØªÙ‡ Ø§ÛŒ ÛŒØ§ Ø´Ù…Ø§Ø±Ù‡ ØªØ§ÛŒÛŒØ¯ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(513976,14278,'tr','LÃ¼tfen bir kÃ¼me seÃ§in veya bir onay numarasÄ± girin',0),(513977,14278,'pl','ProszÄ™ wybraÄ‡ partii lub wprowadziÄ‡ numer potwierdzenia',0),(513978,14278,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð°Ð¿ÐºÐ° Ð¸Ð»Ð¸ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(513979,14278,'ur','Ø§ÛŒÚ© Ø¨ÛŒÚ† Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº ÛŒØ§ Ø§ÛŒÚ© ØªØµØ¯ÛŒÙ‚ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(513980,14278,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð³Ñ€ÑƒÐ¿Ñƒ Ð¸Ð»Ð¸ ÑƒÐ¿Ð¸ÑˆÐ¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ',0),(513981,14278,'vi','Xin vui lÃ²ng chá»n má»™t lÃ´ hoáº·c nháº­p má»™t sá»‘ xÃ¡c nháº­n',0),(513982,14278,'af','Asseblief kies \'n bondel of tik \'n nommer in bevestiging',0),(513983,14278,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i un lot sau introduceÅ£i un numÄƒr de confirmare',0),(513984,14278,'et','Palun valige partii vÃµi sisestage kinnituse Number',0),(513985,14278,'si','Izberite paket ali vnesite Å¡tevilko potrditve',0),(513986,14278,'ba','Silakan pilih kumpulan atau masukkan nomor konfirmasi',0),(513987,14278,'nl','Selecteer een Batch of voer een bevestigingsnummer',0),(513988,14278,'fi','Valitse erÃ¤n tai vahvistus numero',0),(513989,14278,'no','Velg en bunke eller angi en bekreftelse',0),(513990,14278,'da','VÃ¦lg et Batch eller indtaste et bekrÃ¦ftelsesnummer',0),(513991,14278,'ko','ì œë°œ ì¼ê´„ ì²˜ë¦¬ë¥¼ ì„ íƒ í•˜ê±°ë‚˜ í™•ì¸ ë²ˆí˜¸ë¥¼ ìž…ë ¥',0),(513992,14278,'he','× × ×‘×—×¨ ××¦×•×•×” ××• ×”×–×Ÿ ×ž×¡×¤×¨ ××™×©×•×¨',0),(513993,14278,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î´Î­ÏƒÎ¼Î· Î® ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ Î±ÏÎ¹Î¸Î¼ÏŒ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ·Ï‚',0),(513994,14278,'zh','è¯·é€‰æ‹©ä¸€æ‰¹æˆ–è¾“å…¥ä¸€ä¸ªç¡®è®¤å·ç ',0),(513995,14278,'sv','VÃ¤lj ett Batch eller ange ett bekrÃ¤ftelsenummer',0),(513996,14278,'it','Seleziona un Batch o immettere un numero di conferma',0),(513997,14278,'tl','',0),(513998,14278,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸¥à¸·à¸­à¸à¸Šà¸¸à¸”à¸‡à¸²à¸™ à¸«à¸£à¸·à¸­à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸à¸²à¸£à¸¢à¸·à¸™à¸¢à¸±à¸™',0),(513999,14278,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¬à¥ˆà¤š à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤à¤• à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(514000,14278,'ms','Sila pilih kelompok atau masukkan nombor pengesahan yang',0),(514001,14278,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ù…Ø¬Ù…ÙˆØ¹Ø©ØŒ Ø£Ùˆ Ù‚Ù… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… ØªØ£ÙƒÙŠØ¯',0),(514002,14278,'fr','S\'il vous plaÃ®t sÃ©lectionnez un lot ou entrez un numÃ©ro de Confirmation',0),(514003,14278,'jp','ãƒãƒƒãƒã‚’é¸æŠžã¾ãŸã¯ç¢ºèªç•ªå·ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(514004,14278,'pt','Por favor, selecione um lote ou digite um nÃºmero de confirmaÃ§Ã£o',0),(514005,14278,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð°ÐºÐµÑ‚, Ð¸Ð»Ð¸ Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(514006,14278,'es','Por favor seleccione un lote o escriba un nÃºmero de confirmaciÃ³n',0),(514007,14278,'de','Bitte wÃ¤hlen Sie einen Stapel oder geben Sie eine BestÃ¤tigungsnummer',0),(514008,14278,'en','Please Select A Batch Or Enter A Confirmation Number',0),(514009,14279,'is','',0),(514010,14279,'dr','Ø¯Ø³ØªÙ‡ Ø§ÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(514011,14279,'pr','Ø¯Ø³ØªÙ‡ Ø§ÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(514012,14279,'tr','Toplu iÅŸlemi seÃ§in',0),(514013,14279,'pl','Wybierz partii',0),(514014,14279,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð°Ð¿ÐºÐ°',0),(514015,14279,'ur','Ø¨ÛŒÚ† Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(514016,14279,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð³Ñ€ÑƒÐ¿Ñƒ',0),(514017,14279,'vi','Chá»n hÃ ng loáº¡t',0),(514018,14279,'af','Kies bondel',0),(514019,14279,'ro','SelectaÅ£i lotul',0),(514020,14279,'et','Valige tÃ¶Ã¶leht',0),(514021,14279,'si','Izberite paket',0),(514022,14279,'ba','Pilih Batch',0),(514023,14279,'nl','Selecteer Batch',0),(514024,14279,'fi','Valitse erÃ¤',0),(514025,14279,'no','Velg satsvis',0),(514026,14279,'da','VÃ¦lg parti',0),(514027,14279,'ko','ì¼ê´„ ì²˜ë¦¬ë¥¼ ì„ íƒ',0),(514028,14279,'he','×‘×—×¨ ××¦×•×•×”',0),(514029,14279,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î±Î¶Î¹ÎºÎ®',0),(514030,14279,'zh','é€‰æ‹©æ‰¹æ¬¡',0),(514031,14279,'sv','VÃ¤lj journal',0),(514032,14279,'it','Selezionare Batch',0),(514033,14279,'tl','',0),(514034,14279,'th','à¹€à¸¥à¸·à¸­à¸à¸Šà¸¸à¸”',0),(514035,14279,'hi','à¤¬à¥ˆà¤š à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(514036,14279,'ms','Pilih Kumpulan',0),(514037,14279,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø¯ÙØ¹ÙŠ',0),(514038,14279,'fr','SÃ©lectionnez lot',0),(514039,14279,'jp','ãƒãƒƒãƒã‚’é¸æŠžã—ã¾ã™',0),(514040,14279,'pt','Selecione o lote',0),(514041,14279,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð°ÐºÐµÑ‚',0),(514042,14279,'es','Seleccione lote',0),(514043,14279,'de','WÃ¤hlen Sie Stapel',0),(514044,14279,'en','Select Batch',0),(514045,14280,'is','',0),(514046,14280,'dr','Ù†Ø§Ù… Ø³Ù†Ø¯ Ù…ØªÙ…Ù…',0),(514047,14280,'pr','Ù†Ø§Ù… Ø³Ù†Ø¯ Ù…ØªÙ…Ù…',0),(514048,14280,'tr','DeÄŸiÅŸiklik belge adÄ±',0),(514049,14280,'pl','Zmiana nazwy dokumentu',0),(514050,14280,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(514051,14280,'ur','ØªØ±Ù…ÛŒÙ… Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ø§ Ù†Ø§Ù…',0),(514052,14280,'sr','ÐÐ°Ð·Ð¸Ð² Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð°Ð¼Ð°Ð½Ð´Ð¼Ð°Ð½',0),(514053,14280,'vi','Sá»­a Ä‘á»•i tÃ i liá»‡u tÃªn',0),(514054,14280,'af','Wysiging dokument naam',0),(514055,14280,'ro','Modificare nume Document',0),(514056,14280,'et','Muudatusettepanek dokumendile nimi',0),(514057,14280,'si','Sprememba ime dokumenta',0),(514058,14280,'ba','Perubahan nama dokumen',0),(514059,14280,'nl','Amendement documentnaam',0),(514060,14280,'fi','Tarkistuksen tiedoston nimi',0),(514061,14280,'no','Navn pÃ¥ endring',0),(514062,14280,'da','Ã†ndringsforslag dokumentnavnet',0),(514063,14280,'ko','ê°œì • ë¬¸ì„œ ì´ë¦„',0),(514064,14280,'he','×©× ×”×ž×¡×ž×š ×ª×™×§×•×Ÿ',0),(514065,14280,'el','Î¤ÏÎ¿Ï€Î¿Î»Î¿Î³Î¯Î± ÏŒÎ½Î¿Î¼Î± ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(514066,14280,'zh','ä¿®è®¢æ–‡æ¡£åç§°',0),(514067,14280,'sv','Ã„ndringsfÃ¶rslag dokumentnamn',0),(514068,14280,'it','Nome documento emendamento',0),(514069,14280,'tl','',0),(514070,14280,'th','à¸Šà¸·à¹ˆà¸­à¹€à¸­à¸à¸ªà¸²à¸£à¹à¸à¹‰à¹„à¸‚',0),(514071,14280,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤•à¤¾ à¤¨à¤¾à¤®',0),(514072,14280,'ms','Nama dokumen pindaan',0),(514073,14280,'ar','ØªØ¹Ø¯ÙŠÙ„ Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªÙ†Ø¯',0),(514074,14280,'fr','Modification Document nom',0),(514075,14280,'jp','æ”¹æ­£ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆå',0),(514076,14280,'pt','Nome do documento de alteraÃ§Ã£o',0),(514077,14280,'ru','ÐŸÐ¾Ð¿Ñ€Ð°Ð²ÐºÐ° Ð¸Ð¼Ñ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(514078,14280,'es','Nombre del documento de enmienda',0),(514079,14280,'de','Ã„nderungsantrag Dokumentnamen',0),(514080,14280,'en','Amendment Document Name',0),(514081,14281,'is','',0),(514082,14281,'dr','Ø§ØµÙ„Ø§Ø­ Ø§Ù„Ú¯Ùˆ Ø´Ù†Ø§Ø³Ù‡',0),(514083,14281,'pr','Ø§ØµÙ„Ø§Ø­ Ø§Ù„Ú¯Ùˆ Ø´Ù†Ø§Ø³Ù‡',0),(514084,14281,'tr','DeÄŸiÅŸiklik ÅŸablonu kimliÄŸi',0),(514085,14281,'pl','Zmiana szablonu ID',0),(514086,14281,'bg','Ð˜Ð” Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð·Ð° Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(514087,14281,'ur','ØªØ±Ù…ÛŒÙ… Ø³Ø§Ù†Ú†Ø§ Ø´Ù†Ø§Ø®Øª',0),(514088,14281,'sr','Ð˜Ð” Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ° Ð°Ð¼Ð°Ð½Ð´Ð¼Ð°Ð½',0),(514089,14281,'vi','Sá»­a Ä‘á»•i máº«u ID',0),(514090,14281,'af','Wysiging sjabloon ID',0),(514091,14281,'ro','ID de ÅŸablon modificÄƒri',0),(514092,14281,'et','Muudatus malli ID',0),(514093,14281,'si','ID predloge za spremembo',0),(514094,14281,'ba','Perubahan Template ID',0),(514095,14281,'nl','Amendement sjabloon ID',0),(514096,14281,'fi','Tarkistus mallin tunnus',0),(514097,14281,'no','Endring mal-ID',0),(514098,14281,'da','Ã†ndringsforslag skabelon-ID',0),(514099,14281,'ko','ê°œì • ì„œì‹ íŒŒì¼ ID',0),(514100,14281,'he','×ª×™×§×•×Ÿ ×ª×‘× ×™×ª ×ž×–×”×”',0),(514101,14281,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï… Ï„ÏÎ¿Ï€Î¿Î»Î¿Î³Î¯Î±',0),(514102,14281,'zh','ä¿®æ”¹æ¨¡æ¿ ID',0),(514103,14281,'sv','Mall-ID fÃ¶r Ã¤ndring',0),(514104,14281,'it','Modifica modello ID',0),(514105,14281,'tl','',0),(514106,14281,'th','à¹à¸à¹‰à¹„à¸‚à¸£à¸«à¸±à¸ªà¹€à¸—à¹‡à¸¡à¹€à¸žà¸¥à¸•',0),(514107,14281,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ ID',0),(514108,14281,'ms','Pindaan Template ID',0),(514109,14281,'ar','ØªØ¹Ø¯ÙŠÙ„ Ù‚Ø§Ù„Ø¨ Ù…Ø¹Ø±Ù',0),(514110,14281,'fr','ID de modÃ¨le de modification',0),(514111,14281,'jp','æ”¹æ­£ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ ID',0),(514112,14281,'pt','Modelo de alteraÃ§Ã£o de identificaÃ§Ã£o',0),(514113,14281,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÑˆÐ°Ð±Ð»Ð¾Ð½Ð° Ð¿Ð¾Ð¿Ñ€Ð°Ð²ÐºÐ°',0),(514114,14281,'es','Enmienda plantilla ID',0),(514115,14281,'de','Ã„nderung Vorlagen-ID',0),(514116,14281,'en','Amendment Template ID',0),(514117,14282,'is','',0),(514118,14282,'dr','Ù†Ø§Ù… Ù†ÙˆØ´ØªØ§Ø± Ø¶Ø§Ù…Ù†',0),(514119,14282,'pr','Ù†Ø§Ù… Ù†ÙˆØ´ØªØ§Ø± Ø¶Ø§Ù…Ù†',0),(514120,14282,'tr','GarantÃ¶r belge adÄ±',0),(514121,14282,'pl','Nazwa dokumentu gwaranta',0),(514122,14282,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð½Ð° Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð°',0),(514123,14282,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ Ø¶Ø§Ù…Ù† Ú©Ø§ Ù†Ø§Ù…',0),(514124,14282,'sr','ÐÐ°Ð·Ð¸Ð² Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð°',0),(514125,14282,'vi','Báº£o lÃ£nh tÃ i liá»‡u tÃªn',0),(514126,14282,'af','Borg dokument naam',0),(514127,14282,'ro','Numele de Document garant',0),(514128,14282,'et','KÃ¤endaja dokumendi nimi',0),(514129,14282,'si','Ime dokumenta garant',0),(514130,14282,'ba','Nama dokumen penjamin',0),(514131,14282,'nl','De naam van het Document van de borg',0),(514132,14282,'fi','Asiakirjan nimen',0),(514133,14282,'no','Garantist navn',0),(514134,14282,'da','Garant dokumentnavnet',0),(514135,14282,'ko','ë³´ì¦ì¸ ë¬¸ì„œ ì´ë¦„',0),(514136,14282,'he','×©× ×”×ž×¡×ž×š ×¢×¨×‘',0),(514137,14282,'el','Î•Î³Î³Ï…Î·Ï„Î®Ï‚ ÏŒÎ½Î¿Î¼Î± ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï…',0),(514138,14282,'zh','æ‹…ä¿äººæ–‡ä»¶åç§°',0),(514139,14282,'sv','Garant dokumentnamn',0),(514140,14282,'it','Nome documento garante',0),(514141,14282,'tl','',0),(514142,14282,'th','à¸Šà¸·à¹ˆà¸­à¹€à¸­à¸à¸ªà¸²à¸£à¸œà¸¹à¹‰à¸„à¹‰à¸³à¸›à¸£à¸°à¸à¸±à¸™',0),(514143,14282,'hi','à¤—à¤¾à¤°à¤‚à¤Ÿà¤° à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤•à¤¾ à¤¨à¤¾à¤®',0),(514144,14282,'ms','Nama dokumen penjamin',0),(514145,14282,'ar','Ø§Ø³Ù… Ø§Ù„ÙˆØ«ÙŠÙ‚Ø© Ø§Ù„Ø¶Ø§Ù…Ù†',0),(514146,14282,'fr','Nom du Document garant',0),(514147,14282,'jp','é€£å¸¯ä¿è¨¼äººãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆå',0),(514148,14282,'pt','Nome do documento garante',0),(514149,14282,'ru','Ð˜Ð¼Ñ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð³Ð°Ñ€Ð°Ð½Ñ‚',0),(514150,14282,'es','Nombre del documento garante',0),(514151,14282,'de','Garant-Dokumentname',0),(514152,14282,'en','Guarantor Document Name',0),(514153,14283,'is','',0),(514154,14283,'dr','Ø¶Ø§Ù…Ù† Ù‚Ø§Ù„Ø¨ Ø´Ù†Ø§Ø³Ù‡',0),(514155,14283,'pr','Ø¶Ø§Ù…Ù† Ù‚Ø§Ù„Ø¨ Ø´Ù†Ø§Ø³Ù‡',0),(514156,14283,'tr','GarantÃ¶r ÅŸablonu kimliÄŸi',0),(514157,14283,'pl','Gwarant szablon ID',0),(514158,14283,'bg','Ð˜Ð” Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð·Ð° Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð°',0),(514159,14283,'ur','Ø¶Ø§Ù…Ù† Ø³Ø§Ù†Ú†Ø§ Ø´Ù†Ø§Ø®Øª',0),(514160,14283,'sr','Ð˜Ð” Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ° Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð°',0),(514161,14283,'vi','Báº£o lÃ£nh máº«u ID',0),(514162,14283,'af','Borg sjabloon ID',0),(514163,14283,'ro','Garant ÅŸablon ID',0),(514164,14283,'et','KÃ¤endaja malli ID',0),(514165,14283,'si','ID predloge garant',0),(514166,14283,'ba','Penjamin Template ID',0),(514167,14283,'nl','Borg sjabloon ID',0),(514168,14283,'fi','Takaajan mallin tunnus',0),(514169,14283,'no','Garantist mal-ID',0),(514170,14283,'da','Garant skabelon-ID',0),(514171,14283,'ko','ë³´ì¦ì¸ ì„œì‹ íŒŒì¼ ID',0),(514172,14283,'he','×ž×–×”×” ×ª×‘× ×™×ª ×¢×¨×‘',0),(514173,14283,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï… ÎµÎ³Î³Ï…Î·Ï„Î®',0),(514174,14283,'zh','æ‹…ä¿äººæ¨¡æ¿ ID',0),(514175,14283,'sv','Garant mall-ID',0),(514176,14283,'it','ID modello garante',0),(514177,14283,'tl','',0),(514178,14283,'th','à¸£à¸«à¸±à¸ªà¹€à¸—à¹‡à¸¡à¹€à¸žà¸¥à¸œà¸¹à¹‰à¸„à¹‰à¸³à¸›à¸£à¸°à¸à¸±à¸™',0),(514179,14283,'hi','à¤—à¤¾à¤°à¤‚à¤Ÿà¤° à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ ID',0),(514180,14283,'ms','Penjamin Template ID',0),(514181,14283,'ar','Ù…Ø¹Ø±Ù Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¶Ø§Ù…Ù†',0),(514182,14283,'fr','ID de modÃ¨le de garant',0),(514183,14283,'jp','ä¿è¨¼ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ ID',0),(514184,14283,'pt','Fiador modelo ID',0),(514185,14283,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÑˆÐ°Ð±Ð»Ð¾Ð½Ð° Ð³Ð°Ñ€Ð°Ð½Ñ‚',0),(514186,14283,'es','Garante plantilla ID',0),(514187,14283,'de','Garant-Vorlagen-ID',0),(514188,14283,'en','Guarantor Template ID',0),(514189,14284,'is','',0),(514190,14284,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ù‚Ø§Ù„Ø¨ Ø´Ù†Ø§Ø³Ù‡ - Ø§Ù…Ø¶Ø§Ø¡ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† 4',0),(514191,14284,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ù‚Ø§Ù„Ø¨ Ø´Ù†Ø§Ø³Ù‡ - Ø§Ù…Ø¶Ø§Ø¡ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† 4',0),(514192,14284,'tr','Åžablon kimliÄŸi - 4 imzalayanlarÄ±n kira',0),(514193,14284,'pl','DzierÅ¼awy szablon ID - 4 osoby podpisujÄ…ce',0),(514194,14284,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð˜Ð” Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ - 4 Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ñ‰Ð¸',0),(514195,14284,'ur','Ø³Ø§Ù†Ú†Ø§ ID - 4 Ú©Ø±Ù†Û’ ÙˆØ§Ù„ÙˆÚº Ù„ÛŒØ²',0),(514196,14284,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð˜Ð” Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ° - 4 Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ½Ð¸ÐºÐ°',0),(514197,14284,'vi','Cho thuÃª máº«u ID - 4 ngÆ°á»i kÃ½',0),(514198,14284,'af','Huur sjabloon ID - 4 Signers',0),(514199,14284,'ro','Leasing ID ÅŸablon - 4 semnatarii',0),(514200,14284,'et','Liisi malli ID - 4 allkirjastaja',0),(514201,14284,'si','Zakup ID predloge - 4 podpisniki',0),(514202,14284,'ba','Sewa Template ID - penandatangan 4',0),(514203,14284,'nl','Lease sjabloon ID - 4 ondertekenaars',0),(514204,14284,'fi','Vuokrata mallin tunnus - 4 allekirjoittajia',0),(514205,14284,'no','Lease mal-ID - 4 signatarer',0),(514206,14284,'da','Lease skabelon-ID - 4 underskrivere',0),(514207,14284,'ko','ìž„ëŒ€ í…œí”Œë¦¿ ID-4 ì„œëª…ìž',0),(514208,14284,'he','×©×›×™×¨×•×ª ×ž×–×”×” ×ª×‘× ×™×ª - 4 ×”×—×•×ª×ž×™×',0),(514209,14284,'el','ÎœÎ¯ÏƒÎ¸Ï‰ÏƒÎ· Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï… - 4 Ï…Ï€Î¿Î³ÏÎ¬Ï†Î¿Î½Ï„ÎµÏ‚',0),(514210,14284,'zh','ç§Ÿèµæ¨¡æ¿ ID-4 ç­¾å',0),(514211,14284,'sv','Leasa mall-ID - 4 undertecknarna',0),(514212,14284,'it','Locazione modello ID - 4 firmatari',0),(514213,14284,'tl','',0),(514214,14284,'th','à¹€à¸Šà¹ˆà¸²à¸£à¸«à¸±à¸ªà¹€à¸—à¹‡à¸¡à¹€à¸žà¸¥à¸• - 4 à¸Šà¸·à¹ˆà¸­',0),(514215,14284,'hi','à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ ID - 4 à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(514216,14284,'ms','Pajakan Template ID - 4 penandatangan',0),(514217,14284,'ar','Ø¥ÙŠØ¬Ø§Ø± Ù‚Ø§Ù„Ø¨ Ù…Ø¹Ø±Ù-Ø§Ù„Ù…ÙˆÙ‚Ø¹ÙŠÙ† 4',0),(514218,14284,'fr','Location modÃ¨le ID - 4 signataires',0),(514219,14284,'jp','ãƒªãƒ¼ã‚¹ã®ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ ID - 4 ç½²å',0),(514220,14284,'pt','LocaÃ§Ã£o modelo ID - 4 signatÃ¡rios',0),(514221,14284,'ru','ÐÑ€ÐµÐ½Ð´Ð° ID ÑˆÐ°Ð±Ð»Ð¾Ð½Ð° - 4 Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ñ‚Ð¾Ð²',0),(514222,14284,'es','Arriendo plantilla ID - 4 firmantes',0),(514223,14284,'de','Leasing Vorlage ID - 4 Unterzeichner',0),(514224,14284,'en','Lease Template ID - 4 Signers',0),(514225,14285,'is','',0),(514226,14285,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ',0),(514227,14285,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ',0),(514228,14285,'tr','Evde beslenen hayvan aylÄ±k Ã¼cret',0),(514229,14285,'pl','MiesiÄ™czna opÅ‚ata za zwierzÄ™',0),(514230,14285,'bg','ÐœÐµÑÐµÑ‡Ð½Ð° Ñ‚Ð°ÐºÑÐ° Ð·Ð° Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð»ÑŽÐ±Ð¸Ð¼Ñ†Ð¸',0),(514231,14285,'ur','Ù…Ø§ÛØ§Ù†Û Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ±ÙˆÚº Ú©ÛŒ ÙÛŒØ³',0),(514232,14285,'sr','ÐœÐµÑÐµÑ‡Ð½Ð° Ð½Ð°ÐºÐ½Ð°Ð´Ð° Ð·Ð° Ñ™ÑƒÐ±Ð¸Ð¼Ñ†Ð°',0),(514233,14285,'vi','Váº­t nuÃ´i phÃ­ hÃ ng thÃ¡ng',0),(514234,14285,'af','Troeteldier maandelikse fooi',0),(514235,14285,'ro','Taxa lunara de animal de casÄƒ',0),(514236,14285,'et','Lemmikloomade kuutasu',0),(514237,14285,'si','MeseÄno nadomestilo za hiÅ¡ne',0),(514238,14285,'ba','Bulanan hewan peliharaan',0),(514239,14285,'nl','Huisdier maandbedrag',0),(514240,14285,'fi','HellitellÃ¤ kuukausimaksu',0),(514241,14285,'no','Pet mÃ¥nedspris',0),(514242,14285,'da','MÃ¥nedligt gebyr for kÃ¦ledyr',0),(514243,14285,'ko','ë§¤ì›” ì• ì™„ ë™ë¬¼ ìš”ê¸ˆ',0),(514244,14285,'he','×ª×©×œ×•× ×—×•×“×©×™ ×œ×—×™×•×ª ×ž×—×ž×“',0),(514245,14285,'el','ÎœÎ·Î½Î¹Î±Î¯Î¿ Ï€Î¬Î³Î¹Î¿ ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Ï‰Î½ Î¶ÏŽÏ‰Î½',0),(514246,14285,'zh','å® ç‰©æœˆç§Ÿè´¹',0),(514247,14285,'sv','SÃ¤llskapsdjur mÃ¥nadsavgift',0),(514248,14285,'it','Supplemento per animali domestici mensile',0),(514249,14285,'tl','',0),(514250,14285,'th','à¹€à¸”à¸·à¸­à¸™à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(514251,14285,'hi','à¤®à¤¾à¤¸à¤¿à¤• à¤¶à¥à¤²à¥à¤• à¤•à¥‡ à¤ªà¤¾à¤²à¤¤à¥‚',0),(514252,14285,'ms','Yuran bulanan haiwan kesayangan',0),(514253,14285,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø§Ù„Ø´Ù‡Ø±ÙŠ',0),(514254,14285,'fr','MensualitÃ© pour animaux de compagnie',0),(514255,14285,'jp','æ¯Žæœˆã®ãƒšãƒƒãƒˆæ–™é‡‘',0),(514256,14285,'pt','Mensalidade do animal de estimaÃ§Ã£o',0),(514257,14285,'ru','Ð•Ð¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð° ÐŸÐ­Ð¢',0),(514258,14285,'es','Cuota mensual del animal domÃ©stico',0),(514259,14285,'de','Haustier MonatsgebÃ¼hr',0),(514260,14285,'en','Monthly Pet Fee',0),(514261,14286,'is','',0),(514262,14286,'dr','Ù…Ø§Ù‡ Ù‚Ø¨Ù„ Ø§Ø² Ø­Ø±Ú©Øª Ø¯Ø± ØªØ§Ø±ÛŒØ® Ø§ÙˆÙ„ Ø¹Ù„Øª ÙØ§Ú©ØªÙˆØ±',0),(514263,14286,'pr','Ù…Ø§Ù‡ Ù‚Ø¨Ù„ Ø§Ø² Ø­Ø±Ú©Øª Ø¯Ø± ØªØ§Ø±ÛŒØ® Ø§ÙˆÙ„ Ø¹Ù„Øª ÙØ§Ú©ØªÙˆØ±',0),(514264,14286,'tr','TaÅŸÄ±nma tarihinden Ã¶nceki ay Ã¶nce son fatura',0),(514265,14286,'pl','MiesiÄ™cy przed datÄ… Move w pierwszej faktury ze wzglÄ™du',0),(514266,14286,'bg','ÐœÐµÑÐµÑ†Ð° Ð¿Ñ€ÐµÐ´Ð¸ Ð´Ð²Ð¸Ð¶ÐµÐ½Ð¸Ðµ Ð² Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð¿ÑŠÑ€Ð²Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ðµ Due',0),(514267,14286,'ur','Ù…Ù†ØªÙ‚Ù„ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø³Û’ Ù¾ÛÙ„Û’ Ù…Ø§Û Ù¾ÛÙ„Û’ Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(514268,14286,'sr','ÐŸÑ€Ð²Ð¾ Ð¼ÐµÑÐµÑ†Ð¸ Ð¿Ñ€Ðµ Ð¿Ð¾Ð¼ÐµÑ€Ð¸Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(514269,14286,'vi','ThÃ¡ng trÆ°á»›c khi di chuyá»ƒn trong ngÃ y Ä‘áº§u tiÃªn hoÃ¡ Ä‘Æ¡n do',0),(514270,14286,'af','Maande voor datum skuif-in eerste faktuur betaalbaar',0),(514271,14286,'ro','Luni Ã®nainte de data de mutare-in prima factura scadentÄƒ',0),(514272,14286,'et','Kuud enne liikuma-in esimese arve otse',0),(514273,14286,'si','Mesecev pred datumom premik v prvi raÄun zaradi',0),(514274,14286,'ba','Bulan sebelum tanggal pindah masuk pertama faktur jatuh tempo',0),(514275,14286,'nl','Maanden vÃ³Ã³r de bewegen-in eerste factuur verschuldigde',0),(514276,14286,'fi','Kuukautta ennen muuttopÃ¤ivÃ¤Ã¤ ensimmÃ¤isen laskun erÃ¤pÃ¤ivÃ¤',0),(514277,14286,'no','MÃ¥neder fÃ¸r flytte inn dato fÃ¸rste faktura grunn',0),(514278,14286,'da','MÃ¥neder fÃ¸r flytte ind fÃ¸rst fakturere Due',0),(514279,14286,'ko','ìž…ì£¼ ë‚ ì§œ ì „ì— ê°œì›” ë¨¼ì € ì¸í•´ ì†¡ìž¥',0),(514280,14286,'he','×—×•×“×©×™× ×œ×¤× ×™ ×ª××¨×™×š ×”×ž×¢×‘×¨ ×§×•×“× ×—×©×‘×•× ×™×ª ×‘×©×œ',0),(514281,14286,'el','ÎœÎ®Î½ÎµÏ‚ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ ÎºÎ¯Î½Î·ÏƒÎ·-ÏƒÏ„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ Ï€ÏÏŽÏ„Î± Î´ÎµÏŒÎ½Ï„Ï‰Ï‚',0),(514282,14286,'zh','å‡ ä¸ªæœˆå‰æ¬å…¥æ—¥æœŸé¦–æ¬¡å‘ç¥¨åˆ°æœŸ',0),(514283,14286,'sv','MÃ¥nader fÃ¶re inflyttning fÃ¶rsta faktura fÃ¶rfaller',0),(514284,14286,'it','Mesi prima di spostare in data fattura prima scadenza',0),(514285,14286,'tl','',0),(514286,14286,'th','à¹€à¸”à¸·à¸­à¸™à¸à¹ˆà¸­à¸™à¸—à¸µà¹ˆà¸ˆà¸°à¸¢à¹‰à¸²à¸¢à¹ƒà¸™à¸§à¸±à¸™à¸à¹ˆà¸­à¸™à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”',0),(514287,14286,'hi','à¤®à¤¹à¥€à¤¨à¥‹à¤‚ à¤ªà¤¹à¤²à¥‡ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤šà¤¾à¤² à¤®à¥‡à¤‚ à¤ªà¤¹à¤²à¥€ à¤¬à¤¾à¤° à¤¦à¥‡à¤¯ à¤šà¤¾à¤²à¤¾à¤¨',0),(514288,14286,'ms','Bulan sebelum tarikh pemindahan masuk pertama invois perlu dibuat',0),(514289,14286,'ar','Ø£Ø´Ù‡Ø± Ù‚Ø¨Ù„ Ø§Ù„ØªØ­Ø±Ùƒ ÙÙŠ ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø£ÙˆÙ„Ù‰ Ø§Ù„ÙˆØ§Ø¬Ø¨',0),(514290,14286,'fr','Mois avant la Date de se dÃ©placer en premiÃ¨re facture Due',0),(514291,14286,'jp','ç§»å‹•æ—¥ãƒ¶æœˆå‰ã«ã€æœ€åˆè«‹æ±‚æ›¸ã®æœŸæ—¥',0),(514292,14286,'pt','Meses antes da data de mover-nos primeiro fatura devida',0),(514293,14286,'ru','ÐœÐµÑÑÑ†ÐµÐ² Ð´Ð¾ Ð´Ð°Ñ‚Ñ‹, Move Ð² Ð¿ÐµÑ€Ð²Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ Ð´Ð¾Ð»Ð¶Ð½Ñ‹Ð¼ Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð¼',0),(514294,14286,'es','Meses antes de la fecha de mudanza primera facturaciÃ³n debida',0),(514295,14286,'de','Monate vor Einzugsdatum Rechnung zuerst fÃ¤llig',0),(514296,14286,'en','Months Before Move-in Date First Invoice Due',0),(514297,14287,'is','',0),(514298,14287,'dr','Ù†Ø§Ù… Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ Ø³Ù†Ø¯',0),(514299,14287,'pr','Ù†Ø§Ù… Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ Ø³Ù†Ø¯',0),(514300,14287,'tr','Evde beslenen hayvan belge adÄ±',0),(514301,14287,'pl','Nazwa dokumentu zwierzÄ™',0),(514302,14287,'bg','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð»ÑŽÐ±Ð¸Ð¼Ñ†Ð¸ Ð¸Ð¼Ðµ',0),(514303,14287,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©Ø§ Ù†Ø§Ù…',0),(514304,14287,'sr','Ð˜Ð¼Ðµ Ñ™ÑƒÐ±Ð¸Ð¼Ñ†Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(514305,14287,'vi','Váº­t nuÃ´i tÃ i liá»‡u tÃªn',0),(514306,14287,'af','Troeteldier dokument naam',0),(514307,14287,'ro','Numele documentului pentru animale de companie',0),(514308,14287,'et','Lemmikloomade dokumendi nimi',0),(514309,14287,'si','Ime jjeza dokumenta',0),(514310,14287,'ba','Nama hewan peliharaan dokumen',0),(514311,14287,'nl','Huisdier documentnaam',0),(514312,14287,'fi','HellitellÃ¤ asiakirjan nimi',0),(514313,14287,'no','Navn pÃ¥ kjÃ¦ledyr',0),(514314,14287,'da','Pet dokumentnavnet',0),(514315,14287,'ko','ì• ì™„ ë™ë¬¼ ë¬¸ì„œ ì´ë¦„',0),(514316,14287,'he','×©× ×”×ž×¡×ž×š ×œ×—×™×•×ª ×ž×—×ž×“',0),(514317,14287,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Ï„Î¿Ï… ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ Î¶ÏŽÎ¿ ÏŒÎ½Î¿Î¼Î±',0),(514318,14287,'zh','å® ç‰©çš„æ–‡æ¡£çš„åç§°',0),(514319,14287,'sv','SÃ¤llskapsdjur dokumentnamn',0),(514320,14287,'it','Nome del documento dell\'animale domestico',0),(514321,14287,'tl','',0),(514322,14287,'th','à¸Šà¸·à¹ˆà¸­à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡à¹€à¸­à¸à¸ªà¸²à¸£',0),(514323,14287,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤•à¤¾ à¤¨à¤¾à¤®',0),(514324,14287,'ms','Nama dokumen haiwan kesayangan',0),(514325,14287,'ar','Ø§Ø³Ù… Ø§Ù„ÙˆØ«ÙŠÙ‚Ø© Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ©',0),(514326,14287,'fr','Nom du Document pour animaux de compagnie',0),(514327,14287,'jp','ãƒšãƒƒãƒˆã®ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆå',0),(514328,14287,'pt','Nome do documento do animal de estimaÃ§Ã£o',0),(514329,14287,'ru','Ð˜Ð¼Ñ Ð¿Ð¸Ñ‚Ð¾Ð¼Ñ†Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(514330,14287,'es','Nombre del documento del animal domÃ©stico',0),(514331,14287,'de','Haustier Dokumentnamen',0),(514332,14287,'en','Pet Document Name',0),(514333,14288,'is','',0),(514334,14288,'dr','ÙƒØ¯ Ù‚Ø§Ù„Ø¨ Ù¾Øª',0),(514335,14288,'pr','ÙƒØ¯ Ù‚Ø§Ù„Ø¨ Ù¾Øª',0),(514336,14288,'tr','Evde beslenen hayvan ÅŸablonu kimliÄŸi',0),(514337,14288,'pl','PieÅ›ciÄ‡ szablon ID',0),(514338,14288,'bg','Ð˜Ð” Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð·Ð° Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð»ÑŽÐ±Ð¸Ð¼Ñ†Ð¸',0),(514339,14288,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ±ÙˆÚº Ú©Û’ Ø³Ø§Ù†Ú†Û’ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(514340,14288,'sr','Ð‰ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ð˜Ð” Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ°',0),(514341,14288,'vi','Váº­t nuÃ´i tiÃªu báº£n ID',0),(514342,14288,'af','Troeteldier sjabloon ID',0),(514343,14288,'ro','Animal de casÄƒ ÅŸablon ID',0),(514344,14288,'et','Lemmikloomade malli ID',0),(514345,14288,'si','Jjeza ID predloge',0),(514346,14288,'ba','Hewan peliharaan Template ID',0),(514347,14288,'nl','Huisdier sjabloon ID',0),(514348,14288,'fi','HellitellÃ¤ mallin tunnus',0),(514349,14288,'no','Pet mal-ID',0),(514350,14288,'da','Pet skabelon-ID',0),(514351,14288,'ko','ì• ì™„ ë™ë¬¼ ì„œì‹ íŒŒì¼ ID',0),(514352,14288,'he','×ž×–×”×” ×ª×‘× ×™×ª ×œ×—×™×•×ª ×ž×—×ž×“',0),(514353,14288,'el','ÎšÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ Î¶ÏŽÎ¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï…',0),(514354,14288,'zh','å® ç‰©æ¨¡æ¿ ID',0),(514355,14288,'sv','Mall-ID fÃ¶r sÃ¤llskapsdjur',0),(514356,14288,'it','ID modello domestico',0),(514357,14288,'tl','',0),(514358,14288,'th','à¸£à¸«à¸±à¸ªà¹€à¸—à¹‡à¸¡à¹€à¸žà¸¥à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(514359,14288,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ ID',0),(514360,14288,'ms','Haiwan peliharaan Template ID',0),(514361,14288,'ar','Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ù‚Ø§Ù„Ø¨ Ù…Ø¹Ø±Ù',0),(514362,14288,'fr','ID de modÃ¨le pour animaux de compagnie',0),(514363,14288,'jp','ãƒšãƒƒãƒˆ ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ ID',0),(514364,14288,'pt','Modelo de identificaÃ§Ã£o do animal de estimaÃ§Ã£o',0),(514365,14288,'ru','ÐŸÐ­Ð¢ ID ÑˆÐ°Ð±Ð»Ð¾Ð½Ð°',0),(514366,14288,'es','ID de plantilla del animal domÃ©stico',0),(514367,14288,'de','Haustier Vorlagen-ID',0),(514368,14288,'en','Pet Template ID',0),(514369,14289,'is','',0),(514370,14289,'dr','Ù†Ø§Ù… Ø³Ù†Ø¯ ÙØ³Ø®',0),(514371,14289,'pr','Ù†Ø§Ù… Ø³Ù†Ø¯ ÙØ³Ø®',0),(514372,14289,'tr','AyrÄ±lma belge adÄ±',0),(514373,14289,'pl','Nazwa dokumentu wypowiedzenia',0),(514374,14289,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð·Ð° Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÑÐ²Ð°Ð½Ðµ',0),(514375,14289,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ Ù…Ù†Ø³ÙˆØ®ÛŒ Ú©Ø§ Ù†Ø§Ù…',0),(514376,14289,'sr','ÐÐ°Ð·Ð¸Ð² Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð° Ð·Ð° Ð¿Ñ€ÐµÐºÐ¸Ð´ Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð¾Ð´Ð½Ð¾ÑÐ°',0),(514377,14289,'vi','Cháº¥m dá»©t tÃ i liá»‡u tÃªn',0),(514378,14289,'af','BeÃ«indiging dokument naam',0),(514379,14289,'ro','Numele de Document rezilierea',0),(514380,14289,'et','LÃµpetamise dokumendi nimi',0),(514381,14289,'si','Ime dokumenta prenehanje',0),(514382,14289,'ba','Penghentian nama dokumen',0),(514383,14289,'nl','De naam van het Document van de beÃ«indiging',0),(514384,14289,'fi','Irtisanominen asiakirjan nimi',0),(514385,14289,'no','Navn pÃ¥ avslutning',0),(514386,14289,'da','Opsigelse dokumentnavnet',0),(514387,14289,'ko','ì¢…ë£Œ ë¬¸ì„œ ì´ë¦„',0),(514388,14289,'he','×©× ×”×ž×¡×ž×š ×¡×™×•×',0),(514389,14289,'el','ÎŒÎ½Î¿Î¼Î± ÎµÎ³Î³ÏÎ¬Ï†Î¿Ï… ÎºÎ±Ï„Î±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(514390,14289,'zh','ç»ˆæ­¢æ–‡æ¡£åç§°',0),(514391,14289,'sv','UppsÃ¤gning dokumentnamn',0),(514392,14289,'it','Nome del documento di terminazione',0),(514393,14289,'tl','',0),(514394,14289,'th','à¸Šà¸·à¹ˆà¸­à¹€à¸­à¸à¸ªà¸²à¸£à¸ˆà¹‰à¸²à¸‡',0),(514395,14289,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤•à¥‡ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤•à¤¾ à¤¨à¤¾à¤®',0),(514396,14289,'ms','Nama dokumen penamatan',0),(514397,14289,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø³ØªÙ†Ø¯ Ø¥Ù†Ù‡Ø§Ø¡',0),(514398,14289,'fr','Nom de Document de rÃ©siliation',0),(514399,14289,'jp','çµ‚äº†ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆå',0),(514400,14289,'pt','Nome do documento de rescisÃ£o',0),(514401,14289,'ru','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ð¸Ð¼Ñ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°',0),(514402,14289,'es','Nombre del documento de terminaciÃ³n',0),(514403,14289,'de','KÃ¼ndigung Dokumentnamen',0),(514404,14289,'en','Termination Document Name',0),(514405,14290,'is','',0),(514406,14290,'dr','Ø®ØªÙ… Ù‚Ø§Ù„Ø¨ Ø´Ù†Ø§Ø³Ù‡ - Ø§Ù…Ø¶Ø§Ø¡ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† 2',0),(514407,14290,'pr','Ø®ØªÙ… Ù‚Ø§Ù„Ø¨ Ø´Ù†Ø§Ø³Ù‡ - Ø§Ù…Ø¶Ø§Ø¡ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† 2',0),(514408,14290,'tr','Fesih ÅŸablon kimliÄŸi - 2 imzalayanlarÄ±n',0),(514409,14290,'pl','ZakoÅ„czenie szablon ID - 2 osoby podpisujÄ…ce',0),(514410,14290,'bg','Ð˜Ð” Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð·Ð° Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÑÐ²Ð°Ð½Ðµ - 2 Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ñ‰Ð¸',0),(514411,14290,'ur','Ù…Ù†Ø³ÙˆØ®ÛŒ Ø³Ø§Ù†Ú†Ø§ ID - 2 Ú©Ø±Ù†Û’ ÙˆØ§Ù„ÙˆÚº',0),(514412,14290,'sr','Ð˜Ð” Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ° Ð·Ð° Ð¿Ñ€ÐµÐºÐ¸Ð´ Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð¾Ð´Ð½Ð¾ÑÐ° - 2 Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ½Ð¸ÐºÐ°',0),(514413,14290,'vi','Cháº¥m dá»©t máº«u ID - 2 ngÆ°á»i kÃ½',0),(514414,14290,'af','BeÃ«indiging sjabloon ID - 2 Signers',0),(514415,14290,'ro','ÃŽncetarea ÅŸablon ID - 2 semnatarii',0),(514416,14290,'et','LÃµpetamise malli ID - 2 allkirjastajad',0),(514417,14290,'si','Prenehanje ID predloge - 2 podpisniki',0),(514418,14290,'ba','Penghentian Template ID - penandatangan 2',0),(514419,14290,'nl','BeÃ«indiging sjabloon ID - 2 ondertekenaars',0),(514420,14290,'fi','Irtisanominen mallin tunnus - 2 allekirjoittajia',0),(514421,14290,'no','Oppsigelse mal-ID - 2 signatarer',0),(514422,14290,'da','Opsigelse skabelon-ID - 2 underskrivere',0),(514423,14290,'ko','í•´ì§€ ì„œì‹ íŒŒì¼ ID-2 ì„œëª…ìž',0),(514424,14290,'he','×¡×™×•× ×ª×‘× ×™×ª ×ž×–×”×” - ×”×—×•×ª×ž×™× 2',0),(514425,14290,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï… ÎºÎ±Ï„Î±Î³Î³ÎµÎ»Î¯Î± - 2 Ï…Ï€Î¿Î³ÏÎ¬Ï†Î¿Î½Ï„ÎµÏ‚',0),(514426,14290,'zh','ç»ˆæ­¢æ¨¡æ¿ ID-2 ç­¾å',0),(514427,14290,'sv','UppsÃ¤gning mall-ID - 2 undertecknarna',0),(514428,14290,'it','ID modello cessazione - 2 firmatari',0),(514429,14290,'tl','',0),(514430,14290,'th','à¸£à¸«à¸±à¸ªà¹€à¸—à¹‡à¸¡à¹€à¸žà¸¥à¸ªà¸´à¹‰à¸™ - 2 à¸Šà¸·à¹ˆà¸­',0),(514431,14290,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ ID - 2 à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤•à¤°à¥à¤¤à¤¾',0),(514432,14290,'ms','Penamatan Template ID - penandatangan 2',0),(514433,14290,'ar','Ø¥Ù†Ù‡Ø§Ø¡ Ù‚Ø§Ù„Ø¨ Ù…Ø¹Ø±Ù-Ø§Ù„Ù…ÙˆÙ‚Ø¹ÙŠÙ† 2',0),(514434,14290,'fr','ID de modÃ¨le de rÃ©siliation - 2 signataires',0),(514435,14290,'jp','çµ‚äº†ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ ID - 2 ç½²åè€…',0),(514436,14290,'pt','TerminaÃ§Ã£o modelo ID - 2 signatÃ¡rios',0),(514437,14290,'ru','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ ÑˆÐ°Ð±Ð»Ð¾Ð½ ID - 2 Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ñ‚Ð¾Ð²',0),(514438,14290,'es','TerminaciÃ³n plantilla ID - 2 firmantes',0),(514439,14290,'de','KÃ¼ndigung Vorlage ID - 2 Unterzeichner',0),(514440,14290,'en','Termination Template ID - 2 Signers',0),(514441,14291,'is','',0),(514442,14291,'dr','Ø®ØªÙ… Ù‚Ø§Ù„Ø¨ Ø´Ù†Ø§Ø³Ù‡ - Ø§Ù…Ø¶Ø§Ø¡ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† 3',0),(514443,14291,'pr','Ø®ØªÙ… Ù‚Ø§Ù„Ø¨ Ø´Ù†Ø§Ø³Ù‡ - Ø§Ù…Ø¶Ø§Ø¡ Ú©Ù†Ù†Ø¯Ú¯Ø§Ù† 3',0),(514444,14291,'tr','Fesih ÅŸablon kimliÄŸi - 3 imzalayanlarÄ±n',0),(514445,14291,'pl','ZakoÅ„czenie szablon ID - 3 osoby podpisujÄ…ce',0),(514446,14291,'bg','Ð˜Ð” Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð·Ð° Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÑÐ²Ð°Ð½Ðµ - 3 Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ñ‰Ð¸',0),(514447,14291,'ur','Ù…Ù†Ø³ÙˆØ®ÛŒ Ø³Ø§Ù†Ú†Ø§ ID - 3 Ú©Ø±Ù†Û’ ÙˆØ§Ù„ÙˆÚº',0),(514448,14291,'sr','Ð˜Ð” Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ° Ð·Ð° Ð¿Ñ€ÐµÐºÐ¸Ð´ Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð¾Ð´Ð½Ð¾ÑÐ° - 3 Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ½Ð¸ÐºÐ°',0),(514449,14291,'vi','Cháº¥m dá»©t máº«u ID - 3 ngÆ°á»i kÃ½',0),(514450,14291,'af','BeÃ«indiging sjabloon ID - 3 Signers',0),(514451,14291,'ro','ÃŽncetarea ÅŸablon ID - 3 semnatarii',0),(514452,14291,'et','LÃµpetamise malli ID - 3 allkirjastajad',0),(514453,14291,'si','Prenehanje ID predloge - 3 podpisniki',0),(514454,14291,'ba','Penghentian Template ID - penandatangan 3',0),(514455,14291,'nl','BeÃ«indiging sjabloon ID - 3 ondertekenaars',0),(514456,14291,'fi','Irtisanominen mallin tunnus - 3 allekirjoittajia',0),(514457,14291,'no','Oppsigelse mal-ID - 3 signatarer',0),(514458,14291,'da','Opsigelse skabelon-ID - 3 underskrivere',0),(514459,14291,'ko','í•´ì§€ ì„œì‹ íŒŒì¼ ID-3 ì„œëª…ìž',0),(514460,14291,'he','×¡×™×•× ×ª×‘× ×™×ª ×ž×–×”×” - 3 ×”×—×•×ª×ž×™×',0),(514461,14291,'el','Î›Î®Î¾Î· Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï… - 3 Ï…Ï€Î¿Î³ÏÎ¬Ï†Î¿Î½Ï„ÎµÏ‚',0),(514462,14291,'zh','ç»ˆæ­¢æ¨¡æ¿ ID-3 ç­¾å',0),(514463,14291,'sv','UppsÃ¤gning mall-ID - 3 undertecknarna',0),(514464,14291,'it','ID modello cessazione - 3 firmatari',0),(514465,14291,'tl','',0),(514466,14291,'th','à¸£à¸«à¸±à¸ªà¹€à¸—à¹‡à¸¡à¹€à¸žà¸¥à¸ªà¸´à¹‰à¸™ - 3 à¸Šà¸·à¹ˆà¸­',0),(514467,14291,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ ID - 3 à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤•à¤°à¥à¤¤à¤¾',0),(514468,14291,'ms','Penamatan Template ID - 3 penandatangan',0),(514469,14291,'ar','Ø¥Ù†Ù‡Ø§Ø¡ Ù‚Ø§Ù„Ø¨ Ù…Ø¹Ø±Ù-Ø§Ù„Ù…ÙˆÙ‚Ø¹ÙŠÙ† 3',0),(514470,14291,'fr','ID de modÃ¨le de rÃ©siliation - 3 signataires',0),(514471,14291,'jp','çµ‚äº†ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ ID - 3 ç½²å',0),(514472,14291,'pt','TerminaÃ§Ã£o modelo ID - 3 signatÃ¡rios',0),(514473,14291,'ru','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ ÑˆÐ°Ð±Ð»Ð¾Ð½ ID - 3 Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð²ÑˆÐ¸Ñ…',0),(514474,14291,'es','TerminaciÃ³n plantilla ID - 3 firmantes',0),(514475,14291,'de','KÃ¼ndigung Vorlage ID - 3 Unterzeichner',0),(514476,14291,'en','Termination Template ID - 3 Signers',0),(514477,14292,'is','',0),(514478,14292,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÛŒØ¯ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ ØªÙ…Ø§Ù… Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¯Ø± ØªÙ…Ø§Ù… Ø´Ø±Ú©Øª Ù‡Ø§ÛŒ ØªØ³Øª Ú©Ù†ÛŒØ¯ØŸ',0),(514479,14292,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÛŒØ¯ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ ØªÙ…Ø§Ù… Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¯Ø± ØªÙ…Ø§Ù… Ø´Ø±Ú©Øª Ù‡Ø§ÛŒ ØªØ³Øª Ú©Ù†ÛŒØ¯ØŸ',0),(514480,14292,'tr','TÃ¼m kredi kartlarÄ± tÃ¼m ÅŸirketlerde test etmek istediÄŸinizden emin misiniz?',0),(514481,14292,'pl','Czy na pewno chcesz przetestowaÄ‡ wszystkie karty kredytowe we wszystkich spÃ³Å‚kach?',0),(514482,14292,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ñ‚ÐµÑÑ‚Ð²Ð°Ñ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸ Ð²ÑŠÐ² Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ñ„Ð¸Ñ€Ð¼Ð¸?',0),(514483,14292,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ØªÙ…Ø§Ù… Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±ÚˆØ² Ú©ÛŒ ØªÙ…Ø§Ù… Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ù…ÛŒÚº Ø¬Ø§Ù†Ú† Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(514484,14292,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ñ‚ÐµÑÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ ÑÐ²Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ñƒ ÑÐ²Ð¸Ð¼ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°Ð¼Ð°?',0),(514485,14292,'vi','Báº¡n cÃ³ cháº¯c báº¡n muá»‘n kiá»ƒm tra tháº» tÃ­n dá»¥ng táº¥t cáº£ trong táº¥t cáº£ cÃ¡c cÃ´ng ty?',0),(514486,14292,'af','Is jy seker jy wil alle kredietkaarte in alle maatskappye te toets?',0),(514487,14292,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ testeze toate cardurile de credit Ã®n toate companiile?',0),(514488,14292,'et','Kas kindlasti katsetada kÃµik krediitkaardid kÃµik ettevÃµtted?',0),(514489,14292,'si','Ali ste prepriÄani, da Å¾elite preizkusiti vse kreditne kartice v vseh druÅ¾bah?',0),(514490,14292,'ba','Apakah Anda yakin Anda ingin menguji semua kartu kredit di semua perusahaan?',0),(514491,14292,'nl','Weet u zeker dat u wilt testen van alle credit cards in alle bedrijven?',0),(514492,14292,'fi','Oletko varma, ettÃ¤ haluat testata kaikki luottokortit kaikissa yrityksissÃ¤?',0),(514493,14292,'no','Er du sikker pÃ¥ at du vil teste alle kredittkort i alle firmaer?',0),(514494,14292,'da','Er du sikker pÃ¥ du Ã¸nsker at teste alle kreditkort i alle selskaber?',0),(514495,14292,'ko','ë‹¹ì‹ ì€ ëª¨ë“  ê¸°ì—…ì— ëª¨ë“  ì‹ ìš© ì¹´ë“œë¥¼ í…ŒìŠ¤íŠ¸ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(514496,14292,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×‘×“×•×§ ×›×œ ×›×¨×˜×™×¡×™ ×”××©×¨××™ ×‘×›×œ ×”×—×‘×¨×•×ª?',0),(514497,14292,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¿ÎºÎ¹Î¼Î¬ÏƒÎµÏ„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚ ÏƒÎµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ ÎµÏ€Î¹Ï‡ÎµÎ¹ÏÎ®ÏƒÎµÎ¹Ï‚;',0),(514498,14292,'zh','ä½ ç¡®å®šä½ æƒ³è¦åœ¨æ‰€æœ‰å…¬å¸ä¸­æµ‹è¯•æ‰€æœ‰çš„ä¿¡ç”¨å¡ï¼Ÿ',0),(514499,14292,'sv','Ã„r du sÃ¤ker pÃ¥ att du vill testa alla kreditkort i alla fÃ¶retag?',0),(514500,14292,'it','Sei sicuro di che voler testare tutte le carte di credito in tutte le aziende?',0),(514501,14292,'tl','',0),(514502,14292,'th','à¸„à¸¸à¸“à¹à¸™à¹ˆà¹ƒà¸ˆà¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸—à¸”à¸ªà¸­à¸šà¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¹ƒà¸™à¸šà¸£à¸´à¸©à¸±à¸—à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(514503,14292,'hi','à¤•à¥à¤¯à¤¾ à¤µà¤¾à¤•à¤ˆ à¤†à¤ª à¤¸à¤­à¥€ à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¸à¤­à¥€ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¤¾ à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(514504,14292,'ms','Adakah anda pasti anda ingin menguji semua kad kredit di semua syarikat?',0),(514505,14292,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø§Ø®ØªØ¨Ø§Ø± Ø¬Ù…ÙŠØ¹ Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ÙÙŠ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø´Ø±ÙƒØ§ØªØŸ',0),(514506,14292,'fr','ÃŠtes-vous certain de que vouloir tester toutes les cartes de crÃ©dit dans toutes les sociÃ©tÃ©s ?',0),(514507,14292,'jp','ã™ã¹ã¦ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã™ã¹ã¦ã®ä¼æ¥­ã§ãƒ†ã‚¹ãƒˆã‚’ã—ã¦ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(514508,14292,'pt','Tem certeza que deseja testar todos os cartÃµes de crÃ©dito em todas as empresas?',0),(514509,14292,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð²ÑÐµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð²Ð¾ Ð²ÑÐµÑ… ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ…?',0),(514510,14292,'es','Â¿EstÃ¡ seguro que desea probar todas las tarjetas de crÃ©dito en todas las empresas?',0),(514511,14292,'de','Sind Sie sicher, dass Sie alle Kreditkarten in allen Unternehmen testen mÃ¶chten?',0),(514512,14292,'en','Are you sure you want to test all credit cards in all companies?',0),(514513,14293,'is','',0),(514514,14293,'dr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù†ØªØ§ÛŒØ¬ Ø¢Ø²Ù…ÙˆÙ† Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(514515,14293,'pr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù†ØªØ§ÛŒØ¬ Ø¢Ø²Ù…ÙˆÙ† Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(514516,14293,'tr','Kredi kartÄ± aylÄ±k Test sonuÃ§larÄ±',0),(514517,14293,'pl','Karta kredytowa miesiÄ™czne wyniki badaÅ„',0),(514518,14293,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¼ÐµÑÐµÑ‡Ð½Ð¸Ñ‚Ðµ Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸ Ð¾Ñ‚ Ñ‚ÐµÑÑ‚Ð¾Ð²ÐµÑ‚Ðµ',0),(514519,14293,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù…Ø§ÛØ§Ù†Û Ù¹ÛŒØ³Ù¹ Ú©Û’ Ù†ØªØ§Ø¦Ø¬',0),(514520,14293,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¸ Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ðµ Ñ‚ÐµÑÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(514521,14293,'vi','Káº¿t quáº£ kiá»ƒm tra tháº» tÃ­n dá»¥ng hÃ ng thÃ¡ng',0),(514522,14293,'af','Kredietkaart maandelikse toets resultate',0),(514523,14293,'ro','Card de credit lunar rezultatele testelor',0),(514524,14293,'et','Krediitkaardi igakuise testi tulemused',0),(514525,14293,'si','Kreditne kartice meseÄnih rezultatov preskusa',0),(514526,14293,'ba','Hasil tes bulanan kartu kredit',0),(514527,14293,'nl','Creditcard maandelijkse testresultaten',0),(514528,14293,'fi','Luottokortin kuukausittain testitulokset',0),(514529,14293,'no','Kredittkort mÃ¥nedlige testresultater',0),(514530,14293,'da','Kreditkort mÃ¥nedlige testresultater',0),(514531,14293,'ko','ì‹ ìš© ì¹´ë“œ ì›”ë³„ í…ŒìŠ¤íŠ¸ ê²°ê³¼',0),(514532,14293,'he','×ª×•×¦××•×ª ×”×‘×“×™×§×” ×—×•×“×©×™ ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(514533,14293,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Î¼Î·Î½Î¹Î±Î¯Î± Î±Ï€Î¿Ï„ÎµÎ»Î­ÏƒÎ¼Î±Ï„Î± Î´Î¿ÎºÎ¹Î¼ÏŽÎ½',0),(514534,14293,'zh','ä¿¡ç”¨å¡æ¯æœˆæµ‹è¯•ç»“æžœ',0),(514535,14293,'sv','Kreditkort mÃ¥natliga testresultat',0),(514536,14293,'it','Risultati Test mensili di carta di credito',0),(514537,14293,'tl','',0),(514538,14293,'th','à¸œà¸¥à¸à¸²à¸£à¸—à¸”à¸ªà¸­à¸šà¸£à¸²à¸¢à¹€à¸”à¸·à¸­à¸™à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(514539,14293,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤®à¤¾à¤¸à¤¿à¤• à¤ªà¤°à¥€à¤•à¥à¤·à¤¾ à¤ªà¤°à¤¿à¤£à¤¾à¤®',0),(514540,14293,'ms','Keputusan ujian bulanan kad kredit',0),(514541,14293,'ar','Ù†ØªØ§Ø¦Ø¬ Ø§Ù„Ø§Ø®ØªØ¨Ø§Ø± Ø§Ù„Ø´Ù‡Ø±ÙŠ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(514542,14293,'fr','RÃ©sultats de Test mensuels de carte de crÃ©dit',0),(514543,14293,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®æ¯Žæœˆã®ãƒ†ã‚¹ãƒˆçµæžœ',0),(514544,14293,'pt','Resultados de teste mensal de cartÃ£o de crÃ©dito',0),(514545,14293,'ru','Ð•Ð¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ñ‹Ðµ Ñ€ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ñ‹ Ñ‚ÐµÑÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(514546,14293,'es','Resultados mensuales de tarjeta de crÃ©dito',0),(514547,14293,'de','Kreditkarte monatlich Testergebnisse',0),(514548,14293,'en','Credit Card Monthly Test Results',0),(514549,14294,'is','',0),(514550,14294,'dr','ØªØ³Øª Ù‡Ø§ÛŒ Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¨Ù‡ Ø§ØªÙ…Ø§Ù… Ø§Ø³Øª',0),(514551,14294,'pr','ØªØ³Øª Ù‡Ø§ÛŒ Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¨Ù‡ Ø§ØªÙ…Ø§Ù… Ø§Ø³Øª',0),(514552,14294,'tr','Kredi kart testler tamamlandÄ±ktan',0),(514553,14294,'pl','Wykonaniu testÃ³w karty kredytowej',0),(514554,14294,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ñ‚ÐµÑÑ‚Ð¾Ð²Ðµ ÑÐ° Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸Ð»Ð¸',0),(514555,14294,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ù¹ÛŒØ³Ù¹ Ù…Ú©Ù…Ù„ Ú©Ø± Ú†Ú©Û’ ÛÛŒÚº',0),(514556,14294,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ñ‚ÐµÑÑ‚Ð¾Ð²Ð¸ ÑÑƒ Ð·Ð°Ð²Ñ€ÑˆÐ¸Ð»Ð¸',0),(514557,14294,'vi','Tháº» tÃ­n dá»¥ng thá»­ nghiá»‡m Ä‘Ã£ hoÃ n táº¥t',0),(514558,14294,'af','Kredietkaart toetse voltooi het',0),(514559,14294,'ro','Teste de Card de credit au finalizat',0),(514560,14294,'et','Krediitkaardi testid on lÃµpule viidud',0),(514561,14294,'si','DokonÄan teste kreditne kartice',0),(514562,14294,'ba','Kartu kredit tes telah menyelesaikan',0),(514563,14294,'nl','Creditcard Tests zijn voltooid',0),(514564,14294,'fi','Luottokortin testit on suoritettu',0),(514565,14294,'no','Kredittkort testene er fullfÃ¸rt',0),(514566,14294,'da','Kreditkort test har afsluttet',0),(514567,14294,'ko','ì‹ ìš© ì¹´ë“œ í…ŒìŠ¤íŠ¸ ì™„ë£Œ',0),(514568,14294,'he','×”×©×œ×ž×ª ×”×‘×“×™×§×•×ª ×›×¨×˜×™×¡ ××©×¨××™',0),(514569,14294,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Î´Î¿ÎºÎ¹Î¼Î­Ï‚ Î­Ï‡Î¿Ï…Î½ Î¿Î»Î¿ÎºÎ»Î·ÏÏ‰Î¸ÎµÎ¯',0),(514570,14294,'zh','ä¿¡ç”¨å¡æµ‹è¯•å®Œæˆ',0),(514571,14294,'sv','Kreditkort tester har slutfÃ¶rt',0),(514572,14294,'it','Hanno completato il test di carta di credito',0),(514573,14294,'tl','',0),(514574,14294,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸”à¸ªà¸­à¸šà¹€à¸ªà¸£à¹‡à¸ˆ',0),(514575,14294,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤ªà¥‚à¤°à¤¾ à¤•à¤° à¤²à¤¿à¤¯à¤¾ à¤¹à¥ˆ',0),(514576,14294,'ms','Ujian kad kredit telah selesai',0),(514577,14294,'ar','Ø§ÙƒØªÙ…Ø§Ù„ Ø§Ù„Ø§Ø®ØªØ¨Ø§Ø±Ø§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(514578,14294,'fr','Tests de carte de crÃ©dit ont terminÃ©',0),(514579,14294,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ãƒ†ã‚¹ãƒˆãŒå®Œäº†ã—ã¾ã™ã€‚',0),(514580,14294,'pt','Completaram-se testes de cartÃ£o de crÃ©dito',0),(514581,14294,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐµÐ½Ñ‹ Ð¸ÑÐ¿Ñ‹Ñ‚Ð°Ð½Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(514582,14294,'es','Han completado pruebas de tarjeta de crÃ©dito',0),(514583,14294,'de','Kreditkarte-Tests abgeschlossen haben',0),(514584,14294,'en','Credit Card Tests Have Completed',0),(514585,14295,'is','',0),(514586,14295,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù†ØªÛŒØ¬Ù‡ ØªØ³Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(514587,14295,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù†ØªÛŒØ¬Ù‡ ØªØ³Øª Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(514588,14295,'tr','Kredi kartÄ± sÄ±nav sonuÃ§ bilgileri',0),(514589,14295,'pl','SzczegÃ³Å‚y karty kredytowej Test wynik',0),(514590,14295,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ñ‚ÐµÑÑ‚ Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(514591,14295,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø¬Ø§Ù†Ú† Ú©Ø§ Ù†ØªÛŒØ¬Û Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(514592,14295,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð° Ñ‚ÐµÑÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñƒ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(514593,14295,'vi','Chi tiáº¿t káº¿t quáº£ kiá»ƒm tra tháº» tÃ­n dá»¥ng',0),(514594,14295,'af','Toets resultaat kredietkaartbesonderhede',0),(514595,14295,'ro','Detaliile cardului de credit Test rezultat',0),(514596,14295,'et','Krediitkaardi katse tulemuse Ã¼ksikasjad',0),(514597,14295,'si','Podatke o kreditni kartici Test rezultat',0),(514598,14295,'ba','Rincian hasil tes kartu kredit',0),(514599,14295,'nl','Creditcard Test resultaat Details',0),(514600,14295,'fi','Luottokorttitiedot testin tulos',0),(514601,14295,'no','Test resultat kredittkortdetaljer',0),(514602,14295,'da','Test resultat kreditkortoplysninger',0),(514603,14295,'ko','ì‹ ìš© ì¹´ë“œ í…ŒìŠ¤íŠ¸ ê²°ê³¼ ì„¸ë¶€ ì •ë³´',0),(514604,14295,'he','×¤×¨×˜×™ ×›×¨×˜×™×¡ ×”××©×¨××™ ×ž×‘×—×Ÿ ×”×ª×•×¦××”',0),(514605,14295,'el','Î”Î¿ÎºÎ¹Î¼Î® Î±Ï€Î¿Ï„Î­Î»ÎµÏƒÎ¼Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î·Ï‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ®Ï‚ ÎºÎ¬ÏÏ„Î±Ï‚',0),(514606,14295,'zh','ä¿¡ç”¨å¡æµ‹è¯•ç»“æžœè¯¦ç»†ä¿¡æ¯',0),(514607,14295,'sv','Test resultat kreditkortsuppgifter',0),(514608,14295,'it','Dettagli di carta di credito Test risultati',0),(514609,14295,'tl','',0),(514610,14295,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸œà¸¥à¸à¸²à¸£à¸—à¸”à¸ªà¸­à¸šà¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(514611,14295,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤ªà¤°à¤¿à¤£à¤¾à¤® à¤µà¤¿à¤µà¤°à¤£',0),(514612,14295,'ms','Butir-butir keputusan ujian kad kredit',0),(514613,14295,'ar','ØªÙØ§ØµÙŠÙ„ Ù†ØªÙŠØ¬Ø© Ø§Ø®ØªØ¨Ø§Ø± Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(514614,14295,'fr','DÃ©tails de carte de crÃ©dit Test rÃ©sultat',0),(514615,14295,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ãƒ†ã‚¹ãƒˆçµæžœã®è©³ç´°',0),(514616,14295,'pt','CartÃ£o de crÃ©dito detalhes do resultado de teste',0),(514617,14295,'ru','ÐŸÐ¾Ð´Ñ€Ð¾Ð±Ð½Ñ‹Ðµ Ñ€ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ñ‹ Ñ‚ÐµÑÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ñ… ÐºÐ°Ñ€Ñ‚',0),(514618,14295,'es','Datos de resultado de prueba de tarjeta de crÃ©dito',0),(514619,14295,'de','Kreditkarte Testergebnisdetails',0),(514620,14295,'en','Credit Card Test Result Details',0),(514621,14296,'is','',0),(514622,14296,'dr','Ø´Ú©Ø³Øª',0),(514623,14296,'pr','Ø´Ú©Ø³Øª',0),(514624,14296,'tr','HatalarÄ±',0),(514625,14296,'pl','Awarie',0),(514626,14296,'bg','ÐŸÐ¾Ð²Ñ€ÐµÐ´Ð¸',0),(514627,14296,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒØ§Úº',0),(514628,14296,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐ°',0),(514629,14296,'vi','Tháº¥t báº¡i',0),(514630,14296,'af','Mislukkings',0),(514631,14296,'ro','EÅŸecuri',0),(514632,14296,'et','Rikete',0),(514633,14296,'si','Napak',0),(514634,14296,'ba','Kegagalan',0),(514635,14296,'nl','Storingen',0),(514636,14296,'fi','EpÃ¤onnistumisia',0),(514637,14296,'no','Feil',0),(514638,14296,'da','Fejl',0),(514639,14296,'ko','ì‹¤íŒ¨',0),(514640,14296,'he','×›×©×œ×™×',0),(514641,14296,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯ÎµÏ‚',0),(514642,14296,'zh','å¤±è´¥',0),(514643,14296,'sv','Misslyckanden',0),(514644,14296,'it','Fallimenti',0),(514645,14296,'tl','',0),(514646,14296,'th','à¸„à¸§à¸²à¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(514647,14296,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾à¤“à¤‚',0),(514648,14296,'ms','Kegagalan',0),(514649,14296,'ar','Ø§Ù„ÙØ´Ù„',0),(514650,14296,'fr','Ã‰checs',0),(514651,14296,'jp','éšœå®³',0),(514652,14296,'pt','Falhas',0),(514653,14296,'ru','ÐÐµÑƒÐ´Ð°Ñ‡Ð¸',0),(514654,14296,'es','Fallas',0),(514655,14296,'de','Fehler',0),(514656,14296,'en','Failures',0),(514657,14297,'is','',0),(514658,14297,'dr','Ù…ÙˆÙÙ‚ÛŒØª',0),(514659,14297,'pr','Ù…ÙˆÙÙ‚ÛŒØª',0),(514660,14297,'tr','BaÅŸarÄ±lar',0),(514661,14297,'pl','Sukcesy',0),(514662,14297,'bg','Ð£ÑÐ¿ÐµÑ…Ð¸',0),(514663,14297,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒÙˆÚº',0),(514664,14297,'sr','Ð£ÑÐ¿Ñ˜ÐµÑÐ¸',0),(514665,14297,'vi','ThÃ nh cÃ´ng',0),(514666,14297,'af','Suksesse',0),(514667,14297,'ro','Succese',0),(514668,14297,'et','Edu',0),(514669,14297,'si','Uspehi',0),(514670,14297,'ba','Keberhasilan',0),(514671,14297,'nl','Successen',0),(514672,14297,'fi','Saavutuksia',0),(514673,14297,'no','Suksesser',0),(514674,14297,'da','Succeser',0),(514675,14297,'ko','ì„±ê³µ',0),(514676,14297,'he','×”×¦×œ×—×•×ª',0),(514677,14297,'el','Î•Ï€Î¹Ï„Ï…Ï‡Î¯ÎµÏ‚',0),(514678,14297,'zh','æˆåŠŸ',0),(514679,14297,'sv','FramgÃ¥ngar',0),(514680,14297,'it','Successi',0),(514681,14297,'tl','',0),(514682,14297,'th','à¸„à¸§à¸²à¸¡à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(514683,14297,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤“à¤‚',0),(514684,14297,'ms','Kejayaan',0),(514685,14297,'ar','Ø§Ù„Ù†Ø¬Ø§Ø­Ø§Øª',0),(514686,14297,'fr','SuccÃ¨s',0),(514687,14297,'jp','æˆåŠŸ',0),(514688,14297,'pt','Sucessos',0),(514689,14297,'ru','Ð£ÑÐ¿ÐµÑ…Ð¸',0),(514690,14297,'es','Ã‰xitos',0),(514691,14297,'de','Erfolge',0),(514692,14297,'en','Successes',0),(514693,14298,'is','',0),(514694,14298,'dr','Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¢Ø²Ù…ÙˆÙ†',0),(514695,14298,'pr','Ú©Ø§Ø±Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¢Ø²Ù…ÙˆÙ†',0),(514696,14298,'tr','Test kredi kartlarÄ±',0),(514697,14298,'pl','Test karty kredytowe',0),(514698,14298,'bg','Ð¢ÐµÑÑ‚ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(514699,14298,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©ÛŒ Ø¬Ø§Ù†Ú†',0),(514700,14298,'sr','Ð¢ÐµÑÑ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(514701,14298,'vi','Kiá»ƒm tra tháº» tÃ­n dá»¥ng',0),(514702,14298,'af','Toets kredietkaarte',0),(514703,14298,'ro','Carduri de Credit de testare',0),(514704,14298,'et','Test krediitkaardid',0),(514705,14298,'si','Test kreditne kartice',0),(514706,14298,'ba','Menguji kartu kredit',0),(514707,14298,'nl','Test creditcards',0),(514708,14298,'fi','Testaa luottokortit',0),(514709,14298,'no','Teste kredittkort',0),(514710,14298,'da','Test kreditkort',0),(514711,14298,'ko','ì‹ ìš© ì¹´ë“œ í…ŒìŠ¤íŠ¸',0),(514712,14298,'he','×‘×“×™×§×ª ×›×¨×˜×™×¡×™ ××©×¨××™',0),(514713,14298,'el','Î”Î¿ÎºÎ¹Î¼Î® Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ ÎºÎ¬ÏÏ„ÎµÏ‚',0),(514714,14298,'zh','æµ‹è¯•ä¿¡ç”¨å¡',0),(514715,14298,'sv','Testa kreditkort',0),(514716,14298,'it','Carte di credito di prova',0),(514717,14298,'tl','',0),(514718,14298,'th','à¸—à¸”à¸ªà¸­à¸šà¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(514719,14298,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¤¾ à¤ªà¤°à¥€à¤•à¥à¤·à¤£',0),(514720,14298,'ms','Kad kredit ujian',0),(514721,14298,'ar','Ø§Ø®ØªØ¨Ø§Ø± Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(514722,14298,'fr','Cartes de crÃ©dit de test',0),(514723,14298,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã‚’ãƒ†ã‚¹ãƒˆã—ã¾ã™ã€‚',0),(514724,14298,'pt','Teste de cartÃµes de crÃ©dito',0),(514725,14298,'ru','Ð¢ÐµÑÑ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(514726,14298,'es','Prueba de tarjetas de crÃ©dito',0),(514727,14298,'de','Test Kreditkarten',0),(514728,14298,'en','Test Credit Cards',0),(514729,14299,'is','',0),(514730,14299,'dr','Ú©Ù„ Ú©Ø§Ø±Øª',0),(514731,14299,'pr','Ú©Ù„ Ú©Ø§Ø±Øª',0),(514732,14299,'tr','Toplam kartlarÄ±',0),(514733,14299,'pl','CaÅ‚kowita karty',0),(514734,14299,'bg','ÐžÐ±Ñ‰Ð¾ ÐºÐ°Ñ€Ñ‚Ð¸',0),(514735,14299,'ur','Ú©Ù„ Ú©Ø§Ø±Úˆ',0),(514736,14299,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° ÐºÐ°Ñ€Ñ‚Ðµ',0),(514737,14299,'vi','Táº¥t cáº£ tháº»',0),(514738,14299,'af','Totale kaarte',0),(514739,14299,'ro','Total carti',0),(514740,14299,'et','Kogu kaardid',0),(514741,14299,'si','Skupne kartice',0),(514742,14299,'ba','Kartu Total',0),(514743,14299,'nl','Totale kaarten',0),(514744,14299,'fi','YhteensÃ¤ kortista',0),(514745,14299,'no','Totalt kortene',0),(514746,14299,'da','Samlede kort',0),(514747,14299,'ko','ì´ ì¹´ë“œ',0),(514748,14299,'he','×¡×” ×› ×ª×¢×•×“×•×ª',0),(514749,14299,'el','Î£ÏÎ½Î¿Î»Î¿ ÎºÎ±ÏÏ„ÏŽÎ½',0),(514750,14299,'zh','æ€»å¡',0),(514751,14299,'sv','Totala kort',0),(514752,14299,'it','Totale carte',0),(514753,14299,'tl','',0),(514754,14299,'th','à¸šà¸±à¸•à¸£à¸£à¸§à¸¡',0),(514755,14299,'hi','à¤•à¥à¤² à¤•à¤¾à¤°à¥à¤¡',0),(514756,14299,'ms','Jumlah Kad',0),(514757,14299,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø¨Ø·Ø§Ù‚Ø§Øª',0),(514758,14299,'fr','Cartes totales',0),(514759,14299,'jp','åˆè¨ˆã‚«ãƒ¼ãƒ‰',0),(514760,14299,'pt','CartÃµes totais',0),(514761,14299,'ru','Ð’ÑÐµÐ³Ð¾ ÐºÐ°Ñ€Ñ‚',0),(514762,14299,'es','Totales tarjetas',0),(514763,14299,'de','Gesamt-Karten',0),(514764,14299,'en','Total Cards',0),(514765,14300,'is','',0),(514766,14300,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù†ØªØ§ÛŒØ¬ Ø¯Ø³ØªÙ‡',0),(514767,14300,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù†ØªØ§ÛŒØ¬ Ø¯Ø³ØªÙ‡',0),(514768,14300,'tr','Toplu sonuÃ§larÄ± gÃ¶ster',0),(514769,14300,'pl','Zobacz wyniki partia',0),(514770,14300,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¾Ñ‚ Ð¿Ð°Ñ€Ñ‚Ð¸Ð´Ð°',0),(514771,14300,'ur','Ø¨ÛŒÚ† Ú©Û’ Ù†ØªØ§Ø¦Ø¬ Ø¯ÛŒÚ©Ú¾ÛŒÚº',0),(514772,14300,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ€ÐµÐ·ÑƒÐ»Ñ‚Ð°Ñ‚Ðµ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ñƒ',0),(514773,14300,'vi','Xem hÃ ng loáº¡t káº¿t quáº£',0),(514774,14300,'af','Bekyk bondel resultate',0),(514775,14300,'ro','Vezi rezultatele de lot',0),(514776,14300,'et','Vaata partii tulemusi',0),(514777,14300,'si','Pogled serije rezultatov',0),(514778,14300,'ba','Melihat Batch hasil',0),(514779,14300,'nl','Batch-resultaten weergeven',0),(514780,14300,'fi','NÃ¤ytÃ¤ erÃ¤n tulokset',0),(514781,14300,'no','Vis Batch resultater',0),(514782,14300,'da','Se Batch resultater',0),(514783,14300,'ko','ì¼ê´„ ì²˜ë¦¬ ê²°ê³¼ ë³´ê¸°',0),(514784,14300,'he','×”×¦×’ ×ª×•×¦××•×ª ××¦×•×•×”',0),(514785,14300,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï„Ï‰Î½ Î±Ï€Î¿Ï„ÎµÎ»ÎµÏƒÎ¼Î¬Ï„Ï‰Î½ Ï„Î·Ï‚ Î´Î­ÏƒÎ¼Î·Ï‚',0),(514786,14300,'zh','æŸ¥çœ‹æ‰¹å¤„ç†ç»“æžœ',0),(514787,14300,'sv','Visa resultat fÃ¶r Batch',0),(514788,14300,'it','Visualizza i risultati del lotto',0),(514789,14300,'tl','',0),(514790,14300,'th','à¸”à¸¹à¸Šà¸¸à¸”à¸œà¸¥à¸¥à¸±à¸žà¸˜à¹Œ',0),(514791,14300,'hi','à¤¬à¥ˆà¤š à¤ªà¤°à¤¿à¤£à¤¾à¤® à¤¦à¥‡à¤–à¥‡à¤‚',0),(514792,14300,'ms','Lihat Kumpulan hasil',0),(514793,14300,'ar','Ø¹Ø±Ø¶ Ù†ØªØ§Ø¦Ø¬ Ø§Ù„Ø¯ÙØ¹Ø©',0),(514794,14300,'fr','Afficher les rÃ©sultats de traitement par lots',0),(514795,14300,'jp','ãƒãƒƒãƒã®çµæžœã‚’è¦‹ã‚‹',0),(514796,14300,'pt','Ver resultados de lote',0),(514797,14300,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ñ€ÐµÐ·ÑƒÐ»ÑŒÑ‚Ð°Ñ‚Ñ‹ Ð¿Ð°Ñ€Ñ‚Ð¸Ð¸',0),(514798,14300,'es','Ver resultados de lote',0),(514799,14300,'de','Batch-Ergebnisse anzeigen',0),(514800,14300,'en','View Batch Results',0),(514801,14301,'is','',0),(514802,14301,'dr','Ø´Ù…Ø§ Ø§ÙˆÙ„ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø¯Ø³ØªÙ‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(514803,14301,'pr','Ø´Ù…Ø§ Ø§ÙˆÙ„ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø¯Ø³ØªÙ‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(514804,14301,'tr','Ã–nce toplu seÃ§melisiniz',0),(514805,14301,'pl','Najpierw naleÅ¼y wybraÄ‡ partii',0),(514806,14301,'bg','ÐŸÑŠÑ€Ð²Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð°Ð¿ÐºÐ°',0),(514807,14301,'ur','Ø¢Ù¾ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§ÛŒÚ© Ø¨ÛŒÚ† Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(514808,14301,'sr','ÐŸÑ€Ð²Ð¾ Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð³Ñ€ÑƒÐ¿Ñƒ',0),(514809,14301,'vi','TrÆ°á»›c tiÃªn báº¡n pháº£i chá»n má»™t lÃ´',0),(514810,14301,'af','Eerstens moet jy kies \'n bondel',0),(514811,14301,'ro','Mai Ã®ntÃ¢i trebuie sÄƒ selectaÅ£i un lot',0),(514812,14301,'et','Esmalt peate valima partii',0),(514813,14301,'si','Najprej morate izbrati serije',0),(514814,14301,'ba','Anda harus memilih dulu Batch',0),(514815,14301,'nl','U moet eerst een Batch selecteren',0),(514816,14301,'fi','Valitse ensimmÃ¤inen erÃ¤',0),(514817,14301,'no','Du mÃ¥ velge en bunke',0),(514818,14301,'da','Du skal fÃ¸rst vÃ¦lge et parti',0),(514819,14301,'ko','ì²« ë²ˆì§¸ ì¼ê´„ ì²˜ë¦¬ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(514820,14301,'he','×ª×—×™×œ×” ×¢×œ×™×š ×œ×‘×—×•×¨ ××¦×•×•×”',0),(514821,14301,'el','Î ÏÏŽÏ„Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î¼Î¹Î± Ï€Î±ÏÏ„Î¯Î´Î±',0),(514822,14301,'zh','æ‚¨é¦–å…ˆå¿…é¡»é€‰æ‹©ä¸€æ‰¹',0),(514823,14301,'sv','Du mÃ¥ste fÃ¶rst vÃ¤lja ett parti',0),(514824,14301,'it','Ãˆ innanzitutto necessario selezionare un Batch',0),(514825,14301,'tl','',0),(514826,14301,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸Šà¸¸à¸”',0),(514827,14301,'hi','à¤¤à¥à¤® à¤ªà¤¹à¤²à¥‡ à¤à¤• à¤¬à¥ˆà¤š à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(514828,14301,'ms','Anda terlebih dahulu perlu memilih kelompok',0),(514829,14301,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø£ÙˆÙ„Ø§Ù‹ ØªØ­Ø¯ÙŠØ¯ Ø¯ÙØ¹Ø©',0),(514830,14301,'fr','Vous devez d\'abord sÃ©lectionner un lot',0),(514831,14301,'jp','æœ€åˆã®ãƒãƒƒãƒã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(514832,14301,'pt','VocÃª primeiro deve selecionar um lote',0),(514833,14301,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¿Ð°ÐºÐµÑ‚',0),(514834,14301,'es','Primero debe seleccionar un lote',0),(514835,14301,'de','ZunÃ¤chst mÃ¼ssen Sie einen Stapel auswÃ¤hlen',0),(514836,14301,'en','You First Must Select A Batch',0),(514837,14302,'is','',0),(514838,14302,'dr','ØªÙ…Ø§Ù… Ø³Ø§Ø®ØªÙ…Ø§Ù† Ù‡Ø§',0),(514839,14302,'pr','ØªÙ…Ø§Ù… Ø³Ø§Ø®ØªÙ…Ø§Ù† Ù‡Ø§',0),(514840,14302,'tr','BÃ¼tÃ¼n binalar',0),(514841,14302,'pl','Wszystkie budynki',0),(514842,14302,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÑÐ³Ñ€Ð°Ð´Ð¸',0),(514843,14302,'ur','ØªÙ…Ø§Ù… Ø¹Ù…Ø§Ø±ØªÙˆÚº',0),(514844,14302,'sr','Ð¡Ð²Ðµ Ð·Ð³Ñ€Ð°Ð´Ðµ',0),(514845,14302,'vi','Táº¥t cáº£ cÃ¡c tÃ²a nhÃ ',0),(514846,14302,'af','Alle geboue',0),(514847,14302,'ro','Toate clÄƒdirile',0),(514848,14302,'et','KÃµik hooned',0),(514849,14302,'si','Vse stavbe',0),(514850,14302,'ba','Semua bangunan',0),(514851,14302,'nl','Alle gebouwen',0),(514852,14302,'fi','Kaikki rakennukset',0),(514853,14302,'no','Alle bygninger',0),(514854,14302,'da','Alle bygninger',0),(514855,14302,'ko','ëª¨ë“  ê±´ë¬¼',0),(514856,14302,'he','×›×œ ×”×‘× ×™×™× ×™×',0),(514857,14302,'el','ÎŒÎ»Î± Ï„Î± ÎºÏ„Î¯ÏÎ¹Î±',0),(514858,14302,'zh','æ‰€æœ‰å»ºç­‘ç‰©',0),(514859,14302,'sv','Alla byggnader',0),(514860,14302,'it','Tutti gli edifici',0),(514861,14302,'tl','',0),(514862,14302,'th','à¸­à¸²à¸„à¸²à¸£à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(514863,14302,'hi','à¤¸à¤­à¥€ à¤‡à¤®à¤¾à¤°à¤¤à¥‹à¤‚',0),(514864,14302,'ms','Semua bangunan',0),(514865,14302,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…Ø¨Ø§Ù†ÙŠ',0),(514866,14302,'fr','Tous les bÃ¢timents',0),(514867,14302,'jp','ã™ã¹ã¦ã®å»ºç‰©',0),(514868,14302,'pt','Todos os edifÃ­cios',0),(514869,14302,'ru','Ð’ÑÐµ Ð·Ð´Ð°Ð½Ð¸Ñ',0),(514870,14302,'es','Todos los edificios',0),(514871,14302,'de','Alle GebÃ¤ude',0),(514872,14302,'en','All Buildings',0),(514873,14303,'is','',0),(514874,14303,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÛŒ Ø¨Ø± Ø§Ø³Ø§Ø³ Ù†ÙˆØ¹ ÙˆØ§Ø­Ø¯',0),(514875,14303,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÛŒ Ø¨Ø± Ø§Ø³Ø§Ø³ Ù†ÙˆØ¹ ÙˆØ§Ø­Ø¯',0),(514876,14303,'tr','Birimi tÃ¼rÃ¼ne gÃ¶re grupla',0),(514877,14303,'pl','Grupa przez jednostki typu',0),(514878,14303,'bg','Ð“Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾ Ñ‚Ð¸Ð¿ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(514879,14303,'ur','Ú¯Ø±ÙˆÙ¾ Ø¨Ù…Ø·Ø§Ø¨Ù‚ Ù‚Ø³Ù… ÛŒÙˆÙ†Ù¹',0),(514880,14303,'sr','Ð“Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾ Ð²Ñ€ÑÑ‚Ð¸ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(514881,14303,'vi','NhÃ³m theo loáº¡i cÄƒn há»™',0),(514882,14303,'af','Groepeer volgens tipe eenheid',0),(514883,14303,'ro','Grup de unitate de tip',0),(514884,14303,'et','RÃ¼hmita Ã¼hiku tÃ¼Ã¼p',0),(514885,14303,'si','ZdruÅ¾i po vrsta enote',0),(514886,14303,'ba','Kelompok oleh Unit Type',0),(514887,14303,'nl','Groeperen op eenheidstype',0),(514888,14303,'fi','RyhmÃ¤n tyyppi',0),(514889,14303,'no','Grupper etter enhetstype',0),(514890,14303,'da','Gruppe af enhedstype',0),(514891,14303,'ko','ìž¥ì¹˜ ìœ í˜•ë³„ ê·¸ë£¹',0),(514892,14303,'he','×§×‘×¥ ×œ×¤×™ ×¡×•×’ ×™×—×™×“×”',0),(514893,14303,'el','ÎŸÎ¼Î±Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· ÎºÎ±Ï„Î¬ Î¼Î¿Î½Î¬Î´Î± Ï„ÏÏ€Î¿Ï…',0),(514894,14303,'zh','æŒ‰å•ä½ç±»åž‹åˆ†ç»„',0),(514895,14303,'sv','Grupp av typ',0),(514896,14303,'it','Gruppo di unitÃ  tipo',0),(514897,14303,'tl','',0),(514898,14303,'th','à¸ˆà¸±à¸”à¸à¸¥à¸¸à¹ˆà¸¡à¸•à¸²à¸¡à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸«à¸™à¹ˆà¸§à¸¢',0),(514899,14303,'hi','à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¤®à¥‚à¤¹',0),(514900,14303,'ms','Kumpulan mengikut jenis Unit',0),(514901,14303,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø­Ø³Ø¨ Ù†ÙˆØ¹ Ø§Ù„ÙˆØ­Ø¯Ø©',0),(514902,14303,'fr','Groupe par Type d\'unitÃ©',0),(514903,14303,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆ ã‚¿ã‚¤ãƒ—ã«ã‚ˆã‚‹ã‚°ãƒ«ãƒ¼ãƒ—åŒ–',0),(514904,14303,'pt','Agrupar por tipo de unidade',0),(514905,14303,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð¾ Ñ‚Ð¸Ð¿Ñƒ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ñ‹',0),(514906,14303,'es','Grupo por tipo de unidad',0),(514907,14303,'de','Gruppieren nach Typ',0),(514908,14303,'en','Group By Unit Type',0),(514909,14304,'is','',0),(514910,14304,'dr','Ø´Ø§Ù…Ù„ ÙˆØ§Ø­Ø¯Ù‡Ø§ÛŒ Ø¨Ø§Ø²',0),(514911,14304,'pr','Ø´Ø§Ù…Ù„ ÙˆØ§Ø­Ø¯Ù‡Ø§ÛŒ Ø¨Ø§Ø²',0),(514912,14304,'tr','AÃ§Ä±k birimleri iÃ§erir',0),(514913,14304,'pl','Obejmuje otwarte jednostki',0),(514914,14304,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¾Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð¸',0),(514915,14304,'ur','Ú©Ú¾Ù„ÛŒ ÛŒÙˆÙ†Ù¹Ø³ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(514916,14304,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ Ð¾Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(514917,14304,'vi','Bao gá»“m má»Ÿ Ä‘Æ¡n vá»‹',0),(514918,14304,'af','Sluit oop eenhede',0),(514919,14304,'ro','Includ unitÄƒÈ›i deschise',0),(514920,14304,'et','Lisada avatud Ã¼ksused',0),(514921,14304,'si','VkljuÄi odprte enote',0),(514922,14304,'ba','Termasuk unit terbuka',0),(514923,14304,'nl','Open eenheden omvatten',0),(514924,14304,'fi','Avaa valvontaÂ­toimenpiteitÃ¤',0),(514925,14304,'no','Inkluder Ã¥pne enheter',0),(514926,14304,'da','Omfatte Ã¥bne enheder',0),(514927,14304,'ko','ì—´ë ¤ìžˆëŠ” ë‹¨ìœ„ë¥¼ í¬í•¨',0),(514928,14304,'he','×›×•×œ×œ×™× ×™×—×™×“×•×ª ×¤×ª×•×—×•×ª',0),(514929,14304,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Î±Î½Î¿Î¹ÎºÏ„Î­Ï‚ Î¼Î¿Î½Î¬Î´ÎµÏ‚',0),(514930,14304,'zh','åŒ…æ‹¬å¼€æ”¾å•ä½',0),(514931,14304,'sv','Inkludera Ã¶ppna enheter',0),(514932,14304,'it','Comprendono unitÃ  aperta',0),(514933,14304,'tl','',0),(514934,14304,'th','à¸£à¸§à¸¡à¸«à¸™à¹ˆà¸§à¸¢à¹€à¸›à¸´à¸”',0),(514935,14304,'hi','à¤–à¥à¤²à¤¾ à¤‡à¤•à¤¾à¤‡à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(514936,14304,'ms','Termasuk unit terbuka',0),(514937,14304,'ar','ÙˆØªØ´Ù…Ù„ ÙˆØ­Ø¯Ø§Øª Ù…ÙØªÙˆØ­Ø©',0),(514938,14304,'fr','Inclure les unitÃ©s ouvertes',0),(514939,14304,'jp','é–‹ã„ãŸãƒ¦ãƒ‹ãƒƒãƒˆãŒå«ã¾ã‚Œã¾ã™ã€‚',0),(514940,14304,'pt','Incluem unidades abertas',0),(514941,14304,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ð¹ ÐµÐ´Ð¸Ð½Ð¸Ñ†',0),(514942,14304,'es','Incluyen unidades abiertas',0),(514943,14304,'de','Offene Einheiten gehÃ¶ren',0),(514944,14304,'en','Include Open Units',0),(514945,14305,'is','',0),(514946,14305,'dr','Ø´Ø§Ù…Ù„ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡',0),(514947,14305,'pr','Ø´Ø§Ù…Ù„ Ø«Ø¨Øª Ù†Ø´Ø¯Ù‡',0),(514948,14305,'tr','Ä°Ã§erir imzalanmamÄ±ÅŸ',0),(514949,14305,'pl','ZawierajÄ… niepodpisane',0),(514950,14305,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð½ÐµÐ¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸',0),(514951,14305,'ur','Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº ØºÛŒØ± Ø¯Ø³ØªØ®Ø· Ø´Ø¯Û',0),(514952,14305,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐÐµÐ¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ð½Ð°',0),(514953,14305,'vi','Bao gá»“m dáº¥u',0),(514954,14305,'af','Sluit ongetekende',0),(514955,14305,'ro','Includ nesemnate',0),(514956,14305,'et','Sisaldada allkirjastamata',0),(514957,14305,'si','VkljuÄujejo nepodpisani',0),(514958,14305,'ba','Termasuk Unsigned',0),(514959,14305,'nl','Omvatten niet-ondertekende',0),(514960,14305,'fi','SisÃ¤ltÃ¤Ã¤ allekirjoittamattomia',0),(514961,14305,'no','Inkluderer usignerte',0),(514962,14305,'da','Omfatter ikke-signeret',0),(514963,14305,'ko','í¬í•¨ ì„œëª… ë˜ì§€ ì•Šì€',0),(514964,14305,'he','×›×•×œ×œ×™× ×œ× ×—×ª×•×',0),(514965,14305,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Î±Î½Ï…Ï€ÏŒÎ³ÏÎ±Ï†Î¿',0),(514966,14305,'zh','åŒ…æ‹¬æ— ç¬¦å·',0),(514967,14305,'sv','InnehÃ¥lla osignerade',0),(514968,14305,'it','Includono senza segno',0),(514969,14305,'tl','',0),(514970,14305,'th','à¸£à¸§à¸¡à¸£à¸±à¸šà¸£à¸­à¸‡',0),(514971,14305,'hi','à¤¶à¤¾à¤®à¤¿à¤² à¤…à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤¿à¤¤',0),(514972,14305,'ms','Termasuk tidak ditandatangani',0),(514973,14305,'ar','ÙˆØªØ´Ù…Ù„ ØºÙŠØ± Ø§Ù„Ù…ÙˆÙ‚Ø¹Ø©',0),(514974,14305,'fr','Inclure non signÃ©',0),(514975,14305,'jp','å«ã‚€ç¬¦å·ãªã—',0),(514976,14305,'pt','Incluir nÃ£o assinado',0),(514977,14305,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ð½ÐµÐ¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð½Ñ‹Ðµ',0),(514978,14305,'es','Incluyen sin firmar',0),(514979,14305,'de','Enthalten ohne Vorzeichen',0),(514980,14305,'en','Include Unsigned',0),(514981,14306,'is','',0),(514982,14306,'dr','Ø¢ØºØ§Ø² Ø§Ø¬Ø§Ø±Ù‡',0),(514983,14306,'pr','Ø¢ØºØ§Ø² Ø§Ø¬Ø§Ø±Ù‡',0),(514984,14306,'tr','Kira baÅŸlangÄ±Ã§',0),(514985,14306,'pl','RozpoczÄ™cia leasingu',0),(514986,14306,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¡Ñ‚Ð°Ñ€Ñ‚',0),(514987,14306,'ur','Ù„ÛŒØ² Ø´Ø±ÙˆØ¹',0),(514988,14306,'sr','Ð—Ð°ÐºÑƒÐ¿ Ð¡Ñ‚Ð°Ñ€Ñ‚',0),(514989,14306,'vi','Báº¯t Ä‘áº§u cho thuÃª',0),(514990,14306,'af','Huurkontrak begin',0),(514991,14306,'ro','Contract de leasing Ã®ncepe',0),(514992,14306,'et','Rendi alguse',0),(514993,14306,'si','ZaÄetek najema',0),(514994,14306,'ba','Sewa mulai',0),(514995,14306,'nl','Lease Start',0),(514996,14306,'fi','Vuokrasopimuksen alku',0),(514997,14306,'no','Leieavtalen Start',0),(514998,14306,'da','LejemÃ¥let Start',0),(514999,14306,'ko','ìž„ëŒ€ ì‹œìž‘',0),(515000,14306,'he','×”×ª×—×œ ×—×›×™×¨×”',0),(515001,14306,'el','ÎˆÎ½Î±ÏÎ¾Î· Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(515002,14306,'zh','ç§Ÿçº¦å¼€å§‹',0),(515003,14306,'sv','Hyresavtalet Start',0),(515004,14306,'it','Inizio locazione',0),(515005,14306,'tl','',0),(515006,14306,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(515007,14306,'hi','à¤²à¥€à¤œ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­',0),(515008,14306,'ms','Mula pajakan',0),(515009,14306,'ar','Ø¨Ø¯Ø¡ Ø§Ù„ØªØ£Ø¬ÙŠØ±',0),(515010,14306,'fr','DÃ©but de bail',0),(515011,14306,'jp','ãƒªãƒ¼ã‚¹ã®é–‹å§‹',0),(515012,14306,'pt','InÃ­cio da locaÃ§Ã£o',0),(515013,14306,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(515014,14306,'es','Inicio del arrendamiento',0),(515015,14306,'de','Leasing-Start',0),(515016,14306,'en','Lease Start',0),(515017,14307,'is','',0),(515018,14307,'dr','Ù†ÙˆØ¹ ÙˆØ§Ø­Ø¯',0),(515019,14307,'pr','Ù†ÙˆØ¹ ÙˆØ§Ø­Ø¯',0),(515020,14307,'tr','Ãœnite tÃ¼rÃ¼',0),(515021,14307,'pl','Typ jednostki',0),(515022,14307,'bg','Ð¢Ð¸Ð¿ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(515023,14307,'ur','ÛŒÙˆÙ†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(515024,14307,'sr','Ð¢Ð¸Ð¿ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ðµ',0),(515025,14307,'vi','Loáº¡i cÄƒn há»™',0),(515026,14307,'af','Eenheid Tipe',0),(515027,14307,'ro','Tip de unitate',0),(515028,14307,'et','Ãœhiku tÃ¼Ã¼p',0),(515029,14307,'si','Vrsta enote',0),(515030,14307,'ba','Jenis unit',0),(515031,14307,'nl','Eenheidstype',0),(515032,14307,'fi','OrganisaatioyksikÃ¶n tyyppi',0),(515033,14307,'no','Enhetstype',0),(515034,14307,'da','Unit Type',0),(515035,14307,'ko','ë‹¨ìœ„ ìœ í˜•',0),(515036,14307,'he','×¡×•×’ ×™×—×™×“×”',0),(515037,14307,'el','Î¤ÏÏ€Î¿Ï‚ Î¼Î¿Î½Î¬Î´Ï‰Î½',0),(515038,14307,'zh','å•ä½ç±»åž‹',0),(515039,14307,'sv','Enhetstyp',0),(515040,14307,'it','Tipo di unitÃ ',0),(515041,14307,'tl','',0),(515042,14307,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸«à¸™à¹ˆà¸§à¸¢',0),(515043,14307,'hi','à¤¯à¥‚à¤¨à¤¿à¤Ÿ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(515044,14307,'ms','Unit jenis',0),(515045,14307,'ar','Ù†ÙˆØ¹ Ø§Ù„ÙˆØ­Ø¯Ø©',0),(515046,14307,'fr','Type d\'unitÃ©',0),(515047,14307,'jp','å˜ä½ã®ç¨®é¡ž',0),(515048,14307,'pt','Tipo de unidade',0),(515049,14307,'ru','Ð¢Ð¸Ð¿ ÐµÐ´Ð¸Ð½Ð¸Ñ†',0),(515050,14307,'es','Tipo de unidad',0),(515051,14307,'de','Einheitentyp',0),(515052,14307,'en','Unit Type',0),(515053,14308,'is','',0),(515054,14308,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯',0),(515055,14308,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯',0),(515056,14308,'tr','Kabartma temizlik/zarar',0),(515057,14308,'pl','Czyszczenie/uszkodzenia ulgi',0),(515058,14308,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/ÑƒÐ²Ñ€ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ',0),(515059,14308,'ur','ØµÙØ§Ø¦ÛŒ/Ø±ÛŒÙ„ÛŒÙ Ù†Ù‚ØµØ§Ù†',0),(515060,14308,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ',0),(515061,14308,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i cá»©u trá»£',0),(515062,14308,'af','Skoonmaak/skade verligting',0),(515063,14308,'ro','CurÄƒÅ£are/daune Relief',0),(515064,14308,'et','Puhastamine/kahju leevendamiseks',0),(515065,14308,'si','ÄŒiÅ¡Äenje/Å¡kodo Relief',0),(515066,14308,'ba','Pembersihan/kerusakan Relief',0),(515067,14308,'nl','Reiniging/schade Relief',0),(515068,14308,'fi','Puhdistus/vahinko helpotus',0),(515069,14308,'no','RengjÃ¸ring/skade lettelse',0),(515070,14308,'da','RengÃ¸ring/skader Relief',0),(515071,14308,'ko','ì²­ì†Œ í”¼í•´ êµ¬ì œ',0),(515072,14308,'he','× ×™×§×•×™/× ×–×§ ×”×§×œ×”',0),(515073,14308,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ·',0),(515074,14308,'zh','æ¸…æ´—æŸå®³æ•‘æµŽ',0),(515075,14308,'sv','RengÃ¶ring/skada lÃ¤ttnad',0),(515076,14308,'it','Pulizia/danno sollievo',0),(515077,14308,'tl','',0),(515078,14308,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¸«à¸²à¸¢à¸šà¸£à¸£à¹€à¸—à¸²',0),(515079,14308,'hi','à¤°à¤¾à¤¹à¤¤ à¤•à¥€ à¤¸à¤«à¤¾à¤ˆ/à¤¨à¥à¤•à¤¸à¤¾à¤¨',0),(515080,14308,'ms','Kering/kerosakan pelepasan',0),(515081,14308,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø§Ù„Ø¥ØºØ§Ø«Ø©',0),(515082,14308,'fr','Nettoyage/dommages secours',0),(515083,14308,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆ',0),(515084,14308,'pt','Limpeza/danos alÃ­vio',0),(515085,14308,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/Ð¿Ð¾Ð²Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ñ Ñ€ÐµÐ»ÑŒÐµÑ„',0),(515086,14308,'es','Limpieza/daÃ±o alivio',0),(515087,14308,'de','Reinigung/Schaden Sie-Relief',0),(515088,14308,'en','Cleaning/Damage Relief',0),(515089,14309,'is','',0),(515090,14309,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ GL Ø­Ø³Ø§Ø¨',0),(515091,14309,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ GL Ø­Ø³Ø§Ø¨',0),(515092,14309,'tr','Kabartma GL hesap temizlik/zarar',0),(515093,14309,'pl','Czyszczenie/uszkodzenia ulgi GL konta',0),(515094,14309,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(515095,14309,'ur','ØµÙØ§Ø¦ÛŒ/Ø±ÛŒÙ„ÛŒÙ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù‚ØµØ§Ù†',0),(515096,14309,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(515097,14309,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i giáº£m GL tÃ i khoáº£n',0),(515098,14309,'af','Skoonmaak/skade verligting GL rekening',0),(515099,14309,'ro','CurÄƒÅ£are/daune Relief GL cont',0),(515100,14309,'et','Puhastamine/kahju leevendamiseks pearaamatukontole',0),(515101,14309,'si','ÄŒiÅ¡Äenje/Å¡kodo Relief GL raÄun',0),(515102,14309,'ba','Pembersihan/kerusakan Relief GL Account',0),(515103,14309,'nl','Reiniging/schade Relief GL Account',0),(515104,14309,'fi','Puhdistus/vahinko helpotusta Kirjanpitotilin pÃ¤Ã¤tilin',0),(515105,14309,'no','RengjÃ¸ring/skade lettelse gi-konto',0),(515106,14309,'da','RengÃ¸ring/skader Relief GL konto',0),(515107,14309,'ko','ì²­ì†Œ í”¼í•´ êµ¬í˜¸ GL ê³„ì •',0),(515108,14309,'he','× ×™×§×•×™/× ×–×§ ×”×§×œ×” GL ×—×©×‘×•×Ÿ',0),(515109,14309,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(515110,14309,'zh','æ¸…æ´—æŸå®³æ•‘æµŽæ€»å¸ç§‘ç›®',0),(515111,14309,'sv','RengÃ¶ring/skada lÃ¤ttnad GL konto',0),(515112,14309,'it','Pulizia/danno sollievo GL Account',0),(515113,14309,'tl','',0),(515114,14309,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¹€à¸ªà¸µà¸¢à¸šà¸±à¸à¸Šà¸µ GL à¸šà¸£à¸£à¹€à¸—à¸²',0),(515115,14309,'hi','à¤°à¤¾à¤¹à¤¤ GL à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤¸à¤«à¤¾à¤ˆ/à¤¨à¥à¤•à¤¸à¤¾à¤¨',0),(515116,14309,'ms','Kering/kerosakan pelepasan GL akaun',0),(515117,14309,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø­Ø³Ø§Ø¨ GL Ø§Ù„Ø¥ØºØ§Ø«Ø©',0),(515118,14309,'fr','Nettoyage/dommages compte GL de secours',0),(515119,14309,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(515120,14309,'pt','Limpeza/danos alÃ­vio GL conta',0),(515121,14309,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/ÑƒÑ‰ÐµÑ€Ð± Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ GL ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(515122,14309,'es','Limpieza/daÃ±o alivio GL cuenta',0),(515123,14309,'de','Relief Hauptbuchkonto Reinigung/Schaden',0),(515124,14309,'en','Cleaning/Damage Relief GL Account',0),(515125,14310,'is','',0),(515126,14310,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Reconciliations Ø§Ù…Ø¯Ø§Ø¯',0),(515127,14310,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Reconciliations Ø§Ù…Ø¯Ø§Ø¯',0),(515128,14310,'tr','Kabartma mutabakatlarÄ± temizlik/zarar',0),(515129,14310,'pl','Czyszczenie/uszkodzenia uzgodnienia ulgi',0),(515130,14310,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ñ€Ð°Ð²Ð½ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(515131,14310,'ur','ØµÙØ§Ø¦ÛŒ/Ø±ÛŒÙ„ÛŒÙ Ø±ÛŒÚ©ÙˆÙ†Ú©Ø§Ù„ÛŒØ§Ù¹Ø§Ù†Ø³ Ù†Ù‚ØµØ§Ù†',0),(515132,14310,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ Ð¿Ð¾Ð¼Ð¸Ñ€ÐµÑšÐ°',0),(515133,14310,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i giáº£m Reconciliations',0),(515134,14310,'af','Skoonmaak/skade verligting Reconciliations',0),(515135,14310,'ro','CurÄƒÅ£are/daune Relief Reconcilieri',0),(515136,14310,'et','Puhastamine/kahju leevendamiseks vÃµrdlevalt',0),(515137,14310,'si','ÄŒiÅ¡Äenje/Å¡kodo Relief uskladitve',0),(515138,14310,'ba','Pembersihan/kerusakan Relief rekonsiliasi',0),(515139,14310,'nl','Reiniging/schade Relief aansluitingen',0),(515140,14310,'fi','Puhdistus/vahinko helpotusta tÃ¤smÃ¤ytykset',0),(515141,14310,'no','RengjÃ¸ring/skade lettelse avstemminger',0),(515142,14310,'da','RengÃ¸ring/skader Relief afstemninger',0),(515143,14310,'ko','ì²­ì†Œ ì†ìƒ êµ¬ì¡° ì¡°ì •',0),(515144,14310,'he','× ×™×§×•×™/× ×–×§ ×”×§×œ×” ×”×ª××ž×•×ª',0),(515145,14310,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± ÏƒÏ…Î¼Ï†Î¹Î»Î¹ÏŽÏƒÎµÎ¹Ï‚ Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ·',0),(515146,14310,'zh','æ¸…æ´—æŸå®³æ•‘æµŽå¯¹è´¦',0),(515147,14310,'sv','RengÃ¶ring/skada lÃ¤ttnad avstÃ¤mningar',0),(515148,14310,'it','Pulizia/danno sollievo riconciliazioni',0),(515149,14310,'tl','',0),(515150,14310,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¸„à¸§à¸²à¸¡à¹€à¸ªà¸µà¸¢à¸«à¸²à¸¢à¸à¸£à¸°à¸—à¸šà¸¢à¸­à¸”à¸šà¸£à¸£à¹€à¸—à¸²',0),(515151,14310,'hi','à¤°à¤¾à¤¹à¤¤ Reconciliations à¤¸à¤«à¤¾à¤ˆ/à¤¨à¥à¤•à¤¸à¤¾à¤¨',0),(515152,14310,'ms','Kering/kerosakan penyesuaian pelepasan',0),(515153,14310,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø§Ù„ØªØ³ÙˆÙŠØ§Øª Ø§Ù„Ø¥ØºØ§Ø«Ø©',0),(515154,14310,'fr','Nettoyage/dÃ©gÃ¢ts des rapprochements de secours',0),(515155,14310,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆèª¿æ•´',0),(515156,14310,'pt','Limpeza/danos reconciliaÃ§Ãµes de alÃ­vio',0),(515157,14310,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/ÑƒÑ‰ÐµÑ€Ð± Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð²Ñ‹Ð²ÐµÑ€ÐºÐ¸',0),(515158,14310,'es','Limpieza/daÃ±o alivio conciliaciones',0),(515159,14310,'de','Reinigung/Schaden Sie-Relief-Abstimmungen',0),(515160,14310,'en','Cleaning/Damage Relief Reconciliations',0),(515161,14311,'is','',0),(515162,14311,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø­ÙØ¸',0),(515163,14311,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø­ÙØ¸',0),(515164,14311,'tr','Temizlik/hasar muhafaza yardÄ±m',0),(515165,14311,'pl','Czyszczenie/uszkodzenia zwolnienia zatrzymanych',0),(515166,14311,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð°Ð·Ð²Ð°Ñ‚',0),(515167,14311,'ur','ØµÙØ§Ø¦ÛŒ/Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾ÛŒ Ø±ÛŒÙ„ÛŒÙ Ù†Ù‚ØµØ§Ù†',0),(515168,14311,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ Ð·Ð°Ð´Ñ€Ð¶Ð°Ð²Ð°Ñ˜Ñƒ',0),(515169,14311,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i giáº£m giá»¯ láº¡i',0),(515170,14311,'af','Skoonmaak/skade verligting behou',0),(515171,14311,'ro','CurÄƒÅ£are/daune Relief reÅ£inute',0),(515172,14311,'et','Puhastamine/kahju sÃ¤ilitada maksuvabastuse',0),(515173,14311,'si','ÄŒiÅ¡Äenje/Å¡kodo pomoÄ, ki ohranijo',0),(515174,14311,'ba','Pembersihan/kerusakan Relief yang dipertahankan',0),(515175,14311,'nl','Reiniging/schade Relief behouden',0),(515176,14311,'fi','Puhdistus/vahinko helpotusta sÃ¤ily',0),(515177,14311,'no','RengjÃ¸ring/skade lettelse beholdt',0),(515178,14311,'da','RengÃ¸ring/skader Relief bevares',0),(515179,14311,'ko','ì²­ì†Œ í”¼í•´ êµ¬ì œ ìœ ì§€',0),(515180,14311,'he','× ×™×§×•×™/× ×–×§ ×”×§×œ×” × ×©×ž×¨',0),(515181,14311,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ· Ï€Î¿Ï… Î´Î¹Î±Ï„Î·ÏÎ¿ÏÎ½Ï„Î±Î¹',0),(515182,14311,'zh','æ¸…æ´—æŸå®³æ•‘æµŽä¿ç•™',0),(515183,14311,'sv','RengÃ¶ring/skada lÃ¤ttnad behÃ¶ll',0),(515184,14311,'it','Pulizia/danno sollievo ha mantenuto',0),(515185,14311,'tl','',0),(515186,14311,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¸«à¸²à¸¢à¸šà¸£à¸£à¹€à¸—à¸²à¸£à¸±à¸à¸©à¸²',0),(515187,14311,'hi','à¤¸à¤«à¤¾à¤ˆ/à¤•à¥à¤·à¤¤à¤¿ à¤•à¤¾à¤¯à¤® à¤°à¤¾à¤¹à¤¤',0),(515188,14311,'ms','Kering/kerosakan pelepasan yang dikekalkan',0),(515189,14311,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø§Ù„Ø¥ØºØ§Ø«Ø© Ø§Ù„Ø§Ø­ØªÙØ§Ø¸',0),(515190,14311,'fr','Nettoyage/dommages secours retenus',0),(515191,14311,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆã‚’ä¿æŒ',0),(515192,14311,'pt','Limpeza/danos alÃ­vio retido',0),(515193,14311,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/Ð¿Ð¾Ð²Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ñ Ñ€ÐµÐ»ÑŒÐµÑ„ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ð»',0),(515194,14311,'es','Limpieza/daÃ±o alivio retenido',0),(515195,14311,'de','Reinigung/Schaden Sie Relief beibehalten',0),(515196,14311,'en','Cleaning/Damage Relief Retained',0),(515197,14312,'is','',0),(515198,14312,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø­ÙØ¸ Ú©ÙˆÙ¾Ù† Ø§Ù…Ø¯Ø§Ø¯ÛŒ',0),(515199,14312,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø­ÙØ¸ Ú©ÙˆÙ¾Ù† Ø§Ù…Ø¯Ø§Ø¯ÛŒ',0),(515200,14312,'tr','Temizlik/hasar kabartma fiÅŸ muhafaza',0),(515201,14312,'pl','Ulga czyszczenie uszkodzeÅ„ zachowana Voucher',0),(515202,14312,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð°Ð·Ð²Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(515203,14312,'ur','ØµÙØ§Ø¦ÛŒ/Ù†Ù‚ØµØ§Ù† Ø±ÛŒÙ„ÛŒÙ ÙˆØ§Ø¤Ú†Ø± Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾ÛŒ',0),(515204,14312,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ Ð·Ð°Ð´Ñ€Ð¶Ð°Ð²Ð°Ñ˜Ñƒ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(515205,14312,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i giáº£m giá»¯ láº¡i phiáº¿u',0),(515206,14312,'af','Skoonmaak/skade verligting behou bewys',0),(515207,14312,'ro','CurÄƒÅ£are/daune Relief pÄƒstrat Voucher',0),(515208,14312,'et','Puhastamine/kahju leevendamiseks sÃ¤ilitanud kanne',0),(515209,14312,'si','ÄŒiÅ¡Äenje Å¡kode Relief zadrÅ¾i kupon',0),(515210,14312,'ba','Pembersihan kerusakan Relief dipertahankan Voucher',0),(515211,14312,'nl','Reiniging/schade Relief ingehouden Voucher',0),(515212,14312,'fi','Puhdistus/vahinko helpotusta sÃ¤ilyttÃ¤Ã¤ tosite',0),(515213,14312,'no','RengjÃ¸ring/skade lettelse beholdt bilag',0),(515214,14312,'da','RengÃ¸ring/skader Relief bevares Voucher',0),(515215,14312,'ko','ì²­ì†Œ/í”¼í•´ êµ¬ì œ ìœ ì§€ ë°”ìš°ì²˜',0),(515216,14312,'he','× ×™×§×•×™/× ×–×§ ×©×•×‘×¨ ×™×ª×¨×ª ×”×¡×™×•×¢',0),(515217,14312,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ· Î´Î¹Î±Ï„Î·ÏÎ¿ÏÎ½Ï„Î±Î¹ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(515218,14312,'zh','æ¸…æ´—æŸå®³æ•‘æµŽä¿ç•™çš„å‡­è¯',0),(515219,14312,'sv','RengÃ¶ring/skada lÃ¤ttnad behÃ¶ll kupongen',0),(515220,14312,'it','Pulizia/danno sollievo mantenuto buono',0),(515221,14312,'tl','',0),(515222,14312,'th','à¸Šà¹ˆà¸§à¸¢à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¸„à¸§à¸²à¸¡à¹€à¸ªà¸µà¸¢à¸«à¸²à¸¢à¹€à¸à¹‡à¸šà¸£à¸±à¸à¸©à¸²à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸',0),(515223,14312,'hi','à¤¸à¤«à¤¾à¤ˆ/à¤•à¥à¤·à¤¤à¤¿ à¤°à¤¾à¤¹à¤¤ à¤µà¤¾à¤‰à¤šà¤° à¤•à¤¾à¤¯à¤®',0),(515224,14312,'ms','Pelepasan kering/kerosakan terkumpul baucer',0),(515225,14312,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø§Ù„Ø¥ØºØ§Ø«Ø© Ø§Ù„Ø§Ø­ØªÙØ§Ø¸ Ø¨Ø§Ù„Ø§ÙŠØµØ§Ù„',0),(515226,14312,'fr','Nettoyage/dommages secours conservÃ© bon',0),(515227,14312,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆä¿æŒä¼ç¥¨',0),(515228,14312,'pt','Limpeza/danos alÃ­vio retidos Voucher',0),(515229,14312,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/Ð¿Ð¾Ð²Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ñ Ñ€ÐµÐ»ÑŒÐµÑ„ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ð» Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(515230,14312,'es','Limpieza/daÃ±o alivio retuvo Voucher',0),(515231,14312,'de','Reinigung/Schaden Relief erhalten Gutschein',0),(515232,14312,'en','Cleaning/Damage Relief Retained Voucher',0),(515233,14313,'is','',0),(515234,14313,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(515235,14313,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø¨Ø§Ø²Ú¯Ø´Øª',0),(515236,14313,'tr','Temizlik/hasar dÃ¶ndÃ¼ kabartma',0),(515237,14313,'pl','Czyszczenie/uszkodzenia ulgÄ… powrÃ³ciÅ‚',0),(515238,14313,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸',0),(515239,14313,'ur','ØµÙØ§Ø¦ÛŒ/ÙˆØ§Ù¾Ø³ Ø±ÛŒÙ„ÛŒÙ Ù†Ù‚ØµØ§Ù†',0),(515240,14313,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾',0),(515241,14313,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i giáº£m trá»Ÿ láº¡i',0),(515242,14313,'af','Skoonmaak/skade verligting teruggekeer',0),(515243,14313,'ro','CurÄƒÅ£are/daune Relief s-a Ã®ntors',0),(515244,14313,'et','Puhastamine/kahju leevendamiseks tagastatud',0),(515245,14313,'si','ÄŒiÅ¡Äenje/Å¡kodo Relief vrnil',0),(515246,14313,'ba','Pembersihan/kerusakan Relief kembali',0),(515247,14313,'nl','Reiniging/schade Relief geretourneerd',0),(515248,14313,'fi','Puhdistus/vahinko helpotusta palasi',0),(515249,14313,'no','RengjÃ¸ring/skade lettelse returnert',0),(515250,14313,'da','RengÃ¸ring/skader Relief returneres',0),(515251,14313,'ko','ì²­ì†Œ í”¼í•´ êµ¬í˜¸ ë°˜í™˜',0),(515252,14313,'he','× ×™×§×•×™/× ×–×§ ×”×§×œ×” ×—×–×¨',0),(515253,14313,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ· ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ',0),(515254,14313,'zh','æ¸…æ´—æŸå®³æ•‘æµŽè¿”å›ž',0),(515255,14313,'sv','RengÃ¶ring/skada lÃ¤ttnad Ã¥tervÃ¤nde',0),(515256,14313,'it','Pulizia/danno sollievo restituito',0),(515257,14313,'tl','',0),(515258,14313,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¸«à¸²à¸¢à¸šà¸£à¸£à¹€à¸—à¸²à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¸„à¸·à¸™',0),(515259,14313,'hi','à¤°à¤¾à¤¹à¤¤ à¤²à¥Œà¤Ÿà¥‡ à¤¸à¤«à¤¾à¤ˆ/à¤¨à¥à¤•à¤¸à¤¾à¤¨',0),(515260,14313,'ms','Kering/kerosakan pelepasan kembali',0),(515261,14313,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø§Ù„Ø¥ØºØ§Ø«Ø© Ø¹Ø§Ø¯',0),(515262,14313,'fr','Nettoyage/dommages secours retournÃ©',0),(515263,14313,'jp','è¿”ã•ã‚Œã‚‹æ•‘æ¸ˆã®ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/æå‚·',0),(515264,14313,'pt','Limpeza/danos alÃ­vio retornado',0),(515265,14313,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/ÑƒÑ‰ÐµÑ€Ð± Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ',0),(515266,14313,'es','Limpieza/daÃ±o alivio regresado',0),(515267,14313,'de','Reinigung/Schaden Sie Relief zurÃ¼ckgegeben',0),(515268,14313,'en','Cleaning/Damage Relief Returned',0),(515269,14314,'is','',0),(515270,14314,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø¨Ø§Ø²Ú¯Ø´Øª ÙØ§Ú©ØªÙˆØ±',0),(515271,14314,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø¨Ø§Ø²Ú¯Ø´Øª ÙØ§Ú©ØªÙˆØ±',0),(515272,14314,'tr','Temizlik/hasar kabartma fatura geri dÃ¶ndÃ¼.',0),(515273,14314,'pl','Ulga czyszczenie uszkodzenia zwracane faktury',0),(515274,14314,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(515275,14314,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØµÙØ§Ø¦ÛŒ/Ù†Ù‚ØµØ§Ù† Ø±ÛŒÙ„ÛŒÙ Ù„ÙˆÙ¹ Ø¢Ø¦Û’',0),(515276,14314,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ Ñ˜Ðµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(515277,14314,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i giáº£m trá»Ÿ láº¡i hÃ³a Ä‘Æ¡n',0),(515278,14314,'af','Skoonmaak/skade verligting teruggekeer faktuur',0),(515279,14314,'ro','CurÄƒÅ£are/daune Relief Ã®ntors facturÄƒ',0),(515280,14314,'et','Puhastamine/kahju leevendamiseks tagastatud arve',0),(515281,14314,'si','ÄŒiÅ¡Äenje Å¡kode Relief vrnil raÄuna',0),(515282,14314,'ba','Pembersihan kerusakan Relief kembali faktur',0),(515283,14314,'nl','Reiniging/schade Relief geretourneerd factuur',0),(515284,14314,'fi','Puhdistus/vahinko helpotusta palasi laskun',0),(515285,14314,'no','RengjÃ¸ring/skade lettelse returnerte faktura',0),(515286,14314,'da','RengÃ¸ring/skader Relief returneres faktura',0),(515287,14314,'ko','ì²­ì†Œ/í”¼í•´ êµ¬ì œ ë°˜í™˜ ì²­êµ¬ì„œ',0),(515288,14314,'he','× ×™×§×•×™/× ×–×§ ×”×§×œ×” ×—×–×¨ ×—×©×‘×•× ×™×ª',0),(515289,14314,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ· ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(515290,14314,'zh','æ¸…æ´—æŸå®³æ•‘æµŽè¿”å›žå‘ç¥¨',0),(515291,14314,'sv','RengÃ¶ring/skada lÃ¤ttnad Ã¥tervÃ¤nde faktura',0),(515292,14314,'it','Pulizia/danno sollievo restituito fattura',0),(515293,14314,'tl','',0),(515294,14314,'th','à¸Šà¹ˆà¸§à¸¢à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¸„à¸§à¸²à¸¡à¹€à¸ªà¸µà¸¢à¸«à¸²à¸¢à¸ªà¹ˆà¸‡à¸„à¸·à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(515295,14314,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥€ à¤¸à¤«à¤¾à¤ˆ/à¤•à¥à¤·à¤¤à¤¿ à¤°à¤¾à¤¹à¤¤ à¤²à¥Œà¤Ÿà¥‡',0),(515296,14314,'ms','Pelepasan kering/kerosakan kembali invois',0),(515297,14314,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø§Ù„Ø¥ØºØ§Ø«Ø© Ø¹Ø§Ø¯ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(515298,14314,'fr','Nettoyage/dommages secours retournÃ© facture',0),(515299,14314,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆè«‹æ±‚ã‚’è¿”ã•ã‚Œã‚‹',0),(515300,14314,'pt','Limpeza/danos alÃ­vio retornado a factura',0),(515301,14314,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/ÑƒÑ‰ÐµÑ€Ð± Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð²ÐµÑ€Ð½ÑƒÐ»ÑÑ ÑÑ‡ÐµÑ‚Ð°',0),(515302,14314,'es','Limpieza/daÃ±o alivio regresado factura',0),(515303,14314,'de','Reinigung/Schaden Relief zurÃ¼ckgegeben Rechnung',0),(515304,14314,'en','Cleaning/Damage Relief Returned Invoice',0),(515305,14315,'is','',0),(515306,14315,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ',0),(515307,14315,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ',0),(515308,14315,'tr','Ä°lk evde beslenen hayvan Ã¼creti',0),(515309,14315,'pl','PieÅ›ciÄ‡ opÅ‚aty wstÄ™pnej',0),(515310,14315,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ñ‚Ð°ÐºÑÐ° Ð·Ð° Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð»ÑŽÐ±Ð¸Ð¼Ñ†Ð¸',0),(515311,14315,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ±ÙˆÚº Ú©ÛŒ ÙÛŒØ³',0),(515312,14315,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ñƒ Ð½Ð°ÐºÐ½Ð°Ð´Ñƒ Ð·Ð° Ñ™ÑƒÐ±Ð¸Ð¼Ñ†Ð°',0),(515313,14315,'vi','Khoáº£n phÃ­ ban Ä‘áº§u váº­t nuÃ´i',0),(515314,14315,'af','Aanvanklike troeteldier fooi',0),(515315,14315,'ro','Taxa iniÅ£ialÄƒ de animal de casÄƒ',0),(515316,14315,'et','Esialgse tasu lemmiklooma eest',0),(515317,14315,'si','ZaÄetno pristojbino jjeza',0),(515318,14315,'ba','Awal biaya hewan peliharaan',0),(515319,14315,'nl','InitiÃ«le huisdier kosten',0),(515320,14315,'fi','EnsimmÃ¤inen LemmikkielÃ¤inmaksu',0),(515321,14315,'no','Innledende Pet gebyr',0),(515322,14315,'da','Indledende Pet gebyr',0),(515323,14315,'ko','ì´ˆê¸° ì• ì™„ ë™ë¬¼ ë¹„ìš©',0),(515324,14315,'he','×“×ž×™ ×œ×—×™×•×ª ×ž×—×ž×“',0),(515325,14315,'el','Î‘ÏÏ‡Î¹ÎºÎ® Ï‡ÏÎ­Ï‰ÏƒÎ· ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Ï‰Î½ Î¶ÏŽÏ‰Î½',0),(515326,14315,'zh','åˆå§‹å® ç‰©è´¹',0),(515327,14315,'sv','SÃ¤llskapsdjur startavgift',0),(515328,14315,'it','Supplemento per animali domestici iniziale',0),(515329,14315,'tl','',0),(515330,14315,'th','à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(515331,14315,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤ªà¤¾à¤²à¤¤à¥‚ à¤¶à¥à¤²à¥à¤•',0),(515332,14315,'ms','Kos haiwan kesayangan yang awal',0),(515333,14315,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(515334,14315,'fr','PremiÃ¨re somme pour animaux de compagnie',0),(515335,14315,'jp','åˆæœŸã®ãƒšãƒƒãƒˆæ–™é‡‘',0),(515336,14315,'pt','Taxa de estimaÃ§Ã£o inicial',0),(515337,14315,'ru','ÐŸÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸Ðµ Ð¶Ð¸Ð²Ð¾Ñ‚Ð½Ñ‹Ðµ',0),(515338,14315,'es','Cuota inicial del animal domÃ©stico',0),(515339,14315,'de','Haustier Ausgabeaufschlag',0),(515340,14315,'en','Initial Pet Fee',0),(515341,14316,'is','',0),(515342,14316,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ù¾Øª GL Ø­Ø³Ø§Ø¨',0),(515343,14316,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ù¾Øª GL Ø­Ø³Ø§Ø¨',0),(515344,14316,'tr','Ä°lk evde beslenen hayvan Ã¼cret GL hesabÄ±',0),(515345,14316,'pl','Konto GL pieÅ›ciÄ‡ opÅ‚aty wstÄ™pnej',0),(515346,14316,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ñ‚Ð°ÐºÑÐ° Ð·Ð° Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(515347,14316,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ±ÙˆÚº Ú©ÛŒ ÙÛŒØ³ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(515348,14316,'sr','ÐšÐ¾Ð½Ñ‚Ð° Ð“Ð› Ð¿Ð¾Ñ‡ÐµÑ‚Ð½Ñƒ Ð½Ð°ÐºÐ½Ð°Ð´Ñƒ Ð·Ð° Ñ™ÑƒÐ±Ð¸Ð¼Ñ†Ð°',0),(515349,14316,'vi','Khoáº£n phÃ­ ban Ä‘áº§u váº­t nuÃ´i GL tÃ i khoáº£n',0),(515350,14316,'af','Aanvanklike troeteldier fooi GL rekening',0),(515351,14316,'ro','Cont de GL iniÅ£ialÄƒ taxa animal de casÄƒ',0),(515352,14316,'et','Esialgse tasu lemmiklooma eest pearaamatukontole',0),(515353,14316,'si','ZaÄetno pristojbino jjeza GL raÄun',0),(515354,14316,'ba','Biaya hewan peliharaan awal GL Account',0),(515355,14316,'nl','InitiÃ«le huisdier kosten GL Account',0),(515356,14316,'fi','HellitellÃ¤ aloitusmaksun Kirjanpitotilin pÃ¤Ã¤tilin',0),(515357,14316,'no','Innledende Pet gebyr gi-konto',0),(515358,14316,'da','Indledende Pet gebyr GL konto',0),(515359,14316,'ko','ì´ˆê¸° ì• ì™„ ë™ë¬¼ ë¹„ìš© GL ê³„ì •',0),(515360,14316,'he','×—×©×‘×•×Ÿ GL ×“×ž×™ ×œ×—×™×•×ª ×ž×—×ž×“',0),(515361,14316,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ Î¶ÏŽÎ¿ Ï‡ÏÎ­Ï‰ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(515362,14316,'zh','åˆå§‹å® ç‰©è´¹æ€»å¸ç§‘ç›®',0),(515363,14316,'sv','SÃ¤llskapsdjur startavgift GL konto',0),(515364,14316,'it','Supplemento per animali domestici iniziale GL Account',0),(515365,14316,'tl','',0),(515366,14316,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(515367,14316,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤¶à¥à¤²à¥à¤• à¤•à¥‡ à¤ªà¤¾à¤²à¤¤à¥‚ GL à¤–à¤¾à¤¤à¥‡',0),(515368,14316,'ms','Kos haiwan kesayangan awal GL akaun',0),(515369,14316,'ar','Ø­Ø³Ø§Ø¨ GL Ø±Ø³ÙˆÙ… Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(515370,14316,'fr','Compte GL initial Fee pour animaux de compagnie',0),(515371,14316,'jp','åˆæœŸã®ãƒšãƒƒãƒˆæ–™é‡‘ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(515372,14316,'pt','Taxa de estimaÃ§Ã£o inicial GL conta',0),(515373,14316,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ GL Ð¿ÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸Ðµ Ð¶Ð¸Ð²Ð¾Ñ‚Ð½Ñ‹Ðµ',0),(515374,14316,'es','Mascotas inicial GL cuenta',0),(515375,14316,'de','Haustier Ausgabeaufschlag Sako',0),(515376,14316,'en','Initial Pet Fee GL Account',0),(515377,14317,'is','',0),(515378,14317,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ù¾Øª Ø­ÙØ¸',0),(515379,14317,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ù¾Øª Ø­ÙØ¸',0),(515380,14317,'tr','Ä°lk evde beslenen hayvan Ã¼creti muhafaza',0),(515381,14317,'pl','PieÅ›ciÄ‡ opÅ‚aty wstÄ™pnej, zachowane',0),(515382,14317,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÐµÐ½ Ð³Ð°Ð»ÐµÐ½Ð¸Ðº Ñ‚Ð°ÐºÑÐ° Ð·Ð°Ð¿Ð°Ð·Ð²Ð°Ñ‚',0),(515383,14317,'ur','Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾ÛŒ Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ±ÙˆÚº Ú©ÛŒ ÙÛŒØ³',0),(515384,14317,'sr','Ð˜Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ Ñ™ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ð½Ð°ÐºÐ½Ð°Ð´Ð° Ð·Ð°Ð´Ñ€Ð¶Ð°Ð²Ð°Ñ˜Ñƒ',0),(515385,14317,'vi','Ban Ä‘áº§u chi phÃ­ váº­t nuÃ´i giá»¯ láº¡i',0),(515386,14317,'af','Aanvanklike troeteldier fooi behou',0),(515387,14317,'ro','IniÅ£ial taxa animal de casÄƒ pÄƒstreazÄƒ',0),(515388,14317,'et','Jaotamata esialgse lemmiklooma tasu',0),(515389,14317,'si','ZaÄetno pristojbino jjeza ohranijo',0),(515390,14317,'ba','Awal biaya hewan peliharaan yang dipertahankan',0),(515391,14317,'nl','InitiÃ«le huisdier kosten behouden',0),(515392,14317,'fi','SÃ¤ilyttÃ¤Ã¤ alkuperÃ¤isen LemmikkielÃ¤inmaksu',0),(515393,14317,'no','Innledende Pet gebyr beholdt',0),(515394,14317,'da','Indledende Pet gebyr bevaret',0),(515395,14317,'ko','ì´ˆê¸° ì• ì™„ ë™ë¬¼ ë¹„ìš© ìœ ì§€',0),(515396,14317,'he','×“×ž×™ ×ž×—×ž×“ × ×©×ž×¨',0),(515397,14317,'el','Î‘ÏÏ‡Î¹ÎºÎ® Ï‡ÏÎ­Ï‰ÏƒÎ· ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Ï‰Î½ Î¶ÏŽÏ‰Î½ Ï€Î¿Ï… Î´Î¹Î±Ï„Î·ÏÎ¿ÏÎ½Ï„Î±Î¹',0),(515398,14317,'zh','ä¿ç•™çš„åˆå§‹å® ç‰©è´¹',0),(515399,14317,'sv','SÃ¤llskapsdjur startavgift behÃ¶ll',0),(515400,14317,'it','Supplemento per animali domestici iniziale ha mantenuto',0),(515401,14317,'tl','',0),(515402,14317,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸—à¸µà¹ˆà¸£à¸±à¸à¸©à¸²à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(515403,14317,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤ªà¤¾à¤²à¤¤à¥‚ à¤¶à¥à¤²à¥à¤• à¤•à¤¾à¤¯à¤®',0),(515404,14317,'ms','Awal kos haiwan kesayangan yang dikekalkan',0),(515405,14317,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø§Ù„Ø£ÙˆÙ„Ù‰ Ø§Ù„Ø§Ø­ØªÙØ§Ø¸',0),(515406,14317,'fr','Frais pour animaux de compagnie initial conservÃ©',0),(515407,14317,'jp','åˆæœŸã®ãƒšãƒƒãƒˆæ–™é‡‘ã‚’ä¿æŒ',0),(515408,14317,'pt','Inicial taxa de animais mantida',0),(515409,14317,'ru','ÐŸÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸Ðµ Ð¶Ð¸Ð²Ð¾Ñ‚Ð½Ñ‹Ðµ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ð»Ð¸',0),(515410,14317,'es','Inicial mascotas retenidas',0),(515411,14317,'de','Haustier Ausgabeaufschlag beibehalten',0),(515412,14317,'en','Initial Pet Fee Retained',0),(515413,14318,'is','',0),(515414,14318,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ù¾Øª Ø¨Ø§Ø²Ú¯Ø´Øª',0),(515415,14318,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ù¾Øª Ø¨Ø§Ø²Ú¯Ø´Øª',0),(515416,14318,'tr','DÃ¶ndÃ¼rÃ¼len ilk evde beslenen hayvan Ã¼creti',0),(515417,14318,'pl','OpÅ‚aty wstÄ™pnej pieÅ›ciÄ‡ zwracany',0),(515418,14318,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÐµÐ½ Ð³Ð°Ð»ÐµÐ½Ð¸Ðº Ñ‚Ð°ÐºÑÐ° Ð²ÑŠÑ€Ð½Ð°Ñ‚Ð¸',0),(515419,14318,'ur','ÙˆØ§Ù¾Ø³ Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ±ÙˆÚº Ú©ÛŒ ÙÛŒØ³',0),(515420,14318,'sr','Ð˜Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ Ñ™ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ð½Ð°ÐºÐ½Ð°Ð´Ð° ÑÐµ Ð²Ñ€Ð°Ñ‚Ð¸Ð¾',0),(515421,14318,'vi','Ban Ä‘áº§u chi phÃ­ váº­t nuÃ´i trá»Ÿ láº¡i',0),(515422,14318,'af','Aanvanklike troeteldier fooi teruggekeer',0),(515423,14318,'ro','Taxa animal de casÄƒ iniÅ£ialÄƒ a revenit',0),(515424,14318,'et','Esialgse lemmiklooma tasu tagastatakse',0),(515425,14318,'si','ZaÄetno pristojbino jjeza vrnil',0),(515426,14318,'ba','Awal biaya hewan peliharaan tidak kembali',0),(515427,14318,'nl','InitiÃ«le huisdier kosten geretourneerd',0),(515428,14318,'fi','Palauttaa alkuperÃ¤isen LemmikkielÃ¤inmaksu',0),(515429,14318,'no','Innledende Pet gebyr returnert',0),(515430,14318,'da','Indledende Pet gebyr returneret',0),(515431,14318,'ko','ì´ˆê¸° ì• ì™„ ë™ë¬¼ ìˆ˜ìˆ˜ë£Œ ë°˜í™˜',0),(515432,14318,'he','×“×ž×™ ×ž×—×ž×“ ×—×–×¨',0),(515433,14318,'el','Î‘ÏÏ‡Î¹ÎºÎ® Ï‡ÏÎ­Ï‰ÏƒÎ· ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Ï‰Î½ Î¶ÏŽÏ‰Î½ Ï€Î¿Ï… ÎµÏ€Î­ÏƒÏ„ÏÎµÏˆÎµ',0),(515434,14318,'zh','è¿”å›žçš„åˆå§‹å® ç‰©è´¹',0),(515435,14318,'sv','SÃ¤llskapsdjur startavgift Ã¥tervÃ¤nde',0),(515436,14318,'it','Supplemento per animali domestici iniziale restituito',0),(515437,14318,'tl','',0),(515438,14318,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡à¸„à¹ˆà¸²à¸ªà¹ˆà¸‡à¸à¸¥à¸±à¸š',0),(515439,14318,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤ªà¤¾à¤²à¤¤à¥‚ à¤¶à¥à¤²à¥à¤• à¤²à¥Œà¤Ÿà¤¾',0),(515440,14318,'ms','Awal kos haiwan kesayangan yang kembali',0),(515441,14318,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø§Ù„Ø£ÙˆÙ„Ù‰ Ø¹Ø§Ø¯',0),(515442,14318,'fr','Frais pour animaux de compagnie initial retournÃ©',0),(515443,14318,'jp','è¿”ã•ã‚Œã‚‹æœ€åˆã®ãƒšãƒƒãƒˆæ–™é‡‘',0),(515444,14318,'pt','Taxa de estimaÃ§Ã£o inicial retornada',0),(515445,14318,'ru','ÐŸÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸Ðµ Ð¶Ð¸Ð²Ð¾Ñ‚Ð½Ñ‹Ðµ Ð²ÐµÑ€Ð½ÑƒÐ»Ð¸ÑÑŒ',0),(515446,14318,'es','Mascotas inicial devuelto',0),(515447,14318,'de','Haustier Ausgabeaufschlag zurÃ¼ckgegeben',0),(515448,14318,'en','Initial Pet Fee Returned',0),(515449,14319,'is','',0),(515450,14319,'dr','Ø®ÙˆØ¯Ø±Ùˆ-Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ',0),(515451,14319,'pr','Ø®ÙˆØ¯Ø±Ùˆ-Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ',0),(515452,14319,'tr','Otomatik Ã¶deme',0),(515453,14319,'pl','Auto-Billing',0),(515454,14319,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(515455,14319,'ur','Ø®ÙˆØ¯Ú©Ø§Ø±-Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(515456,14319,'sr','ÐÑƒÑ‚Ð¾-Ð½Ð°Ð¿Ð»Ð°Ñ‚Ðµ',0),(515457,14319,'vi','Thanh toÃ¡n tá»± Ä‘á»™ng',0),(515458,14319,'af','Outo-fakturering',0),(515459,14319,'ro','Auto-facturare',0),(515460,14319,'et','Auto-arved',0),(515461,14319,'si','Auto-obraÄun',0),(515462,14319,'ba','Auto-Billing',0),(515463,14319,'nl','Auto-Billing',0),(515464,14319,'fi','Automaattisen laskutuksen',0),(515465,14319,'no','Auto-fakturering',0),(515466,14319,'da','Auto-fakturering',0),(515467,14319,'ko','ìžë™ ê²°ì œ',0),(515468,14319,'he','×—×™×•×‘ ××•×˜×•×ž×˜×™',0),(515469,14319,'el','Auto-Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(515470,14319,'zh','è‡ªåŠ¨è®¡è´¹',0),(515471,14319,'sv','Auto-fakturering',0),(515472,14319,'it','Auto-fatturazione',0),(515473,14319,'tl','',0),(515474,14319,'th','à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(515475,14319,'hi','à¤‘à¤Ÿà¥‹-à¤¬à¤¿à¤²à¤¿à¤‚à¤—',0),(515476,14319,'ms','Bil automatik',0),(515477,14319,'ar','Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª-Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(515478,14319,'fr','Auto-facturation',0),(515479,14319,'jp','è‡ªå‹•è«‹æ±‚',0),(515480,14319,'pt','Auto-facturaÃ§Ã£o',0),(515481,14319,'ru','ÐÐ²Ñ‚Ð¾ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³',0),(515482,14319,'es','Auto-facturaciÃ³n',0),(515483,14319,'de','Auto-Billing',0),(515484,14319,'en','Auto-Billing',0),(515485,14320,'is','',0),(515486,14320,'dr','Ú©Ù„Ø§Ø³ Ù…Ø³ØªØ§Ø¬Ø±',0),(515487,14320,'pr','Ú©Ù„Ø§Ø³ Ù…Ø³ØªØ§Ø¬Ø±',0),(515488,14320,'tr','KiracÄ± sÄ±nÄ±fÄ±',0),(515489,14320,'pl','Klasa najemcy',0),(515490,14320,'bg','ÐšÐ»Ð°Ñ Ð½Ð° Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»Ñ',0),(515491,14320,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ú©Ø§ Ø·Ø¨Ù‚Û',0),(515492,14320,'sr','ÐšÐ»Ð°ÑÐ° ÑÑ‚Ð°Ð½Ð°Ñ€',0),(515493,14320,'vi','CÃ¡c lá»›p há»c cá»§a ngÆ°á»i thuÃª nhÃ ',0),(515494,14320,'af','Klas van huurder',0),(515495,14320,'ro','Clasa de chiriaÅŸ',0),(515496,14320,'et','ÃœÃ¼rnik klass',0),(515497,14320,'si','Razred najemnik',0),(515498,14320,'ba','Kelas penyewa',0),(515499,14320,'nl','Klasse van huurder',0),(515500,14320,'fi','Luokan vuokralainen',0),(515501,14320,'no','Klasse av leietaker',0),(515502,14320,'da','Klasse af lejer',0),(515503,14320,'ko','ê±°ì£¼ìžì˜ í´ëž˜ìŠ¤',0),(515504,14320,'he','×ž×—×œ×§×” ×©×œ ×”×“×™×™×¨',0),(515505,14320,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï„Î¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(515506,14320,'zh','ç±»çš„ç§Ÿå®¢',0),(515507,14320,'sv','Klass av hyresgÃ¤sten',0),(515508,14320,'it','Classe dell\'inquilino',0),(515509,14320,'tl','',0),(515510,14320,'th','à¸›à¸£à¸°à¹€à¸ à¸—à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(515511,14320,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤•à¥€ à¤•à¥à¤²à¤¾à¤¸',0),(515512,14320,'ms','Kelas penyewa',0),(515513,14320,'ar','ÙØ¦Ø© Ù…Ù† Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(515514,14320,'fr','Classe du locataire',0),(515515,14320,'jp','ãƒ†ãƒŠãƒ³ãƒˆã®ã‚¯ãƒ©ã‚¹',0),(515516,14320,'pt','Classe de inquilino',0),(515517,14320,'ru','ÐšÐ»Ð°ÑÑ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€Ð¾Ð²',0),(515518,14320,'es','Clase del inquilino',0),(515519,14320,'de','Klasse des PÃ¤chters',0),(515520,14320,'en','Class Of Tenant',0),(515521,14321,'is','',0),(515522,14321,'dr','ØªØ§Ø±ÛŒØ® Ø§Ù…Ø¶Ø§',0),(515523,14321,'pr','ØªØ§Ø±ÛŒØ® Ø§Ù…Ø¶Ø§',0),(515524,14321,'tr','KayÄ±t tarihi',0),(515525,14321,'pl','Daty podpisania',0),(515526,14321,'bg','Ð”Ð°Ñ‚Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½',0),(515527,14321,'ur','ØªØ§Ø±ÛŒØ® Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Ø¦Û’',0),(515528,14321,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°Ð¾',0),(515529,14321,'vi','NgÃ y Ä‘Äƒng',0),(515530,14321,'af','Datum geteken',0),(515531,14321,'ro','Data semnat',0),(515532,14321,'et','Allkirjastamise kuupÃ¤evast',0),(515533,14321,'si','Datum podpisali',0),(515534,14321,'ba','Tanggal masuk',0),(515535,14321,'nl','Ondertekening',0),(515536,14321,'fi','PÃ¤ivÃ¤ys',0),(515537,14321,'no','Dato signert',0),(515538,14321,'da','Dato underskrevet',0),(515539,14321,'ko','ì„œëª… ë‚ ì§œ',0),(515540,14321,'he','×ª××¨×™×š ×—×ª×™×ž×”',0),(515541,14321,'el','Î¥Ï€Î¿Î³ÏÎ±Ï†Î®',0),(515542,14321,'zh','ç­¾ç½²æ—¥æœŸ',0),(515543,14321,'sv','Dag undertecknades',0),(515544,14321,'it','Data firmata',0),(515545,14321,'tl','',0),(515546,14321,'th','à¸§à¸±à¸™à¸¥à¸‡à¸™à¸²à¸¡',0),(515547,14321,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤¿à¤',0),(515548,14321,'ms','Tarikh ditandatangani',0),(515549,14321,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªÙˆÙ‚ÙŠØ¹',0),(515550,14321,'fr','Date de signature',0),(515551,14321,'jp','ç½²åæ—¥ä»˜',0),(515552,14321,'pt','Data assinada',0),(515553,14321,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(515554,14321,'es','Fecha de firma',0),(515555,14321,'de','Datum unterzeichnet',0),(515556,14321,'en','Date Signed',0),(515557,14322,'is','',0),(515558,14322,'dr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† Ø§Ø¬Ø§Ø±Ù‡',0),(515559,14322,'pr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† Ø§Ø¬Ø§Ø±Ù‡',0),(515560,14322,'tr','Kira bitiÅŸ tarihi',0),(515561,14322,'pl','Data zakoÅ„czenia umowy najmu',0),(515562,14322,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(515563,14322,'ur','Ù„ÛŒØ² Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(515564,14322,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð·Ð° Ð½Ð°Ñ˜Ð°Ð¼',0),(515565,14322,'vi','NgÃ y káº¿t thÃºc cho thuÃª',0),(515566,14322,'af','Einddatum van huurkontrak',0),(515567,14322,'ro','Data de sfÃ¢rÅŸit de Ã®nchiriere',0),(515568,14322,'et','ÃœÃ¼rilepingu lÃµpetamine',0),(515569,14322,'si','KonÄni datum najema',0),(515570,14322,'ba','Tanggal akhir dari sewa',0),(515571,14322,'nl','Einddatum van Lease',0),(515572,14322,'fi','Vuokrasopimuksen pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(515573,14322,'no','Sluttdatoen for Lease',0),(515574,14322,'da','Slutdatoen for Lease',0),(515575,14322,'ko','ìž„ëŒ€ì˜ ì¢…ë£Œ ë‚ ì§œ',0),(515576,14322,'he','×ª××¨×™×š ×”×¡×™×•× ×©×œ ×”×—×•×–×”',0),(515577,14322,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(515578,14322,'zh','ç§Ÿèµç»“æŸæ—¥æœŸ',0),(515579,14322,'sv','Slutdatum fÃ¶r leasing',0),(515580,14322,'it','Data di scadenza del contratto di locazione',0),(515581,14322,'tl','',0),(515582,14322,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸‚à¸­à¸‡à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(515583,14322,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥€ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(515584,14322,'ms','Tarikh tamat pajakan',0),(515585,14322,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(515586,14322,'fr','Date de fin du bail',0),(515587,14322,'jp','ãƒªãƒ¼ã‚¹ã®çµ‚äº†æ—¥',0),(515588,14322,'pt','Data de tÃ©rmino do contrato de leasing',0),(515589,14322,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(515590,14322,'es','Fecha de finalizaciÃ³n de contrato de arrendamiento',0),(515591,14322,'de','Enddatum des Mietvertrags',0),(515592,14322,'en','End Date Of Lease',0),(515593,14323,'is','',0),(515594,14323,'dr','Ø§Ø¬Ø§Ø±Ù‡ Ø§Ù…Ø¶Ø§ - Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(515595,14323,'pr','Ø§Ø¬Ø§Ø±Ù‡ Ø§Ù…Ø¶Ø§ - Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(515596,14323,'tr','Ä°mzalÄ± kiralarÄ± - aylÄ±k',0),(515597,14323,'pl','Podpisane umowy najmu - miesiÄ™cznie',0),(515598,14323,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¾ Ð»Ð¸Ð·Ð¸Ð½Ð³ - Ð¼ÐµÑÐµÑ‡Ð½Ð¾',0),(515599,14323,'ur','Ø¯Ø³ØªØ®Ø· Ø´Ø¯Û Ù„ÙÛŒØ²Ø² - Ù…Ø§ÛØ§Ù†Û',0),(515600,14323,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ°Ð½Ð¸ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸ - Ð¼Ñ˜ÐµÑÐµÑ‡Ð½Ð¾',0),(515601,14323,'vi','Cho thuÃª kÃ½ - hÃ ng thÃ¡ng',0),(515602,14323,'af','Getekende huurooreenkomste - maandeliks',0),(515603,14323,'ro','Semnat contracte de leasing - lunar',0),(515604,14323,'et','Allkirjastatud rent - kuu',0),(515605,14323,'si','Podpisana Najemi - meseÄno',0),(515606,14323,'ba','Sewa ditandatangani - bulanan',0),(515607,14323,'nl','Ondertekende Leases - maandelijks',0),(515608,14323,'fi','Allekirjoitettu vuokrasopimukset - kuukausittain',0),(515609,14323,'no','Signert leiekontrakter - mÃ¥nedlig',0),(515610,14323,'da','Signeret lejemÃ¥l - mÃ¥nedlig',0),(515611,14323,'ko','ì„œëª… ëœ ìž„ëŒ€-ì›”ê°„',0),(515612,14323,'he','×—×›×™×¨×” ×—×ª×•× - ×—×•×“×©×™',0),(515613,14323,'el','Î¥Ï€Î¿Î³ÏÎ±Ï†Î® Î¼Î¹ÏƒÎ¸ÏŽÏƒÎµÎ¹Ï‚ - Î¼Î·Î½Î¹Î±Î¯Î±',0),(515614,14323,'zh','ç­¾è®¢çš„ç§Ÿçº¦ â€” â€” æ¯æœˆ',0),(515615,14323,'sv','Undertecknat leasingavtal - mÃ¥nadsvis',0),(515616,14323,'it','Firmato contratti di locazione - mensile',0),(515617,14323,'tl','',0),(515618,14323,'th','à¸¥à¸‡à¸™à¸²à¸¡à¹€à¸Šà¹ˆà¸² - à¸£à¸²à¸¢à¹€à¸”à¸·à¸­à¸™',0),(515619,14323,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤¿à¤¤ à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚ - à¤®à¤¾à¤¸à¤¿à¤•',0),(515620,14323,'ms','Pajakan ditandatangani - bulanan',0),(515621,14323,'ar','Ø¹Ù‚ÙˆØ¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± Ø§Ù„Ù…ÙˆÙ‚Ø¹Ø©-Ø´Ù‡Ø±ÙŠØ§',0),(515622,14323,'fr','Baux signÃ©s - mensuel',0),(515623,14323,'jp','ç½²åã•ã‚ŒãŸãƒªãƒ¼ã‚¹ - æ¯Žæœˆ',0),(515624,14323,'pt','Assinado locaÃ§Ãµes - mensal',0),(515625,14323,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð½Ñ‹Ñ… Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð¾Ð² Ð°Ñ€ÐµÐ½Ð´Ñ‹ - ÐµÐ¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ð¾',0),(515626,14323,'es','Contratos de arrendamiento firmados - mensual',0),(515627,14323,'de','Signierte Leases - monatlich',0),(515628,14323,'en','Signed Leases - Monthly',0),(515629,14324,'is','',0),(515630,14324,'dr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡ Ù†Ø§Ù…Ù‡',0),(515631,14324,'pr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡ Ù†Ø§Ù…Ù‡',0),(515632,14324,'tr','Kira baÅŸlangÄ±Ã§ tarihi',0),(515633,14324,'pl','Data rozpoczÄ™cia leasingu',0),(515634,14324,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(515635,14324,'ur','Ù„ÛŒØ² Ú©ÛŒ Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØªØ§Ø±ÛŒØ®',0),(515636,14324,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð·Ð° Ð½Ð°Ñ˜Ð°Ð¼',0),(515637,14324,'vi','NgÃ y báº¯t Ä‘áº§u cho thuÃª',0),(515638,14324,'af','Begin datum van huurkontrak',0),(515639,14324,'ro','Data de Ã®nceput a inchirierii',0),(515640,14324,'et','ÃœÃ¼rilepingu alguskuupÃ¤ev',0),(515641,14324,'si','ZaÄetni datum najema',0),(515642,14324,'ba','Tanggal mulai sewa',0),(515643,14324,'nl','Begindatum van Lease',0),(515644,14324,'fi','Vuokrasopimuksen alkamispÃ¤ivÃ¤',0),(515645,14324,'no','Startdatoen for Lease',0),(515646,14324,'da','Startdatoen for Lease',0),(515647,14324,'ko','ìž„ëŒ€ ì‹œìž‘ ë‚ ì§œ',0),(515648,14324,'he','×ª××¨×™×š ×”×”×ª×—×œ×” ×©×œ ×”×—×•×–×”',0),(515649,14324,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(515650,14324,'zh','ç§Ÿèµçš„å¼€å§‹æ—¥æœŸ',0),(515651,14324,'sv','Startdatum fÃ¶r leasing',0),(515652,14324,'it','Data di inizio del contratto di locazione',0),(515653,14324,'tl','',0),(515654,14324,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸‚à¸­à¸‡à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²',0),(515655,14324,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‡ à¤•à¥€ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¤à¤¿à¤¥à¤¿',0),(515656,14324,'ms','Tarikh mula pajakan',0),(515657,14324,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(515658,14324,'fr','Date de dÃ©but du contrat de location',0),(515659,14324,'jp','ãƒªãƒ¼ã‚¹ã®é–‹å§‹æ—¥',0),(515660,14324,'pt','Data de inÃ­cio do contrato de leasing',0),(515661,14324,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(515662,14324,'es','Fecha de inicio del contrato de arrendamiento',0),(515663,14324,'de','Startdatum der Lease',0),(515664,14324,'en','Start Date Of Lease',0),(515665,14325,'is','',0),(515666,14325,'dr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡',0),(515667,14325,'pr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡',0),(515668,14325,'tr','Kiralama baÅŸlangÄ±Ã§ tarihi',0),(515669,14325,'pl','Data rozpoczÄ™cia leasingu',0),(515670,14325,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³',0),(515671,14325,'ur','Ù„ÙÛŒØ²Ø² Ú©ÛŒ Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØªØ§Ø±ÛŒØ®',0),(515672,14325,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð¸',0),(515673,14325,'vi','NgÃ y báº¯t Ä‘áº§u cá»§a cho thuÃª',0),(515674,14325,'af','Begin datum van huurooreenkomste',0),(515675,14325,'ro','Data de Ã®nceput a contractelor de leasing',0),(515676,14325,'et','Rendilepingute alguskuupÃ¤ev',0),(515677,14325,'si','ZaÄetni datum najema',0),(515678,14325,'ba','Tanggal mulai dari sewa',0),(515679,14325,'nl','Begindatum van lease-overeenkomsten',0),(515680,14325,'fi','AloituspÃ¤ivÃ¤ vuokrasopimukset',0),(515681,14325,'no','Startdatoen for leieavtaler',0),(515682,14325,'da','Startdatoen for lejemÃ¥l',0),(515683,14325,'ko','ìž„ëŒ€ ì‹œìž‘ ë‚ ì§œ',0),(515684,14325,'he','×ª××¨×™×š ×”×”×ª×—×œ×” ×©×œ ×—×›×™×¨×”',0),(515685,14325,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Ï„Î·Ï‚ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(515686,14325,'zh','ç§Ÿçº¦çš„å¼€å§‹æ—¥æœŸ',0),(515687,14325,'sv','Startdatum fÃ¶r leasing',0),(515688,14325,'it','Data di inizio delle operazioni di leasing',0),(515689,14325,'tl','',0),(515690,14325,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹€à¸Šà¹ˆà¸²',0),(515691,14325,'hi','à¤ªà¤Ÿà¥à¤Ÿà¥‹à¤‚ à¤•à¥€ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¤à¤¿à¤¥à¤¿',0),(515692,14325,'ms','Tarikh mula pajakan',0),(515693,14325,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(515694,14325,'fr','Date de dÃ©but du bail',0),(515695,14325,'jp','ãƒªãƒ¼ã‚¹ã®é–‹å§‹æ—¥',0),(515696,14325,'pt','Data de inÃ­cio de locaÃ§Ãµes',0),(515697,14325,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ð°Ñ€ÐµÐ½Ð´Ñ‹',0),(515698,14325,'es','Fecha de inicio de arrendamientos',0),(515699,14325,'de','Startdatum des Leasings',0),(515700,14325,'en','Start Date Of Leases',0),(515701,14326,'is','',0),(515702,14326,'dr','Ø§Ø¬Ø§Ø±Ù‡ ÙØ¹Ø§Ù„ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù†',0),(515703,14326,'pr','Ø§Ø¬Ø§Ø±Ù‡ ÙØ¹Ø§Ù„ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù†',0),(515704,14326,'tr','Etkin kira olarak',0),(515705,14326,'pl','DzierÅ¼awa aktywna w',0),(515706,14326,'bg','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³ ÐºÐ°Ñ‚Ð¾ Ð½Ð°',0),(515707,14326,'ur','Ø²ÛŒØ± Ø¹Ù…Ù„ Ù„ÛŒØ² Ú©Û’ Ø·ÙˆØ± Ù¾Ø±',0),(515708,14326,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð¸Ð·Ð½Ð°Ñ˜Ð¼Ñ™Ð¸Ð²Ð°ÑšÐµ ÐºÐ°Ð¾',0),(515709,14326,'vi','Cho thuÃª hoáº¡t Ä‘á»™ng nhÆ°',0),(515710,14326,'af','Aktiewe huurkontrak As van',0),(515711,14326,'ro','Leasing active ca de',0),(515712,14326,'et','Aktiivne liisingu AS',0),(515713,14326,'si','Aktivno najem kot',0),(515714,14326,'ba','Sewa aktif sebagai',0),(515715,14326,'nl','Actieve Lease als van',0),(515716,14326,'fi','Aktiivinen vuokrasopimuksen kuin',0),(515717,14326,'no','Aktive Lease som',0),(515718,14326,'da','Aktive lejemÃ¥l som af',0),(515719,14326,'ko','ë¡œ í™œì„± ìž„ëŒ€',0),(515720,14326,'he','×”×—×›×™×¨×” ×”×¤×¢×™×œ×” ×”×—×œ',0),(515721,14326,'el','Î•Î½ÎµÏÎ³ÏŒ Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· Ï‰Ï‚',0),(515722,14326,'zh','æ´»åŠ¨ç§Ÿçº¦çš„ä½œä¸º',0),(515723,14326,'sv','Aktiva lÃ¥nets som av',0),(515724,14326,'it','Contratto di locazione attivo come di',0),(515725,14326,'tl','',0),(515726,14326,'th','à¹€à¸Šà¹ˆà¸²à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸­à¸¢à¸¹à¹ˆà¹€à¸›à¹‡à¸™à¸‚à¸­à¸‡',0),(515727,14326,'hi','à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤ªà¤Ÿà¥à¤Ÿà¥‡',0),(515728,14326,'ms','Aktif pajakan sebagai',0),(515729,14326,'ar','Ø§Ù„ØªØ£Ø¬ÙŠØ± Ø§Ù„Ù†Ø´Ø·Ø© ÙƒÙ…Ù†',0),(515730,14326,'fr','Bail actif comme des',0),(515731,14326,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªãƒªãƒ¼ã‚¹ã®ã¨ã—ã¦',0),(515732,14326,'pt','Ativa locaÃ§Ã£o a partir de',0),(515733,14326,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ð°Ñ Ð°Ñ€ÐµÐ½Ð´Ð° Ð¿Ð¾ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸ÑŽ Ð½Ð°',0),(515734,14326,'es','Arrendamiento activo como de',0),(515735,14326,'de','Aktive Lease als der',0),(515736,14326,'en','Active Lease As Of',0),(515737,14327,'is','',0),(515738,14327,'dr','Ø´Ù‡Ø± ÙØ¹Ù„ÛŒ',0),(515739,14327,'pr','Ø´Ù‡Ø± ÙØ¹Ù„ÛŒ',0),(515740,14327,'tr','Mevcut ÅŸehir',0),(515741,14327,'pl','BieÅ¼Ä…ce miasta',0),(515742,14327,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¡Ð¸Ñ‚Ð¸',0),(515743,14327,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø´ÛØ±',0),(515744,14327,'sr','Ð¡Ñ‚Ñ€ÑƒÑ˜Ð° Ð³Ñ€Ð°Ð´',0),(515745,14327,'vi','Hiá»‡n táº¡i thÃ nh phá»‘',0),(515746,14327,'af','Huidige Stad',0),(515747,14327,'ro','OraÅŸul curent',0),(515748,14327,'et','Praegune linn',0),(515749,14327,'si','Trenutno mesto',0),(515750,14327,'ba','Saat ini kota',0),(515751,14327,'nl','Huidige stad',0),(515752,14327,'fi','Nykyinen kaupunki',0),(515753,14327,'no','Gjeldende byen',0),(515754,14327,'da','NuvÃ¦rende by',0),(515755,14327,'ko','í˜„ìž¬ ì‹œ',0),(515756,14327,'he','×”×¢×™×¨ ×”× ×•×›×—×™',0),(515757,14327,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï€ÏŒÎ»Î·',0),(515758,14327,'zh','å½“å‰åŸŽå¸‚',0),(515759,14327,'sv','Nuvarande staden',0),(515760,14327,'it','CittÃ  di corrente',0),(515761,14327,'tl','',0),(515762,14327,'th','à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¹€à¸¡à¸·à¸­à¸‡',0),(515763,14327,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¶à¤¹à¤°',0),(515764,14327,'ms','Semasa bandar',0),(515765,14327,'ar','Ø§Ù„Ù…Ø¯ÙŠÙ†Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(515766,14327,'fr','Ville de courant',0),(515767,14327,'jp','ç¾åœ¨ã®éƒ½å¸‚',0),(515768,14327,'pt','Cidade de corrente',0),(515769,14327,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð³Ð¾Ñ€Ð¾Ð´',0),(515770,14327,'es','La ciudad actual',0),(515771,14327,'de','Aktuelle Stadt',0),(515772,14327,'en','Current City',0),(515773,14328,'is','',0),(515774,14328,'dr','Ú©Ù†ÙˆÙ†ÛŒ',0),(515775,14328,'pr','Ú©Ù†ÙˆÙ†ÛŒ',0),(515776,14328,'tr','Mevcut durum',0),(515777,14328,'pl','Aktualny stan',0),(515778,14328,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(515779,14328,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ø­Ø§Ù„Øª',0),(515780,14328,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ ÑÑ‚Ð°ÑšÐµ',0),(515781,14328,'vi','NhÃ  nÆ°á»›c hiá»‡n táº¡i',0),(515782,14328,'af','Huidige staat',0),(515783,14328,'ro','Starea actuala',0),(515784,14328,'et','Praeguse olukorra',0),(515785,14328,'si','Trenutno stanje',0),(515786,14328,'ba','Keadaan',0),(515787,14328,'nl','Huidige toestand',0),(515788,14328,'fi','Nykytila',0),(515789,14328,'no','Gjeldende status',0),(515790,14328,'da','Aktuel status',0),(515791,14328,'ko','í˜„ìž¬ ìƒíƒœ',0),(515792,14328,'he','×ž×¦×‘ × ×•×›×—×™',0),(515793,14328,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(515794,14328,'zh','å½“å‰çŠ¶æ€',0),(515795,14328,'sv','Aktuella staten',0),(515796,14328,'it','Stato corrente',0),(515797,14328,'tl','',0),(515798,14328,'th','à¸ªà¸–à¸²à¸™à¸°à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(515799,14328,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤°à¤¾à¤œà¥à¤¯',0),(515800,14328,'ms','Keadaan semasa',0),(515801,14328,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(515802,14328,'fr','Ã‰tat actuel',0),(515803,14328,'jp','ç¾åœ¨ã®çŠ¶æ…‹',0),(515804,14328,'pt','Estado atual',0),(515805,14328,'ru','Ð¢ÐµÐºÑƒÑ‰ÐµÐµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(515806,14328,'es','Estado actual',0),(515807,14328,'de','Aktueller Zustand',0),(515808,14328,'en','Current State',0),(515809,14329,'is','',0),(515810,14329,'dr','ÙØ´Ø±Ø¯Ù‡ Ú©Ù†ÙˆÙ†ÛŒ',0),(515811,14329,'pr','ÙØ´Ø±Ø¯Ù‡ Ú©Ù†ÙˆÙ†ÛŒ',0),(515812,14329,'tr','GeÃ§erli ZIP',0),(515813,14329,'pl','Obecny Zip',0),(515814,14329,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸',0),(515815,14329,'ur','Ø­Ø§Ù„ÛŒÛ Ø²Ù¾',0),(515816,14329,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð—Ð¸Ð¿',0),(515817,14329,'vi','Hiá»‡n táº¡i Sá»‘ Zip',0),(515818,14329,'af','Huidige ritssluiter',0),(515819,14329,'ro','Curent Zip',0),(515820,14329,'et','Praegune Zip',0),(515821,14329,'si','Trenutni Zip',0),(515822,14329,'ba','Saat ini Zip',0),(515823,14329,'nl','Huidige Zip',0),(515824,14329,'fi','Nykyinen Zip',0),(515825,14329,'no','Gjeldende Zip',0),(515826,14329,'da','NuvÃ¦rende Zip',0),(515827,14329,'ko','í˜„ìž¬ Zip',0),(515828,14329,'he','Zip ×”× ×•×›×—×™',0),(515829,14329,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Zip',0),(515830,14329,'zh','å½“å‰ Zip',0),(515831,14329,'sv','Nuvarande Zip',0),(515832,14329,'it','Zip corrente',0),(515833,14329,'tl','',0),(515834,14329,'th','à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œ',0),(515835,14329,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤œà¤¼à¤¿à¤ª',0),(515836,14329,'ms','Semasa Zip',0),(515837,14329,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(515838,14329,'fr','Zip courante',0),(515839,14329,'jp','ç¾åœ¨ Zip',0),(515840,14329,'pt','Zip atual',0),(515841,14329,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð¸Ð½Ð´ÐµÐºÑ',0),(515842,14329,'es','Zip actual',0),(515843,14329,'de','Aktuelle Zip',0),(515844,14329,'en','Current Zip',0),(515845,14330,'is','',0),(515846,14330,'dr','Ø´Ù‡Ø± Ø¯Ø§Ø¦Ù…',0),(515847,14330,'pr','Ø´Ù‡Ø± Ø¯Ø§Ø¦Ù…',0),(515848,14330,'tr','KalÄ±cÄ± ÅŸehir',0),(515849,14330,'pl','StaÅ‚e City',0),(515850,14330,'bg','ÐŸÐ¾ÑÑ‚Ð¾ÑÐ½ÐµÐ½ Ð³Ñ€Ð°Ð´',0),(515851,14330,'ur','Ù…Ø³ØªÙ‚Ù„ Ø´ÛØ±',0),(515852,14330,'sr','Ð¡Ñ‚Ð°Ð»Ð½Ð¸ Ð³Ñ€Ð°Ð´',0),(515853,14330,'vi','ThÃ nh phá»‘ vÄ©nh cá»­u',0),(515854,14330,'af','Permanente Stad',0),(515855,14330,'ro','Permanent City',0),(515856,14330,'et','Alaline City',0),(515857,14330,'si','Stalno mesto',0),(515858,14330,'ba','Kota permanen',0),(515859,14330,'nl','Permanente stad',0),(515860,14330,'fi','PysyvÃ¤ City',0),(515861,14330,'no','Permanent byen',0),(515862,14330,'da','Permanent by',0),(515863,14330,'ko','ì˜êµ¬ ì‹œ',0),(515864,14330,'he','×”×¢×™×¨ ×§×‘×•×¢',0),(515865,14330,'el','Î ÏŒÎ»Î· Î¼ÏŒÎ½Î¹Î¼Î¿Î¹',0),(515866,14330,'zh','å¸¸é©»å¸‚',0),(515867,14330,'sv','Permanent City',0),(515868,14330,'it','CittÃ  permanente',0),(515869,14330,'tl','',0),(515870,14330,'th','à¹€à¸¡à¸·à¸­à¸‡à¸–à¸²à¸§à¸£',0),(515871,14330,'hi','à¤¸à¥à¤¥à¤¾à¤¯à¥€ à¤¶à¤¹à¤°',0),(515872,14330,'ms','Bandar tetap',0),(515873,14330,'ar','Ù…Ø¯ÙŠÙ†Ø© Ø§Ù„Ø¯Ø§Ø¦Ù…',0),(515874,14330,'fr','Ville de permanent',0),(515875,14330,'jp','æ’ä¹…çš„ãªè¡—',0),(515876,14330,'pt','Cidade de permanente',0),(515877,14330,'ru','Ð“Ð¾Ñ€Ð¾Ð´ Ð¿Ð¾ÑÑ‚Ð¾ÑÐ½Ð½Ð¾Ð³Ð¾',0),(515878,14330,'es','Ciudad permanente',0),(515879,14330,'de','Bleibende Stadt',0),(515880,14330,'en','Permanent City',0),(515881,14331,'is','',0),(515882,14331,'dr','Ø¯ÙˆÙ„Øª Ø¯Ø§Ø¦Ù…',0),(515883,14331,'pr','Ø¯ÙˆÙ„Øª Ø¯Ø§Ø¦Ù…',0),(515884,14331,'tr','KalÄ±cÄ± devlet',0),(515885,14331,'pl','StaÅ‚e stanu',0),(515886,14331,'bg','ÐŸÐ¾ÑÑ‚Ð¾ÑÐ½Ð½Ð¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(515887,14331,'ur','Ù…Ø³ØªÙ‚Ù„ Ø­Ø§Ù„Øª',0),(515888,14331,'sr','Ð¢Ñ€Ð°Ñ˜Ð½Ð¾ ÑÑ‚Ð°ÑšÐµ',0),(515889,14331,'vi','NhÃ  nÆ°á»›c thÆ°á»ng trá»±c',0),(515890,14331,'af','Permanente staat',0),(515891,14331,'ro','Statul permanent',0),(515892,14331,'et','PÃ¼siv riik',0),(515893,14331,'si','Stalni Älanici',0),(515894,14331,'ba','Negara permanen',0),(515895,14331,'nl','Permanente staat',0),(515896,14331,'fi','PysyvÃ¤ valtion',0),(515897,14331,'no','Permanent tilstand',0),(515898,14331,'da','Permanent tilstand',0),(515899,14331,'ko','ì˜êµ¬ ìƒíƒœ',0),(515900,14331,'he','×ž×¦×‘ ×§×‘×•×¢',0),(515901,14331,'el','ÎœÏŒÎ½Î¹Î¼Î¿ Î¼Î­Î»Î¿Ï‚',0),(515902,14331,'zh','å¸¸é©»çŠ¶æ€',0),(515903,14331,'sv','Permanent tillstÃ¥nd',0),(515904,14331,'it','Permanente stato',0),(515905,14331,'tl','',0),(515906,14331,'th','à¸£à¸±à¸à¸–à¸²à¸§à¸£',0),(515907,14331,'hi','à¤¸à¥à¤¥à¤¾à¤¯à¥€ à¤°à¤¾à¤œà¥à¤¯',0),(515908,14331,'ms','Negeri kekal',0),(515909,14331,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ù„Ø¯Ø§Ø¦Ù…',0),(515910,14331,'fr','Ã‰tat permanent',0),(515911,14331,'jp','æ’ä¹…çš„ãªçŠ¶æ…‹',0),(515912,14331,'pt','Estado de permanente',0),(515913,14331,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð¾ÑÐ½Ð½Ð¾Ð³Ð¾',0),(515914,14331,'es','Estado permanente',0),(515915,14331,'de','Permanent State',0),(515916,14331,'en','Permanent State',0),(515917,14332,'is','',0),(515918,14332,'dr','Ø¯Ø§Ø¦Ù…ÛŒ ÙØ§ÛŒÙ„ Ù‡Ø§ÛŒ ÙØ´Ø±Ø¯Ù‡',0),(515919,14332,'pr','Ø¯Ø§Ø¦Ù…ÛŒ ÙØ§ÛŒÙ„ Ù‡Ø§ÛŒ ÙØ´Ø±Ø¯Ù‡',0),(515920,14332,'tr','KalÄ±cÄ± ZIP',0),(515921,14332,'pl','StaÅ‚e Zip',0),(515922,14332,'bg','ÐŸÐ¾ÑÑ‚Ð¾ÑÐ½Ð½Ð¸ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸',0),(515923,14332,'ur','Ù…Ø³ØªÙ‚Ù„ Ø²Ù¾',0),(515924,14332,'sr','Ð¢Ñ€Ð°Ñ˜Ð½Ð¾ Ð—Ð¸Ð¿',0),(515925,14332,'vi','VÄ©nh viá»…n Zip',0),(515926,14332,'af','Permanente ritssluiter',0),(515927,14332,'ro','PermanentÄƒ Zip',0),(515928,14332,'et','PÃ¼siva Zip',0),(515929,14332,'si','Stalno Zip',0),(515930,14332,'ba','Zip permanen',0),(515931,14332,'nl','Permanente Zip',0),(515932,14332,'fi','PysyvÃ¤ Zip',0),(515933,14332,'no','Permanent Zip',0),(515934,14332,'da','Permanent Zip',0),(515935,14332,'ko','ì˜êµ¬ ìš°íŽ¸',0),(515936,14332,'he','×ž×™×§×•×“ ×§×‘×•×¢',0),(515937,14332,'el','ÎœÏŒÎ½Î¹Î¼Î· Zip',0),(515938,14332,'zh','æ°¸ä¹…é‚®ç¼–',0),(515939,14332,'sv','Permanent Zip',0),(515940,14332,'it','Zip permanente',0),(515941,14332,'tl','',0),(515942,14332,'th','à¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œà¸–à¸²à¸§à¸£',0),(515943,14332,'hi','à¤¸à¥à¤¥à¤¾à¤¯à¥€ à¤œà¤¼à¤¿à¤ª',0),(515944,14332,'ms','Zip yang kekal',0),(515945,14332,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ø§Ù„Ø¯Ø§Ø¦Ù…Ø©',0),(515946,14332,'fr','Zip permanente',0),(515947,14332,'jp','æ°¸ä¹…çš„ãª Zip',0),(515948,14332,'pt','Zip permanente',0),(515949,14332,'ru','ÐŸÐ¾ÑÑ‚Ð¾ÑÐ½Ð½Ñ‹Ðµ Zip',0),(515950,14332,'es','Zip permanente',0),(515951,14332,'de','Permanente Zip',0),(515952,14332,'en','Permanent Zip',0),(515953,14333,'is','',0),(515954,14333,'dr','Ø§Ø±Ø³Ø§Ù„ Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(515955,14333,'pr','Ø§Ø±Ø³Ø§Ù„ Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ù‡ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(515956,14333,'tr','SeÃ§ili e-posta gÃ¶ndermek',0),(515957,14333,'pl','WyÅ›lij E-mail do wybranej',0),(515958,14333,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¸Ð¼ÐµÐ¹Ð» Ð´Ð¾ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(515959,14333,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø§ Ù…Ù†ØªØ®Ø¨ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(515960,14333,'sr','Ð¡Ð»Ð°ÑšÐµ Ðµ-Ð¿Ð¾Ñ€ÑƒÐºÐµ Ð·Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ',0),(515961,14333,'vi','Gá»­i Email Ä‘áº¿n Ä‘Ã£ chá»n',0),(515962,14333,'af','Stuur e-pos aan geselekteerde',0),(515963,14333,'ro','Trimite E-mail la selectat',0),(515964,14333,'et','Saada e-valitud',0),(515965,14333,'si','PoÅ¡lji e-poÅ¡to na izbrane',0),(515966,14333,'ba','Kirim Email untuk dipilih',0),(515967,14333,'nl','Stuur Email naar geselecteerde',0),(515968,14333,'fi','LÃ¤hettÃ¤Ã¤ sÃ¤hkÃ¶postia valitulle',0),(515969,14333,'no','Send epost til valgte',0),(515970,14333,'da','Send E-mail til udvalgte',0),(515971,14333,'ko','ì„ íƒí•œ ì´ë©”ì¼ì„ ë³´ë‚¼',0),(515972,14333,'he','×©×œ×— ×“×•× ×œ ×©× ×‘×—×¨',0),(515973,14333,'el','Î£Ï„ÎµÎ¯Î»ÎµÏ„Îµ Email ÏƒÎµ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î±',0),(515974,14333,'zh','å‘é€é‚®ä»¶è‡³æ‰€é€‰',0),(515975,14333,'sv','Skicka mail till valda',0),(515976,14333,'it','Invia E-mail a selezionata',0),(515977,14333,'tl','',0),(515978,14333,'th','à¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥à¹Œà¹ƒà¸«à¹‰à¹€à¸¥à¸·à¸­à¸',0),(515979,14333,'hi','à¤ˆà¤®à¥‡à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¯à¤¨à¤¿à¤¤ à¤­à¥‡à¤œà¥‡à¤‚',0),(515980,14333,'ms','Menghantar e-mel untuk dipilih',0),(515981,14333,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¥Ù„Ù‰ Ù…Ø®ØªØ§Ø±Ø©',0),(515982,14333,'fr','Envoyer courriel Ã  sÃ©lectionnÃ©',0),(515983,14333,'jp','é¸æŠžã—ãŸé›»å­ãƒ¡ãƒ¼ãƒ«ã‚’ãŠé€ã‚Š',0),(515984,14333,'pt','Envie um E-mail para selecionado',0),(515985,14333,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¸ÑÑŒÐ¼Ð¾ Ð´Ð»Ñ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾',0),(515986,14333,'es','Enviar correo electrÃ³nico a seleccionados',0),(515987,14333,'de','Senden Sie E-Mail an ausgewÃ¤hlten',0),(515988,14333,'en','Send Email To Selected',0),(515989,14334,'is','',0),(515990,14334,'dr','Ø§Ø±Ø³Ø§Ù„ Ø§ÛŒÙ…ÛŒÙ„ Ø¶Ø§Ù…Ù†',0),(515991,14334,'pr','Ø§Ø±Ø³Ø§Ù„ Ø§ÛŒÙ…ÛŒÙ„ Ø¶Ø§Ù…Ù†',0),(515992,14334,'tr','GarantÃ¶r e-posta gÃ¶nder',0),(515993,14334,'pl','WyÅ›lij E-mail gwaranta',0),(515994,14334,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¸Ð¼ÐµÐ¹Ð» Ð½Ð° Ð³Ð°Ñ€Ð°Ð½Ñ‚',0),(515995,14334,'ur','Ø¶Ø§Ù…Ù† Ø§ÛŒ Ù…ÛŒÙ„ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(515996,14334,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð•Ð¼Ð°Ð¸Ð» Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð°',0),(515997,14334,'vi','Gá»­i thÆ° Ä‘iá»‡n tá»­ báº£o lÃ£nh',0),(515998,14334,'af','Borg e-pos stuur',0),(515999,14334,'ro','Trimite E-mail de garant',0),(516000,14334,'et','KÃ¤endaja saada',0),(516001,14334,'si','PoÅ¡lji Email garant',0),(516002,14334,'ba','Kirim Email penjamin',0),(516003,14334,'nl','E-mail van de borg',0),(516004,14334,'fi','Takaajan sÃ¤hkÃ¶postitse',0),(516005,14334,'no','Send garantist epost',0),(516006,14334,'da','Send garant E-mail',0),(516007,14334,'ko','ë³´ì¦ì¸ ì´ë©”ì¼ ë³´ë‚´ê¸°',0),(516008,14334,'he','×©×œ×— ×“×•× ×œ ×¢×¨×‘',0),(516009,14334,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Email ÎµÎ³Î³Ï…Î·Ï„Î®',0),(516010,14334,'zh','å‘é€ç”µå­é‚®ä»¶æ‹…ä¿äºº',0),(516011,14334,'sv','Maila garant',0),(516012,14334,'it','Invia E-mail a garante',0),(516013,14334,'tl','',0),(516014,14334,'th','à¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸„à¹‰à¸³à¸›à¸£à¸°à¸à¸±à¸™',0),(516015,14334,'hi','à¤—à¤¾à¤°à¤‚à¤Ÿà¤° à¤ˆà¤®à¥‡à¤² à¤­à¥‡à¤œà¥‡à¤‚',0),(516016,14334,'ms','Menghantar e-mel penjamin',0),(516017,14334,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø¶Ø§Ù…Ù†',0),(516018,14334,'fr','Envoyer Email garant',0),(516019,14334,'jp','é€£å¸¯ä¿è¨¼äººã® e ãƒ¡ãƒ¼ãƒ«ã‚’é€ã‚‹',0),(516020,14334,'pt','Enviar E-mail de fiador',0),(516021,14334,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¸ÑÑŒÐ¼Ð¾ Ð³Ð°Ñ€Ð°Ð½Ñ‚',0),(516022,14334,'es','Enviar correo electrÃ³nico garante',0),(516023,14334,'de','Garant-E-Mail senden',0),(516024,14334,'en','Send Guarantor Email',0),(516025,14335,'is','',0),(516026,14335,'dr','Ø§Ø±Ø³Ø§Ù„ Ø§ÛŒÙ…ÛŒÙ„ Ø¶Ø§Ù…Ù†',0),(516027,14335,'pr','Ø§Ø±Ø³Ø§Ù„ Ø§ÛŒÙ…ÛŒÙ„ Ø¶Ø§Ù…Ù†',0),(516028,14335,'tr','GarantÃ¶r e-postalar gÃ¶ndermek',0),(516029,14335,'pl','WysyÅ‚anie e-maili gwaranta',0),(516030,14335,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð³Ð°Ñ€Ð°Ð½Ñ‚ Ð¸Ð¼ÐµÐ¹Ð»Ð¸',0),(516031,14335,'ur','Ø¶Ø§Ù…Ù† Ø§ÛŒ Ù…ÛŒÙ„Ø² Ø¨Ú¾ÛŒØ¬',0),(516032,14335,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð¼ÐµÑ˜Ð»Ð¾Ð²Ðµ Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð°',0),(516033,14335,'vi','Gá»­i email báº£o lÃ£nh',0),(516034,14335,'af','Borg e-posse te stuur',0),(516035,14335,'ro','Trimite e-mailuri garant',0),(516036,14335,'et','KÃ¤endaja kirju saata',0),(516037,14335,'si','PoÅ¡iljanje e-poÅ¡te garant',0),(516038,14335,'ba','Mengirim email penjamin',0),(516039,14335,'nl','Borg E-mails versturen',0),(516040,14335,'fi','Takaajan sÃ¤hkÃ¶postia',0),(516041,14335,'no','E-postmeldingene garantist',0),(516042,14335,'da','Send garant E-mails',0),(516043,14335,'ko','ë³´ì¦ì¸ ì´ë©”ì¼ ë³´ë‚´ê¸°',0),(516044,14335,'he','×œ×©×œ×•×— ×ž×™×™×œ×™× ×¢×¨×‘',0),(516045,14335,'el','Î£Ï„ÎµÎ¯Î»ÎµÏ„Îµ Î¼Î·Î½ÏÎ¼Î±Ï„Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Ï„Î¿Ï… ÎµÎ³Î³Ï…Î·Ï„Î®',0),(516046,14335,'zh','å‘é€ç”µå­é‚®ä»¶æ‹…ä¿äºº',0),(516047,14335,'sv','Skicka e-post garant',0),(516048,14335,'it','Inviare email del garante',0),(516049,14335,'tl','',0),(516050,14335,'th','à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸œà¸¹à¹‰à¸„à¹‰à¸³à¸›à¸£à¸°à¸à¸±à¸™',0),(516051,14335,'hi','à¤—à¤¾à¤°à¤‚à¤Ÿà¤° à¤ˆà¤®à¥‡à¤² à¤­à¥‡à¤œà¥‡à¤‚',0),(516052,14335,'ms','Menghantar e-mel penjamin',0),(516053,14335,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø¶Ø§Ù…Ù†',0),(516054,14335,'fr','Envoyer des Emails de garant',0),(516055,14335,'jp','é€£å¸¯ä¿è¨¼äººã® e ãƒ¡ãƒ¼ãƒ«ã‚’é€ã‚‹',0),(516056,14335,'pt','Enviar E-mails de fiador',0),(516057,14335,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¸ÑÑŒÐ¼Ð° Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð°',0),(516058,14335,'es','Enviar correos electrÃ³nicos garante',0),(516059,14335,'de','Garant-e-Mails zu senden',0),(516060,14335,'en','Send Guarantor Emails',0),(516061,14336,'is','',0),(516062,14336,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø²ÛŒÙ†Ù‡ Ø³ÙˆØ¯Ù…Ù†Ø¯ &amp; Ø§ÙˆØ§Ø®Ø±',0),(516063,14336,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù‡Ø²ÛŒÙ†Ù‡ Ø³ÙˆØ¯Ù…Ù†Ø¯ &amp; Ø§ÙˆØ§Ø®Ø±',0),(516064,14336,'tr','Utility & geÃ§ Ã¼creti faturalama',0),(516065,14336,'pl','NarzÄ™dzie & pÃ³Åºno opÅ‚aty fakturowania',0),(516066,14336,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰Ð½Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð° & ÐºÑ€Ð°Ñ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð°',0),(516067,14336,'ur','Ø§ÙØ§Ø¯ÛŒØª & Ù…Ø±Ø­ÙˆÙ… Ú©ÛŒ ÙÛŒØ³ Ø§Ù†ÙˆØ§Ú©Ø§Ù†Ú¯',0),(516068,14336,'sr','Ð£ÑÐ»ÑƒÐ¶Ð½Ð¸ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼ Ð·Ð° & ÐºÐ°ÑÐ½Ð¾ Ñ…Ð¾Ð½Ð¾Ñ€Ð°Ñ€ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(516069,14336,'vi','Tiá»‡n Ã­ch &amp; cuá»‘i phÃ­ láº­p hoÃ¡ Ä‘Æ¡n',0),(516070,14336,'af','Nutsprogram & laat fooi fakturering',0),(516071,14336,'ro','Utilitate & tÃ¢rziu taxa de facturare',0),(516072,14336,'et','Utility & hilinenud tasu arveldamine',0),(516073,14336,'si','Utility & pozno pristojbina fakturiranje',0),(516074,14336,'ba','Biaya utilitas & akhir faktur',0),(516075,14336,'nl','Utility & laat vergoeding facturering',0),(516076,14336,'fi','Utility & myÃ¶hÃ¤Ã¤n maksu laskutus',0),(516077,14336,'no','VerktÃ¸yet & sen gebyr fakturering',0),(516078,14336,'da','Utility & sen gebyr fakturering',0),(516079,14336,'ko','ìœ í‹¸ë¦¬í‹° & ëŠ¦ì€ ìˆ˜ìˆ˜ë£Œ ì²­êµ¬ì„œ',0),(516080,14336,'he','×—×©×‘×•× ×™×•×ª ×”×©×™×¨×•×ª & ×ž××—×¨ ×‘×ª×©×œ×•×',0),(516081,14336,'el','Î’Î¿Î·Î¸Î·Ï„Î¹ÎºÏŒ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± & Î±ÏÎ³Î¬ Î±Î¼Î¿Î¹Î²Î®Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·',0),(516082,14336,'zh','å®žç”¨ç¨‹åº &amp; æ™šè´¹ç”¨å¼€ç¥¨',0),(516083,14336,'sv','Utility & sena avgift fakturering',0),(516084,14336,'it','Tassa di utilitÃ  & fine fatturazione',0),(516085,14336,'tl','',0),(516086,14336,'th','à¸à¸²à¸£à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¹ˆà¸²à¹‚à¸›à¸£à¹à¸à¸£à¸¡à¸­à¸£à¸£à¸–à¸›à¸£à¸°à¹‚à¸¢à¸Šà¸™à¹Œ & à¸ªà¸²à¸¢',0),(516087,14336,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤¿à¤¤à¤¾ & à¤¦à¥‡à¤° à¤¶à¥à¤²à¥à¤• à¤šà¤¾à¤²à¤¾à¤¨',0),(516088,14336,'ms','Invois bayaran utiliti & lewat',0),(516089,14336,'ar','Ø§Ù„Ø£Ø¯Ø§Ø© Ø§Ù„Ù…Ø³Ø§Ø¹Ø¯Ø© Ø¢Ù†Ø¯ ÙˆÙ‚Øª Ù…ØªØ£Ø®Ø± Ø±Ø³ÙˆÙ… Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(516090,14336,'fr','Utilitaire & fin des frais de facturation',0),(516091,14336,'jp','ãƒ¦ãƒ¼ãƒ†ã‚£ãƒªãƒ†ã‚£ & å¾ŒåŠæ–™ã®è«‹æ±‚æ›¸ç™ºè¡Œ',0),(516092,14336,'pt','UtilitÃ¡rio & tarde taxa faturamento',0),(516093,14336,'ru','Ð£Ñ‚Ð¸Ð»Ð¸Ñ‚Ð° & Ð¿Ð¾Ð·Ð´Ð½Ð¾ Ð¿Ð»Ð°Ñ‚Ð° Ð·Ð° Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(516094,14336,'es','Utilidad &amp; tarde pago facturaciÃ³n',0),(516095,14336,'de','Dienstprogramm & spÃ¤ten GebÃ¼hr Rechnungsstellung',0),(516096,14336,'en','Utility & Late Fee Invoicing',0),(516097,14337,'is','',0),(516098,14337,'dr','Ù…Ø³ØªØ§Ø¬Ø± Ø§ÛŒÙ…ÛŒÙ„',0),(516099,14337,'pr','Ù…Ø³ØªØ§Ø¬Ø± Ø§ÛŒÙ…ÛŒÙ„',0),(516100,14337,'tr','KiracÄ± e-posta',0),(516101,14337,'pl','E-mail najemcy',0),(516102,14337,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¸Ð¼ÐµÐ¹Ð»',0),(516103,14337,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ø§ÛŒ Ù…ÛŒÙ„',0),(516104,14337,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð•Ð¼Ð°Ð¸Ð»',0),(516105,14337,'vi','NgÆ°á»i thuÃª nhÃ  Email',0),(516106,14337,'af','Huurder e-pos',0),(516107,14337,'ro','ChiriaÅŸ E-mail',0),(516108,14337,'et','ÃœÃ¼rnik Email',0),(516109,14337,'si','Najemnik Email',0),(516110,14337,'ba','Penyewa Email',0),(516111,14337,'nl','Huurder E-mail',0),(516112,14337,'fi','Vuokralainen sÃ¤hkÃ¶posti',0),(516113,14337,'no','Leietaker Email',0),(516114,14337,'da','Lejer E-mail',0),(516115,14337,'ko','ê±°ì£¼ìž ì´ë©”ì¼',0),(516116,14337,'he','×”×“×™×™×¨ ×“×•×',0),(516117,14337,'el','ÎœÎ¹ÏƒÎ¸Ï‰Ï„Î® Email',0),(516118,14337,'zh','ç§Ÿå®¢çš„ç”µå­é‚®ä»¶',0),(516119,14337,'sv','HyresgÃ¤sten Email',0),(516120,14337,'it','Inquilino Email',0),(516121,14337,'tl','',0),(516122,14337,'th','à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(516123,14337,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤ˆà¤®à¥‡à¤²',0),(516124,14337,'ms','E-mel penyewa',0),(516125,14337,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(516126,14337,'fr','Email du locataire',0),(516127,14337,'jp','ãƒ†ãƒŠãƒ³ãƒˆ ãƒ¡ãƒ¼ãƒ«',0),(516128,14337,'pt','Inquilino Email',0),(516129,14337,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(516130,14337,'es','Correo electrÃ³nico del inquilino',0),(516131,14337,'de','Mieter-E-Mail',0),(516132,14337,'en','Tenant Email',0),(516133,14338,'is','',0),(516134,14338,'dr','Ù…Ø³ØªØ§Ø¬Ø± ØªÙ„ÙÙ†',0),(516135,14338,'pr','Ù…Ø³ØªØ§Ø¬Ø± ØªÙ„ÙÙ†',0),(516136,14338,'tr','KiracÄ± telefon',0),(516137,14338,'pl','Telefon najemcy',0),(516138,14338,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(516139,14338,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± ÙÙˆÙ†',0),(516140,14338,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(516141,14338,'vi','NgÆ°á»i thuÃª nhÃ  Ä‘iá»‡n thoáº¡i',0),(516142,14338,'af','Huurder foon',0),(516143,14338,'ro','ChiriaÅŸ telefon',0),(516144,14338,'et','ÃœÃ¼rnik telefoni',0),(516145,14338,'si','Najemnik telefon',0),(516146,14338,'ba','Penyewa telepon',0),(516147,14338,'nl','Huurder telefoon',0),(516148,14338,'fi','Vuokralainen puhelimen',0),(516149,14338,'no','Leietaker telefon',0),(516150,14338,'da','Lejer telefon',0),(516151,14338,'ko','ìž… ì£¼ìž ì „í™”',0),(516152,14338,'he','×”×“×™×™×¨ ×˜×œ×¤×•×Ÿ',0),(516153,14338,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(516154,14338,'zh','ç§Ÿå®¢ç”µè¯',0),(516155,14338,'sv','HyresgÃ¤sten telefon',0),(516156,14338,'it','Inquilino telefono',0),(516157,14338,'tl','',0),(516158,14338,'th','à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œ',0),(516159,14338,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤«à¥‹à¤¨',0),(516160,14338,'ms','Telefon penyewa',0),(516161,14338,'ar','Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(516162,14338,'fr','TÃ©lÃ©phone du locataire',0),(516163,14338,'jp','ãƒ†ãƒŠãƒ³ãƒˆé›»è©±',0),(516164,14338,'pt','Telefone do inquilino',0),(516165,14338,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(516166,14338,'es','Inquilino telÃ©fono',0),(516167,14338,'de','Mieter-Telefon',0),(516168,14338,'en','Tenant Phone',0),(516169,14339,'is','',0),(516170,14339,'dr','Ø³ÙØ§Ø±Ø´ Ú©Ø§Ø± Ø²ÛŒØ± ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(516171,14339,'pr','Ø³ÙØ§Ø±Ø´ Ú©Ø§Ø± Ø²ÛŒØ± ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(516172,14339,'tr','AÅŸaÄŸÄ±daki iÅŸ emri onaylandÄ±',0),(516173,14339,'pl','NastÄ™pujÄ…cej kolejnoÅ›ci pracy zostaÅ‚ zatwierdzony',0),(516174,14339,'bg','Ð¡Ð»ÐµÐ´Ð½Ð°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ° Ðµ Ð±Ð¸Ð» Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½',0),(516175,14339,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ú©Ø§Ù… ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ Ú¯Ø¦ÛŒ ÛÛ’',0),(516176,14339,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ñ€Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½.',0),(516177,14339,'vi','Bá»™ cÃ´ng viá»‡c sau Ä‘Ã¢y Ä‘Ã£ Ä‘Æ°á»£c cháº¥p thuáº­n',0),(516178,14339,'af','Die volgende werk bestelling goedgekeur is',0),(516179,14339,'ro','Ordine de lucru a fost aprobat',0),(516180,14339,'et','TÃ¶Ã¶ korralduse heaks',0),(516181,14339,'si','Naslednjem vrstnem redu delo je bil odobren',0),(516182,14339,'ba','Urutan kerja berikut telah disetujui',0),(516183,14339,'nl','De volgende werkorder is goedgekeurd',0),(516184,14339,'fi','TyÃ¶ jÃ¤rjestyksessÃ¤ on hyvÃ¤ksytty',0),(516185,14339,'no','FÃ¸lgende Arbeidsordre er godkjent',0),(516186,14339,'da','De fÃ¸lgende arbejdsordre er blevet godkendt',0),(516187,14339,'ko','ë‹¤ìŒ ìž‘ì—… ìˆœì„œ ëŒ€ë¡œ ìŠ¹ì¸ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(516188,14339,'he','×¡×“×¨ ×”×¢×‘×•×“×” ×”×‘× ××•×©×¨×”',0),(516189,14339,'el','Î— Î±ÎºÏŒÎ»Î¿Ï…Î¸Î· ÏƒÎµÎ¹ÏÎ¬ Î­ÏÎ³Î¿ Î­Ï‡ÎµÎ¹ ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯',0),(516190,14339,'zh','ä¸‹é¢çš„å·¥ä½œè®¢å•å·²è¢«æŽ¥å—',0),(516191,14339,'sv','FÃ¶ljande arbete ordning har godkÃ¤nts',0),(516192,14339,'it','Ãˆ stato approvato il seguente ordine di lavoro',0),(516193,14339,'tl','',0),(516194,14339,'th','à¹„à¸”à¹‰à¸£à¸±à¸šà¸à¸²à¸£à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸¥à¸³à¸”à¸±à¸šà¸‡à¸²à¸™à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰',0),(516195,14339,'hi','à¤¨à¤¿à¤®à¥à¤¨ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥€ à¤—à¤ˆ à¤¹à¥ˆ',0),(516196,14339,'ms','Perintah kerja yang berikut telah diluluskan',0),(516197,14339,'ar','ØªÙ… Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(516198,14339,'fr','L\'ordre de travail suivant a Ã©tÃ© approuvÃ©',0),(516199,14339,'jp','æ¬¡ã®ä½œæ¥­é †åºã‚’æ‰¿èªã—ã¾ã—ãŸã€‚',0),(516200,14339,'pt','A seguinte ordem de trabalhos foi aprovada',0),(516201,14339,'ru','Ð‘Ñ‹Ð» ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(516202,14339,'es','Ha sido aprobado el siguiente orden de trabajo',0),(516203,14339,'de','Wir gratulieren der folgenden Arbeitsauftrag',0),(516204,14339,'en','The Following Work Order Has Been Approved',0),(516205,14340,'is','',0),(516206,14340,'dr','Ø³ÙØ§Ø±Ø´ Ú©Ø§Ø± Ø²ÛŒØ± Ù…Ù…Ù†ÙˆØ¹ Ø§Ø³Øª',0),(516207,14340,'pr','Ø³ÙØ§Ø±Ø´ Ú©Ø§Ø± Ø²ÛŒØ± Ù…Ù…Ù†ÙˆØ¹ Ø§Ø³Øª',0),(516208,14340,'tr','AÅŸaÄŸÄ±daki iÅŸ emri reddedildi',0),(516209,14340,'pl','OdmÃ³wiono nastÄ™pujÄ…ce zlecenia',0),(516210,14340,'bg','Ð¡Ð»ÐµÐ´Ð½Ð°Ñ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ° Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½',0),(516211,14340,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ú©Ø§Ù… ØªØ±ØªÛŒØ¨ Ù†ÛÛŒÚº Ø¯ÛŒ Ú¯Ø¦ÛŒ',0),(516212,14340,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ñ€Ð°Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ñ˜Ðµ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½.',0),(516213,14340,'vi','Thá»© tá»± cÃ´ng viá»‡c sau Ä‘Ã£ bá»‹ tá»« chá»‘i',0),(516214,14340,'af','Die volgende werk orde het geweier',0),(516215,14340,'ro','Ordine de lucru a fost refuzat',0),(516216,14340,'et','JÃ¤rgmine tÃ¶Ã¶kÃ¤sk eitada',0),(516217,14340,'si','Takole dela je bil zavrnjen',0),(516218,14340,'ba','Urutan kerja berikut telah ditolak',0),(516219,14340,'nl','De volgende werkorder is geweigerd',0),(516220,14340,'fi','TyÃ¶ jÃ¤rjestyksessÃ¤ on evÃ¤tty',0),(516221,14340,'no','FÃ¸lgende Arbeidsordre er avslÃ¥tt',0),(516222,14340,'da','De fÃ¸lgende arbejdsordre er blevet nÃ¦gtet',0),(516223,14340,'ko','ë‹¤ìŒ ìž‘ì—… ìˆœì„œ ëŒ€ë¡œ ê±°ë¶€ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(516224,14340,'he','×”×–×ž× ×ª ×”×¢×‘×•×“×” ×”×‘××” × ×“×—×ª×”',0),(516225,14340,'el','Î‘ÏÎ½Î®Î¸Î·ÎºÎµ Ï„Î·Î½ Î±ÎºÏŒÎ»Î¿Ï…Î¸Î· ÏƒÎµÎ¹ÏÎ¬ Î³Î¹Î± Ï„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(516226,14340,'zh','ä»¥ä¸‹çš„å·¥ä½œé¡ºåºå·²è¢«æ‹’ç»',0),(516227,14340,'sv','FÃ¶ljande arbete ordning har nekats',0),(516228,14340,'it','Il seguente ordine di lavoro Ã¨ stato negato',0),(516229,14340,'tl','',0),(516230,14340,'th','à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™à¸–à¸¹à¸à¸›à¸à¸´à¹€à¸ªà¸˜',0),(516231,14340,'hi','à¤¨à¤¿à¤®à¥à¤¨ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤® à¤•à¤¾ à¤–à¤‚à¤¡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(516232,14340,'ms','Perintah kerja yang berikut telah dinafikan',0),(516233,14340,'ar','ØªÙ… Ø±ÙØ¶ Ø§Ù„Ù†Ø¸Ø§Ù… Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(516234,14340,'fr','L\'ordre de travail suivant a Ã©tÃ© refusÃ©',0),(516235,14340,'jp','æ¬¡ã®ä½œæ¥­é †åºãŒæ‹’å¦ã•ã‚Œã¾ã—ãŸ',0),(516236,14340,'pt','Negou-se a seguinte ordem de trabalho',0),(516237,14340,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ð±Ñ‹Ð»Ð¾ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð¾',0),(516238,14340,'es','Se le ha negado el siguiente orden de trabajo',0),(516239,14340,'de','Der folgenden Arbeitsauftrag wurde verweigert',0),(516240,14340,'en','The Following Work Order Has Been Denied',0),(516241,14341,'is','',0),(516242,14341,'dr','Ù†ÙˆØ¹ Ú©Ø§Ø± Ø­Ø°Ù',0),(516243,14341,'pr','Ù†ÙˆØ¹ Ú©Ø§Ø± Ø­Ø°Ù',0),(516244,14341,'tr','Ä°ÅŸ tÃ¼rÃ¼nÃ¼ Sil',0),(516245,14341,'pl','UsuÅ„ typ pracy',0),(516246,14341,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(516247,14341,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(516248,14341,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(516249,14341,'vi','XÃ³a bá» cÃ´ng viá»‡c loáº¡i',0),(516250,14341,'af','Skrap werk tipe',0),(516251,14341,'ro','Åžterge activitatea tip',0),(516252,14341,'et','Kustuta tÃ¶Ã¶ tÃ¼Ã¼p',0),(516253,14341,'si','Izbrisati vrsto dela',0),(516254,14341,'ba','Menghapus jenis pekerjaan',0),(516255,14341,'nl','Werksoort verwijderen',0),(516256,14341,'fi','Poista tyÃ¶n tyyppi',0),(516257,14341,'no','Slette arbeid',0),(516258,14341,'da','Slette arbejdstype',0),(516259,14341,'ko','ìž‘ì—… í˜•ì‹ ì‚­ì œ',0),(516260,14341,'he','×œ×ž×—×•×§ ×¡×•×’ ×¢×‘×•×“×”',0),(516261,14341,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï…',0),(516262,14341,'zh','åˆ é™¤å·¥ä½œç±»åž‹',0),(516263,14341,'sv','Ta bort arbetstyp',0),(516264,14341,'it','Eliminare il tipo di lavoro',0),(516265,14341,'tl','',0),(516266,14341,'th','à¸¥à¸šà¸Šà¸™à¸´à¸”à¸‡à¸²à¸™',0),(516267,14341,'hi','à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(516268,14341,'ms','Menghapuskan jenis kerja',0),(516269,14341,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(516270,14341,'fr','Supprimez le Type de travail',0),(516271,14341,'jp','ä½œæ¥­ã®ç¨®é¡žã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(516272,14341,'pt','Excluir o tipo de trabalho',0),(516273,14341,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‡ÐµÐ³Ð¾',0),(516274,14341,'es','Eliminar el tipo de trabajo',0),(516275,14341,'de','Arbeitstyp lÃ¶schen',0),(516276,14341,'en','Delete Work Type',0),(516277,14342,'is','',0),(516278,14342,'dr','Ø¹Ø¯Ù… Ø§ÙØ²ÙˆØ¯Ù† Ú©Ø§Ø± Ù†ÙˆØ¹',0),(516279,14342,'pr','Ø¹Ø¯Ù… Ø§ÙØ²ÙˆØ¯Ù† Ú©Ø§Ø± Ù†ÙˆØ¹',0),(516280,14342,'tr','BaÅŸarÄ±sÄ±z ekleme iÅŸ tÃ¼rÃ¼',0),(516281,14342,'pl','Dodawanie typu pracy brak',0),(516282,14342,'bg','ÐÐµÑƒÑÐ¿ÐµÑ… Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(516283,14342,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©Û’ Ø°Ø±ÛŒØ¹Û Ú©Ø§Ù… Ù‚Ø³Ù…',0),(516284,14342,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐ° Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(516285,14342,'vi','Tháº¥t báº¡i thÃªm cÃ´ng viá»‡c loáº¡i',0),(516286,14342,'af','Mislukking voeg werk tipe',0),(516287,14342,'ro','EÅŸecul adÄƒugarea de lucru tip',0),(516288,14342,'et','Rike lisades tÃ¶Ã¶ tÃ¼Ã¼p',0),(516289,14342,'si','Neuspeh dodajanje vrsta dela',0),(516290,14342,'ba','Jenis pekerjaan menambahkan kegagalan',0),(516291,14342,'nl','Mislukking werksoort toevoegen',0),(516292,14342,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ tyÃ¶n tyyppi',0),(516293,14342,'no','Feil Ã¥ legge arbeidstype',0),(516294,14342,'da','Manglende tilfÃ¸je arbejdstype',0),(516295,14342,'ko','ì‹¤íŒ¨ ì¶”ê°€ ìž‘ì—… í˜•ì‹',0),(516296,14342,'he','×›×©×œ ×”×•×¡×¤×ª ×¡×•×’ ×¢×‘×•×“×”',0),(516297,14342,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·Ï‚ Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(516298,14342,'zh','å¤±è´¥æ·»åŠ å·¥ä½œç±»åž‹',0),(516299,14342,'sv','UnderlÃ¥tenhet att lÃ¤gga arbetstyp',0),(516300,14342,'it','Tipo di lavoro aggiungendo errore',0),(516301,14342,'tl','',0),(516302,14342,'th','à¸Šà¸™à¸´à¸”à¸‡à¸²à¸™à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(516303,14342,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¤•à¤° à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤°',0),(516304,14342,'ms','Kegagalan menambah kerja jenis',0),(516305,14342,'ar','ÙØ´Ù„ Ø¥Ø¶Ø§ÙØ© Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(516306,14342,'fr','Type de travail ajout de dÃ©faillance',0),(516307,14342,'jp','éšœå®³è¿½åŠ ã™ã‚‹ä½œæ¥­ã®ç¨®é¡ž',0),(516308,14342,'pt','Tipo de trabalho adicionando falha',0),(516309,14342,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ Ñ‚Ð¸Ð¿ ÑÐ±Ð¾Ñ',0),(516310,14342,'es','Falta agregar tipo de trabajo',0),(516311,14342,'de','HinzufÃ¼gen von Arbeit Fehlertyp.',0),(516312,14342,'en','Failure Adding Work Type',0),(516313,14343,'is','',0),(516314,14343,'dr','Ù†ÙˆØ¹ Ú©Ø§Ø± Ø­Ø°Ù',0),(516315,14343,'pr','Ù†ÙˆØ¹ Ú©Ø§Ø± Ø­Ø°Ù',0),(516316,14343,'tr','Ä°ÅŸ tÃ¼rÃ¼nÃ¼ Sil',0),(516317,14343,'pl','UsuÅ„ typ pracy',0),(516318,14343,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(516319,14343,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(516320,14343,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(516321,14343,'vi','XÃ³a bá» cÃ´ng viá»‡c loáº¡i',0),(516322,14343,'af','Skrap werk tipe',0),(516323,14343,'ro','Åžterge activitatea tip',0),(516324,14343,'et','Kustuta tÃ¶Ã¶ tÃ¼Ã¼p',0),(516325,14343,'si','Izbrisati vrsto dela',0),(516326,14343,'ba','Menghapus jenis pekerjaan',0),(516327,14343,'nl','Werksoort verwijderen',0),(516328,14343,'fi','Poista tyÃ¶n tyyppi',0),(516329,14343,'no','Slette arbeid',0),(516330,14343,'da','Slette arbejdstype',0),(516331,14343,'ko','ìž‘ì—… í˜•ì‹ ì‚­ì œ',0),(516332,14343,'he','×œ×ž×—×•×§ ×¡×•×’ ×¢×‘×•×“×”',0),(516333,14343,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï„ÏÏ€Î¿Ï…',0),(516334,14343,'zh','åˆ é™¤å·¥ä½œç±»åž‹',0),(516335,14343,'sv','Ta bort arbetstyp',0),(516336,14343,'it','Eliminare il tipo di lavoro',0),(516337,14343,'tl','',0),(516338,14343,'th','à¸¥à¸šà¸Šà¸™à¸´à¸”à¸‡à¸²à¸™',0),(516339,14343,'hi','à¤•à¤¾à¤® à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(516340,14343,'ms','Menghapuskan jenis kerja',0),(516341,14343,'ar','Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(516342,14343,'fr','Supprimez le Type de travail',0),(516343,14343,'jp','ä½œæ¥­ã®ç¨®é¡žã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(516344,14343,'pt','Excluir o tipo de trabalho',0),(516345,14343,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‡ÐµÐ³Ð¾',0),(516346,14343,'es','Eliminar el tipo de trabajo',0),(516347,14343,'de','Arbeitstyp lÃ¶schen',0),(516348,14343,'en','Delete Work Type',0),(516349,14344,'is','',0),(516350,14344,'dr','Ø¹Ø¯Ù… Ø­Ø°Ù Ú©Ø§Ø± Ù†ÙˆØ¹',0),(516351,14344,'pr','Ø¹Ø¯Ù… Ø­Ø°Ù Ú©Ø§Ø± Ù†ÙˆØ¹',0),(516352,14344,'tr','BaÅŸarÄ±sÄ±z silme iÅŸ tÃ¼rÃ¼',0),(516353,14344,'pl','Usuwanie awarii typ pracy',0),(516354,14344,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð·Ð°Ñ‡ÐµÑ€ÐºÐ²Ð°Ð½Ðµ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(516355,14344,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ø­Ø°Ù Ú©Ø± Ø±ÛØ§ ÛÛ’ Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù…',0),(516356,14344,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð±Ñ€Ð¸ÑÐ°ÑšÐ° Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(516357,14344,'vi','Loáº¡i cÃ´ng viá»‡c xÃ³a bá» tháº¥t báº¡i',0),(516358,14344,'af','Mislukking skrap werk tipe',0),(516359,14344,'ro','EÅŸecul ÅŸtergerea de lucru tip',0),(516360,14344,'et','TÃµrge kustutamisel tÃ¶Ã¶ tÃ¼Ã¼p',0),(516361,14344,'si','Neuspeh brisanjem vrsta dela',0),(516362,14344,'ba','Jenis pekerjaan menghapus kegagalan',0),(516363,14344,'nl','Mislukking werksoort verwijderen',0),(516364,14344,'fi','Virhe poistettaessa tyÃ¶n tyyppi',0),(516365,14344,'no','Feil slette arbeidstype',0),(516366,14344,'da','Manglende sletning arbejdstype',0),(516367,14344,'ko','ì‹¤íŒ¨ ì‚­ì œ ìž‘ì—… í˜•ì‹',0),(516368,14344,'he','×¡×•×’ ×¢×‘×•×“×” ×‘×ž×—×™×§×ª ×›×©×œ',0),(516369,14344,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(516370,14344,'zh','å¤±è´¥åˆ é™¤å·¥ä½œç±»åž‹',0),(516371,14344,'sv','Fel ta bort arbetstyp',0),(516372,14344,'it','Tipo di lavoro eliminazione guasto',0),(516373,14344,'tl','',0),(516374,14344,'th','à¸Šà¸™à¸´à¸”à¸‡à¸²à¸™à¸¥à¸šà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(516375,14344,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤°',0),(516376,14344,'ms','Kegagalan menghapuskan kerja jenis',0),(516377,14344,'ar','ÙØ´Ù„ Ø­Ø°Ù Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(516378,14344,'fr','Type de travail suppression de dÃ©faillance',0),(516379,14344,'jp','å¤±æ•—ã—ãŸå‰Šé™¤ã™ã‚‹ä½œæ¥­ã®ç¨®é¡ž',0),(516380,14344,'pt','Tipo de trabalho excluindo falha',0),(516381,14344,'ru','Ð¢Ð¸Ð¿ ÑÐ±Ð¾Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(516382,14344,'es','Tipo de trabajo eliminando fallas',0),(516383,14344,'de','LÃ¶schen von Arbeit Fehlertyp.',0),(516384,14344,'en','Failure Deleting Work Type',0),(516385,14345,'is','',0),(516386,14345,'dr','Ø¹Ø¯Ù… Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ú©Ø§Ø± Ù†ÙˆØ¹',0),(516387,14345,'pr','Ø¹Ø¯Ù… Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ú©Ø§Ø± Ù†ÙˆØ¹',0),(516388,14345,'tr','BaÅŸarÄ±sÄ±z gÃ¼ncelleÅŸtirme iÅŸ tÃ¼rÃ¼',0),(516389,14345,'pl','Brak aktualizacji pracy typu',0),(516390,14345,'bg','ÐÐµÑƒÑÐ¿ÐµÑ… Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð²Ð¸Ð´ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(516391,14345,'ur','Ù†Ø§Ú©Ø§Ù…ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø§Ù… Ù‚Ø³Ù…',0),(516392,14345,'sr','ÐžÑ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð²Ñ€ÑÑ‚Ð° Ñ€Ð°Ð´Ð°',0),(516393,14345,'vi','Sá»± tháº¥t báº¡i cáº­p nháº­t cÃ´ng viá»‡c loáº¡i',0),(516394,14345,'af','Mislukking outobywerking werk tipe',0),(516395,14345,'ro','EÅŸecul actualizarea tip de munca',0),(516396,14345,'et','TÃµrge vÃ¤rskendamisel tÃ¶Ã¶ liik',0),(516397,14345,'si','Neuspeh posodabljanje vrsta dela',0),(516398,14345,'ba','Jenis pekerjaan memperbarui kegagalan',0),(516399,14345,'nl','Mislukking werksoort bijwerken',0),(516400,14345,'fi','EpÃ¤onnistuminen pÃ¤ivittÃ¤Ã¤ tyÃ¶n tyyppi',0),(516401,14345,'no','Feil oppdatering arbeidstype',0),(516402,14345,'da','Manglende opdatering arbejdstype',0),(516403,14345,'ko','ì‹¤íŒ¨ ì—…ë°ì´íŠ¸ ìž‘ì—… í˜•ì‹',0),(516404,14345,'he','×¡×•×’ ×¢×‘×•×“×” ×”×ž×¢×“×›× ×ª ×›×©×œ',0),(516405,14345,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ Ï„ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(516406,14345,'zh','å¤±è´¥æ›´æ–°å·¥ä½œç±»åž‹',0),(516407,14345,'sv','Misslyckande uppdaterande arbetstyp',0),(516408,14345,'it','Tipo di lavoro aggiornamento errore',0),(516409,14345,'tl','',0),(516410,14345,'th','à¸Šà¸™à¸´à¸”à¸‡à¸²à¸™à¹ƒà¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(516411,14345,'hi','à¤µà¤¿à¤«à¤²à¤¤à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾à¤® à¤ªà¥à¤°à¤•à¤¾à¤°',0),(516412,14345,'ms','Kegagalan mengemaskini kerja jenis',0),(516413,14345,'ar','ÙØ´Ù„ ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(516414,14345,'fr','Type de travail mise Ã  jour de panne',0),(516415,14345,'jp','å¤±æ•—ã—ãŸæ›´æ–°ä½œæ¥­ã®ç¨®é¡ž',0),(516416,14345,'pt','Tipo de trabalho atualizaÃ§Ã£o falha',0),(516417,14345,'ru','Ð¢Ð¸Ð¿ ÑÐ±Ð¾Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(516418,14345,'es','Tipo de trabajo actualizaciÃ³n falla',0),(516419,14345,'de','Aktualisierung Arbeit Fehlertyp.',0),(516420,14345,'en','Failure Updating Work Type',0),(516421,14346,'is','',0),(516422,14346,'dr','Ù¾ØªØ§Ù†Ø³ÙŠÙ„ Ø®Ø· Ù„ÙˆÙ„Ù‡',0),(516423,14346,'pr','Ù¾ØªØ§Ù†Ø³ÙŠÙ„ Ø®Ø· Ù„ÙˆÙ„Ù‡',0),(516424,14346,'tr','Potansiyelleri boru hattÄ±',0),(516425,14346,'pl','PotencjaÅ‚ rurociÄ…gu',0),(516426,14346,'bg','ÐŸÐ¾Ñ‚ÐµÐ½Ñ†Ð¸Ð°Ð»Ð¸ Ñ‚Ñ€ÑŠÐ±Ð¾Ð¿Ñ€Ð¾Ð²Ð¾Ð´',0),(516427,14346,'ur','Ø§Ù…Ú©Ø§Ù†Ø§Øª Ù¾Ø§Ø¦Ù¾ Ù„Ø§Ø¦Ù†',0),(516428,14346,'sr','ÐŸÐ¾Ñ‚ÐµÐ½Ñ†Ð¸Ñ˜Ð°Ð»Ð¸ Ð½Ð°Ñ„Ñ‚Ð¾Ð²Ð¾Ð´Ð°',0),(516429,14346,'vi','ÄÆ°á»ng á»‘ng tiá»m nÄƒng',0),(516430,14346,'af','Potensiaal pyplyn',0),(516431,14346,'ro','Conducte de potentiale',0),(516432,14346,'et','Potentsiaalide torujuhe',0),(516433,14346,'si','Potenciali cevovoda',0),(516434,14346,'ba','Potensi pipa',0),(516435,14346,'nl','Potentieel pijpleiding',0),(516436,14346,'fi','Potentiaalit putki',0),(516437,14346,'no','Potensialer rÃ¸rledning',0),(516438,14346,'da','Potentialer Pipeline',0),(516439,14346,'ko','ìž ìž¬ë ¥ íŒŒì´í”„ë¼ì¸',0),(516440,14346,'he','×¤×•×˜× ×¦×™××œ ×¦×™× ×•×¨',0),(516441,14346,'el','Î”Ï…Î½Î±Î¼Î¹ÎºÎ¬ Î±Î³Ï‰Î³Î¿Ï',0),(516442,14346,'zh','ç”µä½ç®¡é“',0),(516443,14346,'sv','Potentialer Pipeline',0),(516444,14346,'it','Pipeline di potenziali',0),(516445,14346,'tl','',0),(516446,14346,'th','à¸•à¸­à¸™à¸¨à¸±à¸à¸¢à¸ à¸²à¸ž',0),(516447,14346,'hi','à¤•à¥à¤·à¤®à¤¤à¤¾ à¤ªà¤¾à¤‡à¤ªà¤²à¤¾à¤‡à¤¨',0),(516448,14346,'ms','Talian paip potensi',0),(516449,14346,'ar','Ø¥Ù…ÙƒØ§Ù†ÙŠØ§Øª Ø®Ø· Ø£Ù†Ø§Ø¨ÙŠØ¨',0),(516450,14346,'fr','Pipeline de potentiels',0),(516451,14346,'jp','é›»ä½ãƒ‘ã‚¤ãƒ—ãƒ©ã‚¤ãƒ³',0),(516452,14346,'pt','Pipeline de potenciais',0),(516453,14346,'ru','ÐŸÐ¾Ñ‚ÐµÐ½Ñ†Ð¸Ð°Ð»Ð¾Ð² Ñ‚Ñ€ÑƒÐ±Ð¾Ð¿Ñ€Ð¾Ð²Ð¾Ð´Ð¾Ð²',0),(516454,14346,'es','TuberÃ­a de potenciales',0),(516455,14346,'de','Potenziale Pipeline',0),(516456,14346,'en','Potentials Pipeline',0),(516457,14347,'is','',0),(516458,14347,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ - Ù…Ø¯ÛŒØ±ÛŒØª Ø§Ù…ÙˆØ§Ù„',0),(516459,14347,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ - Ù…Ø¯ÛŒØ±ÛŒØª Ø§Ù…ÙˆØ§Ù„',0),(516460,14347,'tr','Kurulum - mÃ¼lkiyet yÃ¶netimi',0),(516461,14347,'pl','Instalator - zarzÄ…dzanie nieruchomoÅ›ciami',0),(516462,14347,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° - ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¸Ð¼Ð¾Ñ‚Ð¸',0),(516463,14347,'ur','Ø³ÛŒÙ¹ Ø§Ù¾ - Ø§Ù…Ù„Ø§Ú© Ú©Û’ Ø§Ù†ØªØ¸Ø§Ù…',0),(516464,14347,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ - Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ð½ÐµÐºÑ€ÐµÑ‚Ð½Ð¸Ð½Ð°Ð¼Ð°',0),(516465,14347,'vi','Thiáº¿t láº­p - quáº£n lÃ½ tÃ i sáº£n',0),(516466,14347,'af','Opstelling - Eiendomsbestuur',0),(516467,14347,'ro','Configurare - Property Management',0),(516468,14347,'et','Setup - kinnisvara haldamine',0),(516469,14347,'si','Setup - upravljanje premoÅ¾enja',0),(516470,14347,'ba','Pengaturan - manajemen properti',0),(516471,14347,'nl','Setup - beheer van onroerend goed',0),(516472,14347,'fi','Setup - omaisuudenhoito',0),(516473,14347,'no','Oppsett - Eiendomsforvaltning',0),(516474,14347,'da','Setup - ejendomsforvaltning',0),(516475,14347,'ko','ì„¤ì •-ìž¬ì‚° ê´€ë¦¬',0),(516476,14347,'he','×”×’×“×¨×•×ª - × ×™×”×•×œ × ×›×¡×™×',0),(516477,14347,'el','ÎŸÏÎ³Î¬Î½Ï‰ÏƒÎ· - Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Î±ÎºÎ¹Î½Î®Ï„Ï‰Î½',0),(516478,14347,'zh','è®¾ç½®-ç‰©ä¸šç®¡ç†',0),(516479,14347,'sv','Setup - fastighetsfÃ¶rvaltning',0),(516480,14347,'it','Installazione - gestione immobiliare',0),(516481,14347,'tl','',0),(516482,14347,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² - à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£à¸­à¸ªà¸±à¸‡à¸«à¸²à¸£à¸´à¸¡à¸—à¸£à¸±à¸žà¸¢à¹Œ',0),(516483,14347,'hi','à¤¸à¥‡à¤Ÿà¤…à¤ª - à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨',0),(516484,14347,'ms','Persediaan - pengurusan harta',0),(516485,14347,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯-Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ù…Ù…ØªÙ„ÙƒØ§Øª',0),(516486,14347,'fr','Installation - gestion immobiliÃ¨re',0),(516487,14347,'jp','ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— - ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ãƒžãƒã‚¸ãƒ¡ãƒ³ãƒˆ',0),(516488,14347,'pt','InstalaÃ§Ã£o - gestÃ£o imobiliÃ¡ria',0),(516489,14347,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° - ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½ÐµÐ´Ð²Ð¸Ð¶Ð¸Ð¼Ð¾ÑÑ‚ÑŒÑŽ',0),(516490,14347,'es','ConfiguraciÃ³n - gestiÃ³n de la propiedad',0),(516491,14347,'de','Setup - Immobilienverwaltung',0),(516492,14347,'en','Setup - Property Management',0),(516493,14348,'is','',0),(516494,14348,'dr','Ú©Ø§Ø± Ù†ÙˆØ¹ Ø§ÙØ²ÙˆØ¯Ù†/Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(516495,14348,'pr','Ú©Ø§Ø± Ù†ÙˆØ¹ Ø§ÙØ²ÙˆØ¯Ù†/Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(516496,14348,'tr','Ä°ÅŸ tÃ¼rÃ¼ Ekle/GÃ¼ncelle',0),(516497,14348,'pl','Typ pracy Dodaj/Aktualizuj',0),(516498,14348,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ð¸Ð¿ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ/Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(516499,14348,'ur','Ú©Ø§Ù… Ú©ÛŒ Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(516500,14348,'sr','Ð Ð°Ð´ Ñ‚Ð¸Ð¿ Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(516501,14348,'vi','CÃ´ng viá»‡c loáº¡i ThÃªm/Cáº­p Nháº­t',0),(516502,14348,'af','Werk tipe voeg/opdatering',0),(516503,14348,'ro','De lucru tip AdÄƒugaÅ£i/actualizaÅ£i',0),(516504,14348,'et','TÃ¶Ã¶ liigi lisamine/uuendamine',0),(516505,14348,'si','Delo vrsta Dodaj/posodobi',0),(516506,14348,'ba','Pekerjaan jenis Tambahkan/Perbarui',0),(516507,14348,'nl','Werk Type toevoegen/bijwerken',0),(516508,14348,'fi','TyÃ¶n tyyppi lisÃ¤Ã¤/PÃ¤ivitÃ¤',0),(516509,14348,'no','Arbeid Type Legg til/Oppdater',0),(516510,14348,'da','Arbejdet Type TilfÃ¸j/opdater',0),(516511,14348,'ko','ìž‘ì—… ìœ í˜• ì¶”ê°€/ì—…ë°ì´íŠ¸',0),(516512,14348,'he','×¡×•×’ ×©×œ ×¢×‘×•×“×” ×”×•×¡×¤×ª/×¢×“×›×•×Ÿ',0),(516513,14348,'el','Î¤ÏÏ€Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(516514,14348,'zh','å·¥ä½œç±»åž‹æ·»åŠ /æ›´æ–°',0),(516515,14348,'sv','Arbete typ LÃ¤gg till/uppdatera',0),(516516,14348,'it','Lavoro tipo aggiungere/aggiornare',0),(516517,14348,'tl','',0),(516518,14348,'th','à¸‡à¸²à¸™à¸Šà¸™à¸´à¸”à¹€à¸žà¸´à¹ˆà¸¡/à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(516519,14348,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡/à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(516520,14348,'ms','Kerja jenis Tambah/Kemaskini',0),(516521,14348,'ar','Ø¥Ø¶Ø§ÙØ©/ØªØ­Ø¯ÙŠØ« Ù†ÙˆØ¹ Ø§Ù„Ø¹Ù…Ù„',0),(516522,14348,'fr','Travail Type ajouter/mettre Ã  jour',0),(516523,14348,'jp','ä»•äº‹ã®ç¨®é¡žã‚’è¿½åŠ /æ›´æ–°',0),(516524,14348,'pt','Tipo de trabalho adicionar/atualizar',0),(516525,14348,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ñ‚Ð¸Ð¿ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(516526,14348,'es','Trabajo tipo agregar/actualizar',0),(516527,14348,'de','Arbeit Typ hinzufÃ¼gen/aktualisieren',0),(516528,14348,'en','Work Type Add/Update',0),(516529,14349,'is','',0),(516530,14349,'dr','Ù‡ÛŒÚ† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(516531,14349,'pr','Ù‡ÛŒÚ† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(516532,14349,'tr','HiÃ§bir veri ayarla',0),(516533,14349,'pl','Brak danych zostaÅ‚a ustawiona',0),(516534,14349,'bg','ÐÑÐ¼Ð° Ð´Ð°Ð½Ð½Ð¸ Ðµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð°',0),(516535,14349,'ur','Ú©ÙˆØ¦ÛŒ Ú©ÙˆØ§Ø¦Ù Ø³ÛŒÙ¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(516536,14349,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(516537,14349,'vi','KhÃ´ng cÃ³ dá»¯ liá»‡u Ä‘Ã£ Ä‘Æ°á»£c thiáº¿t láº­p',0),(516538,14349,'af','Geen Data is opgestel',0),(516539,14349,'ro','Nu existÄƒ date a fost stabilit',0),(516540,14349,'et','Andmeid pole mÃ¤Ã¤ratud',0),(516541,14349,'si','Komplet brez podatkov',0),(516542,14349,'ba','Tidak ada Data yang telah ditetapkan',0),(516543,14349,'nl','Geen gegevens is ingesteld',0),(516544,14349,'fi','Tietoja ei ole mÃ¤Ã¤ritetty',0),(516545,14349,'no','Ingen Data er satt',0),(516546,14349,'da','Ingen datasÃ¦t',0),(516547,14349,'ko','ë°ì´í„° ì„¤ì •',0),(516548,14349,'he','××™×Ÿ × ×ª×•× ×™× ×˜×¨× × ×§×‘×¢',0),(516549,14349,'el','Î”Î­Î½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(516550,14349,'zh','æ²¡æœ‰æ•°æ®å·²è®¾ç½®',0),(516551,14349,'sv','Inga Data har stÃ¤llts in',0),(516552,14349,'it','Nessun dato Ã¨ stato impostato',0),(516553,14349,'tl','',0),(516554,14349,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹„à¸¡à¹ˆà¸¡à¸µà¸à¸²à¸£à¸•à¸±à¹‰à¸‡',0),(516555,14349,'hi','à¤•à¥‹à¤ˆ à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(516556,14349,'ms','Tiada Data telah ditetapkan',0),(516557,14349,'ar','ÙˆÙ‚Ø¯ ØªÙ… ØªØ¹ÙŠÙŠÙ† Ø£ÙŠØ© Ø¨ÙŠØ§Ù†Ø§Øª',0),(516558,14349,'fr','Aucune donnÃ©e n\'a Ã©tÃ© dÃ©finie',0),(516559,14349,'jp','ãƒ‡ãƒ¼ã‚¿ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(516560,14349,'pt','Nenhum dado foi definido',0),(516561,14349,'ru','ÐÐ°Ð±Ð¾Ñ€ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð½ÐµÑ‚',0),(516562,14349,'es','No se ha establecido ningÃºn dato',0),(516563,14349,'de','Keine Daten wurde festgelegt.',0),(516564,14349,'en','No Data Has Been Set',0),(516565,14350,'is','',0),(516566,14350,'dr','Ù…Ù‚Ø±Ø± Ø³ÙØ§Ø±Ø´ Ø¨Ø± Ø§Ø³Ø§Ø³ ØªØ§Ø±ÛŒØ® ÙØ§Ú©ØªÙˆØ± Ø´Ø±Ø§ÛŒØ·',0),(516567,14350,'pr','Ù…Ù‚Ø±Ø± Ø³ÙØ§Ø±Ø´ Ø¨Ø± Ø§Ø³Ø§Ø³ ØªØ§Ø±ÛŒØ® ÙØ§Ú©ØªÙˆØ± Ø´Ø±Ø§ÛŒØ·',0),(516568,14350,'tr','SipariÅŸ vade tarihi fatura koÅŸullarÄ±na gÃ¶re',0),(516569,14350,'pl','ZamÃ³wienia ze wzglÄ™du na fakturze podstawie daty',0),(516570,14350,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð¿Ð°Ð´ÐµÐ¶ Ð´Ð°Ñ‚Ð° Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð° ÑƒÑÐ»Ð¾Ð²Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(516571,14350,'ur','Ø¢Ø±ÚˆØ± Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ® Ù¾Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§ØµØ·Ù„Ø§Ø­Ø§Øª Ù¾Ø± Ù…Ø¨Ù†ÛŒ',0),(516572,14350,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ ÑƒÑÐ»Ð¾Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(516573,14350,'vi','Tá»± do ngÃ y dá»±a trÃªn hÃ³a Ä‘Æ¡n tá»«',0),(516574,14350,'af','Bestel verskuldigde datum gebaseer op faktuur terme',0),(516575,14350,'ro','Comanda cuvenit data bazate pe termenii de facturÄƒ',0),(516576,14350,'et','Tellimuse tÃ¤htaeg kuupÃ¤ev pÃµhineb arve tingimused',0),(516577,14350,'si','NaroÄite zaradi datum glede na pogoje raÄuna',0),(516578,14350,'ba','Memesan Due Date berdasarkan istilah faktur',0),(516579,14350,'nl','Bestel Due datum gebaseerd op factuur voorwaarden',0),(516580,14350,'fi','Tilaa asianmukaisesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ perustuu laskun ehtojen',0),(516581,14350,'no','Bestille grunn datoen basert pÃ¥ faktureringsvilkÃ¥r',0),(516582,14350,'da','Bestil Due dato baseret pÃ¥ fakturaen',0),(516583,14350,'ko','ì¸í•´ ì£¼ë¬¸ ë‚ ì§œ ê³„ì‚° ì¡°ê±´ì— ë”°ë¼',0),(516584,14350,'he','×¡×“×¨ ×™×¢×“ ×ª××¨×™×š ×‘×”×ª×‘×¡×¡ ×¢×œ ×ª× ××™ ×—×©×‘×•× ×™×ª',0),(516585,14350,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(516586,14350,'zh','è®¢è´­åˆ°æœŸæ—¥æœŸåŸºäºŽå‘ç¥¨æ¡æ¬¾',0),(516587,14350,'sv','BestÃ¤ll vederbÃ¶rlig datum baserat pÃ¥ faktura villkor',0),(516588,14350,'it','Ordinare Due data base su termini di fattura',0),(516589,14350,'tl','',0),(516590,14350,'th','à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™à¸•à¸²à¸¡à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(516591,14350,'hi','à¤†à¤¦à¥‡à¤¶ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤° à¤šà¤¾à¤²à¤¾à¤¨ à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(516592,14350,'ms','Pesanan akhir tarikh berdasarkan terma-terma invois',0),(516593,14350,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚ Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ø³ØªÙ†Ø§Ø¯Ø§Ù‹ Ø¥Ù„Ù‰ Ø´Ø±ÙˆØ· Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(516594,14350,'fr','Commander Due Date basÃ©e sur les termes de la facture',0),(516595,14350,'jp','æ³¨æ–‡ç· ã‚åˆ‡ã‚Šæ—¥è«‹æ±‚æ›¸ã®æ¡é …ã«åŸºã¥ã',0),(516596,14350,'pt','Ordem devida Data com base em termos de factura',0),(516597,14350,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½Ð°Ð´Ð»ÐµÐ¶Ð°Ñ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ð°Ð½Ð¸Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð°',0),(516598,14350,'es','Orden debido basado en tÃ©rminos de facturaciÃ³n',0),(516599,14350,'de','Bestellen Sie Due Date basierend auf Rechnung',0),(516600,14350,'en','Order Due Date Based On Invoice Terms',0),(516601,14351,'is','',0),(516602,14351,'dr','Ù…ÙˆÙ‚Ø¹ÙŠØªÙ‡Ø§ÛŒ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø±ÙˆÛŒ Ø¨Ø±Ú†Ø³Ø¨ Ø¯Ø± Ù†Ù‚Ø§Ø·',0),(516603,14351,'pr','Ù…ÙˆÙ‚Ø¹ÙŠØªÙ‡Ø§ÛŒ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø±ÙˆÛŒ Ø¨Ø±Ú†Ø³Ø¨ Ø¯Ø± Ù†Ù‚Ø§Ø·',0),(516604,14351,'tr','Etiket Ã¼zerindeki sipariÅŸ Puan sayÄ± konumu',0),(516605,14351,'pl','ZamÃ³wienie numer pozycji na etykiecie w punktach',0),(516606,14351,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð° Ð² Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(516607,14351,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ù¾Ùˆ Ø²ÛŒØ´Ù† Ù¾Ø± Ù„ÛŒØ¨Ù„ Ù†Ú©Ø§Øª Ù…ÛŒÚº',0),(516608,14351,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ˜Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° Ð½Ð°Ð»ÐµÐ¿Ð½Ð¸Ñ†Ð¸ Ñƒ Ñ‚Ð°Ñ‡ÐºÐ°Ð¼Ð°',0),(516609,14351,'vi','Vá»‹ trÃ­ sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng trÃªn nhÃ£n á»Ÿ Ä‘iá»ƒm',0),(516610,14351,'af','Bestelling nommer posisie op etiket In punte',0),(516611,14351,'ro','ComandÄƒ numÄƒrul poziÅ£ia pe etichetÄƒ Ã®n puncte',0),(516612,14351,'et','Tellimuse Number positsiooni etiketile punktid',0),(516613,14351,'si','Naloga Å¡tevilo lega na etiketi toÄk',0),(516614,14351,'ba','Posisi nomor pesanan pada Label poin',0),(516615,14351,'nl','Bestelling nummer positie op de Label In punten',0),(516616,14351,'fi','Tilauksen numeron sijainti etiketissÃ¤ pistettÃ¤',0),(516617,14351,'no','Bestill nummer posisjon pÃ¥ etiketten poeng',0),(516618,14351,'da','Ordre nummer placering pÃ¥ etiketten i point',0),(516619,14351,'ko','í¬ì¸íŠ¸ì—ì„œ ë¼ë²¨ ì£¼ë¬¸ ë²ˆí˜¸ ìœ„ì¹˜',0),(516620,14351,'he','×”×¢×ž×“×” ×ž×¡×¤×¨ ×”×–×ž× ×” ×¢×œ ×ª×•×•×™×ª ×‘× ×§×•×“×•×ª',0),(516621,14351,'el','Î¤Î¬Î¾Î· Î±ÏÎ¹Î¸Î¼Î¿Ï Î¸Î­ÏƒÎ· ÏƒÏ„Î·Î½ ÎµÏ„Î¹ÎºÎ­Ï„Î± ÏƒÏ„Î± ÏƒÎ·Î¼ÎµÎ¯Î±',0),(516622,14351,'zh','åœ¨æ ‡ç­¾ä¸Šä»¥ç£…ä¸ºå•ä½çš„é¡ºåºç¼–å·ä½ç½®',0),(516623,14351,'sv','BestÃ¤ll antal placering pÃ¥ etikett i poÃ¤ng',0),(516624,14351,'it','Ordine numero posizione sull\'etichetta In punti',0),(516625,14351,'tl','',0),(516626,14351,'th','à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸¥à¸³à¸”à¸±à¸šà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸™à¸›à¹‰à¸²à¸¢à¹ƒà¸™à¸ˆà¸¸à¸”',0),(516627,14351,'hi','à¤²à¥‡à¤¬à¤² à¤ªà¤° à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥à¤¥à¤¾à¤¨ à¤…à¤‚à¤• à¤®à¥‡à¤‚',0),(516628,14351,'ms','Kedudukan nombor pesanan pada Label dalam mata',0),(516629,14351,'ar','ØªØ±ØªÙŠØ¨ Ù…ÙˆØ¶Ø¹ Ø§Ù„Ø±Ù‚Ù… ÙÙŠ Ø§Ù„ØªØ³Ù…ÙŠØ© ÙÙŠ Ø§Ù„Ù†Ù‚Ø§Ø·',0),(516630,14351,'fr','Ordre numÃ©ro de poste sur l\'Ã©tiquette en Points',0),(516631,14351,'jp','ãƒã‚¤ãƒ³ãƒˆ ãƒ©ãƒ™ãƒ«ã«ã‚ªãƒ¼ãƒ€ãƒ¼ç•ªå·ã®ä½ç½®',0),(516632,14351,'pt','Ordem nÃºmero posiÃ§Ã£o no rÃ³tulo em pontos',0),(516633,14351,'ru','Ð—Ð°ÐºÐ°Ð· Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ð½Ð° ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐµ Ð² Ð¿ÑƒÐ½ÐºÑ‚Ð°Ñ…',0),(516634,14351,'es','PosiciÃ³n nÃºmero del orden de etiqueta en los puntos',0),(516635,14351,'de','Anzahl Auftragslage auf Etikett Punkte',0),(516636,14351,'en','Order Number Position On Label In Points',0),(516637,14352,'is','',0),(516638,14352,'dr','Ù…ÙˆÙ‚Ø¹ÛŒØª Ù…Ù‚Ø¯Ø§Ø± Ø±ÙˆÛŒ Ø¨Ø±Ú†Ø³Ø¨ Ø¯Ø± Ù†Ù‚Ø§Ø·',0),(516639,14352,'pr','Ù…ÙˆÙ‚Ø¹ÛŒØª Ù…Ù‚Ø¯Ø§Ø± Ø±ÙˆÛŒ Ø¨Ø±Ú†Ø³Ø¨ Ø¯Ø± Ù†Ù‚Ø§Ø·',0),(516640,14352,'tr','Etiket Ã¼zerindeki miktar bulunduÄŸu noktalarÄ±',0),(516641,14352,'pl','IloÅ›Ä‡ pozycji na etykiecie w punktach',0),(516642,14352,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ñ Ð½Ð° ÐµÑ‚Ð¸ÐºÐµÑ‚Ð° Ð² Ñ‚Ð¾Ñ‡ÐºÐ¸',0),(516643,14352,'ur','Ù„ÛŒØ¨Ù„ Ù¾Ø± Ù…Ù‚Ø¯Ø§Ø± Ù¾ÙˆØ²ÛŒØ´Ù† Ù†Ú©Ø§Øª Ù…ÛŒÚº',0),(516644,14352,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ð¾Ð»Ð¾Ð¶Ð°Ñ˜ Ð½Ð° Ð¾Ð·Ð½Ð°ÐºÑƒ Ñƒ Ñ‚Ð°Ñ‡ÐºÐ°Ð¼Ð°',0),(516645,14352,'vi','Sá»‘ lÆ°á»£ng vá»‹ trÃ­ trÃªn nhÃ£n á»Ÿ Ä‘iá»ƒm',0),(516646,14352,'af','Hoeveelheid posisie op etiket In punte',0),(516647,14352,'ro','PoziÅ£ia cantitatea pe etichetÄƒ Ã®n puncte',0),(516648,14352,'et','Kogus positsiooni etiketile punktid',0),(516649,14352,'si','KoliÄina poloÅ¾aj na etiketi toÄk',0),(516650,14352,'ba','Kuantitas posisi pada Label dalam poin',0),(516651,14352,'nl','Hoeveelheid positie op de Label In punten',0),(516652,14352,'fi','MÃ¤Ã¤rÃ¤ kantaa etiketti pistettÃ¤',0),(516653,14352,'no','Antall posisjon pÃ¥ etiketten poeng',0),(516654,14352,'da','MÃ¦ngde placering pÃ¥ etiketten i point',0),(516655,14352,'ko','í¬ì¸íŠ¸ì—ì„œ ë¼ë²¨ ìˆ˜ëŸ‰ ìœ„ì¹˜',0),(516656,14352,'he','×›×ž×•×ª ×‘×¢×ž×“×” ×¢×œ ×ª×•×•×™×ª × ×§×•×“×•×ª',0),(516657,14352,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Î¸Î­ÏƒÎ· ÏƒÏ„Î·Î½ ÎµÏ„Î¹ÎºÎ­Ï„Î± ÏƒÏ„Î± ÏƒÎ·Î¼ÎµÎ¯Î±',0),(516658,14352,'zh','åœ¨æ ‡ç­¾ä¸Šä»¥ç£…ä¸ºå•ä½çš„æ•°é‡ä½ç½®',0),(516659,14352,'sv','Kvantitet Position pÃ¥ etikett i poÃ¤ng',0),(516660,14352,'it','Posizione quantitÃ  sull\'etichetta In punti',0),(516661,14352,'tl','',0),(516662,14352,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸šà¸™à¸›à¹‰à¸²à¸¢à¹ƒà¸™à¸ˆà¸¸à¸”',0),(516663,14352,'hi','à¤¬à¤¿à¤‚à¤¦à¥à¤“à¤‚ à¤®à¥‡à¤‚ à¤²à¥‡à¤¬à¤² à¤ªà¤° à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(516664,14352,'ms','Kedudukan kuantiti Label pada mata',0),(516665,14352,'ar','Ù…ÙˆÙ‚Ù Ø§Ù„ÙƒÙ…ÙŠØ© Ø¹Ù„Ù‰ Ø§Ù„ØªØ³Ù…ÙŠØ© ÙÙŠ Ø§Ù„Ù†Ù‚Ø§Ø·',0),(516666,14352,'fr','QuantitÃ© Position sur l\'Ã©tiquette en Points',0),(516667,14352,'jp','ä½ç½®ã‚’ãƒã‚¤ãƒ³ãƒˆå˜ä½ã§ã®ãƒ©ãƒ™ãƒ«ã®æ•°é‡',0),(516668,14352,'pt','PosiÃ§Ã£o de quantidade no rÃ³tulo em pontos',0),(516669,14352,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¹ Ð½Ð° ÑÑ‚Ð¸ÐºÐµÑ‚ÐºÐµ Ð² Ñ‚Ð¾Ñ‡ÐºÐ°Ñ…',0),(516670,14352,'es','PosiciÃ³n de cantidad en la etiqueta en puntos',0),(516671,14352,'de','Menge Position auf Etikett In Punkten',0),(516672,14352,'en','Quantity Position On Label In Points',0),(516673,14353,'is','',0),(516674,14353,'dr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(516675,14353,'pr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(516676,14353,'tr','SipariÅŸ numarasÄ±nÄ± gÃ¶ster',0),(516677,14353,'pl','PokaÅ¼ numer zamÃ³wienia',0),(516678,14353,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(516679,14353,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(516680,14353,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(516681,14353,'vi','Hiá»ƒn thá»‹ sá»‘ thá»© tá»±',0),(516682,14353,'af','Wys orde nommer',0),(516683,14353,'ro','AratÄƒ numÄƒrul de ordine',0),(516684,14353,'et','NÃ¤ita jÃ¤rjekorranumber',0),(516685,14353,'si','PokaÅ¾i Å¡tevilko',0),(516686,14353,'ba','Nomor pesanan Tampilkan',0),(516687,14353,'nl','Toon ordernummer',0),(516688,14353,'fi','NÃ¤ytÃ¤ numero',0),(516689,14353,'no','Vis ordrenummeret',0),(516690,14353,'da','Vis ordrenummeret',0),(516691,14353,'ko','ì£¼ë¬¸ ë²ˆí˜¸ë¥¼ í‘œì‹œ',0),(516692,14353,'he','×”×¦×’ ××ª ×ž×¡×¤×¨ ×”×”×–×ž× ×”',0),(516693,14353,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î¬Î¾Î· Î±ÏÎ¹Î¸Î¼Î¿Ï',0),(516694,14353,'zh','æ˜¾ç¤ºè®¢å•ç¼–å·',0),(516695,14353,'sv','Visa ordernummer',0),(516696,14353,'it','Visualizza il numero di ordine',0),(516697,14353,'tl','',0),(516698,14353,'th','à¹à¸ªà¸”à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(516699,14353,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(516700,14353,'ms','Menunjukkan nombor pesanan',0),(516701,14353,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨',0),(516702,14353,'fr','Affiche le numÃ©ro de commande',0),(516703,14353,'jp','æ³¨æ–‡ç•ªå·ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(516704,14353,'pt','Mostrar o nÃºmero de ordem',0),(516705,14353,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(516706,14353,'es','Mostrar nÃºmero de pedido',0),(516707,14353,'de','Bestellnummer anzeigen',0),(516708,14353,'en','Show Order Number',0),(516709,14354,'is','',0),(516710,14354,'dr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø±',0),(516711,14354,'pr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ù…Ù‚Ø¯Ø§Ø±',0),(516712,14354,'tr','MiktarÄ± gÃ¶ster',0),(516713,14354,'pl','PokaÅ¼ iloÅ›Ä‡',0),(516714,14354,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(516715,14354,'ur','Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(516716,14354,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ',0),(516717,14354,'vi','Hiá»ƒn thá»‹ sá»‘ lÆ°á»£ng',0),(516718,14354,'af','Hoeveelheid wys',0),(516719,14354,'ro','AratÄƒ cantitatea',0),(516720,14354,'et','Kas nÃ¤idata kogust',0),(516721,14354,'si','PokaÅ¾i koliÄino',0),(516722,14354,'ba','Menunjukkan jumlah',0),(516723,14354,'nl','Toon aantal',0),(516724,14354,'fi','NÃ¤ytÃ¤ mÃ¤Ã¤rÃ¤',0),(516725,14354,'no','Vis antallet',0),(516726,14354,'da','Vis mÃ¦ngde',0),(516727,14354,'ko','ìˆ˜ëŸ‰ í‘œì‹œ',0),(516728,14354,'he','×œ×”×¦×™×’ ×›×ž×•×ª',0),(516729,14354,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±Ï‚',0),(516730,14354,'zh','æ˜¾ç¤ºæ•°é‡',0),(516731,14354,'sv','Visa kvantitet',0),(516732,14354,'it','Visualizza la quantitÃ ',0),(516733,14354,'tl','',0),(516734,14354,'th','à¹à¸ªà¸”à¸‡à¸›à¸£à¸´à¸¡à¸²à¸“',0),(516735,14354,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(516736,14354,'ms','Menunjukkan kuantiti',0),(516737,14354,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ÙƒÙ…ÙŠØ©',0),(516738,14354,'fr','Voir la quantitÃ©',0),(516739,14354,'jp','é‡ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(516740,14354,'pt','Mostrar quantidade',0),(516741,14354,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(516742,14354,'es','Mostrar cantidad',0),(516743,14354,'de','Karte-Menge',0),(516744,14354,'en','Show Quantity',0),(516745,14355,'is','',0),(516746,14355,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± Ø¬Ø¯ÛŒØ¯',0),(516747,14355,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± Ø¬Ø¯ÛŒØ¯',0),(516748,14355,'tr','Yeni el ile Ã¶deme',0),(516749,14355,'pl','Nowy podrÄ™cznik pÅ‚atnoÅ›ci',0),(516750,14355,'bg','ÐÐ¾Ð²Ð¸ Ñ€ÑŠÑ‡Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(516751,14355,'ur','Ù†Ø¦Û’ Ø¯Ø³ØªÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(516752,14355,'sr','ÐÐ¾Ð²Ð° Ð ÑƒÑ‡Ð½Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(516753,14355,'vi','Thanh toÃ¡n má»›i hÆ°á»›ng dáº«n sá»­ dá»¥ng',0),(516754,14355,'af','Nuwe handleiding betaling',0),(516755,14355,'ro','NouÄƒ platÄƒ manualÄƒ',0),(516756,14355,'et','Uus automaat makse',0),(516757,14355,'si','Novo roÄno plaÄilo',0),(516758,14355,'ba','Pembayaran Manual baru',0),(516759,14355,'nl','Nieuwe handmatige betaling',0),(516760,14355,'fi','Uusi manuaalinen maksu',0),(516761,14355,'no','Ny manuell betaling',0),(516762,14355,'da','Nye manuel betaling',0),(516763,14355,'ko','ìƒˆë¡œìš´ ìˆ˜ë™ ê²°ì œ',0),(516764,14355,'he','×ª×©×œ×•× ×™×“× ×™ ×—×“×©',0),(516765,14355,'el','ÎÎ­Î¿ ÎµÎ³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(516766,14355,'zh','æ–°æ‰‹åŠ¨ä»˜æ¬¾',0),(516767,14355,'sv','Ny manuell betalning',0),(516768,14355,'it','Nuovo pagamento manuale',0),(516769,14355,'tl','',0),(516770,14355,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡à¹ƒà¸«à¸¡à¹ˆ',0),(516771,14355,'hi','à¤¨à¤¯à¤¾ à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(516772,14355,'ms','Bayaran secara Manual yang baru',0),(516773,14355,'ar','Ø§Ù„Ø¯ÙØ¹ Ø§Ù„ÙŠØ¯ÙˆÙŠ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(516774,14355,'fr','Nouveau paiement manuel',0),(516775,14355,'jp','æ–°ã—ã„ã®æ‰‹å‹•ã®ãŠæ”¯æ‰•ã„',0),(516776,14355,'pt','Pagamento Manual novo',0),(516777,14355,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ€ÑƒÑ‡Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(516778,14355,'es','Nuevo pago Manual',0),(516779,14355,'de','Neue manuelle Zahlung',0),(516780,14355,'en','New Manual Payment',0),(516781,14356,'is','',0),(516782,14356,'dr','ØµÙ†Ø¯ÙˆÙ‚ Ø¬Ø¯ÛŒØ¯ Ø¨Ø±Ø§ÛŒ AP',0),(516783,14356,'pr','ØµÙ†Ø¯ÙˆÙ‚ Ø¬Ø¯ÛŒØ¯ Ø¨Ø±Ø§ÛŒ AP',0),(516784,14356,'tr','AP iÃ§in yeni PO',0),(516785,14356,'pl','Nowe PO AP',0),(516786,14356,'bg','ÐÐ¾Ð²Ð¸ PO Ð°Ð¿',0),(516787,14356,'ur','AP Ú©Û’ Ù„ÛŒÛ’ Ù†Ø¦Û’ Ù¾Ùˆ',0),(516788,14356,'sr','ÐÐ¾Ð²Ð¸ ÐŸÐž ÐÐŸ',0),(516789,14356,'vi','Má»›i PO Ä‘á»ƒ AP',0),(516790,14356,'af','Nuwe PO te AP',0),(516791,14356,'ro','PO nou AP',0),(516792,14356,'et','Uus PO AP',0),(516793,14356,'si','Novih PO k AP',0),(516794,14356,'ba','Baru PO AP',0),(516795,14356,'nl','Nieuwe PO aan AP',0),(516796,14356,'fi','Uuden PO AP',0),(516797,14356,'no','Nye PO til AP',0),(516798,14356,'da','Nye PO til AP',0),(516799,14356,'ko','APì— ìƒˆë¡œìš´ í¬',0),(516800,14356,'he','×¤×• ×—×“×© ×œ AP',0),(516801,14356,'el','ÎÎ­Î± PO Î±Ï€',0),(516802,14356,'zh','æ–°å®åˆ° AP',0),(516803,14356,'sv','Nya PO AP',0),(516804,14356,'it','Nuovo PO AP',0),(516805,14356,'tl','',0),(516806,14356,'th','PO à¹ƒà¸«à¸¡à¹ˆà¹„à¸›à¸—à¸µà¹ˆ AP',0),(516807,14356,'hi','à¤à¤ªà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤ à¤ªà¥‹',0),(516808,14356,'ms','PO baru untuk AP',0),(516809,14356,'ar','Ø¨Ùˆ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ù„ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(516810,14356,'fr','Nouveau PO Ã  AP',0),(516811,14356,'jp','æ–°ã—ã„ PO AP ã‚’',0),(516812,14356,'pt','Novo PO para AP',0),(516813,14356,'ru','ÐÐ¾Ð²Ñ‹Ðµ PO Ð´Ð»Ñ AP',0),(516814,14356,'es','Nuevo PO a AP',0),(516815,14356,'de','Neue PO mit AP',0),(516816,14356,'en','New PO To AP',0),(516817,14357,'is','',0),(516818,14357,'dr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ù‡ ØªÙ…Ø§Ù… Ù…Ø´ØªØ±ÛŒØ§Ù† Ù…Ø·Ø§Ø¨Ù‚',0),(516819,14357,'pr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ù‡ ØªÙ…Ø§Ù… Ù…Ø´ØªØ±ÛŒØ§Ù† Ù…Ø·Ø§Ø¨Ù‚',0),(516820,14357,'tr','TÃ¼m eÅŸleÅŸen mÃ¼ÅŸterilere e-posta deyimleri',0),(516821,14357,'pl','E-mail instrukcje do wszystkich klientÃ³w pasujÄ…ce',0),(516822,14357,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸ Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð°Ñ‰Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(516823,14357,'ur','ØªÙ…Ø§Ù… Ù…Ø´Ø§Ø¨Û ØµØ§Ø±ÙÛŒÙ† Ú©Ùˆ Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ø¨ÛŒØ§Ù†Ø§Øª',0),(516824,14357,'sr','Ð•Ð¼Ð°Ð¸Ð» Ð¸Ð·Ñ˜Ð°Ð²Ðµ Ð´Ð° ÑÐ²Ð¸ ÐºÑƒÐ¿Ñ†Ð¸ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ',0),(516825,14357,'vi','BÃ¡o cÃ¡o email cho táº¥t cáº£ phÃ¹ há»£p vá»›i khÃ¡ch hÃ ng hÃ ng',0),(516826,14357,'af','E-pos state aan alle bypassende kliÃ«nte',0),(516827,14357,'ro','DeclaraÅ£iile de e-mail la toÅ£i clienÅ£ii potrivire',0),(516828,14357,'et','E-posti avaldused sobitamine klientidelt',0),(516829,14357,'si','Email izjave vse ujemanje stranke',0),(516830,14357,'ba','Laporan email untuk semua pelanggan yang cocok',0),(516831,14357,'nl','E verklaringen aan alle overeenkomende klanten',0),(516832,14357,'fi','SÃ¤hkÃ¶posti lausuntoja kaikki vastaavat asiakkaat',0),(516833,14357,'no','E-uttalelser til alle samsvarende kunder',0),(516834,14357,'da','E-mail udtalelser til alle matchende kunder',0),(516835,14357,'ko','ëª¨ë“  ì¼ì¹˜ í•˜ëŠ” ê³ ê°ì— ê²Œ ì´ë©”ì¼ ë¬¸ì˜',0),(516836,14357,'he','×”×¦×”×¨×•×ª ×“×•× ×œ×›×œ ×”×œ×§×•×—×•×ª ×ª×•××ž×•×ª',0),(516837,14357,'el','Î”Î·Î»ÏŽÏƒÎµÎ¹Ï‚ Ï„Î¿Ï… Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… ÏƒÎµ ÏŒÎ»Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(516838,14357,'zh','å‘æ‰€æœ‰åŒ¹é…å®¢æˆ·çš„ç”µå­é‚®ä»¶å£°æ˜Ž',0),(516839,14357,'sv','E-post meddelanden till alla matchande kunder',0),(516840,14357,'it','Dichiarazioni di e-mail a tutti i clienti corrispondente',0),(516841,14357,'tl','',0),(516842,14357,'th','à¸‡à¸šà¸­à¸µà¹€à¸¡à¸¥à¹Œà¹ƒà¸«à¹‰à¸•à¸£à¸‡à¸à¸±à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(516843,14357,'hi','à¤¸à¤­à¥€ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤ˆà¤®à¥‡à¤² à¤¬à¤¯à¤¾à¤¨',0),(516844,14357,'ms','Penyata e-mel kepada semua pelanggan yang sepadan',0),(516845,14357,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù…Ø·Ø§Ø¨Ù‚Ø©',0),(516846,14357,'fr','DÃ©clarations de courriel Ã  tous les clients correspondants',0),(516847,14357,'jp','ä¸€è‡´ã™ã‚‹ã™ã¹ã¦ã®ãŠå®¢æ§˜ã«ãƒ¡ãƒ¼ãƒ«æ–‡',0),(516848,14357,'pt','DeclaraÃ§Ãµes de e-mail a todos os clientes correspondentes',0),(516849,14357,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð´Ð»Ñ Ð²ÑÐµÑ… Ð¿Ð¾Ð´Ñ…Ð¾Ð´ÑÑ‰Ð¸Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(516850,14357,'es','Declaraciones de correo electrÃ³nico a todos los clientes que empareja',0),(516851,14357,'de','E-Mail-Anweisungen fÃ¼r alle passenden Kunden',0),(516852,14357,'en','Email Statements To All Matching Customers',0),(516853,14358,'is','',0),(516854,14358,'dr','Ø§ÛŒÙ…ÛŒÙ„ Ø§Ø¸Ù‡Ø§Ø±Ø§Øª',0),(516855,14358,'pr','Ø§ÛŒÙ…ÛŒÙ„ Ø§Ø¸Ù‡Ø§Ø±Ø§Øª',0),(516856,14358,'tr','E-posta deyimleri',0),(516857,14358,'pl','E-mail instrukcje',0),(516858,14358,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(516859,14358,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ø¨ÛŒØ§Ù†Ø§Øª',0),(516860,14358,'sr','Ð•Ð¼Ð°Ð¸Ð» Ð¸Ð·Ñ˜Ð°Ð²Ðµ',0),(516861,14358,'vi','BÃ¡o cÃ¡o email',0),(516862,14358,'af','E-pos state',0),(516863,14358,'ro','E-mail declaratii',0),(516864,14358,'et','E-posti avaldused',0),(516865,14358,'si','Email izjave',0),(516866,14358,'ba','Laporan email',0),(516867,14358,'nl','E verklaringen',0),(516868,14358,'fi','SÃ¤hkÃ¶posti lausunnot',0),(516869,14358,'no','E-uttalelser',0),(516870,14358,'da','E-mail udtalelser',0),(516871,14358,'ko','ì´ë©”ì¼ ë¬¸ì˜',0),(516872,14358,'he','×”×¦×”×¨×•×ª ×“×•×',0),(516873,14358,'el','Î”Î·Î»ÏŽÏƒÎµÎ¹Ï‚ Ï„Î¿Ï… Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(516874,14358,'zh','ç”µå­é‚®ä»¶å£°æ˜Ž',0),(516875,14358,'sv','E-uttalanden',0),(516876,14358,'it','E-mail istruzioni',0),(516877,14358,'tl','',0),(516878,14358,'th','à¸‡à¸šà¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(516879,14358,'hi','à¤ˆà¤®à¥‡à¤² à¤¬à¤¯à¤¾à¤¨',0),(516880,14358,'ms','Penyata e-mel',0),(516881,14358,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(516882,14358,'fr','Envoyer des dÃ©clarations',0),(516883,14358,'jp','ãƒ¡ãƒ¼ãƒ«æ–‡',0),(516884,14358,'pt','DeclaraÃ§Ãµes de e-mail',0),(516885,14358,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ð¹ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¹',0),(516886,14358,'es','Declaraciones de correo electrÃ³nico',0),(516887,14358,'de','E-Mail-Anweisungen',0),(516888,14358,'en','Email Statements',0),(516889,14359,'is','',0),(516890,14359,'dr','Ø¨Ø¯ÙˆÙ† Ø§ÛŒÙ…ÛŒÙ„',0),(516891,14359,'pr','Ø¨Ø¯ÙˆÙ† Ø§ÛŒÙ…ÛŒÙ„',0),(516892,14359,'tr','E-posta yok',0),(516893,14359,'pl','Nie E-mail',0),(516894,14359,'bg','ÐÑÐ¼Ð° Ð¸Ð¼ÐµÐ¹Ð»',0),(516895,14359,'ur','Ú©ÙˆØ¦ÛŒ Ø§ÛŒ Ù…ÛŒÙ„',0),(516896,14359,'sr','ÐÐµÐ¼Ð° Ð•-Ð¼Ð°Ð¸Ð»',0),(516897,14359,'vi','KhÃ´ng cÃ³ Email',0),(516898,14359,'af','Geen e-pos',0),(516899,14359,'ro','Nici un Email',0),(516900,14359,'et','E-post',0),(516901,14359,'si','Brez e-poÅ¡te',0),(516902,14359,'ba','Ada Email',0),(516903,14359,'nl','Geen E-mail',0),(516904,14359,'fi','Ei sÃ¤hkÃ¶postia',0),(516905,14359,'no','Ingen e-post',0),(516906,14359,'da','Ingen E-mail',0),(516907,14359,'ko','ì´ë©”ì¼',0),(516908,14359,'he','××™×Ÿ ××™×ž×™×™×œ',0),(516909,14359,'el','Î”ÎµÎ½ Email',0),(516910,14359,'zh','æ²¡æœ‰ç”µå­é‚®ä»¶',0),(516911,14359,'sv','Ingen e-post',0),(516912,14359,'it','No E-mail',0),(516913,14359,'tl','',0),(516914,14359,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(516915,14359,'hi','à¤•à¥‹à¤ˆ à¤ˆà¤®à¥‡à¤²',0),(516916,14359,'ms','E-mel tidak',0),(516917,14359,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(516918,14359,'fr','Aucun E-mail',0),(516919,14359,'jp','ãƒ¡ãƒ¼ãƒ«ãªã—',0),(516920,14359,'pt','Sem E-mail',0),(516921,14359,'ru','ÐÐµÑ‚ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(516922,14359,'es','No Email',0),(516923,14359,'de','Keine E-Mail',0),(516924,14359,'en','No Email',0),(516925,14360,'is','',0),(516926,14360,'dr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø§ÛŒÙ…ÛŒÙ„ Ù¾ÛŒØ´Ø±ÙØª',0),(516927,14360,'pr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø§ÛŒÙ…ÛŒÙ„ Ù¾ÛŒØ´Ø±ÙØª',0),(516928,14360,'tr','Bildirimi e-posta ilerleme',0),(516929,14360,'pl','Instrukcja E-mail postÄ™pu',0),(516930,14360,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð½Ð°Ð¿Ñ€ÐµÐ´ÑŠÐº Ð´ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ',0),(516931,14360,'ur','Ø¨ÛŒØ§Ù† Ø§ÛŒ Ù…ÛŒÙ„ Ù¾ÛŒØ´ Ø±ÙØª',0),(516932,14360,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð•Ð¼Ð°Ð¸Ð» Ð½Ð°Ð¿Ñ€ÐµÐ´Ð°Ðº',0),(516933,14360,'vi','BÃ¡o cÃ¡o Email tiáº¿n bá»™',0),(516934,14360,'af','Stelling e-pos vordering',0),(516935,14360,'ro','Progresul de Email declaraÅ£ie',0),(516936,14360,'et','Avaldus e-posti edu',0),(516937,14360,'si','Izjava Email napredek',0),(516938,14360,'ba','Pernyataan Email kemajuan',0),(516939,14360,'nl','Verklaring E-mail vooruitgang',0),(516940,14360,'fi','Ilmoitus Email edistymistÃ¤',0),(516941,14360,'no','Setningen e-fremgang',0),(516942,14360,'da','ErklÃ¦ring E-mail fremskridt',0),(516943,14360,'ko','ì„±ëª… ì´ë©”ì¼ ì§„í–‰',0),(516944,14360,'he','×”×”×¦×”×¨×” ×“×•× ×œ ×”×ª×§×“×ž×•×ª',0),(516945,14360,'el','Î”Î®Î»Ï‰ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Ï€ÏÏŒÎ¿Î´Î¿',0),(516946,14360,'zh','å£°æ˜Žç”µå­é‚®ä»¶è¿›å±•',0),(516947,14360,'sv','Uttalande e-framsteg',0),(516948,14360,'it','Corso di istruzione Email',0),(516949,14360,'tl','',0),(516950,14360,'th','à¸„à¸§à¸²à¸¡à¸„à¸·à¸šà¸«à¸™à¹‰à¸²à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸£à¸²à¸¢à¸‡à¸²à¸™',0),(516951,14360,'hi','à¤¬à¤¯à¤¾à¤¨ à¤ˆà¤®à¥‡à¤² à¤ªà¥à¤°à¤—à¤¤à¤¿',0),(516952,14360,'ms','Penyata e-mel kemajuan',0),(516953,14360,'ar','Ø¨ÙŠØ§Ù† Ø£Ø±Ø³Ù„ Ø§Ù„ØªÙ‚Ø¯Ù…',0),(516954,14360,'fr','DÃ©claration Email progrÃ¨s',0),(516955,14360,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆé›»å­ãƒ¡ãƒ¼ãƒ«ã®é€²è¡ŒçŠ¶æ³',0),(516956,14360,'pt','DeclaraÃ§Ã£o E-mail progresso',0),(516957,14360,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð¿Ñ€Ð¾Ð³Ñ€ÐµÑÑ',0),(516958,14360,'es','DeclaraciÃ³n Email progreso',0),(516959,14360,'de','Anweisung E-Mail Fortschritt',0),(516960,14360,'en','Statement Email Progress',0),(516961,14361,'is','',0),(516962,14361,'dr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(516963,14361,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(516964,14361,'tr','Nakliye notlar',0),(516965,14361,'pl','WysyÅ‚anie notatki',0),(516966,14361,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(516967,14361,'ur','Ø´Ù¾Ù†Ú¯ Ù†ÙˆÙ¹',0),(516968,14361,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(516969,14361,'vi','Váº­n chuyá»ƒn Notes',0),(516970,14361,'af','Gestuur notas',0),(516971,14361,'ro','Notele de livrare',0),(516972,14361,'et','Toimetaja mÃ¤rkused',0),(516973,14361,'si','Dostava opombe',0),(516974,14361,'ba','Pengiriman Catatan',0),(516975,14361,'nl','Verzending notities',0),(516976,14361,'fi','Toimitus toteaa',0),(516977,14361,'no','Frakt notater',0),(516978,14361,'da','Shipping noter',0),(516979,14361,'ko','ë°°ì†¡ ë…¸íŠ¸',0),(516980,14361,'he','×ž×©×œ×•×— ×”×¢×¨×•×ª',0),(516981,14361,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î± ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(516982,14361,'zh','èˆªè¿ç¬”è®°',0),(516983,14361,'sv','Frakt anteckningar',0),(516984,14361,'it','Note di spedizione',0),(516985,14361,'tl','',0),(516986,14361,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(516987,14361,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(516988,14361,'ms','Nota-Nota perkapalan',0),(516989,14361,'ar','Ù…Ø°ÙƒØ±Ø§Øª Ø§Ù„Ø´Ø­Ù†',0),(516990,14361,'fr','Informations sur la livraison',0),(516991,14361,'jp','ç™ºé€ã®æ³¨æ„äº‹é …',0),(516992,14361,'pt','Envio de notas',0),(516993,14361,'ru','ÐŸÐ¾Ð³Ñ€ÑƒÐ·Ð¾Ñ‡Ð½Ñ‹Ðµ',0),(516994,14361,'es','Notas de envÃ­o',0),(516995,14361,'de','Versandhinweise',0),(516996,14361,'en','Shipping Notes',0),(516997,14362,'is','',0),(516998,14362,'dr','Ù‚Ø§Ù„Ø¨ EFT Ú©Ø§Ù†Ø§Ø¯Ø§',0),(516999,14362,'pr','Ù‚Ø§Ù„Ø¨ EFT Ú©Ø§Ù†Ø§Ø¯Ø§',0),(517000,14362,'tr','KanadalÄ± EFT biÃ§imi',0),(517001,14362,'pl','Kanadyjski EFT Format',0),(517002,14362,'bg','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ¸ EFT Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(517003,14362,'ur','Ú©ÛŒÙ†ÛŒÚˆÛŒÙ† EFT ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(517004,14362,'sr','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ¸ Ð•Ð¤Ð¢ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(517005,14362,'vi','Canada EFT Ä‘á»‹nh dáº¡ng',0),(517006,14362,'af','Kanadese EFT formaat',0),(517007,14362,'ro','Canadian EFT Format',0),(517008,14362,'et','Kanada EFT Formaat',0),(517009,14362,'si','Kanadski EFT Format',0),(517010,14362,'ba','Kanada TDE Format',0),(517011,14362,'nl','Canadese EFT formaat',0),(517012,14362,'fi','Kanadan EFT muodossa',0),(517013,14362,'no','Kanadiske EFT Format',0),(517014,14362,'da','Canadiske EFT Format',0),(517015,14362,'ko','ìºë‚˜ë‹¤ ì†¡ê¸ˆ í˜•ì‹',0),(517016,14362,'he','×ª×‘× ×™×ª EFT ×§× ×“×™',0),(517017,14362,'el','ÎšÎ±Î½Î±Î´Î¹ÎºÎ® EFT Î¼Î¿ÏÏ†Î®',0),(517018,14362,'zh','åŠ æ‹¿å¤§ EFT æ ¼å¼',0),(517019,14362,'sv','Kanadensiska EFT Format',0),(517020,14362,'it','EFT canadese formato',0),(517021,14362,'tl','',0),(517022,14362,'th','à¸£à¸¹à¸›à¹à¸šà¸š EFT à¹à¸„à¸™à¸²à¸”à¸²',0),(517023,14362,'hi','à¤•à¤¨à¤¾à¤¡à¤¾à¤ˆ à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(517024,14362,'ms','Format Kanada EFT',0),(517025,14362,'ar','ØªÙ†Ø³ÙŠÙ‚ EFT Ø§Ù„ÙƒÙ†Ø¯ÙŠ',0),(517026,14362,'fr','Format canadien EFT',0),(517027,14362,'jp','ã‚«ãƒŠãƒ€ã®éŠ€è¡Œå£åº§æŒ¯è¾¼ã®å½¢å¼',0),(517028,14362,'pt','Formato EFT canadense',0),(517029,14362,'ru','ÐšÐ°Ð½Ð°Ð´ÑÐºÐ¸Ð¹ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ð¹ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(517030,14362,'es','Formato canadiense EFT',0),(517031,14362,'de','Kanadische EFT-Format',0),(517032,14362,'en','Canadian EFT Format',0),(517033,14363,'is','',0),(517034,14363,'dr','CIBC',0),(517035,14363,'pr','CIBC',0),(517036,14363,'tr','CIBC',0),(517037,14363,'pl','CIBC',0),(517038,14363,'bg','CIBC',0),(517039,14363,'ur','Ú©Ø§Ø¨Ú©',0),(517040,14363,'sr','Ð¦Ð˜Ð‘Ð¦',0),(517041,14363,'vi','CIBC',0),(517042,14363,'af','CIBC',0),(517043,14363,'ro','CIBC',0),(517044,14363,'et','CIBC',0),(517045,14363,'si','CIBC',0),(517046,14363,'ba','CIBC',0),(517047,14363,'nl','CIBC',0),(517048,14363,'fi','CIBC',0),(517049,14363,'no','CIBC',0),(517050,14363,'da','CIBC',0),(517051,14363,'ko','CIBC',0),(517052,14363,'he','CIBC',0),(517053,14363,'el','CIBC',0),(517054,14363,'zh','åŠ æ‹¿å¤§å¸å›½å•†ä¸šé“¶è¡Œ',0),(517055,14363,'sv','CIBC',0),(517056,14363,'it','CIBC',0),(517057,14363,'tl','',0),(517058,14363,'th','CIBC',0),(517059,14363,'hi','à¤•à¤¨à¤¾à¤¡à¤¿à¤¯à¤¨ à¤¬à¥ˆà¤‚à¤•',0),(517060,14363,'ms','CIBC',0),(517061,14363,'ar','CIBC',0),(517062,14363,'fr','CIBC',0),(517063,14363,'jp','CIBC',0),(517064,14363,'pt','CIBC',0),(517065,14363,'ru','CIBC',0),(517066,14363,'es','CIBC',0),(517067,14363,'de','CIBC',0),(517068,14363,'en','CIBC',0),(517069,14364,'is','',0),(517070,14364,'dr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹',0),(517071,14364,'pr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹',0),(517072,14364,'tr','BaÅŸlangÄ±Ã§ tarihi',0),(517073,14364,'pl','Data poczÄ…tkowa',0),(517074,14364,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(517075,14364,'ur','ØªØ§Ø±ÛŒØ® Ø¢ØºØ§Ø²',0),(517076,14364,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(517077,14364,'vi','Báº¯t Ä‘áº§u tá»« ngÃ y',0),(517078,14364,'af','Begin datum',0),(517079,14364,'ro','ÃŽncepÃ¢nd cu data',0),(517080,14364,'et','SÏ…idu alguse kuupÎ´ev',0),(517081,14364,'si','ZaÄetni datum',0),(517082,14364,'ba','Tanggal awal',0),(517083,14364,'nl','Begindatum',0),(517084,14364,'fi','AlkamispÃ¤ivÃ¤',0),(517085,14364,'no','Startdatoen',0),(517086,14364,'da','Startdato',0),(517087,14364,'ko','ì‹œìž‘ ë‚ ì§œ',0),(517088,14364,'he','×ª××¨×™×š ×ª×—×™×œ×ª',0),(517089,14364,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(517090,14364,'zh','å¼€å§‹æ—¥æœŸ',0),(517091,14364,'sv','Startdatum',0),(517092,14364,'it','Data di inizio',0),(517093,14364,'tl','',0),(517094,14364,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(517095,14364,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(517096,14364,'ms','Mulai tarikh',0),(517097,14364,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø§ÙŠØ©',0),(517098,14364,'fr','Date de dÃ©but',0),(517099,14364,'jp','é–‹å§‹æ—¥',0),(517100,14364,'pt','Data de inÃ­cio',0),(517101,14364,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(517102,14364,'es','Fecha de inicio',0),(517103,14364,'de','Datum Beginn',0),(517104,14364,'en','Beginning Date',0),(517105,14365,'is','',0),(517106,14365,'dr','Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù† ØªØ¹Ø§Ø¯Ù„',0),(517107,14365,'pr','Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù† ØªØ¹Ø§Ø¯Ù„',0),(517108,14365,'tr','KapanÄ±ÅŸ bakiyesi',0),(517109,14365,'pl','Saldo zamkniÄ™cia',0),(517110,14365,'bg','ÐšÑ€Ð°Ð¹Ð½Ð¾ ÑÐ°Ð»Ð´Ð¾',0),(517111,14365,'ur','ØªÙˆØ§Ø²Ù† Ø¨Ù†Ø¯ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(517112,14365,'sr','Ð—Ð°ÐºÑ™ÑƒÑ‡Ð½Ð¸ ÑÐ°Ð»Ð´Ð¾',0),(517113,14365,'vi','ÄÃ³ng cá»­a sá»‘ dÆ°',0),(517114,14365,'af','Sluitende balans',0),(517115,14365,'ro','Echilibrul de Ã®nchidere',0),(517116,14365,'et','Aasta lÃµppsaldo',0),(517117,14365,'si','Zapiranje ravnovesje',0),(517118,14365,'ba','Menutup keseimbangan',0),(517119,14365,'nl','Eindsaldo',0),(517120,14365,'fi','Kirjanpitoarvo kauden lopussa',0),(517121,14365,'no','Avslutningssaldoen',0),(517122,14365,'da','Ultimosaldo',0),(517123,14365,'ko','ê²°ì‚° ìž”ì•¡',0),(517124,14365,'he','×ž×™×ª×¨×ª ×¡×’×™×¨×”',0),(517125,14365,'el','ÎšÎ»ÎµÎ¯ÏƒÎ¹Î¼Î¿ Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î±',0),(517126,14365,'zh','æœŸæœ«ä½™é¢',0),(517127,14365,'sv','UtgÃ¥ende balans',0),(517128,14365,'it','Saldo di chiusura',0),(517129,14365,'tl','',0),(517130,14365,'th','à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸›à¸´à¸”à¸šà¸±à¸à¸Šà¸µ',0),(517131,14365,'hi','à¤¸à¤‚à¤¤à¥à¤²à¤¨ à¤•à¥‹ à¤¬à¤‚à¤¦ à¤•à¤°à¤¨à¥‡',0),(517132,14365,'ms','Tutup baki',0),(517133,14365,'ar','Ø±ØµÙŠØ¯ Ø§Ù„Ø¥Ù‚ÙØ§Ù„',0),(517134,14365,'fr','Solde de clÃ´ture',0),(517135,14365,'jp','æœŸæœ«æ®‹é«˜',0),(517136,14365,'pt','Saldo final',0),(517137,14365,'ru','ÐšÐ¾Ð½ÐµÑ‡Ð½Ð¾Ðµ ÑÐ°Ð»ÑŒÐ´Ð¾',0),(517138,14365,'es','Cierre de Balance',0),(517139,14365,'de','Endstand',0),(517140,14365,'en','Closing Balance',0),(517141,14366,'is','',0),(517142,14366,'dr','ØªØ§Ø±ÙŠØ® Ø®Ø§ØªÙ…Ù‡',0),(517143,14366,'pr','ØªØ§Ø±ÙŠØ® Ø®Ø§ØªÙ…Ù‡',0),(517144,14366,'tr','KapanÄ±ÅŸ tarihi',0),(517145,14366,'pl','Data zamkniÄ™cia',0),(517146,14366,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð²Ð°Ð½Ðµ',0),(517147,14366,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø¨Ù†Ø¯ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(517148,14366,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐ°',0),(517149,14366,'vi','NgÃ y chá»‘t',0),(517150,14366,'af','Sluitingsdatum',0),(517151,14366,'ro','Data limitÄƒ',0),(517152,14366,'et','Sulgemise kuupÃ¤ev',0),(517153,14366,'si','ZakljuÄni datum',0),(517154,14366,'ba','Tanggal penutupan',0),(517155,14366,'nl','Uiterste datum',0),(517156,14366,'fi','Hakuaika pÃ¤Ã¤ttyy',0),(517157,14366,'no','SÃ¸knadsfrist',0),(517158,14366,'da','Ultimodato-',0),(517159,14366,'ko','ë§ˆê°ì¼',0),(517160,14366,'he','×ª××¨×™×š ×”×¡×’×™×¨×”',0),(517161,14366,'el','ÎšÎ±Ï„Î±Î»Î·ÎºÏ„Î¹ÎºÎ® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(517162,14366,'zh','æˆªæ­¢æ—¥æœŸ',0),(517163,14366,'sv','UB-datum',0),(517164,14366,'it','Data di chiusura',0),(517165,14366,'tl','',0),(517166,14366,'th','à¸§à¸±à¸™à¸›à¸´à¸”',0),(517167,14366,'hi','à¤¸à¤®à¤¾à¤ªà¤¨ à¤¤à¤¿à¤¥à¤¿',0),(517168,14366,'ms','Tarikh Tutup',0),(517169,14366,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥ØºÙ„Ø§Ù‚',0),(517170,14366,'fr','Date de clÃ´ture',0),(517171,14366,'jp','ç· åˆ‡æ—¥',0),(517172,14366,'pt','Data de encerramento',0),(517173,14366,'ru','Ð”Ð°Ñ‚Ð° Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¸Ñ',0),(517174,14366,'es','Fecha de cierre',0),(517175,14366,'de','Anmeldeschluss',0),(517176,14366,'en','Closing Date',0),(517177,14367,'is','',0),(517178,14367,'dr','Ø¨Ø³ØªÙ† Ø¨Ø§Ù„Øº',0),(517179,14367,'pr','Ø¨Ø³ØªÙ† Ø¨Ø§Ù„Øº',0),(517180,14367,'tr','ToplamlarÄ± kapanÄ±ÅŸ',0),(517181,14367,'pl','ZamkniÄ™cie sum',0),(517182,14367,'bg','Ð—Ð°Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ Ð½Ð° Ð¾Ð±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸',0),(517183,14367,'ur','Ù…ÛŒØ²Ø§Ù† Ø¨Ù†Ø¯ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(517184,14367,'sr','Ð—Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(517185,14367,'vi','Tá»•ng sá»‘ Ä‘Ã³ng cá»­a',0),(517186,14367,'af','Totale sluit',0),(517187,14367,'ro','BilanÅ£ul de Ã®nchidere',0),(517188,14367,'et','Sulgemise kogusummad',0),(517189,14367,'si','Zapiranje vsote',0),(517190,14367,'ba','Penutupan total',0),(517191,14367,'nl','Sluiten van totalen',0),(517192,14367,'fi','Sulkeminen yhteensÃ¤',0),(517193,14367,'no','Lukke totaler',0),(517194,14367,'da','Lukke totaler',0),(517195,14367,'ko','ìš”ì•½ ë‹«ê¸°',0),(517196,14367,'he','×¡×’×™×¨×ª ×¡×›×•×ž×™×',0),(517197,14367,'el','ÎšÎ»ÎµÎ¯ÏƒÎ¹Î¼Î¿ ÏƒÏÎ½Î¿Î»Î±',0),(517198,14367,'zh','å…³é—­æ€»è®¡',0),(517199,14367,'sv','StÃ¤nga summor',0),(517200,14367,'it','I totali di chiusura',0),(517201,14367,'tl','',0),(517202,14367,'th','à¸›à¸´à¸”à¸œà¸¥à¸£à¸§à¸¡',0),(517203,14367,'hi','à¤¯à¥‹à¤— à¤•à¥‹ à¤¬à¤‚à¤¦ à¤•à¤°à¤¨à¥‡',0),(517204,14367,'ms','Tutup jumlah',0),(517205,14367,'ar','Ø¥ØºÙ„Ø§Ù‚ Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹',0),(517206,14367,'fr','Totaux de clÃ´ture',0),(517207,14367,'jp','åˆè¨ˆã‚’é–‰ã˜ã‚‹',0),(517208,14367,'pt','Fechando os totais',0),(517209,14367,'ru','Ð—Ð°ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¸Ñ‚Ð¾Ð³Ð¸',0),(517210,14367,'es','EstadÃ­sticas totales de cierre',0),(517211,14367,'de','SchlieÃŸen von Summen',0),(517212,14367,'en','Closing Totals',0),(517213,14368,'is','',0),(517214,14368,'dr','Ø´Ù…Ø§Ø±Ù‡ ØªÙ…Ø§Ø³',0),(517215,14368,'pr','Ø´Ù…Ø§Ø±Ù‡ ØªÙ…Ø§Ø³',0),(517216,14368,'tr','Ä°rtibat numarasÄ±',0),(517217,14368,'pl','Numer kontaktowy',0),(517218,14368,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(517219,14368,'ur','Ø±Ø§Ø¨Ø·Û Ù†Ù…Ø¨Ø±',0),(517220,14368,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð°',0),(517221,14368,'vi','Sá»‘ liÃªn láº¡c',0),(517222,14368,'af','Kontak nommer',0),(517223,14368,'ro','NumÄƒr de contact',0),(517224,14368,'et','Kontakt arv',0),(517225,14368,'si','Kontaktna Å¡tevilka',0),(517226,14368,'ba','Nomor kontak',0),(517227,14368,'nl','Nummer van de contactpersoon',0),(517228,14368,'fi','YhteyshenkilÃ¶n numero',0),(517229,14368,'no','Kontaktnummeret',0),(517230,14368,'da','Kontakt nummer',0),(517231,14368,'ko','ì—°ë½ ë²ˆí˜¸',0),(517232,14368,'he','×¦×•×¨ ×§×©×¨ ×¢× ×ž×¡×¤×¨',0),(517233,14368,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚',0),(517234,14368,'zh','è”ç³»å·ç ',0),(517235,14368,'sv','Kontaktnummer',0),(517236,14368,'it','Contattare il numero',0),(517237,14368,'tl','',0),(517238,14368,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸•à¸´à¸”à¸•à¹ˆà¸­',0),(517239,14368,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤¨à¤‚à¤¬à¤°',0),(517240,14368,'ms','Nombor untuk dihubungi',0),(517241,14368,'ar','Ø§ØªØµÙ„ Ø¨Ø±Ù‚Ù…',0),(517242,14368,'fr','NumÃ©ro de tÃ©lÃ©phone',0),(517243,14368,'jp','ãŠå•ã„åˆã‚ã›ç•ªå·',0),(517244,14368,'pt','NÃºmero de contato',0),(517245,14368,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€',0),(517246,14368,'es','NÃºmero de contacto',0),(517247,14368,'de','Kontaktnummer',0),(517248,14368,'en','Contact Number',0),(517249,14369,'is','',0),(517250,14369,'dr','ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÛŒ Ù…Ø±ØªØ¨ Ú†Ú© Ù„ÛŒØ³Øª',0),(517251,14369,'pr','ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÛŒ Ù…Ø±ØªØ¨ Ú†Ú© Ù„ÛŒØ³Øª',0),(517252,14369,'tr','PO kontrol listesi sÄ±ralama dÃ¼zeni',0),(517253,14369,'pl','KolejnoÅ›Ä‡ sortowania listy kontrolnej PO',0),(517254,14369,'bg','PO Ñ€ÐµÐ´ Ð·Ð° ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(517255,14369,'ur','Ù¾Ùˆ Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª Ú©ÛŒ Ú†Ú¾Ø§Ù†Ù¹ ØªØ±ØªÛŒØ¨',0),(517256,14369,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð°ÑšÐ° ÐŸÐž ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(517257,14369,'vi','Thá»© tá»± sáº¯p xáº¿p danh sÃ¡ch kiá»ƒm tra PO',0),(517258,14369,'af','Posbus kontrolelys Ordeningsvolgorde',0),(517259,14369,'ro','Ordinea de sortare PO lista de verificare',0),(517260,14369,'et','PO Meelespea sortimisjÃ¤rjestus',0),(517261,14369,'si','PO kontrolni seznam vrstni red',0),(517262,14369,'ba','PO Checklist urutan',0),(517263,14369,'nl','PO controlelijst sorteervolgorde',0),(517264,14369,'fi','PO tarkistuslista lajittelujÃ¤rjestys',0),(517265,14369,'no','PO Sjekkliste sorteringsrekkefÃ¸lge',0),(517266,14369,'da','PO tjekliste sorteringsrÃ¦kkefÃ¸lge',0),(517267,14369,'ko','í¬ ê²€ì‚¬ ëª©ë¡ ì •ë ¬ ìˆœì„œ',0),(517268,14369,'he','×¡×“×¨ ×”×ž×™×•×Ÿ ×©×œ ×¨×©×™×ž×ª ×”×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢ ×©×œ ×¤×•',0),(517269,14369,'el','PO Î»Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… ÏƒÎµÎ¹ÏÎ¬ Ï„Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ·Ï‚',0),(517270,14369,'zh','å¤§åŸ”æ¸…å•æŽ’åºé¡ºåº',0),(517271,14369,'sv','PO checklista sorteringsordning',0),(517272,14369,'it','PO Checklist ordinamento',0),(517273,14369,'tl','',0),(517274,14369,'th','à¸¥à¸³à¸”à¸±à¸šà¸à¸²à¸£à¸ˆà¸±à¸”à¹€à¸£à¸µà¸¢à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š PO',0),(517275,14369,'hi','PO à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¥à¤°à¤®',0),(517276,14369,'ms','PO semak Susun mengikut',0),(517277,14369,'ar','Øµ. Ø¨ Ù‚Ø§Ø¦Ù…Ø© ØªØ±ØªÙŠØ¨ Ø§Ù„ÙØ±Ø²',0),(517278,14369,'fr','Ordre de tri de liste de contrÃ´le PO',0);
INSERT INTO `langdef` VALUES (517279,14369,'jp','PO ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆä¸¦ã¹æ›¿ãˆé †åº',0),(517280,14369,'pt','Ordem de classificaÃ§Ã£o de lista de verificaÃ§Ã£o de PO',0),(517281,14369,'ru','PO ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº ÑÐ¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(517282,14369,'es','PO orden lista',0),(517283,14369,'de','PO-Checkliste-Sortierreihenfolge',0),(517284,14369,'en','PO Checklist Sort Order',0),(517285,14370,'is','',0),(517286,14370,'dr','Ø¢Ù…Ø±ÛŒÚ©Ø§ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ú©Ø³Ù¾Ø±Ø³',0),(517287,14370,'pr','Ø¢Ù…Ø±ÛŒÚ©Ø§ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ú©Ø³Ù¾Ø±Ø³',0),(517288,14370,'tr','American Express Transfer',0),(517289,14370,'pl','AmerykaÅ„ski bÅ‚yskawicznego',0),(517290,14370,'bg','ÐÐ¼ÐµÑ€Ð¸ÐºÐ°Ð½ÑÐºÐ¸ ÐµÐºÑÐ¿Ñ€ÐµÑÐ½Ð¸',0),(517291,14370,'ur','Ø§Ù…Ø±ÛŒÚ©ÛŒ Ø§ÛŒÚ©Ø³Ù¾Ø±ÛŒØ³ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(517292,14370,'sr','ÐÐ¼ÐµÑ€Ð¸Ñ‡ÐºÐ¸ Ð•ÐºÑÐ¿Ñ€ÐµÑ Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€',0),(517293,14370,'vi','Chuyá»ƒn nhanh ngÆ°á»i Má»¹',0),(517294,14370,'af','Amerikaanse uitdruklike oordrag',0),(517295,14370,'ro','American expres transferul',0),(517296,14370,'et','Ameerika kiire Ã¼leandmine',0),(517297,14370,'si','American Express Transfer',0),(517298,14370,'ba','American Express Transfer',0),(517299,14370,'nl','Amerikaanse uitdrukkelijke overdracht',0),(517300,14370,'fi','American pikasiirto',0),(517301,14370,'no','American Express overfÃ¸ring',0),(517302,14370,'da','American Express overfÃ¸rsel',0),(517303,14370,'ko','ë¯¸êµ­ ê³ ì† ì „ì†¡',0),(517304,14370,'he','×”×¢×‘×¨×ª ××ž×¨×™×§×Ÿ ××§×¡×¤×¨×¡',0),(517305,14370,'el','Î‘Î¼ÎµÏÎ¹ÎºÎ±Î½Î¹ÎºÎ® Ï„Î±Ï‡ÎµÎ¯Î±Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚',0),(517306,14370,'zh','ç¾Žå›½å¿«é€’è½¬è®©',0),(517307,14370,'sv','American Express Ã¶verfÃ¶ring',0),(517308,14370,'it','Trasferimento espresso americano',0),(517309,14370,'tl','',0),(517310,14370,'th','à¹‚à¸­à¸™à¸­à¹€à¸¡à¸£à¸´à¸à¸±à¸™à¹€à¸­à¹‡à¸à¸‹à¹Œà¹€à¸žà¸£à¸ª',0),(517311,14370,'hi','à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¨ à¤à¤•à¥à¤¸à¤ªà¥à¤°à¥‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£',0),(517312,14370,'ms','Pemindahan Daftar Amerika',0),(517313,14370,'ar','Ù†Ù‚Ù„ Ø£Ù…Ø±ÙŠÙƒØ§Ù† Ø¥ÙƒØ³Ø¨Ø±Ø³',0),(517314,14370,'fr','American Express Transfer',0),(517315,14370,'jp','ã‚¢ãƒ¡ãƒªã‚«ã®é«˜é€Ÿè»¢é€',0),(517316,14370,'pt','American Express transferÃªncia',0),(517317,14370,'ru','ÐÐ¼ÐµÑ€Ð¸ÐºÐ°Ð½ÑÐºÐ¸Ð¹ Ð­ÐºÑÐ¿Ñ€ÐµÑÑ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´',0),(517318,14370,'es','Transferencia expreso americano',0),(517319,14370,'de','American Express Transfer',0),(517320,14370,'en','American Express Transfer',0),(517321,14371,'is','',0),(517322,14371,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ú©Ø³Ù¾Ø±Ø³',0),(517323,14371,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ Ø§Ù†ØªÙ‚Ø§Ù„ Ø§Ú©Ø³Ù¾Ø±Ø³',0),(517324,14371,'tr','American Express Transfer giriÅŸ',0),(517325,14371,'pl','AmerykaÅ„ski bÅ‚yskawicznego wpisu',0),(517326,14371,'bg','ÐÐ¼ÐµÑ€Ð¸ÐºÐ°Ð½ÑÐºÐ¸ ÐµÐºÑÐ¿Ñ€ÐµÑÐ½Ð¸ Ð·Ð°Ð¿Ð¸Ñ',0),(517327,14371,'ur','Ø§Ù…Ø±ÛŒÚ©ÛŒ Ø§ÛŒÚ©Ø³Ù¾Ø±ÛŒØ³ Ù¹Ø±Ø§Ù†Ø³ÙØ± Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(517328,14371,'sr','ÐÐ¼ÐµÑ€Ð¸Ñ‡ÐºÐ¸ Ð•ÐºÑÐ¿Ñ€ÐµÑ Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€ ÑÑ‚Ð°Ð²ÐºÐ°',0),(517329,14371,'vi','Chuyá»ƒn nhanh ngÆ°á»i Má»¹ nháº­p cáº£nh',0),(517330,14371,'af','Amerikaanse uitdruklike oordrag inskrywing',0),(517331,14371,'ro','American expres transferul intrare',0),(517332,14371,'et','Ameerika kiire Ã¼lemineku kande',0),(517333,14371,'si','American Express Transfer vstop',0),(517334,14371,'ba','American Express Transfer masuk',0),(517335,14371,'nl','Amerikaanse uitdrukkelijke overdracht Entry',0),(517336,14371,'fi','American pikasiirto merkintÃ¤',0),(517337,14371,'no','American Express overfÃ¸ring oppfÃ¸ring',0),(517338,14371,'da','American Express overfÃ¸rsel post',0),(517339,14371,'ko','ë¯¸êµ­ ê³ ì† ì „ì†¡ í•­ëª©',0),(517340,14371,'he','×¢×¨×š ×”×¢×‘×¨×ª ××ž×¨×™×§×Ÿ ××§×¡×¤×¨×¡',0),(517341,14371,'el','Î‘Î¼ÎµÏÎ¹ÎºÎ±Î½Î¹ÎºÎ® Ï„Î±Ï‡ÎµÎ¯Î±Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚ ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(517342,14371,'zh','ç¾Žå›½å¿«é€’è½¬è®©æ¡ç›®',0),(517343,14371,'sv','American Express Ã¶verfÃ¶ring intrÃ¤de',0),(517344,14371,'it','Voce americana trasferimento espresso',0),(517345,14371,'tl','',0),(517346,14371,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹‚à¸­à¸™à¸­à¹€à¸¡à¸£à¸´à¸à¸±à¸™à¹€à¸­à¹‡à¸à¸‹à¹Œà¹€à¸žà¸£à¸ª',0),(517347,14371,'hi','à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¨ à¤à¤•à¥à¤¸à¤ªà¥à¤°à¥‡à¤¸ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(517348,14371,'ms','Amerika Syarikat pemindahan Daftar Masuk',0),(517349,14371,'ar','Ø¯Ø®ÙˆÙ„ Ù†Ù‚Ù„ Ø£Ù…Ø±ÙŠÙƒØ§Ù† Ø¥ÙƒØ³Ø¨Ø±Ø³',0),(517350,14371,'fr','American Express Transfer entrÃ©e',0),(517351,14371,'jp','ã‚¢ãƒ¡ãƒªã‚«ã®é«˜é€Ÿè»¢é€ã‚¨ãƒ³ãƒˆãƒª',0),(517352,14371,'pt','American Express transferÃªncia entrada',0),(517353,14371,'ru','ÐÐ¼ÐµÑ€Ð¸ÐºÐ°Ð½ÑÐºÐ¸Ð¹ Ð­ÐºÑÐ¿Ñ€ÐµÑÑ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(517354,14371,'es','Entrada de transferencia expreso americano',0),(517355,14371,'de','American Express Transfer-Eintrag',0),(517356,14371,'en','American Express Transfer Entry',0),(517357,14372,'is','',0),(517358,14372,'dr','Authorize.net ØªØ±Ø§Ú©Ù†Ø´ Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(517359,14372,'pr','Authorize.net ØªØ±Ø§Ú©Ù†Ø´ Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(517360,14372,'tr','Authorize.NET iÅŸlem dosyasÄ±',0),(517361,14372,'pl','Authorize.net transakcji pliku',0),(517362,14372,'bg','Authorize.NET Ñ„Ð°Ð¹Ð» Ð·Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(517363,14372,'ur','Authorize.net Ù„ÛŒÙ† Ø¯ÛŒÙ† Ù…Ø³Ù„',0),(517364,14372,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Authorize.NET',0),(517365,14372,'vi','Authorize.net giao dá»‹ch táº­p tin',0),(517366,14372,'af','Authorize.net transaksie lÃªer',0),(517367,14372,'ro','FiÅŸier de tranzacÅ£ii Authorize.net',0),(517368,14372,'et','Authorize.net tehingu fail',0),(517369,14372,'si','Authorize.net datoteke transakcijskega',0),(517370,14372,'ba','Authorize.net transaksi File',0),(517371,14372,'nl','Authorize.net transactie bestand',0),(517372,14372,'fi','Authorize.net tapahtumatiedosto',0),(517373,14372,'no','Authorize.net transaksjonsfil',0),(517374,14372,'da','Authorize.net transaktionsfil',0),(517375,14372,'ko','Authorize.net íŠ¸ëžœìž­ì…˜ íŒŒì¼',0),(517376,14372,'he','×§×•×‘×¥ ×”×˜×¨× ×–×§×¦×™×•×ª Authorize.net',0),(517377,14372,'el','Authorize.net Î±ÏÏ‡ÎµÎ¯Î¿ ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½',0),(517378,14372,'zh','Authorize.net äº¤æ˜“æ–‡ä»¶',0),(517379,14372,'sv','Authorize.net transaktionsfil',0),(517380,14372,'it','File delle transazioni Authorize.NET',0),(517381,14372,'tl','',0),(517382,14372,'th','à¹à¸Ÿà¹‰à¸¡à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡ Authorize.net',0),(517383,14372,'hi','Authorize.net à¤Ÿà¥à¤°à¤¾à¤‚à¤œà¤¼à¥‡à¤•à¥à¤¶à¤¨ à¤«à¤¼à¤¾à¤‡à¤²',0),(517384,14372,'ms','Fail transaksi Authorize.net',0),(517385,14372,'ar','Ù…Ù„Ù Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Authorize.net',0),(517386,14372,'fr','Fichier de transactions Authorize.net',0),(517387,14372,'jp','Authorize.net ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ãƒ•ã‚¡ã‚¤ãƒ«',0),(517388,14372,'pt','Arquivo de transaÃ§Ãµes Authorize.net',0),(517389,14372,'ru','Authorize.NET Ñ„Ð°Ð¹Ð»Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹',0),(517390,14372,'es','Archivo de transacciones Authorize.net',0),(517391,14372,'de','Authorize.net Transaktionsdatei',0),(517392,14372,'en','Authorize.net Transaction File',0),(517393,14373,'is','',0),(517394,14373,'dr','ÙˆØ§Ø±Ø¯ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Authorize.net',0),(517395,14373,'pr','ÙˆØ§Ø±Ø¯ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Authorize.net',0),(517396,14373,'tr','Authorize.NET hareketleri iÃ§e aktarma',0),(517397,14373,'pl','PrzywÃ³z Authorize.net transakcji',0),(517398,14373,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Authorize.net Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸',0),(517399,14373,'ur','Authorize.net Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(517400,14373,'sr','Ð£Ð²Ð¾Ð· Authorize.net Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(517401,14373,'vi','Nháº­p kháº©u Authorize.net giao dá»‹ch',0),(517402,14373,'af','Voer Authorize.net transaksies',0),(517403,14373,'ro','Authorize.net tranzacÅ£ii de import',0),(517404,14373,'et','Authorize.net kannete importimine',0),(517405,14373,'si','Uvoz Authorize.net transakcije',0),(517406,14373,'ba','Impor Authorize.net transaksi',0),(517407,14373,'nl','Importeer Authorize.net transacties',0),(517408,14373,'fi','Tuo Authorize.net tapahtumat',0),(517409,14373,'no','Importere Authorize.net transaksjoner',0),(517410,14373,'da','Importere Authorize.net transaktioner',0),(517411,14373,'ko','Authorize.net ê±°ëž˜ë¥¼ ìˆ˜ìž…',0),(517412,14373,'he','×™×™×‘×•× Authorize.net ×¢×¡×§××•×ª',0),(517413,14373,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Authorize.net ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚',0),(517414,14373,'zh','å¯¼å…¥ Authorize.net äº¤æ˜“è®°å½•',0),(517415,14373,'sv','Importera Authorize.net transaktioner',0),(517416,14373,'it','Operazioni di importazione Authorize.net',0),(517417,14373,'tl','',0),(517418,14373,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡ Authorize.net',0),(517419,14373,'hi','Authorize.net à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(517420,14373,'ms','Urus niaga Authorize.net import',0),(517421,14373,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø­Ø±ÙƒØ§Øª Authorize.net',0),(517422,14373,'fr','Transactions d\'importation Authorize.net',0),(517423,14373,'jp','Authorize.net ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(517424,14373,'pt','TransacÃ§Ãµes de importaÃ§Ã£o Authorize.net',0),(517425,14373,'ru','Authorize.net Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(517426,14373,'es','Authorize.net transacciones de importaciÃ³n',0),(517427,14373,'de','Import Authorize.net Transaktionen',0),(517428,14373,'en','Import Authorize.net Transactions',0),(517429,14374,'is','',0),(517430,14374,'dr','Ù‡ÛŒÚ† Ù…Ø±Ø¬Ø¹ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(517431,14374,'pr','Ù‡ÛŒÚ† Ù…Ø±Ø¬Ø¹ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(517432,14374,'tr','Herhangi bir baÅŸvuru bulundu',0),(517433,14374,'pl','Nie ma odniesienia Znalezione',0),(517434,14374,'bg','ÐÑÐ¼Ð° Ñ€ÐµÑ„ÐµÑ€ÐµÐ½Ñ‚Ð½Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(517435,14374,'ur','Ú©ÙˆØ¦ÛŒ ÙˆØ§Ù‚ÙÛŒØª Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(517436,14374,'sr','Ð£Ð¿ÑƒÑ†Ð¸Ð²Ð°ÑšÐµ Ð½Ð°ÑˆÐ°Ð¾',0),(517437,14374,'vi','KhÃ´ng cÃ³ tÃ i liá»‡u tham kháº£o tÃ¬m tháº¥y',0),(517438,14374,'af','Geen verwysing gevind',0),(517439,14374,'ro','Nici o referinÅ£Äƒ gÄƒsit',0),(517440,14374,'et','Leitud viide',0),(517441,14374,'si','Ne omenja, najti',0),(517442,14374,'ba','Tidak ada referensi yang ditemukan',0),(517443,14374,'nl','Geen referentie gevonden',0),(517444,14374,'fi','Mainintaa lÃ¶ytÃ¤nyt',0),(517445,14374,'no','Fant ingen referanse',0),(517446,14374,'da','Ingen Reference, fandt',0),(517447,14374,'ko','ì°¾ì„ ìˆ˜ ì—†ëŠ” ì°¸ì¡°',0),(517448,14374,'he','××™×Ÿ ×›×œ ×”×ª×™×™×—×¡×•×ª × ×ž×¦××•',0),(517449,14374,'el','ÎšÎ±Î¼Î¯Î± Î±Î½Î±Ï†Î¿ÏÎ¬ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(517450,14374,'zh','å‘çŽ°æ²¡æœ‰å‚è€ƒ',0),(517451,14374,'sv','Ingen hÃ¤nvisning hittade',0),(517452,14374,'it','Nessun riferimento trovato',0),(517453,14374,'tl','',0),(517454,14374,'th','à¸­à¹‰à¸²à¸‡à¸­à¸´à¸‡à¹„à¸¡à¹ˆà¸žà¸š',0),(517455,14374,'hi','à¤•à¥‹à¤ˆ à¤¸à¤‚à¤¦à¤°à¥à¤­ à¤ªà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(517456,14374,'ms','Tiada rujukan yang didapati',0),(517457,14374,'ar','Ù…Ø±Ø¬Ø¹ Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(517458,14374,'fr','Aucune rÃ©fÃ©rence trouvÃ©e',0),(517459,14374,'jp','ç™ºè¦‹ã®å‚ç…§ãªã—',0),(517460,14374,'pt','Nenhuma referÃªncia encontrada',0),(517461,14374,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹ ÑÑÑ‹Ð»ÐºÐ¸',0),(517462,14374,'es','Ninguna referencia encontrada',0),(517463,14374,'de','Keine Referenz gefunden',0),(517464,14374,'en','No Reference Found',0),(517465,14375,'is','',0),(517466,14375,'dr','Ù‡ÛŒÚ† Ù…Ø±Ø¬Ø¹ Ú©Ù„ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(517467,14375,'pr','Ù‡ÛŒÚ† Ù…Ø±Ø¬Ø¹ Ú©Ù„ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(517468,14375,'tr','Toplam bulunan herhangi bir baÅŸvuru',0),(517469,14375,'pl','Nie ma odniesienia znaleziono ogÃ³Å‚em',0),(517470,14375,'bg','ÐÑÐ¼Ð° Ñ€ÐµÑ„ÐµÑ€ÐµÐ½Ñ‚Ð½Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(517471,14375,'ur','Ú©Ù„ Ù…Ù„Ø§ Ú©Ø§ Ú©ÙˆØ¦ÛŒ Ø­ÙˆØ§Ù„Û Ù†ÛÛŒÚº',0),(517472,14375,'sr','Ð£Ð¿ÑƒÑ†Ð¸Ð²Ð°ÑšÐµ Ð½Ð°ÑˆÐ»Ð¸ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(517473,14375,'vi','KhÃ´ng cÃ³ tÃ i liá»‡u tham kháº£o tÃ¬m tháº¥y táº¥t cáº£',0),(517474,14375,'af','Geen verwysing gevind totale',0),(517475,14375,'ro','Nici o referinÅ£Äƒ gÄƒsit totalÄƒ',0),(517476,14375,'et','Leitud kokku viide',0),(517477,14375,'si','Ne omenja ugotovljeno skupno',0),(517478,14375,'ba','Tidak ada referensi ditemukan Total',0),(517479,14375,'nl','Geen referentie gevonden totale',0),(517480,14375,'fi','Mainintaa lÃ¶ytyi yhteensÃ¤',0),(517481,14375,'no','Ingen referanse funnet totalt',0),(517482,14375,'da','Ingen Reference fundet samlede',0),(517483,14375,'ko','ì´ ë°œê²¬ ì°¸ì¡°',0),(517484,14375,'he','××™×Ÿ ×›×œ ×”×ª×™×™×—×¡×•×ª × ×ž×¦××• ×¡×”',0),(517485,14375,'el','ÎšÎ±Î¼Î¯Î± Î±Î½Î±Ï†Î¿ÏÎ¬ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(517486,14375,'zh','å‘çŽ°æ€»æ²¡æœ‰å‚è€ƒ',0),(517487,14375,'sv','Ingen hÃ¤nvisning hittade totalt',0),(517488,14375,'it','Nessun riferimento trovato totale',0),(517489,14375,'tl','',0),(517490,14375,'th','à¸­à¹‰à¸²à¸‡à¸­à¸´à¸‡à¹„à¸¡à¹ˆà¸žà¸šà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(517491,14375,'hi','à¤•à¥‹à¤ˆ à¤¸à¤‚à¤¦à¤°à¥à¤­ à¤•à¥à¤² à¤ªà¤¾à¤¯à¤¾',0),(517492,14375,'ms','Tiada rujukan yang didapati jumlah',0),(517493,14375,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…Ø±Ø¬Ø¹ Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ø¬Ù…ÙˆØ¹',0),(517494,14375,'fr','Aucune rÃ©fÃ©rence trouvÃ©e Total',0),(517495,14375,'jp','è¦‹ã¤ã‹ã£ãŸåˆè¨ˆå‚ç…§ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(517496,14375,'pt','Nenhuma referÃªncia encontrada Total',0),(517497,14375,'ru','ÐÐµ ÑÑÑ‹Ð»ÐºÐ° Ð½Ð°Ð¹Ð´ÐµÐ½Ð° ÐžÐ±Ñ‰Ð°Ñ',0),(517498,14375,'es','Ninguna referencia encontrada Total',0),(517499,14375,'de','Keine Referenz gefunden Total',0),(517500,14375,'en','No Reference Found Total',0),(517501,14376,'is','',0),(517502,14376,'dr','Ø¯ÛŒÚ¯Ø± Ú©Ø§Ø±Øª Ú©Ù„',0),(517503,14376,'pr','Ø¯ÛŒÚ¯Ø± Ú©Ø§Ø±Øª Ú©Ù„',0),(517504,14376,'tr','BaÅŸka bir kart toplam',0),(517505,14376,'pl','Inne karty ogÃ³Å‚em',0),(517506,14376,'bg','Ð”Ñ€ÑƒÐ³Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(517507,14376,'ur','Ø¯ÛŒÚ¯Ø± Ú©Ø§Ø±Úˆ Ú©Ù„',0),(517508,14376,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð´Ñ€ÑƒÐ³Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(517509,14376,'vi','Táº¥t cáº£ tháº»',0),(517510,14376,'af','Ander totale kaart',0),(517511,14376,'ro','Alt Card totalÄƒ',0),(517512,14376,'et','Teistes kaarti kokku',0),(517513,14376,'si','Druge skupne kartice',0),(517514,14376,'ba','Kartu lain total',0),(517515,14376,'nl','Andere kaart totale',0),(517516,14376,'fi','Kortilla yhteensÃ¤',0),(517517,14376,'no','Andre kort totalt',0),(517518,14376,'da','Andre kort samlede',0),(517519,14376,'ko','ë‹¤ë¥¸ ì¹´ë“œ ì´',0),(517520,14376,'he','×§×œ×£ ××—×¨ ×¡×”',0),(517521,14376,'el','Î†Î»Î»Î· ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(517522,14376,'zh','å¦ä¸€å¼ å¡ç‰‡æ€»',0),(517523,14376,'sv','Andra kort totalt',0),(517524,14376,'it','Altra carta totale',0),(517525,14376,'tl','',0),(517526,14376,'th','à¹„à¸žà¹ˆà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(517527,14376,'hi','à¤…à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥à¤²',0),(517528,14376,'ms','Kad lain-lain Jumlah',0),(517529,14376,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø£Ø®Ø±Ù‰ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹',0),(517530,14376,'fr','Autre carte total',0),(517531,14376,'jp','ä»–ã®ã‚«ãƒ¼ãƒ‰ã®åˆè¨ˆ',0),(517532,14376,'pt','Outro cartÃ£o total',0),(517533,14376,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð²ÑÐµÐ³Ð¾',0),(517534,14376,'es','Otra tarjeta total',0),(517535,14376,'de','Andere Karte gesamt',0),(517536,14376,'en','Other Card total',0),(517537,14377,'is','',0),(517538,14377,'dr','Ú©Ø§Ø±Øª Ø¯ÛŒÚ¯Ø± Ø§Ù†ØªÙ‚Ø§Ù„',0),(517539,14377,'pr','Ú©Ø§Ø±Øª Ø¯ÛŒÚ¯Ø± Ø§Ù†ØªÙ‚Ø§Ù„',0),(517540,14377,'tr','DiÄŸer kart Transfer',0),(517541,14377,'pl','UÅ¼yczenie karty',0),(517542,14377,'bg','Ð”Ñ€ÑƒÐ³Ð¸ ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ñ€ÐµÐ²Ð¾Ð´',0),(517543,14377,'ur','Ø¯ÛŒÚ¯Ø± Ú©Ø§Ø±Úˆ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(517544,14377,'sr','Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€ Ð´Ñ€ÑƒÐ³Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(517545,14377,'vi','Chuyá»ƒn nhÆ°á»£ng tháº» khÃ¡c',0),(517546,14377,'af','Ander kaart oordrag',0),(517547,14377,'ro','Transferul de carte',0),(517548,14377,'et','Muud Card edastamine',0),(517549,14377,'si','Drug prenos kartico',0),(517550,14377,'ba','Transfer kartu lain',0),(517551,14377,'nl','Andere kaart overdracht',0),(517552,14377,'fi','Muut siirto',0),(517553,14377,'no','Andre overfÃ¸re',0),(517554,14377,'da','Andre kort overfÃ¸rsel',0),(517555,14377,'ko','ë‹¤ë¥¸ ì¹´ë“œ ì „ì†¡',0),(517556,14377,'he','×”×¢×‘×¨×ª ×›×¨×˜×™×¡ ××—×¨',0),(517557,14377,'el','Î†Î»Î»Î· ÎºÎ¬ÏÏ„Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬',0),(517558,14377,'zh','å…¶ä»–å¡ä¼ è¾“',0),(517559,14377,'sv','Andra Ã¶verfÃ¶ring',0),(517560,14377,'it','Altro trasferimento di carta',0),(517561,14377,'tl','',0),(517562,14377,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸šà¸±à¸•à¸£à¸­à¸·à¹ˆà¸™ à¹†',0),(517563,14377,'hi','à¤…à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¡ à¤§à¤¨ à¤…à¤‚à¤¤à¤°à¤£',0),(517564,14377,'ms','Pemindahan kad lain',0),(517565,14377,'ar','Ù†Ù‚Ù„ Ø¨Ø·Ø§Ù‚Ø© Ø£Ø®Ø±Ù‰',0),(517566,14377,'fr','Autre opÃ©ration de transfert de carte',0),(517567,14377,'jp','ä»–ã®ã‚«ãƒ¼ãƒ‰ã®è»¢é€',0),(517568,14377,'pt','Outra transferÃªncia de cartÃ£o',0),(517569,14377,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(517570,14377,'es','Otra transferencia de tarjeta',0),(517571,14377,'de','Andere Karte-Transfer',0),(517572,14377,'en','Other Card Transfer',0),(517573,14378,'is','',0),(517574,14378,'dr','ÙˆØ±ÙˆØ¯ÛŒ Ú©Ø§Ø±Øª Ø¯ÛŒÚ¯Ø± Ø§Ù†ØªÙ‚Ø§Ù„',0),(517575,14378,'pr','ÙˆØ±ÙˆØ¯ÛŒ Ú©Ø§Ø±Øª Ø¯ÛŒÚ¯Ø± Ø§Ù†ØªÙ‚Ø§Ù„',0),(517576,14378,'tr','DiÄŸer kart Transfer giriÅŸ',0),(517577,14378,'pl','Inne karty przeniesienia wpisu',0),(517578,14378,'bg','Ð”Ñ€ÑƒÐ³Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð° Ð¿Ñ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½Ðµ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(517579,14378,'ur','Ø¯ÛŒÚ¯Ø± Ú©Ø§Ø±Úˆ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©Ø§ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(517580,14378,'sr','Ð”Ñ€ÑƒÐ³Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(517581,14378,'vi','Tháº» chuyá»ƒn nháº­p',0),(517582,14378,'af','Ander kaart oordrag inskrywing',0),(517583,14378,'ro','Alte Card Transfer de intrare',0),(517584,14378,'et','Muud kaardi Ã¼leandmise kanne',0),(517585,14378,'si','Druge kartice prenos vstop',0),(517586,14378,'ba','Entri lain Transfer kartu',0),(517587,14378,'nl','Andere kaart overdracht vermelding',0),(517588,14378,'fi','Muut kortin siirto merkintÃ¤',0),(517589,14378,'no','Andre kort overfÃ¸ring oppfÃ¸ringen',0),(517590,14378,'da','Andre kort overfÃ¸rsel post',0),(517591,14378,'ko','ë‹¤ë¥¸ ì¹´ë“œ ì „ì†¡ í•­ëª©',0),(517592,14378,'he','×¢×¨×š ×”×¢×‘×¨×ª ×›×¨×˜×™×¡ ××—×¨',0),(517593,14378,'el','Î†Î»Î»Î· ÎºÎ¬ÏÏ„Î± ÎµÎ¯ÏƒÎ¿Î´Î¿ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬',0),(517594,14378,'zh','å…¶ä»–å¡è½¬è®©æ¡ç›®',0),(517595,14378,'sv','Andra kort Ã¶verfÃ¶ring posten',0),(517596,14378,'it','Altra voce di trasferimento di carta',0),(517597,14378,'tl','',0),(517598,14378,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸šà¸±à¸•à¸£à¸­à¸·à¹ˆà¸™ à¹†',0),(517599,14378,'hi','à¤…à¤¨à¥à¤¯ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(517600,14378,'ms','Lain-lain Kad pemindahan kemasukan',0),(517601,14378,'ar','Ø¯Ø®ÙˆÙ„ Ù†Ù‚Ù„ Ø¨Ø·Ø§Ù‚Ø© Ø£Ø®Ø±Ù‰',0),(517602,14378,'fr','Autre entrÃ©e de transfert de carte',0),(517603,14378,'jp','ä»–ã®ã‚«ãƒ¼ãƒ‰ã®è»¢é€ã‚¨ãƒ³ãƒˆãƒª',0),(517604,14378,'pt','Outra entrada de transferÃªncia de cartÃ£o',0),(517605,14378,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸ ÐºÐ°Ñ€Ñ‚Ð¾Ñ‡ÐºÑƒ.',0),(517606,14378,'es','Otra entrada de transferencia de tarjeta',0),(517607,14378,'de','Andere Karten-Transfer-Eintrag',0),(517608,14378,'en','Other Card Transfer Entry',0),(517609,14379,'is','',0),(517610,14379,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ø­Ø³Ø§Ø¨ GL',0),(517611,14379,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ø­Ø³Ø§Ø¨ GL',0),(517612,14379,'tr','A GL hesabÄ±ndan giriniz',0),(517613,14379,'pl','Podaj A z konta GL',0),(517614,14379,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð Ð¾Ñ‚ GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(517615,14379,'ur','A Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³Û’ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(517616,14379,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ Ð ÑÐ° Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(517617,14379,'vi','Vui lÃ²ng nháº­p má»™t tá»« tÃ i khoáº£n GL',0),(517618,14379,'af','Tik asseblief \'n van GL rekening',0),(517619,14379,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un din GL contul',0),(517620,14379,'et','Sisestage A GL kontolt',0),(517621,14379,'si','Prosim nastopiti A iz GL raÄun',0),(517622,14379,'ba','Masukkan A dari rekening GL',0),(517623,14379,'nl','Voer A van GL Account',0),(517624,14379,'fi','Anna A Kirjanpitotilin pÃ¤Ã¤tilin',0),(517625,14379,'no','Angi en fra gi-konto',0),(517626,14379,'da','Angiv en fra GL konto',0),(517627,14379,'ko','GL ê³„ì •ì—ì„œ Aë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(517628,14379,'he','×× × ×”×–×Ÿ A ×ž×—×©×‘×•×Ÿ GL',0),(517629,14379,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ A Î±Ï€ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(517630,14379,'zh','è¯·è¾“å…¥ä¸€ä¸ªä»Žæ€»å¸ç§‘ç›®',0),(517631,14379,'sv','Skriv in A frÃ¥n GL konto',0),(517632,14379,'it','Inserisci A dal conto GL',0),(517633,14379,'tl','',0),(517634,14379,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸°à¸šà¸¸ A à¸ˆà¸²à¸à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(517635,14379,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ GL à¤–à¤¾à¤¤à¥‡ à¤¸à¥‡ A à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(517636,14379,'ms','Sila masukkan A dari akaun GL',0),(517637,14379,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ A Ù…Ù† Ø­Ø³Ø§Ø¨ GL',0),(517638,14379,'fr','Veuillez saisir A partir de compte GL',0),(517639,14379,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‹ã‚‰ A ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(517640,14379,'pt','Por favor, digite A conta de GL',0),(517641,14379,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ A Ñ GL ÑÑ‡ÐµÑ‚Ð°',0),(517642,14379,'es','Ingrese A de cuenta de GL',0),(517643,14379,'de','Bitte geben Sie A von Sako',0),(517644,14379,'en','Please Enter A From GL Account',0),(517645,14380,'is','',0),(517646,14380,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ø­Ø³Ø§Ø¨ GL',0),(517647,14380,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ø­Ø³Ø§Ø¨ GL',0),(517648,14380,'tr','LÃ¼tfen A GL hesabÄ±nÄ±za girin',0),(517649,14380,'pl','ProszÄ™ wpisz konto GL',0),(517650,14380,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ A GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(517651,14380,'ur','A Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(517652,14380,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ ÑƒÐ½ÐµÑÐ¸Ñ‚Ðµ Ð Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½',0),(517653,14380,'vi','Vui lÃ²ng nháº­p A GL tÃ i khoáº£n',0),(517654,14380,'af','Tik asseblief \'n GL rekening',0),(517655,14380,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un GL contul',0),(517656,14380,'et','Sisestage A pearaamatukontole',0),(517657,14380,'si','Prosim nastopiti A raÄun GL',0),(517658,14380,'ba','Masukkan A ke GL Account',0),(517659,14380,'nl','Voer A aan GL-Account',0),(517660,14380,'fi','Anna A Kirjanpitotilin pÃ¤Ã¤tilin',0),(517661,14380,'no','Angi en GL-kontoen',0),(517662,14380,'da','Angiv en GL konto',0),(517663,14380,'ko','GL ê³„ì •ì— Aë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(517664,14380,'he','×× × ×”×–×Ÿ A ×œ×—×©×‘×•×Ÿ GL',0),(517665,14380,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ A Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(517666,14380,'zh','è¯·è¾“å…¥ä¸€ä¸ªæŒ‡å‘æ€»å¸ç§‘ç›®',0),(517667,14380,'sv','Ange en GL konto',0),(517668,14380,'it','Inserisci un account GL',0),(517669,14380,'tl','',0),(517670,14380,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆ A à¹„à¸›à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(517671,14380,'hi','A GL à¤–à¤¾à¤¤à¥‡ à¤®à¥‡à¤‚ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(517672,14380,'ms','Sila masukkan A ke akaun GL',0),(517673,14380,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ A Ø¥Ù„Ù‰ Ø­Ø³Ø§Ø¨ GL',0),(517674,14380,'fr','S\'il vous plaÃ®t entrer A au compte GL',0),(517675,14380,'jp','A GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(517676,14380,'pt','Por favor, digite A conta de GL',0),(517677,14380,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ A GL ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(517678,14380,'es','Por favor ingrese A cuenta de GL',0),(517679,14380,'de','Bitte geben Sie A GL-Konto',0),(517680,14380,'en','Please Enter A To GL Account',0),(517681,14381,'is','',0),(517682,14381,'dr','Ù„Ø·ÙØ§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ØªØ§Ø±ÛŒØ® Ø§Ù†ØªÙ‚Ø§Ù„',0),(517683,14381,'pr','Ù„Ø·ÙØ§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ ØªØ§Ø±ÛŒØ® Ø§Ù†ØªÙ‚Ø§Ù„',0),(517684,14381,'tr','LÃ¼tfen Transfer tarihi girin',0),(517685,14381,'pl','WprowadÅº datÄ™ przeniesienia',0),(517686,14381,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð° Ð½Ð° Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð°',0),(517687,14381,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©Û’ ØªØ§Ø±ÛŒØ® Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(517688,14381,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(517689,14381,'vi','Vui lÃ²ng nháº­p má»™t ngÃ y chuyá»ƒn giao',0),(517690,14381,'af','Tik asseblief \'n datum van oordrag',0),(517691,14381,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i o datÄƒ de Transfer',0),(517692,14381,'et','Palun sisestage Ã¼leandmise kuupÃ¤eva',0),(517693,14381,'si','Vnesite datum prenosa',0),(517694,14381,'ba','Harap masukkan tanggal Transfer',0),(517695,14381,'nl','Voer een datum van overdracht',0),(517696,14381,'fi','Kirjoita siirron pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(517697,14381,'no','Angi en dato',0),(517698,14381,'da','Angiv en overfÃ¸rselsdato for',0),(517699,14381,'ko','ì „ì†¡ ë‚ ì§œë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(517700,14381,'he','× × ×”×–×Ÿ ×ª××¨×™×š ×”×¢×‘×¨×”',0),(517701,14381,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Î·Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚',0),(517702,14381,'zh','è¯·è¾“å…¥ä¸€ä¸ªè½¬è®©æ—¥æœŸ',0),(517703,14381,'sv','Ange ett Ã¶verfÃ¶ringsdatum',0),(517704,14381,'it','Inserisci una data di trasferimento',0),(517705,14381,'tl','',0),(517706,14381,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸°à¸šà¸¸à¸§à¸±à¸™à¹‚à¸­à¸™',0),(517707,14381,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(517708,14381,'ms','Sila masukkan tarikh pemindahan',0),(517709,14381,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ® Ù†Ù‚Ù„',0),(517710,14381,'fr','Veuillez entrer une Date de transfert',0),(517711,14381,'jp','è»¢é€æ—¥ä»˜ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(517712,14381,'pt','Por favor introduza uma data de transferÃªncia',0),(517713,14381,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ñƒ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(517714,14381,'es','Introduce una fecha de transferencia',0),(517715,14381,'de','Bitte geben Sie eine Transfer-Datum',0),(517716,14381,'en','Please Enter A Transfer Date',0),(517717,14382,'is','',0),(517718,14382,'dr','Ù…Ø±Ø¬Ø¹ Ú©Ù„ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(517719,14382,'pr','Ù…Ø±Ø¬Ø¹ Ú©Ù„ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(517720,14382,'tr','Toplam bulunan baÅŸvurusu',0),(517721,14382,'pl','OdwoÅ‚anie znaleziono ogÃ³Å‚em',0),(517722,14382,'bg','Ð ÐµÑ„ÐµÑ€ÐµÐ½Ñ‚ÐµÐ½ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(517723,14382,'ur','Ú©Ù„ Ù…Ù„Ø§ Ú©Ø§ Ø­ÙˆØ§Ù„Û',0),(517724,14382,'sr','Ð ÐµÑ„ÐµÑ€ÐµÐ½Ñ†Ð° Ð½Ð°ÑˆÐ»Ð¸ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(517725,14382,'vi','TÃ i liá»‡u tham kháº£o tÃ¬m tháº¥y táº¥t cáº£',0),(517726,14382,'af','Verwysing gevind totale',0),(517727,14382,'ro','GÄƒsit totalÄƒ de referinÈ›Äƒ',0),(517728,14382,'et','Viide leiti kokku',0),(517729,14382,'si','ReferenÄni ugotovljeno skupno',0),(517730,14382,'ba','Referensi ditemukan Total',0),(517731,14382,'nl','Referentie gevonden totale',0),(517732,14382,'fi','Viittaus lÃ¶ytyi yhteensÃ¤',0),(517733,14382,'no','Fant totale referanse',0),(517734,14382,'da','Henvisning findes samlede',0),(517735,14382,'ko','ì´ ë°œê²¬ ì°¸ì¡°',0),(517736,14382,'he','×”×¤× ×™×” × ×ž×¦××• ×¡×”',0),(517737,14382,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬Ï‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(517738,14382,'zh','å‘çŽ°æ€»çš„å‚è€ƒ',0),(517739,14382,'sv','Referens hittade totalt',0),(517740,14382,'it','Riferimento trovato totale',0),(517741,14382,'tl','',0),(517742,14382,'th','à¸žà¸šà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸­à¹‰à¸²à¸‡à¸­à¸´à¸‡',0),(517743,14382,'hi','à¤•à¥à¤² à¤ªà¤¾à¤¯à¤¾ à¤¸à¤‚à¤¦à¤°à¥à¤­',0),(517744,14382,'ms','Rujukan yang didapati jumlah',0),(517745,14382,'ar','Ù…Ø±Ø¬Ø¹ Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ø¬Ù…ÙˆØ¹',0),(517746,14382,'fr','RÃ©fÃ©rence trouvÃ©e Total',0),(517747,14382,'jp','å‚ç…§ã®åˆè¨ˆãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(517748,14382,'pt','ReferÃªncia encontrada Total',0),(517749,14382,'ru','Ð¡ÑÑ‹Ð»ÐºÐ° Ð½Ð°Ð¹Ð´ÐµÐ½Ð° ÐžÐ±Ñ‰Ð°Ñ',0),(517750,14382,'es','Referencia encontrado Total',0),(517751,14382,'de','Verweis gefunden Total',0),(517752,14382,'en','Reference Found Total',0),(517753,14383,'is','',0),(517754,14383,'dr','Ø­Ù„ Ùˆ ÙØµÙ„ ØªØ§Ø±ÛŒØ®',0),(517755,14383,'pr','Ø­Ù„ Ùˆ ÙØµÙ„ ØªØ§Ø±ÛŒØ®',0),(517756,14383,'tr','DÃ¼zenleme tarihi',0),(517757,14383,'pl','Data rozliczenia',0),(517758,14383,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÑÐ´ÐµÐ»ÐºÐ°Ñ‚Ð°',0),(517759,14383,'ur','Ø³ÛŒÙ¹Ù„Ù…Ù†Ù¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(517760,14383,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ°',0),(517761,14383,'vi','Khu Ä‘á»‹nh cÆ° ngÃ y',0),(517762,14383,'af','Nedersetting datum',0),(517763,14383,'ro','Data tranzacÅ£iei',0),(517764,14383,'et','ArvelduskuupÃ¤eva',0),(517765,14383,'si','Datum poravnave',0),(517766,14383,'ba','Tanggal penyelesaian',0),(517767,14383,'nl','Betalings-en leveringsdatum',0),(517768,14383,'fi','Tilitys',0),(517769,14383,'no','OppgjÃ¸rsdatoen.',0),(517770,14383,'da','Afregningsdatoen',0),(517771,14383,'ko','ê²°ì‚°ì¼',0),(517772,14383,'he','×ª××¨×™×š ×”×¡×“×¨×ª ×”×—×©×‘×•×Ÿ',0),(517773,14383,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î´Î¹Î±ÎºÎ±Î½Î¿Î½Î¹ÏƒÎ¼Î¿Ï',0),(517774,14383,'zh','è§£å†³æ—¥æœŸ',0),(517775,14383,'sv','Likviddagen',0),(517776,14383,'it','Data di liquidazione',0),(517777,14383,'tl','',0),(517778,14383,'th','à¸§à¸±à¸™à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(517779,14383,'hi','à¤¨à¤¿à¤ªà¤Ÿà¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(517780,14383,'ms','Tarikh penyelesaian',0),(517781,14383,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ØªØ³ÙˆÙŠØ©',0),(517782,14383,'fr','Date de rÃ¨glement',0),(517783,14383,'jp','å—æ¸¡æ—¥',0),(517784,14383,'pt','Data de liquidaÃ§Ã£o',0),(517785,14383,'ru','Ð”Ð°Ñ‚Ð° ÑÐ¾Ð³Ð»Ð°ÑˆÐµÐ½Ð¸Ñ',0),(517786,14383,'es','Fecha de liquidaciÃ³n',0),(517787,14383,'de','Abrechnungstermin',0),(517788,14383,'en','Settlement Date',0),(517789,14384,'is','',0),(517790,14384,'dr','Ø¨Ø±Ú¯Ù‡ Ù‡Ø§ÛŒ Ø¬Ø¯Ø§ Ø´Ø¯Ù‡ Ø¨Ù‡ ÙˆØ³ÛŒÙ„Ù‡',0),(517791,14384,'pr','Ø¨Ø±Ú¯Ù‡ Ù‡Ø§ÛŒ Ø¬Ø¯Ø§ Ø´Ø¯Ù‡ Ø¨Ù‡ ÙˆØ³ÛŒÙ„Ù‡',0),(517792,14384,'tr','Sekmeyle ayrÄ±lmÄ±ÅŸ',0),(517793,14384,'pl','Rozdzielany tabulatorami',0),(517794,14384,'bg','Ð¡ Ñ‚Ð°Ð±ÑƒÐ»Ð°Ñ‚Ð¾Ñ€Ð¸',0),(517795,14384,'ur','ØªØ­Ø¯ÛŒØ¯ÛŒ Ù¹ÛŒØ¨',0),(517796,14384,'sr','Ð Ð°Ð·Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½ Ñ‚Ð°Ð±ÑƒÐ»Ð°Ñ‚Ð¾Ñ€Ð¾Ð¼',0),(517797,14384,'vi','Tab phÃ¢n cÃ¡ch',0),(517798,14384,'af','TAB afgebaken',0),(517799,14384,'ro','Fila delimitat',0),(517800,14384,'et','Tabelduskohaga eraldatud',0),(517801,14384,'si','Tabulatorji',0),(517802,14384,'ba','Tab yang dibatasi',0),(517803,14384,'nl','Door tabs gescheiden',0),(517804,14384,'fi','SARKAIN-teksti',0),(517805,14384,'no','Tabulatordelt',0),(517806,14384,'da','Tabulatorsepareret',0),(517807,14384,'ko','íƒ­ìœ¼ë¡œ êµ¬ë¶„',0),(517808,14384,'he','×ž×•×¤×¨×“ ×‘××ž×¦×¢×•×ª ×˜××‘×™×',0),(517809,14384,'el','ÎŸÏÎ¹Î¿Î¸ÎµÏ„Î·Î¼Î­Î½Î¿Ï‚ Î¼Îµ Tab',0),(517810,14384,'zh','åˆ¶è¡¨ç¬¦åˆ†éš”',0),(517811,14384,'sv','TabbavgrÃ¤nsad',0),(517812,14384,'it','Delimitato da tabulazioni',0),(517813,14384,'tl','',0),(517814,14384,'th','à¹à¸—à¹‡à¸šà¸„à¸±à¹ˆà¸™',0),(517815,14384,'hi','à¤¸à¥€à¤®à¤¾à¤‚à¤•à¤¿à¤¤ à¤Ÿà¥ˆà¤¬',0),(517816,14384,'ms','Tab Delimited',0),(517817,14384,'ar','Ø§Ù„ØªØ¨ÙˆÙŠØ¨ Ù…Ø­Ø¯Ø¯',0),(517818,14384,'fr','DÃ©limitÃ© par des tabulations',0),(517819,14384,'jp','ã‚¿ãƒ–åŒºåˆ‡ã‚Š',0),(517820,14384,'pt','Delimitado por tabulaÃ§Ã£o',0),(517821,14384,'ru','Ð¡ Ñ€Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑÐ¼Ð¸ Ñ‚Ð°Ð±ÑƒÐ»ÑÑ†Ð¸Ð¸',0),(517822,14384,'es','Delimitado por tabuladores',0),(517823,14384,'de','Durch Tabulatoren getrennt',0),(517824,14384,'en','Tab Delimited',0),(517825,14385,'is','',0),(517826,14385,'dr','Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(517827,14385,'pr','Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(517828,14385,'tr','Ä°ÅŸlem bilgisi baÅŸarÄ±yla iÅŸlendi',0),(517829,14385,'pl','Info transakcji pomyÅ›lnie przetworzona',0),(517830,14385,'bg','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐµÐ½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(517831,14385,'ur','Ù¹Ø±Ø§Ù†Ø²ÛŒÚ©Ø´Ù† Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ',0),(517832,14385,'sr','Ð¢Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð˜Ð½Ñ„Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ñ€Ð°Ñ’ÐµÐ½',0),(517833,14385,'vi','ThÃ´ng tin giao dá»‹ch xá»­ lÃ½ thÃ nh cÃ´ng',0),(517834,14385,'af','Transaksie-inligting suksesvol verwerk',0),(517835,14385,'ro','TranzacÅ£ie informaÅ£ii prelucrate cu succes',0),(517836,14385,'et','Kande Info tÃ¶Ã¶tlemine Ãµnnestus',0),(517837,14385,'si','Transakcije Info uspeÅ¡no obdelane',0),(517838,14385,'ba','Info transaksi diproses berhasil',0),(517839,14385,'nl','Transactie Info verwerkt',0),(517840,14385,'fi','Tapahtuman Info kÃ¤siteltiin onnistuneesti',0),(517841,14385,'no','Transaksjonen Info behandlet',0),(517842,14385,'da','Transaktionen Info behandlet',0),(517843,14385,'ko','ì„±ê³µì ìœ¼ë¡œ ì²˜ë¦¬ í•˜ëŠ” íŠ¸ëžœìž­ì…˜ ì •ë³´',0),(517844,14385,'he','×¤×¨×˜×™ ×”×¢×¡×§×” ×ž×¢×•×‘×“ ×‘×”×¦×œ×—×”',0),(517845,14385,'el','Î£Ï…Î½Î±Î»Î»Î±Î³Î®Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï…Ï€Î¿Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹ ÏƒÎµ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(517846,14385,'zh','æˆåŠŸå¤„ç†çš„äº¤æ˜“è®°å½•ä¿¡æ¯',0),(517847,14385,'sv','Transaktion information har behandlats',0),(517848,14385,'it','Info transazione elaborata correttamente',0),(517849,14385,'tl','',0),(517850,14385,'th','à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸µà¹ˆà¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(517851,14385,'hi','à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤‚à¤¸à¤¾à¤§à¤¿à¤¤',0),(517852,14385,'ms','Maklumat transaksi diproses berjaya',0),(517853,14385,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ù„ØªÙŠ ØªØªÙ… Ù…Ø¹Ø§Ù„Ø¬ØªÙ‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(517854,14385,'fr','Info de transactions traitÃ©e avec succÃ¨s',0),(517855,14385,'jp','æ­£å¸¸ã«å‡¦ç†ã•ã‚ŒãŸãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³æƒ…å ±',0),(517856,14385,'pt','InformaÃ§Ã£o de transaÃ§Ã£o processada com sucesso',0),(517857,14385,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½',0),(517858,14385,'es','InformaciÃ³n de transacciones procesada con Ã©xito',0),(517859,14385,'de','Transaktion Informationen erfolgreich verarbeitet',0),(517860,14385,'en','Transaction Info Processed Successfully',0),(517861,14386,'is','',0),(517862,14386,'dr','Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù† Ø§Ù…Ù„Ø§Ú© Ù…Ø¯ÛŒØ±ÛŒØª Ù¾ÙˆØ±ØªØ§Ù„ Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø§ÙˆÙ„',0),(517863,14386,'pr','Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù† Ø§Ù…Ù„Ø§Ú© Ù…Ø¯ÛŒØ±ÛŒØª Ù¾ÙˆØ±ØªØ§Ù„ Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø§ÙˆÙ„',0),(517864,14386,'tr','MÃ¼lkiyet yÃ¶netimi Portal eriÅŸimi kullanÄ±cÄ±lara ilk atama',0),(517865,14386,'pl','PrzypisaÄ‡ wÅ‚aÅ›ciwoÅ›Ä‡ zarzÄ…dzanie dostÄ™pu do portalu uÅ¼ytkownicy po raz pierwszy',0),(517866,14386,'bg','Ð—Ð°Ð´Ð°Ð²Ð° ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð¾ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ñ€Ñ‚Ð°Ð»Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð¿ÑŠÑ€Ð²Ð¾',0),(517867,14386,'ur','Ø¬Ø§Ø¦ÛŒØ¯Ø§Ø¯ Ù…Ù†ÛŒØ¬Ù…Ù†Ù¹ Ù¾ÙˆØ±Ù¹Ù„ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ú©Û’ Ù„Ø¦Û’ ØµØ§Ø±ÙÛŒÙ† Ú©Ùˆ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(517868,14386,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ð¸Ð¼Ð°ÑšÐµ ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ð¿Ð¾Ñ€Ñ‚Ð°Ð»Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸Ð¼Ð° Ð¿Ñ€Ð²Ð¾',0),(517869,14386,'vi','GÃ¡n tÃ i sáº£n quáº£n lÃ½ cá»•ng thÃ´ng tin truy cáº­p cho ngÆ°á»i dÃ¹ng Ä‘áº§u tiÃªn',0),(517870,14386,'af','Eerste eiendom bestuur Portal toegang aan gebruikers toewys',0),(517871,14386,'ro','Atribui proprietate Management Portal accesul utilizatorilor Ã®n primul rÃ¢nd',0),(517872,14386,'et','Kinnisvara haldamise sissepÃ¤Ã¤s mÃ¤Ã¤rata kasutajatele esmalt',0),(517873,14386,'si','Dodelite lastnost upravljanje dostopa do portala uporabnikom najprej',0),(517874,14386,'ba','Menetapkan properti manajemen Portal akses ke pengguna pertama',0),(517875,14386,'nl','Eerste eigenschap beheer Portal-toegang aan gebruikers toewijzen',0),(517876,14386,'fi','MÃ¤Ã¤rittÃ¤Ã¤ omaisuuden hallinta portaalin kÃ¤yttÃ¤jille ensin',0),(517877,14386,'no','Tilordne Egenskapstilgang Management Portal til brukere fÃ¸rst',0),(517878,14386,'da','Tildele Property Management portalen adgang til brugere fÃ¸rst',0),(517879,14386,'ko','ë¨¼ì € ì†ì„± ê´€ë¦¬ í¬í„¸ ì•¡ì„¸ìŠ¤ ì‚¬ìš©ìžì— ê²Œ í• ë‹¹',0),(517880,14386,'he','×”×§×¦××ª ×’×™×©×” ×¤×•×¨×˜×œ ×œ× ×™×”×•×œ ×¨×›×•×© ×œ×ž×©×ª×ž×©×™× ×§×•×“×',0),(517881,14386,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ Î¹Î´Î¹ÏŒÏ„Î·Ï„Î± Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚ Ï€ÏÎ»Î·Ï‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÏƒÏ„Î¿Ï…Ï‚ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Ï€ÏÏŽÏ„Î±',0),(517882,14386,'zh','ç¬¬ä¸€æ¬¡å°†ç‰©ä¸šç®¡ç†é—¨æˆ·è®¿é—®åˆ†é…ç»™ç”¨æˆ·',0),(517883,14386,'sv','Tilldela egenskapen Management Portal tillgÃ¥ng till anvÃ¤ndare fÃ¶rst',0),(517884,14386,'it','Assegnare la proprietÃ  Gestione portale accesso agli utenti prima',0),(517885,14386,'tl','',0),(517886,14386,'th','à¸à¸³à¸«à¸™à¸”à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¸žà¸­à¸£à¹Œà¸—à¸±à¸¥à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸à¹ˆà¸­à¸™',0),(517887,14386,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤ªà¥‹à¤°à¥à¤Ÿà¤² à¤¤à¤• à¤ªà¤¹à¥à¤à¤š à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤ªà¤¹à¤²à¥€ à¤¬à¤¾à¤° à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(517888,14386,'ms','Peruntukkan akses Portal Pengurusan Hartanah kepada pengguna pertama',0),(517889,14386,'ar','ØªØ¹ÙŠÙŠÙ† Ø®Ø§ØµÙŠØ© Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø¯Ø®Ù„ Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø£ÙˆÙ„Ø§Ù‹',0),(517890,14386,'fr','Assigner la propriÃ©tÃ© gestion portail d\'accÃ¨s aux utilisateurs tout d\'abord',0),(517891,14386,'jp','æœ€åˆã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ç®¡ç†ãƒãƒ¼ã‚¿ãƒ«ã¸ã®ã‚¢ã‚¯ã‚»ã‚¹ã‚’å‰²ã‚Šå½“ã¦ã‚‹',0),(517892,14386,'pt','Atribuir acesso Portal de gestÃ£o de propriedade para os usuÃ¡rios primeiro',0),(517893,14386,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° Ð½Ð°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑÐ¼ Ð´Ð¾ÑÑ‚ÑƒÐ¿ Ðº Ð¿Ð¾Ñ€Ñ‚Ð°Ð»Ñƒ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÐ²Ð¾Ð¹ÑÑ‚Ð²Ð°',0),(517894,14386,'es','Asignar acceso Portal de gestiÃ³n de propiedad a los usuarios primero',0),(517895,14386,'de','Eigenschaft Management Portal Zugang zuerst Benutzern zuweisen',0),(517896,14386,'en','Assign Property Management Portal Access To Users First',0),(517897,14387,'is','',0),(517898,14387,'dr','Ø¬Ø¯ÛŒØ¯ Ø§Ø¬Ø§Ø±Ù‡ ØªØ®Øª Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(517899,14387,'pr','Ø¬Ø¯ÛŒØ¯ Ø§Ø¬Ø§Ø±Ù‡ ØªØ®Øª Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(517900,14387,'tr','Yeni kira Daire komisyon',0),(517901,14387,'pl','Nowe umowy najmu pÅ‚askie Komisji',0),(517902,14387,'bg','ÐÐ¾Ð²Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ð»Ð¾ÑÐºÐ¸ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ',0),(517903,14387,'ur','Ù†Ø¦ÛŒ Ù„ÛŒØ² ÙÙ„ÛŒÙ¹ Ú©Ù…ÛŒØ´Ù†',0),(517904,14387,'sr','ÐÐ¾Ð²Ð¸ Ð·Ð°ÐºÑƒÐ¿ ÑÑ‚Ð°Ð½Ð° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ðµ',0),(517905,14387,'vi','Hoa há»“ng má»›i cho thuÃª cÄƒn há»™',0),(517906,14387,'af','Nuwe huurkontrak plat Kommissie',0),(517907,14387,'ro','Nou contract de leasing plat Comisiei',0),(517908,14387,'et','Uus Ã¼Ã¼rileping korter komisjoni',0),(517909,14387,'si','Nov najem stanovanje Komisija',0),(517910,14387,'ba','Baru Lease datar komisi',0),(517911,14387,'nl','Nieuwe Lease platte Commissie',0),(517912,14387,'fi','Uusi vuokrasopimus tasainen komissio',0),(517913,14387,'no','Ny leieavtale Flat kommisjon',0),(517914,14387,'da','Ny Lease flad Kommissionen',0),(517915,14387,'ko','ìƒˆë¡œìš´ ìž„ëŒ€ íŽ¸í‰í•œ ìœ„ì›íšŒ',0),(517916,14387,'he','×”× ×¦×™×‘×•×ª ×©×˜×•×— ×—×›×™×¨×” ×—×“×©',0),(517917,14387,'el','ÎÎ­Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· ÎµÏ€Î¯Ï€ÎµÎ´Î· Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®',0),(517918,14387,'zh','æ–°çš„ç§Ÿèµå•ä½å§”å‘˜ä¼š',0),(517919,14387,'sv','Nya leasingavtal platt kommissionen',0),(517920,14387,'it','Nuova Commissione piatto Lease',0),(517921,14387,'tl','',0),(517922,14387,'th','à¸™à¸²à¸¢à¹à¸šà¸™à¹€à¸Šà¹ˆà¸²à¹ƒà¸«à¸¡à¹ˆ',0),(517923,14387,'hi','à¤¨à¤ˆ à¤²à¥€à¤œ à¤«à¥à¤²à¥ˆà¤Ÿ à¤†à¤¯à¥‹à¤—',0),(517924,14387,'ms','Baru pajakan rata Suruhanjaya',0),(517925,14387,'ar','Ù„Ø¬Ù†Ø© Ø´Ù‚Ø© Ø¥ÙŠØ¬Ø§Ø± Ø¬Ø¯ÙŠØ¯Ø©',0),(517926,14387,'fr','Nouvelle location plat Commission',0),(517927,14387,'jp','æ–°ã—ã„ãƒªãƒ¼ã‚¹ ãƒ•ãƒ©ãƒƒãƒˆå§”å“¡ä¼š',0),(517928,14387,'pt','Nova ComissÃ£o plano de locaÃ§Ã£o',0),(517929,14387,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹ ÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ð° ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(517930,14387,'es','Nueva ComisiÃ³n plana de arrendamiento',0),(517931,14387,'de','Neue Leasing-flach-Kommission',0),(517932,14387,'en','New Lease Flat Commission',0),(517933,14388,'is','',0),(517934,14388,'dr','Ø¯Ø±ØµØ¯ Ú©Ù…ÛŒØ³ÛŒÙˆÙ† ØªØ§Ø²Ù‡ Ø§Ø¬Ø§Ø±Ù‡',0),(517935,14388,'pr','Ø¯Ø±ØµØ¯ Ú©Ù…ÛŒØ³ÛŒÙˆÙ† ØªØ§Ø²Ù‡ Ø§Ø¬Ø§Ø±Ù‡',0),(517936,14388,'tr','Yeni kira yÃ¼zde Komisyonu',0),(517937,14388,'pl','Nowe umowy najmu procent Komisji',0),(517938,14388,'bg','ÐÐ¾Ð²Ð° Ð»Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ',0),(517939,14388,'ur','Ù†Ø¦ÛŒ Ù„ÛŒØ² ÙÛŒØµØ¯ Ú©Ù…ÛŒØ´Ù†',0),(517940,14388,'sr','ÐÐ¾Ð²Ð¸ Ð·Ð°ÐºÑƒÐ¿ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ðµ',0),(517941,14388,'vi','Má»›i cho thuÃª pháº§n trÄƒm hoa há»“ng',0),(517942,14388,'af','Nuwe huurkontrak persent Kommissie',0),(517943,14388,'ro','Nou contract de leasing la sutÄƒ Comisiei',0),(517944,14388,'et','Uue liisingu protsenti komisjoni',0),(517945,14388,'si','Nove najemne pogodbe odstotek provizije',0),(517946,14388,'ba','Baru Lease persen komisi',0),(517947,14388,'nl','Nieuwe Lease procent Commissie',0),(517948,14388,'fi','Uuden vuokrasopimuksen prosenttia komission',0),(517949,14388,'no','Ny leieavtale prosent kommisjon',0),(517950,14388,'da','Ny Lease procent Kommissionen',0),(517951,14388,'ko','ìƒˆë¡œìš´ ìž„ëŒ€ % ìœ„ì›íšŒ',0),(517952,14388,'he','×—×“×© ×—×›×™×¨×” ××—×•×– ×¢×ž×œ×”',0),(517953,14388,'el','ÎÎ­Î± Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ· Ï€Î¿ÏƒÎ¿ÏƒÏ„Î¹Î±Î¯Î± Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹Î±',0),(517954,14388,'zh','æ–°ç§Ÿçº¦ç™¾åˆ†æ¯”å§”å‘˜ä¼š',0),(517955,14388,'sv','Nya leasingavtal procent kommissionen',0),(517956,14388,'it','Nuova Commissione percentuale Lease',0),(517957,14388,'tl','',0),(517958,14388,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¹ˆà¸™à¹ƒà¸«à¸¡à¹ˆà¹€à¸Šà¹ˆà¸²',0),(517959,14388,'hi','à¤¨à¤ˆ à¤²à¥€à¤œ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¤®à¥€à¤¶à¤¨',0),(517960,14388,'ms','Baru pajakan peratus komisen',0),(517961,14388,'ar','Ù„Ø¬Ù†Ø© Ø§Ù„Ù…Ø¦Ø© Ø¥ÙŠØ¬Ø§Ø± Ø¬Ø¯ÙŠØ¯Ø©',0),(517962,14388,'fr','Nouveau bail pourcentage Commission',0),(517963,14388,'jp','æ–°ã—ã„ãƒªãƒ¼ã‚¹ ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆæ‰‹æ•°æ–™',0),(517964,14388,'pt','Nova ComissÃ£o percentual de locaÃ§Ã£o',0),(517965,14388,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð°Ñ€ÐµÐ½Ð´Ñ‹ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(517966,14388,'es','Nueva ComisiÃ³n por ciento del contrato de arrendamiento',0),(517967,14388,'de','Neue Lease Prozent Kommission',0),(517968,14388,'en','New Lease Percent Commission',0),(517969,14389,'is','',0),(517970,14389,'dr','Ø¨ÛŒØ´ Ø§Ø² 30 Ø±ÙˆØ² Ø§ÙˆØ§Ø®Ø± Ùª Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ú©Ø§Ù‡Ø´',0),(517971,14389,'pr','Ø¨ÛŒØ´ Ø§Ø² 30 Ø±ÙˆØ² Ø§ÙˆØ§Ø®Ø± Ùª Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ú©Ø§Ù‡Ø´',0),(517972,14389,'tr','30 gÃ¼n geÃ§ % komisyon azaltma',0),(517973,14389,'pl','Ponad 30 dni koniec % Komisji obniÅ¼enie',0),(517974,14389,'bg','ÐÐ°Ð´ 30 Ð´Ð½Ð¸ ÐºÑ€Ð°Ñ % Ð½Ð°Ð¼Ð°Ð»ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(517975,14389,'ur','30 Ø³Û’ Ø²Ø§Ø¦Ø¯ Ø¯Ù† Ù…Ø±Ø­ÙˆÙ… ÙÛŒØµØ¯ Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ú©Ù…ÛŒ',0),(517976,14389,'sr','ÐšÐ°ÑÐ½Ð¾ ÑÐ¼Ð°ÑšÐµÑšÐµ % ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¿Ñ€ÐµÐºÐ¾ 30 Ð´Ð°Ð½Ð°',0),(517977,14389,'vi','HÆ¡n 30 ngÃ y cuá»‘i % hoa há»“ng giáº£m',0),(517978,14389,'af','Oor 30 dae laat % Kommissie vermindering',0),(517979,14389,'ro','Peste 30 de zile Ã®ntÃ¢rziere Comisia reducere %',0),(517980,14389,'et','Ãœle 30 pÃ¤eva lÃµpus % komisjoni vÃ¤hendamine',0),(517981,14389,'si','VeÄ kot 30 dni pozno % Komisija zmanjÅ¡anje',0),(517982,14389,'ba','Lebih dari 30 hari akhir % Komisi pengurangan',0),(517983,14389,'nl','Meer dan 30 dagen laat % Commissie vermindering',0),(517984,14389,'fi','Yli 30 pÃ¤ivÃ¤Ã¤ myÃ¶hÃ¤ssÃ¤ komission vÃ¤hennysprosentti',0),(517985,14389,'no','Over 30 dager sen % provisjon reduksjon',0),(517986,14389,'da','Over 30 dage forsinket % Kommissionen reduktion',0),(517987,14389,'ko','30 ì¼ ëŠ¦ì€ % ìˆ˜ìˆ˜ë£Œ ê°ì†Œ',0),(517988,14389,'he','×ž×¢×œ 30 ×™×ž×™× ×ž××•×—×¨ % ×¢×ž×œ×” ×¦×ž×¦×•×',0),(517989,14389,'el','Î Î¬Î½Ï‰ Î±Ï€ÏŒ 30 Î·Î¼Î­ÏÎµÏ‚ Î±ÏÎ³Î¬ % Î¼ÎµÎ¯Ï‰ÏƒÎ· Ï„Î·Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®Ï‚',0),(517990,14389,'zh','è¶…è¿‡ 30 å¤©æ™š %ä½£é‡‘',0),(517991,14389,'sv','Ã–ver 30 dagar sen % kommissionen minskning',0),(517992,14389,'it','Riduzione di oltre 30 giorni fine % Commissione',0),(517993,14389,'tl','',0),(517994,14389,'th','à¸¥à¸”à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™%à¸¥à¹ˆà¸²à¸Šà¹‰à¸²à¸à¸§à¹ˆà¸² 30 à¸§à¸±à¸™',0),(517995,14389,'hi','30 à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¦à¤¿à¤¨ à¤¦à¥‡à¤° à¤¸à¥‡ % à¤†à¤¯à¥‹à¤— à¤•à¤®à¥€',0),(517996,14389,'ms','Pengurangan Suruhanjaya % lewat lebih daripada 30 hari',0),(517997,14389,'ar','ØªØ®ÙÙŠØ¶ Ø£ÙŠØ§Ù… Ù…Ø§ ÙŠØ²ÙŠØ¯ Ø¹Ù„Ù‰ 30% Ù…Ù† Ø£ÙˆØ§Ø®Ø± Ø§Ù„Ù„Ø¬Ù†Ø©',0),(517998,14389,'fr','Plus de 30 jours fin % Commission rÃ©duction',0),(517999,14389,'jp','ä»¥ä¸Š 30 æ—¥å¾ŒæœŸ ï¼… å§”å“¡ä¼šå‰Šæ¸›',0),(518000,14389,'pt','Mais de 30 dias atrasado % reduÃ§Ã£o de ComissÃ£o',0),(518001,14389,'ru','Ð¡Ð½Ð¸Ð¶ÐµÐ½Ð¸Ðµ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ð¿Ð¾Ð·Ð´Ð½Ð¾ % ÑÐ²Ñ‹ÑˆÐµ 30 Ð´Ð½ÐµÐ¹',0),(518002,14389,'es','MÃ¡s de 30 dÃ­as tarde % ComisiÃ³n reducciÃ³n',0),(518003,14389,'de','Reduzierung von mehr als 30 Tage spÃ¤t % Kommission',0),(518004,14389,'en','Over 30 Days Late % Commission Reduction',0),(518005,14390,'is','',0),(518006,14390,'dr','Ø§ÙˆØ§Ø®Ø± Ø±ÙˆØ² Ø¨ÛŒØ´ Ø§Ø² 60 Ùª Ú©Ø§Ù‡Ø´ Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(518007,14390,'pr','Ø§ÙˆØ§Ø®Ø± Ø±ÙˆØ² Ø¨ÛŒØ´ Ø§Ø² 60 Ùª Ú©Ø§Ù‡Ø´ Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(518008,14390,'tr','60 gÃ¼n geÃ§ % komisyon azaltma',0),(518009,14390,'pl','Ponad 60 dni koniec % Komisji obniÅ¼enie',0),(518010,14390,'bg','ÐÐ°Ð´ 60 Ð´Ð½Ð¸ ÐºÑ€Ð°Ñ % Ð½Ð°Ð¼Ð°Ð»ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(518011,14390,'ur','Ù¾Ø± 60 Ø¯Ù†ÙˆÚº Ù…Ø±Ø­ÙˆÙ… ÙÛŒØµØ¯ Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ú©Ù…ÛŒ',0),(518012,14390,'sr','ÐšÐ°ÑÐ½Ð¾ ÑÐ¼Ð°ÑšÐµÑšÐµ % ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¿Ñ€ÐµÐºÐ¾ 60 Ð´Ð°Ð½Ð°',0),(518013,14390,'vi','HÆ¡n 60 ngÃ y cuá»‘i % hoa há»“ng giáº£m',0),(518014,14390,'af','Oor 60 dae laat % Kommissie vermindering',0),(518015,14390,'ro','Peste 60 de zile de Ã®ntÃ¢rziere % Comisia reducere',0),(518016,14390,'et','Ãœle 60 pÃ¤eva lÃµpus % komisjoni vÃ¤hendamine',0),(518017,14390,'si','VeÄ kot 60 dni prepozno % Komisija zmanjÅ¡anje',0),(518018,14390,'ba','Lebih dari 60 hari terlambat % Komisi pengurangan',0),(518019,14390,'nl','Meer dan 60 dagen laat % Commissie vermindering',0),(518020,14390,'fi','Yli 60 pÃ¤ivÃ¤Ã¤ myÃ¶hÃ¤ssÃ¤ komission vÃ¤hennysprosentti',0),(518021,14390,'no','Over 60 dager sent % provisjon reduksjon',0),(518022,14390,'da','Over 60 dage forsinket % Kommissionen reduktion',0),(518023,14390,'ko','60 ì—¬ ì¼ ëŠ¦ì€ % ìˆ˜ìˆ˜ë£Œ ê°ì†Œ',0),(518024,14390,'he','×ž×¢×œ 60 ×™×ž×™× ×ž××•×—×¨ % ×¢×ž×œ×” ×¦×ž×¦×•×',0),(518025,14390,'el','Î Î¬Î½Ï‰ Î±Ï€ÏŒ 60 Î·Î¼Î­ÏÎµÏ‚ Î±ÏÎ³Î¬ % Î¼ÎµÎ¯Ï‰ÏƒÎ· Ï„Î·Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®Ï‚',0),(518026,14390,'zh','è¶…è¿‡ 60 å¤©æ™š %ä½£é‡‘',0),(518027,14390,'sv','Ã–ver 60 dagar sen % kommissionen minskning',0),(518028,14390,'it','Riduzione di oltre 60 giorni fine % Commissione',0),(518029,14390,'tl','',0),(518030,14390,'th','à¸¥à¸”à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™%à¸¥à¹ˆà¸²à¸Šà¹‰à¸²à¸à¸§à¹ˆà¸² 60 à¸§à¸±à¸™',0),(518031,14390,'hi','60 à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¦à¤¿à¤¨ à¤¦à¥‡à¤° à¤¸à¥‡ % à¤†à¤¯à¥‹à¤— à¤•à¤®à¥€',0),(518032,14390,'ms','Pengurangan Suruhanjaya % lewat lebih daripada 60 hari',0),(518033,14390,'ar','ØªØ®ÙÙŠØ¶ Ø£ÙŠØ§Ù… Ù…Ø§ ÙŠØ²ÙŠØ¯ Ø¹Ù„Ù‰ 60% Ù…Ù† Ø£ÙˆØ§Ø®Ø± Ø§Ù„Ù„Ø¬Ù†Ø©',0),(518034,14390,'fr','Plus de 60 jours fin % Commission rÃ©duction',0),(518035,14390,'jp','ä»¥ä¸Š 60 æ—¥é…ã‚Œã¦ ï¼… å§”å“¡ä¼šå‰Šæ¸›',0),(518036,14390,'pt','Mais de 60 dias atrasado % reduÃ§Ã£o de ComissÃ£o',0),(518037,14390,'ru','Ð‘Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ 60 Ð´Ð½ÐµÐ¹ Ð¿Ð¾Ð·Ð´Ð½Ð¾ ÑÐ½Ð¸Ð¶ÐµÐ½Ð¸Ðµ % ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(518038,14390,'es','MÃ¡s de 60 dÃ­as tarde % ComisiÃ³n reducciÃ³n',0),(518039,14390,'de','Reduzierung von mehr als 60 Tage spÃ¤t % Kommission',0),(518040,14390,'en','Over 60 Days Late % Commission Reduction',0),(518041,14391,'is','',0),(518042,14391,'dr','Ø¨ÛŒØ´ Ø§Ø² 90 Ø±ÙˆØ² Ø§ÙˆØ§Ø®Ø± Ùª Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ú©Ø§Ù‡Ø´',0),(518043,14391,'pr','Ø¨ÛŒØ´ Ø§Ø² 90 Ø±ÙˆØ² Ø§ÙˆØ§Ø®Ø± Ùª Ú©Ù…ÛŒØ³ÛŒÙˆÙ† Ú©Ø§Ù‡Ø´',0),(518044,14391,'tr','90 gÃ¼n geÃ§ % komisyon azaltma',0),(518045,14391,'pl','Ponad 90 dni pod koniec % Komisji obniÅ¼enie',0),(518046,14391,'bg','ÐÐ°Ð´ 90 Ð´Ð½Ð¸ ÐºÑ€Ð°Ñ % Ð½Ð°Ð¼Ð°Ð»ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(518047,14391,'ur','Ø²ÛŒØ§Ø¯Û 90 Ø¯Ù†ÙˆÚº Ù…Ø±Ø­ÙˆÙ… ÙÛŒØµØ¯ Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ Ú©Ù…ÛŒ',0),(518048,14391,'sr','ÐšÐ°ÑÐ½Ð¾ ÑÐ¼Ð°ÑšÐµÑšÐµ % ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ð° Ð¿Ñ€ÐµÐºÐ¾ 90 Ð´Ð°Ð½Ð°',0),(518049,14391,'vi','HÆ¡n 90 ngÃ y cuá»‘i % hoa há»“ng giáº£m',0),(518050,14391,'af','Meer as 90 dae laat % Kommissie vermindering',0),(518051,14391,'ro','Peste 90 de zile tÃ¢rziu % reducere a Comisiei',0),(518052,14391,'et','Ãœle 90 pÃ¤eva hilinenud % komisjoni vÃ¤hendamine',0),(518053,14391,'si','VeÄ kot 90 dni pozno % Komisija zmanjÅ¡anje',0),(518054,14391,'ba','Lebih dari 90 hari akhir % Komisi pengurangan',0),(518055,14391,'nl','Meer dan 90 dagen laat % Commissie vermindering',0),(518056,14391,'fi','Yli 90 pÃ¤ivÃ¤Ã¤ myÃ¶hÃ¤ssÃ¤ komission vÃ¤hennysprosentti',0),(518057,14391,'no','Over 90 dager sen % provisjon reduksjon',0),(518058,14391,'da','Over 90 dage forsinket % Kommissionen reduktion',0),(518059,14391,'ko','90 ì¼ ëŠ¦ì€ % ìˆ˜ìˆ˜ë£Œ ê°ì†Œ',0),(518060,14391,'he','×ž×¢×œ 90 ×™×•× ×ž××•×—×¨ % ×¢×ž×œ×” ×¦×ž×¦×•×',0),(518061,14391,'el','Î Î¬Î½Ï‰ Î±Ï€ÏŒ 90 Î·Î¼Î­ÏÎµÏ‚ Î±ÏÎ³Î¬ % Î¼ÎµÎ¯Ï‰ÏƒÎ· Ï„Î·Ï‚ Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®Ï‚',0),(518062,14391,'zh','è¶…è¿‡ 90 å¤©æ™š %ä½£é‡‘',0),(518063,14391,'sv','Ã–ver 90 dagar sen % kommissionen minskning',0),(518064,14391,'it','Riduzione di oltre 90 giorni fine % Commissione',0),(518065,14391,'tl','',0),(518066,14391,'th','à¸¥à¸”à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™%à¸¥à¹ˆà¸²à¸Šà¹‰à¸²à¸à¸§à¹ˆà¸² 90 à¸§à¸±à¸™',0),(518067,14391,'hi','90 à¤¦à¤¿à¤¨à¥‹à¤‚ à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¦à¥‡à¤° à¤¸à¥‡ % à¤†à¤¯à¥‹à¤— à¤•à¤®à¥€',0),(518068,14391,'ms','Pengurangan Suruhanjaya % lewat lebih dari 90 hari',0),(518069,14391,'ar','ØªØ®ÙÙŠØ¶ Ø£ÙŠØ§Ù… Ù…Ø§ ÙŠØ²ÙŠØ¯ Ø¹Ù„Ù‰ 90% Ù…Ù† Ø£ÙˆØ§Ø®Ø± Ø§Ù„Ù„Ø¬Ù†Ø©',0),(518070,14391,'fr','Plus de 90 jours fin % Commission rÃ©duction',0),(518071,14391,'jp','90 æ—¥é–“é…ã ï¼… æ‰‹æ•°æ–™å¼•ãä¸‹ã’ã«',0),(518072,14391,'pt','Mais de 90 dias atrasado % reduÃ§Ã£o de ComissÃ£o',0),(518073,14391,'ru','Ð¡Ð½Ð¸Ð¶ÐµÐ½Ð¸Ðµ ÐºÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸ Ð¿Ð¾Ð·Ð´Ð½Ð¾ % ÑÐ²Ñ‹ÑˆÐµ 90 Ð´Ð½ÐµÐ¹',0),(518074,14391,'es','MÃ¡s de 90 dÃ­as tarde % ComisiÃ³n reducciÃ³n',0),(518075,14391,'de','Reduzierung von mehr als 90 Tage spÃ¤t % Kommission',0),(518076,14391,'en','Over 90 Days Late % Commission Reduction',0),(518077,14392,'is','',0),(518078,14392,'dr','ØªÙ…Ø¯ÛŒØ¯ Ø§Ø¬Ø§Ø±Ù‡ ØªØ®Øª Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(518079,14392,'pr','ØªÙ…Ø¯ÛŒØ¯ Ø§Ø¬Ø§Ø±Ù‡ ØªØ®Øª Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(518080,14392,'tr','DÃ¼z kira Komisyonu yenilemek',0),(518081,14392,'pl','Odnowienia dzierÅ¼awy pÅ‚askie Komisji',0),(518082,14392,'bg','ÐŸÐ¾Ð´Ð½Ð¾Ð²Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³Ð° Ð¿Ð»Ð¾ÑÐºÐ¸ ÐšÐ¾Ð¼Ð¸ÑÐ¸ÑÑ‚Ð°',0),(518083,14392,'ur','Ù„ÛŒØ² ÙÙ„ÛŒÙ¹ Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯',0),(518084,14392,'sr','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚Ð¸ Ð·Ð°ÐºÑƒÐ¿ ÑÑ‚Ð°Ð½Ð° ÐºÐ¾Ð¼Ð¸ÑÐ¸Ñ˜Ðµ',0),(518085,14392,'vi','Gia háº¡n á»¦y ban cÄƒn há»™ cho thuÃª',0),(518086,14392,'af','Hernu huurkontrak plat Kommissie',0),(518087,14392,'ro','ReÃ®nnoi Lease apartament Comisiei',0),(518088,14392,'et','ÃœÃ¼rilepingu korter komisjon uuendada',0),(518089,14392,'si','Obnoviti najem stanovanje Komisija',0),(518090,14392,'ba','Memperbaharui sewa datar komisi',0),(518091,14392,'nl','Platte Commissie Lease vernieuwen',0),(518092,14392,'fi','Vuokrasopimus tasainen komissio uudistaa',0),(518093,14392,'no','Fornye leieavtalen Flat kommisjonen',0),(518094,14392,'da','Forny leasingkontrakt flad Kommissionen',0),(518095,14392,'ko','ê°±ì‹  ìž„ëŒ€ íŽ¸í‰í•œ ìœ„ì›íšŒ',0),(518096,14392,'he','×—×™×“×•×© ×”×—×›×™×¨×” ×”× ×¦×™×‘×•×ª ×©×˜×•×—',0),(518097,14392,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ· Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î· Î•Ï€Î¹Ï„ÏÎ¿Ï€Î®',0),(518098,14392,'zh','ç»­è®¢ç§Ÿçº¦å¹³å§”å‘˜ä¼š',0),(518099,14392,'sv','FÃ¶rnya Lease plan kommissionen',0),(518100,14392,'it','Rinnovare il Lease Commissione piana',0),(518101,14392,'tl','',0),(518102,14392,'th','à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸à¸ªà¸±à¸à¸à¸²à¹€à¸Šà¹ˆà¸²à¸™à¸²à¸¢à¹à¸šà¸™',0),(518103,14392,'hi','à¤²à¥€à¤œ à¤«à¥à¤²à¥ˆà¤Ÿ à¤†à¤¯à¥‹à¤— à¤•à¥‹ à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤',0),(518104,14392,'ms','Memperbaharui pajakan rata Suruhanjaya',0),(518105,14392,'ar','ØªØ¬Ø¯ÙŠØ¯ Ø¹Ù‚Ø¯ Ø¥ÙŠØ¬Ø§Ø± Ø´Ù‚Ø© Ø§Ù„Ù„Ø¬Ù†Ø©',0),(518106,14392,'fr','Renouveler le bail Commission plat',0),(518107,14392,'jp','ãƒªãƒ¼ã‚¹ ãƒ•ãƒ©ãƒƒãƒˆå§”å“¡ä¼šã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(518108,14392,'pt','Renovar a ComissÃ£o plano de locaÃ§Ã£o',0),(518109,14392,'ru','ÐŸÑ€Ð¾Ð´Ð»Ð¸Ñ‚ÑŒ Ð°Ñ€ÐµÐ½Ð´Ñƒ ÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ð° ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(518110,14392,'es','Renovar contrato ComisiÃ³n plana',0),(518111,14392,'de','Vermietung Wohnung Kommission zu erneuern',0),(518112,14392,'en','Renew Lease Flat Commission',0),(518113,14393,'is','',0),(518114,14393,'dr','ØªÙ…Ø¯ÛŒØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ùª Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(518115,14393,'pr','ØªÙ…Ø¯ÛŒØ¯ Ø§Ø¬Ø§Ø±Ù‡ Ùª Ú©Ù…ÛŒØ³ÛŒÙˆÙ†',0),(518116,14393,'tr','Kira % komisyon yenilemek',0),(518117,14393,'pl','OdnowiÄ‡ dzierÅ¼awÄ™ % prowizji',0),(518118,14393,'bg','ÐŸÐ¾Ð´Ð½Ð¾Ð²Ð¸ Ð»Ð¸Ð·Ð¸Ð½Ð³Ð° % ÐºÐ¾Ð¼Ð¸ÑÐ¸Ð¾Ð½Ð½Ð°',0),(518119,14393,'ur','Ù„ÛŒØ² ÙÛŒØµØ¯ Ú©Ù…ÛŒØ´Ù† Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯',0),(518120,14393,'sr','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚Ð¸ Ð·Ð°ÐºÑƒÐ¿ % Ð¿Ñ€Ð¾Ð²Ð¸Ð·Ð¸Ñ˜Ðµ',0),(518121,14393,'vi','Gia háº¡n há»£p Ä‘á»“ng thuÃª % hoa há»“ng',0),(518122,14393,'af','Huurkontrak % Kommissie hernu',0),(518123,14393,'ro','ReÃ®nnoi leasing % comision',0),(518124,14393,'et','Pikendada Ã¼Ã¼rilepingu % komisjoni',0),(518125,14393,'si','Obnovijo zakup % provizije',0),(518126,14393,'ba','Memperbaharui sewa % komisi',0),(518127,14393,'nl','Vernieuwen van de Lease % Commissie',0),(518128,14393,'fi','Uusia vuokrasopimuksen %: N',0),(518129,14393,'no','Fornye leieavtalen % provisjon',0),(518130,14393,'da','Forny rettigheden % provision',0),(518131,14393,'ko','ê°±ì‹  ìž„ëŒ€ % ìœ„ì›íšŒ',0),(518132,14393,'he','×—×™×“×•×© ×—×›×™×¨×” % ×¢×ž×œ×”',0),(518133,14393,'el','Î‘Î½Î±Î½Î­Ï‰ÏƒÎ· Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚ % Ï€ÏÎ¿Î¼Î®Î¸ÎµÎ¹Î±',0),(518134,14393,'zh','ç»­è®¢ç§Ÿçº¦ %çš„ä½£é‡‘',0),(518135,14393,'sv','FÃ¶rnya lÃ¥net % provision',0),(518136,14393,'it','Rinnovare il Lease % Commissione',0),(518137,14393,'tl','',0),(518138,14393,'th','à¸•à¹ˆà¸­à¸­à¸²à¸¢à¸¸à¹€à¸Šà¹ˆà¸²%à¸„à¹ˆà¸²à¸„à¸­à¸¡à¸¡à¸´à¸Šà¸Šà¸±à¸™',0),(518139,14393,'hi','à¤²à¥€à¤œ % à¤†à¤¯à¥‹à¤— à¤•à¥‹ à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤',0),(518140,14393,'ms','Memperbaharui pajakan % Suruhanjaya',0),(518141,14393,'ar','ØªØ¬Ø¯ÙŠØ¯ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø± % Ø¹Ù…ÙˆÙ„Ø©',0),(518142,14393,'fr','Renouveler le bail % Commission',0),(518143,14393,'jp','ãƒªãƒ¼ã‚¹ % å§”å“¡ä¼šã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(518144,14393,'pt','Renovar a locaÃ§Ã£o % ComissÃ£o',0),(518145,14393,'ru','ÐŸÑ€Ð¾Ð´Ð»Ð¸Ñ‚ÑŒ Ð°Ñ€ÐµÐ½Ð´Ñƒ % ÐšÐ¾Ð¼Ð¸ÑÑÐ¸Ð¸',0),(518146,14393,'es','Renovar el contrato de arrendamiento % ComisiÃ³n',0),(518147,14393,'de','Erneuerung der Lease % Provision',0),(518148,14393,'en','Renew Lease % Commission',0),(518149,14394,'is','',0),(518150,14394,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ù†Ø¸Ø± Ø³Ù†Ø¬ÛŒ Ù…Ø´ØªØ±ÛŒ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±',0),(518151,14394,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ù†Ø¸Ø± Ø³Ù†Ø¬ÛŒ Ù…Ø´ØªØ±ÛŒ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±',0),(518152,14394,'tr','Bir uygulama mÃ¼ÅŸteri anket oluÅŸturma',0),(518153,14394,'pl','Tworzenie aplikacji klient badanie',0),(518154,14394,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ñ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ',0),(518155,14394,'ur','Ø§ÛŒÚ© Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù† Ú©Ø³Ù¹Ù…Ø± Ø³Ø±ÙˆÛ’ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(518156,14394,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜ Ð°Ð½ÐºÐµÑ‚Ñƒ ÐºÑƒÐ¿Ñ†Ð° Ð·Ð° Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(518157,14394,'vi','Táº¡o ra má»™t cuá»™c kháº£o sÃ¡t khÃ¡ch hÃ ng á»©ng dá»¥ng',0),(518158,14394,'af','Skep \'n aansoek kliÃ«nt opname',0),(518159,14394,'ro','Crea o aplicaÅ£ie client sondaj',0),(518160,14394,'et','Loo taotlus jÃµuluspÃ¤mmÃ¤rid',0),(518161,14394,'si','Ustvarite pregled uporabe kupca',0),(518162,14394,'ba','Membuat aplikasi Customer Survey',0),(518163,14394,'nl','Een klanttevredenheidsonderzoek toepassing maken',0),(518164,14394,'fi','Luo sovelluksen Asiakaskysely',0),(518165,14394,'no','Opprette en applikasjon kundeundersÃ¸kelse',0),(518166,14394,'da','Oprette en ansÃ¸gning kundeundersÃ¸gelse',0),(518167,14394,'ko','ë§Œë“¤ê¸° ì‘ìš© í”„ë¡œê·¸ëž¨ ê³ ê° ì„¤ë¬¸ ì¡°ì‚¬',0),(518168,14394,'he','×¦×•×¨ ×¡×§×¨ ×œ×§×•×—×•×ª ×©×œ ×™×™×©×•×',0),(518169,14394,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î¼Î¹Î± ÎµÏ†Î±ÏÎ¼Î¿Î³Î® Ï€ÎµÎ»Î¬Ï„Î· Î­ÏÎµÏ…Î½Î±',0),(518170,14394,'zh','åˆ›å»ºåº”ç”¨ç¨‹åºå®¢æˆ·è°ƒæŸ¥',0),(518171,14394,'sv','Skapa en ansÃ¶kan kundenkÃ¤t',0),(518172,14394,'it','Creare un\'applicazione Customer Survey',0),(518173,14394,'tl','',0),(518174,14394,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¸ªà¸³à¸£à¸§à¸ˆà¸¥à¸¹à¸à¸„à¹‰à¸²à¸‚à¸­à¸‡à¹à¸­à¸žà¸¥à¸´à¹€à¸„à¸Šà¸±à¸™',0),(518175,14394,'hi','à¤à¤• à¤†à¤µà¥‡à¤¦à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤¬à¤¨à¤¾à¤à¤',0),(518176,14394,'ms','Membuat kaji selidik pelanggan permohonan untuk',0),(518177,14394,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¥Ø¬Ø±Ø§Ø¡ Ù…Ø³Ø­ ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(518178,14394,'fr','CrÃ©er une Application client enquÃªte',0),(518179,14394,'jp','ä½œæˆã€ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã®é¡§å®¢èª¿æŸ»',0),(518180,14394,'pt','Criar uma aplicativo cliente pesquisa',0),(518181,14394,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð¾Ð¿Ñ€Ð¾Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¹',0),(518182,14394,'es','Crear una aplicaciÃ³n cliente encuesta',0),(518183,14394,'de','Erstellen einer Anwendung-Kundenbefragung',0),(518184,14394,'en','Create An Application Customer Survey',0),(518185,14395,'is','',0),(518186,14395,'dr','Ø§Ù„Ø­Ø§Ù‚',0),(518187,14395,'pr','Ø§Ù„Ø­Ø§Ù‚',0),(518188,14395,'tr','Sonuna ekle',0),(518189,14395,'pl','DoÅ‚Ä…cz',0),(518190,14395,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(518191,14395,'ur','Ø§Ù„Ø­Ø§Ù‚ Ú©Ø±ÛŒÚº',0),(518192,14395,'sr','Ð—Ð° Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐµ',0),(518193,14395,'vi','Phá»¥ thÃªm',0),(518194,14395,'af','Voeg',0),(518195,14395,'ro','AdÄƒugare',0),(518196,14395,'et','Lisa lÃµppu',0),(518197,14395,'si','Dodajanje',0),(518198,14395,'ba','Menambahkan',0),(518199,14395,'nl','Toevoegen',0),(518200,14395,'fi','LiitÃ¤',0),(518201,14395,'no','TilfÃ¸y',0),(518202,14395,'da','FÃ¸j',0),(518203,14395,'ko','ì¶”ê°€',0),(518204,14395,'he','×¦×¨×£',0),(518205,14395,'el','Î ÏÎ¿ÏƒÎ¬ÏÏ„Î·ÏƒÎ·',0),(518206,14395,'zh','è¿½åŠ ',0),(518207,14395,'sv','LÃ¤gg till',0),(518208,14395,'it','Accodare',0),(518209,14395,'tl','',0),(518210,14395,'th','à¸œà¸™à¸§à¸',0),(518211,14395,'hi','à¤ªà¥€à¤›à¥‡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(518212,14395,'ms','Tambah',0),(518213,14395,'ar','Ø¥Ù„Ø­Ø§Ù‚',0),(518214,14395,'fr','Ajouter',0),(518215,14395,'jp','è¿½åŠ ',0),(518216,14395,'pt','Acrescentar',0),(518217,14395,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(518218,14395,'es','Anexar',0),(518219,14395,'de','AnfÃ¼gen',0),(518220,14395,'en','Append',0),(518221,14396,'is','',0),(518222,14396,'dr','Ø­Ø§Ù„Øª',0),(518223,14396,'pr','Ø­Ø§Ù„Øª',0),(518224,14396,'tr','Modu',0),(518225,14396,'pl','Tryb',0),(518226,14396,'bg','Ð ÐµÐ¶Ð¸Ð¼',0),(518227,14396,'ur','Ù…ÙˆÚˆ',0),(518228,14396,'sr','Ð ÐµÐ¶Ð¸Ð¼',0),(518229,14396,'vi','Cháº¿ Ä‘á»™',0),(518230,14396,'af','Modus',0),(518231,14396,'ro','Modul de',0),(518232,14396,'et','ReÅ¾iim',0),(518233,14396,'si','NaÄin',0),(518234,14396,'ba','Modus',0),(518235,14396,'nl','Modus',0),(518236,14396,'fi','Tila',0),(518237,14396,'no','Modus',0),(518238,14396,'da','Mode',0),(518239,14396,'ko','ëª¨ë“œ',0),(518240,14396,'he','×ž×¦×‘',0),(518241,14396,'el','Î›ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(518242,14396,'zh','æ¨¡å¼',0),(518243,14396,'sv','LÃ¤ge',0),(518244,14396,'it','ModalitÃ ',0),(518245,14396,'tl','',0),(518246,14396,'th','à¹‚à¸«à¸¡à¸”',0),(518247,14396,'hi','à¤®à¥‹à¤¡',0),(518248,14396,'ms','Mod',0),(518249,14396,'ar','ÙˆØ¶Ø¹',0),(518250,14396,'fr','Mode',0),(518251,14396,'jp','ãƒ¢ãƒ¼ãƒ‰',0),(518252,14396,'pt','Modo',0),(518253,14396,'ru','Ð ÐµÐ¶Ð¸Ð¼',0),(518254,14396,'es','Modo',0),(518255,14396,'de','Modus',0),(518256,14396,'en','Mode',0),(518257,14397,'is','',0),(518258,14397,'dr','Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†',0),(518259,14397,'pr','Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†',0),(518260,14397,'tr','DeÄŸiÅŸtir',0),(518261,14397,'pl','ZamieÅ„',0),(518262,14397,'bg','Ð—Ð°Ð¼ÐµÐ½Ð¸',0),(518263,14397,'ur','Ø¨Ø¯Ù„ Ø¯ÛŒÚº',0),(518264,14397,'sr','Ð—Ð°Ð¼ÐµÐ½Ð¸',0),(518265,14397,'vi','Thay tháº¿',0),(518266,14397,'af','Vervang',0),(518267,14397,'ro','ÃŽnlocui',0),(518268,14397,'et','Asenda',0),(518269,14397,'si','Zamenjaj',0),(518270,14397,'ba','Menggantikan',0),(518271,14397,'nl','Vervangen',0),(518272,14397,'fi','Korvaa',0),(518273,14397,'no','Erstatt',0),(518274,14397,'da','Erstat',0),(518275,14397,'ko','ë°”ê¾¸ê¸°',0),(518276,14397,'he','×”×—×œ×£',0),(518277,14397,'el','Î‘Î½Ï„Î¹ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(518278,14397,'zh','æ›¿æ¢',0),(518279,14397,'sv','ErsÃ¤tt',0),(518280,14397,'it','Sostituire',0),(518281,14397,'tl','',0),(518282,14397,'th','à¹à¸—à¸™',0),(518283,14397,'hi','à¤•à¥€ à¤œà¤—à¤¹',0),(518284,14397,'ms','Menggantikan',0),(518285,14397,'ar','Ø§Ø³ØªØ¨Ø¯Ø§Ù„',0),(518286,14397,'fr','Remplacer',0),(518287,14397,'jp','ç½®æ›',0),(518288,14397,'pt','Substituir',0),(518289,14397,'ru','Ð—Ð°Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(518290,14397,'es','Reemplazar',0),(518291,14397,'de','Ersetzen',0),(518292,14397,'en','Replace',0),(518293,14398,'is','',0),(518294,14398,'dr','Ø§ÛŒØ§Ù„Ø§Øª',0),(518295,14398,'pr','Ø§ÛŒØ§Ù„Ø§Øª',0),(518296,14398,'tr','BirleÅŸik',0),(518297,14398,'pl','PaÅ„stwa',0),(518298,14398,'bg','Ð§Ð»ÐµÐ½ÐºÐ¸',0),(518299,14398,'ur','ÛØ§Ø¦Û’',0),(518300,14398,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð°',0),(518301,14398,'vi','Ká»³',0),(518302,14398,'af','State',0),(518303,14398,'ro','Statele',0),(518304,14398,'et','Riikide',0),(518305,14398,'si','DrÅ¾ave',0),(518306,14398,'ba','Serikat',0),(518307,14398,'nl','Staten',0),(518308,14398,'fi','Valtioiden',0),(518309,14398,'no','Stater',0),(518310,14398,'da','Stater',0),(518311,14398,'ko','ìƒíƒœ',0),(518312,14398,'he','×”×‘×¨×™×ª',0),(518313,14398,'el','ÎœÎ­Î»Î·',0),(518314,14398,'zh','å›½å®¶',0),(518315,14398,'sv','Staterna',0),(518316,14398,'it','Stati',0),(518317,14398,'tl','',0),(518318,14398,'th','à¸­à¹€à¸¡à¸£à¸´à¸à¸²',0),(518319,14398,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾',0),(518320,14398,'ms','Negeri-Negeri',0),(518321,14398,'ar','Ø§Ù„Ø¯ÙˆÙ„',0),(518322,14398,'fr','Ã‰tats',0),(518323,14398,'jp','çŠ¶æ…‹',0),(518324,14398,'pt','Estados-Membros',0),(518325,14398,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð°',0),(518326,14398,'es','Estados',0),(518327,14398,'de','Staaten',0),(518328,14398,'en','States',0),(518329,14399,'is','',0),(518330,14399,'dr','Ù†ÛŒØ§Ø² Ø§ÛŒØ§Ù„Ø§Øª Ø­Ø±ÙˆÙ Ø¨Ø±ÙˆØ²',0),(518331,14399,'pr','Ù†ÛŒØ§Ø² Ø§ÛŒØ§Ù„Ø§Øª Ø­Ø±ÙˆÙ Ø¨Ø±ÙˆØ²',0),(518332,14399,'tr','BirleÅŸik harfleri gÃ¼ncelleme gerekir',0),(518333,14399,'pl','PaÅ„stwa muszÄ… inicjaÅ‚y aktualizowane',0),(518334,14399,'bg','Ð§Ð»ÐµÐ½ÐºÐ¸ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ð»Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½',0),(518335,14399,'ur','Ø§Ù…Ø±ÛŒÚ©Û Ù…ÛŒÚº Ù…Ø®ØªØµØ± Ø¯Ø³ØªØ®Ø· Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(518336,14399,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð° Ñ‚Ñ€ÐµÐ±Ð° Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð»Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(518337,14399,'vi','Ká»³ cáº§n táº¯t Cáº­p Nháº­t',0),(518338,14399,'af','State moet voorletters bygewerk',0),(518339,14399,'ro','Statele trebuie iniÅ£ialele actualizat',0),(518340,14399,'et','Peavad panema uuendatud initsiaalid',0),(518341,14399,'si','ÄŒlanice morajo zaÄetnice posodobljen',0),(518342,14399,'ba','Negara perlu inisial Diperbarui',0),(518343,14399,'nl','Staten moeten initialen bijgewerkt',0),(518344,14399,'fi','Valtioiden on pÃ¤ivitetty nimikirjaimet',0),(518345,14399,'no','USA trenger initialer oppdatert',0),(518346,14399,'da','Stater behÃ¸ver initialer opdateret',0),(518347,14399,'ko','êµ­ê°€ ì´ë‹ˆì…œ ì—…ë°ì´íŠ¸ í•„ìš”',0),(518348,14399,'he','×”×‘×¨×™×ª ×¦×¨×™×›×” ×œ×¢×“×›×Ÿ ××ª ×¨××©×™ ×”×ª×™×‘×•×ª',0),(518349,14399,'el','ÎœÎ­Î»Î· Ï€ÏÎ­Ï€ÎµÎ¹ Î±ÏÏ‡Î¹ÎºÎ¬ Î½Î± ÎµÎ½Î·Î¼ÎµÏÏ‰Î¸ÎµÎ¯',0),(518350,14399,'zh','å„å›½éœ€è¦æ›´æ–°çš„ç¼©å†™',0),(518351,14399,'sv','Staterna mÃ¥ste initialer uppdaterad',0),(518352,14399,'it','Gli Stati devono iniziali aggiornate',0),(518353,14399,'tl','',0),(518354,14399,'th','à¸­à¹€à¸¡à¸£à¸´à¸à¸²à¸ˆà¸³à¹€à¸›à¹‡à¸™à¸Šà¸·à¹ˆà¸­à¸¢à¹ˆà¸­à¸—à¸µà¹ˆà¸–à¸¹à¸à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(518355,14399,'hi','à¤°à¤¾à¤œà¥à¤¯à¥‹à¤‚ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥ˆ à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤ªà¥à¤°à¤¥à¤®à¤¾à¤•à¥à¤·à¤°',0),(518356,14399,'ms','Syarikat perlu singkatan yang dikemaskini',0),(518357,14399,'ar','Ø§Ù„Ø¯ÙˆÙ„ Ø¨Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰ ØªØ­Ø¯ÙŠØ«Ù‡Ø§ Ø¨Ø§Ù„Ø£Ø­Ø±Ù Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(518358,14399,'fr','Les Ã‰tats doivent initiales mis Ã  jour',0),(518359,14399,'jp','çŠ¶æ…‹æ›´æ–°ã®ã‚¤ãƒ‹ã‚·ãƒ£ãƒ«å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(518360,14399,'pt','Estados-Membros tÃªm iniciais atualizadas',0),(518361,14399,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ð»Ñ‹',0),(518362,14399,'es','Los Estados necesitan iniciales actualizadas',0),(518363,14399,'de','Staaten brauchen Initialen aktualisiert',0),(518364,14399,'en','States Need Initials Updated',0),(518365,14400,'is','',0),(518366,14400,'dr','Ú†Ú© Ú©Ø±Ø¯Ù† Ú©Ø³Ø¨ Ùˆ Ú©Ø§Ø±',0),(518367,14400,'pr','Ú†Ú© Ú©Ø±Ø¯Ù† Ú©Ø³Ø¨ Ùˆ Ú©Ø§Ø±',0),(518368,14400,'tr','Ä°ÅŸ denetleme',0),(518369,14400,'pl','Biznesowe konto czekowe',0),(518370,14400,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ñ‚Ð°',0),(518371,14400,'ur','Ú©Ø§Ø±ÙˆØ¨Ø§Ø± Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(518372,14400,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° Ð¿Ð¾ÑÐ»Ð¾Ð²Ð½Ðµ',0),(518373,14400,'vi','Dá»‹ch vá»¥ doanh nhÃ¢n kiá»ƒm tra',0),(518374,14400,'af','Besigheid kontroleer',0),(518375,14400,'ro','Afaceri de verificare',0),(518376,14400,'et','EttevÃµtete kontrollimine',0),(518377,14400,'si','Preverjanje poslovne',0),(518378,14400,'ba','Memeriksa bisnis',0),(518379,14400,'nl','Bedrijf controleren',0),(518380,14400,'fi','Liike tarkistaa',0),(518381,14400,'no','Sjekkonto for bedrifter',0),(518382,14400,'da','Business kontrol',0),(518383,14400,'ko','ë¹„ì¦ˆë‹ˆìŠ¤ ì²´í‚¹',0),(518384,14400,'he','×‘×“×™×§×ª ×¢×¡×§×™×',0),(518385,14400,'el','Î¤Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Ï„Î·Ï‚ ÎµÏ€Î¹Ï‡ÎµÎ¯ÏÎ·ÏƒÎ·Ï‚',0),(518386,14400,'zh','ä¸šåŠ¡æ£€æŸ¥',0),(518387,14400,'sv','Kontroll av verksamheten',0),(518388,14400,'it','Affari controllando',0),(518389,14400,'tl','',0),(518390,14400,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸˜à¸¸à¸£à¸à¸´à¸ˆ',0),(518391,14400,'hi','à¤•à¤¾à¤°à¥‹à¤¬à¤¾à¤° à¤•à¥€ à¤œà¤¾à¤à¤š',0),(518392,14400,'ms','Mendaftar perniagaan',0),(518393,14400,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø£Ø¹Ù…Ø§Ù„',0),(518394,14400,'fr','VÃ©rification de l\'entreprise',0),(518395,14400,'jp','ãƒ“ã‚¸ãƒã‚¹ã‚’ãƒã‚§ãƒƒã‚¯',0),(518396,14400,'pt','VerificaÃ§Ã£o de negÃ³cio',0),(518397,14400,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð±Ð¸Ð·Ð½ÐµÑÐ°',0),(518398,14400,'es','ComprobaciÃ³n de negocios',0),(518399,14400,'de','GeschÃ¤ft Ã¼berprÃ¼fen',0),(518400,14400,'en','Business Checking',0),(518401,14401,'is','',0),(518402,14401,'dr','Ø§Ø®Ø·Ø§Ø± Ù†Ù‡Ø§ÛŒÛŒ',0),(518403,14401,'pr','Ø§Ø®Ø·Ø§Ø± Ù†Ù‡Ø§ÛŒÛŒ',0),(518404,14401,'tr','Son haklarÄ±',0),(518405,14401,'pl','Ostatnie powiadomienie',0),(518406,14401,'bg','ÐšÑ€Ð°Ð¹Ð½Ð°Ñ‚Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(518407,14401,'ur','Ø­ØªÙ…ÛŒ Ù†ÙˆÙ¹Ø³',0),(518408,14401,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐµ ÑƒÐ¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ',0),(518409,14401,'vi','ThÃ´ng bÃ¡o cuá»‘i cÃ¹ng',0),(518410,14401,'af','Finale kennisgewing',0),(518411,14401,'ro','Notificarea finalÄƒ',0),(518412,14401,'et','LÃµplik teade',0),(518413,14401,'si','KonÄno obvestilo',0),(518414,14401,'ba','Final Notice',0),(518415,14401,'nl','Final Notice',0),(518416,14401,'fi','Lopullisen tiedonannon',0),(518417,14401,'no','Siste varsel',0),(518418,14401,'da','Afsluttende meddelelse',0),(518419,14401,'ko','ìµœì¢… ì£¼ì˜ ì‚¬í•­',0),(518420,14401,'he','×”×ª×¨××” ××—×¨×•× ×”',0),(518421,14401,'el','Î¤ÎµÎ»Î¹ÎºÎ® Î±Î½Î±ÎºÎ¿Î¯Î½Ï‰ÏƒÎ·',0),(518422,14401,'zh','æœ€åŽé€šçŸ¥',0),(518423,14401,'sv','Sista anmÃ¤lan',0),(518424,14401,'it','Avviso finale',0),(518425,14401,'tl','',0),(518426,14401,'th','à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢à¸›à¸£à¸°à¸à¸²à¸¨',0),(518427,14401,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¸à¥‚à¤šà¤¨à¤¾',0),(518428,14401,'ms','Notis akhir',0),(518429,14401,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ù†Ù‡Ø§Ø¦ÙŠ',0),(518430,14401,'fr','Avis final',0),(518431,14401,'jp','æœ€çµ‚é€šçŸ¥',0),(518432,14401,'pt','Aviso final',0),(518433,14401,'ru','Ð—Ð°ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(518434,14401,'es','Aviso final',0),(518435,14401,'de','Letzte Mahnung',0),(518436,14401,'en','Final Notice',0),(518437,14402,'is','',0),(518438,14402,'dr','Ø§ÙˆÙ„ Ù…ØªÙˆØ¬Ù‡',0),(518439,14402,'pr','Ø§ÙˆÙ„ Ù…ØªÙˆØ¬Ù‡',0),(518440,14402,'tr','Ä°lk duyuru',0),(518441,14402,'pl','Pierwsze zawiadomienie',0),(518442,14402,'bg','ÐŸÑŠÑ€Ð²Ð°Ñ‚Ð° Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(518443,14402,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ù†ÙˆÙ¹Ø³',0),(518444,14402,'sr','ÐŸÑ€Ð²Ð¾ ÑƒÐ¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ',0),(518445,14402,'vi','ThÃ´ng bÃ¡o Ä‘áº§u tiÃªn',0),(518446,14402,'af','Eerste kennisgewing',0),(518447,14402,'ro','Primul anunÅ£',0),(518448,14402,'et','Esimene teade',0),(518449,14402,'si','Prvo obvestilo',0),(518450,14402,'ba','Pemberitahuan pertama',0),(518451,14402,'nl','Eerste aankondiging',0),(518452,14402,'fi','EnsimmÃ¤inen ilmoitus',0),(518453,14402,'no','FÃ¸rste varsel',0),(518454,14402,'da','FÃ¸rste bekendtgÃ¸relse',0),(518455,14402,'ko','ì²« ë²ˆì§¸ ì˜ˆ ê³ ',0),(518456,14402,'he','×”×•×“×¢×” ×¨××©×•× ×”',0),(518457,14402,'el','Î ÏÏŽÏ„Î· Î±Î½Î±ÎºÎ¿Î¯Î½Ï‰ÏƒÎ·',0),(518458,14402,'zh','ç¬¬ä¸€æ¬¡é€šçŸ¥',0),(518459,14402,'sv','FÃ¶rsta meddelande',0),(518460,14402,'it','Primo avviso',0),(518461,14402,'tl','',0),(518462,14402,'th','à¸›à¸£à¸°à¸à¸²à¸¨à¸„à¸£à¸±à¹‰à¸‡à¹à¸£à¸',0),(518463,14402,'hi','à¤ªà¤¹à¤²à¤¾ à¤¨à¥‹à¤Ÿà¤¿à¤¸',0),(518464,14402,'ms','Notis pertama',0),(518465,14402,'ar','Ø§Ù„Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø£ÙˆÙ„',0),(518466,14402,'fr','Premier avis',0),(518467,14402,'jp','æœ€åˆã®é€šçŸ¥',0),(518468,14402,'pt','Primeiro aviso',0),(518469,14402,'ru','ÐŸÐµÑ€Ð²Ð¾Ðµ Ð¸Ð·Ð²ÐµÑ‰ÐµÐ½Ð¸Ðµ',0),(518470,14402,'es','Primer aviso',0),(518471,14402,'de','Erste Mitteilung',0),(518472,14402,'en','First Notice',0),(518473,14403,'is','',0),(518474,14403,'dr','Ø§Ø®Ø·Ø§Ø± Ø¯ÙˆÙ…',0),(518475,14403,'pr','Ø§Ø®Ø·Ø§Ø± Ø¯ÙˆÙ…',0),(518476,14403,'tr','Ä°kinci duyuru',0),(518477,14403,'pl','Drugie ogÅ‚oszenie',0),(518478,14403,'bg','Ð’Ñ‚Ð¾Ñ€Ð°Ñ‚Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(518479,14403,'ur','Ø¯ÙˆØ³Ø±Û’ Ù†ÙˆÙ¹Ø³',0),(518480,14403,'sr','Ð”Ñ€ÑƒÐ³Ð¾ ÑƒÐ¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ',0),(518481,14403,'vi','ThÃ´ng bÃ¡o thá»© hai',0),(518482,14403,'af','Tweede kennisgewing',0),(518483,14403,'ro','Al doilea anunÅ£',0),(518484,14403,'et','Teine teade',0),(518485,14403,'si','Drugo obvestilo',0),(518486,14403,'ba','Pemberitahuan kedua',0),(518487,14403,'nl','Tweede aankondiging',0),(518488,14403,'fi','Toisella',0),(518489,14403,'no','Andre varsel',0),(518490,14403,'da','Anden meddelelse',0),(518491,14403,'ko','ë‘ ë²ˆì§¸ ì˜ˆ ê³ ',0),(518492,14403,'he','×”×•×“×¢×” ×©× ×™×™×”',0),(518493,14403,'el','Î”ÎµÏÏ„ÎµÏÎ· Î±Î½Î±ÎºÎ¿Î¯Î½Ï‰ÏƒÎ·',0),(518494,14403,'zh','ç¬¬äºŒæ¬¡é€šçŸ¥',0),(518495,14403,'sv','Andra mÃ¤rker',0),(518496,14403,'it','Secondo avviso',0),(518497,14403,'tl','',0),(518498,14403,'th','à¸›à¸£à¸°à¸à¸²à¸¨à¸—à¸µà¹ˆà¸ªà¸­à¸‡',0),(518499,14403,'hi','à¤¦à¥‚à¤¸à¤°à¥€ à¤¨à¥‹à¤Ÿà¤¿à¤¸',0),(518500,14403,'ms','Notis kedua',0),(518501,14403,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø«Ø§Ù†ÙŠØ©',0),(518502,14403,'fr','DeuxiÃ¨me avis',0),(518503,14403,'jp','2 ç•ªç›®ã®ãŠçŸ¥ã‚‰ã›',0),(518504,14403,'pt','Segundo aviso',0),(518505,14403,'ru','Ð’Ñ‚Ð¾Ñ€Ð¾Ðµ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ',0),(518506,14403,'es','Segundo aviso',0),(518507,14403,'de','Zweite Bekanntmachung',0),(518508,14403,'en','Second Notice',0),(518509,14404,'is','',0),(518510,14404,'dr','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø³Ø§Ø¨Ù‚Ù‡',0),(518511,14404,'pr','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø³Ø§Ø¨Ù‚Ù‡',0),(518512,14404,'tr','Hesap numarasÄ± aynÄ± olmalÄ±dÄ±r',0),(518513,14404,'pl','Numery kont musi odpowiadaÄ‡',0),(518514,14404,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ²Ð¿Ð°Ð´Ð° Ñ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(518515,14404,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø³Û’ Ù…Ø´Ø§Ø¨Û ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(518516,14404,'sr','Ð‘Ñ€Ð¾Ñ˜ÐµÐ²Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð¼Ð¾Ñ€Ð°Ñ˜Ñƒ Ð´Ð° ÑÐµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ',0),(518517,14404,'vi','Sá»‘ tÃ i khoáº£n pháº£i phÃ¹ há»£p vá»›i',0),(518518,14404,'af','Rekeningnommers moet ooreenstem',0),(518519,14404,'ro','Numerele de cont trebuie sÄƒ corespundÄƒ',0),(518520,14404,'et','Kontonumbrite tuleb Ã¼hti',0),(518521,14404,'si','Å tevilke raÄunov morajo tekme',0),(518522,14404,'ba','Nomor rekening harus cocok',0),(518523,14404,'nl','Rekeningnummers moet overeenkomen met',0),(518524,14404,'fi','Tilinumerot on vastattava',0),(518525,14404,'no','Kontonummer mÃ¥ samsvare med',0),(518526,14404,'da','Kontonumre bÃ¸r matche',0),(518527,14404,'ko','ê³„ì¢Œ ë²ˆí˜¸ì™€ ì¼ì¹˜ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(518528,14404,'he','×ž×¡×¤×¨×™ ×”×—×©×‘×•×Ÿ ×—×™×™×‘ ×œ×”×ª××™×',0),(518529,14404,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î¼Îµ Î±ÏÎ¹Î¸Î¼Î¿ÏÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(518530,14404,'zh','å¸æˆ·å·ç å¿…é¡»ä¸ŽåŒ¹é…',0),(518531,14404,'sv','Kontonummer mÃ¥ste matcha',0),(518532,14404,'it','Numeri di conto devono corrispondere',0),(518533,14404,'tl','',0),(518534,14404,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µà¸•à¹‰à¸­à¸‡à¸•à¸£à¸‡à¸à¸±à¸š',0),(518535,14404,'hi','à¤–à¤¾à¤¤à¤¾ à¤¨à¤‚à¤¬à¤° à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(518536,14404,'ms','Nombor-nombor akaun mesti sepadan dengan',0),(518537,14404,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ø£Ø±Ù‚Ø§Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(518538,14404,'fr','NumÃ©ros de compte doivent correspondre',0),(518539,14404,'jp','å£åº§ç•ªå·ã«ä¸€è‡´ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(518540,14404,'pt','NÃºmeros de conta devem corresponder',0),(518541,14404,'ru','ÐÐ¾Ð¼ÐµÑ€Ð° ÑÑ‡ÐµÑ‚Ð¾Ð² Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¾Ð²Ð°Ñ‚ÑŒ',0),(518542,14404,'es','Debe coincidir con el nÃºmero de cuenta',0),(518543,14404,'de','Kontonummern mÃ¼ssen Ã¼bereinstimmen',0),(518544,14404,'en','Account Numbers Must Match',0),(518545,14405,'is','',0),(518546,14405,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ',0),(518547,14405,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ',0),(518548,14405,'tr','Banka hesabÄ± ekleme',0),(518549,14405,'pl','DodaÄ‡ konto bankowe',0),(518550,14405,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(518551,14405,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(518552,14405,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(518553,14405,'vi','ThÃªm tÃ i khoáº£n ngÃ¢n hÃ ng',0),(518554,14405,'af','Voeg bankrekening',0),(518555,14405,'ro','AdÄƒugaÅ£i contul bancar',0),(518556,14405,'et','Panga konto lisamine',0),(518557,14405,'si','Dodati banÄni raÄun',0),(518558,14405,'ba','Menambahkan rekening Bank',0),(518559,14405,'nl','Bank Account toevoegen',0),(518560,14405,'fi','LisÃ¤Ã¤ pankkitili',0),(518561,14405,'no','Legge til bankkonto',0),(518562,14405,'da','TilfÃ¸je bankkonto',0),(518563,14405,'ko','ì€í–‰ ê³„ì¢Œë¥¼ ì¶”ê°€',0),(518564,14405,'he','×”×•×¡×£ ××ª ×—×©×‘×•×Ÿ ×”×‘× ×§',0),(518565,14405,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(518566,14405,'zh','æ·»åŠ é“¶è¡Œå¸æˆ·',0),(518567,14405,'sv','LÃ¤gga till bankkonto',0),(518568,14405,'it','Aggiungi conto bancario',0),(518569,14405,'tl','',0),(518570,14405,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£',0),(518571,14405,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(518572,14405,'ms','Tambah akaun Bank',0),(518573,14405,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ',0),(518574,14405,'fr','Ajouter un compte de banque',0),(518575,14405,'jp','éŠ€è¡Œå£åº§ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(518576,14405,'pt','Adicionar a conta bancÃ¡ria',0),(518577,14405,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(518578,14405,'es','AÃ±adir cuenta bancaria',0),(518579,14405,'de','Bank-Konto hinzufÃ¼gen',0),(518580,14405,'en','Add Bank Account',0),(518581,14406,'is','',0),(518582,14406,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ',0),(518583,14406,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ',0),(518584,14406,'tr','Banka hesaplarÄ±',0),(518585,14406,'pl','Rachunki bankowe',0),(518586,14406,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(518587,14406,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(518588,14406,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(518589,14406,'vi','TÃ i khoáº£n ngÃ¢n hÃ ng',0),(518590,14406,'af','Bankrekeninge',0),(518591,14406,'ro','Conturi bancare',0),(518592,14406,'et','Pangakontod',0),(518593,14406,'si','BanÄni raÄuni',0),(518594,14406,'ba','Rekening bank',0),(518595,14406,'nl','Bankrekeningen',0),(518596,14406,'fi','Pankkitilit',0),(518597,14406,'no','Bankkonti',0),(518598,14406,'da','Bankkonti',0),(518599,14406,'ko','ì€í–‰ ê³„ì¢Œ',0),(518600,14406,'he','×—×©×‘×•× ×•×ª ×‘× ×§',0),(518601,14406,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿ÏÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(518602,14406,'zh','é“¶è¡Œè´¦æˆ·',0),(518603,14406,'sv','Bankkonton',0),(518604,14406,'it','Conti bancari',0),(518605,14406,'tl','',0),(518606,14406,'th','à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£',0),(518607,14406,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‹à¤‚',0),(518608,14406,'ms','Akaun bank',0),(518609,14406,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(518610,14406,'fr','Comptes bancaires',0),(518611,14406,'jp','éŠ€è¡Œå£åº§',0),(518612,14406,'pt','Contas bancÃ¡rias',0),(518613,14406,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(518614,14406,'es','Cuentas bancarias',0),(518615,14406,'de','Bankkonten',0),(518616,14406,'en','Bank Accounts',0),(518617,14407,'is','',0),(518618,14407,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ',0),(518619,14407,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ',0),(518620,14407,'tr','Banka hesaplarÄ± yÃ¶nergeleri',0),(518621,14407,'pl','Instrukcje rachunkÃ³w bankowych',0),(518622,14407,'bg','Ð˜Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸ Ð·Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(518623,14407,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ú©Ú¾Ø§ØªÙˆÚº Ú©ÛŒ ÛØ¯Ø§ÛŒØ§Øª',0),(518624,14407,'sr','Ð£Ð¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð·Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(518625,14407,'vi','TÃ i khoáº£n ngÃ¢n hÃ ng hÆ°á»›ng dáº«n',0),(518626,14407,'af','Bankrekeninge instruksies',0),(518627,14407,'ro','InstrucÅ£iuni de conturi bancare',0),(518628,14407,'et','Pangakontode juhiseid',0),(518629,14407,'si','BanÄni raÄuni navodila',0),(518630,14407,'ba','Instruksi rekening bank',0),(518631,14407,'nl','Instructies voor bankrekeningen',0),(518632,14407,'fi','Pankkitilien ohjeet',0),(518633,14407,'no','Bankkontoer instruksjoner',0),(518634,14407,'da','Bankkonti instruktioner',0),(518635,14407,'ko','ì€í–‰ ê³„ì¢Œ ì§€ì¹¨',0),(518636,14407,'he','×”×•×¨××•×ª ×—×©×‘×•× ×•×ª ×‘× ×§',0),(518637,14407,'el','ÎŸÎ´Î·Î³Î¯ÎµÏ‚ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿ÏÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(518638,14407,'zh','é“¶è¡Œè´¦æˆ·çš„æŒ‡ç¤º',0),(518639,14407,'sv','Bankkonton instruktioner',0),(518640,14407,'it','Conti bancari istruzioni',0),(518641,14407,'tl','',0),(518642,14407,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸‚à¸­à¸‡à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£',0),(518643,14407,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‡ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(518644,14407,'ms','Arahan akaun bank',0),(518645,14407,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø­Ø³Ø§Ø¨Ø§Øª Ù…ØµØ±ÙÙŠØ©',0),(518646,14407,'fr','Instructions de comptes bancaires',0),(518647,14407,'jp','éŠ€è¡Œå£åº§ã®æŒ‡ç¤º',0),(518648,14407,'pt','InstruÃ§Ãµes de contas bancÃ¡rias',0),(518649,14407,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ ÑÑ‡ÐµÑ‚Ð° Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(518650,14407,'es','Instrucciones de cuentas bancarias',0),(518651,14407,'de','Bankkonten Anweisungen',0),(518652,14407,'en','Bank Accounts Instructions',0),(518653,14408,'is','',0),(518654,14408,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(518655,14408,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(518656,14408,'tr','Banka hesabÄ± baÅŸarÄ±yla eklendi',0),(518657,14408,'pl','PomyÅ›lnie dodano konto bankowe',0),(518658,14408,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(518659,14408,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(518660,14408,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(518661,14408,'vi','TÃ i khoáº£n ngÃ¢n hÃ ng thÃªm thÃ nh cÃ´ng',0),(518662,14408,'af','Bank rekening bygevoeg suksesvol',0),(518663,14408,'ro','Cont bancar adÄƒugat cu succes',0),(518664,14408,'et','Lisatud pangakonto',0),(518665,14408,'si','BanÄni raÄun uspeÅ¡no dodan',0),(518666,14408,'ba','Rekening bank yang ditambahkan berhasil',0),(518667,14408,'nl','Bank Account met succes toegevoegd',0),(518668,14408,'fi','Pankkitilin lisÃ¤Ã¤minen onnistui',0),(518669,14408,'no','Bankkontoen som ble lagt til',0),(518670,14408,'da','Bankkonto tilfÃ¸jet',0),(518671,14408,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ì€í–‰ ê³„ì¢Œ',0),(518672,14408,'he','×—×©×‘×•×Ÿ ×‘× ×§ × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(518673,14408,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÎ¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(518674,14408,'zh','å·²æˆåŠŸæ·»åŠ çš„é“¶è¡Œè´¦æˆ·',0),(518675,14408,'sv','Bankkonto som lagts',0),(518676,14408,'it','Bank Account aggiunto con successo',0),(518677,14408,'tl','',0),(518678,14408,'th','à¸˜à¸™à¸²à¸„à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(518679,14408,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(518680,14408,'ms','Akaun bank yang berjaya menambah',0),(518681,14408,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ Ø¥Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(518682,14408,'fr','Compte bancaire ajoutÃ© avec succÃ¨s',0),(518683,14408,'jp','éŠ€è¡Œå£åº§ãŒæ­£å¸¸ã«è¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(518684,14408,'pt','Conta bancÃ¡ria adicionada com sucesso',0),(518685,14408,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(518686,14408,'es','Cuenta bancaria se ha agregado correctamente',0),(518687,14408,'de','Bank-Konto erfolgreich hinzugefÃ¼gt',0),(518688,14408,'en','Bank Account Added Successfully',0),(518689,14409,'is','',0),(518690,14409,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ Ú©Ù…Ú©',0),(518691,14409,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ Ú©Ù…Ú©',0),(518692,14409,'tr','Banka hesap YardÄ±mÄ±',0),(518693,14409,'pl','Konto pomoc',0),(518694,14409,'bg','ÐŸÐ¾Ð¼Ð¾Ñ‰ Ð·Ð° Ð¿Ð°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°',0),(518695,14409,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù…Ø¯Ø¯',0),(518696,14409,'sr','ÐŸÐ¾Ð¼Ð¾Ñ› Ð·Ð° Ñ€Ð°Ñ‡ÑƒÐ½ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(518697,14409,'vi','Trá»£ giÃºp tÃ i khoáº£n ngÃ¢n hÃ ng',0),(518698,14409,'af','Bankrekening hulp',0),(518699,14409,'ro','Cont bancar ajutor',0),(518700,14409,'et','Pangakonto spikker',0),(518701,14409,'si','BanÄni raÄun pomoÄ',0),(518702,14409,'ba','Rekening bank bantuan',0),(518703,14409,'nl','Bankrekening Help',0),(518704,14409,'fi','Pankkitilin ohje',0),(518705,14409,'no','Bankkonto hjelp',0),(518706,14409,'da','Bank konto hjÃ¦lp',0),(518707,14409,'ko','ì€í–‰ ê³„ì • ë„ì›€ë§',0),(518708,14409,'he','×¢×–×¨×” ×‘×—×©×‘×•×Ÿ ×”×‘× ×§',0),(518709,14409,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î²Î¿Î®Î¸ÎµÎ¹Î±',0),(518710,14409,'zh','é“¶è¡Œå¸æˆ·çš„å¸®åŠ©',0),(518711,14409,'sv','Bankkonto hjÃ¤lp',0),(518712,14409,'it','Aiuto conto bancario',0),(518713,14409,'tl','',0),(518714,14409,'th','à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£',0),(518715,14409,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‡ à¤®à¤¦à¤¦',0),(518716,14409,'ms','Bantuan akaun bank',0),(518717,14409,'ar','Ù…Ø³Ø§Ø¹Ø¯Ø© Ø­Ø³Ø§Ø¨ Ù…ØµØ±ÙÙŠ',0),(518718,14409,'fr','Aide compte bancaire',0),(518719,14409,'jp','éŠ€è¡Œå£åº§ãƒ˜ãƒ«ãƒ—',0),(518720,14409,'pt','Ajuda de conta bancÃ¡ria',0),(518721,14409,'ru','Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ° ÑÑ‡ÐµÑ‚ Ð² Ð±Ð°Ð½ÐºÐµ',0),(518722,14409,'es','Ayuda de cuenta bancaria',0),(518723,14409,'de','Bankkonto-Hilfe',0),(518724,14409,'en','Bank Account Help',0),(518725,14410,'is','',0),(518726,14410,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ú©Ù…Ú© Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ',0),(518727,14410,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ Ú©Ù…Ú© Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ',0),(518728,14410,'tr','Banka hesabÄ± yardÄ±m talimatlarÄ±nÄ±',0),(518729,14410,'pl','Konto bankowe pomocy instrukcji',0),(518730,14410,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð¿Ð¾Ð¼Ð¾Ñ‰ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(518731,14410,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù…Ø¯Ø¯ ÛØ¯Ø§ÛŒØ§Øª',0),(518732,14410,'sr','Ð£Ð¿ÑƒÑ‚ÑÑ‚Ð²Ð° Ð·Ð° Ð¿Ð¾Ð¼Ð¾Ñ› Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(518733,14410,'vi','HÆ°á»›ng dáº«n trá»£ giÃºp tÃ i khoáº£n ngÃ¢n hÃ ng',0),(518734,14410,'af','Bankrekening hulp instruksies',0),(518735,14410,'ro','InstrucÅ£iuni de ajutor cont bancar',0),(518736,14410,'et','Pangakonto aidata juhiste',0),(518737,14410,'si','BanÄni raÄun pomoÄ navodila',0),(518738,14410,'ba','Petunjuk Bantuan rekening bank',0),(518739,14410,'nl','Bankrekening hulp instructies',0),(518740,14410,'fi','Pankkitilin auttaa ohjeet',0),(518741,14410,'no','Bankkonto hjelp instruksjoner',0),(518742,14410,'da','Bankkonto hjÃ¦lp instruktioner',0),(518743,14410,'ko','ì€í–‰ ê³„ì¢Œ ë„ì›€ ì§€ì¹¨',0),(518744,14410,'he','×”×•×¨××•×ª ×œ×¢×–×¨×” ×—×©×‘×•×Ÿ ×‘× ×§',0),(518745,14410,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î²Î¿Î®Î¸ÎµÎ¹Î± Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(518746,14410,'zh','é“¶è¡Œå¸æˆ·å¸®åŠ©è¯´æ˜Ž',0),(518747,14410,'sv','Bankkonto hjÃ¤lpinstruktioner',0),(518748,14410,'it','Conto bancario Help istruzioni',0),(518749,14410,'tl','',0),(518750,14410,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³à¸§à¸´à¸˜à¸µà¹ƒà¸Šà¹‰à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£',0),(518751,14410,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‡ à¤®à¤¦à¤¦ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(518752,14410,'ms','Arahan bantuan akaun bank',0),(518753,14410,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª Ù…Ø³Ø§Ø¹Ø¯Ø© Ø­Ø³Ø§Ø¨ Ù…ØµØ±ÙÙŠ',0),(518754,14410,'fr','Compte bancaire aide Instructions',0),(518755,14410,'jp','éŠ€è¡Œå£åº§ã€ãƒ˜ãƒ«ãƒ—ã®èª¬æ˜Ž',0),(518756,14410,'pt','InstruÃ§Ãµes de ajuda de conta bancÃ¡ria',0),(518757,14410,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ ÑÑ‡ÐµÑ‚ Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(518758,14410,'es','Cuenta bancaria ayuda instrucciones',0),(518759,14410,'de','Bankkonto-Hilfe-Anleitungen',0),(518760,14410,'en','Bank Account Help Instructions',0),(518761,14411,'is','',0),(518762,14411,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(518763,14411,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(518764,14411,'tr','Banka hesabÄ± baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(518765,14411,'pl','Konto bankowe pomyÅ›lnie zaktualizowana',0),(518766,14411,'bg','ÐŸÐ°Ñ€Ð¸Ñ‡Ð½Ð¸ ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð°, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(518767,14411,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(518768,14411,'sr','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(518769,14411,'vi','TÃ i khoáº£n ngÃ¢n hÃ ng Cáº­p Nháº­t thÃ nh cÃ´ng',0),(518770,14411,'af','Bankrekening suksesvol bygewerk',0),(518771,14411,'ro','Cont bancar actualizat cu succes',0),(518772,14411,'et','VÃ¤rskendatud pangakonto',0),(518773,14411,'si','BanÄni raÄun uspeÅ¡no posodobljena',0),(518774,14411,'ba','Rekening bank yang berhasil',0),(518775,14411,'nl','Bankrekening bijgewerkt',0),(518776,14411,'fi','Pankkitilin pÃ¤ivitetty',0),(518777,14411,'no','Bankkontoen som er oppdatert',0),(518778,14411,'da','Bank konto opdateret',0),(518779,14411,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì€í–‰ ê³„ì¢Œ',0),(518780,14411,'he','×—×©×‘×•×Ÿ ×”×‘× ×§ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(518781,14411,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(518782,14411,'zh','é“¶è¡Œå¸æˆ·å·²æˆåŠŸæ›´æ–°',0),(518783,14411,'sv','Bankkonto som uppdaterats',0),(518784,14411,'it','Conto bancario aggiornato con successo',0),(518785,14411,'tl','',0),(518786,14411,'th','à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(518787,14411,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(518788,14411,'ms','Akaun bank yang dikemaskini berjaya',0),(518789,14411,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ Ø¨Ù†Ø¬Ø§Ø­ ØªØ­Ø¯ÙŠØ«',0),(518790,14411,'fr','Compte bancaire mis Ã  jour avec succÃ¨s',0),(518791,14411,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸéŠ€è¡Œå£åº§',0),(518792,14411,'pt','Conta bancÃ¡ria atualizada com sucesso',0),(518793,14411,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ ÑÑ‡ÐµÑ‚, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(518794,14411,'es','Cuenta bancaria actualizada',0),(518795,14411,'de','Bank-Konto erfolgreich aktualisiert',0),(518796,14411,'en','Bank Account Updated Successfully',0),(518797,14412,'is','',0),(518798,14412,'dr','ØªØ§ÛŒÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨',0),(518799,14412,'pr','ØªØ§ÛŒÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨',0),(518800,14412,'tr','Hesap numarasÄ±nÄ± onaylamak',0),(518801,14412,'pl','PotwierdÅº numer konta',0),(518802,14412,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(518803,14412,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(518804,14412,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(518805,14412,'vi','XÃ¡c nháº­n sá»‘ tÃ i khoáº£n',0),(518806,14412,'af','Rekening nommer bevestig',0),(518807,14412,'ro','Confirma numÄƒrul de cont',0),(518808,14412,'et','Kinnitage konto Number',0),(518809,14412,'si','Potrditev Å¡tevilka raÄuna',0),(518810,14412,'ba','Konfirmasikan nomor akun',0),(518811,14412,'nl','Rekeningnummer bevestigen',0),(518812,14412,'fi','Vahvista tilin numero',0),(518813,14412,'no','Kontroller kontonummeret',0),(518814,14412,'da','BekrÃ¦fte kontonummer',0),(518815,14412,'ko','ê³„ì¢Œ ë²ˆí˜¸ í™•ì¸',0),(518816,14412,'he','×œ××©×¨ ××ª ×ž×¡×¤×¨ ×”×—×©×‘×•×Ÿ',0),(518817,14412,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎµÎ¹ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(518818,14412,'zh','ç¡®è®¤å¸æˆ·å·ç ',0),(518819,14412,'sv','BekrÃ¤fta kontonummer',0),(518820,14412,'it','Confermare il numero di conto',0),(518821,14412,'tl','',0),(518822,14412,'th','à¸¢à¸·à¸™à¸¢à¸±à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µ',0),(518823,14412,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(518824,14412,'ms','Mengesahkan nombor akaun',0),(518825,14412,'ar','ØªØ£ÙƒÙŠØ¯ Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(518826,14412,'fr','Confirmer le numÃ©ro de compte',0),(518827,14412,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå·ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(518828,14412,'pt','Confirmar o nÃºmero da conta',0),(518829,14412,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°',0),(518830,14412,'es','Confirmar el nÃºmero de cuenta',0),(518831,14412,'de','Kontonummer zu bestÃ¤tigen',0),(518832,14412,'en','Confirm Account Number',0),(518833,14413,'is','',0),(518834,14413,'dr','Ù†Ø§Ù… Ø­Ø³Ø§Ø¨',0),(518835,14413,'pr','Ù†Ø§Ù… Ø­Ø³Ø§Ø¨',0),(518836,14413,'tr','Hesap adÄ±',0),(518837,14413,'pl','Nazwa konta',0),(518838,14413,'bg','Ð˜Ð¼Ðµ Ð¿Ð¾ ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð°',0),(518839,14413,'ur','Ù†Ø§Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾Ø±',0),(518840,14413,'sr','Ð˜Ð¼Ðµ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ñƒ',0),(518841,14413,'vi','TÃªn trÃªn tÃ i khoáº£n',0),(518842,14413,'af','Naam op rekening',0),(518843,14413,'ro','Nume cont',0),(518844,14413,'et','Konto nimi',0),(518845,14413,'si','Ime na raÄun',0),(518846,14413,'ba','Nama pada rekening',0),(518847,14413,'nl','Naam op Account',0),(518848,14413,'fi','Tilin nimi',0),(518849,14413,'no','Navn pÃ¥ konto',0),(518850,14413,'da','Navn pÃ¥ konto',0),(518851,14413,'ko','ê³„ì • ì´ë¦„',0),(518852,14413,'he','×©× ×—×©×‘×•×Ÿ',0),(518853,14413,'el','ÎŒÎ½Î¿Î¼Î± ÎºÎ±Î¹ Î³Î¹Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(518854,14413,'zh','å¸æˆ·åç§°',0),(518855,14413,'sv','Namn pÃ¥ konto',0),(518856,14413,'it','Nome dell\'account',0),(518857,14413,'tl','',0),(518858,14413,'th','à¸Šà¸·à¹ˆà¸­à¸šà¸±à¸à¸Šà¸µ',0),(518859,14413,'hi','à¤ªà¤° à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤¨à¤¾à¤®',0),(518860,14413,'ms','Nama akaun',0),(518861,14413,'ar','Ø§Ø³Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(518862,14413,'fr','Nom de compte',0),(518863,14413,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®åå‰',0),(518864,14413,'pt','Nome na conta',0),(518865,14413,'ru','Ð˜Ð¼Ñ Ð²Ð»Ð°Ð´ÐµÐ»ÑŒÑ†Ð° ÑÑ‡ÐµÑ‚Ð°',0),(518866,14413,'es','Nombre de cuenta',0),(518867,14413,'de','Name auf Konto',0),(518868,14413,'en','Name On Account',0),(518869,14414,'is','',0),(518870,14414,'dr','Ù†Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ù…Ø¹ØªØ¨Ø± Ù…Ø³ÛŒØ±ÛŒØ§Ø¨ÛŒ',0),(518871,14414,'pr','Ù†Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ù…Ø¹ØªØ¨Ø± Ù…Ø³ÛŒØ±ÛŒØ§Ø¨ÛŒ',0),(518872,14414,'tr','GeÃ§erli bir yÃ¶nlendirme numarasÄ±',0),(518873,14414,'pl','Nie prawidÅ‚owy numer marszruty',0),(518874,14414,'bg','ÐÐµ Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚',0),(518875,14414,'ur','Ù†ÛÛŒÚº Ø¬Ø§Ø¦Ø² Ø±ÙˆÙ¹ Ù†Ù…Ø¨Ø±',0),(518876,14414,'sr','ÐÐ¸Ñ˜Ðµ Ð²Ð°Ð¶ÐµÑ›Ð¸ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð±Ð°Ð½ÐºÐµ',0),(518877,14414,'vi','KhÃ´ng pháº£i lÃ  má»™t sá»‘ Ä‘á»‹nh tuyáº¿n há»£p lá»‡',0),(518878,14414,'af','Nie \'n geldige Routing nommer',0),(518879,14414,'ro','Nu un valabil numÄƒrul de circuit',0),(518880,14414,'et','Pole kehtiv marsruudi numbrit',0),(518881,14414,'si','Ni veljavna Å¡tevilka proizvodnega postopka',0),(518882,14414,'ba','Bukan nomor Routing yang Valid',0),(518883,14414,'nl','Niet een geldige bewerkingsplannummer',0),(518884,14414,'fi','Virheellinen reititys numero',0),(518885,14414,'no','Ikke et gyldig registreringsnummer',0),(518886,14414,'da','Ikke et gyldigt registreringsnummer',0),(518887,14414,'ko','ìœ íš¨í•œ ë¼ìš°íŒ… ë²ˆí˜¸',0),(518888,14414,'he','×œ× ×ž×¡×¤×¨ × ×™×ª×•×‘ ×—×•×§×™',0),(518889,14414,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î½Î±Ï‚ Î­Î³ÎºÏ…ÏÎ¿Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(518890,14414,'zh','ä¸æ˜¯æœ‰æ•ˆçš„è·¯ç”±æ•°å­—',0),(518891,14414,'sv','Inte ett giltigt organisationsnummer',0),(518892,14414,'it','Non un numero valido di Routing',0),(518893,14414,'tl','',0),(518894,14414,'th','à¹„à¸¡à¹ˆà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸ªà¸²à¸¢à¸‡à¸²à¸™à¸à¸²à¸£à¸œà¸¥à¸´à¸•à¸—à¸µà¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(518895,14414,'hi','à¤¨à¤¹à¥€à¤‚ à¤•à¥‹à¤ˆ à¤®à¤¾à¤¨à¥à¤¯ à¤…à¤¨à¥à¤®à¤¾à¤°à¥à¤—à¤£ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(518896,14414,'ms','Tidak penghalaan nombor yang sah',0),(518897,14414,'ar','Ù„ÙŠØ³ Ø±Ù‚Ù…Ø§Ù‹ ØµØ­ÙŠØ­Ø§Ù‹ Ø§Ù„ØªÙˆØ¬ÙŠÙ‡',0),(518898,14414,'fr','Pas un numÃ©ro de routage valide',0),(518899,14414,'jp','ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå·',0),(518900,14414,'pt','NÃ£o Ã© um nÃºmero vÃ¡lido de roteamento',0),(518901,14414,'ru','ÐÐµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð½Ð¾Ð¼ÐµÑ€ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð°',0),(518902,14414,'es','No un nÃºmero vÃ¡lido de enrutamiento',0),(518903,14414,'de','Keine gÃ¼ltige Bankleitzahl',0),(518904,14414,'en','Not A Valid Routing Number',0),(518905,14415,'is','',0),(518906,14415,'dr','Ù‡ÛŒÚ† Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(518907,14415,'pr','Ù‡ÛŒÚ† Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(518908,14415,'tr','Bulunan bir banka hesaplarÄ±',0),(518909,14415,'pl','Nie kont bankowych, Znalezione',0),(518910,14415,'bg','ÐÑÐ¼Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸',0),(518911,14415,'ur','Ú©ÙˆØ¦ÛŒ Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾Ø§ÛŒØ§',0),(518912,14415,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ñƒ Ð±Ð°Ð½Ñ†Ð¸ Ð½Ð°ÑˆÐ»Ð¸',0),(518913,14415,'vi','KhÃ´ng cÃ³ tÃ i khoáº£n ngÃ¢n hÃ ng tÃ¬m tháº¥y',0),(518914,14415,'af','Geen Bank rekeninge gevind',0),(518915,14415,'ro','Nu conturile bancare gÄƒsit',0),(518916,14415,'et','Ei leidnud pangakontod',0),(518917,14415,'si','Brez banÄnih raÄunov naÅ¡el',0),(518918,14415,'ba','No Rekening Bank yang ditemukan',0),(518919,14415,'nl','Geen Bank Accounts gevonden',0),(518920,14415,'fi','Ei ole pankkitiliÃ¤, lÃ¶ytyi',0),(518921,14415,'no','Noen bankkonto funnet',0),(518922,14415,'da','Nogen bankkonti, fandt',0),(518923,14415,'ko','ë°œê²¬ ì€í–‰ ê³„ì •ì´ ì—†ëŠ”',0),(518924,14415,'he','××™×Ÿ ×—×©×‘×•× ×•×ª ×‘× ×§ × ×ž×¦××•',0),(518925,14415,'el','Î”ÎµÎ½ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿ÏÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(518926,14415,'zh','å‘çŽ°æ²¡æœ‰é“¶è¡Œè´¦æˆ·',0),(518927,14415,'sv','Ingen bankkonton som hittade',0),(518928,14415,'it','Conti bancari non trovato',0),(518929,14415,'tl','',0),(518930,14415,'th','à¸šà¸±à¸à¸Šà¸µà¹„à¸¡à¹ˆà¸žà¸š',0),(518931,14415,'hi','à¤•à¥‹à¤ˆ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(518932,14415,'ms','Tiada akaun Bank yang ditemui',0),(518933,14415,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ù…ØµØ±ÙÙŠØ© Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(518934,14415,'fr','Aucun compte bancaire trouvÃ©',0),(518935,14415,'jp','ãªã„éŠ€è¡Œå£åº§ã‚’ç™ºè¦‹',0),(518936,14415,'pt','Sem contas bancÃ¡rias encontrado',0),(518937,14415,'ru','ÐÐ°Ð¹Ð´ÐµÐ½Ð¾ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(518938,14415,'es','No hay cuentas bancarias encontrado',0),(518939,14415,'de','Keine Bankkonten gefunden',0),(518940,14415,'en','No Bank Accounts Found',0),(518941,14416,'is','',0),(518942,14416,'dr','Ù…Ø³ÛŒØ±ÛŒØ§Ø¨ÛŒ Ø´Ù…Ø§Ø±Ù‡ 9 Ø±Ù‚Ù…ÛŒ Ø¨Ø§ÛŒØ¯',0),(518943,14416,'pr','Ù…Ø³ÛŒØ±ÛŒØ§Ø¨ÛŒ Ø´Ù…Ø§Ø±Ù‡ 9 Ø±Ù‚Ù…ÛŒ Ø¨Ø§ÛŒØ¯',0),(518944,14416,'tr','Ãœretim akÄ±ÅŸÄ± numarasÄ± 9 haneli olmalÄ±dÄ±r',0),(518945,14416,'pl','Numer marszruty musi byÄ‡ 9 cyfr',0),(518946,14416,'bg','ÐÐ¾Ð¼ÐµÑ€ÑŠÑ‚ Ð½Ð° Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ 9 Ñ†Ð¸Ñ„Ñ€Ð¸',0),(518947,14416,'ur','Ø±ÙˆÙ¹ Ù†Ù…Ø¨Ø± 9 Ø§Ø¹Ø¯Ø§Ø¯ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(518948,14416,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð½Ð¾Ð³ Ð¿Ð¾ÑÑ‚ÑƒÐ¿ÐºÐ° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ 9 Ñ†Ð¸Ñ„Ð°Ñ€Ð°',0),(518949,14416,'vi','Sá»‘ Ä‘á»‹nh tuyáº¿n pháº£i lÃ  9 chá»¯ sá»‘',0),(518950,14416,'af','Die Routing nommer 9 syfers moet wees',0),(518951,14416,'ro','NumÄƒrul de circuit trebuie sÄƒ fie 9 cifre',0),(518952,14416,'et','Marsruudi Number peab olema 9-kohaline',0),(518953,14416,'si','Å tevilka proizvodnega postopka mora biti 9 Å¡tevilk',0),(518954,14416,'ba','Nomor Routing harus 9 digit',0),(518955,14416,'nl','Nummer van het bewerkingsplan moet 9 cijfers',0),(518956,14416,'fi','Reitityksen numeron on oltava 9 numeroa',0),(518957,14416,'no','Rutenummeret mÃ¥ vÃ¦re 9 siffer',0),(518958,14416,'da','Registreringsnummeret skal bestÃ¥ af 9 cifre',0),(518959,14416,'ko','ë¼ìš°íŒ… ë²ˆí˜¸ 9 ìžë¦¬ ì—¬ì•¼ í•©ë‹ˆë‹¤.',0),(518960,14416,'he','×ž×¡×¤×¨ ×”× ×™×ª×•×‘ ×œ×”×™×•×ª 9 ×¡×¤×¨×•×ª',0),(518961,14416,'el','Î¤Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï†Î±ÏƒÎµÎ¿Î»Î¿Î³Î¯Î¿Ï… Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ 9 ÏˆÎ·Ï†Î¯Î±',0),(518962,14416,'zh','è·¯ç”±çš„æ•°é‡å¿…é¡»æ˜¯ 9 ä½æ•°',0),(518963,14416,'sv','Organisationsnumret mÃ¥ste vara 9 siffror',0),(518964,14416,'it','Il numero di percorso deve essere di 9 cifre',0),(518965,14416,'tl','',0),(518966,14416,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹€à¸ªà¹‰à¸™à¸—à¸²à¸‡à¸•à¹‰à¸­à¸‡à¹€à¸›à¹‡à¸™à¸•à¸±à¸§à¹€à¸¥à¸‚ 9 à¸«à¸¥à¸±à¸',0),(518967,14416,'hi','à¤…à¤¨à¥à¤®à¤¾à¤°à¥à¤—à¤£ à¤¸à¤‚à¤–à¥à¤¯à¤¾ 9 à¤…à¤‚à¤• à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(518968,14416,'ms','Nombor penghalaan mesti 9 digit',0),(518969,14416,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø¹Ø¯Ø¯ Ø§Ù„ØªÙˆØ¬ÙŠÙ‡ Ø±Ù‚Ù… 9',0),(518970,14416,'fr','Le numÃ©ro d\'acheminement doit Ãªtre 9 chiffres',0),(518971,14416,'jp','ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå·ã¯ 9 æ¡ã®æ•°å­—ã‚’ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(518972,14416,'pt','O nÃºmero deve ser de 9 dÃ­gitos',0),(518973,14416,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð° Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ 9 Ñ†Ð¸Ñ„Ñ€',0),(518974,14416,'es','El nÃºmero de la encaminamiento debe ser 9 dÃ­gitos',0),(518975,14416,'de','Die Bankleitzahl muss 9 Ziffern sein.',0),(518976,14416,'en','The Routing Number Must Be 9 Digits',0),(518977,14417,'is','',0),(518978,14417,'dr','Ø´Ù…Ø§ Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø§ÛŒÙ† Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ Ù†Ø¯Ø§Ø±ÛŒØ¯',0),(518979,14417,'pr','Ø´Ù…Ø§ Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø§ÛŒÙ† Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ Ù†Ø¯Ø§Ø±ÛŒØ¯',0),(518980,14417,'tr','Bu banka hesabÄ± iÃ§in eriÅŸim yok',0),(518981,14417,'pl','Nie masz dostÄ™pu do tego konta bankowego',0),(518982,14417,'bg','Ð’Ð¸Ðµ Ð½ÑÐ¼Ð°Ñ‚Ðµ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ñ‚Ð°Ð·Ð¸ Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(518983,14417,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§Ø³ Ú©Û’ Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ø­Ø§ØµÙ„ Ù†ÛÛŒÚº',0),(518984,14417,'sr','ÐÐµÐ¼Ð°Ñ‚Ðµ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(518985,14417,'vi','Báº¡n khÃ´ng cÃ³ quyá»n truy cáº­p vÃ o tÃ i khoáº£n ngÃ¢n hÃ ng',0),(518986,14417,'af','Jy het nie toegang tot hierdie bankrekening',0),(518987,14417,'ro','Nu aveÅ£i acces la acest cont bancar',0),(518988,14417,'et','Teil pole juurdepÃ¤Ã¤su selle pangakonto',0),(518989,14417,'si','Nimate dostopa za ta banÄni raÄun',0),(518990,14417,'ba','Anda tidak memiliki akses ke rekening Bank ini',0),(518991,14417,'nl','U hoeft geen toegang tot deze bankrekening',0),(518992,14417,'fi','Sinulla ei ole pÃ¤Ã¤syÃ¤ pankkitilin',0),(518993,14417,'no','Du har ikke tilgang til denne bankkontoen',0),(518994,14417,'da','Du har ikke adgang til denne bankkonto',0),(518995,14417,'ko','ì´ ì€í–‰ ê³„ì¢Œì— ëŒ€ í•œ ì•¡ì„¸ìŠ¤ë¥¼ í•˜ì§€ ì•Šì•„ë„',0),(518996,14417,'he','××™×Ÿ ×œ×š ×’×™×©×” ×œ×—×©×‘×•×Ÿ ×”×‘× ×§ ×”×–×”',0),(518997,14417,'el','Î”ÎµÎ½ Î­Ï‡ÎµÏ„Îµ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(518998,14417,'zh','æ‚¨æ²¡æœ‰è®¿é—®æ­¤é“¶è¡Œå¸æˆ·',0),(518999,14417,'sv','Du har inte tillgÃ¥ng till detta bankkonto',0),(519000,14417,'it','Non hai accesso a questo conto bancario',0),(519001,14417,'tl','',0),(519002,14417,'th','à¸„à¸¸à¸“à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£à¸™à¸µà¹‰',0),(519003,14417,'hi','à¤†à¤ª à¤‡à¤¸ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¹à¥à¤à¤š à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(519004,14417,'ms','Anda tidak mempunyai capaian ke akaun Bank ini',0),(519005,14417,'ar','Ù„ÙŠØ³ Ù„Ø¯ÙŠÙƒ Ø­Ù‚ Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ù‡Ø°Ø§ Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ',0),(519006,14417,'fr','Vous n\'avez pas accÃ¨s Ã  ce compte bancaire',0),(519007,14417,'jp','ã“ã®éŠ€è¡Œå£åº§ã¸ã®ã‚¢ã‚¯ã‚»ã‚¹ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(519008,14417,'pt','VocÃª nÃ£o tem acesso Ã  conta bancÃ¡ria',0),(519009,14417,'ru','Ð’Ñ‹ Ð½Ðµ Ð¸Ð¼ÐµÑŽÑ‚ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ðº ÑÑ‚Ð¾Ð¼Ñƒ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð¼Ñƒ ÑÑ‡ÐµÑ‚Ñƒ',0),(519010,14417,'es','Usted no tiene acceso a esta cuenta bancaria',0),(519011,14417,'de','Sie keinen Zugriff auf dieses Bankkonto',0),(519012,14417,'en','You Do Not Have Access To This Bank Account',0),(519013,14418,'is','',0),(519014,14418,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(519015,14418,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(519016,14418,'tr','Bir hesap numarasÄ± girmeniz gerekir',0),(519017,14418,'pl','NaleÅ¼y wprowadziÄ‡ numer konta',0),(519018,14418,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(519019,14418,'ur','Ø¢Ù¾ Ú©Ø§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(519020,14418,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð±Ñ€Ð¾Ñ˜ ÐºÐ¾Ð½Ñ‚Ð°',0),(519021,14418,'vi','Báº¡n pháº£i nháº­p má»™t sá»‘ tÃ i khoáº£n',0),(519022,14418,'af','Jy moet \'n rekeningnommer intik',0),(519023,14418,'ro','Trebuie sÄƒ introduceÅ£i un numÄƒr de cont',0),(519024,14418,'et','Peate sisestama kontonumbri',0),(519025,14418,'si','Morate vnesti Å¡tevilko konta',0),(519026,14418,'ba','Anda harus memasukkan nomor rekening',0),(519027,14418,'nl','U moet een rekeningnummer invoeren',0),(519028,14418,'fi','Kirjoita tilinumero',0),(519029,14418,'no','Du mÃ¥ angi et kontonummer',0),(519030,14418,'da','Du skal indtaste et kontonummer',0),(519031,14418,'ko','ê³„ì¢Œ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(519032,14418,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ž×¡×¤×¨ ×—×©×‘×•×Ÿ',0),(519033,14418,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(519034,14418,'zh','æ‚¨å¿…é¡»è¾“å…¥å¸æˆ·å·ç ',0),(519035,14418,'sv','Du mÃ¥ste ange ett kontonummer',0),(519036,14418,'it','Ãˆ necessario immettere un numero di conto',0),(519037,14418,'tl','',0),(519038,14418,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µ',0),(519039,14418,'hi','à¤†à¤ª à¤à¤• à¤–à¤¾à¤¤à¤¾ à¤¨à¤‚à¤¬à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(519040,14418,'ms','Anda mesti masukkan nombor akaun',0),(519041,14418,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø­Ø³Ø§Ø¨',0),(519042,14418,'fr','Vous devez entrer un numÃ©ro de compte',0),(519043,14418,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå·ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(519044,14418,'pt','VocÃª deve digitar um nÃºmero de conta',0),(519045,14418,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°',0),(519046,14418,'es','Debe introducir un nÃºmero de cuenta',0),(519047,14418,'de','Sie mÃ¼ssen eine Kontonummer eingeben.',0),(519048,14418,'en','You Must Enter An Account Number',0),(519049,14419,'is','',0),(519050,14419,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ù†Ø§Ù… Ø¨Ø§Ù†Ú© Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(519051,14419,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ù†Ø§Ù… Ø¨Ø§Ù†Ú© Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(519052,14419,'tr','Banka adÄ± girmelisiniz',0),(519053,14419,'pl','NaleÅ¼y wprowadziÄ‡ nazwÄ™ banku',0),(519054,14419,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð½Ð° Ð±Ð°Ð½ÐºÐ°',0),(519055,14419,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø¨ÛŒÙ†Ú© Ú©Û’ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(519056,14419,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð±Ð°Ð½ÐºÐµ',0),(519057,14419,'vi','Báº¡n pháº£i nháº­p tÃªn ngÃ¢n hÃ ng',0),(519058,14419,'af','U moet \'n Banknaam invoer',0),(519059,14419,'ro','Trebuie sÄƒ introduceÅ£i un nume de Banca',0),(519060,14419,'et','Sisestage Panga nimi',0),(519061,14419,'si','Vnesti morate ime banke',0),(519062,14419,'ba','Anda harus memasukkan nama Bank',0),(519063,14419,'nl','U moet de naam van een Bank invoeren',0),(519064,14419,'fi','Anna pankin nimi',0),(519065,14419,'no','Du mÃ¥ angi et banknavn',0),(519066,14419,'da','Du skal angive en banknavn',0),(519067,14419,'ko','ì€í–‰ ì´ë¦„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(519068,14419,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×©× ×‘× ×§',0),(519069,14419,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± Î¤ÏÎ¬Ï€ÎµÎ¶Î±',0),(519070,14419,'zh','æ‚¨å¿…é¡»è¾“å…¥é“¶è¡Œåç§°',0),(519071,14419,'sv','Du mÃ¥ste ange ett banknamn',0),(519072,14419,'it','Ãˆ necessario immettere un nome di banca',0),(519073,14419,'tl','',0),(519074,14419,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­à¸˜à¸™à¸²à¸„à¸²à¸£',0),(519075,14419,'hi','à¤†à¤ª à¤à¤• à¤¬à¥ˆà¤‚à¤• à¤•à¤¾ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(519076,14419,'ms','Anda harus masukkan nama Bank',0),(519077,14419,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø§Ø³Ù… Ø§Ù„Ø¨Ù†Ùƒ',0),(519078,14419,'fr','Vous devez entrer un nom de la Banque',0),(519079,14419,'jp','éŠ€è¡Œåã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(519080,14419,'pt','VocÃª deve digitar um nome de banco',0),(519081,14419,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¸Ð¼Ñ Ð±Ð°Ð½ÐºÐ°',0),(519082,14419,'es','Debe introducir un nombre de banco',0),(519083,14419,'de','Sie mÃ¼ssen einen Banknamen eingeben.',0),(519084,14419,'en','You Must Enter A Bank Name',0),(519085,14420,'is','',0),(519086,14420,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ù†Ø§Ù… Ø­Ø³Ø§Ø¨ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(519087,14420,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ù†Ø§Ù… Ø­Ø³Ø§Ø¨ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(519088,14420,'tr','Hesap adÄ± girmelisiniz',0),(519089,14420,'pl','Musisz wprowadziÄ‡ nazwÄ™ konta',0),(519090,14420,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð°',0),(519091,14420,'ur','Ø¢Ù¾ Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾Ø± Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(519092,14420,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½',0),(519093,14420,'vi','Báº¡n pháº£i nháº­p tÃªn tÃ i khoáº£n',0),(519094,14420,'af','Jy moet die naam intik op die rekening',0),(519095,14420,'ro','Trebuie sÄƒ introduceÅ£i numele contului',0),(519096,14420,'et','Sisestage konto nimi',0),(519097,14420,'si','Vnesti morate ime na raÄunu',0),(519098,14420,'ba','Anda harus memasukkan nama pada rekening',0),(519099,14420,'nl','Moet u de naam op de rekening',0),(519100,14420,'fi','Kirjoita tilin nimi',0),(519101,14420,'no','Du mÃ¥ angi navnet pÃ¥ kontoen',0),(519102,14420,'da','Du skal angive navnet pÃ¥ kontoen',0),(519103,14420,'ko','ê³„ì • ì´ë¦„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(519104,14420,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ××ª ×”×©× ×¢×œ ×—×©×‘×•×Ÿ',0),(519105,14420,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(519106,14420,'zh','æ‚¨å¿…é¡»è¾“å…¥è¯¥å¸æˆ·çš„åç§°',0),(519107,14420,'sv','Du mÃ¥ste ange namnet pÃ¥ kontot',0),(519108,14420,'it','Ãˆ necessario immettere il nome dell\'account',0),(519109,14420,'tl','',0),(519110,14420,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸Šà¸·à¹ˆà¸­à¸šà¸±à¸à¸Šà¸µ',0),(519111,14420,'hi','à¤¤à¥à¤® à¤ªà¤° à¤–à¤¾à¤¤à¤¾ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(519112,14420,'ms','Anda mesti masukkan nama akaun',0),(519113,14420,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(519114,14420,'fr','Vous devez entrer le nom du compte',0),(519115,14420,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®åå‰ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(519116,14420,'pt','VocÃª deve digitar o nome da conta',0),(519117,14420,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¸Ð¼Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(519118,14420,'es','Debe escribir el nombre de la cuenta',0),(519119,14420,'de','Sie mÃ¼ssen den Namen des Kontos eingeben.',0),(519120,14420,'en','You Must Enter The Name On The Account',0),(519121,14421,'is','',0),(519122,14421,'dr','Ø§ØªÙ‡Ø§Ù…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(519123,14421,'pr','Ø§ØªÙ‡Ø§Ù…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(519124,14421,'tr','Ãœcretleri baÅŸarÄ±yla silindi',0),(519125,14421,'pl','OpÅ‚aty za przesâ”‚anie',0),(519126,14421,'bg','Ð¢Ð°ÐºÑÐ¸, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(519127,14421,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬ Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(519128,14421,'sr','ÐžÐ¿Ñ‚ÑƒÐ¶Ð±Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(519129,14421,'vi','Chi phÃ­ Ä‘Ã£ xÃ³a thÃ nh cÃ´ng',0),(519130,14421,'af','Koste suksesvol geskrap',0),(519131,14421,'ro','Taxe eliminÄƒ cu succes',0),(519132,14421,'et','Makse edukalt kustutatud',0),(519133,14421,'si','StroÅ¡kov uspeÅ¡no izbrisana',0),(519134,14421,'ba','Biaya dihapus berhasil',0),(519135,14421,'nl','Kosten met succes verwijderd',0),(519136,14421,'fi','Maksut poistettu',0),(519137,14421,'no','Kostnader slettet',0),(519138,14421,'da','Afgifter slettet',0),(519139,14421,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” ìš”ê¸ˆ',0),(519140,14421,'he','×—×™×•×‘×™× × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(519141,14421,'el','Î§ÏÎµÏŽÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(519142,14421,'zh','å·²æˆåŠŸåˆ é™¤çš„æ”¶è´¹',0),(519143,14421,'sv','Avgifter raderades',0),(519144,14421,'it','Oneri eliminati con successo',0),(519145,14421,'tl','',0),(519146,14421,'th','à¸„à¹ˆà¸²à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(519147,14421,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(519148,14421,'ms','Caj-caj yang dihapuskan dengan jayanya',0),(519149,14421,'ar','Ø±Ø³ÙˆÙ… Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(519150,14421,'fr','Charges supprimÃ©s avec succÃ¨s',0),(519151,14421,'jp','æ­£å¸¸ã«å‰Šé™¤ã•ã‚ŒãŸæ–™é‡‘',0),(519152,14421,'pt','AcusaÃ§Ãµes apagadas com sucesso',0),(519153,14421,'ru','ÐžÐ±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(519154,14421,'es','Cargos eliminados con Ã©xito',0),(519155,14421,'de','GebÃ¼hren, die erfolgreich gelÃ¶scht',0),(519156,14421,'en','Charges Deleted Successfully',0),(519157,14422,'is','',0),(519158,14422,'dr','Ø­Ø°Ù Ù‡Ø²ÛŒÙ†Ù‡',0),(519159,14422,'pr','Ø­Ø°Ù Ù‡Ø²ÛŒÙ†Ù‡',0),(519160,14422,'tr','Ãœcretleri Sil',0),(519161,14422,'pl','UsunÄ…Ä‡ opÅ‚at',0),(519162,14422,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°ÐºÑÐ¸',0),(519163,14422,'ur','Ø§Ù„Ø²Ø§Ù…Ø§Øª Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(519164,14422,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(519165,14422,'vi','XoÃ¡ khoáº£n phÃ­',0),(519166,14422,'af','Skrap kostes',0),(519167,14422,'ro','ÅžtergeÅ£i taxe',0),(519168,14422,'et','Kustuta makse',0),(519169,14422,'si','Izbrisati stroÅ¡ki',0),(519170,14422,'ba','Menghapus biaya',0),(519171,14422,'nl','Verwijderen van kosten',0),(519172,14422,'fi','Poistaa maksut',0),(519173,14422,'no','Slette kostnader',0),(519174,14422,'da','Slette afgifter',0),(519175,14422,'ko','ìš”ê¸ˆ ì‚­ì œ',0),(519176,14422,'he','×ž×—×™×§×ª ×›×ª×‘ ××™×©×•×',0),(519177,14422,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(519178,14422,'zh','åˆ é™¤æ”¶è´¹',0),(519179,14422,'sv','Ta bort avgifter',0),(519180,14422,'it','Eliminare oneri',0),(519181,14422,'tl','',0),(519182,14422,'th','à¸¥à¸šà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡',0),(519183,14422,'hi','à¤†à¤°à¥‹à¤ªà¥‹à¤‚ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(519184,14422,'ms','Menghapuskan caj',0),(519185,14422,'ar','Ø­Ø°Ù Ø±Ø³ÙˆÙ…',0),(519186,14422,'fr','Supprimer les frais',0),(519187,14422,'jp','æ–™é‡‘ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(519188,14422,'pt','Excluir encargos',0),(519189,14422,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(519190,14422,'es','Eliminar cargos',0),(519191,14422,'de','GebÃ¼hren lÃ¶schen',0),(519192,14422,'en','Delete Charges',0),(519193,14423,'is','',0),(519194,14423,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯',0),(519195,14423,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯',0),(519196,14423,'tr','Sil SeÃ§ili masraflar',0),(519197,14423,'pl','UsuÅ„ wybrane opÅ‚aty',0),(519198,14423,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ñ‚Ð°ÐºÑÐ¸',0),(519199,14423,'ur','Ù…Ù†ØªØ®Ø¨ Ø§Ù„Ø²Ø§Ù…Ø§Øª Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(519200,14423,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ðµ',0),(519201,14423,'vi','XÃ³a lá»±a chá»n chi phÃ­',0),(519202,14423,'af','Skrap geselekteerde koste',0),(519203,14423,'ro','A ÅŸterge selectat taxe',0),(519204,14423,'et','Kustuta valitud tasud',0),(519205,14423,'si','IzbriÅ¡i izbrane stroÅ¡ki',0),(519206,14423,'ba','Menghapus biaya dipilih',0),(519207,14423,'nl','Verwijder geselecteerde kosten',0),(519208,14423,'fi','Poista valittu maksut',0),(519209,14423,'no','Slett valgte kostnader',0),(519210,14423,'da','Slet de valgte gebyrer',0),(519211,14423,'ko','ì‚­ì œ ì„ íƒí•œ ìš”ê¸ˆ',0),(519212,14423,'he','×œ×ž×—×•×§ ××ª ×”× ×‘×—×¨×ª ××™×©×•×',0),(519213,14423,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Ï‰Î½ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(519214,14423,'zh','åˆ é™¤é€‰å®šçš„æ”¶è´¹',0),(519215,14423,'sv','Ta bort markerade avgifter',0),(519216,14423,'it','Elimina selezionati oneri',0),(519217,14423,'tl','',0),(519218,14423,'th','à¸¥à¸šà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(519219,14423,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤†à¤°à¥‹à¤ªà¥‹à¤‚ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(519220,14423,'ms','Menghapuskan caj-caj yang terpilih',0),(519221,14423,'ar','Ø­Ø°Ù Ø§Ù„Ø§ØªÙ‡Ø§Ù…Ø§Øª Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(519222,14423,'fr','Supprimer certains frais',0),(519223,14423,'jp','å‰Šé™¤é¸æŠžã—ãŸæ–™é‡‘',0),(519224,14423,'pt','Excluir selecionadas acusaÃ§Ãµes',0),(519225,14423,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ðµ Ð¾Ð±Ð²Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(519226,14423,'es','Eliminar cargos seleccionados',0),(519227,14423,'de','AusgewÃ¤hlte lÃ¶schen GebÃ¼hren',0),(519228,14423,'en','Delete Selected Charges',0),(519229,14424,'is','',0),(519230,14424,'dr','Ø§Ø±Ø²ÛŒØ§Ø¨ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø¯ÛŒØ±',0),(519231,14424,'pr','Ø§Ø±Ø²ÛŒØ§Ø¨ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø¯ÛŒØ±',0),(519232,14424,'tr','Gecikme bedeli deÄŸerlendirmek',0),(519233,14424,'pl','Oceny opÅ‚aty za pÃ³Åºno',0),(519234,14424,'bg','ÐžÑ†ÐµÐ½Ð¸ Ñ‚Ð°ÐºÑÐ° Ð·Ð° ÐºÑŠÑÐ½Ð¾',0),(519235,14424,'ur','Ù…Ø±Ø­ÙˆÙ… Ú©ÛŒ ÙÛŒØ³ Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÙ†Û’',0),(519236,14424,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð¸ Ð¾Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(519237,14424,'vi','ÄÃ¡nh giÃ¡ phÃ­ tráº£ trá»…',0),(519238,14424,'af','Assesseer laat fooi',0),(519239,14424,'ro','Evalua taxÄƒ de Ã®ntÃ¢rziere',0),(519240,14424,'et','Hinnata viivis',0),(519241,14424,'si','Oceniti pozno pristojbina',0),(519242,14424,'ba','Menilai keterlambatan',0),(519243,14424,'nl','Beoordelen van de te Late betaling',0),(519244,14424,'fi','Arvioida viivÃ¤styskorko',0),(519245,14424,'no','Vurdere forsinkelsesavgift',0),(519246,14424,'da','Vurdere sen gebyr',0),(519247,14424,'ko','ì—°ì²´ ë£Œë¥¼ í‰ê°€',0),(519248,14424,'he','×œ×”×¢×¨×™×š ××ª ×“×ž×™ ×”××™×—×•×¨',0),(519249,14424,'el','Î‘Î¾Î¹Î¿Î»Î¿Î³Î®ÏƒÎµÎ¹ Ï„Î·Î½ Ï€ÏÏŒÏƒÏ†Î±Ï„Î· Î±Î¼Î¿Î¹Î²Î®',0),(519250,14424,'zh','è¯„ä¼°æ»žçº³é‡‘',0),(519251,14424,'sv','BedÃ¶ma fÃ¶rseningsavgift',0),(519252,14424,'it','Valutare il ritardo',0),(519253,14424,'tl','',0),(519254,14424,'th','à¸›à¸£à¸°à¹€à¸¡à¸´à¸™à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸¥à¹ˆà¸²à¸Šà¹‰à¸²',0),(519255,14424,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤¶à¥à¤²à¥à¤• à¤•à¤¾ à¤†à¤•à¤²à¤¨',0),(519256,14424,'ms','Menilai yuran lewat',0),(519257,14424,'ar','ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(519258,14424,'fr','Ã‰valuer les frais de retard',0),(519259,14424,'jp','å»¶æ»žæ–™ã‚’æŸ»å®šã—ã¾ã™ã€‚',0),(519260,14424,'pt','Avaliar a taxa de atraso',0),(519261,14424,'ru','ÐžÑ†ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð·Ð´Ð½Ð¸Ð¹ ÑÐ±Ð¾Ñ€',0),(519262,14424,'es','Evaluar recargo',0),(519263,14424,'de','GebÃ¼hr fÃ¼r verspÃ¤tete bewerten',0),(519264,14424,'en','Assess Late Fee',0),(519265,14425,'is','',0),(519266,14425,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø±Ø²ÛŒØ§Ø¨ÛŒ',0),(519267,14425,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø±Ø²ÛŒØ§Ø¨ÛŒ',0),(519268,14425,'tr','Ãœcreti deÄŸerlendirildi',0),(519269,14425,'pl','OpÅ‚ata za ocenÄ™',0),(519270,14425,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(519271,14425,'ur','ÙÛŒØ³ Ú©ÛŒ ØªØ´Ø®ÛŒØµ',0),(519272,14425,'sr','Ð’Ð¸ÑÐ¸Ð½Ð¸ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ Ð·Ð°',0),(519273,14425,'vi','Lá»‡ phÃ­ Ä‘Ã¡nh giÃ¡',0),(519274,14425,'af','Fooi geassesseer',0),(519275,14425,'ro','Taxa de evaluat',0),(519276,14425,'et','Tasu hinnata',0),(519277,14425,'si','Pristojbina, ocenjena',0),(519278,14425,'ba','Biaya dinilai',0),(519279,14425,'nl','Vergoeding beoordeeld',0),(519280,14425,'fi','Arvioi maksu',0),(519281,14425,'no','Avgift vurdert',0),(519282,14425,'da','Gebyr vurderet',0),(519283,14425,'ko','í‰ê°€ ìˆ˜ìˆ˜ë£Œ',0),(519284,14425,'he','×“×ž×™ ×”×¢×¨×™×š',0),(519285,14425,'el','Î¤Î­Î»Î¿Ï‚ Î±Î¾Î¹Î¿Î»Î¿Î³Î¿ÏÎ½Ï„Î±Î¹',0),(519286,14425,'zh','è´¹ç”¨åˆ†æ‘Š',0),(519287,14425,'sv','Avgiften bedÃ¶ms',0),(519288,14425,'it','Tassa valutata',0),(519289,14425,'tl','',0),(519290,14425,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸›à¸£à¸°à¹€à¸¡à¸´à¸™',0),(519291,14425,'hi','à¤¶à¥à¤²à¥à¤• à¤®à¥‚à¤²à¥à¤¯à¤¾à¤‚à¤•à¤¨',0),(519292,14425,'ms','Yuran yang dinilai',0),(519293,14425,'ar','Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ù‚Ø±Ø±Ø©',0),(519294,14425,'fr','Frais Ã©valuÃ©s',0),(519295,14425,'jp','è©•ä¾¡æ–™é‡‘',0),(519296,14425,'pt','Taxa de avaliaÃ§Ã£o',0),(519297,14425,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ð¾Ñ†ÐµÐ½ÐºÑƒ',0),(519298,14425,'es','Costo evaluado',0),(519299,14425,'de','GebÃ¼hr beurteilt',0),(519300,14425,'en','Fee Assessed',0),(519301,14426,'is','',0),(519302,14426,'dr','Ø§Ø¹Ù„Ø§Ù† Ù‡Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± &amp; Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§ÙˆØ§Ø®Ø±',0),(519303,14426,'pr','Ø§Ø¹Ù„Ø§Ù† Ù‡Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± &amp; Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§ÙˆØ§Ø®Ø±',0),(519304,14426,'tr','Fatura bildirimleri & geÃ§ Ã¼cretleri',0),(519305,14426,'pl','Fakturach & opÅ‚aty za pÃ³Åºno',0),(519306,14426,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ & Ð·Ð°ÐºÑŠÑÐ½ÐµÐ»Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(519307,14426,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª & Ù…Ø±Ø­ÙˆÙ… Ú©ÛŒ ÙÛŒØ³',0),(519308,14426,'sr','ÐžÐ±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ° Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ & ÐºÐ°ÑÐ½Ð¾ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ',0),(519309,14426,'vi','HoÃ¡ Ä‘Æ¡n thÃ´ng bÃ¡o &amp; phÃ­ muá»™n',0),(519310,14426,'af','Faktuur kennisgewings & laat gelde',0),(519311,14426,'ro','NotificÄƒrile de facturÄƒ & tÃ¢rzii',0),(519312,14426,'et','Arve teated & hilinenud lÃµivude',0),(519313,14426,'si','RaÄuna obvestila & pozno pristojbine',0),(519314,14426,'ba','Faktur pemberitahuan & biaya keterlambatan',0),(519315,14426,'nl','Factuur meldingen & achterstallige betalingen',0),(519316,14426,'fi','Laskuun ilmoitusten & myÃ¶hÃ¤stymismaksuja',0),(519317,14426,'no','Faktura varsler & sent avgifter',0),(519318,14426,'da','Faktura meddelelser & sent gebyrer',0),(519319,14426,'ko','ì†¡ìž¥ ì•Œë¦¼ & ì—°ì²´ ë£Œ',0),(519320,14426,'he','×—×©×‘×•× ×™×ª ×”×•×“×¢×•×ª & ×“×ž×™ ×ž××•×—×¨',0),(519321,14426,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚ & Ï„Î­Î»Î· Ï„Î­Î»Î·',0),(519322,14426,'zh','å‘ç¥¨é€šçŸ¥ &amp; æ»žçº³é‡‘',0),(519323,14426,'sv','Faktura anmÃ¤lningar & fÃ¶rseningsavgifter',0),(519324,14426,'it','Notifiche di fattura & tasse ritardate',0),(519325,14426,'tl','',0),(519326,14426,'th','à¸à¸²à¸£à¹à¸ˆà¹‰à¸‡à¹€à¸•à¸·à¸­à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ & à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸¥à¹ˆà¸²à¸Šà¹‰à¸²',0),(519327,14426,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤ & à¤¦à¥‡à¤° à¤«à¥€à¤¸',0),(519328,14426,'ms','Pemberitahuan invois & yuran lewat',0),(519329,14426,'ar','Ø¥Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¢Ù†Ø¯ Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(519330,14426,'fr','Notifications de facture & frais de retard',0),(519331,14426,'jp','è«‹æ±‚æ›¸é€šçŸ¥ & å»¶æ»žæ–™',0),(519332,14426,'pt','NotificaÃ§Ãµes de fatura & taxas atrasadas',0),(519333,14426,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ & Ð·Ð° Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐºÑƒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(519334,14426,'es','Notificaciones de factura &amp; cargos por pagos atrasados',0),(519335,14426,'de','Rechnung Benachrichtigungen & Verzugszinsen',0),(519336,14426,'en','Invoice Notifications & Late Fees',0),(519337,14427,'is','',0),(519338,14427,'dr','Ø§Ø±Ø²ÛŒØ§Ø¨ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø¯ÛŒØ±',0),(519339,14427,'pr','Ø§Ø±Ø²ÛŒØ§Ø¨ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø¯ÛŒØ±',0),(519340,14427,'tr','GeÃ§ Ã¼creti deÄŸerlendirmesi',0),(519341,14427,'pl','PÃ³Åºno opÅ‚aty oceny',0),(519342,14427,'bg','ÐšÑŠÑÐ½Ð¾ Ñ‚Ð°ÐºÑÐ° Ð·Ð° Ð¾Ñ†ÐµÐ½ÐºÐ°',0),(519343,14427,'ur','Ù…Ø±Ø­ÙˆÙ… Ú©ÛŒ ÙÛŒØ³ Ú©ÛŒ ØªØ´Ø®ÛŒØµ',0),(519344,14427,'sr','ÐŸÐ¾ÐºÐ¾Ñ˜Ð½Ð¸ Ð½Ð°ÐºÐ½Ð°Ð´Ð° Ð¿Ñ€Ð¾Ñ†Ñ˜ÐµÐ½Ð°',0),(519345,14427,'vi','Cuá»‘i phÃ­ Ä‘Ã¡nh giÃ¡',0),(519346,14427,'af','Laat fooi assessering',0),(519347,14427,'ro','TÃ¢rziu taxa de evaluare',0),(519348,14427,'et','Hilinenud tasu hindamine',0),(519349,14427,'si','Pozno pristojbina oceno',0),(519350,14427,'ba','Akhir biaya penilaian',0),(519351,14427,'nl','Late vergoeding beoordeling',0),(519352,14427,'fi','MyÃ¶hÃ¤Ã¤n maksu arviointi',0),(519353,14427,'no','Sen gebyr vurdering',0),(519354,14427,'da','Sen gebyr vurdering',0),(519355,14427,'ko','ëŠ¦ì€ ë¹„ìš© í‰ê°€',0),(519356,14427,'he','×”×¢×¨×›×ª ×“×ž×™ ×ž××•×—×¨',0),(519357,14427,'el','Î‘ÏÎ³Î¬ Î±Î¼Î¿Î¹Î²Î®Ï‚ Î±Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(519358,14427,'zh','åŽæœŸè´¹ç”¨è¯„ä¼°',0),(519359,14427,'sv','Sen avgift bedÃ¶mning',0),(519360,14427,'it','Valutazione del canone tardo',0),(519361,14427,'tl','',0),(519362,14427,'th','à¸›à¸£à¸°à¹€à¸¡à¸´à¸™à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸¥à¹ˆà¸²à¸Šà¹‰à¸²',0),(519363,14427,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤¶à¥à¤²à¥à¤• à¤®à¥‚à¤²à¥à¤¯à¤¾à¤‚à¤•à¤¨',0),(519364,14427,'ms','Lewat bayaran penilaian',0),(519365,14427,'ar','ØªÙ‚ÙŠÙŠÙ… Ø§Ù„Ø±Ø³ÙˆÙ… Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(519366,14427,'fr','Ã‰valuation fin de frais',0),(519367,14427,'jp','å¾ŒåŠæ–™è©•ä¾¡',0),(519368,14427,'pt','AvaliaÃ§Ã£o final de taxa',0),(519369,14427,'ru','ÐŸÐ¾Ð·Ð´Ð½Ð¸Ð¹ ÑÐ±Ð¾Ñ€ Ð¾Ñ†ÐµÐ½ÐºÐ¸',0),(519370,14427,'es','EvaluaciÃ³n pago tardÃ­o',0),(519371,14427,'de','SpÃ¤ten Fee Assessment',0),(519372,14427,'en','Late Fee Assessment',0),(519373,14428,'is','',0),(519374,14428,'dr','Ø¯ÛŒØ± Ù…ØªÙˆØ¬Ù‡',0),(519375,14428,'pr','Ø¯ÛŒØ± Ù…ØªÙˆØ¬Ù‡',0),(519376,14428,'tr','GeÃ§ haber',0),(519377,14428,'pl','Koniec ogÅ‚oszenia',0),(519378,14428,'bg','ÐšÑ€Ð°Ñ Ð½Ð° Ð¿Ñ€ÐµÐ´Ð¸Ð·Ð²ÐµÑÑ‚Ð¸ÐµÑ‚Ð¾',0),(519379,14428,'ur','Ù…Ø±Ø­ÙˆÙ… Ù†ÙˆÙ¹Ø³',0),(519380,14428,'sr','ÐŸÐ¾Ð¼Ð°Ð»Ð¾ ÐºÐ°ÑÐ½Ð¾',0),(519381,14428,'vi','ThÃ´ng bÃ¡o cuá»‘i',0),(519382,14428,'af','Laat kennisgewing',0),(519383,14428,'ro','TÃ¢rziu notificare',0),(519384,14428,'et','Hilinenud teade',0),(519385,14428,'si','Pozno obvestilo',0),(519386,14428,'ba','Akhir pemberitahuan',0),(519387,14428,'nl','Late aankondiging',0),(519388,14428,'fi','MyÃ¶hÃ¤Ã¤n Huomautus',0),(519389,14428,'no','Sen notis',0),(519390,14428,'da','Sen varsel',0),(519391,14428,'ko','ëŠ¦ì€ ê³µì§€',0),(519392,14428,'he','×”×•×“×¢×” ×ž××•×—×¨×ª',0),(519393,14428,'el','ÎšÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ®ÏƒÎµÎ¹Ï‚ ÏƒÏ„Î·Î½ Ï€ÏÎ¿ÎºÎ®ÏÏ…Î¾Î·',0),(519394,14428,'zh','è¿Ÿä½œé€šçŸ¥',0),(519395,14428,'sv','Sent varsel',0),(519396,14428,'it','Avviso fine',0),(519397,14428,'tl','',0),(519398,14428,'th','à¹à¸ˆà¹‰à¸‡à¸¥à¹ˆà¸²à¸Šà¹‰à¸²',0),(519399,14428,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤¸à¥‚à¤šà¤¨à¤¾',0),(519400,14428,'ms','Notis yang lewat',0),(519401,14428,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø±Ø§Ø­Ù„',0),(519402,14428,'fr','Avis tardif',0),(519403,14428,'jp','æ°—ã¥ããŒé…ã‚Œã¦',0),(519404,14428,'pt','Aviso de atraso',0),(519405,14428,'ru','ÐŸÐ¾Ð·Ð´Ð½ÐµÐ³Ð¾ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(519406,14428,'es','Tarde',0),(519407,14428,'de','SpÃ¤te Mitteilung',0),(519408,14428,'en','Late Notice',0),(519409,14429,'is','',0),(519410,14429,'dr','Ø¯ÛŒØ± Ù…ØªÙˆØ¬Ù‡ Ø§Ù„Ú¯Ùˆ',0),(519411,14429,'pr','Ø¯ÛŒØ± Ù…ØªÙˆØ¬Ù‡ Ø§Ù„Ú¯Ùˆ',0),(519412,14429,'tr','GeÃ§ haber ÅŸablonu',0),(519413,14429,'pl','Koniec ogÅ‚oszenia szablon',0),(519414,14429,'bg','ÐšÑŠÑÐ½Ð¾ ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(519415,14429,'ur','Ù…Ø±Ø­ÙˆÙ… Ù†ÙˆÙ¹Ø³ Ø³Ø§Ù†Ú†Ø§',0),(519416,14429,'sr','ÐŸÐ¾ÐºÐ¾Ñ˜Ð½Ð¸ Ð½Ð°Ñ˜Ð°Ð²Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº',0),(519417,14429,'vi','Cuá»‘i thÃ´ng bÃ¡o máº«u',0),(519418,14429,'af','Laat kennisgewing sjabloon',0),(519419,14429,'ro','TÃ¢rziu notificare ÅŸablon',0),(519420,14429,'et','Hilinenud teade Mall',0),(519421,14429,'si','Predlogo poznega obvestila',0),(519422,14429,'ba','Akhir pemberitahuan Template',0),(519423,14429,'nl','Late aankondiging sjabloon',0),(519424,14429,'fi','MyÃ¶hÃ¤Ã¤n ilmoituksen malli',0),(519425,14429,'no','Sent varsel mal',0),(519426,14429,'da','Sen varsel skabelon',0),(519427,14429,'ko','ëŠ¦ì€ ê³  ì‹œ ì„œì‹ íŒŒì¼',0),(519428,14429,'he','×ª×‘× ×™×ª ×”×•×“×¢×” ×ž××•×—×¨×ª',0),(519429,14429,'el','ÎšÎ±Î¸Ï…ÏƒÏ„ÎµÏÎ·Î¼Î­Î½Î· Î±Î½Î±ÎºÎ¿Î¯Î½Ï‰ÏƒÎ· Ï€ÏÏŒÏ„Ï…Ï€Î¿',0),(519430,14429,'zh','æ™šé€šçŸ¥æ¨¡æ¿',0),(519431,14429,'sv','Sent varsel mall',0),(519432,14429,'it','Tardo Template di avviso',0),(519433,14429,'tl','',0),(519434,14429,'th','à¹à¸¡à¹ˆà¹à¸ˆà¹‰à¸‡à¸¥à¹ˆà¸²à¸Šà¹‰à¸²',0),(519435,14429,'hi','à¤¦à¥‡à¤° à¤¸à¥‡ à¤¸à¥‚à¤šà¤¨à¤¾ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ',0),(519436,14429,'ms','Lewat notis Template',0),(519437,14429,'ar','Ù‚Ø§Ù„Ø¨ Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø±Ø§Ø­Ù„',0),(519438,14429,'fr','ModÃ¨le d\'avis tardif',0),(519439,14429,'jp','é…ã„é€šçŸ¥ã®ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ',0),(519440,14429,'pt','Modelo de aviso final',0),(519441,14429,'ru','ÐšÐ¾Ð½Ñ†Ðµ ÑˆÐ°Ð±Ð»Ð¾Ð½ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(519442,14429,'es','Plantilla de aviso tarde',0),(519443,14429,'de','Ende Hinweis-Vorlage',0),(519444,14429,'en','Late Notice Template',0),(519445,14430,'is','',0),(519446,14430,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØºÛŒØ± Ù‚Ø§Ø¨Ù„ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø¨Ù‡ Ø§Ø¯Ø§Ù…Ù‡ Ù„Ø§Ø²Ù… Ø§Ø³Øª.',0),(519447,14430,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØºÛŒØ± Ù‚Ø§Ø¨Ù„ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø¨Ù‡ Ø§Ø¯Ø§Ù…Ù‡ Ù„Ø§Ø²Ù… Ø§Ø³Øª.',0),(519448,14430,'tr','Ã–demesiz baÅŸvuru Ã¼creti, devam etmek iÃ§in gerekli.',0),(519449,14430,'pl','OpÅ‚ata nie podlega zwrotowi aplikacji jest wymagane aby przejÅ›Ä‡.',0),(519450,14430,'bg','ÐÐµ ÑÐµ Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð° Ñ‚Ð°ÐºÑÐ° ÑÐµ Ð¸Ð·Ð¸ÑÐºÐ²Ð° Ð·Ð° Ð´Ð° Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð¸Ñ‚Ðµ.',0),(519451,14430,'ur','Ø¢Ú¯Û’ Ø¨Ú‘Ú¾Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ù†Ø§Ù‚Ø§Ø¨Ù„ ÙˆØ§Ù¾Ø³ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ ÙÛŒØ³ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(519452,14430,'sr','ÐšÐ°Ñ€Ñ‚Ð° Ð·Ð° Ð¿Ð¾Ð¿ÑƒÑšÐ°Ð²ÑšÐµ Ñ˜Ðµ Ð½ÐµÐ¾Ð¿Ñ…Ð¾Ð´Ð½Ð° Ð·Ð° Ð½Ð°ÑÑ‚Ð°Ð²Ð°Ðº.',0),(519453,14430,'vi','Má»™t lá»‡ phÃ­ ná»™p Ä‘Æ¡n khÃ´ng hoÃ n tráº£ lÃ  cáº§n thiáº¿t Ä‘á»ƒ tiáº¿n hÃ nh.',0),(519454,14430,'af','\'N nie-terugbetaalbare aansoekfooi word vereis om voort te gaan.',0),(519455,14430,'ro','O taxa de cerere de ofertÄƒ este necesar pentru a continua.',0),(519456,14430,'et','-Tagasimakse taotluse esitamise lÃµiv on vaja jÃ¤tkata.',0),(519457,14430,'si','Non-refundable vloga pristojbina mora prehajati.',0),(519458,14430,'ba','Biaya aplikasi dikembalikan diperlukan untuk melanjutkan.',0),(519459,14430,'nl','Een niet-restitueerbare aanvraagkosten is vereist om door te gaan.',0),(519460,14430,'fi','Palauteta hakemusmaksun tarvitaan.',0),(519461,14430,'no','Et ikke-refunderbart PÃ¥meldingsavgiften er nÃ¸dvendig for Ã¥ fortsette.',0),(519462,14430,'da','En ikke refunderes ansÃ¸gningsgebyr skal fortsÃ¦tte.',0),(519463,14430,'ko','í™˜ë¶ˆ ì‹ ì²­ë¹„ëŠ” ì§„í–‰ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(519464,14430,'he','×™×™×©×•× ×©××™× ×• × ×™×ª×Ÿ ×œ×”×—×–×¨ ×ª×©×œ×•× × ×“×¨×© ×›×“×™ ×œ×”×ž×©×™×š.',0),(519465,14430,'el','Î¤Î­Î»Î¿Ï…Ï‚ Î´ÎµÎ½ ÎµÏ€Î¹ÏƒÏ„ÏÎ­Ï†ÎµÏ„Î±Î¹ ÎµÏ†Î±ÏÎ¼Î¿Î³Î® Ï…Ï€Î¿Ï‡ÏÎµÎ¿ÏÏ„Î±Î¹ Î½Î± Ï€Î±ÏÎ±Î´ÏŽÏƒÎµÎ¹.',0),(519466,14430,'zh','ä¸é€€è¿˜æŠ¥åè´¹æ‰èƒ½ç»§ç»­ã€‚',0),(519467,14430,'sv','En icke-Ã¥terbetalningsbar avgift krÃ¤vs fÃ¶r att gÃ¥ vidare.',0),(519468,14430,'it','Per procedere Ã¨ necessaria una quota di iscrizione non Ã¨ rimborsabile.',0),(519469,14430,'tl','',0),(519470,14430,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹„à¸¡à¹ˆà¸„à¸·à¸™à¸ˆà¸°à¸•à¹‰à¸­à¸‡à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£',0),(519471,14430,'hi','à¤à¤• à¤—à¥ˆà¤° à¤µà¤¾à¤ªà¤¸à¥€à¤¯à¥‹à¤—à¥à¤¯ à¤†à¤µà¥‡à¤¦à¤¨ à¤¶à¥à¤²à¥à¤• à¤†à¤—à¥‡ à¤¬à¤¢à¤¼à¤¨à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆà¥¤',0),(519472,14430,'ms','Bayaran permohonan dikembalikan yang diperlukan untuk meneruskan.',0),(519473,14430,'ar','Ø¨Ø¹Ø¯ Ø¯ÙØ¹ Ø±Ø³ÙˆÙ… Ø§Ù„Ø·Ù„Ø¨ Ø³ÙˆÙ ØªÙƒÙˆÙ† Ù‚Ø§Ø¯Ø±Ø© Ø¹Ù„Ù‰ Ø§Ø³ØªÙƒÙ…Ø§Ù„ Ø§Ù„ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(519474,14430,'fr','Un frais d\'inscription non remboursable est nÃ©cessaire pour aller de l\'avant.',0),(519475,14430,'jp','ç¶šè¡Œã™ã‚‹ã«ã¯ã€æ‰•ã„æˆ»ã—ä¸å¯ã®ç”³è«‹æ–™ãŒå¿…è¦ã§ã™ã€‚',0),(519476,14430,'pt','Uma taxa de inscriÃ§Ã£o nÃ£o-reembolsÃ¡vel Ã© necessÃ¡ria para prosseguir.',0),(519477,14430,'ru','Ð”Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶ÐµÐ½Ð¸Ñ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð½ÐµÐ²Ð¾Ð·Ð²Ñ€Ð°Ñ‰Ð°ÐµÐ¼Ñ‹Ð¹ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½Ð½Ñ‹Ð¹ Ð²Ð·Ð½Ð¾Ñ.',0),(519478,14430,'es','Es necesaria una cuota de solicitud no reembolsable para proceder.',0),(519479,14430,'de','Eine nicht rÃ¼ckzahlbare AnmeldegebÃ¼hr wird benÃ¶tigt, um fortzufahren.',0),(519480,14430,'en','A non-refundable application fee is required to proceed.',0),(519481,14431,'is','',0),(519482,14431,'dr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§Ú©ØªÙˆØ±',0),(519483,14431,'pr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§Ú©ØªÙˆØ±',0),(519484,14431,'tr','AR fatura Ã¶n Ã¶deme',0),(519485,14431,'pl','AR faktury przedpÅ‚aty',0),(519486,14431,'bg','AR Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð°Ð²Ð°Ð½ÑÐ¾Ð²Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(519487,14431,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù¾ÛÙ„Û’ Ø§Ø¯Ø§Ø¦Ú¯ÛŒ',0),(519488,14431,'sr','ÐÐ  Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð°ÐºÐ¾Ð½Ñ‚Ð°Ñ†Ð¸Ñ˜Ðµ',0),(519489,14431,'vi','Thanh toÃ¡n trÆ°á»›c hÃ³a Ä‘Æ¡n AR',0),(519490,14431,'af','AR faktuur voorafbetaalmeters',0),(519491,14431,'ro','AR factura avans',0),(519492,14431,'et','AR arve ennetÃ¤htaegse tagastamise',0),(519493,14431,'si','Avansni raÄun AR',0),(519494,14431,'ba','AR faktur pembayaran di muka',0),(519495,14431,'nl','AR factuur vooruitbetaling',0),(519496,14431,'fi','AR lasku ennakkomaksun',0),(519497,14431,'no','AR faktura forskuddsbetaling',0),(519498,14431,'da','AR faktura forudbetaling',0),(519499,14431,'ko','AR ì²­êµ¬ì„œ ê²°ì œ',0),(519500,14431,'he','AR ×—×©×‘×•× ×™×ª ×ª×©×œ×•× ×ž×¨××©',0),(519501,14431,'el','AR Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€ÏÎ¿Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(519502,14431,'zh','åº”æ”¶è´¦æ¬¾å‘ç¥¨é¢„ä»˜æ¬¾',0),(519503,14431,'sv','AR faktura fÃ¶rskottsbetalning',0),(519504,14431,'it','AR fattura pagamento anticipato',0),(519505,14431,'tl','',0),(519506,14431,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²à¸‚à¸­à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ AR',0),(519507,14431,'hi','à¤. à¤†à¤°. à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¥‚à¤°à¥à¤µ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(519508,14431,'ms','Bayaran pendahuluan invois AR',0),(519509,14431,'ar','AR ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø³Ø¨Ù‚',0),(519510,14431,'fr','AR facture acompte',0),(519511,14431,'jp','AR è«‹æ±‚æ›¸å‰æ‰•ã„',0),(519512,14431,'pt','Pagamento antecipado de fatura de AR',0),(519513,14431,'ru','AR ÑÑ‡ÐµÑ‚Ð° Ð¿Ñ€ÐµÐ´Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(519514,14431,'es','AR factura prepago',0),(519515,14431,'de','AR Rechnung Vorauszahlung',0),(519516,14431,'en','AR Invoice Prepayment',0),(519517,14432,'is','',0),(519518,14432,'dr','Ø­Ø³Ø§Ø¨ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(519519,14432,'pr','Ø­Ø³Ø§Ø¨ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(519520,14432,'tr','Hesap SeÃ§',0),(519521,14432,'pl','Wybierz konto',0),(519522,14432,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(519523,14432,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(519524,14432,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³',0),(519525,14432,'vi','Chá»n tÃ i khoáº£n',0),(519526,14432,'af','Kies rekening',0),(519527,14432,'ro','SelectaÃ¾i cont',0),(519528,14432,'et','Vali konto',0),(519529,14432,'si','Izberite raÄun',0),(519530,14432,'ba','Pilih Account',0),(519531,14432,'nl','Selecteer Account',0),(519532,14432,'fi','Valitse tili',0),(519533,14432,'no','Velg konto',0),(519534,14432,'da','VÃ¦lg konto',0),(519535,14432,'ko','ê³„ì • ì„ íƒ',0),(519536,14432,'he','×‘×—×¨ ×—×©×‘×•×Ÿ',0),(519537,14432,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(519538,14432,'zh','é€‰æ‹©å¸æˆ·',0),(519539,14432,'sv','VÃ¤lj konto',0),(519540,14432,'it','Selezionare Account',0),(519541,14432,'tl','',0),(519542,14432,'th','à¹€à¸¥à¸·à¸­à¸à¸šà¸±à¸à¸Šà¸µ',0),(519543,14432,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(519544,14432,'ms','Pilih akaun',0),(519545,14432,'ar','Ø­Ø¯Ø¯ Ø­Ø³Ø§Ø¨',0),(519546,14432,'fr','SÃ©lectionnez compte',0),(519547,14432,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’é¸æŠžã—ã¾ã™',0),(519548,14432,'pt','Selecione a conta',0),(519549,14432,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(519550,14432,'es','Seleccione cuenta',0),(519551,14432,'de','WÃ¤hlen Sie Konto',0),(519552,14432,'en','Select Account',0),(519553,14433,'is','',0),(519554,14433,'dr','Ø°Ø®ÛŒØ±Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ',0),(519555,14433,'pr','Ø°Ø®ÛŒØ±Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ',0),(519556,14433,'tr','SaklÄ± banka hesaplarÄ±',0),(519557,14433,'pl','Przechowywane rachunkÃ³w bankowych',0),(519558,14433,'bg','Ð¡ÑŠÑ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ‚Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(519559,14433,'ur','Ø°Ø®ÛŒØ±Û Ø´Ø¯Û Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(519560,14433,'sr','Ð£ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚ÐµÐ½Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(519561,14433,'vi','TÃ i khoáº£n ngÃ¢n hÃ ng Ä‘Æ°á»£c lÆ°u trá»¯',0),(519562,14433,'af','Gestoorde bankrekeninge',0),(519563,14433,'ro','Conturi bancare stocate',0),(519564,14433,'et','Salvestatud pangakontode',0),(519565,14433,'si','Shranjene banÄnih raÄunov',0),(519566,14433,'ba','Rekening Bank yang disimpan',0),(519567,14433,'nl','Opgeslagen bankrekeningen',0),(519568,14433,'fi','Tallennettujen pankkitilien',0),(519569,14433,'no','Lagrede bankkonti',0),(519570,14433,'da','Lagrede bankkonti',0),(519571,14433,'ko','ì €ìž¥ëœ ì€í–‰ ê³„ì¢Œ',0),(519572,14433,'he','×ž××•×—×¡× ×™× ×—×©×‘×•× ×•×ª ×‘× ×§',0),(519573,14433,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏ…Î¼Î­Î½Î· Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿ÏÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(519574,14433,'zh','å­˜å‚¨çš„é“¶è¡Œè´¦æˆ·',0),(519575,14433,'sv','Lagrade bankkonton',0),(519576,14433,'it','Conti bancari memorizzati',0),(519577,14433,'tl','',0),(519578,14433,'th','à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£à¹€à¸à¹‡à¸šà¹„à¸§à¹‰',0),(519579,14433,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹à¤¿à¤¤ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‹à¤‚',0),(519580,14433,'ms','Akaun-akaun Bank yang disimpan',0),(519581,14433,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ù…ØµØ±ÙÙŠØ© Ø§Ù„Ù…Ø®Ø²Ù†Ø©',0),(519582,14433,'fr','Comptes bancaires stockÃ©es',0),(519583,14433,'jp','ã‚¹ãƒˆã‚¢ãƒ‰ã®éŠ€è¡Œå£åº§',0),(519584,14433,'pt','Armazenado de contas bancÃ¡rias',0),(519585,14433,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(519586,14433,'es','Cuentas bancarias almacenados',0),(519587,14433,'de','Gespeicherte Bankkonten',0),(519588,14433,'en','Stored Bank Accounts',0),(519589,14434,'is','',0),(519590,14434,'dr','Ø§ÛŒÙ† Ø´Ø±Ú©Øª Ø¨Ù‡ Ø±ÙˆÙ†Ø¯ ACH Ù¾Ø±Ø¯Ø§Ø®Øª Ø¢Ù†Ù‡Ø§ ØªÙ†Ø¸ÛŒÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(519591,14434,'pr','Ø§ÛŒÙ† Ø´Ø±Ú©Øª Ø¨Ù‡ Ø±ÙˆÙ†Ø¯ ACH Ù¾Ø±Ø¯Ø§Ø®Øª Ø¢Ù†Ù‡Ø§ ØªÙ†Ø¸ÛŒÙ… Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(519592,14434,'tr','Bu ÅŸirketin iÅŸlem ACH Ã¶demeler iÃ§in ayarlanmamÄ±ÅŸ',0),(519593,14434,'pl','Ta firma nie jest skonfigurowany do obsÅ‚ugi pÅ‚atnoÅ›ci ACH',0),(519594,14434,'bg','Ð¢Ð°Ð·Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð½Ðµ Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐ½ Ð·Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð½Ð° Ð¡Ð¯ÐšÐ',0),(519595,14434,'ur','Ø§Ø³ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ø¹Ù…Ù„ Ø§Ú† Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ø§Ù¾ Ù†ÛÛŒÚº',0),(519596,14434,'sr','ÐžÐ²Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾Ð´ÐµÑˆÐµÐ½ Ð½Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑ ÐÑ… ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(519597,14434,'vi','CÃ´ng ty nÃ y khÃ´ng Ä‘Æ°á»£c thiáº¿t láº­p Ä‘á»ƒ quÃ¡ trÃ¬nh ACH thanh toÃ¡n',0),(519598,14434,'af','Hierdie maatskappy nie opgestel Is om die proses ACH betalings',0),(519599,14434,'ro','AceastÄƒ companie nu este configurat pentru plÄƒÅ£ile de ACH proces',0),(519600,14434,'et','See firma pole seadistatud maksete tÃ¶Ã¶tlemise ACH',0),(519601,14434,'si','To podjetje ni nastavljen za proces ACH plaÄila',0),(519602,14434,'ba','Perusahaan ini tidak diset untuk proses pembayaran ACH',0),(519603,14434,'nl','Dit bedrijf Is niet ingesteld op proces ACH-betalingen',0),(519604,14434,'fi','TÃ¤mÃ¤ yritys ei ole mÃ¤Ã¤ritetty ACH maksujen kÃ¤sittelyyn',0),(519605,14434,'no','Dette selskapet er ikke konfigurert til Ã¥ behandle ACH betalinger',0),(519606,14434,'da','Dette selskab er ikke sat op til proces ACH betalinger',0),(519607,14434,'ko','ì´ íšŒì‚¬ í”„ë¡œì„¸ìŠ¤ ACH ì§€ë¶ˆ í•˜ë„ë¡ ì„¤ì • ë˜ì–´',0),(519608,14434,'he','×”×—×‘×¨×” ×”×–××ª ×œ× ×ž×•×’×“×¨ ×ª×”×œ×™×š ACH ×ª×©×œ×•×ž×™×',0),(519609,14434,'el','Î‘Ï…Ï„Î® Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ ÏŽÏƒÏ„Îµ Î½Î± Î´Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½ ACH',0),(519610,14434,'zh','è¿™å®¶å…¬å¸æ˜¯ä¸ä¼šè®¾ç½®ä¸ºå¤„ç† ACH ä»˜æ¬¾',0),(519611,14434,'sv','Detta fÃ¶retag har inte stÃ¤llts in att processen ACH-betalningar',0),(519612,14434,'it','Questa azienda non Ã¨ configurata per processo ACH pagamenti',0),(519613,14434,'tl','',0),(519614,14434,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸–à¸¹à¸à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹ƒà¸«à¹‰à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ ACH',0),(519615,14434,'hi','ACH à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(519616,14434,'ms','Syarikat ini tidak disetkan untuk proses men pembayaran',0),(519617,14434,'ar','Ù„Ù… ÙŠØªÙ… Ø¥Ø¹Ø¯Ø§Ø¯ Ù‡Ø°Ù‡ Ø§Ù„Ø´Ø±ÙƒØ© Ù„Ø¹Ù…Ù„ÙŠØ© Ø§Ù„Ø¯ÙØ¹ Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(519618,14434,'fr','Cette sociÃ©tÃ© n\'est pas configurÃ©e pour traiter les paiements de ACH',0),(519619,14434,'jp','ã“ã®ä¼šç¤¾ã¯ ACH ã®æ”¯æ‰•ã®å‡¦ç†ã«è¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(519620,14434,'pt','Esta empresa nÃ£o estÃ¡ configurada para processo ACH pagamentos',0),(519621,14434,'ru','Ð­Ñ‚Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð½Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾ÐµÐ½ Ð´Ð»Ñ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ ÐÐšÐŸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(519622,14434,'es','Esta empresa no estÃ¡ configurada para procesar los pagos ACH',0),(519623,14434,'de','Diese Firma ist fÃ¼r Prozess-ACH-Zahlungen nicht eingerichtet.',0),(519624,14434,'en','This Company Is Not Set Up To Process ACH Payments',0),(519625,14435,'is','',0),(519626,14435,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù…ØªÙ…Ù… Ø«Ø¨Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(519627,14435,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù…ØªÙ…Ù… Ø«Ø¨Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(519628,14435,'tr','DeÄŸiÅŸiklik isteÄŸi imza ekleme',0),(519629,14435,'pl','DodaÄ‡ zmiana Å¼Ä…dania podpisania',0),(519630,14435,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð·Ð°ÑÐ²ÐºÐ°',0),(519631,14435,'ur','ØªØ±Ù…ÛŒÙ… Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Ø±Ù†Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(519632,14435,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð°Ð¼Ð°Ð½Ð´Ð¼Ð°Ð½ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²',0),(519633,14435,'vi','ThÃªm cÃ¡c tu chÃ­nh Ã¡n kÃ½ yÃªu cáº§u',0),(519634,14435,'af','Voeg wysiging ondertekening versoek',0),(519635,14435,'ro','Adauga semnarea cererii de modificare',0),(519636,14435,'et','Lisa muudatuse taotlus allkiri',0),(519637,14435,'si','Dodaj spremembe zahtevo za podpisovanje',0),(519638,14435,'ba','Tambahkan permintaan penandatanganan amandemen',0),(519639,14435,'nl','Amendement ondertekening verzoek toevoegen',0),(519640,14435,'fi','LisÃ¤tÃ¤ tarkistuksen allekirjoituspyyntÃ¶',0),(519641,14435,'no','Legge til endring signeringsforespÃ¸rsel',0),(519642,14435,'da','TilfÃ¸je Ã¦ndringsforslag underskrevet anmodning',0),(519643,14435,'ko','ê°œì • ì„œëª… ìš”ì²­ ì¶”ê°€',0),(519644,14435,'he','×”×•×¡×£ ×‘×ª×™×§×•×Ÿ ×‘×§×©×” ×œ×—×ª×™×ž×ª',0),(519645,14435,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„ÏÎ¿Ï€Î¿Î»Î¿Î³Î¯Î± (Î±Î¯Ï„Î·ÏƒÎ·)',0),(519646,14435,'zh','æ·»åŠ ç­¾åè¯·æ±‚çš„ä¿®è®¢',0),(519647,14435,'sv','LÃ¤gga till Ã¤ndringsfÃ¶rslag underteckna begÃ¤ran',0),(519648,14435,'it','Aggiungi firma la richiesta di modifica',0),(519649,14435,'tl','',0),(519650,14435,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸³à¸‚à¸­à¸£à¸±à¸šà¸£à¸­à¸‡à¸à¸²à¸£à¹à¸à¹‰à¹„à¸‚',0),(519651,14435,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤…à¤¨à¥à¤°à¥‹à¤§ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(519652,14435,'ms','Tambah pindaan permintaan menandatangani',0),(519653,14435,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù„Ù‰ Ø·Ù„Ø¨ Ø§Ù„ØªØ¹Ø¯ÙŠÙ„',0),(519654,14435,'fr','Ajouter amendement demande de signature',0),(519655,14435,'jp','æ”¹æ­£è¦æ±‚ã¸ã®ç½²åã®è¿½åŠ ã—ã¾ã™ã€‚',0),(519656,14435,'pt','Adicionar assinatura de solicitaÃ§Ã£o de alteraÃ§Ã£o',0),(519657,14435,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð¿Ñ€Ð°Ð²ÐºÐ¸ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(519658,14435,'es','AÃ±adir firma la solicitud de enmienda',0),(519659,14435,'de','FÃ¼gen Ã„nderungsantrag Signing Request hinzu',0),(519660,14435,'en','Add Amendment Signing Request',0),(519661,14436,'is','',0),(519662,14436,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø§Ù…Ø¶Ø§ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¶Ø§Ù…Ù†',0),(519663,14436,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø§Ù…Ø¶Ø§ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¶Ø§Ù…Ù†',0),(519664,14436,'tr','GarantÃ¶r istek imza ekleme',0),(519665,14436,'pl','DodaÄ‡ gwaranta Å¼Ä…dania podpisania',0),(519666,14436,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð³Ð°Ñ€Ð°Ð½Ñ‚ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð·Ð°ÑÐ²ÐºÐ°',0),(519667,14436,'ur','Ø¶Ø§Ù…Ù† Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Ø±Ù†Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(519668,14436,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð° Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²',0),(519669,14436,'vi','ThÃªm ngÆ°á»i báº£o lÃ£nh kÃ½ yÃªu cáº§u',0),(519670,14436,'af','Voeg borg ondertekening versoek',0),(519671,14436,'ro','Adauga garant semnarea cererii',0),(519672,14436,'et','KÃ¤endaja allkiri lisada',0),(519673,14436,'si','Dodaj garant zahtevo za podpisovanje',0),(519674,14436,'ba','Tambahkan penjamin permintaan penandatanganan',0),(519675,14436,'nl','Borg ondertekening verzoek toevoegen',0),(519676,14436,'fi','LisÃ¤Ã¤ takaajan allekirjoituspyyntÃ¶',0),(519677,14436,'no','Legge til garantist signeringsforespÃ¸rsel',0),(519678,14436,'da','TilfÃ¸j garant underskrive anmodningen',0),(519679,14436,'ko','ë³´ì¦ì¸ ì„œëª… ìš”ì²­ ì¶”ê°€',0),(519680,14436,'he','×œ×”×•×¡×™×£ ×¢×¨×‘ ×—×ª×™×ž×ª ×”×‘×§×©×”',0),(519681,14436,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÎ³Î³Ï…Î·Ï„Î® (Î±Î¯Ï„Î·ÏƒÎ·)',0),(519682,14436,'zh','æ·»åŠ ç­¾åè¯·æ±‚çš„æ‹…ä¿äºº',0),(519683,14436,'sv','LÃ¤gg till borgensmannen underteckna begÃ¤ran',0),(519684,14436,'it','Aggiungi garante firma richiesta',0),(519685,14436,'tl','',0),(519686,14436,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸³à¸‚à¸­à¸£à¸±à¸šà¸£à¸­à¸‡à¸œà¸¹à¹‰à¸„à¹‰à¸³à¸›à¸£à¸°à¸à¸±à¸™',0),(519687,14436,'hi','à¤—à¤¾à¤°à¤‚à¤Ÿà¥€ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤…à¤¨à¥à¤°à¥‹à¤§ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(519688,14436,'ms','Tambah penjamin permintaan menandatangani',0),(519689,14436,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù„Ù‰ Ø·Ù„Ø¨ Ø§Ù„Ø¶Ø§Ù…Ù†',0),(519690,14436,'fr','Ajouter garant demande de signature',0),(519691,14436,'jp','ä¿è¨¼äººã®è¦æ±‚ã®ç½²åã®è¿½åŠ ã—ã¾ã™ã€‚',0),(519692,14436,'pt','Adicionar fiador assinar a solicitaÃ§Ã£o',0),(519693,14436,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÑŒ Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð°',0),(519694,14436,'es','AÃ±adir a garante firmar peticiÃ³n',0),(519695,14436,'de','FÃ¼gen Sie Garant Signing Request',0),(519696,14436,'en','Add Guarantor Signing Request',0),(519697,14437,'is','',0),(519698,14437,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ Ø«Ø¨Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(519699,14437,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ Ø«Ø¨Øª Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(519700,14437,'tr','Evcil hayvan istek imza ekleme',0),(519701,14437,'pl','DodaÄ‡ Pet Å¼Ä…dania podpisania',0),(519702,14437,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Pet Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð·Ð°ÑÐ²ÐºÐ°',0),(519703,14437,'ur','Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ± Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Ø±Ù†Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(519704,14437,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ™ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²',0),(519705,14437,'vi','ThÃªm Pet kÃ½ yÃªu cáº§u',0),(519706,14437,'af','Voeg troeteldier ondertekening versoek',0),(519707,14437,'ro','Adauga semnarea cererii de companie',0),(519708,14437,'et','Lisa allkiri Pet',0),(519709,14437,'si','Dodajte Pet zahtevo za podpisovanje',0),(519710,14437,'ba','Tambahkan Pet permintaan penandatanganan',0),(519711,14437,'nl','Huisdier ondertekening verzoek toevoegen',0),(519712,14437,'fi','LisÃ¤Ã¤ Pet allekirjoituspyyntÃ¶',0),(519713,14437,'no','Legge til Pet signeringsforespÃ¸rsel',0),(519714,14437,'da','TilfÃ¸je Pet underskrevet anmodning',0),(519715,14437,'ko','ì• ì™„ ë™ë¬¼ ì„œëª… ìš”ì²­ ì¶”ê°€',0),(519716,14437,'he','×œ×”×•×¡×™×£ ×‘×§×©×” ×œ×—×ª×™×ž×ª ××ª ×—×™×™×ª ×”×ž×—×ž×“',0),(519717,14437,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Pet (Î±Î¯Ï„Î·ÏƒÎ·)',0),(519718,14437,'zh','æ·»åŠ ç­¾åè¯·æ±‚çš„å® ç‰©',0),(519719,14437,'sv','LÃ¤gg till Pet underteckna begÃ¤ran',0),(519720,14437,'it','Aggiungi Pet firma richiesta',0),(519721,14437,'tl','',0),(519722,14437,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡à¸„à¸³à¸‚à¸­à¸£à¸±à¸šà¸£à¸­à¸‡',0),(519723,14437,'hi','à¤ªà¤¾à¤²à¤¤à¥‚ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(519724,14437,'ms','Tambah Pet permintaan menandatangani',0),(519725,14437,'ar','Ø£Ø¶Ù Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ø·Ù„Ø¨',0),(519726,14437,'fr','Ajouter Pet demande de signature',0),(519727,14437,'jp','ãƒšãƒƒãƒˆã®è¦æ±‚ã®ç½²åã®è¿½åŠ ã—ã¾ã™ã€‚',0),(519728,14437,'pt','Adicionar Pet solicitaÃ§Ã£o de assinatura',0),(519729,14437,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¸Ñ‚Ð¾Ð¼Ñ†Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(519730,14437,'es','AÃ±adir mascota firmar peticiÃ³n',0),(519731,14437,'de','HinzufÃ¼gen von Pet Signing Request',0),(519732,14437,'en','Add Pet Signing Request',0),(519733,14438,'is','',0),(519734,14438,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø§Ù…Ø¶Ø§ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙØ³Ø®',0),(519735,14438,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø§Ù…Ø¶Ø§ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙØ³Ø®',0),(519736,14438,'tr','SonlandÄ±rma isteÄŸi imza ekleme',0),(519737,14438,'pl','Dodaj zakoÅ„czenie Å¼Ä…dania podpisania',0),(519738,14438,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÑÐ²Ð°Ð½Ðµ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð·Ð°ÑÐ²ÐºÐ°',0),(519739,14438,'ur','Ù…Ù†Ø³ÙˆØ®ÛŒ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø± Ø¯Ø³ØªØ®Ø· Ú©Ø±Ù†Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(519740,14438,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ñ€ÐµÐºÐ¸Ð´Ð° Ñ€Ð°Ð´Ð½Ð¾Ð³ Ð¾Ð´Ð½Ð¾ÑÐ° Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²',0),(519741,14438,'vi','ThÃªm cháº¥m dá»©t viá»‡c Ä‘Äƒng kÃ½ yÃªu cáº§u',0),(519742,14438,'af','Voeg beÃ«indiging ondertekening versoek',0),(519743,14438,'ro','Adauga Ã®ncetarea semnarea cererii',0),(519744,14438,'et','Lisada lÃµpetamise taotlus allkiri',0),(519745,14438,'si','Dodaj prenehanje zahtevo za podpisovanje',0),(519746,14438,'ba','Tambahkan penghentian permintaan penandatanganan',0),(519747,14438,'nl','BeÃ«indiging ondertekening verzoek toevoegen',0),(519748,14438,'fi','LisÃ¤Ã¤ irtisanominen allekirjoituspyyntÃ¶',0),(519749,14438,'no','Legge til oppsigelse signeringsforespÃ¸rsel',0),(519750,14438,'da','TilfÃ¸je opsigelse underskrevet anmodning',0),(519751,14438,'ko','ì¢…ë£Œ ìš”ì²­ì— ì„œëª… ì¶”ê°€',0),(519752,14438,'he','×”×•×¡×£ ×¡×™×•× ×‘×§×©×” ×œ×—×ª×™×ž×ª',0),(519753,14438,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„ÎµÏÎ¼Î±Ï„Î¹ÏƒÎ¼Î¿Ï (Î±Î¯Ï„Î·ÏƒÎ·)',0),(519754,14438,'zh','æ·»åŠ ç­¾åè¯·æ±‚ç»ˆæ­¢',0),(519755,14438,'sv','LÃ¤gg till uppsÃ¤gning underteckna begÃ¤ran',0),(519756,14438,'it','Aggiungi firma la richiesta di terminazione',0),(519757,14438,'tl','',0),(519758,14438,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸³à¸‚à¸­à¸£à¸±à¸šà¸£à¸­à¸‡à¸à¸²à¸£à¸ˆà¹‰à¸²à¸‡',0),(519759,14438,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤•à¥‡ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(519760,14438,'ms','Tambah penamatan permintaan menandatangani',0),(519761,14438,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø¹Ù„Ù‰ Ø·Ù„Ø¨ Ø¥Ù†Ù‡Ø§Ø¡',0),(519762,14438,'fr','Ajouter signant la demande de rÃ©siliation',0),(519763,14438,'jp','çµ‚äº†è¦æ±‚ã¸ã®ç½²åã®è¿½åŠ ã—ã¾ã™ã€‚',0),(519764,14438,'pt','Adicionar a assinar o pedido de rescisÃ£o',0),(519765,14438,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð½Ð° Ð¿Ð¾Ð´Ð¿Ð¸ÑÑŒ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ',0),(519766,14438,'es','AÃ±adir terminaciÃ³n firmar peticiÃ³n',0),(519767,14438,'de','FÃ¼gen Sie KÃ¼ndigung Signing Request hinzu',0),(519768,14438,'en','Add Termination Signing Request',0),(519769,14439,'is','',0),(519770,14439,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø­Ø³Ø§Ø¨ ØªØ³Ú©ÛŒÙ†',0),(519771,14439,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø­Ø³Ø§Ø¨ ØªØ³Ú©ÛŒÙ†',0),(519772,14439,'tr','Temizlik/hasar yardÄ±m hesabÄ±',0),(519773,14439,'pl','Czyszczenie/uszkodzenia ulgi konta',0),(519774,14439,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(519775,14439,'ur','ØµÙØ§Ø¦ÛŒ/Ø±ÛŒÙ„ÛŒÙ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù‚ØµØ§Ù†',0),(519776,14439,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(519777,14439,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i cá»©u trá»£ tÃ i khoáº£n',0),(519778,14439,'af','Skoonmaak/skade verligting rekening',0),(519779,14439,'ro','CurÄƒÅ£are/daune Relief cont',0),(519780,14439,'et','Puhastamine/kahju leevendamiseks konto',0),(519781,14439,'si','ÄŒiÅ¡Äenje/Å¡kode odpis raÄuna',0),(519782,14439,'ba','Pembersihan/kerusakan Account Bantuan',0),(519783,14439,'nl','Reiniging/schade Relief Account',0),(519784,14439,'fi','Puhdistus/vahinko helpotusta tili',0),(519785,14439,'no','RengjÃ¸ring/skade lettelse konto',0),(519786,14439,'da','RengÃ¸ring/skader Relief konto',0),(519787,14439,'ko','ì²­ì†Œ í”¼í•´ êµ¬í˜¸ ê³„ì •',0),(519788,14439,'he','× ×™×§×•×™/× ×–×§ ×”×§×œ×” ×—×©×‘×•×Ÿ',0),(519789,14439,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± ÎºÎ¬Ï„Ï‰ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÎµÎ»Î¬Ï†ÏÏ…Î½ÏƒÎ·Ï‚ Ï„Î¿Ï…',0),(519790,14439,'zh','æ¸…æ´—æŸå®³æ•‘ç¾è´¦æˆ·',0),(519791,14439,'sv','RengÃ¶ring/skada lÃ¤ttnad konto',0),(519792,14439,'it','Pulizia/danno sollievo Account',0),(519793,14439,'tl','',0),(519794,14439,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¹€à¸ªà¸µà¸¢à¸šà¸±à¸à¸Šà¸µà¸šà¸£à¸£à¹€à¸—à¸²',0),(519795,14439,'hi','à¤°à¤¾à¤¹à¤¤ à¤–à¤¾à¤¤à¥‡ à¤¸à¤«à¤¾à¤ˆ/à¤¨à¥à¤•à¤¸à¤¾à¤¨',0),(519796,14439,'ms','Kering/kerosakan pelepasan akaun',0),(519797,14439,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¥ØºØ§Ø«Ø©',0),(519798,14439,'fr','Nettoyage/dommages secours compte',0),(519799,14439,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(519800,14439,'pt','Limpeza/dano conta de alÃ­vio',0),(519801,14439,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/ÑƒÑ‰ÐµÑ€Ð± Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(519802,14439,'es','Limpieza/daÃ±o alivio cuenta',0),(519803,14439,'de','Reinigung/Schaden Sie-Relief-Konto',0),(519804,14439,'en','Cleaning/Damage Relief Account',0),(519805,14440,'is','',0),(519806,14440,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø±Ø³Ø§Ù†ÛŒ ØªÙ†Ø¸ÛŒÙ…',0),(519807,14440,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø±Ø³Ø§Ù†ÛŒ ØªÙ†Ø¸ÛŒÙ…',0),(519808,14440,'tr','Temizlik/hasar kabartma ayarlama',0),(519809,14440,'pl','Czyszczenie/uszkodzenia regulacji ulgi',0),(519810,14440,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ',0),(519811,14440,'ur','ØµÙØ§Ø¦ÛŒ/Ø±ÛŒÙ„ÛŒÙ Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ù†Ù‚ØµØ§Ù†',0),(519812,14440,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(519813,14440,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i giáº£m Ä‘iá»u chá»‰nh',0),(519814,14440,'af','Skoonmaak/skade verligting aanpassing',0),(519815,14440,'ro','CurÄƒÅ£are/daune Relief ajustare',0),(519816,14440,'et','Puhastamine/kahju mahaarvamise korrigeerimine',0),(519817,14440,'si','ÄŒiÅ¡Äenje/Å¡kodo Relief prilagoditev',0),(519818,14440,'ba','Pembersihan/kerusakan Relief penyesuaian',0),(519819,14440,'nl','Reiniging/schade Relief aanpassing',0),(519820,14440,'fi','Puhdistus/vahinko helpotusta sÃ¤Ã¤tÃ¶',0),(519821,14440,'no','RengjÃ¸ring/skade lettelse justering',0),(519822,14440,'da','RengÃ¸ring/skader Relief justering',0),(519823,14440,'ko','ì²­ì†Œ ì†ìƒ êµ¬ì¡° ì¡°ì •',0),(519824,14440,'he','× ×™×§×•×™/× ×–×§ ×”×§×œ×” ×”×ª××ž×”',0),(519825,14440,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ· Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚',0),(519826,14440,'zh','æ¸…æ´—æŸå®³æ•‘æµŽè°ƒæ•´',0),(519827,14440,'sv','RengÃ¶ring/skada lÃ¤ttnad justering',0),(519828,14440,'it','Pulizia/danno sollievo regolazione',0),(519829,14440,'tl','',0),(519830,14440,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¹€à¸ªà¸µà¸¢à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸šà¸£à¸£à¹€à¸—à¸²',0),(519831,14440,'hi','à¤°à¤¾à¤¹à¤¤ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤¸à¤«à¤¾à¤ˆ/à¤¨à¥à¤•à¤¸à¤¾à¤¨',0),(519832,14440,'ms','Kering/kerosakan pelarasan pelepasan',0),(519833,14440,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø§Ù„ØªÙƒÙŠÙ Ø§Ù„Ø¥ØºØ§Ø«Ø©',0),(519834,14440,'fr','Nettoyage/dommages ajustement de soulagement',0),(519835,14440,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆèª¿æ•´',0),(519836,14440,'pt','Limpeza e ajuste de alÃ­vio de danos',0),(519837,14440,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/ÑƒÑ€Ð¾Ð½ Ð±Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð¿ÐµÑ€ÐµÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸',0),(519838,14440,'es','Limpieza/daÃ±o alivio ajuste',0),(519839,14440,'de','Reinigung/Schaden Sie-Relief-Anpassung',0),(519840,14440,'en','Cleaning/Damage Relief Adjustment',0),(519841,14441,'is','',0),(519842,14441,'dr','Ù…Ø³ØªØ§Ø¬Ø± Ù‡Ù…Ú©Ø§Ø±ÛŒ 2',0),(519843,14441,'pr','Ù…Ø³ØªØ§Ø¬Ø± Ù‡Ù…Ú©Ø§Ø±ÛŒ 2',0),(519844,14441,'tr','Ortak kiracÄ± 2',0),(519845,14441,'pl','WspÃ³Å‚pracy najemca 2',0),(519846,14441,'bg','Ð¡ÑŠ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ» 2',0),(519847,14441,'ur','Ù…Ø®Ù„ÙˆØ· Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± 2',0),(519848,14441,'sr','ÐšÐ¾Ð»ÐµÐ³Ð° ÑÑ‚Ð°Ð½Ð°Ñ€ 2',0),(519849,14441,'vi','Äá»“ng ngÆ°á»i thuÃª nhÃ  2',0),(519850,14441,'af','Mede-huurder 2',0),(519851,14441,'ro','Co-chiriaÅŸ 2',0),(519852,14441,'et','KoostÃ¶Ã¶ Ã¼Ã¼rnik 2',0),(519853,14441,'si','Co-najemnik 2',0),(519854,14441,'ba','Penyewa Co 2',0),(519855,14441,'nl','Co huurder 2',0),(519856,14441,'fi','YhteistyÃ¶tÃ¤ vuokralainen 2',0),(519857,14441,'no','Co leietaker 2',0),(519858,14441,'da','Co lejer 2',0),(519859,14441,'ko','ê³µë™ ê±°ì£¼ìž 2',0),(519860,14441,'he','×”×“×™×™×¨ ×©×•×ª×£ 2',0),(519861,14441,'el','Î£Ï…Î½-ÎµÎ½Î¿Î¹ÎºÎ¹Î±ÏƒÏ„Î®Ï‚ 2',0),(519862,14441,'zh','åˆç§Ÿ 2',0),(519863,14441,'sv','Co hyresgÃ¤st 2',0),(519864,14441,'it','Co-inquilino 2',0),(519865,14441,'tl','',0),(519866,14441,'th','à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¸£à¹ˆà¸§à¸¡ 2',0),(519867,14441,'hi','à¤¸à¤¹ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° 2',0),(519868,14441,'ms','Bersama penyewa 2',0),(519869,14441,'ar','Ù…Ø³ØªØ£Ø¬Ø± 2',0),(519870,14441,'fr','Colocataire 2',0),(519871,14441,'jp','å…±åŒãƒ†ãƒŠãƒ³ãƒˆ 2',0),(519872,14441,'pt','Inquilino co 2',0),(519873,14441,'ru','Ð¡Ð¾Ð¿Ñ€ÐµÐ´ÑÐµÐ´Ð°Ñ‚ÐµÐ»ÑŒ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ 2',0),(519874,14441,'es','Inquilino CO 2',0),(519875,14441,'de','Co Mieter 2',0),(519876,14441,'en','Co-Tenant 2',0),(519877,14442,'is','',0),(519878,14442,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ',0),(519879,14442,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ',0),(519880,14442,'tr','Ä°lk evde beslenen hayvan Ã¼cret hesabÄ±',0),(519881,14442,'pl','Konto opÅ‚aty wstÄ™pnej zwierzÄ™',0),(519882,14442,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÐµÐ½ Ð³Ð°Ð»ÐµÐ½Ð¸Ðº Ñ‚Ð°ÐºÑÐ° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(519883,14442,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ±ÙˆÚº Ú©ÛŒ ÙÛŒØ³ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(519884,14442,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð¿Ð¾Ñ‡ÐµÑ‚Ð½Ðµ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ Ð·Ð° ÐºÑƒÑ›Ð½Ðµ Ñ™ÑƒÐ±Ð¸Ð¼Ñ†Ðµ',0),(519885,14442,'vi','Ban Ä‘áº§u váº­t nuÃ´i phÃ­ tÃ i khoáº£n',0),(519886,14442,'af','Aanvanklike troeteldier fooi rekening',0),(519887,14442,'ro','Cont taxÄƒ iniÅ£ialÄƒ pentru animale de companie',0),(519888,14442,'et','Esialgse lemmiklooma tasu konto',0),(519889,14442,'si','ZaÄetno pristojbino jjeza raÄun',0),(519890,14442,'ba','Biaya hewan peliharaan awal Account',0),(519891,14442,'nl','InitiÃ«le huisdier kosten Account',0),(519892,14442,'fi','EnsimmÃ¤inen lemmikkielÃ¤inten lisÃ¤maksun tili',0),(519893,14442,'no','Innledende Pet gebyr konto',0),(519894,14442,'da','Indledende Pet gebyr konto',0),(519895,14442,'ko','ì´ˆê¸° ì• ì™„ ë™ë¬¼ ë¹„ìš© ê³„ì •',0),(519896,14442,'he','×—×©×‘×•×Ÿ ×“×ž×™ ×œ×—×™×•×ª ×ž×—×ž×“',0),(519897,14442,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ Î¶ÏŽÎ¿ Ï‡ÏÎ­Ï‰ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(519898,14442,'zh','åˆå§‹å® ç‰©è´¹å¸æˆ·',0),(519899,14442,'sv','SÃ¤llskapsdjur startavgift konto',0),(519900,14442,'it','Supplemento per animali domestici iniziale Account',0),(519901,14442,'tl','',0),(519902,14442,'th','à¸šà¸±à¸à¸Šà¸µà¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(519903,14442,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤ªà¤¾à¤²à¤¤à¥‚ à¤¶à¥à¤²à¥à¤• à¤–à¤¾à¤¤à¤¾',0),(519904,14442,'ms','Kos haiwan kesayangan awal akaun',0),(519905,14442,'ar','Ø­Ø³Ø§Ø¨ Ø±Ø³ÙˆÙ… Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(519906,14442,'fr','Compte initial frais pour animaux de compagnie',0),(519907,14442,'jp','åˆæœŸã®ãƒšãƒƒãƒˆæ–™é‡‘ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(519908,14442,'pt','Taxa de estimaÃ§Ã£o inicial conta',0),(519909,14442,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿ÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸Ðµ Ð¶Ð¸Ð²Ð¾Ñ‚Ð½Ñ‹Ðµ',0),(519910,14442,'es','Cuenta de cuota inicial para mascotas',0),(519911,14442,'de','Erste Haustier GebÃ¼hrenkonto',0),(519912,14442,'en','Initial Pet Fee Account',0),(519913,14443,'is','',0),(519914,14443,'dr','Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø­Ø³Ø§Ø¨',0),(519915,14443,'pr','Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ù…Ø§Ù‡Ø§Ù†Ù‡ Ø­Ø³Ø§Ø¨',0),(519916,14443,'tr','AylÄ±k evde beslenen hayvan Ã¼cret hesabÄ±',0),(519917,14443,'pl','MiesiÄ™czna opÅ‚ata za zwierzÄ™ konta',0),(519918,14443,'bg','ÐœÐµÑÐµÑ‡Ð½Ð° Ñ‚Ð°ÐºÑÐ° Ð·Ð° Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(519919,14443,'ur','Ù…Ø§ÛØ§Ù†Û Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ±ÙˆÚº Ú©ÛŒ ÙÛŒØ³ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(519920,14443,'sr','ÐœÐµÑÐµÑ‡Ð½Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ñ™ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ð½Ð°ÐºÐ½Ð°Ð´Ð°',0),(519921,14443,'vi','TÃ i khoáº£n váº­t nuÃ´i lá»‡ phÃ­ hÃ ng thÃ¡ng',0),(519922,14443,'af','Maandelikse fooi troeteldier rekening',0),(519923,14443,'ro','Cont lunar taxa animal de casÄƒ',0),(519924,14443,'et','Igakuine tasu lemmiklooma eest konto',0),(519925,14443,'si','MeseÄni raÄun jjeza pristojbina',0),(519926,14443,'ba','Bulanan Account biaya hewan peliharaan',0),(519927,14443,'nl','Maandelijkse huisdier vergoeding rekening',0),(519928,14443,'fi','Kuukausittain hellitellÃ¤ lisÃ¤maksun tili',0),(519929,14443,'no','MÃ¥nedlig Pet avgift konto',0),(519930,14443,'da','Pet gebyr mÃ¥nedsoversigt',0),(519931,14443,'ko','ì›”ê°„ ì• ì™„ ë™ë¬¼ ë¹„ìš© ê³„ì •',0),(519932,14443,'he','×—×©×‘×•×Ÿ ×—×•×“×©×™ ×“×ž×™ ×œ×—×™×•×ª ×ž×—×ž×“',0),(519933,14443,'el','ÎœÎ·Î½Î¹Î±Î¯Î± Î±Î¼Î¿Î¹Î²Î® ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ Î¶ÏŽÎ¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(519934,14443,'zh','æ¯æœˆçš„å® ç‰©çš„è´¹ç”¨å¸æˆ·',0),(519935,14443,'sv','Avgift fÃ¶r husdjur MÃ¥nadskalkyl',0),(519936,14443,'it','Conto mensile di supplemento per animali domestici',0),(519937,14443,'tl','',0),(519938,14443,'th','à¸šà¸±à¸à¸Šà¸µà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡à¸£à¸²à¸¢à¹€à¸”à¸·à¸­à¸™',0),(519939,14443,'hi','à¤®à¤¾à¤¸à¤¿à¤• à¤¶à¥à¤²à¥à¤• à¤•à¥‡ à¤ªà¤¾à¤²à¤¤à¥‚ à¤–à¤¾à¤¤à¥‡',0),(519940,14443,'ms','Bulanan akaun kos haiwan kesayangan',0),(519941,14443,'ar','Ø­Ø³Ø§Ø¨ Ø±Ø³ÙˆÙ… Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø§Ù„Ø´Ù‡Ø±ÙŠ',0),(519942,14443,'fr','Mensuel compte d\'animaux de compagnie',0),(519943,14443,'jp','æ¯Žæœˆã®ãƒšãƒƒãƒˆæ–™é‡‘ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(519944,14443,'pt','Conta mensal de taxa do animal de estimaÃ§Ã£o',0),(519945,14443,'ru','Ð•Ð¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸Ðµ Ð¶Ð¸Ð²Ð¾Ñ‚Ð½Ñ‹Ðµ',0),(519946,14443,'es','Cuenta mensual de mascotas',0),(519947,14443,'de','Haustier-GebÃ¼hr Monatsrechnung',0),(519948,14443,'en','Monthly Pet Fee Account',0),(519949,14444,'is','',0),(519950,14444,'dr','Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(519951,14444,'pr','Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(519952,14444,'tr','Ã–n Ã¶deme',0),(519953,14444,'pl','Przed dokonaniem pÅ‚atnoÅ›ci',0),(519954,14444,'bg','ÐÐ²Ð°Ð½ÑÐ¾Ð²Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(519955,14444,'ur','Ù‚Ø¨Ù„ Ø§Ø² Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(519956,14444,'sr','ÐŸÑ€Ðµ-Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(519957,14444,'vi','Thanh toÃ¡n trÆ°á»›c',0),(519958,14444,'af','Pre-betaling',0),(519959,14444,'ro','PlatÄƒ Ã®n avans',0),(519960,14444,'et','Eelsetele',0),(519961,14444,'si','PredplaÄila',0),(519962,14444,'ba','Pra-pembayaran',0),(519963,14444,'nl','Vooruitbetaling',0),(519964,14444,'fi','Ennakkomaksu',0),(519965,14444,'no','Forskuddsbetaling',0),(519966,14444,'da','Forudbetaling',0),(519967,14444,'ko','ì‚¬ì „ ì§€ë¶ˆ',0),(519968,14444,'he','×ª×©×œ×•× ×ž×¨××©',0),(519969,14444,'el','Î ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î®',0),(519970,14444,'zh','é¢„ä»˜è´¹',0),(519971,14444,'sv','FÃ¶rskottsbetalning',0),(519972,14444,'it','Pagamento anticipato',0),(519973,14444,'tl','',0),(519974,14444,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²',0),(519975,14444,'hi','à¤ªà¥‚à¤°à¥à¤µ-à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(519976,14444,'ms','Bayaran pendahuluan',0),(519977,14444,'ar','Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø³Ø¨Ù‚',0),(519978,14444,'fr','Paiement anticipÃ©',0),(519979,14444,'jp','äº‹å‰ã®ãŠæ”¯æ‰•ã„',0),(519980,14444,'pt','PrÃ©-pagamento',0),(519981,14444,'ru','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð°Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ð°',0),(519982,14444,'es','Pago por adelantado',0),(519983,14444,'de','Vorauszahlung',0),(519984,14444,'en','Pre-Payment',0),(519985,14445,'is','',0),(519986,14445,'dr','Ø§Ù…Ø¶Ø§Ø¡ Ú©Ù†Ù†Ø¯Ù‡ 3',0),(519987,14445,'pr','Ø§Ù…Ø¶Ø§Ø¡ Ú©Ù†Ù†Ø¯Ù‡ 3',0),(519988,14445,'tr','Ä°mzalayanÄ±n 3',0),(519989,14445,'pl','Osoba podpisujÄ…ca 3',0),(519990,14445,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ 3',0),(519991,14445,'ur','Ø¯Ø³ØªØ®Ø· Ú©Ù†Ù†Ø¯Û 3',0),(519992,14445,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ½Ð¸Ðº 3',0),(519993,14445,'vi','NgÆ°á»i kÃ½ 3',0),(519994,14445,'af','Ondertekenaar 3',0),(519995,14445,'ro','Semnatar 3',0),(519996,14445,'et','Allkirjastaja 3',0),(519997,14445,'si','Podpisnika 3',0),(519998,14445,'ba','Penandatangan 3',0),(519999,14445,'nl','Ondertekenaar 3',0),(520000,14445,'fi','Allekirjoittaja 3',0),(520001,14445,'no','Signataren 3',0),(520002,14445,'da','Underskriveren 3',0),(520003,14445,'ko','ì„œëª…ìž 3',0),(520004,14445,'he','×”×—×•×ª× 3',0),(520005,14445,'el','Î¥Ï€Î¿Î³ÏÎ¬Ï†Ï‰Î½ 3',0),(520006,14445,'zh','ç­¾åè€… 3',0),(520007,14445,'sv','Signerat 3',0),(520008,14445,'it','Firmatario 3',0),(520009,14445,'tl','',0),(520010,14445,'th','à¸œà¸¹à¹‰à¸¥à¸‡à¸™à¸²à¸¡ 3',0),(520011,14445,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°à¤•à¤°à¥à¤¤à¤¾ 3',0),(520012,14445,'ms','Penandatangan 3',0),(520013,14445,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ 3',0),(520014,14445,'fr','Signataire 3',0),(520015,14445,'jp','ç½²åè€… 3',0),(520016,14445,'pt','SignatÃ¡rio 3',0),(520017,14445,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð²ÑˆÐµÐ³Ð¾ 3',0),(520018,14445,'es','Firmante 3',0),(520019,14445,'de','Signer 3',0),(520020,14445,'en','Signer 3',0),(520021,14446,'is','',0),(520022,14446,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø­Ø³Ø§Ø¨ GL Ú©Ù…Ú© ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù† Ùˆ Ø¢Ø³ÛŒØ¨ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.',0),(520023,14446,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø­Ø³Ø§Ø¨ GL Ú©Ù…Ú© ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù† Ùˆ Ø¢Ø³ÛŒØ¨ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯.',0),(520024,14446,'tr','Temizleme/hasar kabartma GL hesabÄ± seÃ§meniz gerekir.',0),(520025,14446,'pl','NaleÅ¼y wybraÄ‡ konto GL ulga czyszczenie/uszkodzenia.',0),(520026,14446,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð·Ð° GL Ð½Ð° Ñ‡Ð¸ÑÑ‚ÐµÐ½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ.',0),(520027,14446,'ur','Ø¢Ù¾ Ø§ÛŒÚ© ØµÙØ§Ø¦ÛŒ/Ù†Ù‚ØµØ§Ù† Ø±ÛŒÙ„ÛŒÙ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Û”',0),(520028,14446,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð“Ð› Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ Ð·Ð° Ñ‡Ð¸ÑˆÑ›ÐµÑšÐµ/Ð¾ÑˆÑ‚ÐµÑ›ÐµÑšÐ°.',0),(520029,14446,'vi','Báº¡n pháº£i chá»n má»™t tÃ i khoáº£n GL cá»©u trá»£ háº¥p/thiá»‡t háº¡i.',0),(520030,14446,'af','Jy moet \'n skoonmaker/skade verligting GL rekening kies.',0),(520031,14446,'ro','Trebuie sÄƒ selectaÅ£i o chimicÄƒ/daune Relief GL cont.',0),(520032,14446,'et','Valige puhastus/kahju leevendamiseks pearaamatukontole.',0),(520033,14446,'si','ÄŒistilnica/Å¡kodo Relief GL raÄun, morate izbrati.',0),(520034,14446,'ba','Anda harus memilih rekening GL Relief Cleaning kerusakan.',0),(520035,14446,'nl','U moet een reinigen/schade Relief GL Account selecteren.',0),(520036,14446,'fi','Valitse pesu/vahinko helpotusta kÃ¤ytetÃ¤Ã¤nkÃ¶ KP-tiliÃ¤.',0),(520037,14446,'no','Du mÃ¥ velge en rengjÃ¸ring/skade lettelse GL konto.',0),(520038,14446,'da','Du skal vÃ¦lge en rengÃ¸ring/skader Relief GL konto.',0),(520039,14446,'ko','í´ë¦¬ë‹/í”¼í•´ êµ¬ì œ GL ê³„ì •ì„ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(520040,14446,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×—×©×‘×•×Ÿ GL ×”×§×œ×” × ×™×§×•×™/× ×–×§.',0),(520041,14446,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ¼Î±/Î¶Î·Î¼Î¯Î± Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î».',0),(520042,14446,'zh','æ‚¨å¿…é¡»é€‰æ‹©ä¸€ä¸ªæ¸…æ´/æŸå®³æ•‘æµŽ GL å¸æˆ·ã€‚',0),(520043,14446,'sv','Du mÃ¥ste vÃ¤lja en rengÃ¶ring/skada lÃ¤ttnad GL konto.',0),(520044,14446,'it','Ãˆ necessario selezionare un Account di GL pulizia/danno sollievo.',0),(520045,14446,'tl','',0),(520046,14446,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸šà¸±à¸à¸Šà¸µ GL à¸šà¸£à¸£à¹€à¸—à¸²à¸‹à¸±à¸/à¸„à¸§à¸²à¸¡à¹€à¸ªà¸µà¸¢à¸«à¸²à¸¢',0),(520047,14446,'hi','à¤¤à¥à¤® à¤à¤• à¤•à¥à¤²à¥€à¤¨à¤¿à¤‚à¤—/à¤•à¥à¤·à¤¤à¤¿ à¤°à¤¾à¤¹à¤¤ GL à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾à¥¤',0),(520048,14446,'ms','Anda mesti memilih akaun GL pelepasan kering/kerosakan.',0),(520049,14446,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ ØªØ­Ø¯ÙŠØ¯ \"Ø­Ø³Ø§Ø¨ GL Ø§Ù„Ø¥ØºØ§Ø«Ø©\" ØªÙ†Ø¸ÙŠÙ/Ø§Ù„Ø¶Ø±Ø±.',0),(520050,14446,'fr','Vous devez sÃ©lectionner un nettoyage/dommages secours GL compte.',0),(520051,14446,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(520052,14446,'pt','VocÃª deve selecionar uma conta de GL do alÃ­vio de limpeza e danos.',0),(520053,14446,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ GL Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð¾Ð²/Ð¿Ð¾Ð²Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ñ.',0),(520054,14446,'es','Debe seleccionar una cuenta de GL alivio de limpieza o daÃ±os.',0),(520055,14446,'de','Sie mÃ¼ssen eine Reinigung/Schaden Relief-GL-Konto auswÃ¤hlen.',0),(520056,14446,'en','You must select a Cleaning/Damage Relief GL Account.',0),(520057,14447,'is','',0),(520058,14447,'dr','Ù…Ø³ØªØ§Ø¬Ø± Ù‡Ù…Ú©Ø§Ø±ÛŒ 2 Ø§ÛŒÙ…ÛŒÙ„',0),(520059,14447,'pr','Ù…Ø³ØªØ§Ø¬Ø± Ù‡Ù…Ú©Ø§Ø±ÛŒ 2 Ø§ÛŒÙ…ÛŒÙ„',0),(520060,14447,'tr','Ortak kiracÄ± 2 e-posta',0),(520061,14447,'pl','WspÃ³Å‚pracy najemca 2 E-mail',0),(520062,14447,'bg','Ð¡ÑŠ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ» 2 Ð¸Ð¼ÐµÐ¹Ð»',0),(520063,14447,'ur','Ù…Ø®Ù„ÙˆØ· Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± 2 Ø§ÛŒ Ù…ÛŒÙ„',0),(520064,14447,'sr','ÐšÐ¾Ð»ÐµÐ³Ð° ÑÑ‚Ð°Ð½Ð°Ñ€ 2 Ð•Ð¼Ð°Ð¸Ð»',0),(520065,14447,'vi','Äá»“ng ngÆ°á»i thuÃª nhÃ  2 Email',0),(520066,14447,'af','Mede-huurder 2 e-pos',0),(520067,14447,'ro','Co-chiriaÅŸ 2 Email',0),(520068,14447,'et','KoostÃ¶Ã¶ Ã¼Ã¼rnik 2 e-posti',0),(520069,14447,'si','Co-najemnik 2 Email',0),(520070,14447,'ba','Email penyewa Co 2',0),(520071,14447,'nl','Co huurder 2 E-mail',0),(520072,14447,'fi','YhteistyÃ¶tÃ¤ vuokralainen 2 sÃ¤hkÃ¶posti',0),(520073,14447,'no','Leietaker co 2 e-post',0),(520074,14447,'da','Co lejer 2 E-mail',0),(520075,14447,'ko','ê³µë™ ê±°ì£¼ìž 2 ì´ë©”ì¼',0),(520076,14447,'he','×”×“×™×™×¨ ×©×•×ª×£ 2 ×“×•×',0),(520077,14447,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ ÏƒÏ…Î½-ÎµÎ½Î¿Î¹ÎºÎ¹Î±ÏƒÏ„Î®Ï‚ 2',0),(520078,14447,'zh','åˆç§Ÿ 2 ç”µå­é‚®ä»¶',0),(520079,14447,'sv','Co hyresgÃ¤st 2 e',0),(520080,14447,'it','Co-inquilino 2 Email',0),(520081,14447,'tl','',0),(520082,14447,'th','à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¸£à¹ˆà¸§à¸¡ 2 à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(520083,14447,'hi','à¤¸à¤¹ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° 2 à¤ˆà¤®à¥‡à¤²',0),(520084,14447,'ms','E-mel bersama penyewa 2',0),(520085,14447,'ar','Ù…Ø³ØªØ£Ø¬Ø± 2 Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(520086,14447,'fr','Colocataire 2 Email',0),(520087,14447,'jp','å…±åŒãƒ†ãƒŠãƒ³ãƒˆ 2 ãƒ¡ãƒ¼ãƒ«',0),(520088,14447,'pt','E-mail inquilino co 2',0),(520089,14447,'ru','Ð¡Ð¾Ð¿Ñ€ÐµÐ´ÑÐµÐ´Ð°Ñ‚ÐµÐ»ÑŒ Ð°Ñ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ 2 Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð°Ñ Ð¿Ð¾Ñ‡Ñ‚Ð°',0),(520090,14447,'es','Correo electrÃ³nico inquilino CO 2',0),(520091,14447,'de','Co Mieter 2 Email',0),(520092,14447,'en','Co-Tenant 2 Email',0),(520093,14448,'is','',0),(520094,14448,'dr','Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø¹Ø¨Ø§Ø±ØªÙ†Ø¯ Ø§Ø²:',0),(520095,14448,'pr','Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø¹Ø¨Ø§Ø±ØªÙ†Ø¯ Ø§Ø²:',0),(520096,14448,'tr','Bir ilk evde beslenen hayvan Ã¼creti dahil',0),(520097,14448,'pl','ObejmujÄ… opÅ‚aty wstÄ™pnej zwierzÄ™',0),(520098,14448,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¿ÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°Ñ‚Ð° Ð³Ð°Ð»ÐµÐ½Ð¸Ðº Ñ‚Ð°ÐºÑÐ°',0),(520099,14448,'ur','Ø§ÛŒÚ© Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ±ÙˆÚº Ú©ÛŒ ÙÛŒØ³ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(520100,14448,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ Ð¸ Ð¿Ð¾Ñ‡ÐµÑ‚Ð½Ñƒ Ð½Ð°ÐºÐ½Ð°Ð´Ñƒ Ð·Ð° ÐºÑƒÑ›Ð½Ðµ Ñ™ÑƒÐ±Ð¸Ð¼Ñ†Ðµ',0),(520101,14448,'vi','Bao gá»“m má»™t khoáº£n phÃ­ ban Ä‘áº§u váº­t nuÃ´i',0),(520102,14448,'af','Sluit \'n aanvanklike fooi troeteldier',0),(520103,14448,'ro','Include o taxÄƒ iniÅ£ialÄƒ pentru animale de companie',0),(520104,14448,'et','Sisaldavad esialgset lemmiklooma tasu',0),(520105,14448,'si','VkljuÄuje zaÄetno pristojbino za hiÅ¡ne',0),(520106,14448,'ba','Termasuk biaya hewan peliharaan awal',0),(520107,14448,'nl','Een initiÃ«le huisdier kosten omvatten',0),(520108,14448,'fi','SisÃ¤ltÃ¤Ã¤ alkuperÃ¤isen LemmikkielÃ¤inmaksu',0),(520109,14448,'no','Inkluder en innledende Pet gebyr',0),(520110,14448,'da','Omfatte en indledende Pet gebyr',0),(520111,14448,'ko','ì´ˆê¸° ì• ì™„ ë™ë¬¼ ë¹„ìš© í¬í•¨',0),(520112,14448,'he','×›×•×œ×œ×™× ×ª×©×œ×•× ×¨××©×•× ×™ ×œ×—×™×•×ª ×ž×—×ž×“',0),(520113,14448,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î¼Î¹Î± Î±ÏÏ‡Î¹ÎºÎ® Ï‡ÏÎ­Ï‰ÏƒÎ· ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Ï‰Î½ Î¶ÏŽÏ‰Î½',0),(520114,14448,'zh','åŒ…æ‹¬åˆå§‹çš„å® ç‰©è´¹',0),(520115,14448,'sv','Inkludera en sÃ¤llskapsdjur startavgift',0),(520116,14448,'it','Includono un costo iniziale dell\'animale domestico',0),(520117,14448,'tl','',0),(520118,14448,'th','à¸£à¸§à¸¡à¸„à¹ˆà¸²à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡à¹€à¸›à¹‡à¸™à¸•à¹‰à¸™',0),(520119,14448,'hi','à¤à¤• à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤¶à¥à¤²à¥à¤• à¤•à¥‡ à¤ªà¤¾à¤²à¤¤à¥‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(520120,14448,'ms','Termasuk yuran permulaan haiwan kesayangan',0),(520121,14448,'ar','ÙˆØªØ´Ù…Ù„ Ø±Ø³ÙˆÙ… Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(520122,14448,'fr','Inclure une premiÃ¨re somme pour animaux de compagnie',0),(520123,14448,'jp','åˆæœŸã®ãƒšãƒƒãƒˆæ–™é‡‘ãŒå«ã¾ã‚Œã¾ã™',0),(520124,14448,'pt','Incluem uma taxa inicial de estimaÃ§Ã£o',0),(520125,14448,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ð¿ÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð²Ð·Ð½Ð¾Ñ ÐŸÐ­Ð¢',0),(520126,14448,'es','Incluyen una cuota inicial del animal domÃ©stico',0),(520127,14448,'de','GehÃ¶ren Sie ein Haustier Ausgabeaufschlag',0),(520128,14448,'en','Include An Initial Pet Fee',0),(520129,14449,'is','',0),(520130,14449,'dr','Ø´Ø§Ù…Ù„ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ú©Ù…Ú© ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨',0),(520131,14449,'pr','Ø´Ø§Ù…Ù„ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ú©Ù…Ú© ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨',0),(520132,14449,'tr','Temizlik/hasar YardÄ±mÄ± tutarÄ± dahil et',0),(520133,14449,'pl','To kwota ulgi czyszczenia szkody',0),(520134,14449,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¿Ð¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ ÑÑƒÐ¼Ð°',0),(520135,14449,'ur','Ø§ÛŒÚ© ØµÙØ§Ø¦ÛŒ/Ù†Ù‚ØµØ§Ù† Ø§Ù…Ø¯Ø§Ø¯ÛŒ Ø±Ù‚Ù… Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(520136,14449,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ Ð¸Ð·Ð½Ð¾Ñ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ Ð·Ð° Ñ‡Ð¸ÑˆÑ›ÐµÑšÐµ/ÑˆÑ‚ÐµÑ‚Ðµ',0),(520137,14449,'vi','Bao gá»“m má»™t sá»‘ tiá»n cá»©u trá»£ lÃ m sáº¡ch/thiá»‡t háº¡i',0),(520138,14449,'af','\'N skoonmaak/skade verligting bedrag insluit',0),(520139,14449,'ro','Include o sumÄƒ de Relief de curÄƒÅ£are/daune',0),(520140,14449,'et','Puhastamine/kahju maksuvabastuse summa hulka',0),(520141,14449,'si','VkljuÄuje ÄiÅ¡Äenje Å¡kode odpis zneska',0),(520142,14449,'ba','Termasuk sejumlah Relief pembersihan kerusakan',0),(520143,14449,'nl','Omvatten een reiniging/schade Relief bedrag',0),(520144,14449,'fi','Kuuluvat pesu/vahinkojen helpotusta mÃ¤Ã¤rÃ¤Ã¤',0),(520145,14449,'no','Inkluder rengjÃ¸ring/skade lettelse belÃ¸p',0),(520146,14449,'da','Omfatte en rengÃ¸ring/skader Relief belÃ¸b',0),(520147,14449,'ko','ì²­ì†Œ/í”¼í•´ êµ¬ì œ ê¸ˆì•¡ í¬í•¨',0),(520148,14449,'he','×›×•×œ×œ×™× ×›×ž×•×ª ×”×§×œ×” × ×™×§×•×™/× ×–×§',0),(520149,14449,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î­Î½Î± Ï€Î¿ÏƒÏŒ Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ· ÎºÎ±Î¸Î±ÏÎ¹ÏƒÎ¼Î¿Ï/Î¶Î·Î¼Î¯Î±',0),(520150,14449,'zh','åŒ…æ‹¬æ¸…æ´—/æŸå®³æ•‘æµŽé‡‘é¢',0),(520151,14449,'sv','Inkludera en rengÃ¶ring/skada lÃ¤ttnad',0),(520152,14449,'it','Comprendono una quantitÃ  di pulizia/danno sollievo',0),(520153,14449,'tl','',0),(520154,14449,'th','à¸£à¸§à¸¡à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸Šà¹ˆà¸§à¸¢à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¸„à¸§à¸²à¸¡à¹€à¸ªà¸µà¸¢à¸«à¸²à¸¢',0),(520155,14449,'hi','à¤à¤• à¤¸à¤«à¤¾à¤ˆ/à¤•à¥à¤·à¤¤à¤¿ à¤°à¤¾à¤¹à¤¤ à¤°à¤¾à¤¶à¤¿ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(520156,14449,'ms','Termasuk jumlah pelepasan yang kering/kerosakan',0),(520157,14449,'ar','ÙˆØªØ´Ù…Ù„ ÙƒÙ…ÙŠØ© Ø¥ØºØ§Ø«Ø© ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø±',0),(520158,14449,'fr','Inclure un montant de secours nettoyage/dommages',0),(520159,14449,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆé¡ã‚’å«ã‚ã‚‹',0),(520160,14449,'pt','Incluir uma quantidade de alÃ­vio de limpeza/danos',0),(520161,14449,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ ÑÑƒÐ¼Ð¼Ñƒ Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð¾Ñ‡Ð¸ÑÑ‚ÐºÐ¸/Ð¿Ð¾Ð²Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ñ',0),(520162,14449,'es','Incluyen una cantidad de alivio de la limpieza o daÃ±os',0),(520163,14449,'de','Beinhalten Sie eine Reinigung/Schaden-Relief-Menge',0),(520164,14449,'en','Include A Cleaning/Damage Relief Amount',0),(520165,14450,'is','',0),(520166,14450,'dr','Ù„Ø·ÙØ§Ù‹ ÛŒÚ© Ø­Ø±Ú©Øª Ø¯Ø± ØªØ§Ø±ÛŒØ® Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(520167,14450,'pr','Ù„Ø·ÙØ§Ù‹ ÛŒÚ© Ø­Ø±Ú©Øª Ø¯Ø± ØªØ§Ø±ÛŒØ® Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(520168,14450,'tr','LÃ¼tfen bir hareket tarihi seÃ§in',0),(520169,14450,'pl','Wybierz ruch w dniu',0),(520170,14450,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐµÐ´Ð¸Ð½ Ñ…Ð¾Ð´ Ð² Ñ‚Ð¾Ð·Ð¸ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚',0),(520171,14450,'ur','Ø§ÛŒÚ© Ø§Ù‚Ø¯Ø§Ù… Ù…ÛŒÚº ØªØ§Ø±ÛŒØ® Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(520172,14450,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ‚ÐµÐ· Ñƒ Ð´Ð°Ñ‚ÑƒÐ¼',0),(520173,14450,'vi','Vui lÃ²ng chá»n má»™t Ä‘á»™ng thÃ¡i trong ngÃ y',0),(520174,14450,'af','Kies asseblief \'n skuif In datum',0),(520175,14450,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i o mutare Ã®n data',0),(520176,14450,'et','Palun valige liikuda kuupÃ¤eva',0),(520177,14450,'si','Izberite prehod v datum',0),(520178,14450,'ba','Silakan pilih bergerak tanggal',0),(520179,14450,'nl','Selecteer een beweging In datum',0),(520180,14450,'fi','Valitse liikkua pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(520181,14450,'no','Velg et trekk ut dato',0),(520182,14450,'da','VÃ¦lg venligst et trÃ¦k i dato',0),(520183,14450,'ko','ë‚ ì§œì—ì„œ ì´ë™ì„ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(520184,14450,'he','× × ×‘×—×¨ ×ž×”×œ×š ×ª××¨×™×š',0),(520185,14450,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± ÎºÎ¯Î½Î·ÏƒÎ· Î±Ï€ÏŒ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(520186,14450,'zh','è¯·åœ¨æ—¥æœŸä¸­é€‰æ‹©ç§»åŠ¨',0),(520187,14450,'sv','VÃ¤nligen vÃ¤lj ett drag i datum',0),(520188,14450,'it','Si prega di selezionare una mossa In data',0),(520189,14450,'tl','',0),(520190,14450,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸¥à¸·à¸­à¸à¸à¸²à¸£à¸¢à¹‰à¸²à¸¢à¹ƒà¸™à¸§à¸±à¸™',0),(520191,14450,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤šà¤¾à¤² à¤®à¥‡à¤‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(520192,14450,'ms','Sila pilih satu tarikh',0),(520193,14450,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ ØªØ­Ø±Ùƒ ÙÙŠ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(520194,14450,'fr','Veuillez sÃ©lectionner un dÃ©mÃ©nagement en Date',0),(520195,14450,'jp','æ—¥ä»˜ã®ç§»å‹•ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(520196,14450,'pt','Por favor, selecione um movimento na data',0),(520197,14450,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑˆÐ°Ð³ Ð² Ð”Ð°Ñ‚Ð°',0),(520198,14450,'es','Por favor seleccione un movimiento en fecha',0),(520199,14450,'de','Bitte wÃ¤hlen Sie eine Bewegung im Datum',0),(520200,14450,'en','Please Select A Move In Date',0),(520201,14451,'is','',0),(520202,14451,'dr','Ù…Ø¨Ù„Øº Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(520203,14451,'pr','Ù…Ø¨Ù„Øº Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(520204,14451,'tr','Ã–n Ã¶deme tutarÄ±',0),(520205,14451,'pl','Kwota przedpÅ‚aty',0),(520206,14451,'bg','Ð¡ÑƒÐ¼Ð° Ð·Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(520207,14451,'ur','Ù‚Ø¨Ù„ Ø§Ø² Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù‚Ù…',0),(520208,14451,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ñ€ÐµÐ´-Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(520209,14451,'vi','Tiá»n má»‡nh giÃ¡ tráº£ tiá»n',0),(520210,14451,'af','Pre-betaling bedrag',0),(520211,14451,'ro','Suma de platÄƒ Ã®n avans',0),(520212,14451,'et','Enne makse summa',0),(520213,14451,'si','Znesek predplaÄila',0),(520214,14451,'ba','Jumlah pra-pembayaran',0),(520215,14451,'nl','Pre-betaling bedrag',0),(520216,14451,'fi','Ennakkomaksun summa',0),(520217,14451,'no','Betaling belÃ¸pet',0),(520218,14451,'da','Forudbetalte belÃ¸b',0),(520219,14451,'ko','ì„  ë‚© ê¸ˆì•¡',0),(520220,14451,'he','×¡×›×•× ×”×ª×©×œ×•× ×ž×¨××©',0),(520221,14451,'el','Î Î¿ÏƒÏŒ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î®',0),(520222,14451,'zh','å‰ä»˜æ¬¾é‡‘é¢',0),(520223,14451,'sv','FÃ¶re betalning belopp',0),(520224,14451,'it','Importo del pagamento anticipato',0),(520225,14451,'tl','',0),(520226,14451,'th','à¸¢à¸­à¸”à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²',0),(520227,14451,'hi','à¤ªà¥‚à¤°à¥à¤µ-à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿',0),(520228,14451,'ms','Amaun bayaran pendahuluan',0),(520229,14451,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø³Ø¨Ù‚',0),(520230,14451,'fr','Montant du paiement anticipÃ©',0),(520231,14451,'jp','äº‹å‰ã«ãŠæ”¯æ‰•ã„é‡‘é¡',0),(520232,14451,'pt','Quantidade de prÃ©-pagamento',0),(520233,14451,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð¹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(520234,14451,'es','Cantidad del pago adelantado',0),(520235,14451,'de','Vor der Zahlung',0),(520236,14451,'en','Pre-Payment Amount',0),(520237,14452,'is','',0),(520238,14452,'dr','ØªØ§Ø±ÛŒØ® Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(520239,14452,'pr','ØªØ§Ø±ÛŒØ® Ù¾ÛŒØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(520240,14452,'tr','Ã–n Ã¶deme tarihi',0),(520241,14452,'pl','Data pÅ‚atnoÅ›ci przed',0),(520242,14452,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(520243,14452,'ur','Ù‚Ø¨Ù„ Ø§Ø² Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(520244,14452,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€ÐµÐ´-ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(520245,14452,'vi','Thanh toÃ¡n trÆ°á»›c ngÃ y',0),(520246,14452,'af','Pre-betaling datum',0),(520247,14452,'ro','Data de platÄƒ Ã®n avans',0),(520248,14452,'et','Eelnevalt maksmise kuupÃ¤ev',0),(520249,14452,'si','Pred izplaÄilom datum',0),(520250,14452,'ba','Tanggal pra-pembayaran',0),(520251,14452,'nl','Pre-betaling datum',0),(520252,14452,'fi','Ennen maksun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(520253,14452,'no','FÃ¸r betalingsdatoen',0),(520254,14452,'da','FÃ¸r betalingsdatoen',0),(520255,14452,'ko','ì‚¬ì „ ì§€ë¶ˆ ë‚ ì§œ',0),(520256,14452,'he','×ª××¨×™×š ×ª×©×œ×•× ×ž×¨××©',0),(520257,14452,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î®',0),(520258,14452,'zh','å‰ä»˜æ¬¾æ—¥æœŸ',0),(520259,14452,'sv','FÃ¶re betalningsdatum',0),(520260,14452,'it','Data di pagamento anticipato',0),(520261,14452,'tl','',0),(520262,14452,'th','à¸§à¸±à¸™à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸¥à¹ˆà¸§à¸‡à¸«à¸™à¹‰à¸²',0),(520263,14452,'hi','à¤ªà¥‚à¤°à¥à¤µ-à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿',0),(520264,14452,'ms','Tarikh bayaran pendahuluan',0),(520265,14452,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø³Ø¨Ù‚',0),(520266,14452,'fr','Date de paiement anticipÃ©',0),(520267,14452,'jp','äº‹å‰ã®ãŠæ”¯æ‰•ã„ã®æ—¥ä»˜',0),(520268,14452,'pt','Data de pre-pagamento',0),(520269,14452,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð¹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(520270,14452,'es','Fecha de pago adelantado',0),(520271,14452,'de','Vorauszahlung-Datum',0),(520272,14452,'en','Pre-Payment Date',0),(520273,14453,'is','',0),(520274,14453,'dr','Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(520275,14453,'pr','Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(520276,14453,'tr','GÃ¶nderilmiÅŸ app',0),(520277,14453,'pl','Aplikacja przekazywane',0),(520278,14453,'bg','ÐÐ¿ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð¸',0),(520279,14453,'ur','Ø¹Ø±Ø¶ Ú©ÛŒØ§ Ø§Ù¾Ù„ÛŒ Ú©ÛŒØ´Ù†',0),(520280,14453,'sr','ÐÐ¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð¿Ñ€ÐµÐ´Ð°Ð¾',0),(520281,14453,'vi','á»¨ng dá»¥ng gá»­i',0),(520282,14453,'af','App voorgelÃª',0),(520283,14453,'ro','App prezentate',0),(520284,14453,'et','Esitatud app',0),(520285,14453,'si','App vpisali',0),(520286,14453,'ba','Aplikasi diajukan',0),(520287,14453,'nl','App afkomstig',0),(520288,14453,'fi','LÃ¤hettÃ¤neet App',0),(520289,14453,'no','App innsendt',0),(520290,14453,'da','App indsendt',0),(520291,14453,'ko','ì‘ìš© í”„ë¡œê·¸ëž¨ ì œì¶œ',0),(520292,14453,'he','App × ××¡×¤×•',0),(520293,14453,'el','App Ï€Î¿Ï… Ï…Ï€Î¿Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹',0),(520294,14453,'zh','æäº¤çš„åº”ç”¨ç¨‹åº',0),(520295,14453,'sv','App som skickats in',0),(520296,14453,'it','App inserita',0),(520297,14453,'tl','',0),(520298,14453,'th','App à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡',0),(520299,14453,'hi','App à¤ªà¥à¤°à¤¸à¥à¤¤à¥à¤¤',0),(520300,14453,'ms','Aplikasi yang dikemukakan',0),(520301,14453,'ar','Ø§Ù„ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ù…Ù‚Ø¯Ù…',0),(520302,14453,'fr','App soumis',0),(520303,14453,'jp','ã‚¢ãƒ—ãƒªã®æå‡º',0),(520304,14453,'pt','App enviado',0),(520305,14453,'ru','ÐŸÑ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¾',0),(520306,14453,'es','App presentada',0),(520307,14453,'de','App eingereicht',0),(520308,14453,'en','App Submitted',0),(520309,14454,'is','',0),(520310,14454,'dr','Ø´Ø§Ù…Ù„ ÙØ³Ø®',0),(520311,14454,'pr','Ø´Ø§Ù…Ù„ ÙØ³Ø®',0),(520312,14454,'tr','Dahil sonlandÄ±rÄ±ldÄ±',0),(520313,14454,'pl','ObejmujÄ… zakoÅ„czony',0),(520314,14454,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð¸ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÐµÐ½Ð¸',0),(520315,14454,'ur','Ø´Ø§Ù…Ù„ ÛÛŒÚº Ø®ØªÙ… ÛÙˆ Ú¯ÛŒØ§',0),(520316,14454,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¿Ñ€ÐµÐºÐ¸Ð½ÑƒÑ‚',0),(520317,14454,'vi','Bao gá»“m cháº¥m dá»©t',0),(520318,14454,'af','Sluit beÃ«indig',0),(520319,14454,'ro','Includ reziliat',0),(520320,14454,'et','Sisaldab lÃµpetatud',0),(520321,14454,'si','VkljuÄujejo prekinjen',0),(520322,14454,'ba','Termasuk dihentikan',0),(520323,14454,'nl','Omvatten beÃ«indigd',0),(520324,14454,'fi','Kuuluu pÃ¤Ã¤ttÃ¤Ã¤',0),(520325,14454,'no','Inkluderer avsluttet',0),(520326,14454,'da','Omfatter afsluttes',0),(520327,14454,'ko','í¬í•¨ ì¢…ë£Œ',0),(520328,14454,'he','×›×•×œ×œ×™× ×”×¡×ª×™×™×',0),(520329,14454,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï„ÎµÏÎ¼Î±Ï„Î¹ÏƒÏ„ÎµÎ¯',0),(520330,14454,'zh','åŒ…æ‹¬ç»ˆæ­¢',0),(520331,14454,'sv','Inkluderar avslutas',0),(520332,14454,'it','Includono terminato',0),(520333,14454,'tl','',0),(520334,14454,'th','à¸£à¸§à¸¡à¸–à¸¶à¸‡à¸¢à¸à¹€à¸¥à¸´à¸',0),(520335,14454,'hi','à¤¶à¤¾à¤®à¤¿à¤² à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤ˆ',0),(520336,14454,'ms','Termasuk ditamatkan',0),(520337,14454,'ar','ÙˆØªØ´Ù…Ù„ Ø¥Ù†Ù‡Ø§Ø¡',0),(520338,14454,'fr','Inclure rÃ©siliÃ©',0),(520339,14454,'jp','å«ã‚ã‚‹çµ‚äº†',0),(520340,14454,'pt','Incluem finalizado',0),(520341,14454,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‰ÐµÐ½Ð¾',0),(520342,14454,'es','Incluya terminada',0),(520343,14454,'de','Sind beendet',0),(520344,14454,'en','Include Terminated',0),(520345,14455,'is','',0),(520346,14455,'dr','Com Ø¢Ø®Ø±ÙŠÙ†',0),(520347,14455,'pr','Com Ø¢Ø®Ø±ÙŠÙ†',0),(520348,14455,'tr','Son Com',0),(520349,14455,'pl','Ostatni Com',0),(520350,14455,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Com',0),(520351,14455,'ur','Ø¢Ø®Ø±ÛŒ Com',0),(520352,14455,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¦Ð¾Ð¼',0),(520353,14455,'vi','Cuá»‘i Com',0),(520354,14455,'af','Laaste Com',0),(520355,14455,'ro','Ultima Com',0),(520356,14455,'et','Viimase Com',0),(520357,14455,'si','Zadnji Com',0),(520358,14455,'ba','Terakhir Com',0),(520359,14455,'nl','Laatste Com',0),(520360,14455,'fi','Viime Com',0),(520361,14455,'no','Siste Com',0),(520362,14455,'da','Sidste Com',0),(520363,14455,'ko','ë§ˆì§€ë§‰ Com',0),(520364,14455,'he','××—×¨×•× ×” Com',0),(520365,14455,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Com',0),(520366,14455,'zh','æœ€åŽä¸€ä¸ª Com',0),(520367,14455,'sv','Senaste Com',0),(520368,14455,'it','Ultimo Com',0),(520369,14455,'tl','',0),(520370,14455,'th','à¸¥à¹ˆà¸²à¸ªà¸¸à¸” Com',0),(520371,14455,'hi','à¤ªà¤¿à¤›à¤²à¥‡ Com',0),(520372,14455,'ms','Com lepas',0),(520373,14455,'ar','Com Ø¢Ø®Ø±',0),(520374,14455,'fr','Dernier Com',0),(520375,14455,'jp','æœ€å¾Œã® Com',0),(520376,14455,'pt','Ãšltima Com',0),(520377,14455,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ ÐºÐ¾Ð¼',0),(520378,14455,'es','Ãšltima Com',0),(520379,14455,'de','Letzten Com',0),(520380,14455,'en','Last Com',0),(520381,14456,'is','',0),(520382,14456,'dr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† Com',0),(520383,14456,'pr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† Com',0),(520384,14456,'tr','Son Com tarihi',0),(520385,14456,'pl','Ostatnia data Com',0),(520386,14456,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Com',0),(520387,14456,'ur','Com Ú©ÛŒ Ø¢Ø®Ø±ÛŒ ØªØ§Ø±ÛŒØ®',0),(520388,14456,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð¦Ð¾Ð¼',0),(520389,14456,'vi','Com ngÃ y cuá»‘i cÃ¹ng',0),(520390,14456,'af','Laaste Com datum',0),(520391,14456,'ro','Ultima data de Com',0),(520392,14456,'et','LÃµppkuupÃ¤eva Com',0),(520393,14456,'si','Datum zadnjega Com',0),(520394,14456,'ba','Tanggal terakhir Com',0),(520395,14456,'nl','Datum van laatste Com',0),(520396,14456,'fi','Com viimeinen',0),(520397,14456,'no','Dato for siste Com',0),(520398,14456,'da','Sidste Com dato',0),(520399,14456,'ko','ë§ˆì§€ë§‰ Com ë‚ ì§œ',0),(520400,14456,'he','×”×ª××¨×™×š ×”××—×¨×•×Ÿ Com',0),(520401,14456,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Com',0),(520402,14456,'zh','Com æ—¥æœŸ',0),(520403,14456,'sv','Datum fÃ¶r senaste Com',0),(520404,14456,'it','Ultima data di Com',0),(520405,14456,'tl','',0),(520406,14456,'th','à¸¥à¹ˆà¸²à¸ªà¸¸à¸”à¸§à¸±à¸™ Com',0),(520407,14456,'hi','à¤ªà¤¿à¤›à¤²à¥‡ Com à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(520408,14456,'ms','Tarikh Com',0),(520409,14456,'ar','Ø¢Ø®Ø± ØªØ§Ø±ÙŠØ® Ù„ÙƒÙˆÙ…',0),(520410,14456,'fr','DerniÃ¨re Date de Com',0),(520411,14456,'jp','æœ€å¾Œã® Com ã®æ—¥ä»˜',0),(520412,14456,'pt','Ãšltimo encontro Com',0),(520413,14456,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ Com',0),(520414,14456,'es','Com fecha de Ãºltima',0),(520415,14456,'de','Datum der letzten Com',0),(520416,14456,'en','Last Com Date',0),(520417,14457,'is','',0),(520418,14457,'dr','Ø¨Ø¹Ø¯ Com ØªØ§Ø±ÛŒØ®',0),(520419,14457,'pr','Ø¨Ø¹Ø¯ Com ØªØ§Ø±ÛŒØ®',0),(520420,14457,'tr','Sonraki Com tarihi',0),(520421,14457,'pl','NastÄ™pnego dnia Com',0),(520422,14457,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð° Com',0),(520423,14457,'ur','Ø§Ú¯Ù„ÛŒ Com ØªØ§Ø±ÛŒØ®',0),(520424,14457,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ ÑÐ»ÐµÐ´ÐµÑ›ÐµÐ³ Ð¦Ð¾Ð¼',0),(520425,14457,'vi','Com ngÃ y tiáº¿p theo',0),(520426,14457,'af','Volgende Com datum',0),(520427,14457,'ro','UrmÄƒtoarea datÄƒ de Com',0),(520428,14457,'et','JÃ¤rgmise Com kuupÃ¤ev',0),(520429,14457,'si','Datum naslednjega Com',0),(520430,14457,'ba','Kencan Com berikutnya',0),(520431,14457,'nl','Volgende Com datum',0),(520432,14457,'fi','Seuraava Com pvm',0),(520433,14457,'no','Neste Com.',0),(520434,14457,'da','Dato for nÃ¦ste Com',0),(520435,14457,'ko','ë‹¤ìŒ Com ë‚ ì§œ',0),(520436,14457,'he','×ª××¨×™×š Com ×”×‘×',0),(520437,14457,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Î—Î¼/Î½Î¯Î± Com',0),(520438,14457,'zh','ä¸‹ä¸€æ¬¡ Com æ—¥æœŸ',0),(520439,14457,'sv','NÃ¤sta Com datum',0),(520440,14457,'it','Il prossimo appuntamento di Com',0),(520441,14457,'tl','',0),(520442,14457,'th','Com à¸§à¸±à¸™à¸–à¸±à¸”à¹„à¸›',0),(520443,14457,'hi','à¤…à¤—à¤²à¥‡ Com à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(520444,14457,'ms','Seterusnya Com tarikh',0),(520445,14457,'ar','ØªØ§Ø±ÙŠØ® Com Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(520446,14457,'fr','Prochaine Date de Com',0),(520447,14457,'jp','æ¬¡ã® Com ã®æ—¥ä»˜',0),(520448,14457,'pt','PrÃ³xima data Com',0),(520449,14457,'ru','Ð”Ð°Ñ‚Ð° ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ³Ð¾ Com',0),(520450,14457,'es','PrÃ³xima fecha Com',0),(520451,14457,'de','Datum des ersten Com',0),(520452,14457,'en','Next Com Date',0),(520453,14458,'is','',0),(520454,14458,'dr','Ù†ÙˆØ¹ Ø¨Ø¹Ø¯ÛŒ Com',0),(520455,14458,'pr','Ù†ÙˆØ¹ Ø¨Ø¹Ø¯ÛŒ Com',0),(520456,14458,'tr','Sonraki Com tÃ¼rÃ¼',0),(520457,14458,'pl','NastÄ™pny typ Com',0),(520458,14458,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¸ÑÑ‚ Ñ‚Ð¸Ð¿ Com',0),(520459,14458,'ur','Ø§Ú¯Ù„Û’ Com Ù‚Ø³Ù…',0),(520460,14458,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ñ‚Ð¸Ð¿ Ð¦Ð¾Ð¼',0),(520461,14458,'vi','Tiáº¿p theo Com loáº¡i',0),(520462,14458,'af','Volgende Com tipe',0),(520463,14458,'ro','UrmÄƒtorul tip de Com',0),(520464,14458,'et','JÃ¤rgmine selline Com-tÃ¼Ã¼p',0),(520465,14458,'si','Naslednja vrsta Com',0),(520466,14458,'ba','Berikutnya jenis Com',0),(520467,14458,'nl','Volgende Com Type',0),(520468,14458,'fi','Seuraava on Com-tyyppi',0),(520469,14458,'no','Neste Com-Type',0),(520470,14458,'da','NÃ¦ste Com Type',0),(520471,14458,'ko','ë‹¤ìŒ Com í˜•ì‹',0),(520472,14458,'he','×¡×•×’ ×”-Com ×”×‘×',0),(520473,14458,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î¿Ï‚ Ï„ÏÏ€Î¿Ï‚ Com',0),(520474,14458,'zh','ä¸‹ä¸€ä¸ª Com ç±»åž‹',0),(520475,14458,'sv','NÃ¤sta Com-typ',0),(520476,14458,'it','Prossimo tipo Com',0),(520477,14458,'tl','',0),(520478,14458,'th','à¸Šà¸™à¸´à¸” Com à¸–à¸±à¸”à¹„à¸›',0),(520479,14458,'hi','à¤…à¤—à¤²à¥‡ Com à¤ªà¥à¤°à¤•à¤¾à¤°',0),(520480,14458,'ms','Seterusnya jenis Com',0),(520481,14458,'ar','Ù†ÙˆØ¹ Com Ø§Ù„Ù‚Ø§Ø¯Ù…',0),(520482,14458,'fr','Prochain Type de Com',0),(520483,14458,'jp','æ¬¡ã® Com åž‹',0),(520484,14458,'pt','PrÃ³ximo tipo Com',0),(520485,14458,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ Ñ‚Ð¸Ð¿ Com',0),(520486,14458,'es','Siguiente tipo Com',0),(520487,14458,'de','NÃ¤chste Com-Typ',0),(520488,14458,'en','Next Com Type',0),(520489,14459,'is','',0),(520490,14459,'dr','Ù‡Ù… Ø§ØªØ§Ù‚ÛŒ',0),(520491,14459,'pr','Ù‡Ù… Ø§ØªØ§Ù‚ÛŒ',0),(520492,14459,'tr','Oda arkadaÅŸÄ±',0),(520493,14459,'pl','WspÃ³Å‚lokatorÃ³w',0),(520494,14459,'bg','Ð¡ÑŠÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ñ‚Ð¸',0),(520495,14459,'ur','Ù…ÛŒÙ¹Ø³',0),(520496,14459,'sr','Ð¦Ð¸Ð¼ÐµÑ€Ð¸',0),(520497,14459,'vi','Báº¡n cÃ¹ng phÃ²ng',0),(520498,14459,'af','Roommates',0),(520499,14459,'ro','Colegi de camerÄƒ',0),(520500,14459,'et','Toakaaslased',0),(520501,14459,'si','Roommates',0),(520502,14459,'ba','Teman sekamar',0),(520503,14459,'nl','Kamergenoten',0),(520504,14459,'fi','Roommates',0),(520505,14459,'no','Romkamerater',0),(520506,14459,'da','BofÃ¦ller',0),(520507,14459,'ko','ë£¸ë©”ì´íŠ¸',0),(520508,14459,'he','×©×•×ª×¤×™× ×œ×“×™×¨×”',0),(520509,14459,'el','Î£Ï…Î³ÎºÎ¬Ï„Î¿Î¹ÎºÎ¿Î¹',0),(520510,14459,'zh','å®¤å‹',0),(520511,14459,'sv','Rumskamrater',0),(520512,14459,'it','Compagni di stanza',0),(520513,14459,'tl','',0),(520514,14459,'th','à¸„à¸™',0),(520515,14459,'hi','à¤•à¤®à¤°à¥‡ à¤®à¥‡à¤‚ à¤°à¤¹à¤¤à¥‡',0),(520516,14459,'ms','Rakan sebilik',0),(520517,14459,'ar','Ø§Ù„Ø­Ø¬Ø±Ø©',0),(520518,14459,'fr','Colocataires',0),(520519,14459,'jp','ãƒ«ãƒ¼ãƒ ãƒ¡ã‚¤ãƒˆ',0),(520520,14459,'pt','Colegas de quarto',0),(520521,14459,'ru','Ð¡Ð¾ÑÐµÐ´Ð¸ Ð¿Ð¾ ÐºÐ¾Ð¼Ð½Ð°Ñ‚Ðµ',0),(520522,14459,'es','CompaÃ±eros de piso',0),(520523,14459,'de','RoomMates Wandsticker',0),(520524,14459,'en','Roommates',0),(520525,14460,'is','',0),(520526,14460,'dr','Ù‡Ù… Ø§ØªØ§Ù‚ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(520527,14460,'pr','Ù‡Ù… Ø§ØªØ§Ù‚ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(520528,14460,'tr','Ä°stenen Oda arkadaÅŸÄ±',0),(520529,14460,'pl','ZgÅ‚oszony wspÃ³Å‚lokatorÃ³w',0),(520530,14460,'bg','Ð˜ÑÐºÐ°Ð½Ð¸ÑÑ‚ ÑÑŠÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ñ‚Ð¸',0),(520531,14460,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø±Ø¯Û Ù…ÛŒÙ¹Ø³',0),(520532,14460,'sr','Ð¢Ñ€Ð°Ð¶ÐµÐ½Ð¸ Ñ†Ð¸Ð¼ÐµÑ€Ð¸',0),(520533,14460,'vi','Báº¡n cÃ¹ng phÃ²ng yÃªu cáº§u',0),(520534,14460,'af','Vereiste Roommates',0),(520535,14460,'ro','SolicitatÄƒ de camerÄƒ',0),(520536,14460,'et','Taotletud toakaaslased',0),(520537,14460,'si','Zahtevane Roommates',0),(520538,14460,'ba','Teman sekamar diminta',0),(520539,14460,'nl','Gevraagde kamergenoten',0),(520540,14460,'fi','PyydettyÃ¤ huonetoveri',0),(520541,14460,'no','Forespurte romkamerater',0),(520542,14460,'da','Anmodede bofÃ¦ller',0),(520543,14460,'ko','ìš”ì²­ ëœ ë£¸ë©”ì´íŠ¸',0),(520544,14460,'he','×©×•×ª×¤×™× ×”×ž×‘×•×§×©',0),(520545,14460,'el','Î–Î·Ï„Î®Î¸Î·ÎºÎµ ÏƒÏ…Î³ÎºÎ¬Ï„Î¿Î¹ÎºÎ¿Î¹',0),(520546,14460,'zh','è¯·æ±‚çš„å®¤å‹',0),(520547,14460,'sv','Ã–nskade rumskamrater',0),(520548,14460,'it','Compagni di stanza richiesti',0),(520549,14460,'tl','',0),(520550,14460,'th','à¸„à¸™à¸—à¸µà¹ˆà¸£à¹‰à¸­à¸‡à¸‚à¸­',0),(520551,14460,'hi','à¤…à¤¨à¥à¤°à¥‹à¤§ à¤•à¤¿à¤ à¤—à¤ à¤•à¤®à¤°à¥‡ à¤®à¥‡à¤‚ à¤°à¤¹à¤¤à¥‡',0),(520552,14460,'ms','Diminta rakan sebilik',0),(520553,14460,'ar','Ø§Ù„Ù…Ø·Ù„ÙˆØ¨ Ù…Ù† ØºØ±ÙÙ‡Ù…',0),(520554,14460,'fr','Colocataires demandÃ©es',0),(520555,14460,'jp','è¦æ±‚ã•ã‚ŒãŸãƒ«ãƒ¼ãƒ ãƒ¡ã‚¤ãƒˆ',0),(520556,14460,'pt','Colegas de quarto solicitadas',0),(520557,14460,'ru','Ð—Ð°Ð¿Ñ€Ð¾ÑˆÐµÐ½Ð½Ñ‹Ð¹ ÑÐ¾ÑÐµÐ´ÐµÐ¹',0),(520558,14460,'es','CompaÃ±eros de habitaciÃ³n solicitadas',0),(520559,14460,'de','Angeforderte Mitbewohner',0),(520560,14460,'en','Requested Roommates',0),(520561,14461,'is','',0),(520562,14461,'dr','Ù‡Ù… Ø§ØªØ§Ù‚ÛŒ 1',0),(520563,14461,'pr','Ù‡Ù… Ø§ØªØ§Ù‚ÛŒ 1',0),(520564,14461,'tr','Oda arkadaÅŸÄ± 1',0),(520565,14461,'pl','WspÃ³Å‚lokator 1',0),(520566,14461,'bg','Ð¡ÑŠÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ñ‚ 1',0),(520567,14461,'ur','Ù…ÛŒÙ¹ 1',0),(520568,14461,'sr','Ð¦Ð¸Ð¼ÐµÑ€ 1',0),(520569,14461,'vi','Báº¡n cÃ¹ng phÃ²ng 1',0),(520570,14461,'af','Huisgenoot 1',0),(520571,14461,'ro','Colega de camera 1',0),(520572,14461,'et','Toakaaslane 1',0),(520573,14461,'si','Sostanovalec 1',0),(520574,14461,'ba','Teman sekamar 1',0),(520575,14461,'nl','Kamergenoot 1',0),(520576,14461,'fi','Huonetoveri 1',0),(520577,14461,'no','Romkamerat 1',0),(520578,14461,'da','Roommate 1',0),(520579,14461,'ko','ë£¸ë©”ì´íŠ¸ 1',0),(520580,14461,'he','×”×©×•×ª×£ ×œ×—×“×¨ 1',0),(520581,14461,'el','Î£Ï…Î³ÎºÎ¬Ï„Î¿Î¹ÎºÎ¿Ï‚ 1',0),(520582,14461,'zh','å®¤å‹ 1',0),(520583,14461,'sv','Rumskompis 1',0),(520584,14461,'it','Compagno di stanza 1',0),(520585,14461,'tl','',0),(520586,14461,'th','à¹€à¸žà¸·à¹ˆà¸­à¸™à¸£à¹ˆà¸§à¸¡à¸«à¹‰à¸­à¸‡ 1',0),(520587,14461,'hi','à¤°à¥‚à¤®à¤®à¥‡à¤Ÿ 1',0),(520588,14461,'ms','Rakan sebilik 1',0),(520589,14461,'ar','Ø§Ù„Ø­Ø¬Ø±Ø© 1',0),(520590,14461,'fr','Colocataire 1',0),(520591,14461,'jp','ãƒ«ãƒ¼ãƒ ãƒ¡ã‚¤ãƒˆ 1',0),(520592,14461,'pt','Colega de quarto 1',0),(520593,14461,'ru','Ð¡Ð¾ÑÐµÐ´ 1',0),(520594,14461,'es','CompaÃ±ero de piso 1',0),(520595,14461,'de','Mitbewohner 1',0),(520596,14461,'en','Roommate 1',0),(520597,14462,'is','',0),(520598,14462,'dr','Ù‡Ù… Ø§ØªØ§Ù‚ÛŒ 2',0),(520599,14462,'pr','Ù‡Ù… Ø§ØªØ§Ù‚ÛŒ 2',0),(520600,14462,'tr','Oda arkadaÅŸÄ±m 2',0),(520601,14462,'pl','WspÃ³Å‚lokator 2',0),(520602,14462,'bg','Ð¡ÑŠÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ñ‚ 2',0),(520603,14462,'ur','Ù…ÛŒÙ¹ 2',0),(520604,14462,'sr','Ð¦Ð¸Ð¼ÐµÑ€ 2',0),(520605,14462,'vi','Báº¡n cÃ¹ng phÃ²ng 2',0),(520606,14462,'af','Huisgenoot 2',0),(520607,14462,'ro','Colega de camera 2',0),(520608,14462,'et','Toakaaslane 2',0),(520609,14462,'si','Sostanovalec 2',0),(520610,14462,'ba','Teman sekamar 2',0),(520611,14462,'nl','Kamergenoot 2',0),(520612,14462,'fi','Huonetoveri 2',0),(520613,14462,'no','Romkamerat 2',0),(520614,14462,'da','Roommate 2',0),(520615,14462,'ko','ë£¸ë©”ì´íŠ¸ 2',0),(520616,14462,'he','×œ×“×™×¨×” 2',0),(520617,14462,'el','Î£Ï…Î³ÎºÎ¬Ï„Î¿Î¹ÎºÎ¿Ï‚ 2',0),(520618,14462,'zh','å®¤å‹ 2',0),(520619,14462,'sv','Rumskompis 2',0),(520620,14462,'it','Compagno di stanza 2',0),(520621,14462,'tl','',0),(520622,14462,'th','à¹€à¸žà¸·à¹ˆà¸­à¸™à¸£à¹ˆà¸§à¸¡à¸«à¹‰à¸­à¸‡ 2',0),(520623,14462,'hi','à¤°à¥‚à¤®à¤®à¥‡à¤Ÿ 2',0),(520624,14462,'ms','Rakan sebilik 2',0),(520625,14462,'ar','Ø§Ù„Ø­Ø¬Ø±Ø© 2',0),(520626,14462,'fr','Colocataire 2',0),(520627,14462,'jp','ãƒ«ãƒ¼ãƒ ãƒ¡ã‚¤ãƒˆ 2',0),(520628,14462,'pt','Colega de quarto 2',0),(520629,14462,'ru','Ð¡Ð¾ÑÐµÐ´ 2',0),(520630,14462,'es','CompaÃ±ero de piso 2',0),(520631,14462,'de','Mitbewohner 2',0),(520632,14462,'en','Roommate 2',0),(520633,14463,'is','',0),(520634,14463,'dr','Ù‡Ù… Ø§ØªØ§Ù‚ÛŒ 3',0),(520635,14463,'pr','Ù‡Ù… Ø§ØªØ§Ù‚ÛŒ 3',0),(520636,14463,'tr','Oda arkadaÅŸÄ±m 3',0),(520637,14463,'pl','WspÃ³Å‚lokator 3',0),(520638,14463,'bg','Ð¡ÑŠÐºÐ²Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ñ‚ 3',0),(520639,14463,'ur','Ù…ÛŒÙ¹ 3',0),(520640,14463,'sr','Ð¦Ð¸Ð¼ÐµÑ€ 3',0),(520641,14463,'vi','Báº¡n cÃ¹ng phÃ²ng 3',0),(520642,14463,'af','Huisgenoot 3',0),(520643,14463,'ro','Colega 3',0),(520644,14463,'et','Toakaaslane 3',0),(520645,14463,'si','Sostanovalec 3',0),(520646,14463,'ba','Teman sekamar 3',0),(520647,14463,'nl','Kamergenoot 3',0),(520648,14463,'fi','Huonetoveri 3',0),(520649,14463,'no','Romkamerat 3',0),(520650,14463,'da','Roommate 3',0),(520651,14463,'ko','ë£¸ë©”ì´íŠ¸ 3',0),(520652,14463,'he','×œ×“×™×¨×” 3',0),(520653,14463,'el','Î£Ï…Î³ÎºÎ¬Ï„Î¿Î¹ÎºÎ¿Ï‚ 3',0),(520654,14463,'zh','å®¤å‹ 3',0),(520655,14463,'sv','Rumskompis 3',0),(520656,14463,'it','Compagno di stanza 3',0),(520657,14463,'tl','',0),(520658,14463,'th','à¹€à¸žà¸·à¹ˆà¸­à¸™à¸£à¹ˆà¸§à¸¡à¸«à¹‰à¸­à¸‡ 3',0),(520659,14463,'hi','à¤°à¥‚à¤®à¤®à¥‡à¤Ÿ 3',0),(520660,14463,'ms','Rakan sebilik 3',0),(520661,14463,'ar','Ø§Ù„Ø­Ø¬Ø±Ø© 3',0),(520662,14463,'fr','Colocataire 3',0),(520663,14463,'jp','ãƒ«ãƒ¼ãƒ ãƒ¡ã‚¤ãƒˆ 3',0),(520664,14463,'pt','Colega de quarto 3',0),(520665,14463,'ru','Ð¡Ð¾ÑÐµÐ´Ð¸ 3',0),(520666,14463,'es','CompaÃ±ero de piso 3',0),(520667,14463,'de','Mitbewohner 3',0),(520668,14463,'en','Roommate 3',0),(520669,14464,'is','',0),(520670,14464,'dr','Ù†Ù‡Ø§ÛŒÛŒ',0),(520671,14464,'pr','Ù†Ù‡Ø§ÛŒÛŒ',0),(520672,14464,'tr','Son haline getir',0),(520673,14464,'pl','Finalizowanie',0),(520674,14464,'bg','Ð¤Ð¸Ð½Ð°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(520675,14464,'ur','Ø§ØµÙ„Ø§Ø­',0),(520676,14464,'sr','Ð”Ð¾Ð²Ñ€ÑˆÐ°Ð²Ð°ÑšÐµ',0),(520677,14464,'vi','HoÃ n thÃ nh',0),(520678,14464,'af','POMA',0),(520679,14464,'ro','Finalizarea',0),(520680,14464,'et','LÃµpetamine',0),(520681,14464,'si','DokonÄanje',0),(520682,14464,'ba','Menyelesaikan',0),(520683,14464,'nl','Finaliseren',0),(520684,14464,'fi','Viimeistele',0),(520685,14464,'no','FullfÃ¸re',0),(520686,14464,'da','FÃ¦rdiggÃ¸re',0),(520687,14464,'ko','ë§ˆë¬´ë¦¬',0),(520688,14464,'he','×’×™×‘×•×© ×¡×•×¤×™',0),(520689,14464,'el','ÎŸÏÎ¹ÏƒÏ„Î¹ÎºÎ¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹',0),(520690,14464,'zh','æ•²å®š',0),(520691,14464,'sv','SlutfÃ¶ra',0),(520692,14464,'it','Finalizzare',0),(520693,14464,'tl','',0),(520694,14464,'th','à¸‚à¸±à¹‰à¸™à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(520695,14464,'hi','à¤•à¥‹ à¤…à¤‚à¤¤à¤¿à¤® à¤°à¥‚à¤ª',0),(520696,14464,'ms','Memuktamadkan',0),(520697,14464,'ar','ÙˆØ¶Ø¹ Ø§Ù„Ù„Ù…Ø³Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø© Ø¹Ù„Ù‰',0),(520698,14464,'fr','Finaliser',0),(520699,14464,'jp','ãƒ•ã‚¡ã‚¤ãƒŠãƒ©ã‚¤ã‚º',0),(520700,14464,'pt','Finalizar',0),(520701,14464,'ru','Ð—Ð°Ð²ÐµÑ€ÑˆÐ¸Ñ‚ÑŒ',0),(520702,14464,'es','Finalizar',0),(520703,14464,'de','Finalisieren',0),(520704,14464,'en','Finalize',0),(520705,14465,'is','',0),(520706,14465,'dr','ÙˆØ¶Ø¹ÛŒØª Ø«Ø¨Øª Ù†Ø§Ù…',0),(520707,14465,'pr','ÙˆØ¶Ø¹ÛŒØª Ø«Ø¨Øª Ù†Ø§Ù…',0),(520708,14465,'tr','Ä°mza durumu',0),(520709,14465,'pl','Podpisanie Status',0),(520710,14465,'bg','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ‚Ð°',0),(520711,14465,'ur','Ø­Ø§Ù„Øª Ø¯Ø³ØªØ®Ø·',0),(520712,14465,'sr','ÐŸÐ¾Ñ‚Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(520713,14465,'vi','ÄÄƒng nháº­p tÃ¬nh tráº¡ng',0),(520714,14465,'af','Ondertekening Status',0),(520715,14465,'ro','Semnarea statutului',0),(520716,14465,'et','Allkirja olek',0),(520717,14465,'si','Podpisu statusom',0),(520718,14465,'ba','Masuk Status',0),(520719,14465,'nl','Ondertekening Status',0),(520720,14465,'fi','Allekirjoituksen tila',0),(520721,14465,'no','Signering Status',0),(520722,14465,'da','Underskrive Status',0),(520723,14465,'ko','ì„œëª… ìƒíƒœ',0),(520724,14465,'he','×—×ª×™×ž×” ×¢×œ ×”×ž×¦×‘',0),(520725,14465,'el','Î¥Ï€Î¿Î³ÏÎ±Ï†Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(520726,14465,'zh','ç­¾åçŠ¶æ€',0),(520727,14465,'sv','Undertecknandet Status',0),(520728,14465,'it','Firma di Status',0),(520729,14465,'tl','',0),(520730,14465,'th','à¸£à¸±à¸šà¸£à¸­à¸‡à¸ªà¸–à¸²à¸™à¸°',0),(520731,14465,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤ªà¤° à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤°',0),(520732,14465,'ms','Menandatangani Status',0),(520733,14465,'ar','ØªÙˆÙ‚ÙŠØ¹ Ù…Ø±ÙƒØ²',0),(520734,14465,'fr','Signature de statut',0),(520735,14465,'jp','ç½²åã®çŠ¶æ…‹',0),(520736,14465,'pt','Status de assinatura',0),(520737,14465,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(520738,14465,'es','Firma de estado',0),(520739,14465,'de','Unterzeichnung Status',0),(520740,14465,'en','Signing Status',0),(520741,14466,'is','',0),(520742,14466,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(520743,14466,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª',0),(520744,14466,'tr','Temizlik/hasar kabartma iadesi',0),(520745,14466,'pl','Czyszczenie/szkody zwrot ulgi',0),(520746,14466,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(520747,14466,'ur','ØµÙØ§Ø¦ÛŒ/Ø§Ù…Ø¯Ø§Ø¯ÛŒ Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ Ù†Ù‚ØµØ§Ù†',0),(520748,14466,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°',0),(520749,14466,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i hoÃ n láº¡i tiá»n cá»©u trá»£',0),(520750,14466,'af','Skoonmaak/skade verligting terugbetaling',0),(520751,14466,'ro','CurÄƒÅ£are/daune Relief restituire',0),(520752,14466,'et','Puhastamine/kahju leevendamiseks toetuse',0),(520753,14466,'si','ÄŒiÅ¡Äenje/Å¡kode odpis vraÄila',0),(520754,14466,'ba','Pembersihan/kerusakan pengembalian dana bantuan',0),(520755,14466,'nl','Reiniging/schade Relief restitutie',0),(520756,14466,'fi','Puhdistus/vahinko helpotusta tuki',0),(520757,14466,'no','RengjÃ¸ring/skade lettelse tilbakebetaling',0),(520758,14466,'da','RengÃ¸ring/skader Relief restitution',0),(520759,14466,'ko','ì²­ì†Œ í”¼í•´ êµ¬í˜¸ í™˜ë¶ˆ',0),(520760,14466,'he','× ×™×§×•×™/× ×–×§ ×©×œ ×”×—×–×¨ ×›×¡×¤×™ ×”×¡×™×•×¢',0),(520761,14466,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ· ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚',0),(520762,14466,'zh','æ¸…æ´—æŸå®³æ•‘æµŽé€€æ¬¾',0),(520763,14466,'sv','RengÃ¶ring/skada lÃ¤ttnad Ã¥terbetalning',0),(520764,14466,'it','Pulizia/danno sollievo rimborso',0),(520765,14466,'tl','',0),(520766,14466,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¹€à¸ªà¸µà¸¢à¸„à¸·à¸™à¹€à¸‡à¸´à¸™à¸šà¸£à¸£à¹€à¸—à¸²à¸—à¸¸à¸à¸‚à¹Œ',0),(520767,14466,'hi','à¤°à¤¾à¤¹à¤¤ à¤µà¤¾à¤ªà¤¸à¥€ à¤•à¥€ à¤¸à¤«à¤¾à¤ˆ/à¤¨à¥à¤•à¤¸à¤¾à¤¨',0),(520768,14466,'ms','Kering/kerosakan pelepasan bayaran balik',0),(520769,14466,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ø¥ØºØ§Ø«Ø©',0),(520770,14466,'fr','Nettoyage/dommages de restitution du Relief',0),(520771,14466,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆæ‰•ã„æˆ»ã—',0),(520772,14466,'pt','Limpeza/danos restituiÃ§Ã£o de alÃ­vio',0),(520773,14466,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/ÑƒÑ‰ÐµÑ€Ð± Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð²Ð¾Ð·Ð²Ñ€Ð°Ñ‚',0),(520774,14466,'es','Limpieza/daÃ±o alivio reembolso',0),(520775,14466,'de','Reinigung/Schaden Sie-Relief-Erstattung',0),(520776,14466,'en','Cleaning/Damage Relief Refund',0),(520777,14467,'is','',0),(520778,14467,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(520779,14467,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(520780,14467,'tr','Kabartma kalan temizlik/zarar',0),(520781,14467,'pl','Czyszczenie/uszkodzenia ulgi pozostaÅ‚a',0),(520782,14467,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ Ð¾ÑÑ‚Ð°Ñ‚ÑŠÐº',0),(520783,14467,'ur','ØµÙØ§Ø¦ÛŒ/Ø±ÛŒÙ„ÛŒÙ Ø¨Ø§Ù‚ÛŒ Ù†Ù‚ØµØ§Ù†',0),(520784,14467,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ Ð¾ÑÑ‚Ð°Ñ‚Ð°Ðº Ð¿Ñ€Ð¸ Ð´ÐµÑ™ÐµÑšÑƒ',0),(520785,14467,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i giáº£m cÃ²n láº¡i',0),(520786,14467,'af','Skoonmaak/skade verligting Restant',0),(520787,14467,'ro','CurÄƒÅ£are/daune Relief restul',0),(520788,14467,'et','Puhastamine/kahju leevendamiseks Ã¼lejÃ¤Ã¤nud',0),(520789,14467,'si','ÄŒiÅ¡Äenje/Å¡kodo olajÅ¡anje preostal',0),(520790,14467,'ba','Pembersihan/kerusakan Relief sisa',0),(520791,14467,'nl','Reiniging/schade Relief rest',0),(520792,14467,'fi','Puhdistus/vahinko helpotusta jÃ¤ljellÃ¤',0),(520793,14467,'no','RengjÃ¸ring/skade lettelse resten',0),(520794,14467,'da','RengÃ¸ring/skader Relief resten',0),(520795,14467,'ko','ì²­ì†Œ í”¼í•´ êµ¬í˜¸ ë‚˜ë¨¸ì§€',0),(520796,14467,'he','× ×™×§×•×™/× ×–×§ ×”×©××¨×™×ª ×”×§×œ×”',0),(520797,14467,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ· Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(520798,14467,'zh','æ¸…æ´—æŸå®³æ•‘æµŽä½™æ•°',0),(520799,14467,'sv','RengÃ¶ring/skada lÃ¤ttnad resten',0),(520800,14467,'it','Pulizia/danno sollievo resto',0),(520801,14467,'tl','',0),(520802,14467,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¸„à¸§à¸²à¸¡à¹€à¸ªà¸µà¸¢à¸«à¸²à¸¢à¹€à¸«à¸¥à¸·à¸­à¸šà¸£à¸£à¹€à¸—à¸²',0),(520803,14467,'hi','à¤°à¤¾à¤¹à¤¤ à¤•à¥‡ à¤¶à¥‡à¤· à¤¸à¤«à¤¾à¤ˆ/à¤¨à¥à¤•à¤¸à¤¾à¤¨',0),(520804,14467,'ms','Kering/kerosakan pelepasan baki',0),(520805,14467,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ© Ø§Ù„Ø¥ØºØ§Ø«Ø©',0),(520806,14467,'fr','Nettoyage/dommages secours reste',0),(520807,14467,'jp','æ•‘æ¸ˆæ®‹ã‚Šã®ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/æå‚·',0),(520808,14467,'pt','Limpeza/dano restante de alÃ­vio',0),(520809,14467,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/ÑƒÑ‰ÐµÑ€Ð± Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð¾ÑÑ‚Ð°Ñ‚Ð¾Ðº',0),(520810,14467,'es','Limpieza/daÃ±o alivio resto',0),(520811,14467,'de','Reinigung/Schaden Sie-Relief-Rest',0),(520812,14467,'en','Cleaning/Damage Relief Remainder',0),(520813,14468,'is','',0),(520814,14468,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø¯Ø±Ø¢Ù…Ø¯',0),(520815,14468,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø¯Ø±Ø¢Ù…Ø¯',0),(520816,14468,'tr','Temizlik/hasar rahatlama gelir',0),(520817,14468,'pl','Czyszczenie/uszkodzenia zwolnienia dochodÃ³w',0),(520818,14468,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸',0),(520819,14468,'ur','ØµÙØ§Ø¦ÛŒ/Ø±ÛŒÙ„ÛŒÙ Ø±ÛŒÙˆÙ†ÛŒÙˆ Ù†Ù‚ØµØ§Ù†',0),(520820,14468,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(520821,14468,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i giáº£m doanh thu',0),(520822,14468,'af','Skoonmaak/skade verligting inkomste',0),(520823,14468,'ro','CurÄƒÅ£are/daune Relief venituri',0),(520824,14468,'et','Puhastamine/kahju leevendamiseks tulu',0),(520825,14468,'si','ÄŒiÅ¡Äenje/Å¡kodo oprostitev prihodkov',0),(520826,14468,'ba','Pembersihan/kerusakan Relief pendapatan',0),(520827,14468,'nl','Reiniging/schade Relief inkomsten',0),(520828,14468,'fi','Puhdistus/vahinko helpotusta tulot',0),(520829,14468,'no','RengjÃ¸ring/skade lettelse inntekter',0),(520830,14468,'da','RengÃ¸ring/skader Relief indtÃ¦gter',0),(520831,14468,'ko','ì²­ì†Œ í”¼í•´ êµ¬í˜¸ ìˆ˜ìµ',0),(520832,14468,'he','× ×™×§×•×™/× ×–×§ ×”×§×œ×” ×”×›× ×¡×•×ª',0),(520833,14468,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± Î±Î½Î±ÎºÎ¿ÏÏ†Î¹ÏƒÎ· Î­ÏƒÎ¿Î´Î±',0),(520834,14468,'zh','æ¸…æ´—æŸå®³æ•‘æµŽæ”¶å…¥',0),(520835,14468,'sv','RengÃ¶ring/skada lÃ¤ttnad intÃ¤kter',0),(520836,14468,'it','Pulizia/danno sollievo entrate',0),(520837,14468,'tl','',0),(520838,14468,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¹€à¸ªà¸µà¸¢à¸£à¸²à¸¢à¹„à¸”à¹‰à¸šà¸£à¸£à¹€à¸—à¸²',0),(520839,14468,'hi','à¤¸à¤«à¤¾à¤ˆ/à¤°à¤¾à¤¹à¤¤ à¤°à¤¾à¤œà¤¸à¥à¤µ à¤¨à¥à¤•à¤¸à¤¾à¤¨',0),(520840,14468,'ms','Kering/kerosakan hasil bantuan',0),(520841,14468,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø§Ù„Ø¥ØºØ§Ø«Ø©',0),(520842,14468,'fr','Nettoyage/dommages secours recettes',0),(520843,14468,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆåŽç›Š',0),(520844,14468,'pt','Limpeza/danos receitas de alÃ­vio',0),(520845,14468,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/ÑƒÑ‰ÐµÑ€Ð± Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð²',0),(520846,14468,'es','Limpieza/daÃ±o alivio ingresos',0),(520847,14468,'de','Reinigung/Schaden Sie-Relief-Einnahmen',0),(520848,14468,'en','Cleaning/Damage Relief Revenue',0),(520849,14469,'is','',0),(520850,14469,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯',0),(520851,14469,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†/Ø¢Ø³ÛŒØ¨ Ø§Ù…Ø¯Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ø¯Ø±Ø¢Ù…Ø¯',0),(520852,14469,'tr','Temizlik/hasar rahatlama gelir hesabÄ±',0),(520853,14469,'pl','Czyszczenie/uszkodzenia konto dochodÃ³w zwolnienia',0),(520854,14469,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ/Ñ‰ÐµÑ‚Ð¸ Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(520855,14469,'ur','ØµÙØ§Ø¦ÛŒ/Ø±ÛŒÙ„ÛŒÙ Ø±ÛŒÙˆÛŒÙ†ÛŒÙˆ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù‚ØµØ§Ù†',0),(520856,14469,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ /ÑˆÑ‚ÐµÑ‚Ñƒ ÐºÐ¾Ð½Ñ‚Ð¾ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð° Ð¾Ð»Ð°ÐºÑˆÐ°ÑšÐµ',0),(520857,14469,'vi','LÃ m sáº¡ch/thiá»‡t háº¡i giáº£m doanh thu tÃ i khoáº£n',0),(520858,14469,'af','Skoonmaak/skade verligting inkomste rekening',0),(520859,14469,'ro','CurÄƒÅ£are/daune contul de venituri Relief',0),(520860,14469,'et','Puhastamine/kahju leevendamiseks tulukonto',0),(520861,14469,'si','ÄŒiÅ¡Äenje/Å¡kodo oprostitev prihodkov raÄuna',0),(520862,14469,'ba','Pembersihan/kerusakan Relief pendapatan Account',0),(520863,14469,'nl','Relief inkomstenrekening reiniging/schade',0),(520864,14469,'fi','Puhdistus/vahinko helpotusta tuottotili',0),(520865,14469,'no','RengjÃ¸ring/skade lettelse inntektskontoen',0),(520866,14469,'da','RengÃ¸ring/skader Relief omsÃ¦tningskonto',0),(520867,14469,'ko','ì²­ì†Œ í”¼í•´ êµ¬í˜¸ ìˆ˜ìµ ê³„ì •',0),(520868,14469,'he','× ×™×§×•×™/× ×–×§ ×—×©×‘×•×Ÿ ×”×›× ×¡×•×ª ×”×§×œ×”',0),(520869,14469,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒÏ‚/Î¶Î·Î¼Î¯Î± ÎºÎ¬Ï„Ï‰ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ ÎµÎ»Î¬Ï†ÏÏ…Î½ÏƒÎ·Ï‚ Ï„Î¿Ï… Î­ÏƒÎ¿Î´Î±',0),(520870,14469,'zh','æ¸…æ´—æŸå®³æ•‘æµŽæ”¶å…¥å¸æˆ·',0),(520871,14469,'sv','RengÃ¶ring/skada lÃ¤ttnad intÃ¤ktskonto',0),(520872,14469,'it','Pulizia/danno conto ricavi sollievo',0),(520873,14469,'tl','',0),(520874,14469,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”/à¸„à¸§à¸²à¸¡à¹€à¸ªà¸µà¸¢à¸«à¸²à¸¢à¸‚à¸­à¸‡à¸šà¸±à¸à¸Šà¸µà¸£à¸²à¸¢à¹„à¸”à¹‰à¸šà¸£à¸£à¹€à¸—à¸²',0),(520875,14469,'hi','à¤°à¤¾à¤¹à¤¤ à¤°à¤¾à¤œà¤¸à¥à¤µ à¤–à¤¾à¤¤à¥‡ à¤¸à¤«à¤¾à¤ˆ/à¤¨à¥à¤•à¤¸à¤¾à¤¨',0),(520876,14469,'ms','Kering/kerosakan akaun pendapatan pelepasan',0),(520877,14469,'ar','ØªÙ†Ø¸ÙŠÙ Ø§Ù„Ø£Ø¶Ø±Ø§Ø± Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯ Ø§Ù„Ø¥ØºØ§Ø«Ø©',0),(520878,14469,'fr','Nettoyage/dommages compte de revenus de secours',0),(520879,14469,'jp','ã‚¯ãƒªãƒ¼ãƒ‹ãƒ³ã‚°/è¢«å®³æ•‘æ¸ˆåŽç›Šå‹˜å®š',0),(520880,14469,'pt','Limpeza/dano conta de receitas de alÃ­vio',0),(520881,14469,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°/ÑƒÑ‰ÐµÑ€Ð± Ð¿Ð¾Ð¼Ð¾Ñ‰Ð¸ ÑÑ‡ÐµÑ‚ Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð²',0),(520882,14469,'es','Limpieza/daÃ±o alivio ingresos cuenta',0),(520883,14469,'de','Reinigung/Schaden Sie Relief Ertragskonto',0),(520884,14469,'en','Cleaning/Damage Relief Revenue Account',0),(520885,14470,'is','',0),(520886,14470,'dr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ',0),(520887,14470,'pr','Ø¨Ø§Ø²Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ',0),(520888,14470,'tr','Ä°lk evde beslenen hayvan Ã¼cret iadesi',0),(520889,14470,'pl','Zwrot opÅ‚aty wstÄ™pnej zwierzÄ™',0),(520890,14470,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÐµÐ½ Ð³Ð°Ð»ÐµÐ½Ð¸Ðº Ñ‚Ð°ÐºÑÐ° Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(520891,14470,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ±ÙˆÚº Ú©ÛŒ ÙÛŒØ³ Ø±Ù‚Ù… Ú©ÛŒ ÙˆØ§Ù¾Ø³ÛŒ',0),(520892,14470,'sr','Ð˜Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ Ñ™ÑƒÐ±Ð¸Ð¼Ð°Ñ† Ð½Ð°ÐºÐ½Ð°Ð´Ð° Ð¿Ð¾Ð²Ñ€Ð°Ñ‚ Ð½Ð¾Ð²Ñ†Ð°',0),(520893,14470,'vi','HoÃ n tráº£ khoáº£n phÃ­ ban Ä‘áº§u váº­t nuÃ´i',0),(520894,14470,'af','Aanvanklike troeteldier fooi terugbetaling',0),(520895,14470,'ro','Rambursare taxa iniÅ£ialÄƒ de animal de casÄƒ',0),(520896,14470,'et','Esialgse tasu lemmiklooma eest toetust',0),(520897,14470,'si','ZaÄetno pristojbino jjeza nadomestila',0),(520898,14470,'ba','Pengembalian dana awal biaya hewan peliharaan',0),(520899,14470,'nl','InitiÃ«le huisdier kosten restitutie',0),(520900,14470,'fi','EnsimmÃ¤inen lemmikkielÃ¤inten jÃ¤senmaksun palautukseen',0),(520901,14470,'no','Innledende Pet gebyr tilbakebetaling',0),(520902,14470,'da','Indledende Pet gebyr restitution',0),(520903,14470,'ko','ì´ˆê¸° ì• ì™„ ë™ë¬¼ ìˆ˜ìˆ˜ë£Œ í™˜ë¶ˆ',0),(520904,14470,'he','×”×—×–×¨ ××’×¨×ª ×ž×—×ž×“ ×”×¨××©×•× ×™×ª',0),(520905,14470,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ Î¶ÏŽÎ¿ Ï‡ÏÎ­Ï‰ÏƒÎ· ÎµÏ€Î¹ÏƒÏ„ÏÎ¿Ï†Î®Ï‚',0),(520906,14470,'zh','åˆå§‹å® ç‰©è´¹é€€æ¬¾',0),(520907,14470,'sv','SÃ¤llskapsdjur startavgift Ã¥terbetalning',0),(520908,14470,'it','Supplemento per animali domestici iniziale rimborso',0),(520909,14470,'tl','',0),(520910,14470,'th','à¸„à¸·à¸™à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(520911,14470,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤ªà¤¾à¤²à¤¤à¥‚ à¤¶à¥à¤²à¥à¤• à¤µà¤¾à¤ªà¤¸à¥€',0),(520912,14470,'ms','Bayaran balik awal kos haiwan kesayangan',0),(520913,14470,'ar','Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø±Ø³ÙˆÙ… Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(520914,14470,'fr','Remboursement des frais pour animaux de compagnie initiale',0),(520915,14470,'jp','åˆæœŸã®ãƒšãƒƒãƒˆæ–™é‡‘æ‰•ã„æˆ»ã—',0),(520916,14470,'pt','RestituiÃ§Ã£o de taxa de estimaÃ§Ã£o inicial',0),(520917,14470,'ru','Ð’Ð¾Ð·Ð²Ñ€Ð°Ñ‚ Ð¿ÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ñ… Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸Ðµ Ð¶Ð¸Ð²Ð¾Ñ‚Ð½Ñ‹Ðµ',0),(520918,14470,'es','Reembolso de la cuota inicial del animal domÃ©stico',0),(520919,14470,'de','Haustier Ausgabeaufschlag Erstattung',0),(520920,14470,'en','Initial Pet Fee Refund',0),(520921,14471,'is','',0),(520922,14471,'dr','Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(520923,14471,'pr','Ø­ÛŒÙˆØ§Ù† Ø®Ø§Ù†Ú¯ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(520924,14471,'tr','Ä°lk evde beslenen hayvan Ã¼creti geri kalan',0),(520925,14471,'pl','PozostaÅ‚a czÄ™Å›Ä‡ opÅ‚aty wstÄ™pnej zwierzÄ™',0),(520926,14471,'bg','ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ñ‚Ð°ÐºÑÐ° Ð·Ð° Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸ Ð¾ÑÑ‚Ð°Ñ‚ÑŠÐº',0),(520927,14471,'ur','Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ù¾Ø§Ù„ØªÙˆ Ø¬Ø§Ù†ÙˆØ±ÙˆÚº Ú©ÛŒ ÙÛŒØ³ Ø¨Ø§Ù‚ÛŒ',0),(520928,14471,'sr','ÐžÑÑ‚Ð°Ñ‚Ð°Ðº Ð¿Ñ€Ð¸ Ð´ÐµÑ™ÐµÑšÑƒ Ð¿Ð¾Ñ‡ÐµÑ‚Ð½Ñƒ Ð½Ð°ÐºÐ½Ð°Ð´Ñƒ Ð·Ð° Ñ™ÑƒÐ±Ð¸Ð¼Ñ†Ð°',0),(520929,14471,'vi','Khoáº£n phÃ­ ban Ä‘áº§u váº­t nuÃ´i cÃ²n láº¡i',0),(520930,14471,'af','Aanvanklike troeteldier fooi Restant',0),(520931,14471,'ro','Restul de taxa iniÅ£ialÄƒ de animal de casÄƒ',0),(520932,14471,'et','Esialgse tasu lemmiklooma eest Ã¼lejÃ¤Ã¤nud',0),(520933,14471,'si','ZaÄetno pristojbino jjeza preostanek',0),(520934,14471,'ba','Sisanya awal biaya hewan peliharaan',0),(520935,14471,'nl','InitiÃ«le huisdier kosten rest',0),(520936,14471,'fi','HellitellÃ¤ aloitusmaksun jÃ¤ljellÃ¤',0),(520937,14471,'no','Innledende Pet gebyr resten',0),(520938,14471,'da','Indledende Pet gebyr resten',0),(520939,14471,'ko','ì´ˆê¸° ì• ì™„ ë™ë¬¼ ë¹„ìš© ë‚˜ë¨¸ì§€',0),(520940,14471,'he','×™×ª×¨×ª ×“×ž×™ ×œ×—×™×•×ª ×ž×—×ž×“',0),(520941,14471,'el','Î‘ÏÏ‡Î¹ÎºÎ® Ï‡ÏÎ­Ï‰ÏƒÎ· ÎºÎ±Ï„Î¿Î¹ÎºÎ¯Î´Î¹Î¿ Î¶ÏŽÎ¿ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(520942,14471,'zh','åˆå§‹å® ç‰©è´¹å‰©ä½™æ—¶é—´',0),(520943,14471,'sv','SÃ¤llskapsdjur startavgift resten',0),(520944,14471,'it','Supplemento per animali domestici iniziale resto',0),(520945,14471,'tl','',0),(520946,14471,'th','à¹€à¸«à¸¥à¸·à¸­à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸±à¸•à¸§à¹Œà¹€à¸¥à¸µà¹‰à¸¢à¸‡',0),(520947,14471,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤¶à¥à¤²à¥à¤• à¤•à¥‡ à¤ªà¤¾à¤²à¤¤à¥‚ à¤ªà¤¶à¥ à¤•à¥‡ à¤¶à¥‡à¤·',0),(520948,14471,'ms','Baki awal kos haiwan kesayangan',0),(520949,14471,'ar','Ù…Ø§ ØªØ¨Ù‚Ù‰ Ù…Ù† Ø±Ø³ÙˆÙ… Ø§Ù„Ø­ÙŠÙˆØ§Ù†Ø§Øª Ø§Ù„Ø£Ù„ÙŠÙØ© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(520950,14471,'fr','Reste de la premiÃ¨re somme pour animaux de compagnie',0),(520951,14471,'jp','åˆæœŸã®ãƒšãƒƒãƒˆæ–™é‡‘æ®‹ã‚Š',0),(520952,14471,'pt','Taxa de estimaÃ§Ã£o inicial restante',0),(520953,14471,'ru','ÐžÑÑ‚Ð°Ñ‚Ð¾Ðº Ð¿ÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð´Ð¾Ð¼Ð°ÑˆÐ½Ð¸Ðµ Ð¶Ð¸Ð²Ð¾Ñ‚Ð½Ñ‹Ðµ',0),(520954,14471,'es','Resto de cuota inicial para mascotas',0),(520955,14471,'de','Haustier Ausgabeaufschlag Rest',0),(520956,14471,'en','Initial Pet Fee Remainder',0),(520957,14472,'is','',0),(520958,14472,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÛŒØ¯ Ù…ØªÙ‚Ø§Ø¶ÛŒ',0),(520959,14472,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÛŒØ¯ Ù…ØªÙ‚Ø§Ø¶ÛŒ',0),(520960,14472,'tr','Yeni baÅŸvuru hesabÄ± oluÅŸturma',0),(520961,14472,'pl','UtwÃ³rz nowe konto wnioskodawcy',0),(520962,14472,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð·Ð° Ð·Ð°ÑÐ²Ð¸Ñ‚ÐµÐ»Ñ',0),(520963,14472,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¯ÛÙ†Ø¯Û Ú©Û’ Ù†ÛŒØ§ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(520964,14472,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¿Ð¾Ð´Ð½Ð¾ÑÐ¸Ð¾Ñ†Ð°',0),(520965,14472,'vi','Táº¡o tÃ i khoáº£n má»›i ná»™p Ä‘Æ¡n',0),(520966,14472,'af','Skep nuwe rekening van die aansoeker',0),(520967,14472,'ro','CreeazÄƒ un cont nou de solicitant',0),(520968,14472,'et','Loo uus taotleja kontole',0),(520969,14472,'si','Ustvarite nov raÄun vlagatelja',0),(520970,14472,'ba','Buat akun baru pemohon',0),(520971,14472,'nl','Maak nieuwe aanvrager Account',0),(520972,14472,'fi','Luo uusi hakijan tili',0),(520973,14472,'no','Opprette ny sÃ¸keren konto',0),(520974,14472,'da','Oprette nye ansÃ¸geren konto',0),(520975,14472,'ko','ìƒˆë¡œìš´ ì‹ ì²­ìž ê³„ì • ë§Œë“¤ê¸°',0),(520976,14472,'he','×™×¦×™×¨×ª ×—×©×‘×•×Ÿ ×—×“×© ×”×ž×‘×§×©',0),(520977,14472,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î½Î­Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï„Î¿Ï… Î±Î¹Ï„Î¿ÏÎ½Ï„Î¿Ï‚',0),(520978,14472,'zh','åˆ›å»ºæ–°çš„ç”³è¯·äººå¸æˆ·',0),(520979,14472,'sv','Skapa nya sÃ¶kanden konto',0),(520980,14472,'it','Creare nuovo Account del richiedente',0),(520981,14472,'tl','',0),(520982,14472,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸šà¸±à¸à¸Šà¸µà¸œà¸¹à¹‰à¸ªà¸¡à¸±à¸„à¸£à¹ƒà¸«à¸¡à¹ˆ',0),(520983,14472,'hi','à¤¨à¤ˆ à¤†à¤µà¥‡à¤¦à¤• à¤–à¤¾à¤¤à¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(520984,14472,'ms','Cipta akaun pemohon baru',0),(520985,14472,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙŠØ¯ Ù…Ù‚Ø¯Ù… Ø§Ù„Ø·Ù„Ø¨',0),(520986,14472,'fr','CrÃ©er un nouveau compte dÃ©posant',0),(520987,14472,'jp','æ–°ã—ã„ç”³è«‹è€…ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½œæˆã—ã¾ã™ã€‚',0),(520988,14472,'pt','Criar nova conta de candidatos',0),(520989,14472,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð°ÑÐ²Ð¸Ñ‚ÐµÐ»Ñ',0),(520990,14472,'es','Crear nueva cuenta de solicitante',0),(520991,14472,'de','Antragsteller Kundenkonto erstellen',0),(520992,14472,'en','Create New Applicant Account',0),(520993,14473,'is','',0),(520994,14473,'dr','Ù¾Ø± Ú©Ø±Ø¯Ù† ÙØ±Ù… Ø²ÛŒØ± Ø¨Ø±Ø§ÛŒ Ø§ÛŒØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ù…ØªÙ‚Ø§Ø¶ÛŒ',0),(520995,14473,'pr','Ù¾Ø± Ú©Ø±Ø¯Ù† ÙØ±Ù… Ø²ÛŒØ± Ø¨Ø±Ø§ÛŒ Ø§ÛŒØ¬Ø§Ø¯ Ø­Ø³Ø§Ø¨ Ù…ØªÙ‚Ø§Ø¶ÛŒ',0),(520996,14473,'tr','BaÅŸvuru sahibi hesabÄ±nÄ±zÄ± oluÅŸturmak iÃ§in aÅŸaÄŸÄ±daki formu doldurunuz',0),(520997,14473,'pl','WypeÅ‚nij poniÅ¼szy formularz, aby utworzyÄ‡ konto wnioskodawcy',0),(520998,14473,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ð° Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ Ð·Ð° Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÑ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ ÐºÐ°Ð½Ð´Ð¸Ð´Ð°Ñ‚Ð° Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(520999,14473,'ur','Ø¢Ù¾ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¯ÛÙ†Ø¯Û Ú©Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†ÛŒÚ†Û’ Ø¯ÛŒØ¦Û’ Ú¯Ø¦Û’ Ø§Ø³ ÙØ§Ø±Ù… Ú©Ùˆ Ø¨Ú¾Ø±ÛŒÚº',0),(521000,14473,'sr','ÐŸÐ¾Ð¿ÑƒÐ½Ð¸Ñ‚Ðµ Ñ„Ð¾Ñ€Ð¼ÑƒÐ»Ð°Ñ€ Ð¸ÑÐ¿Ð¾Ð´ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð»Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¿Ð¾Ð´Ð½Ð¾ÑÐ¸Ð¾Ñ†Ð°',0),(521001,14473,'vi','Äiá»n vÃ o biá»ƒu máº«u dÆ°á»›i Ä‘Ã¢y Ä‘á»ƒ táº¡o tÃ i khoáº£n ngÆ°á»i ná»™p Ä‘Æ¡n',0),(521002,14473,'af','Vul die vorm hieronder om jou aansoeker rekening te skep',0),(521003,14473,'ro','CompletaÅ£i formularul de mai jos pentru a crea contul solicitantului',0),(521004,14473,'et','TÃ¤itke alljÃ¤rgnev vorm, et hageja konto loomisel',0),(521005,14473,'si','Izpolnite spodnji obrazec za ustvarjanje raÄuna vlagatelja',0),(521006,14473,'ba','Mengisi formulir di bawah untuk membuat akun pemohon',0),(521007,14473,'nl','Vul het formulier hieronder om uw Account aanvrager',0),(521008,14473,'fi','TÃ¤ytÃ¤ lomake alla kantaja-tilin luomiseen',0),(521009,14473,'no','Fyll ut skjemaet nedenfor for Ã¥ opprette kontoen sÃ¸keren',0),(521010,14473,'da','Udfyld formularen nedenfor for at oprette kontoen ansÃ¸geren',0),(521011,14473,'ko','ë³¸ì¸ ê³„ì •ì„ ë§Œë“¤ë ¤ë©´ ì•„ëž˜ ì–‘ì‹ì„ ìž‘ì„±í•©ë‹ˆë‹¤',0),(521012,14473,'he','×ž×œ××• ××ª ×”×˜×•×¤×¡ ×©×œ×”×œ×Ÿ ×›×“×™ ×œ×™×¦×•×¨ ×—×©×‘×•×Ÿ ×”×ž×•×¢×ž×“ ×©×œ×š',0),(521013,14473,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏŽÏƒÏ„Îµ Ï„Î·Î½ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Ï†ÏŒÏÎ¼Î± Î³Î¹Î± Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÎ±Ï‚ Î±Î¹Ï„Î¿ÏÎ½Ï„Î¿Ï‚',0),(521014,14473,'zh','å¡«å†™ä¸‹é¢çš„è¡¨å•ä»¥åˆ›å»ºæ‚¨çš„ç”³è¯·äººå¸æˆ·',0),(521015,14473,'sv','Fyll i formulÃ¤ret nedan fÃ¶r att skapa kontot sÃ¶kanden',0),(521016,14473,'it','Compila il modulo qui sotto per creare il tuo Account del richiedente',0),(521017,14473,'tl','',0),(521018,14473,'th','à¸à¸£à¸­à¸à¹à¸šà¸šà¸Ÿà¸­à¸£à¹Œà¸¡à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡à¹€à¸žà¸·à¹ˆà¸­à¸ªà¸£à¹‰à¸²à¸‡à¸šà¸±à¸à¸Šà¸µà¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ªà¸¡à¸±à¸„à¸£',0),(521019,14473,'hi','à¤…à¤ªà¤¨à¥‡ à¤†à¤µà¥‡à¤¦à¤• à¤–à¤¾à¤¤à¤¾ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥€à¤šà¥‡ à¤¦à¤¿à¤ à¤—à¤ à¤«à¥‰à¤°à¥à¤® à¤•à¥‹ à¤­à¤°à¥‡à¤‚',0),(521020,14473,'ms','Isi borang di bawah ini untuk membuka akaun pemohon',0),(521021,14473,'ar','Ù…Ù„Ø¡ Ø§Ù„Ù†Ù…ÙˆØ°Ø¬ Ø£Ø¯Ù†Ø§Ù‡ Ø¥Ù†Ø´Ø§Ø¡ \"Ø­Ø³Ø§Ø¨ Ù…Ù‚Ø¯Ù… Ø§Ù„Ø·Ù„Ø¨\" Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(521022,14473,'fr','Remplissez le formulaire ci-dessous pour crÃ©er votre compte dÃ©posant',0),(521023,14473,'jp','ç”³è«‹è€…ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½œæˆã™ã‚‹ã®ã«ã¯ã€ä»¥ä¸‹ã®ãƒ•ã‚©ãƒ¼ãƒ ã«è¨˜å…¥ã—ã¾ã™ã€‚',0),(521024,14473,'pt','Preencha o formulÃ¡rio abaixo para criar sua conta do requerente',0),(521025,14473,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚Ðµ Ñ„Ð¾Ñ€Ð¼Ñƒ Ð½Ð¸Ð¶Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÐ¾Ð·Ð´Ð°Ñ‚ÑŒ ÑÐ²Ð¾Ð¹ ÑÑ‡ÐµÑ‚',0),(521026,14473,'es','Rellene el siguiente formulario para crear tu cuenta de solicitante',0),(521027,14473,'de','FÃ¼llen Sie das Formular unten, um Ihre Bewerber-Konto erstellen',0),(521028,14473,'en','Fill out the form below to create your Applicant Account',0),(521029,14474,'is','',0),(521030,14474,'dr','Ø§Ø¯Ø§Ù…Ù‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±',0),(521031,14474,'pr','Ø§Ø¯Ø§Ù…Ù‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø±',0),(521032,14474,'tr','Uygulamaya devam',0),(521033,14474,'pl','PrzejdÅº do aplikacji',0),(521034,14474,'bg','ÐŸÑ€Ð¸ÑÑ‚ÑŠÐ¿Ð¸ ÐºÑŠÐ¼ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(521035,14474,'ur','Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù† Ú©Û’ Ù„ÛŒÛ’ Ø¢Ú¯Û’ Ø¨Ú‘Ú¾Ù†Ø§',0),(521036,14474,'sr','ÐÐ°ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð´Ð¾ Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(521037,14474,'vi','Tiáº¿n hÃ nh Ä‘á»ƒ á»©ng dá»¥ng',0),(521038,14474,'af','Voortgaan om aansoek te',0),(521039,14474,'ro','Proceda la aplicarea',0),(521040,14474,'et','JÃ¤tkake avalduse',0),(521041,14474,'si','Nadaljuje z uporabo',0),(521042,14474,'ba','Lanjutkan ke aplikasi',0),(521043,14474,'nl','Overgaan tot toepassing',0),(521044,14474,'fi','Siirry sovelluksen',0),(521045,14474,'no','Videre til programmet',0),(521046,14474,'da','FortsÃ¦t til ansÃ¸gning',0),(521047,14474,'ko','ì‘ìš© í”„ë¡œê·¸ëž¨ì„ ì§„í–‰',0),(521048,14474,'he','×”×ž×©×š ×™×™×©×•×',0),(521049,14474,'el','Î ÏÎ¿Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹ ÏƒÏ„Î·Î½ ÎµÏ†Î±ÏÎ¼Î¿Î³Î®',0),(521050,14474,'zh','ç»§ç»­æ‰§è¡Œåº”ç”¨ç¨‹åº',0),(521051,14474,'sv','GÃ¥ vidare till ansÃ¶kan',0),(521052,14474,'it','Procedere all\'applicazione',0),(521053,14474,'tl','',0),(521054,14474,'th','à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¹à¸­à¸žà¸¥à¸´à¹€à¸„à¸Šà¸±à¸™',0),(521055,14474,'hi','à¤†à¤µà¥‡à¤¦à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤—à¥‡ à¤¬à¤¢à¤¼à¤¨à¤¾',0),(521056,14474,'ms','Lengkapkan permohonan',0),(521057,14474,'ar','Ø§Ù„Ù…Ø¶ÙŠ Ù‚Ø¯Ù…Ø§ ÙÙŠ ØªØ·Ø¨ÙŠÙ‚',0),(521058,14474,'fr','ProcÃ©der Ã  l\'Application',0),(521059,14474,'jp','ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã«é€²ã‚€',0),(521060,14474,'pt','Proceder Ã  aplicaÃ§Ã£o',0),(521061,14474,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ðº Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸ÑŽ',0),(521062,14474,'es','Proceder a la aplicaciÃ³n',0),(521063,14474,'de','Fahren Sie mit der Anwendung',0),(521064,14474,'en','Proceed To Application',0),(521065,14475,'is','',0),(521066,14475,'dr','Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù† ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹',0),(521067,14475,'pr','Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù† ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹',0),(521068,14475,'tr','GeÃ§erlilik baÅŸlangÄ±Ã§ tarihi',0),(521069,14475,'pl','Data rozpoczÄ™cia dostÄ™pnoÅ›ci',0),(521070,14475,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚',0),(521071,14475,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ÛŒ Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(521072,14475,'sr','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¾ÑÑ‚ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(521073,14475,'vi','TÃ¬nh tráº¡ng sáºµn cÃ³ báº¯t Ä‘áº§u ngÃ y',0),(521074,14475,'af','Beskikbaarheid Begin datum',0),(521075,14475,'ro','Data de inceput de disponibilitate',0),(521076,14475,'et','KÃ¤ttesaadavus alguskuupÃ¤ev',0),(521077,14475,'si','ZaÄetni datum razpoloÅ¾ljivosti',0),(521078,14475,'ba','Tanggal mulai ketersediaan',0),(521079,14475,'nl','Begindatum van de beschikbaarheid',0),(521080,14475,'fi','Saatavuus aloituspÃ¤ivÃ¤',0),(521081,14475,'no','Start tilgjengelighetsdato',0),(521082,14475,'da','TilgÃ¦ngelighed Begin dato',0),(521083,14475,'ko','ê°€ìš©ì„± ì‹œìž‘ ë‚ ì§œ',0),(521084,14475,'he','×ª××¨×™×š ×”×”×ª×—×œ×” ×–×ž×™× ×•×ª',0),(521085,14475,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Î´Î¹Î±Î¸ÎµÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î±Ï‚',0),(521086,14475,'zh','å¯ç”¨æ€§çš„å¼€å§‹æ—¥æœŸ',0),(521087,14475,'sv','BÃ¶rja DISP.datum',0),(521088,14475,'it','Data di inizio disponibilitÃ ',0),(521089,14475,'tl','',0),(521090,14475,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(521091,14475,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§à¤¤à¤¾ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(521092,14475,'ms','Ketersediaan Mulakan tarikh',0),(521093,14475,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ ØªÙˆØ§ÙØ±',0),(521094,14475,'fr','Date de dÃ©but de disponibilitÃ©',0),(521095,14475,'jp','æä¾›é–‹å§‹æ—¥',0),(521096,14475,'pt','Data de inÃ­cio de disponibilidade',0),(521097,14475,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ÑÑ‚Ð¸',0),(521098,14475,'es','Fecha de inicio de disponibilidad',0),(521099,14475,'de','Anfangsdatum der VerfÃ¼gbarkeit',0),(521100,14475,'en','Availability Begin Date',0),(521101,14476,'is','',0),(521102,14476,'dr','Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù† ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù†',0),(521103,14476,'pr','Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÙˆØ¯Ù† ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù†',0),(521104,14476,'tr','GeÃ§erlilik bitiÅŸ tarihi',0),(521105,14476,'pl','Data zakoÅ„czenia dostÄ™pnoÅ›ci',0),(521106,14476,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚',0),(521107,14476,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(521108,14476,'sr','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¾ÑÑ‚ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(521109,14476,'vi','NgÃ y káº¿t thÃºc tÃ¬nh tráº¡ng sáºµn cÃ³',0),(521110,14476,'af','Beskikbaarheid Einddatum',0),(521111,14476,'ro','Data de sfÃ¢rÅŸit disponibilitatea',0),(521112,14476,'et','KÃ¤ttesaadavus lÃµppkuupÃ¤ev',0),(521113,14476,'si','KonÄni datum razpoloÅ¾ljivosti',0),(521114,14476,'ba','Tanggal akhir ketersediaan',0),(521115,14476,'nl','Einddatum van de beschikbaarheid',0),(521116,14476,'fi','KÃ¤ytettÃ¤vissÃ¤ olemisen pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n',0),(521117,14476,'no','Tilgjengelige sluttdatoen',0),(521118,14476,'da','Slutdato for tilgÃ¦ngelighed',0),(521119,14476,'ko','ê°€ìš©ì„± ë ë‚ ì§œ',0),(521120,14476,'he','×ª××¨×™×š ×¡×™×•× ×–×ž×™× ×•×ª×•',0),(521121,14476,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Î´Î¹Î±Î¸ÎµÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î±Ï‚',0),(521122,14476,'zh','å¯ç”¨æ€§ç»“æŸæ—¥æœŸ',0),(521123,14476,'sv','TillgÃ¤nglighet slutdatum',0),(521124,14476,'it','Data fine disponibilitÃ ',0),(521125,14476,'tl','',0),(521126,14476,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(521127,14476,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§à¤¤à¤¾ à¤…à¤‚à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(521128,14476,'ms','Tarikh akhir ketersediaan',0),(521129,14476,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø¥ØªØ§Ø­Ø©',0),(521130,14476,'fr','Date de fin de disponibilitÃ©',0),(521131,14476,'jp','å¯ç”¨æ€§çµ‚äº†æ—¥',0),(521132,14476,'pt','Data de tÃ©rmino de disponibilidade',0),(521133,14476,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ÑÑ‚Ð¸',0),(521134,14476,'es','Fecha de finalizaciÃ³n de la disponibilidad',0),(521135,14476,'de','VerfÃ¼gbarkeit-Enddatum',0),(521136,14476,'en','Availability End Date',0),(521137,14477,'is','',0),(521138,14477,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¨Ø§ÛŒØ¯ Ø­Ø¯Ø§Ù‚Ù„ 8 Ø­Ø±Ù Ø¨Ø§Ø´Ø¯',0),(521139,14477,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¨Ø§ÛŒØ¯ Ø­Ø¯Ø§Ù‚Ù„ 8 Ø­Ø±Ù Ø¨Ø§Ø´Ø¯',0),(521140,14477,'tr','Parola en az 8 karakter olmalÄ±',0),(521141,14477,'pl','HasÅ‚o musi mieÄ‡ co najmniej 8 znakÃ³w',0),(521142,14477,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð°Ñ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð½Ð°Ð¹-Ð¼Ð°Ð»ÐºÐ¾ 8 Ð·Ð½Ð°ÐºÐ°',0),(521143,14477,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ú©Ù… Ø§Ø² Ú©Ù… 8 Ú©Ø±ÛŒÚ©Ù¹Ø± ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(521144,14477,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ° Ð¼Ð¾Ñ€Ð° Ð¸Ð¼Ð°Ñ‚Ð¸ Ð½Ð°Ñ˜Ð¼Ð°ÑšÐµ 8 Ð·Ð½Ð°ÐºÐ¾Ð²Ð°',0),(521145,14477,'vi','Máº­t kháº©u pháº£i cÃ³ Ã­t nháº¥t 8 kÃ½ tá»±',0),(521146,14477,'af','Wagwoord moet ten minste 8 karakters word',0),(521147,14477,'ro','Parola trebuie sÄƒ aibÄƒ cel puÈ›in 8 caractere',0),(521148,14477,'et','Parool peab olema vÃ¤hemalt 8 mÃ¤rki',0),(521149,14477,'si','Geslo mora biti dolgo vsaj 8 znakov',0),(521150,14477,'ba','Password harus minimal 8 karakter',0),(521151,14477,'nl','Wachtwoord moet ten minste 8 tekens',0),(521152,14477,'fi','Salasanassa on oltava vÃ¤hintÃ¤Ã¤n 8 merkkiÃ¤',0),(521153,14477,'no','Passordet mÃ¥ vÃ¦re minst 8 tegn',0),(521154,14477,'da','Adgangskoden skal vÃ¦re mindst 8 tegn',0),(521155,14477,'ko','ì•”í˜¸ëŠ” 8 ìž ì´ìƒ ì´ì–´ì•¼ í•©ë‹ˆë‹¤.',0),(521156,14477,'he','×”×¡×™×¡×ž×” ×—×™×™×‘×ª ×œ×”×™×•×ª ×œ×¤×—×•×ª 8 ×ª×•×•×™×',0),(521157,14477,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ 8 Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÎµÏ‚',0),(521158,14477,'zh','å¯†ç å¿…é¡»è‡³å°‘ä¸º 8 ä¸ªå­—ç¬¦',0),(521159,14477,'sv','LÃ¶senordet mÃ¥ste vara minst 8 tecken',0),(521160,14477,'it','La password deve essere di almeno 8 caratteri',0),(521161,14477,'tl','',0),(521162,14477,'th','à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸­à¸¢à¹ˆà¸²à¸‡à¸™à¹‰à¸­à¸¢ 8 à¸•à¸±à¸§',0),(521163,14477,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤•à¤® à¤¸à¥‡ à¤•à¤® 8 à¤µà¤°à¥à¤£ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤.',0),(521164,14477,'ms','Kata laluan mestilah sekurang-kurangnya 8 aksara',0),(521165,14477,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙƒÙˆÙ† ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ù…Ù† 8 Ø£Ø­Ø±Ù Ø¹Ù„Ù‰ Ø§Ù„Ø£Ù‚Ù„',0),(521166,14477,'fr','Mot de passe doit comporter au moins 8 caractÃ¨res',0),(521167,14477,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã¯ 8 æ–‡å­—ä»¥ä¸Šã§ã‚ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(521168,14477,'pt','Senha deve ter no mÃ­nimo 8 caracteres',0),(521169,14477,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ Ð´Ð¾Ð»Ð¶ÐµÐ½ ÑÐ¾Ð´ÐµÑ€Ð¶Ð°Ñ‚ÑŒ Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼ 8 ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¾Ð²',0),(521170,14477,'es','ContraseÃ±a debe tener al menos 8 caracteres',0),(521171,14477,'de','Passwort muss mindestens 8 Zeichen lang sein.',0),(521172,14477,'en','Password Must Be At Least 8 Characters',0),(521173,14478,'is','',0),(521174,14478,'dr','ØªÙ†Ø¸ÛŒÙ… Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(521175,14478,'pr','ØªÙ†Ø¸ÛŒÙ… Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(521176,14478,'tr','Yeni ÅŸifre ayarla',0),(521177,14478,'pl','Ustaw nowe hasÅ‚o',0),(521178,14478,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(521179,14478,'ur','Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ù†ÛŒØ§ Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(521180,14478,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ Ð½Ð¾Ð²Ñƒ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ',0),(521181,14478,'vi','Äáº·t máº­t kháº©u má»›i',0),(521182,14478,'af','Kies \'n nuwe wagwoord',0),(521183,14478,'ro','SetaÅ£i parola noua',0),(521184,14478,'et','Kinnita uus salasÃµna',0),(521185,14478,'si','Nastavi novo geslo',0),(521186,14478,'ba','Atur Password baru',0),(521187,14478,'nl','Nieuwe wachtwoord instellen',0),(521188,14478,'fi','Aseta uusi salasana',0),(521189,14478,'no','Angi nytt passord',0),(521190,14478,'da','Angiv ny adgangskode',0),(521191,14478,'ko','ìƒˆ ì•”í˜¸ ì„¤ì •ëœ',0),(521192,14478,'he','×§×™×‘×¢×• ×¡×™×¡×ž×” ×—×“×©×”',0),(521193,14478,'el','ÎÎ­Î¿ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(521194,14478,'zh','è®¾ç½®æ–°å¯†ç ',0),(521195,14478,'sv','Ange nytt lÃ¶senord',0),(521196,14478,'it','Imposta Nuova Password',0),(521197,14478,'tl','',0),(521198,14478,'th','à¸•à¸±à¹‰à¸‡à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(521199,14478,'hi','à¤¨à¤¯à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(521200,14478,'ms','Set kata laluan baru',0),(521201,14478,'ar','ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ø¬Ø¯ÙŠØ¯Ø©',0),(521202,14478,'fr','Nouveau jeu de mot de passe',0),(521203,14478,'jp','æ–°ã—ã„ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(521204,14478,'pt','Definir nova senha',0),(521205,14478,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ',0),(521206,14478,'es','Establecer nueva contraseÃ±a',0),(521207,14478,'de','Neues Kennwort festlegen',0),(521208,14478,'en','Set New Password',0),(521209,14479,'is','',0),(521210,14479,'dr','ØªÙ†Ø¸ÛŒÙ… Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ±',0),(521211,14479,'pr','ØªÙ†Ø¸ÛŒÙ… Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ±',0),(521212,14479,'tr','Koymak parola',0),(521213,14479,'pl','Ustaw hasÅ‚o',0),(521214,14479,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(521215,14479,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø³ÙŠÙ¹ Ú©Ø±ÙŠÚº',0),(521216,14479,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ',0),(521217,14479,'vi','Thiáº¿t láº­p máº­t kháº©u',0),(521218,14479,'af','Stel wagwoord',0),(521219,14479,'ro','SetaÅ£i parola',0),(521220,14479,'et','MÃ¤Ã¤ra parool',0),(521221,14479,'si','Nastavi geslo',0),(521222,14479,'ba','Atur Password',0),(521223,14479,'nl','Wachtwoord instellen',0),(521224,14479,'fi','Aseta salasana',0),(521225,14479,'no','Angi passord',0),(521226,14479,'da','Indstil adgangskode',0),(521227,14479,'ko','ë¹„ë°€ ë²ˆí˜¸ ì„¤ì •ëœ',0),(521228,14479,'he','×”×’×“×¨×ª ×¡×™×¡×ž×”',0),(521229,14479,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ ÎºÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(521230,14479,'zh','è®¾ç½®çš„å¯†ç ',0),(521231,14479,'sv','Ange lÃ¶senord',0),(521232,14479,'it','Imposta Password',0),(521233,14479,'tl','',0),(521234,14479,'th','à¸•à¸±à¹‰à¸‡à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™',0),(521235,14479,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(521236,14479,'ms','Set kata laluan',0),(521237,14479,'ar','ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ±',0),(521238,14479,'fr','DÃ©finir mot de passe',0),(521239,14479,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®è¨­å®š',0),(521240,14479,'pt','Definir senha',0),(521241,14479,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ',0),(521242,14479,'es','Set Password',0),(521243,14479,'de','Kennwort festlegen',0),(521244,14479,'en','Set Password',0),(521245,14480,'is','',0),(521246,14480,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø§ÛŒØ§Ù† Ù†ÙˆØ´ØªØ§Ø±',0),(521247,14480,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø§ÛŒØ§Ù† Ù†ÙˆØ´ØªØ§Ø±',0),(521248,14480,'tr','Tamamlanan belge talepleri',0),(521249,14480,'pl','Å»Ä…dania wypeÅ‚nionego dokumentu',0),(521250,14480,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÐ½ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¸ÑÐºÐ°Ð½Ð¸Ñ',0),(521251,14480,'ur','Ù…Ú©Ù…Ù„ Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(521252,14480,'sr','ÐŸÐ¾Ð¿ÑƒÑšÐµÐ½Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°',0),(521253,14480,'vi','YÃªu cáº§u tÃ i liá»‡u hoÃ n thÃ nh',0),(521254,14480,'af','Voltooide dokument versoeke',0),(521255,14480,'ro','Completat documentul cereri',0),(521256,14480,'et','TÃ¤idetud dokument taotlused',0),(521257,14480,'si','Izpolnjen dokument zahteve',0),(521258,14480,'ba','Permintaan dokumen selesai',0),(521259,14480,'nl','Voltooide documentaanvragen',0),(521260,14480,'fi','Valmistunut AsiakirjapyyntÃ¶jen',0),(521261,14480,'no','FullfÃ¸rte forespÃ¸rsler om',0),(521262,14480,'da','Udfyldte dokumentanmodninger',0),(521263,14480,'ko','ì™„ì„± ëœ ë¬¸ì„œ ìš”ì²­',0),(521264,14480,'he','×‘×§×©×•×ª ×œ×ž×¡×ž×›×™× ×©×”×•×©×œ×ž×•',0),(521265,14480,'el','Î£Ï…Î¼Ï€Î»Î·ÏÏ‰Î¼Î­Î½Î¿ Î­Î³Î³ÏÎ±Ï†Î¿ Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚',0),(521266,14480,'zh','å·²å®Œæˆçš„æ–‡æ¡£è¯·æ±‚',0),(521267,14480,'sv','Ifyllda dokumentet Ã¶nskemÃ¥l',0),(521268,14480,'it','Documento completo richieste',0),(521269,14480,'tl','',0),(521270,14480,'th','à¸£à¹‰à¸­à¸‡à¸‚à¸­à¹€à¸­à¸à¸ªà¸²à¸£à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(521271,14480,'hi','à¤ªà¥‚à¤°à¤¾ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚',0),(521272,14480,'ms','Permohonan dokumen yang lengkap',0),(521273,14480,'ar','Ø·Ù„Ø¨Ø§Øª Ø§Ù„ÙˆØ«Ø§Ø¦Ù‚ Ø§Ù„Ù…ÙƒØªÙ…Ù„Ø©',0),(521274,14480,'fr','Demandes de documents dÃ»ment rempli',0),(521275,14480,'jp','å®Œæˆã—ãŸãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã‚’è¦æ±‚',0),(521276,14480,'pt','Pedidos de documento concluÃ­do',0),(521277,14480,'ru','Ð—Ð°Ð¿Ñ€Ð¾ÑÑ‹ Ð·Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð½Ñ‹Ñ… Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(521278,14480,'es','Solicitudes de documento completo',0),(521279,14480,'de','AusgefÃ¼llte Dokument Anforderungen',0),(521280,14480,'en','Completed Document Requests',0),(521281,14481,'is','',0),(521282,14481,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø³Ù†Ø¯',0),(521283,14481,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø³Ù†Ø¯',0),(521284,14481,'tr','Belge istekleri',0),(521285,14481,'pl','Å»Ä…dania dokumentÃ³w',0),(521286,14481,'bg','Ð˜ÑÐºÐ°Ð½Ð¸Ñ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚',0),(521287,14481,'ur','Ø¯Ø³ØªØ§ÙˆÛŒØ² Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(521288,14481,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°',0),(521289,14481,'vi','TÃ i liá»‡u yÃªu cáº§u',0),(521290,14481,'af','Dokument versoeke',0),(521291,14481,'ro','Cereri de documente',0),(521292,14481,'et','Dokumendi taotluste',0),(521293,14481,'si','Zahteve dokumenta',0),(521294,14481,'ba','Permintaan dokumen',0),(521295,14481,'nl','Documentaanvragen',0),(521296,14481,'fi','AsiakirjapyyntÃ¶jen',0),(521297,14481,'no','DokumentforespÃ¸rsler',0),(521298,14481,'da','Dokumentanmodninger',0),(521299,14481,'ko','ë¬¸ì„œ ìš”ì²­',0),(521300,14481,'he','×‘×§×©×•×ª ×œ×ž×¡×ž×›×™×',0),(521301,14481,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚',0),(521302,14481,'zh','æ–‡æ¡£è¯·æ±‚',0),(521303,14481,'sv','DokumentbegÃ¤randen',0),(521304,14481,'it','Richieste di documenti',0),(521305,14481,'tl','',0),(521306,14481,'th','à¸£à¹‰à¸­à¸‡à¸‚à¸­à¹€à¸­à¸à¸ªà¸²à¸£',0),(521307,14481,'hi','à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚',0),(521308,14481,'ms','Dokumen permohonan',0),(521309,14481,'ar','Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ ÙˆØ«Ø§Ø¦Ù‚',0),(521310,14481,'fr','Demandes de documents',0),(521311,14481,'jp','è³‡æ–™è«‹æ±‚',0),(521312,14481,'pt','Pedidos de documento',0),(521313,14481,'ru','Ð—Ð°Ð¿Ñ€Ð¾ÑÑ‹ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(521314,14481,'es','Solicitudes de documento',0),(521315,14481,'de','Dokument-Anforderungen',0),(521316,14481,'en','Document Requests',0),(521317,14482,'is','',0),(521318,14482,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø³Ù†Ø¯ Ø§Ù†ØªØ¸Ø§Ø±',0),(521319,14482,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø³Ù†Ø¯ Ø§Ù†ØªØ¸Ø§Ø±',0),(521320,14482,'tr','Bekleyen belge talepleri',0),(521321,14482,'pl','Dokumentu oczekujÄ…cego Å¼Ä…dania',0),(521322,14482,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð¸ÑÐºÐ°Ð½Ð¸Ñ',0),(521323,14482,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø¯Ø³ØªØ§ÙˆÛŒØ²',0),(521324,14482,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°',0),(521325,14482,'vi','YÃªu cáº§u Ä‘ang chá» xá»­ lÃ½ tÃ i liá»‡u',0),(521326,14482,'af','Hangende dokument versoeke',0),(521327,14482,'ro','Cereri de Document Ã®n aÈ™teptare',0),(521328,14482,'et','Ootel dokumendi taotlused',0),(521329,14482,'si','ÄŒakajoÄih dokumentov zahteve',0),(521330,14482,'ba','Permintaan dokumen tertunda',0),(521331,14482,'nl','Document dat in behandeling aanvragen',0),(521332,14482,'fi','Odottavaa pyynnÃ¶t',0),(521333,14482,'no','Ventende forespÃ¸rsler om',0),(521334,14482,'da','Ventende dokumentanmodninger',0),(521335,14482,'ko','ë³´ë¥˜ ì¤‘ì¸ ë¬¸ì„œ ìš”ì²­',0),(521336,14482,'he','×‘×§×©×•×ª ×œ×ž×¡×ž×›×™× ×ž×ž×ª×™× ×”',0),(521337,14482,'el','ÎˆÎ³Î³ÏÎ±Ï†Î¿ ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚',0),(521338,14482,'zh','å¾…å®šçš„æ–‡æ¡£è¯·æ±‚',0),(521339,14482,'sv','PÃ¥gÃ¥ende begÃ¤randen',0),(521340,14482,'it','Richieste di documenti in sospeso',0),(521341,14482,'tl','',0),(521342,14482,'th','à¸£à¹‰à¸­à¸‡à¸‚à¸­à¹€à¸­à¸à¸ªà¸²à¸£à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(521343,14482,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼ à¤…à¤¨à¥à¤°à¥‹à¤§à¥‹à¤‚',0),(521344,14482,'ms','Permohonan dokumen belum selesai',0),(521345,14482,'ar','Ø·Ù„Ø¨Ø§Øª Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(521346,14482,'fr','Demandes de documents en attente',0),(521347,14482,'jp','ä¿ç•™ä¸­ã®ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆã®è¦æ±‚',0),(521348,14482,'pt','SolicitaÃ§Ãµes de documentos pendentes',0),(521349,14482,'ru','Ð—Ð°Ð¿Ñ€Ð¾ÑÑ‹ Ð½Ð° Ñ€Ð°ÑÑÐ¼Ð¾Ñ‚Ñ€ÐµÐ½Ð¸Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(521350,14482,'es','Solicitudes de documentos pendientes',0),(521351,14482,'de','Ausstehende Dokument Anforderungen',0),(521352,14482,'en','Pending Document Requests',0),(521353,14483,'is','',0),(521354,14483,'dr','Ø«Ø¨Øª Ù†Ø§Ù… Ù…Ø³ØªØ§Ø¬Ø± 3',0),(521355,14483,'pr','Ø«Ø¨Øª Ù†Ø§Ù… Ù…Ø³ØªØ§Ø¬Ø± 3',0),(521356,14483,'tr','KiracÄ± 3 iÅŸareti',0),(521357,14483,'pl','Najemca 3 znak',0),(521358,14483,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» 3 Ð·Ð½Ð°Ðº',0),(521359,14483,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± 3 Ø¹Ù„Ø§Ù…Øª',0),(521360,14483,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ 3 Ð·Ð½Ð°ÐºÐ°',0),(521361,14483,'vi','Dáº¥u hiá»‡u ngÆ°á»i thuÃª nhÃ  3',0),(521362,14483,'af','Huurder 3 advertensie',0),(521363,14483,'ro','ChiriaÅŸ 3 semn',0),(521364,14483,'et','ÃœÃ¼rnik 3 mÃ¤rk',0),(521365,14483,'si','Najemnik 3 znak',0),(521366,14483,'ba','Penyewa 3 tanda',0),(521367,14483,'nl','Huurder 3 teken',0),(521368,14483,'fi','Vuokralainen 3 merkki',0),(521369,14483,'no','Leietaker 3 tegn',0),(521370,14483,'da','Lejer 3 tegn',0),(521371,14483,'ko','ì„¸ ìž…ìž 3 ê¸°í˜¸',0),(521372,14483,'he','×“×™×™×¨ ×¡×™×ž×Ÿ 3',0),(521373,14483,'el','Î£Î·Î¼Î¬Î´Î¹ Î¼Î¹ÏƒÎ¸Ï‰Ï„Î® 3',0),(521374,14483,'zh','ç§Ÿå®¢ 3 æ ‡å¿—',0),(521375,14483,'sv','HyresgÃ¤sten 3 tecken',0),(521376,14483,'it','Segno di inquilino 3',0),(521377,14483,'tl','',0),(521378,14483,'th','à¹€à¸Šà¹ˆà¸² 3 à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡',0),(521379,14483,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° 3 à¤¸à¤¾à¤‡à¤¨ à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(521380,14483,'ms','Penyewa 3 tanda',0),(521381,14483,'ar','ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø± 3',0),(521382,14483,'fr','Locataire 3 signe',0),(521383,14483,'jp','ãƒ†ãƒŠãƒ³ãƒˆãŒ 3 ã¤ã®ã‚µã‚¤ãƒ³',0),(521384,14483,'pt','Sinal de inquilino 3',0),(521385,14483,'ru','ÐÑ€ÐµÐ½Ð´Ð°Ñ‚Ð¾Ñ€ 3 Ð·Ð½Ð°Ðº',0),(521386,14483,'es','Signo de inquilino 3',0),(521387,14483,'de','Mieter 3 Zeichen',0),(521388,14483,'en','Tenant 3 Sign',0),(521389,14484,'is','',0),(521390,14484,'dr','Ø§Ø³Ù†Ø§Ø¯ Ù…Ù†',0),(521391,14484,'pr','Ø§Ø³Ù†Ø§Ø¯ Ù…Ù†',0),(521392,14484,'tr','Benim evrak',0),(521393,14484,'pl','Moje dokumenty',0),(521394,14484,'bg','ÐœÐ¾Ð¸Ñ‚Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(521395,14484,'ur','Ù…ÛŒØ±ÛŒ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(521396,14484,'sr','ÐœÐ¾Ñ˜Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(521397,14484,'vi','TÃ i liá»‡u cá»§a tÃ´i',0),(521398,14484,'af','My dokumente',0),(521399,14484,'ro','Documentele mele',0),(521400,14484,'et','Minu dokumendid',0),(521401,14484,'si','Moji dokumenti',0),(521402,14484,'ba','Dokumen-dokumen saya',0),(521403,14484,'nl','Mijn documenten',0),(521404,14484,'fi','Omat tiedostot',0),(521405,14484,'no','Mine dokumenter',0),(521406,14484,'da','Mine dokumenter',0),(521407,14484,'ko','ë‚´ ë¬¸ì„œ',0),(521408,14484,'he','×”×ž×¡×ž×›×™× ×©×œ×™',0),(521409,14484,'el','ÎœÎ¿Ï… Î­Î³Î³ÏÎ±Ï†Î±',0),(521410,14484,'zh','æˆ‘çš„æ–‡æ¡£',0),(521411,14484,'sv','Mina dokument',0),(521412,14484,'it','Miei documenti',0),(521413,14484,'tl','',0),(521414,14484,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(521415,14484,'hi','à¤®à¥‡à¤°à¥‡ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼',0),(521416,14484,'ms','Dokumen saya',0),(521417,14484,'ar','Ø§Ù„Ù…Ø³ØªÙ†Ø¯Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨ÙŠ',0),(521418,14484,'fr','Mes Documents',0),(521419,14484,'jp','ãƒžã‚¤ ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ',0),(521420,14484,'pt','Meus documentos',0),(521421,14484,'ru','ÐœÐ¾Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(521422,14484,'es','Mis documentos',0),(521423,14484,'de','Meine Dokumente',0),(521424,14484,'en','My Documents',0),(521425,14485,'is','',0),(521426,14485,'dr','Ù…Ø´Ø®ØµØ§Øª Ù…Ø³ØªØ§Ø¬Ø±',0),(521427,14485,'pr','Ù…Ø´Ø®ØµØ§Øª Ù…Ø³ØªØ§Ø¬Ø±',0),(521428,14485,'tr','KiracÄ± profili',0),(521429,14485,'pl','Profil najemcÃ³w',0),(521430,14485,'bg','ÐÐ°ÐµÐ¼Ð°Ñ‚ÐµÐ» Ð¿Ñ€Ð¾Ñ„Ð¸Ð»',0),(521431,14485,'ur','Ú©Ø±Ø§ÛŒÛ Ø¯Ø§Ø± Ù¾Ø±ÙˆÙØ§Ø¦Ù„',0),(521432,14485,'sr','Ð¡Ñ‚Ð°Ð½Ð°Ñ€ Ð¿Ñ€Ð¾Ñ„Ð¸Ð»Ð°',0),(521433,14485,'vi','Há»“ sÆ¡ ngÆ°á»i thuÃª nhÃ ',0),(521434,14485,'af','Huurder profiel',0),(521435,14485,'ro','ChiriaÅŸ profil',0),(521436,14485,'et','Rentniku kasutajaprofiili',0),(521437,14485,'si','Najemnik profil',0),(521438,14485,'ba','Penyewa profil',0),(521439,14485,'nl','Huurder profiel',0),(521440,14485,'fi','Vuokralainen profiili',0),(521441,14485,'no','Leietaker profil',0),(521442,14485,'da','Lejer profil',0),(521443,14485,'ko','ì„¸ ìž…ìž í”„ë¡œí•„',0),(521444,14485,'he','×”×“×™×™×¨ ×¤×¨×•×¤×™×œ',0),(521445,14485,'el','Î ÏÎ¿Ï†Î¯Î» Ï„Î¿Ï… Î¼Î¹ÏƒÎ¸Ï‰Ï„Î®',0),(521446,14485,'zh','ç§Ÿå®¢é…ç½®æ–‡ä»¶',0),(521447,14485,'sv','HyresgÃ¤sten profil',0),(521448,14485,'it','Profilo di inquilino',0),(521449,14485,'tl','',0),(521450,14485,'th','à¹‚à¸žà¸£à¹„à¸Ÿà¸¥à¹Œà¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²',0),(521451,14485,'hi','à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤° à¤ªà¥à¤°à¥‹à¤«à¤¼à¤¾à¤‡à¤²',0),(521452,14485,'ms','Profil penyewa',0),(521453,14485,'ar','Ø§Ù„Ø´Ø®ØµÙŠØ© Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±',0),(521454,14485,'fr','Profil de locataire',0),(521455,14485,'jp','ãƒ†ãƒŠãƒ³ãƒˆã®ãƒ—ãƒ­ãƒ•ã‚¡ã‚¤ãƒ«',0),(521456,14485,'pt','Perfil do inquilino',0),(521457,14485,'ru','ÐŸÑ€Ð¾Ñ„Ð¸Ð»ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(521458,14485,'es','Perfil de inquilino',0),(521459,14485,'de','Mieter-Profil',0),(521460,14485,'en','Tenant Profile',0),(521461,14486,'is','',0),(521462,14486,'dr','Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®ÙˆØ¯ Ùˆ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯Ù‡ Ø±ÙˆÛŒ Ø°Ø®ÛŒØ±Ù‡ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(521463,14486,'pr','Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø®ÙˆØ¯ Ùˆ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯Ù‡ Ø±ÙˆÛŒ Ø°Ø®ÛŒØ±Ù‡ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(521464,14486,'tr','AÅŸaÄŸÄ±ya bilgilerinizi gÃ¼ncelleÅŸtirmek ve tÄ±kÄ±rtÄ± kurtarmak ne zaman bitmiÅŸ',0),(521465,14486,'pl','ZaktualizowaÄ‡ swoje dane poniÅ¼ej i kliknij przycisk Zapisz, po zakoÅ„czeniu',0),(521466,14486,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ Ð¸ Ñ‰Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ Ð²ÑŠÑ€Ñ…Ñƒ Ð—Ð°Ð¿Ð¸ÑˆÐ¸, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ðµ Ð³Ð¾Ñ‚Ð¾Ð²Ð¾',0),(521467,14486,'ur','Ø¢Ù¾ Ù†ÛŒÚ†Û’ Ø¯ÛŒ Ú¯Ø¦ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ù…Ø­ÙÙˆØ¸ ØªÚ©Ù…ÛŒÙ„ Ù¾Ø± Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(521468,14486,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ð¸ ÐºÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ ÐºÐ°Ð´ Ð³Ð¾Ñ‚Ð¾Ð²Ð¾',0),(521469,14486,'vi','Cáº­p nháº­t thÃ´ng tin cá»§a báº¡n dÆ°á»›i Ä‘Ã¢y vÃ  nháº¥p vÃ o lÆ°u khi thá»±c hiá»‡n',0),(521470,14486,'af','Dateer jou inligting hieronder en klik op stoor wanneer klaar',0),(521471,14486,'ro','ActualizaÅ£i informaÅ£iile de mai jos ÅŸi faceÅ£i clic pe SalvaÅ£i atunci cÃ¢nd face',0),(521472,14486,'et','Uuenda oma andmed allpool ja klÃµpsake nuppu Salvesta kui valmis',0),(521473,14486,'si','Posodobite svoje podatke spodaj in kliknite Shrani, ko konÄate',0),(521474,14486,'ba','Memperbarui informasi di bawah ini dan klik Simpan setelah selesai',0),(521475,14486,'nl','Bijwerken van uw gegevens hieronder en klik op opslaan wanneer u klaar bent',0),(521476,14486,'fi','PÃ¤ivitÃ¤ alla olevat tiedot ja valitse Tallenna, kun olet valmis',0),(521477,14486,'no','Oppdatere opplysningene dine nedenfor, og klikk Lagre nÃ¥r du er ferdig',0),(521478,14486,'da','Opdatere dine oplysninger nedenfor og klik pÃ¥ Gem, nÃ¥r du er fÃ¦rdig',0),(521479,14486,'ko','ì•„ëž˜ì˜ ì •ë³´ë¥¼ ì—…ë°ì´íŠ¸ í•˜ ê³  ì™„ë£Œ ë˜ ë©´ ì €ìž¥ì„ í´ë¦­ í•©ë‹ˆë‹¤',0),(521480,14486,'he','×œ×¢×“×›×Ÿ ××ª ×”×ž×™×“×¢ ×©×œ×š ×œ×ž×˜×” ×•×œ×—×¥ ×¢×œ Save ×›××©×¨ × ×¢×©×”',0),(521481,14486,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÎ±Ï‚ Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ ÎºÎ±Î¹ ÎºÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº ÏƒÏ„Î¿ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· ÏŒÏ„Î±Î½ Î³Î¯Î½ÎµÏ„Î±Î¹',0),(521482,14486,'zh','æ›´æ–°ä¸‹é¢æ‚¨çš„ä¿¡æ¯å¹¶å•å‡»ä¿å­˜å½“å®Œæˆ',0),(521483,14486,'sv','Uppdatera din information nedan och klicka pÃ¥ Spara nÃ¤r du Ã¤r klar',0),(521484,14486,'it','Aggiornare i tuoi dati qui sotto e fare clic su Salva quando fatto',0),(521485,14486,'tl','',0),(521486,14486,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‚à¸­à¸‡à¸„à¸¸à¸“à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡ à¹à¸¥à¸°à¸„à¸¥à¸´à¸à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸¡à¸·à¹ˆà¸­à¸—à¸³',0),(521487,14486,'hi','à¤¨à¥€à¤šà¥‡ à¤…à¤ªà¤¨à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚ à¤”à¤° à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤ªà¤° à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚ à¤œà¤¬ à¤•à¤¿à¤¯à¤¾',0),(521488,14486,'ms','Kemaskini maklumat anda di bawah dan klik Simpan apabila selesai',0),(521489,14486,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ Ø£Ø¯Ù†Ø§Ù‡ØŒ ÙˆØ§Ù†Ù‚Ø± ÙÙˆÙ‚ Ø­ÙØ¸ Ø¹Ù†Ø¯ Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(521490,14486,'fr','Mettre Ã  jour vos informations ci-dessous et cliquez sur enregistrer lorsque terminÃ©',0),(521491,14486,'jp','ä»¥ä¸‹ã®æƒ…å ±ã‚’æ›´æ–°ã—ã€çµ‚ã‚ã£ãŸã‚‰ [ä¿å­˜]',0),(521492,14486,'pt','Actualizar os seus dados abaixo e clique em salvar quando terminar',0),(521493,14486,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÑƒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ Ð½Ð¸Ð¶Ðµ Ð¸ Ð½Ð°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐºÐ½Ð¾Ð¿ÐºÑƒ Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ, ÐºÐ¾Ð³Ð´Ð° ÑÐ´ÐµÐ»Ð°Ð»Ð¸',0),(521494,14486,'es','Actualizar tu informaciÃ³n a continuaciÃ³n y haga clic en guardar cuando termine',0),(521495,14486,'de','Aktualisieren Sie Ihre Daten unten und klicken Sie auf speichern, wenn fertig',0),(521496,14486,'en','Update your information below and click Save when done',0),(521497,14487,'is','',0),(521498,14487,'dr','Ù…Ø¯ÛŒØ±ÛŒØª Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ',0),(521499,14487,'pr','Ù…Ø¯ÛŒØ±ÛŒØª Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ',0),(521500,14487,'tr','Banka hesaplarÄ±nÄ± yÃ¶netme',0),(521501,14487,'pl','ZarzÄ…dzanie kontami bankowymi',0),(521502,14487,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(521503,14487,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†Ø¯ÙˆØ¨Ø³Øª Ú©Ø±ÛŒÚº',0),(521504,14487,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½Ð¸Ð¼Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(521505,14487,'vi','Quáº£n lÃ½ tÃ i khoáº£n ngÃ¢n hÃ ng',0),(521506,14487,'af','Bank rekeninge bestuur',0),(521507,14487,'ro','Gestionarea conturilor bancare',0),(521508,14487,'et','Hallata pangakontosid',0),(521509,14487,'si','Upravljaj banÄnimi raÄuni',0),(521510,14487,'ba','Mengelola rekening Bank',0),(521511,14487,'nl','Bankrekeningen beheren',0),(521512,14487,'fi','Hallita pankkitilejÃ¤',0),(521513,14487,'no','HÃ¥ndtere bankkontoer',0),(521514,14487,'da','Administrere bankkonti',0),(521515,14487,'ko','ì€í–‰ ê³„ì¢Œ ê´€ë¦¬',0),(521516,14487,'he','× ×™×”×•×œ ×—×©×‘×•× ×•×ª ×‘× ×§',0),(521517,14487,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŽÎ½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(521518,14487,'zh','ç®¡ç†é“¶è¡Œè´¦æˆ·',0),(521519,14487,'sv','Hantera bankkonton',0),(521520,14487,'it','Gestire conti bancari',0),(521521,14487,'tl','',0),(521522,14487,'th','à¸ˆà¸±à¸”à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£',0),(521523,14487,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¤¾ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤•à¤°à¥‡à¤‚',0),(521524,14487,'ms','Menguruskan akaun Bank',0),(521525,14487,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(521526,14487,'fr','GÃ©rer les comptes bancaires',0),(521527,14487,'jp','éŠ€è¡Œå£åº§ã‚’ç®¡ç†ã—ã¾ã™ã€‚',0),(521528,14487,'pt','Gerenciar contas bancÃ¡rias',0),(521529,14487,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¼Ð¸ ÑÑ‡ÐµÑ‚Ð°Ð¼Ð¸',0),(521530,14487,'es','Gestionar cuentas bancarias',0),(521531,14487,'de','Verwaltung von Bankkonten',0),(521532,14487,'en','Manage Bank Accounts',0),(521533,14488,'is','',0),(521534,14488,'dr','Ù…Ø´Ø®ØµØ§Øª &amp; Ø§Ø³Ù†Ø§Ø¯',0),(521535,14488,'pr','Ù…Ø´Ø®ØµØ§Øª &amp; Ø§Ø³Ù†Ø§Ø¯',0),(521536,14488,'tr','Profil & belgeler',0),(521537,14488,'pl','Profil & dokumentÃ³w',0),(521538,14488,'bg','ÐŸÑ€Ð¾Ñ„Ð¸Ð» & Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(521539,14488,'ur','Ù¾Ø±ÙˆÙØ§Ø¦Ù„ & Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(521540,14488,'sr','ÐŸÑ€Ð¾Ñ„Ð¸Ð» Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(521541,14488,'vi','Há»“ sÆ¡ &amp; tÃ i liá»‡u',0),(521542,14488,'af','Profiel & dokumente',0),(521543,14488,'ro','Profilul & documente',0),(521544,14488,'et','Profiili & dokumendid',0),(521545,14488,'si','Profil & dokumentov',0),(521546,14488,'ba','Profil & dokumen',0),(521547,14488,'nl','Profiel & documenten',0),(521548,14488,'fi','Profiilin & asiakirjat',0),(521549,14488,'no','Profil & dokumenter',0),(521550,14488,'da','Profil & dokumenter',0),(521551,14488,'ko','í”„ë¡œí•„ & ë¬¸ì„œ',0),(521552,14488,'he','×¤×¨×•×¤×™×œ & ×ž×¡×ž×›×™×',0),(521553,14488,'el','Î ÏÎ¿Ï†Î¯Î» & Î­Î³Î³ÏÎ±Ï†Î±',0),(521554,14488,'zh','é…ç½®æ–‡ä»¶ &amp; æ–‡ä»¶',0),(521555,14488,'sv','Profil & dokument',0),(521556,14488,'it','Profilo & documenti',0),(521557,14488,'tl','',0),(521558,14488,'th','à¸ªà¹ˆà¸§à¸™à¸à¸³à¸«à¸™à¸”à¸„à¹ˆà¸²à¹€à¸­à¸à¸ªà¸²à¸£ &',0),(521559,14488,'hi','à¤ªà¥à¤°à¥‹à¤«à¤¼à¤¾à¤‡à¤² & à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¥‹à¤‚',0),(521560,14488,'ms','Profil & dokumen',0),(521561,14488,'ar','Ø§Ù„ÙˆØ«Ø§Ø¦Ù‚ Ø§Ù„Ø´Ø®ØµÙŠØ© Ø¢Ù†Ø¯',0),(521562,14488,'fr','Profil & Documents',0),(521563,14488,'jp','ãƒ—ãƒ­ãƒ•ã‚¡ã‚¤ãƒ« & ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ',0),(521564,14488,'pt','Perfil & documentos',0),(521565,14488,'ru','ÐŸÑ€Ð¾Ñ„Ð¸Ð»ÑŒ & Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(521566,14488,'es','El perfil &amp; de documentos',0),(521567,14488,'de','Profil- & -Dokumente',0),(521568,14488,'en','Profile & Documents',0),(521569,14489,'is','',0),(521570,14489,'dr','3dcart ÙˆØ¶Ø¹ÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(521571,14489,'pr','3dcart ÙˆØ¶Ø¹ÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(521572,14489,'tr','3dcart sevkiyat durumunu otomatik olarak gÃ¼ncelleÅŸtir',0),(521573,14489,'pl','Automatycznie Aktualizuj Status wysyÅ‚ki 3dcart',0),(521574,14489,'bg','3dcart Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑÑ‚Ð°Ñ‚ÑƒÑ ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾',0),(521575,14489,'ur','3dcart Ø´Ù¾Ù†Ú¯ Ø­Ø§Ù„Øª Ú©Ùˆ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(521576,14489,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(521577,14489,'vi','Tá»± Ä‘á»™ng Cáº­p Nháº­t 3dcart váº­n chuyá»ƒn tráº¡ng thÃ¡i',0),(521578,14489,'af','3dcart gestuur Status outomaties opdateer',0),(521579,14489,'ro','Actualiza starea de transport 3dcart automat',0),(521580,14489,'et','3dcart kohaletoimetamise olekut automaatselt uuendada',0),(521581,14489,'si','Samodejno posodobite stanje 3dcart',0),(521582,14489,'ba','Memperbarui Status pengiriman 3dcart secara otomatis',0),(521583,14489,'nl','3dcart verzendstatus automatisch bijwerken',0),(521584,14489,'fi','PÃ¤ivitÃ¤ 3dcart toimituksen tilaa automaattisesti',0),(521585,14489,'no','Oppdatere 3dcart leveringsstatus automatisk',0),(521586,14489,'da','Opdatere 3dcart leveringsstatus automatisk',0),(521587,14489,'ko','3dcart ë°°ì†¡ ìƒíƒœë¥¼ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(521588,14489,'he','×¢×“×›×•×Ÿ ×ž×¦×‘ ×”×ž×©×œ×•×— 3dcart ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(521589,14489,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(521590,14489,'zh','è‡ªåŠ¨æ›´æ–° 3dcart èˆªè¿åœ°ä½',0),(521591,14489,'sv','Uppdatera 3dcart frakt Status automatiskt',0),(521592,14489,'it','Aggiornare automaticamente lo stato di spedizione 3dcart',0),(521593,14489,'tl','',0),(521594,14489,'th','à¸­à¸±à¸žà¹€à¸” 3dcart à¸ªà¸–à¸²à¸™à¸°à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(521595,14489,'hi','3dcart à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(521596,14489,'ms','Kemas kini Status penghantaran 3dcart secara automatik',0),(521597,14489,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨ØªØ­Ø¯ÙŠØ« Ø­Ø§Ù„Ø© Ø§Ù„Ø´Ø­Ù† 3dcart',0),(521598,14489,'fr','Mise Ã  jour de statut de livraison 3dcart automatiquement',0),(521599,14489,'jp','3dcart å‡ºè·çŠ¶æ³ã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(521600,14489,'pt','Atualizar automaticamente o Status de envio 3dcart',0),(521601,14489,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ 3dcart',0),(521602,14489,'es','Actualizar estado de envÃ­o 3dcart automÃ¡ticamente',0),(521603,14489,'de','3dcart-Versandstatus automatisch aktualisieren',0),(521604,14489,'en','Update 3dcart Shipping Status Automatically',0),(521605,14490,'is','',0),(521606,14490,'dr','Ø§ÛŒÙ…ÛŒÙ„ Ø­ÙˆØ§Ù„Ù‡',0),(521607,14490,'pr','Ø§ÛŒÙ…ÛŒÙ„ Ø­ÙˆØ§Ù„Ù‡',0),(521608,14490,'tr','E-posta gelirleri',0),(521609,14490,'pl','E-mail przekazÃ³w',0),(521610,14490,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð¿Ñ€ÐµÐ²Ð¾Ð´Ð¸',0),(521611,14490,'ur','Ø§ÛŒ Ù…ÛŒÙ„ ØªØ±Ø³ÛŒÙ„Ø§Øª',0),(521612,14490,'sr','Ð•Ð¼Ð°Ð¸Ð» Ð´Ð¾Ð·Ð½Ð°ÐºÐ°',0),(521613,14490,'vi','Email Kiá»u há»‘i',0),(521614,14490,'af','E-pos overmakingen',0),(521615,14490,'ro','E-mail remitenÅ£ele',0),(521616,14490,'et','E-posti rahaÃ¼lekanded',0),(521617,14490,'si','Email nakazil',0),(521618,14490,'ba','Email pengiriman uang',0),(521619,14490,'nl','E-mail overmakingen',0),(521620,14490,'fi','SÃ¤hkÃ¶posti rahalÃ¤hetykset',0),(521621,14490,'no','E-remitteringer',0),(521622,14490,'da','E-mail pengeoverfÃ¸rsler',0),(521623,14490,'ko','ì´ë©”ì¼ ì†¡ê¸ˆ',0),(521624,14490,'he','×”×¢×‘×¨×•×ª ×‘× ×§××™×•×ª ×“×•×',0),(521625,14490,'el','Î•Î¼Î²Î¬ÏƒÎ¼Î±Ï„Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(521626,14490,'zh','ç”µå­é‚®ä»¶æ±‡æ¬¾',0),(521627,14490,'sv','E-post remitteringar',0),(521628,14490,'it','Rimesse e-mail',0),(521629,14490,'tl','',0),(521630,14490,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸œà¹ˆà¸²à¸™à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(521631,14490,'hi','à¤ˆà¤®à¥‡à¤² à¤µà¤¿à¤ªà¥à¤°à¥‡à¤·à¤£',0),(521632,14490,'ms','E-mel kiriman wang',0),(521633,14490,'ar','ØªØ­ÙˆÙŠÙ„Ø§Øª Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(521634,14490,'fr','Envois de fonds par courriel',0),(521635,14490,'jp','ãƒ¡ãƒ¼ãƒ«é€é‡‘',0),(521636,14490,'pt','Remessas de e-mail',0),(521637,14490,'ru','Ð”ÐµÐ½ÐµÐ¶Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ñ‹ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(521638,14490,'es','Remesas de correo electrÃ³nico',0),(521639,14490,'de','E-Mail Ãœberweisungen',0),(521640,14490,'en','Email Remittances',0),(521641,14491,'is','',0),(521642,14491,'dr','3dcart ÙˆØ¶Ø¹ÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ù‡ Ø±ÙˆØ²',0),(521643,14491,'pr','3dcart ÙˆØ¶Ø¹ÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ù‡ Ø±ÙˆØ²',0),(521644,14491,'tr','3dcart sevkiyat durumu gÃ¼ncelleme',0),(521645,14491,'pl','Status wysyÅ‚ki 3dcart aktualizacja',0),(521646,14491,'bg','3dcart Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑÑ‚Ð°Ñ‚ÑƒÑ‚ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°',0),(521647,14491,'ur','3dcart Ú©ÛŒ Ø´Ù¾Ù†Ú¯ Ø­Ø§Ù„Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(521648,14491,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(521649,14491,'vi','3dcart váº­n chuyá»ƒn tráº¡ng thÃ¡i Cáº­p Nháº­t',0),(521650,14491,'af','3dcart gestuur Status bygewerk',0),(521651,14491,'ro','3dcart transport statutul actualizat',0),(521652,14491,'et','3dcart saatmine olekut on vÃ¤rskendatud',0),(521653,14491,'si','3dcart stanje posodobljeno',0),(521654,14491,'ba','Status pengiriman 3dcart Diperbarui',0),(521655,14491,'nl','3dcart verzendstatus bijgewerkt',0),(521656,14491,'fi','3dcart toimituksen tilaa pÃ¤ivitetÃ¤Ã¤n',0),(521657,14491,'no','3dcart leveringsstatus oppdatert',0),(521658,14491,'da','3dcart leveringsstatus opdateret',0),(521659,14491,'ko','3dcart ë°°ì†¡ ìƒíƒœ ì—…ë°ì´íŠ¸',0),(521660,14491,'he','×ž×¦×‘ ×”×ž×©×œ×•×— 3dcart ×ž×¢×•×“×›×Ÿ',0),(521661,14491,'el','3dcart ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(521662,14491,'zh','3dcart èˆªè¿çŠ¶æ€æ›´æ–°',0),(521663,14491,'sv','3dcart frakt Status uppdaterad',0),(521664,14491,'it','3Dcart Shipping Status aggiornato',0),(521665,14491,'tl','',0),(521666,14491,'th','à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ 3dcart à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(521667,14491,'hi','3dcart à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(521668,14491,'ms','Status penghantaran 3dcart yang Kemaskini',0),(521669,14491,'ar','Ù…Ø±ÙƒØ² Ø§Ù„Ø´Ø­Ù† 3dcart ØªØ­Ø¯ÙŠØ«',0),(521670,14491,'fr','3Dcart expÃ©dition statut mis Ã  jour',0),(521671,14491,'jp','3dcart ç™ºé€çŠ¶æ³ã‚’æ›´æ–°ã—ã¾ã—ãŸ',0),(521672,14491,'pt','3Dcart transporte Status atualizado',0),(521673,14491,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ 3dcart Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(521674,14491,'es','3DCart envÃ­o estado actualizado',0),(521675,14491,'de','3dcart-Versand-Status aktualisiert',0),(521676,14491,'en','3dcart Shipping Status Updated',0),(521677,14492,'is','',0),(521678,14492,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ 3dcart ÙˆØ¶Ø¹ÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(521679,14492,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ 3dcart ÙˆØ¶Ø¹ÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(521680,14492,'tr','3dcart sevkiyat durumu gÃ¼ncelleÅŸtirilirken hata oluÅŸtu',0),(521681,14492,'pl','BÅ‚Ä…d podczas aktualizowania stanu wysyÅ‚ki 3dcart',0),(521682,14492,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ 3dcart Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(521683,14492,'ur','3dcart Ú©ÛŒ Ø´Ù¾Ù†Ú¯ Ø­Ø§Ù„Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†Ù‚Øµ',0),(521684,14492,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(521685,14492,'vi','Lá»—i Cáº­p Nháº­t 3dcart váº­n chuyá»ƒn tÃ¬nh tráº¡ng',0),(521686,14492,'af','Fout 3dcart gestuur Status bywerk',0),(521687,14492,'ro','Eroare la actualizarea statutul de transport 3dcart',0),(521688,14492,'et','3dcart kohaletoimetamise olekut vÃ¤rskendamise tÃµrge',0),(521689,14492,'si','Napaka pri posodabljanju 3dcart stanje',0),(521690,14492,'ba','Kesalahan Update Status pengiriman 3dcart',0),(521691,14492,'nl','Fout bij het bijwerken van 3dcart verzendstatus',0),(521692,14492,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ 3dcart toimituksen tilaa',0),(521693,14492,'no','Feil under oppdatering av 3dcart leveringsstatus',0),(521694,14492,'da','Fejl under opdatering af 3dcart leveringsstatus',0),(521695,14492,'ko','3dcart ë°°ì†¡ ìƒíƒœ ì—…ë°ì´íŠ¸ ì˜¤ë¥˜',0),(521696,14492,'he','×©×’×™××” ×‘×¢×ª ×¢×“×›×•×Ÿ ×ž×¦×‘ ×”×ž×©×œ×•×— 3dcart',0),(521697,14492,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(521698,14492,'zh','æ›´æ–° 3dcart èˆªè¿çŠ¶æ€æ—¶å‡ºé”™',0),(521699,14492,'sv','Gick inte att uppdatera 3dcart frakt Status',0),(521700,14492,'it','Errore durante l\'aggiornamento dello stato di spedizione 3dcart',0),(521701,14492,'tl','',0),(521702,14492,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ 3dcart',0),(521703,14492,'hi','3dcart à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(521704,14492,'ms','Ralat dalam mengemas kini Status penghantaran 3dcart',0),(521705,14492,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø­Ø§Ù„Ø© Ø§Ù„Ø´Ø­Ù† 3dcart',0),(521706,14492,'fr','Erreur mise Ã  jour de statut de livraison 3dcart',0),(521707,14492,'jp','3dcart å‡ºè·ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã®æ›´æ–°ã‚¨ãƒ©ãƒ¼',0),(521708,14492,'pt','Erro ao atualizar o Status de envio 3dcart',0),(521709,14492,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ 3dcart',0),(521710,14492,'es','Error al actualizar el Status del envÃ­o 3dcart',0),(521711,14492,'de','Fehler beim Aktualisieren der 3dcart Versandstatus',0),(521712,14492,'en','Error Updating 3dcart Shipping Status',0),(521713,14493,'is','',0),(521714,14493,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ÙˆØ¶Ø¹ÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ 3dcart Ù…Ø³Ø¦Ù„Ù‡ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯.',0),(521715,14493,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ÙˆØ¶Ø¹ÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ 3dcart Ù…Ø³Ø¦Ù„Ù‡ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯.',0),(521716,14493,'tr','3dcart sevkiyat durum gÃ¼ncelleme sorunu vardÄ±.',0),(521717,14493,'pl','ByÅ‚o problemu aktualizacji 3dcart status wysyÅ‚ki.',0),(521718,14493,'bg','Ð˜Ð¼Ð°ÑˆÐµ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° 3dcart ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾.',0),(521719,14493,'ur','3dcart Ø§Ù…Ù¾ÙˆØ±Ù¹ ÚˆÛŒÙˆÙ¹ÛŒ Ø­Ø§Ù„Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ø§ÛŒÚ© Ù…Ø³Ø¦Ù„Û ØªÚ¾Ø§ Û”',0),(521720,14493,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ ÑÐ¿Ð¾Ñ€Ð½Ð¾ Ð¿Ð¸Ñ‚Ð°ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ 3Ð´Ñ†Ð°Ñ€Ñ‚ ÑÑ‚Ð°Ñ‚ÑƒÑ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ.',0),(521721,14493,'vi','ÄÃ£ cÃ³ má»™t váº¥n Ä‘á» cáº­p nháº­t tÃ¬nh tráº¡ng váº­n chuyá»ƒn 3dcart.',0),(521722,14493,'af','Daar was \'n probleem met die bywerking van die 3dcart shipping status.',0),(521723,14493,'ro','A existat o problemÄƒ actualizarea statutul 3dcart transport.',0),(521724,14493,'et','Seal oli probleem ajakohastamine 3dcart saatmise olek.',0),(521725,14493,'si','Je bilo vpraÅ¡anje posodabljanje status ladijskega 3dcart.',0),(521726,14493,'ba','Ada masalah memperbarui status pengiriman 3dcart.',0),(521727,14493,'nl','Er was een probleem de 3dcart verzending status bijwerken.',0),(521728,14493,'fi','3dcart lÃ¤hetyksen tilan pÃ¤ivittÃ¤minen kysymyksen.',0),(521729,14493,'no','Det var et problem oppdatere 3dcart shipping statusen.',0),(521730,14493,'da','Der var et problem opdateringsstatus 3dcart shipping.',0),(521731,14493,'ko','3dcart ë°°ì†¡ ìƒíƒœ ì—…ë°ì´ íŠ¸ì— ë¬¸ì œê°€ ìžˆì—ˆìŠµë‹ˆë‹¤.',0),(521732,14493,'he','××™×¨×¢×” ×‘×¢×™×” ×¢×“×›×•×Ÿ ×ž×¦×‘ ×ž×©×œ×•×— 3dcart.',0),(521733,14493,'el','Î¥Ï€Î®ÏÏ‡Îµ Î­Î½Î± Î¸Î­Î¼Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î·Î½ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Ï„Î¿Ï… 3dcart.',0),(521734,14493,'zh','æœ‰äº†æ›´æ–°çš„ 3dcart èˆªè¿åœ°ä½é—®é¢˜ã€‚',0),(521735,14493,'sv','Det var en frÃ¥ga som uppdaterar 3dcart leverans status.',0),(521736,14493,'it','C\'era un problema aggiornando lo stato di spedizione 3dcart.',0),(521737,14493,'tl','',0),(521738,14493,'th','à¸¡à¸µà¸›à¸±à¸à¸«à¸²à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ 3dcart',0),(521739,14493,'hi','à¤µà¤¹à¤¾à¤ à¤à¤• à¤®à¥à¤¦à¥à¤¦à¤¾ 3dcart à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¤¾ à¤¥à¤¾à¥¤',0),(521740,14493,'ms','Ini satu isu yang mengemaskini status penghantaran 3dcart.',0),(521741,14493,'ar','Ù‡Ù†Ø§Ùƒ Ù…Ø³Ø£Ù„Ø© ØªØ­Ø¯ÙŠØ« Ø­Ø§Ù„Ø© Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ 3dcart.',0),(521742,14493,'fr','Il y avait un problÃ¨me de mise Ã  jour le statut d\'expÃ©dition 3dcart.',0),(521743,14493,'jp','3dcart å‡ºè·ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã®æ›´æ–°å•é¡ŒãŒã‚ã£ãŸã€‚',0),(521744,14493,'pt','Houve um problema atualizando o status de envio 3dcart.',0),(521745,14493,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ 3dcart ÑÑ‚Ð°Ñ‚ÑƒÑ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸.',0),(521746,14493,'es','Hubo un problema actualizar el estado del envÃ­o 3dcart.',0),(521747,14493,'de','Es gab ein Problem der 3dcart-Versandstatus aktualisieren.',0),(521748,14493,'en','There was an issue updating the 3dcart shipping status.',0),(521749,14494,'is','',0),(521750,14494,'dr','3dcart Ø³ÙØ§Ø±Ø´',0),(521751,14494,'pr','3dcart Ø³ÙØ§Ø±Ø´',0),(521752,14494,'tr','3dcart sipariÅŸ',0),(521753,14494,'pl','3dcart zamÃ³wienie',0),(521754,14494,'bg','3dcart Ñ€ÐµÐ´',0),(521755,14494,'ur','3dcart Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(521756,14494,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(521757,14494,'vi','Thá»© tá»± 3dcart',0),(521758,14494,'af','3dcart orde',0),(521759,14494,'ro','3dcart ordine',0),(521760,14494,'et','3dcart tellimus',0),(521761,14494,'si','3dcart naloga',0),(521762,14494,'ba','3dcart Order',0),(521763,14494,'nl','3dcart volgorde',0),(521764,14494,'fi','3dcart jÃ¤rjestyksessÃ¤',0),(521765,14494,'no','3dcart orden',0),(521766,14494,'da','3dcart rÃ¦kkefÃ¸lge',0),(521767,14494,'ko','3dcart ìˆœì„œ',0),(521768,14494,'he','3dcart ×”×¡×“×¨',0),(521769,14494,'el','Î£ÎµÎ¹ÏÎ¬ 3dcart',0),(521770,14494,'zh','3dcart å‘½ä»¤',0),(521771,14494,'sv','3dcart ordning',0),(521772,14494,'it','Ordine 3Dcart',0),(521773,14494,'tl','',0),(521774,14494,'th','à¸ªà¸±à¹ˆà¸‡ 3dcart',0),(521775,14494,'hi','3dcart à¤•à¥à¤°à¤®',0),(521776,14494,'ms','Perintah 3dcart',0),(521777,14494,'ar','ØªØ±ØªÙŠØ¨ 3dcart',0),(521778,14494,'fr','Ordre 3Dcart',0),(521779,14494,'jp','3dcart æ³¨æ–‡',0),(521780,14494,'pt','Ordem 3Dcart',0),(521781,14494,'ru','3dcart Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(521782,14494,'es','Orden 3DCart',0),(521783,14494,'de','3dcart Reihenfolge',0),(521784,14494,'en','3dcart Order',0),(521785,14495,'is','',0),(521786,14495,'dr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ Ù¾ÛŒÚ¯ÛŒØ±ÛŒ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(521787,14495,'pr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ Ù¾ÛŒÚ¯ÛŒØ±ÛŒ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(521788,14495,'tr','Bir izleme numarasÄ± girin',0),(521789,14495,'pl','Podaj numer Å›ledzenia',0),(521790,14495,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(521791,14495,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(521792,14495,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ',0),(521793,14495,'vi','Vui lÃ²ng nháº­p má»™t sá»‘ theo dÃµi',0),(521794,14495,'af','Tik asseblief \'n Tracking nommer',0),(521795,14495,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un numÄƒr de urmÄƒrire',0),(521796,14495,'et','Sisestage jÃ¤lgimise Number',0),(521797,14495,'si','Vnesite Å¡tevilko sledenja',0),(521798,14495,'ba','Masukkan nomor pelacakan',0),(521799,14495,'nl','Voer een trackingnummer',0),(521800,14495,'fi','Kirjoita seurantanumeron',0),(521801,14495,'no','Angi et sporingsnummer',0),(521802,14495,'da','Angiv et Tracking-nummer',0),(521803,14495,'ko','ì¶”ì  ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤',0),(521804,14495,'he','×”×–×Ÿ ×ž×¡×¤×¨ ×ž×¢×§×‘',0),(521805,14495,'el','Î Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÏ„Îµ Î­Î½Î±Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚',0),(521806,14495,'zh','è¯·è¾“å…¥ä¸€ä¸ªè·Ÿè¸ªå·ç ',0),(521807,14495,'sv','Ange ett spÃ¥rningsnummer',0),(521808,14495,'it','Per favore inserisci un numero di Tracking',0),(521809,14495,'tl','',0),(521810,14495,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸à¸²à¸£à¸•à¸´à¸”à¸•à¸²à¸¡',0),(521811,14495,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(521812,14495,'ms','Sila masukkan nombor Tracking',0),(521813,14495,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø§Ù„ØªØªØ¨Ø¹',0),(521814,14495,'fr','Veuillez entrer un numÃ©ro de suivi',0),(521815,14495,'jp','è¿½è·¡ç•ªå·ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(521816,14495,'pt','Por favor, digite um nÃºmero de rastreamento',0),(521817,14495,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð´Ð»Ñ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ',0),(521818,14495,'es','Introduce un nÃºmero de seguimiento',0),(521819,14495,'de','Bitte geben Sie eine Tracking-Nummer',0),(521820,14495,'en','Please Enter A Tracking Number',0),(521821,14496,'is','',0),(521822,14496,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ ÙØ±Ø¢ÛŒÙ†Ø¯',0),(521823,14496,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ù‡Ø§ÛŒ ÙØ±Ø¢ÛŒÙ†Ø¯',0),(521824,14496,'tr','Ä°ÅŸlem gÃ¶nderiler',0),(521825,14496,'pl','Proces wysyÅ‚ki',0),(521826,14496,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(521827,14496,'ur','Ø¹Ù…Ù„ ØªØ±Ø³ÛŒÙ„',0),(521828,14496,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(521829,14496,'vi','QuÃ¡ trÃ¬nh lÃ´ hÃ ng',0),(521830,14496,'af','Proses gestuur',0),(521831,14496,'ro','Procesul de transporturi',0),(521832,14496,'et','Protsessi saadetised',0),(521833,14496,'si','Proces poÅ¡iljk',0),(521834,14496,'ba','Proses pengiriman',0),(521835,14496,'nl','Proces zendingen',0),(521836,14496,'fi','KÃ¤sittele lÃ¤hetykset',0),(521837,14496,'no','Prosessen forsendelser',0),(521838,14496,'da','Processen forsendelser',0),(521839,14496,'ko','ê³µì • ì¶œí•˜',0),(521840,14496,'he','×ª×”×œ×™×š ×ž×©×œ×•×—×™×',0),(521841,14496,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(521842,14496,'zh','å‡ºè´§æµç¨‹',0),(521843,14496,'sv','Processen transporter',0),(521844,14496,'it','Spedizioni di processo',0),(521845,14496,'tl','',0),(521846,14496,'th','à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(521847,14496,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤²à¤¦à¤¾à¤¨',0),(521848,14496,'ms','Proses penghantaran',0),(521849,14496,'ar','Ø¹Ù…Ù„ÙŠØ© Ø´Ø­Ù†',0),(521850,14496,'fr','ExpÃ©ditions de processus',0),(521851,14496,'jp','ãƒ—ãƒ­ã‚»ã‚¹ã®å‡ºè·å°æ•°',0),(521852,14496,'pt','Carregamentos de processo',0),(521853,14496,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(521854,14496,'es','EnvÃ­os de proceso',0),(521855,14496,'de','Prozess-Sendungen',0),(521856,14496,'en','Process Shipments',0),(521857,14497,'is','',0),(521858,14497,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª 3dcart Ú©Ø´ØªÛŒ',0),(521859,14497,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª 3dcart Ú©Ø´ØªÛŒ',0),(521860,14497,'tr','3dcart sipariÅŸler gemi',0),(521861,14497,'pl','ZamÃ³wienia 3dcart',0),(521862,14497,'bg','ÐšÐ¾Ñ€Ð°Ð±Ð° 3dcart Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(521863,14497,'ur','Ø¬ÛØ§Ø² Ú©Û’ 3dcart Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(521864,14497,'sr','Ð‘Ñ€Ð¾Ð´ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(521865,14497,'vi','TÃ u Ä‘Æ¡n Ä‘áº·t hÃ ng 3dcart',0),(521866,14497,'af','Skip 3dcart bestellings',0),(521867,14497,'ro','Nava 3dcart comenzi',0),(521868,14497,'et','Laeva 3dcart tellimused',0),(521869,14497,'si','3dcart naroÄil za ladje',0),(521870,14497,'ba','Kapal 3dcart pesanan',0),(521871,14497,'nl','Schip 3dcart Orders',0),(521872,14497,'fi','Alusten 3dcart tilausten',0),(521873,14497,'no','3dcart bestillinger',0),(521874,14497,'da','Skibet 3dcart ordrer',0),(521875,14497,'ko','3dcart ì£¼ë¬¸ ë°œì†¡',0),(521876,14497,'he','×”×¡×¤×™× ×” 3dcart ×”×–×ž× ×•×ª',0),(521877,14497,'el','3dcart Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€Î»Î¿Î¯Ï‰Î½',0),(521878,14497,'zh','èˆ¹èˆ¶ 3dcart è®¢å•',0),(521879,14497,'sv','Fartyget 3dcart order',0),(521880,14497,'it','Nave 3dcart ordini',0),(521881,14497,'tl','',0),(521882,14497,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ 3dcart',0),(521883,14497,'hi','à¤œà¤¹à¤¾à¤œ 3dcart à¤†à¤¦à¥‡à¤¶',0),(521884,14497,'ms','Menghantar pesanan 3dcart',0),(521885,14497,'ar','Ø£ÙˆØ§Ù…Ø± 3dcart Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(521886,14497,'fr','DELAI est 3dcart',0),(521887,14497,'jp','3dcart ã®èˆ¹èˆ¶å—æ³¨',0),(521888,14497,'pt','Navio 3dcart ordens',0),(521889,14497,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ 3dcart Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(521890,14497,'es','Nave 3dcart Ã³rdenes',0),(521891,14497,'de','Schiff 3dcart Bestellungen',0),(521892,14497,'en','Ship 3dcart Orders',0),(521893,14498,'is','',0),(521894,14498,'dr','EFT Ù¾Ø±Ø¯Ø§Ø®Øª',0),(521895,14498,'pr','EFT Ù¾Ø±Ø¯Ø§Ø®Øª',0),(521896,14498,'tr','EFT Ã¶deme',0),(521897,14498,'pl','EFT pÅ‚atnoÅ›ci',0),(521898,14498,'bg','EFT Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(521899,14498,'ur','EFT Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(521900,14498,'sr','Ð•Ð¤Ð¢ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(521901,14498,'vi','EFT thanh toÃ¡n',0),(521902,14498,'af','EFT betaling',0),(521903,14498,'ro','Plata EFT',0),(521904,14498,'et','EFT makse',0),(521905,14498,'si','PlaÄilo EFT',0),(521906,14498,'ba','Pembayaran TDE',0),(521907,14498,'nl','EFT betaling',0),(521908,14498,'fi','EFT Payment',0),(521909,14498,'no','EFT betaling',0),(521910,14498,'da','EFT betaling',0),(521911,14498,'ko','ì „ìž ì†¡ê¸ˆ ì§€ë¶ˆ',0),(521912,14498,'he','EFT ×”×ª×©×œ×•×',0),(521913,14498,'el','EFT Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(521914,14498,'zh','EFT ä»˜æ¬¾',0),(521915,14498,'sv','EFT betalning',0),(521916,14498,'it','Pagamento EFT',0),(521917,14498,'tl','',0),(521918,14498,'th','EFT à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(521919,14498,'hi','à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(521920,14498,'ms','Bayaran EFT',0),(521921,14498,'ar','ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø£Ù…ÙˆØ§Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(521922,14498,'fr','Paiement de l\'EFT',0),(521923,14498,'jp','éŠ€è¡Œå£åº§æŒ¯è¾¼æ±ºæ¸ˆ',0),(521924,14498,'pt','Pagamento de EFT',0),(521925,14498,'ru','Ð­Ð›Ð•ÐšÐ¢Ð ÐžÐÐÐ«Ð™ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(521926,14498,'es','Pago EFT',0),(521927,14498,'de','EFT-Zahlung',0),(521928,14498,'en','EFT Payment',0),(521929,14499,'is','',0),(521930,14499,'dr','Ø­ÙˆØ§Ù„Ù‡',0),(521931,14499,'pr','Ø­ÙˆØ§Ù„Ù‡',0),(521932,14499,'tr','Havale',0),(521933,14499,'pl','Przelew',0),(521934,14499,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð´',0),(521935,14499,'ur','Ø²Ø±Ù…Ø¨Ø§Ø¯Ù„Û',0),(521936,14499,'sr','ÐŸÑ€Ð¸ÑÑ‚Ð¸Ð³Ð°Ð¾',0),(521937,14499,'vi','Chuyá»ƒn tiá»n',0),(521938,14499,'af','Remittance',0),(521939,14499,'ro','Remitente',0),(521940,14499,'et','RahaÃ¼lekanne',0),(521941,14499,'si','Nakazilo',0),(521942,14499,'ba','Pengiriman uang',0),(521943,14499,'nl','Remise',0),(521944,14499,'fi','Maksusuoritus',0),(521945,14499,'no','Remisse',0),(521946,14499,'da','Remittance',0),(521947,14499,'ko','ì†¡ê¸ˆ',0),(521948,14499,'he','×”×¢×‘×¨×” ×‘× ×§××™×ª',0),(521949,14499,'el','ÎˆÎ¼Î²Î±ÏƒÎ¼Î±',0),(521950,14499,'zh','æ±‡æ¬¾',0),(521951,14499,'sv','Remittering',0),(521952,14499,'it','Rimesse',0),(521953,14499,'tl','',0),(521954,14499,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸œà¹ˆà¸²à¸™à¸˜à¸™à¸²à¸„à¸²à¸£',0),(521955,14499,'hi','à¤µà¤¿à¤ªà¥à¤°à¥‡à¤·à¤£',0),(521956,14499,'ms','Kiriman wang',0),(521957,14499,'ar','Ø§Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(521958,14499,'fr','Versement',0),(521959,14499,'jp','é€é‡‘',0),(521960,14499,'pt','Remessa',0),(521961,14499,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð´',0),(521962,14499,'es','Remesas',0),(521963,14499,'de','Ãœberweisung',0),(521964,14499,'en','Remittance',0),(521965,14500,'is','',0),(521966,14500,'dr','Ù¾ÙˆÙ„ ÙØ±Ø³ØªØ§Ø¯Ù‡',0),(521967,14500,'pr','Ù¾ÙˆÙ„ ÙØ±Ø³ØªØ§Ø¯Ù‡',0),(521968,14500,'tr','E-postayla gÃ¶nderilen havale',0),(521969,14500,'pl','Przelewu e-mailem',0),(521970,14500,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð´ ÐµÐ¼Ð°Ð¹Ð»',0),(521971,14500,'ur','Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© Ú©ÛŒ ØªØ±Ø³ÛŒÙ„',0),(521972,14500,'sr','ÐŸÑ€Ð¸ÑÑ‚Ð¸Ð³Ð°Ð¾ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð»',0),(521973,14500,'vi','Chuyá»ƒn tiá»n gá»­i qua email',0),(521974,14500,'af','Remittance per e-pos',0),(521975,14500,'ro','Incasare prin E-mail',0),(521976,14500,'et','RahaÃ¼lekande meilitsi',0),(521977,14500,'si','Nakazilo po e-poÅ¡ti',0),(521978,14500,'ba','Pengiriman email',0),(521979,14500,'nl','Overschrijving per E-mail',0),(521980,14500,'fi','LÃ¤hettÃ¤mÃ¤llÃ¤ sÃ¤hkÃ¶postitse',0),(521981,14500,'no','Remittering sendt',0),(521982,14500,'da','Remittance mailede',0),(521983,14500,'ko','ì´ë©”ì¼ë¡œ ì†¡ê¸ˆ',0),(521984,14500,'he','×”×¢×‘×¨×” ×‘× ×§××™×ª ×‘×“×•×',0),(521985,14500,'el','ÎˆÎ¼Î²Î±ÏƒÎ¼Î± Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(521986,14500,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€çš„æ±‡æ¬¾',0),(521987,14500,'sv','Remittering mailade',0),(521988,14500,'it','Rimesse inviato via email',0),(521989,14500,'tl','',0),(521990,14500,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸œà¹ˆà¸²à¸™à¸˜à¸™à¸²à¸„à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥',0),(521991,14500,'hi','à¤ˆà¤®à¥‡à¤² à¤ªà¥à¤°à¥‡à¤·à¤£',0),(521992,14500,'ms','Pengiriman wang melalui e-mel',0),(521993,14500,'ar','Ø§Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(521994,14500,'fr','Transfert de fonds par courriel',0),(521995,14500,'jp','ãƒ¡ãƒ¼ãƒ«é€é‡‘',0),(521996,14500,'pt','Remessa por E-mail',0),(521997,14500,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾ Ð´ÐµÐ½ÐµÐ¶Ð½Ñ‹Ñ…',0),(521998,14500,'es','EnvÃ­o por correo electrÃ³nico',0),(521999,14500,'de','Ãœberweisung per E-Mail',0),(522000,14500,'en','Remittance Emailed',0),(522001,14501,'is','',0),(522002,14501,'dr','Ø­ÙˆØ§Ù„Ù‡ Ø§ÛŒÙ…ÛŒÙ„ Ù¾ÛŒØ´Ø±ÙØª',0),(522003,14501,'pr','Ø­ÙˆØ§Ù„Ù‡ Ø§ÛŒÙ…ÛŒÙ„ Ù¾ÛŒØ´Ø±ÙØª',0),(522004,14501,'tr','Havale Email ilerleme',0),(522005,14501,'pl','Przekaz E-mail postÄ™pu',0),(522006,14501,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð¸Ð¼ÐµÐ¹Ð» Ð¿Ñ€Ð¾Ð³Ñ€ÐµÑ',0),(522007,14501,'ur','ØªØ±Ø³ÛŒÙ„ Ø§ÛŒ Ù…ÛŒÙ„ Ù¾ÛŒØ´ Ø±ÙØª',0),(522008,14501,'sr','ÐŸÑ€Ð¸ÑÑ‚Ð¸Ð³Ð°Ð¾ Ð•Ð¼Ð°Ð¸Ð» Ð½Ð°Ð¿Ñ€ÐµÐ´Ð°Ðº',0),(522009,14501,'vi','Chuyá»ƒn tiá»n Email tiáº¿n bá»™',0),(522010,14501,'af','Remittance e-pos vordering',0),(522011,14501,'ro','Progresul de E-mail remitente',0),(522012,14501,'et','RahaÃ¼lekande Email edu',0),(522013,14501,'si','Nakazilo Email napredek',0),(522014,14501,'ba','Pengiriman Email kemajuan',0),(522015,14501,'nl','Remise E-mail vooruitgang',0),(522016,14501,'fi','LÃ¤hettÃ¤mÃ¤llÃ¤ sÃ¤hkÃ¶postia edistymistÃ¤',0),(522017,14501,'no','Remittering e-fremgang',0),(522018,14501,'da','Remittance E-mail fremskridt',0),(522019,14501,'ko','ì†¡ê¸ˆ ì´ë©”ì¼ ì§„í–‰',0),(522020,14501,'he','×”×ª×§×“×ž×•×ª ××™×ž×™×™×œ ×”×‘× ×§××™×ª',0),(522021,14501,'el','Î•Î¼Î²Î±ÏƒÎ¼Î¬Ï„Ï‰Î½ Email Ï€ÏÏŒÎ¿Î´Î¿',0),(522022,14501,'zh','æ±‡æ¬¾ç”µå­é‚®ä»¶è¿›å±•',0),(522023,14501,'sv','Remittering e-framsteg',0),(522024,14501,'it','Rimesse Email progresso',0),(522025,14501,'tl','',0),(522026,14501,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸œà¹ˆà¸²à¸™à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸„à¸§à¸²à¸¡à¸„à¸·à¸šà¸«à¸™à¹‰à¸²',0),(522027,14501,'hi','à¤µà¤¿à¤ªà¥à¤°à¥‡à¤·à¤£ à¤ˆà¤®à¥‡à¤² à¤ªà¥à¤°à¤—à¤¤à¤¿',0),(522028,14501,'ms','Kiriman e-mel kemajuan',0),(522029,14501,'ar','ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø£Ù…ÙˆØ§Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„ØªÙ‚Ø¯Ù…',0),(522030,14501,'fr','Versement Email progrÃ¨s',0),(522031,14501,'jp','é€é‡‘ãƒ¡ãƒ¼ãƒ«ã®é€²è¡ŒçŠ¶æ³',0),(522032,14501,'pt','Envio E-mail progresso',0),(522033,14501,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð´ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð¿Ñ€Ð¾Ð³Ñ€ÐµÑÑ',0),(522034,14501,'es','Remesas Email progreso',0),(522035,14501,'de','Rimesse E-Mail Fortschritt',0),(522036,14501,'en','Remittance Email Progress',0),(522037,14502,'is','',0),(522038,14502,'dr','Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ¹Ø¯Ø§Ø¯ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† ÙØ±Ø§ØªØ± Ø±ÙØªÙ‡ Ø§Ø³Øª',0),(522039,14502,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± ØªØ¹Ø¯Ø§Ø¯ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† ÙØ±Ø§ØªØ± Ø±ÙØªÙ‡ Ø§Ø³Øª',0),(522040,14502,'tr','En fazla kullanÄ±cÄ± sayÄ±sÄ± aÅŸÄ±ldÄ±',0),(522041,14502,'pl','Przekroczono maksymalnÄ… liczbÄ™ uÅ¼ytkownikÃ³w',0),(522042,14502,'bg','Ð• Ð½Ð°Ð´Ñ…Ð²ÑŠÑ€Ð»ÐµÐ½ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»ÐµÐ½ Ð±Ñ€Ð¾Ð¹ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(522043,14502,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©ÛŒ Ø¨Ú‘ÛŒ Ø³Û’ Ø¨Ú‘ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø¢Ú¯Û’ Ø¨Ú‘Ú¾ Ú†Ú©ÛŒ ÛÛ’',0),(522044,14502,'sr','ÐŸÑ€ÐµÐ¼Ð°ÑˆÐµÐ½ Ñ˜Ðµ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(522045,14502,'vi','Tá»‘i Ä‘a sá»‘ lÆ°á»£ng ngÆ°á»i dÃ¹ng Ä‘Ã£ bá»‹ vÆ°á»£t quÃ¡',0),(522046,14502,'af','Maksimum aantal gebruikers het nie oorskry is nie',0),(522047,14502,'ro','S-a depÄƒÈ™it numÄƒrul maxim de utilizatori',0),(522048,14502,'et','Lubatud kasutajate arv Ã¼letas',0),(522049,14502,'si','PreseÅ¾eno najveÄje Å¡tevilo uporabnikov',0),(522050,14502,'ba','Jumlah maksimum Users telah melampaui',0),(522051,14502,'nl','Maximum aantal gebruikers is overschreden',0),(522052,14502,'fi','KÃ¤yttÃ¤jien enimmÃ¤ismÃ¤Ã¤rÃ¤ on ylitetty',0),(522053,14502,'no','Maksimalt antall brukere er overskredet',0),(522054,14502,'da','Maksimalt antal brugere er overskredet',0),(522055,14502,'ko','ì‚¬ìš©ìžì˜ ìµœëŒ€ ìˆ˜ë¥¼ ì´ˆê³¼',0),(522056,14502,'he','×”×ž×¡×¤×¨ ×”×ž×™×¨×‘×™ ×©×œ ×ž×©×ª×ž×©×™× ××™×¨×¢×” ×—×¨×™×’×”',0),(522057,14502,'el','ÎžÎµÏ€ÎµÏÎ¬ÏƒÏ„Î·ÎºÎµ Î¿ Î¼Î­Î³Î¹ÏƒÏ„Î¿Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½ Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½',0),(522058,14502,'zh','å·²è¶…å‡ºæœ€å¤§ç”¨æˆ·æ•°',0),(522059,14502,'sv','Maximalt antal anvÃ¤ndare har Ã¶verskridits',0),(522060,14502,'it','Ãˆ stato superato il numero massimo di utenti',0),(522061,14502,'tl','',0),(522062,14502,'th','à¹€à¸à¸´à¸™à¸ˆà¸³à¸™à¸§à¸™à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(522063,14502,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥€ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤¾à¤° à¤¹à¥‹ à¤—à¤ˆ à¤¹à¥ˆ',0),(522064,14502,'ms','Bilangan maksima pengguna telah melebihi',0),(522065,14502,'ar','ØªÙ… ØªØ¬Ø§ÙˆØ² Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(522066,14502,'fr','Nombre maximal d\'utilisateurs a Ã©tÃ© dÃ©passÃ©e',0),(522067,14502,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®æœ€å¤§æ•°ã‚’è¶…ãˆã¾ã—ãŸ',0),(522068,14502,'pt','Foi excedido o nÃºmero mÃ¡ximo de usuÃ¡rios',0),(522069,14502,'ru','ÐŸÑ€ÐµÐ²Ñ‹ÑˆÐµÐ½Ð¾ Ð¼Ð°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(522070,14502,'es','Se ha superado el nÃºmero mÃ¡ximo de usuarios',0),(522071,14502,'de','Maximale Anzahl von Benutzern wurde Ã¼berschritten',0),(522072,14502,'en','Maximum Number Of Users Has Been Exceeded',0),(522073,14503,'is','',0),(522074,14503,'dr','Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ù†Ù…ÛŒ ØªÙˆØ§Ù† Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯.',0),(522075,14503,'pr','Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ù†Ù…ÛŒ ØªÙˆØ§Ù† Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯.',0),(522076,14503,'tr','KullanÄ±cÄ± eklenemiyor.',0),(522077,14503,'pl','Nie moÅ¼na dodaÄ‡ uÅ¼ytkownika.',0),(522078,14503,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½.',0),(522079,14503,'ur','ØµØ§Ø±Ù Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ ÛÛ’ Û”',0),(522080,14503,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°.',0),(522081,14503,'vi','KhÃ´ng thá»ƒ thÃªm ngÆ°á»i dÃ¹ng.',0),(522082,14503,'af','Gebruiker kan bygevoeg word.',0),(522083,14503,'ro','Imposibil de adÄƒugat utilizatorul.',0),(522084,14503,'et','Kasutajat ei saa lisada.',0),(522085,14503,'si','Uporabnika ni mogoÄe dodati.',0),(522086,14503,'ba','Pengguna tidak dapat ditambahkan.',0),(522087,14503,'nl','Gebruiker kan niet worden toegevoegd.',0),(522088,14503,'fi','KÃ¤yttÃ¤jÃ¤Ã¤ ei voi lisÃ¤tÃ¤.',0),(522089,14503,'no','Brukeren kan ikke legges til.',0),(522090,14503,'da','Brugeren kan ikke tilfÃ¸jes.',0),(522091,14503,'ko','ì‚¬ìš©ìžë¥¼ ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(522092,14503,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×•×¡×™×£ ××ª ×”×ž×©×ª×ž×©.',0),(522093,14503,'el','Î§ÏÎ®ÏƒÏ„Î· Î´ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸Î¿ÏÎ½.',0),(522094,14503,'zh','æ— æ³•æ·»åŠ ç”¨æˆ·ã€‚',0),(522095,14503,'sv','AnvÃ¤ndaren kan inte lÃ¤ggas till.',0),(522096,14503,'it','Utente non puÃ² essere aggiunto.',0),(522097,14503,'tl','',0),(522098,14503,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸žà¸´à¹ˆà¸¡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(522099,14503,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾à¥¤',0),(522100,14503,'ms','Pengguna tidak dapat ditambah.',0),(522101,14503,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù….',0),(522102,14503,'fr','L\'utilisateur ne peut pas Ãªtre ajoutÃ©.',0),(522103,14503,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’è¿½åŠ ã§ãã¾ã›ã‚“ã€‚',0),(522104,14503,'pt','UsuÃ¡rio nÃ£o pode ser adicionado.',0),(522105,14503,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½.',0),(522106,14503,'es','No se puede Agregar el usuario.',0),(522107,14503,'de','Benutzer kann nicht hinzugefÃ¼gt werden.',0),(522108,14503,'en','User cannot be added.',0),(522109,14504,'is','',0),(522110,14504,'dr','Ù…Ø´ØªØ±ÛŒ 3 Ø³Ø§Ù„ Ø³Ø§Ø¨Ù‚Ù‡',0),(522111,14504,'pr','Ù…Ø´ØªØ±ÛŒ 3 Ø³Ø§Ù„ Ø³Ø§Ø¨Ù‚Ù‡',0),(522112,14504,'tr','MÃ¼ÅŸteri 3 yÄ±llÄ±k geÃ§miÅŸi',0),(522113,14504,'pl','Klienta 3-letniej historii',0),(522114,14504,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ 3-Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(522115,14504,'ur','Ú©Ø³Ù¹Ù…Ø± 3 Ø³Ø§Ù„Û ØªØ§Ø±ÛŒØ®',0),(522116,14504,'sr','ÐšÑƒÐ¿Ð°Ñ† 3-Ð³Ð¾Ð´Ð¸ÑˆÑšÐ¾Ñ˜ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð¸',0),(522117,14504,'vi','KhÃ¡ch hÃ ng 3-nÄƒm lá»‹ch sá»­',0),(522118,14504,'af','KliÃ«nt 3-jaar geskiedenis',0),(522119,14504,'ro','Istorie de 3 ani client',0),(522120,14504,'et','Kliendi 3 aastat ajalugu',0),(522121,14504,'si','Kupec 3-letni zgodovini',0),(522122,14504,'ba','Pelanggan 3 tahun sejarah',0),(522123,14504,'nl','Klant 3-jarige geschiedenis',0),(522124,14504,'fi','3 vuoden Asiakashistoria',0),(522125,14504,'no','3 Ã¥rs kundehistorikk',0),(522126,14504,'da','Kunde 3-Ã¥rige historie',0),(522127,14504,'ko','ê³ ê° 3 ë…„ ì—­ì‚¬',0),(522128,14504,'he','×œ×§×•×— 3 ×©× ×•×ª ×”×™×¡×˜×•×¨×™×”',0),(522129,14504,'el','3-ÎµÏ„Î® Î¹ÏƒÏ„Î¿ÏÎ¯Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(522130,14504,'zh','å®¢æˆ· 3 å¹´çš„åŽ†å²',0),(522131,14504,'sv','Kund 3-Ã¥riga historia',0),(522132,14504,'it','Cliente 3 anni di storia',0),(522133,14504,'tl','',0),(522134,14504,'th','à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸¥à¸¹à¸à¸„à¹‰à¸² 3 à¸›à¸µ',0),(522135,14504,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• 3 à¤¸à¤¾à¤² à¤•à¥‡ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(522136,14504,'ms','Baca 3 tahun sejarah',0),(522137,14504,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø³Ù†Ø© 3 Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(522138,14504,'fr','Client historique de 3 ans',0),(522139,14504,'jp','é¡§å®¢ã® 3 å¹´ã®æ­´å²',0),(522140,14504,'pt','Cliente 3-anos de histÃ³ria',0),(522141,14504,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ 3-Ð»ÐµÑ‚Ð½ÑŽÑŽ Ð¸ÑÑ‚Ð¾Ñ€Ð¸ÑŽ',0),(522142,14504,'es','Cliente 3 aÃ±os de historia',0),(522143,14504,'de','3-jÃ¤hrige Kundenhistorie',0),(522144,14504,'en','Customer 3-Year History',0),(522145,14505,'is','',0),(522146,14505,'dr','ÙØ±ÙˆØ´ YTD',0),(522147,14505,'pr','ÙØ±ÙˆØ´ YTD',0),(522148,14505,'tr','SatÄ±ÅŸ YTD',0),(522149,14505,'pl','YTD Sales',0),(522150,14505,'bg','ÐžÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(522151,14505,'ur','ÛŒÙ¹Ø¯ Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(522152,14505,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(522153,14505,'vi','YTD bÃ¡n hÃ ng',0),(522154,14505,'af','YTD verkope',0),(522155,14505,'ro','YTD vÃ¢nzÄƒri',0),(522156,14505,'et','YTD mÃ¼Ã¼k',0),(522157,14505,'si','YTD prodaje',0),(522158,14505,'ba','YTD penjualan',0),(522159,14505,'nl','YTD verkoop',0),(522160,14505,'fi','Tuotteiden myynti',0),(522161,14505,'no','YTD salg',0),(522162,14505,'da','Ã…TD-salg',0),(522163,14505,'ko','ëˆ„ê³„ íŒë§¤',0),(522164,14505,'he','×ž×›×™×¨×•×ª ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(522165,14505,'el','Î¤Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ YTD',0),(522166,14505,'zh','æœ¬å¹´ç´¯è®¡é”€å”®é¢æŽ’åˆ—',0),(522167,14505,'sv','YTD Sales',0),(522168,14505,'it','YTD vendite',0),(522169,14505,'tl','',0),(522170,14505,'th','à¸‚à¸²à¸¢ YTD',0),(522171,14505,'hi','YTD à¤¬à¤¿à¤•à¥à¤°à¥€',0),(522172,14505,'ms','THK jualan',0),(522173,14505,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø¹Ø§Ù…',0),(522174,14505,'fr','Ventes de CDA',0),(522175,14505,'jp','YTD å£²ä¸Š',0),(522176,14505,'pt','Vendas acumulado no ano',0),(522177,14505,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(522178,14505,'es','YTD ventas',0),(522179,14505,'de','YTD Sales',0),(522180,14505,'en','YTD Sales',0),(522181,14506,'is','',0),(522182,14506,'dr','Ø¯Ø± Xfer',0),(522183,14506,'pr','Ø¯Ø± Xfer',0),(522184,14506,'tr','Xfer Ã¼zerinde',0),(522185,14506,'pl','Na Xfer',0),(522186,14506,'bg','ÐÐ° Xfer',0),(522187,14506,'ur','Ø§ÙØ§Ø± Ù¾Ø±',0),(522188,14506,'sr','ÐÐ° XÑ„ÐµÑ€',0),(522189,14506,'vi','TrÃªn Xfer',0),(522190,14506,'af','Op Xfer',0),(522191,14506,'ro','Pe Xfer',0),(522192,14506,'et','Linna Xfer',0),(522193,14506,'si','Na Xfer',0),(522194,14506,'ba','Pada Xfer',0),(522195,14506,'nl','Op Xfer',0),(522196,14506,'fi','JÃ¤senen Xfer',0),(522197,14506,'no','PÃ¥ Xfer',0),(522198,14506,'da','PÃ¥ Xfer',0),(522199,14506,'ko','Xferì—',0),(522200,14506,'he','×‘- Xfer',0),(522201,14506,'el','Î£Îµ Xfer',0),(522202,14506,'zh','å…³äºŽ Xfer',0),(522203,14506,'sv','PÃ¥ Xfer',0),(522204,14506,'it','Su Xfer',0),(522205,14506,'tl','',0),(522206,14506,'th','à¹ƒà¸™ Xfer',0),(522207,14506,'hi','à¤ªà¤° Xfer',0),(522208,14506,'ms','Pada Xfer',0),(522209,14506,'ar','Ø¹Ù„Ù‰ Ø²ÙÙŠØ±',0),(522210,14506,'fr','Sur Xfer',0),(522211,14506,'jp','Xfer ã®',0),(522212,14506,'pt','Na Xfer',0),(522213,14506,'ru','ÐÐ° Xfer',0),(522214,14506,'es','En Xfer',0),(522215,14506,'de','Auf Xfer',0),(522216,14506,'en','On Xfer',0),(522217,14507,'is','',0),(522218,14507,'dr','Ù…ÙˆØ§Ø±Ø¯ Ø§Ø®ÛŒØ±',0),(522219,14507,'pr','Ù…ÙˆØ§Ø±Ø¯ Ø§Ø®ÛŒØ±',0),(522220,14507,'tr','Son kullanÄ±lan Ã¶ÄŸeler',0),(522221,14507,'pl','Najnowsze pozycje',0),(522222,14507,'bg','Ð¡ÐºÐ¾Ñ€Ð¾ÑˆÐ½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(522223,14507,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ø´ÛŒØ§',0),(522224,14507,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(522225,14507,'vi','BÃ i gáº§n Ä‘Ã¢y',0),(522226,14507,'af','Onlangse Items',0),(522227,14507,'ro','Articole recente',0),(522228,14507,'et','Viimatised Ã¼ksused',0),(522229,14507,'si','Nedavni elementi',0),(522230,14507,'ba','Produk terbaru',0),(522231,14507,'nl','Recente Items',0),(522232,14507,'fi','Ã„skeiset kohteet',0),(522233,14507,'no','Siste elementer',0),(522234,14507,'da','Seneste emner',0),(522235,14507,'ko','ìµœê·¼ í•­ëª©',0),(522236,14507,'he','×¤×¨×™×˜×™× ××—×¨×•× ×™×',0),(522237,14507,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(522238,14507,'zh','æœ€è¿‘ä½¿ç”¨çš„é¡¹ç›®',0),(522239,14507,'sv','Senaste objekt',0),(522240,14507,'it','Articoli recenti',0),(522241,14507,'tl','',0),(522242,14507,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(522243,14507,'hi','à¤¹à¤¾à¤² à¤•à¥‡ à¤†à¤‡à¤Ÿà¤®',0),(522244,14507,'ms','Butiran terbaharu',0),(522245,14507,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø­Ø¯ÙŠØ«Ø©',0),(522246,14507,'fr','Articles rÃ©cents',0),(522247,14507,'jp','æœ€è¿‘ä½¿ã£ãŸé …ç›®',0),(522248,14507,'pt','Itens recentes',0),(522249,14507,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¿ÑƒÐ½ÐºÑ‚Ñ‹',0),(522250,14507,'es','ArtÃ­culos recientes',0),(522251,14507,'de','Zuletzt verwendete Elemente',0),(522252,14507,'en','Recent Items',0),(522253,14508,'is','',0),(522254,14508,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø§Ø®ÛŒØ±',0),(522255,14508,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø§Ø®ÛŒØ±',0),(522256,14508,'tr','Son satÄ±cÄ±lar',0),(522257,14508,'pl','Ostatnie dostawcÃ³w',0),(522258,14508,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(522259,14508,'ur','Ø­Ø§Ù„ÛŒÛ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº',0),(522260,14508,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(522261,14508,'vi','Táº¡i nhÃ  cung cáº¥p',0),(522262,14508,'af','Onlangse verkopers',0),(522263,14508,'ro','Recente furnizori',0),(522264,14508,'et','Tehtud mÃ¼Ã¼jad',0),(522265,14508,'si','Nedavni prodajalci',0),(522266,14508,'ba','Hari vendor',0),(522267,14508,'nl','Recente verkopers',0),(522268,14508,'fi','Hotelliin toimittajat',0),(522269,14508,'no','Siste leverandÃ¸rer',0),(522270,14508,'da','Seneste leverandÃ¸rer',0),(522271,14508,'ko','ìµœê·¼ ê³µê¸‰ ì—…ì²´',0),(522272,14508,'he','×¡×¤×§×™× ×”××—×¨×•× ×•×ª',0),(522273,14508,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚',0),(522274,14508,'zh','æœ€è¿‘çš„ä¾›åº”å•†',0),(522275,14508,'sv','Senaste leverantÃ¶rer',0),(522276,14508,'it','Fornitori recenti',0),(522277,14508,'tl','',0),(522278,14508,'th','à¸¥à¹ˆà¸²à¸ªà¸¸à¸”à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(522279,14508,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(522280,14508,'ms','Vendor hari',0),(522281,14508,'ar','Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ† Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(522282,14508,'fr','Vendeurs rÃ©centes',0),(522283,14508,'jp','æœ€è¿‘ã®ãƒ™ãƒ³ãƒ€ãƒ¼',0),(522284,14508,'pt','Ãšltimos fornecedores',0),(522285,14508,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(522286,14508,'es','Vendedores recientes',0),(522287,14508,'de','Aktuelle Anbieter',0),(522288,14508,'en','Recent Vendors',0),(522289,14509,'is','',0),(522290,14509,'dr','Ø«Ø¨Øª Ù…Ø­ØµÙˆÙ„ &amp; Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø§ÙˆÙ„ÛŒÙ‡ Ø´Ø±Ú©Øª',0),(522291,14509,'pr','Ø«Ø¨Øª Ù…Ø­ØµÙˆÙ„ &amp; Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø§ÙˆÙ„ÛŒÙ‡ Ø´Ø±Ú©Øª',0),(522292,14509,'tr','ÃœrÃ¼n kaydÄ± & ilk ÅŸirket kurulumu',0),(522293,14509,'pl','Rejestracja produktu & konfiguracji poczÄ…tkowej firma',0),(522294,14509,'bg','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸ÑÑ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° & Ð¿ÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(522295,14509,'ur','Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ Ø±Ø¬Ø³Ù¹Ø±ÛŒØ´Ù† & Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ Ú©Ù…Ù¾Ù†ÛŒ Ø³ÛŒÙ¹ Ø§Ù¾',0),(522296,14509,'sr','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ˜Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð° Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¿Ð¾Ñ‡ÐµÑ‚Ð½Ð¾ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(522297,14509,'vi','ÄÄƒng kÃ½ sáº£n pháº©m &amp; thiáº¿t láº­p ban Ä‘áº§u cÃ´ng ty',0),(522298,14509,'af','Produk registrasie & aanvanklike maatskappy opstelling',0),(522299,14509,'ro','ÃŽnregistrarea & iniÅ£ialÄƒ compania Setup',0),(522300,14509,'et','Toote registreerimine & esialgne ettevÃµtte seadistus',0),(522301,14509,'si','Registracija izdelka & zaÄetno podjetje Setup',0),(522302,14509,'ba','Registrasi produk & perusahaan Initial Setup',0),(522303,14509,'nl','Productregistratie & eerste bedrijf Setup',0),(522304,14509,'fi','Tuotteen rekisterÃ¶inti & alkuperÃ¤isen yrityksen asetukset',0),(522305,14509,'no','Produktregistrering & fÃ¸rste firmaoppsettet',0),(522306,14509,'da','Produktregistrering & indledende firmaopsÃ¦tningen',0),(522307,14509,'ko','ì œí’ˆ ë“±ë¡ & ì´ˆê¸° íšŒì‚¬ ì„¤ì¹˜',0),(522308,14509,'he','×¨×™×©×•× ×”×ž×•×¦×¨ & ×”×”×ª×§× ×” ×”×¨××©×•× ×™×ª ×”×—×‘×¨×”',0),(522309,14509,'el','Î•Î³Î³ÏÎ±Ï†Î®Ï‚ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚ & Î‘ÏÏ‡Î¹ÎºÎ® ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(522310,14509,'zh','äº§å“æ³¨å†Œ &amp; åˆå§‹å…¬å¸è®¾ç½®',0),(522311,14509,'sv','Produktregistrering & instÃ¤llningarna fÃ¶rsta fÃ¶retaget',0),(522312,14509,'it','Registrazione del prodotto & Setup iniziale azienda',0),(522313,14509,'tl','',0),(522314,14509,'th','à¸¥à¸‡à¸—à¸°à¹€à¸šà¸µà¸¢à¸™à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œ & à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™ à¸šà¸£à¸´à¸©à¸±à¸—',0),(522315,14509,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤ªà¤‚à¤œà¥€à¤•à¤°à¤£ & à¤†à¤¦à¥à¤¯à¤¾à¤•à¥à¤·à¤° à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥‡à¤Ÿà¤…à¤ª',0),(522316,14509,'ms','Pendaftaran produk & persediaan awal Syarikat',0),(522317,14509,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ù…Ù†ØªØ¬ Ø¢Ù†Ø¯ Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø£ÙˆÙ„Ù‰',0),(522318,14509,'fr','Enregistrement du produit & StÃ© Initial',0),(522319,14509,'jp','è£½å“ç™»éŒ² & åˆæœŸä¼šç¤¾ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(522320,14509,'pt','Registro do produto & Setup inicial empresa',0),(522321,14509,'ru','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ñ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° & Ñ„Ð¸Ñ€Ð¼Ñ‹ Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ð°Ñ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(522322,14509,'es','Registro del producto &amp; empresa Initial Setup',0),(522323,14509,'de','Produktregistrierung & Initial FirmengrÃ¼ndung',0),(522324,14509,'en','Product Registration & Initial Company Setup',0),(522325,14510,'is','',0),(522326,14510,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø²Ø§Ø±Ø´',0),(522327,14510,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú¯Ø²Ø§Ø±Ø´',0),(522328,14510,'tr','SeÃ§ili raporlarÄ±',0),(522329,14510,'pl','Wybrane raporty',0),(522330,14510,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´Ð¸ Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(522331,14510,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ø¯Û Ø±Ù¾ÙˆØ±Ù¹Ø³',0),(522332,14510,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(522333,14510,'vi','BÃ¡o cÃ¡o Ä‘Æ°á»£c chá»n',0),(522334,14510,'af','Verslae gekies',0),(522335,14510,'ro','Rapoartele selectate',0),(522336,14510,'et','Valitud aruannete',0),(522337,14510,'si','PoroÄila izbere',0),(522338,14510,'ba','Laporan yang dipilih',0),(522339,14510,'nl','Rapporten geselecteerd',0),(522340,14510,'fi','Kertomukset valinnut',0),(522341,14510,'no','Rapporter valgt',0),(522342,14510,'da','Rapporter valgt',0),(522343,14510,'ko','ë³´ê³ ì„œ ì„ íƒ',0),(522344,14510,'he','×“×•×—×•×ª ×©× ×‘×—×¨×•',0),(522345,14510,'el','Î•ÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(522346,14510,'zh','é€‰å®šçš„æŠ¥å‘Š',0),(522347,14510,'sv','Rapporter som valts',0),(522348,14510,'it','Report selezionato',0),(522349,14510,'tl','',0),(522350,14510,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(522351,14510,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(522352,14510,'ms','Laporan-laporan yang dipilih',0),(522353,14510,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ù…Ø®ØªØ§Ø±Ø©',0),(522354,14510,'fr','Rapports sÃ©lectionnÃ©s',0),(522355,14510,'jp','ãƒ¬ãƒãƒ¼ãƒˆã‚’é¸æŠž',0),(522356,14510,'pt','RelatÃ³rios selecionados',0),(522357,14510,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹',0),(522358,14510,'es','Informes seleccionados',0),(522359,14510,'de','Berichte ausgewÃ¤hlt',0),(522360,14510,'en','Reports Selected',0),(522361,14511,'is','',0),(522362,14511,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(522363,14511,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(522364,14511,'tr','GÃ¶ster raporlar',0),(522365,14511,'pl','PokaÅ¼ raporty',0),(522366,14511,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(522367,14511,'ur','Ø´Ùˆ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(522368,14511,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ðµ',0),(522369,14511,'vi','Hiá»ƒn thá»‹ bÃ¡o cÃ¡o',0),(522370,14511,'af','Wys verslae',0),(522371,14511,'ro','AratÄƒ rapoartele',0),(522372,14511,'et','NÃ¤ita aruanded',0),(522373,14511,'si','PrikaÅ¾i poroÄila',0),(522374,14511,'ba','Menampilkan laporan',0),(522375,14511,'nl','Toon rapporten',0),(522376,14511,'fi','NÃ¤ytÃ¤ raportit',0),(522377,14511,'no','Vis rapporter',0),(522378,14511,'da','Vis rapporter',0),(522379,14511,'ko','í‘œì‹œ ë³´ê³ ì„œ',0),(522380,14511,'he','×”×¦×’ ×“×•×—×•×ª',0),(522381,14511,'el','Î•ÎšÎ˜Î•Î£Î•Î©Î ÎœÎŸÎ¡Î¦ÎŸÎ›ÎŸÎ“Î™Î‘Î£',0),(522382,14511,'zh','æ˜¾ç¤ºæŠ¥å‘Š',0),(522383,14511,'sv','Visa rapporter',0),(522384,14511,'it','Visualizza report',0),(522385,14511,'tl','',0),(522386,14511,'th','à¹à¸ªà¸”à¸‡à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(522387,14511,'hi','à¤¶à¥‹ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(522388,14511,'ms','Papar Laporan',0),(522389,14511,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ±',0),(522390,14511,'fr','Rapports Voir la',0),(522391,14511,'jp','ã‚·ãƒ§ãƒ¼ ãƒ¬ãƒãƒ¼ãƒˆ',0),(522392,14511,'pt','Visualizar relatÃ³rios',0),(522393,14511,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹',0),(522394,14511,'es','Mostrar informes',0),(522395,14511,'de','Berichte anzeigen',0),(522396,14511,'en','Show Reports',0),(522397,14512,'is','',0),(522398,14512,'dr','Ø¨Ø§Ù„Ø§ 10 Ù…Ø´ØªØ±ÛŒØ§Ù† Ú†Ø§Ù¾--30 Ø±ÙˆØ²',0),(522399,14512,'pr','Ø¨Ø§Ù„Ø§ 10 Ù…Ø´ØªØ±ÛŒØ§Ù† Ú†Ø§Ù¾--30 Ø±ÙˆØ²',0),(522400,14512,'tr','En iyi 10 baskÄ± mÃ¼ÅŸteriler - 30 gÃ¼n',0),(522401,14512,'pl','10 najlepszych klientÃ³w wydruku - 30 dni',0),(522402,14512,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ - 30 Ð´Ð½Ð¸',0),(522403,14512,'ur','Ù¹Ø§Ù¾ 10 Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ú¯Ø§ÛÚ©ÙˆÚº - 30 Ø¯Ù†',0),(522404,14512,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐºÑƒÐ¿Ñ†Ð¸ Ð¿Ñ€Ð²Ð¸Ñ… 10 - 30 Ð´Ð°Ð½Ð°',0),(522405,14512,'vi','Top 10 in khÃ¡ch - 30 ngÃ y',0),(522406,14512,'af','Top 10 druk klante - 30 dae',0),(522407,14512,'ro','ClienÅ£ii imprimare top 10 - 30 de zile',0),(522408,14512,'et','Top 10 Prindi kÃ¼lastajad - 30 pÃ¤eva',0),(522409,14512,'si','Print kupci top 10 - 30 dni',0),(522410,14512,'ba','Top 10 cetak pelanggan - 30 hari',0),(522411,14512,'nl','Top 10 afdrukken klanten - 30 dagen',0),(522412,14512,'fi','Top 10 tulosta asiakkaat - 30 pÃ¤ivÃ¤Ã¤',0),(522413,14512,'no','Topp 10 Print kunder - 30 dager',0),(522414,14512,'da','Top 10 udskrive kunderne - 30 dage',0),(522415,14512,'ko','í†± 10 ì¸ì‡„ ê³ ê°-30 ì¼',0),(522416,14512,'he','×œ×§×•×—×•×ª ×”×“×¤×¡×” ×”×¢×œ×™×•×Ÿ 10 - 30 ×™×ž×™×',0),(522417,14512,'el','Top 10 ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ - 30 Î·Î¼Î­ÏÎµÏ‚',0),(522418,14512,'zh','åå¤§æ‰“å°å®¢æˆ·-30 å¤©',0),(522419,14512,'sv','Topp 10 skriva ut kunder - 30 dagar',0),(522420,14512,'it','Clienti stampa Top 10 - 30 giorni',0),(522421,14512,'tl','',0),(522422,14512,'th','à¹‚à¸£à¸‡à¹à¸£à¸¡à¸¢à¸­à¸”à¸™à¸´à¸¢à¸¡à¹ƒà¸™à¸¥à¸¹à¸à¸„à¹‰à¸²à¸žà¸´à¸¡à¸žà¹Œ 10 - 30 à¸§à¸±à¸™',0),(522423,14512,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤—à¥à¤°à¤¾à¤¹à¤• - 30 à¤¦à¤¿à¤¨',0),(522424,14512,'ms','Top 10 cetakan pelanggan - 30 hari',0),(522425,14512,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø·Ø¨Ø§Ø¹Ø© Ø£Ø¹Ù„Ù‰ 10-30 ÙŠÙˆÙ…Ø§',0),(522426,14512,'fr','Top 10 impression clients - 30 jours',0),(522427,14512,'jp','ãƒˆãƒƒãƒ— 10 å°åˆ·ã€é¡§å®¢ - 30 æ—¥',0),(522428,14512,'pt','Top 10 clientes impressÃ£o - 30 dias',0),(522429,14512,'ru','Ð¢Ð¾Ð¿ 10 ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ - 30 Ð´Ð½ÐµÐ¹',0),(522430,14512,'es','Top 10 clientes imprimir - 30 dÃ­as',0),(522431,14512,'de','Top 10 Print-Kunden - 30 Tage',0),(522432,14512,'en','Top 10 Print Customers - 30 Days',0),(522433,14513,'is','',0),(522434,14513,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¯Ø³ØªÙ‡ - 30 Ø±ÙˆØ²',0),(522435,14513,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¯Ø³ØªÙ‡ - 30 Ø±ÙˆØ²',0),(522436,14513,'tr','Kategori - 30 gÃ¼n stok kullanÄ±mÄ±',0),(522437,14513,'pl','ZuÅ¼ycie zapasÃ³w wedÅ‚ug kategorii - 30 dzieÅ„',0),(522438,14513,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°ÐµÐ¼Ð¾ÑÑ‚ Ð½Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ - 30 Ð´Ð½Ð¸',0),(522439,14513,'ur','Ø²Ù…Ø±Û: 30 Ø¯Ù† Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(522440,14513,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸ - 30 Ð´Ð°Ð½Ð°',0),(522441,14513,'vi','Sá»­ dá»¥ng hÃ ng tá»“n kho theo thá»ƒ loáº¡i - 30 ngÃ y',0),(522442,14513,'af','Voorraad gebruik deur kategorie - 30 dag',0),(522443,14513,'ro','Stocuri de utilizare de categoria - 30 zile',0),(522444,14513,'et','Varude kasutamine kategooria - 30 pÃ¤eva',0),(522445,14513,'si','Zaloge navada po kategoriji - 30 dan',0),(522446,14513,'ba','Penggunaan persediaan berdasarkan Kategori - 30 hari',0),(522447,14513,'nl','Inventaris gebruik per categorie - 30 dagen',0),(522448,14513,'fi','Sivustovaraston kÃ¤yttÃ¶ Kategoria - 30 pÃ¤ivÃ¤Ã¤',0),(522449,14513,'no','Lager bruk av kategori - 30 dagers',0),(522450,14513,'da','Lageret brug af kategori - 30 dages',0),(522451,14513,'ko','ì¹´í…Œê³ ë¦¬-30 ì¼ ìž¬ê³  ì‚¬ìš©',0),(522452,14513,'he','×”×©×™×ž×•×© ×”×ž×œ××™ ×œ×¤×™ ×§×˜×’×•×¨×™×” - 30 ×™×•×',0),(522453,14513,'el','Î§ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î±Î½Î¬ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± - 30 Î·Î¼ÎµÏÏŽÎ½',0),(522454,14513,'zh','æŒ‰ç±»åˆ«-30 å¤©çš„åº“å­˜ä½¿ç”¨çŽ‡',0),(522455,14513,'sv','Inventering anvÃ¤ndning av kategori - 30 dagars',0),(522456,14513,'it','Utilizzo di inventario di categoria - 30 giorni',0),(522457,14513,'tl','',0),(522458,14513,'th','à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸— - 30 à¸§à¸±à¸™',0),(522459,14513,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤‰à¤ªà¤¯à¥‹à¤— à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¶à¥à¤°à¥‡à¤£à¥€ - 30 à¤¦à¤¿à¤µà¤¸',0),(522460,14513,'ms','Penggunaan inventori mengikut kategori - 30 hari',0),(522461,14513,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø­Ø³Ø¨ Ø§Ù„ÙØ¦Ø©-30 ÙŠÙˆÙ…',0),(522462,14513,'fr','Utilisation de l\'inventaire par catÃ©gorie - 30 jours',0),(522463,14513,'jp','ã‚«ãƒ†ã‚´ãƒª - 30 æ—¥é–“ã§ã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®åˆ©ç”¨çŠ¶æ³',0),(522464,14513,'pt','Uso de estoque por categoria - dia 30',0),(522465,14513,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÐ¼ - 30 Ð´ÐµÐ½ÑŒ',0),(522466,14513,'es','Uso del inventario por categorÃ­a - 30 dÃ­as',0),(522467,14513,'de','Inventar-Nutzung durch Kategorie - 30 Tage',0),(522468,14513,'en','Inventory Usage By Category - 30 Day',0),(522469,14514,'is','',0),(522470,14514,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¯Ø³ØªÙ‡ - Ø³Ø§Ù„',0),(522471,14514,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¯Ø³ØªÙ‡ - Ø³Ø§Ù„',0),(522472,14514,'tr','Kategori - yÄ±l stok kullanÄ±mÄ±',0),(522473,14514,'pl','ZuÅ¼ycie zapasÃ³w wedÅ‚ug kategorii - rok',0),(522474,14514,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°ÐµÐ¼Ð¾ÑÑ‚ Ð½Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ - Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(522475,14514,'ur','Ø²Ù…Ø±Û: Ø³Ø§Ù„ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(522476,14514,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸ - Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(522477,14514,'vi','Sá»­ dá»¥ng hÃ ng tá»“n kho theo thá»ƒ loáº¡i - nÄƒm',0),(522478,14514,'af','Voorraad gebruik deur kategorie - jaar',0),(522479,14514,'ro','Stocuri de utilizare de categoria - an',0),(522480,14514,'et','Varude kasutamine kategooria - aasta',0),(522481,14514,'si','Zaloge navada po kategoriji - leto',0),(522482,14514,'ba','Penggunaan persediaan berdasarkan Kategori - tahun',0),(522483,14514,'nl','Inventaris gebruik per categorie - jaar',0),(522484,14514,'fi','Sivustovaraston kÃ¤yttÃ¶ Kategoria - vuoden',0),(522485,14514,'no','Lager bruk av kategori - Ã¥r',0),(522486,14514,'da','Lageret brug af kategori - Ã¥r',0),(522487,14514,'ko','ì¹´í…Œê³ ë¦¬-ë…„ ì¸ë²¤í† ë¦¬ ì‚¬ìš©',0),(522488,14514,'he','×”×©×™×ž×•×© ×”×ž×œ××™ ×œ×¤×™ ×§×˜×’×•×¨×™×” - ×©× ×”',0),(522489,14514,'el','Î§ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î±Î½Î¬ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± - Î­Ï„Î¿Ï‚',0),(522490,14514,'zh','æŒ‰ç±»åˆ«-å¹´åº“å­˜ä½¿ç”¨çŽ‡',0),(522491,14514,'sv','Inventering anvÃ¤ndning av kategori - Ã¥r',0),(522492,14514,'it','Utilizzo di inventario di categoria - anno',0),(522493,14514,'tl','',0),(522494,14514,'th','à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸— - à¸›à¸µ',0),(522495,14514,'hi','à¤¶à¥à¤°à¥‡à¤£à¥€ - à¤µà¤°à¥à¤· à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥‚à¤šà¥€ à¤‰à¤ªà¤¯à¥‹à¤—',0),(522496,14514,'ms','Penggunaan inventori mengikut kategori - tahun',0),(522497,14514,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø­Ø³Ø¨ Ø§Ù„ÙØ¦Ø©-Ø§Ù„Ø³Ù†Ø©',0),(522498,14514,'fr','Utilisation de l\'inventaire par catÃ©gorie - annÃ©e',0),(522499,14514,'jp','ã‚«ãƒ†ã‚´ãƒª - å¹´åˆ¥ã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®åˆ©ç”¨çŠ¶æ³',0),(522500,14514,'pt','Uso de estoque por categoria - ano',0),(522501,14514,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÐ¼ - Ð³Ð¾Ð´',0),(522502,14514,'es','Uso del inventario por categorÃ­a - aÃ±o',0),(522503,14514,'de','Inventar-Nutzung durch Kategorie - Jahr',0),(522504,14514,'en','Inventory Usage By Category - Year',0),(522505,14515,'is','',0),(522506,14515,'dr','Ø¯Ø±Ø¢Ù…Ø¯ &amp; Ù‡Ø²ÛŒÙ†Ù‡',0),(522507,14515,'pr','Ø¯Ø±Ø¢Ù…Ø¯ &amp; Ù‡Ø²ÛŒÙ†Ù‡',0),(522508,14515,'tr','Gelir & giderleri',0),(522509,14515,'pl','DochÃ³d & wydatki',0),(522510,14515,'bg','ÐŸÑ€Ð¸Ñ…Ð¾Ð´Ð¸ & Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(522511,14515,'ur','Ø¢Ù…Ø¯Ù†ÛŒ & Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(522512,14515,'sr','ÐŸÑ€Ð¸Ñ…Ð¾Ð´Ð¸ Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(522513,14515,'vi','Thu nháº­p &amp; chi phÃ­',0),(522514,14515,'af','Inkomste en uitgawes',0),(522515,14515,'ro','Venituri & cheltuielile',0),(522516,14515,'et','Tulud & kulud',0),(522517,14515,'si','Dohodek & stroÅ¡ki',0),(522518,14515,'ba','Pendapatan & pengeluaran',0),(522519,14515,'nl','Inkomsten & kosten',0),(522520,14515,'fi','Tuotot & kulut',0),(522521,14515,'no','Inntekt & utgifter',0),(522522,14515,'da','Indkomst & udgifter',0),(522523,14515,'ko','ì†Œë“ & ë¹„ìš©',0),(522524,14515,'he','×”×›× ×¡×•×ª & ×”×•×¦××•×ª',0),(522525,14515,'el','ÎˆÏƒÎ¿Î´Î± & Î­Î¾Î¿Î´Î±',0),(522526,14515,'zh','æ”¶å…¥ &amp; è´¹ç”¨',0),(522527,14515,'sv','IntÃ¤kter & kostnader',0),(522528,14515,'it','Spese & reddito',0),(522529,14515,'tl','',0),(522530,14515,'th','& à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸à¸³à¹„à¸£à¸‚à¸²à¸”à¸—à¸¸à¸™',0),(522531,14515,'hi','à¤†à¤¯ & à¤µà¥à¤¯à¤¯',0),(522532,14515,'ms','Pendapatan & perbelanjaan',0),(522533,14515,'ar','Ø§Ù„Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø¢Ù†Ø¯',0),(522534,14515,'fr','Recettes & dÃ©penses',0),(522535,14515,'jp','æ‰€å¾— & è²»ç”¨',0),(522536,14515,'pt','Receitas despesas &',0),(522537,14515,'ru','Ð”Ð¾Ñ…Ð¾Ð´Ñ‹ & Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(522538,14515,'es','Ingresos gastos &amp;',0),(522539,14515,'de','& Ertrag',0),(522540,14515,'en','Income & Expenses',0),(522541,14516,'is','',0),(522542,14516,'dr','Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ',0),(522543,14516,'pr','Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ',0),(522544,14516,'tr','Hesap oluÅŸturma',0),(522545,14516,'pl','RachunkowoÅ›ci',0),(522546,14516,'bg','Ð¡Ñ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(522547,14516,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹Ù†Ú¯',0),(522548,14516,'sr','Ð Ð°Ñ‡ÑƒÐ½Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(522549,14516,'vi','Káº¿ toÃ¡n',0),(522550,14516,'af','Rekeningkundige',0),(522551,14516,'ro','Contabilitate',0),(522552,14516,'et','Raamatupidamine',0),(522553,14516,'si','RaÄunovodstvo',0),(522554,14516,'ba','Akuntansi',0),(522555,14516,'nl','Boekhouding',0),(522556,14516,'fi','Kirjanpito',0),(522557,14516,'no','Regnskap',0),(522558,14516,'da','Regnskab',0),(522559,14516,'ko','íšŒê³„',0),(522560,14516,'he','×—×©×‘×•× ××•×ª',0),(522561,14516,'el','Î›Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ®',0),(522562,14516,'zh','ä¼šè®¡',0),(522563,14516,'sv','Redovisning',0),(522564,14516,'it','ContabilitÃ ',0),(522565,14516,'tl','',0),(522566,14516,'th','à¸šà¸±à¸à¸Šà¸µ',0),(522567,14516,'hi','à¤²à¥‡à¤–à¤¾à¤‚à¤•à¤¨',0),(522568,14516,'ms','Perakaunan',0),(522569,14516,'ar','Ø§Ù„Ù…Ø­Ø§Ø³Ø¨Ø©',0),(522570,14516,'fr','ComptabilitÃ©',0),(522571,14516,'jp','ä¼šè¨ˆ',0),(522572,14516,'pt','Contabilidade',0),(522573,14516,'ru','Ð‘ÑƒÑ…Ð³Ð°Ð»Ñ‚ÐµÑ€ÑÐºÐ¸Ð¹ ÑƒÑ‡ÐµÑ‚',0),(522574,14516,'es','Contabilidad',0),(522575,14516,'de','Buchhaltung',0),(522576,14516,'en','Accounting',0),(522577,14517,'is','',0),(522578,14517,'dr','ØªØ¹Ø¯Ø§Ø¯ ÙØ±ÙˆØ´ YTD',0),(522579,14517,'pr','ØªØ¹Ø¯Ø§Ø¯ ÙØ±ÙˆØ´ YTD',0),(522580,14517,'tr','SatÄ±ÅŸ YTD Mkt.',0),(522581,14517,'pl','IloÅ›Ä‡ sprzedaÅ¼y YTD',0),(522582,14517,'bg','ÐžÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¸',0),(522583,14517,'ur','ÛŒÙ¹Ø¯ Ø³ÛŒÙ„Ø² Ù‚ÛŒ',0),(522584,14517,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÐšÐ¾Ð».',0),(522585,14517,'vi','YTD bÃ¡n hÃ ng SL',0),(522586,14517,'af','YTD verkope Qty',0),(522587,14517,'ro','Cantit vanzari YTD',0),(522588,14517,'et','YTD mÃ¼Ã¼gi kogus',0),(522589,14517,'si','KoliÄina prodaje YTD',0),(522590,14517,'ba','YTD penjualan Qty',0),(522591,14517,'nl','YTD verkoop Qty',0),(522592,14517,'fi','Vuoden alusta myynnin mÃ¤Ã¤rÃ¤',0),(522593,14517,'no','YTD salg antall',0),(522594,14517,'da','YTD Sales Qty',0),(522595,14517,'ko','ëˆ„ê³„ íŒë§¤ ìˆ˜ëŸ‰',0),(522596,14517,'he','×›×ž×•×ª ×ž×›×™×¨×•×ª ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(522597,14517,'el','Qty Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ YTD',0),(522598,14517,'zh','YTD é”€å”®é‡',0),(522599,14517,'sv','YTD Sales Kvt',0),(522600,14517,'it','YTD Sales Qty',0),(522601,14517,'tl','',0),(522602,14517,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸‚à¸²à¸¢ YTD',0),(522603,14517,'hi','YTD à¤µà¤¿à¤•à¥à¤°à¤¯ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(522604,14517,'ms','Qty jualan THK',0),(522605,14517,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø¹Ø§Ù…',0),(522606,14517,'fr','YTD QtÃ© vente',0),(522607,14517,'jp','YTD å£²ä¸Šæ•°é‡',0),(522608,14517,'pt','Qtde de vendas acumulado no ano',0),(522609,14517,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(522610,14517,'es','YTD ventas Qty',0),(522611,14517,'de','YTD Vertrieb Qty',0),(522612,14517,'en','YTD Sales Qty',0),(522613,14518,'is','',0),(522614,14518,'dr','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø¨ÛŒØ§Ù†ÛŒÙ‡',0),(522615,14518,'pr','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø¨ÛŒØ§Ù†ÛŒÙ‡',0),(522616,14518,'tr','Deyim gerektirir',0),(522617,14518,'pl','WymagajÄ… instrukcja',0),(522618,14518,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ð´ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ',0),(522619,14518,'ur','Ø¨ÛŒØ§Ù† Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÙˆØªÛŒ ÛÛ’',0),(522620,14518,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°Ñ˜Ñƒ Ð¸Ð·Ñ˜Ð°Ð²Ñƒ',0),(522621,14518,'vi','YÃªu cáº§u bÃ¡o cÃ¡o',0),(522622,14518,'af','Verklaring vereis',0),(522623,14518,'ro','NecesitÄƒ declaraÅ£ie',0),(522624,14518,'et','NÃµuda avalduse',0),(522625,14518,'si','Zahtevajo izjavo',0),(522626,14518,'ba','Memerlukan pernyataan',0),(522627,14518,'nl','Verklaring is vereist',0),(522628,14518,'fi','Vaatia',0),(522629,14518,'no','Kreve erklÃ¦ring',0),(522630,14518,'da','KrÃ¦ve redegÃ¸relse',0),(522631,14518,'ko','ê³„ì‚° ì„œ í•„ìš”',0),(522632,14518,'he','×œ×“×¨×•×© ×”×¦×”×¨×”',0),(522633,14518,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½ Î´Î®Î»Ï‰ÏƒÎ·',0),(522634,14518,'zh','éœ€è¦å£°æ˜Ž',0),(522635,14518,'sv','KrÃ¤ver uttalande',0),(522636,14518,'it','Richiedono istruzione',0),(522637,14518,'tl','',0),(522638,14518,'th','à¸•à¹‰à¸­à¸‡à¹ƒà¸Šà¹‰à¸‡à¸š',0),(522639,14518,'hi','à¤¬à¤¯à¤¾à¤¨ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(522640,14518,'ms','Memerlukan penyata',0),(522641,14518,'ar','ØªØªØ·Ù„Ø¨ Ø¨ÙŠØ§Ù†',0),(522642,14518,'fr','Exiger la dÃ©claration',0),(522643,14518,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆãŒå¿…è¦ã§ã™ã€‚',0),(522644,14518,'pt','Exigir a declaraÃ§Ã£o',0),(522645,14518,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð¾Ð¿ÐµÑ€Ð°Ñ‚Ð¾Ñ€',0),(522646,14518,'es','Requieren declaraciÃ³n',0),(522647,14518,'de','Require-Anweisung',0),(522648,14518,'en','Require Statement',0),(522649,14519,'is','',0),(522650,14519,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§Ú©ØªÙˆØ±',0),(522651,14519,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§Ú©ØªÙˆØ±',0),(522652,14519,'tr','Fatura havale',0),(522653,14519,'pl','Przelewy dla faktury',0),(522654,14519,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð´ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(522655,14519,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ Ø²Ø±Ù…Ø¨Ø§Ø¯Ù„Û',0),(522656,14519,'sr','ÐŸÑ€Ð¸ÑÑ‚Ð¸Ð³Ð°Ð¾ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(522657,14519,'vi','Chuyá»ƒn tiá»n cho hÃ³a Ä‘Æ¡n',0),(522658,14519,'af','Remittance vir faktuur',0),(522659,14519,'ro','Remitere pentru facturÄƒ',0),(522660,14519,'et','RahaÃ¼lekande arve',0),(522661,14519,'si','Nakazilo za raÄun',0),(522662,14519,'ba','Remiten untuk faktur',0),(522663,14519,'nl','Remise voor factuur',0),(522664,14519,'fi','Laskun maksusuoritus',0),(522665,14519,'no','Remittering For faktura',0),(522666,14519,'da','Remittering til faktura',0),(522667,14519,'ko','ì†¡ìž¥ì— ëŒ€ í•œ ì†¡ê¸ˆ',0),(522668,14519,'he','×”×¢×‘×¨×” ×‘× ×§××™×ª ×¢×‘×•×¨ ×—×©×‘×•× ×™×ª',0),(522669,14519,'el','ÎˆÎ¼Î²Î±ÏƒÎ¼Î± Ï€ÏÎ¿Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(522670,14519,'zh','å‘ç¥¨æ±‡æ¬¾',0),(522671,14519,'sv','Remittering fÃ¶r faktura',0),(522672,14519,'it','Rimesse per fattura',0),(522673,14519,'tl','',0),(522674,14519,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸œà¹ˆà¸²à¸™à¸˜à¸™à¸²à¸„à¸²à¸£à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(522675,14519,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤§à¤¨ à¤ªà¥à¤°à¥‡à¤·à¤£',0),(522676,14519,'ms','Kiriman wang bagi invois',0),(522677,14519,'ar','Ø§Ù„ØªØ­ÙˆÙŠÙ„Ø§Øª Ø§Ù„Ù…Ø§Ù„ÙŠØ© Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(522678,14519,'fr','Remise pour une facture',0),(522679,14519,'jp','è«‹æ±‚æ›¸ã®é€é‡‘',0),(522680,14519,'pt','Remessa de fatura',0),(522681,14519,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð´ Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð°',0),(522682,14519,'es','Remesas para factura',0),(522683,14519,'de','Ãœberweisung fÃ¼r Rechnung',0),(522684,14519,'en','Remittance For Invoice',0),(522685,14520,'is','',0),(522686,14520,'dr','Ù…Ø·Ù„Ø¨ intercompany',0),(522687,14520,'pr','Ù…Ø·Ù„Ø¨ intercompany',0),(522688,14520,'tr','ÅžirketlerarasÄ± giriÅŸ',0),(522689,14520,'pl','Zapis miÄ™dzyfirmowej',0),(522690,14520,'bg','ÐœÐµÐ¶Ð´ÑƒÑ„Ð¸Ñ€Ð¼ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸Ñ',0),(522691,14520,'ur','Ø§Ù†Ù¹Ø±Ú©ÙˆÙ…Ù¾Ù†ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(522692,14520,'sr','ÐœÐµÑ’ÑƒÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜ÑÐºÐµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(522693,14520,'vi','Intercompany má»¥c',0),(522694,14520,'af','Intercompany inskrywing',0),(522695,14520,'ro','Intrare inter-companii',0),(522696,14520,'et','Kontsernisisene kanne',0),(522697,14520,'si','Znotraj podjetja vstop',0),(522698,14520,'ba','Antar entri',0),(522699,14520,'nl','IC-ingang',0),(522700,14520,'fi','Konsernin sisÃ¤inen tapahtuma',0),(522701,14520,'no','Konserninterne oppfÃ¸ring',0),(522702,14520,'da','Mellempostering',0),(522703,14520,'ko','íšŒì‚¬ ê°„ í•­ëª©',0),(522704,14520,'he','×¢×¨×š ×‘×™×Ÿ-×—×‘×¨×ª×™×•×ª',0),(522705,14520,'el','Î”Î¹ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ® ÎµÎ³Î³ÏÎ±Ï†Î®',0),(522706,14520,'zh','å†…éƒ¨å…¬å¸çš„æ¡ç›®',0),(522707,14520,'sv','Koncerninterna transaktionen',0),(522708,14520,'it','Voce interaziendale',0),(522709,14520,'tl','',0),(522710,14520,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸šà¸£à¸´à¸©à¸±à¸—',0),(522711,14520,'hi','Intercompany à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(522712,14520,'ms','Catatan urus',0),(522713,14520,'ar','Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø´Ù‚ÙŠÙ‚Ø©',0),(522714,14520,'fr','EntrÃ©e intersociÃ©tÃ©e',0),(522715,14520,'jp','ä¼šç¤¾é–“ã®ã‚¨ãƒ³ãƒˆãƒª',0),(522716,14520,'pt','Entrada de empresas coligada',0),(522717,14520,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ Ñ Ð°Ñ„Ñ„Ð¸Ð»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÐµÐ¹',0),(522718,14520,'es','Entrada de empresas vinculada',0),(522719,14520,'de','Intercompany-Eintrag',0),(522720,14520,'en','Intercompany Entry',0),(522721,14521,'is','',0),(522722,14521,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(522723,14521,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(522724,14521,'tr','Stok maliyeti gÃ¶rÃ¼ntÃ¼leyemiyorsunuz',0),(522725,14521,'pl','Nie moÅ¼na wyÅ›wietliÄ‡ koszty zapasÃ³w',0),(522726,14521,'bg','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ñ„Ð¸Ð·',0),(522727,14521,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ù†Ø¸Ø± Ù†ÛÛŒÚº Ø¢Ø¦Û’ Ú¯Ø§',0),(522728,14521,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð¶ÐµÐ¼ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(522729,14521,'vi','KhÃ´ng thá»ƒ xem hÃ ng tá»“n kho chi phÃ­',0),(522730,14521,'af','Koste van voorraad kan bekyk',0),(522731,14521,'ro','Nu pot vizualiza costurile de inventar',0),(522732,14521,'et','Ei saa vaadata lao kulud',0),(522733,14521,'si','StroÅ¡ki popisa ni mogoÄe ogledati',0),(522734,14521,'ba','Tidak dapat melihat biaya persediaan',0),(522735,14521,'nl','Voorraadkosten weergeven niet',0),(522736,14521,'fi','Voi tarkastella varastokustannukset',0),(522737,14521,'no','Kan ikke vise lagerkostnader',0),(522738,14521,'da','Kan ikke se lageromkostninger',0),(522739,14521,'ko','ìž¬ê³  ë¹„ìš©ì„ ë³¼ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(522740,14521,'he','××™×Ÿ ×‘××¤×©×¨×•×ª×š ×œ×”×¦×™×’ ×¢×œ×•×™×•×ª ×”×ž×œ××™',0),(522741,14521,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Ï€ÏÎ¿Î²Î¬Î»Ï‰ ÎºÏŒÏƒÏ„Î¿Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚.',0),(522742,14521,'zh','ä¸èƒ½æŸ¥çœ‹åº“å­˜æˆæœ¬',0),(522743,14521,'sv','Kan inte Visa lagerkostnader',0),(522744,14521,'it','Non Ã¨ possibile visualizzare i costi di inventario',0),(522745,14521,'tl','',0),(522746,14521,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸”à¸¹à¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(522747,14521,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¥€ à¤²à¤¾à¤—à¤¤ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(522748,14521,'ms','Tidak dapat melihat kos inventori',0),(522749,14521,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¹Ø±Ø¶ ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(522750,14521,'fr','Impossible d\'afficher les coÃ»ts de l\'inventaire',0),(522751,14521,'jp','åœ¨åº«ã‚³ã‚¹ãƒˆã‚’è¦‹ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(522752,14521,'pt','NÃ£o pode ver os custos de inventÃ¡rio',0),(522753,14521,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ ÑÐºÐ»Ð°Ð´ÑÐºÐ¸Ñ… Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(522754,14521,'es','No puede ver los costos de inventario',0),(522755,14521,'de','Lagerkosten kann nicht angezeigt werden.',0),(522756,14521,'en','Cannot View Inventory Costs',0),(522757,14522,'is','',0),(522758,14522,'dr','Ø­Ø°Ù Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(522759,14522,'pr','Ø­Ø°Ù Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(522760,14522,'tr','Silinen hesaplar hariÃ§',0),(522761,14522,'pl','Wyklucz konta usuniÄ™te',0),(522762,14522,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð¸ Ð˜Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸',0),(522763,14522,'ur','Ø­Ø°Ù Ø´Ø¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(522764,14522,'sr','Ð˜Ð·ÑƒÐ·Ð¼Ð¸ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(522765,14522,'vi','Loáº¡i trá»« Ä‘Ã£ xoÃ¡ tÃ i khoáº£n',0),(522766,14522,'af','Uitsluit geskrap rekeninge',0),(522767,14522,'ro','Exclude ÅŸters conturile',0),(522768,14522,'et','VÃ¤listada kustutatakse kontod',0),(522769,14522,'si','IzkljuÄi Izbrisani raÄuni',0),(522770,14522,'ba','Mengecualikan akun dihapus',0),(522771,14522,'nl','Verwijderde Accounts uitsluiten',0),(522772,14522,'fi','Poistaa Poistetut tilit',0),(522773,14522,'no','Utelate slettede kontoer',0),(522774,14522,'da','Udelukke slettede konti',0),(522775,14522,'ko','ì‚­ì œ ëœ ê³„ì • ì œì™¸',0),(522776,14522,'he','×œ× ×œ×›×œ×•×œ ×—×©×‘×•× ×•×ª × ×ž×—×§×•',0),(522777,14522,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¯ÏƒÎµÎ¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯',0),(522778,14522,'zh','æŽ’é™¤å·²åˆ é™¤çš„å¸æˆ·',0),(522779,14522,'sv','Uteslut bort konton',0),(522780,14522,'it','Escludere gli account cancellati',0),(522781,14522,'tl','',0),(522782,14522,'th','à¹„à¸¡à¹ˆà¸£à¸§à¸¡à¸šà¸±à¸à¸Šà¸µà¸—à¸µà¹ˆà¸–à¸¹à¸à¸¥à¸š',0),(522783,14522,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‹ à¤¬à¤¾à¤¹à¤°',0),(522784,14522,'ms','Tidak termasuk akaun dihapuskan',0),(522785,14522,'ar','Ø§Ø³ØªØ¨Ø¹Ø§Ø¯ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø­Ø°ÙˆÙØ©',0),(522786,14522,'fr','Exclure les comptes supprimÃ©s',0),(522787,14522,'jp','å‰Šé™¤ã—ãŸã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’é™¤å¤–ã—ã¾ã™ã€‚',0),(522788,14522,'pt','Excluir contas deletadas',0),(522789,14522,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð£Ð´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ñ‹',0),(522790,14522,'es','Excluir las cuentas borradas',0),(522791,14522,'de','GelÃ¶schte Konten ausschlieÃŸen',0),(522792,14522,'en','Exclude Deleted Accounts',0),(522793,14523,'is','',0),(522794,14523,'dr','Ø¬Ø³ØªØ¬ÙˆÛŒ Ù…Ú©Ø§Ù† Ø¢Ø´ØºØ§Ù„ Ø¯Ø± Ù‚ÙØ³Ù‡',0),(522795,14523,'pr','Ø¬Ø³ØªØ¬ÙˆÛŒ Ù…Ú©Ø§Ù† Ø¢Ø´ØºØ§Ù„ Ø¯Ø± Ù‚ÙØ³Ù‡',0),(522796,14523,'tr','Arama kutusu/raf konumu',0),(522797,14523,'pl','Szukaj w dla Bin/pÃ³Å‚ki lokalizacji',0),(522798,14523,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ð¡Ðš/ÑÑ‚ÐµÐ»Ð°Ð¶ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(522799,14523,'ur','Ø¨Ù†/Ø´ÛŒÙ„Ù Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Û’ Ù„Ø¦Û’ ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(522800,14523,'sr','ÐŸÐ¾Ñ‚Ñ€Ð°Ð¶Ð¸ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð‘Ð¸Ð½/Ð¿Ð¾Ð»Ð¸Ñ†Ð°',0),(522801,14523,'vi','TÃ¬m kiáº¿m vá»‹ trÃ­ Bin/ká»‡',0),(522802,14523,'af','Soek vir ligging asblik/rak',0),(522803,14523,'ro','De cÄƒutare pentru locaÅ£ia Bin/raft',0),(522804,14523,'et','Bin/riiul asukoha otsimine',0),(522805,14523,'si','Iskanje mesta regal/polica',0),(522806,14523,'ba','Pencarian lokasi Bin rak',0),(522807,14523,'nl','Bin/plank locatie zoeken',0),(522808,14523,'fi','Etsi Bin/hylly sijainti',0),(522809,14523,'no','SÃ¸k etter Bin/sokkel plassering',0),(522810,14523,'da','SÃ¸g efter Bin/hylde placering',0),(522811,14523,'ko','ë¹ˆ/ì„ ë°˜ ìœ„ì¹˜ì— ëŒ€ í•œ ê²€ìƒ‰',0),(522812,14523,'he','×—×™×¤×•×© ×¢×‘×•×¨ ×ž×™×§×•× ×¡×œ ××• ×ž×“×£',0),(522813,14523,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î³Î¹Î± Ï„Î·Î½ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Bin/ÏÎ¬Ï†Î¹',0),(522814,14523,'zh','Bin/è´§æž¶ä½ç½®æœç´¢',0),(522815,14523,'sv','SÃ¶ka efter Bin/hylla plats',0),(522816,14523,'it','Ricerca per posizione Bin/mensola',0),(522817,14523,'tl','',0),(522818,14523,'th','à¸«à¸²à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸Šà¹ˆà¸­à¸‡à¹€à¸à¹‡à¸š/à¸Šà¸±à¹‰à¸™',0),(522819,14523,'hi','à¤¬à¤¿à¤¨/à¤¶à¥‡à¤²à¥à¤« à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¥‹à¤œ',0),(522820,14523,'ms','Carian untuk lokasi Bin/rak',0),(522821,14523,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ù…ÙˆÙ‚Ø¹ Ø¨Ù†/Ø§Ù„Ø¬Ø±Ù',0),(522822,14523,'fr','Recherche d\'emplacement Bin/tablette',0),(522823,14523,'jp','ç®±/æ£šã®å ´æ‰€ã®æ¤œç´¢',0),(522824,14523,'pt','Pesquisa para localizaÃ§Ã£o de Bin/prateleira',0),(522825,14523,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Bin/Ð¿Ð¾Ð»ÐºÐ°',0),(522826,14523,'es','BÃºsqueda para la localizaciÃ³n de Bin/estante',0),(522827,14523,'de','Suche nach Bin/Regal',0),(522828,14523,'en','Search For Bin/Shelf Location',0),(522829,14524,'is','',0),(522830,14524,'dr','Ù…Ø­Ù„ Ø§Ù†Ø¨Ø§Ø±',0),(522831,14524,'pr','Ù…Ø­Ù„ Ø§Ù†Ø¨Ø§Ø±',0),(522832,14524,'tr','Ambar yeri',0),(522833,14524,'pl','Lokalizacji magazynowej',0),(522834,14524,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð½Ð° ÑÐºÐ»Ð°Ð´',0),(522835,14524,'ur','Ú¯ÙˆØ¯Ø§Ù… Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(522836,14524,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ð°',0),(522837,14524,'vi','Vá»‹ trÃ­ kho',0),(522838,14524,'af','Pakhuis ligging',0),(522839,14524,'ro','LocaÅ£ie depozit',0),(522840,14524,'et','Lao asukoha',0),(522841,14524,'si','SkladiÅ¡Äna lokacija',0),(522842,14524,'ba','Lokasi gudang',0),(522843,14524,'nl','Magazijn',0),(522844,14524,'fi','Varastosijainti',0),(522845,14524,'no','Lagerlokasjon',0),(522846,14524,'da','Lagerlokation',0),(522847,14524,'ko','ì°½ ê³  ìœ„ì¹˜',0),(522848,14524,'he','×ž×™×§×•× ×”×ž×—×¡×Ÿ',0),(522849,14524,'el','Î‘Ï€Î¿Î¸Î®ÎºÎ·',0),(522850,14524,'zh','ä»“åº“ä½ç½®',0),(522851,14524,'sv','LagerstÃ¤lle',0),(522852,14524,'it','Ubicazione magazzino',0),(522853,14524,'tl','',0),(522854,14524,'th','à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡à¸„à¸¥à¸±à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(522855,14524,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤¸à¥à¤¥à¤¾à¤¨',0),(522856,14524,'ms','Lokasi gudang',0),(522857,14524,'ar','Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹',0),(522858,14524,'fr','Emplacement de l\'entrepÃ´t',0),(522859,14524,'jp','å€‰åº«ã®å ´æ‰€',0),(522860,14524,'pt','LocalizaÃ§Ã£o do armazÃ©m',0),(522861,14524,'ru','Ð¡ÐºÐ»Ð°Ð´Ð°',0),(522862,14524,'es','UbicaciÃ³n del almacÃ©n',0),(522863,14524,'de','Lagerort',0),(522864,14524,'en','Warehouse Location',0),(522865,14525,'is','',0),(522866,14525,'dr','&amp; Ø®ÙˆØ¯Ú©Ø§Ø± Ø§ÛŒÙ…ÛŒÙ„',0),(522867,14525,'pr','&amp; Ø®ÙˆØ¯Ú©Ø§Ø± Ø§ÛŒÙ…ÛŒÙ„',0),(522868,14525,'tr','& Otomatik e-posta',0),(522869,14525,'pl','& Auto E-mail',0),(522870,14525,'bg','& Ð˜Ð¼ÐµÐ¹Ð» Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾',0),(522871,14525,'ur','& Ø®ÙˆØ¯Ú©Ø§Ø± Ø§ÛŒ Ù…ÛŒÙ„',0),(522872,14525,'sr','& ÐÑƒÑ‚Ð¾ Ð•Ð¼Ð°Ð¸Ð»',0),(522873,14525,'vi','&amp; Tá»± Ä‘á»™ng Email',0),(522874,14525,'af','& Outomatiese e-pos',0),(522875,14525,'ro','& Auto E-mail',0),(522876,14525,'et','& Automaatne e-posti',0),(522877,14525,'si','& Auto Email',0),(522878,14525,'ba','& Auto Email',0),(522879,14525,'nl','& Auto E-mail',0),(522880,14525,'fi','& Auto Email',0),(522881,14525,'no','& Automatisk e-post',0),(522882,14525,'da','& Auto E-mail',0),(522883,14525,'ko','& ìžë™ ì´ë©”ì¼',0),(522884,14525,'he','& ×“×•× ×œ ××•×˜×•×ž×˜×™',0),(522885,14525,'el','& Auto Email',0),(522886,14525,'zh','&amp; è‡ªåŠ¨ç”µå­é‚®ä»¶',0),(522887,14525,'sv','& Automatisk e-post',0),(522888,14525,'it','& Email automatico',0),(522889,14525,'tl','',0),(522890,14525,'th','& à¸­à¸µà¹€à¸¡à¸¥à¹Œà¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(522891,14525,'hi','& à¤‘à¤Ÿà¥‹ à¤ˆà¤®à¥‡à¤²',0),(522892,14525,'ms','& Auto Email',0),(522893,14525,'ar','Ø¢Ù†Ø¯ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(522894,14525,'fr','& Automatique par courriel',0),(522895,14525,'jp','& è‡ªå‹•ãƒ¡ãƒ¼ãƒ«',0),(522896,14525,'pt','& Auto E-mail',0),(522897,14525,'ru','& ÐÐ²Ñ‚Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(522898,14525,'es','&amp; Correo electrÃ³nico automÃ¡tico',0),(522899,14525,'de','& Automobil-Email',0),(522900,14525,'en','& Auto Email',0),(522901,14526,'is','',0),(522902,14526,'dr','Ø§ÛŒÙ…ÛŒÙ„ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(522903,14526,'pr','Ø§ÛŒÙ…ÛŒÙ„ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(522904,14526,'tr','Fatura e-posta',0),(522905,14526,'pl','E-mail gdy zafakturowane',0),(522906,14526,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð¿Ñ€Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(522907,14526,'ur','Ø¬Ø¨ Ø§Ù†ÙˆÙˆØ§Ø³ÛŒØ¯ Ø§ÛŒ Ù…ÛŒÙ„',0),(522908,14526,'sr','Ð• -Ð¿Ð¾ÑˆÑ‚Ðµ ÐºÐ°Ð´Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½',0),(522909,14526,'vi','ThÆ° Ä‘iá»‡n tá»­ khi láº­p hoÃ¡ Ä‘Æ¡n',0),(522910,14526,'af','E-pos wanneer Invoiced',0),(522911,14526,'ro','E-mail atunci cÃ¢nd facturate',0),(522912,14526,'et','E-maili kui arveldatud',0),(522913,14526,'si','Email kadar fakturirate',0),(522914,14526,'ba','Email ketika ditagih',0),(522915,14526,'nl','E-mail wanneer gefactureerd',0),(522916,14526,'fi','Laskutuksen sÃ¤hkÃ¶posti',0),(522917,14526,'no','E-post nÃ¥r fakturert',0),(522918,14526,'da','E-mail nÃ¥r faktureret',0),(522919,14526,'ko','ì´ë©”ì¼ ì²­êµ¬ í•˜ëŠ” ê²½ìš°',0),(522920,14526,'he','×“×•× ×œ ×›××©×¨ ×”×•×’×©×” ×—×©×‘×•× ×™×ª',0),(522921,14526,'el','Email ÏŒÏ„Î±Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î·Î¸ÎµÎ¯',0),(522922,14526,'zh','åœ¨å¼€ç¥¨æ—¶çš„ç”µå­é‚®ä»¶',0),(522923,14526,'sv','E-post nÃ¤r faktureras',0),(522924,14526,'it','Email quando fatturati',0),(522925,14526,'tl','',0),(522926,14526,'th','à¸­à¸µà¹€à¸¡à¸¥à¹Œà¹€à¸¡à¸·à¹ˆà¸­à¸­à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(522927,14526,'hi','à¤œà¤¬ à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤ˆà¤®à¥‡à¤²',0),(522928,14526,'ms','E-mel apabila invois',0),(522929,14526,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¹Ù†Ø¯ ÙÙˆØªØ±Ø©',0),(522930,14526,'fr','Courriel lorsque facturÃ©',0),(522931,14526,'jp','è«‹æ±‚æ™‚ã«ãƒ¡ãƒ¼ãƒ«',0),(522932,14526,'pt','E-mail quando facturado',0),(522933,14526,'ru','Ð­Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ, ÐºÐ¾Ð³Ð´Ð° Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚',0),(522934,14526,'es','Correo cuando facturada',0),(522935,14526,'de','E-Mail Rechnung',0),(522936,14526,'en','Email When Invoiced',0),(522937,14527,'is','',0),(522938,14527,'dr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø±ÙˆØ²',0),(522939,14527,'pr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø±ÙˆØ²',0),(522940,14527,'tr','Deyim gÃ¼n',0),(522941,14527,'pl','Instrukcja dzieÅ„',0),(522942,14527,'bg','Ð”ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ Ð´ÐµÐ½',0),(522943,14527,'ur','Ø¯Ù† Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(522944,14527,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð´Ð°Ð½Ð°',0),(522945,14527,'vi','TuyÃªn bá»‘ ngÃ y',0),(522946,14527,'af','Stelling dag',0),(522947,14527,'ro','DeclaraÅ£ia zilei',0),(522948,14527,'et','Aruanne pÃ¤eval',0),(522949,14527,'si','Izjava dneva',0),(522950,14527,'ba','Pernyataan hari',0),(522951,14527,'nl','Verklaring dag',0),(522952,14527,'fi','Lausunnon pÃ¤ivÃ¤',0),(522953,14527,'no','Setningen dag',0),(522954,14527,'da','ErklÃ¦ring dag',0),(522955,14527,'ko','ë¬¸ ì¼',0),(522956,14527,'he','×™×•× ×”×¦×”×¨×”',0),(522957,14527,'el','Î”Î®Î»Ï‰ÏƒÎ· Î·Î¼Î­ÏÎ±',0),(522958,14527,'zh','è¯­å¥çš„ä¸€å¤©',0),(522959,14527,'sv','Uttalande dag',0),(522960,14527,'it','Giorno di istruzione',0),(522961,14527,'tl','',0),(522962,14527,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸£à¸²à¸¢à¸‡à¸²à¸™',0),(522963,14527,'hi','à¤¬à¤¯à¤¾à¤¨ à¤¦à¤¿à¤¨',0),(522964,14527,'ms','Kenyataan hari',0),(522965,14527,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„ÙŠÙˆÙ…',0),(522966,14527,'fr','Jour de la dÃ©claration',0),(522967,14527,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã®æ—¥',0),(522968,14527,'pt','Dia da declaraÃ§Ã£o',0),(522969,14527,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð´Ð½Ñ',0),(522970,14527,'es','DÃ­a de declaraciÃ³n',0),(522971,14527,'de','Anweisung Tag',0),(522972,14527,'en','Statement Day',0),(522973,14528,'is','',0),(522974,14528,'dr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø§ÛŒ Ù…Ø§Ù‡',0),(522975,14528,'pr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø§ÛŒ Ù…Ø§Ù‡',0),(522976,14528,'tr','Deyim ay',0),(522977,14528,'pl','Instrukcja miesiÄ…ca',0),(522978,14528,'bg','Ð”ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ Ð¼ÐµÑÐµÑ†',0),(522979,14528,'ur','Ù…ÛÛŒÙ†Û’ Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(522980,14528,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð¼ÐµÑÐµÑ†Ð°',0),(522981,14528,'vi','TuyÃªn bá»‘ thÃ¡ng',0),(522982,14528,'af','Stelling maand',0),(522983,14528,'ro','DeclaraÅ£ia lunii',0),(522984,14528,'et','VÃ¤ljavÃµtte kuu',0),(522985,14528,'si','Izjava meseca',0),(522986,14528,'ba','Pernyataan bulan',0),(522987,14528,'nl','Verklaring van maand',0),(522988,14528,'fi','Ilmoitus kuukauden',0),(522989,14528,'no','Setningen mÃ¥ned',0),(522990,14528,'da','ErklÃ¦ring mÃ¥ned',0),(522991,14528,'ko','ë¬¸ ë‹¬',0),(522992,14528,'he','×ž×©×¤×˜ ×‘×—×•×“×©',0),(522993,14528,'el','Î”Î®Î»Ï‰ÏƒÎ· Ï„Î¿Ï… Î¼Î®Î½Î±',0),(522994,14528,'zh','å¸å•æœˆä»½',0),(522995,14528,'sv','Uttalande mÃ¥nad',0),(522996,14528,'it','Mese di istruzione',0),(522997,14528,'tl','',0),(522998,14528,'th','à¸‡à¸šà¹€à¸”à¸·à¸­à¸™',0),(522999,14528,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¯à¤¾à¤¨',0),(523000,14528,'ms','Penyata bulan',0),(523001,14528,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ø´Ù‡Ø±',0),(523002,14528,'fr','Mois de la dÃ©claration',0),(523003,14528,'jp','æ˜Žç´°æ›¸ã®æœˆ',0),(523004,14528,'pt','MÃªs de instruÃ§Ã£o',0),(523005,14528,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð¼ÐµÑÑÑ†',0),(523006,14528,'es','DeclaraciÃ³n mes',0),(523007,14528,'de','Anweisung Monat',0),(523008,14528,'en','Statement Month',0),(523009,14529,'is','',0),(523010,14529,'dr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø³Ø§Ù„',0),(523011,14529,'pr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø³Ø§Ù„',0),(523012,14529,'tr','Deyim yÄ±l',0),(523013,14529,'pl','Instrukcja roku',0),(523014,14529,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(523015,14529,'ur','Ø³Ø§Ù„ Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(523016,14529,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(523017,14529,'vi','TuyÃªn bá»‘ nÄƒm',0),(523018,14529,'af','Stelling jaar',0),(523019,14529,'ro','DeclaraÅ£ie an',0),(523020,14529,'et','Aruande aasta',0),(523021,14529,'si','Izjava leta',0),(523022,14529,'ba','Pernyataan tahun',0),(523023,14529,'nl','Verklaring van het jaar',0),(523024,14529,'fi','Ilmoitus vuoden',0),(523025,14529,'no','Setningen Ã¥r',0),(523026,14529,'da','ErklÃ¦ring Ã¥r',0),(523027,14529,'ko','ë¬¸ í•´',0),(523028,14529,'he','×©× ×” ××ª ×”×”×¦×”×¨×”',0),(523029,14529,'el','Î”Î®Î»Ï‰ÏƒÎ· Ï„Î¿Ï… Î­Ï„Î¿Ï…Ï‚',0),(523030,14529,'zh','å£°æ˜Žå¹´',0),(523031,14529,'sv','Uttalande Ã¥r',0),(523032,14529,'it','Dichiarazione anno',0),(523033,14529,'tl','',0),(523034,14529,'th','à¸›à¸µà¸‡à¸š',0),(523035,14529,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤¬à¤¯à¤¾à¤¨',0),(523036,14529,'ms','Tahun penyata',0),(523037,14529,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ø³Ù†Ø©',0),(523038,14529,'fr','AnnÃ©e de dÃ©claration',0),(523039,14529,'jp','æ–‡å¹´',0),(523040,14529,'pt','Ano de instruÃ§Ã£o',0),(523041,14529,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð³Ð¾Ð´',0),(523042,14529,'es','AÃ±o de declaraciÃ³n',0),(523043,14529,'de','Anweisung Jahr',0),(523044,14529,'en','Statement Year',0),(523045,14530,'is','',0),(523046,14530,'dr','Ù‡Ù…Ù‡ Ø±ÙˆØ´',0),(523047,14530,'pr','Ù‡Ù…Ù‡ Ø±ÙˆØ´',0),(523048,14530,'tr','TÃ¼m yÃ¶ntemleri',0),(523049,14530,'pl','Wszystkie metody',0),(523050,14530,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¼ÐµÑ‚Ð¾Ð´Ð¸',0),(523051,14530,'ur','ØªÙ…Ø§Ù… ØªØ± Ø·Ø±ÛŒÙ‚Û‚ Ú©Ø§Ø±',0),(523052,14530,'sr','Ð¡Ð²Ðµ Ð¼ÐµÑ‚Ð¾Ð´Ðµ',0),(523053,14530,'vi','Táº¥t cáº£ cÃ¡c phÆ°Æ¡ng phÃ¡p',0),(523054,14530,'af','Alle metodes',0),(523055,14530,'ro','Toate metodele',0),(523056,14530,'et','KÃµik meetodid',0),(523057,14530,'si','Vse metode',0),(523058,14530,'ba','Semua metode',0),(523059,14530,'nl','Alle methoden',0),(523060,14530,'fi','Kaikki menetelmÃ¤t',0),(523061,14530,'no','Alle metoder',0),(523062,14530,'da','Alle metoder',0),(523063,14530,'ko','ëª¨ë“  ë©”ì„œë“œ',0),(523064,14530,'he','×›×œ ×”×©×™×˜×•×ª',0),(523065,14530,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ Î¼Î­Î¸Î¿Î´Î¿Î¹',0),(523066,14530,'zh','æ‰€æœ‰æ–¹æ³•',0),(523067,14530,'sv','Alla metoder',0),(523068,14530,'it','Tutti i metodi',0),(523069,14530,'tl','',0),(523070,14530,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(523071,14530,'hi','à¤¸à¤­à¥€ à¤µà¤¿à¤§à¤¿à¤¯à¤¾à¤',0),(523072,14530,'ms','Semua kaedah',0),(523073,14530,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø£Ø³Ø§Ù„ÙŠØ¨',0),(523074,14530,'fr','Toutes les mÃ©thodes',0),(523075,14530,'jp','ã™ã¹ã¦ã®ãƒ¡ã‚½ãƒƒãƒ‰',0),(523076,14530,'pt','Todos os mÃ©todos',0),(523077,14530,'ru','Ð’ÑÐµ Ð¼ÐµÑ‚Ð¾Ð´Ñ‹',0),(523078,14530,'es','Todos los mÃ©todos',0),(523079,14530,'de','Alle Methoden',0),(523080,14530,'en','All Methods',0),(523081,14531,'is','',0),(523082,14531,'dr','Ø±ÙˆØ´ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø¬Ø§Ø²',0),(523083,14531,'pr','Ø±ÙˆØ´ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø¬Ø§Ø²',0),(523084,14531,'tr','Ä°zin verilen Ã¶deme yÃ¶ntemleri',0),(523085,14531,'pl','Metody pÅ‚atnoÅ›ci dozwolone',0),(523086,14531,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸ Ð¼ÐµÑ‚Ð¾Ð´Ð¸ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(523087,14531,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚ÙˆÚº Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ',0),(523088,14531,'sr','ÐÐ°Ñ‡Ð¸Ð½Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(523089,14531,'vi','PhÆ°Æ¡ng thá»©c thanh toÃ¡n Ä‘Æ°á»£c phÃ©p',0),(523090,14531,'af','Betaalmetodes toegelaat',0),(523091,14531,'ro','Metode de platÄƒ a permis',0),(523092,14531,'et','Lubatud makseviisid',0),(523093,14531,'si','Dovoljeni naÄini plaÄila',0),(523094,14531,'ba','Metode pembayaran yang diperbolehkan',0),(523095,14531,'nl','Betalingsmethoden toegestaan',0),(523096,14531,'fi','Internet maksutapoja',0),(523097,14531,'no','Betalingsmetoder tillatt',0),(523098,14531,'da','Betalingsmetoder tilladt',0),(523099,14531,'ko','ì§€ë¶ˆ ë°©ë²• í—ˆìš©',0),(523100,14531,'he','×©×™×˜×•×ª ×ª×©×œ×•× ×ž×•×ª×¨',0),(523101,14531,'el','ÎœÎµÎ¸ÏŒÎ´Î¿Ï…Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(523102,14531,'zh','å…è®¸çš„ä»˜æ¬¾æ–¹å¼',0),(523103,14531,'sv','Betalningsmetoder som tillÃ¥tet',0),(523104,14531,'it','Metodi di pagamento consentiti',0),(523105,14531,'tl','',0),(523106,14531,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸­à¸™à¸¸à¸à¸²à¸•',0),(523107,14531,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤¤à¤°à¥€à¤•à¥‡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥€',0),(523108,14531,'ms','Kaedah pembayaran yang dibenarkan',0),(523109,14531,'ar','Ø£Ø³Ø§Ù„ÙŠØ¨ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡Ø§',0),(523110,14531,'fr','MÃ©thodes de paiement autorisÃ©es',0),(523111,14531,'jp','ãŠæ”¯æ‰•ã„æ–¹æ³•ã‚’è¨±å¯',0),(523112,14531,'pt','MÃ©todos de pagamento permitidos',0),(523113,14531,'ru','Ð¡Ð¿Ð¾ÑÐ¾Ð±Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(523114,14531,'es','MÃ©todos de pago permitidos',0),(523115,14531,'de','Zahlungsarten erlaubt',0),(523116,14531,'en','Payment Methods Allowed',0),(523117,14532,'is','',0),(523118,14532,'dr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(523119,14532,'pr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(523120,14532,'tr','Not baÅŸarÄ±yla kaydedildi',0),(523121,14532,'pl','Uwaga zapisane',0),(523122,14532,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(523123,14532,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ù†ÙˆÙ¹',0),(523124,14532,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(523125,14532,'vi','LÆ°u Ã½ lÆ°u thÃ nh cÃ´ng',0),(523126,14532,'af','Let wel suksesvol gestoor',0),(523127,14532,'ro','NotÄƒ salvat cu succes',0),(523128,14532,'et','MÃ¤rkus edukalt salvestatud',0),(523129,14532,'si','Opomba uspeÅ¡no shranjen',0),(523130,14532,'ba','Catatan yang disimpan berhasil',0),(523131,14532,'nl','Opmerking succesvol opgeslagen',0),(523132,14532,'fi','Huomautus tallennettu',0),(523133,14532,'no','Merk lagret',0),(523134,14532,'da','BemÃ¦rk gemt med succes',0),(523135,14532,'ko','ì°¸ê³  ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(523136,14532,'he','×”×¢×¨×” ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(523137,14532,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ· Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(523138,14532,'zh','å·²æˆåŠŸä¿å­˜çš„æ³¨é‡Š',0),(523139,14532,'sv','Obs sparats',0),(523140,14532,'it','Nota salvato correttamente',0),(523141,14532,'tl','',0),(523142,14532,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(523143,14532,'hi','à¤¨à¥‹à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(523144,14532,'ms','Nota yang berjaya disimpan',0),(523145,14532,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø­ÙØ¸ Ø¨Ù†Ø¬Ø§Ø­',0),(523146,14532,'fr','Note enregistrÃ© avec succÃ¨s',0),(523147,14532,'jp','ãƒ¡ãƒ¢æ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(523148,14532,'pt','Nota salva com sucesso',0),(523149,14532,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(523150,14532,'es','Nota guardado correctamente',0),(523151,14532,'de','Hinweis wurde erfolgreich gespeichert',0),(523152,14532,'en','Note Saved Successfully',0),(523153,14533,'is','',0),(523154,14533,'dr','Ø®Ø±ÙŠØ¯ Ø®Ø· Ù…ÙˆØ±Ø¯ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª',0),(523155,14533,'pr','Ø®Ø±ÙŠØ¯ Ø®Ø· Ù…ÙˆØ±Ø¯ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª',0),(523156,14533,'tr','SipariÅŸ satÄ±r Ã¶ÄŸesi notlarÄ±',0),(523157,14533,'pl','KolejnoÅ›Ä‡ pozycji Notes',0),(523158,14533,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(523159,14533,'ur','Ø­Ú©Ù… Ù„Ø§Ø¦Ù† Ø´Û’ Ù†ÙˆÙ¹',0),(523160,14533,'sr','Ð ÐµÐ´Ð¾ÑÐ»ÐµÐ´ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(523161,14533,'vi','Thá»© tá»± chi tiáº¿t Ä‘Æ¡n hÃ ng ghi chÃº',0),(523162,14533,'af','Orde lynitem notas',0),(523163,14533,'ro','Note de element rÃ¢nd ordine',0),(523164,14533,'et','Tellimuse reaÃ¼ksuste mÃ¤rkmed',0),(523165,14533,'si','Naloga postavko opombe',0),(523166,14533,'ba','Catatan Item baris pesanan',0),(523167,14533,'nl','Volgorde regelitem notities',0),(523168,14533,'fi','Tilauksen rivinimikkeen toteaa',0),(523169,14533,'no','For linjeelementet notater',0),(523170,14533,'da','Bestil linjeelement noter',0),(523171,14533,'ko','ì£¼ë¬¸ ë¼ì¸ í•­ëª© ì°¸ê³ ',0),(523172,14533,'he','×”×¢×¨×•×ª ×¤×¨×™×˜ ×©×•×¨×”',0),(523173,14533,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(523174,14533,'zh','è®¢å•è¡Œé¡¹ç›®å¤‡æ³¨',0),(523175,14533,'sv','Ordning radartikel anteckningar',0),(523176,14533,'it','Ordine linea voce note',0),(523177,14533,'tl','',0),(523178,14533,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(523179,14533,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤¨à¥‹à¤Ÿà¥à¤¸',0),(523180,14533,'ms','Nota barang baris perintah',0),(523181,14533,'ar','ØªØ±ØªÙŠØ¨ Ø¨Ù†Ø¯ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(523182,14533,'fr','Ordre rubrique Notes',0),(523183,14533,'jp','ã‚ªãƒ¼ãƒ€ãƒ¼ ãƒ©ã‚¤ãƒ³é …ç›®ã®ãƒ¡ãƒ¢',0),(523184,14533,'pt','Notas de Item de linha de ordem',0),(523185,14533,'ru','ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ð·Ð°ÐºÐ°Ð·Ð°',0),(523186,14533,'es','Notas de artÃ­culo de lÃ­nea de orden',0),(523187,14533,'de','Bestellung Einzelposten Notes',0),(523188,14533,'en','Order Line Item Notes',0),(523189,14534,'is','',0),(523190,14534,'dr','Ù„Ø·ÙØ§ ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯',0),(523191,14534,'pr','Ù„Ø·ÙØ§ ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯',0),(523192,14534,'tr','LÃ¼tfen bir not girin',0),(523193,14534,'pl','Wpisz notatkÃª',0),(523194,14534,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(523195,14534,'ur','Ù†ÙˆÙ¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(523196,14534,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑƒÐºÑƒ',0),(523197,14534,'vi','Vui lÃ²ng nháº­p má»™t lÆ°u Ã½',0),(523198,14534,'af','Tik asseblief \'n nota',0),(523199,14534,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i o notÄƒ',0),(523200,14534,'et','Sisestage mÃ¤rkme',0),(523201,14534,'si','Vnesite opombo',0),(523202,14534,'ba','Masukkan catatan',0),(523203,14534,'nl','Voer een opmerking',0),(523204,14534,'fi','Kirjoita muistiinpanon',0),(523205,14534,'no','Skriv inn et notat',0),(523206,14534,'da','Angiv en Note',0),(523207,14534,'ko','ë©”ëª¨ë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(523208,14534,'he','×”×–×™× ×• ×‘×‘×§×©×” ××ª ×¤×ª×§',0),(523209,14534,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼Î¹Î± ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(523210,14534,'zh','è¯·è¾“å…¥æ³¨é‡Š',0),(523211,14534,'sv','Ange en anteckning',0),(523212,14534,'it','Si prega di inserire una nota',0),(523213,14534,'tl','',0),(523214,14534,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸',0),(523215,14534,'hi','à¤à¤• à¤¨à¥‹à¤Ÿ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(523216,14534,'ms','Sila masukkan nota',0),(523217,14534,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ù…Ù„Ø§Ø­Ø¸Ø©',0),(523218,14534,'fr','Veuillez saisir une Note',0),(523219,14534,'jp','ãƒ¡ãƒ¢ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(523220,14534,'pt','Por favor, introduza uma nota',0),(523221,14534,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(523222,14534,'es','Por favor, ingrese una nota',0),(523223,14534,'de','Bitte geben Sie eine Anmerkung',0),(523224,14534,'en','Please Enter A Note',0),(523225,14535,'is','',0),(523226,14535,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ø¹Ù†ÙˆØ§Ù† Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(523227,14535,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ø¹Ù†ÙˆØ§Ù† Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(523228,14535,'tr','LÃ¼tfen bir baÅŸlÄ±k girin',0),(523229,14535,'pl','Podaj tytuÅ‚',0),(523230,14535,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð·Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ',0),(523231,14535,'ur','Ø§ÛŒÚ© Ø¹Ù†ÙˆØ§Ù† Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(523232,14535,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð°ÑÐ»Ð¾Ð²',0),(523233,14535,'vi','Vui lÃ²ng nháº­p má»™t tiÃªu Ä‘á»',0),(523234,14535,'af','Tik asseblief \'n titel',0),(523235,14535,'ro','Va rugam introduceti un titlu',0),(523236,14535,'et','Sisestage tiitel',0),(523237,14535,'si','Vnesite naslov',0),(523238,14535,'ba','Please Enter A Title',0),(523239,14535,'nl','Voer een titel in',0),(523240,14535,'fi','Kirjoita otsikko',0),(523241,14535,'no','Angi en tittel',0),(523242,14535,'da','Angiv en titel',0),(523243,14535,'ko','ì œëª©ì„ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(523244,14535,'he','×× × ×”×–×Ÿ ×›×•×ª×¨×ª',0),(523245,14535,'el','Î Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÏ„Îµ Î­Î½Î±Î½ Ï„Î¯Ï„Î»Î¿',0),(523246,14535,'zh','è¯·è¾“å…¥æ ‡é¢˜',0),(523247,14535,'sv','Skriv in en titel',0),(523248,14535,'it','Inserisci un titolo',0),(523249,14535,'tl','',0),(523250,14535,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸Šà¸·à¹ˆà¸­à¹€à¸£à¸·à¹ˆà¸­à¸‡',0),(523251,14535,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¶à¥€à¤°à¥à¤·à¤• à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(523252,14535,'ms','Sila masukkan tajuk',0),(523253,14535,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø¹Ù†ÙˆØ§Ù†',0),(523254,14535,'fr','S\'il vous plaÃ®t entrez un titre',0),(523255,14535,'jp','ã‚¿ã‚¤ãƒˆãƒ«ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(523256,14535,'pt','Por favor, digite um tÃ­tulo',0),(523257,14535,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ',0),(523258,14535,'es','Introduce un tÃ­tulo',0),(523259,14535,'de','Bitte geben Sie einen Titel',0),(523260,14535,'en','Please Enter A Title',0),(523261,14536,'is','',0),(523262,14536,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯',0),(523263,14536,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯',0),(523264,14536,'tr','VarsayÄ±lan not seÃ§in',0),(523265,14536,'pl','Uwaga wybierz domyÅ›lny',0),(523266,14536,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(523267,14536,'ur','Ø·Û’ Ø´Ø¯Û Ù†ÙˆÙ¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(523268,14536,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(523269,14536,'vi','Chá»n máº·c Ä‘á»‹nh lÆ°u Ã½',0),(523270,14536,'af','Kies verstek Nota',0),(523271,14536,'ro','SelectaÅ£i implicit NotÄƒ',0),(523272,14536,'et','Valige vaikimisi',0),(523273,14536,'si','Izberite privzeta Opomba',0),(523274,14536,'ba','Pilih Default catatan',0),(523275,14536,'nl','Selecteer standaard notitie',0),(523276,14536,'fi','Valitse oletusarvoinen Huomautus',0),(523277,14536,'no','Velg standardmerknad',0),(523278,14536,'da','VÃ¦lg standard BemÃ¦rk',0),(523279,14536,'ko','ê¸°ë³¸ ìŒí‘œ ì„ íƒ',0),(523280,14536,'he','×”×¢×¨×” ×‘×—×™×¨×ª ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(523281,14536,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î·Î½ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(523282,14536,'zh','é€‰æ‹©é»˜è®¤æ³¨é‡Š',0),(523283,14536,'sv','VÃ¤lj standard Obs',0),(523284,14536,'it','Selezionare predefinito nota',0),(523285,14536,'tl','',0),(523286,14536,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(523287,14536,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤§à¥à¤¯à¤¾à¤¨ à¤¦à¥‡à¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(523288,14536,'ms','Pilih Nota lalai',0),(523289,14536,'ar','Ø­Ø¯Ø¯ Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(523290,14536,'fr','Remarque sÃ©lectionnez par dÃ©faut',0),(523291,14536,'jp','æ—¢å®šã®æ³¨è¨˜ã‚’é¸æŠžã—ã¾ã™',0),(523292,14536,'pt','Selecione padrÃ£o nota',0),(523293,14536,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(523294,14536,'es','Seleccione predeterminada Nota',0),(523295,14536,'de','WÃ¤hlen Sie Standard-Notiz',0),(523296,14536,'en','Select Default Note',0),(523297,14537,'is','',0),(523298,14537,'dr','Ù…ÛŒØ²Ø§Ù† Ù…ØªÙˆØ³Ø·',0),(523299,14537,'pr','Ù…ÛŒØ²Ø§Ù† Ù…ØªÙˆØ³Ø·',0),(523300,14537,'tr','Ortalama hÄ±zÄ±',0),(523301,14537,'pl','Åšrednia stopa',0),(523302,14537,'bg','Ð¡Ñ€ÐµÐ´ÐµÐ½ ÐºÑƒÑ€Ñ',0),(523303,14537,'ur','Ø§ÙˆØ³Ø· Ø´Ø±Ø­',0),(523304,14537,'sr','ÐŸÑ€Ð¾ÑÐµÑ‡Ð½Ð° ÑÑ‚Ð¾Ð¿Ð°',0),(523305,14537,'vi','Trung bÃ¬nh tá»· lá»‡',0),(523306,14537,'af','Gemiddelde koers',0),(523307,14537,'ro','Rata medie',0),(523308,14537,'et','Keskmine kurss',0),(523309,14537,'si','PovpreÄna stopnja',0),(523310,14537,'ba','Tingkat rata-rata',0),(523311,14537,'nl','Gemiddelde koers',0),(523312,14537,'fi','Keskikurssi',0),(523313,14537,'no','Gjennomsnittlig',0),(523314,14537,'da','Gennemsnitskurs',0),(523315,14537,'ko','í‰ê·  ì†ë„',0),(523316,14537,'he','×§×¦×‘ ×ž×ž×•×¦×¢',0),(523317,14537,'el','ÎœÎ­ÏƒÎ¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(523318,14537,'zh','å¹³å‡é€ŸçŽ‡',0),(523319,14537,'sv','Genomsnittliga',0),(523320,14537,'it','Tasso medio',0),(523321,14537,'tl','',0),(523322,14537,'th','à¸­à¸±à¸•à¸£à¸²à¹€à¸‰à¸¥à¸µà¹ˆà¸¢',0),(523323,14537,'hi','à¤”à¤¸à¤¤ à¤¦à¤°',0),(523324,14537,'ms','Kadar purata',0),(523325,14537,'ar','Ù…Ø¹Ø¯Ù„ Ù…ØªÙˆØ³Ø·',0),(523326,14537,'fr','Taux moyen',0),(523327,14537,'jp','å¹³å‡ãƒ¬ãƒ¼ãƒˆ',0),(523328,14537,'pt','Taxa mÃ©dia',0),(523329,14537,'ru','Ð¡Ñ€ÐµÐ´Ð½Ð¸Ð¹ ÐºÑƒÑ€Ñ',0),(523330,14537,'es','Tasa promedio',0),(523331,14537,'de','Durchschnittskurs',0),(523332,14537,'en','Average Rate',0),(523333,14538,'is','',0),(523334,14538,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‡ØªÙ„',0),(523335,14538,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‡ØªÙ„',0),(523336,14538,'tr','Hotel kullanÄ±mÄ±',0),(523337,14538,'pl','UÅ¼ycie Hotel',0),(523338,14538,'bg','Ð¥Ð¾Ñ‚ÐµÐ» Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ',0),(523339,14538,'ur','ÛÙˆÙ¹Ù„ Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(523340,14538,'sr','Ð¥Ð¾Ñ‚ÐµÐ» ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ðµ',0),(523341,14538,'vi','Sá»­ dá»¥ng khÃ¡ch sáº¡n',0),(523342,14538,'af','Hotel gebruik',0),(523343,14538,'ro','Hotel de utilizare',0),(523344,14538,'et','Hotell kasutus',0),(523345,14538,'si','Hotel navada',0),(523346,14538,'ba','Hotel penggunaan',0),(523347,14538,'nl','Hotel gebruik',0),(523348,14538,'fi','Hotel kÃ¤yttÃ¶',0),(523349,14538,'no','Hotel bruk',0),(523350,14538,'da','Hotel skik',0),(523351,14538,'ko','í˜¸í…” ì‚¬ìš©',0),(523352,14538,'he','×”×©×™×ž×•×© hotel',0),(523353,14538,'el','ÎžÎµÎ½Î¿Î´Î¿Ï‡ÎµÎ¯Î¿ Ï‡ÏÎ®ÏƒÎ·',0),(523354,14538,'zh','é…’åº—ä½¿ç”¨',0),(523355,14538,'sv','Hotel anvÃ¤ndning',0),(523356,14538,'it','Utilizzo di Hotel',0),(523357,14538,'tl','',0),(523358,14538,'th','à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¹à¸£à¸¡',0),(523359,14538,'hi','à¤¹à¥‹à¤Ÿà¤² à¤•à¥‡ à¤‰à¤ªà¤¯à¥‹à¤—',0),(523360,14538,'ms','Penggunaan Hotel',0),(523361,14538,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„ÙÙ†Ø¯Ù‚',0),(523362,14538,'fr','Utilisation de l\'hÃ´tel',0),(523363,14538,'jp','ãƒ›ãƒ†ãƒ«ã®åˆ©ç”¨çŠ¶æ³',0),(523364,14538,'pt','Uso de Hotel',0),(523365,14538,'ru','ÐžÑ‚ÐµÐ»ÑŒ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(523366,14538,'es','Hotel uso',0),(523367,14538,'de','Hotel-Auslastung',0),(523368,14538,'en','Hotel Usage',0),(523369,14539,'is','',0),(523370,14539,'dr','Ø¢Ù…Ø§Ø± Ú©Ø§Ø±Ø¨Ø±Ø¯ Ù‡ØªÙ„',0),(523371,14539,'pr','Ø¢Ù…Ø§Ø± Ú©Ø§Ø±Ø¨Ø±Ø¯ Ù‡ØªÙ„',0),(523372,14539,'tr','Hotel kullanÄ±m istatistikleri',0),(523373,14539,'pl','Hotel statystykÄ™',0),(523374,14539,'bg','Ð¥Ð¾Ñ‚ÐµÐ» Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°ÐµÐ¼Ð¾ÑÑ‚ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(523375,14539,'ur','ÛÙˆÙ¹Ù„ Ú©Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±',0),(523376,14539,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐµ ÐºÐ¾Ñ€Ð¸ÑˆÑ›ÐµÑšÐ° Ñ…Ð¾Ñ‚ÐµÐ»',0),(523377,14539,'vi','Thá»‘ng kÃª sá»­ dá»¥ng khÃ¡ch sáº¡n',0),(523378,14539,'af','Hotel gebruikstatistiek',0),(523379,14539,'ro','Statisticile de utilizare Hotel',0),(523380,14539,'et','Hotell kasutamise statistika',0),(523381,14539,'si','Statistike uporabe Hotel',0),(523382,14539,'ba','Statistik penggunaan Hotel',0),(523383,14539,'nl','Hotel gebruiksstatistieken',0),(523384,14539,'fi','Hotel kÃ¤yttÃ¶tilastoja',0),(523385,14539,'no','Hotel bruksstatistikk',0),(523386,14539,'da','Hotel brugsstatistikker',0),(523387,14539,'ko','í˜¸í…” ì‚¬ìš© í†µê³„',0),(523388,14539,'he','×ž×œ×•×Ÿ ×¡×˜×˜×™×¡×˜×™×§×•×ª',0),(523389,14539,'el','Î£Ï„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï‡ÏÎ®ÏƒÎ·Ï‚ Hotel',0),(523390,14539,'zh','é…’åº—ä½¿ç”¨æƒ…å†µç»Ÿè®¡ä¿¡æ¯',0),(523391,14539,'sv','Hotel anvÃ¤ndningsstatistik',0),(523392,14539,'it','Statistiche di utilizzo Hotel',0),(523393,14539,'tl','',0),(523394,14539,'th','à¸ªà¸–à¸´à¸•à¸´à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¹à¸£à¸¡',0),(523395,14539,'hi','à¤¹à¥‹à¤Ÿà¤² à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¥‡ à¤†à¤à¤•à¤¡à¤¼à¥‡',0),(523396,14539,'ms','Statistik penggunaan Hotel',0),(523397,14539,'ar','Ø¥Ø­ØµØ§Ø¡Ø§Øª Ø¨Ø´Ø£Ù† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„ÙÙ†Ø¯Ù‚',0),(523398,14539,'fr','Statistiques d\'utilisation de l\'hÃ´tel',0),(523399,14539,'jp','ãƒ›ãƒ†ãƒ«ã®åˆ©ç”¨çŠ¶æ³ã®çµ±è¨ˆæƒ…å ±',0),(523400,14539,'pt','EstatÃ­sticas de uso do Hotel',0),(523401,14539,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ° Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¾Ñ‚ÐµÐ»ÑŒ',0),(523402,14539,'es','EstadÃ­sticas de uso de Hotel',0),(523403,14539,'de','Hotel Nutzungsstatistiken',0),(523404,14539,'en','Hotel Usage Statistics',0),(523405,14540,'is','',0),(523406,14540,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‡ØªÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(523407,14540,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‡ØªÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(523408,14540,'tr','Hotel kullanÄ±m baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(523409,14540,'pl','Hotel zwyczaj pomyÅ›lnie zaktualizowana',0),(523410,14540,'bg','Ð¥Ð¾Ñ‚ÐµÐ» Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(523411,14540,'ur','ÛÙˆÙ¹Ù„ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(523412,14540,'sr','Ð¥Ð¾Ñ‚ÐµÐ» ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(523413,14540,'vi','KhÃ¡ch sáº¡n cÃ¡ch sá»­ dá»¥ng Cáº­p Nháº­t thÃ nh cÃ´ng',0),(523414,14540,'af','Hotel mediagebruiksregte suksesvol bygewerk',0),(523415,14540,'ro','Hotel de utilizare actualizat cu succes',0),(523416,14540,'et','Hotell kasutus vÃ¤rskendatud',0),(523417,14540,'si','Hotel navada uspeÅ¡no posodobljena',0),(523418,14540,'ba','Hotel penggunaan berhasil',0),(523419,14540,'nl','Hotel gebruik bijgewerkt',0),(523420,14540,'fi','Hotel kÃ¤yttÃ¶ pÃ¤ivitetty',0),(523421,14540,'no','Hotel bruk oppdatert',0),(523422,14540,'da','Hotel skik opdateret',0),(523423,14540,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” í˜¸í…” ì‚¬ìš©',0),(523424,14540,'he','×ž×œ×•×Ÿ ×”×©×™×ž×•×© ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(523425,14540,'el','ÎžÎµÎ½Î¿Î´Î¿Ï‡ÎµÎ¯Î¿ Ï‡ÏÎ®ÏƒÎ· ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(523426,14540,'zh','é…’åº—ä½¿ç”¨å·²æˆåŠŸæ›´æ–°',0),(523427,14540,'sv','Hotel anvÃ¤ndning uppdaterats',0),(523428,14540,'it','Hotel utilizzo aggiornato con successo',0),(523429,14540,'tl','',0),(523430,14540,'th','à¸à¸²à¸£à¹ƒà¸Šà¹‰à¹‚à¸£à¸‡à¹à¸£à¸¡à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(523431,14540,'hi','à¤¹à¥‹à¤Ÿà¤² à¤•à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤‰à¤ªà¤¯à¥‹à¤—',0),(523432,14540,'ms','Penggunaan Hotel berjaya dikemas kini',0),(523433,14540,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„ÙÙ†Ø¯Ù‚ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(523434,14540,'fr','HÃ´tel utilisation correctement mis Ã  jour',0),(523435,14540,'jp','ãƒ›ãƒ†ãƒ«ã®åˆ©ç”¨çŠ¶æ³ãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸ',0),(523436,14540,'pt','Hotel uso atualizado com sucesso',0),(523437,14540,'ru','ÐžÑ‚ÐµÐ»ÑŒ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(523438,14540,'es','Hotel uso actualizado correctamente',0),(523439,14540,'de','Hotel-Auslastung, die erfolgreich aktualisiert',0),(523440,14540,'en','Hotel Usage Updated Successfully',0),(523441,14541,'is','',0),(523442,14541,'dr','Ø§Ø´ØºØ§Ù„',0),(523443,14541,'pr','Ø§Ø´ØºØ§Ù„',0),(523444,14541,'tr','Doluluk',0),(523445,14541,'pl','Okupacja',0),(523446,14541,'bg','Ð—Ð°ÐµÑ‚Ð¾ÑÑ‚',0),(523447,14541,'ur','Ø³Ú©ÙˆÙ†Øª',0),(523448,14541,'sr','ÐžÐºÑƒÐ¿Ð°Ñ†Ð¸Ñ˜Ðµ',0),(523449,14541,'vi','Suáº¥t phÃ²ng',0),(523450,14541,'af','Okkupasie',0),(523451,14541,'ro','De ocupare',0),(523452,14541,'et','HÃµivatus',0),(523453,14541,'si','Zasedenost',0),(523454,14541,'ba','Hunian',0),(523455,14541,'nl','Bezetting',0),(523456,14541,'fi','Kapasiteetti',0),(523457,14541,'no','Bruk',0),(523458,14541,'da','BelÃ¦gning',0),(523459,14541,'ko','ì¸',0),(523460,14541,'he','×ª×¤×•×¡×”',0),(523461,14541,'el','Î§Ï‰ÏÎ·Ï„Î¹ÎºÏŒÏ„Î·Ï„Î±',0),(523462,14541,'zh','å…¥ä½',0),(523463,14541,'sv','BelÃ¤ggning',0),(523464,14541,'it','Occupazione',0),(523465,14541,'tl','',0),(523466,14541,'th','à¸œà¸¹à¹‰à¹€à¸‚à¹‰à¸²à¸žà¸±à¸',0),(523467,14541,'hi','à¤…à¤§à¤¿à¤­à¥‹à¤—',0),(523468,14541,'ms','Penghunian',0),(523469,14541,'ar','Ø´ØºÙ„',0),(523470,14541,'fr','Occupation',0),(523471,14541,'jp','å æœ‰',0),(523472,14541,'pt','OcupaÃ§Ã£o',0),(523473,14541,'ru','Ð Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ð¸Ðµ',0),(523474,14541,'es','OcupaciÃ³n',0),(523475,14541,'de','Belegung',0),(523476,14541,'en','Occupancy',0),(523477,14542,'is','',0),(523478,14542,'dr','Ø§ØªØ§Ù‚ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯',0),(523479,14542,'pr','Ø§ØªØ§Ù‚ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯',0),(523480,14542,'tr','Oda mevcuttur',0),(523481,14542,'pl','DostÄ™pne pokoje',0),(523482,14542,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ ÑÑ‚Ð°Ð¸',0),(523483,14542,'ur','Ú©Ù…Ø±Û’ Ù…ÛÛŒØ§',0),(523484,14542,'sr','Ð¡Ð»Ð¾Ð±Ð¾Ð´Ð½Ð¸Ñ… ÑÐ¾Ð±Ð°',0),(523485,14542,'vi','PhÃ²ng cÃ³ sáºµn',0),(523486,14542,'af','Kamers beskikbaar',0),(523487,14542,'ro','Camere disponibile',0),(523488,14542,'et','Saadaval on toad',0),(523489,14542,'si','Sobe na voljo',0),(523490,14542,'ba','Kamar yang tersedia',0),(523491,14542,'nl','Kamers beschikbaar',0),(523492,14542,'fi','Huoneita saatavilla',0),(523493,14542,'no','Rom tilgjengelig',0),(523494,14542,'da','VÃ¦relserne til rÃ¥dighed',0),(523495,14542,'ko','ê°ì‹¤ ì´ìš©ì´ ê°€ëŠ¥',0),(523496,14542,'he','×—×“×¨×™× ×™×¤×™× ×•× ×•×—×™×.',0),(523497,14542,'el','Î”Ï‰Î¼Î¬Ï„Î¹Î± Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î±',0),(523498,14542,'zh','ç©ºæˆ¿',0),(523499,14542,'sv','TillgÃ¤ngliga rum',0),(523500,14542,'it','Camere disponibili',0),(523501,14542,'tl','',0),(523502,14542,'th','à¸«à¹‰à¸­à¸‡à¸§à¹ˆà¸²à¸‡',0),(523503,14542,'hi','à¤•à¤®à¤°à¥‡ à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(523504,14542,'ms','Bilik-bilik yang disediakan',0),(523505,14542,'ar','Ø§Ù„ØºØ±Ù Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(523506,14542,'fr','Chambres disponibles',0),(523507,14542,'jp','åˆ©ç”¨å¯èƒ½ãªå®¢å®¤',0),(523508,14542,'pt','Quartos disponÃ­veis',0),(523509,14542,'ru','Ð¡Ð²Ð¾Ð±Ð¾Ð´Ð½Ñ‹Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(523510,14542,'es','Habitaciones disponibles',0),(523511,14542,'de','VerfÃ¼gbare Zimmer',0),(523512,14542,'en','Rooms Available',0),(523513,14543,'is','',0),(523514,14543,'dr','Ø§ØªØ§Ù‚ Ø§Ø¬Ø§Ø±Ù‡',0),(523515,14543,'pr','Ø§ØªØ§Ù‚ Ø§Ø¬Ø§Ø±Ù‡',0),(523516,14543,'tr','KiralÄ±k Odalar',0),(523517,14543,'pl','Pokoje wynajmowane',0),(523518,14543,'bg','Ð¡Ñ‚Ð°Ð¸ Ð¿Ð¾Ð´ Ð½Ð°ÐµÐ¼',0),(523519,14543,'ur','Ú©Ù…Ø±ÙˆÚº Ú©Ùˆ Ú©Ø±Ø§ÛŒÛ’ Ù¾Ø±',0),(523520,14543,'sr','Ð˜Ð·Ð½Ð°Ñ˜Ð¼Ð¸Ð¾ Ñ˜Ðµ ÑÐ¾Ð±Ñƒ',0),(523521,14543,'vi','PhÃ²ng thuÃª',0),(523522,14543,'af','Kamers gehuur',0),(523523,14543,'ro','Camere de Ã®nchiriat',0),(523524,14543,'et','Toad rentida',0),(523525,14543,'si','Sobe v najemu',0),(523526,14543,'ba','Kamar Disewakan',0),(523527,14543,'nl','Kamers verhuurd',0),(523528,14543,'fi','Huoneita vuokrataan',0),(523529,14543,'no','Rommene leies',0),(523530,14543,'da','VÃ¦relser udlejes',0),(523531,14543,'ko','ê°ì‹¤ ìž„ëŒ€',0),(523532,14543,'he','×—×“×¨×™× ×œ×©×›×•×¨',0),(523533,14543,'el','Î”Ï‰Î¼Î¬Ï„Î¹Î± ÎµÎ½Î¿Î¹ÎºÎ¹Î¬Î¶Î¿Î½Ï„Î±Î¹',0),(523534,14543,'zh','æˆ¿é—´ç§Ÿä½',0),(523535,14543,'sv','Rummen hyrs ut',0),(523536,14543,'it','Camere in affitto',0),(523537,14543,'tl','',0),(523538,14543,'th','à¸«à¹‰à¸­à¸‡à¹€à¸Šà¹ˆà¸²',0),(523539,14543,'hi','à¤•à¤®à¤°à¤¾ à¤•à¤¿à¤°à¤¾à¤ à¤ªà¤° à¤²à¤¿à¤¯à¤¾',0),(523540,14543,'ms','Bilik-bilik yang disewa',0),(523541,14543,'ar','Ø§Ù„ØºØ±Ù Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±Ø©',0),(523542,14543,'fr','Chambres louÃ©es',0),(523543,14543,'jp','ãƒ¬ãƒ³ã‚¿ãƒ« ãƒ«ãƒ¼ãƒ ',0),(523544,14543,'pt','Quartos alugados',0),(523545,14543,'ru','ÐÐ¾Ð¼ÐµÑ€Ð° Ð² Ð°Ñ€ÐµÐ½Ð´Ñƒ',0),(523546,14543,'es','Habitaciones alquiladas',0),(523547,14543,'de','Zimmer vermietet',0),(523548,14543,'en','Rooms Rented',0),(523549,14544,'is','',0),(523550,14544,'dr','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ù„ Ø§ØªØ§Ù‚',0),(523551,14544,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ù„ Ø§ØªØ§Ù‚',0),(523552,14544,'tr','Toplam Oda gelir',0),(523553,14544,'pl','Dochody ogÃ³Å‚em pokÃ³j',0),(523554,14544,'bg','ÐžÐ±Ñ‰Ð° ÑÑ‚Ð°Ñ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸',0),(523555,14544,'ur','Ú©Ù„ Ú©Ù…Ø±Û’ Ø¢Ù…Ø¯Ù†ÛŒ',0),(523556,14544,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ ÑÐ¾Ð±Ð° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(523557,14544,'vi','Táº¥t cáº£ phÃ²ng doanh thu',0),(523558,14544,'af','Totale kamer inkomste',0),(523559,14544,'ro','Camera Total venituri',0),(523560,14544,'et','Kokku toa tulud',0),(523561,14544,'si','Skupna soba prihodkov',0),(523562,14544,'ba','Pendapatan total kamar',0),(523563,14544,'nl','Totale kamer inkomsten',0),(523564,14544,'fi','YhteensÃ¤ tulot',0),(523565,14544,'no','Totale rom inntekter',0),(523566,14544,'da','Samlede vÃ¦relse indtÃ¦gter',0),(523567,14544,'ko','ì´ ê°ì‹¤ ìˆ˜ìž…',0),(523568,14544,'he','×—×“×¨ ×¡×” ×› ×”×›× ×¡×•×ª',0),(523569,14544,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Î´Ï‰Î¼Î¬Ï„Î¹Î¿ Î­ÏƒÎ¿Î´Î±',0),(523570,14544,'zh','æ€»å®¢æˆ¿æ”¶å…¥',0),(523571,14544,'sv','Totala rumsintÃ¤kterna',0),(523572,14544,'it','Camera totale entrate',0),(523573,14544,'tl','',0),(523574,14544,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¸£à¸§à¸¡à¸«à¹‰à¸­à¸‡',0),(523575,14544,'hi','à¤•à¥à¤² à¤•à¤•à¥à¤· à¤°à¤¾à¤œà¤¸à¥à¤µ',0),(523576,14544,'ms','Hasil Jumlah bilik',0),(523577,14544,'ar','Ø§Ù„ØºØ±Ù Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª',0),(523578,14544,'fr','Revenu total',0),(523579,14544,'jp','å…¨å®¢å®¤ã®åŽç›Š',0),(523580,14544,'pt','Quarto do total das receitas',0),(523581,14544,'ru','Ð”Ð¾Ñ…Ð¾Ð´ Ð²ÑÐµÐ³Ð¾ Ð½Ð¾Ð¼ÐµÑ€',0),(523582,14544,'es','Ingreso total de la habitaciÃ³n',0),(523583,14544,'de','Total Zimmer Einnahmen',0),(523584,14544,'en','Total Room Revenue',0),(523585,14545,'is','',0),(523586,14545,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ù‡Ø±Ù‡ Ø±Ø§ ÙˆÛŒØ±Ø§ÛŒØ´ Ú©Ù†ÛŒØ¯',0),(523587,14545,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ù‡Ø±Ù‡ Ø±Ø§ ÙˆÛŒØ±Ø§ÛŒØ´ Ú©Ù†ÛŒØ¯',0),(523588,14545,'tr','Faiz Ã¼cretleri dÃ¼zenlemek',0),(523589,14545,'pl','Edytuj odsetek',0),(523590,14545,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ñ…Ð²Ð¸',0),(523591,14545,'ur','Ø³ÙˆØ¯ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(523592,14545,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÐ°Ð¼Ð°Ñ‚Ð½Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(523593,14545,'vi','Chá»‰nh sá»­a phÃ­ lÃ£i suáº¥t',0),(523594,14545,'af','Redigeer renteheffings',0),(523595,14545,'ro','Editare dobÃ¢nzile',0),(523596,14545,'et','Redigeeri viivisetasud',0),(523597,14545,'si','Urejanje obresti',0),(523598,14545,'ba','Mengedit beban bunga',0),(523599,14545,'nl','Rentelasten bewerken',0),(523600,14545,'fi','Muokkaa korkokulut',0),(523601,14545,'no','Redigere renter',0),(523602,14545,'da','Redigere renteudgifter',0),(523603,14545,'ko','ì´ìž ë¹„ìš©ì„ íŽ¸ì§‘',0),(523604,14545,'he','×¢×¨×•×š ×¨×™×‘×™×ª',0),(523605,14545,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„ÏŒÎºÏ‰Î½',0),(523606,14545,'zh','ç¼–è¾‘åˆ©æ¯è´¹ç”¨',0),(523607,14545,'sv','Redigera rÃ¤ntekostnader',0),(523608,14545,'it','Modificare le spese di interesse',0),(523609,14545,'tl','',0),(523610,14545,'th','à¹à¸à¹‰à¹„à¸‚à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢',0),(523611,14545,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤ªà¥à¤°à¤­à¤¾à¤° à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(523612,14545,'ms','Edit caj faedah',0),(523613,14545,'ar','ØªØ­Ø±ÙŠØ± Ø£Ø³Ø¹Ø§Ø± Ø§Ù„ÙØ§Ø¦Ø¯Ø©',0),(523614,14545,'fr','Modifier les frais d\'intÃ©rÃªts',0),(523615,14545,'jp','åˆ©æ¯ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(523616,14545,'pt','Editar juros',0),(523617,14545,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(523618,14545,'es','Editar cargas de interÃ©s',0),(523619,14545,'de','Bearbeiten von Zinsen',0),(523620,14545,'en','Edit Interest Charges',0),(523621,14546,'is','',0),(523622,14546,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø¨Ù‡Ø±Ù‡',0),(523623,14546,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø¨Ù‡Ø±Ù‡',0),(523624,14546,'tr','Hesaplanan faiz',0),(523625,14546,'pl','Obliczone odsetki',0),(523626,14546,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð°Ñ‚Ð° Ð»Ð¸Ñ…Ð²Ð°',0),(523627,14546,'ur','Ù…Ø­Ø³ÙˆØ¨ Ø¯Ù„Ú†Ø³Ù¾ÛŒ',0),(523628,14546,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚Ð° ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(523629,14546,'vi','TÃ­nh quan tÃ¢m',0),(523630,14546,'af','Berekende rente',0),(523631,14546,'ro','DobÃ¢nda calculatÄƒ',0),(523632,14546,'et','Arvutatud intress',0),(523633,14546,'si','IzraÄunane obresti',0),(523634,14546,'ba','Bunga dihitung',0),(523635,14546,'nl','Berekende rente',0),(523636,14546,'fi','Laskettu korko',0),(523637,14546,'no','Renter',0),(523638,14546,'da','Beregnede rente',0),(523639,14546,'ko','ê³„ì‚° ëœ ê´€ì‹¬',0),(523640,14546,'he','×”×¨×™×‘×™×ª ×ž×—×•×©×‘×ª',0),(523641,14546,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹Î¶ÏŒÎ¼ÎµÎ½Î¿Ï…Ï‚ Ï„ÏŒÎºÎ¿Ï…Ï‚',0),(523642,14546,'zh','è®¡ç®—çš„åˆ©æ¯',0),(523643,14546,'sv','BerÃ¤knad rÃ¤nta',0),(523644,14546,'it','Interessi calcolati',0),(523645,14546,'tl','',0),(523646,14546,'th','à¸„à¸³à¸™à¸§à¸“à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢',0),(523647,14546,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¿à¤¤ à¤¬à¥à¤¯à¤¾à¤œ',0),(523648,14546,'ms','Jumlah faedah yang dikenakan',0),(523649,14546,'ar','Ø§Ù„ÙØ§Ø¦Ø¯Ø© Ø§Ù„Ù…Ø­Ø³ÙˆØ¨Ø©',0),(523650,14546,'fr','IntÃ©rÃªt calculÃ©',0),(523651,14546,'jp','è¨ˆç®—ã•ã‚Œã‚‹åˆ©ç›Š',0),(523652,14546,'pt','Juros calculados',0),(523653,14546,'ru','ÐÐ°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(523654,14546,'es','InterÃ©s calculado',0),(523655,14546,'de','Berechneten Zinsen',0),(523656,14546,'en','Calculated Interest',0),(523657,14547,'is','',0),(523658,14547,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹',0),(523659,14547,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹',0),(523660,14547,'tr','Hesaplama baÅŸlangÄ±Ã§ tarihi',0),(523661,14547,'pl','Data rozpoczÄ™cia obliczeÅ„',0),(523662,14547,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(523663,14547,'ur','Ø­Ø³Ø§Ø¨ Ú©Û’ Ø¢ØºØ§Ø² Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(523664,14547,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(523665,14547,'vi','TÃ­nh toÃ¡n báº¯t Ä‘áº§u ngÃ y',0),(523666,14547,'af','Berekening Begin datum',0),(523667,14547,'ro','Data de inceput de calcul',0),(523668,14547,'et','Algus kuupÃ¤ev',0),(523669,14547,'si','ZaÄetni datum za izraÄun',0),(523670,14547,'ba','Perhitungan dimulai tanggal',0),(523671,14547,'nl','Berekening begindatum',0),(523672,14547,'fi','Laskennan aloituspÃ¤ivÃ¤',0),(523673,14547,'no','Start Beregningsdato',0),(523674,14547,'da','Beregningsdatoen Begin',0),(523675,14547,'ko','ê³„ì‚° ì‹œìž‘ ë‚ ì§œ',0),(523676,14547,'he','×”×—×™×©×•×‘ ×‘×’×™×Ÿ ×ª××¨×™×š',0),(523677,14547,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(523678,14547,'zh','è®¡ç®—å¼€å§‹æ—¥æœŸ',0),(523679,14547,'sv','BÃ¶rja BerÃ¤kningsdatum',0),(523680,14547,'it','Data di inizio calcolo',0),(523681,14547,'tl','',0),(523682,14547,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸„à¸³à¸™à¸§à¸“',0),(523683,14547,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(523684,14547,'ms','Tarikh mulakan pengiraan',0),(523685,14547,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(523686,14547,'fr','Date de dÃ©but de calcul',0),(523687,14547,'jp','è¨ˆç®—ã®é–‹å§‹æ—¥',0),(523688,14547,'pt','Data de inÃ­cio do cÃ¡lculo',0),(523689,14547,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ð¾Ð³Ð¾',0),(523690,14547,'es','Fecha de inicio de cÃ¡lculo',0),(523691,14547,'de','Anfangsdatum Berechnung',0),(523692,14547,'en','Calculation Begin Date',0),(523693,14548,'is','',0),(523694,14548,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªØ§Ø±ÛŒØ®',0),(523695,14548,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªØ§Ø±ÛŒØ®',0),(523696,14548,'tr','Hesaplama tarihi',0),(523697,14548,'pl','Obliczanie daty',0),(523698,14548,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ',0),(523699,14548,'ur','Ø­Ø³Ø§Ø¨ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(523700,14548,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(523701,14548,'vi','TÃ­nh toÃ¡n ngÃ y',0),(523702,14548,'af','Berekening datum',0),(523703,14548,'ro','Data calculÄƒrii',0),(523704,14548,'et','Arvutamise kuupÃ¤ev',0),(523705,14548,'si','Datum izraÄuna',0),(523706,14548,'ba','Perhitungan tanggal',0),(523707,14548,'nl','Berekeningsdatum',0),(523708,14548,'fi','Laskentapvm',0),(523709,14548,'no','Beregningsdato',0),(523710,14548,'da','Beregningsdatoen',0),(523711,14548,'ko','ê³„ì‚° ë‚ ì§œ',0),(523712,14548,'he','×—×™×©×•×‘ ×ª××¨×™×š',0),(523713,14548,'el','Î—Î¼/Î½Î¯Î± Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(523714,14548,'zh','è®¡ç®—æ—¥æœŸ',0),(523715,14548,'sv','BerÃ¤kningsdatum',0),(523716,14548,'it','Data di calcolo',0),(523717,14548,'tl','',0),(523718,14548,'th','à¸§à¸±à¸™à¸„à¸³à¸™à¸§à¸“',0),(523719,14548,'hi','à¤—à¤£à¤¨à¤¾ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(523720,14548,'ms','Pengiraan tarikh',0),(523721,14548,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø³Ø§Ø¨',0),(523722,14548,'fr','Date de calcul',0),(523723,14548,'jp','è¨ˆç®—ã®æ—¥ä»˜',0),(523724,14548,'pt','Data de cÃ¡lculo',0),(523725,14548,'ru','Ð”Ð°Ñ‚Ð° Ñ€Ð°ÑÑ‡ÐµÑ‚Ð°',0),(523726,14548,'es','Fecha de cÃ¡lculo',0),(523727,14548,'de','Berechnungsdatum',0),(523728,14548,'en','Calculation Date',0),(523729,14549,'is','',0),(523730,14549,'dr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù†',0),(523731,14549,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù†',0),(523732,14549,'tr','Hesaplama bitiÅŸ tarihi',0),(523733,14549,'pl','Data zakoÅ„czenia obliczania',0),(523734,14549,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ',0),(523735,14549,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ú©Ø§ Ø­Ø³Ø§Ø¨',0),(523736,14549,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(523737,14549,'vi','TÃ­nh toÃ¡n ngÃ y káº¿t thÃºc',0),(523738,14549,'af','Berekening Einddatum',0),(523739,14549,'ro','Data de sfÃ¢rÅŸit de calcul',0),(523740,14549,'et','Arvutuse lÃµppkuupÃ¤ev',0),(523741,14549,'si','IzraÄuna konÄni datum',0),(523742,14549,'ba','Perhitungan tanggal akhir',0),(523743,14549,'nl','Berekening einddatum',0),(523744,14549,'fi','Laskennan pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(523745,14549,'no','Sluttdatoen for beregning',0),(523746,14549,'da','Slutdato for beregning',0),(523747,14549,'ko','ê³„ì‚° ì¢…ë£Œì¼',0),(523748,14549,'he','×—×™×©×•×‘ ×ª××¨×™×š ×¡×™×•×',0),(523749,14549,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(523750,14549,'zh','è®¡ç®—ç»“æŸæ—¥æœŸ',0),(523751,14549,'sv','BerÃ¤kning slutdatum',0),(523752,14549,'it','Data di fine calcolo',0),(523753,14549,'tl','',0),(523754,14549,'th','à¸„à¸³à¸™à¸§à¸“à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(523755,14549,'hi','à¤ªà¤°à¤¿à¤•à¤²à¤¨ à¤…à¤‚à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(523756,14549,'ms','Tarikh akhir pengiraan',0),(523757,14549,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(523758,14549,'fr','Date de fin de calcul',0),(523759,14549,'jp','è¨ˆç®—ã®çµ‚äº†æ—¥',0),(523760,14549,'pt','Data de tÃ©rmino do cÃ¡lculo',0),(523761,14549,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ð¹',0),(523762,14549,'es','Fecha de finalizaciÃ³n de cÃ¡lculo',0),(523763,14549,'de','Enddatum Berechnung',0),(523764,14549,'en','Calculation End Date',0),(523765,14550,'is','',0),(523766,14550,'dr','ØªÙ†Ø¸ÛŒÙ… Ø¨Ù‡Ø±Ù‡',0),(523767,14550,'pr','ØªÙ†Ø¸ÛŒÙ… Ø¨Ù‡Ø±Ù‡',0),(523768,14550,'tr','Faiz ayarlamalarÄ±',0),(523769,14550,'pl','Dostosowaniem stÃ³p procentowych',0),(523770,14550,'bg','Ð›Ð¸Ñ…Ð²Ð¸',0),(523771,14550,'ur','Ø³ÙˆØ¯ Ú©ÛŒ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹',0),(523772,14550,'sr','ÐšÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(523773,14550,'vi','Äiá»u chá»‰nh lÃ£i suáº¥t',0),(523774,14550,'af','Rente aanpassings',0),(523775,14550,'ro','AjustÄƒrile de dobÃ¢ndÄƒ',0),(523776,14550,'et','Intresside korrigeerimised',0),(523777,14550,'si','Prilagoditve obrestne',0),(523778,14550,'ba','Bunga penyesuaian',0),(523779,14550,'nl','Belang aanpassingen',0),(523780,14550,'fi','Korko-oikaisuja',0),(523781,14550,'no','Interesse justeringer',0),(523782,14550,'da','Rentekorrektioner',0),(523783,14550,'ko','ê´€ì‹¬ ì¡°ì •',0),(523784,14550,'he','×”×ª××ž×•×ª ×”×¨×™×‘×™×ª',0),(523785,14550,'el','Î•Î½Î´Î¹Î±Ï†Î­ÏÎ¿Î½ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚',0),(523786,14550,'zh','åˆ©æ¯è°ƒæ•´',0),(523787,14550,'sv','Intresse justeringar',0),(523788,14550,'it','Regolazioni di interesse',0),(523789,14550,'tl','',0),(523790,14550,'th','à¸ªà¸™à¹ƒà¸ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(523791,14550,'hi','à¤°à¥à¤šà¤¿ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨',0),(523792,14550,'ms','Faedah pelarasan',0),(523793,14550,'ar','ØªØ³ÙˆÙŠØ§Øª Ø§Ù„ÙØ§Ø¦Ø¯Ø©',0),(523794,14550,'fr','Ajustements d\'intÃ©rÃªt',0),(523795,14550,'jp','é‡‘åˆ©èª¿æ•´',0),(523796,14550,'pt','Ajustes de interesse',0),(523797,14550,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ñ‹Ðµ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(523798,14550,'es','Ajustes de interÃ©s',0),(523799,14550,'de','Interesse-Anpassungen',0),(523800,14550,'en','Interest Adjustments',0),(523801,14551,'is','',0),(523802,14551,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ù‡Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(523803,14551,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ù‡Ø±Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(523804,14551,'tr','Vade farkÄ± Ã¶demeleri baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(523805,14551,'pl','Odsetek pomyÅ›lnie zaktualizowana',0),(523806,14551,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð»Ð¸Ñ…Ð²Ð¸, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(523807,14551,'ur','Ø³ÙˆØ¯ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(523808,14551,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ðµ Ð¾Ð¿Ñ‚ÑƒÐ¶Ð±Ð°Ð¼Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(523809,14551,'vi','PhÃ­ lÃ£i suáº¥t cáº­p nháº­t thÃ nh cÃ´ng',0),(523810,14551,'af','Rente heffings suksesvol bygewerk',0),(523811,14551,'ro','DobÃ¢nzile actualizat cu succes',0),(523812,14551,'et','VÃ¤rskendatud viivisetasud',0),(523813,14551,'si','Obresti, ki je uspeÅ¡no posodobljena',0),(523814,14551,'ba','Biaya bunga yang berhasil',0),(523815,14551,'nl','Rentelasten bijgewerkt',0),(523816,14551,'fi','PÃ¤ivitetty korkokulut',0),(523817,14551,'no','Renter oppdatert',0),(523818,14551,'da','Renteudgifter opdateret',0),(523819,14551,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ì´ìž ë¹„ìš©',0),(523820,14551,'he','×¢× ×™×™×Ÿ ×—×™×•×‘×™× ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(523821,14551,'el','Î§Î¡Î•Î©Î£Î•Î™Î£ Î¤ÎŸÎšÎ©Î ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(523822,14551,'zh','å·²æˆåŠŸæ›´æ–°çš„åˆ©æ¯è´¹ç”¨',0),(523823,14551,'sv','RÃ¤ntekostnader uppdaterats',0),(523824,14551,'it','Spese di interesse aggiornati con successo',0),(523825,14551,'tl','',0),(523826,14551,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(523827,14551,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¬à¥à¤¯à¤¾à¤œ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(523828,14551,'ms','Caj faedah yang berjaya dikemas kini',0),(523829,14551,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„ÙØ§Ø¦Ø¯Ø© ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(523830,14551,'fr','Frais d\'intÃ©rÃªt mis Ã  jour avec succÃ¨s',0),(523831,14551,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸåˆ©æ¯',0),(523832,14551,'pt','Juros atualizados com sucesso',0),(523833,14551,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹ Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(523834,14551,'es','Cargas de interÃ©s actualizados correctamente',0),(523835,14551,'de','Zinsen, die erfolgreich aktualisiert',0),(523836,14551,'en','Interest Charges Updated Successfully',0),(523837,14552,'is','',0),(523838,14552,'dr','ÙØ§Ú©ØªÙˆØ± + Ø¨Ù‡Ø±Ù‡',0),(523839,14552,'pr','ÙØ§Ú©ØªÙˆØ± + Ø¨Ù‡Ø±Ù‡',0),(523840,14552,'tr','Fatura + faiz',0),(523841,14552,'pl','Faktura + odsetki',0),(523842,14552,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° + Ð»Ð¸Ñ…Ð²Ð°',0),(523843,14552,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø³ÙˆØ¯',0),(523844,14552,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° + ÐºÐ°Ð¼Ð°Ñ‚Ðµ',0),(523845,14552,'vi','HoÃ¡ Ä‘Æ¡n + quan tÃ¢m',0),(523846,14552,'af','Faktuur + rente',0),(523847,14552,'ro','Factura + interes',0),(523848,14552,'et','Arve + intress',0),(523849,14552,'si','RaÄun + obresti',0),(523850,14552,'ba','Faktur + bunga',0),(523851,14552,'nl','Factuur + belang',0),(523852,14552,'fi','Lasku + korko',0),(523853,14552,'no','Faktura + rente',0),(523854,14552,'da','Faktura + renter',0),(523855,14552,'ko','ì¸ë³´ì´ìŠ¤ + ê´€ì‹¬',0),(523856,14552,'he','×—×©×‘×•× ×™×ª + ×¨×™×‘×™×ª',0),(523857,14552,'el','Î¤ÏŒÎºÎ¿Î¹ + Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(523858,14552,'zh','å‘ç¥¨ ï¼‹ åˆ©æ¯',0),(523859,14552,'sv','Faktura + rÃ¤nta',0),(523860,14552,'it','Fattura + interessi',0),(523861,14552,'tl','',0),(523862,14552,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ + à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢',0),(523863,14552,'hi','à¤šà¤¾à¤²à¤¾à¤¨ + à¤¬à¥à¤¯à¤¾à¤œ',0),(523864,14552,'ms','Invois + faedah',0),(523865,14552,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© + Ø§Ù„ÙØ§Ø¦Ø¯Ø©',0),(523866,14552,'fr','Facture + intÃ©rÃªts',0),(523867,14552,'jp','è«‹æ±‚æ›¸ + åˆ©å­',0),(523868,14552,'pt','Factura + juros',0),(523869,14552,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° + Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(523870,14552,'es','Factura + interÃ©s',0),(523871,14552,'de','Rechnung + Zinsen',0),(523872,14552,'en','Invoice + Interest',0),(523873,14553,'is','',0),(523874,14553,'dr','Ø¬Ø³ØªØ¬ÙˆÛŒ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø§Ø²',0),(523875,14553,'pr','Ø¬Ø³ØªØ¬ÙˆÛŒ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø§Ø²',0),(523876,14553,'tr','Arama aÃ§Ä±k faturalar',0),(523877,14553,'pl','Szukaj otwartych rachunkÃ³w',0),(523878,14553,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(523879,14553,'ur','ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº Ú©Ú¾ÙˆÙ„ÛŒÚº ÙˆØ¨Ø¬Ù„ÛŒ',0),(523880,14553,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ',0),(523881,14553,'vi','TÃ¬m kiáº¿m má»Ÿ hÃ³a Ä‘Æ¡n',0),(523882,14553,'af','Soek oop fakture',0),(523883,14553,'ro','CÄƒutaÅ£i facturilor deschise',0),(523884,14553,'et','Otsi avatud arved',0),(523885,14553,'si','Iskanje odprtih raÄunov',0),(523886,14553,'ba','Cari terbuka faktur',0),(523887,14553,'nl','Zoek openstaande facturen',0),(523888,14553,'fi','Etsi avoimet laskut',0),(523889,14553,'no','SÃ¸k etter Ã¥pne fakturaer',0),(523890,14553,'da','SÃ¸g Ã¥bne fakturaer',0),(523891,14553,'ko','ê²€ìƒ‰ ì˜¤í”ˆ ì¸ë³´ì´ìŠ¤',0),(523892,14553,'he','×—×™×¤×•×© ×—×©×‘×•× ×™×•×ª ×¤×ª×•×—×•×ª',0),(523893,14553,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î±Î½Î¿Î¹ÎºÏ„Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(523894,14553,'zh','æœç´¢æœªç»“å‘ç¥¨',0),(523895,14553,'sv','SÃ¶k Ã¶ppna fakturor',0),(523896,14553,'it','Ricerca fatture aperte',0),(523897,14553,'tl','',0),(523898,14553,'th','à¸„à¹‰à¸™à¸«à¸²à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸›à¸´à¸”',0),(523899,14553,'hi','à¤–à¥‹à¤œ à¤–à¥‹à¤²à¥‡à¤‚ à¤šà¤¾à¤²à¤¾à¤¨',0),(523900,14553,'ms','Invois-invois yang terbuka di Cari',0),(523901,14553,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙØªÙˆØ­Ø©',0),(523902,14553,'fr','Recherche des factures ouvertes',0),(523903,14553,'jp','æœªæ±ºæ¸ˆã®è«‹æ±‚æ›¸ã‚’æ¤œç´¢',0),(523904,14553,'pt','Pesquisar as faturas em aberto',0),(523905,14553,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(523906,14553,'es','BÃºsqueda de facturas abiertas',0),(523907,14553,'de','Suche offene Rechnungen',0),(523908,14553,'en','Search Open Invoices',0),(523909,14554,'is','',0),(523910,14554,'dr','Ù…Ø¬Ø§Ø² Ø¨Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø®Ø§Ù„ÛŒ',0),(523911,14554,'pr','Ù…Ø¬Ø§Ø² Ø¨Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø®Ø§Ù„ÛŒ',0),(523912,14554,'tr','Void Ã¶demeler iÃ§in yetkili deÄŸil',0),(523913,14554,'pl','Nie uprawnieÅ„ do pÅ‚atnoÅ›ci za niewaÅ¼ne',0),(523914,14554,'bg','ÐÑÐ¼Ð°Ñ‚ Ð¿Ñ€Ð°Ð²Ð¾ Ð´Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ñ‚ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(523915,14554,'ur','Ø¨Ø§Ø·Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø±Ù†Û’ Ú©ÛŒ Ù…Ø¬Ø§Ø² Ù†ÛÛŒÚº',0),(523916,14554,'sr','ÐÐµÐ¼Ð°Ñ‚Ðµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ñƒ Ð´Ð° Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ñƒ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(523917,14554,'vi','KhÃ´ng cÃ³ quyá»n Void cÃ¡c khoáº£n thanh toÃ¡n',0),(523918,14554,'af','Nie gemagtig is om die leemte betalings',0),(523919,14554,'ro','Nu sunt autorizate sÄƒ nule plÄƒÅ£i',0),(523920,14554,'et','Puudub Ãµigus tÃ¼histada maksete',0),(523921,14554,'si','Ne dovoli, da niÄna plaÄila',0),(523922,14554,'ba','Tidak diizinkan untuk pembayaran Batal',0),(523923,14554,'nl','Niet geautoriseerd om te vervallen betalingen',0),(523924,14554,'fi','Ei saa mitÃ¤tÃ¶idÃ¤ maksut',0),(523925,14554,'no','Ikke godkjent annullert betaling',0),(523926,14554,'da','Ikke tilladelse til at Void betalinger',0),(523927,14554,'ko','Void ì§€ë¶ˆ ìˆ˜ ìžˆëŠ” ê¶Œí•œì´ ì—†ìŠµë‹ˆë‹¤.',0),(523928,14554,'he','×”×©×¨×•×ž ××œ ×—×œ×œ ×ª×©×œ×•×ž×™×',0),(523929,14554,'el','Î”ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î½Î± Î¬ÎºÏ…ÏÎ· Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(523930,14554,'zh','æœªæŽˆæƒè®¿é—®æ— æ•ˆä»˜æ¬¾',0),(523931,14554,'sv','Inte auktoriserad att Void betalningar',0),(523932,14554,'it','Non autorizzato ai pagamenti di vuoto',0),(523933,14554,'tl','',0),(523934,14554,'th','à¹„à¸¡à¹ˆà¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸¢à¸à¹€à¸¥à¸´à¸',0),(523935,14554,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤§à¤¿à¤•à¥ƒà¤¤ à¤¨à¤¹à¥€à¤‚',0),(523936,14554,'ms','Tidak mempunyai kuasa untuk tidak sah pembayaran',0),(523937,14554,'ar','Ù„Ø§ ÙŠØ¤Ø°Ù† Ù„Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¨Ø§Ø·Ù„Ø©',0),(523938,14554,'fr','Pas autorisÃ©e Ã  paiements Sub',0),(523939,14554,'jp','Void ã®æ”¯æ‰•ã„ã‚’è¨±å¯ã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(523940,14554,'pt','NÃ£o autorizado para pagamentos Void',0),(523941,14554,'ru','ÐÐµ ÑƒÐ¿Ð¾Ð»Ð½Ð¾Ð¼Ð¾Ñ‡ÐµÐ½ Void Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(523942,14554,'es','No autorizado a los pagos de vacÃ­o',0),(523943,14554,'de','Nicht berechtigt, Zahlungen von Void',0),(523944,14554,'en','Not Authorized To Void Payments',0),(523945,14555,'is','',0),(523946,14555,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ø¯Ø±Ø¬Ù‡ Ø§Ø¹ØªØ¨Ø§Ø± Ø³Ø§Ù‚Ø·',0),(523947,14555,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ø¯Ø±Ø¬Ù‡ Ø§Ø¹ØªØ¨Ø§Ø± Ø³Ø§Ù‚Ø·',0),(523948,14555,'tr','Void Ã¶deme',0),(523949,14555,'pl','UniewaÅ¼nij pÅ‚atnoÅ›Ä‡',0),(523950,14555,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(523951,14555,'ur','Ø¨Ø§Ø·Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(523952,14555,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ˜ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(523953,14555,'vi','LÃ m máº¥t hiá»‡u lá»±c thanh toÃ¡n',0),(523954,14555,'af','Leemte betaling',0),(523955,14555,'ro','Nule de platÄƒ',0),(523956,14555,'et','TÃ¼hista makse',0),(523957,14555,'si','NiÄna plaÄila',0),(523958,14555,'ba','Membatalkan pembayaran',0),(523959,14555,'nl','Betaling ongeldig',0),(523960,14555,'fi','MitÃ¤tÃ¶i maksu',0),(523961,14555,'no','Annullere betaling',0),(523962,14555,'da','Ugyldig betaling',0),(523963,14555,'ko','ë¹„ ì§€ë¶ˆ',0),(523964,14555,'he','×”×ª×©×œ×•× ×‘×˜×œ ×•×ž×‘×•×˜×œ',0),(523965,14555,'el','Î‘ÎºÏ…ÏÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€Î»Î·ÏÏ‰Î¼Î®',0),(523966,14555,'zh','æ— æ•ˆä»˜æ¬¾',0),(523967,14555,'sv','Ogiltig betalning',0),(523968,14555,'it','Annullare il pagamento',0),(523969,14555,'tl','',0),(523970,14555,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(523971,14555,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(523972,14555,'ms','Pembayaran tidak sah',0),(523973,14555,'ar','Ø§Ù„Ø¯ÙØ¹ Ø¨Ø§Ø·Ù„Ø©',0),(523974,14555,'fr','Paiement Sub',0),(523975,14555,'jp','æ”¯æ‰•ã„ãŒç„¡åŠ¹ã—ã¾ã™ã€‚',0),(523976,14555,'pt','Anular o pagamento',0),(523977,14555,'ru','ÐÐ½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(523978,14555,'es','Anular el pago',0),(523979,14555,'de','Void Zahlung',0),(523980,14555,'en','Void Payment',0),(523981,14556,'is','',0),(523982,14556,'dr','ÙØ§Ú©ØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙØ±Ø³ØªØ§Ø¯Ù‡',0),(523983,14556,'pr','ÙØ§Ú©ØªÙˆØ± Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙØ±Ø³ØªØ§Ø¯Ù‡',0),(523984,14556,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde e-postayla gÃ¶nderilen fatura',0),(523985,14556,'pl','Faktury wysÅ‚ane pomyÅ›lnie',0),(523986,14556,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°, ÐµÐ¼Ð°Ð¹Ð» ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(523987,14556,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú©',0),(523988,14556,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð» ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(523989,14556,'vi','HÃ³a Ä‘Æ¡n gá»­i qua email thÃ nh cÃ´ng',0),(523990,14556,'af','Faktuur suksesvol per e-pos',0),(523991,14556,'ro','Factura prin E-mail cu succes',0),(523992,14556,'et','Arve saadetakse edukalt',0),(523993,14556,'si','RaÄuna po e-poÅ¡ti uspeÅ¡no',0),(523994,14556,'ba','Faktur diemail berhasil',0),(523995,14556,'nl','Factuur per E-mail met succes',0),(523996,14556,'fi','Lasku lÃ¤hetetÃ¤Ã¤n onnistuneesti',0),(523997,14556,'no','Faktura sendt vellykket',0),(523998,14556,'da','Faktura sendt med succes',0),(523999,14556,'ko','ì„±ê³µì ìœ¼ë¡œ ì´ë©”ì¼ ì²­êµ¬ì„œ',0),(524000,14556,'he','×—×©×‘×•× ×™×ª ×‘×“×•××¨ ×‘×”×¦×œ×—×”',0),(524001,14556,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(524002,14556,'zh','æˆåŠŸåœ°é€šè¿‡ç”µå­é‚®ä»¶å‘é€çš„å‘ç¥¨',0),(524003,14556,'sv','Fakturan mailas framgÃ¥ngsrikt',0),(524004,14556,'it','Fattura inviata con successo',0),(524005,14556,'tl','',0),(524006,14556,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(524007,14556,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ˆà¤®à¥‡à¤² à¤šà¤¾à¤²à¤¾à¤¨',0),(524008,14556,'ms','Invois melalui e-mel berjaya',0),(524009,14556,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¨Ù†Ø¬Ø§Ø­',0),(524010,14556,'fr','Facture envoyÃ© avec succÃ¨s',0),(524011,14556,'jp','è«‹æ±‚æ›¸ãŒæ­£å¸¸ã«ãƒ¡ãƒ¼ãƒ«ã§é€ä¿¡',0),(524012,14556,'pt','Fatura por E-mail com sucesso',0),(524013,14556,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(524014,14556,'es','Factura por correo electrÃ³nico con Ã©xito',0),(524015,14556,'de','Rechnung per E-Mail erfolgreich',0),(524016,14556,'en','Invoice Emailed Successfully',0),(524017,14557,'is','',0),(524018,14557,'dr','Ù…Ø§Ù„ÛŒØ§Øª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(524019,14557,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(524020,14557,'tr','Nakliye vergisi yok',0),(524021,14557,'pl','Å»aden podatek nie wysyÅ‚ki',0),(524022,14557,'bg','ÐÑÐ¼Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð°Ð½ÑŠÐº',0),(524023,14557,'ur','Ú©ÙˆØ¦ÛŒ Ø´Ù¾Ù†Ú¯ Ù¹ÛŒÚ©Ø³',0),(524024,14557,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(524025,14557,'vi','KhÃ´ng cÃ³ thuáº¿ váº­n chuyá»ƒn',0),(524026,14557,'af','Geen belasting gestuur',0),(524027,14557,'ro','Nici o taxa de transport maritim',0),(524028,14557,'et','Nr laevandus maksu',0),(524029,14557,'si','Ni ladijskega davÄni',0),(524030,14557,'ba','Tidak ada pajak pengiriman',0),(524031,14557,'nl','Geen verzendkosten belasting',0),(524032,14557,'fi','Shipping-veroa',0),(524033,14557,'no','Ingen frakt skatt',0),(524034,14557,'da','Ingen Shipping skat',0),(524035,14557,'ko','ì„¸ê¸ˆë„ ì—†ê³  ë°°ì†¡',0),(524036,14557,'he','×ž×¡ ×ž×©×œ×•×—',0),(524037,14557,'el','ÎšÎ±Î½Î­Î½Î±Ï‚ Ï†ÏŒÏÎ¿Ï‚ Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(524038,14557,'zh','æ²¡æœ‰èˆªè¿ç¨Ž',0),(524039,14557,'sv','Ingen frakt skatt',0),(524040,14557,'it','Nessuna tassa di spedizione',0),(524041,14557,'tl','',0),(524042,14557,'th','à¹„à¸¡à¹ˆà¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ à¸²à¸©à¸µ',0),(524043,14557,'hi','à¤•à¥‹à¤ˆ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤Ÿà¥ˆà¤•à¥à¤¸',0),(524044,14557,'ms','Tiada penghantaran cukai',0),(524045,14557,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø´Ø­Ù†',0),(524046,14557,'fr','Aucune taxe d\'expÃ©dition',0),(524047,14557,'jp','ã„ã„ãˆé€æ–™ç¨Ž',0),(524048,14557,'pt','Sem taxa de frete',0),(524049,14557,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ðµ Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(524050,14557,'es','No hay impuesto de envÃ­o',0),(524051,14557,'de','Keine Versandkosten-Steuer',0),(524052,14557,'en','No Shipping Tax',0),(524053,14558,'is','',0),(524054,14558,'dr','Ø§Ù…Ø¶Ø§ÛŒÛŒ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(524055,14558,'pr','Ø§Ù…Ø¶Ø§ÛŒÛŒ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(524056,14558,'tr','Gerekli imza yok',0),(524057,14558,'pl','Nie podpis wymagane',0),(524058,14558,'bg','ÐÐµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼ Ðµ Ð¿Ð¾Ð´Ð¿Ð¸Ñ',0),(524059,14558,'ur','Ø¯Ø³ØªØ®Ø· Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª Ù†ÛÛŒÚº',0),(524060,14558,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾',0),(524061,14558,'vi','KhÃ´ng cÃ³ chá»¯ kÃ½ yÃªu cáº§u',0),(524062,14558,'af','Geen handtekening vereis',0),(524063,14558,'ro','Nici o semnÄƒturÄƒ necesare',0),(524064,14558,'et','Puudub nÃµutav allkiri',0),(524065,14558,'si','Brez podpisa, ki zahteva',0),(524066,14558,'ba','Tanpa tanda tangan yang diperlukan',0),(524067,14558,'nl','Geen handtekening vereist',0),(524068,14558,'fi','Ei allekirjoitus vaaditaan',0),(524069,14558,'no','Ingen signatur kreves',0),(524070,14558,'da','Ingen signatur krÃ¦ves',0),(524071,14558,'ko','ì„œëª…ì´ í•„ìš”í•œ',0),(524072,14558,'he','××™×Ÿ ×—×ª×™×ž×” × ×“×¨×©',0),(524073,14558,'el','ÎšÎ±Î¼Î¯Î± Ï…Ï€Î¿Î³ÏÎ±Ï†Î® Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹',0),(524074,14558,'zh','æ²¡æœ‰æ‰€éœ€çš„ç­¾å',0),(524075,14558,'sv','Ingen signatur krÃ¤vs',0),(524076,14558,'it','Nessuna firma necessaria',0),(524077,14558,'tl','',0),(524078,14558,'th','à¹„à¸¡à¹ˆà¸•à¹‰à¸­à¸‡à¸¡à¸µà¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™',0),(524079,14558,'hi','à¤•à¥‹à¤ˆ à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(524080,14558,'ms','Tiada tandatangan diperlukan',0),(524081,14558,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(524082,14558,'fr','Aucune Signature requise',0),(524083,14558,'jp','å¿…è¦ãªç½²åãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(524084,14558,'pt','Sem assinatura necessÃ¡ria',0),(524085,14558,'ru','ÐŸÐ¾Ð´Ð¿Ð¸ÑÑŒ Ð½Ðµ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ',0),(524086,14558,'es','Ninguna firma requerida',0),(524087,14558,'de','Keine Unterschrift erforderlich',0),(524088,14558,'en','No Signature Required',0),(524089,14559,'is','',0),(524090,14559,'dr','Ø³Ø§ÛŒØª',0),(524091,14559,'pr','Ø³Ø§ÛŒØª',0),(524092,14559,'tr','Site',0),(524093,14559,'pl','Witryny',0),(524094,14559,'bg','Ð¡Ð°Ð¹Ñ‚',0),(524095,14559,'ur','ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹',0),(524096,14559,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(524097,14559,'vi','Trang web',0),(524098,14559,'af','Webwerf',0),(524099,14559,'ro','Site-ul',0),(524100,14559,'et','Saidi',0),(524101,14559,'si','Mesto',0),(524102,14559,'ba','Situs',0),(524103,14559,'nl','Site',0),(524104,14559,'fi','Sivuston',0),(524105,14559,'no','Nettstedet',0),(524106,14559,'da','Site',0),(524107,14559,'ko','ì‚¬ì´íŠ¸',0),(524108,14559,'he','×”××ª×¨',0),(524109,14559,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(524110,14559,'zh','ç½‘ç«™',0),(524111,14559,'sv','Webbplats',0),(524112,14559,'it','Sito',0),(524113,14559,'tl','',0),(524114,14559,'th','à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ',0),(524115,14559,'hi','à¤¸à¤¾à¤‡à¤Ÿ',0),(524116,14559,'ms','Laman web',0),(524117,14559,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(524118,14559,'fr','Site',0),(524119,14559,'jp','ã‚µã‚¤ãƒˆ',0),(524120,14559,'pt','Site',0),(524121,14559,'ru','Ð¡Ð°Ð¹Ñ‚',0),(524122,14559,'es','Sitio',0),(524123,14559,'de','Website',0),(524124,14559,'en','Site',0),(524125,14560,'is','',0),(524126,14560,'dr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ù…Ø´ØªØ±ÛŒ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ù…Ø±Ø¨ÙˆØ·',0),(524127,14560,'pr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ù…Ø´ØªØ±ÛŒ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ù…Ø±Ø¨ÙˆØ·',0),(524128,14560,'tr','MÃ¼ÅŸteri alakalÄ± olduÄŸunda gÃ¶ster',0),(524129,14560,'pl','PokaÅ¼ klientÃ³w stosownych',0),(524130,14560,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ðµ ÑƒÐ¼ÐµÑÑ‚Ð½Ð¾',0),(524131,14560,'ur','Ú¯Ø§ÛÚ© Ø¬Ø¨ Ù…ØªØ¹Ù„Ù‚Û Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(524132,14560,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐºÑƒÐ¿Ñ†Ð° ÐºÐ°Ð´Ð° Ñ€ÐµÐ»ÐµÐ²Ð°Ð½Ñ‚Ð½Ðµ',0),(524133,14560,'vi','Hiá»ƒn thá»‹ khÃ¡ch hÃ ng khi cÃ³ liÃªn quan',0),(524134,14560,'af','KliÃ«nt wanneer toepaslike toon',0),(524135,14560,'ro','AratÄƒ client atunci cÃ¢nd relevante',0),(524136,14560,'et','NÃ¤ita klienti kui tÃ¤htsus',0),(524137,14560,'si','PokaÅ¾i kupca, Äe je primerno',0),(524138,14560,'ba','Menunjukkan pelanggan bila relevan',0),(524139,14560,'nl','Klant wanneer relevante weergeven',0),(524140,14560,'fi','NÃ¤ytÃ¤ asiakas tarvittaessa',0),(524141,14560,'no','Vis nÃ¥r det er Relevant',0),(524142,14560,'da','Vis kunde nÃ¥r relevante',0),(524143,14560,'ko','ê³ ê° ë•Œ ê´€ë ¨ í‘œì‹œ',0),(524144,14560,'he','×œ×”×¨××•×ª ×œ×œ×§×•×— ×‘×¢×ª ×”×¨×œ×•×•× ×˜×™×ª',0),(524145,14560,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· ÎºÎ±Ï„Î¬ Ï€ÎµÏÎ¯Ï€Ï„Ï‰ÏƒÎ·',0),(524146,14560,'zh','æ˜¾ç¤ºå®¢æˆ·åœ¨ç›¸å…³æ—¶',0),(524147,14560,'sv','Visa kunden nÃ¤r relevanta',0),(524148,14560,'it','Visualizza cliente quando pertinenti',0),(524149,14560,'tl','',0),(524150,14560,'th','à¹à¸ªà¸”à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸¡à¸·à¹ˆà¸­à¸—à¸µà¹ˆà¹€à¸à¸µà¹ˆà¸¢à¸§à¸‚à¹‰à¸­à¸‡',0),(524151,14560,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¬ à¤ªà¥à¤°à¤¾à¤¸à¤‚à¤—à¤¿à¤• à¤¦à¤¿à¤–à¤¾à¤à¤',0),(524152,14560,'ms','Menunjukkan pelanggan apabila berkaitan',0),(524153,14560,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¹Ù†Ø¯ Ø°Ø§Øª Ø§Ù„ØµÙ„Ø©',0),(524154,14560,'fr','Voir l\'Ã©tablissement client lorsque pertinent',0),(524155,14560,'jp','é–¢é€£ã™ã‚‹æ™‚ã«é¡§å®¢ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(524156,14560,'pt','Mostrar ao cliente quando relevantes',0),(524157,14560,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ñƒ Ð¿Ñ€Ð¸ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ…',0),(524158,14560,'es','Mostrar al cliente cuando proceda',0),(524159,14560,'de','Zeigen Sie Kunden gegebenenfalls',0),(524160,14560,'en','Show Customer When Relevant',0),(524161,14561,'is','',0),(524162,14561,'dr','Ù…ØªÙˆØ³Ø· Ù†Ø±Ø® Ø±ÙˆØ²Ø§Ù†Ù‡',0),(524163,14561,'pr','Ù…ØªÙˆØ³Ø· Ù†Ø±Ø® Ø±ÙˆØ²Ø§Ù†Ù‡',0),(524164,14561,'tr','Ortalama gÃ¼nlÃ¼k kurlarÄ±',0),(524165,14561,'pl','Åšrednia dzienna stawka',0),(524166,14561,'bg','Ð¡Ñ€ÐµÐ´ÐµÐ½ Ð´Ð½ÐµÐ²ÐµÐ½ ÐºÑƒÑ€Ñ',0),(524167,14561,'ur','Ø±ÙˆØ²Ø§Ù†Û Ú©Û’ Ø§ÙˆØ³Ø· Ø´Ø±Ø­',0),(524168,14561,'sr','ÐŸÑ€Ð¾ÑÐµÑ‡Ð½Ð¸ Ð´Ð½ÐµÐ²Ð½Ð¸ ÐºÑƒÑ€Ñ',0),(524169,14561,'vi','Tá»· lá»‡ hÃ ng ngÃ y trung bÃ¬nh',0),(524170,14561,'af','Gemiddelde daaglikse koers',0),(524171,14561,'ro','Rata medie de zi cu zi',0),(524172,14561,'et','Keskmine pÃ¤evatasu',0),(524173,14561,'si','PovpreÄen dnevni teÄaj',0),(524174,14561,'ba','Tingkat harian rata-rata',0),(524175,14561,'nl','Gemiddelde dagelijkse tarief',0),(524176,14561,'fi','KeskimÃ¤Ã¤rÃ¤inen pÃ¤ivittÃ¤inen mÃ¤Ã¤rÃ¤',0),(524177,14561,'no','Gjennomsnittlig daglig Rate',0),(524178,14561,'da','Gennemsnitlige daglige sats',0),(524179,14561,'ko','í‰ê·  ì¼ì¼ ìš”ê¸ˆ',0),(524180,14561,'he','×ª×¢×¨×™×£ ×™×•×ž×™ ×ž×ž×•×¦×¢',0),(524181,14561,'el','ÎœÎ­ÏƒÎ· Î·Î¼ÎµÏÎ®ÏƒÎ¹Î± Ï„Î¹Î¼Î®',0),(524182,14561,'zh','å¹³å‡æ¯æ—¥æˆ¿ä»·',0),(524183,14561,'sv','Genomsnittliga dagskursen',0),(524184,14561,'it','Tariffa giornaliera media',0),(524185,14561,'tl','',0),(524186,14561,'th','à¸­à¸±à¸•à¸£à¸²à¹€à¸‰à¸¥à¸µà¹ˆà¸¢à¸£à¸²à¸¢à¸§à¸±à¸™',0),(524187,14561,'hi','à¤”à¤¸à¤¤ à¤¦à¥ˆà¤¨à¤¿à¤• à¤¦à¤°',0),(524188,14561,'ms','Purata kadar harian',0),(524189,14561,'ar','Ù…ØªÙˆØ³Ø· Ø§Ù„Ù…Ø¹Ø¯Ù„ Ø§Ù„ÙŠÙˆÙ…ÙŠ',0),(524190,14561,'fr','Taux journalier moyen',0),(524191,14561,'jp','æ¯Žæ—¥ã®å¹³å‡çŽ‡',0),(524192,14561,'pt','Taxa mÃ©dia diÃ¡ria',0),(524193,14561,'ru','Ð¡Ñ€ÐµÐ´Ð½Ð¸Ð¹ ÑÑƒÑ‚Ð¾Ñ‡Ð½Ñ‹Ð¹',0),(524194,14561,'es','Tarifa diaria promedio',0),(524195,14561,'de','Durchschnittliche Tagessatz',0),(524196,14561,'en','Average Daily Rate',0),(524197,14562,'is','',0),(524198,14562,'dr','Ø´Ø±Ú©Øª ØªØ±Ú©ÛŒØ¨ Ø¯Ø§Ø¯Ù‡',0),(524199,14562,'pr','Ø´Ø±Ú©Øª ØªØ±Ú©ÛŒØ¨ Ø¯Ø§Ø¯Ù‡',0),(524200,14562,'tr','BirleÅŸtirme ÅŸirket verileri',0),(524201,14562,'pl','Dane firmy Å‚Ä…czÄ…',0),(524202,14562,'bg','ÐšÐ¾Ð¼Ð±Ð¸Ð½Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(524203,14562,'ur','Ù…Ø´ØªØ±Ú©Û Ú©Ù…Ù¾Ù†ÛŒ ÚˆÛŒÙ¹Ø§',0),(524204,14562,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸ Ð¾ Ñ„Ð¸Ñ€Ð¼Ð¸ ÐºÐ¾Ð¼Ð±Ð°Ñ˜Ð½',0),(524205,14562,'vi','CÃ´ng ty káº¿t há»£p dá»¯ liá»‡u',0),(524206,14562,'af','Kombineer maatskappy Data',0),(524207,14562,'ro','Combina datele',0),(524208,14562,'et','Ãœhenda firma andmed',0),(524209,14562,'si','Podjetje kombinira podatke',0),(524210,14562,'ba','Data Perusahaan menggabungkan',0),(524211,14562,'nl','Gegevens combineren van bedrijf',0),(524212,14562,'fi','YhdistÃ¤ yrityksen tiedot',0),(524213,14562,'no','Kombiner firmadata',0),(524214,14562,'da','Kombinere virksomhedens Data',0),(524215,14562,'ko','ê²°í•© íšŒì‚¬ ë°ì´í„°',0),(524216,14562,'he','× ×ª×•× ×™ ×”×—×‘×¨×” ×œ×©×œ×‘',0),(524217,14562,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ ÏƒÏ…Î½Î´Ï…Î¬Î¶Î¿Ï…Î½',0),(524218,14562,'zh','ç»“åˆå…¬å¸æ•°æ®',0),(524219,14562,'sv','Kombinera fÃ¶retagets Data',0),(524220,14562,'it','Azienda di combinare dati',0),(524221,14562,'tl','',0),(524222,14562,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥ à¸šà¸£à¸´à¸©à¸±à¸—à¸£à¸§à¸¡',0),(524223,14562,'hi','à¤—à¤ à¤¬à¤‚à¤§à¤¨ à¤•à¤‚à¤ªà¤¨à¥€ à¤¡à¤¾à¤Ÿà¤¾',0),(524224,14562,'ms','Data Syarikat menggabungkan',0),(524225,14562,'ar','Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø¬Ù…Ø¹ Ø¨ÙŠÙ† Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(524226,14562,'fr','DonnÃ©es de compagnie de moissonneuses',0),(524227,14562,'jp','çµåˆä¼æ¥­ãƒ‡ãƒ¼ã‚¿',0),(524228,14562,'pt','Empresa de combinar dados',0),(524229,14562,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ ÐºÐ¾Ð¼Ð±Ð¸Ð½Ð°Ñ‚',0),(524230,14562,'es','Datos de la compaÃ±Ã­a de combinar',0),(524231,14562,'de','Kombinieren-Unternehmensdaten',0),(524232,14562,'en','Combine Company Data',0),(524233,14563,'is','',0),(524234,14563,'dr','Ø´Ø±Ú©Øª Ù‡Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ø¬Ø¯Ø§Ú¯Ø§Ù†Ù‡ Ù†Ù…Ø§ÛŒØ´',0),(524235,14563,'pr','Ø´Ø±Ú©Øª Ù‡Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ø¬Ø¯Ø§Ú¯Ø§Ù†Ù‡ Ù†Ù…Ø§ÛŒØ´',0),(524236,14563,'tr','Åžirketler ayrÄ± ayrÄ± gÃ¶rÃ¼ntÃ¼lemek',0),(524237,14563,'pl','Wystawa firm oddzielnie',0),(524238,14563,'bg','ÐžÑ‚Ð´ÐµÐ»Ð½Ð¾ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð¸',0),(524239,14563,'ur','Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ú©Ùˆ Ø¹Ù„ÛŒØ­Ø¯Û Ø¹Ù„ÛŒØ­Ø¯Û Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(524240,14563,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¾Ð´Ð²Ð¾Ñ˜ÐµÐ½Ð¾',0),(524241,14563,'vi','Hiá»ƒn thá»‹ cÃ´ng ty má»™t cÃ¡ch riÃªng biá»‡t',0),(524242,14563,'af','Maatskappye apart vertoon',0),(524243,14563,'ro','AfiÅŸarea companii separat',0),(524244,14563,'et','Kuvatakse firmad eraldi',0),(524245,14563,'si','Prikaz druÅ¾be loÄeno',0),(524246,14563,'ba','Menampilkan perusahaan secara terpisah',0),(524247,14563,'nl','Bedrijven afzonderlijk weergeven',0),(524248,14563,'fi','Ilmaista elÃ¤mÃ¤ntoveri erikseen',0),(524249,14563,'no','Vise selskaper separat',0),(524250,14563,'da','Vise virksomheder separat',0),(524251,14563,'ko','íšŒì‚¬ë¥¼ ë³„ë„ë¡œ í‘œì‹œ',0),(524252,14563,'he','×œ×”×¦×™×’ ×—×‘×¨×•×ª ×‘× ×¤×¨×“',0),(524253,14563,'el','Î•Î¼Ï†Î±Î½Î¯ÏƒÎµÏ„Îµ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚ Î¾ÎµÏ‡Ï‰ÏÎ¹ÏƒÏ„Î¬',0),(524254,14563,'zh','å•ç‹¬æ˜¾ç¤ºå…¬å¸',0),(524255,14563,'sv','Visa fÃ¶retag separat',0),(524256,14563,'it','Visualizzare separatamente le aziende',0),(524257,14563,'tl','',0),(524258,14563,'th','à¹à¸ªà¸”à¸‡à¸šà¸£à¸´à¸©à¸±à¸—à¹à¸¢à¸à¸•à¹ˆà¸²à¸‡à¸«à¸²à¸',0),(524259,14563,'hi','à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤…à¤²à¤— à¤¸à¥‡ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(524260,14563,'ms','Memaparkan Syarikat secara berasingan',0),(524261,14563,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø´Ø±ÙƒØ§Øª ÙƒÙ„ Ø¹Ù„Ù‰ Ø­Ø¯Ø©',0),(524262,14563,'fr','Afficher les entreprises sÃ©parÃ©ment',0),(524263,14563,'jp','ä¼šç¤¾åˆ¥ã«è¡¨ç¤ºã—ã¾ã™ã€‚',0),(524264,14563,'pt','Exibir empresas separadamente',0),(524265,14563,'ru','ÐžÑ‚Ð´ÐµÐ»ÑŒÐ½Ð¾ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¹',0),(524266,14563,'es','Mostrar empresas por separado',0),(524267,14563,'de','Unternehmen separat anzeigen',0),(524268,14563,'en','Display Companies Separately',0),(524269,14564,'is','',0),(524270,14564,'dr','Ø¢Ù…Ø§Ø± Ù‡ØªÙ„',0),(524271,14564,'pr','Ø¢Ù…Ø§Ø± Ù‡ØªÙ„',0),(524272,14564,'tr','Hotel istatistik',0),(524273,14564,'pl','Hotel statystyki',0),(524274,14564,'bg','Ð¥Ð¾Ñ‚ÐµÐ» ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(524275,14564,'ur','ÛÙˆÙ¹Ù„ Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±',0),(524276,14564,'sr','Ð¥Ð¾Ñ‚ÐµÐ» Ð¡Ñ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(524277,14564,'vi','Sá»‘ liá»‡u thá»‘ng kÃª khÃ¡ch sáº¡n',0),(524278,14564,'af','Hotel statistiek',0),(524279,14564,'ro','Hotel statistici',0),(524280,14564,'et','Hotell statistika',0),(524281,14564,'si','Hotel statistika',0),(524282,14564,'ba','Statistik Hotel',0),(524283,14564,'nl','Hotel statistieken',0),(524284,14564,'fi','Hotel tilastot',0),(524285,14564,'no','Hotel statistikk',0),(524286,14564,'da','Hotel statistik',0),(524287,14564,'ko','í˜¸í…” í†µê³„',0),(524288,14564,'he','×ž×œ×•×Ÿ ×¡×˜×˜×™×¡×˜×™×§×”',0),(524289,14564,'el','ÎžÎµÎ½Î¿Î´Î¿Ï‡ÎµÎ¯Î¿ ÏƒÏ„Î±Ï„Î¹ÏƒÏ„Î¹ÎºÎ­Ï‚',0),(524290,14564,'zh','é…’åº—ç»Ÿè®¡',0),(524291,14564,'sv','Hotel statistik',0),(524292,14564,'it','Statistiche di Hotel',0),(524293,14564,'tl','',0),(524294,14564,'th','à¹‚à¸£à¸‡à¹à¸£à¸¡à¸ªà¸–à¸´à¸•à¸´',0),(524295,14564,'hi','à¤¹à¥‹à¤Ÿà¤² à¤•à¥‡ à¤†à¤à¤•à¤¡à¤¼à¥‡',0),(524296,14564,'ms','Statistik Hotel',0),(524297,14564,'ar','Ø¥Ø­ØµØ§Ø¡Ø§Øª ÙÙ†Ø¯Ù‚',0),(524298,14564,'fr','Statistiques de l\'hÃ´tel',0),(524299,14564,'jp','ãƒ›ãƒ†ãƒ«çµ±è¨ˆ',0),(524300,14564,'pt','EstatÃ­sticas do Hotel',0),(524301,14564,'ru','ÐžÑ‚ÐµÐ»ÑŒ ÑÑ‚Ð°Ñ‚Ð¸ÑÑ‚Ð¸ÐºÐ°',0),(524302,14564,'es','EstadÃ­sticas de Hotel',0),(524303,14564,'de','Hotel-Statistik',0),(524304,14564,'en','Hotel Statistics',0),(524305,14565,'is','',0),(524306,14565,'dr','Ù†Ù…Ø§ÛŒØ´ Ú†Ù†Ø¯ Ø´Ø±Ú©Øª',0),(524307,14565,'pr','Ù†Ù…Ø§ÛŒØ´ Ú†Ù†Ø¯ Ø´Ø±Ú©Øª',0),(524308,14565,'tr','Ã‡oklu ÅŸirket gÃ¶rÃ¼ntÃ¼leme',0),(524309,14565,'pl','WyÅ›wietlanie wielu firm',0),(524310,14565,'bg','ÐœÐ½Ð¾Ð³Ð¾Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð°, Ð¼Ð½Ð¾Ð³Ð¾ÐºÐ»Ð¾Ð½Ð¾Ð²Ð° Ð´Ð¸ÑÐ¿Ð»ÐµÐ¹',0),(524311,14565,'ur','Ú©Ø«ÛŒØ± Ú©Ù…Ù¾Ù†ÛŒ Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(524312,14565,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· ÑÐ° Ð²Ð¸ÑˆÐµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(524313,14565,'vi','Nhiá»u cÃ´ng ty Hiá»ƒn thá»‹',0),(524314,14565,'af','Multi maatskappy vertoon',0),(524315,14565,'ro','Multi-companie de afiÅŸare',0),(524316,14565,'et','Multi firma kuvamine',0),(524317,14565,'si','Multi-podjetje zaslon',0),(524318,14565,'ba','Tampilan multi-perusahaan',0),(524319,14565,'nl','Meerdere bedrijven Display',0),(524320,14565,'fi','Useita yrityksiÃ¤ nÃ¤yttÃ¶',0),(524321,14565,'no','Flerfirma skjerm',0),(524322,14565,'da','Flere firmaer Display',0),(524323,14565,'ko','ë‹¤ì¤‘ íšŒì‚¬ ë””ìŠ¤í”Œë ˆì´',0),(524324,14565,'he','×”×¦×’ ×—×‘×¨×•×ª ×ž×¨×•×‘×•×ª',0),(524325,14565,'el','Î•Ï€Î¯Î´ÎµÎ¹Î¾Î· Ï€Î¿Î»Ï…-ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(524326,14565,'zh','å¤šå…¬å¸æ˜¾ç¤º',0),(524327,14565,'sv','Flera fÃ¶retag Display',0),(524328,14565,'it','Display multi-azienda',0),(524329,14565,'tl','',0),(524330,14565,'th','à¹à¸ªà¸”à¸‡à¸«à¸¥à¸²à¸¢à¸šà¸£à¸´à¸©à¸±à¸—',0),(524331,14565,'hi','à¤®à¤²à¥à¤Ÿà¥€-à¤•à¤®à¥à¤ªà¤¨à¥€ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨',0),(524332,14565,'ms','Paparan Syarikat multi',0),(524333,14565,'ar','Ø¹Ø±Ø¶ Ø´Ø±ÙƒØ© Ù…ØªØ¹Ø¯Ø¯Ø©',0),(524334,14565,'fr','Affichage multi-sociÃ©tÃ©',0),(524335,14565,'jp','è¤‡æ•°ä¼æ¥­ã®è¡¨ç¤º',0),(524336,14565,'pt','Empresa multi-Display',0),(524337,14565,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¼ÑƒÐ»ÑŒÑ‚Ð¸ Ð´Ð¸ÑÐ¿Ð»ÐµÐ¹',0),(524338,14565,'es','Empresa multi pantalla',0),(524339,14565,'de','Multi-Firmendarstellung',0),(524340,14565,'en','Multi-Company Display',0),(524341,14566,'is','',0),(524342,14566,'dr','Ø¯Ø± Ù‡Ø± RR',0),(524343,14566,'pr','Ø¯Ø± Ù‡Ø± RR',0),(524344,14566,'tr','RR',0),(524345,14566,'pl','Na RR',0),(524346,14566,'bg','Ð˜ RR',0),(524347,14566,'ur','ÙÛŒ Ú©Ø±ÛŒÚº',0),(524348,14566,'sr','ÐŸÐ¾ Ð Ð ',0),(524349,14566,'vi','Má»—i RR',0),(524350,14566,'af','Per RR',0),(524351,14566,'ro','Per RR',0),(524352,14566,'et','RR kohta',0),(524353,14566,'si','Na RR',0),(524354,14566,'ba','Per RR',0),(524355,14566,'nl','Per RR',0),(524356,14566,'fi','/ RR',0),(524357,14566,'no','Per RR',0),(524358,14566,'da','Per RR',0),(524359,14566,'ko','RR ë‹¹',0),(524360,14566,'he','×œ×›×œ RR',0),(524361,14566,'el','Î‘Î½Î¬ RR',0),(524362,14566,'zh','æ¯ RR',0),(524363,14566,'sv','Per RR',0),(524364,14566,'it','A RR',0),(524365,14566,'tl','',0),(524366,14566,'th','à¸•à¹ˆà¸­ RR',0),(524367,14566,'hi','à¤†à¤° à¤†à¤° à¤ªà¥à¤°à¤¤à¤¿',0),(524368,14566,'ms','Satu RR',0),(524369,14566,'ar','ÙƒÙ„ RR',0),(524370,14566,'fr','Par RR',0),(524371,14566,'jp','RR ã”ã¨',0),(524372,14566,'pt','Por RR',0),(524373,14566,'ru','Ð’ ÐžÐ ',0),(524374,14566,'es','Por RR',0),(524375,14566,'de','Pro RR',0),(524376,14566,'en','Per RR',0),(524377,14567,'is','',0),(524378,14567,'dr','Ù‚ÛŒÙ…Øª Ú©Ù„ Ù‡Ø²ÛŒÙ†Ù‡ ØªÙˆØ³Ø· Ù…Ø±Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡',0),(524379,14567,'pr','Ù‚ÛŒÙ…Øª Ú©Ù„ Ù‡Ø²ÛŒÙ†Ù‡ ØªÙˆØ³Ø· Ù…Ø±Ú©Ø² Ù‡Ø²ÛŒÙ†Ù‡',0),(524380,14567,'tr','Alt toplam giderleri maliyet merkezi tarafÄ±ndan',0),(524381,14567,'pl','Sumy wydatkÃ³w przez MPK',0),(524382,14567,'bg','ÐœÐµÐ¶Ð´Ð¸Ð½Ð½Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¾Ñ‚ Ñ†ÐµÐ½Ñ‚ÑŠÑ€ Ð·Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(524383,14567,'ur','Ù„Ø§Ú¯Øª Ú©Û’ Ù…Ø±Ú©Ø² Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø°ÛŒÙ„ÛŒ Ù…ÛŒØ²Ø§Ù†',0),(524384,14567,'sr','ÐŸÐ¾Ð´Ð·Ð±Ð¸Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(524385,14567,'vi','CÃ¡c chi phÃ­ subtotal bá»Ÿi Trung tÃ¢m chi phÃ­',0),(524386,14567,'af','Subtotal uitgawes deur koste Sentrum',0),(524387,14567,'ro','Subtotal cheltuielile de Cost Center',0),(524388,14567,'et','Vahesumma â€“ kulukeskuse kulude',0),(524389,14567,'si','SeÅ¡tevek stroÅ¡kov s stroÅ¡kovno srediÅ¡Äe',0),(524390,14567,'ba','Biaya yang subtotal oleh biaya Pusat',0),(524391,14567,'nl','Subtotaal kosten door kosten Center',0),(524392,14567,'fi','YhteensÃ¤ kulut kustannuspaikka',0),(524393,14567,'no','Delsum utgiftene ved kostsenter',0),(524394,14567,'da','Subtotal udgifter af bÃ¦reren',0),(524395,14567,'ko','ë¹„ìš© ì„¼í„° ê²½ë¹„ ì†Œê³„',0),(524396,14567,'he','×¡×›×•× ×‘×™× ×™×™× ×”×•×¦××•×ª ×¢×œ ×™×“×™ ×ž×¨×›×– ×¢×œ×•×™×•×ª',0),(524397,14567,'el','ÎœÎµÏÎ¹ÎºÏŒ Î¬Î¸ÏÎ¿Î¹ÏƒÎ¼Î± Î´Î±Ï€Î±Î½ÏŽÎ½ Î±Ï€ÏŒ ÎºÎ­Î½Ï„ÏÎ¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(524398,14567,'zh','å°è®¡æŒ‰æˆæœ¬ä¸­å¿ƒåˆ†ç±»çš„å¼€æ”¯',0),(524399,14567,'sv','Delsumma kostnader fÃ¶rdelade pÃ¥ kostnadsstÃ¤lle',0),(524400,14567,'it','Subtotale costi di centro di costo',0),(524401,14567,'tl','',0),(524402,14567,'th','à¸œà¸¥à¸£à¸§à¸¡à¸¢à¹ˆà¸­à¸¢à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸•à¸²à¸¡à¸¨à¸¹à¸™à¸¢à¹Œà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(524403,14567,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤µà¥à¤¯à¤¯ à¤•à¤¾ à¤‰à¤ª-à¤¯à¥‹à¤—',0),(524404,14567,'ms','Jumlah kecil perbelanjaan oleh Pusat kos',0),(524405,14567,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ Ù„Ù…ØµØ±ÙˆÙØ§Øª Ø¨Ù…Ø±ÙƒØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(524406,14567,'fr','Sous-total DÃ©penses par centre de coÃ»ts',0),(524407,14567,'jp','ã‚³ã‚¹ãƒˆ ã‚»ãƒ³ã‚¿ãƒ¼åˆ¥è²»ç”¨ã‚’å°è¨ˆã—ã¾ã™ã€‚',0),(524408,14567,'pt','Subtotal de despesas por centro de custo',0),(524409,14567,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð¿Ð¾ ÐœÐ’Ð—',0),(524410,14567,'es','Subtotal gastos por centro de costos',0),(524411,14567,'de','Zwischensumme Aufwendungen nach Kostenstelle',0),(524412,14567,'en','Subtotal Expenses By Cost Center',0),(524413,14568,'is','',0),(524414,14568,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡ Ø§ØªØ§Ù‚',0),(524415,14568,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ø¬Ø§Ø±Ù‡ Ø§ØªØ§Ù‚',0),(524416,14568,'tr','Toplam oda kiraladÄ±m.',0),(524417,14568,'pl','Wynajmowane pokoje Å‚Ä…cznie',0),(524418,14568,'bg','ÐžÐ±Ñ‰Ð¾ ÑÑ‚Ð°Ð¸ Ð¿Ð¾Ð´ Ð½Ð°ÐµÐ¼',0),(524419,14568,'ur','Ú©Ù„ Ú©Ù…Ø±ÙˆÚº Ú©Ùˆ Ú©Ø±Ø§ÛŒÛ’ Ù¾Ø±',0),(524420,14568,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ñ˜Ðµ Ð¸Ð·Ð½Ð°Ñ˜Ð¼Ð¸Ð¾ ÑÐ¾Ð±Ñƒ',0),(524421,14568,'vi','Tá»•ng sá»‘ thuÃª phÃ²ng',0),(524422,14568,'af','Totaal kamers gehuur',0),(524423,14568,'ro','Total camere de Ã®nchiriat',0),(524424,14568,'et','Kokku renditud toad',0),(524425,14568,'si','Skupno hiÅ¡ah',0),(524426,14568,'ba','Total menyewa kamar',0),(524427,14568,'nl','Totaal gehuurde kamers',0),(524428,14568,'fi','YhteensÃ¤ vuokrasi huonetta',0),(524429,14568,'no','Totalt leide rom',0),(524430,14568,'da','Lejede vÃ¦relser i alt',0),(524431,14568,'ko','ì´ ìž„ëŒ€ ê°ì‹¤',0),(524432,14568,'he','×¡×” ×› ×”×©×›×™×¨ ×—×“×¨×™×.',0),(524433,14568,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬, ÎµÎ½Î¿Î¹ÎºÎ¹Î±Î¶ÏŒÎ¼ÎµÎ½Î± Î´Ï‰Î¼Î¬Ï„Î¹Î±',0),(524434,14568,'zh','å…±ç§Ÿäº†æˆ¿é—´',0),(524435,14568,'sv','Totalt hyrde rum',0),(524436,14568,'it','Totale camere in affitto',0),(524437,14568,'tl','',0),(524438,14568,'th','à¸«à¹‰à¸­à¸‡à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(524439,14568,'hi','à¤•à¥à¤² à¤•à¤®à¤°à¥‡ à¤•à¤¿à¤°à¤¾à¤ à¤ªà¤° à¤²à¤¿à¤¯à¤¾',0),(524440,14568,'ms','Jumlah keseluruhan yang menyewa bilik',0),(524441,14568,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ØºØ±Ù Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±Ø©',0),(524442,14568,'fr','Chambres Ã  louer au total',0),(524443,14568,'jp','åˆè¨ˆãƒ¬ãƒ³ã‚¿ãƒ« ãƒ«ãƒ¼ãƒ ',0),(524444,14568,'pt','Total quartos alugado',0),(524445,14568,'ru','Ð’ÑÐµÐ³Ð¾ Ð² Ð°Ñ€ÐµÐ½Ð´Ñƒ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(524446,14568,'es','Total alquilado habitaciones',0),(524447,14568,'de','Insgesamt vermietet Zimmer',0),(524448,14568,'en','Total Rented Rooms',0),(524449,14569,'is','',0),(524450,14569,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ GL',0),(524451,14569,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ GL',0),(524452,14569,'tr','GL kurulum doÄŸrulamak',0),(524453,14569,'pl','SprawdÅº, czy ustawienia GL',0),(524454,14569,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ GL Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(524455,14569,'ur','Ø¬ÛŒØ¬Û’ Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(524456,14569,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð“Ð›',0),(524457,14569,'vi','XÃ¡c minh thiáº¿t láº­p GL',0),(524458,14569,'af','Verifieer GL opstelling',0),(524459,14569,'ro','Verifica GL Setup',0),(524460,14569,'et','Kontrollige seadistuses',0),(524461,14569,'si','Preverite nastavitev GL',0),(524462,14569,'ba','Memverifikasi GL Setup',0),(524463,14569,'nl','Controleer of GL Setup',0),(524464,14569,'fi','GL-asetusten tarkistaminen',0),(524465,14569,'no','Kontroller finansoppsettet',0),(524466,14569,'da','Kontrollere RegnskabsopsÃ¦tning',0),(524467,14569,'ko','GL ì„¤ì¹˜ í™•ì¸',0),(524468,14569,'he','×•×“× ×”×”×ª×§× ×” GL',0),(524469,14569,'el','Î•Ï€Î±Î»Î®Î¸ÎµÏ…ÏƒÎ· Ï„Î·Ï‚ ÏÏÎ¸Î¼Î¹ÏƒÎ®Ï‚ GL',0),(524470,14569,'zh','éªŒè¯ GL çš„è®¾ç½®',0),(524471,14569,'sv','Kontrollera GL Setup',0),(524472,14569,'it','Verificare la configurazione GL',0),(524473,14569,'tl','',0),(524474,14569,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸² GL',0),(524475,14569,'hi','à¤œà¥€à¤à¤² à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(524476,14569,'ms','Sahkan GL persediaan',0),(524477,14569,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø¥Ø¹Ø¯Ø§Ø¯ GL',0),(524478,14569,'fr','VÃ©rifier la configuration des paramÃ¨tres comptabilitÃ©',0),(524479,14569,'jp','GL ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—ã“ã¨ã‚’ç¢ºèªã—ã¾ã™',0),(524480,14569,'pt','Verifique se a configuraÃ§Ã£o GL',0),(524481,14569,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ GL',0),(524482,14569,'es','Verifique la configuraciÃ³n GL',0),(524483,14569,'de','ÃœberprÃ¼fen Sie die Fibu-Einrichtung',0),(524484,14569,'en','Verify GL Setup',0),(524485,14570,'is','',0),(524486,14570,'dr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ GL Ø­Ø³Ø§Ø¨',0),(524487,14570,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ GL Ø­Ø³Ø§Ø¨',0),(524488,14570,'tr','Navlun GL hesabÄ±',0),(524489,14570,'pl','Konto GL transport',0),(524490,14570,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ð° Ñ‚Ð¾Ð²Ð°Ñ€Ð¸',0),(524491,14570,'ur','ÙØ±Ø§Ø¦Ù¹ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(524492,14570,'sr','Ð¢ÐµÑ€ÐµÑ‚Ð½Ð¸ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(524493,14570,'vi','Váº­n chuyá»ƒn hÃ ng hÃ³a GL tÃ i khoáº£n',0),(524494,14570,'af','Vrag GL rekening',0),(524495,14570,'ro','Cont de GL de marfÄƒ',0),(524496,14570,'et','Kaubaveo pearaamatukontole',0),(524497,14570,'si','Tovorni GL raÄun',0),(524498,14570,'ba','Account GL pengiriman',0),(524499,14570,'nl','Vracht GL Account',0),(524500,14570,'fi','Tavaraliikenteen Kirjanpitotilin pÃ¤Ã¤tilin',0),(524501,14570,'no','Frakt gi-konto',0),(524502,14570,'da','Fragt GL konto',0),(524503,14570,'ko','í™”ë¬¼ GL ê³„ì •',0),(524504,14570,'he','×”×•×‘×œ×” GL ×—×©×‘×•×Ÿ',0),(524505,14570,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» ÎµÎ¼Ï€Î¿ÏÎµÏ…Î¼Î±Ï„Î¹ÎºÏŽÎ½ Î¼ÎµÏ„Î±Ï†Î¿ÏÏŽÎ½',0),(524506,14570,'zh','è´§è¿æ€»å¸ç§‘ç›®',0),(524507,14570,'sv','Frakt GL konto',0),(524508,14570,'it','Trasporto merci conto GL',0),(524509,14570,'tl','',0),(524510,14570,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸„à¹ˆà¸²à¸‚à¸™à¸ªà¹ˆà¸‡',0),(524511,14570,'hi','à¤®à¤¾à¤² à¤¢à¥à¤²à¤¾à¤ˆ GL à¤–à¤¾à¤¤à¥‡',0),(524512,14570,'ms','Pengangkutan GL akaun',0),(524513,14570,'ar','Ø­Ø³Ø§Ø¨ GL Ø§Ù„Ø´Ø­Ù†',0),(524514,14570,'fr','Compte GL fret',0),(524515,14570,'jp','è²¨ç‰© GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(524516,14570,'pt','Frete GL conta',0),(524517,14570,'ru','Ð“Ñ€ÑƒÐ·Ð¾Ð²Ñ‹Ðµ GL ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(524518,14570,'es','Carga GL cuenta',0),(524519,14570,'de','Fracht-Sako',0),(524520,14570,'en','Freight GL Account',0),(524521,14571,'is','',0),(524522,14571,'dr','Ø¨Ø±Ø§ÛŒ Ø§ÙØ²ÙˆØ¯Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù¾ÛŒØ´ ÙØ±Ø¶ Ø®Ø· Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(524523,14571,'pr','Ø¨Ø±Ø§ÛŒ Ø§ÙØ²ÙˆØ¯Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù¾ÛŒØ´ ÙØ±Ø¶ Ø®Ø· Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(524524,14571,'tr','VarsayÄ±lan satÄ±r Not eklemek iÃ§in tÄ±klatÄ±n',0),(524525,14571,'pl','Kliknij, aby dodaÄ‡ domyÅ›lnÄ… wiersza Uwaga',0),(524526,14571,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð»Ð¸Ð½Ð¸Ñ Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(524527,14571,'ur','Ø·Û’ Ø´Ø¯Û Ù„Ø§Ø¦Ù† Ù†ÙˆÙ¹ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©ÛŒÙ„Ø¦Û’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(524528,14571,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ñ€ÐµÐ´ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(524529,14571,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ thÃªm máº·c Ä‘á»‹nh dÃ²ng ghi chÃº',0),(524530,14571,'af','Klik om te voeg by verstek lyn Nota',0),(524531,14571,'ro','FaceÅ£i clic pentru a adÄƒuga Note de linie implicitÄƒ',0),(524532,14571,'et','Sisestage rea vaikemÃ¤rkused',0),(524533,14571,'si','Kliknite, Äe Å¾elite dodati privzeti Ärta Opomba',0),(524534,14571,'ba','Klik untuk menambahkan catatan garis Default',0),(524535,14571,'nl','Klik om te standaard lijn notitie toevoegen',0),(524536,14571,'fi','LisÃ¤Ã¤ oletus linja huomautus napsauttamalla',0),(524537,14571,'no','Klikk for Ã¥ legge til standard linje Note',0),(524538,14571,'da','Klik for at tilfÃ¸je standard linje BemÃ¦rk',0),(524539,14571,'ko','ê¸°ë³¸ ë¼ì¸ ë…¸íŠ¸ë¥¼ ì¶”ê°€ í•˜ë ¤ë©´ í´ë¦­',0),(524540,14571,'he','×œ×—×¥ ×›×“×™ ×œ×”×•×¡×™×£ ×”×¢×¨×” ×©×•×¨×ª ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(524541,14571,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï„Î·Î½ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î³ÏÎ±Î¼Î¼Î® Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(524542,14571,'zh','å•å‡»æ­¤å¤„ï¼Œæ·»åŠ é»˜è®¤è¡Œæ³¨é‡Š',0),(524543,14571,'sv','Klicka fÃ¶r att lÃ¤gga till standard linje anmÃ¤rkning',0),(524544,14571,'it','Fare clic per aggiungere una nota di linea di Default',0),(524545,14571,'tl','',0),(524546,14571,'th','à¸„à¸¥à¸´à¸à¹€à¸žà¸´à¹ˆà¸¡à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸šà¸£à¸£à¸—à¸±à¸”à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(524547,14571,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤°à¥‡à¤–à¤¾ à¤¨à¥‹à¤Ÿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(524548,14571,'ms','Klik untuk menambah Nota talian lalai',0),(524549,14571,'ar','Ø§Ù†Ù‚Ø± Ù„Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„Ø®Ø· Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(524550,14571,'fr','Cliquez ici pour ajouter une Note de ligne par dÃ©faut',0),(524551,14571,'jp','æ—¢å®šã®è¡Œã®ãƒ¡ãƒ¢ã‚’è¿½åŠ ã™ã‚‹ã«ã¯ã€] ã‚’ã‚¯ãƒªãƒƒã‚¯ã—ã¾ã™',0),(524552,14571,'pt','Clique para adicionar nota de linha padrÃ£o',0),(524553,14571,'ru','Ð©ÐµÐ»ÐºÐ½Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ Ð»Ð¸Ð½Ð¸Ð¸ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(524554,14571,'es','Haga clic en agregar nota de lÃ­nea predeterminada',0),(524555,14571,'de','Klicken Sie auf Standard-Line-Notiz hinzufÃ¼gen',0),(524556,14571,'en','Click To Add Default Line Note',0),(524557,14572,'is','',0),(524558,14572,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ø®Ø· Ù…ÙˆØ§Ø±Ø¯',0),(524559,14572,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ø®Ø· Ù…ÙˆØ§Ø±Ø¯',0),(524560,14572,'tr','SipariÅŸ satÄ±r Ã¶ÄŸeleri iÃ§in varsayÄ±lan belirlenmiÃ¾',0),(524561,14572,'pl','Zestaw domyÅ›lne notatki dla pozycji w wierszu zamÃ³wienia',0),(524562,14572,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ Ñ€ÐµÐ´Ð¾Ð²Ðµ',0),(524563,14572,'ur','Ø­Ú©Ù… Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û Ù†ÙˆÙ¹ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(524564,14572,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÐºÐµ Ð·Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ñ€ÐµÐ´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(524565,14572,'vi','Thiáº¿t láº­p máº·c Ä‘á»‹nh ghi chÃº cho Ä‘Æ¡n Ä‘áº·t hÃ ng chi tiáº¿t Ä‘Æ¡n hÃ ng',0),(524566,14572,'af','Stel verstek notas vir orde lyn Items',0),(524567,14572,'ro','Set Default note pentru articolele din linia de comandÄƒ',0),(524568,14572,'et','MÃ¤Ã¤ra vaikimisi mÃ¤rkmed tellimuse reaÃ¼ksuste',0),(524569,14572,'si','Nastavite privzeto opombe za elemente v vrstici naloga',0),(524570,14572,'ba','Menetapkan Default catatan untuk item baris pesanan',0),(524571,14572,'nl','Standaard notities voor regelitems volgorde instellen',0),(524572,14572,'fi','Asettaa oletus toteaa tilausrivin nimikkeet',0),(524573,14572,'no','Angi standard notater For ordreelementer',0),(524574,14572,'da','Indstille standard noter For linjeelementer i Order',0),(524575,14572,'ko','ì£¼ë¬¸ í’ˆëª©ì— ëŒ€ í•œ ê¸°ë³¸ ì •ë³´ë¥¼ ì„¤ì •',0),(524576,14572,'he','×”×’×“×¨×ª ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×”×¢×¨×•×ª ×¢×‘×•×¨ ×©×•×¨×ª ×”×–×ž× ×ª ×¤×¨×™×˜×™×',0),(524577,14572,'el','Î ÏÎ¿Î²Î»Î­Ï€ÎµÏ„Î±Î¹ ÏƒÎµÎ¹ÏÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î³ÏÎ±Î¼Î¼Î®Ï‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(524578,14572,'zh','ä¸ºè®¢å•è¡Œå¼é¡¹ç›®è®¾ç½®é»˜è®¤è¯´æ˜Ž',0),(524579,14572,'sv','StÃ¤lla in standard anteckningar fÃ¶r radartiklar fÃ¶r Order',0),(524580,14572,'it','Impostare note predefinito per gli elementi di riga ordine',0),(524581,14572,'tl','',0),(524582,14572,'th','à¸•à¸±à¹‰à¸‡à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¹ƒà¸™à¸šà¸£à¸£à¸—à¸±à¸”à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(524583,14572,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¨à¥‹à¤Ÿà¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(524584,14572,'ms','Menyediakan Nota-Nota lalai untuk perintah talian item',0),(524585,14572,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ø¨Ù†ÙˆØ¯ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(524586,14572,'fr','DÃ©finir des Notes par dÃ©faut pour l\'ordre des rubriques',0),(524587,14572,'jp','æ³¨æ–‡ã®å“ç›®ã«å¯¾ã™ã‚‹æ—¢å®šã®ãƒ¡ãƒ¢ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(524588,14572,'pt','Conjunto notas de padrÃ£o para os itens de linha de ordem',0),(524589,14572,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸ Ð´Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð·Ð°ÐºÐ°Ð·Ð°',0),(524590,14572,'es','Establecer por defecto notas para artÃ­culos de lÃ­nea de orden',0),(524591,14572,'de','Set Default Notes fÃ¼r Bestellung Einzelposten',0),(524592,14572,'en','Set Default Notes For Order Line Items',0),(524593,14573,'is','',0),(524594,14573,'dr','Ø­Ø³Ø§Ø¨ Ù…ØªØ¹Ù„Ù‚ Ø¨Ù‡ Ø´Ø±Ú©Øª Ø¯ÛŒÚ¯Ø±',0),(524595,14573,'pr','Ø­Ø³Ø§Ø¨ Ù…ØªØ¹Ù„Ù‚ Ø¨Ù‡ Ø´Ø±Ú©Øª Ø¯ÛŒÚ¯Ø±',0),(524596,14573,'tr','Hesap diÄŸer ÅŸirkete ait',0),(524597,14573,'pl','Konto naleÅ¼y do innej firmy',0),(524598,14573,'bg','ÐŸÑ€Ð¾Ñ„Ð¸Ð»ÑŠÑ‚ Ð¿Ñ€Ð¸Ð½Ð°Ð´Ð»ÐµÐ¶Ð¸ Ð½Ð° Ð´Ñ€ÑƒÐ³Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(524599,14573,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯ÛŒÚ¯Ø± Ú©Ù…Ù¾Ù†ÛŒ Ø³Û’ ØªØ¹Ù„Ù‚ Ø±Ú©Ú¾ØªØ§ ÛÛ’ Û”',0),(524600,14573,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¿Ñ€Ð¸Ð¿Ð°Ð´Ð° Ð´Ñ€ÑƒÐ³Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ñƒ',0),(524601,14573,'vi','TÃ i khoáº£n thuá»™c vá» cÃ´ng ty khÃ¡c',0),(524602,14573,'af','Rekening behoort aan \'n ander maatskappy',0),(524603,14573,'ro','Contul aparÅ£ine de altÄƒ societate',0),(524604,14573,'et','Konto kuulub teise firma',0),(524605,14573,'si','RaÄun pripada drugo podjetje',0),(524606,14573,'ba','Akun milik perusahaan lain',0),(524607,14573,'nl','Account behoort met ander bedrijf',0),(524608,14573,'fi','Tili kuuluu yrityksen',0),(524609,14573,'no','Kontoen tilhÃ¸rer andre selskaper',0),(524610,14573,'da','Konto tilhÃ¸rer andre selskaber',0),(524611,14573,'ko','ë‹¤ë¥¸ íšŒì‚¬ì— ì†í•˜ëŠ” ê³„ì •',0),(524612,14573,'he','×—×©×‘×•×Ÿ ×©×™×™×š ×œ×—×‘×¨×ª ××—×¨×™×',0),(524613,14573,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î¿Ï… Î±Î½Î®ÎºÎµÎ¹ ÏƒÎµ Î¬Î»Î»Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(524614,14573,'zh','å±žäºŽå…¶ä»–å…¬å¸çš„å¸æˆ·',0),(524615,14573,'sv','Konto tillhÃ¶r andra fÃ¶retag',0),(524616,14573,'it','Conto appartiene ad altre societÃ ',0),(524617,14573,'tl','',0),(524618,14573,'th','à¸šà¸±à¸à¸Šà¸µà¹€à¸›à¹‡à¸™à¸‚à¸­à¸‡à¸šà¸£à¸´à¸©à¸±à¸—à¸­à¸·à¹ˆà¸™',0),(524619,14573,'hi','à¤…à¤¨à¥à¤¯ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤…à¤‚à¤¤à¤°à¥à¤—à¤¤ à¤†à¤¤à¤¾ à¤¹à¥ˆ',0),(524620,14573,'ms','Akaun milik syarikat lain',0),(524621,14573,'ar','Ø­Ø³Ø§Ø¨ ÙŠÙ†ØªÙ…ÙŠ Ø¥Ù„Ù‰ Ø´Ø±ÙƒØ© Ø£Ø®Ø±Ù‰',0),(524622,14573,'fr','Compte appartient Ã  une autre sociÃ©tÃ©',0),(524623,14573,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒä»–ã®ä¼šç¤¾ã«å±žã™ã‚‹',0),(524624,14573,'pt','Conta pertence a outra empresa',0),(524625,14573,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ñ€Ð¸Ð½Ð°Ð´Ð»ÐµÐ¶Ð¸Ñ‚ Ðº Ð´Ñ€ÑƒÐ³Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(524626,14573,'es','Cuenta pertenece a otra empresa',0),(524627,14573,'de','Konto auf anderen Unternehmen gehÃ¶rt',0),(524628,14573,'en','Account Belongs To Other Company',0),(524629,14574,'is','',0),(524630,14574,'dr','Ø­Ø°Ù Ø­Ø³Ø§Ø¨',0),(524631,14574,'pr','Ø­Ø°Ù Ø­Ø³Ø§Ø¨',0),(524632,14574,'tr','SilinmiÅŸ hesap',0),(524633,14574,'pl','Konto usuniÄ™te',0),(524634,14574,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ñ‚ Ð¿Ñ€Ð¾Ñ„Ð¸Ð»',0),(524635,14574,'ur','Ø­Ø°Ù Ø´Ø¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(524636,14574,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(524637,14574,'vi','TÃ i khoáº£n Ä‘Ã£ xÃ³a',0),(524638,14574,'af','Geskrapte rekening',0),(524639,14574,'ro','Cont ÅŸters',0),(524640,14574,'et','Kustutatud konto',0),(524641,14574,'si','Izbrisati raÄun',0),(524642,14574,'ba','Akun dihapus',0),(524643,14574,'nl','Verwijderde Account',0),(524644,14574,'fi','Poistettu tili',0),(524645,14574,'no','Slettet konto',0),(524646,14574,'da','Slettede konto',0),(524647,14574,'ko','ì‚­ì œ ëœ ê³„ì •',0),(524648,14574,'he','×”×—×©×‘×•×Ÿ ×©× ×ž×—×§',0),(524649,14574,'el','Î”Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(524650,14574,'zh','åˆ é™¤çš„å¸æˆ·',0),(524651,14574,'sv','Kontot',0),(524652,14574,'it','Account eliminato',0),(524653,14574,'tl','',0),(524654,14574,'th','à¸¥à¸šà¸šà¸±à¸à¸Šà¸µ',0),(524655,14574,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤–à¤¾à¤¤à¥‡',0),(524656,14574,'ms','Akaun dihapuskan',0),(524657,14574,'ar','Ø­Ø°Ù Ø§Ù„Ø­Ø³Ø§Ø¨',0),(524658,14574,'fr','Compte supprimÃ©',0),(524659,14574,'jp','å‰Šé™¤ã•ã‚ŒãŸã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(524660,14574,'pt','Conta excluÃ­da',0),(524661,14574,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð½Ð°Ñ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(524662,14574,'es','Cuenta eliminada',0),(524663,14574,'de','GelÃ¶schten Kontos',0),(524664,14574,'en','Deleted Account',0),(524665,14575,'is','',0),(524666,14575,'dr','ØªÙ†Ø¸ÛŒÙ… Ù†Ø´Ø¯Ù‡',0),(524667,14575,'pr','ØªÙ†Ø¸ÛŒÙ… Ù†Ø´Ø¯Ù‡',0),(524668,14575,'tr','AyarlÄ± deÄŸil',0),(524669,14575,'pl','Nie zestaw',0),(524670,14575,'bg','ÐÐµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼',0),(524671,14575,'ur','Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(524672,14575,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(524673,14575,'vi','KhÃ´ng Ä‘áº·t',0),(524674,14575,'af','Stel nie',0),(524675,14575,'ro','Nu seta',0),(524676,14575,'et','Pole seatud',0),(524677,14575,'si','Ni nastavljena',0),(524678,14575,'ba','Tidak diatur',0),(524679,14575,'nl','Niet ingesteld',0),(524680,14575,'fi','Ei ole mÃ¤Ã¤ritetty',0),(524681,14575,'no','Ikke angitt',0),(524682,14575,'da','Ikke angivet',0),(524683,14575,'ko','ì„¤ì • í•˜ì§€',0),(524684,14575,'he','×œ× ×”×•×’×“×¨',0),(524685,14575,'el','Î”ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(524686,14575,'zh','æœªè®¾ç½®',0),(524687,14575,'sv','Inte stÃ¤lla',0),(524688,14575,'it','Non impostato',0),(524689,14575,'tl','',0),(524690,14575,'th','à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸•à¸±à¹‰à¸‡',0),(524691,14575,'hi','à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(524692,14575,'ms','Tidak ditetapkan',0),(524693,14575,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ†',0),(524694,14575,'fr','Pas la valeur',0),(524695,14575,'jp','è¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(524696,14575,'pt','NÃ£o definido',0),(524697,14575,'ru','ÐÐµ Ð·Ð°Ð´Ð°Ð½Ð¾',0),(524698,14575,'es','No se establece',0),(524699,14575,'de','Nicht festgelegt',0),(524700,14575,'en','Not Set',0),(524701,14576,'is','',0),(524702,14576,'dr','Ø¯Ø§Ø¯ÛŒØ¯ØŒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(524703,14576,'pr','Ø¯Ø§Ø¯ÛŒØ¯ØŒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(524704,14576,'tr','Silinen hesaplar yeniden atama',0),(524705,14576,'pl','Ponowne przypisywanie konta usuniÄ™te',0),(524706,14576,'bg','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾ Ð²ÑŠÐ·Ð»Ð°Ð³Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸',0),(524707,14576,'ur','Ø¨Ú¾Ø± ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø­Ø°Ù Ú©Ø± Ø¯ÛŒ Û”',0),(524708,14576,'sr','ÐŸÐ¾Ð½Ð¾Ð²Ð½Ð¾ Ð´Ð¾Ð´ÐµÑ™Ð¸Ð²Ð°ÑšÐµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(524709,14576,'vi','GÃ¡n xÃ³a tÃ i khoáº£n',0),(524710,14576,'af','Reassign geskrap rekeninge',0),(524711,14576,'ro','Reasociere ÅŸters conturile',0),(524712,14576,'et','MÃ¤Ã¤ra kustutatakse kontod',0),(524713,14576,'si','Znova dodelite Izbrisani raÄuni',0),(524714,14576,'ba','Menetapkan kembali akun dihapus',0),(524715,14576,'nl','Verwijderde Accounts toewijzen',0),(524716,14576,'fi','SiirrÃ¤ Poistetut tilit',0),(524717,14576,'no','Tilordne slettede kontoer',0),(524718,14576,'da','Gentildele slettede konti',0),(524719,14576,'ko','ì‚­ì œ ëœ ê³„ì •ì— ë‹¤ì‹œ í• ë‹¹',0),(524720,14576,'he','×”×§×¦××” ×ž×—×“×© ×©×œ ×—×©×‘×•× ×•×ª × ×ž×—×§×•',0),(524721,14576,'el','Î•Îº Î½Î­Î¿Ï… ÎµÎºÏ‡ÏŽÏÎ·ÏƒÎ· Î´Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(524722,14576,'zh','é‡æ–°æŒ‡å®šå·²åˆ é™¤çš„å¸æˆ·',0),(524723,14576,'sv','Ã…teranvisa bort konton',0),(524724,14576,'it','Riassegnare gli account cancellati',0),(524725,14576,'tl','',0),(524726,14576,'th','à¸à¸³à¸«à¸™à¸”à¸šà¸±à¸à¸Šà¸µà¸—à¸µà¹ˆà¸–à¸¹à¸à¸¥à¸š',0),(524727,14576,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤–à¤¾à¤¤à¥‡ à¤ªà¥à¤¨: à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(524728,14576,'ms','Mengatur semula akaun dihapuskan',0),(524729,14576,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø­Ø°ÙˆÙØ©',0),(524730,14576,'fr','RÃ©affecter les comptes supprimÃ©s',0),(524731,14576,'jp','å‰Šé™¤ã—ãŸã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®å†å‰²ã‚Šå½“ã¦ãã ã•ã„ã€‚',0),(524732,14576,'pt','Reatribuir contas deletadas',0),(524733,14576,'ru','ÐŸÐµÑ€ÐµÐ½Ð°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ Ð£Ð´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ñ‹',0),(524734,14576,'es','Reasignar las cuentas borradas',0),(524735,14576,'de','GelÃ¶schte Konten zuweisen',0),(524736,14576,'en','Reassign Deleted Accounts',0),(524737,14577,'is','',0),(524738,14577,'dr','ØªÙ†Ø¸ÛŒÙ…Ø§Øª',0),(524739,14577,'pr','ØªÙ†Ø¸ÛŒÙ…Ø§Øª',0),(524740,14577,'tr','AyarÄ±',0),(524741,14577,'pl','Ustawienie',0),(524742,14577,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(524743,14577,'ur','Ø³ÛŒÙ¹Ù†Ú¯',0),(524744,14577,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(524745,14577,'vi','Thiáº¿t láº­p',0),(524746,14577,'af','Instelling',0),(524747,14577,'ro','Setarea',0),(524748,14577,'et','SÃ¤te',0),(524749,14577,'si','Nastavitev',0),(524750,14577,'ba','Pengaturan',0),(524751,14577,'nl','Instelling',0),(524752,14577,'fi','Asetus',0),(524753,14577,'no','Innstillingen',0),(524754,14577,'da','Indstilling',0),(524755,14577,'ko','ì„¤ì •',0),(524756,14577,'he','×”×’×“×¨×”',0),(524757,14577,'el','Î¡ÏÎ¸Î¼Î¹ÏƒÎ·',0),(524758,14577,'zh','è®¾ç½®',0),(524759,14577,'sv','InstÃ¤llningen',0),(524760,14577,'it','Impostazione',0),(524761,14577,'tl','',0),(524762,14577,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²',0),(524763,14577,'hi','à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—',0),(524764,14577,'ms','Persekitaran',0),(524765,14577,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(524766,14577,'fr','RÃ©glage',0),(524767,14577,'jp','è¨­å®š',0),(524768,14577,'pt','ConfiguraÃ§Ã£o',0),(524769,14577,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(524770,14577,'es','Ajuste',0),(524771,14577,'de','Einstellung',0),(524772,14577,'en','Setting',0),(524773,14578,'is','',0),(524774,14578,'dr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø®ÙˆØ¯ Ø±Ø§ Ø¯Ø§Ø±Ø§ÛŒ Ø®Ø·Ø§ Ø§Ø³Øª',0),(524775,14578,'pr','Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø¯ÙØªØ± Ú©Ù„ Ø®ÙˆØ¯ Ø±Ø§ Ø¯Ø§Ø±Ø§ÛŒ Ø®Ø·Ø§ Ø§Ø³Øª',0),(524776,14578,'tr','Genel muhasebe kurulum hatalarÄ± vardÄ±r',0),(524777,14578,'pl','Ustawienia ksiÄ™gi ma bÅ‚Ä™dy',0),(524778,14578,'bg','Ð’Ð°ÑˆÐ°Ñ‚Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð·Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ ÑÑŠÐ´ÑŠÑ€Ð¶Ð° Ð³Ñ€ÐµÑˆÐºÐ¸',0),(524779,14578,'ur','Ø¢Ù¾ Ú©Ú¾Ø§ØªØ§ Ø³ÛŒÙ¹ Ø§Ù¾ Ù…ÛŒÚº Ø§ØºÙ„Ø§Ø· ÛÛŒÚº',0),(524780,14578,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ñ‚Ð²Ð¾Ñ˜Ðµ ÐºÑšÐ¸Ð³Ðµ Ð¸Ð¼Ð° Ð³Ñ€ÐµÑˆÐ°ÐºÐ°',0),(524781,14578,'vi','Thiáº¿t láº­p Ledger cá»§a báº¡n cÃ³ lá»—i',0),(524782,14578,'af','Jou grootboek opstel het foute',0),(524783,14578,'ro','Setup-ul din registrul are erori',0),(524784,14578,'et','Pearaamatu seadistamine on vead',0),(524785,14578,'si','Nastavitev vaÅ¡e knjige je napake',0),(524786,14578,'ba','Anda Setup Ledger memiliki kesalahan',0),(524787,14578,'nl','Uw Boekhoudinstellingen heeft fouten',0),(524788,14578,'fi','PÃ¤Ã¤kirjanpidon asetuksissa on virheitÃ¤',0),(524789,14578,'no','Din Finansoppsett har feil',0),(524790,14578,'da','Din finansopsÃ¦tning har fejl',0),(524791,14578,'ko','ë ˆì € ì„¤ì¹˜ëŠ” ì˜¤ë¥˜',0),(524792,14578,'he','×”×’×“×¨×ª ×”×—×©×‘×•× ×•×ª ×©×œ×š ×™×© ×©×’×™××•×ª',0),(524793,14578,'el','Î›Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® Î Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ· ÏƒÎ±Ï‚ Î­Ï‡ÎµÎ¹ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î±',0),(524794,14578,'zh','æ‚¨çš„åˆ†ç±»å¸è®¾ç½®æœ‰é”™è¯¯',0),(524795,14578,'sv','Din RedovisningsinstÃ¤llningar har fel',0),(524796,14578,'it','Il Setup di contabilitÃ  presenta errori',0),(524797,14578,'tl','',0),(524798,14578,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸¡à¸µà¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(524799,14578,'hi','à¤†à¤ªà¤•à¤¾ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤¤à¥à¤°à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¹à¥ˆà¤‚',0),(524800,14578,'ms','Persediaan Lejar anda mengandungi ralat',0),(524801,14578,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ ØªØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ Ø£Ø®Ø·Ø§Ø¡',0),(524802,14578,'fr','Vos paramÃ¨tres de comptabilitÃ© comporte des erreurs',0),(524803,14578,'jp','ç·å‹˜å®šå…ƒå¸³è¨­å®šã‚¨ãƒ©ãƒ¼ãŒã‚ã‚Šã¾ã™ã€‚',0),(524804,14578,'pt','Sua configuraÃ§Ã£o Ledger tem erros',0),(524805,14578,'ru','Ð’Ð°ÑˆÐ¸ Ð¤Ð¸Ð½Ð°Ð½ÑÑ‹ ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¸Ð¼ÐµÐµÑ‚ Ð¾ÑˆÐ¸Ð±ÐºÐ¸',0),(524806,14578,'es','Su configuraciÃ³n contabilidad tiene errores',0),(524807,14578,'de','Ihre Finanzbuchhaltung-Einrichtung hat StÃ¶rungen',0),(524808,14578,'en','Your Ledger Setup Has Errors',0),(524809,14579,'is','',0),(524810,14579,'dr','Ø­Ø³Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ù„ÛŒØ³Øª',0),(524811,14579,'pr','Ø­Ø³Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ù„ÛŒØ³Øª',0),(524812,14579,'tr','Hesap listesi',0),(524813,14579,'pl','Lista kont',0),(524814,14579,'bg','ÐŸÑ€Ð¾Ñ„Ð¸Ð» ÑÐ¿Ð¸ÑÑŠÐº',0),(524815,14579,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(524816,14579,'sr','Ð›Ð¸ÑÑ‚Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(524817,14579,'vi','Danh sÃ¡ch tÃ i khoáº£n',0),(524818,14579,'af','Rekening lys',0),(524819,14579,'ro','Lista de cont',0),(524820,14579,'et','Kontode loendist',0),(524821,14579,'si','Seznama raÄunov',0),(524822,14579,'ba','Daftar account',0),(524823,14579,'nl','Accountlijst',0),(524824,14579,'fi','Tilin luettelo',0),(524825,14579,'no','Oversikt',0),(524826,14579,'da','Kontolisten',0),(524827,14579,'ko','ê³„ì • ëª©ë¡',0),(524828,14579,'he','×¨×©×™×ž×ª ×ª×™×§×™ ×œ×§×•×—×•×ª',0),(524829,14579,'el','Î›Î¯ÏƒÏ„Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(524830,14579,'zh','å¸æˆ·åˆ—è¡¨',0),(524831,14579,'sv','Kontolista',0),(524832,14579,'it','Elenco account',0),(524833,14579,'tl','',0),(524834,14579,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(524835,14579,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¥‚à¤šà¥€',0),(524836,14579,'ms','Senarai akaun',0),(524837,14579,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø­Ø³Ø§Ø¨',0),(524838,14579,'fr','Liste des comptes',0),(524839,14579,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆä¸€è¦§',0),(524840,14579,'pt','Lista de contas',0),(524841,14579,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(524842,14579,'es','Lista de cuentas',0),(524843,14579,'de','Kontenliste',0),(524844,14579,'en','Account List',0),(524845,14580,'is','',0),(524846,14580,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú©Ø§Ø±Ú©Ù†Ø§Ù†',0),(524847,14580,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú©Ø§Ø±Ú©Ù†Ø§Ù†',0),(524848,14580,'tr','Ã‡alÄ±ÅŸan eklemek',0),(524849,14580,'pl','DodaÄ‡ pracownika',0),(524850,14580,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(524851,14580,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(524852,14580,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(524853,14580,'vi','ThÃªm nhÃ¢n viÃªn',0),(524854,14580,'af','Voeg werknemer',0),(524855,14580,'ro','Adauga angajat',0),(524856,14580,'et','Lisada tÃ¶Ã¶taja',0),(524857,14580,'si','Dodaj zaposlenega',0),(524858,14580,'ba','Tambahkan karyawan',0),(524859,14580,'nl','Werknemer toevoegen',0),(524860,14580,'fi','LisÃ¤Ã¤ tyÃ¶ntekijÃ¤',0),(524861,14580,'no','Legg ansatte',0),(524862,14580,'da','FÃ¸j medarbejder',0),(524863,14580,'ko','ì§ì› ì¶”ê°€',0),(524864,14580,'he','×”×•×¡×¤×ª ×¢×•×‘×“',0),(524865,14580,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(524866,14580,'zh','æ·»åŠ å‘˜å·¥',0),(524867,14580,'sv','LÃ¤gg till medarbetare',0),(524868,14580,'it','Aggiungi dipendente',0),(524869,14580,'tl','',0),(524870,14580,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(524871,14580,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(524872,14580,'ms','Tambah pekerja',0),(524873,14580,'ar','Ø¥Ø¶Ø§ÙØ© Ù…ÙˆØ¸Ù',0),(524874,14580,'fr','Ajouter employÃ©',0),(524875,14580,'jp','å¾“æ¥­å“¡ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(524876,14580,'pt','Adicionar empregado',0),(524877,14580,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ°',0),(524878,14580,'es','AÃ±adir empleado',0),(524879,14580,'de','Mitarbeiter hinzufÃ¼gen',0),(524880,14580,'en','Add Employee',0),(524881,14581,'is','',0),(524882,14581,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(524883,14581,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(524884,14581,'tr','SeÃ§ilen ekleme',0),(524885,14581,'pl','Dodaj wybrane',0),(524886,14581,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸Ñ‚Ðµ',0),(524887,14581,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(524888,14581,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ',0),(524889,14581,'vi','ThÃªm lá»±a chá»n',0),(524890,14581,'af','Voeg geselekteerde',0),(524891,14581,'ro','Adauga selectate',0),(524892,14581,'et','Lisa valitud',0),(524893,14581,'si','Dodaj izbrane',0),(524894,14581,'ba','Tambahkan dipilih',0),(524895,14581,'nl','Selectie toevoegen',0),(524896,14581,'fi','LisÃ¤Ã¤ valittu',0),(524897,14581,'no','Legg til valgte',0),(524898,14581,'da','TilfÃ¸je valgte',0),(524899,14581,'ko','ì„ íƒí•œ ì¶”ê°€',0),(524900,14581,'he','×œ×”×•×¡×™×£ ×©× ×‘×—×¨×•',0),(524901,14581,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Ï‰Î½',0),(524902,14581,'zh','æ·»åŠ æ‰€é€‰é¡¹ç›®',0),(524903,14581,'sv','LÃ¤gg till valda',0),(524904,14581,'it','Aggiungi selezionati',0),(524905,14581,'tl','',0),(524906,14581,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(524907,14581,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(524908,14581,'ms','Tambah terpilih',0),(524909,14581,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(524910,14581,'fr','Ajouter sÃ©lectionnÃ©s',0),(524911,14581,'jp','é¸æŠžã—ãŸè¿½åŠ ã—ã¾ã™ã€‚',0),(524912,14581,'pt','Adicionar selecionadas',0),(524913,14581,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð½Ð¾Ðµ',0),(524914,14581,'es','AÃ±adir seleccionados',0),(524915,14581,'de','AusgewÃ¤hlte hinzufÃ¼gen',0),(524916,14581,'en','Add Selected',0),(524917,14582,'is','',0),(524918,14582,'dr','ØªÙ…Ø§Ù… Ù…Ø·Ø§Ù„Ø¨ ÙƒÙ„ÛŒÙƒ ÙƒÙ†ÛŒØ¯',0),(524919,14582,'pr','ØªÙ…Ø§Ù… Ù…Ø·Ø§Ù„Ø¨ ÙƒÙ„ÛŒÙƒ ÙƒÙ†ÛŒØ¯',0),(524920,14582,'tr','TÃ¼m giriÅŸleri filtresiz',0),(524921,14582,'pl','Wszystkie wpisy niefiltrowane',0),(524922,14582,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð±ÐµÐ· Ñ„Ð¸Ð»Ñ‚ÑŠÑ€',0),(524923,14582,'ur','Ø§Ù†ÙÙ„Ù¹Ø±Úˆ ØªÙ…Ø§Ù… Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(524924,14582,'sr','ÐÐµÑ„Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°Ð½Ð¸ ÑÐ²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(524925,14582,'vi','Táº¥t cáº£ cÃ¡c má»¥c Unfiltered',0),(524926,14582,'af','Alle inskrywings ongefiltreerde',0),(524927,14582,'ro','Toate intrÄƒrile nefiltrate',0),(524928,14582,'et','KÃµik kanded filtreerimata',0),(524929,14582,'si','Vse postavke, nefiltrirana',0),(524930,14582,'ba','Semua entri tanpa filter',0),(524931,14582,'nl','Alle inzendingen ongefilterd',0),(524932,14582,'fi','Kaikki merkinnÃ¤t suodattamaton',0),(524933,14582,'no','Alle ufiltrert',0),(524934,14582,'da','Alle poster ufiltreret',0),(524935,14582,'ko','ëª¨ë“  í•­ëª© í•„í„°ë§',0),(524936,14582,'he','×›×œ ×”×¢×¨×›×™× ×ž×¡×•× ×Ÿ',0),(524937,14582,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î±Ï†Î¹Î»Ï„ÏÎ¬ÏÎ¹ÏƒÏ„Î¿',0),(524938,14582,'zh','æœªç»è¿‡æ»¤çš„æ‰€æœ‰æ¡ç›®',0),(524939,14582,'sv','Alla poster ofiltrerade',0),(524940,14582,'it','Tutte le voci non filtrato',0),(524941,14582,'tl','',0),(524942,14582,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸—à¸µà¹ˆà¸¢à¸±à¸‡à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸à¸£à¸­à¸‡',0),(524943,14582,'hi','à¤¸à¤­à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤‚ à¤…à¤¨à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤°à¥à¤¡',0),(524944,14582,'ms','Semua penyertaan yang pun tidak dituras',0),(524945,14582,'ar','ÙƒØ§ÙØ© Ø¥Ø¯Ø®Ø§Ù„Ø§Øª ÙÙ„ØªØ±',0),(524946,14582,'fr','Toutes les entrÃ©es non filtrÃ©e',0),(524947,14582,'jp','ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼å‡¦ç†ãªã—ã®ã™ã¹ã¦ã®ã‚¨ãƒ³ãƒˆãƒªãƒ¼',0),(524948,14582,'pt','Todas as entradas sem filtro',0),(524949,14582,'ru','Ð’ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½ÐµÑ„Ð¸Ð»ÑŒÑ‚Ñ€Ð¾Ð²Ð°Ð½Ð½Ð¾Ðµ',0),(524950,14582,'es','Todas las entradas sin filtrar',0),(524951,14582,'de','Alle EintrÃ¤ge ungefiltert',0),(524952,14582,'en','All Entries Unfiltered',0),(524953,14583,'is','',0),(524954,14583,'dr','Ù‡Ù…Ù‡ ØµÙØ­Ø§Øª Ø§Ø² Ø¬Ø³ØªØ¬Ùˆ',0),(524955,14583,'pr','Ù‡Ù…Ù‡ ØµÙØ­Ø§Øª Ø§Ø² Ø¬Ø³ØªØ¬Ùˆ',0),(524956,14583,'tr','TÃ¼m arama sayfalarÄ±ndan',0),(524957,14583,'pl','Wszystkie strony z wyszukiwarki',0),(524958,14583,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ Ð¾Ñ‚ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(524959,14583,'ur','ØªÙ…Ø§Ù… ØµÙØ­Ø§Øª ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº',0),(524960,14583,'sr','Ð¡Ð²Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð¸Ð· Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ðµ',0),(524961,14583,'vi','Táº¥t cáº£ cÃ¡c trang khá»i tÃ¬m kiáº¿m',0),(524962,14583,'af','Alle bladsye van soektog',0),(524963,14583,'ro','Toate paginile de cÄƒutare',0),(524964,14583,'et','Otsi kÃµik lehekÃ¼ljed',0),(524965,14583,'si','Vse strani iz iskanja',0),(524966,14583,'ba','Semua halaman dari pencarian',0),(524967,14583,'nl','Alle pagina\'s van zoeken',0),(524968,14583,'fi','Kaikki sivut Search',0),(524969,14583,'no','Alle sider fra sÃ¸k',0),(524970,14583,'da','Alle sider fra SÃ¸g',0),(524971,14583,'ko','ê²€ìƒ‰ì—ì„œ ëª¨ë“  íŽ˜ì´ì§€',0),(524972,14583,'he','×›×œ ×”×“×¤×™× ×ž×ª×•×š ×—×™×¤×•×©',0),(524973,14583,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ ÏƒÎµÎ»Î¯Î´ÎµÏ‚ Î±Ï€ÏŒ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(524974,14583,'zh','æœç´¢çš„æ‰€æœ‰é¡µé¢',0),(524975,14583,'sv','Alla sidor frÃ¥n SÃ¶k',0),(524976,14583,'it','Tutte le pagine di ricerca',0),(524977,14583,'tl','',0),(524978,14583,'th','à¸«à¸™à¹‰à¸²à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸ˆà¸²à¸à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²',0),(524979,14583,'hi','à¤¸à¤­à¥€ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤¸à¥‡ à¤–à¥‹à¤œ',0),(524980,14583,'ms','Semua halaman dari carian',0),(524981,14583,'ar','ÙƒØ§ÙØ© ØµÙØ­Ø§Øª Ù…Ù† Ø§Ù„Ø¨Ø­Ø«',0),(524982,14583,'fr','Toutes les Pages de recherche',0),(524983,14583,'jp','æ¤œç´¢ã‹ã‚‰ã™ã¹ã¦ã®ãƒšãƒ¼ã‚¸',0),(524984,14583,'pt','Todas as pÃ¡ginas de busca',0),(524985,14583,'ru','Ð’ÑÐµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ð¸Ð· Ð¿Ð¾Ð¸ÑÐºÐ°',0),(524986,14583,'es','Todas las pÃ¡ginas de bÃºsqueda',0),(524987,14583,'de','Alle Seiten von der Suche',0),(524988,14583,'en','All Pages From Search',0),(524989,14584,'is','',0),(524990,14584,'dr','Ø±Ù…Ø² Ø¯ÛŒÚ¯Ø± Ø®ÙˆØ§Ù‡Ø¯ Ø¨ÙˆØ¯ Ø§Ù…Ù† ØªØ±',0),(524991,14584,'pr','Ø±Ù…Ø² Ø¯ÛŒÚ¯Ø± Ø®ÙˆØ§Ù‡Ø¯ Ø¨ÙˆØ¯ Ø§Ù…Ù† ØªØ±',0),(524992,14584,'tr','Daha uzun bir parola daha gÃ¼venli olur.',0),(524993,14584,'pl','DÅ‚uÅ¼sze hasÅ‚o bÄ™dzie bardziej bezpieczne',0),(524994,14584,'bg','ÐŸÐ¾-Ð´ÑŠÐ»Ð³Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð° Ñ‰Ðµ Ð±ÑŠÐ´Ðµ Ð¿Ð¾-ÑÐ¸Ð³ÑƒÑ€ÐµÐ½',0),(524995,14584,'ur','Ø§ÛŒÚ© Ø·ÙˆÛŒÙ„ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø²ÛŒØ§Ø¯Û Ù…Ø­ÙÙˆØ¸ ÛÙˆ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(524996,14584,'sr','Ð”ÑƒÐ¶Ñƒ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ð±Ð¸Ñ‚Ð¸ Ð±ÐµÐ·Ð±ÐµÐ´Ð½Ð¸Ñ˜Ð°',0),(524997,14584,'vi','Má»™t máº­t kháº©u dÃ i hÆ¡n sáº½ an toÃ n hÆ¡n',0),(524998,14584,'af','\'N langer wagwoord veiliger sou wees',0),(524999,14584,'ro','O parolÄƒ mai lungÄƒ ar fi mai sigure',0),(525000,14584,'et','Pikemat parooli on turvalisem',0),(525001,14584,'si','DaljÅ¡e geslo, bi bilo bolj varno',0),(525002,14584,'ba','Password lama akan lebih aman',0),(525003,14584,'nl','Een langer wachtwoord zou veiliger zijn',0),(525004,14584,'fi','PitkÃ¤t salasanat on turvallisempi',0),(525005,14584,'no','Lengre passord ville vÃ¦re sikrere',0),(525006,14584,'da','En lÃ¦ngere Password ville vÃ¦re mere sikker',0),(525007,14584,'ko','ë” ê¸´ ì•”í˜¸ ë³´ë‹¤ ì•ˆì „í•œ ê²ƒ',0),(525008,14584,'he','×¡×™×¡×ž×” ×¢×•×“ ×™×”×™×” ×‘×˜×•×— ×™×•×ª×¨',0),(525009,14584,'el','ÎœÎ¹Î± Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ¿ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Î¸Î± ÎµÎ¯Î½Î±Î¹ Ï€Î¹Î¿ Î±ÏƒÏ†Î±Î»Î­Ï‚',0),(525010,14584,'zh','è¾ƒé•¿çš„å¯†ç ä¼šå˜å¾—æ›´å®‰å…¨',0),(525011,14584,'sv','En lÃ¤ngre lÃ¶senord skulle vara sÃ¤krare',0),(525012,14584,'it','Una Password piÃ¹ lunga sarebbe piÃ¹ sicura',0),(525013,14584,'tl','',0),(525014,14584,'th','à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸¢à¸²à¸§à¸ˆà¸°à¸›à¸¥à¸­à¸”à¸ à¸±à¸¢à¸¡à¸²à¸à¸‚à¸¶à¹‰à¸™',0),(525015,14584,'hi','à¤à¤• à¤²à¤‚à¤¬à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤”à¤° à¤…à¤§à¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¿à¤¤ à¤¹à¥‹ à¤œà¤¾à¤à¤—à¤¾',0),(525016,14584,'ms','Kata laluan yang lebih panjang adalah lebih selamat',0),(525017,14584,'ar','ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ø£Ø·ÙˆÙ„ ØªÙƒÙˆÙ† Ø£ÙƒØ«Ø± Ø£Ù…Ø§Ù†Ø§Ù‹',0),(525018,14584,'fr','Un mot de passe plus long serait plus sÃ»r',0),(525019,14584,'jp','é•·ã„ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚ˆã‚Šå®‰å…¨ã ã‚ã†',0),(525020,14584,'pt','Uma palavra-passe mais tempo seria mais segura',0),(525021,14584,'ru','Ð”Ð»Ð¸Ð½Ð½Ñ‹Ð¹ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð±ÑƒÐ´ÐµÑ‚ Ð±Ð¾Ð»ÐµÐµ Ð±ÐµÐ·Ð¾Ð¿Ð°ÑÐ½Ñ‹Ð¼',0),(525022,14584,'es','Una contraseÃ±a mÃ¡s larga estarÃ­a mÃ¡s segura',0),(525023,14584,'de','Ein lÃ¤ngeres Kennwort wÃ¤re sicherer',0),(525024,14584,'en','A Longer Password Would Be More Secure',0),(525025,14585,'is','',0),(525026,14585,'dr','Ø³Ø§Ø¨Ù‚Ù‡ Ùˆ Ù‡Ø¯Ù',0),(525027,14585,'pr','Ø³Ø§Ø¨Ù‚Ù‡ Ùˆ Ù‡Ø¯Ù',0),(525028,14585,'tr','Arka plan',0),(525029,14585,'pl','TÅ‚o',0),(525030,14585,'bg','Ð¤Ð¾Ð½',0),(525031,14585,'ur','Ù¾Ø³ Ù…Ù†Ø¸Ø±',0),(525032,14585,'sr','ÐŸÐ¾Ð·Ð°Ð´Ð¸Ð½Ð°',0),(525033,14585,'vi','Ná»n',0),(525034,14585,'af','Agtergrond',0),(525035,14585,'ro','Fundal',0),(525036,14585,'et','Taust',0),(525037,14585,'si','Ozadje',0),(525038,14585,'ba','Latar belakang',0),(525039,14585,'nl','Achtergrond',0),(525040,14585,'fi','Tausta',0),(525041,14585,'no','Bakgrunn',0),(525042,14585,'da','Baggrund',0),(525043,14585,'ko','ë°°ê²½',0),(525044,14585,'he','×¨×§×¢',0),(525045,14585,'el','Î¦ÏŒÎ½Ï„Î¿',0),(525046,14585,'zh','èƒŒæ™¯',0),(525047,14585,'sv','Bakgrund',0),(525048,14585,'it','Sfondo',0),(525049,14585,'tl','',0),(525050,14585,'th','à¸žà¸·à¹‰à¸™à¸«à¸¥à¸±à¸‡',0),(525051,14585,'hi','à¤ªà¥ƒà¤·à¥à¤ à¤­à¥‚à¤®à¤¿',0),(525052,14585,'ms','Latar belakang',0),(525053,14585,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø£Ø³Ø§Ø³ÙŠØ©',0),(525054,14585,'fr','Fond',0),(525055,14585,'jp','ãƒãƒƒã‚¯ ã‚°ãƒ©ã‚¦ãƒ³ãƒ‰',0),(525056,14585,'pt','Plano de fundo',0),(525057,14585,'ru','Ð¡Ð¿Ñ€Ð°Ð²Ð¾Ñ‡Ð½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(525058,14585,'es','Fondo',0),(525059,14585,'de','Hintergrund',0),(525060,14585,'en','Background',0),(525061,14586,'is','',0),(525062,14586,'dr','Ù„ÛŒØ³Øª Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ú©',0),(525063,14586,'pr','Ù„ÛŒØ³Øª Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ú©',0),(525064,14586,'tr','Banka mevduat listesi',0),(525065,14586,'pl','Banku depozyt lista',0),(525066,14586,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÐ¿Ð¸ÑÑŠÐº',0),(525067,14586,'ur','Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(525068,14586,'sr','Ð›Ð¸ÑÑ‚Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(525069,14586,'vi','NgÃ¢n hÃ ng tiá»n gá»­i danh sÃ¡ch',0),(525070,14586,'af','Bank deposito lys',0),(525071,14586,'ro','ListÄƒ de depozit bancar',0),(525072,14586,'et','Panga deposiiti nimekiri',0),(525073,14586,'si','BanÄni depozit seznam',0),(525074,14586,'ba','Bank Deposit daftar',0),(525075,14586,'nl','Bank storting lijst',0),(525076,14586,'fi','Pankki tallettaa List',0),(525077,14586,'no','Bank innskudd liste',0),(525078,14586,'da','Bank depositum liste',0),(525079,14586,'ko','ì€í–‰ ì˜ˆê¸ˆ ëª©ë¡',0),(525080,14586,'he','×¨×©×™×ž×ª ×”×¤×§×“×” ×‘×‘× ×§',0),(525081,14586,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ·Ï‚ Î»Î¯ÏƒÏ„Î±',0),(525082,14586,'zh','é“¶è¡Œå­˜æ¬¾æ¸…å•',0),(525083,14586,'sv','Bank insÃ¤ttning lista',0),(525084,14586,'it','Elenco di deposito bancario',0),(525085,14586,'tl','',0),(525086,14586,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸˜à¸™à¸²à¸„à¸²à¸£',0),(525087,14586,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤¸à¥‚à¤šà¥€',0),(525088,14586,'ms','Senarai Deposit Bank',0),(525089,14586,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(525090,14586,'fr','Liste de banques de dÃ©pÃ´t',0),(525091,14586,'jp','éŠ€è¡Œé é‡‘ã®ãƒªã‚¹ãƒˆ',0),(525092,14586,'pt','Lista de depÃ³sito de banco',0),(525093,14586,'ru','Ð‘Ð°Ð½Ðº Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(525094,14586,'es','Lista de depÃ³sitos de banco',0),(525095,14586,'de','Bank Scheckeinreichungsliste',0),(525096,14586,'en','Bank Deposit List',0),(525097,14587,'is','',0),(525098,14587,'dr','Ù…Ø±Ø²',0),(525099,14587,'pr','Ù…Ø±Ø²',0),(525100,14587,'tr','KenarlÄ±k',0),(525101,14587,'pl','Granica',0),(525102,14587,'bg','Ð“Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(525103,14587,'ur','Ø³Ø±Ø­Ø¯',0),(525104,14587,'sr','Ð“Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(525105,14587,'vi','BiÃªn giá»›i',0),(525106,14587,'af','Grens',0),(525107,14587,'ro','FrontierÄƒ',0),(525108,14587,'et','Ã„Ã¤ris',0),(525109,14587,'si','Obroba',0),(525110,14587,'ba','Perbatasan',0),(525111,14587,'nl','Grens',0),(525112,14587,'fi','Raja',0),(525113,14587,'no','Kantlinje',0),(525114,14587,'da','GrÃ¦nsen',0),(525115,14587,'ko','í…Œë‘ë¦¬',0),(525116,14587,'he','×’×‘×•×œ',0),(525117,14587,'el','Î£ÏÎ½Î¿ÏÎ±',0),(525118,14587,'zh','è¾¹æ¡†',0),(525119,14587,'sv','GrÃ¤nsen',0),(525120,14587,'it','Confine',0),(525121,14587,'tl','',0),(525122,14587,'th','à¹€à¸ªà¹‰à¸™à¸‚à¸­à¸š',0),(525123,14587,'hi','à¤¬à¥‰à¤°à¥à¤¡à¤°',0),(525124,14587,'ms','Sempadan',0),(525125,14587,'ar','Ø§Ù„Ø­Ø¯ÙˆØ¯',0),(525126,14587,'fr','FrontiÃ¨re',0),(525127,14587,'jp','å¢ƒç•Œç·š',0),(525128,14587,'pt','Fronteira',0),(525129,14587,'ru','Ð“Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(525130,14587,'es','Frontera',0),(525131,14587,'de','Grenze',0),(525132,14587,'en','Border',0),(525133,14588,'is','',0),(525134,14588,'dr','Ù‚Ù‡ÙˆÙ‡ Ø§ÛŒ',0),(525135,14588,'pr','Ù‚Ù‡ÙˆÙ‡ Ø§ÛŒ',0),(525136,14588,'tr','Brown',0),(525137,14588,'pl','Brown',0),(525138,14588,'bg','Ð‘Ñ€Ð°ÑƒÐ½',0),(525139,14588,'ur','Ø¨Ø±Ø§Ø¤Ù†',0),(525140,14588,'sr','Ð‘Ñ€Ð¾wÐ½',0),(525141,14588,'vi','Brown',0),(525142,14588,'af','Bruin',0),(525143,14588,'ro','Brown',0),(525144,14588,'et','Brown',0),(525145,14588,'si','Brown',0),(525146,14588,'ba','Brown',0),(525147,14588,'nl','Brown',0),(525148,14588,'fi','Brown',0),(525149,14588,'no','Brown',0),(525150,14588,'da','Brown',0),(525151,14588,'ko','ë¸Œë¼ìš´',0),(525152,14588,'he','×‘×¨××•×Ÿ',0),(525153,14588,'el','ÎšÎ±Ï†Î­',0),(525154,14588,'zh','å¸ƒæœ—',0),(525155,14588,'sv','Brown',0),(525156,14588,'it','Brown',0),(525157,14588,'tl','',0),(525158,14588,'th','à¸ªà¸µà¸™à¹‰à¸³à¸•à¸²à¸¥',0),(525159,14588,'hi','à¤¬à¥à¤°à¤¾à¤‰à¤¨',0),(525160,14588,'ms','Brown',0),(525161,14588,'ar','Ø¨Ø±Ø§ÙˆÙ†',0),(525162,14588,'fr','Brown',0),(525163,14588,'jp','ãƒ–ãƒ©ã‚¦ãƒ³',0),(525164,14588,'pt','Brown',0),(525165,14588,'ru','Ð‘Ñ€Ð°ÑƒÐ½',0),(525166,14588,'es','Brown',0),(525167,14588,'de','Brown',0),(525168,14588,'en','Brown',0),(525169,14589,'is','',0),(525170,14589,'dr','Ù„ÛŒØ³Øª Ú©Ù¾ÛŒ Ø¨ÛŒÙ„',0),(525171,14589,'pr','Ù„ÛŒØ³Øª Ú©Ù¾ÛŒ Ø¨ÛŒÙ„',0),(525172,14589,'tr','CC fatura listesi',0),(525173,14589,'pl','CC Bill listy',0),(525174,14589,'bg','CC Ð±Ð¸Ð» ÑÐ¿Ð¸ÑÑŠÐº',0),(525175,14589,'ur','Ù†Ù‚Ù„ Ø¨Ø±Ø§Û“ Ø¨Ù„ ÙÛØ±Ø³Øª',0),(525176,14589,'sr','Ð¦Ð¦ Ð‘Ð¸Ð» Ð»Ð¸ÑÑ‚Ð°',0),(525177,14589,'vi','CC Bill danh sÃ¡ch',0),(525178,14589,'af','BK Wetsontwerp lys',0),(525179,14589,'ro','ListÄƒ de Bill CC',0),(525180,14589,'et','CC Bill loend',0),(525181,14589,'si','Seznam Kp Bill',0),(525182,14589,'ba','Daftar tagihan CC',0),(525183,14589,'nl','CC Bill lijst',0),(525184,14589,'fi','Laskun kopio',0),(525185,14589,'no','CC Bill liste',0),(525186,14589,'da','CC Bill liste',0),(525187,14589,'ko','CC ë²•ì•ˆ ëª©ë¡',0),(525188,14589,'he','×¨×©×™×ž×ª ×‘×™×œ CC',0),(525189,14589,'el','Î›Î¯ÏƒÏ„Î± Bill CC',0),(525190,14589,'zh','CC æ¡ä¾‹è‰æ¡ˆåˆ—è¡¨',0),(525191,14589,'sv','CC Bill lista',0),(525192,14589,'it','Elenco di Bill CC',0),(525193,14589,'tl','',0),(525194,14589,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸³à¹€à¸™à¸²à¸–à¸¶à¸‡',0),(525195,14589,'hi','CC à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤¸à¥‚à¤šà¥€',0),(525196,14589,'ms','Senarai Rang undang-undang CC',0),(525197,14589,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨ÙŠÙ„ CC',0),(525198,14589,'fr','Liste de Bill CC',0),(525199,14589,'jp','CC ãƒ“ãƒ«ä¸€è¦§',0),(525200,14589,'pt','Lista de Bill CC',0),(525201,14589,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð‘Ð¸Ð»Ð» CC',0),(525202,14589,'es','CC Bill lista',0),(525203,14589,'de','CC-Bill-Liste',0),(525204,14589,'en','CC Bill List',0),(525205,14590,'is','',0),(525206,14590,'dr','Ù„ÛŒØ³Øª Ø®Ø±ÛŒØ¯ Ú©Ù¾ÛŒ',0),(525207,14590,'pr','Ù„ÛŒØ³Øª Ø®Ø±ÛŒØ¯ Ú©Ù¾ÛŒ',0),(525208,14590,'tr','CC satÄ±nalma listesi',0),(525209,14590,'pl','CC zakupu listy',0),(525210,14590,'bg','CC Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° ÑÐ¿Ð¸ÑÑŠÐº',0),(525211,14590,'ur','Ù†Ù‚Ù„ Ø¨Ø±Ø§Û“ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(525212,14590,'sr','Ð¦Ð¦ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(525213,14590,'vi','CC mua danh sÃ¡ch',0),(525214,14590,'af','BK aankoop lys',0),(525215,14590,'ro','ListÄƒ de cumpÄƒrare CC',0),(525216,14590,'et','CC ostu nimekiri',0),(525217,14590,'si','Seznam Kp nakup',0),(525218,14590,'ba','Daftar pembelian CC',0),(525219,14590,'nl','CC Inkoopoverzicht',0),(525220,14590,'fi','CC Ostoluettelo',0),(525221,14590,'no','CC KjÃ¸psoversikt',0),(525222,14590,'da','CC kÃ¸bsoversigt',0),(525223,14590,'ko','CC êµ¬ìž… ëª©ë¡',0),(525224,14590,'he','×‘×¨×©×™×ž×ª ×”×¨×›×™×©×” CC',0),(525225,14590,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î±Î³Î¿ÏÏŽÎ½ CC',0),(525226,14590,'zh','æŠ„é€é‡‡è´­æ¸…å•',0),(525227,14590,'sv','CC kÃ¶p lista',0),(525228,14590,'it','Lista di acquisto CC',0),(525229,14590,'tl','',0),(525230,14590,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸‹à¸·à¹‰à¸­ CC',0),(525231,14590,'hi','CC à¤–à¤°à¥€à¤¦ à¤•à¥€ à¤¸à¥‚à¤šà¥€',0),(525232,14590,'ms','Senarai pembelian CC',0),(525233,14590,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø´Ø±Ø§Ø¡ Ù†Ø³Ø®Ø©',0),(525234,14590,'fr','Liste d\'achats CC',0),(525235,14590,'jp','CC è³¼å…¥ä¸€è¦§',0),(525236,14590,'pt','Lista de compra CC',0),(525237,14590,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° ÑÐ¿Ð¸ÑÐ¾Ðº CC',0),(525238,14590,'es','Lista de compra CC',0),(525239,14590,'de','CC-Einkaufsliste',0),(525240,14590,'en','CC Purchase List',0),(525241,14591,'is','',0),(525242,14591,'dr','ØªØºÛŒÛŒØ± Ø¬Ø³ØªØ¬Ùˆ',0),(525243,14591,'pr','ØªØºÛŒÛŒØ± Ø¬Ø³ØªØ¬Ùˆ',0),(525244,14591,'tr','DeÄŸiÅŸim arama',0),(525245,14591,'pl','Zmiana Szukaj',0),(525246,14591,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ Ñ‚ÑŠÑ€ÑÐµÐ½ÐµÑ‚Ð¾',0),(525247,14591,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ ØªÙ„Ø§Ø´',0),(525248,14591,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ðµ',0),(525249,14591,'vi','Thay Ä‘á»•i tÃ¬m',0),(525250,14591,'af','Verandering soek',0),(525251,14591,'ro','Schimbare cÄƒutare',0),(525252,14591,'et','Muuda otsingu',0),(525253,14591,'si','Iskanje sprememb',0),(525254,14591,'ba','Ubah pencarian',0),(525255,14591,'nl','Verandering zoeken',0),(525256,14591,'fi','Muuta hakua',0),(525257,14591,'no','Endre sÃ¸k',0),(525258,14591,'da','Skift sÃ¸gning',0),(525259,14591,'ko','ë³€ê²½ ê²€ìƒ‰',0),(525260,14591,'he','×©×™× ×•×™ ×—×™×¤×•×©',0),(525261,14591,'el','Î‘Î»Î»Î±Î³Î® Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ·',0),(525262,14591,'zh','æ›´æ”¹æœç´¢',0),(525263,14591,'sv','Ã„ndra SÃ¶k',0),(525264,14591,'it','Modifica ricerca',0),(525265,14591,'tl','',0),(525266,14591,'th','à¸„à¹‰à¸™à¸«à¸²à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(525267,14591,'hi','à¤¬à¤¦à¤²à¥‡à¤‚ à¤–à¥‹à¤œ',0),(525268,14591,'ms','Tukar carian',0),(525269,14591,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„ØªØºÙŠÙŠØ±',0),(525270,14591,'fr','Recherche de changement',0),(525271,14591,'jp','å¤‰æ›´ã®æ¤œç´¢',0),(525272,14591,'pt','Busca de mudanÃ§a',0),(525273,14591,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð¸ÑÐº',0),(525274,14591,'es','BÃºsqueda de cambio',0),(525275,14591,'de','Suche verÃ¤ndern',0),(525276,14591,'en','Change Search',0),(525277,14592,'is','',0),(525278,14592,'dr','Ú†Ú© Ù„ÛŒØ³Øª',0),(525279,14592,'pr','Ú†Ú© Ù„ÛŒØ³Øª',0),(525280,14592,'tr','Kontrol listesi',0),(525281,14592,'pl','Lista kontrolna',0),(525282,14592,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð·Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(525283,14592,'ur','ÙÛØ±Ø³Øª Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(525284,14592,'sr','Ð§ÐµÐº-Ð»Ð¸ÑÑ‚Ð°',0),(525285,14592,'vi','Danh sÃ¡ch kiá»ƒm tra',0),(525286,14592,'af','Kontrole lys',0),(525287,14592,'ro','Lista de verificare',0),(525288,14592,'et','Kontroll-loend',0),(525289,14592,'si','Preverite seznam',0),(525290,14592,'ba','Daftar Periksa',0),(525291,14592,'nl','Checklist',0),(525292,14592,'fi','Muistilista',0),(525293,14592,'no','Sjekkliste',0),(525294,14592,'da','Tjekliste',0),(525295,14592,'ko','ì²´í¬ ë¦¬ìŠ¤íŠ¸',0),(525296,14592,'he','×‘×“×•×§ ×¨×©×™×ž×”',0),(525297,14592,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(525298,14592,'zh','æ£€æŸ¥åˆ—è¡¨',0),(525299,14592,'sv','Checklista',0),(525300,14592,'it','Check-List',0),(525301,14592,'tl','',0),(525302,14592,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(525303,14592,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(525304,14592,'ms','Senarai Semak',0),(525305,14592,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(525306,14592,'fr','Liste de vÃ©rification',0),(525307,14592,'jp','ãƒã‚§ãƒƒã‚¯ ãƒªã‚¹ãƒˆ',0),(525308,14592,'pt','Lista de verificaÃ§Ã£o',0),(525309,14592,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(525310,14592,'es','Lista de comprobaciÃ³n',0),(525311,14592,'de','Check-Liste',0),(525312,14592,'en','Check List',0),(525313,14593,'is','',0),(525314,14593,'dr','Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± Ø§Ø¹Ù…Ø§Ù„',0),(525315,14593,'pr','Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± Ø§Ø¹Ù…Ø§Ù„',0),(525316,14593,'tr','SipariÅŸe uygulanan kredi',0),(525317,14593,'pl','Kredyt stosowany na zamÃ³wienie',0),(525318,14593,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚, Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸ ÐºÑŠÐ¼ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(525319,14593,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù„Ú¯Ø§Ø¦ÛŒ Ú¯Ø¦ÛŒ Û”',0),(525320,14593,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ñ˜Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÑšÐµÐ½Ð° Ð½Ð° Ñ€ÐµÐ´',0),(525321,14593,'vi','TÃ­n dá»¥ng Ä‘Æ°á»£c Ã¡p dá»¥ng Ä‘á»ƒ Ä‘áº·t hÃ ng',0),(525322,14593,'af','Krediet op orde toegepas',0),(525323,14593,'ro','Credit aplicate la comanda',0),(525324,14593,'et','Krediidi rakendatava korra',0),(525325,14593,'si','Credit uporabljajo po naroÄilu',0),(525326,14593,'ba','Kredit yang diterapkan untuk Order',0),(525327,14593,'nl','Krediet dat wordt toegepast om te bestellen',0),(525328,14593,'fi','Hyvitys, tilata',0),(525329,14593,'no','Kreditt som innvilges rekkefÃ¸lge',0),(525330,14593,'da','Credit anvendes til ordre',0),(525331,14593,'ko','ì‹ ìš© ìˆœì„œì— ì ìš©',0),(525332,14593,'he','××©×¨××™ ×œ×”×—×™×œ ×¢×œ ×¡×“×¨',0),(525333,14593,'el','Î Î±ÏÎ±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚ Ï€Î¿Ï… ÎµÏ†Î±ÏÎ¼ÏŒÎ¶ÎµÏ„Î±Î¹ ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î·',0),(525334,14593,'zh','ä¿¡ç”¨ç§©åºä¸­çš„åº”ç”¨',0),(525335,14593,'sv','Kredit tillÃ¤mpas pÃ¥ bestÃ¤llning',0),(525336,14593,'it','Credito applicato all\'ordine',0),(525337,14593,'tl','',0),(525338,14593,'th','à¹€à¸„à¸£à¸”à¸´à¸•à¸—à¸µà¹ˆà¹ƒà¸Šà¹‰à¸ªà¸±à¹ˆà¸‡',0),(525339,14593,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¥‚ à¤•à¥€ à¤—à¤ˆ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(525340,14593,'ms','Kredit yang digunakan untuk menempah',0),(525341,14593,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„ØªÙŠ ØªØ·Ø¨Ù‚ Ø¹Ù„Ù‰ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(525342,14593,'fr','CrÃ©dit appliquÃ© Ã  commande',0),(525343,14593,'jp','æ³¨æ–‡ã«é©ç”¨ã•ã‚Œã‚‹ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ',0),(525344,14593,'pt','CrÃ©dito aplicado Ã  ordem',0),(525345,14593,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚, Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ Ðº Ð¿Ð¾Ñ€ÑÐ´ÐºÑƒ',0),(525346,14593,'es','CrÃ©dito aplicado a la orden',0),(525347,14593,'de','Gutschrift auf Bestellung',0),(525348,14593,'en','Credit Applied to Order',0),(525349,14594,'is','',0),(525350,14594,'dr','Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ù„ØºÙˆ Ø´Ø¯',0),(525351,14594,'pr','Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´ Ù„ØºÙˆ Ø´Ø¯',0),(525352,14594,'tr','Kredi iÃ§in sipariÅŸ iptal edildi',0),(525353,14594,'pl','Kredytowa anulowana na zamÃ³wienie',0),(525354,14594,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚, Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð¸ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(525355,14594,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒÙ„Ø¦Û’ Ø¢Ø±ÚˆØ± Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(525356,14594,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð° Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ´Ð°Ðº',0),(525357,14594,'vi','TÃ­n dá»¥ng bá»‹ há»§y bá» cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(525358,14594,'af','Krediet vir bestelling gekanselleer',0),(525359,14594,'ro','Credit anulate pentru comanda',0),(525360,14594,'et','TÃ¼histatud tellimuse krediidi',0),(525361,14594,'si','Kredit za naroÄilo preklicano',0),(525362,14594,'ba','Kredit dibatalkan untuk Order',0),(525363,14594,'nl','Krediet voor Order geannuleerd',0),(525364,14594,'fi','Luotto peruuttaa tilauksen',0),(525365,14594,'no','Kreditt avbrutt for ordre',0),(525366,14594,'da','Kredit annulleret ordren',0),(525367,14594,'ko','ì‹ ìš© ìˆœì„œì— ëŒ€ í•œ ì·¨ì†Œ',0),(525368,14594,'he','××©×¨××™ ×‘×•×˜×œ×” ×¢×‘×•×¨ ×”×–×ž× ×”',0),(525369,14594,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(525370,14594,'zh','å–æ¶ˆè®¢å•çš„ä¿¡ç”¨',0),(525371,14594,'sv','Kredit annullerats fÃ¶r bestÃ¤llning',0),(525372,14594,'it','Credito annullato per ordine',0),(525373,14594,'tl','',0),(525374,14594,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¸à¸²à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(525375,14594,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(525376,14594,'ms','Kredit yang dibatalkan bagi perintah',0),(525377,14594,'ar','Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù„ØºØ§Ø¡ Ù„Ù„Ù†Ø¸Ø§Ù…',0),(525378,14594,'fr','CrÃ©dit annulÃ© pour commander',0),(525379,14594,'jp','æ³¨æ–‡ã®ã‚­ãƒ£ãƒ³ã‚»ãƒ« ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ',0),(525380,14594,'pt','CrÃ©dito cancelado por ordem',0),(525381,14594,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ñ‹ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(525382,14594,'es','CrÃ©dito cancelado por orden',0),(525383,14594,'de','Kredit fÃ¼r Bestellung abgebrochen',0),(525384,14594,'en','Credit Canceled for Order',0),(525385,14595,'is','',0),(525386,14595,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(525387,14595,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(525388,14595,'tr','Kredi kartÄ± faturalarÄ±',0),(525389,14595,'pl','Rachunki kart kredytowych',0),(525390,14595,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð½Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸',0),(525391,14595,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø¨Ù„Ø²',0),(525392,14595,'sr','Ð Ð°Ñ‡ÑƒÐ½Ð¸ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(525393,14595,'vi','HÃ³a Ä‘Æ¡n tháº» tÃ­n dá»¥ng',0),(525394,14595,'af','Kredietkaart rekeninge',0),(525395,14595,'ro','Facturile de Card de credit',0),(525396,14595,'et','Krediitkaardi arveid',0),(525397,14595,'si','RaÄune kreditnih kartic',0),(525398,14595,'ba','Tagihan kartu kredit',0),(525399,14595,'nl','Credit Card rekeningen',0),(525400,14595,'fi','Luottokortti laskut',0),(525401,14595,'no','Kredittkort regninger',0),(525402,14595,'da','Kreditkort regninger',0),(525403,14595,'ko','ì‹ ìš© ì¹´ë“œ ì²­êµ¬ì„œ',0),(525404,14595,'he','. ×—×©×‘×•× ×•×ª ×›×¨×˜×™×¡ ×”××©×¨××™',0),(525405,14595,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŽÎ½ ÎºÎ±ÏÏ„ÏŽÎ½',0),(525406,14595,'zh','ä¿¡ç”¨å¡è´¦å•',0),(525407,14595,'sv','Kreditkort rÃ¤kningar',0),(525408,14595,'it','Fatture della carta di credito',0),(525409,14595,'tl','',0),(525410,14595,'th','à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(525411,14595,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¬à¤¿à¤²',0),(525412,14595,'ms','Bil-bil kad kredit',0),(525413,14595,'ar','ÙÙˆØ§ØªÙŠØ± Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(525414,14595,'fr','Factures de carte de crÃ©dit',0),(525415,14595,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®è«‹æ±‚æ›¸',0),(525416,14595,'pt','CartÃ£o de crÃ©dito',0),(525417,14595,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(525418,14595,'es','Tarjetas de crÃ©dito',0),(525419,14595,'de','Kreditkarten-Rechnungen',0),(525420,14595,'en','Credit Card Bills',0),(525421,14596,'is','',0),(525422,14596,'dr','ØµÙØ­Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(525423,14596,'pr','ØµÙØ­Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(525424,14596,'tr','Åžu anda gÃ¶sterilen sayfa',0),(525425,14596,'pl','Obecnie pokazano stronÄ™',0),(525426,14596,'bg','Ð’ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ð¿Ð¾ÐºÐ°Ð·Ð°Ð½Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(525427,14596,'ur','Ø§Ø³ ÙˆÙ‚Øª Ø¯Ú©Ú¾Ø§Ø¦Û’ ØµÙØ­Û',0),(525428,14596,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(525429,14596,'vi','Hiá»‡n nay Hiá»ƒn thá»‹ trang',0),(525430,14596,'af','Tans aangetoon bladsy',0),(525431,14596,'ro','ÃŽn prezent prezentate filme',0),(525432,14596,'et','Praegu kuvatakse leht',0),(525433,14596,'si','Trenutno prikazano stran',0),(525434,14596,'ba','Saat ini ditampilkan Halaman',0),(525435,14596,'nl','Op dit moment weergegeven pagina',0),(525436,14596,'fi','TÃ¤llÃ¤hetkellÃ¤ nÃ¤kyvissÃ¤ sivun',0),(525437,14596,'no','Gjeldende viste siden',0),(525438,14596,'da','Aktuelt viste side',0),(525439,14596,'ko','í˜„ìž¬ í‘œì‹œ ëœ íŽ˜ì´ì§€',0),(525440,14596,'he','×“×£ ×”×ž×•×¦×’×ª ×›×¢×ª',0),(525441,14596,'el','Î•Î¼Ï†Î±Î½Î¹Î¶ÏŒÎ¼ÎµÎ½Î· ÏƒÎµÎ»Î¯Î´Î±',0),(525442,14596,'zh','å½“å‰æ˜¾ç¤ºçš„é¡µ',0),(525443,14596,'sv','FÃ¶r nÃ¤rvarande visas sidan',0),(525444,14596,'it','Pagina attualmente visualizzata',0),(525445,14596,'tl','',0),(525446,14596,'th','à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¹à¸ªà¸”à¸‡à¸«à¸™à¹‰à¸²',0),(525447,14596,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¦à¤¿à¤–à¤¾à¤ à¤—à¤ à¤ªà¥ƒà¤·à¥à¤ ',0),(525448,14596,'ms','Laman sedang ditunjukkan',0),(525449,14596,'ar','Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ù…Ø¹Ø±ÙˆØ¶Ø© Ø­Ø§Ù„ÙŠØ§',0),(525450,14596,'fr','Page actuellement affichÃ©e',0),(525451,14596,'jp','ç¾åœ¨è¡¨ç¤ºã•ã‚Œã¦ã„ã‚‹ãƒšãƒ¼ã‚¸',0),(525452,14596,'pt','PÃ¡gina atualmente mostrada.',0),(525453,14596,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°ÐµÑ‚ÑÑ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(525454,14596,'es','Actualmente se muestra pÃ¡gina',0),(525455,14596,'de','Aktuell angezeigte Seite',0),(525456,14596,'en','Currently Shown Page',0),(525457,14597,'is','',0),(525458,14597,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¯Ø§Ø´Ø¨ÙˆØ±Ø¯',0),(525459,14597,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¯Ø§Ø´Ø¨ÙˆØ±Ø¯',0),(525460,14597,'tr','GÃ¶sterge Tablosu raporu',0),(525461,14597,'pl','Panel raport',0),(525462,14597,'bg','Ð¢Ð°Ð±Ð»Ð¾ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(525463,14597,'ur','ÚˆÛŒØ´ Ø¨ÙˆØ±Úˆ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(525464,14597,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ñ‚Ð°Ð±Ð»Ðµ',0),(525465,14597,'vi','Báº£ng bÃ¡o cÃ¡o',0),(525466,14597,'af','Dashboard verslag',0),(525467,14597,'ro','Tablou de bord raport',0),(525468,14597,'et','Armatuurlaua aruanne',0),(525469,14597,'si','PoroÄilo nadzorne ploÅ¡Äe',0),(525470,14597,'ba','Laporan dasbor',0),(525471,14597,'nl','Dashboardrapport',0),(525472,14597,'fi','TiivistelmÃ¤raporttina',0),(525473,14597,'no','Instrumentbordrapport',0),(525474,14597,'da','InstrumentbrÃ¦trapport',0),(525475,14597,'ko','ëŒ€ì‹œë³´ë“œ ë³´ê³ ì„œ',0),(525476,14597,'he','×“×•×— ×œ×•×— ×”×ž×—×•×•× ×™×',0),(525477,14597,'el','Î¤Î±Î¼Ï€Î»ÏŒ Î­ÎºÎ¸ÎµÏƒÎ·',0),(525478,14597,'zh','ä»ªè¡¨æ¿æŠ¥è¡¨',0),(525479,14597,'sv','Instrumentpanelsrapport',0),(525480,14597,'it','Cruscotto Report',0),(525481,14597,'tl','',0),(525482,14597,'th','à¹à¸”à¹Šà¸Š',0),(525483,14597,'hi','à¤¡à¥ˆà¤¶à¤¬à¥‹à¤°à¥à¤¡ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(525484,14597,'ms','Papan pemuka Laporan',0),(525485,14597,'ar','ØªÙ‚Ø±ÙŠØ± Ù„ÙˆØ­Ø© Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(525486,14597,'fr','Rapport de tableau de bord',0),(525487,14597,'jp','ãƒ€ãƒƒã‚·ãƒ¥ ãƒœãƒ¼ãƒ‰ã®ãƒ¬ãƒãƒ¼ãƒˆ',0),(525488,14597,'pt','RelatÃ³rio do painel de controle',0),(525489,14597,'ru','ÐŸÐ°Ð½ÐµÐ»ÑŒ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(525490,14597,'es','Informe del tablero de instrumentos',0),(525491,14597,'de','Dashboardbericht',0),(525492,14597,'en','Dashboard Report',0),(525493,14598,'is','',0),(525494,14598,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø®ÙˆØ¯Ú©Ø§Ø± ÙØ§Ú©ØªÙˆØ±',0),(525495,14598,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø®ÙˆØ¯Ú©Ø§Ø± ÙØ§Ú©ØªÙˆØ±',0),(525496,14598,'tr','VarsayÄ±lan Fatura e-posta ÅŸablonu otomatik',0),(525497,14598,'pl','DomyÅ›lny szablon wiadomoÅ›ci E-mail zautomatyzowane faktury',0),(525498,14598,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÐ½ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð¼ÐµÐ¹Ð» ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(525499,14598,'ur','Ø®ÙˆØ¯ Ú©Ø§Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§ÛŒ Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Ø§ Ø·Û’ Ø´Ø¯Û',0),(525500,14598,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ðµ-Ð¿Ð¾Ñ€ÑƒÐºÐµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(525501,14598,'vi','Máº·c Ä‘á»‹nh tá»± Ä‘á»™ng hÃ³a Ä‘Æ¡n thÆ° Ä‘iá»‡n tá»­ máº«u',0),(525502,14598,'af','Verstek geoutomatiseerde faktuur e-pos sjabloon',0),(525503,14598,'ro','Implicit automat factura E-mail ÅŸablon',0),(525504,14598,'et','Vaikimisi Automated arvelt meilisÃµnumimallid',0),(525505,14598,'si','Privzeto avtomatska raÄuna Email predloga',0),(525506,14598,'ba','Invoice otomatis Email Template default',0),(525507,14598,'nl','Standaard geautomatiseerde e-mailtemplate voor factuur',0),(525508,14598,'fi','Oletus laskujen automaattinen sÃ¤hkÃ¶postimalli',0),(525509,14598,'no','Standard automatisert faktura e-mal',0),(525510,14598,'da','Standard automatiseret faktura E-mail-skabelon',0),(525511,14598,'ko','ê¸°ë³¸ ìžë™ ì†¡ìž¥ ì´ë©”ì¼ í…œí”Œë¦¿',0),(525512,14598,'he','×‘×¨×™×¨×ª ×ž×—×“×œ ×ª×‘× ×™×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™ ×—×©×‘×•× ×™×ª ××•×˜×•×ž×˜×™×ª',0),(525513,14598,'el','Î ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î±Ï…Ï„Î¿Î¼Î±Ï„Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(525514,14598,'zh','é»˜è®¤è‡ªåŠ¨å‘ç¥¨ç”µå­é‚®ä»¶æ¨¡æ¿',0),(525515,14598,'sv','Standard automatisk faktura e-mall',0),(525516,14598,'it','Predefinito automatico modello E-mail fattura',0),(525517,14598,'tl','',0),(525518,14598,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥',0),(525519,14598,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤ˆà¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤',0),(525520,14598,'ms','Default Template e-mel automatik invois',0),(525521,14598,'ar','Ù‚Ø§Ù„Ø¨ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¢Ù„ÙŠ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(525522,14598,'fr','Par dÃ©faut le modÃ¨le de courriel automatisÃ© de facture',0),(525523,14598,'jp','æ—¢å®šã®è‡ªå‹•è«‹æ±‚æ›¸é›»å­ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ',0),(525524,14598,'pt','PadrÃ£o de modelo de Email automatizado factura',0),(525525,14598,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð° ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(525526,14598,'es','Por defecto la plantilla de correo electrÃ³nico automatizado factura',0),(525527,14598,'de','Standard-automatisierte E-Mail-Rechnungsvorlage',0),(525528,14598,'en','Default Automated Invoice Email Template',0),(525529,14599,'is','',0),(525530,14599,'dr','Reconciliations Ø¨Ø§Ù†Ú© ÙˆÛŒØ±Ø§ÛŒØ´',0),(525531,14599,'pr','Reconciliations Ø¨Ø§Ù†Ú© ÙˆÛŒØ±Ø§ÛŒØ´',0),(525532,14599,'tr','DÃ¼zenle banka mutabakatlarÄ±',0),(525533,14599,'pl','Uzgodnienia bankowe edycja',0),(525534,14599,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ ÑÑŠÐ¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(525535,14599,'ur','ØªØ¯ÙˆÛŒÙ† Ø¨ÛŒÙ†Ú© Ø±ÛŒÚ©ÙˆÙ†Ú©Ø§Ù„ÛŒØ§Ù¹Ø§Ù†Ø³',0),(525536,14599,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑÑ€Ð°Ð²ÑšÐµÑšÐµ',0),(525537,14599,'vi','Chá»‰nh sá»­a ngÃ¢n hÃ ng Reconciliations',0),(525538,14599,'af','Redigeer Bank Reconciliations',0),(525539,14599,'ro','Reconcilieri bancare de editare',0),(525540,14599,'et','Redigeeri pangakontode sobitamise',0),(525541,14599,'si','Urejanje banÄnega usklajevanja',0),(525542,14599,'ba','Edit Bank rekonsiliasi',0),(525543,14599,'nl','Bankreconciliaties bewerken',0),(525544,14599,'fi','Muokkaa pankkitilin tÃ¤smÃ¤ytykset',0),(525545,14599,'no','Rediger bankavstemminger',0),(525546,14599,'da','Rediger bankafstemninger',0),(525547,14599,'ko','íŽ¸ì§‘ ì€í–‰ ì¡°ì •',0),(525548,14599,'he','×”×ª××ž×•×ª ×‘× ×§ ×¢×¨×™×›×”',0),(525549,14599,'el','Î£Ï…Î¼Ï†Ï‰Î½Î¹ÏŽÎ½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŽÎ½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(525550,14599,'zh','ç¼–è¾‘é“¶è¡Œå¯¹è´¦',0),(525551,14599,'sv','Redigera bankkontoavstÃ¤mningar',0),(525552,14599,'it','Riconciliazioni bancarie modifica',0),(525553,14599,'tl','',0),(525554,14599,'th','à¸à¸£à¸°à¸—à¸šà¸¢à¸­à¸” à¸˜à¸™à¸²à¸„à¸²à¸£à¹à¸à¹‰à¹„à¸‚',0),(525555,14599,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤¬à¥ˆà¤‚à¤• Reconciliations',0),(525556,14599,'ms','Penyesuaian Edit Bank',0),(525557,14599,'ar','ØªØ­Ø±ÙŠØ± Ù…ØµØ±Ù Ø§Ù„ØªØ³ÙˆÙŠØ§Øª',0),(525558,14599,'fr','Rapprochements bancaires Edit',0),(525559,14599,'jp','ç·¨é›†éŠ€è¡Œå‹˜å®šèª¿æ•´',0),(525560,14599,'pt','ConciliaÃ§Ãµes bancÃ¡rias Edit',0),(525561,14599,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(525562,14599,'es','Conciliaciones bancarias editar',0),(525563,14599,'de','Bearbeiten Bank Abstimmungen',0),(525564,14599,'en','Edit Bank Reconciliations',0),(525565,14600,'is','',0),(525566,14600,'dr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ',0),(525567,14600,'pr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ',0),(525568,14600,'tr','GiriÅŸler',0),(525569,14600,'pl','Wpisy',0),(525570,14600,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸',0),(525571,14600,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(525572,14600,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ',0),(525573,14600,'vi','Má»¥c',0),(525574,14600,'af','Inskrywings',0),(525575,14600,'ro','IntrÄƒri',0),(525576,14600,'et','Kanded',0),(525577,14600,'si','Postavke',0),(525578,14600,'ba','Entri',0),(525579,14600,'nl','Posten',0),(525580,14600,'fi','Tapahtumat',0),(525581,14600,'no','OppfÃ¸ringer',0),(525582,14600,'da','Poster',0),(525583,14600,'ko','í•­ëª©',0),(525584,14600,'he','×¢×¨×›×™',0),(525585,14600,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(525586,14600,'zh','æ¡ç›®',0),(525587,14600,'sv','Poster',0),(525588,14600,'it','Voci',0),(525589,14600,'tl','',0),(525590,14600,'th','à¸£à¸²à¸¢à¸à¸²à¸£',0),(525591,14600,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(525592,14600,'ms','Penyertaan',0),(525593,14600,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª',0),(525594,14600,'fr','EntrÃ©es',0),(525595,14600,'jp','ã‚¨ãƒ³ãƒˆãƒª',0),(525596,14600,'pt','Entradas',0),(525597,14600,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸',0),(525598,14600,'es','Entradas',0),(525599,14600,'de','EintrÃ¤ge',0),(525600,14600,'en','Entries',0),(525601,14601,'is','',0),(525602,14601,'dr','Ù…Ø­Ø±ÙˆÙ… Ú©Ø±Ø¯Ù† Ø§Ø² Ø¯Ø±Ø¬Ù‡ Ø§Ø¹ØªØ¨Ø§Ø± Ø³Ø§Ù‚Ø·',0),(525603,14601,'pr','Ù…Ø­Ø±ÙˆÙ… Ú©Ø±Ø¯Ù† Ø§Ø² Ø¯Ø±Ø¬Ù‡ Ø§Ø¹ØªØ¨Ø§Ø± Ø³Ø§Ù‚Ø·',0),(525604,14601,'tr','Void dÄ±ÅŸla',0),(525605,14601,'pl','WykluczyÄ‡ Void',0),(525606,14601,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð¸ Void',0),(525607,14601,'ur','Ø¨Û’ Ø¹Ù‚Ù„ Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(525608,14601,'sr','Ð˜Ð·ÑƒÐ·Ð¼Ð¸ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ñƒ',0),(525609,14601,'vi','Loáº¡i trá»« cÃ¡c Void',0),(525610,14601,'af','Leemte uitsluit',0),(525611,14601,'ro','Exclude Void',0),(525612,14601,'et','VÃ¤listada Void',0),(525613,14601,'si','IzkljuÄi praznino',0),(525614,14601,'ba','Mengecualikan kekosongan',0),(525615,14601,'nl','Void uitsluiten',0),(525616,14601,'fi','JÃ¤ttÃ¤Ã¤ Void',0),(525617,14601,'no','Utelate Void',0),(525618,14601,'da','Udelukke tomrum',0),(525619,14601,'ko','ê³µ í—ˆë¥¼ ì œì™¸',0),(525620,14601,'he','×œ× ×œ×›×œ×•×œ ×—×œ×œ ×¨×™×§',0),(525621,14601,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¯ÏƒÎµÎ¹ ÎºÎµÎ½ÏŒ',0),(525622,14601,'zh','æŽ’é™¤è™šç©º',0),(525623,14601,'sv','Utesluta Void',0),(525624,14601,'it','Escludere Void',0),(525625,14601,'tl','',0),(525626,14601,'th','à¹à¸¢à¸à¹‚à¸¡à¸†à¸°',0),(525627,14601,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¥‹ à¤¬à¤¾à¤¹à¤°',0),(525628,14601,'ms','Kekosongan ini tidak termasuk',0),(525629,14601,'ar','Ø§Ø³ØªØ¨Ø¹Ø§Ø¯ Ø§Ù„ÙØ±Ø§Øº',0),(525630,14601,'fr','Exclure vide',0),(525631,14601,'jp','Void ã‚’é™¤å¤–ã—ã¾ã™ã€‚',0),(525632,14601,'pt','Excluir vazio',0),(525633,14601,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡Ð°ÐµÑ‚ Void',0),(525634,14601,'es','Excluir vacÃ­o',0),(525635,14601,'de','Void ausschlieÃŸen',0),(525636,14601,'en','Exclude Void',0),(525637,14602,'is','',0),(525638,14602,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø®Ø§Ù†Ù‡',0),(525639,14602,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø®Ø§Ù†Ù‡',0),(525640,14602,'tr','Giderleri ev',0),(525641,14602,'pl','Koszty domu',0),(525642,14602,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð´Ð¾Ð¼',0),(525643,14602,'ur','Ú¯Ú¾Ø± Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(525644,14602,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð´Ð¾Ð¼',0),(525645,14602,'vi','Chi phÃ­ nhÃ ',0),(525646,14602,'af','Uitgawes huis',0),(525647,14602,'ro','Cheltuielile de acasÄƒ',0),(525648,14602,'et','Kulud kodu',0),(525649,14602,'si','StroÅ¡ki doma',0),(525650,14602,'ba','Biaya rumah',0),(525651,14602,'nl','Kosten Home',0),(525652,14602,'fi','Kulut kotiin',0),(525653,14602,'no','Utgifter hjem',0),(525654,14602,'da','Udgifter hjem',0),(525655,14602,'ko','ë¹„ìš© ê°€ì •',0),(525656,14602,'he','×”×•×¦××•×ª ×”×‘×™×ª',0),(525657,14602,'el','ÎˆÎ¾Î¿Î´Î± ÏƒÏ€Î¯Ï„Î¹',0),(525658,14602,'zh','è´¹ç”¨çš„å®¶',0),(525659,14602,'sv','Kostnader hem',0),(525660,14602,'it','Le spese di casa',0),(525661,14602,'tl','',0),(525662,14602,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¹ƒà¸™à¸šà¹‰à¸²à¸™',0),(525663,14602,'hi','à¤µà¥à¤¯à¤¯ à¤˜à¤°',0),(525664,14602,'ms','Perbelanjaan rumah',0),(525665,14602,'ar','Ù†ÙÙ‚Ø§Øª Ø§Ù„Ù…Ù†Ø²Ù„',0),(525666,14602,'fr','Frais maison',0),(525667,14602,'jp','è²»ç”¨ã®å®¶',0),(525668,14602,'pt','As despesas de casa',0),(525669,14602,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð´Ð¾Ð¼Ð°',0),(525670,14602,'es','Gastos de casa',0),(525671,14602,'de','Aufwendungen-Startseite',0),(525672,14602,'en','Expenses Home',0),(525673,14603,'is','',0),(525674,14603,'dr','Ø§Ø² ÙÛŒÙ„ØªØ±',0),(525675,14603,'pr','Ø§Ø² ÙÛŒÙ„ØªØ±',0),(525676,14603,'tr','Filtre',0),(525677,14603,'pl','Filtrowane z',0),(525678,14603,'bg','Ð¤Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¾Ñ‚',0),(525679,14603,'ur','Ø³Û’ ÙÙ„Ù¹Ø± Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(525680,14603,'sr','Ð¤Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¸Ð·',0),(525681,14603,'vi','Lá»c tá»«',0),(525682,14603,'af','Gefiltreer uit',0),(525683,14603,'ro','Filtrat din',0),(525684,14603,'et','Filtreeritud',0),(525685,14603,'si','IzloÄeni iz',0),(525686,14603,'ba','Disaring dari',0),(525687,14603,'nl','Uit gefilterd',0),(525688,14603,'fi','Suodatettu',0),(525689,14603,'no','Filtrert fra',0),(525690,14603,'da','Filtreret fra',0),(525691,14603,'ko','í•„í„°ë§',0),(525692,14603,'he','×¡×™× ×•×Ÿ ×ž',0),(525693,14603,'el','Î¦Î¹Î»Ï„ÏÎ¬ÏÎµÏ„Î±Î¹ Î±Ï€ÏŒ',0),(525694,14603,'zh','ä»Žè¿‡æ»¤',0),(525695,14603,'sv','Filtreras frÃ¥n',0),(525696,14603,'it','Filtrata da',0),(525697,14603,'tl','',0),(525698,14603,'th','à¸à¸£à¸­à¸‡à¸ˆà¸²à¸',0),(525699,14603,'hi','à¤¸à¥‡ à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤° à¤•à¤¿à¤ à¤—à¤',0),(525700,14603,'ms','Ditapis daripada',0),(525701,14603,'ar','ØªØµÙÙŠØªÙ‡Ø§ Ù…Ù†',0),(525702,14603,'fr','FiltrÃ©es Ã  partir de',0),(525703,14603,'jp','ã‚’é™¤å¤–',0),(525704,14603,'pt','Filtrado do',0),(525705,14603,'ru','ÐžÑ‚Ñ„Ð¸Ð»ÑŒÑ‚Ñ€Ð¾Ð²Ñ‹Ð²Ð°ÑŽÑ‚ÑÑ Ð¸Ð·',0),(525706,14603,'es','Filtrado de',0),(525707,14603,'de','Von gefiltert',0),(525708,14603,'en','Filtered From',0),(525709,14604,'is','',0),(525710,14604,'dr','Tline Ø¯Ù¾Ùˆ',0),(525711,14604,'pr','Tline Ø¯Ù¾Ùˆ',0),(525712,14604,'tr','Firs gerÃ§ekleÅŸen',0),(525713,14604,'pl','Tline jodÅ‚y',0),(525714,14604,'bg','Ð•Ð»Ð¸ Tline',0),(525715,14604,'ur','Ø§ÛŒÙ Ø¢Ø¦ÛŒ Ø¢Ø± Ø¯Ø±Ø¬ Ù¹Ù„Ø§Ù†Ø§',0),(525716,14604,'sr','ÐŸÑ€Ð²Ð¾ Ð¢Ð»Ð¸Ð½Ðµ',0),(525717,14604,'vi','Sam Tline',0),(525718,14604,'af','Firs Tline',0),(525719,14604,'ro','Brazi Tline',0),(525720,14604,'et','Kuuske Tline',0),(525721,14604,'si','Tline smrek',0),(525722,14604,'ba','Cemara Tline',0),(525723,14604,'nl','Sparren Tline',0),(525724,14604,'fi','Kuusien Tline',0),(525725,14604,'no','FÃ¸rste Tline',0),(525726,14604,'da','Firs Tline',0),(525727,14604,'ko','ì „ë‚˜ë¬´ Tline',0),(525728,14604,'he','Tline ×”××©×•×—×™×',0),(525729,14604,'el','Tline Î­Î»Î±Ï„Î±',0),(525730,14604,'zh','å†·æ‰ Tline',0),(525731,14604,'sv','Firs Tline',0),(525732,14604,'it','Abeti Tline',0),(525733,14604,'tl','',0),(525734,14604,'th','à¹‚à¸£à¸‡à¹à¸£à¸¡à¹€à¸Ÿà¸­à¸£à¹Œà¸ªà¸¥à¹‡à¸­à¸”à¸ˆà¹Œ Tline',0),(525735,14604,'hi','à¤à¤«à¤†à¤‡à¤†à¤° Tline',0),(525736,14604,'ms','Firs Tline',0),(525737,14604,'ar','Ø§Ù„ØªÙ†ÙˆØ¨ ØªÙ„ÙŠÙ†ÙŠ',0),(525738,14604,'fr','Illll sapins',0),(525739,14604,'jp','ã‚‚ã¿ Tline',0),(525740,14604,'pt','Tline abetos',0),(525741,14604,'ru','Ð•Ð»Ð¸ Tline',0),(525742,14604,'es','Abetos Tline',0),(525743,14604,'de','Tannen Tline',0),(525744,14604,'en','Firs Tline',0),(525745,14605,'is','',0),(525746,14605,'dr','Ú©Ø±ÙˆÙ… Ø¯Ø±ÛŒØ§ÙØª',0),(525747,14605,'pr','Ú©Ø±ÙˆÙ… Ø¯Ø±ÛŒØ§ÙØª',0),(525748,14605,'tr','Krom alÄ±n',0),(525749,14605,'pl','Pobierz Chrome',0),(525750,14605,'bg','Ð’Ð·ÐµÐ¼Ð¸ Ñ…Ñ€Ð¾Ð¼',0),(525751,14605,'ur','Ú©Ø±ÙˆÙ… Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(525752,14605,'sr','Ð”Ð¾Ð±Ð¸Ñ‚Ð¸ Ñ…Ñ€Ð¾Ð¼Ð°',0),(525753,14605,'vi','CÃ³ Ä‘Æ°á»£c Chrome',0),(525754,14605,'af','Kry Chrome',0),(525755,14605,'ro','Ia crom',0),(525756,14605,'et','Chrome saada',0),(525757,14605,'si','Dobili Chrome',0),(525758,14605,'ba','Mendapatkan Chrome',0),(525759,14605,'nl','Get Chrome',0),(525760,14605,'fi','Hanki kromi',0),(525761,14605,'no','FÃ¥ krom',0),(525762,14605,'da','FÃ¥ krom',0),(525763,14605,'ko','í¬ë¡¬',0),(525764,14605,'he','×œ×§×‘×œ ×›×¨×•×',0),(525765,14605,'el','Î Î¬ÏÎµÏ„Îµ Ï‡ÏÏŽÎ¼Î¹Î¿',0),(525766,14605,'zh','è®© Chrome',0),(525767,14605,'sv','FÃ¥ Chrome',0),(525768,14605,'it','Ottenere cromo',0),(525769,14605,'tl','',0),(525770,14605,'th','à¸£à¸±à¸šà¹‚à¸„à¸£à¹€à¸¡à¸µà¹ˆà¸¢à¸¡',0),(525771,14605,'hi','à¤•à¥à¤°à¥‹à¤® à¤®à¤¿à¤²',0),(525772,14605,'ms','Mendapatkan Chrome',0),(525773,14605,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø§Ù„ÙƒØ±ÙˆÙ…',0),(525774,14605,'fr','TÃ©lÃ©chargez Chrome',0),(525775,14605,'jp','ã‚¯ãƒ­ãƒ ã‚’å¾—ã‚‹',0),(525776,14605,'pt','Obter Chrome',0),(525777,14605,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ñ…Ñ€Ð¾Ð¼',0),(525778,14605,'es','Obtener cromo',0),(525779,14605,'de','Chrome zu erhalten',0),(525780,14605,'en','Get Chrome',0),(525781,14606,'is','',0),(525782,14606,'dr','Ù‡Ø¯Ø±',0),(525783,14606,'pr','Ù‡Ø¯Ø±',0),(525784,14606,'tr','BaÅŸlÄ±k',0),(525785,14606,'pl','NagÅ‚Ã³wek',0),(525786,14606,'bg','Ð“Ð¾Ñ€ÐµÐ½',0),(525787,14606,'ur','Ø³Ø±ØªØ­Ø±ÛŒØ±',0),(525788,14606,'sr','Ð—Ð°Ð³Ð»Ð°Ð²Ñ™Ðµ',0),(525789,14606,'vi','TiÃªu Ä‘á»',0),(525790,14606,'af','Dekblad',0),(525791,14606,'ro','Antet',0),(525792,14606,'et','PÃ¤is',0),(525793,14606,'si','Glava',0),(525794,14606,'ba','Header',0),(525795,14606,'nl','Koptekst',0),(525796,14606,'fi','Otsikko',0),(525797,14606,'no','Topptekst',0),(525798,14606,'da','Header',0),(525799,14606,'ko','í—¤ë”',0),(525800,14606,'he','×›×•×ª×¨×ª',0),(525801,14606,'el','ÎšÎµÏ†Î±Î»Î¯Î´Î±',0),(525802,14606,'zh','æ ‡å¤´',0),(525803,14606,'sv','Sidhuvud',0),(525804,14606,'it','Intestazione',0),(525805,14606,'tl','',0),(525806,14606,'th','à¸«à¸±à¸§à¸‚à¹‰à¸­',0),(525807,14606,'hi','à¤¶à¥€à¤°à¥à¤· à¤²à¥‡à¤–',0),(525808,14606,'ms','Pengepala',0),(525809,14606,'ar','Ø±Ø£Ø³',0),(525810,14606,'fr','En-tÃªte',0),(525811,14606,'jp','ãƒ˜ãƒƒãƒ€ãƒ¼',0),(525812,14606,'pt','CabeÃ§alho',0),(525813,14606,'ru','Ð—Ð°Ð³Ð¾Ð»Ð¾Ð²Ð¾Ðº',0),(525814,14606,'es','Cabecera',0),(525815,14606,'de','Header',0),(525816,14606,'en','Header',0),(525817,14607,'is','',0),(525818,14607,'dr','Ø¨Ø±Ø¬Ø³ØªÙ‡ Ú©Ø±Ø¯Ù†',0),(525819,14607,'pr','Ø¨Ø±Ø¬Ø³ØªÙ‡ Ú©Ø±Ø¯Ù†',0),(525820,14607,'tr','Vurgulama',0),(525821,14607,'pl','PodÅ›wietl',0),(525822,14607,'bg','ÐœÐ°Ñ€ÐºÐ¸Ñ€Ð°Ð¹Ñ‚Ðµ',0),(525823,14607,'ur','Ù†Ù…Ø§ÛŒØ§Úº Ú©Ø±ÛŒÚº',0),(525824,14607,'sr','Ð˜ÑÑ‚Ð¸Ñ†Ð°ÑšÐµ',0),(525825,14607,'vi','Äiá»ƒm ná»•i báº­t',0),(525826,14607,'af','Beklemtoon',0),(525827,14607,'ro','EvidenÅ£ia',0),(525828,14607,'et','TÃµsta esile',0),(525829,14607,'si','Vrhunec',0),(525830,14607,'ba','Sorot',0),(525831,14607,'nl','Hoogtepunt',0),(525832,14607,'fi','Korosta',0),(525833,14607,'no','HÃ¸ydepunkt',0),(525834,14607,'da','FremhÃ¦ve',0),(525835,14607,'ko','ê°•ì¡° í‘œì‹œ',0),(525836,14607,'he','×”××¨',0),(525837,14607,'el','ÎšÏ…ÏÎ¹ÏŽÏ„ÎµÏÎ¿ ÏƒÎ·Î¼ÎµÎ¯Î¿',0),(525838,14607,'zh','çªå‡ºæ˜¾ç¤º',0),(525839,14607,'sv','Markera',0),(525840,14607,'it','Evidenziare',0),(525841,14607,'tl','',0),(525842,14607,'th','à¹€à¸™à¹‰à¸™',0),(525843,14607,'hi','à¤¹à¤¾à¤‡à¤²à¤¾à¤‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(525844,14607,'ms','Acara kemuncak',0),(525845,14607,'ar','ØªØ³Ù„ÙŠØ· Ø§Ù„Ø¶ÙˆØ¡ Ø¹Ù„Ù‰',0),(525846,14607,'fr','Mettez en surbrillance',0),(525847,14607,'jp','ãƒã‚¤ãƒ©ã‚¤ãƒˆ',0),(525848,14607,'pt','Destaque',0),(525849,14607,'ru','Ð“Ð¾Ð»Ñ‹',0),(525850,14607,'es','Punto culminante',0),(525851,14607,'de','Markieren',0),(525852,14607,'en','Highlight',0),(525853,14608,'is','',0),(525854,14608,'dr','Ù…ØªÙ† Ø¨Ø±Ø¬Ø³ØªÙ‡',0),(525855,14608,'pr','Ù…ØªÙ† Ø¨Ø±Ø¬Ø³ØªÙ‡',0),(525856,14608,'tr','Metni vurgulama',0),(525857,14608,'pl','Zaznacz tekst',0),(525858,14608,'bg','ÐžÑÐ²ÐµÑ‚ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐºÑÑ‚',0),(525859,14608,'ur','Ù…ØªÙ† Ú©Ùˆ Ù†Ù…Ø§ÛŒØ§Úº Ú©Ø±ÛŒÚº',0),(525860,14608,'sr','Ð˜ÑÑ‚Ð¸Ñ†Ð°ÑšÐµ Ñ‚ÐµÐºÑÑ‚Ð°',0),(525861,14608,'vi','Highlight Text',0),(525862,14608,'af','Teks beklemtoon',0),(525863,14608,'ro','EvidenÅ£iaÅ£i textul',0),(525864,14608,'et','TÃµstke tekst esile',0),(525865,14608,'si','OznaÄite besedilo',0),(525866,14608,'ba','Sorot teks',0),(525867,14608,'nl','Tekst markeren',0),(525868,14608,'fi','Korosta teksti',0),(525869,14608,'no','Utheve tekst',0),(525870,14608,'da','FremhÃ¦ve tekst',0),(525871,14608,'ko','í…ìŠ¤íŠ¸ ê°•ì¡° í‘œì‹œ',0),(525872,14608,'he','×œ×¡×ž×Ÿ ×˜×§×¡×˜',0),(525873,14608,'el','Î•Ï€Î¹ÏƒÎ®Î¼Î±Î½ÏƒÎ· Ï„Î¿Ï… ÎºÎµÎ¹Î¼Î­Î½Î¿Ï…',0),(525874,14608,'zh','çªå‡ºæ˜¾ç¤ºæ–‡æœ¬',0),(525875,14608,'sv','Markera Text',0),(525876,14608,'it','Evidenziare il testo',0),(525877,14608,'tl','',0),(525878,14608,'th','à¹€à¸™à¹‰à¸™à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡',0),(525879,14608,'hi','à¤ªà¤¾à¤  à¤¹à¤¾à¤‡à¤²à¤¾à¤‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(525880,14608,'ms','Menyerlahkan teks',0),(525881,14608,'ar','Ù‚Ù… Ø¨ØªÙ…ÙŠÙŠØ² Ø§Ù„Ù†Øµ',0),(525882,14608,'fr','Mettez en surbrillance de texte',0),(525883,14608,'jp','ãƒ†ã‚­ã‚¹ãƒˆã‚’å¼·èª¿è¡¨ç¤ºã—ã¾ã™ã€‚',0),(525884,14608,'pt','RealÃ§ar texto',0),(525885,14608,'ru','Ð’Ñ‹Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ñ‚ÐµÐºÑÑ‚',0),(525886,14608,'es','Resaltar texto',0),(525887,14608,'de','Hervorheben von Text',0),(525888,14608,'en','Highlight Text',0),(525889,14609,'is','',0),(525890,14609,'dr','Ú¯Ø²Ø§Ø±Ø´ Homeboard',0),(525891,14609,'pr','Ú¯Ø²Ø§Ø±Ø´ Homeboard',0),(525892,14609,'tr','PullarÄ±nÄ± raporlarÄ±',0),(525893,14609,'pl','Homeboard raporty',0),(525894,14609,'bg','Homeboard Ð´Ð¾ÐºÐ»Ð°Ð´Ð¸',0),(525895,14609,'ur','ÛÙˆÙ…ÛŒØ¨ÙˆØ¢Ø±Ø¯ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(525896,14609,'sr','Ð¥Ð¾Ð¼ÐµÐ±Ð¾Ð°Ñ€Ð´ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(525897,14609,'vi','Homeboard bÃ¡o cÃ¡o',0),(525898,14609,'af','Homeboard verslae',0),(525899,14609,'ro','Homeboard rapoarte',0),(525900,14609,'et','Homeboard aruanded',0),(525901,14609,'si','Homeboard poroÄila',0),(525902,14609,'ba','Homeboard laporan',0),(525903,14609,'nl','Homeboard rapporten',0),(525904,14609,'fi','Homeboard raportit',0),(525905,14609,'no','Homeboard rapporter',0),(525906,14609,'da','Homeboard rapporter',0),(525907,14609,'ko','Homeboard ë³´ê³ ì„œ',0),(525908,14609,'he','×“×•×—×•×ª Homeboard',0),(525909,14609,'el','Homeboard ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(525910,14609,'zh','Homeboard æŠ¥å‘Š',0),(525911,14609,'sv','Homeboard rapporter',0),(525912,14609,'it','Rapporti Homeboard',0),(525913,14609,'tl','',0),(525914,14609,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™ Homeboard',0),(525915,14609,'hi','Homeboard à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(525916,14609,'ms','Laporan Homeboard',0),(525917,14609,'ar','ØªÙ‚Ø§Ø±ÙŠØ± Ù‡ÙˆÙ…ÙŠØ¨ÙˆØ§Ø±Ø¯',0),(525918,14609,'fr','Rapports homeboard',0),(525919,14609,'jp','Homeboard ãƒ¬ãƒãƒ¼ãƒˆ',0),(525920,14609,'pt','RelatÃ³rios homeboard',0),(525921,14609,'ru','Homeboard Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹',0),(525922,14609,'es','Informes Homeboard',0),(525923,14609,'de','Homeboard Berichte',0),(525924,14609,'en','Homeboard Reports',0),(525925,14610,'is','',0),(525926,14610,'dr','ÛŒØ¹Ù†ÛŒ Ø§Ø·Ù„Ø§Ø¹ Ø±Ø³Ø§Ù†ÛŒ Ù‚Ø¯ÛŒÙ…ÛŒ Ø§Ø³Øª',0),(525927,14610,'pr','ÛŒØ¹Ù†ÛŒ Ø§Ø·Ù„Ø§Ø¹ Ø±Ø³Ø§Ù†ÛŒ Ù‚Ø¯ÛŒÙ…ÛŒ Ø§Ø³Øª',0),(525928,14610,'tr','Yani eski gÃ¼ncelleÅŸtirme bildirimi olduÄŸunu',0),(525929,14610,'pl','Czyli jest stary uaktualniÃ¦ zawiadomienie',0),(525930,14610,'bg','Ð¢.Ð•. Ð• ÑÑ‚Ð°Ñ€ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ',0),(525931,14610,'ur','ÛŒØ¹Ù†ÛŒ Ù¾Ø±Ø§Ù†Û’ ØªØ¬Ø¯ÛŒØ¯ Ù†ÙˆÙ¹Ø³ ÛÛ’',0),(525932,14610,'sr','Ð˜Ð• Ñ˜Ðµ ÑÑ‚Ð°Ñ€Ð¸ Ð£Ð¿Ð´Ð°Ñ‚Ðµ Ñ€Ð¾ÐºÑƒ',0),(525933,14610,'vi','Tá»©c lÃ  lÃ  cÅ© Cáº­p nháº­t thÃ´ng bÃ¡o',0),(525934,14610,'af','IE ou bywerking kennis Is',0),(525935,14610,'ro','AdicÄƒ este vechi actualizare aviz',0),(525936,14610,'et','ST on vana Update teate',0),(525937,14610,'si','IE je stara Update obvestila',0),(525938,14610,'ba','IE adalah tua Update pemberitahuan',0),(525939,14610,'nl','IE Is oude Update kennisgeving',0),(525940,14610,'fi','ELI on vanha pÃ¤ivittÃ¤Ã¤ ilmoitus',0),(525941,14610,'no','IE er gamle oppdateringen varsel',0),(525942,14610,'da','DVS er gamle opdatering varsel',0),(525943,14610,'ko','ì¦‰ ì˜¤ëž˜ ëœ ì—…ë°ì´íŠ¸ ê³µì§€ìž…ë‹ˆë‹¤',0),(525944,14610,'he','×›×œ×•×ž×¨ ×”×•× ×”×•×“×¢×ª ×¢×“×›×•×Ÿ ×”×™×©×Ÿ',0),(525945,14610,'el','Î”Î·Î»Î±Î´Î® ÎµÎ¯Î½Î±Î¹ Ï€Î±Î»Î¹Î¬ ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Î½Î±Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³ÏŽÎ½',0),(525946,14610,'zh','å³æ˜¯æ—§çš„æ›´æ–°é€šçŸ¥',0),(525947,14610,'sv','DVS Ã¤r gamla uppdatering meddelande',0),(525948,14610,'it','CIOÃˆ Ã¨ vecchio avviso di aggiornamento',0),(525949,14610,'tl','',0),(525950,14610,'th','IE à¸ˆà¸°à¸›à¸£à¸°à¸à¸²à¸¨à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸à¹ˆà¸²',0),(525951,14610,'hi','à¤¯à¤¾à¤¨à¥€ à¤ªà¥à¤°à¤¾à¤¨à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥‚à¤šà¤¨à¤¾ à¤¹à¥ˆ',0),(525952,14610,'ms','Iaitu adalah lama Update notis',0),(525953,14610,'ar','Ø£ÙŠ Ù‡Ùˆ Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù‚Ø¯ÙŠÙ…',0),(525954,14610,'fr','C\'est Ã  dire est vieux avis de mise Ã  jour',0),(525955,14610,'jp','IE ã¯ã€å¤ã„æ›´æ–°ãƒ—ãƒ­ã‚°ãƒ©ãƒ ã®é€šçŸ¥',0),(525956,14610,'pt','Ou seja, Ã© velho aviso de atualizaÃ§Ã£o',0),(525957,14610,'ru','Ð¢Ð¾ ÐµÑÑ‚ÑŒ ÑÑ‚Ð¾ ÑÑ‚Ð°Ñ€Ñ‹Ð¹ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð± Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¸',0),(525958,14610,'es','Es decir, es viejo aviso de actualizaciÃ³n',0),(525959,14610,'de','IE ist alten Update-Benachrichtigung',0),(525960,14610,'en','IE Is Old Update Notice',0),(525961,14611,'is','',0),(525962,14611,'dr','Ø´Ø§Ù…Ù„ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(525963,14611,'pr','Ø´Ø§Ù…Ù„ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(525964,14611,'tr','Dahil silindi',0),(525965,14611,'pl','ObejmujÄ… usuniÄ™te',0),(525966,14611,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸',0),(525967,14611,'ur','Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº Ø­Ø°Ù Ø´Ø¯Û',0),(525968,14611,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(525969,14611,'vi','Bao gá»“m xÃ³a',0),(525970,14611,'af','Sluit geskrap',0),(525971,14611,'ro','Includ ÅŸters',0),(525972,14611,'et','Sisaldab kustutatud',0),(525973,14611,'si','VkljuÄujejo Ärta',0),(525974,14611,'ba','Termasuk dihapus',0),(525975,14611,'nl','Omvatten verwijderd',0),(525976,14611,'fi','Ovat poistettu',0),(525977,14611,'no','Inkluder slettet',0),(525978,14611,'da','Omfatter slettet',0),(525979,14611,'ko','í¬í•¨ ì‚­ì œ',0),(525980,14611,'he','×›×•×œ×œ×™× ×©× ×ž×—×§×•',0),(525981,14611,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯',0),(525982,14611,'zh','åŒ…æ‹¬åˆ é™¤',0),(525983,14611,'sv','Ta bort',0),(525984,14611,'it','Includere eliminati',0),(525985,14611,'tl','',0),(525986,14611,'th','à¸£à¸§à¸¡à¸¥à¸š',0),(525987,14611,'hi','à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚ à¤¹à¤Ÿà¤¾à¤ à¤—à¤',0),(525988,14611,'ms','Termasuk dihapuskan',0),(525989,14611,'ar','ÙˆØªØ´Ù…Ù„ Ø­Ø°Ù',0),(525990,14611,'fr','Inclure supprimÃ©',0),(525991,14611,'jp','å«ã‚ã‚‹å‰Šé™¤',0),(525992,14611,'pt','Incluem eliminado',0),(525993,14611,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ',0),(525994,14611,'es','Son eliminados',0),(525995,14611,'de','Enthalten gelÃ¶scht',0),(525996,14611,'en','Include Deleted',0),(525997,14612,'is','',0),(525998,14612,'dr','ØµÙØ­Ù‡ Ø§ØµÙ„ÛŒ Ø¯Ø±Ø¢Ù…Ø¯',0),(525999,14612,'pr','ØµÙØ­Ù‡ Ø§ØµÙ„ÛŒ Ø¯Ø±Ø¢Ù…Ø¯',0),(526000,14612,'tr','Gelir ev',0),(526001,14612,'pl','DochodÃ³w domu',0),(526002,14612,'bg','Ð”Ð¾Ñ…Ð¾Ð´ ÐÐ°Ñ‡Ð°Ð»Ð¾',0),(526003,14612,'ur','Ø¢Ù…Ø¯Ù†ÛŒ Ú¯Ú¾Ø±',0),(526004,14612,'sr','ÐŸÑ€Ð¸Ñ…Ð¾Ð´ Ð´Ð¾Ð¼',0),(526005,14612,'vi','Trang chá»§ thu nháº­p',0),(526006,14612,'af','Inkomste huis',0),(526007,14612,'ro','Venit acasÄƒ',0),(526008,14612,'et','Tulu kodu',0),(526009,14612,'si','Prihodke doma',0),(526010,14612,'ba','Home pendapatan',0),(526011,14612,'nl','Inkomen Home',0),(526012,14612,'fi','Tulot Etusivu',0),(526013,14612,'no','Inntekt hjem',0),(526014,14612,'da','Indkomst hjem',0),(526015,14612,'ko','ì†Œë“ í™ˆ',0),(526016,14612,'he','×”×›× ×¡×” ×”×‘×™×ª×”',0),(526017,14612,'el','Î‘ÏÏ‡Î¹ÎºÎ® ÎµÎ¹ÏƒÏŒÎ´Î·Î¼Î±',0),(526018,14612,'zh','æ”¶å…¥å®¶åº­',0),(526019,14612,'sv','Inkomst hem',0),(526020,14612,'it','Casa di reddito',0),(526021,14612,'tl','',0),(526022,14612,'th','à¸šà¹‰à¸²à¸™à¸£à¸²à¸¢à¹„à¸”à¹‰',0),(526023,14612,'hi','à¤†à¤¯ à¤˜à¤°',0),(526024,14612,'ms','Utama pendapatan',0),(526025,14612,'ar','Ø¯Ø®Ù„ Ø§Ù„Ù…Ù†Ø²Ù„',0),(526026,14612,'fr','Revenu domicile',0),(526027,14612,'jp','æ‰€å¾—ãƒ›ãƒ¼ãƒ ',0),(526028,14612,'pt','Renda de casa',0),(526029,14612,'ru','Ð”Ð¾Ñ…Ð¾Ð´ Ð´Ð¾Ð¼Ð°',0),(526030,14612,'es','Casa de renta',0),(526031,14612,'de','Einkommen-Startseite',0),(526032,14612,'en','Income Home',0),(526033,14613,'is','',0),(526034,14613,'dr','Ø¨Ù‡ Ø§Ø±Ø« Ù…ÛŒ Ø¨Ø±Ù†Ø¯',0),(526035,14613,'pr','Ø¨Ù‡ Ø§Ø±Ø« Ù…ÛŒ Ø¨Ø±Ù†Ø¯',0),(526036,14613,'tr','Devral',0),(526037,14613,'pl','Dziedziczenie',0),(526038,14613,'bg','ÐÐ°ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ',0),(526039,14613,'ur','ÙˆØ§Ø±Ø«',0),(526040,14613,'sr','ÐÐ°ÑÐ»ÐµÐ´Ð¸Ñ‚Ð¸',0),(526041,14613,'vi','Káº¿ thá»«a',0),(526042,14613,'af','Oorerf',0),(526043,14613,'ro','MoÅŸteni',0),(526044,14613,'et','PÃ¤ri',0),(526045,14613,'si','Dedovanje',0),(526046,14613,'ba','Mewarisi',0),(526047,14613,'nl','Overnemen',0),(526048,14613,'fi','Peri',0),(526049,14613,'no','Arve',0),(526050,14613,'da','Arver',0),(526051,14613,'ko','ìƒì†',0),(526052,14613,'he','×™×•×¨×©×™×',0),(526053,14613,'el','ÎšÎ»Î·ÏÎ¿Î½Î¿Î¼Î¿ÏÎ½',0),(526054,14613,'zh','ç»§æ‰¿',0),(526055,14613,'sv','Ã„rva',0),(526056,14613,'it','Ereditare',0),(526057,14613,'tl','',0),(526058,14613,'th','à¸ªà¸·à¸šà¸—à¸­à¸”',0),(526059,14613,'hi','à¤…à¤¨à¥à¤µà¤¾à¤‚à¤¶à¤¿à¤• à¤°à¥‚à¤ª à¤¸à¥‡ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(526060,14613,'ms','Mewarisi',0),(526061,14613,'ar','ÙˆØ±Ø§Ø«Ø©',0),(526062,14613,'fr','HÃ©riter',0),(526063,14613,'jp','ç¶™æ‰¿',0),(526064,14613,'pt','Herdar',0),(526065,14613,'ru','ÐÐ°ÑÐ»ÐµÐ´Ð¾Ð²Ð°Ñ‚ÑŒ',0),(526066,14613,'es','Heredar',0),(526067,14613,'de','Erben',0),(526068,14613,'en','Inherit',0),(526069,14614,'is','',0),(526070,14614,'dr','Ù…Ø±Ø² Ø¯Ø§Ø®Ù„ÛŒ',0),(526071,14614,'pr','Ù…Ø±Ø² Ø¯Ø§Ø®Ù„ÛŒ',0),(526072,14614,'tr','Ä°Ã§ kenarlÄ±k',0),(526073,14614,'pl','Granica wewnÄ™trzna',0),(526074,14614,'bg','Ð’ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð° Ð³Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(526075,14614,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ø³Ø±Ø­Ø¯',0),(526076,14614,'sr','Ð£Ð½ÑƒÑ‚Ñ€Ð°ÑˆÑšÐµ Ð¸Ð²Ð¸Ñ†Ðµ',0),(526077,14614,'vi','BÃªn trong biÃªn giá»›i',0),(526078,14614,'af','Innerlike grens',0),(526079,14614,'ro','BordurÄƒ interioarÄƒ',0),(526080,14614,'et','SisekÃ¼ljel',0),(526081,14614,'si','Notranje meje',0),(526082,14614,'ba','Batin perbatasan',0),(526083,14614,'nl','Binnenste rand',0),(526084,14614,'fi','SisÃ¤inen reunus',0),(526085,14614,'no','Indre kantlinje',0),(526086,14614,'da','Indre grÃ¦nse',0),(526087,14614,'ko','ì•ˆìª½ í…Œë‘ë¦¬',0),(526088,14614,'he','×”×’×‘×•×œ ×”×¤× ×™×ž×™',0),(526089,14614,'el','Î•ÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ¬ ÏƒÏÎ½Î¿ÏÎ±',0),(526090,14614,'zh','å†…éƒ¨è¾¹æ¡†',0),(526091,14614,'sv','Inre grÃ¤nsen',0),(526092,14614,'it','Bordo interno',0),(526093,14614,'tl','',0),(526094,14614,'th','à¹€à¸ªà¹‰à¸™à¸‚à¸­à¸šà¸ à¸²à¸¢à¹ƒà¸™',0),(526095,14614,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¬à¥‰à¤°à¥à¤¡à¤°',0),(526096,14614,'ms','Dalam sempadan',0),(526097,14614,'ar','Ø§Ù„Ø­Ø¯ÙˆØ¯ Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(526098,14614,'fr','FrontiÃ¨re intÃ©rieure',0),(526099,14614,'jp','å†…å´ã®å¢ƒç•Œç·š',0),(526100,14614,'pt','Fronteira interna',0),(526101,14614,'ru','Ð’Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½ÑÑ Ð³Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(526102,14614,'es','Frontera interior',0),(526103,14614,'de','Innere Grenze',0),(526104,14614,'en','Inner Border',0),(526105,14615,'is','',0),(526106,14615,'dr','Ø±Ø§Ø¨Ø·',0),(526107,14615,'pr','Ø±Ø§Ø¨Ø·',0),(526108,14615,'tr','Arabirimi',0),(526109,14615,'pl','Interfejs',0),(526110,14615,'bg','Ð˜Ð½Ñ‚ÐµÑ€Ñ„ÐµÐ¹Ñ',0),(526111,14615,'ur','Ø³Ø·Ø­ Ø§Ù„Ø¨ÛŒÙ†',0),(526112,14615,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ñ„ÐµÑ˜Ñ',0),(526113,14615,'vi','Giao diá»‡n',0),(526114,14615,'af','Koppelvlak',0),(526115,14615,'ro','Interfata',0),(526116,14615,'et','Liides',0),(526117,14615,'si','Vmesnik',0),(526118,14615,'ba','Antarmuka',0),(526119,14615,'nl','Interface',0),(526120,14615,'fi','KÃ¤yttÃ¶liittymÃ¤',0),(526121,14615,'no','Grensesnitt',0),(526122,14615,'da','GrÃ¦nseflade',0),(526123,14615,'ko','ì¸í„°íŽ˜ì´ìŠ¤',0),(526124,14615,'he','×ž×ž×©×§',0),(526125,14615,'el','Î”Î¹ÎµÏ€Î±Ï†Î®',0),(526126,14615,'zh','æŽ¥å£',0),(526127,14615,'sv','GrÃ¤nssnitt',0),(526128,14615,'it','Interfaccia',0),(526129,14615,'tl','',0),(526130,14615,'th','à¸­à¸´à¸™à¹€à¸—à¸­à¸£à¹Œà¹€à¸Ÿà¸‹',0),(526131,14615,'hi','à¤‡à¤‚à¤Ÿà¤°à¤«à¤¼à¥‡à¤¸',0),(526132,14615,'ms','Antara muka',0),(526133,14615,'ar','ÙˆØ§Ø¬Ù‡Ø©',0),(526134,14615,'fr','Interface',0),(526135,14615,'jp','ã‚¤ãƒ³ã‚¿ãƒ¼ãƒ•ã‚§ã‚¤ã‚¹',0),(526136,14615,'pt','Interface',0),(526137,14615,'ru','Ð˜Ð½Ñ‚ÐµÑ€Ñ„ÐµÐ¹Ñ',0),(526138,14615,'es','Interfaz',0),(526139,14615,'de','Schnittstelle',0),(526140,14615,'en','Interface',0),(526141,14616,'is','',0),(526142,14616,'dr','ÙˆØ±Ø²Ø´Ú¯Ø§Ù‡ Ø®Ø§Ù†Ù‡',0),(526143,14616,'pr','ÙˆØ±Ø²Ø´Ú¯Ø§Ù‡ Ø®Ø§Ù†Ù‡',0),(526144,14616,'tr','Stok giriÅŸ',0),(526145,14616,'pl','Strona gÅ‚Ã³wna spis',0),(526146,14616,'bg','Ð¡ÐºÐ»Ð°Ð´ Ð´Ð¾Ð¼',0),(526147,14616,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú¯Ú¾Ø±',0),(526148,14616,'sr','Ð”Ð¾Ð¼ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(526149,14616,'vi','NhÃ  hÃ ng tá»“n kho',0),(526150,14616,'af','Inventaris huis',0),(526151,14616,'ro','Inventarul Home',0),(526152,14616,'et','Varude kodu',0),(526153,14616,'si','Zaloge doma',0),(526154,14616,'ba','Rumah persediaan',0),(526155,14616,'nl','Inventaris Home',0),(526156,14616,'fi','Varaston koti',0),(526157,14616,'no','Lageret hjem',0),(526158,14616,'da','Lager hjem',0),(526159,14616,'ko','ìž¬ê³  ì§‘',0),(526160,14616,'he','×ž×œ××™ ×”×‘×™×ª',0),(526161,14616,'el','Î‘ÏÏ‡Î¹ÎºÎ® Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(526162,14616,'zh','åº“å­˜çš„å®¶',0),(526163,14616,'sv','Inventering hem',0),(526164,14616,'it','Inventario casa',0),(526165,14616,'tl','',0),(526166,14616,'th','à¸«à¸™à¹‰à¸²à¹à¸£à¸à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(526167,14616,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤˜à¤°',0),(526168,14616,'ms','Rumah inventori',0),(526169,14616,'ar','Ø§Ù„ØµÙØ­Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ© Ø§Ù„Ø¬Ø±Ø¯',0),(526170,14616,'fr','Accueil de l\'inventaire',0),(526171,14616,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®ãƒ›ãƒ¼ãƒ ',0),(526172,14616,'pt','Casa de inventÃ¡rio',0),(526173,14616,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð´Ð¾Ð¼Ð°',0),(526174,14616,'es','Casa de inventario',0),(526175,14616,'de','Inventar-Startseite',0),(526176,14616,'en','Inventory Home',0),(526177,14617,'is','',0),(526178,14617,'dr','Ù„ÛŒØ³Øª ÙØ§Ú©ØªÙˆØ±',0),(526179,14617,'pr','Ù„ÛŒØ³Øª ÙØ§Ú©ØªÙˆØ±',0),(526180,14617,'tr','Fatura Listesi',0),(526181,14617,'pl','Lista faktur',0),(526182,14617,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(526183,14617,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(526184,14617,'sr','Ð›Ð¸ÑÑ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(526185,14617,'vi','Danh sÃ¡ch hÃ³a Ä‘Æ¡n',0),(526186,14617,'af','Faktuur lys',0),(526187,14617,'ro','Lista de facturÄƒ',0),(526188,14617,'et','Arvete nimekiri',0),(526189,14617,'si','RaÄun seznam',0),(526190,14617,'ba','Daftar faktur',0),(526191,14617,'nl','Factuur lijst',0),(526192,14617,'fi','Laskuluetteloon',0),(526193,14617,'no','Faktura-listen',0),(526194,14617,'da','Faktura liste',0),(526195,14617,'ko','ì†¡ìž¥ ëª©ë¡',0),(526196,14617,'he','×¨×©×™×ž×ª ×—×©×‘×•× ×™×•×ª',0),(526197,14617,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î»Î¯ÏƒÏ„Î±',0),(526198,14617,'zh','å‘ç¥¨æ¸…å•',0),(526199,14617,'sv','Fakturalistan',0),(526200,14617,'it','Elenco di fattura',0),(526201,14617,'tl','',0),(526202,14617,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(526203,14617,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¸à¥‚à¤šà¥€',0),(526204,14617,'ms','Senarai invois',0),(526205,14617,'ar','Ù‚Ø§Ø¦Ù…Ø© ÙØ§ØªÙˆØ±Ø©',0),(526206,14617,'fr','Liste des factures',0),(526207,14617,'jp','è«‹æ±‚æ›¸ä¸€è¦§',0),(526208,14617,'pt','Lista de fatura',0),(526209,14617,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(526210,14617,'es','Lista de factura',0),(526211,14617,'de','Rechnungsliste',0),(526212,14617,'en','Invoice List',0),(526213,14618,'is','',0),(526214,14618,'dr','Ù„ÛŒØ³Øª ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø±',0),(526215,14618,'pr','Ù„ÛŒØ³Øª ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø±',0),(526216,14618,'tr','GÃ¼nlÃ¼k girdisi listesi',0),(526217,14618,'pl','Lista wpisÃ³w dziennika',0),(526218,14618,'bg','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ ÑÐ¿Ð¸ÑÑŠÐº',0),(526219,14618,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ ÙÛØ±Ø³Øª',0),(526220,14618,'sr','Ð›Ð¸ÑÑ‚Ð° ÑƒÐ½Ð¾ÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(526221,14618,'vi','Táº¡p chÃ­ má»¥c nháº­p danh sÃ¡ch',0),(526222,14618,'af','Joernaal inskrywing lys',0),(526223,14618,'ro','ListÄƒ de intrÄƒri jurnal',0),(526224,14618,'et','TÃ¶Ã¶lehe kande loendi kaudu',0),(526225,14618,'si','Seznam vnosov v dnevnik',0),(526226,14618,'ba','Daftar entri jurnal',0),(526227,14618,'nl','Dagboek Entry List',0),(526228,14618,'fi','Kirjauskansion merkintÃ¤ luetteloon',0),(526229,14618,'no','Oversikt over oppfÃ¸ring',0),(526230,14618,'da','Journal indrejse liste',0),(526231,14618,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª© ëª©ë¡',0),(526232,14618,'he','×¨×©×™×ž×ª ×¢×¨×š ×™×•×ž×Ÿ',0),(526233,14618,'el','Î›Î¯ÏƒÏ„Î± Î­Î½Î±ÏÎ¾Î· ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(526234,14618,'zh','æ—¥è®°æ¡ç›®åˆ—è¡¨',0),(526235,14618,'sv','Tidning spÃ¤rrlistan',0),(526236,14618,'it','Journal Entry List',0),(526237,14618,'tl','',0),(526238,14618,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸™à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™',0),(526239,14618,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¥‚à¤šà¥€',0),(526240,14618,'ms','Senarai kemasukan jurnal',0),(526241,14618,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¥Ø¯Ø®Ø§Ù„ Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(526242,14618,'fr','Liste des entrÃ©es Journal',0),(526243,14618,'jp','ä»•è¨³å¸³ã‚¨ãƒ³ãƒˆãƒª ãƒªã‚¹ãƒˆ',0),(526244,14618,'pt','Lista de entrada de diÃ¡rio',0),(526245,14618,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ Ð¶ÑƒÑ€Ð½Ð°Ð»Ð°',0),(526246,14618,'es','Lista de entradas de diario',0),(526247,14618,'de','Liste der Journal-Eintrag',0),(526248,14618,'en','Journal Entry List',0),(526249,14619,'is','',0),(526250,14619,'dr','Ø®Ø§Ù†Ù‡ Ù„Ø¬Ø±',0),(526251,14619,'pr','Ø®Ø§Ù†Ù‡ Ù„Ø¬Ø±',0),(526252,14619,'tr','Defter giriÅŸ',0),(526253,14619,'pl','KsiÄ™gi gÅ‚Ã³wnej',0),(526254,14619,'bg','ÐšÐ½Ð¸Ð³Ð° Ð·Ð° Ð´Ð¾Ð¼Ð°',0),(526255,14619,'ur','Ú©Ú¾Ø§ØªØ§ Ú¯Ú¾Ø±',0),(526256,14619,'sr','ÐšÑšÐ¸Ð³Ðµ ÐºÑƒÑ›Ð¸',0),(526257,14619,'vi','Ledger nhÃ ',0),(526258,14619,'af','Grootboek huis',0),(526259,14619,'ro','Registru casa',0),(526260,14619,'et','Pearaamatukonto koju',0),(526261,14619,'si','Knjigo doma',0),(526262,14619,'ba','Rumah Ledger',0),(526263,14619,'nl','Ledger Home',0),(526264,14619,'fi','Kirjanpito koti',0),(526265,14619,'no','Finans hjem',0),(526266,14619,'da','Ledger hjem',0),(526267,14619,'ko','ë ˆì € í™ˆ',0),(526268,14619,'he','×‘×™×ª ×¡×¤×¨ ×¨××©×™',0),(526269,14619,'el','Î£Ï€Î¯Ï„Î¹ Ï„Î¿Ï… ÎºÎ±Î¸Î¿Î»Î¹ÎºÎ¿Ï',0),(526270,14619,'zh','åˆ†ç±»å¸çš„å®¶',0),(526271,14619,'sv','Redovisning-hem',0),(526272,14619,'it','ContabilitÃ  casa',0),(526273,14619,'tl','',0),(526274,14619,'th','à¸šà¹‰à¸²à¸™à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—',0),(526275,14619,'hi','à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ à¤˜à¤°',0),(526276,14619,'ms','Lejar utama',0),(526277,14619,'ar','Ù…Ù†Ø²Ù„ Ø§Ù„Ø£Ø³ØªØ§Ø°',0),(526278,14619,'fr','Maison de grand livre',0),(526279,14619,'jp','ç·å‹˜å®šå…ƒå¸³ã®å®¶',0),(526280,14619,'pt','Casa de Ledger',0),(526281,14619,'ru','Ð”Ð¾Ð¼ ÐºÐ½Ð¸Ð³Ð¸',0),(526282,14619,'es','Casa del libro',0),(526283,14619,'de','Ledger-Startseite',0),(526284,14619,'en','Ledger Home',0),(526285,14620,'is','',0),(526286,14620,'dr','Ø§Ø³ØªØ«Ù†Ø§ Ø¯Ø± Ø­Ø§Ø´ÛŒÙ‡',0),(526287,14620,'pr','Ø§Ø³ØªØ«Ù†Ø§ Ø¯Ø± Ø­Ø§Ø´ÛŒÙ‡',0),(526288,14620,'tr','Kenar Ã¶zel durum',0),(526289,14620,'pl','Margines wyjÄ…tek',0),(526290,14620,'bg','Ð“Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¸Ð·ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ',0),(526291,14620,'ur','Ø­Ø§Ø´ÛŒÛ Ø§Ø³ØªØ«Ù†Ø§',0),(526292,14620,'sr','ÐœÐ°Ñ€Ð³Ð¸Ð½Ðµ Ð¸Ð·ÑƒÐ·ÐµÑ‚Ð°Ðº',0),(526293,14620,'vi','Margin ngoáº¡i lá»‡',0),(526294,14620,'af','Marge uitsondering',0),(526295,14620,'ro','Marja de excepÅ£ie',0),(526296,14620,'et','Marginaali erand',0),(526297,14620,'si','Stopnja izjema',0),(526298,14620,'ba','Margin pengecualian',0),(526299,14620,'nl','Marge uitzondering',0),(526300,14620,'fi','Marginaali poikkeus',0),(526301,14620,'no','Marg unntak',0),(526302,14620,'da','Margen undtagelse',0),(526303,14620,'ko','ì—¬ë°± ì˜ˆì™¸',0),(526304,14620,'he','×©×•×œ×™×™× ×—×¨×™×’×”',0),(526305,14620,'el','Î ÎµÏÎ¹Î¸ÏŽÏÎ¹Î¿ ÎµÎ¾Î±Î¯ÏÎµÏƒÎ·',0),(526306,14620,'zh','ç¼˜å¼‚å¸¸',0),(526307,14620,'sv','Marginal undantag',0),(526308,14620,'it','Eccezione di margine',0),(526309,14620,'tl','',0),(526310,14620,'th','à¸¢à¸à¹€à¸§à¹‰à¸™à¸‚à¸­à¸š',0),(526311,14620,'hi','à¤®à¤¾à¤°à¥à¤œà¤¿à¤¨ à¤…à¤ªà¤µà¤¾à¤¦',0),(526312,14620,'ms','Pengecualian margin',0),(526313,14620,'ar','Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ø§Ù„Ù‡Ø§Ù…Ø´',0),(526314,14620,'fr','Exception de marge',0),(526315,14620,'jp','ä½™ç™½ã®ä¾‹å¤–',0),(526316,14620,'pt','ExceÃ§Ã£o de margem',0),(526317,14620,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð»ÐµÐ¹',0),(526318,14620,'es','ExcepciÃ³n de margen',0),(526319,14620,'de','Marge-Ausnahme',0),(526320,14620,'en','Margin Exception',0),(526321,14621,'is','',0),(526322,14621,'dr','Ø±Ø¯ÛŒÙ Furture Ø¬Ù„ÙˆÚ¯ÛŒØ±ÛŒ Ø§Ø² Ø­Ø§ÙØ¸Ù‡ Ù…Ø­Ø¯ÙˆØ¯',0),(526323,14621,'pr','Ø±Ø¯ÛŒÙ Furture Ø¬Ù„ÙˆÚ¯ÛŒØ±ÛŒ Ø§Ø² Ø­Ø§ÙØ¸Ù‡ Ù…Ø­Ø¯ÙˆØ¯',0),(526324,14621,'tr','Bellek sÄ±nÄ±rÄ± Ã¶nleme Furture satÄ±rlarÄ±',0),(526325,14621,'pl','PamiÄ™ci Limit zapobieganie Furture wierszy',0),(526326,14621,'bg','Ð ÐµÐ´Ð¾Ð²Ðµ Ð·Ð° Ð¿Ñ€ÐµÐ´Ð¾Ñ‚Ð²Ñ€Ð°Ñ‚ÑÐ²Ð°Ð½Ðµ Ð¿Ð¾-Ð½Ð°Ñ‚Ð°Ñ‚ÑŠÐº Ð½Ð° Ð¿Ð°Ð¼ÐµÑ‚ Ð³Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(526327,14621,'ur','Ù…ÛŒÙ…ÙˆØ±ÛŒ Ø­Ø¯ Ú©ÛŒ Ø±ÙˆÚ© ØªÚ¾Ø§Ù… ÙÙˆØ±Ù¹ÙˆØ±Ø§ ØµÙÛŒÚº',0),(526328,14621,'sr','Ð ÐµÐ´Ð¾Ð²Ðµ Ð¤ÑƒÑ€Ñ‚ÑƒÑ€Ðµ Ð›Ð¸Ð¼Ð¸Ñ‚ Ð·Ð° ÑÐ¿Ñ€ÐµÑ‡Ð°Ð²Ð°ÑšÐµ Ð¼ÐµÐ¼Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(526329,14621,'vi','Giá»›i háº¡n bá»™ nhá»› ngÄƒn cháº·n Furture hÃ ng',0),(526330,14621,'af','Geheue beperk voorkoming van Furture rye',0),(526331,14621,'ro','Memorie limitÄƒ prevenirea Furture rÃ¢nduri',0),(526332,14621,'et','MÃ¤lu limiit ennetada Furture read',0),(526333,14621,'si','Spomin viÅ¡ek prepreÄevanje Furture vrstic',0),(526334,14621,'ba','Memori batas mencegah Furture baris',0),(526335,14621,'nl','Geheugen limiet voorkomen Furture rijen',0),(526336,14621,'fi','Muisti rajoita estÃ¤Ã¤ Furture rivit',0),(526337,14621,'no','Minne grensen hindre Furture rader',0),(526338,14621,'da','Hukommelse grÃ¦nse forhindrer Furture rÃ¦kker',0),(526339,14621,'ko','ë©”ëª¨ë¦¬ ì œí•œ ë°©ì§€ Furture í–‰',0),(526340,14621,'he','×©×•×¨×•×ª ×›×©×× ×—× ×• ××ž×¨×™× ×ž× ×™×¢×ª ×ž×’×‘×œ×ª ×”×–×™×›×¨×•×Ÿ',0),(526341,14621,'el','ÎœÎ½Î®Î¼Î· ÏŒÏÎ¹Î¿ Ï€ÏÏŒÎ»Î·ÏˆÎ· Furture ÏƒÎµÎ¹ÏÎ­Ï‚',0),(526342,14621,'zh','å†…å­˜é™åˆ¶é˜²æ­¢å°†æ¥è¡Œæ•°',0),(526343,14621,'sv','Minne grÃ¤ns att fÃ¶rhindra Furture rader',0),(526344,14621,'it','Memoria limite impedendo Furture righe',0),(526345,14621,'tl','',0),(526346,14621,'th','à¸«à¸™à¹ˆà¸§à¸¢à¸„à¸§à¸²à¸¡à¸ˆà¸³à¸ˆà¸³à¸à¸±à¸”à¸›à¹‰à¸­à¸‡à¸à¸±à¸™à¹à¸£à¸‡à¹à¸–à¸§',0),(526347,14621,'hi','à¤¸à¥à¤®à¥ƒà¤¤à¤¿ à¤¸à¥€à¤®à¤¾ à¤°à¥‹à¤•à¤¨à¥‡ Furture à¤ªà¤‚à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤',0),(526348,14621,'ms','Memori had menghalang Furture baris',0),(526349,14621,'ar','Ø§Ù„Ø°Ø§ÙƒØ±Ø© Ø­Ø¯ Ù…Ù†Ø¹ ÙÙˆØ±ØªÙˆØ±ÙŠ Ø§Ù„ØµÙÙˆÙ',0),(526350,14621,'fr','MÃ©moire limite empÃªchant Furture lignes',0),(526351,14621,'jp','ãƒ¡ãƒ¢ãƒªåˆ¶é™ã‚’é˜²æ­¢ã™ã‚‹ Furture è¡Œ',0),(526352,14621,'pt','MemÃ³ria limite impedindo Furture linhas',0),(526353,14621,'ru','ÐŸÐ°Ð¼ÑÑ‚Ð¸ Ð¿Ñ€ÐµÐ´ÐµÐ» Ð¿Ñ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ñ Furture ÑÑ‚Ñ€Ð¾Ðº',0),(526354,14621,'es','Memoria lÃ­mite evitando Furture filas',0),(526355,14621,'de','Memory Limit verhindert angezeigte Zeilen',0),(526356,14621,'en','Memory Limit Preventing Furture Rows',0),(526357,14622,'is','',0),(526358,14622,'dr','Ù…ÙˆØ±Ø¯ Ø¬Ø¯ÛŒØ¯',0),(526359,14622,'pr','Ù…ÙˆØ±Ø¯ Ø¬Ø¯ÛŒØ¯',0),(526360,14622,'tr','Yeni Ã¶ÄŸe',0),(526361,14622,'pl','Nowy element',0),(526362,14622,'bg','ÐÐ¾Ð² ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(526363,14622,'ur','Ù†Ø¦ÛŒ Ø´Û’',0),(526364,14622,'sr','ÐÐ¾Ð²Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(526365,14622,'vi','Khoáº£n má»¥c má»›i',0),(526366,14622,'af','Nuwe Item',0),(526367,14622,'ro','Element nou',0),(526368,14622,'et','Uus Ã¼ksus',0),(526369,14622,'si','Nov element',0),(526370,14622,'ba','Item baru',0),(526371,14622,'nl','Nieuw Item',0),(526372,14622,'fi','Uusi kohde',0),(526373,14622,'no','Nytt element',0),(526374,14622,'da','Nyt element',0),(526375,14622,'ko','ìƒˆ í•­ëª©',0),(526376,14622,'he','×¤×¨×™×˜ ×—×“×©',0),(526377,14622,'el','ÎÎ­Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(526378,14622,'zh','æ–°é¡¹ç›®',0),(526379,14622,'sv','Nytt objekt',0),(526380,14622,'it','Nuovo elemento',0),(526381,14622,'tl','',0),(526382,14622,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¹ƒà¸«à¸¡à¹ˆ',0),(526383,14622,'hi','à¤¨à¤ à¤†à¤‡à¤Ÿà¤®',0),(526384,14622,'ms','Perkara baru',0),(526385,14622,'ar','Ø¹Ù†ØµØ± Ø¬Ø¯ÙŠØ¯',0),(526386,14622,'fr','Nouvel Ã©lÃ©ment',0),(526387,14622,'jp','æ–°ã—ã„é …ç›®',0),(526388,14622,'pt','Novo Item',0),(526389,14622,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(526390,14622,'es','El nuevo artÃ­culo',0),(526391,14622,'de','Neues Element',0),(526392,14622,'en','New Item',0),(526393,14623,'is','',0),(526394,14623,'dr','Ù‡ÛŒÚ† Ø´Ø®ØµÛŒØª Ø­Ø±ÙˆÙ Ù¾ÛŒØ¯Ø§',0),(526395,14623,'pr','Ù‡ÛŒÚ† Ø´Ø®ØµÛŒØª Ø­Ø±ÙˆÙ Ù¾ÛŒØ¯Ø§',0),(526396,14623,'tr','HiÃ§bir kÃ¼Ã§Ã¼k harfli karakterler bulundu',0),(526397,14623,'pl','Nie litery Znalezione',0),(526398,14623,'bg','ÐÑÐ¼Ð° Ð¼Ð°Ð»ÐºÐ¸ Ð±ÑƒÐºÐ²Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(526399,14623,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ú†Ú¾ÙˆÙ¹Û’ Ø­Ø±ÙˆÙ Ú©Ø±ÛŒÚ©Ù¹Ø±',0),(526400,14623,'sr','ÐÐµÐ¼Ð° Ð¼Ð°Ð»Ð¸Ñ… Ð·Ð½Ð°ÐºÐ¾Ð²Ð° ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ð°Ð»Ð°Ð·Ðµ',0),(526401,14623,'vi','KhÃ´ng cÃ³ kÃ½ tá»± chá»¯ thÆ°á»ng tÃ¬m tháº¥y',0),(526402,14623,'af','Geen onderkasletters karakters gevind',0),(526403,14623,'ro','Caractere minuscule gÄƒsit',0),(526404,14623,'et','Ei leidnud vÃ¤iketÃ¤hed',0),(526405,14623,'si','Male znake naÅ¡el',0),(526406,14623,'ba','Tidak ada karakter huruf kecil yang ditemukan',0),(526407,14623,'nl','Geen kleine letters gevonden',0),(526408,14623,'fi','Ei lÃ¶ytÃ¤nyt pieniÃ¤ kirjaimia',0),(526409,14623,'no','Ingen smÃ¥ bokstaver funnet',0),(526410,14623,'da','Ingen smÃ¥ bogstaver fundet',0),(526411,14623,'ko','ì†Œë¬¸ìž ë¬¸ìžê°€ ë°œê²¬',0),(526412,14623,'he','×œ× × ×ž×¦××• ×ª×•×•×™× ×‘××•×ª×™×•×ª ×§×˜× ×•×ª',0),(526413,14623,'el','Î”ÎµÎ½ Ï€ÎµÎ¶Î¿ÏÏ‚ Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(526414,14623,'zh','æ²¡æœ‰æ‰¾åˆ°çš„å°å†™å­—ç¬¦',0),(526415,14623,'sv','Ingen gemener hittade',0),(526416,14623,'it','Nessun caratteri minuscoli trovati',0),(526417,14623,'tl','',0),(526418,14623,'th','à¸žà¸šà¸­à¸±à¸à¸‚à¸£à¸°à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸žà¸´à¸¡à¸žà¹Œà¹€à¸¥à¹‡à¸',0),(526419,14623,'hi','à¤•à¥‹à¤ˆ à¤²à¥‹à¤…à¤°à¤•à¥‡à¤¸ à¤…à¤•à¥à¤·à¤° à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(526420,14623,'ms','Tiada aksara huruf kecil yang ditemui',0),(526421,14623,'ar','Ø£Ø­Ø±Ù ØµØºÙŠØ±Ø© Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(526422,14623,'fr','Pas trouvÃ©s de caractÃ¨res minuscules',0),(526423,14623,'jp','ãªã„å°æ–‡å­—æ–‡å­—ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(526424,14623,'pt','Sem caracteres minÃºsculos encontrados',0),(526425,14623,'ru','ÐÐµ ÑÐ¸Ð¼Ð²Ð¾Ð»Ñ‹ Ð½Ð¸Ð¶Ð½ÐµÐ³Ð¾ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð° Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(526426,14623,'es','No encontrados los caracteres en minÃºsculas',0),(526427,14623,'de','Keine Kleinbuchstaben gefunden',0),(526428,14623,'en','No Lowercase Characters Found',0),(526429,14624,'is','',0),(526430,14624,'dr','Ù‡ÛŒÚ† Ø´Ø®ØµÛŒØª Ø´Ù…Ø§Ø±Ù‡ ÛŒØ§ÙØª',0),(526431,14624,'pr','Ù‡ÛŒÚ† Ø´Ø®ØµÛŒØª Ø´Ù…Ø§Ø±Ù‡ ÛŒØ§ÙØª',0),(526432,14624,'tr','Bulunan numara karakter',0),(526433,14624,'pl','Nie liczby znakÃ³w znaleÅºÄ‡',0),(526434,14624,'bg','ÐÑÐ¼Ð° Ð±Ñ€Ð¾Ð¹ ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(526435,14624,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ù†Ù…Ø¨Ø± Ú©Ø±ÛŒÚ©Ù¹Ø±',0),(526436,14624,'sr','ÐÐµÐ¼Ð° Ð±Ñ€Ð¾Ñ˜Ð° Ð·Ð½Ð°ÐºÐ¾Ð²Ð° ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ð°Ð»Ð°Ð·Ðµ',0),(526437,14624,'vi','KhÃ´ng cÃ³ nhÃ¢n váº­t sá»‘ tÃ¬m tháº¥y',0),(526438,14624,'af','Geen nommer karakters gevind',0),(526439,14624,'ro','Nici un numÄƒr de caractere gÄƒsit',0),(526440,14624,'et','Leitud arv mÃ¤rke',0),(526441,14624,'si','Å tevilÄne znake naÅ¡el',0),(526442,14624,'ba','Tidak ada nomor karakter yang ditemukan',0),(526443,14624,'nl','Geen cijfertekens gevonden',0),(526444,14624,'fi','Ei mÃ¤Ã¤rÃ¤ merkkejÃ¤',0),(526445,14624,'no','Antall tegn funnet',0),(526446,14624,'da','Ingen taltegn fundet',0),(526447,14624,'ko','ì•„ë‹ˆ ìˆ«ìž ë¬¸ìž',0),(526448,14624,'he','××™×Ÿ ×ž×¡×¤×¨ ×ª×•×•×™× × ×ž×¦××•',0),(526449,14624,'el','Î”ÎµÎ½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÏ‰Î½ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(526450,14624,'zh','å‘çŽ°æ²¡æœ‰æ•°å­—å­—ç¬¦',0),(526451,14624,'sv','Inga nummer tecken hittade',0),(526452,14624,'it','Nessun numero caratteri trovati',0),(526453,14624,'tl','',0),(526454,14624,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸­à¸±à¸à¸‚à¸£à¸°à¹€à¸¥à¸‚',0),(526455,14624,'hi','à¤•à¥‹à¤ˆ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤…à¤•à¥à¤·à¤°à¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(526456,14624,'ms','Tiada aksara nombor yang ditemui',0),(526457,14624,'ar','ØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù„Ø§ Ø£Ø­Ø±Ù Ø±Ù‚Ù…',0),(526458,14624,'fr','Aucun caractÃ¨re numÃ©ro trouvÃ©',0),(526459,14624,'jp','ãªã„æ•°å­—ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(526460,14624,'pt','Nenhum caractere nÃºmero encontrado',0),(526461,14624,'ru','ÐÐµÑ‚ Ñ‡Ð¸ÑÐ»Ð° ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¾Ð²',0),(526462,14624,'es','No hay nÃºmero de personajes encontrado',0),(526463,14624,'de','Keine Anzahl Zeichen gefunden',0),(526464,14624,'en','No Number Characters Found',0),(526465,14625,'is','',0),(526466,14625,'dr','Ù†Ù…Ø§Ø¯Ù‡Ø§ÛŒ Ù‡ÛŒÚ† Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(526467,14625,'pr','Ù†Ù…Ø§Ø¯Ù‡Ø§ÛŒ Ù‡ÛŒÚ† Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(526468,14625,'tr','Bulunan hiÃ§bir simgeler',0),(526469,14625,'pl','Nie moÅ¼na odnaleÅºÄ‡ symboli',0),(526470,14625,'bg','ÐÑÐ¼Ð° ÑÐ¸Ð¼Ð²Ð¾Ð»Ð¸',0),(526471,14625,'ur','Ú©ÙˆØ¦ÛŒ Ø¹Ù„Ø§Ù…Ø§Øª Ù¾Ø§Ø¦ÛŒ',0),(526472,14625,'sr','ÐÐµÐ¼Ð° ÑÐ¸Ð¼Ð±Ð¾Ð»Ð¸ ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ð°Ð»Ð°Ð·Ðµ',0),(526473,14625,'vi','KhÃ´ng cÃ³ biá»ƒu tÆ°á»£ng tÃ¬m tháº¥y',0),(526474,14625,'af','Geen simbole gevind',0),(526475,14625,'ro','Nu simboluri gÄƒsit',0),(526476,14625,'et','No sÃ¼mbolid',0),(526477,14625,'si','Brez simbolov, ki so',0),(526478,14625,'ba','Simbol-simbol tidak ditemukan',0),(526479,14625,'nl','Geen symbolen',0),(526480,14625,'fi','Ei lÃ¶ydettyjÃ¤ symboleja',0),(526481,14625,'no','Finner ingen symboler',0),(526482,14625,'da','Ingen symboler',0),(526483,14625,'ko','ë°œê²¬ ì—†ìŒ ê¸°í˜¸',0),(526484,14625,'he','×œ× × ×ž×¦××• ×¡×™×ž× ×™×',0),(526485,14625,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ ÎºÎ±Î½Î­Î½Î± ÏƒÏÎ¼Î²Î¿Î»Î¿',0),(526486,14625,'zh','æ²¡æœ‰æ‰¾åˆ°çš„ç¬¦å·',0),(526487,14625,'sv','Inga symboler',0),(526488,14625,'it','Non vi sono simboli trovati',0),(526489,14625,'tl','',0),(526490,14625,'th','à¸ªà¸±à¸à¸¥à¸±à¸à¸©à¸“à¹Œà¹„à¸¡à¹ˆà¸žà¸š',0),(526491,14625,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤¤à¥€à¤• à¤ªà¤¾à¤¯à¤¾',0),(526492,14625,'ms','Tidak ada simbol yang ditemui',0),(526493,14625,'ar','Ø±Ù…ÙˆØ² Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(526494,14625,'fr','Pas trouvÃ©s de symboles',0),(526495,14625,'jp','è¦‹ã¤ã‹ã£ãŸã‚·ãƒ³ãƒœãƒ«ãŒãªã„ã§ã™ã€‚',0),(526496,14625,'pt','NÃ£o hÃ¡ sÃ­mbolos encontrados',0),(526497,14625,'ru','ÐÐµ Ð´Ñ€ÑƒÐ³Ð¸Ðµ ÑÐ¸Ð¼Ð²Ð¾Ð»Ñ‹',0),(526498,14625,'es','No hay sÃ­mbolos',0),(526499,14625,'de','Keine Symbole gefunden',0),(526500,14625,'en','No Symbols Found',0),(526501,14626,'is','',0),(526502,14626,'dr','Ù‡ÛŒÚ† Ø´Ø®ØµÛŒØª Ø¨Ø²Ø±Ú¯ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(526503,14626,'pr','Ù‡ÛŒÚ† Ø´Ø®ØµÛŒØª Ø¨Ø²Ø±Ú¯ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(526504,14626,'tr','BÃ¼yÃ¼k harf karakter bulundu',0),(526505,14626,'pl','Nie ma wielkich liter, Znalezione',0),(526506,14626,'bg','ÐÑÐ¼Ð° Ð³Ð»Ð°Ð²Ð½Ð¸ Ð±ÑƒÐºÐ²Ð¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(526507,14626,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ø¨Ú‘Û’ Ø­Ø±ÙˆÙ Ú©Ø±ÛŒÚ©Ù¹Ø±',0),(526508,14626,'sr','ÐÐµÐ¼Ð° Ð²ÐµÐ»Ð¸ÐºÐ¸Ñ… Ð·Ð½Ð°ÐºÐ¾Ð²Ð° ÐºÐ¾Ñ˜Ð¸ ÑÐµ Ð½Ð°Ð»Ð°Ð·Ðµ',0),(526509,14626,'vi','KhÃ´ng cÃ³ kÃ½ tá»± chá»¯ hoa tÃ¬m tháº¥y',0),(526510,14626,'af','Geen hoofletters karakters gevind',0),(526511,14626,'ro','Caractere majuscule gÄƒsit',0),(526512,14626,'et','Ei leidnud suurtÃ¤hed',0),(526513,14626,'si','Brez velike znake naÅ¡el',0),(526514,14626,'ba','Tidak ada karakter huruf besar yang ditemukan',0),(526515,14626,'nl','Geen hoofdletters gevonden',0),(526516,14626,'fi','Ei isoja merkkejÃ¤',0),(526517,14626,'no','Ingen bokstaver funnet',0),(526518,14626,'da','Ingen store bogstaver fundet',0),(526519,14626,'ko','ì•„ë‹ˆ ëŒ€ë¬¸ìž ë°œê²¬',0),(526520,14626,'he','××™×Ÿ ×ª×•×•×™ ××•×ª×™×•×ª ×¨×™×©×™×•×ª × ×ž×¦××•',0),(526521,14626,'el','Î”ÎµÎ½ ÎºÎµÏ†Î±Î»Î±Î¯Î¿Ï…Ï‚ Ï‡Î±ÏÎ±ÎºÏ„Î®ÏÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(526522,14626,'zh','å‘çŽ°æ²¡æœ‰å¤§å†™å­—ç¬¦',0),(526523,14626,'sv','Inga stora bokstÃ¤ver Funna',0),(526524,14626,'it','Nessun caratteri maiuscoli trovati',0),(526525,14626,'tl','',0),(526526,14626,'th','à¸žà¸šà¸­à¸±à¸à¸‚à¸£à¸°à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸«à¸à¹ˆ',0),(526527,14626,'hi','à¤•à¥‹à¤ˆ à¤…à¤ªà¤°à¤•à¥‡à¤¸ à¤…à¤•à¥à¤·à¤° à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(526528,14626,'ms','Tiada aksara huruf yang ditemui',0),(526529,14626,'ar','Ø§Ù„Ø£Ø­Ø±Ù Ø§Ù„ÙƒØ¨ÙŠØ±Ø© Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(526530,14626,'fr','Pas trouvÃ©s de caractÃ¨res majuscules',0),(526531,14626,'jp','ã„ã„ãˆå¤§æ–‡å­—ã®æ–‡å­—ãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(526532,14626,'pt','Sem caracteres maiÃºsculos encontrados',0),(526533,14626,'ru','ÐÐµ Ð¿Ñ€Ð¾Ð¿Ð¸ÑÐ½Ñ‹Ðµ ÑÐ¸Ð¼Ð²Ð¾Ð»Ñ‹, Ð½Ð°Ð¹Ð´ÐµÐ½Ð½Ñ‹Ðµ',0),(526534,14626,'es','Sin caracteres en mayÃºsculas',0),(526535,14626,'de','Keine GroÃŸbuchstaben gefunden',0),(526536,14626,'en','No Uppercase Characters Found',0),(526537,14627,'is','',0),(526538,14627,'dr','Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´',0),(526539,14627,'pr','Ù„ÛŒØ³Øª Ø³ÙØ§Ø±Ø´',0),(526540,14627,'tr','SipariÅŸ listesi',0),(526541,14627,'pl','Lista zleceÅ„',0),(526542,14627,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(526543,14627,'ur','Ø¢Ø±ÚˆØ± ÙÛØ±Ø³Øª',0),(526544,14627,'sr','Ð›Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(526545,14627,'vi','Thá»© tá»± danh sÃ¡ch',0),(526546,14627,'af','Orde lys',0),(526547,14627,'ro','ListÄƒ comandÄƒ',0),(526548,14627,'et','Hooldustellimuste loend',0),(526549,14627,'si','Seznam nalogov',0),(526550,14627,'ba','Daftar permintaan',0),(526551,14627,'nl','Orderlijst',0),(526552,14627,'fi','Huoltotilauksen luettelo',0),(526553,14627,'no','RekkefÃ¸lgen',0),(526554,14627,'da','Bestil liste',0),(526555,14627,'ko','ì£¼ë¬¸ ëª©ë¡',0),(526556,14627,'he','×¨×©×™×ž×ª ×¡×“×¨',0),(526557,14627,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ½Ï„Î¿Î»ÏŽÎ½',0),(526558,14627,'zh','é¡ºåºåˆ—è¡¨',0),(526559,14627,'sv','BestÃ¤llningslista',0),(526560,14627,'it','Lista ordini',0),(526561,14627,'tl','',0),(526562,14627,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(526563,14627,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¥‚à¤šà¥€',0),(526564,14627,'ms','Senarai pesanan',0),(526565,14627,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù†Ø¸Ø§Ù…',0),(526566,14627,'fr','Liste des commandes',0),(526567,14627,'jp','æ³¨æ–‡ä¸€è¦§',0),(526568,14627,'pt','Lista de ordem',0),(526569,14627,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(526570,14627,'es','Lista de la orden',0),(526571,14627,'de','Bestell-Liste',0),(526572,14627,'en','Order List',0),(526573,14628,'is','',0),(526574,14628,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø§Ø³Øª Ú©Ù‡ Ø¨ÛŒØ´ Ø§Ø² Ø­Ø¯ Ú©ÙˆØªØ§Ù‡ Ù‡ÙØª Ú©Ø§Ø±Ø§Ú©ØªØ± Ø·ÙˆÙ„Ø§Ù†ÛŒ Ø¨Ø§ÛŒØ¯',0),(526575,14628,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø§Ø³Øª Ú©Ù‡ Ø¨ÛŒØ´ Ø§Ø² Ø­Ø¯ Ú©ÙˆØªØ§Ù‡ Ù‡ÙØª Ú©Ø§Ø±Ø§Ú©ØªØ± Ø·ÙˆÙ„Ø§Ù†ÛŒ Ø¨Ø§ÛŒØ¯',0),(526576,14628,'tr','Parola Ã§ok kÄ±sa uzun yedi karakter olmalÄ±dÄ±r',0),(526577,14628,'pl','HasÅ‚o jest zbyt krÃ³tki, musi byÄ‡ siedem Char dÅ‚ugo',0),(526578,14628,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð°Ñ‚Ð° Ðµ Ð¿Ñ€ÐµÐºÐ°Ð»ÐµÐ½Ð¾ ÐºÑŠÑÐ° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð´Ð¾ ÑÐµÐ´ÐµÐ¼ Ð·Ð½Ð°ÐºÐ° Ð´ÑŠÐ»Ð³Ð¾',0),(526579,14628,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¨ÛØª Ú†Ú¾ÙˆÙ¹Ø§ ÛÛ’ Ø³Ø§Øª Ú©Ø±ÛŒÚ©Ù¹Ø± Ø·ÙˆÛŒÙ„ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(526580,14628,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ° Ñ˜Ðµ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÐºÐ° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ ÑÐµÐ´Ð°Ð¼ Ð¦Ñ…Ð°Ñ€ Ð´ÑƒÐ³Ð¾',0),(526581,14628,'vi','Máº­t kháº©u lÃ  quÃ¡ ngáº¯n pháº£i lÃ  báº£y Char lÃ¢u',0),(526582,14628,'af','Wagwoord Is te kort moet sewe huishulp word lank',0),(526583,14628,'ro','Parola este prea scurtÄƒ trebuie sÄƒ fie ÅŸapte Char lung',0),(526584,14628,'et','Parool on liiga lÃ¼hike, tuleb seitse Char kaua',0),(526585,14628,'si','Geslo je prekratko mora biti dolg sedem Char',0),(526586,14628,'ba','Password terlalu pendek harus tujuh Char panjang',0),(526587,14628,'nl','Wachtwoord Is te kort moet zeven tekens lang',0),(526588,14628,'fi','Salasana on liian lyhyt on oltava seitsemÃ¤n merkkiÃ¤ pitkÃ¤',0),(526589,14628,'no','Passordet er for kort mÃ¥ syv tegn lang',0),(526590,14628,'da','Adgangskoden er for kort skal vÃ¦re syv Char lÃ¦nge',0),(526591,14628,'ko','ì•”í˜¸ê°€ ë„ˆë¬´ ì§§ìŠµë‹ˆë‹¤ ê¸´ 7 ë¬¸ìž ì´ì–´ì•¼',0),(526592,14628,'he','×”×¡×™×¡×ž×” ×”×™× ×§×¦×¨×” ×ž×“×™ ×—×™×™×‘ ×œ×”×™×•×ª ×©×‘×¢ Char ×–×ž×Ÿ',0),(526593,14628,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹ Ï€Î¿Î»Ï Î¼Î¹ÎºÏÎ® Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Ï„Î¿ Char ÎµÏ€Ï„Î¬ ÎºÎ±Î¹ÏÏŒ',0),(526594,14628,'zh','å¯†ç æ˜¯å¤ªçŸ­å¿…é¡»ä¸ƒä¸ªå­—ç¬¦é•¿',0),(526595,14628,'sv','LÃ¶senordet Ã¤r fÃ¶r kort mÃ¥ste vara sju tecken lÃ¥nga',0),(526596,14628,'it','Password Ã¨ troppo corta deve essere sette Char lunghi',0),(526597,14628,'tl','',0),(526598,14628,'th','à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸ˆà¸°à¸ªà¸±à¹‰à¸™à¹€à¸à¸´à¸™à¹„à¸›à¸•à¹‰à¸­à¸‡à¹€à¸›à¹‡à¸™à¸­à¸±à¸à¸‚à¸£à¸°à¹€à¸ˆà¹‡à¸”à¸™à¸²à¸™',0),(526599,14628,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¬à¤¹à¥à¤¤ à¤›à¥‹à¤Ÿà¤¾ à¤¹à¥ˆ à¤¸à¤¾à¤¤ à¤µà¤°à¥à¤£ à¤²à¤‚à¤¬à¤¾ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(526600,14628,'ms','Kata laluan yang tidak terlalu pendek mesti Char tujuh lama',0),(526601,14628,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± ØºÙŠØ± Ù‚ØµÙŠØ±Ø© Ø¬Ø¯Ø§Ù‹ ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø´Ø§Ø± Ø§Ù„Ø³Ø¨Ø¹Ø© Ù…Ù†Ø° ÙØªØ±Ø© Ø·ÙˆÙŠÙ„Ø©',0),(526602,14628,'fr','Mot de passe est trop court doit Ãªtre sept Char longues',0),(526603,14628,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ãŒçŸ­ã™ãŽã¾ã™ 7 Char ã‚’é•·ãã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™',0),(526604,14628,'pt','Senha Ã© muito curta deve ser sete Char tempo',0),(526605,14628,'ru','Ð¡Ð»Ð¸ÑˆÐºÐ¾Ð¼ ÐºÐ¾Ñ€Ð¾Ñ‚ÐºÐ¸Ð¹ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð»Ð¸Ð½Ð¾Ð¹ ÑÐµÐ¼ÑŒ Char',0),(526606,14628,'es','La contraseÃ±a es demasiado corta debe estar siete Char',0),(526607,14628,'de','Passwort ist zu kurz muss sieben Char lange',0),(526608,14628,'en','Password Is Too Short Must Be Seven Char Long',0),(526609,14629,'is','',0),(526610,14629,'dr','Ø§Ø³ØªØ­Ú©Ø§Ù… Ú¯Ø°Ø±ÙˆØ§Ú˜Ù‡ Ø¨ÛŒØ´ Ø§Ø² Ø­Ø¯ Ú©Ù… Ø§Ø³Øª',0),(526611,14629,'pr','Ø§Ø³ØªØ­Ú©Ø§Ù… Ú¯Ø°Ø±ÙˆØ§Ú˜Ù‡ Ø¨ÛŒØ´ Ø§Ø² Ø­Ø¯ Ú©Ù… Ø§Ø³Øª',0),(526612,14629,'tr','Parola gÃ¼venlik dÃ¼zeyi Ã§ok dÃ¼ÅŸÃ¼ktÃ¼r',0),(526613,14629,'pl','SiÅ‚a hasÅ‚a jest zbyt niska',0),(526614,14629,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð°Ñ‚Ð° Ðµ Ð¿Ñ€ÐµÐºÐ°Ð»ÐµÐ½Ð¾ Ð½Ð¸ÑÐºÐ°',0),(526615,14629,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ú©ÛŒ Ø·Ø§Ù‚Øª Ø¨ÛØª Ú©Ù… ÛÛ’ Û”',0),(526616,14629,'sr','Ð¡Ð½Ð°Ð³Ð° Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ Ñ˜Ðµ Ð¿Ñ€ÐµÐ½Ð¸ÑÐºÐ°',0),(526617,14629,'vi','Máº­t kháº©u sá»©c máº¡nh lÃ  quÃ¡ tháº¥p',0),(526618,14629,'af','Wagwoord krag Is te laag',0),(526619,14629,'ro','Puterea parola este prea scÄƒzut',0),(526620,14629,'et','SalasÃµna tugevus on liiga madal',0),(526621,14629,'si','Geslo moÄ prenizka',0),(526622,14629,'ba','Kekuatan kata sandi terlalu rendah',0),(526623,14629,'nl','Wachtwoordsterkte Is te laag',0),(526624,14629,'fi','Salasanan vahvuus on liian alhainen',0),(526625,14629,'no','Passordstyrke er for lav',0),(526626,14629,'da','Styrke for adgangskode er for lav',0),(526627,14629,'ko','ì•”í˜¸ ê°•ë„ ë„ˆë¬´ ë‚®ìŠµë‹ˆë‹¤.',0),(526628,14629,'he','×—×•×–×§ ×¡×™×¡×ž××•×ª ×”×•× × ×ž×•×š ×ž×“×™',0),(526629,14629,'el','Î™ÏƒÏ‡ÏÏ‚ ÎºÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÎµÎ¯Î½Î±Î¹ Ï€Î¿Î»Ï Ï‡Î±Î¼Î·Î»Î®',0),(526630,14629,'zh','å¯†ç å¼ºåº¦æ˜¯å¤ªä½Ž',0),(526631,14629,'sv','LÃ¶senordsstyrka Ã¤r fÃ¶r lÃ¥g',0),(526632,14629,'it','Forza password Ã¨ troppo basso',0),(526633,14629,'tl','',0),(526634,14629,'th','à¸„à¸§à¸²à¸¡à¹à¸£à¸‡à¸‚à¸­à¸‡à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸—à¸µà¹ˆà¹€à¸›à¹‡à¸™à¸•à¹ˆà¸³à¹€à¸à¸´à¸™à¹„à¸›',0),(526635,14629,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¤à¤¾à¤•à¤¤ à¤­à¥€ à¤•à¤® à¤¹à¥ˆ',0),(526636,14629,'ms','Kekuatan kata laluan adalah terlalu rendah',0),(526637,14629,'ar','Ù‚ÙˆØ© ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ù…Ù†Ø®ÙØ¶ Ø¬Ø¯Ø§Ù‹',0),(526638,14629,'fr','Force de mot de passe est trop faible',0),(526639,14629,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®å¼·åº¦ãŒä½Žã™ãŽã¾ã™ã€‚',0),(526640,14629,'pt','ForÃ§a da senha Ã© muito baixa',0),(526641,14629,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ ÑÐ¸Ð»Ð° ÑÐ»Ð¸ÑˆÐºÐ¾Ð¼ Ð¼Ð°Ð»Ð°',0),(526642,14629,'es','ContraseÃ±a es demasiado baja',0),(526643,14629,'de','PasswortstÃ¤rke ist zu niedrig',0),(526644,14629,'en','Password Strength Is Too Low',0),(526645,14630,'is','',0),(526646,14630,'dr','Ù„ÛŒØ³Øª Ù¾Ø±Ø¯Ø§Ø®Øª',0),(526647,14630,'pr','Ù„ÛŒØ³Øª Ù¾Ø±Ø¯Ø§Ø®Øª',0),(526648,14630,'tr','Ã–deme listesi',0),(526649,14630,'pl','Lista pÅ‚atnoÅ›ci',0),(526650,14630,'bg','Ð˜Ð·Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÑÐ¿Ð¸ÑÑŠÐº',0),(526651,14630,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(526652,14630,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(526653,14630,'vi','Danh sÃ¡ch thanh toÃ¡n',0),(526654,14630,'af','Betaling lys',0),(526655,14630,'ro','Lista de plata',0),(526656,14630,'et','Maksete nimekiri',0),(526657,14630,'si','Seznam plaÄilnih',0),(526658,14630,'ba','Daftar',0),(526659,14630,'nl','Betaling lijst',0),(526660,14630,'fi','Masku haluttaa',0),(526661,14630,'no','Betaling liste',0),(526662,14630,'da','Betaling liste',0),(526663,14630,'ko','ê²°ì œ ëª©ë¡',0),(526664,14630,'he','×¨×©×™×ž×ª ×”×ª×©×œ×•×',0),(526665,14630,'el','Î›Î¯ÏƒÏ„Î± Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(526666,14630,'zh','ä»˜æ¬¾æ¸…å•',0),(526667,14630,'sv','Betalning lista',0),(526668,14630,'it','Elenco di pagamento',0),(526669,14630,'tl','',0),(526670,14630,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(526671,14630,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¥‚à¤šà¥€',0),(526672,14630,'ms','Senarai bayaran',0),(526673,14630,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¯ÙØ¹',0),(526674,14630,'fr','Liste des paiements',0),(526675,14630,'jp','æ”¯æ‰•ãƒªã‚¹ãƒˆ',0),(526676,14630,'pt','Lista de pagamento',0),(526677,14630,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(526678,14630,'es','Lista de pago',0),(526679,14630,'de','Auszahlungsliste',0),(526680,14630,'en','Payment List',0),(526681,14631,'is','',0),(526682,14631,'dr','Ø®Ø§Ù†Ù‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(526683,14631,'pr','Ø®Ø§Ù†Ù‡ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(526684,14631,'tr','Bordro ev',0),(526685,14631,'pl','Strona listy pÅ‚ac',0),(526686,14631,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð½Ð°',0),(526687,14631,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©Û’ Ú¯Ú¾Ø±',0),(526688,14631,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð´Ð¾Ð¼',0),(526689,14631,'vi','BiÃªn cháº¿ nhÃ ',0),(526690,14631,'af','Salarisstelsel huis',0),(526691,14631,'ro','Salarizare Home',0),(526692,14631,'et','Palgaarvestuse kodu',0),(526693,14631,'si','Dom na izplaÄane plaÄe',0),(526694,14631,'ba','Penggajian rumah',0),(526695,14631,'nl','Payroll Home',0),(526696,14631,'fi','Palkanlaskennan koti',0),(526697,14631,'no','LÃ¸nn hjem',0),(526698,14631,'da','LÃ¸n hjem',0),(526699,14631,'ko','ê¸‰ì—¬ í™ˆ',0),(526700,14631,'he','×ž×©×›×•×¨×•×ª ×”×‘×™×ª×”',0),(526701,14631,'el','Î£Ï€Î¯Ï„Î¹ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(526702,14631,'zh','å·¥èµ„å›žå®¶',0),(526703,14631,'sv','LÃ¶nelistan hem',0),(526704,14631,'it','Casa del libro paga',0),(526705,14631,'tl','',0),(526706,14631,'th','à¸šà¹‰à¸²à¸™à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(526707,14631,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤˜à¤°',0),(526708,14631,'ms','Rumah gaji',0),(526709,14631,'ar','Ù…Ù†Ø²Ù„ Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(526710,14631,'fr','Accueil paie',0),(526711,14631,'jp','çµ¦ä¸Žã®å®¶',0),(526712,14631,'pt','Casa de folha de pagamento',0),(526713,14631,'ru','Ð”Ð¾Ð¼ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(526714,14631,'es','Casa de nÃ³mina',0),(526715,14631,'de','Payroll-Startseite',0),(526716,14631,'en','Payroll Home',0),(526717,14632,'is','',0),(526718,14632,'dr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(526719,14632,'pr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(526720,14632,'tr','Yinelenen giriÅŸler',0),(526721,14632,'pl','Wpisy powtarzajÄ…ce',0),(526722,14632,'bg','ÐŸÐ¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(526723,14632,'ur','Ù…Ú©Ø±Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(526724,14632,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(526725,14632,'vi','Má»¥c láº·p láº¡i',0),(526726,14632,'af','Herhalende inskrywings',0),(526727,14632,'ro','IntrÄƒri recurente',0),(526728,14632,'et','Korduvad kanded',0),(526729,14632,'si','PonavljajoÄe se postavke',0),(526730,14632,'ba','Entri berulang',0),(526731,14632,'nl','Periodieke posten',0),(526732,14632,'fi','Toistuvia tapahtumia',0),(526733,14632,'no','Gjentakelsesposter',0),(526734,14632,'da','Gentagelsesposterne',0),(526735,14632,'ko','ë˜í’€ì´ ë˜ëŠ” í•­ëª©',0),(526736,14632,'he','×¢×¨×›×™× ×—×•×–×¨×™×',0),(526737,14632,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(526738,14632,'zh','é‡å¤æ¡ç›®',0),(526739,14632,'sv','Ã…terkommande poster',0),(526740,14632,'it','Voci ricorrenti',0),(526741,14632,'tl','',0),(526742,14632,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸à¸²à¸£à¹€à¸à¸´à¸”à¸‹à¹‰à¸³',0),(526743,14632,'hi','à¤†à¤µà¤°à¥à¤¤à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(526744,14632,'ms','Penyertaan yang berulang',0),(526745,14632,'ar','Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ù…ØªÙƒØ±Ø±Ø©',0),(526746,14632,'fr','EntrÃ©es rÃ©currentes',0),(526747,14632,'jp','å®šæœŸçš„ãªã‚¨ãƒ³ãƒˆãƒª',0),(526748,14632,'pt','Entradas recorrentes',0),(526749,14632,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(526750,14632,'es','Entradas recurrentes',0),(526751,14632,'de','Dauerbuchungen',0),(526752,14632,'en','Recurring Entries',0),(526753,14633,'is','',0),(526754,14633,'dr','Ù„ÛŒØ³Øª ÙˆØ±ÙˆØ¯ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(526755,14633,'pr','Ù„ÛŒØ³Øª ÙˆØ±ÙˆØ¯ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(526756,14633,'tr','Yinelenen giriÅŸ listesi',0),(526757,14633,'pl','Cykliczne lista wpisÃ³w',0),(526758,14633,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ',0),(526759,14633,'ur','Ø¨Ø§Ø± Ø¨Ø§Ø± ÛÙˆÙ†Û’ ÙˆØ§Ù„ÛŒ ÙÛØ±Ø³Øª Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(526760,14633,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð»Ð¸ÑÑ‚Ðµ',0),(526761,14633,'vi','Äá»‹nh ká»³ má»¥c nháº­p danh sÃ¡ch',0),(526762,14633,'af','Herhalende inskrywing lys',0),(526763,14633,'ro','ListÄƒ de intrÄƒri recurente',0),(526764,14633,'et','Korduvad kanne loend',0),(526765,14633,'si','PonavljajoÄi se vpis seznam',0),(526766,14633,'ba','Berulang daftar entri',0),(526767,14633,'nl','Terugkerende deelnemerslijst',0),(526768,14633,'fi','Toistuva merkintÃ¤ luetteloon',0),(526769,14633,'no','Regelmessige liste',0),(526770,14633,'da','Tilbagevendende indrejse liste',0),(526771,14633,'ko','ë˜í’€ì´ í•­ëª© ëª©ë¡',0),(526772,14633,'he','×¨×©×™×ž×ª ×”×¢×¨×›×™× ×—×•×–×¨×•×ª',0),(526773,14633,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ Î»Î¯ÏƒÏ„Î± Î­Î½Î±ÏÎ¾Î·',0),(526774,14633,'zh','é‡å¤çš„æ¡ç›®åˆ—è¡¨',0),(526775,14633,'sv','Ã…terkommande spÃ¤rrlistan',0),(526776,14633,'it','Elenco di voci ricorrenti',0),(526777,14633,'tl','',0),(526778,14633,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¹€à¸à¸´à¸”à¸‹à¹‰à¸³',0),(526779,14633,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¥‚à¤šà¥€',0),(526780,14633,'ms','Senarai kemasukan berulang',0),(526781,14633,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¥Ø¯Ø®Ø§Ù„ Ù…ØªÙƒØ±Ø±',0),(526782,14633,'fr','Liste des Ã©critures rÃ©currentes',0),(526783,14633,'jp','å®šæœŸçš„ãªã‚¨ãƒ³ãƒˆãƒªãƒ¼ ãƒªã‚¹ãƒˆ',0),(526784,14633,'pt','Lista de entrada recorrentes',0),(526785,14633,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ…ÑÑ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(526786,14633,'es','Lista de entradas de recurrentes',0),(526787,14633,'de','Wiederkehrende Meldeliste',0),(526788,14633,'en','Recurring Entry List',0),(526789,14634,'is','',0),(526790,14634,'dr','Ø¬Ø¯ÙˆÙ„ Ú¯Ø²Ø§Ø±Ø´',0),(526791,14634,'pr','Ø¬Ø¯ÙˆÙ„ Ú¯Ø²Ø§Ø±Ø´',0),(526792,14634,'tr','Rapor tablosu',0),(526793,14634,'pl','Raportu tabeli',0),(526794,14634,'bg','Ð¡Ð¿Ñ€Ð°Ð²ÐºÐ° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(526795,14634,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú©ÛŒ Ù…ÛŒØ²',0),(526796,14634,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ñ‚Ð°Ð±ÐµÐ»Ðµ',0),(526797,14634,'vi','BÃ¡o cÃ¡o bÃ n',0),(526798,14634,'af','Verslag tabel',0),(526799,14634,'ro','Raportul masÄƒ',0),(526800,14634,'et','Aruande tabel',0),(526801,14634,'si','Tabela poroÄila',0),(526802,14634,'ba','Tabel laporan',0),(526803,14634,'nl','Verslag tabel',0),(526804,14634,'fi','Raporttitaulu',0),(526805,14634,'no','Tabellen til rapporten',0),(526806,14634,'da','Rapporttabel',0),(526807,14634,'ko','ë³´ê³ ì„œ í…Œì´ë¸”',0),(526808,14634,'he','×˜×‘×œ×” ×“×• ×—',0),(526809,14634,'el','Î Î™ÎÎ‘ÎšÎ‘Î£ Î‘ÎÎ‘Î¦ÎŸÎ¡Î©Î',0),(526810,14634,'zh','æŠ¥å‘Šè¡¨æ ¼',0),(526811,14634,'sv','Rapport tabell',0),(526812,14634,'it','Tabella di relazione',0),(526813,14634,'tl','',0),(526814,14634,'th','à¸•à¸²à¸£à¸²à¸‡à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(526815,14634,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(526816,14634,'ms','Jadual Laporan',0),(526817,14634,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(526818,14634,'fr','Tableau de rapport',0),(526819,14634,'jp','ãƒ¬ãƒãƒ¼ãƒˆ ãƒ†ãƒ¼ãƒ–ãƒ«',0),(526820,14634,'pt','Tabela de relatÃ³rio',0),(526821,14634,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð°',0),(526822,14634,'es','Informe mesa',0),(526823,14634,'de','Berichtstabelle',0),(526824,14634,'en','Report Table',0),(526825,14635,'is','',0),(526826,14635,'dr','Ù„ÛŒØ³Øª Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´',0),(526827,14635,'pr','Ù„ÛŒØ³Øª Ù¾Ø±Ø³Ù†Ù„ ÙØ±ÙˆØ´',0),(526828,14635,'tr','SatÄ±ÅŸ personeli listesi',0),(526829,14635,'pl','Lista sprzedawcÃ³w',0),(526830,14635,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð» ÑÐ¿Ð¸ÑÑŠÐº',0),(526831,14635,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø±ÙˆÚº Ú©ÛŒ ÙÛØ±Ø³Øª',0),(526832,14635,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ Ð»Ð¸ÑÑ‚Ð°',0),(526833,14635,'vi','Danh sÃ¡ch nhÃ¢n viÃªn bÃ¡n hÃ ng',0),(526834,14635,'af','Verkope personeel lys',0),(526835,14635,'ro','Lista de personal de vÃ¢nzÄƒri',0),(526836,14635,'et','MÃ¼Ã¼gipersonalile loend',0),(526837,14635,'si','Prodajno osebje seznam',0),(526838,14635,'ba','Daftar penjualan personil',0),(526839,14635,'nl','Verkooppersoneel lijst',0),(526840,14635,'fi','Myynnin yhteystiedot',0),(526841,14635,'no','Selgere listen',0),(526842,14635,'da','Salgspersonalet liste',0),(526843,14635,'ko','íŒë§¤ ì§ì› ëª©ë¡',0),(526844,14635,'he','×¨×©×™×ž×ª ×× ×©×™ ×ž×›×™×¨×•×ª',0),(526845,14635,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿ Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ¿Ï Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(526846,14635,'zh','é”€å”®äººå‘˜åå•',0),(526847,14635,'sv','FÃ¶rsÃ¤ljningspersonal lista',0),(526848,14635,'it','Elenco del personale di vendita',0),(526849,14635,'tl','',0),(526850,14635,'th','à¸£à¸²à¸¢à¸Šà¸·à¹ˆà¸­à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢',0),(526851,14635,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚ à¤¸à¥‚à¤šà¥€',0),(526852,14635,'ms','Senarai kakitangan jualan',0),(526853,14635,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¨Ù…ÙˆØ¸ÙÙŠ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(526854,14635,'fr','Liste du Personnel de vente',0),(526855,14635,'jp','å–¶æ¥­æ‹…å½“è€…ã®ãƒªã‚¹ãƒˆ',0),(526856,14635,'pt','Lista do pessoal de vendas',0),(526857,14635,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð¾Ð²',0),(526858,14635,'es','Lista de personal de ventas',0),(526859,14635,'de','Verkaufspersonal Liste',0),(526860,14635,'en','Sales Personnel List',0),(526861,14636,'is','',0),(526862,14636,'dr','Ø°Ø®ÛŒØ±Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù†',0),(526863,14636,'pr','Ø°Ø®ÛŒØ±Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù†',0),(526864,14636,'tr','FarklÄ± Kaydet',0),(526865,14636,'pl','Zapisz jako',0),(526866,14636,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ ÐºÐ°Ñ‚Ð¾',0),(526867,14636,'ur','Ù…Ø­ÙÙˆØ¸ Ø¨Ø·ÙˆØ±',0),(526868,14636,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ ÐºÐ°Ð¾',0),(526869,14636,'vi','LÆ°u nhÆ°',0),(526870,14636,'af','Stoor as',0),(526871,14636,'ro','Salvare ca',0),(526872,14636,'et','Salvesta nimega',0),(526873,14636,'si','Shrani kot',0),(526874,14636,'ba','Simpan sebagai',0),(526875,14636,'nl','Opslaan als',0),(526876,14636,'fi','Tallenna nimellÃ¤',0),(526877,14636,'no','Lagre som',0),(526878,14636,'da','Gem som',0),(526879,14636,'ko','ë‹¤ë¥¸ ì´ë¦„ìœ¼ë¡œ ì €ìž¥',0),(526880,14636,'he','×©×ž×™×¨×” ×‘×©×',0),(526881,14636,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï‰Ï‚',0),(526882,14636,'zh','å¦å­˜ä¸º',0),(526883,14636,'sv','Spara som',0),(526884,14636,'it','Salva come',0),(526885,14636,'tl','',0),(526886,14636,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸›à¹‡à¸™',0),(526887,14636,'hi','à¤‡à¤¸ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(526888,14636,'ms','Simpan sebagai',0),(526889,14636,'ar','Ø­ÙØ¸ Ø¨Ø§Ø³Ù…',0),(526890,14636,'fr','Enregistrer en tant que',0),(526891,14636,'jp','åå‰ã‚’ä»˜ã‘ã¦ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(526892,14636,'pt','Salvar como',0),(526893,14636,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ ÐºÐ°Ðº',0),(526894,14636,'es','Guardar como',0),(526895,14636,'de','Speichern als',0),(526896,14636,'en','Save as',0),(526897,14637,'is','',0),(526898,14637,'dr','Ù…Ù†ÙˆÛŒ Ø¬Ø§Ù†Ø¨ÛŒ',0),(526899,14637,'pr','Ù…Ù†ÙˆÛŒ Ø¬Ø§Ù†Ø¨ÛŒ',0),(526900,14637,'tr','Yan menÃ¼',0),(526901,14637,'pl','Boczne Menu',0),(526902,14637,'bg','Ð“Ð»Ð°Ð²Ð½Ð¾Ñ‚Ð¾ Ð¼ÐµÐ½ÑŽ',0),(526903,14637,'ur','Ø³Ø§Ø¦ÛŒÚˆ Ù…ÛŒÙ†Ùˆ',0),(526904,14637,'sr','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸ Ð¼ÐµÐ½Ð¸Ñ˜Ð°',0),(526905,14637,'vi','ÄÆ¡n bÃªn',0),(526906,14637,'af','Kant kieslys',0),(526907,14637,'ro','Meniul',0),(526908,14637,'et','Vasakpoolsest menÃ¼Ã¼st',0),(526909,14637,'si','Strani menija',0),(526910,14637,'ba','Menu samping',0),(526911,14637,'nl','Kant Menu',0),(526912,14637,'fi','Sivupalkista',0),(526913,14637,'no','Menyen',0),(526914,14637,'da','Sidemenu',0),(526915,14637,'ko','ì‚¬ì´ë“œ ë©”ë‰´',0),(526916,14637,'he','×ª×¤×¨×™×˜ ×¦×“',0),(526917,14637,'el','Î Î»ÎµÏ…ÏÎ¬ Î¼ÎµÎ½Î¿Ï',0),(526918,14637,'zh','ä¾§è¾¹èœå•',0),(526919,14637,'sv','Sidan menyn',0),(526920,14637,'it','Menu laterale',0),(526921,14637,'tl','',0),(526922,14637,'th','à¹€à¸¡à¸™à¸¹à¸”à¹‰à¸²à¸™à¸‚à¹‰à¸²à¸‡',0),(526923,14637,'hi','à¤ªà¤•à¥à¤· à¤®à¥‡à¤¨à¥‚',0),(526924,14637,'ms','Menu sampingan',0),(526925,14637,'ar','Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¬Ø§Ù†Ø¨ÙŠØ©',0),(526926,14637,'fr','Menu latÃ©ral',0),(526927,14637,'jp','ã‚µã‚¤ãƒ‰ ãƒ¡ãƒ‹ãƒ¥ãƒ¼',0),(526928,14637,'pt','Menu lateral',0),(526929,14637,'ru','Ð‘Ð¾ÐºÐ¾Ð²Ð¾Ðµ Ð¼ÐµÐ½ÑŽ',0),(526930,14637,'es','MenÃº lateral',0),(526931,14637,'de','SeitenmenÃ¼',0),(526932,14637,'en','Side Menu',0),(526933,14638,'is','',0),(526934,14638,'dr','ØµÙØ­Ù‡ Ú¯Ø³ØªØ±Ø¯Ù‡',0),(526935,14638,'pr','ØµÙØ­Ù‡ Ú¯Ø³ØªØ±Ø¯Ù‡',0),(526936,14638,'tr','Elektronik tablo',0),(526937,14638,'pl','Arkusz kalkulacyjny',0),(526938,14638,'bg','Ð•Ð»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(526939,14638,'ur','Ú¯ÙˆØ´ÙˆØ§Ø±Û',0),(526940,14638,'sr','Ð£Ð½Ð°ÐºÑ€ÑÐ½Ðµ Ñ‚Ð°Ð±ÐµÐ»Ðµ',0),(526941,14638,'vi','Báº£ng tÃ­nh',0),(526942,14638,'af','Sigblad',0),(526943,14638,'ro','Foaie de calcul',0),(526944,14638,'et','Arvutustabeli',0),(526945,14638,'si','Preglednica',0),(526946,14638,'ba','Spreadsheet',0),(526947,14638,'nl','Werkblad',0),(526948,14638,'fi','Laskentataulukon',0),(526949,14638,'no','Regneark',0),(526950,14638,'da','Regneark',0),(526951,14638,'ko','ìŠ¤í”„ë ˆë“œì‹œíŠ¸',0),(526952,14638,'he','×’×™×œ×™×•×Ÿ ××œ×§×˜×¨×•× ×™',0),(526953,14638,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ¿Ï Ï†ÏÎ»Î»Î¿Ï…',0),(526954,14638,'zh','ç”µå­è¡¨æ ¼',0),(526955,14638,'sv','Kalkylblad',0),(526956,14638,'it','Foglio di calcolo',0),(526957,14638,'tl','',0),(526958,14638,'th','à¸à¸£à¸°à¸”à¸²à¸©à¸„à¸³à¸™à¸§à¸“',0),(526959,14638,'hi','à¤¸à¥à¤ªà¥à¤°à¥‡à¤¡à¤¶à¥€à¤Ÿ',0),(526960,14638,'ms','Hamparan',0),(526961,14638,'ar','Ø¬Ø¯ÙˆÙ„ Ø¨ÙŠØ§Ù†Ø§Øª',0),(526962,14638,'fr','Feuille de calcul',0),(526963,14638,'jp','ã‚¹ãƒ—ãƒ¬ãƒƒãƒ‰ã‚·ãƒ¼ãƒˆ',0),(526964,14638,'pt','Folha de cÃ¡lculo',0),(526965,14638,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(526966,14638,'es','Hoja de cÃ¡lculo',0),(526967,14638,'de','Tabellenkalkulation',0),(526968,14638,'en','Spreadsheet',0),(526969,14639,'is','',0),(526970,14639,'dr','Ø²ÛŒØ± Ú¯Ø±ÙˆÙ‡ Ø²Ù…ÛŒÙ†Ù‡',0),(526971,14639,'pr','Ø²ÛŒØ± Ú¯Ø±ÙˆÙ‡ Ø²Ù…ÛŒÙ†Ù‡',0),(526972,14639,'tr','Alt grup arka plan',0),(526973,14639,'pl','Grupa pod tÅ‚o',0),(526974,14639,'bg','Ð¡ÑƒÐ± Ð³Ñ€ÑƒÐ¿Ð° Ñ„Ð¾Ð½',0),(526975,14639,'ur','Ø°ÛŒÙ„ÛŒ Ú¯Ø±ÙˆÙ¾ Ù¾Ø³ Ù…Ù†Ø¸Ø±',0),(526976,14639,'sr','ÐŸÐ¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð° Ð³Ñ€ÑƒÐ¿Ðµ Ð¿Ð¾Ð·Ð°Ð´Ð¸Ð½Ðµ',0),(526977,14639,'vi','Tiá»ƒu nhÃ³m ná»n',0),(526978,14639,'af','Sub-groep agtergrond',0),(526979,14639,'ro','Grupa sub fundal',0),(526980,14639,'et','Sub Group taust',0),(526981,14639,'si','Sub skupine ozadje',0),(526982,14639,'ba','Sub kumpulan latar belakang',0),(526983,14639,'nl','Sub-groep achtergrond',0),(526984,14639,'fi','Osalaitteistot ryhmÃ¤ tausta',0),(526985,14639,'no','Sub-gruppen bakgrunn',0),(526986,14639,'da','Sub gruppe baggrund',0),(526987,14639,'ko','í•˜ìœ„ ê·¸ë£¹ ë°°ê²½',0),(526988,14639,'he','×ª×ª ×§×‘×•×¦×” ×¨×§×¢',0),(526989,14639,'el','Î¥Ï€Î¿ Î¿Î¼Î¬Î´Î±Ï‚ Ï†ÏŒÎ½Ï„Î¿',0),(526990,14639,'zh','å­ç»„èƒŒæ™¯',0),(526991,14639,'sv','Sub-gruppen bakgrund',0),(526992,14639,'it','Sotto gruppo sfondo',0),(526993,14639,'tl','',0),(526994,14639,'th','à¸žà¸·à¹‰à¸™à¸«à¸¥à¸±à¸‡à¸‚à¸­à¸‡ à¸à¸¥à¸¸à¹ˆà¸¡à¸¢à¹ˆà¸­à¸¢',0),(526995,14639,'hi','à¤‰à¤ª à¤¸à¤®à¥‚à¤¹ à¤ªà¥ƒà¤·à¥à¤ à¤­à¥‚à¤®à¤¿',0),(526996,14639,'ms','Latar belakang kumpulan kecil',0),(526997,14639,'ar','Ø®Ù„ÙÙŠØ© Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„ÙØ±Ø¹ÙŠØ©',0),(526998,14639,'fr','Sup groupe Background',0),(526999,14639,'jp','ã‚µãƒ– ã‚°ãƒ«ãƒ¼ãƒ—èƒŒæ™¯',0),(527000,14639,'pt','Sub grupo plano de fundo',0),(527001,14639,'ru','Sub Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Ñ„Ð¾Ð½',0),(527002,14639,'es','Subgrupo fondo',0),(527003,14639,'de','Untergruppe Hintergrund',0),(527004,14639,'en','Sub Group Background',0),(527005,14640,'is','',0),(527006,14640,'dr','Ù…ØªÙ† Ø²ÛŒØ± Ú¯Ø±ÙˆÙ‡',0),(527007,14640,'pr','Ù…ØªÙ† Ø²ÛŒØ± Ú¯Ø±ÙˆÙ‡',0),(527008,14640,'tr','Alt grup metin',0),(527009,14640,'pl','Grupa sub tekst',0),(527010,14640,'bg','ÐŸÐ¾Ð´ Ð³Ñ€ÑƒÐ¿Ð° Ñ‚ÐµÐºÑÑ‚',0),(527011,14640,'ur','Ø°ÛŒÙ„ÛŒ Ú¯Ø±ÙˆÙ¾ Ù…ØªÙ†',0),(527012,14640,'sr','ÐŸÐ¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð° Ð³Ñ€ÑƒÐ¿Ð° Ñ‚ÐµÐºÑÑ‚',0),(527013,14640,'vi','Tiá»ƒu nhÃ³m vÄƒn báº£n',0),(527014,14640,'af','Sub-groep teks',0),(527015,14640,'ro','Grup de sub Text',0),(527016,14640,'et','Sub Group tekst',0),(527017,14640,'si','Sub skupine besedilo',0),(527018,14640,'ba','Sub kumpulan teks',0),(527019,14640,'nl','Sub-groep tekst',0),(527020,14640,'fi','Osalaitteistot ryhmÃ¤ teksti',0),(527021,14640,'no','Sub grupper tekst',0),(527022,14640,'da','Sub gruppe tekst',0),(527023,14640,'ko','í•˜ìœ„ ê·¸ë£¹ í…ìŠ¤íŠ¸',0),(527024,14640,'he','×§×‘×•×¦×ª ×¡××‘ ×˜×§×¡×˜',0),(527025,14640,'el','ÎšÎµÎ¯Î¼ÎµÎ½Î¿ Ï…Ï€Î¿ Î¿Î¼Î¬Î´Î±Ï‚',0),(527026,14640,'zh','å­ç»„æ–‡æœ¬',0),(527027,14640,'sv','Sub-gruppen Text',0),(527028,14640,'it','Gruppo sub testo',0),(527029,14640,'tl','',0),(527030,14640,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡ à¸à¸¥à¸¸à¹ˆà¸¡à¸¢à¹ˆà¸­à¸¢',0),(527031,14640,'hi','à¤‰à¤ª à¤¸à¤®à¥‚à¤¹ à¤ªà¤¾à¤ ',0),(527032,14640,'ms','Teks sub Kumpulan',0),(527033,14640,'ar','Ù†Øµ Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„ÙØ±Ø¹ÙŠØ©',0),(527034,14640,'fr','Sup groupe texte',0),(527035,14640,'jp','ã‚µãƒ– ã‚°ãƒ«ãƒ¼ãƒ—ã®ãƒ†ã‚­ã‚¹ãƒˆ',0),(527036,14640,'pt','Texto de sub grupo',0),(527037,14640,'ru','Ð¢ÐµÐºÑÑ‚ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Sub',0),(527038,14640,'es','Subgrupo texto',0),(527039,14640,'de','Untergruppe Text',0),(527040,14640,'en','Sub Group Text',0),(527041,14641,'is','',0),(527042,14641,'dr','Ø²ÛŒØ± Ù‡Ø¯Ø±',0),(527043,14641,'pr','Ø²ÛŒØ± Ù‡Ø¯Ø±',0),(527044,14641,'tr','Alt baÅŸlÄ±k',0),(527045,14641,'pl','NagÅ‚Ã³wek sub',0),(527046,14641,'bg','ÐŸÐ¾Ð´ Ð·Ð°Ð³Ð»Ð°Ð²Ð¸ÐµÑ‚Ð¾',0),(527047,14641,'ur','Ø°ÛŒÙ„ÛŒ Ø³Ø±ØªØ­Ø±ÛŒØ±',0),(527048,14641,'sr','ÐŸÐ¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð° Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ð°',0),(527049,14641,'vi','TiÃªu Ä‘á» phá»¥',0),(527050,14641,'af','Sub-opskrif',0),(527051,14641,'ro','Sub antet',0),(527052,14641,'et','Sub pÃ¤is',0),(527053,14641,'si','Pod glavo',0),(527054,14641,'ba','Sub Header',0),(527055,14641,'nl','Sub kop',0),(527056,14641,'fi','Sub otsikko',0),(527057,14641,'no','Sub-overskrift',0),(527058,14641,'da','Sub Header',0),(527059,14641,'ko','í•˜ìœ„ ë¨¸ë¦¬ê¸€',0),(527060,14641,'he','×ª×ª ×›×•×ª×¨×ª',0),(527061,14641,'el','ÎšÎµÏ†Î±Î»Î¯Î´Î± Ï…Ï€Î¿',0),(527062,14641,'zh','å­æ ‡é¢˜',0),(527063,14641,'sv','Sub-huvud',0),(527064,14641,'it','Intestazione sub',0),(527065,14641,'tl','',0),(527066,14641,'th','à¸«à¸±à¸§à¸‚à¹‰à¸­à¸¢à¹ˆà¸­à¸¢',0),(527067,14641,'hi','à¤‰à¤ª à¤¶à¥€à¤°à¥à¤·à¤•',0),(527068,14641,'ms','Sub tajuk',0),(527069,14641,'ar','Ø±Ø£Ø³ sub',0),(527070,14641,'fr','Void Header',0),(527071,14641,'jp','ã‚µãƒ– ãƒ˜ãƒƒãƒ€ãƒ¼',0),(527072,14641,'pt','Sub cabeÃ§alho',0),(527073,14641,'ru','ÐŸÐ¾Ð´Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²Ð¾Ðº',0),(527074,14641,'es','Sub Jefe',0),(527075,14641,'de','Sub-Header',0),(527076,14641,'en','Sub Header',0),(527077,14642,'is','',0),(527078,14642,'dr','Ø²ÛŒØ± Ù†ÙˆØ§Ø± ÙˆØ¸ÛŒÙÙ‡ Ù¾Ø³ Ø²Ù…ÛŒÙ†Ù‡',0),(527079,14642,'pr','Ø²ÛŒØ± Ù†ÙˆØ§Ø± ÙˆØ¸ÛŒÙÙ‡ Ù¾Ø³ Ø²Ù…ÛŒÙ†Ù‡',0),(527080,14642,'tr','Alt gÃ¶rev Ã§ubuÄŸu arka planÄ±',0),(527081,14642,'pl','Pod tÅ‚o paska zadaÅ„',0),(527082,14642,'bg','ÐŸÐ¾Ð´ Ð»ÐµÐ½Ñ‚Ð°Ñ‚Ð° Ñ„Ð¾Ð½',0),(527083,14642,'ur','Ø°ÛŒÙ„ÛŒ Ù¹Ø§Ø³Ú© Ø¨Ø§Ø± Ù¾Ø³ Ù…Ù†Ø¸Ø±',0),(527084,14642,'sr','ÐŸÐ¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð° Ð¿Ð¾Ð·Ð°Ð´Ð¸Ð½Ñƒ Ñ‚Ñ€Ð°ÐºÐµ Ð·Ð°Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(527085,14642,'vi','Sub trÃªn thanh tÃ¡c vá»¥ ná»n',0),(527086,14642,'af','Sub taakbalk agtergrond',0),(527087,14642,'ro','Fundal de Taskbar sub',0),(527088,14642,'et','Sub tegumiriba tausta',0),(527089,14642,'si','Ozadje penzum sub',0),(527090,14642,'ba','Sub Taskbar latar belakang',0),(527091,14642,'nl','Sub Taskbar achtergrond',0),(527092,14642,'fi','Sub tehtÃ¤vÃ¤palkin taustaa',0),(527093,14642,'no','Sub oppgavelinjen bakgrunn',0),(527094,14642,'da','Sub proceslinjen baggrund',0),(527095,14642,'ko','í•˜ìœ„ ìž‘ì—… í‘œì‹œì¤„ ë°°ê²½',0),(527096,14642,'he','×¨×§×¢ ×”×ž×©×™×ž×•×ª sub',0),(527097,14642,'el','Î¥Ï€Î¿ Î´Î¿Ï…Î»ÎµÎ¹Î¬ Ï…Ï€ÏŒÎ²Î±Î¸ÏÎ¿',0),(527098,14642,'zh','å­ä»»åŠ¡æ èƒŒæ™¯',0),(527099,14642,'sv','Sub AktivitetsfÃ¤ltet bakgrund',0),(527100,14642,'it','Sfondo barra delle applicazioni di sub',0),(527101,14642,'tl','',0),(527102,14642,'th','à¸žà¸·à¹‰à¸™à¸«à¸¥à¸±à¸‡à¹à¸–à¸šà¸¢à¹ˆà¸­à¸¢',0),(527103,14642,'hi','à¤‰à¤ª à¤•à¤¾à¤°à¥à¤¯ à¤ªà¤Ÿà¥à¤Ÿà¥€ à¤ªà¥ƒà¤·à¥à¤ à¤­à¥‚à¤®à¤¿',0),(527104,14642,'ms','Latar belakang bar tugas kecil',0),(527105,14642,'ar','Ø®Ù„ÙÙŠØ© Ø´Ø±ÙŠØ· Ø§Ù„Ù…Ù‡Ø§Ù… Ø§Ù„ÙØ±Ø¹ÙŠØ©',0),(527106,14642,'fr','Void / arriÃ¨re-plan de la barre des tÃ¢ches',0),(527107,14642,'jp','ã‚¿ã‚¹ã‚¯ ãƒãƒ¼ã®èƒŒæ™¯ã‚’ã‚µãƒ–ã—ã¾ã™ã€‚',0),(527108,14642,'pt','Sub fundo de barra de tarefas',0),(527109,14642,'ru','Sub Ð¿Ð°Ð½ÐµÐ»Ð¸ Ð·Ð°Ð´Ð°Ñ‡ Ñ„Ð¾Ð½',0),(527110,14642,'es','Sub fondo de la barra de tareas',0),(527111,14642,'de','Sub Taskbar Hintergrund',0),(527112,14642,'en','Sub Taskbar Background',0),(527113,14643,'is','',0),(527114,14643,'dr','Ù…ØªÙ† Ø²ÛŒØ± Ù†ÙˆØ§Ø± ÙˆØ¸ÛŒÙÙ‡',0),(527115,14643,'pr','Ù…ØªÙ† Ø²ÛŒØ± Ù†ÙˆØ§Ø± ÙˆØ¸ÛŒÙÙ‡',0),(527116,14643,'tr','Alt gÃ¶rev Ã§ubuÄŸundaki metni',0),(527117,14643,'pl','Sub tekst paska zadaÅ„',0),(527118,14643,'bg','ÐŸÐ¾Ð´ Ð»ÐµÐ½Ñ‚Ð°Ñ‚Ð° Ñ‚ÐµÐºÑÑ‚',0),(527119,14643,'ur','Ø°ÛŒÙ„ÛŒ Ù¹Ø§Ø³Ú© Ø¨Ø§Ø± Ù…ØªÙ†',0),(527120,14643,'sr','ÐŸÐ¾Ð´Ð¼Ð¾Ñ€Ð½Ð¸Ñ†Ð° Ñ‚ÐµÐºÑÑ‚ Ð½Ð° Ñ‚Ñ€Ð°Ñ†Ð¸ Ð·Ð°Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(527121,14643,'vi','Tiá»ƒu vÄƒn báº£n trÃªn thanh tÃ¡c vá»¥',0),(527122,14643,'af','Sub taakbalk teks',0),(527123,14643,'ro','Text de Taskbar sub',0),(527124,14643,'et','Sub tegumiriba tekst',0),(527125,14643,'si','Sub opravilne vrstice besedila',0),(527126,14643,'ba','Sub Taskbar teks',0),(527127,14643,'nl','Sub Taskbar tekst',0),(527128,14643,'fi','Sub tehtÃ¤vÃ¤palkin teksti',0),(527129,14643,'no','Sub oppgavelinjen tekst',0),(527130,14643,'da','Sub proceslinjen tekst',0),(527131,14643,'ko','í•˜ìœ„ ìž‘ì—… í‘œì‹œì¤„ í…ìŠ¤íŠ¸',0),(527132,14643,'he','×¡××‘ ×˜×§×¡×˜ ×©×•×¨×ª ×”×ž×©×™×ž×•×ª',0),(527133,14643,'el','Î¥Ï€Î¿ ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î· Î³ÏÎ±Î¼Î¼Î® ÎµÏÎ³Î±ÏƒÎ¹ÏŽÎ½',0),(527134,14643,'zh','å­ä»»åŠ¡æ æ–‡æœ¬',0),(527135,14643,'sv','Sub AktivitetsfÃ¤ltet Text',0),(527136,14643,'it','Sub testo sulla barra delle applicazioni',0),(527137,14643,'tl','',0),(527138,14643,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¹à¸–à¸šà¸¢à¹ˆà¸­à¸¢',0),(527139,14643,'hi','à¤‰à¤ª à¤•à¤¾à¤°à¥à¤¯ à¤ªà¤Ÿà¥à¤Ÿà¥€ à¤ªà¤¾à¤ ',0),(527140,14643,'ms','Sub teks bar tugas',0),(527141,14643,'ar','Ù†Øµ Ø´Ø±ÙŠØ· Ø§Ù„Ù…Ù‡Ø§Ù… Ø§Ù„ÙØ±Ø¹ÙŠØ©',0),(527142,14643,'fr','Void / texte de la barre des tÃ¢ches',0),(527143,14643,'jp','ã‚¿ã‚¹ã‚¯ ãƒãƒ¼ã®ãƒ†ã‚­ã‚¹ãƒˆã‚’ã‚µãƒ–ã—ã¾ã™ã€‚',0),(527144,14643,'pt','Sub texto de barra de tarefas',0),(527145,14643,'ru','Ð¢ÐµÐºÑÑ‚ Ð·Ð°Ð´Ð°Ñ‡ Sub',0),(527146,14643,'es','Sub texto de la barra de tareas',0),(527147,14643,'de','Sub-Taskbar-Text',0),(527148,14643,'en','Sub Taskbar Text',0),(527149,14644,'is','',0),(527150,14644,'dr','Ø³ÛŒØ³ØªÙ…',0),(527151,14644,'pr','Ø³ÛŒØ³ØªÙ…',0),(527152,14644,'tr','Sistem',0),(527153,14644,'pl','Systemu',0),(527154,14644,'bg','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð°',0),(527155,14644,'ur','Ù†Ø¸Ø§Ù…',0),(527156,14644,'sr','Ð¡Ð¸ÑÑ‚ÐµÐ¼',0),(527157,14644,'vi','Há»‡ thá»‘ng',0),(527158,14644,'af','Stelsel',0),(527159,14644,'ro','Sistem',0),(527160,14644,'et','SÃ¼steemi',0),(527161,14644,'si','Sistem',0),(527162,14644,'ba','Sistem',0),(527163,14644,'nl','Systeem',0),(527164,14644,'fi','JÃ¤rjestelmÃ¤n',0),(527165,14644,'no','Systemet',0),(527166,14644,'da','System',0),(527167,14644,'ko','ì‹œìŠ¤í…œ',0),(527168,14644,'he','×ž×¢×¨×›×ª',0),(527169,14644,'el','Î£ÏÏƒÏ„Î·Î¼Î±',0),(527170,14644,'zh','ç³»ç»Ÿ',0),(527171,14644,'sv','System',0),(527172,14644,'it','Sistema',0),(527173,14644,'tl','',0),(527174,14644,'th','à¸£à¸°à¸šà¸š',0),(527175,14644,'hi','à¤ªà¥à¤°à¤£à¤¾à¤²à¥€',0),(527176,14644,'ms','Sistem',0),(527177,14644,'ar','Ù†Ø¸Ø§Ù…',0),(527178,14644,'fr','SystÃ¨me',0),(527179,14644,'jp','ã‚·ã‚¹ãƒ†ãƒ ',0),(527180,14644,'pt','Sistema',0),(527181,14644,'ru','Ð¡Ð¸ÑÑ‚ÐµÐ¼Ð°',0),(527182,14644,'es','Sistema',0),(527183,14644,'de','System',0),(527184,14644,'en','System',0),(527185,14645,'is','',0),(527186,14645,'dr','Ù„ÛŒØ³Øª Timeclock',0),(527187,14645,'pr','Ù„ÛŒØ³Øª Timeclock',0),(527188,14645,'tr','TimeClock listesi',0),(527189,14645,'pl','Lista TimeClock',0),(527190,14645,'bg','TimeClock ÑÐ¿Ð¸ÑÑŠÐº',0),(527191,14645,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ú©ÛŒ ÙÛØ±Ø³Øª',0),(527192,14645,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº Ð»Ð¸ÑÑ‚Ð°',0),(527193,14645,'vi','Danh sÃ¡ch timeclock',0),(527194,14645,'af','Timeclock lys',0),(527195,14645,'ro','Lista de ceas',0),(527196,14645,'et','TimeClock loend',0),(527197,14645,'si','TimeClock seznam',0),(527198,14645,'ba','Daftar timeclock',0),(527199,14645,'nl','Klok lijst',0),(527200,14645,'fi','Timeclock luettelo',0),(527201,14645,'no','TimeClock liste',0),(527202,14645,'da','Timeclock liste',0),(527203,14645,'ko','Timeclock ëª©ë¡',0),(527204,14645,'he','×¨×©×™×ž×ª Timeclock',0),(527205,14645,'el','Î›Î¯ÏƒÏ„Î± Timeclock',0),(527206,14645,'zh','æ‰“å¡é’Ÿåˆ—è¡¨',0),(527207,14645,'sv','Timeclock lista',0),(527208,14645,'it','Elenco Timeclock',0),(527209,14645,'tl','',0),(527210,14645,'th','à¸£à¸²à¸¢à¸à¸²à¸£ Timeclock',0),(527211,14645,'hi','Timeclock à¤¸à¥‚à¤šà¥€',0),(527212,14645,'ms','Senarai Timeclock',0),(527213,14645,'ar','Ù‚Ø§Ø¦Ù…Ø© ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(527214,14645,'fr','Timeclock liste',0),(527215,14645,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ä¸€è¦§',0),(527216,14645,'pt','Lista de timeclock',0),(527217,14645,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº TimeClock',0),(527218,14645,'es','Lista de TimeClock',0),(527219,14645,'de','Timeclock Liste',0),(527220,14645,'en','Timeclock List',0),(527221,14646,'is','',0),(527222,14646,'dr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø²ÛŒØ§Ø¯ÛŒ Ø¨Ø±Ø§ÛŒ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù†',0),(527223,14646,'pr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø²ÛŒØ§Ø¯ÛŒ Ø¨Ø±Ø§ÛŒ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù†',0),(527224,14646,'tr','GÃ¶steri iÃ§in Ã§ok fazla giriÅŸ',0),(527225,14646,'pl','Zbyt wiele wpisÃ³w do PokaÅ¼',0),(527226,14646,'bg','Ð¢Ð²ÑŠÑ€Ð´Ðµ Ð¼Ð½Ð¾Ð³Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ',0),(527227,14646,'ur','Ø´Ùˆ Ú©Û’ Ù„ÛŒÛ’ Ø¨ÛØª Ø²ÛŒØ§Ø¯Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(527228,14646,'sr','ÐŸÑ€ÐµÐ²Ð¸ÑˆÐµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð½Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ñƒ',0),(527229,14646,'vi','QuÃ¡ nhiá»u má»¥c Ä‘á»ƒ hiá»ƒn thá»‹',0),(527230,14646,'af','Te veel inskrywings te wys',0),(527231,14646,'ro','Prea multe intrÄƒri la Show',0),(527232,14646,'et','Liiga palju kirjeid NÃ¤ita',0),(527233,14646,'si','PreveÄ vnosov za Show',0),(527234,14646,'ba','Terlalu banyak entri untuk Tampilkan',0),(527235,14646,'nl','Teveel posten naar Show',0),(527236,14646,'fi','NÃ¤ytÃ¤ liikaa merkintÃ¶jÃ¤',0),(527237,14646,'no','For mange oppfÃ¸ringer til Show',0),(527238,14646,'da','Alt for mange poster til Show',0),(527239,14646,'ko','ë„ˆë¬´ ë§Žì€ í•­ëª© í‘œì‹œ',0),(527240,14646,'he','×¢×¨×›×™× ×¨×‘×™× ×ž×“×™ ×œ×”×¦×’×”',0),(527241,14646,'el','Î Î¬ÏÎ± Ï€Î¿Î»Î»Î­Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î½Î± Ï„Î·Î½ ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ·',0),(527242,14646,'zh','å¯¹æ˜¾ç¤ºçš„æ¡ç›®å¤ªå¤š',0),(527243,14646,'sv','FÃ¶r mÃ¥nga poster att Visa',0),(527244,14646,'it','Troppe voci a Visualizza',0),(527245,14646,'tl','',0),(527246,14646,'th','à¸à¸²à¸£à¸”à¸¹à¸£à¸²à¸¢à¸à¸²à¸£à¸¡à¸²à¸à¹€à¸à¸´à¸™à¹„à¸›',0),(527247,14646,'hi','à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥€ à¤•à¤ˆ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(527248,14646,'ms','Terlalu banyak masukan untuk Papar',0),(527249,14646,'ar','Ø§Ù„Ø¹Ø¯ÙŠØ¯ Ù…Ù† Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ù„Ø¥Ø¸Ù‡Ø§Ø±',0),(527250,14646,'fr','Trop d\'entrÃ©es au spectacle',0),(527251,14646,'jp','è¡¨ç¤ºã™ã‚‹ã‚¨ãƒ³ãƒˆãƒªãŒå¤šã™ãŽã¾ã™ã€‚',0),(527252,14646,'pt','Muitas entradas para o Show',0),(527253,14646,'ru','Ð¡Ð»Ð¸ÑˆÐºÐ¾Ð¼ Ð¼Ð½Ð¾Ð³Ð¾ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ Ð½Ð° ÑˆÐ¾Ñƒ',0),(527254,14646,'es','Demasiadas entradas para mostrar',0),(527255,14646,'de','Zu viele EintrÃ¤ge zu Show',0),(527256,14646,'en','Too Many Entries To Show',0),(527257,14647,'is','',0),(527258,14647,'dr','Ù…Ù†ÙˆÛŒ Ø¨Ø§Ù„Ø§',0),(527259,14647,'pr','Ù…Ù†ÙˆÛŒ Ø¨Ø§Ù„Ø§',0),(527260,14647,'tr','Ãœst menÃ¼',0),(527261,14647,'pl','GÃ³rnym Menu',0),(527262,14647,'bg','Ð“Ð»Ð°Ð²Ð½Ð¾Ñ‚Ð¾ Ð¼ÐµÐ½ÑŽ',0),(527263,14647,'ur','Ø¨Ø§Ù„Ø§ Ù…ÛŒÙ†ÛŒÙˆ',0),(527264,14647,'sr','Ð“Ð¾Ñ€ÑšÐ¸ Ð¼ÐµÐ½Ð¸',0),(527265,14647,'vi','Menu trÃªn cÃ¹ng',0),(527266,14647,'af','Boonste kieslys',0),(527267,14647,'ro','Meniul de sus',0),(527268,14647,'et','Ãœlemine menÃ¼Ã¼',0),(527269,14647,'si','Zgornjem meniju',0),(527270,14647,'ba','Top Menu',0),(527271,14647,'nl','Hoofdmenu',0),(527272,14647,'fi','YlÃ¤valikosta',0),(527273,14647,'no','Menyen Ã¸verst',0),(527274,14647,'da','Top Menu',0),(527275,14647,'ko','ìƒë‹¨ ë©”ë‰´',0),(527276,14647,'he','×ª×¤×¨×™×˜ ×¨××©×™',0),(527277,14647,'el','Î•Ï€Î¬Î½Ï‰ Î¼ÎµÎ½Î¿Ï',0),(527278,14647,'zh','é¡¶éƒ¨çš„èœå•',0),(527279,14647,'sv','Ã–versta menyn',0),(527280,14647,'it','Menu in alto',0),(527281,14647,'tl','',0),(527282,14647,'th','à¹€à¸¡à¸™à¸¹à¸”à¹‰à¸²à¸™à¸šà¸™',0),(527283,14647,'hi','à¤¶à¥€à¤°à¥à¤· à¤®à¥‡à¤¨à¥‚',0),(527284,14647,'ms','Menu atas',0),(527285,14647,'ar','Ø£Ø¹Ù„Ù‰ Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(527286,14647,'fr','Menu du haut',0),(527287,14647,'jp','ãƒˆãƒƒãƒ— ãƒ¡ãƒ‹ãƒ¥ãƒ¼',0),(527288,14647,'pt','Menu superior',0),(527289,14647,'ru','Ð’ÐµÑ€Ñ…Ð½ÐµÐµ Ð¼ÐµÐ½ÑŽ',0),(527290,14647,'es','MenÃº superior',0),(527291,14647,'de','Top-MenÃ¼',0),(527292,14647,'en','Top Menu',0),(527293,14648,'is','',0),(527294,14648,'dr','Ø³Ø¨Ú© ÙˆØ§Ø³Ø· Ú©Ø§Ø±Ø¨Ø±',0),(527295,14648,'pr','Ø³Ø¨Ú© ÙˆØ§Ø³Ø· Ú©Ø§Ø±Ø¨Ø±',0),(527296,14648,'tr','UI stili',0),(527297,14648,'pl','Styl UI',0),(527298,14648,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¸Ð½Ñ‚ÐµÑ€Ñ„ÐµÐ¹Ñ ÑÑ‚Ð¸Ð»',0),(527299,14648,'ur','UI Ø·Ø±Ø²',0),(527300,14648,'sr','Ð£Ð˜ ÑÑ‚Ð¸Ð»',0),(527301,14648,'vi','Giao diá»‡n ngÆ°á»i dÃ¹ng phong cÃ¡ch',0),(527302,14648,'af','UI-styl',0),(527303,14648,'ro','UI stil',0),(527304,14648,'et','Kasutajaliidese stiil',0),(527305,14648,'si','Slog uporabniÅ¡kega vmesnika',0),(527306,14648,'ba','Gaya UI',0),(527307,14648,'nl','UI stijl',0),(527308,14648,'fi','UI-tyylin',0),(527309,14648,'no','Stilen',0),(527310,14648,'da','UI stil',0),(527311,14648,'ko','UI ìŠ¤íƒ€ì¼',0),(527312,14648,'he','×¡×’× ×•×Ÿ ×ž×ž×©×§ ×”×ž×©×ª×ž×©',0),(527313,14648,'el','Î£Ï„Ï…Î» UI',0),(527314,14648,'zh','ç”¨æˆ·ç•Œé¢æ ·å¼',0),(527315,14648,'sv','UI stil',0),(527316,14648,'it','Interfaccia utente stile',0),(527317,14648,'tl','',0),(527318,14648,'th','à¸£à¸¹à¸›à¹à¸šà¸š UI',0),(527319,14648,'hi','UI à¤¶à¥ˆà¤²à¥€',0),(527320,14648,'ms','UI gaya',0),(527321,14648,'ar','Ù†Ù…Ø· ÙˆØ§Ø¬Ù‡Ø© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(527322,14648,'fr','Interface utilisateur Style',0),(527323,14648,'jp','UI ã‚¹ã‚¿ã‚¤ãƒ«',0),(527324,14648,'pt','Estilo de interface do usuÃ¡rio',0),(527325,14648,'ru','Ð¡Ñ‚Ð¸Ð»ÑŒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ð³Ð¾ Ð¸Ð½Ñ‚ÐµÑ€Ñ„ÐµÐ¹ÑÐ°',0),(527326,14648,'es','Estilo de interfaz de usuario',0),(527327,14648,'de','UI Style',0),(527328,14648,'en','UI Style',0),(527329,14649,'is','',0),(527330,14649,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø±Ú©Øª Ø³Ø¨Ú©',0),(527331,14649,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø±Ú©Øª Ø³Ø¨Ú©',0),(527332,14649,'tr','KullanÄ±m ÅŸirket tarzÄ±',0),(527333,14649,'pl','Firma wykorzystanie stylu',0),(527334,14649,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ñ„Ð¸Ñ€Ð¼ÐµÐ½ ÑÑ‚Ð¸Ð»',0),(527335,14649,'ur','Ø·Ø±Ø² Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ù…Ù¾Ù†ÛŒ',0),(527336,14649,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ ÑÑ‚Ð¸Ð»',0),(527337,14649,'vi','CÃ´ng ty sá»­ dá»¥ng phong cÃ¡ch',0),(527338,14649,'af','Gebruik maatskappy styl',0),(527339,14649,'ro','Utilizarea companie stil',0),(527340,14649,'et','Kasuta ettevÃµtte stiil',0),(527341,14649,'si','Podjetje uporabi slog',0),(527342,14649,'ba','Perusahaan menggunakan gaya',0),(527343,14649,'nl','Gebruik huisstijl',0),(527344,14649,'fi','KÃ¤ytÃ¤ yrityksen tyyli',0),(527345,14649,'no','Bruk selskapet stil',0),(527346,14649,'da','Brug selskab stil',0),(527347,14649,'ko','ì‚¬ìš© íšŒì‚¬ ìŠ¤íƒ€ì¼',0),(527348,14649,'he','×”×—×‘×¨×” ×©×™×ž×•×© ×‘×¡×’× ×•×Ÿ',0),(527349,14649,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± Ï‡ÏÎ®ÏƒÎ· ÏƒÏ„Ï…Î»',0),(527350,14649,'zh','ä½¿ç”¨å…¬å¸çš„é£Žæ ¼',0),(527351,14649,'sv','AnvÃ¤nda fÃ¶retagets stil',0),(527352,14649,'it','Uso azienda stile',0),(527353,14649,'tl','',0),(527354,14649,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¹ƒà¸Šà¹‰à¹à¸šà¸š',0),(527355,14649,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚ à¤¶à¥ˆà¤²à¥€',0),(527356,14649,'ms','Syarikat menggunakan gaya',0),(527357,14649,'ar','Ù†Ù…Ø· Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ø´Ø±ÙƒØ©',0),(527358,14649,'fr','Utilisation sociÃ©tÃ© Style',0),(527359,14649,'jp','ä½¿ç”¨ã™ã‚‹ä¼šç¤¾ã®ã‚¹ã‚¿ã‚¤ãƒ«',0),(527360,14649,'pt','Estilo de uso empresa',0),(527361,14649,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð½Ð¾Ð³Ð¾ ÑÑ‚Ð¸Ð»Ñ',0),(527362,14649,'es','Estilo de uso empresa',0),(527363,14649,'de','Verwendung Unternehmen Stil',0),(527364,14649,'en','Use Company Style',0),(527365,14650,'is','',0),(527366,14650,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø³ÛŒØ³ØªÙ… Ø³Ø¨Ú©',0),(527367,14650,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø³ÛŒØ³ØªÙ… Ø³Ø¨Ú©',0),(527368,14650,'tr','Sistem stilini kullan',0),(527369,14650,'pl','System stylu',0),(527370,14650,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼Ð° ÑÑ‚Ð¸Ð»',0),(527371,14650,'ur','Ù†Ø¸Ø§Ù… Ø·Ø±Ø² Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(527372,14650,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼ÑÐºÐ¸ ÑÑ‚Ð¸Ð»',0),(527373,14650,'vi','Sá»­ dá»¥ng há»‡ thá»‘ng phong cÃ¡ch',0),(527374,14650,'af','Stelsel styl gebruik',0),(527375,14650,'ro','Utilizarea sistemului de stil',0),(527376,14650,'et','Kasutage sÃ¼steemi laadi',0),(527377,14650,'si','Uporabo sistema slog',0),(527378,14650,'ba','Menggunakan sistem gaya',0),(527379,14650,'nl','Gebruik systeem stijl',0),(527380,14650,'fi','KÃ¤ytÃ¤ jÃ¤rjestelmÃ¤n tyyliÃ¤',0),(527381,14650,'no','Bruke System-stil',0),(527382,14650,'da','Brug System stil',0),(527383,14650,'ko','ì‹œìŠ¤í…œ ìŠ¤íƒ€ì¼ ì‚¬ìš©',0),(527384,14650,'he','×”×©×ª×ž×© ×‘×¡×’× ×•×Ÿ ×ž×¢×¨×›×ª',0),(527385,14650,'el','Î§ÏÎ®ÏƒÎ· ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚ ÏƒÏ„Ï…Î»',0),(527386,14650,'zh','ä½¿ç”¨ç³»ç»Ÿæ ·å¼',0),(527387,14650,'sv','AnvÃ¤nda systemet stil',0),(527388,14650,'it','Utilizzare il sistema stile',0),(527389,14650,'tl','',0),(527390,14650,'th','à¹ƒà¸Šà¹‰à¸£à¸°à¸šà¸šà¸¥à¸±à¸à¸©à¸“à¸°',0),(527391,14650,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤¶à¥ˆà¤²à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(527392,14650,'ms','Menggunakan gaya sistem',0),(527393,14650,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù†Ù…Ø· Ø§Ù„Ù†Ø¸Ø§Ù…',0),(527394,14650,'fr','Utiliser le systÃ¨me Style',0),(527395,14650,'jp','ã‚·ã‚¹ãƒ†ãƒ ã®ã‚¹ã‚¿ã‚¤ãƒ«ã‚’ä½¿ç”¨',0),(527396,14650,'pt','Use o estilo de sistema',0),(527397,14650,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹ ÑÑ‚Ð¸Ð»ÑŒ',0),(527398,14650,'es','Uso sistema estilo',0),(527399,14650,'de','Verwenden Sie System-Stil',0),(527400,14650,'en','Use System Style',0),(527401,14651,'is','',0),(527402,14651,'dr','ÙˆÙ†Ø¯ÙˆØ± Ù„ÛŒØ³Øª Ø¨ÛŒÙ„',0),(527403,14651,'pr','ÙˆÙ†Ø¯ÙˆØ± Ù„ÛŒØ³Øª Ø¨ÛŒÙ„',0),(527404,14651,'tr','SatÄ±cÄ± fatura listesi',0),(527405,14651,'pl','Lista dostawcÃ³w Bill',0),(527406,14651,'bg','Ð‘Ð¸Ð» ÑÐ¿Ð¸ÑÑŠÐº Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(527407,14651,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ ÙÛØ±Ø³Øª',0),(527408,14651,'sr','Ð‘Ð¸Ð» Ð»Ð¸ÑÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(527409,14651,'vi','NhÃ  cung cáº¥p hÃ³a Ä‘Æ¡n danh sÃ¡ch',0),(527410,14651,'af','Handelaar Wetsontwerp lys',0),(527411,14651,'ro','ListÄƒ de factura furnizor',0),(527412,14651,'et','Hankija arve loendi',0),(527413,14651,'si','Seznam dobaviteljev raÄun',0),(527414,14651,'ba','Daftar tagihan vendor',0),(527415,14651,'nl','Bill leveranciersoverzicht',0),(527416,14651,'fi','Bill toimittajaluettelo',0),(527417,14651,'no','Bill leverandÃ¸roversikten',0),(527418,14651,'da','Bill kreditorliste',0),(527419,14651,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ ëª©ë¡',0),(527420,14651,'he','×¨×©×™×ž×ª ×©×œ ×‘×™×œ',0),(527421,14651,'el','Bill ÎºÎ±Ï„Î¬Î»Î¿Î³Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½',0),(527422,14651,'zh','æ¡ä¾‹è‰æ¡ˆçš„ä¾›åº”å•†åˆ—è¡¨',0),(527423,14651,'sv','Bill leverantÃ¶rslista',0),(527424,14651,'it','Elenco fattura fornitore',0),(527425,14651,'tl','',0),(527426,14651,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(527427,14651,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤¸à¥‚à¤šà¥€',0),(527428,14651,'ms','Senarai Rang undang-undang penjual.',0),(527429,14651,'ar','Ù‚Ø§Ø¦Ù…Ø© ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…ÙˆØ±Ø¯',0),(527430,14651,'fr','Liste de facture fournisseur',0),(527431,14651,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸ã®ãƒªã‚¹ãƒˆ',0),(527432,14651,'pt','Lista de fornecedores Bill',0),(527433,14651,'ru','Ð‘Ð¸Ð»Ð» ÑÐ¿Ð¸ÑÐ¾Ðº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(527434,14651,'es','Lista de proveedores de Bill',0),(527435,14651,'de','Bill KreditorenÃ¼bersicht',0),(527436,14651,'en','Vendor Bill List',0),(527437,14652,'is','',0),(527438,14652,'dr','ØµÙØ­Ù‡ ÙˆØ¨',0),(527439,14652,'pr','ØµÙØ­Ù‡ ÙˆØ¨',0),(527440,14652,'tr','Web sayfasÄ±',0),(527441,14652,'pl','Strony sieci Web',0),(527442,14652,'bg','Ð£ÐµÐ± ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(527443,14652,'ur','ÙˆÛŒØ¨ Ú©Ø§ ØµÙØ­Û',0),(527444,14652,'sr','WÐµÐ± ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(527445,14652,'vi','Trang web',0),(527446,14652,'af','Webbladsy',0),(527447,14652,'ro','Pagina de web',0),(527448,14652,'et','Veebileht',0),(527449,14652,'si','Spletne strani',0),(527450,14652,'ba','Halaman web',0),(527451,14652,'nl','Webpagina',0),(527452,14652,'fi','Www-sivu',0),(527453,14652,'no','Webside',0),(527454,14652,'da','Webside',0),(527455,14652,'ko','ì›¹ íŽ˜ì´ì§€',0),(527456,14652,'he','×“×£ ××™× ×˜×¨× ×˜',0),(527457,14652,'el','Î™ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î±',0),(527458,14652,'zh','ç½‘é¡µ',0),(527459,14652,'sv','Webbsida',0),(527460,14652,'it','Pagina Web',0),(527461,14652,'tl','',0),(527462,14652,'th','à¹€à¸§à¹‡à¸šà¹€à¸žà¸ˆ',0),(527463,14652,'hi','à¤µà¥‡à¤¬à¤ªà¥‡à¤œ',0),(527464,14652,'ms','Laman web',0),(527465,14652,'ar','ØµÙØ­Ø© ÙˆÙŠØ¨',0),(527466,14652,'fr','Page Web',0),(527467,14652,'jp','Web ãƒšãƒ¼ã‚¸',0),(527468,14652,'pt','PÃ¡gina da Web',0),(527469,14652,'ru','Ð’ÐµÐ±-ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(527470,14652,'es','PÃ¡gina Web',0),(527471,14652,'de','Webseite',0),(527472,14652,'en','Webpage',0),(527473,14653,'is','',0),(527474,14653,'dr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ù…Ø±ÙˆØ±Ú¯Ø± Ú©Ø±ÙˆÙ…',0),(527475,14653,'pr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ù…Ø±ÙˆØ±Ú¯Ø± Ú©Ø±ÙˆÙ…',0),(527476,14653,'tr','Biz krom tarayÄ±cÄ± tavsiye',0),(527477,14653,'pl','Zalecamy przeglÄ…darki Chrome',0),(527478,14653,'bg','ÐÐ¸Ðµ Ð¿Ñ€ÐµÐ¿Ð¾Ñ€ÑŠÑ‡Ð²Ð°Ð¼Ðµ Ð½Ð° Ð±Ñ€Ð°ÑƒÐ·ÑŠÑ€Ð° Chrome',0),(527479,14653,'ur','ÛÙ… Ø³ÙØ§Ø±Ø´ Ú©Ø±ØªÛ’ ÛÛŒÚº Ú©Û Ú©Ø±ÙˆÙ… Ø¨Ø±Ø§Ø¤Ø²Ø±',0),(527480,14653,'sr','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑƒÑ‡ÑƒÑ˜ÐµÐ¼Ð¾ Ñ…Ñ€Ð¾Ð¼Ð° Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‡Ð°',0),(527481,14653,'vi','ChÃºng tÃ´i khuyÃªn báº¡n nÃªn trÃ¬nh duyá»‡t Chrome',0),(527482,14653,'af','Ons beveel die Chrome-blaaier',0),(527483,14653,'ro','Va recomandam browserul Chrome',0),(527484,14653,'et','Soovitame Chrome brauser',0),(527485,14653,'si','PriporoÄamo, da brskalnik Chrome',0),(527486,14653,'ba','Kami merekomendasikan peramban Chrome',0),(527487,14653,'nl','Het is raadzaam de Chrome-Browser',0),(527488,14653,'fi','Suosittelemme Chrome-selain',0),(527489,14653,'no','Vi anbefaler Chrome nettleseren',0),(527490,14653,'da','Vi anbefaler Chrome-browseren',0),(527491,14653,'ko','í¬ë¡¬ ë¸Œë¼ìš°ì €ë¥¼ ê²ƒì´ ì¢‹ìŠµë‹ˆë‹¤.',0),(527492,14653,'he','×× ×• ×ž×ž×œ×™×¦×™× ×‘×“×¤×“×¤×Ÿ ×›×¨×•×',0),(527493,14653,'el','Î£Î±Ï‚ ÏƒÏ…Î½Î¹ÏƒÏ„Î¿ÏÎ¼Îµ Ï„Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Ï€ÎµÏÎ¹Î®Î³Î·ÏƒÎ·Ï‚ Chrome',0),(527494,14653,'zh','æˆ‘ä»¬æŽ¨èçš„ Chrome æµè§ˆå™¨',0),(527495,14653,'sv','Vi rekommenderar webblÃ¤saren Chrome',0),(527496,14653,'it','Si consiglia il Browser Chrome',0),(527497,14653,'tl','',0),(527498,14653,'th','à¹€à¸£à¸²à¸‚à¸­à¹à¸™à¸°à¸™à¸³à¹€à¸šà¸£à¸²à¸§à¹Œà¹€à¸‹à¸­à¸£à¹Œ Chrome',0),(527499,14653,'hi','à¤¹à¤® à¤•à¥à¤°à¥‹à¤® à¤¬à¥à¤°à¤¾à¤‰à¤œà¤¼à¤° à¤•à¥€ à¤¸à¤¿à¤«à¤¾à¤°à¤¿à¤¶',0),(527500,14653,'ms','Kami mengesyorkan pelayar Chrome',0),(527501,14653,'ar','ÙˆÙ†Ø­Ù† Ù†ÙˆØµÙŠ Ø¨Ù…ØªØµÙØ­ ÙƒØ±ÙˆÙ…',0),(527502,14653,'fr','Nous vous recommandons le navigateur Chrome',0),(527503,14653,'jp','Chrome ãƒ–ãƒ©ã‚¦ã‚¶ãƒ¼ã‚’ãŠå‹§ã‚ã—ã¾ã™',0),(527504,14653,'pt','Recomendamos o navegador Chrome',0),(527505,14653,'ru','ÐœÑ‹ Ñ€ÐµÐºÐ¾Ð¼ÐµÐ½Ð´ÑƒÐµÐ¼ Ð±Ñ€Ð°ÑƒÐ·ÐµÑ€ Chrome',0),(527506,14653,'es','Recomendamos el navegador Chrome',0),(527507,14653,'de','Wir empfehlen den Chrombrowser',0),(527508,14653,'en','We Recommend The Chrome Browser',0),(527509,14654,'is','',0),(527510,14654,'dr','Ù…Ø±ÙˆØ±Ú¯Ø± Ø´Ù…Ø§ Ù…Ù†Ø³ÙˆØ® Ø´Ø¯Ù‡ Ø§Ø³Øª Ùˆ Ø¯Ø±Ø³Øª Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ú©Ø§Ø± Ù†Ù…ÛŒ Ú©Ù†Ø¯',0),(527511,14654,'pr','Ù…Ø±ÙˆØ±Ú¯Ø± Ø´Ù…Ø§ Ù…Ù†Ø³ÙˆØ® Ø´Ø¯Ù‡ Ø§Ø³Øª Ùˆ Ø¯Ø±Ø³Øª Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ú©Ø§Ø± Ù†Ù…ÛŒ Ú©Ù†Ø¯',0),(527512,14654,'tr','TarayÄ±cÄ±nÄ±zÄ±n gÃ¼ncel deÄŸil ve bu yazÄ±lÄ±m ile dÃ¼zgÃ¼n Ã§alÄ±ÅŸmayabilir',0),(527513,14654,'pl','Twoja przeglÄ…darka jest przestarzaÅ‚a i moÅ¼e nie dziaÅ‚aÄ‡ poprawnie z tego oprogramowania',0),(527514,14654,'bg','Ð’Ð°ÑˆÐ¸ÑÑ‚ Ð±Ñ€Ð°ÑƒÐ·ÑŠÑ€ Ðµ Ð¾ÑÑ‚Ð°Ñ€ÑÐ»Ð° Ð¸ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¾Ð½Ð¸Ñ€Ð° Ð¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¾ Ñ Ñ‚Ð¾Ð·Ð¸ ÑÐ¾Ñ„Ñ‚ÑƒÐµÑ€',0),(527515,14654,'ur','Ø¢Ù¾ Ú©Û’ Ø¨Ø±Ø§Ø¤Ø²Ø± Ù…ÛŒÚº Ù…ØªØ±ÙˆÚ© ÛÙˆ Ú†Ú©Ø§ ÛÛ’ Ø§ÙˆØ± ØµØ­ÛŒØ­ ÛŒÛ Ø³Ø§ÙÙ¹ ÙˆÛŒØ¦Ø± Ú©Û’ Ø³Ø§ØªÚ¾ Ú©Ø§Ù… Ú©Ø±Û’',0),(527516,14654,'sr','Ð’Ð°Ñˆ Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ‡ Ñ˜Ðµ Ð·Ð°ÑÑ‚Ð°Ñ€ÐµÐ¾ Ð¸ Ð¼Ð¾Ð¶Ð´Ð° Ð½ÐµÑ›Ðµ Ð¸ÑÐ¿Ñ€Ð°Ð²Ð½Ð¾ Ñ€Ð°Ð´Ð¸Ñ‚Ð¸ ÑÐ° Ñ‚Ð¸Ð¼ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð¾Ð¼',0),(527517,14654,'vi','TrÃ¬nh duyá»‡t cá»§a báº¡n lÃ  lá»—i thá»i vÃ  cÃ³ thá»ƒ khÃ´ng hoáº¡t Ä‘á»™ng Ä‘Ãºng vá»›i pháº§n má»m nÃ y',0),(527518,14654,'af','Jou blaaier Is verouderd en kan nie behoorlik funksioneer met hierdie sagteware',0),(527519,14654,'ro','Browser-ul este depÄƒÅŸit ÅŸi nu poate funcÅ£iona corect cu acest Software',0),(527520,14654,'et','Teie brauser on vananenud ja ei pruugi Ãµigesti selle tarkvara',0),(527521,14654,'si','VaÅ¡ brskalnik je zastarel in morda ne bo pravilno delovala s to Software',0),(527522,14654,'ba','Browser Anda sudah usang dan mungkin tidak berfungsi dengan baik dengan perangkat lunak ini',0),(527523,14654,'nl','Uw Browser Is verouderd en werkt mogelijk niet goed met deze Software',0),(527524,14654,'fi','Selaimesi on vanhentunut ja ei ehkÃ¤ toimi oikein tÃ¤mÃ¤n ohjelmiston',0),(527525,14654,'no','Nettleseren er utdaterte og kan ikke ordentlig med denne programvaren',0),(527526,14654,'da','Din Browser er forÃ¦ldet og fungerer muligvis ikke korrekt med denne Software',0),(527527,14654,'ko','ê·€í•˜ì˜ ë¸Œë¼ìš°ì €ëŠ” ì˜¤ëž˜ ëœ ë°ì´ ì†Œí”„íŠ¸ì›¨ì–´ì™€ í•¨ê»˜ ì œëŒ€ë¡œ ìž‘ë™ í•˜ì§€ ì•Šì„ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(527528,14654,'he','×”×“×¤×“×¤×Ÿ ×©×œ×š ×”×•× ×ž×™×•×©×Ÿ, ×œ× ×™×ª×¤×§×“ ×›×¨××•×™ ×¢× ×ª×•×›× ×” ×–×•',0),(527529,14654,'el','Î¤Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Ï€ÎµÏÎ¹Î®Î³Î·ÏƒÎ®Ï‚ ÏƒÎ±Ï‚ ÎµÎ¯Î½Î±Î¹ Î¾ÎµÏ€ÎµÏÎ±ÏƒÎ¼Î­Î½Î· ÎºÎ±Î¹ Î´ÎµÎ½ Î¸Î± Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¿ÏÎ½ ÏƒÏ‰ÏƒÏ„Î¬ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î»Î¿Î³Î¹ÏƒÎ¼Î¹ÎºÏŒ',0),(527530,14654,'zh','æ‚¨çš„æµè§ˆå™¨å·²ç»è¿‡æ—¶ï¼Œå¯èƒ½æ— æ³•æ­£å¸¸ä½¿ç”¨æ­¤è½¯ä»¶',0),(527531,14654,'sv','Din webblÃ¤sare Ã¤r fÃ¶rÃ¥ldrad och kanske inte fungerar korrekt med den hÃ¤r programvaran',0),(527532,14654,'it','Il tuo Browser Ã¨ obsoleto e potrebbe non funzionare correttamente con questo Software',0),(527533,14654,'tl','',0),(527534,14654,'th','à¹€à¸šà¸£à¸²à¸§à¹Œà¹€à¸‹à¸­à¸£à¹Œà¸‚à¸­à¸‡à¸„à¸¸à¸“à¸ˆà¸°à¸¥à¹‰à¸²à¸ªà¸¡à¸±à¸¢ à¹à¸¥à¸°à¸­à¸²à¸ˆà¹„à¸¡à¹ˆà¸—à¸³à¸‡à¸²à¸™à¸­à¸¢à¹ˆà¸²à¸‡à¸–à¸¹à¸à¸•à¹‰à¸­à¸‡ à¸”à¹‰à¸§à¸¢à¸‹à¸­à¸Ÿà¸•à¹Œà¹à¸§à¸£à¹Œà¸™à¸µà¹‰',0),(527535,14654,'hi','à¤†à¤ªà¤•à¤¾ à¤¬à¥à¤°à¤¾à¤‰à¤œà¤¼à¤° à¤ªà¥à¤°à¤¾à¤¨à¤¾ à¤¹à¥ˆ à¤”à¤° à¤‡à¤¸ à¤¸à¥‰à¤«à¤¼à¥à¤Ÿà¤µà¥‡à¤¯à¤° à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ à¥€à¤• à¤¸à¥‡ à¤•à¤¾à¤°à¥à¤¯ à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾',0),(527536,14654,'ms','Pelayar anda adalah ketinggalan zaman dan tidak boleh berfungsi dengan betul dengan perisian ini',0),(527537,14654,'ar','Ø§Ù„Ù…ØªØµÙØ­ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù‚Ø¯ Ø¹ÙØ§ Ø¹Ù„ÙŠÙ‡Ø§ Ø§Ù„Ø²Ù…Ù†ØŒ ÙˆÙ‚Ø¯ Ù„Ø§ ØªØ¹Ù…Ù„ Ø¨Ø´ÙƒÙ„ ØµØ­ÙŠØ­ Ù…Ø¹ Ù‡Ø°Ø§ Ø§Ù„Ø¨Ø±Ù†Ø§Ù…Ø¬',0),(527538,14654,'fr','Votre navigateur est obsolÃ¨te et peut ne pas fonctionner correctement avec ce logiciel',0),(527539,14654,'jp','ãŠä½¿ã„ã®ãƒ–ãƒ©ã‚¦ã‚¶ãƒ¼ãŒå¤ãã€ã“ã®ã‚½ãƒ•ãƒˆã‚¦ã‚§ã‚¢ã§ã¯æ­£å¸¸ã«æ©Ÿèƒ½ã—ãªã„å¯èƒ½æ€§ãŒã‚ã‚Šã¾ã™ã€‚',0),(527540,14654,'pt','Seu navegador estÃ¡ desatualizado e pode nÃ£o funcionar corretamente com este Software',0),(527541,14654,'ru','Ð’Ð°Ñˆ Ð±Ñ€Ð°ÑƒÐ·ÐµÑ€ ÑƒÑÑ‚Ð°Ñ€ÐµÐ» Ð¸ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð½Ð¾Ñ€Ð¼Ð°Ð»ÑŒÐ½Ð¾ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ ÑÑ‚Ð¸Ð¼ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ð½Ñ‹Ð¼ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸ÐµÐ¼',0),(527542,14654,'es','Su navegador estÃ¡ obsoleto y no puede funcionar correctamente con este Software',0),(527543,14654,'de','Ihr Browser ist veraltet und kann mit dieser Software nicht richtig funktionieren',0),(527544,14654,'en','Your Browser Is Outdated and May Not Function Properly With This Software',0),(527545,14655,'is','',0),(527546,14655,'dr','Ù‡Ø¯Ø§ÛŒØª',0),(527547,14655,'pr','Ù‡Ø¯Ø§ÛŒØª',0),(527548,14655,'tr','Yeniden yÃ¶nlendirme',0),(527549,14655,'pl','Przekierowanie',0),(527550,14655,'bg','ÐŸÑ€ÐµÐ½Ð°ÑÐ¾Ñ‡Ð²Ð°Ð½Ðµ',0),(527551,14655,'ur','ØªØ¬ÙˆÛŒØ²Ú©Ø±Ù†Ø§',0),(527552,14655,'sr','ÐŸÑ€ÐµÑƒÑÐ¼ÐµÑ€Ð°Ð²Ð°ÑšÐµ',0),(527553,14655,'vi','Chuyá»ƒn hÆ°á»›ng',0),(527554,14655,'af','Herlei',0),(527555,14655,'ro','Redirectionarea',0),(527556,14655,'et','Ãœmbersuunamine',0),(527557,14655,'si','Preusmerjanje',0),(527558,14655,'ba','Mengarahkan',0),(527559,14655,'nl','Omleiden',0),(527560,14655,'fi','Uudelleenohjaus',0),(527561,14655,'no','Omdirigere',0),(527562,14655,'da','Omdirigere',0),(527563,14655,'ko','ë¦¬ë””ë ‰ì…˜',0),(527564,14655,'he','× ×™×ª×•×‘ ×ž×—×“×©',0),(527565,14655,'el','Î¤Î¿Î½ ÎµÏ€Î±Î½Î±Ï€ÏÎ¿ÏƒÎ±Î½Î±Ï„Î¿Î»Î¹ÏƒÎ¼ÏŒ',0),(527566,14655,'zh','é‡å®šå‘',0),(527567,14655,'sv','Omdirigera',0),(527568,14655,'it','Reindirizzamento',0),(527569,14655,'tl','',0),(527570,14655,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸—à¸´à¸¨à¸—à¸²à¸‡',0),(527571,14655,'hi','à¤ªà¥à¤¨à¤ƒ à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¤¿à¤¤ à¤•à¤° à¤•à¥‡',0),(527572,14655,'ms','Mengubah hala',0),(527573,14655,'ar','Ø¥Ø¹Ø§Ø¯Ø© ØªÙˆØ¬ÙŠÙ‡',0),(527574,14655,'fr','Redirection',0),(527575,14655,'jp','ãƒªãƒ€ã‚¤ãƒ¬ã‚¯ãƒˆ',0),(527576,14655,'pt','Redirecionando',0),(527577,14655,'ru','ÐŸÐµÑ€ÐµÐ½Ð°Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(527578,14655,'es','Redireccionando',0),(527579,14655,'de','Umleiten',0),(527580,14655,'en','Redirecting',0),(527581,14656,'is','',0),(527582,14656,'dr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† API Ø¨Ø±Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ÙˆØ¶Ø¹ÛŒØª 3dcart Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(527583,14656,'pr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† API Ø¨Ø±Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ÙˆØ¶Ø¹ÛŒØª 3dcart Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(527584,14656,'tr','3dcart durumunu gÃ¼ncelleÅŸtirmek geliÅŸmiÅŸ API etkinleÅŸtir',0),(527585,14656,'pl','WÅ‚Ä…cz zaawansowane API, aby zaktualizowaÄ‡ stan 3dcart',0),(527586,14656,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐ°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¸ API, Ð·Ð° Ð´Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚Ðµ 3dcart ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾',0),(527587,14656,'ur','3dcart Ø­Ø§Ù„Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø¹Ù„ÛŒ API Ø§ÛÙ„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(527588,14656,'sr','ÐžÐ¼Ð¾Ð³ÑƒÑ›Ð¸ Ð½Ð°Ð¿Ñ€ÐµÐ´Ð½Ðµ ÐÐŸÐ˜ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð»Ð¸ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(527589,14656,'vi','KÃ­ch hoáº¡t tÃ­nh nÄƒng nÃ¢ng cao API Ä‘á»ƒ cáº­p nháº­t tÃ¬nh tráº¡ng 3dcart',0),(527590,14656,'af','Aktiveer gevorderde API 3dcart Status bywerk',0),(527591,14656,'ro','Permite avansate API pentru a actualiza starea 3dcart',0),(527592,14656,'et','VÃµimaldada tÃ¤iustatud API 3dcart oleku vÃ¤rskendamine',0),(527593,14656,'si','OmogoÄi napredno API za posodobitev 3dcart Status',0),(527594,14656,'ba','Mengaktifkan Advanced API untuk memperbarui 3dcart Status',0),(527595,14656,'nl','Inschakelen van geavanceerde API om 3dcart Status te werken',0),(527596,14656,'fi','Mahdollistaa kehittyneet API 3dcart tilan pÃ¤ivittÃ¤minen',0),(527597,14656,'no','Avanserte API oppdatere 3dcart Status',0),(527598,14656,'da','Aktivere avancerede API til at opdatere 3dcart Status',0),(527599,14656,'ko','ê³ ê¸‰ API 3dcart ìƒíƒœ ì—…ë°ì´ íŠ¸ë¥¼ í™œì„±í™”í•©ë‹ˆë‹¤',0),(527600,14656,'he','×œ××¤×©×¨ API ×ž×ª×§×“×ž×•×ª ×œ×¢×“×›×Ÿ ××ª ×”×ž×¦×‘ 3dcart',0),(527601,14656,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ· API Î³Î¹Î± Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Ï„Î· Î¸Î­ÏƒÎ· 3dcart Î³Î¹Î± Ï€ÏÎ¿Ï‡Ï‰ÏÎ·Î¼Î­Î½Î¿Ï…Ï‚',0),(527602,14656,'zh','å¯ç”¨é«˜çº§ API æ¥æ›´æ–° 3dcart çŠ¶æ€',0),(527603,14656,'sv','Aktivera avancerade API fÃ¶r att uppdatera Status fÃ¶r 3dcart',0),(527604,14656,'it','Enable Advanced API per aggiornare lo Status 3dcart',0),(527605,14656,'tl','',0),(527606,14656,'th','à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™ API à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡à¹€à¸žà¸·à¹ˆà¸­à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸–à¸²à¸™à¸° 3dcart',0),(527607,14656,'hi','à¤‰à¤¨à¥à¤¨à¤¤ API à¤…à¤¦à¥à¤¯à¤¤à¤¨ 3dcart à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤•à¥à¤·à¤® à¤•à¤°à¥‡à¤‚',0),(527608,14656,'ms','Membolehkan maju API untuk mengemaskini 3dcart Status',0),(527609,14656,'ar','ØªÙ…ÙƒÙŠÙ† API Ù…ØªÙ‚Ø¯Ù…Ø© ØªØ­Ø¯ÙŠØ« Ø­Ø§Ù„Ø© 3dcart',0),(527610,14656,'fr','Enable Advanced API pour mettre Ã  jour le statut de 3dcart',0),(527611,14656,'jp','3dcart ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã‚’æ›´æ–°ã™ã‚‹é«˜åº¦ãª API ã‚’æœ‰åŠ¹ã«ã—ã¾ã™ã€‚',0),(527612,14656,'pt','Enable Advanced API para atualizar o Status de 3dcart',0),(527613,14656,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ð¹ API Ð´Ð»Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° 3dcart',0),(527614,14656,'es','Habilitar avanzada API actualizar estado 3dcart',0),(527615,14656,'de','Aktivieren Sie erweiterte API 3dcart Status aktualisieren',0),(527616,14656,'en','Enable Advanced API To Update 3dcart Status',0),(527617,14657,'is','',0),(527618,14657,'dr','ÙˆØ¶Ø¹ÛŒØª Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(527619,14657,'pr','ÙˆØ¶Ø¹ÛŒØª Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(527620,14657,'tr','Durum kullanÄ±lamÄ±yor',0),(527621,14657,'pl','Stan nie dostÄ™pna',0),(527622,14657,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ðµ Ðµ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾',0),(527623,14657,'ur','Ø­Ø§Ù„Øª Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº',0),(527624,14657,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½',0),(527625,14657,'vi','TÃ¬nh tráº¡ng khÃ´ng cÃ³ sáºµn',0),(527626,14657,'af','Status nie beskikbaar nie',0),(527627,14657,'ro','Statuie nu folositor',0),(527628,14657,'et','Olek pole saadaval',0),(527629,14657,'si','Stanje ni na voljo',0),(527630,14657,'ba','Status tidak tersedia',0),(527631,14657,'nl','Status niet beschikbaar',0),(527632,14657,'fi','Tila ei saatavilla',0),(527633,14657,'no','Ikke',0),(527634,14657,'da','Status ikke tilgÃ¦ngelig',0),(527635,14657,'ko','ì‚¬ìš©í•  ìˆ˜ ì—†ëŠ” ìƒíƒœ',0),(527636,14657,'he','×ž×¦×‘ ×œ× ×–×ž×™×Ÿ',0),(527637,14657,'el','Î˜Î­ÏƒÎ· Î¼Î· Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î·',0),(527638,14657,'zh','çŠ¶æ€ä¸å¯ç”¨',0),(527639,14657,'sv','Status inte tillgÃ¤nglig',0),(527640,14657,'it','Stato non disponibile',0),(527641,14657,'tl','',0),(527642,14657,'th','à¸ªà¸–à¸²à¸™à¸°à¹„à¸¡à¹ˆà¸¡à¸µ',0),(527643,14657,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(527644,14657,'ms','Status yang tidak terdapat',0),(527645,14657,'ar','Ø­Ø§Ù„Ø© ØºÙŠØ± Ù…ØªÙˆÙØ±',0),(527646,14657,'fr','Statut non disponible',0),(527647,14657,'jp','çŠ¶æ…‹ã‚’åˆ©ç”¨ã§ãã¾ã›ã‚“ã€‚',0),(527648,14657,'pt','Status nÃ£o disponÃ­vel',0),(527649,14657,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½ÐµÐ´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾',0),(527650,14657,'es','Estado no disponible',0),(527651,14657,'de','Status nicht verfÃ¼gbar',0),(527652,14657,'en','Status Not Available',0),(527653,14658,'is','',0),(527654,14658,'dr','ØªÙ„ÙÙ† 2',0),(527655,14658,'pr','ØªÙ„ÙÙ† 2',0),(527656,14658,'tr','Telefon 2',0),(527657,14658,'pl','Telefon 2',0),(527658,14658,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 2',0),(527659,14658,'ur','ÙÙˆÙ† 2',0),(527660,14658,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 2',0),(527661,14658,'vi','Äiá»‡n thoáº¡i 2',0),(527662,14658,'af','Selfoon 2',0),(527663,14658,'ro','Telefon 2',0),(527664,14658,'et','Telefon 2',0),(527665,14658,'si','Telefon 2',0),(527666,14658,'ba','Telepon 2',0),(527667,14658,'nl','Telefoon 2',0),(527668,14658,'fi','Puhelin 2',0),(527669,14658,'no','Telefon 2',0),(527670,14658,'da','Telefon 2',0),(527671,14658,'ko','ì „í™” 2',0),(527672,14658,'he','×˜×œ×¤×•×Ÿ 2',0),(527673,14658,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î¿ 2',0),(527674,14658,'zh','ç”µè¯ 2',0),(527675,14658,'sv','Telefon 2',0),(527676,14658,'it','Telefono 2',0),(527677,14658,'tl','',0),(527678,14658,'th','à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œ 2',0),(527679,14658,'hi','à¤«à¤¼à¥‹à¤¨ 2',0),(527680,14658,'ms','Telefon 2',0),(527681,14658,'ar','Ø±Ù‚Ù… Ø§Ù„Ù‡Ø§ØªÙ 2',0),(527682,14658,'fr','TÃ©lÃ©phone 2',0),(527683,14658,'jp','é›»è©± 2',0),(527684,14658,'pt','Telefone 2',0),(527685,14658,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ 2',0),(527686,14658,'es','TelÃ©fono: 2',0),(527687,14658,'de','Telefon 2',0),(527688,14658,'en','Phone 2',0),(527689,14659,'is','',0),(527690,14659,'dr','3dcart ÙØ§Ú©ØªÙˆØ± #',0),(527691,14659,'pr','3dcart ÙØ§Ú©ØªÙˆØ± #',0),(527692,14659,'tr','3dcart fatura #',0),(527693,14659,'pl','Faktura 3dcart #',0),(527694,14659,'bg','3dcart Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° #',0),(527695,14659,'ur','3dcart # Ø§Ù†ÙˆØ§Ø¦Ø³',0),(527696,14659,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµÑ‚Ðµ #',0),(527697,14659,'vi','hoÃ¡ Ä‘Æ¡n 3dcart #',0),(527698,14659,'af','3dcart faktuur #',0),(527699,14659,'ro','3dcart factura #',0),(527700,14659,'et','3dcart arve #',0),(527701,14659,'si','3dcart raÄun #',0),(527702,14659,'ba','3dcart faktur #',0),(527703,14659,'nl','3dcart factuur #',0),(527704,14659,'fi','3dcart laskun numero',0),(527705,14659,'no','3dcart fakturanummer',0),(527706,14659,'da','3dcart faktura #',0),(527707,14659,'ko','3dcart ì†¡ìž¥ #',0),(527708,14659,'he','3dcart ×—×©×‘×•× ×™×ª #',0),(527709,14659,'el','3dcart Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ #',0),(527710,14659,'zh','3dcart å‘ç¥¨ #',0),(527711,14659,'sv','3dcart fakturerar #',0),(527712,14659,'it','3Dcart fattura #',0),(527713,14659,'tl','',0),(527714,14659,'th','3dcart à¹ƒà¸š#',0),(527715,14659,'hi','3dcart # à¤šà¤¾à¤²à¤¾à¤¨',0),(527716,14659,'ms','3dcart invois #',0),(527717,14659,'ar','Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© 3dcart',0),(527718,14659,'fr','3Dcart facture #',0),(527719,14659,'jp','3dcart # è«‹æ±‚æ›¸',0),(527720,14659,'pt','3Dcart fatura #',0),(527721,14659,'ru','3dcart ÑÑ‡ÐµÑ‚Ð° #',0),(527722,14659,'es','3DCart factura #',0),(527723,14659,'de','3dcart Rechnung #',0),(527724,14659,'en','3dcart Invoice #',0),(527725,14660,'is','',0),(527726,14660,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ÙˆØ¶Ø¹ÛŒØª',0),(527727,14660,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ÙˆØ¶Ø¹ÛŒØª',0),(527728,14660,'tr','Hata gÃ¼ncelleÅŸtirme durumu',0),(527729,14660,'pl','BÅ‚Ä…d aktualizacji stanu',0),(527730,14660,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾',0),(527731,14660,'ur','Ù†Ù‚Øµ Ø­Ø§Ù„Øª ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(527732,14660,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(527733,14660,'vi','Lá»—i cáº­p nháº­t tráº¡ng thÃ¡i',0),(527734,14660,'af','Fout Outobywerking Status',0),(527735,14660,'ro','Eroare actualizarea statutul',0),(527736,14660,'et','TÃµrge vÃ¤rskendamise olek',0),(527737,14660,'si','Posodabljanje stanje napake',0),(527738,14660,'ba','Kesalahan Update Status',0),(527739,14660,'nl','Fout bijwerken Status',0),(527740,14660,'fi','Virhe pÃ¤ivitettÃ¤essÃ¤ tila',0),(527741,14660,'no','Feilstatus for oppdatering',0),(527742,14660,'da','Opdatering fejlstatus',0),(527743,14660,'ko','ì˜¤ë¥˜ ì—…ë°ì´íŠ¸ ìƒíƒœ',0),(527744,14660,'he','×¢×“×›×•×Ÿ ×ž×¦×‘ ×©×’×™××”',0),(527745,14660,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÏƒÏ†Î¬Î»Î¼Î±Ï„Î¿Ï‚',0),(527746,14660,'zh','é”™è¯¯æ›´æ–°çŠ¶æ€',0),(527747,14660,'sv','Uppdatera felstatus',0),(527748,14660,'it','Errore aggiornamento Status',0),(527749,14660,'tl','',0),(527750,14660,'th','à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(527751,14660,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(527752,14660,'ms','Ralat pengemaskinian Status',0),(527753,14660,'ar','Ø®Ø·Ø£ ÙÙŠ ØªØ­Ø¯ÙŠØ« Ø­Ø§Ù„Ø©',0),(527754,14660,'fr','Statut d\'erreur mise Ã  jour',0),(527755,14660,'jp','ã‚¨ãƒ©ãƒ¼ã®æ›´æ–°ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(527756,14660,'pt','Status de atualizaÃ§Ã£o de erro',0),(527757,14660,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(527758,14660,'es','Estado de error de actualizaciÃ³n',0),(527759,14660,'de','Aktualisierung Fehlerstatus',0),(527760,14660,'en','Error Updating Status',0),(527761,14661,'is','',0),(527762,14661,'dr','ÙˆØ¶Ø¹ÛŒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(527763,14661,'pr','ÙˆØ¶Ø¹ÛŒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ²',0),(527764,14661,'tr','Durumu baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(527765,14661,'pl','Stan pomyÅ›lnie zaktualizowana',0),(527766,14661,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(527767,14661,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(527768,14661,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(527769,14661,'vi','TÃ¬nh tráº¡ng Cáº­p Nháº­t thÃ nh cÃ´ng',0),(527770,14661,'af','Status suksesvol bygewerk',0),(527771,14661,'ro','Statutul actualizat cu succes',0),(527772,14661,'et','Oleku vÃ¤rskendamine Ãµnnestus',0),(527773,14661,'si','Status uspeÅ¡no posodobljena',0),(527774,14661,'ba','Status yang berhasil',0),(527775,14661,'nl','Status bijgewerkt',0),(527776,14661,'fi','Tilan pÃ¤ivitys onnistui',0),(527777,14661,'no','Statusen oppdatert',0),(527778,14661,'da','Status opdateret',0),(527779,14661,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ ìƒíƒœ',0),(527780,14661,'he','×”×ž×¦×‘ ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(527781,14661,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(527782,14661,'zh','å·²æˆåŠŸæ›´æ–°çš„çŠ¶æ€',0),(527783,14661,'sv','Status uppdaterades',0),(527784,14661,'it','Stato aggiornato con successo',0),(527785,14661,'tl','',0),(527786,14661,'th','à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(527787,14661,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(527788,14661,'ms','Status dikemaskini berjaya',0),(527789,14661,'ar','Ø­Ø§Ù„Ø© Ø§Ù„ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(527790,14661,'fr','Statut mis Ã  jour avec succÃ¨s',0),(527791,14661,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚ŒãŸã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(527792,14661,'pt','Status atualizado com sucesso',0),(527793,14661,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(527794,14661,'es','Estado actualizado correctamente',0),(527795,14661,'de','Status erfolgreich aktualisiert',0),(527796,14661,'en','Status Updated Successfully',0),(527797,14662,'is','',0),(527798,14662,'dr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ Ù…Ø´ØªØ±ÛŒ',0),(527799,14662,'pr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ Ù…Ø´ØªØ±ÛŒ',0),(527800,14662,'tr','MÃ¼ÅŸteri baÅŸlangÄ±Ã§ tarihi',0),(527801,14662,'pl','Data rozpoczÄ™cia nabywcy',0),(527802,14662,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(527803,14662,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØªØ§Ø±ÛŒØ®',0),(527804,14662,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(527805,14662,'vi','NgÃ y báº¯t Ä‘áº§u khÃ¡ch hÃ ng',0),(527806,14662,'af','KliÃ«nt begin datum',0),(527807,14662,'ro','Data de Ã®ncepere a clientului',0),(527808,14662,'et','Kliendi alguskuupÃ¤ev',0),(527809,14662,'si','Kupec zaÄetni datum',0),(527810,14662,'ba','Tanggal mulai pelanggan',0),(527811,14662,'nl','Begindatum van de klant',0),(527812,14662,'fi','Asiakas-aloituspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(527813,14662,'no','Kunden startdato',0),(527814,14662,'da','Kunde startdato',0),(527815,14662,'ko','ê³ ê° ì‹œìž‘ ë‚ ì§œ',0),(527816,14662,'he','×ª××¨×™×š ×”×ª×—×œ×” ×©×œ ×”×œ×§×•×—',0),(527817,14662,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(527818,14662,'zh','å®¢æˆ·å¼€å§‹æ—¥æœŸ',0),(527819,14662,'sv','Kunden startdatum',0),(527820,14662,'it','Data di inizio del cliente',0),(527821,14662,'tl','',0),(527822,14662,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(527823,14662,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(527824,14662,'ms','Tarikh mula Baca',0),(527825,14662,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(527826,14662,'fr','Date de dÃ©but de client',0),(527827,14662,'jp','é¡§å®¢ã®é–‹å§‹æ—¥',0),(527828,14662,'pt','Data de inÃ­cio do cliente',0),(527829,14662,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(527830,14662,'es','Fecha de inicio del cliente',0),(527831,14662,'de','Kunden-Startdatum',0),(527832,14662,'en','Customer Start Date',0),(527833,14663,'is','',0),(527834,14663,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø¯Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ ØµÙØ­Ù‡ Ú¯Ø³ØªØ±Ø¯Ù‡',0),(527835,14663,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø¯Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ ØµÙØ­Ù‡ Ú¯Ø³ØªØ±Ø¯Ù‡',0),(527836,14663,'tr','Elektronik tablo programÄ±nda dÃ¼zenleyin',0),(527837,14663,'pl','Edycja programu arkusza kalkulacyjnego',0),(527838,14663,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð² Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð° Ð·Ð° ÐµÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð¸',0),(527839,14663,'ur','Ú¯ÙˆØ´ÙˆØ§Ø±Û Ù¾Ø±ÙˆÚ¯Ø±Ø§Ù… Ù…ÛŒÚº ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(527840,14663,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ñƒ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ñƒ Ð·Ð° Ñ‚Ð°Ð±ÐµÐ»Ð°Ñ€Ð½Ðµ Ð¿Ñ€Ð¾Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(527841,14663,'vi','Chá»‰nh sá»­a trong báº£ng tÃ­nh chÆ°Æ¡ng trÃ¬nh',0),(527842,14663,'af','Redigeer In sigblad Program',0),(527843,14663,'ro','Editare Ã®n Program de calcul tabelar',0),(527844,14663,'et','Tabelarvutusprogrammi redigeerida',0),(527845,14663,'si','Urejanje preglednic',0),(527846,14663,'ba','Edit dalam Spreadsheet Program',0),(527847,14663,'nl','Bewerken In Spreadsheet-programma',0),(527848,14663,'fi','Muokkaa taulukkolaskentaohjelmaan',0),(527849,14663,'no','Redigere i regneark',0),(527850,14663,'da','Redigere i regnearksprogram',0),(527851,14663,'ko','ìŠ¤í”„ë ˆë“œì‹œíŠ¸ í”„ë¡œê·¸ëž¨ì—ì„œ íŽ¸ì§‘',0),(527852,14663,'he','×¢×¨×™×›×ª ×‘×ª×•×›× ×™×ª ×’×™×œ×™×•×Ÿ ××œ×§×˜×¨×•× ×™',0),(527853,14663,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÏŽÎ½ Ï†ÏÎ»Î»Ï‰Î½',0),(527854,14663,'zh','åœ¨ç”µå­è¡¨æ ¼ç¨‹åºä¸­è¿›è¡Œç¼–è¾‘',0),(527855,14663,'sv','Redigera i kalkylbladsprogram',0),(527856,14663,'it','Modificare nel programma di foglio di calcolo',0),(527857,14663,'tl','',0),(527858,14663,'th','à¹à¸à¹‰à¹„à¸‚à¹ƒà¸™à¹‚à¸›à¸£à¹à¸à¸£à¸¡à¸à¸£à¸°à¸”à¸²à¸©à¸„à¸³à¸™à¸§à¸“',0),(527859,14663,'hi','à¤¸à¥à¤ªà¥à¤°à¥‡à¤¡à¤¶à¥€à¤Ÿ à¤ªà¥à¤°à¥‹à¤—à¥à¤°à¤¾à¤® à¤®à¥‡à¤‚ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(527860,14663,'ms','Edit dalam Program hamparan',0),(527861,14663,'ar','ØªØ­Ø±ÙŠØ± ÙÙŠ Ø¨Ø±Ù†Ø§Ù…Ø¬ Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(527862,14663,'fr','Modifier dans tableur',0),(527863,14663,'jp','ã‚¹ãƒ—ãƒ¬ãƒƒãƒ‰ã‚·ãƒ¼ãƒˆ ãƒ—ãƒ­ã‚°ãƒ©ãƒ ã§ç·¨é›†ã—ã¾ã™ã€‚',0),(527864,14663,'pt','Editar no programa de planilha eletrÃ´nica',0),(527865,14663,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð² Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ðµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ñ‹Ñ… Ñ‚Ð°Ð±Ð»Ð¸Ñ†',0),(527866,14663,'es','Editar en programa de hoja de cÃ¡lculo',0),(527867,14663,'de','Im Tabellenkalkulationsprogramm bearbeiten',0),(527868,14663,'en','Edit In Spreadsheet Program',0),(527869,14664,'is','',0),(527870,14664,'dr','ØµØ§Ø¯Ø±Ø§Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ',0),(527871,14664,'pr','ØµØ§Ø¯Ø±Ø§Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ',0),(527872,14664,'tr','MÃ¼ÅŸteri verilerini verme',0),(527873,14664,'pl','Eksport danych klienta',0),(527874,14664,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(527875,14664,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆØ§Ø¦Ù Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(527876,14664,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(527877,14664,'vi','Dá»¯ liá»‡u khÃ¡ch hÃ ng xuáº¥t kháº©u',0),(527878,14664,'af','KliÃ«nt Data uitvoer',0),(527879,14664,'ro','ExportaÅ£i datele clienÅ£ilor',0),(527880,14664,'et','Kliendi andmete eksportimine',0),(527881,14664,'si','Izvoz podatkov o strankah',0),(527882,14664,'ba','Ekspor Data Pelanggan',0),(527883,14664,'nl','Klantgegevens exporteren',0),(527884,14664,'fi','Asiakkaan tietojen vieminen',0),(527885,14664,'no','Eksportere kundedata',0),(527886,14664,'da','Eksportere kundedata',0),(527887,14664,'ko','ê³ ê° ë°ì´í„° ë‚´ë³´ë‚´ê¸°',0),(527888,14664,'he','×™×™×¦×•× × ×ª×•× ×™ ×œ×§×•×—',0),(527889,14664,'el','Î•Î¾Î±Î³Ï‰Î³Î® Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(527890,14664,'zh','å°†å®¢æˆ·æ•°æ®å¯¼å‡º',0),(527891,14664,'sv','Exportera kunddata',0),(527892,14664,'it','Esportare i dati dei clienti',0),(527893,14664,'tl','',0),(527894,14664,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(527895,14664,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(527896,14664,'ms','Eksport Data pelanggan',0),(527897,14664,'ar','ØªØµØ¯ÙŠØ± Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(527898,14664,'fr','Exporter des donnÃ©es de client',0),(527899,14664,'jp','é¡§å®¢ãƒ‡ãƒ¼ã‚¿ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(527900,14664,'pt','Exportar dados do cliente',0),(527901,14664,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(527902,14664,'es','Exportar los datos del cliente',0),(527903,14664,'de','Export von Kundendaten',0),(527904,14664,'en','Export Customer Data',0),(527905,14665,'is','',0),(527906,14665,'dr','Ù…Ø´ØªØ±ÛŒØ§Ù† ØµØ§Ø¯Ø±Ø§Øª ÙØ§ÛŒÙ„',0),(527907,14665,'pr','Ù…Ø´ØªØ±ÛŒØ§Ù† ØµØ§Ø¯Ø±Ø§Øª ÙØ§ÛŒÙ„',0),(527908,14665,'tr','MÃ¼ÅŸteri verme dosyasÄ± al',0),(527909,14665,'pl','Importowanie pliku eksportu klienta',0),(527910,14665,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ñ„Ð°Ð¹Ð» ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(527911,14665,'ur','Ú©Ø³Ù¹Ù…Ø± Ø¨Ø±Ø¢Ù…Ø¯ Ù…Ø³Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(527912,14665,'sr','Ð£Ð²ÐµÐ·Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð·Ð° Ð¸Ð·Ð²Ð¾Ð· ÐºÑƒÐ¿Ñ†Ð°',0),(527913,14665,'vi','Nháº­p khÃ¡ch hÃ ng xuáº¥t kháº©u táº­p tin',0),(527914,14665,'af','Voer kliÃ«nt uitvoer lÃªer',0),(527915,14665,'ro','FiÅŸier de Export import client',0),(527916,14665,'et','Impordi kliendi ekspordi fail',0),(527917,14665,'si','Izvoz datoteke za uvoz strank',0),(527918,14665,'ba','File ekspor impor pelanggan',0),(527919,14665,'nl','Klant Export importbestand',0),(527920,14665,'fi','Tuontitiedoston asiakkaan vienti',0),(527921,14665,'no','Importer kunden eksportfilen',0),(527922,14665,'da','Kunde udfÃ¸rsel importfil',0),(527923,14665,'ko','ê³ ê° ë‚´ë³´ë‚´ê¸° íŒŒì¼ ê°€ì ¸ì˜¤ê¸°',0),(527924,14665,'he','×™×™×‘×•× ×§×•×‘×¥ ×”×™×™×¦×•× ×”×œ×§×•×—',0),(527925,14665,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï… ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(527926,14665,'zh','å¯¼å…¥å®¢æˆ·å¯¼å‡ºæ–‡ä»¶',0),(527927,14665,'sv','Import Export-kundregister',0),(527928,14665,'it','Importazione File di esportazione del cliente',0),(527929,14665,'tl','',0),(527930,14665,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹„à¸Ÿà¸¥à¹Œà¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(527931,14665,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(527932,14665,'ms','Fail eksport import pelanggan',0),(527933,14665,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù„Ù Ø§Ù„ØªØµØ¯ÙŠØ± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(527934,14665,'fr','Importer un fichier client Export',0),(527935,14665,'jp','é¡§å®¢ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ ãƒ•ã‚¡ã‚¤ãƒ«ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(527936,14665,'pt','Importar arquivo de exportaÃ§Ã£o do cliente',0),(527937,14665,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ñ„Ð°Ð¹Ð»Ð° ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(527938,14665,'es','Archivo de exportaciÃ³n importaciÃ³n del cliente',0),(527939,14665,'de','Kunden-Export-Datei importieren',0),(527940,14665,'en','Import Customer Export File',0),(527941,14666,'is','',0),(527942,14666,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ ØªØºÛŒÛŒØ± ÛŒØ§ÙØªÙ‡',0),(527943,14666,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ ØªØºÛŒÛŒØ± ÛŒØ§ÙØªÙ‡',0),(527944,14666,'tr','DeÄŸiÅŸtirilmiÅŸ verileri alma',0),(527945,14666,'pl','PrzywÃ³z zmodyfikowanych danych',0),(527946,14666,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¼Ð¾Ð´Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(527947,14666,'ur','ØªØ±Ù…ÛŒÙ… Ø´Ø¯Û Ú©ÙˆØ§Ø¦Ù Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(527948,14666,'sr','Ð£Ð²Ð¾Ð· Ñ˜Ðµ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ð¾ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(527949,14666,'vi','Nháº­p dá»¯ liá»‡u láº§n',0),(527950,14666,'af','Gemodifiseerde Data invoer',0),(527951,14666,'ro','Import date modificate',0),(527952,14666,'et','Muudetud andmeid importida',0),(527953,14666,'si','Uvoz spremenjeni podatki',0),(527954,14666,'ba','Mengimpor Data dimodifikasi',0),(527955,14666,'nl','Gewijzigde gegevens importeren',0),(527956,14666,'fi','Tuo muutetut tiedot',0),(527957,14666,'no','Importer endret Data',0),(527958,14666,'da','Importer Ã¦ndret Data',0),(527959,14666,'ko','ìˆ˜ì • ëœ ë°ì´í„°ë¥¼ ê°€ì ¸ì˜¤ê¸°',0),(527960,14666,'he','×™×™×‘×•× × ×ª×•× ×™× ×©×©×•× ×•',0),(527961,14666,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(527962,14666,'zh','å¯¼å…¥ä¿®æ”¹åŽçš„æ•°æ®',0),(527963,14666,'sv','Importera Ã¤ndrade Data',0),(527964,14666,'it','Importare dati modificati',0),(527965,14666,'tl','',0),(527966,14666,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸²à¸£à¹à¸à¹‰à¹„à¸‚',0),(527967,14666,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤¡à¥‡à¤Ÿà¤¾ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(527968,14666,'ms','Import Data diubahsuai',0),(527969,14666,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø¹Ø¯Ù„Ø©',0),(527970,14666,'fr','Importer des donnÃ©es modifiÃ©es',0),(527971,14666,'jp','å¤‰æ›´ã•ã‚ŒãŸãƒ‡ãƒ¼ã‚¿ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(527972,14666,'pt','Importar dados modificados',0),(527973,14666,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð½Ñ‹Ñ… Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(527974,14666,'es','ImportaciÃ³n de datos modificados',0),(527975,14666,'de','GeÃ¤nderte Daten importieren',0),(527976,14666,'en','Import Modified Data',0),(527977,14667,'is','',0),(527978,14667,'dr','Ø¹Ø¯Ù… Ø§Ù†ØªØ®Ø§Ø¨ Ù‡Ù…Ù‡',0),(527979,14667,'pr','Ø¹Ø¯Ù… Ø§Ù†ØªØ®Ø§Ø¨ Ù‡Ù…Ù‡',0),(527980,14667,'tr','TÃ¼m iÅŸaretini kaldÄ±rÄ±n',0),(527981,14667,'pl','UsuÅ„ zaznaczenie wszystkich',0),(527982,14667,'bg','Ð Ð°Ð·Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð¹ Ð²ÑÐ¸Ñ‡ÐºÐ¸',0),(527983,14667,'ur','ØªÙ…Ø§Ù… Ø¨Û’ Ù†Ø´Ø§Ù† Ú©Ø±ÛŒÚº',0),(527984,14667,'sr','ÐžÐ¿Ð¾Ð·Ð¾Ð²Ð¸ ÑÐ²Ðµ',0),(527985,14667,'vi','Bá» chá»n táº¥t cáº£',0),(527986,14667,'af','Ontmerk almal',0),(527987,14667,'ro','Debifati toate',0),(527988,14667,'et','TÃ¼hjendage kÃµik',0),(527989,14667,'si','PoÄisti vse',0),(527990,14667,'ba','Hapus centang semua',0),(527991,14667,'nl','Schakel alle',0),(527992,14667,'fi','Poista kaikkien valinta',0),(527993,14667,'no','Fjern alle',0),(527994,14667,'da','Uncheck alle',0),(527995,14667,'ko','ëª¨ë‘ ì„ íƒ ì·¨ì†Œ',0),(527996,14667,'he','×‘×˜×œ ×‘×—×™×¨×”',0),(527997,14667,'el','Î‘Ï€Î¿ÎµÏ€Î¹Î»Î¿Î³Î® ÏŒÎ»Ï‰Î½',0),(527998,14667,'zh','å–æ¶ˆå…¨éƒ¨é€‰ä¸­',0),(527999,14667,'sv','Avmarkera alla',0),(528000,14667,'it','Deseleziona tutto',0),(528001,14667,'tl','',0),(528002,14667,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¹€à¸¥à¸·à¸­à¸à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(528003,14667,'hi','à¤¸à¤­à¥€ à¤•à¥‹ à¤…à¤¨à¤šà¥‡à¤• à¤•à¤°à¥‡à¤‚',0),(528004,14667,'ms','Kosongkan Semua',0),(528005,14667,'ar','Ø¥Ù„ØºØ§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ø§Ù„ÙƒÙ„',0),(528006,14667,'fr','DÃ©cocher tous',0),(528007,14667,'jp','ã™ã¹ã¦ã‚ªãƒ•ã—ã¾ã™ã€‚',0),(528008,14667,'pt','Desmarcar tudo',0),(528009,14667,'ru','Ð¡Ð½ÑÑ‚ÑŒ Ð²ÑÐµ',0),(528010,14667,'es','Desactive todas',0),(528011,14667,'de','Deaktivieren Sie alle',0),(528012,14667,'en','Uncheck All',0),(528013,14668,'is','',0),(528014,14668,'dr','ØªÙ…Ø§Ù… Ø´Ø±Ø­ Ù‡Ø§',0),(528015,14668,'pr','ØªÙ…Ø§Ù… Ø´Ø±Ø­ Ù‡Ø§',0),(528016,14668,'tr','TÃ¼m aÃ§Ä±klamalarÄ±',0),(528017,14668,'pl','Wszystkie opisy',0),(528018,14668,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(528019,14668,'ur','ØªÙ…Ø§Ù… ØªØµØ±ÛŒØ­Ø§Øª',0),(528020,14668,'sr','Ð¡Ð²Ðµ Ð¾Ð¿Ð¸ÑÐµ',0),(528021,14668,'vi','Táº¥t cáº£ cÃ¡c mÃ´ táº£',0),(528022,14668,'af','Alle beskrywings',0),(528023,14668,'ro','Toate descrierile',0),(528024,14668,'et','KÃµik kirjeldused',0),(528025,14668,'si','Vsi opisi',0),(528026,14668,'ba','Semua Deskripsi',0),(528027,14668,'nl','Alle beschrijvingen',0),(528028,14668,'fi','Kaikki kuvaukset',0),(528029,14668,'no','Alle beskrivelser',0),(528030,14668,'da','Alle beskrivelser',0),(528031,14668,'ko','ëª¨ë“  ì„¤ëª…',0),(528032,14668,'he','×›×œ ×”×ª×™××•×¨×™×',0),(528033,14668,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚',0),(528034,14668,'zh','æ‰€æœ‰çš„æè¿°',0),(528035,14668,'sv','Alla beskrivningar',0),(528036,14668,'it','Tutte le descrizioni',0),(528037,14668,'tl','',0),(528038,14668,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(528039,14668,'hi','à¤¸à¤­à¥€ à¤µà¤¿à¤µà¤°à¤£',0),(528040,14668,'ms','Semua penerangan',0),(528041,14668,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø£ÙˆØµØ§Ù',0),(528042,14668,'fr','Toutes les Descriptions',0),(528043,14668,'jp','ã™ã¹ã¦ã®èª¬æ˜Ž',0),(528044,14668,'pt','Todas as descriÃ§Ãµes',0),(528045,14668,'ru','Ð’ÑÐµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(528046,14668,'es','Todas las descripciones',0),(528047,14668,'de','Alle Beschreibungen',0),(528048,14668,'en','All Descriptions',0),(528049,14669,'is','',0),(528050,14669,'dr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø¨Ø±Ø§ÛŒ Ø¨ÛŒØ´ Ø§Ø² ÛŒÚ© Ø³Ø§Ù„',0),(528051,14669,'pr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø¨Ø±Ø§ÛŒ Ø¨ÛŒØ´ Ø§Ø² ÛŒÚ© Ø³Ø§Ù„',0),(528052,14669,'tr','Ä°Ã§in bir yÄ±l iÃ§inde sipariÅŸ vermeyen',0),(528053,14669,'pl','Nie zamÃ³wienia przez ponad rok',0),(528054,14669,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ ÐµÐ´Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(528055,14669,'ur','Ø§ÛŒÚ© Ø³Ø§Ù„ Ø³Û’ Ø²Ø§Ø¦Ø¯ Ú©Û’ Ù„Ø¦Û’ Ú©ÙˆØ¦ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø§Ø±ÛŒ',0),(528056,14669,'sr','ÐÐµÐ¼Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð¿Ñ€ÐµÐºÐ¾ Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(528057,14669,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n Ä‘áº·t hÃ ng cho hÆ¡n má»™t nÄƒm',0),(528058,14669,'af','Geen bestellings vir oor een jaar',0),(528059,14669,'ro','Comenzi pentru peste un an',0),(528060,14669,'et','Ãœhe aasta jooksul pole tellimusi',0),(528061,14669,'si','Brez naroÄila za veÄ kot eno leto',0),(528062,14669,'ba','Tidak ada perintah untuk lebih dari satu tahun',0),(528063,14669,'nl','Geen Orders voor meer dan Ã©Ã©n jaar',0),(528064,14669,'fi','Tilaukset yli vuoden',0),(528065,14669,'no','Ingen ordrer For Over ett Ã¥r',0),(528066,14669,'da','Ingen ordrer pÃ¥ Over et Ã¥r',0),(528067,14669,'ko','1 ë…„ ì´ìƒì— ëŒ€ í•œ ì£¼ë¬¸ì´ ë“¤ì–´ì˜¤ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(528068,14669,'he','×¤×§×•×“×•×ª ×ž×¢×œ ×©× ×”',0),(528069,14669,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ Î³Î¹Î± Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Î­Î½Î± Ï‡ÏÏŒÎ½Î¿',0),(528070,14669,'zh','ä¸€å¹´å¤šæ²¡æœ‰è®¢å•',0),(528071,14669,'sv','Inga bestÃ¤llningar fÃ¶r Ã¶ver ett Ã¥r',0),(528072,14669,'it','Nessun ordine per oltre un anno',0),(528073,14669,'tl','',0),(528074,14669,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸µ',0),(528075,14669,'hi','à¤à¤• à¤µà¤°à¥à¤· à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶',0),(528076,14669,'ms','Pesanan tidak lebih daripada satu tahun',0),(528077,14669,'ar','Ù„Ø§ Ø£ÙˆØ§Ù…Ø± Ù„Ø£ÙƒØ«Ø± Ù…Ù† Ø³Ù†Ø© ÙˆØ§Ø­Ø¯Ø©',0),(528078,14669,'fr','Aucune commande depuis plus d\'un an',0),(528079,14669,'jp','1 å¹´ä»¥ä¸Šã®æ³¨æ–‡ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(528080,14669,'pt','NÃ£o hÃ¡ ordens para mais de um ano',0),(528081,14669,'ru','ÐÐµÑ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð½Ð° Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ð¾Ð´Ð¸Ð½ Ð³Ð¾Ð´',0),(528082,14669,'es','No hay pedidos para mÃ¡s de un aÃ±o',0),(528083,14669,'de','Keine AuftrÃ¤ge fÃ¼r Ã¼ber ein Jahr',0),(528084,14669,'en','No Orders For Over One Year',0),(528085,14670,'is','',0),(528086,14670,'dr','Ù†Ù‡ Ø¯Ø± ÛŒÚ© Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÛŒ Ø³Ø§Ù„',0),(528087,14670,'pr','Ù†Ù‡ Ø¯Ø± ÛŒÚ© Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÛŒ Ø³Ø§Ù„',0),(528088,14670,'tr','YÄ±l boyunca hiÃ§bir sipariÅŸ',0),(528089,14670,'pl','Nie zamÃ³wienia na rok',0),(528090,14670,'bg','Ð—Ð°Ð¿Ð¾Ð²ÐµÐ´ Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(528091,14670,'ur','Ø³Ø§Ù„ Ú©Û’ Ø­Ú©Ù… Ù†ÛÛŒÚº',0),(528092,14670,'sr','ÐÐµÐ¼Ð° Ñ€ÐµÐ´Ð° Ð·Ð° Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(528093,14670,'vi','KhÃ´ng cÃ³ thá»© tá»± cho nÄƒm',0),(528094,14670,'af','Geen bevel vir jaar',0),(528095,14670,'ro','Nici un ordin pentru anul',0),(528096,14670,'et','No selleks, et aasta',0),(528097,14670,'si','Nobenih nalog za leto',0),(528098,14670,'ba','Urutan untuk tahun',0),(528099,14670,'nl','Geen orde voor jaar',0),(528100,14670,'fi','Vuosi ei ole jÃ¤rjestyksessÃ¤',0),(528101,14670,'no','Ingen rekkefÃ¸lge For Ã¥r',0),(528102,14670,'da','Ingen ordre For Ã¥r',0),(528103,14670,'ko','ë…„ ìˆœì„œ ì—†ì´',0),(528104,14670,'he','××™×Ÿ ×¡×“×¨ ×”×©× ×”',0),(528105,14670,'el','ÎšÎ±Î¼Î¯Î± Î´Î¹Î±Ï„Î±Î³Î® Î³Î¹Î± Ï„Î¿ Î­Ï„Î¿Ï‚',0),(528106,14670,'zh','æ²¡æœ‰ä¸€å¹´çš„é¡ºåº',0),(528107,14670,'sv','Ingen ordning i Ã¥r',0),(528108,14670,'it','Nessun ordine per anno',0),(528109,14670,'tl','',0),(528110,14670,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸µ',0),(528111,14670,'hi','à¤¸à¤¾à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶',0),(528112,14670,'ms','Tiada perintah bagi tahun',0),(528113,14670,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªØ±ØªÙŠØ¨ Ù„Ù„Ø³Ù†Ø©',0),(528114,14670,'fr','Aucune commande pour l\'annÃ©e',0),(528115,14670,'jp','å¹´ã®ãŸã‚ã®é †åº',0),(528116,14670,'pt','Nenhuma ordem por ano',0),(528117,14670,'ru','ÐÐµÑ‚ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ð½Ð° Ð³Ð¾Ð´',0),(528118,14670,'es','Ninguna orden por aÃ±o',0),(528119,14670,'de','Keine Bestellung fÃ¼r das Jahr',0),(528120,14670,'en','No Order For Year',0),(528121,14671,'is','',0),(528122,14671,'dr','ÙÙ‚Ø· Ø§ÛŒÙ† ØªÙˆØ¶ÛŒØ­Ø§Øª',0),(528123,14671,'pr','ÙÙ‚Ø· Ø§ÛŒÙ† ØªÙˆØ¶ÛŒØ­Ø§Øª',0),(528124,14671,'tr','Sadece bu aÃ§Ä±klamasÄ±',0),(528125,14671,'pl','Tylko ten opis',0),(528126,14671,'bg','Ð¡Ð°Ð¼Ð¾ Ñ‚Ð¾Ð²Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(528127,14671,'ur','ØµØ±Ù Ø§Ø³ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(528128,14671,'sr','Ð¡Ð°Ð¼Ð¾ Ð¾Ð²Ð°Ñ˜ Ð¾Ð¿Ð¸Ñ',0),(528129,14671,'vi','Chá»‰ nÃ y mÃ´ táº£',0),(528130,14671,'af','Net hierdie Beskrywing',0),(528131,14671,'ro','Numai aceastÄƒ descriere',0),(528132,14671,'et','Ainult see kirjeldus',0),(528133,14671,'si','Le ta opis',0),(528134,14671,'ba','Hanya ini deskripsi',0),(528135,14671,'nl','Alleen deze beschrijving',0),(528136,14671,'fi','TÃ¤mÃ¤ kuvaus',0),(528137,14671,'no','Bare denne beskrivelsen',0),(528138,14671,'da','Kun denne beskrivelse',0),(528139,14671,'ko','ì´ ì„¤ëª…ë§Œ',0),(528140,14671,'he','×¨×§ ×ª×™××•×¨ ×–×”',0),(528141,14671,'el','ÎœÏŒÎ½Î¿ Î±Ï…Ï„Î® Î· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(528142,14671,'zh','ä»…æ­¤è¯´æ˜Ž',0),(528143,14671,'sv','Endast denna beskrivning',0),(528144,14671,'it','Solo questa descrizione',0),(528145,14671,'tl','',0),(528146,14671,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹€à¸‰à¸žà¸²à¸°à¸™à¸µà¹‰',0),(528147,14671,'hi','à¤•à¥‡à¤µà¤² à¤‡à¤¸ à¤µà¤¿à¤µà¤°à¤£',0),(528148,14671,'ms','Hanya huraian ini',0),(528149,14671,'ar','Ø¥Ù„Ø§ Ø£Ù† Ù‡Ø°Ø§ Ø§Ù„ÙˆØµÙ',0),(528150,14671,'fr','Seulement cette Description',0),(528151,14671,'jp','ã“ã®èª¬æ˜Žã®ã¿',0),(528152,14671,'pt','SÃ³ esta descriÃ§Ã£o',0),(528153,14671,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÑÑ‚Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(528154,14671,'es','SÃ³lo esta descripciÃ³n',0),(528155,14671,'de','Nur diese Beschreibung',0),(528156,14671,'en','Only This Description',0),(528157,14672,'is','',0),(528158,14672,'dr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ø¨Ø±Ø¯Ø§Ø±ÛŒ Ø¬Ù‡Øª Ø®Ø§Øµ',0),(528159,14672,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ø¨Ø±Ø¯Ø§Ø±ÛŒ Ø¬Ù‡Øª Ø®Ø§Øµ',0),(528160,14672,'tr','Belirli Order Taker',0),(528161,14672,'pl','PrzyjmujÄ…cy zamÃ³wienie szczegÃ³lne',0),(528162,14672,'bg','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ñ€ÐµÐ´ Taker',0),(528163,14672,'ur','Ù…Ø®ØµÙˆØµ ØªØ±ØªÛŒØ¨ Ù†Ú¯Ø±Ø§Ù†',0),(528164,14672,'sr','ÐžÐ´Ñ€ÐµÑ’ÐµÐ½Ð¾Ð¼ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´Ñƒ Ð³Ñ€Ð°Ð±Ñ™Ð¸Ð²Ð¸Ñ†Ð°',0),(528165,14672,'vi','Thá»© tá»± cá»¥ thá»ƒ Taker',0),(528166,14672,'af','Spesifieke volgorde Taker',0),(528167,14672,'ro','Preluat comanda specifice',0),(528168,14672,'et','Konkreetse tellimuse vastuvÃµtja',0),(528169,14672,'si','Poseben red kupcu',0),(528170,14672,'ba','Pengambil pesanan khusus',0),(528171,14672,'nl','Bepaalde volgorde Taker',0),(528172,14672,'fi','Erityinen jotta saaja',0),(528173,14672,'no','Bestemt rekkefÃ¸lge Taker',0),(528174,14672,'da','Specifikke ordretageren',0),(528175,14672,'ko','íŠ¹ì • ìˆœì„œì— ë”°ë¼ ì¦ê¸´ë‹¤',0),(528176,14672,'he','×”××“× ×©×§×™×‘×œ ×”×–×ž× ×” ×ž×¡×•×™×ž×ª',0),(528177,14672,'el','Î£Ï…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î· ÏƒÎµÎ¹ÏÎ¬ ÎºÏ„Î®Ï„Î¿ÏÎ±Ï‚',0),(528178,14672,'zh','å…·ä½“ç‚¹å•å‘˜',0),(528179,14672,'sv','SÃ¤rskilda ordermottagaren',0),(528180,14672,'it','Taker ordine specifico',0),(528181,14672,'tl','',0),(528182,14672,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸‰à¸žà¸²à¸°à¹€à¸à¸£à¸”',0),(528183,14672,'hi','à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤†à¤¦à¥‡à¤¶ à¤²à¥‡à¤¨à¥‡ à¤µà¤¾à¤²à¤¾',0),(528184,14672,'ms','Pemenang perintah khusus',0),(528185,14672,'ar','Ø£Ø®Ø° ØªØ±ØªÙŠØ¨ Ù…Ø¹ÙŠÙ†',0),(528186,14672,'fr','Preneur d\'ordre spÃ©cifique',0),(528187,14672,'jp','ç‰¹å®šã®é †åºã®å—ã‘æ‰‹',0),(528188,14672,'pt','BeneficiÃ¡rio da ordem especÃ­fica',0),(528189,14672,'ru','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ð¾Ð¼ Ð¿Ð¾Ñ€ÑÐ´ÐºÐµ Ð¿Ñ€Ð¾Ð´Ð°Ð²ÐµÑ†',0),(528190,14672,'es','Orden especÃ­fico tomador',0),(528191,14672,'de','Bestimmten Reihenfolge Taker',0),(528192,14672,'en','Specific Order Taker',0),(528193,14673,'is','',0),(528194,14673,'dr','Ø¨Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(528195,14673,'pr','Ø¨Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(528196,14673,'tr','MÃ¼ÅŸteriye geri',0),(528197,14673,'pl','WrÃ³Ä‡ do klienta',0),(528198,14673,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÐºÑŠÐ¼ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(528199,14673,'ur','Ú¯Ø§ÛÚ© Ú©Ùˆ ÙˆØ§Ù¾Ø³',0),(528200,14673,'sr','ÐÐ°Ð·Ð°Ð´ Ð½Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(528201,14673,'vi','Quay láº¡i khÃ¡ch hÃ ng',0),(528202,14673,'af','Terug na die kliÃ«nt',0),(528203,14673,'ro','ÃŽnapoi la client',0),(528204,14673,'et','Tagasi kliendile',0),(528205,14673,'si','Nazaj na kupca',0),(528206,14673,'ba','Kembali ke pelanggan',0),(528207,14673,'nl','Terug naar klant',0),(528208,14673,'fi','Takaisin asiakkaalle',0),(528209,14673,'no','Tilbake til kunden',0),(528210,14673,'da','Tilbage til kunden',0),(528211,14673,'ko','ê³ ê°ìœ¼ë¡œ ëŒì•„ê°€ê¸°',0),(528212,14673,'he','×—×–×¨×” ×œ×œ×§×•×—',0),(528213,14673,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(528214,14673,'zh','åé¦ˆç»™é¡¾å®¢',0),(528215,14673,'sv','Tillbaka till kund',0),(528216,14673,'it','Customer',0),(528217,14673,'tl','',0),(528218,14673,'th','à¸à¸¥à¸±à¸šà¹„à¸›à¸¢à¸±à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(528219,14673,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹ à¤µà¤¾à¤ªà¤¸',0),(528220,14673,'ms','Kembali kepada pelanggan',0),(528221,14673,'ar','Ù…Ø±Ø© Ø£Ø®Ø±Ù‰ Ø¥Ù„Ù‰ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(528222,14673,'fr','Retour au client',0),(528223,14673,'jp','é¡§å®¢ã«æˆ»ã‚‹',0),(528224,14673,'pt','Volta para o cliente',0),(528225,14673,'ru','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ Ðº ÐºÐ»Ð¸ÐµÐ½Ñ‚Ñƒ',0),(528226,14673,'es','Cliente',0),(528227,14673,'de','ZurÃ¼ck zum Kunden',0),(528228,14673,'en','Back To Customer',0),(528229,14674,'is','',0),(528230,14674,'dr','Ø¨Ù‡ Ø¬Ø²Ø¦ÛŒØ§Øª',0),(528231,14674,'pr','Ø¨Ù‡ Ø¬Ø²Ø¦ÛŒØ§Øª',0),(528232,14674,'tr','AyrÄ±ntÄ±larÄ± iÃ§in',0),(528233,14674,'pl','WrÃ³Ä‡ do szczegÃ³Å‚Ã³w',0),(528234,14674,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÐºÑŠÐ¼ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(528235,14674,'ur','ØªÙØµÛŒÙ„Ø§Øª Ú©Û’ Ù„Ø¦Û’ ÙˆØ§Ù¾Ø³',0),(528236,14674,'sr','ÐÐ°Ð·Ð°Ð´ Ñƒ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(528237,14674,'vi','Quay láº¡i chi tiáº¿t',0),(528238,14674,'af','Terug na besonderhede',0),(528239,14674,'ro','ÃŽnapoi la detalii',0),(528240,14674,'et','Tagasi detailidele',0),(528241,14674,'si','Nazaj v podrobnosti',0),(528242,14674,'ba','Kembali ke rincian',0),(528243,14674,'nl','Terug naar Details',0),(528244,14674,'fi','Palaa tiedot',0),(528245,14674,'no','Tilbake til detaljer',0),(528246,14674,'da','Tilbage til detaljer',0),(528247,14674,'ko','ì„¸ë¶€ ì‚¬í•­ìœ¼ë¡œ ëŒì•„ê°€ê¸°',0),(528248,14674,'he','×—×–×¨×” ×¢×œ ×¤×¨×˜×™×',0),(528249,14674,'el','Î Î¯ÏƒÏ‰ ÏƒÏ„Î¹Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(528250,14674,'zh','è¿”å›žåˆ°è¯¦ç»†ä¿¡æ¯',0),(528251,14674,'sv','Tillbaka till Detaljer',0),(528252,14674,'it','Torna ai dettagli',0),(528253,14674,'tl','',0),(528254,14674,'th','à¸à¸¥à¸±à¸šà¹„à¸›à¸¢à¸±à¸‡à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”',0),(528255,14674,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤ªà¤¸',0),(528256,14674,'ms','Kembali ke maklumat',0),(528257,14674,'ar','Ø§Ù„Ø¹ÙˆØ¯Ø© Ø¥Ù„Ù‰ ØªÙØ§ØµÙŠÙ„',0),(528258,14674,'fr','Retour aux dÃ©tails',0),(528259,14674,'jp','è©³ç´°ã«æˆ»ã‚‹',0),(528260,14674,'pt','Para obter detalhes',0),(528261,14674,'ru','Ð’ÐµÑ€Ð½ÑƒÑ‚ÑŒÑÑ Ðº Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(528262,14674,'es','A los detalles',0),(528263,14674,'de','ZurÃ¼ck zu Details',0),(528264,14674,'en','Back To Details',0),(528265,14675,'is','',0),(528266,14675,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹Ù„Ù‚ CSR',0),(528267,14675,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ù…Ø¹Ù„Ù‚ CSR',0),(528268,14675,'tr','CSR bekleyen sipariÅŸler',0),(528269,14675,'pl','Zlecenia oczekujÄ…ce CSR',0),(528270,14675,'bg','Ð§Ð°ÐºÐ°Ñ‰ ÐšÐ¡Ðž Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(528271,14675,'ur','CSR Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(528272,14675,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð¦Ð¡Ð  Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(528273,14675,'vi','CSR Ä‘ang chá» xá»­ lÃ½ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(528274,14675,'af','Hangende KMV bestellings',0),(528275,14675,'ro','Ordinele Ã®n aÈ™teptare CSR',0),(528276,14675,'et','Ootel CSR tellimused',0),(528277,14675,'si','ÄŒakajoÄe DOP naroÄila',0),(528278,14675,'ba','Pending CSR order',0),(528279,14675,'nl','In behandeling MVO Orders',0),(528280,14675,'fi','Odottava CSR tilaukset',0),(528281,14675,'no','Ventende CSR ordrer',0),(528282,14675,'da','Ventende CSR ordrer',0),(528283,14675,'ko','ë³´ë¥˜ ì¤‘ì¸ CSR ì£¼ë¬¸',0),(528284,14675,'he','CSR ×ž×ž×ª×™× ×™× ×œ×¤×§×•×“×•×ª',0),(528285,14675,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± Î•ÎšÎ•',0),(528286,14675,'zh','æŒ‚èµ·çš„ CSR è®¢å•',0),(528287,14675,'sv','VÃ¤ntande CSR order',0),(528288,14675,'it','Ordini in sospeso CSR',0),(528289,14675,'tl','',0),(528290,14675,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸à¸²à¸£à¸žà¸´à¸ˆà¸²à¸£à¸“à¸² CSR',0),(528291,14675,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¸à¥€à¤à¤¸à¤†à¤° à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(528292,14675,'ms','Pesanan belum selesai tanggungjawab sosial korporat',0),(528293,14675,'ar','Ø£ÙˆØ§Ù…Ø± Ù…Ø¹Ù„Ù‚Ø© Ø§Ù„Ù…Ø³Ø¤ÙˆÙ„ÙŠØ© Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠØ© Ù„Ù„Ø´Ø±ÙƒØ§Øª',0),(528294,14675,'fr','Commandes en attente de RSE',0),(528295,14675,'jp','ä¿ç•™ä¸­ã® CSR æ³¨æ–‡',0),(528296,14675,'pt','Ordens pendentes de RSE',0),(528297,14675,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð´Ð¾ ÐšÐ¡Ðž',0),(528298,14675,'es','Ã“rdenes pendientes RSE',0),(528299,14675,'de','Ausstehende CSR-Bestellungen',0),(528300,14675,'en','Pending CSR Orders',0),(528301,14676,'is','',0),(528302,14676,'dr','Ø§Ù†ØªØ¸Ø§Ø± Ù¾Ø§Ú©Øª Ø¨Ø±Ø¯Ø§Ø´Øª',0),(528303,14676,'pr','Ø§Ù†ØªØ¸Ø§Ø± Ù¾Ø§Ú©Øª Ø¨Ø±Ø¯Ø§Ø´Øª',0),(528304,14676,'tr','Bekleyen zarf gÃ¶sterimler',0),(528305,14676,'pl','Koperta czasu wyÅ›wietleÅ„',0),(528306,14676,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ð¿Ð»Ð¸Ðº Ð¸Ð¼Ð¿Ñ€ÐµÑÐ¸Ð¸',0),(528307,14676,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ù„ÙØ§ÙÛ Ù†Ù‚ÙˆØ´',0),(528308,14676,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ ÐºÐ¾Ð²ÐµÑ€Ñ‚Ñƒ ÑƒÑ‚Ð¸ÑÐºÐµ',0),(528309,14676,'vi','Äang chá» xá»­ lÃ½ phong bÃ¬ Hiá»ƒn thá»‹',0),(528310,14676,'af','Hangende koevert indrukke',0),(528311,14676,'ro','ÃŽn aÅŸteptarea plic impresii',0),(528312,14676,'et','Ootel Ã¼mbrik muljed',0),(528313,14676,'si','ÄŒakajoÄe ovojnica prikazov',0),(528314,14676,'ba','Tayangan tertunda amplop',0),(528315,14676,'nl','In behandeling envelop indrukken',0),(528316,14676,'fi','Odottava kirjekuori nÃ¤yttÃ¶kerrat',0),(528317,14676,'no','Ventende konvolutt visninger',0),(528318,14676,'da','Ventende kuvert visninger',0),(528319,14676,'ko','ë³´ë¥˜ ì¤‘ì¸ ë´‰íˆ¬ ë…¸ì¶œ',0),(528320,14676,'he','×¨×©×ž×™× ×”×ž×¢×˜×¤×” ×ž×ž×ª×™× ×”',0),(528321,14676,'el','Î•ÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ Ï†Î¬ÎºÎµÎ»Î¿ ÎµÎ½Ï„Ï…Ï€ÏŽÏƒÎµÎ¹Ï‚',0),(528322,14676,'zh','æŒ‚èµ·çš„ä¿¡å°å°è±¡',0),(528323,14676,'sv','VÃ¤ntande kuvert intryck',0),(528324,14676,'it','Impressioni di busta in sospeso',0),(528325,14676,'tl','',0),(528326,14676,'th','à¸­à¸´à¸¡à¸‹à¸­à¸‡à¸ˆà¸”à¸«à¸¡à¸²à¸¢à¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(528327,14676,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤²à¤¿à¤«à¤¾à¤«à¤¾ à¤›à¤¾à¤ªà¥‡à¤‚',0),(528328,14676,'ms','Sampul surat yang belum selesai tayangan',0),(528329,14676,'ar','Ø§Ù†Ø·Ø¨Ø§Ø¹Ø§Øª Ø§Ù„Ù…ØºÙ„Ù Ù…Ø¹Ù„Ù‚Ø©',0),(528330,14676,'fr','Impressions de l\'enveloppe en attente',0),(528331,14676,'jp','ä¿ç•™ä¸­ã®ã‚¨ãƒ³ãƒ™ãƒ­ãƒ¼ãƒ—ã®å°è±¡',0),(528332,14676,'pt','ImpressÃµes de Envelope pendente',0),(528333,14676,'ru','ÐžÐ¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚ Ð¿Ð¾ÐºÐ°Ð·Ð¾Ð²',0),(528334,14676,'es','Impresiones pendientes envolvente',0),(528335,14676,'de','Ausstehende Umschlag-Impressionen',0),(528336,14676,'en','Pending Envelope Impressions',0),(528337,14677,'is','',0),(528338,14677,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø´Ø±Ø­ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø´ØºÙ„',0),(528339,14677,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø´Ø±Ø­ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø´ØºÙ„',0),(528340,14677,'tr','Standart iÅŸ tanÄ±mÄ± ekleme',0),(528341,14677,'pl','Dodaj opis pracy standard',0),(528342,14677,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(528343,14677,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ú©Ø§Ù… Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(528344,14677,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð¾Ð¿Ð¸Ñ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ðµ Ð¿Ð¾ÑÐ»Ð°',0),(528345,14677,'vi','MÃ´ táº£ tiÃªu chuáº©n cÃ´ng viá»‡c thÃªm',0),(528346,14677,'af','Standaard posbeskrywing voeg',0),(528347,14677,'ro','Adauga standard a postului',0),(528348,14677,'et','TÃ¼Ã¼pametijuhendi lisamine',0),(528349,14677,'si','Dodajte opis standard dela',0),(528350,14677,'ba','Deskripsi pekerjaan standar menambahkan',0),(528351,14677,'nl','Standaard functieomschrijving toevoegen',0),(528352,14677,'fi','Standard tyÃ¶nkuva lisÃ¤Ã¤',0),(528353,14677,'no','Standard stillingsbeskrivelse legge',0),(528354,14677,'da','Standard jobbeskrivelse tilfÃ¸je',0),(528355,14677,'ko','í‘œì¤€ ìž‘ì—… ì„¤ëª… ì¶”ê°€',0),(528356,14677,'he','×”×•×¡×£ ×ª×™××•×¨ ×¢×‘×•×“×” ×¡×˜× ×“×¨×˜×™×ª',0),(528357,14677,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®Ï‚',0),(528358,14677,'zh','æ ‡å‡†èŒåŠ¡è¯´æ˜Žæ·»åŠ ',0),(528359,14677,'sv','Standard arbetsbeskrivning lÃ¤gga till',0),(528360,14677,'it','Aggiungi Descrizione del lavoro standard',0),(528361,14677,'tl','',0),(528362,14677,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹€à¸à¸µà¹ˆà¸¢à¸§à¸à¸±à¸šà¸‡à¸²à¸™à¸¡à¸²à¸•à¸£à¸à¸²à¸™',0),(528363,14677,'hi','à¤®à¤¾à¤¨à¤• à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤µà¤¿à¤µà¤°à¤£ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(528364,14677,'ms','Penghuraian kerja Standard Tambah',0),(528365,14677,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØµÙ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(528366,14677,'fr','Description de poste standard ajouter',0),(528367,14677,'jp','æ¨™æº–çš„ãªä»•äº‹ã®èª¬æ˜Žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(528368,14677,'pt','Adicionar DescriÃ§Ã£o de trabalho padrÃ£o',0),(528369,14677,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(528370,14677,'es','AÃ±adir DescripciÃ³n de trabajo estÃ¡ndar',0),(528371,14677,'de','Standard-Job-Beschreibung hinzufÃ¼gen',0),(528372,14677,'en','Standard Job Description Add',0),(528373,14678,'is','',0),(528374,14678,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø®Ø·Ø§',0),(528375,14678,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‚Ø±Ø§Ø± Ø¯Ø§Ø¯Ù† Ø®Ø·Ø§',0),(528376,14678,'tr','Hata ekleme satÄ±cÄ±',0),(528377,14678,'pl','BÅ‚Ä…d wstawiania sprzedawcy',0),(528378,14678,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð¼ÑŠÐºÐ²Ð°Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(528379,14678,'ur','Ù†Ù‚Øµ ÙˆÛŒÙ†ÚˆØ± Ø¯Ø§Ø®Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(528380,14678,'sr','Ð“Ñ€ÐµÑˆÐºÐ° ÑƒÐ¼ÐµÑ‚Ð°ÑšÐµÐ¼ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(528381,14678,'vi','Lá»—i chÃ¨n Vendor',0),(528382,14678,'af','Fout invoeging handelaar',0),(528383,14678,'ro','Eroare inserarea furnizor',0),(528384,14678,'et','Viga lisamine hankijale',0),(528385,14678,'si','Napaka Vstavljanje dobavitelja',0),(528386,14678,'ba','Kesalahan memasukkan Vendor',0),(528387,14678,'nl','Fout invoegen leverancier',0),(528388,14678,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ toimittajan',0),(528389,14678,'no','Feil sette leverandÃ¸r',0),(528390,14678,'da','Fejl indsÃ¦tte leverandÃ¸r',0),(528391,14678,'ko','ì˜¤ë¥˜ ì‚½ìž… ê³µê¸‰ ì—…ì²´',0),(528392,14678,'he','×©×’×™××” ×”×•×¡×¤×ª ×¡×¤×§',0),(528393,14678,'el','Î›Î¬Î¸Î¿Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(528394,14678,'zh','é”™è¯¯æ’å…¥ä¾›åº”å•†',0),(528395,14678,'sv','Fel infoga leverantÃ¶r',0),(528396,14678,'it','Errore inserimento Vendor',0),(528397,14678,'tl','',0),(528398,14678,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¹à¸—à¸£à¸à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(528399,14678,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¡à¤¾à¤²à¤¨à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(528400,14678,'ms','Penjual memasukkan ralat',0),(528401,14678,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ø¯Ø±Ø§Ø¬ Ù…ÙˆØ±Ø¯',0),(528402,14678,'fr','Erreur insertion nom du vendeur',0),(528403,14678,'jp','ã‚¨ãƒ©ãƒ¼æŒ¿å…¥ãƒ™ãƒ³ãƒ€ãƒ¼',0),(528404,14678,'pt','Erro inserindo fornecedor',0),(528405,14678,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²ÑÑ‚Ð°Ð²ÐºÐ¸ Ð°Ð±Ð¾Ð½ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(528406,14678,'es','Error introduciendo proveedor',0),(528407,14678,'de','Fehler EinfÃ¼gen von Vendor',0),(528408,14678,'en','Error Inserting Vendor',0),(528409,14679,'is','',0),(528410,14679,'dr','Ú©Ù„Ù…Ø§Øª Ø¹Ø¨ÙˆØ± Ø¬ÙˆØ± Ø¨Ø§ÛŒØ¯',0),(528411,14679,'pr','Ú©Ù„Ù…Ø§Øª Ø¹Ø¨ÙˆØ± Ø¬ÙˆØ± Ø¨Ø§ÛŒØ¯',0),(528412,14679,'tr','ParolalarÄ± aynÄ± olmasÄ± gerekir',0),(528413,14679,'pl','HasÅ‚a musi odpowiadaÄ‡',0),(528414,14679,'bg','ÐŸÐ°Ñ€Ð¾Ð»Ð¸Ñ‚Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð°Ñ‚',0),(528415,14679,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù…Ø´Ø§Ø¨Û ÛÙˆÙ†Û’ Ú†Ø§ÛÛŒØ¦ÛŒÚº',0),(528416,14679,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐµ Ð¼Ð¾Ñ€Ð°Ñ˜Ñƒ Ð´Ð° ÑÐµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ',0),(528417,14679,'vi','Máº­t kháº©u pháº£i phÃ¹ há»£p vá»›i',0),(528418,14679,'af','Wagwoorde moet ooreenstem',0),(528419,14679,'ro','Parolele trebuie sÄƒ corespundÄƒ',0),(528420,14679,'et','Paroolid tuleb Ã¼hti',0),(528421,14679,'si','Gesla se mora ujemati z',0),(528422,14679,'ba','Pastikan kedua password cocok',0),(528423,14679,'nl','Wachtwoorden moeten overeenkomen met',0),(528424,14679,'fi','Salasanat on vastattava',0),(528425,14679,'no','Passord mÃ¥ samsvare med',0),(528426,14679,'da','Adgangskoder skal matche',0),(528427,14679,'ko','ì•”í˜¸ì™€ ì¼ì¹˜ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(528428,14679,'he','×¡×™×¡×ž××•×ª ×—×™×™×‘×•×ª ×œ×”×ª××™×',0),(528429,14679,'el','ÎŸÎ¹ ÎºÏ‰Î´Î¹ÎºÎ¿Î¯ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½',0),(528430,14679,'zh','å¯†ç å¿…é¡»åŒ¹é…',0),(528431,14679,'sv','LÃ¶senord mÃ¥ste matcha',0),(528432,14679,'it','Le password devono corrispondere',0),(528433,14679,'tl','',0),(528434,14679,'th','à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¸•à¹‰à¸­à¸‡à¸•à¸£à¸‡à¸à¸±à¸š',0),(528435,14679,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(528436,14679,'ms','Kata laluan mesti sepadan dengan',0),(528437,14679,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØªØ·Ø§Ø¨Ù‚ ÙƒÙ„Ù…Ø§Øª Ø§Ù„Ù…Ø±ÙˆØ±',0),(528438,14679,'fr','Mots de passe doivent correspondre',0),(528439,14679,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ãŒä¸€è‡´ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(528440,14679,'pt','As senhas devem corresponder',0),(528441,14679,'ru','ÐŸÐ°Ñ€Ð¾Ð»Ð¸ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐ¾Ð²Ð¿Ð°Ð´Ð°Ñ‚ÑŒ',0),(528442,14679,'es','Las contraseÃ±as deben coincidir.',0),(528443,14679,'de','PasswÃ¶rter mÃ¼ssen Ã¼bereinstimmen.',0),(528444,14679,'en','Passwords Must Match',0),(528445,14680,'is','',0),(528446,14680,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(528447,14680,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(528448,14680,'tr','Parola girmeniz gerekir',0),(528449,14680,'pl','NaleÅ¼y wprowadziÄ‡ hasÅ‚o',0),(528450,14680,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(528451,14680,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(528452,14680,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ',0),(528453,14680,'vi','Báº¡n pháº£i nháº­p máº­t kháº©u',0),(528454,14680,'af','Jy moet \'n wagwoord intik',0),(528455,14680,'ro','Trebuie sÄƒ introduceÅ£i o parolÄƒ',0),(528456,14680,'et','Peate sisestama parooli',0),(528457,14680,'si','Vnesti morate geslo',0),(528458,14680,'ba','Anda harus memasukkan Password',0),(528459,14680,'nl','U moet een wachtwoord invoeren',0),(528460,14680,'fi','Salasana on annettava',0),(528461,14680,'no','Du mÃ¥ angi et passord',0),(528462,14680,'da','Du skal angive en adgangskode',0),(528463,14680,'ko','ì•”í˜¸ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(528464,14680,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×¡×™×¡×ž×”',0),(528465,14680,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(528466,14680,'zh','æ‚¨å¿…é¡»è¾“å…¥å¯†ç ',0),(528467,14680,'sv','Du mÃ¥ste ange ett lÃ¶senord',0),(528468,14680,'it','Ãˆ necessario immettere una Password',0),(528469,14680,'tl','',0),(528470,14680,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™',0),(528471,14680,'hi','à¤¤à¥à¤® à¤à¤• à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(528472,14680,'ms','Anda mesti memasukkan kata laluan',0),(528473,14680,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ±.',0),(528474,14680,'fr','Vous devez entrer un mot de passe',0),(528475,14680,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(528476,14680,'pt','VocÃª deve digitar uma senha',0),(528477,14680,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ',0),(528478,14680,'es','Debe introducir una contraseÃ±a',0),(528479,14680,'de','Sie mÃ¼ssen ein Kennwort eingeben.',0),(528480,14680,'en','You Must Enter a Password',0),(528481,14681,'is','',0),(528482,14681,'dr','ØªÚ©Ø±Ø§Ø±ÛŒ Ù…ÙˆØ±Ø¯ Ù…Ø·Ø§Ø¨Ù‚ÛŒ ÛŒØ§ÙØª Ù†Ø´Ø¯',0),(528483,14681,'pr','ØªÚ©Ø±Ø§Ø±ÛŒ Ù…ÙˆØ±Ø¯ Ù…Ø·Ø§Ø¨Ù‚ÛŒ ÛŒØ§ÙØª Ù†Ø´Ø¯',0),(528484,14681,'tr','Yinelenen eÅŸleÅŸme bulundu',0),(528485,14681,'pl','DuplikatÃ³w znalezionych',0),(528486,14681,'bg','Ð”ÑƒÐ±Ð»Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ñ',0),(528487,14681,'ur','Ù…Ø«Ù†ÛŒ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(528488,14681,'sr','Ð”ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚Ð° Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð¸Ñ… Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ°',0),(528489,14681,'vi','Láº·p láº¡i tráº­n Ä‘áº¥u tÃ¬m tháº¥y',0),(528490,14681,'af','Duplikaat pasmaats gevind nie',0),(528491,14681,'ro','Meciuri dubluri gÄƒsite',0),(528492,14681,'et','Vasteid leiti duplikaat',0),(528493,14681,'si','Najdenih dvojnikov',0),(528494,14681,'ba','Duplikat ditemukan',0),(528495,14681,'nl','Dubbele resultaten gevonden',0),(528496,14681,'fi','PÃ¤Ã¤llekkÃ¤isiÃ¤ hakutuloksia',0),(528497,14681,'no','Like treff',0),(528498,14681,'da','Dublerede kampe fandt',0),(528499,14681,'ko','ì¤‘ë³µ ì¼ì¹˜ í•˜ëŠ” ê²°ê³¼',0),(528500,14681,'he','×©×›×¤×œ ×”×”×ª××ž×•×ª ×©××•×ª×¨×•',0),(528501,14681,'el','Î”Î¹Ï€Î»Î¬ Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÎµÏ‚ Ï€Î¿Ï… Î²ÏÎ¯ÏƒÎºÎ¿Î½Ï„Î±Î¹',0),(528502,14681,'zh','æ‰¾åˆ°çš„é‡å¤åŒ¹é…é¡¹',0),(528503,14681,'sv','Dubbla matcher hittade',0),(528504,14681,'it','Duplicare le corrispondenze trovate',0),(528505,14681,'tl','',0),(528506,14681,'th','à¸žà¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¸‹à¹‰à¸³à¸à¸±à¸™',0),(528507,14681,'hi','à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤œà¥‹à¤¡à¤¼ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(528508,14681,'ms','Pendua padanan yang ditemui',0),(528509,14681,'ar','ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ø·Ø§Ø¨Ù‚Ø§Øª Ù…ÙƒØ±Ø±Ø©',0),(528510,14681,'fr','Dupliquer les correspondances trouvÃ©es',0),(528511,14681,'jp','ä¸€è‡´ã™ã‚‹é …ç›®ã®è¤‡è£½ã—ã¾ã™ã€‚',0),(528512,14681,'pt','Duplicar correspondÃªncias encontradas',0),(528513,14681,'ru','Ð”ÑƒÐ±Ð»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ð°Ð¹Ð´ÐµÐ½Ð½Ñ‹Ñ… ÑÐ¾Ð²Ð¿Ð°Ð´ÐµÐ½Ð¸Ð¹',0),(528514,14681,'es','Duplicar a coincidencias encontradas',0),(528515,14681,'de','Doppelte Treffer gefunden',0),(528516,14681,'en','Duplicate Matches Found',0),(528517,14682,'is','',0),(528518,14682,'dr','Ù…Ø³Ø§Ø¨Ù‚Ø§Øª',0),(528519,14682,'pr','Ù…Ø³Ø§Ø¨Ù‚Ø§Øª',0),(528520,14682,'tr','MaÃ§lar',0),(528521,14682,'pl','Mecze',0),(528522,14682,'bg','ÐœÐ°Ñ‡Ð¾Ð²Ðµ',0),(528523,14682,'ur','Ù…ÛŒÚ†',0),(528524,14682,'sr','ÐŸÐ¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ°',0),(528525,14682,'vi','Tráº­n Ä‘áº¥u',0),(528526,14682,'af','Wedstryde',0),(528527,14682,'ro','Meciuri',0),(528528,14682,'et','Vasted',0),(528529,14682,'si','Tekme',0),(528530,14682,'ba','Pertandingan',0),(528531,14682,'nl','Wedstrijden',0),(528532,14682,'fi','Ottelut',0),(528533,14682,'no','Kamper',0),(528534,14682,'da','Kampe',0),(528535,14682,'ko','ì„ ìˆ˜',0),(528536,14682,'he','×’×¤×¨×•×¨×™×',0),(528537,14682,'el','Î‘Î³ÏŽÎ½ÎµÏ‚',0),(528538,14682,'zh','ç«æŸ´',0),(528539,14682,'sv','Matcher',0),(528540,14682,'it','Partite',0),(528541,14682,'tl','',0),(528542,14682,'th','à¸•à¸£à¸‡à¸à¸±à¸™',0),(528543,14682,'hi','à¤®à¥‡à¤² à¤–à¤¾à¤¤à¤¾',0),(528544,14682,'ms','Padanan',0),(528545,14682,'ar','Ù…Ø¨Ø§Ø±ÙŠØ§Øª',0),(528546,14682,'fr','Matches',0),(528547,14682,'jp','ä¸€è‡´ã—ã¾ã™ã€‚',0),(528548,14682,'pt','FÃ³sforos',0),(528549,14682,'ru','ÐœÐ°Ñ‚Ñ‡Ð¸',0),(528550,14682,'es','Acerca de los partidos',0),(528551,14682,'de','Treffern',0),(528552,14682,'en','Matches',0),(528553,14683,'is','',0),(528554,14683,'dr','ØµØ§Ø¯Ø±Ø§Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(528555,14683,'pr','ØµØ§Ø¯Ø±Ø§Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(528556,14683,'tr','Stok verilerini verme',0),(528557,14683,'pl','Eksport danych spisu',0),(528558,14683,'bg','Ð¡ÐºÐ»Ð°Ð´ Ð´Ð°Ð½Ð½Ð¸',0),(528559,14683,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ ÚˆÛŒÙ¹Ø§ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(528560,14683,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(528561,14683,'vi','Xuáº¥t kháº©u hÃ ng tá»“n kho dá»¯ liá»‡u',0),(528562,14683,'af','Voorraad Data uitvoer',0),(528563,14683,'ro','Export date de inventar',0),(528564,14683,'et','Inventuuri andmete eksportimine',0),(528565,14683,'si','Izvoz podatkov popisa',0),(528566,14683,'ba','Ekspor Data inventarisasi',0),(528567,14683,'nl','Inventarisatiegegevens exporteren',0),(528568,14683,'fi','Varaston tietojen vieminen',0),(528569,14683,'no','Eksportere lagerdata',0),(528570,14683,'da','Eksportere lagerdata',0),(528571,14683,'ko','ìž¬ê³  ë°ì´í„° ë‚´ë³´ë‚´ê¸°',0),(528572,14683,'he','×™×™×¦×•× × ×ª×•× ×™ ×”×ž×œ××™',0),(528573,14683,'el','Î•Î¾Î±Î³Ï‰Î³Î® Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï„Î·Ï‚ Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(528574,14683,'zh','å¯¼å‡ºåº“å­˜æ•°æ®',0),(528575,14683,'sv','Exportera inventeringsdata',0),(528576,14683,'it','Esportare i dati di inventario',0),(528577,14683,'tl','',0),(528578,14683,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(528579,14683,'hi','à¤¸à¥‚à¤šà¥€ à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(528580,14683,'ms','Mengeksport Data inventori',0),(528581,14683,'ar','ØªØµØ¯ÙŠØ± Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(528582,14683,'fr','Exporter des donnÃ©es de l\'inventaire',0),(528583,14683,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒª ãƒ‡ãƒ¼ã‚¿ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(528584,14683,'pt','Exportar dados de inventÃ¡rio',0),(528585,14683,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(528586,14683,'es','ExportaciÃ³n de datos de inventario',0),(528587,14683,'de','Inventardaten',0),(528588,14683,'en','Export Inventory Data',0),(528589,14684,'is','',0),(528590,14684,'dr','Ù†ÙˆÚ©',0),(528591,14684,'pr','Ù†ÙˆÚ©',0),(528592,14684,'tr','Ä°pucu',0),(528593,14684,'pl','Porada',0),(528594,14684,'bg','Ð¡ÑŠÐ²ÐµÑ‚',0),(528595,14684,'ur','Ù¹ÙˆÙ¹Ú©Ø§',0),(528596,14684,'sr','Ð”Ð¾Ñ˜Ð°Ð²Ð°',0),(528597,14684,'vi','Máº¹o',0),(528598,14684,'af','Wenk',0),(528599,14684,'ro','Sfat',0),(528600,14684,'et','NÃ¤punÃ¤ide',0),(528601,14684,'si','Nasvet',0),(528602,14684,'ba','Tip',0),(528603,14684,'nl','Tip',0),(528604,14684,'fi','KÃ¤rki',0),(528605,14684,'no','Tips',0),(528606,14684,'da','Tip',0),(528607,14684,'ko','íŒ',0),(528608,14684,'he','×¢×¦×”',0),(528609,14684,'el','Î£Ï…Î¼Î²Î¿Ï…Î»Î®',0),(528610,14684,'zh','å°è´´å£«',0),(528611,14684,'sv','Tips',0),(528612,14684,'it','Punta',0),(528613,14684,'tl','',0),(528614,14684,'th','à¸„à¸³à¹à¸™à¸°à¸™à¸³',0),(528615,14684,'hi','à¤Ÿà¤¿à¤ª',0),(528616,14684,'ms','Petua',0),(528617,14684,'ar','ØªÙ„Ù…ÙŠØ­',0),(528618,14684,'fr','Astuce',0),(528619,14684,'jp','ãƒ’ãƒ³ãƒˆ',0),(528620,14684,'pt','Dica',0),(528621,14684,'ru','ÐŸÐ¾Ð´ÑÐºÐ°Ð·ÐºÐ°',0),(528622,14684,'es','Punta',0),(528623,14684,'de','Tipp',0),(528624,14684,'en','Tip',0),(528625,14685,'is','',0),(528626,14685,'dr','Ú©Ù¾ÛŒ Ø¢Ø¯Ø±Ø³ Ø¨Ù‡ Ú©Ø´ØªÛŒ',0),(528627,14685,'pr','Ú©Ù¾ÛŒ Ø¢Ø¯Ø±Ø³ Ø¨Ù‡ Ú©Ø´ØªÛŒ',0),(528628,14685,'tr','Gemiye adresi kopyalayÄ±n',0),(528629,14685,'pl','Skopiuj adres do wysyÅ‚ki do',0),(528630,14685,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð°Ð´Ñ€ÐµÑÐ° Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ ÐºÑŠÐ¼',0),(528631,14685,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ù„Ø¦Û’ Ù¾ØªÛ Ú©Ø§Ù¾ÛŒ Ú©Ø±ÛŒÚº',0),(528632,14685,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ˜ Ð°Ð´Ñ€ÐµÑÑƒ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ Ñƒ',0),(528633,14685,'vi','Sao chÃ©p Ä‘á»‹a chá»‰ Ä‘á»ƒ tÃ u',0),(528634,14685,'af','Kopieer adres om die skip om te',0),(528635,14685,'ro','CopiaÅ£i adresa de la nava sÄƒ',0),(528636,14685,'et','Kopeeri aadress laeva',0),(528637,14685,'si','Kopirajte naslov na ladji',0),(528638,14685,'ba','Salin alamat ke kapal untuk',0),(528639,14685,'nl','Adres kopiÃ«ren naar schip',0),(528640,14685,'fi','Osoitteen kopioiminen aluksen',0),(528641,14685,'no','Kopier adressen til skip',0),(528642,14685,'da','Kopiere adressen til skib',0),(528643,14685,'ko','ìš´ì†¡ì§€ ì£¼ì†Œ ë³µì‚¬',0),(528644,14685,'he','×”×¢×ª×§ ×›×ª×•×‘×ª ×œ×ž×©×œ×•×—',0),(528645,14685,'el','Î‘Î½Ï„Î¹Î³ÏÎ±Ï†Î® Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·Ï‚ Ï€Î»Î¿Î¯Î¿ Î½Î±',0),(528646,14685,'zh','å°†åœ°å€å¤åˆ¶åˆ°èˆ°',0),(528647,14685,'sv','Kopiera adressen till fartyget fÃ¶r att',0),(528648,14685,'it','Copia l\'indirizzo alla nave a',0),(528649,14685,'tl','',0),(528650,14685,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹„à¸›à¸¢à¸±à¸‡',0),(528651,14685,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¤à¥‡ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(528652,14685,'ms','Salin alamat untuk kapal',0),(528653,14685,'ar','Ù†Ø³Ø® Ø§Ù„Ø¹Ù†ÙˆØ§Ù† Ø¥Ù„Ù‰ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(528654,14685,'fr','Copiez l\'adresse Ã  expÃ©dier Ã ',0),(528655,14685,'jp','èˆ¹ã‚’ã‚¢ãƒ‰ãƒ¬ã‚¹ã«ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(528656,14685,'pt','Copie o endereÃ§o Ã  nave para',0),(528657,14685,'ru','Ð¡ÐºÐ¾Ð¿Ð¸Ñ€ÑƒÐ¹Ñ‚Ðµ Ð°Ð´Ñ€ÐµÑ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ',0),(528658,14685,'es','Copiar direcciÃ³n al barco a',0),(528659,14685,'de','Adresse zu Schiff zu kopieren',0),(528660,14685,'en','Copy Address To Ship To',0),(528661,14686,'is','',0),(528662,14686,'dr','Ø±ÙˆÙ†ÙˆØ´Øª Ø¯Ø± Ú©Ø´ØªÛŒ',0),(528663,14686,'pr','Ø±ÙˆÙ†ÙˆØ´Øª Ø¯Ø± Ú©Ø´ØªÛŒ',0),(528664,14686,'tr','Gemiye kopyalayÄ±n',0),(528665,14686,'pl','Skopiuj na statku',0),(528666,14686,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(528667,14686,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©ÛŒ Ù†Ù‚Ù„',0),(528668,14686,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð½Ð° Ð±Ñ€Ð¾Ð´ Ð´Ð°',0),(528669,14686,'vi','Sao chÃ©p vÃ o tÃ u',0),(528670,14686,'af','Na die skip om te kopieer',0),(528671,14686,'ro','Copie a navei pentru a',0),(528672,14686,'et','Kopeerige laeva',0),(528673,14686,'si','Kopiranje na ladji',0),(528674,14686,'ba','Salin ke kapal untuk',0),(528675,14686,'nl','Kopieer naar schip',0),(528676,14686,'fi','Kopioi aluksen',0),(528677,14686,'no','Kopiere til skip',0),(528678,14686,'da','Kopier til skib',0),(528679,14686,'ko','ë°°ë¥¼ ë³µì‚¬',0),(528680,14686,'he','×”×¢×ª×§ ××œ ×”×¡×¤×™× ×”',0),(528681,14686,'el','Î‘Î½Ï„Î¹Î³ÏÎ±Ï†Î® ÏƒÎµ Ï€Î»Î¿Î¯Î¿',0),(528682,14686,'zh','å°†å¤åˆ¶åˆ°èˆ°',0),(528683,14686,'sv','Kopiera till fartyget fÃ¶r att',0),(528684,14686,'it','Copia da spedire a',0),(528685,14686,'tl','',0),(528686,14686,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹„à¸›à¸¢à¸±à¸‡',0),(528687,14686,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(528688,14686,'ms','Salin ke kapal',0),(528689,14686,'ar','Ù†Ø³Ø® Ø¥Ù„Ù‰ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(528690,14686,'fr','Copiez Ã  expÃ©dier Ã ',0),(528691,14686,'jp','èˆ¹ã«ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(528692,14686,'pt','Copie Ã  nave para',0),(528693,14686,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ',0),(528694,14686,'es','Copiar al barco a',0),(528695,14686,'de','Kopieren Sie auf Schiff',0),(528696,14686,'en','Copy to Ship To',0),(528697,14687,'is','',0),(528698,14687,'dr','Ú©Ø§Ø±Øª Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª',0),(528699,14687,'pr','Ú©Ø§Ø±Øª Ù…ÙˆØ¬ÙˆØ¯ Ø§Ø³Øª',0),(528700,14687,'tr','KartÄ±',0),(528701,14687,'pl','Karta jest obecny',0),(528702,14687,'bg','ÐšÐ°Ñ€Ñ‚Ð° Ðµ Ð½Ð°Ð»Ð¸Ñ†Ðµ',0),(528703,14687,'ur','Ú©Ø§Ø±Úˆ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’ Û”',0),(528704,14687,'sr','ÐšÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ñ˜Ðµ Ð¿Ð¾ÐºÐ»Ð¾Ð½',0),(528705,14687,'vi','Tháº» Ä‘Æ°á»£c trÃ¬nh bÃ y',0),(528706,14687,'af','Kaart Is teenwoordig',0),(528707,14687,'ro','Cardul este prezent',0),(528708,14687,'et','Kaart on olemas',0),(528709,14687,'si','Kartica je prisotna',0),(528710,14687,'ba','Ada kartu',0),(528711,14687,'nl','Kaart Is aanwezig',0),(528712,14687,'fi','Kortti on kÃ¤ytÃ¶ssÃ¤',0),(528713,14687,'no','Kortet finnes',0),(528714,14687,'da','Kortet er til stede',0),(528715,14687,'ko','ì¹´ë“œ ìžˆìœ¼ë©´',0),(528716,14687,'he','×›×¨×˜×™×¡ ×–×” ×§×™×™×',0),(528717,14687,'el','ÎšÎ¬ÏÏ„Î± ÎµÎ¯Î½Î±Î¹ Ï€Î±ÏÎ¿ÏÏƒÎ±',0),(528718,14687,'zh','åˆ™å­˜åœ¨å¡',0),(528719,14687,'sv','Kortet Ã¤r nÃ¤rvarande',0),(528720,14687,'it','Carta Ã¨ presente',0),(528721,14687,'tl','',0),(528722,14687,'th','à¸šà¸±à¸•à¸£à¸­à¸¢à¸¹à¹ˆ',0),(528723,14687,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(528724,14687,'ms','Kad yang terdapat',0),(528725,14687,'ar','Ø¨Ø·Ø§Ù‚Ø© Ù…ÙˆØ¬ÙˆØ¯',0),(528726,14687,'fr','Carte est prÃ©sent',0),(528727,14687,'jp','ã‚«ãƒ¼ãƒ‰ãŒå­˜åœ¨',0),(528728,14687,'pt','CartÃ£o estÃ¡ presente',0),(528729,14687,'ru','ÐŸÑ€Ð¸ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÐºÐ°Ñ€Ñ‚Ð°',0),(528730,14687,'es','Tarjeta estÃ¡ presente',0),(528731,14687,'de','Karte ist vorhanden',0),(528732,14687,'en','Card Is Present',0),(528733,14688,'is','',0),(528734,14688,'dr','Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡',0),(528735,14688,'pr','Ù¾Ø±Ø¯Ø§Ø²Ù†Ø¯Ù‡',0),(528736,14688,'tr','Ä°ÅŸlemci',0),(528737,14688,'pl','Procesor',0),(528738,14688,'bg','ÐŸÑ€Ð¾Ñ†ÐµÑÐ¾Ñ€',0),(528739,14688,'ur','Ù¾Ø±ÙˆØ³ÛŒØ³Ø±',0),(528740,14688,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑÐ¾Ñ€',0),(528741,14688,'vi','Bá»™ xá»­ lÃ½',0),(528742,14688,'af','Verwerker',0),(528743,14688,'ro','Procesor',0),(528744,14688,'et','Protsessor',0),(528745,14688,'si','Procesor',0),(528746,14688,'ba','Prosesor',0),(528747,14688,'nl','Processor',0),(528748,14688,'fi','Prosessori',0),(528749,14688,'no','Prosessor',0),(528750,14688,'da','Processor',0),(528751,14688,'ko','í”„ë¡œì„¸ì„œ',0),(528752,14688,'he','×ž×¢×‘×“',0),(528753,14688,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„Î®',0),(528754,14688,'zh','å¤„ç†å™¨',0),(528755,14688,'sv','Processor',0),(528756,14688,'it','Processore',0),(528757,14688,'tl','',0),(528758,14688,'th','à¸•à¸±à¸§à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥',0),(528759,14688,'hi','à¤ªà¥à¤°à¥‹à¤¸à¥‡à¤¸à¤°',0),(528760,14688,'ms','Pemproses',0),(528761,14688,'ar','Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬',0),(528762,14688,'fr','Processeur',0),(528763,14688,'jp','ãƒ—ãƒ­ã‚»ãƒƒã‚µ',0),(528764,14688,'pt','Processador',0),(528765,14688,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€',0),(528766,14688,'es','Procesador',0),(528767,14688,'de','Prozessor',0),(528768,14688,'en','Processor',0),(528769,14689,'is','',0),(528770,14689,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÛŒ ACH Ùˆ ÛŒØ§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ EFT',0),(528771,14689,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÛŒ ACH Ùˆ ÛŒØ§ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ EFT',0),(528772,14689,'tr','ACH veya EFT Ã¶demeler iÃ§in hesap numarasÄ±',0),(528773,14689,'pl','Numer konta IRA lub EFT pÅ‚atnoÅ›ci',0),(528774,14689,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° ÐÐšÐš Ð¸Ð»Ð¸ EFT Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(528775,14689,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ø§Ú† ÛŒØ§ EFT Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Û’ Ù„ÛŒÛ’',0),(528776,14689,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð·Ð° ÐÑ… Ð¸Ð»Ð¸ Ð•Ð¤Ð¢ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(528777,14689,'vi','TÃ i khoáº£n sá»‘ cho ACH hay EFT thanh toÃ¡n',0),(528778,14689,'af','Rekening nommer vir ACH of EFT betalings',0),(528779,14689,'ro','NumÄƒr de cont pentru ACH sau EFT plÄƒÅ£i',0),(528780,14689,'et','Kontonumbri ACH vÃµi EFT tegemiseks',0),(528781,14689,'si','Å tevilka raÄuna za ACH ali EFT plaÄila',0),(528782,14689,'ba','Nomor rekening untuk pembayaran TDE atau ACH',0),(528783,14689,'nl','Rekeningnummer voor ACH of EFT betalingen',0),(528784,14689,'fi','Tilinumero ACH tai EFT-maksut',0),(528785,14689,'no','Kontonummeret For ACH eller EFT betaling',0),(528786,14689,'da','Kontonummeret For ACH eller EFT betalinger',0),(528787,14689,'ko','ACH ë˜ëŠ” ì „ìž ì†¡ê¸ˆ ì§€ë¶ˆ ê³„ì¢Œ ë²ˆí˜¸',0),(528788,14689,'he','×ž×¡×¤×¨ ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ACH ××• ×ª×©×œ×•×ž×™× EFT',0),(528789,14689,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î³Î¹Î± ACH Î® Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î—ÎœÎ§',0),(528790,14689,'zh','ACH æˆ– EFT ä»˜æ¬¾å¸å·',0),(528791,14689,'sv','Kontonummer fÃ¶r ACH eller EFT betalningar',0),(528792,14689,'it','Numero di conto per ACH o pagamenti EFT',0),(528793,14689,'tl','',0),(528794,14689,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µà¸ªà¸³à¸«à¸£à¸±à¸š ACH à¸«à¸£à¸·à¸­ EFT à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(528795,14689,'hi','ACH à¤¯à¤¾ à¤ˆà¤à¤«à¤¼à¤Ÿà¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(528796,14689,'ms','Nombor akaun bagi men atau bayaran EFT',0),(528797,14689,'ar','Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ù„Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹ Ø£Ùˆ ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø£Ù…ÙˆØ§Ù„ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(528798,14689,'fr','NumÃ©ro de compte pour les ACH ou paiements EFT',0),(528799,14689,'jp','ACH ã®éŠ€è¡Œå£åº§æŒ¯è¾¼å£åº§ç•ªå·',0),(528800,14689,'pt','NÃºmero de conta para ACH ou pagamentos de EFT',0),(528801,14689,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ ACH Ð¸Ð»Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ EFT',0),(528802,14689,'es','NÃºmero de cuenta para pagos EFT o ACH',0),(528803,14689,'de','Kontonummer fÃ¼r ACH oder EFT Zahlungen',0),(528804,14689,'en','Account Number For ACH Or EFT Payments',0),(528805,14690,'is','',0),(528806,14690,'dr','Ø¨ÛŒÙ„ ØªÙˆØ¬Ù‡',0),(528807,14690,'pr','Ø¨ÛŒÙ„ ØªÙˆØ¬Ù‡',0),(528808,14690,'tr','Bill dikkat',0),(528809,14690,'pl','Bill uwagÄ™',0),(528810,14690,'bg','Ð—Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð·Ð° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸ÐµÑ‚Ð¾',0),(528811,14690,'ur','Ø¨Ù„ Ú©ÛŒ ØªÙˆØ¬Û Ú©Û’ Ù„Ø¦Û’',0),(528812,14690,'sr','Ð‘Ð¸Ð» Ð´Ð° Ð¿Ð°Ð¶ÑšÑƒ',0),(528813,14690,'vi','CÃ¡c hÃ³a Ä‘Æ¡n Ä‘áº¿n sá»± chÃº Ã½',0),(528814,14690,'af','Wetsontwerp aandag',0),(528815,14690,'ro','Bill atenÅ£ia',0),(528816,14690,'et','Bill tÃ¤helepanu',0),(528817,14690,'si','Bill pozornost',0),(528818,14690,'ba','Tagihan untuk perhatian',0),(528819,14690,'nl','Bill aandacht',0),(528820,14690,'fi','Bill tietoon',0),(528821,14690,'no','Bill oppmerksomhet',0),(528822,14690,'da','Bill opmÃ¦rksom',0),(528823,14690,'ko','ê´€ì‹¬ì„ ë¹Œ',0),(528824,14690,'he','×‘×™×œ ×ª×©×•×ž×ª ×œ×‘',0),(528825,14690,'el','Bill Ï€ÏÎ¿ÏƒÎ¿Ï‡Î®',0),(528826,14690,'zh','æ³¨æ„åˆ°æ¡ä¾‹è‰æ¡ˆ',0),(528827,14690,'sv','Bill uppmÃ¤rksamhet',0),(528828,14690,'it','Bill all\'attenzione',0),(528829,14690,'tl','',0),(528830,14690,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸„à¸§à¸²à¸¡à¸ªà¸™à¹ƒà¸ˆ',0),(528831,14690,'hi','à¤§à¥à¤¯à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²',0),(528832,14690,'ms','Rang undang-undang untuk perhatian',0),(528833,14690,'ar','Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ø¥Ù„Ù‰ Ø§Ù„Ø§Ù‡ØªÙ…Ø§Ù…',0),(528834,14690,'fr','Projet de loi Ã  l\'Attention',0),(528835,14690,'jp','æ³¨æ„ã™ã‚‹æ³•æ¡ˆ',0),(528836,14690,'pt','Bill a atenÃ§Ã£o',0),(528837,14690,'ru','Ð‘Ð¸Ð»Ð» Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ',0),(528838,14690,'es','Proyecto de ley de atenciÃ³n',0),(528839,14690,'de','Bill aufmerksam',0),(528840,14690,'en','Bill To Attention',0),(528841,14691,'is','',0),(528842,14691,'dr','ØªØºÛŒÛŒØ± Ø¢Ø¯Ø±Ø³ Ø¨Ù‡ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø·ÙˆØ± Ù¾ÛŒØ´ ÙØ±Ø¶ Ú©Ù¾ÛŒ',0),(528843,14691,'pr','ØªØºÛŒÛŒØ± Ø¢Ø¯Ø±Ø³ Ø¨Ù‡ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø·ÙˆØ± Ù¾ÛŒØ´ ÙØ±Ø¶ Ú©Ù¾ÛŒ',0),(528844,14691,'tr','Gemi iÃ§in varsayÄ±lan olarak kopya adres deÄŸiÅŸikliÄŸi',0),(528845,14691,'pl','Skopiuj adres zmiany domyÅ›lnego statku',0),(528846,14691,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð°Ð´Ñ€ÐµÑ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° ÐºÑŠÐ¼ Ð½ÐµÑÐ²ÑÐ²Ð°Ð½Ðµ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(528847,14691,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ø·Û’ Ø´Ø¯Û Ù†Ù‚Ù„ Ø¹Ù†ÙˆØ§Ù† Ú©ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ',0),(528848,14691,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ñ˜ Ð°Ð´Ñ€ÐµÑÑƒ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð° Ñƒ Ð²ÐµÐ·Ð¸ Ñ Ð±Ñ€Ð¾Ð´Ð° Ð´Ð°',0),(528849,14691,'vi','Sao chÃ©p Ä‘á»‹a chá»‰ thay Ä‘á»•i Ä‘á»ƒ máº·c Ä‘á»‹nh tÃ u',0),(528850,14691,'af','Kopieer adres verander om die skip te verstek',0),(528851,14691,'ro','Copia adresa schimbarea implicit nava sÄƒ',0),(528852,14691,'et','Kopeeri aadress muutub vaikimisi laeva',0),(528853,14691,'si','Kopirajte naslov spremeni privzeto ladja',0),(528854,14691,'ba','Salin alamat perubahan ke Default kapal untuk',0),(528855,14691,'nl','Adreswijziging verzenden naar standaard kopiÃ«ren',0),(528856,14691,'fi','Kopioi Osoitteenmuutos oletus aluksen',0),(528857,14691,'no','Kopier adressen endres til standard leveringsadresse',0),(528858,14691,'da','Kopi-adresseÃ¦ndring af Default skibet til at',0),(528859,14691,'ko','ë³µì‚¬ ê¸°ë³¸ ë°°ì†¡ ì£¼ì†Œ ë³€ê²½',0),(528860,14691,'he','×”×¢×ª×§ ×©×™× ×•×™ ×›×ª×•×‘×ª ×‘×¨×™×¨×ª ×ž×—×“×œ ×œ×ž×©×œ×•×—',0),(528861,14691,'el','Î‘Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î±Î»Î»Î±Î³Î® ÏƒÏ„Î¹Ï‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Ï€Î»Î¿Î¯Î¿ Î½Î±',0),(528862,14691,'zh','å¤åˆ¶åœ°å€æ›´æ”¹é»˜è®¤èˆ°',0),(528863,14691,'sv','Kopiera adressen Ã¤ndras till standard fÃ¶r fartyg',0),(528864,14691,'it','Cambio di indirizzo copia di Default la nave a',0),(528865,14691,'tl','',0),(528866,14691,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹„à¸›à¸¢à¸±à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(528867,14691,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥‡ à¤œà¤¹à¤¾à¤œ à¤•à¥‹ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤¤à¥‡ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(528868,14691,'ms','Pertukaran Alamat salinan untuk lalai kapal',0),(528869,14691,'ar','Ù†Ø³Ø® ØªØºÙŠÙŠØ± Ø§Ù„Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(528870,14691,'fr','Changement d\'adresse de copie par dÃ©faut de navire Ã ',0),(528871,14691,'jp','æ—¢å®šã®é€ä»˜å…ˆã«ä½æ‰€å¤‰æ›´ã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(528872,14691,'pt','MudanÃ§a de endereÃ§o cÃ³pia para o padrÃ£o de navio para',0),(528873,14691,'ru','Ð¡ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð°Ð´Ñ€ÐµÑ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(528874,14691,'es','Cambio de direcciÃ³n de copia por defecto nave a',0),(528875,14691,'de','Adresse Ã¤ndern, um die Standard-Schiff zu kopieren',0),(528876,14691,'en','Copy Address Change To Default Ship To',0),(528877,14692,'is','',0),(528878,14692,'dr','Ø§Ú¯Ø± Ø¯ÙˆÙ„Øª Ù„ÛŒØ³Øª Ù†Ø´Ø¯Ù‡',0),(528879,14692,'pr','Ø§Ú¯Ø± Ø¯ÙˆÙ„Øª Ù„ÛŒØ³Øª Ù†Ø´Ø¯Ù‡',0),(528880,14692,'tr','EÄŸer devlet kayÄ±tlÄ± deÄŸil',0),(528881,14692,'pl','JeÅ›li PaÅ„stwa niepubliczny',0),(528882,14692,'bg','ÐÐºÐ¾ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð½Ð° ÑÐºÑ€Ð¸Ñ‚',0),(528883,14692,'ur','Ø§Ú¯Ø± Ø±ÛŒØ§Ø³ØªÛŒ Ù†Ø§ÙÛØ±Ø³Øª',0),(528884,14692,'sr','ÐÐºÐ¾ Ð´Ñ€Ð¶Ð°Ð²Ð° Ð½Ð¸Ñ˜Ðµ Ð½Ð° Ð»Ð¸ÑÑ‚Ð¸',0),(528885,14692,'vi','Náº¿u nhÃ  nÆ°á»›c khÃ´ng cÃ´ng khai',0),(528886,14692,'af','As staat ongenoteerde',0),(528887,14692,'ro','DacÄƒ stat nelistate',0),(528888,14692,'et','Kui riigi noteerimata',0),(528889,14692,'si','ÄŒe drÅ¾ava ne kotirajo na borzi',0),(528890,14692,'ba','Jika negara tidak terdaftar',0),(528891,14692,'nl','Als staat niet-beursgenoteerde',0),(528892,14692,'fi','Jos valtion salaiset',0),(528893,14692,'no','Hvis staten unoterte',0),(528894,14692,'da','Hvis staten unoterede',0),(528895,14692,'ko','ì£¼ í•˜ëŠ” ê²½ìš° ëª©ë¡ì— ì—†ëŠ”',0),(528896,14692,'he','×× ×”×ž×“×™× ×” ×—×¡×•×™',0),(528897,14692,'el','Î‘Î½ Ï„Î¿ ÎºÏÎ¬Ï„Î¿Ï‚ ÎµÎºÏ„ÏŒÏ‚ Î»Î¯ÏƒÏ„Î±Ï‚',0),(528898,14692,'zh','å¦‚æžœçŠ¶æ€æœªä¸Šå¸‚',0),(528899,14692,'sv','Om statliga onoterade',0),(528900,14692,'it','Se lo stato non quotate',0),(528901,14692,'tl','',0),(528902,14692,'th','à¸–à¹‰à¸²à¸£à¸±à¸à¹„à¸¡à¹ˆà¹à¸ªà¸”à¸‡',0),(528903,14692,'hi','à¤¯à¤¦à¤¿ à¤°à¤¾à¤œà¥à¤¯ à¤…à¤¸à¥‚à¤šà¥€à¤¬à¤¦à¥à¤§',0),(528904,14692,'ms','Jika negeri tidak tersenarai',0),(528905,14692,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù†Øª Ø§Ù„Ø¯ÙˆÙ„Ø© ØºÙŠØ± Ø§Ù„Ù…Ø¯Ø±Ø¬Ø© ÙÙŠ Ø§Ù„Ø¨ÙˆØ±ØµØ©',0),(528906,14692,'fr','Si l\'Ã‰tat non cotÃ©es',0),(528907,14692,'jp','çŠ¶æ…‹ãªã‚‰æœªå…¬é–‹',0),(528908,14692,'pt','Se o estado nÃ£o listado',0),(528909,14692,'ru','Ð•ÑÐ»Ð¸ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ðµ Ñ‡Ð°ÑÑ‚Ð½Ñ‹Ðµ',0),(528910,14692,'es','Si el estado no cotizadas',0),(528911,14692,'de','Wenn State nicht bÃ¶rsennotierte',0),(528912,14692,'en','If State Unlisted',0),(528913,14693,'is','',0),(528914,14693,'dr','Ø¯ÙØªØ±',0),(528915,14693,'pr','Ø¯ÙØªØ±',0),(528916,14693,'tr','Ofis',0),(528917,14693,'pl','Biuro',0),(528918,14693,'bg','ÐžÑ„Ð¸Ñ',0),(528919,14693,'ur','Ø¯ÙØªØ±',0),(528920,14693,'sr','ÐžÑ„Ñ„Ð¸Ñ†Ðµ',0),(528921,14693,'vi','VÄƒn phÃ²ng',0),(528922,14693,'af','Kantoor',0),(528923,14693,'ro','Birou',0),(528924,14693,'et','Office',0),(528925,14693,'si','Urad',0),(528926,14693,'ba','Kantor',0),(528927,14693,'nl','Office',0),(528928,14693,'fi','Office',0),(528929,14693,'no','Office',0),(528930,14693,'da','Office',0),(528931,14693,'ko','ì‚¬ë¬´ì‹¤',0),(528932,14693,'he','Office',0),(528933,14693,'el','Î“ÏÎ±Ï†ÎµÎ¯Î¿',0),(528934,14693,'zh','åŠžå…¬å®¤',0),(528935,14693,'sv','Office',0),(528936,14693,'it','Ufficio',0),(528937,14693,'tl','',0),(528938,14693,'th','à¸ªà¸³à¸™à¸±à¸à¸‡à¸²à¸™',0),(528939,14693,'hi','à¤•à¤¾à¤°à¥à¤¯à¤¾à¤²à¤¯',0),(528940,14693,'ms','Pejabat',0),(528941,14693,'ar','Ù…ÙƒØªØ¨',0),(528942,14693,'fr','Bureau',0),(528943,14693,'jp','ã‚ªãƒ•ã‚£ã‚¹',0),(528944,14693,'pt','EscritÃ³rio',0),(528945,14693,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(528946,14693,'es','Oficina',0),(528947,14693,'de','BÃ¼ro',0),(528948,14693,'en','Office',0),(528949,14694,'is','',0),(528950,14694,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ ØªÙˆØ¬Ù‡',0),(528951,14694,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ ØªÙˆØ¬Ù‡',0),(528952,14694,'tr','AlÄ±ntÄ± dikkat',0),(528953,14694,'pl','Uwaga cytat',0),(528954,14694,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸ÐµÑ‚Ð¾',0),(528955,14694,'ur','Ø§Ù‚ØªØ¨Ø§Ø³ Ú©ÛŒ ØªÙˆØ¬Û',0),(528956,14694,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð¿Ð°Ð¶ÑšÑƒ',0),(528957,14694,'vi','Sá»± chÃº Ã½ cá»§a bÃ¡o giÃ¡',0),(528958,14694,'af','Aanhaling aandag',0),(528959,14694,'ro','Citat atenÅ£ia',0),(528960,14694,'et','Hinnapakkumise tÃ¤helepanu',0),(528961,14694,'si','Citiram pozornost',0),(528962,14694,'ba','Mengutip perhatian',0),(528963,14694,'nl','Offerte aandacht',0),(528964,14694,'fi','Lainaus huomiota',0),(528965,14694,'no','Tilbud oppmerksomhet',0),(528966,14694,'da','Citat opmÃ¦rksomhed',0),(528967,14694,'ko','ê²¬ì  ì£¼ì˜',0),(528968,14694,'he','×”×¦×¢×ª ×ž×—×™×¨ ×ª×©×•×ž×ª ×œ×‘',0),(528969,14694,'el','Î ÏÎ¿ÏƒÎ¿Ï‡Î® Ï€ÏÎ¿ÏƒÏ†Î¿ÏÎ¬',0),(528970,14694,'zh','æŠ¥ä»·å•çš„å…³æ³¨',0),(528971,14694,'sv','Citera uppmÃ¤rksamhet',0),(528972,14694,'it','Citazione attenzione',0),(528973,14694,'tl','',0),(528974,14694,'th','à¸ªà¸™à¹ƒà¸ˆà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(528975,14694,'hi','à¤¬à¥‹à¤²à¥€ à¤§à¥à¤¯à¤¾à¤¨',0),(528976,14694,'ms','Perhatian quote',0),(528977,14694,'ar','Ø§Ù‚ØªØ¨Ø³ Ù…Ù† Ø§Ù„Ø§Ù‡ØªÙ…Ø§Ù…',0),(528978,14694,'fr','Devis Attention',0),(528979,14694,'jp','æ³¨æ„ã‚’å¼•ç”¨ã—ã¾ã™ã€‚',0),(528980,14694,'pt','CitaÃ§Ã£o de atenÃ§Ã£o',0),(528981,14694,'ru','Ð¦Ð¸Ñ‚Ð°Ñ‚Ð° Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ñ',0),(528982,14694,'es','AtenciÃ³n de cita',0),(528983,14694,'de','Zitat von Aufmerksamkeit',0),(528984,14694,'en','Quote Attention',0),(528985,14695,'is','',0),(528986,14695,'dr','Ø§Ø±Ø³Ø§Ù„ Ù¾ÛŒØ´ ÙØ§Ú©ØªÙˆØ±',0),(528987,14695,'pr','Ø§Ø±Ø³Ø§Ù„ Ù¾ÛŒØ´ ÙØ§Ú©ØªÙˆØ±',0),(528988,14695,'tr','Fatura gÃ¶nderin',0),(528989,14695,'pl','WyÅ›lij fakturÄ™',0),(528990,14695,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(528991,14695,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(528992,14695,'sr','ÐŸÐ¾ÑÐ»Ð°Ñ‚Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(528993,14695,'vi','Gá»­i hoÃ¡ Ä‘Æ¡n',0),(528994,14695,'af','Faktuur stuur',0),(528995,14695,'ro','Trimite factura',0),(528996,14695,'et','Saada arve',0),(528997,14695,'si','Izstavite raÄun',0),(528998,14695,'ba','Mengirim faktur',0),(528999,14695,'nl','Factuur sturen',0),(529000,14695,'fi','LÃ¤hettÃ¤Ã¤ laskun',0),(529001,14695,'no','Send faktura',0),(529002,14695,'da','Send faktura',0),(529003,14695,'ko','ì²­êµ¬ì„œ ë³´ë‚¼',0),(529004,14695,'he','×©×œ×— ×—×©×‘×•× ×™×ª',0),(529005,14695,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(529006,14695,'zh','å‘é€å‘ç¥¨',0),(529007,14695,'sv','Skicka faktura',0),(529008,14695,'it','Inviare la fattura',0),(529009,14695,'tl','',0),(529010,14695,'th','à¸ªà¹ˆà¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(529011,14695,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥‡à¤œà¤¨à¥‡',0),(529012,14695,'ms','Hantar invois',0),(529013,14695,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(529014,14695,'fr','Envoyer la facture',0),(529015,14695,'jp','è«‹æ±‚æ›¸ã‚’é€ä»˜ã—ã¾ã™ã€‚',0),(529016,14695,'pt','Enviar a factura',0),(529017,14695,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(529018,14695,'es','EnviarÃ¡ la factura',0),(529019,14695,'de','Rechnung senden',0),(529020,14695,'en','Send Invoice',0),(529021,14696,'is','',0),(529022,14696,'dr','Ú¯Ø²Ø§Ø±Ø´ CSR',0),(529023,14696,'pr','Ú¯Ø²Ø§Ø±Ø´ CSR',0),(529024,14696,'tr','CSR raporu',0),(529025,14696,'pl','Raport CSR',0),(529026,14696,'bg','ÐšÐ¡Ðž Ð´Ð¾ÐºÐ»Ð°Ð´',0),(529027,14696,'ur','CSR Ø±Ù¾ÙˆØ±Ù¹',0),(529028,14696,'sr','Ð¦Ð¡Ð  Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(529029,14696,'vi','CSR bÃ¡o cÃ¡o',0),(529030,14696,'af','CSR-herwinning verslag',0),(529031,14696,'ro','Raport de CSR',0),(529032,14696,'et','CSR aruannet',0),(529033,14696,'si','CSR poroÄilo',0),(529034,14696,'ba','Laporan CSR',0),(529035,14696,'nl','Maatschappelijk verslag',0),(529036,14696,'fi','CSR-raportti',0),(529037,14696,'no','CSR Report',0),(529038,14696,'da','CSR-rapport',0),(529039,14696,'ko','CSR ë³´ê³ ì„œ',0),(529040,14696,'he','×“×• ×— ××—×¨×™×•×ª ×ª××’×™×“×™×ª',0),(529041,14696,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î‘ÎµÎ¹Ï†Î¿ÏÎ¯Î±Ï‚',0),(529042,14696,'zh','ä¼ä¸šç¤¾ä¼šè´£ä»»æŠ¥å‘Š',0),(529043,14696,'sv','CSR rapport',0),(529044,14696,'it','Rapporto CSR',0),(529045,14696,'tl','',0),(529046,14696,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™ CSR',0),(529047,14696,'hi','à¤¸à¥€à¤à¤¸à¤†à¤° à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(529048,14696,'ms','Laporan tanggungjawab sosial korporat',0),(529049,14696,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…Ø³Ø¤ÙˆÙ„ÙŠØ© Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠØ© Ù„Ù„Ø´Ø±ÙƒØ§Øª',0),(529050,14696,'fr','Rapport sur la RSE',0),(529051,14696,'jp','CSR å ±å‘Šæ›¸',0),(529052,14696,'pt','RelatÃ³rio de RSE',0),(529053,14696,'ru','CÐ¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(529054,14696,'es','Informe de RSC',0),(529055,14696,'de','CSR-Bericht',0),(529056,14696,'en','CSR Report',0),(529057,14697,'is','',0),(529058,14697,'dr','Ù¾Ø§Ú©Øª Ù†Ø§Ù…Ù‡ Ø¨Ø±Ø§ÛŒ Ú†Ø§Ù¾',0),(529059,14697,'pr','Ù¾Ø§Ú©Øª Ù†Ø§Ù…Ù‡ Ø¨Ø±Ø§ÛŒ Ú†Ø§Ù¾',0),(529060,14697,'tr','ZarflarÄ± yazdÄ±rma',0),(529061,14697,'pl','Koperty do wydruku',0),(529062,14697,'bg','ÐŸÐ»Ð¸ÐºÐ¾Ð²Ðµ Ñ Ð¿ÐµÑ‡Ð°Ñ‚',0),(529063,14697,'ur','Ù„ÙØ§ÙÛ’ Ú†Ú¾Ø§Ù¾ÛŒÚº Ú©Û’ Ù„ÛŒÛ’',0),(529064,14697,'sr','ÐšÐ¾Ð²ÐµÑ€Ñ‚Ðµ Ð·Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°ÑšÐµ',0),(529065,14697,'vi','Phong bÃ¬ Ä‘á»ƒ in',0),(529066,14697,'af','Koeverte te druk',0),(529067,14697,'ro','Plicuri pentru imprimare',0),(529068,14697,'et','Ãœmbrike printimine',0),(529069,14697,'si','Kuverte, tisk',0),(529070,14697,'ba','Amplop untuk cetak',0),(529071,14697,'nl','Enveloppen afdrukken',0),(529072,14697,'fi','Kirjekuorien tulostaminen',0),(529073,14697,'no','Konvolutter til ut',0),(529074,14697,'da','Konvolutter til Print',0),(529075,14697,'ko','ë´‰íˆ¬ ì¸ì‡„',0),(529076,14697,'he','×ž×¢×˜×¤×•×ª ×œ×”×“×¤×¡×”',0),(529077,14697,'el','Î¦Î¬ÎºÎµÎ»Î¿Î¹ Î³Î¹Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(529078,14697,'zh','æ‰“å°ä¿¡å°',0),(529079,14697,'sv','Kuvert till Print',0),(529080,14697,'it','Buste per stampa',0),(529081,14697,'tl','',0),(529082,14697,'th','à¸‹à¸­à¸‡à¸ˆà¸”à¸«à¸¡à¸²à¸¢à¹€à¸¡à¸·à¹ˆà¸­à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸žà¸´à¸¡à¸žà¹Œ',0),(529083,14697,'hi','à¤²à¤¿à¤«à¤¼à¤¾à¤«à¤¼à¥‡ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(529084,14697,'ms','Sampul surat untuk cetak',0),(529085,14697,'ar','Ù…ØºÙ„ÙØ§Øª Ù„Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(529086,14697,'fr','Enveloppes Ã  imprimer',0),(529087,14697,'jp','å°ç­’ã®å°åˆ·',0),(529088,14697,'pt','Envelopes para imprimir',0),(529089,14697,'ru','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚Ñ‹, Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ',0),(529090,14697,'es','Sobres para imprimir',0),(529091,14697,'de','UmschlÃ¤ge drucken',0),(529092,14697,'en','Envelopes To Print',0),(529093,14698,'is','',0),(529094,14698,'dr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø§Ù…Ø³Ø§Ù„',0),(529095,14698,'pr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø§Ù…Ø³Ø§Ù„',0),(529096,14698,'tr','Emir bu yÄ±l',0),(529097,14698,'pl','Nie zamÃ³wienia w tym roku',0),(529098,14698,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ñ‚Ð°Ð·Ð¸ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(529099,14698,'ur','Ú©ÙˆØ¦ÛŒ Ø­Ú©Ù… Ø§Ø³ Ø³Ø§Ù„',0),(529100,14698,'sr','ÐÐ¸ÐºÐ°ÐºÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ°, Ð¾Ð²Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(529101,14698,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n Ä‘áº·t hÃ ng nÄƒm nay',0),(529102,14698,'af','Geen bestellings hierdie jaar',0),(529103,14698,'ro','Nici o ordine Ã®n acest an',0),(529104,14698,'et','Pole tellimusi sel aastal',0),(529105,14698,'si','Letos ni bilo naroÄil',0),(529106,14698,'ba','Tidak ada order tahun ini',0),(529107,14698,'nl','Geen Orders dit jaar',0),(529108,14698,'fi','Tilauksia ei tÃ¤nÃ¤ vuonna',0),(529109,14698,'no','Ingen ordrer i Ã¥r',0),(529110,14698,'da','Ingen ordrer i Ã¥r',0),(529111,14698,'ko','ì•„ë‹ˆ ì£¼ë¬¸ ì˜¬í•´',0),(529112,14698,'he','×¤×§×•×“×•×ª ×”×©× ×”',0),(529113,14698,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ Ï†Î­Ï„Î¿Ï‚',0),(529114,14698,'zh','ä»Šå¹´æ²¡æœ‰è®¢å•',0),(529115,14698,'sv','Inga order i Ã¥r',0),(529116,14698,'it','Nessun ordine di quest\'anno',0),(529117,14698,'tl','',0),(529118,14698,'th','à¸›à¸µà¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(529119,14698,'hi','à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤‡à¤¸ à¤µà¤°à¥à¤·',0),(529120,14698,'ms','Tiada pesanan tahun ini',0),(529121,14698,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙˆØ§Ù…Ø± Ù‡Ø°Ø§ Ø§Ù„Ø¹Ø§Ù…',0),(529122,14698,'fr','Aucune commande cette annÃ©e',0),(529123,14698,'jp','æ³¨æ–‡ã®ãªã„ä»Šå¹´',0),(529124,14698,'pt','Nenhuma ordem este ano',0),(529125,14698,'ru','ÐÐµÑ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð² ÑÑ‚Ð¾Ð¼ Ð³Ð¾Ð´Ñƒ',0),(529126,14698,'es','No hay Ã³rdenes este aÃ±o',0),(529127,14698,'de','Keine Bestellungen in diesem Jahr',0),(529128,14698,'en','No Orders This Year',0),(529129,14699,'is','',0),(529130,14699,'dr','Ø´Ø±Ø­ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(529131,14699,'pr','Ø´Ø±Ø­ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(529132,14699,'tr','Standart iÅŸ tanÄ±mlarÄ±',0),(529133,14699,'pl','Standardowych opisÃ³w',0),(529134,14699,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð¸ Ð´Ð»ÑŠÐ¶Ð½Ð¾ÑÑ‚Ð½Ð¸ Ñ…Ð°Ñ€Ð°ÐºÑ‚ÐµÑ€Ð¸ÑÑ‚Ð¸ÐºÐ¸',0),(529135,14699,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ú©Ø§Ù… ØªØµØ±ÛŒØ­Ø§Øª',0),(529136,14699,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð¿Ð¾ÑÐ°Ð¾ Ð¾Ð¿Ð¸ÑÐµ',0),(529137,14699,'vi','MÃ´ táº£ cÃ´ng viá»‡c tiÃªu chuáº©n',0),(529138,14699,'af','Standaard werk beskrywings',0),(529139,14699,'ro','Fise standard',0),(529140,14699,'et','Standard ametijuhendid',0),(529141,14699,'si','Standard opisih',0),(529142,14699,'ba','Deskripsi pekerjaan standar',0),(529143,14699,'nl','Standaard functiebeschrijvingen',0),(529144,14699,'fi','Standardin toimenkuvat',0),(529145,14699,'no','Standard jobbeskrivelser',0),(529146,14699,'da','Standard jobbeskrivelser',0),(529147,14699,'ko','í‘œì¤€ ìž‘ì—… ì„¤ëª…',0),(529148,14699,'he','×ª×™××•×¨×™× ×¢×‘×•×“×” ×¡×˜× ×“×¨×˜×™×ª',0),(529149,14699,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†ÏŽÎ½',0),(529150,14699,'zh','æ ‡å‡†èŒåŠ¡è¯´æ˜Ž',0),(529151,14699,'sv','Standard arbetsbeskrivningar',0),(529152,14699,'it','Descrizioni del lavoro standard',0),(529153,14699,'tl','',0),(529154,14699,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹€à¸à¸µà¹ˆà¸¢à¸§à¸à¸±à¸šà¸‡à¸²à¸™à¸¡à¸²à¸•à¸£à¸à¸²à¸™',0),(529155,14699,'hi','à¤®à¤¾à¤¨à¤• à¤¨à¥Œà¤•à¤°à¥€ à¤µà¤¿à¤µà¤°à¤£',0),(529156,14699,'ms','Deskripsi tugas Standard',0),(529157,14699,'ar','ØªÙˆØµÙŠÙ Ø§Ù„ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(529158,14699,'fr','Descriptions de travail standard',0),(529159,14699,'jp','æ¨™æº–çš„ãªã‚¸ãƒ§ãƒ–ã®èª¬æ˜Ž',0),(529160,14699,'pt','DescriÃ§Ãµes de trabalho padrÃ£o',0),(529161,14699,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(529162,14699,'es','Descripciones estÃ¡ndar',0),(529163,14699,'de','Standard-Job-Beschreibungen',0),(529164,14699,'en','Standard Job Descriptions',0),(529165,14700,'is','',0),(529166,14700,'dr','Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø§Ø¶Ø§ÙÛŒ',0),(529167,14700,'pr','Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ø§Ø¶Ø§ÙÛŒ',0),(529168,14700,'tr','Ä°lave kurulum seÃ§eneklerini',0),(529169,14700,'pl','Dodatkowe opcje instalacyjne',0),(529170,14700,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(529171,14700,'ur','Ø§Ø¶Ø§ÙÛŒ Ø³ÛŒÙ¹ Ø§Ù¾ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(529172,14700,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¸Ð½ÑÑ‚Ð°Ð»Ð°Ñ†Ð¸Ñ˜Ðµ',0),(529173,14700,'vi','TÃ¹y chá»n bá»• sung thiáº¿t láº­p',0),(529174,14700,'af','Bykomende opstel opsies',0),(529175,14700,'ro','OpÅ£iunile de configurare suplimentare',0),(529176,14700,'et','TÃ¤iendavad',0),(529177,14700,'si','Dodatne nastavitve',0),(529178,14700,'ba','Pilihan tambahan persediaan',0),(529179,14700,'nl','Aanvullende instellingsopties',0),(529180,14700,'fi','LisÃ¤asetuksia',0),(529181,14700,'no','Flere oppsettalternativer',0),(529182,14700,'da','Yderligere opsÃ¦tningsindstillinger',0),(529183,14700,'ko','ì¶”ê°€ ì„¤ì • ì˜µì…˜',0),(529184,14700,'he','××¤×©×¨×•×™×•×ª ×”×’×“×¨×ª × ×•×¡×¤×™×',0),(529185,14700,'el','Î•Î³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(529186,14700,'zh','é™„åŠ çš„è®¾ç½®é€‰é¡¹',0),(529187,14700,'sv','Ytterligare installationsalternativ',0),(529188,14700,'it','Opzioni di installazione aggiuntive',0),(529189,14700,'tl','',0),(529190,14700,'th','à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(529191,14700,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤µà¤¿à¤•à¤²à¥à¤ª',0),(529192,14700,'ms','Persediaan tambahan pilihan',0),(529193,14700,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø¥Ø¹Ø¯Ø§Ø¯ Ø¥Ø¶Ø§ÙÙŠØ©',0),(529194,14700,'fr','Options d\'installation supplÃ©mentaires',0),(529195,14700,'jp','è¿½åŠ ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ— ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(529196,14700,'pt','OpÃ§Ãµes de configuraÃ§Ã£o adicionais',0),(529197,14700,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹',0),(529198,14700,'es','Opciones de configuraciÃ³n adicionales',0),(529199,14700,'de','ZusÃ¤tzliche Setup-Optionen',0),(529200,14700,'en','Additional Setup Options',0),(529201,14701,'is','',0),(529202,14701,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ú©Ù¾ÛŒ Ø§Ø² ÙØ¹Ù„ÛŒ Ø´Ø±Ú©Øª',0),(529203,14701,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ú©Ù¾ÛŒ Ø§Ø² ÙØ¹Ù„ÛŒ Ø´Ø±Ú©Øª',0),(529204,14701,'tr','GeÃ§erli ÅŸirketi satÄ±cÄ±lardan Kopyala',0),(529205,14701,'pl','Skopiuj dostawcÃ³w firmy prÄ…du',0),(529206,14701,'bg','ÐšÐ¾Ð¿Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð¾Ñ‚ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(529207,14701,'ur','Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ù†Û’ Ù…ÙˆØ¬ÙˆØ¯Û Ú©Ù…Ù¾Ù†ÛŒ Ø³Û’ Ù†Ù‚Ù„ Ú©Ø±ÛŒÚº',0),(529208,14701,'sr','ÐšÐ¾Ð¿Ð¸Ñ€Ð°ÑšÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ Ð¸Ð· Ñ‚ÐµÐºÑƒÑ›ÐµÐ³ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ',0),(529209,14701,'vi','NhÃ  cung cáº¥p báº£n sao tá»« hiá»‡n táº¡i cÃ´ng ty',0),(529210,14701,'af','Kopieer verkopers van huidige maatskappy',0),(529211,14701,'ro','CopiaÅ£i vÃ¢nzÄƒtorii de compania actualÄƒ',0),(529212,14701,'et','MÃ¼Ã¼jate kopeerimiseks praeguse ettevÃµtte',0),(529213,14701,'si','Izvod prodajalci iz trenutno podjetje',0),(529214,14701,'ba','Menyalin vendor dari perusahaan saat ini',0),(529215,14701,'nl','Leveranciers van huidig bedrijf kopiÃ«ren',0),(529216,14701,'fi','Kopioi nykyisen yrityksen myyjÃ¤t',0),(529217,14701,'no','Kopiere leverandÃ¸rer fra gjeldende selskap',0),(529218,14701,'da','Kopiere leverandÃ¸rer fra aktuelt regnskab',0),(529219,14701,'ko','í˜„ìž¬ íšŒì‚¬ì—ì„œ ë³µì‚¬ ì—…ì²´',0),(529220,14701,'he','×”×¢×ª×§ ×¡×¤×§×™ ×”×—×‘×¨×” ×”× ×•×›×—×™',0),(529221,14701,'el','Î‘Î½Ï„Î¯Î³ÏÎ±Ï†Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ Î±Ï€ÏŒ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(529222,14701,'zh','å¤åˆ¶ä»Žå½“å‰å…¬å¸çš„ä¾›åº”å•†',0),(529223,14701,'sv','Kopiera leverantÃ¶rer frÃ¥n aktuellt fÃ¶retag',0),(529224,14701,'it','Fornitori di copia da societÃ  corrente',0),(529225,14701,'tl','',0),(529226,14701,'th','à¸„à¸±à¸”à¸¥à¸­à¸à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸ˆà¸²à¸ à¸šà¸£à¸´à¸©à¸±à¸—à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(529227,14701,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(529228,14701,'ms','Salin vendor dari Syarikat semasa',0),(529229,14701,'ar','Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ† Ù†Ø³Ø®Ø© Ù…Ù† Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(529230,14701,'fr','Copier des fournisseurs de la compagnie actuelle',0),(529231,14701,'jp','ç¾åœ¨ã®ä¼šç¤¾ã‹ã‚‰ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’ã‚³ãƒ”ãƒ¼ã—ã¾ã™ã€‚',0),(529232,14701,'pt','CÃ³pia de fornecedores da empresa atual',0),(529233,14701,'ru','ÐšÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¸Ð· Ñ‚ÐµÐºÑƒÑ‰ÐµÐ¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(529234,14701,'es','Vendedores de copia de la actual compaÃ±Ã­a',0),(529235,14701,'de','Anbieter von aktuelle Firma kopieren',0),(529236,14701,'en','Copy Vendors From Current Company',0),(529237,14702,'is','',0),(529238,14702,'dr','Ø§ÛŒØ¬Ø§Ø¯ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(529239,14702,'pr','Ø§ÛŒØ¬Ø§Ø¯ ÛŒÚ© Ø­Ø³Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(529240,14702,'tr','Yeni kullanÄ±cÄ± hesabÄ± oluÅŸturma',0),(529241,14702,'pl','Tworzenie nowego konta uÅ¼ytkownika',0),(529242,14702,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(529243,14702,'ur','Ø§ÛŒÚ© Ù†ÛŒØ§ ØµØ§Ø±Ù Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(529244,14702,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾Ð³ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(529245,14702,'vi','Táº¡o tÃ i khoáº£n ngÆ°á»i dÃ¹ng má»›i',0),(529246,14702,'af','Skep \'n nuwe gebruikersrekening',0),(529247,14702,'ro','CreaÅ£i un cont nou de utilizator',0),(529248,14702,'et','Uue kasutajakonto loomine',0),(529249,14702,'si','Ustvarite nov uporabniÅ¡ki raÄun',0),(529250,14702,'ba','Membuat Account pengguna baru',0),(529251,14702,'nl','Een nieuwe gebruikersaccount maken',0),(529252,14702,'fi','Luo uusi kÃ¤yttÃ¤jÃ¤tili',0),(529253,14702,'no','Opprette en ny brukerkonto',0),(529254,14702,'da','Opret en ny brugerkonto',0),(529255,14702,'ko','ìƒˆ ì‚¬ìš©ìž ê³„ì • ë§Œë“¤ê¸°',0),(529256,14702,'he','×œ×™×¦×•×¨ ×—×©×‘×•×Ÿ ×ž×©×ª×ž×© ×—×“×©',0),(529257,14702,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î­Î½Î± Î½Î­Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï‡ÏÎ®ÏƒÏ„Î·',0),(529258,14702,'zh','åˆ›å»ºä¸€ä¸ªæ–°çš„ç”¨æˆ·å¸æˆ·',0),(529259,14702,'sv','Skapa ett nytt anvÃ¤ndarkonto',0),(529260,14702,'it','Creare un nuovo Account utente',0),(529261,14702,'tl','',0),(529262,14702,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸šà¸±à¸à¸Šà¸µà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹ƒà¸«à¸¡à¹ˆ',0),(529263,14702,'hi','à¤•à¥‹à¤ˆ à¤¨à¤¯à¤¾ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(529264,14702,'ms','Mencipta satu akaun pengguna baru',0),(529265,14702,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø­Ø³Ø§Ø¨ Ù…Ø³ØªØ®Ø¯Ù… Ø¬Ø¯ÙŠØ¯',0),(529266,14702,'fr','CrÃ©er un nouveau compte d\'utilisateur',0),(529267,14702,'jp','æ–°ã—ã„ãƒ¦ãƒ¼ã‚¶ãƒ¼ ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½œæˆã—ã¾ã™ã€‚',0),(529268,14702,'pt','Criar uma nova conta de usuÃ¡rio',0),(529269,14702,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð¹ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(529270,14702,'es','Crear una nueva cuenta de usuario',0),(529271,14702,'de','Erstellen eines neuen Benutzerkontos',0),(529272,14702,'en','Create A New User Account',0),(529273,14703,'is','',0),(529274,14703,'dr','Ø¨Ø±Ú†Ø³Ø¨ Ø¨Ø§Ø±Ú©Ø¯ Ù…ÙˆØ±Ø¯ Ù¾ÛŒØ´ ÙØ±Ø¶',0),(529275,14703,'pr','Ø¨Ø±Ú†Ø³Ø¨ Ø¨Ø§Ø±Ú©Ø¯ Ù…ÙˆØ±Ø¯ Ù¾ÛŒØ´ ÙØ±Ø¶',0),(529276,14703,'tr','VarsayÄ±lan madde barkod etiket',0),(529277,14703,'pl','DomyÅ›lna pozycja etykiety kodÃ³w kreskowych',0),(529278,14703,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð±Ð°Ñ€ÐºÐ¾Ð´ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð¸',0),(529279,14703,'ur','Ø·Û’ Ø´Ø¯Û Ø´Û’ Ø¨Ø§Ø±Ú©ÙˆÚˆ Ù„ÛŒØ¨Ù„',0),(529280,14703,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð‘Ð°Ñ€Ñ†Ð¾Ð´Ðµ Ð¾Ð·Ð½Ð°ÐºÐ°',0),(529281,14703,'vi','Máº·c Ä‘á»‹nh má»¥c mÃ£ váº¡ch nhÃ£n',0),(529282,14703,'af','Verstek Item strepieskode etiket',0),(529283,14703,'ro','Implicit elementului de coduri de bare etichetÄƒ',0),(529284,14703,'et','Kauba vÃ¶Ã¶tkoodi vaikesildi',0),(529285,14703,'si','Privzete oznake elementa Ärtne kode',0),(529286,14703,'ba','Item standar Label Barcode',0),(529287,14703,'nl','Barcode Label standaarditem',0),(529288,14703,'fi','Oletusarvo viivakooditarra',0),(529289,14703,'no','Standard strekkodeetikett',0),(529290,14703,'da','Standard vare stregkodeetiket',0),(529291,14703,'ko','ê¸°ë³¸ í•­ëª© ë°”ì½”ë“œ ë¼ë²¨',0),(529292,14703,'he','×ª×•×•×™×ª ×‘×¨×§×•×“ ×”×¤×¨×™×˜ ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(529293,14703,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÏ„Î¹ÎºÎµÏ„ÏŽÎ½',0),(529294,14703,'zh','é»˜è®¤ç‰©æ–™æ¡ç æ ‡ç­¾',0),(529295,14703,'sv','Standard objekt streckkodsetikett',0),(529296,14703,'it','Etichetta Barcode predefinita Item',0),(529297,14703,'tl','',0),(529298,14703,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸‰à¸¥à¸²à¸',0),(529299,14703,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤†à¤‡à¤Ÿà¤® à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤²à¥‡à¤¬à¤²',0),(529300,14703,'ms','Label Kod Bar perkara lalai',0),(529301,14703,'ar','ØªØ³Ù…ÙŠØ© Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠ Ø¹Ù†ØµØ± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(529302,14703,'fr','Ã‰tiquette de code Ã  barres de point par dÃ©faut',0),(529303,14703,'jp','æ—¢å®šã‚¢ã‚¤ãƒ†ãƒ ã®ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ ãƒ©ãƒ™ãƒ«',0),(529304,14703,'pt','Etiqueta de cÃ³digo de barras padrÃ£o Item',0),(529305,14703,'ru','Ð¨Ñ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(529306,14703,'es','Etiqueta de cÃ³digo de barras del artÃ­culo predeterminado',0),(529307,14703,'de','Standard-Element-Barcode-Etiketten',0),(529308,14703,'en','Default Item Barcode Label',0),(529309,14704,'is','',0),(529310,14704,'dr','Ù…ÙˆØ±Ø¯ Ø¨Ø±Ú†Ø³Ø¨ Ø¨Ø§Ø±Ú©Ø¯ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª Ù¾ÛŒØ´ ÙØ±Ø¶',0),(529311,14704,'pr','Ù…ÙˆØ±Ø¯ Ø¨Ø±Ú†Ø³Ø¨ Ø¨Ø§Ø±Ú©Ø¯ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª Ù¾ÛŒØ´ ÙØ±Ø¶',0),(529312,14704,'tr','Ã–ÄŸe Ã¶ndeÄŸeri sipariÅŸler iÃ§in barkod etiket',0),(529313,14704,'pl','DomyÅ›lna pozycja etykiety kodÃ³w kreskowych zleceÅ„',0),(529314,14704,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð±Ð°Ñ€ÐºÐ¾Ð´ ÐµÑ‚Ð¸ÐºÐµÑ‚Ð° Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(529315,14704,'ur','Ø¨Ø§Ø±Ú©ÙˆÚˆ Ù„ÛŒØ¨Ù„ Ú©Û’ Ø­Ú©Ù… Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û Ø´Û’',0),(529316,14704,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð‘Ð°Ñ€Ñ†Ð¾Ð´Ðµ Ð¾Ð·Ð½Ð°ÐºÐ° Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(529317,14704,'vi','Máº·c Ä‘á»‹nh má»¥c mÃ£ váº¡ch nhÃ£n cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(529318,14704,'af','Verstek Item strepieskode etiket vir bestellings',0),(529319,14704,'ro','Elementul implicit de coduri de bare etichetÄƒ pentru comenzi',0),(529320,14704,'et','Vaikimisi kauba vÃ¶Ã¶tkoodi mÃ¤rgistuse tellimuste',0),(529321,14704,'si','Privzeti element Ärtno kodo oznako za naroÄila',0),(529322,14704,'ba','Item standar Label Barcode untuk pesanan',0),(529323,14704,'nl','Barcode Label voor Orders standaarditem',0),(529324,14704,'fi','Oletusarvo viivakooditarra tilauksia',0),(529325,14704,'no','Standard strekkodeetikett For bestillinger',0),(529326,14704,'da','Standard vare stregkodeetiket For ordrer',0),(529327,14704,'ko','ë°”ì½”ë“œ ë ˆì´ë¸” ì£¼ë¬¸ì— ëŒ€ í•œ ê¸°ë³¸ í•­ëª©',0),(529328,14704,'he','×›×‘×¨×™×¨×ª ×ž×—×“×œ ×œ×¤×¨×™×˜ ×ª×•×•×™×ª ×‘×¨×§×•×“ ×¢×‘×•×¨ ×”×–×ž× ×•×ª',0),(529329,14704,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÏ„Î¹ÎºÎµÏ„ÏŽÎ½ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(529330,14704,'zh','é»˜è®¤é¡¹ç›®è®¢å•çš„æ¡å½¢ç æ ‡ç­¾',0),(529331,14704,'sv','Standard objekt streckkodsetikett fÃ¶r order',0),(529332,14704,'it','Elemento predefinito Barcode Label per ordini',0),(529333,14704,'tl','',0),(529334,14704,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸‰à¸¥à¸²à¸à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(529335,14704,'hi','à¤®à¤¦ à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤²à¥‡à¤¬à¤² à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(529336,14704,'ms','Lalai Item Label Kod Bar untuk Tempahan',0),(529337,14704,'ar','Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¹Ù†ØµØ± ØªØ³Ù…ÙŠØ© Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠ Ù„Ø£ÙˆØ§Ù…Ø±',0),(529338,14704,'fr','Default Item Barcode Label pour les commandes',0),(529339,14704,'jp','ãƒãƒ¼ã‚³ãƒ¼ãƒ‰ ãƒ» ãƒ©ãƒ™ãƒ«ã®æ³¨æ–‡ã®æ—¢å®šã‚¢ã‚¤ãƒ†ãƒ ',0),(529340,14704,'pt','PadrÃ£o Item Etiqueta de cÃ³digo de barras para encomendas',0),(529341,14704,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(529342,14704,'es','Elemento predeterminado etiqueta de cÃ³digo de barras para pedidos',0),(529343,14704,'de','Standard Element Barcode-Etikett fÃ¼r Bestellungen',0),(529344,14704,'en','Default Item Barcode Label For Orders',0),(529345,14705,'is','',0),(529346,14705,'dr','Ø§Ø² Ø¢Ø®Ø±ÛŒÙ† Ø¨Ø§Ø²Ø¯ÛŒØ¯ Ø´Ù…Ø§',0),(529347,14705,'pr','Ø§Ø² Ø¢Ø®Ø±ÛŒÙ† Ø¨Ø§Ø²Ø¯ÛŒØ¯ Ø´Ù…Ø§',0),(529348,14705,'tr','Son ziyaretinizden beri',0),(529349,14705,'pl','Od Twojej ostatniej wizyty',0),(529350,14705,'bg','ÐžÑ‚ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð²Ð¸ Ð¿Ð¾ÑÐµÑ‰ÐµÐ½Ð¸Ðµ',0),(529351,14705,'ur','Ø§Ù¾Ù†Û’ Ø¢Ø®Ø±ÛŒ Ø¯ÙˆØ±Û’ Ú©Û’ Ø¨Ø¹Ø¯',0),(529352,14705,'sr','ÐžÐ´ Ñ‚Ð²Ð¾Ñ˜Ðµ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð¿Ð¾ÑÐµÑ‚Ðµ',0),(529353,14705,'vi','Ká»ƒ tá»« chuyáº¿n thÄƒm cuá»‘i cÃ¹ng cá»§a báº¡n',0),(529354,14705,'af','Sedert jou laaste besoek',0),(529355,14705,'ro','La ultima ta vizita',0),(529356,14705,'et','Alates teie viimasest kÃ¼lastusest',0),(529357,14705,'si','Od vaÅ¡ega zadnjega obiska',0),(529358,14705,'ba','Sejak Your Last Visit',0),(529359,14705,'nl','Sinds uw laatste bezoek',0),(529360,14705,'fi','Viime kÃ¤yntisi',0),(529361,14705,'no','Siden sist besÃ¸k',0),(529362,14705,'da','Siden dit sidste besÃ¸g',0),(529363,14705,'ko','ë‹¹ì‹ ì˜ ë§ˆì§€ë§‰ ë°©ë¬¸ ì´í›„',0),(529364,14705,'he','×ž××– ×‘×™×§×•×¨×š ×”××—×¨×•×Ÿ',0),(529365,14705,'el','Î‘Ï€ÏŒ Ï„Î·Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÏƒÎ±Ï‚ ÎµÏ€Î¯ÏƒÎºÎµÏˆÎ·',0),(529366,14705,'zh','è‡ªä½ ä¸Šæ¬¡è®¿é—®ä»¥æ¥',0),(529367,14705,'sv','Sedan ditt senaste besÃ¶k',0),(529368,14705,'it','Dalla tua ultima visita',0),(529369,14705,'tl','',0),(529370,14705,'th','à¸•à¸±à¹‰à¸‡à¹à¸•à¹ˆà¸à¸²à¸£à¹€à¸”à¸´à¸™',0),(529371,14705,'hi','à¤†à¤ªà¤•à¤¾ à¤…à¤‚à¤¤à¤¿à¤® à¤¯à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤¬à¤¾à¤¦',0),(529372,14705,'ms','Sejak kunjungan terakhir',0),(529373,14705,'ar','Ù…Ù†Ø° Ø¢Ø®Ø± Ø²ÙŠØ§Ø±Ø© Ù„Ùƒ',0),(529374,14705,'fr','Depuis votre derniÃ¨re visite',0),(529375,14705,'jp','å‰å›žã®ã‚¢ã‚¯ã‚»ã‚¹ä»¥é™',0),(529376,14705,'pt','Desde sua Ãºltima visita',0),(529377,14705,'ru','Ð¡ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ð²Ð°ÑˆÐµÐ³Ð¾ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ Ð²Ð¸Ð·Ð¸Ñ‚Ð°',0),(529378,14705,'es','Desde su Ãºltima visita',0),(529379,14705,'de','Seit Ihrem letzten Besuch',0),(529380,14705,'en','Since Your Last Visit',0),(529381,14706,'is','',0),(529382,14706,'dr','# ÙØ§Ú©ØªÙˆØ±',0),(529383,14706,'pr','# ÙØ§Ú©ØªÙˆØ±',0),(529384,14706,'tr','Fatura #',0),(529385,14706,'pl','Faktura #',0),(529386,14706,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¾Ð¼ÐµÑ€',0),(529387,14706,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ #',0),(529388,14706,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ñ‚Ð¸ #',0),(529389,14706,'vi','HoÃ¡ Ä‘Æ¡n #',0),(529390,14706,'af','Faktuur #',0),(529391,14706,'ro','Factura #',0),(529392,14706,'et','Arve #',0),(529393,14706,'si','RaÄun #',0),(529394,14706,'ba','Faktur #',0),(529395,14706,'nl','Factuur #',0),(529396,14706,'fi','Laskun numero',0),(529397,14706,'no','Fakturanummer',0),(529398,14706,'da','Faktura #',0),(529399,14706,'ko','# ì†¡ìž¥',0),(529400,14706,'he','×—×©×‘×•× ×™×ª #',0),(529401,14706,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ #',0),(529402,14706,'zh','å‘ç¥¨å·ç ',0),(529403,14706,'sv','Fakturera #',0),(529404,14706,'it','Fattura #',0),(529405,14706,'tl','',0),(529406,14706,'th','#à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(529407,14706,'hi','à¤šà¤¾à¤²à¤¾à¤¨ #',0),(529408,14706,'ms','Invois #',0),(529409,14706,'ar','Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(529410,14706,'fr','# La facture',0),(529411,14706,'jp','# è«‹æ±‚æ›¸ã—ã¾ã™ã€‚',0),(529412,14706,'pt','Invoice #',0),(529413,14706,'ru','Ð¡Ñ‡ÐµÑ‚ #',0),(529414,14706,'es','Factura #',0),(529415,14706,'de','# In Rechnung zu stellen',0),(529416,14706,'en','Invoice #',0),(529417,14707,'is','',0),(529418,14707,'dr','ÙØ§Ú©ØªÙˆØ± Ø¯ÙˆØ±Ù‡ - 1 Ø³Ø§Ù„',0),(529419,14707,'pr','ÙØ§Ú©ØªÙˆØ± Ø¯ÙˆØ±Ù‡ - 1 Ø³Ø§Ù„',0),(529420,14707,'tr','Fatura hacmi - 1 yÄ±l',0),(529421,14707,'pl','Faktura wielkoÅ›ci - 1 rok',0),(529422,14707,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¾Ð±ÐµÐ¼ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(529423,14707,'ur','ØµÙˆØª - 1 Ø³Ø§Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(529424,14707,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(529425,14707,'vi','Khá»‘i lÆ°á»£ng hÃ³a Ä‘Æ¡n â€“ 1 nÄƒm',0),(529426,14707,'af','Faktuur Volume - 1 jaar',0),(529427,14707,'ro','Factura de volum - 1 an',0),(529428,14707,'et','Arve maht - 1 aasta',0),(529429,14707,'si','RaÄunu obsega - 1 leto',0),(529430,14707,'ba','Faktur Volume - 1 tahun',0),(529431,14707,'nl','Factuur Volume - 1 jaar',0),(529432,14707,'fi','Laskun mÃ¤Ã¤rÃ¤ - 1 vuosi',0),(529433,14707,'no','Faktura volum - 1 Ã¥r',0),(529434,14707,'da','Faktura volumen - 1 Ã¥r',0),(529435,14707,'ko','ì†¡ìž¥ ë³¼ë¥¨-1 ë…„',0),(529436,14707,'he','×—×©×‘×•× ×™×ª × ×¤×— - 1 ×©× ×”',0),(529437,14707,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„ÏŒÎ¼Î¿Ï‚ - 1 Î­Ï„Î¿Ï‚',0),(529438,14707,'zh','å‘ç¥¨é‡-1 å¹´',0),(529439,14707,'sv','Faktura volym - 1 Ã¥r',0),(529440,14707,'it','Volume di fattura - 1 anno',0),(529441,14707,'tl','',0),(529442,14707,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ - 1 à¸›à¸µ',0),(529443,14707,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ - 1 à¤¸à¤¾à¤²',0),(529444,14707,'ms','Jumlah invois - 1 tahun',0),(529445,14707,'ar','Ø­Ø¬Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©-Ø³Ù†Ø© 1',0),(529446,14707,'fr','Facture Volume - 1 an',0),(529447,14707,'jp','è«‹æ±‚æ›¸ã®å·» - 1 å¹´',0),(529448,14707,'pt','Volume de nota fiscal - 1 ano',0),(529449,14707,'ru','ÐžÐ±ÑŠÐµÐ¼ ÑÑ‡ÐµÑ‚Ð° - 1 Ð³Ð¾Ð´',0),(529450,14707,'es','Volumen de factura - 1 aÃ±o',0),(529451,14707,'de','Rechnung Volume - 1 Jahr',0),(529452,14707,'en','Invoice Volume - 1 Year',0),(529453,14708,'is','',0),(529454,14708,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª #',0),(529455,14708,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª #',0),(529456,14708,'tr','Ã–deme #',0),(529457,14708,'pl','PÅ‚atnoÅ›ci #',0),(529458,14708,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ #',0),(529459,14708,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ #',0),(529460,14708,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° #',0),(529461,14708,'vi','Thanh toÃ¡n #',0),(529462,14708,'af','Betaling #',0),(529463,14708,'ro','Plata #',0),(529464,14708,'et','Makse #',0),(529465,14708,'si','PlaÄilo #',0),(529466,14708,'ba','Pembayaran #',0),(529467,14708,'nl','Betaling #',0),(529468,14708,'fi','Maksun #',0),(529469,14708,'no','Betaling #',0),(529470,14708,'da','Betaling #',0),(529471,14708,'ko','ì§€ë¶ˆ #',0),(529472,14708,'he','×”×ª×©×œ×•× #',0),(529473,14708,'el','Î Î»Î·ÏÏ‰Î¼Î® #',0),(529474,14708,'zh','ä»˜æ¬¾ #',0),(529475,14708,'sv','Betalning #',0),(529476,14708,'it','Pagamento #',0),(529477,14708,'tl','',0),(529478,14708,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™#',0),(529479,14708,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ #',0),(529480,14708,'ms','Pembayaran #',0),(529481,14708,'ar','Ø§Ù„Ø¯ÙØ¹ #',0),(529482,14708,'fr','Paiement #',0),(529483,14708,'jp','æ”¯æ‰•ã„ #',0),(529484,14708,'pt','Pagamento #',0),(529485,14708,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° #',0),(529486,14708,'es','Pago #',0),(529487,14708,'de','Zahlung #',0),(529488,14708,'en','Payment #',0),(529489,14709,'is','',0),(529490,14709,'dr','ÙØ§Ú©ØªÙˆØ± Ø¯ÙˆØ±Ù‡ - 1 Ù‡ÙØªÙ‡',0),(529491,14709,'pr','ÙØ§Ú©ØªÙˆØ± Ø¯ÙˆØ±Ù‡ - 1 Ù‡ÙØªÙ‡',0),(529492,14709,'tr','Fatura hacmi - 1 hafta',0),(529493,14709,'pl','Faktura Tom - 1 tydzieÅ„',0),(529494,14709,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¾Ð±ÐµÐ¼ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(529495,14709,'ur','ØµÙˆØª - 1 ÛÙØªÛ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(529496,14709,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ðµ',0),(529497,14709,'vi','Khá»‘i lÆ°á»£ng hÃ³a Ä‘Æ¡n - 1 tuáº§n',0),(529498,14709,'af','Faktuur Volume - 1 Week',0),(529499,14709,'ro','Factura de volum - 1 sÄƒptÄƒmÃ¢nÄƒ',0),(529500,14709,'et','Arve maht - 2 nÃ¤dalat',0),(529501,14709,'si','RaÄunu obsega - 1 teden',0),(529502,14709,'ba','Faktur Volume - 1 minggu',0),(529503,14709,'nl','Factuur Volume - 1 Week',0),(529504,14709,'fi','Laskun mÃ¤Ã¤rÃ¤ - 1 viikko',0),(529505,14709,'no','Faktura volum - 1 uke',0),(529506,14709,'da','Faktura volumen - 1 uge',0),(529507,14709,'ko','ì†¡ìž¥ ë³¼ë¥¨-1 ì£¼',0),(529508,14709,'he','×—×©×‘×•× ×™×ª × ×¤×— - ×©×‘×•×¢ 1',0),(529509,14709,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„ÏŒÎ¼Î¿Ï‚ - 1 ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(529510,14709,'zh','å‘ç¥¨é‡-1 å‘¨',0),(529511,14709,'sv','Faktura volym - 1 vecka',0),(529512,14709,'it','Volume di fattura - 1 settimana',0),(529513,14709,'tl','',0),(529514,14709,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ - 1 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(529515,14709,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¤¾à¤¤à¥à¤°à¤¾ - 1 à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(529516,14709,'ms','Jumlah invois - 1 minggu',0),(529517,14709,'ar','Ø­Ø¬Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©-Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ 1',0),(529518,14709,'fr','Facture Volume - 1 semaine',0),(529519,14709,'jp','è«‹æ±‚æ›¸ã®å·» - 1 é€±',0),(529520,14709,'pt','Volume de factura - semana 1',0),(529521,14709,'ru','ÐžÐ±ÑŠÐµÐ¼ ÑÑ‡ÐµÑ‚Ð° - 1 Ð½ÐµÐ´ÐµÐ»Ñ',0),(529522,14709,'es','Volumen de factura - 1 semana',0),(529523,14709,'de','Rechnung Volume - 1 Woche',0),(529524,14709,'en','Invoice Volume - 1 Week',0),(529525,14710,'is','',0),(529526,14710,'dr','Ø¨Ø§Ù„Ø§ 10 Ù…Ø´ØªØ±ÛŒØ§Ù† - 1 Ù…Ø§Ù‡',0),(529527,14710,'pr','Ø¨Ø§Ù„Ø§ 10 Ù…Ø´ØªØ±ÛŒØ§Ù† - 1 Ù…Ø§Ù‡',0),(529528,14710,'tr','En iyi 10 mÃ¼ÅŸteriler - 1 ay',0),(529529,14710,'pl','10 najlepszych klientÃ³w - 1 miesiÄ…c',0),(529530,14710,'bg','Ð¢Ð¾Ð¿ 10 ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ - 1 Ð¼ÐµÑÐµÑ†',0),(529531,14710,'ur','1 Ù…ÛÛŒÙ†Û Ù¾ÛÙ„Û’ 10 Ú¯Ø§ÛÚ©ÙˆÚº-',0),(529532,14710,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÐºÑƒÐ¿Ð°Ñ†Ð° â€“ 1 Ð¼ÐµÑÐµÑ†',0),(529533,14710,'vi','Top 10 khÃ¡ch - 1 thÃ¡ng',0),(529534,14710,'af','Top 10 kliÃ«nte - 1 maand',0),(529535,14710,'ro','Top 10 clienÅ£ii - 1 luna',0),(529536,14710,'et','Top 10 hotelli - 1 kuu',0),(529537,14710,'si','Top 10 stranke - 1 mesec',0),(529538,14710,'ba','Top 10 pelanggan - 1 bulan',0),(529539,14710,'nl','Top 10 klanten - 1 maand',0),(529540,14710,'fi','Top 10 asiakkaat - 1 kuukausi',0),(529541,14710,'no','Topp 10 kunder - 1 mÃ¥ned',0),(529542,14710,'da','Top 10 kunder - 1 mÃ¥ned',0),(529543,14710,'ko','í†± 10 ê³ ê°-1 ê°œì›”',0),(529544,14710,'he','×”×¢×œ×™×•×Ÿ 10 ×œ×§×•×—×•×ª - 1 ×—×•×“×©',0),(529545,14710,'el','Top 10 Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ - 1 Î¼Î®Î½Î±',0),(529546,14710,'zh','åå¤§å®¢æˆ·-1 ä¸ªæœˆ',0),(529547,14710,'sv','Topp 10 kunder - 1 mÃ¥nad',0),(529548,14710,'it','10 migliori clienti - 1 mese',0),(529549,14710,'tl','',0),(529550,14710,'th','à¸¥à¸¹à¸à¸„à¹‰à¸² 10 à¸­à¸±à¸™à¸”à¸±à¸š - 1 à¹€à¸”à¸·à¸­à¸™',0),(529551,14710,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ - 1 à¤®à¤¹à¥€à¤¨à¤¾',0),(529552,14710,'ms','Top 10 pelanggan - 1 bulan',0),(529553,14710,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø£Ø¹Ù„Ù‰ 10-1 Ø§Ù„Ø´Ù‡Ø±',0),(529554,14710,'fr','Top 10 clients - 1 mois',0),(529555,14710,'jp','é¡§å®¢ãƒˆãƒƒãƒ— 10 - 1 ãƒ¶æœˆ',0),(529556,14710,'pt','Top 10 clientes - 1 mÃªs',0),(529557,14710,'ru','Ð¢Ð¾Ð¿ 10 ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² - 1 Ð¼ÐµÑÑÑ†',0),(529558,14710,'es','Top 10 clientes - 1 mes',0),(529559,14710,'de','Kunden, die Top-10 - 1 Monat',0),(529560,14710,'en','Top 10 Customers - 1 Month',0),(529561,14711,'is','',0),(529562,14711,'dr','Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¨Ø§Ù„Ø§ 10 - 1 Ø³Ø§Ù„',0),(529563,14711,'pr','Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¨Ø§Ù„Ø§ 10 - 1 Ø³Ø§Ù„',0),(529564,14711,'tr','En iyi 10 mÃ¼ÅŸteriler - 1 yÄ±l',0),(529565,14711,'pl','10 najlepszych klientÃ³w - 1 rok',0),(529566,14711,'bg','Ð¢Ð¾Ð¿ 10 ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(529567,14711,'ur','Ù¹Ø§Ù¾ 10 Ú¯Ø§ÛÚ©ÙˆÚº - 1 Ø³Ø§Ù„',0),(529568,14711,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÐºÑƒÐ¿Ð°Ñ†Ð° â€“ 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(529569,14711,'vi','Top 10 khÃ¡ch â€“ 1 nÄƒm',0),(529570,14711,'af','Top 10 kliÃ«nte - 1 jaar',0),(529571,14711,'ro','Top 10 clienÅ£ii - 1 an',0),(529572,14711,'et','Top 10 hotelli - 1 aasta',0),(529573,14711,'si','Top 10 stranke - 1 leto',0),(529574,14711,'ba','Top 10 pelanggan - 1 tahun',0),(529575,14711,'nl','Top 10 klanten - 1 jaar',0),(529576,14711,'fi','Top 10 asiakkaat - 1 vuosi',0),(529577,14711,'no','Topp 10 kunder - 1 Ã¥r',0),(529578,14711,'da','Top 10 kunder - 1 Ã¥r',0),(529579,14711,'ko','í†± 10 ê³ ê°-1 ë…„',0),(529580,14711,'he','×”×¢×œ×™×•×Ÿ 10 ×œ×§×•×—×•×ª - 1 ×©× ×”',0),(529581,14711,'el','Top 10 Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ - 1 Î­Ï„Î¿Ï‚',0),(529582,14711,'zh','åå¤§å®¢æˆ·-1 å¹´',0),(529583,14711,'sv','Topp 10 kunder - 1 Ã¥r',0),(529584,14711,'it','10 migliori clienti - 1 anno',0),(529585,14711,'tl','',0),(529586,14711,'th','à¸¥à¸¹à¸à¸„à¹‰à¸² 10 à¸­à¸±à¸™à¸”à¸±à¸š - 1 à¸›à¸µ',0),(529587,14711,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ - 1 à¤¸à¤¾à¤²',0),(529588,14711,'ms','Top 10 pelanggan - 1 tahun',0),(529589,14711,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¹Ù…Ù„Ø§Ø¡-Ø³Ù†Ø© 1',0),(529590,14711,'fr','Top 10 clients - 1 an',0),(529591,14711,'jp','é¡§å®¢ãƒˆãƒƒãƒ— 10 - 1 å¹´',0),(529592,14711,'pt','Top 10 clientes - 1 ano',0),(529593,14711,'ru','Ð¢Ð¾Ð¿ 10 ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² - 1 Ð³Ð¾Ð´',0),(529594,14711,'es','Top 10 clientes - 1 aÃ±o',0),(529595,14711,'de','Kunden, die Top-10 - 1 Jahr',0),(529596,14711,'en','Top 10 Customers - 1 Year',0),(529597,14712,'is','',0),(529598,14712,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¢ÛŒØ¯ØŒ ÛŒØ§ Ø¨ÛŒØ´ Ø§Ø² Ù…ÙˆØ¹Ø¯ ØªØ§Ø±ÛŒØ®',0),(529599,14712,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¢ÛŒØ¯ØŒ ÛŒØ§ Ø¨ÛŒØ´ Ø§Ø² Ù…ÙˆØ¹Ø¯ ØªØ§Ø±ÛŒØ®',0),(529600,14712,'tr','Faturalar yaklaÅŸÄ±yor ya da vade tarihi',0),(529601,14712,'pl','Faktury zbliÅ¼a lub w odpowiednim terminie',0),(529602,14712,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¿Ñ€ÐµÐ´ Ð¸Ð»Ð¸ Ð½Ð°Ð´ Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(529603,14712,'ur','ØªÙ‚Ø±ÛŒØ¨Ø§ Ú©Û’ Ù‚Ø±ÛŒØ¨ ØªÚ¾ÛŒ ÛŒØ§ Ø§Ù†Ú©Ù… Ù…Ù‚Ø±Ø±Û ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(529604,14712,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµ ÑÐµ Ð±Ð»Ð¸Ð¶Ð¸ Ð¸Ð»Ð¸ Ð³Ð¾Ñ‚Ð¾Ð²Ð¾ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(529605,14712,'vi','HÃ³a Ä‘Æ¡n gáº§n trá»Ÿ lÃªn do ngÃ y',0),(529606,14712,'af','Fakturering nader of oor verskuldigde datum',0),(529607,14712,'ro','Facturi apropie sau peste datoritÄƒ data',0),(529608,14712,'et','Arveldab peaaegu vÃµi rohkem Due Date',0),(529609,14712,'si','RaÄune pribliÅ¾uje ali nad obveznim datumom',0),(529610,14712,'ba','Faktur mendekati atau lebih karena tanggal',0),(529611,14712,'nl','Facturen kort of Over Due datum',0),(529612,14712,'fi','Laskut loppusuoralla tai yli asianmukaisesti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(529613,14712,'no','Fakturaer nÃ¦rmer seg eller Over grunn dato',0),(529614,14712,'da','Fakturaer nÃ¦rmer eller Over Due dato',0),(529615,14712,'ko','ê·¼ì ‘ ë˜ëŠ” ì´ìƒ ì¸í•´ ì†¡ìž¥ ë‚ ì§œ',0),(529616,14712,'he','×—×©×‘×•× ×™×•×ª ×•×”×ž×’×¨×© ××• ×ž×¢×œ ×™×¢×“ ×ª××¨×™×š',0),(529617,14712,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î»Î·ÏƒÎ¹Î¬Î¶ÎµÎ¹ Î® Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(529618,14712,'zh','å‘ç¥¨å·²æŽ¥è¿‘æˆ–è¶…è¿‡åˆ°æœŸæ—¥æœŸ',0),(529619,14712,'sv','Fakturor Nearing eller Ã¶ver Due Date',0),(529620,14712,'it','Fatture avvicinandosi o eccedenza dovuta data',0),(529621,14712,'tl','',0),(529622,14712,'th','à¸Šà¸£à¸² à¸«à¸£à¸·à¸­à¹€à¸à¸´à¸™à¸à¸³à¸«à¸™à¸”à¸Šà¸³à¸£à¸°à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸§à¸±à¸™',0),(529623,14712,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¹à¥‹à¤¨à¥‡ à¤µà¤¾à¤²à¤¾ à¤¯à¤¾ à¤…à¤§à¤¿à¤• à¤¸à¥‡ à¤¨à¤¿à¤¯à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(529624,14712,'ms','Disebabkan hampir atau ke atas invois tarikh',0),(529625,14712,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ÙˆØ§Ø¬Ø¨Ø© Ø¹Ù„Ù‰ ÙˆØ´Ùƒ Ø£Ùˆ Ø¹Ù„Ù‰ Ù…Ø¯Ù‰ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(529626,14712,'fr','Factures presque ou plu Due Date',0),(529627,14712,'jp','é–“è¿‘ä»¥ä¸Šã®ãŸã‚ã®è«‹æ±‚æ›¸ã®æ—¥ä»˜',0),(529628,14712,'pt','Faturas devido prestes ou sobre data',0),(529629,14712,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð±Ð»Ð¸Ð·Ð¸Ñ‚ÑÑ Ð¸Ð»Ð¸ ÑÐ²ÐµÑ€Ñ… Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾ Ð”Ð°Ñ‚Ð°',0),(529630,14712,'es','Facturas debido a punto o sobre fecha',0),(529631,14712,'de','Rechnungen kurz vor oder Ã¼ber Due Date',0),(529632,14712,'en','Invoices Nearing Or Over Due Date',0),(529633,14713,'is','',0),(529634,14713,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø§Ø®ÛŒØ± - 1 Ù‡ÙØªÙ‡',0),(529635,14713,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø§Ø®ÛŒØ± - 1 Ù‡ÙØªÙ‡',0),(529636,14713,'tr','Son Ã¶demeler - 1 hafta',0),(529637,14713,'pl','Ostatnie pÅ‚atnoÅ›ci - 1 tydzieÅ„',0),(529638,14713,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(529639,14713,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ - 1 ÛÙØªÛ',0),(529640,14713,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ðµ',0),(529641,14713,'vi','Thanh toÃ¡n táº¡i - 1 tuáº§n',0),(529642,14713,'af','Onlangse betalings - 1 Week',0),(529643,14713,'ro','PlÄƒÅ£i recente - 1 sÄƒptÄƒmÃ¢nÄƒ',0),(529644,14713,'et','Tehtud maksed - 1 nÃ¤dal',0),(529645,14713,'si','Nedavni plaÄila - 1 teden',0),(529646,14713,'ba','Pembayaran hari - 1 minggu',0),(529647,14713,'nl','Recente betalingen - 1 Week',0),(529648,14713,'fi','Hotelliin maksut - 1 viikko',0),(529649,14713,'no','Nylige betalinger - 1 uke',0),(529650,14713,'da','Seneste betalinger - 1 uge',0),(529651,14713,'ko','ìµœê·¼ ì§€ê¸‰-1 ì£¼',0),(529652,14713,'he','×ª×©×œ×•×ž×™× ××—×¨×•× ×™× - ×©×‘×•×¢ 1',0),(529653,14713,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ - 1 ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(529654,14713,'zh','æœ€è¿‘ä»˜æ¬¾-1 å‘¨',0),(529655,14713,'sv','Senaste betalningar - 1 vecka',0),(529656,14713,'it','Pagamenti recenti - 1 settimana',0),(529657,14713,'tl','',0),(529658,14713,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸¥à¹ˆà¸²à¸ªà¸¸à¸” - 1 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(529659,14713,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤­à¥à¤—à¤¤à¤¾à¤¨ - 1 à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(529660,14713,'ms','Pembayaran hari - 1 minggu',0),(529661,14713,'ar','Ø§Ù„Ø¯ÙØ¹Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø©-Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ 1',0),(529662,14713,'fr','Paiements rÃ©cents - 1 semaine',0),(529663,14713,'jp','æœ€è¿‘ã®ãŠæ”¯æ‰•ã„ - 1 é€±',0),(529664,14713,'pt','Pagamentos recentes - semana 1',0),(529665,14713,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¸Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ - 1 Ð½ÐµÐ´ÐµÐ»Ñ',0),(529666,14713,'es','Pagos recientes - 1 semana',0),(529667,14713,'de','Den letzten Zahlungen - 1 Woche',0),(529668,14713,'en','Recent Payments - 1 Week',0),(529669,14714,'is','',0),(529670,14714,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø±Ø³ÛŒØ¯ Ø¨Ø¯ÙˆÙ† ØµÙ†Ø¯ÙˆÙ‚ - 1 Ù…Ø§Ù‡',0),(529671,14714,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø±Ø³ÛŒØ¯ Ø¨Ø¯ÙˆÙ† ØµÙ†Ø¯ÙˆÙ‚ - 1 Ù…Ø§Ù‡',0),(529672,14714,'tr','Stok giriÅŸlerini PO - 1 ay olmadan',0),(529673,14714,'pl','PrzyjÄ™Ä‡ magazynowych bez PO - 1 miesiÄ…c',0),(529674,14714,'bg','ÐžÐ¿Ð¸Ñ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð±ÐµÐ· PO - 1 Ð¼ÐµÑÐµÑ†',0),(529675,14714,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº Ù¾ÙˆØ³Ù¹ - 1 Ù…ÛÛŒÙ†Û’ Ú©Û’ Ø¨ØºÛŒØ±',0),(529676,14714,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ Ð±ÐµÐ· ÐŸÐž - 1 Ð¼ÐµÑÐµÑ†',0),(529677,14714,'vi','HÃ ng tá»“n kho hÃ³a Ä‘Æ¡n mÃ  khÃ´ng cÃ³ PO - 1 thÃ¡ng',0),(529678,14714,'af','Voorraad ontvangste sonder PO - 1 maand',0),(529679,14714,'ro','Inventarul Ã®ncasÄƒri fara PO - 1 luna',0),(529680,14714,'et','Lao sissetulekute ilma PO - 1 kuu',0),(529681,14714,'si','Zaloge prejemki brez PO - 1 mesec',0),(529682,14714,'ba','Persediaan penerimaan tanpa PO - 1 bulan',0),(529683,14714,'nl','Inventaris ontvangsten zonder PO - 1 maand',0),(529684,14714,'fi','Varastovastaanottojen ilman PO - 1 kuukausi',0),(529685,14714,'no','Lagermottak uten PO - 1 mÃ¥ned',0),(529686,14714,'da','Lagertilgange uden PO - 1 mÃ¥ned',0),(529687,14714,'ko','í¬-1 ê°œì›” ì—†ì´ ìž¬ê³  ì˜ìˆ˜ì¦',0),(529688,14714,'he','×ž×œ××™ ×§×‘×œ×•×ª ×ž×‘×œ×™ ×¤×• - 1 ×—×•×“×©',0),(529689,14714,'el','Î Î±ÏÎ±Î»Î±Î²Î­Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Ï‡Ï‰ÏÎ¯Ï‚ PO - 1 Î¼Î®Î½Î±',0),(529690,14714,'zh','æ²¡æœ‰å®-1 ä¸ªæœˆçš„åº“å­˜æ”¶è´§',0),(529691,14714,'sv','Lagerinleveranser utan PO - 1 mÃ¥nad',0),(529692,14714,'it','Inventario ricevute senza PO - 1 mese',0),(529693,14714,'tl','',0),(529694,14714,'th','à¸à¸²à¸£à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡ à¹‚à¸”à¸¢ PO - 1 à¹€à¸”à¸·à¸­à¸™',0),(529695,14714,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤°à¤¸à¥€à¤¦à¥‡à¤‚ à¤ªà¥‹ - 1 à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾',0),(529696,14714,'ms','Inventori resit tanpa PO - 1 bulan',0),(529697,14714,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¯ÙˆÙ† Ø¨Ùˆ-Ø´Ù‡Ø± 1',0),(529698,14714,'fr','RÃ©ceptions de stock sans PO - 1 mois',0),(529699,14714,'jp','åœ¨åº«å…¥åº« PO - 1 ãƒ¶æœˆãªã—',0),(529700,14714,'pt','Recibos de inventÃ¡rio sem PO - 1 mÃªs',0),(529701,14714,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð±ÐµÐ· PO - 1 Ð¼ÐµÑÑÑ†',0),(529702,14714,'es','Inventario recibos sin PO - 1 mes',0),(529703,14714,'de','Inventar Quittungen ohne PO - 1 Monat',0),(529704,14714,'en','Inventory Receipts Without PO - 1 Month',0),(529705,14715,'is','',0),(529706,14715,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø±Ø³ÛŒØ¯ Ø¨Ø§ Ù¾Ùˆ - 1 Ù…Ø§Ù‡',0),(529707,14715,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø±Ø³ÛŒØ¯ Ø¨Ø§ Ù¾Ùˆ - 1 Ù…Ø§Ù‡',0),(529708,14715,'tr','Stok giriÅŸleri ile PO - 1 ay',0),(529709,14715,'pl','Spis wpÅ‚ywy z PO - 1 miesiÄ…c',0),(529710,14715,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð·Ð° ÑÐºÐ»Ð°Ð´ Ñ PO - 1 Ð¼ÐµÑÐµÑ†',0),(529711,14715,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº Ù¾ÙˆØ³Ù¹ - 1 Ù…ÛÛŒÙ†Û’ Ú©Û’ Ø³Ø§ØªÚ¾',0),(529712,14715,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ ÑÐ° Ð¿Ð¾-Ð¾Ð¼ - 1 Ð¼ÐµÑÐµÑ†',0),(529713,14715,'vi','HÃ ng tá»“n kho hÃ³a Ä‘Æ¡n vá»›i PO - 1 thÃ¡ng',0),(529714,14715,'af','Voorraad ontvangste met PO - 1 maand',0),(529715,14715,'ro','ÃŽncasÄƒrile inventarierea cu PO - 1 luna',0),(529716,14715,'et','Lao sissetulekute PO - 1 kuu',0),(529717,14715,'si','Zaloge potrdila z PO - 1 mesec',0),(529718,14715,'ba','Persediaan kuitansi dengan PO - 1 bulan',0),(529719,14715,'nl','Inventaris ontvangsten met PO - 1 maand',0),(529720,14715,'fi','Varastovastaanottojen PO - 1 kuukausi',0),(529721,14715,'no','Lagermottak med PO - 1 mÃ¥ned',0),(529722,14715,'da','Lagertilgange med PO - 1 mÃ¥ned',0),(529723,14715,'ko','í¬-1 ê°œì›” ëœ ìž¬ê³  ì˜ìˆ˜ì¦',0),(529724,14715,'he','×ž×œ××™ ×§×‘×œ×•×ª ×¢× ×¤×• - 1 ×—×•×“×©',0),(529725,14715,'el','Î Î±ÏÎ±Î»Î±Î²Î­Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î¼Îµ PO - 1 Î¼Î®Î½Î±',0),(529726,14715,'zh','ä¸Žå®-1 ä¸ªæœˆçš„åº“å­˜æ”¶è´§',0),(529727,14715,'sv','Lagerinleveranser med PO - 1 mÃ¥nad',0),(529728,14715,'it','Inventario ricevute con PO - 1 mese',0),(529729,14715,'tl','',0),(529730,14715,'th','à¸à¸²à¸£à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸à¸±à¸š PO - 1 à¹€à¸”à¸·à¸­à¸™',0),(529731,14715,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤°à¤¸à¥€à¤¦à¥‡à¤‚ à¤ªà¥‹ - 1 à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(529732,14715,'ms','Inventori resit dengan PO - 1 bulan',0),(529733,14715,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù…Ø¹ Ø¨Ùˆ-Ø´Ù‡Ø± 1',0),(529734,14715,'fr','RÃ©ceptions de stock avec PO - 1 mois',0),(529735,14715,'jp','åœ¨åº«å…¥åº« PO - 1 ãƒ¶æœˆã§',0),(529736,14715,'pt','Recibos de inventÃ¡rio com PO - 1 mÃªs',0),(529737,14715,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ñ PO - 1 Ð¼ÐµÑÑÑ†',0),(529738,14715,'es','Recibos de inventario con PO - 1 mes',0),(529739,14715,'de','Inventar-Einnahmen mit PO - 1 Monat',0),(529740,14715,'en','Inventory Receipts With PO - 1 Month',0),(529741,14716,'is','',0),(529742,14716,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¯Ø³ØªÙ‡ - 1 Ù…Ø§Ù‡',0),(529743,14716,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¯Ø³ØªÙ‡ - 1 Ù…Ø§Ù‡',0),(529744,14716,'tr','Kategori - 1 ay gÃ¶re stok kullanÄ±mÄ±',0),(529745,14716,'pl','ZuÅ¼ycie zapasÃ³w w kategorii - 1 miesiÄ…c',0),(529746,14716,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°ÐµÐ¼Ð¾ÑÑ‚ Ð½Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ - 1 Ð¼ÐµÑÐµÑ†',0),(529747,14716,'ur','Ø²Ù…Ø±Û: 1 Ù…Ø§Û Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(529748,14716,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸ - 1 Ð¼ÐµÑÐµÑ†',0),(529749,14716,'vi','Sá»­ dá»¥ng hÃ ng tá»“n kho theo thá»ƒ loáº¡i - 1 thÃ¡ng',0),(529750,14716,'af','Voorraad gebruik deur kategorie - 1 maand',0),(529751,14716,'ro','Stocuri de utilizare de categoria - 1 luna',0),(529752,14716,'et','Varude kasutamine kategooria - 1 kuu',0),(529753,14716,'si','Zaloge navada po kategorijah - 1 mesec',0),(529754,14716,'ba','Penggunaan persediaan berdasarkan Kategori - 1 bulan',0),(529755,14716,'nl','Inventaris gebruik per categorie - 1 maand',0),(529756,14716,'fi','Sivustovaraston kÃ¤yttÃ¶ Kategoria - 1 kuukausi',0),(529757,14716,'no','Lager bruk av Kategori - 1 mÃ¥ned',0),(529758,14716,'da','Lageret brug af kategori - 1 mÃ¥ned',0),(529759,14716,'ko','ì¹´í…Œê³ ë¦¬-1 ê°œì›” ìž¬ê³  ì‚¬ìš©',0),(529760,14716,'he','×”×©×™×ž×•×© ×”×ž×œ××™ ×œ×¤×™ ×§×˜×’×•×¨×™×” - 1 ×—×•×“×©',0),(529761,14716,'el','Î§ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î±Î½Î¬ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± - 1 Î¼Î®Î½Î±',0),(529762,14716,'zh','æŒ‰ç±»åˆ«-1 ä¸ªæœˆçš„åº“å­˜ä½¿ç”¨çŽ‡',0),(529763,14716,'sv','Inventering anvÃ¤ndning av kategori - 1 mÃ¥nad',0),(529764,14716,'it','Utilizzo di inventario di categoria - 1 mese',0),(529765,14716,'tl','',0),(529766,14716,'th','à¸à¸²à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸— - 1 à¹€à¸”à¸·à¸­à¸™',0),(529767,14716,'hi','à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤‰à¤ªà¤¯à¥‹à¤— à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¶à¥à¤°à¥‡à¤£à¥€ - 1 à¤®à¤¹à¥€à¤¨à¤¾',0),(529768,14716,'ms','Penggunaan inventori mengikut Kategori - 1 bulan',0),(529769,14716,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø­Ø³Ø¨ Ø§Ù„ÙØ¦Ø©-Ø´Ù‡Ø± 1',0),(529770,14716,'fr','Utilisation de l\'inventaire par catÃ©gorie - 1 mois',0),(529771,14716,'jp','ã‚«ãƒ†ã‚´ãƒªåˆ¥ - 1 ãƒ¶æœˆã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®åˆ©ç”¨çŠ¶æ³',0),(529772,14716,'pt','Uso de estoque por categoria - 1 mÃªs',0),(529773,14716,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÐ¼ - 1 Ð¼ÐµÑÑÑ†',0),(529774,14716,'es','Uso del inventario por categorÃ­a - 1 mes',0),(529775,14716,'de','Inventar-Nutzung durch Kategorie - 1 Monat',0),(529776,14716,'en','Inventory Usage By Category - 1 Month',0),(529777,14717,'is','',0),(529778,14717,'dr','Ø§Ù‚Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¬Ø¯ÛŒØ¯ - 1 Ù…Ø§Ù‡',0),(529779,14717,'pr','Ø§Ù‚Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¬Ø¯ÛŒØ¯ - 1 Ù…Ø§Ù‡',0),(529780,14717,'tr','Yeni stok maddeleri - 1 ay',0),(529781,14717,'pl','Nowych zapasÃ³w - 1 miesiÄ…c',0),(529782,14717,'bg','ÐÐ¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´ - 1 Ð¼ÐµÑÐµÑ†',0),(529783,14717,'ur','Ù†Ø¦ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡ - 1 Ù…ÛÛŒÙ†Û’',0),(529784,14717,'sr','ÐÐ¾Ð²Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° - 1 Ð¼ÐµÑÐµÑ†',0),(529785,14717,'vi','Má»›i tháº­p váº­t tÆ°-1 thÃ¡ng',0),(529786,14717,'af','Nuwe voorraad Items - 1 maand',0),(529787,14717,'ro','Noi obiecte de inventar - 1 luna',0),(529788,14717,'et','Uus laokaupade - 1 kuu',0),(529789,14717,'si','Nove elemente zaloge - 1 mesec',0),(529790,14717,'ba','Baru persediaan barang - 1 bulan',0),(529791,14717,'nl','Nieuwe voorraadartikelen - 1 maand',0),(529792,14717,'fi','Varaston uutuuksia - 1 kuukausi',0),(529793,14717,'no','Nye lagervarer - 1 mÃ¥ned',0),(529794,14717,'da','Nye varer - 1 mÃ¥ned',0),(529795,14717,'ko','ìƒˆë¡œìš´ ì¸ë²¤í† ë¦¬ ì•„ì´í…œ-1 ê°œì›”',0),(529796,14717,'he','×ž×œ××™ ×¤×¨×™×˜×™× ×—×“×©×™× - 1 ×—×•×“×©',0),(529797,14717,'el','ÎÎ­Î± ÎµÎ¯Î´Î· Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ - 1 Î¼Î®Î½Î±',0),(529798,14717,'zh','æ–°çš„åº“å­˜ç‰©æ–™-1 ä¸ªæœˆ',0),(529799,14717,'sv','Nya lagerartiklar - 1 mÃ¥nad',0),(529800,14717,'it','Nuovi articoli di magazzino - 1 mese',0),(529801,14717,'tl','',0),(529802,14717,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¹ƒà¸«à¸¡à¹ˆ - 1 à¹€à¸”à¸·à¸­à¸™',0),(529803,14717,'hi','à¤¨à¤ˆ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® - 1 à¤®à¤¹à¥€à¤¨à¤¾',0),(529804,14717,'ms','Item inventori baru - 1 bulan',0),(529805,14717,'ar','Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø¬Ø¯ÙŠØ¯-Ø´Ù‡Ø± 1',0),(529806,14717,'fr','Nouveaux articles en stock - 1 mois',0),(529807,14717,'jp','æ–°ã—ã„åœ¨åº«ã‚¢ã‚¤ãƒ†ãƒ  - 1 ãƒ¶æœˆ',0),(529808,14717,'pt','Novos itens do inventÃ¡rio - 1 mÃªs',0),(529809,14717,'ru','ÐÐ¾Ð²Ð°Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð½Ð¾ - 1 Ð¼ÐµÑÑÑ†',0),(529810,14717,'es','Nuevos artÃ­culos de inventario - 1 mes',0),(529811,14717,'de','Neue Lagerartikel - 1 Monat',0),(529812,14717,'en','New Inventory Items - 1 Month',0),(529813,14718,'is','',0),(529814,14718,'dr','ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ø®ÛŒØ± - 1 Ù…Ø§Ù‡',0),(529815,14718,'pr','ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ø®ÛŒØ± - 1 Ù…Ø§Ù‡',0),(529816,14718,'tr','Son stok ayarlamalarÄ± - 1 ay',0),(529817,14718,'pl','Ostatnie korekty magazynu - 1 miesiÄ…c',0),(529818,14718,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð° - 1 Ð¼ÐµÑÐµÑ†',0),(529819,14718,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ - 1 Ù…ÛÛŒÙ†Û’',0),(529820,14718,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° - 1 Ð¼ÐµÑÐµÑ†',0),(529821,14718,'vi','Äiá»u chá»‰nh gáº§n Ä‘Ã¢y hÃ ng tá»“n kho - 1 thÃ¡ng',0),(529822,14718,'af','Onlangse voorraad aanpassings - 1 maand',0),(529823,14718,'ro','Recente ajustÄƒrile de stocuri - 1 luna',0),(529824,14718,'et','Tehtud varude tÃ¤psustused - 1 kuu',0),(529825,14718,'si','Zadnje popravke zaloge - 1 mesec',0),(529826,14718,'ba','Hari persediaan penyesuaian - 1 bulan',0),(529827,14718,'nl','Recente voorraadherwaarderingen - 1 maand',0),(529828,14718,'fi','Hotelliin varastomuutokset - 1 kuukausi',0),(529829,14718,'no','Siste lagerjusteringer - 1 mÃ¥ned',0),(529830,14718,'da','Seneste lagerreguleringer - 1 mÃ¥ned',0),(529831,14718,'ko','ìµœê·¼ ìž¬ê³  ì¡°ì •-1 ê°œì›”',0),(529832,14718,'he','×”×ª××ž×•×ª ×ž×œ××™ ×”××—×¨×•× ×™× - 1 ×—×•×“×©',0),(529833,14718,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ - 1 Î¼Î®Î½Î±',0),(529834,14718,'zh','è¿‘æœŸçš„åº“å­˜è°ƒæ•´-1 ä¸ªæœˆ',0),(529835,14718,'sv','Senaste lagerjusteringar - 1 mÃ¥nad',0),(529836,14718,'it','Recenti rettifiche di magazzino - 1 mese',0),(529837,14718,'tl','',0),(529838,14718,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸¥à¹ˆà¸²à¸ªà¸¸à¸” - 1 à¹€à¸”à¸·à¸­à¸™',0),(529839,14718,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ - 1 à¤®à¤¹à¥€à¤¨à¤¾',0),(529840,14718,'ms','Hari inventori pelarasan - 1 bulan',0),(529841,14718,'ar','Ø§Ù„Ø£Ø®ÙŠØ±Ø© ØªØ¹Ø¯ÙŠÙ„Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ†-Ø´Ù‡Ø± 1',0),(529842,14718,'fr','Redressements de l\'inventaire rÃ©cent - 1 mois',0),(529843,14718,'jp','æœ€è¿‘åœ¨åº«èª¿æ•´ - 1 ãƒ¶æœˆ',0),(529844,14718,'pt','Ajustes de inventÃ¡rio recente - 1 mÃªs',0),(529845,14718,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ - 1 Ð¼ÐµÑÑÑ†',0),(529846,14718,'es','Ajustes de inventario reciente - 1 mes',0),(529847,14718,'de','Den letzten Lagerregulierungen - 1 Monat',0),(529848,14718,'en','Recent Inventory Adjustments - 1 Month',0),(529849,14719,'is','',0),(529850,14719,'dr','Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§Ù„Ø§ 10 - 1 Ù…Ø§Ù‡',0),(529851,14719,'pr','Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§Ù„Ø§ 10 - 1 Ù…Ø§Ù‡',0),(529852,14719,'tr','Ä°lk 10 Ã¶ÄŸe - 1 ay',0),(529853,14719,'pl','10 najlepszych elementÃ³w - 1 miesiÄ…c',0),(529854,14719,'bg','Ð¢Ð¾Ð¿ 10 ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ - 1 Ð¼ÐµÑÐµÑ†',0),(529855,14719,'ur','1 Ù…ÛÛŒÙ†Û Ù¾ÛÙ„Û’ 10 Ø§Ø´ÛŒØ§Ø¡-',0),(529856,14719,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÑÑ‚Ð°Ð²ÐºÐ¸ - 1 Ð¼ÐµÑÐµÑ†',0),(529857,14719,'vi','Top 10 bÃ i - 1 thÃ¡ng',0),(529858,14719,'af','Top 10 Items - 1 maand',0),(529859,14719,'ro','Top 10 articole - 1 luna',0),(529860,14719,'et','Top 10 kÃ¼simust - 1 kuu',0),(529861,14719,'si','Top 10 elementov â€“ 1 mesec',0),(529862,14719,'ba','Top 10 Items - 1 bulan',0),(529863,14719,'nl','Top 10 Items - 1 maand',0),(529864,14719,'fi','Top 10 kohteet - 1 kuukausi',0),(529865,14719,'no','Topp 10 elementer - 1 mÃ¥ned',0),(529866,14719,'da','Top 10 varer - 1 mÃ¥ned',0),(529867,14719,'ko','ìƒìœ„ 10 ê°œ í•­ëª©-1 ê°œì›”',0),(529868,14719,'he','×”×¢×œ×™×•×Ÿ 10 ×¤×¨×™×˜×™× - 1 ×—×•×“×©',0),(529869,14719,'el','ÎšÎ¿ÏÏ…Ï†Î® 10 - 1 Î¼Î®Î½Î±',0),(529870,14719,'zh','åå¤§é¡¹ç›®-1 ä¸ªæœˆ',0),(529871,14719,'sv','Topp 10 objekt - 1 mÃ¥nad',0),(529872,14719,'it','Top 10 articoli - 1 mese',0),(529873,14719,'tl','',0),(529874,14719,'th','à¸ªà¸´à¸™à¸„à¹‰à¸² 10 à¸­à¸±à¸™à¸”à¸±à¸šà¹à¸£à¸ - 1 à¹€à¸”à¸·à¸­à¸™',0),(529875,14719,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤†à¤‡à¤Ÿà¤®à¥à¤¸ - 1 à¤®à¤¹à¥€à¤¨à¤¾',0),(529876,14719,'ms','Top 10 item - 1 bulan',0),(529877,14719,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø£ØµÙ†Ø§Ù-Ø´Ù‡Ø± 1',0),(529878,14719,'fr','Top 10 Articles - 1 mois',0),(529879,14719,'jp','ä¸Šä½ 10 é …ç›® - 1 ãƒ¶æœˆ',0),(529880,14719,'pt','Top 10 itens - 1 mÃªs',0),(529881,14719,'ru','Ð¢Ð¾Ð¿-10 ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² - 1 Ð¼ÐµÑÑÑ†',0),(529882,14719,'es','10 mejores artÃ­culos - 1 mes',0),(529883,14719,'de','Top 10 Artikel - 1 Monat',0),(529884,14719,'en','Top 10 Items - 1 Month',0),(529885,14720,'is','',0),(529886,14720,'dr','Ø¨Ø§Ù„Ø§ 10 Ø³ÙˆØ¯ Ù…ÙˆØ±Ø¯ - 1 Ù…Ø§Ù‡',0),(529887,14720,'pr','Ø¨Ø§Ù„Ø§ 10 Ø³ÙˆØ¯ Ù…ÙˆØ±Ø¯ - 1 Ù…Ø§Ù‡',0),(529888,14720,'tr','En iyi 10 Ã¶ÄŸeler - 1 ay kar.',0),(529889,14720,'pl','Top 10 pozycji zysku - 1 miesiÄ…c',0),(529890,14720,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ - 1 Ð¼ÐµÑÐµÑ†',0),(529891,14720,'ur','Ø§ÙˆÙ¾Ø± 10 Ù…Ù†Ø§ÙØ¹ Ø§Ø´ÛŒØ§Ø¡ - 1 Ù…ÛÛŒÙ†Û’',0),(529892,14720,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð¸Ñ€Ð°Ñ˜Ñƒ ÑÑ‚Ð°Ð²ÐºÐ¸ - 1 Ð¼ÐµÑÐµÑ†',0),(529893,14720,'vi','Top 10 lá»£i nhuáº­n bÃ i - 1 thÃ¡ng',0),(529894,14720,'af','Top 10 wins Items - 1 maand',0),(529895,14720,'ro','Top 10 articole de Profit - 1 luna',0),(529896,14720,'et','Top 10 kasumi eseme - 1 kuu',0),(529897,14720,'si','Top 10 dobiÄek predmetov - 1 mesec',0),(529898,14720,'ba','Atas 10 keuntungan Items - 1 bulan',0),(529899,14720,'nl','Top 10 winst Items - 1 maand',0),(529900,14720,'fi','Top 10 voittoa erÃ¤t - 1 kuukausi',0),(529901,14720,'no','Topp 10 overskudd elementer - 1 mÃ¥ned',0),(529902,14720,'da','Top 10 overskud varer - 1 mÃ¥ned',0),(529903,14720,'ko','í†± 10 ì´ìµ í•­ëª©-1 ê°œì›”',0),(529904,14720,'he','Top 10 ×¤×¨×™×˜×™× ×¨×•×•×— - 1 ×—×•×“×©',0),(529905,14720,'el','ÎšÎ¿ÏÏ…Ï†Î® 10 ÎºÎ­ÏÎ´Î¿Ï‚ - 1 Î¼Î®Î½Î±',0),(529906,14720,'zh','é¡¶éƒ¨ 10 åˆ©æ¶¦é¡¹ç›®-1 ä¸ªæœˆ',0),(529907,14720,'sv','Topp 10 resultat objekt - 1 mÃ¥nad',0),(529908,14720,'it','Top 10 articoli di profitto - 1 mese',0),(529909,14720,'tl','',0),(529910,14720,'th','à¹‚à¸£à¸‡à¹à¸£à¸¡à¸¢à¸­à¸”à¸™à¸´à¸¢à¸¡à¹ƒà¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸à¸³à¹„à¸£ 10 - 1 à¹€à¸”à¸·à¸­à¸™',0),(529911,14720,'hi','à¤šà¥‹à¤Ÿà¥€ à¤•à¥‡ 10 à¤²à¤¾à¤­ à¤µà¤¸à¥à¤¤à¥à¤“à¤‚ - 1 à¤®à¤¹à¥€à¤¨à¤¾',0),(529912,14720,'ms','Top 10 keuntungan item - 1 bulan',0),(529913,14720,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¨Ù†ÙˆØ¯ Ø§Ù„Ø£Ø±Ø¨Ø§Ø­-Ø´Ù‡Ø± 1',0),(529914,14720,'fr','Top 10 Articles de Profit - 1 mois',0),(529915,14720,'jp','ãƒˆãƒƒãƒ— 10 åˆ©ç›Šé …ç›® - 1 ãƒ¶æœˆ',0),(529916,14720,'pt','Top 10 itens de lucro - 1 mÃªs',0),(529917,14720,'ru','Ð¢Ð¾Ð¿ 10 Ð¿ÑƒÐ½ÐºÑ‚Ð¾Ð² Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸ - 1 Ð¼ÐµÑÑÑ†',0),(529918,14720,'es','Top 10 artÃ­culos de beneficio - 1 mes',0),(529919,14720,'de','Top 10 Ergebnis Elemente - 1 Monat',0),(529920,14720,'en','Top 10 Profit Items - 1 Month',0),(529921,14721,'is','',0),(529922,14721,'dr','ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ø®ÛŒØ± - 30 Ø±ÙˆØ²',0),(529923,14721,'pr','ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ø®ÛŒØ± - 30 Ø±ÙˆØ²',0),(529924,14721,'tr','Son stok ayarlamalarÄ± - 30 gÃ¼n',0),(529925,14721,'pl','Ostatnie korekty magazynu - 30 dni',0),(529926,14721,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð° - 30 Ð´Ð½Ð¸',0),(529927,14721,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ - 30 Ø¯Ù†',0),(529928,14721,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° - 30 Ð´Ð°Ð½Ð°',0),(529929,14721,'vi','Äiá»u chá»‰nh gáº§n Ä‘Ã¢y hÃ ng tá»“n kho - 30 ngÃ y',0),(529930,14721,'af','Onlangse voorraad aanpassings - 30 dae',0),(529931,14721,'ro','Recente ajustÄƒrile de stocuri - 30 de zile',0),(529932,14721,'et','Tehtud varude tÃ¤psustused - 30 pÃ¤eva',0),(529933,14721,'si','Zadnje popravke zaloge - 30 dni',0),(529934,14721,'ba','Hari persediaan penyesuaian - 30 hari',0),(529935,14721,'nl','Recente voorraadherwaarderingen - 30 dagen',0),(529936,14721,'fi','Hotelliin varastomuutokset - 30 pÃ¤ivÃ¤Ã¤',0),(529937,14721,'no','Siste lagerjusteringer - 30 dager',0),(529938,14721,'da','Seneste lagerreguleringer - 30 dage',0),(529939,14721,'ko','ìµœê·¼ ìž¬ê³  ì¡°ì •-30 ì¼',0),(529940,14721,'he','×”×ª××ž×•×ª ×ž×œ××™ ×”××—×¨×•× ×•×ª - 30 ×™×ž×™×',0),(529941,14721,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î­Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ - 30 Î·Î¼Î­ÏÎµÏ‚',0),(529942,14721,'zh','è¿‘æœŸçš„åº“å­˜è°ƒæ•´-30 å¤©',0),(529943,14721,'sv','Senaste lagerjusteringar - 30 dagar',0),(529944,14721,'it','Recenti rettifiche di magazzino - 30 giorni',0),(529945,14721,'tl','',0),(529946,14721,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸¥à¹ˆà¸²à¸ªà¸¸à¸” - 30 à¸§à¸±à¸™',0),(529947,14721,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ - 30 à¤¦à¤¿à¤¨',0),(529948,14721,'ms','Pelarasan Inventori hari - 30 hari',0),(529949,14721,'ar','ØªØ¹Ø¯ÙŠÙ„Ø§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø£Ø®ÙŠØ±Ø©-30 ÙŠÙˆÙ…Ø§',0),(529950,14721,'fr','Redressements de l\'inventaire rÃ©cent - 30 jours',0),(529951,14721,'jp','æœ€è¿‘åœ¨åº«èª¿æ•´ - 30 æ—¥',0),(529952,14721,'pt','Ajustes de inventÃ¡rio recente - 30 dias',0),(529953,14721,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ - 30 Ð´Ð½ÐµÐ¹',0),(529954,14721,'es','Ajustes de inventario reciente - 30 dÃ­as',0),(529955,14721,'de','Den letzten Lagerregulierungen - 30 Tage',0),(529956,14721,'en','Recent Inventory Adjustments - 30 Days',0),(529957,14722,'is','',0),(529958,14722,'dr','Ø§Ù‚Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¬Ø¯ÛŒØ¯ - 30 Ø±ÙˆØ²',0),(529959,14722,'pr','Ø§Ù‚Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¬Ø¯ÛŒØ¯ - 30 Ø±ÙˆØ²',0),(529960,14722,'tr','Yeni stok maddeleri - 30 gÃ¼n',0),(529961,14722,'pl','Nowych zapasÃ³w - 30 dni',0),(529962,14722,'bg','ÐÐ¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° ÑÐºÐ»Ð°Ð´ - 30 Ð´Ð½Ð¸',0),(529963,14722,'ur','Ù†Ø¦ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡ - 30 Ø¯Ù†',0),(529964,14722,'sr','ÐÐ¾Ð²Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° - 30 Ð´Ð°Ð½Ð°',0),(529965,14722,'vi','Má»›i hÃ ng tá»“n kho má»¥c - 30 ngÃ y',0),(529966,14722,'af','Nuwe voorraad Items - 30 dae',0),(529967,14722,'ro','Noi obiecte de inventar - 30 de zile',0),(529968,14722,'et','Uus laokaupade - 30 pÃ¤eva',0),(529969,14722,'si','Nove elemente zaloge - 30 dni',0),(529970,14722,'ba','Baru persediaan barang - 30 hari',0),(529971,14722,'nl','Nieuwe voorraadartikelen - 30 dagen',0),(529972,14722,'fi','Varaston uutuuksia - 30 pÃ¤ivÃ¤Ã¤',0),(529973,14722,'no','Nye lagervarer - 30 dager',0),(529974,14722,'da','Nye varer - 30 dage',0),(529975,14722,'ko','ìƒˆë¡œìš´ ì¸ë²¤í† ë¦¬ ì•„ì´í…œ-30 ì¼',0),(529976,14722,'he','×ž×œ××™ ×¤×¨×™×˜×™× ×—×“×©×™× - 30 ×™×ž×™×',0),(529977,14722,'el','ÎÎ­Î± ÎµÎ¯Î´Î· Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ - 30 Î·Î¼Î­ÏÎµÏ‚',0),(529978,14722,'zh','æ–°çš„åº“å­˜ç‰©æ–™-30 å¤©',0),(529979,14722,'sv','Nya lagerartiklar - 30 dagar',0),(529980,14722,'it','Nuovi articoli di magazzino - 30 giorni',0),(529981,14722,'tl','',0),(529982,14722,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¹ƒà¸«à¸¡à¹ˆ - 30 à¸§à¸±à¸™',0),(529983,14722,'hi','à¤¨à¤ˆ à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® - 30 à¤¦à¤¿à¤¨',0),(529984,14722,'ms','Item inventori baru - 30 hari',0),(529985,14722,'ar','Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ø¬Ø¯ÙŠØ¯-30 ÙŠÙˆÙ…Ø§',0),(529986,14722,'fr','Nouveaux articles en stock - 30 jours',0),(529987,14722,'jp','æ–°ã—ã„åœ¨åº«ã‚¢ã‚¤ãƒ†ãƒ  - 30 æ—¥',0),(529988,14722,'pt','Novos itens do inventÃ¡rio - 30 dias',0),(529989,14722,'ru','ÐÐ¾Ð²Ð°Ñ Ñ‚Ð¾Ð²Ð°Ñ€Ð½Ð¾ - 30 Ð´Ð½ÐµÐ¹',0),(529990,14722,'es','Nuevos artÃ­culos de inventario - 30 dÃ­as',0),(529991,14722,'de','Neue Lagerartikel - 30 Tage',0),(529992,14722,'en','New Inventory Items - 30 Days',0),(529993,14723,'is','',0),(529994,14723,'dr','Ù…ÙˆØ§Ø±Ø¯ Ø³ÙˆØ¯ Ø¨Ø§Ù„Ø§ 10',0),(529995,14723,'pr','Ù…ÙˆØ§Ø±Ø¯ Ø³ÙˆØ¯ Ø¨Ø§Ù„Ø§ 10',0),(529996,14723,'tr','En iyi 10 kar Ã¶ÄŸeler',0),(529997,14723,'pl','Top 10 pozycji zysk',0),(529998,14723,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(529999,14723,'ur','Ù¹Ø§Ù¾ 10 Ù…Ù†Ø§ÙØ¹ Ø¨Ø®Ø´ Ø§Ø´ÛŒØ§Ø¡',0),(530000,14723,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð¾Ð±Ð¸Ñ‚ÐºÐ°',0),(530001,14723,'vi','Top 10 lá»£i nhuáº­n má»¥c',0),(530002,14723,'af','Top 10 wins Items',0),(530003,14723,'ro','Elemente de Profit top 10',0),(530004,14723,'et','Top 10 tulu kaupade',0),(530005,14723,'si','Top 10 dobiÄek elementov',0),(530006,14723,'ba','Top 10 item keuntungan',0),(530007,14723,'nl','Top 10 winst Items',0),(530008,14723,'fi','Top 10 voittoa kohteet',0),(530009,14723,'no','Topp 10 overskudd elementer',0),(530010,14723,'da','Top 10 overskud varer',0),(530011,14723,'ko','í†± 10 ì´ìµ í•­ëª©',0),(530012,14723,'he','Top 10 ×¤×¨×™×˜×™× ×¨×•×•×—',0),(530013,14723,'el','ÎšÎ¿ÏÏ…Ï†Î® 10 ÎºÎ­ÏÎ´Î¿Ï‚',0),(530014,14723,'zh','æŽ’åå‰åçš„åˆ©æ¶¦é¡¹ç›®',0),(530015,14723,'sv','Topp 10 vinst objekt',0),(530016,14723,'it','Top 10 articoli di profitto',0),(530017,14723,'tl','',0),(530018,14723,'th','10 à¸­à¸±à¸™à¸”à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸à¸³à¹„à¸£',0),(530019,14723,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤²à¤¾à¤­ à¤†à¤‡à¤Ÿà¤®',0),(530020,14723,'ms','Item-item untung Top 10',0),(530021,14723,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¨Ù†ÙˆØ¯ Ø§Ù„Ø£Ø±Ø¨Ø§Ø­',0),(530022,14723,'fr','Top 10 Articles de Profit',0),(530023,14723,'jp','ãƒˆãƒƒãƒ— 10 åˆ©ç›Šé …ç›®',0),(530024,14723,'pt','Top 10 itens de lucro',0),(530025,14723,'ru','Ð¢Ð¾Ð¿ 10 Ð¿ÑƒÐ½ÐºÑ‚Ð¾Ð² Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸',0),(530026,14723,'es','Top 10 artÃ­culos de beneficio',0),(530027,14723,'de','Top 10 Gewinn-Elemente',0),(530028,14723,'en','Top 10 Profit Items',0),(530029,14724,'is','',0),(530030,14724,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø±Ø³ÛŒØ¯ Ø¨Ø§ Ù¾Ùˆ - 30 Ø±ÙˆØ²',0),(530031,14724,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø±Ø³ÛŒØ¯ Ø¨Ø§ Ù¾Ùˆ - 30 Ø±ÙˆØ²',0),(530032,14724,'tr','Stok giriÅŸleri ile PO - 30 gÃ¼n',0),(530033,14724,'pl','Spis wpÅ‚ywy z PO - 30 dni',0),(530034,14724,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð·Ð° ÑÐºÐ»Ð°Ð´ Ñ PO - 30 Ð´Ð½Ð¸',0),(530035,14724,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº Ù¾ÙˆØ³Ù¹ - 30 Ø¯Ù†ÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾',0),(530036,14724,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ ÑƒÐ· ÐŸÐž - 30 Ð´Ð°Ð½Ð°',0),(530037,14724,'vi','HÃ ng tá»“n kho hÃ³a Ä‘Æ¡n vá»›i PO - 30 ngÃ y',0),(530038,14724,'af','Voorraad ontvangste met PO - 30 dae',0),(530039,14724,'ro','ÃŽncasÄƒrile inventarierea cu PO - 30 de zile',0),(530040,14724,'et','Lao sissetulekute PO - 30 pÃ¤eva',0),(530041,14724,'si','Zaloge potrdila z PO - 30 dni',0),(530042,14724,'ba','Persediaan kuitansi dengan PO - 30 hari',0),(530043,14724,'nl','Inventaris ontvangsten met PO - 30 dagen',0),(530044,14724,'fi','Varastovastaanottojen PO - 30 pÃ¤ivÃ¤Ã¤',0),(530045,14724,'no','Lagermottak med PO - 30 dager',0),(530046,14724,'da','Lagertilgange med PO - 30 dage',0),(530047,14724,'ko','í¬-30 ì¼ ê°€ì§„ ìž¬ê³  ì˜ìˆ˜ì¦',0),(530048,14724,'he','×ž×œ××™ ×§×‘×œ×•×ª ×¢× ×¤×• - 30 ×™×ž×™×',0),(530049,14724,'el','Î Î±ÏÎ±Î»Î±Î²Î­Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î¼Îµ PO - 30 Î·Î¼Î­ÏÎµÏ‚',0),(530050,14724,'zh','åº“å­˜æ”¶è´§ä¸Žå¤§åŸ”-30 å¤©',0),(530051,14724,'sv','Lagerinleveranser med PO - 30 dagar',0),(530052,14724,'it','Inventario ricevute con PO - 30 giorni',0),(530053,14724,'tl','',0),(530054,14724,'th','à¸à¸²à¸£à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸à¸±à¸š PO - 30 à¸§à¸±à¸™',0),(530055,14724,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤°à¤¸à¥€à¤¦à¥‡à¤‚ à¤ªà¥‹ - 30 à¤¦à¤¿à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(530056,14724,'ms','Inventori resit dengan PO - 30 hari',0),(530057,14724,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù…Ø¹ Ø¨Ùˆ-30 ÙŠÙˆÙ…Ø§',0),(530058,14724,'fr','RÃ©ceptions de stock avec PO - 30 jours',0),(530059,14724,'jp','åœ¨åº«å…¥åº« PO - 30 æ—¥é–“ã§',0),(530060,14724,'pt','Recibos de inventÃ¡rio com PO - 30 dias',0),(530061,14724,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ñ Ð Ð¾ - 30 Ð´Ð½ÐµÐ¹',0),(530062,14724,'es','Recibos de inventario con PO - 30 dÃ­as',0),(530063,14724,'de','Inventar-Einnahmen mit PO - 30 Tage',0),(530064,14724,'en','Inventory Receipts With PO - 30 Days',0),(530065,14725,'is','',0),(530066,14725,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø±Ø³ÛŒØ¯ Ø¨Ø¯ÙˆÙ† ØµÙ†Ø¯ÙˆÙ‚ - 30 Ø±ÙˆØ²',0),(530067,14725,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø±Ø³ÛŒØ¯ Ø¨Ø¯ÙˆÙ† ØµÙ†Ø¯ÙˆÙ‚ - 30 Ø±ÙˆØ²',0),(530068,14725,'tr','Stok giriÅŸlerini PO - 30 gÃ¼n olmadan',0),(530069,14725,'pl','PrzyjÄ™Ä‡ magazynowych bez PO - 30 dni',0),(530070,14725,'bg','ÐžÐ¿Ð¸Ñ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð±ÐµÐ· PO - 30 Ð´Ð½Ð¸',0),(530071,14725,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ Ø±Ø³ÛŒØ¯ÛŒÚº Ù¾ÙˆØ³Ù¹ - 30 Ø¯Ù† Ú©Û’ Ø¨ØºÛŒØ±',0),(530072,14725,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ Ð±ÐµÐ· ÐŸÐž - 30 Ð´Ð°Ð½Ð°',0),(530073,14725,'vi','HÃ ng tá»“n kho hÃ³a Ä‘Æ¡n mÃ  khÃ´ng cÃ³ PO - 30 ngÃ y',0),(530074,14725,'af','Voorraad ontvangste sonder PO - 30 dae',0),(530075,14725,'ro','Inventarul Ã®ncasÄƒri fara PO - 30 de zile',0),(530076,14725,'et','Lao sissetulekute ilma PO - 30 pÃ¤eva',0),(530077,14725,'si','Zaloge prejemki brez PO - 30 dni',0),(530078,14725,'ba','Persediaan penerimaan tanpa PO - 30 hari',0),(530079,14725,'nl','Inventaris ontvangsten zonder PO - 30 dagen',0),(530080,14725,'fi','Varastovastaanottojen ilman PO - 30 pÃ¤ivÃ¤Ã¤',0),(530081,14725,'no','Lagermottak uten PO - 30 dager',0),(530082,14725,'da','Lagertilgange uden PO - 30 dage',0),(530083,14725,'ko','í¬-30 ì¼ ì—†ì´ ìž¬ê³  ì˜ìˆ˜ì¦',0),(530084,14725,'he','×ž×œ××™ ×§×‘×œ×•×ª ×ž×‘×œ×™ ×¤×• - 30 ×™×ž×™×',0),(530085,14725,'el','Î Î±ÏÎ±Î»Î±Î²Î­Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Ï‡Ï‰ÏÎ¯Ï‚ PO - 30 Î·Î¼Î­ÏÎµÏ‚',0),(530086,14725,'zh','æ²¡æœ‰å®-30 å¤©çš„åº“å­˜æ”¶è´§',0),(530087,14725,'sv','Lagerinleveranser utan PO - 30 dagar',0),(530088,14725,'it','Inventario ricevute senza PO - 30 giorni',0),(530089,14725,'tl','',0),(530090,14725,'th','à¸à¸²à¸£à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡ à¹‚à¸”à¸¢ PO - 30 à¸§à¸±à¸™',0),(530091,14725,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤°à¤¸à¥€à¤¦à¥‡à¤‚ à¤ªà¥‹ - 30 à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¿à¤¨à¤¾',0),(530092,14725,'ms','Inventori resit tanpa PO - 30 hari',0),(530093,14725,'ar','Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¯ÙˆÙ† Ø¨Ùˆ-30 ÙŠÙˆÙ…Ø§',0),(530094,14725,'fr','RÃ©ceptions de stock sans PO - 30 jours',0),(530095,14725,'jp','åœ¨åº«å…¥åº« PO - 30 æ—¥ãªã—',0),(530096,14725,'pt','Recibos de inventÃ¡rio sem PO - 30 dias',0),(530097,14725,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð±ÐµÐ· PO - 30 Ð´Ð½ÐµÐ¹',0),(530098,14725,'es','Inventario recibos sin PO - 30 dÃ­as',0),(530099,14725,'de','Inventar Quittungen ohne PO - 30 Tage',0),(530100,14725,'en','Inventory Receipts Without PO - 30 Days',0),(530101,14726,'is','',0),(530102,14726,'dr','Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§Ù„Ø§ 10',0),(530103,14726,'pr','Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§Ù„Ø§ 10',0),(530104,14726,'tr','En iyi 10 Ã¶ÄŸeler',0),(530105,14726,'pl','Top 10 pozycji',0),(530106,14726,'bg','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸',0),(530107,14726,'ur','Ù¹Ø§Ù¾ 10 Ø§Ø´ÛŒØ§Ø¡',0),(530108,14726,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÑÑ‚Ð°Ð²ÐºÐ¸',0),(530109,14726,'vi','Top 10 bÃ i',0),(530110,14726,'af','Top 10 Items',0),(530111,14726,'ro','Top 10 articole',0),(530112,14726,'et','Top 10 Ã¼ksused',0),(530113,14726,'si','Top 10 elementov',0),(530114,14726,'ba','Top 10 item',0),(530115,14726,'nl','Top 10 Items',0),(530116,14726,'fi','Top 10 kohteet',0),(530117,14726,'no','Topp 10 elementer',0),(530118,14726,'da','Top 10 varer',0),(530119,14726,'ko','ìƒìœ„ 10 ê°œ í•­ëª©',0),(530120,14726,'he','×”×¢×œ×™×•×Ÿ 10 ×¤×¨×™×˜×™×',0),(530121,14726,'el','Top 10 ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(530122,14726,'zh','æŽ’åå‰åçš„é¡¹ç›®',0),(530123,14726,'sv','Topp 10 artiklar',0),(530124,14726,'it','Top 10 articoli',0),(530125,14726,'tl','',0),(530126,14726,'th','à¸ªà¸´à¸™à¸„à¹‰à¸² 10 à¸­à¸±à¸™à¸”à¸±à¸šà¹à¸£à¸',0),(530127,14726,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(530128,14726,'ms','Top 10 item',0),(530129,14726,'ar','Ø£Ø­Ø¯Ø« 10 Ø¹Ù†Ø§ØµØ±',0),(530130,14726,'fr','Top 10 Articles',0),(530131,14726,'jp','ä¸Šä½ 10 é …ç›®',0),(530132,14726,'pt','Top 10 itens',0),(530133,14726,'ru','Ð¢Ð¾Ð¿ 10 ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(530134,14726,'es','Top 10 artÃ­culos',0),(530135,14726,'de','Top 10 Artikel',0),(530136,14726,'en','Top 10 Items',0),(530137,14727,'is','',0),(530138,14727,'dr','Ø³ÙˆØ¯ - 1 Ø³Ø§Ù„',0),(530139,14727,'pr','Ø³ÙˆØ¯ - 1 Ø³Ø§Ù„',0),(530140,14727,'tr','Kar - 1 yÄ±l',0),(530141,14727,'pl','Zysk - 1 rok',0),(530142,14727,'bg','ÐŸÐµÑ‡Ð°Ð»Ð±Ð° - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(530143,14727,'ur','Ù…Ù†Ø§ÙØ¹ - 1 Ø³Ø§Ù„',0),(530144,14727,'sr','Ð”Ð¾Ð±Ð¸Ñ‚ - 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(530145,14727,'vi','Lá»£i nhuáº­n â€“ 1 nÄƒm',0),(530146,14727,'af','Wins - 1 jaar',0),(530147,14727,'ro','Profit - 1 an',0),(530148,14727,'et','Kasum - 1 aasta',0),(530149,14727,'si','DobiÄek - 1 leto',0),(530150,14727,'ba','Keuntungan - 1 tahun',0),(530151,14727,'nl','Winst - 1 jaar',0),(530152,14727,'fi','Voitto - 1 vuosi',0),(530153,14727,'no','Profit - 1 Ã¥r',0),(530154,14727,'da','Profit - 1 Ã¥r',0),(530155,14727,'ko','ì´ìµ-1 ë…„',0),(530156,14727,'he','×¨×•×•×— - 1 ×©× ×”',0),(530157,14727,'el','ÎšÎ­ÏÎ´Î¿Ï‚ - 1 Î­Ï„Î¿Ï‚',0),(530158,14727,'zh','åˆ©æ¶¦-1 å¹´',0),(530159,14727,'sv','Vinst - 1 Ã¥r',0),(530160,14727,'it','Profitto - 1 anno',0),(530161,14727,'tl','',0),(530162,14727,'th','à¸à¸³à¹„à¸£ - 1 à¸›à¸µ',0),(530163,14727,'hi','à¤²à¤¾à¤­ - 1 à¤¸à¤¾à¤²',0),(530164,14727,'ms','Keuntungan - 1 tahun',0),(530165,14727,'ar','Ø§Ù„Ø±Ø¨Ø­-Ø³Ù†Ø© 1',0),(530166,14727,'fr','Profit - 1 an',0),(530167,14727,'jp','åˆ©ç›Š - 1 å¹´',0),(530168,14727,'pt','Lucro - 1 ano',0),(530169,14727,'ru','ÐŸÑ€Ð¸Ð±Ñ‹Ð»ÑŒ - 1 Ð³Ð¾Ð´',0),(530170,14727,'es','Ganancia - 1 aÃ±o',0),(530171,14727,'de','Gewinn - 1 Jahr',0),(530172,14727,'en','Profit - 1 Year',0),(530173,14728,'is','',0),(530174,14728,'dr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ù…Ø¬Ù„Ù‡--1 Ù‡ÙØªÙ‡',0),(530175,14728,'pr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ù…Ø¬Ù„Ù‡--1 Ù‡ÙØªÙ‡',0),(530176,14728,'tr','GÃ¼nlÃ¼k giriÅŸleri - 1 hafta',0),(530177,14728,'pl','Wpisy do dziennika - 1 tydzieÅ„',0),(530178,14728,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ° - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(530179,14728,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª - 1 ÛÙØªÛ',0),(530180,14728,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÑƒ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ðµ',0),(530181,14728,'vi','Táº¡p chÃ­ Entries - 1 tuáº§n',0),(530182,14728,'af','Joernaalinskrywings - 1 Week',0),(530183,14728,'ro','IntrÄƒri Ã®n jurnal - 1 sÄƒptÄƒmÃ¢nÄƒ',0),(530184,14728,'et','PÃ¤evikukannete - 1 nÃ¤dal',0),(530185,14728,'si','Dnevnik - 1 teden',0),(530186,14728,'ba','Entri jurnal - 1 minggu',0),(530187,14728,'nl','Logboekitems - 1 Week',0),(530188,14728,'fi','PÃ¤ivyrimerkintÃ¶jen - 1 viikko',0),(530189,14728,'no','LoggoppfÃ¸ringer - 1 uke',0),(530190,14728,'da','Journaloptegnelser - 1 uge',0),(530191,14728,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª©-1 ì£¼',0),(530192,14728,'he','×¢×¨×›×™ ×™×•×ž×Ÿ - ×©×‘×•×¢ 1',0),(530193,14728,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ - 1 ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(530194,14728,'zh','æ—¥è®°æ¡ç›®-1 å‘¨',0),(530195,14728,'sv','Journalposter - 1 vecka',0),(530196,14728,'it','Voci del diario - 1 settimana',0),(530197,14728,'tl','',0),(530198,14728,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™ - 1 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(530199,14728,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ - 1 à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(530200,14728,'ms','Catatan jurnal - 1 minggu',0),(530201,14728,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©-Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ 1',0),(530202,14728,'fr','Ã‰critures de journal - 1 semaine',0),(530203,14728,'jp','ä»•è¨³å¸³ã‚¨ãƒ³ãƒˆãƒª - 1 é€±',0),(530204,14728,'pt','Entradas de diÃ¡rio - 1 semana',0),(530205,14728,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ - 1 Ð½ÐµÐ´ÐµÐ»Ñ',0),(530206,14728,'es','Entradas del diario - 1 semana',0),(530207,14728,'de','JournaleintrÃ¤ge - 1 Woche',0),(530208,14728,'en','Journal Entries - 1 Week',0),(530209,14729,'is','',0),(530210,14729,'dr','ÙØ±ÙˆØ´ - 1 Ù‡ÙØªÙ‡',0),(530211,14729,'pr','ÙØ±ÙˆØ´ - 1 Ù‡ÙØªÙ‡',0),(530212,14729,'tr','SatÄ±ÅŸ - 1 hafta',0),(530213,14729,'pl','SprzedaÅ¼y - 1 tydzieÅ„',0),(530214,14729,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(530215,14729,'ur','Ø³ÛŒÙ„Ø² - 1 ÛÙØªÛ',0),(530216,14729,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ðµ',0),(530217,14729,'vi','BÃ¡n hÃ ng - 1 tuáº§n',0),(530218,14729,'af','Verkope - 1 Week',0),(530219,14729,'ro','Vanzari - 1 sÄƒptÄƒmÃ¢nÄƒ',0),(530220,14729,'et','MÃ¼Ã¼k - 1 nÃ¤dal',0),(530221,14729,'si','Prodaja - 1 teden',0),(530222,14729,'ba','Penjualan - 1 minggu',0),(530223,14729,'nl','Verkoop - 1 Week',0),(530224,14729,'fi','Myynti - 1 viikko',0),(530225,14729,'no','Salg - 1 uke',0),(530226,14729,'da','Salg - 1 uge',0),(530227,14729,'ko','íŒë§¤-1 ì£¼',0),(530228,14729,'he','×ž×›×™×¨×•×ª - ×©×‘×•×¢ 1',0),(530229,14729,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ - 1 ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(530230,14729,'zh','é”€å”®äººå‘˜ â€” â€” 1 å‘¨',0),(530231,14729,'sv','FÃ¶rsÃ¤ljning - 1 vecka',0),(530232,14729,'it','Vendite - 1 settimana',0),(530233,14729,'tl','',0),(530234,14729,'th','à¸‚à¸²à¸¢ - 1 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(530235,14729,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ - 1 à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(530236,14729,'ms','Jualan - 1 minggu',0),(530237,14729,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª-Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ 1',0),(530238,14729,'fr','Ventes - 1 semaine',0),(530239,14729,'jp','1 é€±é–“ã®è²©å£²-',0),(530240,14729,'pt','Vendas - semana 1',0),(530241,14729,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° - 1 Ð½ÐµÐ´ÐµÐ»Ñ',0),(530242,14729,'es','Ventas - 1 semana',0),(530243,14729,'de','Verkauf - 1 Woche',0),(530244,14729,'en','Sales - 1 Week',0),(530245,14730,'is','',0),(530246,14730,'dr','ÙØ±ÙˆØ´ - 1 Ø³Ø§Ù„',0),(530247,14730,'pr','ÙØ±ÙˆØ´ - 1 Ø³Ø§Ù„',0),(530248,14730,'tr','SatÄ±ÅŸ - 1 yÄ±l',0),(530249,14730,'pl','SprzedaÅ¼y - 1 rok',0),(530250,14730,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(530251,14730,'ur','Ø³ÛŒÙ„Ø² - 1 Ø³Ø§Ù„',0),(530252,14730,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° - 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(530253,14730,'vi','Kinh doanh â€“ 1 nÄƒm',0),(530254,14730,'af','Verkope - 1 jaar',0),(530255,14730,'ro','Vanzari - 1 an',0),(530256,14730,'et','MÃ¼Ã¼k - 1 aasta',0),(530257,14730,'si','Prodaja - 1 leto',0),(530258,14730,'ba','Penjualan - 1 tahun',0),(530259,14730,'nl','Verkoop - 1 jaar',0),(530260,14730,'fi','Myynti - 1 vuosi',0),(530261,14730,'no','Salg - 1 Ã¥r',0),(530262,14730,'da','Salg - 1 Ã¥r',0),(530263,14730,'ko','íŒë§¤-1 ë…„',0),(530264,14730,'he','×ž×›×™×¨×•×ª - 1 ×©× ×”',0),(530265,14730,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ - 1 Î­Ï„Î¿Ï‚',0),(530266,14730,'zh','é”€å”®-1 å¹´',0),(530267,14730,'sv','FÃ¶rsÃ¤ljning - 1 Ã¥r',0),(530268,14730,'it','Vendite - 1 anno',0),(530269,14730,'tl','',0),(530270,14730,'th','à¸‚à¸²à¸¢ - 1 à¸›à¸µ',0),(530271,14730,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ - 1 à¤¸à¤¾à¤²',0),(530272,14730,'ms','Jualan - 1 tahun',0),(530273,14730,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª-Ø³Ù†Ø© 1',0),(530274,14730,'fr','Ventes - 1 an',0),(530275,14730,'jp','å£²ã‚Šä¸Šã’é«˜ - 1 å¹´',0),(530276,14730,'pt','Vendas - 1 ano',0),(530277,14730,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° - 1 Ð³Ð¾Ð´',0),(530278,14730,'es','Ventas - 1 aÃ±o',0),(530279,14730,'de','Verkauf - 1 Jahr',0),(530280,14730,'en','Sales - 1 Year',0),(530281,14731,'is','',0),(530282,14731,'dr','ÙØ±ÙˆØ´ - 8 Ù‡ÙØªÙ‡',0),(530283,14731,'pr','ÙØ±ÙˆØ´ - 8 Ù‡ÙØªÙ‡',0),(530284,14731,'tr','SatÄ±ÅŸ - 8 hafta',0),(530285,14731,'pl','SprzedaÅ¼y - 8 tygodni',0),(530286,14731,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ - 8 ÑÐµÐ´Ð¼Ð¸Ñ†Ð¸',0),(530287,14731,'ur','Ø³ÛŒÙ„Ø² - 8 ÛÙØªÙˆÚº',0),(530288,14731,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° - 8 Ð½ÐµÐ´ÐµÑ™Ð°',0),(530289,14731,'vi','BÃ¡n hÃ ng - 8 tuáº§n',0),(530290,14731,'af','Verkope - 8 weke',0),(530291,14731,'ro','Vanzari - 8 sÄƒptÄƒmÃ¢ni',0),(530292,14731,'et','MÃ¼Ã¼k - 8 nÃ¤dalat',0),(530293,14731,'si','Prodaja - 8 tednov',0),(530294,14731,'ba','Penjualan - 8 minggu',0),(530295,14731,'nl','Verkoop - 8 weken',0),(530296,14731,'fi','Myynti - 8 viikkoa',0),(530297,14731,'no','Salg - 8 uker',0),(530298,14731,'da','Salg - 8 uger',0),(530299,14731,'ko','íŒë§¤-8 ì£¼',0),(530300,14731,'he','×ž×›×™×¨×•×ª - 8 ×©×‘×•×¢×•×ª',0),(530301,14731,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ - 8 ÎµÎ²Î´Î¿Î¼Î¬Î´ÎµÏ‚',0),(530302,14731,'zh','é”€å”®-8 å‘¨',0),(530303,14731,'sv','FÃ¶rsÃ¤ljning - 8 veckor',0),(530304,14731,'it','Vendite - 8 settimane',0),(530305,14731,'tl','',0),(530306,14731,'th','à¸‚à¸²à¸¢ - 8 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(530307,14731,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ - 8 à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(530308,14731,'ms','Jualan - 8 minggu',0),(530309,14731,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª-8 Ø£Ø³Ø§Ø¨ÙŠØ¹',0),(530310,14731,'fr','Ventes - 8 semaines',0),(530311,14731,'jp','è²©å£² - 8 é€±é–“',0),(530312,14731,'pt','Vendas - 8 semanas',0),(530313,14731,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° - 8 Ð½ÐµÐ´ÐµÐ»ÑŒ',0),(530314,14731,'es','Ventas - 8 semanas',0),(530315,14731,'de','Vertrieb - 8 Wochen',0),(530316,14731,'en','Sales - 8 Weeks',0),(530317,14732,'is','',0),(530318,14732,'dr','Ø³ÙØ§Ø±Ø´ Ø¬Ù„Ø¯ - 1 Ø³Ø§Ù„',0),(530319,14732,'pr','Ø³ÙØ§Ø±Ø´ Ø¬Ù„Ø¯ - 1 Ø³Ø§Ù„',0),(530320,14732,'tr','Cilt - 1 yÄ±l sipariÅŸ',0),(530321,14732,'pl','ZamÃ³w Tom - 1 rok',0),(530322,14732,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð¾Ð±ÐµÐ¼ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(530323,14732,'ur','ØµÙˆØª - 1 Ø³Ø§Ù„ Ú©Ø§ Ø­Ú©Ù…',0),(530324,14732,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(530325,14732,'vi','Äáº·t hÃ ng khá»‘i lÆ°á»£ng â€“ 1 nÄƒm',0),(530326,14732,'af','Bestel Volume - 1 jaar',0),(530327,14732,'ro','Comanda volum - 1 an',0),(530328,14732,'et','Tellimuse maht - 1 aasta',0),(530329,14732,'si','Naloga obsega - 1 leto',0),(530330,14732,'ba','Memesan Volume - 1 tahun',0),(530331,14732,'nl','Bestel Volume - 1 jaar',0),(530332,14732,'fi','Tilaa Volume - 1 vuosi',0),(530333,14732,'no','Bestille volum - 1 Ã¥r',0),(530334,14732,'da','Bestil volumen - 1 Ã¥r',0),(530335,14732,'ko','ì£¼ë¬¸ ì–‘-1 ë…„',0),(530336,14732,'he','×”×–×ž× ×ª ××—×¡×•×Ÿ - 1 ×©× ×”',0),(530337,14732,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Ï„ÏŒÎ¼Î¿Ï‚ - 1 Î­Ï„Î¿Ï‚',0),(530338,14732,'zh','è®¢å•é‡-1 å¹´',0),(530339,14732,'sv','BestÃ¤ll volym - 1 Ã¥r',0),(530340,14732,'it','Ordinare il Volume - 1 anno',0),(530341,14732,'tl','',0),(530342,14732,'th','à¸ªà¸±à¹ˆà¸‡à¸›à¸£à¸´à¸¡à¸²à¸“ - 1 à¸›à¸µ',0),(530343,14732,'hi','1 à¤µà¤°à¥à¤· à¤•à¥‡ à¤–à¤‚à¤¡ - à¤†à¤¦à¥‡à¤¶',0),(530344,14732,'ms','Perintah Volume - 1 tahun',0),(530345,14732,'ar','ØªØ±ØªÙŠØ¨ ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†--Ø§Ù„Ø³Ù†Ø© 1',0),(530346,14732,'fr','Commander le Volume - 1 an',0),(530347,14732,'jp','æ³¨æ–‡ã®å·» - 1 å¹´',0),(530348,14732,'pt','Ordem Volume - 1 ano',0),(530349,14732,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾Ð±ÑŠÐµÐ¼ - 1 Ð³Ð¾Ð´',0),(530350,14732,'es','Orden volumen - 1 aÃ±o',0),(530351,14732,'de','Auftragsvolumen Sie - 1 Jahr',0),(530352,14732,'en','Order Volume - 1 Year',0),(530353,14733,'is','',0),(530354,14733,'dr','Ø¬Ù„Ø¯ - Ø³ÙØ§Ø±Ø´ 1 Ù‡ÙØªÙ‡',0),(530355,14733,'pr','Ø¬Ù„Ø¯ - Ø³ÙØ§Ø±Ø´ 1 Ù‡ÙØªÙ‡',0),(530356,14733,'tr','Cilt - 1 hafta sipariÅŸ',0),(530357,14733,'pl','ZamÃ³w Tom - 1 tydzieÅ„',0),(530358,14733,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð¾Ð±ÐµÐ¼ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(530359,14733,'ur','ØµÙˆØª - 1 ÛÙØªÛ Ú©Ø§ Ø­Ú©Ù…',0),(530360,14733,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ðµ',0),(530361,14733,'vi','Äáº·t hÃ ng khá»‘i lÆ°á»£ng - 1 tuáº§n',0),(530362,14733,'af','Bestel Volume - 1 Week',0),(530363,14733,'ro','Comanda volum - 1 sÄƒptÄƒmÃ¢nÄƒ',0),(530364,14733,'et','Tellimuse maht - 2 nÃ¤dalat',0),(530365,14733,'si','NaroÄite glasnost - 1 teden',0),(530366,14733,'ba','Memesan Volume - 1 minggu',0),(530367,14733,'nl','Bestel Volume - 1 Week',0),(530368,14733,'fi','Tilaa Volume - 1 viikko',0),(530369,14733,'no','Bestille volum - 1 uke',0),(530370,14733,'da','Bestil volumen - 1 uge',0),(530371,14733,'ko','ì£¼ë¬¸ ì–‘-1 ì£¼',0),(530372,14733,'he','×”×–×ž× ×ª ××—×¡×•×Ÿ - ×©×‘×•×¢ 1',0),(530373,14733,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Ï„ÏŒÎ¼Î¿Ï‚ - 1 ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(530374,14733,'zh','è®¢å•é‡-1 å‘¨',0),(530375,14733,'sv','BestÃ¤lla volym - 1 vecka',0),(530376,14733,'it','Ordinare il Volume - 1 settimana',0),(530377,14733,'tl','',0),(530378,14733,'th','à¸ªà¸±à¹ˆà¸‡à¸›à¸£à¸´à¸¡à¸²à¸“ - 1 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(530379,14733,'hi','à¤–à¤‚à¤¡ - 1 à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤†à¤¦à¥‡à¤¶',0),(530380,14733,'ms','Perintah Volume - 1 minggu',0),(530381,14733,'ar','ØªØ±ØªÙŠØ¨ ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†--Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ 1',0),(530382,14733,'fr','Commander le Volume - 1 semaine',0),(530383,14733,'jp','æ³¨æ–‡ã®å·» - 1 é€±',0),(530384,14733,'pt','Encomendar Volume - 1 semana',0),(530385,14733,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾Ð±ÑŠÐµÐ¼ - 1 Ð½ÐµÐ´ÐµÐ»Ñ',0),(530386,14733,'es','Orden volumen - 1 semana',0),(530387,14733,'de','Auftragsvolumen Sie - 1 Woche',0),(530388,14733,'en','Order Volume - 1 Week',0),(530389,14734,'is','',0),(530390,14734,'dr','Ù…Ø´ØªØ±ÛŒØ§Ù† - 30 Ø±ÙˆØ² Ø¨Ù‡ ØªØ§Ø²Ú¯ÛŒ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡',0),(530391,14734,'pr','Ù…Ø´ØªØ±ÛŒØ§Ù† - 30 Ø±ÙˆØ² Ø¨Ù‡ ØªØ§Ø²Ú¯ÛŒ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡',0),(530392,14734,'tr','En son eklenen mÃ¼ÅŸteriler - 30 gÃ¼n',0),(530393,14734,'pl','Ostatnio dodane klienci - 30 dni',0),(530394,14734,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ - 30 Ð´Ð½Ð¸',0),(530395,14734,'ur','Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº Ú¯Ø§ÛÚ© - 30 Ø¯Ù† Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(530396,14734,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¾ ÐºÑƒÐ¿Ð°Ñ†Ð° â€“ 30 Ð´Ð°Ð½Ð°',0),(530397,14734,'vi','Gáº§n Ä‘Ã¢y nháº¥t khÃ¡ch - 30 ngÃ y',0),(530398,14734,'af','Onlangs bygevoeg klante - 30 dae',0),(530399,14734,'ro','Recent, a adÄƒugat clienÅ£ii - 30 de zile',0),(530400,14734,'et','Viimati lisatud kÃ¼lastajad - 30 pÃ¤eva',0),(530401,14734,'si','Nedavno dodano stranke - 30 dni',0),(530402,14734,'ba','Baru saja ditambahkan pelanggan - 30 hari',0),(530403,14734,'nl','Onlangs toegevoegde klanten - 30 dagen',0),(530404,14734,'fi','Viimeksi lisÃ¤tyt asiakkaat - 30 pÃ¤ivÃ¤Ã¤',0),(530405,14734,'no','Nylig lagt til kunder - 30 dager',0),(530406,14734,'da','For nylig tilfÃ¸jet kunder - 30 dage',0),(530407,14734,'ko','ìµœê·¼ ê³ ê°-30 ì¼ ì¶”ê°€',0),(530408,14734,'he','×œ××—×¨×•× ×” ×”×•×¡×¤× ×• ×œ×§×•×—×•×ª - 30 ×™×ž×™×',0),(530409,14734,'el','Î ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎ±Î½ Ï€ÏÏŒÏƒÏ†Î±Ï„Î± Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ - 30 Î·Î¼Î­ÏÎµÏ‚',0),(530410,14734,'zh','æœ€è¿‘æ·»åŠ çš„å®¢æˆ·-30 å¤©',0),(530411,14734,'sv','Nytillkomna kunder - 30 dagar',0),(530412,14734,'it','Recentemente aggiunto clienti - 30 giorni',0),(530413,14734,'tl','',0),(530414,14734,'th','à¹€à¸žà¸´à¹ˆà¸‡ à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¸¹à¸à¸„à¹‰à¸² - 30 à¸§à¸±à¸™',0),(530415,14734,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ - 30 à¤¦à¤¿à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾',0),(530416,14734,'ms','Tambah Tempahan pelanggan - 30 hari',0),(530417,14734,'ar','ÙˆØ£Ø¶Ø§Ù Ù…Ø¤Ø®Ø±Ø§ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡--30 ÙŠÙˆÙ…Ø§',0),(530418,14734,'fr','RÃ©cemment ajoutÃ© clients - 30 jours',0),(530419,14734,'jp','æœ€è¿‘è¿½åŠ ã•ã‚ŒãŸãŠå®¢æ§˜ - 30 æ—¥',0),(530420,14734,'pt','Recentemente adicionado clientes - 30 dias',0),(530421,14734,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ð¾ÑÐµÑ‚Ð¸Ñ‚ÐµÐ»ÑÐ¼Ð¸ - 30 Ð´Ð½ÐµÐ¹',0),(530422,14734,'es','Ãšltimos aÃ±adidos clientes - 30 dÃ­as',0),(530423,14734,'de','Vor kurzem Kunden - 30 Tage',0),(530424,14734,'en','Recently Added Customers - 30 Days',0),(530425,14735,'is','',0),(530426,14735,'dr','Ø¨Ù‡ ØªØ§Ø²Ú¯ÛŒ Ø¯Ø±ÛŒØ§ÙØª Ø³ÙØ§Ø±Ø´Ø§Øª - 7 Ø±ÙˆØ²',0),(530427,14735,'pr','Ø¨Ù‡ ØªØ§Ø²Ú¯ÛŒ Ø¯Ø±ÛŒØ§ÙØª Ø³ÙØ§Ø±Ø´Ø§Øª - 7 Ø±ÙˆØ²',0),(530428,14735,'tr','Son zamanlarda alÄ±nan sipariÅŸler - 7 gÃ¼n',0),(530429,14735,'pl','Niedawno otrzymaÅ‚ zamÃ³wienia - 7 dni',0),(530430,14735,'bg','ÐÐ°ÑÐºÐ¾Ñ€Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ - 7 Ð´Ð½Ð¸',0),(530431,14735,'ur','Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº ÙˆØµÙˆÙ„ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª - 7 Ø¯Ù†',0),(530432,14735,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ - 7 Ð´Ð°Ð½Ð°',0),(530433,14735,'vi','Má»›i nháº­n Ä‘Æ°á»£c Ä‘Æ¡n Ä‘áº·t hÃ ng - 7 ngÃ y',0),(530434,14735,'af','Onlangs ontvang bestellings - 7 dae',0),(530435,14735,'ro','Recent primit comenzi - 7 zile',0),(530436,14735,'et','Hiljuti saabunud tellimused - 7 pÃ¤eva',0),(530437,14735,'si','Nedavno prejemalo naroÄila - 7 dni',0),(530438,14735,'ba','Baru saja menerima pesanan - 7 hari',0),(530439,14735,'nl','Onlangs ontvangen Orders - 7 dagen',0),(530440,14735,'fi','Ã„skettÃ¤in tilaukset - 7 pÃ¤ivÃ¤Ã¤',0),(530441,14735,'no','Sist mottatte ordrer - 7 dager',0),(530442,14735,'da','For nylig modtaget ordrer - 7 dage',0),(530443,14735,'ko','ìµœê·¼ ë°›ì€ ì£¼ë¬¸-7 ì¼',0),(530444,14735,'he','×œ××—×¨×•× ×” ×”×ª×§×‘×œ×• ×”×–×ž× ×•×ª - 7 ×™×ž×™×',0),(530445,14735,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î± Î»Î¬Î²ÎµÎ¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ - 7 Î·Î¼Î­ÏÎµÏ‚',0),(530446,14735,'zh','æœ€è¿‘æ”¶åˆ°çš„è®¢å•-7 å¤©',0),(530447,14735,'sv','Nyligen mottagna order - 7 dagar',0),(530448,14735,'it','Recentemente ha ricevuti ordini - 7 giorni',0),(530449,14735,'tl','',0),(530450,14735,'th','à¹€à¸žà¸´à¹ˆà¸‡à¹„à¸”à¹‰à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ - à¸§à¸±à¸™',0),(530451,14735,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤†à¤¦à¥‡à¤¶ - 7 à¤¦à¤¿à¤¨',0),(530452,14735,'ms','Tempahan diterima pesanan - 7 hari',0),(530453,14735,'ar','Ù…Ø¤Ø®Ø±Ø§ ØªÙ„Ù‚Øª Ø£ÙˆØ§Ù…Ø±-7 Ø£ÙŠØ§Ù…',0),(530454,14735,'fr','RÃ©cemment les ordres reÃ§us - 7 jours',0),(530455,14735,'jp','æœ€è¿‘å—ä¿¡ã—ãŸæ³¨æ–‡ - 7 æ—¥',0),(530456,14735,'pt','Recentemente recebeu ordens - 7 dias',0),(530457,14735,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹ - 7 Ð´Ð½ÐµÐ¹',0),(530458,14735,'es','Pedidos recibidos recientemente - 7 dÃ­as',0),(530459,14735,'de','Vor kurzem erhielt AuftrÃ¤ge - 7 Tage',0),(530460,14735,'en','Recently Received Orders - 7 Days',0),(530461,14736,'is','',0),(530462,14736,'dr','Ø§Ø®ÛŒØ±Ø§ Ø­Ù…Ù„ Ø§Ù‚Ù„Ø§Ù… - 30 Ø±ÙˆØ²',0),(530463,14736,'pr','Ø§Ø®ÛŒØ±Ø§ Ø­Ù…Ù„ Ø§Ù‚Ù„Ø§Ù… - 30 Ø±ÙˆØ²',0),(530464,14736,'tr','En son sevk edilen maddeleri - 30 gÃ¼n',0),(530465,14736,'pl','Niedawno wydane przedmioty - 30 dni',0),(530466,14736,'bg','ÐÐ°ÑÐºÐ¾Ñ€Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ - 30 Ð´Ð½Ð¸',0),(530467,14736,'ur','Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ø§Ø´ÛŒØ§Ø¡ - 30 Ø¯Ù†',0),(530468,14736,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸Ñ… Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° - 30 Ð´Ð°Ð½Ð°',0),(530469,14736,'vi','Má»›i chuyá»ƒn má»¥c - 30 ngÃ y',0),(530470,14736,'af','Onlangs Shipped Items - 30 dae',0),(530471,14736,'ro','Recent livrat articole - 30 de zile',0),(530472,14736,'et','Hiljuti lÃ¤hetatud kaubad - 30 pÃ¤eva',0),(530473,14736,'si','Nedavno dobavljene artikle - 30 dni',0),(530474,14736,'ba','Baru saja dikirim item - 30 hari',0),(530475,14736,'nl','Onlangs verzonden artikelen - 30 dagen',0),(530476,14736,'fi','Ã„skettÃ¤in toimitetut nimikkeet - 30 pÃ¤ivÃ¤Ã¤',0),(530477,14736,'no','Nylig sendte elementer - 30 dager',0),(530478,14736,'da','Seneste afsendte varer - 30 dage',0),(530479,14736,'ko','ìµœê·¼ ë°°ì†¡ëœ ìƒí’ˆ-30 ì¼',0),(530480,14736,'he','×œ××—×¨×•× ×” ×©× ×©×œ×—×” ×¤×¨×™×˜×™× - 30 ×™×ž×™×',0),(530481,14736,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î± Î±Ï€Î¿ÏƒÏ„Î­Î»Î»ÎµÏ„Î±Î¹ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± - 30 Î·Î¼Î­ÏÎµÏ‚',0),(530482,14736,'zh','æœ€è¿‘è¿åˆ°çš„ç‰©å“-30 å¤©',0),(530483,14736,'sv','Nyligen levererade artiklar - 30 dagar',0),(530484,14736,'it','Recentemente spediti articoli - 30 giorni',0),(530485,14736,'tl','',0),(530486,14736,'th','à¹€à¸¡à¸·à¹ˆà¸­à¹€à¸£à¹‡à¸§ à¹† à¸™à¸µà¹‰à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ - 30 à¸§à¸±à¸™',0),(530487,14736,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤® - 30 à¤¦à¤¿à¤¨',0),(530488,14736,'ms','Tempahan dihantar item - 30 hari',0),(530489,14736,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ù…Ø¤Ø®Ø±Ø§-30 ÙŠÙˆÙ…Ø§',0),(530490,14736,'fr','RÃ©cemment des articles expÃ©diÃ©s - 30 jours',0),(530491,14736,'jp','æœ€è¿‘å•†å“ç™ºé€ - 30 æ—¥',0),(530492,14736,'pt','Recentemente itens enviados - 30 dias',0),(530493,14736,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ñ… Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð¾Ð² - 30 Ð´Ð½ÐµÐ¹',0),(530494,14736,'es','Recientemente enviados artÃ­culos - 30 dÃ­as',0),(530495,14736,'de','KÃ¼rzlich gelieferten Artikel - 30 Tage',0),(530496,14736,'en','Recently Shipped Items - 30 Days',0),(530497,14737,'is','',0),(530498,14737,'dr','Ø§Ø®ÛŒØ±Ø§ Ø­Ù…Ù„ Ø³ÙØ§Ø±Ø´Ø§Øª - 30 Ø±ÙˆØ²',0),(530499,14737,'pr','Ø§Ø®ÛŒØ±Ø§ Ø­Ù…Ù„ Ø³ÙØ§Ø±Ø´Ø§Øª - 30 Ø±ÙˆØ²',0),(530500,14737,'tr','En son sevk edilen sipariÅŸler - 30 gÃ¼n',0),(530501,14737,'pl','Niedawno wydane rozkazy - 30 dni',0),(530502,14737,'bg','ÐÐ°ÑÐºÐ¾Ñ€Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ - 30 Ð´Ð½Ð¸',0),(530503,14737,'ur','Ø­Ø§Ù„ ÛÛŒ Ù…ÛŒÚº Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª - 30 Ø¯Ù†',0),(530504,14737,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¸Ñ… Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ð° - 30 Ð´Ð°Ð½Ð°',0),(530505,14737,'vi','Má»›i chuyá»ƒn Ä‘Æ¡n Ä‘áº·t hÃ ng - 30 ngÃ y',0),(530506,14737,'af','Onlangs Shipped bestellings - 30 dae',0),(530507,14737,'ro','Recent livrat ordinele - 30 de zile',0),(530508,14737,'et','Hiljuti lÃ¤hetanud jÃ¤tta - 30 pÃ¤eva',0),(530509,14737,'si','Nedavno poÅ¡iljajo naroÄila - 30 dni',0),(530510,14737,'ba','Baru saja dikirim pesanan - 30 hari',0),(530511,14737,'nl','Onlangs verzonden Orders - 30 dagen',0),(530512,14737,'fi','Ã„skettÃ¤in lÃ¤hetetyt tilaukset - 30 pÃ¤ivÃ¤Ã¤',0),(530513,14737,'no','Nylig sendte ordrer - 30 dager',0),(530514,14737,'da','For nylig leverede ordrer - 30 dage',0),(530515,14737,'ko','ìµœê·¼ ë°°ì†¡ëœ ì£¼ë¬¸-30 ì¼',0),(530516,14737,'he','×œ××—×¨×•× ×” ×©× ×©×œ×—×” ×”×–×ž× ×•×ª - 30 ×™×ž×™×',0),(530517,14737,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î± Î¼ÎµÏ„Î±Ï†Î­ÏÎ¿Î½Ï„Î±Î¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ - 30 Î·Î¼Î­ÏÎµÏ‚',0),(530518,14737,'zh','æœ€è¿‘å‘è´§çš„è®¢å•-30 å¤©',0),(530519,14737,'sv','Nyligen levererade order - 30 dagar',0),(530520,14737,'it','Recentemente spediti ordini - 30 giorni',0),(530521,14737,'tl','',0),(530522,14737,'th','à¹€à¸žà¸´à¹ˆà¸‡à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ - 30 à¸§à¸±à¸™',0),(530523,14737,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾ à¤†à¤¦à¥‡à¤¶ - 30 à¤¦à¤¿à¤¨',0),(530524,14737,'ms','Tempahan dihantar pesanan - 30 hari',0),(530525,14737,'ar','Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„ØªÙŠ ØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ù…Ø¤Ø®Ø±Ø§-30 ÙŠÙˆÙ…Ø§',0),(530526,14737,'fr','RÃ©cemment livrÃ©s commandes - 30 jours',0),(530527,14737,'jp','æœ€è¿‘å‡ºè·ã•ã‚ŒãŸæ³¨æ–‡ - 30 æ—¥',0),(530528,14737,'pt','Recentemente enviadas ordens - 30 dias',0),(530529,14737,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¾ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð·Ð°ÐºÐ°Ð·Ñ‹ - 30 Ð´Ð½ÐµÐ¹',0),(530530,14737,'es','Recientemente enviadas Ã³rdenes - 30 dÃ­as',0),(530531,14737,'de','KÃ¼rzlich versandten Bestellungen - 30 Tage',0),(530532,14737,'en','Recently Shipped Orders - 30 Days',0),(530533,14738,'is','',0),(530534,14738,'dr','Ø¨Ø§Ù„Ø§ 10 Ù…Ø´ØªØ±ÛŒØ§Ù†',0),(530535,14738,'pr','Ø¨Ø§Ù„Ø§ 10 Ù…Ø´ØªØ±ÛŒØ§Ù†',0),(530536,14738,'tr','En iyi 10 mÃ¼ÅŸteriler',0),(530537,14738,'pl','10 najlepszych klientÃ³w',0),(530538,14738,'bg','Ð¢Ð¾Ð¿ 10 ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(530539,14738,'ur','Ù¹Ø§Ù¾ 10 ØµØ§Ø±ÙÛŒÙ†',0),(530540,14738,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(530541,14738,'vi','Top 10 khÃ¡ch',0),(530542,14738,'af','Top 10 kliÃ«nte',0),(530543,14738,'ro','Top 10 clienÅ£ii',0),(530544,14738,'et','Top 10 hotelli',0),(530545,14738,'si','Top 10 stranke',0),(530546,14738,'ba','Top 10 pelanggan',0),(530547,14738,'nl','Top 10 klanten',0),(530548,14738,'fi','Top 10 hotellia',0),(530549,14738,'no','Topp 10 kunder',0),(530550,14738,'da','Top 10 kunder',0),(530551,14738,'ko','í†± 10 ê³ ê°',0),(530552,14738,'he','×”×¢×œ×™×•×Ÿ 10 ×”×œ×§×•×—×•×ª',0),(530553,14738,'el','Top 10 Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(530554,14738,'zh','åå¤§å®¢æˆ·',0),(530555,14738,'sv','Topp 10 kunder',0),(530556,14738,'it','Top 10 clienti',0),(530557,14738,'tl','',0),(530558,14738,'th','à¸¥à¸¹à¸à¸„à¹‰à¸² 10 à¸­à¸±à¸™à¸”à¸±à¸š',0),(530559,14738,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(530560,14738,'ms','Top 10 pelanggan',0),(530561,14738,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¹Ù…Ù„Ø§Ø¡',0),(530562,14738,'fr','Top 10 clients',0),(530563,14738,'jp','é¡§å®¢ãƒˆãƒƒãƒ— 10',0),(530564,14738,'pt','Top 10 clientes',0),(530565,14738,'ru','Ð¢Ð¾Ð¿ 10 ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(530566,14738,'es','Top 10 clientes',0),(530567,14738,'de','Kunden, die Top-10',0),(530568,14738,'en','Top 10 Customers',0),(530569,14739,'is','',0),(530570,14739,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ù†Ø²Ø¯ÛŒÚ©ÛŒ Ùˆ ÛŒØ§ Ø¨ÛŒØ´ Ø§Ø² Ù…ÙˆØ¹Ø¯ ØªØ§Ø±ÛŒØ®',0),(530571,14739,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ù†Ø²Ø¯ÛŒÚ©ÛŒ Ùˆ ÛŒØ§ Ø¨ÛŒØ´ Ø§Ø² Ù…ÙˆØ¹Ø¯ ØªØ§Ø±ÛŒØ®',0),(530572,14739,'tr','Emri yakÄ±n veya vade tarihi',0),(530573,14739,'pl','Data zamÃ³wienia w pobliÅ¼u lub nad naleÅ¼ytym',0),(530574,14739,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð±Ð»Ð¸Ð·Ð¾ Ð´Ð¾ Ð¸Ð»Ð¸ Ð½Ð°Ð´ Ð¿Ð¾Ñ€Ð°Ð´Ð¸ Ð´Ð°Ñ‚Ð°',0),(530575,14739,'ur','ØªØ§Ø±ÛŒØ® Ù…Ù‚Ø±Ø±Û Ù¾Ø± ÛŒØ§ Ø§Ø³ Ú©Û’ Ù‚Ø±ÛŒØ¨ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(530576,14739,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ Ñƒ Ð±Ð»Ð¸Ð·Ð¸Ð½Ð¸ Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐºÐ¾ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(530577,14739,'vi','ÄÆ¡n Ä‘áº·t hÃ ng gáº§n trá»Ÿ lÃªn do ngÃ y',0),(530578,14739,'af','Bestellings naby of oor die verskuldigde datum',0),(530579,14739,'ro','Comenzi lÃ¢ngÄƒ sau peste cuvenit data',0),(530580,14739,'et','Tellimuste lÃ¤hedal vÃµi tÃ¤htaja Ã¼letanud kuupÃ¤ev',0),(530581,14739,'si','Datum naroÄila v bliÅ¾ini ali zapadle',0),(530582,14739,'ba','Pesanan di dekat atau berakhir karena tanggal',0),(530583,14739,'nl','Bestellingen in de buurt van of Over tijd datum',0),(530584,14739,'fi','LÃ¤hellÃ¤ tai yli, koska pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(530585,14739,'no','Ordrer i nÃ¦rheten eller forfalte dato',0),(530586,14739,'da','Ordrer i nÃ¦rheden af eller Over Due dato',0),(530587,14739,'ko','ê·¼ì²˜ ë˜ëŠ” ê¸°í•œì— ì£¼ë¬¸ ë‚ ì§œ',0),(530588,14739,'he','×”×–×ž× ×•×ª ×œ×™×“ ××• ×¤×’ ×ª××¨×™×š',0),(530589,14739,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î® Î´ÎµÏŒÎ½Ï„Ï‰Ï‚ Ï€Î»Î·ÏƒÎ¯Î¿Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(530590,14739,'zh','è®¢å•æŽ¥è¿‘æˆ–è¶…è¿‡åˆ°æœŸæ—¥æœŸ',0),(530591,14739,'sv','Order nÃ¤ra eller Ã¶ver vederbÃ¶rlig datum',0),(530592,14739,'it','Ordini vicino o sopra la scadenza Data',0),(530593,14739,'tl','',0),(530594,14739,'th','à¸ªà¸±à¹ˆà¸‡à¹ƒà¸à¸¥à¹‰ à¸«à¸£à¸·à¸­à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™',0),(530595,14739,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤ªà¤¾à¤¸ à¤¯à¤¾ à¤¨à¤¿à¤¯à¤¤ à¤ªà¤° à¤¤à¤¾à¤°à¥€à¤–',0),(530596,14739,'ms','Perintah-perintah yang berhampiran atau di atas disebabkan oleh tarikh',0),(530597,14739,'ar','Ø­ØªÙ‰ Ø§Ù„Ø¢Ù† Ø£ÙˆØ§Ù…Ø± Ø¨Ø§Ù„Ù‚Ø±Ø¨ØŒ Ø£Ùˆ Ø¹Ù„Ù‰ Ø§Ù„Ù†Ø­Ùˆ Ø§Ù„ÙˆØ§Ø¬Ø¨',0),(530598,14739,'fr','Commandes proximitÃ© ou au-dessus de Due Date',0),(530599,14739,'jp','æ³¨æ–‡æœŸé™ä»¥ä¸Šã«è¿‘ã„æ—¥ä»˜',0),(530600,14739,'pt','Ordens perto ou sobre devida Data',0),(530601,14739,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð²Ð±Ð»Ð¸Ð·Ð¸ Ð¸Ð»Ð¸ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð´Ð°Ñ‚Ñ‹',0),(530602,14739,'es','Ã“rdenes cerca o sobre debida fecha',0),(530603,14739,'de','Bestellungen in der NÃ¤he oder Ã¼ber Due Date',0),(530604,14739,'en','Orders Near Or Over Due Date',0),(530605,14740,'is','',0),(530606,14740,'dr','Ø¨Ø§Ø² Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(530607,14740,'pr','Ø¨Ø§Ø² Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(530608,14740,'tr','AÃ§Ä±k tÄ±rnak',0),(530609,14740,'pl','OtwÃ³rz cudzysÅ‚Ã³w',0),(530610,14740,'bg','ÐžÑ‚Ð²Ð¾Ñ€Ð¸ ÐºÐ°Ð²Ð¸Ñ‡ÐºÐ¸',0),(530611,14740,'ur','Ú©Ú¾Ù„ÛŒ ÙˆØ§ÙˆÛŒÙ†',0),(530612,14740,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(530613,14740,'vi','Má»Ÿ bÃ¡o giÃ¡',0),(530614,14740,'af','Oop aanhalings',0),(530615,14740,'ro','Deschidere ghilimele',0),(530616,14740,'et','Avatud hinnapakkumistele',0),(530617,14740,'si','Odprte ponudbe',0),(530618,14740,'ba','Terbuka Penawaran',0),(530619,14740,'nl','Open Quotes',0),(530620,14740,'fi','Avoimet tarjoukset',0),(530621,14740,'no','Ã…pne tilbud',0),(530622,14740,'da','Ã…bne tilbud',0),(530623,14740,'ko','ì˜¤í”ˆ ë”°ì˜´í‘œ',0),(530624,14740,'he','×¤×ª×•×— ×œ×”×¦×¢×•×ª ×ž×—×™×¨',0),(530625,14740,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬ Î±Î½Î¿Î¯Î³Î¼Î±Ï„Î¿Ï‚',0),(530626,14740,'zh','å·¦å¼•å·',0),(530627,14740,'sv','Ã–ppna offerter',0),(530628,14740,'it','Aperte virgolette',0),(530629,14740,'tl','',0),(530630,14740,'th','à¹€à¸›à¸´à¸”à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(530631,14740,'hi','à¤–à¥à¤²à¤¾ à¤‰à¤¦à¥à¤§à¤°à¤£',0),(530632,14740,'ms','Sebut harga dibuka',0),(530633,14740,'ar','ÙØªØ­ Ø¹Ø±ÙˆØ¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(530634,14740,'fr','Citations ouvertes',0),(530635,14740,'jp','é–‹ãã‚¯ã‚ªãƒ¼ãƒˆ',0),(530636,14740,'pt','CotaÃ§Ãµes abertas',0),(530637,14740,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚ÑŒ ÐºÐ°Ð²Ñ‹Ñ‡ÐºÐ¸',0),(530638,14740,'es','Presupuestos abiertos',0),(530639,14740,'de','Offene Angebote',0),(530640,14740,'en','Open Quotes',0),(530641,14741,'is','',0),(530642,14741,'dr','Ù„ÙˆØ§ÛŒØ­ Ø¬Ù„Ø¯ - 1 Ø³Ø§Ù„',0),(530643,14741,'pr','Ù„ÙˆØ§ÛŒØ­ Ø¬Ù„Ø¯ - 1 Ø³Ø§Ù„',0),(530644,14741,'tr','Elektrik faturalarÄ±nÄ± Cilt - 1 yÄ±l',0),(530645,14741,'pl','Rachunki wielkoÅ›ci - 1 rok',0),(530646,14741,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð¾Ð±ÐµÐ¼ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(530647,14741,'ur','ØµÙˆØª - 1 Ø³Ø§Ù„ Ú©Û’ Ø¨Ù„',0),(530648,14741,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸Ñ†Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(530649,14741,'vi','HÃ³a Ä‘Æ¡n khá»‘i lÆ°á»£ng â€“ 1 nÄƒm',0),(530650,14741,'af','Rekeninge Volume - 1 jaar',0),(530651,14741,'ro','Facturile de volum - 1 an',0),(530652,14741,'et','Arved maht - 1 aasta',0),(530653,14741,'si','RaÄuni glasnost - 1 leto',0),(530654,14741,'ba','Tagihan Volume - 1 tahun',0),(530655,14741,'nl','Facturen Volume - 1 jaar',0),(530656,14741,'fi','Laskut Volume - 1 vuosi',0),(530657,14741,'no','Regninger volum - 1 Ã¥r',0),(530658,14741,'da','Regninger volumen - 1 Ã¥r',0),(530659,14741,'ko','ì²­êµ¬ì„œì˜ ë³¼ë¥¨-1 ë…„',0),(530660,14741,'he','×—×©×‘×•× ×•×ª ××—×¡×•×Ÿ - 1 ×©× ×”',0),(530661,14741,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï„ÏŒÎ¼Î¿Ï‚ - 1 Î­Ï„Î¿Ï‚',0),(530662,14741,'zh','ç¥¨æ®å·-1 å¹´',0),(530663,14741,'sv','RÃ¤kningar volym - 1 Ã¥r',0),(530664,14741,'it','Bollette Volume - 1 anno',0),(530665,14741,'tl','',0),(530666,14741,'th','à¸•à¸±à¹‹à¸§ 1 à¸›à¸µ - à¸£à¸°à¸”à¸±à¸šà¹€à¸ªà¸µà¸¢à¸‡',0),(530667,14741,'hi','à¤–à¤‚à¤¡ - 1 à¤¸à¤¾à¤² à¤•à¥‡ à¤¬à¤¿à¤²',0),(530668,14741,'ms','Bil Volume - 1 tahun',0),(530669,14741,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªØ®Ø²ÙŠÙ†-Ø³Ù†Ø© 1',0),(530670,14741,'fr','Bons du Volume - 1 an',0),(530671,14741,'jp','ãƒœãƒªãƒ¥ãƒ¼ãƒ  - 1 å¹´ã‚’æ‰‹å½¢ã—ã¾ã™ã€‚',0),(530672,14741,'pt','Contas Volume - 1 ano',0),(530673,14741,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¾Ð±ÑŠÐµÐ¼ - 1 Ð³Ð¾Ð´',0),(530674,14741,'es','Cuentas volumen - 1 aÃ±o',0),(530675,14741,'de','Rechnungen Volume - 1 Jahr',0),(530676,14741,'en','Bills Volume - 1 Year',0),(530677,14742,'is','',0),(530678,14742,'dr','Ù„ÙˆØ§ÛŒØ­ Ø¬Ù„Ø¯ - 1 Ù‡ÙØªÙ‡',0),(530679,14742,'pr','Ù„ÙˆØ§ÛŒØ­ Ø¬Ù„Ø¯ - 1 Ù‡ÙØªÙ‡',0),(530680,14742,'tr','Cilt - 1 hafta faturalarÄ±',0),(530681,14742,'pl','Rachunki Tom - 1 tydzieÅ„',0),(530682,14742,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð·Ð° Ð¾Ð±ÐµÐ¼ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(530683,14742,'ur','ØµÙˆØª - 1 ÛÙØªÛ Ú©Û’ Ø¨Ù„',0),(530684,14742,'sr','ÐÐ¾Ð²Ñ‡Ð°Ð½Ð¸Ñ†Ðµ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ðµ',0),(530685,14742,'vi','HÃ³a Ä‘Æ¡n khá»‘i lÆ°á»£ng - 1 tuáº§n',0),(530686,14742,'af','Rekeninge Volume - 1 Week',0),(530687,14742,'ro','Facturile de volum - 1 sÄƒptÄƒmÃ¢nÄƒ',0),(530688,14742,'et','Arved maht - 2 nÃ¤dalat',0),(530689,14742,'si','RaÄuni glasnost - 1 teden',0),(530690,14742,'ba','Tagihan Volume - 1 minggu',0),(530691,14742,'nl','Facturen Volume - 1 Week',0),(530692,14742,'fi','Laskut Volume - 1 viikko',0),(530693,14742,'no','Regninger volum - 1 uke',0),(530694,14742,'da','Regninger volumen - 1 uge',0),(530695,14742,'ko','ì²­êµ¬ì„œì˜ ë³¼ë¥¨-1 ì£¼',0),(530696,14742,'he','×—×©×‘×•× ×•×ª ××—×¡×•×Ÿ - ×©×‘×•×¢ 1',0),(530697,14742,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï„ÏŒÎ¼Î¿Ï‚ - 1 ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(530698,14742,'zh','ç¥¨æ®å·-1 å‘¨',0),(530699,14742,'sv','RÃ¤kningar volym - 1 vecka',0),(530700,14742,'it','Bollette Volume - 1 settimana',0),(530701,14742,'tl','',0),(530702,14742,'th','à¸•à¸±à¹‹à¸§à¸›à¸£à¸´à¸¡à¸²à¸•à¸£ - 1 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(530703,14742,'hi','à¤–à¤‚à¤¡ - 1 à¤¹à¤«à¥à¤¤à¥‡ à¤•à¥‡ à¤¬à¤¿à¤²',0),(530704,14742,'ms','Bil Volume - 1 minggu',0),(530705,14742,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªØ®Ø²ÙŠÙ†-Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ 1',0),(530706,14742,'fr','Bons du Volume - 1 semaine',0),(530707,14742,'jp','ãƒœãƒªãƒ¥ãƒ¼ãƒ  - 1 é€±é–“ã‚’æ³•æ¡ˆã—ã¾ã™ã€‚',0),(530708,14742,'pt','Contas Volume - 1 semana',0),(530709,14742,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¾Ð±ÑŠÐµÐ¼ - 1 Ð½ÐµÐ´ÐµÐ»Ñ',0),(530710,14742,'es','Cuentas volumen - 1 semana',0),(530711,14742,'de','Rechnungen Volume - 1 Woche',0),(530712,14742,'en','Bills Volume - 1 Week',0),(530713,14743,'is','',0),(530714,14743,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø§Ø®ÛŒØ± Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ - 1 Ù…Ø§Ù‡',0),(530715,14743,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø§Ø®ÛŒØ± Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ - 1 Ù…Ø§Ù‡',0),(530716,14743,'tr','Son kontroller yazÄ±lÄ± - 1 ay',0),(530717,14743,'pl','Ostatnich kontroli pisemnej - 1 miesiÄ…c',0),(530718,14743,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¿Ð¸ÑÐ¼ÐµÐ½Ð¾ - 1 Ð¼ÐµÑÐµÑ†',0),(530719,14743,'ur','ØªØ­Ø±ÛŒØ± - Ø­Ø§Ù„ÛŒÛ Ú†ÛŒÚ© 1 Ù…ÛÛŒÙ†Û’',0),(530720,14743,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾ - 1 Ð¼ÐµÑÐµÑ†',0),(530721,14743,'vi','Kiá»ƒm tra táº¡i viáº¿t lÆ°u - 1 thÃ¡ng',0),(530722,14743,'af','Onlangse ondersoeke geskryf - 1 maand',0),(530723,14743,'ro','Controale recente scris - 1 luna',0),(530724,14743,'et','Tehtud kontrollide kirjutada - 1 kuu',0),(530725,14743,'si','Nedavni pregledi koncu - 1 mesec',0),(530726,14743,'ba','Tanggal cek ditulis - 1 bulan',0),(530727,14743,'nl','Recente controles geschreven - 1 maand',0),(530728,14743,'fi','Viime tarkastuksia kirjoitettu - 1 kuukausi',0),(530729,14743,'no','Siste sjekker skrevet - 1 mÃ¥ned',0),(530730,14743,'da','Seneste kontrol skrevet - 1 mÃ¥ned',0),(530731,14743,'ko','ìµœê·¼ ê²€ì‚¬-1 ê°œì›”',0),(530732,14743,'he','×”×ž×—××•×ª ×”××—×¨×•× ×•×ª × ×›×ª×‘ - 1 ×—×•×“×©',0),(530733,14743,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Î³ÏÎ±Ï€Ï„Î® - 1 Î¼Î®Î½Î±',0),(530734,14743,'zh','æœ€è¿‘çš„æ£€æŸ¥å†™-1 ä¸ªæœˆ',0),(530735,14743,'sv','De senaste kontrollerna skrivit - 1 mÃ¥nad',0),(530736,14743,'it','Recenti controlli scritti - 1 mese',0),(530737,14743,'tl','',0),(530738,14743,'th','à¸¥à¹ˆà¸²à¸ªà¸¸à¸”à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹€à¸‚à¸µà¸¢à¸™ - 1 à¹€à¸”à¸·à¸­à¸™',0),(530739,14743,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤²à¤¿à¤–à¤¾ - à¤šà¥‡à¤•, 1 à¤®à¤¹à¥€à¤¨à¥‡',0),(530740,14743,'ms','Semalam cek ditulis - 1 bulan',0),(530741,14743,'ar','Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø© Ù…ÙƒØªÙˆØ¨-Ø´Ù‡Ø± 1',0),(530742,14743,'fr','Ces derniers chÃ¨ques Ã©mis - 1 mois',0),(530743,14743,'jp','æœ€è¿‘ã®å°åˆ‡æ‰‹ - 1 ãƒ¶æœˆ',0),(530744,14743,'pt','Ãšltimos cheques escritos - 1 mÃªs',0),(530745,14743,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾ - 1 Ð¼ÐµÑÑÑ†',0),(530746,14743,'es','Ãšltimos cheques escritos - 1 mes',0),(530747,14743,'de','Den letzten PrÃ¼fungen geschrieben - 1 Monat',0),(530748,14743,'en','Recent Checks Written - 1 Month',0),(530749,14744,'is','',0),(530750,14744,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø§Ø®ÛŒØ± Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ - 1 Ù‡ÙØªÙ‡',0),(530751,14744,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø§Ø®ÛŒØ± Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ - 1 Ù‡ÙØªÙ‡',0),(530752,14744,'tr','Son kontroller yazÄ±lÄ± - 1 hafta',0),(530753,14744,'pl','Ostatnich kontroli pisemnej - 1 tydzieÅ„',0),(530754,14744,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¿Ð¸ÑÐ¼ÐµÐ½Ð¾ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(530755,14744,'ur','ØªØ­Ø±ÛŒØ± - Ø­Ø§Ù„ÛŒÛ Ú†ÛŒÚ© 1 ÛÙØªÛ',0),(530756,14744,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ñ‡ÐµÐºÐ¾Ð²Ðµ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ðµ',0),(530757,14744,'vi','Kiá»ƒm tra táº¡i viáº¿t lÆ°u - 1 tuáº§n',0),(530758,14744,'af','Onlangse ondersoeke geskryf - 1 Week',0),(530759,14744,'ro','Controale recente scris - 1 sÄƒptÄƒmÃ¢nÄƒ',0),(530760,14744,'et','Tehtud kontrollide kirjutada - 1 nÃ¤dal',0),(530761,14744,'si','Nedavni pregledi koncu - 1 teden',0),(530762,14744,'ba','Tanggal cek ditulis - 1 minggu',0),(530763,14744,'nl','Recente controles geschreven - 1 Week',0),(530764,14744,'fi','Viime tarkastuksia kirjoitettu - 1 viikko',0),(530765,14744,'no','Siste sjekker skrevet - 1 uke',0),(530766,14744,'da','Seneste kontrol skrevet - 1 uge',0),(530767,14744,'ko','ìµœê·¼ ê²€ì‚¬-1 ì£¼',0),(530768,14744,'he','×”×ž×—××•×ª ×”××—×¨×•× ×•×ª × ×›×ª×‘ - ×©×‘×•×¢ 1',0),(530769,14744,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚ Î³ÏÎ±Ï€Ï„Î® - 1 ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(530770,14744,'zh','æœ€è¿‘çš„æ£€æŸ¥ä¹¦é¢-1 å‘¨',0),(530771,14744,'sv','De senaste kontrollerna skrivit - 1 vecka',0),(530772,14744,'it','Recenti controlli scritti - 1 settimana',0),(530773,14744,'tl','',0),(530774,14744,'th','à¸¥à¹ˆà¸²à¸ªà¸¸à¸”à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹€à¸‚à¸µà¸¢à¸™ - 1 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(530775,14744,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤²à¤¿à¤–à¤¾ - à¤šà¥‡à¤•, 1 à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(530776,14744,'ms','Semalam cek ditulis - 1 minggu',0),(530777,14744,'ar','Ø§Ù„Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø© ÙƒØªØ¨-Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ 1',0),(530778,14744,'fr','Ces derniers chÃ¨ques Ã©mis - 1 semaine',0),(530779,14744,'jp','æœ€è¿‘ã®å°åˆ‡æ‰‹ - 1 é€±',0),(530780,14744,'pt','Ãšltimos cheques escritos - 1 semana',0),(530781,14744,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð½Ð°Ð¿Ð¸ÑÐ°Ð½Ð¾ - 1 Ð½ÐµÐ´ÐµÐ»Ñ',0),(530782,14744,'es','Ãšltimos cheques escritos - 1 semana',0),(530783,14744,'de','Den letzten PrÃ¼fungen geschrieben - 1 Woche',0),(530784,14744,'en','Recent Checks Written - 1 Week',0),(530785,14745,'is','',0),(530786,14745,'dr','Ø¨Ø§Ù„Ø§ Ø¯Ù„Ø§Ø± ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† - 1 Ù…Ø§Ù‡',0),(530787,14745,'pr','Ø¨Ø§Ù„Ø§ Ø¯Ù„Ø§Ø± ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† - 1 Ù…Ø§Ù‡',0),(530788,14745,'tr','Ãœst dolar satÄ±cÄ±larÄ± - 1 ay',0),(530789,14745,'pl','Szczyt Dolar dostawcÃ³w - 1 miesiÄ…c',0),(530790,14745,'bg','Ð¢Ð¾Ð¿ Ð´Ð¾Ð»Ð°Ñ€ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ - 1 Ð¼ÐµÑÐµÑ†',0),(530791,14745,'ur','Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± ÚˆØ§Ù„Ø± Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº - 1 Ù…ÛÛŒÙ†Û’',0),(530792,14745,'sr','Ð’Ñ€Ñ…ÑƒÐ½ÑÐºÐ¸ Ð´Ð¾Ð»Ð°Ñ€ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ - 1 Ð¼ÐµÑÐµÑ†',0),(530793,14745,'vi','ÄÃ´-la hÃ ng Ä‘áº§u nhÃ  cung cáº¥p - 1 thÃ¡ng',0),(530794,14745,'af','Top Dollar verkopers - 1 maand',0),(530795,14745,'ro','Top Dolar furnizori - 1 luna',0),(530796,14745,'et','Top Dollar mÃ¼Ã¼jad - 1 kuu',0),(530797,14745,'si','Top dolar prodajalci - 1 mesec',0),(530798,14745,'ba','Atas dolar vendor - 1 bulan',0),(530799,14745,'nl','Top Dollar leveranciers - 1 maand',0),(530800,14745,'fi','Alkuun dollari toimittajat - 1 kuukausi',0),(530801,14745,'no','Topp Dollar leverandÃ¸rer - 1 mÃ¥ned',0),(530802,14745,'da','Top Dollar leverandÃ¸rer - 1 mÃ¥ned',0),(530803,14745,'ko','ìµœê³  ë‹¬ëŸ¬ ê³µê¸‰ ì—…ì²´-1 ê°œì›”',0),(530804,14745,'he','×¡×¤×§×™× ×ž×•×‘×™×œ×™× ×“×•×œ×¨ - 1 ×—×•×“×©',0),(530805,14745,'el','ÎšÎ¿ÏÏ…Ï†Î±Î¯Î¿ Î´Î¿Î»Î¬ÏÎ¹Î¿ Ï€Ï‰Î»Î·Ï„Î­Ï‚ - 1 Î¼Î®Î½Î±',0),(530806,14745,'zh','é¡¶çº§ç¾Žå…ƒä¾›åº”å•† â€” â€” 1 ä¸ªæœˆ',0),(530807,14745,'sv','Top Dollar leverantÃ¶rer - 1 mÃ¥nad',0),(530808,14745,'it','Top Dollar fornitori - 1 mese',0),(530809,14745,'tl','',0),(530810,14745,'th','à¸”à¸­à¸¥à¸¥à¸²à¸£à¹Œ à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢ - 1 à¹€à¸”à¸·à¸­à¸™',0),(530811,14745,'hi','à¤¶à¥€à¤°à¥à¤· à¤¡à¥‰à¤²à¤° à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ - 1 à¤®à¤¹à¥€à¤¨à¤¾',0),(530812,14745,'ms','Atas dolar vendor - 1 bulan',0),(530813,14745,'ar','Ø£Ø¹Ù„Ù‰ Ø§Ù„Ø¯ÙˆÙ„Ø§Ø± Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ†-Ø´Ù‡Ø± 1',0),(530814,14745,'fr','Principaux fournisseurs de Dollar - 1 mois',0),(530815,14745,'jp','ãƒˆãƒƒãƒ— ãƒ‰ãƒ« ãƒ™ãƒ³ãƒ€ãƒ¼ - 1 ãƒ¶æœˆ',0),(530816,14745,'pt','Principais fornecedores de dÃ³lar - 1 mÃªs',0),(530817,14745,'ru','Ð¢Ð¾Ð¿ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»Ð¸ Ð´Ð¾Ð»Ð»Ð°Ñ€ - 1 Ð¼ÐµÑÑÑ†',0),(530818,14745,'es','Principales proveedores de dÃ³lar - 1 mes',0),(530819,14745,'de','Top Dollar Anbieter - 1 Monat',0),(530820,14745,'en','Top Dollar Vendors - 1 Month',0),(530821,14746,'is','',0),(530822,14746,'dr','Ø¨Ø§Ù„Ø§ Ø¯Ù„Ø§Ø± ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† - 1 Ø³Ø§Ù„',0),(530823,14746,'pr','Ø¨Ø§Ù„Ø§ Ø¯Ù„Ø§Ø± ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† - 1 Ø³Ø§Ù„',0),(530824,14746,'tr','Ãœst dolar satÄ±cÄ±larÄ± - 1 yÄ±l',0),(530825,14746,'pl','Szczyt Dolar dostawcÃ³w - 1 rok',0),(530826,14746,'bg','Ð¢Ð¾Ð¿ Ð´Ð¾Ð»Ð°Ñ€ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(530827,14746,'ur','Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± ÚˆØ§Ù„Ø± Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº - 1 Ø³Ø§Ù„',0),(530828,14746,'sr','Ð’Ñ€Ñ…ÑƒÐ½ÑÐºÐ¸ Ð´Ð¾Ð»Ð°Ñ€ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ - 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(530829,14746,'vi','ÄÃ´-la hÃ ng Ä‘áº§u nhÃ  cung cáº¥p - 1 nÄƒm',0),(530830,14746,'af','Top Dollar verkopers - 1 jaar',0),(530831,14746,'ro','Top Dolar furnizori - 1 an',0),(530832,14746,'et','Top Dollar mÃ¼Ã¼jad - 1 aasta',0),(530833,14746,'si','Top dolar prodajalci - 1 leto',0),(530834,14746,'ba','Atas dolar vendor - 1 tahun',0),(530835,14746,'nl','Top Dollar leveranciers - 1 jaar',0),(530836,14746,'fi','Alkuun dollari toimittajat - 1 vuosi',0),(530837,14746,'no','Topp Dollar leverandÃ¸rer - 1 Ã¥r',0),(530838,14746,'da','Top Dollar leverandÃ¸rer - 1 Ã¥r',0),(530839,14746,'ko','ìµœê³  ë‹¬ëŸ¬ ê³µê¸‰ ì—…ì²´-1 ë…„',0),(530840,14746,'he','×¡×¤×§×™× ×ž×•×‘×™×œ×™× ×“×•×œ×¨ - 1 ×©× ×”',0),(530841,14746,'el','ÎšÎ¿ÏÏ…Ï†Î±Î¯Î¿ Î´Î¿Î»Î¬ÏÎ¹Î¿ Ï€Ï‰Î»Î·Ï„Î­Ï‚ - 1 Î­Ï„Î¿Ï‚',0),(530842,14746,'zh','é¡¶çº§ç¾Žå…ƒä¾›åº”å•†-1 å¹´',0),(530843,14746,'sv','Top Dollar leverantÃ¶rer - 1 Ã¥r',0),(530844,14746,'it','Top Dollar fornitori - 1 anno',0),(530845,14746,'tl','',0),(530846,14746,'th','à¸”à¸­à¸¥à¸¥à¸²à¸£à¹Œ à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢ - 1 à¸›à¸µ',0),(530847,14746,'hi','à¤¶à¥€à¤°à¥à¤· à¤¡à¥‰à¤²à¤° à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ - 1 à¤¸à¤¾à¤²',0),(530848,14746,'ms','Atas dolar vendor - 1 tahun',0),(530849,14746,'ar','Ø£Ø¹Ù„Ù‰ Ø§Ù„Ø¯ÙˆÙ„Ø§Ø± Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ†-Ø³Ù†Ø© 1',0),(530850,14746,'fr','Principaux fournisseurs de Dollar - 1 an',0),(530851,14746,'jp','ãƒˆãƒƒãƒ— ãƒ‰ãƒ« ãƒ™ãƒ³ãƒ€ãƒ¼ - 1 å¹´',0),(530852,14746,'pt','Principais fornecedores de dÃ³lar - 1 ano',0),(530853,14746,'ru','Ð¢Ð¾Ð¿ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»Ð¸ Ð´Ð¾Ð»Ð»Ð°Ñ€ - 1 Ð³Ð¾Ð´',0),(530854,14746,'es','Principales proveedores de dÃ³lar - 1 aÃ±o',0),(530855,14746,'de','Top Dollar Anbieter - 1 Jahr',0),(530856,14746,'en','Top Dollar Vendors - 1 Year',0),(530857,14747,'is','',0),(530858,14747,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¯Ù„Ø§Ø± Ø¨Ø§Ù„Ø§',0),(530859,14747,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¯Ù„Ø§Ø± Ø¨Ø§Ù„Ø§',0),(530860,14747,'tr','Ãœst dolar satÄ±cÄ±lar',0),(530861,14747,'pl','Szczyt Dolar dostawcÃ³w',0),(530862,14747,'bg','Ð¢Ð¾Ð¿ Ð´Ð¾Ð»Ð°Ñ€ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(530863,14747,'ur','Ø³Ø¨ Ø³Û’ Ø§ÙˆÙ¾Ø± ÚˆØ§Ù„Ø± Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº',0),(530864,14747,'sr','Ð’Ñ€Ñ…ÑƒÐ½ÑÐºÐ¸ Ð´Ð¾Ð»Ð°Ñ€ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(530865,14747,'vi','Top Dollar nhÃ  cung cáº¥p',0),(530866,14747,'af','Top Dollar verkopers',0),(530867,14747,'ro','Top Dolar furnizori',0),(530868,14747,'et','Top Dollar mÃ¼Ã¼jad',0),(530869,14747,'si','Top dolar prodajalci',0),(530870,14747,'ba','Atas dolar vendor',0),(530871,14747,'nl','Top Dollar leveranciers',0),(530872,14747,'fi','Top dollarin myyjiÃ¤',0),(530873,14747,'no','Topp Dollar leverandÃ¸rer',0),(530874,14747,'da','Top Dollar leverandÃ¸rer',0),(530875,14747,'ko','ìµœê³  ë‹¬ëŸ¬ ê³µê¸‰ ì—…ì²´',0),(530876,14747,'he','×¡×¤×§×™× ×ž×•×‘×™×œ×™× ×“×•×œ×¨',0),(530877,14747,'el','ÎšÎ¿ÏÏ…Ï†Î±Î¯Î¿ Î´Î¿Î»Î¬ÏÎ¹Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚',0),(530878,14747,'zh','é¡¶çº§ç¾Žå…ƒä¾›åº”å•†',0),(530879,14747,'sv','Top Dollar leverantÃ¶rer',0),(530880,14747,'it','Top Dollar fornitori',0),(530881,14747,'tl','',0),(530882,14747,'th','à¸”à¸­à¸¥à¸¥à¸²à¸£à¹Œ à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(530883,14747,'hi','à¤¶à¥€à¤°à¥à¤· à¤¡à¥‰à¤²à¤° à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(530884,14747,'ms','Atas dolar vendor',0),(530885,14747,'ar','Ø£Ø¹Ù„Ù‰ Ø§Ù„Ø¯ÙˆÙ„Ø§Ø± Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ†',0),(530886,14747,'fr','Principaux fournisseurs de Dollar',0),(530887,14747,'jp','ãƒˆãƒƒãƒ— ãƒ‰ãƒ« ãƒ™ãƒ³ãƒ€ãƒ¼',0),(530888,14747,'pt','Principais fornecedores de dÃ³lar',0),(530889,14747,'ru','Ð¢Ð¾Ð¿ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»Ð¸ Ð´Ð¾Ð»Ð»Ð°Ñ€',0),(530890,14747,'es','Principales proveedores de dÃ³lar',0),(530891,14747,'de','Top Dollar-Anbieter',0),(530892,14747,'en','Top Dollar Vendors',0),(530893,14748,'is','',0),(530894,14748,'dr','Ù†Ø±Ø® ØªØºÛŒÛŒØ±Ø§Øª Ø§Ø®ÛŒØ± Ù¾Ø±Ø¯Ø§Ø®Øª - 1 Ù‡ÙØªÙ‡',0),(530895,14748,'pr','Ù†Ø±Ø® ØªØºÛŒÛŒØ±Ø§Øª Ø§Ø®ÛŒØ± Ù¾Ø±Ø¯Ø§Ø®Øª - 1 Ù‡ÙØªÙ‡',0),(530896,14748,'tr','Son Ã¶deme oranÄ± deÄŸiÅŸiklikleri - 1 hafta',0),(530897,14748,'pl','Ostatnie zmiany stawki pÅ‚ac - 1 tydzieÅ„',0),(530898,14748,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(530899,14748,'ur','Ø­Ø§Ù„ÛŒÛ ØªÙ†Ø®ÙˆØ§Û Ú©ÛŒ Ø´Ø±Ø­ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº - 1 ÛÙØªÛ',0),(530900,14748,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ð¿Ð»Ð°Ñ‚Ðµ ÑÑ‚Ð¾Ð¿Ð° Ð¿Ñ€Ð¾Ð¼Ñ˜ÐµÐ½Ðµ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ðµ',0),(530901,14748,'vi','Thay Ä‘á»•i gáº§n Ä‘Ã¢y tá»· lá»‡ tráº£ tiá»n - 1 tuáº§n',0),(530902,14748,'af','Onlangse betaal koers veranderings - 1 Week',0),(530903,14748,'ro','SchimbÄƒri recente plata rata - 1 sÄƒptÄƒmÃ¢nÄƒ',0),(530904,14748,'et','Tehtud makse mÃ¤Ã¤ra muutused - 1 nÃ¤dal',0),(530905,14748,'si','Nedavne spremembe teÄaja Pay - 1 teden',0),(530906,14748,'ba','Perubahan tingkat membayar hari - 1 minggu',0),(530907,14748,'nl','Recente Pay tariefwijzigingen - 1 Week',0),(530908,14748,'fi','Hotelliin maksu muuttuu - 1 viikko',0),(530909,14748,'no','Nylige endringer i lÃ¸nnssatser - 1 uke',0),(530910,14748,'da','Seneste lÃ¸n satsÃ¦ndringer - 1 uge',0),(530911,14748,'ko','ìµœê·¼ ê¸‰ì—¬ ë³€ë™-1 ì£¼',0),(530912,14748,'he','×”×©×™× ×•×™×™× ×”××—×¨×•× ×™× ×©×œ ×©×™×¢×•×¨ ×”×©×›×¨ - ×©×‘×•×¢ 1',0),(530913,14748,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Î±Î»Î»Î±Î³Î­Ï‚ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î±Î¼Î¿Î¹Î²Î®Ï‚ - 1 ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(530914,14748,'zh','æœ€è¿‘å·¥èµ„çŽ‡å˜åŠ¨-1 å‘¨',0),(530915,14748,'sv','Senaste lÃ¶n rÃ¤ntefÃ¶rÃ¤ndringar - 1 vecka',0),(530916,14748,'it','Recenti variazioni dei tassi di paga - 1 settimana',0),(530917,14748,'tl','',0),(530918,14748,'th','à¸¥à¹ˆà¸²à¸ªà¸¸à¸”à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸­à¸±à¸•à¸£à¸²à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡ - 1 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(530919,14748,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤µà¥‡à¤¤à¤¨ à¤¦à¤° à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ - 1 à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(530920,14748,'ms','Perubahan kadar gaji hari - 1 minggu',0),(530921,14748,'ar','Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø© Ù…Ø¹Ø¯Ù„ Ø§Ù„Ø£Ø¬ÙˆØ±-Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ 1',0),(530922,14748,'fr','Changements rÃ©cents de taux de rÃ©munÃ©ration - 1 semaine',0),(530923,14748,'jp','æœ€è¿‘è³ƒé‡‘çŽ‡ã®å¤‰æ›´ 1 é€±é–“',0),(530924,14748,'pt','Recentes alteraÃ§Ãµes de taxa de pagamento - 1 semana',0),(530925,14748,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ ÐºÑƒÑ€ÑÐ° - 1 Ð½ÐµÐ´ÐµÐ»Ñ',0),(530926,14748,'es','Cambios recientes paga tasa - 1 semana',0),(530927,14748,'de','Neuen Pay Ã„nderungen - 1 Woche',0),(530928,14748,'en','Recent Pay Rate Changes - 1 Week',0),(530929,14749,'is','',0),(530930,14749,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ù‡Ø§ÛŒ Ø§Ø®ÛŒØ± - 1 Ù‡ÙØªÙ‡',0),(530931,14749,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ù‡Ø§ÛŒ Ø§Ø®ÛŒØ± - 1 Ù‡ÙØªÙ‡',0),(530932,14749,'tr','Son Ä°ncelemeler - 1 hafta',0),(530933,14749,'pl','Najnowsze Opinie - 1 tydzieÅ„',0),(530934,14749,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¾Ñ‚Ð·Ð¸Ð²Ð¸ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(530935,14749,'ur','Ø­Ø§Ù„ÛŒÛ Ø¬Ø§Ø¦Ø²Û - 1 ÛÙØªÛ',0),(530936,14749,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ñ€ÐµÑ†ÐµÐ½Ð·Ð¸Ñ˜Ðµ - 1 ÑÐµÐ´Ð¼Ð¸Ñ†Ðµ',0),(530937,14749,'vi','Nháº­n xÃ©t táº¡i - 1 tuáº§n',0),(530938,14749,'af','Onlangse resensies - 1 Week',0),(530939,14749,'ro','Ultimele Comentarii - 1 sÄƒptÄƒmÃ¢nÄƒ',0),(530940,14749,'et','VÃ¤rskemad Ã¼levaated - 1 nÃ¤dal',0),(530941,14749,'si','Nedavni pregledi - 1 teden',0),(530942,14749,'ba','Ulasan terakhir - 1 minggu',0),(530943,14749,'nl','De nieuwste Reviews - 1 Week',0),(530944,14749,'fi','Uusimmat arvostelut - 1 viikko',0),(530945,14749,'no','Nyere vurderinger - 1 uke',0),(530946,14749,'da','Seneste anmeldelser - 1 uge',0),(530947,14749,'ko','ìµœê·¼ ë¦¬ë·°-1 ì£¼',0),(530948,14749,'he','×‘×™×§×•×¨×•×ª ××—×¨×•× ×•×ª - ×©×‘×•×¢ 1',0),(530949,14749,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÏƒÏ‡ÏŒÎ»Î¹Î± - 1 ÎµÎ²Î´Î¿Î¼Î¬Î´Î±',0),(530950,14749,'zh','æœ€è¿‘çš„è¯„è®º-1 å‘¨',0),(530951,14749,'sv','Senaste recensioner - 1 vecka',0),(530952,14749,'it','Ultimi commenti dei clienti - 1 settimana',0),(530953,14749,'tl','',0),(530954,14749,'th','à¸£à¸µà¸§à¸´à¸§à¸¥à¹ˆà¸²à¸ªà¸¸à¸” - 1 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(530955,14749,'hi','à¤¹à¤¾à¤² à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾à¤à¤ - 1 à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(530956,14749,'ms','Ulasan hari - 1 minggu',0),(530957,14749,'ar','Ø§Ù„Ø§Ø³ØªØ¹Ø±Ø§Ø¶Ø§Øª Ø§Ù„ØªÙŠ Ø¬Ø±Øª Ù…Ø¤Ø®Ø±Ø§-Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ 1',0),(530958,14749,'fr','Commentaires rÃ©cents - 1 semaine',0),(530959,14749,'jp','æœ€è¿‘ã®ãƒ¬ãƒ“ãƒ¥ãƒ¼ - 1 é€±',0),(530960,14749,'pt','ComentÃ¡rios recentes - semana 1',0),(530961,14749,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¾Ð±Ð·Ð¾Ñ€Ñ‹ - 1 Ð½ÐµÐ´ÐµÐ»Ñ',0),(530962,14749,'es','Comentarios recientes - 1 semana',0),(530963,14749,'de','Aktuelle Bewertungen - 1 Woche',0),(530964,14749,'en','Recent Reviews - 1 Week',0),(530965,14750,'is','',0),(530966,14750,'dr','Ø¨Ø§Ù„Ø§ Ø¯Ù‡ Ú†Ø§Ù¾ Ù…Ø´ØªØ±ÛŒØ§Ù† - 1 Ù…Ø§Ù‡',0),(530967,14750,'pr','Ø¨Ø§Ù„Ø§ Ø¯Ù‡ Ú†Ø§Ù¾ Ù…Ø´ØªØ±ÛŒØ§Ù† - 1 Ù…Ø§Ù‡',0),(530968,14750,'tr','Top 10 baskÄ± mÃ¼ÅŸteriler - 1 ay',0),(530969,14750,'pl','Top Ten druk klientÃ³w - 1 miesiÄ…c',0),(530970,14750,'bg','Ð¢Ð¾Ð¿ Ð´ÐµÑÐµÑ‚ Ð¿ÐµÑ‡Ð°Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ - 1 Ð¼ÐµÑÐµÑ†',0),(530971,14750,'ur','1 Ù…ÛÛŒÙ†Û’ Ø¯Ø³ Ú†Ú¾Ø§Ù¾ÛŒÚº Ú¯Ø§ÛÚ©ÙˆÚº - Ø§ÙˆÙ¾Ø±',0),(530972,14750,'sr','ÐÐ°Ñ˜Ð±Ð¾Ñ™Ð¸ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸ Ð´ÐµÑÐµÑ‚ ÐŸÑ€Ð¸Ð½Ñ‚ - 1 Ð¼ÐµÑÐµÑ†',0),(530973,14750,'vi','Top Ten in khÃ¡ch - 1 thÃ¡ng',0),(530974,14750,'af','Top Tien druk klante - 1 maand',0),(530975,14750,'ro','Top zece Print clienÅ£ii - 1 luna',0),(530976,14750,'et','Top Ten Prindi kÃ¼lastajad - 1 kuu',0),(530977,14750,'si','Top Ten Print strankam - 1 mesec',0),(530978,14750,'ba','Top sepuluh cetak pelanggan - 1 bulan',0),(530979,14750,'nl','Top tien afdrukken klanten - 1 maand',0),(530980,14750,'fi','Top Ten tulosta asiakkaat - 1 kuukausi',0),(530981,14750,'no','Topp ti Print kunder - 1 mÃ¥ned',0),(530982,14750,'da','Top ti Print kunder - 1 mÃ¥ned',0),(530983,14750,'ko','í†± 10 ì¸ì‡„ ê³ ê°-1 ê°œì›”',0),(530984,14750,'he','Top 10 ×”×“×¤×¡×” ×œ×§×•×—×•×ª - 1 ×—×•×“×©',0),(530985,14750,'el','Top Î´Î­ÎºÎ± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ - 1 Î¼Î®Î½Î±',0),(530986,14750,'zh','é¡¶åæ‰“å°å®¢æˆ·-1 ä¸ªæœˆ',0),(530987,14750,'sv','Top Ten Print kunder - 1 mÃ¥nad',0),(530988,14750,'it','Top Ten stampa clienti - 1 mese',0),(530989,14750,'tl','',0),(530990,14750,'th','à¸­à¸±à¸™à¸”à¸±à¸šà¸ªà¸´à¸šà¸žà¸´à¸¡à¸žà¹Œà¸¥à¸¹à¸à¸„à¹‰à¸² - 1 à¹€à¸”à¸·à¸­à¸™',0),(530991,14750,'hi','à¤šà¥‹à¤Ÿà¥€ à¤•à¥‡ à¤¦à¤¸ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ - 1 à¤®à¤¹à¥€à¤¨à¤¾',0),(530992,14750,'ms','Top pelanggan cetak sepuluh - 1 bulan',0),(530993,14750,'ar','ÙƒØ¨Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø·Ø¨Ø§Ø¹Ø© Ø¹Ø´Ø±Ø©-Ø´Ù‡Ø± 1',0),(530994,14750,'fr','Top Print dix clients - 1 mois',0),(530995,14750,'jp','ãƒˆãƒƒãƒ— 10 å°åˆ·é¡§å®¢ - 1 ãƒ¶æœˆ',0),(530996,14750,'pt','Top 10 Print clientes - 1 mÃªs',0),(530997,14750,'ru','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² - 1 Ð¼ÐµÑÑÑ†',0),(530998,14750,'es','Â«InicioÂ» imprimir diez clientes - 1 mes',0),(530999,14750,'de','Top Ten Print Kunden - 1 Monat',0),(531000,14750,'en','Top Ten Print Customers - 1 Month',0),(531001,14751,'is','',0),(531002,14751,'dr','Ø¬Ù„Ø¯ - Ø³ÙØ§Ø±Ø´ 8 Ù‡ÙØªÙ‡',0),(531003,14751,'pr','Ø¬Ù„Ø¯ - Ø³ÙØ§Ø±Ø´ 8 Ù‡ÙØªÙ‡',0),(531004,14751,'tr','Hacim - 8 hafta sipariÅŸ',0),(531005,14751,'pl','ZamÃ³w Tom - 8 tygodni',0),(531006,14751,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð°Ð¹Ñ‚Ðµ Ð¾Ð±ÐµÐ¼ - 8 ÑÐµÐ´Ð¼Ð¸Ñ†Ð¸',0),(531007,14751,'ur','ØµÙˆØª - 8 ÛÙØªÙˆÚº Ú©Ø§ Ø­Ú©Ù…',0),(531008,14751,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½ - 8 Ð½ÐµÐ´ÐµÑ™Ð°',0),(531009,14751,'vi','Äáº·t hÃ ng khá»‘i lÆ°á»£ng - 8 tuáº§n',0),(531010,14751,'af','Bestel Volume - 8 weke',0),(531011,14751,'ro','Comanda volum - 8 sÄƒptÄƒmÃ¢ni',0),(531012,14751,'et','Tellimuse maht - 8 nÃ¤dalat',0),(531013,14751,'si','Naloga obsega - 8 tednov',0),(531014,14751,'ba','Memesan Volume - 8 minggu',0),(531015,14751,'nl','Bestel Volume - 8 weken',0),(531016,14751,'fi','Tilaa Volume - 8 viikkoa',0),(531017,14751,'no','Bestille volum - 8 uker',0),(531018,14751,'da','Bestil volumen - 8 uger',0),(531019,14751,'ko','ì£¼ë¬¸ ì–‘-8 ì£¼',0),(531020,14751,'he','×”×–×ž× ×ª ××—×¡×•×Ÿ - 8 ×©×‘×•×¢×•×ª',0),(531021,14751,'el','Î Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ Î¤ÏŒÎ¼Î¿Ï‚ - 8 ÎµÎ²Î´Î¿Î¼Î¬Î´ÎµÏ‚',0),(531022,14751,'zh','è®¢å•é‡-8 å‘¨',0),(531023,14751,'sv','BestÃ¤ll volym - 8 veckor',0),(531024,14751,'it','Ordinare il Volume - 8 settimane',0),(531025,14751,'tl','',0),(531026,14751,'th','à¸ªà¸±à¹ˆà¸‡à¸›à¸£à¸´à¸¡à¸²à¸“ - 8 à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(531027,14751,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ - 8 à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(531028,14751,'ms','Perintah Volume - 8 minggu',0),(531029,14751,'ar','ØªØ±ØªÙŠØ¨ ÙˆØ­Ø¯Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ†--8 Ø£Ø³Ø§Ø¨ÙŠØ¹',0),(531030,14751,'fr','Commander le Volume - 8 semaines',0),(531031,14751,'jp','æ³¨æ–‡ã®å·» - 8 é€±é–“',0),(531032,14751,'pt','Ordem Volume - 8 semanas',0),(531033,14751,'ru','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾Ð±ÑŠÐµÐ¼ - 8 Ð½ÐµÐ´ÐµÐ»ÑŒ',0),(531034,14751,'es','Orden volumen - 8 semanas',0),(531035,14751,'de','Auftragsvolumen Sie - 8 Wochen',0),(531036,14751,'en','Order Volume - 8 Weeks',0),(531037,14752,'is','',0),(531038,14752,'dr','Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§Ù„Ø§ 10 - 1 Ø³Ø§Ù„',0),(531039,14752,'pr','Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§Ù„Ø§ 10 - 1 Ø³Ø§Ù„',0),(531040,14752,'tr','Ä°lk 10 Ã¶ÄŸe - 1 yÄ±l',0),(531041,14752,'pl','10 najlepszych elementÃ³w - 1 rok',0),(531042,14752,'bg','Ð¢Ð¾Ð¿ 10 ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(531043,14752,'ur','Ù¹Ø§Ù¾ 10 Ø§Ø´ÛŒØ§Ø¡ - 1 Ø³Ø§Ù„',0),(531044,14752,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 ÑÑ‚Ð°Ð²ÐºÐ¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(531045,14752,'vi','Top 10 bÃ i â€“ 1 nÄƒm',0),(531046,14752,'af','Top 10 Items - 1 jaar',0),(531047,14752,'ro','Top 10 articole - 1 an',0),(531048,14752,'et','Top 10 kÃ¼simust - 1 aasta',0),(531049,14752,'si','Top 10 elementov â€“ 1 leto',0),(531050,14752,'ba','Top 10 Items - 1 tahun',0),(531051,14752,'nl','Top 10 Items - 1 jaar',0),(531052,14752,'fi','Top 10 kohteet - 1 vuosi',0),(531053,14752,'no','Topp 10 elementer - 1 Ã¥r',0),(531054,14752,'da','Top 10 varer - 1 Ã¥r',0),(531055,14752,'ko','ìƒìœ„ 10 ê°œ í•­ëª©-1 ë…„',0),(531056,14752,'he','×”×¢×œ×™×•×Ÿ 10 ×¤×¨×™×˜×™× - 1 ×©× ×”',0),(531057,14752,'el','ÎšÎ¿ÏÏ…Ï†Î® 10 - 1 Î­Ï„Î¿Ï‚',0),(531058,14752,'zh','åå¤§é¡¹ç›®-1 å¹´',0),(531059,14752,'sv','Topp 10 objekt - 1 Ã¥r',0),(531060,14752,'it','Top 10 articoli - 1 anno',0),(531061,14752,'tl','',0),(531062,14752,'th','10 à¸­à¸±à¸™à¸”à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸² - 1 à¸›à¸µ',0),(531063,14752,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤†à¤‡à¤Ÿà¤®à¥à¤¸ - 1 à¤¸à¤¾à¤²',0),(531064,14752,'ms','Top 10 item - 1 tahun',0),(531065,14752,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø£ØµÙ†Ø§Ù-Ø³Ù†Ø© 1',0),(531066,14752,'fr','Top 10 postes - 1 an',0),(531067,14752,'jp','ä¸Šä½ 10 é …ç›® - 1 å¹´',0),(531068,14752,'pt','Top 10 itens - 1 ano',0),(531069,14752,'ru','Ð¢Ð¾Ð¿-10 ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² - 1 Ð³Ð¾Ð´',0),(531070,14752,'es','Top 10 artÃ­culos â€“ 1 aÃ±o',0),(531071,14752,'de','Top 10 Artikel - 1 Jahr',0),(531072,14752,'en','Top 10 Items - 1 Year',0),(531073,14753,'is','',0),(531074,14753,'dr','ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø³ÙˆØ¯ 10 - 1 Ù…Ø§Ù‡',0),(531075,14753,'pr','ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø³ÙˆØ¯ 10 - 1 Ù…Ø§Ù‡',0),(531076,14753,'tr','En iyi 10 mÃ¼ÅŸteriler - 1 ay kar.',0),(531077,14753,'pl','Top 10 klientÃ³w zysk - 1 miesiÄ…c',0),(531078,14753,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ - 1 Ð¼ÐµÑÐµÑ†',0),(531079,14753,'ur','Ø§ÙˆÙ¾Ø± 10 Ù…Ù†Ø§ÙØ¹ ØµØ§Ø±ÙÛŒÙ† - 1 Ù…ÛÛŒÙ†Û’',0),(531080,14753,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð¸Ñ€Ð°Ñ˜Ñƒ ÐºÑƒÐ¿Ñ†Ð¸ - 1 Ð¼ÐµÑÐµÑ†',0),(531081,14753,'vi','Top 10 lá»£i nhuáº­n khÃ¡ch - 1 thÃ¡ng',0),(531082,14753,'af','Top 10 wins klante - 1 maand',0),(531083,14753,'ro','Top 10 Profit clienÅ£ii - 1 luna',0),(531084,14753,'et','Top 10 kasumi kÃ¼lastajad - 1 kuu',0),(531085,14753,'si','Top 10 dobiÄek stranke - 1 mesec',0),(531086,14753,'ba','Atas 10 keuntungan pelanggan - 1 bulan',0),(531087,14753,'nl','Top 10 klanten winst - 1 maand',0),(531088,14753,'fi','Top 10 voittoa asiakkaat - 1 kuukausi',0),(531089,14753,'no','Topp 10 profitt kunder - 1 mÃ¥ned',0),(531090,14753,'da','Top 10 Profit kunder - 1 mÃ¥ned',0),(531091,14753,'ko','í†± 10 ì´ìµ ê³ ê°-1 ê°œì›”',0),(531092,14753,'he','×¨××© 10 ×ž×¨×•×•×™×—×™× ×œ×§×•×—×•×ª - 1 ×—×•×“×©',0),(531093,14753,'el','Top 10 ÎºÎµÏÎ´ÏŽÎ½ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ - 1 Î¼Î®Î½Î±',0),(531094,14753,'zh','å‰ 10 ä¸ªåˆ©æ¶¦å®¢æˆ·-1 ä¸ªæœˆ',0),(531095,14753,'sv','Topp 10 resultat kunder - 1 mÃ¥nad',0),(531096,14753,'it','Top 10 clienti profitto - 1 mese',0),(531097,14753,'tl','',0),(531098,14753,'th','à¸­à¸±à¸™à¸”à¸±à¸š 10 à¸à¸³à¹„à¸£à¸¥à¸¹à¸à¸„à¹‰à¸² - 1 à¹€à¸”à¸·à¸­à¸™',0),(531099,14753,'hi','à¤šà¥‹à¤Ÿà¥€ à¤•à¥‡ 10 à¤²à¤¾à¤­ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ - 1 à¤®à¤¹à¥€à¤¨à¤¾',0),(531100,14753,'ms','Top 10 keuntungan pelanggan - 1 bulan',0),(531101,14753,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø±Ø¨Ø­ Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†-1 Ø§Ù„Ø´Ù‡Ø±',0),(531102,14753,'fr','Top 10 clients rentables - 1 mois',0),(531103,14753,'jp','ãƒˆãƒƒãƒ— 10 åˆ©ç›Šé¡§å®¢ - 1 ãƒ¶æœˆ',0),(531104,14753,'pt','Top 10 clientes lucrativos - 1 mÃªs',0),(531105,14753,'ru','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² - 1 Ð¼ÐµÑÑÑ†',0),(531106,14753,'es','Los 10 mejores beneficios a clientes - 1 mes',0),(531107,14753,'de','Top 10 profitieren Kunden - 1 Monat',0),(531108,14753,'en','Top 10 Profit Customers - 1 Month',0),(531109,14754,'is','',0),(531110,14754,'dr','ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø³ÙˆØ¯ 10 - 1 Ø³Ø§Ù„',0),(531111,14754,'pr','ØµÙØ­Ù‡ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø³ÙˆØ¯ 10 - 1 Ø³Ø§Ù„',0),(531112,14754,'tr','En iyi 10 mÃ¼ÅŸteriler - 1 yÄ±l kar.',0),(531113,14754,'pl','Top 10 klientÃ³w zysk - 1 rok',0),(531114,14754,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(531115,14754,'ur','Ø§ÙˆÙ¾Ø± 10 Ù…Ù†Ø§ÙØ¹ ØµØ§Ø±ÙÛŒÙ† - 1 Ø³Ø§Ù„',0),(531116,14754,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð¸Ñ€Ð°Ñ˜Ñƒ ÐºÑƒÐ¿Ñ†Ð¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(531117,14754,'vi','Top 10 lá»£i nhuáº­n khÃ¡ch â€“ 1 nÄƒm',0),(531118,14754,'af','Top 10 wins klante - 1 jaar',0),(531119,14754,'ro','Top 10 Profit clienÅ£ii - 1 an',0),(531120,14754,'et','Top 10 kasumi kÃ¼lastajad - 1 aasta',0),(531121,14754,'si','Top 10 dobiÄek stranke - 1 leto',0),(531122,14754,'ba','Atas 10 keuntungan pelanggan - 1 tahun',0),(531123,14754,'nl','Top 10 klanten winst - 1 jaar',0),(531124,14754,'fi','Top 10 voittoa asiakkaat - 1 vuosi',0),(531125,14754,'no','Topp 10 profitt kunder - 1 Ã¥r',0),(531126,14754,'da','Top 10 Profit kunder - 1 Ã¥r',0),(531127,14754,'ko','í†± 10 ì´ìµ ê³ ê°-1 ë…„',0),(531128,14754,'he','×¨××© 10 ×ž×¨×•×•×™×—×™× ×œ×§×•×—×•×ª - 1 ×©× ×”',0),(531129,14754,'el','Top 10 Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÎºÎ­ÏÎ´Î¿Ï‚ - 1 Î­Ï„Î¿Ï‚',0),(531130,14754,'zh','å‰ 10 ä¸ªåˆ©æ¶¦å®¢æˆ·-1 å¹´',0),(531131,14754,'sv','Topp 10 resultat kunder - 1 Ã¥r',0),(531132,14754,'it','Top 10 clienti profitto - 1 anno',0),(531133,14754,'tl','',0),(531134,14754,'th','à¸­à¸±à¸™à¸”à¸±à¸š 10 à¸à¸³à¹„à¸£à¸¥à¸¹à¸à¸„à¹‰à¸² - 1 à¸›à¸µ',0),(531135,14754,'hi','à¤šà¥‹à¤Ÿà¥€ à¤•à¥‡ 10 à¤²à¤¾à¤­ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ - 1 à¤¸à¤¾à¤²',0),(531136,14754,'ms','Top 10 keuntungan pelanggan - 1 tahun',0),(531137,14754,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø±Ø¨Ø­ Ø§Ù„Ø²Ø¨Ø§Ø¦Ù†-Ø³Ù†Ø© 1',0),(531138,14754,'fr','Top 10 clients rentables - 1 an',0),(531139,14754,'jp','ãƒˆãƒƒãƒ— 10 åˆ©ç›Šé¡§å®¢ - 1 å¹´',0),(531140,14754,'pt','Top 10 clientes lucro - 1 ano',0),(531141,14754,'ru','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¸Ð±Ñ‹Ð»ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² - 1 Ð³Ð¾Ð´',0),(531142,14754,'es','Los 10 mejores beneficios a clientes - 1 aÃ±o',0),(531143,14754,'de','Top 10 profitieren Kunden - 1 Jahr',0),(531144,14754,'en','Top 10 Profit Customers - 1 Year',0),(531145,14755,'is','',0),(531146,14755,'dr','Ø¨Ø§Ù„Ø§ 10 Ø³ÙˆØ¯ Ù…ÙˆØ±Ø¯ - 1 Ø³Ø§Ù„',0),(531147,14755,'pr','Ø¨Ø§Ù„Ø§ 10 Ø³ÙˆØ¯ Ù…ÙˆØ±Ø¯ - 1 Ø³Ø§Ù„',0),(531148,14755,'tr','En iyi 10 Ã¶ÄŸeler - 1 yÄ±l kar.',0),(531149,14755,'pl','Top 10 pozycji zysku - 1 rok',0),(531150,14755,'bg','Ð¢Ð¾Ð¿ 10 Ð¿ÐµÑ‡Ð°Ð»Ð±Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(531151,14755,'ur','Ø§ÙˆÙ¾Ø± 10 Ù…Ù†Ø§ÙØ¹ Ø§Ø´ÛŒØ§Ø¡ - 1 Ø³Ø§Ù„',0),(531152,14755,'sr','ÐŸÑ€Ð²Ð¸Ñ… 10 Ð¿Ñ€Ð¾Ñ„Ð¸Ñ‚Ð¸Ñ€Ð°Ñ˜Ñƒ ÑÑ‚Ð°Ð²ÐºÐ¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(531153,14755,'vi','Top 10 lá»£i nhuáº­n bÃ i â€“ 1 nÄƒm',0),(531154,14755,'af','Top 10 wins Items - 1 jaar',0),(531155,14755,'ro','Top 10 articole de Profit - 1 an',0),(531156,14755,'et','Top 10 kasumi eseme - 1 aasta',0),(531157,14755,'si','Top 10 dobiÄek elementov â€“ 1 leto',0),(531158,14755,'ba','Atas 10 keuntungan Items - 1 tahun',0),(531159,14755,'nl','Top 10 winst Items - 1 jaar',0),(531160,14755,'fi','Top 10 voittoa erÃ¤t - 1 vuosi',0),(531161,14755,'no','Topp 10 overskudd elementer - 1 Ã¥r',0),(531162,14755,'da','Top 10 overskud varer - 1 Ã¥r',0),(531163,14755,'ko','í†± 10 ì´ìµ í•­ëª©-1 ë…„',0),(531164,14755,'he','Top 10 ×¤×¨×™×˜×™× ×¨×•×•×— - 1 ×©× ×”',0),(531165,14755,'el','ÎšÎ¿ÏÏ…Ï†Î® 10 ÎºÎ­ÏÎ´Î¿Ï‚ - 1 Î­Ï„Î¿Ï‚',0),(531166,14755,'zh','é¡¶éƒ¨ 10 åˆ©æ¶¦é¡¹ç›®-1 å¹´',0),(531167,14755,'sv','Topp 10 resultat objekt - 1 Ã¥r',0),(531168,14755,'it','Top 10 articoli di profitto - 1 anno',0),(531169,14755,'tl','',0),(531170,14755,'th','à¸­à¸±à¸™à¸”à¸±à¸š 10 à¸à¸³à¹„à¸£à¸ªà¸´à¸™à¸„à¹‰à¸² - 1 à¸›à¸µ',0),(531171,14755,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤†à¤‡à¤Ÿà¤®à¥à¤¸ - 1 à¤¸à¤¾à¤² à¤²à¤¾à¤­',0),(531172,14755,'ms','Top 10 keuntungan item - 1 tahun',0),(531173,14755,'ar','Ø£Ø¹Ù„Ù‰ 10 Ø¹Ù†Ø§ØµØ± Ø§Ù„Ø±Ø¨Ø­-Ø³Ù†Ø© 1',0),(531174,14755,'fr','Top 10 Articles de Profit - 1 an',0),(531175,14755,'jp','ãƒˆãƒƒãƒ— 10 åˆ©ç›Šé …ç›® - 1 å¹´',0),(531176,14755,'pt','Top 10 itens de lucro - 1 ano',0),(531177,14755,'ru','Ð¢Ð¾Ð¿ 10 Ð¿ÑƒÐ½ÐºÑ‚Ð¾Ð² Ð¿Ñ€Ð¸Ð±Ñ‹Ð»Ð¸ - 1 Ð³Ð¾Ð´',0),(531178,14755,'es','Top 10 artÃ­culos de beneficio - 1 aÃ±o',0),(531179,14755,'de','Top 10 Ergebnis Elemente - 1 Jahr',0),(531180,14755,'en','Top 10 Profit Items - 1 Year',0),(531181,14756,'is','',0),(531182,14756,'dr','Ø¨Ø§Ù„Ø§ 10 ÙØ±ÙˆØ´ Ø§ÛŒØ§Ù„Ø§Øª - 1 Ù…Ø§Ù‡',0),(531183,14756,'pr','Ø¨Ø§Ù„Ø§ 10 ÙØ±ÙˆØ´ Ø§ÛŒØ§Ù„Ø§Øª - 1 Ù…Ø§Ù‡',0),(531184,14756,'tr','En iyi 10 satÄ±ÅŸ devletler - 1 ay',0),(531185,14756,'pl','Top 10 sprzedaÅ¼y PaÅ„stwa - 1 miesiÄ…c',0),(531186,14756,'bg','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð¸ - 1 Ð¼ÐµÑÐµÑ†',0),(531187,14756,'ur','1 Ù…ÛÛŒÙ†Û Ù¾ÛÙ„Û’ 10 Ø³ÛŒÙ„Ø² Ø§Ù…Ø±ÛŒÚ©Û-',0),(531188,14756,'sr','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð° Ð´Ñ€Ð¶Ð°Ð²Ðµ - 1 Ð¼ÐµÑÐµÑ†',0),(531189,14756,'vi','Top 10 bÃ¡n hÃ ng hoa - 1 thÃ¡ng',0),(531190,14756,'af','Top 10 verkope state - 1 maand',0),(531191,14756,'ro','Top 10 vÃ¢nzÄƒri Statele - 1 luna',0),(531192,14756,'et','Top 10 Sales riike - 1 kuu',0),(531193,14756,'si','Top 10 prodaja drÅ¾ave - 1 mesec',0),(531194,14756,'ba','Top 10 penjualan Serikat - 1 bulan',0),(531195,14756,'nl','Top 10 verkoop Staten - 1 maand',0),(531196,14756,'fi','Top 10 Sales toteaa - 1 kuukausi',0),(531197,14756,'no','Topp 10 salg stater - 1 mÃ¥ned',0),(531198,14756,'da','Top 10 salg stater - 1 mÃ¥ned',0),(531199,14756,'ko','í†± 10 íŒë§¤ ìƒíƒœ-1 ê°œì›”',0),(531200,14756,'he','Top 10 ×ž×“×™× ×•×ª ×”×ž×›×™×¨×•×ª - 1 ×—×•×“×©',0),(531201,14756,'el','Top 10 Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î¼Î­Î»Î· - 1 Î¼Î®Î½Î±',0),(531202,14756,'zh','åå¤§é”€å”®å·ž-1 ä¸ªæœˆ',0),(531203,14756,'sv','Top 10 fÃ¶rsÃ¤ljning stater - 1 mÃ¥nad',0),(531204,14756,'it','Top 10 vendite stati - 1 mese',0),(531205,14756,'tl','',0),(531206,14756,'th','à¹‚à¸£à¸‡à¹à¸£à¸¡à¸¢à¸­à¸”à¸™à¸´à¸¢à¸¡à¹ƒà¸™à¸­à¹€à¸¡à¸£à¸´à¸à¸²à¸‚à¸²à¸¢ 10-1 à¹€à¸”à¸·à¸­à¸™',0),(531207,14756,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤¬à¤¿à¤•à¥à¤°à¥€ à¤°à¤¾à¤œà¥à¤¯à¥‹à¤‚ - 1 à¤®à¤¹à¥€à¤¨à¤¾',0),(531208,14756,'ms','Top 10 jualan syarikat - 1 bulan',0),(531209,14756,'ar','Ø£Ø¹Ù„Ù‰ 10 Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø¯ÙˆÙ„-Ø´Ù‡Ø± 1',0),(531210,14756,'fr','Top 10 ventes Ã‰tats - 1 mois',0),(531211,14756,'jp','ãƒˆãƒƒãƒ— 10 ã®è²©å£²ç±³å›½ - 1 ãƒ¶æœˆ',0),(531212,14756,'pt','Top 10 vendas Estados - 1 mÃªs',0),(531213,14756,'ru','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð° - 1 Ð¼ÐµÑÑÑ†',0),(531214,14756,'es','Top 10 ventas Estados - 1 mes',0),(531215,14756,'de','Top 10 Sales Staaten - 1 Monat',0),(531216,14756,'en','Top 10 Sales States - 1 Month',0),(531217,14757,'is','',0),(531218,14757,'dr','Ø¨Ø§Ù„Ø§ 10 ÙØ±ÙˆØ´ Ø§ÛŒØ§Ù„Ø§Øª - 1 Ø³Ø§Ù„',0),(531219,14757,'pr','Ø¨Ø§Ù„Ø§ 10 ÙØ±ÙˆØ´ Ø§ÛŒØ§Ù„Ø§Øª - 1 Ø³Ø§Ù„',0),(531220,14757,'tr','En iyi 10 satÄ±ÅŸ devletler - 1 yÄ±l',0),(531221,14757,'pl','Top 10 sprzedaÅ¼y PaÅ„stwa - 1 rok',0),(531222,14757,'bg','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð´ÑŠÑ€Ð¶Ð°Ð²Ð¸ - 1 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(531223,14757,'ur','1 Ø³Ø§Ù„ Ù¾ÛÙ„Û’ 10 Ø³ÛŒÙ„Ø² Ø§Ù…Ø±ÛŒÚ©Û-',0),(531224,14757,'sr','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð° Ð´Ñ€Ð¶Ð°Ð²Ðµ - 1 Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(531225,14757,'vi','Top 10 bÃ¡n hÃ ng ká»³ â€“ 1 nÄƒm',0),(531226,14757,'af','Top 10 verkope state - 1 jaar',0),(531227,14757,'ro','Top 10 vÃ¢nzÄƒri Statele - 1 an',0),(531228,14757,'et','Top 10 Sales riike - 1 aasta',0),(531229,14757,'si','Top 10 prodaja drÅ¾ave - 1 leto',0),(531230,14757,'ba','Top 10 penjualan Serikat - 1 tahun',0),(531231,14757,'nl','Top 10 verkoop Staten - 1 jaar',0),(531232,14757,'fi','Top 10 Sales toteaa - 1 vuosi',0),(531233,14757,'no','Topp 10 salg stater - 1 Ã¥r',0),(531234,14757,'da','Top 10 salg stater - 1 Ã¥r',0),(531235,14757,'ko','í†± 10 íŒë§¤ ìƒíƒœ-1 ë…„',0),(531236,14757,'he','Top 10 ×ž×“×™× ×•×ª ×”×ž×›×™×¨×•×ª - 1 ×©× ×”',0),(531237,14757,'el','Top 10 Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î¼Î­Î»Î· - 1 Î­Ï„Î¿Ï‚',0),(531238,14757,'zh','åå¤§é”€å”®å·ž-1 å¹´',0),(531239,14757,'sv','Top 10 fÃ¶rsÃ¤ljning stater - 1 Ã¥r',0),(531240,14757,'it','Top 10 vendite stati - 1 anno',0),(531241,14757,'tl','',0),(531242,14757,'th','à¹‚à¸£à¸‡à¹à¸£à¸¡à¸¢à¸­à¸”à¸™à¸´à¸¢à¸¡à¹ƒà¸™à¸­à¹€à¸¡à¸£à¸´à¸à¸²à¸‚à¸²à¸¢ 10-1 à¸›à¸µ',0),(531243,14757,'hi','à¤¶à¥€à¤°à¥à¤· 10 à¤¬à¤¿à¤•à¥à¤°à¥€ à¤°à¤¾à¤œà¥à¤¯à¥‹à¤‚ - 1 à¤¸à¤¾à¤²',0),(531244,14757,'ms','Top 10 jualan syarikat - 1 tahun',0),(531245,14757,'ar','Ø£Ø¹Ù„Ù‰ 10 Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø¯ÙˆÙ„-Ø³Ù†Ø© 1',0),(531246,14757,'fr','Top 10 ventes Ã‰tats - 1 an',0),(531247,14757,'jp','ãƒˆãƒƒãƒ— 10 ã®è²©å£²ç±³å›½ - 1 å¹´',0),(531248,14757,'pt','Top 10 vendas Estados - 1 ano',0),(531249,14757,'ru','Ð¢Ð¾Ð¿ 10 Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð° - 1 Ð³Ð¾Ð´',0),(531250,14757,'es','Top 10 ventas Estados - 1 aÃ±o',0),(531251,14757,'de','Top 10 Sales Staaten - 1 Jahr',0),(531252,14757,'en','Top 10 Sales States - 1 Year',0),(531253,14758,'is','',0),(531254,14758,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¨ÛŒÙ„',0),(531255,14758,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¨ÛŒÙ„',0),(531256,14758,'tr','Bill Ekle',0),(531257,14758,'pl','Dodaj rachunek',0),(531258,14758,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±Ð¸Ð»',0),(531259,14758,'ur','Ø¨Ù„ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(531260,14758,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð‘Ð¸Ð»',0),(531261,14758,'vi','ThÃªm hÃ³a Ä‘Æ¡n',0),(531262,14758,'af','Voeg Wetsontwerp',0),(531263,14758,'ro','Adauga Bill',0),(531264,14758,'et','Lisada arve',0),(531265,14758,'si','Dodaj raÄun',0),(531266,14758,'ba','Tambahkan Bill',0),(531267,14758,'nl','Voeg Bill toe',0),(531268,14758,'fi','LisÃ¤Ã¤ Emilia',0),(531269,14758,'no','Legge til Bill',0),(531270,14758,'da','TilfÃ¸je Bill',0),(531271,14758,'ko','ë¹Œ ì¶”ê°€',0),(531272,14758,'he','×”×•×¡×£ ××ª ×‘×™×œ',0),(531273,14758,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(531274,14758,'zh','æ·»åŠ æ¡ä¾‹è‰æ¡ˆ',0),(531275,14758,'sv','LÃ¤gg till Bill',0),(531276,14758,'it','Aggiungi Bill',0),(531277,14758,'tl','',0),(531278,14758,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸²à¸¢à¸à¸²à¸£',0),(531279,14758,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(531280,14758,'ms','Tambah Rang undang-undang',0),(531281,14758,'ar','Ø¥Ø¶Ø§ÙØ© ÙØ§ØªÙˆØ±Ø©',0),(531282,14758,'fr','Ajouter Bill',0),(531283,14758,'jp','æ³•æ¡ˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(531284,14758,'pt','Adicionar conta',0),(531285,14758,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð‘Ð¸Ð»Ð»',0),(531286,14758,'es','AÃ±adir Bill',0),(531287,14758,'de','HinzufÃ¼gen von Bill',0),(531288,14758,'en','Add Bill',0),(531289,14759,'is','',0),(531290,14759,'dr','Ù„Ø§ÛŒØ­Ù‡ Ù…Ù‚Ø±Ø± Ø¨Ù‡ Ø²ÙˆØ¯ÛŒ',0),(531291,14759,'pr','Ù„Ø§ÛŒØ­Ù‡ Ù…Ù‚Ø±Ø± Ø¨Ù‡ Ø²ÙˆØ¯ÛŒ',0),(531292,14759,'tr','Bill nedeniyle yakÄ±nda',0),(531293,14759,'pl','Bill odpowiednim wkrÃ³tce',0),(531294,14759,'bg','Ð‘Ð¸Ð» Ð½Ð°Ð´Ð»ÐµÐ¶Ð½Ð¾ ÑÐºÐ¾Ñ€Ð¾',0),(531295,14759,'ur','Ø¬Ù„Ø¯ ÛÛŒ Ø¨Ù„ Ù…Ù‚Ø±Ø±Û',0),(531296,14759,'sr','Ð‘Ð¸Ð» ÐºÑ€Ð°Ñ˜ÑšÐ¸ ÑƒÑÐºÐ¾Ñ€Ð¾',0),(531297,14759,'vi','HÃ³a Ä‘Æ¡n Ä‘áº¿n háº¡n sá»›m',0),(531298,14759,'af','Wetsontwerp sperdatum gou',0),(531299,14759,'ro','Proiect de lege util Ã®n curÃ¢nd',0),(531300,14759,'et','EelnÃµu tÃµttu varsti',0),(531301,14759,'si','Bill zaradi kmalu',0),(531302,14759,'ba','Bill karena segera',0),(531303,14759,'nl','Bill Due snel',0),(531304,14759,'fi','Laskun erÃ¤pÃ¤ivÃ¤n pian',0),(531305,14759,'no','Bill forfaller snart',0),(531306,14759,'da','Bill Due snart',0),(531307,14759,'ko','ë¹Œìœ¼ë¡œ ì¸í•´ ê³§',0),(531308,14759,'he','×‘×™×œ ×™×¢×“ ×‘×§×¨×•×‘',0),(531309,14759,'el','ÎÎ¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿ Due ÏƒÏÎ½Ï„Î¿Î¼Î±',0),(531310,14759,'zh','æ¡ä¾‹è‰æ¡ˆé€‚å½“å¾ˆå¿«',0),(531311,14759,'sv','Bill vederbÃ¶rlig snart',0),(531312,14759,'it','Bill dovuta presto',0),(531313,14759,'tl','',0),(531314,14759,'th','à¸•à¸±à¹‹à¸§à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¹€à¸£à¹‡à¸§ à¹† à¸™à¸µà¹‰',0),(531315,14759,'hi','à¤¬à¤¿à¤² à¤œà¤²à¥à¤¦ à¤¹à¥€ à¤¨à¤¿à¤¯à¤¤',0),(531316,14759,'ms','Rang undang-undang sewajarnya tidak lama lagi',0),(531317,14759,'ar','Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ø§Ù„ÙˆØ§Ø¬Ø¨ Ù‚Ø±ÙŠØ¨Ø§',0),(531318,14759,'fr','Bill voulu bientÃ´t',0),(531319,14759,'jp','ã™ãã«æ³•æ¡ˆã®æœŸé™',0),(531320,14759,'pt','Bill devido em breve',0),(531321,14759,'ru','Ð‘Ð¸Ð»Ð» Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾ ÑÐºÐ¾Ñ€Ð¾',0),(531322,14759,'es','Bill Due pronto',0),(531323,14759,'de','Bill Due bald',0),(531324,14759,'en','Bill Due Soon',0),(531325,14760,'is','',0),(531326,14760,'dr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ù†ÙƒÙŠ ',0),(531327,14760,'pr','ÙˆØ§Ø±Ø¯ ÙƒØ±Ø¯Ù† ØµÙˆØ±Øª ÙˆØ¶Ø¹ÙŠØª Ø¨Ø§Ù†ÙƒÙŠ ',0),(531328,14760,'tr','Alma banka hesaplarÄ±',0),(531329,14760,'pl','WyciÄ…gi bankowe importu',0),(531330,14760,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²Ð¸ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ñ',0),(531331,14760,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø¨ÛŒÙ†Ú© Ú©Û’ Ø¨ÛŒØ§Ù†Ø§Øª',0),(531332,14760,'sr','Ð£Ð²Ð¾Ð· Ð±Ð°Ð½ÐºÐ¾Ð²Ð½Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(531333,14760,'vi','Nháº­p báº£ng kÃª ngÃ¢n hÃ ng',0),(531334,14760,'af','Invoer van Bankstate',0),(531335,14760,'ro','DeclaraÅ£iile de import Bank',0),(531336,14760,'et','Impordi panga vÃ¤ljavÃµtted',0),(531337,14760,'si','Uvoz banÄne izpiske',0),(531338,14760,'ba','Pernyataan Bank impor',0),(531339,14760,'nl','Import bankafschriften',0),(531340,14760,'fi','Tuo tiliotteet',0),(531341,14760,'no','Importer kontoutskrifter',0),(531342,14760,'da','Import kontoudtog',0),(531343,14760,'ko','ê°€ì ¸ì˜¤ê¸° ì€í–‰ ëª…ì„¸ì„œ',0),(531344,14760,'he','×™×‘× ×”×¦×”×¨×•×ª ×‘× ×§',0),(531345,14760,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³ÏŽÎ½ Î´Î·Î»ÏŽÏƒÎµÎ¹Ï‚',0),(531346,14760,'zh','å¯¼å…¥é“¶è¡Œå¯¹å¸å•\r\n',0),(531347,14760,'sv','Importera kontoutdrag',0),(531348,14760,'it','Importazione estratti conto',0),(531349,14760,'tl','',0),(531350,14760,'th','à¸„à¸³à¸ªà¸±à¹ˆà¸‡à¸™à¸³à¹€à¸‚à¹‰à¸² à¸˜à¸™à¸²à¸„à¸²à¸£',0),(531351,14760,'hi','à¤†à¤¯à¤¾à¤¤ à¤¬à¥ˆà¤‚à¤• à¤¬à¤¯à¤¾à¤¨',0),(531352,14760,'ms','Penyata import Bank',0),(531353,14760,'ar','Ø¥Ø³ØªÙŠØ±Ø§Ø¯ ÙƒØ´ÙˆÙØ§Øª Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…ØµØ§Ø±Ù',0),(531354,14760,'fr','RelevÃ©s bancaires d\'importation',0),(531355,14760,'jp','è¼¸å…¥éŠ€è¡Œå–å¼•æ˜Žç´°æ›¸',0),(531356,14760,'pt','Extratos bancÃ¡rios de importaÃ§Ã£o',0),(531357,14760,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ñ… Ð’Ñ‹Ð¿Ð¸ÑÐ¾Ðº',0),(531358,14760,'es','Importtar Estados de Cuentas Bancarios',0),(531359,14760,'de','Import der KontoauszÃ¼ge',0),(531360,14760,'en','Import Bank Statements',0),(531361,14761,'is','',0),(531362,14761,'dr','Ø­Ø°Ù Ú©Ø§Ø±Ø¨Ø±',0),(531363,14761,'pr','Ø­Ø°Ù Ú©Ø§Ø±Ø¨Ø±',0),(531364,14761,'tr','KullanÄ±cÄ± silme',0),(531365,14761,'pl','Usuwanie uÅ¼ytkownika',0),(531366,14761,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(531367,14761,'ur','ØµØ§Ø±Ù Ø­Ø°Ù',0),(531368,14761,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(531369,14761,'vi','XÃ³a ngÆ°á»i dÃ¹ng',0),(531370,14761,'af','Skrapping gebruiker',0),(531371,14761,'ro','È˜tergere utilizator',0),(531372,14761,'et','Kustutamine kasutaja',0),(531373,14761,'si','Brisanje uporabnika',0),(531374,14761,'ba','Penghapusan pengguna',0),(531375,14761,'nl','Verwijderen gebruiker',0),(531376,14761,'fi','Poistetaan kÃ¤yttÃ¤jÃ¤',0),(531377,14761,'no','Sletting av brukeren',0),(531378,14761,'da','Slettet bruger',0),(531379,14761,'ko','ì‚­ì œ ì‚¬ìš©ìž',0),(531380,14761,'he','×ž×—×™×§×ª ×ž×©×ª×ž×©',0),(531381,14761,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Ï‡ÏÎ®ÏƒÏ„Î·',0),(531382,14761,'zh','åˆ é™¤ç”¨æˆ·',0),(531383,14761,'sv','Ta bort anvÃ¤ndare',0),(531384,14761,'it','Cancellazione utente',0),(531385,14761,'tl','',0),(531386,14761,'th','à¸à¸²à¸£à¸¥à¸šà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(531387,14761,'hi','à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(531388,14761,'ms','Penghapusan pengguna',0),(531389,14761,'ar','Ø­Ø°Ù Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(531390,14761,'fr','Suppression utilisateur',0),(531391,14761,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼å‰Šé™¤',0),(531392,14761,'pt','UsuÃ¡rio de exclusÃ£o',0),(531393,14761,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(531394,14761,'es','Usuario borrado',0),(531395,14761,'de','Benutzer lÃ¶schen',0),(531396,14761,'en','Deletion User',0),(531397,14762,'is','',0),(531398,14762,'dr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† Ø­Ø°Ù',0),(531399,14762,'pr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† Ø­Ø°Ù',0),(531400,14762,'tr','BitiÅŸ silme tarihi',0),(531401,14762,'pl','Data zakoÅ„czenia usuwania',0),(531402,14762,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ',0),(531403,14762,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø­Ø°Ù',0),(531404,14762,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð±Ñ€Ð¸ÑÐ°ÑšÐ°',0),(531405,14762,'vi','NgÃ y káº¿t thÃºc viá»‡c xÃ³a',0),(531406,14762,'af','Skrapping Einddatum',0),(531407,14762,'ro','Data de sfÃ¢rÅŸit al ÅŸtergerea',0),(531408,14762,'et','Kustutamise lÃµppkuupÃ¤ev',0),(531409,14762,'si','KonÄni datum izbrisa',0),(531410,14762,'ba','Tanggal akhir penghapusan',0),(531411,14762,'nl','Schrapping einddatum',0),(531412,14762,'fi','Poiston pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(531413,14762,'no','Sluttdatoen for sletting',0),(531414,14762,'da','Slutdato for sletning',0),(531415,14762,'ko','ìµœì¢… ì‚­ì œ ë‚ ì§œ',0),(531416,14762,'he','×ª××¨×™×š ×¡×™×•× ×ž×—×™×§×”',0),(531417,14762,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(531418,14762,'zh','ç»“æŸåˆ é™¤æ—¥æœŸ',0),(531419,14762,'sv','Slutdatum fÃ¶r borttagning',0),(531420,14762,'it','Data di fine eliminazione',0),(531421,14762,'tl','',0),(531422,14762,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸à¸²à¸£à¸¥à¸š',0),(531423,14762,'hi','à¤…à¤‚à¤¤ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤•à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(531424,14762,'ms','Tarikh akhir pemotongan',0),(531425,14762,'ar','Ù†Ù‡Ø§ÙŠØ© ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø°Ù',0),(531426,14762,'fr','Date de suppression de fin',0),(531427,14762,'jp','çµ‚äº†å‰Šé™¤æ—¥',0),(531428,14762,'pt','Data de exclusÃ£o do final',0),(531429,14762,'ru','Ð”Ð°Ñ‚Ð° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ',0),(531430,14762,'es','Fecha de eliminaciÃ³n final',0),(531431,14762,'de','Enddatum lÃ¶schen',0),(531432,14762,'en','End Deletion Date',0),(531433,14763,'is','',0),(531434,14763,'dr','Ø´Ù†Ø§Ø³Ù‡',0),(531435,14763,'pr','Ø´Ù†Ø§Ø³Ù‡',0),(531436,14763,'tr','TanÄ±mlayÄ±cÄ±',0),(531437,14763,'pl','Identyfikator',0),(531438,14763,'bg','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(531439,14763,'ur','Ø´Ù†Ø§Ø®Øª Ú©Ù†Ù†Ø¯Û',0),(531440,14763,'sr','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(531441,14763,'vi','Äá»‹nh danh',0),(531442,14763,'af','Identifiseerder',0),(531443,14763,'ro','Identificator',0),(531444,14763,'et','Identifikaator',0),(531445,14763,'si','Identifikator',0),(531446,14763,'ba','Pengenal',0),(531447,14763,'nl','Id',0),(531448,14763,'fi','Tunnus',0),(531449,14763,'no','Identifikator',0),(531450,14763,'da','Id',0),(531451,14763,'ko','ì‹ë³„ìž',0),(531452,14763,'he','×”×ž×–×”×”',0),(531453,14763,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ',0),(531454,14763,'zh','æ ‡è¯†ç¬¦',0),(531455,14763,'sv','Identifierare',0),(531456,14763,'it','Identificatore',0),(531457,14763,'tl','',0),(531458,14763,'th','à¸£à¸«à¸±à¸ª',0),(531459,14763,'hi','à¤ªà¤¹à¤šà¤¾à¤¨à¤•à¤°à¥à¤¤à¤¾',0),(531460,14763,'ms','Pengenalpastian',0),(531461,14763,'ar','Ø§Ù„Ù…Ø¹Ø±Ù',0),(531462,14763,'fr','Identificateur',0),(531463,14763,'jp','è­˜åˆ¥å­',0),(531464,14763,'pt','Identificador',0),(531465,14763,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(531466,14763,'es','Identificador',0),(531467,14763,'de','Bezeichner',0),(531468,14763,'en','Identifier',0),(531469,14764,'is','',0),(531470,14764,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‡Ø§ Ù…Ø¬Ø¯Ø¯Ø§',0),(531471,14764,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‡Ø§ Ù…Ø¬Ø¯Ø¯Ø§',0),(531472,14764,'tr','Yeniden satÄ±cÄ±',0),(531473,14764,'pl','Dostawcy reaktywowany',0),(531474,14764,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½',0),(531475,14764,'ur','Ù¾Ú¾Ø± Ø²ÛŒØ± Ø¹Ù…Ù„ ÙØ±ÙˆØ´Ù†Ø¯Û',0),(531476,14764,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ñ€ÐµÐ°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð»Ð°',0),(531477,14764,'vi','CÃ¡c nhÃ  cung cáº¥p kÃ­ch hoáº¡t láº¡i',0),(531478,14764,'af','Handelaar geheraktiveer',0),(531479,14764,'ro','Furnizor reactivat',0),(531480,14764,'et','Hankija uuesti',0),(531481,14764,'si','Dobavitelja, ponovno',0),(531482,14764,'ba','Penjual yang diaktifkan',0),(531483,14764,'nl','Leverancier gereactiveerd',0),(531484,14764,'fi','Toimittajan uudelleen',0),(531485,14764,'no','LeverandÃ¸ren reaktivert',0),(531486,14764,'da','Kreditor genaktiveret',0),(531487,14764,'ko','ë‹¤ì‹œ í™œì„±í™” í•˜ëŠ” ê³µê¸‰ ì—…ì²´',0),(531488,14764,'he','×”×¡×¤×§ ×ž×—×“×©',0),(531489,14764,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÎµÏ€Î±Î½ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¸ÎµÎ¯',0),(531490,14764,'zh','ä¾›åº”å•†é‡æ–°æ¿€æ´»',0),(531491,14764,'sv','LeverantÃ¶r reaktiveras',0),(531492,14764,'it','Fornitore riattivato',0),(531493,14764,'tl','',0),(531494,14764,'th','à¸œà¸¹à¹‰à¸—à¸µà¹ˆà¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(531495,14764,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯',0),(531496,14764,'ms','Penjual yang telah diaktifkan semula',0),(531497,14764,'ar','Ø¨Ø§Ø¦Ø¹ ØªÙ†Ø´ÙŠØ·',0),(531498,14764,'fr','Fournisseur rÃ©activÃ©',0),(531499,14764,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®å†ã‚¢ã‚¯ãƒ†ã‚£ãƒ–åŒ–',0),(531500,14764,'pt','Fornecedor reativado',0),(531501,14764,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾',0),(531502,14764,'es','Vendedor reactivado',0),(531503,14764,'de','Hersteller reaktiviert',0),(531504,14764,'en','Vendor Reactivated',0),(531505,14765,'is','',0),(531506,14765,'dr','Ø´Ù†Ø§Ø³Ù‡ Ú©Ø´ØªÛŒ',0),(531507,14765,'pr','Ø´Ù†Ø§Ø³Ù‡ Ú©Ø´ØªÛŒ',0),(531508,14765,'tr','Gemi sicil',0),(531509,14765,'pl','ID statku',0),(531510,14765,'bg','Ð˜Ð” Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð°',0),(531511,14765,'ur','Ø¬ÛØ§Ø² Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(531512,14765,'sr','Ð˜Ð” Ð±Ñ€Ð¾Ð´',0),(531513,14765,'vi','TÃ u ID',0),(531514,14765,'af','Skip ID',0),(531515,14765,'ro','Nava ID',0),(531516,14765,'et','Saaja ID',0),(531517,14765,'si','Ladja ID',0),(531518,14765,'ba','Kapal ID',0),(531519,14765,'nl','Schip ID',0),(531520,14765,'fi','Aluksen tunnus',0),(531521,14765,'no','Skipet ID',0),(531522,14765,'da','Skib-ID',0),(531523,14765,'ko','ë°° ID',0),(531524,14765,'he','×ž×–×”×” ××ª ×”×¡×¤×™× ×”',0),(531525,14765,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€Î»Î¿Î¯Î¿',0),(531526,14765,'zh','èˆ¹èˆ¶ ID',0),(531527,14765,'sv','Fartyg-ID',0),(531528,14765,'it','Nave ID',0),(531529,14765,'tl','',0),(531530,14765,'th','ID à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(531531,14765,'hi','à¤œà¤¹à¤¾à¤œ ID',0),(531532,14765,'ms','ID kapal',0),(531533,14765,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(531534,14765,'fr','ID de navire',0),(531535,14765,'jp','èˆ¹èˆ¶ ID',0),(531536,14765,'pt','ID do navio',0),(531537,14765,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÑÑƒÐ´Ð½Ð°',0),(531538,14765,'es','Nave ID',0),(531539,14765,'de','Schiff-ID',0),(531540,14765,'en','Ship ID',0),(531541,14766,'is','',0),(531542,14766,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø³ÙØ§Ø±Ø´',0),(531543,14766,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø³ÙØ§Ø±Ø´',0),(531544,14766,'tr','SipariÅŸi gÃ¶rÃ¼ntÃ¼le',0),(531545,14766,'pl','WyÅ›wietl zamÃ³wienie',0),(531546,14766,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(531547,14766,'ur','Ù…Ù†Ø¸Ø± ØªØ±ØªÛŒØ¨',0),(531548,14766,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð½Ð°Ð»Ð¾Ð³Ð°',0),(531549,14766,'vi','Xem Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(531550,14766,'af','Bekyk orde',0),(531551,14766,'ro','Vezi Ordinul',0),(531552,14766,'et','Vaata taotlust',0),(531553,14766,'si','Ogled naroÄila',0),(531554,14766,'ba','Lihat pesanan',0),(531555,14766,'nl','Bestelling bekijken',0),(531556,14766,'fi','NÃ¤ytÃ¤ tilaus',0),(531557,14766,'no','Vis bestilling',0),(531558,14766,'da','Vis ordre',0),(531559,14766,'ko','ì •ë ¬ ë³´ê¸°',0),(531560,14766,'he','×¡×“×¨ ×ª×¦×•×’×”',0),(531561,14766,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(531562,14766,'zh','æŸ¥çœ‹è®¢å•',0),(531563,14766,'sv','Visa Order',0),(531564,14766,'it','Visualizza ordine',0),(531565,14766,'tl','',0),(531566,14766,'th','à¸”à¸¹à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(531567,14766,'hi','à¤†à¤¦à¥‡à¤¶ à¤¦à¥‡à¤–à¥‡à¤‚',0),(531568,14766,'ms','Lihat perintah',0),(531569,14766,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ø¹Ø±Ø¶',0),(531570,14766,'fr','Afficher l\'ordre',0),(531571,14766,'jp','[é †åºã®è¡¨ç¤º',0),(531572,14766,'pt','Ordem de exibiÃ§Ã£o',0),(531573,14766,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(531574,14766,'es','Ver orden',0),(531575,14766,'de','Bestellung anzeigen',0),(531576,14766,'en','View Order',0),(531577,14767,'is','',0),(531578,14767,'dr','ÙØ§Ú©ØªÙˆØ± ØªÙˆØ§Ø²Ù†',0),(531579,14767,'pr','ÙØ§Ú©ØªÙˆØ± ØªÙˆØ§Ø²Ù†',0),(531580,14767,'tr','Fatura bakiyesi',0),(531581,14767,'pl','Faktura rÃ³wnowagi',0),(531582,14767,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð±Ð°Ð»Ð°Ð½Ñ',0),(531583,14767,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ ØªÙˆØ§Ø²Ù†',0),(531584,14767,'sr','Ð¡Ð°Ð»Ð´Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(531585,14767,'vi','Sá»‘ dÆ° hÃ³a Ä‘Æ¡n',0),(531586,14767,'af','Faktuur balans',0),(531587,14767,'ro','Soldul facturii',0),(531588,14767,'et','Arve saldo',0),(531589,14767,'si','Saldo raÄuna',0),(531590,14767,'ba','Saldo faktur',0),(531591,14767,'nl','Factuur evenwicht',0),(531592,14767,'fi','Laskun saldo',0),(531593,14767,'no','Faktura balanse',0),(531594,14767,'da','Faktura Balance',0),(531595,14767,'ko','ì†¡ìž¥ ìž”ì•¡',0),(531596,14767,'he','××™×–×•×Ÿ ×—×©×‘×•× ×™×ª',0),(531597,14767,'el','ÎœÎ·Î½Î¹Î±Î¯Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚',0),(531598,14767,'zh','å‘ç¥¨ä½™é¢',0),(531599,14767,'sv','Fakturasaldo',0),(531600,14767,'it','Saldo fattura',0),(531601,14767,'tl','',0),(531602,14767,'th','à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸‚à¸­à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(531603,14767,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¶à¥‡à¤·',0),(531604,14767,'ms','Invois baki',0),(531605,14767,'ar','Ø±ØµÙŠØ¯ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(531606,14767,'fr','Solde de la facture',0),(531607,14767,'jp','è«‹æ±‚æ›¸æ®‹é«˜',0),(531608,14767,'pt','Saldo da fatura',0),(531609,14767,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ ÑÑ‡ÐµÑ‚Ð°',0),(531610,14767,'es','Saldo de factura',0),(531611,14767,'de','Rechnung-Balance',0),(531612,14767,'en','Invoice Balance',0),(531613,14768,'is','',0),(531614,14768,'dr','Ø§Ø±Ø²Ø´ uninvoiced',0),(531615,14768,'pr','Ø§Ø±Ø²Ø´ uninvoiced',0),(531616,14768,'tr','FaturalanmamÄ±ÅŸ deÄŸeri',0),(531617,14768,'pl','WartoÅ›Ä‡ niezafakturowane',0),(531618,14768,'bg','ÐÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(531619,14768,'ur','Ø§Ù†Ø§Ù†ÙˆÙˆØ§Ú© Ù‚Ø¯Ø±',0),(531620,14768,'sr','ÐÐµÑ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(531621,14768,'vi','Uninvoiced giÃ¡ trá»‹',0),(531622,14768,'af','Uninvoiced waarde',0),(531623,14768,'ro','Uninvoiced valoare',0),(531624,14768,'et','Arveldamata vÃ¤Ã¤rtus',0),(531625,14768,'si','Nefakturirane vrednost',0),(531626,14768,'ba','Nilai uninvoiced',0),(531627,14768,'nl','Niet-gefactureerde waarde',0),(531628,14768,'fi','Laskuttamattomat arvo',0),(531629,14768,'no','Ikke fakturerte verdi',0),(531630,14768,'da','Ikke-fakturerede vÃ¦rdi',0),(531631,14768,'ko','Uninvoiced ê°’',0),(531632,14768,'he','×¢×¨×š uninvoiced',0),(531633,14768,'el','ÎœÎ· Î¤Î¹Î¼Î¿Î»Î¿Î³Î·Î¼Î­Î½ÎµÏ‚ Î±Î¾Î¯Î±',0),(531634,14768,'zh','æœªå¼€ç¥¨çš„ä»·å€¼',0),(531635,14768,'sv','Ofakturerade vÃ¤rde',0),(531636,14768,'it','Valore non fatturate',0),(531637,14768,'tl','',0),(531638,14768,'th','à¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¹ˆà¸²',0),(531639,14768,'hi','Uninvoiced à¤®à¤¾à¤¨',0),(531640,14768,'ms','Nilai uninvoiced',0),(531641,14768,'ar','Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø±Ø­Ù„ÙŠØ©',0),(531642,14768,'fr','Valeur non facturÃ©e',0),(531643,14768,'jp','Uninvoiced å€¤',0),(531644,14768,'pt','Uninvoiced valor',0),(531645,14768,'ru','Ð˜ÑÑ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(531646,14768,'es','Valor uninvoiced',0),(531647,14768,'de','Ausstehender Wert',0),(531648,14768,'en','Uninvoiced Value',0),(531649,14769,'is','',0),(531650,14769,'dr','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø¬Ø¹Ø¨Ù‡',0),(531651,14769,'pr','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø¬Ø¹Ø¨Ù‡',0),(531652,14769,'tr','Kutu iÃ§in gemi',0),(531653,14769,'pl','Statek na polu',0),(531654,14769,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð² ÐºÑƒÑ‚Ð¸Ñ',0),(531655,14769,'ur','Ø®Ø§Ù†Û Ù…ÛŒÚº Ø¬ÛØ§Ø²',0),(531656,14769,'sr','Ð£ ÐºÑƒÑ‚Ð¸Ñ˜Ð¸',0),(531657,14769,'vi','TÃ u Ä‘á»ƒ há»™p',0),(531658,14769,'af','Skip na boks',0),(531659,14769,'ro','NavÄƒ la cutie',0),(531660,14769,'et','Kauba saaja kasti',0),(531661,14769,'si','Dostava â€“ polje',0),(531662,14769,'ba','Kapal ke kotak',0),(531663,14769,'nl','Verzenden naar vak',0),(531664,14769,'fi','Aluksen ruutuun',0),(531665,14769,'no','Leveringsgate /-boksen',0),(531666,14769,'da','Skib til boks',0),(531667,14769,'ko','ìƒìžì— ë°°',0),(531668,14769,'he','×œ×ž×©×œ×•×— ×ª×™×‘×ª',0),(531669,14769,'el','Î Î»Î¿Î¯Î¿ ÏƒÏ„Î¿ ÎºÎ¹Î²ÏŽÏ„Î¹Î¿',0),(531670,14769,'zh','èˆ¹åˆ°æ¡†ä¸­',0),(531671,14769,'sv','Fartyget till Box',0),(531672,14769,'it','Spedisci in scatola',0),(531673,14769,'tl','',0),(531674,14769,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸à¸¥à¹ˆà¸­à¸‡',0),(531675,14769,'hi','à¤¬à¥‰à¤•à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(531676,14769,'ms','Kapal ke Peti',0),(531677,14769,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ù…Ø±Ø¨Ø¹',0),(531678,14769,'fr','ExpÃ©dier Ã  boÃ®te',0),(531679,14769,'jp','ãƒœãƒƒã‚¯ã‚¹ã«å‡ºè·ã—ã¾ã™ã€‚',0),(531680,14769,'pt','Enviamos a caixa',0),(531681,14769,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÑÐµÐ¼ Ð² ÐºÐ¾Ñ€Ð¾Ð±ÐºÐµ',0),(531682,14769,'es','La nave a la caja',0),(531683,14769,'de','Ship To Box',0),(531684,14769,'en','Ship To Box',0),(531685,14770,'is','',0),(531686,14770,'dr','ÙØ±ÙˆØ´ Ø¬Ø¹Ø¨Ù‡',0),(531687,14770,'pr','ÙØ±ÙˆØ´ Ø¬Ø¹Ø¨Ù‡',0),(531688,14770,'tr','Kutu sattÄ±',0),(531689,14770,'pl','Sprzedawane na polu',0),(531690,14770,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð´ÐµÐ½Ð¾ Ð½Ð° ÐºÑƒÑ‚Ð¸Ñ',0),(531691,14770,'ur','Ø¨Ø§Ú©Ø³ Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(531692,14770,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð»Ð¸ ÐºÑƒÑ‚Ð¸Ñ˜Ñƒ',0),(531693,14770,'vi','BÃ¡n cho há»™p',0),(531694,14770,'af','Verkoop aan boks',0),(531695,14770,'ro','VÃ¢ndute la cutie',0),(531696,14770,'et','Kast mÃ¼Ã¼dud',0),(531697,14770,'si','Prodajajo polje',0),(531698,14770,'ba','Dijual ke kotak',0);
INSERT INTO `langdef` VALUES (531699,14770,'nl','Verkocht aan vak',0),(531700,14770,'fi','MyydÃ¤Ã¤n-ruutuun',0),(531701,14770,'no','Solgt til boksen',0),(531702,14770,'da','Solgt til boks',0),(531703,14770,'ko','ìƒìž íŒë§¤',0),(531704,14770,'he','× ×ž×›×¨ ×ª×™×‘×ª',0),(531705,14770,'el','Î Ï‰Î»Î¿ÏÎ½Ï„Î±Î¹ ÏƒÎµ Ï€Î»Î±Î¯ÏƒÎ¹Î¿',0),(531706,14770,'zh','å–ç»™æ¡†',0),(531707,14770,'sv','SÃ¥ld till Box',0),(531708,14770,'it','Venduto a scatola',0),(531709,14770,'tl','',0),(531710,14770,'th','à¸‚à¸²à¸¢à¸à¸¥à¹ˆà¸­à¸‡',0),(531711,14770,'hi','à¤¬à¥‰à¤•à¥à¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥‡à¤š à¤¦à¤¿à¤¯à¤¾',0),(531712,14770,'ms','Dijual kepada peti',0),(531713,14770,'ar','ØªØ¨Ø§Ø¹ Ø¥Ù„Ù‰ Ù…Ø±Ø¨Ø¹',0),(531714,14770,'fr','Vendu Ã  la boÃ®te',0),(531715,14770,'jp','ãƒœãƒƒã‚¯ã‚¹ã‚’è²©å£²',0),(531716,14770,'pt','Vendido para a caixa',0),(531717,14770,'ru','ÐŸÑ€Ð¾Ð´Ð°ÐµÑ‚ÑÑ Ð² ÐºÐ¾Ñ€Ð¾Ð±ÐºÐµ',0),(531718,14770,'es','Vendido a la caja',0),(531719,14770,'de','Verkauft an Box',0),(531720,14770,'en','Sold To Box',0),(531721,14771,'is','',0),(531722,14771,'dr','Ù…ØªØºÛŒØ±',0),(531723,14771,'pr','Ù…ØªØºÛŒØ±',0),(531724,14771,'tr','DeÄŸiÅŸkenleri',0),(531725,14771,'pl','Zmienne',0),(531726,14771,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð»Ð¸Ð²Ð¸',0),(531727,14771,'ur','Ù…ØªØºÛŒØ±',0),(531728,14771,'sr','Ð’Ð°Ñ€Ð¸Ñ˜Ð°Ð±Ð»Ðµ',0),(531729,14771,'vi','Biáº¿n',0),(531730,14771,'af','Veranderlikes',0),(531731,14771,'ro','Variabile',0),(531732,14771,'et','Muutujad',0),(531733,14771,'si','Spremenljivke',0),(531734,14771,'ba','Variabel',0),(531735,14771,'nl','Variabelen',0),(531736,14771,'fi','Muuttujat',0),(531737,14771,'no','Variabler',0),(531738,14771,'da','Variabler',0),(531739,14771,'ko','ë³€ìˆ˜',0),(531740,14771,'he','×ž×©×ª× ×™×',0),(531741,14771,'el','ÎœÎµÏ„Î±Î²Î»Î·Ï„Î­Ï‚',0),(531742,14771,'zh','å˜é‡',0),(531743,14771,'sv','Variabler',0),(531744,14771,'it','Variabili',0),(531745,14771,'tl','',0),(531746,14771,'th','à¸•à¸±à¸§à¹à¸›à¸£',0),(531747,14771,'hi','à¤šà¤°',0),(531748,14771,'ms','Pemboleh ubah',0),(531749,14771,'ar','Ø§Ù„Ù…ØªØºÙŠØ±Ø§Øª',0),(531750,14771,'fr','Variables',0),(531751,14771,'jp','å¤‰æ•°',0),(531752,14771,'pt','VariÃ¡veis',0),(531753,14771,'ru','ÐŸÐµÑ€ÐµÐ¼ÐµÐ½Ð½Ñ‹Ðµ',0),(531754,14771,'es','Variables',0),(531755,14771,'de','Variablen',0),(531756,14771,'en','Variables',0),(531757,14772,'is','',0),(531758,14772,'dr','Ù†Ù…Ø§ÛŒØ´ ÙˆØ¶Ø¹ÛŒØª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø±Ø§ÛŒ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ±Ø¯',0),(531759,14772,'pr','Ù†Ù…Ø§ÛŒØ´ ÙˆØ¶Ø¹ÛŒØª Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø±Ø§ÛŒ Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ±Ø¯',0),(531760,14772,'tr','Stok durumlarÄ±nÄ± gÃ¶stermek iÃ§in Ã¶ÄŸe seÃ§enekleri',0),(531761,14772,'pl','Stan zapasÃ³w PokaÅ¼ opcje elementu',0),(531762,14772,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð° Ð·Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¾Ð¿Ñ†Ð¸Ð¸',0),(531763,14772,'ur','Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø­Ø§Ù„Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(531764,14772,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð·Ð° ÑÑ‚Ð°Ð²ÐºÑƒ Ð¾Ð¿Ñ†Ð¸Ñ˜Ðµ',0),(531765,14772,'vi','Hiá»ƒn thá»‹ tÃ¬nh tráº¡ng hÃ ng tá»“n kho cho má»¥c tÃ¹y chá»n',0),(531766,14772,'af','Inventaris Status wys vir Item opsies',0),(531767,14772,'ro','StÃ£rii de inventar pentru elementul opÅ£iuni',0),(531768,14772,'et','NÃ¤ita laoseisu olek Ã¼ksuse suvandid',0),(531769,14772,'si','PrikaÅ¾i stanje zaloge za artikel moÅ¾nosti',0),(531770,14772,'ba','Menunjukkan Status persediaan untuk Item pilihan',0),(531771,14772,'nl','Toon voorraadstatus voor Itemopties',0),(531772,14772,'fi','NÃ¤ytÃ¤ varaston tila kohteen asetukset',0),(531773,14772,'no','Vis Lagerstatus For elementet alternativer',0),(531774,14772,'da','Vis lagerstatus For elementet indstillinger',0),(531775,14772,'ko','í•­ëª© ì˜µì…˜ì— ëŒ€ í•œ ìž¬ê³  ìƒíƒœ ë³´ê¸°',0),(531776,14772,'he','×”×¦×’ ×ž×¦×‘ ×”×ž×œ××™ ×¢×‘×•×¨ ×”×¤×¨×™×˜ ××¤×©×¨×•×™×•×ª',0),(531777,14772,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï„Î¿Ï… Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î³Î¹Î± Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(531778,14772,'zh','æ˜¾ç¤ºåº“å­˜çŠ¶æ€çš„é¡¹ç›®é€‰é¡¹',0),(531779,14772,'sv','Visa lagerstatus fÃ¶r Objektalternativ',0),(531780,14772,'it','Mostrare lo stato di inventario per la voce opzioni',0),(531781,14772,'tl','',0),(531782,14772,'th','à¹à¸ªà¸”à¸‡à¸ªà¸–à¸²à¸™à¸°à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸',0),(531783,14772,'hi','à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¤²à¥à¤ª à¤¦à¤¿à¤–à¤¾à¤à¤',0),(531784,14772,'ms','Tayang Status Inventori bagi pilihan',0),(531785,14772,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø­Ø§Ù„Ø© Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù„Ù„ØµÙ†Ù Ø®ÙŠØ§Ø±Ø§Øª',0),(531786,14772,'fr','Afficher l\'Ã©tat de l\'inventaire pour les Options de l\'Ã©lÃ©ment',0),(531787,14772,'jp','é …ç›®ã®ã‚ªãƒ—ã‚·ãƒ§ãƒ³ã®ãŸã‚ã®ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒªã®ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(531788,14772,'pt','Mostrar Status de inventÃ¡rio para o Item opÃ§Ãµes',0),(531789,14772,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ ÑÑ‚Ð°Ñ‚ÑƒÑ Ð´Ð»Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹',0),(531790,14772,'es','Mostrar el estado de inventario para las opciones del artÃ­culo',0),(531791,14772,'de','Lagerstatus fÃ¼r Elementoptionen anzeigen',0),(531792,14772,'en','Show Inventory Status For Item Options',0),(531793,14773,'is','',0),(531794,14773,'dr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¹Ø¨Ø§Ø±ØªÙ†Ø¯ Ø§Ø²:',0),(531795,14773,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¹Ø¨Ø§Ø±ØªÙ†Ø¯ Ø§Ø²:',0),(531796,14773,'tr','Ä°ade faturalarÄ±na dahil',0),(531797,14773,'pl','ObejmujÄ… faktur korygujÄ…cych',0),(531798,14773,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð¸Ð·Ð²ÐµÑÑ‚Ð¸Ñ',0),(531799,14773,'ur','Ú©Ø±ÛŒÚˆÙ¹ ÛŒØ§Ø¯Ø¯Ø§Ø´ØªÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(531800,14773,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐ°',0),(531801,14773,'vi','Bao gá»“m báº£n ghi nhá»› tÃ­n dá»¥ng',0),(531802,14773,'af','Sluit krediet memo\'s',0),(531803,14773,'ro','Include note de Credit',0),(531804,14773,'et','Sisaldavad kreeditarved',0),(531805,14773,'si','VkljuÄujejo dobropisov',0),(531806,14773,'ba','Termasuk memo kredit',0),(531807,14773,'nl','Creditnota\'s opnemen',0),(531808,14773,'fi','MyÃ¶s hyvityslaskujen erÃ¤kirjaus',0),(531809,14773,'no','Inkluder kreditnotaer',0),(531810,14773,'da','Omfatte kreditnotaer',0),(531811,14773,'ko','ì‹ ìš© ë©”ëª¨ë¥¼ í¬í•¨',0),(531812,14773,'he','×›×•×œ×œ×•×ª ×ª×–×›×™×¨×™× ××©×¨××™',0),(531813,14773,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ¬ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(531814,14773,'zh','åŒ…æ‹¬è´·é¡¹é€šçŸ¥å•',0),(531815,14773,'sv','Inkludera kreditnotor',0),(531816,14773,'it','Includere le note di credito',0),(531817,14773,'tl','',0),(531818,14773,'th','à¸£à¸§à¸¡à¸«à¸™à¸µà¹‰',0),(531819,14773,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤®à¥‡à¤®à¥‹ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(531820,14773,'ms','Termasuk kredit memo',0),(531821,14773,'ar','ÙˆØªØ´Ù…Ù„ Ù…Ø°ÙƒØ±Ø§Øª Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(531822,14773,'fr','Inclure les notes de crÃ©dit',0),(531823,14773,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ãƒ» ãƒ¡ãƒ¢ã‚’å«ã‚ã‚‹',0),(531824,14773,'pt','Incluir notas de crÃ©dito',0),(531825,14773,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð¾Ñ‚',0),(531826,14773,'es','Incluir notas de crÃ©dito',0),(531827,14773,'de','Gutschriften sind',0),(531828,14773,'en','Include Credit Memos',0),(531829,14774,'is','',0),(531830,14774,'dr','3dcart ÙˆØ¶Ø¹ÛŒØª',0),(531831,14774,'pr','3dcart ÙˆØ¶Ø¹ÛŒØª',0),(531832,14774,'tr','3dcart durumu',0),(531833,14774,'pl','Stan 3dcart',0),(531834,14774,'bg','3dcart ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(531835,14774,'ur','3dcart Ú©ÛŒ Ø­Ø§Ù„Øª',0),(531836,14774,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(531837,14774,'vi','tÃ¬nh tráº¡ng 3dcart',0),(531838,14774,'af','3dcart Status',0),(531839,14774,'ro','3dcart statutul',0),(531840,14774,'et','3dcart staatus',0),(531841,14774,'si','3dcart stanje',0),(531842,14774,'ba','3dcart Status',0),(531843,14774,'nl','3dcart Status',0),(531844,14774,'fi','3dcart tila',0),(531845,14774,'no','3dcart Status',0),(531846,14774,'da','3dcart Status',0),(531847,14774,'ko','3dcart ìƒíƒœ',0),(531848,14774,'he','3dcart ×ž×¦×‘',0),(531849,14774,'el','3dcart ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(531850,14774,'zh','3dcart çŠ¶æ€',0),(531851,14774,'sv','3dcart Status',0),(531852,14774,'it','3Dcart Status',0),(531853,14774,'tl','',0),(531854,14774,'th','à¸ªà¸–à¸²à¸™à¸° 3dcart',0),(531855,14774,'hi','3dcart à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(531856,14774,'ms','3dcart Status',0),(531857,14774,'ar','Ù…Ø±ÙƒØ² 3dcart',0),(531858,14774,'fr','3Dcart statut',0),(531859,14774,'jp','3dcart ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(531860,14774,'pt','3Dcart Status',0),(531861,14774,'ru','3dcart ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(531862,14774,'es','3DCart Status',0),(531863,14774,'de','3dcart Status',0),(531864,14774,'en','3dcart Status',0),(531865,14775,'is','',0),(531866,14775,'dr','ØªÙ†Ø¸ÛŒÙ… ÙˆØ¶Ø¹ÛŒØª 3dcart Ù¾Ø±Ø¯Ø§Ø²Ø´',0),(531867,14775,'pr','ØªÙ†Ø¸ÛŒÙ… ÙˆØ¶Ø¹ÛŒØª 3dcart Ù¾Ø±Ø¯Ø§Ø²Ø´',0),(531868,14775,'tr','3dcart durumunu iÅŸleme iÃ§in ayarlama',0),(531869,14775,'pl','Ustaw stan 3dcart do przetwarzania',0),(531870,14775,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ 3dcart ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(531871,14775,'ur','Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ 3dcart Ø­Ø§Ù„Øª Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(531872,14775,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¾Ð±Ñ€Ð°Ð´Ðµ',0),(531873,14775,'vi','Äáº·t tráº¡ng thÃ¡i 3dcart Ä‘á»ƒ xá»­ lÃ½',0),(531874,14775,'af','Stel 3dcart Status na verwerking',0),(531875,14775,'ro','SetaÈ›i starea 3dcart la prelucrarea',0),(531876,14775,'et','Seada 3dcart oleku tÃ¶Ã¶tlemine',0),(531877,14775,'si','Nastavi stanje 3dcart za obdelavo',0),(531878,14775,'ba','Menetapkan 3dcart Status untuk pengolahan',0),(531879,14775,'nl','3dcart Status instellen op Processing',0),(531880,14775,'fi','Aseta 3dcart kÃ¤sittely',0),(531881,14775,'no','Sett 3dcart Status til behandling',0),(531882,14775,'da','SÃ¦t 3dcart Status til forarbejdning',0),(531883,14775,'ko','3dcart ìƒíƒœ ì²˜ë¦¬ë¥¼ ì„¤ì •',0),(531884,14775,'he','×”×’×“×¨ ×ž×¦×‘ 3dcart ×¢×™×‘×•×“',0),(531885,14775,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ 3dcart ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(531886,14775,'zh','å°† 3dcart çŠ¶æ€è®¾ç½®ä¸ºå¤„ç†',0),(531887,14775,'sv','Ange 3dcart Status till bearbetning',0),(531888,14775,'it','Impostare lo stato 3dcart all\'elaborazione',0),(531889,14775,'tl','',0),(531890,14775,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸–à¸²à¸™à¸° 3dcart à¹€à¸žà¸·à¹ˆà¸­à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥',0),(531891,14775,'hi','3dcart à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(531892,14775,'ms','Ditetapkan 3dcart Status pemprosesan',0),(531893,14775,'ar','ØªØ¹ÙŠÙŠÙ† Ù…Ø±ÙƒØ² 3dcart Ù„ØªØ¬Ù‡ÙŠØ²',0),(531894,14775,'fr','La valeur Status 3dcart traitement',0),(531895,14775,'jp','3dcart çŠ¶æ…‹ã®å‡¦ç†ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(531896,14775,'pt','Definir Status de 3dcart para processamento',0),(531897,14775,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ 3dcart ÑÑ‚Ð°Ñ‚ÑƒÑ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸',0),(531898,14775,'es','Definir estado 3dcart al procesamiento',0),(531899,14775,'de','3dcart Status Verarbeitung setzen',0),(531900,14775,'en','Set 3dcart Status To Processing',0),(531901,14776,'is','',0),(531902,14776,'dr','3dcart ØªÙ†Ø¸ÛŒÙ… ÙˆØ¶Ø¹ÛŒØª Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¨Ø±Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨',0),(531903,14776,'pr','3dcart ØªÙ†Ø¸ÛŒÙ… ÙˆØ¶Ø¹ÛŒØª Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø¨Ø±Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨',0),(531904,14776,'tr','Set 3dcart durumu iÅŸleme iÃ§in seÃ§ilen',0),(531905,14776,'pl','Stan zestaw 3dcart do przetwarzania dla wybranych',0),(531906,14776,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ 3dcart ÑÑ‚Ð°Ñ‚ÑƒÑ Ð½Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(531907,14776,'ur','Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº 3dcart Ø­ÛŒØ«ÛŒØª Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§',0),(531908,14776,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¾Ð±Ñ€Ð°Ð´Ðµ Ð·Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸',0),(531909,14776,'vi','Thiáº¿t láº­p 3dcart tÃ¬nh tráº¡ng Ä‘á»ƒ xá»­ lÃ½ cho lá»±a chá»n',0),(531910,14776,'af','Stel 3dcart Status na verwerking vir gekies',0),(531911,14776,'ro','Set 3dcart statutul de prelucrare pentru selectat',0),(531912,14776,'et','Sea 3dcart staatuse tÃ¶Ã¶tlemise jaoks valitud',0),(531913,14776,'si','Status Set 3dcart obdelavo za izbrane',0),(531914,14776,'ba','Set 3dcart Status pengolahan untuk dipilih',0),(531915,14776,'nl','Instellen 3dcart Status op verwerking voor geselecteerd',0),(531916,14776,'fi','Aseta 3dcart tila kÃ¤sittelyyn valittu',0),(531917,14776,'no','Sett 3dcart Status til behandling For valgt',0),(531918,14776,'da','SÃ¦t 3dcart Status til behandling For udvalgte',0),(531919,14776,'ko','Set 3dcart ìƒíƒœì— ëŒ€ í•œ ì²˜ë¦¬ë¥¼ ì„ ì •',0),(531920,14776,'he','3dcart ×”×’×“×¨×ª ×ž×¦×‘ ×”×¢×™×‘×•×“ ×¢×‘×•×¨ × ×‘×—×¨×ª',0),(531921,14776,'el','Î£ÎµÏ„ 3dcart ÎºÎ±Î¸ÎµÏƒÏ„ÏŽÏ‚ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î³Î¹Î± ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚',0),(531922,14776,'zh','è®¾ç½®çš„ 3dcart çŠ¶æ€å¤„ç†çš„é€‰æ‹©',0),(531923,14776,'sv','Set 3dcart Status till bearbetning fÃ¶r utvalda',0),(531924,14776,'it','3dcart set Status di elaborazione per selezionati',0),(531925,14776,'tl','',0),(531926,14776,'th','à¹€à¸¥à¸·à¸­à¸ 3dcart à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸–à¸²à¸™à¸°à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥',0),(531927,14776,'hi','à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚ 3dcart à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¯à¤¨à¤¿à¤¤',0),(531928,14776,'ms','Set 3dcart Status pemprosesan untuk dipilih',0),(531929,14776,'ar','3dcart ØªØ¹ÙŠÙŠÙ† Ù…Ø±ÙƒØ² Ù„Ù„Ù…Ø¹Ø§Ù„Ø¬Ø© Ù„ØªØ­Ø¯ÙŠØ¯',0),(531930,14776,'fr','Set 3dcart statut de traitement pour sÃ©lectionnÃ©',0),(531931,14776,'jp','ã‚»ãƒƒãƒˆ 3dcart çŠ¶æ…‹ã®å‡¦ç†ã‚’é¸æŠž',0),(531932,14776,'pt','3dcart definir Status de processamento para selecionado',0),(531933,14776,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° 3dcart ÑÑ‚Ð°Ñ‚ÑƒÑ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸ Ð´Ð»Ñ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾',0),(531934,14776,'es','Conjunto 3dcart estado de procesamiento para selecciona',0),(531935,14776,'de','Set 3dcart-Status Verarbeitung fÃ¼r ausgewÃ¤hlt',0),(531936,14776,'en','Set 3dcart Status To Processing For Selected',0),(531937,14777,'is','',0),(531938,14777,'dr','Ø¹Ù…Ù„ Ø³Ù‚Ø·',0),(531939,14777,'pr','Ø¹Ù…Ù„ Ø³Ù‚Ø·',0),(531940,14777,'tr','Eylem iptal edildi',0),(531941,14777,'pl','Akcja przerwana',0),(531942,14777,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸ÐµÑ‚Ð¾ Ðµ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‚ÐµÐ½Ð¾',0),(531943,14777,'ur','Ø¹Ù…Ù„ Ú©Ùˆ Ø³Ø§Ù‚Ø· Ú©Ø± Ø¯ÛŒØ§',0),(531944,14777,'sr','ÐÐºÑ†Ð¸Ñ˜Ð° Ñ˜Ðµ Ð¾Ð±ÑƒÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°',0),(531945,14777,'vi','HÃ nh Ä‘á»™ng bá»‹ há»§y bá»',0),(531946,14777,'af','Aksie gestaak',0),(531947,14777,'ro','AcÅ£iune anulatÄƒ',0),(531948,14777,'et','Tegevus katkestati',0),(531949,14777,'si','Dejanje prekinjeno',0),(531950,14777,'ba','Tindakan yang dibatalkan',0),(531951,14777,'nl','Actie afgebroken',0),(531952,14777,'fi','Toiminto keskeytettiin',0),(531953,14777,'no','Handlingen ble avbrutt',0),(531954,14777,'da','Handling afbrudt',0),(531955,14777,'ko','ìž‘ì—… ì¤‘ë‹¨',0),(531956,14777,'he','×”×¤×¢×•×œ×” ×‘×•×˜×œ×”',0),(531957,14777,'el','Î”ÏÎ¬ÏƒÎ· Î¼Î±Ï„Î±Î¹ÏŽÎ¸Î·ÎºÎµ',0),(531958,14777,'zh','æ“ä½œå·²ä¸­æ­¢',0),(531959,14777,'sv','Ã…tgÃ¤rden avbrÃ¶ts',0),(531960,14777,'it','Azione interrotta',0),(531961,14777,'tl','',0),(531962,14777,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£',0),(531963,14777,'hi','à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤¨à¤¿à¤°à¤¸à¥à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(531964,14777,'ms','Tindakan dibatalkan',0),(531965,14777,'ar','ØªÙ… Ø¥Ø­Ø¨Ø§Ø· Ø§Ù„Ø¹Ù…Ù„',0),(531966,14777,'fr','Action annulÃ©e',0),(531967,14777,'jp','å‡¦ç†ã‚’ä¸­æ–­',0),(531968,14777,'pt','AÃ§Ã£o abortada',0),(531969,14777,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹ Ð¿Ñ€ÐµÑ€Ð²Ð°Ð½Ð°',0),(531970,14777,'es','AcciÃ³n abortada',0),(531971,14777,'de','Aktion abgebrochen',0),(531972,14777,'en','Action Aborted',0),(531973,14778,'is','',0),(531974,14778,'dr','Ù…Ø¹Ø±ÙÛŒ Ø´Ø±Ú©Øª ÙØ¹Ø§Ù„ ØªØºÛŒÛŒØ±',0),(531975,14778,'pr','Ù…Ø¹Ø±ÙÛŒ Ø´Ø±Ú©Øª ÙØ¹Ø§Ù„ ØªØºÛŒÛŒØ±',0),(531976,14778,'tr','Etkin ÅŸirket deÄŸiÅŸti',0),(531977,14778,'pl','Aktywny firma zmieniÅ‚a',0),(531978,14778,'bg','ÐÐºÑ‚Ð¸Ð²Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(531979,14778,'ur','ÙØ¹Ø§Ù„ Ú©Ù…Ù¾Ù†ÛŒ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(531980,14778,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ Ð¿Ñ€ÐµÐ´ÑƒÐ·ÐµÑ›Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ð»Ð¾',0),(531981,14778,'vi','CÃ´ng ty hoáº¡t Ä‘á»™ng thay Ä‘á»•i',0),(531982,14778,'af','Aktiewe maatskappy verander',0),(531983,14778,'ro','Firma activ schimbat',0),(531984,14778,'et','Aktiivse ettevÃµte muutunud',0),(531985,14778,'si','Aktivno podjetje spremenila',0),(531986,14778,'ba','Perusahaan aktif yang berubah',0),(531987,14778,'nl','Actieve bedrijf gewijzigd',0),(531988,14778,'fi','Aktiivinen-yhtiÃ¶ muuttuneet',0),(531989,14778,'no','Aktiv selskapet endret',0),(531990,14778,'da','Aktiv firma Ã¦ndret',0),(531991,14778,'ko','ì•¡í‹°ë¸Œ íšŒì‚¬ ë³€ê²½',0),(531992,14778,'he','×”×—×‘×¨×” ×¤×¢×™×œ×” ×”×©×ª× ×”',0),(531993,14778,'el','Î•Î½ÎµÏÎ³ÏŒ ÎµÏ„Î±Î¹ÏÎµÎ¯Î± Î¬Î»Î»Î±Î¾Îµ',0),(531994,14778,'zh','æ´»è·ƒå…¬å¸å˜æ›´',0),(531995,14778,'sv','Aktiva fÃ¶retag fÃ¶rÃ¤ndrats',0),(531996,14778,'it','Azienda attiva cambiato',0),(531997,14778,'tl','',0),(531998,14778,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸­à¸¢à¸¹à¹ˆà¸—à¸µà¹ˆà¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(531999,14778,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤‚à¤ªà¤¨à¥€ à¤¬à¤¦à¤² à¤—à¤ˆ',0),(532000,14778,'ms','Syarikat aktif yang ditukar',0),(532001,14778,'ar','Ø´Ø±ÙƒØ© Ù†Ø´Ø·Ø© ØªØºÙŠØ±Øª',0),(532002,14778,'fr','SociÃ©tÃ© active a changÃ©',0),(532003,14778,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ç¤¾å',0),(532004,14778,'pt','Ativo empresa mudou',0),(532005,14778,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ð»Ð°ÑÑŒ',0),(532006,14778,'es','Empresa activa cambiado',0),(532007,14778,'de','Aktiv-Umfirmierung',0),(532008,14778,'en','Active Company Changed',0),(532009,14779,'is','',0),(532010,14779,'dr','ØªÙ…Ø§Ù… Ù…Ø§Ù‡ Ø±Ø§ Ù‡Ù…Ø§Ù† Ù…Ø§Ù‡ Ø§ÙˆÙ„',0),(532011,14779,'pr','ØªÙ…Ø§Ù… Ù…Ø§Ù‡ Ø±Ø§ Ù‡Ù…Ø§Ù† Ù…Ø§Ù‡ Ø§ÙˆÙ„',0),(532012,14779,'tr','Her ay ilk ay gibi',0),(532013,14779,'pl','Aby wszystkie miesiÄ…ce sam jako pierwszy miesiÄ…c',0),(532014,14779,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¼ÐµÑÐµÑ†Ð¸ ÑÑŠÑ‰Ð¾ ÐºÐ°Ñ‚Ð¾ Ð¿ÑŠÑ€Ð²Ð¸Ñ Ð¼ÐµÑÐµÑ†',0),(532015,14779,'ur','Ø¯Û’ Ø³Ø§Ø±Û’ Ù…ÛÛŒÙ†ÙˆÚº Ù¾ÛÙ„Û’ Ù…ÛÛŒÙ†Û’ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§ÛŒÚ© ÛÛŒ',0),(532016,14779,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ ÑÐ²Ðµ Ð¼ÐµÑÐµÑ†Ðµ Ð¸ÑÑ‚Ð¾ ÐºÐ°Ð¾ Ð¸ Ð¿Ñ€Ð²Ð¸ Ð¼ÐµÑÐµÑ†',0),(532017,14779,'vi','LÃ m cho táº¥t cáº£ cÃ¡c thÃ¡ng giá»‘ng nhÆ° thÃ¡ng Ä‘áº§u tiÃªn',0),(532018,14779,'af','Maak alle maande dieselfde As die eerste maand',0),(532019,14779,'ro','Face toate luni la fel ca prima luna',0),(532020,14779,'et','KÃµik kuud teha sama mis esimene kuu',0),(532021,14779,'si','Naredite vse mesece enako kot prvi mesec',0),(532022,14779,'ba','Membuat semua bulan sama seperti bulan pertama',0),(532023,14779,'nl','Maken al maanden hetzelfde als eerste maand',0),(532024,14779,'fi','Kaikki kuukaudet tehdÃ¤ sama kuin ensimmÃ¤isen kuukauden',0),(532025,14779,'no','GjÃ¸re alle mÃ¥neder samme som fÃ¸rste mÃ¥neden',0),(532026,14779,'da','GÃ¸re alle mÃ¥neder samme som fÃ¸rste mÃ¥ned',0),(532027,14779,'ko','ëª¨ë“  ë‹¬ ê²Œ ì²« ë‹¬ ë™ì¼',0),(532028,14779,'he','×œ×”×¤×•×š ××ª ×›×œ ×”×—×•×“×©×™× ×‘×“×™×•×§ ×›×ž×• ×‘×—×•×“×© ×”×¨××©×•×Ÿ',0),(532029,14779,'el','ÎšÎ¬Î½ÎµÎ¹ ÏŒÎ»Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ Î¼Î®Î½ÎµÏ‚ Î¯Î´Î¹Î± Ï‰Ï‚ Ï€ÏÏŽÏ„Î¿ Î¼Î®Î½Î±',0),(532030,14779,'zh','ä½¿æ‰€æœ‰æœˆä»½ç›¸åŒçš„ç¬¬ä¸€ä¸ªæœˆ',0),(532031,14779,'sv','GÃ¶ra alla mÃ¥nader samma som fÃ¶rsta mÃ¥naden',0),(532032,14779,'it','Fare tutti i mesi come primo mese',0),(532033,14779,'tl','',0),(532034,14779,'th','à¸—à¸³à¹ƒà¸«à¹‰à¸—à¸¸à¸à¹€à¸”à¸·à¸­à¸™à¹€à¸«à¸¡à¸·à¸­à¸™à¹€à¸”à¸·à¸­à¸™à¹à¸£à¸',0),(532035,14779,'hi','à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤¸à¤­à¥€ à¤®à¤¹à¥€à¤¨à¥‹à¤‚ à¤ªà¤¹à¤²à¥‡ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤à¤• à¤¹à¥€',0),(532036,14779,'ms','Membuat semua bulan sama sebagai bulan pertama',0),(532037,14779,'ar','Ø¬Ø¹Ù„ ÙƒØ§ÙØ© Ø§Ù„Ø£Ø´Ù‡Ø± Ù†ÙØ³ Ø§Ù„Ø´Ù‡Ø± Ø§Ù„Ø£ÙˆÙ„',0),(532038,14779,'fr','Faire tous les mois mÃªme comme premier mois',0),(532039,14779,'jp','ã™ã¹ã¦ã®æœˆã‚’ä½œã‚‹æœ€åˆã®æœˆã¨åŒã˜',0),(532040,14779,'pt','Fazer todos os meses mesmo que o primeiro mÃªs',0),(532041,14779,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð²ÑÐµÑ… Ð¼ÐµÑÑÑ†ÐµÐ² Ñ‚Ð¾ Ð¶Ðµ, Ñ‡Ñ‚Ð¾ Ð¿ÐµÑ€Ð²Ñ‹Ð¹ Ð¼ÐµÑÑÑ†',0),(532042,14779,'es','Hacer todos los meses como primer mes',0),(532043,14779,'de','Alle Monate zu machen wie im ersten Monat',0),(532044,14779,'en','Make All Months Same As First Month',0),(532045,14780,'is','',0),(532046,14780,'dr','Ø´Ø§Ù…Ù„ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(532047,14780,'pr','Ø´Ø§Ù…Ù„ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(532048,14780,'tr','Silinen hesaplar dahil',0),(532049,14780,'pl','ObejmowaÄ‡ konta usuniÄ™te',0),(532050,14780,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ð˜Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸',0),(532051,14780,'ur','Ø­Ø°Ù Ø´Ø¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(532052,14780,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(532053,14780,'vi','Bao gá»“m cÃ¡c tÃ i khoáº£n Ä‘Ã£ xÃ³a',0),(532054,14780,'af','Geskrapte rekeninge insluit',0),(532055,14780,'ro','Includ conturi ÅŸterse',0),(532056,14780,'et','Kustutatud kontod',0),(532057,14780,'si','VkljuÄujejo Izbrisani raÄuni',0),(532058,14780,'ba','Menyertakan account dihapus',0),(532059,14780,'nl','Verwijderde Accounts opnemen',0),(532060,14780,'fi','SisÃ¤llytÃ¤ Poistetut tilit',0),(532061,14780,'no','Slettede kontoer',0),(532062,14780,'da','Omfatte slettede konti',0),(532063,14780,'ko','ì‚­ì œ ëœ ê³„ì • í¬í•¨',0),(532064,14780,'he','×œ×›×œ×•×œ ×—×©×‘×•× ×•×ª × ×ž×—×§×•',0),(532065,14780,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î´Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯',0),(532066,14780,'zh','åŒ…æ‹¬å·²åˆ é™¤çš„å¸æˆ·',0),(532067,14780,'sv','Inkludera borttagna konton',0),(532068,14780,'it','Includono gli account cancellati',0),(532069,14780,'tl','',0),(532070,14780,'th','à¸£à¸§à¸¡à¸šà¸±à¸à¸Šà¸µà¸—à¸µà¹ˆà¸–à¸¹à¸à¸¥à¸š',0),(532071,14780,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤–à¤¾à¤¤à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(532072,14780,'ms','Termasuk akaun dihapuskan',0),(532073,14780,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…Ø­Ø°ÙˆÙØ©',0),(532074,14780,'fr','Inclure les comptes supprimÃ©s',0),(532075,14780,'jp','å‰Šé™¤ã•ã‚ŒãŸã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å«ã‚ã‚‹',0),(532076,14780,'pt','Incluir contas deletadas',0),(532077,14780,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ Ð°ÐºÐºÐ°ÑƒÐ½Ñ‚Ñ‹',0),(532078,14780,'es','Incluyen cuentas borradas',0),(532079,14780,'de','Sind z. B. gelÃ¶schte Konten',0),(532080,14780,'en','Include Deleted Accounts',0),(532081,14781,'is','',0),(532082,14781,'dr','ÙÙ‚Ø· Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø®Ø§Øµ',0),(532083,14781,'pr','ÙÙ‚Ø· Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø®Ø§Øµ',0),(532084,14781,'tr','YalnÄ±zca belirli bir mÃ¼ÅŸteri iÃ§in',0),(532085,14781,'pl','Tylko dla konkretnego klienta',0),(532086,14781,'bg','Ð¡Ð°Ð¼Ð¾ Ð·Ð° ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚ÐµÐ½ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(532087,14781,'ur','ØµØ±Ù Ù…Ø®ØµÙˆØµ Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ù„Ø¦Û’',0),(532088,14781,'sr','Ð¡Ð°Ð¼Ð¾ Ð·Ð° Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð°',0),(532089,14781,'vi','Chá»‰ cho khÃ¡ch hÃ ng cá»¥ thá»ƒ',0),(532090,14781,'af','Slegs vir spesifieke kliÃ«nt',0),(532091,14781,'ro','Numai pentru specifice clientului',0),(532092,14781,'et','Ainult konkreetse kliendi jaoks',0),(532093,14781,'si','Samo za doloÄenega kupca',0),(532094,14781,'ba','Hanya untuk nasabah tertentu',0),(532095,14781,'nl','Alleen voor specifieke klant',0),(532096,14781,'fi','Tietyn asiakkaalle',0),(532097,14781,'no','Bare For bestemt kunde',0),(532098,14781,'da','Kun For specifikke kunde',0),(532099,14781,'ko','íŠ¹ì • ê³ ê°ì— ëŒ€ í•œ',0),(532100,14781,'he','×¨×§ ×¢×‘×•×¨ ×œ×§×•×— ×¡×¤×¦×™×¤×™',0),(532101,14781,'el','ÎœÏŒÎ½Î¿ Î³Î¹Î± ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Ï€ÎµÎ»Î¬Ï„Î·',0),(532102,14781,'zh','åªä¸ºç‰¹å®šå®¢æˆ·',0),(532103,14781,'sv','Endast fÃ¶r specifik kund',0),(532104,14781,'it','Solo per la specifica del cliente',0),(532105,14781,'tl','',0),(532106,14781,'th','à¸ªà¸³à¸«à¸£à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸‰à¸žà¸²à¸°à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(532107,14781,'hi','à¤•à¥‡à¤µà¤² à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤',0),(532108,14781,'ms','Hanya untuk pelanggan tertentu',0),(532109,14781,'ar','ÙÙ‚Ø· Ù„Ø¹Ù…ÙŠÙ„ Ù…Ø¹ÙŠÙ†',0),(532110,14781,'fr','Seulement pour le client spÃ©cifique',0),(532111,14781,'jp','ç‰¹å®šã®é¡§å®¢ã«å¯¾ã—ã¦ã®ã¿',0),(532112,14781,'pt','SÃ³ para cliente especÃ­fico',0),(532113,14781,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ð¾Ð³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(532114,14781,'es','SÃ³lo para clientes especÃ­ficos',0),(532115,14781,'de','Nur fÃ¼r bestimmte Kunden',0),(532116,14781,'en','Only For Specific Customer',0),(532117,14782,'is','',0),(532118,14782,'dr','Ø§ÛŒÙ…ÛŒÙ„ ÛŒÚ© Ù†Ø¸Ø±',0),(532119,14782,'pr','Ø§ÛŒÙ…ÛŒÙ„ ÛŒÚ© Ù†Ø¸Ø±',0),(532120,14782,'tr','Bir yorum-posta',0),(532121,14782,'pl','Napisz jeden komentarz',0),(532122,14782,'bg','ÐŸÐ¸ÑˆÐµÑ‚Ðµ ÐµÐ´Ð¸Ð½ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(532123,14782,'ur','Ø§ÛŒÚ© ØªØ¨ØµØ±Û Ú©ÛŒØ§ Ú¯ÛŒØ§ Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(532124,14782,'sr','Ð• -Ð¿Ð¾ÑˆÑ‚Ð° 1 ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(532125,14782,'vi','Gá»­i email cho má»™t bÃ¬nh luáº­n',0),(532126,14782,'af','Een kommentaar per e-pos',0),(532127,14782,'ro','E-mail un comentariu',0),(532128,14782,'et','E-Ã¼ks kommentaar',0),(532129,14782,'si','Email en komentar',0),(532130,14782,'ba','Email satu komentar',0),(532131,14782,'nl','E-mail een commentaar',0),(532132,14782,'fi','Yksi kommentti',0),(532133,14782,'no','Sende en kommentar',0),(532134,14782,'da','Email en kommentar',0),(532135,14782,'ko','í•˜ë‚˜ì˜ ì½”ë©˜íŠ¸ë¥¼ ì´ë©”ì¼',0),(532136,14782,'he','×“×•× ×œ ×ª×’×•×‘×” ××—×ª',0),(532137,14782,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Î­Î½Î± ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(532138,14782,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€ä¸€ä¸ªè¯„è®º',0),(532139,14782,'sv','E-posta en kommentar',0),(532140,14782,'it','E-mail un commento',0),(532141,14782,'tl','',0),(532142,14782,'th','à¹€à¸«à¹‡à¸™à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(532143,14782,'hi','à¤à¤• à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤•à¥‹ à¤ˆà¤®à¥‡à¤²',0),(532144,14782,'ms','E-mel satu komen',0),(532145,14782,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ ØªØ¹Ù„ÙŠÙ‚ ÙˆØ§Ø­Ø¯',0),(532146,14782,'fr','Envoyez un commentaire',0),(532147,14782,'jp','1 ã¤ã®ã‚³ãƒ¡ãƒ³ãƒˆã‚’ãƒ¡ãƒ¼ãƒ«ã—ã¾ã™ã€‚',0),(532148,14782,'pt','Envie um comentÃ¡rio',0),(532149,14782,'ru','ÐžÐ´Ð¸Ð½ ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(532150,14782,'es','Uno de los comentarios por correo electrÃ³nico',0),(532151,14782,'de','E-Mail-ein Kommentar',0),(532152,14782,'en','Email One Comment',0),(532153,14783,'is','',0),(532154,14783,'dr','Ø§ÛŒÙ…ÛŒÙ„ Ø¯Ùˆ Ù†Ø¸Ø±',0),(532155,14783,'pr','Ø§ÛŒÙ…ÛŒÙ„ Ø¯Ùˆ Ù†Ø¸Ø±',0),(532156,14783,'tr','Ä°ki yorum e-posta',0),(532157,14783,'pl','Napisz komentarz dwa',0),(532158,14783,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð´Ð²Ðµ ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€',0),(532159,14783,'ur','Ø¯Ùˆ ØªØ¨ØµØ±Û Ú©Ùˆ Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(532160,14783,'sr','Ð• -2 ÐºÐ¾Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð°',0),(532161,14783,'vi','Gá»­i email cho hai bÃ¬nh luáº­n',0),(532162,14783,'af','Twee kommentaar per e-pos',0),(532163,14783,'ro','E-mail douÄƒ comentariu',0),(532164,14783,'et','Kirjuta kaks kommentaari',0),(532165,14783,'si','Email dve komentar',0),(532166,14783,'ba','Email dua komentar',0),(532167,14783,'nl','E-mail twee commentaar',0),(532168,14783,'fi','Email kaksi kommentti',0),(532169,14783,'no','Send to kommentar',0),(532170,14783,'da','Email to kommentar',0),(532171,14783,'ko','2 ê°œì˜ ì½”ë©˜íŠ¸ ì´ë©”ì¼',0),(532172,14783,'he','×“×•× ×œ ×©×ª×™ ×”×¢×¨×•×ª',0),(532173,14783,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ Î´ÏÎ¿ ÏƒÏ‡ÏŒÎ»Î¹Î¿',0),(532174,14783,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€ä¸¤ä¸ªæ³¨é‡Š',0),(532175,14783,'sv','Maila tvÃ¥ kommentar',0),(532176,14783,'it','E-mail due commento',0),(532177,14783,'tl','',0),(532178,14783,'th','à¸„à¸§à¸²à¸¡à¸„à¸´à¸”à¹€à¸«à¹‡à¸™ 2 à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(532179,14783,'hi','à¤¦à¥‹ à¤Ÿà¤¿à¤ªà¥à¤ªà¤£à¥€ à¤•à¥‹ à¤ˆà¤®à¥‡à¤²',0),(532180,14783,'ms','E-mel komen dua',0),(532181,14783,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ ØªØ¹Ù„ÙŠÙ‚ Ø§Ø«Ù†ÙŠÙ†',0),(532182,14783,'fr','Envoyez deux commentaire',0),(532183,14783,'jp','2 ã¤ã®ã‚³ãƒ¡ãƒ³ãƒˆã‚’ãƒ¡ãƒ¼ãƒ«ã—ã¾ã™ã€‚',0),(532184,14783,'pt','E-mail comentÃ¡rio dois',0),(532185,14783,'ru','Ð”Ð²Ð° ÐºÐ¾Ð¼Ð¼ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð¹ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(532186,14783,'es','Correo electrÃ³nico dos comentario',0),(532187,14783,'de','E-Mail zwei Kommentar',0),(532188,14783,'en','Email Two Comment',0),(532189,14784,'is','',0),(532190,14784,'dr','Ù†Ø§Ù… Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(532191,14784,'pr','Ù†Ø§Ù… Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(532192,14784,'tr','Tam adÄ±',0),(532193,14784,'pl','ImiÄ™ i nazwisko',0),(532194,14784,'bg','ÐŸÑŠÐ»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(532195,14784,'ur','Ù…Ú©Ù…Ù„ Ù†Ø§Ù…',0),(532196,14784,'sr','Ð˜Ð¼Ðµ Ð¸ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(532197,14784,'vi','TÃªn Ä‘áº§y Ä‘á»§',0),(532198,14784,'af','Volle naam',0),(532199,14784,'ro','Nume complet',0),(532200,14784,'et','TÃ¤isnimi',0),(532201,14784,'si','Polno ime',0),(532202,14784,'ba','Nama lengkap',0),(532203,14784,'nl','Volledige naam',0),(532204,14784,'fi','Koko nimi',0),(532205,14784,'no','Fullt navn',0),(532206,14784,'da','Fulde navn',0),(532207,14784,'ko','ì „ì²´ ì´ë¦„',0),(532208,14784,'he','×©× ×ž×œ×',0),(532209,14784,'el','ÎŸÎ½Î¿Î¼Î±Ï„ÎµÏ€ÏŽÎ½Ï…Î¼Î¿',0),(532210,14784,'zh','å…¨å',0),(532211,14784,'sv','FullstÃ¤ndigt namn',0),(532212,14784,'it','Nome e cognome',0),(532213,14784,'tl','',0),(532214,14784,'th','à¸Šà¸·à¹ˆà¸­à¹€à¸•à¹‡à¸¡',0),(532215,14784,'hi','à¤ªà¥‚à¤°à¤¾ à¤¨à¤¾à¤®',0),(532216,14784,'ms','Nama penuh',0),(532217,14784,'ar','Ø§Ù„Ø§Ø³Ù… Ø§Ù„ÙƒØ§Ù…Ù„',0),(532218,14784,'fr','Nom et prÃ©nom',0),(532219,14784,'jp','å®Œå…¨ãªåå‰',0),(532220,14784,'pt','Nome completo',0),(532221,14784,'ru','ÐŸÐ¾Ð»Ð½Ð¾Ðµ Ð¸Ð¼Ñ',0),(532222,14784,'es','Nombre completo',0),(532223,14784,'de','VollstÃ¤ndiger Name',0),(532224,14784,'en','Full Name',0),(532225,14785,'is','',0),(532226,14785,'dr','ØªÙˆØ¬Ù‡: ØªØ±Ø¬Ù…Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· Ø³Ø±ÙˆÛŒØ³ Ø®ÙˆØ¯Ú©Ø§Ø± Ùˆ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø¯Ù‚ÛŒÙ‚ Ù†Ø¨Ø§Ø´Ø¯.',0),(532227,14785,'pr','ØªÙˆØ¬Ù‡: ØªØ±Ø¬Ù…Ù‡ Ø§ÙˆÙ„ÛŒÙ‡ Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· Ø³Ø±ÙˆÛŒØ³ Ø®ÙˆØ¯Ú©Ø§Ø± Ùˆ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø¯Ù‚ÛŒÙ‚ Ù†Ø¨Ø§Ø´Ø¯.',0),(532228,14785,'tr','Dikkat: Ä°lk Ã§evirileri otomatik bir servis tarafÄ±ndan saÄŸlanmaktadÄ±r ve tam olmayabilir.',0),(532229,14785,'pl','Uwaga: TÅ‚umaczenia wstÄ™pnego sÄ… dostarczane przez automatyczny serwis i nie moÅ¼e byÄ‡ dokÅ‚adne.',0),(532230,14785,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ°: ÐŸÑŠÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»Ð½Ð¾ Ð¿Ñ€ÐµÐ²Ð¾Ð´Ð¸ ÑÐµ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²ÑÑ‚ Ð¾Ñ‚ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÐ½ ÑƒÑÐ»ÑƒÐ³Ð° Ð¸ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ñ‚Ð¾Ñ‡Ð½Ð°.',0),(532231,14785,'ur','Ù†ÙˆÙ¹Ø³: Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØªØ±Ø¬Ù…Û’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§ÛŒÚ© Ø®ÙˆØ¯ Ú©Ø§Ø± Ø®Ø¯Ù…Øª ÙØ±Ø§ÛÙ… Ú©ÛŒ Ø¬Ø§ØªÛŒ ÛÛŒÚº Ø§ÙˆØ± ØµØ­ÛŒØ­ Ù†Û ÛÙˆ Û”',0),(532232,14785,'sr','ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð° : ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¾ Ð¿Ñ€ÐµÐ²Ð¾Ð´Ðµ Ð½ÑƒÐ´Ð¸ ÑƒÑÐ»ÑƒÐ³Ðµ Ð½Ð° Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ð·Ð¾Ð²Ð°Ð½ Ð¸ Ð¼Ð¾Ð¶Ð´Ð° Ð½Ð¸Ñ˜Ðµ Ñ‚Ð°Ñ‡Ð°Ð½.',0),(532233,14785,'vi','ThÃ´ng bÃ¡o: Ban Ä‘áº§u cá»§a báº¡n báº£n dá»‹ch Ä‘Æ°á»£c cung cáº¥p bá»Ÿi má»™t dá»‹ch vá»¥ tá»± Ä‘á»™ng vÃ  cÃ³ thá»ƒ khÃ´ng Ä‘Æ°á»£c chÃ­nh xÃ¡c.',0),(532234,14785,'af','Kennisgewing: Aanvanklike vertalings word verskaf deur \'n outomatiese diens en mag nie presiese.',0),(532235,14785,'ro','ANUNÅ¢: IniÅ£ialÄƒ traduceri sunt furnizate de un serviciu automat ÅŸi nu poate fi exactÄƒ.',0),(532236,14785,'et','Teadaanne: Esialgne tÃµlked automatiseeritud teenust osutab ja ei pruugi olla tÃ¤pne.',0),(532237,14785,'si','Obvestilo: ZaÄetno prevodi opravlja avtomatizirano storitev in ne sme biti toÄen.',0),(532238,14785,'ba','Pemberitahuan: Awal terjemahan yang disediakan oleh layanan otomatis dan mungkin tidak tepat.',0),(532239,14785,'nl','Let op: Eerste vertalingen worden ondersteund door een geautomatiseerde service en kunnen niet exact worden.',0),(532240,14785,'fi','Varoitus: EnsimmÃ¤iset kÃ¤Ã¤nnÃ¶kset tarjotaan automatisoitu palvelua ja vÃ¤lttÃ¤mÃ¤ttÃ¤ ole tarkkoja.',0),(532241,14785,'no','Merknad: FÃ¸rste oversettelser leveres av en automatisert tjeneste og kan ikke vÃ¦re nÃ¸yaktig.',0),(532242,14785,'da','BemÃ¦rk: Indledende oversÃ¦ttelser leveres af en automatiseret service og muligvis ikke nÃ¸jagtige.',0),(532243,14785,'ko','ì£¼ì˜ ì‚¬í•­: ì´ˆê¸° ë²ˆì—­ ìžë™í™” ëœ ì„œë¹„ìŠ¤ì— ì˜í•´ ì œê³µ ë˜ ê³  ì •í™• í•˜ì§€ ì•Šì„ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(532244,14785,'he','×”×•×“×¢×”: ×”×¨××©×•× ×™×ª ×ª×¨×’×•×ž×™× ×ž×¡×•×¤×§×™× ×¢×œ-×™×“×™ ×©×™×¨×•×ª ××•×˜×•×ž×˜×™×•×ª, ×œ× ×™×›×•×œ ×œ×”×™×•×ª ×ž×“×•×™×§.',0),(532245,14785,'el','Î‘Î½Î±ÎºÎ¿Î¯Î½Ï‰ÏƒÎ·: Î‘ÏÏ‡Î¹ÎºÎ® Î¼ÎµÏ„Î±Ï†ÏÎ¬ÏƒÎµÎ¹Ï‚ Ï€Î±ÏÎ­Ï‡Î¿Î½Ï„Î±Î¹ Î±Ï€ÏŒ Î¼Î¹Î± Î±Ï…Ï„Î¿Î¼Î±Ï„Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î· Ï…Ï€Î·ÏÎµÏƒÎ¯Î± ÎºÎ±Î¹ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ Î±ÎºÏÎ¹Î²Î®.',0),(532246,14785,'zh','æ³¨æ„ï¼š åˆå§‹ç¿»è¯‘æä¾›çš„è‡ªåŠ¨åŒ–æœåŠ¡å’Œå¯èƒ½ä¸å‡†ç¡®ã€‚',0),(532247,14785,'sv','Notis: FÃ¶rsta Ã¶versÃ¤ttningar ges av en automatiserad tjÃ¤nst och kan inte vara exakt.',0),(532248,14785,'it','Avviso: Iniziale traduzioni sono forniti da un servizio automatico e non possono essere esatti.',0),(532249,14785,'tl','',0),(532250,14785,'th','à¸‚à¹‰à¸­à¸ªà¸±à¸‡à¹€à¸à¸•: à¹à¸›à¸¥à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹‚à¸”à¸¢à¹ƒà¸«à¹‰à¸šà¸£à¸´à¸à¸²à¸£à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´ à¹à¸¥à¸°à¸­à¸²à¸ˆà¹„à¸¡à¹ˆà¹à¸™à¹ˆà¸™à¸­à¸™',0),(532251,14785,'hi','à¤¨à¥‹à¤Ÿà¤¿à¤¸: à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­à¤¿à¤• à¤…à¤¨à¥à¤µà¤¾à¤¦ à¤à¤• à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤¸à¥‡à¤µà¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤•à¤°à¤¾à¤ˆ à¤—à¤ˆ à¤¹à¥ˆà¤‚ à¤”à¤° à¤¸à¤Ÿà¥€à¤• à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾à¥¤',0),(532252,14785,'ms','Notis: Permulaan penterjemahan disediakan oleh servis automatik dan mungkin tidak tepat.',0),(532253,14785,'ar','Ø¥Ø´Ø¹Ø§Ø±: ÙŠØªÙ… ØªÙˆÙÙŠØ± Ø®Ø¯Ù…Ø© Ø§Ù„Ø¢Ù„ÙŠ Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ø§Ù„ØªØ±Ø¬Ù…Ø§Øª Ø§Ù„Ø£ÙˆÙ„Ù‰ ÙˆÙ‚Ø¯ Ù„Ø§ ØªÙƒÙˆÙ† Ø¯Ù‚ÙŠÙ‚Ø©.',0),(532254,14785,'fr','Avis : Initial traductions sont fournies par un service automatisÃ© et ne peuvent pas Ãªtre exactes.',0),(532255,14785,'jp','æ³¨æ„: åˆæœŸç¿»è¨³è‡ªå‹•ã‚µãƒ¼ãƒ“ã‚¹ã«ã‚ˆã£ã¦æä¾›ã•ã‚Œã€æ­£ç¢ºãªã§ããªã„å ´åˆãŒã‚ã‚Šã¾ã™ã€‚',0),(532256,14785,'pt','Aviso: TraduÃ§Ãµes inicial sÃ£o fornecidas por um serviÃ§o automatizado e podem nÃ£o ser exatas.',0),(532257,14785,'ru','Ð’Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ: ÐŸÐµÑ€Ð²Ð¾Ð½Ð°Ñ‡Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ñ‹ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÑÑŽÑ‚ÑÑ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ð·Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð¾Ð¹ ÑÐ»ÑƒÐ¶Ð±Ð¾Ð¹ Ð¸ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ñ‚Ð¾Ñ‡Ð½Ñ‹Ð¼.',0),(532258,14785,'es','Aviso: Las traducciones iniciales son proporcionadas por un servicio automatizado y pueden no ser exactas.',0),(532259,14785,'de','Hinweis: Initial Ãœbersetzungen werden durch einen automatisierten Service zur VerfÃ¼gung gestellt und sind mÃ¶glicherweise nicht genau.',0),(532260,14785,'en','Notice: Initial translations are provided by an automated service and may not be exact.',0),(532261,14786,'is','',0),(532262,14786,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ ØªØ±Ø¬Ù…Ù‡',0),(532263,14786,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ ØªØ±Ø¬Ù…Ù‡',0),(532264,14786,'tr','Ã‡eviri kÄ±lavuzu',0),(532265,14786,'pl','Przewodnik tÅ‚umaczenia',0),(532266,14786,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð´ Ñ€ÑŠÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(532267,14786,'ur','ØªØ±Ø¬Ù…Û Ú¯Ø§Ø¦ÛŒÚˆ',0),(532268,14786,'sr','Ð’Ð¾Ð´Ð¸Ñ‡ Ð·Ð° Ð¿Ñ€ÐµÐ²Ð¾Ñ’ÐµÑšÐµ',0),(532269,14786,'vi','HÆ°á»›ng dáº«n báº£n dá»‹ch',0),(532270,14786,'af','Vertaling gids',0),(532271,14786,'ro','Ghid de traducere',0),(532272,14786,'et','TÃµlke juhend',0),(532273,14786,'si','Prevod vodnik',0),(532274,14786,'ba','Terjemahan panduan',0),(532275,14786,'nl','Vertaalgids',0),(532276,14786,'fi','KÃ¤Ã¤nnÃ¶s opas',0),(532277,14786,'no','Oversettelse Guide',0),(532278,14786,'da','OversÃ¦ttelse Guide',0),(532279,14786,'ko','ë²ˆì—­ ê°€ì´ë“œ',0),(532280,14786,'he','×ž×“×¨×™×š ×ª×¨×’×•×',0),(532281,14786,'el','Î Î¿Î¹ÏŒÏ„Î·Ï„Î±Ï‚ Î¼ÎµÏ„Î±Ï†ÏÎ±ÏƒÏ„Î¹ÎºÏŽÎ½ Ï…Ï€Î·ÏÎµÏƒÎ¹ÏŽÎ½',0),(532282,14786,'zh','ç¿»è¯‘å¯¼æ¸¸',0),(532283,14786,'sv','Ã–versÃ¤ttning Guide',0),(532284,14786,'it','Traduzione guida',0),(532285,14786,'tl','',0),(532286,14786,'th','à¹à¸›à¸¥à¸„à¸¹à¹ˆà¸¡à¸·à¸­',0),(532287,14786,'hi','à¤…à¤¨à¥à¤µà¤¾à¤¦ à¤—à¤¾à¤‡à¤¡',0),(532288,14786,'ms','Panduan terjemahan',0),(532289,14786,'ar','Ø¯Ù„ÙŠÙ„ Ø§Ù„ØªØ±Ø¬Ù…Ø©',0),(532290,14786,'fr','Guide de traduction',0),(532291,14786,'jp','ç¿»è¨³ã‚¬ã‚¤ãƒ‰',0),(532292,14786,'pt','Guia de traduÃ§Ã£o',0),(532293,14786,'ru','Ð ÑƒÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾ Ð¿Ð¾ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ð°Ð¼',0),(532294,14786,'es','GuÃ­a de traducciÃ³n',0),(532295,14786,'de','Ãœbersetzung-Guide',0),(532296,14786,'en','Translation Guide',0),(532297,14787,'is','',0),(532298,14787,'dr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ù…ÛŒ Ø®ÙˆØ§Ù‡Ù… Ø¨Ø±Ø§ÛŒ Ø¨Ù‡Ø¨ÙˆØ¯ Ø§ÛŒÙ† Ø²Ø¨Ø§Ù†ØŒ Ø¯Ø± support@nolapro.com Ø¨Ø§ Ù…Ø§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯ Ùˆ ÛŒØ§ Ø¨Ù‡ Ø¯Ù†Ø¨Ø§Ù„ Ø§ÛŒÙ† Ù„ÛŒÙ†Ú©.',0),(532299,14787,'pr','Ø§Ú¯Ø± Ø´Ù…Ø§ Ù…ÛŒ Ø®ÙˆØ§Ù‡Ù… Ø¨Ø±Ø§ÛŒ Ø¨Ù‡Ø¨ÙˆØ¯ Ø§ÛŒÙ† Ø²Ø¨Ø§Ù†ØŒ Ø¯Ø± support@nolapro.com Ø¨Ø§ Ù…Ø§ ØªÙ…Ø§Ø³ Ø¨Ú¯ÛŒØ±ÛŒØ¯ Ùˆ ÛŒØ§ Ø¨Ù‡ Ø¯Ù†Ø¨Ø§Ù„ Ø§ÛŒÙ† Ù„ÛŒÙ†Ú©.',0),(532300,14787,'tr','Bu dil geliÅŸtirmek istiyorsanÄ±z support@nolapro.com bize veya bu baÄŸlantÄ±yÄ± takip edin.',0),(532301,14787,'pl','JeÅ›li chcesz poprawiÄ‡ ten jÄ™zyk, skontaktuj siÄ™ z nami w support@nolapro.com lub ten link.',0),(532302,14787,'bg','ÐÐºÐ¾ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° ÑÐµ Ð¿Ð¾Ð´Ð¾Ð±Ñ€Ð¸ Ñ‚Ð¾Ð·Ð¸ ÐµÐ·Ð¸Ðº, ÑÐ²ÑŠÑ€Ð¶ÐµÑ‚Ðµ ÑÐµ Ñ Ð½Ð°Ñ Ð½Ð° support@nolapro.com Ð¸Ð»Ð¸ ÑÐ»ÐµÐ´Ð²Ð°Ð¹Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð²Ñ€ÑŠÐ·ÐºÐ°.',0),(532303,14787,'ur','Ø¢Ù¾ Ø§Ø³ Ø²Ø¨Ø§Ù† Ú©Ùˆ Ø¨ÛØªØ± Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº ØªÙˆ ÛÙ…ÛŒÚº support@nolapro.com Ù¾Ø± Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº ÛŒØ§ Ø§Ø³ Ø±Ø¨Ø· Ú©ÛŒ Ù¾ÛŒØ±ÙˆÛŒ Ú©Ø±ÛŒÚº Û”',0),(532304,14787,'sr','ÐÐºÐ¾ Ð±Ð¸ÑÑ‚Ðµ Ð¶ÐµÐ»ÐµÐ»Ð¸ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ð¾Ð±Ð¾Ñ™ÑˆÐ°Ð»Ð¸ Ð¾Ð²Ð°Ñ˜ Ñ˜ÐµÐ·Ð¸Ðº, ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð°Ñ Ð½Ð° support@nolapro.com Ð¸Ð»Ð¸ Ð¿Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ Ð²ÐµÐ·Ñƒ.',0),(532305,14787,'vi','Náº¿u báº¡n muá»‘n cáº£i thiá»‡n ngÃ´n ngá»¯ nÃ y, liÃªn há»‡ vá»›i chÃºng tÃ´i táº¡i support@nolapro.com hoáº·c theo liÃªn káº¿t nÃ y.',0),(532306,14787,'af','As jy wil graag hierdie taal verbeter, kontak ons by support@nolapro.com of volg hierdie skakel.',0),(532307,14787,'ro','DacÄƒ doriÅ£i sÄƒ Ã®mbunÄƒtÄƒÅ£i aceastÄƒ limbÄƒ, contactaÅ£i-ne la support@nolapro.com sau urmaÅ£i acest link.',0),(532308,14787,'et','Kui soovid parandada seda keelt, vÃµtke meiega Ã¼hendust aadressil support@nolapro.com vÃµi seda linki.',0),(532309,14787,'si','ÄŒe bi Å¾eleli izboljÅ¡ati ta jezik, nam piÅ¡ite na support@nolapro.com ali sledite tej povezavi.',0),(532310,14787,'ba','Jika Anda ingin memperbaiki bahasa ini, hubungi kami di support@nolapro.com atau mengikuti link ini.',0),(532311,14787,'nl','Als u verbeteren deze taal willen zou, contact met ons op support@nolapro.com of volg deze link.',0),(532312,14787,'fi','Jos haluat parantaa tÃ¤tÃ¤ kieltÃ¤, ota yhteyttÃ¤ support@nolapro.com tai tÃ¤stÃ¤ linkistÃ¤.',0),(532313,14787,'no','Hvis du Ã¸nsker Ã¥ forbedre dette sprÃ¥ket, kontakt oss pÃ¥ support@nolapro.com eller FÃ¸lg denne linken.',0),(532314,14787,'da','Hvis du gerne vil forbedre dette sprog, kontakt os pÃ¥ support@nolapro.com eller fÃ¸lg dette link.',0),(532315,14787,'ko','ì´ ì–¸ì–´ë¥¼ ê°œì„  í•˜ê¸° ìœ„í•´ support@nolapro.comì—ì„œ ì €í¬ì— ê²Œ ì—°ë½ í•˜ ë˜ëŠ”ì´ ë§í¬ë¥¼ ë”°ë¥´ì‹­ì‹œì˜¤.',0),(532316,14787,'he','×× ××ª×” ×¨×•×¦×” ×œ×©×¤×¨ ××ª ×”×©×¤×” ×”×–××ª, ×§×©×¨ ×‘×›×ª×•×‘×ª support@nolapro.com ××• ×‘×§×™×©×•×¨ ×–×”.',0),(532317,14787,'el','Î‘Î½ Î¸Î± Î¸Î­Î»Î±Ï„Îµ Î½Î± Î²ÎµÎ»Ï„Î¹ÏŽÏƒÎµÏ„Îµ Ï„Î· Î³Î»ÏŽÏƒÏƒÎ± Î±Ï…Ï„Î®, ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î®ÏƒÏ„Îµ Î¼Î±Î¶Î¯ Î¼Î±Ï‚ ÏƒÏ„Î¿ support@nolapro.com Î® Î±ÎºÎ¿Î»Î¿Ï…Î¸Î®ÏƒÏ„Îµ Ï„Î¿ ÏƒÏÎ½Î´ÎµÏƒÎ¼Î¿.',0),(532318,14787,'zh','å¦‚æžœä½ æƒ³è¦æ”¹å–„è¿™ç§è¯­è¨€ï¼Œæˆ‘ä»¬è‡´ç”µ support@nolapro.com æˆ–ç‚¹å‡»æ­¤é“¾æŽ¥ã€‚',0),(532319,14787,'sv','Om du skulle vilja fÃ¶rbÃ¤ttra detta sprÃ¥k, kontakta oss pÃ¥ support@nolapro.com eller fÃ¶lj denna lÃ¤nk.',0),(532320,14787,'it','Se si desidera migliorare questa lingua, contattaci a support@nolapro.com o seguire questo link.',0),(532321,14787,'tl','',0),(532322,14787,'th','à¸–à¹‰à¸²à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ à¸²à¸©à¸²à¸™à¸µà¹‰ à¸•à¸´à¸”à¸•à¹ˆà¸­à¹€à¸£à¸²à¹„à¸”à¹‰à¸—à¸µà¹ˆ support@nolapro.com à¸«à¸£à¸·à¸­à¸•à¸²à¸¡à¸¥à¸´à¸‡à¸„à¹Œà¸™à¸µà¹‰',0),(532323,14787,'hi','à¤¯à¤¦à¤¿ à¤†à¤ª à¤‡à¤¸ à¤­à¤¾à¤·à¤¾ à¤•à¥‹ à¤¬à¥‡à¤¹à¤¤à¤° à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚, à¤¤à¥‹ à¤¹à¤®à¥‡à¤‚ support@nolapro.com à¤ªà¤° à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤‡à¤¸ à¤²à¤¿à¤‚à¤• à¤•à¤¾ à¤…à¤¨à¥à¤¸à¤°à¤£ à¤•',0),(532324,14787,'ms','Jika anda ingin meningkatkan Bahasa ini, hubungi kami di support@nolapro.com atau klik pautan ini.',0),(532325,14787,'ar','Ø¥Ø°Ø§ ÙƒÙ†Øª ØªØ±ØºØ¨ ÙÙŠ ØªØ­Ø³ÙŠÙ† Ù‡Ø°Ù‡ Ø§Ù„Ù„ØºØ©ØŒ Ø§ØªØµÙ„ Ø¨Ù†Ø§ Ø¹Ù„Ù‰ support@nolapro.com Ø£Ùˆ Ø§ØªØ¨Ø¹ Ù‡Ø°Ø§ Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø·.',0),(532326,14787,'fr','Si vous souhaitez enrichir cette langue, contactez-nous au support@nolapro.com ou suivez ce lien.',0),(532327,14787,'jp','ã“ã®è¨€èªžã‚’æ”¹å–„ã™ã‚‹å ´åˆã¯ã€support@nolapro.com ã§ãŠå•ã„åˆã‚ã›ã¾ãŸã¯ã“ã®ãƒªãƒ³ã‚¯ã«å¾“ã£ã¦ãã ã•ã„ã€‚',0),(532328,14787,'pt','Se vocÃª gostaria de melhorar este idioma, entre em contato conosco em support@nolapro.com ou siga este link.',0),(532329,14787,'ru','Ð•ÑÐ»Ð¸ Ð²Ñ‹ Ñ…Ð¾Ñ‚ÐµÐ»Ð¸ Ð±Ñ‹ ÑƒÐ»ÑƒÑ‡ÑˆÐ¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ ÑÐ·Ñ‹Ðº, ÑÐ²ÑÐ¶Ð¸Ñ‚ÐµÑÑŒ Ñ Ð½Ð°Ð¼Ð¸ Ð¿Ð¾ support@nolapro.com Ð¸Ð»Ð¸ Ð¿Ð¾ ÑÑ‚Ð¾Ð¹ ÑÑÑ‹Ð»ÐºÐµ.',0),(532330,14787,'es','Si quieres mejorar este idioma, contacte con nosotros en support@nolapro.com o siga este enlace.',0),(532331,14787,'de','Wenn Sie diese Sprache verbessern mÃ¶chten, kontaktieren Sie uns unter support@nolapro.com oder folgen Sie diesem Link.',0),(532332,14787,'en','If you would like to improve this language, contact us at support@nolapro.com or follow this link.',0),(532333,14788,'is','',0),(532334,14788,'dr','3dcart Ù‚ÛŒÙ…Øª Ù‡Ø§ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(532335,14788,'pr','3dcart Ù‚ÛŒÙ…Øª Ù‡Ø§ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(532336,14788,'tr','3dcart fiyatlarÄ± otomatik olarak gÃ¼ncelleÅŸtir',0),(532337,14788,'pl','Automatyczna aktualizacja ceny 3dcart',0),(532338,14788,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° 3dcart Ñ†ÐµÐ½Ð¸',0),(532339,14788,'ur','3dcart Ú©ÛŒ Ù‚ÛŒÙ…ØªÛŒÚº Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(532340,14788,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ñ†ÐµÐ½Ðµ',0),(532341,14788,'vi','Tá»± Ä‘á»™ng Cáº­p Nháº­t giÃ¡ cáº£ 3dcart',0),(532342,14788,'af','3dcart pryse outomaties opdateer',0),(532343,14788,'ro','ActualizaÅ£i preÅ£urile 3dcart automat',0),(532344,14788,'et','3dcart hindu automaatselt uuendada',0),(532345,14788,'si','Samodejno posodabljanje 3dcart cene',0),(532346,14788,'ba','Memperbarui harga 3dcart secara otomatis',0),(532347,14788,'nl','3dcart prijzen automatisch bijwerken',0),(532348,14788,'fi','PÃ¤ivittÃ¤Ã¤ 3dcart hinnat automaattisesti',0),(532349,14788,'no','Oppdatere 3dcart priser automatisk',0),(532350,14788,'da','Opdatere 3dcart priser automatisk',0),(532351,14788,'ko','3dcart ê°€ê²©ì„ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(532352,14788,'he','×œ×¢×“×›×Ÿ ××ª ×”×ž×—×™×¨×™× 3dcart ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(532353,14788,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart Ï„Î¹Î¼Î­Ï‚',0),(532354,14788,'zh','è‡ªåŠ¨æ›´æ–° 3dcart ä»·æ ¼',0),(532355,14788,'sv','Uppdatera 3dcart priser automatiskt',0),(532356,14788,'it','Aggiornare automaticamente i prezzi 3dcart',0),(532357,14788,'tl','',0),(532358,14788,'th','à¸­à¸±à¸žà¹€à¸”à¸•à¸£à¸²à¸„à¸² 3dcart à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(532359,14788,'hi','3dcart à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤•à¥‹ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(532360,14788,'ms','Kemaskini Terakhir 3dcart harga secara automatik',0),(532361,14788,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£Ø³Ø¹Ø§Ø± 3dcart',0),(532362,14788,'fr','Automatiquement Ã  jour les prix de 3dcart',0),(532363,14788,'jp','3dcart ä¾¡æ ¼ã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(532364,14788,'pt','Atualizar preÃ§os 3dcart automaticamente',0),(532365,14788,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart Ñ†ÐµÐ½Ñ‹',0),(532366,14788,'es','3dcart precios se actualizan automÃ¡ticamente',0),(532367,14788,'de','3dcart Preise automatisch aktualisieren',0),(532368,14788,'en','Update 3dcart Prices Automatically',0),(532369,14789,'is','',0),(532370,14789,'dr','Ù†ÛŒØ§Ø² Ø¨Ù‡ ØªØ¹Ø¯Ø§Ø¯ ØµÙ†Ø¯ÙˆÙ‚ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(532371,14789,'pr','Ù†ÛŒØ§Ø² Ø¨Ù‡ ØªØ¹Ø¯Ø§Ø¯ ØµÙ†Ø¯ÙˆÙ‚ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(532372,14789,'tr','PO numarasÄ± iÃ§in sipariÅŸler gerektirir',0),(532373,14789,'pl','WymagajÄ… numer zamÃ³wienia dla zamÃ³wienia',0),(532374,14789,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð°Ñ‚ PO Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(532375,14789,'ur','Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± Ø¢Ø±ÚˆØ± Ú©Û’ Ù„Ø¦Û’ Ø¶Ø±ÙˆØ±Øª ÛÙˆØªÛŒ ÛÛ’ Û”',0),(532376,14789,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð°Ð½ Ð±Ñ€Ð¾Ñ˜ ÐÐ°Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ðµ Ð·Ð° Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(532377,14789,'vi','YÃªu cáº§u sá»‘ PO cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(532378,14789,'af','Posbus nommer vereis vir bestellings',0),(532379,14789,'ro','NecesitÄƒ numÄƒrul bonului de comandÄƒ pentru comenzi',0),(532380,14789,'et','NÃµuda PO Number tellimused',0),(532381,14789,'si','Zahtevajo Å¡tevilka NaroÄilnice za naroÄila',0),(532382,14789,'ba','Memerlukan nomor PO untuk pesanan',0),(532383,14789,'nl','PO-nummer nodig voor bestellingen',0),(532384,14789,'fi','Vaativat PO tilaukset',0),(532385,14789,'no','Krev innkjÃ¸psordrenummer For bestillinger',0),(532386,14789,'da','KrÃ¦ve PO-nummer For ordrer',0),(532387,14789,'ko','ì£¼ë¬¸ PO ë²ˆí˜¸ í•„ìš”',0),(532388,14789,'he','×“×¨×•×© ×ž×¡×¤×¨ ×”×–×ž× ×ª ×¨×›×© ×¢×‘×•×¨ ×”×–×ž× ×•×ª',0),(532389,14789,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î•Î½Ï„Î¿Î»Î®Ï‚ Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(532390,14789,'zh','è¦æ±‚è®¢å•çš„é‡‡è´­è®¢å•ç¼–å·',0),(532391,14789,'sv','KrÃ¤v inkÃ¶psordernummer fÃ¶r order',0),(532392,14789,'it','Richiedono numero PO per ordini',0),(532393,14789,'tl','',0),(532394,14789,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ PO à¸•à¹‰à¸­à¸‡à¹ƒà¸Šà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(532395,14789,'hi','PO à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥‹à¤¤à¥€ à¤¹à¥ˆ',0),(532396,14789,'ms','Memerlukan nombor PO untuk pesanan',0),(532397,14789,'ar','ØªØªØ·Ù„Ø¨ Ø±Ù‚Ù… Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡ Ù„Ø£ÙˆØ§Ù…Ø±',0),(532398,14789,'fr','Exigent nombre de PO pour les commandes',0),(532399,14789,'jp','æ³¨æ–‡ã® PO ç•ªå·ãŒå¿…è¦ã§ã™ã€‚',0),(532400,14789,'pt','Exigem nÃºmero de PO para encomendas',0),(532401,14789,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ PO Ð½Ð¾Ð¼ÐµÑ€ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(532402,14789,'es','Requieren PO nÃºmero para pedidos',0),(532403,14789,'de','Bestellnummer fÃ¼r AuftrÃ¤ge erfordern',0),(532404,14789,'en','Require PO Number For Orders',0),(532405,14790,'is','',0),(532406,14790,'dr','ØµØ­Ø¨Øª Ø¨Ø§ Ø¯ÙˆØ³ØªØ§Ù†',0),(532407,14790,'pr','ØµØ­Ø¨Øª Ø¨Ø§ Ø¯ÙˆØ³ØªØ§Ù†',0),(532408,14790,'tr','Zen Cart',0),(532409,14790,'pl','Zen Cart',0),(532410,14790,'bg','Zen Cart',0),(532411,14790,'ur','Ø²ÛŒÙ† Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ',0),(532412,14790,'sr','Ð—ÐµÐ½ ÐºÐ¾Ð»Ð¸Ñ†Ð°',0),(532413,14790,'vi','Zen Cart',0),(532414,14790,'af','Zen Cart',0),(532415,14790,'ro','Zen-Cart',0),(532416,14790,'et','Zen Cart',0),(532417,14790,'si','Zen Cart',0),(532418,14790,'ba','Zen Cart',0),(532419,14790,'nl','Zen Cart',0),(532420,14790,'fi','Zen Cart',0),(532421,14790,'no','Zen Cart',0),(532422,14790,'da','Zen Cart',0),(532423,14790,'ko','ì„  ìž¥ë°”êµ¬ë‹ˆ',0),(532424,14790,'he','×ž×”××•×ž×Ÿ',0),(532425,14790,'el','Zen Cart',0),(532426,14790,'zh','ç¦…å®—è½¦',0),(532427,14790,'sv','Zen Cart',0),(532428,14790,'it','Zen Cart',0),(532429,14790,'tl','',0),(532430,14790,'th','à¸£à¸–à¹€à¸‚à¹‡à¸™à¹€à¸‹à¸™',0),(532431,14790,'hi','à¤œà¤¼à¥‡à¤¨ à¤—à¤¾à¤¡à¤¼à¥€',0),(532432,14790,'ms','Zen Cart',0),(532433,14790,'ar','Ø²Ù† Ø§Ù„Ø³Ù„Ø©',0),(532434,14790,'fr','Zen Cart',0),(532435,14790,'jp','ç¦…ã‚«ãƒ¼ãƒˆã«å…¥ã‚Œã‚‹',0),(532436,14790,'pt','Zen Cart',0),(532437,14790,'ru','Zen Cart',0),(532438,14790,'es','Zen Cart',0),(532439,14790,'de','Zen Cart',0),(532440,14790,'en','Zen Cart',0),(532441,14791,'is','',0),(532442,14791,'dr','Ù‚ÛŒÙ…Øª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ù¾Ø³ Ø²Ù…ÛŒÙ†Ù‡ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´',0),(532443,14791,'pr','Ù‚ÛŒÙ…Øª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ù¾Ø³ Ø²Ù…ÛŒÙ†Ù‡ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´',0),(532444,14791,'tr','Fiyat gÃ¼ncelleÅŸtirmeleri arka plan iÃ§in gÃ¶nderilen iÅŸleme',0),(532445,14791,'pl','Cena aktualizacje zostaÅ‚y wysÅ‚ane do tÅ‚a przetwarzania',0),(532446,14791,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð½Ð° Ñ†ÐµÐ½Ð¸Ñ‚Ðµ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð·Ð° Ñ„Ð¾Ð½ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(532447,14791,'ur','Ù‚ÛŒÙ…Øª Ø§Ù¾ ÚˆÛŒÙ¹Ø³ Ù¾Ø³ Ù…Ù†Ø¸Ø± Ú©Û’ Ù„ÛŒÛ’ Ø¨Ú¾ÛŒØ¬Ø§ Ú¯ÛŒØ§ ÛÛ’ Ø¹Ù…Ù„ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(532448,14791,'sr','Ð¦ÐµÐ½Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° ÑƒÐ¿ÑƒÑ›ÐµÐ½Ð¸ ÑÑƒ Ð½Ð° Ð¿Ð¾Ð·Ð°Ð´Ð¸Ð½Ð¸ Ð¾Ð±Ñ€Ð°Ð´Ðµ',0),(532449,14791,'vi','Cáº­p Nháº­t giÃ¡ Ä‘Ã£ Ä‘Æ°á»£c gá»­i cho ná»n táº£ng xá»­ lÃ½',0),(532450,14791,'af','Prys bywerkings gestuur vir agtergrond verwerking',0),(532451,14791,'ro','Pret actualizÄƒri au fost trimise pentru fundal de prelucrare',0),(532452,14791,'et','Hinnauuenduste saadetud tausta tÃ¶Ã¶tlemine',0),(532453,14791,'si','Cena posodobitve so bili poslani za ozadja za predelavo',0),(532454,14791,'ba','Harga update telah dikirim untuk latar belakang pengolahan',0),(532455,14791,'nl','Prijs Updates zijn verzonden voor achtergrond verwerking',0),(532456,14791,'fi','Hinnan pÃ¤ivityksistÃ¤ on lÃ¤hetetty tausta kÃ¤sittely',0),(532457,14791,'no','Prisoppdateringer er sendt For bakgrunnen behandling',0),(532458,14791,'da','Prisopdateringer er blevet sendt til baggrunden behandling',0),(532459,14791,'ko','ê°€ê²© ì—…ë°ì´íŠ¸ ë³´ë‚¸ ë°°ê²½ì— ëŒ€ í•œ ì²˜ë¦¬',0),(532460,14791,'he','×ž×—×™×¨ ×¢×“×›×•× ×™× × ×©×œ×—×• ×¢×œ ×¨×§×¢ ×¢×™×‘×•×“',0),(532461,14791,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¹Î¼ÏŽÎ½ Î­Ï‡Î¿Ï…Î½ ÏƒÏ„Î±Î»ÎµÎ¯ Î³Î¹Î± Ï†ÏŒÎ½Ï„Î¿ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(532462,14791,'zh','ä»·æ ¼æ›´æ–°å·²å‘é€èƒŒæ™¯å¤„ç†',0),(532463,14791,'sv','Prisuppdateringar har skickats fÃ¶r bakgrunden bearbetning',0),(532464,14791,'it','Prezzo aggiornamenti sono stati inviati per sfondo elaborazione',0),(532465,14791,'tl','',0),(532466,14791,'th','à¸ªà¹ˆà¸‡à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸„à¸²à¸ªà¸³à¸«à¸£à¸±à¸šà¸žà¸·à¹‰à¸™à¸«à¸¥à¸±à¸‡à¸à¸²à¸£à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥',0),(532467,14791,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥ƒà¤·à¥à¤ à¤­à¥‚à¤®à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£',0),(532468,14791,'ms','Kemas kini harga telah dihantar untuk latar belakang pemprosesan',0),(532469,14791,'ar','ØªÙ… Ø¥Ø±Ø³Ø§Ù„ ØªØ­Ø¯ÙŠØ«Ø§Øª Ø§Ù„Ø³Ø¹Ø± Ù„Ø®Ù„ÙÙŠØ© Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬Ø©',0),(532470,14791,'fr','Prix mises Ã  jour ont Ã©tÃ© envoyÃ©s pour fond de traitement',0),(532471,14791,'jp','èƒŒæ™¯ã®é€ä¿¡ã•ã‚ŒãŸä¾¡æ ¼ã‚’æ›´æ–°å‡¦ç†',0),(532472,14791,'pt','AtualizaÃ§Ãµes de preÃ§o foram enviadas para plano de fundo processamento',0),(532473,14791,'ru','Ð¦ÐµÐ½Ð° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð±Ñ‹Ð»Ð¸ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð´Ð»Ñ Ñ„Ð¾Ð½Ð¾Ð²Ð¾Ð¹ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸',0),(532474,14791,'es','Precio actualizaciones han sido enviadas para el fondo de procesamiento',0),(532475,14791,'de','Preisaktualisierungen fÃ¼r Hintergrund gesendet wurden Verarbeitung',0),(532476,14791,'en','Price Updates Have Been Sent For Background Processing',0),(532477,14792,'is','',0),(532478,14792,'dr','3dcart Ù‚ÛŒÙ…Øª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(532479,14792,'pr','3dcart Ù‚ÛŒÙ…Øª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(532480,14792,'tr','3dcart fiyatlarÄ±',0),(532481,14792,'pl','Aktualizacja cen 3dcart',0),(532482,14792,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ†ÐµÐ½Ð¸ Ð½Ð° 3dcart',0),(532483,14792,'ur','3dcart Ú©ÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(532484,14792,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ†ÐµÐ½Ð° 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(532485,14792,'vi','Cáº­p Nháº­t 3dcart giÃ¡',0),(532486,14792,'af','Werk 3dcart pryse',0),(532487,14792,'ro','Actualizare 3dcart preturi',0),(532488,14792,'et','Update 3dcart hinnad',0),(532489,14792,'si','Posodobi 3dcart cene',0),(532490,14792,'ba','Harga 3dcart pembaruan',0),(532491,14792,'nl','3dcart prijzen bijwerken',0),(532492,14792,'fi','PÃ¤ivitÃ¤ 3dcart hinnat',0),(532493,14792,'no','Oppdatere 3dcart priser',0),(532494,14792,'da','Opdatere 3dcart priser',0),(532495,14792,'ko','3dcart ê°€ê²© ì—…ë°ì´íŠ¸',0),(532496,14792,'he','×œ×¢×“×›×Ÿ ××ª ×”×ž×—×™×¨×™× 3dcart',0),(532497,14792,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Ï„Î¹Î¼ÏŽÎ½ 3dcart',0),(532498,14792,'zh','æ›´æ–° 3dcart çš„ä»·æ ¼',0),(532499,14792,'sv','Uppdatera 3dcart priser',0),(532500,14792,'it','Aggiornamento prezzi 3dcart',0),(532501,14792,'tl','',0),(532502,14792,'th','à¸­à¸±à¸žà¹€à¸”à¸•à¸£à¸²à¸„à¸² 3dcart',0),(532503,14792,'hi','3dcart à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(532504,14792,'ms','Kemaskini Terakhir 3dcart harga',0),(532505,14792,'ar','ØªØ­Ø¯ÙŠØ« Ø£Ø³Ø¹Ø§Ø± 3dcart',0),(532506,14792,'fr','Mise Ã  jour des prix 3dcart',0),(532507,14792,'jp','3dcart ã®ä¾¡æ ¼ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(532508,14792,'pt','AtualizaÃ§Ã£o 3dcart preÃ§os',0),(532509,14792,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ†ÐµÐ½ 3dcart',0),(532510,14792,'es','Actualizar precios 3dcart',0),(532511,14792,'de','3dcart Preise aktualisieren',0),(532512,14792,'en','Update 3dcart Prices',0),(532513,14793,'is','',0),(532514,14793,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ØµÙ†Ø¯ÙˆÙ‚ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(532515,14793,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ØµÙ†Ø¯ÙˆÙ‚ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(532516,14793,'tr','PO numarasÄ± girmelisiniz',0),(532517,14793,'pl','NaleÅ¼y wprowadziÄ‡ numer zamÃ³wienia',0),(532518,14793,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(532519,14793,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(532520,14793,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ ÑƒÐ½ÐµÑ‚Ð¸ Ð±Ñ€Ð¾Ñ˜ ÐŸÐž',0),(532521,14793,'vi','Báº¡n pháº£i nháº­p má»™t sá»‘ PO',0),(532522,14793,'af','Jy moet \'n PO nommer insleutel',0),(532523,14793,'ro','Trebuie sÄƒ introduceÅ£i un numÄƒr PO',0),(532524,14793,'et','Peate sisestama PO Number',0),(532525,14793,'si','Vnesti morate Å¡tevilka NaroÄilnice',0),(532526,14793,'ba','Anda harus memasukkan nomor PO',0),(532527,14793,'nl','U moet een PO-nummer invoeren',0),(532528,14793,'fi','Anna PO numero',0),(532529,14793,'no','Du mÃ¥ angi et PO-nummer',0),(532530,14793,'da','Du skal angive et PO-nummer',0),(532531,14793,'ko','ì£¼ë¬¸ì„œ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(532532,14793,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ž×¡×¤×¨ ×ž×©×œ×•×—',0),(532533,14793,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î± PO Number',0),(532534,14793,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªé‡‡è´­è®¢å•å·',0),(532535,14793,'sv','Du mÃ¥ste ange ett inkÃ¶psordernummer',0),(532536,14793,'it','Ãˆ necessario immettere un numero di PO',0),(532537,14793,'tl','',0),(532538,14793,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ PO',0),(532539,14793,'hi','à¤¤à¥à¤® à¤à¤• PO à¤¨à¤‚à¤¬à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(532540,14793,'ms','Anda mesti masukkan nombor PO',0),(532541,14793,'ar','ÙŠØ¬Ø¨ Ø¹Ù„ÙŠÙƒ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø¨Ùˆ',0),(532542,14793,'fr','Vous devez entrer un numÃ©ro d\'ordre d\'achat',0),(532543,14793,'jp','PO ç•ªå·ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(532544,14793,'pt','VocÃª deve digitar um nÃºmero de PO',0),(532545,14793,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð°',0),(532546,14793,'es','Debe especificar un nÃºmero de PO',0),(532547,14793,'de','Sie mÃ¼ssen eine Bestellnummer eingeben.',0),(532548,14793,'en','You Must Enter A PO Number',0),(532549,14794,'is','',0),(532550,14794,'dr','Ú©Ù„ Ø³Ø§Ù„ Ù…Ø§Ù„ÛŒ',0),(532551,14794,'pr','Ú©Ù„ Ø³Ø§Ù„ Ù…Ø§Ù„ÛŒ',0),(532552,14794,'tr','Mali yÄ±l toplam',0),(532553,14794,'pl','Rok obrachunkowy ogÃ³Å‚em',0),(532554,14794,'bg','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð¾Ð±Ñ‰Ð¾',0),(532555,14794,'ur','Ù…Ø§Ù„ÛŒ Ø³Ø§Ù„ Ú©Ù„',0),(532556,14794,'sr','Ð¤Ð¸ÑÐºÐ°Ð»Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(532557,14794,'vi','Tá»•ng cá»™ng nÄƒm tÃ i chÃ­nh',0),(532558,14794,'af','Fiskale jaar totaal',0),(532559,14794,'ro','Anul fiscal Total',0),(532560,14794,'et','Rahandusaasta kokku',0),(532561,14794,'si','Poslovno leto skupaj',0),(532562,14794,'ba','Tahun fiskal Total',0),(532563,14794,'nl','Boekjaar totaal',0),(532564,14794,'fi','Tilikausi yhteensÃ¤',0),(532565,14794,'no','RegnskapsÃ¥ret totalt',0),(532566,14794,'da','RegnskabsÃ¥ret alt',0),(532567,14794,'ko','íšŒê³„ ì—°ë„ í•©ê³„',0),(532568,14794,'he','×¡×š ×”×›×¡×¤×™×',0),(532569,14794,'el','ÎŸÎ¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(532570,14794,'zh','è´¢æ”¿å¹´åº¦å…±',0),(532571,14794,'sv','RÃ¤kenskapsÃ¥ret totalt',0),(532572,14794,'it','Anno fiscale totale',0),(532573,14794,'tl','',0),(532574,14794,'th','à¸›à¸µà¸£à¸§à¸¡',0),(532575,14794,'hi','à¤µà¤¿à¤¤à¥à¤¤à¥€à¤¯ à¤µà¤°à¥à¤· à¤•à¥‡ à¤•à¥à¤²',0),(532576,14794,'ms','Jumlah tahun fiskal',0),(532577,14794,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ù„ÙŠØ©',0),(532578,14794,'fr','Total de l\'exercice',0),(532579,14794,'jp','å¹´åº¦åˆè¨ˆ',0),(532580,14794,'pt','Ano fiscal Total',0),(532581,14794,'ru','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Ð³Ð¾Ð´-Ð²ÑÐµÐ³Ð¾',0),(532582,14794,'es','AÃ±o fiscal Total',0),(532583,14794,'de','GeschÃ¤ftsjahr insgesamt',0),(532584,14794,'en','Fiscal Year Total',0),(532585,14795,'is','',0),(532586,14795,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¬Ø²Ø¦ÛŒØ§Øª Ù…Ø´ØªØ±ÛŒ',0),(532587,14795,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¬Ø²Ø¦ÛŒØ§Øª Ù…Ø´ØªØ±ÛŒ',0),(532588,14795,'tr','MÃ¼ÅŸteri ayrÄ±ntÄ±larÄ± gÃ¶rÃ¼ntÃ¼leme',0),(532589,14795,'pl','Zobacz szczegÃ³Å‚y klienta',0),(532590,14795,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(532591,14795,'ur','Ú©Ø³Ù¹Ù…Ø± ØªÙØ§ØµÛŒÙ„ Ù…Ù†Ø¸Ø±',0),(532592,14795,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð´ÐµÑ‚Ð°Ñ™Ð° Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(532593,14795,'vi','Xem khÃ¡ch hÃ ng chi tiáº¿t',0),(532594,14795,'af','Wys Details van kliÃ«nt',0),(532595,14795,'ro','Vezi detalii client',0),(532596,14795,'et','Vaata kliendi andmed',0),(532597,14795,'si','Ogled podrobnosti o strankah',0),(532598,14795,'ba','Lihat rincian pelanggan',0),(532599,14795,'nl','Klant Details weergeven',0),(532600,14795,'fi','NÃ¤ytÃ¤ asiakkaan tiedot',0),(532601,14795,'no','Vis kundeinformasjon',0),(532602,14795,'da','Se kundeoplysninger',0),(532603,14795,'ko','ê³ ê° ì„¸ë¶€ ì •ë³´ ë³´ê¸°',0),(532604,14795,'he','×¤×¨×˜×™ ×”×œ×§×•×—: ×ª×¦×•×’×”',0),(532605,14795,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎ¹ÎµÏ‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(532606,14795,'zh','æŸ¥çœ‹å®¢æˆ·è¯¦ç»†ä¿¡æ¯',0),(532607,14795,'sv','Visa information om kunden',0),(532608,14795,'it','Maggiori dettagli cliente',0),(532609,14795,'tl','',0),(532610,14795,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸”à¸¹à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”',0),(532611,14795,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤µà¤¿à¤µà¤°à¤£ à¤¦à¥‡à¤–à¥‡à¤‚',0),(532612,14795,'ms','Lihat Baca butiran',0),(532613,14795,'ar','Ø¹Ø±Ø¶ ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(532614,14795,'fr','Voir les dÃ©tails de client',0),(532615,14795,'jp','é¡§å®¢ã®è©³ç´°ã®è¡¨ç¤º',0),(532616,14795,'pt','Ver detalhes do cliente',0),(532617,14795,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ð¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(532618,14795,'es','Ver detalles de cliente',0),(532619,14795,'de','Customer Details anzeigen',0),(532620,14795,'en','View Customer Details',0),(532621,14796,'is','',0),(532622,14796,'dr','ØªØ¹Ø¯Ø§Ø¯ Ú©Ù¾ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(532623,14796,'pr','ØªØ¹Ø¯Ø§Ø¯ Ú©Ù¾ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(532624,14796,'tr','Fatura kopya sayÄ±sÄ±',0),(532625,14796,'pl','Liczba kopii faktury',0),(532626,14796,'bg','Ð‘Ñ€Ð¾Ð¹ ÐºÐ¾Ð¿Ð¸Ñ Ð¾Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(532627,14796,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ù†Ù‚ÙˆÙ„ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(532628,14796,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÐ¾Ð¿Ð¸Ñ˜Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(532629,14796,'vi','Sá»‘ lÆ°á»£ng cÃ¡c báº£n sao hÃ³a Ä‘Æ¡n',0),(532630,14796,'af','Nommer van die faktuur afskrifte',0),(532631,14796,'ro','NumÄƒrul de copii pe facturÄƒ',0),(532632,14796,'et','Mitu arve koopiat',0),(532633,14796,'si','Å tevilo izvodov raÄuna',0),(532634,14796,'ba','Jumlah salinan faktur',0),(532635,14796,'nl','Aantal exemplaren van de factuur',0),(532636,14796,'fi','Laskukopioiden lukumÃ¤Ã¤rÃ¤n',0),(532637,14796,'no','Antall fakturakopier',0),(532638,14796,'da','Antal fakturakopier',0),(532639,14796,'ko','ì†¡ìž¥ ë³µì‚¬ë³¸ ìˆ˜',0),(532640,14796,'he','×ž×¡×¤×¨ ×”×¢×•×ª×§×™× ×—×©×‘×•× ×™×ª',0),(532641,14796,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Ï„Ï‰Î½ Î±Î½Ï„Î¹Î³ÏÎ¬Ï†Ï‰Î½ Ï„Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(532642,14796,'zh','å‘ç¥¨å‰¯æœ¬çš„æ•°é‡',0),(532643,14796,'sv','Antal fakturakopior',0),(532644,14796,'it','Numero di copie della fattura',0),(532645,14796,'tl','',0),(532646,14796,'th','à¸ˆà¸³à¸™à¸§à¸™à¸ªà¸³à¹€à¸™à¸²à¸‚à¸­à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(532647,14796,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤ªà¥à¤°à¤¤à¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(532648,14796,'ms','Bilangan salinan invois',0),(532649,14796,'ar','Ø¹Ø¯Ø¯ Ù†Ø³Ø® Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(532650,14796,'fr','Nombre d\'exemplaires de la facture',0),(532651,14796,'jp','è«‹æ±‚æ›¸ã®ã‚³ãƒ”ãƒ¼ã®æ•°',0),(532652,14796,'pt','NÃºmero de cÃ³pias da factura',0),(532653,14796,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐºÐ·ÐµÐ¼Ð¿Ð»ÑÑ€Ð¾Ð² ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(532654,14796,'es','NÃºmero de copias de factura',0),(532655,14796,'de','Anzahl der Rechnungskopien',0),(532656,14796,'en','Number Of Invoice Copies',0),(532657,14797,'is','',0),(532658,14797,'dr','Ø°Ù† Ø³Ø¨Ø¯ Ø§Ø¯ØºØ§Ù… Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÛŒØ´ ÙØ±Ø¶',0),(532659,14797,'pr','Ø°Ù† Ø³Ø¨Ø¯ Ø§Ø¯ØºØ§Ù… Ø¨Ù‡ ØµÙˆØ±Øª Ù¾ÛŒØ´ ÙØ±Ø¶',0),(532660,14797,'tr','Zen sepeti entegrasyonu VarsayÄ±lanlarÄ±',0),(532661,14797,'pl','Zen Cart integracji domyÅ›lne',0),(532662,14797,'bg','Ð”Ð·ÐµÐ½ ÐºÐ¾Ð»Ð¸Ñ‡ÐºÐ°Ñ‚Ð° Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(532663,14797,'ur','Ø²ÛŒÙ† Ú©ÛŒ Ù¹ÙˆÚ©Ø±ÛŒ Ø§Ù†Ø¶Ù…Ø§Ù… Ø·Û’ Ø´Ø¯Û',0),(532664,14797,'sr','Ð—ÐµÐ½ ÐºÐ¾Ð»Ð¸Ñ†Ð° Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð´Ð°Ð½Ðµ Ð²Ñ€Ð¸Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(532665,14797,'vi','Zen Cart tÃ­ch há»£p máº·c Ä‘á»‹nh',0),(532666,14797,'af','Zen Cart integrasie verstek',0),(532667,14797,'ro','Zen Cart integrarea implicite',0),(532668,14797,'et','Zen Cart integratsioon vaikesÃ¤tted',0),(532669,14797,'si','Zen Cart integracija neplaÄil',0),(532670,14797,'ba','Zen Cart integrasi default',0),(532671,14797,'nl','Zen Cart integratie Defaults',0),(532672,14797,'fi','Zen Cart Integration oletukset',0),(532673,14797,'no','Zen Cart integrasjon standarder',0),(532674,14797,'da','Zen Cart Integration standarder',0),(532675,14797,'ko','ì„  ìž¥ë°”êµ¬ë‹ˆ í†µí•© ê¸°ë³¸ê°’',0),(532676,14797,'he','Zen ×¢×’×œ×” ××™× ×˜×’×¨×¦×™×” ×‘×¨×™×¨×•×ª ×ž×—×“×œ',0),(532677,14797,'el','Zen ÎºÎ±Î»Î¬Î¸Î¹ Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ· Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(532678,14797,'zh','ç¦…å®—è½¦é›†æˆé»˜è®¤å€¼',0),(532679,14797,'sv','Zen Cart Integration Defaults',0),(532680,14797,'it','Zen Cart integrazione Defaults',0),(532681,14797,'tl','',0),(532682,14797,'th','à¹€à¸‹à¸™à¸£à¸–à¸£à¸§à¸¡à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(532683,14797,'hi','à¤œà¤¼à¥‡à¤¨ à¤—à¤¾à¤¡à¤¼à¥€ à¤à¤•à¥€à¤•à¤°à¤£ à¤šà¥‚à¤•',0),(532684,14797,'ms','Zen Cart integrasi lalai',0),(532685,14797,'ar','Ø²Ù† Ø§Ù„Ø³Ù„Ø© Ø§Ù„ØªÙƒØ§Ù…Ù„ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ§Øª',0),(532686,14797,'fr','Zen Cart intÃ©gration par dÃ©faut',0),(532687,14797,'jp','ç¦…ã‚«ãƒ¼ãƒˆçµ±åˆãƒ‡ãƒ•ã‚©ãƒ«ãƒˆ',0),(532688,14797,'pt','PadrÃµes de integraÃ§Ã£o do Zen Cart',0),(532689,14797,'ru','Zen Cart Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(532690,14797,'es','Zen Cart integraciÃ³n Defaults',0),(532691,14797,'de','Zen Cart Integration Standardwerte',0),(532692,14797,'en','Zen Cart Integration Defaults',0),(532693,14798,'is','',0),(532694,14798,'dr','&gt; 30 Ø±ÙˆØ²',0),(532695,14798,'pr','&gt; 30 Ø±ÙˆØ²',0),(532696,14798,'tr','&gt; 30 gÃ¼n',0),(532697,14798,'pl','&gt; 30 dni',0),(532698,14798,'bg','&gt; 30 Ð´Ð½Ð¸',0),(532699,14798,'ur','&gt; 30 Ø¯Ù†',0),(532700,14798,'sr','&Ð³Ñ‚; 30 Ð´Ð°Ð½Ð°',0),(532701,14798,'vi','&gt; 30 ngÃ y',0),(532702,14798,'af','&gt; 30 dae',0),(532703,14798,'ro','&gt; 30 zile',0),(532704,14798,'et','&gt; 30 pÃ¤eva',0),(532705,14798,'si','&gt; 30 dni',0),(532706,14798,'ba','&gt; 30 hari',0),(532707,14798,'nl','&gt; 30 dagen',0),(532708,14798,'fi','&gt; 30 pÃ¤ivÃ¤Ã¤',0),(532709,14798,'no','&gt; 30 dager',0),(532710,14798,'da','&gt; 30 dage',0),(532711,14798,'ko','&gt; 30 ì¼',0),(532712,14798,'he','&gt; 30 ×™×ž×™×',0),(532713,14798,'el','&gt; 30 Î·Î¼Î­ÏÎµÏ‚',0),(532714,14798,'zh','&gt; 30 å¤©',0),(532715,14798,'sv','&gt; 30 dagar',0),(532716,14798,'it','&gt; 30 giorni',0),(532717,14798,'tl','',0),(532718,14798,'th','&Gt; 30 à¸§à¸±à¸™',0),(532719,14798,'hi','&gt; 30 à¤¦à¤¿à¤¨',0),(532720,14798,'ms','&gt; 30 hari',0),(532721,14798,'ar','&gt; 30 ÙŠÙˆÙ…Ø§',0),(532722,14798,'fr','&gt; 30 jours',0),(532723,14798,'jp','&gt; 30 æ—¥',0),(532724,14798,'pt','&gt; 30 dias',0),(532725,14798,'ru','&gt; 30 Ð´Ð½ÐµÐ¹',0),(532726,14798,'es','&gt; 30 dÃ­as',0),(532727,14798,'de','&gt; 30 Tage',0),(532728,14798,'en','&gt; 30 Days',0),(532729,14799,'is','',0),(532730,14799,'dr','Ù†Ù…Ø§ÛŒØ´ Ø®Ø· Ø¨Ø±Ø§ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©Ù„ ÙØ§Ú©ØªÙˆØ±',0),(532731,14799,'pr','Ù†Ù…Ø§ÛŒØ´ Ø®Ø· Ø¨Ø±Ø§ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ú©Ù„ ÙØ§Ú©ØªÙˆØ±',0),(532732,14799,'tr','Faturadaki toplam miktarÄ±n Ã§izgisini gÃ¶ster',0),(532733,14799,'pl','PokaÅ¼ liniÄ™ do caÅ‚kowitej iloÅ›ci na fakturze',0),(532734,14799,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´ Ð·Ð° Ð¾Ð±Ñ‰Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(532735,14799,'ur','Ú©Ù„ ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„ÛŒÛ’ Ù„Ø§Ø¦Ù† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(532736,14799,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ€ÐµÐ´ Ð·Ð° Ð£ÐºÑƒÐ¿Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(532737,14799,'vi','Hiá»ƒn thá»‹ dÃ²ng cho sá»‘ lÆ°á»£ng tá»•ng sá»‘ hoÃ¡ Ä‘Æ¡n',0),(532738,14799,'af','Lyn wys vir totale hoeveelheid op die faktuur',0),(532739,14799,'ro','AratÄƒ linie pentru cantitatea totalÄƒ pe facturÄƒ',0),(532740,14799,'et','NÃ¤ita rea kogus arvel',0),(532741,14799,'si','PokaÅ¾i Ärto za celotno koliÄino na raÄun',0),(532742,14799,'ba','Tampilkan baris untuk jumlah Total pada faktur',0),(532743,14799,'nl','Toon lijn voor totale hoeveelheid op factuur',0),(532744,14799,'fi','NÃ¤ytÃ¤ rivi kokonaismÃ¤Ã¤rÃ¤ laskussa',0),(532745,14799,'no','Vis linje For antall pÃ¥ fakturaen',0),(532746,14799,'da','Vis linje For samlet antal pÃ¥ fakturaen',0),(532747,14799,'ko','ì†¡ìž¥ì— ì´ ìˆ˜ëŸ‰ì— ëŒ€ í•œ ë¼ì¸ì„ í‘œì‹œ',0),(532748,14799,'he','×”×¦×’ ×§×• ×¢×‘×•×¨ ×”×›×ž×•×ª ×”×›×•×œ×œ×ª ×‘×—×©×‘×•× ×™×ª',0),(532749,14799,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î³ÏÎ±Î¼Î¼Î®Ï‚ Î³Î¹Î± ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ® Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(532750,14799,'zh','æ˜¾ç¤ºè¡Œçš„å‘ç¥¨ä¸Šçš„æ€»æ•°é‡',0),(532751,14799,'sv','Visa linje fÃ¶r totala kvantiteten pÃ¥ fakturan',0),(532752,14799,'it','Visualizza la linea per un quantitativo totale fattura',0),(532753,14799,'tl','',0),(532754,14799,'th','à¹à¸ªà¸”à¸‡à¸šà¸£à¸£à¸—à¸±à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸£à¸´à¸¡à¸²à¸“à¸£à¸§à¸¡à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(532755,14799,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤ªà¤° à¤•à¥à¤² à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¥‡à¤–à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(532756,14799,'ms','Menunjukkan laluan untuk kuantiti jumlah pada invois',0),(532757,14799,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø®Ø· Ù„Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ© Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(532758,14799,'fr','Voir la ligne pour la quantitÃ© totale sur facture',0),(532759,14799,'jp','è«‹æ±‚æ›¸ã®åˆè¨ˆæ•°é‡ã®ç·šã‚’è¡¨ç¤º',0),(532760,14799,'pt','Mostrar a linha para a quantidade Total na fatura',0),(532761,14799,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð»Ð¸Ð½Ð¸ÑŽ Ð´Ð»Ñ Ð¾Ð±Ñ‰ÐµÐ³Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ð¿Ð¾ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(532762,14799,'es','Mostrar la lÃ­nea de la cantidad Total de factura',0),(532763,14799,'de','Karte Linie fÃ¼r Gesamtmenge auf Rechnung',0),(532764,14799,'en','Show Line For Total Quantity On Invoice',0),(532765,14800,'is','',0),(532766,14800,'dr','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(532767,14800,'pr','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(532768,14800,'tr','Ek satÄ±r Ã¶ÄŸeleri aynÄ± fatura yalnÄ±zca mÃ¼ÅŸteri KÄ±mlÄ±ÄŸÄ± veya ÅŸirket adÄ± veya ilk ve son adÄ± ve fatura numarasÄ± gerekir',0),(532769,14800,'pl','Dodatkowe pozycje w samej faktury wystarczy identyfikator klienta lub nazwa firmy lub pierwszy i nazwisko i numer faktury',0),(532770,14800,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ð² ÐµÐ´Ð½Ð° Ð¸ ÑÑŠÑ‰Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° ÑÐ°Ð¼Ð¾ Ð˜Ð” Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð° Ð¸Ð»Ð¸ Ð¿ÑŠÑ€Ð²Ð¾Ñ‚Ð¾ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(532771,14800,'ur','Ø§Ø¶Ø§ÙÛŒ Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§ Ø§Ø³ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…ÛŒÚº ØµØ±Ù Ø®Ø±ÛŒØ¯Ø§Ø± Ú©ÛŒ Ø´Ù†Ø§Ø®Øª ÛŒØ§ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù†Ø§Ù… ÛŒØ§ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§ÙˆØ± Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ø§ÙˆØ± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù†Ù…Ø¨Ø± Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(532772,14800,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ñ€ÐµÐ´Ñƒ Ñƒ Ð¸ÑÑ‚Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ñ˜Ðµ ÑÐ°Ð¼Ð¾ Ð˜Ð” ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸Ð»Ð¸ Ð¿Ñ€Ð²Ð¸ Ð¸ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(532773,14800,'vi','ThÃªm chi tiáº¿t Ä‘Æ¡n hÃ ng hoÃ¡ Ä‘Æ¡n cÃ¹ng má»™t chá»‰ cáº§n ID khÃ¡ch hÃ ng hoáº·c tÃªn cÃ´ng ty hoáº·c Ä‘áº§u tiÃªn vÃ  cuá»‘i cÃ¹ng tÃªn vÃ  sá»‘ hÃ³a Ä‘Æ¡n',0),(532774,14800,'af','Bykomende lyn Items In die dieselfde faktuur moet slegs die kliÃ«nt-ID of maatskappynaam of eerste en laaste naam en nommer van die faktuur',0),(532775,14800,'ro','Elemente suplimentare de linie Ã®n aceeaÅŸi facturÄƒ nevoie doar de ID client sau numele companiei sau primul ÅŸi ultimul nume ÅŸi numÄƒrul facturii',0),(532776,14800,'et','TÃ¤iendavaid kirjeid sama arve tuleb ainult kliendi ID vÃµi firma nimi vÃµi esimese ja perekonnanimi ning arve Number',0),(532777,14800,'si','Dodatne vrstiÄne postavke v isti raÄun Å¡ele potreba ID stranke ali ime podjetja ali prvi in zadnji ime in Å¡tevilko raÄuna',0),(532778,14800,'ba','Item baris tambahan di faktur sama hanya memerlukan ID pelanggan atau nama perusahaan atau pertama dan nama terakhir dan nomor faktur',0),(532779,14800,'nl','Extra regelitems In dezelfde factuur hoeft de klant-ID of bedrijfsnaam of eerste en laatste naam en het factuurnummer',0),(532780,14800,'fi','Muita eriÃ¤ samaan laskuun tarvitsee vain asiakkaan tunnus tai yrityksen nimi tai ensimmÃ¤isenÃ¤ ja sukunimi ja laskunumero',0),(532781,14800,'no','Flere linjeelementer i den samme fakturaen bare trenger kunde-IDen eller firmanavn eller fÃ¸rste og siste navnet og fakturanummeret',0),(532782,14800,'da','Yderligere linjeelementer i den samme faktura behÃ¸ver kun kunde-ID eller firmanavn eller fÃ¸rste og sidste navn og fakturanummeret',0),(532783,14800,'ko','ê³ ê° ID, íšŒì‚¬ ì´ë¦„ ë˜ëŠ” ì²« ë²ˆì§¸ ë° ë§ˆì§€ë§‰ ì´ë¦„, ì†¡ìž¥ ë²ˆí˜¸ ê°™ì€ ì¸ë³´ì´ìŠ¤ì— ì¶”ê°€ í’ˆëª©ì´ í•„ìš”',0),(532784,14800,'he','×¤×¨×™×˜×™× × ×•×¡×¤×™× ×©×•×¨×” ×‘×—×©×‘×•× ×™×ª ××•×ª×• ×¦×¨×™×š ×¨×§ ××ª ×–×”×•×ª ×”×œ×§×•×— ××• ×©× ×”×—×‘×¨×” ××• ×”×¤×¨×˜×™ ×•××ª ×©× ×”×ž×©×¤×—×” ×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª',0),(532785,14800,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ„Î¿ Î¯Î´Î¹Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÏÎ­Ï€ÎµÎ¹ Î¼ÏŒÎ½Î¿ Ï„Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î· Î® ÏŒÎ½Î¿Î¼Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î® Ï€ÏÏŽÏ„Î¿ ÎºÎ±Î¹ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ ÏŒÎ½Î¿Î¼Î± ÎºÎ±Î¹ Ï„Î¿Î½ Î±ÏÎ¹',0),(532786,14800,'zh','åœ¨åŒä¸€å‘ç¥¨çš„é™„åŠ è¡Œé¡¹ç›®åªéœ€è¦å®¢æˆ· ID æˆ–å…¬å¸åç§°æˆ–ç¬¬ä¸€å’Œæœ€åŽä¸€ä¸ªåå­—å’Œå‘ç¥¨ç¼–å·',0),(532787,14800,'sv','Ytterligare artiklar i samma faktura behÃ¶ver bara Kundnumret eller fÃ¶retagsnamn eller fÃ¶rsta och sista namnet och fakturanummer',0),(532788,14800,'it','Voci aggiuntive nella stessa fattura Ã¨ necessario solo l\'ID del cliente o nome azienda o primo e ultimo nome e il numero di fattura',0),(532789,14800,'tl','',0),(532790,14800,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸”à¸µà¸¢à¸§à¸à¸±à¸™à¸•à¹‰à¸­à¸‡à¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸² à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸— à¸«à¸£à¸·à¸­à¹à¸£à¸ à¹à¸¥à¸°à¸™à¸²à¸¡à¸ªà¸à¸¸à¸¥ à¹à¸¥à¸°à¸',0),(532791,14800,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤°à¥‡à¤–à¤¾ à¤†à¤‡à¤Ÿà¤® à¤à¤• à¤¹à¥€ à¤šà¤¾à¤²à¤¾à¤¨ à¤®à¥‡à¤‚ à¤•à¥‡à¤µà¤² à¤—à¥à¤°à¤¾à¤¹à¤• à¤†à¤ˆà¤¡à¥€ à¤¯à¤¾ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® à¤”à¤° à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤”à¤° à¤‡à¤¨à¤µà¥‰à¤‡à',0),(532792,14800,'ms','Item-item tambahan garisan dalam invois yang sama hanya perlu ID pelanggan atau nama Syarikat atau pertama dan nama dan nombor invois',0),(532793,14800,'ar','Ø¨Ù†ÙˆØ¯ Ø¥Ø¶Ø§ÙÙŠØ© ÙÙŠ Ù†ÙØ³ Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙÙ‚Ø· Ø¨Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰ Ù…Ø¹Ø±Ù Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø£Ùˆ Ø§Ù„Ø£ÙˆÙ„ ÙˆØ§Ø³Ù… Ø§Ù„Ø¹Ø§Ø¦Ù„Ø© ÙˆØ±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(532794,14800,'fr','Des rubriques supplÃ©mentaires sur la mÃªme facture seulement besoin de l\'ID de client ou nom de sociÃ©tÃ© ou premiÃ¨re et prÃ©nom et le numÃ©ro de facture',0),(532795,14800,'jp','åŒã˜è«‹æ±‚æ›¸ã«è¿½åŠ ã®è¡Œã‚¢ã‚¤ãƒ†ãƒ ã§ã¯ã€é¡§å®¢ ID ã¾ãŸã¯ä¼šç¤¾åã¾ãŸã¯æœ€åˆã¨æœ€å¾Œã®åå‰ã¨è«‹æ±‚æ›¸ç•ªå·ã ã‘å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(532796,14800,'pt','Linhas de itens adicionais na mesma fatura sÃ³ precisa o ID de cliente ou nome da empresa ou primeiro e Ãºltimo nome e o nÃºmero da factura',0),(532797,14800,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð² Ñ‚Ð¾Ð¼ Ð¶Ðµ ÑÑ‡ÐµÑ‚Ðµ Ð½ÑƒÐ¶Ð½Ð¾ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð»Ð¸ Ð¿ÐµÑ€Ð²Ñ‹Ð¹ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ Ð¸ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-',0),(532798,14800,'es','ArtÃ­culos de lÃ­nea adicionales en la misma factura sÃ³lo necesita el ID de cliente o nombre de la empresa o primero y apellido y el nÃºmero de factura',0),(532799,14800,'de','ZusÃ¤tzliche Posten In derselben Rechnung brauchen nur die Kundennummer oder Firmennamen oder ersten und Nachname und die Rechnungsnummer',0),(532800,14800,'en','Additional Line Items In The Same Invoice Only Need The Customer ID Or Company Name Or First And Last Name And The Invoice Number',0),(532801,14801,'is','',0),(532802,14801,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯ Ùˆ Ù†Ø§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡',0),(532803,14801,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯ Ùˆ Ù†Ø§Ù… Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø§Ø±Ø§Ø¦Ù‡ Ø´Ø¯Ù‡',0),(532804,14801,'tr','MÃ¼ÅŸteri KimliÄŸi bulunamadÄ± ve ad bilgilerini saÄŸlanmadÄ±',0),(532805,14801,'pl','Nie znaleziono identyfikatora klienta i informacje nazw nie dostarczone',0),(532806,14801,'bg','ÐÐµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½ Ð˜Ð” Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸ Ð¸Ð¼ÐµÑ‚Ð¾ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð½Ðµ Ðµ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²ÐµÐ½Ð°',0),(532807,14801,'ur','Ø´Ù†Ø§Ø®Øª Ú¯Ø§ÛÚ© Ù†ÛÛŒÚº Ù…Ù„Ø§ Ø§ÙˆØ± Ù†Ø§Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ÙØ±Ø§ÛÙ… Ù†ÛÛŒÚº Ú©ÛŒ Ø¬Ø§ØªÛŒ',0),(532808,14801,'sr','Ð˜Ð” ÐºÑƒÐ¿Ñ†Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½ Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð¸Ð¼ÐµÐ½Ð° Ð½Ð¸Ñ˜Ðµ Ð½Ð°Ð²ÐµÐ´ÐµÐ½',0),(532809,14801,'vi','KhÃ´ng tÃ¬m tháº¥y ID khÃ¡ch hÃ ng vÃ  thÃ´ng tin tÃªn khÃ´ng Ä‘Æ°á»£c cung cáº¥p',0),(532810,14801,'af','KliÃ«nt-ID nie gevind en naam inligting voorsien nie',0),(532811,14801,'ro','ID-ul nu a fost gÄƒsit ÅŸi numele informaÅ£ii furnizate nu',0),(532812,14801,'et','Kliendi ID-d ei leitud ja nimi Info ei ole ette',0),(532813,14801,'si','ID stranke ni mogoÄe najti in Info ime ni na voljo',0),(532814,14801,'ba','ID pelanggan tidak ditemukan dan nama Info tidak disediakan',0),(532815,14801,'nl','Klant-ID niet gevonden en naam informatie niet verstrekt',0),(532816,14801,'fi','Asiakastunnus ei lÃ¶ydy ja nimen tietoja toimiteta',0),(532817,14801,'no','Kunde-ID funnet ikke og informasjon om navn finnes ikke',0),(532818,14801,'da','Kunde-ID blev ikke fundet og navn Info fastsat ikke',0),(532819,14801,'ko','ê³ ê° IDë¥¼ ì°¾ì„ ìˆ˜ ì—†ëŠ” ë° ì´ë¦„ ì •ë³´ë¥¼ ì œê³µ í•˜ì§€',0),(532820,14801,'he','×ž×–×”×” ×œ×§×•×— ××™× ×• × ×ž×¦×, ×•×™×© ×©× ×¤×¨×˜×™ ×œ× ×ž×¡×•×¤×§',0),(532821,14801,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î· Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ ÎºÎ±Î¹ ÏŒÎ½Î¿Î¼Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î´ÎµÎ½ Ï€Î±ÏÎ­Ï‡Î¿Î½Ï„Î±Î¹',0),(532822,14801,'zh','æ‰¾ä¸åˆ°å®¢æˆ· ID å’Œåç§°ä¿¡æ¯ä¸æä¾›',0),(532823,14801,'sv','Kund-ID hittades inte och namn information tillhandahÃ¥lls inte',0),(532824,14801,'it','ID cliente non trovato e nome Info non fornito',0),(532825,14801,'tl','',0),(532826,14801,'th','à¹„à¸¡à¹ˆà¸žà¸š ID à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸² à¹à¸¥à¸°à¹„à¸¡à¹ˆà¸¡à¸µà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸Šà¸·à¹ˆà¸­',0),(532827,14801,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• ID à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤”à¤° à¤¨à¤¾à¤® à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¨à¤¹à¥€à¤‚ à¤ªà¥à¤°à¤¦à¤¾à¤¨ à¤•à¥€',0),(532828,14801,'ms','ID pelanggan tidak ditemui dan nama maklumat tidak disediakan',0),(532829,14801,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ø¹Ø±Ù Ø§Ù„Ø¹Ù…ÙŠÙ„ ÙˆÙ„Ù… ØªÙ‚Ø¯Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø§Ø³Ù…',0),(532830,14801,'fr','Client ID introuvable et nom Info non fournis',0),(532831,14801,'jp','é¡§å®¢ ID ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã€åå‰ã®æƒ…å ±ãŒæä¾›ã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(532832,14801,'pt','Cliente ID nÃ£o encontrado e informaÃ§Ã£o de nome nÃ£o fornecido',0),(532833,14801,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸ Ð¸Ð¼Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð½Ðµ Ð¿Ñ€ÐµÐ´Ð¾ÑÑ‚Ð°Ð²Ð»ÑÐµÑ‚ÑÑ',0),(532834,14801,'es','ID de cliente no se encuentra y no proporcionÃ³ informaciÃ³n nombre',0),(532835,14801,'de','Kunden-ID nicht gefunden, und Name Info nicht vorgesehen',0),(532836,14801,'en','Customer ID Not Found And Name Info Not Provided',0),(532837,14802,'is','',0),(532838,14802,'dr','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(532839,14802,'pr','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(532840,14802,'tr','Fatura numarasÄ± ve mÃ¼ÅŸteri numarasÄ± veya ÅŸirket adÄ± veya ilk ve son adÄ± olmasÄ± gerekir',0),(532841,14802,'pl','Musi mieÄ‡ identyfikator pÅ‚atnika i odbiorcy lub nazwa firmy lub imiÄ™ i nazwisko',0),(532842,14802,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ID Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð° Ð¸Ð»Ð¸ Ð¿ÑŠÑ€Ð²Ð¾ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(532843,14802,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø§ÙˆØ± Ú¯Ø§ÛÚ© ID ÛŒØ§ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù†Ø§Ù… ÛŒØ§ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§ÙˆØ± Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(532844,14802,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð˜Ð” Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ \"Ð¸\" ÐšÑƒÐ¿Ð°Ñ† \"Ð¸Ð»Ð¸\"Ð¸Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ \"Ð¸Ð»Ð¸\" Ð¿Ñ€Ð²Ð¸\"Ð¸\" Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(532845,14802,'vi','Pháº£i cÃ³ ID sá»‘ hÃ³a Ä‘Æ¡n vÃ  khÃ¡ch hÃ ng hoáº·c tÃªn cÃ´ng ty hoáº·c Ä‘áº§u tiÃªn vÃ  cuá»‘i cÃ¹ng tÃªn',0),(532846,14802,'af','Faktuur nommer en kliÃ«nt-ID of maatskappynaam of eerste en laaste naam moet hÃª',0),(532847,14802,'ro','Trebuie sÄƒ aveÅ£i numÄƒrul facturii ÅŸi client ID-ul sau numele companiei sau primul ÅŸi ultimul nume',0),(532848,14802,'et','Peab olema arve Number ja kliendi ID vÃµi firma nimi vÃµi esimese ja perekonnanimi',0),(532849,14802,'si','Mora imeti Å¡tevilko raÄuna in Customer ID ali firma ali ime in priimek',0),(532850,14802,'ba','Harus memiliki nomor Invoice dan pelanggan ID atau nama perusahaan atau pertama dan nama terakhir',0),(532851,14802,'nl','Factuurnummer en klant-ID of de naam van het bedrijf of de voornaam en de achternaam moet hebben',0),(532852,14802,'fi','On oltava laskunumero ja Asiakastunnus tai yrityksen nimi tai ensimmÃ¤isenÃ¤ ja sukunimi',0),(532853,14802,'no','MÃ¥ ha fakturanummer og kunde-ID eller firmanavn eller fornavn og etternavn',0),(532854,14802,'da','Skal Have fakturanummer og kunde-ID eller firmanavn eller fÃ¸rste og sidste navn',0),(532855,14802,'ko','ì†¡ìž¥ ë²ˆí˜¸ ë° ê³ ê° ID, íšŒì‚¬ ì´ë¦„ ë˜ëŠ” ì²˜ìŒ, ë§ˆì§€ë§‰ ì´ë¦„ì´ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(532856,14802,'he','×—×™×™×‘ ×œ×”×™×•×ª ×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª ×•×–×™×”×•×™ ×œ×§×•×—×•×ª ××• ×©× ×”×—×‘×¨×” ××• ×”×¤×¨×˜×™ ×•×©× ×”×ž×©×¤×—×”',0),(532857,14802,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡Î¿Ï…Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… ÎºÎ±Î¹ Ï€ÎµÎ»Î¬Ï„Î· ID Î® ÏŒÎ½Î¿Î¼Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î® Ï€ÏÏŽÏ„Î¿ ÎºÎ±Î¹ ÎµÏ€ÏŽÎ½Ï…Î¼Î¿',0),(532858,14802,'zh','å¿…é¡»å…·æœ‰å‘ç¥¨ç¼–å·å’Œå®¢æˆ· ID æˆ–å…¬å¸åç§°æˆ–ç¬¬ä¸€ä¸ªå’Œæœ€åŽä¸€ä¸ªåå­—',0),(532859,14802,'sv','MÃ¥ste ha fakturanummer och kund-ID eller fÃ¶retagets namn eller fÃ¶rsta och sista namn',0),(532860,14802,'it','Deve avere il numero di fattura e Customer ID o nome della societÃ  o prima e cognome',0),(532861,14802,'tl','',0),(532862,14802,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸£à¸«à¸±à¸ªà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹à¸¥à¸°à¸¥à¸¹à¸à¸„à¹‰à¸² à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸— à¸«à¸£à¸·à¸­à¹à¸£à¸ à¹à¸¥à¸°à¸Šà¸·à¹ˆà¸­à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(532863,14802,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤”à¤° à¤—à¥à¤°à¤¾à¤¹à¤• à¤†à¤ˆà¤¡à¥€ à¤¯à¤¾ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® à¤”à¤° à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(532864,14802,'ms','Mesti mempunyai ID nombor invois dan pelanggan atau nama Syarikat atau pertama dan nama',0),(532865,14802,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ù…Ø¹Ø±Ù Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ÙˆØ±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø£Ùˆ Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø£Ùˆ Ø§Ù„Ø£ÙˆÙ„ ÙˆØ§Ø³Ù… Ø§Ù„Ø¹Ø§Ø¦Ù„Ø©',0),(532866,14802,'fr','Doit avoir le numÃ©ro de facture et client ID ou nom de sociÃ©tÃ© ou premiÃ¨re et prÃ©nom',0),(532867,14802,'jp','è«‹æ±‚æ›¸ç•ªå·ã‚„é¡§å®¢ ID ã¾ãŸã¯ä¼šç¤¾åã¾ãŸã¯æœ€åˆã¨æœ€å¾Œã®åå‰ã‚’æŒã¤å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(532868,14802,'pt','Deve ter o nÃºmero da factura e do cliente ID ou nome da empresa ou primeiro e Ãºltimo nome',0),(532869,14802,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð¼ÐµÑ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð¸Ð»Ð¸ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð»Ð¸ Ð¸Ð¼Ñ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ',0),(532870,14802,'es','Debe tener el nÃºmero de factura y el cliente ID o nombre de la empresa o primero y apellido',0),(532871,14802,'de','Rechnungsnummer und Kunden-ID oder Name des Unternehmens oder erste und Nachname mÃ¼ssen',0),(532872,14802,'en','Must Have Invoice Number And Customer ID Or Company Name Or First And Last Name',0),(532873,14803,'is','',0),(532874,14803,'dr','Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ù…Ú¯Ø± Ø§ÛŒÙ†Ú©Ù‡ Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ ØªÙ†Ø¸ÛŒÙ… Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(532875,14803,'pr','Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ù…Ú¯Ø± Ø§ÛŒÙ†Ú©Ù‡ Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ ØªÙ†Ø¸ÛŒÙ… Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(532876,14803,'tr','Åžirket adÄ± veya ilk ve son adÄ± ayarlamadÄ±ysanÄ±z gerekli',0),(532877,14803,'pl','Wymagane, chyba Å¼e nazwa firmy lub imiÄ™ i nazwisko sÄ… ustawione',0),(532878,14803,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ð¾ÑÐ²ÐµÐ½ Ð°ÐºÐ¾ Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð° Ð¸Ð»Ð¸ Ð¿ÑŠÑ€Ð²Ð¾Ñ‚Ð¾ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ ÑÐ° Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¸',0),(532879,14803,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… ÛŒØ§ Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§ÙˆØ± Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ø³ÛŒÙ¹ Ú©ÛŒÛ’ Ú¯Ø¦Û’ ÛÛŒÚº Ø¬Ø¨ ØªÚ© Ú©Û Ù…Ø·Ù„ÙˆØ¨Û',0),(532880,14803,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð¾ÑÐ¸Ð¼ Ð°ÐºÐ¾ Ð¸Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ \"Ð¸Ð»Ð¸\" Ð¿Ñ€Ð²Ð¸\"Ð¸\" Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ ÑÑƒ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ðµ.',0),(532881,14803,'vi','YÃªu cáº§u trá»« khi tÃªn cÃ´ng ty hoáº·c Ä‘áº§u tiÃªn vÃ  tÃªn cuá»‘i cÃ¹ng Ä‘Æ°á»£c thiáº¿t láº­p',0),(532882,14803,'af','Vereis tensy maatskappynaam of eerste en laaste naam is gestel',0),(532883,14803,'ro','Necesare, cu excepÅ£ia cazului Ã®n numele companiei sau primul ÅŸi ultimul nume sunt stabilite',0),(532884,14803,'et','Vaja kui firma nimi vÃµi esimene ja Viimane nimi mÃ¤Ã¤ratud',0),(532885,14803,'si','Potrebna, razen Äe so doloÄene firma ali ime in priimek',0),(532886,14803,'ba','Diperlukan kecuali nama perusahaan atau pertama dan nama terakhir ditetapkan',0),(532887,14803,'nl','Vereist tenzij bedrijfsnaam of eerste en laatste naam zijn ingesteld',0),(532888,14803,'fi','Pakollinen ellei yrityksen nimi tai ensimmÃ¤isenÃ¤ ja sukunimi',0),(532889,14803,'no','Kreves med mindre firmanavn eller fÃ¸rste og siste navnet',0),(532890,14803,'da','PÃ¥krÃ¦vet, medmindre firmanavn eller fÃ¸rste og sidste navn er indstillet',0),(532891,14803,'ko','íšŒì‚¬ ì´ë¦„ ë˜ëŠ” ì²« ë²ˆì§¸ ë° ë§ˆì§€ë§‰ ì´ë¦„ ì„¤ì • í•„ìš”',0),(532892,14803,'he','× ×“×¨×©×™× ××œ× ×× ×›×Ÿ ×©× ×—×‘×¨×” ××• ×¤×¨×˜×™ ×•×©× ×”×ž×©×¤×—×” ×ž×•×’×“×¨×™×',0),(532893,14803,'el','Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹, ÎµÎºÏ„ÏŒÏ‚ ÎµÎ¬Î½ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î® Ï€ÏÏŽÏ„Î¿ ÎºÎ±Î¹ ÎµÏ€ÏŽÎ½Ï…Î¼Î¿ ÎºÎ±Î¸Î¿ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹',0),(532894,14803,'zh','å¿…å¡«ï¼Œé™¤éžå…¬å¸åç§° ï¼ˆæˆ–ç¬¬ä¸€æ¬¡å’Œæœ€åŽä¸€åè¢«è®¾ç½®',0),(532895,14803,'sv','KrÃ¤vs om inte eller fÃ¶retagets namn och efternamn anges',0),(532896,14803,'it','Necessaria a meno che non vengono impostati il nome azienda o primo ed ultimo nome',0),(532897,14803,'tl','',0),(532898,14803,'th','à¸ˆà¸³à¹€à¸›à¹‡à¸™à¹€à¸§à¹‰à¸™à¹à¸•à¹ˆà¸ˆà¸°à¸¡à¸µà¸•à¸±à¹‰à¸‡à¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸— à¸«à¸£à¸·à¸­à¹à¸£à¸ à¹à¸¥à¸°à¸Šà¸·à¹ˆà¸­à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(532899,14803,'hi','à¤œà¤¬ à¤¤à¤• à¤•à¤¿ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® à¤”à¤° à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¸à¥‡à¤Ÿ à¤•à¤° à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(532900,14803,'ms','Diperlukan kecuali nama Syarikat atau pertama dan nama akhir ditetapkan',0),(532901,14803,'ar','Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© Ù…Ø§ Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø£Ùˆ Ø§Ù„Ø£ÙˆÙ„ ÙˆØ§Ø³Ù… Ø§Ù„Ø¹Ø§Ø¦Ù„Ø©',0),(532902,14803,'fr','Obligatoire sauf si le nom de l\'entreprise ou de premier et de nom sont dÃ©finies',0),(532903,14803,'jp','ä¼šç¤¾åã¾ãŸã¯æœ€åˆã¨æœ€å¾Œã®åå‰ãŒè¨­å®šã•ã‚Œã¦ã„ãªã„ãŸã‚ã«å¿…è¦ãª',0),(532904,14803,'pt','NecessÃ¡rio a menos que o nome da empresa ou primeiro e Ãºltimo nome sÃ£o definidas',0),(532905,14803,'ru','Ð•ÑÐ»Ð¸ Ð·Ð°Ð´Ð°Ñ‚ÑŒ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð»Ð¸ Ð¸Ð¼Ñ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ',0),(532906,14803,'es','Obligatorio a menos que el nombre de la empresa o primero y Ãºltimo nombre se establecen',0),(532907,14803,'de','Erforderlich, wenn keine Firmennamen oder ersten und letzten Namen festgelegt sind',0),(532908,14803,'en','Required Unless Company Name Or First And Last Name Are Set',0),(532909,14804,'is','',0),(532910,14804,'dr','Ù…Ú¯Ø± Ø¯Ø± Ù…ÙˆØ§Ø±Ø¯ÛŒ Ú©Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ØªÙ†Ø¸ÛŒÙ… Ø´Ø¯Ù‡ Ø§Ø³Øª Ù„Ø§Ø²Ù…',0),(532911,14804,'pr','Ù…Ú¯Ø± Ø¯Ø± Ù…ÙˆØ§Ø±Ø¯ÛŒ Ú©Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ØªÙ†Ø¸ÛŒÙ… Ø´Ø¯Ù‡ Ø§Ø³Øª Ù„Ø§Ø²Ù…',0),(532912,14804,'tr','MÃ¼ÅŸteri kimliÄŸi veya ÅŸirket adÄ± ayarlanmadÄ±ÄŸÄ± sÃ¼rece gerekli',0),(532913,14804,'pl','Wymagane, chyba Å¼e znajduje siÄ™ identyfikator klienta lub nazwa firmy',0),(532914,14804,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ð¾ÑÐ²ÐµÐ½ Ð°ÐºÐ¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ Ð½Ð¾Ð¼ÐµÑ€ Ð¸Ð»Ð¸ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð° Ðµ Ñ€Ð°Ð·Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½',0),(532915,14804,'ur','Ø¬Ø¨ ØªÚ© Ø®Ø±ÛŒØ¯Ø§Ø± Ú©ÛŒ Ø´Ù†Ø§Ø®Øª ÛŒØ§ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… Ù…ØªØ¹ÛŒÙ† ÛÛ’ Ø¯Ø±Ú©Ø§Ø±',0),(532916,14804,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð¾ÑÐ¸Ð¼ Ð°ÐºÐ¾ Ð˜Ð” ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½.',0),(532917,14804,'vi','YÃªu cáº§u trá»« khi ID khÃ¡ch hÃ ng hoáº·c tÃªn cÃ´ng ty Ä‘Æ°á»£c thiáº¿t láº­p',0),(532918,14804,'af','Vereis tensy kliÃ«nt ID of maatskappy naam Is opgestel',0),(532919,14804,'ro','Cerute daca nu ID-ul sau numele companiei este setat',0),(532920,14804,'et','Vajalik kui kliendi ID vÃµi firma nimi on seatud',0),(532921,14804,'si','Potrebno, razen Äe je doloÄeno ID stranke ali ime podjetja',0),(532922,14804,'ba','Diperlukan kecuali ID pelanggan atau nama perusahaan diatur',0),(532923,14804,'nl','Vereist tenzij klant-ID of naam van het bedrijf Is ingesteld',0),(532924,14804,'fi','Pakollinen ellei asiakas ID tai yrityksen nimi on mÃ¤Ã¤ritetty',0),(532925,14804,'no','Kreves med mindre kunde-ID eller firmanavn er satt',0),(532926,14804,'da','PÃ¥krÃ¦vet, medmindre kunde-ID eller virksomhedens navn er indstillet',0),(532927,14804,'ko','í•„ìš”í•œ ê³ ê° ID ë° íšŒì‚¬ ì´ë¦„ ì„¤ì • ë˜ì–´ ìžˆì§€ ì•Šìœ¼ë©´',0),(532928,14804,'he','× ×“×¨×©×™× ××œ× ×× ×›×Ÿ ×ž×–×”×” ×œ×§×•×— ××• ×©× ×—×‘×¨×” ×ž×•×’×“×¨×ª',0),(532929,14804,'el','Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹, ÎµÎºÏ„ÏŒÏ‚ ÎµÎ¬Î½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Ï„Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î· Î® Î· ÎµÏ€Ï‰Î½Ï…Î¼Î¯Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(532930,14804,'zh','å¿…å¡«ï¼Œé™¤éžå®¢æˆ· ID æˆ–å…¬å¸åç§°è®¾ç½®',0),(532931,14804,'sv','KrÃ¤vs om inte kund-ID eller fÃ¶retagsnamn Ã¤r instÃ¤lld',0),(532932,14804,'it','Necessaria a meno che il cliente ID o nome della societÃ  Ã¨ impostata',0),(532933,14804,'tl','',0),(532934,14804,'th','à¸ˆà¸³à¹€à¸›à¹‡à¸™à¹€à¸§à¹‰à¸™à¹à¸•à¹ˆà¸ˆà¸°à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸²à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸—',0),(532935,14804,'hi','à¤œà¤¬ à¤¤à¤• à¤•à¤¿ à¤—à¥à¤°à¤¾à¤¹à¤• à¤†à¤ˆà¤¡à¥€ à¤¯à¤¾ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¸à¥à¤¥à¤¾à¤ªà¤¿à¤¤ à¤¹à¥ˆ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(532936,14804,'ms','Dikehendaki melainkan pelanggan pengenalan atau nama Syarikat terletak',0),(532937,14804,'ar','Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø© Ù…Ø§ Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ø¹Ø±Ù Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ©',0),(532938,14804,'fr','Requis sauf si le client ID ou nom de l\'entreprise est',0),(532939,14804,'jp','é¡§å®¢ ID ã¾ãŸã¯ä¼šç¤¾åãŒè¨­å®šã•ã‚Œã¦ã„ãªã„å ´åˆã«å¿…è¦ãª',0),(532940,14804,'pt','NecessÃ¡rio a menos que o cliente ID ou nome da empresa Ã© definido',0),(532941,14804,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ, ÐµÑÐ»Ð¸ Ð½Ðµ Ð¸Ð¼ÐµÐµÑ‚ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(532942,14804,'es','Necesaria a menos que se establezca ID de cliente o nombre de la empresa',0),(532943,14804,'de','Erforderlich, wenn die Kunden-ID oder Name des Unternehmens festgelegt ist',0),(532944,14804,'en','Required Unless Customer ID Or Company Name Is Set',0),(532945,14805,'is','',0),(532946,14805,'dr','Ù…Ú¯Ø± Ø¯Ø± Ù…ÙˆØ§Ø±Ø¯ÛŒ Ú©Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ Ù†Ø§Ù… Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(532947,14805,'pr','Ù…Ú¯Ø± Ø¯Ø± Ù…ÙˆØ§Ø±Ø¯ÛŒ Ú©Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ Ù†Ø§Ù… Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(532948,14805,'tr','Gerekli sÃ¼rece mÃ¼ÅŸteri kimliÄŸi ya da ilk ve son adÄ± ayarla',0),(532949,14805,'pl','Wymagane, chyba Å¼e identyfikator klienta lub imiÄ™ i nazwisko sÄ…',0),(532950,14805,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð° Ð¾ÑÐ²ÐµÐ½ Ð°ÐºÐ¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ID Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ ÑÐ° Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸',0),(532951,14805,'ur','Ø¬Ø¨ ØªÚ© Ø®Ø±ÛŒØ¯Ø§Ø± Ú©ÛŒ Ø´Ù†Ø§Ø®Øª ÛŒØ§ Ù¾ÛÙ„Û’ Ø§ÙˆØ± Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… ÛÛŒÚº Ø³ÛŒÙ¹ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(532952,14805,'sr','ÐÐµÐ¾Ð¿Ñ…Ð¾Ð´Ð°Ð½ Ð°ÐºÐ¾ Ð½Ðµ Ð˜Ð” ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð»Ð¸ ÑÑƒ Ð¸Ð¼Ðµ Ð¸ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(532953,14805,'vi','YÃªu cáº§u trá»« khi ID khÃ¡ch hÃ ng hoáº·c tÃªn vÃ  há» Ä‘Æ°á»£c thiáº¿t láº­p',0),(532954,14805,'af','Tensy die kliÃ«nt ID of eerste en laaste naam is stel vereis',0),(532955,14805,'ro','Cerute daca nu ID client sau prenumele sunt stabilite',0),(532956,14805,'et','Vajalik kui kliendi ID vÃµi ees- ja perekonnanimi on seatud',0),(532957,14805,'si','Potrebna, razen Äe ID stranke ali ime in priimek so doloÄene',0),(532958,14805,'ba','Diperlukan kecuali ID pelanggan atau nama pertama dan terakhir yang ditetapkan',0),(532959,14805,'nl','Vereist tenzij klant-ID of naam en achternaam zijn ingesteld',0),(532960,14805,'fi','Pakollinen ellei asiakas ID tai etu- ja sukunimi ovat',0),(532961,14805,'no','Kreves med mindre kunde-ID eller fornavn og etternavn er angitt',0),(532962,14805,'da','PÃ¥krÃ¦vet, medmindre kunde-ID eller fÃ¸rste og sidste navn er angivet',0),(532963,14805,'ko','í•„ìš”í•œ ê³ ê° ID ë˜ëŠ” ì´ë¦„ ì„¤ì •',0),(532964,14805,'he','× ×“×¨×©×™× ××œ× ×× ×›×Ÿ ×ž×–×”×” ×œ×§×•×— ××• ×”×©× ×”×¤×¨×˜×™ ×•×”×ž×©×¤×—×” ×œ×”×’×“×™×¨',0),(532965,14805,'el','Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹, ÎµÎºÏ„ÏŒÏ‚ ÎµÎ¬Î½ Ï„Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î· Î® Ï„Î¿ ÏŒÎ½Î¿Î¼Î± ÎºÎ±Î¹ Ï„Î¿ ÎµÏ€ÏŽÎ½Ï…Î¼Î¿ ÎµÎ¯Î½Î±Î¹ Ï€Î¿Ï…',0),(532966,14805,'zh','å¿…å¡«ï¼Œé™¤éžå®¢æˆ· ID æˆ–åå­—å’Œå§“æ°æ˜¯è®¾ç½®',0),(532967,14805,'sv','KrÃ¤vs om inte kund-ID eller fÃ¶rnamn och efternamn Ã¤r instÃ¤lld',0),(532968,14805,'it','Necessaria a meno che il cliente ID o nome e cognome sono impostate',0),(532969,14805,'tl','',0),(532970,14805,'th','à¸ˆà¸³à¹€à¸›à¹‡à¸™à¹€à¸§à¹‰à¸™à¹à¸•à¹ˆà¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸²à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­ à¹à¸¥à¸°à¸™à¸²à¸¡à¸ªà¸à¸¸à¸¥à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡',0),(532971,14805,'hi','à¤œà¤¬ à¤¤à¤• à¤•à¤¿ à¤—à¥à¤°à¤¾à¤¹à¤• à¤†à¤ˆà¤¡à¥€ à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® à¤”à¤° à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¹à¥ˆà¤‚ à¤¸à¥‡à¤Ÿ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(532972,14805,'ms','Diperlukan melainkan jika ID pelanggan atau nama pertama dan akhir yang ditetapkan',0),(532973,14805,'ar','Ù…Ø·Ù„ÙˆØ¨ Ù…Ø§ Ù„Ù… ÙŠÙƒÙ† ØªØ¹ÙŠÙŠÙ† Ù…Ø¹Ø±Ù Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ Ù‡ÙŠ Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„ ÙˆØ§Ù„Ø£Ø®ÙŠØ±',0),(532974,14805,'fr','Requis sauf si la valeur ID de client ou nom et prÃ©nom sont',0),(532975,14805,'jp','é¡§å®¢ã® ID ã¾ãŸã¯å§“ã¨åãŒè¨­å®šã•ã‚Œã¦ã„ãªã„å ´åˆã«å¿…è¦ãª',0),(532976,14805,'pt','NecessÃ¡rio a menos que o cliente ID ou nome e sobrenome sÃ£o definidas',0),(532977,14805,'ru','Ð•ÑÐ»Ð¸ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ñ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ ÑÐ²Ð»ÑÑŽÑ‚ÑÑ',0),(532978,14805,'es','Obligatorio a menos que el ID de cliente o nombre y apellido son Set',0),(532979,14805,'de','Erforderlich, wenn keine Kundennummer oder vor- und Nachname sind festgelegt',0),(532980,14805,'en','Required Unless Customer ID Or First And Last Name Are Set',0),(532981,14806,'is','',0),(532982,14806,'dr','ÙˆØ§Ø­Ø¯ Ø±Ø§ Ù¾ÛŒØ¯Ø§ Ú©Ù†Ø¯',0),(532983,14806,'pr','ÙˆØ§Ø­Ø¯ Ø±Ø§ Ù¾ÛŒØ¯Ø§ Ú©Ù†Ø¯',0),(532984,14806,'tr','Birim bulunamadÄ±',0),(532985,14806,'pl','Nie moÅ¼na odnaleÅºÄ‡ urzÄ…dzenia',0),(532986,14806,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(532987,14806,'ur','ÛŒÙˆÙ†Ù¹ Ú©Ùˆ Ù…Ù„ Ù†Û Ø³Ú©Ø§',0),(532988,14806,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(532989,14806,'vi','KhÃ´ng thá»ƒ tÃ¬m tháº¥y Ä‘Æ¡n vá»‹',0),(532990,14806,'af','Eenheid nie kon vind',0),(532991,14806,'ro','Nu am putut gÄƒsi unitatea',0),(532992,14806,'et','Ei leia Ã¼ksuse',0),(532993,14806,'si','Enote ni bilo mogoÄe najti.',0),(532994,14806,'ba','Tidak dapat menemukan Unit',0),(532995,14806,'nl','Konden niet vondst eenheid',0),(532996,14806,'fi','Ei lÃ¶ytÃ¤nyt yksikkÃ¶',0),(532997,14806,'no','Finner ikke enhet',0),(532998,14806,'da','Kunne ikke finde enhed',0),(532999,14806,'ko','ìž¥ì¹˜ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(533000,14806,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ×™×—×™×“×”',0),(533001,14806,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Î¼Î¿Î½Î¬Î´Î±',0),(533002,14806,'zh','æ‰¾ä¸åˆ°å•ä½',0),(533003,14806,'sv','Kunde inte hitta enheten',0),(533004,14806,'it','Non riusciva a trovare unitÃ ',0),(533005,14806,'tl','',0),(533006,14806,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸«à¸™à¹ˆà¸§à¸¢',0),(533007,14806,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(533008,14806,'ms','Tidak dapat mencari Unit',0),(533009,14806,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ ÙˆØ­Ø¯Ø©',0),(533010,14806,'fr','UnitÃ© est introuvable',0),(533011,14806,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(533012,14806,'pt','NÃ£o foi possÃ­vel localizar unidade',0),(533013,14806,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ ÑƒÑÑ‚Ñ€Ð¾Ð¹ÑÑ‚Ð²Ð¾',0),(533014,14806,'es','No se pudo encontrar unidad',0),(533015,14806,'de','Einheit konnte nicht gefunden werden.',0),(533016,14806,'en','Could Not Find Unit',0),(533017,14807,'is','',0),(533018,14807,'dr','Ø¯Ø±Ø¢Ù…Ø¯ ÙˆØ§Ø±Ø¯Ø§Øª',0),(533019,14807,'pr','Ø¯Ø±Ø¢Ù…Ø¯ ÙˆØ§Ø±Ø¯Ø§Øª',0),(533020,14807,'tr','Ä°thalat gelir',0),(533021,14807,'pl','PrzywÃ³z dochodÃ³w',0),(533022,14807,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(533023,14807,'ur','Ø¯Ø±Ø¢Ù…Ø¯ÛŒ Ù…Ø­ØµÙˆÙ„',0),(533024,14807,'sr','Ð£Ð²Ð¾Ð·Ð½Ð¸Ñ… Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(533025,14807,'vi','Doanh thu nháº­p',0),(533026,14807,'af','Invoer van inkomste',0),(533027,14807,'ro','Venituri de import',0),(533028,14807,'et','Impordi tulud',0),(533029,14807,'si','Uvoz prihodkov',0),(533030,14807,'ba','Impor pendapatan',0),(533031,14807,'nl','Importeren van inkomsten',0),(533032,14807,'fi','Tuo tuloja',0),(533033,14807,'no','Importere inntekter',0),(533034,14807,'da','Importere indtÃ¦gter',0),(533035,14807,'ko','ìˆ˜ìµ ê°€ì ¸ì˜¤ê¸°',0),(533036,14807,'he','×™×™×‘×•× ×”×›× ×¡×•×ª',0),(533037,14807,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÏƒÏŒÎ´Ï‰Î½',0),(533038,14807,'zh','å¯¼å…¥æ”¶å…¥',0),(533039,14807,'sv','Importera intÃ¤kter',0),(533040,14807,'it','Entrate di importazione',0),(533041,14807,'tl','',0),(533042,14807,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(533043,14807,'hi','à¤°à¤¾à¤œà¤¸à¥à¤µ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(533044,14807,'ms','Mengimport hasil',0),(533045,14807,'ar','Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(533046,14807,'fr','Importer des recettes',0),(533047,14807,'jp','å£²ã‚Šä¸Šã’é«˜ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(533048,14807,'pt','Receitas de importaÃ§Ã£o',0),(533049,14807,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð´Ð¾Ñ…Ð¾Ð´',0),(533050,14807,'es','Ingresos de importaciÃ³n',0),(533051,14807,'de','Import-Einnahmen',0),(533052,14807,'en','Import Revenue',0),(533053,14808,'is','',0),(533054,14808,'dr','Ø¨Ù‡ Ù†Ø¸Ø± Ù…ÛŒ Ø±Ø³Ø¯ Ø±Ú©ÙˆØ±Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(533055,14808,'pr','Ø¨Ù‡ Ù†Ø¸Ø± Ù…ÛŒ Ø±Ø³Ø¯ Ø±Ú©ÙˆØ±Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(533056,14808,'tr','Zaten ithal gÃ¶rÃ¼nmez',0),(533057,14808,'pl','Pojawia siÄ™ on juÅ¼ zostaÅ‚y przywiezione',0),(533058,14808,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð¸Ð·Ð³Ð»ÐµÐ¶Ð´Ð° Ð²ÐµÑ‡Ðµ ÑÐ° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸',0),(533059,14808,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ù¾ÛÙ„Û’ ÛÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©ÛŒÛ’ Ú¯Ø¦Û’ Ù„Ú¯ØªØ§ ÛÛ’',0),(533060,14808,'sr','Ð—Ð°Ð¿Ð¸Ñ Ñ›Ðµ ÑÐµ Ð¿Ð¾Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸ Ð²ÐµÑ› ÑƒÐ²ÐµÐ·ÐµÐ½Ð°',0),(533061,14808,'vi','Há»“ sÆ¡ dÆ°á»ng nhÆ° Ä‘Ã£ Ä‘Æ°á»£c nháº­p kháº©u',0),(533062,14808,'af','Rekord lyk het reeds ingevoer is',0),(533063,14808,'ro','ÃŽnregistrare pare sÄƒ deja au fost importate',0),(533064,14808,'et','Rekord nÃ¤ib juba imporditud',0),(533065,14808,'si','Zapis se zdi, da so bili Å¾e uvoÅ¾eni',0),(533066,14808,'ba','Catatan tampaknya telah diimpor',0),(533067,14808,'nl','Record lijkt te zijn al ingevoerd',0),(533068,14808,'fi','Tietue nÃ¤kyy jo tuotu',0),(533069,14808,'no','Posten ser ut til Ã¥ allerede har blitt importert',0),(533070,14808,'da','Vises posten har allerede blevet indfÃ¸rt',0),(533071,14808,'ko','ë ˆì½”ë“œê°€ ì´ë¯¸ ê°€ì ¸ì˜¨ ê²ƒìœ¼ë¡œ ë³´ì¸ë‹¤',0),(533072,14808,'he','×¨×©×•×ž×” ×ž×•×¤×™×¢×” ×›×“×™ ×©×›×‘×¨ ×™×•×‘××•',0),(533073,14808,'el','Î•Î³Î³ÏÎ±Ï†Î® ÎµÎ¼Ï†Î±Î½Î¯Î¶ÎµÏ„Î±Î¹ Î½Î± Î­Ï‡ÎµÎ¹ Î®Î´Î· ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯',0),(533074,14808,'zh','è®°å½•ä¼¼ä¹Žå·²ç»å¯¼å…¥',0),(533075,14808,'sv','Posten verkar redan har importerats',0),(533076,14808,'it','Record sembra giÃ  sono stati importati',0),(533077,14808,'tl','',0),(533078,14808,'th','à¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸—à¸µà¹ˆà¸›à¸£à¸²à¸à¸à¸¡à¸µà¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(533079,14808,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤†à¤¯à¤¾à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤•à¤Ÿ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ',0),(533080,14808,'ms','Rekod nampaknya telah diimport',0),(533081,14808,'ar','ÙŠØ¸Ù‡Ø± Ø³Ø¬Ù„ Ø§Ù„ÙØ¹Ù„ ØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯Ù‡Ø§',0),(533082,14808,'fr','Enregistrement semble avoir dÃ©jÃ  Ã©tÃ© importÃ©',0),(533083,14808,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ãŒæ—¢ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚Œã¦ã„ã‚‹ã«è¡¨ç¤ºã•ã‚Œã¾ã™ã€‚',0),(533084,14808,'pt','Registro parece jÃ¡ ter sido importado',0),(533085,14808,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ, ÐºÐ°Ðº Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÑÐµÑ‚ÑÑ, ÑƒÐ¶Ðµ Ð±Ñ‹Ð»Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹',0),(533086,14808,'es','Expediente aparece que ya se han importado',0),(533087,14808,'de','Datensatz angezeigt wird, bereits eingefÃ¼hrt worden sind',0),(533088,14808,'en','Record Appears To Have Already Been Imported',0),(533089,14809,'is','',0),(533090,14809,'dr','Ø¯Ø±Ø¢Ù…Ø¯ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ÙØ§ÛŒÙ„ Ø§Ú©Ø³Ù„',0),(533091,14809,'pr','Ø¯Ø±Ø¢Ù…Ø¯ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ ÙØ§ÛŒÙ„ Ø§Ú©Ø³Ù„',0),(533092,14809,'tr','Gelir Excel dosyasÄ±nÄ± seÃ§in',0),(533093,14809,'pl','Wybierz plik programu Excel dochodÃ³w',0),(533094,14809,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸ Excel Ñ„Ð°Ð¹Ð»',0),(533095,14809,'ur','Ø±ÛŒÙˆÙ†ÛŒÙˆ Excel Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(533096,14809,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´ Ð•xÑ†ÐµÐ» Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(533097,14809,'vi','Chá»n táº­p tin Excel doanh thu',0),(533098,14809,'af','Kies inkomste Excel lÃªer',0),(533099,14809,'ro','SelectaÅ£i fiÅŸierul Excel venituri',0),(533100,14809,'et','Valige tulude Exceli fail',0),(533101,14809,'si','Izberi Excelovo datoteko prihodkov',0),(533102,14809,'ba','Pilih File Excel pendapatan',0),(533103,14809,'nl','Selecteer inkomsten Excel-bestand',0),(533104,14809,'fi','Valitse tulot Excel-tiedosto',0),(533105,14809,'no','Velg inntekter Excel-fil',0),(533106,14809,'da','VÃ¦lg indtÃ¦gter Excel fil',0),(533107,14809,'ko','ìˆ˜ìµ Excel íŒŒì¼ ì„ íƒ',0),(533108,14809,'he','×‘×—×¨ ×§×•×‘×¥ Excel ×”×›× ×¡×•×ª',0),(533109,14809,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±ÏÏ‡ÎµÎ¯Î¿ Excel Î­ÏƒÎ¿Î´Î±',0),(533110,14809,'zh','é€‰æ‹©æ”¶å…¥ Excel æ–‡ä»¶',0),(533111,14809,'sv','VÃ¤lj inkomster Excel-fil',0),(533112,14809,'it','Selezionare il File di Excel entrate',0),(533113,14809,'tl','',0),(533114,14809,'th','à¹€à¸¥à¸·à¸­à¸à¹à¸Ÿà¹‰à¸¡ Excel à¸£à¸²à¸¢à¹„à¸”à¹‰',0),(533115,14809,'hi','à¤°à¤¾à¤œà¤¸à¥à¤µ Excel à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(533116,14809,'ms','Pilih fail Excel hasil',0),(533117,14809,'ar','Ø­Ø¯Ø¯ Ù…Ù„Ù Excel Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª',0),(533118,14809,'fr','SÃ©lectionnez le fichier Excel revenus',0),(533119,14809,'jp','åŽç›Šã® Excel ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã—ã¾ã™',0),(533120,14809,'pt','Selecione o arquivo do Excel de receitas',0),(533121,14809,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ„Ð°Ð¹Ð» Excel Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð²',0),(533122,14809,'es','Seleccione el archivo de Excel de ingresos',0),(533123,14809,'de','WÃ¤hlen Sie Einnahmen-Excel-Datei',0),(533124,14809,'en','Select Revenue Excel File',0),(533125,14810,'is','',0),(533126,14810,'dr','ÛŒÚ© Ø¯Ø³ØªÙ‡ Ù‡Ù†ÙˆØ² Ø´Ø±ÙˆØ¹ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(533127,14810,'pr','ÛŒÚ© Ø¯Ø³ØªÙ‡ Ù‡Ù†ÙˆØ² Ø´Ø±ÙˆØ¹ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(533128,14810,'tr','Bir toplu iÅŸlem henÃ¼z baÅŸlatÄ±lmadÄ±',0),(533129,14810,'pl','Partia nie zostaÅ‚a jeszcze rozpoczÄ™ta',0),(533130,14810,'bg','Ð•Ð´Ð½Ð° Ð¿Ð°Ñ€Ñ‚Ð¸Ð´Ð° Ð½Ðµ Ðµ ÑÑ‚Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð° Ð¾Ñ‰Ðµ',0),(533131,14810,'ur','Ø§ÛŒÚ© Ø¨ÛŒÚ† Ú©Û’ Ø¨Ø§ÙˆØ¬ÙˆØ¯ Ø´Ø±ÙˆØ¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ù†ÛÛŒÚº',0),(533132,14810,'sr','Ð“Ñ€ÑƒÐ¿Ñƒ Ñ˜Ð¾Ñˆ Ð½Ð¸ÑÑƒ Ð·Ð°Ð¿Ð¾Ñ‡ÐµÐ»Ðµ',0),(533133,14810,'vi','Má»™t lÃ´ Ä‘Ã£ khÃ´ng Ä‘Æ°á»£c báº¯t Ä‘áº§u Ä‘Æ°á»£c nÃªu ra',0),(533134,14810,'af','\'N bondel het nog nie begin nog',0),(533135,14810,'ro','Un lot nu a fost pornit Ã®ncÄƒ',0),(533136,14810,'et','Partii ei ole veel alanud',0),(533137,14810,'si','Serija je Å¡e niste zagnali',0),(533138,14810,'ba','Kumpulan belum dimulai belum',0),(533139,14810,'nl','Een Batch is nog niet begonnen',0),(533140,14810,'fi','ErÃ¤ ei ole vielÃ¤ kÃ¤ynnistetty',0),(533141,14810,'no','En gruppe er ikke startet ennÃ¥',0),(533142,14810,'da','Et parti er ikke blevet startet endnu',0),(533143,14810,'ko','ì¼ê´„ ì²˜ë¦¬ë¥¼ ì•„ì§ ì‹œìž‘ ë˜ì§€ ì•Šì€',0),(533144,14810,'he','×ž× ×” ×œ× ×”×—×œ×” ×¢×“×™×™×Ÿ',0),(533145,14810,'el','ÎœÎ¹Î± Ï€Î±ÏÏ„Î¯Î´Î± Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¾ÎµÎºÎ¹Î½Î®ÏƒÎµÎ¹ Î±ÎºÏŒÎ¼Î·',0),(533146,14810,'zh','ä¸€æ‰¹å°šæœªå¼€å§‹',0),(533147,14810,'sv','Ett parti har inte startat Ã¤nnu',0),(533148,14810,'it','Un Batch non Ã¨ stato ancora avviato',0),(533149,14810,'tl','',0),(533150,14810,'th','à¸Šà¸¸à¸”à¸‡à¸²à¸™à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¹€à¸£à¸´à¹ˆà¸¡à¸¢à¸±à¸‡',0),(533151,14810,'hi','à¤à¤• à¤¬à¥ˆà¤š à¤…à¤­à¥€ à¤¤à¤• à¤¶à¥à¤°à¥‚ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(533152,14810,'ms','Kumpulan yang belum dimulakan lagi',0),(533153,14810,'ar','Ø¯ÙØ¹Ø© Ù„Ù… ØªØ¨Ø¯Ø£ Ø¨Ø¹Ø¯',0),(533154,14810,'fr','Un lot n\'a pas encore Ã©tÃ© dÃ©marrÃ©',0),(533155,14810,'jp','ãƒãƒƒãƒãŒã¾ã é–‹å§‹ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(533156,14810,'pt','Um lote ainda nÃ£o foi iniciado',0),(533157,14810,'ru','ÐŸÐ°Ñ€Ñ‚Ð¸Ñ ÐµÑ‰Ðµ Ð½Ðµ Ð½Ð°Ñ‡Ð°Ñ‚Ð°',0),(533158,14810,'es','TodavÃ­a no se ha iniciado un lote',0),(533159,14810,'de','Ein Batch hat noch nicht begonnen wurde',0),(533160,14810,'en','A Batch Has Not Been Started Yet',0),(533161,14811,'is','',0),(533162,14811,'dr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ†Ø¸ÛŒÙ…',0),(533163,14811,'pr','Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ†Ø¸ÛŒÙ…',0),(533164,14811,'tr','KayÄ±t bilgisi ayarlanmamÄ±ÅŸ',0),(533165,14811,'pl','Zapis informacji nie zestaw',0),(533166,14811,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð·Ð°Ð¿Ð¸Ñ Ð½Ðµ Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð¾',0),(533167,14811,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(533168,14811,'sr','Ð—Ð°Ð¿Ð¸ÑÐ¸Ð²Ð°ÑšÐµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(533169,14811,'vi','ThÃ´ng tin há»“ sÆ¡ khÃ´ng Ä‘Æ°á»£c thiáº¿t láº­p',0),(533170,14811,'af','Rekord inligting stel nie',0),(533171,14811,'ro','ÃŽnregistrare informaÅ£ii nu Set',0),(533172,14811,'et','Salvestada Info pole seatud',0),(533173,14811,'si','Zapisa informacij ni nastavljena',0),(533174,14811,'ba','Info catatan tidak diatur',0),(533175,14811,'nl','Record Info niet ingesteld',0),(533176,14811,'fi','Tietueen tiedot aseteta',0),(533177,14811,'no','Postinfo ikke angitt',0),(533178,14811,'da','Optage Info ikke indstillet',0),(533179,14811,'ko','ë ˆì½”ë“œ ì •ë³´ë¥¼ ì„¤ì • í•˜ì§€',0),(533180,14811,'he','×¤×¨×˜×™ ×”×¨×©×•×ž×” ××™× ×” ×ž×•×’×“×¨×ª',0),(533181,14811,'el','Î¡ÎµÎºÏŒÏ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Î¿Ï… Î´ÎµÎ½',0),(533182,14811,'zh','è®°å½•ä¿¡æ¯æœªè®¾ç½®',0),(533183,14811,'sv','Spela in information inte instÃ¤lld',0),(533184,14811,'it','Info registrazione non impostato',0),(533185,14811,'tl','',0),(533186,14811,'th','à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”',0),(533187,14811,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(533188,14811,'ms','Maklumat rekod tidak disetkan',0),(533189,14811,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ØªØ³Ø¬ÙŠÙ„',0),(533190,14811,'fr','Info record pas rÃ©glÃ©',0),(533191,14811,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ã®æƒ…å ±ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(533192,14811,'pt','InformaÃ§Ã£o de registro nÃ£o definido',0),(533193,14811,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ Ð·Ð°Ð´Ð°Ð½Ð¾',0),(533194,14811,'es','Registro Info no ajustado',0),(533195,14811,'de','Rekord-Info ist nicht festgelegt.',0),(533196,14811,'en','Record Info Not Set',0),(533197,14812,'is','',0),(533198,14812,'dr','&gt; 90 Ø±ÙˆØ²',0),(533199,14812,'pr','&gt; 90 Ø±ÙˆØ²',0),(533200,14812,'tr','&gt; 90 gÃ¼n',0),(533201,14812,'pl','&gt; 90 dni',0),(533202,14812,'bg','&gt; 90 Ð´Ð½Ð¸',0),(533203,14812,'ur','&gt; 90 Ø¯Ù†',0),(533204,14812,'sr','&Ð³Ñ‚; 90 Ð´Ð°Ð½Ð°',0),(533205,14812,'vi','&gt; 90 ngÃ y',0),(533206,14812,'af','&gt; 90 dae',0),(533207,14812,'ro','&gt; 90 de zile',0),(533208,14812,'et','&gt; 90 pÃ¤eva',0),(533209,14812,'si','&gt; 90 dni',0),(533210,14812,'ba','&gt; 90 hari',0),(533211,14812,'nl','&gt; 90 dagen',0),(533212,14812,'fi','&gt; 90 pÃ¤ivÃ¤Ã¤',0),(533213,14812,'no','&gt; 90 dager',0),(533214,14812,'da','&gt; 90 dage',0),(533215,14812,'ko','&gt; 90 ì¼',0),(533216,14812,'he','&gt; 90 ×™×•×',0),(533217,14812,'el','&gt; 90 Î·Î¼Î­ÏÎµÏ‚',0),(533218,14812,'zh','&gt; 90 å¤©',0),(533219,14812,'sv','&gt; 90 dagar',0),(533220,14812,'it','&gt; 90 giorni',0),(533221,14812,'tl','',0),(533222,14812,'th','&Gt; 90 à¸§à¸±à¸™',0),(533223,14812,'hi','&gt; 90 à¤¦à¤¿à¤¨',0),(533224,14812,'ms','&gt; 90 hari',0),(533225,14812,'ar','&gt; 90 ÙŠÙˆÙ…Ø§',0),(533226,14812,'fr','&gt; 90 jours',0),(533227,14812,'jp','&gt; 90 æ—¥',0),(533228,14812,'pt','&gt; 90 dias',0),(533229,14812,'ru','&gt; 90 Ð´Ð½ÐµÐ¹',0),(533230,14812,'es','&gt; 90 dÃ­as',0),(533231,14812,'de','&gt; 90 Tage',0),(533232,14812,'en','&gt; 90 Days',0),(533233,14813,'is','',0),(533234,14813,'dr','&gt; 60 Ø±ÙˆØ²',0),(533235,14813,'pr','&gt; 60 Ø±ÙˆØ²',0),(533236,14813,'tr','&gt; 60 gÃ¼n',0),(533237,14813,'pl','&gt; 60 dni',0),(533238,14813,'bg','&gt; 60 Ð´Ð½Ð¸',0),(533239,14813,'ur','&gt; 60 Ø¯Ù†',0),(533240,14813,'sr','&Ð³Ñ‚; 60 Ð´Ð°Ð½Ð°',0),(533241,14813,'vi','&gt; 60 ngÃ y',0),(533242,14813,'af','&gt; 60 dae',0),(533243,14813,'ro','&gt; 60 de zile',0),(533244,14813,'et','&gt; 60 pÃ¤eva',0),(533245,14813,'si','&gt; 60 dni',0),(533246,14813,'ba','&gt; 60 hari',0),(533247,14813,'nl','&gt; 60 dagen',0),(533248,14813,'fi','&gt; 60 pÃ¤ivÃ¤n',0),(533249,14813,'no','&gt; 60 dager',0),(533250,14813,'da','&gt; 60 dage',0),(533251,14813,'ko','&gt; 60 ì¼',0),(533252,14813,'he','&gt; 60 ×™×ž×™×',0),(533253,14813,'el','&gt; 60 Î·Î¼Î­ÏÎµÏ‚',0),(533254,14813,'zh','&gt; 60 å¤©',0),(533255,14813,'sv','&gt; 60 dagar',0),(533256,14813,'it','&gt; 60 giorni',0),(533257,14813,'tl','',0),(533258,14813,'th','&Gt; 60 à¸§à¸±à¸™',0),(533259,14813,'hi','&gt; 60 à¤¦à¤¿à¤¨à¥‹à¤‚',0),(533260,14813,'ms','&gt; 60 hari',0),(533261,14813,'ar','&gt; 60 ÙŠÙˆÙ…Ø§',0),(533262,14813,'fr','&gt; 60 jours',0),(533263,14813,'jp','&gt; 60 æ—¥',0),(533264,14813,'pt','&gt; 60 dias',0),(533265,14813,'ru','&gt; 60 Ð´Ð½ÐµÐ¹',0),(533266,14813,'es','&gt; 60 dÃ­as',0),(533267,14813,'de','&gt; 60 Tage',0),(533268,14813,'en','&gt; 60 Days',0),(533269,14814,'is','',0),(533270,14814,'dr','Ø´Ø±Ø§ÛŒØ·',0),(533271,14814,'pr','Ø´Ø±Ø§ÛŒØ·',0),(533272,14814,'tr','KoÅŸullar',0),(533273,14814,'pl','Warunki',0),(533274,14814,'bg','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ',0),(533275,14814,'ur','Ø´Ø±Ø§Ø¦Ø·',0),(533276,14814,'sr','Ð£ÑÐ»Ð¾Ð²Ð¸',0),(533277,14814,'vi','Äiá»u kiá»‡n',0),(533278,14814,'af','Voorwaardes',0),(533279,14814,'ro','CondiÅ£iile',0),(533280,14814,'et','Tingimused',0),(533281,14814,'si','Pogoji',0),(533282,14814,'ba','Kondisi',0),(533283,14814,'nl','Voorwaarden',0),(533284,14814,'fi','Edellytykset',0),(533285,14814,'no','Betingelser',0),(533286,14814,'da','Betingelser',0),(533287,14814,'ko','ì¡°ê±´',0),(533288,14814,'he','×ª× ××™×',0),(533289,14814,'el','Î£Ï…Î½Î¸Î®ÎºÎµÏ‚',0),(533290,14814,'zh','æ¡ä»¶',0),(533291,14814,'sv','Villkor',0),(533292,14814,'it','Condizioni',0),(533293,14814,'tl','',0),(533294,14814,'th','à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚',0),(533295,14814,'hi','à¤¶à¤°à¥à¤¤à¥‡à¤‚',0),(533296,14814,'ms','Syarat-syarat',0),(533297,14814,'ar','Ø§Ù„Ø´Ø±ÙˆØ·',0),(533298,14814,'fr','Conditions',0),(533299,14814,'jp','æ¡ä»¶',0),(533300,14814,'pt','CondiÃ§Ãµes',0),(533301,14814,'ru','Ð£ÑÐ»Ð¾Ð²Ð¸Ñ',0),(533302,14814,'es','Condiciones',0),(533303,14814,'de','Bedingungen',0),(533304,14814,'en','Conditions',0),(533305,14815,'is','',0),(533306,14815,'dr','ØªØ§Ø±ÛŒØ® Ø¹Ù…ÙˆÙ…ÛŒ',0),(533307,14815,'pr','ØªØ§Ø±ÛŒØ® Ø¹Ù…ÙˆÙ…ÛŒ',0),(533308,14815,'tr','Tarihi genel',0),(533309,14815,'pl','Data General',0),(533310,14815,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð»',0),(533311,14815,'ur','ØªØ§Ø±ÛŒØ® Ø¬Ù†Ø±Ù„',0),(533312,14815,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð´Ð°Ñ‚ÑƒÐ¼',0),(533313,14815,'vi','NgÃ y tá»•ng',0),(533314,14815,'af','Datum algemene',0),(533315,14815,'ro','Data General',0),(533316,14815,'et','KuupÃ¤eva kindral',0),(533317,14815,'si','Datum generalni',0),(533318,14815,'ba','Tanggal Umum',0),(533319,14815,'nl','Datum generaal',0),(533320,14815,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ yleinen',0),(533321,14815,'no','Dato generelt',0),(533322,14815,'da','Dato General',0),(533323,14815,'ko','ë‚ ì§œ ì¼ë°˜',0),(533324,14815,'he','×ª××¨×™×š ×›×œ×œ×™',0),(533325,14815,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î³ÎµÎ½Î¹ÎºÎ®Ï‚',0),(533326,14815,'zh','æ—¥æœŸä¸€èˆ¬',0),(533327,14815,'sv','Datum allmÃ¤nna',0),(533328,14815,'it','Data General',0),(533329,14815,'tl','',0),(533330,14815,'th','à¸§à¸±à¸™à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(533331,14815,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤œà¤¨à¤°à¤²',0),(533332,14815,'ms','Tarikh umum',0),(533333,14815,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¹Ø§Ù…',0),(533334,14815,'fr','Date gÃ©nÃ©rale',0),(533335,14815,'jp','ä¸€èˆ¬çš„ãªæ—¥ä»˜',0),(533336,14815,'pt','Data geral',0),(533337,14815,'ru','Ð”Ð°Ñ‚Ð° Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹',0),(533338,14815,'es','Fecha General',0),(533339,14815,'de','Datum allgemein',0),(533340,14815,'en','Date General',0),(533341,14816,'is','',0),(533342,14816,'dr','ØªØ§Ø±ÛŒØ® ISO',0),(533343,14816,'pr','ØªØ§Ø±ÛŒØ® ISO',0),(533344,14816,'tr','Tarihi ISO',0),(533345,14816,'pl','Data ISO',0),(533346,14816,'bg','Ð”Ð°Ñ‚Ð° ISO',0),(533347,14816,'ur','Ø¢Ø¦ÛŒ Ø§ÛŒØ³ Ø§Ùˆ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(533348,14816,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð˜Ð¡Ðž',0),(533349,14816,'vi','NgÃ y ISO',0),(533350,14816,'af','Datum ISO',0),(533351,14816,'ro','Data ISO',0),(533352,14816,'et','KuupÃ¤eva ISO',0),(533353,14816,'si','Datum ISO',0),(533354,14816,'ba','Tanggal ISO',0),(533355,14816,'nl','Datum ISO',0),(533356,14816,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ ISO',0),(533357,14816,'no','Dato ISO',0),(533358,14816,'da','Dato ISO',0),(533359,14816,'ko','ë‚ ì§œ ISO',0),(533360,14816,'he','×ª××¨×™×š ISO',0),(533361,14816,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ISO',0),(533362,14816,'zh','ISO æ—¥æœŸ',0),(533363,14816,'sv','Datum ISO',0),(533364,14816,'it','Data ISO',0),(533365,14816,'tl','',0),(533366,14816,'th','à¸§à¸±à¸™ ISO',0),(533367,14816,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤†à¤ˆà¤à¤¸à¤“',0),(533368,14816,'ms','Tarikh ISO',0),(533369,14816,'ar','ØªØ§Ø±ÙŠØ® ISO',0),(533370,14816,'fr','Date ISO',0),(533371,14816,'jp','ISO ã®æ—¥ä»˜',0),(533372,14816,'pt','Data ISO',0),(533373,14816,'ru','Ð”Ð°Ñ‚Ð° ISO',0),(533374,14816,'es','Fecha ISO',0),(533375,14816,'de','Datum ISO',0),(533376,14816,'en','Date ISO',0),(533377,14817,'is','',0),(533378,14817,'dr','ØªØ§Ø±ÛŒØ® Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡',0),(533379,14817,'pr','ØªØ§Ø±ÛŒØ® Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡',0),(533380,14817,'tr','Tarihi u.s.',0),(533381,14817,'pl','Data U.S.',0),(533382,14817,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¡ÐÐ©',0),(533383,14817,'ur','Ø§Ù…Ø±ÛŒÚ©Û Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(533384,14817,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð£.Ð¡.',0),(533385,14817,'vi','NgÃ y U.S.',0),(533386,14817,'af','Datum U.S',0),(533387,14817,'ro','Data U.S.',0),(533388,14817,'et','KuupÃ¤eva U.S.',0),(533389,14817,'si','Datum ZDA',0),(533390,14817,'ba','Tanggal U.S.',0),(533391,14817,'nl','Datum U.S.',0),(533392,14817,'fi','MennessÃ¤ US',0),(533393,14817,'no','Dato U.S.',0),(533394,14817,'da','Dato U.S.',0),(533395,14817,'ko','ë‚ ì§œ ë¯¸êµ­',0),(533396,14817,'he','×ª××¨×™×š ×‘××¨×” ×‘',0),(533397,14817,'el','Î—Î Î‘ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(533398,14817,'zh','ç¾Žå›½æ—¥æœŸ',0),(533399,14817,'sv','Datum U.S.',0),(533400,14817,'it','Data U.S.',0),(533401,14817,'tl','',0),(533402,14817,'th','à¸§à¸±à¸™à¸ªà¸«à¸£à¸±à¸à¸­à¹€à¸¡à¸£à¸´à¸à¸²',0),(533403,14817,'hi','à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(533404,14817,'ms','Tarikh U.S.',0),(533405,14817,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙˆÙ„Ø§ÙŠØ§Øª Ø§Ù„Ù…ØªØ­Ø¯Ø©',0),(533406,14817,'fr','Date U.S.',0),(533407,14817,'jp','ç±³å›½ã®æ—¥ä»˜',0),(533408,14817,'pt','Data U.S.',0),(533409,14817,'ru','Ð”Ð°Ñ‚Ð° Ð¡Ð¨Ð',0),(533410,14817,'es','Fecha de U.S.',0),(533411,14817,'de','Datum U.S.',0),(533412,14817,'en','Date US',0),(533413,14818,'is','',0),(533414,14818,'dr','Ø¨Ø±Ø§Ø¨Ø± Ø§Ø³Øª Ø¨Ø§',0),(533415,14818,'pr','Ø¨Ø±Ø§Ø¨Ø± Ø§Ø³Øª Ø¨Ø§',0),(533416,14818,'tr','EÅŸittir',0),(533417,14818,'pl','Jest rÃ³wna',0),(533418,14818,'bg','Ð• Ñ€Ð°Ð²Ð½Ð¾',0),(533419,14818,'ur','Ù…Ø³Ø§ÙˆÛŒ',0),(533420,14818,'sr','ÐˆÐµÐ´Ð½Ð°ÐºÐ¾ Ñ˜Ðµ',0),(533421,14818,'vi','Báº±ng',0),(533422,14818,'af','Is gelyk aan',0),(533423,14818,'ro','Este egal cu',0),(533424,14818,'et','VÃµrdub',0),(533425,14818,'si','Je enako',0),(533426,14818,'ba','Sama dengan',0),(533427,14818,'nl','Is gelijk aan',0),(533428,14818,'fi','Vastaa',0),(533429,14818,'no','Er lik',0),(533430,14818,'da','Er lig med',0),(533431,14818,'ko','ê°™ìŒ',0),(533432,14818,'he','×©×•×•×” ×œ-',0),(533433,14818,'el','Î™ÏƒÎ¿ÏÏ„Î±Î¹ Î¼Îµ',0),(533434,14818,'zh','ç­‰äºŽ',0),(533435,14818,'sv','Ã„r lika med',0),(533436,14818,'it','Ãˆ uguale a',0),(533437,14818,'tl','',0),(533438,14818,'th','à¹€à¸—à¹ˆà¸²à¸à¸±à¸š',0),(533439,14818,'hi','à¤•à¥‡ à¤¬à¤°à¤¾à¤¬à¤° à¤¹à¥‹à¤¤à¥€ à¤¹à¥ˆ',0),(533440,14818,'ms','Adalah sama dengan',0),(533441,14818,'ar','ÙŠØ³Ø§ÙˆÙŠ',0),(533442,14818,'fr','Est Ã©gal Ã ',0),(533443,14818,'jp','ç­‰ã—ã„',0),(533444,14818,'pt','Ã‰ igual a',0),(533445,14818,'ru','Ð Ð°Ð²Ð½ÑÐµÑ‚ÑÑ',0),(533446,14818,'es','Es igual a',0),(533447,14818,'de','Entspricht',0),(533448,14818,'en','Equals',0),(533449,14819,'is','',0),(533450,14819,'dr','Ø¹Ø¶ÙˆÛŒØª',0),(533451,14819,'pr','Ø¹Ø¶ÙˆÛŒØª',0),(533452,14819,'tr','KatÄ±lÄ±n',0),(533453,14819,'pl','DoÅ‚Ä…cz do',0),(533454,14819,'bg','ÐŸÑ€Ð¸ÑÑŠÐµÐ´Ð¸Ð½ÐµÑ‚Ðµ ÑÐµ ÐºÑŠÐ¼',0),(533455,14819,'ur','Ù…Ù„Ø§Ù¾ Ú©Ø±ÛŒÚº',0),(533456,14819,'sr','Ð¡Ð¿Ð¾Ñ˜',0),(533457,14819,'vi','Tham gia',0),(533458,14819,'af','Sluit aan by',0),(533459,14819,'ro','AlÄƒturaÅ£i-vÄƒ',0),(533460,14819,'et','Liitu',0),(533461,14819,'si','PridruÅ¾ite se',0),(533462,14819,'ba','Bergabung',0),(533463,14819,'nl','Join',0),(533464,14819,'fi','Liity',0),(533465,14819,'no','Bli med',0),(533466,14819,'da','Deltag',0),(533467,14819,'ko','ê°€ìž…',0),(533468,14819,'he','×”×¦×˜×¨×¤×•×ª',0),(533469,14819,'el','Î“Î¯Î½ÎµÏ„Îµ Î¼Î­Î»Î¿Ï‚',0),(533470,14819,'zh','åŠ å…¥',0),(533471,14819,'sv','GÃ¥ med',0),(533472,14819,'it','Iscriviti',0),(533473,14819,'tl','',0),(533474,14819,'th','à¹€à¸‚à¹‰à¸²à¸£à¹ˆà¸§à¸¡',0),(533475,14819,'hi','à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥‹à¤‚',0),(533476,14819,'ms','Menyertai',0),(533477,14819,'ar','Ø§Ù„Ø§Ù†Ø¶Ù…Ø§Ù… Ø¥Ù„Ù‰',0),(533478,14819,'fr','Rejoignez',0),(533479,14819,'jp','çµåˆ',0),(533480,14819,'pt','Junte-se',0),(533481,14819,'ru','ÐŸÑ€Ð¸ÑÐ¾ÐµÐ´Ð¸Ð½Ð¸Ñ‚ÑŒÑÑ Ðº',0),(533482,14819,'es','Ãšnete',0),(533483,14819,'de','Join',0),(533484,14819,'en','Join',0),(533485,14820,'is','',0),(533486,14820,'dr','Ù…Ø§Ù†Ù†Ø¯',0),(533487,14820,'pr','Ù…Ø§Ù†Ù†Ø¯',0),(533488,14820,'tr','Gibi',0),(533489,14820,'pl','Jak',0),(533490,14820,'bg','ÐšÐ°Ñ‚Ð¾',0),(533491,14820,'ur','Ú©ÛŒ Ø·Ø±Ø­',0),(533492,14820,'sr','ÐšÐ°Ð¾',0),(533493,14820,'vi','Giá»‘ng nhÆ°',0),(533494,14820,'af','Soos',0),(533495,14820,'ro','Ca',0),(533496,14820,'et','Nagu',0),(533497,14820,'si','Kot',0),(533498,14820,'ba','Seperti',0),(533499,14820,'nl','Zoals',0),(533500,14820,'fi','Kuten',0),(533501,14820,'no','Som',0),(533502,14820,'da','Ligesom',0),(533503,14820,'ko','ê°™ì€',0),(533504,14820,'he','×›×ž×•',0),(533505,14820,'el','ÎŒÏ€Ï‰Ï‚',0),(533506,14820,'zh','åƒ',0),(533507,14820,'sv','Som',0),(533508,14820,'it','Come',0),(533509,14820,'tl','',0),(533510,14820,'th','à¹€à¸Šà¹ˆà¸™',0),(533511,14820,'hi','à¤•à¥€ à¤¤à¤°à¤¹',0),(533512,14820,'ms','Seperti',0),(533513,14820,'ar','Ù…Ø«Ù„',0),(533514,14820,'fr','Comme',0),(533515,14820,'jp','ã‚ˆã†ãª',0),(533516,14820,'pt','Como',0),(533517,14820,'ru','ÐšÐ°Ðº',0),(533518,14820,'es','Como',0),(533519,14820,'de','Wie',0),(533520,14820,'en','Like',0),(533521,14821,'is','',0),(533522,14821,'dr','Ù…Ø³Ø§ÙˆÛŒ Ù†ÛŒØ³Øª',0),(533523,14821,'pr','Ù…Ø³Ø§ÙˆÛŒ Ù†ÛŒØ³Øª',0),(533524,14821,'tr','EÅŸit deÄŸil',0),(533525,14821,'pl','Nie rÃ³wne',0),(533526,14821,'bg','ÐÐµ Ðµ Ñ€Ð°Ð²Ð½Ð¾',0),(533527,14821,'ur','Ù…Ø³Ø§ÙˆÛŒ Ù†ÛÛŒÚº',0),(533528,14821,'sr','ÐÐ¸Ñ˜Ðµ Ñ˜ÐµÐ´Ð½Ð°ÐºÐ¾',0),(533529,14821,'vi','KhÃ´ng báº±ng',0),(533530,14821,'af','Is nie gelyk aan',0),(533531,14821,'ro','Nu este egal',0),(533532,14821,'et','Ei vÃµrdu',0),(533533,14821,'si','Ni enako',0),(533534,14821,'ba','Tidak sama',0),(533535,14821,'nl','Niet gelijk',0),(533536,14821,'fi','Eri suuri',0),(533537,14821,'no','Ikke lik',0),(533538,14821,'da','Ikke lige',0),(533539,14821,'ko','ê°™ì§€ ì•ŠìŒ',0),(533540,14821,'he','×œ× ×©×•×•×”',0),(533541,14821,'el','Î”Î¹Î¬Ï†Î¿ÏÎ¿',0),(533542,14821,'zh','ä¸ç­‰äºŽ',0),(533543,14821,'sv','Inte lika',0),(533544,14821,'it','Non uguale',0),(533545,14821,'tl','',0),(533546,14821,'th','à¹„à¸¡à¹ˆà¹€à¸—à¹ˆà¸²à¸à¸±à¸™',0),(533547,14821,'hi','à¤¬à¤°à¤¾à¤¬à¤° à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(533548,14821,'ms','Tidak sama dengan',0),(533549,14821,'ar','Ù„Ø§ ØªØ³Ø§ÙˆÙŠ',0),(533550,14821,'fr','Pas Ã©gal Ã ',0),(533551,14821,'jp','ç­‰ã—ããªã„ã§ã™ã€‚',0),(533552,14821,'pt','NÃ£o igual',0),(533553,14821,'ru','ÐÐµ Ñ€Ð°Ð²Ð½Ð¾',0),(533554,14821,'es','No es igual',0),(533555,14821,'de','Nicht gleich',0),(533556,14821,'en','Not Equal',0),(533557,14822,'is','',0),(533558,14822,'dr','Ù†Ù‡ Ù…Ø«Ù„',0),(533559,14822,'pr','Ù†Ù‡ Ù…Ø«Ù„',0),(533560,14822,'tr','Gibi deÄŸil',0),(533561,14822,'pl','Nie lubiÄ™',0),(533562,14822,'bg','ÐÐµ Ð¼Ð¸ Ñ…Ð°Ñ€ÐµÑÐ²Ð°',0),(533563,14822,'ur','Ù¾Ø³Ù†Ø¯ Ù†ÛÛŒÚº',0),(533564,14822,'sr','ÐÐ¸Ñ˜Ðµ ÐºÐ°Ð¾',0),(533565,14822,'vi','KhÃ´ng giá»‘ng nhÆ°',0),(533566,14822,'af','Nie soos',0),(533567,14822,'ro','Nu ca',0),(533568,14822,'et','Ei meeldi',0),(533569,14822,'si','Ne kot',0),(533570,14822,'ba','Tidak seperti',0),(533571,14822,'nl','Niet zoals',0),(533572,14822,'fi','PidÃ¤',0),(533573,14822,'no','Ikke Like',0),(533574,14822,'da','Ikke lide',0),(533575,14822,'ko','ì•ˆ ì¢‹ì•„',0),(533576,14822,'he','. ×œ× ×›×ž×•',0),(533577,14822,'el','Î”ÎµÎ½ Î±ÏÎ­ÏƒÎµÎ¹',0),(533578,14822,'zh','ä¸å–œæ¬¢',0),(533579,14822,'sv','Inte som',0),(533580,14822,'it','Non piace',0),(533581,14822,'tl','',0),(533582,14822,'th','à¹„à¸¡à¹ˆà¸Šà¸­à¸š',0),(533583,14822,'hi','à¤ªà¤¸à¤‚à¤¦ à¤¨à¤¹à¥€à¤‚',0),(533584,14822,'ms','Tidak suka',0),(533585,14822,'ar','Ù„ÙŠØ³ Ù…Ø«Ù„',0),(533586,14822,'fr','Aime pas',0),(533587,14822,'jp','å¥½ãã§ã¯ãªã„ã§ã™ã€‚',0),(533588,14822,'pt','NÃ£o gosto',0),(533589,14822,'ru','ÐÐµ Ð½Ñ€Ð°Ð²Ð¸Ñ‚ÑÑ',0),(533590,14822,'es','No me gusta',0),(533591,14822,'de','Nicht wie',0),(533592,14822,'en','Not Like',0),(533593,14823,'is','',0),(533594,14823,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ',0),(533595,14823,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ',0),(533596,14823,'tr','Sorgu hatasÄ±',0),(533597,14823,'pl','BÅ‚Ä…d kwerendy',0),(533598,14823,'bg','Ð—Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð³Ñ€ÐµÑˆÐºÐ°',0),(533599,14823,'ur','Ø·Ù„Ø¨ Ù†Ù‚Øµ',0),(533600,14823,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ñƒ ÑƒÐ¿Ð¸Ñ‚',0),(533601,14823,'vi','Truy váº¥n lá»—i',0),(533602,14823,'af','Navraag fout',0),(533603,14823,'ro','Eroare de interogare',0),(533604,14823,'et','PÃ¤ringule viga',0),(533605,14823,'si','Napaka poizvedb',0),(533606,14823,'ba','Permintaan kesalahan',0),(533607,14823,'nl','Fout in de query',0),(533608,14823,'fi','Kyselyn virhe',0),(533609,14823,'no','SpÃ¸rsmÃ¥l feil',0),(533610,14823,'da','ForespÃ¸rgsel fejl',0),(533611,14823,'ko','ì¿¼ë¦¬ ì˜¤ë¥˜',0),(533612,14823,'he','×©×’×™××” ×‘×©××™×œ×ª×”',0),(533613,14823,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÏÏ‰Ï„Î®Î¼Î±Ï„Î¿Ï‚',0),(533614,14823,'zh','æŸ¥è¯¢é”™è¯¯',0),(533615,14823,'sv','FrÃ¥ga fel',0),(533616,14823,'it','Errore query',0),(533617,14823,'tl','',0),(533618,14823,'th','à¸ªà¸­à¸šà¸–à¸²à¸¡à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(533619,14823,'hi','à¤•à¥à¤µà¥‡à¤°à¥€ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(533620,14823,'ms','Ralat pertanyaan',0),(533621,14823,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ù„Ø§Ø³ØªØ¹Ù„Ø§Ù…',0),(533622,14823,'fr','Erreur de requÃªte',0),(533623,14823,'jp','ã‚¯ã‚¨ãƒª ã‚¨ãƒ©ãƒ¼',0),(533624,14823,'pt','Erro de consulta',0),(533625,14823,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(533626,14823,'es','Query Error',0),(533627,14823,'de','Abfragefehler',0),(533628,14823,'en','Query Error',0),(533629,14824,'is','',0),(533630,14824,'dr','Ø§Ø¬Ø±Ø§',0),(533631,14824,'pr','Ø§Ø¬Ø±Ø§',0),(533632,14824,'tr','Ã‡alÄ±ÅŸtÄ±r',0),(533633,14824,'pl','Uruchom',0),(533634,14824,'bg','Ð¢Ð¸Ñ‡Ð°Ð¼',0),(533635,14824,'ur','Ú†Ù„Øª Ú©Ø±ÛŒÚº',0),(533636,14824,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½Ð¸',0),(533637,14824,'vi','Cháº¡y',0),(533638,14824,'af','Loop',0),(533639,14824,'ro','A alerga',0),(533640,14824,'et','KÃ¤ivita',0),(533641,14824,'si','TeÄi',0),(533642,14824,'ba','Menjalankan',0),(533643,14824,'nl','Run',0),(533644,14824,'fi','Suorita',0),(533645,14824,'no','KjÃ¸re',0),(533646,14824,'da','KÃ¸re',0),(533647,14824,'ko','ì‹¤í–‰',0),(533648,14824,'he','×œ×¨×•×¥',0),(533649,14824,'el','Î¤ÏÎ­Î¾Î¹Î¼Î¿',0),(533650,14824,'zh','è¿è¡Œ',0),(533651,14824,'sv','KÃ¶r',0),(533652,14824,'it','Eseguire',0),(533653,14824,'tl','',0),(533654,14824,'th','à¸£à¸±à¸™',0),(533655,14824,'hi','à¤šà¤²à¤¾à¤à¤',0),(533656,14824,'ms','Dikendalikan oleh',0),(533657,14824,'ar','ØªØ´ØºÙŠÙ„',0),(533658,14824,'fr','ExÃ©cutez',0),(533659,14824,'jp','å®Ÿè¡Œ',0),(533660,14824,'pt','Executar',0),(533661,14824,'ru','Ð—Ð°Ð¿ÑƒÑÐº',0),(533662,14824,'es','Ejecutar',0),(533663,14824,'de','AusfÃ¼hren',0),(533664,14824,'en','Run',0),(533665,14825,'is','',0),(533666,14825,'dr','SQL',0),(533667,14825,'pr','SQL',0),(533668,14825,'tr','SQL',0),(533669,14825,'pl','SQL',0),(533670,14825,'bg','SQL',0),(533671,14825,'ur','SQL',0),(533672,14825,'sr','Ð¡QÐ›',0),(533673,14825,'vi','SQL',0),(533674,14825,'af','SQL',0),(533675,14825,'ro','SQL',0),(533676,14825,'et','SQL',0),(533677,14825,'si','SQL',0),(533678,14825,'ba','SQL',0),(533679,14825,'nl','SQL',0),(533680,14825,'fi','SQL',0),(533681,14825,'no','SQL',0),(533682,14825,'da','SQL',0),(533683,14825,'ko','SQL',0),(533684,14825,'he','SQL',0),(533685,14825,'el','SQL',0),(533686,14825,'zh','SQL',0),(533687,14825,'sv','SQL',0),(533688,14825,'it','SQL',0),(533689,14825,'tl','',0),(533690,14825,'th','SQL',0),(533691,14825,'hi','SQL',0),(533692,14825,'ms','SQL',0),(533693,14825,'ar','SQL',0),(533694,14825,'fr','SQL',0),(533695,14825,'jp','SQL',0),(533696,14825,'pt','SQL',0),(533697,14825,'ru','SQL',0),(533698,14825,'es','SQL',0),(533699,14825,'de','SQL',0),(533700,14825,'en','SQL',0),(533701,14826,'is','',0),(533702,14826,'dr','SQL Ùˆ',0),(533703,14826,'pr','SQL Ùˆ',0),(533704,14826,'tr','SQL ve',0),(533705,14826,'pl','SQL i',0),(533706,14826,'bg','SQL Ð¸',0),(533707,14826,'ur','SQL Ø§ÙˆØ±',0),(533708,14826,'sr','Ð¡QÐ› Ð¸',0),(533709,14826,'vi','SQL vÃ ',0),(533710,14826,'af','SQL en',0),(533711,14826,'ro','SQL ÅŸi',0),(533712,14826,'et','SQL-i ja',0),(533713,14826,'si','SQL in',0),(533714,14826,'ba','SQL dan',0),(533715,14826,'nl','SQL en',0),(533716,14826,'fi','SQL ja',0),(533717,14826,'no','SQL og',0),(533718,14826,'da','SQL og',0),(533719,14826,'ko','SQL ë°',0),(533720,14826,'he','SQL ×•',0),(533721,14826,'el','SQL ÎºÎ±Î¹',0),(533722,14826,'zh','SQL å’Œ',0),(533723,14826,'sv','SQL och',0),(533724,14826,'it','SQL e',0),(533725,14826,'tl','',0),(533726,14826,'th','SQL à¹à¸¥à¸°',0),(533727,14826,'hi','à¤à¤¸à¤•à¥à¤¯à¥‚à¤à¤² à¤”à¤°',0),(533728,14826,'ms','SQL dan',0),(533729,14826,'ar','SQL Ùˆ',0),(533730,14826,'fr','SQL et',0),(533731,14826,'jp','SQL ã¨',0),(533732,14826,'pt','SQL e',0),(533733,14826,'ru','SQL Ð¸',0),(533734,14826,'es','SQL y',0),(533735,14826,'de','SQL und',0),(533736,14826,'en','SQL And',0),(533737,14827,'is','',0),(533738,14827,'dr','SQL Ùˆ ÛŒØ§',0),(533739,14827,'pr','SQL Ùˆ ÛŒØ§',0),(533740,14827,'tr','SQL veya',0),(533741,14827,'pl','SQL lub',0),(533742,14827,'bg','SQL Ð¸Ð»Ð¸',0),(533743,14827,'ur','SQL ÛŒØ§',0),(533744,14827,'sr','Ð¡QÐ› Ð¸Ð»Ð¸',0),(533745,14827,'vi','SQL hoáº·c',0),(533746,14827,'af','SQL of',0),(533747,14827,'ro','SQL sau',0),(533748,14827,'et','SQL-i vÃµi',0),(533749,14827,'si','SQL ali',0),(533750,14827,'ba','SQL atau',0),(533751,14827,'nl','SQL of',0),(533752,14827,'fi','SQL tai',0),(533753,14827,'no','SQL eller',0),(533754,14827,'da','SQL eller',0),(533755,14827,'ko','SQL ë˜ëŠ”',0),(533756,14827,'he','SQL ××•',0),(533757,14827,'el','SQL Î®',0),(533758,14827,'zh','SQL æˆ–',0),(533759,14827,'sv','SQL eller',0),(533760,14827,'it','SQL o',0),(533761,14827,'tl','',0),(533762,14827,'th','SQL à¸«à¸£à¸·à¸­',0),(533763,14827,'hi','SQL à¤¯à¤¾',0),(533764,14827,'ms','SQL atau',0),(533765,14827,'ar','SQL Ø£Ùˆ',0),(533766,14827,'fr','SQL ou',0),(533767,14827,'jp','SQL ã¾ãŸã¯',0),(533768,14827,'pt','SQL ou',0),(533769,14827,'ru','SQL Ð¸Ð»Ð¸',0),(533770,14827,'es','SQL o',0),(533771,14827,'de','SQL oder',0),(533772,14827,'en','SQL Or',0),(533773,14828,'is','',0),(533774,14828,'dr','SQL Xor',0),(533775,14828,'pr','SQL Xor',0),(533776,14828,'tr','SQL Xor',0),(533777,14828,'pl','SQL Xor',0),(533778,14828,'bg','SQL Xor',0),(533779,14828,'ur','SQL Xor',0),(533780,14828,'sr','Ð¡QÐ› XÐ¾Ñ€',0),(533781,14828,'vi','SQL Xor',0),(533782,14828,'af','SQL Xor',0),(533783,14828,'ro','SQL Xor',0),(533784,14828,'et','SQL Xor',0),(533785,14828,'si','SQL Xor',0),(533786,14828,'ba','SQL Xor',0),(533787,14828,'nl','SQL Xor',0),(533788,14828,'fi','SQL Xor',0),(533789,14828,'no','SQL Xor',0),(533790,14828,'da','SQL Xor',0),(533791,14828,'ko','SQL Xor',0),(533792,14828,'he','SQL Xor',0),(533793,14828,'el','SQL Xor',0),(533794,14828,'zh','SQL Xor',0),(533795,14828,'sv','SQL Xor',0),(533796,14828,'it','SQL Xor',0),(533797,14828,'tl','',0),(533798,14828,'th','SQL Xor',0),(533799,14828,'hi','SQL Xor',0),(533800,14828,'ms','SQL Xor',0),(533801,14828,'ar','SQL Xor',0),(533802,14828,'fr','SQL Xor',0),(533803,14828,'jp','SQL Xor',0),(533804,14828,'pt','SQL Xor',0),(533805,14828,'ru','SQL Xor',0),(533806,14828,'es','SQL Xor',0),(533807,14828,'de','SQL Xor',0),(533808,14828,'en','SQL Xor',0),(533809,14829,'is','',0),(533810,14829,'dr','Ù‡Ø´Ø¯Ø§Ø± Ø®Ø±ÙˆØ¬ Ø¨Ø¯ÙˆÙ† Ø°Ø®ÛŒØ±Ù‡',0),(533811,14829,'pr','Ù‡Ø´Ø¯Ø§Ø± Ø®Ø±ÙˆØ¬ Ø¨Ø¯ÙˆÙ† Ø°Ø®ÛŒØ±Ù‡',0),(533812,14829,'tr','HayÄ±r kaydetme Ã§Ä±kÄ±ÅŸ uyarmak',0),(533813,14829,'pl','Ostrzec wyjÅ›cia nie zapisaÄ‡',0),(533814,14829,'bg','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´Ð°Ð²Ð°Ñ‚ Ð¸Ð·Ñ…Ð¾Ð´ Ð½Ðµ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(533815,14829,'ur','Ø®Ø±ÙˆØ¬ Ú©Û’ Ø³ÙˆØ§ Ú©ÙˆØ¦ÛŒ Ø®Ø¨Ø±Ø¯Ø§Ø± Ú©ÛŒØ§ ÛÛ’ Û”',0),(533816,14829,'sr','Ð£Ð¿Ð¾Ð·Ð¾Ñ€Ð¸ Ð¸Ð·Ð»Ð°Ð· Ð½Ðµ ÑÐ¿Ð°ÑÐ¸',0),(533817,14829,'vi','Cáº£nh bÃ¡o cÃ¡c lá»‘i ra khÃ´ng lÆ°u',0),(533818,14829,'af','Waarsku verlaat nie red',0),(533819,14829,'ro','Avertiza ieÅŸire nu salva',0),(533820,14829,'et','Hoiatan vÃ¤lju ei pÃ¤Ã¤sta',0),(533821,14829,'si','Opozori izstop ne shrani',0),(533822,14829,'ba','Memperingatkan keluar tidak menyimpan',0),(533823,14829,'nl','Waarschuwen Exit niet opslaan',0),(533824,14829,'fi','Varoittaa liittymÃ¤stÃ¤ ei tallenna',0),(533825,14829,'no','Advare Exit ikke lagre',0),(533826,14829,'da','Advare Exit ikke gemme',0),(533827,14829,'ko','ì•„ë‹ˆ ì €ìž¥ ì¢…ë£Œ ê²½ìœ¼ì‹­ì‹œì˜¤',0),(533828,14829,'he','×œ×”×–×”×™×¨ ××ª ×”×™×¦×™××” ×œ× ×©×ž×•×¨',0),(533829,14829,'el','Î ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¹Î¿ÏÎ½ Î­Î¾Î¿Î´Î¿ Î´ÎµÎ½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·',0),(533830,14829,'zh','è­¦å‘Šä¸ä¿å­˜é€€å‡º',0),(533831,14829,'sv','Varna Exit inte spara',0),(533832,14829,'it','Avvertire uscita senza salvare',0),(533833,14829,'tl','',0),(533834,14829,'th','à¹€à¸•à¸·à¸­à¸™à¸­à¸­à¸à¹„à¸¡à¹ˆà¸šà¸±à¸™à¸—à¸¶à¸',0),(533835,14829,'hi','à¤†à¤—à¤¾à¤¹ à¤¨à¤¹à¥€à¤‚ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚ à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤¨à¤¿à¤•à¤²à¥‡à¤‚',0),(533836,14829,'ms','Memberi amaran kepada keluar tidak Simpan',0),(533837,14829,'ar','ØªØ­Ø°ÙŠØ± Ø§Ù„Ø®Ø±ÙˆØ¬ Ù„Ø§ Ø§Ø­ÙØ¸',0),(533838,14829,'fr','Avertir la sortie sans mÃ©morisation',0),(533839,14829,'jp','ä¿å­˜çµ‚äº†æ™‚ã«è­¦å‘Šã—ã¾ã™ã€‚',0),(533840,14829,'pt','Aviso de saÃ­da nÃ£o salvar',0),(533841,14829,'ru','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ´Ð¸Ñ‚ÑŒ Ð²Ñ‹Ñ…Ð¾Ð´ Ð½Ðµ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ',0),(533842,14829,'es','Advierten salida No guardar',0),(533843,14829,'de','Warn Exit nicht speichern',0),(533844,14829,'en','Warn Exit No Save',0),(533845,14830,'is','',0),(533846,14830,'dr','Ú©Ø§Ø±ØªØ®ÙˆØ§Ù† Ù‡Ù…Ø±Ø§Ù‡',0),(533847,14830,'pr','Ú©Ø§Ø±ØªØ®ÙˆØ§Ù† Ù‡Ù…Ø±Ø§Ù‡',0),(533848,14830,'tr','Mobil POS',0),(533849,14830,'pl','Mobilne POS',0),(533850,14830,'bg','ÐœÐ¾Ð±Ð¸Ð»Ð½Ð¸ ÐŸÐžÐ¡',0),(533851,14830,'ur','Ù…ÙˆØ¨Ø§Ø¦Ù„ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù†',0),(533852,14830,'sr','ÐœÐ¾Ð±Ð¸Ð»Ð½Ð¸ ÐŸÐžÐ¡',0),(533853,14830,'vi','Äiá»‡n thoáº¡i di Ä‘á»™ng POS',0),(533854,14830,'af','Mobiele POS',0),(533855,14830,'ro','POS mobil',0),(533856,14830,'et','Mobiilne POS',0),(533857,14830,'si','Mobilne POS',0),(533858,14830,'ba','Mobile POS',0),(533859,14830,'nl','Mobiele POS',0),(533860,14830,'fi','Mobile POS',0),(533861,14830,'no','Mobile POS',0),(533862,14830,'da','Mobile POS',0),(533863,14830,'ko','ëª¨ë°”ì¼ POS',0),(533864,14830,'he','POS × ×™×™×“×™×',0),(533865,14830,'el','ÎšÎ¹Î½Î·Ï„ÏŒ POS',0),(533866,14830,'zh','ç§»åŠ¨ POS',0),(533867,14830,'sv','Mobile POS',0),(533868,14830,'it','POS mobile',0),(533869,14830,'tl','',0),(533870,14830,'th','POS à¸¡à¸·à¸­à¸–à¸·à¸­',0),(533871,14830,'hi','à¤®à¥‹à¤¬à¤¾à¤‡à¤² POS',0),(533872,14830,'ms','POS mudah alih',0),(533873,14830,'ar','Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ù…ØªÙ†Ù‚Ù„Ø©',0),(533874,14830,'fr','POS mobile',0),(533875,14830,'jp','ãƒ¢ãƒã‚¤ãƒ« POS',0),(533876,14830,'pt','POS mÃ³vel',0),(533877,14830,'ru','ÐœÐ¾Ð±Ð¸Ð»ÑŒÐ½Ñ‹Ðµ POS',0),(533878,14830,'es','POS mÃ³viles',0),(533879,14830,'de','Mobile POS',0),(533880,14830,'en','Mobile POS',0),(533881,14831,'is','',0),(533882,14831,'dr','Ù…Ù†ÙˆÛŒ Ø§ØµÙ„ÛŒ',0),(533883,14831,'pr','Ù…Ù†ÙˆÛŒ Ø§ØµÙ„ÛŒ',0),(533884,14831,'tr','Ana MenÃ¼',0),(533885,14831,'pl','Menu gÅ‚Ã³wne',0),(533886,14831,'bg','Ð“Ð»Ð°Ð²Ð½Ð¾Ñ‚Ð¾ Ð¼ÐµÐ½ÑŽ',0),(533887,14831,'ur','Ù…Ø±Ú©Ø²ÙŠ ÙÛØ±Ø³Øª',0),(533888,14831,'sr','Ð“Ð»Ð°Ð²Ð½Ð¸ Ð¼ÐµÐ½Ð¸',0),(533889,14831,'vi','Menu chÃ­nh',0),(533890,14831,'af','Hoofkieslys',0),(533891,14831,'ro','Meniul principal',0),(533892,14831,'et','PÃµhimenÃ¼Ã¼',0),(533893,14831,'si','Glavni meni',0),(533894,14831,'ba','Menu utama',0),(533895,14831,'nl','Hoofdmenu',0),(533896,14831,'fi','PÃ¤Ã¤valikko',0),(533897,14831,'no','Hovedmenyen',0),(533898,14831,'da','Hovedmenuen',0),(533899,14831,'ko','ë©”ì¸ ë©”ë‰´',0),(533900,14831,'he','×ª×¤×¨×™×˜ ×¨××©×™',0),(533901,14831,'el','ÎšÏÏÎ¹Î¿ Î¼ÎµÎ½Î¿Ï',0),(533902,14831,'zh','ä¸»èœå•',0),(533903,14831,'sv','Huvudmenyn',0),(533904,14831,'it','Menu principale',0),(533905,14831,'tl','',0),(533906,14831,'th','à¹€à¸¡à¸™à¸¹à¸«à¸¥à¸±à¸',0),(533907,14831,'hi','à¤®à¥à¤–à¥à¤¯ à¤®à¥‡à¤¨à¥‚',0),(533908,14831,'ms','Menu Utama',0),(533909,14831,'ar','Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø±Ø¦ÙŠØ³ÙŠØ©',0),(533910,14831,'fr','Menu principal',0),(533911,14831,'jp','ãƒ¡ã‚¤ãƒ³ ãƒ¡ãƒ‹ãƒ¥ãƒ¼',0),(533912,14831,'pt','Menu principal',0),(533913,14831,'ru','Ð“Ð»Ð°Ð²Ð½Ð¾Ðµ Ð¼ÐµÐ½ÑŽ',0),(533914,14831,'es','MenÃº principal',0),(533915,14831,'de','HauptmenÃ¼',0),(533916,14831,'en','Main Menu',0),(533917,14832,'is','',0),(533918,14832,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¢ÛŒØªÙ…',0),(533919,14832,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¢ÛŒØªÙ…',0),(533920,14832,'tr','Ã–ÄŸe Ekle',0),(533921,14832,'pl','Dodaj element',0),(533922,14832,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(533923,14832,'ur','Ø´Û’ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(533924,14832,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(533925,14832,'vi','ThÃªm má»¥c',0),(533926,14832,'af','Voeg Item',0),(533927,14832,'ro','AdÄƒugaÅ£i element',0),(533928,14832,'et','Lisa Ã¼ksus',0),(533929,14832,'si','Dodajte element',0),(533930,14832,'ba','Tambahkan Item',0),(533931,14832,'nl','Item toevoegen',0),(533932,14832,'fi','LisÃ¤Ã¤ kohde',0),(533933,14832,'no','Legge til element',0),(533934,14832,'da','TilfÃ¸j element',0),(533935,14832,'ko','í•­ëª© ì¶”ê°€',0),(533936,14832,'he','×”×•×¡×£ ×¤×¨×™×˜',0),(533937,14832,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(533938,14832,'zh','æ·»åŠ é¡¹',0),(533939,14832,'sv','LÃ¤gga till objekt',0),(533940,14832,'it','Aggiungi elemento',0),(533941,14832,'tl','',0),(533942,14832,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸²à¸¢à¸à¸²à¸£',0),(533943,14832,'hi','à¤†à¤‡à¤Ÿà¤® à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(533944,14832,'ms','Menambah Item',0),(533945,14832,'ar','Ø¥Ø¶Ø§ÙØ© Ø¹Ù†ØµØ±',0),(533946,14832,'fr','Ajouter l\'article',0),(533947,14832,'jp','é …ç›®ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(533948,14832,'pt','Adicionar Item',0),(533949,14832,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(533950,14832,'es','Agregar elemento',0),(533951,14832,'de','Element hinzufÃ¼gen',0),(533952,14832,'en','Add Item',0),(533953,14833,'is','',0),(533954,14833,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙˆØ¶Ø¹ÛŒØª',0),(533955,14833,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙˆØ¶Ø¹ÛŒØª',0),(533956,14833,'tr','KoÅŸul Ekle',0),(533957,14833,'pl','Dodaj warunek',0),(533958,14833,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ ÑƒÑÐ»Ð¾Ð²Ð¸Ðµ',0),(533959,14833,'ur','Ø´Ø±Ø· Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(533960,14833,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ ÑƒÑÐ»Ð¾Ð²',0),(533961,14833,'vi','ThÃªm Ä‘iá»u kiá»‡n',0),(533962,14833,'af','Voeg toestand',0),(533963,14833,'ro','Adauga condiÅ£ie',0),(533964,14833,'et','Lisa tingimus',0),(533965,14833,'si','Dodajte pogoj',0),(533966,14833,'ba','Tambahkan kondisi',0),(533967,14833,'nl','Voorwaarde toevoegen',0),(533968,14833,'fi','LisÃ¤Ã¤ ehto',0),(533969,14833,'no','Legge til betingelse',0),(533970,14833,'da','TilfÃ¸j betingelse',0),(533971,14833,'ko','ì¡°ê±´ ì¶”ê°€',0),(533972,14833,'he','×”×•×¡×£ ×”×ª× ××™',0),(533973,14833,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(533974,14833,'zh','æ·»åŠ æ¡ä»¶',0),(533975,14833,'sv','LÃ¤gg till villkor',0),(533976,14833,'it','Aggiungi condizione',0),(533977,14833,'tl','',0),(533978,14833,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚',0),(533979,14833,'hi','à¤¶à¤°à¥à¤¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(533980,14833,'ms','Menambah syarat',0),(533981,14833,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ø±Ø·',0),(533982,14833,'fr','Ajouter Condition',0),(533983,14833,'jp','æ¡ä»¶ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(533984,14833,'pt','Adicionar condiÃ§Ã£o',0),(533985,14833,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ ÑƒÑÐ»Ð¾Ð²Ð¸Ðµ',0),(533986,14833,'es','AÃ±adir condiciÃ³n',0),(533987,14833,'de','Bedingung hinzufÃ¼gen',0),(533988,14833,'en','Add Condition',0),(533989,14834,'is','',0),(533990,14834,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡',0),(533991,14834,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú¯Ø±ÙˆÙ‡',0),(533992,14834,'tr','Grup ekleme',0),(533993,14834,'pl','Dodaj grupÄ™',0),(533994,14834,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð³Ñ€ÑƒÐ¿Ð°',0),(533995,14834,'ur','Ú¯Ø±ÙˆÙ¾ Ù…ÛŒÚº Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(533996,14834,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð³Ñ€ÑƒÐ¿Ðµ',0),(533997,14834,'vi','ThÃªm nhÃ³m',0),(533998,14834,'af','Voeg groep',0),(533999,14834,'ro','AdÄƒugare grup',0),(534000,14834,'et','RÃ¼hma lisamine',0),(534001,14834,'si','Dodaj skupino',0),(534002,14834,'ba','Menambahkan grup',0),(534003,14834,'nl','Groep toevoegen',0),(534004,14834,'fi','LisÃ¤Ã¤ ryhmÃ¤',0),(534005,14834,'no','Legg til gruppe',0),(534006,14834,'da','TilfÃ¸j gruppe',0),(534007,14834,'ko','ê·¸ë£¹ ì¶”ê°€',0),(534008,14834,'he','×”×•×¡×£ ×§×‘×•×¦×ª',0),(534009,14834,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¿Î¼Î¬Î´Î±Ï‚',0),(534010,14834,'zh','æ·»åŠ ç»„',0),(534011,14834,'sv','LÃ¤gga till grupp',0),(534012,14834,'it','Aggiungi gruppo',0),(534013,14834,'tl','',0),(534014,14834,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸¥à¸¸à¹ˆà¸¡',0),(534015,14834,'hi','à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(534016,14834,'ms','Tambah Kumpulan',0),(534017,14834,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(534018,14834,'fr','Ajouter groupe',0),(534019,14834,'jp','ã‚°ãƒ«ãƒ¼ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(534020,14834,'pt','Adicionar grupo',0),(534021,14834,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð³Ñ€ÑƒÐ¿Ð¿Ñƒ',0),(534022,14834,'es','Agregar grupo',0),(534023,14834,'de','Gruppe hinzufÃ¼gen',0),(534024,14834,'en','Add Group',0),(534025,14835,'is','',0),(534026,14835,'dr','Ú©Ø´ÛŒØ¯Ù† Ù„ÛŒÙ†Ú© Ø¯Ø± Ø§ÛŒÙ†Ø¬Ø§',0),(534027,14835,'pr','Ú©Ø´ÛŒØ¯Ù† Ù„ÛŒÙ†Ú© Ø¯Ø± Ø§ÛŒÙ†Ø¬Ø§',0),(534028,14835,'tr','BaÄŸlantÄ±yÄ± sÃ¼rÃ¼kleyin',0),(534029,14835,'pl','PrzeciÄ…gnij Link tutaj',0),(534030,14835,'bg','ÐŸÐ»ÑŠÐ·Ð½ÐµÑ‚Ðµ Ð²Ñ€ÑŠÐ·ÐºÐ° Ñ‚ÑƒÐº',0),(534031,14835,'ur','ÛŒÛØ§Úº Ù„Ù†Ú© Ú¯Ú¾Ø³ÛŒÙ¹ÛŒÚº',0),(534032,14835,'sr','ÐŸÑ€ÐµÐ²ÑƒÑ†Ð¸Ñ‚Ðµ Ð›Ð¸Ð½Ðº Ð¾Ð²Ð´Ðµ',0),(534033,14835,'vi','KÃ©o liÃªn káº¿t á»Ÿ Ä‘Ã¢y',0),(534034,14835,'af','Sleep skakel hier',0),(534035,14835,'ro','Drag Link aici',0),(534036,14835,'et','Lohistage Link siin',0),(534037,14835,'si','Povlecite povezavo tukaj',0),(534038,14835,'ba','Drag Link di sini',0),(534039,14835,'nl','Slepen Link hier',0),(534040,14835,'fi','VedÃ¤ linkki tÃ¤ssÃ¤',0),(534041,14835,'no','Dra Link her',0),(534042,14835,'da','TrÃ¦k Link her',0),(534043,14835,'ko','ë“œëž˜ê·¸ ë§í¬ ì—¬ê¸°',0),(534044,14835,'he','×’×¨×•×¨ ×§×™×©×•×¨ ×›××Ÿ',0),(534045,14835,'el','Î£ÏÏÎµÏ„Îµ Ï„Î¿ ÏƒÏÎ½Î´ÎµÏƒÎ¼Î¿ ÎµÎ´ÏŽ',0),(534046,14835,'zh','æ‹–åŠ¨é“¾æŽ¥åœ¨è¿™é‡Œ',0),(534047,14835,'sv','Dra lÃ¤nken hÃ¤r',0),(534048,14835,'it','Drag Link qui',0),(534049,14835,'tl','',0),(534050,14835,'th','à¸¥à¸²à¸à¸¥à¸´à¸‡à¸„à¹Œà¸—à¸µà¹ˆà¸™à¸µà¹ˆ',0),(534051,14835,'hi','à¤–à¥€à¤‚à¤šà¥‡à¤‚ à¤²à¤¿à¤‚à¤• à¤¯à¤¹à¤¾à¤',0),(534052,14835,'ms','Drag Link di sini',0),(534053,14835,'ar','Ø§Ø³Ø­Ø¨ Ø§Ù„Ø±Ø§Ø¨Ø· Ù‡Ù†Ø§',0),(534054,14835,'fr','Drag Link ici',0),(534055,14835,'jp','ã“ã“ã«ãƒªãƒ³ã‚¯ã‚’ãƒ‰ãƒ©ãƒƒã‚°',0),(534056,14835,'pt','Arrastar Link aqui',0),(534057,14835,'ru','ÐŸÐµÑ€ÐµÑ‚Ð°Ñ‰Ð¸Ñ‚Ðµ ÑÑÑ‹Ð»ÐºÑƒ Ð·Ð´ÐµÑÑŒ',0),(534058,14835,'es','Drag Link aquÃ­',0),(534059,14835,'de','Drag Link hier',0),(534060,14835,'en','Drag Link Here',0),(534061,14836,'is','',0),(534062,14836,'dr','Ù‚Ø§Ù„Ø¨',0),(534063,14836,'pr','Ù‚Ø§Ù„Ø¨',0),(534064,14836,'tr','BiÃ§im',0),(534065,14836,'pl','Formacie',0),(534066,14836,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(534067,14836,'ur','ÙˆØ¶Ø¹',0),(534068,14836,'sr','ÐžÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°ÑšÐµ',0),(534069,14836,'vi','Äá»‹nh dáº¡ng',0),(534070,14836,'af','Formaat',0),(534071,14836,'ro','Formatul',0),(534072,14836,'et','Formaat',0),(534073,14836,'si','Oblika',0),(534074,14836,'ba','Format',0),(534075,14836,'nl','Formaat',0),(534076,14836,'fi','Muodossa',0),(534077,14836,'no','Format',0),(534078,14836,'da','Format',0),(534079,14836,'ko','í˜•ì‹',0),(534080,14836,'he','×ª×‘× ×™×ª',0),(534081,14836,'el','ÎœÎ¿ÏÏ†Î®',0),(534082,14836,'zh','æ ¼å¼',0),(534083,14836,'sv','Format',0),(534084,14836,'it','Formato',0),(534085,14836,'tl','',0),(534086,14836,'th','à¸£à¸¹à¸›à¹à¸šà¸š',0),(534087,14836,'hi','à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(534088,14836,'ms','Format',0),(534089,14836,'ar','ØªÙ†Ø³ÙŠÙ‚',0),(534090,14836,'fr','Format',0),(534091,14836,'jp','å½¢å¼',0),(534092,14836,'pt','Formato',0),(534093,14836,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(534094,14836,'es','Formato',0),(534095,14836,'de','Format',0),(534096,14836,'en','Format',0),(534097,14837,'is','',0),(534098,14837,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÛŒ Ø¨Ø± Ø§Ø³Ø§Ø³',0),(534099,14837,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÛŒ Ø¨Ø± Ø§Ø³Ø§Ø³',0),(534100,14837,'tr','GÃ¶re GruplandÄ±r',0),(534101,14837,'pl','Grupuj wedÅ‚ug',0),(534102,14837,'bg','Ð“Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾',0),(534103,14837,'ur','Ú¯Ø±ÙˆÙ¾ Ø¨Ù…Ø·Ø§Ø¨Ù‚',0),(534104,14837,'sr','Ð“Ñ€ÑƒÐ¿Ð¸ÑÐ°ÑšÐµ Ð¿Ð¾',0),(534105,14837,'vi','NhÃ³m theo',0),(534106,14837,'af','Groepeer volgens',0),(534107,14837,'ro','Grupa de',0),(534108,14837,'et','Kaupa',0),(534109,14837,'si','ZdruÅ¾i po',0),(534110,14837,'ba','Kelompok oleh',0),(534111,14837,'nl','Groeperen op',0),(534112,14837,'fi','Ryhmittely',0),(534113,14837,'no','Gruppere etter',0),(534114,14837,'da','Gruppe af',0),(534115,14837,'ko','ê·¸ë£¹í™”',0),(534116,14837,'he','×§×‘×¥ ×œ×¤×™',0),(534117,14837,'el','ÎŸÎ¼Î±Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· ÎºÎ±Ï„Î¬',0),(534118,14837,'zh','é€šè¿‡åˆ†ç»„',0),(534119,14837,'sv','Gruppera efter',0),(534120,14837,'it','Gruppo di',0),(534121,14837,'tl','',0),(534122,14837,'th','à¸ˆà¸±à¸”à¸à¸¥à¸¸à¹ˆà¸¡à¸•à¸²à¸¡',0),(534123,14837,'hi','à¤†à¤§à¤¾à¤° à¤ªà¤° à¤¸à¤®à¥‚à¤¹à¥€à¤•à¥ƒà¤¤ à¤•à¤°à¥‡à¤‚',0),(534124,14837,'ms','Kumpulan secara',0),(534125,14837,'ar','ØªØ¬Ù…ÙŠØ¹ Ø­Ø³Ø¨',0),(534126,14837,'fr','Group By',0),(534127,14837,'jp','ã‚°ãƒ«ãƒ¼ãƒ—åŒ–',0),(534128,14837,'pt','Agrupar por',0),(534129,14837,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð¾',0),(534130,14837,'es','Group By',0),(534131,14837,'de','Group By',0),(534132,14837,'en','Group By',0),(534133,14838,'is','',0),(534134,14838,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø²Ù…ÛŒÙ†Ù‡',0),(534135,14838,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø²Ù…ÛŒÙ†Ù‡',0),(534136,14838,'tr','Alan seÃ§in',0),(534137,14838,'pl','Wybierz pole',0),(534138,14838,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ð»Ðµ',0),(534139,14838,'ur','Ù‚Ø·Ø¹Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(534140,14838,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ™Ðµ',0),(534141,14838,'vi','Chá»n trÆ°á»ng',0),(534142,14838,'af','Kies veld',0),(534143,14838,'ro','SelectaÅ£i cÃ¢mpul',0),(534144,14838,'et','Valige vÃ¤li',0),(534145,14838,'si','Izberite polje',0),(534146,14838,'ba','Pilih bidang',0),(534147,14838,'nl','Selecteer veld',0),(534148,14838,'fi','Valitse kenttÃ¤',0),(534149,14838,'no','Velg feltet',0),(534150,14838,'da','VÃ¦lg feltet',0),(534151,14838,'ko','í•„ë“œ ì„ íƒ',0),(534152,14838,'he','×‘×—×¨ ×©×“×”',0),(534153,14838,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï€ÎµÎ´Î¯Î¿',0),(534154,14838,'zh','é€‰æ‹©å­—æ®µ',0),(534155,14838,'sv','VÃ¤lj fÃ¤ltet',0),(534156,14838,'it','Selezionare il campo',0),(534157,14838,'tl','',0),(534158,14838,'th','à¹€à¸¥à¸·à¸­à¸à¸Ÿà¸´à¸¥à¸”à¹Œ',0),(534159,14838,'hi','à¤«à¤¼à¥€à¤²à¥à¤¡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(534160,14838,'ms','Pilih bidang',0),(534161,14838,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø­Ù‚Ù„',0),(534162,14838,'fr','SÃ©lectionnez le champ',0),(534163,14838,'jp','ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’é¸æŠžã—ã¾ã™',0),(534164,14838,'pt','Selecione o campo',0),(534165,14838,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð»Ðµ',0),(534166,14838,'es','Seleccione el campo',0),(534167,14838,'de','WÃ¤hlen Sie Feld',0),(534168,14838,'en','Select Field',0),(534169,14839,'is','',0),(534170,14839,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ Ø§Ø²',0),(534171,14839,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ Ø§Ø²',0),(534172,14839,'tr','Olarak Select set Ã¼zerinden',0),(534173,14839,'pl','Zestaw jak Select z',0),(534174,14839,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ ÐºÐ°Ñ‚Ð¾ Ð¸Ð·Ð±Ð¾Ñ€ Ð¾Ñ‚',0),(534175,14839,'ur','Ø·ÙˆØ± Ù¾Ø± Ù…Ù†ØªØ®Ø¨ Ø³ÛŒÙ¹ Ø³Û’',0),(534176,14839,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ ÐºÐ°Ð¾ Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ Ð¸Ð·',0),(534177,14839,'vi','Thiáº¿t láº­p lÃ  chá»n tá»«',0),(534178,14839,'af','Stel so kies uit',0),(534179,14839,'ro','SetaÅ£i ca selectaÅ£i din',0),(534180,14839,'et','MÃ¤Ã¤ra, kui valida:',0),(534181,14839,'si','Nastavite kot izbranih iz',0),(534182,14839,'ba','Ditetapkan sebagai pilih dari',0),(534183,14839,'nl','Instellen als selecteren uit',0),(534184,14839,'fi','Asettaa kuin valita alkaen',0),(534185,14839,'no','Angi som velger fra',0),(534186,14839,'da','SÃ¦t sÃ¥ vÃ¦lg fra',0),(534187,14839,'ko','ìœ¼ë¡œ ì„ íƒ ì„¤ì •ì—ì„œ',0),(534188,14839,'he','×”×’×“×¨ ×›×ž×• ×‘×—×™×¨×” ×ž',0),(534189,14839,'el','ÎŸÏÎ¹ÏƒÏ„ÎµÎ¯ Ï‰Ï‚ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î±Ï€ÏŒ',0),(534190,14839,'zh','è®¾ç½®é€‰æ‹©ä»Ž',0),(534191,14839,'sv','Ange sÃ¥ vÃ¤lj frÃ¥n',0),(534192,14839,'it','Impostare come selezionare da',0),(534193,14839,'tl','',0),(534194,14839,'th','à¸•à¸±à¹‰à¸‡à¹€à¸›à¹‡à¸™à¹€à¸¥à¸·à¸­à¸à¸ˆà¸²à¸',0),(534195,14839,'hi','à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¥à¤¨à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤¸à¥‡',0),(534196,14839,'ms','Ditetapkan seperti Pilih dari',0),(534197,14839,'ar','ØªØ¹ÙŠÙŠÙ† ØªØ­Ø¯ÙŠØ¯ Ù…Ù†',0),(534198,14839,'fr','Sous sÃ©lectionnez la valeur de',0),(534199,14839,'jp','è¨­å®šã‚’é¸æŠžã‹ã‚‰',0),(534200,14839,'pt','Definir como seleÃ§Ã£o de',0),(534201,14839,'ru','Ð—Ð°Ð´Ð°Ñ‚ÑŒ ÐºÐ°Ðº Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ Ð¾Ñ‚',0),(534202,14839,'es','Establecer lo mÃ¡s selecto de',0),(534203,14839,'de','Legen Sie so wÃ¤hlen Sie aus',0),(534204,14839,'en','Set As Select From',0),(534205,14840,'is','',0),(534206,14840,'dr','Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ú¯Ø±ÙˆÙ‡ Ø²ÛŒØ± Ù…Ø¬Ù…ÙˆØ¹',0),(534207,14840,'pr','Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ú¯Ø±ÙˆÙ‡ Ø²ÛŒØ± Ù…Ø¬Ù…ÙˆØ¹',0),(534208,14840,'tr','Show alt grup toplamlarÄ±',0),(534209,14840,'pl','PokaÅ¼ grupy Sub sumy',0),(534210,14840,'bg','ÐžÐ±Ñ‰ ÑÐ±Ð¾Ñ€ Ð·Ð° Ð³Ñ€ÑƒÐ¿Ð° ÑˆÐ¾Ñƒ Ð¿Ð¾Ð´',0),(534211,14840,'ur','Ø´Ùˆ Ø°ÛŒÙ„ÛŒ Ú¯Ø±ÙˆÙ¾ Ù…ÛŒØ²Ø§Ù†',0),(534212,14840,'sr','Ð—Ð±Ð¸Ñ€Ð¾Ð²Ð¸ Ð³Ñ€ÑƒÐ¿Ðµ Ð¡ÑƒÐ± ÑˆÐ¾Ñƒ',0),(534213,14840,'vi','Tá»•ng sá»‘ hiá»ƒn thá»‹ phá»¥ nhÃ³m',0),(534214,14840,'af','Wys Sub-groep se totale',0),(534215,14840,'ro','Totaluri grup de Sub AratÄƒ',0),(534216,14840,'et','NÃ¤ita Sub rÃ¼hmade kokkuvÃµtted',0),(534217,14840,'si','Vsote skupine show Sub',0),(534218,14840,'ba','Total Tampilkan Sub kumpulan',0),(534219,14840,'nl','Toon Sub groepstotalen',0),(534220,14840,'fi','NÃ¤ytÃ¤ Sub ryhmÃ¤n yhteissummat',0),(534221,14840,'no','Vis Sub gruppetotaler',0),(534222,14840,'da','Vis Sub gruppetotaler',0),(534223,14840,'ko','ë³´ê¸° í•˜ìœ„ ê·¸ë£¹ í•©ê³„',0),(534224,14840,'he','×”×¦×’ ×ª×ª ×§×‘×•×¦×” ×¡×›×•×ž×™×',0),(534225,14840,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÏ…Î½ÏŒÎ»Ï‰Î½ Ï…Ï€Î¿',0),(534226,14840,'zh','æ˜¾ç¤ºå­ç»„æ€»è®¡',0),(534227,14840,'sv','Visa Sub Gruppsummor',0),(534228,14840,'it','Visualizza gruppo Sub totali',0),(534229,14840,'tl','',0),(534230,14840,'th','à¸œà¸¥à¸£à¸§à¸¡à¸‚à¸­à¸‡ à¸à¸¥à¸¸à¹ˆà¸¡à¸¢à¹ˆà¸­à¸¢à¹à¸ªà¸”à¸‡',0),(534231,14840,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤ à¤¸à¤®à¥‚à¤¹ à¤®à¥‡à¤‚ à¤‰à¤ª à¤¯à¥‹à¤—',0),(534232,14840,'ms','Jumlah kumpulan kecil Papar',0),(534233,14840,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„ÙØ±Ø¹ÙŠØ© Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª',0),(534234,14840,'fr','Voir la Sub de sous-totaux',0),(534235,14840,'jp','ã‚·ãƒ§ãƒ¼ã®ã‚µãƒ– ã‚°ãƒ«ãƒ¼ãƒ—åˆè¨ˆ',0),(534236,14840,'pt','Visualizar Sub grupo totais',0),(534237,14840,'ru','Ð˜Ñ‚Ð¾Ð³Ð¸ ÑˆÐ¾Ñƒ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹ Sub',0),(534238,14840,'es','Subgrupo Mostrar totales',0),(534239,14840,'de','Karte Sub Gruppensummen',0),(534240,14840,'en','Show Sub Group Totals',0),(534241,14841,'is','',0),(534242,14841,'dr','Ø§Ø³ØªØ§ØªÛŒÚ©',0),(534243,14841,'pr','Ø§Ø³ØªØ§ØªÛŒÚ©',0),(534244,14841,'tr','Statik',0),(534245,14841,'pl','Statyczne',0),(534246,14841,'bg','Ð¡Ñ‚Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾',0),(534247,14841,'ur','Ø¬Ø§Ù…Ø¯',0),(534248,14841,'sr','Ð¡Ñ‚Ð°Ñ‚Ð¸Ñ‡ÐºÐ¸',0),(534249,14841,'vi','TÄ©nh',0),(534250,14841,'af','Statiese',0),(534251,14841,'ro','StaticÄƒ',0),(534252,14841,'et','Staatiline',0),(534253,14841,'si','StatiÄne',0),(534254,14841,'ba','Statis',0),(534255,14841,'nl','Static',0),(534256,14841,'fi','Staattinen',0),(534257,14841,'no','Statisk',0),(534258,14841,'da','Statisk',0),(534259,14841,'ko','ì •ì ',0),(534260,14841,'he','×—×©×ž×œ ×¡×˜×˜×™',0),(534261,14841,'el','Î£Ï„Î±Ï„Î¹ÎºÎ®',0),(534262,14841,'zh','é™æ€',0),(534263,14841,'sv','Statisk',0),(534264,14841,'it','Statica',0),(534265,14841,'tl','',0),(534266,14841,'th','à¸ªà¸–à¸´à¸•',0),(534267,14841,'hi','à¤¸à¥à¤¥à¥ˆà¤¤à¤¿à¤•',0),(534268,14841,'ms','Statik',0),(534269,14841,'ar','Ø«Ø§Ø¨Øª',0),(534270,14841,'fr','Statique',0),(534271,14841,'jp','é™çš„',0),(534272,14841,'pt','EstÃ¡tica',0),(534273,14841,'ru','Ð¡Ñ‚Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ',0),(534274,14841,'es','EstÃ¡tica',0),(534275,14841,'de','Statische',0),(534276,14841,'en','Static',0),(534277,14842,'is','',0),(534278,14842,'dr','ÙˆØ±ÙˆØ¯ÛŒ Ú©Ø§Ø±Ø¨Ø±',0),(534279,14842,'pr','ÙˆØ±ÙˆØ¯ÛŒ Ú©Ø§Ø±Ø¨Ø±',0),(534280,14842,'tr','KullanÄ±cÄ± giriÅŸi',0),(534281,14842,'pl','Dane wejÅ›ciowe uÅ¼ytkownika',0),(534282,14842,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð²Ñ…Ð¾Ð´',0),(534283,14842,'ur','ØµØ§Ø±Ù Ø§Ù† Ù¾Ù¹',0),(534284,14842,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¸ ÑƒÐ½Ð¾Ñ',0),(534285,14842,'vi','NgÆ°á»i dÃ¹ng nháº­p vÃ o',0),(534286,14842,'af','Gebruikerstoevoer',0),(534287,14842,'ro','Intrare de la utilizator',0),(534288,14842,'et','Kasutaja sisend',0),(534289,14842,'si','Vnos uporabnika',0),(534290,14842,'ba','Input pengguna',0),(534291,14842,'nl','Invoer van de gebruiker',0),(534292,14842,'fi','SyÃ¶ttÃ¶tapa',0),(534293,14842,'no','Brukerinndata',0),(534294,14842,'da','Brugerinput',0),(534295,14842,'ko','ì‚¬ìš©ìž ìž…ë ¥',0),(534296,14842,'he','×§×œ×˜ ×ž×©×ª×ž×©',0),(534297,14842,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€ÏŒ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î·',0),(534298,14842,'zh','ç”¨æˆ·è¾“å…¥',0),(534299,14842,'sv','AnvÃ¤ndarindata',0),(534300,14842,'it','Input dell\'utente',0),(534301,14842,'tl','',0),(534302,14842,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸›à¹‰à¸­à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(534303,14842,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤‡à¤¨à¤ªà¥à¤Ÿ',0),(534304,14842,'ms','Input pengguna',0),(534305,14842,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(534306,14842,'fr','EntrÃ©e d\'utilisateur',0),(534307,14842,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼å…¥åŠ›',0),(534308,14842,'pt','Entrada do usuÃ¡rio',0),(534309,14842,'ru','Ð’Ð²Ð¾Ð´Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¼',0),(534310,14842,'es','Entrada de usuario',0),(534311,14842,'de','Benutzereingaben',0),(534312,14842,'en','User Input',0),(534313,14843,'is','',0),(534314,14843,'dr','Ø§Ø² Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(534315,14843,'pr','Ø§Ø² Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(534316,14843,'tr','SeÃ§in',0),(534317,14843,'pl','Wybierz z',0),(534318,14843,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¾Ñ‚',0),(534319,14843,'ur','Ø³Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(534320,14843,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¸Ð·',0),(534321,14843,'vi','Chá»n tá»«',0),(534322,14843,'af','Kies uit',0),(534323,14843,'ro','SelectaÅ£i din',0),(534324,14843,'et','Saate valida',0),(534325,14843,'si','Izberite iz',0),(534326,14843,'ba','Pilih dari',0),(534327,14843,'nl','Selecteren',0),(534328,14843,'fi','Valitse',0),(534329,14843,'no','Velg',0),(534330,14843,'da','VÃ¦lg fra',0),(534331,14843,'ko','ì„ íƒ',0),(534332,14843,'he','×‘×—×¨ ×ž×ª×•×š',0),(534333,14843,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±Ï€ÏŒ',0),(534334,14843,'zh','ä»Žé€‰æ‹©',0),(534335,14843,'sv','VÃ¤lj frÃ¥n',0),(534336,14843,'it','Selezionare da',0),(534337,14843,'tl','',0),(534338,14843,'th','à¹€à¸¥à¸·à¸­à¸à¸ˆà¸²à¸',0),(534339,14843,'hi','à¤¸à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(534340,14843,'ms','Pilih daripada',0),(534341,14843,'ar','Ø­Ø¯Ø¯ Ù…Ù†',0),(534342,14843,'fr','SÃ©lectionnez dans',0),(534343,14843,'jp','é¸æŠžã—ã¾ã™ã€‚',0),(534344,14843,'pt','Selecione de',0),(534345,14843,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¸Ð·',0),(534346,14843,'es','Seleccione de',0),(534347,14843,'de','WÃ¤hlen Sie aus',0),(534348,14843,'en','Select From',0),(534349,14844,'is','',0),(534350,14844,'dr','Ø§Ø±Ø²Ø´ Ù‡Ø§ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(534351,14844,'pr','Ø§Ø±Ø²Ø´ Ù‡Ø§ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(534352,14844,'tr','DeÄŸerleri seÃ§in',0),(534353,14844,'pl','Wybierz wartoÅ›ci',0),(534354,14844,'bg','Ð˜Ð·Ð±Ð¾Ñ€ Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ð¸',0),(534355,14844,'ur','Ø§Ù‚Ø¯Ø§Ø± Ú©Ùˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(534356,14844,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(534357,14844,'vi','Chá»n giÃ¡ trá»‹',0),(534358,14844,'af','Waardes te kies',0),(534359,14844,'ro','SelectaÅ£i valorile',0),(534360,14844,'et','VÃ¤Ã¤rtuste valimine',0),(534361,14844,'si','Izberite vrednosti',0),(534362,14844,'ba','Pilih nilai-nilai',0),(534363,14844,'nl','Selecteer waarden',0),(534364,14844,'fi','Valitse arvot',0),(534365,14844,'no','Velg verdier',0),(534366,14844,'da','VÃ¦lg vÃ¦rdier',0),(534367,14844,'ko','ê°’ ì„ íƒ',0),(534368,14844,'he','×‘×—×¨ ×¢×¨×›×™×',0),(534369,14844,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¹Î¼Î­Ï‚',0),(534370,14844,'zh','é€‰æ‹©å€¼',0),(534371,14844,'sv','VÃ¤lj vÃ¤rden',0),(534372,14844,'it','Selezionare valori',0),(534373,14844,'tl','',0),(534374,14844,'th','à¹€à¸¥à¸·à¸­à¸à¸„à¹ˆà¸²',0),(534375,14844,'hi','à¤®à¤¾à¤¨à¥‹à¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(534376,14844,'ms','Memilih nilai-nilai',0),(534377,14844,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ù‚ÙŠÙ…',0),(534378,14844,'fr','SÃ©lectionnez valeurs',0),(534379,14844,'jp','å€¤ã‚’é¸æŠžã—ã¾ã™',0),(534380,14844,'pt','Selecione valores',0),(534381,14844,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(534382,14844,'es','Seleccione los valores',0),(534383,14844,'de','WÃ¤hlen Sie Werte',0),(534384,14844,'en','Select Values',0),(534385,14845,'is','',0),(534386,14845,'dr','ØªØ¹Ù…ÛŒØ± Ø®ÙˆØ¯Ø±Ùˆ',0),(534387,14845,'pr','ØªØ¹Ù…ÛŒØ± Ø®ÙˆØ¯Ø±Ùˆ',0),(534388,14845,'tr','Otomatik dÃ¼zeltme',0),(534389,14845,'pl','Auto Fix',0),(534390,14845,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ ÐºÐ¾Ñ€Ð¸Ð³Ð¸Ñ€Ð°Ð½Ðµ',0),(534391,14845,'ur','Ø¢Ù¹Ùˆ ÙÚ©Ø³',0),(534392,14845,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð¸ÑÐ¿Ñ€Ð°Ð²Ð¸',0),(534393,14845,'vi','Sá»­a chá»¯a tá»± Ä‘á»™ng',0),(534394,14845,'af','Outomatiese Fix',0),(534395,14845,'ro','Auto Fix',0),(534396,14845,'et','Automaatne parandus',0),(534397,14845,'si','Auto Fix',0),(534398,14845,'ba','Auto perbaikan',0),(534399,14845,'nl','Auto Fix',0),(534400,14845,'fi','Auto Fix',0),(534401,14845,'no','Auto Fix',0),(534402,14845,'da','Auto Fix',0),(534403,14845,'ko','ìžë™ ìˆ˜ì •',0),(534404,14845,'he','×ª×™×§×•×Ÿ ××•×˜×•×ž×˜×™',0),(534405,14845,'el','Auto Fix',0),(534406,14845,'zh','è‡ªåŠ¨ä¿®å¤',0),(534407,14845,'sv','Auto Fix',0),(534408,14845,'it','Correzione automatica',0),(534409,14845,'tl','',0),(534410,14845,'th','à¸à¸²à¸£à¹à¸à¹‰à¹„à¸‚à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(534411,14845,'hi','à¤¸à¥à¤µà¤¤: à¤ à¥€à¤• à¤•à¤°à¥‡à¤‚',0),(534412,14845,'ms','Auto Baiki',0),(534413,14845,'ar','Ø¥ØµÙ„Ø§Ø­ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª',0),(534414,14845,'fr','Fix Auto',0),(534415,14845,'jp','è‡ªå‹•ä¿®æ­£',0),(534416,14845,'pt','Auto correÃ§Ã£o',0),(534417,14845,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¸ÑÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(534418,14845,'es','Auto Fix',0),(534419,14845,'de','Auto-Fix',0),(534420,14845,'en','Auto Fix',0),(534421,14846,'is','',0),(534422,14846,'dr','Ù¾ÛŒÙˆØ³ØªÙ† Ø¨Ù‡ Ø¬Ø¯ÙˆÙ„ Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(534423,14846,'pr','Ù¾ÛŒÙˆØ³ØªÙ† Ø¨Ù‡ Ø¬Ø¯ÙˆÙ„ Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(534424,14846,'tr','GeÃ§ersiz Tablo birleÅŸtirme',0),(534425,14846,'pl','Tabela nieprawidÅ‚owe Å‚Ä…czenie',0),(534426,14846,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° Ð¿Ñ€Ð¸ÑÑŠÐµÐ´Ð¸Ð½ÑÐ²Ð°Ð½ÐµÑ‚Ð¾',0),(534427,14846,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ø¬Ø¯ÙˆÙ„ Ù…ÛŒÚº Ø´Ù…ÙˆÙ„ÛŒØª',0),(534428,14846,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð° Ñ‚Ð°Ð±ÐµÐ»Ð° Ð¿Ñ€Ð¸Ð´Ñ€ÑƒÐ¶Ð¸Ð²Ð°ÑšÐµ',0),(534429,14846,'vi','KhÃ´ng há»£p lá»‡ báº£ng tham gia',0),(534430,14846,'af','Ongeldig tabel aansluiting by',0),(534431,14846,'ro','Aderarea la masÄƒ nevalid',0),(534432,14846,'et','Lubamatu tabeli liitumine',0),(534433,14846,'si','Neveljaven mizo pridruÅ¾il',0),(534434,14846,'ba','Bergabung dengan tabel tidak valid',0),(534435,14846,'nl','Ongeldige tabel toetreding tot',0),(534436,14846,'fi','Virheellinen taulun liittyminen',0),(534437,14846,'no','Ugyldig tabell begynte',0),(534438,14846,'da','Ugyldigt tabel sammenfÃ¸jning',0),(534439,14846,'ko','ìž˜ëª» ëœ í…Œì´ë¸” ì¡°ì¸',0),(534440,14846,'he','×”×¦×˜×¨×¤×•×ª ×˜×‘×œ×” ×œ× ×—×•×§×™',0),(534441,14846,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· Ï€Î¯Î½Î±ÎºÎ± ÎµÎ½ÏŽÎ½ÎµÎ¹',0),(534442,14846,'zh','æ— æ•ˆçš„è¡¨åŠ å…¥',0),(534443,14846,'sv','Ogiltigt tabell att gÃ¥',0),(534444,14846,'it','Entrare in tabella non valida',0),(534445,14846,'tl','',0),(534446,14846,'th','à¸£à¸§à¸¡à¸•à¸²à¸£à¸²à¸‡à¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(534447,14846,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥‹à¤¨à¥‡ à¤•à¥‡',0),(534448,14846,'ms','Jadual tidak sah menyertai',0),(534449,14846,'ar','Ø§Ù„Ø§Ù†Ø¶Ù…Ø§Ù… Ø¥Ù„Ù‰ Ø§Ù„Ø¬Ø¯ÙˆÙ„ ØºÙŠØ± ØµØ­ÙŠØ­',0),(534450,14846,'fr','Rejoindre une Table non valide',0),(534451,14846,'jp','ç„¡åŠ¹ãªãƒ†ãƒ¼ãƒ–ãƒ«ã«å‚åŠ ã—ã¾ã™ã€‚',0),(534452,14846,'pt','Se juntar a tabela invÃ¡lida',0),(534453,14846,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð°Ñ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° Ð¿Ñ€Ð¸ÑÐ¾ÐµÐ´Ð¸Ð½ÐµÐ½Ð¸Ñ',0),(534454,14846,'es','Unirse a mesa no vÃ¡lido',0),(534455,14846,'de','UngÃ¼ltiger Tabelle verknÃ¼pfen',0),(534456,14846,'en','Invalid Table Joining',0),(534457,14847,'is','',0),(534458,14847,'dr','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø¬Ø¯Ø§ÙˆÙ„ Ù¾ÛŒÙˆØ³Øª',0),(534459,14847,'pr','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø¬Ø¯Ø§ÙˆÙ„ Ù¾ÛŒÙˆØ³Øª',0),(534460,14847,'tr','TablolarÄ± ihtiyaÃ§ katÄ±ldÄ±',0),(534461,14847,'pl','Potrzeba tabele poÅ‚Ä…czone',0),(534462,14847,'bg','ÐœÐ°ÑÐ¸ Ð½ÑƒÐ¶Ð´Ð° ÑÐµ Ð¿Ñ€Ð¸ÑÑŠÐµÐ´Ð¸Ð½Ð¸Ñ…Ð°',0),(534463,14847,'ur','Ø¬Ø¯Ø§ÙˆÙ„ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª Ù…ÛŒÚº Ø´Ù…ÙˆÙ„ÛŒØª Ø§Ø®ØªÛŒØ§Ø± Ú©ÛŒ',0),(534464,14847,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ðµ ÑÐµ Ð¿Ñ€Ð¸Ð´Ñ€ÑƒÐ¶Ð¸Ð¾',0),(534465,14847,'vi','Báº£ng cáº§n tham gia',0),(534466,14847,'af','Tabelle moet aangesluit',0),(534467,14847,'ro','Tabelele trebuie s-au alÄƒturat',0),(534468,14847,'et','Tabelid tuleb liitunud',0),(534469,14847,'si','Tabele potreba pridruÅ¾il',0),(534470,14847,'ba','Tabel perlu bergabung',0),(534471,14847,'nl','Tabellen noodzaak sloot zich aan bij',0),(534472,14847,'fi','Taulukot on liittynyt',0),(534473,14847,'no','Tabeller behovet ble',0),(534474,14847,'da','Tabeller behovet tiltrÃ¥dte',0),(534475,14847,'ko','ì¡°ì¸ í…Œì´ë¸” í•„ìš”',0),(534476,14847,'he','×©×•×œ×—× ×•×ª. ×©×¦×¨×™×›×™× ×”×¦×˜×¨×£',0),(534477,14847,'el','Î Î¯Î½Î±ÎºÎµÏ‚ Î±Î½Î¬Î³ÎºÎ· ÎµÎ½Ï„Î¬Ï‡Î¸Î·ÎºÎ±Î½',0),(534478,14847,'zh','è¡¨éœ€è¦åŠ å…¥',0),(534479,14847,'sv','Tabeller behÃ¶ver sÃ¤llskap',0),(534480,14847,'it','NecessitÃ  di tabelle si unÃ¬',0),(534481,14847,'tl','',0),(534482,14847,'th','à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸•à¸²à¸£à¸²à¸‡à¸—à¸µà¹ˆà¹€à¸‚à¹‰à¸²à¸£à¹ˆà¸§à¸¡',0),(534483,14847,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾à¤“à¤‚ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥‹ à¤—à¤',0),(534484,14847,'ms','Jadual perlu menyertai',0),(534485,14847,'ar','Ø§Ù„Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰ Ø§Ù„Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ù„ØªÙŠ Ø§Ù†Ø¶Ù…Øª Ø¥Ù„Ù‰',0),(534486,14847,'fr','Besoin de tables a rejoint',0),(534487,14847,'jp','çµåˆãƒ†ãƒ¼ãƒ–ãƒ«ãŒå¿…è¦',0),(534488,14847,'pt','Necessidade de tabelas juntou-se',0),(534489,14847,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¿Ñ€Ð¸ÑÐ¾ÐµÐ´Ð¸Ð½Ð¸Ð»ÑÑ Ðº',0),(534490,14847,'es','Necesidad de tablas se uniÃ³ a',0),(534491,14847,'de','Tabellen mÃ¼ssen registriert',0),(534492,14847,'en','Tables Need Joined',0),(534493,14848,'is','',0),(534494,14848,'dr','Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ',0),(534495,14848,'pr','Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ',0),(534496,14848,'tr','Sorgu',0),(534497,14848,'pl','Kwerendy',0),(534498,14848,'bg','Ð—Ð°ÑÐ²ÐºÐ°',0),(534499,14848,'ur','Ø·Ù„Ø¨',0),(534500,14848,'sr','Ð£Ð¿Ð¸Ñ‚',0),(534501,14848,'vi','Truy váº¥n',0),(534502,14848,'af','Navraag',0),(534503,14848,'ro','Interogare',0),(534504,14848,'et','PÃ¤ring',0),(534505,14848,'si','Poizvedbe',0),(534506,14848,'ba','Query',0),(534507,14848,'nl','Query',0),(534508,14848,'fi','Kysely',0),(534509,14848,'no','SpÃ¸rring',0),(534510,14848,'da','ForespÃ¸rgsel',0),(534511,14848,'ko','ì¿¼ë¦¬',0),(534512,14848,'he','×©××™×œ×ª×”',0),(534513,14848,'el','Î•ÏÏŽÏ„Î·Î¼Î±',0),(534514,14848,'zh','æŸ¥è¯¢',0),(534515,14848,'sv','FrÃ¥ga',0),(534516,14848,'it','Query',0),(534517,14848,'tl','',0),(534518,14848,'th','à¹à¸šà¸šà¸ªà¸­à¸šà¸–à¸²à¸¡',0),(534519,14848,'hi','à¤•à¥à¤µà¥‡à¤°à¥€',0),(534520,14848,'ms','Pertanyaan',0),(534521,14848,'ar','Ø§Ù„Ø§Ø³ØªØ¹Ù„Ø§Ù…',0),(534522,14848,'fr','RequÃªte',0),(534523,14848,'jp','ã‚¯ã‚¨ãƒª',0),(534524,14848,'pt','Consulta',0),(534525,14848,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ',0),(534526,14848,'es','Consulta',0),(534527,14848,'de','Abfrage',0),(534528,14848,'en','Query',0),(534529,14849,'is','',0),(534530,14849,'dr','Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯',0),(534531,14849,'pr','Ù¾Ø±Ø³ Ùˆ Ø¬Ùˆ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯',0),(534532,14849,'tr','Sorgu Ekle',0),(534533,14849,'pl','Kwerendy Dodaj',0),(534534,14849,'bg','Ð—Ð°ÑÐ²ÐºÐ° Ð·Ð° Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(534535,14849,'ur','Ø·Ù„Ø¨ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(534536,14849,'sr','Ð”Ð¾Ð´Ð°Ñ˜ ÑƒÐ¿Ð¸Ñ‚',0),(534537,14849,'vi','Truy váº¥n thÃªm',0),(534538,14849,'af','Navraag voeg',0),(534539,14849,'ro','Adauga interogare',0),(534540,14849,'et','PÃ¤ringu lisamine',0),(534541,14849,'si','Poizvedbi dodajte',0),(534542,14849,'ba','Tambahkan query',0),(534543,14849,'nl','Query toevoegen',0),(534544,14849,'fi','Kysely lisÃ¤Ã¤',0),(534545,14849,'no','SpÃ¸rring legger',0),(534546,14849,'da','ForespÃ¸rgsel tilfÃ¸je',0),(534547,14849,'ko','ì¿¼ë¦¬ ì¶”ê°€',0),(534548,14849,'he','×©××™×œ×ª×ª ×”×•×¡×¤×”',0),(534549,14849,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÎµÏÏ‰Ï„Î®Î¼Î±Ï„Î¿Ï‚',0),(534550,14849,'zh','æŸ¥è¯¢æ·»åŠ ',0),(534551,14849,'sv','LÃ¤gga till frÃ¥ga',0),(534552,14849,'it','Aggiungi query',0),(534553,14849,'tl','',0),(534554,14849,'th','à¸ªà¸­à¸šà¸–à¸²à¸¡à¹€à¸žà¸´à¹ˆà¸¡',0),(534555,14849,'hi','à¤•à¥à¤µà¥‡à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(534556,14849,'ms','Pertanyaan Tambah',0),(534557,14849,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ø³ØªØ¹Ù„Ø§Ù…',0),(534558,14849,'fr','Ajouter de la requÃªte',0),(534559,14849,'jp','ã‚¯ã‚¨ãƒªã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(534560,14849,'pt','Adicionar consulta',0),(534561,14849,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾Ñ',0),(534562,14849,'es','Consulta agregar',0),(534563,14849,'de','Abfrage hinzufÃ¼gen',0),(534564,14849,'en','Query Add',0),(534565,14850,'is','',0),(534566,14850,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯ Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§Ø² Ø§ÛŒÙ† ØµÙØ­Ù‡ Ø®Ø§Ø±Ø¬ Ú©Ù†ÛŒØ¯ØŸ',0),(534567,14850,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù†ÛŒØ¯ Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§Ø² Ø§ÛŒÙ† ØµÙØ­Ù‡ Ø®Ø§Ø±Ø¬ Ú©Ù†ÛŒØ¯ØŸ',0),(534568,14850,'tr','Bu sayfadan istediÄŸinizden emin misiniz?',0),(534569,14850,'pl','Czy na pewno chcesz, aby przejÅ›Ä‡ od tej strony?',0),(534570,14850,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð½Ð°Ð¿ÑƒÑÐ½ÐµÑ‚Ðµ Ñ‚Ð°Ð·Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°?',0),(534571,14850,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ø³ ØµÙØ­Û Ú©ÛŒ Ú¯Ø´Øª Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(534572,14850,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð½Ð°Ð¿ÑƒÑÑ‚Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ?',0),(534573,14850,'vi','Báº¡n cÃ³ cháº¯c báº¡n muá»‘n rá»i khá»i trang nÃ y khÃ´ng?',0),(534574,14850,'af','Is jy seker jy wil weg van hierdie bladsy af navigeer?',0),(534575,14850,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ navigaÅ£i la aceasta pagina?',0),(534576,14850,'et','Kas kindlasti sellelt lehelt mujale minna?',0),(534577,14850,'si','Ali ste prepriÄani, da Å¾elite zapustiti to stran?',0),(534578,14850,'ba','Apakah Anda yakin Anda ingin keluar dari Halaman ini?',0),(534579,14850,'nl','Weet u zeker dat u wilt navigeren uit de buurt van deze pagina?',0),(534580,14850,'fi','Oletko varma, ettÃ¤ haluat siirtyÃ¤ pois tÃ¤ltÃ¤ sivulta?',0),(534581,14850,'no','Er du sikker pÃ¥ at du vil navigere bort fra denne siden?',0),(534582,14850,'da','Er du sikker pÃ¥ du vil navigere vÃ¦k fra denne side?',0),(534583,14850,'ko','ë‹¹ì‹ ì€ì´ íŽ˜ì´ì§€ì—ì„œ ì´ë™ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(534584,14850,'he','? ××ª×” ×‘×˜×•×— ×©××ª×” ×¨×•×¦×” ×œ× ×•×•×˜ ×ž×—×•×¥ ×œ×“×£ ×–×”',0),(534585,14850,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î±Ï€Î¿Î¼Î±ÎºÏÏ…Î½Î¸ÎµÎ¯Ï„Îµ Î±Ï€ÏŒ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ»Î¯Î´Î±;',0),(534586,14850,'zh','æ˜¯å¦ç¡®å®žè¦ç¦»å¼€æ­¤é¡µé¢?',0),(534587,14850,'sv','Ã„r du sÃ¤ker du vill navigera frÃ¥n denna sida?',0),(534588,14850,'it','Sei sicuro di che voler passare lontano da questa pagina?',0),(534589,14850,'tl','',0),(534590,14850,'th','à¸„à¸¸à¸“à¹à¸™à¹ˆà¹ƒà¸ˆà¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸­à¸­à¸à¸ˆà¸²à¸à¹€à¸žà¸ˆà¸™à¸µà¹‰à¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(534591,14850,'hi','à¤•à¥à¤¯à¤¾ à¤†à¤ª à¤µà¤¾à¤•à¤ˆ à¤‡à¤¸ à¤ªà¥ƒà¤·à¥à¤  à¤¸à¥‡ à¤¦à¥‚à¤° à¤¨à¥‡à¤µà¥€à¤—à¥‡à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(534592,14850,'ms','Adakah anda pasti hendak meninggalkan halaman ini?',0),(534593,14850,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨Ø¹ÙŠØ¯Ø§Ù‹ Ø¹Ù† Ù‡Ø°Ù‡ Ø§Ù„ØµÙØ­Ø©ØŸ',0),(534594,14850,'fr','ÃŠtes-vous sÃ»r de que vouloir quitter cette page ?',0),(534595,14850,'jp','ã“ã®ãƒšãƒ¼ã‚¸ã‹ã‚‰ç§»å‹•ã—ã¦ã‚‚ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(534596,14850,'pt','Tem certeza que deseja navegar longe nesta pÃ¡gina?',0),(534597,14850,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÑ…Ð¾Ð´Ð¸Ñ‚Ðµ Ñ ÑÑ‚Ð¾Ð¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹?',0),(534598,14850,'es','Â¿EstÃ¡ seguro que desea desplazarse lejos de esta pÃ¡gina?',0),(534599,14850,'de','Bist du sicher, dass Sie diese Seite verlassen wollen?',0),(534600,14850,'en','Are you sure you want to navigate away from this page?',0),(534601,14851,'is','',0),(534602,14851,'dr','ØªÙ‡ÛŒÙ‡ Ø·Ø±Ø­',0),(534603,14851,'pr','ØªÙ‡ÛŒÙ‡ Ø·Ø±Ø­',0),(534604,14851,'tr','DÃ¼zeni hazÄ±rlanÄ±yor',0),(534605,14851,'pl','Przygotowanie ukÅ‚adu',0),(534606,14851,'bg','ÐŸÐ¾Ð´Ð³Ð¾Ñ‚Ð¾Ð²ÐºÐ° Ð½Ð° Ð¾Ñ„Ð¾Ñ€Ð¼Ð»ÐµÐ½Ð¸Ðµ',0),(534607,14851,'ur','Ù„Û’ Ø¢Ø¤Ù¹ ØªÛŒØ§Ø± Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(534608,14851,'sr','ÐŸÑ€Ð¸Ð¿Ñ€ÐµÐ¼Ð° Ñ€Ð°ÑÐ¿Ð¾Ñ€ÐµÐ´Ð°',0),(534609,14851,'vi','Chuáº©n bá»‹ bá»‘ trÃ­',0),(534610,14851,'af','Voorbereiding van uitleg',0),(534611,14851,'ro','PregÄƒtirea Layout',0),(534612,14851,'et','Ettevalmistamise skeem',0),(534613,14851,'si','Priprava postavitev',0),(534614,14851,'ba','Mempersiapkan tata letak',0),(534615,14851,'nl','Voorbereiding van de lay-out',0),(534616,14851,'fi','Valmistellaan asettelu',0),(534617,14851,'no','Forbereder oppsett',0),(534618,14851,'da','Forbereder Layout',0),(534619,14851,'ko','ë ˆì´ì•„ì›ƒì„ ì¤€ë¹„ í•˜ ê³ ',0),(534620,14851,'he','×”×›× ×ª ×¤×¨×™×¡×”',0),(534621,14851,'el','Î ÏÎ¿ÎµÏ„Î¿Î¹Î¼Î±ÏƒÎ¯Î± Î´Î¹Î¬Ï„Î±Î¾Î·',0),(534622,14851,'zh','å‡†å¤‡å¸ƒå±€',0),(534623,14851,'sv','FÃ¶rbereda Layout',0),(534624,14851,'it','Preparazione Layout',0),(534625,14851,'tl','',0),(534626,14851,'th','à¹€à¸•à¸£à¸µà¸¢à¸¡à¹€à¸„à¹‰à¸²à¹‚à¸„à¸£à¸‡',0),(534627,14851,'hi','à¤²à¥‡à¤†à¤‰à¤Ÿ à¤•à¥€ à¤¤à¥ˆà¤¯à¤¾à¤°à¥€',0),(534628,14851,'ms','Menyediakan susun atur',0),(534629,14851,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ ØªØ®Ø·ÙŠØ·',0),(534630,14851,'fr','PrÃ©parer la mise en page',0),(534631,14851,'jp','ãƒ¬ã‚¤ã‚¢ã‚¦ãƒˆã‚’æº–å‚™ã—ã¾ã™ã€‚',0),(534632,14851,'pt','Preparando o Layout',0),(534633,14851,'ru','ÐŸÐ¾Ð´Ð³Ð¾Ñ‚Ð¾Ð²ÐºÐ° Ð¼Ð°ÐºÐµÑ‚Ð°',0),(534634,14851,'es','PreparaciÃ³n de diseÃ±o',0),(534635,14851,'de','Vorbereitung Layout',0),(534636,14851,'en','Preparing Layout',0),(534637,14852,'is','',0),(534638,14852,'dr','3dcart Ù…ÙˆØ±Ø¯ Ø´Ù†Ø§Ø³Ù‡ Ø¢Ø®Ø±ÛŒÙ† Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ',0),(534639,14852,'pr','3dcart Ù…ÙˆØ±Ø¯ Ø´Ù†Ø§Ø³Ù‡ Ø¢Ø®Ø±ÛŒÙ† Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ',0),(534640,14852,'tr','Son alÄ±nan 3dcart Ã¶ÄŸesi kimlikleri',0),(534641,14852,'pl','3dcart pozycji ID ostatnio Å¹rÃ³dÅ‚o',0),(534642,14852,'bg','3dcart ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð˜Ð” Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸',0),(534643,14852,'ur','3dcart Ø´Û’ IDs Ú©Ùˆ Ø¢Ø®Ø±ÛŒ Ø¨Ø§Ø² Ú¯ÛŒØ±',0),(534644,14852,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð˜Ð”-Ð¾Ð²Ð° ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿ÑƒÑ‚ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð°',0),(534645,14852,'vi','3dcart má»¥c ID cuá»‘i Láº¥y',0),(534646,14852,'af','3dcart Item ID\'s laas herwin',0),(534647,14852,'ro','3dcart element de ID-uri de ultima Adus',0),(534648,14852,'et','3dcart kirje ID-d viimast toomist',0),(534649,14852,'si','3dcart ID-jev elementa zadnjiÄ pridobili',0),(534650,14852,'ba','3dcart Item id terakhir Diperoleh',0),(534651,14852,'nl','3dcart objectnummers worden opgenomen laatst ontvangen',0),(534652,14852,'fi','3dcart nimiketunnuksia viimeksi Haettu',0),(534653,14852,'no','3dcart element-IDene Hentet',0),(534654,14852,'da','3dcart element-id\'er sidst hentet',0),(534655,14852,'ko','ë§ˆì§€ë§‰ìœ¼ë¡œ ê²€ìƒ‰ í•œ 3dcart í•­ëª© Id',0),(534656,14852,'he','3dcart ×¤×¨×™×˜ ×ž×–×”×™ ×”××—×¨×•×Ÿ ×©××•×—×–×¨',0),(534657,14852,'el','3dcart Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î¿Ï… Î±Î½Î±ÎºÏ„Î®Î¸Î·ÎºÎ±Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î±',0),(534658,14852,'zh','ä¸Šæ¬¡æ£€ç´¢çš„ 3dcart é¡¹ Id',0),(534659,14852,'sv','3dcart objekt-ID: N senast HÃ¤mtad',0),(534660,14852,'it','3Dcart ID ultimo Estratto',0),(534661,14852,'tl','',0),(534662,14852,'th','à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸² 3dcart à¸¥à¹ˆà¸²à¸ªà¸¸à¸” à¹€à¸£à¸µà¸¢à¸',0),(534663,14852,'hi','3dcart à¤†à¤‡à¤Ÿà¤® IDs à¤…à¤‚à¤¤à¤¿à¤® à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(534664,14852,'ms','ID Item 3dcart buat Diambil',0),(534665,14852,'ar','Ù…Ø¹Ø±ÙØ§Øª Ø¹Ù†ØµØ± 3dcart Ø§Ø³ØªØ±Ø¯Ø§Ø¯Ù‡',0),(534666,14852,'fr','ID d\'Ã©lÃ©ment de 3Dcart derniÃ¨re extraction',0),(534667,14852,'jp','æœ€å¾Œã«å–å¾— 3dcart ã‚¢ã‚¤ãƒ†ãƒ  Id',0),(534668,14852,'pt','IDs de Item 3Dcart Ãºltima obtidas',0),(534669,14852,'ru','3dcart Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ñ‹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ñ',0),(534670,14852,'es','3DCart Item ID Ãºltimo obtenido',0),(534671,14852,'de','3dcart-Element-IDs, die zuletzt abgerufen',0),(534672,14852,'en','3dcart Item IDs Last Retrieved',0),(534673,14853,'is','',0),(534674,14853,'dr','3dcart Ø´Ù†Ø§Ø³Ù‡ Ø¢ÛŒØªÙ… Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(534675,14853,'pr','3dcart Ø´Ù†Ø§Ø³Ù‡ Ø¢ÛŒØªÙ… Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(534676,14853,'tr','3dcart Ã¶ÄŸesi kimlikleri baÅŸarÄ±yla alÄ±ndÄ±',0),(534677,14853,'pl','3dcart pozycji ID Å¹rÃ³dÅ‚o pomyÅ›lnie',0),(534678,14853,'bg','3dcart Ð˜Ð” Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(534679,14853,'ur','3dcart Ø´Û’ IDs Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ø§Ø² Ú¯ÛŒØ±',0),(534680,14853,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð˜Ð”-Ð¾Ð²Ð° ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(534681,14853,'vi','3dcart má»¥c ID láº¥y thÃ nh cÃ´ng',0),(534682,14853,'af','3dcart Item ID\'s suksesvol herwin',0),(534683,14853,'ro','3dcart ID element adus cu succes',0),(534684,14853,'et','3dcart kirje ID-d vÃ¤lja otsitud edukalt',0),(534685,14853,'si','3dcart element IDs uspeÅ¡no pridobljene.',0),(534686,14853,'ba','3dcart Item id diperoleh berhasil',0),(534687,14853,'nl','3dcart objectnummers worden opgenomen ontvangen met succes',0),(534688,14853,'fi','3dcart nimiketunnuksia onnistui',0),(534689,14853,'no','3dcart element-IDene vellykket',0),(534690,14853,'da','3dcart element-id\'er hentet med succes',0),(534691,14853,'ko','ì„±ê³µì ìœ¼ë¡œ ê²€ìƒ‰ í•˜ëŠ” 3dcart í•­ëª© Id',0),(534692,14853,'he','3dcart ×¤×¨×™×˜ ×ž×–×”×™ ×©××•×—×–×¨ ×‘×”×¦×œ×—×”',0),(534693,14853,'el','3dcart Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î±Î½Î±ÎºÏ„Î·Î¸ÎµÎ¯ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(534694,14853,'zh','æˆåŠŸæ£€ç´¢çš„ 3dcart é¡¹ Id',0),(534695,14853,'sv','3dcart objekt-ID: N HÃ¤mtad framgÃ¥ngsrikt',0),(534696,14853,'it','3Dcart ID elemento estratto con successo',0),(534697,14853,'tl','',0),(534698,14853,'th','à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸² 3dcart à¹€à¸£à¸µà¸¢à¸à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(534699,14853,'hi','3dcart à¤†à¤‡à¤Ÿà¤® IDs à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(534700,14853,'ms','3dcart ID Item yang diambil berjaya',0),(534701,14853,'ar','Ù…Ø¹Ø±ÙØ§Øª Ø¹Ù†ØµØ± 3dcart Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(534702,14853,'fr','ID d\'Ã©lÃ©ment 3Dcart extrait avec succÃ¨s',0),(534703,14853,'jp','æ­£å¸¸ã«å–å¾—ã•ã‚ŒãŸ 3dcart ã‚¢ã‚¤ãƒ†ãƒ  Id',0),(534704,14853,'pt','3Dcart IDs de Item recuperadas com Ãªxito',0),(534705,14853,'ru','3dcart Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ñ‹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð², ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ…',0),(534706,14853,'es','3DCart Item ID obtenido con Ã©xito',0),(534707,14853,'de','3dcart-Element-IDs, die erfolgreich abgerufenen',0),(534708,14853,'en','3dcart Item IDs Retrieved Successfully',0),(534709,14854,'is','',0),(534710,14854,'dr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† API Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª 3dcart Ú©Ø´ØªÛŒ',0),(534711,14854,'pr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† API Ù‡Ø§ÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´Ø§Øª 3dcart Ú©Ø´ØªÛŒ',0),(534712,14854,'tr','Gemi 3dcart sipariÅŸi iÃ§in geliÅŸmiÅŸ API etkinleÅŸtir',0),(534713,14854,'pl','WÅ‚Ä…cz zaawansowane API do zamÃ³wienia 3dcart',0),(534714,14854,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐ°Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¸ API ÐºÑŠÐ¼ ÐºÐ¾Ñ€Ð°Ð±Ð° 3dcart Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(534715,14854,'ur','Ø§Ø¹Ù„ÛŒ API Ø¬ÛØ§Ø² 3dcart Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ø§ÛÙ„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(534716,14854,'sr','ÐžÐ¼Ð¾Ð³ÑƒÑ›Ð¸ Ð½Ð°Ð¿Ñ€ÐµÐ´Ð½Ðµ ÐÐŸÐ˜ Ð±Ñ€Ð¾Ð´ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð° Ð·Ð°',0),(534717,14854,'vi','Sá»­ API tiÃªn tiáº¿n Ä‘á»ƒ Ä‘Æ¡n Ä‘áº·t hÃ ng 3dcart tÃ u',0),(534718,14854,'af','Aktiveer gevorderde API te skip 3dcart bestellings',0),(534719,14854,'ro','Permite avansate API pentru a navei 3dcart comenzi',0),(534720,14854,'et','Lubade kasutada tÃ¤iustatud API laeva 3dcart tellimused',0),(534721,14854,'si','OmogoÄi napredno API za 3dcart naroÄil za ladje',0),(534722,14854,'ba','Mengaktifkan Advanced API untuk kapal 3dcart pesanan',0),(534723,14854,'nl','Inschakelen van geavanceerde API aan schip 3dcart Orders',0),(534724,14854,'fi','Ota Advanced API alusten 3dcart tilausten',0),(534725,14854,'no','Aktivere avanserte API for Ã¥ 3dcart bestillinger',0),(534726,14854,'da','Aktivere avancerede API til 3dcart skibsordrer',0),(534727,14854,'ko','ë°° 3dcart ì£¼ë¬¸ ê³ ê¸‰ APIë¥¼ ì‚¬ìš© í•˜ë„ë¡ ì„¤ì •',0),(534728,14854,'he','×œ××¤×©×¨ API ×ž×ª×§×“×ž×•×ª ×”×¡×¤×™× ×” 3dcart ×œ×”×–×ž× ×•×ª',0),(534729,14854,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï€ÏÎ¿Î·Î³Î¼Î­Î½Ï‰Î½ API Î½Î± 3dcart Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Ï€Î»Î¿Î¯Ï‰Î½',0),(534730,14854,'zh','å¯ç”¨é«˜çº§çš„ API å¯¹èˆ¹èˆ¶ 3dcart è®¢å•',0),(534731,14854,'sv','Aktivera avancerade API till fartyget 3dcart order',0),(534732,14854,'it','Consentire la API avanzata nave 3dcart ordini',0),(534733,14854,'tl','',0),(534734,14854,'th','à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™ API à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ 3dcart',0),(534735,14854,'hi','à¤œà¤¹à¤¾à¤œ 3dcart à¤†à¤¦à¥‡à¤¶ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤¨à¥à¤¨à¤¤ API à¤¸à¤•à¥à¤·à¤® à¤•à¤°à¥‡à¤‚',0),(534736,14854,'ms','Membolehkan maju API untuk kapal 3dcart perintah',0),(534737,14854,'ar','ØªÙ…ÙƒÙŠÙ† API Ù…ØªÙ‚Ø¯Ù…Ø© Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø³ÙÙŠÙ†Ø© 3dcart',0),(534738,14854,'fr','Activer API avancÃ©e aux commandes de navires 3dcart',0),(534739,14854,'jp','èˆ¹ 3dcart æ³¨æ–‡ã™ã‚‹é«˜åº¦ãª API ã‚’æœ‰åŠ¹ã«ã—ã¾ã™ã€‚',0),(534740,14854,'pt','Habilitar a API avanÃ§ada a nave 3dcart ordens',0),(534741,14854,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ð¹ API Ð´Ð»Ñ ÐºÐ¾Ñ€Ð°Ð±Ð»Ñ 3dcart Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(534742,14854,'es','Habilitar avanzada API para nave 3dcart Ã³rdenes',0),(534743,14854,'de','Aktivieren Sie erweiterte API zum Schiff 3dcart Bestellungen',0),(534744,14854,'en','Enable Advanced API To Ship 3dcart Orders',0),(534745,14855,'is','',0),(534746,14855,'dr','Ø¯Ø±ÛŒØ§ÙØª Ø´Ù†Ø§Ø³Ù‡ Ù…ÙˆØ±Ø¯ 3dcart',0),(534747,14855,'pr','Ø¯Ø±ÛŒØ§ÙØª Ø´Ù†Ø§Ø³Ù‡ Ù…ÙˆØ±Ø¯ 3dcart',0),(534748,14855,'tr','3dcart Ã¶ÄŸesi kimlikleri almak',0),(534749,14855,'pl','UzyskaÄ‡ identyfikatory elementu 3dcart',0),(534750,14855,'bg','Ð’Ð·ÐµÐ¼Ð¸ 3dcart Ð˜Ð” Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(534751,14855,'ur','3dcart Ø´Û’ Ø´Ù†Ø§Ø®Øª Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(534752,14855,'sr','ÐŸÐ¾ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð˜Ð”-Ð¾Ð²Ð° ÑÑ‚Ð°Ð²ÐºÐ¸',0),(534753,14855,'vi','Nháº­n Ä‘Æ°á»£c 3dcart má»¥c ID',0),(534754,14855,'af','Kry 3dcart Item ID\'s',0),(534755,14855,'ro','ObÅ£ine 3dcart ID-urile de element',0),(534756,14855,'et','Saada 3dcart kirje ID',0),(534757,14855,'si','Get ID 3dcart elementov',0),(534758,14855,'ba','Dapatkan ID Item 3dcart',0),(534759,14855,'nl','Krijgen 3dcart Item-id \'s',0),(534760,14855,'fi','Hanki 3dcart nimiketunnuksia',0),(534761,14855,'no','FÃ¥ 3dcart-element-IDene',0),(534762,14855,'da','FÃ¥ 3dcart element-id\'er',0),(534763,14855,'ko','3dcart í•­ëª© Idë¥¼ ì–»ì„',0),(534764,14855,'he','×œ×”×©×™×’ 3dcart ×¤×¨×™×˜ ×ž×–×”×™',0),(534765,14855,'el','Î Î¬ÏÎµÏ„Îµ Ï„Î± Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ 3dcart',0),(534766,14855,'zh','èŽ·å¾— 3dcart é¡¹ç›® Id',0),(534767,14855,'sv','FÃ¥ 3dcart objekt-ID: N',0),(534768,14855,'it','Ottenere l\'ID di elemento 3dcart',0),(534769,14855,'tl','',0),(534770,14855,'th','à¸£à¸±à¸šà¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸² 3dcart',0),(534771,14855,'hi','3dcart à¤†à¤‡à¤Ÿà¤® IDs à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(534772,14855,'ms','Mendapatkan ID Item 3dcart',0),(534773,14855,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù…Ø¹Ø±ÙØ§Øª Ø¹Ù†ØµØ± 3dcart',0),(534774,14855,'fr','Obtenir l\'ID d\'Ã©lÃ©ment 3dcart',0),(534775,14855,'jp','3dcart ã‚¢ã‚¤ãƒ†ãƒ  Id ã‚’å–å¾—ã—ã¾ã™ã€‚',0),(534776,14855,'pt','3dcart Item identidades',0),(534777,14855,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ñ‹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² 3dcart',0),(534778,14855,'es','Conseguir 3dcart Item ID',0),(534779,14855,'de','3dcart Element-IDs zu bekommen',0),(534780,14855,'en','Get 3dcart Item IDs',0),(534781,14856,'is','',0),(534782,14856,'dr','Ø¯Ø±ÛŒØ§ÙØª Ø´Ù†Ø§Ø³Ù‡ Ù…ÙˆØ±Ø¯ 3dcart Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ ØªØ§ Ù„ÛŒÙ†Ú© Ø¯Ø§Ø¯Ù† Ø¨Ù‡ ØµÙØ­Ù‡ Ù…Ø­ØµÙˆÙ„ 3dcart',0),(534783,14856,'pr','Ø¯Ø±ÛŒØ§ÙØª Ø´Ù†Ø§Ø³Ù‡ Ù…ÙˆØ±Ø¯ 3dcart Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ ØªØ§ Ù„ÛŒÙ†Ú© Ø¯Ø§Ø¯Ù† Ø¨Ù‡ ØµÙØ­Ù‡ Ù…Ø­ØµÙˆÙ„ 3dcart',0),(534784,14856,'tr','3dcart Ã¼rÃ¼n sayfasÄ±na baÄŸlantÄ± saÄŸlamak iÃ§in 3dcart Ã¶ÄŸesi kimlikleri almak',0),(534785,14856,'pl','UzyskaÄ‡ identyfikatory elementu 3dcart pozwalajÄ…ce na powiÄ…zanie do strony produktu 3dcart',0),(534786,14856,'bg','Ð’Ð·ÐµÐ¼Ð¸ 3dcart Ð˜Ð” Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð´Ð° Ð¿Ð¾Ð·Ð²Ð¾Ð»ÑÐ²Ð° ÑÐ²ÑŠÑ€Ð·Ð²Ð°Ð½Ðµ ÐºÑŠÐ¼ 3dcart Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(534787,14856,'ur','3dcart Ù…ØµÙ†ÙˆØ¹Ø§Øª ØµÙØ­Û Ù¾Ø± Ø±Ø¨Ø· Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª 3dcart Ø´Û’ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(534788,14856,'sr','ÐŸÐ¾ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð˜Ð”-Ð¾Ð²Ð° ÑÑ‚Ð°Ð²ÐºÐ¸ Ð´Ð° Ð¾Ð¼Ð¾Ð³ÑƒÑ›Ð°Ð²Ð° Ð¿Ð¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐµ ÑÐ° 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(534789,14856,'vi','Nháº­n Ä‘Æ°á»£c 3dcart má»¥c ID cho phÃ©p liÃªn káº¿t Ä‘áº¿n trang sáº£n pháº©m 3dcart',0),(534790,14856,'af','Kry 3dcart Item ID\'s om skakeling te 3dcart produk bladsy',0),(534791,14856,'ro','ObÅ£ine 3dcart ID element pentru a permite conectarea la pagina de produs 3dcart',0),(534792,14856,'et','Saada 3dcart kirje ID-d oleks vÃµimalik 3dcart toote Page',0),(534793,14856,'si','Get 3dcart element ID omogoÄiti povezovanje 3dcart proizvod stran',0),(534794,14856,'ba','Dapatkan ID Item 3dcart untuk memungkinkan menghubungkan ke halaman produk 3dcart',0),(534795,14856,'nl','Krijgen 3dcart Item-id\'s te koppelen aan 3dcart productpagina',0),(534796,14856,'fi','Hanki 3dcart nimiketunnuksia salli linkittÃ¤Ã¤ 3dcart tuotesivu',0),(534797,14856,'no','FÃ¥ 3dcart-element-IDene til tillater kobling til 3dcart siden',0),(534798,14856,'da','FÃ¥ 3dcart element-id\'er til at tillade forbinder til 3dcart produktside',0),(534799,14856,'ko','3dcart ì œí’ˆ íŽ˜ì´ì§€ì— ì—°ê²°ì„ í—ˆìš© í•˜ë„ë¡ 3dcart í•­ëª© Idë¥¼ ì–»ì„',0),(534800,14856,'he','×œ×”×©×™×’ 3dcart ×ž×–×”×™× ×¤×¨×™×˜ ×›×“×™ ×œ××¤×©×¨ ×§×™×©×•×¨ ×œ×“×£ ×”×ž×•×¦×¨ 3dcart',0),(534801,14856,'el','Î Î¬ÏÎµÏ„Îµ Ï„Î± Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ 3dcart Î½Î± ÎµÏ€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î· ÏƒÏÎ½Î´ÎµÏƒÎ· Î¼Îµ Ï„Î· ÏƒÎµÎ»Î¯Î´Î± Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚ 3dcart',0),(534802,14856,'zh','èŽ·å¾— 3dcart é¡¹ç›® Idï¼Œä»¥ä¾¿é“¾æŽ¥åˆ° 3dcart äº§å“é¡µé¢',0),(534803,14856,'sv','FÃ¥ 3dcart objekt-ID: N fÃ¶r att lÃ¤nka till 3dcart produktsida',0),(534804,14856,'it','Ottenere l\'ID di elemento 3dcart per consentire il collegamento alla pagina del prodotto 3dcart',0),(534805,14856,'tl','',0),(534806,14856,'th','à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸² 3dcart à¹ƒà¸«à¹‰à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡à¹„à¸›à¸—à¸µà¹ˆà¸«à¸™à¹‰à¸²à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¸£à¸¸à¹ˆà¸™ 3dcart à¹„à¸”à¹‰à¸£à¸±à¸š',0),(534807,14856,'hi','3dcart à¤†à¤‡à¤Ÿà¤® IDs 3dcart à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤“',0),(534808,14856,'ms','Mendapatkan ID Item 3dcart untuk membolehkan membuat pautan ke laman produk 3dcart',0),(534809,14856,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù…Ø¹Ø±ÙØ§Øª Ø¹Ù†ØµØ± 3dcart Ù„Ù„Ø³Ù…Ø§Ø­ Ø±Ø¨Ø· Ø¥Ù„Ù‰ ØµÙØ­Ø© Ø§Ù„Ù…Ù†ØªØ¬ 3dcart',0),(534810,14856,'fr','Obtenir l\'ID d\'Ã©lÃ©ment 3dcart pour permettre de relier Ã  la fiche 3dcart',0),(534811,14856,'jp','3dcart è£½å“ãƒšãƒ¼ã‚¸ã¸ã®ãƒªãƒ³ã‚¯ã‚’è¨±å¯ã™ã‚‹ 3dcart é …ç›® Id ã‚’å–å¾—ã—ã¾ã™ã€‚',0),(534812,14856,'pt','3dcart Item identidades para permitir a ligaÃ§Ã£o Ã  pÃ¡gina do produto 3dcart',0),(534813,14856,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ 3dcart Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð¾Ð² ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð´Ð»Ñ ÑÐ²ÑÐ·Ñ‹Ð²Ð°Ð½Ð¸Ñ 3dcart ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(534814,14856,'es','Conseguir 3dcart Item ID para permitir vincular 3dcart pÃ¡gina del producto',0),(534815,14856,'de','3dcart Element-IDs zu ermÃ¶glichen, Anbindung an 3dcart-Produkt-Seite zu erhalten',0),(534816,14856,'en','Get 3dcart Item IDs To Allow Linking To 3dcart Product Page',0),(534817,14857,'is','',0),(534818,14857,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ù…ÙˆØ§Ø±Ø¯',0),(534819,14857,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ù…ÙˆØ§Ø±Ø¯',0),(534820,14857,'tr','Ã–ÄŸeleri almak mÃ¼mkÃ¼n deÄŸil',0),(534821,14857,'pl','Nie wypÅ‚acalny odzyskiwaÄ‡ przedmioty',0),(534822,14857,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(534823,14857,'ur','Ø§Ø´ÛŒØ§ Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù‚Ø§Ø¨Ù„ Ù†ÛÛŒÚº',0),(534824,14857,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ',0),(534825,14857,'vi','KhÃ´ng thá»ƒ truy xuáº¥t khoáº£n má»¥c',0),(534826,14857,'af','Nie in staat om Items te herwin',0),(534827,14857,'ro','Nu sunt Ã®n mÄƒsurÄƒ pentru a prelua elemente',0),(534828,14857,'et','Ei ole vÃµimalik Ã¼ksused alla laadida',0),(534829,14857,'si','Ne more pridobiti elementov',0),(534830,14857,'ba','Tidak mampu mengambil item',0),(534831,14857,'nl','Niet in staat om Items te halen',0),(534832,14857,'fi','Ei voi hakea kohteita',0),(534833,14857,'no','Kan ikke hente elementer',0),(534834,14857,'da','Ikke i stand til at hente elementer',0),(534835,14857,'ko','í•­ëª©ì„ ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(534836,14857,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ××—×–×¨ ×¤×¨×™×˜×™×',0),(534837,14857,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÎµ Î¸Î­ÏƒÎ· Î½Î± Î±Î½Î±ÎºÏ„Î®ÏƒÎµÎ¹ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(534838,14857,'zh','ä¸èƒ½æ£€ç´¢é¡¹',0),(534839,14857,'sv','Inte kunna hÃ¤mta objekt',0),(534840,14857,'it','Non in grado di recuperare gli elementi',0),(534841,14857,'tl','',0),(534842,14857,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸£à¸µà¸¢à¸à¸£à¸²à¸¢à¸à¸²à¸£',0),(534843,14857,'hi','à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¸à¤•à¥à¤·à¤® à¤¨à¤¹à¥€à¤‚',0),(534844,14857,'ms','Tidak mampu untuk mengambil barang-barang',0),(534845,14857,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(534846,14857,'fr','Pas en mesure d\'extraire des Ã©lÃ©ments',0),(534847,14857,'jp','é …ç›®ã‚’å–å¾—ã™ã‚‹ã«ã¯ã€ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(534848,14857,'pt','NÃ£o Ã© capaz de recuperar itens',0),(534849,14857,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¸Ð·Ð²Ð»ÐµÑ‡ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹',0),(534850,14857,'es','No es capaz de recuperar artÃ­culos',0),(534851,14857,'de','Nicht in der Lage Elemente ab',0),(534852,14857,'en','Not Able To Retrieve Items',0),(534853,14858,'is','',0),(534854,14858,'dr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¯Ø± Ú©Ø§Ø±ØªØ®ÙˆØ§Ù† Ù‡Ù…Ø±Ø§Ù‡',0),(534855,14858,'pr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¯Ø± Ú©Ø§Ø±ØªØ®ÙˆØ§Ù† Ù‡Ù…Ø±Ø§Ù‡',0),(534856,14858,'tr','Mobil POS mÃ¼ÅŸteriler gÃ¶steri',0),(534857,14858,'pl','PokaÅ¼ klientÃ³w na mobilnych POS',0),(534858,14858,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð½Ð° Ð¼Ð¾Ð±Ð¸Ð»Ð½Ð¸ ÐŸÐžÐ¡',0),(534859,14858,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©Ùˆ Ù…ÙˆØ¨Ø§Ø¦Ù„ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(534860,14858,'sr','ÐšÑƒÐ¿Ñ†Ð¸ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð½Ð° Ð¼Ð¾Ð±Ð¸Ð»Ð½Ð¸Ð¼ ÐŸÐžÐ¡',0),(534861,14858,'vi','Hiá»ƒn thá»‹ khÃ¡ch trÃªn Ä‘iá»‡n thoáº¡i di Ä‘á»™ng POS',0),(534862,14858,'af','KliÃ«nte wys op mobiele POS',0),(534863,14858,'ro','ClienÅ£ii AratÄƒ pe mobil POS',0),(534864,14858,'et','Hotelli NÃ¤ita mobiilne POS',0),(534865,14858,'si','Stranke, kaÅ¾ejo na mobilne POS',0),(534866,14858,'ba','Lihat pelanggan Mobile POS',0),(534867,14858,'nl','Klanten Toon op mobiele POS',0),(534868,14858,'fi','Asiakkaat NÃ¤ytÃ¤ mobiili POS',0),(534869,14858,'no','Kundene Vis pÃ¥ Mobile POS',0),(534870,14858,'da','Kunder Vis pÃ¥ Mobile POS',0),(534871,14858,'ko','ëª¨ë°”ì¼ POSì— ê³ ê° ë³´ê¸°',0),(534872,14858,'he','×”×œ×§×•×—×•×ª ×œ×”×¨××•×ª ×¢×œ ×§×•×¤×” × ×™×™×“',0),(534873,14858,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÎºÎ¹Î½Î·Ï„Î®Ï‚ Î­Î³Î³',0),(534874,14858,'zh','åœ¨ç§»åŠ¨ç»ˆç«¯ä¸Šæ˜¾ç¤ºçš„å®¢æˆ·',0),(534875,14858,'sv','Kunder Visa pÃ¥ Mobile POS',0),(534876,14858,'it','Visualizza clienti POS Mobile',0),(534877,14858,'tl','',0),(534878,14858,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸”à¸¹à¸šà¸™à¸¡à¸·à¸­à¸–à¸·à¸­ POS',0),(534879,14858,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤®à¥‹à¤¬à¤¾à¤‡à¤² POS à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(534880,14858,'ms','Tunjuk POS mudah alih pelanggan',0),(534881,14858,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ ÙÙŠ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ù…ØªÙ†Ù‚Ù„Ø©',0),(534882,14858,'fr','Les visiteurs se montrent sur Mobile POS',0),(534883,14858,'jp','ãƒ¢ãƒã‚¤ãƒ« POS ã®é¡§å®¢ã‚·ãƒ§ãƒ¼',0),(534884,14858,'pt','Clientes Visualizar no POS mÃ³vel',0),(534885,14858,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹ Ð´ÐµÐ¼Ð¾Ð½ÑÑ‚Ñ€Ð¸Ñ€ÑƒÑŽÑ‚ Ð½Ð° Ð¼Ð¾Ð±Ð¸Ð»ÑŒÐ½Ñ‹Ðµ POS',0),(534886,14858,'es','Los clientes ver POS mÃ³viles',0),(534887,14858,'de','Kunden, die auf Mobile POS anzeigen',0),(534888,14858,'en','Customers Show On Mobile POS',0),(534889,14859,'is','',0),(534890,14859,'dr','Pmt Ø¨ÛŒÙ„ Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³',0),(534891,14859,'pr','Pmt Ø¨ÛŒÙ„ Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³',0),(534892,14859,'tr','AP Bill Devresel Ã¶deme',0),(534893,14859,'pl','AP Bill Pmt',0),(534894,14859,'bg','AP Ð±Ð¸Ð» Pmt',0),(534895,14859,'ur','AP Ø¨Ù„ Ù¾Ù…Ù¹',0),(534896,14859,'sr','ÐÐŸ Ð‘Ð¸Ð»Ð» ÐŸÐ¼Ñ‚',0),(534897,14859,'vi','AP Bill Pmt',0),(534898,14859,'af','GP Wetsontwerp Pmt',0),(534899,14859,'ro','AP Bill Pmt',0),(534900,14859,'et','AP arve makse',0),(534901,14859,'si','AP Bill Pmt',0),(534902,14859,'ba','AP Bill Pmt',0),(534903,14859,'nl','AP Bill Pmt',0),(534904,14859,'fi','AP laskun erÃ¤',0),(534905,14859,'no','AP Bill avdrag',0),(534906,14859,'da','AP Bill ydelse',0),(534907,14859,'ko','AP ë¹Œ Pmt',0),(534908,14859,'he','AP ×‘×™×œ Pmt',0),(534909,14859,'el','AP Bill Pmt',0),(534910,14859,'zh','ç¾Žè”ç¤¾æ¯”å°” Pmt',0),(534911,14859,'sv','AP Bill betalning',0),(534912,14859,'it','AP Bill Pmt',0),(534913,14859,'tl','',0),(534914,14859,'th','Pmt à¸•à¸±à¹‹à¸§ AP',0),(534915,14859,'hi','à¤à¤ªà¥€ à¤µà¤¿à¤§à¥‡à¤¯à¤• Pmt',0),(534916,14859,'ms','AP bil Pmt',0),(534917,14859,'ar','Pmt Ø¨ÙŠÙ„ AP',0),(534918,14859,'fr','AP Bill Pmt',0),(534919,14859,'jp','Ap é€šä¿¡æ³•æ¡ˆå…‰é›»å­å¢—å€ç®¡',0),(534920,14859,'pt','AP Bill Pmt',0),(534921,14859,'ru','AP Ð‘Ð¸Ð»Ð» ÐŸÐ›Ð¢',0),(534922,14859,'es','AP Bill Pmt',0),(534923,14859,'de','AP Bill Pmt',0),(534924,14859,'en','AP Bill Pmt',0),(534925,14860,'is','',0),(534926,14860,'dr','Ø¯Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ®',0),(534927,14860,'pr','Ø¯Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ®',0),(534928,14860,'tr','Toplu iÅŸlem tarihi',0),(534929,14860,'pl','Partia Data',0),(534930,14860,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð°Ñ€Ñ‚Ð¸Ð´Ð°',0),(534931,14860,'ur','Ø¨ÛŒÚ† Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(534932,14860,'sr','Ð“Ñ€ÑƒÐ¿Ð½Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼',0),(534933,14860,'vi','LÃ´ ngÃ y',0),(534934,14860,'af','Bondel datum',0),(534935,14860,'ro','Lot data',0),(534936,14860,'et','Partii kuupÃ¤ev',0),(534937,14860,'si','Serija datum',0),(534938,14860,'ba','Batch tanggal',0),(534939,14860,'nl','Batch datum',0),(534940,14860,'fi','ErÃ¤n pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(534941,14860,'no','Satsvise dato',0),(534942,14860,'da','Batchdato',0),(534943,14860,'ko','ì¼ê´„ ì²˜ë¦¬ ë‚ ì§œ',0),(534944,14860,'he','×ª××¨×™×š ××¦×•×•×”',0),(534945,14860,'el','ÎœÎ±Î¶Î¹ÎºÎ® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(534946,14860,'zh','æ‰¹æ¬¡æ—¥æœŸ',0),(534947,14860,'sv','Batchdatum',0),(534948,14860,'it','Lotto Data',0),(534949,14860,'tl','',0),(534950,14860,'th','à¸§à¸±à¸™à¸Šà¸¸à¸”à¸‡à¸²à¸™',0),(534951,14860,'hi','à¤¬à¥ˆà¤š à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(534952,14860,'ms','Tarikh Kumpulan',0),(534953,14860,'ar','ØªØ§Ø±ÙŠØ® Ø¯ÙØ¹Ø©',0),(534954,14860,'fr','Date de traitement par lots',0),(534955,14860,'jp','ãƒãƒƒãƒæ—¥ä»˜',0),(534956,14860,'pt','Lote data',0),(534957,14860,'ru','ÐŸÐ°ÐºÐµÑ‚Ð½Ñ‹Ð¹ Ð”Ð°Ñ‚Ð°',0),(534958,14860,'es','Lote fecha',0),(534959,14860,'de','Batch-Datum',0),(534960,14860,'en','Batch Date',0),(534961,14861,'is','',0),(534962,14861,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¯Ø³ØªÙ‡',0),(534963,14861,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¯Ø³ØªÙ‡',0),(534964,14861,'tr','Bordro DÃ¶kÃ¼mÃ¼',0),(534965,14861,'pl','Partia raportu',0),(534966,14861,'bg','ÐŸÐ°ÐºÐµÑ‚Ð½Ð¾ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(534967,14861,'ur','Ø¨ÛŒÚ† Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(534968,14861,'sr','Ð“Ñ€ÑƒÐ¿Ð½Ð¾ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(534969,14861,'vi','HÃ ng loáº¡t bÃ¡o cÃ¡o',0),(534970,14861,'af','Bondel verslag',0),(534971,14861,'ro','Lot raport',0),(534972,14861,'et','Partii aruanne',0),(534973,14861,'si','Serija poroÄilo',0),(534974,14861,'ba','Batch laporan',0),(534975,14861,'nl','Batch verslag',0),(534976,14861,'fi','ErÃ¤raportin',0),(534977,14861,'no','Satsvise rapport',0),(534978,14861,'da','Batchrapport',0),(534979,14861,'ko','ì¼ê´„ ì²˜ë¦¬ ë³´ê³ ì„œ',0),(534980,14861,'he','×“×™×•×•×— ××¦×•×•×”',0),(534981,14861,'el','ÎœÎ±Î¶Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ·',0),(534982,14861,'zh','æ‰¹æ¬¡æŠ¥å‘Š',0),(534983,14861,'sv','Batch rapport',0),(534984,14861,'it','Rapporto batch',0),(534985,14861,'tl','',0),(534986,14861,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸Šà¸¸à¸”à¸‡à¸²à¸™',0),(534987,14861,'hi','à¤¬à¥ˆà¤š à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(534988,14861,'ms','Laporan Kumpulan',0),(534989,14861,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹Ø©',0),(534990,14861,'fr','Lot rapport',0),(534991,14861,'jp','ãƒãƒƒãƒ ãƒ¬ãƒãƒ¼ãƒˆ',0),(534992,14861,'pt','RelatÃ³rio de lote',0),(534993,14861,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð¾ Ð¿Ð°ÐºÐµÑ‚Ðµ',0),(534994,14861,'es','Informe por lotes',0),(534995,14861,'de','Batch-Report',0),(534996,14861,'en','Batch Report',0),(534997,14862,'is','',0),(534998,14862,'dr','Ù†ÙˆØ¹ Ø¯Ø³ØªÙ‡',0),(534999,14862,'pr','Ù†ÙˆØ¹ Ø¯Ø³ØªÙ‡',0),(535000,14862,'tr','Toplu iÅŸ tÃ¼rÃ¼',0),(535001,14862,'pl','Partia typu',0),(535002,14862,'bg','Ð”Ð¾Ð·Ð°Ñ‚Ð¾Ñ€Ð¸',0),(535003,14862,'ur','Ø¨ÛŒÚ† Ú©ÛŒ Ù‚Ø³Ù…',0),(535004,14862,'sr','Ð¢Ð¸Ð¿ Ð³Ñ€ÑƒÐ¿Ðµ',0),(535005,14862,'vi','HÃ ng loáº¡t loáº¡i',0),(535006,14862,'af','Bondel tipe',0),(535007,14862,'ro','Tipul de lot',0),(535008,14862,'et','Partii liik',0),(535009,14862,'si','Paketna vrsta',0),(535010,14862,'ba','Tipe batch',0),(535011,14862,'nl','Batch Type',0),(535012,14862,'fi','ErÃ¤n tyyppi',0),(535013,14862,'no','Satsvise Type',0),(535014,14862,'da','Batch Type',0),(535015,14862,'ko','ì¼ê´„ ì²˜ë¦¬ ìœ í˜•',0),(535016,14862,'he','×¡×•×’ ××¦×•×•×”',0),(535017,14862,'el','Î¤ÏÏ€Î¿Ï‚ Ï€Î±ÏÏ„Î¯Î´Î±Ï‚',0),(535018,14862,'zh','æ‰¹å¤„ç†ç±»åž‹',0),(535019,14862,'sv','Batch typ',0),(535020,14862,'it','Tipo di lotto',0),(535021,14862,'tl','',0),(535022,14862,'th','à¸Šà¸™à¸´à¸”à¸Šà¸¸à¸”',0),(535023,14862,'hi','à¤¬à¥ˆà¤š à¤ªà¥à¤°à¤•à¤¾à¤°',0),(535024,14862,'ms','Jenis Kumpulan',0),(535025,14862,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹Ø©',0),(535026,14862,'fr','Type de lot',0),(535027,14862,'jp','ãƒãƒƒãƒå¼',0),(535028,14862,'pt','Tipo de lote',0),(535029,14862,'ru','Ð¢Ð¸Ð¿ Ð¿Ð°ÐºÐµÑ‚Ð¾Ð²',0),(535030,14862,'es','Tipo de lote',0),(535031,14862,'de','Im Batch',0),(535032,14862,'en','Batch Type',0),(535033,14863,'is','',0),(535034,14863,'dr','Ù…Ø´ØªØ±ÛŒ/ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(535035,14863,'pr','Ù…Ø´ØªØ±ÛŒ/ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(535036,14863,'tr','MÃ¼ÅŸteri/SatÄ±cÄ±',0),(535037,14863,'pl','Odbiorcy/dostawcy',0),(535038,14863,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚/Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(535039,14863,'ur','Ú¯Ø§ÛÚ©/ÙØ±ÙˆØ´Ù†Ø¯Û',0),(535040,14863,'sr','ÐšÑƒÐ¿Ñ†Ð°/Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(535041,14863,'vi','KhÃ¡ch hÃ ng/nhÃ  cung cáº¥p',0),(535042,14863,'af','KliÃ«nt/handelaar',0),(535043,14863,'ro','Client/furnizor',0),(535044,14863,'et','Kliendi/hankija',0),(535045,14863,'si','Kupec/dobavitelj',0),(535046,14863,'ba','Pelanggan/Vendor',0),(535047,14863,'nl','Klant/leverancier',0),(535048,14863,'fi','Asiakkaan tai toimittajan',0),(535049,14863,'no','Kunde/leverandÃ¸r',0),(535050,14863,'da','Kunde/leverandÃ¸r',0),(535051,14863,'ko','ê³ ê°/ê³µê¸‰ ì—…ì²´',0),(535052,14863,'he','×œ×§×•×—/×¡×¤×§',0),(535053,14863,'el','Î ÎµÎ»Î¬Ï„Î·/Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(535054,14863,'zh','å®¢æˆ·/ä¾›åº”å•†',0),(535055,14863,'sv','Kund/leverantÃ¶r',0),(535056,14863,'it','Cliente/fornitore',0),(535057,14863,'tl','',0),(535058,14863,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²/à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(535059,14863,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•/à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(535060,14863,'ms','Pelanggan/Penjual',0),(535061,14863,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„/Ø§Ù„Ù…ÙˆØ±Ø¯',0),(535062,14863,'fr','Client/fournisseur',0),(535063,14863,'jp','é¡§å®¢/ä»•å…¥å…ˆ',0),(535064,14863,'pt','Cliente/fornecedor',0),(535065,14863,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‡Ð¸Ðº/Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº',0),(535066,14863,'es','Cliente/proveedor',0),(535067,14863,'de','Debitor/Kreditor',0),(535068,14863,'en','Customer/Vendor',0),(535069,14864,'is','',0),(535070,14864,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† JM & R',0),(535071,14864,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† JM & R',0),(535072,14864,'tr','JM & R gizle',0),(535073,14864,'pl','Ukryj JM & R',0),(535074,14864,'bg','Ð¡ÐºÑ€Ð¸Ð¹ JM & R',0),(535075,14864,'ur','Ø¬Ù… & R Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(535076,14864,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÐˆÐœ & Ð ',0),(535077,14864,'vi','áº¨n JM & R',0),(535078,14864,'af','Versteek JM & R',0),(535079,14864,'ro','Ascunde JM & R',0),(535080,14864,'et','Peida JM & R',0),(535081,14864,'si','Skrij JM & R',0),(535082,14864,'ba','Menyembunyikan JM & R',0),(535083,14864,'nl','Verbergen JM & R',0),(535084,14864,'fi','Piilota JM & R',0),(535085,14864,'no','Skjule JM & R',0),(535086,14864,'da','Skjule JM & Rasmussen',0),(535087,14864,'ko','JM & R ìˆ¨ê¸°ê¸°',0),(535088,14864,'he','×”×¡×ª×¨ JM & R',0),(535089,14864,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· JM & R',0),(535090,14864,'zh','éšè— JM & R',0),(535091,14864,'sv','DÃ¶lja JM & R',0),(535092,14864,'it','Nascondere JM & R',0),(535093,14864,'tl','',0),(535094,14864,'th','à¸‹à¹ˆà¸­à¸™ JM & R',0),(535095,14864,'hi','à¤œà¥‡à¤à¤® & R à¤›à¥à¤ªà¤¾à¤à¤',0),(535096,14864,'ms','Sembunyi JM & R',0),(535097,14864,'ar','Ø¥Ø®ÙØ§Ø¡ JM Ø¢Ù†Ø¯ R',0),(535098,14864,'fr','Cacher JM & R',0),(535099,14864,'jp','JM & R ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(535100,14864,'pt','Esconder JM & R',0),(535101,14864,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ JM & R',0),(535102,14864,'es','Ocultar JM & R',0),(535103,14864,'de','Ausblenden von JM & R',0),(535104,14864,'en','Hide JM&R',0),(535105,14865,'is','',0),(535106,14865,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† ØµØ§Ø­Ø¨Ø§Ù†',0),(535107,14865,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† ØµØ§Ø­Ø¨Ø§Ù†',0),(535108,14865,'tr','Sahipleri gizle',0),(535109,14865,'pl','Ukryj wÅ‚aÅ›cicieli',0),(535110,14865,'bg','Ð¡ÐºÑ€Ð¸Ð¹ ÑÐ¾Ð±ÑÑ‚Ð²ÐµÐ½Ð¸Ñ†Ð¸',0),(535111,14865,'ur','Ù…Ø§Ù„Ú©Ø§Ù† Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(535112,14865,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð²Ð»Ð°ÑÐ½Ð¸Ñ†Ð¸',0),(535113,14865,'vi','áº¨n chá»§ sá»Ÿ há»¯u',0),(535114,14865,'af','Versteek eienaars',0),(535115,14865,'ro','Ascunde proprietari',0),(535116,14865,'et','Peida omanikud',0),(535117,14865,'si','Skriti lastniki',0),(535118,14865,'ba','Menyembunyikan pemilik',0),(535119,14865,'nl','Verbergen van eigenaars',0),(535120,14865,'fi','Piilota omistajat',0),(535121,14865,'no','Skjule eiere',0),(535122,14865,'da','Skjule ejere',0),(535123,14865,'ko','ì†Œìœ ìžë¥¼ ìˆ¨ê¸°ê¸°',0),(535124,14865,'he','×œ×”×¡×ª×™×¨ ××ª ×‘×¢×œ×™',0),(535125,14865,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î¹Î´Î¹Î¿ÎºÏ„Î®Ï„ÎµÏ‚',0),(535126,14865,'zh','éšè—ä¸šä¸»',0),(535127,14865,'sv','DÃ¶lja Ã¤gare',0),(535128,14865,'it','Nascondere i proprietari',0),(535129,14865,'tl','',0),(535130,14865,'th','à¸‹à¹ˆà¸­à¸™à¹€à¸ˆà¹‰à¸²',0),(535131,14865,'hi','à¤®à¤¾à¤²à¤¿à¤•à¥‹à¤‚ à¤•à¥‹ à¤›à¤¿à¤ªà¤¾à¤¨à¥‡',0),(535132,14865,'ms','Menyembunyikan pemilik',0),(535133,14865,'ar','Ø¥Ø®ÙØ§Ø¡ Ø£ØµØ­Ø§Ø¨',0),(535134,14865,'fr','Masquer les propriÃ©taires',0),(535135,14865,'jp','æ‰€æœ‰è€…ã‚’éš ã™',0),(535136,14865,'pt','Esconder os proprietÃ¡rios',0),(535137,14865,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð²Ð»Ð°Ð´ÐµÐ»ÑŒÑ†ÐµÐ²',0),(535138,14865,'es','Ocultar los propietarios',0),(535139,14865,'de','EigentÃ¼mer zu verstecken',0),(535140,14865,'en','Hide Owners',0),(535141,14866,'is','',0),(535142,14866,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† RPR',0),(535143,14866,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† RPR',0),(535144,14866,'tr','RPR gizle',0),(535145,14866,'pl','Ukryj RPR',0),(535146,14866,'bg','Ð¡ÐºÑ€Ð¸Ð¹ RPR',0),(535147,14866,'ur','Ø±Ù¾Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(535148,14866,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð ÐŸÐ ',0),(535149,14866,'vi','áº¨n RPR',0),(535150,14866,'af','Versteek RPR',0),(535151,14866,'ro','Ascunde RPR',0),(535152,14866,'et','Peida RPR',0),(535153,14866,'si','Skrij RPR',0),(535154,14866,'ba','Menyembunyikan RPR',0),(535155,14866,'nl','RPR verbergen',0),(535156,14866,'fi','Piilota RPR',0),(535157,14866,'no','Skjul RPR',0),(535158,14866,'da','Skjule RPR',0),(535159,14866,'ko','RPR ìˆ¨ê¸°ê¸°',0),(535160,14866,'he','×”×¡×ª×¨ RPR',0),(535161,14866,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· RPR',0),(535162,14866,'zh','éšè— RPR',0),(535163,14866,'sv','DÃ¶lja RPR',0),(535164,14866,'it','Nascondere RPR',0),(535165,14866,'tl','',0),(535166,14866,'th','à¸‹à¹ˆà¸­à¸™ RPR',0),(535167,14866,'hi','RPR à¤›à¥à¤ªà¤¾à¤à¤',0),(535168,14866,'ms','Sembunyi RPR',0),(535169,14866,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù…ØªØ§Ø²',0),(535170,14866,'fr','Masquer le RPR',0),(535171,14866,'jp','RPR ã‚’éš ã™',0),(535172,14866,'pt','Esconder RPR',0),(535173,14866,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ RPR',0),(535174,14866,'es','Ocultar RPR',0),(535175,14866,'de','Ausblenden von RPR',0),(535176,14866,'en','Hide RPR',0),(535177,14867,'is','',0),(535178,14867,'dr','ÙˆØ§Ø­Ø¯ ÙØ¹Ø§Ù„',0),(535179,14867,'pr','ÙˆØ§Ø­Ø¯ ÙØ¹Ø§Ù„',0),(535180,14867,'tr','Etkin olmayan birim',0),(535181,14867,'pl','Nieaktywne jednostki',0),(535182,14867,'bg','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸ ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(535183,14867,'ur','ØºÛŒØ± ÙØ¹Ø§Ù„ ÛŒÙˆÙ†Ù¹',0),(535184,14867,'sr','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸ Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(535185,14867,'vi','ÄÆ¡n vá»‹ khÃ´ng hoáº¡t Ä‘á»™ng',0),(535186,14867,'af','Onaktiewe eenheid',0),(535187,14867,'ro','InactivÄƒ unitatea',0),(535188,14867,'et','Passiivsed Ã¼ksus',0),(535189,14867,'si','Neaktivne enote',0),(535190,14867,'ba','Unit tidak aktif',0),(535191,14867,'nl','Inactieve eenheid',0),(535192,14867,'fi','Aktiivinen yksikkÃ¶',0),(535193,14867,'no','Inaktive enhet',0),(535194,14867,'da','Inaktive enhed',0),(535195,14867,'ko','ë¹„í™œë™ ì„± ë‹¨ìœ„',0),(535196,14867,'he','×”×™×—×™×“×” ×œ× ×¤×¢×™×œ×”',0),(535197,14867,'el','Î‘Î½ÎµÎ½ÎµÏÎ³ÏŒ Î¼Î¿Î½Î¬Î´Î±',0),(535198,14867,'zh','å¤„äºŽéžæ´»åŠ¨çŠ¶æ€çš„å•å…ƒ',0),(535199,14867,'sv','Inaktiva enhet',0),(535200,14867,'it','UnitÃ  inattive',0),(535201,14867,'tl','',0),(535202,14867,'th','à¸«à¸™à¹ˆà¸§à¸¢à¸‡à¸²à¸™',0),(535203,14867,'hi','à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯ à¤‡à¤•à¤¾à¤ˆ',0),(535204,14867,'ms','Unit tidak aktif',0),(535205,14867,'ar','ÙˆØ­Ø¯Ø© ØºÙŠØ± Ù†Ø´Ø·',0),(535206,14867,'fr','UnitÃ© inactive',0),(535207,14867,'jp','éžã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªãƒ¦ãƒ‹ãƒƒãƒˆ',0),(535208,14867,'pt','Unidade inativa',0),(535209,14867,'ru','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ',0),(535210,14867,'es','Unidad inactiva',0),(535211,14867,'de','Inaktive Einheit',0),(535212,14867,'en','Inactive Unit',0),(535213,14868,'is','',0),(535214,14868,'dr','Pmt ÙØ§Ú©ØªÙˆØ±',0),(535215,14868,'pr','Pmt ÙØ§Ú©ØªÙˆØ±',0),(535216,14868,'tr','Fatura Devresel Ã¶deme',0),(535217,14868,'pl','Pmt faktury',0),(535218,14868,'bg','Pmt Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(535219,14868,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù¾Ù…Ù¹',0),(535220,14868,'sr','ÐŸÐ¼Ñ‚ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(535221,14868,'vi','HoÃ¡ Ä‘Æ¡n Pmt',0),(535222,14868,'af','Faktuur Pmt',0),(535223,14868,'ro','FacturÄƒ Pmt',0),(535224,14868,'et','Arve makse',0),(535225,14868,'si','Pmt raÄuna',0),(535226,14868,'ba','Faktur Pmt',0),(535227,14868,'nl','Factuur bet',0),(535228,14868,'fi','Laskun erÃ¤',0),(535229,14868,'no','Faktura avdrag',0),(535230,14868,'da','Faktura ydelse',0),(535231,14868,'ko','ì†¡ìž¥ Pmt',0),(535232,14868,'he','Pmt ×—×©×‘×•× ×™×ª',0),(535233,14868,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Pmt',0),(535234,14868,'zh','å‘ç¥¨ Pmt',0),(535235,14868,'sv','Faktura betalning',0),(535236,14868,'it','Fattura Pmt',0),(535237,14868,'tl','',0),(535238,14868,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(535239,14868,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ Pmt',0),(535240,14868,'ms','Pmt invois',0),(535241,14868,'ar','Pmt Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(535242,14868,'fr','Facture Pmt',0),(535243,14868,'jp','è«‹æ±‚æ›¸ã® pmt é–¢æ•°',0),(535244,14868,'pt','PGTO fatura',0),(535245,14868,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÐŸÐ›Ð¢',0),(535246,14868,'es','Factura Pmt',0),(535247,14868,'de','Rechnung Pmt',0),(535248,14868,'en','Invoice Pmt',0),(535249,14869,'is','',0),(535250,14869,'dr','Ø®Ø±ÙˆØ¬ÛŒ Ù…Ø­Ø¯ÙˆØ¯',0),(535251,14869,'pr','Ø®Ø±ÙˆØ¬ÛŒ Ù…Ø­Ø¯ÙˆØ¯',0),(535252,14869,'tr','Limit Ã§Ä±ktÄ±',0),(535253,14869,'pl','Produkcja spÃ³Å‚ka z ograniczonÄ… odpowiedzialnoÅ›ciÄ…',0),(535254,14869,'bg','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸Ðµ Ð¸Ð·Ñ…Ð¾Ð´',0),(535255,14869,'ur','Ø­Ø¯ Ø¢Ø¤Ù¹ Ù¾Ù¹',0),(535256,14869,'sr','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÑšÐµ Ð¸Ð·Ð»Ð°Ð·Ð°',0),(535257,14869,'vi','Giá»›i háº¡n Ä‘áº§u ra',0),(535258,14869,'af','Beperk uitset',0),(535259,14869,'ro','Limita de ieÅŸire',0),(535260,14869,'et','Piiratakse toodangut',0),(535261,14869,'si','Omejitev proizvodnje',0),(535262,14869,'ba','Batas Output',0),(535263,14869,'nl','Limit uitgang',0),(535264,14869,'fi','Raja lÃ¤htÃ¶',0),(535265,14869,'no','Grense-utgang',0),(535266,14869,'da','GrÃ¦nse Output',0),(535267,14869,'ko','ë„ ì¶œë ¥',0),(535268,14869,'he','×ž×’×‘×œ×ª ×¤×œ×˜',0),(535269,14869,'el','ÎŒÏÎ¹Î¿ ÎµÎ¾ÏŒÎ´Î¿Ï…',0),(535270,14869,'zh','é™åˆ¶è¾“å‡º',0),(535271,14869,'sv','BegrÃ¤nsa produktionen',0),(535272,14869,'it','Limite Output',0),(535273,14869,'tl','',0),(535274,14869,'th','à¸œà¸¥à¸œà¸¥à¸´à¸•à¸ˆà¸³à¸à¸±à¸”',0),(535275,14869,'hi','à¤¸à¥€à¤®à¤¾ à¤†à¤‰à¤Ÿà¤ªà¥à¤Ÿ',0),(535276,14869,'ms','Had pengeluaran',0),(535277,14869,'ar','Ø§Ù„Ø¥Ø®Ø±Ø§Ø¬ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰',0),(535278,14869,'fr','Sortie de limite',0),(535279,14869,'jp','åˆ¶é™å‡ºåŠ›',0),(535280,14869,'pt','SaÃ­da de limite',0),(535281,14869,'ru','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸Ðµ Ð²Ñ‹Ð²Ð¾Ð´Ð°',0),(535282,14869,'es','LÃ­mite de salida',0),(535283,14869,'de','Limit-Ausgabe',0),(535284,14869,'en','Limit Output',0),(535285,14870,'is','',0),(535286,14870,'dr','Ù‡ÛŒÚ† Ø¯Ø³ØªÙ‡ ÛŒØ§ÙØª',0),(535287,14870,'pr','Ù‡ÛŒÚ† Ø¯Ø³ØªÙ‡ ÛŒØ§ÙØª',0),(535288,14870,'tr','Bulunan hiÃ§bir toplu iÅŸlemleri',0),(535289,14870,'pl','Nie serii znaleziono',0),(535290,14870,'bg','ÐÑÐ¼Ð° Ð¿Ð°Ð¿ÐºÐ¸ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(535291,14870,'ur','Ú©ÙˆØ¦ÛŒ Ø¨ÛŒÚ†Ø² Ù¾Ø§ÛŒØ§',0),(535292,14870,'sr','ÐÐµÐ¼Ð° Ð³Ñ€ÑƒÐ¿Ðµ Ð½Ð°ÑˆÐ»Ð¸',0),(535293,14870,'vi','LÃ´ khÃ´ng tÃ¬m tháº¥y',0),(535294,14870,'af','Geen hoeveelhede gevind',0),(535295,14870,'ro','Loturi nu a Ã®ntemeia',0),(535296,14870,'et','No kui partiid',0),(535297,14870,'si','Ni serij, najti',0),(535298,14870,'ba','Batch tidak ditemukan',0),(535299,14870,'nl','Geen partijen gevonden',0),(535300,14870,'fi','Ei epÃ¤tyydyttÃ¤viksi',0),(535301,14870,'no','Ingen grupper funnet',0),(535302,14870,'da','Ingen partier fundet',0),(535303,14870,'ko','ì—†ìŒ ì¼ê´„ ì²˜ë¦¬ ë°œê²¬',0),(535304,14870,'he','××™×Ÿ ××¦×•×•×ª × ×ž×¦××•',0),(535305,14870,'el','Î”ÎµÎ½ Ï€Î±ÏÏ„Î¯Î´ÎµÏ‚ Ï€Î¿Ï…',0),(535306,14870,'zh','å‘çŽ°ä»»ä½•æ‰¹å¤„ç†',0),(535307,14870,'sv','Inga partier hittade',0),(535308,14870,'it','Nessun lotti trovati',0),(535309,14870,'tl','',0),(535310,14870,'th','à¸Šà¸¸à¸”à¹„à¸¡à¹ˆà¸žà¸š',0),(535311,14870,'hi','à¤•à¥‹à¤ˆ à¤¬à¥ˆà¤šà¥‹à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(535312,14870,'ms','Tiada Kumpulan yang didapati',0),(535313,14870,'ar','Ø¯ÙØ¹Ø§Øª Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(535314,14870,'fr','Aucun lots trouvÃ©s',0),(535315,14870,'jp','ãªã„ãƒãƒƒãƒãŒè¦‹ã¤ã‹ã‚Šã¾ã—ãŸ',0),(535316,14870,'pt','NÃ£o hÃ¡ lotes encontrados',0),(535317,14870,'ru','ÐŸÐ°ÐºÐµÑ‚Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(535318,14870,'es','No hay lotes encontrados',0),(535319,14870,'de','Keine Chargen gefunden',0),(535320,14870,'en','No Batches Found',0),(535321,14871,'is','',0),(535322,14871,'dr','Ù†ÙˆØ¹ Ø±Ú©ÙˆØ±Ø¯',0),(535323,14871,'pr','Ù†ÙˆØ¹ Ø±Ú©ÙˆØ±Ø¯',0),(535324,14871,'tr','KayÄ±t tÃ¼rÃ¼',0),(535325,14871,'pl','Typ rekordu',0),(535326,14871,'bg','Ð¢Ð¸Ð¿ Ð·Ð°Ð¿Ð¸Ñ',0),(535327,14871,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©ÛŒ Ù‚Ø³Ù…',0),(535328,14871,'sr','Ð’Ñ€ÑÑ‚Ð° Ð·Ð°Ð¿Ð¸ÑÐ°',0),(535329,14871,'vi','Loáº¡i há»“ sÆ¡',0),(535330,14871,'af','Rekord tipe',0),(535331,14871,'ro','Tip de Ã®nregistrare',0),(535332,14871,'et','Kirje tÃ¼Ã¼p',0),(535333,14871,'si','Vrsta zapisa',0),(535334,14871,'ba','Tipe record',0),(535335,14871,'nl','Recordtype',0),(535336,14871,'fi','Tietueen tyyppi',0),(535337,14871,'no','OppfÃ¸ringstype',0),(535338,14871,'da','Posttype',0),(535339,14871,'ko','ë ˆì½”ë“œ ì¢…ë¥˜',0),(535340,14871,'he','×¡×•×’ ×”×¨×©×•×ž×”',0),(535341,14871,'el','Î¤ÏÏ€Î¿Ï‚ ÎºÎ±ÏÏ„Î­Î»Î±Ï‚ \"',0),(535342,14871,'zh','è®°å½•ç±»åž‹',0),(535343,14871,'sv','Posttyp',0),(535344,14871,'it','Tipo di record',0),(535345,14871,'tl','',0),(535346,14871,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”',0),(535347,14871,'hi','à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(535348,14871,'ms','Jenis rekod',0),(535349,14871,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø³Ø¬Ù„',0),(535350,14871,'fr','Type d\'enregistrement',0),(535351,14871,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ã®ç¨®é¡ž',0),(535352,14871,'pt','Tipo de registro',0),(535353,14871,'ru','Ð¢Ð¸Ð¿ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(535354,14871,'es','Tipo de registro',0),(535355,14871,'de','Satzart',0),(535356,14871,'en','Record Type',0),(535357,14872,'is','',0),(535358,14872,'dr','Ø¯Ø±Ø¢Ù…Ø¯',0),(535359,14872,'pr','Ø¯Ø±Ø¢Ù…Ø¯',0),(535360,14872,'tr','Gelir',0),(535361,14872,'pl','Dochody',0),(535362,14872,'bg','ÐŸÑ€Ð¸Ñ…Ð¾Ð´Ð¸',0),(535363,14872,'ur','Ø¢Ù…Ø¯Ù†ÛŒ',0),(535364,14872,'sr','ÐŸÑ€Ð¸Ñ…Ð¾Ð´',0),(535365,14872,'vi','Doanh thu',0),(535366,14872,'af','Inkomste',0),(535367,14872,'ro','Venituri',0),(535368,14872,'et','Tulud',0),(535369,14872,'si','Prihodki',0),(535370,14872,'ba','Pendapatan',0),(535371,14872,'nl','Ontvangsten',0),(535372,14872,'fi','Tulot',0),(535373,14872,'no','Inntekter',0),(535374,14872,'da','IndtÃ¦gter',0),(535375,14872,'ko','ìˆ˜ìµ',0),(535376,14872,'he','×”×›× ×¡×•×ª',0),(535377,14872,'el','ÎˆÏƒÎ¿Î´Î±',0),(535378,14872,'zh','æ”¶å…¥',0),(535379,14872,'sv','IntÃ¤kter',0),(535380,14872,'it','Entrate',0),(535381,14872,'tl','',0),(535382,14872,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰',0),(535383,14872,'hi','à¤°à¤¾à¤œà¤¸à¥à¤µ',0),(535384,14872,'ms','Hasil',0),(535385,14872,'ar','Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª',0),(535386,14872,'fr','Recettes',0),(535387,14872,'jp','åŽç›Š',0),(535388,14872,'pt','Receitas',0),(535389,14872,'ru','Ð”Ð¾Ñ…Ð¾Ð´',0),(535390,14872,'es','Ingresos',0),(535391,14872,'de','Einnahmen',0),(535392,14872,'en','Revenue',0),(535393,14873,'is','',0),(535394,14873,'dr','Ø§Ù†ÙˆØ§Ø¹ Ø±Ú©ÙˆØ±Ø¯ Ù†Ù…Ø§ÛŒØ´',0),(535395,14873,'pr','Ø§Ù†ÙˆØ§Ø¹ Ø±Ú©ÙˆØ±Ø¯ Ù†Ù…Ø§ÛŒØ´',0),(535396,14873,'tr','KayÄ±t tÃ¼rlerini gÃ¶ster',0),(535397,14873,'pl','PokaÅ¼ typy rekordÃ³w',0),(535398,14873,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(535399,14873,'ur','Ø´Ùˆ Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(535400,14873,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð·Ð°Ð¿Ð¸ÑÐ°',0),(535401,14873,'vi','Hiá»ƒn thá»‹ loáº¡i há»“ sÆ¡',0),(535402,14873,'af','Wys rekord tipes',0),(535403,14873,'ro','AratÄƒ tipurile de Ã®nregistrÄƒri',0),(535404,14873,'et','NÃ¤ita kirjetÃ¼Ã¼bid',0),(535405,14873,'si','PokaÅ¾i vrste zapisov',0),(535406,14873,'ba','Menunjukkan jenis data',0),(535407,14873,'nl','Toon recordtypen',0),(535408,14873,'fi','NÃ¤ytÃ¤ tietuetyypit',0),(535409,14873,'no','Vis oppfÃ¸ringstyper',0),(535410,14873,'da','Vis posttyper',0),(535411,14873,'ko','ë ˆì½”ë“œ ì¢…ë¥˜ í‘œì‹œ',0),(535412,14873,'he','×”×¦×’ ×¡×•×’×™ ×¨×©×•×ž×•×ª',0),(535413,14873,'el','Î¤ÏÏ€Î¿Ï…Ï‚ ÎºÎ±ÏÏ„Î­Î»Î±Ï‚ Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·',0),(535414,14873,'zh','æ˜¾ç¤ºçš„è®°å½•ç±»åž‹',0),(535415,14873,'sv','Visa posttyper',0),(535416,14873,'it','Visualizza tipi di Record',0),(535417,14873,'tl','',0),(535418,14873,'th','à¹à¸ªà¸”à¸‡à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”',0),(535419,14873,'hi','à¤¶à¥‹ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(535420,14873,'ms','Menunjukkan jenis-jenis rekod',0),(535421,14873,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø³Ø¬Ù„Ø§Øª',0),(535422,14873,'fr','Afficher les Types de disques',0),(535423,14873,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ã®ç¨®é¡žã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(535424,14873,'pt','Mostrar tipos de registro',0),(535425,14873,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¸Ð¿Ñ‹ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(535426,14873,'es','Mostrar los tipos de registro',0),(535427,14873,'de','Karte-Record-Typen',0),(535428,14873,'en','Show Record Types',0),(535429,14874,'is','',0),(535430,14874,'dr','3dcart Ø¯Ø³ØªÙˆØ±Ø§Øª Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙˆØ¶Ø¹ÛŒØª',0),(535431,14874,'pr','3dcart Ø¯Ø³ØªÙˆØ±Ø§Øª Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙˆØ¶Ø¹ÛŒØª',0),(535432,14874,'tr','3dcart sipariÅŸ durumu iÅŸleme',0),(535433,14874,'pl','3dcart zamÃ³wienia w rozpatrywaniu stanu',0),(535434,14874,'bg','3dcart Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð² ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(535435,14874,'ur','Ø­Ø§Ù„Øª Ú©ÛŒ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº 3dcart Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(535436,14874,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ñƒ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¾Ð±Ñ€Ð°Ð´Ðµ',0),(535437,14874,'vi','3dcart Ä‘Æ¡n Ä‘áº·t hÃ ng trong viá»‡c xá»­ lÃ½ tÃ¬nh tráº¡ng',0),(535438,14874,'af','3dcart bestellings In verwerking Status',0),(535439,14874,'ro','3dcart comenzi Ã®n statutul de prelucrare',0),(535440,14874,'et','3dcart tellimuse tÃ¶Ã¶tlemise olek',0),(535441,14874,'si','3dcart naroÄila v stanje obdelave',0),(535442,14874,'ba','3dcart perintah dalam pengolahan Status',0),(535443,14874,'nl','3dcart Orders In verwerking Status',0),(535444,14874,'fi','3dcart tilausten kÃ¤sittelyn tila',0),(535445,14874,'no','3dcart ordrer under behandling Status',0),(535446,14874,'da','3dcart ordrer i forarbejdning Status',0),(535447,14874,'ko','3dcart ì£¼ë¬¸ ì²˜ë¦¬ ìƒíƒœ',0),(535448,14874,'he','3dcart ×¤×§×•×“×•×ª ×¢×™×‘×•×“ ×ž×¦×‘',0),(535449,14874,'el','3dcart Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÏƒÏ„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(535450,14874,'zh','3dcart è®¢å•çš„å¤„ç†çŠ¶æ€',0),(535451,14874,'sv','3dcart order bearbetning Status',0),(535452,14874,'it','3Dcart ordini In stato di elaborazione',0),(535453,14874,'tl','',0),(535454,14874,'th','3dcart à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹ƒà¸™à¸à¸²à¸£à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¸ªà¸–à¸²à¸™à¸°',0),(535455,14874,'hi','3dcart à¤†à¤¦à¥‡à¤¶ à¤¸à¤‚à¤¸à¤¾à¤§à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤®à¥‡à¤‚',0),(535456,14874,'ms','3dcart pesanan dalam memproses Status',0),(535457,14874,'ar','Ø£ÙˆØ§Ù…Ø± 3dcart ÙÙŠ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„ÙˆØ¶Ø¹',0),(535458,14874,'fr','3Dcart ordres dans l\'Ã©tat de traitement',0),(535459,14874,'jp','3dcart ã®å—æ³¨å‡¦ç†ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(535460,14874,'pt','3Dcart ordens no Status de processamento',0),(535461,14874,'ru','3dcart Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð² Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐµ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(535462,14874,'es','3DCart Ã³rdenes en el estado de procesamiento',0),(535463,14874,'de','3dcart AuftrÃ¤ge im Bearbeitungsstatus',0),(535464,14874,'en','3dcart Orders In Processing Status',0),(535465,14875,'is','',0),(535466,14875,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø¯Ø³ØªÙˆØ±Ø§Øª Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙˆØ¶Ø¹ÛŒØª',0),(535467,14875,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø¯Ø³ØªÙˆØ±Ø§Øª Ù¾Ø±Ø¯Ø§Ø²Ø´ ÙˆØ¶Ø¹ÛŒØª',0),(535468,14875,'tr','SipariÅŸ durumu iÅŸleme almak mÃ¼mkÃ¼n deÄŸil',0),(535469,14875,'pl','Nie wypÅ‚acalny odzyskiwaÄ‡ zamÃ³wienia w rozpatrywaniu stanu',0),(535470,14875,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð²Ð»ÐµÑ‡Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð² ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(535471,14875,'ur','Ø­Ø§Ù„Øª Ú©ÛŒ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ù…ÛŒÚº Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù‚Ø§Ø¨Ù„ Ù†ÛÛŒÚº',0),(535472,14875,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ Ð½Ð°Ð»Ð¾Ð³Ðµ Ñƒ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¾Ð±Ñ€Ð°Ð´Ðµ',0),(535473,14875,'vi','KhÃ´ng thá»ƒ Ä‘á»ƒ láº¥y Ä‘Æ¡n Ä‘áº·t hÃ ng trong xá»­ lÃ½ tÃ¬nh tráº¡ng',0),(535474,14875,'af','Nie in staat om bestellings In verwerking Status herwin',0),(535475,14875,'ro','Nu sunt Ã®n mÄƒsurÄƒ pentru a prelua comenzi Ã®n statutul de prelucrare',0),(535476,14875,'et','Ei saa laadida tellimuste tÃ¶Ã¶tlemise olek',0),(535477,14875,'si','Ne more pridobiti naroÄila v stanje obdelave',0),(535478,14875,'ba','Tidak mampu mengambil pesanan dalam pengolahan Status',0),(535479,14875,'nl','Niet in staat om op te halen van Orders In verwerking Status',0),(535480,14875,'fi','Ei voi hakea tilausten kÃ¤sittelyn tila',0),(535481,14875,'no','Kan ikke hente ordrer i behandling Status',0),(535482,14875,'da','Ikke i stand til at hente ordrer i forarbejdning Status',0),(535483,14875,'ko','ì£¼ë¬¸ ì²˜ë¦¬ ìƒíƒœì—ì„œ ê²€ìƒ‰ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(535484,14875,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ××—×–×¨ ×¤×§×•×“×•×ª ×¢×™×‘×•×“ ×ž×¦×‘',0),(535485,14875,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÏƒÎµ Î¸Î­ÏƒÎ· Î½Î± Î±Î½Î±ÎºÏ„Î®ÏƒÎµÏ„Îµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ ÏƒÏ„Î·Î½ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(535486,14875,'zh','ä¸èƒ½æ£€ç´¢è®¢å•çš„å¤„ç†çŠ¶æ€',0),(535487,14875,'sv','Inte kunna hÃ¤mta order bearbetning Status',0),(535488,14875,'it','Non in grado di recuperare gli ordini In stato di elaborazione',0),(535489,14875,'tl','',0),(535490,14875,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸”à¸¶à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹ƒà¸™à¸à¸²à¸£à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¸ªà¸–à¸²à¸™à¸°',0),(535491,14875,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤¸à¤‚à¤¸à¤¾à¤§à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¸à¤•à¥à¤·à¤® à¤¨à¤¹à¥€à¤‚',0),(535492,14875,'ms','Tidak mampu untuk mengambil pesanan dalam memproses Status',0),(535493,14875,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø£ÙˆØ§Ù…Ø± ÙÙŠ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„ÙˆØ¶Ø¹',0),(535494,14875,'fr','Pas en mesure de rÃ©cupÃ©rer les commandes au statut de traitement',0),(535495,14875,'jp','å‡¦ç†ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã®æ³¨æ–‡ã‚’å–å¾—ã™ã‚‹ã«ã¯ã€ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(535496,14875,'pt','NÃ£o Ã© capaz de recuperar as ordens no Status de processamento',0),(535497,14875,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð² Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐµ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(535498,14875,'es','No es capaz de recuperar las Ã³rdenes en el estado de procesamiento',0),(535499,14875,'de','Nicht in der Lage AuftrÃ¤ge abrufen im Bearbeitungsstatus',0),(535500,14875,'en','Not Able To Retrieve Orders In Processing Status',0),(535501,14876,'is','',0),(535502,14876,'dr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø¯Ø± ÙˆØ¶Ø¹ÛŒØª Ù¾Ø±Ø¯Ø§Ø²Ø´',0),(535503,14876,'pr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø¯Ø± ÙˆØ¶Ø¹ÛŒØª Ù¾Ø±Ø¯Ø§Ø²Ø´',0),(535504,14876,'tr','Ä°ÅŸlem durumu bulunan emir',0),(535505,14876,'pl','Nie zamÃ³wienia w stan przetwarzania',0),(535506,14876,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸ Ð² ÐµÑ‚Ð°Ð¿Ð¸Ñ‚Ðµ Ð½Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(535507,14876,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ø­Ø§Ù„Øª Ù…ÛŒÚº Ù¾Ø§ÛŒØ§',0),(535508,14876,'sr','ÐÐµÐ¼Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ñƒ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¾Ð±Ñ€Ð°Ð´Ðµ',0),(535509,14876,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n Ä‘áº·t hÃ ng tÃ¬m tháº¥y trong tÃ¬nh tráº¡ng cháº¿ biáº¿n',0),(535510,14876,'af','Geen bestellings gevind In die verwerking Status',0),(535511,14876,'ro','Comenzi gÄƒsite Ã®n starea de prelucrare',0),(535512,14876,'et','No tellimuste tÃ¶Ã¶tlemise olek leitud',0),(535513,14876,'si','Brez naroÄil, najdemo v stanje obdelave',0),(535514,14876,'ba','Tidak ada order yang ditemukan dalam Status pengolahan',0),(535515,14876,'nl','Geen Orders zijn gevonden In de verwerking Status',0),(535516,14876,'fi','Tilauksia ei lÃ¶ytynyt kÃ¤sittelytila',0),(535517,14876,'no','Ingen ordrer i statusen behandling',0),(535518,14876,'da','Ingen ordrer, fundet i behandlingsstatus',0),(535519,14876,'ko','ì•„ë‹ˆ ì£¼ë¬¸ ì²˜ë¦¬ ìƒíƒœì—ì„œ ë°œê²¬',0),(535520,14876,'he','×¤×§×•×“×•×ª × ×ž×¦××• ×‘ ×ž×¦×‘ ×¢×™×‘×•×“',0),(535521,14876,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ ÏƒÏ„Î·Î½ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(535522,14876,'zh','æ²¡æœ‰å‘çŽ°åœ¨å¤„ç†çŠ¶æ€çš„è®¢å•',0),(535523,14876,'sv','Inga bestÃ¤llningar Funna i Bearbetningsstatus',0),(535524,14876,'it','Nessun ordine trovato In stato di elaborazione',0),(535525,14876,'tl','',0),(535526,14876,'th','à¹„à¸¡à¹ˆà¸žà¸šà¹ƒà¸™à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(535527,14876,'hi','à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤®à¥‡à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(535528,14876,'ms','Tiada perintah yang ditemui di dalam Status pemprosesan',0),(535529,14876,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙˆØ§Ù…Ø± ÙˆØ¬Ø¯Øª ÙÙŠ Ø­Ø§Ù„Ø© Ù…Ø¹Ø§Ù„Ø¬Ø©',0),(535530,14876,'fr','Pas trouvÃ©s dans l\'Ã©tat de traitement de commandes',0),(535531,14876,'jp','æ³¨æ–‡ã®å‡¦ç†çŠ¶æ…‹ã§ãªã„ã§ã™ã€‚',0),(535532,14876,'pt','Nenhuma ordem consta o Status de processamento',0),(535533,14876,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð½Ðµ Ð² ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ñ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸',0),(535534,14876,'es','Ninguna orden en el estado de procesamiento',0),(535535,14876,'de','Keine Bestellungen In den Bearbeitungsstatus gefunden',0),(535536,14876,'en','No Orders Found In The Processing Status',0),(535537,14877,'is','',0),(535538,14877,'dr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¨Ø¯ÙˆÙ† Ø§Ù†ØªØ®Ø§Ø¨',0),(535539,14877,'pr','Ù…Ø­Ù…ÙˆÙ„Ù‡ Ø¨Ø¯ÙˆÙ† Ø§Ù†ØªØ®Ø§Ø¨',0),(535540,14877,'tr','HiÃ§bir sevk irsaliyelerinin seÃ§ili',0),(535541,14877,'pl','Nie wysyÅ‚ek wybrane',0),(535542,14877,'bg','ÐÑÐ¼Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð·Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(535543,14877,'ur','Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº Ù„ÛŒØªÛŒ',0),(535544,14877,'sr','ÐÐµÐ¼Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(535545,14877,'vi','CÃ¡c lÃ´ hÃ ng khÃ´ng cÃ³ lá»±a chá»n',0),(535546,14877,'af','Geen vervoer gekies',0),(535547,14877,'ro','Nici expediÅ£iile selectate',0),(535548,14877,'et','Pole valitud saadetised',0),(535549,14877,'si','Ne poÅ¡iljke, izbrane',0),(535550,14877,'ba','Tidak ada pengiriman yang dipilih',0),(535551,14877,'nl','Geen zendingen geselecteerd',0),(535552,14877,'fi','LÃ¤hetystÃ¤ ei valittu',0),(535553,14877,'no','Ingen leveringer valgt',0),(535554,14877,'da','Ingen leverancer valgt',0),(535555,14877,'ko','ì•„ë‹ˆ ì¶œí•˜ ëŸ‰ ì„ ì •',0),(535556,14877,'he','××™×Ÿ ×ž×©×œ×•×—×™× ×©× ×‘×—×¨×•',0),(535557,14877,'el','Î”ÎµÎ½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ Ï€Î¿Ï… ÎµÏ€Î¹Î»Î­Î³Î¿Î½Ï„Î±Î¹',0),(535558,14877,'zh','é€‰æ‹©æ²¡æœ‰å‘è´§',0),(535559,14877,'sv','Inga transporter som valts',0),(535560,14877,'it','No spedizioni selezionate',0),(535561,14877,'tl','',0),(535562,14877,'th','à¹„à¸¡à¹ˆà¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(535563,14877,'hi','à¤•à¥‹à¤ˆ à¤šà¤¯à¤¨à¤¿à¤¤ à¤²à¤¦à¤¾à¤¨',0),(535564,14877,'ms','Tiada penghantaran yang dipilih',0),(535565,14877,'ar','Ù„Ø§ Ø´Ø­Ù†Ø§Øª Ù…Ø®ØªØ§Ø±Ø©',0),(535566,14877,'fr','Aucun envoi sÃ©lectionnÃ©',0),(535567,14877,'jp','é¸æŠžã•ã‚Œã¦ãªã„å‡ºè·',0),(535568,14877,'pt','Sem carregamentos selecionados',0),(535569,14877,'ru','ÐÐµÑ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ð¾Ð³Ð¾',0),(535570,14877,'es','No hay envÃ­os seleccionados',0),(535571,14877,'de','Keine Sendungen ausgewÃ¤hlt',0),(535572,14877,'en','No Shipments Selected',0),(535573,14878,'is','',0),(535574,14878,'dr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ù‡ 3dcart',0),(535575,14878,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø¨Ù‡ 3dcart',0),(535576,14878,'tr','3dcart iÃ§in gÃ¶nderilen Sevkiyat bilgileri',0),(535577,14878,'pl','WysyÅ‚ka informacje przesyÅ‚ane do 3dcart',0),(535578,14878,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð´Ð¾ 3dcart',0),(535579,14878,'ur','3dcart Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬Û’ Ú¯Ø¦Û’ Ú©Ú¾ÛŒÙ¾ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(535580,14878,'sr','Ð˜ÐÐ¤ . Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ†Ð¸ Ð¿Ð¾ÑÐ»Ð°Ñ‚Ð¾ 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(535581,14878,'vi','ThÃ´ng tin lÃ´ hÃ ng gá»­i Ä‘áº¿n 3dcart',0),(535582,14878,'af','Verskeping Info na 3dcart gestuur',0),(535583,14878,'ro','Info transport trimis 3dcart',0),(535584,14878,'et','Saadetise Info saata 3dcart',0),(535585,14878,'si','Podatki o dobavi, poÅ¡lje 3dcart',0),(535586,14878,'ba','Info pengiriman yang dikirim ke 3dcart',0),(535587,14878,'nl','Verzending Info naar 3dcart gestuurd',0),(535588,14878,'fi','Toimitus Info lÃ¤hetetÃ¤Ã¤n 3dcart',0),(535589,14878,'no','Forsendelsen Info sendt Ã¥ 3dcart',0),(535590,14878,'da','Forsendelse Info sendt til 3dcart',0),(535591,14878,'ko','3dcart ì „ì†¡ ì„ ì  ì •ë³´',0),(535592,14878,'he','×¤×¨×˜×™ ×”×ž×©×œ×•×— × ×©×œ×— 3dcart',0),(535593,14878,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Ï€Î¿Ï… Î­ÏƒÏ„ÎµÎ¹Î»Îµ Î½Î± 3dcart',0),(535594,14878,'zh','è£…è¿ä¿¡æ¯å‘é€åˆ° 3dcart',0),(535595,14878,'sv','Leverans Info skickas till 3dcart',0),(535596,14878,'it','Info spedizione inviata a 3dcart',0),(535597,14878,'tl','',0),(535598,14878,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹„à¸›à¸—à¸µà¹ˆ 3dcart',0),(535599,14878,'hi','à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ 3dcart à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œà¤¾',0),(535600,14878,'ms','Penghantaran maklumat yang dihantar kepada 3dcart',0),(535601,14878,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø´Ø­Ù†Ø© Ø§Ù„Ù…Ø±Ø³Ù„Ø© Ø¥Ù„Ù‰ 3dcart',0),(535602,14878,'fr','Info expÃ©dition envoyÃ©e Ã  3dcart',0),(535603,14878,'jp','å‡ºè·æƒ…å ±ã‚’ 3dcart ã«é€ä¿¡',0),(535604,14878,'pt','InformaÃ§Ã£o da expediÃ§Ã£o enviada para 3dcart',0),(535605,14878,'ru','ÐžÑ‚Ð³Ñ€ÑƒÐ·ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð»ÑÐµÑ‚ÑÑ Ð² 3dcart',0),(535606,14878,'es','InformaciÃ³n de envÃ­o enviado a 3dcart',0),(535607,14878,'de','Versand-Info an 3dcart gesendet',0),(535608,14878,'en','Shipment Info Sent To 3dcart',0),(535609,14879,'is','',0),(535610,14879,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ù†Ø¸Ù… Ù†ÙˆÛŒÙ†',0),(535611,14879,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ù†Ø¸Ù… Ù†ÙˆÛŒÙ†',0),(535612,14879,'tr','Yeni bir sipariÅŸ oluÅŸturun',0),(535613,14879,'pl','Tworzenie nowego porzÄ…dku',0),(535614,14879,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(535615,14879,'ur','Ù†Ø¦Û’ Ø¢Ø±ÚˆØ± Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(535616,14879,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³',0),(535617,14879,'vi','Táº¡o Ä‘Æ¡n hÃ ng má»›i',0),(535618,14879,'af','Nuwe orde skep',0),(535619,14879,'ro','CreaÅ£i noua ordine',0),(535620,14879,'et','Vali taotlus',0),(535621,14879,'si','Ustvarite nov nalog',0),(535622,14879,'ba','Menciptakan Orde Baru',0),(535623,14879,'nl','Nieuwe Order maken',0),(535624,14879,'fi','Luo uusi tilaus',0),(535625,14879,'no','Opprette ny ordre',0),(535626,14879,'da','Oprette ny ordre',0),(535627,14879,'ko','ìƒˆë¡œìš´ ì§ˆì„œë¥¼ ë§Œë“¤',0),(535628,14879,'he','×œ×™×¦×•×¨ ×¡×“×¨ ×—×“×©',0),(535629,14879,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î½Î­Î±Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚',0),(535630,14879,'zh','åˆ›å»ºæ–°è®¢å•',0),(535631,14879,'sv','Skapa ny Order',0),(535632,14879,'it','Creare il nuovo ordine',0),(535633,14879,'tl','',0),(535634,14879,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹ƒà¸«à¸¡à¹ˆ',0),(535635,14879,'hi','à¤¨à¤¯à¤¾ à¤‘à¤°à¥à¤¡à¤° à¤¬à¤¨à¤¾à¤à¤',0),(535636,14879,'ms','Membuat perintah yang baru',0),(535637,14879,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø£Ù…Ø± Ø¬Ø¯ÙŠØ¯',0),(535638,14879,'fr','CrÃ©er nouvel ordre',0),(535639,14879,'jp','æ–°ã—ã„æ³¨æ–‡ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(535640,14879,'pt','Criar nova ordem',0),(535641,14879,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð·',0),(535642,14879,'es','Crear nuevo orden',0),(535643,14879,'de','Neue Ordnung schaffen',0),(535644,14879,'en','Create New Order',0),(535645,14880,'is','',0),(535646,14880,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ù‡ Ø¹Ù„Øª',0),(535647,14880,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ù‡ Ø¹Ù„Øª',0),(535648,14880,'tr','Åžu anda vade',0),(535649,14880,'pl','Obecnie ze wzglÄ™du',0),(535650,14880,'bg','Ð’ Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° Ð´ÑŠÐ»Ð¶Ð¸',0),(535651,14880,'ur','Ø§Ø³ ÙˆÙ‚Øª Ú©ÛŒ ÙˆØ¬Û Ø³Û’',0),(535652,14880,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ñ€Ð¾Ðº',0),(535653,14880,'vi','Hiá»‡n nay do',0),(535654,14880,'af','Tans verskuldig',0),(535655,14880,'ro','ÃŽn prezent datorate',0),(535656,14880,'et','Praegu otse',0),(535657,14880,'si','Trenutno zaradi',0),(535658,14880,'ba','Saat ini jatuh tempo',0),(535659,14880,'nl','Momenteel verschuldigd',0),(535660,14880,'fi','TÃ¤llÃ¤ hetkellÃ¤ mÃ¤Ã¤rÃ¤',0),(535661,14880,'no','Som skal',0),(535662,14880,'da','I Ã¸jeblikket Due',0),(535663,14880,'ko','í˜„ìž¬ ì˜ˆì •',0),(535664,14880,'he','×›×™×•× ×‘×©×œ',0),(535665,14880,'el','Î•Î³Î³ÏÎ¬Ï†Ï‰Î½ Ï€ÏÏŒÎºÎµÎ¹Ï„Î±Î¹',0),(535666,14880,'zh','ç›®å‰åˆ°æœŸ',0),(535667,14880,'sv','FÃ¶r nÃ¤rvarande pÃ¥ grund av',0),(535668,14880,'it','Attualmente dovuta',0),(535669,14880,'tl','',0),(535670,14880,'th','à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¹ƒà¸™à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(535671,14880,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¦à¥‡à¤¯',0),(535672,14880,'ms','Buat masa ini terhutang',0),(535673,14880,'ar','Ø§Ù„ÙˆØ§Ø¬Ø¨ Ø­Ø§Ù„ÙŠØ§',0),(535674,14880,'fr','Actuellement Due',0),(535675,14880,'jp','ç¾åœ¨äºˆå®š',0),(535676,14880,'pt','Atualmente devido',0),(535677,14880,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð´Ð¾Ð»Ð¶Ð½Ñ‹Ð¼ Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð¼',0),(535678,14880,'es','Actualmente debido',0),(535679,14880,'de','Derzeit fÃ¤llig',0),(535680,14880,'en','Currently Due',0),(535681,14881,'is','',0),(535682,14881,'dr','Ø¢Ø¯Ø±Ø³ 1',0),(535683,14881,'pr','Ø¢Ø¯Ø±Ø³ 1',0),(535684,14881,'tr','Adres 1',0),(535685,14881,'pl','Adres 1',0),(535686,14881,'bg','ÐÐ´Ñ€ÐµÑ 1',0),(535687,14881,'ur','Ù¾ØªØ§ 1',0),(535688,14881,'sr','ÐÐ´Ñ€ÐµÑÐ° 1',0),(535689,14881,'vi','Äá»‹a chá»‰ 1',0),(535690,14881,'af','Adres 1',0),(535691,14881,'ro','Adresa 1',0),(535692,14881,'et','Aadressi 1',0),(535693,14881,'si','Naslov 1',0),(535694,14881,'ba','Alamat 1',0),(535695,14881,'nl','Adres 1',0),(535696,14881,'fi','Osoite 1',0),(535697,14881,'no','Adresse 1',0),(535698,14881,'da','Adresse 1',0),(535699,14881,'ko','ì£¼ì†Œ 1',0),(535700,14881,'he','×›×ª×•×‘×ª 1',0),(535701,14881,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· 1',0),(535702,14881,'zh','åœ°å€ 1',0),(535703,14881,'sv','Adress: 1',0),(535704,14881,'it','Indirizzo 1',0),(535705,14881,'tl','',0),(535706,14881,'th','à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆ 1',0),(535707,14881,'hi','à¤ªà¤¤à¤¾ 1',0),(535708,14881,'ms','Alamat 1',0),(535709,14881,'ar','Ø§Ù„Ø¹Ù†ÙˆØ§Ù† 1',0),(535710,14881,'fr','Adresse 1',0),(535711,14881,'jp','ã‚¢ãƒ‰ãƒ¬ã‚¹ 1',0),(535712,14881,'pt','EndereÃ§o 1',0),(535713,14881,'ru','ÐÐ´Ñ€ÐµÑ 1',0),(535714,14881,'es','DirecciÃ³n 1',0),(535715,14881,'de','Adresse 1',0),(535716,14881,'en','Address 1',0),(535717,14882,'is','',0),(535718,14882,'dr','Ø¢Ø¯Ø±Ø³ 2',0),(535719,14882,'pr','Ø¢Ø¯Ø±Ø³ 2',0),(535720,14882,'tr','Adres 2',0),(535721,14882,'pl','Adres 2',0),(535722,14882,'bg','ÐÐ´Ñ€ÐµÑ 2',0),(535723,14882,'ur','Ù¾ØªÛ’ 2',0),(535724,14882,'sr','ÐÐ´Ñ€ÐµÑÐ° 2',0),(535725,14882,'vi','Äá»‹a chá»‰ 2',0),(535726,14882,'af','Adres 2',0),(535727,14882,'ro','Adresa 2',0),(535728,14882,'et','Aadress 2',0),(535729,14882,'si','Naslov 2',0),(535730,14882,'ba','Alamat 2',0),(535731,14882,'nl','Adres 2',0),(535732,14882,'fi','Osoite 2',0),(535733,14882,'no','Adresse 2',0),(535734,14882,'da','Adresse 2',0),(535735,14882,'ko','ì£¼ì†Œ 2',0),(535736,14882,'he','×›×ª×•×‘×ª 2',0),(535737,14882,'el','Î”Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· 2',0),(535738,14882,'zh','åœ°å€ 2',0),(535739,14882,'sv','Adress 2',0),(535740,14882,'it','Indirizzo 2',0),(535741,14882,'tl','',0),(535742,14882,'th','à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆ 2',0),(535743,14882,'hi','à¤ªà¤¤à¤¾ 2',0),(535744,14882,'ms','Alamat 2',0),(535745,14882,'ar','Ø§Ù„Ø¹Ù†ÙˆØ§Ù† 2',0),(535746,14882,'fr','Adresse 2',0),(535747,14882,'jp','ä½æ‰€ 2',0),(535748,14882,'pt','EndereÃ§o 2',0),(535749,14882,'ru','ÐÐ´Ñ€ÐµÑ 2',0),(535750,14882,'es','DirecciÃ³n 2',0),(535751,14882,'de','Adresse 2',0),(535752,14882,'en','Address 2',0),(535753,14883,'is','',0),(535754,14883,'dr','Ø´Ù‡Ø±Ø³ØªØ§Ù†ØŒ Ø§Ø³ØªØ§Ù† Ùˆ Ø²ÛŒÙ¾',0),(535755,14883,'pr','Ø´Ù‡Ø±Ø³ØªØ§Ù†ØŒ Ø§Ø³ØªØ§Ù† Ùˆ Ø²ÛŒÙ¾',0),(535756,14883,'tr','City, State ve Zip',0),(535757,14883,'pl','Miasto, stan i Zip',0),(535758,14883,'bg','Ð“Ñ€Ð°Ð´, Ð´ÑŠÑ€Ð¶Ð°Ð²Ð° Ð¸ Zip',0),(535759,14883,'ur','Ø´ÛØ±ØŒ Ø±ÛŒØ§Ø³Øª Ø§ÙˆØ± Ø²Ù¾',0),(535760,14883,'sr','Ð“Ñ€Ð°Ð´ , Ð´Ñ€Ð¶Ð°Ð²Ð° Ð¸ Ð—Ð¸Ð¿',0),(535761,14883,'vi','ThÃ nh phá»‘, tiá»ƒu bang vÃ  Sá»‘ Zip',0),(535762,14883,'af','Stad, staat en Zip',0),(535763,14883,'ro','OraÅŸ, stat ÅŸi Zip',0),(535764,14883,'et','Linn, riik ja Zip',0),(535765,14883,'si','Mesto, drÅ¾ava in Zip',0),(535766,14883,'ba','Kota, negara, dan Zip',0),(535767,14883,'nl','Stad, staat en Zip',0),(535768,14883,'fi','Kaupunki, osavaltio ja Zip',0),(535769,14883,'no','By, stat og Zip',0),(535770,14883,'da','By, stat og Zip',0),(535771,14883,'ko','ë„ì‹œ, ì£¼ ë° ìš°íŽ¸ ë²ˆí˜¸',0),(535772,14883,'he','×¢×™×¨, ×ž×“×™× ×”, ×ž×™×§×•×“',0),(535773,14883,'el','Î ÏŒÎ»Î·Ï‚, Ï€Î¿Î»Î¹Ï„ÎµÎ¹Î±ÎºÎ¿ÏÏ‚ ÎºÎ±Î¹ Zip',0),(535774,14883,'zh','å¸‚ã€ å·žå’Œé‚®æ”¿ç¼–ç ',0),(535775,14883,'sv','Stad, stat och Zip',0),(535776,14883,'it','CittÃ , stato e Zip',0),(535777,14883,'tl','',0),(535778,14883,'th','à¸‹à¸´à¸•à¸µà¹‰ à¸£à¸±à¸ à¹à¸¥à¸°à¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œ',0),(535779,14883,'hi','à¤¶à¤¹à¤°, à¤°à¤¾à¤œà¥à¤¯ à¤”à¤° à¤œà¤¼à¤¿à¤ª',0),(535780,14883,'ms','Bandar, Negeri dan Zip',0),(535781,14883,'ar','Ø§Ù„Ù…Ø¯ÙŠÙ†Ø© ÙˆØ§Ù„Ø¯ÙˆÙ„Ø© ÙˆØ§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(535782,14883,'fr','Ville, Ã‰tat et Zip',0),(535783,14883,'jp','éƒ½å¸‚ã€çŠ¶æ…‹ãŠã‚ˆã³ã‚¸ãƒƒãƒ‘ãƒ¼',0),(535784,14883,'pt','Cidade, estado e CEP',0),(535785,14883,'ru','Ð“Ð¾Ñ€Ð¾Ð´Ð°, ÑˆÑ‚Ð°Ñ‚Ð° Ð¸ Zip',0),(535786,14883,'es','Ciudad, estado y Zip',0),(535787,14883,'de','Stadt, Bundesstaat und Postleitzahl',0),(535788,14883,'en','City, State And Zip',0),(535789,14884,'is','',0),(535790,14884,'dr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª',0),(535791,14884,'pr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª',0),(535792,14884,'tr','SipariÅŸ yok',0),(535793,14884,'pl','Nie zamÃ³wienia',0),(535794,14884,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(535795,14884,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø§Ø±ÛŒ',0),(535796,14884,'sr','ÐÐµÐ¼Ð° Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(535797,14884,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(535798,14884,'af','Geen bestellings',0),(535799,14884,'ro','Comenzi',0),(535800,14884,'et','Pole tellimusi',0),(535801,14884,'si','Ni bilo naroÄil',0),(535802,14884,'ba','Tidak ada order',0),(535803,14884,'nl','Geen Orders',0),(535804,14884,'fi','Tilaukset',0),(535805,14884,'no','Ingen ordrer',0),(535806,14884,'da','Ingen ordrer',0),(535807,14884,'ko','ì•„ë‹ˆ ì£¼ë¬¸',0),(535808,14884,'he','×¤×§×•×“×•×ª',0),(535809,14884,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹',0),(535810,14884,'zh','æ²¡æœ‰è®¢å•',0),(535811,14884,'sv','Inga order',0),(535812,14884,'it','Nessun ordine',0),(535813,14884,'tl','',0),(535814,14884,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(535815,14884,'hi','à¤•à¥‹à¤ˆ à¤‘à¤°à¥à¤¡à¤°à¥à¤¸ à¤¨à¤¹à¥€à¤‚',0),(535816,14884,'ms','Perintah tidak',0),(535817,14884,'ar','Ù„Ø§ Ø£ÙˆØ§Ù…Ø±',0),(535818,14884,'fr','Aucune commande',0),(535819,14884,'jp','æ³¨æ–‡ã®ãªã„ã§ã™ã€‚',0),(535820,14884,'pt','Nenhuma ordem',0),(535821,14884,'ru','ÐÐµÑ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(535822,14884,'es','No hay Ã³rdenes',0),(535823,14884,'de','Keine Bestellungen',0),(535824,14884,'en','No Orders',0),(535825,14885,'is','',0),(535826,14885,'dr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø§Ø²',0),(535827,14885,'pr','Ø¨Ø¯ÙˆÙ† Ø¯Ø³ØªÙˆØ±Ø§Øª Ø§Ø²',0),(535828,14885,'tr','Beri hiÃ§bir emir',0),(535829,14885,'pl','Nie zamÃ³wienia od',0),(535830,14885,'bg','ÐÑÐ¼Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¾Ñ‚',0),(535831,14885,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Û’ Ø¨Ø¹Ø¯',0),(535832,14885,'sr','ÐÐ¸ÐºÐ°ÐºÐ²Ð° Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ° Ð¾Ð´',0),(535833,14885,'vi','KhÃ´ng cÃ³ Ä‘Æ¡n Ä‘áº·t hÃ ng tá»«',0),(535834,14885,'af','Geen bestellings sedert',0),(535835,14885,'ro','Comenzi de',0),(535836,14885,'et','Tellimused alates',0),(535837,14885,'si','Brez naroÄil od',0),(535838,14885,'ba','Tidak ada order sejak',0),(535839,14885,'nl','Geen bestellingen sinds',0),(535840,14885,'fi','Tilaukset vuodesta',0),(535841,14885,'no','Ingen bestillinger siden',0),(535842,14885,'da','Ingen ordrer siden',0),(535843,14885,'ko','ì´í›„ ì•„ë¬´ ì£¼ë¬¸',0),(535844,14885,'he','×¤×§×•×“×•×ª ×ž××–',0),(535845,14885,'el','Î”ÎµÎ½ ÎºÎ±Ï„Î±Î´Î¹ÎºÎ¬Î¶ÎµÎ¹ Î±Ï€ÏŒ',0),(535846,14885,'zh','å› ä¸ºæ²¡æœ‰è®¢å•',0),(535847,14885,'sv','Inga order sedan',0),(535848,14885,'it','Nessun ordine dal',0),(535849,14885,'tl','',0),(535850,14885,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸•à¸±à¹‰à¸‡à¹à¸•à¹ˆ',0),(535851,14885,'hi','à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥‡ à¤•à¥‹à¤ˆ à¤†à¤¦à¥‡à¤¶',0),(535852,14885,'ms','Pesanan tidak sejak',0),(535853,14885,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø£ÙˆØ§Ù…Ø± Ù…Ù†Ø°',0),(535854,14885,'fr','Aucune commande depuis',0),(535855,14885,'jp','ä»¥æ¥æ³¨æ–‡ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(535856,14885,'pt','NÃ£o hÃ¡ ordens desde',0),(535857,14885,'ru','ÐÐµÑ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð², Ð½Ð°Ñ‡Ð¸Ð½Ð°Ñ Ñ',0),(535858,14885,'es','No hay Ã³rdenes desde',0),(535859,14885,'de','Keine AuftrÃ¤ge seit',0),(535860,14885,'en','No Orders Since',0),(535861,14886,'is','',0),(535862,14886,'dr','Ú©Ø§Ø±Ø¨Ø± Ø¨Ù‡ Ù„ÛŒØ³Øª',0),(535863,14886,'pr','Ú©Ø§Ø±Ø¨Ø± Ø¨Ù‡ Ù„ÛŒØ³Øª',0),(535864,14886,'tr','KullanÄ±cÄ± listesi',0),(535865,14886,'pl','Lista uÅ¼ytkownikÃ³w',0),(535866,14886,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ñ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(535867,14886,'ur','ØµØ§Ø±Ù ÙÛØ±Ø³Øª',0),(535868,14886,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(535869,14886,'vi','Danh sÃ¡ch ngÆ°á»i dÃ¹ng',0),(535870,14886,'af','Gebruiker lys',0),(535871,14886,'ro','Lista de utilizator',0),(535872,14886,'et','Kasutajate nimekiri',0),(535873,14886,'si','Seznam uporabnikov',0),(535874,14886,'ba','Daftar pengguna',0),(535875,14886,'nl','Gebruikerslijst',0),(535876,14886,'fi','KÃ¤yttÃ¤jÃ¤luettelo',0),(535877,14886,'no','Brukerlisten',0),(535878,14886,'da','Liste over brugere',0),(535879,14886,'ko','ì‚¬ìš©ìž ëª©ë¡',0),(535880,14886,'he','×¨×©×™×ž×ª ×ž×©×ª×ž×©×™×',0),(535881,14886,'el','Î›Î¯ÏƒÏ„Î± Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½',0),(535882,14886,'zh','ç”¨æˆ·åˆ—è¡¨',0),(535883,14886,'sv','AnvÃ¤ndarlista',0),(535884,14886,'it','Elenco utenti',0),(535885,14886,'tl','',0),(535886,14886,'th','à¸£à¸²à¸¢à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(535887,14886,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¥‚à¤šà¥€',0),(535888,14886,'ms','Senarai pengguna',0),(535889,14886,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(535890,14886,'fr','Liste des utilisateurs',0),(535891,14886,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ ãƒªã‚¹ãƒˆ',0),(535892,14886,'pt','Lista de usuÃ¡rios',0),(535893,14886,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(535894,14886,'es','Lista de usuarios',0),(535895,14886,'de','Benutzerliste',0),(535896,14886,'en','User List',0),(535897,14887,'is','',0),(535898,14887,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø·Ù„Ø¨ Ø¨Ù‡ Ø³Ø§Ù„ Ø¨Ø³ØªÙ‡ Ù†ÛŒØ³Øª',0),(535899,14887,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø§ÙØ²ÙˆØ¯Ù† Ù…Ø·Ù„Ø¨ Ø¨Ù‡ Ø³Ø§Ù„ Ø¨Ø³ØªÙ‡ Ù†ÛŒØ³Øª',0),(535900,14887,'tr','GiriÅŸ kapalÄ± yÄ±la ekleyemezsiniz',0),(535901,14887,'pl','Nie moÅ¼na dodaÄ‡ wpis do zamkniÄ™tego roku',0),(535902,14887,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(535903,14887,'ur','Ø¯Ø§Ø®Ù„Û’ Ú©Û’ Ù„Ø¦Û’ Ø¨Ù†Ø¯ Ø³Ø§Ù„ Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(535904,14887,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸ ÑÑ‚Ð°Ð²ÐºÑƒ Ñƒ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ñƒ Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(535905,14887,'vi','KhÃ´ng thá»ƒ thÃªm má»¥c nháº­p Ä‘á»ƒ Ä‘Ã³ng cá»­a nÄƒm',0),(535906,14887,'af','Inskrywing kan voeg om geslote jaar',0),(535907,14887,'ro','Imposibil de adÄƒugat intrare an Ã®nchis',0),(535908,14887,'et','Ei saa lisada kirjet suletud aasta',0),(535909,14887,'si','Ni mogoÄe dodati vnos zakljuÄeno leto',0),(535910,14887,'ba','Tidak dapat menambahkan entri ke ditutup tahun',0),(535911,14887,'nl','Vermelding kan niet toevoegen aan gesloten jaar',0),(535912,14887,'fi','Ei voi lisÃ¤tÃ¤ merkinnÃ¤n suljetun tilikauden',0),(535913,14887,'no','Kan ikke legge til oppfÃ¸ring lukket Ã¥r',0),(535914,14887,'da','Kan ikke fÃ¸je posten til lukkede Ã¥r',0),(535915,14887,'ko','ë‹«ížŒëœ 1 ë…„ í•­ëª©ì— ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(535916,14887,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×•×¡×™×£ ×¢×¨×š ×œ×©× ×” ×¡×’×•×¨',0),(535917,14887,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„ÏŒ Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï„Î·Î½ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÏƒÎµ ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŒ Î­Ï„Î¿Ï‚',0),(535918,14887,'zh','æ— æ³•å°†æ¡ç›®æ·»åŠ åˆ°å·²å…³é—­ä¸€å¹´',0),(535919,14887,'sv','Kan inte lÃ¤gga till post stÃ¤ngda Ã¥r',0),(535920,14887,'it','Non Ã¨ possibile aggiungere la voce all\'anno chiuso',0),(535921,14887,'tl','',0),(535922,14887,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¸›à¸´à¸”à¸›à¸µ',0),(535923,14887,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¬à¤‚à¤¦ à¤µà¤°à¥à¤· à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹à¤¡à¤¼ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(535924,14887,'ms','Tidak boleh menambah kemasukan ke tahun tertutup',0),(535925,14887,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¶Ø§ÙØ© Ø¥Ø¯Ø®Ø§Ù„ Ù„Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ù†ØªÙ‡ÙŠØ©',0),(535926,14887,'fr','Impossible d\'ajouter entrÃ©e pour l\'exercice clÃ´turÃ©',0),(535927,14887,'jp','é–‰ã˜ãŸå¹´ã«ã‚¨ãƒ³ãƒˆãƒªã‚’è¿½åŠ ã§ãã¾ã›ã‚“ã€‚',0),(535928,14887,'pt','NÃ£o Ã© possÃ­vel adicionar entrada de ano fechado',0),(535929,14887,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð² Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¾Ð¹ Ð³Ð¾Ð´',0),(535930,14887,'es','No se puede agregar entrada al aÃ±o cerrado',0),(535931,14887,'de','Eintrag kann nicht in geschlossenen Jahr hinzugefÃ¼gt werden.',0),(535932,14887,'en','Cannot Add Entry To Closed Year',0),(535933,14888,'is','',0),(535934,14888,'dr','Ú©ÙˆÙ¾Ù† Ø§Ø² Ø³Ø§Ù„ Ø¨Ø³ØªÙ‡ Ø´Ø¯ Unpost Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯',0),(535935,14888,'pr','Ú©ÙˆÙ¾Ù† Ø§Ø² Ø³Ø§Ù„ Ø¨Ø³ØªÙ‡ Ø´Ø¯ Unpost Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯',0),(535936,14888,'tr','FiÅŸler kapalÄ± bir yÄ±l Unpost olamaz',0),(535937,14888,'pl','Nie Unpost bony z zamkniÄ™tym roku',0),(535938,14888,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Unpost Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸ Ð¾Ñ‚ Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡Ð¸Ð»Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(535939,14888,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ Ø´Ú©Ù„ Ø§ÛŒÚ© Ø¨Ù†Ø¯ Ø³Ø§Ù„ Ø³Û’ Ø§Ù†Ù¾ÙˆØ³Ù¹ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(535940,14888,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¿Ð¾Ð²ÑƒÐ¸Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ Ð¸Ð· Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ñƒ Ð³Ð¾Ð´Ð¸Ð½Ñƒ',0),(535941,14888,'vi','KhÃ´ng thá»ƒ Unpost chá»©ng tá»« tá»« má»™t nÄƒm Ä‘Ã³ng cá»­a',0),(535942,14888,'af','Bewyse van \'n geslote jaar kan Unpost',0),(535943,14888,'ro','Nu pot Unpost bonuri la un an, Ã®nchis',0),(535944,14888,'et','Ei saa Unpost kanded suletud aasta',0),(535945,14888,'si','Ne morem Unpost kuponi iz zakljuÄeno leto',0),(535946,14888,'ba','Tidak Unpost voucher dari tahun tertutup',0),(535947,14888,'nl','Vouchers kunnen niet Unpost van een gesloten jaar',0),(535948,14888,'fi','Ei Unpost suljetun tilikauden tositteet',0),(535949,14888,'no','Kan ikke Unpost kuponger fra et lukket Ã¥r',0),(535950,14888,'da','Kan ikke Unpost gavekort fra en lukket Ã¥r',0),(535951,14888,'ko','ë‹«ížŒëœ 1 ë…„ì—ì„œ ìƒí’ˆê¶Œì„ Unpost ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(535952,14888,'he','×œ× ×™×›×•×œ Unpost ×©×•×‘×¨×™× ×ž×”×©× ×” ×”×¡×’×•×¨×”',0),(535953,14888,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÏŽ Î½Î± Unpost ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î± Î±Ï€ÏŒ Î­Î½Î± ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŒ Î­Ï„Î¿Ï‚',0),(535954,14888,'zh','ä¸èƒ½å°é—­åŒæ¯” Unpost å‡­è¯',0),(535955,14888,'sv','Kan inte Unpost kuponger frÃ¥n ett stÃ¤ngt Ã¥r',0),(535956,14888,'it','Non puÃ² Unpost buoni da un anno chiuso',0),(535957,14888,'tl','',0),(535958,14888,'th','à¹„à¸¡à¹ˆ Unpost à¸ªà¸³à¸„à¸±à¸à¸ˆà¸²à¸à¸›à¸µà¸›à¸´à¸”',0),(535959,14888,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤à¤• à¤¬à¤‚à¤¦ à¤µà¤°à¥à¤· à¤¸à¥‡ Unpost à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(535960,14888,'ms','Tidak boleh Unpost baucer dari tahun tertutup',0),(535961,14888,'ar','Ù„Ø§ Ø£ÙˆÙ†Ø¨ÙˆØ³Øª Ù‚Ø³Ø§Ø¦Ù… Ù…Ù† Ø³Ù†Ø© Ù…ØºÙ„Ù‚Ø©',0),(535962,14888,'fr','Ne peut pas Unpost bons d\'un exercice clÃ´turÃ©',0),(535963,14888,'jp','é–‰ã˜ãŸå¹´ã‹ã‚‰ãƒã‚¦ãƒã‚¡ã‚’è¨˜å¸³ã§ãã¾ã›ã‚“ã€‚',0),(535964,14888,'pt','NÃ£o posso Unpost vales de um ano fechado',0),(535965,14888,'ru','ÐÐµÐ»ÑŒÐ·Ñ Unpost Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹ Ð¾Ñ‚ Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¾Ð³Ð¾ Ð³Ð¾Ð´Ð°',0),(535966,14888,'es','No se anunciÃ³ los vales de un aÃ±o cerrado',0),(535967,14888,'de','Gutscheine kÃ¶nnen nicht von einem geschlossenen Jahr Unpost werden.',0),(535968,14888,'en','Cannot Unpost Vouchers From A Closed Year',0),(535969,14889,'is','',0),(535970,14889,'dr','Ú©ÙˆÙ¾Ù† Ø¯Ø± unpost',0),(535971,14889,'pr','Ú©ÙˆÙ¾Ù† Ø¯Ø± unpost',0),(535972,14889,'tr','YayÄ±nlanan kuponlarÄ± unpost',0),(535973,14889,'pl','Unpost bony wysÅ‚ana na',0),(535974,14889,'bg','Unpost Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸, Ð¿ÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½ Ð½Ð°',0),(535975,14889,'ur','ÙˆØ§Ø¤Ú†Ø± Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ù¾Ø± Ø§Ù†Ù¾ÙˆØ³Ù¹',0),(535976,14889,'sr','ÐŸÐ¾Ð²ÑƒÐ¸Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸ ÐŸÐ¾ÑÑ‚ÐµÐ´',0),(535977,14889,'vi','Unpost chá»©ng tá»« Ä‘Æ°á»£c Ä‘Äƒng trÃªn',0),(535978,14889,'af','Unpost bewyse gepos op',0),(535979,14889,'ro','Unpost vouchere postat pe',0),(535980,14889,'et','Unpost sisestatud kanded',0),(535981,14889,'si','Unpost Bone objavljeno na',0),(535982,14889,'ba','Unpost voucher yang dikirim pada',0),(535983,14889,'nl','Vouchers Gepost op unpost',0),(535984,14889,'fi','Unpost tositteet lÃ¤hetetty',0),(535985,14889,'no','Unpost kuponger postet pÃ¥',0),(535986,14889,'da','Unpost gavekort sendt pÃ¥',0),(535987,14889,'ko','ìƒí’ˆê¶Œì— ê²Œì‹œ unpost',0),(535988,14889,'he','Unpost ×©×•×‘×¨×™× ×¤×•×¨×¡× ×‘',0),(535989,14889,'el','Unpost ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î±, Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏ„Î·ÎºÎµ ÏƒÏ„Î¹Ï‚',0),(535990,14889,'zh','Unpost ä¸Šè¿‡å¸çš„å‡­è¯',0),(535991,14889,'sv','Unpost kuponger postat pÃ¥',0),(535992,14889,'it','Unpost buoni pubblicati su',0),(535993,14889,'tl','',0),(535994,14889,'th','Unpost à¸ªà¸³à¸„à¸±à¸à¹‚à¸žà¸ª',0),(535995,14889,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤ªà¤° à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ unpost',0),(535996,14889,'ms','Unpost baucar yang dikirim',0),(535997,14889,'ar','Ø£ÙˆÙ†Ø¨ÙˆØ³Øª Ø§Ù„Ù‚Ø³Ø§Ø¦Ù… Ø§Ù„ØªÙŠ Ù†Ø´Ø±Øª ÙÙŠ',0),(535998,14889,'fr','Unpost bons postÃ©es',0),(535999,14889,'jp','è»¢è¨˜ã•ã‚ŒãŸä¼ç¥¨ã‚’è¨˜å¸³ã—ã¾ã™ã€‚',0),(536000,14889,'pt','Unpost Vouchers postados em',0),(536001,14889,'ru','Unpost Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹, ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¾',0),(536002,14889,'es','AnunciÃ³ vales publicados en',0),(536003,14889,'de','Gutscheine geschrieben am unpost',0),(536004,14889,'en','Unpost Vouchers Posted On',0),(536005,14890,'is','',0),(536006,14890,'dr','Ø­Ø³Ø§Ø¨ Ø­Ø³Ø§Ø¨ Ø¯Ø±ÛŒØ§ÙØªÙ†ÛŒ GL',0),(536007,14890,'pr','Ø­Ø³Ø§Ø¨ Ø­Ø³Ø§Ø¨ Ø¯Ø±ÛŒØ§ÙØªÙ†ÛŒ GL',0),(536008,14890,'tr','HesaplarÄ±na alacak hesaplarÄ± GL hesabÄ±',0),(536009,14890,'pl','Konta konto naleÅ¼noÅ›ci GL',0),(536010,14890,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(536011,14890,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¬Ø§Ø¦Ø² Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(536012,14890,'sr','ÐšÐ¾Ð½Ñ‚Ð° Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(536013,14890,'vi','TÃ i khoáº£n pháº£i thu GL tÃ i khoáº£n',0),(536014,14890,'af','Rekeninge verskuldig GL rekening',0),(536015,14890,'ro','Conturi de Ã®ncasat GL cont',0),(536016,14890,'et','Kontode MÃ¼Ã¼gireskontro pearaamatukontole',0),(536017,14890,'si','RaÄun raÄuni terjatev GL',0),(536018,14890,'ba','Account piutang GL Account',0),(536019,14890,'nl','Accounts Receivable GL Account',0),(536020,14890,'fi','TilejÃ¤ myyntireskontran GL tili',0),(536021,14890,'no','Kontoer fordringer gi-konto',0),(536022,14890,'da','Tilgodehavende GL konto',0),(536023,14890,'ko','ê³„ì • ë¯¸ìˆ˜ê¸ˆ GL ê³„ì •',0),(536024,14890,'he','×—×©×‘×•×Ÿ ×—×©×‘×•× ×•×ª ×œ×’×‘×™×™×” GL',0),(536025,14890,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ ÎµÎ¹ÏƒÏ€ÏÎ±ÎºÏ„Î­Î¿Ï…Ï‚ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(536026,14890,'zh','å¸æˆ·åº”æ”¶å¸æ¬¾æ€»å¸ç§‘ç›®',0),(536027,14890,'sv','Kontona Kundfordringar GL konto',0),(536028,14890,'it','Accounts Receivable GL Account',0),(536029,14890,'tl','',0),(536030,14890,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸¥à¸¹à¸à¸«à¸™à¸µà¹‰à¸šà¸±à¸à¸Šà¸µ',0),(536031,14890,'hi','à¤–à¤¾à¤¤à¥‹à¤‚ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¯ GL à¤–à¤¾à¤¤à¥‡',0),(536032,14890,'ms','Akaun belum terima GL akaun',0),(536033,14890,'ar','Ø­Ø³Ø§Ø¨Ø§Øª Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ù‚Ø¨Ø¶ GL Ø­Ø³Ø§Ø¨',0),(536034,14890,'fr','Comptes dÃ©biteurs GL compte',0),(536035,14890,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆå£²æŽ›é‡‘å‹˜å®šã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(536036,14890,'pt','Contas a receber GL conta',0),(536037,14890,'ru','Ð¡Ñ‡ÐµÑ‚Ð¾Ð² Ðº Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸ÑŽ GL ÑÑ‡ÐµÑ‚Ð°',0),(536038,14890,'es','Cuenta de cuentas por cobrar GL',0),(536039,14890,'de','Accounts Receivable Sako',0),(536040,14890,'en','Accounts Receivable GL Account',0),(536041,14891,'is','',0),(536042,14891,'dr','Ù†ØªÙˆØ§Ù†Ø³Øª Ù…Ø´ØªØ±ÛŒ Ù¾ÛŒØ¯Ø§ Ú©Ù†Ø¯ Ø¨Ù†Ø§Ø¨Ø±Ø§ÛŒÙ† Ø¨Ø¯ÙˆÙ† ÙØ§Ú©ØªÙˆØ± Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡',0),(536043,14891,'pr','Ù†ØªÙˆØ§Ù†Ø³Øª Ù…Ø´ØªØ±ÛŒ Ù¾ÛŒØ¯Ø§ Ú©Ù†Ø¯ Ø¨Ù†Ø§Ø¨Ø±Ø§ÛŒÙ† Ø¨Ø¯ÙˆÙ† ÙØ§Ú©ØªÙˆØ± Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡',0),(536044,14891,'tr','MÃ¼ÅŸteri oluÅŸturulmuÅŸ hiÃ§bir fatura bulunamadÄ±',0),(536045,14891,'pl','Nie mogÅ‚em znaleÅºÄ‡ klienta, wiÄ™c nie ma faktury tworzone',0),(536046,14891,'bg','ÐÐµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚, Ñ‚Ð°ÐºÐ° Ñ‡Ðµ Ð½ÑÐ¼Ð° ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(536047,14891,'ur','Ú©Ø³Ù¹Ù…Ø± Ø¨Ù†Ø§ÛŒØ§ ØªÙˆ Ú©ÙˆØ¦ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÛÛŒÚº ÚˆÚ¾ÙˆÙ†Úˆ Ø³Ú©Ø§',0),(536048,14891,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ ÐºÑƒÐ¿Ñ†Ð° Ñ‚Ð°ÐºÐ¾ Ð´Ð° Ð½ÐµÐ¼Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð°',0),(536049,14891,'vi','KhÃ´ng thá»ƒ tÃ¬m tháº¥y khÃ¡ch hÃ ng nhÆ° váº­y khÃ´ng cÃ³ hÃ³a Ä‘Æ¡n táº¡o',0),(536050,14891,'af','Kon dus geen faktuur geskep kliÃ«nt vind nie',0),(536051,14891,'ro','Nu am putut gÄƒsi clienÅ£i astfel Ã®ncÃ¢t nici o facturÄƒ creatÄƒ',0),(536052,14891,'et','Ei leidnud klient ei ole loodud arve',0),(536053,14891,'si','Ni mogoÄe najti kupca tako faktura ustvaril',0),(536054,14891,'ba','Tidak bisa menemukan pelanggan faktur sehingga tidak diciptakan',0),(536055,14891,'nl','Konden niet vondst klant dus geen factuur gemaakt',0),(536056,14891,'fi','Laskua ei lÃ¶ytynyt asiakas joten ei luotu',0),(536057,14891,'no','Finner ikke kunden sÃ¥ ingen fakturaen opprettet',0),(536058,14891,'da','Kunne ikke finde kundens faktura sÃ¥ ikke lavet',0),(536059,14891,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ê³ ê° ê·¸ë ‡ê²Œ ì†¡ìž¥ ìƒì„±',0),(536060,14891,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ×œ×§×•×—×•×ª ××– ×‘×œ×™ ×—×©×‘×•× ×™×ª ×©× ×•×¦×¨×•',0),(536061,14891,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Ï€ÎµÎ»Î¬Ï„Î· Î­Ï„ÏƒÎ¹ Î´ÎµÎ½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ',0),(536062,14891,'zh','æ‰¾ä¸åˆ°å®¢æˆ·åˆ›å»ºæ‰€ä»¥æ²¡æœ‰å‘ç¥¨',0),(536063,14891,'sv','Kunde inte hitta kunden sÃ¥ ingen faktura skapas',0),(536064,14891,'it','Non poteva trovare cliente quindi senza fattura creata',0),(536065,14891,'tl','',0),(536066,14891,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸¥à¸¹à¸à¸„à¹‰à¸²à¸ˆà¸¶à¸‡à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸ªà¸£à¹‰à¸²à¸‡',0),(536067,14891,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤² à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ à¤¤à¥‹ à¤•à¥‹à¤ˆ à¤šà¤¾à¤²à¤¾à¤¨ à¤¬à¤¨à¤¾à¤',0),(536068,14891,'ms','Tidak dapat mencari pelanggan jadi tiada invois yang dicipta',0),(536069,14891,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø­ØªÙ‰ Ù„Ø§ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§',0),(536070,14891,'fr','Ne pouvait pas trouver client donc pas facture crÃ©Ã©e',0),(536071,14891,'jp','ãªã„ã®ã§ä½œæˆã•ã‚Œã‚‹è«‹æ±‚æ›¸ã®é¡§å®¢ã‚’è¦‹ã¤ã‘ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(536072,14891,'pt','NÃ£o foi possÃ­vel localizar cliente entÃ£o nenhuma factura criada',0),(536073,14891,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°, Ð¿Ð¾ÑÑ‚Ð¾Ð¼Ñƒ Ð½Ðµ ÑÑ‡ÐµÑ‚ ÑÐ¾Ð·Ð´Ð°Ð½',0),(536074,14891,'es','No se pudo encontrar al cliente sin factura creada',0),(536075,14891,'de','Konnte keine Kunden finden also keine Rechnung erstellt',0),(536076,14891,'en','Could Not Find Customer So No Invoice Created',0),(536077,14892,'is','',0),(536078,14892,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙˆØ§Ø±Ø¯',0),(536079,14892,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙˆØ§Ø±Ø¯',0),(536080,14892,'tr','Giderleri baÅŸarÄ±yla alÄ±ndÄ±',0),(536081,14892,'pl','Wydatki zostaÅ‚y zaimportowane pomyÅ›lnie',0),(536082,14892,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(536083,14892,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø± Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(536084,14892,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ²ÐµÐ·ÐµÐ½Ðµ',0),(536085,14892,'vi','Chi phÃ­ nháº­p thÃ nh cÃ´ng',0),(536086,14892,'af','Uitgawes suksesvol ingevoer',0),(536087,14892,'ro','Cheltuielile importat cu succes',0),(536088,14892,'et','Kulud edukalt imporditud',0),(536089,14892,'si','StroÅ¡kov uspeÅ¡no uvoÅ¾en',0),(536090,14892,'ba','Biaya berhasil diimpor',0),(536091,14892,'nl','Kosten geÃ¯mporteerd',0),(536092,14892,'fi','Kulut tuonti onnistui',0),(536093,14892,'no','Utgifter importert',0),(536094,14892,'da','Udgifter importeret',0),(536095,14892,'ko','ì„±ê³µì ìœ¼ë¡œ ê°€ì ¸ì˜¨ ë¹„ìš©',0),(536096,14892,'he','×”×•×¦××•×ª ×™×•×‘××• ×‘×”×¦×œ×—×”',0),(536097,14892,'el','ÎˆÎ¾Î¿Î´Î± Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(536098,14892,'zh','å·²æˆåŠŸå¯¼å…¥çš„è´¹ç”¨',0),(536099,14892,'sv','Kostnader har importerats',0),(536100,14892,'it','Spese importate correttamente',0),(536101,14892,'tl','',0),(536102,14892,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¹ƒà¸™à¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(536103,14892,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ à¤µà¥à¤¯à¤¯',0),(536104,14892,'ms','Perbelanjaan yang berjaya diimport',0),(536105,14892,'ar','Ù†ÙÙ‚Ø§Øª Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(536106,14892,'fr','Frais ont bien Ã©tÃ© importÃ©es',0),(536107,14892,'jp','æ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚ŒãŸè²»ç”¨',0),(536108,14892,'pt','Despesas importadas com Ãªxito',0),(536109,14892,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð½Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(536110,14892,'es','Gastos importados con Ã©xito',0),(536111,14892,'de','Aufwendungen, die erfolgreich importiert',0),(536112,14892,'en','Expenses Imported Successfully',0),(536113,14893,'is','',0),(536114,14893,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙˆØ§Ø±Ø¯Ø§Øª',0),(536115,14893,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙˆØ§Ø±Ø¯Ø§Øª',0),(536116,14893,'tr','Alma giderleri',0),(536117,14893,'pl','Koszty importu',0),(536118,14893,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(536119,14893,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(536120,14893,'sr','Ð£Ð²Ð¾Ð· Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(536121,14893,'vi','Chi phÃ­ nháº­p kháº©u',0),(536122,14893,'af','Invoer uitgawes',0),(536123,14893,'ro','Cheltuielile de import',0),(536124,14893,'et','Impordi kulud',0),(536125,14893,'si','Uvoznih stroÅ¡kov',0),(536126,14893,'ba','Biaya impor',0),(536127,14893,'nl','Importeren van kosten',0),(536128,14893,'fi','Tuo kulut',0),(536129,14893,'no','Importere utgifter',0),(536130,14893,'da','Importere udgifter',0),(536131,14893,'ko','ìˆ˜ìž… ë¹„ìš©',0),(536132,14893,'he','×”×•×¦××•×ª ×™×™×‘×•×',0),(536133,14893,'el','ÎˆÎ¾Î¿Î´Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(536134,14893,'zh','è¿›å£è´¹ç”¨',0),(536135,14893,'sv','Importera kostnader',0),(536136,14893,'it','Spese di importazione',0),(536137,14893,'tl','',0),(536138,14893,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(536139,14893,'hi','à¤†à¤¯à¤¾à¤¤ à¤–à¤°à¥à¤š',0),(536140,14893,'ms','Perbelanjaan import',0),(536141,14893,'ar','Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(536142,14893,'fr','Frais d\'importation',0),(536143,14893,'jp','è¼¸å…¥ã®è²»ç”¨',0),(536144,14893,'pt','Despesas de importaÃ§Ã£o',0),(536145,14893,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð½Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(536146,14893,'es','Gastos de importaciÃ³n',0),(536147,14893,'de','Import Kosten',0),(536148,14893,'en','Import Expenses',0),(536149,14894,'is','',0),(536150,14894,'dr','Ù‡Ø²ÛŒÙ†Ù‡ ÙØ§ÛŒÙ„ Ø§Ú©Ø³Ù„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(536151,14894,'pr','Ù‡Ø²ÛŒÙ†Ù‡ ÙØ§ÛŒÙ„ Ø§Ú©Ø³Ù„ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(536152,14894,'tr','Masraf Excel dosyasÄ±nÄ± seÃ§in',0),(536153,14894,'pl','Wybierz plik programu Excel koszt',0),(536154,14894,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ¼ÐµÑ‚ÐºÐ° Excel Ñ„Ð°Ð¹Ð»',0),(536155,14894,'ur','Ø®Ø±Ú†Û’ Excel Ù…Ø³Ù„ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(536156,14894,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð° Ð•xÑ†ÐµÐ» Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð°',0),(536157,14894,'vi','Chá»n chi phÃ­ Excel táº­p tin',0),(536158,14894,'af','Kies uitgawe Excel lÃªer',0),(536159,14894,'ro','SelectaÅ£i fiÅŸierul Excel cheltuieli',0),(536160,14894,'et','Valige kulu Exceli fail',0),(536161,14894,'si','Izberi Excelovo datoteko stroÅ¡ke',0),(536162,14894,'ba','Pilih File Excel biaya',0),(536163,14894,'nl','Selecteer kosten Excel-bestand',0),(536164,14894,'fi','Valitse kuluraportin Excel-tiedosto',0),(536165,14894,'no','Velg bekostning Excel-fil',0),(536166,14894,'da','VÃ¦lg udgift Excel fil',0),(536167,14894,'ko','ë¹„ìš© Excel íŒŒì¼ ì„ íƒ',0),(536168,14894,'he','×‘×—×¨ ×§×•×‘×¥ Excel ×”×•×¦××•×ª',0),(536169,14894,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î±ÏÏ‡ÎµÎ¯Î¿ Excel Î´Î±Ï€Î¬Î½Î·',0),(536170,14894,'zh','é€‰æ‹©è´¹ç”¨çš„ Excel æ–‡ä»¶',0),(536171,14894,'sv','VÃ¤lj bekostnad Excel-fil',0),(536172,14894,'it','Selezionare il File di Excel spese',0),(536173,14894,'tl','',0),(536174,14894,'th','à¹€à¸¥à¸·à¸­à¸à¹à¸Ÿà¹‰à¸¡ Excel à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢',0),(536175,14894,'hi','à¤µà¥à¤¯à¤¯ Excel à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(536176,14894,'ms','Pilih fail Excel perbelanjaan',0),(536177,14894,'ar','Ø­Ø¯Ø¯ Ù…Ù„Ù Excel Ø­Ø³Ø§Ø¨',0),(536178,14894,'fr','SÃ©lectionnez le fichier Excel dÃ©penses',0),(536179,14894,'jp','çµŒè²»ã® Excel ãƒ•ã‚¡ã‚¤ãƒ«ã‚’é¸æŠžã—ã¾ã™',0),(536180,14894,'pt','Selecione o arquivo do Excel de despesa',0),(536181,14894,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ„Ð°Ð¹Ð» Excel ÑÑ‡ÐµÑ‚',0),(536182,14894,'es','Seleccione el archivo de Excel gastos',0),(536183,14894,'de','WÃ¤hlen Sie Kosten-Excel-Datei',0),(536184,14894,'en','Select Expense Excel File',0),(536185,14895,'is','',0),(536186,14895,'dr','ÙˆØ§Ø­Ø¯ ØºÛŒØ± ÙØ¹Ø§Ù„ Ø§Ø³Øª',0),(536187,14895,'pr','ÙˆØ§Ø­Ø¯ ØºÛŒØ± ÙØ¹Ø§Ù„ Ø§Ø³Øª',0),(536188,14895,'tr','Birimi etkin deÄŸil',0),(536189,14895,'pl','Jednostka jest nieaktywny',0),(536190,14895,'bg','Ð•Ð´Ð¸Ð½Ð¸Ñ†Ð° Ðµ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð°',0),(536191,14895,'ur','ÛŒÙˆÙ†Ù¹ ØºÛŒØ± ÙØ¹Ø§Ù„ ÛÛ’ Û”',0),(536192,14895,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸Ñ†Ð° Ñ˜Ðµ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð°',0),(536193,14895,'vi','ÄÆ¡n vá»‹ lÃ  khÃ´ng hoáº¡t Ä‘á»™ng',0),(536194,14895,'af','Eenheid Is onaktief',0),(536195,14895,'ro','Unitatea este inactiv',0),(536196,14895,'et','Ãœksus pole aktiivne',0),(536197,14895,'si','Enota je neaktivna',0),(536198,14895,'ba','Unit ini tidak aktif',0),(536199,14895,'nl','Eenheid Is inactief',0),(536200,14895,'fi','YksikkÃ¶ ei ole kÃ¤ytÃ¶ssÃ¤',0),(536201,14895,'no','Enheten er inaktiv',0),(536202,14895,'da','Enheden er inaktiv',0),(536203,14895,'ko','ë‹¨ìœ„ëŠ” í™œì„±',0),(536204,14895,'he','×™×—×™×“×” ××™× ×• ×¤×¢×™×œ',0),(536205,14895,'el','ÎœÎ¿Î½Î¬Î´Î± ÎµÎ¯Î½Î±Î¹ Î±Î½ÎµÎ½ÎµÏÎ³ÏŒ',0),(536206,14895,'zh','å•ä½å¤„äºŽéžæ´»åŠ¨çŠ¶æ€',0),(536207,14895,'sv','Enheten Ã¤r inaktiv',0),(536208,14895,'it','UnitÃ  Ã¨ inattivo',0),(536209,14895,'tl','',0),(536210,14895,'th','à¸«à¸™à¹ˆà¸§à¸¢à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(536211,14895,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯ à¤°à¤¹à¤¤à¤¾ à¤¹à¥ˆ',0),(536212,14895,'ms','Unit tidak aktif',0),(536213,14895,'ar','ÙˆØ­Ø¯Ø© ØºÙŠØ± Ù†Ø´Ø·',0),(536214,14895,'fr','UnitÃ© est Inactive',0),(536215,14895,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆã¯ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã§ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(536216,14895,'pt','Unidade estÃ¡ inativa',0),(536217,14895,'ru','ÐŸÐ¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ðµ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¾',0),(536218,14895,'es','Unidad estÃ¡ inactivo',0),(536219,14895,'de','Einheit ist inaktiv',0),(536220,14895,'en','Unit Is Inactive',0),(536221,14896,'is','',0),(536222,14896,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¬Ø²Ø¦ÛŒØ§Øª Ø¯Ø³ØªÙ‡',0),(536223,14896,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¬Ø²Ø¦ÛŒØ§Øª Ø¯Ø³ØªÙ‡',0),(536224,14896,'tr','Toplu iÅŸlem ayrÄ±ntÄ±larÄ±nÄ± gÃ¶rÃ¼ntÃ¼leme',0),(536225,14896,'pl','Zobacz szczegÃ³Å‚y partii',0),(536226,14896,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð¿Ð°Ñ€Ñ‚Ð¸Ð´Ð°',0),(536227,14896,'ur','Ø¨ÛŒÚ† ØªÙØ§ØµÛŒÙ„ Ù…Ù†Ø¸Ø±',0),(536228,14896,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð´ÐµÑ‚Ð°Ñ™Ð° Ð·Ð° Ð³Ñ€ÑƒÐ¿Ðµ',0),(536229,14896,'vi','Xem thÃ´ng tin chi tiáº¿t lÃ´',0),(536230,14896,'af','Bekyk bondel besonderhede',0),(536231,14896,'ro','Vezi lotul detalii',0),(536232,14896,'et','Partii Ã¼ksikasjad',0),(536233,14896,'si','Pogled serije podrobnosti',0),(536234,14896,'ba','Lihat Batch rincian',0),(536235,14896,'nl','Weergave Batch Details',0),(536236,14896,'fi','NÃ¤ytÃ¤ erÃ¤n tiedot',0),(536237,14896,'no','Vis Batch detaljer',0),(536238,14896,'da','Se Batch detaljer',0),(536239,14896,'ko','ì¼ê´„ ì²˜ë¦¬ ì„¸ë¶€ ì •ë³´ ë³´ê¸°',0),(536240,14896,'he','×”×¦×’×ª ×¤×¨×˜×™× ××¦×•×•×”',0),(536241,14896,'el','ÎœÎ±Î¶Î¹ÎºÎ® Ï€ÏÎ¿Î²Î¿Î»Î® Î»ÎµÏ€Ï„Î¿Î¼ÎµÏÎµÎ¹ÏŽÎ½',0),(536242,14896,'zh','æŸ¥çœ‹æ‰¹æ¬¡è¯¦ç»†ä¿¡æ¯',0),(536243,14896,'sv','Visa batchdetaljer',0),(536244,14896,'it','Maggiori dettagli Batch',0),(536245,14896,'tl','',0),(536246,14896,'th','à¸”à¸¹à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸Šà¸¸à¸”',0),(536247,14896,'hi','à¤¬à¥ˆà¤š à¤µà¤¿à¤µà¤°à¤£ à¤¦à¥‡à¤–à¥‡à¤‚',0),(536248,14896,'ms','Lihat butiran Batch',0),(536249,14896,'ar','Ø¹Ø±Ø¶ ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¯ÙØ¹Ø§Øª',0),(536250,14896,'fr','Voir les dÃ©tails de lot',0),(536251,14896,'jp','ãƒãƒƒãƒã®è©³ç´°ã®è¡¨ç¤º',0),(536252,14896,'pt','Ver detalhes do lote',0),(536253,14896,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ð¹ Ð¾ Ð¿Ð°ÐºÐµÑ‚Ðµ',0),(536254,14896,'es','Ver detalles de la hornada',0),(536255,14896,'de','Batch-Details anzeigen',0),(536256,14896,'en','View Batch Details',0),(536257,14897,'is','',0),(536258,14897,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø¯Ø±Ø¢Ù…Ø¯',0),(536259,14897,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ Ø¯Ø±Ø¢Ù…Ø¯',0),(536260,14897,'tr','AlÄ±nan gelir verileri',0),(536261,14897,'pl','Dochody importowanych danych',0),(536262,14897,'bg','Ð”Ð°Ð½Ð½Ð¸Ñ‚Ðµ Ð·Ð° Ð²Ð½ÐµÑÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(536263,14897,'ur','Ú©ÙˆØ§Ø¦Ù Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û Ø¢Ù…Ø¯Ù†ÛŒ',0),(536264,14897,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸ ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸ Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°',0),(536265,14897,'vi','Dá»¯ liá»‡u doanh thu nháº­p kháº©u',0),(536266,14897,'af','Ingevoerde inkomste Data',0),(536267,14897,'ro','Datele importate venituri',0),(536268,14897,'et','Imporditud tulu andmed',0),(536269,14897,'si','UvoÅ¾ene prihodkov podatkov',0),(536270,14897,'ba','Data impor pendapatan',0),(536271,14897,'nl','GeÃ¯mporteerde inkomsten gegevens',0),(536272,14897,'fi','Tuodut tuloihin',0),(536273,14897,'no','Importerte inntekter Data',0),(536274,14897,'da','Importerede indtÃ¦gter Data',0),(536275,14897,'ko','ê°€ì ¸ì˜¨ëœ ìˆ˜ìµ ë°ì´í„°',0),(536276,14897,'he','× ×ª×•× ×™ ×”×›× ×¡×•×ª ×ž×™×•×‘××™×',0),(536277,14897,'el','Î•Î¹ÏƒÎ±Î³ÏŒÎ¼ÎµÎ½Î± Î­ÏƒÎ¿Î´Î±',0),(536278,14897,'zh','å¯¼å…¥çš„æ”¶å…¥æ•°æ®',0),(536279,14897,'sv','Importerade inkomster Data',0),(536280,14897,'it','Dati importati entrate',0),(536281,14897,'tl','',0),(536282,14897,'th','à¸£à¸²à¸¢à¹„à¸”à¹‰à¸™à¸³à¹€à¸‚à¹‰à¸²à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(536283,14897,'hi','à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ à¤°à¤¾à¤œà¤¸à¥à¤µ à¤¡à¥‡à¤Ÿà¤¾',0),(536284,14897,'ms','Hasil import Data',0),(536285,14897,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¥ÙŠØ±Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(536286,14897,'fr','DonnÃ©es sur les recettes importÃ©es',0),(536287,14897,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚ŒãŸå£²ä¸Šãƒ‡ãƒ¼ã‚¿',0),(536288,14897,'pt','Dados importados receitas',0),(536289,14897,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð½Ñ‹Ðµ Ð¿Ð¾ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(536290,14897,'es','Datos de ingresos importado',0),(536291,14897,'de','Importierte Umsatzdaten',0),(536292,14897,'en','Imported Revenue Data',0),(536293,14898,'is','',0),(536294,14898,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØµÙØ­Ù‡ Ù…Ø­ØµÙˆÙ„ 3dcart',0),(536295,14898,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ØµÙØ­Ù‡ Ù…Ø­ØµÙˆÙ„ 3dcart',0),(536296,14898,'tr','GÃ¶rÃ¼nÃ¼m 3dcart Ã¼rÃ¼n sayfasÄ±',0),(536297,14898,'pl','Widok strony produktu 3dcart',0),(536298,14898,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ 3dcart Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(536299,14898,'ur','3dcart Ù…ØµÙ†ÙˆØ¹Ø§Øª ØµÙØ­Û Ù…Ù†Ø¸Ø±',0),(536300,14898,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(536301,14898,'vi','Xem 3dcart sáº£n pháº©m trang',0),(536302,14898,'af','Bekyk 3dcart produk bladsy',0),(536303,14898,'ro','3dcart produs pagina',0),(536304,14898,'et','Vaata 3dcart toote Page',0),(536305,14898,'si','Ogled strani 3dcart izdelka',0),(536306,14898,'ba','Lihat halaman produk 3dcart',0),(536307,14898,'nl','Bekijk 3dcart productpagina',0),(536308,14898,'fi','Katso 3dcart tuotteen sivu',0),(536309,14898,'no','Vis 3dcart produktsiden',0),(536310,14898,'da','Se 3dcart produktside',0),(536311,14898,'ko','3dcart ì œí’ˆ íŽ˜ì´ì§€ ë³´ê¸°',0),(536312,14898,'he','×“×£ ×ž×•×¦×¨ 3dcart ×ª×¦×•×’×”',0),(536313,14898,'el','Î ÏÎ¿Î²Î¿Î»Î® 3dcart Ï€ÏÎ¿ÏŠÏŒÎ½ ÏƒÎµÎ»Î¯Î´Î±',0),(536314,14898,'zh','æŸ¥çœ‹ 3dcart äº§å“é¡µ',0),(536315,14898,'sv','Visa 3dcart produktsida',0),(536316,14898,'it','Pagina di visualizzazione 3dcart prodotto',0),(536317,14898,'tl','',0),(536318,14898,'th','à¸”à¸¹à¸«à¸™à¹‰à¸²à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¸£à¸¸à¹ˆà¸™ 3dcart',0),(536319,14898,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ 3dcart à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤ªà¥ƒà¤·à¥à¤ ',0),(536320,14898,'ms','Lihat 3dcart produk Laman',0),(536321,14898,'ar','Ø¹Ø±Ø¶ 3dcart ØµÙØ­Ø© Ø§Ù„Ù…Ù†ØªØ¬',0),(536322,14898,'fr','Page produit d\'affichage 3dcart',0),(536323,14898,'jp','3dcart è£½å“ãƒšãƒ¼ã‚¸ã‚’è¦‹ã‚‹',0),(536324,14898,'pt','Ver pÃ¡gina do produto 3dcart',0),(536325,14898,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° 3dcart',0),(536326,14898,'es','Ver la pÃ¡gina de producto 3dcart',0),(536327,14898,'de','Ansicht 3dcart-Produktseite',0),(536328,14898,'en','View 3dcart Product Page',0),(536329,14899,'is','',0),(536330,14899,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¯Ø± ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(536331,14899,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¯Ø± ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(536332,14899,'tr','Mobil POS gÃ¶ster',0),(536333,14899,'pl','PokaÅ¼ w mobilnych POS',0),(536334,14899,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð² Ð¼Ð¾Ð±Ð¸Ð»Ð½Ð¸ ÐŸÐžÐ¡',0),(536335,14899,'ur','Ù…ÛŒÚº Ù…ÙˆØ¨Ø§Ø¦Ù„ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(536336,14899,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñƒ Ð¼Ð¾Ð±Ð¸Ð»Ð½Ð¸Ð¼ ÐŸÐžÐ¡',0),(536337,14899,'vi','Hiá»ƒn thá»‹ trong Ä‘iá»‡n thoáº¡i di Ä‘á»™ng POS',0),(536338,14899,'af','Wys In mobiele POS',0),(536339,14899,'ro','AratÄƒ Ã®n POS mobil',0),(536340,14899,'et','Kuva mobiilne POS',0),(536341,14899,'si','PokaÅ¾i v mobilnih POS',0),(536342,14899,'ba','Tampilkan di Mobile POS',0),(536343,14899,'nl','In mobiele POS weergeven',0),(536344,14899,'fi','NÃ¤ytÃ¤ hotelli mobiili POS',0),(536345,14899,'no','Vis i Mobile POS',0),(536346,14899,'da','Vis i Mobile POS',0),(536347,14899,'ko','ëª¨ë°”ì¼ POSì— í‘œì‹œ',0),(536348,14899,'he','×”×¦×’ ×‘- POS × ×™×™×“×™×',0),(536349,14899,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÎµ ÎºÎ¹Î½Î·Ï„ÏŒ POS',0),(536350,14899,'zh','åœ¨ç§»åŠ¨ POS ä¸­æ˜¾ç¤º',0),(536351,14899,'sv','Visa i Mobile POS',0),(536352,14899,'it','Visualizza In POS Mobile',0),(536353,14899,'tl','',0),(536354,14899,'th','à¹à¸ªà¸”à¸‡à¹ƒà¸™à¹‚à¸¡à¸šà¸²à¸¢ POS',0),(536355,14899,'hi','à¤®à¥‹à¤¬à¤¾à¤‡à¤² POS à¤®à¥‡à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(536356,14899,'ms','Menunjukkan dalam POS mudah alih',0),(536357,14899,'ar','ÙˆØªØ¸Ù‡Ø± ÙÙŠ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ù…ØªÙ†Ù‚Ù„Ø©',0),(536358,14899,'fr','Afficher Ã  POS Mobile',0),(536359,14899,'jp','ãƒ¢ãƒã‚¤ãƒ« POS ã§è¡¨ç¤ºã—ã¾ã™ã€‚',0),(536360,14899,'pt','Mostrar em POS mÃ³vel',0),(536361,14899,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð² Ð¼Ð¾Ð±Ð¸Ð»ÑŒÐ½Ñ‹Ñ… POS',0),(536362,14899,'es','Mostrar en POS mÃ³viles',0),(536363,14899,'de','In Mobile POS anzeigen',0),(536364,14899,'en','Show In Mobile POS',0),(536365,14900,'is','',0),(536366,14900,'dr','ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¯Ø³ØªÙ‡ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(536367,14900,'pr','ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¯Ø³ØªÙ‡ Ù…ÙˆØ±Ø¯ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ú©Ù†ÛŒØ¯',0),(536368,14900,'tr','Madde Kategori ayarÄ±nÄ± kullanÄ±n',0),(536369,14900,'pl','Ustawienie kategorii zapasu',0),(536370,14900,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(536371,14900,'ur','Ø´Û’ Ø²Ù…Ø±Û Ø³ÛŒÙ¹Ù†Ú¯ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(536372,14900,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÑƒ ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(536373,14900,'vi','Sá»­ dá»¥ng má»¥c danh má»¥c thiáº¿t láº­p',0),(536374,14900,'af','Item kategorie instelling gebruik',0),(536375,14900,'ro','UtilizaÈ›i setarea de categorie articol',0),(536376,14900,'et','Ãœksuse kategooria sÃ¤tte',0),(536377,14900,'si','Uporabite nastavitev kategorijo artikla',0),(536378,14900,'ba','Gunakan Item kategori pengaturan',0),(536379,14900,'nl','Item categorie instelling gebruiken',0),(536380,14900,'fi','KÃ¤ytÃ¤ kohteen luokka asetus',0),(536381,14900,'no','Bruke elementet kategori innstillingen',0),(536382,14900,'da','Brug elementet kategori indstilling',0),(536383,14900,'ko','í•­ëª© ë²”ì£¼ ì„¤ì •ì„ ì‚¬ìš© í•˜ ì—¬',0),(536384,14900,'he','×”×©×ª×ž×© ×‘×”×’×“×¨×” ×§×˜×’×•×¨×™×” ×¤×¨×™×˜',0),(536385,14900,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î· ÏÏÎ¸Î¼Î¹ÏƒÎ· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(536386,14900,'zh','ä½¿ç”¨é¡¹ç›®ç±»åˆ«è®¾ç½®',0),(536387,14900,'sv','AnvÃ¤nd objektet kategori instÃ¤llningen',0),(536388,14900,'it','Utilizzare l\'elemento categoria impostazione',0),(536389,14900,'tl','',0),(536390,14900,'th','à¹ƒà¸Šà¹‰à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸›à¸£à¸°à¹€à¸ à¸—à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(536391,14900,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤— à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(536392,14900,'ms','Penggunaan barang kategori persekitaran',0),(536393,14900,'ar','Ø§Ø³ØªØ®Ø¯Ù… Ø¹Ù†ØµØ± ÙØ¦Ø© Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯',0),(536394,14900,'fr','Utiliser le paramÃ¨tre de catÃ©gorie point',0),(536395,14900,'jp','é …ç›®ã®ã‚«ãƒ†ã‚´ãƒªã®è¨­å®šã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(536396,14900,'pt','Use a configuraÃ§Ã£o de categoria de Item',0),(536397,14900,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(536398,14900,'es','ArtÃ­culo categorÃ­a configuraciÃ³n',0),(536399,14900,'de','Artikel-Kategorie-Einstellung verwenden',0),(536400,14900,'en','Use Item Category Setting',0),(536401,14901,'is','',0),(536402,14901,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¯Ø± ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(536403,14901,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¯Ø± ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(536404,14901,'tr','Mobil POS gÃ¶ster:',0),(536405,14901,'pl','PokaÅ¼ na mobilnych POS',0),(536406,14901,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð½Ð° Ð¼Ð¾Ð±Ð¸Ð»Ð½Ð¸ ÐŸÐžÐ¡',0),(536407,14901,'ur','Ù¾Ø± Ù…ÙˆØ¨Ø§Ø¦Ù„ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(536408,14901,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð½Ð° Ð¼Ð¾Ð±Ð¸Ð»Ð½Ð¸Ð¼ ÐŸÐžÐ¡',0),(536409,14901,'vi','Hiá»ƒn thá»‹ trÃªn Ä‘iá»‡n thoáº¡i di Ä‘á»™ng POS',0),(536410,14901,'af','Wys op mobiele POS',0),(536411,14901,'ro','AratÄƒ pe mobil POS',0),(536412,14901,'et','Kuva mobiilne POS',0),(536413,14901,'si','PrikaÅ¾i na mobilne POS',0),(536414,14901,'ba','Lihat Mobile POS',0),(536415,14901,'nl','Toon op mobiele POS',0),(536416,14901,'fi','NÃ¤ytÃ¤ mobiili POS',0),(536417,14901,'no','Vis pÃ¥ Mobile POS',0),(536418,14901,'da','Vis pÃ¥ Mobile POS',0),(536419,14901,'ko','ëª¨ë°”ì¼ POSì— í‘œì‹œ',0),(536420,14901,'he','×”×¦×’ ×¢×œ ×§×•×¤×” × ×™×™×“',0),(536421,14901,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÏ„Î¿ ÎºÎ¹Î½Î·Ï„ÏŒ POS',0),(536422,14901,'zh','åœ¨ç§»åŠ¨ç»ˆç«¯ä¸Šæ˜¾ç¤º',0),(536423,14901,'sv','Visa pÃ¥ Mobile POS',0),(536424,14901,'it','Visualizza sulla POS Mobile',0),(536425,14901,'tl','',0),(536426,14901,'th','à¹à¸ªà¸”à¸‡à¸šà¸™ POS à¸¡à¸·à¸­à¸–à¸·à¸­',0),(536427,14901,'hi','à¤®à¥‹à¤¬à¤¾à¤‡à¤² POS à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(536428,14901,'ms','Tunjuk POS mudah alih',0),(536429,14901,'ar','ÙˆØªØ¸Ù‡Ø± ÙÙŠ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ù…ØªÙ†Ù‚Ù„Ø©',0),(536430,14901,'fr','Afficher sur Mobile POS',0),(536431,14901,'jp','ãƒ¢ãƒã‚¤ãƒ« Pos è¡¨ç¤ºã—ã¾ã™ã€‚',0),(536432,14901,'pt','Mostrar no POS mÃ³vel',0),(536433,14901,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½Ð° Ð¼Ð¾Ð±Ð¸Ð»ÑŒÐ½Ñ‹Ðµ POS',0),(536434,14901,'es','Mostrar en POS mÃ³viles',0),(536435,14901,'de','Auf Mobile POS anzeigen',0),(536436,14901,'en','Show On Mobile POS',0),(536437,14902,'is','',0),(536438,14902,'dr','Ø¨Ù‡ Ø·ÙˆØ± Ù…ØªÙˆØ³Ø· Ø¨Ø± Ø§Ø³Ø§Ø³ ÙØ±ÙˆØ´ Ø¨ÛŒØ´ Ø§Ø² Ø³Ø§Ù„ Ú¯Ø°Ø´ØªÙ‡',0),(536439,14902,'pr','Ø¨Ù‡ Ø·ÙˆØ± Ù…ØªÙˆØ³Ø· Ø¨Ø± Ø§Ø³Ø§Ø³ ÙØ±ÙˆØ´ Ø¨ÛŒØ´ Ø§Ø² Ø³Ø§Ù„ Ú¯Ø°Ø´ØªÙ‡',0),(536440,14902,'tr','Ortalama olarak son bir yÄ±l iÃ§inde satÄ±ÅŸ dayalÄ±',0),(536441,14902,'pl','Åšrednio na sprzedaÅ¼y w ubiegÅ‚ym roku',0),(536442,14902,'bg','Ð’ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð° ÑÑ€ÐµÐ´Ð½Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿Ñ€ÐµÐ· Ð¸Ð·Ð¼Ð¸Ð½Ð°Ð»Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(536443,14902,'ur','Ú¯Ø²Ø´ØªÛ Ø³Ø§Ù„ Ú©Û’ Ø¯ÙˆØ±Ø§Ù† Ø§ÙˆØ³Ø·Ø§Ù‹ ÙØ±ÙˆØ®Øª Ù¾Ø± Ù…Ø¨Ù†ÛŒ',0),(536444,14902,'sr','Ð‘Ð°Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾ÑÐµÑ‡Ð½Ð¸Ð¼ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¿Ñ€Ð¾Ñ‚ÐµÐºÐ»Ð¸Ñ… Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ð´Ð°Ð½Ð°',0),(536445,14902,'vi','Dá»±a trÃªn trung bÃ¬nh bÃ¡n hÃ ng trong nÄƒm qua',0),(536446,14902,'af','Gebaseer op die gemiddelde verkope oor die afgelope jaar',0),(536447,14902,'ro','Medie pe baza vÃ¢nzÄƒrilor ultimii ani',0),(536448,14902,'et','PÃµhinevad keskmistel mÃ¼Ã¼k viimase aasta jooksul',0),(536449,14902,'si','Na podlagi povpreÄnih prodaje v preteklem letu',0),(536450,14902,'ba','Berdasarkan penjualan rata-rata selama tahun lalu',0),(536451,14902,'nl','Gebaseerd op de gemiddelde verkoop afgelopen jaar',0),(536452,14902,'fi','Perustuu keskimÃ¤Ã¤rÃ¤isiin myynti kuluneen vuoden aikana',0),(536453,14902,'no','Basert pÃ¥ den gjennomsnittlige salg siste Ã¥ret',0),(536454,14902,'da','Baseret pÃ¥ gennemsnitlige salg sidste Ã¥r',0),(536455,14902,'ko','ì§€ë‚œ 1 ë…„ ë™ì•ˆ í‰ê·  íŒë§¤ë¥¼ ê¸°ë°˜ìœ¼ë¡œ',0),(536456,14902,'he','×ž×‘×•×¡×¡ ×¢×œ ×ž×ž×•×¦×¢ ×ž×›×™×¨×•×ª ×‘×©× ×” ×”××—×¨×•× ×”',0),(536457,14902,'el','ÎœÎµ Î²Î¬ÏƒÎ· Ï„Î¹Ï‚ Î¼Î­ÏƒÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Ï€Î­ÏÏ…ÏƒÎ¹',0),(536458,14902,'zh','åŸºäºŽè¿‡åŽ»ä¸€å¹´çš„å¹³å‡é”€å”®é¢',0),(536459,14902,'sv','Baseras pÃ¥ den genomsnittliga fÃ¶rsÃ¤ljningen under senaste Ã¥ret',0),(536460,14902,'it','Basato in media vendite nel corso dell\'anno passato',0),(536461,14902,'tl','',0),(536462,14902,'th','à¹‚à¸”à¸¢à¹€à¸‰à¸¥à¸µà¹ˆà¸¢à¸‚à¸²à¸¢à¸›à¸µà¸—à¸µà¹ˆà¸œà¹ˆà¸²à¸™à¸¡à¸²',0),(536463,14902,'hi','à¤”à¤¸à¤¤ à¤ªà¤° à¤ªà¤¿à¤›à¤²à¥‡ à¤à¤• à¤¸à¤¾à¤² à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤†à¤§à¤¾à¤°à¤¿à¤¤',0),(536464,14902,'ms','Berdasarkan purata jualan tahun lepas',0),(536465,14902,'ar','Ø§Ø³ØªÙ†Ø§Ø¯Ø§Ù‹ Ø¥Ù„Ù‰ Ù…ØªÙˆØ³Ø· Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø®Ù„Ø§Ù„ Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ù…Ø§Ø¶ÙŠØ©',0),(536466,14902,'fr','FondÃ©e sur la moyenne des ventes au cours de l\'annÃ©e Ã©coulÃ©e',0),(536467,14902,'jp','éŽåŽ» 1 å¹´é–“ã®å¹³å‡å£²ä¸Šå€¤ã«åŸºã¥ã„ã¦ãã ã•ã„ã€‚',0),(536468,14902,'pt','Com base em mÃ©dia vendas ano passado',0),(536469,14902,'ru','Ð’ ÑÑ€ÐµÐ´Ð½ÐµÐ¼ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð² Ð¿Ñ€Ð¾ÑˆÐ»Ð¾Ð¼ Ð³Ð¾Ð´Ñƒ',0),(536470,14902,'es','Basados en promedio las ventas durante el aÃ±o pasado',0),(536471,14902,'de','Auf der Grundlage im Durchschnitt Sales vergangenen Jahr',0),(536472,14902,'en','Based On Average Sales Over Past Year',0),(536473,14903,'is','',0),(536474,14903,'dr','Ù…ÙˆØ§Ø±Ø¯ Ù†Ø§Ø¯ÛŒØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(536475,14903,'pr','Ù…ÙˆØ§Ø±Ø¯ Ù†Ø§Ø¯ÛŒØ¯Ù‡ Ú¯Ø±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(536476,14903,'tr','YoksayÄ±lan Ã¶ÄŸeler',0),(536477,14903,'pl','Zignorowane elementy',0),(536478,14903,'bg','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¾Ð±ÐµÐºÑ‚Ð¸',0),(536479,14903,'ur','Ù†Ø¸Ø±Ø§Ù†Ø¯Ø§Ø² Ø§Ø´ÛŒØ§Ø¡',0),(536480,14903,'sr','Ð—Ð°Ð½ÐµÐ¼Ð°Ñ€ÐµÐ½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(536481,14903,'vi','Khoáº£n má»¥c bá»‹ bá» qua',0),(536482,14903,'af','GeÃ¯gnoreer Items',0),(536483,14903,'ro','Elemente ignorate',0),(536484,14903,'et','Ignoreeritud Ã¼ksused',0),(536485,14903,'si','Prezrti elementi',0),(536486,14903,'ba','Item yang diabaikan',0),(536487,14903,'nl','Genegeerde objecten',0),(536488,14903,'fi','Ohitetut',0),(536489,14903,'no','Ignorerte elementer',0),(536490,14903,'da','Ignorerede elementer',0),(536491,14903,'ko','ë¬´ì‹œ í•­ëª©',0),(536492,14903,'he','×¤×¨×™×˜×™× ×©×”×ª×¢×œ×ž×ª ×ž×”×Ÿ',0),(536493,14903,'el','Î‘Î³Î½Î¿Î¿ÏÎ½Ï„Î±Î¹ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(536494,14903,'zh','è¢«å¿½ç•¥çš„é¡¹ç›®',0),(536495,14903,'sv','Ignorerade objekt',0),(536496,14903,'it','Elementi ignorati',0),(536497,14903,'tl','',0),(536498,14903,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸–à¸¹à¸à¸¥à¸°à¹€à¸§à¹‰à¸™',0),(536499,14903,'hi','à¤§à¥à¤¯à¤¾à¤¨ à¤¨ à¤¦à¥€ à¤—à¤ˆ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(536500,14903,'ms','Item-item yang diabaikan',0),(536501,14903,'ar','Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„ØªÙŠ ØªÙ… ØªØ¬Ø§Ù‡Ù„Ù‡Ø§',0),(536502,14903,'fr','Ã‰lÃ©ments ignorÃ©s',0),(536503,14903,'jp','ç„¡è¦–ã™ã‚‹é …ç›®',0),(536504,14903,'pt','Itens ignorados',0),(536505,14903,'ru','ÐŸÑ€Ð¾Ð¿ÑƒÑ‰ÐµÐ½Ð½Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹',0),(536506,14903,'es','ArtÃ­culos omitidos',0),(536507,14903,'de','Ignorierten Elemente',0),(536508,14903,'en','Ignored Items',0),(536509,14904,'is','',0),(536510,14904,'dr','Ø§Ú¯Ø± Ø¹Ø±Ø¶Ù‡ Ú©Ù†ÙˆÙ†ÛŒ Ú†Ø´Ù… Ù¾ÙˆØ´ÛŒ Ø¨ÛŒØ´ Ø§Ø²',0),(536511,14904,'pr','Ø§Ú¯Ø± Ø¹Ø±Ø¶Ù‡ Ú©Ù†ÙˆÙ†ÛŒ Ú†Ø´Ù… Ù¾ÙˆØ´ÛŒ Ø¨ÛŒØ´ Ø§Ø²',0),(536512,14904,'tr','GeÃ§erli tedarik ise gÃ¶rmezden Ã¼zerinde',0),(536513,14904,'pl','JeÅ›li zasilanie jest nad',0),(536514,14904,'bg','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð°Ð½Ðµ Ð°ÐºÐ¾ ÐµÐ»ÐµÐºÑ‚Ñ€Ð¸Ñ‡ÐµÑÐºÐ¾ Ð·Ð°Ñ…Ñ€Ð°Ð½Ð²Ð°Ð½Ðµ Ðµ Ð½Ð°Ð´',0),(536515,14904,'ur','Ø§Ú¯Ø± Ù…ÙˆØ¬ÙˆØ¯Û Ú©ÛŒ ÙØ±Ø§ÛÙ…ÛŒ ÛÛ’ Ù†Ø¸Ø± Ø§Ù†Ø¯Ø§Ø² Ù¾Ø±',0),(536516,14904,'sr','Ð—Ð°Ð½ÐµÐ¼Ð°Ñ€Ð¸ Ð°ÐºÐ¾ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ ÐÐ°Ð±Ð°Ð²ÐºÐ° Ð¿Ñ€ÐµÐºÐ¾',0),(536517,14904,'vi','Bá» qua náº¿u hiá»‡n táº¡i cung cáº¥p lÃ  hÆ¡n',0),(536518,14904,'af','Ignoreer as huidige aanbod Is oor',0),(536519,14904,'ro','Ignora dacÄƒ alimentarea cu curent este peste',0),(536520,14904,'et','Ignoreerida, kui praegune pakkumine on Ã¼le',0),(536521,14904,'si','Prezri ÄŒe napajanje toka je nad',0),(536522,14904,'ba','Abaikan jika pasokan saat ini adalah atas',0),(536523,14904,'nl','Negeren als huidige aanbod Is Over',0),(536524,14904,'fi','Ohita, jos nykyinen on yli',0),(536525,14904,'no','Ignorer hvis nÃ¥vÃ¦rende forsyning er Over',0),(536526,14904,'da','Ignorere, hvis aktuelle udbud er Over',0),(536527,14904,'ko','ë¬´ì‹œ ê²½ìš° ì „ë¥˜ ê³µê¸‰ì„ í†µí•´',0),(536528,14904,'he','×œ×”×ª×¢×œ× ×× ×”×”×™×¦×¢ ×”× ×•×›×—×™.',0),(536529,14904,'el','Î‘Î³Î½Î¿Î¿ÏÎ½ Î±Î½ Î¿ Ï„ÏÎ­Ï‡Ï‰Î½ Î±Î½ÎµÏ†Î¿Î´Î¹Î±ÏƒÎ¼ÏŒÏ‚ ÎµÎ¯Î½Î±Î¹ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ',0),(536530,14904,'zh','å¦‚æžœå½“å‰ä¾›åº”æ˜¯å¿½ç•¥äº†',0),(536531,14904,'sv','Ignorera om StrÃ¶mtillfÃ¶rselen Ã¤r Ã¶ver',0),(536532,14904,'it','Ignorare se la corrente elettrica Ã¨ sopra',0),(536533,14904,'tl','',0),(536534,14904,'th','à¹„à¸¡à¹ˆà¸ªà¸™à¹ƒà¸ˆà¸§à¹ˆà¸²à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¸­à¸¸à¸›à¸—à¸²à¸™à¸¡à¸²à¸à¸à¸§à¹ˆà¸²',0),(536535,14904,'hi','à¤¯à¤¦à¤¿ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤†à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤¹à¥ˆ à¤•à¥€ à¤‰à¤ªà¥‡à¤•à¥à¤·à¤¾ à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(536536,14904,'ms','Abaikan jika bekalan semasa ke atas',0),(536537,14904,'ar','ØªØ¬Ø§Ù‡Ù„ Ø¥Ø°Ø§ Ø§Ù„Ø¹Ø±Ø¶ Ø§Ù„Ø­Ø§Ù„ÙŠ Ø¹Ù„Ù‰ Ù…Ø¯Ù‰',0),(536538,14904,'fr','Ignorer si l\'alimentation en courant est plus',0),(536539,14904,'jp','é›»æµä¾›çµ¦ã¯å ´åˆã‚’ç„¡è¦–ã™ã‚‹ä¸Š',0),(536540,14904,'pt','Ignorar se a oferta atual Ã© sobre',0),(536541,14904,'ru','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐµÑÐ»Ð¸ Ñ‚Ð¾ÐºÐ° Ñ‡ÐµÑ€ÐµÐ·',0),(536542,14904,'es','Ignorar si la corriente estÃ¡ sobre',0),(536543,14904,'de','Ignorieren, wenn die Stromversorgung Ã¼ber',0),(536544,14904,'en','Ignore If Current Supply Is Over',0),(536545,14905,'is','',0),(536546,14905,'dr','Ø¨Ø¯ÙˆÙ† Ø³Ø§Ø¨Ù‚Ù‡ ÙØ±ÙˆØ´ Ø¯Ø± Ø¯Ø³ØªØ±Ø³',0),(536547,14905,'pr','Ø¨Ø¯ÙˆÙ† Ø³Ø§Ø¨Ù‚Ù‡ ÙØ±ÙˆØ´ Ø¯Ø± Ø¯Ø³ØªØ±Ø³',0),(536548,14905,'tr','SatÄ±ÅŸ GeÃ§miÅŸi mevcut',0),(536549,14905,'pl','Nie historii sprzedaÅ¼y dostÄ™pne',0),(536550,14905,'bg','ÐÑÐ¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(536551,14905,'ur','Ú©ÙˆØ¦ÛŒ Ø³ÛŒÙ„Ø² Ø³Ø§Ø¨Ù‚Ø§Øª Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº',0),(536552,14905,'sr','ÐÐµÐ¼Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¸Ñ… Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(536553,14905,'vi','KhÃ´ng cÃ³ lá»‹ch sá»­ bÃ¡n hÃ ng cÃ³ sáºµn',0),(536554,14905,'af','Geen verkope geskiedenis beskikbaar',0),(536555,14905,'ro','Nici o istorie de vÃ¢nzÄƒri disponibil',0),(536556,14905,'et','MÃ¼Ã¼gi ajalugu puudub',0),(536557,14905,'si','Ni na voljo Zgodovina prodaje',0),(536558,14905,'ba','Tidak ada sejarah penjualan yang tersedia',0),(536559,14905,'nl','Geen transactiebestanden beschikbaar',0),(536560,14905,'fi','Myynnin hakuhistoriaa ei ole kÃ¤ytettÃ¤vissÃ¤',0),(536561,14905,'no','Ingen Salgshistorikk tilgjengelig',0),(536562,14905,'da','Ingen tilgÃ¦ngelige salgshistorik',0),(536563,14905,'ko','ì—­ì‚¬ ì—†ì´ íŒë§¤ ê°€ëŠ¥',0),(536564,14905,'he','×”×™×¡×˜×•×¨×™×™×ª ×ž×›×™×¨×•×ª ×œ× ×–×ž×™×Ÿ',0),(536565,14905,'el','Î”ÎµÎ½ Î¹ÏƒÏ„Î¿ÏÎ¯Î±Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î¿',0),(536566,14905,'zh','æ²¡æœ‰å¯ç”¨çš„é”€å”®åŽ†å²è®°å½•',0),(536567,14905,'sv','Ingen fÃ¶rsÃ¤ljning historia tillgÃ¤nglig',0),(536568,14905,'it','Nessuna storia di vendita disponibile',0),(536569,14905,'tl','',0),(536570,14905,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸à¸²à¸£à¸‚à¸²à¸¢à¸—à¸µà¹ˆà¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(536571,14905,'hi','à¤•à¥‹à¤ˆ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(536572,14905,'ms','Tiada sejarah jualan yang disediakan',0),(536573,14905,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(536574,14905,'fr','Aucun historique des ventes disponible',0),(536575,14905,'jp','å–¶æ¥­å±¥æ­´ä½¿ç”¨ä¸å¯',0),(536576,14905,'pt','NÃ£o hÃ¡ histÃ³rico de vendas disponÃ­vel',0),(536577,14905,'ru','ÐÐµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(536578,14905,'es','No hay historia de ventas disponible',0),(536579,14905,'de','Keine Vertriebshistorie verfÃ¼gbar',0),(536580,14905,'en','No Sales History Available',0),(536581,14906,'is','',0),(536582,14906,'dr','Ù¾ÛŒØ´ Ø¨ÛŒÙ†ÛŒ ÙØ±ÙˆØ´ Ø¨Ø± Ø§Ø³Ø§Ø³',0),(536583,14906,'pr','Ù¾ÛŒØ´ Ø¨ÛŒÙ†ÛŒ ÙØ±ÙˆØ´ Ø¨Ø± Ø§Ø³Ø§Ø³',0),(536584,14906,'tr','Temel satÄ±ÅŸ tahmini',0),(536585,14906,'pl','Prognoza sprzedaÅ¼y oparta na',0),(536586,14906,'bg','ÐŸÑ€Ð¾Ð³Ð½Ð¾Ð·Ð°Ñ‚Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸, Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð°',0),(536587,14906,'ur','Ø³ÛŒÙ„Ø² Ú©ÛŒ Ù¾ÛŒØ´Ù† Ú¯ÙˆØ¦ÛŒ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø±',0),(536588,14906,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¿Ñ€ÐµÐ´Ð²Ð¸Ñ’Ð°ÑšÐµ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ',0),(536589,14906,'vi','BÃ¡n hÃ ng thá»i dá»±a trÃªn',0),(536590,14906,'af','Verkope skatting gebaseer op',0),(536591,14906,'ro','Prognoza de vÃ¢nzÄƒri pe baza',0),(536592,14906,'et','PÃµhineb mÃ¼Ã¼gieelarve',0),(536593,14906,'si','Prodajne napovedi na podlagi',0),(536594,14906,'ba','Prakiraan penjualan berdasarkan',0),(536595,14906,'nl','Verkoopprognose gebaseerd op',0),(536596,14906,'fi','Myynnin ennuste perustuu',0),(536597,14906,'no','Salgsprognose basert pÃ¥',0),(536598,14906,'da','Salgsprognose baseret pÃ¥',0),(536599,14906,'ko','ê¸°ë°˜ìœ¼ë¡œ íŒë§¤ ì˜ˆì¸¡',0),(536600,14906,'he','×”×ž×‘×•×¡×¡×ª ×¢×œ ×ª×—×–×™×ª ×ž×›×™×¨×•×ª',0),(536601,14906,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€ÏÏŒÎ²Î»ÎµÏˆÎ· Î¼Îµ Î²Î¬ÏƒÎ·',0),(536602,14906,'zh','åŸºäºŽé”€å”®é¢„æµ‹',0),(536603,14906,'sv','FÃ¶rsÃ¤ljningsprognos baserat pÃ¥',0),(536604,14906,'it','Previsioni di vendita sulla base',0),(536605,14906,'tl','',0),(536606,14906,'th','à¸•à¸²à¸¡à¸„à¸²à¸”à¸à¸²à¸£à¸“à¹Œà¸¢à¸­à¸”à¸‚à¸²à¸¢',0),(536607,14906,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤ªà¥‚à¤°à¥à¤µà¤¾à¤¨à¥à¤®à¤¾à¤¨ à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤°',0),(536608,14906,'ms','Ramalan jualan berdasarkan',0),(536609,14906,'ar','Ø§Ù„ØªÙ†Ø¨Ø¤ Ø¨Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³',0),(536610,14906,'fr','PrÃ©visions de ventes basÃ©es sur',0),(536611,14906,'jp','åŸºã¥ãå£²ä¸Šäºˆæ¸¬',0),(536612,14906,'pt','PrevisÃ£o de vendas com base em',0),(536613,14906,'ru','ÐŸÑ€Ð¾Ð³Ð½Ð¾Ð· Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ',0),(536614,14906,'es','PrevisiÃ³n de ventas basado en',0),(536615,14906,'de','Auf der Grundlage von Vertriebsprognose',0),(536616,14906,'en','Sales Forecast Based On',0),(536617,14907,'is','',0),(536618,14907,'dr','Ù†Ù…Ø§ÛŒØ´ Ù…ÙˆØ§Ø±Ø¯ ØªÙ†Ù‡Ø§ Ø¨Ø§ Ù…Ø­Ù„ Ø¯Ø± Ø¯Ø§Ø®Ù„ Ø§Ù†Ø¨Ø§Ø± Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(536619,14907,'pr','Ù†Ù…Ø§ÛŒØ´ Ù…ÙˆØ§Ø±Ø¯ ØªÙ†Ù‡Ø§ Ø¨Ø§ Ù…Ø­Ù„ Ø¯Ø± Ø¯Ø§Ø®Ù„ Ø§Ù†Ø¨Ø§Ø± Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(536620,14907,'tr','YalnÄ±zca atanan ambar iÃ§indeki bir konuma sahip Ã¶ÄŸeleri gÃ¶ster',0),(536621,14907,'pl','PokaÅ¼ tylko przedmioty z lokalizacji w obrÄ™bie magazynu przypisanego',0),(536622,14907,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ñ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð² ÑÐºÐ»Ð°Ð´Ð° Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½Ð¸',0),(536623,14907,'ur','ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û Ú¯ÙˆØ¯Ø§Ù… Ú©Û’ Ø§Ù†Ø¯Ø± Ø§ÛŒÚ© Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Û’ Ø³Ø§ØªÚ¾ ØµØ±Ù Ø§Ø´ÛŒØ§ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(536624,14907,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ ÑƒÐ½ÑƒÑ‚Ð°Ñ€ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ð° Ð´Ð¾Ð´ÐµÑ™ÐµÐ½',0),(536625,14907,'vi','Hiá»ƒn thá»‹ cÃ¡c chá»‰ má»¥c vá»›i má»™t vá»‹ trÃ­ trong kho chá»‰ Ä‘á»‹nh',0),(536626,14907,'af','Wys slegs Items met \'n ligging binne pakhuis toegeken',0),(536627,14907,'ro','AratÄƒ numai elementele cu o locaÅ£ie Ã®n depozit alocate',0),(536628,14907,'et','NÃ¤ita ainult saadetisi ladu mÃ¤Ã¤ratud asukohale',0),(536629,14907,'si','PokaÅ¾i samo elemente z lokacijo v skladiÅ¡Äu, dodeljena',0),(536630,14907,'ba','Tampilkan hanya item dengan lokasi dalam gudang gambar ditetapkan',0),(536631,14907,'nl','Alleen objecten met een locatie in magazijn toegewezen weergeven',0),(536632,14907,'fi','NÃ¤ytÃ¤ vain tuotteet sijainti mÃ¤Ã¤ritetty varasto',0),(536633,14907,'no','Vise bare elementene med en plassering i lager tilordnet',0),(536634,14907,'da','Vis kun elementer med en placering inden for lagerstedet tildelt',0),(536635,14907,'ko','í• ë‹¹ ì°½ ê³  ë‚´ ìœ„ì¹˜ì™€ í•­ëª©ë§Œ í‘œì‹œ',0),(536636,14907,'he','×”×¦×’ ×¨×§ ×¤×¨×™×˜×™× ×¢× ×ž×™×§×•× ×‘×ª×•×š ×”×ž×—×¡×Ÿ ×©×”×•×§×¦×•',0),(536637,14907,'el','Î•Î¼Ï†Î±Î½Î¯Î¶Î¿Î½Ï„Î±Î¹ Î¼ÏŒÎ½Î¿ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î¼Îµ Î¼Î¹Î± Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Î¼Î­ÏƒÎ± Î±Ï€Î¿Î¸Î®ÎºÎ· ÎµÎ¼Ï€Î¿ÏÎµÏ…Î¼Î¬Ï„Ï‰Î½ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Î½Î±Ï„ÎµÎ¸ÎµÎ¯',0),(536638,14907,'zh','æ˜¾ç¤ºé¡¹ç›®æŒ‡å®šä»“åº“å†…çš„æŸä¸ªä½ç½®ï¼Œ',0),(536639,14907,'sv','Visa endast objekt med en plats i lagret tilldelas',0),(536640,14907,'it','Visualizza solo gli elementi con una posizione all\'interno del magazzino assegnato',0),(536641,14907,'tl','',0),(536642,14907,'th','à¹à¸ªà¸”à¸‡à¹€à¸‰à¸žà¸²à¸°à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆ à¸¡à¸µà¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸ à¸²à¸¢à¹ƒà¸™à¸„à¸¥à¸±à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”à¹ƒà¸«à¹‰',0),(536643,14907,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤ à¤•à¥‡à¤µà¤² à¤†à¤‡à¤Ÿà¤® à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤ à¤—à¤ à¤—à¥‹à¤¦à¤¾à¤® à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤à¤• à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(536644,14907,'ms','Menunjukkan hanya item dengan lokasi dalam gudang yang diperuntukkan',0),(536645,14907,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¹Ù†Ø§ØµØ± ÙÙ‚Ø· Ù…Ø¹ Ù…ÙˆÙ‚Ø¹ Ø¯Ø§Ø®Ù„ Ù…Ø³ØªÙˆØ¯Ø¹ Ø§Ù„Ù…Ø¹ÙŠÙ†Ø©',0),(536646,14907,'fr','Afficher uniquement les Ã©lÃ©ments bÃ©nÃ©ficiant d\'un emplacement au sein de l\'entrepÃ´t assignÃ©',0),(536647,14907,'jp','å‰²ã‚Šå½“ã¦ã‚‰ã‚ŒãŸå€‰åº«å†…ã®å ´æ‰€ã‚’æŒã¤é …ç›®ã®ã¿è¡¨ç¤ºã—ã¾ã™ã€‚',0),(536648,14907,'pt','Mostrar apenas itens de uma localizaÃ§Ã£o com armazÃ©m atribuÃ­do',0),(536649,14907,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ‚Ð¾Ð²Ð°Ñ€Ñ‹ Ñ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÐ¼ Ð² Ð¿Ñ€ÐµÐ´ÐµÐ»Ð°Ñ… ÑÐºÐ»Ð°Ð´Ð° Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½',0),(536650,14907,'es','Mostrar sÃ³lo los elementos con una ubicaciÃ³n de almacÃ©n asignado',0),(536651,14907,'de','Zeigen Sie nur Artikel mit einer Position in Lager zugewiesen an',0),(536652,14907,'en','Show Only Items With A Location Within Warehouse Assigned',0),(536653,14908,'is','',0),(536654,14908,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒØ´ Ø¨ÛŒÙ†ÛŒ',0),(536655,14908,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù¾ÛŒØ´ Ø¨ÛŒÙ†ÛŒ',0),(536656,14908,'tr','KullanÄ±m tahmin',0),(536657,14908,'pl','UÅ¼ycie Pogoda',0),(536658,14908,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð³Ð½Ð¾Ð·Ð°',0),(536659,14908,'ur','Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒ Ù¾ÛŒØ´Ù† Ú¯ÙˆØ¦ÛŒ',0),(536660,14908,'sr','ÐŸÑ€ÐµÐ´Ð²Ð¸Ñ’Ð°ÑšÐµ Ð·Ð° ÐºÐ¾Ñ€Ð¸ÑˆÑ‚ÐµÑšÐµ',0),(536661,14908,'vi','Sá»­ dá»¥ng thá»i',0),(536662,14908,'af','Gebruik skatting',0),(536663,14908,'ro','Prognoza de utilizare',0),(536664,14908,'et','Kasutamise prognoos',0),(536665,14908,'si','Uporaba napoved',0),(536666,14908,'ba','Penggunaan Forecast',0),(536667,14908,'nl','Gebruik weer',0),(536668,14908,'fi','KÃ¤yttÃ¶ SÃ¤Ã¤',0),(536669,14908,'no','Bruk prognose',0),(536670,14908,'da','Brug Forecast',0),(536671,14908,'ko','ì‚¬ìš© ì˜ˆì¸¡',0),(536672,14908,'he','×”×©×™×ž×•×© ×ª×—×–×™×ª',0),(536673,14908,'el','Î ÏÏŒÎ²Î»ÎµÏˆÎ· Ï‡ÏÎ®ÏƒÎ·Ï‚',0),(536674,14908,'zh','ä½¿ç”¨é¢„æµ‹',0),(536675,14908,'sv','AnvÃ¤ndning prognos',0),(536676,14908,'it','Previsioni di utilizzo',0),(536677,14908,'tl','',0),(536678,14908,'th','à¸à¸²à¸£à¸„à¸²à¸”à¸à¸²à¸£à¸“à¹Œà¸à¸²à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(536679,14908,'hi','à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤¾ à¤ªà¥‚à¤°à¥à¤µà¤¾à¤¨à¥à¤®à¤¾à¤¨',0),(536680,14908,'ms','Ramalan penggunaan',0),(536681,14908,'ar','Ø§Ù„ØªÙ†Ø¨Ø¤ Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù…',0),(536682,14908,'fr','PrÃ©visions d\'utilisation',0),(536683,14908,'jp','ä½¿ç”¨çŽ‡ã®äºˆæ¸¬',0),(536684,14908,'pt','PrevisÃ£o de uso',0),(536685,14908,'ru','ÐŸÑ€Ð¾Ð³Ð½Ð¾Ð· Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(536686,14908,'es','PrevisiÃ³n del uso',0),(536687,14908,'de','Nutzung-Prognose',0),(536688,14908,'en','Usage Forecast',0),(536689,14909,'is','',0),(536690,14909,'dr','ØªØºÛŒÛŒØ±',0),(536691,14909,'pr','ØªØºÛŒÛŒØ±',0),(536692,14909,'tr','TarafÄ±ndan deÄŸiÅŸtirildi',0),(536693,14909,'pl','ZmieniÄ‡ przez',0),(536694,14909,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½ÐµÐ½ Ð¾Ñ‚',0),(536695,14909,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(536696,14909,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸Ð¾ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(536697,14909,'vi','Thay Ä‘á»•i bá»Ÿi',0),(536698,14909,'af','Verander deur',0),(536699,14909,'ro','Modificat de',0),(536700,14909,'et','Muuta',0),(536701,14909,'si','Spremenil',0),(536702,14909,'ba','Diubah oleh',0),(536703,14909,'nl','Gewijzigd door',0),(536704,14909,'fi','Muuttaa',0),(536705,14909,'no','Endret av',0),(536706,14909,'da','Ã†ndret af',0),(536707,14909,'ko','ì˜í•´ ë³€ê²½',0),(536708,14909,'he','×œ×©×™× ×•×™ ×¢×œ-×™×“×™',0),(536709,14909,'el','Î†Î»Î»Î±Î¾Îµ Î±Ï€ÏŒ',0),(536710,14909,'zh','é€šè¿‡æ›´æ”¹',0),(536711,14909,'sv','Ã„ndras av',0),(536712,14909,'it','Modificato da',0),(536713,14909,'tl','',0),(536714,14909,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¹‚à¸”à¸¢',0),(536715,14909,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤',0),(536716,14909,'ms','Ditukar dengan',0),(536717,14909,'ar','ØªØºÙŠÙŠØ±Ù‡Ø§ Ø¨ÙˆØ§Ø³Ø·Ø©',0),(536718,14909,'fr','ModifiÃ© par',0),(536719,14909,'jp','ã«ã‚ˆã£ã¦å¤‰æ›´ã•ã‚Œã¾ã—ãŸã€‚',0),(536720,14909,'pt','Alterado pelo',0),(536721,14909,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¾',0),(536722,14909,'es','Cambiado por',0),(536723,14909,'de','GeÃ¤ndert von',0),(536724,14909,'en','Changed By',0),(536725,14910,'is','',0),(536726,14910,'dr','Ù…Ø­Ù„ Ø¯Ø± Ø¯Ø§Ø®Ù„ Ø§Ù†Ø¨Ø§Ø± ØªØ§Ø±ÛŒØ®',0),(536727,14910,'pr','Ù…Ø­Ù„ Ø¯Ø± Ø¯Ø§Ø®Ù„ Ø§Ù†Ø¨Ø§Ø± ØªØ§Ø±ÛŒØ®',0),(536728,14910,'tr','Ambar geÃ§miÅŸ iÃ§inde konum',0),(536729,14910,'pl','Lokalizacja w historii hurtowni',0),(536730,14910,'bg','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð² ÑÐºÐ»Ð°Ð´Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(536731,14910,'ur','Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú¯ÙˆØ¯Ø§Ù… ØªØ§Ø±ÛŒØ® Ú©Û’ Ø§Ù†Ø¯Ø±',0),(536732,14910,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ ÑƒÐ½ÑƒÑ‚Ð°Ñ€ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(536733,14910,'vi','Vá»‹ trÃ­ trong nhÃ  kho lá»‹ch sá»­',0),(536734,14910,'af','Ligging binne pakhuis geskiedenis',0),(536735,14910,'ro','Amplasarea Ã®n cadrul depozitului istoriei',0),(536736,14910,'et','KlÃµpsatav lao ajalugu',0),(536737,14910,'si','Lokacija znotraj skladiÅ¡Äa zgodovina',0),(536738,14910,'ba','Lokasi gudang sejarah',0),(536739,14910,'nl','Locatie in magazijn geschiedenis',0),(536740,14910,'fi','Sijainti varaston historia',0),(536741,14910,'no','Plassering pÃ¥ lageret historie',0),(536742,14910,'da','Placering inden for lagerstedet historie',0),(536743,14910,'ko','ì°½ ê³  ì—­ì‚¬ ë‚´ ìœ„ì¹˜',0),(536744,14910,'he','×ž×™×§×•× ×‘×ª×•×š ×”×ž×—×¡×Ÿ ×”×™×¡×˜×•×¨×™×”',0),(536745,14910,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± ÏƒÎµ Î±Ï€Î¿Î¸Î®ÎºÎ· Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(536746,14910,'zh','åœ¨ä»“åº“åŽ†å²ä¸­çš„ä½ç½®',0),(536747,14910,'sv','LÃ¤ge inom lager historia',0),(536748,14910,'it','Posizione all\'interno della storia di magazzino',0),(536749,14910,'tl','',0),(536750,14910,'th','à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸ à¸²à¸¢à¹ƒà¸™à¸„à¸¥à¸±à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸›à¸£à¸°à¸§à¸±à¸•à¸´',0),(536751,14910,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤¸à¥à¤¥à¤¾à¤¨',0),(536752,14910,'ms','Lokasi di dalam gudang sejarah',0),(536753,14910,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø¯Ø§Ø®Ù„ Ù…Ø³ØªÙˆØ¯Ø¹ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(536754,14910,'fr','Location entrepÃ´t historique',0),(536755,14910,'jp','ã‚¦ã‚§ã‚¢ãƒã‚¦ã‚¹ã®å±¥æ­´å†…ã®ä½ç½®',0),(536756,14910,'pt','LocalizaÃ§Ã£o dentro da histÃ³ria do armazÃ©m',0),(536757,14910,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð²Ð½ÑƒÑ‚Ñ€Ð¸ ÑÐºÐ»Ð°Ð´Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸',0),(536758,14910,'es','UbicaciÃ³n dentro de la historia de almacÃ©n',0),(536759,14910,'de','Lage im Warehouse-Geschichte',0),(536760,14910,'en','Location Within Warehouse History',0),(536761,14911,'is','',0),(536762,14911,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯ ØªØ§',0),(536763,14911,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯ ØªØ§',0),(536764,14911,'tr','Kadar kullanÄ±lan',0),(536765,14911,'pl','UÅ¼ywane do',0),(536766,14911,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚ Ð´Ð¾',0),(536767,14911,'ur','ØªÚ© Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(536768,14911,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ð¾ Ð´Ð¾',0),(536769,14911,'vi','ÄÆ°á»£c sá»­ dá»¥ng cho Ä‘áº¿n khi',0),(536770,14911,'af','Gebruik totdat',0),(536771,14911,'ro','Utilizate pÃ¢nÄƒ la',0),(536772,14911,'et','Kasutada kuni',0),(536773,14911,'si','Uporabljajo do',0),(536774,14911,'ba','Digunakan sampai',0),(536775,14911,'nl','Tot en met gebruikt',0),(536776,14911,'fi','HylÃ¤tty',0),(536777,14911,'no','FÃ¸r',0),(536778,14911,'da','Brugt indtil',0),(536779,14911,'ko','ê¹Œì§€ ì‚¬ìš©',0),(536780,14911,'he','×‘×©×™×ž×•×© ×¢×“',0),(536781,14911,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹ Î¼Î­Ï‡ÏÎ¹',0),(536782,14911,'zh','ä¹‹å‰ä½¿ç”¨',0),(536783,14911,'sv','AnvÃ¤nds till',0),(536784,14911,'it','Utilizzato fino',0),(536785,14911,'tl','',0),(536786,14911,'th','à¹ƒà¸Šà¹‰à¹„à¸”à¹‰à¸ˆà¸™à¸à¸§à¹ˆà¸²',0),(536787,14911,'hi','à¤œà¤¬ à¤¤à¤• à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(536788,14911,'ms','Digunakan sehingga',0),(536789,14911,'ar','ÙŠØ³ØªØ®Ø¯Ù… Ø­ØªÙ‰',0),(536790,14911,'fr','UtilisÃ© jusqu\'en',0),(536791,14911,'jp','ã¾ã§ä½¿ç”¨ã•ã‚Œã¾ã™ã€‚',0),(536792,14911,'pt','Usado atÃ©',0),(536793,14911,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ Ð´Ð¾',0),(536794,14911,'es','Utilizado hasta',0),(536795,14911,'de','Bis',0),(536796,14911,'en','Used Until',0),(536797,14912,'is','',0),(536798,14912,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú¯Ø°Ø´ØªÙ‡ Ù…Ú©Ø§Ù† Ø¯Ø± Ø¯Ø§Ø®Ù„ Ø§Ù†Ø¨Ø§Ø±',0),(536799,14912,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú¯Ø°Ø´ØªÙ‡ Ù…Ú©Ø§Ù† Ø¯Ø± Ø¯Ø§Ø®Ù„ Ø§Ù†Ø¨Ø§Ø±',0),(536800,14912,'tr','Depo iÃ§ine geÃ§miÅŸ gÃ¶rÃ¼ntÃ¼leme',0),(536801,14912,'pl','Zobacz wczeÅ›niejsze lokalizacje w magazynu',0),(536802,14912,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð² ÑÐºÐ»Ð°Ð´Ð°',0),(536803,14912,'ur','Ù…Ø§Ø¶ÛŒ Ú©Û’ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Û’ Ú¯ÙˆØ¯Ø§Ù… Ú©Û’ Ø§Ù†Ø¯Ø± Ú©Ùˆ Ø¯ÛŒÚ©Ú¾Ù†Û’',0),(536804,14912,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¸Ñ… Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°Ð¼Ð° ÑƒÐ½ÑƒÑ‚Ð°Ñ€ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ð°',0),(536805,14912,'vi','Xem qua cÃ¡c vá»‹ trÃ­ trong kho',0),(536806,14912,'af','Bekyk verby plekke binne pakhuis',0),(536807,14912,'ro','Vezi trecut locaÅ£ii Ã®n depozit',0),(536808,14912,'et','Saate vaadata ladu kohtadest',0),(536809,14912,'si','Ogled preteklih lokacijah v skladiÅ¡Äu',0),(536810,14912,'ba','Lihat lokasi dalam gudang gambar',0),(536811,14912,'nl','Bekijk verleden locaties in magazijn',0),(536812,14912,'fi','Tarkastella aiempia varaston sijainteihin',0),(536813,14912,'no','Vis tidligere steder i lageret',0),(536814,14912,'da','Se forbi steder inden for lageret',0),(536815,14912,'ko','ê³¼ê±°ì˜ ì°½ ê³  ë‚´ ìœ„ì¹˜ ë³´ê¸°',0),(536816,14912,'he','×”×¦×’ ××ª ×”×¢×‘×¨ ×ž×™×§×•×ž×™× ×‘×ª×•×š ×”×ž×—×¡×Ÿ',0),(536817,14912,'el','Î”ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ Î¸Î­ÏƒÎµÎ¹Ï‚ Î¼Î­ÏƒÎ± Î±Ï€Î¿Î¸Î®ÎºÎ·',0),(536818,14912,'zh','æŸ¥çœ‹è¿‡åŽ»åœ¨ä»“åº“å†…çš„ä½ç½®',0),(536819,14912,'sv','Visa tidigare platser inom lager',0),(536820,14912,'it','Visualizzazione di precedenti posizioni all\'interno del magazzino',0),(536821,14912,'tl','',0),(536822,14912,'th','à¸”à¸¹à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸ à¸²à¸¢à¹ƒà¸™à¸„à¸¥à¸±à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸œà¹ˆà¸²à¸™à¸¡à¸²',0),(536823,14912,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤•à¥‡ à¤­à¥€à¤¤à¤° à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤…à¤¤à¥€à¤¤ à¤•à¥‹ à¤¦à¥‡à¤–à¤¨à¥‡',0),(536824,14912,'ms','Lihat dahulu lokasi gudang',0),(536825,14912,'ar','Ø¹Ø±Ø¶ ÙÙŠ Ø§Ù„Ù…Ø§Ø¶ÙŠ Ù…ÙˆÙ‚Ø¹Ø§ Ø¯Ø§Ø®Ù„ Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹',0),(536826,14912,'fr','Affichez antÃ©rieures emplacements au sein de l\'entrepÃ´t',0),(536827,14912,'jp','éŽåŽ»ã®å€‰åº«å†…ã®å ´æ‰€ã‚’è¡¨ç¤º',0),(536828,14912,'pt','Ver os Ãºltimos locais no armazÃ©m',0),(536829,14912,'ru','ÐŸÐ¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¼ÐµÑÑ‚Ð° Ð² Ð¿Ñ€ÐµÐ´ÐµÐ»Ð°Ñ… ÑÐºÐ»Ð°Ð´Ð°',0),(536830,14912,'es','Ver anteriores ubicaciones dentro de almacÃ©n',0),(536831,14912,'de','FrÃ¼here Positionen im Warehouse anzeigen',0),(536832,14912,'en','View Past Locations Within Warehouse',0),(536833,14913,'is','',0),(536834,14913,'dr','Ø¯Ø±ÛŒØ§ÙØª',0),(536835,14913,'pr','Ø¯Ø±ÛŒØ§ÙØª',0),(536836,14913,'tr','Almak',0),(536837,14913,'pl','OtrzymaÄ‡',0),(536838,14913,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚Ðµ',0),(536839,14913,'ur','ÙˆØµÙˆÙ„ Ú©Ø±ÛŒÚº',0),(536840,14913,'sr','ÐŸÑ€Ð¸Ñ˜ÐµÐ¼',0),(536841,14913,'vi','Nháº­n Ä‘Æ°á»£c',0),(536842,14913,'af','Ontvang',0),(536843,14913,'ro','Primi',0),(536844,14913,'et','Saada',0),(536845,14913,'si','Prejeli',0),(536846,14913,'ba','Menerima',0),(536847,14913,'nl','Ontvangen',0),(536848,14913,'fi','Vastaanottaa',0),(536849,14913,'no','Motta',0),(536850,14913,'da','Modtager',0),(536851,14913,'ko','ìˆ˜ì‹ ',0),(536852,14913,'he','×œ×§×‘×œ',0),(536853,14913,'el','Î›Î¬Î²ÎµÏ„Îµ',0),(536854,14913,'zh','æŽ¥æ”¶',0),(536855,14913,'sv','Ta emot',0),(536856,14913,'it','Ricevere',0),(536857,14913,'tl','',0),(536858,14913,'th','à¹„à¸”à¹‰à¸£à¸±à¸š',0),(536859,14913,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(536860,14913,'ms','Menerima',0),(536861,14913,'ar','ØªÙ„Ù‚ÙŠ',0),(536862,14913,'fr','Recevoir',0),(536863,14913,'jp','å—ä¿¡',0),(536864,14913,'pt','Receber',0),(536865,14913,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ',0),(536866,14913,'es','Recibir',0),(536867,14913,'de','Erhalten',0),(536868,14913,'en','Receive',0),(536869,14914,'is','',0),(536870,14914,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø¢Ø¯Ø±Ø³ Ø§ÛŒÙ…ÛŒÙ„ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(536871,14914,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø¢Ø¯Ø±Ø³ Ø§ÛŒÙ…ÛŒÙ„ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(536872,14914,'tr','E-posta adresi girmelisiniz',0),(536873,14914,'pl','NaleÅ¼y wprowadziÄ‡ adres E-mail',0),(536874,14914,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ',0),(536875,14914,'ur','Ø¢Ù¾ Ú©Ø§ Ø§ÛŒ Ù…ÛŒÙ„ Ø§ÛŒÚˆØ±ÛŒØ³ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(536876,14914,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ðµ-Ð°Ð´Ñ€ÐµÑÑƒ',0),(536877,14914,'vi','Báº¡n pháº£i nháº­p Ä‘á»‹a chá»‰ Email',0),(536878,14914,'af','Jy moet \'n e-posadres insleutel',0),(536879,14914,'ro','Trebuie sÄƒ introduceÅ£i o adresÄƒ de E-mail',0),(536880,14914,'et','Sisestage e-posti aadress',0),(536881,14914,'si','Morate vnesti e-poÅ¡tni naslov',0),(536882,14914,'ba','Anda harus memasukkan alamat Email',0),(536883,14914,'nl','U moet een emailadres invullen',0),(536884,14914,'fi','Anna sÃ¤hkÃ¶postiosoitteesi',0),(536885,14914,'no','Du mÃ¥ angi en e-postadresse',0),(536886,14914,'da','Du skal angive en E-mail-adresse',0),(536887,14914,'ko','ì´ë©”ì¼ ì£¼ì†Œë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(536888,14914,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×›×ª×•×‘×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™',0),(536889,14914,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î¼Î¹Î± Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(536890,14914,'zh','æ‚¨å¿…é¡»è¾“å…¥ç”µå­é‚®ä»¶åœ°å€',0),(536891,14914,'sv','Du mÃ¥ste ange en e-postadress',0),(536892,14914,'it','Ãˆ necessario inserire un indirizzo Email',0),(536893,14914,'tl','',0),(536894,14914,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸­à¸¢à¸¹à¹ˆà¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(536895,14914,'hi','à¤†à¤ªà¤•à¥‹ à¤à¤• à¤ˆà¤®à¥‡à¤² à¤ªà¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(536896,14914,'ms','Anda mesti masukkan alamat e-mel',0),(536897,14914,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø¹Ù†ÙˆØ§Ù† Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(536898,14914,'fr','Vous devez entrer une adresse E-mail',0),(536899,14914,'jp','ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(536900,14914,'pt','VocÃª deve digitar um endereÃ§o de E-mail',0),(536901,14914,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ Ð°Ð´Ñ€ÐµÑ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(536902,14914,'es','Debe introducir una direcciÃ³n de correo electrÃ³nico',0),(536903,14914,'de','Sie mÃ¼ssen eine E-Mail-Adresse eingeben.',0),(536904,14914,'en','You Must Enter An Email Address',0),(536905,14915,'is','',0),(536906,14915,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ØªÙ„ÙÙ† Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(536907,14915,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ØªÙ„ÙÙ† Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(536908,14915,'tr','Bir telefon numarasÄ± girmelisiniz',0),(536909,14915,'pl','NaleÅ¼y wprowadziÄ‡ numer telefonu',0),(536910,14915,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(536911,14915,'ur','Ø¢Ù¾ Ú©Ùˆ Ø§ÛŒÚ© ÙÙˆÙ† Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(536912,14915,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ ÑƒÐ½ÐµÑ‚Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(536913,14915,'vi','Báº¡n pháº£i nháº­p má»™t sá»‘ Ä‘iá»‡n thoáº¡i',0),(536914,14915,'af','Jy moet \'n telefoonnommer intik',0),(536915,14915,'ro','Trebuie sÄƒ introduceÅ£i un numÄƒr de telefon',0),(536916,14915,'et','Peate sisestama telefoninumbri',0),(536917,14915,'si','Vnesite telefonsko Å¡tevilko',0),(536918,14915,'ba','Anda harus memasukkan nomor telepon',0),(536919,14915,'nl','U moet een telefoonnummer invoeren',0),(536920,14915,'fi','Kirjoita puhelinnumero',0),(536921,14915,'no','Du mÃ¥ angi et telefonnummer',0),(536922,14915,'da','Du skal angive et telefonnummer',0),(536923,14915,'ko','ì „í™” ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(536924,14915,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×ž×¡×¤×¨ ×˜×œ×¤×•×Ÿ',0),(536925,14915,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î·Î»ÎµÏ†ÏŽÎ½Î¿Ï…',0),(536926,14915,'zh','æ‚¨å¿…é¡»è¾“å…¥ä¸€ä¸ªç”µè¯å·ç ',0),(536927,14915,'sv','Du mÃ¥ste ange ett telefonnummer',0),(536928,14915,'it','Ãˆ necessario immettere un numero di telefono',0),(536929,14915,'tl','',0),(536930,14915,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œ',0),(536931,14915,'hi','à¤†à¤ª à¤à¤• à¤«à¤¼à¥‹à¤¨ à¤¨à¤‚à¤¬à¤° à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(536932,14915,'ms','Anda mesti masukkan nombor telefon',0),(536933,14915,'ar','ÙŠØ¬Ø¨ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ù‡Ø§ØªÙ',0),(536934,14915,'fr','Vous devez entrer un numÃ©ro de tÃ©lÃ©phone',0),(536935,14915,'jp','é›»è©±ç•ªå·ã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(536936,14915,'pt','VocÃª deve digitar um nÃºmero de telefone',0),(536937,14915,'ru','Ð’Ð°Ð¼ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(536938,14915,'es','Debe introducir un nÃºmero de telÃ©fono',0),(536939,14915,'de','Sie mÃ¼ssen eine Telefonnummer eingeben.',0),(536940,14915,'en','You Must Enter A Phone Number',0),(536941,14916,'is','',0),(536942,14916,'dr','Ø¨Ø±Ø§ÛŒ Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø·ÙˆØ· Ø¨ÛŒØ´ØªØ± ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ',0),(536943,14916,'pr','Ø¨Ø±Ø§ÛŒ Ø§ÙØ²ÙˆØ¯Ù† Ø®Ø·ÙˆØ· Ø¨ÛŒØ´ØªØ± ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ',0),(536944,14916,'tr','Daha fazla Ã§izgi eklemek iÃ§in Kaydet',0),(536945,14916,'pl','Zapisz siÄ™ aby dodaÄ‡ wiÄ™cej linii',0),(536946,14916,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð·Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ñ€ÐµÐ´Ð¾Ð²Ðµ',0),(536947,14916,'ur','Ù…Ø²ÛŒØ¯ Ù„Ø§Ø¦Ù†ÛŒÚº Ø§Ø¶Ø§ÙÛ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(536948,14916,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ð²Ð¸ÑˆÐµ Ð»Ð¸Ð½Ð¸Ñ˜Ð°',0),(536949,14916,'vi','Tiáº¿t kiá»‡m Ä‘á»ƒ thÃªm thÃªm dÃ²ng',0),(536950,14916,'af','Stoor te voeg meer lyne',0),(536951,14916,'ro','Salvare pentru a adÄƒuga mai multe linii',0),(536952,14916,'et','Salvesta, et lisada mitu rida',0),(536953,14916,'si','Shranite dodati veÄ vrstic',0),(536954,14916,'ba','Simpan untuk menambahkan baris lain',0),(536955,14916,'nl','Opslaan om toe te voegen meer lijnen',0),(536956,14916,'fi','Tallenna lisÃ¤tÃ¤ rivejÃ¤',0),(536957,14916,'no','Lagre for Ã¥ legge til flere linjer',0),(536958,14916,'da','Gem for at fÃ¸je flere linjer',0),(536959,14916,'ko','ë” ë§Žì€ ë¼ì¸ì„ ì¶”ê°€ í•˜ê¸°',0),(536960,14916,'he','×©×ž×•×¨ ×›×“×™ ×œ×”×•×¡×™×£ ×§×•×•×™× × ×•×¡×¤×™×',0),(536961,14916,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎµÏ‚ Î³ÏÎ±Î¼Î¼Î­Ï‚',0),(536962,14916,'zh','ä¿å­˜è¦æ·»åŠ æ›´å¤šè¡Œ',0),(536963,14916,'sv','Spara fÃ¶r att lÃ¤gga till fler rader',0),(536964,14916,'it','Salva per aggiungere ulteriori righe',0),(536965,14916,'tl','',0),(536966,14916,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸à¸²à¸£',0),(536967,14916,'hi','à¤…à¤§à¤¿à¤• à¤ªà¤‚à¤•à¥à¤¤à¤¿à¤¯à¥‹à¤‚ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(536968,14916,'ms','Simpan untuk menambah lagi laluan',0),(536969,14916,'ar','Ø­ÙØ¸ Ù„Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ù…Ø²ÙŠØ¯ Ù…Ù† Ø®Ø·ÙˆØ·',0),(536970,14916,'fr','Enregistrer pour ajouter davantage de lignes',0),(536971,14916,'jp','è¤‡æ•°ã®è¡Œã‚’è¿½åŠ ã™ã‚‹ã«ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(536972,14916,'pt','Salvar para adicionar mais linhas',0),(536973,14916,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð´Ð»Ñ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÑÑ‚Ñ€Ð¾Ðº',0),(536974,14916,'es','Ahorrar para agregar mÃ¡s lÃ­neas',0),(536975,14916,'de','Sparen Sie weitere Zeilen hinzufÃ¼gen',0),(536976,14916,'en','Save To Add More Lines',0),(536977,14917,'is','',0),(536978,14917,'dr','Ù¾ÛŒ Ø§Ú† Ù¾ÛŒ Ø­Ù„Ù‚Ù‡ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(536979,14917,'pr','Ù¾ÛŒ Ø§Ú† Ù¾ÛŒ Ø­Ù„Ù‚Ù‡ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(536980,14917,'tr','Gerekli PHP Curl',0),(536981,14917,'pl','PHP Curl wymagane',0),(536982,14917,'bg','PHP ÐºÑŠÐ´Ñ€Ñ Ð¸Ð·Ð¸ÑÐºÐ²Ð°',0),(536983,14917,'ur','Ù¾ÛŒ Ø§ÛŒÚ† Ù¾ÛŒ Ù…ÙˆÚ‘Ù†Ø§ Ø¶Ø±ÙˆØ±ÛŒ',0),(536984,14917,'sr','ÐŸÐ¥ÐŸ ÑÐ°Ð²Ð¸Ñ˜Ð°ÑšÐµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾',0),(536985,14917,'vi','PHP Curl yÃªu cáº§u',0),(536986,14917,'af','PHP krul vereis',0),(536987,14917,'ro','PHP cÃ¢rlionÅ£a necesare',0),(536988,14917,'et','PHP Curl nÃµutav',0),(536989,14917,'si','PHP Curl, zahteva',0),(536990,14917,'ba','Curl PHP yang diperlukan',0),(536991,14917,'nl','PHP Curl vereist',0),(536992,14917,'fi','PHP Curl tarvitaan',0),(536993,14917,'no','PHP Curl kreves',0),(536994,14917,'da','PHP Curl krÃ¦ves',0),(536995,14917,'ko','PHP Curl í•„ìš”',0),(536996,14917,'he','×§×•×¨×œ PHP × ×“×¨×©',0),(536997,14917,'el','PHP Î¼Ï€Î¿ÏÎºÎ»Î± Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(536998,14917,'zh','æ‰€éœ€çš„ PHP å·æ›²',0),(536999,14917,'sv','PHP Curl krÃ¤vs',0),(537000,14917,'it','PHP Curl necessaria',0),(537001,14917,'tl','',0),(537002,14917,'th','à¸‚à¸” PHP à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¸à¸²à¸£',0),(537003,14917,'hi','à¤†à¤µà¤¶à¥à¤¯à¤• PHP à¤•à¤°à¥à¤²',0),(537004,14917,'ms','PHP Curl yang diperlukan',0),(537005,14917,'ar','PHP Ø§Ù„Ø¶ÙÙŠØ±Ø© Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(537006,14917,'fr','PHP Curl requis',0),(537007,14917,'jp','å¿…è¦ãª PHP ã®ã‚«ãƒ¼ãƒ«',0),(537008,14917,'pt','Curl PHP necessÃ¡rio',0),(537009,14917,'ru','PHP Curl Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ',0),(537010,14917,'es','PHP Curl requerido',0),(537011,14917,'de','PHP-Curl erforderlich',0),(537012,14917,'en','PHP Curl Required',0),(537013,14918,'is','',0),(537014,14918,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨ GL Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¬Ø¯ÛŒØ¯',0),(537015,14918,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨ GL Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¬Ø¯ÛŒØ¯',0),(537016,14918,'tr','Yeni varsayÄ±lan GL hesabÄ± ekleme',0),(537017,14918,'pl','Dodaj nowe konto domyÅ›lne GL',0),(537018,14918,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ GL',0),(537019,14918,'ur','Ù†ÛŒØ§ Ø·Û’ Ø´Ø¯Û Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(537020,14918,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð“Ð›',0),(537021,14918,'vi','ThÃªm tÃ i khoáº£n má»›i máº·c Ä‘á»‹nh GL',0),(537022,14918,'af','Voeg nuwe GL verstekrekening',0),(537023,14918,'ro','AdÃ£ugare cont nou implicit GL',0),(537024,14918,'et','Lisage uus vaikekonto GL',0),(537025,14918,'si','Dodaj nov privzeti raÄun GL',0),(537026,14918,'ba','Tambahkan Account GL Default baru',0),(537027,14918,'nl','Nieuwe standaard GL Account toevoegen',0),(537028,14918,'fi','LisÃ¤Ã¤ uusi oletus GL tili',0),(537029,14918,'no','Legge til ny standard GL konto',0),(537030,14918,'da','TilfÃ¸je nye standard GL konto',0),(537031,14918,'ko','ìƒˆë¡œìš´ ê¸°ë³¸ GL ê³„ì •ì„ ì¶”ê°€í•©ë‹ˆë‹¤',0),(537032,14918,'he','×œ×”×•×¡×™×£ ×—×©×‘×•×Ÿ ×—×“×© ×©×œ GL ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(537033,14918,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(537034,14918,'zh','æ·»åŠ æ–°çš„é»˜è®¤æ€»å¸ç§‘ç›®',0),(537035,14918,'sv','LÃ¤gg till nya standardkontot GL',0),(537036,14918,'it','Aggiungi nuovo Account predefinito di GL',0),(537037,14918,'tl','',0),(537038,14918,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(537039,14918,'hi','à¤¨à¤¯à¤¾ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ GL à¤–à¤¾à¤¤à¥‡ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(537040,14918,'ms','Menambah akaun GL lalai baru',0),(537041,14918,'ar','Ø¥Ø¶Ø§ÙØ© Ø­Ø³Ø§Ø¨ GL Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(537042,14918,'fr','Ajouter un nouveau compte GL par dÃ©faut',0),(537043,14918,'jp','æ–°ã—ã„æ—¢å®šã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(537044,14918,'pt','Adicionar nova conta GL padrÃ£o',0),(537045,14918,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²ÑƒÑŽ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ GL',0),(537046,14918,'es','Agregar nueva cuenta GL por defecto',0),(537047,14918,'de','Neues Standard-GL-Konto hinzufÃ¼gen',0),(537048,14918,'en','Add New Default GL Account',0),(537049,14919,'is','',0),(537050,14919,'dr','Ù…Ø­Ù„ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø´Ø±Ú©Øª',0),(537051,14919,'pr','Ù…Ø­Ù„ Ù¾ÛŒØ´ ÙØ±Ø¶ Ø´Ø±Ú©Øª',0),(537052,14919,'tr','VarsayÄ±lan ÅŸirket konumu',0),(537053,14919,'pl','Lokalizacja domyÅ›lna firmy',0),(537054,14919,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(537055,14919,'ur','Ø·Û’ Ø´Ø¯Û Ú©Ù…Ù¾Ù†ÛŒ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(537056,14919,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(537057,14919,'vi','Vá»‹ trÃ­ máº·c Ä‘á»‹nh cÃ´ng ty',0),(537058,14919,'af','Verstek maatskappy ligging',0),(537059,14919,'ro','Compania implicit locaÅ£ia',0),(537060,14919,'et','Vaikimisi ettevÃµtte asukoht',0),(537061,14919,'si','Podjetje privzeto mesto',0),(537062,14919,'ba','Lokasi default perusahaan',0),(537063,14919,'nl','Standaardbedrijf locatie',0),(537064,14919,'fi','Oletusyrityksen sijainti',0),(537065,14919,'no','Standard firmaplassering',0),(537066,14919,'da','Standardregnskabet placering',0),(537067,14919,'ko','ê¸°ë³¸ íšŒì‚¬ ìœ„ì¹˜',0),(537068,14919,'he','×ž×™×§×•× ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×”×—×‘×¨×”',0),(537069,14919,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(537070,14919,'zh','é»˜è®¤å…¬å¸ä½ç½®',0),(537071,14919,'sv','Standard fÃ¶retagsplats',0),(537072,14919,'it','Posizione predefinita azienda',0),(537073,14919,'tl','',0),(537074,14919,'th','à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡ à¸šà¸£à¸´à¸©à¸±à¸—à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(537075,14919,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤•à¤‚à¤ªà¤¨à¥€ à¤¸à¥à¤¥à¤¾à¤¨',0),(537076,14919,'ms','Lokasi Syarikat lalai',0),(537077,14919,'ar','Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(537078,14919,'fr','Emplacement de la sociÃ©tÃ© par dÃ©faut',0),(537079,14919,'jp','æ—¢å®šã®ä¼šç¤¾ã®å ´æ‰€',0),(537080,14919,'pt','LocalizaÃ§Ã£o da empresa padrÃ£o',0),(537081,14919,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(537082,14919,'es','UbicaciÃ³n de la empresa por defecto',0),(537083,14919,'de','Standard-Firmensitz',0),(537084,14919,'en','Default Company Location',0),(537085,14920,'is','',0),(537086,14920,'dr','Ú©Ø§Ø±Ø¨Ø± Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ ØªÙ†Ù‡Ø§ Ø§Ø³Øª',0),(537087,14920,'pr','Ú©Ø§Ø±Ø¨Ø± Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ ØªÙ†Ù‡Ø§ Ø§Ø³Øª',0),(537088,14920,'tr','KullanÄ±cÄ± yalnÄ±zca Mobil POS eriÅŸimi var',0),(537089,14920,'pl','UÅ¼ytkownik jest tylko mobilny dostÄ™p POS',0),(537090,14920,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ðµ Ð¼Ð¾Ð±Ð¸Ð»ÐµÐ½ POS Ð´Ð¾ÑÑ‚ÑŠÐ¿ ÑÐ°Ð¼Ð¾',0),(537091,14920,'ur','ØµØ§Ø±Ù Ú©Ùˆ ØµØ±Ù Ù…ÙˆØ¨Ø§Ø¦Ù„ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø±Ø³Ø§Ø¦ÛŒ ÛÛ’',0),(537092,14920,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ñ˜Ðµ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¼Ð¾Ð±Ð¸Ð»Ð½Ð¸Ð¼ ÐŸÐžÐ¡',0),(537093,14920,'vi','NgÆ°á»i sá»­ dá»¥ng lÃ  truy cáº­p POS di Ä‘á»™ng chá»‰',0),(537094,14920,'af','Gebruiker Is mobiele POS toegang slegs',0),(537095,14920,'ro','Utilizatorul este acces POS mobil numai',0),(537096,14920,'et','Kasutaja on mobiilne POS juurdepÃ¤Ã¤s ainult',0),(537097,14920,'si','Uporabnik je mobilni dostop POS le',0),(537098,14920,'ba','Pengguna adalah Mobile POS akses hanya',0),(537099,14920,'nl','Gebruiker Is alleen mobiele POS-toegang',0),(537100,14920,'fi','KÃ¤yttÃ¤jÃ¤ on POS mobiilikÃ¤yttÃ¶ vain',0),(537101,14920,'no','Brukeren er mobil POS tilgang bare',0),(537102,14920,'da','Brugeren er POS mobiladgang kun',0),(537103,14920,'ko','ì‚¬ìš©ìžê°€ ëª¨ë°”ì¼ POS ì•¡ì„¸ìŠ¤ ì „ìš©',0),(537104,14920,'he','×ž×©×ª×ž×© ×–×” ×’×™×©×” × ×™×™×“×ª ×§×•×¤×” ×‘×œ×‘×“',0),(537105,14920,'el','Î§ÏÎ®ÏƒÏ„Î·Ï‚ ÎµÎ¯Î½Î±Î¹ ÎºÎ¹Î½Î·Ï„Î® Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· Î¼ÏŒÎ½Î¿ Î¼Îµ Ï„Î¿ POS',0),(537106,14920,'zh','ç”¨æˆ·æ˜¯ç§»åŠ¨ POS æŽ¥å…¥åª',0),(537107,14920,'sv','AnvÃ¤ndaren Ã¤r mobil POS Ã¥tkomst endast',0),(537108,14920,'it','Utente Ã¨ il solo accesso Mobile POS',0),(537109,14920,'tl','',0),(537110,14920,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸—à¸µà¹ˆà¹€à¸›à¹‡à¸™ POS à¹€à¸‚à¹‰à¸²à¸¡à¸·à¸­à¸–à¸·à¸­à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(537111,14920,'hi','à¤®à¥‹à¤¬à¤¾à¤‡à¤² POS à¤ªà¤¹à¥à¤à¤š à¤•à¥‡à¤µà¤² à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¹à¥ˆ',0),(537112,14920,'ms','Pengguna adalah capaian POS mudah alih sahaja',0),(537113,14920,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ù‡Ùˆ Ø§Ù„ÙˆØµÙˆÙ„ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ø¬ÙˆØ§Ù„ ÙÙ‚Ø·',0),(537114,14920,'fr','L\'utilisateur est uniquement un accÃ¨s Mobile POS',0),(537115,14920,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ãŒãƒ¢ãƒã‚¤ãƒ« POS ã‚¢ã‚¯ã‚»ã‚¹ã®ã¿',0),(537116,14920,'pt','UsuÃ¡rio Ã© apenas acesso mÃ³vel POS',0),(537117,14920,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð±ÑƒÐ´ÐµÑ‚ ÐœÐ¾Ð±Ð¸Ð»ÑŒÐ½Ñ‹Ð¹ POS Ð´Ð¾ÑÑ‚ÑƒÐ¿ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(537118,14920,'es','Usuario es sÃ³lo acceso mÃ³vil POS',0),(537119,14920,'de','Benutzer ist nur Mobile POS-Zugriff',0),(537120,14920,'en','User Is Mobile POS Access Only',0),(537121,14921,'is','',0),(537122,14921,'dr','ØªØ§Ø±ÛŒØ® ÙØ§Ú©ØªÙˆØ± Ø´Ø§Ø±Ú˜ Ø®ÙˆØ¯Ú©Ø§Ø± Ø¯Ø± Ù…ÙˆØ¹Ø¯',0),(537123,14921,'pr','ØªØ§Ø±ÛŒØ® ÙØ§Ú©ØªÙˆØ± Ø´Ø§Ø±Ú˜ Ø®ÙˆØ¯Ú©Ø§Ø± Ø¯Ø± Ù…ÙˆØ¹Ø¯',0),(537124,14921,'tr','Otomatik ÅŸarj faturadaki vade tarihi',0),(537125,14921,'pl','Data faktury za auto na odpowiednim',0),(537126,14921,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð·Ð°Ñ€ÐµÐ¶Ð´Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð° Ð¿Ð°Ð´ÐµÐ¶',0),(537127,14921,'ur','ØªØ§Ø±ÛŒØ® Ù…Ù‚Ø±Ø±Û Ù¾Ø± Ø¢Ù¹Ùˆ Ú†Ø§Ø±Ø¬ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(537128,14921,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð¿ÑƒÑšÐµÑšÐµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð½Ð° ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(537129,14921,'vi','Tá»± Ä‘á»™ng hÃ³a Ä‘Æ¡n phÃ­ trÃªn do ngÃ y',0),(537130,14921,'af','Outomatiese beheer faktuur op die verskuldigde datum',0),(537131,14921,'ro','Factura de taxa auto pe cuvenit data',0),(537132,14921,'et','Auto eest arve tÃ¤htaeg kuupÃ¤ev',0),(537133,14921,'si','Datum raÄuna Auto dajatev na ustreznem',0),(537134,14921,'ba','Tanggal faktur muatan Auto pada waktunya',0),(537135,14921,'nl','Auto gratis factuur op Due Date',0),(537136,14921,'fi','Auto maksu laskun erÃ¤pÃ¤ivÃ¤nÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(537137,14921,'no','Auto kostnad pÃ¥ grunn fakturadato',0),(537138,14921,'da','Auto afgift faktura pÃ¥ behÃ¸rig dato',0),(537139,14921,'ko','ë•Œë¬¸ì— ìžë™ ì¶©ì „ ì†¡ìž¥ ë‚ ì§œ',0),(537140,14921,'he','×ª××¨×™×š ×—×©×‘×•× ×™×ª ×ª×©×œ×•× ××•×˜×•×ž×˜×™×ª ×¢×œ ×™×¢×“',0),(537141,14921,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· Ï‡ÏÎ­Ï‰ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÏ„Î· Î´Î­Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(537142,14921,'zh','è‡ªåŠ¨æ”¶è´¹å‘ç¥¨åœ¨åˆ°æœŸæ—¥æœŸ',0),(537143,14921,'sv','Automatisk laddning fakturan pÃ¥ Due Date',0),(537144,14921,'it','Data della fattura di addebito automatico su Due',0),(537145,14921,'tl','',0),(537146,14921,'th','à¸§à¸±à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¹ƒà¸™à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”',0),(537147,14921,'hi','à¤‘à¤Ÿà¥‹ à¤¶à¥à¤²à¥à¤• à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¤° à¤¨à¤¿à¤¯à¤¤ à¤¤à¤¾à¤°à¥€à¤–',0),(537148,14921,'ms','Invois bayaran auto pada tarikh',0),(537149,14921,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø±Ø³ÙˆÙ… Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ø¹Ù„Ù‰ Ø§Ù„Ù†Ø­Ùˆ Ø§Ù„ÙˆØ§Ø¬Ø¨',0),(537150,14921,'fr','Date de la facture de frais d\'automobile sur Due',0),(537151,14921,'jp','æœŸé™ã‚’è‡ªå‹•æ–™é‡‘è«‹æ±‚æ›¸ã®æ—¥ä»˜',0),(537152,14921,'pt','Factura de carga auto na devida Data',0),(537153,14921,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ Ð·Ð°Ñ€ÑÐ´ Auto Ð½Ð° Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð¼',0),(537154,14921,'es','Factura de carga automÃ¡tica en debida fecha',0),(537155,14921,'de','Auto kostenlos Rechnung auf Due Date',0),(537156,14921,'en','Auto Charge Invoice On Due Date',0),(537157,14922,'is','',0),(537158,14922,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¬Ø§Ø±Ù‡',0),(537159,14922,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø¬Ø§Ø±Ù‡',0),(537160,14922,'tr','Kira uygulamasÄ±',0),(537161,14922,'pl','DzierÅ¼awa aplikacji',0),(537162,14922,'bg','Ð›Ð¸Ð·Ð¸Ð½Ð³ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(537163,14922,'ur','Ù¾Ù¹Û’ Ù¾Ø± Ø¯ÛŒÙ†Û’ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(537164,14922,'sr','Ð›Ð¸Ð·Ð¸Ð½Ð³',0),(537165,14922,'vi','Cho thuÃª á»©ng dá»¥ng',0),(537166,14922,'af','Huurkontrak aansoek',0),(537167,14922,'ro','Cererea de leasing',0),(537168,14922,'et','Liisingutaotlus',0),(537169,14922,'si','Najem uporabe',0),(537170,14922,'ba','Sewa aplikasi',0),(537171,14922,'nl','Lease toepassing',0),(537172,14922,'fi','Vuokra Application',0),(537173,14922,'no','Lease program',0),(537174,14922,'da','Leasing ansÃ¸gning',0),(537175,14922,'ko','ìž„ëŒ€ ì‘ìš© í”„ë¡œê·¸ëž¨',0),(537176,14922,'he','×”×‘×§×©×” ×—×›×™×¨×”',0),(537177,14922,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î¼Î¯ÏƒÎ¸Ï‰ÏƒÎ·Ï‚',0),(537178,14922,'zh','ç§Ÿçº¦ä¸­çš„åº”ç”¨',0),(537179,14922,'sv','Lease program',0),(537180,14922,'it','Applicazione del contratto di locazione',0),(537181,14922,'tl','',0),(537182,14922,'th','à¹‚à¸›à¸£à¹à¸à¸£à¸¡à¹€à¸Šà¹ˆà¸²à¸‹à¸·à¹‰à¸­',0),(537183,14922,'hi','à¤²à¥€à¤œ à¤†à¤µà¥‡à¤¦à¤¨',0),(537184,14922,'ms','Permohonan pajakan',0),(537185,14922,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø¹Ù‚Ø¯ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø±',0),(537186,14922,'fr','Demande de location',0),(537187,14922,'jp','ç”³ã—è¾¼ã¿æ›¸ã®æå‡º',0),(537188,14922,'pt','Pedido de locaÃ§Ã£o',0),(537189,14922,'ru','Ð›Ð¸Ð·Ð¸Ð½Ð³Ð¾Ð²Ð°Ñ Ð·Ð°ÑÐ²ÐºÐ°',0),(537190,14922,'es','Solicitud de contrato de arrendamiento',0),(537191,14922,'de','Leasing-Anwendung',0),(537192,14922,'en','Lease Application',0),(537193,14923,'is','',0),(537194,14923,'dr','Ù…Ø³ØªØ§Ø¬Ø±Ø§Ù† ÙØ¹Ø§Ù„',0),(537195,14923,'pr','Ù…Ø³ØªØ§Ø¬Ø±Ø§Ù† ÙØ¹Ø§Ù„',0),(537196,14923,'tr','Etkin kiracÄ±',0),(537197,14923,'pl','Aktywne lokatorÃ³w',0),(537198,14923,'bg','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸Ñ‚Ðµ Ð½Ð°ÐµÐ¼Ð°Ñ‚ÐµÐ»Ð¸',0),(537199,14923,'ur','Ø²ÛŒØ± Ø¹Ù…Ù„ Ø¯Ø§Ø±ÙˆÚº',0),(537200,14923,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¸ ÑÑ‚Ð°Ð½Ð°Ñ€Ðµ',0),(537201,14923,'vi','NgÆ°á»i thuÃª nhÃ  hoáº¡t Ä‘á»™ng',0),(537202,14923,'af','Aktiewe huurders',0),(537203,14923,'ro','Activ chiriasi',0),(537204,14923,'et','Aktiivne Ã¼Ã¼rnikud',0),(537205,14923,'si','Aktivno najemnikov',0),(537206,14923,'ba','Aktif penyewa',0),(537207,14923,'nl','Actieve huurders',0),(537208,14923,'fi','Aktiivinen vuokralaisten',0),(537209,14923,'no','Aktive leietakere',0),(537210,14923,'da','Aktive lejere',0),(537211,14923,'ko','í™œì„±í™” ê±°ì£¼ìž',0),(537212,14923,'he','×“×™×™×¨×™× ×¤×¢×™×œ×”',0),(537213,14923,'el','Î•Î½ÎµÏÎ³ÏŒ ÎµÎ½Î¿Î¹ÎºÎ¹Î±ÏƒÏ„Î­Ï‚',0),(537214,14923,'zh','æ´»è·ƒçš„ç§Ÿæˆ·',0),(537215,14923,'sv','Aktiva hyresgÃ¤ster',0),(537216,14923,'it','Inquilini attivi',0),(537217,14923,'tl','',0),(537218,14923,'th','à¸œà¸¹à¹‰à¹€à¸Šà¹ˆà¸²à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸­à¸¢à¸¹à¹ˆ',0),(537219,14923,'hi','à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤¿à¤°à¤¾à¤¯à¥‡à¤¦à¤¾à¤°à¥‹à¤‚',0),(537220,14923,'ms','Penyewa yang aktif',0),(537221,14923,'ar','Ø§Ù„Ù…Ø³ØªØ£Ø¬Ø±ÙŠÙ† Ø§Ù„Ù†Ø´Ø·Ø©',0),(537222,14923,'fr','Locataires actives',0),(537223,14923,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªãƒ†ãƒŠãƒ³ãƒˆ',0),(537224,14923,'pt','Inquilinos ativos',0),(537225,14923,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ Ð¶Ð¸Ð»ÑŒÑ†Ñ‹',0),(537226,14923,'es','Inquilinos activos',0),(537227,14923,'de','Aktive Mieter',0),(537228,14923,'en','Active Tenants',0),(537229,14924,'is','',0),(537230,14924,'dr','Ø®Ø§Ø±Ø¬ Ø§Ø² Ø¨ÙˆØ±Ø³',0),(537231,14924,'pr','Ø®Ø§Ø±Ø¬ Ø§Ø² Ø¨ÙˆØ±Ø³',0),(537232,14924,'tr','Stokta',0),(537233,14924,'pl','Obecnie brak na stanie',0),(537234,14924,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚',0),(537235,14924,'ur','Ø§Ø³Ù¹Ø§Ú© Ø³Û’ Ø¨Ø§ÛØ±',0),(537236,14924,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð½ÐµÐ´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾',0),(537237,14924,'vi','Ra khá»i chá»©ng khoÃ¡n',0),(537238,14924,'af','Uit voorraad',0),(537239,14924,'ro','Din stoc',0),(537240,14924,'et','LÃ¤bimÃ¼Ã¼dud',0),(537241,14924,'si','Ni na zalogi',0),(537242,14924,'ba','Keluar dari saham',0),(537243,14924,'nl','Niet op voorraad',0),(537244,14924,'fi','Varastossa',0),(537245,14924,'no','Utsolgt',0),(537246,14924,'da','Udsolgt',0),(537247,14924,'ko','í’ˆì ˆ',0),(537248,14924,'he','××–×œ ×ž×”×ž×œ××™',0),(537249,14924,'el','Î•Î¾Î±Î½Ï„Î»Î®Î¸Î·ÎºÎµ',0),(537250,14924,'zh','åº“å­˜ä¸è¶³',0),(537251,14924,'sv','Slut i lager',0),(537252,14924,'it','Esaurito',0),(537253,14924,'tl','',0),(537254,14924,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸«à¸¡à¸”à¸ªà¸•à¹Šà¸­à¸',0),(537255,14924,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥‡ à¤¬à¤¾à¤¹à¤°',0),(537256,14924,'ms','Tiada dalam stok',0),(537257,14924,'ar','Ù„Ù„Ø®Ø±ÙˆØ¬ Ù…Ù† Ø§Ù„Ø£Ø³Ù‡Ù…',0),(537258,14924,'fr','En rupture de Stock',0),(537259,14924,'jp','åœ¨åº«åˆ‡ã‚Œ',0),(537260,14924,'pt','Fora de estoque',0),(537261,14924,'ru','ÐÐµÑ‚ Ð½Ð° ÑÐºÐ»Ð°Ð´Ðµ',0),(537262,14924,'es','Fuera de Stock',0),(537263,14924,'de','Nicht auf Lager',0),(537264,14924,'en','Out Of Stock',0),(537265,14925,'is','',0),(537266,14925,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†ÛŒ ØªØ®ÙÛŒÙ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(537267,14925,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ†ÛŒ ØªØ®ÙÛŒÙ Ø¯Ø± Ù‡Ù†Ú¯Ø§Ù… ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(537268,14925,'tr','Ä°ndirim geÃ§ersiz kÄ±lma, Ã¶demeleri girerken izin ver',0),(537269,14925,'pl','UmoÅ¼liwia nadpisanie zniÅ¼ki podczas wprowadzania pÅ‚atnoÅ›ci',0),(537270,14925,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð·Ð°Ð¼ÐµÑÑ‚Ð²Ð°Ð½Ðµ Ð¿Ñ€Ð¸ Ð²ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(537271,14925,'ur','Ø±Ø¹Ø§ÛŒØª ØªØ¬Ø§ÙˆØ² Ø¬Ø¨ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ù…ÛŒÚº Ø¯Ø§Ø®Ù„ ÛÙˆÙ†Û’ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(537272,14925,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð¿Ñ€ÐµÐ¼Ð¾ÑˆÑ›Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑƒÐ½Ð¾ÑÐ° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(537273,14925,'vi','Cho phÃ©p ghi Ä‘Ã¨ giáº£m giÃ¡ khi nháº­p cÃ¡c khoáº£n thanh toÃ¡n',0),(537274,14925,'af','Laat afslag oorheers wanneer betalings aangaan',0),(537275,14925,'ro','Permite reduceri suprascrie atunci cÃ¢nd intrÄƒ plÄƒÅ£i',0),(537276,14925,'et','Luba allahindluse alistamise maksete sisestamisel',0),(537277,14925,'si','Dovoli preglasitev popust pri vnosu plaÄil',0),(537278,14925,'ba','Memungkinkan menimpa diskon ketika memasuki pembayaran',0),(537279,14925,'nl','Korting overschrijven toestaan bij het invoeren van betalingen',0),(537280,14925,'fi','Salli alennuksen ohitus maksuja syÃ¶tettÃ¤essÃ¤',0),(537281,14925,'no','Tillat overstyring av rabatt nÃ¥r betalinger',0),(537282,14925,'da','Tillade rabat tilsidesÃ¦tte, nÃ¥r du indtaster betalinger',0),(537283,14925,'ko','ì§€ë¶ˆ ìž…ë ¥í•  ë•Œ í• ì¸ ìž¬ì •ì˜ í—ˆìš©',0),(537284,14925,'he','×œ××¤×©×¨ ×¢×§×™×¤×ª ×”× ×—×” ×‘×¢×ª ×”×–× ×ª ×ª×©×œ×•×ž×™×',0),(537285,14925,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î·Î½ Ï€Î±ÏÎ¬ÎºÎ±Î¼ÏˆÎ· Î­ÎºÏ€Ï„Ï‰ÏƒÎ· ÎºÎ±Ï„Î¬ Ï„Î·Î½ ÎµÎ¯ÏƒÎ¿Î´Î¿ Ï„Ï‰Î½ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(537286,14925,'zh','åœ¨è¾“å…¥ä»˜æ¬¾æ—¶å…è®¸æŠ˜æ‰£æ”¹å†™',0),(537287,14925,'sv','TillÃ¥ta rabatt omstÃ¤llning nÃ¤r du anger betalningar',0),(537288,14925,'it','Consentire sconto Override quando entrano i pagamenti',0),(537289,14925,'tl','',0),(537290,14925,'th','à¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¹à¸—à¸™à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¹€à¸¡à¸·à¹ˆà¸­à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(537291,14925,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤“à¤µà¤°à¤°à¤¾à¤‡à¤¡ à¤œà¤¬ à¤­à¥à¤—à¤¤à¤¾à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤°à¤¨à¥‡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(537292,14925,'ms','Membenarkan menimpa diskaun apabila memasukkan bayaran',0),(537293,14925,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨ØªØ¬Ø§ÙˆØ² Ø§Ù„Ø®ØµÙ… Ø¹Ù†Ø¯ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(537294,14925,'fr','Permettent la remise de substitution lors de la saisie des paiements',0),(537295,14925,'jp','æ”¯æ‰•ã®å…¥åŠ›æ™‚ã«å‰²å¼•ã®ä¸Šæ›¸ãã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(537296,14925,'pt','Permitir substituiÃ§Ã£o de desconto quando entrar em pagamentos',0),(537297,14925,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÐ¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ ÑÐºÐ¸Ð´ÐºÐ° Ð¿Ñ€Ð¸ Ð²Ð²Ð¾Ð´Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(537298,14925,'es','Permitir anulaciÃ³n de descuento al ingresar los pagos',0),(537299,14925,'de','Rabatt Ãœberschreibung zu ermÃ¶glichen, bei der Eingabe von Zahlungen',0),(537300,14925,'en','Allow Discount Override When Entering Payments',0),(537301,14926,'is','',0),(537302,14926,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú©Ø´ØªÛŒ ÙˆØ§Ù‚Ø¹ÛŒ Ø´Ø§Ø±Ú˜ Ø¨Ø±Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± Ø§Ú¯Ø± Ø´Ø§Ø±Ú˜ Ù‡ÛŒÚ† Ú©Ø´ØªÛŒ Ø¨Ø± Ø§Ø³Ø§Ø³ Ø³ÙØ§Ø±Ø´',0),(537303,14926,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú©Ø´ØªÛŒ ÙˆØ§Ù‚Ø¹ÛŒ Ø´Ø§Ø±Ú˜ Ø¨Ø±Ø§ÛŒ ÙØ§Ú©ØªÙˆØ± Ø§Ú¯Ø± Ø´Ø§Ø±Ú˜ Ù‡ÛŒÚ† Ú©Ø´ØªÛŒ Ø¨Ø± Ø§Ø³Ø§Ø³ Ø³ÙØ§Ø±Ø´',0),(537304,14926,'tr','HiÃ§bir gemi sipariÅŸi Ã¼zerinde ÅŸarj fiili sevk giderleri fatura iÃ§in kullanÄ±n',0),(537305,14926,'pl','JeÅ›li Å¼aden statek za na zamÃ³wienie za pomocÄ… statku za faktury',0),(537306,14926,'bg','ÐÐºÐ¾ Ð½ÑÐ¼Ð° ÐºÐ¾Ñ€Ð°Ð± Ñ‚Ð°ÐºÑÐ° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¸Ñ ÐºÐ¾Ñ€Ð°Ð± Ñ‚Ð°ÐºÑÐ° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(537307,14926,'ur','Ø§Ú¯Ø± Ú©ÙˆØ¦ÛŒ Ø¬ÛØ§Ø² Ø¢Ø±ÚˆØ± Ù¾Ø± Ú†Ø§Ø±Ø¬ Ø§ØµÙ„ Ø¬ÛØ§Ø² Ú†Ø§Ø±Ø¬ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(537308,14926,'sr','ÐÐºÐ¾ Ð½ÐµÐ¼Ð° Ð±Ñ€Ð¾Ð´Ð° Ð·Ð° Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ð¼ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÑ‚Ð²Ð°Ñ€Ð½Ðµ Ð±Ñ€Ð¾Ð´ Ð¿ÑƒÑšÐµÑšÐµ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(537309,14926,'vi','Náº¿u khÃ´ng cÃ³ tÃ u phÃ­ trÃªn Ä‘Æ¡n Ä‘áº·t hÃ ng sá»­ dá»¥ng thá»±c táº¿ tÃ u phÃ­ cho hÃ³a Ä‘Æ¡n',0),(537310,14926,'af','Indien geen skip hef op bestelling gebruik werklike skip gelaai vir faktuur',0),(537311,14926,'ro','DacÄƒ nava nu percepe comanda utilizarea navei reale taxÄƒ pentru factura',0),(537312,14926,'et','Kui Ã¼htegi laeva eest tellimuses kasutada laeva eest arve',0),(537313,14926,'si','ÄŒe nobena ladja zaraÄuna na nalogu uporabo dejanski ladji naboja za raÄun',0),(537314,14926,'ba','Jika kapal tidak mengisi pesanan menggunakan biaya sebenarnya kapal untuk faktur',0),(537315,14926,'nl','Als geen schip op volgorde laadt gebruiken werkelijke schip kosten voor factuur',0),(537316,14926,'fi','Jos alus ei periÃ¤ tilauksesta kÃ¤yttÃ¤Ã¤ todellisia toimituksen laskun',0),(537317,14926,'no','Hvis ingen skipet lader pÃ¥ bestilling bruke faktiske leveringskostnaden For fakturaen',0),(537318,14926,'da','Hvis ingen skib opkrÃ¦ver pÃ¥ ordre bruge faktiske skib afgift For faktura',0),(537319,14926,'ko','ì•„ë¬´ ì„ ë°• ì£¼ë¬¸ì— ì¶©ì „ í•˜ë©´ ì†¡ìž¥ì— ëŒ€ í•œ ì‹¤ì œ ì„ ë°• ìš”ê¸ˆì„ ì‚¬ìš©',0),(537320,14926,'he','×× ×”×¡×¤×™× ×” ××™×Ÿ ×œ×—×™×™×‘ ×¢×œ ×ž× ×ª ×œ×”×©×ª×ž×© ×‘×¤×•×¢×œ ×”×¡×¤×™× ×” ×ª×©×œ×•× ×¢×‘×•×¨ ×—×©×‘×•× ×™×ª',0),(537321,14926,'el','Î‘Î½ Ï„Î¿ Ï€Î»Î¿Î¯Î¿ Î´ÎµÎ½ Ï‡ÏÎµÏŽÎ½Î¿Ï…Î½ Î³Î¹Î± Ï‡ÏÎ®ÏƒÎ· Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ¿Ï Ï€Î»Î¿Î¯Î¿Ï… Î´Î±Ï€Î¬Î½Î· Î³Î¹Î± Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(537322,14926,'zh','å¦‚æžœæ²¡æœ‰èˆ¹æŠ¼é¡ºåºä½¿ç”¨å®žé™…è¿è´¹å‘ç¥¨',0),(537323,14926,'sv','Om inga fartyg avgift pÃ¥ Order AnvÃ¤nd verkliga fartygets avgift fÃ¶r faktura',0),(537324,14926,'it','Se nessuna nave carica su ordine utilizzare reale nave carica per fattura',0),(537325,14926,'tl','',0),(537326,14926,'th','à¸–à¹‰à¸²à¹€à¸£à¸·à¸­à¹„à¸¡à¹ˆà¸¡à¸µà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¹ƒà¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡ à¹ƒà¸Šà¹‰à¸„à¹ˆà¸²à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ˆà¸£à¸´à¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(537327,14926,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤œà¤¹à¤¾à¤œ à¤ªà¥à¤°à¤­à¤¾à¤°à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚ à¤¯à¤¦à¤¿ à¤•à¥‹à¤ˆ à¤œà¤¹à¤¾à¤œ à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤†à¤°à¥‹à¤ª',0),(537328,14926,'ms','Jika kapal tiada caj ke atas pesanan menggunakan bayaran sebenar kapal untuk invois',0),(537329,14926,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ø£ÙŠ Ø³ÙÙŠÙ†Ø© Ø´Ø­Ù† ÙÙŠ Ø£Ù…Ø± Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø±Ø³ÙˆÙ… Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø§Ù„ÙØ¹Ù„ÙŠØ© Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(537330,14926,'fr','Si aucun navire de Charge sur commande utiliser navire rÃ©el frais pour facture',0),(537331,14926,'jp','èˆ¹æ–™ã®é †åºã«ä½¿ç”¨å®Ÿèˆ¹æ–™é‡‘è«‹æ±‚',0),(537332,14926,'pt','Se nenhum navio cobrar na ordem usar carga de navio real para fatura',0),(537333,14926,'ru','Ð•ÑÐ»Ð¸ Ð½Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð·Ð°Ñ€ÑÐ´ Ð½Ð° Ð·Ð°ÐºÐ°Ð· Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð·Ð°Ñ€ÑÐ´Ð° Ð´Ð»Ñ ÑÑ‡ÐµÑ‚Ð°',0),(537334,14926,'es','Si ningÃºn barco de carga en orden usa buque real carga para factura',0),(537335,14926,'de','Wenn kein Schiff auf Bestellung berechnen verwenden Sie tatsÃ¤chliche Schiff kostenlos fÃ¼r Rechnung',0),(537336,14926,'en','If No Ship Charge On Order Use Actual Ship Charge For Invoice',0),(537337,14927,'is','',0),(537338,14927,'dr','Ø¬Ø¯Ø§Ú¯Ø§Ù†Ù‡ ØªÙˆØ³Ø· Ú©Ø´ØªÛŒ Ø¨Ù‡',0),(537339,14927,'pr','Ø¬Ø¯Ø§Ú¯Ø§Ù†Ù‡ ØªÙˆØ³Ø· Ú©Ø´ØªÛŒ Ø¨Ù‡',0),(537340,14927,'tr','Gemi iÃ§in ayrÄ±',0),(537341,14927,'pl','Oddzielne statkiem do',0),(537342,14927,'bg','ÐžÑ‚Ð´ÐµÐ»Ð½Ð¾ Ñ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾',0),(537343,14927,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ø¹Ù„ÛŒØ­Ø¯Û',0),(537344,14927,'sr','ÐžÐ´Ð²Ð¾Ñ˜ÐµÐ½Ð° Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð±Ñ€Ð¾Ð´Ð° Ð´Ð°',0),(537345,14927,'vi','RiÃªng biá»‡t bá»Ÿi tÃ u',0),(537346,14927,'af','Afsonderlike per skip na',0),(537347,14927,'ro','Separat de nava sÄƒ',0),(537348,14927,'et','Eraldi laevasÃµidu',0),(537349,14927,'si','LoÄena z ladjo do',0),(537350,14927,'ba','Terpisah oleh kapal untuk',0),(537351,14927,'nl','Afzonderlijke per schip naar',0),(537352,14927,'fi','Erottaa aluksen',0),(537353,14927,'no','Separat med skip til',0),(537354,14927,'da','SÃ¦rskilt med skib til',0),(537355,14927,'ko','ë°°ë¥¼ í•˜ ì—¬ ë³„ë„',0),(537356,14927,'he','× ×¤×¨×“ ×¢×œ ×™×“×™ ×”×¡×¤×™× ×”',0),(537357,14927,'el','ÎžÎµÏ‡Ï‰ÏÎ¹ÏƒÏ„ÏŒ Î¼Îµ Ï€Î»Î¿Î¯Î¿',0),(537358,14927,'zh','å•ç‹¬ç”¨èˆ¹è¿åˆ°',0),(537359,14927,'sv','Separat med fartyg till',0),(537360,14927,'it','Separato dalla nave a',0),(537361,14927,'tl','',0),(537362,14927,'th','à¹à¸¢à¸à¸•à¹ˆà¸²à¸‡à¸«à¸²à¸ à¹‚à¸”à¸¢à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹„à¸›à¸¢à¸±à¸‡',0),(537363,14927,'hi','à¤…à¤²à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(537364,14927,'ms','Berasingan oleh kapal',0),(537365,14927,'ar','Ù…Ù†ÙØµÙ„Ø© Ø¨Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(537366,14927,'fr','SÃ©parÃ© par bateau Ã ',0),(537367,14927,'jp','èˆ¹ãŒåˆ¥',0),(537368,14927,'pt','Separado por navio para',0),(537369,14927,'ru','ÐžÑ‚Ð´ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð´Ð»Ñ',0),(537370,14927,'es','Separados por la nave a',0),(537371,14927,'de','Separate per Schiff nach',0),(537372,14927,'en','Separate By Ship To',0),(537373,14928,'is','',0),(537374,14928,'dr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(537375,14928,'pr','Ø®Ø·Ø§ Ø¯Ø± Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(537376,14928,'tr','Hata iÅŸleme dosyasÄ±',0),(537377,14928,'pl','BÅ‚Ä…d przetwarzania pliku',0),(537378,14928,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° Ñ„Ð°Ð¹Ð»Ð°',0),(537379,14928,'ur','Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ù…Ø³Ù„ Ù†Ù‚Øµ',0),(537380,14928,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¾Ð±Ñ€Ð°Ð´Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(537381,14928,'vi','Lá»—i xá»­ lÃ½ táº­p tin',0),(537382,14928,'af','Fout verwerking lÃªer',0),(537383,14928,'ro','Eroare de procesare fiÅŸier',0),(537384,14928,'et','TÃµrge menetluse toimiku',0),(537385,14928,'si','Napaka pri obdelavi datoteke',0),(537386,14928,'ba','Kesalahan pengolahan File',0),(537387,14928,'nl','Fout bij verwerking van bestand',0),(537388,14928,'fi','Virhetiedoston kÃ¤sittelyssÃ¤',0),(537389,14928,'no','Feil ved behandling av fil',0),(537390,14928,'da','Fejl under behandling af fil',0),(537391,14928,'ko','ì˜¤ë¥˜ ì²˜ë¦¬ íŒŒì¼',0),(537392,14928,'he','×©×’×™××” ×‘×¢×™×‘×•×“ ×§×•×‘×¥',0),(537393,14928,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÏƒÏ†Î±Î»Î¼Î¬Ï„Ï‰Î½',0),(537394,14928,'zh','å¤„ç†æ–‡ä»¶æ—¶å‡ºé”™',0),(537395,14928,'sv','Fel vid bearbetning av fil',0),(537396,14928,'it','Errore elaborazione File',0),(537397,14928,'tl','',0),(537398,14928,'th','à¹à¸Ÿà¹‰à¸¡à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(537399,14928,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¸à¤‚à¤¸à¤¾à¤§à¤¨ à¤«à¤¼à¤¾à¤‡à¤²',0),(537400,14928,'ms','Ralat pemprosesan fail',0),(537401,14928,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ù…Ù„Ù',0),(537402,14928,'fr','Fichier de traitement des erreurs',0),(537403,14928,'jp','ãƒ•ã‚¡ã‚¤ãƒ«å‡¦ç†ã‚¨ãƒ©ãƒ¼',0),(537404,14928,'pt','Arquivo de processamento de erros',0),(537405,14928,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐµ Ñ„Ð°Ð¹Ð»Ð°',0),(537406,14928,'es','Error al procesar el archivo',0),(537407,14928,'de','Fehler verarbeiten der Datei',0),(537408,14928,'en','Error Processing File',0),(537409,14929,'is','',0),(537410,14929,'dr','Ø¯Ø±ÛŒØ§ÙØª ÙØ§ÛŒÙ„ Ø¯Ø± Ù‚Ø§Ù„Ø¨ CSV Ø¨Ø§ÛŒØ¯',0),(537411,14929,'pr','Ø¯Ø±ÛŒØ§ÙØª ÙØ§ÛŒÙ„ Ø¯Ø± Ù‚Ø§Ù„Ø¨ CSV Ø¨Ø§ÛŒØ¯',0),(537412,14929,'tr','DosyayÄ± CSV biÃ§iminde olmasÄ± gerekir',0),(537413,14929,'pl','Plik musi byÄ‡ w formacie CSV',0),(537414,14929,'bg','Ð¤Ð°Ð¹Ð»ÑŠÑ‚ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ð² CSV Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(537415,14929,'ur','ÙØ§Ø¦Ù„ CSV ÙˆØ¶Ø¹ Ù…ÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(537416,14929,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ñƒ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ñƒ Ð¦Ð¡Ð’',0),(537417,14929,'vi','Táº­p tin pháº£i á»Ÿ Ä‘á»‹nh dáº¡ng CSV',0),(537418,14929,'af','LÃªer moet word In die CSV-formaat',0),(537419,14929,'ro','FiÅŸierul trebuie sÄƒ fie Ã®n CSV Format',0),(537420,14929,'et','Fail peab olema CSV formaadis',0),(537421,14929,'si','Datoteka mora biti v formatu CSV',0),(537422,14929,'ba','File ini harus dalam CSV Format',0),(537423,14929,'nl','Bestand moet zich In CSV-indeling',0),(537424,14929,'fi','Tiedoston on oltava CSV-muodossa',0),(537425,14929,'no','Filen mÃ¥ vÃ¦re i CSV-Format',0),(537426,14929,'da','Filen skal vÃ¦re i CSV-Format',0),(537427,14929,'ko','íŒŒì¼ì€ CSV í˜•ì‹ ì´ì–´ì•¼',0),(537428,14929,'he','×”×§×•×‘×¥ ×—×™×™×‘ ×œ×”×™×•×ª ×‘×ª×‘× ×™×ª CSV',0),(537429,14929,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÏƒÎµ Î¼Î¿ÏÏ†Î® CSV',0),(537430,14929,'zh','æ–‡ä»¶å¿…é¡»ä»¥ CSV æ ¼å¼',0),(537431,14929,'sv','Filen mÃ¥ste vara i CSV-Format',0),(537432,14929,'it','File deve essere In formato CSV',0),(537433,14929,'tl','',0),(537434,14929,'th','à¹à¸Ÿà¹‰à¸¡à¸•à¹‰à¸­à¸‡à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸£à¸¹à¸›à¹à¸šà¸š CSV',0),(537435,14929,'hi','à¤«à¤¼à¤¾à¤‡à¤² CSV à¤ªà¥à¤°à¤¾à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(537436,14929,'ms','Fail mestilah dalam CSV Format',0),(537437,14929,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø§Ù„Ù…Ù„Ù ÙÙŠ ØªÙ†Ø³ÙŠÙ‚ CSV',0),(537438,14929,'fr','Fichier doit Ãªtre au Format CSV',0),(537439,14929,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ CSV å½¢å¼ã§ã‚ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(537440,14929,'pt','Arquivo deve estar no formato CSV',0),(537441,14929,'ru','Ð¤Ð°Ð¹Ð» Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð² Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚Ðµ CSV',0),(537442,14929,'es','Archivo debe estar en formato CSV',0),(537443,14929,'de','Datei muss im CSV-Format',0),(537444,14929,'en','File Must Be In CSV Format',0),(537445,14930,'is','',0),(537446,14930,'dr','Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø¨Ø§ÛŒØ¯ Ø¨Ù‡ Ú©Ù…ØªØ± Ø§Ø² 4 Mb',0),(537447,14930,'pr','Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø¨Ø§ÛŒØ¯ Ø¨Ù‡ Ú©Ù…ØªØ± Ø§Ø² 4 Mb',0),(537448,14930,'tr','Dosya 4 MB\'den daha az olmalÄ±dÄ±r',0),(537449,14930,'pl','Plik musi byÄ‡ mniejsza niÅ¼ 4 Mb',0),(537450,14930,'bg','Ð¤Ð°Ð¹Ð»ÑŠÑ‚ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ð¿Ð¾-Ð¼Ð°Ð»ÐºÐ¾ Ð¾Ñ‚ 4 Mb',0),(537451,14930,'ur','Ù…Ø³Ù„ Ø³Û’ Ú©Ù… 4 Ø§ÛŒÙ… Ø¨ÛŒ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(537452,14930,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¼Ð°ÑšÐµ Ð¾Ð´ 4 ÐœÐ±',0),(537453,14930,'vi','Táº­p tin pháº£i lÃ  Ã­t hÆ¡n 4 Mb',0),(537454,14930,'af','LÃªer moet nie minder as 4 Mb wees nie',0),(537455,14930,'ro','FiÅŸierul trebuie sÄƒ fie mai micÄƒ de 4 Mb',0),(537456,14930,'et','Fail on vÃ¤iksem kui 4 Mb',0),(537457,14930,'si','Datoteka mora biti manj kot 4 Mb',0),(537458,14930,'ba','File ini harus kurang dari 4 Mb',0),(537459,14930,'nl','Bestand moet minder dan 4 Mb',0),(537460,14930,'fi','Tiedoston on oltava alle 4 megatavua',0),(537461,14930,'no','Filen mÃ¥ vÃ¦re mindre enn 4 Mb',0),(537462,14930,'da','Filen skal vÃ¦re mindre end 4 Mb',0),(537463,14930,'ko','íŒŒì¼ 4mb ë¯¸ë§Œ ì´ì–´ì•¼ í•©ë‹ˆë‹¤.',0),(537464,14930,'he','×§×•×‘×¥ ×—×™×™×‘ ×œ×”×™×•×ª ×¤×—×•×ª ×ž- 4 Mb',0),(537465,14930,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î»Î¹Î³ÏŒÏ„ÎµÏÎ¿ Î±Ï€ÏŒ 4 Mb',0),(537466,14930,'zh','æ–‡ä»¶å¿…é¡»å°äºŽ 4 Mb',0),(537467,14930,'sv','Filen mÃ¥ste vara mindre Ã¤n 4 Mb',0),(537468,14930,'it','File deve essere inferiore a 4 Mb',0),(537469,14930,'tl','',0),(537470,14930,'th','à¹„à¸Ÿà¸¥à¹Œà¸•à¹‰à¸­à¸‡à¸™à¹‰à¸­à¸¢à¸à¸§à¹ˆà¸² 4 Mb',0),(537471,14930,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ à¤•à¤® à¤¸à¥‡ à¤•à¤® 4 Mb',0),(537472,14930,'ms','Fail mestilah kurang dari 4 Mb',0),(537473,14930,'ar','Ø§Ù„Ù…Ù„Ù ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø£Ù‚Ù„ Ù…Ù† 4 Ù…ÙŠØºØ§ Ø¨Ø§ÙŠØª',0),(537474,14930,'fr','Fichier doit Ãªtre infÃ©rieure Ã  4 Mo',0),(537475,14930,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ãŒ 4 Mb æœªæº€ã«ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(537476,14930,'pt','Arquivo deve ser inferior a 4 Mb',0),(537477,14930,'ru','Ð¤Ð°Ð¹Ð» Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð¼ÐµÐ½ÑŒÑˆÐµ 4 ÐœÐ‘',0),(537478,14930,'es','El archivo debe estar a menos de 4 Mb',0),(537479,14930,'de','Datei muss weniger als 4 Mb sein.',0),(537480,14930,'en','File Must Be Less Than 4 Mb',0),(537481,14931,'is','',0),(537482,14931,'dr','Ø®Ø· Ø²ÛŒØ± Ú©Ø´ØªÛŒ Ø®Ø§Ø±Ø¬ Ø§Ø² Ú©Ø´ÙˆØ± Ù†ÛŒØ³Øª',0),(537483,14931,'pr','Ø®Ø· Ø²ÛŒØ± Ú©Ø´ØªÛŒ Ø®Ø§Ø±Ø¬ Ø§Ø² Ú©Ø´ÙˆØ± Ù†ÛŒØ³Øª',0),(537484,14931,'tr','AÅŸaÄŸÄ±daki satÄ±rÄ± yurtdÄ±ÅŸÄ± gemi olamaz',0),(537485,14931,'pl','NastÄ™pujÄ…cy wiersz nie statku za granicÄ…',0),(537486,14931,'bg','Ð¡Ð»ÐµÐ´Ð½Ð¸ÑÑ‚ Ñ€ÐµÐ´ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÐºÐ¾Ñ€Ð°Ð± Ð² Ñ‡ÑƒÐ¶Ð±Ð¸Ð½Ð°',0),(537487,14931,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ù„Ø§Ø¦Ù† Ø¬ÛØ§Ø² Ø³Ù…Ù†Ø¯Ø± Ù¾Ø§Ø± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(537488,14931,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ñ€ÐµÐ´ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚Ð¸ Ñƒ Ð¸Ð½Ð¾ÑÑ‚Ñ€Ð°Ð½ÑÑ‚Ð²Ñƒ',0),(537489,14931,'vi','DÃ²ng sau khÃ´ng thá»ƒ gá»­i á»Ÿ nÆ°á»›c ngoÃ i',0),(537490,14931,'af','Die volgende lyn kan oorsee skip',0),(537491,14931,'ro','UrmÄƒtoarea linie nu navÄƒ de peste mÄƒri',0),(537492,14931,'et','JÃ¤rgmine rida ei saa lÃ¤hetada vÃ¤lismaal',0),(537493,14931,'si','Naslednja vrstica ni ladjo v tujini',0),(537494,14931,'ba','Baris berikut tidak bisa kapal luar negeri',0),(537495,14931,'nl','De volgende regel schip niet overzee',0),(537496,14931,'fi','Seuraava rivi ei voi aluksen ulkomaille',0),(537497,14931,'no','FÃ¸lgende linje skipet ikke utlandet',0),(537498,14931,'da','FÃ¸lgende linje kan ikke skib udlandet',0),(537499,14931,'ko','ë‹¤ìŒ ì¤„ í•´ì™¸ ë°°ì†¡í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(537500,14931,'he','×”×©×•×¨×” ×”×‘××” ×œ× ×™×›×•×œ×”. ×œ×©×œ×•×— ×œ×—×•',0),(537501,14931,'el','Î— Î±ÎºÏŒÎ»Î¿Ï…Î¸Î· Î³ÏÎ±Î¼Î¼Î® Î´ÎµÎ½ Ï€Î»Î¿Î¯Î¿ ÏƒÏ„Î¿ ÎµÎ¾Ï‰Ï„ÎµÏÎ¹ÎºÏŒ',0),(537502,14931,'zh','ä¸‹é¢çš„è¡Œä¸èƒ½å¯„å¾€æµ·å¤–',0),(537503,14931,'sv','FÃ¶ljande rad kan inte fartyget utomlands',0),(537504,14931,'it','La riga seguente non puÃ² spedire all\'estero',0),(537505,14931,'tl','',0),(537506,14931,'th','à¸šà¸£à¸£à¸—à¸±à¸”à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸•à¹ˆà¸²à¸‡à¸›à¸£à¸°à¹€à¸—à¸¨',0),(537507,14931,'hi','à¤¨à¤¿à¤®à¥à¤¨ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤µà¤¿à¤¦à¥‡à¤¶à¥€ à¤œà¤¹à¤¾à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(537508,14931,'ms','Baris yang berikut tidak kapal di luar negara',0),(537509,14931,'ar','Ø§Ù„Ø³Ø·Ø± Ø§Ù„ØªØ§Ù„ÙŠ Ù„Ø§ Ø³ÙÙŠÙ†Ø© ÙÙŠ Ø§Ù„Ø®Ø§Ø±Ø¬',0),(537510,14931,'fr','La ligne suivante ne peut pas expÃ©dier Ã  l\'Ã©tranger',0),(537511,14931,'jp','æµ·å¤–å‡ºè·ã§ããªã„ãŸã‚ã€æ¬¡ã®è¡Œ',0),(537512,14931,'pt','A linha a seguir nÃ£o fazem entregas internacionais',0),(537513,14931,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð°Ñ ÑÑ‚Ñ€Ð¾ÐºÐ° Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð° Ð·Ð° Ñ€ÑƒÐ±ÐµÐ¶Ð¾Ð¼',0),(537514,14931,'es','No puede enviar la siguiente lÃ­nea en el extranjero',0),(537515,14931,'de','Die folgende Zeile kann nicht im Ausland versenden',0),(537516,14931,'en','The Following Line Cannot Ship Overseas',0),(537517,14932,'is','',0),(537518,14932,'dr','Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ CSV Ø®Ø· Ù…ÙˆØ±Ø¯',0),(537519,14932,'pr','Ø¢Ù¾Ù„ÙˆØ¯ ÙØ§ÛŒÙ„ CSV Ø®Ø· Ù…ÙˆØ±Ø¯',0),(537520,14932,'tr','SatÄ±r Ã¶ÄŸesi CSV dosyasÄ± yÃ¼kleme',0),(537521,14932,'pl','PrzeÅ›lij plik CSV pozycji',0),(537522,14932,'bg','ÐšÐ°Ñ‡Ð²Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ CSV Ñ„Ð°Ð¹Ð»',0),(537523,14932,'ur','Ù„Ø§Ø¦Ù† Ø´Û’ CSV ÙØ§Ø¦Ù„ Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(537524,14932,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð°ÑšÐµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð¦Ð¡Ð’ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(537525,14932,'vi','Táº£i lÃªn tá»‡p CSV chi tiáº¿t Ä‘Æ¡n hÃ ng',0),(537526,14932,'af','Lyn-Item CSV-lÃªer oplaai',0),(537527,14932,'ro','ÃŽncÄƒrcaÅ£i fiÅŸierul CSV element rÃ¢nd',0),(537528,14932,'et','ReaÃ¼ksuse CSV faili Ã¼les laadida',0),(537529,14932,'si','NaloÅ¾ite datoteko CSV vrstiÄne postavke',0),(537530,14932,'ba','Meng-upload File CSV Item baris',0),(537531,14932,'nl','Regelitem CSV-bestand uploadt',0),(537532,14932,'fi','LÃ¤hetÃ¤ rivinimikkeen CSV-tiedosto',0),(537533,14932,'no','Linjeelement CSV filopplasting',0),(537534,14932,'da','Uploade linjeelement CSV-fil',0),(537535,14932,'ko','í’ˆëª© CSV íŒŒì¼ ì—…ë¡œë“œ',0),(537536,14932,'he','×”×¢×œ××ª ×§×•×‘×¥ CSV ×¤×¨×™×˜ ×©×•×¨×”',0),(537537,14932,'el','Î‘Î½ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ CSV ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(537538,14932,'zh','ä¸Šè½½è¡Œé¡¹ç›® CSV æ–‡ä»¶',0),(537539,14932,'sv','Ladda upp radartikel CSV-filen',0),(537540,14932,'it','Caricare File CSV elemento pubblicitario',0),(537541,14932,'tl','',0),(537542,14932,'th','à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¹à¸Ÿà¹‰à¸¡ CSV à¸£à¸²à¸¢à¸à¸²à¸£',0),(537543,14932,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® CSV à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(537544,14932,'ms','Muat naik fail CSV Line Item',0),(537545,14932,'ar','ØªØ­Ù…ÙŠÙ„ Ù…Ù„Ù CSV Ø¨Ù†Ø¯',0),(537546,14932,'fr','TÃ©lÃ©charger le fichier CSV de rubrique',0),(537547,14932,'jp','CSV ãƒ•ã‚¡ã‚¤ãƒ«ã®è¡Œã‚¢ã‚¤ãƒ†ãƒ ã‚’ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(537548,14932,'pt','Upload de arquivo CSV de Item de linha',0),(537549,14932,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ ÑÑ‚Ñ€Ð¾ÐºÐ¸ CSV-Ñ„Ð°Ð¹Ð»Ð°',0),(537550,14932,'es','Cargue el archivo CSV renglÃ³n',0),(537551,14932,'de','Einzelposten-CSV-Datei hochladen',0),(537552,14932,'en','Upload Line Item CSV File',0),(537553,14933,'is','',0),(537554,14933,'dr','Ø­Ø°Ù Ø§Ù…Ø¶Ø§ÛŒ',0),(537555,14933,'pr','Ø­Ø°Ù Ø§Ù…Ø¶Ø§ÛŒ',0),(537556,14933,'tr','Ä°mzayÄ± silme',0),(537557,14933,'pl','UsuÅ„ podpis',0),(537558,14933,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð´Ð¿Ð¸Ñ',0),(537559,14933,'ur','Ø¯Ø³ØªØ®Ø· Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(537560,14933,'sr','Ð‘Ñ€Ð¸ÑÐ°ÑšÐµ Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°',0),(537561,14933,'vi','XÃ³a chá»¯ kÃ½',0),(537562,14933,'af','Skrap handtekening',0),(537563,14933,'ro','ÅžtergeÅ£i semnÄƒtura',0),(537564,14933,'et','Kustuta allkiri',0),(537565,14933,'si','Izbrisati podpis',0),(537566,14933,'ba','Hapus tanda tangan',0),(537567,14933,'nl','Handtekening verwijderen',0),(537568,14933,'fi','Poista allekirjoitus',0),(537569,14933,'no','Slette signaturen',0),(537570,14933,'da','Slet signatur',0),(537571,14933,'ko','ì„œëª… ì‚­ì œ',0),(537572,14933,'he','×ž×—×™×§×ª ×—×ª×™×ž×”',0),(537573,14933,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Ï„Î·Î½ Ï…Ï€Î¿Î³ÏÎ±Ï†Î®',0),(537574,14933,'zh','åˆ é™¤ç­¾å',0),(537575,14933,'sv','Ta bort signatur',0),(537576,14933,'it','Eliminare la firma',0),(537577,14933,'tl','',0),(537578,14933,'th','à¸¥à¸šà¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™',0),(537579,14933,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(537580,14933,'ms','Menghapuskan tandatangan',0),(537581,14933,'ar','Ø­Ø°Ù Ø§Ù„ØªÙˆÙ‚ÙŠØ¹',0),(537582,14933,'fr','Supprimer la Signature',0),(537583,14933,'jp','ç½²åã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(537584,14933,'pt','Excluir assinatura',0),(537585,14933,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸',0),(537586,14933,'es','Borrar firma',0),(537587,14933,'de','Signatur lÃ¶schen',0),(537588,14933,'en','Delete Signature',0),(537589,14934,'is','',0),(537590,14934,'dr','Ø§Ù…Ø¶Ø§ÛŒ',0),(537591,14934,'pr','Ø§Ù…Ø¶Ø§ÛŒ',0),(537592,14934,'tr','Ä°mza dosyasÄ±',0),(537593,14934,'pl','Plik sygnatury',0),(537594,14934,'bg','ÐŸÐ¾Ð´Ð¿Ð¸Ñ Ñ„Ð°Ð¹Ð»',0),(537595,14934,'ur','Ø¯Ø³ØªØ®Ø· Ù…Ø³Ù„',0),(537596,14934,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð¿Ð¾Ñ‚Ð¿Ð¸ÑÐ°',0),(537597,14934,'vi','Tá»‡p chá»¯ kÃ½',0),(537598,14934,'af','Handtekening lÃªer',0),(537599,14934,'ro','SemnÄƒtura fiÅŸier',0),(537600,14934,'et','Allkiri faili',0),(537601,14934,'si','Podpis datoteke',0),(537602,14934,'ba','File tanda tangan',0),(537603,14934,'nl','Handtekeningbestand',0),(537604,14934,'fi','Allekirjoitus',0),(537605,14934,'no','Signaturfilen',0),(537606,14934,'da','Signaturfil',0),(537607,14934,'ko','ì„œëª… íŒŒì¼',0),(537608,14934,'he','×§×•×‘×¥ ×”×—×ª×™×ž×”',0),(537609,14934,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ Ï…Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(537610,14934,'zh','ç­¾åæ–‡ä»¶',0),(537611,14934,'sv','Signaturfilen',0),(537612,14934,'it','File di firma',0),(537613,14934,'tl','',0),(537614,14934,'th','à¹à¸Ÿà¹‰à¸¡à¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™',0),(537615,14934,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤«à¤¾à¤‡à¤²',0),(537616,14934,'ms','Fail pengenalan',0),(537617,14934,'ar','Ù…Ù„Ù Ø§Ù„ØªÙˆÙ‚ÙŠØ¹',0),(537618,14934,'fr','Fichier de signature',0),(537619,14934,'jp','ç½²åãƒ•ã‚¡ã‚¤ãƒ«',0),(537620,14934,'pt','Arquivo de assinatura',0),(537621,14934,'ru','Ð¤Ð°Ð¹Ð» Ð¿Ð¾Ð´Ð¿Ð¸ÑÐ¸',0),(537622,14934,'es','Archivo de firma',0),(537623,14934,'de','Signaturdatei',0),(537624,14934,'en','Signature File',0),(537625,14935,'is','',0),(537626,14935,'dr','Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ Ù…ÙˆØ±Ø¯',0),(537627,14935,'pr','Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡ Ù…ÙˆØ±Ø¯',0),(537628,14935,'tr','EklenmiÅŸ Ã¶ÄŸe',0),(537629,14935,'pl','Dodany element',0),(537630,14935,'bg','Ð”Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ÑÑ‚ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(537631,14935,'ur','Ø´Û’ Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(537632,14935,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(537633,14935,'vi','ThÃªm má»¥c',0),(537634,14935,'af','Item gevoeg',0),(537635,14935,'ro','AdaugÄƒ articol',0),(537636,14935,'et','Lisatud Ã¼ksuse',0),(537637,14935,'si','Doda element',0),(537638,14935,'ba','Ditambahkan Item',0),(537639,14935,'nl','Toegevoegd Item',0),(537640,14935,'fi','LisÃ¤tyn kohteen',0),(537641,14935,'no','Ekstra vare',0),(537642,14935,'da','TilfÃ¸jet element',0),(537643,14935,'ko','ì¶”ê°€ ëœ í•­ëª©',0),(537644,14935,'he','×¤×¨×™×˜ × ×•×¡×£',0),(537645,14935,'el','Î ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(537646,14935,'zh','æ·»åŠ çš„é¡¹',0),(537647,14935,'sv','Lagt till objekt',0),(537648,14935,'it','Elemento aggiunto',0),(537649,14935,'tl','',0),(537650,14935,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(537651,14935,'hi','à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤®',0),(537652,14935,'ms','Item tambahan',0),(537653,14935,'ar','Ø£Ø¶ÙŠÙ Ø§Ù„Ø¨Ù†Ø¯',0),(537654,14935,'fr','Ã‰lÃ©ment ajoutÃ©',0),(537655,14935,'jp','è¿½åŠ ã•ã‚ŒãŸé …ç›®',0),(537656,14935,'pt','Item adicionado',0),(537657,14935,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(537658,14935,'es','ArtÃ­culo aÃ±adido',0),(537659,14935,'de','HinzugefÃ¼gtes Element',0),(537660,14935,'en','Added Item',0),(537661,14936,'is','',0),(537662,14936,'dr','Ø­Ø³Ø§Ø¨ API',0),(537663,14936,'pr','Ø­Ø³Ø§Ø¨ API',0),(537664,14936,'tr','API hesabÄ±',0),(537665,14936,'pl','API konta',0),(537666,14936,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° API',0),(537667,14936,'ur','API Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(537668,14936,'sr','ÐÐŸÐ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(537669,14936,'vi','API tÃ i khoáº£n',0),(537670,14936,'af','API rekening',0),(537671,14936,'ro','API cont',0),(537672,14936,'et','API konto',0),(537673,14936,'si','API raÄun',0),(537674,14936,'ba','API Account',0),(537675,14936,'nl','API-Account',0),(537676,14936,'fi','API tili',0),(537677,14936,'no','API-konto',0),(537678,14936,'da','API-konto',0),(537679,14936,'ko','API ê³„ì •',0),(537680,14936,'he','API ×—×©×‘×•×Ÿ',0),(537681,14936,'el','API Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(537682,14936,'zh','API å¸æˆ·',0),(537683,14936,'sv','API-konto',0),(537684,14936,'it','Conto di API',0),(537685,14936,'tl','',0),(537686,14936,'th','à¸šà¸±à¸à¸Šà¸µ API',0),(537687,14936,'hi','API à¤–à¤¾à¤¤à¥‡',0),(537688,14936,'ms','Akaun API',0),(537689,14936,'ar','Ø­Ø³Ø§Ø¨ API',0),(537690,14936,'fr','Compte de l\'API',0),(537691,14936,'jp','API ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(537692,14936,'pt','Conta de API',0),(537693,14936,'ru','API ÑÑ‡ÐµÑ‚Ð°',0),(537694,14936,'es','API cuenta',0),(537695,14936,'de','API-Konto',0),(537696,14936,'en','API Account',0),(537697,14937,'is','',0),(537698,14937,'dr','API Ú©Ø§Ø±Ø¨Ø±',0),(537699,14937,'pr','API Ú©Ø§Ø±Ø¨Ø±',0),(537700,14937,'tr','API kullanÄ±cÄ±',0),(537701,14937,'pl','API uÅ¼ytkownika',0),(537702,14937,'bg','API Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(537703,14937,'ur','API ØµØ§Ø±Ù',0),(537704,14937,'sr','ÐÐŸÐ˜ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾Ð³',0),(537705,14937,'vi','NgÆ°á»i sá»­ dá»¥ng API',0),(537706,14937,'af','API-gebruiker',0),(537707,14937,'ro','API utilizator',0),(537708,14937,'et','API kasutaja',0),(537709,14937,'si','Uporabnika API',0),(537710,14937,'ba','API pengguna',0),(537711,14937,'nl','API gebruiker',0),(537712,14937,'fi','API: n kÃ¤yttÃ¤jÃ¤',0),(537713,14937,'no','API bruker',0),(537714,14937,'da','API-bruger',0),(537715,14937,'ko','API ì‚¬ìš©ìž',0),(537716,14937,'he','API ×ž×©×ª×ž×©',0),(537717,14937,'el','API Ï‡ÏÎ®ÏƒÏ„Î·',0),(537718,14937,'zh','API ç”¨æˆ·',0),(537719,14937,'sv','API-anvÃ¤ndare',0),(537720,14937,'it','Utente API',0),(537721,14937,'tl','',0),(537722,14937,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰ API',0),(537723,14937,'hi','API à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(537724,14937,'ms','Pengguna API',0),(537725,14937,'ar','API Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(537726,14937,'fr','Utilisateur de l\'API',0),(537727,14937,'jp','API ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(537728,14937,'pt','UsuÃ¡rio API',0),(537729,14937,'ru','API-Ð¸Ð½Ñ‚ÐµÑ€Ñ„ÐµÐ¹Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(537730,14937,'es','Usuario API',0),(537731,14937,'de','API-Benutzer',0),(537732,14937,'en','API User',0),(537733,14938,'is','',0),(537734,14938,'dr','ÙˆØ§Ø±Ø¯Ø§Øª',0),(537735,14938,'pr','ÙˆØ§Ø±Ø¯Ø§Øª',0),(537736,14938,'tr','Ä°Ã§e aktarma',0),(537737,14938,'pl','Importowanie',0),(537738,14938,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(537739,14938,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(537740,14938,'sr','Ð£Ð²Ð¾Ð·',0),(537741,14938,'vi','Nháº­p kháº©u',0),(537742,14938,'af','Invoer',0),(537743,14938,'ro','Importul',0),(537744,14938,'et','Importimine',0),(537745,14938,'si','Uvoz',0),(537746,14938,'ba','Mengimpor',0),(537747,14938,'nl','Importeren',0),(537748,14938,'fi','Tuominen',0),(537749,14938,'no','Importere',0),(537750,14938,'da','Importere',0),(537751,14938,'ko','ê°€ì ¸ì˜¤ê¸°',0),(537752,14938,'he','×™×™×‘×•×',0),(537753,14938,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®',0),(537754,14938,'zh','å¯¼å…¥',0),(537755,14938,'sv','Importera',0),(537756,14938,'it','Importazione',0),(537757,14938,'tl','',0),(537758,14938,'th','à¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(537759,14938,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(537760,14938,'ms','Mengimport',0),(537761,14938,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(537762,14938,'fr','Importation',0),(537763,14938,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(537764,14938,'pt','Importando',0),(537765,14938,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(537766,14938,'es','ImportaciÃ³n',0),(537767,14938,'de','Importieren',0),(537768,14938,'en','Importing',0),(537769,14939,'is','',0),(537770,14939,'dr','Magento ØªØµÙˆÛŒØ± ÙØ±ÙˆØ´Ú¯Ø§Ù‡',0),(537771,14939,'pr','Magento ØªØµÙˆÛŒØ± ÙØ±ÙˆØ´Ú¯Ø§Ù‡',0),(537772,14939,'tr','Magento Resim KataloÄŸu',0),(537773,14939,'pl','Katalog obrazu Magento',0),(537774,14939,'bg','Magento Image ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³',0),(537775,14939,'ur','Ù…Ø§Ú¯Ø§Ù†Ù¹Ùˆ Ù†Ù‚Ø´ Ø³Øª',0),(537776,14939,'sr','ÐœÐ°Ð³ÐµÐ½Ñ‚Ð¾ Ð˜Ð¼Ð°Ð³Ðµ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³',0),(537777,14939,'vi','Magento hÃ¬nh áº£nh cá»­a hÃ ng',0),(537778,14939,'af','Magento beeld katalogus',0),(537779,14939,'ro','Magento imagine Catalog',0),(537780,14939,'et','Magento Image Kataloog',0),(537781,14939,'si','Magento podobe katalog',0),(537782,14939,'ba','Katalog gambar Magento',0),(537783,14939,'nl','Magento afbeeldingscatalogus',0),(537784,14939,'fi','Magento kuva Verkkokauppa',0),(537785,14939,'no','Magento bildekatalog',0),(537786,14939,'da','Magento billede katalog',0),(537787,14939,'ko','Magento ì´ë¯¸ì§€ ì¹´íƒˆë¡œê·¸',0),(537788,14939,'he','×§×˜×œ×•×’ ×ª×ž×•× ×•×ª ×ž×’\'× ×˜×•',0),(537789,14939,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ¹ÎºÏŒÎ½Î±Ï‚ Magento',0),(537790,14939,'zh','Magento å›¾åƒç›®å½•',0),(537791,14939,'sv','Magento bildkatalog',0),(537792,14939,'it','Catalogo immagine di Magento',0),(537793,14939,'tl','',0),(537794,14939,'th','à¹à¸„à¹‡à¸•à¸•à¸²à¸¥à¹‡à¸­à¸à¸ à¸²à¸žà¸§à¸µà¹‚à¸­à¹„à¸­à¸žà¸µ',0),(537795,14939,'hi','Magento à¤›à¤µà¤¿ à¤•à¥ˆà¤Ÿà¤²à¥‰à¤—',0),(537796,14939,'ms','Imej Magento Katalog',0),(537797,14939,'ar','ÙƒØªØ§Ù„ÙˆØ¬ ØµÙˆØ± Ø§Ù„Ù…Ø§Ø¬Ù†ØªÙˆ',0),(537798,14939,'fr','Catalogue d\'images de Magento',0),(537799,14939,'jp','Magento ã‚¤ãƒ¡ãƒ¼ã‚¸ ã‚«ã‚¿ãƒ­ã‚°',0),(537800,14939,'pt','CatÃ¡logo de imagens de Magento',0),(537801,14939,'ru','ÐšÐ°Ñ‚Ð°Ð»Ð¾Ð³ Magento Ð¾Ð±Ñ€Ð°Ð·Ð¾Ð²',0),(537802,14939,'es','CatÃ¡logo Magento imagen',0),(537803,14939,'de','Magento Imagebibliothek',0),(537804,14939,'en','Magento Image Catalog',0),(537805,14940,'is','',0),(537806,14940,'dr','Magento Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(537807,14940,'pr','Magento Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(537808,14940,'tr','Magento stok',0),(537809,14940,'pl','Magazynu Magento',0),(537810,14940,'bg','Magento Ð·Ð°Ð¿Ð°ÑÐ¸',0),(537811,14940,'ur','Ù…Ø§Ú¯Ø§Ù†Ù¹Ùˆ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(537812,14940,'sr','ÐœÐ°Ð³ÐµÐ½Ñ‚Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(537813,14940,'vi','Magento hÃ ng tá»“n kho',0),(537814,14940,'af','Magento voorraad',0),(537815,14940,'ro','Magento inventar',0),(537816,14940,'et','Magento varude',0),(537817,14940,'si','Magento zaloge',0),(537818,14940,'ba','Magento persediaan',0),(537819,14940,'nl','Magento inventaris',0),(537820,14940,'fi','Magento varaston',0),(537821,14940,'no','Magento lager',0),(537822,14940,'da','Magento lager',0),(537823,14940,'ko','Magento ìž¬ê³ ',0),(537824,14940,'he','×ž×œ××™ ×ž×’\'× ×˜×•',0),(537825,14940,'el','Magento Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(537826,14940,'zh','Magento åº“å­˜',0),(537827,14940,'sv','Magento inventering',0),(537828,14940,'it','Inventario di Magento',0),(537829,14940,'tl','',0),(537830,14940,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸‚à¸­à¸‡à¸§à¸µà¹‚à¸­à¹„à¸­à¸žà¸µ',0),(537831,14940,'hi','Magento à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€',0),(537832,14940,'ms','Inventori Magento',0),(537833,14940,'ar','Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„Ù…Ø§Ø¬Ù†ØªÙˆ',0),(537834,14940,'fr','Inventaire de Magento',0),(537835,14940,'jp','Magento ã®åœ¨åº«',0),(537836,14940,'pt','InventÃ¡rio de Magento',0),(537837,14940,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Magento',0),(537838,14940,'es','Inventario de Magento',0),(537839,14940,'de','Magento-Inventar',0),(537840,14940,'en','Magento Inventory',0),(537841,14941,'is','',0),(537842,14941,'dr','Magento ÙØ±ÙˆØ´Ú¯Ø§Ù‡',0),(537843,14941,'pr','Magento ÙØ±ÙˆØ´Ú¯Ø§Ù‡',0),(537844,14941,'tr','Magento maÄŸaza',0),(537845,14941,'pl','Magento sklepu',0),(537846,14941,'bg','Magento Ñ…Ñ€Ð°Ð½Ð¸Ð»Ð¸Ñ‰Ðµ',0),(537847,14941,'ur','Ù…Ø§Ú¯Ø§Ù†Ù¹Ùˆ Ø³Ù¹ÙˆØ±',0),(537848,14941,'sr','ÐœÐ°Ð³ÐµÐ½Ñ‚Ð¾ Ðµ',0),(537849,14941,'vi','Magento cá»­a hÃ ng',0),(537850,14941,'af','Magento Winkel',0),(537851,14941,'ro','Magento magazin',0),(537852,14941,'et','Magento pood',0),(537853,14941,'si','Magento trgovini',0),(537854,14941,'ba','Toko Magento',0),(537855,14941,'nl','Magento winkel',0),(537856,14941,'fi','Magento tallentaa',0),(537857,14941,'no','Magento butikk',0),(537858,14941,'da','Magento butik',0),(537859,14941,'ko','Magento ì €ìž¥ì†Œ',0),(537860,14941,'he','×—× ×•×ª ×ž×’\'× ×˜×•',0),(537861,14941,'el','Magento ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î±',0),(537862,14941,'zh','Magento å•†åº—',0),(537863,14941,'sv','Magento butik',0),(537864,14941,'it','Negozio Magento',0),(537865,14941,'tl','',0),(537866,14941,'th','à¸£à¹‰à¸²à¸™à¸§à¸µà¹‚à¸­à¹„à¸­à¸žà¸µ',0),(537867,14941,'hi','Magento à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨',0),(537868,14941,'ms','Kedai Magento',0),(537869,14941,'ar','Ù…Ø®Ø²Ù† Ø§Ù„Ù…Ø§Ø¬Ù†ØªÙˆ',0),(537870,14941,'fr','Boutique Magento',0),(537871,14941,'jp','Magento ã®ã‚¹ãƒˆã‚¢',0),(537872,14941,'pt','Loja Magento',0),(537873,14941,'ru','Magento Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½',0),(537874,14941,'es','Tienda Magento',0),(537875,14941,'de','Magento-Shop',0),(537876,14941,'en','Magento Store',0),(537877,14942,'is','',0),(537878,14942,'dr','Ø§Ø±Ø³Ø§Ù„ ØªØµÙˆÛŒØ±',0),(537879,14942,'pr','Ø§Ø±Ø³Ø§Ù„ ØªØµÙˆÛŒØ±',0),(537880,14942,'tr','Resim gÃ¶nderme',0),(537881,14942,'pl','WysyÅ‚anie obrazu',0),(537882,14942,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(537883,14942,'ur','ØªØµÙˆÛŒØ± Ø¨Ú¾ÛŒØ¬ Ø±ÛØ§ ÛÛ’ Û”',0),(537884,14942,'sr','Ð¡Ð»Ð°ÑšÐµ ÑÐ»Ð¸ÐºÐ°',0),(537885,14942,'vi','Gá»­i hÃ¬nh áº£nh',0),(537886,14942,'af','Stuur tans beeld',0),(537887,14942,'ro','Trimiterea imaginii',0),(537888,14942,'et','Pildi saatmine',0),(537889,14942,'si','PoÅ¡iljanje slike',0),(537890,14942,'ba','Mengirim gambar',0),(537891,14942,'nl','Verzenden afbeelding',0),(537892,14942,'fi','Kuvien',0),(537893,14942,'no','Sende bildet',0),(537894,14942,'da','At sende billedet',0),(537895,14942,'ko','ì´ë¯¸ì§€ ë³´ë‚´ê¸°',0),(537896,14942,'he','×©×œ×™×—×ª ×ª×ž×•× ×”',0),(537897,14942,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÎ¹ÎºÏŒÎ½Î±Ï‚',0),(537898,14942,'zh','å‘é€å›¾åƒ',0),(537899,14942,'sv','Skicka bild',0),(537900,14942,'it','Invio immagine',0),(537901,14942,'tl','',0),(537902,14942,'th','à¸ªà¹ˆà¸‡à¸£à¸¹à¸›',0),(537903,14942,'hi','à¤šà¤¿à¤¤à¥à¤° à¤­à¤¿à¤œà¤µà¤¾à¤¨à¤¾',0),(537904,14942,'ms','Menghantar imej',0),(537905,14942,'ar','Ø¥Ø±Ø³Ø§Ù„ ØµÙˆØ±Ø©',0),(537906,14942,'fr','Envoi d\'Image',0),(537907,14942,'jp','ã‚¤ãƒ¡ãƒ¼ã‚¸ã®é€ä¿¡',0),(537908,14942,'pt','Enviar imagem',0),(537909,14942,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²ÐºÐ° Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(537910,14942,'es','EnvÃ­o de imÃ¡genes',0),(537911,14942,'de','Bild senden',0),(537912,14942,'en','Sending Image',0),(537913,14943,'is','',0),(537914,14943,'dr','Ø¢Ø¯Ø±Ø³ Ù¾Ø§ÛŒÙ‡ Ø³Ø§ÛŒØª',0),(537915,14943,'pr','Ø¢Ø¯Ø±Ø³ Ù¾Ø§ÛŒÙ‡ Ø³Ø§ÛŒØª',0),(537916,14943,'tr','Site ana URL\'si',0),(537917,14943,'pl','Podstawowy adres Url witryny',0),(537918,14943,'bg','Ð‘Ð°Ð·Ð° URL Ð°Ð´Ñ€ÐµÑ Ð½Ð° ÑÐ°Ð¹Ñ‚',0),(537919,14943,'ur','Ø³Ø§Ø¦Ù¹ Ø¨ÛŒØ³ Url',0),(537920,14943,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð¸ Ð£Ñ€Ð» Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(537921,14943,'vi','Url cÆ¡ sá»Ÿ trang web',0),(537922,14943,'af','Werf basis Url',0),(537923,14943,'ro','Site-ul URL-ul de bazÄƒ',0),(537924,14943,'et','Saidi baas-Url',0),(537925,14943,'si','Osnovni naslov mesta',0),(537926,14943,'ba','Url situs dasar',0),(537927,14943,'nl','Base Url van de site',0),(537928,14943,'fi','Sivuston perus-Url',0),(537929,14943,'no','Base webadressen',0),(537930,14943,'da','Site Base Url',0),(537931,14943,'ko','ì‚¬ì´íŠ¸ ê¸°ë³¸ Url',0),(537932,14943,'he','×›×ª×•×‘×ª Url ×‘×¡×™×¡×™×ª ×©×œ ×”××ª×¨',0),(537933,14943,'el','Î™ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î± Ï„Î·Ï‚ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·Ï‚ Url Î²Î¬ÏƒÎ·Ï‚',0),(537934,14943,'zh','åŸºåœ°ç½‘å€',0),(537935,14943,'sv','Bas-Url fÃ¶r webbplatsen',0),(537936,14943,'it','Url di Base sito',0),(537937,14943,'tl','',0),(537938,14943,'th','Url à¸«à¸¥à¸±à¸à¸‚à¸­à¸‡à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ',0),(537939,14943,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤†à¤§à¤¾à¤° Url',0),(537940,14943,'ms','Url Laman web asas',0),(537941,14943,'ar','Ù‚Ø§Ø¹Ø¯Ø© Ù…Ø­Ø¯Ø¯ Ù…ÙˆÙ‚Ø¹ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(537942,14943,'fr','Url de site de Base',0),(537943,14943,'jp','ã‚µã‚¤ãƒˆã®ãƒ™ãƒ¼ã‚¹ Url',0),(537944,14943,'pt','Url Base do site',0),(537945,14943,'ru','Ð‘Ð°Ð·Ð¾Ð²Ñ‹Ð¹ URL-Ð°Ð´Ñ€ÐµÑ ÑÐ°Ð¹Ñ‚Ð°',0),(537946,14943,'es','Sitio Url Base',0),(537947,14943,'de','Website-Basis-Url',0),(537948,14943,'en','Site Base Url',0),(537949,14944,'is','',0),(537950,14944,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù‡Ù…Ú¯Ø§Ù… Ø³Ø§Ø²ÛŒ',0),(537951,14944,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù‡Ù…Ú¯Ø§Ù… Ø³Ø§Ø²ÛŒ',0),(537952,14944,'tr','EÅŸitleme stok',0),(537953,14944,'pl','Synchronizacja zapasÃ³w',0),(537954,14944,'bg','Ð¡Ð¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ð¿Ð¸Ñ',0),(537955,14944,'ur','ÛÙ… ÙˆÙ‚Øª Ø³Ø§Ø²ÛŒ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(537956,14944,'sr','Ð¡Ð¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(537957,14944,'vi','Äá»“ng bá»™ hÃ ng tá»“n kho',0),(537958,14944,'af','Sinchro voorraad',0),(537959,14944,'ro','Inventarul de sincronizare',0),(537960,14944,'et','SÃ¼nkroniseerimine nimekirja',0),(537961,14944,'si','Sinhronizacijo zaloge',0),(537962,14944,'ba','Sinkronisasi persediaan',0),(537963,14944,'nl','Sync inventaris',0),(537964,14944,'fi','Synkronoi luettelo',0),(537965,14944,'no','Sync lager',0),(537966,14944,'da','Sync lager',0),(537967,14944,'ko','ë™ê¸°í™” ëª©ë¡',0),(537968,14944,'he','×¡×™× ×›×¨×•×Ÿ ×ž×œ××™',0),(537969,14944,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® ÏƒÏ…Î³Ï‡ÏÎ¿Î½Î¹ÏƒÎ¼Î¿Ï',0),(537970,14944,'zh','åŒæ­¥åº“å­˜',0),(537971,14944,'sv','Sync inventering',0),(537972,14944,'it','Inventario di sincronizzazione',0),(537973,14944,'tl','',0),(537974,14944,'th','à¸‹à¸´à¸‡à¸„à¹Œà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(537975,14944,'hi','à¤¸à¤¿à¤‚à¤•à¥à¤°à¤¨à¤¾à¤‡à¤œà¤¼à¥‡à¤¶à¤¨ à¤¸à¥‚à¤šà¥€',0),(537976,14944,'ms','Inventori segerak',0),(537977,14944,'ar','Ù…Ø²Ø§Ù…Ù†Ø© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(537978,14944,'fr','Inventaire Sync',0),(537979,14944,'jp','åŒæœŸã®åœ¨åº«',0),(537980,14944,'pt','InventÃ¡rio de sincronizaÃ§Ã£o',0),(537981,14944,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ ÑÐ¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(537982,14944,'es','Inventario de sincronizaciÃ³n',0),(537983,14944,'de','Sync-Inventar',0),(537984,14944,'en','Sync Inventory',0),(537985,14945,'is','',0),(537986,14945,'dr','Ø¹Ú©Ø³ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù‡Ù…Ú¯Ø§Ù… Ø³Ø§Ø²ÛŒ',0),(537987,14945,'pr','Ø¹Ú©Ø³ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ù‡Ù…Ú¯Ø§Ù… Ø³Ø§Ø²ÛŒ',0),(537988,14945,'tr','EÅŸitleme stok gÃ¶rÃ¼ntÃ¼leri',0),(537989,14945,'pl','Synchronizacja spis obrazÃ³w',0),(537990,14945,'bg','Ð¡Ð¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ð¿Ð¸Ñ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(537991,14945,'ur','ÛÙ… ÙˆÙ‚Øª Ø³Ø§Ø²ÛŒ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©ÛŒ ØªØµØ§ÙˆÛŒØ±',0),(537992,14945,'sr','Ð¡Ð¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ð° Ð·Ð°Ð»Ð¸Ñ…Ð° ÑÐ»Ð¸ÐºÐµ',0),(537993,14945,'vi','Äá»“ng bá»™ hÃ ng tá»“n kho hÃ¬nh áº£nh',0),(537994,14945,'af','Sinchro voorraad beelde',0),(537995,14945,'ro','Imagini de inventar sincronizare',0),(537996,14945,'et','SÃ¼nkroonimise varude pildid',0),(537997,14945,'si','Sinhronizacijo zaloge slike',0),(537998,14945,'ba','Sinkronisasi persediaan gambar',0),(537999,14945,'nl','Sync voorraad beelden',0),(538000,14945,'fi','Sync varaston kuvia',0),(538001,14945,'no','Sync lager bilder',0),(538002,14945,'da','Sync lager billeder',0),(538003,14945,'ko','ë™ê¸°í™” ìž¬ê³  ì´ë¯¸ì§€',0),(538004,14945,'he','×¡×™× ×›×¨×•×Ÿ ×ž×œ××™ ×ª×ž×•× ×•×ª',0),(538005,14945,'el','Î£Ï…Î³Ï‡ÏÎ¿Î½Î¹ÏƒÎ¼Î¿Ï Î±Ï€Î¿Î³ÏÎ±Ï†Î® ÎµÎ¹ÎºÏŒÎ½ÎµÏ‚',0),(538006,14945,'zh','åŒæ­¥åº“å­˜å›¾åƒ',0),(538007,14945,'sv','Sync inventering bilder',0),(538008,14945,'it','Immagini di inventario di sincronizzazione',0),(538009,14945,'tl','',0),(538010,14945,'th','à¸‹à¸´à¸‡à¸„à¹Œà¸„à¸‡à¸£à¸¹à¸›',0),(538011,14945,'hi','à¤¸à¤¿à¤‚à¤•à¥à¤°à¤¨à¤¾à¤‡à¤œà¤¼à¥‡à¤¶à¤¨ à¤¸à¥‚à¤šà¥€ à¤›à¤µà¤¿à¤¯à¤¾à¤',0),(538012,14945,'ms','Imej-imej inventori segerak',0),(538013,14945,'ar','Ù…Ø²Ø§Ù…Ù†Ø© Ù…Ø®Ø²ÙˆÙ† Ø§Ù„ØµÙˆØ±',0),(538014,14945,'fr','Images de l\'inventaire de synchronisation',0),(538015,14945,'jp','åŒæœŸåœ¨åº«ç”»åƒ',0),(538016,14945,'pt','Imagens de inventÃ¡rio de sincronizaÃ§Ã£o',0),(538017,14945,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ Sync',0),(538018,14945,'es','ImÃ¡genes de inventario de sincronizaciÃ³n',0),(538019,14945,'de','Sync-Inventar-Bilder',0),(538020,14945,'en','Sync Inventory Images',0),(538021,14946,'is','',0),(538022,14946,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù‡',0),(538023,14946,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù‡',0),(538024,14946,'tr','GÃ¼ncelleme',0),(538025,14946,'pl','Aktualizacja',0),(538026,14946,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½',0),(538027,14946,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(538028,14946,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(538029,14946,'vi','Cáº­p Nháº­t',0),(538030,14946,'af','Opgedateer',0),(538031,14946,'ro','Actualizat',0),(538032,14946,'et','Uuendatud',0),(538033,14946,'si','Posodobljen',0),(538034,14946,'ba','Diperbarui',0),(538035,14946,'nl','Bijgewerkt',0),(538036,14946,'fi','PÃ¤ivitetty',0),(538037,14946,'no','Oppdatert',0),(538038,14946,'da','Opdateret',0),(538039,14946,'ko','ì—…ë°ì´íŠ¸',0),(538040,14946,'he','×¢×•×“×›×Ÿ',0),(538041,14946,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(538042,14946,'zh','æ›´æ–°',0),(538043,14946,'sv','Uppdaterad',0),(538044,14946,'it','Aggiornato',0),(538045,14946,'tl','',0),(538046,14946,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(538047,14946,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾',0),(538048,14946,'ms','Dikemaskini',0),(538049,14946,'ar','ØªØ­Ø¯ÙŠØ«',0),(538050,14946,'fr','Mis Ã  jour',0),(538051,14946,'jp','æ›´æ–°',0),(538052,14946,'pt','Atualizado',0),(538053,14946,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(538054,14946,'es','Actualizado',0),(538055,14946,'de','Aktualisiert',0),(538056,14946,'en','Updated',0),(538057,14947,'is','',0),(538058,14947,'dr','Ø¨Ù‡ Ù‡Ù†Ú¯Ø§Ù… Ø´Ø¯Ù‡ Ø¯Ø± Ù…ÙˆØ±Ø¯',0),(538059,14947,'pr','Ø¨Ù‡ Ù‡Ù†Ú¯Ø§Ù… Ø´Ø¯Ù‡ Ø¯Ø± Ù…ÙˆØ±Ø¯',0),(538060,14947,'tr','GÃ¼ncelleÅŸtirilen Ã¶ÄŸeyi',0),(538061,14947,'pl','Aktualizacja pozycji',0),(538062,14947,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸Ñ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(538063,14947,'ur','ØªØ§Ø²Û ØªØ±ÛŒÙ† Ø´Û’',0),(538064,14947,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(538065,14947,'vi','Cáº­p Nháº­t khoáº£n má»¥c',0),(538066,14947,'af','Bygewerkte Item',0),(538067,14947,'ro','Articol actualizat',0),(538068,14947,'et','VÃ¤rskendatud Ã¼ksust',0),(538069,14947,'si','Posodobljenega elementa',0),(538070,14947,'ba','Diperbarui Item',0),(538071,14947,'nl','Bijgewerkte Item',0),(538072,14947,'fi','PÃ¤ivitettyÃ¤ kohdetta',0),(538073,14947,'no','Oppdaterte elementet',0),(538074,14947,'da','Opdateret vare',0),(538075,14947,'ko','ì—…ë°ì´íŠ¸ ëœ í•­ëª©',0),(538076,14947,'he','×¤×¨×™×˜ ×ž×¢×•×“×›×Ÿ',0),(538077,14947,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(538078,14947,'zh','æ›´æ–°çš„é¡¹ç›®',0),(538079,14947,'sv','Uppdaterade objektet',0),(538080,14947,'it','Elemento aggiornato',0),(538081,14947,'tl','',0),(538082,14947,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(538083,14947,'hi','à¤…à¤ªà¤¡à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤®',0),(538084,14947,'ms','Item dikemaskini',0),(538085,14947,'ar','Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„Ù…Ø­Ø¯Ø«',0),(538086,14947,'fr','Ã‰lÃ©ment mis Ã  jour',0),(538087,14947,'jp','æ›´æ–°ã•ã‚ŒãŸé …ç›®',0),(538088,14947,'pt','Item atualizado',0),(538089,14947,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(538090,14947,'es','ArtÃ­culo actualizado',0),(538091,14947,'de','Aktualisierte Element',0),(538092,14947,'en','Updated Item',0),(538093,14948,'is','',0),(538094,14948,'dr','Desription',0),(538095,14948,'pr','Desription',0),(538096,14948,'tr','Desription',0),(538097,14948,'pl','Opisie',0),(538098,14948,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½ Ð½Ð°Ñ‡Ð¸Ð½ÑŠÑ‚',0),(538099,14948,'ur','Ø¯Ø§Ø³Ø±Ø§Ù¾Ø´Ù†',0),(538100,14948,'sr','Ð”ÐµÑÑ€Ð¸Ð¿Ñ‚Ð¸Ð¾Ð½',0),(538101,14948,'vi','Desription',0),(538102,14948,'af','Desription',0),(538103,14948,'ro','Desription',0),(538104,14948,'et','Desription',0),(538105,14948,'si','Desription',0),(538106,14948,'ba','Desription',0),(538107,14948,'nl','Desription',0),(538108,14948,'fi','Desription',0),(538109,14948,'no','Beskrivelse',0),(538110,14948,'da','Desription',0),(538111,14948,'ko','ì„¼ì„œ',0),(538112,14948,'he','Desription',0),(538113,14948,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(538114,14948,'zh','å¡å£³',0),(538115,14948,'sv','Beskrivning',0),(538116,14948,'it','Desription',0),(538117,14948,'tl','',0),(538118,14948,'th','Desription',0),(538119,14948,'hi','Desription',0),(538120,14948,'ms','Desription',0),(538121,14948,'ar','Ø¯ÙŠØ³Ø±ÙŠØ¨Ø´Ù†',0),(538122,14948,'fr','Desription',0),(538123,14948,'jp','èªžç¾©',0),(538124,14948,'pt','Desription',0),(538125,14948,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸ÑŽ',0),(538126,14948,'es','Desription',0),(538127,14948,'de','Beschreibung',0),(538128,14948,'en','Desription',0),(538129,14949,'is','',0),(538130,14949,'dr','Ù„ÛŒÙ†Ú© Ø¨Ù‡ AP ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§',0),(538131,14949,'pr','Ù„ÛŒÙ†Ú© Ø¨Ù‡ AP ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§',0),(538132,14949,'tr','AP rehber baÄŸlantÄ±',0),(538133,14949,'pl','Link do AP kontakty',0),(538134,14949,'bg','Ð’Ñ€ÑŠÐ·ÐºÐ° ÐºÑŠÐ¼ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ñ‚Ðµ AP',0),(538135,14949,'ur','AP Ø±ÙˆØ§Ø¨Ø· Ø³Û’ Ø±Ø¨Ø·',0),(538136,14949,'sr','ÐŸÐ¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐµ ÑÐ° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ð¼Ð° ÐÐŸ',0),(538137,14949,'vi','CÃ¡c liÃªn káº¿t vÃ o AP liÃªn há»‡',0),(538138,14949,'af','Skakel na GP kontakte',0),(538139,14949,'ro','Link la AP contacte',0),(538140,14949,'et','AP Kontaktide linkimine',0),(538141,14949,'si','Povezava do stikov AP',0),(538142,14949,'ba','Link ke AP kontak',0),(538143,14949,'nl','Link naar AP contacten',0),(538144,14949,'fi','Linkki yhteystietoihin AP',0),(538145,14949,'no','Link til AP kontakter',0),(538146,14949,'da','Link til AP kontakter',0),(538147,14949,'ko','AP ì—°ë½ì²˜ ë§í¬',0),(538148,14949,'he','×§×™×©×•×¨ ×œ×× ×©×™ AP',0),(538149,14949,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Î¼Îµ Ï„Î¿ AP ÎµÏ€Î±Ï†Î­Ï‚',0),(538150,14949,'zh','é“¾æŽ¥åˆ° AP è”ç³»äºº',0),(538151,14949,'sv','LÃ¤nk till AP kontakter',0),(538152,14949,'it','Link ai contatti di AP',0),(538153,14949,'tl','',0),(538154,14949,'th','à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡à¸à¸±à¸šà¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­ AP',0),(538155,14949,'hi','à¤à¤ªà¥€ à¤¸à¤‚à¤ªà¤°à¥à¤•à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¿à¤‚à¤•',0),(538156,14949,'ms','Pautan ke AP kenalan',0),(538157,14949,'ar','Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø· Ù„Ù„Ø§ØªØµØ§Ù„Ø§Øª ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(538158,14949,'fr','Lien vers les Contacts de l\'AP',0),(538159,14949,'jp','AP ã®é€£çµ¡å…ˆã¸ã®ãƒªãƒ³ã‚¯',0),(538160,14949,'pt','Link para contatos de AP',0),(538161,14949,'ru','Ð¡ÑÑ‹Ð»ÐºÐ° Ð½Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñ‹ AP',0),(538162,14949,'es','Enlace a AP contactos',0),(538163,14949,'de','Link zu AP-Kontakte',0),(538164,14949,'en','Link To AP Contacts',0),(538165,14950,'is','',0),(538166,14950,'dr','Ù„ÛŒÙ†Ú© Ø¨Ù‡ Ø¹Ù„ÛŒØ±Ø¶Ø§ ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§',0),(538167,14950,'pr','Ù„ÛŒÙ†Ú© Ø¨Ù‡ Ø¹Ù„ÛŒØ±Ø¶Ø§ ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§',0),(538168,14950,'tr','AR rehber baÄŸlantÄ±',0),(538169,14950,'pl','Link do kontaktÃ³w AR',0),(538170,14950,'bg','Ð’Ñ€ÑŠÐ·ÐºÐ° ÐºÑŠÐ¼ AR ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(538171,14950,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø±ÙˆØ§Ø¨Ø· Ø³Û’ Ø±Ø¨Ø·',0),(538172,14950,'sr','ÐŸÐ¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐµ ÑÐ° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ð¼Ð° ÐÐ ',0),(538173,14950,'vi','LiÃªn káº¿t Ä‘áº¿n Ä‘á»‹a chá»‰ liÃªn láº¡c AR',0),(538174,14950,'af','Skakel na AR kontakte',0),(538175,14950,'ro','Link la AR contacte',0),(538176,14950,'et','AR Kontaktide linkimine',0),(538177,14950,'si','Povezava do stikov AR',0),(538178,14950,'ba','Link ke AR kontak',0),(538179,14950,'nl','Link naar AR contacten',0),(538180,14950,'fi','Linkki yhteystietoihin AR',0),(538181,14950,'no','Link til AR kontakter',0),(538182,14950,'da','Link til AR kontakter',0),(538183,14950,'ko','ì•„ì¹¸ì†Œ ì—°ë½ì²˜ ë§í¬',0),(538184,14950,'he','×§×™×©×•×¨ ×œ×× ×©×™ AR',0),(538185,14950,'el','Î£ÏÎ½Î´ÎµÏƒÎ· ÏƒÏ„Î¹Ï‚ ÎµÏ€Î±Ï†Î­Ï‚ Ï„Î¿Ï… AR',0),(538186,14950,'zh','é“¾æŽ¥åˆ° AR è”ç³»äºº',0),(538187,14950,'sv','LÃ¤nk till AR kontakter',0),(538188,14950,'it','Link ai contatti di AR',0),(538189,14950,'tl','',0),(538190,14950,'th','à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡à¸à¸±à¸šà¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­ AR',0),(538191,14950,'hi','AR à¤¸à¤‚à¤ªà¤°à¥à¤•à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¿à¤‚à¤•',0),(538192,14950,'ms','Pautan ke kenalan AR',0),(538193,14950,'ar','Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø· Ø¨Ø¬Ù‡Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„ Ø¹',0),(538194,14950,'fr','Lien vers les Contacts de l\'AR',0),(538195,14950,'jp','AR ã®é€£çµ¡å…ˆã¸ã®ãƒªãƒ³ã‚¯',0),(538196,14950,'pt','Link para contatos de AR',0),(538197,14950,'ru','Ð¡ÑÑ‹Ð»ÐºÐ° Ð½Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñ‹ AR',0),(538198,14950,'es','Enlace a AR contactos',0),(538199,14950,'de','Link zu AR-Kontakte',0),(538200,14950,'en','Link To AR Contacts',0),(538201,14951,'is','',0),(538202,14951,'dr','ÙˆØ¸ÛŒÙÙ‡',0),(538203,14951,'pr','ÙˆØ¸ÛŒÙÙ‡',0),(538204,14951,'tr','GÃ¶rev',0),(538205,14951,'pl','Zadanie',0),(538206,14951,'bg','Ð—Ð°Ð´Ð°Ñ‡Ð°Ñ‚Ð°',0),(538207,14951,'ur','Ú©Ø§Ù…',0),(538208,14951,'sr','Ð—Ð°Ð´Ð°Ñ‚Ð°Ðº',0),(538209,14951,'vi','Nhiá»‡m vá»¥',0),(538210,14951,'af','Taak',0),(538211,14951,'ro','Sarcina',0),(538212,14951,'et','Ãœlesanne',0),(538213,14951,'si','Opravilo',0),(538214,14951,'ba','Tugas',0),(538215,14951,'nl','Taak',0),(538216,14951,'fi','TehtÃ¤vÃ¤n',0),(538217,14951,'no','Oppgave',0),(538218,14951,'da','Opgave',0),(538219,14951,'ko','ìž‘ì—…',0),(538220,14951,'he','×¤×¢×™×œ×•×ª',0),(538221,14951,'el','Î•ÏÎ³Î±ÏƒÎ¯Î±',0),(538222,14951,'zh','ä»»åŠ¡',0),(538223,14951,'sv','Uppgift',0),(538224,14951,'it','Compito',0),(538225,14951,'tl','',0),(538226,14951,'th','à¸‡à¸²à¸™',0),(538227,14951,'hi','à¤•à¤¾à¤°à¥à¤¯',0),(538228,14951,'ms','Tugas',0),(538229,14951,'ar','Ø§Ù„Ù…Ù‡Ù…Ø©',0),(538230,14951,'fr','TÃ¢che',0),(538231,14951,'jp','ã‚¿ã‚¹ã‚¯',0),(538232,14951,'pt','Tarefa',0),(538233,14951,'ru','Ð—Ð°Ð´Ð°Ñ‡Ð°',0),(538234,14951,'es','Tarea',0),(538235,14951,'de','Aufgabe',0),(538236,14951,'en','Task',0),(538237,14952,'is','',0),(538238,14952,'dr','ÙˆØ¸Ø§ÛŒÙ',0),(538239,14952,'pr','ÙˆØ¸Ø§ÛŒÙ',0),(538240,14952,'tr','GÃ¶revleri',0),(538241,14952,'pl','Zadania',0),(538242,14952,'bg','Ð—Ð°Ð´Ð°Ñ‡Ð¸',0),(538243,14952,'ur','Ù…Ø¬Ù…ÙˆØ¹Û Ú©Ø§Ø±',0),(538244,14952,'sr','Ð—Ð°Ð´Ð°Ñ†Ð¸',0),(538245,14952,'vi','Nhiá»‡m vá»¥',0),(538246,14952,'af','Take',0),(538247,14952,'ro','Sarcini',0),(538248,14952,'et','Ãœlesanded',0),(538249,14952,'si','Naloge',0),(538250,14952,'ba','Tugas',0),(538251,14952,'nl','Taken',0),(538252,14952,'fi','TehtÃ¤vÃ¤t',0),(538253,14952,'no','Oppgaver',0),(538254,14952,'da','Opgaver',0),(538255,14952,'ko','ìž‘ì—…',0),(538256,14952,'he','×ž×©×™×ž×•×ª',0),(538257,14952,'el','Î•ÏÎ³Î±ÏƒÎ¯ÎµÏ‚',0),(538258,14952,'zh','ä»»åŠ¡',0),(538259,14952,'sv','Uppgifter',0),(538260,14952,'it','Compiti',0),(538261,14952,'tl','',0),(538262,14952,'th','à¸‡à¸²à¸™',0),(538263,14952,'hi','à¤•à¤¾à¤°à¥à¤¯',0),(538264,14952,'ms','Tugas-tugas',0),(538265,14952,'ar','Ø§Ù„Ù…Ù‡Ø§Ù…',0),(538266,14952,'fr','TÃ¢ches',0),(538267,14952,'jp','ã‚¿ã‚¹ã‚¯',0),(538268,14952,'pt','Tarefas',0),(538269,14952,'ru','Ð—Ð°Ð´Ð°Ñ‡Ð¸',0),(538270,14952,'es','Tareas',0),(538271,14952,'de','Aufgaben',0),(538272,14952,'en','Tasks',0),(538273,14953,'is','',0),(538274,14953,'dr','ÙˆØ¸ÛŒÙÙ‡ Ø§Ù‚Ø¯Ø§Ù…',0),(538275,14953,'pr','ÙˆØ¸ÛŒÙÙ‡ Ø§Ù‚Ø¯Ø§Ù…',0),(538276,14953,'tr','GÃ¶rev eylemi',0),(538277,14953,'pl','Zadaniem akcji',0),(538278,14953,'bg','Ð—Ð°Ð´Ð°Ñ‡Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(538279,14953,'ur','Ø¹Ù…Ù„ Ú©Ø§Ù…',0),(538280,14953,'sr','ÐÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ð´Ð°Ñ‚ÐºÐ°',0),(538281,14953,'vi','Nhiá»‡m vá»¥ hÃ nh Ä‘á»™ng',0),(538282,14953,'af','Taak aksie',0),(538283,14953,'ro','Sarcina de acÅ£iune',0),(538284,14953,'et','Toiming tegevus',0),(538285,14953,'si','Dejanja',0),(538286,14953,'ba','Tugas aksi',0),(538287,14953,'nl','Taakactie',0),(538288,14953,'fi','TehtÃ¤vÃ¤n suorittaminen',0),(538289,14953,'no','Oppgavehandling',0),(538290,14953,'da','Opgavehandling',0),(538291,14953,'ko','ìž‘ì—… ë™ìž‘',0),(538292,14953,'he','×¤×¢×™×œ×•×ª ×¤×¢×•×œ×”',0),(538293,14953,'el','Î•Î½Î­ÏÎ³ÎµÎ¹Î±Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(538294,14953,'zh','ä»»åŠ¡æ“ä½œ',0),(538295,14953,'sv','UppgiftsÃ¥tgÃ¤rden',0),(538296,14953,'it','Azione di attivitÃ ',0),(538297,14953,'tl','',0),(538298,14953,'th','à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸‡à¸²à¸™',0),(538299,14953,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾',0),(538300,14953,'ms','Tindakan tugas',0),(538301,14953,'ar','Ø¹Ù…Ù„ Ø§Ù„Ù…Ù‡Ù…Ø©',0),(538302,14953,'fr','Action de tÃ¢che',0),(538303,14953,'jp','ã‚¿ã‚¹ã‚¯ ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(538304,14953,'pt','AÃ§Ã£o de tarefa',0),(538305,14953,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð·Ð°Ð´Ð°Ñ‡',0),(538306,14953,'es','AcciÃ³n de tarea',0),(538307,14953,'de','Aktion starten',0),(538308,14953,'en','Task Action',0),(538309,14954,'is','',0),(538310,14954,'dr','Ø§Ù‚Ø¯Ø§Ù…Ø§Øª ÙˆØ¸ÛŒÙÙ‡',0),(538311,14954,'pr','Ø§Ù‚Ø¯Ø§Ù…Ø§Øª ÙˆØ¸ÛŒÙÙ‡',0),(538312,14954,'tr','GÃ¶rev eylemleri',0),(538313,14954,'pl','Wykonywania zadaÅ„',0),(538314,14954,'bg','Ð—Ð°Ð´Ð°Ñ‡Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(538315,14954,'ur','Ú©Ø§Ù… Ú©Û’ Ø§Ø¹Ù…Ø§Ù„',0),(538316,14954,'sr','Ð—Ð°Ð´Ð°Ñ‚Ð°Ðº Ñ€Ð°Ð´ÑšÐµ',0),(538317,14954,'vi','Nhiá»‡m vá»¥ hÃ nh Ä‘á»™ng',0),(538318,14954,'af','Taak aksies',0),(538319,14954,'ro','AcÅ£iuni de sarcina',0),(538320,14954,'et','Ãœlesande tegevused',0),(538321,14954,'si','Opravil dejanja',0),(538322,14954,'ba','Tugas tindakan',0),(538323,14954,'nl','Taakacties',0),(538324,14954,'fi','TehtÃ¤vien toimintojen',0),(538325,14954,'no','Oppgavehandlinger',0),(538326,14954,'da','UdfÃ¸relse af opgaver',0),(538327,14954,'ko','ìž‘ì—… ë™ìž‘',0),(538328,14954,'he','×¤×¢×•×œ×•×ª ×”×ž×©×™×ž×”',0),(538329,14954,'el','ÎˆÏÎ³Î¿ Î´ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(538330,14954,'zh','ä»»åŠ¡æ“ä½œ',0),(538331,14954,'sv','AktivitetsÃ¥tgÃ¤rder',0),(538332,14954,'it','Azioni attivitÃ ',0),(538333,14954,'tl','',0),(538334,14954,'th','à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸‡à¸²à¸™',0),(538335,14954,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾à¤à¤',0),(538336,14954,'ms','Tindakan-tindakan tugas',0),(538337,14954,'ar','Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ù…Ù‡Ù…Ø©',0),(538338,14954,'fr','Actions de tÃ¢che',0),(538339,14954,'jp','ã‚¿ã‚¹ã‚¯ ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(538340,14954,'pt','AÃ§Ãµes de tarefa',0),(538341,14954,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(538342,14954,'es','Acciones de la tarea',0),(538343,14954,'de','Aufgabenaktionen',0),(538344,14954,'en','Task Actions',0),(538345,14955,'is','',0),(538346,14955,'dr','ÙˆØ¶Ø¹ÛŒØª ÙˆØ¸ÛŒÙÙ‡',0),(538347,14955,'pr','ÙˆØ¶Ø¹ÛŒØª ÙˆØ¸ÛŒÙÙ‡',0),(538348,14955,'tr','GÃ¶rev durumu',0),(538349,14955,'pl','Stan zadania',0),(538350,14955,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð·Ð°Ð´Ð°Ñ‡Ð°Ñ‚Ð°',0),(538351,14955,'ur','Ø­Ø§Ù„Øª Ú©Ø§Ù…',0),(538352,14955,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð´Ð°Ñ‚ÐºÐ°',0),(538353,14955,'vi','Tráº¡ng thÃ¡i nhiá»‡m vá»¥',0),(538354,14955,'af','Taak Status',0),(538355,14955,'ro','Starea de sarcina',0),(538356,14955,'et','TÃ¶Ã¶Ã¼lesande olek',0),(538357,14955,'si','Stanje opravila',0),(538358,14955,'ba','Tugas Status',0),(538359,14955,'nl','Taakstatus',0),(538360,14955,'fi','TehtÃ¤vÃ¤n tila',0),(538361,14955,'no','Aktivitetsstatus',0),(538362,14955,'da','Opgavestatus',0),(538363,14955,'ko','ìž‘ì—… ìƒíƒœ',0),(538364,14955,'he','×ž×¦×‘ ×¤×¢×™×œ×•×ª',0),(538365,14955,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¹ÏŽÎ½',0),(538366,14955,'zh','ä»»åŠ¡çŠ¶æ€',0),(538367,14955,'sv','Aktivitetsstatus',0),(538368,14955,'it','Stato attivitÃ ',0),(538369,14955,'tl','',0),(538370,14955,'th','à¸ªà¸–à¸²à¸™à¸°à¸‚à¸­à¸‡à¸‡à¸²à¸™',0),(538371,14955,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(538372,14955,'ms','Tugas Status',0),(538373,14955,'ar','Ø­Ø§Ù„Ø© Ø§Ù„Ù…Ù‡Ù…Ø©',0),(538374,14955,'fr','Ã‰tat de la tÃ¢che',0),(538375,14955,'jp','ã‚¿ã‚¹ã‚¯ã®é€²æ—çŠ¶æ³',0),(538376,14955,'pt','Status da tarefa',0),(538377,14955,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð·Ð°Ð´Ð°Ñ‡Ð¸',0),(538378,14955,'es','Estado de la tarea',0),(538379,14955,'de','Vorgangsstatus',0),(538380,14955,'en','Task Status',0),(538381,14956,'is','',0),(538382,14956,'dr','ÙˆØ¶Ø¹ÛŒØª ÙˆØ¸ÛŒÙÙ‡',0),(538383,14956,'pr','ÙˆØ¶Ø¹ÛŒØª ÙˆØ¸ÛŒÙÙ‡',0),(538384,14956,'tr','GÃ¶rev durumlarÄ±',0),(538385,14956,'pl','Statusy zadaÅ„',0),(538386,14956,'bg','Ð—Ð°Ð´Ð°Ñ‡Ð° ÑÑ‚Ð°Ñ‚ÑƒÑÐ¸',0),(538387,14956,'ur','Ú©Ø§Ù… Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(538388,14956,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑÐ° Ð·Ð°Ð´Ð°Ñ‚ÐºÐ°',0),(538389,14956,'vi','Tráº¡ng thÃ¡i nhiá»‡m vá»¥',0),(538390,14956,'af','Taak statusse',0),(538391,14956,'ro','StÄƒrile de sarcina',0),(538392,14956,'et','TÃ¶Ã¶Ã¼lesande olek',0),(538393,14956,'si','Statusov opravil',0),(538394,14956,'ba','Tugas status',0),(538395,14956,'nl','Taak statussen',0),(538396,14956,'fi','TehtÃ¤vÃ¤n tila',0),(538397,14956,'no','Oppgave statuser',0),(538398,14956,'da','Opgave statusser',0),(538399,14956,'ko','ìž‘ì—… ìƒíƒœ',0),(538400,14956,'he','×¤×¢×™×œ×•×ª ×¡×˜×˜×•×¡×™×',0),(538401,14956,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÎºÎ±Ï„Î±ÏƒÏ„Î¬ÏƒÎµÎ¹Ï‚',0),(538402,14956,'zh','ä»»åŠ¡çŠ¶æ€',0),(538403,14956,'sv','Uppgift status',0),(538404,14956,'it','Stati di attivitÃ ',0),(538405,14956,'tl','',0),(538406,14956,'th','à¸ªà¸–à¸²à¸™à¸°à¸‡à¸²à¸™',0),(538407,14956,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¸à¥à¤¥à¤¿à¤¤à¤¿à¤¯à¤¾à¤',0),(538408,14956,'ms','Tugas status',0),(538409,14956,'ar','Ø§Ù„Ø­Ø§Ù„Ø§Øª Ø§Ù„Ù…Ù‡Ù…Ø©',0),(538410,14956,'fr','Statuts de la tÃ¢che',0),(538411,14956,'jp','ã‚¿ã‚¹ã‚¯ã®çŠ¶æ…‹',0),(538412,14956,'pt','Status da tarefa',0),(538413,14956,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑÑ‹ Ð·Ð°Ð´Ð°Ñ‡',0),(538414,14956,'es','Estados de tarea',0),(538415,14956,'de','Task-Status',0),(538416,14956,'en','Task Statuses',0),(538417,14957,'is','',0),(538418,14957,'dr','Ø§ØªØµØ§Ù„',0),(538419,14957,'pr','Ø§ØªØµØ§Ù„',0),(538420,14957,'tr','BaÄŸlanma',0),(538421,14957,'pl','ÅÄ…czenie',0),(538422,14957,'bg','Ð¡Ð²ÑŠÑ€Ð·Ð²Ð°Ð½Ðµ',0),(538423,14957,'ur','Ø¬Ú‘ Ø±ÛØ§ ÛÛ’',0),(538424,14957,'sr','ÐŸÐ¾Ð²ÐµÐ·Ð¸Ð²Ð°ÑšÐµ',0),(538425,14957,'vi','Káº¿t ná»‘i',0),(538426,14957,'af','Koppel tans',0),(538427,14957,'ro','Conectarea',0),(538428,14957,'et','Ãœhenduse loomine',0),(538429,14957,'si','Povezovanje',0),(538430,14957,'ba','Menghubungkan',0),(538431,14957,'nl','Verbinding maken',0),(538432,14957,'fi','LiittÃ¤minen',0),(538433,14957,'no','Koble',0),(538434,14957,'da','Tilslutning',0),(538435,14957,'ko','ì—°ê²°',0),(538436,14957,'he','×”×ª×—×‘×¨×•×ª',0),(538437,14957,'el','Î¤Î· ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(538438,14957,'zh','è¿žæŽ¥',0),(538439,14957,'sv','Ansluta',0),(538440,14957,'it','Collegamento',0),(538441,14957,'tl','',0),(538442,14957,'th','à¸à¸²à¸£à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­',0),(538443,14957,'hi','à¤•à¤¨à¥‡à¤•à¥à¤Ÿ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(538444,14957,'ms','Menyambung',0),(538445,14957,'ar','Ø§Ù„Ø§ØªØµØ§Ù„',0),(538446,14957,'fr','Connexion',0),(538447,14957,'jp','æŽ¥ç¶šã—ã¾ã™ã€‚',0),(538448,14957,'pt','Conectando-se',0),(538449,14957,'ru','ÐŸÐ¾Ð´ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ',0),(538450,14957,'es','ConexiÃ³n',0),(538451,14957,'de','Herstellen einer Verbindung',0),(538452,14957,'en','Connecting',0),(538453,14958,'is','',0),(538454,14958,'dr','ØµØ§Ø¯Ø±Ø§Øª',0),(538455,14958,'pr','ØµØ§Ø¯Ø±Ø§Øª',0),(538456,14958,'tr','DÄ±ÅŸa aktarma',0),(538457,14958,'pl','Eksportowanie',0),(538458,14958,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(538459,14958,'ur','Ø¨Ø±Ø¢Ù…Ø¯',0),(538460,14958,'sr','Ð˜Ð·Ð²Ð¾Ð·',0),(538461,14958,'vi','Xuáº¥t kháº©u',0),(538462,14958,'af','Uitvoer',0),(538463,14958,'ro','Exportatori',0),(538464,14958,'et','Eksportimine',0),(538465,14958,'si','IzvaÅ¾anje',0),(538466,14958,'ba','Mengekspor',0),(538467,14958,'nl','Exporteren',0),(538468,14958,'fi','Vieminen',0),(538469,14958,'no','Eksportere',0),(538470,14958,'da','Eksportere',0),(538471,14958,'ko','ë‚´ë³´ë‚´ê¸°',0),(538472,14958,'he','×™×™×¦×•×',0),(538473,14958,'el','Î•Î¾Î±Î³Ï‰Î³Î®',0),(538474,14958,'zh','å‡ºå£',0),(538475,14958,'sv','Exportera',0),(538476,14958,'it','Esportazione',0),(538477,14958,'tl','',0),(538478,14958,'th','à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(538479,14958,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¤¾',0),(538480,14958,'ms','Mengeksport',0),(538481,14958,'ar','Ø§Ù„Ù…ØµØ¯Ø±Ø©',0),(538482,14958,'fr','Exportation',0),(538483,14958,'jp','ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ',0),(538484,14958,'pt','Exportando',0),(538485,14958,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(538486,14958,'es','ExportaciÃ³n',0),(538487,14958,'de','Exportieren',0),(538488,14958,'en','Exporting',0),(538489,14959,'is','',0),(538490,14959,'dr','Ù„ÛŒØ³Øª Ø¯Ø±ÛŒØ§ÙØª Ù…Ø­ØµÙˆÙ„',0),(538491,14959,'pr','Ù„ÛŒØ³Øª Ø¯Ø±ÛŒØ§ÙØª Ù…Ø­ØµÙˆÙ„',0),(538492,14959,'tr','AlÄ±nan Ã¼rÃ¼n listesi',0),(538493,14959,'pl','Lista produktÃ³w otrzymanych',0),(538494,14959,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ñ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸',0),(538495,14959,'ur','Ù…ÙˆØµÙˆÙ„Û Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ ÙÛØ±Ø³Øª',0),(538496,14959,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð¸Ñ… Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(538497,14959,'vi','Nháº­n Ä‘Æ°á»£c sáº£n pháº©m danh sÃ¡ch',0),(538498,14959,'af','Ontvang produk lys',0),(538499,14959,'ro','Lista de produse primite',0),(538500,14959,'et','VastuvÃµetud Tootenimekiri',0),(538501,14959,'si','Seznam prejetih izdelkov',0),(538502,14959,'ba','Daftar produk diterima',0),(538503,14959,'nl','Ontvangen productlijst',0),(538504,14959,'fi','Vastaanotettujen tuotteiden luettelo',0),(538505,14959,'no','Mottatte produktliste',0),(538506,14959,'da','Modtagne produktliste',0),(538507,14959,'ko','ë°›ì€ ì œí’ˆ ëª©ë¡',0),(538508,14959,'he','×¨×©×™×ž×ª ×”×ž×•×¦×¨×™× ×©×”×ª×§×‘×œ×•',0),(538509,14959,'el','Î ÏÎ¿ÏŠÏŒÎ½ Ï€Î¿Ï… Ï€Î±ÏÎ±Î»Î®Ï†Î¸Î·ÎºÎµ Î»Î¯ÏƒÏ„Î±',0),(538510,14959,'zh','å·²æŽ¥æ”¶çš„äº§å“åˆ—è¡¨',0),(538511,14959,'sv','Mottagen produktlista',0),(538512,14959,'it','Elenco prodotti ricevuti',0),(538513,14959,'tl','',0),(538514,14959,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸š',0),(538515,14959,'hi','à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤¸à¥‚à¤šà¥€',0),(538516,14959,'ms','Senarai produk yang diterima',0),(538517,14959,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…Ù†ØªØ¬Ø§Øª Ø§Ù„Ù…Ø³ØªÙ„Ù…Ø©',0),(538518,14959,'fr','Liste de produit reÃ§u',0),(538519,14959,'jp','å—ã‘å–ã£ãŸå•†å“ä¸€è¦§',0),(538520,14959,'pt','Lista de produto recebido',0),(538521,14959,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ… Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð²',0),(538522,14959,'es','Lista de productos recibidos',0),(538523,14959,'de','Empfangene Produktliste',0),(538524,14959,'en','Received Product List',0),(538525,14960,'is','',0),(538526,14960,'dr','Dmgd',0),(538527,14960,'pr','Dmgd',0),(538528,14960,'tr','Dmgd',0),(538529,14960,'pl','Dmgd',0),(538530,14960,'bg','Dmgd',0),(538531,14960,'ur','Ø¯Ù…Ú¯Ø¯',0),(538532,14960,'sr','Ð”Ð¼Ð³Ð´',0),(538533,14960,'vi','Dmgd',0),(538534,14960,'af','Dmgd',0),(538535,14960,'ro','Dmgd',0),(538536,14960,'et','Dmgd',0),(538537,14960,'si','Dmgd',0),(538538,14960,'ba','Dmgd',0),(538539,14960,'nl','Dmgd',0),(538540,14960,'fi','Dmgd',0),(538541,14960,'no','Dmgd',0),(538542,14960,'da','Dmgd',0),(538543,14960,'ko','Dmgd',0),(538544,14960,'he','Dmgd',0),(538545,14960,'el','Dmgd',0),(538546,14960,'zh','Dmgd',0),(538547,14960,'sv','Dmgd',0),(538548,14960,'it','Dmgd',0),(538549,14960,'tl','',0),(538550,14960,'th','Dmgd',0),(538551,14960,'hi','Dmgd',0),(538552,14960,'ms','Dmgd',0),(538553,14960,'ar','Ø¯Ù…Ø¬Ø¯',0),(538554,14960,'fr','Dmgd',0),(538555,14960,'jp','Dmgd',0),(538556,14960,'pt','Dmgd',0),(538557,14960,'ru','Dmgd',0),(538558,14960,'es','Dmgd',0),(538559,14960,'de','Dmgd',0),(538560,14960,'en','Dmgd',0),(538561,14961,'is','',0),(538562,14961,'dr','Recvd',0),(538563,14961,'pr','Recvd',0),(538564,14961,'tr','Recvd',0),(538565,14961,'pl','Odebranych pakietÃ³w',0),(538566,14961,'bg','ÐŸÑ€Ð¸ÐµÑ‚Ð¾ Ð¿Ð¾Ð²',0),(538567,14961,'ur','Ø±ÛŒÚ©ÙˆØ¯',0),(538568,14961,'sr','Ð¡Ð¿Ð°ÑÐµÐ½ ÑÐ¿Ð°ÑÐ°Ð²Ð°Ñ‚Ð¸ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(538569,14961,'vi','Recvd',0),(538570,14961,'af','Recvd',0),(538571,14961,'ro','Apel',0),(538572,14961,'et','KÃµnest keeldumine Lk21',0),(538573,14961,'si','Strani21',0),(538574,14961,'ba','Recvd',0),(538575,14961,'nl','Recvd',0),(538576,14961,'fi','Recvd',0),(538577,14961,'no','Recvd',0),(538578,14961,'da','Indg',0),(538579,14961,'ko','Recvd',0),(538580,14961,'he','×©×”×ª×§×‘×œ',0),(538581,14961,'el','Î›Î®ÏˆÎµÎ¹Ï‚ Î±Ï€Î¿ÎºÏÎ¯ÏƒÎµÏ‰Î½',0),(538582,14961,'zh','Recvd',0),(538583,14961,'sv','Mottagna',0),(538584,14961,'it','Recvd',0),(538585,14961,'tl','',0),(538586,14961,'th','Recvd',0),(538587,14961,'hi','Recvd',0),(538588,14961,'ms','Recvd',0),(538589,14961,'ar','Ø§Ù„Ù…ØªÙ„Ù‚ÙŠ',0),(538590,14961,'fr','Recvd',0),(538591,14961,'jp','Recvd',0),(538592,14961,'pt','LibertaÃ§Ãµes',0),(538593,14961,'ru','Recvd',0),(538594,14961,'es','Llam',0),(538595,14961,'de','Empfangene',0),(538596,14961,'en','Recvd',0),(538597,14962,'is','',0),(538598,14962,'dr','Rtrnd',0),(538599,14962,'pr','Rtrnd',0),(538600,14962,'tr','Rtrnd',0),(538601,14962,'pl','Rtrnd',0),(538602,14962,'bg','Rtrnd',0),(538603,14962,'ur','Ø±Ù¹Ø±Ù†Úˆ',0),(538604,14962,'sr','Ð Ñ‚Ñ€Ð½Ð´',0),(538605,14962,'vi','Rtrnd',0),(538606,14962,'af','Rtrnd',0),(538607,14962,'ro','Rtrnd',0),(538608,14962,'et','Rtrnd',0),(538609,14962,'si','Rtrnd',0),(538610,14962,'ba','Rtrnd',0),(538611,14962,'nl','Rtrnd',0),(538612,14962,'fi','Rtrnd',0),(538613,14962,'no','Rtrnd',0),(538614,14962,'da','Rtrnd',0),(538615,14962,'ko','Rtrnd',0),(538616,14962,'he','Rtrnd',0),(538617,14962,'el','Rtrnd',0),(538618,14962,'zh','Rtrnd',0),(538619,14962,'sv','Rtrnd',0),(538620,14962,'it','Rtrnd',0),(538621,14962,'tl','',0),(538622,14962,'th','Rtrnd',0),(538623,14962,'hi','Rtrnd',0),(538624,14962,'ms','Rtrnd',0),(538625,14962,'ar','Ø±ØªØ±Ù†Ø¯',0),(538626,14962,'fr','S\'',0),(538627,14962,'jp','Rtrnd',0),(538628,14962,'pt','Rtrnd',0),(538629,14962,'ru','Rtrnd',0),(538630,14962,'es','Rtrnd',0),(538631,14962,'de','Rtrnd',0),(538632,14962,'en','Rtrnd',0),(538633,14963,'is','',0),(538634,14963,'dr','Ù†Ù…Ø§ÛŒØ´/Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØµÙ†Ø¯ÙˆÙ‚',0),(538635,14963,'pr','Ù†Ù…Ø§ÛŒØ´/Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØµÙ†Ø¯ÙˆÙ‚',0),(538636,14963,'tr','PO bilgi gÃ¶ster/gizle',0),(538637,14963,'pl','PokaÅ¼/Ukryj PO Info',0),(538638,14963,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸/Ð¡ÐºÑ€Ð¸Ð¹ PO Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(538639,14963,'ur','Ù¾Ùˆ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù†Ù…Ø§ÛŒØ´/Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(538640,14963,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ /Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÐŸÐž Ð˜Ð½Ñ„Ð¾',0),(538641,14963,'vi','Hiá»ƒn thá»‹/áº©n thÃ´ng tin PO',0),(538642,14963,'af','Wys/versteek Posbus Info',0),(538643,14963,'ro','AfiÅŸare/ascundere informaÅ£ii PO',0),(538644,14963,'et','Kuva/peida PO Info',0),(538645,14963,'si','PokaÅ¾i/Skrij PO Info',0),(538646,14963,'ba','Tampilkan/Sembunyikan PO Info',0),(538647,14963,'nl','Toon/Verberg PO Info',0),(538648,14963,'fi','NÃ¤ytÃ¤ tai Piilota PO Info',0),(538649,14963,'no','Vis/Skjul PO Info',0),(538650,14963,'da','Skjul PO Info',0),(538651,14963,'ko','í¬ ì •ë³´ í‘œì‹œ/ìˆ¨ê¸°ê¸°',0),(538652,14963,'he','×”×¦×’×”/×”×¡×ª×¨×” ×©×œ ×ž×™×“×¢ ×¤×•',0),(538653,14963,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·/Î±Ï€ÏŒÎºÏÏ…ÏˆÎ· PO Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(538654,14963,'zh','æ˜¾ç¤º/éšè—å®ä¿¡æ¯',0),(538655,14963,'sv','Visa/DÃ¶lj PO information',0),(538656,14963,'it','Mostra/Nascondi Info PO',0),(538657,14963,'tl','',0),(538658,14963,'th','à¹à¸ªà¸”à¸‡/à¸‹à¹ˆà¸­à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥ PO',0),(538659,14963,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤/PO à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤›à¥à¤ªà¤¾à¤à¤',0),(538660,14963,'ms','Tayang/Sembunyi Maklumat PO',0),(538661,14963,'ar','Ø¥Ø¸Ù‡Ø§Ø±/Ø¥Ø®ÙØ§Ø¡ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨Ùˆ',0),(538662,14963,'fr','Afficher/masquer les infos PO',0),(538663,14963,'jp','PO æƒ…å ±ã®è¡¨ç¤º/éžè¡¨ç¤º',0),(538664,14963,'pt','Mostrar/esconder informaÃ§Ã£o de PO',0),(538665,14963,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ/ÑÐºÑ€Ñ‹Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ PO',0),(538666,14963,'es','Mostrar/ocultar informaciÃ³n PO',0),(538667,14963,'de','Ausblenden Sie einblenden/PO-Info',0),(538668,14963,'en','Show/Hide PO Info',0),(538669,14964,'is','',0),(538670,14964,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø¯ÛŒÚ¯Ø± Ø§Ú¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª 0',0),(538671,14964,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø¯ÛŒÚ¯Ø± Ø§Ú¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª 0',0),(538672,14964,'tr','SeÃ§tiyseniz kullanÄ±m diÄŸer maliyet 0 dÄ±r',0),(538673,14964,'pl','Stosowanie innych kosztÃ³w, jeÅ›li wybrany jest 0',0),(538674,14964,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð´Ñ€ÑƒÐ³Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸, Ð°ÐºÐ¾ Ðµ 0',0),(538675,14964,'ur','Ø§Ú¯Ø± Ù…Ù†ØªØ®Ø¨ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ø¯ÛŒÚ¯Ø± Ù‚ÛŒÙ…Øª 0 ÛÛ’',0),(538676,14964,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð´Ñ€ÑƒÐ³Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð°ÐºÐ¾ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð° Ñ˜Ðµ 0',0),(538677,14964,'vi','Sá»­ dá»¥ng khÃ¡c chi phÃ­ náº¿u Ä‘Æ°á»£c chá»n lÃ  0',0),(538678,14964,'af','Gebruik ander koste indien gekies Is 0',0),(538679,14964,'ro','Utilizarea altor Cost dacÄƒ selectat este 0',0),(538680,14964,'et','Kasutamise muud kulu kui valitud on 0',0),(538681,14964,'si','Uporabo drugih stroÅ¡kov, Äe je 0',0),(538682,14964,'ba','Penggunaan lain biaya jika dipilih adalah 0',0),(538683,14964,'nl','Gebruik andere kosten als geselecteerd Is 0',0),(538684,14964,'fi','Muut kustannukset, jos valittuna on 0',0),(538685,14964,'no','Bruk andre kostnader hvis valgt er 0',0),(538686,14964,'da','Brug andre omkostninger Hvis valgt er 0',0),(538687,14964,'ko','ì‚¬ìš© í•˜ ì—¬ ë‹¤ë¥¸ ë¹„ìš© ì„ íƒì€ 0',0),(538688,14964,'he','××—×¨×™× ×¢×œ×•×ª ×©×™×ž×•×© ×× × ×‘×—×¨ ×”×•× 0',0),(538689,14964,'el','Î§ÏÎ®ÏƒÎ· Î¬Î»Î»Ï‰Î½ ÎºÏŒÏƒÏ„Î¿Ï‚ Î±Î½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯ ÎµÎ¯Î½Î±Î¹ 0',0),(538690,14964,'zh','ä½¿ç”¨å…¶ä»–æˆæœ¬å¦‚æžœé€‰å®šä¸º 0',0),(538691,14964,'sv','AnvÃ¤nda andra kostnaden om valt Ã¤r 0',0),(538692,14964,'it','Uso altri costi se selezionato sono 0',0),(538693,14964,'tl','',0),(538694,14964,'th','à¹ƒà¸Šà¹‰à¸­à¸·à¹ˆà¸™ à¹† à¸•à¹‰à¸™à¸—à¸¸à¸™à¸–à¹‰à¸²à¹€à¸¥à¸·à¸­à¸à¹€à¸›à¹‡à¸™ 0',0),(538695,14964,'hi','à¤¯à¤¦à¤¿ à¤šà¤¯à¤¨à¤¿à¤¤ à¤‰à¤ªà¤¯à¥‹à¤— à¤…à¤¨à¥à¤¯ à¤²à¤¾à¤—à¤¤ 0 à¤¹à¥ˆ',0),(538696,14964,'ms','Penggunaan lain-lain kos jika dipilih adalah 0',0),(538697,14964,'ar','ÙŠØªÙ… Ø§Ø³ØªØ®Ø¯Ø§Ù… ØºÙŠØ±Ù‡Ø§ Ø§Ù„ØªÙƒÙ„ÙØ© ÙÙŠ Ø­Ø§Ù„Ø© ØªØ­Ø¯ÙŠØ¯ 0',0),(538698,14964,'fr','Autre coÃ»t d\'utilisation si sÃ©lectionnÃ© est 0',0),(538699,14964,'jp','ä½¿ç”¨ã‚³ã‚¹ãƒˆä»–ã®é¸æŠžã•ã‚Œã¦ã„ã‚‹å ´åˆã¯ 0',0),(538700,14964,'pt','Uso outros custos se selecionado Ã© 0',0),(538701,14964,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð´Ñ€ÑƒÐ³Ð¸Ñ… ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐµÑÐ»Ð¸ Ð²Ñ‹Ð±Ñ€Ð°Ð½-0',0),(538702,14964,'es','Utilizar otro coste si selecciona es 0',0),(538703,14964,'de','Andere Kosten Einsatz Wenn ausgewÃ¤hlt ist 0',0),(538704,14964,'en','Use Other Cost If Selected Is 0',0),(538705,14965,'is','',0),(538706,14965,'dr','ØªØµÙˆÛŒØ± Ø§ØµÙ„ÛŒ',0),(538707,14965,'pr','ØªØµÙˆÛŒØ± Ø§ØµÙ„ÛŒ',0),(538708,14965,'tr','Temel gÃ¶rÃ¼ntÃ¼',0),(538709,14965,'pl','Obraz podstawowy',0),(538710,14965,'bg','Ð‘Ð°Ð·Ð° Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(538711,14965,'ur','Ø¨ÛŒØ³ Ù†Ù‚Ø´',0),(538712,14965,'sr','ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ñ˜ ÑÐ»Ð¸Ñ†Ð¸',0),(538713,14965,'vi','áº¢nh cÆ¡ sá»Ÿ',0),(538714,14965,'af','Basis beeld',0),(538715,14965,'ro','BazÄƒ imagine',0),(538716,14965,'et','Baasi pilt',0),(538717,14965,'si','Osnovni Image',0),(538718,14965,'ba','Gambar dasar',0),(538719,14965,'nl','Basisimage',0),(538720,14965,'fi','Perustaa kuvan',0),(538721,14965,'no','Standardavbildningen',0),(538722,14965,'da','Basisafbildningen',0),(538723,14965,'ko','ê¸°ë³¸ ì´ë¯¸ì§€',0),(538724,14965,'he','×ª×ž×•× ×ª ×”×‘×¡×™×¡',0),(538725,14965,'el','Î’Î¬ÏƒÎ· ÎµÎ¹ÎºÏŒÎ½Î±Ï‚',0),(538726,14965,'zh','åŸºæœ¬æ˜ åƒ',0),(538727,14965,'sv','Bas-Image',0),(538728,14965,'it','Immagine di base',0),(538729,14965,'tl','',0),(538730,14965,'th','à¸£à¸¹à¸›à¸žà¸·à¹‰à¸™à¸à¸²à¸™',0),(538731,14965,'hi','à¤†à¤§à¤¾à¤° à¤›à¤µà¤¿',0),(538732,14965,'ms','Imej asas',0),(538733,14965,'ar','Ø§Ù„ØµÙˆØ±Ø© Ø§Ù„Ø£Ø³Ø§Ø³ÙŠØ©',0),(538734,14965,'fr','Image de base',0),(538735,14965,'jp','åŸºæœ¬ã‚¤ãƒ¡ãƒ¼ã‚¸',0),(538736,14965,'pt','Imagem base',0),(538737,14965,'ru','ÐžÑÐ½Ð¾Ð²Ð½Ð¾Ð¹ Ð¾Ð±Ñ€Ð°Ð·',0),(538738,14965,'es','Imagen base',0),(538739,14965,'de','Basis-Image',0),(538740,14965,'en','Base Image',0),(538741,14966,'is','',0),(538742,14966,'dr','Ø±Ø¯',0),(538743,14966,'pr','Ø±Ø¯',0),(538744,14966,'tr','HariÃ§ tut',0),(538745,14966,'pl','Wyklucz',0),(538746,14966,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð¸',0),(538747,14966,'ur','Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(538748,14966,'sr','Ð˜ÑÐºÑ™ÑƒÑ‡Ð¸',0),(538749,14966,'vi','Loáº¡i trá»«',0),(538750,14966,'af','Uitsluit',0),(538751,14966,'ro','Exclude',0),(538752,14966,'et','VÃ¤listada',0),(538753,14966,'si','IzkljuÄi',0),(538754,14966,'ba','Mengecualikan',0),(538755,14966,'nl','Uitsluiten',0),(538756,14966,'fi','Sulkea pois',0),(538757,14966,'no','Ekskluder',0),(538758,14966,'da','Udelukke',0),(538759,14966,'ko','ì œì™¸',0),(538760,14966,'he','××™-×›×œ×™×œ×”',0),(538761,14966,'el','Î•Î¾Î±Î¯ÏÎµÏƒÎ·',0),(538762,14966,'zh','æŽ’é™¤',0),(538763,14966,'sv','Utesluta',0),(538764,14966,'it','Escludere',0),(538765,14966,'tl','',0),(538766,14966,'th','à¹„à¸¡à¹ˆà¸£à¸§à¸¡',0),(538767,14966,'hi','à¤¬à¤¾à¤¹à¤° à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚',0),(538768,14966,'ms','Tidak termasuk',0),(538769,14966,'ar','Ø§Ø³ØªØ¨Ø¹Ø§Ø¯',0),(538770,14966,'fr','Exclure',0),(538771,14966,'jp','é™¤å¤–ã—ã¾ã™ã€‚',0),(538772,14966,'pt','Excluir',0),(538773,14966,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ',0),(538774,14966,'es','Excluir',0),(538775,14966,'de','AusschlieÃŸen',0),(538776,14966,'en','Exclude',0),(538777,14967,'is','',0),(538778,14967,'dr','Ø¨Ø±Ú†Ø³Ø¨',0),(538779,14967,'pr','Ø¨Ø±Ú†Ø³Ø¨',0),(538780,14967,'tr','Etiket',0),(538781,14967,'pl','Etykieta',0),(538782,14967,'bg','Ð•Ñ‚Ð¸ÐºÐµÑ‚',0),(538783,14967,'ur','Ù„ÛŒØ¨Ù„',0),(538784,14967,'sr','ÐžÐ·Ð½Ð°ÐºÐ°',0),(538785,14967,'vi','NhÃ£n',0),(538786,14967,'af','Etiket',0),(538787,14967,'ro','Eticheta',0),(538788,14967,'et','Silt',0),(538789,14967,'si','Oznaka',0),(538790,14967,'ba','Label',0),(538791,14967,'nl','Label',0),(538792,14967,'fi','Etiketti',0),(538793,14967,'no','Etikett',0),(538794,14967,'da','Etiket',0),(538795,14967,'ko','ë ˆì´ë¸”',0),(538796,14967,'he','×ª×•×•×™×ª',0),(538797,14967,'el','Î•Ï„Î¹ÎºÎ­Ï„Î±',0),(538798,14967,'zh','æ ‡ç­¾',0),(538799,14967,'sv','Etikett',0),(538800,14967,'it','Etichetta',0),(538801,14967,'tl','',0),(538802,14967,'th','à¸›à¹‰à¸²à¸¢à¸Šà¸·à¹ˆà¸­',0),(538803,14967,'hi','à¤²à¥‡à¤¬à¤²',0),(538804,14967,'ms','Label',0),(538805,14967,'ar','Ø§Ù„ØªØ³Ù…ÙŠØ©',0),(538806,14967,'fr','Ã‰tiquette',0),(538807,14967,'jp','ãƒ©ãƒ™ãƒ«',0),(538808,14967,'pt','RÃ³tulo',0),(538809,14967,'ru','Ð›ÐµÐ¹Ð±Ð»',0),(538810,14967,'es','Etiqueta',0),(538811,14967,'de','Etikett',0),(538812,14967,'en','Label',0),(538813,14968,'is','',0),(538814,14968,'dr','Magento Ú©Ø§ØªØ§Ù„ÙˆÚ¯ ØªØµØ§ÙˆÛŒØ±',0),(538815,14968,'pr','Magento Ú©Ø§ØªØ§Ù„ÙˆÚ¯ ØªØµØ§ÙˆÛŒØ±',0),(538816,14968,'tr','Magento katalog resimleri',0),(538817,14968,'pl','Magento Katalog zdjÄ™Ä‡',0),(538818,14968,'bg','Magento ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(538819,14968,'ur','Ù…Ø§Ú¯Ø§Ù†Ù¹Ùˆ Ø³Øª ØªØµØ§ÙˆÛŒØ±',0),(538820,14968,'sr','ÐœÐ°Ð³ÐµÐ½Ñ‚Ð¾ ÐºÐ°Ñ‚Ð°Ð»Ð¾Ð³ ÑÐ»Ð¸ÐºÐµ',0),(538821,14968,'vi','Magento danh má»¥c hÃ¬nh áº£nh',0),(538822,14968,'af','Magento katalogus beelde',0),(538823,14968,'ro','Magento Catalog imagini',0),(538824,14968,'et','Magento kataloogi Pildid',0),(538825,14968,'si','Magento katalog slik',0),(538826,14968,'ba','Magento Katalog gambar',0),(538827,14968,'nl','Magento catalogus beelden',0),(538828,14968,'fi','Magento-verkkokauppa kuvia',0),(538829,14968,'no','Magento katalogen bilder',0),(538830,14968,'da','Magento butik billeder',0),(538831,14968,'ko','Magento ì¹´íƒˆë¡œê·¸ ì´ë¯¸ì§€',0),(538832,14968,'he','×ž×’\'× ×˜×• ×§×˜×œ×•×’ ×ª×ž×•× ×•×ª',0),(538833,14968,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Magento ÎµÎ¹ÎºÏŒÎ½ÎµÏ‚',0),(538834,14968,'zh','Magento ç›®å½•å›¾åƒ',0),(538835,14968,'sv','Magento katalog bilder',0),(538836,14968,'it','Immagini catalogo Magento',0),(538837,14968,'tl','',0),(538838,14968,'th','à¸ à¸²à¸žà¹à¸„à¹‡à¸•à¸•à¸²à¸¥à¹‡à¸­à¸à¸‚à¸­à¸‡à¸§à¸µà¹‚à¸­à¹„à¸­à¸žà¸µ',0),(538839,14968,'hi','Magento à¤•à¥ˆà¤Ÿà¤²à¥‰à¤— à¤›à¤µà¤¿à¤¯à¤¾à¤',0),(538840,14968,'ms','Imej-imej Magento Katalog',0),(538841,14968,'ar','ØµÙˆØ± ÙƒØªØ§Ù„ÙˆØ¬ Ø§Ù„Ù…Ø§Ø¬Ù†ØªÙˆ',0),(538842,14968,'fr','Images de catalogue Magento',0),(538843,14968,'jp','Magento ã®ã‚«ã‚¿ãƒ­ã‚°ç”»åƒ',0),(538844,14968,'pt','Imagens de catÃ¡logo de Magento',0),(538845,14968,'ru','ÐšÐ°Ñ‚Ð°Ð»Ð¾Ð³ Magento Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(538846,14968,'es','CatÃ¡logo Magento imÃ¡genes',0),(538847,14968,'de','Magento Katalog Bilder',0),(538848,14968,'en','Magento Catalog Images',0),(538849,14969,'is','',0),(538850,14969,'dr','Ù‡ÛŒÚ† ØªØµÙˆÛŒØ±',0),(538851,14969,'pr','Ù‡ÛŒÚ† ØªØµÙˆÛŒØ±',0),(538852,14969,'tr','Resim yok',0),(538853,14969,'pl','Brak obrazu',0),(538854,14969,'bg','ÐÑÐ¼Ð° Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(538855,14969,'ur','Ú©ÙˆØ¦ÛŒ Ù†Ù‚Ø´',0),(538856,14969,'sr','ÐÐµÐ¼Ð° ÑÐ»Ð¸ÐºÐµ',0),(538857,14969,'vi','KhÃ´ng cÃ³ hÃ¬nh áº£nh',0),(538858,14969,'af','Geen beeld',0),(538859,14969,'ro','Nici o imagine',0),(538860,14969,'et','Pilt puudub',0),(538861,14969,'si','Ni slike',0),(538862,14969,'ba','Tidak ada gambar',0),(538863,14969,'nl','Geen beeld',0),(538864,14969,'fi','Ei kuvaa',0),(538865,14969,'no','Ikke noe bilde',0),(538866,14969,'da','Intet billede',0),(538867,14969,'ko','ì•„ë‹ˆ ì´ë¯¸ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(538868,14969,'he','××™×Ÿ ×ª×ž×•× ×”',0),(538869,14969,'el','ÎšÎ±Î¼Î¯Î± ÎµÎ¹ÎºÏŒÎ½Î±',0),(538870,14969,'zh','æ²¡æœ‰å›¾åƒ',0),(538871,14969,'sv','Ingen bild',0),(538872,14969,'it','Nessuna immagine',0),(538873,14969,'tl','',0),(538874,14969,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸ à¸²à¸ž',0),(538875,14969,'hi','à¤•à¥‹à¤ˆ à¤›à¤µà¤¿',0),(538876,14969,'ms','Tiada gambar',0),(538877,14969,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ ØµÙˆØ±Ø©',0),(538878,14969,'fr','Pas d\'Image',0),(538879,14969,'jp','ã‚¤ãƒ¡ãƒ¼ã‚¸ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(538880,14969,'pt','Nenhuma imagem',0),(538881,14969,'ru','ÐÐµÑ‚ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(538882,14969,'es','Ninguna imagen',0),(538883,14969,'de','Kein Bild',0),(538884,14969,'en','No Image',0),(538885,14970,'is','',0),(538886,14970,'dr','ØªØµÙˆÛŒØ± Ú©ÙˆÚ†Ú©',0),(538887,14970,'pr','ØªØµÙˆÛŒØ± Ú©ÙˆÚ†Ú©',0),(538888,14970,'tr','KÃ¼Ã§Ã¼k resim',0),(538889,14970,'pl','MaÅ‚y obrazek',0),(538890,14970,'bg','ÐœÐ°Ð»ÐºÐ¾ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(538891,14970,'ur','Ú†Ú¾ÙˆÙ¹ÛŒ ØªØµÙˆÛŒØ±',0),(538892,14970,'sr','ÐœÐ°Ð»Ð° ÑÐ»Ð¸ÐºÐ°',0),(538893,14970,'vi','HÃ¬nh áº£nh nhá»',0),(538894,14970,'af','Klein beeld',0),(538895,14970,'ro','Imagine mica',0),(538896,14970,'et','VÃ¤ike pilt',0),(538897,14970,'si','Majhne slike',0),(538898,14970,'ba','Gambar kecil',0),(538899,14970,'nl','Kleine afbeelding',0),(538900,14970,'fi','Pieni kuva',0),(538901,14970,'no','Lite bilde',0),(538902,14970,'da','Lille billede',0),(538903,14970,'ko','ìž‘ì€ ì´ë¯¸ì§€',0),(538904,14970,'he','×ª×ž×•× ×” ×§×˜× ×”',0),(538905,14970,'el','ÎœÎ¹ÎºÏÎ® ÎµÎ¹ÎºÏŒÎ½Î±',0),(538906,14970,'zh','å°å›¾åƒ',0),(538907,14970,'sv','Liten bild',0),(538908,14970,'it','Piccola immagine',0),(538909,14970,'tl','',0),(538910,14970,'th','à¸£à¸¹à¸›à¸ à¸²à¸žà¸‚à¸™à¸²à¸”à¹€à¸¥à¹‡à¸',0),(538911,14970,'hi','à¤›à¥‹à¤Ÿà¥€ à¤¸à¥€ à¤›à¤µà¤¿',0),(538912,14970,'ms','Imej kecil',0),(538913,14970,'ar','ØµÙˆØ±Ø© ØµØºÙŠØ±Ø©',0),(538914,14970,'fr','Petite Image',0),(538915,14970,'jp','å°ã•ãªç”»åƒ',0),(538916,14970,'pt','Imagem pequena',0),(538917,14970,'ru','ÐœÐ°Ð»ÐµÐ½ÑŒÐºÐ¾Ðµ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(538918,14970,'es','Imagen pequeÃ±a',0),(538919,14970,'de','Kleines Bild',0),(538920,14970,'en','Small Image',0),(538921,14971,'is','',0),(538922,14971,'dr','ØªØµÙˆÛŒØ± Ø¨Ù†Ø¯ Ø§Ù†Ú¯Ø´ØªÛŒ',0),(538923,14971,'pr','ØªØµÙˆÛŒØ± Ø¨Ù†Ø¯ Ø§Ù†Ú¯Ø´ØªÛŒ',0),(538924,14971,'tr','KÃ¼Ã§Ã¼k resim',0),(538925,14971,'pl','Miniatury',0),(538926,14971,'bg','ÐœÐ¸Ð½Ð¸Ð°Ñ‚ÑŽÑ€Ð°',0),(538927,14971,'ur','Ù¾ÙˆØ±Ù†Û',0),(538928,14971,'sr','Ð¡Ð»Ð¸Ñ‡Ð¸Ñ†Ðµ',0),(538929,14971,'vi','HÃ¬nh thu nhá»',0),(538930,14971,'af','PosseÃ«lprentjie',0),(538931,14971,'ro','Miniatura',0),(538932,14971,'et','Pisipilt',0),(538933,14971,'si','SliÄico',0),(538934,14971,'ba','Thumbnail',0),(538935,14971,'nl','Miniatuur',0),(538936,14971,'fi','Pikkukuva',0),(538937,14971,'no','Miniatyrbilde',0),(538938,14971,'da','Miniature',0),(538939,14971,'ko','ì¶•ì†ŒíŒ ê·¸ë¦¼',0),(538940,14971,'he','×ª×ž×•× ×” ×ž×ž×•×–×¢×¨×ª',0),(538941,14971,'el','ÎœÎ¹ÎºÏÎ¿Î³ÏÎ±Ï†Î¯Î±',0),(538942,14971,'zh','ç¼©ç•¥å›¾',0),(538943,14971,'sv','Miniatyr',0),(538944,14971,'it','Miniatura',0),(538945,14971,'tl','',0),(538946,14971,'th','à¸£à¸¹à¸›à¸‚à¸™à¸²à¸”à¸¢à¹ˆà¸­',0),(538947,14971,'hi','à¤¥à¤‚à¤¬à¤¨à¥‡à¤²',0),(538948,14971,'ms','Lakaran kenit',0),(538949,14971,'ar','ØµÙˆØ±Ø© Ù…ØµØºØ±Ø©',0),(538950,14971,'fr','Miniature',0),(538951,14971,'jp','ã‚µãƒ ãƒã‚¤ãƒ«',0),(538952,14971,'pt','Miniatura',0),(538953,14971,'ru','Ð­ÑÐºÐ¸Ð·',0),(538954,14971,'es','Miniatura',0),(538955,14971,'de','Ein Bild',0),(538956,14971,'en','Thumbnail',0),(538957,14972,'is','',0),(538958,14972,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(538959,14972,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(538960,14972,'tr','Kalan Mkt.',0),(538961,14972,'pl','IloÅ›Ä‡ pozostaÅ‚ych',0),(538962,14972,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾ÑÑ‚Ð°Ð²Ð°Ñ‰Ð¸',0),(538963,14972,'ur','Ø¨Ø§Ù‚ÛŒ Ù‚ÛŒ',0),(538964,14972,'sr','ÐŸÑ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð° ÐºÐ¾Ð».',0),(538965,14972,'vi','Qty cÃ²n láº¡i',0),(538966,14972,'af','Qty oor',0),(538967,14972,'ro','Cantit rÄƒmase',0),(538968,14972,'et','ÃœlejÃ¤Ã¤nud kogus',0),(538969,14972,'si','KoliÄina preostalih',0),(538970,14972,'ba','Qty tersisa',0),(538971,14972,'nl','Aantal resterende',0),(538972,14972,'fi','JÃ¤ljellÃ¤ oleva mÃ¤Ã¤rÃ¤',0),(538973,14972,'no','Antall gjenvÃ¦rende',0),(538974,14972,'da','Antal resterende',0),(538975,14972,'ko','ë‚¨ì€ ìˆ˜ëŸ‰',0),(538976,14972,'he','×›×ž×•×ª ×©× ×•×ª×¨×”',0),(538977,14972,'el','Qty Ï€Î±ÏÎ±Î¼Î­Î½Î¿Ï…Î½',0),(538978,14972,'zh','å‰©ä½™æ•°é‡',0),(538979,14972,'sv','Antal Ã¥terstÃ¥ende',0),(538980,14972,'it','Qty rimanenti',0),(538981,14972,'tl','',0),(538982,14972,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸„à¸‡à¹€à¸«à¸¥à¸·à¸­',0),(538983,14972,'hi','à¤¶à¥‡à¤· à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(538984,14972,'ms','Qty yang tinggal',0),(538985,14972,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(538986,14972,'fr','QtÃ© restante',0),(538987,14972,'jp','æ®‹ã‚Šã®æ•°é‡',0),(538988,14972,'pt','Qtde restante',0),(538989,14972,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð¾ÑÑ‚Ð°Ð²ÑˆÐ¸Ñ…ÑÑ',0),(538990,14972,'es','Cantidad restante',0),(538991,14972,'de','Qty Nummer(n)',0),(538992,14972,'en','Qty Remaining',0),(538993,14973,'is','',0),(538994,14973,'dr','Ù†Ù…Ø§ÛŒØ´/Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø¬Ø²Ø¦ÛŒØ§Øª Ø³ÙØ§Ø±Ø´',0),(538995,14973,'pr','Ù†Ù…Ø§ÛŒØ´/Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø¬Ø²Ø¦ÛŒØ§Øª Ø³ÙØ§Ø±Ø´',0),(538996,14973,'tr','SipariÅŸ ayrÄ±ntÄ±larÄ± gÃ¶ster/gizle',0),(538997,14973,'pl','PokaÅ¼/Ukryj szczegÃ³Å‚y zamÃ³wienia',0),(538998,14973,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ/ÑÐºÑ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(538999,14973,'ur','Ø¢Ø±ÚˆØ± ØªÙØ§ØµÛŒÙ„ Ù†Ù…Ø§ÛŒØ´/Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(539000,14973,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ /Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð´ÐµÑ‚Ð°Ñ™Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(539001,14973,'vi','Hiá»ƒn thá»‹/áº©n thÃ´ng tin chi tiáº¿t Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(539002,14973,'af','Wys/versteek bestelling besonderhede',0),(539003,14973,'ro','AfiÈ™are/Ascundere detalii comanda',0),(539004,14973,'et','Kuva/peida Tellimuse Ã¼ksikasjad',0),(539005,14973,'si','PokaÅ¾i/Skrij podrobnosti o naroÄilu',0),(539006,14973,'ba','Tampilkan/Sembunyikan rincian pesanan',0),(539007,14973,'nl','Toon/Verberg Orderinformatie',0),(539008,14973,'fi','NÃ¤ytÃ¤ tai Piilota tiedot',0),(539009,14973,'no','Vis/Skjul Ordredetaljer',0),(539010,14973,'da','Skjul ordreoplysninger',0),(539011,14973,'ko','ì£¼ë¬¸ ì„¸ë¶€ ì •ë³´ í‘œì‹œ/ìˆ¨ê¸°ê¸°',0),(539012,14973,'he','×”×¦×’/×”×¡×ª×¨ ×¤×¨×˜×™ ×”×–×ž× ×”',0),(539013,14973,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ·/Î±Ï€ÏŒÎºÏÏ…ÏˆÎ· Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(539014,14973,'zh','æ˜¾ç¤º/éšè—è®¢å•è¯¦ç»†ä¿¡æ¯',0),(539015,14973,'sv','Visa/DÃ¶lj Orderdetaljer',0),(539016,14973,'it','Mostra/Nascondi dettagli ordine',0),(539017,14973,'tl','',0),(539018,14973,'th','à¹à¸ªà¸”à¸‡/à¸‹à¹ˆà¸­à¸™à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(539019,14973,'hi','à¤‘à¤°à¥à¤¡à¤° à¤µà¤¿à¤µà¤°à¤£ à¤¦à¤¿à¤–à¤¾à¤à¤/à¤›à¥à¤ªà¤¾à¤à¤',0),(539020,14973,'ms','Tayang/Sembunyi butir-butir pesanan',0),(539021,14973,'ar','Ø¥Ø¸Ù‡Ø§Ø±/Ø¥Ø®ÙØ§Ø¡ ØªÙØ§ØµÙŠÙ„ ØªØ±ØªÙŠØ¨',0),(539022,14973,'fr','Afficher/masquer les dÃ©tails de la commande',0),(539023,14973,'jp','æ³¨æ–‡ã®è©³ç´°ã®è¡¨ç¤º/éžè¡¨ç¤º',0),(539024,14973,'pt','Mostrar/ocultar detalhes do pedido',0),(539025,14973,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¸Ð»Ð¸ ÑÐºÑ€Ñ‹Ñ‚ÑŒ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾ Ð·Ð°ÐºÐ°Ð·Ðµ',0),(539026,14973,'es','Mostrar/Ocultar detalles de la orden',0),(539027,14973,'de','Order Details ein-/ausblenden',0),(539028,14973,'en','Show/Hide Order Details',0),(539029,14974,'is','',0),(539030,14974,'dr','Magento',0),(539031,14974,'pr','Magento',0),(539032,14974,'tr','Magento',0),(539033,14974,'pl','Magento',0),(539034,14974,'bg','Magento',0),(539035,14974,'ur','Ù…Ø§Ú¯Ø§Ù†Ù¹Ùˆ',0),(539036,14974,'sr','ÐœÐ°Ð³ÐµÐ½Ñ‚Ð¾',0),(539037,14974,'vi','Magento',0),(539038,14974,'af','Magento',0),(539039,14974,'ro','Magento',0),(539040,14974,'et','Magento',0),(539041,14974,'si','Magento',0),(539042,14974,'ba','Magento',0),(539043,14974,'nl','Magento',0),(539044,14974,'fi','Magento',0),(539045,14974,'no','Magento',0),(539046,14974,'da','Magento',0),(539047,14974,'ko','Magento',0),(539048,14974,'he','×ž×’\'× ×˜×•',0),(539049,14974,'el','Magento',0),(539050,14974,'zh','Magento',0),(539051,14974,'sv','Magento',0),(539052,14974,'it','Magento',0),(539053,14974,'tl','',0),(539054,14974,'th','à¸§à¸µà¹‚à¸­à¹„à¸­à¸žà¸µ',0),(539055,14974,'hi','Magento',0),(539056,14974,'ms','Magento',0),(539057,14974,'ar','Ø§Ù„Ù…Ø§Ø¬Ù†ØªÙˆ',0),(539058,14974,'fr','Magento',0),(539059,14974,'jp','Magento',0),(539060,14974,'pt','Magento',0),(539061,14974,'ru','Magento',0),(539062,14974,'es','Magento',0),(539063,14974,'de','Magento',0),(539064,14974,'en','Magento',0),(539065,14975,'is','',0),(539066,14975,'dr','Magento ÛŒÚ©Ù¾Ø§Ø±Ú†Ù‡ Ø³Ø§Ø²ÛŒ',0),(539067,14975,'pr','Magento ÛŒÚ©Ù¾Ø§Ø±Ú†Ù‡ Ø³Ø§Ø²ÛŒ',0),(539068,14975,'tr','Magento entegrasyon',0),(539069,14975,'pl','Integracja Magento',0),(539070,14975,'bg','Magento Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ',0),(539071,14975,'ur','Ù…Ø§Ú¯Ø§Ù†Ù¹Ùˆ Ø§Ù†Ø¶Ù…Ø§Ù…',0),(539072,14975,'sr','ÐœÐ°Ð³ÐµÐ½Ñ‚Ð¾ Ð¸Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ˜Ðµ',0),(539073,14975,'vi','Magento há»™i nháº­p',0),(539074,14975,'af','Magento integrasie',0),(539075,14975,'ro','Integrarea Magento',0),(539076,14975,'et','Magento integreerimist',0),(539077,14975,'si','Magento integracije',0),(539078,14975,'ba','Magento integrasi',0),(539079,14975,'nl','Magento integratie',0),(539080,14975,'fi','Magento integraatio',0),(539081,14975,'no','Magento integrering',0),(539082,14975,'da','Magento Integration',0),(539083,14975,'ko','Magento í†µí•©',0),(539084,14975,'he','×©×™×œ×•×‘ ×ž×’\'× ×˜×•',0),(539085,14975,'el','Magento Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ·Ï‚',0),(539086,14975,'zh','Magento é›†æˆ',0),(539087,14975,'sv','Magento Integration',0),(539088,14975,'it','Integrazione di Magento',0),(539089,14975,'tl','',0),(539090,14975,'th','à¸£à¸§à¸¡à¸§à¸µà¹‚à¸­à¹„à¸­à¸žà¸µ',0),(539091,14975,'hi','Magento à¤à¤•à¥€à¤•à¤°à¤£',0),(539092,14975,'ms','Integrasi Magento',0),(539093,14975,'ar','Ø§Ù„ØªÙƒØ§Ù…Ù„ Ø§Ù„Ù…Ø§Ø¬Ù†ØªÙˆ',0),(539094,14975,'fr','IntÃ©gration Magento',0),(539095,14975,'jp','Magento ã®çµ±åˆ',0),(539096,14975,'pt','IntegraÃ§Ã£o do Magento',0),(539097,14975,'ru','Ð˜Ð½Ñ‚ÐµÐ³Ñ€Ð°Ñ†Ð¸Ñ Magento',0),(539098,14975,'es','IntegraciÃ³n de Magento',0),(539099,14975,'de','Magento Integration',0),(539100,14975,'en','Magento Integration',0),(539101,14976,'is','',0),(539102,14976,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ØªÚ©Ù…ÛŒÙ„ Ø´Ø¯',0),(539103,14976,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ØªÚ©Ù…ÛŒÙ„ Ø´Ø¯',0),(539104,14976,'tr','Alma tamamlandÄ±',0),(539105,14976,'pl','PrzywÃ³z kompletny',0),(539106,14976,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ðµ Ð·Ð°Ð²ÑŠÑ€ÑˆÐµÐ½Ð¾',0),(539107,14976,'ur','Ù…Ú©Ù…Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(539108,14976,'sr','Ð£Ð²Ð¾Ð· Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½',0),(539109,14976,'vi','Chuyá»ƒn nháº­p hoÃ n táº¥t',0),(539110,14976,'af','Invoer voltooi',0),(539111,14976,'ro','Import complet',0),(539112,14976,'et','Importimine on lÃµpule viidud',0),(539113,14976,'si','Uvoz je konÄan',0),(539114,14976,'ba','Impor lengkap',0),(539115,14976,'nl','Importeren voltooid',0),(539116,14976,'fi','Tuonti valmis',0),(539117,14976,'no','Importering fullfÃ¸rt',0),(539118,14976,'da','Import komplet',0),(539119,14976,'ko','ê°€ì ¸ì˜¤ê¸° ì™„ë£Œ',0),(539120,14976,'he','×™×™×‘×•× ×ž×œ×',0),(539121,14976,'el','Î Î»Î®ÏÎ·Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(539122,14976,'zh','å¯¼å…¥å®Œæˆ',0),(539123,14976,'sv','Importen klar',0),(539124,14976,'it','Importazione completa',0),(539125,14976,'tl','',0),(539126,14976,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(539127,14976,'hi','à¤†à¤¯à¤¾à¤¤ à¤ªà¥‚à¤°à¥à¤£',0),(539128,14976,'ms','Import selesai',0),(539129,14976,'ar','Ø§ÙƒØªÙ…Ø§Ù„ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(539130,14976,'fr','Importation complÃ¨te',0),(539131,14976,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆãŒå®Œäº†ã—ã¾ã—ãŸ',0),(539132,14976,'pt','ImportaÃ§Ã£o completa',0),(539133,14976,'ru','ÐŸÐ¾Ð»Ð½Ñ‹Ð¹ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(539134,14976,'es','ImportaciÃ³n completa',0),(539135,14976,'de','Import abgeschlossen',0),(539136,14976,'en','Import Complete',0),(539137,14977,'is','',0),(539138,14977,'dr','Ú†Ù†Ø¯',0),(539139,14977,'pr','Ú†Ù†Ø¯',0),(539140,14977,'tr','Birden Ã§ok',0),(539141,14977,'pl','Wielu',0),(539142,14977,'bg','ÐœÐ½Ð¾Ð¶ÐµÑÑ‚Ð²Ð¾',0),(539143,14977,'ur','Ú©Ø«ÛŒØ±',0),(539144,14977,'sr','Ð’Ð¸ÑˆÐµ',0),(539145,14977,'vi','Nhiá»u',0),(539146,14977,'af','Meervoudige',0),(539147,14977,'ro','Mai multe',0),(539148,14977,'et','Mitme',0),(539149,14977,'si','VeÄ',0),(539150,14977,'ba','Beberapa',0),(539151,14977,'nl','Meerdere',0),(539152,14977,'fi','Useita',0),(539153,14977,'no','Flere',0),(539154,14977,'da','Flere',0),(539155,14977,'ko','ì—¬ëŸ¬',0),(539156,14977,'he','×ž×¨×•×‘×™×',0),(539157,14977,'el','Î Î¿Î»Î»Î±Ï€Î»Î­Ï‚',0),(539158,14977,'zh','å¤šä¸ª',0),(539159,14977,'sv','Flera',0),(539160,14977,'it','Multiple',0),(539161,14977,'tl','',0),(539162,14977,'th','à¸«à¸¥à¸²à¸¢',0),(539163,14977,'hi','à¤à¤•à¤¾à¤§à¤¿à¤•',0),(539164,14977,'ms','Berbilang',0),(539165,14977,'ar','Ù…ØªØ¹Ø¯Ø¯Ø©',0),(539166,14977,'fr','Multiples',0),(539167,14977,'jp','è¤‡æ•°',0),(539168,14977,'pt','MÃºltiplas',0),(539169,14977,'ru','ÐÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾',0),(539170,14977,'es','MÃºltiples',0),(539171,14977,'de','Mehrere',0),(539172,14977,'en','Multiple',0),(539173,14978,'is','',0),(539174,14978,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù†',0),(539175,14978,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù†',0),(539176,14978,'tr','Ekleme',0),(539177,14978,'pl','Dodawanie',0),(539178,14978,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ',0),(539179,14978,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(539180,14978,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ',0),(539181,14978,'vi','ThÃªm',0),(539182,14978,'af','Voeg',0),(539183,14978,'ro','AdÄƒugarea',0),(539184,14978,'et','Lisamine',0),(539185,14978,'si','Dodajanje',0),(539186,14978,'ba','Menambahkan',0),(539187,14978,'nl','Toe te voegen',0),(539188,14978,'fi','LisÃ¤Ã¤minen',0),(539189,14978,'no','Legge til',0),(539190,14978,'da','TilfÃ¸je',0),(539191,14978,'ko','ì¶”ê°€',0),(539192,14978,'he','×”×•×¡×¤×ª',0),(539193,14978,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(539194,14978,'zh','æ·»åŠ ',0),(539195,14978,'sv','Att lÃ¤gga till',0),(539196,14978,'it','L\'aggiunta di',0),(539197,14978,'tl','',0),(539198,14978,'th','à¹€à¸žà¸´à¹ˆà¸¡',0),(539199,14978,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(539200,14978,'ms','Menambah',0),(539201,14978,'ar','Ø¥Ø¶Ø§ÙØ©',0),(539202,14978,'fr','Ajouter',0),(539203,14978,'jp','è¿½åŠ ã—ã¾ã™ã€‚',0),(539204,14978,'pt','Adicionando',0),(539205,14978,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(539206,14978,'es','Agregar',0),(539207,14978,'de','HinzufÃ¼gen',0),(539208,14978,'en','Adding',0),(539209,14979,'is','',0),(539210,14979,'dr','Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø®Ø±Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(539211,14979,'pr','Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø®Ø±Ø§Ø¨ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(539212,14979,'tr','Dosya bozuk',0),(539213,14979,'pl','Plik jest uszkodzony',0),(539214,14979,'bg','Ð¤Ð°Ð¹Ð»ÑŠÑ‚ Ðµ Ð¿Ð¾Ð²Ñ€ÐµÐ´ÐµÐ½',0),(539215,14979,'ur','Ù…Ø³Ù„ Ø®Ø±Ø§Ø¨ ÛÛ’',0),(539216,14979,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ñ˜Ðµ Ð¾ÑˆÑ‚ÐµÑ›ÐµÐ½Ð°',0),(539217,14979,'vi','Táº­p tin bá»‹ há»ng',0),(539218,14979,'af','LÃªer Is korrup',0),(539219,14979,'ro','FiÅŸierul este corupt',0),(539220,14979,'et','Fail on rikutud',0),(539221,14979,'si','Datoteka je poÅ¡kodovana',0),(539222,14979,'ba','Berkas tersebut rusak',0),(539223,14979,'nl','Bestand Is beschadigd',0),(539224,14979,'fi','Tiedosto on vioittunut',0),(539225,14979,'no','Filen er skadet',0),(539226,14979,'da','Filen er beskadiget',0),(539227,14979,'ko','íŒŒì¼ì´ ì†ìƒ ë˜ì–´',0),(539228,14979,'he','×§×•×‘×¥ ×¤×’×•×',0),(539229,14979,'el','Î¤Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ ÎµÎ¯Î½Î±Î¹ ÎºÎ±Ï„ÎµÏƒÏ„ÏÎ±Î¼Î¼Î­Î½Î¿',0),(539230,14979,'zh','æ–‡ä»¶å·²æŸå',0),(539231,14979,'sv','Filen Ã¤r skadad',0),(539232,14979,'it','File Ã¨ corrotto',0),(539233,14979,'tl','',0),(539234,14979,'th','à¹à¸Ÿà¹‰à¸¡à¹€à¸ªà¸µà¸¢à¸«à¸²à¸¢',0),(539235,14979,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¦à¥‚à¤·à¤¿à¤¤ à¤¹à¥ˆ',0),(539236,14979,'ms','Fail sudah rosak',0),(539237,14979,'ar','Ø§Ù„Ù…Ù„Ù Ù…Ø¹Ø·ÙˆØ¨',0),(539238,14979,'fr','Le fichier est endommagÃ©',0),(539239,14979,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ãŒå£Šã‚Œã¦ã„ã¾ã™',0),(539240,14979,'pt','Arquivo estÃ¡ corrompido',0),(539241,14979,'ru','Ð¤Ð°Ð¹Ð» Ð¿Ð¾Ð²Ñ€ÐµÐ¶Ð´ÐµÐ½',0),(539242,14979,'es','Archivo estÃ¡ daÃ±ado',0),(539243,14979,'de','Die Datei ist beschÃ¤digt',0),(539244,14979,'en','File Is Corrupt',0),(539245,14980,'is','',0),(539246,14980,'dr','Ù‡Ù…Ú¯Ø§Ù… Ø³Ø§Ø²ÛŒ',0),(539247,14980,'pr','Ù‡Ù…Ú¯Ø§Ù… Ø³Ø§Ø²ÛŒ',0),(539248,14980,'tr','EÅŸitleme',0),(539249,14980,'pl','Synchronizacja',0),(539250,14980,'bg','Ð¡Ð¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(539251,14980,'ur','ÛÙ… ÙˆÙ‚Øª Ø³Ø§Ø²ÛŒ',0),(539252,14980,'sr','Ð—Ð° ÑÐ¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ñƒ',0),(539253,14980,'vi','Äá»“ng bá»™',0),(539254,14980,'af','Sinchro',0),(539255,14980,'ro','Sincronizare',0),(539256,14980,'et','SÃ¼nkroonimine',0),(539257,14980,'si','Sinhronizacija',0),(539258,14980,'ba','Sinkronisasi',0),(539259,14980,'nl','Sync',0),(539260,14980,'fi','Synkronointi',0),(539261,14980,'no','Synkronisering',0),(539262,14980,'da','Sync',0),(539263,14980,'ko','ë™ê¸°í™”',0),(539264,14980,'he','×¡×™× ×›×¨×•×Ÿ',0),(539265,14980,'el','Î£Ï…Î³Ï‡ÏÎ¿Î½Î¹ÏƒÎ¼Î¿Ï',0),(539266,14980,'zh','åŒæ­¥',0),(539267,14980,'sv','Sync',0),(539268,14980,'it','Sincronizzazione',0),(539269,14980,'tl','',0),(539270,14980,'th','à¸‹à¸´à¸‡à¸„à¹Œ',0),(539271,14980,'hi','à¤¸à¤¿à¤‚à¤•',0),(539272,14980,'ms','Segerak',0),(539273,14980,'ar','Ø§Ù„Ù…Ø²Ø§Ù…Ù†Ø©',0),(539274,14980,'fr','Sync',0),(539275,14980,'jp','åŒæœŸ',0),(539276,14980,'pt','SincronizaÃ§Ã£o',0),(539277,14980,'ru','Ð¡Ð¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(539278,14980,'es','SincronizaciÃ³n',0),(539279,14980,'de','Sync',0),(539280,14980,'en','Sync',0),(539281,14981,'is','',0),(539282,14981,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(539283,14981,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(539284,14981,'tr','GÃ¼ncelleÅŸtirme',0),(539285,14981,'pl','Aktualizacji',0),(539286,14981,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(539287,14981,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(539288,14981,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(539289,14981,'vi','Cáº­p Nháº­t',0),(539290,14981,'af','Bywerking',0),(539291,14981,'ro','Actualizarea',0),(539292,14981,'et','VÃ¤rskendamine',0),(539293,14981,'si','Posodabljanje',0),(539294,14981,'ba','Memperbarui',0),(539295,14981,'nl','Bijwerken',0),(539296,14981,'fi','PÃ¤ivittÃ¤minen',0),(539297,14981,'no','Oppdatering',0),(539298,14981,'da','Opdatering',0),(539299,14981,'ko','ì—…ë°ì´íŠ¸',0),(539300,14981,'he','×¢×“×›×•×Ÿ',0),(539301,14981,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(539302,14981,'zh','æ›´æ–°',0),(539303,14981,'sv','Uppdatera',0),(539304,14981,'it','Aggiornamento',0),(539305,14981,'tl','',0),(539306,14981,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(539307,14981,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¤¾',0),(539308,14981,'ms','Mengemaskini',0),(539309,14981,'ar','ØªØ­Ø¯ÙŠØ«',0),(539310,14981,'fr','Mise Ã  jour',0),(539311,14981,'jp','æ›´æ–°',0),(539312,14981,'pt','Atualizando',0),(539313,14981,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(539314,14981,'es','ActualizaciÃ³n',0),(539315,14981,'de','Aktualisierung',0),(539316,14981,'en','Updating',0),(539317,14982,'is','',0),(539318,14982,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÛŒØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(539319,14982,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÛŒØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(539320,14982,'tr','SatÄ±cÄ± satÄ±nalma sipariÅŸleri',0),(539321,14982,'pl','ZamÃ³wienia dostawcy',0),(539322,14982,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(539323,14982,'ur','ÙˆÛŒÙ†ÚˆØ± Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª',0),(539324,14982,'sr','Ð˜Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(539325,14982,'vi','ÄÆ¡n Ä‘áº·t hÃ ng mua nhÃ  cung cáº¥p',0),(539326,14982,'af','Handelaar aankoop bestellings',0),(539327,14982,'ro','Comenzi de cumpÄƒrare furnizor',0),(539328,14982,'et','Hankijale ostutellimuste',0),(539329,14982,'si','Dobavitelja nabavni nalogi',0),(539330,14982,'ba','Pesanan pembelian Penjual',0),(539331,14982,'nl','Inkooporders van leverancier',0),(539332,14982,'fi','Toimittajan ostotilaukset',0),(539333,14982,'no','LeverandÃ¸ren bestillinger',0),(539334,14982,'da','Kreditor indkÃ¸bsordrer',0),(539335,14982,'ko','ê³µê¸‰ ì—…ì²´ êµ¬ë§¤ ì£¼ë¬¸',0),(539336,14982,'he','×”×–×ž× ×•×ª ×¨×›×© ×”×¡×¤×§',0),(539337,14982,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Î³Î¿ÏÏŽÎ½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(539338,14982,'zh','ä¾›åº”å•†çš„é‡‡è´­è®¢å•',0),(539339,14982,'sv','LeverantÃ¶r inkÃ¶psorder',0),(539340,14982,'it','Ordini di acquisto del fornitore',0),(539341,14982,'tl','',0),(539342,14982,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸œà¸¹à¹‰à¸‚à¸²à¸¢',0),(539343,14982,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(539344,14982,'ms','Pesanan pembelian vendor',0),(539345,14982,'ar','Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡ Ù…Ù† Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(539346,14982,'fr','Commandes fournisseur',0),(539347,14982,'jp','ä»•å…¥å…ˆã®ç™ºæ³¨',0),(539348,14982,'pt','Ordens de compra de fornecedor',0),(539349,14982,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ Ð°Ð±Ð¾Ð½ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(539350,14982,'es','Ã“rdenes de compra proveedor',0),(539351,14982,'de','Lieferanten-Bestellungen',0),(539352,14982,'en','Vendor Purchase Orders',0),(539353,14983,'is','',0),(539354,14983,'dr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§ Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ†',0),(539355,14983,'pr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§ Ù‚Ø§Ù„Ø¨ Ø³ØªÙˆÙ†',0),(539356,14983,'tr','KiÅŸi dosyasÄ± sÃ¼tun biÃ§imi',0),(539357,14983,'pl','Kontakt z plik formatu kolumny',0),(539358,14983,'bg','ÐšÐ¾Ð»Ð¾Ð½Ð° Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð° Ñ„Ð°Ð¹Ð» Ñ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(539359,14983,'ur','ÙˆØ¶Ø¹ Ú©Ø§Ù„Ù… Ø±Ø§Ø¨Ø·Û Ù…Ø³Ù„',0),(539360,14983,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð° Ñƒ ÐºÐ¾Ð»Ð¾Ð½Ð¸',0),(539361,14983,'vi','Tá»‡p liÃªn há»‡ cá»™t Ä‘á»‹nh dáº¡ng',0),(539362,14983,'af','Kontak kolom lÃªerformaat',0),(539363,14983,'ro','Format de coloane dosar contact',0),(539364,14983,'et','Kontaktide fail veeruvormingut',0),(539365,14983,'si','Stolpcu Format datoteke stika',0),(539366,14983,'ba','Format File kontak kolom',0),(539367,14983,'nl','Contact-kolom bestandsindeling',0),(539368,14983,'fi','Yhteystietotiedoston sarakkeen muoto',0),(539369,14983,'no','Kontaktfil kolonneformat',0),(539370,14983,'da','Kontakt-kolonne filformat',0),(539371,14983,'ko','ì—°ë½ì²˜ íŒŒì¼ ì—´ í˜•ì‹',0),(539372,14983,'he','×ª×‘× ×™×ª ×¢×ž×•×“×” ×§×•×‘×¥ ×× ×©×™ ×§×©×¨',0),(539373,14983,'el','Î£Ï„Î®Î»Î· Î¼Î¿ÏÏ†Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï… ÎµÏ€Î±Ï†ÏŽÎ½',0),(539374,14983,'zh','è”ç³»äººæ–‡ä»¶åˆ—æ ¼å¼',0),(539375,14983,'sv','Kontakt-kolumn filformatet',0),(539376,14983,'it','Contatta formato colonna',0),(539377,14983,'tl','',0),(539378,14983,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œà¹à¸Ÿà¹‰à¸¡à¸•à¸´à¸”à¸•à¹ˆà¸­',0),(539379,14983,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(539380,14983,'ms','Format kolum fail Kenalan',0),(539381,14983,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¹Ù…ÙˆØ¯ ÙÙŠ Ù…Ù„Ù Ø§Ù„Ø§ØªØµØ§Ù„',0),(539382,14983,'fr','Format de colonne de fichier contact',0),(539383,14983,'jp','é€£çµ¡å…ˆãƒ•ã‚¡ã‚¤ãƒ«ã®åˆ—ã®å½¢å¼',0),(539384,14983,'pt','Formato de coluna do arquivo de contatos',0),(539385,14983,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ñ‹Ð¹ Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð¾Ð²',0),(539386,14983,'es','Formato de archivo contacto de columna',0),(539387,14983,'de','Kontaktdatei Spaltenformat',0),(539388,14983,'en','Contact File Column Format',0),(539389,14984,'is','',0),(539390,14984,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø² ÙØ§ÛŒÙ„ CSV',0),(539391,14984,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø² ÙØ§ÛŒÙ„ CSV',0),(539392,14984,'tr','CSV dosyasÄ±ndan iÃ§e aktarma',0),(539393,14984,'pl','Import z pliku CSV',0),(539394,14984,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚ CSV Ñ„Ð°Ð¹Ð»',0),(539395,14984,'ur','CSV Ù…Ø³Ù„ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(539396,14984,'sr','Ð£Ð²Ð¾Ð· Ð¸Ð· Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(539397,14984,'vi','Chuyá»ƒn nháº­p tá»« tá»‡p CSV',0),(539398,14984,'af','Voer in vanaf CSV-lÃªer',0),(539399,14984,'ro','Import din fiÅŸier CSV',0),(539400,14984,'et','Importida CSV-failist',0),(539401,14984,'si','Uvoz iz datoteke CSV',0),(539402,14984,'ba','Impor dari CSV File',0),(539403,14984,'nl','Importeren uit CSV-bestand',0),(539404,14984,'fi','Tuominen CSV-tiedostosta',0),(539405,14984,'no','Import fra CSV-filen',0),(539406,14984,'da','Import fra CSV-fil',0),(539407,14984,'ko','CSV íŒŒì¼ì—ì„œ ê°€ì ¸ì˜¤ê¸°',0),(539408,14984,'he','×™×™×‘×•× ×ž×§×•×‘×¥ CSV',0),(539409,14984,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€ÏŒ Î±ÏÏ‡ÎµÎ¯Î¿ CSV',0),(539410,14984,'zh','ä»Ž CSV æ–‡ä»¶å¯¼å…¥',0),(539411,14984,'sv','Import frÃ¥n CSV-fil',0),(539412,14984,'it','Importazione da File CSV',0),(539413,14984,'tl','',0),(539414,14984,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸²à¸à¹„à¸Ÿà¸¥à¹Œ CSV',0),(539415,14984,'hi','CSV à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(539416,14984,'ms','Import daripada fail CSV',0),(539417,14984,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù† Ù…Ù„Ù CSV',0),(539418,14984,'fr','Import de fichier CSV',0),(539419,14984,'jp','CSV ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(539420,14984,'pt','ImportaÃ§Ã£o de arquivo CSV',0),(539421,14984,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¸Ð· CSV-Ñ„Ð°Ð¹Ð»Ð°',0),(539422,14984,'es','Importar desde un archivo CSV',0),(539423,14984,'de','Import von CSV-Datei',0),(539424,14984,'en','Import From CSV File',0),(539425,14985,'is','',0),(539426,14985,'dr','Ù†Ø§Ù… Ù…Ø±Ø¬Ø¹',0),(539427,14985,'pr','Ù†Ø§Ù… Ù…Ø±Ø¬Ø¹',0),(539428,14985,'tr','BaÅŸvuru adÄ±',0),(539429,14985,'pl','Nazwa referencyjna',0),(539430,14985,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(539431,14985,'ur','Ø­ÙˆØ§Ù„Û Ø¯ÛŒÚº Ú©Ø§ Ù†Ø§Ù…',0),(539432,14985,'sr','Ð ÐµÑ„ÐµÑ€ÐµÐ½Ñ†Ð° Ð¸Ð¼Ðµ',0),(539433,14985,'vi','TÃªn tÃ i liá»‡u tham kháº£o',0),(539434,14985,'af','Verwysing naam',0),(539435,14985,'ro','Nume de referinÅ£Äƒ',0),(539436,14985,'et','Viidatud',0),(539437,14985,'si','ReferenÄni naziv',0),(539438,14985,'ba','Nama referensi',0),(539439,14985,'nl','Referentienaam',0),(539440,14985,'fi','Viitteen nimi',0),(539441,14985,'no','Referansenavn',0),(539442,14985,'da','Referencenavn',0),(539443,14985,'ko','ì°¸ì¡° ì´ë¦„',0),(539444,14985,'he','×©× ××¡×ž×›×ª×',0),(539445,14985,'el','ÎŒÎ½Î¿Î¼Î± Î±Î½Î±Ï†Î¿ÏÎ¬Ï‚',0),(539446,14985,'zh','å¼•ç”¨åç§°',0),(539447,14985,'sv','Referensnamn',0),(539448,14985,'it','Nome di riferimento',0),(539449,14985,'tl','',0),(539450,14985,'th','à¸Šà¸·à¹ˆà¸­à¸à¸²à¸£à¸­à¹‰à¸²à¸‡à¸­à¸´à¸‡',0),(539451,14985,'hi','à¤¸à¤‚à¤¦à¤°à¥à¤­ à¤•à¤¾ à¤¨à¤¾à¤®',0),(539452,14985,'ms','Nama rujukan',0),(539453,14985,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ø±Ø¬Ø¹',0),(539454,14985,'fr','Nom de rÃ©fÃ©rence',0),(539455,14985,'jp','å‚ç…§å',0),(539456,14985,'pt','Nome de referÃªncia',0),(539457,14985,'ru','Ð˜Ð¼Ñ ÑÑÑ‹Ð»ÐºÐ¸',0),(539458,14985,'es','Nombre de referencia',0),(539459,14985,'de','Referenzname',0),(539460,14985,'en','Reference Name',0),(539461,14986,'is','',0),(539462,14986,'dr','Ù„Ø·ÙØ§Ù‹ ÛŒÚ© ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(539463,14986,'pr','Ù„Ø·ÙØ§Ù‹ ÛŒÚ© ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(539464,14986,'tr','LÃ¼tfen bir satÄ±cÄ± seÃ§in',0),(539465,14986,'pl','ProszÄ™ wybraÄ‡ dostawcÄ™',0),(539466,14986,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(539467,14986,'ur','Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº Ø§ÛŒÚ© Ø®ÙˆØ§Ù†Ú†Û ÙØ±ÙˆØ´ Ø®Ø§ØªÙˆÙ†',0),(539468,14986,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(539469,14986,'vi','Vui lÃ²ng chá»n má»™t nhÃ  cung cáº¥p',0),(539470,14986,'af','Kies asseblief \'n ondernemer',0),(539471,14986,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i un furnizor',0),(539472,14986,'et','Palun valige hankija',0),(539473,14986,'si','Izberite prodajalca',0),(539474,14986,'ba','Pilih Vendor',0),(539475,14986,'nl','Kies een leverancier',0),(539476,14986,'fi','Valitse toimittaja',0),(539477,14986,'no','Velg en leverandÃ¸r',0),(539478,14986,'da','VÃ¦lg en leverandÃ¸r',0),(539479,14986,'ko','ê³µê¸‰ ì—…ì²´ë¥¼ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(539480,14986,'he','× × ×‘×—×¨ ×¡×¤×§',0),(539481,14986,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î­Î½Î±Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(539482,14986,'zh','è¯·é€‰æ‹©ä¸€ä¸ªä¾›åº”å•†',0),(539483,14986,'sv','VÃ¤lj en leverantÃ¶r',0),(539484,14986,'it','Prego selezionare un fornitore',0),(539485,14986,'tl','',0),(539486,14986,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸¥à¸·à¸­à¸à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(539487,14986,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(539488,14986,'ms','Sila pilih Vendor',0),(539489,14986,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ù…ÙˆØ±Ø¯',0),(539490,14986,'fr','S\'il vous plaÃ®t sÃ©lectionnez un fournisseur',0),(539491,14986,'jp','ä»•å…¥å…ˆã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(539492,14986,'pt','Por favor selecione um fornecedor',0),(539493,14986,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(539494,14986,'es','Por favor seleccione un proveedor',0),(539495,14986,'de','Bitte wÃ¤hlen Sie einen Anbieter',0),(539496,14986,'en','Please Select A Vendor',0),(539497,14987,'is','',0),(539498,14987,'dr','Ù„Ø§ÛŒØ­Ù‡ Ù†Ø¸Ø§Ù… Ù¾Ø±Ø¯Ø§Ø®Øª',0),(539499,14987,'pr','Ù„Ø§ÛŒØ­Ù‡ Ù†Ø¸Ø§Ù… Ù¾Ø±Ø¯Ø§Ø®Øª',0),(539500,14987,'tr','Fatura Ã¶deme',0),(539501,14987,'pl','Bill Pay',0),(539502,14987,'bg','Bill Pay',0),(539503,14987,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(539504,14987,'sr','Ð‘Ð¸Ð» Ð¿Ð»Ð°Ñ‚Ðµ',0),(539505,14987,'vi','Bill Pay',0),(539506,14987,'af','Wetsontwerp betaal',0),(539507,14987,'ro','Bill Pay',0),(539508,14987,'et','MSN Bill Pay',0),(539509,14987,'si','Bill Pay',0),(539510,14987,'ba','Bill Pay',0),(539511,14987,'nl','Bill Pay',0),(539512,14987,'fi','Bill Pay',0),(539513,14987,'no','Bill Pay',0),(539514,14987,'da','Bill Pay',0),(539515,14987,'ko','ë¹Œ íŽ˜ì´',0),(539516,14987,'he','Bill Pay',0),(539517,14987,'el','Î Î»Î·ÏÏ‰Î¼Î® Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(539518,14987,'zh','è´¦å•æ”¯ä»˜',0),(539519,14987,'sv','Bill Pay',0),(539520,14987,'it','Bill Pay',0),(539521,14987,'tl','',0),(539522,14987,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(539523,14987,'hi','à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(539524,14987,'ms','Bayar bil',0),(539525,14987,'ar','Bill Pay',0),(539526,14987,'fr','Bill Pay',0),(539527,14987,'jp','è«‹æ±‚æ›¸æ”¯æ‰•ã„',0),(539528,14987,'pt','Bill Pay',0),(539529,14987,'ru','Bill Pay',0),(539530,14987,'es','Pago de facturas',0),(539531,14987,'de','Rechnung zu bezahlen',0),(539532,14987,'en','Bill Pay',0),(539533,14988,'is','',0),(539534,14988,'dr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…Ø´Ù…ÙˆÙ„ÛŒØª ÙˆÙ‚ØªÛŒ Unreceiving Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(539535,14988,'pr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…Ø´Ù…ÙˆÙ„ÛŒØª ÙˆÙ‚ØªÛŒ Unreceiving Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(539536,14988,'tr','Hareketleri Unreceiving zaman zemin stok',0),(539537,14988,'pl','Backdate transakcji, gdy Unreceiving zapasÃ³w',0),(539538,14988,'bg','Backdate Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Unreceiving Ð·Ð°Ð¿Ð°ÑÐ¸',0),(539539,14988,'ur','Ø¬Ø¨ Ø§Ù†Ø±ÛŒÚ©ÛŒÙˆØ§Ù†Ú¯ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø¨Ø§Ú©Ú©Ø¯Ø§Ù¹ÛŒ Ú©ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ',0),(539540,14988,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐºÐ°Ð´Ð° Ð£Ð½Ñ€ÐµÑ†ÐµÐ¸Ð²Ð¸Ð½Ð³ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(539541,14988,'vi','Backdate giao dá»‹ch khi Unreceiving hÃ ng tá»“n kho',0),(539542,14988,'af','Backdate transaksies wanneer Unreceiving voorraad',0),(539543,14988,'ro','Backdate tranzacÅ£ii atunci cÃ¢nd Unreceiving inventarul',0),(539544,14988,'et','Backdate kandeid kui Unreceiving varude',0),(539545,14988,'si','Umakniti transakcije, ko Unreceiving zaloge',0),(539546,14988,'ba','Backdate transaksi ketika Unreceiving persediaan',0),(539547,14988,'nl','Achterdeur transacties wanneer Unreceiving voorraad',0),(539548,14988,'fi','Takautuvasti tapahtumat, kun Unreceiving varastoa',0),(539549,14988,'no','Tilbakedatere transaksjoner nÃ¥r Unreceiving lager',0),(539550,14988,'da','Tilbagevirkende kraft transaktioner, nÃ¥r Unreceiving opgÃ¸relse',0),(539551,14988,'ko','Unreceiving ë•Œ ê±°ëž˜ë¥¼ ì†Œê¸‰ ìž¬ê³ ',0),(539552,14988,'he','××§× ×” ×¢×¡×§××•×ª ×›××©×¨ Unreceiving ×ž×œ××™',0),(539553,14988,'el','ÎšÎ±Î¸Î¿ÏÎ¹ÏƒÎ¸ÎµÎ¯ Î±Î½Î±Î´ÏÎ¿Î¼Î¹ÎºÎ¬ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ ÏŒÏ„Î±Î½ Unreceiving Î±Ï€Î¿Î³ÏÎ±Ï†Î®Ï‚',0),(539554,14988,'zh','å›žæº¯äº¤æ˜“è®°å½•æ—¶é‡‡ç”¨åº“å­˜',0),(539555,14988,'sv','Antedatera transaktioner nÃ¤r Unreceiving lager',0),(539556,14988,'it','Retrodatare operazioni quando Unreceiving inventario',0),(539557,14988,'tl','',0),(539558,14988,'th','Backdate à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¹€à¸¡à¸·à¹ˆà¸­ Unreceiving à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(539559,14988,'hi','à¤œà¤¬ Unreceiving à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ backdate à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€',0),(539560,14988,'ms','Backdate transaksi apabila Unreceiving inventori',0),(539561,14988,'ar','ØªØ¤Ø±Ø® Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¹Ù†Ø¯ Ø£ÙˆÙ†Ø±ÙŠØ³ÙŠÙÙŠÙ†Ø¬ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(539562,14988,'fr','Antidater des Transactions quand Unreceiving l\'inventaire',0),(539563,14988,'jp','Unreceiving ã™ã‚‹ã¨ãã«ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã‚’ç§»ç±å‰åœ¨åº«',0),(539564,14988,'pt','Retroagir transaÃ§Ãµes quando Unreceiving inventÃ¡rio',0),(539565,14988,'ru','Ð—Ð°Ð´Ð½Ð¸Ð¼ Ñ‡Ð¸ÑÐ»Ð¾Ð¼ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ Ð¿Ñ€Ð¸ Unreceiving Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(539566,14988,'es','Retrotraer las transacciones cuando Unreceiving inventario',0),(539567,14988,'de','Transaktionen zurÃ¼ckdatieren, wenn Unreceiving Inventar',0),(539568,14988,'en','Backdate Transactions When Unreceiving Inventory',0),(539569,14989,'is','',0),(539570,14989,'dr','Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÛŒ Ù‡Ù…Ù‡',0),(539571,14989,'pr','Ø§Ø¶Ø§ÙÙ‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø±Ø§ÛŒ Ù‡Ù…Ù‡',0),(539572,14989,'tr','SeÃ§ili tÃ¼m Ã¶demelerin toplamÄ±nÄ±',0),(539573,14989,'pl','DodaÄ‡ pÅ‚atnoÅ›ci dla wszystkich wybranych',0),(539574,14989,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(539575,14989,'ur','ØªÙ…Ø§Ù… Ù…Ù†ØªØ®Ø¨ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(539576,14989,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð·Ð° ÑÐ²Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ',0),(539577,14989,'vi','ThÃªm khoáº£n thanh toÃ¡n cho táº¥t cáº£ cÃ¡c lá»±a chá»n',0),(539578,14989,'af','Voeg betalings vir al gekies',0),(539579,14989,'ro','Adauga plÄƒÅ£ilor pentru toate selectate',0),(539580,14989,'et','Lisage kÃµik valitud eest',0),(539581,14989,'si','Dodaj plaÄila za vse izbrane',0),(539582,14989,'ba','Tambahkan pembayaran untuk semua dipilih',0),(539583,14989,'nl','Betalingen voor alle geselecteerde toevoegen',0),(539584,14989,'fi','LisÃ¤Ã¤ maksuja kaikki valitut',0),(539585,14989,'no','Legge til betalinger For alle valgte',0),(539586,14989,'da','TilfÃ¸je betalinger For alle markerede',0),(539587,14989,'ko','ëª¨ë‘ ì„ íƒì— ëŒ€ í•œ ì§€ë¶ˆì„ ì¶”ê°€',0),(539588,14989,'he','×œ×”×•×¡×™×£ ×ª×©×œ×•×ž×™× ×¢×‘×•×¨ ×›×œ ×©× ×‘×—×¨',0),(539589,14989,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î³Î¹Î± ÏŒÎ»Î± Ï„Î± ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î±',0),(539590,14989,'zh','æ·»åŠ æ‰€æœ‰é€‰å®šçš„ä»˜æ¬¾',0),(539591,14989,'sv','LÃ¤gg till betalningar fÃ¶r alla valda',0),(539592,14989,'it','Aggiungere i pagamenti per tutti selezionati',0),(539593,14989,'tl','',0),(539594,14989,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(539595,14989,'hi','à¤¸à¤­à¥€ à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(539596,14989,'ms','Menambah pembayaran untuk semua dipilih',0),(539597,14989,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¯ÙÙˆØ¹Ø§Øª Ù„ØªØ­Ø¯ÙŠØ¯ ÙƒØ§ÙØ©',0),(539598,14989,'fr','Ajouter des paiements pour tous sÃ©lectionnÃ©s',0),(539599,14989,'jp','é¸æŠžã—ãŸã™ã¹ã¦ã®ãŸã‚ã®æ”¯æ‰•ã„ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(539600,14989,'pt','Adicionar pagamentos para todos os itens selecionados',0),(539601,14989,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð´Ð»Ñ Ð²ÑÐµÑ… Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ…',0),(539602,14989,'es','AÃ±adir los pagos para todos los seleccionados',0),(539603,14989,'de','FÃ¼gen Sie Zahlungen fÃ¼r alle ausgewÃ¤hlten hinzu',0),(539604,14989,'en','Add Payments For All Selected',0),(539605,14990,'is','',0),(539606,14990,'dr','ØªØ¹Ø§Ø¯Ù„ Ø¨Ø§Ù†Ú©ÛŒ',0),(539607,14990,'pr','ØªØ¹Ø§Ø¯Ù„ Ø¨Ø§Ù†Ú©ÛŒ',0),(539608,14990,'tr','Banka bakiyesi',0),(539609,14990,'pl','Saldo bankowe',0),(539610,14990,'bg','Ð‘Ð°Ð»Ð°Ð½Ñ Ð±Ð°Ð½ÐºÐ°',0),(539611,14990,'ur','Ø¨ÛŒÙ†Ú© Ø¨ÛŒÙ„Ù†Ø³',0),(539612,14990,'sr','Ð¡Ñ‚Ð°ÑšÐµ Ð½Ð° Ñ€Ð°Ñ†ÑƒÐ½Ñƒ',0),(539613,14990,'vi','Sá»‘ dÆ° ngÃ¢n hÃ ng',0),(539614,14990,'af','Bank balans',0),(539615,14990,'ro','Soldul bancar',0),(539616,14990,'et','Panga saldo',0),(539617,14990,'si','BanÄne bilance',0),(539618,14990,'ba','Saldo Bank',0),(539619,14990,'nl','Banksaldo',0),(539620,14990,'fi','Pankkitilin saldo',0),(539621,14990,'no','Banksaldo',0),(539622,14990,'da','Bank Balance',0),(539623,14990,'ko','ì€í–‰ ìž”ê³ ',0),(539624,14990,'he','×™×ª×¨×ª ×—×©×‘×•×Ÿ ×”×‘× ×§',0),(539625,14990,'el','Î¤ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŽÎ½ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½',0),(539626,14990,'zh','é“¶è¡Œå­˜æ¬¾ä½™é¢',0),(539627,14990,'sv','Bank balans',0),(539628,14990,'it','Bilancio bancario',0),(539629,14990,'tl','',0),(539630,14990,'th','à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£',0),(539631,14990,'hi','à¤¬à¥ˆà¤‚à¤• à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸',0),(539632,14990,'ms','Baki bank',0),(539633,14990,'ar','Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ù…ØµØ±ÙÙŠ',0),(539634,14990,'fr','Solde bancaire',0),(539635,14990,'jp','éŠ€è¡Œã®é é‡‘æ®‹é«˜',0),(539636,14990,'pt','Saldo bancÃ¡rio',0),(539637,14990,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ Ð±Ð°Ð½ÐºÐ°',0),(539638,14990,'es','Saldo bancario',0),(539639,14990,'de','Bankguthaben',0),(539640,14990,'en','Bank Balance',0),(539641,14991,'is','',0),(539642,14991,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙÙŠØ´',0),(539643,14991,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙÙŠØ´',0),(539644,14991,'tr','Fatura numarasÄ±',0),(539645,14991,'pl','Numer rachunku',0),(539646,14991,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð°',0),(539647,14991,'ur','Ø¨Ù„ Ù†Ù…Ø¨Ø±',0),(539648,14991,'sr','Ð Ð°Ñ‡ÑƒÐ½ Ð±Ñ€Ð¾Ñ˜',0),(539649,14991,'vi','Sá»‘ Bill',0),(539650,14991,'af','Rekening nommer',0),(539651,14991,'ro','Bill numÄƒrul',0),(539652,14991,'et','Arve Number',0),(539653,14991,'si','Bill Å¡tevilka',0),(539654,14991,'ba','Jumlah tagihan',0),(539655,14991,'nl','Bill nummer',0),(539656,14991,'fi','Lasku numero',0),(539657,14991,'no','Regning nummer',0),(539658,14991,'da','Bill nummer',0),(539659,14991,'ko','ì²­êµ¬ì„œ ë²ˆí˜¸',0),(539660,14991,'he','×ž×¡×¤×¨ ×”×—×©×‘×•×Ÿ',0),(539661,14991,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(539662,14991,'zh','å•ç¼–å·',0),(539663,14991,'sv','Bill nummer',0),(539664,14991,'it','Numero di fattura',0),(539665,14991,'tl','',0),(539666,14991,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚',0),(539667,14991,'hi','à¤¬à¤¿à¤² à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(539668,14991,'ms','Nombor Rang undang-undang',0),(539669,14991,'ar','Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(539670,14991,'fr','NumÃ©ro de facture',0),(539671,14991,'jp','è«‹æ±‚æ›¸ç•ªå·',0),(539672,14991,'pt','NÃºmero de conta',0),(539673,14991,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸',0),(539674,14991,'es','NÃºmero de factura',0),(539675,14991,'de','Rechnungsnummer',0),(539676,14991,'en','Bill Number',0),(539677,14992,'is','',0),(539678,14992,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(539679,14992,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(539680,14992,'tr','Ã–demeleri baÅŸarÄ±yla kaydedildi',0),(539681,14992,'pl','PÅ‚atnoÅ›ci zapisane',0),(539682,14992,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(539683,14992,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Ø§ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(539684,14992,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(539685,14992,'vi','CÃ¡c khoáº£n thanh toÃ¡n lÆ°u thÃ nh cÃ´ng',0),(539686,14992,'af','Betalings suksesvol gestoor',0),(539687,14992,'ro','PlÄƒÅ£i salvat cu succes',0),(539688,14992,'et','Maksete edukalt salvestatud',0),(539689,14992,'si','PlaÄila uspeÅ¡no shranjen',0),(539690,14992,'ba','Pembayaran yang berhasil diselamatkan',0),(539691,14992,'nl','Betalingen succesvol opgeslagen',0),(539692,14992,'fi','Maksut tallennettu',0),(539693,14992,'no','Betalinger lagret',0),(539694,14992,'da','Betalinger gemt med succes',0),(539695,14992,'ko','ê²°ì œë¥¼ ì„±ê³µì ìœ¼ë¡œ ì €ìž¥',0),(539696,14992,'he','×ª×©×œ×•×ž×™× ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(539697,14992,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(539698,14992,'zh','å·²æˆåŠŸä¿å­˜çš„ä»˜æ¬¾',0),(539699,14992,'sv','Betalningar som sparats',0),(539700,14992,'it','Pagamenti salvati correttamente',0),(539701,14992,'tl','',0),(539702,14992,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(539703,14992,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(539704,14992,'ms','Pembayaran berjaya disimpan',0),(539705,14992,'ar','Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø­ÙØ¸ Ø¨Ù†Ø¬Ø§Ø­',0),(539706,14992,'fr','Paiements enregistrÃ©s avec succÃ¨s',0),(539707,14992,'jp','ãŠæ”¯æ‰•ã„ãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(539708,14992,'pt','Pagamentos com sucesso',0),(539709,14992,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(539710,14992,'es','Pagos guardados correctamente',0),(539711,14992,'de','Zahlungen erfolgreich gespeichert',0),(539712,14992,'en','Payments Saved Successfully',0),(539713,14993,'is','',0),(539714,14993,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù†',0),(539715,14993,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒØ§Ù†',0),(539716,14993,'tr','Ä°stemciler iÃ§in faturalarÄ± Ã¶demek',0),(539717,14993,'pl','PÅ‚aciÄ‡ rachunki dla klientÃ³w',0),(539718,14993,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸',0),(539719,14993,'ur','Ú¯Ø§ÛÚ© Ú©Û’ Ù„Ø¦Û’ Ø¨Ù„ÙˆÚº Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(539720,14993,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð·Ð° ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ðµ',0),(539721,14993,'vi','Tráº£ cÃ¡c hÃ³a Ä‘Æ¡n cho khÃ¡ch hÃ ng',0),(539722,14993,'af','Rekeninge betaal vir kliÃ«nte',0),(539723,14993,'ro','Plata facturilor pentru clientii',0),(539724,14993,'et','Maksa arveid klientidele',0),(539725,14993,'si','PlaÄilo raÄunov za stranke',0),(539726,14993,'ba','Membayar tagihan untuk klien',0),(539727,14993,'nl','Rekeningen betalen voor Clients',0),(539728,14993,'fi','Maksaa laskut asiakkaille',0),(539729,14993,'no','Betale regninger For klienter',0),(539730,14993,'da','Betale regninger For klienter',0),(539731,14993,'ko','í´ë¼ì´ì–¸íŠ¸ì— ëŒ€ í•œ ì²­êµ¬ì„œë¥¼ ì§€ë¶ˆ',0),(539732,14993,'he','×œ×©×œ× ××ª ×”×—×©×‘×•× ×•×ª ×¢×‘×•×¨ ×œ×§×•×—×•×ª',0),(539733,14993,'el','Î Î»Î·ÏÏŽÏƒÎµÏ„Îµ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(539734,14993,'zh','ä¸ºå®¢æˆ·æ”¯ä»˜è´¦å•',0),(539735,14993,'sv','Betala rÃ¤kningar fÃ¶r klienter',0),(539736,14993,'it','Pagare le bollette per i clienti',0),(539737,14993,'tl','',0),(539738,14993,'th','à¸Šà¸³à¸£à¸°à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸ªà¸³à¸«à¸£à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²',0),(539739,14993,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²à¥‹à¤‚ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(539740,14993,'ms','Membayar bil-bil untuk pelanggan',0),(539741,14993,'ar','Ø¯ÙØ¹ ÙÙˆØ§ØªÙŠØ± Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(539742,14993,'fr','Payer les factures pour les Clients',0),(539743,14993,'jp','ã‚¯ãƒ©ã‚¤ã‚¢ãƒ³ãƒˆã®ãŸã‚ã®æ‰‹å½¢ã‚’æ”¯æ‰•ã†',0),(539744,14993,'pt','Pagar contas para clientes',0),(539745,14993,'ru','ÐžÐ¿Ð»Ð°Ñ‡Ð¸Ð²Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(539746,14993,'es','Pagar las facturas de clientes',0),(539747,14993,'de','Bezahlen von Rechnungen fÃ¼r Kunden',0),(539748,14993,'en','Pay Bills For Clients',0),(539749,14994,'is','',0),(539750,14994,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± RPR',0),(539751,14994,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± RPR',0),(539752,14994,'tr','RPR fatura numarasÄ±',0),(539753,14994,'pl','Numer faktury RPR',0),(539754,14994,'bg','RPR Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¾Ð¼ÐµÑ€',0),(539755,14994,'ur','Ø±Ù¾Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø±',0),(539756,14994,'sr','Ð ÐŸÐ  Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(539757,14994,'vi','RPR hoÃ¡ Ä‘Æ¡n sá»‘',0),(539758,14994,'af','RPR faktuur nommer',0),(539759,14994,'ro','NumÄƒrul de facturÄƒ RPR',0),(539760,14994,'et','RPR arvenumber',0),(539761,14994,'si','RPR Å¡tevilko raÄuna',0),(539762,14994,'ba','RPR faktur jumlah',0),(539763,14994,'nl','RPR factuurnummer',0),(539764,14994,'fi','RPR laskunumero',0),(539765,14994,'no','RPR fakturanummer',0),(539766,14994,'da','RPR fakturanummer',0),(539767,14994,'ko','RPR ì†¡ìž¥ ë²ˆí˜¸',0),(539768,14994,'he','×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª RPR',0),(539769,14994,'el','RPR Î¤Î™ÎœÎŸÎ›ÎŸÎ“Î—Î£Î—Î£',0),(539770,14994,'zh','RPR å‘ç¥¨ç¼–å·',0),(539771,14994,'sv','RPR fakturanummer',0),(539772,14994,'it','Numero fattura RPR',0),(539773,14994,'tl','',0),(539774,14994,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ RPR',0),(539775,14994,'hi','RPR à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(539776,14994,'ms','Nombor invois RPR',0),(539777,14994,'ar','Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù…ØªØ§Ø²',0),(539778,14994,'fr','NumÃ©ro de facture RPR',0),(539779,14994,'jp','RPR è«‹æ±‚æ›¸ç•ªå·',0),(539780,14994,'pt','NÃºmero de factura RPR',0),(539781,14994,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ RPR',0),(539782,14994,'es','NÃºmero de factura de RPR',0),(539783,14994,'de','RPR-Rechnungsnummer',0),(539784,14994,'en','RPR Invoice Number',0),(539785,14995,'is','',0),(539786,14995,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(539787,14995,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(539788,14995,'tr','SeÃ§ili tutar',0),(539789,14995,'pl','Wybranej iloÅ›ci',0),(539790,14995,'bg','Ð˜Ð·Ð±Ñ€Ð°Ð½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(539791,14995,'ur','Ù…Ù†ØªØ®Ø¨ Ø±Ù‚Ù…',0),(539792,14995,'sr','Ð˜Ð·Ð°Ð±Ñ€Ð°Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(539793,14995,'vi','Sá»‘ tiá»n Ä‘Æ°á»£c lá»±a chá»n',0),(539794,14995,'af','Geselekteerde bedrag',0),(539795,14995,'ro','Valoarea selectatÄƒ',0),(539796,14995,'et','Valitud summa',0),(539797,14995,'si','Izbrani znesek',0),(539798,14995,'ba','Jumlah dipilih',0),(539799,14995,'nl','Geselecteerde bedrag',0),(539800,14995,'fi','Valittu summa',0),(539801,14995,'no','Valgte belÃ¸p',0),(539802,14995,'da','Udvalgte belÃ¸b',0),(539803,14995,'ko','ì„ íƒí•œ ê¸ˆì•¡',0),(539804,14995,'he','×¡×›×•× ×©× ×‘×—×¨',0),(539805,14995,'el','Î•Ï€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Ï€Î¿ÏƒÏŒ',0),(539806,14995,'zh','æ‰€é€‰çš„é‡‘é¢',0),(539807,14995,'sv','Valda beloppet',0),(539808,14995,'it','Importo selezionato',0),(539809,14995,'tl','',0),(539810,14995,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(539811,14995,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤°à¤¾à¤¶à¤¿',0),(539812,14995,'ms','Jumlah yang dipilih',0),(539813,14995,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø­Ø¯Ø¯',0),(539814,14995,'fr','QuantitÃ© sÃ©lectionnÃ©e',0),(539815,14995,'jp','é¸æŠžã—ãŸé‡',0),(539816,14995,'pt','Quantidade selecionada',0),(539817,14995,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(539818,14995,'es','Cantidad seleccionada',0),(539819,14995,'de','AusgewÃ¤hlte Menge',0),(539820,14995,'en','Selected Amount',0),(539821,14996,'is','',0),(539822,14996,'dr','Ø¢Ú¯Ù‡ÛŒ Ù‡Ø§ÛŒ Ø´Ø§Ù…Ù„',0),(539823,14996,'pr','Ø¢Ú¯Ù‡ÛŒ Ù‡Ø§ÛŒ Ø´Ø§Ù…Ù„',0),(539824,14996,'tr','MÃ¼ÅŸteri adaylarÄ± iÃ§erir',0),(539825,14996,'pl','To prowadzi',0),(539826,14996,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ð²Ð¾Ð´Ð¸',0),(539827,14996,'ur','Ù„Û’ Ø¬Ø§ØªØ§ ÛÛ’ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(539828,14996,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ñ‚Ñ€Ð°Ð³Ð¾Ð²Ðµ',0),(539829,14996,'vi','Bao gá»“m dáº«n',0),(539830,14996,'af','Sluit lei',0),(539831,14996,'ro','Includ conduce',0),(539832,14996,'et','Sisaldavad viib',0),(539833,14996,'si','VkljuÄujejo vodi',0),(539834,14996,'ba','Termasuk memimpin',0),(539835,14996,'nl','Omvatten Leads',0),(539836,14996,'fi','Liideille',0),(539837,14996,'no','Inkluder fÃ¸rer',0),(539838,14996,'da','Omfatte fÃ¸rer',0),(539839,14996,'ko','ë¦¬ë“œë¥¼ í¬í•¨',0),(539840,14996,'he','×œ×›×œ×•×œ ×”×¤× ×™×•×ª',0),(539841,14996,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î¿Î´Î·Î³ÎµÎ¯',0),(539842,14996,'zh','åŒ…æ‹¬æ½œåœ¨é¡¾å®¢',0),(539843,14996,'sv','Ta med Leads',0),(539844,14996,'it','Includono cavi',0),(539845,14996,'tl','',0),(539846,14996,'th','à¸£à¸§à¸¡à¹€à¸›à¹‰à¸²à¸«à¸¡à¸²à¸¢',0),(539847,14996,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€à¤¸à¥‚à¤¤à¥à¤° à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(539848,14996,'ms','Termasuk membawa',0),(539849,14996,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ù…ØªÙˆÙ‚Ø¹ÙŠÙ†',0),(539850,14996,'fr','Inclure les prospects',0),(539851,14996,'jp','ãƒªãƒ¼ãƒ‰ç·šã‚’å«ã‚ã‚‹',0),(539852,14996,'pt','Incluem pistas',0),(539853,14996,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°ÑŽÑ‚ Ð² ÑÐµÐ±Ñ Ð²ÐµÐ´ÐµÑ‚',0),(539854,14996,'es','Incluyen cables',0),(539855,14996,'de','ZÃ¤hlen Leads',0),(539856,14996,'en','Include Leads',0),(539857,14997,'is','',0),(539858,14997,'dr','Ø¢Ú¯Ù‡ÛŒ',0),(539859,14997,'pr','Ø¢Ú¯Ù‡ÛŒ',0),(539860,14997,'tr','MÃ¼ÅŸteri adaylarÄ±',0),(539861,14997,'pl','Prowadzi',0),(539862,14997,'bg','Ð’Ð¾Ð´Ð¸',0),(539863,14997,'ur','Ú©ÛŒ Ø·Ø±Ù Ø¬Ø§ØªØ§ ÛÛ’',0),(539864,14997,'sr','ÐŸÐ¾Ñ‚ÐµÐ½Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸',0),(539865,14997,'vi','Dáº«n',0),(539866,14997,'af','Lei',0),(539867,14997,'ro','Duce',0),(539868,14997,'et','Viib',0),(539869,14997,'si','Vodi',0),(539870,14997,'ba','Memimpin',0),(539871,14997,'nl','Leidt',0),(539872,14997,'fi','Johtaa',0),(539873,14997,'no','Leder',0),(539874,14997,'da','FÃ¸rer',0),(539875,14997,'ko','ë¦¬ë“œ',0),(539876,14997,'he','×ž×•×‘×™×œ',0),(539877,14997,'el','ÎŸÎ´Î·Î³ÎµÎ¯',0),(539878,14997,'zh','æ½œåœ¨é¡¾å®¢',0),(539879,14997,'sv','Leder',0),(539880,14997,'it','Conduce',0),(539881,14997,'tl','',0),(539882,14997,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸›à¹‰à¸²à¸«à¸¡à¸²à¸¢',0),(539883,14997,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€à¤¸à¥‚à¤¤à¥à¤°',0),(539884,14997,'ms','Membawa',0),(539885,14997,'ar','ÙˆÙŠØ¤Ø¯ÙŠ',0),(539886,14997,'fr','Conduit',0),(539887,14997,'jp','ãƒªãƒ¼ãƒ‰',0),(539888,14997,'pt','Leva',0),(539889,14997,'ru','ÐŸÑ€Ð¸Ð²Ð¾Ð´Ð¸Ñ‚',0),(539890,14997,'es','Conduce',0),(539891,14997,'de','FÃ¼hrt',0),(539892,14997,'en','Leads',0),(539893,14998,'is','',0),(539894,14998,'dr','ØªÙ…Ø§Ù… ÙˆÙ„Ø³ÙˆØ§Ù„ÛŒ Ù‡Ø§ÛŒ Ù…Ø§Ù„ÛŒØ§ØªÛŒ',0),(539895,14998,'pr','ØªÙ…Ø§Ù… ÙˆÙ„Ø³ÙˆØ§Ù„ÛŒ Ù‡Ø§ÛŒ Ù…Ø§Ù„ÛŒØ§ØªÛŒ',0),(539896,14998,'tr','TÃ¼m vergi bÃ¶lgeleri',0),(539897,14998,'pl','Wszystkie okrÄ™gi podatkowe',0),(539898,14998,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(539899,14998,'ur','ØªÙ…Ø§Ù… Ù¹ÛŒÚ©Ø³ Ø§Ø¶Ù„Ø§Ø¹',0),(539900,14998,'sr','Ð¡Ð²Ð¸ ÑƒÐ±Ð¸Ñ€Ð°Ñ‚Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(539901,14998,'vi','Táº¥t cáº£ thuáº¿ huyá»‡n',0),(539902,14998,'af','Alle belasting distrikte',0),(539903,14998,'ro','Toate raioanele fiscale',0),(539904,14998,'et','KÃµikide maksude linnaosades',0),(539905,14998,'si','Vse davÄne okraje',0),(539906,14998,'ba','Semua pajak daerah',0),(539907,14998,'nl','Alle belasting districten',0),(539908,14998,'fi','Kaikki vero piirit',0),(539909,14998,'no','Alle skatt distrikter',0),(539910,14998,'da','Alle skat distrikter',0),(539911,14998,'ko','ëª¨ë“  ì„¸ê¸ˆ ì§€êµ¬',0),(539912,14998,'he','×›×œ ×ž×—×•×–×•×ª ×ž×¡',0),(539913,14998,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ­Ï‚ Ï€ÎµÏÎ¹Ï†Î­ÏÎµÎ¹ÎµÏ‚',0),(539914,14998,'zh','æ‰€æœ‰çš„ç¨ŽåŒº',0),(539915,14998,'sv','Alla skatt distrikt',0),(539916,14998,'it','Tutti i distretti fiscali',0),(539917,14998,'tl','',0),(539918,14998,'th','à¹€à¸‚à¸•à¸ à¸²à¸©à¸µà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(539919,14998,'hi','à¤¸à¤­à¥€ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤œà¤¿à¤²à¥‹à¤‚',0),(539920,14998,'ms','Semua cukai Daerah',0),(539921,14998,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø¯ÙˆØ§Ø¦Ø± Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©',0),(539922,14998,'fr','Tous les Districts de taxe',0),(539923,14998,'jp','ã™ã¹ã¦ã®ç¨Žåœ°åŒº',0),(539924,14998,'pt','Todos os distritos de imposto',0),(539925,14998,'ru','Ð’ÑÐµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ Ð¾ÐºÑ€ÑƒÐ³Ð°',0),(539926,14998,'es','Todos los distritos de impuestos',0),(539927,14998,'de','Alle Steuer-Bezirke',0),(539928,14998,'en','All Tax Districts',0),(539929,14999,'is','',0),(539930,14999,'dr','Ø§Ú¯Ø± Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ø§ Ø§Ø±Ø² Ø¯ÛŒÚ¯Ø± Ø§Ø² ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù†Ø±Ø® Ø§Ø±Ø² Ù¾Ø§ÛŒÙ‡ Ø®ÙˆØ¯Ú©Ø§Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ù…Ú¯Ø± Ø§ÛŒÙ†Ú©Ù‡ Ø¯Ø³ØªÛŒ ÙˆØ§Ø±Ø¯',0),(539931,14999,'pr','Ø§Ú¯Ø± Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ø§ Ø§Ø±Ø² Ø¯ÛŒÚ¯Ø± Ø§Ø² ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù†Ø±Ø® Ø§Ø±Ø² Ù¾Ø§ÛŒÙ‡ Ø®ÙˆØ¯Ú©Ø§Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ù…Ú¯Ø± Ø§ÛŒÙ†Ú©Ù‡ Ø¯Ø³ØªÛŒ ÙˆØ§Ø±Ø¯',0),(539932,14999,'tr','EÄŸer tedarikÃ§iler ile baz para birimi el ile girdiÄŸiniz sÃ¼rece otomatik oranlarÄ± kullanÄ±lacak farklÄ± bir para biriminde iÃ§in iÃ§e aktarma',0),(539933,14999,'pl','JeÅ›li importowanie dla dostawcÃ³w w walucie innej niÅ¼ waluta bazowa cena automatyczne bÄ™dzie uÅ¼ywany chyba wprowadzony rÄ™cznie',0),(539934,14999,'bg','ÐÐºÐ¾ Ð²Ð½Ð¾ÑÐ¸Ñ‚ÐµÐ» Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ñ Ð²Ð°Ð»ÑƒÑ‚Ð° Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð° Ð¾Ñ‚ Ð±Ð°Ð·Ð¾Ð²Ð°Ñ‚Ð° Ð²Ð°Ð»ÑƒÑ‚Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¸ Ñ‰Ðµ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°, Ð¾ÑÐ²ÐµÐ½ Ð°ÐºÐ¾ Ñ€ÑŠÑ‡Ð½Ð¾ Ð²ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ',0),(539935,14999,'ur','Ø§Ú¯Ø± Ø§ÛŒÚ© Ú©Ø±Ù†Ø³ÛŒ Ø¨Ù†ÛŒØ§Ø¯ÛŒ Ú©Ø±Ù†Ø³ÛŒ Ø®ÙˆØ¯Ú©Ø§Ø± Ø´Ø±Ø­ Ú©Û’ Ø¹Ù„Ø§ÙˆÛ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©Û’ Ù„Ø¦Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø± Ø±ÛØ§ ÛÛ’ Ø¬Ø¨ ØªÚ© Ú©Û Ø¯Ø³ØªÛŒ Ø·ÙˆØ± Ù¾Ø± Ø¯Ø§Ø®Ù„ ÛÙˆØ¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(539936,14999,'sr','ÐÐºÐ¾ ÑƒÐ²Ð¾Ð· Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ ÑÐ° Ð²Ð°Ð»ÑƒÑ‚Ð¾Ð¼ ÐºÐ¾Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ ÑÑ‚Ð¾Ð¿Ðµ Ñ›Ðµ ÑÐµ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ð¸, Ð¾ÑÐ¸Ð¼ Ð°ÐºÐ¾ Ñ€ÑƒÑ‡Ð½Ð¾ ÑƒÐ½ÐµÐ»Ð¸ Ð¾ÑÐ½Ð¾Ð²Ð½Ðµ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(539937,14999,'vi','Náº¿u nháº­p kháº©u cho nhÃ  cung cáº¥p vá»›i má»™t loáº¡i tiá»n tá»‡ khÃ¡c hÆ¡n so vá»›i cÃ¡c loáº¡i tiá»n tá»‡ cÆ¡ sá»Ÿ tá»· giÃ¡ tá»± Ä‘á»™ng sáº½ Ä‘Æ°á»£c sá»­ dá»¥ng trá»« khi Ä‘Ã£ nháº­p theo cÃ¡ch thá»§ cÃ´ng',0),(539938,14999,'af','As invoer vir verkopers met \'n geldeenheid anders as die basis outomatiese wisselkoerse sal gebruik word tensy handmatig ingetik',0),(539939,14999,'ro','ÃŽn cazul Ã®n care importul de furnizori cu o altÄƒ monedÄƒ decÃ¢t moneda de bazÄƒ automatÄƒ a cursurilor vor fi utilizate decÃ¢t dacÄƒ introduse manual',0),(539940,14999,'et','Kui importimine hankijate baasi automaatne valuutakursside muus vÃ¤Ã¤ringus kui kÃ¤sitsi sisestatud kasutatakse',0),(539941,14999,'si','ÄŒe uvoz za dobavitelje z valuto razen bo osnovno valuto samodejni teÄaji uporabljajo razen Äe roÄno vnesete',0),(539942,14999,'ba','Jika mengimpor untuk vendor dengan mata uang lain daripada harga otomatis mata uang dasar yang akan digunakan kecuali masukkan secara manual',0),(539943,14999,'nl','Als importeren voor leveranciers met een andere valuta dan de basisvaluta automatische tarieven zal worden gebruikt tenzij handmatig ingevoerd',0),(539944,14999,'fi','Jos tuot toimittajalle valuutassa kuin perusvaluutta automaattinen edullisin kÃ¤ytetÃ¤Ã¤n paitsi manuaalisesti',0),(539945,14999,'no','Hvis importerer For leverandÃ¸rer med en annen valuta enn standardvalutaen automatisk priser vil bli brukt hvis angitt manuelt',0),(539946,14999,'da','Hvis import til leverandÃ¸rer med en anden valuta end den nedrig gangbarhed automatisk satser vil blive brugt medmindre manuelt indtastet',0),(539947,14999,'ko','ìˆ˜ë™ìœ¼ë¡œ ìž…ë ¥ ë˜ì§€ ì•Šì€ ê²½ìš° ê¸°ë³¸ í†µí™” ìžë™ ìš”ê¸ˆ ì´ì™¸ì˜ ë‹¤ë¥¸ í†µí™” ê³µê¸‰ ì—…ì²´ì— ëŒ€ í•œ ê°€ì ¸ì˜¤ê¸° í•˜ëŠ” ê²½ìš° ì‚¬ìš© ë©ë‹ˆë‹¤.',0),(539948,14999,'he','×× ×™×™×‘×•× ×¢×‘×•×¨ ×¡×¤×§×™ ×œ×ž×˜×‘×¢ ×—×•×¥ ×ž×˜×‘×¢ ×”×‘×¡×™×¡ ×™×™×¢×©×” ×©×™×ž×•×© ××•×˜×•×ž×˜×™ ×”×ž×—×™×¨×™× ××œ× ×× ×”×”×–× ×” ×™×“× ×™×ª',0),(539949,14999,'el','Î•Î¬Î½ Î· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ Î¼Îµ Î­Î½Î± Î½ÏŒÎ¼Î¹ÏƒÎ¼Î± ÎµÎºÏ„ÏŒÏ‚ Î±Ï€ÏŒ Ï„Î¿ Î²Î±ÏƒÎ¹ÎºÏŒ Î½ÏŒÎ¼Î¹ÏƒÎ¼Î± Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Ï„Î¹Î¼Î­Ï‚ Î¸Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î·Î¸Î¿ÏÎ½, ÎµÎºÏ„ÏŒÏ‚ ÎºÎ±Î¹ Î±Î½ ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÎ¹ Î¼Îµ',0),(539950,14999,'zh','å¦‚æžœå¯¼å…¥ä¸ºä¸Žä¸€ç§è´§å¸çš„ä¾›åº”å•†ä»¥å¤–å°†ç”¨åŸºç¡€è´§å¸è‡ªåŠ¨çŽ‡ï¼Œé™¤éžæ‰‹åŠ¨è¾“å…¥',0),(539951,14999,'sv','Om importerar fÃ¶r leverantÃ¶rer med en annan valuta Ã¤n bas automatiska priser kommer att anvÃ¤ndas om angett manuellt',0),(539952,14999,'it','Se l\'importazione per i fornitori con una valuta diversa da quella Base automatiche tariffe verranno utilizzati se non inserito manualmente',0),(539953,14999,'tl','',0),(539954,14999,'th','à¸–à¹‰à¸²à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸”à¹‰à¸§à¸¢à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™à¸­à¸·à¹ˆà¸™à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆà¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™à¸žà¸·à¹‰à¸™à¸à¸²à¸™à¸—à¸µà¹ˆà¸ˆà¸°à¹ƒà¸Šà¹‰à¸£à¸²à¸„à¸²à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¸›à¹‰à¸­',0),(539955,14999,'hi','à¤¯à¤¦à¤¿ à¤à¤• à¤®à¥à¤¦à¥à¤°à¤¾ à¤†à¤§à¤¾à¤° à¤®à¥à¤¦à¥à¤°à¤¾ à¤¸à¥à¤µà¤¤: à¤¦à¤°à¥‹à¤‚ à¤œà¤¬ à¤¤à¤• à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤°à¥‚à¤ª à¤¸à¥‡ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾ à¤•à¥‡ à¤…à¤²à',0),(539956,14999,'ms','Jika mengimport untuk vendor dengan Mata Wang selain daripada mata wang asas kadar automatik akan digunakan kecuali secara manual masukkan',0),(539957,14999,'ar','ÙÙŠ Ø­Ø§Ù„Ø© Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù„Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ† Ø¨Ø¹Ù…Ù„Ù‡ Ø®Ù„Ø§Ù Ø§Ù„Ø¹Ù…Ù„Ø© Ø§Ù„ØªÙŠ Ø³ÙŠØªÙ… Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù…Ø¹Ø¯Ù„Ø§Øª Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ Ø¥Ù„Ø§ Ø¥Ø°Ø§ ØªÙ… Ø¥Ø¯Ø®Ø§Ù„Ù‡Ø§ ÙŠØ¯ÙˆÙŠØ§Ù‹',0),(539958,14999,'fr','Si l\'importation pour les fournisseurs avec une autre devise que la devise de Base taux automatiques seront utilisÃ©s Ã  moins que saisi manuellement',0),(539959,14999,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’æ‰‹å‹•ã§å…¥åŠ›ã—ãªã„é™ã‚Šã€è‡ªå‹•ãƒ¬ãƒ¼ãƒˆãŒä½¿ç”¨ã•ã‚Œã¾ã™åŸºæœ¬é€šè²¨ä»¥å¤–ã®é€šè²¨ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹å ´åˆ',0),(539960,14999,'pt','Se importando para os vendedores com uma moeda diferente da moeda Base taxas automÃ¡ticas serÃ£o usadas a nÃ£o ser inseridos manualmente',0),(539961,14999,'ru','Ð•ÑÐ»Ð¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ñ Ð²Ð°Ð»ÑŽÑ‚Ð¾Ð¹ Ð´Ñ€ÑƒÐ³Ð¾Ð¹ Ñ‡ÐµÐ¼ Ð½Ðµ Ð²Ð²Ð¾Ð´Ð¸Ñ‚ÑÑ Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ Ð±ÑƒÐ´ÑƒÑ‚ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒÑÑ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð±Ð°Ð·Ð¾Ð²Ð¾Ð¹ Ð²Ð°Ð»ÑŽÑ‚Ñ‹',0),(539962,14999,'es','Si la importaciÃ³n para los vendedores con una moneda distinta de la moneda Base se utilizarÃ¡n tarifas automÃ¡ticas salvo que ingrese manualmente',0),(539963,14999,'de','Wenn fÃ¼r Anbieter mit einer anderen WÃ¤hrung als der WÃ¤hrung zu importieren, wie automatische Preise genutzt werden soll, sofern nicht manuell eingegeben',0),(539964,14999,'en','If Importing For Vendors With A Currency Other Than The Base Currency Automatic Rates Will Be Used Unless Manually Entered',0),(539965,15000,'is','',0),(539966,15000,'dr','Ù„Ø·ÙØ§ ØªÙ†Ø¸ÛŒÙ… Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ø±Ø² Ø­Ø³Ø§Ø¨ Ú©Ù†ÛŒØ¯ Ùˆ Ø³Ø¹ÛŒ Ú©Ù†ÛŒØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡',0),(539967,15000,'pr','Ù„Ø·ÙØ§ ØªÙ†Ø¸ÛŒÙ… Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ø±Ø² Ø­Ø³Ø§Ø¨ Ú©Ù†ÛŒØ¯ Ùˆ Ø³Ø¹ÛŒ Ú©Ù†ÛŒØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡',0),(539968,15000,'tr','LÃ¼tfen ticaret hesap ve denemek bir daha para birimi ayarla',0),(539969,15000,'pl','ProszÄ™ ustawiÄ‡ walucie handlu konto i sprÃ³buj ponownie',0),(539970,15000,'bg','ÐœÐ¾Ð»Ñ ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹Ñ‚Ðµ Ð²Ð°Ð»ÑƒÑ‚Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²Ð¸Ñ ÑÐ¼ÐµÑ‚ÐºÐ° Ð¸ Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(539971,15000,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ú©Ø±Ù†Ø³ÛŒ Ù¹Ø±ÛŒÚˆÙ†Ú¯ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§ÙˆØ± Ú©Ø±Ù†Û’ Ú©ÛŒ Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(539972,15000,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð²Ð°Ð»ÑƒÑ‚Ð° Ñ‚Ñ€Ð³Ð¾Ð²Ð°ÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½ Ð¸ Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(539973,15000,'vi','Vui lÃ²ng Ä‘áº·t má»™t loáº¡i tiá»n tá»‡ thÆ°Æ¡ng máº¡i tÃ i khoáº£n vÃ  thá»­ má»™t láº§n ná»¯a',0),(539974,15000,'af','Stel asseblief \'n valuta handel rekening en probeer weer',0),(539975,15000,'ro','VÄƒ rugÄƒm sÄƒ setaÅ£i o monedÄƒ de tranzacÅ£ionare cont ÅŸi Ã®ncercaÅ£i din nou',0),(539976,15000,'et','Palun MÃ¤Ã¤rake valuuta kauplemise konto ja proovige uuesti',0),(539977,15000,'si','Prosim nastavi valuta trgovanja raÄun in poskusite znova',0),(539978,15000,'ba','Silakan Set mata uang perdagangan Account dan mencoba lagi',0),(539979,15000,'nl','Stel een valuta Trading Account en probeer opnieuw',0),(539980,15000,'fi','Aseta valuutta kaupankÃ¤ynnin tili ja yritÃ¤ uudelleen',0),(539981,15000,'no','Angi en valuta Trading konto og prÃ¸v igjen',0),(539982,15000,'da','Angiv en valuta Trading konto og prÃ¸v igen',0),(539983,15000,'ko','ê³„ì • ë° ì‹œë„ ë‹¤ì‹œ ë¬´ì—­ í•˜ëŠ” í†µí™”ë¥¼ ì„¤ì • í•˜ì‹­ì‹œì˜¤',0),(539984,15000,'he','× × ×”×’×“×¨ ×ž×˜×‘×¢ ×”×ž×¡×—×¨ ×‘×—×©×‘×•×Ÿ ×•×œ× ×¡×•×ª ×©×•×‘',0),(539985,15000,'el','ÎŸÏÎ¯ÏƒÏ„Îµ Î­Î½Î± Î½ÏŒÎ¼Î¹ÏƒÎ¼Î± ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎºÎ±Î¹ Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(539986,15000,'zh','è¯·è®¾ç½®è´§å¸äº¤æ˜“å¸æˆ·ï¼Œè¯·è¯•ç€å†ä¸€æ¬¡',0),(539987,15000,'sv','Ange en valuta handel konto och fÃ¶rsÃ¶k igen',0),(539988,15000,'it','Si prega di impostare una moneta di scambio Account e provare nuovamente',0),(539989,15000,'tl','',0),(539990,15000,'th','à¸à¸£à¸¸à¸“à¸²à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™à¸à¸²à¸£à¸„à¹‰à¸²à¸šà¸±à¸à¸Šà¸µà¹à¸¥à¸°à¸¥à¸­à¸‡à¸­à¸µà¸à¸„à¸£à¸±à¹‰à¸‡',0),(539991,15000,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤®à¥à¤¦à¥à¤°à¤¾ à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤° à¤–à¤¾à¤¤à¥‡ à¤”à¤° à¤•à¥‹à¤¶à¤¿à¤¶ à¤«à¤¿à¤° à¤¸à¥‡ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(539992,15000,'ms','Sila Tetapkan satu Mata Wang perdagangan akaun dan cuba sekali lagi',0),(539993,15000,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ¹ÙŠÙŠÙ† Ø¹Ù…Ù„Ù‡ Ø§Ù„ØªØ¯Ø§ÙˆÙ„ ÙÙŠ Ø§Ù„Ø­Ø³Ø§Ø¨ ÙˆØ­Ø§ÙˆÙ„ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(539994,15000,'fr','S\'il vous plaÃ®t dÃ©finir une monnaie Trading compte et essayez Ã  nouveau',0),(539995,15000,'jp','ã—ã‚ˆã†ã¨ã™ã‚‹ã¨ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å†åº¦å–å¼•é€šè²¨ã‚’è¨­å®šã—ã¦ãã ã•ã„ã€‚',0),(539996,15000,'pt','Por favor, defina uma moeda de troca conta e tente novamente',0),(539997,15000,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð²Ð°Ð»ÑŽÑ‚Ñƒ Ñ‚Ð¾Ñ€Ð³Ð¾Ð²Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð¸ Ð¿Ð¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÑÐ½Ð¾Ð²Ð°',0),(539998,15000,'es','Por favor seleccione una moneda de cuenta e intente de nuevo comercio',0),(539999,15000,'de','Setzen Sie bitte einen Devisenhandel Konto und versuchen Sie es erneut',0),(540000,15000,'en','Please Set A Currency Trading Account And Try Again',0),(540001,15001,'is','',0),(540002,15001,'dr','Ù„Ø·ÙØ§ ØªØ¨Ø¯ÛŒÙ„ Ú©Ù†ÛŒØ¯ Ùˆ Ø³Ø¹ÛŒ Ú©Ù†ÛŒØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(540003,15001,'pr','Ù„Ø·ÙØ§ ØªØ¨Ø¯ÛŒÙ„ Ú©Ù†ÛŒØ¯ Ùˆ Ø³Ø¹ÛŒ Ú©Ù†ÛŒØ¯ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(540004,15001,'tr','LÃ¼tfen dÃ¶nÃ¼ÅŸtÃ¼rme ve deneyin tekrar gÃ¼ncelleme',0),(540005,15001,'pl','ProszÄ™ zaktualizowaÄ‡ konwersji i sprÃ³buj ponownie',0),(540006,15001,'bg','ÐœÐ¾Ð»Ñ, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð¸ Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(540007,15001,'ur','Ù…Ø°ÛØ¨ Ú©ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ø§ÙˆØ± Ú©Ø±Ù†Û’ Ú©ÛŒ Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº Ù¾Ú¾Ø± ØªØ§Ø²Û Ú©Ø±ÛŒÚº',0),(540008,15001,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ Ð¸ Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(540009,15001,'vi','Xin vui lÃ²ng cáº­p nháº­t chuyá»ƒn Ä‘á»•i vÃ  cá»‘ gáº¯ng má»™t láº§n ná»¯a',0),(540010,15001,'af','Asseblief opdateer omskakeling en probeer weer',0),(540011,15001,'ro','VÄƒ rugÄƒm sÄƒ actualizaÅ£i de conversie ÅŸi Ã®ncercaÅ£i din nou',0),(540012,15001,'et','Palun uuendage muundamise ja proovige uuesti',0),(540013,15001,'si','Prosimo, posodobite pretvorbe in poskusite znova',0),(540014,15001,'ba','Perbarui konversi dan coba lagi',0),(540015,15001,'nl','Please Update conversie en probeer opnieuw',0),(540016,15001,'fi','PÃ¤ivitÃ¤ muuntaminen ja yritÃ¤ uudelleen',0),(540017,15001,'no','Oppdater konvertering og prÃ¸v igjen',0),(540018,15001,'da','Opdater konvertering og prÃ¸ve igen',0),(540019,15001,'ko','ì—…ë°ì´ íŠ¸ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤ ë³€í™˜ ë° Try ë‹¤ì‹œ',0),(540020,15001,'he','×× × ×¢×“×›×Ÿ ×”×ž×¨×” ×•×œ× ×¡×•×ª ×©×•×‘',0),(540021,15001,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î®Ï‚ ÎºÎ±Î¹ Ï€ÏÎ¿ÏƒÏ€Î±Î¸Î®ÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(540022,15001,'zh','è¯·å†æ¬¡æ›´æ–°è½¬æ¢å’Œå°è¯•',0),(540023,15001,'sv','VÃ¤nligen uppdatera konvertering och fÃ¶rsÃ¶k igen',0),(540024,15001,'it','Si prega di aggiornare conversione e provare nuovamente',0),(540025,15001,'tl','',0),(540026,15001,'th','à¸à¸£à¸¸à¸“à¸²à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹à¸›à¸¥à¸‡à¹à¸¥à¸°à¸¥à¸­à¸‡à¸­à¸µà¸à¸„à¸£à¸±à¹‰à¸‡',0),(540027,15001,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤°à¥‚à¤ªà¤¾à¤‚à¤¤à¤°à¤£ à¤”à¤° à¤•à¥‹à¤¶à¤¿à¤¶ à¤•à¥‹ à¤«à¤¿à¤° à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(540028,15001,'ms','Sila kemas kini Pertukaran dan cuba sekali lagi',0),(540029,15001,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ø§Ù„ØªØ­ÙˆÙŠÙ„ ÙˆØ­Ø§ÙˆÙ„ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(540030,15001,'fr','Veuillez mettre Ã  jour Conversion et essayez Ã  nouveau',0),(540031,15001,'jp','å¤‰æ›ã¨ Try ã‚’ã‚‚ã†ä¸€åº¦æ›´æ–°ã—ã¦ãã ã•ã„ã€‚',0),(540032,15001,'pt','Por favor, atualize a conversÃ£o e tente novamente',0),(540033,15001,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¸ Ð¿Ð¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ ÑÐ½Ð¾Ð²Ð°',0),(540034,15001,'es','Por favor actualice conversiÃ³n e intente otra vez',0),(540035,15001,'de','Bitte aktualisieren Sie Konvertierung und versuchen Sie es erneut',0),(540036,15001,'en','Please Update Conversion And Try Again',0),(540037,15002,'is','',0),(540038,15002,'dr','ØªØ¹ÛŒÛŒÙ† Ù†Ø±Ø® ØªØ¨Ø¯ÛŒÙ„ Ø§Ø±Ø²',0),(540039,15002,'pr','ØªØ¹ÛŒÛŒÙ† Ù†Ø±Ø® ØªØ¨Ø¯ÛŒÙ„ Ø§Ø±Ø²',0),(540040,15002,'tr','Para birimi dÃ¶nÃ¼ÅŸtÃ¼rme oranlarÄ±nÄ± ayarlamak',0),(540041,15002,'pl','Zestaw kursÃ³w wymiany walut',0),(540042,15002,'bg','Ð—Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ ÐžÐ±Ð¼ÐµÐ½Ð½Ð¸ Ð²Ð°Ð»ÑƒÑ‚Ð½Ð¸ ÐºÑƒÑ€ÑÐ¾Ð²Ðµ',0),(540043,15002,'ur','Ú©Ø±Ù†Ø³ÛŒ Ú©ÛŒ Ø´Ø±Ø­ Ø¨Ø¯Ù„ÛŒ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(540044,15002,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ ÑÑ‚Ð¾Ð¿Ðµ ÐºÐ¾Ð½Ð²ÐµÑ€Ð·Ð¸Ñ˜Ðµ Ð²Ð°Ð»ÑƒÑ‚Ðµ',0),(540045,15002,'vi','Thiáº¿t láº­p tá»· giÃ¡ chuyá»ƒn Ä‘á»•i tiá»n tá»‡',0),(540046,15002,'af','Stel omskakeling wisselkoerse',0),(540047,15002,'ro','SetaÅ£i rate de schimb valutar',0),(540048,15002,'et','MÃ¤Ã¤ratud valuuta vahetuskurss',0),(540049,15002,'si','DoloÄi valuto menjalni teÄaji',0),(540050,15002,'ba','Mengatur tingkat konversi mata uang',0),(540051,15002,'nl','Valuta conversie ratios instellen',0),(540052,15002,'fi','MÃ¤Ã¤ritÃ¤ valuutan hinnat',0),(540053,15002,'no','Angi valutaen konverteringsfrekvenser',0),(540054,15002,'da','Angive valutakurser konvertering',0),(540055,15002,'ko','í†µí™” ì „í™˜ ë¥  ì„¤ì •',0),(540056,15002,'he','×”×’×“×¨ ×‘×©×¢×¨×™ ×”×ž×¨×” ×ž×˜×‘×¢',0),(540057,15002,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ Î½Î¿Î¼Î¹ÏƒÎ¼Î±Ï„Î¹ÎºÎ­Ï‚ Î¹ÏƒÎ¿Ï„Î¹Î¼Î¯ÎµÏ‚',0),(540058,15002,'zh','è®¾ç½®è´§å¸çš„æ¢ç®—çŽ‡',0),(540059,15002,'sv','Ange omrÃ¤kningstal',0),(540060,15002,'it','Impostare i tassi di conversione valuta',0),(540061,15002,'tl','',0),(540062,15002,'th','à¸•à¸±à¹‰à¸‡à¸­à¸±à¸•à¸£à¸²à¸à¸²à¸£à¹à¸›à¸¥à¸‡à¸ªà¸à¸¸à¸¥à¹€à¸‡à¸´à¸™',0),(540063,15002,'hi','à¤®à¥à¤¦à¥à¤°à¤¾ à¤°à¥‚à¤ªà¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¤° à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(540064,15002,'ms','Menetapkan kadar Penukaran Mata Wang',0),(540065,15002,'ar','ØªØ¹ÙŠÙŠÙ† Ø£Ø³Ø¹Ø§Ø± ØªØ­ÙˆÙŠÙ„ Ø§Ù„Ø¹Ù…Ù„Ø§Øª',0),(540066,15002,'fr','DÃ©finir le taux de Conversion de devises',0),(540067,15002,'jp','é€šè²¨ã®æ›ç®—ãƒ¬ãƒ¼ãƒˆã‚’è¨­å®šã—ã¾ã™ã€‚',0),(540068,15002,'pt','Definir taxas de conversÃ£o de moeda',0),(540069,15002,'ru','Ð—Ð°Ð´Ð°Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÑÑ‡ÐµÑ‚Ð° Ð²Ð°Ð»ÑŽÑ‚',0),(540070,15002,'es','Fijar las tasas de conversiÃ³n de moneda',0),(540071,15002,'de','Set Currency Conversion-Raten',0),(540072,15002,'en','Set Currency Conversion Rates',0),(540073,15003,'is','',0),(540074,15003,'dr','Ù„ÛŒØ³Øª Ø¯Ø± eBay',0),(540075,15003,'pr','Ù„ÛŒØ³Øª Ø¯Ø± eBay',0),(540076,15003,'tr','EBay liste Ã¼zerinde',0),(540077,15003,'pl','Lista na eBay',0),(540078,15003,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð½Ð° eBay',0),(540079,15003,'ur','ÙÛØ±Ø³Øª Ù¾Ø± Ø§ÛŒ Ø¨Û’',0),(540080,15003,'sr','Ð›Ð¸ÑÑ‚Ð° Ð½Ð° ÐµÐ‘Ð°yÑƒ',0),(540081,15003,'vi','Danh sÃ¡ch trÃªn eBay',0),(540082,15003,'af','Lys op eBay',0),(540083,15003,'ro','Lista de pe eBay',0),(540084,15003,'et','Nimekiri eBay',0),(540085,15003,'si','Seznam na eBay',0),(540086,15003,'ba','Daftar di eBay',0),(540087,15003,'nl','Lijst op eBay',0),(540088,15003,'fi','Luettelo eBay',0),(540089,15003,'no','Listen pÃ¥ eBay',0),(540090,15003,'da','Listen pÃ¥ eBay',0),(540091,15003,'ko','EBayì— ëª©ë¡',0),(540092,15003,'he','×”×¨×©×™×ž×” ×‘- eBay',0),(540093,15003,'el','Î›Î¯ÏƒÏ„Î± ÏƒÎµ eBay',0),(540094,15003,'zh','åˆ—è¡¨ä¸Š eBay',0),(540095,15003,'sv','Lista pÃ¥ eBay',0),(540096,15003,'it','Lista su eBay',0),(540097,15003,'tl','',0),(540098,15003,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸™ eBay',0),(540099,15003,'hi','EBay à¤ªà¤° à¤¸à¥‚à¤šà¥€',0),(540100,15003,'ms','Senarai di eBay',0),(540101,15003,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¹Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ Ø¦ÙŠ Ø¨Ø£ÙŠ',0),(540102,15003,'fr','Liste sur eBay',0),(540103,15003,'jp','EBay ãƒªã‚¹ãƒˆã§',0),(540104,15003,'pt','Lista em eBay',0),(540105,15003,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð½Ð° eBay',0),(540106,15003,'es','Lista de eBay',0),(540107,15003,'de','Liste auf eBay',0),(540108,15003,'en','List On eBay',0),(540109,15004,'is','',0),(540110,15004,'dr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÛŒØ¯ Ø¬Ø¯ÛŒØ¯',0),(540111,15004,'pr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÛŒØ¯ Ø¬Ø¯ÛŒØ¯',0),(540112,15004,'tr','Yeni satÄ±nalma teklifi',0),(540113,15004,'pl','Nowa propozycja zakupu',0),(540114,15004,'bg','ÐÐ¾Ð²Ð¾ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(540115,15004,'ur','Ù†Ø¦ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ¬ÙˆÛŒØ²',0),(540116,15004,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð³ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(540117,15004,'vi','Äá» nghá»‹ mua má»›i',0),(540118,15004,'af','Nuwe aankoop voorstel',0),(540119,15004,'ro','Noua propunere de cumpÄƒrare',0),(540120,15004,'et','Uue ostutellimuse ettepaneku',0),(540121,15004,'si','Nov predlog za nakup',0),(540122,15004,'ba','Baru Proposal pembelian',0),(540123,15004,'nl','Nieuwe aankoop voorstel',0),(540124,15004,'fi','Uusi hankinta ehdotus',0),(540125,15004,'no','Nytt KjÃ¸p forslag',0),(540126,15004,'da','Nye kÃ¸b forslag',0),(540127,15004,'ko','ìƒˆë¡œìš´ êµ¬ë§¤ ì œì•ˆ',0),(540128,15004,'he','×”×¦×¢×ª ×”×¨×›×© ×”×—×“×©',0),(540129,15004,'el','ÎÎ­Î± Ï€ÏÏŒÏ„Î±ÏƒÎ· Î±Î³Î¿ÏÎ¬Ï‚',0),(540130,15004,'zh','æ–°çš„è´­ä¹°å»ºè®®',0),(540131,15004,'sv','Nya kÃ¶p fÃ¶rslag',0),(540132,15004,'it','Nuova proposta di acquisto',0),(540133,15004,'tl','',0),(540134,15004,'th','à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­à¸à¸²à¸£à¸‹à¸·à¹‰à¸­à¹ƒà¸«à¸¡à¹ˆ',0),(540135,15004,'hi','à¤¨à¤ˆ à¤–à¤°à¥€à¤¦ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ',0),(540136,15004,'ms','Baru cadangan pembelian',0),(540137,15004,'ar','Ø§Ù‚ØªØ±Ø§Ø­ Ø´Ø±Ø§Ø¡ Ø¬Ø¯ÙŠØ¯',0),(540138,15004,'fr','Nouvelle proposition d\'achat',0),(540139,15004,'jp','æ–°ã—ã„è³¼å…¥ã®ææ¡ˆ',0),(540140,15004,'pt','Nova proposta de compra',0),(540141,15004,'ru','ÐÐ¾Ð²Ð¾Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(540142,15004,'es','Nueva propuesta de compra',0),(540143,15004,'de','Neue Kauf-Vorschlag',0),(540144,15004,'en','New Purchase Proposal',0),(540145,15005,'is','',0),(540146,15005,'dr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÛŒØ¯',0),(540147,15005,'pr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÛŒØ¯',0),(540148,15005,'tr','SatÄ±nalma teklifi',0),(540149,15005,'pl','Propozycji kupna',0),(540150,15005,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(540151,15005,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ¬ÙˆÛŒØ²',0),(540152,15005,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð³ Ð·Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(540153,15005,'vi','Äá» nghá»‹ mua',0),(540154,15005,'af','Aankoop voorstel',0),(540155,15005,'ro','Propunere de cumpÄƒrare',0),(540156,15005,'et','Ostu ettepaneku',0),(540157,15005,'si','Nakup predlog',0),(540158,15005,'ba','Proposal pembelian',0),(540159,15005,'nl','Aankoop voorstel',0),(540160,15005,'fi','Osto ehdotuksen',0),(540161,15005,'no','KjÃ¸p forslag',0),(540162,15005,'da','KÃ¸b forslag',0),(540163,15005,'ko','êµ¬ë§¤ ì œì•ˆ',0),(540164,15005,'he','×”×¦×¢×ª ×¨×›×©',0),(540165,15005,'el','Î ÏÏŒÏ„Î±ÏƒÎ· Î±Î³Î¿ÏÎ¬Ï‚',0),(540166,15005,'zh','è´­ä¹°å»ºè®®',0),(540167,15005,'sv','KÃ¶p fÃ¶rslag',0),(540168,15005,'it','Proposta di acquisto',0),(540169,15005,'tl','',0),(540170,15005,'th','à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­à¸‹à¸·à¹‰à¸­',0),(540171,15005,'hi','à¤–à¤°à¥€à¤¦ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ',0),(540172,15005,'ms','Cadangan pembelian',0),(540173,15005,'ar','Ø§Ù‚ØªØ±Ø§Ø­ Ø´Ø±Ø§Ø¡',0),(540174,15005,'fr','Proposition d\'achat',0),(540175,15005,'jp','è³¼å…¥ã®ææ¡ˆ',0),(540176,15005,'pt','Proposta de compra',0),(540177,15005,'ru','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(540178,15005,'es','Propuesta de compra',0),(540179,15005,'de','Kauf-Vorschlag',0),(540180,15005,'en','Purchase Proposal',0),(540181,15006,'is','',0),(540182,15006,'dr','Ø°Ø®ÛŒØ±Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯',0),(540183,15006,'pr','Ø°Ø®ÛŒØ±Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯',0),(540184,15006,'tr','Teklif olarak kaydet',0),(540185,15006,'pl','Zapisz jako wniosek',0),(540186,15006,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ ÐºÐ°Ñ‚Ð¾ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(540187,15006,'ur','ØªØ¬ÙˆÛŒØ² Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(540188,15006,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ ÐºÐ°Ð¾ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð³',0),(540189,15006,'vi','Tiáº¿t kiá»‡m nhÆ° Ä‘á» nghá»‹',0),(540190,15006,'af','Stoor As voorstel',0),(540191,15006,'ro','Salvare ca propunerea',0),(540192,15006,'et','Kui ettepanek',0),(540193,15006,'si','Shrani kot predlog',0),(540194,15006,'ba','Simpan sebagai Proposal',0),(540195,15006,'nl','Opslaan als voorstel',0),(540196,15006,'fi','Tallenna ehdotus',0),(540197,15006,'no','Lagre som forslag',0),(540198,15006,'da','Gemme som forslag',0),(540199,15006,'ko','ì œì•ˆì„œë¡œ ì €ìž¥',0),(540200,15006,'he','×©×ž×•×¨ ××ª ×”×”×¦×¢×”',0),(540201,15006,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï‰Ï‚ Ï€ÏÏŒÏ„Î±ÏƒÎ·',0),(540202,15006,'zh','å¦å­˜ä¸ºçš„å»ºè®®',0),(540203,15006,'sv','Spara som fÃ¶rslag',0),(540204,15006,'it','Salvare come proposta',0),(540205,15006,'tl','',0),(540206,15006,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸›à¹‡à¸™à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­',0),(540207,15006,'hi','à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(540208,15006,'ms','Simpan sebagai cadangan',0),(540209,15006,'ar','Ø­ÙØ¸ ÙƒØ§Ù‚ØªØ±Ø§Ø­',0),(540210,15006,'fr','Enregistrer en tant que proposition',0),(540211,15006,'jp','ææ¡ˆã¨ã—ã¦ä¿å­˜ã—ã¾ã™ã€‚',0),(540212,15006,'pt','Salve como proposta',0),(540213,15006,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ ÐºÐ°Ðº Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(540214,15006,'es','Guardar como propuesta',0),(540215,15006,'de','Speichern als Vorschlag',0),(540216,15006,'en','Save As Proposal',0),(540217,15007,'is','',0),(540218,15007,'dr','ÙÙ‡Ø±Ø³Øª Ø®Ø±ÛŒØ¯ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ',0),(540219,15007,'pr','ÙÙ‡Ø±Ø³Øª Ø®Ø±ÛŒØ¯ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ÛŒ',0),(540220,15007,'tr','SatÄ±nalma teklifi denetim listesi',0),(540221,15007,'pl','Lista kontrolna propozycjÄ™ zakupu',0),(540222,15007,'bg','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÐµÐ½ ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(540223,15007,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ¬ÙˆÛŒØ² Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(540224,15007,'sr','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ð° Ð»Ð¸ÑÑ‚Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð³',0),(540225,15007,'vi','Mua Ä‘á» nghá»‹ danh sÃ¡ch kiá»ƒm tra',0),(540226,15007,'af','Aankoop voorstel Kontrolelys',0),(540227,15007,'ro','AchiziÅ£ie propunerea de verificare',0),(540228,15007,'et','Ostu ettepaneku Meelespea',0),(540229,15007,'si','Kontrolni seznam predlog za nakup',0),(540230,15007,'ba','Pembelian Proposal Checklist',0),(540231,15007,'nl','Aankoop voorstel Checklist',0),(540232,15007,'fi','Osto ehdotuksen tarkistuslista',0),(540233,15007,'no','KjÃ¸p forslag sjekkliste',0),(540234,15007,'da','KÃ¸b forslag tjekliste',0),(540235,15007,'ko','êµ¬ë§¤ ì œì•ˆ ê²€ì‚¬ ëª©ë¡',0),(540236,15007,'he','×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢ ×”×¦×¢×ª ×¨×›×©',0),(540237,15007,'el','Î›Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… Ï€ÏÏŒÏ„Î±ÏƒÎ· Î±Î³Î¿ÏÎ¬Ï‚',0),(540238,15007,'zh','è´­ä¹°å»ºè®®æ¸…å•',0),(540239,15007,'sv','KÃ¶p fÃ¶rslag checklista',0),(540240,15007,'it','Checklist di proposta di acquisto',0),(540241,15007,'tl','',0),(540242,15007,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­à¸‹à¸·à¹‰à¸­',0),(540243,15007,'hi','à¤–à¤°à¥€à¤¦ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ',0),(540244,15007,'ms','Senarai semak permohonan pembelian',0),(540245,15007,'ar','Ø´Ø±Ø§Ø¡ Ø§Ù‚ØªØ±Ø§Ø­ Ù…Ø±Ø¬Ø¹ÙŠØ©',0),(540246,15007,'fr','Liste de proposition d\'achat',0),(540247,15007,'jp','è³¼å…¥ææ¡ˆãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆ',0),(540248,15007,'pt','Lista de verificaÃ§Ã£o proposta de compra',0),(540249,15007,'ru','ÐšÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(540250,15007,'es','Lista propuesta de compra',0),(540251,15007,'de','Kauf Vorschlag Checkliste',0),(540252,15007,'en','Purchase Proposal Checklist',0),(540253,15008,'is','',0),(540254,15008,'dr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯',0),(540255,15008,'pr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯',0),(540256,15008,'tr','Ã–neri',0),(540257,15008,'pl','Wniosek',0),(540258,15008,'bg','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(540259,15008,'ur','ØªØ¬ÙˆÛŒØ²',0),(540260,15008,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð³',0),(540261,15008,'vi','Äá» nghá»‹',0),(540262,15008,'af','Voorstel',0),(540263,15008,'ro','Propunere',0),(540264,15008,'et','Ettepaneku',0),(540265,15008,'si','Predlog',0),(540266,15008,'ba','Proposal',0),(540267,15008,'nl','Voorstel',0),(540268,15008,'fi','Ehdotuksen',0),(540269,15008,'no','Forslag',0),(540270,15008,'da','Forslag',0),(540271,15008,'ko','ì œì•ˆ',0),(540272,15008,'he','×”×”×¦×¢×”',0),(540273,15008,'el','Î ÏÏŒÏ„Î±ÏƒÎ·',0),(540274,15008,'zh','å»ºè®®',0),(540275,15008,'sv','FÃ¶rslag',0),(540276,15008,'it','Proposta',0),(540277,15008,'tl','',0),(540278,15008,'th','à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­',0),(540279,15008,'hi','à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ',0),(540280,15008,'ms','Cadangan',0),(540281,15008,'ar','Ø§Ù‚ØªØ±Ø§Ø­',0),(540282,15008,'fr','Proposition',0),(540283,15008,'jp','ææ¡ˆ',0),(540284,15008,'pt','Proposta',0),(540285,15008,'ru','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(540286,15008,'es','Propuesta',0),(540287,15008,'de','Vorschlag',0),(540288,15008,'en','Proposal',0),(540289,15009,'is','',0),(540290,15009,'dr','Ù†Ù…Ø§ÛŒØ´ Ø·Ø±Ø­',0),(540291,15009,'pr','Ù†Ù…Ø§ÛŒØ´ Ø·Ø±Ø­',0),(540292,15009,'tr','Ã–nerileri gÃ¶ster',0),(540293,15009,'pl','PokaÅ¼ propozycje',0),(540294,15009,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(540295,15009,'ur','ØªØ¬Ø§ÙˆÛŒØ² Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(540296,15009,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð³Ðµ',0),(540297,15009,'vi','Hiá»ƒn thá»‹ Ä‘á» xuáº¥t',0),(540298,15009,'af','Wys voorstelle',0),(540299,15009,'ro','AratÄƒ propuneri',0),(540300,15009,'et','NÃ¤ita ettepanekud',0),(540301,15009,'si','PokaÅ¾i predloge',0),(540302,15009,'ba','Menunjukkan proposal',0),(540303,15009,'nl','Toon voorstellen',0),(540304,15009,'fi','NÃ¤ytÃ¤ ehdotukset',0),(540305,15009,'no','Vis forslag',0),(540306,15009,'da','Vis forslag',0),(540307,15009,'ko','ê³µì—° ì œì•ˆ',0),(540308,15009,'he','×”×¦×’ ×”×¦×¢×•×ª',0),(540309,15009,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€ÏÎ¿Ï„Î¬ÏƒÎµÎ¹Ï‚',0),(540310,15009,'zh','æ˜¾ç¤ºå»ºè®®',0),(540311,15009,'sv','Visa fÃ¶rslag',0),(540312,15009,'it','Visualizza le proposte',0),(540313,15009,'tl','',0),(540314,15009,'th','à¹à¸ªà¸”à¸‡à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­',0),(540315,15009,'hi','à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µà¥‹à¤‚ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(540316,15009,'ms','Menunjukkan cadangan-cadangan',0),(540317,15009,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø§Ù‚ØªØ±Ø§Ø­Ø§Øª',0),(540318,15009,'fr','Voir l\'Ã©tablissement de propositions',0),(540319,15009,'jp','ã‚·ãƒ§ãƒ¼ã®ææ¡ˆ',0),(540320,15009,'pt','Visualizar propostas',0),(540321,15009,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(540322,15009,'es','Mostrar propuestas',0),(540323,15009,'de','VorschlÃ¤ge anzeigen',0),(540324,15009,'en','Show Proposals',0),(540325,15010,'is','',0),(540326,15010,'dr','ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯',0),(540327,15010,'pr','ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯',0),(540328,15010,'tr','Teklife dÃ¶nÃ¼ÅŸtÃ¼rÃ¼n',0),(540329,15010,'pl','Konwersja do wniosku',0),(540330,15010,'bg','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð² Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(540331,15010,'ur','ØªØ¬ÙˆÛŒØ² Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ø¨Ø¯Ù„ÛŒÚº',0),(540332,15010,'sr','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚ÑƒÑ˜ Ñƒ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð³Ñƒ',0),(540333,15010,'vi','Chuyá»ƒn Ä‘á»•i Ä‘á»ƒ Ä‘á» nghá»‹',0),(540334,15010,'af','Omskep voorstel',0),(540335,15010,'ro','Conversia la propunerea',0),(540336,15010,'et','Ettepanek muuta',0),(540337,15010,'si','Pretvori v predlog',0),(540338,15010,'ba','Mengkonversi ke Proposal',0),(540339,15010,'nl','Converteren naar voorstel',0),(540340,15010,'fi','Muuntaa ehdotuksen',0),(540341,15010,'no','Konvertere til forslag',0),(540342,15010,'da','Konvertere til forslag',0),(540343,15010,'ko','ì œì•ˆ ë³€í™˜',0),(540344,15010,'he','×œ×”×ž×™×¨ ××ª ×”×”×¦×¢×”',0),(540345,15010,'el','ÎœÎµÏ„Î±Ï„ÏÎ¿Ï€Î® ÏƒÎµ Ï€ÏÏŒÏ„Î±ÏƒÎ·',0),(540346,15010,'zh','è½¬æ¢çš„å»ºè®®',0),(540347,15010,'sv','Konvertera till fÃ¶rslaget',0),(540348,15010,'it','Convertire in proposta',0),(540349,15010,'tl','',0),(540350,15010,'th','à¹à¸›à¸¥à¸‡à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­',0),(540351,15010,'hi','à¤•à¤¨à¥à¤µà¤°à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ',0),(540352,15010,'ms','Menukar kepada cadangan',0),(540353,15010,'ar','ØªØ­ÙˆÙŠÙ„ Ø¥Ù„Ù‰ Ø§Ù‚ØªØ±Ø§Ø­',0),(540354,15010,'fr','Convertir en proposition',0),(540355,15010,'jp','ææ¡ˆã¸ã®å¤‰æ›ã—ã¾ã™ã€‚',0),(540356,15010,'pt','Converter a proposta',0),(540357,15010,'ru','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ Ð² Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(540358,15010,'es','Convertir a propuesta',0),(540359,15010,'de','Konvertieren des Vorschlags',0),(540360,15010,'en','Convert To Proposal',0),(540361,15011,'is','',0),(540362,15011,'dr','ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(540363,15011,'pr','ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(540364,15011,'tr','SatÄ±nalma sipariÅŸi iÃ§in DÃ¶nÃ¼ÅŸtÃ¼r',0),(540365,15011,'pl','Konwertuj na zamÃ³wienie zakupu',0),(540366,15011,'bg','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ Ð² Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(540367,15011,'ur','ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ø®Ø±ÛŒØ¯Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…ÛŒÚº Ø¨Ø¯Ù„ÛŒÚº',0),(540368,15011,'sr','ÐšÐ¾Ð½Ð²ÐµÑ€Ñ‚Ð¾Ð²Ð°Ñ‚Ð¸ Ñƒ Ð¸Ð·Ð»Ð°Ð·Ð½Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(540369,15011,'vi','Chuyá»ƒn Ä‘á»•i Ä‘á»ƒ mua hÃ ng',0),(540370,15011,'af','Omskep om orde te koop',0),(540371,15011,'ro','Conversie Ã®n comandÄƒ cumpÄƒrare',0),(540372,15011,'et','Teisendage ostutellimuste',0),(540373,15011,'si','Pretvori v nabavni nalog',0),(540374,15011,'ba','Mengkonversi ke Order Pembelian',0),(540375,15011,'nl','Converteren naar inkooporder',0),(540376,15011,'fi','Muuntaa ostotilaus',0),(540377,15011,'no','Konverter til bestilling',0),(540378,15011,'da','Konverter til indkÃ¸bsordre',0),(540379,15011,'ko','êµ¬ë§¤ ì£¼ë¬¸ìœ¼ë¡œ ë³€í™˜',0),(540380,15011,'he','×”×ž×¨×ª ×”×–×ž× ×ª ×¨×›×©',0),(540381,15011,'el','ÎœÎµÏ„Î±Ï„ÏÎ¿Ï€Î® ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(540382,15011,'zh','è½¬æ¢ä¸ºé‡‡è´­è®¢å•',0),(540383,15011,'sv','Konvertera till inkÃ¶psorder',0),(540384,15011,'it','Converti in ordine di acquisto',0),(540385,15011,'tl','',0),(540386,15011,'th','à¹à¸›à¸¥à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(540387,15011,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¨à¤µà¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(540388,15011,'ms','Tukar kepada pesanan pembelian',0),(540389,15011,'ar','ØªØ­ÙˆÙŠÙ„ Ø¥Ù„Ù‰ Ø£Ù…Ø± Ø´Ø±Ø§Ø¡',0),(540390,15011,'fr','Converti au bon de commande',0),(540391,15011,'jp','ç™ºæ³¨æ›¸ã«å¤‰æ›ã—ã¾ã™ã€‚',0),(540392,15011,'pt','Converter a ordem de compra',0),(540393,15011,'ru','ÐŸÑ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ Ð² Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(540394,15011,'es','Convertir a la orden de compra',0),(540395,15011,'de','Konvertieren, um die Bestellung',0),(540396,15011,'en','Convert To Purchase Order',0),(540397,15012,'is','',0),(540398,15012,'dr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÛŒØ¯ ÙˆÛŒØ±Ø§ÛŒØ´',0),(540399,15012,'pr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÛŒØ¯ ÙˆÛŒØ±Ø§ÛŒØ´',0),(540400,15012,'tr','SatÄ±nalma teklifi dÃ¼zenle',0),(540401,15012,'pl','Edytuj propozycji kupna',0),(540402,15012,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(540403,15012,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ¬ÙˆÛŒØ² Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(540404,15012,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð³',0),(540405,15012,'vi','Chá»‰nh sá»­a Ä‘á» nghá»‹ mua',0),(540406,15012,'af','Redigeer aankoop voorstel',0),(540407,15012,'ro','Editare propunerea de cumpÄƒrare',0),(540408,15012,'et','Redigeeri ostu ettepaneku',0),(540409,15012,'si','Uredi nakup predlog',0),(540410,15012,'ba','Mengedit Proposal pembelian',0),(540411,15012,'nl','Aankoop voorstel bewerken',0),(540412,15012,'fi','Muokkaa osto ehdotusta',0),(540413,15012,'no','Redigere KjÃ¸p forslag',0),(540414,15012,'da','Redigere KÃ¸b forslag',0),(540415,15012,'ko','êµ¬ë§¤ ì œì•ˆ íŽ¸ì§‘',0),(540416,15012,'he','×¢×¨×™×›×ª ×”×¦×¢×ª ×¨×›×©',0),(540417,15012,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î·Î½ Ï€ÏÏŒÏ„Î±ÏƒÎ· Î±Î³Î¿ÏÎ¬Ï‚',0),(540418,15012,'zh','ç¼–è¾‘é‡‡è´­æ–¹æ¡ˆ',0),(540419,15012,'sv','Redigera kÃ¶p fÃ¶rslag',0),(540420,15012,'it','Modificare la proposta di acquisto',0),(540421,15012,'tl','',0),(540422,15012,'th','à¹à¸à¹‰à¹„à¸‚à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­à¸‹à¸·à¹‰à¸­',0),(540423,15012,'hi','à¤–à¤°à¥€à¤¦ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(540424,15012,'ms','Edit cadangan pembelian',0),(540425,15012,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù‚ØªØ±Ø§Ø­ Ø´Ø±Ø§Ø¡',0),(540426,15012,'fr','Modifier la proposition d\'achat',0),(540427,15012,'jp','è³¼å…¥ææ¡ˆã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(540428,15012,'pt','Editar proposta de compra',0),(540429,15012,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(540430,15012,'es','Modificar la propuesta de compra',0),(540431,15012,'de','Bearbeiten von Kauf-Vorschlag',0),(540432,15012,'en','Edit Purchase Proposal',0),(540433,15013,'is','',0),(540434,15013,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ ÛŒÚ© Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯',0),(540435,15013,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ ØªØ¨Ø¯ÛŒÙ„ Ø¨Ù‡ ÛŒÚ© Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯',0),(540436,15013,'tr','SatÄ±nalma sipariÅŸi bir Ã¶neriyi dÃ¶nÃ¼ÅŸtÃ¼rÃ¼lÃ¼r',0),(540437,15013,'pl','ZamÃ³wienie zakupu, konwertowane na wniosek',0),(540438,15013,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°, Ð¿Ñ€ÐµÐ²Ñ€ÑŠÑ‰Ð° Ð² Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(540439,15013,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Ùˆ Ø§ÛŒÚ© ØªØ¬ÙˆÛŒØ² Ú©Ùˆ Ø¨Ø¯Ù„ Ø¯ÛŒØ§ Û”',0),(540440,15013,'sr','ÐŸÐ¾Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ð° ÐºÐ¾Ð½Ð²ÐµÑ€Ñ‚ÑƒÑ˜Ñƒ Ñƒ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð³',0),(540441,15013,'vi','Mua hÃ ng chuyá»ƒn Ä‘á»•i sang má»™t Ä‘á» nghá»‹',0),(540442,15013,'af','Koop bestelling-omskep na \'n voorstel',0),(540443,15013,'ro','ComandÄƒ cumpÄƒrare, convertit la o propunere',0),(540444,15013,'et','Ostutellimuse teisendatakse ettepaneku',0),(540445,15013,'si','Nabavni nalog, ki se pretvori v predlog',0),(540446,15013,'ba','Order Pembelian dikonversi proposal',0),(540447,15013,'nl','Inkooporder geconverteerd naar een voorstel',0),(540448,15013,'fi','Ostotilaus muunnetaan ehdotuksen',0),(540449,15013,'no','Bestilling konverteres til et forslag',0),(540450,15013,'da','IndkÃ¸bsordren konverteret til et forslag',0),(540451,15013,'ko','êµ¬ë§¤ ì£¼ë¬¸ ì œì•ˆì— ë³€í™˜',0),(540452,15013,'he','×›×“×™ ×œ×”×ž×™×¨ ×”×¦×¢×” ×œ×¨×›×•×©',0),(540453,15013,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚, Î¼ÎµÏ„Î±Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ ÏƒÎµ Î¼Î¹Î± Ï€ÏÏŒÏ„Î±ÏƒÎ·',0),(540454,15013,'zh','é‡‡è´­è®¢å•è½¬æ¢ä¸ºä¸€ä¸ªå»ºè®®',0),(540455,15013,'sv','InkÃ¶psordern konverteras till ett fÃ¶rslag',0),(540456,15013,'it','Ordine convertito in una proposta di acquisto',0),(540457,15013,'tl','',0),(540458,15013,'th','à¹à¸›à¸¥à¸‡à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(540459,15013,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤',0),(540460,15013,'ms','Pembelian perintah ditukar kepada cadangan',0),(540461,15013,'ar','Ø£Ù…Ø± ØªØ­ÙˆÙŠÙ„ Ø¥Ù„Ù‰ Ø§Ù‚ØªØ±Ø§Ø­ Ø´Ø±Ø§Ø¡',0),(540462,15013,'fr','Bon de commande converti Ã  une proposition',0),(540463,15013,'jp','è³¼è²·ç™ºæ³¨ææ¡ˆã«å¤‰æ›',0),(540464,15013,'pt','Convertido em uma proposta de ordem de compra',0),(540465,15013,'ru','Ð—Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ, Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ð½Ñ‹ Ð² Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(540466,15013,'es','Convertido en una propuesta de orden de compra',0),(540467,15013,'de','Bestellung konvertiert zu einem Vorschlag',0),(540468,15013,'en','Purchase Order Converted To A Proposal',0),(540469,15014,'is','',0),(540470,15014,'dr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÛŒØ¯ Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± ØªØ¨Ø¯ÛŒÙ„',0),(540471,15014,'pr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÛŒØ¯ Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± ØªØ¨Ø¯ÛŒÙ„',0),(540472,15014,'tr','SatÄ±nalma teklifi sipariÅŸe dÃ¶nÃ¼ÅŸtÃ¼rÃ¼lÃ¼r',0),(540473,15014,'pl','Propozycja zakupu konwertowane na zamÃ³wienie',0),(540474,15014,'bg','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ, Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½ Ð² Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(540475,15014,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ¬ÙˆÛŒØ² Ø§ÛŒÚ© Ø­Ú©Ù… Ú©Ùˆ Ø¨Ø¯Ù„ Ø³Ú©ØªØ§ ÛÛ’ Û”',0),(540476,15014,'sr','ÐÐ°Ð±Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð³ Ð¿Ñ€ÐµÑ‚Ð²Ð¾Ñ€ÐµÐ½ Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(540477,15014,'vi','Mua Ä‘á» nghá»‹ chuyá»ƒn Ä‘á»•i sang má»™t Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(540478,15014,'af','Koop voorstel omgeskakel na \'n bevel',0),(540479,15014,'ro','Propunerea convertit la o comandÄƒ de cumpÄƒrare',0),(540480,15014,'et','Ostu ettepaneku tellimuseks teisendada',0),(540481,15014,'si','Nakup predlog pretvoriti v nalog',0),(540482,15014,'ba','Proposal pembelian dikonversi ke perintah',0),(540483,15014,'nl','Aankoop voorstel omgezet in een Order',0),(540484,15014,'fi','Ostaa ehdotuksen muuntaa tilaukseksi',0),(540485,15014,'no','KjÃ¸pe forslaget konverteres til en bestilling',0),(540486,15014,'da','KÃ¸b forslag konverteres til en ordre',0),(540487,15014,'ko','êµ¬ë§¤ ì£¼ë¬¸ìœ¼ë¡œ ë³€í™˜ í•˜ëŠ” ì œì•ˆ',0),(540488,15014,'he','×”×¦×¢×ª ×¨×›×© ×œ×”×ž×™×¨ ×¦×•',0),(540489,15014,'el','Î ÏÏŒÏ„Î±ÏƒÎ· Î±Î³Î¿ÏÎ¬Ï‚, Î¼ÎµÏ„Î±Ï„ÏÎ¿Ï€Î® ÏƒÎµ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(540490,15014,'zh','è´­ä¹°å»ºè®®è½¬æ¢ä¸ºè®¢å•',0),(540491,15014,'sv','KÃ¶p fÃ¶rslag konverteras till en Order',0),(540492,15014,'it','Proposta di acquisto convertito in un ordine',0),(540493,15014,'tl','',0),(540494,15014,'th','à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­à¸‹à¸·à¹‰à¸­à¸—à¸µà¹ˆà¹à¸›à¸¥à¸‡à¹€à¸›à¹‡à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(540495,15014,'hi','à¤–à¤°à¥€à¤¦ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤†à¤¦à¥‡à¤¶ à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤',0),(540496,15014,'ms','Cadangan pembelian yang ditukar kepada suatu perintah',0),(540497,15014,'ar','Ø§Ù‚ØªØ±Ø§Ø­ ØªØ­ÙˆÙŠÙ„Ù‡Ø§ Ø¥Ù„Ù‰ Ø£Ù…Ø± Ø´Ø±Ø§Ø¡',0),(540498,15014,'fr','Proposition d\'achat convertie Ã  une ordonnance',0),(540499,15014,'jp','è³¼å…¥ææ¡ˆã‚’å—æ³¨ã«å¤‰æ›',0),(540500,15014,'pt','Proposta de compra, convertida em uma ordem',0),(540501,15014,'ru','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ñ€ÐµÐ¾Ð±Ñ€Ð°Ð·Ð¾Ð²Ð°Ñ‚ÑŒ Ð² Ð·Ð°ÐºÐ°Ð·',0),(540502,15014,'es','Propuesta de convertir a una orden de compra',0),(540503,15014,'de','Kauf-Vorschlag in eine Bestellung umgewandelt',0),(540504,15014,'en','Purchase Proposal Converted To An Order',0),(540505,15015,'is','',0),(540506,15015,'dr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÛŒØ¯ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(540507,15015,'pr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÛŒØ¯ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(540508,15015,'tr','SatÄ±nalma teklifi gÃ¼ncelleÅŸtirme',0),(540509,15015,'pl','Aktualizacja propozycji kupna',0),(540510,15015,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸ÐµÑ‚Ð¾',0),(540511,15015,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ¬ÙˆÛŒØ² Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(540512,15015,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð³',0),(540513,15015,'vi','Cáº­p Nháº­t Ä‘á» nghá»‹ mua',0),(540514,15015,'af','Bywerking aankoop voorstel',0),(540515,15015,'ro','Propunere de cumpÄƒrare actualizare',0),(540516,15015,'et','Uuenda ostu ettepaneku',0),(540517,15015,'si','Posodobitev nakup predlog',0),(540518,15015,'ba','Memperbarui Proposal pembelian',0),(540519,15015,'nl','Aankoop voorstel bijwerken',0),(540520,15015,'fi','PÃ¤ivitÃ¤ osto ehdotuksen',0),(540521,15015,'no','Oppdatere KjÃ¸p forslag',0),(540522,15015,'da','Opdater KÃ¸b forslag',0),(540523,15015,'ko','ì—…ë°ì´íŠ¸ êµ¬ë§¤ ì œì•ˆ',0),(540524,15015,'he','×¢×“×›×Ÿ ×”×¦×¢×ª ×¨×›×©',0),(540525,15015,'el','Î ÏÏŒÏ„Î±ÏƒÎ· Î±Î³Î¿ÏÎ¬Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(540526,15015,'zh','æ›´æ–°é‡‡è´­å»ºè®®',0),(540527,15015,'sv','Uppdatera kÃ¶p fÃ¶rslag',0),(540528,15015,'it','Proposta di acquisto di aggiornamento',0),(540529,15015,'tl','',0),(540530,15015,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­à¸‹à¸·à¹‰à¸­',0),(540531,15015,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤–à¤°à¥€à¤¦ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µ',0),(540532,15015,'ms','Kemaskini Terakhir cadangan pembelian',0),(540533,15015,'ar','Ø§Ù‚ØªØ±Ø§Ø­ Ø´Ø±Ø§Ø¡ Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(540534,15015,'fr','Proposition d\'achat de mise Ã  jour',0),(540535,15015,'jp','æ›´æ–°ã®è³¼å…¥ã®ææ¡ˆ',0),(540536,15015,'pt','Proposta de compra de atualizaÃ§Ã£o',0),(540537,15015,'ru','ÐžÐ±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(540538,15015,'es','Propuesta de compra de actualizaciÃ³n',0),(540539,15015,'de','Update kaufen-Vorschlag',0),(540540,15015,'en','Update Purchase Proposal',0),(540541,15016,'is','',0),(540542,15016,'dr','Ø¬Ø³ØªØ¬Ùˆ Ø¢Ú¯Ù‡ÛŒ',0),(540543,15016,'pr','Ø¬Ø³ØªØ¬Ùˆ Ø¢Ú¯Ù‡ÛŒ',0),(540544,15016,'tr','Arama Ä°pucu',0),(540545,15016,'pl','Szukaj prowadzi',0),(540546,15016,'bg','Ð¢ÑŠÑ€ÑÐµÐ½Ðµ Ð²Ð¾Ð´Ð¸',0),(540547,15016,'ur','ØªÙ„Ø§Ø´ Ú©ÛŒ Ù‚ÛŒØ§Ø¯Øª Ú©Ø±ØªØ§ ÛÛ’',0),(540548,15016,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ‚ÐµÐ½Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸Ñ… ÐºÐ»Ð¸Ñ˜ÐµÐ½Ð°Ñ‚Ð°',0),(540549,15016,'vi','TÃ¬m dáº«n',0),(540550,15016,'af','Soektog lei',0),(540551,15016,'ro','CÄƒutaÅ£i conduce',0),(540552,15016,'et','Otsing viib',0),(540553,15016,'si','Iskanje vodi',0),(540554,15016,'ba','Cari mengarah',0),(540555,15016,'nl','Zoek Leads',0),(540556,15016,'fi','Etsi johtaa',0),(540557,15016,'no','SÃ¸k fÃ¸rer',0),(540558,15016,'da','SÃ¸g efter kundeemner',0),(540559,15016,'ko','ê²€ìƒ‰ ì§€ë„',0),(540560,15016,'he','×”×—×™×¤×•×© ×ž×•×‘×™×œ',0),(540561,15016,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î¿Î´Î·Î³ÎµÎ¯',0),(540562,15016,'zh','æœç´¢æ½œåœ¨é¡¾å®¢',0),(540563,15016,'sv','SÃ¶k leder',0),(540564,15016,'it','Conduce ricerca',0),(540565,15016,'tl','',0),(540566,15016,'th','à¸„à¹‰à¸™à¸«à¸²à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸›à¹‰à¸²à¸«à¸¡à¸²à¸¢',0),(540567,15016,'hi','à¤–à¥‹à¤œ à¤¬à¤¿à¤•à¥à¤°à¥€à¤¸à¥‚à¤¤à¥à¤°',0),(540568,15016,'ms','Petunjuk carian',0),(540569,15016,'ar','Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ù…ØªÙˆÙ‚Ø¹ÙŠÙ†',0),(540570,15016,'fr','Pistes de recherche',0),(540571,15016,'jp','æ¤œç´¢ãƒªãƒ¼ãƒ‰',0),(540572,15016,'pt','Busca de pistas',0),(540573,15016,'ru','ÐŸÐ¾Ð¸ÑÐº Ð¿Ñ€Ð¸Ð²Ð¾Ð´Ð¸Ñ‚',0),(540574,15016,'es','La bÃºsqueda de pistas',0),(540575,15016,'de','Suche fÃ¼hrt',0),(540576,15016,'en','Search Leads',0),(540577,15017,'is','',0),(540578,15017,'dr','Ø°Ø®ÛŒØ±Ù‡ Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø³Ø±Ø¨',0),(540579,15017,'pr','Ø°Ø®ÛŒØ±Ù‡ Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø³Ø±Ø¨',0),(540580,15017,'tr','Yeni mÃ¼ÅŸteri adayÄ± olarak kaydet',0),(540581,15017,'pl','Zapisz nowego klienta jako potencjalnego klienta',0),(540582,15017,'bg','Ð—Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ°Ñ‚Ð¾ Ð¿Ð¾Ñ‚ÐµÐ½Ñ†Ð¸Ð°Ð»ÐµÐ½ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(540583,15017,'ur','Ù†Ø¦Û’ Ú¯Ø§ÛÚ© Ú©ÛŒ Ù‚ÛŒØ§Ø¯Øª Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(540584,15017,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ð½Ð¾Ð²Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð° ÐºÐ°Ð¾ Ð¿Ð¾Ñ‚ÐµÐ½Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾Ð³ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(540585,15017,'vi','Tiáº¿t kiá»‡m khÃ¡ch hÃ ng má»›i nhÆ° má»™t dáº«n',0),(540586,15017,'af','Stoor nuwe kliÃ«nt As \'n lei',0),(540587,15017,'ro','SalvaÅ£i nou client ca un plumb',0),(540588,15017,'et','Salvestage uus klient kaasa',0),(540589,15017,'si','Shranjevanje novega kupca kot vodilo',0),(540590,15017,'ba','Menyimpan pelanggan baru sebagai memimpin',0),(540591,15017,'nl','Nieuwe klant opslaan als een voorsprong',0),(540592,15017,'fi','Tallentaa uuden asiakkaan liidiksi',0),(540593,15017,'no','Lagre ny kunde som et kundeemne',0),(540594,15017,'da','Gem ny kunde som en bly',0),(540595,15017,'ko','ë¦¬ë“œë¡œ ìƒˆë¡œìš´ ê³ ê°ì„ ì €ìž¥',0),(540596,15017,'he','×©×ž×™×¨×ª ×œ×§×•×— ×—×“×© ×—×•×˜',0),(540597,15017,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Î½Î­Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· Ï‰Ï‚ ÎµÎ½ÏŒÏ‚ Ï…Ï€Î¿ÏˆÎ®Ï†Î¹Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(540598,15017,'zh','æ½œåœ¨é¡¾å®¢å¦å­˜æ–°å®¢æˆ·',0),(540599,15017,'sv','Spara ny kund som ett Lead',0),(540600,15017,'it','Salvare il nuovo cliente come un piombo',0),(540601,15017,'tl','',0),(540602,15017,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸«à¸¡à¹ˆà¹€à¸›à¹‡à¸™à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸›à¹‰à¸²à¸«à¸¡à¸²à¸¢',0),(540603,15017,'hi','à¤¨à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤à¤• à¤•à¤¾ à¤¨à¥‡à¤¤à¥ƒà¤¤à¥à¤µ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(540604,15017,'ms','Simpan pelanggan baru sebagai persiapan',0),(540605,15017,'ar','Ø­ÙØ¸ Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø¬Ø¯ÙŠØ¯ ÙƒØ¹Ù…ÙŠÙ„ Ù…ØªÙˆÙ‚Ø¹',0),(540606,15017,'fr','Enregistrez le nouveau client en tant que responsable',0),(540607,15017,'jp','é‰›ã®ã‚ˆã†ã«æ–°ã—ã„é¡§å®¢ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(540608,15017,'pt','Salve o novo cliente como uma pista',0),(540609,15017,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² ÐºÐ°Ðº ÑÐ²Ð¸Ð½ÐµÑ†',0),(540610,15017,'es','Guardar a nuevo cliente como una ventaja',0),(540611,15017,'de','Speichern von neuen Kunden als Lead',0),(540612,15017,'en','Save New Customer As A Lead',0),(540613,15018,'is','',0),(540614,15018,'dr','Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø§Ø®ØªØµØ§Øµ Ø¯Ù‡ÛŒØ¯',0),(540615,15018,'pr','Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø§Ø®ØªØµØ§Øµ Ø¯Ù‡ÛŒØ¯',0),(540616,15018,'tr','KullanÄ±cÄ±larÄ± ata',0),(540617,15018,'pl','Przypisywanie uÅ¼ytkownikÃ³w',0),(540618,15018,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(540619,15018,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©Ùˆ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(540620,15018,'sr','Ð”Ð¾Ð´ÐµÑ™Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(540621,15018,'vi','GÃ¡n cho ngÆ°á»i dÃ¹ng',0),(540622,15018,'af','Gebruikers toeken',0),(540623,15018,'ro','AtribuiÅ£i utilizatorilor',0),(540624,15018,'et','MÃ¤Ã¤ra kasutajad',0),(540625,15018,'si','Dodelite uporabnikom',0),(540626,15018,'ba','Menetapkan pengguna',0),(540627,15018,'nl','Gebruikers toewijzen',0),(540628,15018,'fi','MÃ¤Ã¤ritÃ¤ kÃ¤yttÃ¤jÃ¤t',0),(540629,15018,'no','Tilordne brukere',0),(540630,15018,'da','Tildele brugere',0),(540631,15018,'ko','ì‚¬ìš©ìž í• ë‹¹',0),(540632,15018,'he','×œ×”×§×¦×•×ª ×ž×©×ª×ž×©×™×',0),(540633,15018,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯Î¶ÎµÏ„Îµ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(540634,15018,'zh','å°†ç”¨æˆ·åˆ†é…',0),(540635,15018,'sv','Tilldela anvÃ¤ndare',0),(540636,15018,'it','Assegnare gli utenti',0),(540637,15018,'tl','',0),(540638,15018,'th','à¸à¸³à¸«à¸™à¸”à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(540639,15018,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(540640,15018,'ms','Menguntukkan pengguna',0),(540641,15018,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(540642,15018,'fr','Affecter des utilisateurs',0),(540643,15018,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«å‰²ã‚Šå½“ã¦ã‚‹',0),(540644,15018,'pt','Atribuir usuÃ¡rios',0),(540645,15018,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(540646,15018,'es','Asignar usuarios',0),(540647,15018,'de','Zuweisen von Benutzern',0),(540648,15018,'en','Assign Users',0),(540649,15019,'is','',0),(540650,15019,'dr','ØªØ¹ÛŒÛŒÙ† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø±ÛŒ',0),(540651,15019,'pr','ØªØ¹ÛŒÛŒÙ† Ú¯Ø±ÙˆÙ‡ Ù‡Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø±ÛŒ',0),(540652,15019,'tr','KullanÄ±cÄ± gruplarÄ±nÄ± atama',0),(540653,15019,'pl','Przypisywanie grup uÅ¼ytkownikÃ³w',0),(540654,15019,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð³Ñ€ÑƒÐ¿Ð¸',0),(540655,15019,'ur','ØµØ§Ø±Ù Ú¯Ø±ÙˆÙ¾ ØªÙÙˆÛŒØ¶ Ú©Ø±ÛŒÚº',0),(540656,15019,'sr','Ð”Ð¾Ð´ÐµÐ»Ð¸Ñ‚Ðµ Ð³Ñ€ÑƒÐ¿Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(540657,15019,'vi','Chá»‰ Ä‘á»‹nh nhÃ³m ngÆ°á»i dÃ¹ng',0),(540658,15019,'af','Wys gebruikergroepe',0),(540659,15019,'ro','Atribui grupurilor de utilizatori',0),(540660,15019,'et','Kasutajagruppide mÃ¤Ã¤ramine',0),(540661,15019,'si','Dodeliti uporabniÅ¡ke skupine',0),(540662,15019,'ba','Menetapkan kelompok pengguna',0),(540663,15019,'nl','Gebruikersgroepen toewijzen',0),(540664,15019,'fi','KÃ¤yttÃ¤jÃ¤ryhmien mÃ¤Ã¤rittÃ¤minen',0),(540665,15019,'no','Tilordne brukergrupper',0),(540666,15019,'da','Tildele brugergrupper',0),(540667,15019,'ko','ì‚¬ìš©ìž ê·¸ë£¹ í• ë‹¹',0),(540668,15019,'he','×”×§×¦××ª ×§×‘×•×¦×•×ª ×ž×©×ª×ž×©×™×',0),(540669,15019,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÏ„Îµ Î¿Î¼Î¬Î´ÎµÏ‚ Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½',0),(540670,15019,'zh','å°†ç”¨æˆ·ç»„åˆ†é…',0),(540671,15019,'sv','Tilldela anvÃ¤ndargrupper',0),(540672,15019,'it','Assegnare a gruppi di utenti',0),(540673,15019,'tl','',0),(540674,15019,'th','à¸à¸³à¸«à¸™à¸”à¸à¸¥à¸¸à¹ˆà¸¡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(540675,15019,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¤®à¥‚à¤¹à¥‹à¤‚ à¤•à¥‹ à¤…à¤¸à¤¾à¤‡à¤¨',0),(540676,15019,'ms','Peruntukkan kumpulan pengguna',0),(540677,15019,'ar','ØªØ¹ÙŠÙŠÙ† Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(540678,15019,'fr','Affecter des groupes d\'utilisateurs',0),(540679,15019,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ ã‚°ãƒ«ãƒ¼ãƒ—ã«å‰²ã‚Šå½“ã¦ã‚‹',0),(540680,15019,'pt','Atribuir grupos de usuÃ¡rios',0),(540681,15019,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð³Ñ€ÑƒÐ¿Ð¿ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(540682,15019,'es','Asignar a grupos de usuarios',0),(540683,15019,'de','Benutzergruppen zuweisen',0),(540684,15019,'en','Assign User Groups',0),(540685,15020,'is','',0),(540686,15020,'dr','Ø®ÙˆØ¯Ú©Ø§Ø± ØªØ®ØµÛŒØµ Ù…Ø®Ø§Ø·Ø¨ÛŒÙ†',0),(540687,15020,'pr','Ø®ÙˆØ¯Ú©Ø§Ø± ØªØ®ØµÛŒØµ Ù…Ø®Ø§Ø·Ø¨ÛŒÙ†',0),(540688,15020,'tr','Otomatik ata kiÅŸiler',0),(540689,15020,'pl','Automatyczne przypisywanie kontakty',0),(540690,15020,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸',0),(540691,15020,'ur','Ø®ÙˆØ¯ ØªÙÙˆÛŒØ¶ Ø±ÙˆØ§Ø¨Ø·',0),(540692,15020,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð´Ð¾Ð´ÐµÑ™Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ð¼Ð°',0),(540693,15020,'vi','Tá»± Ä‘á»™ng gÃ¡n sá»‘ liÃªn láº¡c',0),(540694,15020,'af','Outomatiese opdra kontakte',0),(540695,15020,'ro','Contacte de atribuire auto',0),(540696,15020,'et','Automaatne mÃ¤Ã¤ramine kontaktid',0),(540697,15020,'si','Auto dodeliti stikov',0),(540698,15020,'ba','Auto menetapkan kontak',0),(540699,15020,'nl','Auto toewijzen contacten',0),(540700,15020,'fi','Auto antaa yhteystiedot',0),(540701,15020,'no','Automatisk tilordne kontaktene',0),(540702,15020,'da','Auto tildele kontakter',0),(540703,15020,'ko','ìžë™ í• ë‹¹ ì—°ë½ì²˜',0),(540704,15020,'he','×× ×©×™ ×§×©×¨ ×”×§×¦××” ××•×˜×•×ž×˜×™×ª',0),(540705,15020,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎºÏ‡ÏŽÏÎ·ÏƒÎ· ÎµÏ€Î±Ï†Î­Ï‚',0),(540706,15020,'zh','è‡ªåŠ¨åˆ†é…è”ç³»äºº',0),(540707,15020,'sv','Auto tilldela kontakter',0),(540708,15020,'it','Auto Assign contatti',0),(540709,15020,'tl','',0),(540710,15020,'th','à¸•à¸´à¸”à¸•à¹ˆà¸­à¸à¸³à¸«à¸™à¸”à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(540711,15020,'hi','à¤¸à¥à¤µà¤¤à¤ƒ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤°à¥‡à¤‚ à¤¸à¤‚à¤ªà¤°à¥à¤•',0),(540712,15020,'ms','Auto peruntukkan orang hubungan',0),(540713,15020,'ar','Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª ØªØ¹ÙŠÙŠÙ† Ø¬Ù‡Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„',0),(540714,15020,'fr','Auto Assign Contacts',0),(540715,15020,'jp','è‡ªå‹•å‰²ã‚Šå½“ã¦é€£çµ¡å…ˆ',0),(540716,15020,'pt','Auto atribuir contatos',0),(540717,15020,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¾Ð²',0),(540718,15020,'es','Auto asignar contactos',0),(540719,15020,'de','Auto Assign Kontakte',0),(540720,15020,'en','Auto Assign Contacts',0),(540721,15021,'is','',0),(540722,15021,'dr','Ø¢ØºØ§Ø² Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø²ÛŒÙ¾',0),(540723,15021,'pr','Ø¢ØºØ§Ø² Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø²ÛŒÙ¾',0),(540724,15021,'tr','Begin ZIP aralÄ±ÄŸÄ±',0),(540725,15021,'pl','PoczÄ…tkowy zakres Zip',0),(540726,15021,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½Ð¸ Zip Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(540727,15021,'ur','Ø¢ØºØ§Ø² Ø²Ù¾ Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(540728,15021,'sr','ÐžÐ·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð—Ð¸Ð¿ Ð¾Ð¿ÑÐµÐ³',0),(540729,15021,'vi','Báº¯t Ä‘áº§u Zip pháº¡m vi',0),(540730,15021,'af','Begin Zip reeks',0),(540731,15021,'ro','Gama de Zip incep',0),(540732,15021,'et','Alusta Zip valik',0),(540733,15021,'si','ZaÄetni Å¾viÅ¾g obseg',0),(540734,15021,'ba','Mulailah Zip rentang',0),(540735,15021,'nl','Begin Zip bereik',0),(540736,15021,'fi','Aloita Zip alue',0),(540737,15021,'no','Start Zip utvalg',0),(540738,15021,'da','Begynd Zip vifte',0),(540739,15021,'ko','ì‹œìž‘ ìš°íŽ¸ ë²ˆí˜¸ ë²”ìœ„',0),(540740,15021,'he','×˜×•×•×— ×ž×™×§×•×“ ×‘×’×™×Ÿ',0),(540741,15021,'el','Î‘ÏÏ‡Î¯ÏƒÏ„Îµ Zip Ï†Î¬ÏƒÎ¼Î±',0),(540742,15021,'zh','å¼€å§‹åŽ‹ç¼©èŒƒå›´',0),(540743,15021,'sv','BÃ¶rja Zip utbud',0),(540744,15021,'it','Gamma Zip Begin',0),(540745,15021,'tl','',0),(540746,15021,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸Šà¹ˆà¸§à¸‡à¸‹à¸´à¸›',0),(540747,15021,'hi','à¤¶à¥à¤°à¥‚ à¤œà¤¼à¤¿à¤ª à¤°à¥‡à¤‚à¤œ',0),(540748,15021,'ms','Mulakan Zip pelbagai',0),(540749,15021,'ar','ØªØ¨Ø¯Ø£ Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(540750,15021,'fr','Gamme Zip Begin',0),(540751,15021,'jp','é–‹å§‹ Zip ç¯„å›²',0),(540752,15021,'pt','Begin Zip gama',0),(540753,15021,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð° Zip',0),(540754,15021,'es','Begin Zip gama',0),(540755,15021,'de','BEGIN Zip Range',0),(540756,15021,'en','Begin Zip Range',0),(540757,15022,'is','',0),(540758,15022,'dr','ØªÙ…Ø§Ø³ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯ Ù‡Ø³ØªÙ†Ø¯',0),(540759,15022,'pr','ØªÙ…Ø§Ø³ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯ Ù‡Ø³ØªÙ†Ø¯',0),(540760,15022,'tr','KiÅŸiler Ã¶zel',0),(540761,15022,'pl','Kontakty sÄ… ekskluzywne',0),(540762,15022,'bg','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸Ñ‚Ðµ ÑÐ° Ð¸Ð·ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÐµÐ»Ð½Ð¸',0),(540763,15022,'ur','Ø±Ø§Ø¨Ø·Û Ø§ÙØ±Ø§Ø¯ Ø®ØµÙˆØµÛŒ ÛÛŒÚº',0),(540764,15022,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸ ÑÐµ Ð¸ÑÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ',0),(540765,15022,'vi','Äá»‹a chá»‰ liÃªn láº¡c Ä‘Æ°á»£c Ä‘á»™c quyá»n',0),(540766,15022,'af','Kontakte is eksklusief',0),(540767,15022,'ro','Contacte sunt Exclusive',0),(540768,15022,'et','On ainuÃµigusliku',0),(540769,15022,'si','Stiki so izkljuÄno',0),(540770,15022,'ba','Kontak eksklusif',0),(540771,15022,'nl','Contactpersonen zijn exclusief',0),(540772,15022,'fi','Yhteystiedot ovat yksinomainen',0),(540773,15022,'no','Kontakter er utelukkende',0),(540774,15022,'da','Kontakter er eksklusive',0),(540775,15022,'ko','ì—°ë½ì²˜ëŠ”',0),(540776,15022,'he','×× ×©×™ ×§×©×¨ ×”× ×‘×œ×¢×“×™×™×',0),(540777,15022,'el','Î•Ï€Î±Ï†Î­Ï‚ ÎµÎ¯Î½Î±Î¹ Î±Ï€Î¿ÎºÎ»ÎµÎ¹ÏƒÏ„Î¹ÎºÎ®',0),(540778,15022,'zh','è”ç³»äººæ˜¯æŽ’æ–¥',0),(540779,15022,'sv','Kontakter Ã¤r exklusiva',0),(540780,15022,'it','Contatti sono esclusivi',0),(540781,15022,'tl','',0),(540782,15022,'th','à¸•à¸´à¸”à¸•à¹ˆà¸­à¹€à¸›à¹‡à¸™à¸žà¸´à¹€à¸¨à¸©',0),(540783,15022,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤…à¤¨à¤¨à¥à¤¯ à¤¹à¥ˆà¤‚',0),(540784,15022,'ms','Hubungan adalah eksklusif',0),(540785,15022,'ar','Ø¬Ù‡Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„ Ø­ØµØ±ÙŠØ©',0),(540786,15022,'fr','Contacts sont exclusifs',0),(540787,15022,'jp','é€£çµ¡å…ˆã¯ã€æŽ’ä»–çš„',0),(540788,15022,'pt','Os contatos sÃ£o exclusivos',0),(540789,15022,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñ‹ ÑÐ²Ð»ÑÑŽÑ‚ÑÑ Ð¸ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¼Ð¸',0),(540790,15022,'es','Los contactos son exclusivos',0),(540791,15022,'de','Kontakte sind exklusive',0),(540792,15022,'en','Contacts Are Exclusive',0),(540793,15023,'is','',0),(540794,15023,'dr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§ Ø§Ø±ØªØ¨Ø§Ø·',0),(540795,15023,'pr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§ Ø§Ø±ØªØ¨Ø§Ø·',0),(540796,15023,'tr','Ä°lgili kiÅŸi baÄŸlama',0),(540797,15023,'pl','Kontakt z linkami',0),(540798,15023,'bg','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ ÑÐ²ÑŠÑ€Ð·Ð²Ð°Ð½Ðµ',0),(540799,15023,'ur','Ø±Ø¨Ø· Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº',0),(540800,15023,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ ÐºÐ¾Ñ˜Ð¸ Ð¿Ð¾Ð²ÐµÐ·ÑƒÑ˜Ðµ',0),(540801,15023,'vi','LiÃªn há»‡ liÃªn káº¿t',0),(540802,15023,'af','Kontak skakeling',0),(540803,15023,'ro','Contact de legÄƒturÄƒ',0),(540804,15023,'et','Kontakti linkimine',0),(540805,15023,'si','Stik, povezovanje',0),(540806,15023,'ba','Hubungi menghubungkan',0),(540807,15023,'nl','Contactpersoon koppelen',0),(540808,15023,'fi','Yhteystiedon linkittÃ¤minen',0),(540809,15023,'no','Kontakt kobling',0),(540810,15023,'da','Kontakt sammenkÃ¦dning',0),(540811,15023,'ko','ì—°ë½ì²˜ ì—°ê²°',0),(540812,15023,'he','×¦×•×¨ ×§×©×¨ ×¢× ×§×™×©×•×¨',0),(540813,15023,'el','Î•Ï€Î±Ï†Î®, ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(540814,15023,'zh','è”ç³»äººé“¾æŽ¥',0),(540815,15023,'sv','Kontakt LÃ¤nkar',0),(540816,15023,'it','Contatto che collega',0),(540817,15023,'tl','',0),(540818,15023,'th','à¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­à¸—à¸µà¹ˆà¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡',0),(540819,15023,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤œà¥‹à¤¡à¤¼à¤¨à¤¾',0),(540820,15023,'ms','Kenalan yang menghubungkan',0),(540821,15023,'ar','Ø±Ø¨Ø· Ø¬Ù‡Ø© Ø§Ù„Ø§ØªØµØ§Ù„',0),(540822,15023,'fr','Contact Liens',0),(540823,15023,'jp','é€£çµ¡å…ˆãƒªãƒ³ã‚¯',0),(540824,15023,'pt','Contato ligando',0),(540825,15023,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚, ÑÐ²ÑÐ·Ñ‹Ð²Ð°Ð½Ð¸Ðµ',0),(540826,15023,'es','Contacto une',0),(540827,15023,'de','Kontakt verknÃ¼pfen',0),(540828,15023,'en','Contact Linking',0),(540829,15024,'is','',0),(540830,15024,'dr','Ù¾Ø§ÛŒØ§Ù† Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø²ÛŒÙ¾',0),(540831,15024,'pr','Ù¾Ø§ÛŒØ§Ù† Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø²ÛŒÙ¾',0),(540832,15024,'tr','BitiÅŸ ZIP aralÄ±ÄŸÄ±',0),(540833,15024,'pl','Koniec zakresu Zip',0),(540834,15024,'bg','ÐšÑ€Ð°Ð¹ Zip Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(540835,15024,'ur','Ø¢Ø®Ø± Ø²Ù¾ Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(540836,15024,'sr','Ð—Ð°Ð²Ñ€ÑˆÐ¸ Ð—Ð¸Ð¿ Ð¾Ð¿ÑÐµÐ³',0),(540837,15024,'vi','Káº¿t thÃºc Zip pháº¡m vi',0),(540838,15024,'af','Einde Zip reeks',0),(540839,15024,'ro','Gama de Zip din urmÄƒ',0),(540840,15024,'et','LÃµpuks Zip valik',0),(540841,15024,'si','KonÄaj obseg Zip',0),(540842,15024,'ba','Akhir Zip rentang',0),(540843,15024,'nl','Einde Zip bereik',0),(540844,15024,'fi','Lopulta Zip alue',0),(540845,15024,'no','Enden Zip rekkevidde',0),(540846,15024,'da','Ende Zip vifte',0),(540847,15024,'ko','ê²°êµ­ ìš°íŽ¸ ë²ˆí˜¸ ë²”ìœ„',0),(540848,15024,'he','×˜×•×•×— ×ž×™×§×•×“ ×¡×•×£',0),(540849,15024,'el','Î¤Î­Î»Î¿Ï‚ ÏƒÎµÎ¹ÏÎ¬ Zip',0),(540850,15024,'zh','ç»“æŸ Zip èŒƒå›´',0),(540851,15024,'sv','Slutet Zip utbud',0),(540852,15024,'it','Fine serie Zip',0),(540853,15024,'tl','',0),(540854,15024,'th','à¸Šà¹ˆà¸§à¸‡à¸›à¸¥à¸²à¸¢à¸‹à¸´à¸›',0),(540855,15024,'hi','à¤…à¤‚à¤¤ à¤œà¤¼à¤¿à¤ª à¤°à¥‡à¤‚à¤œ',0),(540856,15024,'ms','Akhir Zip pelbagai',0),(540857,15024,'ar','Ù†Ù‡Ø§ÙŠØ© Ù†Ø·Ø§Ù‚ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(540858,15024,'fr','Gamme Zip',0),(540859,15024,'jp','Zip ç¯„å›²ã®çµ‚äº†',0),(540860,15024,'pt','Final Zip gama',0),(540861,15024,'ru','ÐšÐ¾Ð½ÐµÑ† Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð° Zip',0),(540862,15024,'es','Final Zip gama',0),(540863,15024,'de','End-Zip-Bereich',0),(540864,15024,'en','End Zip Range',0),(540865,15025,'is','',0),(540866,15025,'dr','ÙÛŒÙ„ØªØ±',0),(540867,15025,'pr','ÙÛŒÙ„ØªØ±',0),(540868,15025,'tr','Filtreler',0),(540869,15025,'pl','Filtry',0),(540870,15025,'bg','Ð¤Ð¸Ð»Ñ‚Ñ€Ð¸',0),(540871,15025,'ur','ÙÙ„Ù¹Ø±',0),(540872,15025,'sr','Ð¤Ð¸Ð»Ñ‚ÐµÑ€Ð¸',0),(540873,15025,'vi','Bá»™ lá»c',0),(540874,15025,'af','Filters',0),(540875,15025,'ro','Filtre',0),(540876,15025,'et','Filtrid',0),(540877,15025,'si','Filtri',0),(540878,15025,'ba','Filter',0),(540879,15025,'nl','Filters',0),(540880,15025,'fi','Suodattimet',0),(540881,15025,'no','Filtre',0),(540882,15025,'da','Filtre',0),(540883,15025,'ko','í•„í„°',0),(540884,15025,'he','×ž×¡× × ×™×',0),(540885,15025,'el','Î¦Î¯Î»Ï„ÏÎ±',0),(540886,15025,'zh','ç­›é€‰å™¨',0),(540887,15025,'sv','Filter',0),(540888,15025,'it','Filtri',0),(540889,15025,'tl','',0),(540890,15025,'th','à¸•à¸±à¸§à¸à¸£à¸­à¸‡',0),(540891,15025,'hi','à¤«à¤¿à¤²à¥à¤Ÿà¤°',0),(540892,15025,'ms','Penapis',0),(540893,15025,'ar','Ø¹ÙˆØ§Ù…Ù„ Ø§Ù„ØªØµÙÙŠØ©',0),(540894,15025,'fr','Filtres',0),(540895,15025,'jp','ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼',0),(540896,15025,'pt','Filtros',0),(540897,15025,'ru','Ð¤Ð¸Ð»ÑŒÑ‚Ñ€Ñ‹',0),(540898,15025,'es','Filtros',0),(540899,15025,'de','Filter',0),(540900,15025,'en','Filters',0),(540901,15026,'is','',0),(540902,15026,'dr','Ú†Ø´Ù… Ù¾ÙˆØ´ÛŒ Ø§Ø² ÙˆØ¶Ø¹ÛŒØª',0),(540903,15026,'pr','Ú†Ø´Ù… Ù¾ÙˆØ´ÛŒ Ø§Ø² ÙˆØ¶Ø¹ÛŒØª',0),(540904,15026,'tr','DurumlarÄ± yoksay',0),(540905,15026,'pl','Ignoruj statusy',0),(540906,15026,'bg','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð°Ð¹ ÑÑ‚Ð°Ñ‚ÑƒÑÐ¸',0),(540907,15026,'ur','Ø­ÛŒØ«ÛŒØª Ú©Ùˆ Ù†Ø¸Ø± Ø§Ù†Ø¯Ø§Ø² Ú©Ø±ÛŒÚº',0),(540908,15026,'sr','Ð—Ð°Ð½ÐµÐ¼Ð°Ñ€Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑÐ¸',0),(540909,15026,'vi','Bá» qua tráº¡ng thÃ¡i',0),(540910,15026,'af','Ignoreer statusse',0),(540911,15026,'ro','Ignora Statusuri',0),(540912,15026,'et','Ignoreeri olek',0),(540913,15026,'si','Prezri statusi',0),(540914,15026,'ba','Mengabaikan status',0),(540915,15026,'nl','Negeren van statussen',0),(540916,15026,'fi','Ohita tila',0),(540917,15026,'no','Ignorere statuser',0),(540918,15026,'da','Ignorere statusser',0),(540919,15026,'ko','ìƒíƒœë¥¼ ë¬´ì‹œ',0),(540920,15026,'he','×”×ª×¢×œ× ×¡×˜×˜×•×¡×™×',0),(540921,15026,'el','Î‘Î³Î½Î¿Î®ÏƒÎµÎ¹ ÎºÎ±Ï„Î±ÏƒÏ„Î¬ÏƒÎµÎ¹Ï‚',0),(540922,15026,'zh','å¿½ç•¥çŠ¶æ€',0),(540923,15026,'sv','Ignorera status',0),(540924,15026,'it','Ignorare status',0),(540925,15026,'tl','',0),(540926,15026,'th','à¸¥à¸°à¹€à¸§à¹‰à¸™à¸ªà¸–à¸²à¸™à¸°',0),(540927,15026,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿à¤¯à¥‹à¤‚ à¤ªà¤° à¤§à¥à¤¯à¤¾à¤¨ à¤¨ à¤¦à¥‡à¤‚',0),(540928,15026,'ms','Mengabaikan status',0),(540929,15026,'ar','ØªØ¬Ø§Ù‡Ù„ Ø§Ù„Ø­Ø§Ù„Ø§Øª',0),(540930,15026,'fr','Ignorer les statuts',0),(540931,15026,'jp','ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã‚’ç„¡è¦–ã—ã¾ã™ã€‚',0),(540932,15026,'pt','Ignorar o status',0),(540933,15026,'ru','Ð˜Ð³Ð½Ð¾Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð°Ñ‚ÑƒÑÑ‹',0),(540934,15026,'es','Ignorar los Estados',0),(540935,15026,'de','Status zu ignorieren',0),(540936,15026,'en','Ignore Statuses',0),(540937,15027,'is','',0),(540938,15027,'dr','ØªÙ†Ù‡Ø§ Ù…Ù†Ø¬Ø±',0),(540939,15027,'pr','ØªÙ†Ù‡Ø§ Ù…Ù†Ø¬Ø±',0),(540940,15027,'tr','Sadece aÃ§ar',0),(540941,15027,'pl','Prowadzi tylko',0),(540942,15027,'bg','Ð’Ð¾Ð´Ð¸ ÑÐ°Ð¼Ð¾',0),(540943,15027,'ur','ØµØ±Ù Ú©ÛŒ Ø·Ø±Ù Ø¬Ø§ØªØ§ ÛÛ’',0),(540944,15027,'sr','Ð’Ð¾Ð´Ð¸ ÑÐ°Ð¼Ð¾',0),(540945,15027,'vi','Dáº«n chá»‰',0),(540946,15027,'af','Slegs lei',0),(540947,15027,'ro','Duce numai',0),(540948,15027,'et','Viib ainult',0),(540949,15027,'si','Vodi le',0),(540950,15027,'ba','Memimpin hanya',0),(540951,15027,'nl','Alleen leidt',0),(540952,15027,'fi','Johtaa vain',0),(540953,15027,'no','FÃ¸rer bare',0),(540954,15027,'da','FÃ¸rer kun',0),(540955,15027,'ko','ì§€ë„',0),(540956,15027,'he','×ž×•×‘×™×œ ×¨×§',0),(540957,15027,'el','ÎŸÎ´Î·Î³ÎµÎ¯ Î¼ÏŒÎ½Î¿',0),(540958,15027,'zh','å”¯ä¸€çš„çº¿ç´¢',0),(540959,15027,'sv','Leder bara',0),(540960,15027,'it','Porta solo',0),(540961,15027,'tl','',0),(540962,15027,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸›à¹‰à¸²à¸«à¸¡à¸²à¸¢à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(540963,15027,'hi','à¤•à¥‡à¤µà¤² à¤¸à¥à¤°à¤¾à¤—',0),(540964,15027,'ms','Membawa hanya',0),(540965,15027,'ar','ÙŠØ¤Ø¯ÙŠ ÙÙ‚Ø·',0),(540966,15027,'fr','Conduit seulement',0),(540967,15027,'jp','ãƒªãƒ¼ãƒ‰ã®ã¿',0),(540968,15027,'pt','Leva apenas',0),(540969,15027,'ru','ÐŸÑ€Ð¸Ð²Ð¾Ð´Ð¸Ñ‚ Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(540970,15027,'es','Plomos solamente',0),(540971,15027,'de','FÃ¼hrt nur',0),(540972,15027,'en','Leads Only',0),(540973,15028,'is','',0),(540974,15028,'dr','ØºÛŒØ± ØªÙ†Ù‡Ø§ Ù…Ù†Ø¬Ø±',0),(540975,15028,'pr','ØºÛŒØ± ØªÙ†Ù‡Ø§ Ù…Ù†Ø¬Ø±',0),(540976,15028,'tr','Sadece sigara aÃ§ar',0),(540977,15028,'pl','Nie prowadzi tylko',0),(540978,15028,'bg','ÐÐµ Ð²Ð¾Ð´Ð¸ ÑÐ°Ð¼Ð¾',0),(540979,15028,'ur','ØºÛŒØ± ØµØ±Ù Ú©ÛŒ Ø·Ø±Ù Ø¬Ø§ØªØ§ ÛÛ’',0),(540980,15028,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½Ðµ Ð²Ð¾Ð´Ð¸ ÑÐ°Ð¼Ð¾',0),(540981,15028,'vi','PhÃ²ng khÃ´ng dáº«n chá»‰',0),(540982,15028,'af','Nie lei slegs',0),(540983,15028,'ro','Ne duce numai',0),(540984,15028,'et','Mitte viib ainult',0),(540985,15028,'si','Ne vodi samo',0),(540986,15028,'ba','Bebas menyebabkan hanya',0),(540987,15028,'nl','Niet leidt alleen',0),(540988,15028,'fi','Ei johtaa vain',0),(540989,15028,'no','Ikke fÃ¸rer bare',0),(540990,15028,'da','Ikke fÃ¸rer kun',0),(540991,15028,'ko','ë¹„ ì§€ë„',0),(540992,15028,'he','×©××™× ×• ×ž×•×‘×™×œ ×¨×§',0),(540993,15028,'el','ÎœÎ· Î¿Î´Î·Î³ÎµÎ¯ Î¼ÏŒÎ½Î¿',0),(540994,15028,'zh','åªæœ‰éžçº¿ç´¢',0),(540995,15028,'sv','Icke leder endast',0),(540996,15028,'it','Conduce non solo',0),(540997,15028,'tl','',0),(540998,15028,'th','à¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆà¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸›à¹‰à¸²à¸«à¸¡à¸²à¸¢à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(540999,15028,'hi','à¤—à¥ˆà¤° à¤•à¥‡à¤µà¤² à¤¸à¥à¤°à¤¾à¤—',0),(541000,15028,'ms','Bebas membawa hanya',0),(541001,15028,'ar','ÙŠØ¤Ø¯ÙŠ Ø¹Ø¯Ù… ÙÙ‚Ø·',0),(541002,15028,'fr','Conduit non seulement',0),(541003,15028,'jp','éžãƒªãƒ¼ãƒ‰ã®ã¿',0),(541004,15028,'pt','NÃ£o leva apenas',0),(541005,15028,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð½Ðµ Ð¿Ñ€Ð¸Ð²Ð¾Ð´Ð¸Ñ‚',0),(541006,15028,'es','Conduce no sÃ³lo',0),(541007,15028,'de','FÃ¼hrt nicht nur',0),(541008,15028,'en','Non Leads Only',0),(541009,15029,'is','',0),(541010,15029,'dr','Ù„Ø·ÙØ§ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±ÛŒ',0),(541011,15029,'pr','Ù„Ø·ÙØ§ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±ÛŒ',0),(541012,15029,'tr','LÃ¼tfen bir gÃ¶rev ekleme',0),(541013,15029,'pl','ProszÄ™ dodaÄ‡ zadanie',0),(541014,15029,'bg','ÐœÐ¾Ð»Ñ, Ð´Ð¾Ð±Ð°Ð²ÐµÑ‚Ðµ Ð·Ð°Ð´Ð°Ñ‡Ð°',0),(541015,15029,'ur','Ú©Ø§Ù… Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(541016,15029,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð·Ð°Ð´Ð°Ñ‚ÐºÐ°',0),(541017,15029,'vi','Xin vui lÃ²ng thÃªm má»™t nhiá»‡m vá»¥',0),(541018,15029,'af','Voeg asseblief \'n taak',0),(541019,15029,'ro','VÄƒ rugÄƒm sÄƒ adÄƒugaÅ£i o sarcinÄƒ',0),(541020,15029,'et','Palun lisa toiming',0),(541021,15029,'si','Dodajte opravila',0),(541022,15029,'ba','Harap menambahkan tugas',0),(541023,15029,'nl','Voeg een taak',0),(541024,15029,'fi','LisÃ¤Ã¤ tehtÃ¤vÃ¤',0),(541025,15029,'no','Legg til en aktivitet',0),(541026,15029,'da','TilfÃ¸j en opgave',0),(541027,15029,'ko','ìž‘ì—…ì„ ì¶”ê°€ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(541028,15029,'he','× × ×”×•×¡×£ ×¤×¢×™×œ×•×ª',0),(541029,15029,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î­Î½Î± Î­ÏÎ³Î¿',0),(541030,15029,'zh','è¯·æ·»åŠ ä»»åŠ¡',0),(541031,15029,'sv','LÃ¤gg till en aktivitet',0),(541032,15029,'it','Si prega di aggiungere un\'attivitÃ ',0),(541033,15029,'tl','',0),(541034,15029,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸žà¸´à¹ˆà¸¡à¸‡à¸²à¸™',0),(541035,15029,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤•à¤¾à¤°à¥à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(541036,15029,'ms','Sila tambah tugas yang',0),(541037,15029,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¶Ø§ÙØ© Ù…Ù‡Ù…Ø©',0),(541038,15029,'fr','S\'il vous plaÃ®t ajouter une tÃ¢che',0),(541039,15029,'jp','ã‚¿ã‚¹ã‚¯ã‚’è¿½åŠ ã—ã¦ãã ã•ã„ã€‚',0),(541040,15029,'pt','Por favor, adicione uma tarefa',0),(541041,15029,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð° Ð´Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð·Ð°Ð´Ð°Ñ‡Ñƒ',0),(541042,15029,'es','Por favor agregar una tarea',0),(541043,15029,'de','Bitte fÃ¼gen Sie eine Aufgabe',0),(541044,15029,'en','Please Add A Task',0),(541045,15030,'is','',0),(541046,15030,'dr','Ú©Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(541047,15030,'pr','Ú©Ø§Ø± Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(541048,15030,'tr','GÃ¶rev baÅŸarÄ±yla silindi',0),(541049,15030,'pl','PomyÅ›lnie usuniÄ™to zadanie',0),(541050,15030,'bg','Ð—Ð°Ð´Ð°Ñ‡Ð°Ñ‚Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541051,15030,'ur','Ú©Ø§Ù… Ø³Ú©ÛŒØ³ÙÙˆÙ„Ù„ Ø­Ø°Ù Ø´Ø¯Û',0),(541052,15030,'sr','Ð—Ð°Ð´Ð°Ñ‚Ð°Ðº Ñ˜Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541053,15030,'vi','Nhiá»‡m vá»¥ Ä‘Ã£ xÃ³a thÃ nh cÃ´ng',0),(541054,15030,'af','Taak suksesvol geskrap',0),(541055,15030,'ro','Sarcina eliminÄƒ cu succes',0),(541056,15030,'et','Ãœlesande kustutamine Ãµnnestus',0),(541057,15030,'si','Opravilo izbrisano Sucessfully',0),(541058,15030,'ba','Tugas dihapus berhasil',0),(541059,15030,'nl','Taak verwijderd Sucessfully',0),(541060,15030,'fi','TehtÃ¤vÃ¤n poistaminen onnistui',0),(541061,15030,'no','Oppgave slettet ble',0),(541062,15030,'da','Opgaven slettet Sucessfully',0),(541063,15030,'ko','ìž‘ì—… ì‚­ì œë¥¼ ì„±ê³µì ìœ¼ë¡œ',0),(541064,15030,'he','×”×ž×©×™×ž×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(541065,15030,'el','ÎˆÏÎ³Î¿ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(541066,15030,'zh','æˆåŠŸåˆ é™¤ä»»åŠ¡',0),(541067,15030,'sv','Aktiviteten bort framgÃ¥ngsrikt',0),(541068,15030,'it','AttivitÃ  eliminato con successo',0),(541069,15030,'tl','',0),(541070,15030,'th','à¸‡à¸²à¸™à¸¥à¸šà¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(541071,15030,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(541072,15030,'ms','Tugas dihapuskan berjaya',0),(541073,15030,'ar','Ø­Ø°Ù Ø§Ù„Ù…Ù‡Ù…Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(541074,15030,'fr','TÃ¢che supprimÃ©e avec succÃ¨s',0),(541075,15030,'jp','ã‚¿ã‚¹ã‚¯ã¯æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(541076,15030,'pt','Tarefa excluÃ­da com sucesso',0),(541077,15030,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541078,15030,'es','Tarea eliminado correctamente',0),(541079,15030,'de','Task gelÃ¶scht wurde erfolgreich',0),(541080,15030,'en','Task Deleted Sucessfully',0),(541081,15031,'is','',0),(541082,15031,'dr','ÙˆØ¸ÛŒÙÙ‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(541083,15031,'pr','ÙˆØ¸ÛŒÙÙ‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(541084,15031,'tr','GÃ¶rev baÅŸarÄ±yla kaydedilen bilgi',0),(541085,15031,'pl','Temat zadania zapisane pomyÅ›lnie',0),(541086,15031,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð·Ð°Ð´Ð°Ñ‡Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541087,15031,'ur','Ø³Ú©ÛŒØ³ÙÙˆÙ„Ù„ Ú©Ø§Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø­ÙÙˆØ¸',0),(541088,15031,'sr','Ð—Ð°Ð´Ð°Ñ‚Ð°Ðº Ð˜Ð½Ñ„Ð¾ ÑÐ¿Ð°ÑÐ°Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541089,15031,'vi','Nhiá»‡m vá»¥ thÃ´ng tin Ä‘Ã£ lÆ°u thÃ nh cÃ´ng',0),(541090,15031,'af','Taak Info suksesvol gestoor',0),(541091,15031,'ro','Sarcina Info salvat cu succes',0),(541092,15031,'et','TÃ¶Ã¶Ã¼lesande teave salvestatakse edukalt',0),(541093,15031,'si','Naloga zavijati zaÅ¡Äititi Sucessfully',0),(541094,15031,'ba','Tugas Info disimpan berhasil',0),(541095,15031,'nl','Taak Info opgeslagen Sucessfully',0),(541096,15031,'fi','TehtÃ¤vien Info tallennettu onnistuneesti',0),(541097,15031,'no','Aktivitet informasjon lagret Sucessfully',0),(541098,15031,'da','Opgave Info gemt Sucessfully',0),(541099,15031,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” ìž‘ì—… ì •ë³´',0),(541100,15031,'he','×¤×¨×˜×™ ×”×ž×©×™×ž×” ×©× ×©×ž×¨×• ×‘×”×¦×œ×—×”',0),(541101,15031,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(541102,15031,'zh','ä¿å­˜æˆåŠŸçš„ä»»åŠ¡ä¿¡æ¯',0),(541103,15031,'sv','Uppgift information sparas framgÃ¥ngsrikt',0),(541104,15031,'it','AttivitÃ  informazioni salvate con successo',0),(541105,15031,'tl','',0),(541106,15031,'th','à¸‡à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸–à¸¹à¸à¸šà¸±à¸™à¸—à¸¶à¸à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(541107,15031,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(541108,15031,'ms','Tugas maklumat disimpan berjaya',0),(541109,15031,'ar','Ø­ÙØ¸ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ù‡Ù…Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(541110,15031,'fr','TÃ¢che informations enregistrÃ©es avec succÃ¨s',0),(541111,15031,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚Œã‚‹ã‚¿ã‚¹ã‚¯æƒ…å ±',0),(541112,15031,'pt','InformaÃ§Ã£o de tarefa salva com sucesso',0),(541113,15031,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð·Ð°Ð´Ð°Ñ‡Ðµ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541114,15031,'es','Guarda informaciÃ³n de tarea correctamente',0),(541115,15031,'de','Aufgaben-Info wurde erfolgreich gespeichert',0),(541116,15031,'en','Task Info Saved Sucessfully',0),(541117,15032,'is','',0),(541118,15032,'dr','ÙˆØ¸ÛŒÙÙ‡ Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(541119,15032,'pr','ÙˆØ¸ÛŒÙÙ‡ Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(541120,15032,'tr','GÃ¶revi yeni/DÃ¼zenle',0),(541121,15032,'pl','Nowe zadania/edycja',0),(541122,15032,'bg','ÐÐ¾Ð²Ð° Ð·Ð°Ð´Ð°Ñ‡Ð°/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(541123,15032,'ur','Ù†ÛŒØ§ Ú©Ø§Ù…/ØªØ¯ÙˆÛŒÙ†',0),(541124,15032,'sr','ÐÐ¾Ð²Ð¸ Ð·Ð°Ð´Ð°Ñ‚Ð°Ðº/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(541125,15032,'vi','Má»›i/nhiá»‡m vá»¥ chá»‰nh sá»­a',0),(541126,15032,'af','Nuwe taak/redigeer',0),(541127,15032,'ro','Sarcina nou/editare',0),(541128,15032,'et','TÃ¶Ã¶Ã¼lesande uus/Muuda',0),(541129,15032,'si','Naloga novega/Uredi',0),(541130,15032,'ba','Tugas baru/Edit',0),(541131,15032,'nl','Nieuwe taak/bewerken',0),(541132,15032,'fi','TehtÃ¤vÃ¤ uusi tai Muokkaa',0),(541133,15032,'no','Oppgave ny/Rediger',0),(541134,15032,'da','Opgave nye/Rediger',0),(541135,15032,'ko','ìž‘ì—… ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘',0),(541136,15032,'he','×¤×¢×™×œ×•×ª ×—×“×©×”/×¢×¨×™×›×”',0),(541137,15032,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(541138,15032,'zh','ä»»åŠ¡æ–°å»º/ç¼–è¾‘',0),(541139,15032,'sv','Den nya uppgiften/redigera',0),(541140,15032,'it','Compito nuovo/modifica',0),(541141,15032,'tl','',0),(541142,15032,'th','à¸‡à¸²à¸™à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚',0),(541143,15032,'hi','à¤¨à¤ˆ à¤•à¤¾à¤°à¥à¤¯/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(541144,15032,'ms','Tugas baru/Edit',0),(541145,15032,'ar','Ø§Ù„Ù…Ù‡Ù…Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©/ØªØ­Ø±ÙŠØ±',0),(541146,15032,'fr','Nouvelle tÃ¢che/modifier',0),(541147,15032,'jp','ã‚¿ã‚¹ã‚¯ã®ä½œæˆã¨ç·¨é›†',0),(541148,15032,'pt','Nova tarefa/editar',0),(541149,15032,'ru','Ð—Ð°Ð´Ð°Ñ‡Ð° Ð½Ð¾Ð²Ñ‹Ñ… Ð¸Ð»Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(541150,15032,'es','Tarea nueva o editar',0),(541151,15032,'de','Aufgabe neu/bearbeiten',0),(541152,15032,'en','Task New/Edit',0),(541153,15033,'is','',0),(541154,15033,'dr','Ø§Ù†ØªØ³Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø±',0),(541155,15033,'pr','Ø§Ù†ØªØ³Ø§Ø¨ Ú©Ø§Ø±Ø¨Ø±',0),(541156,15033,'tr','KullanÄ±cÄ± atama',0),(541157,15033,'pl','Przypisywanie uÅ¼ytkownika',0),(541158,15033,'bg','ÐŸÑ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(541159,15033,'ur','ØµØ§Ø±Ù ØªÙÙˆÛŒØ¶',0),(541160,15033,'sr','Ð—Ð°Ð´Ð°Ñ‚Ð°Ðº ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(541161,15033,'vi','NgÆ°á»i sá»­ dá»¥ng chuyá»ƒn nhÆ°á»£ng',0),(541162,15033,'af','Gebruiker opdrag',0),(541163,15033,'ro','Rolurilor de utilizator',0),(541164,15033,'et','Kasutajale mÃ¤Ã¤ramine',0),(541165,15033,'si','UporabniÅ¡ke dodelitve',0),(541166,15033,'ba','Pengguna tugas',0),(541167,15033,'nl','Gebruiker toewijzing',0),(541168,15033,'fi','KÃ¤yttÃ¤jÃ¤n mÃ¤Ã¤ritys',0),(541169,15033,'no','Bruker tildeling',0),(541170,15033,'da','Bruger tildeling',0),(541171,15033,'ko','ì‚¬ìš©ìž í• ë‹¹',0),(541172,15033,'he','×”×§×¦××ª ×ž×©×ª×ž×©',0),(541173,15033,'el','Î•ÎºÏ‡ÏŽÏÎ·ÏƒÎ· Ï‡ÏÎ®ÏƒÏ„Î·',0),(541174,15033,'zh','ç”¨æˆ·åˆ†é…',0),(541175,15033,'sv','AnvÃ¤ndartilldelning',0),(541176,15033,'it','Assegnazione utente',0),(541177,15033,'tl','',0),(541178,15033,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸à¸³à¸«à¸™à¸”',0),(541179,15033,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤…à¤¸à¤¾à¤‡à¤¨à¤®à¥‡à¤‚à¤Ÿ',0),(541180,15033,'ms','Tugasan pengguna',0),(541181,15033,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(541182,15033,'fr','Affectation utilisateur',0),(541183,15033,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®å‰²ã‚Šå½“ã¦',0),(541184,15033,'pt','AtribuiÃ§Ã£o de usuÃ¡rio',0),(541185,15033,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(541186,15033,'es','AsignaciÃ³n de usuario',0),(541187,15033,'de','Von Benutzerrechten',0),(541188,15033,'en','User Assignment',0),(541189,15034,'is','',0),(541190,15034,'dr','Ø­Ø°Ù ÙˆØ¸ÛŒÙÙ‡ Ø¹Ù…Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(541191,15034,'pr','Ø­Ø°Ù ÙˆØ¸ÛŒÙÙ‡ Ø¹Ù…Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(541192,15034,'tr','GÃ¶revi eylem baÅŸarÄ±yla silindi',0),(541193,15034,'pl','PomyÅ›lnie usuniÄ™to zadanie dziaÅ‚ania',0),(541194,15034,'bg','Ð—Ð°Ð´Ð°Ñ‡Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541195,15034,'ur','Ø³Ú©ÛŒØ³ÙÙˆÙ„Ù„ Ú©Ø§Ù… Ø¹Ù…Ù„ Ø­Ø°Ù Ø´Ø¯Û',0),(541196,15034,'sr','Ð—Ð°Ð´Ð°Ñ‚Ð°Ðº Ð°ÐºÑ†Ð¸Ñ˜Ñƒ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541197,15034,'vi','Nhiá»‡m vá»¥ hÃ nh Ä‘á»™ng xÃ³a thÃ nh cÃ´ng',0),(541198,15034,'af','Taak aksie geskrap suksesvol',0),(541199,15034,'ro','Sarcina acÅ£iune eliminÄƒ cu succes',0),(541200,15034,'et','Ãœlesande toimingu kustutamine Ãµnnestus',0),(541201,15034,'si','Dejanja Ärta Sucessfully',0),(541202,15034,'ba','Tugas tindakan dihapus berhasil',0),(541203,15034,'nl','Taakactie verwijderd Sucessfully',0),(541204,15034,'fi','TehtÃ¤vÃ¤n suorittaminen poistaminen onnistui',0),(541205,15034,'no','Oppgavehandling slettet ble',0),(541206,15034,'da','Opgavehandling slettet Sucessfully',0),(541207,15034,'ko','ìž‘ì—… ìž‘ì—…ì€ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ',0),(541208,15034,'he','×¤×¢×™×œ×•×ª ×¤×¢×•×œ×” × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(541209,15034,'el','Î•Î½Î­ÏÎ³ÎµÎ¹Î±Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(541210,15034,'zh','ä»»åŠ¡æ“ä½œåˆ é™¤æˆåŠŸ',0),(541211,15034,'sv','UppgiftsÃ¥tgÃ¤rden bort framgÃ¥ngsrikt',0),(541212,15034,'it','AttivitÃ  azione cancellati con successo',0),(541213,15034,'tl','',0),(541214,15034,'th','à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸‡à¸²à¸™à¸¥à¸šà¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(541215,15034,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(541216,15034,'ms','Tindakan tugas dihapuskan berjaya',0),(541217,15034,'ar','Ø­Ø°Ù Ø¥Ø¬Ø±Ø§Ø¡ Ø§Ù„Ù…Ù‡Ù…Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(541218,15034,'fr','Action de tÃ¢che supprimÃ©e avec succÃ¨s',0),(541219,15034,'jp','ã‚¿ã‚¹ã‚¯ ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã¯æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸã€‚',0),(541220,15034,'pt','Tarefa aÃ§Ã£o excluÃ­do com Ãªxito',0),(541221,15034,'ru','Ð—Ð°Ð´Ð°Ñ‡Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541222,15034,'es','Tarea acciÃ³n eliminado correctamente',0),(541223,15034,'de','Aktion Aufgabe gelÃ¶scht wurde erfolgreich',0),(541224,15034,'en','Task Action Deleted Sucessfully',0),(541225,15035,'is','',0),(541226,15035,'dr','ÙˆØ¸ÛŒÙÙ‡ Ø§Ù‚Ø¯Ø§Ù… Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(541227,15035,'pr','ÙˆØ¸ÛŒÙÙ‡ Ø§Ù‚Ø¯Ø§Ù… Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(541228,15035,'tr','GÃ¶rev eylemi yeni/DÃ¼zenle',0),(541229,15035,'pl','Zadanie dziaÅ‚ania nowego/edycja',0),(541230,15035,'bg','Ð—Ð°Ð´Ð°Ñ‡Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð½Ð¾Ð²/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(541231,15035,'ur','Ú©Ø§Ù… Ø¹Ù…Ù„ Ù†Ø¦Û’/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(541232,15035,'sr','Ð—Ð°Ð´Ð°Ñ‚Ð°Ðº Ð°ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð¾Ð²Ð¸Ñ…/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(541233,15035,'vi','Nhiá»‡m vá»¥ má»›i/hÃ nh Ä‘á»™ng chá»‰nh sá»­a',0),(541234,15035,'af','Taak aksie nuwe/redigeer',0),(541235,15035,'ro','Sarcina noi acÅ£iunea/editare',0),(541236,15035,'et','Toiming tegevus uus/Muuda',0),(541237,15035,'si','Opravilo dejanje novo/Uredi',0),(541238,15035,'ba','Tugas tindakan baru/Edit',0),(541239,15035,'nl','Taak actie nieuwe/bewerken',0),(541240,15035,'fi','TehtÃ¤vÃ¤ toiminto uusi tai Muokkaa',0),(541241,15035,'no','Aktivitet handling ny/Rediger',0),(541242,15035,'da','Opgave handling ny/Rediger',0),(541243,15035,'ko','ìž‘ì—… ìž‘ì—… ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘',0),(541244,15035,'he','×¤×¢×™×œ×•×ª ×¤×¢×•×œ×” ×—×“×©/×¢×¨×™×›×”',0),(541245,15035,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Î´ÏÎ¬ÏƒÎ· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(541246,15035,'zh','ä»»åŠ¡è¡ŒåŠ¨æ–°å»º/ç¼–è¾‘',0),(541247,15035,'sv','Uppgift Ã¥tgÃ¤rder ny/redigera',0),(541248,15035,'it','AttivitÃ  azione nuovo/modifica',0),(541249,15035,'tl','',0),(541250,15035,'th','à¸‡à¸²à¸™à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚',0),(541251,15035,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¨à¤ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(541252,15035,'ms','Tugas tindakan baru/Edit',0),(541253,15035,'ar','Ù…Ù‡Ù…Ø© Ø¹Ù…Ù„ Ø¬Ø¯ÙŠØ¯Ø©/ØªØ­Ø±ÙŠØ±',0),(541254,15035,'fr','TÃ¢che nouvelle Action/modifier',0),(541255,15035,'jp','ã‚¿ã‚¹ã‚¯ ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ä½œæˆ/ç·¨é›†',0),(541256,15035,'pt','Tarefa aÃ§Ã£o novo/editar',0),(541257,15035,'ru','Ð—Ð°Ð´Ð°Ñ‡Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹ Ð½Ð¾Ð²Ñ‹Ñ… Ð¸Ð»Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(541258,15035,'es','Tarea acciÃ³n crear o editar',0),(541259,15035,'de','Aufgabe Aktion neu/bearbeiten',0),(541260,15035,'en','Task Action New/Edit',0),(541261,15036,'is','',0),(541262,15036,'dr','ÙˆØ¸ÛŒÙÙ‡ Ø¹Ù…Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(541263,15036,'pr','ÙˆØ¸ÛŒÙÙ‡ Ø¹Ù…Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(541264,15036,'tr','GÃ¶rev baÅŸarÄ±yla kaydedilen eylem',0),(541265,15036,'pl','Zadanie dziaÅ‚ania zapisane pomyÅ›lnie',0),(541266,15036,'bg','Ð—Ð°Ð´Ð°Ñ‡Ð° Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541267,15036,'ur','Ú©Ø§Ù… Ú©Û’ Ø¹Ù…Ù„ Ú©Ùˆ Ø³Ú©ÛŒØ³ÙÙˆÙ„Ù„ Ù†Ø¬Ø§Øª',0),(541268,15036,'sr','Ð—Ð°Ð´Ð°Ñ‚Ð°Ðº Ð°ÐºÑ†Ð¸Ñ˜Ñƒ ÑÐ¿Ð°ÑÐ°Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541269,15036,'vi','Nhiá»‡m vá»¥ hÃ nh Ä‘á»™ng lÆ°u thÃ nh cÃ´ng',0),(541270,15036,'af','Taak aksie suksesvol gestoor',0),(541271,15036,'ro','Sarcina acÅ£iune salvat cu succes',0),(541272,15036,'et','Toiming tegevus salvestatud edukalt',0),(541273,15036,'si','Shranjene Sucessfully dejanja',0),(541274,15036,'ba','Tugas aksi menyelamatkan berhasil',0),(541275,15036,'nl','Taakactie opgeslagen Sucessfully',0),(541276,15036,'fi','TehtÃ¤vÃ¤n suorittaminen tallennettu onnistuneesti',0),(541277,15036,'no','Oppgavehandling lagret Sucessfully',0),(541278,15036,'da','Opgavehandling gemt Sucessfully',0),(541279,15036,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ ëœ ìž‘ì—… ìž‘ì—…',0),(541280,15036,'he','×¤×¢×•×œ×” ×”×ž×©×™×ž×•×ª ×”×¦×™×œ×• ×‘×”×¦×œ×—×”',0),(541281,15036,'el','Î•Î½Î­ÏÎ³ÎµÎ¹Î±Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(541282,15036,'zh','ä»»åŠ¡æ“ä½œä¿å­˜æˆåŠŸ',0),(541283,15036,'sv','UppgiftsÃ¥tgÃ¤rden sparade framgÃ¥ngsrikt',0),(541284,15036,'it','Azione di attivitÃ  salvate con successo',0),(541285,15036,'tl','',0),(541286,15036,'th','à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸‡à¸²à¸™à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(541287,15036,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(541288,15036,'ms','Tindakan tugas yang disimpan berjaya',0),(541289,15036,'ar','Ø­ÙØ¸ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ù…Ù‡Ù…Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(541290,15036,'fr','Action de tÃ¢ches enregistrÃ©e avec succÃ¨s',0),(541291,15036,'jp','ã‚¿ã‚¹ã‚¯ ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã¯æ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã™ã€‚',0),(541292,15036,'pt','AÃ§Ã£o de tarefa salva com sucesso',0),(541293,15036,'ru','Ð—Ð°Ð´Ð°Ñ‡Ð¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541294,15036,'es','Tarea acciÃ³n guardado correctamente',0),(541295,15036,'de','Aktion der Aufgabe wurde erfolgreich gespeichert',0),(541296,15036,'en','Task Action Saved Sucessfully',0),(541297,15037,'is','',0),(541298,15037,'dr','ÙˆØ¶Ø¹ÛŒØª ÙˆØ¸ÛŒÙÙ‡ Ø­Ø°Ù Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(541299,15037,'pr','ÙˆØ¶Ø¹ÛŒØª ÙˆØ¸ÛŒÙÙ‡ Ø­Ø°Ù Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(541300,15037,'tr','GÃ¶rev durumu baÅŸarÄ±yla silindi',0),(541301,15037,'pl','PomyÅ›lnie usuniÄ™to stanu zadania',0),(541302,15037,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð·Ð°Ð´Ð°Ñ‡Ð°Ñ‚Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541303,15037,'ur','Ø­Ø§Ù„Øª Ú©Ø§Ù… Ø³Ú©ÛŒØ³ÙÙˆÙ„Ù„ Ø­Ø°Ù Ø´Ø¯Û',0),(541304,15037,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð´Ð°Ñ‚ÐºÐ° Ñ˜Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ð° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541305,15037,'vi','TÃ¬nh tráº¡ng cÃ´ng viá»‡c xÃ³a thÃ nh cÃ´ng',0),(541306,15037,'af','Taak Status suksesvol geskrap',0),(541307,15037,'ro','Sarcina statutul eliminÄƒ cu succes',0),(541308,15037,'et','TÃ¶Ã¶Ã¼lesande oleku kustutamine Ãµnnestus',0),(541309,15037,'si','Stanje opravila Ärta Sucessfully',0),(541310,15037,'ba','Tugas Status dihapus berhasil',0),(541311,15037,'nl','Taakstatus verwijderd Sucessfully',0),(541312,15037,'fi','TehtÃ¤vÃ¤n tilan poistaminen onnistui',0),(541313,15037,'no','Aktivitetsstatusen slettet ble',0),(541314,15037,'da','Opgavestatus slettet Sucessfully',0),(541315,15037,'ko','ìž‘ì—… ìƒíƒœë¥¼ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ',0),(541316,15037,'he','×ž×¦×‘ ×¤×¢×™×œ×•×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(541317,15037,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¹ÏŽÎ½ Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(541318,15037,'zh','ä»»åŠ¡çŠ¶æ€åˆ é™¤æˆåŠŸ',0),(541319,15037,'sv','Aktivitetsstatus bort framgÃ¥ngsrikt',0),(541320,15037,'it','Stato attivitÃ  cancellati con successo',0),(541321,15037,'tl','',0),(541322,15037,'th','à¸ªà¸–à¸²à¸™à¸°à¸‚à¸­à¸‡à¸‡à¸²à¸™à¸¥à¸šà¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(541323,15037,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(541324,15037,'ms','Tugas Status dihapuskan berjaya',0),(541325,15037,'ar','Ø­Ø°Ù Ø­Ø§Ù„Ø© Ø§Ù„Ù…Ù‡Ù…Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(541326,15037,'fr','Ã‰tat de la tÃ¢che supprimÃ©e avec succÃ¨s',0),(541327,15037,'jp','ã‚¿ã‚¹ã‚¯ã®é€²æ—çŠ¶æ³ã¯æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸã€‚',0),(541328,15037,'pt','Status da tarefa excluÃ­do com Ãªxito',0),(541329,15037,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð´Ð°Ñ‡Ð¸ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541330,15037,'es','Estado de la tarea eliminado correctamente',0),(541331,15037,'de','Task-Status gelÃ¶scht wurde erfolgreich',0),(541332,15037,'en','Task Status Deleted Sucessfully',0),(541333,15038,'is','',0),(541334,15038,'dr','Ú©Ø§Ø± ÙˆØ¶Ø¹ÛŒØª Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(541335,15038,'pr','Ú©Ø§Ø± ÙˆØ¶Ø¹ÛŒØª Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(541336,15038,'tr','GÃ¶rev durumu yeni/DÃ¼zenle',0),(541337,15038,'pl','Zadania stan Nowy/edycja',0),(541338,15038,'bg','Ð—Ð°Ð´Ð°Ñ‡Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð¾Ð²Ð¸/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(541339,15038,'ur','Ú©Ø§Ù… Ø­Ø§Ù„Øª Ù†Ø¦Û’/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(541340,15038,'sr','Ð—Ð°Ð´Ð°Ñ‚Ð°Ðº Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð½Ð¾Ð²Ð¸Ñ…/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(541341,15038,'vi','Nhiá»‡m vá»¥ má»›i/tÃ¬nh tráº¡ng chá»‰nh sá»­a',0),(541342,15038,'af','Taak Status nuwe/redigeer',0),(541343,15038,'ro','Sarcina stare nou/editare',0),(541344,15038,'et','TÃ¶Ã¶Ã¼lesande oleku uus/Muuda',0),(541345,15038,'si','Nalogo Status novo/Uredi',0),(541346,15038,'ba','Tugas Status baru/Edit',0),(541347,15038,'nl','Taak Status nieuwe/bewerken',0),(541348,15038,'fi','TehtÃ¤vÃ¤n tila uusi tai Muokkaa',0),(541349,15038,'no','Oppgave statusen ny/Rediger',0),(541350,15038,'da','Opgave Status ny/Rediger',0),(541351,15038,'ko','ìž‘ì—… ìƒíƒœ ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘',0),(541352,15038,'he','×¤×¢×™×œ×•×ª ×ž×¦×‘ ×—×“×©/×¢×¨×™×›×”',0),(541353,15038,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¹ÏŽÎ½ Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(541354,15038,'zh','ä»»åŠ¡çŠ¶æ€æ–°å»º/ç¼–è¾‘',0),(541355,15038,'sv','Uppgift Status ny/redigera',0),(541356,15038,'it','Compito Status nuovo/modifica',0),(541357,15038,'tl','',0),(541358,15038,'th','à¸‡à¸²à¸™à¸ªà¸–à¸²à¸™à¸°à¹ƒà¸«à¸¡à¹ˆà¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚',0),(541359,15038,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¨à¤/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(541360,15038,'ms','Tugas Status baru/Edit',0),(541361,15038,'ar','Ù…Ù‡Ù…Ø© Ø§Ù„Ù…Ø±ÙƒØ² Ø§Ù„Ø¬Ø¯ÙŠØ¯/ØªØ­Ø±ÙŠØ±',0),(541362,15038,'fr','TÃ¢che nouveau statut/modifier',0),(541363,15038,'jp','ã‚¿ã‚¹ã‚¯ã®çŠ¶æ…‹æ–°ã—ã„/ç·¨é›†',0),(541364,15038,'pt','Status de tarefa nova/editar',0),(541365,15038,'ru','Ð—Ð°Ð´Ð°Ñ‡Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ Ð½Ð¾Ð²Ñ‹Ñ… Ð¸ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(541366,15038,'es','Tarea estado nuevo o editar',0),(541367,15038,'de','Task Status neu/bearbeiten',0),(541368,15038,'en','Task Status New/Edit',0),(541369,15039,'is','',0),(541370,15039,'dr','ÙˆØ¶Ø¹ÛŒØª ÙˆØ¸ÛŒÙÙ‡ Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(541371,15039,'pr','ÙˆØ¶Ø¹ÛŒØª ÙˆØ¸ÛŒÙÙ‡ Ø°Ø®ÛŒØ±Ù‡ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(541372,15039,'tr','GÃ¶rev durumu baÅŸarÄ±yla kaydedildi',0),(541373,15039,'pl','Stan zadania zapisane pomyÅ›lnie',0),(541374,15039,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð·Ð°Ð´Ð°Ñ‡Ð°Ñ‚Ð°, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541375,15039,'ur','Ø³Ú©ÛŒØ³ÙÙˆÙ„Ù„ Ù…Ø­ÙÙˆØ¸ Ø­Ø§Ù„Øª Ú©Ø§Ù…',0),(541376,15039,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð´Ð°Ñ‚ÐºÐ° ÑÐ¿Ð°ÑÐ°Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541377,15039,'vi','Tráº¡ng thÃ¡i nhiá»‡m vá»¥ lÆ°u thÃ nh cÃ´ng',0),(541378,15039,'af','Taak Status suksesvol gestoor',0),(541379,15039,'ro','Starea de sarcina salvat cu succes',0),(541380,15039,'et','TÃ¶Ã¶Ã¼lesande olek salvestatakse edukalt',0),(541381,15039,'si','Shranjena stanja opravila uspeÅ¡no',0),(541382,15039,'ba','Tugas Status disimpan berhasil',0),(541383,15039,'nl','Taakstatus opgeslagen Sucessfully',0),(541384,15039,'fi','TehtÃ¤vÃ¤n tila tallennettu onnistuneesti',0),(541385,15039,'no','Aktivitetsstatus lagret Sucessfully',0),(541386,15039,'da','Opgavestatus gemt Sucessfully',0),(541387,15039,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ ëœ ìž‘ì—… ìƒíƒœ',0),(541388,15039,'he','×ž×¦×‘ ×¤×¢×™×œ×•×ª × ×©×ž×¨ ×‘×”×¦×œ×—×”',0),(541389,15039,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(541390,15039,'zh','ä¿å­˜æˆåŠŸçš„ä»»åŠ¡çŠ¶æ€',0),(541391,15039,'sv','Aktivitetsstatus sparade framgÃ¥ngsrikt',0),(541392,15039,'it','Stato dello compito salvato con successo',0),(541393,15039,'tl','',0),(541394,15039,'th','à¸ªà¸–à¸²à¸™à¸°à¸‚à¸­à¸‡à¸‡à¸²à¸™à¸šà¸±à¸™à¸—à¸¶à¸à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(541395,15039,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤•à¤¾à¤°à¥à¤¯ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(541396,15039,'ms','Tugas Status disimpan berjaya',0),(541397,15039,'ar','Ø­ÙØ¸ Ø­Ø§Ù„Ø© Ø§Ù„Ù…Ù‡Ù…Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(541398,15039,'fr','Ã‰tat de la tÃ¢che enregistrÃ©e avec succÃ¨s',0),(541399,15039,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚ŒãŸã‚¿ã‚¹ã‚¯ã®é€²æ—çŠ¶æ³',0),(541400,15039,'pt','Status da tarefa salvo com sucesso',0),(541401,15039,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð·Ð°Ð´Ð°Ñ‡Ð¸, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(541402,15039,'es','Estado de la tarea de guardado correctamente',0),(541403,15039,'de','Task-Status wurde erfolgreich gespeichert',0),(541404,15039,'en','Task Status Saved Sucessfully',0),(541405,15040,'is','',0),(541406,15040,'dr','ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ø­Ø°Ù Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(541407,15040,'pr','ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ø­Ø°Ù Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(541408,15040,'tr','EtkinliÄŸi baÅŸarÄ±yla silindi',0),(541409,15040,'pl','PomyÅ›lnie usuniÄ™to aktywnoÅ›Ä‡',0),(541410,15040,'bg','Ð”ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541411,15040,'ur','Ø³Ú©ÛŒØ³ÙÙˆÙ„Ù„ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ø­Ø°Ù Ø´Ø¯Û',0),(541412,15040,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541413,15040,'vi','Hoáº¡t Ä‘á»™ng xÃ³a thÃ nh cÃ´ng',0),(541414,15040,'af','Aktiwiteit suksesvol geskrap',0),(541415,15040,'ro','Activitate eliminÄƒ cu succes',0),(541416,15040,'et','Tegevuse kustutamine Ãµnnestus',0),(541417,15040,'si','Dejavnost, izbrisana Sucessfully',0),(541418,15040,'ba','Aktivitas dihapus berhasil',0),(541419,15040,'nl','Activiteit verwijderd Sucessfully',0),(541420,15040,'fi','TehtÃ¤vÃ¤n poistaminen onnistui',0),(541421,15040,'no','Aktiviteten slettet ble',0),(541422,15040,'da','Slettes aktiviteten Sucessfully',0),(541423,15040,'ko','í™œë™ ì‚­ì œë¥¼ ì„±ê³µì ìœ¼ë¡œ',0),(541424,15040,'he','×¤×¢×™×œ×•×ª × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(541425,15040,'el','Î”ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(541426,15040,'zh','æˆåŠŸåˆ é™¤æ´»åŠ¨',0),(541427,15040,'sv','Aktiviteten bort framgÃ¥ngsrikt',0),(541428,15040,'it','AttivitÃ  cancellati con successo',0),(541429,15040,'tl','',0),(541430,15040,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸¥à¸šà¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(541431,15040,'hi','à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤•à¥‹ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(541432,15040,'ms','Aktiviti dipadam berjaya',0),(541433,15040,'ar','Ø­Ø°Ù Ù†Ø´Ø§Ø· Ø¨Ù†Ø¬Ø§Ø­',0),(541434,15040,'fr','ActivitÃ© supprimÃ©e avec succÃ¨s',0),(541435,15040,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ã¯æ­£å¸¸ã«å‰Šé™¤',0),(541436,15040,'pt','Atividade excluÃ­do com Ãªxito',0),(541437,15040,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(541438,15040,'es','Actividad eliminado correctamente',0),(541439,15040,'de','AktivitÃ¤t gelÃ¶scht wurde erfolgreich',0),(541440,15040,'en','Activity Deleted Sucessfully',0),(541441,15041,'is','',0),(541442,15041,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙØ¹Ø§Ù„ÛŒØª',0),(541443,15041,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙØ¹Ø§Ù„ÛŒØª',0),(541444,15041,'tr','Etkinlik Ekle',0),(541445,15041,'pl','Dodaj aktywnoÅ›Ä‡',0),(541446,15041,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(541447,15041,'ur','Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(541448,15041,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(541449,15041,'vi','ThÃªm hoáº¡t Ä‘á»™ng',0),(541450,15041,'af','Voeg aktiwiteit',0),(541451,15041,'ro','Adauga activitate',0),(541452,15041,'et','Lisa tegevus',0),(541453,15041,'si','Dodajte dejavnost',0),(541454,15041,'ba','Tambahkan aktivitas',0),(541455,15041,'nl','Activiteit toevoegen',0),(541456,15041,'fi','LisÃ¤Ã¤ aktiviteetti',0),(541457,15041,'no','Legge til aktivitet',0),(541458,15041,'da','TilfÃ¸je aktivitet',0),(541459,15041,'ko','ì¶”ê°€ í™œë™',0),(541460,15041,'he','×œ×”×•×¡×™×£ ×¤×¢×™×œ×•×ª',0),(541461,15041,'el','Î— Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼Î¹Î±Ï‚ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚',0),(541462,15041,'zh','æ·»åŠ æ´»åŠ¨',0),(541463,15041,'sv','LÃ¤gg till aktivitet',0),(541464,15041,'it','Aggiungi attivitÃ ',0),(541465,15041,'tl','',0),(541466,15041,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸´à¸ˆà¸à¸£à¸£à¸¡',0),(541467,15041,'hi','à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(541468,15041,'ms','Tambah aktiviti',0),(541469,15041,'ar','Ø¥Ø¶Ø§ÙØ© Ù†Ø´Ø§Ø·',0),(541470,15041,'fr','Ajouter une activitÃ©',0),(541471,15041,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(541472,15041,'pt','Adicionar atividade',0),(541473,15041,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(541474,15041,'es','Agregar actividad',0),(541475,15041,'de','AktivitÃ¤t hinzufÃ¼gen',0),(541476,15041,'en','Add Activity',0),(541477,15042,'is','',0),(541478,15042,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙØ¹Ø§Ù„ÛŒØª Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ Ù‡Ø§ÛŒ Ù…Ø®ØªÙ„Ù',0),(541479,15042,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙØ¹Ø§Ù„ÛŒØª Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ Ù‡Ø§ÛŒ Ù…Ø®ØªÙ„Ù',0),(541480,15042,'tr','FarklÄ± mÃ¼ÅŸteri aktivite Ekle',0),(541481,15042,'pl','Dodaj aktywnoÅ›Ä‡ dla rÃ³Å¼nych klientÃ³w',0),(541482,15042,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° Ð´Ñ€ÑƒÐ³ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(541483,15042,'ur','Ù…Ø®ØªÙ„Ù Ú¯Ø§ÛÚ©ÙˆÚº Ú©Û’ Ù„ÛŒÛ’ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(541484,15042,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð·Ð° Ð´Ñ€ÑƒÐ³Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð°',0),(541485,15042,'vi','ThÃªm hoáº¡t Ä‘á»™ng cho cÃ¡c khÃ¡ch hÃ ng khÃ¡c nhau',0),(541486,15042,'af','Voeg aktiwiteit vir verskillende kliÃ«nte',0),(541487,15042,'ro','Adauga activitate pentru diferite client',0),(541488,15042,'et','Lisa tegevus erinevate kliendi',0),(541489,15042,'si','Dodajte dejavnost za razliÄne stranke',0),(541490,15042,'ba','Menambahkan aktivitas untuk pelanggan yang berbeda',0),(541491,15042,'nl','Activiteit toevoegen voor verschillende klant',0),(541492,15042,'fi','LisÃ¤Ã¤ aktiviteetti asiakkaaseen',0),(541493,15042,'no','Legge til aktivitet For ulike kunde',0),(541494,15042,'da','TilfÃ¸j aktivitet For forskellige kunde',0),(541495,15042,'ko','ë‹¤ë¥¸ ê³ ê°ì— ëŒ€ í•œ í™œë™ ì¶”ê°€',0),(541496,15042,'he','×œ×”×•×¡×™×£ ×¤×¢×™×œ×•×ª ×¢×‘×•×¨ ×œ×§×•×—×•×ª ×©×•× ×™×',0),(541497,15042,'el','Î— Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼Î¹Î±Ï‚ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚ Î³Î¹Î± Î´Î¹Î±Ï†Î¿ÏÎµÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(541498,15042,'zh','é’ˆå¯¹ä¸åŒçš„å®¢æˆ·æ·»åŠ æ´»åŠ¨',0),(541499,15042,'sv','LÃ¤gg till aktivitet fÃ¶r annan kund',0),(541500,15042,'it','Aggiungi attivitÃ  per clienti diversi',0),(541501,15042,'tl','',0),(541502,15042,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸à¸±à¸™',0),(541503,15042,'hi','à¤µà¤¿à¤­à¤¿à¤¨à¥à¤¨ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(541504,15042,'ms','Tambah aktiviti untuk pelanggan yang berbeza',0),(541505,15042,'ar','Ø¥Ø¶Ø§ÙØ© Ù†Ø´Ø§Ø· Ù„Ù…Ø®ØªÙ„Ù Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(541506,15042,'fr','Ajouter une activitÃ© pour diffÃ©rents clients',0),(541507,15042,'jp','åˆ¥ã®é¡§å®¢ã®ãŸã‚ã®ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(541508,15042,'pt','Adicionar atividade para clientes diferentes',0),(541509,15042,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð´Ð»Ñ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ñ‹Ñ… ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(541510,15042,'es','Agregar actividad para diferentes clientes',0),(541511,15042,'de','HinzufÃ¼gen von AktivitÃ¤ten fÃ¼r verschiedene Kunden',0),(541512,15042,'en','Add Activity For Different Customer',0),(541513,15043,'is','',0),(541514,15043,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙØ¹Ø§Ù„ÛŒØª Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø®ØªÙ„Ù',0),(541515,15043,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙØ¹Ø§Ù„ÛŒØª Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…Ø®ØªÙ„Ù',0),(541516,15043,'tr','FarklÄ± satÄ±cÄ± iÃ§in aktivite Ekle',0),(541517,15043,'pl','Dodaj aktywnoÅ›Ä‡ dla rÃ³Å¼nych dostawcÃ³w',0),(541518,15043,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° Ð´Ñ€ÑƒÐ³ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(541519,15043,'ur','Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù…Ø®ØªÙ„Ù ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(541520,15043,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð·Ð° Ð´Ñ€ÑƒÐ³Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(541521,15043,'vi','ThÃªm hoáº¡t Ä‘á»™ng cho cÃ¡c nhÃ  cung cáº¥p khÃ¡c nhau',0),(541522,15043,'af','Voeg aktiwiteit vir verskillende handelaar',0),(541523,15043,'ro','Adauga activitate pentru alt furnizor',0),(541524,15043,'et','Lisa tegevus erineva hankija',0),(541525,15043,'si','Dodajte dejavnost za drugega dobavitelja',0),(541526,15043,'ba','Menambahkan aktivitas untuk Vendor yang berbeda',0),(541527,15043,'nl','Activiteit toevoegen voor andere leverancier',0),(541528,15043,'fi','LisÃ¤Ã¤ aktiviteetti toimittajatapahtumat',0),(541529,15043,'no','Legge til aktivitet For annen leverandÃ¸r',0),(541530,15043,'da','TilfÃ¸j aktivitet For anden leverandÃ¸r',0),(541531,15043,'ko','ë‹¤ë¥¸ ê³µê¸‰ ì—…ì²´ì— ëŒ€ í•œ í™œë™ ì¶”ê°€',0),(541532,15043,'he','×œ×”×•×¡×™×£ ×¤×¢×™×œ×•×ª ×¢×‘×•×¨ ×¡×¤×§×™× ×©×•× ×™×',0),(541533,15043,'el','Î— Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î¼Î¹Î±Ï‚ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚ Î³Î¹Î± Î¬Î»Î»Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(541534,15043,'zh','ä¸ºä¸åŒçš„ä¾›åº”å•†æ·»åŠ æ´»åŠ¨',0),(541535,15043,'sv','LÃ¤gg till aktivitet fÃ¶r annan leverantÃ¶r',0),(541536,15043,'it','Aggiungi attivitÃ  per diversi Vendor',0),(541537,15043,'tl','',0),(541538,15043,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸—à¸µà¹ˆà¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸à¸±à¸™',0),(541539,15043,'hi','à¤µà¤¿à¤­à¤¿à¤¨à¥à¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(541540,15043,'ms','Menambah aktiviti untuk penjual yang berbeza',0),(541541,15043,'ar','Ø¥Ø¶Ø§ÙØ© Ù†Ø´Ø§Ø· Ù„Ø¨Ø§Ø¦Ø¹ Ù…Ø®ØªÙ„ÙØ©',0),(541542,15043,'fr','Ajouter une activitÃ© de fournisseur diffÃ©rent',0),(541543,15043,'jp','ç•°ãªã‚‹ãƒ™ãƒ³ãƒ€ãƒ¼ã®æ´»å‹•ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(541544,15043,'pt','Adicionar atividade para outro fornecedor',0),(541545,15043,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð´Ð»Ñ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ñ‹Ñ… Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(541546,15043,'es','Agregar actividad por diferentes proveedores',0),(541547,15043,'de','HinzufÃ¼gen von AktivitÃ¤ten fÃ¼r verschiedene Hersteller',0),(541548,15043,'en','Add Activity For Different Vendor',0),(541549,15044,'is','',0),(541550,15044,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙØ¹Ø§Ù„ÛŒØª Ø¬Ø¯ÛŒØ¯',0),(541551,15044,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙØ¹Ø§Ù„ÛŒØª Ø¬Ø¯ÛŒØ¯',0),(541552,15044,'tr','Yeni aktivite Ekle',0),(541553,15044,'pl','Dodaj nowÄ… dziaÅ‚alnoÅ›Ä‡',0),(541554,15044,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð²Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(541555,15044,'ur','Ù†Ø¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(541556,15044,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(541557,15044,'vi','ThÃªm má»›i hoáº¡t Ä‘á»™ng',0),(541558,15044,'af','Voeg nuwe aktiwiteit',0),(541559,15044,'ro','Adauga noua activitate',0),(541560,15044,'et','Lisa uus tegevus',0),(541561,15044,'si','Dodajte novo dejavnost',0),(541562,15044,'ba','Tambahkan aktivitas baru',0),(541563,15044,'nl','Nieuwe activiteit toevoegen',0),(541564,15044,'fi','LisÃ¤Ã¤ uusi aktiviteetti',0),(541565,15044,'no','Legg til ny aktivitet',0),(541566,15044,'da','TilfÃ¸j ny aktivitet',0),(541567,15044,'ko','ìƒˆ ìž‘ì—… ì¶”ê°€',0),(541568,15044,'he','×”×•×¡×£ ×¤×¢×™×œ×•×ª ×—×“×©×”',0),(541569,15044,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î±Ï‚ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚',0),(541570,15044,'zh','æ·»åŠ æ–°çš„æ´»åŠ¨',0),(541571,15044,'sv','LÃ¤gg till ny aktivitet',0),(541572,15044,'it','Aggiungi nuova attivitÃ ',0),(541573,15044,'tl','',0),(541574,15044,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¹ƒà¸«à¸¡à¹ˆ',0),(541575,15044,'hi','à¤¨à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(541576,15044,'ms','Tambah aktiviti baru',0),(541577,15044,'ar','Ø¥Ø¶Ø§ÙØ© Ù†Ø´Ø§Ø· Ø¬Ø¯ÙŠØ¯',0),(541578,15044,'fr','Ajouter une nouvelle activitÃ©',0),(541579,15044,'jp','æ–°ã—ã„ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(541580,15044,'pt','Adicionar nova atividade',0),(541581,15044,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð²Ð¸Ð´ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(541582,15044,'es','Agregar nueva actividad',0),(541583,15044,'de','Neue AktivitÃ¤t hinzufÃ¼gen',0),(541584,15044,'en','Add New Activity',0),(541585,15045,'is','',0),(541586,15045,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙØ¹Ø§Ù„ÛŒØª Ø¬Ø¯ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±',0),(541587,15045,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ÙØ¹Ø§Ù„ÛŒØª Ø¬Ø¯ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±',0),(541588,15045,'tr','Yeni etkinlik iÃ§in gÃ¶rev ekleme',0),(541589,15045,'pl','Dodaj nowÄ… dziaÅ‚alnoÅ›Ä‡ dla zadania',0),(541590,15045,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð½Ð¾Ð²Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° Ð·Ð°Ð´Ð°Ñ‡Ð°',0),(541591,15045,'ur','Ú©Ø§Ù… Ú©Û’ Ù„Ø¦Û’ Ù†Ø¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(541592,15045,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð·Ð° Ð·Ð°Ð´Ð°Ñ‚Ð°Ðº',0),(541593,15045,'vi','ThÃªm má»›i hoáº¡t Ä‘á»™ng cho nhiá»‡m vá»¥',0),(541594,15045,'af','Voeg nuwe aktiwiteit vir taak',0),(541595,15045,'ro','Adauga noua activitate pentru sarcina',0),(541596,15045,'et','Lisa uus tegevus Ã¼lesanne',0),(541597,15045,'si','Dodajte novo dejavnost za nalogo',0),(541598,15045,'ba','Tambahkan aktivitas baru untuk tugas',0),(541599,15045,'nl','Nieuwe activiteit voor taak toevoegen',0),(541600,15045,'fi','LisÃ¤Ã¤ uusi aktiviteetti tehtÃ¤vÃ¤n',0),(541601,15045,'no','Legg til ny aktivitet For aktivitet',0),(541602,15045,'da','TilfÃ¸j ny aktivitet For opgave',0),(541603,15045,'ko','ìž‘ì—…ì— ëŒ€ í•œ ìƒˆ ìž‘ì—… ì¶”ê°€',0),(541604,15045,'he','×”×•×¡×£ ×¤×¢×™×œ×•×ª ×—×“×©×” ×¢×‘×•×¨ ×¤×¢×™×œ×•×ª',0),(541605,15045,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î³Î¹Î± ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(541606,15045,'zh','ä¸ºä»»åŠ¡æ·»åŠ æ–°çš„æ´»åŠ¨',0),(541607,15045,'sv','LÃ¤gg till ny aktivitet fÃ¶r uppgift',0),(541608,15045,'it','Aggiungere una nuova attivitÃ  per attivitÃ ',0),(541609,15045,'tl','',0),(541610,15045,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¹ƒà¸«à¸¡à¹ˆà¸ªà¸³à¸«à¸£à¸±à¸šà¸‡à¸²à¸™',0),(541611,15045,'hi','à¤¨à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¾à¤°à¥à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(541612,15045,'ms','Tambah aktiviti baru bagi tugas',0),(541613,15045,'ar','Ø¥Ø¶Ø§ÙØ© Ù†Ø´Ø§Ø· Ø¬Ø¯ÙŠØ¯ Ù„Ù„Ù…Ù‡Ù…Ø©',0),(541614,15045,'fr','Ajouter une nouvelle activitÃ© pour tÃ¢che',0),(541615,15045,'jp','ã‚¿ã‚¹ã‚¯ã®æ–°ã—ã„æ´»å‹•ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(541616,15045,'pt','Adicionar nova atividade para a tarefa',0),(541617,15045,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð²Ð¸Ð´ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸ Ð´Ð»Ñ Ð·Ð°Ð´Ð°Ñ‡Ð¸',0),(541618,15045,'es','Agregar nueva actividad para la tarea',0),(541619,15045,'de','Neue AktivitÃ¤t fÃ¼r Aufgabe hinzufÃ¼gen',0),(541620,15045,'en','Add New Activity For Task',0),(541621,15046,'is','',0),(541622,15046,'dr','Ù…ÛŒØ²Ø§Ù† Ø§Ø¹ØªÙ…Ø§Ø¯ Ø¨Ù‡ Ù†ÙØ³',0),(541623,15046,'pr','Ù…ÛŒØ²Ø§Ù† Ø§Ø¹ØªÙ…Ø§Ø¯ Ø¨Ù‡ Ù†ÙØ³',0),(541624,15046,'tr','Tutar gÃ¼ven',0),(541625,15046,'pl','IloÅ›Ä‡ zaufania',0),(541626,15046,'bg','Ð¡ÑƒÐ¼Ð° Ð´Ð¾Ð²ÐµÑ€Ð¸Ðµ',0),(541627,15046,'ur','Ø±Ù‚Ù… Ù¾Ø± Ø§Ø¹ØªÙ…Ø§Ø¯',0),(541628,15046,'sr','Ð˜Ð·Ð½Ð¾Ñ ÑÐ°Ð¼Ð¾Ð¿Ð¾ÑƒÐ·Ð´Ð°ÑšÐµ',0),(541629,15046,'vi','Sá»‘ lÆ°á»£ng sá»± tá»± tin',0),(541630,15046,'af','Bedrag vertroue',0),(541631,15046,'ro','Suma de Ã®ncredere',0),(541632,15046,'et','Summa usaldust',0),(541633,15046,'si','KoliÄino zaupanja',0),(541634,15046,'ba','Jumlah keyakinan',0),(541635,15046,'nl','Bedrag vertrouwen',0),(541636,15046,'fi','MÃ¤Ã¤rÃ¤ luottamusta',0),(541637,15046,'no','BelÃ¸pet tillit',0),(541638,15046,'da','MÃ¦ngde tillid',0),(541639,15046,'ko','ê¸ˆì•¡ ìžì‹ ê°',0),(541640,15046,'he','×›×ž×•×ª ×‘×™×˜×—×•×Ÿ',0),(541641,15046,'el','Î Î¿ÏƒÏŒ ÎµÎ¼Ï€Î¹ÏƒÏ„Î¿ÏƒÏÎ½Î·Ï‚',0),(541642,15046,'zh','é‡‘é¢ä¿¡å¿ƒ',0),(541643,15046,'sv','Beloppet fÃ¶rtroende',0),(541644,15046,'it','Fiducia di quantitÃ ',0),(541645,15046,'tl','',0),(541646,15046,'th','à¸¡à¸±à¹ˆà¸™à¹ƒà¸ˆà¸¢à¸­à¸”',0),(541647,15046,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤†à¤¤à¥à¤®à¤µà¤¿à¤¶à¥à¤µà¤¾à¤¸',0),(541648,15046,'ms','Jumlah keyakinan',0),(541649,15046,'ar','Ù…Ù‚Ø¯Ø§Ø± Ø§Ù„Ø«Ù‚Ø©',0),(541650,15046,'fr','Confiance de montant',0),(541651,15046,'jp','é‡ã®ä¿¡é ¼',0),(541652,15046,'pt','ConfianÃ§a de quantidade',0),(541653,15046,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð´Ð¾Ð²ÐµÑ€Ð¸Ñ',0),(541654,15046,'es','Confianza de cantidad',0),(541655,15046,'de','Menge Vertrauen',0),(541656,15046,'en','Amount Confidence',0),(541657,15047,'is','',0),(541658,15047,'dr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± ØªØ¹ÛŒÛŒÙ†',0),(541659,15047,'pr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± ØªØ¹ÛŒÛŒÙ†',0),(541660,15047,'tr','Otomatik olarak atanan kiÅŸi',0),(541661,15047,'pl','Kontakt automatycznie przypisany',0),(541662,15047,'bg','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¿Ñ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°',0),(541663,15047,'ur','Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯',0),(541664,15047,'sr','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð´Ð¾Ð´ÐµÑ™ÑƒÑ˜Ðµ',0),(541665,15047,'vi','CÃ¡c sá»‘ liÃªn láº¡c Ä‘Æ°á»£c gÃ¡n tá»± Ä‘á»™ng',0),(541666,15047,'af','Kontak outomaties toegeken',0),(541667,15047,'ro','Contact atribuie automat',0),(541668,15047,'et','Automaatselt mÃ¤Ã¤ratud kontakt',0),(541669,15047,'si','Stiku samodejno dodeli',0),(541670,15047,'ba','Kontak secara otomatis ditetapkan',0),(541671,15047,'nl','Contactpersoon automatisch toegewezen',0),(541672,15047,'fi','Automaattisesti kontaktin',0),(541673,15047,'no','Kontakt automatisk tilordnet',0),(541674,15047,'da','Kontakt automatisk tildelt',0),(541675,15047,'ko','ì—°ë½ì²˜ ìžë™ìœ¼ë¡œ í• ë‹¹',0),(541676,15047,'he','×§×©×¨ ×ž×•×§×¦×” ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(541677,15047,'el','Î•Ï€Î±Ï†Î® Î­Ï‡ÎµÎ¹ Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎµÎ¹ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î±',0),(541678,15047,'zh','è‡ªåŠ¨åˆ†é…çš„è”ç³»äºº',0),(541679,15047,'sv','Kontakt tilldelas automatiskt',0),(541680,15047,'it','Contatto assegnato automaticamente',0),(541681,15047,'tl','',0),(541682,15047,'th','à¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­à¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”à¹ƒà¸«à¹‰à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(541683,15047,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(541684,15047,'ms','Kenalan secara automatik ditugaskan',0),(541685,15047,'ar','Ø¬Ù‡Ø© Ø§Ù„Ø§ØªØµØ§Ù„ Ø§Ù„ØªÙŠ ØªÙ… ØªØ¹ÙŠÙŠÙ†Ù‡Ø§ ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹',0),(541686,15047,'fr','Contact automatiquement assignÃ©',0),(541687,15047,'jp','è‡ªå‹•çš„ã«å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¾ã™é€£çµ¡å…ˆ',0),(541688,15047,'pt','Contato atribuÃ­do automaticamente',0),(541689,15047,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñ‹ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð½Ð°Ð·Ð½Ð°Ñ‡Ð°ÐµÑ‚ÑÑ',0),(541690,15047,'es','Contacto asignada automÃ¡ticamente',0),(541691,15047,'de','Kontakt automatisch zugewiesen',0),(541692,15047,'en','Contact Automatically Assigned',0),(541693,15048,'is','',0),(541694,15048,'dr','Ø¹Ù…Ù„ÛŒØ§Øª ÙØ¹Ù„ÛŒ',0),(541695,15048,'pr','Ø¹Ù…Ù„ÛŒØ§Øª ÙØ¹Ù„ÛŒ',0),(541696,15048,'tr','GeÃ§erli eylem',0),(541697,15048,'pl','BieÅ¼Ä…ca akcja',0),(541698,15048,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(541699,15048,'ur','Ø­Ø§Ù„ÛŒÛ Ø¹Ù…Ù„',0),(541700,15048,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð° Ñ€Ð°Ð´ÑšÐ°',0),(541701,15048,'vi','HÃ nh Ä‘á»™ng hiá»‡n thá»i',0),(541702,15048,'af','Die huidige aksie',0),(541703,15048,'ro','AcÈ›iunea curentÄƒ',0),(541704,15048,'et','Praegune toiming',0),(541705,15048,'si','Trenutno dejanje',0),(541706,15048,'ba','Tindakan saat ini',0),(541707,15048,'nl','Huidige actie',0),(541708,15048,'fi','Nykyinen toimi',0),(541709,15048,'no','Gjeldende handling',0),(541710,15048,'da','NuvÃ¦rende handling',0),(541711,15048,'ko','í˜„ìž¬ ìž‘ì—…',0),(541712,15048,'he','×”×¤×¢×•×œ×” ×”× ×•×›×—×™×ª',0),(541713,15048,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î´ÏÎ¬ÏƒÎ·',0),(541714,15048,'zh','å½“å‰æ“ä½œ',0),(541715,15048,'sv','Aktuella Ã¥tgÃ¤rden',0),(541716,15048,'it','Azione corrente',0),(541717,15048,'tl','',0),(541718,15048,'th','à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(541719,15048,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¥à¤°à¤¿à¤¯à¤¾',0),(541720,15048,'ms','Tindakan semasa',0),(541721,15048,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(541722,15048,'fr','Action en cours',0),(541723,15048,'jp','ç¾åœ¨ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(541724,15048,'pt','AÃ§Ã£o atual',0),(541725,15048,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(541726,15048,'es','AcciÃ³n actual',0),(541727,15048,'de','Aktuelle Aktion',0),(541728,15048,'en','Current Action',0),(541729,15049,'is','',0),(541730,15049,'dr','Ù…Ø¨Ù„Øº Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø®Ø±ÛŒØ¯',0),(541731,15049,'pr','Ù…Ø¨Ù„Øº Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ø®Ø±ÛŒØ¯',0),(541732,15049,'tr','Tahmini satÄ±nalma tutarÄ±',0),(541733,15049,'pl','Kwota szacunkowa zakupu',0),(541734,15049,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð³Ð½Ð¾Ð·Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(541735,15049,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ø±Ù‚Ù…',0),(541736,15049,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ð¸Ð·Ð½Ð¾Ñ',0),(541737,15049,'vi','Sá»‘ tiá»n Æ°á»›c tÃ­nh mua',0),(541738,15049,'af','Geraamde aankoop bedrag',0),(541739,15049,'ro','Cantitate estimatÄƒ de cumpÄƒrare',0),(541740,15049,'et','Hinnangulise ostu summa',0),(541741,15049,'si','Znesek ocenjenih nabave',0),(541742,15049,'ba','Jumlah perkiraan pembelian',0),(541743,15049,'nl','Geschatte aankoopbedrag',0),(541744,15049,'fi','Arvioitu osto mÃ¤Ã¤rÃ¤',0),(541745,15049,'no','ForhÃ¥ndsberegnet innkjÃ¸p belÃ¸p',0),(541746,15049,'da','Estimeret KÃ¸b belÃ¸b',0),(541747,15049,'ko','ì˜ˆìƒëœ êµ¬ìž… ê¸ˆì•¡',0),(541748,15049,'he','×¡×›×•× ×¨×›×™×©×” ×ž×©×•×¢×¨',0),(541749,15049,'el','Î Î¿ÏƒÏŒ Î±Î³Î¿ÏÎ¬Ï‚ ÎµÎºÏ„Î¹Î¼Î¬Ï„Î±Î¹ ÏŒÏ„Î¹',0),(541750,15049,'zh','ä¼°è®¡çš„è´­ä¹°é‡',0),(541751,15049,'sv','Uppskattat inkÃ¶psbelopp',0),(541752,15049,'it','Importo stimato di acquisto',0),(541753,15049,'tl','',0),(541754,15049,'th','à¸¢à¸­à¸”à¸‹à¸·à¹‰à¸­à¹‚à¸”à¸¢à¸›à¸£à¸°à¸¡à¸²à¸“',0),(541755,15049,'hi','à¤–à¤°à¥€à¤¦ à¤•à¥‡ à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤°à¤¾à¤¶à¤¿',0),(541756,15049,'ms','Amaun anggaran pembelian',0),(541757,15049,'ar','Ù…Ø¨Ù„Øº Ø§Ù„Ø´Ø±Ø§Ø¡ Ø§Ù„Ù…Ù‚Ø¯Ø±Ø©',0),(541758,15049,'fr','Montant estimÃ© de l\'achat',0),(541759,15049,'jp','æŽ¨å®šè³¼å…¥é‡‘é¡',0),(541760,15049,'pt','Valor da compra estimado',0),(541761,15049,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÐ¼ÐµÑ‚Ð½Ñ‹Ñ… Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(541762,15049,'es','Monto estimado de compra',0),(541763,15049,'de','GeschÃ¤tzte Kaufbetrag',0),(541764,15049,'en','Estimated Purchase Amount',0),(541765,15050,'is','',0),(541766,15050,'dr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ù…ÛŒØ²Ø§Ù† ÙØ±ÙˆØ´',0),(541767,15050,'pr','Ø¨Ø±Ø¢ÙˆØ±Ø¯ Ù…ÛŒØ²Ø§Ù† ÙØ±ÙˆØ´',0),(541768,15050,'tr','Tahmini satÄ±ÅŸ tutarÄ±',0),(541769,15050,'pl','Szacowana kwota sprzedaÅ¼y',0),(541770,15050,'bg','ÐŸÑ€Ð¾Ð³Ð½Ð¾Ð·Ð½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ',0),(541771,15050,'ur','Ø³ÛŒÙ„Ø² Ú©Ø§ Ø§Ù†Ø¯Ø§Ø²Û Ù„Ú¯Ø§ÛŒØ§ Ú¯ÛŒØ§',0),(541772,15050,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð¸Ð·Ð½Ð¾Ñ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(541773,15050,'vi','Æ¯á»›c tÃ­nh sá»‘ lÆ°á»£ng bÃ¡n hÃ ng',0),(541774,15050,'af','Geskatte verkope bedrag',0),(541775,15050,'ro','Cantitate estimatÄƒ',0),(541776,15050,'et','Eeldatava mÃ¼Ã¼gi summa',0),(541777,15050,'si','PredraÄunski znesek prodaje',0),(541778,15050,'ba','Diperkirakan jumlah penjualan',0),(541779,15050,'nl','Geschatte omzet',0),(541780,15050,'fi','Arvioitu myyntisumma',0),(541781,15050,'no','Estimerte salgsbelÃ¸pet',0),(541782,15050,'da','Forventede salgsbelÃ¸b',0),(541783,15050,'ko','ì˜ˆìƒëœ íŒë§¤ ê¸ˆì•¡',0),(541784,15050,'he','××•×ž×“×Ÿ ×›×ž×•×ª ×”×ž×›×™×¨×•×ª',0),(541785,15050,'el','Î•ÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î¿ Ï€Î¿ÏƒÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(541786,15050,'zh','ä¼°è®¡é”€å”®é‡‘é¢',0),(541787,15050,'sv','BerÃ¤knade fÃ¶rsÃ¤ljningsbelopp',0),(541788,15050,'it','Importo stimato delle vendite',0),(541789,15050,'tl','',0),(541790,15050,'th','à¸›à¸£à¸°à¸¡à¸²à¸“à¸à¸²à¸£à¸¢à¸­à¸”à¸‚à¸²à¸¢',0),(541791,15050,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤°à¤¾à¤¶à¤¿',0),(541792,15050,'ms','Anggaran jumlah jualan',0),(541793,15050,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ù…Ù‚Ø¯Ø±Ø©',0),(541794,15050,'fr','Montant estimatif des ventes',0),(541795,15050,'jp','å£²ä¸Šé«˜æŽ¨å®šé¡',0),(541796,15050,'pt','Montante estimado de vendas',0),(541797,15050,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(541798,15050,'es','Monto estimado de ventas',0),(541799,15050,'de','GeschÃ¤tzte Verkaufsbetrag',0),(541800,15050,'en','Estimated Sales Amount',0),(541801,15051,'is','',0),(541802,15051,'dr','ØªÙ…Ø§Ø³ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(541803,15051,'pr','ØªÙ…Ø§Ø³ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡ Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(541804,15051,'tr','Ã–zel kiÅŸi zaten atandÄ±',0),(541805,15051,'pl','Ekskluzywne kontakt juÅ¼ zostaÅ‚ przypisany',0),(541806,15051,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÐµÐ»Ð½Ð°Ñ‚Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð²ÐµÑ‡Ðµ Ðµ Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½',0),(541807,15051,'ur','Ø®ØµÙˆØµÛŒ Ø±Ø§Ø¨Ø·Û Ú©Ùˆ Ù¾ÛÙ„Û’ ÛÛŒ ØªÙÙˆÛŒØ¶ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(541808,15051,'sr','Ð•ÐºÑÐºÐ»ÑƒÐ·Ð¸Ð²Ð½Ð¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ñ˜Ðµ Ð²ÐµÑ› Ð´Ð¾Ð´ÐµÑ™ÐµÐ½.',0),(541809,15051,'vi','Äá»™c quyá»n liÃªn há»‡ Ä‘Ã£ Ä‘Æ°á»£c chá»‰ Ä‘á»‹nh',0),(541810,15051,'af','Eksklusiewe kontak reeds geheg',0),(541811,15051,'ro','Contact exclusivÄƒ a fost deja alocat',0),(541812,15051,'et','Eksklusiivne kontakt on juba mÃ¤Ã¤ratud',0),(541813,15051,'si','IzkljuÄno stiku Å¾e dodeljena',0),(541814,15051,'ba','Hubungi eksklusif telah ditetapkan',0),(541815,15051,'nl','Exclusieve contactpersoon is al toegewezen',0),(541816,15051,'fi','Yksinomainen on jo mÃ¤Ã¤ritetty',0),(541817,15051,'no','Eksklusive kontakten er allerede tilordnet',0),(541818,15051,'da','Eksklusive kontakt allerede er blevet tildelt',0),(541819,15051,'ko','ë…ì  ì—°ë½ì²˜ ì´ë¯¸ í• ë‹¹ ëœ',0),(541820,15051,'he','×§×©×¨ ×‘×œ×¢×“×™×ª ×”×•×§×¦×” ×›×‘×¨',0),(541821,15051,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¹ÏƒÏ„Î¹ÎºÎ® ÎµÏ€Î±Ï†Î® Î­Ï‡ÎµÎ¹ Î®Î´Î· ÎµÎºÏ‡Ï‰ÏÎ·Î¸ÎµÎ¯',0),(541822,15051,'zh','å·²æŒ‡æ´¾ç‹¬å®¶è”ç³»',0),(541823,15051,'sv','Exklusiva kontakter har redan tilldelats',0),(541824,15051,'it','Contatto esclusivo Ã¨ giÃ  stato assegnato',0),(541825,15051,'tl','',0),(541826,15051,'th','à¸•à¸´à¸”à¸•à¹ˆà¸­à¹€à¸­à¸à¸ªà¸´à¸—à¸˜à¸´à¹Œà¹€à¸‰à¸žà¸²à¸°à¸šà¸¸à¸„à¸„à¸¥à¸–à¸¹à¸à¸à¸³à¸«à¸™à¸”à¹à¸¥à¹‰à¸§',0),(541827,15051,'hi','à¤…à¤¨à¤¨à¥à¤¯ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(541828,15051,'ms','Hubungi eksklusif sudah pun',0),(541829,15051,'ar','ØªÙ… Ø¨Ø§Ù„ÙØ¹Ù„ ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø§ØªØµØ§Ù„ Ø§Ù„Ø­ØµØ±ÙŠ',0),(541830,15051,'fr','Contact exclusif a Dâ”œâŒjâ”œÃ¡ â”œâŒtâ”œâŒ assignâ”œâŒ',0),(541831,15051,'jp','æŽ’ä»–çš„ãªæŽ¥è§¦ã«æ—¢ã«å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ã¾ã™ã€‚',0),(541832,15051,'pt','Contato exclusivo jÃ¡ tiver sido atribuÃ­do.',0),(541833,15051,'ru','Ð­ÐºÑÐºÐ»ÑŽÐ·Ð¸Ð²Ð½Ñ‹Ð¹ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ ÑƒÐ¶Ðµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½',0),(541834,15051,'es','Contacto exclusivo ya ha sido asignado.',0),(541835,15051,'de','Exklusive Kontakt wurde bereits zugewiesen',0),(541836,15051,'en','Exclusive Contact Has Already Been Assigned',0),(541837,15052,'is','',0),(541838,15052,'dr','ÙÛŒÙ„ØªØ± Ù„ÛŒØ³Øª',0),(541839,15052,'pr','ÙÛŒÙ„ØªØ± Ù„ÛŒØ³Øª',0),(541840,15052,'tr','Filtre listesi',0),(541841,15052,'pl','Lista filtrÃ³w',0),(541842,15052,'bg','Ð¤Ð¸Ð»Ñ‚Ñ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(541843,15052,'ur','ÙÛØ±Ø³Øª Ú©Ùˆ ÙÙ„Ù¹Ø± Ú©Ø±ÛŒÚº',0),(541844,15052,'sr','Ð›Ð¸ÑÑ‚Ð° Ñ„Ð¸Ð»Ñ‚ÐµÑ€Ð°',0),(541845,15052,'vi','Danh sÃ¡ch lá»c',0),(541846,15052,'af','Filter lys',0),(541847,15052,'ro','Lista de filtre',0),(541848,15052,'et','Loendi filtreerimiseks',0),(541849,15052,'si','Seznam filtrov',0),(541850,15052,'ba','Daftar Filter',0),(541851,15052,'nl','Lijst filteren',0),(541852,15052,'fi','Suodatinluettelo',0),(541853,15052,'no','Filterlisten',0),(541854,15052,'da','Filterliste',0),(541855,15052,'ko','í•„í„° ëª©ë¡',0),(541856,15052,'he','×¨×©×™×ž×ª ×”×ž×¡× × ×™×',0),(541857,15052,'el','Î›Î¯ÏƒÏ„Î± Ï†Î¯Î»Ï„ÏÏ‰Î½',0),(541858,15052,'zh','ç­›é€‰å™¨åˆ—è¡¨',0),(541859,15052,'sv','Filtrera listan',0),(541860,15052,'it','Elenco filtri',0),(541861,15052,'tl','',0),(541862,15052,'th','à¸à¸£à¸­à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸£à¸²à¸¢à¸à¸²à¸£',0),(541863,15052,'hi','à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤° à¤¸à¥‚à¤šà¥€',0),(541864,15052,'ms','Senarai penapis',0),(541865,15052,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¹ÙˆØ§Ù…Ù„ ØªØµÙÙŠØ©',0),(541866,15052,'fr','Liste de filtres',0),(541867,15052,'jp','ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼ä¸€è¦§',0),(541868,15052,'pt','Lista de filtros',0),(541869,15052,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ñ„Ð¸Ð»ÑŒÑ‚Ñ€Ð¾Ð²',0),(541870,15052,'es','Lista de filtros',0),(541871,15052,'de','Filterliste',0),(541872,15052,'en','Filter List',0),(541873,15053,'is','',0),(541874,15053,'dr','Ø¢Ø®Ø±ÛŒÙ† Ø¹Ù…Ù„ Ø´Ø±ÙˆØ¹',0),(541875,15053,'pr','Ø¢Ø®Ø±ÛŒÙ† Ø¹Ù…Ù„ Ø´Ø±ÙˆØ¹',0),(541876,15053,'tr','Son eylem Begin',0),(541877,15053,'pl','Ostatnia akcja Begin',0),(541878,15053,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð°',0),(541879,15053,'ur','Ø¢Ø®Ø±ÛŒ Ø¹Ù…Ù„ Ø´Ø±ÙˆØ¹',0),(541880,15053,'sr','ÐžÐ·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾ÑˆÐ»Ðµ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(541881,15053,'vi','Cuá»‘i cÃ¹ng hÃ nh Ä‘á»™ng báº¯t Ä‘áº§u',0),(541882,15053,'af','Laaste aksie Begin',0),(541883,15053,'ro','Ultima acÅ£iune Ã®ncepe',0),(541884,15053,'et','Viimase tegevuse algus',0),(541885,15053,'si','Zadnje dejanje Begin',0),(541886,15053,'ba','Terakhir aksi dimulai',0),(541887,15053,'nl','Laatste actie beginnen',0),(541888,15053,'fi','Viimeinen toiminta alkaa',0),(541889,15053,'no','Siste handling begynner',0),(541890,15053,'da','Sidste handling Begin',0),(541891,15053,'ko','ë§ˆì§€ë§‰ ìž‘ì—… ì‹œìž‘',0),(541892,15053,'he','×‘×’×™×Ÿ ×¤×¢×•×œ×” ××—×¨×•× ×”',0),(541893,15053,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î­Î½Î±ÏÎ¾Î· Î´ÏÎ¬ÏƒÎ·Ï‚',0),(541894,15053,'zh','æœ€åŽçš„è¡ŒåŠ¨å¼€å§‹',0),(541895,15053,'sv','Sista Ã¥tgÃ¤rden bÃ¶rja',0),(541896,15053,'it','Ultima azione Begin',0),(541897,15053,'tl','',0),(541898,15053,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(541899,15053,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤¶à¥à¤°à¥‚',0),(541900,15053,'ms','Mulakan tindakan terakhir',0),(541901,15053,'ar','Ø§Ù„Ù…Ø§Ø¶ÙŠ Ø¨Ø¯Ø¡ Ø§Ù„Ø¹Ù…Ù„',0),(541902,15053,'fr','DerniÃ¨re Action Begin',0),(541903,15053,'jp','æœ€å¾Œã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã®é–‹å§‹',0),(541904,15053,'pt','Ãšltima aÃ§Ã£o Begin',0),(541905,15053,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹ Begin',0),(541906,15053,'es','La acciÃ³n comienza',0),(541907,15053,'de','Letzte Aktion Begin',0),(541908,15053,'en','Last Action Begin',0),(541909,15054,'is','',0),(541910,15054,'dr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† Ø§Ù‚Ø¯Ø§Ù…',0),(541911,15054,'pr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† Ø§Ù‚Ø¯Ø§Ù…',0),(541912,15054,'tr','Son iÅŸlem tarihi',0),(541913,15054,'pl','Data ostatniej akcji',0),(541914,15054,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(541915,15054,'ur','Ø¹Ù…Ù„ Ú©Û’ Ø¢Ø®Ø±ÛŒ ØªØ§Ø±ÛŒØ®',0),(541916,15054,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ñ€Ð°Ð´ÑšÐµ',0),(541917,15054,'vi','NgÃ y hÃ nh Ä‘á»™ng cuá»‘i cÃ¹ng',0),(541918,15054,'af','Laaste aksie datum',0),(541919,15054,'ro','Ultima actiune data',0),(541920,15054,'et','Viimase tegevuse kuupÃ¤ev',0),(541921,15054,'si','Datum zadnje dejanje',0),(541922,15054,'ba','Tanggal tindakan terakhir',0),(541923,15054,'nl','Datum van laatste actie',0),(541924,15054,'fi','Viimeinen toiminta',0),(541925,15054,'no','Handlingsdato for siste',0),(541926,15054,'da','Sidste handling dato',0),(541927,15054,'ko','ë§ˆì§€ë§‰ ì•¡ì…˜ ë‚ ì§œ',0),(541928,15054,'he','×ª××¨×™×š ×”×¤×¢×•×œ×” ×”××—×¨×•× ×”',0),(541929,15054,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î—Î¼.',0),(541930,15054,'zh','ä¸Šä¸€æ“ä½œæ—¥æœŸ',0),(541931,15054,'sv','Senaste Ã¥tgÃ¤rdsdatum',0),(541932,15054,'it','Data dell\'ultima azione',0),(541933,15054,'tl','',0),(541934,15054,'th','à¸§à¸±à¸™à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(541935,15054,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(541936,15054,'ms','Tarikh tindakan',0),(541937,15054,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡ Ø§Ù„Ø£Ø®ÙŠØ±',0),(541938,15054,'fr','DerniÃ¨re Date de l\'Action',0),(541939,15054,'jp','æœ€å¾Œã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã®æ—¥ä»˜',0),(541940,15054,'pt','Data da Ãºltima aÃ§Ã£o',0),(541941,15054,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(541942,15054,'es','Ãšltima fecha de la acciÃ³n',0),(541943,15054,'de','AktivitÃ¤tsdatum der letzten',0),(541944,15054,'en','Last Action Date',0),(541945,15055,'is','',0),(541946,15055,'dr','Ø¢Ø®Ø±ÛŒÙ† Ø§Ù‚Ø¯Ø§Ù… Ù¾Ø§ÛŒØ§Ù†',0),(541947,15055,'pr','Ø¢Ø®Ø±ÛŒÙ† Ø§Ù‚Ø¯Ø§Ù… Ù¾Ø§ÛŒØ§Ù†',0),(541948,15055,'tr','Son eylem bitiÅŸ',0),(541949,15055,'pl','Ostatnia akcja koniec',0),(541950,15055,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÐºÑ€Ð°Ð¹',0),(541951,15055,'ur','Ø¢Ø®Ø±ÛŒ Ø¹Ù…Ù„ Ø®ØªÙ…',0),(541952,15055,'sr','Ð—Ð°Ð´ÑšÐ¸ ÐºÑ€Ð°Ñ˜ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(541953,15055,'vi','HÃ nh Ä‘á»™ng cuá»‘i',0),(541954,15055,'af','Laaste aksie einde',0),(541955,15055,'ro','Ultima acÅ£iune sfÃ¢rÅŸitul',0),(541956,15055,'et','Viimase tegevuse lÃµpp',0),(541957,15055,'si','Zadnje dejanje konec',0),(541958,15055,'ba','Akhir tindakan',0),(541959,15055,'nl','Laatste actie eind',0),(541960,15055,'fi','Viime toimintaa lopussa',0),(541961,15055,'no','Siste handling slutten',0),(541962,15055,'da','Sidste handling ende',0),(541963,15055,'ko','ë§ˆì§€ë§‰ ìž‘ì—… ë',0),(541964,15055,'he','×¡×™×•× ×¤×¢×•×œ×” ××—×¨×•× ×”',0),(541965,15055,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î´ÏÎ¬ÏƒÎ·Ï‚ Ï„Î­Î»Î¿Ï‚',0),(541966,15055,'zh','æœ€åŽçš„è¡ŒåŠ¨ç»“æŸ',0),(541967,15055,'sv','Sista Ã¥tgÃ¤rden avsluta',0),(541968,15055,'it','Ultima azione fine',0),(541969,15055,'tl','',0),(541970,15055,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(541971,15055,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤…à¤‚à¤¤',0),(541972,15055,'ms','Lepas tamat tindakan',0),(541973,15055,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡ Ø§Ù„Ø£Ø®ÙŠØ±',0),(541974,15055,'fr','DerniÃ¨re Action fin',0),(541975,15055,'jp','æœ€å¾Œã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(541976,15055,'pt','Ãšltima aÃ§Ã£o final',0),(541977,15055,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ ÐºÐ¾Ð½ÐµÑ† Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹',0),(541978,15055,'es','Fin de la acciÃ³n',0),(541979,15055,'de','Letzte Aktion Ende',0),(541980,15055,'en','Last Action End',0),(541981,15056,'is','',0),(541982,15056,'dr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ø¢Ø®Ø±ÛŒÙ†',0),(541983,15056,'pr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ø¢Ø®Ø±ÛŒÙ†',0),(541984,15056,'tr','Son Not',0),(541985,15056,'pl','Ostatnia uwaga',0),(541986,15056,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(541987,15056,'ur','Ø¢Ø®Ø±ÛŒ Ù†ÙˆÙ¹',0),(541988,15056,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ° Ð¿Ð¾Ñ€ÑƒÐºÐ°',0),(541989,15056,'vi','Cuá»‘i cÃ¹ng lÆ°u Ã½',0),(541990,15056,'af','Laaste Nota',0),(541991,15056,'ro','Ultima notÄƒ',0),(541992,15056,'et','Viimase noodi',0),(541993,15056,'si','Zadnja Opomba',0),(541994,15056,'ba','Catatan terakhir',0),(541995,15056,'nl','Laatste opmerking',0),(541996,15056,'fi','Edellinen Huomautus',0),(541997,15056,'no','Siste notat',0),(541998,15056,'da','Sidste BemÃ¦rk',0),(541999,15056,'ko','ë§ˆì§€ë§‰ ë©”ëª¨',0),(542000,15056,'he','×”×¢×¨×” ××—×¨×•× ×”',0),(542001,15056,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·',0),(542002,15056,'zh','æœ€åŽä¸€ä¸ªéŸ³ç¬¦',0),(542003,15056,'sv','Senaste notera',0),(542004,15056,'it','Ultima nota',0),(542005,15056,'tl','',0),(542006,15056,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(542007,15056,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤§à¥à¤¯à¤¾à¤¨ à¤¦à¥‡à¤‚',0),(542008,15056,'ms','Nota terakhir',0),(542009,15056,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø£Ø®ÙŠØ±Ø©',0),(542010,15056,'fr','Dernier billet',0),(542011,15056,'jp','æœ€å¾Œã®æ³¨æ„',0),(542012,15056,'pt','Ãšltima nota',0),(542013,15056,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÑÑ Ð½Ð¾Ñ‚Ð°',0),(542014,15056,'es','Ãšltima nota',0),(542015,15056,'de','Zuletzt eingegebene',0),(542016,15056,'en','Last Note',0),(542017,15057,'is','',0),(542018,15057,'dr','Ø¢Ø®Ø±ÛŒÙ† Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§',0),(542019,15057,'pr','Ø¢Ø®Ø±ÛŒÙ† Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§',0),(542020,15057,'tr','Son notlar',0),(542021,15057,'pl','Ostatnie notatki',0),(542022,15057,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(542023,15057,'ur','Ø¢Ø®Ø±ÛŒ Ù†ÙˆÙ¹',0),(542024,15057,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(542025,15057,'vi','Ghi chÃº cuá»‘i cÃ¹ng',0),(542026,15057,'af','Laaste notas',0),(542027,15057,'ro','Notele de ultimii',0),(542028,15057,'et','Viimased mÃ¤rkmed',0),(542029,15057,'si','Zadnji zapiski',0),(542030,15057,'ba','Catatan terakhir',0),(542031,15057,'nl','Laatste nota',0),(542032,15057,'fi','Viime toteaa',0),(542033,15057,'no','Siste notater',0),(542034,15057,'da','Sidste noter',0),(542035,15057,'ko','ë§ˆì§€ë§‰ ë…¸íŠ¸',0),(542036,15057,'he','×”×¢×¨×•×ª ×œ××—×¨×•× ×”',0),(542037,15057,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯ÎµÏ‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(542038,15057,'zh','æœ€åŽå‡ ä¸ªéŸ³ç¬¦',0),(542039,15057,'sv','Senaste anteckningar',0),(542040,15057,'it','Ultime note',0),(542041,15057,'tl','',0),(542042,15057,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(542043,15057,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¥‹à¤Ÿà¥à¤¸',0),(542044,15057,'ms','Nota-Nota terakhir',0),(542045,15057,'ar','Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(542046,15057,'fr','DerniÃ¨res Notes',0),(542047,15057,'jp','æœ€å¾Œã®ãƒŽãƒ¼ãƒˆ',0),(542048,15057,'pt','Ãšltimas notas',0),(542049,15057,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(542050,15057,'es','Notas de fondo',0),(542051,15057,'de','Letzte Hinweise',0),(542052,15057,'en','Last Notes',0),(542053,15058,'is','',0),(542054,15058,'dr','ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ù…Ù†',0),(542055,15058,'pr','ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ù…Ù†',0),(542056,15058,'tr','Benim etkinlik',0),(542057,15058,'pl','Moja dziaÅ‚alnoÅ›Ä‡',0),(542058,15058,'bg','ÐœÐ¾ÑÑ‚Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(542059,15058,'ur','Ù…ÛŒÚº Ù…ÛŒØ±ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(542060,15058,'sr','ÐœÐ¾Ñ˜Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(542061,15058,'vi','Hoáº¡t Ä‘á»™ng cá»§a tÃ´i',0),(542062,15058,'af','My aktiwiteit',0),(542063,15058,'ro','Activitatea mea',0),(542064,15058,'et','Minu tegevus',0),(542065,15058,'si','Moje dejavnosti',0),(542066,15058,'ba','Aktivitas saya',0),(542067,15058,'nl','Mijn activiteit',0),(542068,15058,'fi','Oma toiminta',0),(542069,15058,'no','Min aktivitet',0),(542070,15058,'da','Min aktivitet',0),(542071,15058,'ko','ë‚´ í™œë™',0),(542072,15058,'he','×”×¤×¢×™×œ×•×ª ×©×œ×™',0),(542073,15058,'el','ÎœÎ¿Ï… Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(542074,15058,'zh','æˆ‘çš„æ´»åŠ¨',0),(542075,15058,'sv','Min aktivitet',0),(542076,15058,'it','La mia attivitÃ ',0),(542077,15058,'tl','',0),(542078,15058,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(542079,15058,'hi','à¤®à¥‡à¤°à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(542080,15058,'ms','Aktiviti saya',0),(542081,15058,'ar','Ù†Ø´Ø§Ø· Ø¨Ù„Ø¯ÙŠ',0),(542082,15058,'fr','Mon activitÃ©',0),(542083,15058,'jp','ç§ã®æ´»å‹•',0),(542084,15058,'pt','Minha atividade',0),(542085,15058,'ru','ÐœÐ¾Ñ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚ÑŒ',0),(542086,15058,'es','Mi actividad',0),(542087,15058,'de','Meine TÃ¤tigkeit',0),(542088,15058,'en','My Activity',0),(542089,15059,'is','',0),(542090,15059,'dr','ÙØ¹Ø§Ù„ÛŒØª Ø¬Ø¯ÛŒØ¯',0),(542091,15059,'pr','ÙØ¹Ø§Ù„ÛŒØª Ø¬Ø¯ÛŒØ¯',0),(542092,15059,'tr','Yeni etkinlik',0),(542093,15059,'pl','Nowej dziaÅ‚alnoÅ›ci',0),(542094,15059,'bg','ÐÐ¾Ð²Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(542095,15059,'ur','Ù†Ø¦ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(542096,15059,'sr','ÐÐ¾Ð²Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(542097,15059,'vi','Hoáº¡t Ä‘á»™ng má»›i',0),(542098,15059,'af','Nuwe aktiwiteit',0),(542099,15059,'ro','Noua activitate',0),(542100,15059,'et','Uus tegevus',0),(542101,15059,'si','Nova dejavnost',0),(542102,15059,'ba','Aktivitas baru',0),(542103,15059,'nl','Nieuwe activiteit',0),(542104,15059,'fi','Uusi aktiviteetti',0),(542105,15059,'no','Ny aktivitet',0),(542106,15059,'da','Ny aktivitet',0),(542107,15059,'ko','ìƒˆë¡œìš´ í™œë™',0),(542108,15059,'he','×¤×¢×™×œ×•×ª ×—×“×©×”',0),(542109,15059,'el','ÎÎ­Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(542110,15059,'zh','æ–°çš„æ´»åŠ¨',0),(542111,15059,'sv','Ny aktivitet',0),(542112,15059,'it','Nuova attivitÃ ',0),(542113,15059,'tl','',0),(542114,15059,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¹ƒà¸«à¸¡à¹ˆ',0),(542115,15059,'hi','à¤¨à¤ˆ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(542116,15059,'ms','Aktiviti baru',0),(542117,15059,'ar','Ù†Ø´Ø§Ø· Ø¬Ø¯ÙŠØ¯',0),(542118,15059,'fr','Nouvelle activitÃ©',0),(542119,15059,'jp','æ–°ã—ã„ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£',0),(542120,15059,'pt','Nova atividade',0),(542121,15059,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð²Ð¸Ð´ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(542122,15059,'es','Nueva actividad',0),(542123,15059,'de','Neue AktivitÃ¤t',0),(542124,15059,'en','New Activity',0),(542125,15060,'is','',0),(542126,15060,'dr','Ø§Ù‚Ø¯Ø§Ù… Ø¨Ø¹Ø¯ÛŒ',0),(542127,15060,'pr','Ø§Ù‚Ø¯Ø§Ù… Ø¨Ø¹Ø¯ÛŒ',0),(542128,15060,'tr','Bir sonraki eylem',0),(542129,15060,'pl','NastÄ™pnej akcji',0),(542130,15060,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(542131,15060,'ur','Ø§Ú¯Ù„ÛŒ Ú©Ø§Ø±Ø±ÙˆØ§Ø¦ÛŒ',0),(542132,15060,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ñƒ Ñ€Ð°Ð´ÑšÑƒ',0),(542133,15060,'vi','Hoáº¡t Ä‘á»™ng tiáº¿p theo',0),(542134,15060,'af','Volgende aksie',0),(542135,15060,'ro','UrmÄƒtoarea acÅ£iune',0),(542136,15060,'et','JÃ¤rgmise tegevuse',0),(542137,15060,'si','Naslednje dejanje',0),(542138,15060,'ba','Tindakan berikutnya',0),(542139,15060,'nl','Volgende actie',0),(542140,15060,'fi','Seuraava toiminto',0),(542141,15060,'no','Neste handling',0),(542142,15060,'da','NÃ¦ste aktion',0),(542143,15060,'ko','ë‹¤ìŒ ìž‘ì—…',0),(542144,15060,'he','×”×¤×¢×•×œ×” ×”×‘××”',0),(542145,15060,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· ÎµÎ½Î­ÏÎ³ÎµÎ¹Î±',0),(542146,15060,'zh','ä¸‹ä¸€æ­¥è¡ŒåŠ¨',0),(542147,15060,'sv','NÃ¤sta Ã¥tgÃ¤rd',0),(542148,15060,'it','Azione successiva',0),(542149,15060,'tl','',0),(542150,15060,'th','à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸•à¹ˆà¸­à¹„à¸›',0),(542151,15060,'hi','à¤…à¤—à¤²à¥€ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(542152,15060,'ms','Tindakan seterusnya',0),(542153,15060,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ù…Ù‚Ø¨Ù„',0),(542154,15060,'fr','Prochaine Action',0),(542155,15060,'jp','æ¬¡ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(542156,15060,'pt','PrÃ³xima aÃ§Ã£o',0),(542157,15060,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰ÐµÐµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(542158,15060,'es','PrÃ³xima acciÃ³n',0),(542159,15060,'de','NÃ¤chste Aktion',0),(542160,15060,'en','Next Action',0),(542161,15061,'is','',0),(542162,15061,'dr','Ø´Ø±ÙˆØ¹ Ø¹Ù…Ù„ Ø¨Ø¹Ø¯ÛŒ',0),(542163,15061,'pr','Ø´Ø±ÙˆØ¹ Ø¹Ù…Ù„ Ø¨Ø¹Ø¯ÛŒ',0),(542164,15061,'tr','Bir sonraki eylem Begin',0),(542165,15061,'pl','NastÄ™pne dziaÅ‚ania Begin',0),(542166,15061,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð°',0),(542167,15061,'ur','Ø§Ú¯Ù„ÛŒ Ú©Ø§Ø±Ø±ÙˆØ§Ø¦ÛŒ Ø´Ø±ÙˆØ¹',0),(542168,15061,'sr','ÐžÐ·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° ÑÐ»ÐµÐ´ÐµÑ›Ðµ Ñ€Ð°Ð´ÑšÐµ',0),(542169,15061,'vi','Tiáº¿p theo hÃ nh Ä‘á»™ng báº¯t Ä‘áº§u',0),(542170,15061,'af','Volgende aksie Begin',0),(542171,15061,'ro','UrmÄƒtoarea acÅ£iune Ã®ncepe',0),(542172,15061,'et','JÃ¤rgmise tegevuse algus',0),(542173,15061,'si','Naslednji ukrep Begin',0),(542174,15061,'ba','Berikutnya tindakan dimulai',0),(542175,15061,'nl','Volgende actie beginnen',0),(542176,15061,'fi','Seuraava toiminta alkaa',0),(542177,15061,'no','Neste handling begynner',0),(542178,15061,'da','NÃ¦ste handling Begin',0),(542179,15061,'ko','ë‹¤ìŒ ìž‘ì—… ì‹œìž‘',0),(542180,15061,'he','×‘×’×™×Ÿ ×¤×¢×•×œ×” ×”×‘××”',0),(542181,15061,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Î­Î½Î±ÏÎ¾Î· Î´ÏÎ¬ÏƒÎ·Ï‚',0),(542182,15061,'zh','æŽ¥ä¸‹æ¥çš„è¡ŒåŠ¨å¼€å§‹',0),(542183,15061,'sv','NÃ¤sta Ã¥tgÃ¤rd bÃ¶rjar',0),(542184,15061,'it','Prossima azione Begin',0),(542185,15061,'tl','',0),(542186,15061,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸•à¹ˆà¸­à¹„à¸›',0),(542187,15061,'hi','à¤…à¤—à¤²à¥€ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤¶à¥à¤°à¥‚',0),(542188,15061,'ms','Mulakan tindakan seterusnya',0),(542189,15061,'ar','Ø§Ù„Ø¨Ø¯Ø¡ ÙÙŠ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ù‚Ø§Ø¯Ù…',0),(542190,15061,'fr','Prochaine Action Begin',0),(542191,15061,'jp','æ¬¡ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã®é–‹å§‹',0),(542192,15061,'pt','PrÃ³xima aÃ§Ã£o Begin',0),(542193,15061,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð°Ñ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹ Begin',0),(542194,15061,'es','La prÃ³xima acciÃ³n Begin',0),(542195,15061,'de','NÃ¤chste Aktion Begin',0),(542196,15061,'en','Next Action Begin',0),(542197,15062,'is','',0),(542198,15062,'dr','ØªØ§Ø±ÛŒØ® Ø§Ù‚Ø¯Ø§Ù… Ø¨Ø¹Ø¯ÛŒ',0),(542199,15062,'pr','ØªØ§Ø±ÛŒØ® Ø§Ù‚Ø¯Ø§Ù… Ø¨Ø¹Ø¯ÛŒ',0),(542200,15062,'tr','Sonraki eylem tarihi',0),(542201,15062,'pl','Data nastÄ™pnej akcji',0),(542202,15062,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(542203,15062,'ur','Ø§Ú¯Ù„ÛŒ Ú©Ø§Ø±Ø±ÙˆØ§Ø¦ÛŒ ØªØ§Ø±ÛŒØ®',0),(542204,15062,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð° Ð°ÐºÑ†Ð¸Ñ˜Ñƒ',0),(542205,15062,'vi','NgÃ y hÃ nh Ä‘á»™ng tiáº¿p theo',0),(542206,15062,'af','Volgende aksie datum',0),(542207,15062,'ro','UrmÄƒtoarea datÄƒ de acÅ£iune',0),(542208,15062,'et','JÃ¤rgmise toimingu kuupÃ¤ev',0),(542209,15062,'si','Datum naslednje dejanje',0),(542210,15062,'ba','Tanggal tindakan berikutnya',0),(542211,15062,'nl','Volgende actie datum',0),(542212,15062,'fi','Seuraavan toimenpiteen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(542213,15062,'no','Neste handling.',0),(542214,15062,'da','NÃ¦ste aktionsdato',0),(542215,15062,'ko','ë‹¤ìŒ ìž‘ì—… ë‚ ì§œ',0),(542216,15062,'he','×ª××¨×™×š ×”×¤×¢×•×œ×” ×”×‘××”',0),(542217,15062,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Î—Î¼.',0),(542218,15062,'zh','æŽ¥ä¸‹æ¥çš„è¡ŒåŠ¨æ—¥æœŸ',0),(542219,15062,'sv','NÃ¤sta Ã¥tgÃ¤rdsdatum',0),(542220,15062,'it','Il prossimo appuntamento di azione',0),(542221,15062,'tl','',0),(542222,15062,'th','à¸§à¸±à¸™à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸•à¹ˆà¸­à¹„à¸›',0),(542223,15062,'hi','à¤…à¤—à¤²à¥€ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–',0),(542224,15062,'ms','Tarikh tindakan seterusnya',0),(542225,15062,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡ Ø§Ù„ØªØ§Ù„ÙŠ',0),(542226,15062,'fr','Prochaine Date de l\'Action',0),(542227,15062,'jp','æ¬¡ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã®æ—¥ä»˜',0),(542228,15062,'pt','PrÃ³xima data de aÃ§Ã£o',0),(542229,15062,'ru','Ð”Ð°Ñ‚Ð° ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ³Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(542230,15062,'es','PrÃ³xima fecha de acciÃ³n',0),(542231,15062,'de','NÃ¤chste Aktion am',0),(542232,15062,'en','Next Action Date',0),(542233,15063,'is','',0),(542234,15063,'dr','Ø¨Ø¹Ø¯ Ø§Ø² Ù¾Ø§ÛŒØ§Ù† Ø¹Ù…Ù„',0),(542235,15063,'pr','Ø¨Ø¹Ø¯ Ø§Ø² Ù¾Ø§ÛŒØ§Ù† Ø¹Ù…Ù„',0),(542236,15063,'tr','Bir sonraki eylem bitiÅŸ',0),(542237,15063,'pl','NastÄ™pny koniec akcji',0),(542238,15063,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð¾Ñ‚Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ ÐºÑ€Ð°Ð¹',0),(542239,15063,'ur','Ø§Ú¯Ù„ÛŒ Ú©Ø§Ø±Ø±ÙˆØ§Ø¦ÛŒ Ø®ØªÙ…',0),(542240,15063,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ðµ Ñ€Ð°Ð´ÑšÐµ ÐºÑ€Ð°Ñ˜',0),(542241,15063,'vi','Tiáº¿p theo hÃ nh Ä‘á»™ng cuá»‘i',0),(542242,15063,'af','Volgende aksie einde',0),(542243,15063,'ro','UrmÄƒtoarea acÅ£iune sfÃ¢rÅŸitul',0),(542244,15063,'et','JÃ¤rgmise tegevuse lÃµpp',0),(542245,15063,'si','Naslednji ukrep konec',0),(542246,15063,'ba','Berikutnya tindakan akhir',0),(542247,15063,'nl','Volgende actie eind',0),(542248,15063,'fi','Seuraava toiminto loppuun',0),(542249,15063,'no','Neste handling slutten',0),(542250,15063,'da','NÃ¦ste handling ende',0),(542251,15063,'ko','ë‹¤ìŒ ìž‘ì—… ë',0),(542252,15063,'he','×‘×¡×•×£ ×”×¤×¢×•×œ×” ×”×‘××”',0),(542253,15063,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î· Î´ÏÎ¬ÏƒÎ· Ï„Î­Î»Î¿Ï‚',0),(542254,15063,'zh','æŽ¥ä¸‹æ¥çš„è¡ŒåŠ¨ç»“æŸ',0),(542255,15063,'sv','NÃ¤sta Ã¥tgÃ¤rd slutet',0),(542256,15063,'it','Prossima azione fine',0),(542257,15063,'tl','',0),(542258,15063,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸•à¹ˆà¸­à¹„à¸›',0),(542259,15063,'hi','à¤…à¤—à¤²à¥€ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤…à¤‚à¤¤',0),(542260,15063,'ms','Seterusnya tindakan akhir',0),(542261,15063,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ù…Ù‚Ø¨Ù„',0),(542262,15063,'fr','Prochaine Action fin',0),(542263,15063,'jp','æ¬¡ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³çµ‚äº†',0),(542264,15063,'pt','PrÃ³xima acÃ§Ã£o final',0),(542265,15063,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð°Ñ ÐšÐ¾Ð½ÐµÑ† Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹',0),(542266,15063,'es','La prÃ³xima acciÃ³n final',0),(542267,15063,'de','NÃ¤chste Aktion Ende',0),(542268,15063,'en','Next Action End',0),(542269,15064,'is','',0),(542270,15064,'dr','ØªÙ…Ø§Ø³ Ø¨Ø§',0),(542271,15064,'pr','ØªÙ…Ø§Ø³ Ø¨Ø§',0),(542272,15064,'tr','BaÄŸlantÄ± yok',0),(542273,15064,'pl','Brak kontaktu',0),(542274,15064,'bg','ÐÑÐ¼Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(542275,15064,'ur','Ú©ÙˆØ¦ÛŒ Ø±Ø§Ø¨Ø·Û',0),(542276,15064,'sr','ÐÐµÐ¼Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð°',0),(542277,15064,'vi','KhÃ´ng cÃ³ sá»‘ liÃªn láº¡c',0),(542278,15064,'af','Geen kontak',0),(542279,15064,'ro','Nici un Contact',0),(542280,15064,'et','Kontakti pole',0),(542281,15064,'si','Nobenega stika',0),(542282,15064,'ba','Tidak ada kontak',0),(542283,15064,'nl','Geen Contact',0),(542284,15064,'fi','Ei ole yhteyttÃ¤',0),(542285,15064,'no','Ingen kontakt',0),(542286,15064,'da','Ingen kontakt',0),(542287,15064,'ko','ì ‘ì´‰',0),(542288,15064,'he','×‘×œ×™ ×§×©×¨',0),(542289,15064,'el','Î”ÎµÎ½ Î­ÏÏ‡Î¿Î½Ï„Î±Î¹ ÏƒÎµ ÎµÏ€Î±Ï†Î®',0),(542290,15064,'zh','æ²¡æœ‰è”ç³»äºº',0),(542291,15064,'sv','Ingen kontakt',0),(542292,15064,'it','Nessun contatto',0),(542293,15064,'tl','',0),(542294,15064,'th','à¸•à¸´à¸”à¸•à¹ˆà¸­',0),(542295,15064,'hi','à¤•à¥‹à¤ˆ à¤¸à¤‚à¤ªà¤°à¥à¤•',0),(542296,15064,'ms','Tiada kenalan',0),(542297,15064,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø§ØªØµØ§Ù„',0),(542298,15064,'fr','Pas de Contact',0),(542299,15064,'jp','é€£çµ¡å…ˆã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(542300,15064,'pt','Sem contato',0),(542301,15064,'ru','ÐÐµÑ‚ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð°',0),(542302,15064,'es','Sin contacto',0),(542303,15064,'de','Kein Kontakt',0),(542304,15064,'en','No Contact',0),(542305,15065,'is','',0),(542306,15065,'dr','Ù‡ÛŒÚ† Ù…Ø´ØªØ±ÛŒØ§Ù† Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø±Ø§ÛŒ ØªØ®ØµÛŒØµ',0),(542307,15065,'pr','Ù‡ÛŒÚ† Ù…Ø´ØªØ±ÛŒØ§Ù† Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø±Ø§ÛŒ ØªØ®ØµÛŒØµ',0),(542308,15065,'tr','Atama iÃ§in kullanÄ±labilir hiÃ§bir mÃ¼ÅŸteriler',0),(542309,15065,'pl','Nie klientÃ³w, ktÃ³re sÄ… dostÄ™pne do przydzielenia',0),(542310,15065,'bg','ÐÑÐ¼Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð·Ð° Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(542311,15065,'ur','Ú©ÙˆØ¦ÛŒ Ú¯Ø§ÛÚ© Ú©ÛŒ ØªÙÙˆÛŒØ¶ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø³ØªÛŒØ§Ø¨',0),(542312,15065,'sr','ÐÐµÐ¼Ð° ÐºÐ»Ð¸Ñ˜ÐµÐ½Ð°Ñ‚Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ð·Ð° Ð·Ð°Ð´Ð°Ñ‚Ð°Ðº',0),(542313,15065,'vi','KhÃ´ng cÃ³ khÃ¡ch hÃ ng sáºµn sÃ ng cho nhiá»‡m vá»¥',0),(542314,15065,'af','Geen kliÃ«nte beskikbaar vir opdrag',0),(542315,15065,'ro','Nici clienÅ£ii disponibile pentru misiune',0),(542316,15065,'et','Saadaval kliente',0),(542317,15065,'si','Nobene stranke, ki so na voljo za dodelitev',0),(542318,15065,'ba','Pelanggan tidak tersedia untuk tugas',0),(542319,15065,'nl','Geen klanten beschikbaar zijn voor toewijzingen',0),(542320,15065,'fi','KÃ¤ytÃ¶ssÃ¤ ei ole asiakkaita',0),(542321,15065,'no','Ingen kunder tilgjengelig For tildeling',0),(542322,15065,'da','Ingen kunder, der er tilgÃ¦ngelige For tildeling',0),(542323,15065,'ko','í• ë‹¹ì— ì‚¬ìš©í•  ìˆ˜ ì—†ëŠ” ê³ ê°',0),(542324,15065,'he','×œ×§×•×—×•×ª ×–×ž×™×Ÿ ×¢×‘×•×¨ ×”×§×¦××”',0),(542325,15065,'el','Î”ÎµÎ½ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± Î³Î¹Î± Î±Î½Î¬Î¸ÎµÏƒÎ·',0),(542326,15065,'zh','æ²¡æœ‰å¯ä¾›åˆ†é…çš„å®¢æˆ·',0),(542327,15065,'sv','Inga kunder som Ã¤r tillgÃ¤ngliga fÃ¶r tilldelning',0),(542328,15065,'it','Clienti non disponibili per l\'assegnazione',0),(542329,15065,'tl','',0),(542330,15065,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹„à¸¡à¹ˆà¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸à¸³à¸«à¸™à¸”',0),(542331,15065,'hi','à¤•à¥‹à¤ˆ à¤…à¤¸à¤¾à¤‡à¤¨à¤®à¥‡à¤‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(542332,15065,'ms','Tiada pelanggan yang disediakan untuk tugasan',0),(542333,15065,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø¹Ù…Ù„Ø§Ø¡ Ù…ØªØ§Ø­ Ù„Ù„ØªØ¹ÙŠÙŠÙ†',0),(542334,15065,'fr','Pas disponibles pour l\'assignation de clients',0),(542335,15065,'jp','å‰²ã‚Šå½“ã¦ã«ä½¿ç”¨ã§ãã‚‹é¡§å®¢ã§ã¯ãªã„ã§ã™ã€‚',0),(542336,15065,'pt','NÃ£o hÃ¡ clientes disponÃ­veis para atribuiÃ§Ã£o',0),(542337,15065,'ru','ÐÐµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹ Ð´Ð»Ñ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(542338,15065,'es','No disponible para la asignaciÃ³n de clientes',0),(542339,15065,'de','Keine Kunden, die fÃ¼r die Zuweisung',0),(542340,15065,'en','No Customers Available For Assignment',0),(542341,15066,'is','',0),(542342,15066,'dr','Ù‡ÛŒÚ† ÙˆØ¸ÛŒÙÙ‡ Ø§ÛŒ Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(542343,15066,'pr','Ù‡ÛŒÚ† ÙˆØ¸ÛŒÙÙ‡ Ø§ÛŒ Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(542344,15066,'tr','AtanmÄ±ÅŸ gÃ¶rev yok',0),(542345,15066,'pl','Nie przypisanych zadaÅ„',0),(542346,15066,'bg','ÐÑÐ¼Ð° Ð·Ð°Ð´Ð°Ñ‡Ð¸, Ð²ÑŠÐ·Ð»Ð¾Ð¶ÐµÐ½Ð¸',0),(542347,15066,'ur','ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ù…Ø¬Ù…ÙˆØ¹Û Ú©Ø§Ø±',0),(542348,15066,'sr','ÐÐµÐ¼Ð° Ð´Ð¾Ð´ÐµÑ™ÐµÐ½Ð¸Ñ… Ð·Ð°Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(542349,15066,'vi','KhÃ´ng cÃ³ tÃ¡c vá»¥ Ä‘Æ°á»£c gÃ¡n',0),(542350,15066,'af','Geen take toegewys',0),(542351,15066,'ro','Nici sarcinilor atribuite',0),(542352,15066,'et','Antud Ã¼lesannete',0),(542353,15066,'si','Ni nalog',0),(542354,15066,'ba','Tidak ada tugas yang diberikan',0),(542355,15066,'nl','Geen taken die zijn toegewezen',0),(542356,15066,'fi','Ei tehtÃ¤vien',0),(542357,15066,'no','Ingen aktiviteter som er tildelt',0),(542358,15066,'da','Ingen opgaver',0),(542359,15066,'ko','í• ë‹¹ ëœ ì—†ëŠ” ìž‘ì—…',0),(542360,15066,'he','××™×Ÿ ×ž×©×™×ž×•×ª ×©×”×•×§×¦×•',0),(542361,15066,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Î½Î±Ï„ÎµÎ¸ÎµÎ¯',0),(542362,15066,'zh','æ²¡æœ‰åˆ†é…ä»»åŠ¡',0),(542363,15066,'sv','Inga arbetsuppgifter',0),(542364,15066,'it','Senza attivitÃ  assegnate',0),(542365,15066,'tl','',0),(542366,15066,'th','à¸‡à¸²à¸™à¹„à¸¡à¹ˆà¸¡à¸µà¸à¸³à¸«à¸™à¸”',0),(542367,15066,'hi','à¤•à¥‹à¤ˆ à¤•à¤¾à¤°à¥à¤¯ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(542368,15066,'ms','Tiada tugas yang diberikan',0),(542369,15066,'ar','Ù„Ø§ Ø§Ù„Ù…Ù‡Ø§Ù… Ø§Ù„ØªÙŠ ØªÙ… ØªØ¹ÙŠÙŠÙ†Ù‡Ø§',0),(542370,15066,'fr','Aucune tÃ¢ches assignÃ©es',0),(542371,15066,'jp','å‰²ã‚Šå½“ã¦ã‚‰ã‚ŒãŸã‚¿ã‚¹ã‚¯ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(542372,15066,'pt','Sem tarefas atribuÃ­das',0),(542373,15066,'ru','Ð—Ð°Ð´Ð°Ñ‡Ð¸ Ð½Ðµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½',0),(542374,15066,'es','No hay tareas asignadas',0),(542375,15066,'de','Keine zugewiesenen Aufgaben',0),(542376,15066,'en','No Tasks Assigned',0),(542377,15067,'is','',0),(542378,15067,'dr','Ù‡ÛŒÚ† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ø±Ø§ÛŒ ØªØ®ØµÛŒØµ Ø¯Ø± Ø¯Ø³ØªØ±Ø³',0),(542379,15067,'pr','Ù‡ÛŒÚ† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ø±Ø§ÛŒ ØªØ®ØµÛŒØµ Ø¯Ø± Ø¯Ø³ØªØ±Ø³',0),(542380,15067,'tr','Atama iÃ§in kullanÄ±labilir hiÃ§bir satÄ±cÄ±lar',0),(542381,15067,'pl','Nie dostawcÃ³w, ktÃ³re sÄ… dostÄ™pne do przydzielenia',0),(542382,15067,'bg','ÐÑÐ¼Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ð·Ð° Ñ€Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ðµ',0),(542383,15067,'ur','Ú©ÙˆØ¦ÛŒ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©ÛŒ ØªÙÙˆÛŒØ¶ Ú©Û’ Ù„ÛŒÛ’ Ø¯Ø³ØªÛŒØ§Ø¨',0),(542384,15067,'sr','ÐÐµÐ¼Ð° Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ðµ Ð·Ð° Ð·Ð°Ð´Ð°Ñ‚Ð°Ðº Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(542385,15067,'vi','KhÃ´ng cÃ³ nhÃ  cung cáº¥p cÃ³ sáºµn cho chuyá»ƒn nhÆ°á»£ng',0),(542386,15067,'af','Geen handelaars beskikbaar vir opdrag',0),(542387,15067,'ro','Nu vÃ¢nzÄƒtorii disponibile pentru misiune',0),(542388,15067,'et','Pole hankijate saadaval',0),(542389,15067,'si','Ni na voljo za dodeljevanje dobaviteljem',0),(542390,15067,'ba','Vendor tidak tersedia untuk tugas',0),(542391,15067,'nl','Geen leveranciers beschikbaar zijn voor toewijzingen',0),(542392,15067,'fi','KÃ¤ytÃ¶ssÃ¤ ole myyjiÃ¤',0),(542393,15067,'no','Ingen leverandÃ¸rer tilgjengelig For tildeling',0),(542394,15067,'da','Ingen leverandÃ¸rer, der er tilgÃ¦ngelige For tildeling',0),(542395,15067,'ko','í• ë‹¹ì— ì‚¬ìš©í•  ìˆ˜ ì—†ëŠ” ê³µê¸‰ ì—…ì²´',0),(542396,15067,'he','××™×Ÿ ×¡×¤×§×™× ×–×ž×™× ×™× ×¢×‘×•×¨ ×”×§×¦××”',0),(542397,15067,'el','Î”ÎµÎ½ Ï€Ï‰Î»Î·Ï„Î­Ï‚ Ï€Î¿Ï… ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î± Î³Î¹Î± Î±Î½Î¬Î¸ÎµÏƒÎ·',0),(542398,15067,'zh','æ²¡æœ‰å¯ä¾›åˆ†é…çš„ä¾›åº”å•†',0),(542399,15067,'sv','Inga leverantÃ¶rer tillgÃ¤ngliga fÃ¶r tilldelning',0),(542400,15067,'it','No venditori disponibili per l\'assegnazione',0),(542401,15067,'tl','',0),(542402,15067,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¹„à¸¡à¹ˆà¸¡à¸µà¸à¸²à¸£à¸à¸³à¸«à¸™à¸”',0),(542403,15067,'hi','à¤•à¥‹à¤ˆ à¤…à¤¸à¤¾à¤‡à¤¨à¤®à¥‡à¤‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(542404,15067,'ms','Vendor tidak tersedia untuk tugasan',0),(542405,15067,'ar','Ù„Ø§ Ø§Ù„Ø¨Ø§Ø¦Ø¹ÙŠÙ† Ø§Ù„Ù…ØªÙˆÙØ±Ø© Ù„Ù„ØªØ¹ÙŠÙŠÙ†',0),(542406,15067,'fr','Aucun fournisseurs disponibles pour l\'assignation',0),(542407,15067,'jp','å‰²ã‚Šå½“ã¦ã«ä½¿ç”¨ã§ãã‚‹ãƒ™ãƒ³ãƒ€ãƒ¼ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(542408,15067,'pt','NÃ£o disponÃ­vel para atribuiÃ§Ã£o de fornecedores',0),(542409,15067,'ru','ÐÐµÑ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð², Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ñ… Ð´Ð»Ñ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(542410,15067,'es','No disponible para la asignaciÃ³n de vendedores',0),(542411,15067,'de','Kein Anbieter ProjektvorgÃ¤ngen',0),(542412,15067,'en','No Vendors Available For Assignment',0),(542413,15068,'is','',0),(542414,15068,'dr','Ø®Ø±ÛŒØ¯ Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¹ØªÙ…Ø§Ø¯ Ø¨Ù‡ Ù†ÙØ³',0),(542415,15068,'pr','Ø®Ø±ÛŒØ¯ Ù…Ù‚Ø¯Ø§Ø± Ø§Ø¹ØªÙ…Ø§Ø¯ Ø¨Ù‡ Ù†ÙØ³',0),(542416,15068,'tr','SatÄ±nalma tutarÄ± gÃ¼ven',0),(542417,15068,'pl','Zakup zaufania kwoty',0),(542418,15068,'bg','Ð”Ð¾Ð²ÐµÑ€Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(542419,15068,'ur','Ø±Ù‚Ù… Ù¾Ø± Ø§Ø¹ØªÙ…Ø§Ø¯ Ú©ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(542420,15068,'sr','Ð˜Ð·Ð»Ð°Ð·Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑÐ°Ð¼Ð¾Ð¿Ð¾ÑƒÐ·Ð´Ð°ÑšÐµ',0),(542421,15068,'vi','Mua sá»‘ lÆ°á»£ng tin cáº­y',0),(542422,15068,'af','Aankoop bedrag vertroue',0),(542423,15068,'ro','CumpÄƒrare suma Ã®ncredere',0),(542424,15068,'et','Ostu summa usaldust',0),(542425,15068,'si','Nakup znesek zaupanje',0),(542426,15068,'ba','Membeli jumlah keyakinan',0),(542427,15068,'nl','Aankoop bedrag vertrouwen',0),(542428,15068,'fi','Ostojen mÃ¤Ã¤rÃ¤ luottamusta',0),(542429,15068,'no','KjÃ¸p belÃ¸pet tillit',0),(542430,15068,'da','KÃ¸b belÃ¸b tillid',0),(542431,15068,'ko','êµ¬ë§¤ ê¸ˆì•¡ ìžì‹ ê°',0),(542432,15068,'he','×œ×¨×›×•×© ×‘×™×˜×—×•×Ÿ ×›×ž×•×ª',0),(542433,15068,'el','Î‘Î³Î¿ÏÎ¬ Ï€Î¿ÏƒÏŒ ÎµÎ¼Ï€Î¹ÏƒÏ„Î¿ÏƒÏÎ½Î·Ï‚',0),(542434,15068,'zh','è´­ä¹°é‡çš„ä¿¡å¿ƒ',0),(542435,15068,'sv','KÃ¶p belopp fÃ¶rtroende',0),(542436,15068,'it','Acquisto importo fiducia',0),(542437,15068,'tl','',0),(542438,15068,'th','à¸¡à¸±à¹ˆà¸™à¹ƒà¸ˆà¸¢à¸­à¸”à¸‹à¸·à¹‰à¸­',0),(542439,15068,'hi','à¤°à¤¾à¤¶à¤¿ à¤•à¥‡ à¤†à¤¤à¥à¤®à¤µà¤¿à¤¶à¥à¤µà¤¾à¤¸ à¤•à¥€ à¤–à¤°à¥€à¤¦',0),(542440,15068,'ms','Keyakinan terhadap jumlah pembelian',0),(542441,15068,'ar','Ø´Ø±Ø§Ø¡ ÙƒÙ…ÙŠØ© Ø§Ù„Ø«Ù‚Ø©',0),(542442,15068,'fr','Achat montant confiance',0),(542443,15068,'jp','è³¼å…¥é‡‘é¡ã®ä¿¡é ¼',0),(542444,15068,'pt','ConfianÃ§a de quantidade de compra',0),(542445,15068,'ru','Ð”Ð¾Ð²ÐµÑ€Ð¸Ðµ ÑÑƒÐ¼Ð¼Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(542446,15068,'es','Compra cantidad confianza',0),(542447,15068,'de','Menge Vertrauen zu erwerben',0),(542448,15068,'en','Purchase Amount Confidence',0),(542449,15069,'is','',0),(542450,15069,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ø§Ø¹ØªÙ…Ø§Ø¯ Ø¨Ù‡ Ù†ÙØ³',0),(542451,15069,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙØ±ÙˆØ´ Ø§Ø¹ØªÙ…Ø§Ø¯ Ø¨Ù‡ Ù†ÙØ³',0),(542452,15069,'tr','SatÄ±ÅŸ tutarÄ± gÃ¼ven',0),(542453,15069,'pl','Kwota sprzedaÅ¼y zaufania',0),(542454,15069,'bg','Ð¡ÑƒÐ¼Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð´Ð¾Ð²ÐµÑ€Ð¸Ðµ',0),(542455,15069,'ur','ÙØ±ÙˆØ®Øª Ú©ÛŒ Ø±Ù‚Ù… Ù¾Ø± Ø§Ø¹ØªÙ…Ø§Ø¯',0),(542456,15069,'sr','Ð˜Ð·Ð½Ð¾Ñ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÑÐ°Ð¼Ð¾Ð¿Ð¾ÑƒÐ·Ð´Ð°ÑšÐµ',0),(542457,15069,'vi','Sá»‘ lÆ°á»£ng bÃ¡n hÃ ng tá»± tin',0),(542458,15069,'af','Verkope bedrag vertroue',0),(542459,15069,'ro','SumÄƒ vÃ¢nzÄƒri Ã®ncredere',0),(542460,15069,'et','MÃ¼Ã¼gisumma usaldust',0),(542461,15069,'si','Znesek prodaje zaupanje',0),(542462,15069,'ba','Jumlah penjualan keyakinan',0),(542463,15069,'nl','Verkoopbedrag vertrouwen',0),(542464,15069,'fi','Myyntisumma luottamusta',0),(542465,15069,'no','SalgsbelÃ¸p tillit',0),(542466,15069,'da','SalgsbelÃ¸b tillid',0),(542467,15069,'ko','íŒë§¤ ê¸ˆì•¡ ìžì‹ ê°',0),(542468,15069,'he','×›×ž×•×ª ×”×ž×›×™×¨×•×ª ×‘×™×˜×—×•×Ÿ',0),(542469,15069,'el','Î•Î¼Ï€Î¹ÏƒÏ„Î¿ÏƒÏÎ½Î· Ï€Î¿ÏƒÏŒ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(542470,15069,'zh','é”€å”®é‡‘é¢çš„ä¿¡å¿ƒ',0),(542471,15069,'sv','FÃ¶rsÃ¤ljningsbelopp fÃ¶rtroende',0),(542472,15069,'it','Importo vendite fiducia',0),(542473,15069,'tl','',0),(542474,15069,'th','à¸¡à¸±à¹ˆà¸™à¹ƒà¸ˆà¸¢à¸­à¸”à¸‚à¸²à¸¢',0),(542475,15069,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤°à¤¾à¤¶à¤¿ à¤†à¤¤à¥à¤®à¤µà¤¿à¤¶à¥à¤µà¤¾à¤¸',0),(542476,15069,'ms','Jumlah jualan keyakinan',0),(542477,15069,'ar','ÙƒÙ…ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø«Ù‚Ø©',0),(542478,15069,'fr','Montant des ventes de confiance',0),(542479,15069,'jp','å£²ã‚Šä¸Šã’é«˜ä¿¡é ¼',0),(542480,15069,'pt','Quantidade de vendas de confianÃ§a',0),(542481,15069,'ru','Ð¡ÑƒÐ¼Ð¼Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð¾Ð²ÐµÑ€Ð¸Ñ',0),(542482,15069,'es','Importe de ventas confianza',0),(542483,15069,'de','Verkaufsbetrag Vertrauen',0),(542484,15069,'en','Sales Amount Confidence',0),(542485,15070,'is','',0),(542486,15070,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙØ¹Ø§Ù„ÛŒØª',0),(542487,15070,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ ÙØ¹Ø§Ù„ÛŒØª',0),(542488,15070,'tr','EtkinliÄŸi gÃ¶rÃ¼ntÃ¼le',0),(542489,15070,'pl','WyÅ›wietlanie aktywnoÅ›ci',0),(542490,15070,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(542491,15070,'ur','ÙØ¹Ù„ÛŒØª Ù…Ù†Ø¸Ø± Ú©Ø±ÛŒÚº',0),(542492,15070,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(542493,15070,'vi','Xem hoáº¡t Ä‘á»™ng',0),(542494,15070,'af','Bekyk aktiwiteit',0),(542495,15070,'ro','Vezi activitatea',0),(542496,15070,'et','Vaata tegevusala',0),(542497,15070,'si','Ogled dejavnosti',0),(542498,15070,'ba','Lihat aktivitas',0),(542499,15070,'nl','Bekijk activiteit',0),(542500,15070,'fi','NÃ¤ytÃ¤ toiminta',0),(542501,15070,'no','Vis aktivitet',0),(542502,15070,'da','Vis aktivitet',0),(542503,15070,'ko','í™œë™ ë³´ê¸°',0),(542504,15070,'he','×ª×¦×•×’×ª ×¤×¢×™×œ×•×ª',0),(542505,15070,'el','Î ÏÎ¿Î²Î¿Î»Î® Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚',0),(542506,15070,'zh','æŸ¥çœ‹æ´»åŠ¨',0),(542507,15070,'sv','Visa aktivitet',0),(542508,15070,'it','Visualizza attivitÃ ',0),(542509,15070,'tl','',0),(542510,15070,'th','à¸”à¸¹à¸à¸´à¸ˆà¸à¸£à¸£à¸¡',0),(542511,15070,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(542512,15070,'ms','Lihat aktiviti',0),(542513,15070,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ù†Ø´Ø§Ø·',0),(542514,15070,'fr','Vue activitÃ©',0),(542515,15070,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£ã®è¡¨ç¤º',0),(542516,15070,'pt','Exibir atividade',0),(542517,15070,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(542518,15070,'es','Ver actividad',0),(542519,15070,'de','Vorgang anzeigen',0),(542520,15070,'en','View Activity',0),(542521,15071,'is','',0),(542522,15071,'dr','Ø´Ù…Ø§ ØªÙ…Ø§Ø³ Ø²ÛŒØ± Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(542523,15071,'pr','Ø´Ù…Ø§ ØªÙ…Ø§Ø³ Ø²ÛŒØ± Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(542524,15071,'tr','AÅŸaÄŸÄ±daki kiÅŸi atanmÄ±ÅŸ',0),(542525,15071,'pl','Przypisano nastÄ™pujÄ…ce kontakt',0),(542526,15071,'bg','Ð’Ð¸ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð²ÑŠÐ·Ð»Ð¾Ð¶ÐµÐ½Ð¸ Ð½Ð° ÑÐ»ÐµÐ´Ð½Ð¸Ñ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(542527,15071,'ur','Ø¢Ù¾ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ø±Ø§Ø¨Ø·Û ØªÙÙˆÛŒØ¶ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(542528,15071,'sr','ÐžÐ´Ñ€ÐµÐ´Ð¸Ð»Ð¸ ÑÑƒ ÑÐ»ÐµÐ´ÐµÑ›Ð¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(542529,15071,'vi','Báº¡n Ä‘Ã£ Ä‘Æ°á»£c chá»‰ Ä‘á»‹nh sá»‘ liÃªn láº¡c sau Ä‘Ã¢y',0),(542530,15071,'af','Jy het die volgende kontak toegeken is',0),(542531,15071,'ro','AÅ£i fost atribuit Contact urmÄƒtoarele',0),(542532,15071,'et','Teile on mÃ¤Ã¤ratud jÃ¤rgmised kontakt',0),(542533,15071,'si','Dodeljeno vam je bilo naslednje kontaktne',0),(542534,15071,'ba','Anda ditugaskan kontak berikut',0),(542535,15071,'nl','U hebt de volgende contactpersoon zijn toegewezen',0),(542536,15071,'fi','Sinulle on mÃ¤Ã¤ritetty seuraavat yhteystiedot',0),(542537,15071,'no','Du er tildelt fÃ¸lgende kontakten',0),(542538,15071,'da','Du har fÃ¥et tildelt den fÃ¸lgende kontakt',0),(542539,15071,'ko','ë‹¹ì‹ ì€ ë‹¤ìŒ ì—°ë½ì²˜ì— í• ë‹¹ ëœ',0),(542540,15071,'he','××ª×” ×”×•×§×¦×• ×”×§×©×¨ ×”×‘××™×',0),(542541,15071,'el','Î£Î±Ï‚ Î­Ï‡Î¿Ï…Î½ Î±Î½Î±Ï„ÎµÎ¸ÎµÎ¯ Î¼ÎµÏ„Î¬ Ï„Î·Î½ ÎµÏ€Î±Ï†Î®',0),(542542,15071,'zh','æ‚¨å·²åˆ†é…ä»¥ä¸‹è”ç³»äºº',0),(542543,15071,'sv','Du har tilldelats fÃ¶ljande kontakten',0),(542544,15071,'it','Vi Ã¨ stato assegnato il seguente contatto',0),(542545,15071,'tl','',0),(542546,15071,'th','à¸„à¸¸à¸“à¹„à¸”à¹‰à¸à¸³à¸«à¸™à¸”à¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­à¸”à¸±à¸‡à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰',0),(542547,15071,'hi','à¤†à¤ª à¤¨à¤¿à¤®à¥à¤¨à¤²à¤¿à¤–à¤¿à¤¤ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(542548,15071,'ms','Anda telah ditugaskan kenalan berikut',0),(542549,15071,'ar','ØªÙ… ØªØ¹ÙŠÙŠÙ†Ùƒ Ø¬Ù‡Ø© Ø§Ù„Ø§ØªØµØ§Ù„ Ø§Ù„ØªØ§Ù„ÙŠØ©',0),(542550,15071,'fr','Vous avez Ã©tÃ© affectÃ© le Contact suivant',0),(542551,15071,'jp','æ¬¡ã®é€£çµ¡å…ˆã«å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ã¾ã™ã€‚',0),(542552,15071,'pt','VocÃª recebeu o seguinte contato',0),(542553,15071,'ru','Ð’Ñ‹ Ð±Ñ‹Ð»Ð¸ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ñ‹ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ñ‹',0),(542554,15071,'es','Se le ha asignado el siguiente contacto',0),(542555,15071,'de','Sie haben den folgenden Kontakt zugeordnet wurde',0),(542556,15071,'en','You Have Been Assigned The Following Contact',0),(542557,15072,'is','',0),(542558,15072,'dr','Ù…Ø§Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Prox',0),(542559,15072,'pr','Ù…Ø§Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Prox',0),(542560,15072,'tr','AylardÄ±r Prox hesaplama',0),(542561,15072,'pl','MiesiÄ™cy do obliczania Prox',0),(542562,15072,'bg','ÐœÐµÑÐµÑ†Ð° Ð·Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Prox',0),(542563,15072,'ur','Ù…Ø§Û Ù¾Ø±Ø§ÙˆÙ† Ú©Û’ Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø±',0),(542564,15072,'sr','ÐœÐµÑÐµÑ†Ð¸ Ð·Ð° Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ ÐŸÑ€Ð¾x',0),(542565,15072,'vi','VÃ i thÃ¡ng Ä‘á»ƒ Prox tÃ­nh',0),(542566,15072,'af','Maande vir Prox berekening',0),(542567,15072,'ro','Luni pentru calculul Prox',0),(542568,15072,'et','Kuu Prox arvutamine',0),(542569,15072,'si','Mesecev za izraÄun Prox',0),(542570,15072,'ba','Bulan untuk perhitungan Prox',0),(542571,15072,'nl','Maanden voor Prox berekening',0),(542572,15072,'fi','Kuukauden Prox laskentaa varten',0),(542573,15072,'no','MÃ¥neder For Prox beregning',0),(542574,15072,'da','MÃ¥neder For Prox beregning',0),(542575,15072,'ko','Prox ê³„ì‚°ì— ëŒ€ í•œ ë‹¬',0),(542576,15072,'he','×—×•×“×©×™× ×œ×—×™×©×•×‘ Prox',0),(542577,15072,'el','ÎœÎ®Î½ÎµÏ‚ Î³Î¹Î± Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Prox',0),(542578,15072,'zh','æ„Ÿåº”è®¡ç®—çš„å‡ ä¸ªæœˆ',0),(542579,15072,'sv','MÃ¥nader fÃ¶r Prox berÃ¤kning',0),(542580,15072,'it','Mesi per calcolo Prox',0),(542581,15072,'tl','',0),(542582,15072,'th','à¹€à¸”à¸·à¸­à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸„à¸³à¸™à¸§à¸“ Prox',0),(542583,15072,'hi','Prox à¤—à¤£à¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¹à¥€à¤¨à¥‹à¤‚',0),(542584,15072,'ms','Bulan untuk pengiraan Prox',0),(542585,15072,'ar','Ø£Ø´Ù‡Ø± Ù„Ø­Ø³Ø§Ø¨ Prox',0),(542586,15072,'fr','Mois pour le calcul de Prox',0),(542587,15072,'jp','è¿‘æŽ¥ã®è¨ˆç®—ã®ãŸã‚ãƒ¶æœˆ',0),(542588,15072,'pt','Meses para cÃ¡lculo Prox',0),(542589,15072,'ru','ÐœÐµÑÑÑ†ÐµÐ² Ð´Ð»Ñ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð° Prox',0),(542590,15072,'es','Meses para el cÃ¡lculo de Prox',0),(542591,15072,'de','Monaten fÃ¼r Prox-Berechnung',0),(542592,15072,'en','Months For Prox Calculation',0),(542593,15073,'is','',0),(542594,15073,'dr','Ù…Ø§Ù‡ Prox Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªØ®ÙÛŒÙ ØªØ§Ø±ÛŒØ®',0),(542595,15073,'pr','Ù…Ø§Ù‡ Prox Ù…Ø­Ø§Ø³Ø¨Ù‡ ØªØ®ÙÛŒÙ ØªØ§Ø±ÛŒØ®',0),(542596,15073,'tr','Ay Prox iskontosu tarihinin hesaplanmasÄ± iÃ§in',0),(542597,15073,'pl','MiesiÄ™cy do obliczania daty rabatu Prox',0),(542598,15073,'bg','ÐœÐµÑÐµÑ†Ð° Ð·Ð° Prox Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°Ñ‚Ð°',0),(542599,15073,'ur','Ù…Ø§Û Ù¾Ø±Ø§ÙˆÙ† Ú©ÛŒ Ø±Ø¹Ø§ÛŒØª Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ú©Û’ Ø­Ø³Ø§Ø¨ Ú©Û’ Ù„Ø¦Û’',0),(542600,15073,'sr','ÐœÐµÑÐµÑ†Ð¸ Ð·Ð° Ð¿Ñ€Ð¾Ñ€Ð°Ñ‡ÑƒÐ½ ÐŸÑ€Ð¾x Ð´Ð°Ñ‚ÑƒÐ¼ ÐºÐ°ÑÐ°ÑÐºÐ¾Ð½Ñ‚Ð°',0),(542601,15073,'vi','VÃ i thÃ¡ng Ä‘á»ƒ Prox tÃ­nh giáº£m giÃ¡ ngÃ y',0),(542602,15073,'af','Maande vir Prox berekening van afslag datum',0),(542603,15073,'ro','Luni pentru calculul Prox reducere la data',0),(542604,15073,'et','Kuu hinnaalandi kuupÃ¤eva arvutamisel Prox',0),(542605,15073,'si','Mesecev za bli izraÄun datuma popusta',0),(542606,15073,'ba','Bulan untuk Prox perhitungan tanggal DISKON',0),(542607,15073,'nl','Maanden voor Prox berekening van de contantkorting',0),(542608,15073,'fi','Kuukauden alennuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n laskenta Prox',0),(542609,15073,'no','MÃ¥neder For Prox beregning av rabattdatoen',0),(542610,15073,'da','MÃ¥neder For Prox beregning af rabatdatoen',0),(542611,15073,'ko','Prox í• ì¸ ë‚ ì§œ ê³„ì‚°ì— ëŒ€ í•œ ë‹¬',0),(542612,15073,'he','×—×•×“×©×™× ×¢×‘×•×¨ ×—×™×©×•×‘ Prox ×ª××¨×™×š ×”× ×—×”',0),(542613,15073,'el','ÎœÎ®Î½ÎµÏ‚ Î³Î¹Î± Prox Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Ï„Î·Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚ Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚',0),(542614,15073,'zh','å‡ ä¸ªæœˆæ„Ÿåº”è®¡ç®—çš„æŠ˜æ‰£æ—¥æœŸ',0),(542615,15073,'sv','MÃ¥nader fÃ¶r Prox berÃ¤kna rabattdatum',0),(542616,15073,'it','Mesi per Prox calcolo della data di sconto',0),(542617,15073,'tl','',0),(542618,15073,'th','à¹€à¸”à¸·à¸­à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸„à¸³à¸™à¸§à¸“ Prox à¸§à¸±à¸™à¸—à¸µà¹ˆ',0),(542619,15073,'hi','à¤®à¤¹à¥€à¤¨à¥‹à¤‚ à¤•à¥‡ à¤²à¤¿à¤ Prox à¤›à¥‚à¤Ÿ à¤¤à¤¿à¤¥à¤¿ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(542620,15073,'ms','Bulan untuk pengiraan Prox tarikh diskaun',0),(542621,15073,'ar','Ø£Ø´Ù‡Ø± Ù„Ø­Ø³Ø§Ø¨ Prox Ù…Ù† ØªØ§Ø±ÙŠØ® Ø§Ù„Ø®ØµÙ…',0),(542622,15073,'fr','Mois pour Prox calcul de la Date d\'escompte',0),(542623,15073,'jp','ãƒ¶æœˆå‰²å¼•ã®æ—¥ä»˜ã®è¿‘æŽ¥è¨ˆç®—',0),(542624,15073,'pt','Meses para Prox cÃ¡lculo da data de desconto',0),(542625,15073,'ru','ÐœÐµÑÑÑ†ÐµÐ² Ð´Ð»Ñ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ³Ð¾ Ð¼ÐµÑÑÑ†Ð° Ñ€Ð°ÑÑ‡ÐµÑ‚ Ð´Ð°Ñ‚Ñ‹ ÑÐºÐ¸Ð´ÐºÐ¸',0),(542626,15073,'es','Meses para el Prox cÃ¡lculo de la fecha de descuento',0),(542627,15073,'de','Monaten fÃ¼r Prox Berechnung der Skontodatum',0),(542628,15073,'en','Months For Prox Calculation Of Discount Date',0),(542629,15074,'is','',0),(542630,15074,'dr','ØªØ§Ø±ÛŒØ® Ù…Ø§Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Prox Ù…Ù‚Ø±Ø±',0),(542631,15074,'pr','ØªØ§Ø±ÛŒØ® Ù…Ø§Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Prox Ù…Ù‚Ø±Ø±',0),(542632,15074,'tr','Ay vade Prox hesaplama tarihi',0),(542633,15074,'pl','MiesiÄ…ce obliczania Prox Due Date',0),(542634,15074,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¼ÐµÑÐµÑ†Ð° Ð·Ð° Prox Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸Ñ‚Ðµ',0),(542635,15074,'ur','Ù…Ø§Û Ù¾Ø±Ø§ÙˆÙ† Ø§Ø¹Ø¯Ø§Ø¯ Ùˆ Ø´Ù…Ø§Ø± Ú©Û’ Ù…Ù‚Ø±Ø±Û ØªØ§Ø±ÛŒØ®',0),(542636,15074,'sr','ÐœÐµÑÐµÑ†Ð¸ Ð·Ð° ÐŸÑ€Ð¾x Ð¿Ñ€Ð¾Ñ€Ð°Ñ‡ÑƒÐ½ ÐºÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(542637,15074,'vi','ThÃ¡ng Ä‘á»ƒ Prox tÃ­nh do ngÃ y',0),(542638,15074,'af','Maande vir Prox berekening van verskuldigde datum',0),(542639,15074,'ro','Data de luni, pentru calculul Prox cuvenit',0),(542640,15074,'et','Kuu jooksul nÃµuetekohaselt Prox arvutamise kuupÃ¤ev',0),(542641,15074,'si','Mesecev za izraÄun bli zapadlosti datum',0),(542642,15074,'ba','Bulan untuk perhitungan Prox Due Date',0),(542643,15074,'nl','Maanden voor Prox berekening van Due Date',0),(542644,15074,'fi','Kuukauden erÃ¤pÃ¤ivien laskennassa Prox pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(542645,15074,'no','MÃ¥neder For Prox beregning av forfallsdato dato',0),(542646,15074,'da','MÃ¥neder For Prox beregning af forfaldsdatoer dato',0),(542647,15074,'ko','ë‹¬ì˜ Prox ê³„ì‚° ë‚ ì§œ',0),(542648,15074,'he','×—×•×“×©×™× ×¢×‘×•×¨ ×—×™×©×•×‘ Prox ×™×¢×“ ×ª××¨×™×š',0),(542649,15074,'el','ÎœÎ®Î½ÎµÏ‚ Î³Î¹Î± Prox Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Ï„Î·Ï‚ Î´Î­Î¿Ï…ÏƒÎ±Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(542650,15074,'zh','å‡ ä¸ªæœˆçš„æ„Ÿåº”è®¡ç®—åˆ°æœŸæ—¥æœŸ',0),(542651,15074,'sv','MÃ¥nader fÃ¶r Prox berÃ¤kning av Due Date',0),(542652,15074,'it','Mesi per calcolo Prox scadenza Data',0),(542653,15074,'tl','',0),(542654,15074,'th','à¹€à¸”à¸·à¸­à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸„à¸³à¸™à¸§à¸“ Prox à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”à¸§à¸±à¸™',0),(542655,15074,'hi','à¤®à¤¹à¥€à¤¨à¥‹à¤‚ à¤•à¥‡ Prox à¤¨à¤¿à¤¯à¤¤ à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¤¾à¤°à¥€à¤–',0),(542656,15074,'ms','Bulan untuk pengiraan Prox habis tempoh tarikh',0),(542657,15074,'ar','Ø£Ø´Ù‡Ø± Ù„Ø­Ø³Ø§Ø¨ Prox Ø§Ù„ÙˆØ§Ø¬Ø¨ Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(542658,15074,'fr','Mois pour le calcul de la Prox de Due Date',0),(542659,15074,'jp','ãƒ¶æœˆã®ãŸã‚ã®è¿‘æŽ¥è¨ˆç®—æ—¥ä»˜',0),(542660,15074,'pt','Data de meses para cÃ¡lculo Prox da devida',0),(542661,15074,'ru','ÐœÐµÑÑÑ†ÐµÐ² Ð´Ð»Ñ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð° Prox Ð½Ð°Ð´Ð»ÐµÐ¶Ð°Ñ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹',0),(542662,15074,'es','Fecha de meses para el Prox cÃ¡lculo de Due',0),(542663,15074,'de','Monate fÃ¼r Prox Berechnung der Due',0),(542664,15074,'en','Months For Prox Calculation Of Due Date',0),(542665,15075,'is','',0),(542666,15075,'dr','Ù…Ù†Ø·Ù‚Ù‡ Ø²Ù…Ø§Ù†ÛŒ',0),(542667,15075,'pr','Ù…Ù†Ø·Ù‚Ù‡ Ø²Ù…Ø§Ù†ÛŒ',0),(542668,15075,'tr','Saat dilimi',0),(542669,15075,'pl','Strefa czasowa',0),(542670,15075,'bg','Ð§Ð°ÑÐ¾Ð²Ð°Ñ‚Ð° Ð·Ð¾Ð½Ð°',0),(542671,15075,'ur','Ù…Ù†Ø·Ù‚Û ÙˆÙ‚Øª',0),(542672,15075,'sr','Ð’Ñ€ÐµÐ¼ÐµÐ½ÑÐºÐ° Ð·Ð¾Ð½Ð°',0),(542673,15075,'vi','MÃºi giá»',0),(542674,15075,'af','Tydsone',0),(542675,15075,'ro','Fusul orar',0),(542676,15075,'et','AjavÃ¶Ã¶ndi',0),(542677,15075,'si','ÄŒasovni pas',0),(542678,15075,'ba','Zona waktu',0),(542679,15075,'nl','Tijdzone',0),(542680,15075,'fi','AikavyÃ¶hyke',0),(542681,15075,'no','Tidssone',0),(542682,15075,'da','Tidszone',0),(542683,15075,'ko','í‘œì¤€ ì‹œê°„ëŒ€',0),(542684,15075,'he','××–×•×¨ ×–×ž×Ÿ',0),(542685,15075,'el','Î–ÏŽÎ½Î· ÏŽÏÎ±Ï‚',0),(542686,15075,'zh','æ—¶åŒº',0),(542687,15075,'sv','Tidszon',0),(542688,15075,'it','Fuso orario',0),(542689,15075,'tl','',0),(542690,15075,'th','à¹‚à¸‹à¸™à¹€à¸§à¸¥à¸²',0),(542691,15075,'hi','à¤¸à¤®à¤¯ à¤œà¤¼à¥‹à¤¨',0),(542692,15075,'ms','Zon masa',0),(542693,15075,'ar','Ø§Ù„Ù…Ù†Ø·Ù‚Ø© Ø§Ù„Ø²Ù…Ù†ÙŠØ©',0),(542694,15075,'fr','Fuseau horaire',0),(542695,15075,'jp','ã‚¿ã‚¤ãƒ  ã‚¾ãƒ¼ãƒ³',0),(542696,15075,'pt','Fuso horÃ¡rio',0),(542697,15075,'ru','Ð§Ð°ÑÐ¾Ð²Ð¾Ð¹ Ð¿Ð¾ÑÑ',0),(542698,15075,'es','Zona horaria',0),(542699,15075,'de','Zeitzone',0),(542700,15075,'en','Time Zone',0),(542701,15076,'is','',0),(542702,15076,'dr','Ù…Ù†Ø·Ù‚Ù‡ Ø²Ù…Ø§Ù†ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø±Ú©Øª',0),(542703,15076,'pr','Ù…Ù†Ø·Ù‚Ù‡ Ø²Ù…Ø§Ù†ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø´Ø±Ú©Øª',0),(542704,15076,'tr','KullanÄ±m ÅŸirket saat dilimi',0),(542705,15076,'pl','Firma wykorzystanie strefy czasowej',0),(542706,15076,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ñ‡Ð°ÑÐ¾Ð²Ð°Ñ‚Ð° Ð·Ð¾Ð½Ð°',0),(542707,15076,'ur','Ù…Ù†Ø·Ù‚Û ÙˆÙ‚Øª Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ù…Ù¾Ù†ÛŒ',0),(542708,15076,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð²Ñ€ÐµÐ¼ÐµÐ½ÑÐºÐµ Ð—Ð¾Ð½Ðµ',0),(542709,15076,'vi','CÃ´ng ty sá»­ dá»¥ng mÃºi giá»',0),(542710,15076,'af','Gebruik maatskappy tydsone',0),(542711,15076,'ro','Utilizarea companie fusul orar',0),(542712,15076,'et','Kasuta ettevÃµtte ajavÃ¶Ã¶nd',0),(542713,15076,'si','Podjetje uporabo Äasovnega pasu',0),(542714,15076,'ba','Perusahaan menggunakan zona waktu',0),(542715,15076,'nl','Gebruik bedrijf tijdzone',0),(542716,15076,'fi','KÃ¤ytÃ¤ yrityksen aikavyÃ¶hyke',0),(542717,15076,'no','Bruk firmaets tidssone',0),(542718,15076,'da','Brug selskab tidszone',0),(542719,15076,'ko','ì‚¬ìš© í•˜ ì—¬ íšŒì‚¬ í‘œì¤€ ì‹œê°„ëŒ€',0),(542720,15076,'he','××–×•×¨ ×–×ž×Ÿ ×©×™×ž×•×© ×”×—×‘×¨×”',0),(542721,15076,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± Ï‡ÏÎ®ÏƒÎ· Î¶ÏŽÎ½Î·Ï‚ ÏŽÏÎ±Ï‚',0),(542722,15076,'zh','ä½¿ç”¨å…¬å¸çš„æ—¶åŒº',0),(542723,15076,'sv','AnvÃ¤nda fÃ¶retagets tidszon',0),(542724,15076,'it','Fuso orario uso azienda',0),(542725,15076,'tl','',0),(542726,15076,'th','à¹‚à¸‹à¸™à¹€à¸§à¸¥à¸²à¸‚à¸­à¸‡ à¸šà¸£à¸´à¸©à¸±à¸—à¹ƒà¸Šà¹‰',0),(542727,15076,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚ à¤¸à¤®à¤¯ à¤œà¤¼à¥‹à¤¨',0),(542728,15076,'ms','Zon masa penggunaan Syarikat',0),(542729,15076,'ar','Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„Ù…Ù†Ø·Ù‚Ø© Ø§Ù„Ø²Ù…Ù†ÙŠØ©',0),(542730,15076,'fr','Fuseau horaire usage entreprise',0),(542731,15076,'jp','ã‚¿ã‚¤ãƒ  ã‚¾ãƒ¼ãƒ³ã‚’ä½¿ç”¨ã™ã‚‹ä¼šç¤¾',0),(542732,15076,'pt','Zona de tempo de uso empresa',0),(542733,15076,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ñ‡Ð°ÑÐ¾Ð²Ð¾Ð¹ Ð¿Ð¾ÑÑ',0),(542734,15076,'es','Empresa uso horario',0),(542735,15076,'de','Verwendung Firma Zeitzone',0),(542736,15076,'en','Use Company Time Zone',0),(542737,15077,'is','',0),(542738,15077,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø³Ø±Ø¨ Ù…ÛŒ Ø¨Ø§Ø´Ø¯.',0),(542739,15077,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø³Ø±Ø¨ Ù…ÛŒ Ø¨Ø§Ø´Ø¯.',0),(542740,15077,'tr','SatÄ±cÄ± bir ipucu bu.',0),(542741,15077,'pl','Sprzedawca jest prowadziÄ‡',0),(542742,15077,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ðµ Ð¾Ð»Ð¾Ð²Ð¾',0),(542743,15077,'ur','ÙØ±ÙˆØ´Ù†Ø¯Û Ú©Ùˆ Ø¨Ø±ØªØ±ÛŒ Ø­Ø§ØµÙ„ ÛÛ’ Û”',0),(542744,15077,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ñ˜Ðµ Ñ‚Ñ€Ð°Ð³',0),(542745,15077,'vi','NgÆ°á»i bÃ¡n hÃ ng lÃ  má»™t dáº«n',0),(542746,15077,'af','Verkoper Is \'n lei',0),(542747,15077,'ro','VÃ¢nzÄƒtorul este o conduce',0),(542748,15077,'et','Hankija on plii',0),(542749,15077,'si','Prodajalec je vodilo',0),(542750,15077,'ba','Vendor adalah memimpin',0),(542751,15077,'nl','Leverancier Is een voorsprong',0),(542752,15077,'fi','Toimittajan on johtaa',0),(542753,15077,'no','LeverandÃ¸ren er et kundeemne',0),(542754,15077,'da','LeverandÃ¸ren er et kundeemne',0),(542755,15077,'ko','ê³µê¸‰ ì—…ì²´ëŠ” ë¦¬ë“œ',0),(542756,15077,'he','×”×¡×¤×§ ×”×•× ×§×¦×” ×—×•×˜',0),(542757,15077,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ ÎµÎ¯Î½Î±Î¹ ÎµÎ½ÏŒÏ‚ Ï…Ï€Î¿ÏˆÎ®Ï†Î¹Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(542758,15077,'zh','ä¾›åº”å•†æ˜¯é“…',0),(542759,15077,'sv','SÃ¤ljaren Ã¤r ett Lead',0),(542760,15077,'it','Fornitore Ã¨ un piombo',0),(542761,15077,'tl','',0),(542762,15077,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¹€à¸›à¹‡à¸™à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸›à¹‰à¸²à¸«à¸¡à¸²à¸¢',0),(542763,15077,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤à¤• à¤¨à¥‡à¤¤à¥ƒà¤¤à¥à¤µ à¤¹à¥ˆ',0),(542764,15077,'ms','Penjual adalah persiapan',0),(542765,15077,'ar','Ø§Ù„Ù…ÙˆØ±Ø¯ Ù‡Ùˆ Ø±Ø§Ø¦Ø¯',0),(542766,15077,'fr','Vendeur est un plomb',0),(542767,15077,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã¯ã€ãƒªãƒ¼ãƒ‰ã§ã™ã€‚',0),(542768,15077,'pt','Fornecedor Ã© uma pista',0),(542769,15077,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº-Ð²ÐµÐ´ÑƒÑ‰Ð¸Ð¹',0),(542770,15077,'es','Vendedor es una pista',0),(542771,15077,'de','Hersteller ist eine Spur',0),(542772,15077,'en','Vendor Is A Lead',0),(542773,15078,'is','',0),(542774,15078,'dr','Ù…Ø´ØªØ±ÛŒ Ø§Ø³Øª Ø¨Ù‡ Ø³Ø±Ø¨',0),(542775,15078,'pr','Ù…Ø´ØªØ±ÛŒ Ø§Ø³Øª Ø¨Ù‡ Ø³Ø±Ø¨',0),(542776,15078,'tr','MÃ¼ÅŸteri bir ipucu bu.',0),(542777,15078,'pl','Klient jest prowadziÄ‡',0),(542778,15078,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑŠÑ‚ Ðµ Ð²Ð¾Ð´ÐµÑ‰Ð°',0),(542779,15078,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ù‚ÛŒØ§Ø¯Øª ÛÛ’ Û”',0),(542780,15078,'sr','ÐšÑƒÐ¿Ð°Ñ† Ñ˜Ðµ Ñ‚Ñ€Ð°Ð³',0),(542781,15078,'vi','KhÃ¡ch hÃ ng lÃ  má»™t dáº«n',0),(542782,15078,'af','KliÃ«nt \'n lood Is',0),(542783,15078,'ro','Clientul este o conduce',0),(542784,15078,'et','Klient on plii',0),(542785,15078,'si','Kupec je vodilo',0),(542786,15078,'ba','Pelanggan adalah memimpin',0),(542787,15078,'nl','Klant Is een voorsprong',0),(542788,15078,'fi','Asiakas on liidin',0),(542789,15078,'no','Kunden er et kundeemne',0),(542790,15078,'da','Kunden er en fÃ¸rende',0),(542791,15078,'ko','ê³ ê°ì€ ë¦¬ë“œ',0),(542792,15078,'he','×”×œ×§×•×— ×”×•× ×§×¦×” ×—×•×˜',0),(542793,15078,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ ÎµÎ¯Î½Î±Î¹ Î­Î½Î± Î·Î³ÎµÏ„Î¹ÎºÏŒ ÏÏŒÎ»Î¿',0),(542794,15078,'zh','å®¢æˆ·æ˜¯é“…',0),(542795,15078,'sv','Kunden Ã¤r en ledande',0),(542796,15078,'it','Cliente Ã¨ un piombo',0),(542797,15078,'tl','',0),(542798,15078,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹€à¸›à¹‡à¸™à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸›à¹‰à¸²à¸«à¸¡à¸²à¸¢',0),(542799,15078,'hi','à¤à¤• à¤¨à¥‡à¤¤à¥ƒà¤¤à¥à¤µ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¹à¥ˆ',0),(542800,15078,'ms','Pelanggan adalah persiapan',0),(542801,15078,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ù‡Ùˆ Ø¹Ù…ÙŠÙ„ Ù…ØªÙˆÙ‚Ø¹',0),(542802,15078,'fr','Client est un chef de file',0),(542803,15078,'jp','é¡§å®¢ã¯ã€ãƒªãƒ¼ãƒ‰ã§ã™ã€‚',0),(542804,15078,'pt','Cliente Ã© uma pista',0),(542805,15078,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð²ÐµÐ´ÑƒÑ‰Ð¸Ð¼',0),(542806,15078,'es','El cliente es una pista',0),(542807,15078,'de','Kunde ist eine Spur',0),(542808,15078,'en','Customer Is A Lead',0),(542809,15079,'is','',0),(542810,15079,'dr','Ø³Ø±Ø¨',0),(542811,15079,'pr','Ø³Ø±Ø¨',0),(542812,15079,'tr','Ä°pucu',0),(542813,15079,'pl','ProwadziÄ‡',0),(542814,15079,'bg','Ð• Ð¾Ð»Ð¾Ð²Ð¾',0),(542815,15079,'ur','Ø¨Ø±ØªØ±ÛŒ Ø­Ø§ØµÙ„ ÛÛ’',0),(542816,15079,'sr','ÐˆÐµ Ñ‚Ñ€Ð°Ð³',0),(542817,15079,'vi','ChÃ¬',0),(542818,15079,'af','Lood is',0),(542819,15079,'ro','Este de plumb',0),(542820,15079,'et','On juhtiv',0),(542821,15079,'si','Je vodilo',0),(542822,15079,'ba','Memimpin',0),(542823,15079,'nl','Wordt geleid',0),(542824,15079,'fi','On johtaa',0),(542825,15079,'no','Ledes',0),(542826,15079,'da','Er bly',0),(542827,15079,'ko','ë¦¬ë“œ',0),(542828,15079,'he','×”×•× ×§×¦×” ×”×—×•×˜',0),(542829,15079,'el','Î•Î¯Î½Î±Î¹ Î¿Î´Î·Î³Î®ÏƒÎµÎ¹',0),(542830,15079,'zh','æ˜¯é“…',0),(542831,15079,'sv','Ã„r bly',0),(542832,15079,'it','Ãˆ piombo',0),(542833,15079,'tl','',0),(542834,15079,'th','à¹€à¸›à¹‡à¸™à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸›à¹‰à¸²à¸«à¸¡à¸²à¸¢',0),(542835,15079,'hi','à¤¨à¥‡à¤¤à¥ƒà¤¤à¥à¤µ à¤¹à¥ˆ',0),(542836,15079,'ms','Diketuai',0),(542837,15079,'ar','Ù‡Ùˆ Ø§Ù„Ø±ØµØ§Øµ',0),(542838,15079,'fr','Est dirigÃ©e',0),(542839,15079,'jp','ãƒªãƒ¼ãƒ‰',0),(542840,15079,'pt','Ã‰ chumbo',0),(542841,15079,'ru','Ð¯Ð²Ð»ÑÐµÑ‚ÑÑ Ð²ÐµÐ´ÑƒÑ‰Ð¸Ð¼',0),(542842,15079,'es','Es plomo',0),(542843,15079,'de','Ist Blei',0),(542844,15079,'en','Is Lead',0),(542845,15080,'is','',0),(542846,15080,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù…Ø®Ø§Ø·Ø¨ÛŒÙ† Ù…Ø´ØªØ±ÛŒ',0),(542847,15080,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù…Ø®Ø§Ø·Ø¨ÛŒÙ† Ù…Ø´ØªØ±ÛŒ',0),(542848,15080,'tr','MÃ¼ÅŸteri kiÅŸileri alma',0),(542849,15080,'pl','Import kontaktÃ³w z klientem',0),(542850,15080,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(542851,15080,'ur','Ú¯Ø§ÛÚ© Ø±ÙˆØ§Ø¨Ø· Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(542852,15080,'sr','Ð£Ð²ÐµÐ·Ð¸Ñ‚Ðµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ðµ ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(542853,15080,'vi','Chuyá»ƒn nháº­p liÃªn há»‡ khÃ¡ch hÃ ng',0),(542854,15080,'af','Voer kontakte in verbeteringsprogram vir',0),(542855,15080,'ro','Import contact client',0),(542856,15080,'et','Kliendi Kontaktide importimine',0),(542857,15080,'si','Uvozi stike kupca',0),(542858,15080,'ba','Mengimpor kontak pelanggan',0),(542859,15080,'nl','Klant contactpersonen importeren',0),(542860,15080,'fi','Asiakkaan yhteystiedot',0),(542861,15080,'no','Importere kundekontakter',0),(542862,15080,'da','Importere kundekontakter',0),(542863,15080,'ko','ê³ ê° ì—°ë½ì²˜ ê°€ì ¸ì˜¤ê¸°',0),(542864,15080,'he','×™×™×‘×•× ×× ×©×™ ×§×©×¨ ×œ×§×•×—×•×ª',0),(542865,15080,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÏ€Î±Ï†ÏŽÎ½ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(542866,15080,'zh','å¯¼å…¥å®¢æˆ·è”ç³»äºº',0),(542867,15080,'sv','Importera kundkontakter',0),(542868,15080,'it','Importare i contatti del cliente',0),(542869,15080,'tl','',0),(542870,15080,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(542871,15080,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤‚à¤ªà¤°à¥à¤• à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(542872,15080,'ms','Import orang hubungan pelanggan',0),(542873,15080,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¬Ù‡Ø§Øª Ø§ØªØµØ§Ù„ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(542874,15080,'fr','Importer des Contacts avec la clientÃ¨le',0),(542875,15080,'jp','é¡§å®¢ã®é€£çµ¡å…ˆã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(542876,15080,'pt','Importar contatos do cliente',0),(542877,15080,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(542878,15080,'es','Importar contactos de atenciÃ³n al cliente',0),(542879,15080,'de','Kunden-Kontakte importieren',0),(542880,15080,'en','Import Customer Contacts',0),(542881,15081,'is','',0),(542882,15081,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù…Ø®Ø§Ø·Ø¨ÛŒÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(542883,15081,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ù…Ø®Ø§Ø·Ø¨ÛŒÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(542884,15081,'tr','SatÄ±cÄ± kiÅŸileri alma',0),(542885,15081,'pl','Import kontaktÃ³w z dostawcÄ…',0),(542886,15081,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¸ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(542887,15081,'ur','ÙˆÛŒÙ†ÚˆØ± Ø±ÙˆØ§Ø¨Ø· Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(542888,15081,'sr','Ð£Ð²ÐµÐ·Ð¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ðµ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(542889,15081,'vi','Chuyá»ƒn nháº­p liÃªn há»‡ nhÃ  cung cáº¥p',0),(542890,15081,'af','Handelaar kontakte invoer',0),(542891,15081,'ro','Import contact de furnizor',0),(542892,15081,'et','Hankija Kontaktide importimine',0),(542893,15081,'si','Uvozi stike dobavitelja',0),(542894,15081,'ba','Mengimpor kontak Vendor',0),(542895,15081,'nl','Leverancier contactpersonen importeren',0),(542896,15081,'fi','Toimittajan yhteystietojen tuominen',0),(542897,15081,'no','Importere leverandÃ¸r kontakter',0),(542898,15081,'da','Importere kreditorkontakter',0),(542899,15081,'ko','ê³µê¸‰ ì—…ì²´ ì—°ë½ì²˜ ê°€ì ¸ì˜¤ê¸°',0),(542900,15081,'he','×™×™×‘×•× ×× ×©×™ ×§×©×¨ ×¡×¤×§×™×',0),(542901,15081,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÏ€Î±Ï†ÏŽÎ½ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(542902,15081,'zh','å¯¼å…¥ä¾›åº”å•†è”ç³»äºº',0),(542903,15081,'sv','Importera leverantÃ¶rskontakter',0),(542904,15081,'it','Importare contatti fornitore',0),(542905,15081,'tl','',0),(542906,15081,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(542907,15081,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(542908,15081,'ms','Mengimport kenalan penjual.',0),(542909,15081,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¬Ù‡Ø§Øª Ø§ØªØµØ§Ù„ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(542910,15081,'fr','Importer des Contacts du vendeur',0),(542911,15081,'jp','ä»•å…¥å…ˆã®é€£çµ¡å…ˆã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(542912,15081,'pt','Importar contatos de fornecedor',0),(542913,15081,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð¾Ð² Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(542914,15081,'es','Importar contactos de proveedores',0),(542915,15081,'de','Import Herstellerkontakte',0),(542916,15081,'en','Import Vendor Contacts',0),(542917,15082,'is','',0),(542918,15082,'dr','POs ØªÙˆØ³Ø· ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(542919,15082,'pr','POs ØªÙˆØ³Ø· ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(542920,15082,'tr','SatÄ±cÄ± tarafÄ±ndan pOs',0),(542921,15082,'pl','POs przez sprzedawcÄ™',0),(542922,15082,'bg','POs Ð¾Ñ‚ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(542923,15082,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù†',0),(542924,15082,'sr','ÐŸÐžÑ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(542925,15082,'vi','POs bá»Ÿi nhÃ  cung cáº¥p',0),(542926,15082,'af','POs deur die verkoper',0),(542927,15082,'ro','POs de furnizor',0),(542928,15082,'et','POs hankija jÃ¤rgi',0),(542929,15082,'si','POs jih prodajalec',0),(542930,15082,'ba','POs oleh Vendor',0),(542931,15082,'nl','POs door verkoper',0),(542932,15082,'fi','POs toimittajittain',0),(542933,15082,'no','POs av leverandÃ¸r',0),(542934,15082,'da','POs efter kreditor',0),(542935,15082,'ko','ê³µê¸‰ ì—…ì²´ì—ì„œ pOs',0),(542936,15082,'he','POs ×œ×¤×™ ×¡×¤×§',0),(542937,15082,'el','Î Î©Î£ Î±Ï€ÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(542938,15082,'zh','ä¾›åº”å•†çš„é‡‡è´­è®¢å•',0),(542939,15082,'sv','POs per leverantÃ¶r',0),(542940,15082,'it','POs dal venditore',0),(542941,15082,'tl','',0),(542942,15082,'th','POs à¹‚à¸”à¸¢à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(542943,15082,'hi','POs à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(542944,15082,'ms','POs oleh penjual.',0),(542945,15082,'ar','Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ù…Ù† Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(542946,15082,'fr','POs par vendeur',0),(542947,15082,'jp','POs ãƒ™ãƒ³ãƒ€ãƒ¼ã«ã‚ˆã£ã¦',0),(542948,15082,'pt','POs por vendedor',0),(542949,15082,'ru','POs Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð¼',0),(542950,15082,'es','POs por proveedor',0),(542951,15082,'de','POs vom Hersteller',0),(542952,15082,'en','POs By Vendor',0),(542953,15083,'is','',0),(542954,15083,'dr','ØªÙ†Ù‡Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø§ÛŒØ¬Ø§Ø¯ Ø·Ø±Ø­ Ø®Ø±ÛŒØ¯ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù†ÛŒØ³Øª',0),(542955,15083,'pr','ØªÙ†Ù‡Ø§ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø§ÛŒØ¬Ø§Ø¯ Ø·Ø±Ø­ Ø®Ø±ÛŒØ¯ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù†ÛŒØ³Øª',0),(542956,15083,'tr','SatÄ±nalma teklifleri deÄŸil POs oluÅŸturabilmeniz iÃ§in',0),(542957,15083,'pl','MoÅ¼na utworzyÄ‡ tylko propozycje zakupu nie POs',0),(542958,15083,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° ÑÑŠÐ·Ð´Ð°Ð²Ð°Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð½Ðµ ÐŸÐ¾Ð·',0),(542959,15083,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ¬Ø§ÙˆÛŒØ² Ù†Û Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† ØµØ±Ù Ø¨Ù†Ø§ Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(542960,15083,'sr','ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ ÑÐ°Ð¼Ð¾ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð·Ð¸ Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ð½Ðµ ÐŸÐžÑ',0),(542961,15083,'vi','Chá»‰ cÃ³ thá»ƒ táº¡o ra mua Ä‘á» nghá»‹ khÃ´ng POs',0),(542962,15083,'af','Kan aankoop voorstelle nie POs skep slegs',0),(542963,15083,'ro','Pot crea numai cumpÄƒrare propuneri nu POs',0),(542964,15083,'et','Saate luua ainult ostu ettepanekud ei POs',0),(542965,15083,'si','Lahko ustvarite le nakup predloge ne POs',0),(542966,15083,'ba','Hanya dapat membuat proposal pembelian tidak POs',0),(542967,15083,'nl','Kan alleen maar leiden tot aankoop voorstellen niet POs',0),(542968,15083,'fi','Luoda vain ostaa ehdotuksia ei POs',0),(542969,15083,'no','Kan bare opprette kjÃ¸pe forslag ikke POs',0),(542970,15083,'da','Kan kun oprette KÃ¸b forslag ikke POs',0),(542971,15083,'ko','êµ¬ë§¤ ì œì•ˆ í•˜ì§€ POs ë§Œë“¤ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(542972,15083,'he','×‘××¤×©×¨×•×ª×š ×œ×™×¦×•×¨ ×¨×§ ×”×¦×¢×•×ª ×¨×›×™×©×” ×œ× POs',0),(542973,15083,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î¼ÏŒÎ½Î¿ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹ Ï€ÏÎ¿Ï„Î¬ÏƒÎµÎ¹Ï‚ Î±Î³Î¿ÏÎ¬Ï‚ Î´ÎµÎ½ Ï„Î¿ Î Î©Î£',0),(542974,15083,'zh','åªèƒ½åˆ›å»ºé‡‡è´­å»ºè®®ä¸ POs',0),(542975,15083,'sv','Kan bara skapa kÃ¶p fÃ¶rslag inte POs',0),(542976,15083,'it','PuÃ² solo creare proposte di acquisto non POs',0),(542977,15083,'tl','',0),(542978,15083,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¸ªà¸£à¹‰à¸²à¸‡à¸‚à¹‰à¸­à¹€à¸ªà¸™à¸­à¸‹à¸·à¹‰à¸­à¹„à¸¡à¹ˆ POs à¹€à¸—à¹ˆà¸²',0),(542979,15083,'hi','à¤•à¥‡à¤µà¤² à¤–à¤°à¥€à¤¦ à¤ªà¥à¤°à¤¸à¥à¤¤à¤¾à¤µà¥‹à¤‚ POs à¤¨à¤¹à¥€à¤‚ à¤¬à¤¨à¤¾ à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(542980,15083,'ms','Hanya boleh membuat cadangan-cadangan pembelian POs tidak',0),(542981,15083,'ar','ÙŠÙ…ÙƒÙ† ÙÙ‚Ø· Ø¥Ù†Ø´Ø§Ø¡ Ù…Ù‚ØªØ±Ø­Ø§Øª Ø§Ù„Ø´Ø±Ø§Ø¡ Ù„Ø§ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹',0),(542982,15083,'fr','Ne peuvent crÃ©er des propositions d\'achat pas POs',0),(542983,15083,'jp','è³¼å…¥ææ¡ˆã—ãªã„ POs ã‚’ä½œæˆã§ãã‚‹ã ã‘',0),(542984,15083,'pt','SÃ³ pode criar propostas de compra nÃ£o POs',0),(542985,15083,'ru','ÐœÐ¾Ð¶Ð½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð½Ðµ POs',0),(542986,15083,'es','SÃ³lo puede crear propuestas de compra no POs',0),(542987,15083,'de','Kauf VorschlÃ¤ge nicht POs kann nur erstellt werden.',0),(542988,15083,'en','Can Only Create Purchase Proposals Not POs',0),(542989,15084,'is','',0),(542990,15084,'dr','Magento Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(542991,15084,'pr','Magento Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(542992,15084,'tr','Magento gÃ¼ncelleÅŸtiriliyor',0),(542993,15084,'pl','Aktualizowanie Magento',0),(542994,15084,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Magento',0),(542995,15084,'ur','Ù…Ø§Ú¯Ø§Ù†Ù¹Ùˆ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(542996,15084,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÐœÐ°Ð³ÐµÐ½Ñ‚Ð¾',0),(542997,15084,'vi','Cáº­p Nháº­t Magento',0),(542998,15084,'af','Outobywerking Magento',0),(542999,15084,'ro','Actualizarea Magento',0),(543000,15084,'et','Ajakohastamine Magento',0),(543001,15084,'si','Posodabljanje Magento',0),(543002,15084,'ba','Memperbarui Magento',0),(543003,15084,'nl','Magento bijwerken',0),(543004,15084,'fi','PÃ¤ivittÃ¤Ã¤ Magento',0),(543005,15084,'no','Oppdatere Magento',0),(543006,15084,'da','Opdatering af Magento',0),(543007,15084,'ko','Magento ì—…ë°ì´íŠ¸',0),(543008,15084,'he','×¢×“×›×•×Ÿ ×ž×’\'× ×˜×•',0),(543009,15084,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Magento',0),(543010,15084,'zh','æ›´æ–° Magento',0),(543011,15084,'sv','Uppdatera Magento',0),(543012,15084,'it','Aggiornare Magento',0),(543013,15084,'tl','',0),(543014,15084,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸§à¸µà¹‚à¸­à¹„à¸­à¸žà¸µ',0),(543015,15084,'hi','Magento à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¤¾',0),(543016,15084,'ms','Mengemaskini Magento',0),(543017,15084,'ar','ØªØ­Ø¯ÙŠØ« [Ù…Ø¬Ù†ØªÙˆ]',0),(543018,15084,'fr','Mise Ã  jour Magento',0),(543019,15084,'jp','Magento ã®æ›´æ–°',0),(543020,15084,'pt','AtualizaÃ§Ã£o do Magento',0),(543021,15084,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Magento',0),(543022,15084,'es','ActualizaciÃ³n de Magento',0),(543023,15084,'de','Aktualisieren von Magento',0),(543024,15084,'en','Updating Magento',0),(543025,15085,'is','',0),(543026,15085,'dr','ØªÙ…Ø§Ù… ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ ØªÙ…Ø§Ø³',0),(543027,15085,'pr','ØªÙ…Ø§Ù… ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ ØªÙ…Ø§Ø³',0),(543028,15085,'tr','Ä°lgili kiÅŸi iÃ§in tÃ¼m etkinlik',0),(543029,15085,'pl','Wszystkie dziaÅ‚ania dla kontaktu',0),(543030,15085,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(543031,15085,'ur','Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯ Ú©Û’ Ù„ÛŒÛ’ ØªÙ…Ø§Ù… Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(543032,15085,'sr','Ð¡Ð²Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(543033,15085,'vi','Táº¥t cáº£ hoáº¡t Ä‘á»™ng cho sá»‘ liÃªn láº¡c',0),(543034,15085,'af','Alle aktiwiteit vir kontak',0),(543035,15085,'ro','Orice activitate de contact',0),(543036,15085,'et','KÃµik tegevus kontakt',0),(543037,15085,'si','Vse dejavnosti za stik',0),(543038,15085,'ba','Semua aktivitas untuk kontak',0),(543039,15085,'nl','Alle activiteiten voor contactpersoon',0),(543040,15085,'fi','Kaikkea toimintaa yhteystiedolle',0),(543041,15085,'no','All aktivitet For kontakt',0),(543042,15085,'da','Al aktivitet For kontakt',0),(543043,15085,'ko','ì—°ë½ì²˜ì— ëŒ€ í•œ ëª¨ë“  í™œë™',0),(543044,15085,'he','×›×œ ×¤×¢×™×œ×•×ª ×¢×‘×•×¨ ××™×© ×§×©×¨',0),(543045,15085,'el','ÎšÎ¬Î¸Îµ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î³Î¹Î± Ï„Î·Î½ ÎµÏ€Î±Ï†Î®',0),(543046,15085,'zh','è”ç³»äººçš„æ‰€æœ‰æ´»åŠ¨',0),(543047,15085,'sv','Alla aktiviteter fÃ¶r kontakt',0),(543048,15085,'it','Tutte le attivitÃ  per contatto',0),(543049,15085,'tl','',0),(543050,15085,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­',0),(543051,15085,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(543052,15085,'ms','Semua aktiviti untuk orang hubungan',0),(543053,15085,'ar','ÙƒÙ„ Ù†Ø´Ø§Ø· Ù„Ù„Ø§ØªØµØ§Ù„',0),(543054,15085,'fr','Toute l\'activitÃ© de Contact',0),(543055,15085,'jp','é€£çµ¡å…ˆã®ã™ã¹ã¦ã®ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£',0),(543056,15085,'pt','Todas as atividades para contato',0),(543057,15085,'ru','Ð’ÑÑ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚ÑŒ Ð´Ð»Ñ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð°',0),(543058,15085,'es','Toda la actividad de contacto',0),(543059,15085,'de','Alle AktivitÃ¤ten fÃ¼r Kontakt',0),(543060,15085,'en','All Activity For Contact',0),(543061,15086,'is','',0),(543062,15086,'dr','ØªÙ…Ø§Ù… ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ',0),(543063,15086,'pr','ØªÙ…Ø§Ù… ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ',0),(543064,15086,'tr','MÃ¼ÅŸteri iÃ§in tÃ¼m etkinlik',0),(543065,15086,'pl','Wszystkie dziaÅ‚ania dla klienta',0),(543066,15086,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(543067,15086,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù„ÛŒÛ’ ØªÙ…Ø§Ù… Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(543068,15086,'sr','Ð¡Ð²Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° ÐºÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð°',0),(543069,15086,'vi','Táº¥t cáº£ hoáº¡t Ä‘á»™ng cho khÃ¡ch hÃ ng',0),(543070,15086,'af','Alle aktiwiteit vir die kliÃ«nt',0),(543071,15086,'ro','Orice activitate pentru client',0),(543072,15086,'et','KÃµik tegevus kliendi',0),(543073,15086,'si','Vse dejavnosti za kupca',0),(543074,15086,'ba','Semua aktivitas untuk pelanggan',0),(543075,15086,'nl','Alle activiteiten voor klant',0),(543076,15086,'fi','Kaikki toiminta asiakkaan',0),(543077,15086,'no','All aktivitet For kunde',0),(543078,15086,'da','Al aktivitet For kunde',0),(543079,15086,'ko','ê³ ê°ì„ ìœ„í•œ ëª¨ë“  í™œë™',0),(543080,15086,'he','×›×œ ×¤×¢×™×œ×•×ª ×¢×‘×•×¨ ×œ×§×•×—',0),(543081,15086,'el','ÎšÎ¬Î¸Îµ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î³Î¹Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(543082,15086,'zh','å®¢æˆ·çš„æ‰€æœ‰æ´»åŠ¨',0),(543083,15086,'sv','Alla aktiviteter fÃ¶r kund',0),(543084,15086,'it','Tutte le attivitÃ  per il cliente',0),(543085,15086,'tl','',0),(543086,15086,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²',0),(543087,15086,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(543088,15086,'ms','Semua aktiviti untuk pelanggan',0),(543089,15086,'ar','ÙƒÙ„ Ù†Ø´Ø§Ø· Ù„Ù„Ø¹Ù…ÙŠÙ„',0),(543090,15086,'fr','Toutes les activitÃ©s pour le client',0),(543091,15086,'jp','ã™ã¹ã¦ã®é¡§å®¢ã®ãŸã‚ã®æ´»å‹•',0),(543092,15086,'pt','Todas as atividades para o cliente',0),(543093,15086,'ru','Ð’ÑÐµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð´Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(543094,15086,'es','Toda la actividad para el cliente',0),(543095,15086,'de','Alle AktivitÃ¤ten fÃ¼r Kunden',0),(543096,15086,'en','All Activity For Customer',0),(543097,15087,'is','',0),(543098,15087,'dr','ØªÙ…Ø§Ù… ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(543099,15087,'pr','ØªÙ…Ø§Ù… ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(543100,15087,'tr','SatÄ±cÄ± iÃ§in tÃ¼m etkinlik',0),(543101,15087,'pl','Wszystkie dziaÅ‚ania dla dostawcy',0),(543102,15087,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(543103,15087,'ur','ØªÙ…Ø§Ù… Ø³Ø±Ú¯Ø±Ù…ÛŒ ÙˆÛŒÙ†ÚˆØ± Ú©Û’ Ù„Ø¦Û’',0),(543104,15087,'sr','Ð¡Ð²Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(543105,15087,'vi','Táº¥t cáº£ hoáº¡t Ä‘á»™ng cho cÃ¡c nhÃ  cung cáº¥p',0),(543106,15087,'af','Alle aktiwiteit vir handelaar',0),(543107,15087,'ro','Orice activitate de furnizor',0),(543108,15087,'et','KÃµik tegevus hankija',0),(543109,15087,'si','Vse dejavnosti za dobavitelja',0),(543110,15087,'ba','Semua aktivitas untuk Vendor',0),(543111,15087,'nl','Alle activiteiten voor leverancier',0),(543112,15087,'fi','Kaikki toiminta toimittajan',0),(543113,15087,'no','All aktivitet For leverandÃ¸r',0),(543114,15087,'da','Al aktivitet For kreditor',0),(543115,15087,'ko','ê³µê¸‰ ì—…ì²´ì— ëŒ€ í•œ ëª¨ë“  í™œë™',0),(543116,15087,'he','×›×œ ×¤×¢×™×œ×•×ª ×¢×‘×•×¨ ×¡×¤×§',0),(543117,15087,'el','ÎšÎ¬Î¸Îµ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î³Î¹Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(543118,15087,'zh','ä¾›åº”å•†çš„æ‰€æœ‰æ´»åŠ¨',0),(543119,15087,'sv','All verksamhet fÃ¶r leverantÃ¶r',0),(543120,15087,'it','Tutte le attivitÃ  per il fornitore',0),(543121,15087,'tl','',0),(543122,15087,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(543123,15087,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(543124,15087,'ms','Semua aktiviti untuk penjual.',0),(543125,15087,'ar','ÙƒÙ„ Ù†Ø´Ø§Ø· Ù„Ù„Ù…ÙˆØ±Ø¯',0),(543126,15087,'fr','Toute l\'activitÃ© de vendeur',0),(543127,15087,'jp','ä»•å…¥å…ˆã®ã™ã¹ã¦ã®ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£',0),(543128,15087,'pt','Todas as atividades para fornecedores',0),(543129,15087,'ru','Ð’ÑÐµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(543130,15087,'es','Todas las actividades para el vendedor',0),(543131,15087,'de','Alle AktivitÃ¤ten fÃ¼r Lieferanten',0),(543132,15087,'en','All Activity For Vendor',0),(543133,15088,'is','',0),(543134,15088,'dr','ÙÙ‚Ø· Ø§ÛŒÙ† Ú©Ø§Ø± & ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§',0),(543135,15088,'pr','ÙÙ‚Ø· Ø§ÛŒÙ† Ú©Ø§Ø± & ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø§',0),(543136,15088,'tr','Sadece bu gÃ¶rev & iletiÅŸim',0),(543137,15088,'pl','Tylko ten zadanie & kontakt',0),(543138,15088,'bg','Ð¡Ð°Ð¼Ð¾ Ñ‚Ð°Ð·Ð¸ Ð·Ð°Ð´Ð°Ñ‡Ð° & ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(543139,15088,'ur','Ø¨Ø³ ÛŒÛ Ú©Ø§Ù… & Ø±Ø§Ø¨Ø·Û',0),(543140,15088,'sr','Ð¡Ð°Ð¼Ð¾ Ð¾Ð²Ð°Ñ˜ Ð·Ð°Ð´Ð°Ñ‚Ð°Ðº & ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(543141,15088,'vi','Chá»‰ nÃ y nhiá»‡m vá»¥ & liÃªn há»‡',0),(543142,15088,'af','Net hierdie taak & kontak',0),(543143,15088,'ro','Doar aceastÄƒ sarcinÄƒ & Contact',0),(543144,15088,'et','Selle Ã¼lesande & kontakt',0),(543145,15088,'si','Samo to opravilo & stik',0),(543146,15088,'ba','Hanya ini tugas & kontak',0),(543147,15088,'nl','Net deze taak & Contact',0),(543148,15088,'fi','Vain tÃ¤mÃ¤n tehtÃ¤vÃ¤n & yhteystiedot',0),(543149,15088,'no','Bare denne oppgaven & kontakt',0),(543150,15088,'da','Netop denne opgave & kontakt',0),(543151,15088,'ko','ê·¸ëƒ¥ì´ ìž‘ì—… & ì—°ë½ì²˜',0),(543152,15088,'he','×¨×§ ×–×• ×ž×©×™×ž×” & ×§×©×¨',0),(543153,15088,'el','Î‘ÎºÏÎ¹Î²ÏŽÏ‚ Î±Ï…Ï„ÏŒ Î­ÏÎ³Î¿ & ÎµÏ€Î±Ï†Î®',0),(543154,15088,'zh','åªæ˜¯è¿™ä¸ªä»»åŠ¡ & è”ç³»äºº',0),(543155,15088,'sv','Bara denna uppgift & kontakt',0),(543156,15088,'it','Solo questo compito & contatto',0),(543157,15088,'tl','',0),(543158,15088,'th','à¹à¸„à¹ˆà¸™à¸µà¹‰à¸‡à¸²à¸™ & à¸•à¸´à¸”à¸•à¹ˆà¸­',0),(543159,15088,'hi','à¤¬à¤¸ à¤‡à¤¸ à¤Ÿà¤¾à¤¸à¥à¤• & à¤¸à¤‚à¤ªà¤°à¥à¤•',0),(543160,15088,'ms','Hanya ini tugas & kenalan',0),(543161,15088,'ar','ÙÙ‚Ø· Ù‡Ø°Ù‡ Ø§Ù„Ù…Ù‡Ù…Ø© Ø¢Ù†Ø¯ Ø§Ù„Ø§ØªØµØ§Ù„',0),(543162,15088,'fr','Juste cette tÃ¢che & Contact',0),(543163,15088,'jp','ã¡ã‚‡ã†ã©ã“ã®ã‚¿ã‚¹ã‚¯ & é€£çµ¡å…ˆ',0),(543164,15088,'pt','SÃ³ esta tarefa & contato',0),(543165,15088,'ru','ÐšÐ°Ðº Ñ€Ð°Ð· ÑÑ‚Ð° Ð·Ð°Ð´Ð°Ñ‡Ð° & ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(543166,15088,'es','SÃ³lo esta tarea & contacto',0),(543167,15088,'de','Gerade diese Aufgabe & Kontakt',0),(543168,15088,'en','Just This Task & Contact',0),(543169,15089,'is','',0),(543170,15089,'dr','ÙÙ‚Ø· Ø§ÛŒÙ† Ú©Ø§Ø± & Ù…Ø´ØªØ±ÛŒ',0),(543171,15089,'pr','ÙÙ‚Ø· Ø§ÛŒÙ† Ú©Ø§Ø± & Ù…Ø´ØªØ±ÛŒ',0),(543172,15089,'tr','Sadece bu gÃ¶rev & mÃ¼ÅŸteri',0),(543173,15089,'pl','Tylko ten zadanie & klienta',0),(543174,15089,'bg','Ð¡Ð°Ð¼Ð¾ Ñ‚Ð°Ð·Ð¸ Ð·Ð°Ð´Ð°Ñ‡Ð° & ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(543175,15089,'ur','Ø¨Ø³ ÛŒÛ Ú©Ø§Ù… & Ú¯Ø§ÛÚ©',0),(543176,15089,'sr','Ð¡Ð°Ð¼Ð¾ Ð¾Ð²Ð°Ñ˜ Ð·Ð°Ð´Ð°Ñ‚Ð°Ðº & ÐºÑƒÐ¿Ñ†Ð°',0),(543177,15089,'vi','Chá»‰ nÃ y nhiá»‡m vá»¥ & khÃ¡ch hÃ ng',0),(543178,15089,'af','Net hierdie taak & kliÃ«nt',0),(543179,15089,'ro','Doar aceastÄƒ sarcinÄƒ & client',0),(543180,15089,'et','Selle Ã¼lesande & kliendi',0),(543181,15089,'si','Samo to opravilo & kupca',0),(543182,15089,'ba','Hanya ini tugas & pelanggan',0),(543183,15089,'nl','Net deze taak & klant',0),(543184,15089,'fi','Vain tÃ¤mÃ¤n tehtÃ¤vÃ¤n & asiakkaan',0),(543185,15089,'no','Bare denne oppgaven & kunde',0),(543186,15089,'da','Netop denne opgave & kunde',0),(543187,15089,'ko','ê·¸ëƒ¥ì´ ìž‘ì—… & ê³ ê°',0),(543188,15089,'he','×¨×§ ×–×• ×ž×©×™×ž×” & ×œ×§×•×—×•×ª',0),(543189,15089,'el','Î‘ÎºÏÎ¹Î²ÏŽÏ‚ Î±Ï…Ï„ÏŒ Î­ÏÎ³Î¿ & Ï€ÎµÎ»Î¬Ï„Î·',0),(543190,15089,'zh','åªæ˜¯è¿™ä¸ªä»»åŠ¡ & å®¢æˆ·',0),(543191,15089,'sv','Bara denna uppgift & kund',0),(543192,15089,'it','Solo questo compito & cliente',0),(543193,15089,'tl','',0),(543194,15089,'th','à¹à¸„à¹ˆà¸™à¸µà¹‰à¸‡à¸²à¸™ & à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(543195,15089,'hi','à¤¬à¤¸ à¤‡à¤¸ à¤Ÿà¤¾à¤¸à¥à¤• & à¤—à¥à¤°à¤¾à¤¹à¤•',0),(543196,15089,'ms','Hanya tugas & Baca ini',0),(543197,15089,'ar','ÙÙ‚Ø· Ù‡Ø°Ù‡ Ø§Ù„Ù…Ù‡Ù…Ø© Ø¢Ù†Ø¯ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(543198,15089,'fr','Juste cette tÃ¢che & client',0),(543199,15089,'jp','ã¡ã‚‡ã†ã©ã“ã®ã‚¿ã‚¹ã‚¯ & é¡§å®¢',0),(543200,15089,'pt','SÃ³ esta tarefa & cliente',0),(543201,15089,'ru','ÐŸÑ€Ð¾ÑÑ‚Ð¾ ÑÑ‚Ð° Ð·Ð°Ð´Ð°Ñ‡Ð° & ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(543202,15089,'es','SÃ³lo esta tarea & al cliente',0),(543203,15089,'de','Gerade diese Aufgabe & Kunden',0),(543204,15089,'en','Just This Task & Customer',0),(543205,15090,'is','',0),(543206,15090,'dr','ÙÙ‚Ø· Ø§ÛŒÙ† Ú©Ø§Ø± & ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(543207,15090,'pr','ÙÙ‚Ø· Ø§ÛŒÙ† Ú©Ø§Ø± & ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(543208,15090,'tr','Sadece bu gÃ¶rev & satÄ±cÄ±',0),(543209,15090,'pl','Tylko ten zadanie & dostawcy',0),(543210,15090,'bg','Ð¡Ð°Ð¼Ð¾ Ñ‚Ð°Ð·Ð¸ Ð·Ð°Ð´Ð°Ñ‡Ð° & Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(543211,15090,'ur','Ø¨Ø³ ÛŒÛ Ú©Ø§Ù… & ÙØ±ÙˆØ´Ù†Ø¯Û',0),(543212,15090,'sr','Ð¡Ð°Ð¼Ð¾ Ð¾Ð²Ð°Ñ˜ Ð·Ð°Ð´Ð°Ñ‚Ð°Ðº & Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(543213,15090,'vi','Chá»‰ nÃ y nhiá»‡m vá»¥ & nhÃ  cung cáº¥p',0),(543214,15090,'af','Net hierdie taak & handelaar',0),(543215,15090,'ro','Doar aceastÄƒ sarcinÄƒ & furnizor',0),(543216,15090,'et','Selle Ã¼lesande & hankija',0),(543217,15090,'si','Samo to opravilo & dobavitelja',0),(543218,15090,'ba','Hanya ini tugas & Vendor',0),(543219,15090,'nl','Net deze taak & leverancier',0),(543220,15090,'fi','Vain tÃ¤mÃ¤n tehtÃ¤vÃ¤n & toimittajan',0),(543221,15090,'no','Bare denne oppgaven & leverandÃ¸r',0),(543222,15090,'da','Netop denne opgave & leverandÃ¸r',0),(543223,15090,'ko','ê·¸ëƒ¥ì´ ìž‘ì—… & ê³µê¸‰ ì—…ì²´',0),(543224,15090,'he','×¨×§ ×–×• ×ž×©×™×ž×” & ×”×¡×¤×§',0),(543225,15090,'el','Î‘ÎºÏÎ¹Î²ÏŽÏ‚ Î±Ï…Ï„ÏŒ Î­ÏÎ³Î¿ & Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(543226,15090,'zh','åªæ˜¯è¿™ä¸ªä»»åŠ¡ & ä¾›åº”å•†',0),(543227,15090,'sv','Bara denna uppgift & leverantÃ¶r',0),(543228,15090,'it','Solo questo compito & fornitore',0),(543229,15090,'tl','',0),(543230,15090,'th','à¹à¸„à¹ˆà¸™à¸µà¹‰à¸‡à¸²à¸™ & à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(543231,15090,'hi','à¤¬à¤¸ à¤‡à¤¸ à¤Ÿà¤¾à¤¸à¥à¤• & à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(543232,15090,'ms','Hanya ini tugas & penjual.',0),(543233,15090,'ar','ÙÙ‚Ø· Ù‡Ø°Ù‡ Ø§Ù„Ù…Ù‡Ù…Ø© Ø¢Ù†Ø¯ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(543234,15090,'fr','Juste cette tÃ¢che & vendeur',0),(543235,15090,'jp','ã¡ã‚‡ã†ã©ã“ã®ã‚¿ã‚¹ã‚¯ & ãƒ™ãƒ³ãƒ€ãƒ¼',0),(543236,15090,'pt','SÃ³ esta tarefa & fornecedor',0),(543237,15090,'ru','ÐŸÑ€Ð¾ÑÑ‚Ð¾ ÑÑ‚Ð° Ð·Ð°Ð´Ð°Ñ‡Ð° & Ð°Ð±Ð¾Ð½ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(543238,15090,'es','SÃ³lo esta tarea & proveedor',0),(543239,15090,'de','Gerade diese Aufgabe & Lieferanten',0),(543240,15090,'en','Just This Task & Vendor',0),(543241,15091,'is','',0),(543242,15091,'dr','Ø¨Ø¯ÙˆÙ† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ ØªØ§Ø±ÛŒØ®Ú†Ù‡ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(543243,15091,'pr','Ø¨Ø¯ÙˆÙ† Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ ØªØ§Ø±ÛŒØ®Ú†Ù‡ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(543244,15091,'tr','Tarih verisi bulunamadÄ±',0),(543245,15091,'pl','Nie ma danych historia',0),(543246,15091,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸ÑÑ‚Ð°',0),(543247,15091,'ur','Ú©ÙˆØ¦ÛŒ Ø³Ø§Ø¨Ù‚Ø§Øª Ú©ÙˆØ§Ø¦Ù Ù¾Ø§ÛŒØ§',0),(543248,15091,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¾ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð¸ Ð½Ð°ÑˆÐ°Ð¾',0),(543249,15091,'vi','KhÃ´ng cÃ³ dá»¯ liá»‡u lá»‹ch sá»­ Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(543250,15091,'af','Geen geskiedenis Data gevind',0),(543251,15091,'ro','Nu existÄƒ date de istorie gÄƒsit',0),(543252,15091,'et','Ajaloo andmeid ei leitud',0),(543253,15091,'si','Ni naÅ¡el podatke o zgodovini',0),(543254,15091,'ba','Tidak ada Data sejarah yang ditemukan',0),(543255,15091,'nl','Geen gevonden geschiedenisgegevens',0),(543256,15091,'fi','Ei historia tietoja ei lÃ¶ytynyt',0),(543257,15091,'no','Ingen historikkdata funnet',0),(543258,15091,'da','Ingen historikdata fundet',0),(543259,15091,'ko','ë°œê²¬ ì—­ì‚¬ ë°ì´í„°',0),(543260,15091,'he','××™×Ÿ × ×ª×•× ×™ ×”×”×™×¡×˜×•×¨×™×” × ×ž×¦××•',0),(543261,15091,'el','Î”ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Î± Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(543262,15091,'zh','æ‰¾ä¸åˆ°åŽ†å²æ•°æ®',0),(543263,15091,'sv','Inga historikdata hittades',0),(543264,15091,'it','Dati di storia non trovati',0),(543265,15091,'tl','',0),(543266,15091,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸›à¸£à¸°à¸§à¸±à¸•à¸´',0),(543267,15091,'hi','à¤•à¥‹à¤ˆ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤¡à¥‡à¤Ÿà¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(543268,15091,'ms','Tiada Data sejarah yang ditemui',0),(543269,15091,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(543270,15091,'fr','Aucune donnÃ©e historique trouvÃ©e',0),(543271,15091,'jp','å±¥æ­´ãƒ‡ãƒ¼ã‚¿ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(543272,15091,'pt','NÃ£o hÃ¡ dados de histÃ³ria encontrados',0),(543273,15091,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸, Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹',0),(543274,15091,'es','No hay datos de historia encontradas',0),(543275,15091,'de','Keine Geschichtendaten gefunden',0),(543276,15091,'en','No History Data Found',0),(543277,15092,'is','',0),(543278,15092,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ø¹Ù…Ù„ Ú©Ø§Ø± Ø±Ø§ Ø§ÛŒØ¬Ø§Ø¯ Ú©Ù†ÛŒØ¯',0),(543279,15092,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ø¹Ù…Ù„ Ú©Ø§Ø± Ø±Ø§ Ø§ÛŒØ¬Ø§Ø¯ Ú©Ù†ÛŒØ¯',0),(543280,15092,'tr','LÃ¼tfen bir gÃ¶rev eylemi oluÅŸturun',0),(543281,15092,'pl','ProszÄ™ utworzyÄ‡ zadanie dziaÅ‚ania',0),(543282,15092,'bg','ÐœÐ¾Ð»Ñ, ÑÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð½Ð° Ð·Ð°Ð´Ð°Ñ‡Ð°',0),(543283,15092,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ú©Ø§Ù… Ú©Ø§Ù… ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(543284,15092,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ñ€Ð°Ð´ÑšÑƒ Ð·Ð°Ð´Ð°Ñ‚ÐºÐ°',0),(543285,15092,'vi','HÃ£y táº¡o má»™t hÃ nh Ä‘á»™ng cÃ´ng viá»‡c',0),(543286,15092,'af','Skep asseblief \'n taak aksie',0),(543287,15092,'ro','VÄƒ rugÄƒm sÄƒ creaÅ£i o acÅ£iune de sarcina',0),(543288,15092,'et','Palun luua tÃ¶Ã¶Ã¼lesande tegevus',0),(543289,15092,'si','Ustvarite opravilo dejanje',0),(543290,15092,'ba','Silakan membuat tindakan tugas',0),(543291,15092,'nl','Maak een taakactie',0),(543292,15092,'fi','Luo tehtÃ¤vÃ¤n suorittaminen',0),(543293,15092,'no','Opprett en oppgavehandling',0),(543294,15092,'da','Opret venligst en opgavehandling',0),(543295,15092,'ko','ìž‘ì—… ë™ìž‘ì„ ë§Œë“¤ì–´ ì£¼ì„¸ìš”',0),(543296,15092,'he','×‘×‘×§×©×” ×¦×•×¨ ×¤×¢×•×œ×ª ×”×ž×©×™×ž×”',0),(543297,15092,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ ÎµÎ½Î­ÏÎ³ÎµÎ¹Î±Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(543298,15092,'zh','è¯·åˆ›å»ºä¸€ä¸ªä»»åŠ¡æ“ä½œ',0),(543299,15092,'sv','VÃ¤nligen skapa en uppgiftsÃ¥tgÃ¤rd',0),(543300,15092,'it','Si prega di creare un\'azione di attivitÃ ',0),(543301,15092,'tl','',0),(543302,15092,'th','à¹‚à¸›à¸£à¸”à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸‡à¸²à¸™à¸à¸²à¸£',0),(543303,15092,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤•à¤¾à¤°à¥à¤¯ à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(543304,15092,'ms','Sila membuat tindakan tugas',0),(543305,15092,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ Ø¥Ø¬Ø±Ø§Ø¡ Ø§Ù„Ù…Ù‡Ù…Ø©',0),(543306,15092,'fr','Veuillez crÃ©er une Action de tÃ¢che',0),(543307,15092,'jp','ã‚¿ã‚¹ã‚¯ ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã‚’ä½œæˆã—ã¦ãã ã•ã„ã€‚',0),(543308,15092,'pt','Por favor, crie uma aÃ§Ã£o de tarefa',0),(543309,15092,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑÐ¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(543310,15092,'es','Por favor crea una acciÃ³n de tarea',0),(543311,15092,'de','Bitte erstellen Sie eine Aufgabe-Aktion',0),(543312,15092,'en','Please Create A Task Action',0),(543313,15093,'is','',0),(543314,15093,'dr','Ù„Ø·ÙØ§ Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ¶Ø¹ÛŒØª ÙˆØ¸ÛŒÙÙ‡',0),(543315,15093,'pr','Ù„Ø·ÙØ§ Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ¶Ø¹ÛŒØª ÙˆØ¸ÛŒÙÙ‡',0),(543316,15093,'tr','LÃ¼tfen bir gÃ¶rev durumunu oluÅŸturun',0),(543317,15093,'pl','ProszÄ™ utworzyÄ‡ stanu zadania',0),(543318,15093,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ Ð·Ð°Ð´Ð°Ñ‡Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(543319,15093,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© Ø­Ø§Ù„Øª Ú©Ø§Ù… ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(543320,15093,'sr','ÐœÐ¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð´Ð°Ñ‚ÐºÐ°',0),(543321,15093,'vi','HÃ£y táº¡o má»™t tráº¡ng thÃ¡i nhiá»‡m vá»¥',0),(543322,15093,'af','Skep asseblief \'n taak Status',0),(543323,15093,'ro','VÄƒ rugÄƒm sÄƒ creaÅ£i un statut de sarcina',0),(543324,15093,'et','Palun luua tÃ¶Ã¶Ã¼lesande olek',0),(543325,15093,'si','Prosimo, ustvarite stanje opravila',0),(543326,15093,'ba','Silahkan membuat Status tugas',0),(543327,15093,'nl','Maak een taakstatus',0),(543328,15093,'fi','Luo tehtÃ¤vÃ¤n tila',0),(543329,15093,'no','Opprett en aktivitetsstatus',0),(543330,15093,'da','Opret venligst en opgavestatus',0),(543331,15093,'ko','ìž‘ì—… ìƒíƒœë¥¼ ë§Œë“¤ì–´ ì£¼ì„¸ìš”',0),(543332,15093,'he','×‘×‘×§×©×” ×œ×™×¦×•×¨ ×ž×¦×‘ ×¤×¢×™×œ×•×ª',0),(543333,15093,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î¼Î¹Î± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎµÏÎ³Î±ÏƒÎ¹ÏŽÎ½',0),(543334,15093,'zh','è¯·åˆ›å»ºä»»åŠ¡çŠ¶æ€',0),(543335,15093,'sv','VÃ¤nligen skapa en aktivitetsstatus',0),(543336,15093,'it','Si prega di creare uno stato di attivitÃ ',0),(543337,15093,'tl','',0),(543338,15093,'th','à¸à¸£à¸¸à¸“à¸²à¸ªà¸£à¹‰à¸²à¸‡à¸ªà¸–à¸²à¸™à¸°à¸‡à¸²à¸™',0),(543339,15093,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤•à¤¾à¤°à¥à¤¯ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(543340,15093,'ms','Sila membuat Status tugas',0),(543341,15093,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ Ø­Ø§Ù„Ø© Ø§Ù„Ù…Ù‡Ù…Ø©',0),(543342,15093,'fr','Veuillez crÃ©er un Ã©tat de la tÃ¢che',0),(543343,15093,'jp','ã‚¿ã‚¹ã‚¯ã®é€²æ—çŠ¶æ³ã‚’ä½œæˆã—ã¦ãã ã•ã„ã€‚',0),(543344,15093,'pt','Por favor, crie um Status da tarefa',0),(543345,15093,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑÐ¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð·Ð°Ð´Ð°Ñ‡Ð¸',0),(543346,15093,'es','Por favor, crear un estado de la tarea',0),(543347,15093,'de','Bitte erstellen Sie einen Task-Status',0),(543348,15093,'en','Please Create A Task Status',0),(543349,15094,'is','',0),(543350,15094,'dr','Ø³Ø§Ø¨Ù‚Ù‡ Ø­Ø³Ø§Ø¨',0),(543351,15094,'pr','Ø³Ø§Ø¨Ù‚Ù‡ Ø­Ø³Ø§Ø¨',0),(543352,15094,'tr','Hesap geÃ§miÅŸi',0),(543353,15094,'pl','Historia konta',0),(543354,15094,'bg','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ñ€ÑŠÑ†ÐµÑ‚Ðµ',0),(543355,15094,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(543356,15094,'sr','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(543357,15094,'vi','Lá»‹ch sá»­ tÃ i khoáº£n',0),(543358,15094,'af','Rekening geskiedenis',0),(543359,15094,'ro','Cont de istorie',0),(543360,15094,'et','Konto ajalugu',0),(543361,15094,'si','Zgodovina raÄuna',0),(543362,15094,'ba','Riwayat rekening',0),(543363,15094,'nl','Accountgeschiedenis',0),(543364,15094,'fi','Asiakashistoria',0),(543365,15094,'no','Logg for forretningsforbindelse',0),(543366,15094,'da','Kontohistorik',0),(543367,15094,'ko','ê³„ì • ë‚´ì—­',0),(543368,15094,'he','×”×™×¡×˜×•×¨×™×” ×—×©×‘×•×Ÿ',0),(543369,15094,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(543370,15094,'zh','å¸æˆ·åŽ†å²è®°å½•',0),(543371,15094,'sv','Kontohistorik',0),(543372,15094,'it','Storia del conto',0),(543373,15094,'tl','',0),(543374,15094,'th','à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸šà¸±à¸à¸Šà¸µ',0),(543375,15094,'hi','à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(543376,15094,'ms','Sejarah akaun',0),(543377,15094,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(543378,15094,'fr','Historique du compte',0),(543379,15094,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®å±¥æ­´',0),(543380,15094,'pt','Conta a histÃ³ria',0),(543381,15094,'ru','Ð˜ÑÑ‚Ð¾Ñ€Ð¸Ñ ÑÑ‡ÐµÑ‚Ð°',0),(543382,15094,'es','Historial de la cuenta',0),(543383,15094,'de','Firmenhistorie',0),(543384,15094,'en','Account History',0),(543385,15095,'is','',0),(543386,15095,'dr','Ù†Ø´Ø§Ù† Ø¨Ø§Ø±Ú©Ø¯ Ø¯Ø± ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´',0),(543387,15095,'pr','Ù†Ø´Ø§Ù† Ø¨Ø§Ø±Ú©Ø¯ Ø¯Ø± ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´',0),(543388,15095,'tr','Barkod sipariÅŸ onayÄ± gÃ¶ster',0),(543389,15095,'pl','PokaÅ¼ kod kreskowy na potwierdzenie zamÃ³wienia',0),(543390,15095,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð±Ð°Ñ€ÐºÐ¾Ð´ Ð½Ð° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(543391,15095,'ur','Ø¨Ø§Ø±Ú©ÙˆÚˆ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(543392,15095,'sr','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð±Ð°Ñ€ ÐºÐ¾Ð´Ð° Ð½Ð° ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(543393,15095,'vi','Hiá»ƒn thá»‹ khÃ¡ch sáº¡n mÃ£ váº¡ch trÃªn xÃ¡c nháº­n Ä‘áº·t hÃ ng',0),(543394,15095,'af','Wys strepieskode op bestelling bevestiging',0),(543395,15095,'ro','AratÄƒ de coduri de bare pe confirmarea comenzii',0),(543396,15095,'et','Kuva vÃ¶Ã¶tkoodi Tellimuse kinnitus',0),(543397,15095,'si','PrikaÅ¾i Ärtne kode na potrditev naloga',0),(543398,15095,'ba','Lihat Barcode konfirmasi Order',0),(543399,15095,'nl','Toon Barcode op bevestiging van de bestelling',0),(543400,15095,'fi','Viivakoodin nÃ¤yttÃ¤minen vahvistus',0),(543401,15095,'no','Vis strekkode pÃ¥ ordrebekreftelsen',0),(543402,15095,'da','Vis stregkode pÃ¥ ordrebekrÃ¦ftelse',0),(543403,15095,'ko','ì£¼ë¬¸ í™•ì¸ ì„œì— ë°”ì½”ë“œ í‘œì‹œ',0),(543404,15095,'he','×”×¦×’ ××ª ×‘×¨×§×•×“ ×¢×œ ××™×©×•×¨ ×”×–×ž× ×”',0),(543405,15095,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Barcode Î³Î¹Î± ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(543406,15095,'zh','åœ¨ç¡®è®¤è®¢å•ä¸Šæ˜¾ç¤ºæ¡ç ',0),(543407,15095,'sv','Visa streckkoden pÃ¥ orderbekrÃ¤ftelse',0),(543408,15095,'it','Visualizza il codice a barre sulla conferma d\'ordine',0),(543409,15095,'tl','',0),(543410,15095,'th','à¸”à¸¹à¸šà¸²à¸£à¹Œà¹‚à¸„à¹‰à¸”à¹ƒà¸™à¸à¸²à¸£à¸¢à¸·à¸™à¸¢à¸±à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(543411,15095,'hi','à¤¬à¤¾à¤°à¤•à¥‹à¤¡ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(543412,15095,'ms','Menunjukkan Kod Bar pada perintah pengesahan',0),(543413,15095,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø´Ø±ÙŠØ·ÙŠ Ø¹Ù„Ù‰ ØªØ£ÙƒÙŠØ¯ Ø§Ù„Ø·Ù„Ø¨',0),(543414,15095,'fr','Afficher le code Ã  barres sur la Confirmation de commande',0),(543415,15095,'jp','ã”æ³¨æ–‡ã®ç¢ºèªãƒãƒ¼ã‚³ãƒ¼ãƒ‰ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(543416,15095,'pt','Mostrar o cÃ³digo de barras na confirmaÃ§Ã£o da encomenda',0),(543417,15095,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑˆÑ‚Ñ€Ð¸Ñ…-ÐºÐ¾Ð´ Ð½Ð° Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ð¸ Ð·Ð°ÐºÐ°Ð·Ð°',0),(543418,15095,'es','Mostrar cÃ³digo de barras en confirmaciÃ³n de la orden',0),(543419,15095,'de','Barcode auf AuftragsbestÃ¤tigung anzeigen',0),(543420,15095,'en','Show Barcode On Order Confirmation',0),(543421,15096,'is','',0),(543422,15096,'dr','Magento ØªÙ†Ø¸ÛŒÙ…Ø§Øª',0),(543423,15096,'pr','Magento ØªÙ†Ø¸ÛŒÙ…Ø§Øª',0),(543424,15096,'tr','Magento ayarlarÄ±nÄ± yapma',0),(543425,15096,'pl','Ustawienia Magento',0),(543426,15096,'bg','Ð ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð°Ñ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸Ñ‚Ðµ Ð½Ð° Magento',0),(543427,15096,'ur','Ù…Ø§Ú¯Ø§Ù†Ù¹Ùˆ Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº Ù…Ø·Ø§Ø¨Ù‚ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(543428,15096,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ð´Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð·Ð° ÐœÐ°Ð³ÐµÐ½Ñ‚Ð¾',0),(543429,15096,'vi','Äiá»u chá»‰nh cÃ i Ä‘áº·t Magento',0),(543430,15096,'af','Verstel Magento instellings',0),(543431,15096,'ro','ReglaÈ›i setÄƒrile de Magento',0),(543432,15096,'et','Magento sÃ¤tete kohandamine',0),(543433,15096,'si','Prilagodite nastavitve Magento',0),(543434,15096,'ba','Menyesuaikan pengaturan Magento',0),(543435,15096,'nl','Magento instellingen aanpassen',0),(543436,15096,'fi','Magento sÃ¤Ã¤tÃ¤minen',0),(543437,15096,'no','Justere Magento innstillinger',0),(543438,15096,'da','Justere indstillingerne for Magento',0),(543439,15096,'ko','Magento ì„¤ì •ì„ ì¡°ì •í•©ë‹ˆë‹¤',0),(543440,15096,'he','×œ×›×•×•× ×Ÿ ×”×’×“×¨×•×ª ×ž×’\'× ×˜×•',0),(543441,15096,'el','Î ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® ÏÏ…Î¸Î¼Î¯ÏƒÎµÏ‰Î½ Magento',0),(543442,15096,'zh','è°ƒæ•´ Magento è®¾ç½®',0),(543443,15096,'sv','Justera instÃ¤llningarna fÃ¶r Magento',0),(543444,15096,'it','Regolare le impostazioni di Magento',0),(543445,15096,'tl','',0),(543446,15096,'th','à¸›à¸£à¸±à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸§à¸µà¹‚à¸­à¹„à¸­à¸žà¸µ',0),(543447,15096,'hi','Magento à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(543448,15096,'ms','Laras seting Magento',0),(543449,15096,'ar','Ø¶Ø¨Ø· Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ù…Ø§Ø¬Ù†ØªÙˆ',0),(543450,15096,'fr','Ajuster les rÃ©glages de Magento',0),(543451,15096,'jp','Magento ã®è¨­å®šã‚’èª¿æ•´ã—ã¾ã™ã€‚',0),(543452,15096,'pt','Ajustar configuraÃ§Ãµes de Magento',0),(543453,15096,'ru','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Magento',0),(543454,15096,'es','Ajustar la configuraciÃ³n de Magento',0),(543455,15096,'de','Magento-Einstellungen anpassen',0),(543456,15096,'en','Adjust Magento Settings',0),(543457,15097,'is','',0),(543458,15097,'dr','Ø®Ø·Ø§ÛŒ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(543459,15097,'pr','Ø®Ø·Ø§ÛŒ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(543460,15097,'tr','Emir alÄ±nÄ±rken hata oluÅŸtu',0),(543461,15097,'pl','BÅ‚Ä…d podczas pobierania zamÃ³wieÅ„',0),(543462,15097,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(543463,15097,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¨Ø§Ø² Ú¯ÛŒØ± Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(543464,15097,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÑƒ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(543465,15097,'vi','Lá»—i láº¥y Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(543466,15097,'af','Fout herwinning bestellings',0),(543467,15097,'ro','Eroare preluarea comenzilor',0),(543468,15097,'et','TÃµrge allalaadimisel tellimused',0),(543469,15097,'si','Napaka pri pridobivanju naroÄil',0),(543470,15097,'ba','Kesalahan mengambil pesanan',0),(543471,15097,'nl','Fout bij het ophalen van Orders',0),(543472,15097,'fi','Virhe haettaessa tilaukset',0),(543473,15097,'no','Feil under henting av bestillinger',0),(543474,15097,'da','Fejl under hentning af ordrer',0),(543475,15097,'ko','ì˜¤ë¥˜ ì£¼ë¬¸ ê²€ìƒ‰',0),(543476,15097,'he','×©×’×™××” ×‘××—×–×•×¨ ×”×–×ž× ×•×ª',0),(543477,15097,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(543478,15097,'zh','æ£€ç´¢è®¢å•æ—¶å‡ºé”™',0),(543479,15097,'sv','Fel vid hÃ¤mtning av order',0),(543480,15097,'it','Errore nel recupero ordini',0),(543481,15097,'tl','',0),(543482,15097,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸”à¸¶à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(543483,15097,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤¨à¤ƒà¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(543484,15097,'ms','Ralat mendapatkan perintah',0),(543485,15097,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø£ÙˆØ§Ù…Ø±',0),(543486,15097,'fr','Erreur de rÃ©cupÃ©ration des commandes',0),(543487,15097,'jp','æ³¨æ–‡ã®å–å¾—ã‚¨ãƒ©ãƒ¼',0),(543488,15097,'pt','Erro ao recuperar as ordens',0),(543489,15097,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ð¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(543490,15097,'es','Error al recuperar las Ã³rdenes',0),(543491,15097,'de','Fehler beim Abrufen von Bestellungen',0),(543492,15097,'en','Error Retrieving Orders',0),(543493,15098,'is','',0),(543494,15098,'dr','Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(543495,15098,'pr','Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´',0),(543496,15098,'tr','SipariÅŸ numarasÄ±',0),(543497,15098,'pl','Od numeru zamÃ³wienia',0),(543498,15098,'bg','ÐžÑ‚ Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(543499,15098,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ø³Û’',0),(543500,15098,'sr','Ð˜Ð· Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(543501,15098,'vi','Tá»« sá»‘ thá»© tá»±',0),(543502,15098,'af','Van orde nommer',0),(543503,15098,'ro','La numÄƒrul de ordine',0),(543504,15098,'et','Tellimuse Number:',0),(543505,15098,'si','Iz zaporedno Å¡tevilko',0),(543506,15098,'ba','Dari nomor pesanan',0),(543507,15098,'nl','Van ordernummer',0),(543508,15098,'fi','Tilauksen numero',0),(543509,15098,'no','Fra ordrenummer',0),(543510,15098,'da','Fra ordrenummer',0),(543511,15098,'ko','ì£¼ë¬¸ ë²ˆí˜¸ì—ì„œ',0),(543512,15098,'he','×ž×ª×•×š ×ž×¡×¤×¨ ×”×–×ž× ×”',0),(543513,15098,'el','Î‘Ï€ÏŒ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ',0),(543514,15098,'zh','ä»Žè®¢å•ç¼–å·',0),(543515,15098,'sv','FrÃ¥n ordernummer',0),(543516,15098,'it','Dal numero d\'ordine',0),(543517,15098,'tl','',0),(543518,15098,'th','à¸ˆà¸²à¸à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(543519,15098,'hi','à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‡',0),(543520,15098,'ms','Dari nombor pesanan',0),(543521,15098,'ar','Ù…Ù† Ø±Ù‚Ù… Ø§Ù„Ø·Ù„Ø¨',0),(543522,15098,'fr','Du numÃ©ro de commande',0),(543523,15098,'jp','æ³¨æ–‡ç•ªå·ã‹ã‚‰',0),(543524,15098,'pt','Do nÃºmero de ordem',0),(543525,15098,'ru','ÐžÑ‚ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(543526,15098,'es','De nÃºmero de la orden',0),(543527,15098,'de','Von Bestellnummer',0),(543528,15098,'en','From Order Number',0),(543529,15099,'is','',0),(543530,15099,'dr','Magento Ø³ÙØ§Ø±Ø´Ø§Øª ÙˆØ§Ø±Ø¯Ø§Øª',0),(543531,15099,'pr','Magento Ø³ÙØ§Ø±Ø´Ø§Øª ÙˆØ§Ø±Ø¯Ø§Øª',0),(543532,15099,'tr','Magento emir alma',0),(543533,15099,'pl','ZamÃ³wieÅ„ przywozowych Magento',0),(543534,15099,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Magento Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(543535,15099,'ur','Ù…Ø§Ú¯Ø§Ù†Ù¹Ùˆ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(543536,15099,'sr','Ð£Ð²Ð¾Ð· ÐœÐ°Ð³ÐµÐ½Ñ‚Ð¾ Ð½Ð°Ñ€ÐµÑ’ÐµÑšÐ°',0),(543537,15099,'vi','Nháº­p kháº©u Magento Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(543538,15099,'af','Voer Magento bestellings',0),(543539,15099,'ro','Importa ordinele de Magento',0),(543540,15099,'et','Impordi Magento tellimused',0),(543541,15099,'si','Uvoz Magento naroÄila',0),(543542,15099,'ba','Impor Magento pesanan',0),(543543,15099,'nl','Magento Orders importeren',0),(543544,15099,'fi','Tuo Magento tilaukset',0),(543545,15099,'no','Importere Magento ordrer',0),(543546,15099,'da','Importere Magento ordrer',0),(543547,15099,'ko','ê°€ì ¸ì˜¤ê¸° Magento ì£¼ë¬¸',0),(543548,15099,'he','×™×™×‘×•× ×ž×’\'× ×˜×• ×”×–×ž× ×•×ª',0),(543549,15099,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ Magento',0),(543550,15099,'zh','å¯¼å…¥ Magento è®¢å•',0),(543551,15099,'sv','Magento bestÃ¤llning',0),(543552,15099,'it','Importazione ordini di Magento',0),(543553,15099,'tl','',0),(543554,15099,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ªà¸±à¹ˆà¸‡à¸§à¸µà¹‚à¸­à¹„à¸­à¸žà¸µ',0),(543555,15099,'hi','Magento à¤†à¤¦à¥‡à¤¶ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(543556,15099,'ms','Perintah-perintah Magento import',0),(543557,15099,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø§Ø¬Ù†ØªÙˆ',0),(543558,15099,'fr','Importer les commandes Magento',0),(543559,15099,'jp','Magento ã®å—æ³¨ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(543560,15099,'pt','ImportaÃ§Ã£o de ordens de Magento',0),(543561,15099,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Magento',0),(543562,15099,'es','Pedidos de importaciÃ³n Magento',0),(543563,15099,'de','Magento Bestellungen importieren',0),(543564,15099,'en','Import Magento Orders',0),(543565,15100,'is','',0),(543566,15100,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙÙ‚Ø· 200 Ø¯Ø± ÛŒÚ© Ø²Ù…Ø§Ù† Ø¢ÙˆØ±Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯',0),(543567,15100,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª ÙÙ‚Ø· 200 Ø¯Ø± ÛŒÚ© Ø²Ù…Ø§Ù† Ø¢ÙˆØ±Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯',0),(543568,15100,'tr','Sadece 200 sipariÅŸlerini aynÄ± anda getirilebilir',0),(543569,15100,'pl','Tylko 200 zamÃ³wienia moÅ¼e byÄ‡ wniesiona w jednym czasie',0),(543570,15100,'bg','Ð¡Ð°Ð¼Ð¾ 200 Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð¿Ñ€ÐµÐ´ÑÐ²ÑÐ²Ð°Ð½Ð¸ ÐµÐ´Ð½Ð¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾',0),(543571,15100,'ur','ØµØ±Ù 200 Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø§ÛŒÚ© ÙˆÙ‚Øª Ù…ÛŒÚº Ù„Ø§ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§ ÛÛ’',0),(543572,15100,'sr','Ð¡Ð°Ð¼Ð¾ 200 Ð½Ð°Ð»Ð¾Ð³Ðµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð¸ÑÑ‚Ð¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¾ Ð´Ð° Ð±ÑƒÐ´Ðµ Ð´Ð¾Ð²ÐµÐ´ÐµÐ½',0),(543573,15100,'vi','Chá»‰ cÃ³ 200 Ä‘Æ¡n Ä‘áº·t hÃ ng cÃ³ thá»ƒ Ä‘Æ°á»£c Ä‘Æ°a vÃ o táº¡i má»™t thá»i gian',0),(543574,15100,'af','Slegs 200 bestellings kan gebring word op een slag',0),(543575,15100,'ro','Numai 200 comenzi poate fi adus la un moment dat Ã®n',0),(543576,15100,'et','Ainult 200 tellimusi vÃµib esitada samal ajal',0),(543577,15100,'si','Samo 200 naroÄil se lahko obravnava v enem trenutku',0),(543578,15100,'ba','Hanya 200 pesanan dapat dibawa pada satu waktu',0),(543579,15100,'nl','Slechts 200 Orders kunnen worden gebracht op een bepaald moment',0),(543580,15100,'fi','Vain 200 tilaukset voidaan viedÃ¤ kerralla',0),(543581,15100,'no','Bare 200 ordrer kan bli brakt samtidig',0),(543582,15100,'da','Kun 200 ordrer kan blive bragt pÃ¥ Ã©n gang',0),(543583,15100,'ko','ë§Œ 200 ëª…ë ¹ì€ ì£¼ì–´ì§ˆ ìˆ˜ ìžˆë‹¤ í•œ ë²ˆì—',0),(543584,15100,'he','×¨×§ 200 ×”×–×ž× ×•×ª × ×™×ª×Ÿ ×œ×”×‘×™× ×‘×‘×ª ××—×ª',0),(543585,15100,'el','ÎœÏŒÎ½Î¿ 200 Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Ï€Î±ÏÎ¿Ï…ÏƒÎ¹Î±ÏƒÏ„Î¿ÏÎ½ Î¼Î­ÏƒÎ± ÏƒÎµ Î­Î½Î± Ï‡ÏÏŒÎ½Î¿',0),(543586,15100,'zh','å¯ä»¥è®¢å•ä»… 200 å°ï¼Œå¸¦æ¥ä¸€æ¬¡äº†',0),(543587,15100,'sv','Endast 200 order kan fÃ¶ras In pÃ¥ en gÃ¥ng',0),(543588,15100,'it','Solo 200 ordini possono essere portati un tempo',0),(543589,15100,'tl','',0),(543590,15100,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¹€à¸‰à¸žà¸²à¸° 200 à¸ªà¸²à¸¡à¸²à¸£à¸–à¸™à¸³à¹ƒà¸™à¸„à¸£à¸±à¹‰à¸‡à¹€à¸”à¸µà¸¢à¸§',0),(543591,15100,'hi','à¤•à¥‡à¤µà¤² 200 à¤†à¤¦à¥‡à¤¶ à¤à¤• à¤¹à¥€ à¤¸à¤®à¤¯ à¤®à¥‡à¤‚ à¤²à¤¾à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(543592,15100,'ms','Pesanan hanya 200 boleh dibawa masuk pada satu-satu masa',0),(543593,15100,'ar','Ø£ÙˆØ§Ù…Ø± ÙÙ‚Ø· 200 ÙŠÙ…ÙƒÙ† Ø£Ù† ØªØªØ­Ù‚Ù‚ ÙˆÙ‚Øª ÙˆØ§Ø­Ø¯',0),(543594,15100,'fr','Seulement 200 ordonnances peuvent Ãªtre amenÃ©s en mÃªme temps',0),(543595,15100,'jp','ã®ã¿ 200 æ³¨æ–‡åŒæ™‚ã«ã‚‚ãŸã‚‰ã•ã‚Œã‚‹ã“ã¨',0),(543596,15100,'pt','Apenas 200 ordens podem ser trazidas simultaneamente',0),(543597,15100,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ 200 Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¿Ñ€Ð¸Ð²Ð»ÐµÑ‡ÐµÐ½Ñ‹ Ð¾Ð´Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ñ',0),(543598,15100,'es','SÃ³lo 200 Ã³rdenes pueden ser traÃ­das en contemporÃ¡neamente',0),(543599,15100,'de','Nur 200 Bestellungen kÃ¶nnen auf einmal eingebracht werden',0),(543600,15100,'en','Only 200 Orders Can Be Brought In At One Time',0),(543601,15101,'is','',0),(543602,15101,'dr','# Ø³ÙØ§Ø±Ø´',0),(543603,15101,'pr','# Ø³ÙØ§Ø±Ø´',0),(543604,15101,'tr','SipariÅŸ No',0),(543605,15101,'pl','Nr zamÃ³wienia',0),(543606,15101,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° #',0),(543607,15101,'ur','# Ú©Ø§ Ø­Ú©Ù…',0),(543608,15101,'sr','ÐÐ°Ñ€ÐµÐ´Ð¸ #',0),(543609,15101,'vi','Äáº·t hÃ ng #',0),(543610,15101,'af','# Bestel',0),(543611,15101,'ro','Comanda #',0),(543612,15101,'et','Tellimuse nr',0),(543613,15101,'si','NaroÄilo #',0),(543614,15101,'ba','Memesan #',0),(543615,15101,'nl','# Bestellen',0),(543616,15101,'fi','Tilauksen numero',0),(543617,15101,'no','Bestillingsnummer',0),(543618,15101,'da','Bestil #',0),(543619,15101,'ko','# ì£¼ë¬¸',0),(543620,15101,'he','×¡×“×¨ #',0),(543621,15101,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± #',0),(543622,15101,'zh','è®¢å• #',0),(543623,15101,'sv','Ordernr',0),(543624,15101,'it','Ordine #',0),(543625,15101,'tl','',0),(543626,15101,'th','à¸ªà¸±à¹ˆà¸‡#',0),(543627,15101,'hi','à¤†à¤¦à¥‡à¤¶ #',0),(543628,15101,'ms','Pesanan #',0),(543629,15101,'ar','ØªØ±ØªÙŠØ¨ #',0),(543630,15101,'fr','No de commande',0),(543631,15101,'jp','æ³¨æ–‡ç•ªå·',0),(543632,15101,'pt','Ordem #',0),(543633,15101,'ru','Ð—Ð°ÐºÐ°Ð· #',0),(543634,15101,'es','Orden #',0),(543635,15101,'de','Auftragsnr.',0),(543636,15101,'en','Order #',0),(543637,15102,'is','',0),(543638,15102,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø±Ø§ Ø¯Ø±ÛŒØ§ÙØª Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø² Ø§ÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´',0),(543639,15102,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø±Ø§ Ø¯Ø±ÛŒØ§ÙØª Ø³ÙØ§Ø±Ø´Ø§Øª Ø§Ø² Ø§ÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ø³ÙØ§Ø±Ø´',0),(543640,15102,'tr','Bu sipariÅŸ numarasÄ± sipariÅŸleri almak iÃ§in sipariÅŸ numarasÄ± ayarlama',0),(543641,15102,'pl','Zestaw numer zamÃ³wienia, aby zamÃ³wienia z tego numeru zamÃ³wienia',0),(543642,15102,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð´Ð° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ Ð¿Ð¾Ñ€ÐµÐ´ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð°',0),(543643,15102,'ur','Ø§Ø³ Ù†Ø¸Ù… Ù†Ù…Ø¨Ø± Ø³Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø­Ø§ØµÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ù†Ø¸Ù… Ù†Ù…Ø¨Ø± Ú©Ùˆ Ù…Ø±ØªØ¨ Ú©Ø±ÛŒÚº',0),(543644,15102,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÑÐµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ Ð¸Ð· Ð±Ñ€Ð¾Ñ˜ Ñ‚Ð¾Ð³ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð°',0),(543645,15102,'vi','Thiáº¿t láº­p má»™t sá»‘ Ä‘Æ¡n Ä‘áº·t hÃ ng Ä‘á»ƒ cÃ³ Ä‘Æ°á»£c Ä‘Æ¡n Ä‘áº·t hÃ ng tá»« sá»‘ Ä‘iá»‡n thoáº¡i Ä‘áº·t hÃ ng',0),(543646,15102,'af','Stel \'n bestelling nommer kry bestellings uit daardie volgorde nommer',0),(543647,15102,'ro','SetaÅ£i un numar de ordine pentru a obÅ£ine comenzi la care numÄƒrul de ordine',0),(543648,15102,'et','Tellimuse numbrit saada tellimusi selle jÃ¤rjekorranumbri esitatud',0),(543649,15102,'si','Nastavite z zaporednimi Å¡tevilkami dobiti naroÄila od to zaporedno Å¡tevilko',0),(543650,15102,'ba','Mengatur nomor urut untuk mendapatkan pesanan dari urutan nomor pada',0),(543651,15102,'nl','Instellen van een ordernummer heeft opgegeven om de Orders van die bestelnummer op',0),(543652,15102,'fi','MÃ¤Ã¤ritetty tilausnumero saat tilauksia ettÃ¤ tilausnumero',0),(543653,15102,'no','Angi et ordrenummer fÃ¥ bestillinger fra det nummeret',0),(543654,15102,'da','Indstille et ordrenummer at fÃ¥ ordrer fra denne ordrenummer',0),(543655,15102,'ko','ì£¼ë¬¸ ë²ˆí˜¸ í•´ë‹¹ ì£¼ë¬¸ ë²ˆí˜¸ì—ì„œ ìˆœì„œë¥¼ ì„¤ì •',0),(543656,15102,'he','×”×’×“×¨×ª ×ž×¡×¤×¨ ×”×–×ž× ×” ×œ×§×‘×œ ×”×–×ž× ×•×ª ×ž×Ÿ ×”×ž×¡×¤×¨ ×”×–×” ×¡×“×¨',0),(543657,15102,'el','ÎŸÏÎ¯ÏƒÎµÏ„Îµ Î­Î½Î± Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ Î³Î¹Î± Î½Î± Ï€Î¬ÏÎµÎ¹ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Ï€ÏŒ ÎµÎºÎµÎ¯Î½Î¿ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏƒÏ„Î¿',0),(543658,15102,'zh','è®¾ç½®é¡ºåºç¼–å·ï¼Œä»¥å¾—åˆ°è®¢å•ï¼Œè®¢å•å·',0),(543659,15102,'sv','Ange ordernummer att fÃ¥ order frÃ¥n det ordernummer',0),(543660,15102,'it','Impostare un numero di ordine per ricevere ordini da quel numero ordine su',0),(543661,15102,'tl','',0),(543662,15102,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ˆà¸²à¸à¹€à¸¥à¸‚à¸—à¸µà¹ˆà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(543663,15102,'hi','à¤‰à¤¸ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‡ à¤†à¤¦à¥‡à¤¶ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(543664,15102,'ms','Menetapkan suatu nombor pesanan untuk mendapatkan pesanan dari nombor perintah itu',0),(543665,15102,'ar','ØªØ¹ÙŠÙŠÙ† Ø¹Ø¯Ø¯ ØªØ±ØªÙŠØ¨ Ù„Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ø£ÙˆØ§Ù…Ø± Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ø¹Ø¯Ø¯ Ø£Ù…Ø± Ø¹Ù„Ù‰',0),(543666,15102,'fr','DÃ©finissez un numÃ©ro de commande pour obtenir des ordonnances de ce numÃ©ro de commande sur',0),(543667,15102,'jp','ãã®æ³¨æ–‡ç•ªå·ã‹ã‚‰ã®æ³¨æ–‡ã‚’å–å¾—ã™ã‚‹ã«ã¯ã€æ³¨æ–‡ç•ªå·ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(543668,15102,'pt','Definir um nÃºmero de ordem para obter as ordens desse nÃºmero de ordem',0),(543669,15102,'ru','Ð—Ð°Ð´Ð°Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð° Ð´Ð»Ñ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¾Ñ‚ ÑÑ‚Ð¾Ð³Ð¾ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(543670,15102,'es','Establecer un nÃºmero de orden para obtener Ã³rdenes de ese nÃºmero de orden',0),(543671,15102,'de','Legen Sie eine Bestellnummer, Bestellungen von dieser Reihenfolge Zahl zu erhalten, auf',0),(543672,15102,'en','Set An Order Number To Get Orders From That Order Number On',0),(543673,15103,'is','',0),(543674,15103,'dr','Ù…Ø±Ø­Ù„Ù‡ ØªÙ†Ø¸ÛŒÙ…',0),(543675,15103,'pr','Ù…Ø±Ø­Ù„Ù‡ ØªÙ†Ø¸ÛŒÙ…',0),(543676,15103,'tr','Set aÅŸamasÄ±',0),(543677,15103,'pl','Zestaw etapie',0),(543678,15103,'bg','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ ÐµÑ‚Ð°Ð¿',0),(543679,15103,'ur','Ø§Ø³Ù¹ÛŒØ¬ Ú©Û’ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(543680,15103,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ ÑÑ†ÐµÐ½Ñƒ',0),(543681,15103,'vi','Thiáº¿t láº­p giai Ä‘oáº¡n',0),(543682,15103,'af','Stel stadium',0),(543683,15103,'ro','Set etapÄƒ',0),(543684,15103,'et','Sea etapp',0),(543685,15103,'si','Nastavi stopnjo',0),(543686,15103,'ba','Set panggung',0),(543687,15103,'nl','Stel fase',0),(543688,15103,'fi','Aseta vaiheessa',0),(543689,15103,'no','Angi stadiet',0),(543690,15103,'da','SÃ¦t stadie',0),(543691,15103,'ko','ì„¤ì •ëœ ë‹¨ê³„',0),(543692,15103,'he','×”×’×“×¨ ×©×œ×‘',0),(543693,15103,'el','ÎšÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î¿ ÏƒÏ„Î¬Î´Î¹Î¿',0),(543694,15103,'zh','å°†çš„é˜¶æ®µè®¾ç½®',0),(543695,15103,'sv','StÃ¤ll in scenen',0),(543696,15103,'it','Stage set',0),(543697,15103,'tl','',0),(543698,15103,'th','à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”',0),(543699,15103,'hi','à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤¿à¤¤ à¤šà¤°à¤£',0),(543700,15103,'ms','Set pentas',0),(543701,15103,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…Ø±Ø­Ù„Ø©',0),(543702,15103,'fr','Jeu de scÃ¨ne',0),(543703,15103,'jp','è¨­å®šæ®µéšŽ',0),(543704,15103,'pt','Definir fase',0),(543705,15103,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÑÑ‚Ð°Ð¿',0),(543706,15103,'es','Etapa de ajuste',0),(543707,15103,'de','Set BÃ¼hne',0),(543708,15103,'en','Set Stage',0),(543709,15104,'is','',0),(543710,15104,'dr','Ù…Ø±Ø­Ù„Ù‡ Ú©Ù†ÙˆÙ†ÛŒ',0),(543711,15104,'pr','Ù…Ø±Ø­Ù„Ù‡ Ú©Ù†ÙˆÙ†ÛŒ',0),(543712,15104,'tr','GeÃ§erli aÅŸamasÄ±',0),(543713,15104,'pl','Obecnym etapie',0),(543714,15104,'bg','Ð¢ÐµÐºÑƒÑ‰ ÐµÑ‚Ð°Ð¿',0),(543715,15104,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ù…Ø±Ø­Ù„Û’',0),(543716,15104,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ñƒ Ñ„Ð°Ð·Ñƒ',0),(543717,15104,'vi','Giai Ä‘oáº¡n hiá»‡n nay',0),(543718,15104,'af','Huidige stadium',0),(543719,15104,'ro','Stadiul actual',0),(543720,15104,'et','Hetkeseisu',0),(543721,15104,'si','Trenutno stopnjo',0),(543722,15104,'ba','Tahap yang saat ini',0),(543723,15104,'nl','Huidige etappe',0),(543724,15104,'fi','Nykyinen vaihe',0),(543725,15104,'no','Gjeldende fase',0),(543726,15104,'da','NuvÃ¦rende fase',0),(543727,15104,'ko','í˜„ìž¬ ë‹¨ê³„',0),(543728,15104,'he','×‘×©×œ×‘ ×”× ×•×›×—×™',0),(543729,15104,'el','Î¤ÏÎ­Ï‡Î¿Î½ ÏƒÏ„Î¬Î´Î¹Î¿',0),(543730,15104,'zh','å½“å‰é˜¶æ®µ',0),(543731,15104,'sv','Nuvarande skede',0),(543732,15104,'it','Fase corrente',0),(543733,15104,'tl','',0),(543734,15104,'th','à¸£à¸°à¸¢à¸°à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(543735,15104,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¤‚à¤š',0),(543736,15104,'ms','Semasa peringkat',0),(543737,15104,'ar','Ø§Ù„Ù…Ø±Ø­Ù„Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(543738,15104,'fr','Stade actuel',0),(543739,15104,'jp','ç¾åœ¨ã®ã‚¹ãƒ†ãƒ¼ã‚¸',0),(543740,15104,'pt','EstÃ¡gio atual',0),(543741,15104,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ ÑÑ‚Ð°Ð¿',0),(543742,15104,'es','Etapa actual',0),(543743,15104,'de','Aktuelle Stufe',0),(543744,15104,'en','Current Stage',0),(543745,15105,'is','',0),(543746,15105,'dr','Ù…Ø±Ø­Ù„Ù‡ Ù‚Ø¨Ù„ÛŒ',0),(543747,15105,'pr','Ù…Ø±Ø­Ù„Ù‡ Ù‚Ø¨Ù„ÛŒ',0),(543748,15105,'tr','Ã–nceki sahne',0),(543749,15105,'pl','Poprzedni etap',0),(543750,15105,'bg','ÐŸÑ€ÐµÐ´Ñ…Ð¾Ð´ÐµÐ½ ÐµÑ‚Ð°Ð¿',0),(543751,15105,'ur','Ù¾Ú†Ú¾Ù„Û’ Ù…Ø±Ø­Ù„Û’',0),(543752,15105,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ñƒ Ñ„Ð°Ð·Ñƒ',0),(543753,15105,'vi','Giai Ä‘oáº¡n trÆ°á»›c Ä‘Ã³',0),(543754,15105,'af','Vorige stadium',0),(543755,15105,'ro','Etapa anterioarÄƒ',0),(543756,15105,'et','Eelmisse faasi',0),(543757,15105,'si','PrejÅ¡nji stopnji',0),(543758,15105,'ba','Tahap sebelumnya',0),(543759,15105,'nl','Vorige fase',0),(543760,15105,'fi','Edelliseen vaiheeseen',0),(543761,15105,'no','Forrige stadium',0),(543762,15105,'da','Tidligere fase',0),(543763,15105,'ko','ì´ì „ ë‹¨ê³„',0),(543764,15105,'he','×”×©×œ×‘ ×”×§×•×“×',0),(543765,15105,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î¿ ÏƒÏ„Î¬Î´Î¹Î¿',0),(543766,15105,'zh','å‰ä¸€é˜¶æ®µ',0),(543767,15105,'sv','FÃ¶regÃ¥ende etapp',0),(543768,15105,'it','Fase precedente',0),(543769,15105,'tl','',0),(543770,15105,'th','à¸‚à¸±à¹‰à¸™à¸•à¸­à¸™à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(543771,15105,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤šà¤°à¤£',0),(543772,15105,'ms','Peringkat sebelumnya',0),(543773,15105,'ar','Ø§Ù„Ù…Ø±Ø­Ù„Ø© Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(543774,15105,'fr','Ã‰tape prÃ©cÃ©dente',0),(543775,15105,'jp','å‰ã®ã‚¹ãƒ†ãƒ¼ã‚¸',0),(543776,15105,'pt','EstÃ¡gio anterior',0),(543777,15105,'ru','ÐŸÑ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ð¹ ÑÑ‚Ð°Ð¿',0),(543778,15105,'es','Etapa anterior',0),(543779,15105,'de','Vorherige Etappe',0),(543780,15105,'en','Previous Stage',0),(543781,15106,'is','',0),(543782,15106,'dr','ØµØ§Ø¯Ø±Ø§Øª Ù…ÙˆØ±Ø¯ DOTmed',0),(543783,15106,'pr','ØµØ§Ø¯Ø±Ø§Øª Ù…ÙˆØ±Ø¯ DOTmed',0),(543784,15106,'tr','DOTmed Ã¶ÄŸesi verme',0),(543785,15106,'pl','DOTmed przedmiot eksportu',0),(543786,15106,'bg','DOTmed ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¸Ð·Ð½Ð¾Ñ',0),(543787,15106,'ur','Ø¯ÙˆÙ¹Ù…Ø¯ Ø´Û’ Ú©ÛŒ Ø¨Ø±Ø¢Ù…Ø¯',0),(543788,15106,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð”ÐžÐ¢Ð¼ÐµÐ´ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»',0),(543789,15106,'vi','DOTmed má»¥c xuáº¥t kháº©u',0),(543790,15106,'af','DOTmed Item uitvoer',0),(543791,15106,'ro','DOTmed element Export',0),(543792,15106,'et','DOTmed kauba eksport',0),(543793,15106,'si','Izvozna artikla DOTmed',0),(543794,15106,'ba','Ekspor DOTmed Item',0),(543795,15106,'nl','DOTmed Item Export',0),(543796,15106,'fi','DOTmed nimikkeen vienti',0),(543797,15106,'no','DOTmed element eksport',0),(543798,15106,'da','DOTmed vare eksport',0),(543799,15106,'ko','DOTmed í•­ëª© ë‚´ë³´ë‚´ê¸°',0),(543800,15106,'he','×™×™×¦×•× DOTmed ×¤×¨×™×˜',0),(543801,15106,'el','DOTmed ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®',0),(543802,15106,'zh','DOTmed é¡¹ç›®å‡ºå£',0),(543803,15106,'sv','DOTmed objekt Export',0),(543804,15106,'it','Elemento DOTmed esportazione',0),(543805,15106,'tl','',0),(543806,15106,'th','DOTmed à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¹ˆà¸‡à¸­à¸­à¸',0),(543807,15106,'hi','DOTmed à¤†à¤‡à¤Ÿà¤® à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤',0),(543808,15106,'ms','Eksport DOTmed Item',0),(543809,15106,'ar','ØªØµØ¯ÙŠØ± Ø§Ù„Ø¨Ù†Ø¯ Ø¯ÙˆØªÙ…ÙŠØ¯',0),(543810,15106,'fr','DOTmed point Export',0),(543811,15106,'jp','DOTmed ã‚¢ã‚¤ãƒ†ãƒ ã®ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ',0),(543812,15106,'pt','DOTmed Item de exportaÃ§Ã£o',0),(543813,15106,'ru','DOTmed Ð¿ÑƒÐ½ÐºÑ‚ Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(543814,15106,'es','ArtÃ­culo DOTmed exportaciÃ³n',0),(543815,15106,'de','DOTmed Element-Export',0),(543816,15106,'en','DOTmed Item Export',0),(543817,15107,'is','',0),(543818,15107,'dr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ÙˆØ§Ù‚Ø¹ÛŒ',0),(543819,15107,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ ÙˆØ§Ù‚Ø¹ÛŒ',0),(543820,15107,'tr','GerÃ§ek sevkiyat',0),(543821,15107,'pl','Rzeczywiste koszty',0),(543822,15107,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð°Ñ‚Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(543823,15107,'ur','Ø§ØµÙ„ Ø´Ù¾Ù†Ú¯',0),(543824,15107,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(543825,15107,'vi','Váº­n chuyá»ƒn thá»±c táº¿',0),(543826,15107,'af','Werklike gestuur',0),(543827,15107,'ro','Reale de transport maritim',0),(543828,15107,'et','Tegelikku tarnimist',0),(543829,15107,'si','Dejanske dobave',0),(543830,15107,'ba','Pengiriman sesungguhnya',0),(543831,15107,'nl','Werkelijke verzendkosten',0),(543832,15107,'fi','Todellinen merenkulku',0),(543833,15107,'no','Faktiske frakt',0),(543834,15107,'da','Faktiske fragt',0),(543835,15107,'ko','ì‹¤ì œ ë°°ì†¡',0),(543836,15107,'he','×”×ž×©×œ×•×— ×‘×¤×•×¢×œ',0),(543837,15107,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ® Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(543838,15107,'zh','å®žé™…è¿è´¹',0),(543839,15107,'sv','Faktiska frakt',0),(543840,15107,'it','Spedizione effettiva',0),(543841,15107,'tl','',0),(543842,15107,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ˆà¸£à¸´à¸‡',0),(543843,15107,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(543844,15107,'ms','Penghantaran sebenar',0),(543845,15107,'ar','Ø§Ù„Ø´Ø­Ù† Ø§Ù„ÙØ¹Ù„ÙŠØ©',0),(543846,15107,'fr','ExpÃ©dition rÃ©elle',0),(543847,15107,'jp','å®Ÿéš›ã®é€æ–™',0),(543848,15107,'pt','Envio real',0),(543849,15107,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ°Ñ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(543850,15107,'es','EnvÃ­o real',0),(543851,15107,'de','TatsÃ¤chliche Versandkosten',0),(543852,15107,'en','Actual Shipping',0),(543853,15108,'is','',0),(543854,15108,'dr','ÙˆØ²Ù† ÙˆØ§Ù‚Ø¹ÛŒ',0),(543855,15108,'pr','ÙˆØ²Ù† ÙˆØ§Ù‚Ø¹ÛŒ',0),(543856,15108,'tr','GerÃ§ek aÄŸÄ±rlÄ±k',0),(543857,15108,'pl','Rzeczywista waga',0),(543858,15108,'bg','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»Ð½Ð¾Ñ‚Ð¾ Ñ‚ÐµÐ³Ð»Ð¾',0),(543859,15108,'ur','Ø§ØµÙ„ ÙˆØ²Ù†',0),(543860,15108,'sr','Ð¡Ñ‚Ð²Ð°Ñ€Ð½Ð° Ñ‚ÐµÐ¶Ð¸Ð½Ð°',0),(543861,15108,'vi','Trá»ng lÆ°á»£ng thá»±c táº¿',0),(543862,15108,'af','Werklike gewig',0),(543863,15108,'ro','Greutatea realÄƒ',0),(543864,15108,'et','Tegelik kaalulangus',0),(543865,15108,'si','Dejanska teÅ¾a',0),(543866,15108,'ba','Berat aktual',0),(543867,15108,'nl','Werkelijke gewicht',0),(543868,15108,'fi','Todellinen paino',0),(543869,15108,'no','Faktisk vekt',0),(543870,15108,'da','Faktiske vÃ¦gt',0),(543871,15108,'ko','ì‹¤ì œ ë¬´ê²Œ',0),(543872,15108,'he','×”×ž×©×§×œ ×‘×¤×•×¢×œ',0),(543873,15108,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÏŒ Î²Î¬ÏÎ¿Ï‚',0),(543874,15108,'zh','å®žé™…é‡é‡',0),(543875,15108,'sv','Faktisk vikt',0),(543876,15108,'it','Peso effettivo',0),(543877,15108,'tl','',0),(543878,15108,'th','à¸™à¹‰à¸³à¸«à¸™à¸±à¸à¸ˆà¸£à¸´à¸‡',0),(543879,15108,'hi','à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤µà¤œà¤¨',0),(543880,15108,'ms','Berat sebenar',0),(543881,15108,'ar','Ø§Ù„ÙˆØ²Ù† Ø§Ù„ÙØ¹Ù„ÙŠ',0),(543882,15108,'fr','Poids rÃ©el',0),(543883,15108,'jp','å®Ÿéš›ã®é‡é‡',0),(543884,15108,'pt','Peso real',0),(543885,15108,'ru','Ð¤Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð²ÐµÑ',0),(543886,15108,'es','Peso real',0),(543887,15108,'de','TatsÃ¤chliche Gewicht',0),(543888,15108,'en','Actual Weight',0),(543889,15109,'is','',0),(543890,15109,'dr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ø³ÙØ§Ø±Ø´',0),(543891,15109,'pr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ø³ÙØ§Ø±Ø´',0),(543892,15109,'tr','Begin sipariÅŸ tarihi',0),(543893,15109,'pl','BEGIN Data zamÃ³wienia',0),(543894,15109,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(543895,15109,'ur','Ø´Ø±ÙˆØ¹ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(543896,15109,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(543897,15109,'vi','Báº¯t Ä‘áº§u ngÃ y Ä‘áº·t hÃ ng',0),(543898,15109,'af','Begin datum van bevel',0),(543899,15109,'ro','Incep data comenzii',0),(543900,15109,'et','Algab tellimuse kuupÃ¤ev',0),(543901,15109,'si','ZaÄetni datum naroÄila',0),(543902,15109,'ba','Mulai tanggal Order',0),(543903,15109,'nl','Begin Orderdatum',0),(543904,15109,'fi','Tilauksen aloituspÃ¤ivÃ¤',0),(543905,15109,'no','Start dato',0),(543906,15109,'da','Begynd Ordredato',0),(543907,15109,'ko','ì‹œìž‘ ìˆœì„œ ë‚ ì§œ',0),(543908,15109,'he','×ª××¨×™×š ×”×–×ž× ×” ×‘×’×™×Ÿ',0),(543909,15109,'el','Î—Î¼/Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ ÎµÎ½Ï„Î¿Î»Î®Ï‚',0),(543910,15109,'zh','å¼€å§‹è®¢å•æ—¥æœŸ',0),(543911,15109,'sv','BÃ¶rja Orderdatum',0),(543912,15109,'it','Data ordine Begin',0),(543913,15109,'tl','',0),(543914,15109,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(543915,15109,'hi','à¤†à¤°à¤‚à¤­ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(543916,15109,'ms','Tarikh Perintah mulakan',0),(543917,15109,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡ ØªØ±ØªÙŠØ¨',0),(543918,15109,'fr','Date de la commande BEGIN',0),(543919,15109,'jp','é–‹å§‹é †åºã®æ—¥ä»˜',0),(543920,15109,'pt','Data do pedido de Begin',0),(543921,15109,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð”Ð°Ñ‚Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(543922,15109,'es','Fecha de la orden de comenzar',0),(543923,15109,'de','BEGIN Bestelldatum',0),(543924,15109,'en','Begin Order Date',0),(543925,15110,'is','',0),(543926,15110,'dr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† Ø³ÙØ§Ø±Ø´',0),(543927,15110,'pr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† Ø³ÙØ§Ø±Ø´',0),(543928,15110,'tr','Son sipariÅŸ tarihi',0),(543929,15110,'pl','Data zakoÅ„czenia zlecenia',0),(543930,15110,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(543931,15110,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… ØªØ±ØªÛŒØ¨',0),(543932,15110,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(543933,15110,'vi','Káº¿t thÃºc ngÃ y Ä‘áº·t hÃ ng',0),(543934,15110,'af','Einde orde datum',0),(543935,15110,'ro','Data de sfÃ¢rÅŸit al Ordinului',0),(543936,15110,'et','Tellimuse lÃµppkuupÃ¤ev',0),(543937,15110,'si','KonÄni datum naloga',0),(543938,15110,'ba','Akhir tanggal Order',0),(543939,15110,'nl','Einde Orderdatum',0),(543940,15110,'fi','Tilauksen pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(543941,15110,'no','RekkefÃ¸lge sluttdato',0),(543942,15110,'da','Slutdato for ordre',0),(543943,15110,'ko','ìµœì¢… ì£¼ë¬¸ ë‚ ì§œ',0),(543944,15110,'he','×ª××¨×™×š ×¡×™×•× ×”×–×ž× ×”',0),(543945,15110,'el','Î¤Î­Î»Î¿Ï‚ Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(543946,15110,'zh','ç»“æŸè®¢å•æ—¥æœŸ',0),(543947,15110,'sv','Slutdatum fÃ¶r ordern',0),(543948,15110,'it','Data di fine ordine',0),(543949,15110,'tl','',0),(543950,15110,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(543951,15110,'hi','à¤…à¤‚à¤¤ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(543952,15110,'ms','Tarikh Perintah akhir',0),(543953,15110,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ù†Ø¸Ø§Ù…',0),(543954,15110,'fr','Date fin de la commande',0),(543955,15110,'jp','æœ€çµ‚æ³¨æ–‡æ—¥ä»˜',0),(543956,15110,'pt','Data do pedido final',0),(543957,15110,'ru','Ð”Ð°Ñ‚Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(543958,15110,'es','Fecha de la orden final',0),(543959,15110,'de','Bestellung Enddatum',0),(543960,15110,'en','End Order Date',0),(543961,15111,'is','',0),(543962,15111,'dr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø§Ø³Øª',0),(543963,15111,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø§Ø³Øª',0),(543964,15111,'tr','EST nakliye',0),(543965,15111,'pl','Est wysyÅ‚ki',0),(543966,15111,'bg','EST Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(543967,15111,'ur','Est Ø´Ù¾Ù†Ú¯',0),(543968,15111,'sr','Ð•ÑÑ‚ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(543969,15111,'vi','Váº­n chuyá»ƒn EDT',0),(543970,15111,'af','Est gestuur',0),(543971,15111,'ro','Est de transport maritim',0),(543972,15111,'et','EST laevandus',0),(543973,15111,'si','Dostava EST',0),(543974,15111,'ba','Pengiriman Est',0),(543975,15111,'nl','Est verzending',0),(543976,15111,'fi','Est toimitus',0),(543977,15111,'no','EST frakt',0),(543978,15111,'da','EST Shipping',0),(543979,15111,'ko','Est ë°°ì†¡',0),(543980,15111,'he','×ž×©×œ×•×— Est',0),(543981,15111,'el','EST Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(543982,15111,'zh','Est èˆªè¿',0),(543983,15111,'sv','Est frakt',0),(543984,15111,'it','Spedizione est',0),(543985,15111,'tl','',0),(543986,15111,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ Est',0),(543987,15111,'hi','à¤ˆà¤à¤¸à¤Ÿà¥€ à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(543988,15111,'ms','Penghantaran Est',0),(543989,15111,'ar','Ù…Ø¤Ø³Ø³Ø© Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ',0),(543990,15111,'fr','ExpÃ©dition de l\'est',0),(543991,15111,'jp','ç±³å›½æ±éƒ¨æ¨™æº–æ™‚åˆ»ã®é€æ–™',0),(543992,15111,'pt','Transporte de est',0),(543993,15111,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° EST',0),(543994,15111,'es','EnvÃ­o de est',0),(543995,15111,'de','EST-Versand',0),(543996,15111,'en','Est Shipping',0),(543997,15112,'is','',0),(543998,15112,'dr','ÙˆØ²Ù† Est',0),(543999,15112,'pr','ÙˆØ²Ù† Est',0),(544000,15112,'tr','EST aÄŸÄ±rlÄ±k',0),(544001,15112,'pl','Waga Est',0),(544002,15112,'bg','EST Ñ‚ÐµÐ³Ð»Ð¾',0),(544003,15112,'ur','Est ÙˆØ²Ù†',0),(544004,15112,'sr','Ð•ÑÑ‚ Ñ‚ÐµÐ¶Ð¸Ð½Ð°',0),(544005,15112,'vi','Trá»ng lÆ°á»£ng EST',0),(544006,15112,'af','Est gewig',0),(544007,15112,'ro','Greutate de Est',0),(544008,15112,'et','EST kaal',0),(544009,15112,'si','EST teÅ¾e',0),(544010,15112,'ba','Berat Est',0),(544011,15112,'nl','Est gewicht',0),(544012,15112,'fi','Est paino',0),(544013,15112,'no','EST vekt',0),(544014,15112,'da','EST vÃ¦gt',0),(544015,15112,'ko','ë™ë¶€ í‘œì¤€ì‹œ ë¬´ê²Œ',0),(544016,15112,'he','×ž×©×§×œ Est',0),(544017,15112,'el','Î’Î¬ÏÎ¿Ï‚ EST',0),(544018,15112,'zh','Est é‡é‡',0),(544019,15112,'sv','Est vikt',0),(544020,15112,'it','Peso est',0),(544021,15112,'tl','',0),(544022,15112,'th','à¸™à¹‰à¸³à¸«à¸™à¸±à¸ Est',0),(544023,15112,'hi','à¤‡ à¤à¤¸ à¤Ÿà¥€ à¤µà¤œà¤¨',0),(544024,15112,'ms','Berat Est',0),(544025,15112,'ar','Ø§Ù„ÙˆØ²Ù† Est',0),(544026,15112,'fr','Poids est',0),(544027,15112,'jp','ç±³å›½æ±éƒ¨æ¨™æº–æ™‚åˆ»ã®é‡é‡',0),(544028,15112,'pt','Peso est',0),(544029,15112,'ru','Ð’ÐµÑ EST',0),(544030,15112,'es','Est peso',0),(544031,15112,'de','EST-Gewicht',0),(544032,15112,'en','Est Weight',0),(544033,15113,'is','',0),(544034,15113,'dr','Ø§Ø®ØªÙ„Ø§Ù Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(544035,15113,'pr','Ø§Ø®ØªÙ„Ø§Ù Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(544036,15113,'tr','Nakliye farkÄ±',0),(544037,15113,'pl','WysyÅ‚ka rÃ³Å¼nica',0),(544038,15113,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ€Ð°Ð·Ð»Ð¸ÐºÐ°',0),(544039,15113,'ur','ÙØ±Ù‚ Ø´Ù¾Ù†Ú¯',0),(544040,15113,'sr','Ð Ð°Ð·Ð»Ð¸ÐºÐ° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(544041,15113,'vi','Váº­n chuyá»ƒn khÃ¡c biá»‡t',0),(544042,15113,'af','Verskil gestuur',0),(544043,15113,'ro','DiferenÅ£a de transport maritim',0),(544044,15113,'et','Laevanduse erinevus',0),(544045,15113,'si','Dostava razlika',0),(544046,15113,'ba','Pengiriman perbedaan',0),(544047,15113,'nl','Verzending verschil',0),(544048,15113,'fi','Toimitus ero',0),(544049,15113,'no','Frakt forskjellen',0),(544050,15113,'da','Shipping forskel',0),(544051,15113,'ko','ë°°ì†¡ ì°¨ì´',0),(544052,15113,'he','×”×”×‘×“×œ ×ž×©×œ×•×—',0),(544053,15113,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î± Î´Î¹Î±Ï†Î¿ÏÎ¬',0),(544054,15113,'zh','èˆªè¿å·®å¼‚',0),(544055,15113,'sv','Frakt skillnaden',0),(544056,15113,'it','Differenza di spedizione',0),(544057,15113,'tl','',0),(544058,15113,'th','à¸„à¸§à¸²à¸¡à¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¹ƒà¸™à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(544059,15113,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤…à¤‚à¤¤à¤°',0),(544060,15113,'ms','Penghantaran perbezaan',0),(544061,15113,'ar','ÙØ±Ù‚ Ø§Ù„Ø´Ø­Ù†',0),(544062,15113,'fr','DiffÃ©rence d\'expÃ©dition',0),(544063,15113,'jp','é€æ–™ãŒé•ã†',0),(544064,15113,'pt','DiferenÃ§a de frete',0),(544065,15113,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ€Ð°Ð·Ð½Ð¸Ñ†Ð°',0),(544066,15113,'es','Diferencia de envÃ­o',0),(544067,15113,'de','Versand-Unterschied',0),(544068,15113,'en','Shipping Difference',0),(544069,15114,'is','',0),(544070,15114,'dr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ØŒ Ø§Ù†ØªØ¸Ø§Ø±: Ú©Ø§Ù‡Ø´ Actuals Ø±Ø§ ØªØ®Ù…ÛŒÙ† Ù…ÛŒ Ø²Ù†Ø¯.',0),(544071,15114,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ØŒ Ø§Ù†ØªØ¸Ø§Ø±: Ú©Ø§Ù‡Ø´ Actuals Ø±Ø§ ØªØ®Ù…ÛŒÙ† Ù…ÛŒ Ø²Ù†Ø¯.',0),(544072,15114,'tr','Nakliye Vs fiili deÄŸerleri tahmin eder.',0),(544073,15114,'pl','WysyÅ‚ka szacuje Vs wartoÅ›ci rzeczywistych',0),(544074,15114,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ñ†ÐµÐ½ÑÐ²Ð° ÑÑ€ÐµÑ‰Ñƒ Ñ‚ÐµÐºÑƒÑ‰Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(544075,15114,'ur','Ø´Ù¾Ù†Ú¯ Ø¨Ù…Ù‚Ø§Ø¨Ù„Û Ø§Ú©Ø§Ù„Ø³ ØªØ®Ù…ÛŒÙ†Û ÛÛ’ Û”',0),(544076,15114,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð¿Ñ€Ð¾Ñ†ÐµÑšÑƒÑ˜Ðµ Ð’Ñ ÑÑ‚Ð°ÑšÐ°',0),(544077,15114,'vi','Váº­n chuyá»ƒn Æ°á»›c tÃ­nh Vs Actuals',0),(544078,15114,'af','Gestuur skat Vs Actuals',0),(544079,15114,'ro','Transport maritim estimeazÄƒ Vs actualizÄƒrilor',0),(544080,15114,'et','Laevanduse hinnangul Vs tegelikud nÃ¤itajad',0),(544081,15114,'si','Dostava ocenjuje Vs opravljeno delo',0),(544082,15114,'ba','Pengiriman memperkirakan Vs Actuals',0),(544083,15114,'nl','Verzending schat Vs werkelijke waarden',0),(544084,15114,'fi','Shipping arvioi Vs todelliset arvot',0),(544085,15114,'no','Frakt anslÃ¥r Vs faktiske data',0),(544086,15114,'da','Forsendelse skÃ¸n Vs faktiske oplysninger',0),(544087,15114,'ko','ë°°ì†¡ ê²¬ì  Vs ì‹¤ì œ',0),(544088,15114,'he','×ž×©×œ×•×— ×”×¢×¨×›×•×ª ×œ×¢×•×ž×ª × ×ª×•× ×™× ×‘×¤×•×¢×œ',0),(544089,15114,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î± ÎµÎºÏ„Î¹Î¼Î¬ Ï€ÏÎ±Î³Î¼Î±Ï„Î¹ÎºÎ¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Vs',0),(544090,15114,'zh','èˆªè¿ä¼°è®¡ Vs å®žé™…å€¼',0),(544091,15114,'sv','Frakt uppskattar Vs verkliga vÃ¤rden',0),(544092,15114,'it','Spedizione stime valori effettivi Vs',0),(544093,15114,'tl','',0),(544094,15114,'th','à¸ˆà¸±à¸”à¸›à¸£à¸°à¹€à¸¡à¸´à¸™à¸ˆà¸£à¸´à¸‡ Vs',0),(544095,15114,'hi','à¤¬à¤¨à¤¾à¤® à¤µà¤¾à¤¸à¥à¤¤à¤µà¤¿à¤• à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤•à¤¾ à¤…à¤¨à¥à¤®à¤¾à¤¨',0),(544096,15114,'ms','Penghantaran anggaran Vs Actuals',0),(544097,15114,'ar','ÙˆØªØ´ÙŠØ± ØªÙ‚Ø¯ÙŠØ±Ø§Øª Ø§Ù„Ø´Ø­Ù† Ù…Ù‚Ø§Ø¨Ù„ Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„ÙØ¹Ù„ÙŠ',0),(544098,15114,'fr','ExpÃ©dition estime Vs dÃ©penses rÃ©elles',0),(544099,15114,'jp','é€æ–™è¦‹ç©ã‚‚ã‚Šå¯¾å®Ÿç¸¾',0),(544100,15114,'pt','Transporte estima Vs Actuals',0),(544101,15114,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¾Ñ†ÐµÐ½ÐºÐ°Ð¼ Vs Ñ„Ð°ÐºÑ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(544102,15114,'es','EnvÃ­o estima Vs Actuals',0),(544103,15114,'de','Versand schÃ¤tzt Vs aktuelle Werte',0),(544104,15114,'en','Shipping Estimates Vs Actuals',0),(544105,15115,'is','',0),(544106,15115,'dr','Ø±ÙˆØ´ Ú©Ø´ØªÛŒ',0),(544107,15115,'pr','Ø±ÙˆØ´ Ú©Ø´ØªÛŒ',0),(544108,15115,'tr','Gemi yÃ¶ntemi',0),(544109,15115,'pl','Metoda statku',0),(544110,15115,'bg','ÐœÐµÑ‚Ð¾Ð´ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(544111,15115,'ur','Ø¬ÛØ§Ø² Ú©Ø§ Ø·Ø±ÛŒÙ‚Û',0),(544112,15115,'sr','Ð‘Ñ€Ð¾Ð´ Ð¼ÐµÑ‚Ð¾Ð´',0),(544113,15115,'vi','TÃ u phÆ°Æ¡ng phÃ¡p',0),(544114,15115,'af','Skip metode',0),(544115,15115,'ro','Metoda de livrare',0),(544116,15115,'et','Laeva meetod',0),(544117,15115,'si','Ladja metoda',0),(544118,15115,'ba','Metode kapal',0),(544119,15115,'nl','Schip methode',0),(544120,15115,'fi','Aluksen menetelmÃ¤',0),(544121,15115,'no','Skipet metode',0),(544122,15115,'da','Skibet metode',0),(544123,15115,'ko','ì„ ë°• ë°©ë²•',0),(544124,15115,'he','×©×™×˜×ª ×”×¡×¤×™× ×”',0),(544125,15115,'el','ÎœÎ­Î¸Î¿Î´Î¿Ï‚ Ï€Î»Î¿Î¯Î¿',0),(544126,15115,'zh','èˆ¹èˆ¶çš„æ–¹æ³•',0),(544127,15115,'sv','Fartyget metod',0),(544128,15115,'it','Metodo di nave',0),(544129,15115,'tl','',0),(544130,15115,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(544131,15115,'hi','à¤œà¤¹à¤¾à¤œ à¤µà¤¿à¤§à¤¿',0),(544132,15115,'ms','Kaedah kapal',0),(544133,15115,'ar','Ø£Ø³Ù„ÙˆØ¨ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(544134,15115,'fr','MÃ©thode de navire',0),(544135,15115,'jp','é…é€æ–¹æ³•',0),(544136,15115,'pt','MÃ©todo de navio',0),(544137,15115,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¼ÐµÑ‚Ð¾Ð´',0),(544138,15115,'es','MÃ©todo de la nave',0),(544139,15115,'de','Schiff-Methode',0),(544140,15115,'en','Ship Method',0),(544141,15116,'is','',0),(544142,15116,'dr','ØªÙØ§ÙˆØª ÙˆØ²Ù†',0),(544143,15116,'pr','ØªÙØ§ÙˆØª ÙˆØ²Ù†',0),(544144,15116,'tr','AÄŸÄ±rlÄ±k farkÄ±',0),(544145,15116,'pl','RÃ³Å¼nica wagi',0),(544146,15116,'bg','Ð¢ÐµÐ³Ð»Ð¾Ñ‚Ð¾ Ñ€Ð°Ð·Ð»Ð¸ÐºÐ°',0),(544147,15116,'ur','ÙˆØ²Ù† Ú©Ø§ ÙØ±Ù‚',0),(544148,15116,'sr','Ð¢ÐµÐ¶Ð¸Ð½Ð° Ñ€Ð°Ð·Ð»Ð¸ÐºÐ°',0),(544149,15116,'vi','Trá»ng lÆ°á»£ng khÃ¡c biá»‡t',0),(544150,15116,'af','Gewig verskil',0),(544151,15116,'ro','DiferenÅ£a de greutate',0),(544152,15116,'et','Kaalu erinevus',0),(544153,15116,'si','TeÅ¾a razlika',0),(544154,15116,'ba','Perbedaan berat badan',0),(544155,15116,'nl','Gewicht verschil',0),(544156,15116,'fi','Painoero',0),(544157,15116,'no','Vekten forskjellen',0),(544158,15116,'da','VÃ¦gtforskel',0),(544159,15116,'ko','ë¬´ê²Œ ì°¨ì´',0),(544160,15116,'he','×”×”×‘×“×œ ×‘×ž×©×§×œ',0),(544161,15116,'el','Î— Î´Î¹Î±Ï†Î¿ÏÎ¬ Î²Î¬ÏÎ¿Ï…Ï‚',0),(544162,15116,'zh','é‡é‡å·®å¼‚',0),(544163,15116,'sv','Viktskillnaden',0),(544164,15116,'it','Differenza di peso',0),(544165,15116,'tl','',0),(544166,15116,'th','à¸„à¸§à¸²à¸¡à¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸‚à¸­à¸‡à¸™à¹‰à¸³à¸«à¸™à¸±à¸',0),(544167,15116,'hi','à¤µà¤œà¤¨ à¤«à¤°à¥à¤•',0),(544168,15116,'ms','Perbezaan berat badan',0),(544169,15116,'ar','ÙØ±Ù‚ Ø§Ù„ÙˆØ²Ù†',0),(544170,15116,'fr','DiffÃ©rence de poids',0),(544171,15116,'jp','é‡é‡å·®',0),(544172,15116,'pt','DiferenÃ§a de peso',0),(544173,15116,'ru','Ð Ð°Ð·Ð½Ð¸Ñ†Ð° Ð²ÐµÑÐ°',0),(544174,15116,'es','Diferencia de peso',0),(544175,15116,'de','Gewicht Unterschied',0),(544176,15116,'en','Weight Difference',0),(544177,15117,'is','',0),(544178,15117,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÙˆØ§Ø±Ø¯ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ GL Ùˆ Ù…Ù‚Ø¯Ø§Ø± Ú©Ù‡ Ù…Ø¬Ù…ÙˆØ¹ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø§ÙØ³Øª',0),(544179,15117,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÙˆØ§Ø±Ø¯ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ GL Ùˆ Ù…Ù‚Ø¯Ø§Ø± Ú©Ù‡ Ù…Ø¬Ù…ÙˆØ¹ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ø§ÙØ³Øª',0),(544180,15117,'tr','GL hesap ve mahsup hareketin toplam tutarlarÄ± girmeniz gerekir',0),(544181,15117,'pl','NaleÅ¼y wprowadziÄ‡ GL rachunki i kwoty, ktÃ³re przesuniÄ™cie wszystkich transakcji',0),(544182,15117,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ GL ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¸ ÑÑƒÐ¼Ð¸, ÐºÐ¾Ð¸Ñ‚Ð¾ ÐºÐ¾Ð¼Ð¿ÐµÐ½ÑÐ¸Ñ€Ð°Ñ‚ Ð¾Ð±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸ÑÑ‚Ð°',0),(544183,15117,'ur','Ø¢Ù¾ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ø§ÙˆØ± Ø¬Ùˆ Ù…Ø¹Ø§Ù…Ù„Û Ú©Ù„ Ø¢ÙØ³Ù¹ Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(544184,15117,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð“Ð› Ð½Ð°Ð»Ð¾Ð³Ðµ Ð¸ Ð¸Ð·Ð½Ð¾ÑÐ° ÐºÐ¾Ñ˜Ðµ Ð¿Ð¾Ð¼Ð°Ðº ÑƒÐºÑƒÐ¿Ð°Ð½ Ð¸Ð·Ð½Ð¾Ñ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð°',0),(544185,15117,'vi','Báº¡n pháº£i nháº­p GL tÃ i khoáº£n vÃ  sá»‘ tiá»n bÃ¹ Ä‘áº¯p táº¥t cáº£ giao dá»‹ch',0),(544186,15117,'af','Jy moet intik GL rekeninge en bedrae wat die transaksie totaal geneutraliseer',0),(544187,15117,'ro','Trebuie sÄƒ introduceÅ£i GL conturile È™i sumele care compensa suma tranzacÅ£iei',0),(544188,15117,'et','Peate sisestama GL arved ja rahasummad, et korvata tehingu kogusumma',0),(544189,15117,'si','Vnesti morate GL raÄunov in zneske, ki izravnajo celotne transakcije',0),(544190,15117,'ba','Anda harus memasukkan GL account dan jumlah yang Offset Total transaksi',0),(544191,15117,'nl','U moet invoeren GL rekeningen en bedragen die de totale transactie compenseren',0),(544192,15117,'fi','Anna GL tilit ja mÃ¤Ã¤rÃ¤t, jotka korvasivat tapahtuman kokonaissumman',0),(544193,15117,'no','Du mÃ¥ angi GL kontoer og belÃ¸p som motvirket hele transaksjonen',0),(544194,15117,'da','Du skal angive GL konti og belÃ¸b, der opveje totalen for transaktionen',0),(544195,15117,'ko','GL ê³„ì • ë° ì˜¤í”„ì…‹ íŠ¸ëžœìž­ì…˜ í•©ê³„ ê¸ˆì•¡ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(544196,15117,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×—×©×‘×•× ×•×ª GL ×•×›×ž×•×™×•×ª ×©×ž×§×–×–×™× ××ª ×”×¡×›×•× ×”×›×•×œ×œ ×©×œ ×”×ª× ×•×¢×”',0),(544197,15117,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ ÎºÎ±Î¹ Ï€Î¿ÏƒÎ¬ Ï€Î¿Ï… Î±Î½Ï„Î¹ÏƒÏ„Î±Î¸Î¼Î¯Î¶Î¿Ï…Î½ Ï„Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï„Î·Ï‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(544198,15117,'zh','æ‚¨å¿…é¡»è¾“å…¥æ€»å¸ç§‘ç›®å’Œæ•°é¢æŠµæ¶ˆäº¤æ˜“è®°å½•åˆè®¡',0),(544199,15117,'sv','Du mÃ¥ste ange GL konton och belopp som kompenseras hela transaktionen',0),(544200,15117,'it','Devi inserire gli account GL e quantitÃ  tali da compensare il totale delle transazioni',0),(544201,15117,'tl','',0),(544202,15117,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸£à¸«à¸±à¸ªà¸šà¸±à¸à¸Šà¸µà¹à¸¥à¸°à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸£à¸§à¸¡à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸­à¸­à¸Ÿà¹€à¸‹à¹‡à¸•',0),(544203,15117,'hi','à¤†à¤ª GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤”à¤° à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤•à¥à¤² à¤‘à¤«à¤¸à¥‡à¤Ÿ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(544204,15117,'ms','Anda mesti masukkan GL akaun dan jumlah yang mengimbangi jumlah urus niaga',0),(544205,15117,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙ‚ÙˆÙ… Ø¨Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª GL ÙˆÙ…Ø¨Ø§Ù„Øº Ø§Ù„ØªØ¹ÙˆÙŠØ¶ Ø¹Ù† Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(544206,15117,'fr','Vous devez saisir des comptes GL et les montants qui compensent le Total de la Transaction',0),(544207,15117,'jp','GL å‹˜å®šã¨ç›¸æ®ºãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã®åˆè¨ˆé‡‘é¡ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(544208,15117,'pt','VocÃª deve inserir contas GL e quantias que compensar o Total de transaÃ§Ãµes',0),(544209,15117,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð²Ð²ÐµÑÑ‚Ð¸ GL ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¸ ÑÑƒÐ¼Ð¼Ñ‹, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ðµ ÑÐ¼ÐµÑ‰ÐµÐ½Ð¸Ðµ Ð²ÑÐµÐ³Ð¾ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹',0),(544210,15117,'es','Debe especificar las cuentas GL y cantidades que compensan el Total de la transacciÃ³n',0),(544211,15117,'de','Sie mÃ¼ssen eingeben, GL-Konten und BetrÃ¤ge, die der Transaktion Total versetzt',0),(544212,15117,'en','You Must Enter GL Accounts And Amounts That Offset The Transaction Total',0),(544213,15118,'is','',0),(544214,15118,'dr','ØµØ§Ø¯Ø±Ø§Øª Ø§Ù‚Ù„Ø§Ù… DOTmed',0),(544215,15118,'pr','ØµØ§Ø¯Ø±Ø§Øª Ø§Ù‚Ù„Ø§Ù… DOTmed',0),(544216,15118,'tr','DOTmed Ã¶ÄŸeleri verme',0),(544217,15118,'pl','WywÃ³z DOTmed',0),(544218,15118,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° DOTmed ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(544219,15118,'ur','Ø¯ÙˆÙ¹Ù…Ø¯ Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(544220,15118,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð”ÐžÐ¢Ð¼ÐµÐ´ ÑÑ‚Ð°Ð²ÐºÐµ',0),(544221,15118,'vi','Xuáº¥t kháº©u máº·t hÃ ng DOTmed',0),(544222,15118,'af','Uitvoer DOTmed Items',0),(544223,15118,'ro','Elemente de DOTmed export',0),(544224,15118,'et','Ekspordi DOTmed Ã¼ksused',0),(544225,15118,'si','IzvoÅ¾eni elementi DOTmed',0),(544226,15118,'ba','Mengekspor barang-barang DOTmed',0),(544227,15118,'nl','DOTmed Items exporteren',0),(544228,15118,'fi','Vie DOTmed',0),(544229,15118,'no','Eksportere DOTmed elementer',0),(544230,15118,'da','Eksportere DOTmed emner',0),(544231,15118,'ko','DOTmed í•­ëª© ë‚´ë³´ë‚´ê¸°',0),(544232,15118,'he','×œ×™×™×¦× ×¤×¨×™×˜×™× DOTmed',0),(544233,15118,'el','Î•Î¾Î¬Î³ÎµÎ¹ DOTmed ÎµÎ¯Î´Î·',0),(544234,15118,'zh','å‡ºå£ DOTmed é¡¹ç›®',0),(544235,15118,'sv','Exportera DOTmed objekt',0),(544236,15118,'it','Esportare gli elementi DOTmed',0),(544237,15118,'tl','',0),(544238,15118,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¹ˆà¸‡à¸­à¸­à¸ DOTmed',0),(544239,15118,'hi','DOTmed à¤†à¤‡à¤Ÿà¤® à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(544240,15118,'ms','Eksport barang-barang DOTmed',0),(544241,15118,'ar','ØªØµØ¯ÙŠØ± Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø¯ÙˆØªÙ…ÙŠØ¯',0),(544242,15118,'fr','Exporter des Ã©lÃ©ments de DOTmed',0),(544243,15118,'jp','DOTmed ã‚¢ã‚¤ãƒ†ãƒ ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(544244,15118,'pt','Exportar itens de DOTmed',0),(544245,15118,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² DOTmed',0),(544246,15118,'es','Productos de exportaciÃ³n DOTmed',0),(544247,15118,'de','DOTmed Elemente exportieren',0),(544248,15118,'en','Export DOTmed Items',0),(544249,15119,'is','',0),(544250,15119,'dr','Ø§ÛŒÙ…ÛŒÙ„ Ù…Ø´ØªØ±ÛŒØ§Ù†',0),(544251,15119,'pr','Ø§ÛŒÙ…ÛŒÙ„ Ù…Ø´ØªØ±ÛŒØ§Ù†',0),(544252,15119,'tr','E-posta mÃ¼ÅŸteriler',0),(544253,15119,'pl','Poczta elektroniczna klienci',0),(544254,15119,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(544255,15119,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ ØµØ§Ø±ÙÛŒÙ†',0),(544256,15119,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚Ð¸ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(544257,15119,'vi','Email khÃ¡ch',0),(544258,15119,'af','E-pos kliÃ«nte',0),(544259,15119,'ro','ClienÅ£ii de poÅŸtÄƒ electronicÄƒ',0),(544260,15119,'et','E-posti hotelli',0),(544261,15119,'si','Email stranke',0),(544262,15119,'ba','Email pelanggan',0),(544263,15119,'nl','E-mail klanten',0),(544264,15119,'fi','SÃ¤hkÃ¶posti asiakkaat',0),(544265,15119,'no','E-kunder',0),(544266,15119,'da','E-mail kunder',0),(544267,15119,'ko','ì´ë©”ì¼ ê³ ê°',0),(544268,15119,'he','×œ×§×•×—×•×ª ×“×•×',0),(544269,15119,'el','Î¤Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(544270,15119,'zh','ç”µå­é‚®ä»¶å®¢æˆ·',0),(544271,15119,'sv','E-kunder',0),(544272,15119,'it','Clienti e-mail',0),(544273,15119,'tl','',0),(544274,15119,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(544275,15119,'hi','à¤ˆà¤®à¥‡à¤² à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚',0),(544276,15119,'ms','Pelanggan e-mel',0),(544277,15119,'ar','Ø¹Ù…Ù„Ø§Ø¡ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(544278,15119,'fr','Clients de courriel',0),(544279,15119,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«é¡§å®¢',0),(544280,15119,'pt','Clientes de e-mail',0),(544281,15119,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(544282,15119,'es','Clientes de correo electrÃ³nico',0),(544283,15119,'de','E-Mail-Kunden',0),(544284,15119,'en','Email Customers',0),(544285,15120,'is','',0),(544286,15120,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø§ Ù…ÙˆØ§Ø±Ø¯',0),(544287,15120,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø§ Ù…ÙˆØ§Ø±Ø¯',0),(544288,15120,'tr','FaturalarÄ± Ã¶ÄŸeleri ile',0),(544289,15120,'pl','Faktury z elementÃ³w',0),(544290,15120,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ñ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(544291,15120,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ú©Û’ Ø³Ø§ØªÚ¾',0),(544292,15120,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ ÑÐ° ÑÑ‚Ð°Ð²ÐºÐ°Ð¼Ð°',0),(544293,15120,'vi','CÃ¡c hÃ³a Ä‘Æ¡n vá»›i má»¥c',0),(544294,15120,'af','Fakture met Items',0),(544295,15120,'ro','Facturi cu articole',0),(544296,15120,'et','Arvete Ã¼ksuste',0),(544297,15120,'si','RaÄunov z elementi',0),(544298,15120,'ba','Faktur dengan item',0),(544299,15120,'nl','Facturen met Items',0),(544300,15120,'fi','Laskujen kohteita',0),(544301,15120,'no','Fakturaer med elementer',0),(544302,15120,'da','Fakturaer med varer',0),(544303,15120,'ko','ì†¡ìž¥ í•­ëª©',0),(544304,15120,'he','×—×©×‘×•× ×™×•×ª ×¢× ×¤×¨×™×˜×™×',0),(544305,15120,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î¼Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(544306,15120,'zh','å‘ç¥¨é¡¹ç›®',0),(544307,15120,'sv','Fakturor med objekt',0),(544308,15120,'it','Fatture con elementi',0),(544309,15120,'tl','',0),(544310,15120,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£',0),(544311,15120,'hi','à¤†à¤‡à¤Ÿà¤®à¥à¤¸ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤šà¤¾à¤²à¤¾à¤¨',0),(544312,15120,'ms','Invois dengan butiran',0),(544313,15120,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ù…Ø¹ Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(544314,15120,'fr','Factures avec Ã©lÃ©ments',0),(544315,15120,'jp','è«‹æ±‚æ›¸ã®é …ç›®',0),(544316,15120,'pt','Facturas com itens',0),(544317,15120,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ñ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°Ð¼Ð¸',0),(544318,15120,'es','Facturas con elementos',0),(544319,15120,'de','Rechnungen mit Elementen',0),(544320,15120,'en','Invoices With Items',0),(544321,15121,'is','',0),(544322,15121,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ',0),(544323,15121,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ',0),(544324,15121,'tr','Otomatik olarak alÄ±nan sipariÅŸ',0),(544325,15121,'pl','Aby automatycznie pobrane',0),(544326,15121,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(544327,15121,'ur','Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ Ù…ØªØ¹Ù„Ù‚Û ØªØ±ØªÛŒØ¨',0),(544328,15121,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(544329,15121,'vi','Tá»± Ä‘á»™ng láº¥y thá»© tá»±',0),(544330,15121,'af','Outomaties groote orde',0),(544331,15121,'ro','Comanda automat Adus',0),(544332,15121,'et','Automaatselt vÃ¤lja otsitud jÃ¤rjekorras',0),(544333,15121,'si','Samodejno Vzpostavljeno nalog',0),(544334,15121,'ba','Order secara otomatis Diperoleh',0),(544335,15121,'nl','Automatisch ontvangen Order',0),(544336,15121,'fi','Automaattisesti Haettu jÃ¤rjestyksessÃ¤',0),(544337,15121,'no','Automatisk Hentet rekkefÃ¸lge',0),(544338,15121,'da','Automatisk hentet rÃ¦kkefÃ¸lge',0),(544339,15121,'ko','ìžë™ìœ¼ë¡œ ê²€ìƒ‰ ëœ ìˆœì„œ',0),(544340,15121,'he','×¡×“×¨ ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™ ×”×ž××•×—×–×¨×™×',0),(544341,15121,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î± Î±Î½Î±ÎºÏ„Î·Î¼Î­Î½ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(544342,15121,'zh','è‡ªåŠ¨æ£€ç´¢çš„é¡ºåº',0),(544343,15121,'sv','Automatiskt HÃ¤mtad ordning',0),(544344,15121,'it','Ordine estratto automaticamente',0),(544345,15121,'tl','',0),(544346,15121,'th','à¸ªà¸±à¹ˆà¸‡à¸”à¸¶à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(544347,15121,'hi','à¤…à¤­à¤¿à¤—à¤®à¤¨ à¤¤à¤¿à¤¥à¤¿: à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤•à¥à¤°à¤®',0),(544348,15121,'ms','Perintah secara automatik Diambil',0),(544349,15121,'ar','Ø£Ù…Ø± ØªÙ… Ø§Ø³ØªØ±Ø¯Ø§Ø¯Ù‡Ø§ ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹',0),(544350,15121,'fr','Commande automatiquement RÃ©cupÃ©rÃ©e',0),(544351,15121,'jp','è‡ªå‹•çš„ã«é–²è¦§é †åº',0),(544352,15121,'pt','Ordem automaticamente recuperado',0),(544353,15121,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¾ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°',0),(544354,15121,'es','Orden obtenido automÃ¡ticamente',0),(544355,15121,'de','Automatisch abgerufenen Order',0),(544356,15121,'en','Automatically Retrieved Order',0),(544357,15122,'is','',0),(544358,15122,'dr','Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ù†Ù‡ Ù¾ÛŒØ¯Ø§ Ú©Ø±Ø¯Ù† ÙØ±ÙˆØ´Ú¯Ø§Ù‡',0),(544359,15122,'pr','Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ù†Ù‡ Ù¾ÛŒØ¯Ø§ Ú©Ø±Ø¯Ù† ÙØ±ÙˆØ´Ú¯Ø§Ù‡',0),(544360,15122,'tr','MaÄŸazasÄ± bulabilirim diye',0),(544361,15122,'pl','Kulisy nie znaleÅºÄ‡ sklep',0),(544362,15122,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð½Ðµ ÐÐ°Ð¼ÐµÑ€ÐµÑ‚Ðµ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½',0),(544363,15122,'ur','ÚˆÚ¾ÙˆÙ†ÚˆÛŒÚº Ø°Ø®ÛŒØ±Û Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(544364,15122,'sr','ÐœÐ¾Ð³Ð°Ð¾ Ð½Ðµ Ñ‚Ñ€Ð°Ð¶ÐµÑšÐµ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð°',0),(544365,15122,'vi','CÃ³ thá»ƒ khÃ´ng tÃ¬m tháº¥y cá»­a hÃ ng',0),(544366,15122,'af','Kan nie vind Winkel',0),(544367,15122,'ro','Ar putea nu gÄƒsi magazin',0),(544368,15122,'et','Kas ei leia pood',0),(544369,15122,'si','Lahko najdem Store',0),(544370,15122,'ba','Bisa tidak menemukan toko',0),(544371,15122,'nl','Kan niet zoeken winkel',0),(544372,15122,'fi','Voisi lÃ¶ytÃ¤Ã¤ SÃ¤ilytÃ¤',0),(544373,15122,'no','Kunne ikke finne Store',0),(544374,15122,'da','Kunne ikke finde butik',0),(544375,15122,'ko','ì•ˆê°€ ê²Œë¥¼ ì°¾ì„ ìˆ˜',0),(544376,15122,'he','×¢×œ×•×œ ×œ× ×œ×ž×¦×•× ×—× ×•×ª',0),(544377,15122,'el','Î˜Î± Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î¼Î·Î½ Î²ÏÏ‰ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î±',0),(544378,15122,'zh','å¯ä»¥ä¸æ‰¾åº—',0),(544379,15122,'sv','Kunde inte hitta butik',0),(544380,15122,'it','Potrebbe non trovare Store',0),(544381,15122,'tl','',0),(544382,15122,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¸ˆà¸±à¸”à¹€à¸à¹‡à¸šà¸„à¹‰à¸™à¸«à¸²à¹„à¸¡à¹ˆ',0),(544383,15122,'hi','à¤¸à¤•à¤¾ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢à¥‡à¤‚ à¤¸à¥à¤Ÿà¥‹à¤°',0),(544384,15122,'ms','Boleh tidak mencari kedai',0),(544385,15122,'ar','ÙˆÙŠÙ…ÙƒÙ† Ø£Ù† Ù„Ø§ ØªØ¬Ø¯ Ù…Ø®Ø²Ù†',0),(544386,15122,'fr','Pourrait pas trouver magasin',0),(544387,15122,'jp','æ¤œç´¢åº—ã§ã¯ãªã„å¯èƒ½æ€§ãŒã‚ã‚Šã¾ã™ã€‚',0),(544388,15122,'pt','Poderia nÃ£o encontrar loja',0),(544389,15122,'ru','ÐœÐ¾Ð¶ÐµÑ‚ Ð½Ðµ Ð½Ð°Ð¹Ñ‚Ð¸ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½',0),(544390,15122,'es','PodrÃ­a no encontrar tienda',0),(544391,15122,'de','Konnte nicht Find Store',0),(544392,15122,'en','Could Not Find Store',0),(544393,15123,'is','',0),(544394,15123,'dr','Magento Ø³ÙØ§Ø±Ø´',0),(544395,15123,'pr','Magento Ø³ÙØ§Ø±Ø´',0),(544396,15123,'tr','Magento sipariÅŸ',0),(544397,15123,'pl','Magento zamÃ³wienia',0),(544398,15123,'bg','Magento Ñ€ÐµÐ´',0),(544399,15123,'ur','Ù…Ø§Ú¯Ø§Ù†Ù¹Ùˆ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(544400,15123,'sr','ÐœÐ°Ð³ÐµÐ½Ñ‚Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(544401,15123,'vi','Thá»© tá»± Magento',0),(544402,15123,'af','Magento orde',0),(544403,15123,'ro','Magento ordine',0),(544404,15123,'et','Magento tellimus',0),(544405,15123,'si','Magento nalog',0),(544406,15123,'ba','Magento Order',0),(544407,15123,'nl','Magento volgorde',0),(544408,15123,'fi','Magento jÃ¤rjestyksessÃ¤',0),(544409,15123,'no','Magento rekkefÃ¸lge',0),(544410,15123,'da','Magento rÃ¦kkefÃ¸lge',0),(544411,15123,'ko','Magento ìˆœì„œ',0),(544412,15123,'he','×¡×“×¨ ×ž×’\'× ×˜×•',0),(544413,15123,'el','Magento Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(544414,15123,'zh','Magento é¡ºåº',0),(544415,15123,'sv','Magento ordning',0),(544416,15123,'it','Ordine di Magento',0),(544417,15123,'tl','',0),(544418,15123,'th','à¸ªà¸±à¹ˆà¸‡à¸§à¸µà¹‚à¸­à¹„à¸­à¸žà¸µ',0),(544419,15123,'hi','Magento à¤•à¥‡ à¤†à¤¦à¥‡à¤¶',0),(544420,15123,'ms','Perintah Magento',0),(544421,15123,'ar','ØªØ±ØªÙŠØ¨ Ø§Ù„Ù…Ø§Ø¬Ù†ØªÙˆ',0),(544422,15123,'fr','Ordre de Magento',0),(544423,15123,'jp','Magento ã®é †åº',0),(544424,15123,'pt','Ordem de Magento',0),(544425,15123,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Magento',0),(544426,15123,'es','Orden de Magento',0),(544427,15123,'de','Magento-Bestellung',0),(544428,15123,'en','Magento Order',0),(544429,15124,'is','',0),(544430,15124,'dr','Ø¯Ø±Ø¬ Ù…ÙˆØ±Ø¯',0),(544431,15124,'pr','Ø¯Ø±Ø¬ Ù…ÙˆØ±Ø¯',0),(544432,15124,'tr','Ã–ÄŸe Ekle',0),(544433,15124,'pl','Wstaw element',0),(544434,15124,'bg','Ð’Ð¼ÑŠÐºÐ½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(544435,15124,'ur','Ø´Û’ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(544436,15124,'sr','Ð£Ð¼ÐµÑ‚Ð½Ð¸ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(544437,15124,'vi','ChÃ¨n khoáº£n má»¥c',0),(544438,15124,'af','Voeg Item',0),(544439,15124,'ro','Inserare element',0),(544440,15124,'et','Lisa Ã¼ksus',0),(544441,15124,'si','Vstavi element',0),(544442,15124,'ba','Menyisipkan Item',0),(544443,15124,'nl','Item invoegen',0),(544444,15124,'fi','LisÃ¤Ã¤ kohde',0),(544445,15124,'no','Sett inn element',0),(544446,15124,'da','IndsÃ¦t element',0),(544447,15124,'ko','í•­ëª© ì‚½ìž…',0),(544448,15124,'he','×œ×”×•×¡×™×£ ××ª ×”×¤×¨×™×˜',0),(544449,15124,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(544450,15124,'zh','æ’å…¥é¡¹ç›®',0),(544451,15124,'sv','Infoga objekt',0),(544452,15124,'it','Inserire l\'elemento',0),(544453,15124,'tl','',0),(544454,15124,'th','à¹à¸—à¸£à¸à¸£à¸²à¸¢à¸à¸²à¸£',0),(544455,15124,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤®à¥à¤®à¤¿à¤²à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(544456,15124,'ms','Masukkan Item',0),(544457,15124,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø§Ù„Ø¨Ù†Ø¯',0),(544458,15124,'fr','Ajouter un point',0),(544459,15124,'jp','é …ç›®ã‚’æŒ¿å…¥ã—ã¾ã™ã€‚',0),(544460,15124,'pt','Inserir Item',0),(544461,15124,'ru','Ð’ÑÑ‚Ð°Ð²Ð¸Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(544462,15124,'es','Insertar elemento',0),(544463,15124,'de','Element einfÃ¼gen',0),(544464,15124,'en','Insert Item',0),(544465,15125,'is','',0),(544466,15125,'dr','3dcart Ø³Ø§ÛŒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(544467,15125,'pr','3dcart Ø³Ø§ÛŒØª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(544468,15125,'tr','3dcart sitesi baÅŸarÄ±yla silindi',0),(544469,15125,'pl','3dcart strony usuniÄ™te pomyÅ›lnie',0),(544470,15125,'bg','3dcart ÑÐ°Ð¹Ñ‚ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(544471,15125,'ur','3dcart Ø³Ø§Ø¦Ù¹ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ú©Û’ Ø³Ø§ØªÚ¾ Ø®Ø§Ø±Ø¬',0),(544472,15125,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(544473,15125,'vi','3dcart trang web Ä‘Ã£ xÃ³a thÃ nh cÃ´ng',0),(544474,15125,'af','3dcart webwerf suksesvol geskrap',0),(544475,15125,'ro','3dcart Site eliminÄƒ cu succes',0),(544476,15125,'et','3dcart saidile edukalt kustutatud',0),(544477,15125,'si','3dcart mesto uspeÅ¡no izbrisana',0),(544478,15125,'ba','3dcart situs dihapus berhasil',0),(544479,15125,'nl','3dcart Site met succes verwijderd',0),(544480,15125,'fi','3dcart sivusto poistettu',0),(544481,15125,'no','3dcart nettstedet slettet',0),(544482,15125,'da','3dcart websted slettet',0),(544483,15125,'ko','ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ í•˜ëŠ” 3dcart ì‚¬ì´íŠ¸',0),(544484,15125,'he','××ª×¨ 3dcart × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(544485,15125,'el','3dcart Site Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(544486,15125,'zh','3dcart ç½‘ç«™å·²æˆåŠŸåˆ é™¤',0),(544487,15125,'sv','3dcart webbplats raderades',0),(544488,15125,'it','3Dcart sito eliminato con successo',0),(544489,15125,'tl','',0),(544490,15125,'th','à¹„à¸‹à¸•à¹Œ 3dcart à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(544491,15125,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾ à¤¦à¥€ 3dcart à¤¸à¤¾à¤‡à¤Ÿ',0),(544492,15125,'ms','Lokasi 3dcart dihapuskan dengan jayanya',0),(544493,15125,'ar','Ù…ÙˆÙ‚Ø¹ 3dcart Ø­Ø°Ù Ø¨Ù†Ø¬Ø§Ø­',0),(544494,15125,'fr','3Dcart Site supprimÃ© avec succÃ¨s',0),(544495,15125,'jp','3dcart ã‚µã‚¤ãƒˆãŒæ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(544496,15125,'pt','3Dcart Site apagado com sucesso',0),(544497,15125,'ru','3dcart ÑÐ°Ð¹Ñ‚ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(544498,15125,'es','3DCart sitio eliminado satisfactoriamente',0),(544499,15125,'de','3dcart-Website erfolgreich gelÃ¶scht',0),(544500,15125,'en','3dcart Site Deleted Successfully',0),(544501,15126,'is','',0),(544502,15126,'dr','Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÛŒØ® ÙØ¹Ù„ÛŒ Ø¨Ù‡ Ø¬Ø§ÛŒ ØªØ§Ø±ÛŒØ® Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§Ú©ØªÙˆØ±',0),(544503,15126,'pr','Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² ØªØ§Ø±ÛŒØ® ÙØ¹Ù„ÛŒ Ø¨Ù‡ Ø¬Ø§ÛŒ ØªØ§Ø±ÛŒØ® Ø·Ø±Ø­ Ù¾Ø±Ø¯Ø§Ø®Øª ÙØ§Ú©ØªÙˆØ±',0),(544504,15126,'tr','Fatura Ã¶deme planÄ± tarihi yerine geÃ§erli tarih kullanma',0),(544505,15126,'pl','Faktury za pomocÄ… bieÅ¼Ä…cej daty, a nie data planu pÅ‚atnoÅ›ci',0),(544506,15126,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð° Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°, Ð° Ð½Ðµ Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð»Ð°Ð½',0),(544507,15126,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù¾ÛŒÙ…Ù†Ù¹ Ù¾Ù„Ø§Ù† ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø¨Ø¬Ø§Ø¦Û’ Ù…ÙˆØ¬ÙˆØ¯Û ØªØ§Ø±ÛŒØ® Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(544508,15126,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¿Ð¾Ð¼Ð¾Ñ›Ñƒ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾Ð³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°, Ð° Ð½Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° ÐŸÐ»Ð°Ð½',0),(544509,15126,'vi','HÃ³a Ä‘Æ¡n báº±ng cÃ¡ch sá»­ dá»¥ng ngÃ y hiá»‡n táº¡i chá»© khÃ´ng pháº£i lÃ  ngÃ y káº¿ hoáº¡ch thanh toÃ¡n',0),(544510,15126,'af','Faktuur gebruik huidige datum eerder as betaling Plan datum',0),(544511,15126,'ro','FacturÄƒ utilizeazÄƒ data curentÄƒ, mai degrabÄƒ decÃ¢t data de Plan de platÄƒ',0),(544512,15126,'et','TÃ¤nase kuupÃ¤eva, mitte plaan maksepÃ¤eva arve',0),(544513,15126,'si','RaÄun uporabi trenutni datum kot datum plaÄila naÄrt',0),(544514,15126,'ba','Faktur menggunakan tanggal saat ini daripada rencana pembayaran',0),(544515,15126,'nl','Met behulp van huidige datum in plaats van betaling Plan datum factuur',0),(544516,15126,'fi','Laskun pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n kuin maksupÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(544517,15126,'no','Fakturaen som bruker gjeldende dato i stedet for betaling Plan dato',0),(544518,15126,'da','Faktura ved hjÃ¦lp af dags dato i stedet for betaling Plan dato',0),(544519,15126,'ko','ì†¡ìž¥ ì§€ë¶ˆ ê³„íš ë‚ ì§œ ëŒ€ì‹  í˜„ìž¬ ë‚ ì§œë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(544520,15126,'he','×—×©×‘×•× ×™×ª ×ž×©×ª×ž×© ×”×ª××¨×™×š ×”× ×•×›×—×™ ×•×œ× ×ª××¨×™×š ×ª×•×›× ×™×ª ×ª×©×œ×•×',0),(544521,15126,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ±Î¹ ÏŒÏ‡Î¹ ÏƒÏ‡Î­Î´Î¹Î¿ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(544522,15126,'zh','ä½¿ç”¨å½“å‰æ—¥æœŸï¼Œè€Œä¸æ˜¯ä»˜æ¬¾è®¡åˆ’æ—¥æœŸçš„å‘ç¥¨',0),(544523,15126,'sv','Fakturan med aktuella datum i stÃ¤llet fÃ¶r betalningsdatum Plan',0),(544524,15126,'it','Fattura utilizzando la data corrente, piuttosto che data del piano di pagamento',0),(544525,15126,'tl','',0),(544526,15126,'th','à¹ƒà¸Šà¹‰à¸§à¸±à¸™à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¸¡à¸²à¸à¸à¸§à¹ˆà¸²à¸§à¸±à¸™à¹à¸œà¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(544527,15126,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¯à¥‹à¤œà¤¨à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤¬à¤œà¤¾à¤¯ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°',0),(544528,15126,'ms','Invois menggunakan tarikh semasa dan bukannya tarikh pelan pembayaran',0),(544529,15126,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø§Ù„ÙŠ Ø¨Ø¯Ù„Ø§Ù‹ Ù…Ù† ØªØ§Ø±ÙŠØ® Ø®Ø·Ø© Ø¯ÙØ¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(544530,15126,'fr','Facture Ã  l\'aide de la Date actuelle et non Date de Plan de paiement',0),(544531,15126,'jp','è«‹æ±‚æ›¸ã®æ”¯æ‰•ã„è¨ˆç”»æ—¥ä»˜ã§ã¯ãªãã€ç¾åœ¨ã®æ—¥ä»˜ã‚’ä½¿ç”¨ã—ã¦',0),(544532,15126,'pt','Usando a data atual, ao invÃ©s de data de plano de pagamento de fatura',0),(544533,15126,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸ÐµÐ¼ Ñ‚ÐµÐºÑƒÑ‰ÐµÐ¹ Ð´Ð°Ñ‚Ñ‹, Ð° Ð½Ðµ Ð”Ð°Ñ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð»Ð°Ð½Ð°',0),(544534,15126,'es','Factura con fecha actual en lugar de la fecha de pago del Plan',0),(544535,15126,'de','Rechnung mit Tagesdatum als Zahlungsdatum Plan',0),(544536,15126,'en','Invoice Using Current Date Rather Than Payment Plan Date',0),(544537,15127,'is','',0),(544538,15127,'dr','Ø±ÙˆØ´ Ù‡Ø²ÛŒÙ†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙÛŒØ²ÛŒÚ©ÛŒ',0),(544539,15127,'pr','Ø±ÙˆØ´ Ù‡Ø²ÛŒÙ†Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙÛŒØ²ÛŒÚ©ÛŒ',0),(544540,15127,'tr','Fiziksel stok iÃ§in maliyet yÃ¶ntemi',0),(544541,15127,'pl','Koszt metody inwentaryzacji',0),(544542,15127,'bg','Ð¦ÐµÐ½Ð° Ð¼ÐµÑ‚Ð¾Ð´ Ð·Ð° Ñ„Ð¸Ð·Ð¸Ñ‡ÐµÑÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€',0),(544543,15127,'ur','Ø¬Ø³Ù…Ø§Ù†ÛŒ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù‚ÛŒÙ…Øª Ø·Ø±ÛŒÙ‚Û',0),(544544,15127,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¼ÐµÑ‚Ð¾Ð´ Ð·Ð° Ð¿Ð¾Ð¿Ð¸Ñ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(544545,15127,'vi','CÃ¡c phÆ°Æ¡ng phÃ¡p chi phÃ­ cho hÃ ng tá»“n kho váº­t lÃ½',0),(544546,15127,'af','Koste metode vir fisiese voorraad',0),(544547,15127,'ro','Metoda de cost pentru inventar fizic',0),(544548,15127,'et','Soetusmaksumuse meetod inventuur',0),(544549,15127,'si','NaloÅ¾bena metoda za popis zaloge',0),(544550,15127,'ba','Biaya metode untuk persediaan fisik',0),(544551,15127,'nl','Cost, methode voor fysieke inventaris',0),(544552,15127,'fi','Cost menetelmÃ¤n inventointi',0),(544553,15127,'no','Kostnader metode For vareopptelling',0),(544554,15127,'da','Omkostninger metode For lageropgÃ¸relse',0),(544555,15127,'ko','ì‹¤ì œ ìž¬ê³  ë¹„ìš©ëœ ë°©ë²•',0),(544556,15127,'he','×©×™×˜×ª ×¢×œ×•×ª ×”×ž×œ××™ ×”×¤×™×–×™',0),(544557,15127,'el','ÎšÏŒÏƒÏ„Î¿Ï…Ï‚ Î¼Î­Î¸Î¿Î´Î¿Ï‚ Î³Î¹Î± Ï†Ï…ÏƒÎ¹ÎºÎ® Î±Ï€Î¿Î³ÏÎ±Ï†Î®',0),(544558,15127,'zh','ç‰©ç†åº“å­˜æˆæœ¬çš„æ³•',0),(544559,15127,'sv','Kostnad metod fÃ¶r inventering',0),(544560,15127,'it','Metodo costo per inventario fisico',0),(544561,15127,'tl','',0),(544562,15127,'th','à¸§à¸´à¸˜à¸µà¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸—à¸²à¸‡à¸à¸²à¸¢à¸ à¸²à¸ž',0),(544563,15127,'hi','à¤­à¥Œà¤¤à¤¿à¤• à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¤¤ à¤µà¤¿à¤§à¤¿',0),(544564,15127,'ms','Kaedah kos inventori fizikal',0),(544565,15127,'ar','Ø£Ø³Ù„ÙˆØ¨ Ø§Ù„ØªÙƒÙ„ÙØ© Ù„Ù„Ù…Ø®Ø²ÙˆÙ† Ø§Ù„ÙØ¹Ù„ÙŠ',0),(544566,15127,'fr','MÃ©thode coÃ»t de l\'inventaire physique',0),(544567,15127,'jp','ç¾ç‰©åœ¨åº«ã®åŽŸä¾¡æ³•',0),(544568,15127,'pt','MÃ©todo de custo de inventÃ¡rio fÃ­sico',0),(544569,15127,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¼ÐµÑ‚Ð¾Ð´ Ð´Ð»Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(544570,15127,'es','MÃ©todo de costo de inventario fÃ­sico',0),(544571,15127,'de','KostengÃ¼nstige Methode fÃ¼r die Inventur',0),(544572,15127,'en','Cost Method For Physical Inventory',0),(544573,15128,'is','',0),(544574,15128,'dr','Ø´Ø±ÙˆØ¹ ØªØ®ÙÛŒÙ ØªØ§Ø±ÛŒØ®',0),(544575,15128,'pr','Ø´Ø±ÙˆØ¹ ØªØ®ÙÛŒÙ ØªØ§Ø±ÛŒØ®',0),(544576,15128,'tr','Begin iskonto tarihi',0),(544577,15128,'pl','Data rozpoczÄ™cia rabatu',0),(544578,15128,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð·Ð° Ð½Ð°Ñ‡Ð°Ð»Ð¾',0),(544579,15128,'ur','Ø¢ØºØ§Ø² Ø±Ø¹Ø§ÛŒØª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(544580,15128,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð°',0),(544581,15128,'vi','Báº¯t Ä‘áº§u giáº£m giÃ¡ ngÃ y',0),(544582,15128,'af','Begin afslag datum',0),(544583,15128,'ro','ÃŽnceput reducere la data',0),(544584,15128,'et','Allahindluse alguskuupÃ¤ev',0),(544585,15128,'si','ZaÄetni datum kasaskonta',0),(544586,15128,'ba','Mulailah diskon tanggal',0),(544587,15128,'nl','Begindatum korting',0),(544588,15128,'fi','Alennus aloituspÃ¤ivÃ¤',0),(544589,15128,'no','Start rabattdatoen',0),(544590,15128,'da','Begynd rabatdatoen',0),(544591,15128,'ko','ì‹œìž‘ í• ì¸ ë‚ ì§œ',0),(544592,15128,'he','×‘×’×™×Ÿ ×”× ×—×” ×ª××¨×™×š',0),(544593,15128,'el','ÎˆÎ½Î±ÏÎ¾Î·/Î½Î¯Î± Î­ÎºÏ€Ï„Ï‰ÏƒÎ·Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(544594,15128,'zh','å¼€å§‹æŠ˜æ‰£æ—¥æœŸ',0),(544595,15128,'sv','BÃ¶rja rabattdatumet',0),(544596,15128,'it','Data di sconto Begin',0),(544597,15128,'tl','',0),(544598,15128,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(544599,15128,'hi','à¤†à¤°à¤‚à¤­ à¤›à¥‚à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(544600,15128,'ms','Tarikh diskaun mulakan',0),(544601,15128,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø¯Ø¡ Ø§Ù„Ø®ØµÙ…',0),(544602,15128,'fr','Date de remise de Begin',0),(544603,15128,'jp','å‰²å¼•ã®é–‹å§‹æ—¥',0),(544604,15128,'pt','Begin data de desconto',0),(544605,15128,'ru','Ð”Ð°Ñ‚Ñ‹ Ð½Ð°Ñ‡Ð°Ð»Ð° ÑÐºÐ¸Ð´Ð¾Ðº',0),(544606,15128,'es','Fecha Inicio',0),(544607,15128,'de','Anfangsdatum Rabatt',0),(544608,15128,'en','Begin Discount Date',0),(544609,15129,'is','',0),(544610,15129,'dr','ØªØ®ÙÛŒÙ Ø®Ø±Ù…Ø§',0),(544611,15129,'pr','ØªØ®ÙÛŒÙ Ø®Ø±Ù…Ø§',0),(544612,15129,'tr','Tarihler indirim',0),(544613,15129,'pl','Rabat daty',0),(544614,15129,'bg','ÐžÑ‚ÑÑ‚ÑŠÐ¿ÐºÐ° Ð´Ð°Ñ‚Ð¸',0),(544615,15129,'ur','ØªÙˆØ§Ø±ÛŒØ® ÚˆØ³Ú©Ø§Ø¤Ù†Ù¹',0),(544616,15129,'sr','ÐŸÐ¾Ð¿ÑƒÑÑ‚ Ð½Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ðµ',0),(544617,15129,'vi','Giáº£m giÃ¡ ngÃ y',0),(544618,15129,'af','Afslag van datums',0),(544619,15129,'ro','Reducere de dvs.',0),(544620,15129,'et','Allahindluse kuupÃ¤ev',0),(544621,15129,'si','Popust datumov',0),(544622,15129,'ba','DISKON TERBAIK untuk tanggal',0),(544623,15129,'nl','Goedkope datums',0),(544624,15129,'fi','Alennus pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(544625,15129,'no','Rabatt datoer',0),(544626,15129,'da','Rabat datoer',0),(544627,15129,'ko','ë‚ ì§œ í• ì¸',0),(544628,15129,'he','×”× ×—×” ×ª××¨×™×›×™×',0),(544629,15129,'el','Î•ÎšÎ Î¤Î©Î£Î•Î™Î£ Î³Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(544630,15129,'zh','æŠ˜æ‰£æ—¥æœŸ',0),(544631,15129,'sv','Rabatt datum',0),(544632,15129,'it','Sconto date',0),(544633,15129,'tl','',0),(544634,15129,'th','à¸¥à¸”à¸§à¸±à¸™à¸•à¹‰à¸­à¸‡',0),(544635,15129,'hi','à¤¡à¤¿à¤¸à¥à¤•à¤¾à¤‰à¤‚à¤Ÿ à¤¤à¤¾à¤°à¥€à¤–à¥‹à¤‚',0),(544636,15129,'ms','Diskaun pada tarikh',0),(544637,15129,'ar','Ø®ØµÙ… Ø§Ù„ØªÙˆØ§Ø±ÙŠØ®',0),(544638,15129,'fr','Dates de remise',0),(544639,15129,'jp','å‰²å¼•ã®æ—¥ä»˜',0),(544640,15129,'pt','Datas de desconto',0),(544641,15129,'ru','Ð¡ÐºÐ¸Ð´ÐºÐ° Ð´Ð°Ñ‚Ñ‹',0),(544642,15129,'es','Las fechas de descuento',0),(544643,15129,'de','Discount-Termine',0),(544644,15129,'en','Discount Dates',0),(544645,15130,'is','',0),(544646,15130,'dr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† ØªØ®ÙÛŒÙ',0),(544647,15130,'pr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† ØªØ®ÙÛŒÙ',0),(544648,15130,'tr','BitiÅŸ iskonto tarihi',0),(544649,15130,'pl','Data rabatu koÅ„cowego',0),(544650,15130,'bg','ÐšÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ°',0),(544651,15130,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ø±Ø¹Ø§ÛŒØª',0),(544652,15130,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ ÐºÐ°ÑÐ°ÑÐºÐ¾Ð½Ñ‚Ð°',0),(544653,15130,'vi','NgÃ y káº¿t thÃºc giáº£m giÃ¡',0),(544654,15130,'af','Afslag Einddatum',0),(544655,15130,'ro','Data de reducere la sfÃ¢rÅŸitul',0),(544656,15130,'et','LÃµpuks allahindluse kuupÃ¤ev',0),(544657,15130,'si','KonÄni datum popusta',0),(544658,15130,'ba','Tanggal akhir DISKON',0),(544659,15130,'nl','Korting einddatum',0),(544660,15130,'fi','Alennuksen pÃ¤Ã¤ttymispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(544661,15130,'no','Rabatt sluttdatoen',0),(544662,15130,'da','Rabat slutdato',0),(544663,15130,'ko','í• ì¸ ì¢…ë£Œì¼',0),(544664,15130,'he','×ª××¨×™×š ×”×¡×™×•× ×”× ×—×”',0),(544665,15130,'el','ÎˆÎºÏ€Ï„Ï‰ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(544666,15130,'zh','ç»“æŸæŠ˜æ‰£æ—¥æœŸ',0),(544667,15130,'sv','Slutdatum fÃ¶r rabatt',0),(544668,15130,'it','Data di fine sconto',0),(544669,15130,'tl','',0),(544670,15130,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(544671,15130,'hi','à¤…à¤‚à¤¤ à¤›à¥‚à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(544672,15130,'ms','Tarikh akhir diskaun',0),(544673,15130,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø®ØµÙ…',0),(544674,15130,'fr','Date de remise de fin',0),(544675,15130,'jp','å‰²å¼•ã®çµ‚äº†æ—¥',0),(544676,15130,'pt','Data de tÃ©rmino de desconto',0),(544677,15130,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ ÑÐºÐ¸Ð´ÐºÐ¸',0),(544678,15130,'es','Fecha de finalizaciÃ³n de descuento',0),(544679,15130,'de','Enddatum Rabatt',0),(544680,15130,'en','End Discount Date',0),(544681,15131,'is','',0),(544682,15131,'dr','Ú©Ø§Ù„Ú©',0),(544683,15131,'pr','Ú©Ø§Ù„Ú©',0),(544684,15131,'tr','KireÃ§',0),(544685,15131,'pl','Calc',0),(544686,15131,'bg','Calc',0),(544687,15131,'ur','Ù…Ø²ÛŒØ¯ Ú©Ø§Ù… Ú©ÛŒ Ú©ÛŒÙ„Ú©ÙˆÙ„ÛŒÙ¹Ø±',0),(544688,15131,'sr','Ð Ð°Ñ‡ÑƒÐ½Ð°ÑšÐµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(544689,15131,'vi','Calc',0),(544690,15131,'af','Calc',0),(544691,15131,'ro','Calc',0),(544692,15131,'et','Calc',0),(544693,15131,'si','Calc',0),(544694,15131,'ba','Calc',0),(544695,15131,'nl','Calc',0),(544696,15131,'fi','Calc',0),(544697,15131,'no','Beregning',0),(544698,15131,'da','Calc',0),(544699,15131,'ko','ì„ íšŒ ì§ˆ',0),(544700,15131,'he','×§××œ×§',0),(544701,15131,'el','Calc',0),(544702,15131,'zh','Calc',0),(544703,15131,'sv','Calc',0),(544704,15131,'it','Calc',0),(544705,15131,'tl','',0),(544706,15131,'th','à¸„à¸³à¸™à¸§à¸“',0),(544707,15131,'hi','Calc',0),(544708,15131,'ms','Kerak',0),(544709,15131,'ar','Ø§Ø­Ø³Ø¨',0),(544710,15131,'fr','Calc',0),(544711,15131,'jp','ã‚«ãƒ«ã‚¯',0),(544712,15131,'pt','Calc',0),(544713,15131,'ru','Calc',0),(544714,15131,'es','Calc',0),(544715,15131,'de','Calc',0),(544716,15131,'en','Calc',0),(544717,15132,'is','',0),(544718,15132,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… ÙˆÛŒØ±Ø§ÛŒØ´ Ø­Ø§Ù…Ù„',0),(544719,15132,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… ÙˆÛŒØ±Ø§ÛŒØ´ Ø­Ø§Ù…Ù„',0),(544720,15132,'tr','DÃ¼zenleme taÅŸÄ±yÄ±cÄ± tarafÄ±ndan giriÅŸ bilgi ekleme',0),(544721,15132,'pl','Dodanie informacji logowania przez przewoÅºnika edycji',0),(544722,15132,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð²Ñ…Ð¾Ð´ Ð¾Ñ‚ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡',0),(544723,15132,'ur','ØªØ¯ÙˆÛŒÙ†ÛŒ Ú©ÛŒØ±ÛŒØ¦Ø± Ú©ÛŒ Ù„Ø§Ú¯ Ø§Ù† Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(544724,15132,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð›Ð¾Ð³Ð¸Ð½ Ð˜Ð½Ñ„Ð¾ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð·Ð° ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð¾ÑÐ°Ñ‡',0),(544725,15132,'vi','ThÃªm Ä‘Äƒng nháº­p thÃ´ng tin cá»§a nhÃ  cung cáº¥p chá»‰nh sá»­a',0),(544726,15132,'af','Voeg aanmeldinligting deur redigering draer',0),(544727,15132,'ro','Adauga Login informaÅ£ii de editare transportator',0),(544728,15132,'et','Lisage Login Info toimetamine vedaja poolt',0),(544729,15132,'si','Dodaj prepriÄevalnost zavijati urejanje prevoznik',0),(544730,15132,'ba','Tambahkan Info Login oleh pembawa mengedit',0),(544731,15132,'nl','Voeg Login Info door bewerken vervoerder',0),(544732,15132,'fi','LisÃ¤Ã¤ kirjautumistiedot editointi harjoittaja',0),(544733,15132,'no','Legge til logikk Info av redigering Carrier',0),(544734,15132,'da','TilfÃ¸je Login Info redigering luftfartsselskab',0),(544735,15132,'ko','íŽ¸ì§‘ ì´ë™ í†µì‹ ì‚¬ì— ì˜í•´ ë¡œê·¸ì¸ ì •ë³´ ì¶”ê°€',0),(544736,15132,'he','×œ×”×•×¡×™×£ ×ž×™×“×¢ ×›× ×™×¡×” ×¢×œ-×™×“×™ ×¢×¨×™×›×” ×”×”×•×‘×œ×”',0),(544737,15132,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÏƒÏÎ½Î´ÎµÏƒÎ®Ï‚ Î±Ï€ÏŒ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(544738,15132,'zh','æ·»åŠ ç¼–è¾‘æ‰¿è¿äººçš„ç™»å½•ä¿¡æ¯',0),(544739,15132,'sv','LÃ¤gg till inloggningsinformation av redigering Carrier',0),(544740,15132,'it','Aggiungere informazioni di Login di Carrier Modifica',0),(544741,15132,'tl','',0),(544742,15132,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š à¹‚à¸”à¸¢à¸œà¸¹à¹‰à¹ƒà¸«à¹‰à¸šà¸£à¸´à¸à¸²à¸£à¹à¸à¹‰à¹„à¸‚',0),(544743,15132,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤µà¤¾à¤¹à¤• à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤²à¥‰à¤—à¤¿à¤¨ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(544744,15132,'ms','Tambah maklumat log masuk oleh syarikat penyuntingan',0),(544745,15132,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ù‚Ø¨Ù„ ØªØ­Ø±ÙŠØ± Ø§Ù„Ù†Ø§Ù‚Ù„',0),(544746,15132,'fr','Ajouter des informations de connexion par Ã©dition porteur',0),(544747,15132,'jp','ç·¨é›†ã®ã‚­ãƒ£ãƒªã‚¢ã«ã‚ˆã£ã¦ãƒ­ã‚°ã‚¤ãƒ³æƒ…å ±ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(544748,15132,'pt','Adicionar informaÃ§Ãµes de Login por transportadora ediÃ§Ã£o',0),(544749,15132,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð›Ð¾Ð³Ð¸Ð½ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸ÐºÐ¾Ð¼',0),(544750,15132,'es','AÃ±adir informaciÃ³n de inicio de sesiÃ³n por transportista ediciÃ³n',0),(544751,15132,'de','Login-Info durch Bearbeitung Carrier hinzufÃ¼gen',0),(544752,15132,'en','Add Login Info By Editing Carrier',0),(544753,15133,'is','',0),(544754,15133,'dr','Ø§Ø¨Ø¹Ø§Ø¯',0),(544755,15133,'pr','Ø§Ø¨Ø¹Ø§Ø¯',0),(544756,15133,'tr','Boyutlar',0),(544757,15133,'pl','Wymiary',0),(544758,15133,'bg','ÐÐ¸Ð²Ð° Ð½Ð° Ð°Ð½Ð°Ð»Ð¸Ñ‚Ð¸Ñ‡Ð½Ð¾ÑÑ‚',0),(544759,15133,'ur','Ø·ÙˆÙ„ Ùˆ Ø¹Ø±Ø¶',0),(544760,15133,'sr','Ð”Ð¸Ð¼ÐµÐ½Ð·Ð¸Ñ˜Ðµ',0),(544761,15133,'vi','KÃ­ch thÆ°á»›c',0),(544762,15133,'af','Dimensies',0),(544763,15133,'ro','Dimensiuni',0),(544764,15133,'et','MÃµÃµtmed',0),(544765,15133,'si','Dimenzije',0),(544766,15133,'ba','Dimensi',0),(544767,15133,'nl','Afmetingen',0),(544768,15133,'fi','Mitat',0),(544769,15133,'no','Dimensjoner',0),(544770,15133,'da','Dimensioner',0),(544771,15133,'ko','ì¹˜ìˆ˜',0),(544772,15133,'he','×ž×™×“×•×ª',0),(544773,15133,'el','Î”Î¹Î±ÏƒÏ„Î¬ÏƒÎµÎ¹Ï‚',0),(544774,15133,'zh','å°ºå¯¸',0),(544775,15133,'sv','Dimensioner',0),(544776,15133,'it','Dimensioni',0),(544777,15133,'tl','',0),(544778,15133,'th','à¸¡à¸´à¸•à¸´',0),(544779,15133,'hi','à¤†à¤¯à¤¾à¤®',0),(544780,15133,'ms','Dimensi',0),(544781,15133,'ar','Ø£Ø¨Ø¹Ø§Ø¯',0),(544782,15133,'fr','Dimensions',0),(544783,15133,'jp','å¯¸æ³•',0),(544784,15133,'pt','DimensÃµes',0),(544785,15133,'ru','Ð“Ð°Ð±Ð°Ñ€Ð¸Ñ‚Ð½Ñ‹Ðµ Ñ€Ð°Ð·Ð¼ÐµÑ€Ñ‹',0),(544786,15133,'es','Dimensiones',0),(544787,15133,'de','Abmessungen',0),(544788,15133,'en','Dimensions',0),(544789,15134,'is','',0),(544790,15134,'dr','LxWxH',0),(544791,15134,'pr','LxWxH',0),(544792,15134,'tr','LxWxH',0),(544793,15134,'pl','Lxszer. xwys.',0),(544794,15134,'bg','LxWxH',0),(544795,15134,'ur','Ù„Ø§ÙˆØ§Û',0),(544796,15134,'sr','Ð›xWxÐ¥',0),(544797,15134,'vi','DxRxC',0),(544798,15134,'af','LxWxH',0),(544799,15134,'ro','LxWxH',0),(544800,15134,'et','PxLxK',0),(544801,15134,'si','DxÅ xV',0),(544802,15134,'ba','LxWxH',0),(544803,15134,'nl','LxBxH',0),(544804,15134,'fi','PxLxK',0),(544805,15134,'no','LxBxH',0),(544806,15134,'da','LxBxH',0),(544807,15134,'ko','LxWxH',0),(544808,15134,'he','LxWxH',0),(544809,15134,'el','ÎœÏ‡Î Ï‡Î¥',0),(544810,15134,'zh','ï¼ˆé•¿å®½é«˜ï¼‰',0),(544811,15134,'sv','LxBxH',0),(544812,15134,'it','LxWxH',0),(544813,15134,'tl','',0),(544814,15134,'th','LxWxH',0),(544815,15134,'hi','LxWxH',0),(544816,15134,'ms','LxWxH',0),(544817,15134,'ar','LxWxH',0),(544818,15134,'fr','LxlxH',0),(544819,15134,'jp','LxWxH',0),(544820,15134,'pt','CxLxA',0),(544821,15134,'ru','Ð” Ñ… Ñˆ Ñ…',0),(544822,15134,'es','LxWxH',0),(544823,15134,'de','LxBxH',0),(544824,15134,'en','LxWxH',0),(544825,15135,'is','',0),(544826,15135,'dr','Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ø¨Ø²Ø§Ø± Ø¹Ù…ÙˆÙ…ÛŒ Ø§Ú©Ø³Ù¾Ø±Øª',0),(544827,15135,'pr','Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ø¨Ø²Ø§Ø± Ø¹Ù…ÙˆÙ…ÛŒ Ø§Ú©Ø³Ù¾Ø±Øª',0),(544828,15135,'tr','Genel alÄ±ntÄ± aracÄ±nÄ± kullanma',0),(544829,15135,'pl','OgÃ³lne narzÄ™dzie cytowanie',0),(544830,15135,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ð³ÐµÐ½ÐµÑ€Ð¸Ñ‡Ð½Ð¸ Ñ†Ð¸Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚',0),(544831,15135,'ur','Ø¹Ù…ÙˆÙ…ÛŒ Ø¨Ù„Ù†Ø¯ ØªØ±ÛŒÙ† Ø§Ø³Ù…Ù Ú©Û’ Ø­ÙˆØ§Ù„Û’ Ø³Û’ Ø±Ù¾ÙˆØ±Ù¹ ÛØªÚ¾ÛŒØ§Ø± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(544832,15135,'sr','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð°Ñ˜ÑƒÑ›Ð¸ Ð³ÐµÐ½ÐµÑ€Ð¸Ñ‡ÐºÐµ Ð°Ð»Ð°Ñ‚ÐºÐ¾Ð¼',0),(544833,15135,'vi','Báº±ng cÃ¡ch sá»­ dá»¥ng cÃ´ng cá»¥ chung trÃ­ch dáº«n',0),(544834,15135,'af','Generiese met vermelding van instrument gebruik',0),(544835,15135,'ro','Utilizarea instrumentului citÃ¢nd generice',0),(544836,15135,'et','Generic tsiteerides tÏ†Ï†riista kasutamine',0),(544837,15135,'si','Z uporabo generiÄnih citira orodje',0),(544838,15135,'ba','Menggunakan alat Penawaran Umum',0),(544839,15135,'nl','Met behulp van generieke citeren Tool',0),(544840,15135,'fi','YleisiÃ¤ lainaten-tyÃ¶kalulla',0),(544841,15135,'no','Bruke generiske sitere verktÃ¸yet',0),(544842,15135,'da','Ved hjÃ¦lp af generiske citere vÃ¦rktÃ¸j',0),(544843,15135,'ko','ì¼ë°˜ ì¸ìš© ë„êµ¬ë¥¼ ì‚¬ìš© í•˜ ì—¬',0),(544844,15135,'he','×‘××ž×¦×¢×•×ª ×›×œ×™ ×¦×™×˜×•×˜ ×›×œ×œ×™',0),(544845,15135,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Î³ÎµÎ½Î¹ÎºÏŒ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ Ï€Î±ÏÎ±Î¸Î­Ï„Ï‰',0),(544846,15135,'zh','ä½¿ç”¨æ³›åž‹çš„æŠ¥ä»·å·¥å…·',0),(544847,15135,'sv','Generiska verktyget citera',0),(544848,15135,'it','Utilizzo generico strumento citando',0),(544849,15135,'tl','',0),(544850,15135,'th','à¹ƒà¸Šà¹‰à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(544851,15135,'hi','à¤œà¥‡à¤¨à¥‡à¤°à¤¿à¤• à¤²à¥‡à¤– à¤•à¤¾ à¤¹à¤µà¤¾à¤²à¤¾ à¤‰à¤ªà¤•à¤°à¤£ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°',0),(544852,15135,'ms','Menggunakan alat Sebutharga generik',0),(544853,15135,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø£Ø¯Ø§Ø© Ù†Ù‚Ù„Ø§ Ø¹Ù† Ø¹Ø§Ù…Ø©',0),(544854,15135,'fr','Ã€ l\'aide de l\'outil cotation gÃ©nÃ©rique',0),(544855,15135,'jp','å¼•ç”¨ã®æ±Žç”¨ãƒ„ãƒ¼ãƒ«ã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(544856,15135,'pt','Usando a ferramenta citando genÃ©rica',0),(544857,15135,'ru','Ð¡ Ð¿Ð¾Ð¼Ð¾Ñ‰ÑŒÑŽ ÑƒÐ½Ð¸Ð²ÐµÑ€ÑÐ°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð° ÑÐ¾ ÑÑÑ‹Ð»ÐºÐ¾Ð¹',0),(544858,15135,'es','Usando la herramienta genÃ©rica de cotizaciones',0),(544859,15135,'de','Verwendung von generischen zitieren Tool',0),(544860,15135,'en','Using Generic Quoting Tool',0),(544861,15136,'is','',0),(544862,15136,'dr','Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ø§Ø±Ø¨Ø±ÛŒ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³',0),(544863,15136,'pr','Ø¨Ø§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ø§Ø±Ø¨Ø±ÛŒ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³',0),(544864,15136,'tr','UPS kimlik bilgilerinizi kullanarak',0),(544865,15136,'pl','Przy uÅ¼yciu poÅ›wiadczeÅ„ UPS',0),(544866,15136,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð²Ð°ÑˆÐ¸Ñ‚Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° UPS',0),(544867,15136,'ur','Ø§Ù¾Ù†ÛŒ UPS Ø§Ø³Ù†Ø§Ø¯ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(544868,15136,'sr','ÐŸÐ¾Ð¼Ð¾Ñ›Ñƒ Ð²Ð°ÑˆÐ¸Ñ… Ð°ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸Ð²Ð° Ð£ÐŸÐ¡-Ð°',0),(544869,15136,'vi','Sá»­ dá»¥ng á»§y nhiá»‡m UPS cá»§a báº¡n',0),(544870,15136,'af','Gebruik jou onderbrekinglose Kragtoevoer verwysings',0),(544871,15136,'ro','UtilizÃ¢nd acreditÄƒrile de UPS',0),(544872,15136,'et','UPS-i mandaadi abil',0),(544873,15136,'si','Z vaÅ¡imi poverilnicami UPS',0),(544874,15136,'ba','Menggunakan kredensial UPS',0),(544875,15136,'nl','Met behulp van uw UPS-referenties',0),(544876,15136,'fi','UPS-tunnuksilla',0),(544877,15136,'no','Ved hjelp av legitimasjonsbeskrivelsene UPS',0),(544878,15136,'da','Ved hjÃ¦lp af legitimationsoplysningerne UPS',0),(544879,15136,'ko','UPS ìžê²© ì¦ëª…ì„ ì‚¬ìš© í•˜ ì—¬',0),(544880,15136,'he','×‘××ž×¦×¢×•×ª ×”××™×©×•×¨×™× ×©×œ×š ×¢×œ×™×•×ª',0),(544881,15136,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÏŽÎ½Ï„Î±Ï‚ Ï„Î± Î´Î¹Î±Ï€Î¹ÏƒÏ„ÎµÏ…Ï„Î®ÏÎ¹Î¬ ÏƒÎ±Ï‚ UPS',0),(544882,15136,'zh','ä½¿ç”¨æ‚¨çš„ UPS å‡­æ®',0),(544883,15136,'sv','Med dina UPS-referenser',0),(544884,15136,'it','Utilizzando le credenziali di UPS',0),(544885,15136,'tl','',0),(544886,15136,'th','à¹ƒà¸Šà¹‰à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸›à¸£à¸°à¸ˆà¸³à¸•à¸±à¸§à¸‚à¸­à¸‡ UPS',0),(544887,15136,'hi','à¤†à¤ªà¤•à¤¾ à¤¯à¥‚à¤ªà¥€à¤à¤¸ à¤•à¥à¤°à¥‡à¤¡à¥‡à¤‚à¤¶à¤¿à¤¯à¤²à¥à¤¸ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°',0),(544888,15136,'ms','Menggunakan kelayakan up anda',0),(544889,15136,'ar','Ø¨Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø§Ø¹ØªÙ…Ø§Ø¯ Ø§Ù„Ø®Ø§ØµØ© Ø¨Ùƒ UPS',0),(544890,15136,'fr','Ã€ l\'aide de vos informations d\'identification de l\'UPS',0),(544891,15136,'jp','UPS ã®è³‡æ ¼æƒ…å ±ã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(544892,15136,'pt','Usando suas credenciais do UPS',0),(544893,15136,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÑ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð˜Ð‘ÐŸ',0),(544894,15136,'es','Use sus credenciales de UPS',0),(544895,15136,'de','Unter Verwendung Ihrer Anmeldeinformationen UPS',0),(544896,15136,'en','Using Your UPS Credentials',0),(544897,15137,'is','',0),(544898,15137,'dr','Ø§ÛŒÙ†Ú†',0),(544899,15137,'pr','Ø§ÛŒÙ†Ú†',0),(544900,15137,'tr','Ä°nÃ§',0),(544901,15137,'pl','Cale',0),(544902,15137,'bg','Ð˜Ð½Ñ‡Ð°',0),(544903,15137,'ur','Ø§Ù†Ú†',0),(544904,15137,'sr','Ð˜Ð½Ñ‡Ð°',0),(544905,15137,'vi','Inch',0),(544906,15137,'af','Duim',0),(544907,15137,'ro','Inci',0),(544908,15137,'et','Tolli',0),(544909,15137,'si','Palcev',0),(544910,15137,'ba','Inci',0),(544911,15137,'nl','Inch',0),(544912,15137,'fi','Tuumaa',0),(544913,15137,'no','Tommer',0),(544914,15137,'da','Inches',0),(544915,15137,'ko','ì¸ì¹˜',0),(544916,15137,'he','×¡ ×ž',0),(544917,15137,'el','ÎŠÎ½Ï„ÏƒÎµÏ‚',0),(544918,15137,'zh','è‹±å¯¸',0),(544919,15137,'sv','Inches',0),(544920,15137,'it','Pollici',0),(544921,15137,'tl','',0),(544922,15137,'th','à¸™à¸´à¹‰à¸§',0),(544923,15137,'hi','à¤‡à¤‚à¤š',0),(544924,15137,'ms','Inci',0),(544925,15137,'ar','Ø¨ÙˆØµØ©',0),(544926,15137,'fr','Pouces',0),(544927,15137,'jp','ã‚¤ãƒ³ãƒ',0),(544928,15137,'pt','Polegadas',0),(544929,15137,'ru','Ð”ÑŽÐ¹Ð¼Ð¾Ð²',0),(544930,15137,'es','Pulgadas',0),(544931,15137,'de','Zoll',0),(544932,15137,'en','Inches',0),(544933,15138,'is','',0),(544934,15138,'dr','Ú©Ø´ØªÛŒ Ù…ÙˆØ±Ø¯ Ø¨Ù‡ Ø®ÙˆØ¯ÛŒ Ø®ÙˆØ¯',0),(544935,15138,'pr','Ú©Ø´ØªÛŒ Ù…ÙˆØ±Ø¯ Ø¨Ù‡ Ø®ÙˆØ¯ÛŒ Ø®ÙˆØ¯',0),(544936,15138,'tr','Ã–ÄŸe gemi tek baÅŸÄ±na',0),(544937,15138,'pl','Pozycja statkÃ³w przez siebie',0),(544938,15138,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» ÐºÐ¾Ñ€Ð°Ð±Ð¸ Ð¾Ñ‚ ÑÐ°Ð¼Ð¾ ÑÐµÐ±Ðµ ÑÐ¸',0),(544939,15138,'ur','Ø´Û’ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²ÙˆÚº Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø®ÙˆØ¯',0),(544940,15138,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ð±Ñ€Ð¾Ð´Ð¾Ð²Ð° ÑÐ°Ð¼Ð° Ð¾Ð´ ÑÐµÐ±Ðµ',0),(544941,15138,'vi','Má»¥c tÃ u cá»§a chÃ­nh nÃ³',0),(544942,15138,'af','Item skepe deur self',0),(544943,15138,'ro','Element de nave de la sine',0),(544944,15138,'et','Ãœksus laevade ise',0),(544945,15138,'si','Element ladje sama',0),(544946,15138,'ba','Kapal-kapal barang sendiri',0),(544947,15138,'nl','Item schepen door zelf',0),(544948,15138,'fi','Nimikkeen alukset itse',0),(544949,15138,'no','Elementet skipene selv',0),(544950,15138,'da','Vare skibe af sig selv',0),(544951,15138,'ko','ìžì²´ í•­ëª© ë°°ì†¡',0),(544952,15138,'he','×¡×¤×™× ×•×ª ×¤×¨×™×˜ ×‘×¤× ×™ ×¢×¦×ž×•',0),(544953,15138,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€Î»Î¿Î¯Î± Î±Ï€ÏŒ Î¼ÏŒÎ½Î· Ï„Î·Ï‚',0),(544954,15138,'zh','é¡¹èˆ¹èˆ¶æœ¬èº«',0),(544955,15138,'sv','Objektet fartyg av sig sjÃ¤lv',0),(544956,15138,'it','Elemento navi da sola',0),(544957,15138,'tl','',0),(544958,15138,'th','à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸² à¸”à¹‰à¸§à¸¢à¸•à¸±à¸§à¹€à¸­à¸‡',0),(544959,15138,'hi','à¤®à¤¦ à¤ªà¥‹à¤¤à¥‹à¤‚ à¤¸à¥‡ à¤¹à¥€',0),(544960,15138,'ms','Butiran kapal-kapal dengan sendirinya',0),(544961,15138,'ar','Ø§Ù„Ø¨Ù†Ø¯ Ø§Ù„Ø³ÙÙ† Ø¨Ù†ÙØ³Ù‡Ø§',0),(544962,15138,'fr','Navires point par elle-mÃªme',0),(544963,15138,'jp','å˜ç‹¬ã§å•†å“ã®ç™ºé€',0),(544964,15138,'pt','Item navios por si sÃ³',0),(544965,15138,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»Ð¸ Ð¿ÑƒÐ½ÐºÑ‚ ÑÐ°Ð¼ Ð¿Ð¾ ÑÐµÐ±Ðµ',0),(544966,15138,'es','ArtÃ­culo naves por sÃ­ mismo',0),(544967,15138,'de','Element-Schiffe von selbst',0),(544968,15138,'en','Item Ships By Itself',0),(544969,15139,'is','',0),(544970,15139,'dr','Ø§Ø¨Ø¹Ø§Ø¯ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(544971,15139,'pr','Ø§Ø¨Ø¹Ø§Ø¯ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(544972,15139,'tr','Nakliye boyutlarÄ±',0),(544973,15139,'pl','WysyÅ‚ka wymiary',0),(544974,15139,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ€Ð°Ð·Ð¼ÐµÑ€Ð¸',0),(544975,15139,'ur','Ú©Ø´ØªÛŒ Ø±Ø§Ù†ÛŒ Ú©Û’ Ø·ÙˆÙ„ Ùˆ Ø¹Ø±Ø¶',0),(544976,15139,'sr','Ð”Ð¸Ð¼ÐµÐ½Ð·Ð¸Ñ˜Ðµ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(544977,15139,'vi','Váº­n chuyá»ƒn kÃ­ch thÆ°á»›c',0),(544978,15139,'af','Dimensies gestuur',0),(544979,15139,'ro','Dimensiuni de expediere',0),(544980,15139,'et','Laevanduse mÃµÃµtmed',0),(544981,15139,'si','Dostava dimenzije',0),(544982,15139,'ba','Dimensi pengiriman',0),(544983,15139,'nl','Shipping afmetingen',0),(544984,15139,'fi','Toimitus mitat',0),(544985,15139,'no','Frakt dimensjoner',0),(544986,15139,'da','Shipping dimensioner',0),(544987,15139,'ko','ë°°ì†¡ ì¹˜ìˆ˜',0),(544988,15139,'he','×ž×©×œ×•×— ×ž×™×“×•×ª',0),(544989,15139,'el','Î”Î¹Î±ÏƒÏ„Î¬ÏƒÎµÎ¹Ï‚ Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(544990,15139,'zh','è£…è¿å°ºå¯¸',0),(544991,15139,'sv','Frakt dimensioner',0),(544992,15139,'it','Dimensioni di spedizione',0),(544993,15139,'tl','',0),(544994,15139,'th','à¸‚à¸™à¸²à¸”à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(544995,15139,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤†à¤¯à¤¾à¤®',0),(544996,15139,'ms','Penghantaran dimensi',0),(544997,15139,'ar','Ø£Ø¨Ø¹Ø§Ø¯ Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ',0),(544998,15139,'fr','Dimensions d\'expÃ©dition',0),(544999,15139,'jp','å‡ºè·å¯¸æ³•',0),(545000,15139,'pt','DimensÃµes de transporte',0),(545001,15139,'ru','Ð“Ð°Ð±Ð°Ñ€Ð¸Ñ‚Ð½Ñ‹Ðµ Ñ€Ð°Ð·Ð¼ÐµÑ€Ñ‹',0),(545002,15139,'es','Dimensiones del envÃ­o',0),(545003,15139,'de','Versand-Abmessungen',0),(545004,15139,'en','Shipping Dimensions',0),(545005,15140,'is','',0),(545006,15140,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ØªØµÙˆÛŒØ± Ø¬Ø¯ÛŒØ¯',0),(545007,15140,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ØªØµÙˆÛŒØ± Ø¬Ø¯ÛŒØ¯',0),(545008,15140,'tr','Yeni Resim Ekle',0),(545009,15140,'pl','DodaÄ‡ nowy obraz',0),(545010,15140,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð¾ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(545011,15140,'ur','Ù†ÛŒØ§ Ù†Ù‚Ø´ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(545012,15140,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ñƒ ÑÐ»Ð¸ÐºÑƒ',0),(545013,15140,'vi','ThÃªm hÃ¬nh áº£nh má»›i',0),(545014,15140,'af','Voeg nuwe beeld',0),(545015,15140,'ro','Adauga imagine nouÄƒ',0),(545016,15140,'et','Lisa uus pilt',0),(545017,15140,'si','Dodajte novo sliko',0),(545018,15140,'ba','Tambahkan gambar baru',0),(545019,15140,'nl','Nieuwe afbeelding toevoegen',0),(545020,15140,'fi','LisÃ¤Ã¤ uusi kuva',0),(545021,15140,'no','Legge til nytt bilde',0),(545022,15140,'da','TilfÃ¸j nyt billede',0),(545023,15140,'ko','ìƒˆ ì´ë¯¸ì§€ë¥¼ ì¶”ê°€',0),(545024,15140,'he','×ª×•×¡×™×£ ×ª×ž×•× ×” ×—×“×©×”',0),(545025,15140,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î±Ï‚ ÎµÎ¹ÎºÏŒÎ½Î±Ï‚',0),(545026,15140,'zh','æ·»åŠ æ–°çš„æ˜ åƒ',0),(545027,15140,'sv','LÃ¤gg till ny bild',0),(545028,15140,'it','Aggiungi nuova immagine',0),(545029,15140,'tl','',0),(545030,15140,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸¹à¸›à¸ à¸²à¸žà¹ƒà¸«à¸¡à¹ˆ',0),(545031,15140,'hi','à¤¨à¤ˆ à¤›à¤µà¤¿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(545032,15140,'ms','Menambah imej baru',0),(545033,15140,'ar','Ø¥Ø¶Ø§ÙØ© ØµÙˆØ±Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(545034,15140,'fr','Ajouter Nouvelle Image',0),(545035,15140,'jp','æ–°ã—ã„ç”»åƒã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(545036,15140,'pt','Adicionar nova imagem',0),(545037,15140,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ð¾Ðµ Ð¸Ð·Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ',0),(545038,15140,'es','Agregar nueva imagen',0),(545039,15140,'de','Neues Bild hinzufÃ¼gen',0),(545040,15140,'en','Add New Image',0),(545041,15141,'is','',0),(545042,15141,'dr','Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ú©Ù„ÛŒØ¯',0),(545043,15141,'pr','Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ú©Ù„ÛŒØ¯',0),(545044,15141,'tr','EriÅŸim tuÅŸu',0),(545045,15141,'pl','Klawisz dostÄ™pu',0),(545046,15141,'bg','ÐšÐ»Ð°Ð²Ð¸Ñˆ Ð·Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(545047,15141,'ur','Ú©Ù„ÛŒØ¯ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ',0),(545048,15141,'sr','ÐŸÑ€Ð¸ÑÑ‚ÑƒÐ¿ ÐºÑ™ÑƒÑ‡',0),(545049,15141,'vi','PhÃ­m truy cáº­p',0),(545050,15141,'af','Toegang sleutel',0),(545051,15141,'ro','Cheie de acces',0),(545052,15141,'et','VÃµrgu vÃµti',0),(545053,15141,'si','Tipka za dostop',0),(545054,15141,'ba','Akses Key',0),(545055,15141,'nl','Toegangstoets',0),(545056,15141,'fi','PikanÃ¤ppÃ¤in',0),(545057,15141,'no','Hurtigtast',0),(545058,15141,'da','Access Key',0),(545059,15141,'ko','ì•¡ì„¸ìŠ¤ í‚¤',0),(545060,15141,'he','×ž×§×© ×’×™×©×”',0),(545061,15141,'el','ÎšÎ»ÎµÎ¹Î´Î¯ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(545062,15141,'zh','è®¿é—®é”®',0),(545063,15141,'sv','TilltrÃ¤de nyckel',0),(545064,15141,'it','Chiave di accesso',0),(545065,15141,'tl','',0),(545066,15141,'th','à¸„à¸µà¸¢à¹Œà¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡',0),(545067,15141,'hi','à¤ªà¤¹à¥à¤à¤š à¤•à¥à¤‚à¤œà¥€',0),(545068,15141,'ms','Kekunci akses',0),(545069,15141,'ar','Ù…ÙØªØ§Ø­ Ø§Ù„ÙˆØµÙˆÙ„',0),(545070,15141,'fr','Touche d\'accÃ¨s rapide',0),(545071,15141,'jp','ã‚¢ã‚¯ã‚»ã‚¹ ã‚­ãƒ¼',0),(545072,15141,'pt','Chave de acesso',0),(545073,15141,'ru','ÐšÐ»ÑŽÑ‡ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°',0),(545074,15141,'es','Tecla de acceso',0),(545075,15141,'de','Zugriffstaste',0),(545076,15141,'en','Access Key',0),(545077,15142,'is','',0),(545078,15142,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª Ø­Ø§Ù…Ù„',0),(545079,15142,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª Ø­Ø§Ù…Ù„',0),(545080,15142,'tr','TaÅŸÄ±yÄ±cÄ± sitesine giriÅŸ',0),(545081,15142,'pl','PrzewoÅºnik Strona logowania',0),(545082,15142,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ ÑÐ°Ð¹Ñ‚ Ð²Ñ…Ð¾Ð´',0),(545083,15142,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ø³Ø§Ø¦Ù¹ Ù„Ø§Ú¯ Ø§Ù†',0),(545084,15142,'sr','ÐÐ¾ÑÐ°Ñ‡ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð›Ð¾Ð³Ð¸Ð½',0),(545085,15142,'vi','TÃ u sÃ¢n bay trang web Ä‘Äƒng nháº­p',0),(545086,15142,'af','Draer werf aantekening',0),(545087,15142,'ro','Transportatorul Site Login',0),(545088,15142,'et','Vedaja saidile sisselogimine',0),(545089,15142,'si','Prevoznik poloÅ¾aj prepriÄevalnost',0),(545090,15142,'ba','Login situs pembawa',0),(545091,15142,'nl','Vervoerder Site Login',0),(545092,15142,'fi','Operaattorin kirjautuminen',0),(545093,15142,'no','TransportÃ¸r sted logikk',0),(545094,15142,'da','Carrier Site Login',0),(545095,15142,'ko','ìºë¦¬ì–´ ì‚¬ì´íŠ¸ ë¡œê·¸ì¸',0),(545096,15142,'he','×›× ×™×¡×” ×œ××ª×¨ ×”×ž×•×‘×™×œ',0),(545097,15142,'el','Î£ÏÎ½Î´ÎµÏƒÎ· ÏƒÏ„Î¿Î½ Î¹ÏƒÏ„Î¿Ï‡ÏŽÏÎ¿ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(545098,15142,'zh','æ‰¿è¿äººç½‘ç«™ç™»å½•',0),(545099,15142,'sv','Carrier webbplats Login',0),(545100,15142,'it','Portante sito Login',0),(545101,15142,'tl','',0),(545102,15142,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸‚à¸™à¸ªà¹ˆà¸‡à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(545103,15142,'hi','à¤µà¤¾à¤¹à¤• à¤¸à¤¾à¤‡à¤Ÿ à¤²à¥‰à¤—à¤¿à¤¨',0),(545104,15142,'ms','Log masuk Laman web pembekal perkhidmatan',0),(545105,15142,'ar','Ø¯Ø®ÙˆÙ„ Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù†Ø§Ù‚Ù„',0),(545106,15142,'fr','Transporteur Site Login',0),(545107,15142,'jp','ã‚­ãƒ£ãƒªã‚¢ ã‚µã‚¤ãƒˆ ãƒ­ã‚°ã‚¤ãƒ³',0),(545108,15142,'pt','Transportadora Site Login',0),(545109,15142,'ru','Ð’Ñ…Ð¾Ð´ Ð½Ð° ÑÐ°Ð¹Ñ‚ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸ÐºÐ°',0),(545110,15142,'es','Portador sitio Login',0),(545111,15142,'de','Carrier Website Login',0),(545112,15142,'en','Carrier Site Login',0),(545113,15143,'is','',0),(545114,15143,'dr','Ø­Ø§Ù…Ù„ Ø³Ø§ÛŒØª Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±',0),(545115,15143,'pr','Ø­Ø§Ù…Ù„ Ø³Ø§ÛŒØª Ø±Ù…Ø² Ø¹Ø¨ÙˆØ±',0),(545116,15143,'tr','TaÅŸÄ±yÄ±cÄ± Site ÅŸifre',0),(545117,15143,'pl','HasÅ‚o Strona przewoÅºnika',0),(545118,15143,'bg','ÐŸÑ€ÐµÐ²Ð¾Ð·Ð²Ð°Ñ‡ ÑÐ°Ð¹Ñ‚ Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(545119,15143,'ur','Ú©ÛŒØ±ÛŒØ¦Ø± Ø³Ø§Ø¦Ù¹ Ú©Ø§ Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(545120,15143,'sr','ÐÐ¾ÑÐ°Ñ‡ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð° Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ',0),(545121,15143,'vi','TÃ u sÃ¢n bay trang web máº­t kháº©u',0),(545122,15143,'af','Draer werf wagwoord',0),(545123,15143,'ro','Parola de site-ul de transport',0),(545124,15143,'et','Vedaja saidi parool',0),(545125,15143,'si','Prevoznik stran geslo',0),(545126,15143,'ba','Operator situs Password',0),(545127,15143,'nl','Vervoerder Site wachtwoord',0),(545128,15143,'fi','Operaattorin sivuston salasana',0),(545129,15143,'no','OperatÃ¸r nettstedet passord',0),(545130,15143,'da','Carrier Site adgangskode',0),(545131,15143,'ko','ìºë¦¬ì–´ ì‚¬ì´íŠ¸ ë¹„ë°€ ë²ˆí˜¸',0),(545132,15143,'he','×¡×™×¡×ž×” ×‘××ª×¨ ×”×¡×¤×§',0),(545133,15143,'el','ÎšÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ Ï€ÎµÏÎ¹Î¿Ï‡ÏŽÎ½ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Î±',0),(545134,15143,'zh','æ‰¿è¿äººç½‘ç«™å¯†ç ',0),(545135,15143,'sv','Carrier webbplats lÃ¶senord',0),(545136,15143,'it','Portante sito Password',0),(545137,15143,'tl','',0),(545138,15143,'th','à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¸šà¸£à¸´à¸©à¸±à¸—à¸‚à¸™à¸ªà¹ˆà¸‡',0),(545139,15143,'hi','à¤µà¤¾à¤¹à¤• à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡',0),(545140,15143,'ms','Kata laluan laman web pembekal perkhidmatan',0),(545141,15143,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ù†Ø§Ù‚Ù„',0),(545142,15143,'fr','Transporteur Site mot de passe',0),(545143,15143,'jp','ã‚­ãƒ£ãƒªã‚¢ ã‚µã‚¤ãƒˆ ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰',0),(545144,15143,'pt','Senha de Site de transportadora',0),(545145,15143,'ru','ÐŸÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸Ðº Ð¿Ð°Ñ€Ð¾Ð»Ñ ÑÐ°Ð¹Ñ‚Ð°',0),(545146,15143,'es','Portador sitio contraseÃ±a',0),(545147,15143,'de','Carrier Site Passwort',0),(545148,15143,'en','Carrier Site Password',0),(545149,15144,'is','',0),(545150,15144,'dr','Ø§Ø¨Ø¹Ø§Ø¯ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù¾ÛŒØ´ ÙØ±Ø¶',0),(545151,15144,'pr','Ø§Ø¨Ø¹Ø§Ø¯ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù¾ÛŒØ´ ÙØ±Ø¶',0),(545152,15144,'tr','VarsayÄ±lan Kargo boyutlarÄ±',0),(545153,15144,'pl','WymiarÃ³w domyÅ›lnych wysyÅ‚ki',0),(545154,15144,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ€Ð°Ð·Ð¼ÐµÑ€Ð¸',0),(545155,15144,'ur','Ø·Û’ Ø´Ø¯Û Ø´Ù¾Ù†Ú¯ Ø·ÙˆÙ„ Ùˆ Ø¹Ø±Ø¶',0),(545156,15144,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° Ð´Ð¸Ð¼ÐµÐ½Ð·Ð¸Ñ˜Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(545157,15144,'vi','Máº·c Ä‘á»‹nh váº­n chuyá»ƒn kÃ­ch thÆ°á»›c',0),(545158,15144,'af','Verstek gestuur dimensies',0),(545159,15144,'ro','Dimensiuni de livrare implicite',0),(545160,15144,'et','Vaikedimensioone laevandus',0),(545161,15144,'si','Privzete dimenzije dostava',0),(545162,15144,'ba','Standar pengiriman dimensi',0),(545163,15144,'nl','Standaard verzending dimensies',0),(545164,15144,'fi','Toimitus oletusdimensiot',0),(545165,15144,'no','Standard frakt dimensjoner',0),(545166,15144,'da','Standarddimensioner Shipping',0),(545167,15144,'ko','ê¸°ë³¸ ë°°ì†¡ ì¹˜ìˆ˜',0),(545168,15144,'he','×ž×™×“×•×ª ×ž×©×œ×•×— ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(545169,15144,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Î´Î¹Î±ÏƒÏ„Î¬ÏƒÎµÎ¹Ï‚ Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(545170,15144,'zh','é»˜è®¤è£…è¿å°ºå¯¸',0),(545171,15144,'sv','Frakt dimensioner',0),(545172,15144,'it','Dimensioni di spedizione predefinita',0),(545173,15144,'tl','',0),(545174,15144,'th','à¸‚à¸™à¸²à¸”à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(545175,15144,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤†à¤¯à¤¾à¤®',0),(545176,15144,'ms','Dimensi perkapalan lalai',0),(545177,15144,'ar','Ø£Ø¨Ø¹Ø§Ø¯ Ø§Ù„Ø´Ø­Ù† Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(545178,15144,'fr','Dimensions d\'expÃ©dition par dÃ©faut',0),(545179,15144,'jp','æ—¢å®šã®å‡ºè·æ™‚å¯¸æ³•',0),(545180,15144,'pt','DimensÃµes de transporte padrÃ£o',0),(545181,15144,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð³Ð°Ð±Ð°Ñ€Ð¸Ñ‚Ð½Ñ‹Ðµ Ñ€Ð°Ð·Ð¼ÐµÑ€Ñ‹',0),(545182,15144,'es','Dimensiones del envÃ­o por defecto',0),(545183,15144,'de','Standardabmessungen Versand',0),(545184,15144,'en','Default Shipping Dimensions',0),(545185,15145,'is','',0),(545186,15145,'dr','Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯ Ø¨Ø±Ø§ÛŒ ØªØºÛŒÛŒØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(545187,15145,'pr','Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯ Ø¨Ø±Ø§ÛŒ ØªØºÛŒÛŒØ± Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(545188,15145,'tr','DeÄŸiÅŸtirmek iÃ§in yeni bir ÅŸifre girin',0),(545189,15145,'pl','WprowadÅº nowe hasÅ‚o do zmiany',0),(545190,15145,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð²Ð°Ñ‚Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(545191,15145,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ù†ÛŒØ§ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(545192,15145,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ñƒ',0),(545193,15145,'vi','Nháº­p máº­t kháº©u má»›i Ä‘á»ƒ thay Ä‘á»•i',0),(545194,15145,'af','Tik die nuwe wagwoord te verander',0),(545195,15145,'ro','IntroduceÅ£i parola nouÄƒ la schimbare',0),(545196,15145,'et','Sisestage uue parooli muutmine',0),(545197,15145,'si','Vnesite novo geslo za spremembo',0),(545198,15145,'ba','Masukkan sandi baru untuk perubahan',0),(545199,15145,'nl','Geef een nieuw wachtwoord om te wijzigen',0),(545200,15145,'fi','Anna uusi salasana muutos',0),(545201,15145,'no','Skriv inn nytt passord endring',0),(545202,15145,'da','Indtast ny adgangskode til Ã¦ndring',0),(545203,15145,'ko','ë³€ê²½ í•˜ë ¤ë©´ ìƒˆ ì•”í˜¸ ìž…ë ¥',0),(545204,15145,'he','×”×–×Ÿ ××ª ×”×¡×™×¡×ž×” ×”×—×“×©×” ×œ×©×™× ×•×™',0),(545205,15145,'el','Î•Î¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ Î½Î­Î¿ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÏƒÏ„Î·Î½ Î±Î»Î»Î±Î³Î®',0),(545206,15145,'zh','è¾“å…¥æ–°å¯†ç ï¼Œä»¥æ›´æ”¹',0),(545207,15145,'sv','Ange nytt lÃ¶senord till fÃ¶rÃ¤ndring',0),(545208,15145,'it','Immettere la nuova Password al cambiamento',0),(545209,15145,'tl','',0),(545210,15145,'th','à¸›à¹‰à¸­à¸™à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¹ƒà¸«à¸¡à¹ˆà¹€à¸žà¸·à¹ˆà¸­à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(545211,15145,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¯à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(545212,15145,'ms','Masukkan kata laluan baru untuk perubahan',0),(545213,15145,'ar','Ø£Ø¯Ø®Ù„ ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ù„Ù„ØªØºÙŠÙŠØ±',0),(545214,15145,'fr','Entrez le nouveau mot de passe au changement',0),(545215,15145,'jp','å¤‰æ›´ã«æ–°ã—ã„ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(545216,15145,'pt','Digite a nova senha para a mudanÃ§a',0),(545217,15145,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ Ð´Ð»Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(545218,15145,'es','Introduzca la nueva contraseÃ±a para el cambio',0),(545219,15145,'de','Neue Passwort Ã¤ndern',0),(545220,15145,'en','Enter New Password To Change',0),(545221,15146,'is','',0),(545222,15146,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø³Ø·Ø­ Ø¨Ø±Ø§ÛŒ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¨Ù‡ Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(545223,15146,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø³Ø·Ø­ Ø¨Ø±Ø§ÛŒ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¨Ù‡ Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(545224,15146,'tr','Teklife eklemek iÃ§in dÃ¼z tutar',0),(545225,15146,'pl','Kwota zryczaÅ‚towana, aby dodaÄ‡ do oferty',0),(545226,15146,'bg','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ð° ÑÑƒÐ¼Ð° Ð·Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ ÐºÑŠÐ¼ Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð°',0),(545227,15146,'ur','ÙÙ„ÛŒÙ¹ Ø±Ù‚Ù… Ø³Û’ Ø§Ù‚ØªØ¨Ø§Ø³ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(545228,15146,'sr','Ð Ð°Ð²Ð°Ð½ Ð¸Ð·Ð½Ð¾Ñ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(545229,15146,'vi','CÄƒn há»™ sá»‘ tiá»n Ä‘á»ƒ thÃªm vÃ o bÃ¡o giÃ¡',0),(545230,15146,'af','Plat bedrag te voeg tot die aanhaling',0),(545231,15146,'ro','Suma de plat pentru a adÄƒuga la citat',0),(545232,15146,'et','Kindla summa lisamiseks Quote',0),(545233,15146,'si','Ravno znesek priÅ¡teti v citat',0),(545234,15146,'ba','Jumlah datar untuk menambahkan kutipan',0),(545235,15146,'nl','Platte bedrag toevoegen aan offerte',0),(545236,15146,'fi','KiinteÃ¤ summa lisÃ¤Ã¤ lainaus',0),(545237,15146,'no','Flat belÃ¸pet til Ã¥ sitere',0),(545238,15146,'da','Flad belÃ¸b til at fÃ¸je til tilbud',0),(545239,15146,'ko','í‰ë©´ ê¸ˆì•¡ ê²¬ì ì„ ì¶”ê°€ í•˜ë ¤ë©´',0),(545240,15146,'he','×›×ž×•×ª ×©×˜×•×— ×›×“×™ ×œ×”×•×¡×™×£ ×”×¦×¢×ª ×ž×—×™×¨',0),(545241,15146,'el','Î•Ï€Î¯Ï€ÎµÎ´Î· Ï€Î¿ÏƒÏŒ Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÏƒÏ„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(545242,15146,'zh','è‹¥è¦æ·»åŠ å¼•ç”¨çš„å›ºå®šé‡‘é¢',0),(545243,15146,'sv','Platt summa att lÃ¤gga till citat',0),(545244,15146,'it','Piatto quantitÃ  da aggiungere al preventivo',0),(545245,15146,'tl','',0),(545246,15146,'th','à¸¢à¸­à¸”à¹à¸šà¸™à¹€à¸žà¸·à¹ˆà¸­à¹€à¸žà¸´à¹ˆà¸¡à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(545247,15146,'hi','à¤«à¥à¤²à¥ˆà¤Ÿ à¤°à¤¾à¤¶à¤¿ à¤‰à¤¦à¥à¤§à¥ƒà¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(545248,15146,'ms','Jumlah yang rata untuk menambah kepada sebut harga',0),(545249,15146,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø´Ù‚Ø© Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(545250,15146,'fr','Montant fixe pour ajouter au devis',0),(545251,15146,'jp','å¹³ã‚‰ãªé‡ã®è¦‹ç©ã‚‚ã‚Šã‚’è¿½åŠ ã™ã‚‹ã«ã¯',0),(545252,15146,'pt','Valor fixo para adicionar Ã  cotaÃ§Ã£o',0),(545253,15146,'ru','ÐŸÐ»Ð¾ÑÐºÐ¸Ðµ ÑÑƒÐ¼Ð¼Ð° Ð´Ð»Ñ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(545254,15146,'es','Cantidad fija para agregar a cotizaciÃ³n',0),(545255,15146,'de','Pauschalbetrag Zitat hinzu',0),(545256,15146,'en','Flat Amount To Add To Quote',0),(545257,15147,'is','',0),(545258,15147,'dr','Ø­Ø¯Ø§Ú©Ø«Ø± ÙˆØ²Ù†',0),(545259,15147,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± ÙˆØ²Ù†',0),(545260,15147,'tr','Max kutu aÄŸÄ±rlÄ±ÄŸÄ±',0),(545261,15147,'pl','Max masa opakowania',0),(545262,15147,'bg','ÐœÐ°ÐºÑ ÐºÑƒÑ‚Ð¸Ñ Ñ‚ÐµÐ³Ð»Ð¾',0),(545263,15147,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø®Ø§Ù†Û ÙˆØ²Ù†',0),(545264,15147,'sr','ÐœÐ°x ÐºÑƒÑ‚Ð¸Ñ˜Ð° Ñ‚ÐµÐ¶Ð¸Ð½Ð°',0),(545265,15147,'vi','Trá»ng lÆ°á»£ng tá»‘i Ä‘a há»™p',0),(545266,15147,'af','Max boks gewig',0),(545267,15147,'ro','Greutate cutie Max',0),(545268,15147,'et','Max karbi kaal',0),(545269,15147,'si','Max teÅ¾a polje',0),(545270,15147,'ba','Berat maksimum kotak',0),(545271,15147,'nl','Max vak gewicht',0),(545272,15147,'fi','Ruutuun korkeintaan',0),(545273,15147,'no','Max for vekttap',0),(545274,15147,'da','Max boksens vÃ¦gt',0),(545275,15147,'ko','ìµœëŒ€ ìƒìž ë¬´ê²Œ',0),(545276,15147,'he','×ž×©×§×œ ×”×ª×™×‘×” Max',0),(545277,15147,'el','Max Î²Î¬ÏÎ¿Ï‚ ÎºÎ¿Ï…Ï„Î¯',0),(545278,15147,'zh','æœ€å¤§æ¯›é‡',0),(545279,15147,'sv','Max lÃ¥da, vikt',0),(545280,15147,'it','Peso scatola max',0),(545281,15147,'tl','',0),(545282,15147,'th','à¸™à¹‰à¸³à¸«à¸™à¸±à¸à¸à¸¥à¹ˆà¸­à¸‡à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(545283,15147,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤¬à¥‰à¤•à¥à¤¸ à¤µà¤œà¤¨',0),(545284,15147,'ms','Berat maksimum Peti',0),(545285,15147,'ar','Ù…Ø§ÙƒØ³ Ù…Ø±Ø¨Ø¹ Ø§Ù„ÙˆØ²Ù†',0),(545286,15147,'fr','Max boÃ®te poids',0),(545287,15147,'jp','æœ€å¤§ãƒœãƒƒã‚¯ã‚¹é‡é‡',0),(545288,15147,'pt','Peso mÃ¡ximo da caixa',0),(545289,15147,'ru','ÐœÐ°ÐºÑ Ð²ÐµÑ ÐºÐ¾Ñ€Ð¾Ð±ÐºÐ¸',0),(545290,15147,'es','Peso mÃ¡ximo de la caja',0),(545291,15147,'de','Max Box-Gewicht',0),(545292,15147,'en','Max Box Weight',0),(545293,15148,'is','',0),(545294,15148,'dr','Ø¨Ø³ØªÙ‡ Ø¬Ø¯ÛŒØ¯ Ù¾Ø³ Ø§Ø² Ø§ÛŒÙ† ÙˆØ²Ù† Ù…Ø­Ø§Ø³Ø¨Ù‡',0),(545295,15148,'pr','Ø¨Ø³ØªÙ‡ Ø¬Ø¯ÛŒØ¯ Ù¾Ø³ Ø§Ø² Ø§ÛŒÙ† ÙˆØ²Ù† Ù…Ø­Ø§Ø³Ø¨Ù‡',0),(545296,15148,'tr','Bu aÄŸÄ±rlÄ±k sonra hesaplanan yeni paket',0),(545297,15148,'pl','Nowy pakiet obliczony po tej masy',0),(545298,15148,'bg','ÐÐ¾Ð²Ð° Ð¾Ð¿Ð°ÐºÐ¾Ð²ÐºÐ°, Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð° ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð° Ñ‚ÐµÐ³Ð»Ð¾',0),(545299,15148,'ur','Ø§Ø³ Ú©Û’ ÙˆØ²Ù† Ú©Û’ Ø¨Ø¹Ø¯ Ø­Ø³Ø§Ø¨ Ù†ÛŒØ§ Ù¾ÛŒÚ©Ø¬',0),(545300,15148,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð°ÐºÐµÑ‚ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð° Ð¿Ð¾ÑÐ»Ðµ Ð¾Ð²Ð°Ñ˜ Ñ‚ÐµÑ€ÐµÑ‚',0),(545301,15148,'vi','Má»›i gÃ³i tÃ­nh toÃ¡n sau nÃ y trá»ng lÆ°á»£ng',0),(545302,15148,'af','Nuwe pakket na hierdie gewig bereken',0),(545303,15148,'ro','Noul pachet calculate dupÄƒ aceastÄƒ greutate',0),(545304,15148,'et','PÃ¤rast kÃµnealuse massi arvutada uus pakett',0),(545305,15148,'si','Nov paket izraÄuna po tem teÅ¾e',0),(545306,15148,'ba','Paket baru yang dihitung setelah berat badan ini',0),(545307,15148,'nl','Nieuwe pakket berekend na dit gewicht',0),(545308,15148,'fi','Uuden paketin jÃ¤lkeen tÃ¤mÃ¤ paino',0),(545309,15148,'no','Ny pakke beregnet etter denne vekten',0),(545310,15148,'da','Ny pakke beregnet efter denne vÃ¦gt',0),(545311,15148,'ko','ì´ ë¬´ê²Œ í›„ ê³„ì‚° í•˜ëŠ” ìƒˆë¡œìš´ íŒ¨í‚¤ì§€',0),(545312,15148,'he','×”×—×‘×™×œ×” ×”×—×“×©×” ×ž×—×•×©×‘ ×œ××—×¨ ×”×ž×©×§×œ ×”×–×”',0),(545313,15148,'el','ÎÎ­Î¿ Ï€Î±ÎºÎ­Ï„Î¿ Ï€Î¿Ï… Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶ÎµÏ„Î±Î¹ Î¼Îµ Î±Ï…Ï„ÏŒ Î²Î¬ÏÎ¿Ï‚',0),(545314,15148,'zh','æ–°åŒ…åŽè¿™ä¸ªé‡é‡è®¡ç®—',0),(545315,15148,'sv','Nytt paket berÃ¤knas efter denna vikt',0),(545316,15148,'it','Nuovo pacchetto calcolato dopo questo peso',0),(545317,15148,'tl','',0),(545318,15148,'th','à¹à¸žà¸„à¹€à¸à¸ˆà¹ƒà¸«à¸¡à¹ˆà¸—à¸µà¹ˆà¸„à¸³à¸™à¸§à¸“à¸ˆà¸²à¸à¸™à¹‰à¸³à¸«à¸™à¸±à¸à¸™à¸µà¹‰',0),(545319,15148,'hi','à¤¨à¤ à¤ªà¥ˆà¤•à¥‡à¤œ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤‡à¤¸ à¤µà¤œà¤¨ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(545320,15148,'ms','Pakej baru yang dikira selepas berat badan',0),(545321,15148,'ar','Ø§Ù„Ø­Ø²Ù…Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© ØªØ­Ø³Ø¨ Ø¨Ø¹Ø¯ Ù‡Ø°Ø§ Ø§Ù„ÙˆØ²Ù†',0),(545322,15148,'fr','Nouveau forfait calculÃ© aprÃ¨s ce poids',0),(545323,15148,'jp','ã“ã®é‡é‡ã®å¾Œè¨ˆç®—ã•ã‚Œã‚‹æ–°ã—ã„ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸',0),(545324,15148,'pt','Novo pacote calculado apÃ³s este peso',0),(545325,15148,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð°ÐºÐµÑ‚, Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ñ‹Ð²Ð°ÐµÑ‚ÑÑ Ð¿Ð¾ÑÐ»Ðµ ÑÑ‚Ð¾Ð³Ð¾ Ð²ÐµÑÐ°',0),(545326,15148,'es','Nuevo paquete calculado despuÃ©s de este peso',0),(545327,15148,'de','Neues Paket nach Gewicht berechnet',0),(545328,15148,'en','New Package Calculated After This Weight',0),(545329,15149,'is','',0),(545330,15149,'dr','Ø¯Ø±ØµØ¯ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¨Ù‡ Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(545331,15149,'pr','Ø¯Ø±ØµØ¯ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¨Ù‡ Ù†Ù‚Ù„ Ù‚ÙˆÙ„',0),(545332,15149,'tr','Teklife eklemek iÃ§in yÃ¼zde',0),(545333,15149,'pl','Procent, aby dodaÄ‡ do oferty',0),(545334,15149,'bg','% Ð—Ð° Ð´Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ ÐºÑŠÐ¼ Ð¾Ñ„ÐµÑ€Ñ‚Ð°Ñ‚Ð°',0),(545335,15149,'ur','ÙÛŒØµØ¯ Ø³Û’ Ø§Ù‚ØªØ¨Ø§Ø³ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(545336,15149,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð´Ð¾Ð´Ð°Ð»Ð¸ Ñ†Ð¸Ñ‚Ð°Ñ‚',0),(545337,15149,'vi','Pháº§n trÄƒm Ä‘á»ƒ thÃªm vÃ o bÃ¡o giÃ¡',0),(545338,15149,'af','Persent te voeg tot die aanhaling',0),(545339,15149,'ro','La sutÄƒ pentru a adÄƒuga la oferta',0),(545340,15149,'et','Protsenti, et lisada hinnapakkumine',0),(545341,15149,'si','Odstotkov dodati citat',0),(545342,15149,'ba','Persen untuk menambahkan kutipan',0),(545343,15149,'nl','Procent toe te voegen aan een offerte',0),(545344,15149,'fi','Prosenttia lisÃ¤Ã¤ lainaus',0),(545345,15149,'no','Prosent til Legg til tilbud',0),(545346,15149,'da','Procent til at fÃ¸je til tilbud',0),(545347,15149,'ko','ê²¬ì ì„ ì¶”ê°€ í•˜ë ¤ë©´ %',0),(545348,15149,'he','××—×•×– ×›×“×™ ×œ×”×•×¡×™×£ ×”×¦×¢×ª ×ž×—×™×¨',0),(545349,15149,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Î³Î¹Î± Î½Î± Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÏƒÏ„Î¿ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ¼Î±',0),(545350,15149,'zh','%å°†æ·»åŠ åˆ°æŠ¥ä»·',0),(545351,15149,'sv','Procent att lÃ¤gga till citat',0),(545352,15149,'it','Per cento per aggiungere al preventivo',0),(545353,15149,'tl','',0),(545354,15149,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¹ƒà¸™à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(545355,15149,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤‰à¤¦à¥à¤§à¥ƒà¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(545356,15149,'ms','Peratus untuk menambah kepada sebut harga',0),(545357,15149,'ar','ÙÙŠ Ø§Ù„Ù…Ø¦Ø© Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ø¹Ø±Ø¶ Ø§Ù„Ø£Ø³Ø¹Ø§Ø±',0),(545358,15149,'fr','Pour cent Ã  ajouter au devis',0),(545359,15149,'jp','ãƒ‘ãƒ¼ã‚»ãƒ³ãƒˆã®å¼•ç”¨ã‚’è¿½åŠ ã™ã‚‹ã«ã¯',0),(545360,15149,'pt','Por cento para adicionar Ã  cotaÃ§Ã£o',0),(545361,15149,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð´Ð»Ñ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ñ†Ð¸Ñ‚Ð°Ñ‚Ñ‹',0),(545362,15149,'es','Por ciento para agregar a cotizaciÃ³n',0),(545363,15149,'de','Prozent Quote hinzu',0),(545364,15149,'en','Percent To Add To Quote',0),(545365,15150,'is','',0),(545366,15150,'dr','Ø¨Ø§Ø² Ú©Ø±Ø¯Ù† Ø¯Ø± Ø²Ø¨Ø§Ù†Ù‡ Ø¬Ø¯ÛŒØ¯',0),(545367,15150,'pr','Ø¨Ø§Ø² Ú©Ø±Ø¯Ù† Ø¯Ø± Ø²Ø¨Ø§Ù†Ù‡ Ø¬Ø¯ÛŒØ¯',0),(545368,15150,'tr','Yeni sekmede aÃ§',0),(545369,15150,'pl','OtwÃ³rz w nowej karcie',0),(545370,15150,'bg','ÐžÑ‚Ð²Ð°Ñ€ÑÐ½Ðµ Ð² Ð½Ð¾Ð² Ñ€Ð°Ð·Ð´ÐµÐ»',0),(545371,15150,'ur','Ù†Ø¦ÛŒ Ù¹ÛŒØ¨ Ù…ÛŒÚº Ú©Ú¾ÙˆÙ„ÛŒÚº',0),(545372,15150,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸ Ð½Ð° Ð½Ð¾Ð²Ð¾Ñ˜ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¸',0),(545373,15150,'vi','Má»Ÿ trong Tab má»›i',0),(545374,15150,'af','Open In nuwe duimgids',0),(545375,15150,'ro','Deschidere Ã®n filÄƒ nouÄƒ',0),(545376,15150,'et','Ava uuel vahekaardil',0),(545377,15150,'si','Odpri v novem zavihku',0),(545378,15150,'ba','Buka di Tab Baru',0),(545379,15150,'nl','Open In nieuw tabblad',0),(545380,15150,'fi','Avaa uudessa vÃ¤lilehdessÃ¤',0),(545381,15150,'no','Ã…pne i ny fane',0),(545382,15150,'da','Ã…bn i nyt faneblad',0),(545383,15150,'ko','ìƒˆ íƒ­ì—ì„œ ì—´ê¸°',0),(545384,15150,'he','×¤×ª×— ×‘×œ×©×•× ×™×ª ×—×“×©×”',0),(545385,15150,'el','Î‘Î½Î¿Î¯Î³Ï‰ Î¼Î­ÏƒÎ± ÎºÎ±Î¹Î½Î¿ÏÏÎ³Î¹Î¿Ï‚ ÎµÏ„Î¹ÎºÎ­Ï„Î±',0),(545386,15150,'zh','åœ¨æ–°é€‰é¡¹å¡ä¸­æ‰“å¼€',0),(545387,15150,'sv','Ã–ppna i ny flik',0),(545388,15150,'it','Apri In nuova scheda',0),(545389,15150,'tl','',0),(545390,15150,'th','à¹€à¸›à¸´à¸”à¹ƒà¸™à¹à¸—à¹‡à¸šà¹ƒà¸«à¸¡à¹ˆ',0),(545391,15150,'hi','à¤¨à¤ à¤Ÿà¥ˆà¤¬ à¤®à¥‡à¤‚ à¤–à¥‹à¤²à¥‡à¤‚',0),(545392,15150,'ms','Terbuka dalam Tab baru',0),(545393,15150,'ar','ÙØªØ­ ÙÙŠ Ø¹Ù„Ø§Ù…Ø© ØªØ¨ÙˆÙŠØ¨ Ø¬Ø¯ÙŠØ¯Ø©',0),(545394,15150,'fr','Ouvrir dans un nouvel onglet',0),(545395,15150,'jp','æ–°ã—ã„ã‚¿ãƒ–ã§é–‹ã',0),(545396,15150,'pt','Abrir em nova aba',0),(545397,15150,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚ÑŒ Ð² Ð½Ð¾Ð²Ð¾Ð¹ Ð²ÐºÐ»Ð°Ð´ÐºÐµ',0),(545398,15150,'es','Abrir en una pestaÃ±a nueva',0),(545399,15150,'de','In neuem Tab Ã¶ffnen',0),(545400,15150,'en','Open In New Tab',0),(545401,15151,'is','',0),(545402,15151,'dr','Ø§Ø±ØªÙØ§Ø¹ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(545403,15151,'pr','Ø§Ø±ØªÙØ§Ø¹ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(545404,15151,'tr','Nakliye yÃ¼ksekliÄŸi',0),(545405,15151,'pl','WysyÅ‚ka wysokoÅ›Ä‡',0),(545406,15151,'bg','Ð’Ð¸ÑÐ¾Ñ‡Ð¸Ð½Ð° Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(545407,15151,'ur','Ø§ÙˆÙ†Ú†Ø§Ø¦ÛŒ Ø´Ù¾Ù†Ú¯',0),(545408,15151,'sr','Ð’Ð¸ÑÐ¸Ð½Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(545409,15151,'vi','Váº­n chuyá»ƒn chiá»u cao',0),(545410,15151,'af','Hoogte gestuur',0),(545411,15151,'ro','ÃŽnÄƒlÅ£imea de transport maritim',0),(545412,15151,'et','Laevanduse kÃµrgus',0),(545413,15151,'si','Dostava viÅ¡ina',0),(545414,15151,'ba','Pengiriman tinggi',0),(545415,15151,'nl','Verzending hoogte',0),(545416,15151,'fi','Kuljetuksen korkeus',0),(545417,15151,'no','Frakt hÃ¸yde',0),(545418,15151,'da','Shipping hÃ¸jde',0),(545419,15151,'ko','ì„ ì  ë†’ì´',0),(545420,15151,'he','×ž×©×œ×•×— ×’×•×‘×”',0),(545421,15151,'el','ÎŽÏˆÎ¿Ï‚ Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(545422,15151,'zh','èˆªè¿é«˜åº¦',0),(545423,15151,'sv','Frakt hÃ¶jd',0),(545424,15151,'it','Altezza di trasporto',0),(545425,15151,'tl','',0),(545426,15151,'th','à¸„à¸§à¸²à¸¡à¸ªà¸¹à¸‡à¸ªà¹ˆà¸‡',0),(545427,15151,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤Šà¤à¤šà¤¾à¤ˆ',0),(545428,15151,'ms','Penghantaran ketinggian',0),(545429,15151,'ar','Ø°Ø±ÙˆØ© Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ',0),(545430,15151,'fr','Hauteur d\'expÃ©dition',0),(545431,15151,'jp','é«˜ã•ã‚’å‡ºè·',0),(545432,15151,'pt','Altura de transporte',0),(545433,15151,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð²Ñ‹ÑÐ¾Ñ‚Ð°',0),(545434,15151,'es','Altura de envÃ­o',0),(545435,15151,'de','Versand-HÃ¶he',0),(545436,15151,'en','Shipping Height',0),(545437,15152,'is','',0),(545438,15152,'dr','Ø·ÙˆÙ„ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(545439,15152,'pr','Ø·ÙˆÙ„ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(545440,15152,'tr','Nakliye uzunluÄŸu',0),(545441,15152,'pl','DÅ‚ugoÅ›Ä‡ wysyÅ‚ki',0),(545442,15152,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð½Ð° Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(545443,15152,'ur','Ø¬ÛØ§Ø² Ø±Ø§Ù†ÛŒ Ú©ÛŒ Ù„Ù…Ø¨Ø§Ø¦ÛŒ',0),(545444,15152,'sr','Ð”ÑƒÐ¶Ð¸Ð½Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(545445,15152,'vi','Váº­n chuyá»ƒn chiá»u dÃ i',0),(545446,15152,'af','Lengte gestuur',0),(545447,15152,'ro','Lungime de transport maritim',0),(545448,15152,'et','MeresÃµidu pikkuse',0),(545449,15152,'si','DolÅ¾ina ladijskega prometa',0),(545450,15152,'ba','Pengiriman panjang',0),(545451,15152,'nl','Verzending lengte',0),(545452,15152,'fi','LÃ¤hetyksen pituus',0),(545453,15152,'no','Frakt lengde',0),(545454,15152,'da','Shipping lÃ¦ngde',0),(545455,15152,'ko','ì„ ë°• ê¸¸ì´',0),(545456,15152,'he','×ž×©×œ×•×— ××•×¨×š',0),(545457,15152,'el','ÎœÎ®ÎºÎ¿Ï‚ Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(545458,15152,'zh','èˆ¹èˆ¶é•¿åº¦',0),(545459,15152,'sv','Frakt lÃ¤ngd',0),(545460,15152,'it','Lunghezza di spedizione',0),(545461,15152,'tl','',0),(545462,15152,'th','à¸„à¸§à¸²à¸¡à¸¢à¸²à¸§à¸‚à¸­à¸‡à¸‚à¸™à¸ªà¹ˆà¸‡',0),(545463,15152,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤²à¤‚à¤¬à¤¾à¤ˆ',0),(545464,15152,'ms','Tempoh penghantaran',0),(545465,15152,'ar','Ø·ÙˆÙ„ Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ',0),(545466,15152,'fr','Longueur de livraison',0),(545467,15152,'jp','é•·ã•ã‚’å‡ºè·',0),(545468,15152,'pt','Comprimento de transporte',0),(545469,15152,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð»Ð¸Ð½Ð°',0),(545470,15152,'es','Longitud de envÃ­o',0),(545471,15152,'de','Versand-LÃ¤nge',0),(545472,15152,'en','Shipping Length',0),(545473,15153,'is','',0),(545474,15153,'dr','Ø¹Ø±Ø¶ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(545475,15153,'pr','Ø¹Ø±Ø¶ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(545476,15153,'tr','Nakliye geniÅŸliÄŸi',0),(545477,15153,'pl','SzerokoÅ›Ä‡ wysyÅ‚ki',0),(545478,15153,'bg','Ð¨Ð¸Ñ€Ð¸Ð½Ð° Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(545479,15153,'ur','Ú†ÙˆÚ‘Ø§Ø¦ÛŒ Ø´Ù¾Ù†Ú¯',0),(545480,15153,'sr','Ð¨Ð¸Ñ€Ð¸Ð½Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(545481,15153,'vi','Chiá»u rá»™ng váº­n chuyá»ƒn',0),(545482,15153,'af','Breedte gestuur',0),(545483,15153,'ro','Transport lÄƒÅ£ime',0),(545484,15153,'et','Laevanduse laius',0),(545485,15153,'si','Å irina ladijskega prometa',0),(545486,15153,'ba','Pengiriman lebar',0),(545487,15153,'nl','Verzendkosten breedte',0),(545488,15153,'fi','Kuljetuksen leveys',0),(545489,15153,'no','Frakt bredde',0),(545490,15153,'da','Shipping bredde',0),(545491,15153,'ko','ì„ ì  í­',0),(545492,15153,'he','×ž×©×œ×•×— ×¨×•×—×‘',0),(545493,15153,'el','Î Î»Î¬Ï„Î¿Ï‚ Î½Î±Ï…Ï„Î¹Î»Î¯Î±',0),(545494,15153,'zh','èˆªè¿å®½åº¦',0),(545495,15153,'sv','Frakt bredd',0),(545496,15153,'it','Larghezza di trasporto',0),(545497,15153,'tl','',0),(545498,15153,'th','à¸„à¸§à¸²à¸¡à¸à¸§à¹‰à¸²à¸‡à¹ƒà¸™à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(545499,15153,'hi','à¤¨à¥Œà¤µà¤¹à¤¨ à¤šà¥Œà¤¡à¤¼à¤¾à¤ˆ',0),(545500,15153,'ms','Penghantaran Kelebaran',0),(545501,15153,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø´Ø­Ù†',0),(545502,15153,'fr','Largeur de transport maritime',0),(545503,15153,'jp','é…é€å¹…',0),(545504,15153,'pt','Largura de transporte',0),(545505,15153,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑˆÐ¸Ñ€Ð¸Ð½Ð°',0),(545506,15153,'es','Anchura de envÃ­o',0),(545507,15153,'de','Versand-Breite',0),(545508,15153,'en','Shipping Width',0),(545509,15154,'is','',0),(545510,15154,'dr','2 Ø±ÙˆØ² Ù‡ÙˆØ§ÛŒÛŒ',0),(545511,15154,'pr','2 Ø±ÙˆØ² Ù‡ÙˆØ§ÛŒÛŒ',0),(545512,15154,'tr','2 gÃ¼n hava',0),(545513,15154,'pl','2 dzieÅ„ powietrza',0),(545514,15154,'bg','2-Ñ€Ð¸ Ð´ÐµÐ½ Ð²ÑŠÐ·Ð´ÑƒÑ…',0),(545515,15154,'ur','Ø¯ÙˆØ³Ø±Ø§ Ø¯Ù† ÛÙˆØ§',0),(545516,15154,'sr','2 Ð´Ð°Ð½Ð° Ð°Ð²Ð¸Ð¾Ð½Ð¾Ð¼',0),(545517,15154,'vi','2 ngÃ y khÃ´ng',0),(545518,15154,'af','2de dag lug',0),(545519,15154,'ro','doua zi Air',0),(545520,15154,'et','2. pÃ¤ev Air',0),(545521,15154,'si','2. dan zraka',0),(545522,15154,'ba','2 hari Air',0),(545523,15154,'nl','2nd Day Air',0),(545524,15154,'fi','toinen pÃ¤ivÃ¤ Air',0),(545525,15154,'no','andre dag Air',0),(545526,15154,'da','2nd Day Air',0),(545527,15154,'ko','2 ì¼ í•­ê³µ',0),(545528,15154,'he','2 ×™×•× ××•×•×™×¨',0),(545529,15154,'el','2Î· Î±Î³Ï‰Î½Î¹ÏƒÏ„Î¹ÎºÎ® Air',0),(545530,15154,'zh','ç¬¬äºŒå¤©çš„ç©ºæ°”',0),(545531,15154,'sv','2 dag Air',0),(545532,15154,'it','2 Â° giorno aria',0),(545533,15154,'tl','',0),(545534,15154,'th','2 à¸§à¸±à¸™à¸­à¸²à¸à¸²à¸¨',0),(545535,15154,'hi','2 à¤¦à¤¿à¤µà¤¸ à¤¹à¤µà¤¾',0),(545536,15154,'ms','2 hari Penyaman',0),(545537,15154,'ar','Ø§Ù„ÙŠÙˆÙ… Ø§Ù„Ø«Ø§Ù†ÙŠ Ù„Ù„Ø·ÙŠØ±Ø§Ù†',0),(545538,15154,'fr','2e journÃ©e de l\'Air',0),(545539,15154,'jp','ç¬¬ 2 æ—¥ç›®ã®ç©ºæ°—',0),(545540,15154,'pt','2Âº ar de dia',0),(545541,15154,'ru','2-Ð¹ Ð´ÐµÐ½ÑŒ Ð²Ð¾Ð·Ð´ÑƒÑ…',0),(545542,15154,'es','2nd Day Air',0),(545543,15154,'de','2. Tag-Air',0),(545544,15154,'en','2nd Day Air',0),(545545,15155,'is','',0),(545546,15155,'dr','Ù…Ø´ØªØ±ÛŒ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ú©Ù‡ Ù…Ø±Ø¨ÙˆØ·',0),(545547,15155,'pr','Ù…Ø´ØªØ±ÛŒ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ú©Ù‡ Ù…Ø±Ø¨ÙˆØ·',0),(545548,15155,'tr','MÃ¼ÅŸteri veya satÄ±cÄ± alakalÄ± olduÄŸunda gÃ¶ster',0),(545549,15155,'pl','PokaÅ¼ odbiorcy lub dostawcy, gdy odpowiednie',0),(545550,15155,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ðµ ÑƒÐ¼ÐµÑÑ‚Ð½Ð¾',0),(545551,15155,'ur','Ú©Ø³Ù¹Ù…Ø± ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û Ø¬Ø¨ Ù…ØªØ¹Ù„Ù‚Û Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(545552,15155,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÐºÑƒÐ¿Ð°Ñ† Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ ÐºÐ°Ð´Ð° Ñ€ÐµÐ»ÐµÐ²Ð°Ð½Ñ‚Ð½Ðµ',0),(545553,15155,'vi','Hiá»ƒn thá»‹ khÃ¡ch hÃ ng hoáº·c nhÃ  cung cáº¥p khi cÃ³ liÃªn quan',0),(545554,15155,'af','KliÃ«nt of handelaar wanneer toepaslike toon',0),(545555,15155,'ro','AratÄƒ client sau de furnizor atunci cÃ¢nd relevante',0),(545556,15155,'et','NÃ¤ita kliendi vÃµi hankija kui tÃ¤htsus',0),(545557,15155,'si','PokaÅ¾i kupca ali dobavitelja, Äe je primerno',0),(545558,15155,'ba','Menunjukkan pelanggan atau Vendor bila relevan',0),(545559,15155,'nl','Toon klanten- of leverancierskaart wanneer relevante',0),(545560,15155,'fi','NÃ¤ytÃ¤ asiakkaan tai toimittajan tarvittaessa',0),(545561,15155,'no','Vis kunde eller leverandÃ¸r nÃ¥r relevante',0),(545562,15155,'da','Vis Debitor eller kreditor, nÃ¥r det er Relevant',0),(545563,15155,'ko','ê³ ê° ë˜ëŠ” ê³µê¸‰ ì—…ì²´ ê´€ë ¨ ëœ ê²½ìš° í‘œì‹œ',0),(545564,15155,'he','×”×¦×’ ×œ×§×•×— ××• ×¡×¤×§ ×‘×¢×ª ×”×¨×œ×•×•× ×˜×™×ª',0),(545565,15155,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€ÎµÎ»Î¬Ï„Î· Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®, Î±Î½Î±ÎºÏ„Î·Î¸Î­Î½Ï„Î±',0),(545566,15155,'zh','æ˜¾ç¤ºå®¢æˆ·æˆ–ä¾›åº”å•†æ—¶æœ‰å…³',0),(545567,15155,'sv','Visa kund- eller leverantÃ¶rskortet nÃ¤r relevanta',0),(545568,15155,'it','Visualizza il cliente o il fornitore quando pertinenti',0),(545569,15155,'tl','',0),(545570,15155,'th','à¹à¸ªà¸”à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²à¸«à¸£à¸·à¸­à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹€à¸¡à¸·à¹ˆà¸­à¸—à¸µà¹ˆà¹€à¸à¸µà¹ˆà¸¢à¸§à¸‚à¹‰à¸­à¸‡',0),(545571,15155,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤œà¤¬ à¤ªà¥à¤°à¤¾à¤¸à¤‚à¤—à¤¿à¤• à¤¦à¤¿à¤–à¤¾à¤à¤',0),(545572,15155,'ms','Menunjukkan pelanggan atau penjual apabila berkaitan',0),(545573,15155,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ Ø§Ù„Ù…ÙˆØ±Ø¯ Ø¹Ù†Ø¯ Ø°Ø§Øª Ø§Ù„ØµÙ„Ø©',0),(545574,15155,'fr','Voir l\'Ã©tablissement client ou fournisseur si nÃ©cessaire',0),(545575,15155,'jp','é¡§å®¢ã¾ãŸã¯ä»•å…¥å…ˆé–¢é€£ã™ã‚‹ã¨ãã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(545576,15155,'pt','Mostrar ao cliente ou fornecedor quando relevantes',0),(545577,15155,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°, ÐºÐ¾Ð³Ð´Ð° ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ',0),(545578,15155,'es','Mostrar al cliente o proveedor cuando proceda',0),(545579,15155,'de','Zeigen Sie Debitor oder Kreditor gegebenenfalls an',0),(545580,15155,'en','Show Customer Or Vendor When Relevant',0),(545581,15156,'is','',0),(545582,15156,'dr','Ù¾ÛŒØ±ÛŒ',0),(545583,15156,'pr','Ù¾ÛŒØ±ÛŒ',0),(545584,15156,'tr','YaÅŸlanma',0),(545585,15156,'pl','Starzenie siÄ™',0),(545586,15156,'bg','Ð¡Ñ‚Ð°Ñ€ÐµÐµÐ½Ðµ',0),(545587,15156,'ur','Ø®Ø³ØªÛ',0),(545588,15156,'sr','Ð¡Ñ‚Ð°Ñ€ÐµÑšÐ°',0),(545589,15156,'vi','LÃ£o hÃ³a',0),(545590,15156,'af','Veroudering',0),(545591,15156,'ro','ÃŽmbÄƒtrÃ¢nire',0),(545592,15156,'et','Vananemist',0),(545593,15156,'si','Staranje',0),(545594,15156,'ba','Penuaan',0),(545595,15156,'nl','Veroudering',0),(545596,15156,'fi','IkÃ¤Ã¤ntyminen',0),(545597,15156,'no','Aldring',0),(545598,15156,'da','Aging',0),(545599,15156,'ko','ë…¸í™”',0),(545600,15156,'he','×”×–×“×§× ×•×ª',0),(545601,15156,'el','Î“Î®ÏÎ±Î½ÏƒÎ·',0),(545602,15156,'zh','è€åŒ–',0),(545603,15156,'sv','Ã…ldrande',0),(545604,15156,'it','Invecchiamento',0),(545605,15156,'tl','',0),(545606,15156,'th','à¸­à¸²à¸¢à¸¸à¸«à¸™à¸µà¹‰',0),(545607,15156,'hi','à¤‰à¤®à¥à¤° à¤¬à¤¢à¤¼à¤¨à¥‡',0),(545608,15156,'ms','Penuaan',0),(545609,15156,'ar','Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø©',0),(545610,15156,'fr','Vieillissement',0),(545611,15156,'jp','é«˜é½¢åŒ–',0),(545612,15156,'pt','Envelhecimento',0),(545613,15156,'ru','Ð¡Ñ‚Ð°Ñ€ÐµÐ½Ð¸Ðµ',0),(545614,15156,'es','Envejecimiento',0),(545615,15156,'de','Alterung',0),(545616,15156,'en','Aging',0),(545617,15157,'is','',0),(545618,15157,'dr','3dcart ØªÙ…Ø¯ÛŒØ¯ Ø´Ø±Ø­ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(545619,15157,'pr','3dcart ØªÙ…Ø¯ÛŒØ¯ Ø´Ø±Ø­ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(545620,15157,'tr','BaÅŸarÄ±yla alÄ±nan aÃ§Ä±klamalarÄ± geniÅŸletilmiÅŸ 3dcart',0),(545621,15157,'pl','3dcart rozszerzone opisy Å¹rÃ³dÅ‚o pomyÅ›lnie',0),(545622,15157,'bg','3dcart Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¾ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ, Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(545623,15157,'ur','ØªÙˆØ³ÛŒØ¹ Ú©ÛŒ ØªØµØ±ÛŒØ­Ø§Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ø§Ø² Ú¯ÛŒØ± 3dcart',0),(545624,15157,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¿Ñ€Ð¾ÑˆÐ¸Ñ€ÐµÐ½Ð¸ Ð¾Ð¿Ð¸ÑÐ¸ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð¸ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(545625,15157,'vi','3dcart má»Ÿ rá»™ng mÃ´ táº£ láº¥y thÃ nh cÃ´ng',0),(545626,15157,'af','3dcart uitgebreide beskrywings suksesvol herwin',0),(545627,15157,'ro','3dcart extins descrieri adus cu succes',0),(545628,15157,'et','Laiendatud kirjelduse edukalt vÃ¤lja otsitud 3dcart',0),(545629,15157,'si','3dcart podaljÅ¡a opisi uspeÅ¡no pridobljene.',0),(545630,15157,'ba','3dcart diperpanjang Deskripsi diperoleh berhasil',0),(545631,15157,'nl','3dcart uitgebreid beschrijvingen ontvangen met succes',0),(545632,15157,'fi','3dcart laajennettu kuvaukset onnistui',0),(545633,15157,'no','3dcart utvidet beskrivelser vellykket',0),(545634,15157,'da','3dcart udvidet beskrivelser hentet med succes',0),(545635,15157,'ko','3dcart ì„¤ëª… ì„±ê³µì ìœ¼ë¡œ ê²€ìƒ‰ í™•ìž¥',0),(545636,15157,'he','3dcart ×ž×•×¨×—×‘×ª ×ª×™××•×¨×™× ×©××•×—×–×¨ ×‘×”×¦×œ×—×”',0),(545637,15157,'el','3dcart ÎµÏ€ÎµÎºÏ„Î±Î¸ÎµÎ¯ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚ Î±Î½Î±ÎºÏ„Î·Î¸ÎµÎ¯ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(545638,15157,'zh','3dcart æ‰©å±•æè¿°æˆåŠŸæ£€ç´¢',0),(545639,15157,'sv','3dcart Extended beskrivningar HÃ¤mtad framgÃ¥ngsrikt',0),(545640,15157,'it','3Dcart estese descrizioni Estratto con successo',0),(545641,15157,'tl','',0),(545642,15157,'th','3dcart à¸‚à¸¢à¸²à¸¢à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸—à¸µà¹ˆà¹€à¸£à¸µà¸¢à¸à¸ªà¸³à¹€à¸£à¹‡à¸ˆ',0),(545643,15157,'hi','à¤µà¤¿à¤µà¤°à¤£ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°à¤¿à¤¤ 3dcart',0),(545644,15157,'ms','3dcart yang diberikan huraian-huraian yang diambil berjaya',0),(545645,15157,'ar','3dcart Ø§Ù„Ù…ÙˆØ³Ø¹Ø© Ø£ÙˆØµØ§Ù Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(545646,15157,'fr','3Dcart Ã©tendu Descriptions extrait avec succÃ¨s',0),(545647,15157,'jp','æ­£å¸¸ã«å–å¾—ã•ã‚ŒãŸè¨˜è¿°ã®æ‹¡å¼µ 3dcart',0),(545648,15157,'pt','3Dcart estendido descriÃ§Ãµes obtidas com sucesso',0),(545649,15157,'ru','3dcart Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(545650,15157,'es','3DCart extendido descripciones obtenidas con Ã©xito',0),(545651,15157,'de','3dcart erweiterte Beschreibungen erfolgreich abgerufenen',0),(545652,15157,'en','3dcart Extended Descriptions Retrieved Successfully',0),(545653,15158,'is','',0),(545654,15158,'dr','3dcart Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(545655,15158,'pr','3dcart Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(545656,15158,'tr','3dcart iÃ§in deÄŸil satÄ±ÅŸ ayarlarÄ± baÅŸarÄ±yla alÄ±ndÄ±',0),(545657,15158,'pl','3dcart nie na sprzedaÅ¼ ustawienia ÅºrÃ³dÅ‚o pomyÅ›lnie',0),(545658,15158,'bg','3dcart Ð½Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(545659,15158,'ur','Ø³ÛŒÙ¹Ù†Ú¯ÙˆÚº Ú©Û’ Ù„ÛŒÛ’ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ø§Ø² Ú¯ÛŒØ± Ù†ÛÛŒÚº ÙØ±ÙˆØ®Øª 3dcart',0),(545660,15158,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð½Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(545661,15158,'vi','3dcart khÃ´ng cho cÃ i Ä‘áº·t bÃ¡n láº¥y thÃ nh cÃ´ng',0),(545662,15158,'af','3dcart nie vir verkoop instellings suksesvol herwin',0),(545663,15158,'ro','3dcart nu pentru setÄƒrile de vanzare adus cu succes',0),(545664,15158,'et','Eest mÃ¼Ã¼a seaded edukalt vÃ¤lja otsitud 3dcart',0),(545665,15158,'si','3dcart, ne za prodajo nastavitve uspeÅ¡no pridobljene.',0),(545666,15158,'ba','3dcart tidak untuk dijual pengaturan diperoleh berhasil',0),(545667,15158,'nl','3dcart niet voor verkoop instellingen ontvangen met succes',0),(545668,15158,'fi','3dcart ole myytÃ¤vÃ¤nÃ¤ asetuksille onnistui',0),(545669,15158,'no','3dcart ikke For salg innstillinger vellykket',0),(545670,15158,'da','3dcart ikke til salg indstillinger hentes med succes',0),(545671,15158,'ko','íŒë§¤ ì„¤ì • ì„±ê³µì ìœ¼ë¡œ ê²€ìƒ‰ í•˜ì§€ì— ëŒ€ í•œ 3dcart',0),(545672,15158,'he','3dcart ×œ× ×¢×‘×•×¨ ×”×’×“×¨×•×ª ×œ×ž×›×™×¨×” ×©××•×—×–×¨ ×‘×”×¦×œ×—×”',0),(545673,15158,'el','3dcart ÏŒÏ‡Î¹ Î³Î¹Î± Ï€ÏŽÎ»Î·ÏƒÎ· ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Î±Î½Î±ÎºÏ„Î·Î¸ÎµÎ¯ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(545674,15158,'zh','ä¸æ˜¯ä¸ºäº†é”€å”®è®¾ç½®æˆåŠŸæ£€ç´¢ 3dcart',0),(545675,15158,'sv','3dcart inte fÃ¶r fÃ¶rsÃ¤ljning instÃ¤llningar HÃ¤mtad framgÃ¥ngsrikt',0),(545676,15158,'it','3Dcart non per le impostazioni di vendita Estratto con successo',0),(545677,15158,'tl','',0),(545678,15158,'th','3dcart à¹„à¸¡à¹ˆà¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸à¸²à¸£à¸‚à¸²à¸¢à¸—à¸µà¹ˆà¸”à¸¶à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(545679,15158,'hi','3dcart à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤',0),(545680,15158,'ms','3dcart bukan untuk seting jualan yang diambil berjaya',0),(545681,15158,'ar','3dcart Ù„ÙŠØ³ Ù„Ù„Ø¨ÙŠØ¹ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø§Ø³ØªØ±Ø¯Ø§Ø¯Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(545682,15158,'fr','3Dcart pas pour les paramÃ¨tres de vente extrait avec succÃ¨s',0),(545683,15158,'jp','æ­£å¸¸ã«å–å¾—ã•ã‚ŒãŸè²©å£²è¨­å®šã®ãªã„ 3dcart',0),(545684,15158,'pt','3Dcart nÃ£o para configuraÃ§Ãµes de venda obtida com sucesso',0),(545685,15158,'ru','3dcart Ð½Ðµ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(545686,15158,'es','3DCart no para ajustes de venta obtenido con Ã©xito',0),(545687,15158,'de','3dcart nicht fÃ¼r Sale-Einstellungen erfolgreich abgerufenen',0),(545688,15158,'en','3dcart Not For Sale Settings Retrieved Successfully',0),(545689,15159,'is','',0),(545690,15159,'dr','Ø´Ø±Ø­ Ø·ÙˆÙ„Ø§Ù†ÛŒ Ø±Ø§ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart ÙˆØ§Ø±Ø¯',0),(545691,15159,'pr','Ø´Ø±Ø­ Ø·ÙˆÙ„Ø§Ù†ÛŒ Ø±Ø§ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart ÙˆØ§Ø±Ø¯',0),(545692,15159,'tr','GeniÅŸletilmiÅŸ aÃ§Ä±klamalar bu 3dcart deposundan almak',0),(545693,15159,'pl','Import opisy rozszerzone z tego sklepu 3dcart',0),(545694,15159,'bg','Ð’Ð½Ð¾ÑÐ½Ð¸ Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð¾Ñ‚ Ñ‚Ð¾Ð²Ð° 3dcart Ñ…Ñ€Ð°Ð½Ð¸Ð»Ð¸Ñ‰Ðµ',0),(545695,15159,'ur','ØªÙˆØ³ÛŒØ¹ Ú©ÛŒ ØªØµØ±ÛŒØ­Ø§Øª Ø§Ø³ 3dcart Ú©ÛŒ Ø¯Ú©Ø§Ù† Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(545696,15159,'sr','Ð£Ð²Ð¾Ð· Ð¿Ñ€Ð¾ÑˆÐ¸Ñ€ÐµÐ½Ð¸ Ð¾Ð¿Ð¸ÑÐ¸ Ð¸Ð· Ð¾Ð²Ð¾Ð³ 3Ð´Ñ†Ð°Ñ€Ñ‚ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð°',0),(545697,15159,'vi','Nháº­p mÃ´ táº£ má»Ÿ rá»™ng tá»« cá»­a hÃ ng 3dcart nÃ y',0),(545698,15159,'af','Voer uitgebreide beskrywings van hierdie 3dcart Winkel',0),(545699,15159,'ro','Importa descrieri extinse la acest magazin 3dcart',0),(545700,15159,'et','Laiendatud kirjelduste importimine see 3dcart pood',0),(545701,15159,'si','Uvoz razÅ¡irjenih opisih iz te shrambe 3dcart',0),(545702,15159,'ba','Impor Deskripsi diperpanjang dari toko 3dcart ini',0),(545703,15159,'nl','Uitgebreide beschrijvingen van deze winkel 3dcart importeren',0),(545704,15159,'fi','Laajennettu kuvaukset tuominen 3dcart Store',0),(545705,15159,'no','Importere lengre beskrivelser fra denne 3dcart butikken',0),(545706,15159,'da','Importere udvidede beskrivelser fra denne 3dcart butik',0),(545707,15159,'ko','ì´ 3dcartê°€ ê²Œì—ì„œ í™•ìž¥ëœ ì„¤ëª… ê°€ì ¸ì˜¤ê¸°',0),(545708,15159,'he','×™×™×‘×•× ×ž×•×¨×—×‘ ×ª×™××•×¨×™× ×ž×”×—× ×•×ª 3dcart',0),(545709,15159,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÎºÏ„ÎµÏ„Î±Î¼Î­Î½Î· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚ Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± 3dcart',0),(545710,15159,'zh','ä»Žè¿™ä¸ª 3dcart å­˜å‚¨å¯¼å…¥æ‰©å±•çš„è¯´æ˜Ž',0),(545711,15159,'sv','Importera utÃ¶kade beskrivningar frÃ¥n denna 3dcart butik',0),(545712,15159,'it','Importare descrizioni estese da questo negozio 3dcart',0),(545713,15159,'tl','',0),(545714,15159,'th','à¸™à¸³à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸ˆà¸²à¸à¸£à¹‰à¸²à¸™ 3dcart à¸™à¸µà¹‰',0),(545715,15159,'hi','à¤µà¤¿à¤¸à¥à¤¤à¥ƒà¤¤ à¤µà¤¿à¤µà¤°à¤£ à¤‡à¤¸ 3dcart à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨ à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(545716,15159,'ms','Mengimport penerangan lanjutan dari kedai 3dcart ini',0),(545717,15159,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£ÙˆØµØ§Ù Ø§Ù„Ù…ÙˆØ³Ø¹Ø© Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²Ù† 3dcart',0),(545718,15159,'fr','Importer des longues Descriptions de ce magasin de 3dcart',0),(545719,15159,'jp','æ‹¡å¼µã®èª¬æ˜Žã“ã® 3dcart ã‚¹ãƒˆã‚¢ã‹ã‚‰ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(545720,15159,'pt','ImportaÃ§Ã£o estendido descriÃ§Ãµes desta loja 3dcart',0),(545721,15159,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ð¹ Ð¸Ð· ÑÑ‚Ð¾Ð³Ð¾ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð° 3dcart',0),(545722,15159,'es','Importar descripciones ampliadas de esta tienda 3dcart',0),(545723,15159,'de','Importieren von erweiterten Beschreibungen aus diesem 3dcart-Speicher',0),(545724,15159,'en','Import Extended Descriptions From This 3dcart Store',0),(545725,15160,'is','',0),(545726,15160,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ú¯Ø³ØªØ±Ø¯Ù‡ ØªÙˆØµÛŒÙØŒ Ø§Ú¯Ø± Ù†Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(545727,15160,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ú¯Ø³ØªØ±Ø¯Ù‡ ØªÙˆØµÛŒÙØŒ Ø§Ú¯Ø± Ù†Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(545728,15160,'tr','Åžu anda ayarlanmÄ±ÅŸ GeniÅŸletilmiÅŸ aÃ§Ä±klamalar almak deÄŸilse',0),(545729,15160,'pl','PrzywÃ³z rozszerzone opisy, jeÅ›li nie obecnie zestaw',0),(545730,15160,'bg','Ð’Ð½Ð¾ÑÐ½Ð¸ Ñ€Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ, Ð°ÐºÐ¾ Ð½Ðµ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð°',0),(545731,15160,'ur','ØªÙˆØ³ÛŒØ¹ Ú©ÛŒ ØªØµØ±ÛŒØ­Ø§Øª Ø§Ú¯Ø± Ù†ÛÛŒÚºØŒ ØªÙˆ Ø§Ø³ ÙˆÙ‚Øª Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(545732,15160,'sr','Ð£Ð²Ð¾Ð· Ð¿Ñ€Ð¾ÑˆÐ¸Ñ€ÐµÐ½Ð¾Ð³ Ð¾Ð¿Ð¸ÑÐ° Ð°ÐºÐ¾ Ð½Ðµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(545733,15160,'vi','Nháº­p mÃ´ táº£ má»Ÿ rá»™ng náº¿u khÃ´ng hiá»‡n Ä‘ang thiáº¿t láº­p',0),(545734,15160,'af','Voer uitgebreide beskrywings, indien nie tans stel',0),(545735,15160,'ro','Descrieri extinse de import dacÄƒ nu este setat Ã®n prezent',0),(545736,15160,'et','Import laiendatud kirjelduse kui mitte praegu',0),(545737,15160,'si','Uvoz daljÅ¡e opise, Äe ne trenutno nastavljen',0),(545738,15160,'ba','Impor diperpanjang Deskripsi jika tidak saat ini ditetapkan',0),(545739,15160,'nl','Importeren van uitgebreide beschrijvingen als niet momenteel ingesteld',0),(545740,15160,'fi','Tuo laajennettu kuvauksia, jos sitÃ¤ ei ole mÃ¤Ã¤ritetty',0),(545741,15160,'no','Importere lengre beskrivelser om ikke konfigurert',0),(545742,15160,'da','Importere udvidede beskrivelser, hvis ikke indstillet',0),(545743,15160,'ko','í˜„ìž¬ ì„¤ì • ë˜ì§€ ì•Šì€ ê²½ìš° í™•ìž¥ ëœ ì„¤ëª… ê°€ì ¸ì˜¤ê¸°',0),(545744,15160,'he','×™×™×‘×•× ×ª×™××•×¨×™× ××¨×•×›×™× ×× ×œ× ×ž×•×’×“×¨×ª ×›×¢×ª',0),(545745,15160,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÎµÎºÏ„ÎµÏ„Î±Î¼Î­Î½ÎµÏ‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚, Î±Î½ Î´ÎµÎ½ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(545746,15160,'zh','å¯¼å…¥æ‰©å±•çš„è¯´æ˜Žï¼Œå¦‚æžœä¸æ˜¯å½“å‰è®¾ç½®',0),(545747,15160,'sv','Importera utÃ¶kade beskrivningar om inte fÃ¶r nÃ¤rvarande',0),(545748,15160,'it','Importare descrizioni estese, se non attualmente impostato',0),(545749,15160,'tl','',0),(545750,15160,'th','à¸™à¸³à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸–à¹‰à¸² à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸‚à¸“à¸°à¸™à¸µà¹‰',0),(545751,15160,'hi','à¤µà¤¿à¤¸à¥à¤¤à¥ƒà¤¤ à¤µà¤¿à¤µà¤°à¤£ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚ à¤¯à¤¦à¤¿ à¤¨à¤¹à¥€à¤‚ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(545752,15160,'ms','Import dilanjutkan penerangan jika tidak buat masa ini menetapkan',0),(545753,15160,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£ÙˆØµØ§Ù Ø§Ù„Ù…ÙˆØ³Ø¹Ø© Ø¥Ø°Ø§ Ù„Ù… ÙŠÙƒÙ† Ø­Ø§Ù„ÙŠØ§ ØªØ¹ÙŠÙŠÙ†',0),(545754,15160,'fr','Importer des Descriptions Ã©tendues si il n\'est pas actuellement dÃ©finie',0),(545755,15160,'jp','ç¾åœ¨è¨­å®šã•ã‚Œã¦ã„ãªã„å ´åˆæ‹¡å¼µã®èª¬æ˜Žã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(545756,15160,'pt','DescriÃ§Ãµes estendidas de importaÃ§Ã£o se nÃ£o definido',0),(545757,15160,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ð¹, ÐµÑÐ»Ð¸ Ð½Ðµ Ð² Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ',0),(545758,15160,'es','Importar descripciones ampliadas si no establecido actualmente',0),(545759,15160,'de','Erweiterte Beschreibungen zu importieren, wenn nicht derzeit eingestellt',0),(545760,15160,'en','Import Extended Descriptions If Not Currently Set',0),(545761,15161,'is','',0),(545762,15161,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart ØªÙ†Ø¸ÛŒÙ…Ø§Øª',0),(545763,15161,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart ØªÙ†Ø¸ÛŒÙ…Ø§Øª',0),(545764,15161,'tr','Al bu 3dcart maÄŸazadan SatÄ±lÄ±k ayarlarÄ± iÃ§in deÄŸil',0),(545765,15161,'pl','Importu nie na sprzedaÅ¼ ustawienia z tego sklepu 3dcart',0),(545766,15161,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ð½Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ 3dcart ÐœÐ°Ð³Ð°Ð·Ð¸Ð½',0),(545767,15161,'ur','ÛŒÛ 3dcart Ø§Ø³Ù¹ÙˆØ± Ø³Û’ ÙØ±ÙˆØ®Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ù†ÛÛŒÚº Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(545768,15161,'sr','Ð£Ð²Ð¾Ð· Ð½Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð¸Ð· Ð¾Ð²Ð¾Ð³ 3Ð´Ñ†Ð°Ñ€Ñ‚ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð°',0),(545769,15161,'vi','Nháº­p kháº©u khÃ´ng cho bÃ¡n cÃ i Ä‘áº·t tá»« cá»­a hÃ ng 3dcart nÃ y',0),(545770,15161,'af','Invoer nie vir verkoop instellings uit hierdie 3dcart Winkel',0),(545771,15161,'ro','De import nu pentru setÄƒrile de vÃ¢nzare de la acest magazin 3dcart',0),(545772,15161,'et','Import ei mÃ¼Ã¼gi sÃ¤tteid selles 3dcart poest',0),(545773,15161,'si','Uvoz ni za prodajo nastavitve iz te shrambe 3dcart',0),(545774,15161,'ba','Impor tidak untuk dijual pengaturan dari toko 3dcart ini',0),(545775,15161,'nl','Invoer niet voor verkoop instellingen van deze 3dcart winkel',0),(545776,15161,'fi','Tuo ei myynti asetukset 3dcart Store',0),(545777,15161,'no','Importer ikke For salg innstillinger fra denne 3dcart butikken',0),(545778,15161,'da','Importer ikke til salg indstillinger fra denne 3dcart butik',0),(545779,15161,'ko','ì´ 3dcartê°€ ê²Œì—ì„œ íŒë§¤ ì„¤ì • í•˜ì§€ ê°€ì ¸ì˜¤ê¸°',0),(545780,15161,'he','×™×™×‘×•× ×œ× ×¢×‘×•×¨ ×”×’×“×¨×•×ª ×œ×ž×›×™×¨×” ×ž×”×—× ×•×ª 3dcart',0),(545781,15161,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Î´ÎµÎ½ Î³Î¹Î± Ï€ÏŽÎ»Î·ÏƒÎ· ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± 3dcart',0),(545782,15161,'zh','ä¸æ˜¯ä¸ºäº†ä»Žè¿™ä¸ª 3dcart å•†åº—å‡ºå”®è®¾ç½®å¯¼å…¥',0),(545783,15161,'sv','Importera inte fÃ¶r fÃ¶rsÃ¤ljning instÃ¤llningar frÃ¥n denna 3dcart butik',0),(545784,15161,'it','Importazione non per vendita impostazioni da questo negozio 3dcart',0),(545785,15161,'tl','',0),(545786,15161,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸‚à¸²à¸¢à¸ˆà¸²à¸à¸£à¹‰à¸²à¸™ 3dcart à¸™à¸µà¹‰à¹„à¸¡à¹ˆ',0),(545787,15161,'hi','à¤¨à¤¹à¥€à¤‚ à¤‡à¤¸ 3dcart à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨ à¤¸à¥‡ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¯à¤¾à¤¤',0),(545788,15161,'ms','Import tidak untuk pengesetan jualan dari kedai 3dcart ini',0),(545789,15161,'ar','Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù„Ø§ Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø¨ÙŠØ¹ Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²Ù† 3dcart',0),(545790,15161,'fr','Importation pas pour vendre des paramÃ¨tres de ce magasin de 3dcart',0),(545791,15161,'jp','ã„ãªã„ã“ã® 3dcart ã‚¹ãƒˆã‚¢ã‹ã‚‰è²©å£²è¨­å®šã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(545792,15161,'pt','ImportaÃ§Ã£o nÃ£o para configuraÃ§Ãµes de venda da loja 3dcart',0),(545793,15161,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð½Ðµ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð¸Ð· ÑÑ‚Ð¾Ð³Ð¾ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð° 3dcart',0),(545794,15161,'es','ImportaciÃ³n no para ajustes de venta de la tienda 3dcart',0),(545795,15161,'de','Import nicht fÃ¼r Sale-Einstellungen aus diesem 3dcart-Speicher',0),(545796,15161,'en','Import Not For Sale Settings From This 3dcart Store',0),(545797,15162,'is','',0),(545798,15162,'dr','3dcart ØªÙˆØµÛŒÙØŒ Ø¨Ù‡ ØªÙ…Ø¯ÛŒØ¯ Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(545799,15162,'pr','3dcart ØªÙˆØµÛŒÙØŒ Ø¨Ù‡ ØªÙ…Ø¯ÛŒØ¯ Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(545800,15162,'tr','3dcart geniÅŸletilmiÅŸ aÃ§Ä±klamalar otomatik olarak gÃ¼ncelleÅŸtir',0),(545801,15162,'pl','Aktualizacja 3dcart automatycznie przedÅ‚uÅ¼ona opisy',0),(545802,15162,'bg','3dcart ÑƒÐ´ÑŠÐ»Ð¶ÐµÐ½ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°',0),(545803,15162,'ur','3dcart ØªÙˆØ³ÛŒØ¹ ØªØµØ±ÛŒØ­Ø§Øª Ú©ÛŒ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(545804,15162,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¿Ñ€Ð¾ÑˆÐ¸Ñ€ÐµÐ½Ð¾Ð³ Ð¾Ð¿Ð¸ÑÐ° Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸',0),(545805,15162,'vi','Cáº­p Nháº­t 3dcart má»Ÿ rá»™ng mÃ´ táº£ tá»± Ä‘á»™ng',0),(545806,15162,'af','3dcart uitgebreide beskrywings outomaties opdateer',0),(545807,15162,'ro','Actualizare 3dcart extins descrieri automat',0),(545808,15162,'et','Update 3dcart laiendatud kirjelduse automaatselt',0),(545809,15162,'si','3dcart posodobitev samodejno podaljÅ¡a opisi',0),(545810,15162,'ba','Memperbarui 3dcart diperpanjang Deskripsi secara otomatis',0),(545811,15162,'nl','Update 3dcart verlengd beschrijvingen automatisch',0),(545812,15162,'fi','PÃ¤ivitys 3dcart voimassaoloa kuvaukset',0),(545813,15162,'no','Oppdatere 3dcart automatisk forlenget beskrivelser',0),(545814,15162,'da','Opdater 3dcart udvidet beskrivelser automatisk',0),(545815,15162,'ko','3dcart í™•ìž¥ ì„¤ëª…ì„ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(545816,15162,'he','×¢×“×›×•×Ÿ 3dcart ×ž×•×¨×—×‘ ×ª×™××•×¨×™× ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(545817,15162,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart ÎµÏ€ÎµÎºÏ„Î±Î¸ÎµÎ¯ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î±',0),(545818,15162,'zh','æ›´æ–° 3dcart è‡ªåŠ¨æ‰©å±•è¯´æ˜Ž',0),(545819,15162,'sv','Uppdatera 3dcart Extended beskrivningar automatiskt',0),(545820,15162,'it','Aggiornamento 3dcart estese descrizioni automaticamente',0),(545821,15162,'tl','',0),(545822,15162,'th','à¸­à¸±à¸žà¹€à¸” 3dcart à¸‚à¸¢à¸²à¸¢à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(545823,15162,'hi','3dcart à¤µà¤¿à¤µà¤°à¤£ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°à¤¿à¤¤ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(545824,15162,'ms','Kemaskini Terakhir 3dcart diberikan penerangan secara automatik',0),(545825,15162,'ar','ØªØ­Ø¯ÙŠØ« 3dcart Ø§Ù„Ù…ÙˆØ³Ø¹Ø© Ø£ÙˆØµØ§Ù ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹',0),(545826,15162,'fr','3dcart mise Ã  jour des Descriptions de faÃ§on automatique',0),(545827,15162,'jp','3dcart ã®èª¬æ˜Žã‚’è‡ªå‹•çš„ã«æ‹¡å¼µã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(545828,15162,'pt','AtualizaÃ§Ã£o 3dcart estendido descriÃ§Ãµes automaticamente',0),(545829,15162,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart Ñ€Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸',0),(545830,15162,'es','ActualizaciÃ³n 3dcart extendido descripciones automÃ¡ticamente',0),(545831,15162,'de','Update 3dcart Beschreibungen automatisch verlÃ¤ngert',0),(545832,15162,'en','Update 3dcart Extended Descriptions Automatically',0),(545833,15163,'is','',0),(545834,15163,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ 3dcart Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø±',0),(545835,15163,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ 3dcart Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø±',0),(545836,15163,'tr','3dcart iÃ§in deÄŸil satÄ±ÅŸ ayarlarÄ±nÄ± gÃ¼ncelleÅŸtirme otomatik olarak',0),(545837,15163,'pl','Aktualizacja 3dcart nie na sprzedaÅ¼ ustawienia automatycznie',0),(545838,15163,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸ÑÑ‚Ð° 3dcart Ð½Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾',0),(545839,15163,'ur','3dcart Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº ÙØ±ÙˆØ®Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø®ÙˆØ¯Ú©Ø§Ø± Ø·ÙˆØ± Ù¾Ø±',0),(545840,15163,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð½Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸',0),(545841,15163,'vi','Cáº­p Nháº­t 3dcart khÃ´ng cho cÃ i Ä‘áº·t bÃ¡n tá»± Ä‘á»™ng',0),(545842,15163,'af','3dcart werk nie vir verkoop instellings outomaties',0),(545843,15163,'ro','Update 3dcart nu pentru vÃ¢nzare setÄƒrile automat',0),(545844,15163,'et','VÃ¤rskendus 3dcart ei mÃ¼Ã¼gi seaded automaatselt',0),(545845,15163,'si','Posodobitev 3dcart, ne za prodajo nastavitve samodejno',0),(545846,15163,'ba','Memperbarui 3dcart tidak untuk dijual pengaturan otomatis',0),(545847,15163,'nl','Update 3dcart niet voor verkoop instellingen automatisch',0);
INSERT INTO `langdef` VALUES (545848,15163,'fi','PÃ¤ivitÃ¤ 3dcart ole myytÃ¤vÃ¤nÃ¤ asetukset automaattisesti',0),(545849,15163,'no','Oppdatere 3dcart ikke For salg innstillinger automatisk',0),(545850,15163,'da','Opdatere 3dcart ikke til salg indstillinger automatisk',0),(545851,15163,'ko','3dcart íŒë§¤ ì„¤ì •ì„ í•˜ì§€ ì—…ë°ì´íŠ¸ ìžë™ìœ¼ë¡œ',0),(545852,15163,'he','×¢×“×›×•×Ÿ 3dcart ×œ× ×¢×‘×•×¨ ×”×’×“×¨×•×ª ×œ×ž×›×™×¨×” ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(545853,15163,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart ÏŒÏ‡Î¹ Î³Î¹Î± Ï€ÏŽÎ»Î·ÏƒÎ· ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î±',0),(545854,15163,'zh','æ›´æ–° 3dcart ä¸å‡ºå”®è®¾ç½®è‡ªåŠ¨',0),(545855,15163,'sv','Uppdatera 3dcart inte fÃ¶r fÃ¶rsÃ¤ljning-instÃ¤llningar automatiskt',0),(545856,15163,'it','Aggiornamento 3dcart non per vendita impostazioni automaticamente',0),(545857,15163,'tl','',0),(545858,15163,'th','à¸­à¸±à¸žà¹€à¸” 3dcart à¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆà¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸à¸²à¸£à¸‚à¸²à¸¢à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(545859,15163,'hi','3dcart à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤¨à¤¹à¥€à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡',0),(545860,15163,'ms','Kemaskini Terakhir 3dcart bukan untuk jualan seting secara automatik',0),(545861,15163,'ar','ØªØ­Ø¯ÙŠØ« 3dcart Ù„ÙŠØ³ Ù„Ù„Ø¨ÙŠØ¹ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹',0),(545862,15163,'fr','Mise Ã  jour 3dcart pas pour vendre les paramÃ¨tres automatiquement',0),(545863,15163,'jp','è²©å£²è¨­å®šã®ãªã„ 3dcart ã‚’æ›´æ–°è‡ªå‹•çš„ã«',0),(545864,15163,'pt','Atualizar 3dcart nÃ£o para venda configuraÃ§Ãµes automaticamente',0),(545865,15163,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart Ð½Ðµ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸',0),(545866,15163,'es','ActualizaciÃ³n 3dcart no para venta configuraciÃ³n automÃ¡ticamente',0),(545867,15163,'de','Update 3dcart nicht fÃ¼r Sale-Einstellungen automatisch',0),(545868,15163,'en','Update 3dcart Not For Sale Settings Automatically',0),(545869,15164,'is','',0),(545870,15164,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø®Ø· Ø¨Ø§Ù„Øº',0),(545871,15164,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø®Ø· Ø¨Ø§Ù„Øº',0),(545872,15164,'tr','SatÄ±r toplamlarÄ± gizlemek',0),(545873,15164,'pl','Ukrywanie sum wiersza',0),(545874,15164,'bg','Ð¡ÐºÑ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€ÐµÐ´ ÑÑƒÐ¼Ð¸',0),(545875,15164,'ur','Ù„Ø§Ø¦Ù† Ù…ÛŒØ²Ø§Ù† Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(545876,15164,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ñ€ÐµÐ´ Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(545877,15164,'vi','áº¨n tá»•ng sá»‘ dÃ²ng',0),(545878,15164,'af','Versteek lyn totale',0),(545879,15164,'ro','Ascunde linia totaluri',0),(545880,15164,'et','Peida rida kogusummad',0),(545881,15164,'si','Skrij vrstico vsote',0),(545882,15164,'ba','Sembunyikan baris Total',0),(545883,15164,'nl','Lijn totalen verbergen',0),(545884,15164,'fi','Piilottaa summat',0),(545885,15164,'no','Skjule linjetotaler',0),(545886,15164,'da','Skjule linjesummer',0),(545887,15164,'ko','ë¼ì¸ í•©ê³„ ìˆ¨ê¸°ê¸°',0),(545888,15164,'he','×œ×”×¡×ª×™×¨ ××ª ×©×•×¨×ª ×”×¡×›×•×ž×™×',0),(545889,15164,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ…Î½ÏŒÎ»Ï‰Î½',0),(545890,15164,'zh','éšè—è¡Œåˆè®¡',0),(545891,15164,'sv','DÃ¶lja radsummor',0),(545892,15164,'it','Nascondere la riga totali',0),(545893,15164,'tl','',0),(545894,15164,'th','à¸‹à¹ˆà¸­à¸™à¸œà¸¥à¸£à¸§à¸¡à¸£à¸²à¸¢à¸à¸²à¸£',0),(545895,15164,'hi','à¤¯à¥‹à¤— à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤›à¥à¤ªà¤¾à¤à¤',0),(545896,15164,'ms','Sembunyi jumlah talian',0),(545897,15164,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª Ø§Ù„Ø®Ø·',0),(545898,15164,'fr','Masquer des totaux de ligne',0),(545899,15164,'jp','è¡Œã®åˆè¨ˆã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(545900,15164,'pt','Esconder os totais de linha',0),(545901,15164,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚Ð¸Ðµ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð¸Ñ‚Ð¾Ð³Ð¾Ð²',0),(545902,15164,'es','Ocultar totales de lÃ­nea',0),(545903,15164,'de','Zeilensummen ausblenden',0),(545904,15164,'en','Hide Line Totals',0),(545905,15165,'is','',0),(545906,15165,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ù‚ÛŒÙ…Øª Ù‡Ø±',0),(545907,15165,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ù‚ÛŒÙ…Øª Ù‡Ø±',0),(545908,15165,'tr','Her fiyat gizle',0),(545909,15165,'pl','UkryÄ‡ ceny kaÅ¼dego',0),(545910,15165,'bg','Ð¡ÐºÑ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾Ð±Ñ€Ð° Ñ†ÐµÐ½Ð°',0),(545911,15165,'ur','ÛØ± Ù‚ÛŒÙ…Øª Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(545912,15165,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÑÐ²Ð°ÐºÑƒ Ñ†ÐµÐ½Ñƒ',0),(545913,15165,'vi','áº¨n giÃ¡ má»—i',0),(545914,15165,'af','Prys elke versteek',0),(545915,15165,'ro','Ascunde Pret fiecare',0),(545916,15165,'et','Peida hind iga',0),(545917,15165,'si','Skrij Cena vsakega',0),(545918,15165,'ba','Menyembunyikan harga masing-masing',0),(545919,15165,'nl','Prijs elke verbergen',0),(545920,15165,'fi','Piilota hinta',0),(545921,15165,'no','Skjule pris hver',0),(545922,15165,'da','Skjule pris hver',0),(545923,15165,'ko','ê°€ê²© ê° ìˆ¨ê¸°ê¸°',0),(545924,15165,'he','×œ×”×¡×ª×™×¨ ×‘×›×œ ×ž×—×™×¨',0),(545925,15165,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Ï„Î¹Î¼Î® ÎºÎ¬Î¸Îµ',0),(545926,15165,'zh','éšè—æ¯ä¸ªçš„ä»·æ ¼',0),(545927,15165,'sv','DÃ¶lja pris varje',0),(545928,15165,'it','Nascondere ogni prezzo',0),(545929,15165,'tl','',0),(545930,15165,'th','à¸‹à¹ˆà¸­à¸™à¸£à¸²à¸„à¸²à¹à¸•à¹ˆà¸¥à¸°',0),(545931,15165,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤®à¥‚à¤²à¥à¤¯ à¤›à¥à¤ªà¤¾à¤à¤',0),(545932,15165,'ms','Menyembunyikan harga setiap',0),(545933,15165,'ar','Ø¥Ø®ÙØ§Ø¡ Ø³Ø¹Ø± ÙƒÙ„',0),(545934,15165,'fr','Cacher les prix chaque',0),(545935,15165,'jp','ãã‚Œãžã‚Œã®ä¾¡æ ¼ã‚’è¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(545936,15165,'pt','Ocultar o preÃ§o de cada',0),(545937,15165,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ñ†ÐµÐ½Ñƒ ÐºÐ°Ð¶Ð´Ð¾Ð³Ð¾',0),(545938,15165,'es','Ocultar precio cada',0),(545939,15165,'de','Preis jedes ausblenden',0),(545940,15165,'en','Hide Price Each',0),(545941,15166,'is','',0),(545942,15166,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙˆØ²Ù† Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(545943,15166,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙˆØ²Ù† Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(545944,15166,'tr','AÄŸÄ±rlÄ±k miktarÄ± gÃ¶ster',0),(545945,15166,'pl','PokaÅ¼ iloÅ›Ä‡ masy',0),(545946,15166,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ‚ÐµÐ³Ð»Ð¾',0),(545947,15166,'ur','ÙˆØ²Ù† Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(545948,15166,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ Ñ‚ÐµÐ¶Ð¸Ð½Ð°',0),(545949,15166,'vi','Hiá»ƒn thá»‹ sá»‘ lÆ°á»£ng trá»ng lÆ°á»£ng',0),(545950,15166,'af','Hoeveelheid gewig wys',0),(545951,15166,'ro','AratÄƒ cantitatea de greutate',0),(545952,15166,'et','NÃ¤ita kogust kaal',0),(545953,15166,'si','PokaÅ¾i koliÄino teÅ¾e',0),(545954,15166,'ba','Tampilkan jumlah berat',0),(545955,15166,'nl','Toon hoeveelheid gewicht',0),(545956,15166,'fi','NÃ¤ytÃ¤ mÃ¤Ã¤rÃ¤ paino',0),(545957,15166,'no','Vis antall vekt',0),(545958,15166,'da','Vis mÃ¦ngde vÃ¦gt',0),(545959,15166,'ko','í‘œì‹œ ìˆ˜ëŸ‰ ë¬´ê²Œ',0),(545960,15166,'he','×”×¦×’ ××ª ×›×ž×•×ª ×”×ž×©×§×œ',0),(545961,15166,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î²Î¬ÏÎ¿Ï‚',0),(545962,15166,'zh','æ˜¾ç¤ºæ•°é‡é‡é‡',0),(545963,15166,'sv','Visa kvantitet vikt',0),(545964,15166,'it','Visualizza la peso di quantitÃ ',0),(545965,15166,'tl','',0),(545966,15166,'th','à¹à¸ªà¸”à¸‡à¸›à¸£à¸´à¸¡à¸²à¸“à¸™à¹‰à¸³à¸«à¸™à¸±à¸',0),(545967,15166,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤µà¤œà¤¨ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(545968,15166,'ms','Menunjukkan kuantiti berat',0),(545969,15166,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙƒÙ…ÙŠØ© Ø§Ù„ÙˆØ²Ù†',0),(545970,15166,'fr','Voir la quantitÃ© de poids',0),(545971,15166,'jp','é‡ã®é‡é‡ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(545972,15166,'pt','Mostrar a peso de quantidade',0),(545973,15166,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð²ÐµÑ',0),(545974,15166,'es','Mostrar cantidad peso',0),(545975,15166,'de','Karte Menge Gewicht',0),(545976,15166,'en','Show Quantity Weight',0),(545977,15167,'is','',0),(545978,15167,'dr','ØªÙ‚Ø³ÛŒÙ… Ú©Ø¯ Ú©Ø§Ù„Ø§ & ØªÙˆØ¶ÛŒØ­Ø§Øª',0),(545979,15167,'pr','ØªÙ‚Ø³ÛŒÙ… Ú©Ø¯ Ú©Ø§Ù„Ø§ & ØªÙˆØ¶ÛŒØ­Ø§Øª',0),(545980,15167,'tr','Madde kodu & aÃ§Ä±klamasÄ± bÃ¶lme',0),(545981,15167,'pl','PodzieliÄ‡ kod towaru & opis',0),(545982,15167,'bg','Ð Ð°Ð·Ð´ÐµÐ»Ð¸ ÐºÐ¾Ð´ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ» & Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(545983,15167,'ur','Ø´Û’ Ú©ÙˆÚˆ & Ø¨ÛŒØ§Ù† Ø§Ù„Ú¯ Ú©Ø±ÛŒÚº',0),(545984,15167,'sr','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚Ðµ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¸ Ð¾Ð¿Ð¸Ñ',0),(545985,15167,'vi','TÃ¡ch cÃ¡c má»¥c mÃ£ & mÃ´ táº£',0),(545986,15167,'af','Verdeel die Item kode & Beskrywing',0),(545987,15167,'ro','Split cod articol & Descriere',0),(545988,15167,'et','TÃ¼kelda kaubakood & kirjeldus',0),(545989,15167,'si','Å ifra artikla & opis po delih',0),(545990,15167,'ba','Membagi kode barang & Deskripsi',0),(545991,15167,'nl','Split de artikelcode & beschrijving',0),(545992,15167,'fi','Jakaa nimikkeen koodi & kuvaus',0),(545993,15167,'no','Delt Varekode & beskrivelse',0),(545994,15167,'da','Split varekode & beskrivelse',0),(545995,15167,'ko','í•­ëª© ì½”ë“œ & ì„¤ëª… ë¶„í•˜ì‹œì˜¤',0),(545996,15167,'he','×œ×¤×¦×œ ××ª ×§×•×“ ×”×¤×¨×™×˜ & ×ª×™××•×¨',0),(545997,15167,'el','Split Ï„Î¿ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ & Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(545998,15167,'zh','æ‹†åˆ†é¡¹ç›®ä»£ç  & æè¿°',0),(545999,15167,'sv','Dela den Artikelkod & Beskrivning',0),(546000,15167,'it','Dividere il codice articolo & Descrizione',0),(546001,15167,'tl','',0),(546002,15167,'th','à¹à¸¢à¸à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸² & à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”',0),(546003,15167,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥‹à¤¡ & à¤µà¤°à¥à¤£à¤¨ à¤µà¤¿à¤­à¤¾à¤œà¤¿à¤¤',0),(546004,15167,'ms','Pecahan kod Item & keterangan',0),(546005,15167,'ar','ØªÙ‚Ø³ÙŠÙ… ÙƒÙˆØ¯ Ø§Ù„ØµÙ†Ù Ø¢Ù†Ø¯ Ø§Ù„ÙˆØµÙ',0),(546006,15167,'fr','Diviser le Code article & Description',0),(546007,15167,'jp','é …ç›®ã‚³ãƒ¼ãƒ‰ & èª¬æ˜Žã‚’åˆ†å‰²ã—ã¾ã™ã€‚',0),(546008,15167,'pt','Dividir o cÃ³digo do artigo & descriÃ§Ã£o',0),(546009,15167,'ru','Ð Ð°Ð·Ð´ÐµÐ»Ð¸Ñ‚ÑŒ ÐºÐ¾Ð´ Ñ‚Ð¾Ð²Ð°Ñ€Ð° & Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(546010,15167,'es','Dividir el cÃ³digo de artÃ­culo & DescripciÃ³n',0),(546011,15167,'de','Teilen Sie den Artikelcode & Beschreibung',0),(546012,15167,'en','Split The Item Code & Description',0),(546013,15168,'is','',0),(546014,15168,'dr','Ù†Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¬Ø³ØªØ¬Ùˆ ØªÙˆØ³Ø· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø´ØªØ±ÛŒ',0),(546015,15168,'pr','Ù†Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¬Ø³ØªØ¬Ùˆ ØªÙˆØ³Ø· ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø´ØªØ±ÛŒ',0),(546016,15168,'tr','SatÄ±cÄ± ve mÃ¼ÅŸteri tarafÄ±ndan arama yapamaz',0),(546017,15168,'pl','Nie Szukaj dostawcy i klienta',0),(546018,15168,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ñ‚ÑŠÑ€ÑÐ¸Ñ‚Ðµ Ð¿Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(546019,15168,'ur','Ú¯Ø§ÛÚ© Ø§ÙˆØ± ÙØ±ÙˆØ´Ù†Ø¯Û Ø¯ÙˆÙ†ÙˆÚº Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªÙ„Ø§Ø´ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(546020,15168,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°Ñ‚Ð¸ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸ ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(546021,15168,'vi','KhÃ´ng thá»ƒ tÃ¬m kiáº¿m theo cáº£ hai nhÃ  cung cáº¥p vÃ  khÃ¡ch hÃ ng',0),(546022,15168,'af','Soek kan deur beide die verkoper en kliÃ«nt',0),(546023,15168,'ro','Nu poate cÄƒutare de furnizor ÅŸi client',0),(546024,15168,'et','Ei saa otsida hankija ja kliendi',0),(546025,15168,'si','Ni mogoÄe iskati po dobavitelj in kupec',0),(546026,15168,'ba','Tidak Cari Vendor dan pelanggan',0),(546027,15168,'nl','Kan niet zoeken door zowel de leverancier en de klant',0),(546028,15168,'fi','Ei etsi toimittaja ja asiakas',0),(546029,15168,'no','Kan ikke sÃ¸ke etter leverandÃ¸r og kunde',0),(546030,15168,'da','Kan ikke sÃ¸ge efter bÃ¥de kreditor og debitor',0),(546031,15168,'ko','ê³µê¸‰ ì—…ì²´ì™€ ê³ ê°ì— ì˜í•´ ê²€ìƒ‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(546032,15168,'he','×™×›×•×œ ×œ×—×¤×© ×œ×¤×™ ×¡×¤×§ ×•×œ×§×•×—',0),(546033,15168,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Î±Î½Î±Î¶Î·Ï„Î®ÏƒÎµÏ„Îµ Î±Ï€ÏŒ Ï€ÎµÎ»Î¬Ï„Î· ÎºÎ±Î¹ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(546034,15168,'zh','ä¸èƒ½æœç´¢æŒ‰ä¾›åº”å•†å’Œå®¢æˆ·',0),(546035,15168,'sv','GÃ¥r inte att sÃ¶ka av bÃ¥de leverantÃ¶r och kund',0),(546036,15168,'it','Non Ã¨ possibile cercare sia fornitore e cliente',0),(546037,15168,'tl','',0),(546038,15168,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸„à¹‰à¸™à¸«à¸²à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹à¸¥à¸°à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(546039,15168,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤”à¤° à¤—à¥à¤°à¤¾à¤¹à¤• à¤¦à¥‹à¤¨à¥‹à¤‚ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤–à¥‹à¤œ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(546040,15168,'ms','Tidak dapat mencari dengan kedua-dua penjual dan pelanggan',0),(546041,15168,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„Ø¨Ø­Ø« Ø¹Ù† Ø·Ø±ÙŠÙ‚ ÙƒÙ„ Ù…Ù† Ø§Ù„Ø¨Ø§Ø¦Ø¹ ÙˆØ§Ù„Ø¹Ù…ÙŠÙ„',0),(546042,15168,'fr','Impossible de rechercher par les fournisseurs et les clients',0),(546043,15168,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã¨é¡§å®¢ã®ä¸¡æ–¹ã§æ¤œç´¢ã§ãã¾ã›ã‚“ã€‚',0),(546044,15168,'pt','NÃ£o podemos procurar por fornecedor e cliente',0),(546045,15168,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð¸ÑÐº Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(546046,15168,'es','Puede buscar por proveedor y cliente',0),(546047,15168,'de','Kann nicht von Lieferanten und Kunden suchen.',0),(546048,15168,'en','Cannot Search By Both Vendor And Customer',0),(546049,15169,'is','',0),(546050,15169,'dr','Ø´Ø§Ù…Ù„ Ø§Ù‚Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÛŒ ØºÛŒØ±',0),(546051,15169,'pr','Ø´Ø§Ù…Ù„ Ø§Ù‚Ù„Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ÛŒ ØºÛŒØ±',0),(546052,15169,'tr','Stok Ã¶ÄŸeler iÃ§erir',0),(546053,15169,'pl','ObejmujÄ… zapasÃ³w-',0),(546054,15169,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð°-ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸',0),(546055,15169,'ur','ØºÛŒØ± Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ø´ÛŒØ§Ø¡ Ù…ÛŒÚº Ø´Ø§Ù…Ù„',0),(546056,15169,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ ÐºÐ¾Ñ˜Ð¸ Ð½Ð¸ÑÑƒ Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(546057,15169,'vi','Bao gá»“m-tháº­p váº­t tÆ°',0),(546058,15169,'af','Sluit nie-voorraad Items',0),(546059,15169,'ro','Include elemente Non-inventar',0),(546060,15169,'et','Hulka laokaupade',0),(546061,15169,'si','So-zaloge artiklov',0),(546062,15169,'ba','Termasuk bebas-persediaan barang',0),(546063,15169,'nl','Opnemen van niet-voorraadartikelen',0),(546064,15169,'fi','SisÃ¤ltÃ¤Ã¤ ei-varastotuotteiden',0),(546065,15169,'no','Inkluder ikke-beholdningsvarer',0),(546066,15169,'da','Omfatte ikke lagervarer',0),(546067,15169,'ko','ë¹„-ì¸ë²¤í† ë¦¬ í•­ëª© í¬í•¨',0),(546068,15169,'he','×›×œ×•×œ ×¤×¨×™×˜×™× ×©××™× × ×ž×œ××™',0),(546069,15169,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ ÎµÎ¯Î´Î· Î¼Î·-Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(546070,15169,'zh','åŒ…æ‹¬éžåº“å­˜ç‰©æ–™',0),(546071,15169,'sv','Inkludera icke-lagerartiklar',0),(546072,15169,'it','Includono articoli Non a magazzino',0),(546073,15169,'tl','',0),(546074,15169,'th','à¸£à¸§à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆ',0),(546075,15169,'hi','à¤—à¥ˆà¤°-à¤¸à¥‚à¤šà¥€ à¤†à¤‡à¤Ÿà¤® à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(546076,15169,'ms','Termasuk barangan bebas-inventori',0),(546077,15169,'ar','ÙˆØªØ´Ù…Ù„ Ø¨Ù†ÙˆØ¯ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(546078,15169,'fr','Inclure les articles hors stocks',0),(546079,15169,'jp','éžåœ¨åº«ã‚¢ã‚¤ãƒ†ãƒ ã‚’å«ã‚ã‚‹',0),(546080,15169,'pt','Incluir itens nÃ£o-inventÃ¡rio',0),(546081,15169,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÐ½ÐºÐ»Ð°Ñ‚ÑƒÑ€Ñ‹',0),(546082,15169,'es','Incluir artÃ­culos no inventariados',0),(546083,15169,'de','Sind nicht-Lagerartikel',0),(546084,15169,'en','Include Non-Inventory Items',0),(546085,15170,'is','',0),(546086,15170,'dr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ ØºÛŒØ± Ø¬Ø³ØªØ¬Ùˆ',0),(546087,15170,'pr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ÛŒ ØºÛŒØ± Ø¬Ø³ØªØ¬Ùˆ',0),(546088,15170,'tr','Arama olmayan stok aÃ§Ä±klamasÄ±',0),(546089,15170,'pl','Opis nie â€“ magazynowych',0),(546090,15170,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ-Ð·Ð°Ð¿Ð°ÑÐ¸',0),(546091,15170,'ur','ØªÙ„Ø§Ø´ Ú©Ø±ÛŒÚº-Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ ØªØµØ±ÛŒØ­',0),(546092,15170,'sr','ÐžÐ¿Ð¸Ñ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ ÐºÐ¾Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(546093,15170,'vi','TÃ¬m phÃ²ng khÃ´ng kiá»ƒm kÃª mÃ´ táº£',0),(546094,15170,'af','Soek nie-voorraad Beskrywing',0),(546095,15170,'ro','CÄƒutare Non-inventar Descriere',0),(546096,15170,'et','Otsi lao kirjeldus',0),(546097,15170,'si','Opis za iskanje-zaloge',0),(546098,15170,'ba','Cari bebas-persediaan Deskripsi',0),(546099,15170,'nl','Niet-voorraad zoeknaam',0),(546100,15170,'fi','Hakunimi-kartoitus',0),(546101,15170,'no','Ikke-lager SÃ¸kebeskrivelse',0),(546102,15170,'da','SÃ¸g efter ikke-lager beskrivelse',0),(546103,15170,'ko','ê²€ìƒ‰ ë¹„ ìž¬ê³  ì„¤ëª…',0),(546104,15170,'he','×—×™×¤×•×© ×©××™× × ×ž×œ××™ ×ª×™××•×¨',0),(546105,15170,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î¼Î· Î±Ï€Î¿Î³ÏÎ±Ï†Î® Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(546106,15170,'zh','æœç´¢éžåº“å­˜æè¿°',0),(546107,15170,'sv','SÃ¶kbeskrivning icke-inventering',0),(546108,15170,'it','Descrizione di ricerca Non a magazzino',0),(546109,15170,'tl','',0),(546110,15170,'th','à¸„à¹‰à¸™à¸«à¸²à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹„à¸¡à¹ˆà¸„à¸‡',0),(546111,15170,'hi','à¤–à¥‹à¤œ à¤—à¥ˆà¤°-à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤µà¤¿à¤µà¤°à¤£',0),(546112,15170,'ms','Penerangan inventori carian',0),(546113,15170,'ar','Ø§Ù„ÙˆØµÙ ØºÙŠØ± Ø­ØµØ± Ø§Ù„Ø¨Ø­Ø«',0),(546114,15170,'fr','DÃ©signation de recherche hors stocks',0),(546115,15170,'jp','éžåœ¨åº«èª¬æ˜Žã®æ¤œç´¢',0),(546116,15170,'pt','Pesquisa nÃ£o-inventÃ¡rio descriÃ§Ã£o',0),(546117,15170,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¾Ð¸ÑÐºÐ°-Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(546118,15170,'es','DescripciÃ³n de bÃºsqueda no-inventario',0),(546119,15170,'de','Suche nicht-Inventur Beschreibung',0),(546120,15170,'en','Search Non-Inventory Description',0),(546121,15171,'is','',0),(546122,15171,'dr','Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ & Ø¨Ø³ØªÙ‡',0),(546123,15171,'pr','Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯ Ø¨Ø±Ø§ÛŒ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ & Ø¨Ø³ØªÙ‡',0),(546124,15171,'tr','Fatura & kapalÄ± gÃ¶stermek iÃ§in tÄ±klatÄ±n',0),(546125,15171,'pl','Kliknij, aby pokazaÄ‡ zapowiadane & zamkniÄ™te',0),(546126,15171,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¿Ð¾ÐºÐ°Ð¶Ðµ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸ & Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(546127,15171,'ur','Ø¨Ø§Ù„Ù„Ø§Ø¯ & Ø¨Ù†Ø¯ Ø´Ùˆ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(546128,15171,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° ÐµÐ¼Ð¸ÑÐ¸Ñ˜Ñƒ Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ & Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð°',0),(546129,15171,'vi','Nháº¥n vÃ o Ä‘Ã¢y Ä‘á»ƒ hiá»ƒn thá»‹ quáº£ng cÃ¡o & Ä‘Ã³ng cá»­a',0),(546130,15171,'af','Klik om te wys weerspieÃ«l & gesluit',0),(546131,15171,'ro','Click pentru a arÄƒta facturat & Ã®nchis',0),(546132,15171,'et','KlÃµpsake NÃ¤ita arve & suletud',0),(546133,15171,'si','Kliknite za prikaz zaraÄunali & zaprta',0),(546134,15171,'ba','Klik untuk menunjukkan ditagih & ditutup',0),(546135,15171,'nl','Klik op naar Show gefactureerd & gesloten',0),(546136,15171,'fi','Valitse NÃ¤ytÃ¤ laskutetaan & suljettu',0),(546137,15171,'no','Klikk for Ã¥ vise fakturert & lukket',0),(546138,15171,'da','Klik for at vise faktureret & lukket',0),(546139,15171,'ko','ì²­êµ¬ & íì‡„ í‘œì‹œë¥¼ í´ë¦­ í•˜ì‹­ì‹œì˜¤',0),(546140,15171,'he','×œ×—×¥ ×›×“×™ ×œ×”×¦×™×’ ××ª ×”×—×™×•×‘ & ×¡×’×•×¨×”',0),(546141,15171,'el','ÎšÎ¬Î½Ï„Îµ ÎºÎ»Î¹Îº Î³Î¹Î± ÎµÎ¼Ï†Î¬Î½Î¹ÏƒÎ· Ï‡ÏÎµÏŽÎ½Î¿Î½Ï„Î±Î¹ & ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŒ',0),(546142,15171,'zh','å•å‡»ä»¥æ˜¾ç¤ºè®°å¸ & å…³é—­',0),(546143,15171,'sv','Klicka fÃ¶r att Visa faktureras & stÃ¤ngd',0),(546144,15171,'it','Clicca per Visualizza fatturati & chiuso',0),(546145,15171,'tl','',0),(546146,15171,'th','à¸„à¸¥à¸´à¸à¹€à¸žà¸·à¹ˆà¸­à¹à¸ªà¸”à¸‡à¹€à¸£à¸µà¸¢à¸ & à¸›à¸´à¸”',0),(546147,15171,'hi','à¤¬à¤¿à¤² à¤•à¤¿à¤¯à¤¾ & à¤¬à¤‚à¤¦ à¤¦à¤¿à¤–à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(546148,15171,'ms','Klik untuk Papar dibilkan & ditutup',0),(546149,15171,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù„Ø¹Ø±Ø¶ ÙÙˆØ§ØªÙŠØ± Ø¢Ù†Ø¯ Ù…ØºÙ„Ù‚Ø©',0),(546150,15171,'fr','Cliquer pour montrer Ã  bec & fermÃ©',0),(546151,15171,'jp','ã‚¯ãƒªãƒƒã‚¯ã—ã¦è¡¨ç¤ºã™ã‚‹è«‹æ±‚ & é–‰éŽ–',0),(546152,15171,'pt','Clique para mostrar de bico & fechado',0),(546153,15171,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚ & Ð·Ð°ÐºÑ€Ñ‹Ñ‚',0),(546154,15171,'es','Haga clic en Mostrar factura & cerrado',0),(546155,15171,'de','Hier klicken, um die Karte in Rechnung gestellt & geschlossen',0),(546156,15171,'en','Click To Show Billed & Closed',0),(546157,15172,'is','',0),(546158,15172,'dr','Ú©Ø§Ù…Ù„ Ø¨Ø§ Ù‡ÛŒÚ† Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(546159,15172,'pr','Ú©Ø§Ù…Ù„ Ø¨Ø§ Ù‡ÛŒÚ† Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(546160,15172,'tr','HiÃ§bir sevkiyat ile tamamlamak',0),(546161,15172,'pl','Wraz z nie przesyÅ‚ki',0),(546162,15172,'bg','Ð—Ð°Ð²ÑŠÑ€ÑˆÐ¸ Ñ Ð½Ðµ Ð¿Ñ€Ð°Ñ‚ÐºÐ¸',0),(546163,15172,'ur','Ú©ÙˆØ¦ÛŒ ØªØ±Ø³ÛŒÙ„ Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ú©Ù…Ù„',0),(546164,15172,'sr','Ð¡Ð° ÑÐ²Ðµ Ð±ÐµÐ· Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(546165,15172,'vi','HoÃ n chá»‰nh vá»›i cÃ¡c lÃ´ hÃ ng khÃ´ng',0),(546166,15172,'af','Voltooi met geen vervoer',0),(546167,15172,'ro','Complet cu nici o transporturile',0),(546168,15172,'et','Koos mingit saadetised',0),(546169,15172,'si','Skupaj z ne poÅ¡iljke',0),(546170,15172,'ba','Lengkap dengan pengiriman tidak',0),(546171,15172,'nl','Compleet met geen zendingen',0),(546172,15172,'fi','TÃ¤ydellisenÃ¤ ei toimituksia',0),(546173,15172,'no','Komplett med ingen forsendelser',0),(546174,15172,'da','Komplet med ingen overfÃ¸rsler',0),(546175,15172,'ko','ì•„ë‹ˆ ì¶œí•˜ ì™„ë£Œ',0),(546176,15172,'he','×œ×”×©×œ×™× ×¢× ××™×Ÿ ×ž×©×œ×•×—×™×',0),(546177,15172,'el','Î Î»Î®ÏÎ·Ï‚, Î¼Îµ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ Î´ÎµÎ½',0),(546178,15172,'zh','å®Œæˆä¸Žæ²¡æœ‰å‘è´§',0),(546179,15172,'sv','Komplett med inga transporter',0),(546180,15172,'it','Completare con No spedizioni',0),(546181,15172,'tl','',0),(546182,15172,'th','à¸¡à¸µà¸ªà¹ˆà¸‡à¹„à¸¡à¹ˆ',0),(546183,15172,'hi','à¤•à¥‹à¤ˆ à¤²à¤¦à¤¾à¤¨ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ªà¥‚à¤°à¥à¤£ à¤•à¤°à¥‡à¤‚',0),(546184,15172,'ms','Lengkap dengan penghantaran tidak',0),(546185,15172,'ar','ÙƒØ§Ù…Ù„Ø© Ù…Ø¹ Ù„Ø§ Ø´Ø­Ù†Ø§Øª',0),(546186,15172,'fr','Complet avec aucun envoi',0),(546187,15172,'jp','ã„ã„ãˆå‡ºè·å®Œäº†ã—ã¾ã™ã€‚',0),(546188,15172,'pt','Completa com sem carregamentos',0),(546189,15172,'ru','Ð’ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ðµ Ñ Ð±ÐµÐ· Ð³Ñ€ÑƒÐ·Ð¾Ð²',0),(546190,15172,'es','Completar con No los envÃ­os',0),(546191,15172,'de','Komplett mit keine Sendungen',0),(546192,15172,'en','Complete With No Shipments',0),(546193,15173,'is','',0),(546194,15173,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´',0),(546195,15173,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø±Ø§ÛŒ Ø³ÙØ§Ø±Ø´',0),(546196,15173,'tr','Faturalar iÃ§in sipariÅŸ',0),(546197,15173,'pl','Faktury na zamÃ³wienie',0),(546198,15173,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(546199,15173,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ ØªØ±ØªÛŒØ¨ Ú©Û’ Ù„Ø¦Û’',0),(546200,15173,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð½Ð°Ð»Ð¾Ð³',0),(546201,15173,'vi','HÃ³a Ä‘Æ¡n cho Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(546202,15173,'af','Fakture vir volgorde',0),(546203,15173,'ro','Facturile pentru comanda',0),(546204,15173,'et','Tellimuse arve',0),(546205,15173,'si','RaÄuni za nalog',0),(546206,15173,'ba','Faktur untuk Order',0),(546207,15173,'nl','Facturen voor Order',0),(546208,15173,'fi','Laskut jÃ¤rjestyksessÃ¤',0),(546209,15173,'no','Fakturaer For ordre',0),(546210,15173,'da','Fakturaer For ordre',0),(546211,15173,'ko','ì£¼ë¬¸ì— ëŒ€ í•œ ì²­êµ¬ì„œ',0),(546212,15173,'he','×—×©×‘×•× ×™×•×ª ×¢×‘×•×¨ ×”×–×ž× ×”',0),(546213,15173,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î³Î¹Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(546214,15173,'zh','è®¢å•å‘ç¥¨',0),(546215,15173,'sv','Fakturor fÃ¶r bestÃ¤llning',0),(546216,15173,'it','Fatture per ordine',0),(546217,15173,'tl','',0),(546218,15173,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸ªà¸³à¸«à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(546219,15173,'hi','à¤‘à¤°à¥à¤¡à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(546220,15173,'ms','Invois-invois untuk pesanan',0),(546221,15173,'ar','ÙÙˆØ§ØªÙŠØ± Ù„Ù„Ù†Ø¸Ø§Ù…',0),(546222,15173,'fr','Factures pour commander',0),(546223,15173,'jp','æ³¨æ–‡ã®è«‹æ±‚æ›¸',0),(546224,15173,'pt','Facturas por ordem',0),(546225,15173,'ru','Ð¡Ñ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð´Ð»Ñ Ð·Ð°ÐºÐ°Ð·Ð°',0),(546226,15173,'es','Facturas por orden',0),(546227,15173,'de','Rechnungen fÃ¼r Bestellung',0),(546228,15173,'en','Invoices For Order',0),(546229,15174,'is','',0),(546230,15174,'dr','Ø¬Ù‡Øª Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÛŒ Ú©Ø§Ù…Ù„',0),(546231,15174,'pr','Ø¬Ù‡Øª Ø¹Ù„Ø§Ù…Øª Ú¯Ø°Ø§Ø±ÛŒ Ú©Ø§Ù…Ù„',0),(546232,15174,'tr','Mark sipariÅŸ tamamlandÄ±',0),(546233,15174,'pl','Mark zamÃ³wienie kompletne',0),(546234,15174,'bg','ÐœÐ°Ñ€Ðº Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¿ÑŠÐ»Ð½Ð°',0),(546235,15174,'ur','Ù†Ø´Ø§Ù† Ø²Ø¯ Ú©Ø±ÛŒÚº Ø¢Ø±ÚˆØ± Ù…Ú©Ù…Ù„',0),(546236,15174,'sr','ÐšÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð½Ð° ÐœÐ°Ñ€Ðº Ð½Ð°Ð»Ð¾Ð³Ð°',0),(546237,15174,'vi','Thá»© tá»± Ä‘Ã¡nh dáº¥u hoÃ n thÃ nh',0),(546238,15174,'af','Merk bestelling voltooi',0),(546239,15174,'ro','Marca de ordine complet',0),(546240,15174,'et','Mark tellimuse tÃ¤ielik',0),(546241,15174,'si','Mark vrstni red popolnega',0),(546242,15174,'ba','Mark memesan lengkap',0),(546243,15174,'nl','Mark bestelling compleet',0),(546244,15174,'fi','Mark jÃ¤rjestys valmis',0),(546245,15174,'no','Mark for komplett',0),(546246,15174,'da','Mark ordre komplet',0),(546247,15174,'ko','ë§ˆí¬ ì£¼ë¬¸ ì™„ë£Œ',0),(546248,15174,'he','×ž××¨×§ ×¡×“×¨ ×ž×•×—×œ×˜',0),(546249,15174,'el','Mark Ï€Î±Ï / Î›Î™Î‘Î£',0),(546250,15174,'zh','é©¬å…‹è®¢è´­å®Œæˆ',0),(546251,15174,'sv','Mark fÃ¶r komplett',0),(546252,15174,'it','Mark ordine completo',0),(546253,15174,'tl','',0),(546254,15174,'th','à¸ªà¸±à¹ˆà¸‡à¸—à¸³à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(546255,15174,'hi','à¤®à¤¾à¤°à¥à¤• à¤‘à¤°à¥à¤¡à¤° à¤ªà¥‚à¤°à¤¾',0),(546256,15174,'ms','Pesanan Mark lengkap',0),(546257,15174,'ar','ØªØ±ØªÙŠØ¨ Ø¹Ù„Ø§Ù…Ø© ÙƒØ§Ù…Ù„Ø©',0),(546258,15174,'fr','Mark ordre complet',0),(546259,15174,'jp','ãƒžãƒ¼ã‚¯æ³¨æ–‡å®Œäº†',0),(546260,15174,'pt','Marca ordem completa',0),(546261,15174,'ru','ÐœÐ°Ñ€Ðº Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾Ð»Ð½Ñ‹Ð¹',0),(546262,15174,'es','Marca orden completa',0),(546263,15174,'de','Mark Bestellung abgeschlossen',0),(546264,15174,'en','Mark Order Complete',0),(546265,15175,'is','',0),(546266,15175,'dr','Ø³ÙØ§Ø±Ø´ Ú©Ø§Ù…Ù„ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(546267,15175,'pr','Ø³ÙØ§Ø±Ø´ Ú©Ø§Ù…Ù„ Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(546268,15175,'tr','SipariÅŸ tam olarak iÅŸaretlenmiÅŸ',0),(546269,15175,'pl','ZamÃ³wienie zostaÅ‚o oznaczone peÅ‚nÄ…',0),(546270,15175,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ðµ Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ð° Ð¿ÑŠÐ»Ð½Ð°',0),(546271,15175,'ur','ØªØ±ØªÛŒØ¨ Ù…Ú©Ù…Ù„ Ú©Ø±Ø¯Û Ù†Ø´Ø§Ù† Ø²Ø¯ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(546272,15175,'sr','Ð ÐµÐ´ Ñ˜Ðµ Ð±Ð¸Ð¾ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½ ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½',0),(546273,15175,'vi','ÄÆ¡n Ä‘áº·t hÃ ng Ä‘Ã£ Ä‘Æ°á»£c Ä‘Ã¡nh dáº¥u hoÃ n thÃ nh',0),(546274,15175,'af','Orde het klaar gemerk is',0),(546275,15175,'ro','Ordinul a fost marcat complet',0),(546276,15175,'et','Tellimus on mÃ¤rgitud tÃ¤ielik',0),(546277,15175,'si','Naloga je bila oznaÄena kot dokonÄana',0),(546278,15175,'ba','Urutan telah ditandai lengkap',0),(546279,15175,'nl','Orde heeft als voltooid zijn gemarkeerd',0),(546280,15175,'fi','Tilaus on jo merkitty koko',0),(546281,15175,'no','Ordre har vÃ¦rt merket som fullfÃ¸rt',0),(546282,15175,'da','Orden er blevet markeret som fuldfÃ¸rt',0),(546283,15175,'ko','ì£¼ë¬¸ ì™„ë£Œìœ¼ë¡œ í‘œì‹œ ë˜ì–´ ìžˆë‹¤',0),(546284,15175,'he','×¡×“×¨ ×¡×•×ž×Ÿ ×ž×œ××”',0),(546285,15175,'el','Î£ÎµÎ¹ÏÎ¬ Î­Ï‡ÎµÎ¹ ÎµÏ€Î¹ÏƒÎ·Î¼Î±Î½Î¸ÎµÎ¯ Ï€Î»Î®ÏÎ·',0),(546286,15175,'zh','è®¢å•å·²æ ‡è®°ä¸ºå®Œæˆ',0),(546287,15175,'sv','Ordning har markerats komplett',0),(546288,15175,'it','Ordine Ã¨ stato contrassegnato completo',0),(546289,15175,'tl','',0),(546290,15175,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸¡à¸µà¸à¸²à¸£à¸—à¸³à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(546291,15175,'hi','à¤†à¤¦à¥‡à¤¶ à¤ªà¥‚à¤°à¥à¤£ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(546292,15175,'ms','Perintah telah ditandakan lengkap',0),(546293,15175,'ar','Ø§ØªØ³Ù… Ø§Ù„Ù†Ø¸Ø§Ù… ÙƒØ§Ù…Ù„Ø©',0),(546294,15175,'fr','Ordre a Ã©tÃ© marquÃ©e complÃ¨te',0),(546295,15175,'jp','æ³¨æ–‡ãŒå®Œäº†ãƒžãƒ¼ã‚¯ã•ã‚Œã¦',0),(546296,15175,'pt','Ordem foi marcado completo',0),(546297,15175,'ru','Ð—Ð°ÐºÐ°Ð· Ð±Ñ‹Ð» Ð¾Ñ‚Ð¼ÐµÑ‡ÐµÐ½ Ð¿Ð¾Ð»Ð½Ñ‹Ð¹',0),(546298,15175,'es','Orden ha estado marcada completa',0),(546299,15175,'de','Bestellung wurde komplett markiert',0),(546300,15175,'en','Order Has Been Marked Complete',0),(546301,15176,'is','',0),(546302,15176,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø·ÙˆØ± Ú©Ø§Ù…Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø§Ø³Øª',0),(546303,15176,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø·ÙˆØ± Ú©Ø§Ù…Ù„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø§Ø³Øª',0),(546304,15176,'tr','SipariÅŸ tam olarak faturalandÄ±ÄŸÄ± deÄŸil',0),(546305,15176,'pl','ZamÃ³wienie nie jest w peÅ‚ni rozliczane',0),(546306,15176,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¿ÑŠÐ»Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸',0),(546307,15176,'ur','ØªØ±ØªÛŒØ¨ Ù…Ú©Ù…Ù„ Ø·ÙˆØ± Ù¾Ø± Ø¨Ø§Ù„Ù„Ø§Ø¯ Ù†ÛÛŒÚº ÛÛ’',0),(546308,15176,'sr','Ð ÐµÐ´ ÑÐµ Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµ Ñƒ Ð¿Ð¾Ñ‚Ð¿ÑƒÐ½Ð¾ÑÑ‚Ð¸',0),(546309,15176,'vi','Äáº·t hÃ ng khÃ´ng lÃ  hoÃ n toÃ n láº­p hoÃ¡ Ä‘Æ¡n',0),(546310,15176,'af','Orde Is nie ten volle weerspieÃ«l',0),(546311,15176,'ro','Ordinul nu este complet facturate',0),(546312,15176,'et','Tellimuse mitte tÃ¤ielikult arve',0),(546313,15176,'si','Naloga ni popolnoma izdajate',0),(546314,15176,'ba','Urutan tidak sepenuhnya ditagih',0),(546315,15176,'nl','Bestelling Is niet volledig gefactureerd',0),(546316,15176,'fi','Tilaus laskutetaan ei tÃ¤ysin',0),(546317,15176,'no','Bestillingen er ikke fullt faktureres',0),(546318,15176,'da','Orden er ikke fuldt faktureret',0),(546319,15176,'ko','ì£¼ë¬¸ ì™„ì „ížˆ ì²­êµ¬ í•˜ì§€',0),(546320,15176,'he','×¡×“×¨ ×œ× ×”×—×™×•×‘ ×‘××•×¤×Ÿ ×ž×œ×',0),(546321,15176,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î´ÎµÎ½ Ï‡ÏÎµÏŽÎ½ÎµÏ„Î±Î¹ Ï€Î»Î®ÏÏ‰Ï‚',0),(546322,15176,'zh','ç§©åºä¸æ˜¯å®Œå…¨è®¡è´¹',0),(546323,15176,'sv','Ordningen Ã¤r inte helt faktureras',0),(546324,15176,'it','Ordine non Ã¨ completamente fatturati',0),(546325,15176,'tl','',0),(546326,15176,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ˆà¸°à¹„à¸¡à¹ˆà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸•à¹‡à¸¡',0),(546327,15176,'hi','à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾ à¤ªà¥‚à¤°à¥€ à¤¤à¤°à¤¹ à¤¸à¥‡ à¤¬à¤¿à¤² à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(546328,15176,'ms','Perintah tidak dibilkan sepenuhnya',0),(546329,15176,'ar','Ø£Ù…Ø± Ù„Ø§ ØªÙˆØµÙ ØªÙ…Ø§Ù…Ø§',0),(546330,15176,'fr','Ordre n\'est pas entiÃ¨rement facturÃ©',0),(546331,15176,'jp','é †åºã¯å®Œå…¨ã«èª²é‡‘ã•ã‚Œã¾ã›ã‚“ã€‚',0),(546332,15176,'pt','Ordem totalmente nÃ£o Ã© cobrado',0),(546333,15176,'ru','Ð—Ð°ÐºÐ°Ð· Ð¾Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ Ð½Ðµ Ð¿Ð¾Ð»Ð½Ð¾ÑÑ‚ÑŒÑŽ',0),(546334,15176,'es','Orden no es completamente facturado',0),(546335,15176,'de','Bestellung wird nicht vollstÃ¤ndig abgerechnet.',0),(546336,15176,'en','Order Is Not Fully Billed',0),(546337,15177,'is','',0),(546338,15177,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø·ÙˆØ± Ú©Ø§Ù…Ù„ Ø­Ù…Ù„ Ø§Ø³Øª',0),(546339,15177,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ Ø·ÙˆØ± Ú©Ø§Ù…Ù„ Ø­Ù…Ù„ Ø§Ø³Øª',0),(546340,15177,'tr','SipariÅŸ tamamen gÃ¶nderilmeyen',0),(546341,15177,'pl','ZamÃ³wienie nie jest w peÅ‚ni wysÅ‚ane',0),(546342,15177,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¿ÑŠÐ»Ð½Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¾',0),(546343,15177,'ur','ØªØ±ØªÛŒØ¨ Ù…Ú©Ù…Ù„ Ø·ÙˆØ± Ù¾Ø± Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ù†ÛÛŒÚº ÛÛ’',0),(546344,15177,'sr','ÐÐ°Ð»Ð¾Ð³ Ð½Ð¸Ñ˜Ðµ Ñƒ Ð¿Ð¾Ñ‚Ð¿ÑƒÐ½Ð¾ÑÑ‚Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½',0),(546345,15177,'vi','Thá»© tá»± khÃ´ng pháº£i lÃ  hoÃ n toÃ n Ä‘Æ°á»£c váº­n chuyá»ƒn',0),(546346,15177,'af','Orde Is nie volledig Shipped',0),(546347,15177,'ro','Ordinul nu este complet expediate',0),(546348,15177,'et','Tellimus on tÃ¤ielikult lÃ¤hetatud',0),(546349,15177,'si','Ne popolnoma odposlana',0),(546350,15177,'ba','Pesanan tidak sepenuhnya dikirim',0),(546351,15177,'nl','Bestelling Is niet volledig verzonden',0),(546352,15177,'fi','Jotta ei tule tÃ¤ysin',0),(546353,15177,'no','Bestillingen er ikke fullstendig sendt',0),(546354,15177,'da','Ordren er ikke fuldt leveret',0),(546355,15177,'ko','ìˆœì„œì— ì™„ì „ížˆ í¬í•¨ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(546356,15177,'he','×”×”×–×ž× ×” ×œ× × ×©×œ×—×ª ×‘××•×¤×Ÿ ×ž×œ×',0),(546357,15177,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î´ÎµÎ½ Î±Ï€Î¿ÏƒÏ„Î­Î»Î»ÎµÏ„Î±Î¹ Ï€Î»Î®ÏÏ‰Ï‚',0),(546358,15177,'zh','è®¢å•ä¸å®Œå…¨å‘è´§',0),(546359,15177,'sv','Ordern levereras inte fullt',0),(546360,15177,'it','Ordine non Ã¨ completamente spedito',0),(546361,15177,'tl','',0),(546362,15177,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ˆà¸°à¹„à¸¡à¹ˆà¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(546363,15177,'hi','à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾ à¤ªà¥‚à¤°à¥€ à¤¤à¤°à¤¹ à¤¸à¥‡ à¤¸à¤¹à¤¯à¥‹à¤— à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤°à¤¹à¤¾',0),(546364,15177,'ms','Pesanan tidak dihantar sepenuhnya',0),(546365,15177,'ar','Ø£Ù…Ø± Ù„Ø§ ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§ ØªÙ…Ø§Ù…Ø§',0),(546366,15177,'fr','Commande n\'est pas entiÃ¨rement expÃ©diÃ©e',0),(546367,15177,'jp','é †åºã¯å®Œå…¨ã«åŒæ¢±ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(546368,15177,'pt','Ordem nÃ£o Ã© totalmente enviada',0),(546369,15177,'ru','Ð—Ð°ÐºÐ°Ð· Ð½Ðµ Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½ Ð¿Ð¾Ð»Ð½Ð¾ÑÑ‚ÑŒÑŽ',0),(546370,15177,'es','Orden no es completamente enviado',0),(546371,15177,'de','Bestellung ist nicht vollstÃ¤ndig',0),(546372,15177,'en','Order Is Not Fully Shipped',0),(546373,15178,'is','',0),(546374,15178,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø§Ø±Ø³Ø§Ù„',0),(546375,15178,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø§Ø±Ø³Ø§Ù„',0),(546376,15178,'tr','GÃ¶nderilen gÃ¼ncelleÅŸtirme sayÄ±sÄ±',0),(546377,15178,'pl','Liczba aktualizacji wysÅ‚ana',0),(546378,15178,'bg','Ð‘Ñ€Ð¾Ð¹ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(546379,15178,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒØ§Úº Ø¨Ú¾ÛŒØ¬Ù†Û’ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(546380,15178,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸ Ð¿Ð¾ÑÐ»Ð°Ð¾',0),(546381,15178,'vi','Sá»‘ lÆ°á»£ng cÃ¡c báº£n Cáº­p Nháº­t Ä‘Æ°á»£c gá»­i',0),(546382,15178,'af','Aantal bywerkings gestuur',0),(546383,15178,'ro','NumÄƒr de actualizÄƒri trimis',0),(546384,15178,'et','VÃ¤rskenduste saatmise arv',0),(546385,15178,'si','Å tevilo posodobljenih, poslana',0),(546386,15178,'ba','Jumlah update dikirim',0),(546387,15178,'nl','Aantal Updates verzonden',0),(546388,15178,'fi','MÃ¤Ã¤rÃ¤ pÃ¤ivitykset lÃ¤hetetÃ¤Ã¤n',0),(546389,15178,'no','Antall oppdateringer sendt',0),(546390,15178,'da','Antallet af opdateringer sendes',0),(546391,15178,'ko','ì—…ë°ì´íŠ¸ ì „ì†¡ ìˆ˜',0),(546392,15178,'he','×ž×¡×¤×¨ ×¢×“×›×•× ×™× ×©×œ×—',0),(546393,15178,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Ï‰Î½ ÎµÎºÎ´ÏŒÏƒÎµÏ‰Î½ Ï€Î¿Ï… Î­ÏƒÏ„ÎµÎ¹Î»Îµ',0),(546394,15178,'zh','å‘é€æ›´æ–°çš„æ•°ç›®',0),(546395,15178,'sv','Antalet uppdateringar skickas',0),(546396,15178,'it','Numero di aggiornamenti inviati',0),(546397,15178,'tl','',0),(546398,15178,'th','à¸ˆà¸³à¸™à¸§à¸™à¸ªà¹ˆà¸‡à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(546399,15178,'hi','à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(546400,15178,'ms','Jumlah Kemaskini yang dihantar',0),(546401,15178,'ar','Ø¹Ø¯Ø¯ Ù…Ù† Ø§Ù„ØªØ­Ø¯ÙŠØ«Ø§Øª Ø§Ù„Ù…Ø±Ø³Ù„Ø©',0),(546402,15178,'fr','Nombre de mises Ã  jour envoyÃ©es',0),(546403,15178,'jp','é€ä¿¡ã•ã‚ŒãŸæ›´æ–°ã®æ•°',0),(546404,15178,'pt','NÃºmero de atualizaÃ§Ãµes enviadas',0),(546405,15178,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ð¹',0),(546406,15178,'es','NÃºmero de actualizaciones enviadas',0),(546407,15178,'de','Anzahl der Aktualisierungen gesendet',0),(546408,15178,'en','Number Of Updates Sent',0),(546409,15179,'is','',0),(546410,15179,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù†ÛŒØ³Øª Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¯Ø± 3dcart',0),(546411,15179,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù†ÛŒØ³Øª Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¯Ø± 3dcart',0),(546412,15179,'tr','3dcart SatÄ±lÄ±k ayarlarÄ± iÃ§in gÃ¼ncelleÅŸtirme',0),(546413,15179,'pl','Aktualizowanie nie sprzedaÅ¼ ustawienia w 3dcart',0),(546414,15179,'bg','ÐÐµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð² 3dcart Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ',0),(546415,15179,'ur','ØªØ§Ø²Û 3dcart Ù¾Ø± ÙØ±ÙˆØ®Øª Ú©ÛŒ ØªØ±ØªÛŒØ¨Ø§Øª Ú©Û’ Ù„Ø¦Û’ Ù†ÛÛŒÚº Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(546416,15179,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€Ð¸ 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(546417,15179,'vi','Cáº­p Nháº­t khÃ´ng cho bÃ¡n cÃ i Ä‘áº·t táº¡i 3dcart',0),(546418,15179,'af','Werk nie vir verkoop instellings by 3dcart',0),(546419,15179,'ro','Actualizarea nu pentru setÄƒrile de vÃ¢nzare la 3dcart',0),(546420,15179,'et','Ajakohastamise eest mÃ¼Ã¼ki sÃ¤tteid 3dcart',0),(546421,15179,'si','Posodabljanje ni za prodajo nastavitve na 3dcart',0),(546422,15179,'ba','Memperbarui tidak untuk dijual pengaturan di 3dcart',0),(546423,15179,'nl','Bijwerken van niet voor verkoop instellingen op 3dcart',0),(546424,15179,'fi','PÃ¤ivittÃ¤minen ei myytÃ¤vÃ¤nÃ¤ asetusten 3dcart',0),(546425,15179,'no','Oppdaterer ikke For salg innstillingene pÃ¥ 3dcart',0),(546426,15179,'da','Opdaterer ikke til salg indstillinger pÃ¥ 3dcart',0),(546427,15179,'ko','3dcartì—ì„œ íŒë§¤ ì„¤ì •ì„ í•˜ì§€ ì—…ë°ì´íŠ¸',0),(546428,15179,'he','×¢×“×›×•×Ÿ ×œ× ×¢×‘×•×¨ ×”×’×“×¨×•×ª ×œ×ž×›×™×¨×”-3dcart',0),(546429,15179,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÎ±Î¹ ÏŒÏ‡Î¹ Î³Î¹Î± Ï€ÏŽÎ»Î·ÏƒÎ· ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ ÏƒÏ„Î¿ 3dcart',0),(546430,15179,'zh','ä¸æ›´æ–°åœ¨ 3dcart é”€å”®è®¾ç½®',0),(546431,15179,'sv','Uppdatera inte fÃ¶r fÃ¶rsÃ¤ljning instÃ¤llningar pÃ¥ 3dcart',0),(546432,15179,'it','Aggiornamento non per le impostazioni di vendita presso 3dcart',0),(546433,15179,'tl','',0),(546434,15179,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆà¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸à¸²à¸£à¸‚à¸²à¸¢à¸—à¸µà¹ˆ 3dcart',0),(546435,15179,'hi','3dcart à¤ªà¤° à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¹à¥€à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¤¾',0),(546436,15179,'ms','Mengemas kini bukan untuk jualan seting pada 3dcart',0),(546437,15179,'ar','ØªØ­Ø¯ÙŠØ« Ù„Ø§ Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø¨ÙŠØ¹ ÙÙŠ 3dcart',0),(546438,15179,'fr','Mise Ã  jour pas pour vendre des paramÃ¨tres 3dcart',0),(546439,15179,'jp','ãªã„ 3dcart ã§è²©å£²è¨­å®šã®æ›´æ–°',0),(546440,15179,'pt','Atualizando nÃ£o para configuraÃ§Ãµes de venda em 3dcart',0),(546441,15179,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ðµ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð² Ð½Ð° 3dcart',0),(546442,15179,'es','ActualizaciÃ³n no para ajustes de venta en 3dcart',0),(546443,15179,'de','Aktualisierung nicht fÃ¼r Sale-Einstellungen bei 3dcart',0),(546444,15179,'en','Updating Not For Sale Settings At 3dcart',0),(546445,15180,'is','',0),(546446,15180,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ú©Ø§Ù„Ø§Ù‡Ø§ Ø¯Ø± 3dcart',0),(546447,15180,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ú©Ø§Ù„Ø§Ù‡Ø§ Ø¯Ø± 3dcart',0),(546448,15180,'tr','3dcart adlÄ± Ã¼rÃ¼n aÃ§Ä±klamalarÄ± gÃ¼ncelleÅŸtiriliyor',0),(546449,15180,'pl','Aktualizacja opisÃ³w produktÃ³w w 3dcart',0),(546450,15180,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸ÑÑ‚Ð° Ð² 3dcart',0),(546451,15180,'ur','Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ Ø¬Ù…Ù„Û ØªÙØµÛŒÙ„Ø§Øª 3dcart Ù¾Ø± ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(546452,15180,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¾Ð¿Ð¸ÑÐ° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð° Ñƒ 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(546453,15180,'vi','MÃ´ táº£ sáº£n pháº©m Cáº­p Nháº­t táº¡i 3dcart',0),(546454,15180,'af','Outobywerking produk beskrywings by 3dcart',0),(546455,15180,'ro','Actualizarea descrierile de produs la 3dcart',0),(546456,15180,'et','Ajakohastamine tootekirjeldused kell 3dcart',0),(546457,15180,'si','Posodabljanje poimenovanja izdelkov na 3dcart',0),(546458,15180,'ba','Deskripsi Produk update di 3dcart',0),(546459,15180,'nl','Productbeschrijvingen op 3dcart bijwerken',0),(546460,15180,'fi','PÃ¤ivittÃ¤Ã¤ tuotteen kuvaukset 3dcart',0),(546461,15180,'no','Oppdatere produktbeskrivelser pÃ¥ 3dcart',0),(546462,15180,'da','Opdatere produktbeskrivelser pÃ¥ 3dcart',0),(546463,15180,'ko','3dcartì—ì„œ ì œí’ˆ ì„¤ëª… ì—…ë°ì´íŠ¸',0),(546464,15180,'he','×¢×“×›×•×Ÿ ×ª×™××•×¨×™ ×ž×•×¦×¨ ×‘ 3dcart',0),(546465,15180,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Ï‰Î½ ÏƒÏ„Î¿ 3dcart',0),(546466,15180,'zh','åœ¨ 3dcart çš„æ›´æ–°çš„äº§å“è¯´æ˜Žã€‚',0),(546467,15180,'sv','Uppdatera produktbeskrivningar pÃ¥ 3dcart',0),(546468,15180,'it','Aggiornamento descrizioni di prodotto presso 3dcart',0),(546469,15180,'tl','',0),(546470,15180,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¸—à¸µà¹ˆ 3dcart',0),(546471,15180,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ 3dcart à¤ªà¤° à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤µà¤¿à¤µà¤°à¤£',0),(546472,15180,'ms','Mengemas kini keterangan produk di 3dcart',0),(546473,15180,'ar','ØªØ­Ø¯ÙŠØ« Ù…ÙˆØ§ØµÙØ§Øª Ø§Ù„Ù…Ù†ØªØ¬Ø§Øª ÙÙŠ 3dcart',0),(546474,15180,'fr','Mise Ã  jour des Descriptions de produits Ã  3dcart',0),(546475,15180,'jp','3dcart ã§ã®è£½å“ã®èª¬æ˜Žã®æ›´æ–°',0),(546476,15180,'pt','Atualizando as descriÃ§Ãµes do produto no 3dcart',0),(546477,15180,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° Ð½Ð° 3dcart',0),(546478,15180,'es','ActualizaciÃ³n de descripciones de los productos en 3dcart',0),(546479,15180,'de','Produktbeschreibungen auf 3dcart aktualisieren',0),(546480,15180,'en','Updating Product Descriptions At 3dcart',0),(546481,15181,'is','',0),(546482,15181,'dr','Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´',0),(546483,15181,'pr','Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´',0),(546484,15181,'tr','SatÄ±lÄ±k deÄŸil',0),(546485,15181,'pl','Nie na sprzedaÅ¼',0),(546486,15181,'bg','ÐÐµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(546487,15181,'ur','Ù†Û ÙØ±ÙˆØ®Øª Ú©Û’ Ù„Ø¦Û’',0),(546488,15181,'sr','ÐÐ¸Ñ˜Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(546489,15181,'vi','KhÃ´ng pháº£i Ä‘á»ƒ bÃ¡n',0),(546490,15181,'af','Nie vir verkoop',0),(546491,15181,'ro','Nu de vÃ¢nzare',0),(546492,15181,'et','Mitte mÃ¼Ã¼giks',0),(546493,15181,'si','Ni za prodajo',0),(546494,15181,'ba','Tidak untuk dijual',0),(546495,15181,'nl','Niet voor verkoop',0),(546496,15181,'fi','Ei ole myytÃ¤vÃ¤nÃ¤',0),(546497,15181,'no','Ikke til salgs',0),(546498,15181,'da','Ikke til salg',0),(546499,15181,'ko','íŒë§¤ë¥¼ ìœ„í•´ ì•„ë‹™ë‹ˆë‹¤',0),(546500,15181,'he','. ×œ× ×œ×ž×›×™×¨×”',0),(546501,15181,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Ï€ÏÎ¿Ï‚ Ï€ÏŽÎ»Î·ÏƒÎ·',0),(546502,15181,'zh','éžå–å“',0),(546503,15181,'sv','Inte till salu',0),(546504,15181,'it','Non in vendita',0),(546505,15181,'tl','',0),(546506,15181,'th','à¹„à¸¡à¹ˆà¹€à¸Šà¹ˆà¸²',0),(546507,15181,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¹à¥€à¤‚',0),(546508,15181,'ms','Bukan untuk dijual',0),(546509,15181,'ar','Ù„ÙŠØ³ Ù„Ù„Ø¨ÙŠØ¹',0),(546510,15181,'fr','Pas Ã  vendre',0),(546511,15181,'jp','å£²ã‚Šç‰©ã§ã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(546512,15181,'pt','NÃ£o estÃ¡ Ã  venda',0),(546513,15181,'ru','ÐÐµ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(546514,15181,'es','No para la venta',0),(546515,15181,'de','Nicht zum Verkauf',0),(546516,15181,'en','Not For Sale',0),(546517,15182,'is','',0),(546518,15182,'dr','Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´ ÙÙ‚Ø·',0),(546519,15182,'pr','Ù†Ù‡ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´ ÙÙ‚Ø·',0),(546520,15182,'tr','SatÄ±lÄ±k deÄŸil sadece',0),(546521,15182,'pl','Nie na sprzedaÅ¼ tylko',0),(546522,15182,'bg','ÐÐµ Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð° ÑÐ°Ð¼Ð¾',0),(546523,15182,'ur','Ù†Û ÙØ±ÙˆØ®Øª Ú©Û’ Ù„Ø¦Û’ ØµØ±Ù',0),(546524,15182,'sr','ÐÐ¸Ñ˜Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ ÑÐ°Ð¼Ð¾',0),(546525,15182,'vi','KhÃ´ng pháº£i Ä‘á»ƒ bÃ¡n chá»‰',0),(546526,15182,'af','Nie vir verkoop net',0),(546527,15182,'ro','Nu de vÃ¢nzare numai',0),(546528,15182,'et','Mitte mÃ¼Ã¼giks vaid',0),(546529,15182,'si','Ne naprodaj le',0),(546530,15182,'ba','Tidak untuk dijual hanya',0),(546531,15182,'nl','Niet voor verkoop alleen',0),(546532,15182,'fi','Ei ole myytÃ¤vÃ¤nÃ¤ vain',0),(546533,15182,'no','Ikke For bare',0),(546534,15182,'da','Ikke til salg kun',0),(546535,15182,'ko','íŒë§¤ë§Œì„ ìœ„í•´ì„œê°€ ì•„ë‹ˆê³ ',0),(546536,15182,'he','×œ× ×œ×ž×›×™×¨×” ×‘×œ×‘×“',0),(546537,15182,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Ï€ÏÎ¿Ï‚ Ï€ÏŽÎ»Î·ÏƒÎ· Î¼ÏŒÎ½Î¿',0),(546538,15182,'zh','ä¸æ˜¯ä¸ºäº†åªå‡ºå”®',0),(546539,15182,'sv','Inte till salu endast',0),(546540,15182,'it','Non in vendita solo',0),(546541,15182,'tl','',0),(546542,15182,'th','à¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆà¸ªà¸³à¸«à¸£à¸±à¸šà¸‚à¸²à¸¢à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(546543,15182,'hi','à¤¨à¤¹à¥€à¤‚ à¤¹à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(546544,15182,'ms','Bukan untuk dijual hanya',0),(546545,15182,'ar','Ù„ÙŠØ³ Ù„Ù„Ø¨ÙŠØ¹ ÙÙ‚Ø·',0),(546546,15182,'fr','Non Ã  la vente uniquement',0),(546547,15182,'jp','å£²ã‚Šç‰©ã§ã¯ã‚ã‚Šã¾ã›ã‚“ã®ã¿',0),(546548,15182,'pt','NÃ£o estÃ¡ Ã  venda somente',0),(546549,15182,'ru','ÐÐµ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(546550,15182,'es','No sÃ³lo para la venta',0),(546551,15182,'de','Nicht zum Verkauf nur',0),(546552,15182,'en','Not For Sale Only',0),(546553,15183,'is','',0),(546554,15183,'dr','Ø±Ø§Ø¨Ø· Ø¨ØªØ§',0),(546555,15183,'pr','Ø±Ø§Ø¨Ø· Ø¨ØªØ§',0),(546556,15183,'tr','Beta arayÃ¼zey',0),(546557,15183,'pl','Beta interfejs',0),(546558,15183,'bg','Ð‘ÐµÑ‚Ð° Ð¸Ð½Ñ‚ÐµÑ€Ñ„ÐµÐ¹Ñ',0),(546559,15183,'ur','Ø¨ÛŒ Ù¹Ø§ Ø§Ù†Ù¹Ø±ÙÛŒØ³',0),(546560,15183,'sr','Ð‘ÐµÑ‚Ð° Ð¸Ð½Ñ‚ÐµÑ€Ñ„ÐµÑ˜ÑÐ°',0),(546561,15183,'vi','PhiÃªn báº£n beta giao diá»‡n',0),(546562,15183,'af','Beta-koppelvlak',0),(546563,15183,'ro','InterfaÅ£Äƒ de beta',0),(546564,15183,'et','Beta liides',0),(546565,15183,'si','Beta vmesnik',0),(546566,15183,'ba','Beta antarmuka',0),(546567,15183,'nl','Beta Interface',0),(546568,15183,'fi','LÃ¤hteÃ¤ jhk liitÃ¤ntÃ¤',0),(546569,15183,'no','Beta grenseflate',0),(546570,15183,'da','Beta grÃ¦nseflade',0),(546571,15183,'ko','ë² íƒ€ ì¸í„°íŽ˜ì´ìŠ¤',0),(546572,15183,'he','×ž×ž×©×§ ×‘×˜×',0),(546573,15183,'el','Î’Î®Ï„Î± Î´Î¹ÎµÏ€Î±Ï†Î®',0),(546574,15183,'zh','Beta ç‰ˆç•Œé¢',0),(546575,15183,'sv','Beta grÃ¤nssnitt',0),(546576,15183,'it','Interfaccia beta',0),(546577,15183,'tl','',0),(546578,15183,'th','à¸­à¸´à¸™à¹€à¸—à¸­à¸£à¹Œà¹€à¸Ÿà¸ªà¹€à¸šà¸•à¹‰à¸²',0),(546579,15183,'hi','à¤¬à¥€à¤Ÿà¤¾ à¤‡à¤‚à¤Ÿà¤°à¤«à¤¼à¥‡à¤¸',0),(546580,15183,'ms','Antara muka Beta',0),(546581,15183,'ar','ÙˆØ§Ø¬Ù‡Ø© Ø¨ÙŠØªØ§',0),(546582,15183,'fr','Interface Beta',0),(546583,15183,'jp','ãƒ™ãƒ¼ã‚¿ ãƒ» ã‚¤ãƒ³ã‚¿ãƒ¼ãƒ•ã‚§ãƒ¼ã‚¹',0),(546584,15183,'pt','Interface beta',0),(546585,15183,'ru','Ð˜Ð½Ñ‚ÐµÑ€Ñ„ÐµÐ¹Ñ Ð±ÐµÑ‚Ð°',0),(546586,15183,'es','Interfaz beta',0),(546587,15183,'de','Beta-Schnittstelle',0),(546588,15183,'en','Beta Interface',0),(546589,15184,'is','',0),(546590,15184,'dr','NP6 Ø±Ø§Ø¨Ø·',0),(546591,15184,'pr','NP6 Ø±Ø§Ø¨Ø·',0),(546592,15184,'tr','NP6 arabirim',0),(546593,15184,'pl','Interfejs NP6',0),(546594,15184,'bg','NP6 Ð¸Ð½Ñ‚ÐµÑ€Ñ„ÐµÐ¹Ñ',0),(546595,15184,'ur','NP6 Ø³Ø·Ø­ Ø§Ù„Ø¨ÛŒÙ†',0),(546596,15184,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ñ„ÐµÑ˜Ñ Ð½ÐŸ6',0),(546597,15184,'vi','Giao diá»‡n NP6',0),(546598,15184,'af','NP6 koppelvlak',0),(546599,15184,'ro','Interfata NP6',0),(546600,15184,'et','NP6 liides',0),(546601,15184,'si','NP6 vmesnik',0),(546602,15184,'ba','NP6 antarmuka',0),(546603,15184,'nl','NP6 Interface',0),(546604,15184,'fi','NP6 kÃ¤yttÃ¶liittymÃ¤',0),(546605,15184,'no','NP6 grensesnitt',0),(546606,15184,'da','NP6 grÃ¦nseflade',0),(546607,15184,'ko','NP6 ì¸í„°íŽ˜ì´ìŠ¤',0),(546608,15184,'he','×ž×ž×©×§ NP6',0),(546609,15184,'el','NP6 Î´Î¹ÎµÏ€Î±Ï†Î®',0),(546610,15184,'zh','NP6 æŽ¥å£',0),(546611,15184,'sv','NP6 grÃ¤nssnitt',0),(546612,15184,'it','Interfaccia NP6',0),(546613,15184,'tl','',0),(546614,15184,'th','à¸­à¸´à¸™à¹€à¸—à¸­à¸£à¹Œà¹€à¸Ÿà¸‹ NP6',0),(546615,15184,'hi','NP6 à¤‡à¤‚à¤Ÿà¤°à¤«à¤¼à¥‡à¤¸',0),(546616,15184,'ms','Antara muka NP6',0),(546617,15184,'ar','ÙˆØ§Ø¬Ù‡Ø© NP6',0),(546618,15184,'fr','NP6 Interface',0),(546619,15184,'jp','NP6 ã‚¤ãƒ³ã‚¿ãƒ¼ãƒ•ã‚§ã‚¤ã‚¹',0),(546620,15184,'pt','Interface NP6',0),(546621,15184,'ru','NP6 Ð¸Ð½Ñ‚ÐµÑ€Ñ„ÐµÐ¹Ñ',0),(546622,15184,'es','Interfaz NP6',0),(546623,15184,'de','NP6-Schnittstelle',0),(546624,15184,'en','NP6 Interface',0),(546625,15185,'is','',0),(546626,15185,'dr','Ú©Ø§Ø±Ø¨Ø± ÙˆØ§Ø±Ø¯ Ø³ÛŒØ³ØªÙ… Ø¨Ø§ÛŒØ¯',0),(546627,15185,'pr','Ú©Ø§Ø±Ø¨Ø± ÙˆØ§Ø±Ø¯ Ø³ÛŒØ³ØªÙ… Ø¨Ø§ÛŒØ¯',0),(546628,15185,'tr','KullanÄ±cÄ± oturum aÃ§malÄ±sÄ±nÄ±z',0),(546629,15185,'pl','UÅ¼ytkownik musi zalogowaÄ‡',0),(546630,15185,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð»ÐµÐ·ÐµÑ‚Ðµ Ð¾Ñ‚',0),(546631,15185,'ur','ØµØ§Ø±Ù Ù„Ø§Ú¯',0),(546632,15185,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð¼Ð¾Ñ€Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸',0),(546633,15185,'vi','NgÆ°á»i dÃ¹ng pháº£i Ä‘Äƒng xuáº¥t',0),(546634,15185,'af','Gebruiker moet teken',0),(546635,15185,'ro','Utilizatorul trebuie sÄƒ Log Out',0),(546636,15185,'et','Kasutaja peab Logi vÃ¤lja',0),(546637,15185,'si','Uporabnik mora odjaviti',0),(546638,15185,'ba','Pengguna harus Log Out',0),(546639,15185,'nl','Gebruiker moet uitloggen',0),(546640,15185,'fi','KÃ¤yttÃ¤jÃ¤n on kirjauduttava',0),(546641,15185,'no','Brukeren mÃ¥ logge',0),(546642,15185,'da','Brugeren skal logge',0),(546643,15185,'ko','ì‚¬ìš©ìž ë¡œê·¸ ì•„ì›ƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(546644,15185,'he','×”×ž×©×ª×ž×© ×—×™×™×‘ ×œ×”×™×›× ×¡',0),(546645,15185,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î±Ï€Î¿ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Ï‡ÏÎ®ÏƒÏ„Î·',0),(546646,15185,'zh','ç”¨æˆ·å¿…é¡»æ³¨é”€',0),(546647,15185,'sv','AnvÃ¤ndaren mÃ¥ste logga',0),(546648,15185,'it','Utente deve disconnettersi',0),(546649,15185,'tl','',0),(546650,15185,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸•à¹‰à¸­à¸‡à¸­à¸­à¸à¸ˆà¸²à¸à¸£à¸°à¸šà¸š',0),(546651,15185,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤²à¥‰à¤— à¤‡à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(546652,15185,'ms','Pengguna mestilah Log Keluar',0),(546653,15185,'ar','ÙŠØ¬Ø¨ Ø¹Ù„Ù‰ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… ØªØ³Ø¬ÙŠÙ„',0),(546654,15185,'fr','L\'utilisateur doit fermer la session',0),(546655,15185,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ãŒãƒ­ã‚°ã‚¢ã‚¦ãƒˆã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(546656,15185,'pt','UsuÃ¡rio deve logout',0),(546657,15185,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð²Ñ‹Ð¹Ñ‚Ð¸',0),(546658,15185,'es','Usuario debe cerrar la sesiÃ³n',0),(546659,15185,'de','Benutzer muss sich abmelden',0),(546660,15185,'en','User Must Log Out',0),(546661,15186,'is','',0),(546662,15186,'dr','Ø¢Ø®Ø±ÛŒÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù‡ Ù…ÙˆØ±Ø¯',0),(546663,15186,'pr','Ø¢Ø®Ø±ÛŒÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø´Ø¯Ù‡ Ù…ÙˆØ±Ø¯',0),(546664,15186,'tr','Son gÃ¼ncelleÅŸtirilen Ã¶ÄŸeyi',0),(546665,15186,'pl','Ostatnio aktualizowany element',0),(546666,15186,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(546667,15186,'ur','Ø¢Ø®Ø±ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø´Û’',0),(546668,15186,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ° ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(546669,15186,'vi','Má»¥c cuá»‘i cÃ¹ng Cáº­p Nháº­t',0),(546670,15186,'af','Laaste opgedateer Item',0),(546671,15186,'ro','Ultimul element actualizat',0),(546672,15186,'et','Viimati vÃ¤rskendatud Ã¼ksust',0),(546673,15186,'si','Zadnjega posodobljenega elementa',0),(546674,15186,'ba','Item terakhir diperbarui',0),(546675,15186,'nl','Laatste bijgewerkte Item',0),(546676,15186,'fi','Viimeinen pÃ¤ivitetty kohde',0),(546677,15186,'no','Siste oppdaterte elementet',0),(546678,15186,'da','Sidste opdateret vare',0),(546679,15186,'ko','ìµœê·¼ ì—…ë°ì´íŠ¸ í•­ëª©',0),(546680,15186,'he','×”×¤×¨×™×˜ ×”×ž×¢×•×“×›×Ÿ ×”××—×¨×•×Ÿ',0),(546681,15186,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(546682,15186,'zh','æœ€åŽæ›´æ–°çš„é¡¹ç›®',0),(546683,15186,'sv','Senaste uppdaterade objektet',0),(546684,15186,'it','Ultimo elemento aggiornato',0),(546685,15186,'tl','',0),(546686,15186,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(546687,15186,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤…à¤ªà¤¡à¥‡à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤†à¤‡à¤Ÿà¤®',0),(546688,15186,'ms','Item dikemaskini terakhir',0),(546689,15186,'ar','Ø¢Ø®Ø± ØªØ­Ø¯ÙŠØ« Ø¹Ù†ØµØ±',0),(546690,15186,'fr','Dernier Ã©lÃ©ment mis Ã  jour',0),(546691,15186,'jp','æœ€å¾Œã®æ›´æ–°é …ç›®',0),(546692,15186,'pt','Ãšltimo Item atualizado',0),(546693,15186,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(546694,15186,'es','Ãšltimo actualizado',0),(546695,15186,'de','Letzte aktualisierte Element',0),(546696,15186,'en','Last Updated Item',0),(546697,15187,'is','',0),(546698,15187,'dr','Ø³Ù‡Ø§Ù… Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø³Ø·Ø­ Ø²Ù…ÙŠÙ†Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø§Ø±Ø³Ø§Ù„',0),(546699,15187,'pr','Ø³Ù‡Ø§Ù… Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø³Ø·Ø­ Ø²Ù…ÙŠÙ†Ù‡ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø§Ø±Ø³Ø§Ù„',0),(546700,15187,'tr','Arka plan iÅŸleme iÃ§in gÃ¶nderilen stok dÃ¼zeyi gÃ¼ncelleÅŸtirmeleri',0),(546701,15187,'pl','Czas aktualizacji poziomu wysyÅ‚ane do przetwarzania w tle',0),(546702,15187,'bg','Ð¡ÑŠÑÑ‚Ð°Ð² Ð½Ð¸Ð²Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð·Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° Ñ„Ð¾Ð½Ð°',0),(546703,15187,'ur','Ù¾Ø³ Ù…Ù†Ø¸Ø± Ú©ÛŒ Ù¾Ø±Ø§Ø³ÛŒØ³Ù†Ú¯ Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬Û’ Ú¯Ø¦Û’ Ø§Ø³Ù¹Ø§Ú© Ø³Ø·Ø­ Ø§Ù¾ ÚˆÛŒÙ¹Ø³',0),(546704,15187,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð½Ð¸Ð²Ð¾Ð° Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐµ Ð¿Ð¾ÑÐ»Ð°Ñ‚ Ð½Ð° Ð¾Ð±Ñ€Ð°Ð´Ñƒ Ñƒ Ð¿Ð¾Ð·Ð°Ð´Ð¸Ð½Ð¸',0),(546705,15187,'vi','Cá»• phiáº¿u Cáº­p Nháº­t cáº¥p cho ná»n xá»­ lÃ½',0),(546706,15187,'af','Voorraad vlak bywerkings gestuur vir agtergrond verwerking',0),(546707,15187,'ro','Stoc actualizÄƒri nivel fundal procesate',0),(546708,15187,'et','Varude taseme vÃ¤rskendused taustal tÃ¶Ã¶tlemiseks saadetud',0),(546709,15187,'si','Zalog ravni posodobitve, poslani v obdelavo ozadje',0),(546710,15187,'ba','Saham tingkat update dikirim untuk pengolahan latar belakang',0),(546711,15187,'nl','Voorraad niveau Updates verzonden voor achtergrondverwerking',0),(546712,15187,'fi','Kanta tason pÃ¤ivitykset taustalla kÃ¤sitellÃ¤Ã¤n',0),(546713,15187,'no','Lager nivÃ¥ oppdateringer sendt For bakgrunnsprosessering',0),(546714,15187,'da','Stock niveau opdateringer sendes til baggrundsbehandling',0),(546715,15187,'ko','ìž¬ê³  ìˆ˜ì¤€ ì—…ë°ì´íŠ¸ ë°°ê²½ ì²˜ë¦¬ë¥¼ ìœ„í•´ ë³´ë‚¸',0),(546716,15187,'he','×¢×“×›×•× ×™× ×¨×ž×ª ×ž×œ××™ × ×©×œ×— ×œ×¢×™×‘×•×“ ×¨×§×¢',0),(546717,15187,'el','Î•Î½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹Ï‚ ÎµÏ€Î¯Ï€ÎµÎ´Î¿ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ Î³Î¹Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ„Î¿ Ï€Î±ÏÎ±ÏƒÎºÎ®Î½Î¹Î¿',0),(546718,15187,'zh','å‘é€ä¸ºåŽå°å¤„ç†çš„åº“å­˜çº§åˆ«æ›´æ–°',0),(546719,15187,'sv','Lager nivÃ¥ uppdateringar skickas fÃ¶r behandling i bakgrunden',0),(546720,15187,'it','Magazzino livelli aggiornamenti inviati per l\'elaborazione in Background',0),(546721,15187,'tl','',0),(546722,15187,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸°à¸”à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥à¹€à¸šà¸·à¹‰à¸­à¸‡à¸«à¸¥à¸±à¸‡',0),(546723,15187,'hi','à¤¶à¥‡à¤¯à¤° à¤¤à¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥ƒà¤·à¥à¤ à¤­à¥‚à¤®à¤¿ à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œà¤¾',0),(546724,15187,'ms','Pengemaskinian peringkat stok yang dihantar untuk diproses latar belakang',0),(546725,15187,'ar','Ø§Ù„Ø£Ø³Ù‡Ù… ÙˆØ§Ù„Ù…Ø³ØªØ¬Ø¯Ø§Øª Ù…Ø³ØªÙˆÙ‰ Ø¥Ø±Ø³Ø§Ù„Ù‡Ø§ Ù„ØªØ¬Ù‡ÙŠØ² Ø§Ù„Ø®Ù„ÙÙŠØ©',0),(546726,15187,'fr','Stocks mises Ã  jour niveau envoyÃ©s pour traitement en arriÃ¨re-plan',0),(546727,15187,'jp','ãƒãƒƒã‚¯ ã‚°ãƒ©ã‚¦ãƒ³ãƒ‰å‡¦ç†ã®ãŸã‚é€ä¿¡ãƒ¬ãƒ™ãƒ«ã®åœ¨åº«ã®æ›´æ–°',0),(546728,15187,'pt','AtualizaÃ§Ãµes de nÃ­vel estoque enviadas para processamento em Background',0),(546729,15187,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²Ð½Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ Ð´Ð»Ñ Ñ„Ð¾Ð½Ð¾Ð²Ð¾Ð¹ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸',0),(546730,15187,'es','Actualizaciones niveles stock enviadas para procesamiento en segundo plano',0),(546731,15187,'de','Lager Level-Updates fÃ¼r die Hintergrundverarbeitung gesendet',0),(546732,15187,'en','Stock Level Updates Sent For Background Processing',0),(546733,15188,'is','',0),(546734,15188,'dr','3dcart Ø³Ø·Ø­ Ø³Ù‡Ø§Ù… Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(546735,15188,'pr','3dcart Ø³Ø·Ø­ Ø³Ù‡Ø§Ù… Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(546736,15188,'tr','3dcart stok dÃ¼zeylerini otomatik olarak gÃ¼ncelleÅŸtir',0),(546737,15188,'pl','Automatyczna aktualizacja 3dcart zapasÃ³w',0),(546738,15188,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° 3dcart Ð½Ð¸Ð²Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ',0),(546739,15188,'ur','3dcart Ø§Ø³Ù¹Ø§Ú© Ø³Ø·Ø­ Ø§Ø² Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(546740,15188,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð½Ð¸Ð²Ð¾Ðµ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð°',0),(546741,15188,'vi','Cáº­p Nháº­t 3dcart cá»• phiáº¿u cáº¥p tá»± Ä‘á»™ng',0),(546742,15188,'af','3dcart voorraadvlakke outomaties opdateer',0),(546743,15188,'ro','Actualiza automat 3dcart nivelurile stocurilor',0),(546744,15188,'et','3dcart varude taseme automaatse vÃ¤rskendamise',0),(546745,15188,'si','Samodejno posodabljanje ravni zalog 3dcart',0),(546746,15188,'ba','Memperbarui tingkat stok 3dcart secara otomatis',0),(546747,15188,'nl','3dcart voorraad automatisch bijwerken',0),(546748,15188,'fi','PÃ¤ivitÃ¤ 3dcart varastot automaattisesti',0),(546749,15188,'no','Oppdatere lagernivÃ¥er for 3dcart automatisk',0),(546750,15188,'da','Opdatere 3dcart lagerbeholdningerne automatisk',0),(546751,15188,'ko','3dcart ìž¬ê³  ìˆ˜ì¤€ì„ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(546752,15188,'he','×¢×“×›×•×Ÿ 3dcart ×¨×ž×•×ª ×ž×œ××™ ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(546753,15188,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart ÎµÏ€Î¯Ï€ÎµÎ´Î± Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(546754,15188,'zh','è‡ªåŠ¨æ›´æ–° 3dcart åº“å­˜æ°´å¹³',0),(546755,15188,'sv','Uppdatera 3dcart lagernivÃ¥erna automatiskt',0),(546756,15188,'it','Aggiornare automaticamente il livello delle scorte 3dcart',0),(546757,15188,'tl','',0),(546758,15188,'th','à¸­à¸±à¸žà¹€à¸” 3dcart à¸£à¸°à¸”à¸±à¸šà¸ªà¸•à¹‡à¸­à¸à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(546759,15188,'hi','3dcart à¤¸à¥à¤Ÿà¥‰à¤• à¤¸à¥à¤¤à¤° à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(546760,15188,'ms','Kemaskini Terakhir tahap saham 3dcart secara automatik',0),(546761,15188,'ar','ØªØ­Ø¯ÙŠØ« 3dcart Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹',0),(546762,15188,'fr','Mettre Ã  jour automatiquement les niveaux de Stock 3dcart',0),(546763,15188,'jp','3dcart åœ¨åº«ãƒ¬ãƒ™ãƒ«ã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(546764,15188,'pt','Atualizar automaticamente o nÃ­vel de estoque 3dcart',0),(546765,15188,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart ÑƒÑ€Ð¾Ð²Ð½Ð¸ Ð·Ð°Ð¿Ð°ÑÐ¾Ð²',0),(546766,15188,'es','Actualizar automÃ¡ticamente los niveles de existencias 3dcart',0),(546767,15188,'de','3dcart LagerbestÃ¤nde automatisch aktualisieren',0),(546768,15188,'en','Update 3dcart Stock Levels Automatically',0),(546769,15189,'is','',0),(546770,15189,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø³Ø·Ø­ Ø³Ù‡Ø§Ù… Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart',0),(546771,15189,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø³Ø·Ø­ Ø³Ù‡Ø§Ù… Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart',0),(546772,15189,'tr','Bu 3dcart deposu iÃ§in stok dÃ¼zeylerini GÃ¼ncelleÅŸtir',0),(546773,15189,'pl','Aktualizacja zapasÃ³w dla tego sklepu 3dcart',0),(546774,15189,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð¸Ð²Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ Ð·Ð° Ñ‚Ð¾Ð²Ð° 3dcart Ñ…Ñ€Ð°Ð½Ð¸Ð»Ð¸Ñ‰Ðµ',0),(546775,15189,'ur','ÛŒÛ 3dcart Ø§Ø³Ù¹ÙˆØ± Ú©Û’ Ù„Ø¦Û’ Ø§Ø³Ù¹Ø§Ú© Ú©ÛŒ Ø³Ø·Ø­ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(546776,15189,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð¸Ð²Ð¾Ðµ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð° Ð·Ð° Ð¾Ð²Ñƒ Ñ€Ð°Ð´ÑšÑƒ 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(546777,15189,'vi','Cáº­p Nháº­t cá»• phiáº¿u cáº¥p cho cá»­a hÃ ng 3dcart nÃ y',0),(546778,15189,'af','Voorraadvlakke vir hierdie 3dcart Winkel werk',0),(546779,15189,'ro','Nivelul stocurilor de actualizare pentru acest magazin 3dcart',0),(546780,15189,'et','Uuenda varude tase see 3dcart pood',0),(546781,15189,'si','Posodobitev zalog za to trgovino 3dcart',0),(546782,15189,'ba','Memperbarui tingkat stok untuk toko 3dcart ini',0),(546783,15189,'nl','Voorraad updateniveaus voor deze 3dcart winkel',0),(546784,15189,'fi','PÃ¤ivitÃ¤ varastotasot 3dcart Store',0),(546785,15189,'no','Oppdatere lagernivÃ¥er For denne 3dcart butikken',0),(546786,15189,'da','Opdatere lagerbeholdningerne For denne 3dcart butik',0),(546787,15189,'ko','ì´ 3dcart ì €ìž¥ì†Œì— ëŒ€ í•œ ìž¬ê³  ìˆ˜ì¤€ ì—…ë°ì´íŠ¸',0),(546788,15189,'he','×¢×“×›×•×Ÿ ×¨×ž×•×ª ×ž×œ××™ ×”×—× ×•×ª 3dcart',0),(546789,15189,'el','Î•Ï€Î¯Ï€ÎµÎ´Î± Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± 3dcart',0),(546790,15189,'zh','æ›´æ–°æ­¤ 3dcart å•†åº—çš„åº“å­˜æ°´å¹³',0),(546791,15189,'sv','Uppdatera lagernivÃ¥er fÃ¶r denna 3dcart butik',0),(546792,15189,'it','Aggiornare i livelli delle scorte per questo archivio 3dcart',0),(546793,15189,'tl','',0),(546794,15189,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸°à¸”à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¹‰à¸²à¸™ 3dcart à¸™à¸µà¹‰',0),(546795,15189,'hi','à¤‡à¤¸ 3dcart à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤Ÿà¥‰à¤• à¤•à¥‡ à¤¸à¥à¤¤à¤° à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(546796,15189,'ms','Kemaskini stok tahap untuk kedai 3dcart ini',0),(546797,15189,'ar','ØªØ­Ø¯ÙŠØ« Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ù„Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²Ù† 3dcart',0),(546798,15189,'fr','Mise Ã  jour des niveaux de Stock pour ce magasin de 3dcart',0),(546799,15189,'jp','ã“ã® 3dcart ã‚¹ãƒˆã‚¢ã®åœ¨åº«ãƒ¬ãƒ™ãƒ«ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(546800,15189,'pt','NÃ­veis de estoque de atualizaÃ§Ã£o para esta loja de 3dcart',0),(546801,15189,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð° 3dcart',0),(546802,15189,'es','ActualizaciÃ³n de los niveles de Stock para esta tienda 3dcart',0),(546803,15189,'de','Update LagerbestÃ¤nde fÃ¼r diesen 3dcart-Speicher',0),(546804,15189,'en','Update Stock Levels For This 3dcart Store',0),(546805,15190,'is','',0),(546806,15190,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¢Ø®Ø±ÛŒÙ† Ù…ÙˆØ±Ø¯ Ø¨Ø±ÙˆØ²',0),(546807,15190,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ø¢Ø®Ø±ÛŒÙ† Ù…ÙˆØ±Ø¯ Ø¨Ø±ÙˆØ²',0),(546808,15190,'tr','GÃ¶rÃ¼nÃ¼m son Ã¶ÄŸe gÃ¼ncelleÅŸtirildi',0),(546809,15190,'pl','Widok ostatnia aktualizacja pozycji',0),(546810,15190,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(546811,15190,'ur','Ù…Ù†Ø¸Ø± Ø´Û’ Ø¸Ø§ÛØ± Ú©Ø±Ù†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(546812,15190,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ñ˜Ðµ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿ÑƒÑ‚ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð° ÑÑ‚Ð°Ð²ÐºÐ°',0),(546813,15190,'vi','Xem má»¥c Cáº­p Nháº­t',0),(546814,15190,'af','Bekyk laas bygewerk Item',0),(546815,15190,'ro','Vezi ultima actualizare articol',0),(546816,15190,'et','Vaadet viimati uuendatud Ã¼ksus',0),(546817,15190,'si','Pogled Zadnja posodobitev elementa',0),(546818,15190,'ba','Lihat terakhir diperbarui Item',0),(546819,15190,'nl','Weergave Item voor het laatst bijgewerkt',0),(546820,15190,'fi','Katso pÃ¤ivitetty kohde',0),(546821,15190,'no','Vis oppdatert element',0),(546822,15190,'da','Se opdateret vare',0),(546823,15190,'ko','ë³´ê¸° ìµœê·¼ ì—…ë°ì´íŠ¸ í•­ëª©',0),(546824,15190,'he','×ª×¦×•×’×ª ×¤×¨×™×˜ ×¢×“×›×•×Ÿ ××—×¨×•×Ÿ',0),(546825,15190,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(546826,15190,'zh','æŸ¥çœ‹ä¸Šæ¬¡æ›´æ–°é¡¹ç›®',0),(546827,15190,'sv','Visa senast uppdaterade objekt',0),(546828,15190,'it','Vista ultimo aggiornamento articolo',0),(546829,15190,'tl','',0),(546830,15190,'th','à¸”à¸¹à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(546831,15190,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤…à¤‚à¤¤à¤¿à¤® à¤†à¤‡à¤Ÿà¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(546832,15190,'ms','Paparan Kemaskini Item',0),(546833,15190,'ar','Ø¢Ø®Ø± ØªØ­Ø¯ÙŠØ« Ø·Ø±ÙŠÙ‚Ø© Ø¹Ø±Ø¶ Ø§Ù„Ø¹Ù†ØµØ±',0),(546834,15190,'fr','Vue mise Ã  jour le point',0),(546835,15190,'jp','ã‚¢ã‚¤ãƒ†ãƒ ã‚’æœ€å¾Œã«æ›´æ–°ã•ã‚ŒãŸãƒ“ãƒ¥ãƒ¼',0),(546836,15190,'pt','Vista Ultima atualizaÃ§Ã£o Item',0),(546837,15190,'ru','ÐœÐ½ÐµÐ½Ð¸Ðµ ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(546838,15190,'es','Vista actualizada del artÃ­culo',0),(546839,15190,'de','Ansicht wurde zuletzt aktualisiert am Element',0),(546840,15190,'en','View Last Updated Item',0),(546841,15191,'is','',0),(546842,15191,'dr','Ø¢Ø®Ø±ÛŒÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø³Ù‡Ø§Ù… 3dcart',0),(546843,15191,'pr','Ø¢Ø®Ø±ÛŒÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø³Ù‡Ø§Ù… 3dcart',0),(546844,15191,'tr','Son 3dcart stok gÃ¼ncelleÅŸtirme',0),(546845,15191,'pl','Ostatnia aktualizacja zapasÃ³w 3dcart',0),(546846,15191,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ 3dcart Ð·Ð°Ð¿Ð°ÑÐ¸Ñ‚Ðµ Ð¾Ð±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(546847,15191,'ur','Ø¢Ø®Ø±ÛŒ 3dcart Ø§Ø³Ù¹Ø§Ú© ØªØ¬Ø¯ÛŒØ¯',0),(546848,15191,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð£Ð¿Ð´Ð°Ñ‚Ðµ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð°ÐºÑ†Ð¸Ñ˜Ð°',0),(546849,15191,'vi','Cáº­p Nháº­t cá»• pháº§n 3dcart',0),(546850,15191,'af','Laaste 3dcart voorraad bywerking',0),(546851,15191,'ro','Ultima actualizare stoc 3dcart',0),(546852,15191,'et','Viimase 3dcart varude uuendamine',0),(546853,15191,'si','Zadnja posodobitev zalog 3dcart',0),(546854,15191,'ba','Update terakhir saham 3dcart',0),(546855,15191,'nl','Laatste 3dcart voorraad Update',0),(546856,15191,'fi','Viimeinen 3dcart varaston pÃ¤ivitys',0),(546857,15191,'no','Siste 3dcart lager oppdatering',0),(546858,15191,'da','Sidste 3dcart aktieopdatering',0),(546859,15191,'ko','ë§ˆì§€ë§‰ 3dcart ìž¬ê³  ì—…ë°ì´íŠ¸',0),(546860,15191,'he','×¢×“×›×•×Ÿ ××—×¨×•×Ÿ ×©×œ ×ž× ×™×•×ª 3dcart',0),(546861,15191,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ 3dcart',0),(546862,15191,'zh','3dcart è‚¡ç¥¨æœ€è¿‘æ›´æ–°',0),(546863,15191,'sv','Senaste 3dcart lager uppdatering',0),(546864,15191,'it','Ultimo aggiornamento magazzino 3dcart',0),(546865,15191,'tl','',0),(546866,15191,'th','3dcart à¸«à¸¸à¹‰à¸™à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(546867,15191,'hi','à¤ªà¤¿à¤›à¤²à¥‡ 3dcart à¤¸à¥à¤Ÿà¥‰à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(546868,15191,'ms','3dcart stok dikemaskini',0),(546869,15191,'ar','Ø¢Ø®Ø± ØªØ­Ø¯ÙŠØ« Ù„Ù„Ø£Ø³Ù‡Ù… 3dcart',0),(546870,15191,'fr','DerniÃ¨re mise a jour Stock 3dcart',0),(546871,15191,'jp','æœ€å¾Œã® 3dcart æ ªä¾¡æƒ…å ±æ›´æ–°',0),(546872,15191,'pt','Ãšltima atualizaÃ§Ã£o de estoque 3dcart',0),(546873,15191,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² 3dcart',0),(546874,15191,'es','Ãšltima actualizaciÃ³n Stock 3dcart',0),(546875,15191,'de','Letzte 3dcart Bestandsfortschreibung',0),(546876,15191,'en','Last 3dcart Stock Update',0),(546877,15192,'is','',0),(546878,15192,'dr','Ø­Ø±Ú©Øª Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø± ÙÙ‡Ù… Ùˆ Outs',0),(546879,15192,'pr','Ø­Ø±Ú©Øª Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø± ÙÙ‡Ù… Ùˆ Outs',0),(546880,15192,'tr','Bekleyen Ins ve aÅŸÄ±mlarÄ±nÄ± taÅŸÄ±yÄ±n.',0),(546881,15192,'pl','Ruch czasu in/out',0),(546882,15192,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ñ…Ð¾Ð´ Ins/Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²ÑÐ½Ðµ',0),(546883,15192,'ur','Ø¨Ù‚Ø§ÛŒØ§ Ø¬Ø§Øª/Ø¢Ø¤Ù¹ Ø¨Ú‘Ú¾Ø§Ø¦ÛŒÚº',0),(546884,15192,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð¿Ð¾Ñ‚ÐµÐ· ÑƒÐ¿Ð»Ð°Ñ‚Ðµ/Ð¸ÑÐ¿Ð»Ð°Ñ‚Ðµ',0),(546885,15192,'vi','Äang chá» xá»­ lÃ½ di chuyá»ƒn in/Outs',0),(546886,15192,'af','Hangende skuif Ins/uitdrukke',0),(546887,15192,'ro','PÃ¢nÄƒ muta intrarile/iesirile',0),(546888,15192,'et','Ootel liikuda lÃµhki',0),(546889,15192,'si','Do premakniti Ins/Outs',0),(546890,15192,'ba','Tertunda bergerak Ins Out',0),(546891,15192,'nl','In afwachting van verplaatsen binnen/buiten',0),(546892,15192,'fi','Odottavat siirtÃ¤Ã¤ in/out',0),(546893,15192,'no','Ventende flytte inn/ut',0),(546894,15192,'da','Ventende flytte Ins/Outs',0),(546895,15192,'ko','ë³´ë¥˜ ì¤‘ì¸ ì´ë™ ê¸°ëŠ¥/ì•„ì›ƒ',0),(546896,15192,'he','×ž×ž×ª×™× ×™× ×œ×”×–×™×– ×ª×•×¡×¤×•×ª/×ž×’×–×¨×•×ª',0),(546897,15192,'el','Î£Îµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± ÎºÎ¯Î½Î·ÏƒÎ·-Ins/Outs',0),(546898,15192,'zh','ç­‰å¾…ç§»åŠ¨/æ¥é¾™åŽ»è„‰',0),(546899,15192,'sv','Avvaktan flytta Ins/Outs',0),(546900,15192,'it','In attesa di spostare in/out',0),(546901,15192,'tl','',0),(546902,15192,'th','à¸£à¸­à¸¢à¹‰à¸²à¸¢à¸­à¸´à¸™/à¸¥à¸¶à¸à¸«à¸™à¸²à¸šà¸²à¸‡',0),(546903,15192,'hi','à¤­à¤¾à¤°à¤¤à¥€à¤¯ à¤¨à¥Œà¤¸à¥‡à¤¨à¤¾ à¤ªà¥‹à¤¤/à¤¬à¤¹à¤¿à¤·à¥à¤•à¤¾à¤° à¤²à¤‚à¤¬à¤¿à¤¤ à¤²à¥‡ à¤œà¤¾à¤à¤',0),(546904,15192,'ms','Sementara menunggu bergerak in/out',0),(546905,15192,'ar','Ø±ÙŠØ«Ù…Ø§ ÙŠØªÙ… Ù†Ù‚Ù„/Ø¹Ù…ÙˆÙ…ÙŠØ§Øª',0),(546906,15192,'fr','Dans l\'attente de dÃ©placer les entrÃ©es/sorties',0),(546907,15192,'jp','ä¿ç•™ä¸­ã®ç§»å‹•ã‚¤ãƒ³/ã‚¢ã‚¦ãƒˆ',0),(546908,15192,'pt','Pendente mover entradas/saÃ­das',0),(546909,15192,'ru','Ð”Ð¾ Ð¿ÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½Ð¸Ñ Ð²Ñ…Ð¾Ð´Ñ‹/Ð²Ñ‹Ñ…Ð¾Ð´Ñ‹',0),(546910,15192,'es','Movimiento pendiente entradas/salidas',0),(546911,15192,'de','Ausstehende verschieben ein-/AusgÃ¤ngen',0),(546912,15192,'en','Pending Move Ins/Outs',0),(546913,15193,'is','',0),(546914,15193,'dr','ØªØ¬Ø±Ø¨ÛŒ',0),(546915,15193,'pr','ØªØ¬Ø±Ø¨ÛŒ',0),(546916,15193,'tr','Deneysel',0),(546917,15193,'pl','Eksperymentalny',0),(546918,15193,'bg','Ð•ÐºÑÐ¿ÐµÑ€Ð¸Ð¼ÐµÐ½Ñ‚Ð°Ð»Ð½Ð¸',0),(546919,15193,'ur','ØªØ¬Ø±Ø¨Ø§ØªÛŒ',0),(546920,15193,'sr','Ð•ÐºÑÐ¿ÐµÑ€Ð¸Ð¼ÐµÐ½Ñ‚Ð°Ð»Ð½Ð¸',0),(546921,15193,'vi','Thá»­ nghiá»‡m',0),(546922,15193,'af','Eksperimentele',0),(546923,15193,'ro','Experimentale',0),(546924,15193,'et','Eksperimentaalne',0),(546925,15193,'si','Eksperimentalni',0),(546926,15193,'ba','Eksperimental',0),(546927,15193,'nl','Experimentele',0),(546928,15193,'fi','Kokeellinen',0),(546929,15193,'no','Eksperimentell',0),(546930,15193,'da','Eksperimentel',0),(546931,15193,'ko','ì‹¤í—˜',0),(546932,15193,'he','× ×™×¡×™×•× ×™',0),(546933,15193,'el','Î ÎµÎ¹ÏÎ±Î¼Î±Ï„Î¹ÎºÏŒ',0),(546934,15193,'zh','å®žéªŒ',0),(546935,15193,'sv','Experimental',0),(546936,15193,'it','Sperimentale',0),(546937,15193,'tl','',0),(546938,15193,'th','à¸—à¸”à¸¥à¸­à¸‡',0),(546939,15193,'hi','à¤ªà¥à¤°à¤¯à¥‹à¤—à¤¾à¤¤à¥à¤®à¤•',0),(546940,15193,'ms','Eksperimen',0),(546941,15193,'ar','Ø§Ù„ØªØ¬Ø±ÙŠØ¨ÙŠØ©',0),(546942,15193,'fr','ExpÃ©rimentale',0),(546943,15193,'jp','å®Ÿé¨“',0),(546944,15193,'pt','Experimental',0),(546945,15193,'ru','Ð­ÐºÑÐ¿ÐµÑ€Ð¸Ð¼ÐµÐ½Ñ‚Ð°Ð»ÑŒÐ½Ñ‹Ð¹',0),(546946,15193,'es','Experimental',0),(546947,15193,'de','Experimentelle',0),(546948,15193,'en','Experimental',0),(546949,15194,'is','',0),(546950,15194,'dr','BOM Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ù…ÙˆØ§Ø±Ø¯ Ø²ÛŒØ± Ø±Ø§ Ø¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª & ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´',0),(546951,15194,'pr','BOM Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ù…ÙˆØ§Ø±Ø¯ Ø²ÛŒØ± Ø±Ø§ Ø¯Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª & ØªØ§ÛŒÛŒØ¯ Ø³ÙØ§Ø±Ø´',0),(546952,15194,'tr','SeÃ§im listesi ve sipariÅŸ teyidi Ã¼zerinde Ã¼rÃ¼n ReÃ§etesi alt Ã¶ÄŸeleri gÃ¶ster',0),(546953,15194,'pl','PokaÅ¼ BOM podrzÄ™dne elementy na Pick listy idealna potwierdzenia zamÃ³wienia',0),(546954,15194,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐšÐ˜ Ð¿Ð¾Ð´ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ & Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(546955,15194,'ur','Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª & ØªØ±ØªÛŒØ¨ ØªØµØ¯ÛŒÙ‚ Ù¾Ø± Ø¨Ø§Ù… Ø°ÛŒÙ„ÛŒ Ø§Ø´ÛŒØ§ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(546956,15194,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ Ð¿Ð¾Ð´ÑÑ‚Ð°Ð²ÐºÐµ Ð½Ð° Ð»Ð¸ÑÑ‚Ñƒ Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€ & ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(546957,15194,'vi','Hiá»ƒn thá»‹ khÃ¡ch sáº¡n BOM tiá»ƒu má»¥c trÃªn danh sÃ¡ch lá»±a chá»n & xÃ¡c nháº­n Ä‘áº·t hÃ ng',0),(546958,15194,'af','Wys gebore sub Items op Pick lys & orde bevestiging',0),(546959,15194,'ro','AratÄƒ LM subelemente pe lista de murÄƒturi & confirmarea comenzii',0),(546960,15194,'et','NÃ¤ita Koosluse allkirjetel noppimisloend- & tellimuse kinnituse kohta',0),(546961,15194,'si','PrikaÅ¾i Kosovnice podpostavke postavk na seznam & potrditve naroÄila',0),(546962,15194,'ba','Lihat BOM sub-item memilih daftar & konfirmasi Order',0),(546963,15194,'nl','Toon sub stuklijstartikelen op picklijst & orderbevestiging',0),(546964,15194,'fi','NÃ¤ytÃ¤ Tuoterakenteen osa kohteet poimintaluettelo & vahvistus',0),(546965,15194,'no','Vis sub stykklistevarer pÃ¥ plukklisten & ordrebekreftelse',0),(546966,15194,'da','Vis sub styklistevarer pÃ¥ pluklisten & ordrebekrÃ¦ftelse',0),(546967,15194,'ko','BOM í•˜ìœ„ í•­ëª© ì„ íƒ ëª©ë¡ ë° ì£¼ë¬¸ í™•ì¸ì— í‘œì‹œ',0),(546968,15194,'he','×”×¦×’ ×¤×¨×™×˜×™ ×ž×©× ×” BOM ×¢×œ ×¨×©×™×ž×ª ×¤×™×§ & ××™×©×•×¨ ×”×–×ž× ×”',0),(546969,15194,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï…Ï€Î¿-ÎµÎ¯Î´Î· Ï„ÎµÏ‡Î½Î¹ÎºÎ®Ï‚ Ï„ÎµÏ‡Î½Î¹ÎºÎ®Ï‚ Î ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†Î®Ï‚ ÏƒÎµ Ï„ÏƒÎ¹Î¼Ï€Î¿Î»Î¿Î³ÏŽ Î»Î¯ÏƒÏ„Î± & ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(546970,15194,'zh','æ˜¾ç¤ºç‰©æ–™æ¸…å•åˆ†é¡¹é€‰å–åˆ—è¡¨åŠè®¢å•ç¡®è®¤',0),(546971,15194,'sv','Visa Strukturlista delposter pÃ¥ plocklistan & orderbekrÃ¤ftelse',0),(546972,15194,'it','Visualizza gli elementi secondari di BOM sulla lista di prelievo & conferma d\'ordine',0),(546973,15194,'tl','',0),(546974,15194,'th','à¹à¸ªà¸”à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸¢à¹ˆà¸­à¸¢ BOM à¸šà¸™à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸šà¸´à¸à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¸³à¸£à¸­à¸‡à¸¢à¸·à¸™à¸¢à¸±à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(546975,15194,'hi','à¤šà¥à¤¨à¥‡à¤‚ à¤¸à¥‚à¤šà¥€ & à¤•à¥à¤°à¤® à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤•à¤°à¤£ à¤ªà¤° BOM à¤‰à¤ª à¤†à¤‡à¤Ÿà¤® à¤¦à¤¿à¤–à¤¾à¤à¤',0),(546976,15194,'ms','Menunjukkan item-item sub BOM pada senarai memilih & Order Confirmation',0),(546977,15194,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø´Ø¬Ø±Ø© Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„ÙØ±Ø¹ÙŠØ© ÙÙŠ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù†ØªÙ‚Ø§Ø¡ & ØªØ£ÙƒÙŠØ¯ Ø£Ù…Ø±',0),(546978,15194,'fr','Voir la nomenclature des points subsidiaires sur la liste de sÃ©lection & Confirmation de commande',0),(546979,15194,'jp','é¸æŠžãƒªã‚¹ãƒˆ ãƒ»æ³¨æ–‡ç¢ºèªã«ã‚µãƒ–ã® BOM å“ç›®ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(546980,15194,'pt','Mostrar BOM sub itens na lista de seleÃ§Ã£o e confirmaÃ§Ã£o da ordem',0),(546981,15194,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ð¾Ð´Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¹ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸ Ð½Ð° ÑÐ¿Ð¸ÑÐ¾Ðº Ð²Ñ‹Ð±Ð¾Ñ€Ð° & Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ð°',0),(546982,15194,'es','Mostrar BOM subtemas en la lista de selecciÃ³n y confirmaciÃ³n de la orden',0),(546983,15194,'de','StÃ¼cklistenpositionen Sub auf Auswahlliste & AuftragsbestÃ¤tigung anzeigen',0),(546984,15194,'en','Show BOM Sub-Items On Pick List & Order Confirmation',0),(546985,15195,'is','',0),(546986,15195,'dr','Ù‡Ø´Ø¯Ø§Ø± Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ø§Ú¯Ø± Ø¨ÛŒØ´ Ø§Ø² ÛŒÚ© Ø¨Ø§Ø± Ú†Ø§Ù¾ Ø´Ø¯Ù‡',0),(546987,15195,'pr','Ù‡Ø´Ø¯Ø§Ø± Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ø§Ú¯Ø± Ø¨ÛŒØ´ Ø§Ø² ÛŒÚ© Ø¨Ø§Ø± Ú†Ø§Ù¾ Ø´Ø¯Ù‡',0),(546988,15195,'tr','Birden Ã§ok kez yazdÄ±rÄ±ldÄ±ysa gÃ¶stermek uyarÄ±',0),(546989,15195,'pl','PokaÅ¼ OstrzeÅ¼enie JeÅ›li drukowane wiÄ™cej niÅ¼ raz',0),(546990,15195,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ñ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ Ð°ÐºÐ¾ Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð²Ð° Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ Ð²ÐµÐ´Ð½ÑŠÐ¶',0),(546991,15195,'ur','Ø§Ú¯Ø± Ø§ÛŒÚ© Ø³Û’ Ø²Ø§Ø¦Ø¯ Ø¨Ø§Ø± Ú†Ú¾Ù¾ Ú¯ÛŒØ§ ØªÙˆ Ø´Ùˆ Ú©ÛŒ ØªÙ†Ø¨ÛŒÛ',0),(546992,15195,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑƒÐ¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ Ð´Ð° ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜Ñƒ Ð²Ð¸ÑˆÐµ Ð¿ÑƒÑ‚Ð°',0),(546993,15195,'vi','Hiá»ƒn thá»‹ cáº£nh bÃ¡o náº¿u in nhiá»u hÆ¡n má»™t láº§n',0),(546994,15195,'af','Wys waarskuwing indien meer as een keer gedruk',0),(546995,15195,'ro','AratÄƒ de avertizare dacÄƒ tipÄƒrite de mai multe ori',0),(546996,15195,'et','NÃ¤ita hoiatust kui trÃ¼kkida mitu korda',0),(546997,15195,'si','PrikaÅ¾i opozorilo, Äe veÄ kot enkrat',0),(546998,15195,'ba','Tampilkan peringatan jika dicetak lebih dari sekali',0),(546999,15195,'nl','Toon waarschuwing als meer dan eenmaal afgedrukt',0),(547000,15195,'fi','NÃ¤ytÃ¤ varoitus, jos tulostetaan useita kertoja',0),(547001,15195,'no','Vis advarsel hvis ut mer enn Ã©n gang',0),(547002,15195,'da','Vis advarsel, hvis der udskrives mere end Ã©n gang',0),(547003,15195,'ko','ì—¬ëŸ¬ ë²ˆ ì¸ì‡„ í•˜ëŠ” ê²½ìš° ê²½ê³ ë¥¼ í‘œì‹œ',0),(547004,15195,'he','×”×¦×’ ××–×”×¨×” ×× ×ž×•×“×¤×¡ ×™×•×ª×¨ ×ž×¤×¢× ××—×ª',0),(547005,15195,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Î½ ÎµÎºÏ„Ï…Ï€ÏŽÎ½Î¿Î½Ï„Î±Î¹ Ï€Î¬Î½Ï‰ Î±Ï€ÏŒ Î¼Î¯Î± Ï†Î¿ÏÎ¬',0),(547006,15195,'zh','æ˜¾ç¤ºè­¦å‘Šå¦‚æžœä¸æ­¢ä¸€æ¬¡æ‰“å°',0),(547007,15195,'sv','Visa varning om tryckt mer Ã¤n en gÃ¥ng',0),(547008,15195,'it','Mostra avviso se stampato piÃ¹ di una volta',0),(547009,15195,'tl','',0),(547010,15195,'th','à¹à¸ªà¸”à¸‡à¸„à¸³à¹€à¸•à¸·à¸­à¸™à¸–à¹‰à¸²à¸žà¸´à¸¡à¸žà¹Œà¸¡à¸²à¸à¸à¸§à¹ˆà¸² à¸«à¸™à¸¶à¹ˆà¸‡à¸„à¸£à¸±à¹‰à¸‡',0),(547011,15195,'hi','à¤¯à¤¦à¤¿ à¤à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤¬à¤¾à¤° à¤›à¤ªà¤¾ à¤¶à¥‹ à¤šà¥‡à¤¤à¤¾à¤µà¤¨à¥€',0),(547012,15195,'ms','Papar amaran jika dicetak lebih daripada sekali',0),(547013,15195,'ar','Ø¹Ø±Ø¶ ØªØ­Ø°ÙŠØ± Ø¥Ø°Ø§ ØªÙ…Øª Ø·Ø¨Ø§Ø¹Ø© Ø£ÙƒØ«Ø± Ù…Ù† Ù…Ø±Ø©',0),(547014,15195,'fr','Voir la mise en garde si imprimÃ© plus d\'une fois',0),(547015,15195,'jp','è­¦å‘Šã‚’è¡¨ç¤ºã™ã‚‹å ´åˆã€2 å›žä»¥ä¸Šå°åˆ·',0),(547016,15195,'pt','Mostrar aviso se impresso mais de uma vez',0),(547017,15195,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ, ÐµÑÐ»Ð¸ Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ Ð¾Ð´Ð¸Ð½ Ñ€Ð°Ð·',0),(547018,15195,'es','Mostrar aviso si imprime mÃ¡s de una vez',0),(547019,15195,'de','Warnung anzeigen, wenn mehr als einmal gedruckt',0),(547020,15195,'en','Show Warning If Printed More Than Once',0),(547021,15196,'is','',0),(547022,15196,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(547023,15196,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(547024,15196,'tr','KullanÄ±labilir miktar',0),(547025,15196,'pl','DostÄ™pna iloÅ›Ä‡',0),(547026,15196,'bg','ÐÐ°Ð»Ð¸Ñ‡Ð½Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(547027,15196,'ur','Ø¯Ø³ØªÛŒØ§Ø¨ Ù…Ù‚Ø¯Ø§Ø±',0),(547028,15196,'sr','Ð Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(547029,15196,'vi','CÃ³ sá»‘ lÆ°á»£ng',0),(547030,15196,'af','Beskikbare hoeveelheid',0),(547031,15196,'ro','Cantitatea disponibilÄƒ',0),(547032,15196,'et','Saadaolev kogus',0),(547033,15196,'si','RazpoloÅ¾ljiva koliÄina',0),(547034,15196,'ba','Kuantitas yang tersedia',0),(547035,15196,'nl','Beschikbare hoeveelheid',0),(547036,15196,'fi','KÃ¤ytettÃ¤vissÃ¤ oleva mÃ¤Ã¤rÃ¤',0),(547037,15196,'no','Tilgjengelig antall',0),(547038,15196,'da','Disponibelt antal',0),(547039,15196,'ko','ì‚¬ìš© ê°€ëŠ¥í•œ ìˆ˜ëŸ‰',0),(547040,15196,'he','×›×ž×•×ª ×–×ž×™× ×”',0),(547041,15196,'el','Î”Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(547042,15196,'zh','å¯ç”¨æ•°é‡',0),(547043,15196,'sv','TillgÃ¤ngliga kvantitet',0),(547044,15196,'it','QuantitÃ  disponibile',0),(547045,15196,'tl','',0),(547046,15196,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(547047,15196,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(547048,15196,'ms','Kuantiti disediakan',0),(547049,15196,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(547050,15196,'fr','QuantitÃ© disponible',0),(547051,15196,'jp','åˆ©ç”¨å¯èƒ½ãªæ•°é‡',0),(547052,15196,'pt','Quantidade disponÃ­vel',0),(547053,15196,'ru','Ð”Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(547054,15196,'es','Cantidad disponible',0),(547055,15196,'de','VerfÃ¼gbare Menge',0),(547056,15196,'en','Available Quantity',0),(547057,15197,'is','',0),(547058,15197,'dr','Ø¯Ø± Ø¯Ø³Øª Ù…Ù‚Ø¯Ø§Ø±',0),(547059,15197,'pr','Ø¯Ø± Ø¯Ø³Øª Ù…Ù‚Ø¯Ø§Ø±',0),(547060,15197,'tr','El miktarÄ±',0),(547061,15197,'pl','Na iloÅ›Ä‡',0),(547062,15197,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾Ñ‚Ð¾',0),(547063,15197,'ur','ÛØ§ØªÚ¾ Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ù¾Ø±',0),(547064,15197,'sr','ÐÐ° Ñ€ÑƒÑ†Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸',0),(547065,15197,'vi','TrÃªn bÃ n tay sá»‘ lÆ°á»£ng',0),(547066,15197,'af','Op Hand hoeveelheid',0),(547067,15197,'ro','Cantitatea de mÃ¢nÄƒ',0),(547068,15197,'et','Vaba varu kohta',0),(547069,15197,'si','Na roko koliÄina',0),(547070,15197,'ba','Pada tangan kuantitas',0),(547071,15197,'nl','Op Hand hoeveelheid',0),(547072,15197,'fi','JÃ¤senen kÃ¤ytettÃ¤vissÃ¤ oleva mÃ¤Ã¤rÃ¤',0),(547073,15197,'no','PÃ¥ beholdningsantall',0),(547074,15197,'da','PÃ¥ beholdning',0),(547075,15197,'ko','ì† ìˆ˜ëŸ‰ì—',0),(547076,15197,'he','×¢×œ ×”×™×“ ×›×ž×•×ª',0),(547077,15197,'el','Î£Ï„Î¿ Ï‡Î­ÏÎ¹ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(547078,15197,'zh','å…³äºŽæ‰‹æ•°é‡',0),(547079,15197,'sv','PÃ¥ kvantitet',0),(547080,15197,'it','Sulla quantitÃ  di mano',0),(547081,15197,'tl','',0),(547082,15197,'th','à¹ƒà¸™à¸›à¸£à¸´à¸¡à¸²à¸“à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(547083,15197,'hi','à¤ªà¤° à¤¹à¤¾à¤¥ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(547084,15197,'ms','Pada tangan kuantiti',0),(547085,15197,'ar','Ø¹Ù„Ù‰ Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„ÙØ¹Ù„ÙŠØ©',0),(547086,15197,'fr','QuantitÃ© disponible',0),(547087,15197,'jp','åœ¨åº«æ•°é‡ã«',0),(547088,15197,'pt','Na quantidade de mÃ£o',0),(547089,15197,'ru','ÐÐ° Ñ€ÑƒÐºÑƒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(547090,15197,'es','Cantidad de mano',0),(547091,15197,'de','Auf Hand-Menge',0),(547092,15197,'en','On Hand Quantity',0),(547093,15198,'is','',0),(547094,15198,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø±Ø§Ù‡ Ø¯ÙˆØ± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(547095,15198,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø±Ø§Ù‡ Ø¯ÙˆØ± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(547096,15198,'tr','Uzaktan gÃ¼ncelleÅŸtirmeleri kullanma',0),(547097,15198,'pl','UÅ¼ycie zdalnego aktualizacje',0),(547098,15198,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð¾Ñ‚Ð´Ð°Ð»ÐµÑ‡ÐµÐ½Ð¸ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(547099,15198,'ur','Ø±ÛŒÙ…ÙˆÙ¹ Ø§Ù¾ ÚˆÛŒÙ¹Ø³ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(547100,15198,'sr','Ð£Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð° ÑƒÐ´Ð°Ñ™ÐµÐ½Ðµ Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐµ',0),(547101,15198,'vi','Sá»­ dá»¥ng báº£n Cáº­p Nháº­t tá»« xa',0),(547102,15198,'af','Remote Updates gebruik',0),(547103,15198,'ro','Utilizarea de la distanÅ£Äƒ actualizÄƒri',0),(547104,15198,'et','Serveri uuendused kasutamine',0),(547105,15198,'si','Uporaba oddaljenega posodobitve',0),(547106,15198,'ba','Gunakan remote update',0),(547107,15198,'nl','Externe Updates gebruik',0),(547108,15198,'fi','Kauko pÃ¤ivitykset kÃ¤yttÃ¶Ã¶n',0),(547109,15198,'no','Eksterne oppdateringer bruk',0),(547110,15198,'da','Remote opdateringer brug',0),(547111,15198,'ko','ì›ê²© ì—…ë°ì´íŠ¸ ì‚¬ìš©',0),(547112,15198,'he','×©×™×ž×•×© ×¢×“×›×•× ×™× ×ž×¨×—×•×§',0),(547113,15198,'el','Î§ÏÎ®ÏƒÎ· Î±Ï€Î¿Î¼Î±ÎºÏÏ…ÏƒÎ¼Î­Î½Î·Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹Ï‚',0),(547114,15198,'zh','è¿œç¨‹æ›´æ–°ä½¿ç”¨',0),(547115,15198,'sv','Remote uppdateringar anvÃ¤ndning',0),(547116,15198,'it','Utilizzo di aggiornamenti remoti',0),(547117,15198,'tl','',0),(547118,15198,'th','à¹ƒà¸Šà¹‰à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸°à¸¢à¸°à¹„à¸à¸¥',0),(547119,15198,'hi','à¤¦à¥‚à¤°à¤¸à¥à¤¥ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(547120,15198,'ms','Guna kemas kini jauh',0),(547121,15198,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø§Ù„ØªØ­Ø¯ÙŠØ«Ø§Øª Ø§Ù„Ø¨Ø¹ÙŠØ¯',0),(547122,15198,'fr','Utilisation de mises Ã  jour Ã  distance',0),(547123,15198,'jp','ãƒªãƒ¢ãƒ¼ãƒˆæ›´æ–°ã®ä½¿ç”¨',0),(547124,15198,'pt','Uso remoto de atualizaÃ§Ãµes',0),(547125,15198,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑƒÐ´Ð°Ð»ÐµÐ½Ð½Ð¾Ð³Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(547126,15198,'es','Uso de actualizaciones remotas',0),(547127,15198,'de','Entfernten Updates verwenden',0),(547128,15198,'en','Remote Updates Use',0),(547129,15199,'is','',0),(547130,15199,'dr','Ø¯Ø³ØªÙˆØ± Ú©Ø§Ø± Ù…Ø¯ÛŒØ±ÛŒØª Ø§Ù…ÙˆØ§Ù„ Ø¨Ù‡ Ø´Ø±Ú©Øª Ø¨Ø±ÙˆÛŒØ¯',0),(547131,15199,'pr','Ø¯Ø³ØªÙˆØ± Ú©Ø§Ø± Ù…Ø¯ÛŒØ±ÛŒØª Ø§Ù…ÙˆØ§Ù„ Ø¨Ù‡ Ø´Ø±Ú©Øª Ø¨Ø±ÙˆÛŒØ¯',0),(547132,15199,'tr','Ã–zellik yÃ¶netimi iÅŸ emirlerinin bir ÅŸirkete gitmek',0),(547133,15199,'pl','NieruchomoÅ›ci zarzÄ…dzanie zleceniami iÅ›Ä‡ do firmy',0),(547134,15199,'bg','Ð˜Ð¼Ð¾Ñ‚Ð¸ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð·Ð°ÑÐ²ÐºÐ¸ Ð¾Ñ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð°',0),(547135,15199,'ur','Ù¾Ø±Ø§Ù¾Ø±Ù¹ÛŒ Ù…ÛŒÙ†Ø¬Ù…Ù†Ù¹ Ú©Ø§Ù… Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ù…Ù¾Ù†ÛŒ Ú©Ùˆ Ø¬Ø§Ù†Ø§',0),(547136,15199,'sr','Ð¡Ð²Ð¾Ñ˜ÑÑ‚Ð²Ð¾ Ð·Ð° ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ñ€Ð°Ð´Ð½Ð¸Ð¼ Ð½Ð°Ð»Ð¾Ð·Ð¸Ð¼Ð° Ð¿Ñ€ÐµÑ’Ð¸Ñ‚Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(547137,15199,'vi','Báº¥t Ä‘á»™ng sáº£n quáº£n lÃ½ cÃ´ng viá»‡c Ä‘Æ¡n Ä‘áº·t hÃ ng Ä‘i Ä‘áº¿n cÃ´ng ty',0),(547138,15199,'af','Eiendom bestuur werk bestellings gaan na maatskappy',0),(547139,15199,'ro','Comenzi de lucru proprietatea gestionare merge la companie',0),(547140,15199,'et','Kinnisvara haldamise tÃ¶Ã¶kÃ¤sud minna firma',0),(547141,15199,'si','Lastnost upravljanje delovnih nalogov, pojdite na podjetje',0),(547142,15199,'ba','Properti manajemen kerja perintah pergi ke perusahaan',0),(547143,15199,'nl','Eigenschap Management werkorders Ga naar bedrijf',0),(547144,15199,'fi','Omaisuuden hallinta tyÃ¶tilaukset mennÃ¤ yrityksen',0),(547145,15199,'no','Egenskapen Management Arbeidsordre gÃ¥ til selskapet',0),(547146,15199,'da','Property Management arbejdsordrer gÃ¥ til selskab',0),(547147,15199,'ko','íšŒì‚¬ì—ê°€ ì„œ ìž¬ì‚° ê´€ë¦¬ ìž‘ì—… ìˆœì„œ',0),(547148,15199,'he','×”×–×ž× ×•×ª ×¢×‘×•×“×” × ×™×”×•×œ ×¨×›×•×© ×œ×œ×›×ª ×œ×—×‘×¨×”',0),(547149,15199,'el','Î™Î´Î¹ÏŒÏ„Î·Ï„Î± Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î¬ÎµÎ¹ ÏƒÎµ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(547150,15199,'zh','ç‰©ä¸šç®¡ç†å·¥ä½œè®¢å•åŽ»å…¬å¸',0),(547151,15199,'sv','Property Management arbetsorder gÃ¥ till fÃ¶retag',0),(547152,15199,'it','ProprietÃ  gestione ordini di lavoro andare in azienda',0),(547153,15199,'tl','',0),(547154,15199,'th','à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™à¸ªà¸±à¹ˆà¸‡à¹„à¸›à¸—à¸µà¹ˆà¸šà¸£à¸´à¸©à¸±à¸—',0),(547155,15199,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤•à¤¾à¤°à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤“',0),(547156,15199,'ms','Arahan kerja pengurusan harta pergi ke Syarikat',0),(547157,15199,'ar','Ø®Ø§ØµÙŠØ© Ø¥Ø¯Ø§Ø±Ø© Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø°Ù‡Ø§Ø¨ Ø¥Ù„Ù‰ Ø§Ù„Ø´Ø±ÙƒØ©',0),(547158,15199,'fr','PropriÃ©tÃ© gestion des ordres de travail aller Ã  entreprise',0),(547159,15199,'jp','ãƒ—ãƒ­ãƒ‘ãƒ†ã‚£ç®¡ç†ä½œæ¥­æŒ‡ç¤ºãŒä¼šç¤¾ã«è¡Œã',0),(547160,15199,'pt','Ordens de trabalho de gestÃ£o de propriedade ir companhia',0),(547161,15199,'ru','Ð¡Ð²Ð¾Ð¹ÑÑ‚Ð²Ð° ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð°Ñ€ÑÐ´Ð¾Ð² Ð¿ÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ðº ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(547162,15199,'es','Ã“rdenes de trabajo de gestiÃ³n de propiedades ir a la empresa',0),(547163,15199,'de','Eigenschaft Management ArbeitsauftrÃ¤ge gehen an Firma',0),(547164,15199,'en','Property Management Work Orders Go To Company',0),(547165,15200,'is','',0),(547166,15200,'dr','Ù†Ù…Ø§ÛŒØ´/ÙˆÛŒØ±Ø§ÛŒØ´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(547167,15200,'pr','Ù†Ù…Ø§ÛŒØ´/ÙˆÛŒØ±Ø§ÛŒØ´ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(547168,15200,'tr','GÃ¶rÃ¼ntÃ¼le/DÃ¼zenle satÄ±cÄ±',0),(547169,15200,'pl','WyÅ›wietl/Edytuj dostawcy',0),(547170,15200,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(547171,15200,'ur','Ù…Ù†Ø¸Ø±/ÙˆÛŒÙ†ÚˆØ± ØªØ¯ÙˆÛŒÙ†',0),(547172,15200,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ /Ð£Ñ€ÐµÐ´Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(547173,15200,'vi','Xem/chá»‰nh sá»­a nhÃ  cung cáº¥p',0),(547174,15200,'af','Bekyk/redigeer handelaar',0),(547175,15200,'ro','Vizualizare/Editare furnizor',0),(547176,15200,'et','Vaata/Muuda hankija',0),(547177,15200,'si','Ogled/urejanje dobavitelja',0),(547178,15200,'ba','Lihat/Edit Vendor',0),(547179,15200,'nl','Bekijken/bewerken leverancier',0),(547180,15200,'fi','NÃ¤ytÃ¤/Muokkaa toimittajan',0),(547181,15200,'no','Vis/Rediger leverandÃ¸r',0),(547182,15200,'da','Se/Rediger leverandÃ¸r',0),(547183,15200,'ko','ë³´ê¸°/íŽ¸ì§‘ ê³µê¸‰ ì—…ì²´',0),(547184,15200,'he','×”×¦×’/×¢×¨×•×š ×œ×¡×¤×§',0),(547185,15200,'el','Î ÏÎ¿Î²Î¿Î»Î®/Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(547186,15200,'zh','æŸ¥çœ‹/ç¼–è¾‘ä¾›åº”å•†',0),(547187,15200,'sv','Visa/redigera leverantÃ¶r',0),(547188,15200,'it','Visualizza/modifica fornitore',0),(547189,15200,'tl','',0),(547190,15200,'th','à¹à¸à¹‰à¹„à¸‚à¸¡à¸¸à¸¡à¸¡à¸­à¸‡à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(547191,15200,'hi','à¤¦à¥‡à¤–à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(547192,15200,'ms','Pandangan/Edit Penjual',0),(547193,15200,'ar','Ø¹Ø±Ø¶/ØªØ­Ø±ÙŠØ± Ø§Ù„Ù…ÙˆØ±Ø¯',0),(547194,15200,'fr','Afficher/modifier fournisseur',0),(547195,15200,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¡¨ç¤º/ç·¨é›†',0),(547196,15200,'pt','Exibir/editar fornecedor',0),(547197,15200,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(547198,15200,'es','Ver/editar proveedor',0),(547199,15200,'de','Kreditor anzeigen/bearbeiten',0),(547200,15200,'en','View/Edit Vendor',0),(547201,15201,'is','',0),(547202,15201,'dr','Ø¨Ø§Ø² Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨',0),(547203,15201,'pr','Ø¨Ø§Ø² Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨',0),(547204,15201,'tr','Hesap AÃ§',0),(547205,15201,'pl','OtwÃ³rz konto',0),(547206,15201,'bg','ÐžÑ‚Ð²Ð¾Ñ€Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(547207,15201,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ú¾ÙˆÙ„ÛŒÚº',0),(547208,15201,'sr','ÐžÑ‚Ð²Ð°Ñ€Ð°ÑšÐµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(547209,15201,'vi','Má»Ÿ tÃ i khoáº£n',0),(547210,15201,'af','Rekening oop',0),(547211,15201,'ro','Deschide cont',0),(547212,15201,'et','Konto avamine',0),(547213,15201,'si','RaÄun odprt',0),(547214,15201,'ba','Buka akun',0),(547215,15201,'nl','Rekening openen',0),(547216,15201,'fi','Tili auki',0),(547217,15201,'no','Konto Ã¥pen',0),(547218,15201,'da','Konto Open',0),(547219,15201,'ko','ê³„ì • ì˜¤í”ˆ',0),(547220,15201,'he','×¤×ª×— ×—×©×‘×•×Ÿ',0),(547221,15201,'el','Î†Î½Î¿Î¹Î³Î¼Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(547222,15201,'zh','æ‰“å¼€å¸æˆ·',0),(547223,15201,'sv','Ã–ppna konto',0),(547224,15201,'it','Apri conto',0),(547225,15201,'tl','',0),(547226,15201,'th','à¹€à¸›à¸´à¸”à¸šà¸±à¸à¸Šà¸µ',0),(547227,15201,'hi','à¤–à¤¾à¤¤à¤¾ à¤–à¥‹à¤²à¥‡à¤‚',0),(547228,15201,'ms','Buka akaun',0),(547229,15201,'ar','ÙØªØ­ Ø§Ù„Ø­Ø³Ø§Ø¨',0),(547230,15201,'fr','Ouverture de compte',0),(547231,15201,'jp','å£åº§ã‚’é–‹è¨­',0),(547232,15201,'pt','Abrir conta',0),(547233,15201,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑ‡ÐµÑ‚',0),(547234,15201,'es','Abrir cuenta',0),(547235,15201,'de','Konto Ã¶ffnen',0),(547236,15201,'en','Account Open',0),(547237,15202,'is','',0),(547238,15202,'dr','Ù†Ù…Ø§ÛŒØ´/ÙˆÛŒØ±Ø§ÛŒØ´ Ù…Ø´ØªØ±ÛŒ',0),(547239,15202,'pr','Ù†Ù…Ø§ÛŒØ´/ÙˆÛŒØ±Ø§ÛŒØ´ Ù…Ø´ØªØ±ÛŒ',0),(547240,15202,'tr','GÃ¶rÃ¼ntÃ¼le/DÃ¼zenle mÃ¼ÅŸteri',0),(547241,15202,'pl','WyÅ›wietl/Edytuj klienta',0),(547242,15202,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(547243,15202,'ur','Ú©Ø³Ù¹Ù…Ø± Ù…Ù†Ø¸Ø±/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(547244,15202,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ /Ð£Ñ€ÐµÐ´Ð¸ ÐºÑƒÐ¿Ñ†Ð°',0),(547245,15202,'vi','Xem/chá»‰nh sá»­a khÃ¡ch hÃ ng',0),(547246,15202,'af','Bekyk/redigeer kliÃ«nt',0),(547247,15202,'ro','Vizualizare/Editare client',0),(547248,15202,'et','Vaata/Muuda kliendi',0),(547249,15202,'si','Ogled/urejanje kupca',0),(547250,15202,'ba','Lihat/Edit pelanggan',0),(547251,15202,'nl','Bekijken/bewerken klant',0),(547252,15202,'fi','NÃ¤ytÃ¤/Muokkaa asiakkaan',0),(547253,15202,'no','Vise/redigere kunde',0),(547254,15202,'da','Se/Rediger kunde',0),(547255,15202,'ko','ë³´ê¸°/íŽ¸ì§‘ ê³ ê°',0),(547256,15202,'he','×”×¦×’/×¢×¨×•×š ×”×œ×§×•×—',0),(547257,15202,'el','Î ÏÎ¿Î²Î¿Î»Î®/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(547258,15202,'zh','æŸ¥çœ‹/ç¼–è¾‘å®¢æˆ·',0),(547259,15202,'sv','Visa/redigera kund',0),(547260,15202,'it','Visualizza/modifica cliente',0),(547261,15202,'tl','',0),(547262,15202,'th','à¸”à¸¹à¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(547263,15202,'hi','à¤¦à¥‡à¤–à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(547264,15202,'ms','Baca pandangan/Edit',0),(547265,15202,'ar','Ø¹Ø±Ø¶/ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(547266,15202,'fr','Afficher/modifier client',0),(547267,15202,'jp','é¡§å®¢ã®è¡¨ç¤º/ç·¨é›†',0),(547268,15202,'pt','Exibir/editar cliente',0),(547269,15202,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(547270,15202,'es','Ver/editar cliente',0),(547271,15202,'de','Bearbeiten Sie anzeigen/Kunde',0),(547272,15202,'en','View/Edit Customer',0),(547273,15203,'is','',0),(547274,15203,'dr','Ø¢Ø®Ø±ÛŒÙ† Ø¨Ø§Ø± Ú†Ø§Ù¾ Ø´Ø¯Ù‡',0),(547275,15203,'pr','Ø¢Ø®Ø±ÛŒÙ† Ø¨Ø§Ø± Ú†Ø§Ù¾ Ø´Ø¯Ù‡',0),(547276,15203,'tr','Son yazdÄ±rma',0),(547277,15203,'pl','Ostatnio drukowany',0),(547278,15203,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð½',0),(547279,15203,'ur','Ø¢Ø®Ø±ÛŒ Ù…Ø±ØªØ¨Û Ù…Ø·Ø¨ÙˆØ¹Û',0),(547280,15203,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿ÑƒÑ‚ ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½',0),(547281,15203,'vi','Cuá»‘i in',0),(547282,15203,'af','Laas gedruk',0),(547283,15203,'ro','Ultima imprimare',0),(547284,15203,'et','Viimati prinditud',0),(547285,15203,'si','Nazadnje natisnjen',0),(547286,15203,'ba','Terakhir dicetak',0),(547287,15203,'nl','Voor het laatst afgedrukt',0),(547288,15203,'fi','Viimeksi tulostettu',0),(547289,15203,'no','Sist skrevet ut',0),(547290,15203,'da','Senest udskrevet',0),(547291,15203,'ko','ë§ˆì§€ë§‰ ì¸ì‡„',0),(547292,15203,'he','×”×•×“×¤×¡ ×œ××—×¨×•× ×”',0),(547293,15203,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(547294,15203,'zh','ä¸Šä¸€æ¬¡æ‰“å°',0),(547295,15203,'sv','Senast ut',0),(547296,15203,'it','Ultima stampa',0),(547297,15203,'tl','',0),(547298,15203,'th','à¸žà¸´à¸¡à¸žà¹Œà¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(547299,15203,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤®à¥à¤¦à¥à¤°à¤£',0),(547300,15203,'ms','Buat dicetak',0),(547301,15203,'ar','Ø§Ù„Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(547302,15203,'fr','DerniÃ¨re impression',0),(547303,15203,'jp','æœ€å¾Œã«å°åˆ·ã•ã‚Œã¾ã—ãŸã€‚',0),(547304,15203,'pt','Ãšltima impressÃ£o',0),(547305,15203,'ru','Ð”Ð°Ñ‚Ð° Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(547306,15203,'es','Ãšltimo impreso',0),(547307,15203,'de','Zuletzt gedruckt',0),(547308,15203,'en','Last Printed',0),(547309,15204,'is','',0),(547310,15204,'dr','Ú†Ø§Ù¾ Ø¯ÙˆØ¨Ø§Ø±Ù‡',0),(547311,15204,'pr','Ú†Ø§Ù¾ Ø¯ÙˆØ¨Ø§Ø±Ù‡',0),(547312,15204,'tr','Yeniden yazdÄ±rÄ±n',0),(547313,15204,'pl','Drukuj ponownie',0),(547314,15204,'bg','ÐžÑ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(547315,15204,'ur','Ù¾Ú¾Ø± Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(547316,15204,'sr','Ð˜ÑÐ¿Ð¸Ñ',0),(547317,15204,'vi','In má»™t láº§n ná»¯a',0),(547318,15204,'af','Druk weer',0),(547319,15204,'ro','ImprimaÅ£i din nou',0),(547320,15204,'et','Uuesti printida',0),(547321,15204,'si','Znova natisnite',0),(547322,15204,'ba','Mencetak lagi',0),(547323,15204,'nl','Opnieuw afdrukken',0),(547324,15204,'fi','Tulosta uudelleen',0),(547325,15204,'no','Skrive ut pÃ¥ nytt',0),(547326,15204,'da','Udskriv igen',0),(547327,15204,'ko','ë‹¤ì‹œ ì¸ì‡„',0),(547328,15204,'he','×”×“×¤×¡ ×©×•×‘',0),(547329,15204,'el','Î•ÎºÏ„Ï…Ï€ÏŽÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(547330,15204,'zh','é‡æ–°æ‰“å°',0),(547331,15204,'sv','Skriva ut igen',0),(547332,15204,'it','Stampare di nuovo',0),(547333,15204,'tl','',0),(547334,15204,'th','à¸žà¸´à¸¡à¸žà¹Œà¸­à¸µà¸à¸„à¸£à¸±à¹‰à¸‡',0),(547335,15204,'hi','à¤ªà¥à¤¨: à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(547336,15204,'ms','Cetakan semula',0),(547337,15204,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(547338,15204,'fr','Imprimez Ã  nouveau',0),(547339,15204,'jp','ã‚‚ã†ä¸€åº¦å°åˆ·ã—ã¾ã™ã€‚',0),(547340,15204,'pt','Imprimir novamente',0),(547341,15204,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÐ½Ð¾Ð²Ð°',0),(547342,15204,'es','Imprimir otra vez',0),(547343,15204,'de','Drucken Sie erneut',0),(547344,15204,'en','Print Again',0),(547345,15205,'is','',0),(547346,15205,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø²ÛŒØ± Ù‚Ø¨Ù„Ø§ Ú†Ø§Ù¾ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(547347,15205,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø²ÛŒØ± Ù‚Ø¨Ù„Ø§ Ú†Ø§Ù¾ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(547348,15205,'tr','Emirlere Ã¶nceden yazdÄ±rÄ±lmÄ±ÅŸ',0),(547349,15205,'pl','NastÄ™pujÄ…ce zamÃ³wienia zostaÅ‚y wydrukowane wczeÅ›niej',0),(547350,15205,'bg','Ð¡Ð»ÐµÐ´ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð¾Ñ‚Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð½Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ Ñ‚Ð¾Ð²Ð°',0),(547351,15205,'ur','Ù…Ù†Ø¯Ø±Ø¬Û Ø°ÛŒÙ„ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾ÛÙ„Û’ Ú†Ú¾Ø§Ù¾Ø§ Ú¯ÛŒØ§ ÛÛ’',0),(547352,15205,'sr','ÐžÐ²Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ ÑÑƒ Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾ Ð¾Ð´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ðµ',0),(547353,15205,'vi','CÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng sau Ä‘Ã¢y Ä‘Ã£ Ä‘Æ°á»£c in trÆ°á»›c Ä‘Ã¢y',0),(547354,15205,'af','Die volgende bestellings het voorheen gedruk is',0),(547355,15205,'ro','Ordine urmÄƒtoarele au fost imprimate anterior',0),(547356,15205,'et','JÃ¤rgmised korraldused on juba varem prinditud',0),(547357,15205,'si','Te naloge so bili natisnjeni prej',0),(547358,15205,'ba','Perintah berikut telah dicetak sebelumnya',0),(547359,15205,'nl','De volgende Orders zijn eerder afgedrukt',0),(547360,15205,'fi','Seuraavat on tulostettu aiemmin',0),(547361,15205,'no','FÃ¸lgende bestillinger er skrevet ut tidligere',0),(547362,15205,'da','De fÃ¸lgende ordrer er blevet udskrevet tidligere',0),(547363,15205,'ko','ë‹¤ìŒ ëª…ë ¹ì€ ì´ì „ ì¸ì‡„ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(547364,15205,'he','×”×¦×•×•×™× ×”×‘××™× ×”×•×“×¤×¡×” ×‘×¢×‘×¨',0),(547365,15205,'el','ÎŸÎ¹ Î±ÎºÏŒÎ»Î¿Ï…Î¸ÎµÏ‚ Î´Î¹Î±Ï„Î±Î³Î­Ï‚ Î­Ï‡Î¿Ï…Î½ ÎµÎ¯Î½Î±Î¹ Ï„Ï…Ï€Ï‰Î¼Î­Î½Î± ÏƒÏ„Î¿ Ï€Î±ÏÎµÎ»Î¸ÏŒÎ½',0),(547366,15205,'zh','ä»¥ä¸‹è®¢å•å·²å°å‡ºä»¥å‰',0),(547367,15205,'sv','Om fÃ¶ljande har skrivits ut tidigare',0),(547368,15205,'it','I seguenti ordini sono stati stampati in precedenza',0),(547369,15205,'tl','',0),(547370,15205,'th','à¸¡à¸µà¸à¸²à¸£à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¹„à¸§à¹‰à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(547371,15205,'hi','à¤¨à¤¿à¤®à¥à¤¨ à¤†à¤¦à¥‡à¤¶ à¤ªà¤¹à¤²à¥‡ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(547372,15205,'ms','Perintah berikut telah dicetak sebelum ini',0),(547373,15205,'ar','ÙˆÙ‚Ø¯ ØªÙ… Ø·Ø¨Ø¹ Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„ØªØ§Ù„ÙŠØ© Ø³Ø§Ø¨Ù‚Ø§',0),(547374,15205,'fr','Les ordres suivants ont Ã©tÃ© publiÃ©s prÃ©cÃ©demment',0),(547375,15205,'jp','æ¬¡ã®æ³¨æ–‡ã¯ä»¥å‰ã«å°åˆ·ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(547376,15205,'pt','As seguintes ordens foram impressos anteriormente',0),(547377,15205,'ru','Ð Ð°Ð½ÐµÐµ Ð±Ñ‹Ð»Ð¸ Ð½Ð°Ð¿ÐµÑ‡Ð°Ñ‚Ð°Ð½Ñ‹ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(547378,15205,'es','Las siguientes Ã³rdenes que se han impreso previamente',0),(547379,15205,'de','Folgende AuftrÃ¤ge wurden bereits gedruckt',0),(547380,15205,'en','The Following Orders Have Been Printed Previously',0),(547381,15206,'is','',0),(547382,15206,'dr','Ø¨Ø§Ø± Ú†Ø§Ù¾ Ø´Ø¯Ù‡',0),(547383,15206,'pr','Ø¨Ø§Ø± Ú†Ø§Ù¾ Ø´Ø¯Ù‡',0),(547384,15206,'tr','YazdÄ±rÄ±lan kez',0),(547385,15206,'pl','Razy drukowane',0),(547386,15206,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð°',0),(547387,15206,'ur','Ù…Ø±ØªØ¨Û Ú†Ú¾Ù¾ÛŒ',0),(547388,15206,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐ°',0),(547389,15206,'vi','Láº§n in',0),(547390,15206,'af','Keer gedruk',0),(547391,15206,'ro','Ori imprimate',0),(547392,15206,'et','Printimise kordade',0),(547393,15206,'si','Krat natisnjene',0),(547394,15206,'ba','Kali dicetak',0),(547395,15206,'nl','Vaak afgedrukt',0),(547396,15206,'fi','Tulostettu',0),(547397,15206,'no','Ganger ut',0),(547398,15206,'da','Gange udskrevet',0),(547399,15206,'ko','ì¸ì‡„ ì‹œê°„',0),(547400,15206,'he','×¤×¢×ž×™× ×ž×•×“×¤×¡',0),(547401,15206,'el','Î¦Î¿ÏÎ­Ï‚ Ï„Ï…Ï€ÏŽÎ½ÎµÏ„Î±Î¹',0),(547402,15206,'zh','æ¬¡æ‰“å°',0),(547403,15206,'sv','GÃ¥nger ut',0),(547404,15206,'it','Volte stampati',0),(547405,15206,'tl','',0),(547406,15206,'th','à¸„à¸£à¸±à¹‰à¸‡à¸—à¸µà¹ˆà¸žà¸´à¸¡à¸žà¹Œ',0),(547407,15206,'hi','à¤›à¤ªà¥€ à¤Ÿà¤¾à¤‡à¤®à¥à¤¸',0),(547408,15206,'ms','Times dicetak',0),(547409,15206,'ar','Ù…Ø±Ø§Øª Ø·Ø¨Ø§Ø¹Ø©',0),(547410,15206,'fr','Fois imprimÃ©s',0),(547411,15206,'jp','å°åˆ·æ™‚é–“',0),(547412,15206,'pt','Vezes imprimidos',0),(547413,15206,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸',0),(547414,15206,'es','Veces impresas',0),(547415,15206,'de','Mal gedruckt',0),(547416,15206,'en','Times Printed',0),(547417,15207,'is','',0),(547418,15207,'dr','A & Ù…Ù† Ø³ÙØ§Ø±Ø´',0),(547419,15207,'pr','A & Ù…Ù† Ø³ÙØ§Ø±Ø´',0),(547420,15207,'tr','A ve ben sipariÅŸ',0),(547421,15207,'pl','A idealna mogÄ™ zamÃ³wiÄ‡',0),(547422,15207,'bg','Ð & Ð°Ð· Ð¾ÑÑŠÐ´Ð¸',0),(547423,15207,'ur','A & Ù…ÛŒÚº Ø¢Ø±ÚˆØ±',0),(547424,15207,'sr','Ð Ð¸ ÑÐ°Ð¼ Ð½Ð°Ñ€ÐµÐ´Ð¸',0),(547425,15207,'vi','A & tÃ´i Ä‘áº·t hÃ ng',0),(547426,15207,'af','Ek bestel & A',0),(547427,15207,'ro','A & am comanda',0),(547428,15207,'et','A- & ma tellida',0),(547429,15207,'si','A & sem, da',0),(547430,15207,'ba','A & saya memesan',0),(547431,15207,'nl','A & ik bestellen',0),(547432,15207,'fi','A & voin tilata',0),(547433,15207,'no','A & jeg bestille',0),(547434,15207,'da','A & jeg bestille',0),(547435,15207,'ko','A & ë‚˜ ì£¼ë¬¸',0),(547436,15207,'he','A & ×× ×™ ×ž×–×ž×™×Ÿ',0),(547437,15207,'el','A & ÎµÎ³ÏŽ Ï€Î±ÏÎ±Î³Î³ÎµÎ¯Î»ÎµÏ„Îµ',0),(547438,15207,'zh','A & æˆ‘å‘½ä»¤',0),(547439,15207,'sv','A & jag bestÃ¤lla',0),(547440,15207,'it','A & ho ordine',0),(547441,15207,'tl','',0),(547442,15207,'th','A à¸„à¸¸à¹‰à¸¡à¸„à¹ˆà¸²à¸œà¸¡à¸ªà¸±à¹ˆà¸‡',0),(547443,15207,'hi','A & à¤®à¥ˆà¤‚ à¤†à¤¦à¥‡à¤¶',0),(547444,15207,'ms','A & saya perintah',0),(547445,15207,'ar','A Ø¢Ù†Ø¯ Ø£Ù†Ø§ ØªØ£Ù…Ø±',0),(547446,15207,'fr','A & j\'ai commander',0),(547447,15207,'jp','A ãƒ»æ³¨æ–‡ç§',0),(547448,15207,'pt','A & eu encomendar',0),(547449,15207,'ru','A & Ñ Ð·Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ',0),(547450,15207,'es','A & I de la orden',0),(547451,15207,'de','A & ich bestellen',0),(547452,15207,'en','A&I Order',0),(547453,15208,'is','',0),(547454,15208,'dr','Ø¯Ø±ÛŒØ§ÙØª A & Ù…Ù† Ø±Ø¯ÛŒØ§Ø¨ÛŒ Ø´Ù…Ø§Ø±Ù‡',0),(547455,15208,'pr','Ø¯Ø±ÛŒØ§ÙØª A & Ù…Ù† Ø±Ø¯ÛŒØ§Ø¨ÛŒ Ø´Ù…Ø§Ø±Ù‡',0),(547456,15208,'tr','Get A ve ben izleme numaralarÄ±',0),(547457,15208,'pl','Get A idealna I numery Å›ledzenia',0),(547458,15208,'bg','Get A & I Ð½Ð¾Ð¼ÐµÑ€Ð°Ñ‚Ð° Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ð°',0),(547459,15208,'ur','Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº A & Ù…ÛŒÚº Ø³Ø±Ø§Øº Ø±Ø§Û Ù†Ù…Ø¨Ø±',0),(547460,15208,'sr','Ð£Ð·Ð¼Ð¸ Ð & ÑÐ°Ð¼ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ðµ Ð·Ð° Ð¿Ñ€Ð°Ñ›ÐµÑšÐµ',0),(547461,15208,'vi','Get A & tÃ´i theo dÃµi sá»‘',0),(547462,15208,'af','Kry \'n & ek Tracking nommers',0),(547463,15208,'ro','Ia un & am numere de urmÄƒrire',0),(547464,15208,'et','Get A- & ma jÃ¤litamisnumbreid',0),(547465,15208,'si','ZasluÅ¾iti A & sem Å¡tevilke sledenja',0),(547466,15208,'ba','Get A & saya nomor pelacakan',0),(547467,15208,'nl','Get A & ik volgnummers',0),(547468,15208,'fi','Get A & olen seurantanumerot',0),(547469,15208,'no','FÃ¥ et & jeg sporingsnumre',0),(547470,15208,'da','FÃ¥ en & jeg sporingsnumre',0),(547471,15208,'ko','Get A & ë‚˜ ì¶”ì  ë²ˆí˜¸',0),(547472,15208,'he','Get A & ×× ×™ ×ž×¡×¤×¨×™ ×ž×¢×§×‘',0),(547473,15208,'el','Î Î±Î¯ÏÎ½ÎµÎ¹ Î¼Î¹Î± & ÎµÎ³ÏŽ Î¹Ï‡Î½Î·Î»Î±ÏƒÎ¹Î¼ÏŒÏ„Î·Ï„Î±Ï‚ ÎµÎ¯Î´Î¿Ï…Ï‚',0),(547474,15208,'zh','Get A & æˆ‘è·Ÿè¸ªå·ç ',0),(547475,15208,'sv','FÃ¥ en & jag spÃ¥rningsnummer',0),(547476,15208,'it','Get A & ho numeri di ricerca',0),(547477,15208,'tl','',0),(547478,15208,'th','à¸£à¸±à¸š A à¸„à¸¸à¹‰à¸¡à¸„à¹ˆà¸²à¸œà¸¡à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸à¸²à¸£à¸•à¸´à¸”à¸•à¸²à¸¡',0),(547479,15208,'hi','à¤œà¤¾à¤“ à¤à¤• & à¤®à¥ˆà¤‚ à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(547480,15208,'ms','Dapatkan & saya nombor Tracking',0),(547481,15208,'ar','Ø§Ø­ØµÙ„ Ø¹Ù„Ù‰ Ø£Ù„Ù Ø¢Ù†Ø¯ Ø£Ù†Ø§ Ø£Ø±Ù‚Ø§Ù… Ø§Ù„ØªØ¹Ù‚Ø¨',0),(547482,15208,'fr','Get A & j\'ai des numÃ©ros de suivi',0),(547483,15208,'jp','ã‚²ãƒƒãƒˆ ãƒ»ç§ã®è¿½è·¡ç•ªå·',0),(547484,15208,'pt','Get A & eu nÃºmeros de rastreamento',0),(547485,15208,'ru','Get A & Ñ Ð½Ð¾Ð¼ÐµÑ€Ð¾Ð² ÑÐ»ÐµÐ¶ÐµÐ½Ð¸Ñ',0),(547486,15208,'es','Consigue una y mi nÃºmero de seguimiento',0),(547487,15208,'de','Get A & ich Tracking-Nummern',0),(547488,15208,'en','Get A&I Tracking Numbers',0),(547489,15209,'is','',0),(547490,15209,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÛŒÚ¯ÛŒØ±ÛŒ Ù†Ø´Ø¯',0),(547491,15209,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù¾ÛŒÚ¯ÛŒØ±ÛŒ Ù†Ø´Ø¯',0),(547492,15209,'tr','Ä°zleme numarasÄ± bulunamadÄ±',0),(547493,15209,'pl','Numer przesyÅ‚ki nie znaleziono',0),(547494,15209,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð·Ð° Ð¿Ñ€Ð¾ÑÐ»ÐµÐ´ÑÐ²Ð°Ð½Ðµ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(547495,15209,'ur','Ø³Ø±Ø§Øº Ø±Ø§Û Ù†Ù…Ø¨Ø± Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(547496,15209,'sr','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(547497,15209,'vi','Theo dÃµi sá»‘ khÃ´ng tÃ¬m tháº¥y',0),(547498,15209,'af','Tracking nommer gevind nie',0),(547499,15209,'ro','NumÄƒr de urmÄƒrire nu a fost gÄƒsit',0),(547500,15209,'et','JÃ¤lgimisnumbri ei leitud',0),(547501,15209,'si','Å tevilka sledenja, ni mogoÄe najti',0),(547502,15209,'ba','Nomor pelacakan tidak ditemukan',0),(547503,15209,'nl','Tracking-nummer niet gevonden',0),(547504,15209,'fi','Seurantanumeron ei lÃ¶ydy',0),(547505,15209,'no','Sporingsnummeret ikke funnet',0),(547506,15209,'da','Sporingsnummeret ikke fundet',0),(547507,15209,'ko','ì¶”ì  ë²ˆí˜¸ë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(547508,15209,'he','×œ× × ×ž×¦× ×ž×¡×¤×¨ ×ž×¢×§×‘',0),(547509,15209,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€Î±ÏÎ±ÎºÎ¿Î»Î¿ÏÎ¸Î·ÏƒÎ·Ï‚ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(547510,15209,'zh','è¿½è¸ªå·ç æ‰¾ä¸åˆ°',0),(547511,15209,'sv','SpÃ¥rningsnummer hittades inte',0),(547512,15209,'it','Numero di tracking non trovato',0),(547513,15209,'tl','',0),(547514,15209,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸à¸²à¸£à¸•à¸´à¸”à¸•à¸²à¸¡',0),(547515,15209,'hi','à¤Ÿà¥à¤°à¥ˆà¤•à¤¿à¤‚à¤— à¤¨à¤‚à¤¬à¤° à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(547516,15209,'ms','Nombor Tracking yang tidak dijumpai',0),(547517,15209,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø±Ù‚Ù… Ø§Ù„ØªØªØ¨Ø¹',0),(547518,15209,'fr','NumÃ©ro de suivi introuvable',0),(547519,15209,'jp','è¿½è·¡ç•ªå·ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(547520,15209,'pt','NÃºmero de rastreamento nÃ£o encontrado',0),(547521,15209,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¾Ñ‚ÑÐ»ÐµÐ¶Ð¸Ð²Ð°Ð½Ð¸Ñ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(547522,15209,'es','NÃºmero de seguimiento no se encontrÃ³',0),(547523,15209,'de','Tracking-Nummer nicht gefunden',0),(547524,15209,'en','Tracking Number Not Found',0),(547525,15210,'is','',0),(547526,15210,'dr','Ø¯Ø³ØªÙ‡',0),(547527,15210,'pr','Ø¯Ø³ØªÙ‡',0),(547528,15210,'tr','Toplu iÅŸlemleri',0),(547529,15210,'pl','Instancje',0),(547530,15210,'bg','ÐŸÐ°Ñ€Ñ‚Ð¸Ð´Ð¸',0),(547531,15210,'ur','Ø¨ÛŒÚ†',0),(547532,15210,'sr','Ð“Ñ€ÑƒÐ¿Ðµ',0),(547533,15210,'vi','LÃ´',0),(547534,15210,'af','Hoeveelhede',0),(547535,15210,'ro','Loturi',0),(547536,15210,'et','TÃ¶Ã¶lehed',0),(547537,15210,'si','Serij',0),(547538,15210,'ba','Batch',0),(547539,15210,'nl','Partijen',0),(547540,15210,'fi','ErÃ¤t',0),(547541,15210,'no','Kladder',0),(547542,15210,'da','Partier',0),(547543,15210,'ko','ì¼ê´„ ì²˜ë¦¬',0),(547544,15210,'he','××¦×•×•×ª',0),(547545,15210,'el','Î Î±ÏÏ„Î¯Î´ÎµÏ‚',0),(547546,15210,'zh','æ‰¹æ¬¡',0),(547547,15210,'sv','Batchar',0),(547548,15210,'it','Batch',0),(547549,15210,'tl','',0),(547550,15210,'th','à¸Šà¸¸à¸”',0),(547551,15210,'hi','à¤¬à¥ˆà¤šà¥‹à¤‚',0),(547552,15210,'ms','Kelompok',0),(547553,15210,'ar','Ø¯ÙØ¹Ø§Øª',0),(547554,15210,'fr','Lots',0),(547555,15210,'jp','ãƒãƒƒãƒ',0),(547556,15210,'pt','Lotes',0),(547557,15210,'ru','ÐŸÐ°ÐºÐµÑ‚Ñ‹',0),(547558,15210,'es','Lotes',0),(547559,15210,'de','Chargen',0),(547560,15210,'en','Batches',0),(547561,15211,'is','',0),(547562,15211,'dr','Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(547563,15211,'pr','Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(547564,15211,'tr','Ã–ÄŸeleri iÅŸlemek iÃ§in gÃ¶nderilen',0),(547565,15211,'pl','Towary zostaÅ‚y wysÅ‚ane do przetwarzania',0),(547566,15211,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸Ñ‚Ðµ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð·Ð° Ð¿Ñ€ÐµÑ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(547567,15211,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú©Ùˆ Ú©Ø§Ø±Ø±ÙˆØ§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(547568,15211,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ ÑƒÐ¿ÑƒÑ›ÐµÐ½Ð¸ ÑÑƒ Ð½Ð° Ð¾Ð±Ñ€Ð°Ð´Ñƒ',0),(547569,15211,'vi','Má»¥c Ä‘Ã£ Ä‘Æ°á»£c gá»­i cho cháº¿ biáº¿n',0),(547570,15211,'af','Items gestuur vir verwerking',0),(547571,15211,'ro','Elemente au fost trimise pentru prelucrare',0),(547572,15211,'et','Kaupade tÃ¶Ã¶tlemiseks saadetud',0),(547573,15211,'si','Elementi so bili poslani za predelavo',0),(547574,15211,'ba','Item telah dikirim untuk pengolahan',0),(547575,15211,'nl','Items zijn verzonden voor verwerking',0),(547576,15211,'fi','Tuotteet on lÃ¤hetetty kÃ¤siteltÃ¤vÃ¤ksi',0),(547577,15211,'no','Varene sendes til behandling',0),(547578,15211,'da','Varer er blevet sendt til forarbejdning',0),(547579,15211,'ko','í•­ëª© ì²˜ë¦¬ë¥¼ ìœ„í•´ ì „ì†¡ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(547580,15211,'he','×¤×¨×™×˜×™× ×©× ×©×œ×—×• ×œ×¢×™×‘×•×“',0),(547581,15211,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿ÏƒÏ„Î±Î»ÎµÎ¯ Î³Î¹Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(547582,15211,'zh','å·²ä¸ºå¤„ç†å‘é€é¡¹ç›®',0),(547583,15211,'sv','Objekt har skickats fÃ¶r bearbetning',0),(547584,15211,'it','Gli elementi sono stati inviati per l\'elaborazione',0),(547585,15211,'tl','',0),(547586,15211,'th','à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸›à¸£à¸°à¸¡à¸§à¸¥à¸œà¸¥',0),(547587,15211,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(547588,15211,'ms','Barang-barang telah dihantar untuk diproses',0),(547589,15211,'ar','ØªÙ… Ø¥Ø±Ø³Ø§Ù„ Ø¹Ù†Ø§ØµØ± Ù„Ù…Ø¹Ø§Ù„Ø¬Ø©',0),(547590,15211,'fr','Les Ã©lÃ©ments ont Ã©tÃ© envoyÃ©s pour traitement',0),(547591,15211,'jp','å‡¦ç†ã®ãŸã‚é€ä¿¡ã•ã‚ŒãŸé …ç›®',0),(547592,15211,'pt','Itens foram enviados para processamento',0),(547593,15211,'ru','Ð¢Ð¾Ð²Ð°Ñ€Ñ‹ Ð±Ñ‹Ð»Ð¸ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð´Ð»Ñ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸',0),(547594,15211,'es','Los artÃ­culos han sido enviados para el proceso',0),(547595,15211,'de','Elemente wurden fÃ¼r die Verarbeitung gesendet',0),(547596,15211,'en','Items Have Been Sent For Processing',0),(547597,15212,'is','',0),(547598,15212,'dr','ÙØ§ÛŒÙ„ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(547599,15212,'pr','ÙØ§ÛŒÙ„ ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(547600,15212,'tr','GÃ¼nlÃ¼k dosyalarÄ±',0),(547601,15212,'pl','Pliki dziennika',0),(547602,15212,'bg','Ð›Ð¾Ð³ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(547603,15212,'ur','Ù„Ø§Ú¯ Ù…Ø³Ù„ÛŒÚº',0),(547604,15212,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ðµ',0),(547605,15212,'vi','Táº­p tin Ä‘Äƒng nháº­p',0),(547606,15212,'af','LoglÃªers',0),(547607,15212,'ro','FiÅŸierele log',0),(547608,15212,'et','Logifailid',0),(547609,15212,'si','DnevniÅ¡ke datoteke',0),(547610,15212,'ba','File log',0),(547611,15212,'nl','Log-bestanden',0),(547612,15212,'fi','Lokitiedostot',0),(547613,15212,'no','Loggfiler',0),(547614,15212,'da','Log-filer',0),(547615,15212,'ko','ë¡œê·¸ íŒŒì¼',0),(547616,15212,'he','×§×‘×¦×™ ×™×•×ž×Ÿ ×¨×™×©×•×',0),(547617,15212,'el','Î‘ÏÏ‡ÎµÎ¯Î± ÎºÎ±Ï„Î±Î³ÏÎ±Ï†Î®Ï‚',0),(547618,15212,'zh','æ—¥å¿—æ–‡ä»¶',0),(547619,15212,'sv','Loggfiler',0),(547620,15212,'it','File di registro',0),(547621,15212,'tl','',0),(547622,15212,'th','à¹à¸Ÿà¹‰à¸¡à¸šà¸±à¸™à¸—à¸¶à¸',0),(547623,15212,'hi','à¤²à¥‰à¤— à¤‡à¤¨ à¤«à¤¼à¤¾à¤‡à¤²à¥‹à¤‚',0),(547624,15212,'ms','Fail log',0),(547625,15212,'ar','Ù…Ù„ÙØ§Øª Ø§Ù„Ø³Ø¬Ù„',0),(547626,15212,'fr','Fichiers journaux',0),(547627,15212,'jp','ãƒ­ã‚° ãƒ•ã‚¡ã‚¤ãƒ«',0),(547628,15212,'pt','Arquivos de log',0),(547629,15212,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ Ð¶ÑƒÑ€Ð½Ð°Ð»Ð¾Ð²',0),(547630,15212,'es','Archivos de registro',0),(547631,15212,'de','Log-Dateien',0),(547632,15212,'en','Log Files',0),(547633,15213,'is','',0),(547634,15213,'dr','Ø´Ø±ÙˆØ¹ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(547635,15213,'pr','Ø´Ø±ÙˆØ¹ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(547636,15213,'tr','BaÅŸlangÄ±Ã§ gÃ¼ncelleÅŸtirmeleri',0),(547637,15213,'pl','RozpoczÄ…Ä‡ aktualizacje',0),(547638,15213,'bg','Ð¡Ñ‚Ð°Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(547639,15213,'ur','Ø§Ù¾ ÚˆÛŒÙ¹Ø³ Ú©Ø§ Ø¢ØºØ§Ø²',0),(547640,15213,'sr','ÐŸÐ¾ÐºÑ€ÐµÐ½ÑƒÑ‚Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(547641,15213,'vi','Báº¯t Ä‘áº§u Cáº­p Nháº­t',0),(547642,15213,'af','Begin bywerkings',0),(547643,15213,'ro','ÃŽncepe actualizÄƒri',0),(547644,15213,'et','Start uuendused',0),(547645,15213,'si','ZaÄetek posodobitve',0),(547646,15213,'ba','Memulai pembaruan',0),(547647,15213,'nl','Start Updates',0),(547648,15213,'fi','KÃ¤ynnistÃ¤ pÃ¤ivitykset',0),(547649,15213,'no','Start oppdateringene',0),(547650,15213,'da','Start opdateringer',0),(547651,15213,'ko','ì—…ë°ì´íŠ¸ ì‹œìž‘',0),(547652,15213,'he','×”×¤×¢×œ×ª ×¢×“×›×•× ×™×',0),(547653,15213,'el','ÎˆÎ½Î±ÏÎ¾Î· ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹Ï‚',0),(547654,15213,'zh','å¼€å§‹æ›´æ–°',0),(547655,15213,'sv','Starta uppdateringar',0),(547656,15213,'it','Avviare gli aggiornamenti',0),(547657,15213,'tl','',0),(547658,15213,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(547659,15213,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤•à¤°à¥‡à¤‚',0),(547660,15213,'ms','Kemas kini mula',0),(547661,15213,'ar','Ø¨Ø¯Ø¡ Ø§Ù„ØªØ­Ø¯ÙŠØ«Ø§Øª',0),(547662,15213,'fr','DÃ©marrer les mises Ã  jour',0),(547663,15213,'jp','æ›´æ–°ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(547664,15213,'pt','Iniciar atualizaÃ§Ãµes',0),(547665,15213,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(547666,15213,'es','Inicio Actualizaciones',0),(547667,15213,'de','Start Aktuelles',0),(547668,15213,'en','Start Updates',0),(547669,15214,'is','',0),(547670,15214,'dr','3dcart Ø¨Ø§ ÛŒÚ© Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ & Ù…Ù† Ø³Ø·Ø­ Ù…Ø­ØµÙˆÙ„Ø§Øª',0),(547671,15214,'pr','3dcart Ø¨Ø§ ÛŒÚ© Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ & Ù…Ù† Ø³Ø·Ø­ Ù…Ø­ØµÙˆÙ„Ø§Øª',0),(547672,15214,'tr','3dcart A ile gÃ¼ncelleÅŸtirmek ve ben Ã¼rÃ¼nleri dÃ¼zeyleri',0),(547673,15214,'pl','Aktualizacja 3dcart z A idealna I poziomy produktÃ³w',0),(547674,15214,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° 3dcart Ñ A & I Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸ Ð½Ð¸Ð²Ð°',0),(547675,15214,'ur','3dcart A Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù¾ ÚˆÛŒÙ¹ & Ù…ÛŒÚº Ù…ØµÙ†ÙˆØ¹Ø§Øª Ú©ÛŒ Ø³Ø·Ø­',0),(547676,15214,'sr','Ð Ð´Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ðµ 3Ð´Ñ†Ð°Ñ€Ñ‚ & ÑÐ°Ð¼ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸ Ð½Ð¸Ð²Ð¾Ðµ',0),(547677,15214,'vi','Cáº­p Nháº­t 3dcart vá»›i A & tÃ´i sáº£n pháº©m cáº¥p',0),(547678,15214,'af','3dcart met \'n bywerk & ek produkte vlakke',0),(547679,15214,'ro','Actualizare 3dcart cu A & am produse nivelurile',0),(547680,15214,'et','Uuendada 3dcart A & I toodete tasemed',0),(547681,15214,'si','Posodobiti 3dcart s A & sem ravni izdelkov',0),(547682,15214,'ba','Memperbarui 3dcart dengan & saya tingkat produk',0),(547683,15214,'nl','3dcart met A bijwerken & ik producten niveaus',0),(547684,15214,'fi','PÃ¤ivitÃ¤ 3dcart a & olen tuotteiden tasot',0),(547685,15214,'no','Oppdatere 3dcart med en & jeg produkter nivÃ¥er',0),(547686,15214,'da','Opdatere 3dcart med A & jeg produkter niveauer',0),(547687,15214,'ko','A 3dcart ì—…ë°ì´íŠ¸ & ë‚˜ ì œí’ˆ ìˆ˜ì¤€',0),(547688,15214,'he','×¢×“×›×•×Ÿ 3dcart ×¢× A & ×× ×™ ×ž×•×¦×¨×™× ×¨×ž×•×ª',0),(547689,15214,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart Î¼Îµ Î‘ & ÎµÎ³ÏŽ ÎµÏ€Î¯Ï€ÎµÎ´Î± Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î±',0),(547690,15214,'zh','ç”¨ A æ›´æ–° 3dcart ä»ªè¡¨äº§å“æ°´å¹³',0),(547691,15214,'sv','Uppdatera 3dcart med A & jag produkter nivÃ¥er',0),(547692,15214,'it','Aggiornamento 3dcart con A & prodotti livella',0),(547693,15214,'tl','',0),(547694,15214,'th','à¸­à¸±à¸žà¹€à¸” 3dcart à¸”à¹‰à¸§à¸¢à¸„à¸¸à¹‰à¸¡ à¸„à¹ˆà¸²à¸œà¸¡à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¸£à¸°à¸”à¸±à¸š',0),(547695,15214,'hi','3dcart à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ & à¤®à¥ˆà¤‚ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¥‹à¤‚ à¤•à¤¾ à¤¸à¥à¤¤à¤°',0),(547696,15214,'ms','Kemaskini Terakhir 3dcart dengan A & saya tahap produk',0),(547697,15214,'ar','ØªØ­Ø¯ÙŠØ« 3dcart Ù…Ø¹ Ø£ Ø¢Ù†Ø¯ Ø£Ù†Ø§ Ù…Ø³ØªÙˆÙŠØ§Øª Ø§Ù„Ù…Ù†ØªØ¬Ø§Øª',0),(547698,15214,'fr','Mise Ã  jour 3dcart avec A & j\'ai niveaux produits',0),(547699,15214,'jp','A ã¨ 3dcart ã‚’æ›´æ–°ãƒ»ç§ã¯è£½å“ãƒ¬ãƒ™ãƒ«',0),(547700,15214,'pt','Atualizar 3dcart com A & eu nÃ­veis de produtos',0),(547701,15214,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart Ñ A & Ñ ÑƒÑ€Ð¾Ð²Ð½ÑÑ… Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð²',0),(547702,15214,'es','Actualizar 3dcart con A y que los niveles de productos',0),(547703,15214,'de','Aktualisieren Sie 3dcart mit A & ich Produkte Ebenen',0),(547704,15214,'en','Update 3dcart With A&I Products Levels',0),(547705,15215,'is','',0),(547706,15215,'dr','ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ú©Ø§Ø±',0),(547707,15215,'pr','ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ú©Ø§Ø±',0),(547708,15215,'tr','GÃ¶rev aktivitesi',0),(547709,15215,'pl','DziaÅ‚anie zadania',0),(547710,15215,'bg','Ð”ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð½Ð° Ð·Ð°Ð´Ð°Ñ‡Ð°',0),(547711,15215,'ur','Ú©Ø§Ù… Ú©ÛŒ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(547712,15215,'sr','ÐÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð·Ð°Ð´Ð°Ñ‚ÐºÐ°',0),(547713,15215,'vi','Nhiá»‡m vá»¥ hoáº¡t Ä‘á»™ng',0),(547714,15215,'af','Taak aktiwiteit',0),(547715,15215,'ro','Activitatea de activitate',0),(547716,15215,'et','Toiming tegevus',0),(547717,15215,'si','Naloga dejavnost',0),(547718,15215,'ba','Tugas aktivitas',0),(547719,15215,'nl','Taakactiviteit',0),(547720,15215,'fi','TehtÃ¤vÃ¤n aktiviteetti',0),(547721,15215,'no','Oppgave',0),(547722,15215,'da','Opgave aktivitet',0),(547723,15215,'ko','ìž‘ì—… í™œë™',0),(547724,15215,'he','×¤×¢×™×œ×•×ª ×¤×¢×™×œ×•×ª',0),(547725,15215,'el','Î”ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(547726,15215,'zh','ä»»åŠ¡æ´»åŠ¨',0),(547727,15215,'sv','Uppgiftsaktiviteten',0),(547728,15215,'it','AttivitÃ  di attivitÃ ',0),(547729,15215,'tl','',0),(547730,15215,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸‡à¸²à¸™',0),(547731,15215,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(547732,15215,'ms','Aktiviti tugas',0),(547733,15215,'ar','Ù†Ø´Ø§Ø· Ù…Ù‡Ù…Ø©',0),(547734,15215,'fr','ActivitÃ© spÃ©ciale',0),(547735,15215,'jp','ã‚¿ã‚¹ã‚¯æ´»å‹•',0),(547736,15215,'pt','Atividade de tarefa',0),(547737,15215,'ru','Ð—Ð°Ð´Ð°Ñ‡Ð¸ Ð´ÐµÑÑ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚Ð¸',0),(547738,15215,'es','Actividad tarea',0),(547739,15215,'de','AufgabenaktivitÃ¤t',0),(547740,15215,'en','Task Activity',0),(547741,15216,'is','',0),(547742,15216,'dr','A & Ù…Ù† Ù…Ø­ØµÙˆÙ„Ø§Øª 3dcart Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(547743,15216,'pr','A & Ù…Ù† Ù…Ø­ØµÙˆÙ„Ø§Øª 3dcart Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(547744,15216,'tr','A ve ben Ã¼rÃ¼nleri 3dcart gÃ¼ncelleÅŸtirme',0),(547745,15216,'pl','A idealna I produkty 3dcart aktualizacji',0),(547746,15216,'bg','Ð & I Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸ 3dcart Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(547747,15216,'ur','A & Ù…ÛŒÚº Ù…ØµÙ†ÙˆØ¹Ø§Øª 3dcart Ø§Ù¾ ÚˆÛŒÙ¹',0),(547748,15216,'sr','Ð Ð¸ ÑÐ°Ð¼ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð¸ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð£Ð¿Ð´Ð°Ñ‚Ðµ',0),(547749,15216,'vi','A & tÃ´i sáº£n pháº©m Cáº­p Nháº­t 3dcart',0),(547750,15216,'af','\'N & ek produkte 3dcart bywerking',0),(547751,15216,'ro','A & am produse 3dcart Update',0),(547752,15216,'et','A- & I toodete 3dcart Update',0),(547753,15216,'si','A & I proizvodi 3dcart posodobitev',0),(547754,15216,'ba','A & saya produk 3dcart Update',0),(547755,15216,'nl','A & I producten 3dcart Update',0),(547756,15216,'fi','A & olen tuotteiden 3dcart pÃ¤ivitys',0),(547757,15216,'no','A & jeg produkter 3dcart oppdatering',0),(547758,15216,'da','A & jeg produkter 3dcart opdatering',0),(547759,15216,'ko','A & ë‚˜ ì œí’ˆ 3dcart ì—…ë°ì´íŠ¸',0),(547760,15216,'he','A & ×× ×™ ×ž×•×¦×¨×™× ×¢×“×›×•×Ÿ 3dcart',0),(547761,15216,'el','A & ÎµÎ³ÏŽ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î± 3dcart ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(547762,15216,'zh','A ä»ªè¡¨äº§å“ 3dcart æ›´æ–°',0),(547763,15216,'sv','A & jag produkter 3dcart uppdatering',0),(547764,15216,'it','A & I prodotti 3dcart aggiornamento',0),(547765,15216,'tl','',0),(547766,15216,'th','A à¸„à¸¸à¹‰à¸¡à¸„à¹ˆà¸²à¸œà¸¡à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡ 3dcart',0),(547767,15216,'hi','A & à¤®à¥ˆà¤‚ à¤‰à¤¤à¥à¤ªà¤¾à¤¦à¥‹à¤‚ 3dcart à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(547768,15216,'ms','A & saya produk 3dcart Update',0),(547769,15216,'ar','A Ø¢Ù†Ø¯ Ø£Ù†Ø§ Ù…Ù†ØªØ¬Ø§Øª Ø§Ù„ØªØ­Ø¯ÙŠØ« 3dcart',0),(547770,15216,'fr','A & j\'ai produits 3dcart mise Ã  jour',0),(547771,15216,'jp','A ãƒ»ç§ã®è£½å“ 3dcart æ›´æ–°',0),(547772,15216,'pt','A & eu produtos 3dcart atualizaÃ§Ã£o',0),(547773,15216,'ru','A & Ñ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð² 3dcart Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(547774,15216,'es','A y que productos 3dcart actualizaciÃ³n',0),(547775,15216,'de','A & I Produkte 3dcart-Update',0),(547776,15216,'en','A&I Products 3dcart Update',0),(547777,15217,'is','',0),(547778,15217,'dr','ACH EFT',0),(547779,15217,'pr','ACH EFT',0),(547780,15217,'tr','ACH EFT',0),(547781,15217,'pl','ACH, TRYTON',0),(547782,15217,'bg','ACH EFT',0),(547783,15217,'ur','Ø§Ú† EFT',0),(547784,15217,'sr','ÐÐ¥ Ð•Ð¤Ð¢',0),(547785,15217,'vi','ACH EFT',0),(547786,15217,'af','ACH EFT',0),(547787,15217,'ro','ACH EFT',0),(547788,15217,'et','ACH EFT',0),(547789,15217,'si','ACH EFT',0),(547790,15217,'ba','TDE ACH',0),(547791,15217,'nl','ACH EFT',0),(547792,15217,'fi','ACH EFT',0),(547793,15217,'no','ACH EFT',0),(547794,15217,'da','ACH EFT',0),(547795,15217,'ko','ACH ì†¡ê¸ˆ',0),(547796,15217,'he','ACH EFT',0),(547797,15217,'el','ACH EFT',0),(547798,15217,'zh','ACH EFT',0),(547799,15217,'sv','ACH EFT',0),(547800,15217,'it','ACH EFT',0),(547801,15217,'tl','',0),(547802,15217,'th','ACH EFT',0),(547803,15217,'hi','ACH à¤ˆà¤à¤«à¤¼à¤Ÿà¥€',0),(547804,15217,'ms','MEN EFT',0),(547805,15217,'ar','EFT Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹',0),(547806,15217,'fr','ACH EFT',0),(547807,15217,'jp','ACH éŠ€è¡Œå£åº§æŒ¯è¾¼',0),(547808,15217,'pt','ACH EFT',0),(547809,15217,'ru','ACH EFT',0),(547810,15217,'es','ACH EFT',0),(547811,15217,'de','ACH EFT',0),(547812,15217,'en','ACH EFT',0),(547813,15218,'is','',0),(547814,15218,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‚Ø¨Ø¶',0),(547815,15218,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‚Ø¨Ø¶',0),(547816,15218,'tr','Fatura Ã¶demeleri',0),(547817,15218,'pl','Bill pÅ‚atnoÅ›ci',0),(547818,15218,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(547819,15218,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(547820,15218,'sr','Ð‘Ð¸Ð» ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(547821,15218,'vi','HÃ³a Ä‘Æ¡n thanh toÃ¡n',0),(547822,15218,'af','Wetsontwerp betalings',0),(547823,15218,'ro','Bill plÄƒÅ£i',0),(547824,15218,'et','Telefoniarvele maksete',0),(547825,15218,'si','RaÄun plaÄilne',0),(547826,15218,'ba','Pembayaran tagihan',0),(547827,15218,'nl','Factuur betalingen',0),(547828,15218,'fi','Bill maksut',0),(547829,15218,'no','Avdrag',0),(547830,15218,'da','Bill betalinger',0),(547831,15218,'ko','ë¹Œ ì§€ë¶ˆ',0),(547832,15218,'he','×‘×™×œ ×ª×©×œ×•×ž×™×',0),(547833,15218,'el','Î Î›Î—Î¡Î©ÎœÎ— Î›ÎŸÎ“Î‘Î¡Î™Î‘Î£ÎœÎ©Î ÎœÎ•Î£Î© Î”Î™Î‘Î”Î¥ÎšÎ¤Î¥ÎŸÎ¥',0),(547834,15218,'zh','è´¦å•æ”¯ä»˜',0),(547835,15218,'sv','Bill betalningar',0),(547836,15218,'it','Pagamento delle bollette',0),(547837,15218,'tl','',0),(547838,15218,'th','à¸šà¸£à¸´à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(547839,15218,'hi','à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(547840,15218,'ms','Pembayaran bil',0),(547841,15218,'ar','Ø¯ÙØ¹ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(547842,15218,'fr','Paiements de factures',0),(547843,15218,'jp','è«‹æ±‚æ›¸ã®æ”¯æ‰•ã„',0),(547844,15218,'pt','Pagamentos de contas',0),(547845,15218,'ru','Ð‘Ð¸Ð»Ð» Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(547846,15218,'es','Pago de facturas',0),(547847,15218,'de','Rechnungszahlungen',0),(547848,15218,'en','Bill Payments',0),(547849,15219,'is','',0),(547850,15219,'dr','Pmt Ø¨ÛŒÙ„',0),(547851,15219,'pr','Pmt Ø¨ÛŒÙ„',0),(547852,15219,'tr','Bill Devresel Ã¶deme',0),(547853,15219,'pl','Bill Pmt',0),(547854,15219,'bg','Ð‘Ð¸Ð» Pmt',0),(547855,15219,'ur','Ø¨Ù„ Ù¾Ù…Ù¹',0),(547856,15219,'sr','Ð‘Ð¸Ð»Ð» ÐŸÐ¼Ñ‚',0),(547857,15219,'vi','Bill Pmt',0),(547858,15219,'af','Wetsontwerp Pmt',0),(547859,15219,'ro','Bill Pmt',0),(547860,15219,'et','Arve makse',0),(547861,15219,'si','Bill Pmt',0),(547862,15219,'ba','Bill Pmt',0),(547863,15219,'nl','Bill Pmt',0),(547864,15219,'fi','Bill erÃ¤',0),(547865,15219,'no','Bill avdrag',0),(547866,15219,'da','Bill ydelse',0),(547867,15219,'ko','ë¹Œ Pmt',0),(547868,15219,'he','×‘×™×œ Pmt',0),(547869,15219,'el','Bill Pmt',0),(547870,15219,'zh','æ¡ä¾‹è‰æ¡ˆ Pmt',0),(547871,15219,'sv','Bill betalning',0),(547872,15219,'it','Bill Pmt',0),(547873,15219,'tl','',0),(547874,15219,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(547875,15219,'hi','à¤µà¤¿à¤§à¥‡à¤¯à¤• Pmt',0),(547876,15219,'ms','Pmt Rang undang-undang',0),(547877,15219,'ar','Pmt Ø¨ÙŠÙ„',0),(547878,15219,'fr','Projet de loi Pmt',0),(547879,15219,'jp','æ³•æ¡ˆ Pmt',0),(547880,15219,'pt','Bill Pmt',0),(547881,15219,'ru','Ð‘Ð¸Ð»Ð» Pmt',0),(547882,15219,'es','Bill Pmt',0),(547883,15219,'de','Bill-Pmt',0),(547884,15219,'en','Bill Pmt',0),(547885,15220,'is','',0),(547886,15220,'dr','Ù¾Ø§Ú©',0),(547887,15220,'pr','Ù¾Ø§Ú©',0),(547888,15220,'tr','TemizlenmiÅŸ',0),(547889,15220,'pl','Wyczyszczone',0),(547890,15220,'bg','Ð˜Ð·Ñ‡Ð¸ÑÑ‚Ð²Ð°',0),(547891,15220,'ur','ØµØ§Ù Ú©ÛŒØ§',0),(547892,15220,'sr','ÐžÐ´Ð¾Ð±Ñ€ÐµÐ½Ð¾',0),(547893,15220,'vi','XÃ³a',0),(547894,15220,'af','Skoongemaak',0),(547895,15220,'ro','Eliminate',0),(547896,15220,'et','TÃ¼hjendatud',0),(547897,15220,'si','OÄiÅ¡Äeno',0),(547898,15220,'ba','Membersihkan',0),(547899,15220,'nl','Uitgeschakeld',0),(547900,15220,'fi','Poistettu',0),(547901,15220,'no','Fjernet',0),(547902,15220,'da','Ryddet',0),(547903,15220,'ko','ì‚­ì œ',0),(547904,15220,'he','×¤×™× ×”',0),(547905,15220,'el','Î•ÎºÎºÎ±Î¸Î±ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹',0),(547906,15220,'zh','æ¸…é™¤',0),(547907,15220,'sv','Rensat',0),(547908,15220,'it','Deselezionata',0),(547909,15220,'tl','',0),(547910,15220,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¹€à¸¥à¸·à¸­à¸',0),(547911,15220,'hi','à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥‡ à¤¦à¥€',0),(547912,15220,'ms','Dibersihkan',0),(547913,15220,'ar','Ù…Ø³Ø­',0),(547914,15220,'fr','EffacÃ©e',0),(547915,15220,'jp','ã‚ªãƒ•ã«ã™ã‚‹ã¨',0),(547916,15220,'pt','Desmarcada',0),(547917,15220,'ru','ÐžÑ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ',0),(547918,15220,'es','Borra',0),(547919,15220,'de','Deaktiviert',0),(547920,15220,'en','Cleared',0),(547921,15221,'is','',0),(547922,15221,'dr','Ø³ÙØ§Ø±Ø´',0),(547923,15221,'pr','Ø³ÙØ§Ø±Ø´',0),(547924,15221,'tr','SipariÅŸ',0),(547925,15221,'pl','Zamawianie',0),(547926,15221,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡Ð²Ð°Ð½Ðµ',0),(547927,15221,'ur','Ø­Ú©Ù…',0),(547928,15221,'sr','ÐÐ°Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐµ',0),(547929,15221,'vi','Äáº·t hÃ ng',0),(547930,15221,'af','Bestel',0),(547931,15221,'ro','Comanda',0),(547932,15221,'et','Tellimine',0),(547933,15221,'si','NaroÄanje',0),(547934,15221,'ba','Memesan',0),(547935,15221,'nl','Bestellen',0),(547936,15221,'fi','Tilaaminen',0),(547937,15221,'no','Bestilling',0),(547938,15221,'da','Bestilling',0),(547939,15221,'ko','ì£¼ë¬¸',0),(547940,15221,'he','×”×–×ž× ×ª',0),(547941,15221,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(547942,15221,'zh','è®¢è´­',0),(547943,15221,'sv','BestÃ¤llning',0),(547944,15221,'it','L\'ordinazione',0),(547945,15221,'tl','',0),(547946,15221,'th','à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(547947,15221,'hi','à¤†à¤¦à¥‡à¤¶ à¤¦à¥‡',0),(547948,15221,'ms','Pesanan',0),(547949,15221,'ar','ØªØ±ØªÙŠØ¨',0),(547950,15221,'fr','Vous passez votre commande',0),(547951,15221,'jp','ã”æ³¨æ–‡',0),(547952,15221,'pt','OrdenaÃ§Ã£o',0),(547953,15221,'ru','Ð—Ð°ÐºÐ°Ð·',0),(547954,15221,'es','Ordenar',0),(547955,15221,'de','Bestellen',0),(547956,15221,'en','Ordering',0),(547957,15222,'is','',0),(547958,15222,'dr','Ø­Ù…Ù„ ØªØ§ Ø­Ø¯ÛŒ',0),(547959,15222,'pr','Ø­Ù…Ù„ ØªØ§ Ø­Ø¯ÛŒ',0),(547960,15222,'tr','KÄ±smen Sevkedildi',0),(547961,15222,'pl','CzÄ™Å›ciowo wydane',0),(547962,15222,'bg','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð°',0),(547963,15222,'ur','Ø¬Ø²ÙˆÛŒ Ø·ÙˆØ± Ù¾Ø± Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(547964,15222,'sr','Ð”ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð¾',0),(547965,15222,'vi','Má»™t pháº§n váº­n chuyá»ƒn',0),(547966,15222,'af','Gedeeltelik Shipped',0),(547967,15222,'ro','Expediat parÅ£ial',0),(547968,15222,'et','Osaliselt lÃ¤hetatud',0),(547969,15222,'si','Delno dobavljeno',0),(547970,15222,'ba','Sebagian dikirim',0),(547971,15222,'nl','Gedeeltelijk verzonden',0),(547972,15222,'fi','Osittain toimitettu',0),(547973,15222,'no','Delvis levert',0),(547974,15222,'da','Delvist leveret',0),(547975,15222,'ko','ë¶€ë¶„ì ìœ¼ë¡œ ë°œì†¡',0),(547976,15222,'he','×—×œ×§×™×ª ×©× ×©×œ×—×•',0),(547977,15222,'el','ÎœÎµÏÎ¹ÎºÎ® Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(547978,15222,'zh','éƒ¨åˆ†è¿é€',0),(547979,15222,'sv','Delutlevererad',0),(547980,15222,'it','Spedizione parziale',0),(547981,15222,'tl','',0),(547982,15222,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹€à¸›à¹‡à¸™à¸šà¸²à¸‡à¸ªà¹ˆà¸§à¸™',0),(547983,15222,'hi','à¤†à¤‚à¤¶à¤¿à¤• à¤°à¥‚à¤ª à¤¸à¥‡ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(547984,15222,'ms','Sebahagiannya dihantar',0),(547985,15222,'ar','ØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ø¬Ø²Ø¦ÙŠØ§',0),(547986,15222,'fr','Partiellement expÃ©diÃ©',0),(547987,15222,'jp','ä¸€éƒ¨ã‚’å‡ºè·',0),(547988,15222,'pt','Parcialmente enviado',0),(547989,15222,'ru','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ Ð¾Ñ‚Ð³Ñ€ÑƒÐ¶ÐµÐ½',0),(547990,15222,'es','Enviado parcialmente',0),(547991,15222,'de','Teilweise ausgeliefert',0),(547992,15222,'en','Partially Shipped',0),(547993,15223,'is','',0),(547994,15223,'dr','Ù†Ù…Ø§ÛŒØ´ 50 Ù…Ø·Ù„Ø¨ Ø¨Ø¹Ø¯ÛŒ',0),(547995,15223,'pr','Ù†Ù…Ø§ÛŒØ´ 50 Ù…Ø·Ù„Ø¨ Ø¨Ø¹Ø¯ÛŒ',0),(547996,15223,'tr','Sonraki 50 gÃ¶ster',0),(547997,15223,'pl','PokaÅ¼ nastÄ™pne 50',0),(547998,15223,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ 50',0),(547999,15223,'ur','Ø§Ú¯Ù„Û’ 50 Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(548000,15223,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð°Ñ€ÐµÐ´Ð½Ð¸Ñ… 50',0),(548001,15223,'vi','Hiá»ƒn thá»‹ sau 50',0),(548002,15223,'af','Wys volgende 50',0),(548003,15223,'ro','AratÄƒ urmÄƒtoarea 50',0),(548004,15223,'et','NÃ¤ita jÃ¤rgmist 50',0),(548005,15223,'si','PrikaÅ¾i naslednjo 50',0),(548006,15223,'ba','Tampilkan 50 berikutnya',0),(548007,15223,'nl','Toon volgende 50',0),(548008,15223,'fi','NÃ¤ytÃ¤ seuraavien 50',0),(548009,15223,'no','Vis neste 50',0),(548010,15223,'da','Vis nÃ¦ste 50',0),(548011,15223,'ko','ë‹¤ìŒ 50 í‘œì‹œ',0),(548012,15223,'he','×”×¦×’ 50 ×”×‘×',0),(548013,15223,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎµÏ€ÏŒÎ¼ÎµÎ½Î± 50',0),(548014,15223,'zh','æ˜¾ç¤ºä¸‹ä¸€ä¸ª 50',0),(548015,15223,'sv','Visa nÃ¤sta 50',0),(548016,15223,'it','Visualizza prossimi 50',0),(548017,15223,'tl','',0),(548018,15223,'th','à¹à¸ªà¸”à¸‡ 50 à¸–à¸±à¸”à¹„à¸›',0),(548019,15223,'hi','à¤…à¤—à¤²à¥‡ 50 à¤¦à¤¿à¤–à¤¾à¤à¤',0),(548020,15223,'ms','Menunjukkan 50 akan datang',0),(548021,15223,'ar','Ø¥Ø¸Ù‡Ø§Ø± 50 Ø§Ù„Ù‚Ø§Ø¯Ù…Ø©',0),(548022,15223,'fr','Afficher les 50 prochaines',0),(548023,15223,'jp','æ¬¡ 50 ã—ã¾ã™ã€‚',0),(548024,15223,'pt','Mostrar os prÃ³ximos 50',0),(548025,15223,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ð¹ 50',0),(548026,15223,'es','Ver 50 siguientes',0),(548027,15223,'de','Zeige nÃ¤chste 50',0),(548028,15223,'en','Show Next 50',0),(548029,15224,'is','',0),(548030,15224,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø³Ø§Ø²',0),(548031,15224,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø³Ø§Ø²',0),(548032,15224,'tr','Rapor OluÅŸturucusu',0),(548033,15224,'pl','Konstruktora raportÃ³w',0),(548034,15224,'bg','Report Builder',0),(548035,15224,'ur','Ø±Ù¾ÙˆØ±Ù¹ ØªÛŒØ§Ø± Ú©Ù†Ù†Ø¯Û',0),(548036,15224,'sr','Ð ÐµÐ¿Ð¾Ñ€Ñ‚ Ð‘ÑƒÐ¸Ð»Ð´ÐµÑ€',0),(548037,15224,'vi','XÃ¢y dá»±ng bÃ¡o cÃ¡o',0),(548038,15224,'af','Verslag bouer',0),(548039,15224,'ro','Raport Builder',0),(548040,15224,'et','Aruandelooja',0),(548041,15224,'si','PoroÄilo Builder',0),(548042,15224,'ba','Laporan Builder',0),(548043,15224,'nl','Report Builder',0),(548044,15224,'fi','Report Builder',0),(548045,15224,'no','Rapportbygger',0),(548046,15224,'da','Report Builder',0),(548047,15224,'ko','ë³´ê³ ì„œ ìž‘ì„±ê¸°',0),(548048,15224,'he','×‘×•× ×” ×”×“×•×—×•×ª',0),(548049,15224,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Î´ÏŒÎ¼Î·ÏƒÎ·Ï‚',0),(548050,15224,'zh','æŠ¥è¡¨ç”Ÿæˆå™¨',0),(548051,15224,'sv','Report Builder',0),(548052,15224,'it','Generatore report',0),(548053,15224,'tl','',0),(548054,15224,'th','à¹‚à¸›à¸£à¹à¸à¸£à¸¡à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸‡à¸²à¸™',0),(548055,15224,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¬à¤¿à¤²à¥à¤¡à¤°',0),(548056,15224,'ms','Laporan pembina',0),(548057,15224,'ar','Ù…Ù†Ø´Ø¦ Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(548058,15224,'fr','Le gÃ©nÃ©rateur de rapports',0),(548059,15224,'jp','ãƒ¬ãƒãƒ¼ãƒˆ ãƒ“ãƒ«ãƒ€ãƒ¼',0),(548060,15224,'pt','Construtor de relatÃ³rios',0),(548061,15224,'ru','ÐŸÐ¾ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÐµÐ»ÑŒ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¾Ð²',0),(548062,15224,'es','Generador de informe',0),(548063,15224,'de','Berichts-Generator',0),(548064,15224,'en','Report Builder',0),(548065,15225,'is','',0),(548066,15225,'dr','Ø²Ù…Ø§Ù† Ø³Ù¾Ø±ÛŒ Ø´Ø¯Ù‡',0),(548067,15225,'pr','Ø²Ù…Ø§Ù† Ø³Ù¾Ø±ÛŒ Ø´Ø¯Ù‡',0),(548068,15225,'tr','GeÃ§en sÃ¼re',0),(548069,15225,'pl','UpÅ‚ywajÄ…cy czas',0),(548070,15225,'bg','Ð˜Ð·Ð¼Ð¸Ð½Ð°Ð»Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(548071,15225,'ur','Ú¯Ø²Ø±Ø§ ÙˆÙ‚Øª',0),(548072,15225,'sr','ÐŸÑ€Ð¾Ñ‚ÐµÐºÐ»Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(548073,15225,'vi','Thá»i gian Ä‘Ã£ qua',0),(548074,15225,'af','Verloopte tyd',0),(548075,15225,'ro','Timp scurs',0),(548076,15225,'et','Kulunud aeg',0),(548077,15225,'si','Potekli Äas',0),(548078,15225,'ba','Waktu berlalu',0),(548079,15225,'nl','Verstreken tijd',0),(548080,15225,'fi','Kulunut aika',0),(548081,15225,'no','ForlÃ¸pt tid',0),(548082,15225,'da','ForlÃ¸bet tid',0),(548083,15225,'ko','ê²½ê³¼ ì‹œê°„',0),(548084,15225,'he','×–×ž×Ÿ ×©×—×œ×£',0),(548085,15225,'el','Î§ÏÏŒÎ½Î¿Ï‚ Ï€Î¿Ï… Ï€Î­ÏÎ±ÏƒÎµ',0),(548086,15225,'zh','ç»è¿‡çš„æ—¶é—´',0),(548087,15225,'sv','FÃ¶rfluten tid',0),(548088,15225,'it','Tempo trascorso',0),(548089,15225,'tl','',0),(548090,15225,'th','à¹€à¸§à¸¥à¸²à¸œà¹ˆà¸²à¸™à¹„à¸›',0),(548091,15225,'hi','à¤¬à¥€à¤¤à¤¾ à¤¹à¥à¤† à¤¸à¤®à¤¯',0),(548092,15225,'ms','Berdasarkan keseluruhan catatan masa',0),(548093,15225,'ar','Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ù…Ù†Ù‚Ø¶ÙŠ',0),(548094,15225,'fr','Temps Ã©coulÃ©',0),(548095,15225,'jp','çµŒéŽæ™‚é–“',0),(548096,15225,'pt','Tempo decorrido',0),(548097,15225,'ru','ÐŸÑ€Ð¾ÑˆÐµÐ´ÑˆÐµÐµ Ð²Ñ€ÐµÐ¼Ñ',0),(548098,15225,'es','Tiempo transcurrido',0),(548099,15225,'de','Verstrichene Zeit',0),(548100,15225,'en','Elapsed Time',0),(548101,15226,'is','',0),(548102,15226,'dr','Ø³Ù¾Ø±ÛŒ',0),(548103,15226,'pr','Ø³Ù¾Ø±ÛŒ',0),(548104,15226,'tr','GeÃ§en sÃ¼re',0),(548105,15226,'pl','KtÃ³ry upÅ‚ynÄ…Å‚',0),(548106,15226,'bg','Ð˜Ð·Ð¼Ð¸Ð½Ð°Ð»Ð¸',0),(548107,15226,'ur','Ú¯Ø²Ø±Ø§',0),(548108,15226,'sr','ÐŸÑ€Ð¾Ñ‚ÐµÐºÐ»Ð¾',0),(548109,15226,'vi','TrÃ´i qua',0),(548110,15226,'af','Verstryk',0),(548111,15226,'ro','Scurs',0),(548112,15226,'et','MÃ¶Ã¶dunud',0),(548113,15226,'si','Preteklo',0),(548114,15226,'ba','Berlalu',0),(548115,15226,'nl','Verstreken',0),(548116,15226,'fi','Kulunut',0),(548117,15226,'no','ForlÃ¸pt',0),(548118,15226,'da','ForlÃ¸bet',0),(548119,15226,'ko','ê²½ê³¼',0),(548120,15226,'he','×—×œ×£',0),(548121,15226,'el','Î Î±ÏÎ­Î»Î¸ÎµÎ¹',0),(548122,15226,'zh','è¿‡åŽ»äº†',0),(548123,15226,'sv','FÃ¶rflutit',0),(548124,15226,'it','Trascorso',0),(548125,15226,'tl','',0),(548126,15226,'th','à¸œà¹ˆà¸²à¸™à¹„à¸›',0),(548127,15226,'hi','à¤—à¥à¤œà¤°à¥‡',0),(548128,15226,'ms','Berlalu',0),(548129,15226,'ar','Ø§Ù„Ù…Ù†Ù‚Ø¶ÙŠ',0),(548130,15226,'fr','S\'est Ã©coulÃ©',0),(548131,15226,'jp','çµŒéŽ',0),(548132,15226,'pt','Decorrido',0),(548133,15226,'ru','ÐŸÑ€Ð¾ÑˆÐ»Ð¾',0),(548134,15226,'es','Transcurrido',0),(548135,15226,'de','Verstrichene',0),(548136,15226,'en','Elapsed',0),(548137,15227,'is','',0),(548138,15227,'dr','Ù†Ù‡ Ø¨Ø§ Ø³Ù†Ø¬Ø´ Ø²Ù…Ø§Ù†',0),(548139,15227,'pr','Ù†Ù‡ Ø¨Ø§ Ø³Ù†Ø¬Ø´ Ø²Ù…Ø§Ù†',0),(548140,15227,'tr','HÄ±zÄ±nda deÄŸil',0),(548141,15227,'pl','Nie zarejestrowany',0),(548142,15227,'bg','ÐÐµ Ñ‡Ð°ÑÐ¾Ð²Ð½Ð¸Ðº Ð²',0),(548143,15227,'ur','Ú©ÙˆÛŒÙ„Ú©ÙˆÙ… Ø§Ø³Ù†ÛŒÙ¾ ÚˆØ±ÛŒÚ¯Ù† Ù†ÛÛŒÚº',0),(548144,15227,'sr','ÐÐ¸Ñ˜Ðµ ÑƒÑ€ÐµÐ´Ð½Ð¾ ÑÐµ',0),(548145,15227,'vi','KhÃ´ng tá»‘c Ä‘á»™',0),(548146,15227,'af','Clocked nie',0),(548147,15227,'ro','Nu cronometrat Ã®n',0),(548148,15227,'et','Pole end registreerinud',0),(548149,15227,'si','Ni ustvarila',0),(548150,15227,'ba','Tidak Clock di',0),(548151,15227,'nl','Niet klokte In',0),(548152,15227,'fi','Ole saapunut',0),(548153,15227,'no','Ikke stemplet inn',0),(548154,15227,'da','Ikke clocket',0),(548155,15227,'ko','í•˜ì§€ í´ëŸ­',0),(548156,15227,'he','×œ× ×”×—×ª×™× ×©×¢×•×Ÿ ×‘×›× ×™×¡×”',0),(548157,15227,'el','Î”ÎµÎ½ Ï‡ÏÎ¿Î½Î¿Î¼ÎµÏ„ÏÎ·Î¸ÎµÎ¯',0),(548158,15227,'zh','ä¸Šç­æœªæ‰“å¡',0),(548159,15227,'sv','Inte stÃ¤mplat In',0),(548160,15227,'it','Non cronometrato In',0),(548161,15227,'tl','',0),(548162,15227,'th','à¹„à¸¡à¹ˆà¸•à¸­à¸',0),(548163,15227,'hi','à¤•à¤®à¤¾à¤ à¤¨à¤¹à¥€à¤‚',0),(548164,15227,'ms','Tidak mencatat masa',0),(548165,15227,'ar','Ù„Ø§ Ø³Ø¬Ù„Øª',0),(548166,15227,'fr','Pas cadencÃ©',0),(548167,15227,'jp','ã‚’å‡ºå‹¤ã›ãš',0),(548168,15227,'pt','NÃ£o cronometrado em',0),(548169,15227,'ru','ÐÐµ Ñ€Ð°Ð·Ð³Ð¾Ð½ÑÐ» Ð²',0),(548170,15227,'es','No registrado',0),(548171,15227,'de','Nicht eingestempelt',0),(548172,15227,'en','Not Clocked In',0),(548173,15228,'is','',0),(548174,15228,'dr','Ø´Ø±Ø­ Ú©ÙˆØªØ§Ù‡ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart ÙˆØ§Ø±Ø¯',0),(548175,15228,'pr','Ø´Ø±Ø­ Ú©ÙˆØªØ§Ù‡ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart ÙˆØ§Ø±Ø¯',0),(548176,15228,'tr','KÄ±sa aÃ§Ä±klamalar bu 3dcart deposundan almak',0),(548177,15228,'pl','KrÃ³tkie opisy importu z tego sklepu 3dcart',0),(548178,15228,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÑ€Ð°Ñ‚ÐºÐ¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ 3dcart ÐœÐ°Ð³Ð°Ð·Ð¸Ð½',0),(548179,15228,'ur','ÛŒÛ 3dcart Ø§Ø³Ù¹ÙˆØ± Ø³Û’ Ù…Ø®ØªØµØ± ØªØµØ±ÛŒØ­Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(548180,15228,'sr','Ð£Ð²Ð¾Ð· ÐºÑ€Ð°Ñ‚ÐºÐµ Ð¾Ð¿Ð¸ÑÐµ Ð¸Ð· Ð¾Ð²Ð¾Ð³ 3Ð´Ñ†Ð°Ñ€Ñ‚ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð°',0),(548181,15228,'vi','Nháº­p mÃ´ táº£ ngáº¯n tá»« cá»­a hÃ ng 3dcart nÃ y',0),(548182,15228,'af','Voer kort beskrywings van hierdie 3dcart Winkel',0),(548183,15228,'ro','Import scurte descrieri de la acest magazin 3dcart',0),(548184,15228,'et','See 3dcart pood lÃ¼hikirjeldused importimine',0),(548185,15228,'si','Kratki opisi uvoz iz te shrambe 3dcart',0),(548186,15228,'ba','Deskripsi pendek impor dari toko 3dcart ini',0),(548187,15228,'nl','Korte beschrijvingen van deze winkel 3dcart importeren',0),(548188,15228,'fi','LyhyitÃ¤ kuvauksia tuominen 3dcart Store',0),(548189,15228,'no','Importere korte beskrivelser fra denne 3dcart butikken',0),(548190,15228,'da','Importere korte beskrivelser fra denne 3dcart butik',0),(548191,15228,'ko','ì´ 3dcartê°€ ê²Œì—ì„œ ì§§ì€ ì„¤ëª… ê°€ì ¸ì˜¤ê¸°',0),(548192,15228,'he','×™×™×‘×•× ×ª×™××•×¨×™× ×§×¦×¨×™× ×ž×”×—× ×•×ª 3dcart',0),(548193,15228,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏÎ½Ï„Î¿Î¼ÎµÏ‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚ Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± 3dcart',0),(548194,15228,'zh','ä»Žè¿™ä¸ª 3dcart å­˜å‚¨å¯¼å…¥çš„ç®€çŸ­æè¿°',0),(548195,15228,'sv','Importera korta beskrivningar frÃ¥n denna 3dcart butik',0),(548196,15228,'it','Brevi descrizioni di importazione da questo negozio 3dcart',0),(548197,15228,'tl','',0),(548198,15228,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸ªà¸±à¹‰à¸™à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸²à¸à¸£à¹‰à¸²à¸™ 3dcart à¸™à¸µà¹‰',0),(548199,15228,'hi','à¤²à¤˜à¥ à¤µà¤°à¥à¤£à¤¨ à¤‡à¤¸ 3dcart à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨ à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(548200,15228,'ms','Huraian singkat import dari kedai 3dcart ini',0),(548201,15228,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£ÙˆØµØ§Ù Ù‚ØµÙŠØ±Ø© Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²Ù† 3dcart',0),(548202,15228,'fr','Importation de courtes Descriptions de ce magasin de 3dcart',0),(548203,15228,'jp','ã“ã® 3dcart ã‚¹ãƒˆã‚¢ã‹ã‚‰ç°¡å˜ãªèª¬æ˜Žã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(548204,15228,'pt','ImportaÃ§Ã£o de descriÃ§Ãµes curtas desta loja 3dcart',0),(548205,15228,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¸Ð· ÑÑ‚Ð¾Ð³Ð¾ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð° 3dcart ÐºÑ€Ð°Ñ‚ÐºÐ¸Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(548206,15228,'es','Importar las descripciones cortas de esta tienda 3dcart',0),(548207,15228,'de','Importieren Sie kurze Beschreibungen aus diesem 3dcart-Speicher',0),(548208,15228,'en','Import Short Descriptions From This 3dcart Store',0),(548209,15229,'is','',0),(548210,15229,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ú©ÙˆØªØ§Ù‡ ØªÙˆØµÛŒÙØŒ Ø§Ú¯Ø± Ù†Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(548211,15229,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ú©ÙˆØªØ§Ù‡ ØªÙˆØµÛŒÙØŒ Ø§Ú¯Ø± Ù†Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(548212,15229,'tr','Åžu anda ayarlanmÄ±ÅŸ deÄŸilse kÄ±sa aÃ§Ä±klamalarÄ± almak',0),(548213,15229,'pl','ZaimportowaÄ‡ krÃ³tkich opisÃ³w, jeÅ›li nie obecnie zestaw',0),(548214,15229,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÑ€Ð°Ñ‚ÐºÐ¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ, Ð°ÐºÐ¾ Ð½Ðµ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð°',0),(548215,15229,'ur','Ù…Ø®ØªØµØ± ØªØµØ±ÛŒØ­Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ù†ÛÛŒÚº ØªÙˆ Ø§Ø³ ÙˆÙ‚Øª Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(548216,15229,'sr','Ð£Ð²Ð¾Ð· ÐºÑ€Ð°Ñ‚ÐºÐµ Ð¾Ð¿Ð¸ÑÐµ Ð°ÐºÐ¾ Ð½Ðµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(548217,15229,'vi','Nháº­p mÃ´ táº£ ngáº¯n náº¿u khÃ´ng hiá»‡n Ä‘ang thiáº¿t láº­p',0),(548218,15229,'af','Voer kort beskrywings, indien nie tans stel',0),(548219,15229,'ro','Scurte descrieri de import dacÄƒ nu este setat Ã®n prezent',0),(548220,15229,'et','Importida lÃ¼hikirjeldused kui mitte praegu seatud',0),(548221,15229,'si','Uvoz kratkimi opisi, Äe ne trenutno doloÄa',0),(548222,15229,'ba','Impor Deskripsi pendek jika tidak saat ini ditetapkan',0),(548223,15229,'nl','Importeren van korte beschrijvingen als niet momenteel ingesteld',0),(548224,15229,'fi','Tuo lyhyitÃ¤ kuvauksia, jos sitÃ¤ ei ole mÃ¤Ã¤ritetty',0),(548225,15229,'no','Importere korte beskrivelser om ikke konfigurert',0),(548226,15229,'da','Importere korte beskrivelser, hvis ikke indstillet',0),(548227,15229,'ko','í˜„ìž¬ ì„¤ì • ë˜ì§€ ì•Šì€ ê²½ìš° ì§§ì€ ì„¤ëª… ê°€ì ¸ì˜¤ê¸°',0),(548228,15229,'he','×™×™×‘×•× ×ª×™××•×¨×™ ×§×¦×¨ ×× ×œ× ×ž×•×’×“×¨×ª ×›×¢×ª',0),(548229,15229,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏÎ½Ï„Î¿Î¼ÎµÏ‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚, Î±Î½ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÎµÏ€Î¯ Ï„Î¿Ï… Ï€Î±ÏÏŒÎ½Ï„Î¿Ï‚ Î¿ÏÎ¯Î¶ÎµÏ„Î±Î¹',0),(548230,15229,'zh','å¯¼å…¥çš„ç®€çŸ­è¯´æ˜Žï¼Œå¦‚æžœä¸æ˜¯å½“å‰è®¾ç½®',0),(548231,15229,'sv','Importera korta beskrivningar om inte fÃ¶r nÃ¤rvarande',0),(548232,15229,'it','Brevi descrizioni di importare, se non attualmente impostato',0),(548233,15229,'tl','',0),(548234,15229,'th','à¸™à¸³à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸ªà¸±à¹‰à¸™ à¹† à¸–à¹‰à¸² à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸‚à¸“à¸°à¸™à¸µà¹‰',0),(548235,15229,'hi','à¤²à¤˜à¥ à¤µà¤°à¥à¤£à¤¨ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚ à¤¯à¤¦à¤¿ à¤¨à¤¹à¥€à¤‚ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(548236,15229,'ms','Mengimport huraian pendek jika tidak buat masa ini menetapkan',0),(548237,15229,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø£ÙˆØµØ§Ù Ù‚ØµÙŠØ±Ø© Ø¥Ø°Ø§ Ù„Ù… ÙŠÙƒÙ† Ø­Ø§Ù„ÙŠØ§ ØªØ¹ÙŠÙŠÙ†',0),(548238,15229,'fr','Importer des courtes Descriptions si il n\'est pas actuellement dÃ©finie',0),(548239,15229,'jp','ç¾åœ¨è¨­å®šã•ã‚Œã¦ã„ãªã„å ´åˆã€çŸ­ã„èª¬æ˜Žã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(548240,15229,'pt','Pequenas descriÃ§Ãµes de importaÃ§Ã£o se nÃ£o definido atualmente',0),(548241,15229,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐºÑ€Ð°Ñ‚ÐºÐ¸Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ, ÐµÑÐ»Ð¸ Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(548242,15229,'es','Breves descripciones de importaciÃ³n si no actualmente',0),(548243,15229,'de','Kurzbeschreibungen zu importieren, wenn nicht derzeit eingestellt',0),(548244,15229,'en','Import Short Descriptions If Not Currently Set',0),(548245,15230,'is','',0),(548246,15230,'dr','3dcart Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(548247,15230,'pr','3dcart Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(548248,15230,'tr','3dcart mÃ¼ÅŸteri bilgilerini otomatik olarak gÃ¼ncelleÅŸtir',0),(548249,15230,'pl','Automatyczna aktualizacja informacji klienta 3dcart',0),(548250,15230,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° 3dcart Customer Info',0),(548251,15230,'ur','3dcart Ú¯Ø§ÛÚ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(548252,15230,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ 3Ð´Ñ†Ð°Ñ€Ñ‚ ÐºÑƒÐ¿Ñ†Ð° Ð˜Ð½Ñ„Ð¾',0),(548253,15230,'vi','Tá»± Ä‘á»™ng cáº­p nháº­t thÃ´ng tin khÃ¡ch hÃ ng 3dcart',0),(548254,15230,'af','3dcart kliÃ«nt inligting outomaties opdateer',0),(548255,15230,'ro','Actualizare 3dcart client Info automat',0),(548256,15230,'et','3dcart klienditeave automaatselt uuendada',0),(548257,15230,'si','3dcart stranka Info, samodejno posodobi',0),(548258,15230,'ba','Memperbarui Info Pelanggan 3dcart secara otomatis',0),(548259,15230,'nl','3dcart klant Info automatisch bijwerken',0),(548260,15230,'fi','PÃ¤ivitÃ¤ 3dcart asiakkaan tiedot automaattisesti',0),(548261,15230,'no','Oppdatere 3dcart Kundeinfo automatisk',0),(548262,15230,'da','Opdatere 3dcart kunde Info automatisk',0),(548263,15230,'ko','3dcart ê³ ê° ì •ë³´ë¥¼ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(548264,15230,'he','×¢×“×›×•×Ÿ ×¤×¨×˜×™ ×œ×§×•×— 3dcart ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(548265,15230,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÎµÎ»Î¬Ï„Î· 3dcart',0),(548266,15230,'zh','è‡ªåŠ¨æ›´æ–° 3dcart å®¢æˆ·ä¿¡æ¯',0),(548267,15230,'sv','Uppdatera 3dcart kund information automatiskt',0),(548268,15230,'it','Aggiornamento Info cliente 3dcart automaticamente',0),(548269,15230,'tl','',0),(548270,15230,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸² 3dcart à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(548271,15230,'hi','3dcart à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(548272,15230,'ms','Kemas kini maklumat pelanggan 3dcart secara automatik',0),(548273,15230,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„ 3dcart',0),(548274,15230,'fr','Mettre Ã  jour automatiquement les informations client 3dcart',0),(548275,15230,'jp','3dcart é¡§å®¢æƒ…å ±ã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(548276,15230,'pt','Atualizar a informaÃ§Ã£o de cliente 3dcart automaticamente',0),(548277,15230,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(548278,15230,'es','Actualizar su informaciÃ³n de cliente 3dcart automÃ¡ticamente',0),(548279,15230,'de','3dcart Kundeninfo automatisch aktualisieren',0),(548280,15230,'en','Update 3dcart Customer Info Automatically',0),(548281,15231,'is','',0),(548282,15231,'dr','3dcart Ø´Ø±Ø­ Ú©ÙˆØªØ§Ù‡ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(548283,15231,'pr','3dcart Ø´Ø±Ø­ Ú©ÙˆØªØ§Ù‡ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(548284,15231,'tr','3dcart kÄ±sa tanÄ±mlarÄ± otomatik olarak gÃ¼ncelleme',0),(548285,15231,'pl','Automatyczna aktualizacja 3dcart KrÃ³tki opis',0),(548286,15231,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° 3dcart ÐºÑ€Ð°Ñ‚ÐºÐ¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(548287,15231,'ur','3dcart Ù…Ø®ØªØµØ± ØªØµØ±ÛŒØ­Ø§Øª Ú©ÛŒ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(548288,15231,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ 3Ð´Ñ†Ð°Ñ€Ñ‚ ÐºÑ€Ð°Ñ‚ÐºÐµ Ð¾Ð¿Ð¸ÑÐµ',0),(548289,15231,'vi','Tá»± Ä‘á»™ng Cáº­p Nháº­t mÃ´ táº£ ngáº¯n 3dcart',0),(548290,15231,'af','3dcart kort beskrywings outomaties opdateer',0),(548291,15231,'ro','Actualiza automat 3dcart scurte descrieri',0),(548292,15231,'et','3dcart lÃ¼hikirjeldused automaatse vÃ¤rskendamise',0),(548293,15231,'si','Samodejno posodabljanje 3dcart kratke opise',0),(548294,15231,'ba','Memperbarui Deskripsi pendek 3dcart secara otomatis',0),(548295,15231,'nl','3dcart korte beschrijvingen automatisch bijwerken',0),(548296,15231,'fi','PÃ¤ivitÃ¤ 3dcart lyhyen kuvauksen automaattisesti',0),(548297,15231,'no','Oppdatere 3dcart korte beskrivelser automatisk',0),(548298,15231,'da','Opdatere 3dcart korte beskrivelser automatisk',0),(548299,15231,'ko','3dcart ì§§ì€ ì„¤ëª…ì„ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(548300,15231,'he','×¢×“×›×Ÿ ×ª×™××•×¨×™× ×§×¦×¨×™× 3dcart ××•×˜×•×ž×˜×™×ª',0),(548301,15231,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart ÏƒÏÎ½Ï„Î¿Î¼ÎµÏ‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚',0),(548302,15231,'zh','è‡ªåŠ¨æ›´æ–° 3dcart ç®€çŸ­æè¿°',0),(548303,15231,'sv','Uppdatera 3dcart korta beskrivningar automatiskt',0),(548304,15231,'it','Aggiornare automaticamente 3dcart brevi descrizioni',0),(548305,15231,'tl','',0),(548306,15231,'th','à¸­à¸±à¸žà¹€à¸”à¸•à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹‚à¸”à¸¢à¸¢à¹ˆà¸­à¸‚à¸­à¸‡ 3dcart à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(548307,15231,'hi','3dcart à¤²à¤˜à¥ à¤µà¤¿à¤µà¤°à¤£ à¤¸à¥à¤µà¤¤: à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(548308,15231,'ms','Kemas kini 3dcart pendek huraian secara automatik',0),(548309,15231,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨ØªØ­Ø¯ÙŠØ« Ø£ÙˆØµØ§Ù Ù‚ØµÙŠØ±Ø© 3dcart',0),(548310,15231,'fr','Automatiquement Ã  jour les courtes Descriptions 3dcart',0),(548311,15231,'jp','3dcart çŸ­ã„èª¬æ˜Žã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(548312,15231,'pt','Atualizar descriÃ§Ãµes curtas 3dcart automaticamente',0),(548313,15231,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart ÐºÑ€Ð°Ñ‚ÐºÐ¸Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(548314,15231,'es','Actualizar automÃ¡ticamente las descripciones cortas 3dcart',0),(548315,15231,'de','3dcart kurze Beschreibungen automatisch aktualisieren',0),(548316,15231,'en','Update 3dcart Short Descriptions Automatically',0),(548317,15232,'is','',0),(548318,15232,'dr','Ø§Ø±Ù‚Ø§Ù… ØªÙ„ÙÙ† Ù…Ù†Ø¬Ø± Ø¨Ù‡ Ø­Ø°Ù Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ú¯Ø°Ø´Øª Ø¯Ø± Ø¢Ø¯Ø±Ø³',0),(548319,15232,'pr','Ø§Ø±Ù‚Ø§Ù… ØªÙ„ÙÙ† Ù…Ù†Ø¬Ø± Ø¨Ù‡ Ø­Ø°Ù Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ú¯Ø°Ø´Øª Ø¯Ø± Ø¢Ø¯Ø±Ø³',0),(548320,15232,'tr','Ã–nde gelen telefon basamak URL\'de geÃ§irilen KaldÄ±r',0),(548321,15232,'pl','WiodÄ…ce cyfry telefonu usunÄ…Ä‡ przekazano w URL',0),(548322,15232,'bg','Ð’Ð¾Ð´ÐµÑ‰Ð¸ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ Ñ†Ð¸Ñ„Ñ€Ð¸ Ð·Ð° Ð¿Ñ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð¿Ñ€ÐµÐ¼Ð¸Ð½Ð° Ð² URL',0),(548323,15232,'ur','Ø§ÛÙ… ÙÙˆÙ† Ø§Ø¹Ø¯Ø§Ø¯ Ú¯Ø²Ø±Û’ URL Ù…ÛŒÚº Ø¬Ø¨ ÛÙ¹Ø§Ø¦ÛŒÚº',0),(548324,15232,'sr','Ð’Ð¾Ð´ÐµÑ›Ð¸ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ Ñ†Ð¸Ñ„Ñ€Ðµ ÑÐµ ÑƒÐºÐ»Ð°ÑšÐ°Ñ˜Ñƒ ÐºÐ°Ð´Ð° Ñ˜Ðµ Ð¿Ñ€ÐµÐ¼Ð¸Ð½ÑƒÐ»Ð° Ñƒ Ð£Ð Ð› Ð°Ð´Ñ€ÐµÑÐ¸',0),(548325,15232,'vi','Chá»¯ sá»‘ Ä‘iá»‡n thoáº¡i hÃ ng Ä‘áº§u Ä‘á»ƒ loáº¡i bá» khi Ä‘Æ°á»£c thÃ´ng qua trong URL',0),(548326,15232,'af','Voorste foon syfers om te verwyder wanneer geslaag In URL',0),(548327,15232,'ro','Lider telefon cifre pentru a elimina atunci cÃ¢nd a trecut Ã®n URL-ul',0),(548328,15232,'et','Juhtiv telefoni numbrit eemaldada kui mÃ¶Ã¶dunud aastal URL',0),(548329,15232,'si','Vodilni telefon Å¡tevk odstraniti, ko je minilo v URL',0),(548330,15232,'ba','Digit telepon terkemuka mengeluarkan ketika disahkan pada URL',0),(548331,15232,'nl','Toonaangevende telefoon cijfers te verwijderen als deze worden doorgegeven In de URL',0),(548332,15232,'fi','Johtava Puhelin numeroa poistaa kun URL',0),(548333,15232,'no','Ledende telefon sifre Ã¥ fjerne nÃ¥r passert i URL',0),(548334,15232,'da','FÃ¸rende telefon cifre til fjern nÃ¥r bestÃ¥et i URL',0),(548335,15232,'ko','URLì— ì „ë‹¬ ë  ë•Œ ì œê±°ì— ìµœê³ ì˜ ì „í™” ìžë¦¬',0),(548336,15232,'he','×¡×¤×¨×•×ª ×ž×•×‘×™×œ×™× ×˜×œ×¤×•×Ÿ ×›×“×™ ×œ×”×¡×™×¨ × ×¤×˜×¨ ×‘- URL',0),(548337,15232,'el','ÎšÎ¿ÏÏ…Ï†Î±Î¯Î± Ï„Î·Î»Î­Ï†Ï‰Î½Î¿ ÏˆÎ·Ï†Î¯Î± Î½Î± Î±Ï†Î±Î¹ÏÎ­ÏƒÎµÎ¹ ÏŒÏ„Î±Î½ Ï€Î­ÏÎ±ÏƒÎµ Ï„Î¿ URL',0),(548338,15232,'zh','åˆ é™¤åœ¨ URL ä¸­ä¼ é€’æ—¶é¢†å…ˆç”µè¯æ•°å­—',0),(548339,15232,'sv','Ledande telefon siffror till ta bort nÃ¤r passerade i URL',0),(548340,15232,'it','Cifre iniziali del telefono da rimuovere quando passata nell\'URL',0),(548341,15232,'tl','',0),(548342,15232,'th','à¸™à¸³à¸•à¸±à¸§à¹€à¸¥à¸‚à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œà¹€à¸­à¸²à¸œà¹ˆà¸²à¸™à¹ƒà¸™ URL',0),(548343,15232,'hi','à¤œà¤¬ à¤¯à¥‚à¤†à¤°à¤à¤² à¤®à¥‡à¤‚ à¤ªà¤¾à¤°à¤¿à¤¤ à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤—à¥à¤°à¤£à¥€ à¤«à¥‹à¤¨ à¤…à¤‚à¤•',0),(548344,15232,'ms','Angka telefon terkemuka untuk alih keluar apabila diluluskan di URL',0),(548345,15232,'ar','Ø£Ø±Ù‚Ø§Ù… Ø§Ù„Ù‡Ø§ØªÙ Ø§Ù„Ø±Ø§Ø¦Ø¯Ø© Ù„Ø¥Ø²Ø§Ù„Ø© Ø¹Ù†Ø¯Ù…Ø§ ØªÙ… ØªÙ…Ø±ÙŠØ±Ù‡Ø§ ÙÙŠ Ø¹Ù†ÙˆØ§Ù† URL',0),(548346,15232,'fr','Des chiffres de tÃ©lÃ©phone Ã  retirer lorsqu\'il est passÃ© dans l\'URL',0),(548347,15232,'jp','å‰Šé™¤ URL ã«æ¸¡ã•ã‚Œã‚‹ã¨ãã«é›»è©±ã®æ¡',0),(548348,15232,'pt','DÃ­gitos de telefone principal para remover quando passados na URL',0),(548349,15232,'ru','ÐŸÐµÑ€Ð²Ñ‹Ðµ Ñ†Ð¸Ñ„Ñ€Ñ‹ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð° ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¸ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ðµ Ð² URL-Ð°Ð´Ñ€ÐµÑÐµ',0),(548350,15232,'es','Principales cifras de telÃ©fono para quitar cuando pasa en la URL',0),(548351,15232,'de','FÃ¼hrenden Handy-Ziffern zu entfernen, wenn In der URL Ã¼bergeben',0),(548352,15232,'en','Leading Phone Digits To Remove When Passed In URL',0),(548353,15233,'is','',0),(548354,15233,'dr','Ù…Ø´ØªØ±ÛŒ Ù¾ÛŒØ¯Ø§ Ø´Ù…Ø§Ø±Ù‡ ØªÙ„ÙÙ†',0),(548355,15233,'pr','Ù…Ø´ØªØ±ÛŒ Ù¾ÛŒØ¯Ø§ Ø´Ù…Ø§Ø±Ù‡ ØªÙ„ÙÙ†',0),(548356,15233,'tr','MÃ¼ÅŸteri telefon numarasÄ± iÃ§in bulunamadÄ±',0),(548357,15233,'pl','Nie moÅ¼na odnaleÅºÄ‡ numer telefonu klienta',0),(548358,15233,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½ Ð·Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(548359,15233,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù„ÛŒÛ’ ÙÙˆÙ† Ù†Ù…Ø¨Ø± Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(548360,15233,'sr','ÐšÐ»Ð¸Ñ˜ÐµÐ½Ñ‚ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½ Ð·Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(548361,15233,'vi','KhÃ¡ch hÃ ng khÃ´ng tÃ¬m tháº¥y cho sá»‘ Ä‘iá»‡n thoáº¡i',0),(548362,15233,'af','KliÃ«nt nie gevind vir telefoonnommer',0),(548363,15233,'ro','Clientul nu a fost gÄƒsit pentru numÄƒrul de telefon',0),(548364,15233,'et','Kliendi telefoninumber ei leitud',0),(548365,15233,'si','Kupca ni mogoÄe najti za telefonsko Å¡tevilko',0),(548366,15233,'ba','Pelanggan tidak ditemukan untuk nomor telepon',0),(548367,15233,'nl','Klant niet gevonden voor telefoonnummer',0),(548368,15233,'fi','Asiakasta ei lÃ¶ydy puhelinnumero',0),(548369,15233,'no','Kunde ikke funnet For telefonnummer',0),(548370,15233,'da','Kunde ikke fundet For telefonnummer',0),(548371,15233,'ko','ê³ ê° ì „í™” ë²ˆí˜¸ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(548372,15233,'he','×”×œ×§×•×— ×œ× × ×ž×¦× ×¢×‘×•×¨ ×ž×¡×¤×¨ ×˜×œ×¤×•×Ÿ',0),(548373,15233,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ Î³Î¹Î± Ï„Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î·Î»ÎµÏ†ÏŽÎ½Î¿Ï…',0),(548374,15233,'zh','å®¢æˆ·æ‰¾ä¸åˆ°ç”µè¯å·ç ',0),(548375,15233,'sv','Kunden inte hittas fÃ¶r telefonnummer',0),(548376,15233,'it','Cliente non trovato per il numero di telefono',0),(548377,15233,'tl','',0),(548378,15233,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œà¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(548379,15233,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¥‹à¤¨ à¤¨à¤‚à¤¬à¤° à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(548380,15233,'ms','Pelanggan yang tidak menemui bagi nombor telefon',0),(548381,15233,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø±Ù‚Ù… Ù‡Ø§ØªÙ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(548382,15233,'fr','Client introuvable pour le numÃ©ro de tÃ©lÃ©phone',0),(548383,15233,'jp','ãŠå®¢æ§˜ã®é›»è©±ç•ªå·ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã€‚',0),(548384,15233,'pt','Cliente nÃ£o encontrado para o nÃºmero de telefone',0),(548385,15233,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½ Ð´Ð»Ñ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð½Ð¾Ð³Ð¾ Ð½Ð¾Ð¼ÐµÑ€Ð°',0),(548386,15233,'es','Cliente no encontrado para el nÃºmero de telÃ©fono',0),(548387,15233,'de','Kunden, die nicht fÃ¼r Telefonnummer gefunden',0),(548388,15233,'en','Customer Not Found For Phone Number',0),(548389,15234,'is','',0),(548390,15234,'dr','5 Ø³Ø§Ù„ Ø³Ø§Ø¨Ù‚Ù‡ ÙØ±ÙˆØ´ ØµØ§Ø¯Ø±Ø§Øª',0),(548391,15234,'pr','5 Ø³Ø§Ù„ Ø³Ø§Ø¨Ù‚Ù‡ ÙØ±ÙˆØ´ ØµØ§Ø¯Ø±Ø§Øª',0),(548392,15234,'tr','5 yÄ±llÄ±k satÄ±ÅŸ geÃ§miÅŸi verme',0),(548393,15234,'pl','Eksport 5-letnia historia sprzedaÅ¼y',0),(548394,15234,'bg','5-Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð°Ñ‚Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°Ñ‚Ð° Ð·Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(548395,15234,'ur','5 Ø³Ø§Ù„ ÙØ±ÙˆØ®Øª ØªØ§Ø±ÛŒØ® Ø¨Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(548396,15234,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ 5 Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(548397,15234,'vi','Xuáº¥t 5 nÄƒm bÃ¡n hÃ ng lá»‹ch sá»­',0),(548398,15234,'af','5-jaar verkope geskiedenis uitvoer',0),(548399,15234,'ro','ExportaÅ£i istoria vanzari de 5 ani',0),(548400,15234,'et','5-aastane mÃ¼Ã¼giajaloo eksportida',0),(548401,15234,'si','Izvozne prodaje 5-letni zgodovini',0),(548402,15234,'ba','Ekspor sejarah penjualan 5 tahun',0),(548403,15234,'nl','5-jarige verkoop Geschiedenis exporteren',0),(548404,15234,'fi','ViedÃ¤ 5 vuoden myynti historia',0),(548405,15234,'no','Eksportere 5-Ã¥rs historikk',0),(548406,15234,'da','Eksportere 5-Ã¥rs salgshistorik',0),(548407,15234,'ko','5-1 ë…„ íŒë§¤ ì—­ì‚¬ë¥¼ ë‚´ë³´ë‚´ê¸°',0),(548408,15234,'he','×™×™×¦×•× ×”×™×¡×˜×•×¨×™×™×ª ×ž×›×™×¨×•×ª 5 ×©× ×™×',0),(548409,15234,'el','Î•Î¾Î±Î³Ï‰Î³Î® 5-ÎµÏ„Î® Î¹ÏƒÏ„Î¿ÏÎ¯Î± Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(548410,15234,'zh','å‡ºå£ 5 å¹´é”€å”®åŽ†å²è®°å½•',0),(548411,15234,'sv','Exportera 5 Ã¥rs fÃ¶rsÃ¤ljning historia',0),(548412,15234,'it','Esportare la cronologia delle vendite di 5 anni',0),(548413,15234,'tl','',0),(548414,15234,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸ 5 à¸›à¸µà¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸à¸²à¸£à¸‚à¸²à¸¢',0),(548415,15234,'hi','5 à¤¸à¤¾à¤² à¤¬à¤¿à¤•à¥à¤°à¥€ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(548416,15234,'ms','Sejarah 5 tahun jualan eksport',0),(548417,15234,'ar','ØªØµØ¯ÙŠØ± ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª 5 Ø³Ù†ÙˆØ§Øª',0),(548418,15234,'fr','Exporter l\'historique des ventes 5 ans',0),(548419,15234,'jp','5 å¹´é–“ã®è²©å£²å±¥æ­´ã‚’ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(548420,15234,'pt','5 anos histÃ³rico de vendas de exportaÃ§Ã£o',0),(548421,15234,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð½Ñ‹Ñ… Ð¿Ñ€Ð¾Ð´Ð°Ð¶ 5-Ð»ÐµÑ‚Ð½ÑŽÑŽ Ð¸ÑÑ‚Ð¾Ñ€Ð¸ÑŽ',0),(548422,15234,'es','5 aÃ±os ventas de exportaciÃ³n',0),(548423,15234,'de','Exportieren von 5 Jahren Vertriebshistorie',0),(548424,15234,'en','Export 5-Year Sales History',0),(548425,15235,'is','',0),(548426,15235,'dr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÛŒØ® ÙØ±ÙˆØ´ ØµØ§Ø¯Ø±Ø§Øª',0),(548427,15235,'pr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ ØªØ§Ø±ÛŒØ® ÙØ±ÙˆØ´ ØµØ§Ø¯Ø±Ø§Øª',0),(548428,15235,'tr','Ä°hracat SatÄ±ÅŸ Tarih aralÄ±ÄŸÄ±',0),(548429,15235,'pl','Zakres historii sprzedaÅ¼y eksportu',0),(548430,15235,'bg','Ð•ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(548431,15235,'ur','Ø¨Ø±Ø¢Ù…Ø¯ÛŒ ÙØ±ÙˆØ®Øª ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚',0),(548432,15235,'sr','Ð˜Ð·Ð²Ð¾Ð· Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð° Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¾Ð¿ÑÐµÐ³',0),(548433,15235,'vi','Pháº¡m vi lá»‹ch sá»­ bÃ¡n hÃ ng xuáº¥t kháº©u',0),(548434,15235,'af','Uitvoer verkope geskiedenis reeks',0),(548435,15235,'ro','Gama de istorie export vÃ¢nzÄƒri',0),(548436,15235,'et','Ekspordi mÃ¼Ã¼gi ajalugu vahemik',0),(548437,15235,'si','Izvozne prodaje zgodovini obseg',0),(548438,15235,'ba','Berbagai sejarah penjualan ekspor',0),(548439,15235,'nl','Verkoop geschiedenis Exportbereik',0),(548440,15235,'fi','Vientialue myynti historia',0),(548441,15235,'no','Eksporter salg historien omrÃ¥de',0),(548442,15235,'da','Eksport salg historie vifte',0),(548443,15235,'ko','ìˆ˜ì¶œ íŒë§¤ ì—­ì‚¬ ë²”ìœ„',0),(548444,15235,'he','×˜×•×•×— ×”×™×¡×˜×•×¨×™×™×ª ×ž×›×™×¨×•×ª ×™×™×¦×•×',0),(548445,15235,'el','Î•Î¾Î±Î³Ï‰Î³Î¹ÎºÎ­Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î¹ÏƒÏ„Î¿ÏÎ¯Î± Ï†Î¬ÏƒÎ¼Î±',0),(548446,15235,'zh','å‡ºå£é”€å”®åŽ†å²èŒƒå›´',0),(548447,15235,'sv','Export Sales historia spÃ¤nner',0),(548448,15235,'it','Intervallo di esportazione vendite storia',0),(548449,15235,'tl','',0),(548450,15235,'th','à¸ªà¹ˆà¸‡à¸­à¸­à¸à¸‚à¸²à¸¢à¸Šà¹ˆà¸§à¸‡à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸¨à¸²à¸ªà¸•à¸£à¹Œ',0),(548451,15235,'hi','à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤¶à¥à¤°à¥‡à¤£à¥€',0),(548452,15235,'ms','Pelbagai sejarah jualan eksport',0),(548453,15235,'ar','Ù†Ø·Ø§Ù‚ ØªØ§Ø±ÙŠØ® Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„ØªØµØ¯ÙŠØ±',0),(548454,15235,'fr','Ventes histoire Ã©tendue de l\'exportation',0),(548455,15235,'jp','è¼¸å‡ºè²©å£²å±¥æ­´ã®ç¯„å›²',0),(548456,15235,'pt','Intervalo de histÃ³rico de vendas de exportaÃ§Ã£o',0),(548457,15235,'ru','Ð­ÐºÑÐ¿Ð¾Ñ€Ñ‚Ð½Ñ‹Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(548458,15235,'es','Gama de historia de ventas de exportaciÃ³n',0),(548459,15235,'de','Export Sales History Bereich',0),(548460,15235,'en','Export Sales History Range',0),(548461,15236,'is','',0),(548462,15236,'dr','ÙØ±ÙˆØ´ Ø´Ø±ÙˆØ¹ Ø³Ø§ÛŒØª',0),(548463,15236,'pr','ÙØ±ÙˆØ´ Ø´Ø±ÙˆØ¹ Ø³Ø§ÛŒØª',0),(548464,15236,'tr','SatÄ±ÅŸ baÅŸlangÄ±Ã§ tarihi',0),(548465,15236,'pl','Data rozpoczÄ™cia sprzedaÅ¼y',0),(548466,15236,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(548467,15236,'ur','ÙØ±ÙˆØ®Øª Ø´Ø±ÙˆØ¹ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(548468,15236,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(548469,15236,'vi','BÃ¡n hÃ ng báº¯t Ä‘áº§u ngÃ y',0),(548470,15236,'af','Verkope Begin datum',0),(548471,15236,'ro','Data de inceput de vÃ¢nzare',0),(548472,15236,'et','MÃ¼Ã¼gi alguskuupÃ¤ev',0),(548473,15236,'si','Prodaje zaÄetni datum',0),(548474,15236,'ba','Penjualan dimulai tanggal',0),(548475,15236,'nl','Verkoop begindatum',0),(548476,15236,'fi','Myynnin aloituspÃ¤ivÃ¤',0),(548477,15236,'no','Salget begynner dato',0),(548478,15236,'da','Salg Start dato',0),(548479,15236,'ko','íŒë§¤ ì‹œìž‘ ë‚ ì§œ',0),(548480,15236,'he','×ª××¨×™×š ×‘×’×™×Ÿ ×ž×›×™×¨×•×ª',0),(548481,15236,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(548482,15236,'zh','é”€å”®å¼€å§‹æ—¥æœŸ',0),(548483,15236,'sv','FÃ¶rsÃ¤ljningen bÃ¶rjar datum',0),(548484,15236,'it','Data di inizio vendita',0),(548485,15236,'tl','',0),(548486,15236,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸‚à¸²à¸¢',0),(548487,15236,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤†à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(548488,15236,'ms','Tarikh mulakan jualan',0),(548489,15236,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(548490,15236,'fr','Date de dÃ©but de vente',0),(548491,15236,'jp','è²©å£²é–‹å§‹æ—¥',0),(548492,15236,'pt','Data de inÃ­cio das vendas',0),(548493,15236,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(548494,15236,'es','Fecha de inicio de ventas',0),(548495,15236,'de','Verkauf Anfangsdatum',0),(548496,15236,'en','Sales Begin Date',0),(548497,15237,'is','',0),(548498,15237,'dr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† ÙØ±ÙˆØ´',0),(548499,15237,'pr','ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù† ÙØ±ÙˆØ´',0),(548500,15237,'tr','SatÄ±ÅŸ bitiÅŸ tarihi',0),(548501,15237,'pl','Data zakoÅ„czenia sprzedaÅ¼y',0),(548502,15237,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(548503,15237,'ur','Ø³ÛŒÙ„Ø² Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ®',0),(548504,15237,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(548505,15237,'vi','NgÃ y káº¿t thÃºc bÃ¡n hÃ ng',0),(548506,15237,'af','Verkope Einddatum',0),(548507,15237,'ro','Data de sfÃ¢rÅŸit vÃ¢nzÄƒri',0),(548508,15237,'et','MÃ¼Ã¼gi lÃµppkuupÃ¤ev',0),(548509,15237,'si','Prodaje konÄni datum',0),(548510,15237,'ba','Tanggal akhir penjualan',0),(548511,15237,'nl','Verkoop einddatum',0),(548512,15237,'fi','Myynti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n',0),(548513,15237,'no','Salg sluttdatoen',0),(548514,15237,'da','Salg slutdato',0),(548515,15237,'ko','íŒë§¤ ì¢…ë£Œ ë‚ ì§œ',0),(548516,15237,'he','×ª××¨×™×š ×¡×™×•× ×”×ž×›×™×¨×”',0),(548517,15237,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(548518,15237,'zh','é”€å”®ç»“æŸæ—¥æœŸ',0),(548519,15237,'sv','FÃ¶rsÃ¤ljning slutdatum',0),(548520,15237,'it','Data di fine vendita',0),(548521,15237,'tl','',0),(548522,15237,'th','à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸à¸²à¸£à¸‚à¸²à¸¢',0),(548523,15237,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(548524,15237,'ms','Tarikh akhir penjualan',0),(548525,15237,'ar','ØªØ§Ø±ÙŠØ® Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(548526,15237,'fr','Date de fin de vente',0),(548527,15237,'jp','è²©å£²çµ‚äº†æ—¥',0),(548528,15237,'pt','Data de tÃ©rmino das vendas',0),(548529,15237,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(548530,15237,'es','Fecha de finalizaciÃ³n de ventas',0),(548531,15237,'de','Vertrieb-Enddatum',0),(548532,15237,'en','Sales End Date',0),(548533,15238,'is','',0),(548534,15238,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ØªÙˆØ¶ÛŒØ­Ø§Øª Ú©ÙˆØªØ§Ù‡ Ø¯Ø± 3dcart',0),(548535,15238,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ØªÙˆØ¶ÛŒØ­Ø§Øª Ú©ÙˆØªØ§Ù‡ Ø¯Ø± 3dcart',0),(548536,15238,'tr','3dcart, kÄ±sa aÃ§Ä±klamalarÄ± gÃ¼ncelleÅŸtiriliyor',0),(548537,15238,'pl','Aktualizowanie krÃ³tkie opisy na 3dcart',0),(548538,15238,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÑ€Ð°Ñ‚ÐºÐ¸ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð½Ð° 3dcart',0),(548539,15238,'ur','Ù…Ø®ØªØµØ± ØªØµØ±ÛŒØ­Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ 3dcart Ù¾Ø±',0),(548540,15238,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÐºÑ€Ð°Ñ‚ÐºÐµ Ð¾Ð¿Ð¸ÑÐµ Ñƒ 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(548541,15238,'vi','Cáº­p nháº­t cÃ¡c mÃ´ táº£ ngáº¯n táº¡i 3dcart',0),(548542,15238,'af','Outobywerking kort beskrywings by 3dcart',0),(548543,15238,'ro','Actualizarea scurte descrieri la 3dcart',0),(548544,15238,'et','Ajakohastamine lÃ¼hikirjeldused kell 3dcart',0),(548545,15238,'si','Posodabljanje kratke opise na 3dcart',0),(548546,15238,'ba','Memperbarui Deskripsi pendek di 3dcart',0),(548547,15238,'nl','Bijwerken van korte beschrijvingen op 3dcart',0),(548548,15238,'fi','PÃ¤ivittÃ¤minen lyhyet kuvaukset 3dcart',0),(548549,15238,'no','Oppdatere kort beskrivelse 3dcart',0),(548550,15238,'da','Opdatere kort beskrivelser pÃ¥ 3dcart',0),(548551,15238,'ko','3dcartì—ì„œ ì§§ì€ ì„¤ëª… ì—…ë°ì´íŠ¸',0),(548552,15238,'he','×¢×“×›×•×Ÿ ×ª×™××•×¨ ×§×¦×¨-3dcart',0),(548553,15238,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÏƒÏÎ½Ï„Î¿Î¼ÎµÏ‚ Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î­Ï‚ ÏƒÏ„Î¿ 3dcart',0),(548554,15238,'zh','æ›´æ–°åœ¨ 3dcart çš„ç®€çŸ­æè¿°',0),(548555,15238,'sv','Uppdatera korta beskrivningar pÃ¥ 3dcart',0),(548556,15238,'it','Aggiornamento dei brevi descrizioni alle 3dcart',0),(548557,15238,'tl','',0),(548558,15238,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸ªà¸±à¹‰à¸™ à¹† à¸—à¸µà¹ˆ 3dcart',0),(548559,15238,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ 3dcart à¤ªà¤° à¤²à¤˜à¥ à¤µà¤°à¥à¤£à¤¨',0),(548560,15238,'ms','Mengemas kini keterangan pendek pada 3dcart',0),(548561,15238,'ar','ØªØ­Ø¯ÙŠØ« Ø£ÙˆØµØ§Ù Ù‚ØµÙŠØ±Ø© ÙÙŠ 3dcart',0),(548562,15238,'fr','Mise Ã  jour des descriptions succinctes Ã  3dcart',0),(548563,15238,'jp','3dcart ã§çŸ­ã„èª¬æ˜Žã‚’æ›´æ–°',0),(548564,15238,'pt','Atualizando descriÃ§Ãµes curtas em 3dcart',0),(548565,15238,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐºÑ€Ð°Ñ‚ÐºÐ¸Ðµ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ Ð½Ð° 3dcart',0),(548566,15238,'es','ActualizaciÃ³n de las descripciones cortas en 3dcart',0),(548567,15238,'de','Aktualisieren von kurzen Beschreibungen auf 3dcart',0),(548568,15238,'en','Updating Short Descriptions At 3dcart',0),(548569,15239,'is','',0),(548570,15239,'dr','ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡',0),(548571,15239,'pr','ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ ØªÙ…Ø§Ù… Ø´Ø¯Ù‡',0),(548572,15239,'tr','Ã–zellikleri sÃ¼resi',0),(548573,15239,'pl','Funkcje skoÅ„czony',0),(548574,15239,'bg','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ñ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ» ÑÑ€Ð¾Ðº',0),(548575,15239,'ur','Ø®ØµÙˆØµÛŒØ§Øª Ú©ÛŒ Ù…Ø¯Øª Ø®ØªÙ… ÛÙˆ Ú¯Ø¦ÛŒ ÛÛ’',0),(548576,15239,'sr','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°Ð¼Ð° Ð¸ÑÑ‚ÐµÐºÐ»Ð°',0),(548577,15239,'vi','TÃ­nh nÄƒng háº¿t háº¡n',0),(548578,15239,'af','Kenmerke verval',0),(548579,15239,'ro','Caracteristici expirat',0),(548580,15239,'et','Aegunud funktsioonide',0),(548581,15239,'si','ZnaÄilnosti potekel',0),(548582,15239,'ba','Fitur kadaluarsa',0),(548583,15239,'nl','Functies verlopen',0),(548584,15239,'fi','On vanhentunut',0),(548585,15239,'no','Har utlÃ¸pt',0),(548586,15239,'da','Funktioner er udlÃ¸bet',0),(548587,15239,'ko','ê¸°ëŠ¥ ë§Œë£Œ',0),(548588,15239,'he','×ª×›×•× ×•×ª ×¤×’',0),(548589,15239,'el','Î§Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬ Î»Î®Î¾ÎµÎ¹',0),(548590,15239,'zh','åŠŸèƒ½å·²è¿‡æœŸ',0),(548591,15239,'sv','Har upphÃ¶rt att gÃ¤lla',0),(548592,15239,'it','Caratteristiche scaduto',0),(548593,15239,'tl','',0),(548594,15239,'th','à¸¥à¸±à¸à¸©à¸“à¸°à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(548595,15239,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾à¤“à¤‚ à¤•à¥€ à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤',0),(548596,15239,'ms','Ciri-ciri yang telah tamat tempoh',0),(548597,15239,'ar','Ø§Ù†ØªÙ‡Øª Ù…Ø¯Ø© ØµÙ„Ø§Ø­ÙŠØ© Ø§Ù„Ù…ÙŠØ²Ø§Øª',0),(548598,15239,'fr','CaractÃ©ristiques a expirÃ©',0),(548599,15239,'jp','æ©Ÿèƒ½ã®æœ‰åŠ¹æœŸé™ãŒåˆ‡ã‚Œã¦ãã ã•ã„ã€‚',0),(548600,15239,'pt','CaracterÃ­sticas expirou',0),(548601,15239,'ru','ÐžÑÐ¾Ð±ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ Ð¸ÑÑ‚ÐµÐº',0),(548602,15239,'es','CaracterÃ­sticas caducado',0),(548603,15239,'de','Funktionen abgelaufen',0),(548604,15239,'en','Features Expired',0),(548605,15240,'is','',0),(548606,15240,'dr','ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ø¨Ù‡ Ø²ÙˆØ¯ÛŒ Ù…Ù†Ù‚Ø¶ÛŒ Ù…ÛŒ Ø´ÙˆØ¯',0),(548607,15240,'pr','ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ø¨Ù‡ Ø²ÙˆØ¯ÛŒ Ù…Ù†Ù‚Ø¶ÛŒ Ù…ÛŒ Ø´ÙˆØ¯',0),(548608,15240,'tr','Ã–zellikleri yakÄ±nda sona erecek',0),(548609,15240,'pl','Funkcje niedÅ‚ugo wygaÅ›nie',0),(548610,15240,'bg','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ð¸ Ñ‰Ðµ ÑÐºÐ¾Ñ€Ð¾ Ð¸Ð·Ð´Ð¸ÑˆÐ²Ð°Ð¼',0),(548611,15240,'ur','Ø®ØµÙˆØµÛŒØ§Øª Ú©Ùˆ Ø¬Ù„Ø¯ ÛÛŒ Ø®ØªÙ… ÛÙˆ Ø¬Ø§Ø¦Û’ Ú¯ÛŒ',0),(548612,15240,'sr','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ðµ Ñ›Ðµ ÑƒÑÐºÐ¾Ñ€Ð¾ Ð¸ÑÑ‚ÐµÑ›Ð¸.',0),(548613,15240,'vi','TÃ­nh nÄƒng sáº½ sá»›m háº¿t háº¡n',0),(548614,15240,'af','Kenmerke sal binnekort verval',0),(548615,15240,'ro','Caracteristici va expira Ã®n curÃ¢nd',0),(548616,15240,'et','Funktsioonid aegub varsti',0),(548617,15240,'si','Funkcije bo kmalu potekla',0),(548618,15240,'ba','Fitur akan segera berakhir',0),(548619,15240,'nl','Functies zal spoedig verloopt',0),(548620,15240,'fi','Ominaisuudet umpeutuu',0),(548621,15240,'no','Funksjoner utlÃ¸per snart',0),(548622,15240,'da','Funktioner udlÃ¸ber snart',0),(548623,15240,'ko','ê¸°ëŠ¥ ê³§ ë§Œë£Œ ë©ë‹ˆë‹¤.',0),(548624,15240,'he','×ª×›×•× ×•×ª ×™×¤×•×’ ×‘×§×¨×•×‘',0),(548625,15240,'el','Î§Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬ Î¸Î± Î»Î®Î¾ÎµÎ¹ ÏƒÏÎ½Ï„Î¿Î¼Î±',0),(548626,15240,'zh','åŠŸèƒ½å°†å¾ˆå¿«è¿‡æœŸ',0),(548627,15240,'sv','Funktioner upphÃ¶r snart',0),(548628,15240,'it','Caratteristiche scadrÃ  presto',0),(548629,15240,'tl','',0),(548630,15240,'th','à¸¥à¸±à¸à¸©à¸“à¸°à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™à¸ˆà¸°à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¹€à¸£à¹‡à¸§ à¹† à¸™à¸µà¹‰',0),(548631,15240,'hi','à¤µà¤¿à¤¶à¥‡à¤·à¤¤à¤¾à¤à¤‚ à¤œà¤²à¥à¤¦ à¤¹à¥€ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹ à¤œà¤¾à¤à¤—à¥€',0),(548632,15240,'ms','Ciri-ciri akan tamat tidak lama lagi',0),(548633,15240,'ar','Ù…ÙŠØ²Ø§Øª Ø³ØªÙ†ØªÙ‡ÙŠ Ù‚Ø±ÙŠØ¨Ø§',0),(548634,15240,'fr','CaractÃ©ristiques vont bientÃ´t expirer',0),(548635,15240,'jp','æ©Ÿèƒ½ãŒã™ãã«åˆ‡ã‚Œã‚‹',0),(548636,15240,'pt','CaracterÃ­sticas irÃ£o expirar em breve',0),(548637,15240,'ru','ÐžÑÐ¾Ð±ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ ÑÐºÐ¾Ñ€Ð¾ Ð¸ÑÑ‚ÐµÑ‡ÐµÑ‚',0),(548638,15240,'es','CaracterÃ­sticas caducarÃ¡ pronto',0),(548639,15240,'de','Funktionen lÃ¤uft bald ab',0),(548640,15240,'en','Features Will Soon Expire',0),(548641,15241,'is','',0),(548642,15241,'dr','ØªÙˆØ¬Ù‡',0),(548643,15241,'pr','ØªÙˆØ¬Ù‡',0),(548644,15241,'tr','UyarÄ±',0),(548645,15241,'pl','OgÅ‚oszenie',0),(548646,15241,'bg','Ð‘ÐµÐ»ÐµÐ¶ÐºÐ°',0),(548647,15241,'ur','Ù†ÙˆÙ¹Ø³',0),(548648,15241,'sr','ÐÐ°Ñ˜Ð°Ð²Ðµ',0),(548649,15241,'vi','ThÃ´ng bÃ¡o',0),(548650,15241,'af','Kennisgewing',0),(548651,15241,'ro','Notificare',0),(548652,15241,'et','Teade',0),(548653,15241,'si','Obvestilo',0),(548654,15241,'ba','Pemberitahuan',0),(548655,15241,'nl','Aankondiging',0),(548656,15241,'fi','Ilmoitus',0),(548657,15241,'no','Varsel',0),(548658,15241,'da','Varsel',0),(548659,15241,'ko','ì£¼ì˜ ì‚¬í•­',0),(548660,15241,'he','×©×™× ×œ×‘',0),(548661,15241,'el','Î‘Î½Î±ÎºÎ¿Î¯Î½Ï‰ÏƒÎ·',0),(548662,15241,'zh','é€šçŸ¥',0),(548663,15241,'sv','Varsel',0),(548664,15241,'it','Avviso',0),(548665,15241,'tl','',0),(548666,15241,'th','à¹à¸ˆà¹‰à¸‡à¹ƒà¸«à¹‰à¸—à¸£à¸²à¸š',0),(548667,15241,'hi','à¤¨à¥‹à¤Ÿà¤¿à¤¸',0),(548668,15241,'ms','Notis',0),(548669,15241,'ar','Ø¥Ø´Ø¹Ø§Ø±',0),(548670,15241,'fr','Avis',0),(548671,15241,'jp','ãŠçŸ¥ã‚‰ã›',0),(548672,15241,'pt','Aviso prÃ©vio',0),(548673,15241,'ru','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(548674,15241,'es','Aviso',0),(548675,15241,'de','Und Datenschutz',0),(548676,15241,'en','Notice',0),(548677,15242,'is','',0),(548678,15242,'dr','Ø¢ÛŒÚ©ÙˆÙ†',0),(548679,15242,'pr','Ø¢ÛŒÚ©ÙˆÙ†',0),(548680,15242,'tr','Simge',0),(548681,15242,'pl','Ikona',0),(548682,15242,'bg','Ð˜ÐºÐ¾Ð½Ð°',0),(548683,15242,'ur','Ø´Ø¨ÛŒÛ',0),(548684,15242,'sr','Ð˜ÐºÐ¾Ð½Ð°',0),(548685,15242,'vi','Biá»ƒu tÆ°á»£ng',0),(548686,15242,'af','Ikoon',0),(548687,15242,'ro','Pictograma',0),(548688,15242,'et','Ikoon',0),(548689,15242,'si','Ikona',0),(548690,15242,'ba','Ikon',0),(548691,15242,'nl','Pictogram',0),(548692,15242,'fi','Kuvake',0),(548693,15242,'no','Ikonet',0),(548694,15242,'da','Ikon',0),(548695,15242,'ko','ì•„ì´ì½˜',0),(548696,15242,'he','×¡×ž×œ',0),(548697,15242,'el','Î•Î¹ÎºÎ¿Î½Î¯Î´Î¹Î¿',0),(548698,15242,'zh','å›¾æ ‡',0),(548699,15242,'sv','Ikonen',0),(548700,15242,'it','Icona',0),(548701,15242,'tl','',0),(548702,15242,'th','à¹„à¸­à¸„à¸­à¸™',0),(548703,15242,'hi','à¤†à¤‡à¤•à¤¨',0),(548704,15242,'ms','Ikon',0),(548705,15242,'ar','Ø±Ù…Ø²',0),(548706,15242,'fr','IcÃ´ne',0),(548707,15242,'jp','ã‚¢ã‚¤ã‚³ãƒ³',0),(548708,15242,'pt','Ãcone de',0),(548709,15242,'ru','Ð—Ð½Ð°Ñ‡Ð¾Ðº',0),(548710,15242,'es','Icono',0),(548711,15242,'de','Symbol',0),(548712,15242,'en','Icon',0),(548713,15243,'is','',0),(548714,15243,'dr','Ú¯Ø±ÙˆÙ‡ Ú¯Ø²Ø§Ø±Ø´',0),(548715,15243,'pr','Ú¯Ø±ÙˆÙ‡ Ú¯Ø²Ø§Ø±Ø´',0),(548716,15243,'tr','Rapor grup',0),(548717,15243,'pl','Raport grupy',0),(548718,15243,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´Ð²Ð°Ð¹Ñ‚Ðµ Ð³Ñ€ÑƒÐ¿Ð°',0),(548719,15243,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú¯Ø±ÙˆÙ¾',0),(548720,15243,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð³Ñ€ÑƒÐ¿Ðµ',0),(548721,15243,'vi','BÃ¡o cÃ¡o nhÃ³m',0),(548722,15243,'af','Verslag groep',0),(548723,15243,'ro','Raportul grupului',0),(548724,15243,'et','Aruandes rÃ¼hma',0),(548725,15243,'si','PoroÄilo skupine',0),(548726,15243,'ba','Laporan grup',0),(548727,15243,'nl','Verslag groep',0),(548728,15243,'fi','RaporttiryhmÃ¤n',0),(548729,15243,'no','Rapportgruppe',0),(548730,15243,'da','Rapportgruppe',0),(548731,15243,'ko','ë³´ê³ ì„œ ê·¸ë£¹',0),(548732,15243,'he','×“×• ×— ×§×‘×•×¦×”',0),(548733,15243,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ Î±Ï€ÏÎµÏ€Î¿ÏÏ‚ Î¿Î¼Î¬Î´Î±Ï‚',0),(548734,15243,'zh','æŠ¥å‘Šç»„',0),(548735,15243,'sv','Rapportgrupp',0),(548736,15243,'it','Bilancio di gruppo',0),(548737,15243,'tl','',0),(548738,15243,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™ à¸à¸¥à¸¸à¹ˆà¸¡',0),(548739,15243,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤¸à¤®à¥‚à¤¹',0),(548740,15243,'ms','Laporan Kumpulan',0),(548741,15243,'ar','ØªÙ‚Ø±ÙŠØ± Ø§Ù„ÙØ±ÙŠÙ‚',0),(548742,15243,'fr','Rapport groupe',0),(548743,15243,'jp','ãƒ¬ãƒãƒ¼ãƒˆ ã‚°ãƒ«ãƒ¼ãƒ—',0),(548744,15243,'pt','RelatÃ³rio de grupo',0),(548745,15243,'ru','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð³Ñ€ÑƒÐ¿Ð¿Ñ‹',0),(548746,15243,'es','Informe del grupo de',0),(548747,15243,'de','Berichtsgruppe',0),(548748,15243,'en','Report Group',0),(548749,15244,'is','',0),(548750,15244,'dr','Ø´Ø±Ú©Øª Ù‡Ø§ÛŒ',0),(548751,15244,'pr','Ø´Ø±Ú©Øª Ù‡Ø§ÛŒ',0),(548752,15244,'tr','Åžirketler',0),(548753,15244,'pl','Firm',0),(548754,15244,'bg','Ð¤Ð¸Ñ€Ð¼Ð¸',0),(548755,15244,'ur','Ú©Ù…Ù¾Ù†ÛŒÙˆÚº',0),(548756,15244,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(548757,15244,'vi','CÃ´ng ty',0),(548758,15244,'af','Maatskappye',0),(548759,15244,'ro','Companii',0),(548760,15244,'et','EttevÃµtted',0),(548761,15244,'si','Podjetja',0),(548762,15244,'ba','Perusahaan',0),(548763,15244,'nl','Bedrijven',0),(548764,15244,'fi','Yritykset',0),(548765,15244,'no','Selskaper',0),(548766,15244,'da','Virksomheder',0),(548767,15244,'ko','íšŒì‚¬',0),(548768,15244,'he','×—×‘×¨×•×ª',0),(548769,15244,'el','Î•Ï„Î±Î¹ÏÎµÎ¯ÎµÏ‚',0),(548770,15244,'zh','å…¬å¸',0),(548771,15244,'sv','FÃ¶retag',0),(548772,15244,'it','Aziende',0),(548773,15244,'tl','',0),(548774,15244,'th','à¸šà¸£à¸´à¸©à¸±à¸—',0),(548775,15244,'hi','à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¤¾à¤‚',0),(548776,15244,'ms','Syarikat-Syarikat',0),(548777,15244,'ar','Ø§Ù„Ø´Ø±ÙƒØ§Øª',0),(548778,15244,'fr','Entreprises',0),(548779,15244,'jp','ä¼æ¥­',0),(548780,15244,'pt','Empresas',0),(548781,15244,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(548782,15244,'es','Empresas',0),(548783,15244,'de','Unternehmen',0),(548784,15244,'en','Companies',0),(548785,15245,'is','',0),(548786,15245,'dr','Ù…Ø¬ÙˆØ²',0),(548787,15245,'pr','Ù…Ø¬ÙˆØ²',0),(548788,15245,'tr','Lisans',0),(548789,15245,'pl','Licencja',0),(548790,15245,'bg','Ð›Ð¸Ñ†ÐµÐ½Ð·',0),(548791,15245,'ur','Ù„Ø§Ø¦Ø³Ù†Ø³',0),(548792,15245,'sr','Ð›Ð¸Ñ†ÐµÐ½Ñ†Ðµ',0),(548793,15245,'vi','Giáº¥y phÃ©p',0),(548794,15245,'af','Lisensie',0),(548795,15245,'ro','A da un permis',0),(548796,15245,'et','Litsents',0),(548797,15245,'si','Dati dovoljenje',0),(548798,15245,'ba','Lisensi',0),(548799,15245,'nl','Licentie',0),(548800,15245,'fi','Lisenssi',0),(548801,15245,'no','Lisens',0),(548802,15245,'da','Licens',0),(548803,15245,'ko','ë¼ì´ì„¼ìŠ¤',0),(548804,15245,'he','×¨×©×™×•×Ÿ',0),(548805,15245,'el','Î†Î´ÎµÎ¹Î±',0),(548806,15245,'zh','è®¸å¯è¯',0),(548807,15245,'sv','Licens',0),(548808,15245,'it','Licenza',0),(548809,15245,'tl','',0),(548810,15245,'th','à¸ªà¸´à¸—à¸˜à¸´à¹Œà¸à¸²à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(548811,15245,'hi','à¤²à¤¾à¤‡à¤¸à¥‡à¤‚à¤¸',0),(548812,15245,'ms','Lesen',0),(548813,15245,'ar','Ø§Ù„ØªØ±Ø®ÙŠØµ',0),(548814,15245,'fr','Licence',0),(548815,15245,'jp','ãƒ©ã‚¤ã‚»ãƒ³ã‚¹',0),(548816,15245,'pt','LicenÃ§a',0),(548817,15245,'ru','Ð›Ð¸Ñ†ÐµÐ½Ð·Ð¸Ñ',0),(548818,15245,'es','Licencia de',0),(548819,15245,'de','Lizenz',0),(548820,15245,'en','License',0),(548821,15246,'is','',0),(548822,15246,'dr','Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ØªÙ†Ù‡Ø§ Ø¨Ù‡ ÛŒÚ© Ú©Ø§Ø±Ø¨Ø± ØªØ­Øª Ø§ÛŒÙ† Ú©Ø§Ø± Ø§Ú¯Ø± Ú†Ú© Ù…ÛŒ ØªÙˆØ§Ù† Ø´Ø¯Ù‡',0),(548823,15246,'pr','Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ØªÙ†Ù‡Ø§ Ø¨Ù‡ ÛŒÚ© Ú©Ø§Ø±Ø¨Ø± ØªØ­Øª Ø§ÛŒÙ† Ú©Ø§Ø± Ø§Ú¯Ø± Ú†Ú© Ù…ÛŒ ØªÙˆØ§Ù† Ø´Ø¯Ù‡',0),(548824,15246,'tr','Bir mÃ¼ÅŸteri veya satÄ±cÄ± sadece bir kullanÄ±cÄ± bu gÃ¶revi altÄ±nda iÅŸaretliyse atanabilir',0),(548825,15246,'pl','Odbiorcy lub dostawcy mogÄ… byÄ‡ tylko przypisywane do jednego uÅ¼ytkownika w ten zadanie JeÅ›li zaznaczone',0),(548826,15246,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½ ÑÐ°Ð¼Ð¾ Ð½Ð° ÐµÐ´Ð¸Ð½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð¿Ð¾Ð´ Ñ‚Ð°Ð·Ð¸ Ð·Ð°Ð´Ð°Ñ‡Ð° Ð°ÐºÐ¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¸',0),(548827,15246,'ur','Ø§ÛŒÚ© Ú¯Ø§ÛÚ© ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û ØµØ±Ù Ø§Ø³ Ú©Ø§Ù… Ú©Û’ ØªØ­Øª Ø§ÛŒÚ© ØµØ§Ø±Ù Ú©Û’ Ù„ÛŒÛ’ Ù¾Ú‘ØªØ§Ù„ Ù†ÛÛŒÚº Ú©ÛŒ Ø§Ú¯Ø± ØªÙÙˆÛŒØ¶ Ú©ÛŒØ§ Ø¬Ø§Ø³Ú©Û’',0),(548828,15246,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð´Ð¾Ð´ÐµÑ™ÐµÐ½Ð° ÑÐ°Ð¼Ð¾ Ñ˜ÐµÐ´Ð°Ð½ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ñƒ Ð¾ÐºÐ²Ð¸Ñ€Ñƒ Ð¾Ð²Ð¾Ð³ Ð·Ð°Ð´Ð°Ñ‚ÐºÐ° Ð°ÐºÐ¾ Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾',0),(548829,15246,'vi','Má»™t khÃ¡ch hÃ ng hoáº·c nhÃ  cung cáº¥p cÃ³ thá»ƒ chá»‰ Ä‘Æ°á»£c gÃ¡n cho má»™t ngÆ°á»i dÃ¹ng theo nhiá»‡m vá»¥ nÃ y náº¿u kiá»ƒm tra',0),(548830,15246,'af','\'N kliÃ«nt of handelaar kan slegs toegeken word aan een gebruiker onder hierdie taak as gekontroleer',0),(548831,15246,'ro','Un client sau un furnizor poate doar fi atribuit un utilizator sub aceastÄƒ activitate dacÄƒ verificat',0),(548832,15246,'et','Kliendi vÃµi hankija saab mÃ¤Ã¤rata ainult Ã¼hele kasutajale all selle Ã¼lesande sisselÃ¼litamisel',0),(548833,15246,'si','Kupca ali dobavitelja lahko dodelijo samo za enega uporabnika pod to opravilo Äe preveriti',0),(548834,15246,'ba','Pelanggan, atau Vendor hanya dapat ditetapkan untuk satu pengguna di bawah tugas ini jika dicentang',0),(548835,15246,'nl','Een klant of leverancier kan alleen worden toegewezen aan Ã©Ã©n gebruiker onder deze taak als gecontroleerd',0),(548836,15246,'fi','Asiakkaan tai toimittajan voidaan liittÃ¤Ã¤ vain yhdelle kÃ¤yttÃ¤jÃ¤lle tÃ¤mÃ¤n tehtÃ¤vÃ¤n jos valittu',0),(548837,15246,'no','En kunde eller leverandÃ¸r kan bare tilordnes Ã©n bruker Under denne oppgaven hvis merket',0),(548838,15246,'da','En debitor eller kreditor kan kun tildeles Ã©n bruger Under denne opgave hvis tjekket',0),(548839,15246,'ko','ê³ ê° ë˜ëŠ” ê³µê¸‰ ì—…ì²´ë§Œ í• ë‹¹ ë  ìˆ˜ ìžˆìŠµë‹ˆë‹¤ì´ ìž‘ì—… í•œ ì‚¬ìš©ìž í™•ì¸ í•˜ëŠ” ê²½ìš°',0),(548840,15246,'he','×”×•× ×œ×§×•×— ××• ×¡×¤×§ ×‘×œ×‘×“ × ×™×ª×Ÿ ×œ×”×§×¦×•×ª ×ž×©×ª×ž×© ××—×“ ×ª×—×ª ×¤×¢×™×œ×•×ª ×–×• ×× ×‘×“×§×ª',0),(548841,15246,'el','ÎˆÎ½Î±Î½ Ï€ÎµÎ»Î¬Ï„Î· Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î¼Ï€Î¿ÏÎµÎ¯ Î¼ÏŒÎ½Î¿ Î½Î± Î±Î½Î±Ï„ÎµÎ¸ÎµÎ¯ ÏƒÎµ Î­Î½Î± Ï‡ÏÎ®ÏƒÏ„Î· Ï…Ï€ÏŒ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÎ¬Î½ ÎµÎ»Î­Î³Ï‡ÎµÏ„Î±Î¹',0),(548842,15246,'zh','å®¢æˆ·æˆ–ä¾›åº”å•†åªèƒ½åˆ†é…ç»™ä¸€ä¸ªç”¨æˆ·ä¸‹æ­¤ä»»åŠ¡å¦‚æžœé€‰ä¸­',0),(548843,15246,'sv','En kund eller leverantÃ¶r kan endast tilldelas till en anvÃ¤ndare Under denna uppgift om markerad',0),(548844,15246,'it','Un cliente o fornitore puÃ² solo essere assegnato ad un utente nell\'ambito di questa attivitÃ  se controllato',0),(548845,15246,'tl','',0),(548846,15246,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸«à¸£à¸·à¸­à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸ªà¸²à¸¡à¸²à¸£à¸–à¹ƒà¸«à¹‰à¸à¸±à¸šà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸«à¸™à¸¶à¹ˆà¸‡à¸ à¸²à¸¢à¹ƒà¸•à¹‰à¸‡à¸²à¸™à¸™à¸µà¹‰à¸–à¹‰à¸²à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(548847,15246,'hi','à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡à¤µà¤² à¤‡à¤¸ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥‡ à¤¤à¤¹à¤¤ à¤à¤• à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¯à¤¦à¤¿ à¤šà¥‡à¤• à¤¸à¥Œà¤‚à¤ªà¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(548848,15246,'ms','Pelanggan atau penjual boleh hanya diperuntukkan kepada seorang pengguna di bawah tugas ini jika disemak',0),(548849,15246,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ Ø§Ù„Ù…ÙˆØ±Ø¯ ÙŠÙ…ÙƒÙ† ÙÙ‚Ø· ØªØ¹ÙŠÙŠÙ† Ø¥Ù„Ù‰ Ù…Ø³ØªØ®Ø¯Ù… ÙˆØ§Ø­Ø¯ ØªØ­Øª Ù‡Ø°Ù‡ Ø§Ù„Ù…Ù‡Ù…Ø© Ø¥Ø°Ø§ Ø±Ø§Ø¬Ø¹Øª',0),(548850,15246,'fr','Un client ou le fournisseur ne peut Ãªtre attribuÃ© Ã  un utilisateur dans le cadre de cette tÃ¢che s\'il est activÃ©',0),(548851,15246,'jp','é¡§å®¢ã¾ãŸã¯ä»•å…¥å…ˆãŒã®ã¿å ´åˆã«å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã‚‹ã“ã®ã‚¿ã‚¹ã‚¯ã®ä¸‹ã® 1 ã¤ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’ãƒã‚§ãƒƒã‚¯',0),(548852,15246,'pt','Um fornecedor ou cliente sÃ³ pode ser atribuÃ­do a um usuÃ¡rio sob esta tarefa se verificado',0),(548853,15246,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð¼Ð¾Ð³ÑƒÑ‚ Ð½Ð°Ð·Ð½Ð°Ñ‡Ð°Ñ‚ÑŒÑÑ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð´Ð»Ñ Ð¾Ð´Ð½Ð¾Ð³Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ Ð¿Ð¾Ð´ ÑÑ‚Ð¾Ð¹ Ð·Ð°Ð´Ð°Ñ‡Ð¸ ÐµÑÐ»Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(548854,15246,'es','Un cliente o un proveedor sÃ³lo se pueden asignar a un usuario en esta tarea si',0),(548855,15246,'de','Ein Debitor oder Kreditor kann nur unter diese Aufgabe einem Benutzer zugewiesen werden angekreuzt',0),(548856,15246,'en','A Customer Or Vendor Can Only Be Assigned To One User Under This Task If Checked',0),(548857,15247,'is','',0),(548858,15247,'dr','Ù…Ø´ØªØ±ÛŒØ§Ù† ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø¯Ø± Ø¬Ø³ØªØ¬ÙˆÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø²ÛŒØ± Ø§Ø®ØªØµØ§Øµ Ø®ÙˆØ§Ù‡Ø¯ ÛŒØ§ÙØª',0),(548859,15247,'pr','Ù…Ø´ØªØ±ÛŒØ§Ù† ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø¯Ø± Ø¬Ø³ØªØ¬ÙˆÛŒ Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø²ÛŒØ± Ø§Ø®ØªØµØ§Øµ Ø®ÙˆØ§Ù‡Ø¯ ÛŒØ§ÙØª',0),(548860,15247,'tr','MÃ¼ÅŸterilere veya satÄ±cÄ±lara otomatik olarak arama filtreleri temel alarak kullanÄ±cÄ±lara atanÄ±r',0),(548861,15247,'pl','KlientÃ³w lub dostawcÃ³w zostanie automatycznie przypisany do uÅ¼ytkownikÃ³w oparte na filtrach wyszukiwania poniÅ¼ej',0),(548862,15247,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð¸Ð»Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸ Ñ‰Ðµ Ð±ÑŠÐ´Ð°Ñ‚ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¿Ñ€Ð¸ÑÐ²Ð¾ÑÐ²Ð°Ð½Ð¸ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸Ñ‚Ðµ Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð° Ñ„Ð¸Ð»Ñ‚Ñ€Ð¸ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ',0),(548863,15247,'ur','Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº ÛŒØ§ ØµØ§Ø±ÙÛŒÙ† Ú©Ùˆ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªÙ„Ø§Ø´ ÙÙ„Ù¹Ø± Ù†ÛŒÚ†Û’ Ù¾Ø± Ù…Ø¨Ù†ÛŒ ØµØ§Ø±ÙÛŒÙ† Ú©Ùˆ ØªÙÙˆÛŒØ¶ Ú©ÛŒØ§ Ø¬Ø§Ø¦Û’ Ú¯Ø§',0),(548864,15247,'sr','ÐšÑƒÐ¿Ñ†Ðµ Ð¸Ð»Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ Ñ›Ðµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð±Ð¸Ñ‚Ð¸ Ð´Ð¾Ð´ÐµÑ™ÐµÐ½Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸Ð¼Ð° Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ Ñ„Ð¸Ð»Ñ‚ÐµÑ€Ðµ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð³Ñƒ Ð¸ÑÐ¿Ð¾Ð´',0),(548865,15247,'vi','KhÃ¡ch hÃ ng hoáº·c nhÃ  cung cáº¥p sáº½ Ä‘Æ°á»£c tá»± Ä‘á»™ng gÃ¡n cho ngÆ°á»i dÃ¹ng dá»±a trÃªn cÃ¡c bá»™ lá»c tÃ¬m kiáº¿m dÆ°á»›i Ä‘Ã¢y',0),(548866,15247,'af','KliÃ«nte of verskaffers sal word outomaties toegeken aan gebruikers gebaseer op die soek Filters hieronder',0),(548867,15247,'ro','ClienÅ£ii sau furnizorii vor fi atribuite automat la utilizatori pe baza filtre de cautare de mai jos',0),(548868,15247,'et','Klientide vÃµi hankijate nÃ¤idatakse automaatselt mÃ¤Ã¤rata kasutajatele pÃµhinevad otsingufiltreid allpool',0),(548869,15247,'si','Kupci ali prodajalci samodejno dodeli uporabnikom na osnovi iskalnih filtrov pod',0),(548870,15247,'ba','Pelanggan atau vendor akan secara otomatis ditetapkan ke pengguna berdasarkan filter pencarian di bawah ini',0),(548871,15247,'nl','Klanten of leveranciers zal automatisch worden toegewezen aan gebruikers op basis van de zoekfilters hieronder',0),(548872,15247,'fi','Asiakkaille tai toimittajille mÃ¤Ã¤ritetÃ¤Ã¤n automaattisesti kÃ¤yttÃ¤jille hakusuodattimet',0),(548873,15247,'no','Kunder eller leverandÃ¸rer skal tilordnes automatisk til brukere basert pÃ¥ sÃ¸kefiltre nedenfor',0),(548874,15247,'da','Kunder eller leverandÃ¸rer vil automatisk tildelt til brugere baseret pÃ¥ sÃ¸gefiltre nedenfor',0),(548875,15247,'ko','ê³ ê° ë˜ëŠ” ê³µê¸‰ ì—…ì²´ ìžë™ìœ¼ë¡œ ì•„ëž˜ ê²€ìƒ‰ í•„í„°ì— ë”°ë¼ ì‚¬ìš©ìžì— ê²Œ í• ë‹¹ ë  ê²ƒìž…ë‹ˆë‹¤.',0),(548876,15247,'he','×œ×§×•×—×•×ª ××• ×¡×¤×§×™× ××•×˜×•×ž×˜×™×ª ×©×™×•×§×¦×” ×œ×ž×©×ª×ž×©×™× ×”×ž×‘×•×¡×¡ ×¢×œ ×ž×¡× × ×™ ×—×™×¤×•×© ×ž×ª×—×ª',0),(548877,15247,'el','Î ÎµÎ»Î¬Ï„ÎµÏ‚ Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ Î¸Î± Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¹ÏƒÏ„Î¿ÏÎ½ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î± ÏƒÏ„Î¿Ï…Ï‚ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î± Ï†Î¯Î»Ï„ÏÎ± Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚ ÎºÎ¬Ï„Ï‰ Î±Ï€ÏŒ',0),(548878,15247,'zh','å®¢æˆ·æˆ–ä¾›åº”å•†å°†è‡ªåŠ¨æŒ‡æ´¾ç»™ç”¨æˆ·åŸºäºŽä¸‹é¢çš„æœç´¢ç­›é€‰å™¨',0),(548879,15247,'sv','Kunder eller leverantÃ¶rer kommer att automatiskt tilldelas till anvÃ¤ndare baserat pÃ¥ sÃ¶kfilter under',0),(548880,15247,'it','Clienti o fornitori verranno assegnati automaticamente agli utenti in base ai filtri di ricerca qui sotto',0),(548881,15247,'tl','',0),(548882,15247,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸«à¸£à¸·à¸­à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸ˆà¸°à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¸à¸±à¸šà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹‚à¸”à¸¢à¹ƒà¸Šà¹‰à¸•à¸±à¸§à¸à¸£à¸­à¸‡à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²à¸—à¸µà¹ˆà¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡',0),(548883,15247,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤¸à¥à¤µà¤¤: à¤¨à¥€à¤šà¥‡ à¤–à¥‹à¤œ à¤«à¤¼à¤¿à¤²à¥à¤Ÿà¤° à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤° à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾',0),(548884,15247,'ms','Pelanggan atau Penjual akan secara automatik ditugaskan untuk pengguna berdasarkan penapis carian di bawah',0),(548885,15247,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø£Ùˆ Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ† Ø³ÙŠØªÙ… ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ ØªØ¹ÙŠÙŠÙ† Ø¥Ù„Ù‰ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ø³ØªÙ†Ø§Ø¯Ø§Ù‹ Ø¥Ù„Ù‰ Ø¹ÙˆØ§Ù…Ù„ Ø§Ù„ØªØµÙÙŠØ© Ø§Ù„Ø¨Ø­Ø« Ø£Ø¯Ù†Ø§Ù‡',0),(548886,15247,'fr','Clients ou fournisseurs seront automatiquement assignÃ©s aux utilisateurs en fonction des filtres de recherche ci-dessous',0),(548887,15247,'jp','é¡§å®¢ã¾ãŸã¯ä»•å…¥å…ˆãŒè‡ªå‹•çš„ã«ä¸‹ã®æ¤œç´¢ãƒ•ã‚£ãƒ«ã‚¿ãƒ¼ã«åŸºã¥ã„ã¦ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«å‰²ã‚Šå½“ã¦',0),(548888,15247,'pt','Clientes ou fornecedores serÃ£o automaticamente atribuÃ­dos aos usuÃ¡rios com base nos filtros de pesquisa abaixo',0),(548889,15247,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð¸Ð»Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð±ÑƒÐ´ÐµÑ‚ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð½Ð°Ð·Ð½Ð°Ñ‡Ð°Ñ‚ÑŒÑÑ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑÐ¼ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ Ñ„Ð¸Ð»ÑŒÑ‚Ñ€Ð¾Ð² Ð¿Ð¾Ð¸ÑÐºÐ° Ð½Ð¸Ð¶Ðµ',0),(548890,15247,'es','Clientes o proveedores se asignarÃ¡ automÃ¡ticamente a los usuarios basados en los filtros de bÃºsqueda a continuaciÃ³n',0),(548891,15247,'de','Debitoren oder Kreditoren werden soll. automatisch Benutzer basierend auf den Filter fÃ¼r die Volltextsuche unter zugewiesen',0),(548892,15247,'en','Customers Or Vendors Will Be Automatically Assigned To Users Based On The Search Filters Below',0),(548893,15248,'is','',0),(548894,15248,'dr','ÙØ¹Ø§Ù„ÛŒØª Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(548895,15248,'pr','ÙØ¹Ø§Ù„ÛŒØª Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(548896,15248,'tr','Yeni mÃ¼ÅŸteri aktivite',0),(548897,15248,'pl','Nowej dziaÅ‚alnoÅ›ci klienta',0),(548898,15248,'bg','ÐÐ¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(548899,15248,'ur','Ù†Ø¦Û’ Ú¯Ø§ÛÚ© Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(548900,15248,'sr','ÐÐ¾Ð²Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(548901,15248,'vi','Hoáº¡t Ä‘á»™ng khÃ¡ch hÃ ng má»›i',0),(548902,15248,'af','Nuwe kliÃ«nt aktiwiteit',0),(548903,15248,'ro','Activitatea de client nou',0),(548904,15248,'et','Uue kliendi tegevus',0),(548905,15248,'si','Novega kupca dejavnosti',0),(548906,15248,'ba','Kegiatan pelanggan baru',0),(548907,15248,'nl','Nieuwe klant activiteit',0),(548908,15248,'fi','Uuden asiakkaan toimintaa',0),(548909,15248,'no','Ny kundeaktivitet',0),(548910,15248,'da','Ny kundeaktivitet',0),(548911,15248,'ko','ìƒˆë¡œìš´ ê³ ê° í™œë™',0),(548912,15248,'he','×¤×¢×™×œ×•×ª ×”×œ×§×•×— ×”×—×“×©',0),(548913,15248,'el','ÎÎ­Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(548914,15248,'zh','æ–°å®¢æˆ·æ´»åŠ¨',0),(548915,15248,'sv','Ny kundaktivitet',0),(548916,15248,'it','Nuove attivitÃ  del cliente',0),(548917,15248,'tl','',0),(548918,15248,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸«à¸¡à¹ˆ',0),(548919,15248,'hi','à¤¨à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(548920,15248,'ms','Aktiviti pelanggan baru',0),(548921,15248,'ar','Ù†Ø´Ø§Ø· Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(548922,15248,'fr','Nouvelle activitÃ© client',0),(548923,15248,'jp','æ–°ã—ã„é¡§å®¢ã®æ´»å‹•',0),(548924,15248,'pt','Nova atividade do cliente',0),(548925,15248,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(548926,15248,'es','Nueva actividad de cliente',0),(548927,15248,'de','Neue KundenaktivitÃ¤t',0),(548928,15248,'en','New Customer Activity',0),(548929,15249,'is','',0),(548930,15249,'dr','ÙØ¹Ø§Ù„ÛŒØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÛŒØ¯',0),(548931,15249,'pr','ÙØ¹Ø§Ù„ÛŒØª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÛŒØ¯',0),(548932,15249,'tr','Yeni satÄ±cÄ± faaliyet',0),(548933,15249,'pl','Nowa dziaÅ‚alnoÅ›Ä‡ dostawcy',0),(548934,15249,'bg','ÐÐ¾Ð²Ð° Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð¿Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(548935,15249,'ur','Ù†Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(548936,15249,'sr','ÐÐ¾Ð²Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(548937,15249,'vi','Má»›i Ä‘áº¡i lÃ½ hoáº¡t Ä‘á»™ng',0),(548938,15249,'af','Nuwe handelaar aktiwiteit',0),(548939,15249,'ro','Furnizor de activitate',0),(548940,15249,'et','Uue hankija tegevuse',0),(548941,15249,'si','Nov prodajalec dejavnosti',0),(548942,15249,'ba','Kegiatan Vendor baru',0),(548943,15249,'nl','Nieuwe leverancier activiteit',0),(548944,15249,'fi','Uusi toimittajan tehtÃ¤vÃ¤',0),(548945,15249,'no','Ny leverandÃ¸r-aktivitet',0),(548946,15249,'da','Ny leverandÃ¸r aktivitet',0),(548947,15249,'ko','ìƒˆë¡œìš´ ê³µê¸‰ ì—…ì²´ í™œë™',0),(548948,15249,'he','×¤×¢×™×œ×•×ª ×”×¡×¤×§ ×—×“×©×”',0),(548949,15249,'el','ÎÎ­Î± Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(548950,15249,'zh','æ–°ä¾›åº”å•†æ´»åŠ¨',0),(548951,15249,'sv','Ny leverantÃ¶r aktivitet',0),(548952,15249,'it','Nuova attivitÃ  di venditore',0),(548953,15249,'tl','',0),(548954,15249,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹ƒà¸«à¸¡à¹ˆ',0),(548955,15249,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(548956,15249,'ms','Aktiviti penjual baru',0),(548957,15249,'ar','Ù†Ø´Ø§Ø· Ø¨Ø§Ø¦Ø¹ Ø¬Ø¯ÙŠØ¯',0),(548958,15249,'fr','Nouvelle activitÃ© de vendeur',0),(548959,15249,'jp','æ–°ã—ã„ãƒ™ãƒ³ãƒ€ãƒ¼ã®æ´»å‹•',0),(548960,15249,'pt','Nova atividade de fornecedor',0),(548961,15249,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ',0),(548962,15249,'es','Nueva actividad de vendedor',0),(548963,15249,'de','Neue Hersteller-AktivitÃ¤t',0),(548964,15249,'en','New Vendor Activity',0),(548965,15250,'is','',0),(548966,15250,'dr','Ù‡Ù…Ø±Ø§Ù‡',0),(548967,15250,'pr','Ù‡Ù…Ø±Ø§Ù‡',0),(548968,15250,'tr','HÃ¼cre',0),(548969,15250,'pl','KomÃ³rka',0),(548970,15250,'bg','ÐšÐ»ÐµÑ‚ÐºÐ°',0),(548971,15250,'ur','Ø³ÛŒÙ„',0),(548972,15250,'sr','Ð‹ÐµÐ»Ð¸Ñ˜Ðµ',0),(548973,15250,'vi','Di Ä‘á»™ng',0),(548974,15250,'af','Sel',0),(548975,15250,'ro','CelulÄƒ',0),(548976,15250,'et','Lahter',0),(548977,15250,'si','Celice',0),(548978,15250,'ba','Sel',0),(548979,15250,'nl','Cel',0),(548980,15250,'fi','Solun',0),(548981,15250,'no','Celle',0),(548982,15250,'da','Celle',0),(548983,15250,'ko','ì…€',0),(548984,15250,'he','×ª×',0),(548985,15250,'el','ÎšÏ…Ï„Ï„Î¬ÏÏ‰Î½',0),(548986,15250,'zh','å•å…ƒæ ¼',0),(548987,15250,'sv','Cell',0),(548988,15250,'it','Cella',0),(548989,15250,'tl','',0),(548990,15250,'th','à¹€à¸‹à¸¥à¸¥à¹Œ',0),(548991,15250,'hi','à¤¸à¥‡à¤²',0),(548992,15250,'ms','Sel',0),(548993,15250,'ar','Ø®Ù„ÙŠØ©',0),(548994,15250,'fr','Cellule',0),(548995,15250,'jp','ã‚»ãƒ«',0),(548996,15250,'pt','Celular',0),(548997,15250,'ru','Ð¯Ñ‡ÐµÐ¹ÐºÐ°',0),(548998,15250,'es','CÃ©lula',0),(548999,15250,'de','Zelle',0),(549000,15250,'en','Cell',0),(549001,15251,'is','',0),(549002,15251,'dr','Ø´Ù…Ø§ Ø®ÙˆØ¯ Ø±Ø§ Ù…Ø§Ù‡Ø§Ù†Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù…Ø¬Ø§Ø² Ø§Ø³Øª.',0),(549003,15251,'pr','Ø´Ù…Ø§ Ø®ÙˆØ¯ Ø±Ø§ Ù…Ø§Ù‡Ø§Ù†Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù…Ø¬Ø§Ø² Ø§Ø³Øª.',0),(549004,15251,'tr','AylÄ±k iÅŸlem sÄ±nÄ±rÄ±nÄ±zÄ± aÅŸtÄ±nÄ±z.',0),(549005,15251,'pl','PrzekroczyÅ‚eÅ› limit miesiÄ™czny transakcji.',0),(549006,15251,'bg','ÐÐ°Ð´Ð²Ð¸ÑˆÐ¸Ð»Ð¸ ÑÑ‚Ðµ Ð²Ð°ÑˆÐ°Ñ‚Ð° Ð¼ÐµÑÐµÑ‡ÐµÐ½ Ð»Ð¸Ð¼Ð¸Ñ‚ Ð·Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ.',0),(549007,15251,'ur','Ø¢Ù¾ Ø§Ù¾Ù†Û’ Ù…Ø§ÛØ§Ù†Û Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø­Ø¯ Ú©Ùˆ Ù¾Ø§Ø± Ú©Ø±Ú†Ú©Ø§ ÛÛ’ Û”',0),(549008,15251,'sr','ÐŸÑ€ÐµÐºÐ¾Ñ€Ð°Ñ‡Ð¸Ð»Ð¸ ÑÑ‚Ðµ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÑšÐµ Ð¼ÐµÑÐµÑ‡Ð½Ð¾Ð³ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ.',0),(549009,15251,'vi','Báº¡n Ä‘Ã£ vÆ°á»£t quÃ¡ giá»›i háº¡n giao dá»‹ch hÃ ng thÃ¡ng cá»§a báº¡n.',0),(549010,15251,'af','Jy het jou maandelikse transaksie-limiet oorskry.',0),(549011,15251,'ro','DepÄƒÈ™itÄƒ limita lunarÄƒ de tranzacÅ£ie.',0),(549012,15251,'et','Olete Ã¼letanud oma igakuise tehingulimiidi.',0),(549013,15251,'si','Presegli ste vaÅ¡e meseÄne transakcije.',0),(549014,15251,'ba','Anda telah melebihi batas transaksi bulanan.',0),(549015,15251,'nl','U hebt uw maandelijkse transactie limiet overschreden.',0),(549016,15251,'fi','Kuukausittainen tapahtuman raja on ylitetty.',0),(549017,15251,'no','Du har overskredet din mÃ¥nedlig grense.',0),(549018,15251,'da','Du har overskredet din grÃ¦nse for mÃ¥nedligt transaktion.',0),(549019,15251,'ko','ë‹¹ì‹ ì˜ ì›” ë‹¨ìœ„ íŠ¸ëžœìž­ì…˜ ì œí•œì„ ì´ˆê³¼ í–ˆìŠµë‹ˆë‹¤.',0),(549020,15251,'he','×—×¨×’×ª ×ž×’×‘×œ×ª ×”×ª× ×•×¢×” ×”×—×•×“×©×™ ×©×œ×š.',0),(549021,15251,'el','ÎˆÏ‡ÎµÏ„Îµ Î¾ÎµÏ€ÎµÏÎ¬ÏƒÎµÎ¹ Ï„Î¿ Î¼Î·Î½Î¹Î±Î¯Î¿ ÏŒÏÎ¹Î¿ ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½.',0),(549022,15251,'zh','æ‚¨å·²è¶…å‡ºæ‚¨æ¯æœˆçš„äº¤æ˜“é™åˆ¶ã€‚',0),(549023,15251,'sv','Du har Ã¶verskridit din mÃ¥natliga transaktion grÃ¤ns.',0),(549024,15251,'it','Hai superato il limite di transazioni mensili.',0),(549025,15251,'tl','',0),(549026,15251,'th','à¸„à¸¸à¸“à¸¡à¸µà¹€à¸à¸´à¸™à¸‚à¸µà¸”à¸ˆà¸³à¸à¸±à¸”à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸£à¸²à¸¢à¹€à¸”à¸·à¸­à¸™',0),(549027,15251,'hi','à¤†à¤ª à¤…à¤ªà¤¨à¥‡ à¤®à¤¾à¤¸à¤¿à¤• à¤²à¥‡à¤¨à¤¦à¥‡à¤¨ à¤•à¥€ à¤¸à¥€à¤®à¤¾ à¤ªà¤¾à¤° à¤•à¤° à¤šà¥à¤•à¥‡ à¤¹à¥ˆà¤‚à¥¤',0),(549028,15251,'ms','Anda telah melebihi had transaksi bulanan anda.',0),(549029,15251,'ar','ØªÙ… ØªØ¬Ø§ÙˆØ² Ø­Ø¯ Ø§Ù„Ø­Ø±ÙƒØ© Ø§Ù„Ø´Ù‡Ø±ÙŠ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ.',0),(549030,15251,'fr','Vous avez dÃ©passÃ© votre limite de transaction mensuelle.',0),(549031,15251,'jp','æ¯Žæœˆã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³é™åº¦ã‚’è¶…ãˆã¦ã„ã¾ã™ã€‚',0),(549032,15251,'pt','VocÃª excedeu o seu limite mensal de transaÃ§Ã£o.',0),(549033,15251,'ru','Ð’Ñ‹ Ð¿Ñ€ÐµÐ²Ñ‹ÑÐ¸Ð»Ð¸ Ð²Ð°Ñˆ ÐµÐ¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ñ‹Ð¹ Ð»Ð¸Ð¼Ð¸Ñ‚ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹.',0),(549034,15251,'es','Usted ha excedido su lÃ­mite de transacciones mensuales.',0),(549035,15251,'de','Sie haben Ihre monatlichen Transaktion Grenzen Ã¼berschritten.',0),(549036,15251,'en','You have exceeded your monthly transaction limit.',0),(549037,15252,'is','',0),(549038,15252,'dr','Ø¬Ø¯ÛŒØ¯ ØªØ­Ù‚Ù‚ Ù†Ù‚Ù„ Ù‚ÙˆÙ„/Ø³ÙØ§Ø±Ø´',0),(549039,15252,'pr','Ø¬Ø¯ÛŒØ¯ ØªØ­Ù‚Ù‚ Ù†Ù‚Ù„ Ù‚ÙˆÙ„/Ø³ÙØ§Ø±Ø´',0),(549040,15252,'tr','Yeni yerine getirilmesi teklifi/sipariÅŸi',0),(549041,15252,'pl','Oferta realizacji/zamÃ³wienie',0),(549042,15252,'bg','ÐÐ¾Ð²Ð° Ð¾Ñ„ÐµÑ€Ñ‚Ð°/Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ',0),(549043,15252,'ur','Ù†Ø¦Û’ ØªÚ©Ù…ÛŒÙ„ Ø§Ù‚ØªØ¨Ø§Ø³/Ø¢Ø±ÚˆØ±',0),(549044,15252,'sr','ÐÐ¾Ð²Ð° Ð¿Ð¾Ð½ÑƒÐ´Ð°/Ð½Ð°Ð»Ð¾Ð³ Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ',0),(549045,15252,'vi','Má»›i thá»±c hiá»‡n bÃ¡o/Ä‘áº·t hÃ ng',0),(549046,15252,'af','Nuwe vervulling aanhaling/bestel',0),(549047,15252,'ro','ÃŽmplinirea nouÄƒ ofertÄƒ/comandÄƒ',0),(549048,15252,'et','Uus plaanitud Quote/tellimus',0),(549049,15252,'si','Nov izpolnitev ponudbo/nalog',0),(549050,15252,'ba','Kutipan/Orde Baru pemenuhan',0),(549051,15252,'nl','Nieuwe vervulling Quote/Order',0),(549052,15252,'fi','Uuden suunnitellun tarjouspyynnÃ¶n/tilauksen',0),(549053,15252,'no','Ny planlagt tilbud/bestilling',0),(549054,15252,'da','Nye opfyldelse tilbud/ordre',0),(549055,15252,'ko','ìƒˆë¡œìš´ í–‰ ê²¬ì /ì£¼ë¬¸',0),(549056,15252,'he','×ž×™×ž×•×© ×”×¦×¢×ª ×ž×—×™×¨/×¡×“×¨ ×—×“×©',0),(549057,15252,'el','ÎÎ­Î± ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· Ï€ÏÎ¿ÏƒÏ†Î¿ÏÏŽÎ½/ÎµÎ½Ï„Î¿Î»ÏŽÎ½',0),(549058,15252,'zh','æ–°çš„å±¥è¡ŒæŠ¥ä»·/è®¢å•',0),(549059,15252,'sv','Nya uppfyllelse offert/bestÃ¤llning',0),(549060,15252,'it','Nuovo adempimento preventivo/ordine',0),(549061,15252,'tl','',0),(549062,15252,'th','à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²/à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(549063,15252,'hi','à¤¨à¤ˆ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤¬à¥‹à¤²à¥€/à¤†à¤¦à¥‡à¤¶',0),(549064,15252,'ms','Baru memenuhi Quote/perintah',0),(549065,15252,'ar','Ø§Ù‚ØªØ¨Ø§Ø³/Ø£Ù…Ø± Ø§Ø³ØªÙŠÙØ§Ø¡ Ø¬Ø¯ÙŠØ¯',0),(549066,15252,'fr','Nouvelle devis de rÃ©alisation/commandes',0),(549067,15252,'jp','æ–°ã—ã„è¨ˆç”»ã®è¦‹ç©ã‚Š/ã‚ªãƒ¼ãƒ€ãƒ¼',0),(549068,15252,'pt','Nova cotaÃ§Ã£o/pedido de cumprimento',0),(549069,15252,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ†Ð¸Ñ‚Ð°Ñ‚Ð°/Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(549070,15252,'es','Nuevo pedido/oferta de cumplimiento',0),(549071,15252,'de','Neue ErfÃ¼llung Angebote/Bestellungen',0),(549072,15252,'en','New Fulfillment Quote/Order',0),(549073,15253,'is','',0),(549074,15253,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÛŒØ¯',0),(549075,15253,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¬Ø¯ÛŒØ¯',0),(549076,15253,'tr','Yeni Ã¶deme',0),(549077,15253,'pl','Nowe pÅ‚atnoÅ›ci',0),(549078,15253,'bg','ÐÐ¾Ð²Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(549079,15253,'ur','Ù†Ø¦Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(549080,15253,'sr','ÐÐ¾Ð²Ñƒ ÑƒÐ¿Ð»Ð°Ñ‚Ñƒ',0),(549081,15253,'vi','Thanh toÃ¡n má»›i',0),(549082,15253,'af','Nuwe betaling',0),(549083,15253,'ro','NouÄƒ platÄƒ',0),(549084,15253,'et','Uusi makse',0),(549085,15253,'si','Novo plaÄilo',0),(549086,15253,'ba','Pembayaran baru',0),(549087,15253,'nl','Nieuwe betaling',0),(549088,15253,'fi','Uusi maksu',0),(549089,15253,'no','Ny betaling',0),(549090,15253,'da','Ny betaling',0),(549091,15253,'ko','ìƒˆë¡œìš´ ì§€ë¶ˆ',0),(549092,15253,'he','×ª×©×œ×•× ×—×“×©',0),(549093,15253,'el','ÎÎ­Î± Ï€Î»Î·ÏÏ‰Î¼Î®',0),(549094,15253,'zh','æ–°ä»˜æ¬¾',0),(549095,15253,'sv','Ny betalning',0),(549096,15253,'it','Nuovo pagamento',0),(549097,15253,'tl','',0),(549098,15253,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(549099,15253,'hi','à¤¨à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(549100,15253,'ms','Bayaran baru',0),(549101,15253,'ar','Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(549102,15253,'fr','Nouveau paiement',0),(549103,15253,'jp','æ–°ãŸãªæ”¯æ‰•ã„',0),(549104,15253,'pt','Novo pagamento',0),(549105,15253,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(549106,15253,'es','Nuevo pago',0),(549107,15253,'de','Neue Zahlung',0),(549108,15253,'en','New Payment',0),(549109,15254,'is','',0),(549110,15254,'dr','Ø³ÙØ§Ø±Ø´ Ø³Ø±ÙˆÛŒØ³ Ø¬Ø¯ÛŒØ¯',0),(549111,15254,'pr','Ø³ÙØ§Ø±Ø´ Ø³Ø±ÙˆÛŒØ³ Ø¬Ø¯ÛŒØ¯',0),(549112,15254,'tr','Yeni servis sipariÅŸi',0),(549113,15254,'pl','Nowe zlecenia serwisowego',0),(549114,15254,'bg','ÐÐ¾Ð²Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(549115,15254,'ur','Ø®Ø¯Ù…Øª Ú©Û’ Ù†Ø¦Û’ Ø¢Ø±ÚˆØ±',0),(549116,15254,'sr','ÐÐ¾Ð²Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(549117,15254,'vi','Tráº­t tá»± dá»‹ch vá»¥ má»›i',0),(549118,15254,'af','Nuwe diens bestel',0),(549119,15254,'ro','Noua comandÄƒ de Service',0),(549120,15254,'et','Uue hooldustellimuse',0),(549121,15254,'si','Nov servisni nalog',0),(549122,15254,'ba','Orde layanan baru',0),(549123,15254,'nl','Nieuwe serviceorder',0),(549124,15254,'fi','Uusi huoltotilaus',0),(549125,15254,'no','Ny serviceordre',0),(549126,15254,'da','Ny serviceordre',0),(549127,15254,'ko','ìƒˆë¡œìš´ ì„œë¹„ìŠ¤ ìˆœì„œ',0),(549128,15254,'he','×”×–×ž× ×ª ×©×™×¨×•×ª ×—×“×©',0),(549129,15254,'el','ÎÎ­Î± ÎµÎ½Ï„Î¿Î»Î® Ï„ / Ï…',0),(549130,15254,'zh','æ–°çš„æœåŠ¡è®¢å•',0),(549131,15254,'sv','Ny serviceorder',0),(549132,15254,'it','Nuovo ordine di assistenza',0),(549133,15254,'tl','',0),(549134,15254,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸šà¸£à¸´à¸à¸²à¸£à¹ƒà¸«à¸¡à¹ˆ',0),(549135,15254,'hi','à¤¨à¤ˆ à¤¸à¥‡à¤µà¤¾ à¤•à¥à¤°à¤®',0),(549136,15254,'ms','Pesanan Perkhidmatan baru',0),(549137,15254,'ar','Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø© Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø©',0),(549138,15254,'fr','Nouvelle commande de Service',0),(549139,15254,'jp','æ–°ã—ã„ã‚µãƒ¼ãƒ“ã‚¹ã®æ³¨æ–‡',0),(549140,15254,'pt','Nova ordem de serviÃ§o',0),(549141,15254,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÑÐµÑ€Ð²Ð¸ÑÐ½Ñ‹Ð¹ Ð·Ð°ÐºÐ°Ð·',0),(549142,15254,'es','Nueva orden de servicio',0),(549143,15254,'de','Neuer Serviceauftrag',0),(549144,15254,'en','New Service Order',0),(549145,15255,'is','',0),(549146,15255,'dr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ø¬Ø³ØªØ¬Ùˆ',0),(549147,15255,'pr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ø¬Ø³ØªØ¬Ùˆ',0),(549148,15255,'tr','Arama AÃ§Ä±klamasÄ±',0),(549149,15255,'pl','Opis',0),(549150,15255,'bg','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð·Ð° Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ',0),(549151,15255,'ur','ØªÙ„Ø§Ø´ Ú©ÛŒ ÙˆØ¶Ø§Ø­Øª',0),(549152,15255,'sr','ÐžÐ¿Ð¸Ñ Ð·Ð° Ð¿Ñ€ÐµÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ',0),(549153,15255,'vi','TÃ¬m mÃ´ táº£',0),(549154,15255,'af','Soek Beskrywing',0),(549155,15255,'ro','CÄƒutaÅ£i Descriere',0),(549156,15255,'et','Otsingu kirjeldus',0),(549157,15255,'si','Opis za iskanje',0),(549158,15255,'ba','Cari Keterangan',0),(549159,15255,'nl','Zoeknaam',0),(549160,15255,'fi','Hakunimi',0),(549161,15255,'no','SÃ¸kebeskrivelse',0),(549162,15255,'da','SÃ¸gebeskrivelse',0),(549163,15255,'ko','ê²€ìƒ‰ ì„¤ëª…',0),(549164,15255,'he','×ª×™××•×¨ ×—×™×¤×•×©',0),(549165,15255,'el','Î‘Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Ï€ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(549166,15255,'zh','æœç´¢è¯´æ˜Ž',0),(549167,15255,'sv','SÃ¶kbeskrivning',0),(549168,15255,'it','Descrizione della ricerca',0),(549169,15255,'tl','',0),(549170,15255,'th','à¸­à¸˜à¸´à¸šà¸²à¸¢à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²',0),(549171,15255,'hi','à¤–à¥‹à¤œ à¤µà¤¿à¤µà¤°à¤£',0),(549172,15255,'ms','Penerangan carian',0),(549173,15255,'ar','ÙˆØµÙ Ø§Ù„Ø¨Ø­Ø«',0),(549174,15255,'fr','Description de la recherche',0),(549175,15255,'jp','æ¤œç´¢ã®èª¬æ˜Ž',0),(549176,15255,'pt','DescriÃ§Ã£o da pesquisa',0),(549177,15255,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ð¾Ð¸ÑÐºÐ°',0),(549178,15255,'es','DescripciÃ³n de la bÃºsqueda',0),(549179,15255,'de','Suche Beschreibung',0),(549180,15255,'en','Search Description',0),(549181,15256,'is','',0),(549182,15256,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡/Ø³ÙØ§Ø±Ø´ ÙˆÛŒØ±Ø§ÛŒØ´',0),(549183,15256,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡/Ø³ÙØ§Ø±Ø´ ÙˆÛŒØ±Ø§ÛŒØ´',0),(549184,15256,'tr','GÃ¶rÃ¼nÃ¼m/sipariÅŸ DÃ¼zenle',0),(549185,15256,'pl','WyÅ›wietl/Edytuj zamÃ³wienia',0),(549186,15256,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(549187,15256,'ur','Ù…Ù†Ø¸Ø±/Ø­Ú©Ù… ØªØ±Ù…ÛŒÙ…',0),(549188,15256,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ /Ð£Ñ€ÐµÐ´Ð¸ Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´',0),(549189,15256,'vi','Xem/chá»‰nh sá»­a Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(549190,15256,'af','Bekyk/redigeer orde',0),(549191,15256,'ro','Vizualizare/Editare comanda',0),(549192,15256,'et','Vaata/Muuda tellimuse',0),(549193,15256,'si','Ogled/urejanje nalog',0),(549194,15256,'ba','Lihat/Edit Order',0),(549195,15256,'nl','Volgorde weergeven/bewerken',0),(549196,15256,'fi','NÃ¤ytÃ¤/Muokkaa jÃ¤rjestystÃ¤',0),(549197,15256,'no','Vise/redigere rekkefÃ¸lge',0),(549198,15256,'da','Se/Rediger rÃ¦kkefÃ¸lge',0),(549199,15256,'ko','ë³´ê¸°/íŽ¸ì§‘ ìˆœì„œ',0),(549200,15256,'he','×”×¦×’/×¢×¨×•×š ×¡×“×¨',0),(549201,15256,'el','Î ÏÎ¿Î²Î¿Î»Î®/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(549202,15256,'zh','æŸ¥çœ‹/ç¼–è¾‘è®¢å•',0),(549203,15256,'sv','Visa/redigera Order',0),(549204,15256,'it','Visualizza/modifica ordine',0),(549205,15256,'tl','',0),(549206,15256,'th','à¸”à¸¹à¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(549207,15256,'hi','à¤¦à¥‡à¤–à¥‡à¤‚/à¤•à¥à¤°à¤® à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(549208,15256,'ms','Pandangan/Edit perintah',0),(549209,15256,'ar','Ø¹Ø±Ø¶/ØªØ­Ø±ÙŠØ± Ø§Ù„Ù†Ø¸Ø§Ù…',0),(549210,15256,'fr','Afficher/modifier ordre',0),(549211,15256,'jp','é †åºã®è¡¨ç¤º/ç·¨é›†',0),(549212,15256,'pt','Exibir/editar ordem',0),(549213,15256,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ÐµÑ‚ÑŒ/Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(549214,15256,'es','Ver/editar orden',0),(549215,15256,'de','Bearbeiten Sie anzeigen/bestellen',0),(549216,15256,'en','View/Edit Order',0),(549217,15257,'is','',0),(549218,15257,'dr','Ø²Ù…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(549219,15257,'pr','Ø²Ù…Ø§Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(549220,15257,'tr','Saat baÅŸarÄ±yla kaydedildi',0),(549221,15257,'pl','Czas zapisany pomyÅ›lnie',0),(549222,15257,'bg','Ð’Ñ€ÐµÐ¼ÐµÑ‚Ð¾, ÑÐ¿ÐµÑÑ‚ÐµÐ½Ð¾ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(549223,15257,'ur','ÙˆÙ‚Øª Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù„ÛŒ',0),(549224,15257,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(549225,15257,'vi','Thá»i gian lÆ°u thÃ nh cÃ´ng',0),(549226,15257,'af','Tyd suksesvol gestoor',0),(549227,15257,'ro','Timp salvat cu succes',0),(549228,15257,'et','Kell on edukalt salvestatud',0),(549229,15257,'si','ÄŒasa uspeÅ¡no shranjen',0),(549230,15257,'ba','Waktu disimpan berhasil',0),(549231,15257,'nl','Tijd opgeslagen',0),(549232,15257,'fi','Tallennettu aika',0),(549233,15257,'no','Tid lagret',0),(549234,15257,'da','Gang gemt med succes',0),(549235,15257,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ ëœ ì‹œê°„',0),(549236,15257,'he','×–×ž×Ÿ × ×©×ž×¨ ×‘×”×¦×œ×—×”',0),(549237,15257,'el','Î§ÏÏŒÎ½Î¿Ï‚ Ï€Î¿Ï… ÎµÎ¾Î¿Î¹ÎºÎ¿Î½Î¿Î¼ÎµÎ¯Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(549238,15257,'zh','å·²æˆåŠŸä¿å­˜çš„æ—¶é—´',0),(549239,15257,'sv','Tid sparats',0),(549240,15257,'it','Tempo risparmiato con successo',0),(549241,15257,'tl','',0),(549242,15257,'th','à¹€à¸§à¸¥à¸²à¸—à¸µà¹ˆà¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(549243,15257,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¸à¤®à¤¯',0),(549244,15257,'ms','Masa yang berjaya disimpan',0),(549245,15257,'ar','ÙˆÙ‚Øª Ø­ÙØ¸Ù‡ Ø¨Ù†Ø¬Ø§Ø­',0),(549246,15257,'fr','Temps gagnÃ© avec succÃ¨s',0),(549247,15257,'jp','æ­£å¸¸ã«ä¿å­˜æ™‚é–“',0),(549248,15257,'pt','Tempo com sucesso',0),(549249,15257,'ru','Ð’Ñ€ÐµÐ¼Ñ, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(549250,15257,'es','Tiempo guardado correctamente',0),(549251,15257,'de','Mal erfolgreich gespeichert',0),(549252,15257,'en','Time Saved Successfully',0),(549253,15258,'is','',0),(549254,15258,'dr','Ù‡Ù…Ù‡ Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡ Ø§Ù‚Ø¯Ø§Ù…Ø§Øª Ø¨Ø¹Ø¯ÛŒ Ø´Ø§Ù…Ù„',0),(549255,15258,'pr','Ù‡Ù…Ù‡ Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡ Ø§Ù‚Ø¯Ø§Ù…Ø§Øª Ø¨Ø¹Ø¯ÛŒ Ø´Ø§Ù…Ù„',0),(549256,15258,'tr','TÃ¼m cevapsÄ±z sonraki eylemler iÃ§erir',0),(549257,15258,'pl','ObejmowaÄ‡ wszystkich nieodebranych nastÄ™pnej akcji',0),(549258,15258,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ñ€Ð¾Ð¿ÑƒÑÐ½Ð°Ñ‚Ð¸ ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ‚Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(549259,15258,'ur','ØªÙ…Ø§Ù… ÙÙˆØª Ø´Ø¯Û Ø§Ú¯Ù„Û’ Ø§Ù‚Ø¯Ø§Ù…Ø§Øª Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(549260,15258,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÑÐ²Ðµ Ð¿Ñ€Ð¾Ð¿ÑƒÑˆÑ‚ÐµÐ½Ðµ ÑÐ»ÐµÐ´ÐµÑ›Ðµ Ñ€Ð°Ð´ÑšÐµ',0),(549261,15258,'vi','Bao gá»“m bá»‹ máº¥t táº¥t cáº£ cÃ¡c hÃ nh Ä‘á»™ng tiáº¿p theo',0),(549262,15258,'af','Sluit alle gemis volgende aksies',0),(549263,15258,'ro','Includ ratat toate acÅ£iunile urmÄƒtoare',0),(549264,15258,'et','Kuuluvad kÃµik vastamata jÃ¤rgmise meetmed',0),(549265,15258,'si','VkljuÄujejo vse zamujene naslednji ukrepi',0),(549266,15258,'ba','Termasuk semua melewatkan berikutnya tindakan',0),(549267,15258,'nl','Alle gemiste volgende acties omvatten',0),(549268,15258,'fi','SisÃ¤ltÃ¤Ã¤ kaikki jÃ¤Ã¤neiden seuraavat toimet',0),(549269,15258,'no','Inkludere alle tapte neste handlinger',0),(549270,15258,'da','Omfatte alle ubesvarede nÃ¦ste foranstaltninger',0),(549271,15258,'ko','ëª¨ë‘ ë†“ì¹œëœ ë‹¤ìŒ ìž‘ì—… í¬í•¨',0),(549272,15258,'he','×œ×›×œ×•×œ ×¤×¢×•×œ×•×ª ×”×‘× ×”×›×œ ×©×œ× × ×¢× ×ª×”',0),(549273,15258,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ ÏŒÎ»Î± Ï‡Î±Î¼Î­Î½Î· ÎµÏ€ÏŒÎ¼ÎµÎ½ÎµÏ‚ Î´ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(549274,15258,'zh','åŒ…æ‹¬æ‰€æœ‰é”™è¿‡çš„ä¸‹ä¸€æ­¥è¡ŒåŠ¨',0),(549275,15258,'sv','Inkludera alla missade nÃ¤sta Ã¥tgÃ¤rder',0),(549276,15258,'it','Includono tutte perse prossime azioni',0),(549277,15258,'tl','',0),(549278,15258,'th','à¸£à¸§à¸¡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸–à¸±à¸”à¹„à¸›',0),(549279,15258,'hi','à¤¸à¤­à¥€ à¤›à¥‚à¤Ÿà¥€ à¤¹à¥à¤ˆ à¤…à¤—à¤²à¥€ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(549280,15258,'ms','Termasuk semua terlepas tindakan seterusnya',0),(549281,15258,'ar','ÙˆØªØ´Ù…Ù„ ØºØ§Ø¨ Ø¹Ù† Ø¬Ù…ÙŠØ¹ Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ù…Ù‚Ø¨Ù„Ø©',0),(549282,15258,'fr','Inclure tous manquÃ©es prochaines Actions',0),(549283,15258,'jp','æ¬¡ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã«ã¯ã™ã¹ã¦é€ƒã—ãŸãŒå«ã¾ã‚Œã¾ã™',0),(549284,15258,'pt','Incluir todas perdidas prÃ³ximas aÃ§Ãµes',0),(549285,15258,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð¿Ñ€Ð¾Ð¿ÑƒÑ‰ÐµÐ½Ð½Ñ‹Ðµ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ³Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(549286,15258,'es','Son todo perdidas prÃ³ximas acciones',0),(549287,15258,'de','SchlieÃŸen Sie alle verpasste nÃ¤chste Aktionen',0),(549288,15258,'en','Include All Missed Next Actions',0),(549289,15259,'is','',0),(549290,15259,'dr','Ù‡Ù…Ù‡ Ø§Ø®ÛŒØ± & Ø¢ÛŒÙ†Ø¯Ù‡ Ø§Ù‚Ø¯Ø§Ù…Ø§Øª Ø¨Ø¹Ø¯ÛŒ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(549291,15259,'pr','Ù‡Ù…Ù‡ Ø§Ø®ÛŒØ± & Ø¢ÛŒÙ†Ø¯Ù‡ Ø§Ù‚Ø¯Ø§Ù…Ø§Øª Ø¨Ø¹Ø¯ÛŒ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(549292,15259,'tr','TÃ¼m son ve yaklaÅŸan sonraki eylemler gÃ¶ster',0),(549293,15259,'pl','PokaÅ¼ wszystkie najnowsze idealna nadchodzÄ…ce kolejne dziaÅ‚ania',0),(549294,15259,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ & Ð¿Ñ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸ ÑÐ»ÐµÐ´Ð²Ð°Ñ‰Ð¸Ñ‚Ðµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(549295,15259,'ur','ØªÙ…Ø§Ù… Ø­Ø§Ù„ÛŒÛ & Ø¢Ø¦Ù†Ø¯Û Ø§Ú¯Ù„Ø§ Ø§Ø¹Ù…Ø§Ù„ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(549296,15259,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ²Ðµ Ð½ÐµÐ´Ð°Ð²Ð½Ðµ & Ð¿Ñ€ÐµÐ´ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ ÑÐ»ÐµÐ´ÐµÑ›Ðµ Ñ€Ð°Ð´ÑšÐµ',0),(549297,15259,'vi','Hiá»ƒn thá»‹ táº¥t cáº£ nhá»¯ng hÃ nh Ä‘á»™ng tiáº¿p theo táº¡i & sáº¯p tá»›i',0),(549298,15259,'af','Wys alle onlangse & komende volgende aksies',0),(549299,15259,'ro','AratÄƒ toate recente & viitoare acÅ£iuni viitoare',0),(549300,15259,'et','NÃ¤ita kÃµiki tehtud- & tulemas jÃ¤rgmise meetmeid',0),(549301,15259,'si','PrikaÅ¾i vseh zadnjih & prihajajoÄi naslednji ukrepi',0),(549302,15259,'ba','Tampilkan semua hari & mendatang berikutnya tindakan',0),(549303,15259,'nl','Alle recente & komende volgende acties weergeven',0),(549304,15259,'fi','NÃ¤ytÃ¤ kaikki hotelliin & tulevan seuraavan toiminnot',0),(549305,15259,'no','Vis alle siste & kommende neste handlinger',0),(549306,15259,'da','Vis alle de seneste & kommende nÃ¦ste handlinger',0),(549307,15259,'ko','ëª¨ë“  ìµœê·¼ & ê³§ ë‹¤ìŒ ìž‘ì—… í‘œì‹œ',0),(549308,15259,'he','×”×¦×’ ××ª ×›×œ ×”×¤×¢×•×œ×•×ª ×”×‘××” ×”××—×¨×•× ×•×ª & ×”×§×¨×•×‘×”',0),(549309,15259,'el','Î”ÎµÎ¯Ï„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Ï€ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚, & ÎµÏ€ÎµÏÏ‡ÏŒÎ¼ÎµÎ½Î· ÎµÏ€ÏŒÎ¼ÎµÎ½Î· Î´ÏÎ¬ÏƒÎµÎ¹Ï‚',0),(549310,15259,'zh','æ˜¾ç¤ºæ‰€æœ‰æœ€è¿‘ä¸Žå³å°†åˆ°æ¥çš„ä¸‹ä¸€æ­¥è¡ŒåŠ¨',0),(549311,15259,'sv','Visa alla de senaste & kommande nÃ¤sta Ã¥tgÃ¤rder',0),(549312,15259,'it','Visualizza tutti i recenti & imminenti prossime azioni',0),(549313,15259,'tl','',0),(549314,15259,'th','à¹à¸ªà¸”à¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸¥à¹ˆà¸²à¸ªà¸¸à¸”à¸„à¸¸à¹‰à¸¡à¸–à¸¶à¸‡ à¸„à¹ˆà¸²à¸–à¸±à¸”à¹„à¸›à¸à¸²à¸£à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£',0),(549315,15259,'hi','à¤¸à¤­à¥€ à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ & à¤†à¤—à¤¾à¤®à¥€ à¤…à¤—à¤²à¥€ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(549316,15259,'ms','Tunjukkan semua hari & akan datang tindakan seterusnya',0),(549317,15259,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙƒØ§ÙØ© Ø§Ù„Ø¥Ø¬Ø±Ø§Ø¡Ø§Øª Ø§Ù„Ù…Ù‚Ø¨Ù„Ø© Ø§Ù„Ø£Ø®ÙŠØ±Ø© & Ø§Ù„Ù‚Ø§Ø¯Ù…Ø©',0),(549318,15259,'fr','Montrer toutes les prochaines Actions rÃ©centes & Ã  venir',0),(549319,15259,'jp','ã™ã¹ã¦ã®æœ€è¿‘ãƒ»ä»Šå¾Œã®æ¬¡ã®ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(549320,15259,'pt','Mostrar todas as aÃ§Ãµes de prÃ³xima recentes e prÃ³ximas',0),(549321,15259,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð²ÑÐµ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ & Ð¿Ñ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰ÐµÐ³Ð¾ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰ÐµÐ³Ð¾ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ',0),(549322,15259,'es','Mostrar todas las recientes y prÃ³ximas acciones prÃ³ximas',0),(549323,15259,'de','Alle jÃ¼ngste & bevorstehende nÃ¤chste Aktionen anzeigen',0),(549324,15259,'en','Show All Recent & Upcoming Next Actions',0),(549325,15260,'is','',0),(549326,15260,'dr','ÙÙ‚Ø· ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ CRM',0),(549327,15260,'pr','ÙÙ‚Ø· ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ CRM',0),(549328,15260,'tr','Sadece CRM aktivitesi',0),(549329,15260,'pl','Tylko dziaÅ‚ania programu CRM',0),(549330,15260,'bg','ÐŸÑ€Ð¾ÑÑ‚Ð¾ CRM Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(549331,15260,'ur','Ø¨Ø³ Ú© Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(549332,15260,'sr','Ð¡Ð°Ð¼Ð¾ Ð¦Ð Ðœ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(549333,15260,'vi','Chá»‰ hoáº¡t Ä‘á»™ng CRM',0),(549334,15260,'af','CRM aktiwiteit net',0),(549335,15260,'ro','Doar activitatea de CRM',0),(549336,15260,'et','Lihtsalt CRM-i tegevust',0),(549337,15260,'si','Samo dejavnost programa CRM',0),(549338,15260,'ba','Hanya CRM aktivitas',0),(549339,15260,'nl','Net CRM-activiteit',0),(549340,15260,'fi','Vain CRM: N aktiviteettia',0),(549341,15260,'no','Bare CRM-aktivitet',0),(549342,15260,'da','Bare CRM aktivitet',0),(549343,15260,'ko','ê·¸ëƒ¥ CRM í™œë™',0),(549344,15260,'he','×¨×§ ×¤×¢×™×œ×•×ª CRM',0),(549345,15260,'el','ÎœÏŒÎ»Î¹Ï‚ CRM Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(549346,15260,'zh','åªæ˜¯ CRM æ´»åŠ¨',0),(549347,15260,'sv','Bara CRM-aktivitet',0),(549348,15260,'it','Solo attivitÃ  CRM',0),(549349,15260,'tl','',0),(549350,15260,'th','à¹€à¸žà¸µà¸¢à¸‡à¸à¸´à¸ˆà¸à¸£à¸£à¸¡ CRM',0),(549351,15260,'hi','à¤¸à¤¿à¤°à¥à¤« CRM à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(549352,15260,'ms','Hanya aktiviti CRM',0),(549353,15260,'ar','Ù…Ø¬Ø±Ø¯ Ù†Ø´Ø§Ø· CRM',0),(549354,15260,'fr','Juste l\'activitÃ© CRM',0),(549355,15260,'jp','ã¡ã‚‡ã†ã© CRM æ´»å‹•',0),(549356,15260,'pt','Apenas atividade CRM',0),(549357,15260,'ru','ÐŸÑ€Ð¾ÑÑ‚Ð¾ CRM Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ',0),(549358,15260,'es','SÃ³lo actividad de CRM',0),(549359,15260,'de','CRM-AktivitÃ¤t',0),(549360,15260,'en','Just CRM Activity',0),(549361,15261,'is','',0),(549362,15261,'dr','ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ ÙˆØ²Ø§Ø±Øª Ú©Ø´ÙˆØ±',0),(549363,15261,'pr','ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ ÙˆØ²Ø§Ø±Øª Ú©Ø´ÙˆØ±',0),(549364,15261,'tr','VRM etkinliÄŸi',0),(549365,15261,'pl','VRM aktywnoÅ›Ä‡',0),(549366,15261,'bg','VRM Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚',0),(549367,15261,'ur','VRM Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(549368,15261,'sr','Ð’Ð Ðœ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(549369,15261,'vi','Hoáº¡t Ä‘á»™ng VRM',0),(549370,15261,'af','VRM aktiwiteit',0),(549371,15261,'ro','VRM activitate',0),(549372,15261,'et','VRM tegevus',0),(549373,15261,'si','VRM dejavnost',0),(549374,15261,'ba','Aktivitas VRM',0),(549375,15261,'nl','VRM activiteit',0),(549376,15261,'fi','VRM toimintaa',0),(549377,15261,'no','VRM aktivitet',0),(549378,15261,'da','VRM aktivitet',0),(549379,15261,'ko','VRM í™œë™',0),(549380,15261,'he','×¤×¢×™×œ×•×ª VRM',0),(549381,15261,'el','VRM Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(549382,15261,'zh','VRM æ´»åŠ¨',0),(549383,15261,'sv','VRM aktivitet',0),(549384,15261,'it','AttivitÃ  di VRM',0),(549385,15261,'tl','',0),(549386,15261,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡ VRM',0),(549387,15261,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤®à¤‚à¤¤à¥à¤°à¤¾à¤²à¤¯ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(549388,15261,'ms','VRM aktiviti',0),(549389,15261,'ar','Ø§Ù„Ù†Ø´Ø§Ø· ÙØ±Ù…',0),(549390,15261,'fr','ActivitÃ© VRM',0),(549391,15261,'jp','VRM æ´»å‹•',0),(549392,15261,'pt','Atividade de VRM',0),(549393,15261,'ru','VRM Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ',0),(549394,15261,'es','Actividad de VRM',0),(549395,15261,'de','VRM-AktivitÃ¤t',0),(549396,15261,'en','VRM Activity',0),(549397,15262,'is','',0),(549398,15262,'dr','ØªØ§Ø±ÛŒØ® & Ø¹Ù…ÙˆÙ…ÛŒ Ø²Ù…Ø§Ù†',0),(549399,15262,'pr','ØªØ§Ø±ÛŒØ® & Ø¹Ù…ÙˆÙ…ÛŒ Ø²Ù…Ø§Ù†',0),(549400,15262,'tr','Tarih ve saat genel',0),(549401,15262,'pl','Data idealna czas ogÃ³lne',0),(549402,15262,'bg','Ð”Ð°Ñ‚Ð° & Ð²Ñ€ÐµÐ¼Ðµ Ð³ÐµÐ½ÐµÑ€Ð°Ð»',0),(549403,15262,'ur','ØªØ§Ø±ÛŒØ® & ÙˆÙ‚Øª Ø¬Ù†Ø±Ù„',0),(549404,15262,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸ Ð²Ñ€ÐµÐ¼Ðµ Ð“ÐµÐ½ÐµÑ€Ð°Ð»',0),(549405,15262,'vi','NgÃ y & thá»i gian tá»•ng',0),(549406,15262,'af','Datum en tyd algemene',0),(549407,15262,'ro','Data & timp General',0),(549408,15262,'et','KuupÃ¤ev- & aeg General',0),(549409,15262,'si','Datum & Äas sploÅ¡no',0),(549410,15262,'ba','Tanggal & waktu umum',0),(549411,15262,'nl','Datum & tijd generaal',0),(549412,15262,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ & aika yleinen',0),(549413,15262,'no','Dato & tid generelt',0),(549414,15262,'da','Dato & tid General',0),(549415,15262,'ko','ë‚ ì§œ ë° ì‹œê°„ ì¼ë°˜',0),(549416,15262,'he','×ª××¨×™×š & ×–×ž×Ÿ ×›×œ×œ×™',0),(549417,15262,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± & Ï‡ÏÏŒÎ½Î¿ Î³ÎµÎ½Î¹ÎºÎ®Ï‚',0),(549418,15262,'zh','æ—¥æœŸåŠæ—¶é—´ä¸€èˆ¬',0),(549419,15262,'sv','Datum & tid General',0),(549420,15262,'it','Data & tempo generale',0),(549421,15262,'tl','',0),(549422,15262,'th','à¸§à¸±à¸™à¸„à¸¸à¹‰à¸¡à¸„à¹ˆà¸²à¹€à¸§à¸¥à¸²à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(549423,15262,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• & à¤¸à¤®à¤¯ à¤œà¤¨à¤°à¤²',0),(549424,15262,'ms','Tarikh & masa am',0),(549425,15262,'ar','ØªØ§Ø±ÙŠØ® & Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ø¹Ø§Ù…Ø©',0),(549426,15262,'fr','Date & temps gÃ©nÃ©ral',0),(549427,15262,'jp','æ—¥ä»˜ãƒ»æ™‚é–“ä¸€èˆ¬',0),(549428,15262,'pt','Data &amp; hora geral do',0),(549429,15262,'ru','Ð”Ð°Ñ‚Ð° & Ð²Ñ€ÐµÐ¼Ñ Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹',0),(549430,15262,'es','Fecha y hora General',0),(549431,15262,'de','Datum & Zeit allgemein',0),(549432,15262,'en','Date & Time General',0),(549433,15263,'is','',0),(549434,15263,'dr','ØªØ§Ø±ÛŒØ® & Ø²Ù…Ø§Ù† ISO',0),(549435,15263,'pr','ØªØ§Ø±ÛŒØ® & Ø²Ù…Ø§Ù† ISO',0),(549436,15263,'tr','Tarih ve saat ISO',0),(549437,15263,'pl','Data idealna czas ISO',0),(549438,15263,'bg','Ð”Ð°Ñ‚Ð° & Ð²Ñ€ÐµÐ¼Ðµ ISO',0),(549439,15263,'ur','ØªØ§Ø±ÛŒØ® & ÙˆÙ‚Øª Ø¢Ø¦ÛŒ Ø§ÛŒØ³ Ø§Ùˆ',0),(549440,15263,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸ Ð²Ñ€ÐµÐ¼Ðµ Ð˜Ð¡Ðž',0),(549441,15263,'vi','ISO ngÃ y & thá»i gian',0),(549442,15263,'af','Datum en tyd ISO',0),(549443,15263,'ro','Data & timp ISO',0),(549444,15263,'et','KuupÃ¤ev- & aeg ISO',0),(549445,15263,'si','Datum & Äas ISO',0),(549446,15263,'ba','Tanggal & waktu ISO',0),(549447,15263,'nl','Datum & tijd ISO',0),(549448,15263,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ & aika ISO',0),(549449,15263,'no','Dato & tid ISO',0),(549450,15263,'da','Dato & tid ISO',0),(549451,15263,'ko','ë‚ ì§œ ë° ì‹œê°„ì„ ISO',0),(549452,15263,'he','ISO ×ª××¨×™×š & ×–×ž×Ÿ',0),(549453,15263,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± & Ï‡ÏÏŒÎ½Î¿ ISO',0),(549454,15263,'zh','æ—¥æœŸåŠæ—¶é—´çš„ ISO',0),(549455,15263,'sv','Datum & tid ISO',0),(549456,15263,'it','Data & tempo ISO',0),(549457,15263,'tl','',0),(549458,15263,'th','à¸§à¸±à¸™à¸„à¸¸à¹‰à¸¡à¸„à¹ˆà¸²à¹€à¸§à¸¥à¸²à¸¡à¸²à¸•à¸£à¸à¸²à¸™ ISO',0),(549459,15263,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• & à¤¸à¤®à¤¯ à¤†à¤ˆà¤à¤¸à¤“',0),(549460,15263,'ms','Tarikh & masa ISO',0),(549461,15263,'ar','ØªØ§Ø±ÙŠØ® & Ø§Ù„ÙˆÙ‚Øª ISO',0),(549462,15263,'fr','ISO de date & fois',0),(549463,15263,'jp','æ—¥ä»˜ãƒ»æ™‚åˆ»ã® ISO',0),(549464,15263,'pt','Data e hora ISO',0),(549465,15263,'ru','Ð”Ð°Ñ‚Ð° & Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ ISO',0),(549466,15263,'es','Fecha y hora de la ISO',0),(549467,15263,'de','Datum & Zeit ISO',0),(549468,15263,'en','Date & Time ISO',0),(549469,15264,'is','',0),(549470,15264,'dr','ØªØ§Ø±ÛŒØ® & Ø²Ù…Ø§Ù† Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡',0),(549471,15264,'pr','ØªØ§Ø±ÛŒØ® & Ø²Ù…Ø§Ù† Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡',0),(549472,15264,'tr','Tarih ve zaman',0),(549473,15264,'pl','Data idealna razem nas',0),(549474,15264,'bg','Ð”Ð°Ñ‚Ð° & Ð²Ñ€ÐµÐ¼Ðµ Ð¡ÐÐ©',0),(549475,15264,'ur','ØªØ§Ø±ÛŒØ® & ÙˆÙ‚Øª Ø§Ù…Ø±ÛŒÚ©ÛŒ',0),(549476,15264,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¸ Ð²Ñ€ÐµÐ¼Ðµ Ð£.Ð¡.',0),(549477,15264,'vi','NgÃ y & thá»i gian chÃºng tÃ´i',0),(549478,15264,'af','Datum en tyd ons',0),(549479,15264,'ro','Data & timp ne',0),(549480,15264,'et','KuupÃ¤ev- & aega USA',0),(549481,15264,'si','Datum & Äas ZDA',0),(549482,15264,'ba','Tanggal & waktu kami',0),(549483,15264,'nl','Datum & tijd ons',0),(549484,15264,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ & aika objektimuoto',0),(549485,15264,'no','Dato & tid oss',0),(549486,15264,'da','Dato & tid os',0),(549487,15264,'ko','ë‚ ì§œ ë° ì‹œê°„ ë¯¸êµ­',0),(549488,15264,'he','×ª××¨×™×š & ×–×ž×Ÿ ×‘××¨×” ×‘',0),(549489,15264,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± & ÏŽÏÎ± Î—Î Î‘',0),(549490,15264,'zh','æ—¥æœŸåŠæ—¶é—´ç¾Žå›½',0),(549491,15264,'sv','Datum & tid oss',0),(549492,15264,'it','Data & Time US',0),(549493,15264,'tl','',0),(549494,15264,'th','à¸§à¸±à¸™à¸„à¸¸à¹‰à¸¡ à¸„à¹ˆà¸²à¹€à¸§à¸¥à¸²à¹€à¸£à¸²',0),(549495,15264,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• & à¤¸à¤®à¤¯ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾',0),(549496,15264,'ms','Tarikh & masa kita',0),(549497,15264,'ar','ØªØ§Ø±ÙŠØ® & Ù…Ø±Ø© Ø£Ù…Ø±ÙŠÙƒÙŠ',0),(549498,15264,'fr','Date & fois nous',0),(549499,15264,'jp','æ—¥ä»˜ãƒ»æ™‚é–“ç±³å›½',0),(549500,15264,'pt','Data e hora nos',0),(549501,15264,'ru','Ð”Ð°Ñ‚Ð° & Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð¡Ð¨Ð',0),(549502,15264,'es','Fecha y hora nos',0),(549503,15264,'de','Datum & Zeit uns',0),(549504,15264,'en','Date & Time US',0),(549505,15265,'is','',0),(549506,15265,'dr','A Ø§Ø² Ø¬Ø¯ÙˆÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(549507,15265,'pr','A Ø§Ø² Ø¬Ø¯ÙˆÙ„ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(549508,15265,'tr','A tablosundan seÃ§in',0),(549509,15265,'pl','Wybierz A z tabeli',0),(549510,15265,'bg','ÐžÑ‚Ð±Ñ€Ð°Ð½ A Ð¾Ñ‚ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(549511,15265,'ur','Ø§ÛŒÚ© Ø¬Ø¯ÙˆÙ„ Ø³Û’ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(549512,15265,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸ Ð Ð¸Ð· Ñ‚Ð°Ð±ÐµÐ»Ðµ',0),(549513,15265,'vi','Chá»n A tá»« báº£ng',0),(549514,15265,'af','Kies \'n uit tabel',0),(549515,15265,'ro','Selectati A din tabelul de',0),(549516,15265,'et','A tabelist valida',0),(549517,15265,'si','Izberite A iz tabele',0),(549518,15265,'ba','Pilih A dari tabel',0),(549519,15265,'nl','Selecteer A in tabel',0),(549520,15265,'fi','Valitse A-taulukosta',0),(549521,15265,'no','Velg en tabell',0),(549522,15265,'da','VÃ¦lg en tabel',0),(549523,15265,'ko','í…Œì´ë¸”ì—ì„œ Aë¥¼ ì„ íƒ',0),(549524,15265,'he','×‘×—×¨ × ×ž×”×˜×‘×œ×”',0),(549525,15265,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ A Î±Ï€ÏŒ Ï€Î¯Î½Î±ÎºÎ±',0),(549526,15265,'zh','ä»Žè¡¨ä¸­é€‰æ‹© A',0),(549527,15265,'sv','VÃ¤lj en tabell',0),(549528,15265,'it','Selezionare una tabella',0),(549529,15265,'tl','',0),(549530,15265,'th','à¹€à¸¥à¸·à¸­à¸ A à¸ˆà¸²à¸à¸•à¸²à¸£à¸²à¸‡',0),(549531,15265,'hi','A à¤¸à¥‡ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(549532,15265,'ms','Pilih A dari jadual',0),(549533,15265,'ar','Ø­Ø¯Ø¯ A Ù…Ù† Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(549534,15265,'fr','SÃ©lectionner A partir de Table',0),(549535,15265,'jp','ãƒ†ãƒ¼ãƒ–ãƒ«ã‹ã‚‰é¸æŠžã—ã¾ã™ã€‚',0),(549536,15265,'pt','Selecione A tabela',0),(549537,15265,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ A Ð¸Ð· Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(549538,15265,'es','Seleccionar una de',0),(549539,15265,'de','A aus der Tabelle auswÃ¤hlen',0),(549540,15265,'en','Select A From Table',0),(549541,15266,'is','',0),(549542,15266,'dr','Ø¬Ù…Ø¹Ù‡',0),(549543,15266,'pr','Ø¬Ù…Ø¹Ù‡',0),(549544,15266,'tr','Cuma',0),(549545,15266,'pl','PiÄ…tek',0),(549546,15266,'bg','ÐŸÐµÑ‚ÑŠÐº',0),(549547,15266,'ur','Ø¬Ù…Ø¹Û',0),(549548,15266,'sr','Ð£ Ð¿ÐµÑ‚Ð°Ðº',0),(549549,15266,'vi','Thá»© sÃ¡u',0),(549550,15266,'af','Vrydag',0),(549551,15266,'ro','Vineri',0),(549552,15266,'et','Reede',0),(549553,15266,'si','Petek',0),(549554,15266,'ba','Jumat',0),(549555,15266,'nl','Vrijdag',0),(549556,15266,'fi','Perjantai',0),(549557,15266,'no','Fredag',0),(549558,15266,'da','Fredag',0),(549559,15266,'ko','ê¸ˆìš”ì¼',0),(549560,15266,'he','×™×•× ×©×™×©×™',0),(549561,15266,'el','Î Î±ÏÎ±ÏƒÎºÎµÏ…Î®',0),(549562,15266,'zh','æ˜ŸæœŸäº”',0),(549563,15266,'sv','Fredag',0),(549564,15266,'it','VenerdÃ¬',0),(549565,15266,'tl','',0),(549566,15266,'th','à¸§à¸±à¸™à¸¨à¸¸à¸à¸£à¹Œ',0),(549567,15266,'hi','à¤¶à¥à¤•à¥à¤°à¤µà¤¾à¤°',0),(549568,15266,'ms','Hari Jumaat',0),(549569,15266,'ar','Ø§Ù„Ø¬Ù…Ø¹Ø©',0),(549570,15266,'fr','Vendredi',0),(549571,15266,'jp','é‡‘æ›œæ—¥',0),(549572,15266,'pt','Sexta-feira',0),(549573,15266,'ru','ÐŸÑÑ‚Ð½Ð¸Ñ†Ð°',0),(549574,15266,'es','Viernes',0),(549575,15266,'de','Freitag',0),(549576,15266,'en','Friday',0),(549577,15267,'is','',0),(549578,15267,'dr','Ù‡ÙØªÙ‡ Ø´Ø±ÙˆØ¹ Ù…ÛŒ Ø´ÙˆØ¯ Ø¯Ø±',0),(549579,15267,'pr','Ù‡ÙØªÙ‡ Ø´Ø±ÙˆØ¹ Ù…ÛŒ Ø´ÙˆØ¯ Ø¯Ø±',0),(549580,15267,'tr','Hafta baÅŸlamak Ã¼stÃ¼nde',0),(549581,15267,'pl','TydzieÅ„ rozpoczyna siÄ™',0),(549582,15267,'bg','Ð¡ÐµÐ´Ð¼Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð½Ð°',0),(549583,15267,'ur','ÛÙØªÛ’ Ù…ÛŒÚº Ø´Ø±ÙˆØ¹ ÛÙˆØªØ§ ÛÛ’',0),(549584,15267,'sr','ÐÐµÐ´ÐµÑ™Ñƒ Ð´Ð°Ð½Ð° Ð¿Ð¾Ñ‡Ð¸ÑšÐµ',0),(549585,15267,'vi','Tuáº§n báº¯t Ä‘áº§u vÃ o',0),(549586,15267,'af','Week begin op',0),(549587,15267,'ro','SÄƒptÄƒmÃ¢na Ã®ncepe',0),(549588,15267,'et','NÃ¤dala algus',0),(549589,15267,'si','Teden se zaÄne na',0),(549590,15267,'ba','Minggu dimulai pada',0),(549591,15267,'nl','Week begint op',0),(549592,15267,'fi','Viikko alkaa',0),(549593,15267,'no','Uken starter pÃ¥',0),(549594,15267,'da','Ugen starter pÃ¥',0),(549595,15267,'ko','ì£¼ ì‹œìž‘',0),(549596,15267,'he','×”×©×‘×•×¢ ×ž×ª×—×™×œ ×‘×™×•×',0),(549597,15267,'el','Î‘ÏÏ‡Î® ÎµÎ²Î´Î¿Î¼Î¬Î´Î±Ï‚',0),(549598,15267,'zh','ä¸Šæ˜ŸæœŸå¼€å§‹',0),(549599,15267,'sv','Veckan bÃ¶rjar pÃ¥',0),(549600,15267,'it','Inizio di settimana su',0),(549601,15267,'tl','',0),(549602,15267,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œà¹ƒà¸™',0),(549603,15267,'hi','à¤ªà¤° à¤¸à¤ªà¥à¤¤à¤¾à¤¹ à¤¶à¥à¤°à¥‚',0),(549604,15267,'ms','Minggu bermula pada',0),(549605,15267,'ar','ÙŠØ¨Ø¯Ø£ Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹ ÙÙŠ',0),(549606,15267,'fr','La semaine commence le',0),(549607,15267,'jp','1 é€±é–“ã‚’é–‹å§‹',0),(549608,15267,'pt','Semana comeÃ§a na',0),(549609,15267,'ru','ÐÐµÐ´ÐµÐ»Ñ Ð½Ð°Ñ‡Ð¸Ð½Ð°ÐµÑ‚ÑÑ Ð½Ð°',0),(549610,15267,'es','La semana comienza en',0),(549611,15267,'de','Woche beginnt am',0),(549612,15267,'en','Week Starts On',0),(549613,15268,'is','',0),(549614,15268,'dr','Ú†Ù‡Ø§Ø± Ø´Ù†Ø¨Ù‡',0),(549615,15268,'pr','Ú†Ù‡Ø§Ø± Ø´Ù†Ø¨Ù‡',0),(549616,15268,'tr','Ã‡arÅŸamba',0),(549617,15268,'pl','Åšroda',0),(549618,15268,'bg','Ð¡Ñ€ÑÐ´Ð°',0),(549619,15268,'ur','Ø¨Ø¯Ú¾ Ú©Û’ Ø±ÙˆØ²',0),(549620,15268,'sr','Ð£ ÑÑ€ÐµÐ´Ñƒ',0),(549621,15268,'vi','Thá»© tÆ°',0),(549622,15268,'af','Woensdag',0),(549623,15268,'ro','Miercuri',0),(549624,15268,'et','KolmapÃ¤ev',0),(549625,15268,'si','Sreda',0),(549626,15268,'ba','Rabu',0),(549627,15268,'nl','Woensdag',0),(549628,15268,'fi','Keskiviikko',0),(549629,15268,'no','Onsdag',0),(549630,15268,'da','Onsdag',0),(549631,15268,'ko','ìˆ˜ìš”ì¼',0),(549632,15268,'he','×¨×‘×™×¢×™',0),(549633,15268,'el','Î¤ÎµÏ„Î¬ÏÏ„Î·',0),(549634,15268,'zh','æ˜ŸæœŸä¸‰',0),(549635,15268,'sv','Onsdag',0),(549636,15268,'it','MercoledÃ¬',0),(549637,15268,'tl','',0),(549638,15268,'th','à¸§à¸±à¸™à¸žà¸¸à¸˜',0),(549639,15268,'hi','à¤¬à¥à¤§à¤µà¤¾à¤°',0),(549640,15268,'ms','Rabu',0),(549641,15268,'ar','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡',0),(549642,15268,'fr','Mercredi',0),(549643,15268,'jp','(æ°´æ›œæ—¥)',0),(549644,15268,'pt','Quarta-feira',0),(549645,15268,'ru','Ð¡Ñ€ÐµÐ´Ð°',0),(549646,15268,'es','MiÃ©rcoles',0),(549647,15268,'de','Mittwoch',0),(549648,15268,'en','Wednesday',0),(549649,15269,'is','',0),(549650,15269,'dr','Ø³Ø§ÛŒØª ØªØºÛŒÛŒØ±',0),(549651,15269,'pr','Ø³Ø§ÛŒØª ØªØºÛŒÛŒØ±',0),(549652,15269,'tr','DeÄŸiÅŸim sitesi',0),(549653,15269,'pl','Zmiana strony',0),(549654,15269,'bg','Ð•Ð²Ð¾Ð»ÑŽÑ†Ð¸Ñ Ð½Ð° ÑÐ°Ð¹Ñ‚Ð°',0),(549655,15269,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒ Ú©ÛŒ Ø³Ø§Ø¦Ù¹',0),(549656,15269,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(549657,15269,'vi','Thay Ä‘á»•i trang web',0),(549658,15269,'af','Verandering werf',0),(549659,15269,'ro','Schimbarea site-ului',0),(549660,15269,'et','Muuda saidi',0),(549661,15269,'si','Spremembe mesta',0),(549662,15269,'ba','Ganti situs',0),(549663,15269,'nl','Verandering Site',0),(549664,15269,'fi','Vaihda toimipaikkaa',0),(549665,15269,'no','Endre omrÃ¥det',0),(549666,15269,'da','Ã†ndre Site',0),(549667,15269,'ko','ë³€ê²½ ì‚¬ì´íŠ¸',0),(549668,15269,'he','×©×™× ×•×™ ××ª×¨',0),(549669,15269,'el','Î‘Î»Î»Î±Î³Î® Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±Ï‚',0),(549670,15269,'zh','æ›´æ”¹ç½‘ç«™',0),(549671,15269,'sv','Ã„ndra platsen',0),(549672,15269,'it','Sito di cambiamento',0),(549673,15269,'tl','',0),(549674,15269,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹„à¸‹à¸•à¹Œ',0),(549675,15269,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤¾à¤‡à¤Ÿ',0),(549676,15269,'ms','Tukar lokasi',0),(549677,15269,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(549678,15269,'fr','Changement de Site',0),(549679,15269,'jp','ã‚µã‚¤ãƒˆã®å¤‰æ›´',0),(549680,15269,'pt','Mudar para outro local',0),(549681,15269,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ ÑÐ°Ð¹Ñ‚Ð°',0),(549682,15269,'es','Cambio de sitio',0),(549683,15269,'de','Ã„nderung Website',0),(549684,15269,'en','Change Site',0),(549685,15270,'is','',0),(549686,15270,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙØ¹Ù„ÛŒ Ø´Ø±Ú©Øª',0),(549687,15270,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙØ¹Ù„ÛŒ Ø´Ø±Ú©Øª',0),(549688,15270,'tr','GeÃ§erli ÅŸirket kimliÄŸi',0),(549689,15270,'pl','Identyfikator firmy prÄ…du',0),(549690,15270,'bg','Ð˜Ð” Ð½Ð° Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ñ„Ð¸Ñ€Ð¼Ð°',0),(549691,15270,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ú©Ù…Ù¾Ù†ÛŒ Ø¢Ø¦ÛŒ ÚˆÛŒ',0),(549692,15270,'sr','Ð¡Ñ‚Ñ€ÑƒÑ˜Ð° ÐœÐ°Ñ‚Ð¸Ñ‡Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(549693,15270,'vi','Hiá»‡n táº¡i cÃ´ng ty ID',0),(549694,15270,'af','Huidige maatskappy ID',0),(549695,15270,'ro','Compania actualÄƒ ID',0),(549696,15270,'et','Praeguse ettevÃµtte ID',0),(549697,15270,'si','Trenutno podjetje ID',0),(549698,15270,'ba','Saat ini perusahaan ID',0),(549699,15270,'nl','Huidige bedrijfs-ID',0),(549700,15270,'fi','Nykyisen yrityksen tunnus',0),(549701,15270,'no','Gjeldende firma-ID',0),(549702,15270,'da','NuvÃ¦rende firma-ID',0),(549703,15270,'ko','í˜„ìž¬ íšŒì‚¬ ID',0),(549704,15270,'he','×ž×–×”×” ×—×‘×¨×” ×”× ×•×›×—×™',0),(549705,15270,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎµÏ„Î±Î¹ÏÎµÎ¯Î± ID',0),(549706,15270,'zh','å½“å‰å…¬å¸ ID',0),(549707,15270,'sv','Aktuella fÃ¶retags-ID',0),(549708,15270,'it','ID societÃ  corrente',0),(549709,15270,'tl','',0),(549710,15270,'th','à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¸›à¸£à¸°à¸Šà¸²à¸Šà¸™',0),(549711,15270,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤‚à¤ªà¤¨à¥€ ID',0),(549712,15270,'ms','ID Syarikat semasa',0),(549713,15270,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(549714,15270,'fr','ID de la compagnie actuelle',0),(549715,15270,'jp','ç¾åœ¨ã®ä¼šç¤¾ ID',0),(549716,15270,'pt','Empresa de corrente ID',0),(549717,15270,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ñ‚ÐµÐºÑƒÑ‰ÐµÐ¹ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(549718,15270,'es','IdentificaciÃ³n de la empresa actual',0),(549719,15270,'de','Aktuelle Firma ID',0),(549720,15270,'en','Current Company ID',0),(549721,15271,'is','',0),(549722,15271,'dr','Ø´Ù†Ø§Ø³Ù‡ Ú©Ø§Ø±Ø¨Ø± ÙØ¹Ù„ÛŒ',0),(549723,15271,'pr','Ø´Ù†Ø§Ø³Ù‡ Ú©Ø§Ø±Ø¨Ø± ÙØ¹Ù„ÛŒ',0),(549724,15271,'tr','GeÃ§erli kullanÄ±cÄ± kimliÄŸi',0),(549725,15271,'pl','BieÅ¼Ä…cy identyfikator uÅ¼ytkownika',0),(549726,15271,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸Ñ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(549727,15271,'ur','Ø­Ø§Ù„ÛŒÛ ØµØ§Ø±Ù Ø¢Ø¦ÛŒ ÚˆÛŒ',0),(549728,15271,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð˜Ð” ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(549729,15271,'vi','ID ngÆ°á»i dÃ¹ng hiá»‡n táº¡i',0),(549730,15271,'af','Huidige gebruiker ID',0),(549731,15271,'ro','Curent User ID',0),(549732,15271,'et','Praeguse kasutaja ID',0),(549733,15271,'si','Trenutni ID uporabnika',0),(549734,15271,'ba','ID pengguna saat ini',0),(549735,15271,'nl','Huidige gebruikersnaam',0),(549736,15271,'fi','Nykyinen kÃ¤yttÃ¤jÃ¤tunnus',0),(549737,15271,'no','Gjeldende bruker-ID',0),(549738,15271,'da','Aktuelle bruger-ID',0),(549739,15271,'ko','í˜„ìž¬ ì‚¬ìš©ìž ID',0),(549740,15271,'he','×ž×–×”×” ×”×ž×©×ª×ž×© ×”× ×•×›×—×™',0),(549741,15271,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï„ÏÎ­Ï‡Î¿Î½Ï„Î± Ï‡ÏÎ®ÏƒÏ„Î·',0),(549742,15271,'zh','å½“å‰ç”¨æˆ· ID',0),(549743,15271,'sv','Aktuella anvÃ¤ndar-ID',0),(549744,15271,'it','ID utente corrente',0),(549745,15271,'tl','',0),(549746,15271,'th','ID à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(549747,15271,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ ID',0),(549748,15271,'ms','ID pengguna semasa',0),(549749,15271,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(549750,15271,'fr','ID de l\'utilisateur actuel',0),(549751,15271,'jp','ç¾åœ¨ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ ID',0),(549752,15271,'pt','ID do usuÃ¡rio atual',0),(549753,15271,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ð¹ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(549754,15271,'es','ID de usuario actual',0),(549755,15271,'de','Aktuelle Benutzer-ID',0),(549756,15271,'en','Current User ID',0),(549757,15272,'is','',0),(549758,15272,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¬Ù…Ø¹',0),(549759,15272,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¬Ù…Ø¹',0),(549760,15272,'tr','Genel toplamlarÄ± gÃ¶ster',0),(549761,15272,'pl','/ PokaÅ¼ sumy',0),(549762,15272,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¾Ð±Ñ‰Ð¸Ñ‚Ðµ ÑÑƒÐ¼Ð¸',0),(549763,15272,'ur','Ù…ÛŒØ²Ø§Ù† Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(549764,15272,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð·Ð±Ð¸Ñ€Ð¾Ð²Ðµ',0),(549765,15272,'vi','Tá»•ng sá»‘ hiá»ƒn thá»‹',0),(549766,15272,'af','Totale wys',0),(549767,15272,'ro','AratÄƒ totaluri',0),(549768,15272,'et','NÃ¤ita kokkuvÃµtted',0),(549769,15272,'si','PokaÅ¾i vsote',0),(549770,15272,'ba','Total Tampilkan',0),(549771,15272,'nl','Totalen weergeven',0),(549772,15272,'fi','NÃ¤ytÃ¤ summat',0),(549773,15272,'no','Vis totaler',0),(549774,15272,'da','Vis totaler',0),(549775,15272,'ko','í•©ê³„ í‘œì‹œ',0),(549776,15272,'he','×”×¦×’ ×¡×›×•×ž×™×',0),(549777,15272,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÏ…Î½ÏŒÎ»Ï‰Î½',0),(549778,15272,'zh','æ˜¾ç¤ºæ€»è®¡',0),(549779,15272,'sv','Visa summor',0),(549780,15272,'it','Mostra totali',0),(549781,15272,'tl','',0),(549782,15272,'th','à¹à¸ªà¸”à¸‡à¸œà¸¥à¸£à¸§à¸¡',0),(549783,15272,'hi','à¤¯à¥‹à¤— à¤¦à¤¿à¤–à¤¾à¤à¤',0),(549784,15272,'ms','Menunjukkan jumlah',0),(549785,15272,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª',0),(549786,15272,'fr','Afficher les totaux',0),(549787,15272,'jp','åˆè¨ˆã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(549788,15272,'pt','Mostrar os totais',0),(549789,15272,'ru','ÐŸÐ¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ Ð¸Ñ‚Ð¾Ð³Ð¸',0),(549790,15272,'es','Ver todos los resultados',0),(549791,15272,'de','Anzeigen von Summen',0),(549792,15272,'en','Show Totals',0),(549793,15273,'is','',0),(549794,15273,'dr','Ù‡ÛŒÚ† Ø§Ù†ØªØ®Ø§Ø¨',0),(549795,15273,'pr','Ù‡ÛŒÚ† Ø§Ù†ØªØ®Ø§Ø¨',0),(549796,15273,'tr','YapÄ±lan seÃ§im',0),(549797,15273,'pl','Nie wybÃ³r',0),(549798,15273,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÐ½Ð° ÑÐµÐ»ÐµÐºÑ†Ð¸Ñ',0),(549799,15273,'ur','Ú©ÛŒØ§ Ú©ÙˆØ¦ÛŒ Ø§Ù†ØªØ®Ø§Ø¨',0),(549800,15273,'sr','ÐÐµÐ¼Ð° Ð¸Ð·Ð±Ð¾Ñ€ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ð¾',0),(549801,15273,'vi','KhÃ´ng cÃ³ lá»±a chá»n thá»±c hiá»‡n',0),(549802,15273,'af','Geen seleksie gemaak',0),(549803,15273,'ro','Nicio selecÅ£ie fÄƒcutÄƒ',0),(549804,15273,'et','Valikuid pole tehtud',0),(549805,15273,'si','Ni izbire, ki',0),(549806,15273,'ba','Tidak ada pilihan yang dibuat',0),(549807,15273,'nl','Geen selectie gemaakt',0),(549808,15273,'fi','Ei valintaa',0),(549809,15273,'no','Ikke valgt',0),(549810,15273,'da','Ingen valg',0),(549811,15273,'ko','ì—†ìŒ ì„ íƒ',0),(549812,15273,'he','××™×Ÿ ×‘×—×™×¨×” ×©×‘×•×¦×¢×”',0),(549813,15273,'el','ÎšÎ±Î¼Î¯Î± ÎµÏ€Î¹Î»Î¿Î³Î® Ï€Î¿Ï… Î³Î¯Î½ÎµÏ„Î±Î¹',0),(549814,15273,'zh','æœªé€‰æ‹©ä»»ä½•å†…å®¹',0),(549815,15273,'sv','Inget val gjort',0),(549816,15273,'it','Nessuna selezione',0),(549817,15273,'tl','',0),(549818,15273,'th','à¹„à¸¡à¹ˆà¹€à¸¥à¸·à¸­à¸',0),(549819,15273,'hi','à¤•à¥‹à¤ˆ à¤šà¤¯à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤ à¤—à¤',0),(549820,15273,'ms','Tiada pilihan yang dibuat',0),(549821,15273,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªØ­Ø¯ÙŠØ¯ Ø£Ø¯Ù„Ù‰',0),(549822,15273,'fr','Aucune sÃ©lection effectuÃ©e',0),(549823,15273,'jp','é¸æŠžã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(549824,15273,'pt','Nenhuma seleÃ§Ã£o feita',0),(549825,15273,'ru','ÐÐ¸Ñ‡ÐµÐ³Ð¾ Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð¾',0),(549826,15273,'es','Ninguna selecciÃ³n realizada',0),(549827,15273,'de','Keine Auswahl getroffen',0),(549828,15273,'en','No Selection Made',0),(549829,15274,'is','',0),(549830,15274,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø´Ø§Ù…Ù„ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ø­Ø°Ù Ø´Ø¯Ù‡ & ÙØ¹Ø§Ù„',0),(549831,15274,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø´Ø§Ù…Ù„ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ø­Ø°Ù Ø´Ø¯Ù‡ & ÙØ¹Ø§Ù„',0),(549832,15274,'tr','Rapor silinmiÅŸ ve etkin veri iÃ§erir',0),(549833,15274,'pl','Raport zawiera dane usuniÄ™te idealna aktywnych',0),(549834,15274,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ÑŠÑ‚ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ & Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(549835,15274,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ù…ÛŒÚº Ø­Ø°Ù Ø´Ø¯Û & Ø²ÛŒØ± Ø¹Ù…Ù„ Ú©ÙˆØ§Ø¦Ù Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(549836,15274,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÑÐ°Ð´Ñ€Ð¶Ð¸ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ & Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¸Ñ… Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(549837,15274,'vi','BÃ¡o cÃ¡o bao gá»“m dá»¯ liá»‡u bá»‹ xÃ³a & hoáº¡t Ä‘á»™ng',0),(549838,15274,'af','Verslag sluit beide geskrap & aktiewe Data',0),(549839,15274,'ro','Raportul include atÃ¢t ÅŸterse & activ date',0),(549840,15274,'et','Aruanne sisaldab kustutatud- & aktiivne andmete',0),(549841,15274,'si','PoroÄilo vkljuÄuje izbrisanih & aktivni podatki',0),(549842,15274,'ba','Laporan ini mencakup Data dihapus & aktif',0),(549843,15274,'nl','Verslag omvat zowel verwijderde & actieve gegevens',0),(549844,15274,'fi','Raportti sisÃ¤ltÃ¤Ã¤ poistettujen & aktiivinen Tietoa',0),(549845,15274,'no','Rapporten inkluderer bÃ¥de slettede & aktive Data',0),(549846,15274,'da','Rapporten indeholder bÃ¥de slettede & aktive Data',0),(549847,15274,'ko','ì‚­ì œ ë° í™œì„± ë°ì´í„°ë¥¼ í¬í•¨ í•˜ëŠ” ë³´ê³ ì„œ',0),(549848,15274,'he','×”×“×•×— ×›×•×œ×œ × ×ª×•× ×™× ×©× ×ž×—×§×• & ×¤×¢×™×œ',0),(549849,15274,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Ï„ÏŒÏƒÎ¿ Î´Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î± & ÎµÎ½ÎµÏÎ³ÏŒ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(549850,15274,'zh','æŠ¥å‘ŠåŒ…æ‹¬å·²åˆ é™¤ & æ´»è·ƒæ•°æ®',0),(549851,15274,'sv','Rapporten innehÃ¥ller bÃ¥de borttagna & Active Data',0),(549852,15274,'it','Rapporto include dati sia eliminati & attivi',0),(549853,15274,'tl','',0),(549854,15274,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸¡à¸µà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¥à¸š à¸ªà¸³à¸£à¸­à¸‡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(549855,15274,'hi','à¤¦à¥‹à¤¨à¥‹à¤‚ à¤¨à¤·à¥à¤Ÿ à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ & à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤¡à¥‡à¤Ÿà¤¾ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(549856,15274,'ms','Laporan mengandungi Data yang dipadam & aktif',0),(549857,15274,'ar','ÙˆÙŠØªØ¶Ù…Ù† Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© & Ù†Ø´Ø·Ø© Ø¹Ù„Ù‰ Ø­Ø¯ Ø³ÙˆØ§Ø¡',0),(549858,15274,'fr','Rapport comprend des donnÃ©es aussi bien supprimÃ©es & Active',0),(549859,15274,'jp','å‰Šé™¤ã•ã‚ŒãŸãƒ» ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªãƒ‡ãƒ¼ã‚¿ãŒãƒ¬ãƒãƒ¼ãƒˆã«å«ã¾ã‚Œã¦ã„ã¾ã™',0),(549860,15274,'pt','RelatÃ³rio inclui dados excluÃ­dos & ativos',0),(549861,15274,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ Ð²ÐºÐ»ÑŽÑ‡Ð°ÐµÑ‚ Ð² ÑÐµÐ±Ñ ÑƒÐ´Ð°Ð»ÐµÐ½Ð½Ñ‹Ðµ & Ð°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ñ… Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(549862,15274,'es','Informe incluye los datos eliminados y activados',0),(549863,15274,'de','Bericht enthÃ¤lt sowohl gelÃ¶schte & aktive Daten',0),(549864,15274,'en','Report Includes Both Deleted & Active Data',0),(549865,15275,'is','',0),(549866,15275,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø§Ø² Ú†Ù†Ø¯ Ø´Ø±Ú©Øª Ø´Ø§Ù…Ù„',0),(549867,15275,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¯Ø§Ø¯Ù‡ Ø§Ø² Ú†Ù†Ø¯ Ø´Ø±Ú©Øª Ø´Ø§Ù…Ù„',0),(549868,15275,'tr','Rapor birden Ã§ok ÅŸirket verileri iÃ§erir',0),(549869,15275,'pl','Raport zawiera dane z wielu firm',0),(549870,15275,'bg','ÐžÑ‚Ñ‡ÐµÑ‚ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¾Ñ‚ Ð¼Ð½Ð¾Ð¶ÐµÑÑ‚Ð²Ð¾ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(549871,15275,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ù…ÛŒÚº Ù…ØªØ¹Ø¯Ø¯ Ú©Ù…Ù¾Ù†ÛŒÙˆÚº Ø³Û’ ÚˆÛŒÙ¹Ø§ Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(549872,15275,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÑÐ°Ð´Ñ€Ð¶Ð¸ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¸Ð· Ð²Ð¸ÑˆÐµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(549873,15275,'vi','BÃ¡o cÃ¡o bao gá»“m cÃ¡c dá»¯ liá»‡u tá»« nhiá»u cÃ´ng ty',0),(549874,15275,'af','Verslag sluit Data van verskeie maatskappye',0),(549875,15275,'ro','Raportul include date de la mai multe companii',0),(549876,15275,'et','Aruanne sisaldab mitu ettevÃµtete andmete',0),(549877,15275,'si','PoroÄilo vkljuÄuje podatke iz veÄ podjetij',0),(549878,15275,'ba','Laporan ini mencakup Data dari beberapa perusahaan',0),(549879,15275,'nl','Rapport bevat gegevens uit meerdere bedrijven',0),(549880,15275,'fi','Raportti sisÃ¤ltÃ¤Ã¤ tietoa useita yrityksiÃ¤',0),(549881,15275,'no','Rapporten inneholder Data fra flere selskaper',0),(549882,15275,'da','Rapporten indeholder Data fra flere virksomheder',0),(549883,15275,'ko','ì—¬ëŸ¬ íšŒì‚¬ì—ì„œ ë°ì´í„°ë¥¼ í¬í•¨ í•˜ëŠ” ë³´ê³ ì„œ',0),(549884,15275,'he','×”×“×•×— ×›×•×œ×œ × ×ª×•× ×™× ×ž×—×‘×¨×•×ª ×ž×¨×•×‘×•×ª',0),(549885,15275,'el','ÎˆÎºÎ¸ÎµÏƒÎ· Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹ Î´ÎµÎ´Î¿Î¼Î­Î½Î± Î±Ï€ÏŒ Ï€Î¿Î»Î»Î±Ï€Î»Î­Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯ÎµÏ‚',0),(549886,15275,'zh','æŠ¥å‘ŠåŒ…æ‹¬æ¥è‡ªå¤šä¸ªå…¬å¸çš„æ•°æ®',0),(549887,15275,'sv','Rapporten innehÃ¥ller Data frÃ¥n flera fÃ¶retag',0),(549888,15275,'it','Rapporto include dati da piÃ¹ aziende',0),(549889,15275,'tl','',0),(549890,15275,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸¡à¸µà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ˆà¸²à¸à¸«à¸¥à¸²à¸¢ à¸šà¸£à¸´à¸©à¸±à¸—',0),(549891,15275,'hi','à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤à¤•à¤¾à¤§à¤¿à¤• à¤•à¤‚à¤ªà¤¨à¤¿à¤¯à¥‹à¤‚ à¤¸à¥‡ à¤¡à¤¾à¤Ÿà¤¾ à¤­à¥€ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆ',0),(549892,15275,'ms','Laporan ini mengandungi Data daripada pelbagai syarikat',0),(549893,15275,'ar','ÙˆÙŠØªØ¶Ù…Ù† Ø§Ù„ØªÙ‚Ø±ÙŠØ± Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ù…Ù† Ø´Ø±ÙƒØ§Øª Ù…ØªØ¹Ø¯Ø¯Ø©',0),(549894,15275,'fr','Rapport comprend des donnÃ©es de plusieurs entreprises',0),(549895,15275,'jp','ãƒ¬ãƒãƒ¼ãƒˆã«ã¯ã€è¤‡æ•°ã®ä¼æ¥­ã‹ã‚‰ã®ãƒ‡ãƒ¼ã‚¿ãŒå«ã¾ã‚Œã¦ã„ã¾ã™',0),(549896,15275,'pt','RelatÃ³rio inclui dados de vÃ¡rias empresas',0),(549897,15275,'ru','ÐžÑ‚Ñ‡ÐµÑ‚ ÑÐ¾Ð´ÐµÑ€Ð¶Ð¸Ñ‚ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð¸Ð· Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¸Ñ… ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¹',0),(549898,15275,'es','Informe incluye datos de mÃºltiples empresas',0),(549899,15275,'de','Bericht enthÃ¤lt Daten von mehreren Firmen',0),(549900,15275,'en','Report Includes Data From Multiple Companies',0),(549901,15276,'is','',0),(549902,15276,'dr','Ù…ÛŒØ² Ø¨Ø§ Ù„ØºÙˆ Ø²Ù…ÛŒÙ†Ù‡ Ø¨Ø¯ÙˆÙ† Ú©Ù†ØªØ±Ù„',0),(549903,15276,'pr','Ù…ÛŒØ² Ø¨Ø§ Ù„ØºÙˆ Ø²Ù…ÛŒÙ†Ù‡ Ø¨Ø¯ÙˆÙ† Ú©Ù†ØªØ±Ù„',0),(549904,15276,'tr','Ä°ptal alan denetlenmeyen tablolarla',0),(549905,15276,'pl','Tabele z Anuluj pole niezaznaczone',0),(549906,15276,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð¸ Ñ Ð¾Ñ‚ÐºÐ°Ð· Ð¿Ð¾Ð»ÐµÑ‚Ð¾ Ð½ÐµÐ¾Ñ‚Ð¼ÐµÑ‚Ð½Ð°Ñ‚Ð¾',0),(549907,15276,'ur','Ø¬Ø¯Ø§ÙˆÙ„ Ú©Ùˆ Ù…Ù†Ø³ÙˆØ® Ù‚Ø·Ø¹Û ØºÛŒØ± Ù¾Ú‘ØªØ§Ù„ Ø´Ø¯Û',0),(549908,15276,'sr','Ð¢Ð°Ð±ÐµÐ»Ðµ ÑÐ° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ð¾Ñ€ ÐžÑ‚ÐºÐ°Ð¶Ð¸ Ñƒ Ð¿Ð¾Ñ™Ñƒ',0),(549909,15276,'vi','Báº£ng vá»›i lÄ©nh vá»±c há»§y bá» Ä‘Ã¡nh dáº¥u',0),(549910,15276,'af','Tafels met kanselleer veld ongemerk',0),(549911,15276,'ro','Tabele cu anulare cÃ¢mp nebifatÄƒ',0),(549912,15276,'et','Loobu vÃ¤li mÃ¤rkimata tabelid',0),(549913,15276,'si','Tabele z PrekliÄi polje nepreverjene',0),(549914,15276,'ba','Meja dengan bidang Batal dicentang',0),(549915,15276,'nl','Tabellen met annuleren veld ongecontroleerde',0),(549916,15276,'fi','PÃ¶ydÃ¤t ja Peruuta kentÃ¤n tyhjÃ¤ksi',0),(549917,15276,'no','Tabeller med Avbryt feltet ukontrollert',0),(549918,15276,'da','Tabeller med Annuller felt ukontrolleret',0),(549919,15276,'ko','í™•ì¸ ë˜ì§€ ì•Šì€ ì·¨ì†Œ í•„ë“œì™€ í…Œì´ë¸”',0),(549920,15276,'he','×˜×‘×œ××•×ª ×¢× ×‘×™×˜×•×œ ×©×“×” ×œ× ×ž×¡×•×ž×Ÿ',0),(549921,15276,'el','Î Î¯Î½Î±ÎºÎµÏ‚ Î¼Îµ Î¬ÎºÏ…ÏÎ¿ Ï€ÎµÎ´Î¯Î¿ Î±Ï…Ï„ÏŒ Î±Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î¿',0),(549922,15276,'zh','å–æ¶ˆå­—æ®µæœªé€‰ä¸­çš„è¡¨',0),(549923,15276,'sv','Tabeller med Avbryt hÃ¤r fÃ¤ltet',0),(549924,15276,'it','Tabelle con Annulla campo deselezionato',0),(549925,15276,'tl','',0),(549926,15276,'th','à¸•à¸²à¸£à¸²à¸‡à¸—à¸µà¹ˆ à¸¡à¸µà¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¹ƒà¸™à¸Ÿà¸´à¸¥à¸”à¹Œà¸¢à¸à¹€à¸¥à¸´à¸',0),(549927,15276,'hi','\' à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚ \' à¤«à¤¼à¥€à¤²à¥à¤¡ à¤…à¤¨à¤¿à¤¯à¤‚à¤¤à¥à¤°à¤¿à¤¤ à¤µà¤¾à¤²à¥€ à¤¤à¤¾à¤²à¤¿à¤•à¤¾à¤à¤',0),(549928,15276,'ms','Jadual dengan medan Batal berdaftar',0),(549929,15276,'ar','Ø§Ù„Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ù„ØªÙŠ ØªØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ Ø­Ù‚Ù„ Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø£Ù…Ø± Ø¯ÙˆÙ† Ø±Ø§Ø¯Ø¹',0),(549930,15276,'fr','Tables avec Annuler champ dÃ©sactivÃ©',0),(549931,15276,'jp','ã‚ªãƒ• [ã‚­ãƒ£ãƒ³ã‚»ãƒ«] ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’æŒã¤ãƒ†ãƒ¼ãƒ–ãƒ«',0),(549932,15276,'pt','Tabelas com cancelar campo desmarcado',0),(549933,15276,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ñ Ð¿Ð¾Ð»ÐµÐ¼ Ð¾Ñ‚Ð¼ÐµÐ½Ð° ÑÐ½ÑÑ‚',0),(549934,15276,'es','Mesas con campo de cancelar un',0),(549935,15276,'de','Tabellen mit \"Abbrechen\" Feld',0),(549936,15276,'en','Tables With Cancel Field Unchecked',0),(549937,15277,'is','',0),(549938,15277,'dr','Ù…ÛŒØ² Ø¨Ø§ Ø´Ø±Ú©Øª Ø´Ù†Ø§Ø³Ù‡ Ø²Ù…ÛŒÙ†Ù‡ Ø¨Ø¯ÙˆÙ† Ú©Ù†ØªØ±Ù„',0),(549939,15277,'pr','Ù…ÛŒØ² Ø¨Ø§ Ø´Ø±Ú©Øª Ø´Ù†Ø§Ø³Ù‡ Ø²Ù…ÛŒÙ†Ù‡ Ø¨Ø¯ÙˆÙ† Ú©Ù†ØªØ±Ù„',0),(549940,15277,'tr','Åžirket kimliÄŸi alan denetlenmeyen tablolarla',0),(549941,15277,'pl','Tabele z firmy ID pole niezaznaczone',0),(549942,15277,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð¸ Ñ Ñ„Ð¸Ñ€Ð¼ÐµÐ½ Ð˜Ð” Ð¿Ð¾Ð»Ðµ Ð½ÐµÑ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½',0),(549943,15277,'ur','Ø¬Ø¯Ø§ÙˆÙ„ Ú©Ù…Ù¾Ù†ÛŒ Ø¢Ø¦ÛŒ ÚˆÛŒ Ø´Ø¹Ø¨Û’ ØºÛŒØ± Ù¾Ú‘ØªØ§Ù„ Ø´Ø¯Û',0),(549944,15277,'sr','Ð¢Ð°Ð±ÐµÐ»Ðµ ÑÐ° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð½Ð¸ Ð·Ð½Ð°Ðº ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð˜Ð” Ð¿Ð¾Ñ™Ðµ',0),(549945,15277,'vi','Báº£ng vá»›i trÆ°á»ng cÃ´ng ty ID khÃ´ng Ä‘Æ°á»£c kiá»ƒm soÃ¡t',0),(549946,15277,'af','Tafels met maatskappy ID veld ongemerk',0),(549947,15277,'ro','Tabele cu compania ID cÃ¢mp nebifatÄƒ',0),(549948,15277,'et','EttevÃµtte ID vÃ¤li mÃ¤rkimata tabelid',0),(549949,15277,'si','Tabele s poljem ID podjetja nepreverjene',0),(549950,15277,'ba','Tabel dengan ID perusahaan bidang dicentang',0),(549951,15277,'nl','Tabellen met bedrijfs-ID veld ongecontroleerde',0),(549952,15277,'fi','PÃ¶ydÃ¤t ja Yritystunnus kentÃ¤n tyhjÃ¤ksi',0),(549953,15277,'no','Tabeller med selskapet ID ukontrollert',0),(549954,15277,'da','Tabeller med firma-ID felt ukontrolleret',0),(549955,15277,'ko','íšŒì‚¬ ID í•„ë“œë¥¼ ì„ íƒ í•˜ì§€ ì•Šì€ í…Œì´ë¸”',0),(549956,15277,'he','×˜×‘×œ××•×ª ×¢× ×©×“×” ×ž×–×”×” ×—×‘×¨×” ×œ× ×ž×¡×•×ž×Ÿ',0),(549957,15277,'el','Î Î¯Î½Î±ÎºÎµÏ‚ Î¼Îµ ID ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Ï€ÎµÎ´Î¯Î¿ Î±Ï…Ï„ÏŒ Î±Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î¿',0),(549958,15277,'zh','å…¬å¸ ID å­—æ®µæœªé€‰ä¸­çš„è¡¨',0),(549959,15277,'sv','Tabeller med fÃ¶retags-ID hÃ¤r fÃ¤ltet',0),(549960,15277,'it','Tabelle con il campo ID societÃ  non controllato',0),(549961,15277,'tl','',0),(549962,15277,'th','à¸•à¸²à¸£à¸²à¸‡à¸—à¸µà¹ˆ à¸¡à¸µà¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¹ƒà¸™à¸Ÿà¸´à¸¥à¸”à¹Œà¸£à¸«à¸±à¸ªà¸‚à¸­à¸‡à¸šà¸£à¸´à¸©à¸±à¸—',0),(549963,15277,'hi','à¤•à¤‚à¤ªà¤¨à¥€ ID à¤«à¤¼à¥€à¤²à¥à¤¡ à¤…à¤¨à¤¿à¤¯à¤‚à¤¤à¥à¤°à¤¿à¤¤ à¤µà¤¾à¤²à¥€ à¤¤à¤¾à¤²à¤¿à¤•à¤¾à¤à¤',0),(549964,15277,'ms','Jadual dengan medan ID Syarikat berdaftar',0),(549965,15277,'ar','Ø§Ù„Ø¬Ø¯Ø§ÙˆÙ„ Ø§Ù„ØªÙŠ ØªØ­ØªÙˆÙŠ Ø¹Ù„Ù‰ Ø­Ù‚Ù„ Ù…Ø¹Ø±Ù Ø§Ù„Ø´Ø±ÙƒØ© Ø¯ÙˆÙ† Ø±Ø§Ø¯Ø¹',0),(549966,15277,'fr','Tables avec le champ Code sociÃ©tÃ© dÃ©cochÃ©e',0),(549967,15277,'jp','æŒè¾¼ä¼šç¤¾ ID ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’æŒã¤ãƒ†ãƒ¼ãƒ–ãƒ«',0),(549968,15277,'pt','Tabelas com empresa ID campo desmarcado',0),(549969,15277,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ñ‹ Ñ Ð¿Ð¾Ð»ÐµÐ¼ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ ÑÐ½ÑÑ‚',0),(549970,15277,'es','Tablas con el campo ID de empresa',0),(549971,15277,'de','Tabellen mit Firmenkennung Feld',0),(549972,15277,'en','Tables With Company ID Field Unchecked',0),(549973,15278,'is','',0),(549974,15278,'dr','3dcart ÙˆØ²Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(549975,15278,'pr','3dcart ÙˆØ²Ù† Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(549976,15278,'tr','3dcart aÄŸÄ±rlÄ±k baÅŸarÄ±yla alÄ±ndÄ±',0),(549977,15278,'pl','Å¹rÃ³dÅ‚o: pomyÅ›lnie wag 3dcart',0),(549978,15278,'bg','3dcart Ñ‚ÐµÐ³Ð»Ð°Ñ‚Ð°, Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(549979,15278,'ur','3dcart Ø¨Ø§Ù¹ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¨Ø§Ø² Ú¯ÛŒØ±',0),(549980,15278,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ñ‚ÐµÐ³Ð¾Ð²Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð°',0),(549981,15278,'vi','trá»ng lÆ°á»£ng 3dcart láº¥y thÃ nh cÃ´ng',0),(549982,15278,'af','3dcart gewigte suksesvol herwin',0),(549983,15278,'ro','3dcart greutÄƒÅ£i adus cu succes',0),(549984,15278,'et','3dcart kaaluvihtide vÃ¤lja otsitud edukalt',0),(549985,15278,'si','3dcart uteÅ¾i, uspeÅ¡no pridobljene.',0),(549986,15278,'ba','3dcart beban diperoleh berhasil',0),(549987,15278,'nl','3dcart gewichten ontvangen met succes',0),(549988,15278,'fi','3dcart painot onnistui',0),(549989,15278,'no','3dcart vekter vellykket',0),(549990,15278,'da','3dcart vÃ¦gte hentet med succes',0),(549991,15278,'ko','ì„±ê³µì ìœ¼ë¡œ ê²€ìƒ‰ í•˜ëŠ” 3dcart ë¬´ê²Œ',0),(549992,15278,'he','3dcart ×ž×©×§×•×œ×•×ª ×©××•×—×–×¨ ×‘×”×¦×œ×—×”',0),(549993,15278,'el','3dcart Î²Î¬ÏÎ· Î±Î½Î±ÎºÏ„Î·Î¸ÎµÎ¯ ÎµÏ€Î¹Ï„Ï…Ï‡ÏŽÏ‚',0),(549994,15278,'zh','3dcart é‡é‡æˆåŠŸæ£€ç´¢',0),(549995,15278,'sv','3dcart vikter HÃ¤mtad framgÃ¥ngsrikt',0),(549996,15278,'it','3Dcart pesi Estratto con successo',0),(549997,15278,'tl','',0),(549998,15278,'th','3dcart à¸™à¹‰à¸³à¸«à¸™à¸±à¸à¸”à¸¶à¸‡à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(549999,15278,'hi','3dcart à¤­à¤¾à¤° à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(550000,15278,'ms','3dcart berat diambil berjaya',0),(550001,15278,'ar','Ø£ÙˆØ²Ø§Ù† 3dcart Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(550002,15278,'fr','3Dcart poids extrait avec succÃ¨s',0),(550003,15278,'jp','æ­£å¸¸ã«å–å¾—ã•ã‚ŒãŸ 3dcart é‡ã¿',0),(550004,15278,'pt','3Dcart pesos obtidos com sucesso',0),(550005,15278,'ru','3dcart Ð²ÐµÑÐ¾Ð² ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(550006,15278,'es','3DCart pesos obtenidos con Ã©xito',0),(550007,15278,'de','3dcart Gewichte erfolgreich',0),(550008,15278,'en','3dcart Weights Retrieved Successfully',0),(550009,15279,'is','',0),(550010,15279,'dr','ÙˆØ²Ù† ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart',0),(550011,15279,'pr','ÙˆØ²Ù† ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart',0),(550012,15279,'tr','AÄŸÄ±rlÄ±k bu 3dcart deposundan almak',0),(550013,15279,'pl','PrzywÃ³z wag z tego sklepu 3dcart',0),(550014,15279,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐ¶ÐµÑÑ‚Ð¸ Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ 3dcart ÐœÐ°Ð³Ð°Ð·Ð¸Ð½',0),(550015,15279,'ur','Ø¨Ø§Ù¹ Ø§Ø³ 3dcart Ú©ÛŒ Ø¯Ú©Ø§Ù† Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(550016,15279,'sr','Ð¢ÐµÐ³Ð¾Ð²Ð¸ Ð·Ð° ÑƒÐ²Ð¾Ð· Ð¸Ð· Ð¾Ð²Ð¾Ð³ 3Ð´Ñ†Ð°Ñ€Ñ‚ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð°',0),(550017,15279,'vi','Nháº­p trá»ng lÆ°á»£ng tá»« cá»­a hÃ ng 3dcart nÃ y',0),(550018,15279,'af','Voer gewigte vanaf hierdie 3dcart Winkel',0),(550019,15279,'ro','Import de greutÄƒÅ£i la acest magazin 3dcart',0),(550020,15279,'et','Importida kaalu see 3dcart pood',0),(550021,15279,'si','Uvozne uteÅ¾i iz te shrambe 3dcart',0),(550022,15279,'ba','Impor beban dari toko 3dcart ini',0),(550023,15279,'nl','Gewichten van deze winkel 3dcart importeren',0),(550024,15279,'fi','Tuo painot 3dcart Store',0),(550025,15279,'no','Importere vekter fra denne 3dcart butikken',0),(550026,15279,'da','Importere vÃ¦gte fra denne 3dcart butik',0),(550027,15279,'ko','ì´ 3dcartê°€ ê²Œì—ì„œ ë¬´ê²Œë¥¼ ê°€ì ¸ì˜¤ê¸°',0),(550028,15279,'he','×™×™×‘×•× ×ž×©×§×•×œ×•×ª ×ž×”×—× ×•×ª 3dcart',0),(550029,15279,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î²Î¬ÏÎ· Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± 3dcart',0),(550030,15279,'zh','ä»Žè¿™ 3dcart å­˜å‚¨å¯¼å…¥çš„é‡é‡',0),(550031,15279,'sv','Importera vikter frÃ¥n denna 3dcart butik',0),(550032,15279,'it','Pesi di importazione da questo negozio 3dcart',0),(550033,15279,'tl','',0),(550034,15279,'th','à¸™à¹‰à¸³à¸«à¸™à¸±à¸à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸²à¸à¸£à¹‰à¸²à¸™ 3dcart à¸™à¸µà¹‰',0),(550035,15279,'hi','à¤µà¤œà¤¨ à¤•à¥‡ à¤‡à¤¸ 3dcart à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨ à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(550036,15279,'ms','Import berat dari kedai 3dcart ini',0),(550037,15279,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø£ÙˆØ²Ø§Ù† Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²Ù† 3dcart',0),(550038,15279,'fr','Importer le poids de ce magasin de 3dcart',0),(550039,15279,'jp','ã“ã® 3dcart ã‚¹ãƒˆã‚¢ã‹ã‚‰é‡ã¿ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(550040,15279,'pt','Pesos de importaÃ§Ã£o da loja 3dcart',0),(550041,15279,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¸Ð· ÑÑ‚Ð¾Ð³Ð¾ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð° 3dcart Ð²ÐµÑÐ¾Ð²',0),(550042,15279,'es','Pesos de la importaciÃ³n de esta tienda 3dcart',0),(550043,15279,'de','Import-Gewichte aus diesem 3dcart-Speicher',0),(550044,15279,'en','Import Weights From This 3dcart Store',0),(550045,15280,'is','',0),(550046,15280,'dr','ÙˆØ²Ù† ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ Ø§Ú¯Ø± Ù†Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(550047,15280,'pr','ÙˆØ²Ù† ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ Ø§Ú¯Ø± Ù†Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(550048,15280,'tr','Åžu anda ayarlanmÄ±ÅŸ deÄŸilse aÄŸÄ±rlÄ±klarÄ± alma',0),(550049,15280,'pl','PrzywÃ³z wag, jeÅ›li nie obecnie zestaw',0),(550050,15280,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐ¶ÐµÑÑ‚Ð¸, Ð°ÐºÐ¾ Ð½Ðµ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð°',0),(550051,15280,'ur','Ø¨Ø§Ù¹ Ø¯Ø±Ø¢Ù…Ø¯ Ù†ÛÛŒÚº ØªÙˆ Ø§Ø³ ÙˆÙ‚Øª Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(550052,15280,'sr','Ð£Ð²Ð¾Ð· Ñ‚ÐµÐ³Ð¾Ð²Ðµ Ð°ÐºÐ¾ Ð½Ðµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(550053,15280,'vi','Nháº­p trá»ng lÆ°á»£ng náº¿u khÃ´ng hiá»‡n Ä‘ang thiáº¿t láº­p',0),(550054,15280,'af','Gewigte invoer indien nie tans stel',0),(550055,15280,'ro','GreutÄƒÈ›ile de import dacÄƒ nu este Ã®n prezent stabilit',0),(550056,15280,'et','Raskused impordi kui mitte praegu seatud',0),(550057,15280,'si','Uvozne uteÅ¾i, Äe ne trenutno doloÄa',0),(550058,15280,'ba','Impor bobot jika tidak saat ini ditetapkan',0),(550059,15280,'nl','Importeren van gewichten als niet momenteel ingesteld',0),(550060,15280,'fi','Tuo painot, jos sitÃ¤ ei ole mÃ¤Ã¤ritetty',0),(550061,15280,'no','Importere vekter hvis ikke konfigurert',0),(550062,15280,'da','Importere vÃ¦gte, hvis ikke indstillet',0),(550063,15280,'ko','í˜„ìž¬ ì„¤ì • ë˜ì§€ ì•Šì€ ê²½ìš° ë¬´ê²Œë¥¼ ê°€ì ¸ì˜¤ê¸°',0),(550064,15280,'he','×™×™×‘×•× ×ž×©×§×•×œ×•×ª ×× ×œ× ×ž×•×’×“×¨×ª ×›×¢×ª',0),(550065,15280,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î²Î¬ÏÎ·, Î±Î½ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÎµÏ€Î¯ Ï„Î¿Ï… Ï€Î±ÏÏŒÎ½Ï„Î¿Ï‚ Î¿ÏÎ¯Î¶ÎµÏ„Î±Î¹',0),(550066,15280,'zh','å¯¼å…¥çš„é‡é‡ï¼Œå¦‚æžœä¸æ˜¯å½“å‰è®¾ç½®',0),(550067,15280,'sv','Importera vikter om inte fÃ¶r nÃ¤rvarande',0),(550068,15280,'it','Importare pesi se non attualmente impostato',0),(550069,15280,'tl','',0),(550070,15280,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸™à¹‰à¸³à¸«à¸™à¸±à¸à¸–à¹‰à¸² à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸‚à¸“à¸°à¸™à¸µà¹‰',0),(550071,15280,'hi','à¤¤à¥Œà¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚ à¤¯à¤¦à¤¿ à¤¨à¤¹à¥€à¤‚ à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(550072,15280,'ms','Import berat jika tidak buat masa ini menetapkan',0),(550073,15280,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø£ÙˆØ²Ø§Ù† Ù„Ù… ÙŠÙƒÙ† ØªØ¹ÙŠÙŠÙ† Ø­Ø§Ù„ÙŠØ§',0),(550074,15280,'fr','Importer des poids si ce n\'est actuellement dÃ©fini',0),(550075,15280,'jp','ç¾åœ¨è¨­å®šã•ã‚Œã¦ã„ãªã„å ´åˆã®é‡ã¿ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(550076,15280,'pt','Pesos de importaÃ§Ã£o se nÃ£o definido atualmente',0),(550077,15280,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð²ÐµÑÐ¾Ð², ÐµÑÐ»Ð¸ Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(550078,15280,'es','Pesos de importaciÃ³n, si no actualmente',0),(550079,15280,'de','Gewichte zu importieren, wenn nicht derzeit eingestellt',0),(550080,15280,'en','Import Weights If Not Currently Set',0),(550081,15281,'is','',0),(550082,15281,'dr','3dcart Ù†Ø§Ù… Ù…Ø­ØµÙˆÙ„ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(550083,15281,'pr','3dcart Ù†Ø§Ù… Ù…Ø­ØµÙˆÙ„ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(550084,15281,'tr','3dcart Ã¼rÃ¼n adlarÄ± otomatik olarak gÃ¼ncelleÅŸtir',0),(550085,15281,'pl','Automatyczna aktualizacja nazwy produktu 3dcart',0),(550086,15281,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° 3dcart Ð¸Ð¼ÐµÐ½Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸',0),(550087,15281,'ur','3dcart Ù…ØµÙ†ÙˆØ¹Ø§Øª Ù†Ø§Ù… Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(550088,15281,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¸Ð¼ÐµÐ½Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(550089,15281,'vi','Tá»± Ä‘á»™ng Cáº­p Nháº­t 3dcart tÃªn sáº£n pháº©m',0),(550090,15281,'af','3dcart produk name outomaties opdateer',0),(550091,15281,'ro','Actualiza automat nume de produs 3dcart',0),(550092,15281,'et','3dcart toodete nimed automaatselt uuendada',0),(550093,15281,'si','Samodejno posodabljanje imena izdelkov 3dcart',0),(550094,15281,'ba','Memperbarui nama produk 3dcart secara otomatis',0),(550095,15281,'nl','3dcart productnamen automatisch bijwerken',0),(550096,15281,'fi','PÃ¤ivitÃ¤ 3dcart tuotteiden nimet automaattisesti',0),(550097,15281,'no','Oppdatere 3dcart produktnavn automatisk',0),(550098,15281,'da','Opdatere 3dcart produktnavne automatisk',0),(550099,15281,'ko','3dcart ì œí’ˆ ì´ë¦„ì„ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(550100,15281,'he','×¢×“×›×•×Ÿ ×©×ž×•×ª ×”×ž×•×¦×¨×™× 3dcart ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(550101,15281,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart Î¿Î½ÏŒÎ¼Î±Ï„Î± Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Ï‰Î½',0),(550102,15281,'zh','è‡ªåŠ¨æ›´æ–° 3dcart äº§å“åç§°',0),(550103,15281,'sv','Uppdatera 3dcart produktnamn automatiskt',0),(550104,15281,'it','Aggiornare automaticamente i nomi dei prodotti 3dcart',0),(550105,15281,'tl','',0),(550106,15281,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸Šà¸·à¹ˆà¸­à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œ 3dcart à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(550107,15281,'hi','3dcart à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤¨à¤¾à¤®à¥‹à¤‚ à¤•à¥‹ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(550108,15281,'ms','Kemas kini nama produk 3dcart secara automatik',0),(550109,15281,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨ØªØ­Ø¯ÙŠØ« Ø£Ø³Ù…Ø§Ø¡ Ø§Ù„Ù…Ù†ØªØ¬Ø§Øª 3dcart',0),(550110,15281,'fr','Mettre Ã  jour automatiquement les noms de produits 3dcart',0),(550111,15281,'jp','3dcart è£½å“åã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(550112,15281,'pt','Atualizar os nomes de produto 3dcart automaticamente',0),(550113,15281,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ñ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð²',0),(550114,15281,'es','Actualicen 3dcart producto nombres automÃ¡ticamente',0),(550115,15281,'de','3dcart-Produktnamen automatisch aktualisieren',0),(550116,15281,'en','Update 3dcart Product Names Automatically',0),(550117,15282,'is','',0),(550118,15282,'dr','3dcart ÙˆØ²Ù† Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(550119,15282,'pr','3dcart ÙˆØ²Ù† Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(550120,15282,'tr','3dcart aÄŸÄ±rlÄ±k otomatik olarak gÃ¼ncelleÅŸtir',0),(550121,15282,'pl','Automatyczna aktualizacja wagi 3dcart',0),(550122,15282,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° 3dcart Ñ‚ÐµÐ¶ÐµÑÑ‚Ð¸',0),(550123,15282,'ur','3dcart Ø¨Ø§Ù¹ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(550124,15282,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ñ‚ÐµÐ³Ð¾Ð²Ð°',0),(550125,15282,'vi','Tá»± Ä‘á»™ng Cáº­p Nháº­t 3dcart trá»ng lÆ°á»£ng',0),(550126,15282,'af','3dcart gewigte outomaties opdateer',0),(550127,15282,'ro','Actualiza automat 3dcart greutÄƒÅ£i',0),(550128,15282,'et','3dcart kaaluvihtide automaatse vÃ¤rskendamise',0),(550129,15282,'si','Samodejno posodabljanje 3dcart uteÅ¾i',0),(550130,15282,'ba','Memperbarui bobot 3dcart secara otomatis',0),(550131,15282,'nl','3dcart gewichten automatisch bijwerken',0),(550132,15282,'fi','PÃ¤ivitÃ¤ 3dcart painot automaattisesti',0),(550133,15282,'no','Oppdatere 3dcart vekter automatisk',0),(550134,15282,'da','Opdatere 3dcart vÃ¦gte automatisk',0),(550135,15282,'ko','3dcart ë¬´ê²Œë¥¼ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(550136,15282,'he','×¢×“×›×•×Ÿ 3dcart ×ž×©×§×•×œ×•×ª ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(550137,15282,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart Î²Î¬ÏÎ·',0),(550138,15282,'zh','è‡ªåŠ¨æ›´æ–° 3dcart æƒé‡',0),(550139,15282,'sv','Uppdatera 3dcart vikter automatiskt',0),(550140,15282,'it','Aggiornare automaticamente 3dcart pesi',0),(550141,15282,'tl','',0),(550142,15282,'th','à¸­à¸±à¸žà¹€à¸” 3dcart à¸™à¹‰à¸³à¸«à¸™à¸±à¸à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(550143,15282,'hi','3dcart à¤­à¤¾à¤° à¤¸à¥à¤µà¤¤: à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(550144,15282,'ms','Kemas kini 3dcart berat secara automatik',0),(550145,15282,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£ÙˆØ²Ø§Ù† 3dcart',0),(550146,15282,'fr','Mise Ã  jour de 3dcart poids automatique',0),(550147,15282,'jp','3dcart é‡ã¿ã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(550148,15282,'pt','Atualizar automaticamente o 3dcart pesos',0),(550149,15282,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart Ð²ÐµÑÐ¾Ð²',0),(550150,15282,'es','Actualicen 3dcart pesos automÃ¡ticamente',0),(550151,15282,'de','3dcart Gewichte automatisch aktualisieren',0),(550152,15282,'en','Update 3dcart Weights Automatically',0),(550153,15283,'is','',0),(550154,15283,'dr','Ø¨Ù„ÙˆÚ© Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† & ÙˆÛŒØ±Ø§ÛŒØ´ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¯Ø± ØªØ­Ù‚Ù‚ & Ø³ÙØ§Ø±Ø´Ø§Øª POS',0),(550155,15283,'pr','Ø¨Ù„ÙˆÚ© Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† & ÙˆÛŒØ±Ø§ÛŒØ´ Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¯Ø± ØªØ­Ù‚Ù‚ & Ø³ÙØ§Ø±Ø´Ø§Øª POS',0),(550156,15283,'tr','Ekleme ve mÃ¼ÅŸteriler yerine getirilmesi ve POS sipariÅŸler Ã¼zerinde dÃ¼zenleme blok',0),(550157,15283,'pl','ZablokowaÄ‡ Dodawanie idealna edycji klientÃ³w na speÅ‚nienie idealna POS zamÃ³wienia',0),(550158,15283,'bg','Ð“Ñ€ÑƒÐ¿Ð¾Ð²Ð¾ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ & Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸ Ð½Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÐµÐ½Ð¸Ðµ & Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ ÐŸÐžÐ¡',0),(550159,15283,'ur','Ø§Ø¶Ø§ÙÛ & ØªÚ©Ù…ÛŒÙ„ & Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± ØµØ§Ø±ÙÛŒÙ† Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ø¨Ù„Ø§Ú©',0),(550160,15283,'sr','Ð‘Ð»Ð¾Ðº , Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð¸ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÐºÑƒÐ¿Ñ†Ðµ Ð½Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ & ÐŸÐžÐ¡ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(550161,15283,'vi','Khá»‘i thÃªm & chá»‰nh sá»­a khÃ¡ch hÃ ng thá»±c hiá»‡n & Ä‘Æ¡n Ä‘áº·t hÃ ng POS',0),(550162,15283,'af','Blokkeer voeg & redigering kliÃ«nte op vervulling & POS bestellings',0),(550163,15283,'ro','Bloc adÄƒugarea & clienÅ£ii pe Ã®mplinirea & POS comenzi de editare',0),(550164,15283,'et','Block lisades- & toimetamine klientidele eneseteostus- & POS tellimused',0),(550165,15283,'si','Blok dodajanje & urejanje stranke na izpolnitev & nalogi POS',0),(550166,15283,'ba','Blok menambahkan & mengedit pelanggan pada pemenuhan & POS perintah',0),(550167,15283,'nl','Blok toe te voegen & klanten op vervulling & POS Orders bewerken',0),(550168,15283,'fi','EstÃ¤Ã¤ lisÃ¤Ã¤mÃ¤llÃ¤ & editointi asiakkaille tÃ¤yttÃ¤minen & POS tilauksia',0),(550169,15283,'no','Blokkere legge & redigering kunder pÃ¥ oppfyllelsen & POS ordrer',0),(550170,15283,'da','Blok tilfÃ¸je & redigering kunder pÃ¥ opfyldelse & POS ordrer',0),(550171,15283,'ko','ë¸”ë¡ ì¶”ê°€ & ì„±ì·¨ ë° POS ì£¼ë¬¸ì— ê³ ê° íŽ¸ì§‘',0),(550172,15283,'he','×‘×œ×•×§ ×”×•×¡×¤×ª & ×¢×¨×™×›×” ×”×œ×§×•×—×•×ª ×¢×œ ×”×’×©×ž×” & POS ×”×–×ž× ×•×ª',0),(550173,15283,'el','ÎœÏ€Î»Î¿Îº Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ· & ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Î³Î¹Î± Ï„Î·Î½ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· & POS ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(550174,15283,'zh','å—æ·»åŠ ä¸Žç¼–è¾‘å®žè·µåŠ POS è®¢å•çš„å®¢æˆ·',0),(550175,15283,'sv','Blocket lÃ¤gga & redigering kunder pÃ¥ uppfyllelse & POS order',0),(550176,15283,'it','Blocco aggiunta & clienti il compimento & POS ordini di modifica',0),(550177,15283,'tl','',0),(550178,15283,'th','à¸šà¸¥à¹‡à¸­à¸à¹€à¸žà¸´à¹ˆà¸¡à¸„à¸¸à¹‰à¸¡ à¸„à¹ˆà¸²à¸¥à¸¹à¸à¸„à¹‰à¸²à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸¸à¹‰à¸¡à¸„à¹ˆà¸² POS à¸ªà¸±à¹ˆà¸‡à¹à¸à¹‰à¹„à¸‚',0),(550179,15283,'hi','à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ & à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥€ à¤ªà¥‚à¤°à¥à¤¤à¤¿ & POS à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤¬à¥à¤²à¥‰à¤•',0),(550180,15283,'ms','Blok menambah & menyunting pelanggan memenuhi & pesanan POS',0),(550181,15283,'ar','ÙƒØªÙ„Ø© Ø¥Ø¶Ø§ÙØ© & ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¹Ù„Ù‰ Ø§Ù„ÙˆÙØ§Ø¡ & Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø¨ÙŠØ¹',0),(550182,15283,'fr','Bloc ajoutant & clients sur Fulfillment & POS commandes d\'Ã©dition',0),(550183,15283,'jp','ãƒ–ãƒ­ãƒƒã‚¯ã®è¿½åŠ ãƒ»å……å®Ÿãƒ» PO ã®å—æ³¨ã§é¡§å®¢ã‚’ç·¨é›†',0),(550184,15283,'pt','Bloco adicionando e editando os clientes na realizaÃ§Ã£o & POS ordens',0),(550185,15283,'ru','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ & Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð² Ð½Ð° Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ & POS Ð·Ð°ÐºÐ°Ð·Ñ‹',0),(550186,15283,'es','Bloque de adiciÃ³n y ediciÃ³n de clientes en cumplimiento de Ã³rdenes de POS &',0),(550187,15283,'de','Block hinzufÃ¼gen & Kunden auf ErfÃ¼llung & POS AuftrÃ¤ge bearbeiten',0),(550188,15283,'en','Block Adding & Editing Customers On Fulfillment & POS Orders',0),(550189,15284,'is','',0),(550190,15284,'dr','Ø³ÙØ§Ø±Ø´ Ù‚Ø§Ù„Ø¨',0),(550191,15284,'pr','Ø³ÙØ§Ø±Ø´ Ù‚Ø§Ù„Ø¨',0),(550192,15284,'tr','SipariÅŸi biÃ§imi',0),(550193,15284,'pl','Format zamÃ³wienia',0),(550194,15284,'bg','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(550195,15284,'ur','ØªØ±ØªÛŒØ¨ ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(550196,15284,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(550197,15284,'vi','Thá»© tá»± Ä‘á»‹nh dáº¡ng',0),(550198,15284,'af','Orde formaat',0),(550199,15284,'ro','Comanda Format',0),(550200,15284,'et','Tellimuse vorm',0),(550201,15284,'si','Naloga Format',0),(550202,15284,'ba','Urutan Format',0),(550203,15284,'nl','Order Format',0),(550204,15284,'fi','Order Format',0),(550205,15284,'no','Format for',0),(550206,15284,'da','Order Format',0),(550207,15284,'ko','ì£¼ë¬¸ í˜•ì‹',0),(550208,15284,'he','×ª×‘× ×™×ª ×¡×“×¨',0),(550209,15284,'el','Format Î³Î¹Î±',0),(550210,15284,'zh','å‘½ä»¤æ ¼å¼',0),(550211,15284,'sv','Format-ordning',0),(550212,15284,'it','Formato di ordine',0),(550213,15284,'tl','',0),(550214,15284,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(550215,15284,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(550216,15284,'ms','Perintah Format',0),(550217,15284,'ar','ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(550218,15284,'fr','Commande Format',0),(550219,15284,'jp','æ³¨æ–‡ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(550220,15284,'pt','Formato de ordem',0),(550221,15284,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(550222,15284,'es','Formato de orden de',0),(550223,15284,'de','Bestellformat',0),(550224,15284,'en','Order Format',0),(550225,15285,'is','',0),(550226,15285,'dr','Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(550227,15285,'pr','Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(550228,15285,'tr','Fatura ile aynÄ±',0),(550229,15285,'pl','Tak samo jak faktura',0),(550230,15285,'bg','Ð¡ÑŠÑ‰Ð¾Ñ‚Ð¾ ÐºÐ°Ñ‚Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(550231,15285,'ur','Ø¬ÛŒØ³Ø§ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(550232,15285,'sr','Ð˜ÑÑ‚Ð¾ ÐºÐ°Ð¾ Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(550233,15285,'vi','Giá»‘ng nhÆ° hÃ³a Ä‘Æ¡n',0),(550234,15285,'af','Dieselfde As faktuur',0),(550235,15285,'ro','Fel ca facturÄƒ',0),(550236,15285,'et','Sama mis arve',0),(550237,15285,'si','Isto kot raÄuna',0),(550238,15285,'ba','Sama seperti faktur',0),(550239,15285,'nl','Hetzelfde als factuur',0),(550240,15285,'fi','Sama kuin laskun',0),(550241,15285,'no','Samme som fakturaen',0),(550242,15285,'da','Samme som faktura',0),(550243,15285,'ko','ì²­êµ¬ì„œì™€ ë™ì¼',0),(550244,15285,'he','×‘×“×™×•×§ ×›×ž×• ×—×©×‘×•× ×™×ª',0),(550245,15285,'el','ÎŠÎ´Î¹Î¿ Î¼Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(550246,15285,'zh','åŒæ ·ä½œä¸ºå‘ç¥¨',0),(550247,15285,'sv','Samma som faktura',0),(550248,15285,'it','Stesso come fattura',0),(550249,15285,'tl','',0),(550250,15285,'th','à¹€à¸«à¸¡à¸·à¸­à¸™à¸à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(550251,15285,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¹à¥€',0),(550252,15285,'ms','Sama seperti invois',0),(550253,15285,'ar','Ù†ÙØ³ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(550254,15285,'fr','MÃªme que la facture',0),(550255,15285,'jp','è«‹æ±‚æ›¸ã¨åŒã˜',0),(550256,15285,'pt','Mesmo que a fatura',0),(550257,15285,'ru','Ð¢Ð°Ðº Ð¶Ðµ, ÐºÐ°Ðº ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(550258,15285,'es','Igual a la factura',0),(550259,15285,'de','Identisch mit Rechnung',0),(550260,15285,'en','Same As Invoice',0),(550261,15286,'is','',0),(550262,15286,'dr','Ø¨Ù„ÙˆÚ© ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ú¯Ø°Ø´ØªÙ‡ ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù†',0),(550263,15286,'pr','Ø¨Ù„ÙˆÚ© ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ú¯Ø°Ø´ØªÙ‡ ØªØ§Ø±ÛŒØ® Ù¾Ø§ÛŒØ§Ù†',0),(550264,15286,'tr','BitiÅŸ tarihi geÃ§miÅŸ faturalar blok',0),(550265,15286,'pl','Blok faktur przeszÅ‚oÅ›ci data zakoÅ„czenia',0),(550266,15286,'bg','Ð‘Ð»Ð¾Ðº Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¼Ð¸Ð½Ð°Ð»Ð¾Ñ‚Ð¾ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(550267,15286,'ur','Ø¨Ù„Ø§Ú© ÙˆØ¨Ø¬Ù„ÛŒ Ø§Ø®ØªØªØ§Ù…ÛŒ ØªØ§Ø±ÛŒØ® Ù…Ø§Ø¶ÛŒ',0),(550268,15286,'sr','Ð‘Ð»Ð¾Ðº Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð¾Ñ€ÐµÐ´ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(550269,15286,'vi','Khá»‘i hÃ³a Ä‘Æ¡n qua ngÃ y káº¿t thÃºc',0),(550270,15286,'af','Blok fakture verby Einddatum',0),(550271,15286,'ro','Bloc facturile trecut data de sfÃ¢rÅŸit',0),(550272,15286,'et','Block arvete viimase lÃµppkuupÃ¤ev',0),(550273,15286,'si','Skupinski raÄuni mimo konÄni datum',0),(550274,15286,'ba','Blok faktur melewati tanggal akhir',0),(550275,15286,'nl','Blok facturen verleden einddatum',0),(550276,15286,'fi','EstÃ¤Ã¤ laskujen ohi pÃ¤Ã¤ttymispÃ¤ivÃ¤',0),(550277,15286,'no','Blokk fakturaer forbi sluttdatoen',0),(550278,15286,'da','Blok fakturaer forbi slutdato',0),(550279,15286,'ko','ë ë‚ ì§œ ë¸”ë¡ ì²­êµ¬ì„œ',0),(550280,15286,'he','×‘×œ×•×§ ×—×©×‘×•× ×™×•×ª ××—×¨×™ ×ª××¨×™×š ×¡×™×•×',0),(550281,15286,'el','ÎœÏ€Î»Î¿Îº Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î±ÏÎµÎ»Î¸ÏŒÎ½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(550282,15286,'zh','å—å‘ç¥¨è¿‡åŽ»çš„ç»“æŸæ—¥æœŸ',0),(550283,15286,'sv','Block fakturor fÃ¶rbi slutdatum',0),(550284,15286,'it','Blocco fatture oltre la data di fine',0),(550285,15286,'tl','',0),(550286,15286,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸šà¸¥à¹‡à¸­à¸à¹€à¸¥à¸¢à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(550287,15286,'hi','à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤– à¤ªà¤¿à¤›à¤²à¥‡ à¤¬à¥à¤²à¥‰à¤• à¤šà¤¾à¤²à¤¾à¤¨',0),(550288,15286,'ms','Blok invois melepasi tarikh tamat',0),(550289,15286,'ar','ÙƒØªÙ„Ø© ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø§Ø¶ÙŠ ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡',0),(550290,15286,'fr','Bloc de factures aprÃ¨s la Date de fin',0),(550291,15286,'jp','éŽåŽ»ã®çµ‚äº†æ—¥ãƒ–ãƒ­ãƒƒã‚¯è«‹æ±‚æ›¸',0),(550292,15286,'pt','Bloco de facturas passado data de fim',0),(550293,15286,'ru','Ð‘Ð»Ð¾Ðº ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð¿Ñ€Ð¾ÑˆÐ»Ñ‹Ñ… Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(550294,15286,'es','Block facturas mÃ¡s allÃ¡ de la fecha de finalizaciÃ³n',0),(550295,15286,'de','Block-Rechnungen vorbei Enddatum',0),(550296,15286,'en','Block Invoices Past End Date',0),(550297,15287,'is','',0),(550298,15287,'dr','ØªØ±ØªÛŒØ¨ Ú¯Ø°Ø´ØªÙ‡ Ø§Ø³Øª',0),(550299,15287,'pr','ØªØ±ØªÛŒØ¨ Ú¯Ø°Ø´ØªÙ‡ Ø§Ø³Øª',0),(550300,15287,'tr','Bir son sahiptir',0),(550301,15287,'pl','Ma ostatnie zamÃ³wienie z',0),(550302,15287,'bg','Ð˜Ð¼Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð¾Ð²ÐµÐ´ Ð½Ð°',0),(550303,15287,'ur','Ø§ÛŒÚ© Ú¯Ø²Ø´ØªÛ ØªØ±ØªÛŒØ¨ Ú©Ø§ ÛÛ’',0),(550304,15287,'sr','Ð˜Ð¼Ð° Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° Ð¿Ñ€Ð¾Ñ‚ÐµÐºÐ»Ð¸Ñ… Ð¾Ð´',0),(550305,15287,'vi','CÃ³ má»™t tráº­t tá»± trong quÃ¡ khá»© cá»§a',0),(550306,15287,'af','Het \'n afgelope orde van',0),(550307,15287,'ro','Are un trecut ordine de',0),(550308,15287,'et','On viimase Orden',0),(550309,15287,'si','Je zadnjih vrstni red',0),(550310,15287,'ba','Memiliki urutan masa lalu dari',0),(550311,15287,'nl','Heeft een verleden volgorde van',0),(550312,15287,'fi','On viime ritarikunta',0),(550313,15287,'no','Har en siste ordre av',0),(550314,15287,'da','Har en sidste ordre af',0),(550315,15287,'ko','ê³¼ê±° ìˆœì„œ',0),(550316,15287,'he','×™×© ×¦×• ×§×•×“×ž×™× ×©×œ',0),(550317,15287,'el','ÎˆÏ‡ÎµÎ¹ Î¼Î¹Î± Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÏƒÎµÎ¹ÏÎ¬ Ï„Î¿Ï…',0),(550318,15287,'zh','å·²ç»è¿‡åŽ»çš„é¡ºåº',0),(550319,15287,'sv','Har en tidigare Order av',0),(550320,15287,'it','Ha un ordine passato di',0),(550321,15287,'tl','',0),(550322,15287,'th','à¸¡à¸µà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸œà¹ˆà¸²à¸™à¸¡à¸²à¸‚à¸­à¸‡',0),(550323,15287,'hi','à¤à¤• à¤ªà¤¿à¤›à¤²à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¤¾ à¤¹à¥ˆ',0),(550324,15287,'ms','Mempunyai suatu perintah lepas',0),(550325,15287,'ar','ÙˆÙ‚Ø¯ Ø£Ù…Ø± Ø§Ù„Ù…Ø§Ø¶ÙŠØ© Ù…Ù†',0),(550326,15287,'fr','A un ordre passÃ©',0),(550327,15287,'jp','é †åºãŒéŽåŽ»',0),(550328,15287,'pt','Tem um passado ordem de',0),(550329,15287,'ru','Ð•ÑÑ‚ÑŒ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº',0),(550330,15287,'es','Tiene un pasado orden de',0),(550331,15287,'de','Hat einen letzten Auftrag des',0),(550332,15287,'en','Has A Past Order Of',0),(550333,15288,'is','',0),(550334,15288,'dr','Ú©Ø¯ ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒ',0),(550335,15288,'pr','Ú©Ø¯ ÙØ¹Ø§Ù„ Ø³Ø§Ø²ÛŒ',0),(550336,15288,'tr','Harekete geÃ§irmek ÅŸifre',0),(550337,15288,'pl','Aktywacja kod',0),(550338,15288,'bg','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð´',0),(550339,15288,'ur','Ø¶Ø§Ø¨Ø·Û Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(550340,15288,'sr','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¨Ð¸Ñ„Ñ€Ð°',0),(550341,15288,'vi','KÃ­ch hoáº¡t mÃ£',0),(550342,15288,'af','Aktiveer kode',0),(550343,15288,'ro','Activa codul',0),(550344,15288,'et','Aktiveerimise koodi',0),(550345,15288,'si','VkljuÄite kodo',0),(550346,15288,'ba','Aktifkan kode',0),(550347,15288,'nl','Code activeren',0),(550348,15288,'fi','Aktivoida ilmaista koodikielellÃ¤',0),(550349,15288,'no','Aktivere koden',0),(550350,15288,'da','Aktivere kode',0),(550351,15288,'ko','í™œì„±í™” ì½”ë“œ',0),(550352,15288,'he','×œ×”×¤×¢×™×œ ×§×•×“',0),(550353,15288,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î¿Î½ ÎºÏ‰Î´Î¹ÎºÏŒ',0),(550354,15288,'zh','æ¿€æ´»çš„ä»£ç ',0),(550355,15288,'sv','Aktivera koden',0),(550356,15288,'it','Attivare il codice',0),(550357,15288,'tl','',0),(550358,15288,'th','à¹€à¸£à¸µà¸¢à¸à¹ƒà¸Šà¹‰à¸£à¸«à¸±à¸ª',0),(550359,15288,'hi','à¤•à¥‹à¤¡ à¤•à¥‹ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¥‡à¤‚',0),(550360,15288,'ms','Mengaktifkan kod',0),(550361,15288,'ar','ØªÙ†Ø´ÙŠØ· Ø±Ù…Ø²',0),(550362,15288,'fr','Activer le Code',0),(550363,15288,'jp','ã‚³ãƒ¼ãƒ‰ã‚’ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã«ã—ã¾ã™ã€‚',0),(550364,15288,'pt','Ativar o cÃ³digo',0),(550365,15288,'ru','ÐÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÐ¾Ð´',0),(550366,15288,'es','Activar cÃ³digo',0),(550367,15288,'de','Code zu aktivieren',0),(550368,15288,'en','Activate Code',0),(550369,15289,'is','',0),(550370,15289,'dr','ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ù…Ø¯ÛŒØ±ÛŒØª',0),(550371,15289,'pr','ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ù…Ø¯ÛŒØ±ÛŒØª',0),(550372,15289,'tr','Ã–zelliklerini yÃ¶netme',0),(550373,15289,'pl','ZarzÄ…dzanie funkcjami',0),(550374,15289,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¸',0),(550375,15289,'ur','Ø®ØµÙˆØµÛŒØ§Øª Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±ÛŒÚº',0),(550376,15289,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°Ð¼Ð°',0),(550377,15289,'vi','Quáº£n lÃ½ tÃ­nh nÄƒng',0),(550378,15289,'af','Bestuur kenmerke',0),(550379,15289,'ro','Gestiona caracteristici',0),(550380,15289,'et','Funktsioonide haldamine',0),(550381,15289,'si','Upravljanje funkcij',0),(550382,15289,'ba','Mengelola fitur',0),(550383,15289,'nl','Functies beheren',0),(550384,15289,'fi','Ominaisuuksien hallinta',0),(550385,15289,'no','Behandle funksjoner',0),(550386,15289,'da','Administrer funktioner',0),(550387,15289,'ko','ê¸°ëŠ¥ì„ ê´€ë¦¬',0),(550388,15289,'he','×œ× ×”×œ ××ª ×ª×›×•× ×•×ª',0),(550389,15289,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· Ï‡Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÏŽÎ½',0),(550390,15289,'zh','ç®¡ç†åŠŸèƒ½',0),(550391,15289,'sv','Hantera funktioner',0),(550392,15289,'it','Gestire le funzionalitÃ ',0),(550393,15289,'tl','',0),(550394,15289,'th','à¸ˆà¸±à¸”à¸à¸²à¸£à¸¥à¸±à¸à¸©à¸“à¸°à¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™',0),(550395,15289,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾à¤“à¤‚ à¤•à¤¾ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤•à¤°à¥‡à¤‚',0),(550396,15289,'ms','Uruskan ciri-ciri',0),(550397,15289,'ar','Ø¥Ø¯Ø§Ø±Ø© Ù…ÙŠØ²Ø§Øª',0),(550398,15289,'fr','GÃ©rer les fonctionnalitÃ©s',0),(550399,15289,'jp','æ©Ÿèƒ½ã‚’ç®¡ç†ã—ã¾ã™ã€‚',0),(550400,15289,'pt','Gerenciar recursos',0),(550401,15289,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ„ÑƒÐ½ÐºÑ†Ð¸ÑÐ¼Ð¸',0),(550402,15289,'es','AdministraciÃ³n de caracterÃ­sticas',0),(550403,15289,'de','Funktionen verwalten',0),(550404,15289,'en','Manage Features',0),(550405,15290,'is','',0),(550406,15290,'dr','Ø§Ø´ØªØ±Ø§Ú© Ù…Ù†',0),(550407,15290,'pr','Ø§Ø´ØªØ±Ø§Ú© Ù…Ù†',0),(550408,15290,'tr','Benim abonelik',0),(550409,15290,'pl','MÃ³j subskrypcja',0),(550410,15290,'bg','ÐœÐ¾ÑÑ‚ Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(550411,15290,'ur','Ù…ÛŒØ±ÛŒ Ø±Ú©Ù†ÛŒØª',0),(550412,15290,'sr','ÐœÐ¾Ñ˜Ðµ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(550413,15290,'vi','ÄÄƒng kÃ½ cá»§a tÃ´i',0),(550414,15290,'af','My intekening',0),(550415,15290,'ro','Abonamentul meu',0),(550416,15290,'et','Minu tellimus',0),(550417,15290,'si','Moje naroÄnine',0),(550418,15290,'ba','Saya berlangganan',0),(550419,15290,'nl','Mijn abonnement',0),(550420,15290,'fi','Tilaukseni',0),(550421,15290,'no','Abonnementet',0),(550422,15290,'da','Mit abonnement',0),(550423,15290,'ko','ë‚´ êµ¬ë…',0),(550424,15290,'he','×”×ž× ×•×™ ×©×œ×™',0),(550425,15290,'el','Î£Ï…Î½Î´ÏÎ¿Î¼Î® Î¼Î¿Ï…',0),(550426,15290,'zh','æˆ‘çš„è®¢é˜…',0),(550427,15290,'sv','Min prenumeration',0),(550428,15290,'it','Il mio abbonamento',0),(550429,15290,'tl','',0),(550430,15290,'th','à¹€à¸›à¹‡à¸™à¸ªà¸¡à¸²à¸Šà¸´à¸à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(550431,15290,'hi','à¤®à¥‡à¤°à¥€ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾',0),(550432,15290,'ms','Langganan saya',0),(550433,15290,'ar','Ø§Ø´ØªØ±Ø§ÙƒÙŠ',0),(550434,15290,'fr','Mon abonnement',0),(550435,15290,'jp','ç§ã®å®šæœŸè³¼èª­',0),(550436,15290,'pt','Minha assinatura',0),(550437,15290,'ru','ÐœÐ¾Ð¸ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ¸',0),(550438,15290,'es','Mi suscripciÃ³n',0),(550439,15290,'de','Mein Abonnement',0),(550440,15290,'en','My Subscription',0),(550441,15291,'is','',0),(550442,15291,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø´ØªØ±Ø§Ú© Ø¬Ø¯ÛŒØ¯',0),(550443,15291,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø´ØªØ±Ø§Ú© Ø¬Ø¯ÛŒØ¯',0),(550444,15291,'tr','Yeni abonelik Ã¼creti',0),(550445,15291,'pl','Nowa opÅ‚ata subskrypcyjna',0),(550446,15291,'bg','ÐÐ¾Ð²Ð° Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(550447,15291,'ur','Ù†Ø¦Û’ Ø±Ú©Ù†ÛŒØª Ú©ÛŒ ÙÛŒØ³',0),(550448,15291,'sr','ÐÐ¾Ð²Ð° Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ð° ÑÐµ Ð½Ð°Ð¿Ð»Ð°Ñ›ÑƒÑ˜Ðµ',0),(550449,15291,'vi','Lá»‡ phÃ­ Ä‘Äƒng kÃ½ má»›i',0),(550450,15291,'af','Nuwe fooi',0),(550451,15291,'ro','Abonament nou',0),(550452,15291,'et','Uus mÃ¤rkimistasu',0),(550453,15291,'si','Novo naroÄnino',0),(550454,15291,'ba','Baru biaya berlangganan',0),(550455,15291,'nl','Nieuwe abonnementskosten',0),(550456,15291,'fi','Uusi allekirjoitus maksaa palkkio',0),(550457,15291,'no','Ny abonnementsavgift',0),(550458,15291,'da','Nye abonnementsafgift',0),(550459,15291,'ko','ìƒˆ êµ¬ë… ë£Œ',0),(550460,15291,'he','×“×ž×™ ×ž× ×•×™ ×—×“×©',0),(550461,15291,'el','ÎÎ­Î± ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®',0),(550462,15291,'zh','æ–°çš„è®¢é˜…è´¹',0),(550463,15291,'sv','Nya prenumerationsavgiften',0),(550464,15291,'it','Nuova tariffa di sottoscrizione',0),(550465,15291,'tl','',0),(550466,15291,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸šà¸­à¸à¸£à¸±à¸šà¹€à¸›à¹‡à¸™à¸ªà¸¡à¸²à¸Šà¸´à¸à¹ƒà¸«à¸¡à¹ˆ',0),(550467,15291,'hi','à¤¨à¤ˆ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤¶à¥à¤²à¥à¤•',0),(550468,15291,'ms','Yuran langganan baru',0),(550469,15291,'ar','Ø±Ø³ÙˆÙ… Ø§Ø´ØªØ±Ø§Ùƒ Ø¬Ø¯ÙŠØ¯',0),(550470,15291,'fr','Nouveau prix de l\'abonnement',0),(550471,15291,'jp','æ–°ã—ã„ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã®æ–™é‡‘',0),(550472,15291,'pt','Nova taxa de assinatura',0),(550473,15291,'ru','ÐÐ¾Ð²Ð°Ñ Ð°Ð±Ð¾Ð½ÐµÐ½Ñ‚ÑÐºÐ°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(550474,15291,'es','Nueva tarifa de suscripciÃ³n',0),(550475,15291,'de','Neue Abo-GebÃ¼hr',0),(550476,15291,'en','New Subscription Fee',0),(550477,15292,'is','',0),(550478,15292,'dr','Ø¨Ø¯ÙˆÙ† Ø®Ø±ÛŒØ¯',0),(550479,15292,'pr','Ø¨Ø¯ÙˆÙ† Ø®Ø±ÛŒØ¯',0),(550480,15292,'tr','HiÃ§bir satÄ±n alma',0),(550481,15292,'pl','Nie zakupy',0),(550482,15292,'bg','ÐÑÐ¼Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(550483,15292,'ur','Ú©ÙˆØ¦ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(550484,15292,'sr','ÐÐ¸ÑÑ‚Ðµ ÐºÑƒÐ¿Ð¾Ð²Ð°Ð»Ð¸',0),(550485,15292,'vi','Mua hÃ ng khÃ´ng',0),(550486,15292,'af','Geen aankope',0),(550487,15292,'ro','AchiziÈ›iile nu',0),(550488,15292,'et','Mingit ostu',0),(550489,15292,'si','Brez nakupov',0),(550490,15292,'ba','Tidak ada pembelian',0),(550491,15292,'nl','Geen aankopen',0),(550492,15292,'fi','MitÃ¤Ã¤n ostaa',0),(550493,15292,'no','Ingen kjÃ¸p',0),(550494,15292,'da','Ingen indkÃ¸b',0),(550495,15292,'ko','ì•„ë‹ˆ êµ¬ë§¤',0),(550496,15292,'he','×‘×œ×™ ×¨×›×™×©×•×ª',0),(550497,15292,'el','Î‘Î³Î¿ÏÎ­Ï‚ Î´ÎµÎ½',0),(550498,15292,'zh','æ²¡æœ‰è´­ä¹°',0),(550499,15292,'sv','Inga inkÃ¶p',0),(550500,15292,'it','No acquisti',0),(550501,15292,'tl','',0),(550502,15292,'th','à¹„à¸¡à¹ˆà¸‹à¸·à¹‰à¸­',0),(550503,15292,'hi','à¤•à¥‹à¤ˆ à¤–à¤°à¥€à¤¦',0),(550504,15292,'ms','Sebarang pembelian',0),(550505,15292,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ø´ØªØ±ÙŠØ§Øª',0),(550506,15292,'fr','Pas d\'achat',0),(550507,15292,'jp','ãªã„è³¼å…¥',0),(550508,15292,'pt','Sem compras',0),(550509,15292,'ru','ÐÐµÑ‚ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(550510,15292,'es','No compras',0),(550511,15292,'de','Keine EinkÃ¤ufe',0),(550512,15292,'en','No Purchases',0),(550513,15293,'is','',0),(550514,15293,'dr','Ù…Ø­Ø§Ú©Ù…Ù‡ Ø¨Ù‡ Ù¾Ø§ÛŒØ§Ù† Ù…ÛŒ Ø±Ø³Ø¯',0),(550515,15293,'pr','Ù…Ø­Ø§Ú©Ù…Ù‡ Ø¨Ù‡ Ù¾Ø§ÛŒØ§Ù† Ù…ÛŒ Ø±Ø³Ø¯',0),(550516,15293,'tr','Deneme biter',0),(550517,15293,'pl','PrÃ³ba koÅ„czy siÄ™',0),(550518,15293,'bg','ÐŸÑ€Ð¾Ð±ÐµÐ½ Ð·Ð°Ð²ÑŠÑ€ÑˆÐ²Ð°',0),(550519,15293,'ur','Ù…Ù‚Ø¯Ù…Û’ Ú©ÛŒ Ø³Ù…Ø§Ø¹Øª Ø®ØªÙ… ÛÙˆÙ†Û’',0),(550520,15293,'sr','Ð¡ÑƒÑ’ÐµÑšÐµ ÐºÑ€Ð°Ñ˜ÐµÐ²Ðµ',0),(550521,15293,'vi','PhiÃªn tÃ²a káº¿t thÃºc',0),(550522,15293,'af','Verhoor eindig',0),(550523,15293,'ro','Proces se terminÄƒ',0),(550524,15293,'et','Kohtuprotsess otsad',0),(550525,15293,'si','Poskus konÄa',0),(550526,15293,'ba','Percobaan berakhir',0),(550527,15293,'nl','Proefperiode uiteinden',0),(550528,15293,'fi','Kokeiluversio pÃ¤Ã¤ttyy',0),(550529,15293,'no','Gratisperioden utlÃ¸per',0),(550530,15293,'da','Retssag ender',0),(550531,15293,'ko','ì‹œí—˜ ë',0),(550532,15293,'he','×”×ž×©×¤×˜ ×ž×¡×ª×™×™×',0),(550533,15293,'el','Î”Î¿ÎºÎ¹Î¼Î±ÏƒÏ„Î¹ÎºÎ® Î¬ÎºÏÎ±',0),(550534,15293,'zh','è¯•ç”¨æœŸç»“æŸ',0),(550535,15293,'sv','RÃ¤ttegÃ¥ngen avslutas',0),(550536,15293,'it','Periodo di prova',0),(550537,15293,'tl','',0),(550538,15293,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸à¸²à¸£à¸—à¸”à¸¥à¸­à¸‡',0),(550539,15293,'hi','à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ',0),(550540,15293,'ms','Percubaan berakhir',0),(550541,15293,'ar','ØªÙ†ØªÙ‡ÙŠ Ø§Ù„Ù…Ø­Ø§ÙƒÙ…Ø©',0),(550542,15293,'fr','ExtrÃ©mitÃ©s du procÃ¨s',0),(550543,15293,'jp','è©¦ç”¨çµ‚äº†',0),(550544,15293,'pt','Julgamento termina',0),(550545,15293,'ru','Ð¡ÑƒÐ´ÐµÐ±Ð½Ð°Ñ ÐºÐ¾Ð½Ñ†Ñ‹',0),(550546,15293,'es','Puntas de prueba',0),(550547,15293,'de','Testversion-enden',0),(550548,15293,'en','Trial Ends',0),(550549,15294,'is','',0),(550550,15294,'dr','Ù…Ø­Ø§Ú©Ù…Ù‡ Ù…Ù†Ù‚Ø¶ÛŒ Ø´Ø¯Ù‡',0),(550551,15294,'pr','Ù…Ø­Ø§Ú©Ù…Ù‡ Ù…Ù†Ù‚Ø¶ÛŒ Ø´Ø¯Ù‡',0),(550552,15294,'tr','Deneme sÃ¼resi',0),(550553,15294,'pl','WygasÅ‚a wersja prÃ³bna',0),(550554,15294,'bg','ÐŸÑ€Ð¾Ð±Ð½Ð° Ð²ÐµÑ€ÑÐ¸Ñ Ðµ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ»',0),(550555,15294,'ur','Ù…Ù‚Ø¯Ù…Û Ú©ÛŒ Ù…Ø¯Øª Ø®ØªÙ… ÛÙˆ Ú¯Ø¦ÛŒ ÛÛ’',0),(550556,15294,'sr','Ð¡ÑƒÑ’ÐµÑšÐµ Ñ˜Ðµ Ð¸ÑÑ‚ÐµÐºÐ°Ð¾',0),(550557,15294,'vi','DÃ¹ng thá»­ háº¿t háº¡n',0),(550558,15294,'af','Verhoor verval',0),(550559,15294,'ro','Proces a expirat',0),(550560,15294,'et','Prooviperiood on aegunud',0),(550561,15294,'si','Poskus izdihniti',0),(550562,15294,'ba','Persidangan kadaluarsa',0),(550563,15294,'nl','Verhoor vervallen',0),(550564,15294,'fi','OikeudenkÃ¤ynti pÃ¤Ã¤ttynyt',0),(550565,15294,'no','PrÃ¸veversjon utlÃ¸pt',0),(550566,15294,'da','Retssag udlÃ¸bet',0),(550567,15294,'ko','í‰ê°€íŒ ë§Œë£Œ',0),(550568,15294,'he','×”×ž×©×¤×˜ ×¤×’',0),(550569,15294,'el','Î”Î¯ÎºÎ· Î­Î»Î·Î¾Îµ',0),(550570,15294,'zh','è¯•ç”¨è¿‡æœŸ',0),(550571,15294,'sv','Prov andas ut',0),(550572,15294,'it','Versione di prova scaduta',0),(550573,15294,'tl','',0),(550574,15294,'th','à¸—à¸”à¸¥à¸­à¸‡à¹ƒà¸Šà¹‰à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(550575,15294,'hi','à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤¸à¤®à¤¯ à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤',0),(550576,15294,'ms','Tamat tempoh percubaan',0),(550577,15294,'ar','Ø§Ù†ØªÙ‡Øª Ø§Ù„Ù…Ø­Ø§ÙƒÙ…Ø©',0),(550578,15294,'fr','ProcÃ¨s a expirÃ©',0),(550579,15294,'jp','è©¦ç”¨ç‰ˆã®æœ‰åŠ¹æœŸé™ãŒåˆ‡ã‚Œã¦ãã ã•ã„ã€‚',0),(550580,15294,'pt','Julgamento expirado',0),(550581,15294,'ru','Ð¡ÑƒÐ´Ð° Ð¸ÑÑ‚ÐµÐº',0),(550582,15294,'es','VersiÃ³n de prueba caducado',0),(550583,15294,'de','Testversion abgelaufen',0),(550584,15294,'en','Trial Expired',0),(550585,15295,'is','',0),(550586,15295,'dr','Ú©Ù…Ú© Ù‡Ø²ÛŒÙ†Ù‡ Ø¯Ø§Ø¯Ù‡',0),(550587,15295,'pr','Ú©Ù…Ú© Ù‡Ø²ÛŒÙ†Ù‡ Ø¯Ø§Ø¯Ù‡',0),(550588,15295,'tr','Veri Ã¶deneÄŸi',0),(550589,15295,'pl','Dane dodatku',0),(550590,15295,'bg','ÐšÐ²Ð¾Ñ‚Ð¸ Ð´Ð°Ð½Ð½Ð¸',0),(550591,15295,'ur','Ú©ÙˆØ§Ø¦Ù Ø§Ù„Ø§Ø¤Ù†Ø³',0),(550592,15295,'sr','ÐŸÐ¾Ð´Ð°Ñ†Ð¸ Ð´Ð¾Ð´Ð°Ñ‚Ð°Ðº',0),(550593,15295,'vi','Phá»¥ cáº¥p dá»¯ liá»‡u',0),(550594,15295,'af','Data toelae',0),(550595,15295,'ro','AlocaÈ›ia de date',0),(550596,15295,'et','Andmeid hÃ¼vitise',0),(550597,15295,'si','Podatkov dodatek',0),(550598,15295,'ba','Data tunjangan',0),(550599,15295,'nl','Gegevens vergoeding',0),(550600,15295,'fi','Tiedot korvauksen',0),(550601,15295,'no','Data godtgjÃ¸relse',0),(550602,15295,'da','Data godtgÃ¸relse',0),(550603,15295,'ko','ë°ì´í„° ìˆ˜ë‹¹',0),(550604,15295,'he','×”×§×¦×‘×” × ×ª×•× ×™×',0),(550605,15295,'el','Î•Ï€Î¯Î´Î¿Î¼Î± Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(550606,15295,'zh','æ•°æ®æ´¥è´´',0),(550607,15295,'sv','Data ersÃ¤ttning',0),(550608,15295,'it','IndennitÃ  di dati',0),(550609,15295,'tl','',0),(550610,15295,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¹ˆà¸§à¸™à¸¥à¸”',0),(550611,15295,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤­à¤¤à¥à¤¤à¤¾',0),(550612,15295,'ms','Data elaun',0),(550613,15295,'ar','Ø¨Ø¯Ù„ Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(550614,15295,'fr','Allocation de donnÃ©es',0),(550615,15295,'jp','ãƒ‡ãƒ¼ã‚¿ã®ä¸Šé™',0),(550616,15295,'pt','SubsÃ­dio de dados',0),(550617,15295,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ Ð¿Ð¾ÑÐ¾Ð±Ð¸Ñ',0),(550618,15295,'es','AsignaciÃ³n de datos',0),(550619,15295,'de','Daten-Zulage',0),(550620,15295,'en','Data Allowance',0),(550621,15296,'is','',0),(550622,15296,'dr','Ø¯Ø§Ø¯',0),(550623,15296,'pr','Ø¯Ø§Ø¯',0),(550624,15296,'tr','Yeniler',0),(550625,15296,'pl','Odnawia',0),(550626,15296,'bg','ÐŸÐ¾Ð´Ð½Ð¾Ð²ÑÐ²Ð°',0),(550627,15296,'ur','Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯ Ú©Ø± Ø¯ÛŒ',0),(550628,15296,'sr','ÐžÐ±Ð½Ð°Ð²Ñ™Ð°',0),(550629,15296,'vi','Äá»•i má»›i',0),(550630,15296,'af','Renews',0),(550631,15296,'ro','ReÃ®nnoieÅŸte',0),(550632,15296,'et','Uuendatakse',0),(550633,15296,'si','Obnavlja',0),(550634,15296,'ba','Memperbaharui',0),(550635,15296,'nl','Vernieuwt',0),(550636,15296,'fi','Uudistaa',0),(550637,15296,'no','Fornyer',0),(550638,15296,'da','Fornyer',0),(550639,15296,'ko','ê°±ì‹ ',0),(550640,15296,'he','×ž×—×“×©×ª',0),(550641,15296,'el','Î‘Î½Î±Î½ÎµÏŽÎ½ÎµÎ¹',0),(550642,15296,'zh','æ›´æ–°',0),(550643,15296,'sv','FÃ¶rnyar',0),(550644,15296,'it','Rinnova',0),(550645,15296,'tl','',0),(550646,15296,'th','Renews',0),(550647,15296,'hi','à¤¤à¤¨à¤¾à¤µ',0),(550648,15296,'ms','Memperbaharui',0),(550649,15296,'ar','ÙˆØªØ¬Ø¯Ø¯',0),(550650,15296,'fr','Renouvelle',0),(550651,15296,'jp','æ›´æ–°',0),(550652,15296,'pt','Renova',0),(550653,15296,'ru','Ð’Ð½Ð¾Ð²ÑŒ',0),(550654,15296,'es','Renueva',0),(550655,15296,'de','Erneuert',0),(550656,15296,'en','Renews',0),(550657,15297,'is','',0),(550658,15297,'dr','Ù…Ø­Ø§Ú©Ù…Ù‡ Ø¢Ø®Ø±',0),(550659,15297,'pr','Ù…Ø­Ø§Ú©Ù…Ù‡ Ø¢Ø®Ø±',0),(550660,15297,'tr','Son deneme',0),(550661,15297,'pl','Koniec procesu',0),(550662,15297,'bg','ÐšÑ€Ð°Ð¹ Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(550663,15297,'ur','Ø®ØªÙ… Ù…Ù‚Ø¯Ù…Û',0),(550664,15297,'sr','ÐšÑ€Ð°Ñ˜ ÑÑƒÑ’ÐµÑšÐ°',0),(550665,15297,'vi','Káº¿t thÃºc phiÃªn toÃ ',0),(550666,15297,'af','Einde verhoor',0),(550667,15297,'ro','Scop proces',0),(550668,15297,'et','LÃµpuni kohtuprotsess',0),(550669,15297,'si','Konca sojenja',0),(550670,15297,'ba','Ujian akhir',0),(550671,15297,'nl','Einde Trial',0),(550672,15297,'fi','Loppuun oikeudenkÃ¤yntiÃ¤',0),(550673,15297,'no','Slutten prÃ¸veversjon',0),(550674,15297,'da','Ende retssag',0),(550675,15297,'ko','ìµœì¢… ì‹œí—˜',0),(550676,15297,'he','×‘×¡×•×£ ×ž×©×¤×˜',0),(550677,15297,'el','Î¤Î­Î»Î¿Ï‚ Î´Î¯ÎºÎ·',0),(550678,15297,'zh','æœ€ç»ˆçš„å®¡åˆ¤',0),(550679,15297,'sv','Avsluta rÃ¤ttegÃ¥ng',0),(550680,15297,'it','Fine prova',0),(550681,15297,'tl','',0),(550682,15297,'th','à¸„à¸”à¸µà¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(550683,15297,'hi','à¤ªà¤°à¥€à¤•à¥à¤·à¤£ à¤•à¥‡ à¤…à¤‚à¤¤',0),(550684,15297,'ms','Percubaan akhir',0),(550685,15297,'ar','Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ù…Ø­Ø§ÙƒÙ…Ø©',0),(550686,15297,'fr','ProcÃ¨s de fin',0),(550687,15297,'jp','çµ‚äº†è©¦é¨“',0),(550688,15297,'pt','Julgamento final',0),(550689,15297,'ru','ÐšÐ¾Ð½ÐµÑ† Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ñ‚ÐµÐ»ÑŒÑÑ‚Ð²Ð°',0),(550690,15297,'es','Juicio final',0),(550691,15297,'de','Ende-Testversion',0),(550692,15297,'en','End Trial',0),(550693,15298,'is','',0),(550694,15298,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(550695,15298,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(550696,15298,'tr','GeÃ§ersiz deÄŸer',0),(550697,15298,'pl','NieprawidÅ‚owa wartoÅ›Ä‡',0),(550698,15298,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(550699,15298,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ù‚Ø¯Ø±',0),(550700,15298,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð° Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(550701,15298,'vi','GiÃ¡ trá»‹ khÃ´ng há»£p lá»‡',0),(550702,15298,'af','Ongeldige waarde',0),(550703,15298,'ro','Valoare nevalidÄƒ',0),(550704,15298,'et','Sobimatu vÃ¤Ã¤rtus',0),(550705,15298,'si','Neveljavna vrednost',0),(550706,15298,'ba','Nilai yang valid',0),(550707,15298,'nl','Ongeldige waarde',0),(550708,15298,'fi','Virheellinen arvo',0),(550709,15298,'no','Ugyldig verdi',0),(550710,15298,'da','Ugyldig vÃ¦rdi',0),(550711,15298,'ko','ìž˜ëª» ëœ ê°’',0),(550712,15298,'he','×¢×¨×š ×œ× ×—×•×§×™',0),(550713,15298,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· Ï„Î¹Î¼Î®',0),(550714,15298,'zh','æ— æ•ˆçš„å€¼',0),(550715,15298,'sv','Ogiltigt vÃ¤rde',0),(550716,15298,'it','Valore non valido',0),(550717,15298,'tl','',0),(550718,15298,'th','à¸„à¹ˆà¸²à¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(550719,15298,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤®à¤¾à¤¨',0),(550720,15298,'ms','Nilai yang tidak sah',0),(550721,15298,'ar','Ù‚ÙŠÙ…Ø© ØºÙŠØ± ØµØ§Ù„Ø­Ø©',0),(550722,15298,'fr','Valeur non valide',0),(550723,15298,'jp','ç„¡åŠ¹ãªå€¤',0),(550724,15298,'pt','Valor invÃ¡lido',0),(550725,15298,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð¾Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(550726,15298,'es','Valor no vÃ¡lido',0),(550727,15298,'de','UngÃ¼ltiger Wert',0),(550728,15298,'en','Invalid Value',0),(550729,15299,'is','',0),(550730,15299,'dr','Ù…Ø§Ù‡',0),(550731,15299,'pr','Ù…Ø§Ù‡',0),(550732,15299,'tr','Mo',0),(550733,15299,'pl','Mo',0),(550734,15299,'bg','ÐœÐ¾',0),(550735,15299,'ur','Ù…Ùˆ',0),(550736,15299,'sr','ÐœÐ¾',0),(550737,15299,'vi','Mo',0),(550738,15299,'af','Mo',0),(550739,15299,'ro','MO',0),(550740,15299,'et','Mo',0),(550741,15299,'si','Mo',0),(550742,15299,'ba','Mo',0),(550743,15299,'nl','Mo',0),(550744,15299,'fi','Mo',0),(550745,15299,'no','Mo',0),(550746,15299,'da','Mo',0),(550747,15299,'ko','ëª¨',0),(550748,15299,'he','×ž×•',0),(550749,15299,'el','Mo',0),(550750,15299,'zh','èŽ«',0),(550751,15299,'sv','Mo',0),(550752,15299,'it','Mo',0),(550753,15299,'tl','',0),(550754,15299,'th','Mo',0),(550755,15299,'hi','à¤®à¥‹',0),(550756,15299,'ms','MO',0),(550757,15299,'ar','Ù…Ùˆ',0),(550758,15299,'fr','Mo',0),(550759,15299,'jp','Mo',0),(550760,15299,'pt','Mo',0),(550761,15299,'ru','Mo',0),(550762,15299,'es','Mo',0),(550763,15299,'de','Mo',0),(550764,15299,'en','Mo',0),(550765,15300,'is','',0),(550766,15300,'dr','ØªØºÛŒÛŒØ± Ø§Ø´ØªØ±Ø§Ú©',0),(550767,15300,'pr','ØªØºÛŒÛŒØ± Ø§Ø´ØªØ±Ø§Ú©',0),(550768,15300,'tr','Abonelik deÄŸiÅŸiklikleri',0),(550769,15300,'pl','Subskrypcja zmian',0),(550770,15300,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ Ð² Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚Ð°',0),(550771,15300,'ur','Ø±Ú©Ù†ÛŒØª Ú©ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(550772,15300,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ðµ Ñƒ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ñƒ Ð½Ð°',0),(550773,15300,'vi','Thay Ä‘á»•i Ä‘Äƒng kÃ½',0),(550774,15300,'af','Intekengeld veranderinge',0),(550775,15300,'ro','Abonament modificÄƒri',0),(550776,15300,'et','Tellimus muutused',0),(550777,15300,'si','Vpis spremembe',0),(550778,15300,'ba','Berlangganan perubahan',0),(550779,15300,'nl','Abonnement wijzigingen',0),(550780,15300,'fi','Tilausmuutokset',0),(550781,15300,'no','Abonnement endringer',0),(550782,15300,'da','Abonnement Ã¦ndringer',0),(550783,15300,'ko','êµ¬ë… ë³€ê²½',0),(550784,15300,'he','×ž× ×•×™ ×©×™× ×•×™×™×',0),(550785,15300,'el','Î‘Î»Î»Î±Î³Î® ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®Ï‚',0),(550786,15300,'zh','è®¢é˜…çš„å˜åŒ–',0),(550787,15300,'sv','Ã„ndringar av abonnemang',0),(550788,15300,'it','Modifiche di sottoscrizione',0),(550789,15300,'tl','',0),(550790,15300,'th','à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸ªà¸¡à¸²à¸Šà¸´à¸',0),(550791,15300,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(550792,15300,'ms','Perubahan yuran',0),(550793,15300,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(550794,15300,'fr','Changements d\'attribution',0),(550795,15300,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã®å¤‰æ›´',0),(550796,15300,'pt','AlteraÃ§Ãµes de subscriÃ§Ã£o',0),(550797,15300,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ¸',0),(550798,15300,'es','Cambios de suscripciÃ³n',0),(550799,15300,'de','Abonnement-Ã„nderungen',0),(550800,15300,'en','Subscription Changes',0),(550801,15301,'is','',0),(550802,15301,'dr','Ù…Ø¯ÛŒØ±ÛŒØª ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ø§Ø´ØªØ±Ø§Ú©',0),(550803,15301,'pr','Ù…Ø¯ÛŒØ±ÛŒØª ÙˆÛŒÚ˜Ú¯ÛŒ Ù‡Ø§ÛŒ Ø§Ø´ØªØ±Ø§Ú©',0),(550804,15301,'tr','Abonelik Ã¶zelliklerini yÃ¶netme',0),(550805,15301,'pl','ZarzÄ…dzanie funkcjami subskrypcja',0),(550806,15301,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ð¸',0),(550807,15301,'ur','Ø±Ú©Ù†ÛŒØª Ú©ÛŒ Ø®ØµÙˆØµÛŒØ§Øª Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±ÛŒÚº',0),(550808,15301,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð°Ð¼Ð° Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(550809,15301,'vi','Quáº£n lÃ½ tÃ­nh nÄƒng Ä‘Äƒng kÃ½',0),(550810,15301,'af','Bestuur intekengeld kenmerke',0),(550811,15301,'ro','Gestiona abonament caracteristici',0),(550812,15301,'et','Tellimus funktsioonide haldamine',0),(550813,15301,'si','Upravljanje naroÄnine funkcij',0),(550814,15301,'ba','Mengelola fitur berlangganan',0),(550815,15301,'nl','Abonnementsfuncties beheren',0),(550816,15301,'fi','Tilauksen toimintojen hallinta',0),(550817,15301,'no','Administrere abonnementsfunksjonene',0),(550818,15301,'da','Administrere abonnement funktioner',0),(550819,15301,'ko','êµ¬ë… ê¸°ëŠ¥ì„ ê´€ë¦¬',0),(550820,15301,'he','×œ× ×”×œ ××ª ×ª×›×•× ×•×ª ×ž× ×•×™',0),(550821,15301,'el','Î”Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ· ÏƒÏ…Î½Î´ÏÎ¿Î¼Î® Ï‡Î±ÏÎ±ÎºÏ„Î·ÏÎ¹ÏƒÏ„Î¹ÎºÎ¬',0),(550822,15301,'zh','ç®¡ç†è®¢é˜…åŠŸèƒ½',0),(550823,15301,'sv','Hantera abonnemang funktioner',0),(550824,15301,'it','Gestire le funzionalitÃ  di sottoscrizione',0),(550825,15301,'tl','',0),(550826,15301,'th','à¸ˆà¸±à¸”à¸à¸²à¸£à¸„à¸¸à¸“à¸ªà¸¡à¸šà¸±à¸•à¸´à¸‚à¸­à¸‡à¸ªà¸¡à¸²à¸Šà¸´à¸',0),(550827,15301,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤¸à¥à¤µà¤¿à¤§à¤¾à¤“à¤‚ à¤•à¤¾ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨ à¤•à¤°à¥‡à¤‚',0),(550828,15301,'ms','Uruskan ciri-ciri langganan',0),(550829,15301,'ar','Ø¥Ø¯Ø§Ø±Ø© Ù…ÙŠØ²Ø§Øª Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(550830,15301,'fr','GÃ©rer les fonctionnalitÃ©s de l\'abonnement',0),(550831,15301,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³æ©Ÿèƒ½ã‚’ç®¡ç†ã—ã¾ã™ã€‚',0),(550832,15301,'pt','Gerenciar os recursos de assinatura',0),(550833,15301,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ÑÑ‚ÑÐ¼Ð¸ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ¸',0),(550834,15301,'es','AdministraciÃ³n de caracterÃ­sticas de la suscripciÃ³n',0),(550835,15301,'de','Abonnement-Funktionen verwalten',0),(550836,15301,'en','Manage Subscription Features',0),(550837,15302,'is','',0),(550838,15302,'dr','Ù‡ÛŒÚ† Ø§Ø´ØªØ±Ø§Ú© ÙØ¹Ø§Ù„ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(550839,15302,'pr','Ù‡ÛŒÚ† Ø§Ø´ØªØ±Ø§Ú© ÙØ¹Ø§Ù„ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(550840,15302,'tr','HiÃ§bir etkin abonelik bulundu',0),(550841,15302,'pl','Nie aktywnych subskrypcja',0),(550842,15302,'bg','ÐÐµ Ðµ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚ Ð°ÐºÑ‚Ð¸Ð²ÐµÐ½ Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(550843,15302,'ur','Ú©ÙˆØ¦ÛŒ ÙØ¹Ø§Ù„ Ø±Ú©Ù†ÛŒØª Ù…Ù„ÛŒ',0),(550844,15302,'sr','ÐÐµÐ¼Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ñƒ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ñƒ Ð½Ð°ÑˆÐ°Ð¾',0),(550845,15302,'vi','KhÃ´ng cÃ³ Ä‘Äƒng kÃ½ hoáº¡t Ä‘á»™ng tÃ¬m tháº¥y',0),(550846,15302,'af','Geen aktiewe subskripsie gevind',0),(550847,15302,'ro','FÄƒrÄƒ abonament activ gÄƒsit',0),(550848,15302,'et','Aktiivne tellimust ei leitud',0),(550849,15302,'si','Ni aktivnih naroÄnine',0),(550850,15302,'ba','Tidak berlangganan aktif yang ditemukan',0),(550851,15302,'nl','Geen actieve abonnement gevonden',0),(550852,15302,'fi','Aktiivinen tilausta ei lÃ¶ytynyt',0),(550853,15302,'no','Ingen aktivt abonnement funnet',0),(550854,15302,'da','Ingen aktive abonnement fundet',0),(550855,15302,'ko','ì—†ìŒ í™œì„± êµ¬ë… ë°œê²¬',0),(550856,15302,'he','××™×Ÿ ×ž× ×•×™ ×¤×¢×™×œ ×©× ×ž×¦××•',0),(550857,15302,'el','ÎšÎ±Î¼Î¯Î± ÎµÎ½ÎµÏÎ³Î® ÏƒÏ…Î½Î´ÏÎ¿Î¼Î® Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(550858,15302,'zh','æ‰¾ä¸åˆ°æ´»åŠ¨è®¢é˜…',0),(550859,15302,'sv','Ingen aktiv prenumeration hittade',0),(550860,15302,'it','Nessun abbonamento attivo trovato',0),(550861,15302,'tl','',0),(550862,15302,'th','à¸ªà¸¡à¸±à¸„à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¹„à¸¡à¹ˆà¸žà¸š',0),(550863,15302,'hi','à¤•à¥‹à¤ˆ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤ªà¤¾à¤¯à¤¾',0),(550864,15302,'ms','Langganan tidak aktif mendapati',0),(550865,15302,'ar','Ù„Ø§ Ø§Ø´ØªØ±Ø§Ùƒ Ù†Ø´Ø· Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(550866,15302,'fr','Aucun abonnement actif trouvÃ©',0),(550867,15302,'jp','ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ãŒè¦‹ã¤ã‹ã‚‰ãªã„',0),(550868,15302,'pt','Sem assinatura ativa encontrada',0),(550869,15302,'ru','ÐÐºÑ‚Ð¸Ð²Ð½Ñ‹Ðµ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°',0),(550870,15302,'es','Ninguna suscripciÃ³n activa encontrÃ³',0),(550871,15302,'de','Kein aktives Abonnement gefunden',0),(550872,15302,'en','No Active Subscription Found',0),(550873,15303,'is','',0),(550874,15303,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø´ØªØ±Ø§Ú©',0),(550875,15303,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø´ØªØ±Ø§Ú©',0),(550876,15303,'tr','Abonelik Ã¼creti',0),(550877,15303,'pl','OpÅ‚ata abonamentowa',0),(550878,15303,'bg','ÐÐ±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(550879,15303,'ur','Ø±Ú©Ù†ÛŒØª Ú©ÛŒ ÙÛŒØ³',0),(550880,15303,'sr','ÐŸÑ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ð° ÑÐµ Ð½Ð°Ð¿Ð»Ð°Ñ›ÑƒÑ˜Ðµ',0),(550881,15303,'vi','Lá»‡ phÃ­ Ä‘Äƒng kÃ½',0),(550882,15303,'af','Fooi',0),(550883,15303,'ro','Taxa de abonament',0),(550884,15303,'et','Liitumistasu',0),(550885,15303,'si','NaroÄnino',0),(550886,15303,'ba','Biaya berlangganan',0),(550887,15303,'nl','Abonnementskosten',0),(550888,15303,'fi','Perusmaksu',0),(550889,15303,'no','Abonnementsavgift',0),(550890,15303,'da','Abonnementsafgift',0),(550891,15303,'ko','êµ¬ë… ë£Œ',0),(550892,15303,'he','×“×ž×™ ×ž× ×•×™',0),(550893,15303,'el','Î£Ï…Î½Î´ÏÎ¿Î¼Î®',0),(550894,15303,'zh','è®¢é˜…è´¹',0),(550895,15303,'sv','Abonnemangsavgift',0),(550896,15303,'it','Canone di abbonamento',0),(550897,15303,'tl','',0),(550898,15303,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¸šà¸­à¸à¸£à¸±à¸šà¹€à¸›à¹‡à¸™à¸ªà¸¡à¸²à¸Šà¸´à¸',0),(550899,15303,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤¶à¥à¤²à¥à¤•',0),(550900,15303,'ms','Yuran langganan',0),(550901,15303,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(550902,15303,'fr','Prix de l\'abonnement',0),(550903,15303,'jp','è³¼èª­æ–™',0),(550904,15303,'pt','Taxa de inscriÃ§Ã£o',0),(550905,15303,'ru','ÐÐ±Ð¾Ð½ÐµÐ½Ñ‚ÑÐºÐ°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(550906,15303,'es','Tarifa de suscripciÃ³n',0),(550907,15303,'de','Abo-GebÃ¼hr',0),(550908,15303,'en','Subscription Fee',0),(550909,15304,'is','',0),(550910,15304,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù…Ø­ØµÙˆÙ„ Ù†Ø§Ù… Ø¯Ø± 3dcart',0),(550911,15304,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù…Ø­ØµÙˆÙ„ Ù†Ø§Ù… Ø¯Ø± 3dcart',0),(550912,15304,'tr','3dcart, Ã¼rÃ¼n adlarÄ± gÃ¼ncelleÅŸtiriliyor',0),(550913,15304,'pl','Aktualizowanie nazw produktÃ³w w 3dcart',0),(550914,15304,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ½Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¸Ñ‚Ðµ Ð² 3dcart',0),(550915,15304,'ur','Ù…ØµÙ†ÙˆØ¹Û Ù†Ø§Ù… 3dcart Ù¾Ø± ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(550916,15304,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¸Ð¼ÐµÐ½Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð° Ð½Ð° 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(550917,15304,'vi','TÃªn sáº£n pháº©m Cáº­p Nháº­t táº¡i 3dcart',0),(550918,15304,'af','Outobywerking produk name by 3dcart',0),(550919,15304,'ro','Actualizarea nume de produs la 3dcart',0),(550920,15304,'et','Ajakohastamine tootenimetusi kell 3dcart',0),(550921,15304,'si','Posodabljanje imena izdelkov v 3dcart',0),(550922,15304,'ba','Memperbarui nama produk di 3dcart',0),(550923,15304,'nl','Productnamen op 3dcart bijwerken',0),(550924,15304,'fi','PÃ¤ivittÃ¤Ã¤ tuotteiden nimet 3dcart',0),(550925,15304,'no','Oppdatere produktnavn pÃ¥ 3dcart',0),(550926,15304,'da','Opdatering af navne pÃ¥ 3dcart',0),(550927,15304,'ko','3dcartì—ì„œ ì œí’ˆ ì´ë¦„ ì—…ë°ì´íŠ¸',0),(550928,15304,'he','×¢×“×›×•×Ÿ ×©×ž×•×ª ×ž×•×¦×¨×™×-3dcart',0),(550929,15304,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¿Ï… Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚ Î¿Î½ÏŒÎ¼Î±Ï„Î± ÏƒÏ„Î¿ 3dcart',0),(550930,15304,'zh','åœ¨ 3dcart çš„æ›´æ–°äº§å“åç§°ã€‚',0),(550931,15304,'sv','Uppdatera produktnamn pÃ¥ 3dcart',0),(550932,15304,'it','Aggiornamento dei nomi di prodotto presso 3dcart',0),(550933,15304,'tl','',0),(550934,15304,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸Šà¸·à¹ˆà¸­à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¸—à¸µà¹ˆ 3dcart',0),(550935,15304,'hi','3dcart à¤ªà¤° à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤¨à¤¾à¤®à¥‹à¤‚ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(550936,15304,'ms','Mengemaskini nama produk di 3dcart',0),(550937,15304,'ar','ØªØ­Ø¯ÙŠØ« Ø£Ø³Ù…Ø§Ø¡ Ø§Ù„Ù…Ù†ØªØ¬Ø§Øª ÙÙŠ 3dcart',0),(550938,15304,'fr','Mise Ã  jour des noms de produits Ã  3dcart',0),(550939,15304,'jp','è£½å“åã‚’ 3dcart ã«æ›´æ–°',0),(550940,15304,'pt','Atualizando os nomes de produto em 3dcart',0),(550941,15304,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ð¹ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð² Ð² 3dcart',0),(550942,15304,'es','ActualizaciÃ³n de nombres de productos en 3dcart',0),(550943,15304,'de','Aktualisieren von Produktnamen bei 3dcart',0),(550944,15304,'en','Updating Product Names At 3dcart',0),(550945,15305,'is','',0),(550946,15305,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ÙˆØ²Ù† Ø¯Ø± 3dcart',0),(550947,15305,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ÙˆØ²Ù† Ø¯Ø± 3dcart',0),(550948,15305,'tr','GÃ¼ncelleÅŸtirme aÄŸÄ±rlÄ±k vasÄ±l 3dcart',0),(550949,15305,'pl','Aktualizowanie wagi w 3dcart',0),(550950,15305,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐ¶ÐµÑÑ‚Ð¸ Ð² 3dcart',0),(550951,15305,'ur','Ø¨Ø§Ù¹ 3dcart Ù¾Ø± ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(550952,15305,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚ÐµÐ³Ð¾Ð²Ðµ Ð½Ð° 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(550953,15305,'vi','CÃ¡c trá»ng lÆ°á»£ng Cáº­p Nháº­t táº¡i 3dcart',0),(550954,15305,'af','Outobywerking gewigte by 3dcart',0),(550955,15305,'ro','Actualizarea greutÄƒÅ£i la 3dcart',0),(550956,15305,'et','Ajakohastamine kaalud kell 3dcart',0),(550957,15305,'si','Posodabljanje uteÅ¾i na 3dcart',0),(550958,15305,'ba','Memperbarui beban pada 3dcart',0),(550959,15305,'nl','Bijwerken van gewichten op 3dcart',0),(550960,15305,'fi','PÃ¤ivittÃ¤minen painot 3dcart',0),(550961,15305,'no','Oppdatere vekter pÃ¥ 3dcart',0),(550962,15305,'da','Opdatering af vÃ¦gte pÃ¥ 3dcart',0),(550963,15305,'ko','3dcartì—ì„œ ë¬´ê²Œë¥¼ ì—…ë°ì´íŠ¸',0),(550964,15305,'he','×¢×“×›×•×Ÿ ×ž×©×§×•×œ×•×ª-3dcart',0),(550965,15305,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î²Î¬ÏÎ· ÏƒÏ„Î¿ 3dcart',0),(550966,15305,'zh','åœ¨ 3dcart æ›´æ–°æƒé‡',0),(550967,15305,'sv','Uppdatering av vikter pÃ¥ 3dcart',0),(550968,15305,'it','Aggiornamento dei pesi alle 3dcart',0),(550969,15305,'tl','',0),(550970,15305,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸™à¹‰à¸³à¸«à¸™à¸±à¸à¸—à¸µà¹ˆ 3dcart',0),(550971,15305,'hi','à¤­à¤¾à¤° 3dcart à¤ªà¤° à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(550972,15305,'ms','Mengemaskini berat pada 3dcart',0),(550973,15305,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø£ÙˆØ²Ø§Ù† ÙÙŠ 3dcart',0),(550974,15305,'fr','Mise Ã  jour des pondÃ©rations Ã  3dcart',0),(550975,15305,'jp','3dcart ã§ã‚¦ã‚§ã‚¤ãƒˆã®æ›´æ–°',0),(550976,15305,'pt','Atualizando os pesos no 3dcart',0),(550977,15305,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð²ÐµÑÐ¾Ð² 3dcart',0),(550978,15305,'es','Actualizar pesos a 3dcart',0),(550979,15305,'de','Aktualisieren Gewichte zur 3dcart',0),(550980,15305,'en','Updating Weights At 3dcart',0),(550981,15306,'is','',0),(550982,15306,'dr','3dcart Ù…Ø­ØµÙˆÙ„ ØµÙØ­Ù‡',0),(550983,15306,'pr','3dcart Ù…Ø­ØµÙˆÙ„ ØµÙØ­Ù‡',0),(550984,15306,'tr','3dcart Ã¼rÃ¼n sayfasÄ±',0),(550985,15306,'pl','3dcart Strona produktu',0),(550986,15306,'bg','3dcart Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(550987,15306,'ur','3dcart Ù…ØµÙ†ÙˆØ¹Ø§Øª ØµÙØ­Û',0),(550988,15306,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(550989,15306,'vi','3dcart sáº£n pháº©m trang',0),(550990,15306,'af','3dcart produk bladsy',0),(550991,15306,'ro','Pagina de produs 3dcart',0),(550992,15306,'et','3dcart toote Page',0),(550993,15306,'si','3dcart zmnoÅ¾ek stran',0),(550994,15306,'ba','Halaman produk 3dcart',0),(550995,15306,'nl','3dcart productpagina',0),(550996,15306,'fi','3dcart tuotesivu',0),(550997,15306,'no','3dcart siden',0),(550998,15306,'da','3dcart produktside',0),(550999,15306,'ko','3dcart ì œí’ˆ íŽ˜ì´ì§€',0),(551000,15306,'he','×“×£ ×ž×•×¦×¨ 3dcart',0),(551001,15306,'el','Î£ÎµÎ»Î¯Î´Î± Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚ 3dcart',0),(551002,15306,'zh','3dcart äº§å“é¡µé¢',0),(551003,15306,'sv','3dcart produktsida',0),(551004,15306,'it','3Dcart prodotto pagina',0),(551005,15306,'tl','',0),(551006,15306,'th','à¸«à¸™à¹‰à¸²à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¸£à¸¸à¹ˆà¸™ 3dcart',0),(551007,15306,'hi','3dcart à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤ªà¥ƒà¤·à¥à¤ ',0),(551008,15306,'ms','Laman produk 3dcart',0),(551009,15306,'ar','ØµÙØ­Ø© Ø§Ù„Ù…Ù†ØªØ¬ 3dcart',0),(551010,15306,'fr','Page du produit 3Dcart',0),(551011,15306,'jp','3dcart è£½å“ãƒšãƒ¼ã‚¸',0),(551012,15306,'pt','pÃ¡gina do produto 3Dcart',0),(551013,15306,'ru','Ð¡Ñ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð° 3dcart',0),(551014,15306,'es','PÃ¡gina del producto 3DCart',0),(551015,15306,'de','3dcart-Produktseite',0),(551016,15306,'en','3dcart Product Page',0),(551017,15307,'is','',0),(551018,15307,'dr','ØªØ§ÙŠÙŠØ¯ÙŠÙ‡',0),(551019,15307,'pr','ØªØ§ÙŠÙŠØ¯ÙŠÙ‡',0),(551020,15307,'tr','OnaylarÄ±',0),(551021,15307,'pl','PotwierdzeÅ„',0),(551022,15307,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(551023,15307,'ur','Ú©ÙˆÙ†ÙØ±Ù…Ù¹Ø§Ù†Ø³',0),(551024,15307,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ðµ',0),(551025,15307,'vi','Giáº¥y tá» xÃ¡c nháº­n',0),(551026,15307,'af','Confirmations',0),(551027,15307,'ro','ConfirmÄƒri',0),(551028,15307,'et','Kinnitused',0),(551029,15307,'si','Potrditev',0),(551030,15307,'ba','Konfirmasi',0),(551031,15307,'nl','Bevestigingen',0),(551032,15307,'fi','Vahvistukset',0),(551033,15307,'no','Konfirmasjon',0),(551034,15307,'da','BekrÃ¦ftelser',0),(551035,15307,'ko','ì£¼ë¬¸ í™•ì¸',0),(551036,15307,'he','××™×©×•×¨×™',0),(551037,15307,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎµÎ¹Ï‚',0),(551038,15307,'zh','ç¡®è®¤',0),(551039,15307,'sv','BekrÃ¤ftelser',0),(551040,15307,'it','Conferme',0),(551041,15307,'tl','',0),(551042,15307,'th','à¸¢à¸·à¸™à¸¢à¸±à¸™',0),(551043,15307,'hi','à¤ªà¥à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚',0),(551044,15307,'ms','Pengesahan',0),(551045,15307,'ar','Ø¥Ù‚Ø±Ø§Ø± Ø§Ù„ØªØ¹ÙŠÙŠÙ†Ø§Øª',0),(551046,15307,'fr','Confirmations',0),(551047,15307,'jp','ç¢ºèª',0),(551048,15307,'pt','ConfirmaÃ§Ãµes',0),(551049,15307,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(551050,15307,'es','Mensajes de confirmaciÃ³n',0),(551051,15307,'de','BestÃ¤tigungen',0),(551052,15307,'en','Confirmations',0),(551053,15308,'is','',0),(551054,15308,'dr','Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙˆÛŒØ±Ø§ÛŒØ´ Ø¯Ø³ØªÙ‡ Ø¬Ù…Ø¹ÛŒ',0),(551055,15308,'pr','Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙˆÛŒØ±Ø§ÛŒØ´ Ø¯Ø³ØªÙ‡ Ø¬Ù…Ø¹ÛŒ',0),(551056,15308,'tr','Ã–ÄŸe maliyeti Toplu DÃ¼zenle',0),(551057,15308,'pl','Element kosztÃ³w masowej edycji',0),(551058,15308,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ» Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¼Ð°ÑÐ¾Ð²Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(551059,15308,'ur','Ø´Û’ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ø¨Ú‘Û’ Ù¾ÛŒÙ…Ø§Ù†Û’ Ù¾Ø± ØªØ¯ÙˆÛŒÙ†',0),(551060,15308,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¼Ð°ÑÐ¾Ð²Ð½Ð¾ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(551061,15308,'vi','Má»¥c chi phÃ­ chá»‰nh sá»­a hÃ ng loáº¡t',0),(551062,15308,'af','Item koste massa redigeer',0),(551063,15308,'ro','Element costurile Mass Edit',0),(551064,15308,'et','Ãœksuse maksab massi Edit',0),(551065,15308,'si','StroÅ¡ke artikla mnoÅ¾iÄno urejanje',0),(551066,15308,'ba','Item biaya massa Edit',0),(551067,15308,'nl','Item kosten massa bewerken',0),(551068,15308,'fi','Nimikkeen kustannukset massasta Edit',0),(551069,15308,'no','Varen koster masse Rediger',0),(551070,15308,'da','Vare omkostninger masse Rediger',0),(551071,15308,'ko','í•­ëª© ë¹„ìš© ëŒ€ëŸ‰ íŽ¸ì§‘',0),(551072,15308,'he','×¤×¨×™×˜ ×¢×œ×•×™×•×ª ×¢×¨×™×›×ª ×”×ž×•× ×™×ª',0),(551073,15308,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î¼Î±Î¶Î¹ÎºÎ® ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(551074,15308,'zh','é¡¹ç›®æˆæœ¬æ‰¹é‡ç¼–è¾‘',0),(551075,15308,'sv','Objektet kostar massa redigera',0),(551076,15308,'it','Elemento costi massa modifica',0),(551077,15308,'tl','',0),(551078,15308,'th','à¹à¸à¹‰à¹„à¸‚à¹‚à¸”à¸¢à¸£à¸§à¸¡à¸‚à¸­à¸‡à¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(551079,15308,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤²à¤¾à¤—à¤¤ à¤œà¤¨ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(551080,15308,'ms','Item kos jisim Edit',0),(551081,15308,'ar','Ø§Ù„Ø¨Ù†Ø¯ ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„ØªØ­Ø±ÙŠØ± Ø§Ù„Ø´Ø§Ù…Ù„',0),(551082,15308,'fr','Ã‰lÃ©ment coÃ»ts masse Edit',0),(551083,15308,'jp','ã‚¢ã‚¤ãƒ†ãƒ  ã‚³ã‚¹ãƒˆã®ä¸€æ‹¬ç·¨é›†',0),(551084,15308,'pt','Item custos de ediÃ§Ã£o em massa',0),(551085,15308,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð¼Ð°ÑÑÐ¾Ð²Ð¾Ð³Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ',0),(551086,15308,'es','Tema costos ediciÃ³n masiva',0),(551087,15308,'de','Elements Kosten Mass Edit',0),(551088,15308,'en','Item Costs Mass Edit',0),(551089,15309,'is','',0),(551090,15309,'dr','Ú©Ø§Ø±ØªØ®ÙˆØ§Ù† Ù‡Ù…Ø±Ø§Ù‡ Ù†ÛŒØ§Ø² Ø¨Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§ÙØ²ÙˆØ¯Ù†ÛŒ',0),(551091,15309,'pr','Ú©Ø§Ø±ØªØ®ÙˆØ§Ù† Ù‡Ù…Ø±Ø§Ù‡ Ù†ÛŒØ§Ø² Ø¨Ù‡ Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§ÙØ²ÙˆØ¯Ù†ÛŒ',0),(551092,15309,'tr','Mobil POS stok eklemek-Ã¼stÃ¼nde gerektirir',0),(551093,15309,'pl','Mobilne POS wymaga rozszerzenia zapasÃ³w',0),(551094,15309,'bg','ÐœÐ¾Ð±Ð¸Ð»Ð½Ð¸ ÐŸÐžÐ¡ Ð¸Ð·Ð¸ÑÐºÐ²Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²ÐºÐ°',0),(551095,15309,'ur','Ù…ÙˆØ¨Ø§Ø¦Ù„ Ù¾ÙˆØ²ÛŒØ´Ù† Ù…ØªØ­Ø¯Û Ù…ÛŒÚº Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¨Ø±-Ø§ Ø¶Ø§ÙÛ Ø¯Ø±Ú©Ø§Ø± ÛÛ’',0),(551096,15309,'sr','ÐœÐ¾Ð±Ð¸Ð»Ð½Ð¸ ÐŸÐžÐ¡ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð´Ð¾Ð´Ð°Ñ‚Ð°Ðº Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(551097,15309,'vi','POS di Ä‘á»™ng Ä‘Ã²i há»i Tiá»‡n Ã­ch hÃ ng tá»“n kho',0),(551098,15309,'af','Mobiele POS voorraad byvoegsel vereis',0),(551099,15309,'ro','POS mobil necesitÄƒ supliment de inventar',0),(551100,15309,'et','Mobiilne POS nÃµuab varude lisandmoodul',0),(551101,15309,'si','Mobilne POS zahteva zaloge dodatek',0),(551102,15309,'ba','Mobile POS memerlukan persediaan Add-on',0),(551103,15309,'nl','Mobiele POS vereist inventaris Add-on',0),(551104,15309,'fi','Mobiili POS edellyttÃ¤Ã¤ varaston laajennus',0),(551105,15309,'no','Mobile POS krever lager Add-on',0),(551106,15309,'da','Mobile POS krÃ¦ver lager tilfÃ¸jelse',0),(551107,15309,'ko','ëª¨ë°”ì¼ POS ìž¬ê³  ì¶”ê°€ í•„ìš”',0),(551108,15309,'he','×§×•×¤×” × ×™×™×“ ×“×•×¨×© ×”×¨×—×‘×” ×ž×œ××™',0),(551109,15309,'el','ÎšÎ¹Î½Î·Ï„ÏŒ POS Î±Ï€Î±Î¹Ï„ÎµÎ¯ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(551110,15309,'zh','ç§»åŠ¨ POS éœ€è¦åº“å­˜åŠ è½½é¡¹',0),(551111,15309,'sv','Mobile POS krÃ¤ver inventering tillÃ¤gg',0),(551112,15309,'it','POS mobile richiede il componente aggiuntivo per inventario',0),(551113,15309,'tl','',0),(551114,15309,'th','POS à¸¡à¸·à¸­à¸–à¸·à¸­à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(551115,15309,'hi','à¤®à¥‹à¤¬à¤¾à¤‡à¤² POS à¤‡à¤¨à¥à¤µà¥‡à¤‚à¤Ÿà¤°à¥€ à¤à¤¡-à¤‘à¤¨ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥‹à¤¤à¥€ à¤¹à¥ˆ',0),(551116,15309,'ms','POS mudah alih memerlukan tambahan inventori',0),(551117,15309,'ar','Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ù…ØªÙ†Ù‚Ù„Ø© ÙŠØªØ·Ù„Ø¨ Ù…Ø®Ø²ÙˆÙ† Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø¶Ø§ÙÙŠØ©',0),(551118,15309,'fr','POS mobile nÃ©cessite le module inventaire',0),(551119,15309,'jp','ãƒ¢ãƒã‚¤ãƒ« POS åœ¨åº«ã‚¢ãƒ‰ã‚ªãƒ³ãŒå¿…è¦ã§ã™ã€‚',0),(551120,15309,'pt','POS mÃ³vel requer complemento de inventÃ¡rio',0),(551121,15309,'ru','ÐœÐ¾Ð±Ð¸Ð»ÑŒÐ½Ñ‹Ð¹ POS Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(551122,15309,'es','POS mÃ³viles requiere inventario adicional',0),(551123,15309,'de','Mobile POS erfordert Inventory Add-ons anzeigen',0),(551124,15309,'en','Mobile POS Requires Inventory Add-on',0),(551125,15310,'is','',0),(551126,15310,'dr','Ø§ÙØ²Ø§ÛŒØ´ Ù…Ø­Ø¯ÙˆØ¯ÛŒØª',0),(551127,15310,'pr','Ø§ÙØ²Ø§ÛŒØ´ Ù…Ø­Ø¯ÙˆØ¯ÛŒØª',0),(551128,15310,'tr','SÄ±nÄ±rÄ±nÄ± artÄ±rÄ±n',0),(551129,15310,'pl','ZwiÄ™kszenie limitu',0),(551130,15310,'bg','Ð£Ð²ÐµÐ»Ð¸Ñ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð»Ð¸Ð¼Ð¸Ñ‚Ð°',0),(551131,15310,'ur','Ú©ÛŒ Ø­Ø¯ Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ',0),(551132,15310,'sr','ÐŸÐ¾Ð²ÐµÑ›Ð°Ñ˜Ñ‚Ðµ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÑšÐµ',0),(551133,15310,'vi','TÄƒng giá»›i háº¡n',0),(551134,15310,'af','Verhoog beperk',0),(551135,15310,'ro','MÄƒri limita de',0),(551136,15310,'et','Limiidi suurendamine',0),(551137,15310,'si','PoveÄanje omejitve',0),(551138,15310,'ba','Meningkatkan batas',0),(551139,15310,'nl','Limiet verhogen',0),(551140,15310,'fi','LisÃ¤tÃ¤ raja',0),(551141,15310,'no','Ã˜ke grensen',0),(551142,15310,'da','Ã˜ge grÃ¦nsen',0),(551143,15310,'ko','ì œí•œ ì¦ê°€',0),(551144,15310,'he','×”×’×“×œ×ª ×ž×’×‘×œ×ª',0),(551145,15310,'el','Î‘ÏÎ¾Î·ÏƒÎ· Ï„Î¿Ï… Î¿ÏÎ¯Î¿Ï…',0),(551146,15310,'zh','å¢žåŠ é™åˆ¶',0),(551147,15310,'sv','Ã–ka grÃ¤nsen',0),(551148,15310,'it','Aumento del limite',0),(551149,15310,'tl','',0),(551150,15310,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸§à¸‡à¹€à¸‡à¸´à¸™',0),(551151,15310,'hi','à¤¸à¥€à¤®à¤¾ à¤®à¥‡à¤‚ à¤µà¥ƒà¤¦à¥à¤§à¤¿',0),(551152,15310,'ms','Meningkatkan had',0),(551153,15310,'ar','Ø²ÙŠØ§Ø¯Ø© Ø§Ù„Ø­Ø¯',0),(551154,15310,'fr','Augmenter la limite de',0),(551155,15310,'jp','åˆ¶é™ã‚’å¢—ã‚„ã™',0),(551156,15310,'pt','Aumentar limite',0),(551157,15310,'ru','Ð£Ð²ÐµÐ»Ð¸Ñ‡ÐµÐ½Ð¸Ðµ Ð»Ð¸Ð¼Ð¸Ñ‚Ð°',0),(551158,15310,'es','Aumento de lÃ­mite',0),(551159,15310,'de','Limit erhÃ¶hen',0),(551160,15310,'en','Increase Limit',0),(551161,15311,'is','',0),(551162,15311,'dr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ø²',0),(551163,15311,'pr','Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ø²',0),(551164,15311,'tr','Hareketleri beri',0),(551165,15311,'pl','Transakcji od',0),(551166,15311,'bg','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð¾Ñ‚',0),(551167,15311,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©Û’ Ø¨Ø¹Ø¯',0),(551168,15311,'sr','Ð¢Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ Ð¾Ð´',0),(551169,15311,'vi','CÃ¡c giao dá»‹ch tá»«',0),(551170,15311,'af','Transaksies sedert',0),(551171,15311,'ro','TranzacÅ£iile din',0),(551172,15311,'et','Tehingud alates',0),(551173,15311,'si','Transakcije od',0),(551174,15311,'ba','Transaksi sejak',0),(551175,15311,'nl','Transacties sinds',0),(551176,15311,'fi','Tapahtumien jÃ¤lkeen',0),(551177,15311,'no','Transaksjoner siden',0),(551178,15311,'da','Transaktioner siden',0),(551179,15311,'ko','ì´í›„ ê±°ëž˜',0),(551180,15311,'he','×ª× ×•×¢×•×ª ×ž××–',0),(551181,15311,'el','Î£Ï…Î½Î±Î»Î»Î±Î³Î­Ï‚ Î±Ï€ÏŒ Ï„Î¿',0),(551182,15311,'zh','è‡ªäº¤æ˜“',0),(551183,15311,'sv','Transaktioner sedan',0),(551184,15311,'it','Transazioni dal',0),(551185,15311,'tl','',0),(551186,15311,'th','à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸•à¸±à¹‰à¸‡à¹à¸•à¹ˆ',0),(551187,15311,'hi','à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¥‡ à¤²à¥‡à¤¨à¤¦à¥‡à¤¨',0),(551188,15311,'ms','Transaksi sejak',0),(551189,15311,'ar','Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ù…Ù†Ø°',0),(551190,15311,'fr','Transactions depuis',0),(551191,15311,'jp','ä»¥é™ã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³',0),(551192,15311,'pt','TransaÃ§Ãµes desde',0),(551193,15311,'ru','Ð¡Ð´ÐµÐ»ÐºÐ¸ Ñ',0),(551194,15311,'es','Transacciones desde',0),(551195,15311,'de','Transaktionen seit',0),(551196,15311,'en','Transactions Since',0),(551197,15312,'is','',0),(551198,15312,'dr','Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù…Ø­Ø¯ÙˆØ¯',0),(551199,15312,'pr','Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù…Ø­Ø¯ÙˆØ¯',0),(551200,15312,'tr','Ä°ÅŸlem sÄ±nÄ±rÄ±',0),(551201,15312,'pl','Limit transakcji',0),(551202,15312,'bg','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ Ð³Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(551203,15312,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø­Ø¯',0),(551204,15312,'sr','ÐžÐ³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÑšÐµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð°',0),(551205,15312,'vi','Giá»›i háº¡n giao dá»‹ch',0),(551206,15312,'af','Transaksie-limiet',0),(551207,15312,'ro','LimitÄƒ de tranzacÅ£ie',0),(551208,15312,'et','Kande limiit',0),(551209,15312,'si','Mejne transakcije',0),(551210,15312,'ba','Limit transaksi',0),(551211,15312,'nl','Transactie limiet',0),(551212,15312,'fi','Tapahtuman raja',0),(551213,15312,'no','Grense',0),(551214,15312,'da','Transaktionen grÃ¦nse',0),(551215,15312,'ko','ê±°ëž˜ ì œí•œ',0),(551216,15312,'he','×ž×’×‘×œ×ª ×”×ª× ×•×¢×”',0),(551217,15312,'el','ÎŒÏÎ¹Î¿ ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½',0),(551218,15312,'zh','äº¤æ˜“é™é¢',0),(551219,15312,'sv','Transaktion grÃ¤ns',0),(551220,15312,'it','Limite di transazioni',0),(551221,15312,'tl','',0),(551222,15312,'th','à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸ˆà¸³à¸à¸±à¸”',0),(551223,15312,'hi','à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤•à¥€ à¤¸à¥€à¤®à¤¾',0),(551224,15312,'ms','Had transaksi',0),(551225,15312,'ar','Ø­Ø¯ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(551226,15312,'fr','Limite de transaction',0),(551227,15312,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã®åˆ¶é™',0),(551228,15312,'pt','Limite de transaÃ§Ã£o',0),(551229,15312,'ru','Ð›Ð¸Ð¼Ð¸Ñ‚ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹',0),(551230,15312,'es','LÃ­mite de transacciones',0),(551231,15312,'de','Transaktion-Limit',0),(551232,15312,'en','Transaction Limit',0),(551233,15313,'is','',0),(551234,15313,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(551235,15313,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(551236,15313,'tr','Maliyeti baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(551237,15313,'pl','Koszty pomyÅ›lnie zaktualizowana',0),(551238,15313,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(551239,15313,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(551240,15313,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(551241,15313,'vi','Chi phÃ­ Cáº­p Nháº­t thÃ nh cÃ´ng',0),(551242,15313,'af','Koste suksesvol bygewerk',0),(551243,15313,'ro','Costuri actualizate cu succes',0),(551244,15313,'et','Kulud, mis on edukalt vÃ¤rskendatud',0),(551245,15313,'si','StroÅ¡kov uspeÅ¡no posodobljena',0),(551246,15313,'ba','Biaya yang berhasil',0),(551247,15313,'nl','Kosten bijgewerkt',0),(551248,15313,'fi','Kustannusten pÃ¤ivittÃ¤minen onnistui',0),(551249,15313,'no','Kostnadene oppdatert',0),(551250,15313,'da','Omkostninger opdateret',0),(551251,15313,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ë¹„ìš©',0),(551252,15313,'he','×¢×œ×•×™×•×ª ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(551253,15313,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(551254,15313,'zh','å·²æˆåŠŸæ›´æ–°çš„æˆæœ¬',0),(551255,15313,'sv','Kostnader uppdaterats',0),(551256,15313,'it','Costi aggiornati correttamente',0),(551257,15313,'tl','',0),(551258,15313,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸—à¸µà¹ˆà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(551259,15313,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤²à¤¾à¤—à¤¤',0),(551260,15313,'ms','Kos yang berjaya dikemas kini',0),(551261,15313,'ar','ØªÙƒØ§Ù„ÙŠÙ ØªØ­Ø¯ÙŠØ« Ø¨Ù†Ø¬Ø§Ø­',0),(551262,15313,'fr','Frais de mise Ã  jour rÃ©ussie',0),(551263,15313,'jp','æ­£å¸¸ã«æ›´æ–°ã•ã‚Œã‚‹åŽŸä¾¡',0),(551264,15313,'pt','Custos atualizados com sucesso',0),(551265,15313,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹, Ð±Ñ‹Ð»Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(551266,15313,'es','Actualizada de los costos',0),(551267,15313,'de','Kosten, die erfolgreich aktualisiert',0),(551268,15313,'en','Costs Updated Successfully',0),(551269,15314,'is','',0),(551270,15314,'dr','Ù‡Ø´Ø¯Ø§Ø±: Ø§ÛŒÙ† Ø±ÙˆØ´ Ø§Ø² Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙˆÛŒØ±Ø§ÛŒØ´ Ù†Ù…ÛŒ ØªØºÛŒÛŒØ±Ø§Øª Ø¨Ù‡ GL Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(551271,15314,'pr','Ù‡Ø´Ø¯Ø§Ø±: Ø§ÛŒÙ† Ø±ÙˆØ´ Ø§Ø² Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙˆÛŒØ±Ø§ÛŒØ´ Ù†Ù…ÛŒ ØªØºÛŒÛŒØ±Ø§Øª Ø¨Ù‡ GL Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(551272,15314,'tr','UyarÄ±: Bu yÃ¶ntem maliyetleri dÃ¼zenleme deÄŸiÅŸiklikleri GL iÃ§in deftere nakletmez',0),(551273,15314,'pl','OstrzeÅ¼enie: Ta metoda edycji koszty nie po zmiany do GL',0),(551274,15314,'bg','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ: Ð¢Ð¾Ð·Ð¸ Ð¼ÐµÑ‚Ð¾Ð´ Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð½ÑÐ¼Ð° Ð´Ð° Ð´Ð° Ð¿ÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð½Ð° GL',0),(551275,15314,'ur','ØªÙ†Ø¨ÛŒÛ: ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©Ø§ ÛŒÛ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ø¬ÛŒØ¬Û’ Ú©Ùˆ Ø´Ø§Ø¦Ø¹ Ú©Ø±ÛŒÚº Ú¯Û’ Ù†ÛÛŒÚº',0),(551276,15314,'sr','Ð£Ð¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐµ : ÐžÐ²Ð°Ñ˜ Ð¼ÐµÑ‚Ð¾Ð´ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐ° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð½ÐµÑ›Ðµ ÐºÑšÐ¸Ð¶Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ñƒ Ð“Ðš',0),(551277,15314,'vi','Cáº£nh bÃ¡o: PhÆ°Æ¡ng phÃ¡p nÃ y cá»§a chá»‰nh sá»­a chi phÃ­ sáº½ khÃ´ng Ä‘Äƒng thay Ä‘á»•i lÃªn GL',0),(551278,15314,'af','Waarskuwing: Hierdie metode van redigering koste sal nie plaas veranderinge na GL',0),(551279,15314,'ro','Avertisment: AceastÄƒ metodÄƒ de editare a costurilor va posta nu modificÄƒri la GL',0),(551280,15314,'et','Hoiatus: Selle meetodi toimetamise kulud ei postita muutused GL',0),(551281,15314,'si','Opozorilo: Ta metoda urejanje stroÅ¡kov ne boste objavljali spremembe v GL',0),(551282,15314,'ba','Peringatan: Metode ini editing biaya akan tidak posting perubahan untuk GL',0),(551283,15314,'nl','Waarschuwing: Deze methode voor het bewerken van kosten zullen niet veranderingen GL',0),(551284,15314,'fi','Varoitus: TÃ¤mÃ¤ menetelmÃ¤ kustannusten muokkaamisen lÃ¤hetÃ¤ muutokset GL',0),(551285,15314,'no','Advarsel: Denne metoden for redigering kostnader vil ikke legge endringer til GL',0),(551286,15314,'da','Advarsel: Denne metode til redigering omkostninger ikke bogfÃ¸re Ã¦ndringer til GL',0),(551287,15314,'ko','ê²½ê³ : ë¹„ìš©ì„ íŽ¸ì§‘ì˜ì´ ë°©ë²•ì€ ê²Œì‹œ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤ ë³€ê²½ GLì—',0),(551288,15314,'he','××–×”×¨×”: ×©×™×˜×” ×–×• ×©×œ ×¢×¨×™×›×ª ×¢×œ×•×™×•×ª ×œ× × ×¤×¨×¡× ×©×™× ×•×™×™× GL',0),(551289,15314,'el','Î ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·: Î‘Ï…Ï„Î® Î· Î¼Î­Î¸Î¿Î´Î¿Ï‚ ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎºÏŒÏƒÏ„Î¿Ï‚ Î´ÎµÎ½ Î¸Î± Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏƒÎµÏ„Îµ Î±Î»Î»Î±Î³Î­Ï‚ GL',0),(551290,15314,'zh','è­¦å‘Š: æ­¤æ–¹æ³•çš„ç¼–è¾‘è´¹ç”¨å°†ä¸å‘å¸ƒæ›´æ”¹åˆ° GL',0),(551291,15314,'sv','Varning: Denna metod fÃ¶r redigering kostnader kommer inte publicera Ã¤ndringar till GL',0),(551292,15314,'it','Attenzione: Questo metodo di Editing costi non modifiche verrÃ  pubblicate per GL',0),(551293,15314,'tl','',0),(551294,15314,'th','à¸„à¸³à¹€à¸•à¸·à¸­à¸™: à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¹à¸à¹‰à¹„à¸‚à¸•à¹‰à¸™à¸—à¸¸à¸™à¸™à¸µà¹‰à¸ˆà¸°à¹„à¸¡à¹ˆà¸›à¸£à¸°à¸à¸²à¸¨à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡',0),(551295,15314,'hi','à¤šà¥‡à¤¤à¤¾à¤µà¤¨à¥€: à¤²à¤¾à¤—à¤¤ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤•à¥€ à¤‡à¤¸ à¤ªà¤¦à¥à¤§à¤¤à¤¿ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ GL à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤°à¥‡à¤‚à¤—à¥‡ à¤¨à¤¹à¥€à¤‚',0),(551296,15314,'ms','Amaran: Kaedah penyuntingan kos akan tidak menyiarkan perubahan kepada GL',0),(551297,15314,'ar','ØªØ­Ø°ÙŠØ±: Ù‡Ø°Ø§ Ø§Ù„Ø£Ø³Ù„ÙˆØ¨ Ù„ØªØ­Ø±ÙŠØ± ØªÙƒØ§Ù„ÙŠÙ Ø¹Ø¯Ù… Ù†Ø´Ø± Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø¥Ù„Ù‰ GL',0),(551298,15314,'fr','AVERTISSEMENT : Cette mÃ©thode de montage des coÃ»ts ne posterez pas changements Ã  GL',0),(551299,15314,'jp','è­¦å‘Š: ã“ã®æ–¹æ³•ã§ã‚³ã‚¹ãƒˆã‚’ç·¨é›†ã‚’æŠ•ç¨¿ã—ãªã„å¤‰æ›´ GL ã«',0),(551300,15314,'pt','Aviso: Este mÃ©todo de custos de ediÃ§Ã£o nÃ£o vou postar as alteraÃ§Ãµes para GL',0),(551301,15314,'ru','ÐŸÑ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´ÐµÐ½Ð¸Ðµ: Ð­Ñ‚Ð¾Ñ‚ Ð¼ÐµÑ‚Ð¾Ð´ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹ Ð½Ðµ Ð±ÑƒÐ´ÐµÑ‚ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð½Ð° GL',0),(551302,15314,'es','ADVERTENCIA: Este mÃ©todo de los costos de ediciÃ³n no publicarÃ¡ cambios a GL',0),(551303,15314,'de','Warnung: Diese Methode der Bearbeitung Kosten werden keine Ã„nderungen an den GL gebucht',0),(551304,15314,'en','Warning: This Method Of Editing Costs Will Not Post Changes To GL',0),(551305,15315,'is','',0),(551306,15315,'dr','Ø°Ø®ÛŒØ±Ù‡ ØªØºÛŒÛŒØ±Ø§Øª',0),(551307,15315,'pr','Ø°Ø®ÛŒØ±Ù‡ ØªØºÛŒÛŒØ±Ø§Øª',0),(551308,15315,'tr','DeÄŸiÅŸiklikler kaydedildi',0),(551309,15315,'pl','Zmiany zapisane',0),(551310,15315,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸',0),(551311,15315,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ù…Ø­ÙÙˆØ¸ Ú©ÛŒ Ú¯Ø¦ÛŒÚº',0),(551312,15315,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ðµ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½Ðµ',0),(551313,15315,'vi','Thay Ä‘á»•i lÆ°u',0),(551314,15315,'af','Veranderinge gestoor',0),(551315,15315,'ro','ModificÄƒrile salvate',0),(551316,15315,'et','Salvestatud muudatused',0),(551317,15315,'si','Shranjene spremembe',0),(551318,15315,'ba','Perubahan disimpan',0),(551319,15315,'nl','Wijzigingen opgeslagen',0),(551320,15315,'fi','Tallennetut muutokset',0),(551321,15315,'no','Endringer lagret',0),(551322,15315,'da','Ã†ndringerne gemmes',0),(551323,15315,'ko','ë³€ê²½ ë‚´ìš© ì €ìž¥',0),(551324,15315,'he','×©×™× ×•×™×™× ×©× ×©×ž×¨×•',0),(551325,15315,'el','Î‘Î»Î»Î±Î³Î­Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯',0),(551326,15315,'zh','ä¿å­˜æ›´æ”¹',0),(551327,15315,'sv','Ã„ndringar sparas',0),(551328,15315,'it','Modifiche salvate',0),(551329,15315,'tl','',0),(551330,15315,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(551331,15315,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(551332,15315,'ms','Perubahan yang disimpan',0),(551333,15315,'ar','Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø©',0),(551334,15315,'fr','Modifications enregistrÃ©es',0),(551335,15315,'jp','å¤‰æ›´å†…å®¹ã‚’ä¿å­˜',0),(551336,15315,'pt','AlteraÃ§Ãµes salvadas',0),(551337,15315,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ ÑÐ¾Ñ…Ñ€Ð°Ð½ÑÑŽÑ‚ÑÑ',0),(551338,15315,'es','Cambios guardados',0),(551339,15315,'de','Ã„nderungen gespeichert',0),(551340,15315,'en','Changes Saved',0),(551341,15316,'is','',0),(551342,15316,'dr','Ù‡ÛŒÚ† ØªØºÛŒÛŒØ±ÛŒ Ø®Ø§Ù„ÛŒ Ø¨Ú¯Ø°Ø§Ø±ÛŒØ¯',0),(551343,15316,'pr','Ù‡ÛŒÚ† ØªØºÛŒÛŒØ±ÛŒ Ø®Ø§Ù„ÛŒ Ø¨Ú¯Ø°Ø§Ø±ÛŒØ¯',0),(551344,15316,'tr','Ä°Ã§in deÄŸiÅŸiklik yok boÅŸ bÄ±rakÄ±n',0),(551345,15316,'pl','Pozostaw puste bez zmian',0),(551346,15316,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(551347,15316,'ur','Ú©ÙˆØ¦ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ù„Ø§Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(551348,15316,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð·Ð° Ð½ÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(551349,15316,'vi','Äá»ƒ trá»‘ng cho khÃ´ng cÃ³ sá»± thay Ä‘á»•i',0),(551350,15316,'af','Laat blanko vir geen verandering',0),(551351,15316,'ro','LÄƒsaÅ£i necompletat pentru nici o schimbare',0),(551352,15316,'et','JÃ¤ta tÃ¼hjaks ei muutu',0),(551353,15316,'si','Pustite prazno za brez sprememb',0),(551354,15316,'ba','Biarkan kosong untuk tidak',0),(551355,15316,'nl','Laat leeg om niet te wijzigen',0),(551356,15316,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi ei muutosta',0),(551357,15316,'no','Tomt For ingen endring',0),(551358,15316,'da','For ingen Ã¦ndring er tomt',0),(551359,15316,'ko','ë³€í™”ì— ëŒ€ í•œ ë¹„ì›Œ',0),(551360,15316,'he','×œ×”×©××™×¨ ×¨×™×§ ×œ×œ× ×©×™× ×•×™',0),(551361,15316,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ Î³Î¹Î± ÎºÎ±Î¼Î¯Î± Î±Î»Î»Î±Î³Î®',0),(551362,15316,'zh','æ²¡æœ‰å˜åŒ–ä¸ºç©º',0),(551363,15316,'sv','LÃ¤mna tomt fÃ¶r ingen fÃ¶rÃ¤ndring',0),(551364,15316,'it','Lasciare vuoto per nessun cambiamento',0),(551365,15316,'tl','',0),(551366,15316,'th','à¸›à¸¥à¹ˆà¸­à¸¢à¸§à¹ˆà¸²à¸‡à¹„à¸§à¹‰à¹„à¸¡à¹ˆà¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(551367,15316,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥‹ à¤–à¤¾à¤²à¥€ à¤›à¥‹à¤¡à¤¼',0),(551368,15316,'ms','Biarkan kosong untuk sebarang perubahan',0),(551369,15316,'ar','ØªØ±Ùƒ ÙØ§Ø±ØºØ§Ù‹ Ù„Ø£ÙŠ ØªØºÙŠÙŠØ±',0),(551370,15316,'fr','Laissez vide pour aucun changement',0),(551371,15316,'jp','å¤‰æ›´ãªã—ã®ç©ºç™½ã®ã¾ã¾ã«',0),(551372,15316,'pt','Deixe em branco para nÃ£o alterar',0),(551373,15316,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼ Ð´Ð»Ñ Ð½Ð¸ÐºÐ°ÐºÐ¸Ñ… Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(551374,15316,'es','Deje en blanco para No cambiar',0),(551375,15316,'de','Freilassen, damit keine Ã„nderung',0),(551376,15316,'en','Leave Blank For No Change',0),(551377,15317,'is','',0),(551378,15317,'dr','ØªØ¹ÛŒÛŒÙ† Ù…Ø­Ù„',0),(551379,15317,'pr','ØªØ¹ÛŒÛŒÙ† Ù…Ø­Ù„',0),(551380,15317,'tr','KÃ¼me konumu',0),(551381,15317,'pl','Ustawianie lokalizacji',0),(551382,15317,'bg','Ð—Ð°Ð´Ð°Ð´ÐµÐ½Ð¾Ñ‚Ð¾ Ð¾Ñ‚ Ð²Ð°Ñ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(551383,15317,'ur','Ù…Ù‚Ø±Ø±Û Ø¬Ú¯Û',0),(551384,15317,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(551385,15317,'vi','Äáº·t vá»‹ trÃ­',0),(551386,15317,'af','Stel ligging',0),(551387,15317,'ro','SetaÅ£i locaÅ£ia',0),(551388,15317,'et','MÃ¤Ã¤ratud asukohta',0),(551389,15317,'si','Nastavljena lokacija',0),(551390,15317,'ba','Menetapkan lokasi',0),(551391,15317,'nl','Locatie instellen',0),(551392,15317,'fi','MÃ¤Ã¤ritÃ¤ sijainti',0),(551393,15317,'no','Angi plasseringen',0),(551394,15317,'da','Set placering',0),(551395,15317,'ko','ì„¤ì •ëœ ìœ„ì¹˜',0),(551396,15317,'he','×ž×™×§×•× ×”×’×“×¨',0),(551397,15317,'el','Î¤Î·Ï‚ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±Ï‚ Ï€Î¿Ï… Î¿ÏÎ¯ÏƒÎ±Ï„Îµ',0),(551398,15317,'zh','è®¾ç½®çš„ä½ç½®',0),(551399,15317,'sv','Ange plats',0),(551400,15317,'it','Imposta posizione',0),(551401,15317,'tl','',0),(551402,15317,'th','à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡',0),(551403,15317,'hi','à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤¿à¤¤ à¤¸à¥à¤¥à¤¾à¤¨',0),(551404,15317,'ms','Lokasi yang ditetapkan',0),(551405,15317,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(551406,15317,'fr','Set Location',0),(551407,15317,'jp','ãƒ­ã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã®è¨­å®š',0),(551408,15317,'pt','LocalizaÃ§Ã£o de conjunto',0),(551409,15317,'ru','Ð—Ð°Ð´Ð°Ñ‚ÑŒ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(551410,15317,'es','Establecer ubicaciÃ³n',0),(551411,15317,'de','Festgelegten Position',0),(551412,15317,'en','Set Location',0),(551413,15318,'is','',0),(551414,15318,'dr','ØªÙ†Ø¸ÛŒÙ… ØªØ¹Ø¯Ø§Ø¯ Ø§Ø² Ø·Ø±Ù',0),(551415,15318,'pr','ØªÙ†Ø¸ÛŒÙ… ØªØ¹Ø¯Ø§Ø¯ Ø§Ø² Ø·Ø±Ù',0),(551416,15318,'tr','Miktar yandan ayarla',0),(551417,15318,'pl','UstawiÄ‡ iloÅ›Ä‡ pod rÄ™kÄ…',0),(551418,15318,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ð° Ñ€ÑŠÐºÐ°',0),(551419,15318,'ur','Ù‚ÛŒ Ø¬Ø§Ù†Ø¨ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(551420,15318,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð¸ Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(551421,15318,'vi','Thiáº¿t láº­p Qty máº·t',0),(551422,15318,'af','Stel Qty aan kant',0),(551423,15318,'ro','Stabili cantit pe parte',0),(551424,15318,'et','MÃ¤Ã¤ratud kogus kÃ¤si',0),(551425,15318,'si','Na strani nastavite kol.',0),(551426,15318,'ba','Mengatur Qty di tangan',0),(551427,15318,'nl','Instellen aantal aan kant',0),(551428,15318,'fi','Aseta mÃ¤Ã¤rÃ¤ kÃ¤sillÃ¤',0),(551429,15318,'no','Angi antall pÃ¥ side',0),(551430,15318,'da','Angiv antal pÃ¥ side',0),(551431,15318,'ko','í•œíŽ¸ ìˆ˜ëŸ‰ ì„¤ì •',0),(551432,15318,'he','×œ×”×’×“×™×¨ ×›×ž×•×ª ×¢×œ ×™×“',0),(551433,15318,'el','ÎŸÏÎ¯ÏƒÎµÏ„Îµ Qty Î±Ï†',0),(551434,15318,'zh','æ‰‹ä¸Šè®¾ç½®æ•°é‡',0),(551435,15318,'sv','Ange antal Ã¥',0),(551436,15318,'it','Impostare Qty da lato',0),(551437,15318,'tl','',0),(551438,15318,'th','à¸•à¸±à¹‰à¸‡à¸›à¸£à¸´à¸¡à¸²à¸“à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸„à¸‡à¹€à¸«à¸¥à¸·à¸­',0),(551439,15318,'hi','à¤¹à¤¾à¤¥ à¤ªà¤° à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(551440,15318,'ms','Menetapkan Qty di tangan',0),(551441,15318,'ar','ØªØ¹ÙŠÙŠÙ† ÙƒÙ…ÙŠØ© Ù…Ù† Ù†Ø§Ø­ÙŠØ©',0),(551442,15318,'fr','Quant Ã  la valeur QtÃ©',0),(551443,15318,'jp','ä¸€æ–¹ã§æ•°é‡ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(551444,15318,'pt','Definir Qty por lado',0),(551445,15318,'ru','Ð—Ð°Ð´Ð°Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(551446,15318,'es','Establece la cantidad en mano',0),(551447,15318,'de','Legen Sie die Menge auf Seite',0),(551448,15318,'en','Set Qty On Hand',0),(551449,15319,'is','',0),(551450,15319,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø®Ø·',0),(551451,15319,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø®Ø·',0),(551452,15319,'tr','SatÄ±r toplamÄ±',0),(551453,15319,'pl','ÅÄ…czna kwota wiersza',0),(551454,15319,'bg','ÐžÐ±Ñ‰Ð¾ Ð½Ð° Ð»Ð¸Ð½Ð¸Ñ',0),(551455,15319,'ur','Ù„Ø§Ø¦Ù† Ú©Ù„',0),(551456,15319,'sr','Ð—Ð±Ð¸Ñ€ Ñ€ÐµÐ´Ð°',0),(551457,15319,'vi','Tá»•ng sá»‘ dÃ²ng',0),(551458,15319,'af','Lyn totaal',0),(551459,15319,'ro','Linia Total',0),(551460,15319,'et','Rea kogusumma',0),(551461,15319,'si','Vrstice skupaj',0),(551462,15319,'ba','Total baris',0),(551463,15319,'nl','Lijn totaal',0),(551464,15319,'fi','Rivin kokonaissumma',0),(551465,15319,'no','Linjetotalen',0),(551466,15319,'da','Samlede linjebelÃ¸b',0),(551467,15319,'ko','ë¼ì¸ ì´',0),(551468,15319,'he','×¡×” ×› ×§×•',0),(551469,15319,'el','ÎœÎµÏ ÏƒÏÎ½Î¿Î»Î¿',0),(551470,15319,'zh','è¡Œåˆè®¡',0),(551471,15319,'sv','Radtotalen',0),(551472,15319,'it','Totale riga',0),(551473,15319,'tl','',0),(551474,15319,'th','à¸œà¸¥à¸£à¸§à¸¡à¹ƒà¸™à¸šà¸£à¸£à¸—à¸±à¸”',0),(551475,15319,'hi','à¤°à¥‡à¤–à¤¾ à¤•à¥à¤²',0),(551476,15319,'ms','Jumlah garisan',0),(551477,15319,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø³Ø·Ø±',0),(551478,15319,'fr','Total de la ligne',0),(551479,15319,'jp','æ˜Žç´°åˆè¨ˆ',0),(551480,15319,'pt','Linha Total',0),(551481,15319,'ru','Ð’ÑÐµÐ³Ð¾ Ð»Ð¸Ð½Ð¸Ñ',0),(551482,15319,'es','LÃ­nea Total',0),(551483,15319,'de','Zeilensumme',0),(551484,15319,'en','Line Total',0),(551485,15320,'is','',0),(551486,15320,'dr','ÙØ±Ù…Øª Ø¬Ø¯ÙˆÙ„ ØµÙ†Ø¯ÙˆÙ‚',0),(551487,15320,'pr','ÙØ±Ù…Øª Ø¬Ø¯ÙˆÙ„ ØµÙ†Ø¯ÙˆÙ‚',0),(551488,15320,'tr','PO tablo biÃ§iminde',0),(551489,15320,'pl','PO tabela Format',0),(551490,15320,'bg','PO Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(551491,15320,'ur','Ù¾Ùˆ Ø¬Ø¯ÙˆÙ„ ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(551492,15320,'sr','ÐŸÐž ÑÑ‚Ð¾ Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚',0),(551493,15320,'vi','Äá»‹nh dáº¡ng báº£ng PO',0),(551494,15320,'af','Posbus tabel formaat',0),(551495,15320,'ro','Format de tabel PO',0),(551496,15320,'et','PO tabelivormingus',0),(551497,15320,'si','PO v obliki tabele',0),(551498,15320,'ba','Format Tabel PO',0),(551499,15320,'nl','PO tabelindeling',0),(551500,15320,'fi','PO taulukkomuodossa',0),(551501,15320,'no','PO tabellformat',0),(551502,15320,'da','PO tabelformat',0),(551503,15320,'ko','í¬ í…Œì´ë¸” í˜•ì‹',0),(551504,15320,'he','×¢×™×¦×•×‘ ×˜×‘×œ×” ×¤×•',0),(551505,15320,'el','ÎœÎ¿ÏÏ†Î® Ï€Î¯Î½Î±ÎºÎ± PO',0),(551506,15320,'zh','è’²è¡¨æ ¼æ ¼å¼',0),(551507,15320,'sv','PO tabellformat',0),(551508,15320,'it','Formato tabella PO',0),(551509,15320,'tl','',0),(551510,15320,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¸‚à¸­à¸‡à¸•à¸²à¸£à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(551511,15320,'hi','PO à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(551512,15320,'ms','Format Jadual PO',0),(551513,15320,'ar','Øµ. Ø¨ ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(551514,15320,'fr','Format de Table PO',0),(551515,15320,'jp','PO ã®è¡¨ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(551516,15320,'pt','Formato de tabela de PO',0),(551517,15320,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ PO',0),(551518,15320,'es','Formato de la tabla de PO',0),(551519,15320,'de','PO-Tabellenformat',0),(551520,15320,'en','PO Table Format',0),(551521,15321,'is','',0),(551522,15321,'dr','Ù‚ÛŒÙ…Øª Ù…Ù‚Ø¯Ø§Ø±',0),(551523,15321,'pr','Ù‚ÛŒÙ…Øª Ù…Ù‚Ø¯Ø§Ø±',0),(551524,15321,'tr','Miktar fiyatÄ±',0),(551525,15321,'pl','IloÅ›Ä‡ cena',0),(551526,15321,'bg','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ñ†ÐµÐ½Ð°',0),(551527,15321,'ur','Ù…Ù‚Ø¯Ø§Ø± Ù‚ÛŒÙ…Øª',0),(551528,15321,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ñ†ÐµÐ½Ð°',0),(551529,15321,'vi','Sá»‘ lÆ°á»£ng giÃ¡',0),(551530,15321,'af','Hoeveelheid prys',0),(551531,15321,'ro','Cantitate Pret',0),(551532,15321,'et','Koguse hind',0),(551533,15321,'si','KoliÄina cena',0),(551534,15321,'ba','Harga jumlah',0),(551535,15321,'nl','Hoeveelheid prijs',0),(551536,15321,'fi','MÃ¤Ã¤rÃ¤n hinta',0),(551537,15321,'no','Antallspris',0),(551538,15321,'da','Antalsprisen',0),(551539,15321,'ko','ìˆ˜ëŸ‰ ê°€ê²©',0),(551540,15321,'he','×ž×—×™×¨ ×›×ž×•×ª',0),(551541,15321,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï„Î¹Î¼Î®',0),(551542,15321,'zh','æ•°é‡ä»·æ ¼',0),(551543,15321,'sv','Kvantitetspriset',0),(551544,15321,'it','QuantitÃ  prezzo',0),(551545,15321,'tl','',0),(551546,15321,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸£à¸²à¸„à¸²',0),(551547,15321,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‚à¤²à¥à¤¯',0),(551548,15321,'ms','Kuantiti harga',0),(551549,15321,'ar','Ø³Ø¹Ø± Ø§Ù„ÙƒÙ…ÙŠØ©',0),(551550,15321,'fr','Prix de quantitÃ©',0),(551551,15321,'jp','æ•°é‡ä¾¡æ ¼',0),(551552,15321,'pt','Quantidade preÃ§o',0),(551553,15321,'ru','Ð¨Ñ‚ÑƒÑ‡Ð½Ð°Ñ Ñ†ÐµÐ½Ð°',0),(551554,15321,'es','Precio por cantidad',0),(551555,15321,'de','Mengenpreis',0),(551556,15321,'en','Quantity Price',0),(551557,15322,'is','',0),(551558,15322,'dr','Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÛŒØ¯ ØªÙ†Ù‡Ø§ Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ Ú†Ú© Ù„ÛŒØ³Øª',0),(551559,15322,'pr','Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù…Ù‚Ø¯Ø§Ø± Ø®Ø±ÛŒØ¯ ØªÙ†Ù‡Ø§ Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ Ú†Ú© Ù„ÛŒØ³Øª',0),(551560,15322,'tr','SatÄ±nalma miktarÄ± sadece PO denetim listesinde gÃ¶ster',0),(551561,15322,'pl','PokaÅ¼ iloÅ›Ä‡ zakupu tylko na listÄ™ kontrolnÄ… PO',0),(551562,15322,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑÐ°Ð¼Ð¾ Ð½Ð° PO Ð§ÐµÐºÐ»Ð¸ÑÑ‚',0),(551563,15322,'ur','ØµØ±Ù Ù¾Ùˆ Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª Ù¾Ø± Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(551564,15322,'sr','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð˜Ð·Ð»Ð°Ð·Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° ÑÐ°Ð¼Ð¾ Ð½Ð° ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ñƒ Ð»Ð¸ÑÑ‚Ñƒ ÐŸÐž',0),(551565,15322,'vi','Hiá»ƒn thá»‹ sá»‘ lÆ°á»£ng mua chá»‰ trÃªn danh sÃ¡ch kiá»ƒm tra PO',0),(551566,15322,'af','Aankoop hoeveelheid wys slegs op PO Kontrolelys',0),(551567,15322,'ro','AratÄƒ cantitatea de cumpÄƒrare numai pe PO de verificare',0),(551568,15322,'et','NÃ¤itab ostukogus ainult PO Meelespea',0),(551569,15322,'si','PrikaÅ¾i koliÄine nakupa le na PO kontrolni seznam',0),(551570,15322,'ba','Tampilkan jumlah pembelian hanya di PO Checklist',0),(551571,15322,'nl','Aankoop hoeveelheid Toon alleen op PO Checklist',0),(551572,15322,'fi','NÃ¤ytÃ¤ ostomÃ¤Ã¤rÃ¤ vain olevilla PO tarkistuslista',0),(551573,15322,'no','Vis innkjÃ¸psantall bare pÃ¥ PO sjekkliste',0),(551574,15322,'da','Vis kÃ¸bsantallet kun pÃ¥ PO tjekliste',0),(551575,15322,'ko','í¬ ê²€ì‚¬ ëª©ë¡ì— ëŒ€í•´ì„œë§Œ êµ¬ë§¤ ìˆ˜ëŸ‰ì„ í‘œì‹œ',0),(551576,15322,'he','×”×¦×’ ×›×ž×•×ª ×”×¨×›×™×©×” ×‘×œ×‘×“ ×‘×¨×©×™×ž×” ×¤×•',0),(551577,15322,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Î³Î¿ÏÎ¬Ï‚ Î¼ÏŒÎ½Î¿ ÏƒÎµ PO Î»Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(551578,15322,'zh','ä»…åœ¨å¤§åŸ”æ¸…å•ä¸Šæ˜¾ç¤ºé‡‡è´­æ•°é‡',0),(551579,15322,'sv','Visa inkÃ¶pskvantiteten bara fÃ¶r PO checklista',0),(551580,15322,'it','Visualizza la quantitÃ  di acquisto solo su PO Checklist',0),(551581,15322,'tl','',0),(551582,15322,'th','à¹à¸ªà¸”à¸‡à¸›à¸£à¸´à¸¡à¸²à¸“à¸à¸²à¸£à¸‹à¸·à¹‰à¸­à¹ƒà¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š PO',0),(551583,15322,'hi','à¤•à¥‡à¤µà¤² à¤ªà¥‹ à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ à¤ªà¤° à¤–à¤°à¥€à¤¦ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(551584,15322,'ms','Menunjukkan kuantiti pembelian hanya pada senarai semak PO',0),(551585,15322,'ar','Ø¥Ø¸Ù‡Ø§Ø± ÙƒÙ…ÙŠØ© Ø§Ù„Ø´Ø±Ø§Ø¡ ÙÙ‚Ø· ÙÙŠ Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø±ÙŠØ¯',0),(551586,15322,'fr','Voir la quantitÃ© d\'achat uniquement sur liste de contrÃ´le de PO',0),(551587,15322,'jp','PO ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆã«ã®ã¿ç™ºæ³¨æ•°é‡ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(551588,15322,'pt','Mostrar a quantidade de compra apenas no Checklist de PO',0),(551589,15322,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð½Ð° PO ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(551590,15322,'es','Mostrar cantidad de compra sÃ³lo en lista PO',0),(551591,15322,'de','Einkaufsmenge nur auf PO-Checkliste anzeigen',0),(551592,15322,'en','Show Purchase Quantity Only On PO Checklist',0),(551593,15323,'is','',0),(551594,15323,'dr','Ø³Ø±Ú©ÙˆØ¨ Ø´Ù…Ø§Ø±Ù‡ Ø®Ø· Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ Ú†Ú© Ù„ÛŒØ³Øª',0),(551595,15323,'pr','Ø³Ø±Ú©ÙˆØ¨ Ø´Ù…Ø§Ø±Ù‡ Ø®Ø· Ø¯Ø± ØµÙ†Ø¯ÙˆÙ‚ Ú†Ú© Ù„ÛŒØ³Øª',0),(551596,15323,'tr','SatÄ±r numarasÄ± PO denetim listesi Ã¼zerinde bastÄ±rmak',0),(551597,15323,'pl','Pomijanie linii numer w wykazie kontrolnym PO',0),(551598,15323,'bg','ÐŸÐ¾Ñ‚Ð¸ÑÐºÐ°Ñ‚ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ñ€ÐµÐ´Ð° Ð½Ð° PO Ð§ÐµÐºÐ»Ð¸ÑÑ‚',0),(551599,15323,'ur','Ù¾Ùˆ Ø§ØµÙ„Ø§Ø­ Ú©ÛŒ ÙÛØ±Ø³Øª Ù¾Ø± Ù„Ø§Ø¦Ù† Ù†Ù…Ø¨Ø± Ù…Ù¹Ø§Ø¦ÛŒÚº',0),(551600,15323,'sr','ÐŸÐ¾Ñ‚Ð¸ÑÐ½ÑƒÑ‚Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ€ÐµÐ´Ð° Ð½Ð° ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ñƒ Ð»Ð¸ÑÑ‚Ñƒ ÐŸÐž',0),(551601,15323,'vi','NgÄƒn cháº·n sá»‘ dÃ²ng trÃªn danh sÃ¡ch kiá»ƒm tra PO',0),(551602,15323,'af','Onderdruk ReÃ«lnommer op PO Kontrolelys',0),(551603,15323,'ro','Suprimare numÄƒr de linie pe PO de verificare',0),(551604,15323,'et','TÃµkesta reanumber Ã¼htsel PO Meelespea',0),(551605,15323,'si','Zatiranje Å¡tevilka vrstice PO kontrolni seznam',0),(551606,15323,'ba','Menekan nomor baris pada PO Checklist',0),(551607,15323,'nl','Regelnummer op PO controlelijst onderdrukken',0),(551608,15323,'fi','Tukahduttaa rivinumero PO tarkistuslista',0),(551609,15323,'no','Undertrykke linjenummeret pÃ¥ PO sjekkliste',0),(551610,15323,'da','Undertrykke linjenummer pÃ¥ PO tjekliste',0),(551611,15323,'ko','í¬ ê²€ì‚¬ ëª©ë¡ì— ì¤„ ë²ˆí˜¸ í‘œì‹œ ì•ˆ í•¨',0),(551612,15323,'he','×œ×“×›× ××ª ×ž×¡×¤×¨ ×”×©×•×¨×” ×‘×¨×©×™×ž×” ×¤×•',0),(551613,15323,'el','ÎšÎ±Ï„Î±ÏƒÏ„Î­Î»Î»Î¿Ï…Î½ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ„Î· Î»Î¯ÏƒÏ„Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… PO',0),(551614,15323,'zh','æŠ‘åˆ¶ PO æ¸…å•ä¸Šçš„è¡Œå·',0),(551615,15323,'sv','Undertrycka numret pÃ¥ PO checklista',0),(551616,15323,'it','Sopprimere il numero di riga su PO Checklist',0),(551617,15323,'tl','',0),(551618,15323,'th','à¹„à¸¡à¹ˆà¹ƒà¸ªà¹ˆà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸£à¸£à¸—à¸±à¸”à¹ƒà¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š PO',0),(551619,15323,'hi','PO à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ à¤ªà¤° à¤²à¤¾à¤‡à¤¨ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‹ à¤¦à¤¬à¤¾à¤¨à¥‡',0),(551620,15323,'ms','Menyekat nombor baris pada senarai semak PO',0),(551621,15323,'ar','Ù‚Ù…Ø¹ Ø±Ù‚Ù… Ø§Ù„Ø³Ø·Ø± ÙÙŠ Ù‚Ø§Ø¦Ù…Ø© Ø¨Ø±ÙŠØ¯',0),(551622,15323,'fr','Supprimer le numÃ©ro de ligne dans la liste de contrÃ´le de PO',0),(551623,15323,'jp','PO ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆã«è¡Œç•ªå·ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(551624,15323,'pt','Suprimir o nÃºmero da linha na lista de PO',0),(551625,15323,'ru','ÐŸÐ¾Ð´Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð½Ð° PO ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº',0),(551626,15323,'es','Suprimir el nÃºmero de lÃ­nea en la lista PO',0),(551627,15323,'de','Zeilennummer auf PO-Checkliste zu unterdrÃ¼cken',0),(551628,15323,'en','Suppress Line Number On PO Checklist',0),(551629,15324,'is','',0),(551630,15324,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ POs',0),(551631,15324,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ POs',0),(551632,15324,'tr','VarsayÄ±lan satÄ±cÄ± POS',0),(551633,15324,'pl','DomyÅ›lnym dostawcÄ… dla POs',0),(551634,15324,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð·Ð° POs',0),(551635,15324,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û ÙØ±ÙˆØ´Ù†Ø¯Û',0),(551636,15324,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð·Ð° ÐŸÐžÑ',0),(551637,15324,'vi','NhÃ  cung cáº¥p máº·c Ä‘á»‹nh cho POs',0),(551638,15324,'af','Verstek handelaar vir POs',0),(551639,15324,'ro','Furnizor implicit pentru POs',0),(551640,15324,'et','Vaikimisi hankija POs',0),(551641,15324,'si','Privzetega dobavitelja za POs',0),(551642,15324,'ba','Default Vendor untuk POs',0),(551643,15324,'nl','Standaard leverancier voor POs',0),(551644,15324,'fi','POs oletustoimittaja',0),(551645,15324,'no','StandardleverandÃ¸r For POs',0),(551646,15324,'da','StandardleverandÃ¸ren For POs',0),(551647,15324,'ko','POsì— ëŒ€ í•œ ê¸°ë³¸ ê³µê¸‰ ì—…ì²´',0),(551648,15324,'he','×¡×¤×§ ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×‘×•×¨ POs',0),(551649,15324,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®Ï‚ Î³Î¹Î± POs',0),(551650,15324,'zh','é»˜è®¤ä¾›åº”å•† POs',0),(551651,15324,'sv','StandardleverantÃ¶r fÃ¶r POs',0),(551652,15324,'it','Fornitore di default per POs',0),(551653,15324,'tl','',0),(551654,15324,'th','à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸³à¸«à¸£à¸±à¸š POs',0),(551655,15324,'hi','POs à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(551656,15324,'ms','Penjual lalai untuk POs',0),(551657,15324,'ar','Ø§Ù„Ù…ÙˆØ±Ø¯ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù„Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹',0),(551658,15324,'fr','Fournisseur par dÃ©faut pour POs',0),(551659,15324,'jp','POs ã®æ—¢å®šã®ä»•å…¥å…ˆ',0),(551660,15324,'pt','Fornecedor de padrÃ£o para POs',0),(551661,15324,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð´Ð»Ñ POs',0),(551662,15324,'es','Proveedor predeterminado para la posiciÃ³n',0),(551663,15324,'de','Standardlieferant fÃ¼r POs',0),(551664,15324,'en','Default Vendor For POs',0),(551665,15325,'is','',0),(551666,15325,'dr','Ø¯Ø±ÛŒØ§ÙØª Ø®ÙˆØ¯Ú©Ø§Ø± Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶',0),(551667,15325,'pr','Ø¯Ø±ÛŒØ§ÙØª Ø®ÙˆØ¯Ú©Ø§Ø± Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ù¾ÛŒØ´ ÙØ±Ø¶',0),(551668,15325,'tr','VarsayÄ±lan olarak otomatik POs almak',0),(551669,15325,'pl','OdbieraÄ‡ Auto POs domyÅ›lnie',0),(551670,15325,'bg','ÐŸÐ¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ñ‚Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ POs Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(551671,15325,'ur','Ø¨Ù…Ø·Ø§Ø¨Ù‚ Ø·Û’ Ø´Ø¯Û Ø¢Ù¹Ùˆ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(551672,15325,'sr','ÐŸÑ€Ð¸Ð¼Ð°Ñ‚Ðµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ ÐŸÐžÑ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾',0),(551673,15325,'vi','Nháº­n Ä‘Æ°á»£c tá»± Ä‘á»™ng POs theo máº·c Ä‘á»‹nh',0),(551674,15325,'af','Ontvang Outo POs By verstek',0),(551675,15325,'ro','Primi Auto POs implicit',0),(551676,15325,'et','Saada Auto POs vaikimisi',0),(551677,15325,'si','Prejeli Auto POs privzeto',0),(551678,15325,'ba','Menerima otomatis POs secara Default',0),(551679,15325,'nl','Ontvangen automatisch POs standaard',0),(551680,15325,'fi','Saada Auto POs oletusarvoisesti',0),(551681,15325,'no','Motta automatisk POs som standard',0),(551682,15325,'da','Modtag Auto POs som standard',0),(551683,15325,'ko','ê¸°ë³¸ì ìœ¼ë¡œ ìžë™ POsë¥¼ ë°›ì„',0),(551684,15325,'he','×ž×§×‘×œ×™× ××•×˜×•×ž×˜×™×ª POs ×›×‘×¨×™×¨×ª ×ž×—×“×œ',0),(551685,15325,'el','Î›Î¬Î²ÎµÏ„Îµ Auto Î Î©Î£ Î±Ï€ÏŒ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î®',0),(551686,15325,'zh','æŽ¥å—é»˜è®¤çš„è‡ªåŠ¨ POs',0),(551687,15325,'sv','Ta emot Auto POs som standard',0),(551688,15325,'it','Ricevere Auto POs per impostazione predefinita',0),(551689,15325,'tl','',0),(551690,15325,'th','à¸£à¸±à¸šà¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´ POs à¹‚à¸”à¸¢à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(551691,15325,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤°à¥‚à¤ª à¤¸à¥‡ à¤‘à¤Ÿà¥‹ POs à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(551692,15325,'ms','Menerima Auto POs secara lalai',0),(551693,15325,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ Ø¨Ø´ÙƒÙ„ Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(551694,15325,'fr','Recevoir des POs automatique par dÃ©faut',0),(551695,15325,'jp','æ—¢å®šã§ã¯è‡ªå‹• POs ã‚’å—ä¿¡ã—ã¾ã™ã€‚',0),(551696,15325,'pt','Receber Auto POs por padrÃ£o',0),(551697,15325,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð°ÑŽÑ‚ POs Auto Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(551698,15325,'es','Reciben Auto POs por defecto',0),(551699,15325,'de','Auto-POs standardmÃ¤ÃŸig erhalten',0),(551700,15325,'en','Receive Auto POs By Default',0),(551701,15326,'is','',0),(551702,15326,'dr','Ø³ÙØ§Ø±Ø´ Ù¾Ø°ÛŒØ±ÙØªÙ‡ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(551703,15326,'pr','Ø³ÙØ§Ø±Ø´ Ù¾Ø°ÛŒØ±ÙØªÙ‡ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(551704,15326,'tr','KullanÄ±cÄ± tarafÄ±ndan kabul sipariÅŸini gÃ¶ster',0),(551705,15326,'pl','PokaÅ¼ zamÃ³wienia przyjmowane przez uÅ¼ytkownika',0),(551706,15326,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°, Ð¿Ñ€Ð¸ÐµÑ‚Ð¸ Ð¾Ñ‚ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ñ',0),(551707,15326,'ur','ØµØ§Ø±Ù Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù‚Ø¨ÙˆÙ„ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(551708,15326,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ€ÐµÐ´ Ð¿Ñ€Ð¸Ñ…Ð²Ð°Ñ‚Ð¸Ð¾ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(551709,15326,'vi','Hiá»ƒn thá»‹ thá»© tá»± cháº¥p nháº­n bá»Ÿi ngÆ°á»i dÃ¹ng',0),(551710,15326,'af','Wys orde aanvaar deur gebruiker',0),(551711,15326,'ro','AratÄƒ ordinea acceptate de cÄƒtre utilizator',0),(551712,15326,'et','NÃ¤ita tellimust kasutaja poolt',0),(551713,15326,'si','PokaÅ¾i nalog, ki jih uporabnik',0),(551714,15326,'ba','Lihat pesanan yang diterima oleh pengguna',0),(551715,15326,'nl','Toon Order geaccepteerd door gebruiker',0),(551716,15326,'fi','NÃ¤ytÃ¤ tilaus kÃ¤yttÃ¤jÃ¤ hyvÃ¤ksynyt',0),(551717,15326,'no','Vis rekkefÃ¸lgen akseptert av bruker',0),(551718,15326,'da','Vis ordre accepteret af brugeren',0),(551719,15326,'ko','ì‚¬ìš©ìžì— ì˜í•´ í—ˆìš© í•˜ëŠ” í‘œì‹œ ìˆœì„œ',0),(551720,15326,'he','×œ×”×¦×™×’ ×”×–×ž× ×ª ×ž×ª×§×‘×œ×•×ª ×¢×œ-×™×“×™ ×”×ž×©×ª×ž×©',0),(551721,15326,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î±Ï€Î¿Î´ÎµÎºÏ„Î® Î±Ï€ÏŒ Ï„Î¿ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚',0),(551722,15326,'zh','ç”¨æˆ·æŽ¥å—çš„æ˜¾ç¤ºé¡ºåº',0),(551723,15326,'sv','Visa Order accepteras av anvÃ¤ndaren',0),(551724,15326,'it','Visualizza ordine accettato dall\'utente',0),(551725,15326,'tl','',0),(551726,15326,'th','à¹à¸ªà¸”à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸¢à¸­à¸¡à¸£à¸±à¸šà¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(551727,15326,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤ à¤†à¤¦à¥‡à¤¶ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤¿à¤ à¤œà¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(551728,15326,'ms','Menunjukkan perintah yang diterima oleh pengguna',0),(551729,15326,'ar','Ø£Ù…Ø± Ø¥Ø¸Ù‡Ø§Ø± Ù‚Ø¨ÙˆÙ„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(551730,15326,'fr','Voir la commande acceptÃ©e par utilisateur',0),(551731,15326,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«ã‚ˆã£ã¦å—ã‘å…¥ã‚Œã®é †åºã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(551732,15326,'pt','Mostrar ordem aceitado pelo usuÃ¡rio',0),(551733,15326,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð· Ð¿Ñ€Ð¸Ð½ÑÑ‚ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(551734,15326,'es','Mostrar pedido aceptado por el usuario',0),(551735,15326,'de','Bestellung der Karte vom Benutzer akzeptiert',0),(551736,15326,'en','Show Order Accepted By User',0),(551737,15327,'is','',0),(551738,15327,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÛŒ ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÛŒ Ø´Ù…Ø§Ø±Ù‡ Ø¯Ø± Ø®ÙˆØ¯Ú©Ø§Ø± POs',0),(551739,15327,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø´Ù…Ø§Ø±Ù‡ Ø³ÙØ§Ø±Ø´ Ø¨Ø±Ø§ÛŒ ØµÙ†Ø¯ÙˆÙ‚ Ù¾Ø³ØªÛŒ Ø´Ù…Ø§Ø±Ù‡ Ø¯Ø± Ø®ÙˆØ¯Ú©Ø§Ø± POs',0),(551740,15327,'tr','Otomatik POs PO numarasÄ± iÃ§in sipariÅŸ numarasÄ± kullanÄ±n',0),(551741,15327,'pl','UÅ¼yj numeru zamÃ³wienia na numer zamÃ³wienia w Auto POs',0),(551742,15327,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð° Ð·Ð° PO Ð½Ð¾Ð¼ÐµÑ€ Ð² Ð°Ð²Ñ‚Ð¾ POs',0),(551743,15327,'ur','Ø¢Ø±ÚˆØ± Ù†Ù…Ø¨Ø± Ø¢Ù¹Ùˆ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ù…ÛŒÚº Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(551744,15327,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð° Ð±Ñ€Ð¾Ñ˜ ÐÐ°Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ðµ Ñƒ ÐÑƒÑ‚Ð¾ ÐŸÐžÑ',0),(551745,15327,'vi','Sá»­ dá»¥ng cÃ¡c sá»‘ thá»© tá»± cho sá»‘ PO trong Auto POs',0),(551746,15327,'af','Gebruik volgorde nommer vir PO-nommer In outomatiese POs',0),(551747,15327,'ro','NumÄƒrul de ordine de utilizare pentru numÄƒrul bonului de comandÄƒ Ã®n Auto POs',0),(551748,15327,'et','Kasuta tellimuse Number PO numbri Auto POs',0),(551749,15327,'si','Uporabo zaporedno Å¡tevilko za Å¡tevilka NaroÄilnice v avto POs',0),(551750,15327,'ba','Menggunakan nomor pesanan untuk nomor PO Auto pos',0),(551751,15327,'nl','Ordernummer gebruiken voor PO-nummer In Auto POs',0),(551752,15327,'fi','KÃ¤ytÃ¤ numero PO Auto POS',0),(551753,15327,'no','Bruk nummeret For innkjÃ¸psordrenummer i Auto POs',0),(551754,15327,'da','Bruge ordrenummer For PO-nummer i Auto POs',0),(551755,15327,'ko','ì£¼ë¬¸ ë²ˆí˜¸ë¥¼ ì‚¬ìš© í•˜ ì—¬ PO ë²ˆí˜¸ ìžë™ POsì— ëŒ€ í•œ',0),(551756,15327,'he','×œ×”×©×ª×ž×© ×ž×¡×¤×¨ ×”×–×ž× ×” ×¢×‘×•×¨ ×ž×¡×¤×¨ ×”-PO ×‘- POs ××•×˜×•×ž×˜×™',0),(551757,15327,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î¿Î½ Î±ÏÎ¾Î¿Î½Ï„Î± Î±ÏÎ¹Î¸Î¼ÏŒ Î³Î¹Î± Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Î•Î½Ï„Î¿Î»Î®Ï‚ ÏƒÎµ Auto POs',0),(551758,15327,'zh','ç”¨äºŽè‡ªåŠ¨ POs çš„é‡‡è´­è®¢å•ç¼–å·è®¢å•å·',0),(551759,15327,'sv','AnvÃ¤nda ordernummer fÃ¶r inkÃ¶psordernummer i Auto POs',0),(551760,15327,'it','Utilizzare il numero d\'ordine per numero di PO In Auto POs',0),(551761,15327,'tl','',0),(551762,15327,'th','à¹ƒà¸Šà¹‰à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ PO à¹ƒà¸™à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´ POs',0),(551763,15327,'hi','à¤‘à¤Ÿà¥‹ POs à¤®à¥‡à¤‚ PO à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤°à¤® à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(551764,15327,'ms','Menggunakan nombor pesanan untuk nombor PO dalam Auto POs',0),(551765,15327,'ar','Ø§Ø³ØªØ®Ø¯Ù… Ø±Ù‚Ù… ØªØ±ØªÙŠØ¨ Ù„Ø±Ù‚Ù… Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡ ÙÙŠ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª',0),(551766,15327,'fr','Utiliser le numÃ©ro de commande pour le numÃ©ro d\'ordre d\'achat en Auto POs',0),(551767,15327,'jp','è‡ªå‹• POs å†…ã® PO ç•ªå·ã«é †åºç•ªå·ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(551768,15327,'pt','Use o nÃºmero de ordem por nÃºmero de PO em Auto POs',0),(551769,15327,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð° Ð´Ð»Ñ PO Ð½Ð¾Ð¼ÐµÑ€ Ð°Ð²Ñ‚Ð¾ POs',0),(551770,15327,'es','NÃºmero de orden de uso de nÃºmero en la posiciÃ³n Auto',0),(551771,15327,'de','Verwenden Sie Bestellnummer fÃ¼r PA-Nummer im Auto POs',0),(551772,15327,'en','Use Order Number For PO Number In Auto POs',0),(551773,15328,'is','',0),(551774,15328,'dr','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø´Ù‡Ø±Ø³ØªØ§Ù†',0),(551775,15328,'pr','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø´Ù‡Ø±Ø³ØªØ§Ù†',0),(551776,15328,'tr','Hastaneye sevk',0),(551777,15328,'pl','Statek do powiatu',0),(551778,15328,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð·Ð° Ð¾ÐºÑ€ÑŠÐ³',0),(551779,15328,'ur','Ú©Ø§Ø¤Ù†Ù¹ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø¬ÛØ§Ø²',0),(551780,15328,'sr','Ð‘Ñ€Ð¾Ð´ Ñƒ Ð¾ÐºÑ€ÑƒÐ³',0),(551781,15328,'vi','Gá»­i Ä‘áº¿n quáº­n',0),(551782,15328,'af','Skip na County',0),(551783,15328,'ro','NavÄƒ la County',0),(551784,15328,'et','Kauba saaja maakond',0),(551785,15328,'si','Ladja County',0),(551786,15328,'ba','Kapal ke County',0),(551787,15328,'nl','Schip aan County',0),(551788,15328,'fi','Aluksen County',0),(551789,15328,'no','Leveringsgate County',0),(551790,15328,'da','Skib til County',0),(551791,15328,'ko','í˜„ì— ë°°',0),(551792,15328,'he','×”×¡×¤×™× ×” ×œ×ž×—×•×–',0),(551793,15328,'el','Î Î»Î¿Î¯Î¿ Î½Î± County',0),(551794,15328,'zh','èˆ¹åˆ°åŽ¿',0),(551795,15328,'sv','Fartyget till lÃ¤net',0),(551796,15328,'it','Ship To County',0),(551797,15328,'tl','',0),(551798,15328,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹ƒà¸™à¹€à¸‚à¸•',0),(551799,15328,'hi','à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ',0),(551800,15328,'ms','Kapal County',0),(551801,15328,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ù…Ù‚Ø§Ø·Ø¹Ø©',0),(551802,15328,'fr','ExpÃ©dier Ã  comtÃ©',0),(551803,15328,'jp','éƒ¡ã«å‡ºè·ã—ã¾ã™ã€‚',0),(551804,15328,'pt','Navio para o municÃ­pio',0),(551805,15328,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð² Ð³Ñ€Ð°Ñ„ÑÑ‚Ð²Ð¾',0),(551806,15328,'es','Enviar al Condado de',0),(551807,15328,'de','Schiff nach County',0),(551808,15328,'en','Ship To County',0),(551809,15329,'is','',0),(551810,15329,'dr','Ù‚Ø¨ÙˆÙ„ Ø³ÙØ§Ø±Ø´',0),(551811,15329,'pr','Ù‚Ø¨ÙˆÙ„ Ø³ÙØ§Ø±Ø´',0),(551812,15329,'tr','SipariÅŸ tarafÄ±ndan kabul',0),(551813,15329,'pl','ZamÃ³wienie przyjÄ™te przez',0),(551814,15329,'bg','Ð ÐµÐ´, Ð¿Ñ€Ð¸ÐµÑ‚ Ð¾Ñ‚',0),(551815,15329,'ur','ØªØ±ØªÛŒØ¨ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù‚Ø¨ÙˆÙ„ Ú©Ø± Ù„ÛŒØ§',0),(551816,15329,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ Ð¿Ñ€Ð¸Ñ…Ð²Ð°Ñ›ÐµÐ½ Ð¾Ð´',0),(551817,15329,'vi','Thá»© tá»± cháº¥p nháº­n',0),(551818,15329,'af','Orde aanvaar deur',0),(551819,15329,'ro','Ordinul acceptate de',0),(551820,15329,'et','Poolt aktsepteeritud tellimuse',0),(551821,15329,'si','Nalog, ki jih je sprejela',0),(551822,15329,'ba','Order diterima oleh',0),(551823,15329,'nl','Volgorde aanvaard door',0),(551824,15329,'fi','Jotta hyvÃ¤ksyÃ¤',0),(551825,15329,'no','Bestill akseptert av',0),(551826,15329,'da','Ordren accepteres af',0),(551827,15329,'ko','ì£¼ë¬¸ì— ì˜í•´ í—ˆìš©',0),(551828,15329,'he','×¡×“×¨ ×ž×ª×§×‘×œ×•×ª ×¢×œ-×™×“×™',0),(551829,15329,'el','Î ÏÎ¿ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î½Î± Î³Î¯Î½ÎµÎ¹ Î±Ï€Î¿Î´ÎµÎºÏ„Î® Î±Ï€ÏŒ',0),(551830,15329,'zh','æ‰€æŽ¥å—çš„è®¢å•',0),(551831,15329,'sv','Ordning som godkÃ¤nts av',0),(551832,15329,'it','Ordine accettato da',0),(551833,15329,'tl','',0),(551834,15329,'th','à¸¢à¸­à¸¡à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(551835,15329,'hi','à¤†à¤¦à¥‡à¤¶ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥à¤µà¥€à¤•à¤¾à¤° à¤•à¤¿à¤ à¤œà¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(551836,15329,'ms','Perintah yang diterima oleh',0),(551837,15329,'ar','Ø£Ù…Ø± ØªÙ‚Ø¨Ù„Ù‡',0),(551838,15329,'fr','Commande acceptÃ©e par',0),(551839,15329,'jp','å—æ³¨',0),(551840,15329,'pt','Pedido aceitado pela',0),(551841,15329,'ru','Ð—Ð°ÐºÐ°Ð· Ð¿Ñ€Ð¸Ð½ÑÑ‚',0),(551842,15329,'es','Orden aceptada por',0),(551843,15329,'de','Bestellung von akzeptiert',0),(551844,15329,'en','Order Accepted By',0),(551845,15330,'is','',0),(551846,15330,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª Ø§Ø´ØªØ±Ø§Ú©',0),(551847,15330,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª Ø§Ø´ØªØ±Ø§Ú©',0),(551848,15330,'tr','GÃ¼ncelleÅŸtirme abonelik fatura',0),(551849,15330,'pl','ZaktualizowaÄ‡ subskrypcji pÅ‚atnoÅ›ci',0),(551850,15330,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(551851,15330,'ur','Ø±Ú©Ù†ÛŒØª Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(551852,15330,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ðµ',0),(551853,15330,'vi','Cáº­p Nháº­t Ä‘Äƒng kÃ½ thanh toÃ¡n',0),(551854,15330,'af','Bywerking intekengeld fakturering',0),(551855,15330,'ro','Facturare de abonament actualizare',0),(551856,15330,'et','Tellimus arveldamist vÃ¤rskendada',0),(551857,15330,'si','Posodobitev zaraÄunavanje naroÄnine',0),(551858,15330,'ba','Memperbarui berlangganan penagihan',0),(551859,15330,'nl','Update abonnement facturering',0),(551860,15330,'fi','PÃ¤ivitÃ¤ tilaus laskutus',0),(551861,15330,'no','Oppdatere fakturering av abonnement',0),(551862,15330,'da','Opdatere abonnement fakturering',0),(551863,15330,'ko','ì—…ë°ì´íŠ¸ êµ¬ë… ê²°ì œ',0),(551864,15330,'he','×—×™×•×‘ ×”×ž× ×•×™ ×¢×“×›×•×Ÿ',0),(551865,15330,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®Ï‚',0),(551866,15330,'zh','æ›´æ–°è®¢é˜…è®¡è´¹',0),(551867,15330,'sv','Uppdatera prenumeration fakturering',0),(551868,15330,'it','Aggiornamento sottoscrizione fatturazione',0),(551869,15330,'tl','',0),(551870,15330,'th','à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸ªà¸¡à¸²à¸Šà¸´à¸à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(551871,15330,'hi','à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¥‡à¤‚',0),(551872,15330,'ms','Kemaskini Terakhir bil langganan',0),(551873,15330,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ ÙÙŠ Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(551874,15330,'fr','Mise Ã  jour de la facturation de l\'abonnement',0),(551875,15330,'jp','è³¼èª­æ–™è«‹æ±‚æ›¸ã‚’æ›´æ–°ã—ã¾ã™ã€‚',0),(551876,15330,'pt','CobranÃ§a de assinatura de atualizaÃ§Ã£o',0),(551877,15330,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ¸ Ð±Ð¸Ð»Ð»Ð¸Ð½Ð³',0),(551878,15330,'es','ActualizaciÃ³n suscripciÃ³n facturaciÃ³n',0),(551879,15330,'de','Update Abonnement Abrechnung',0),(551880,15330,'en','Update Subscription Billing',0),(551881,15331,'is','',0),(551882,15331,'dr','Ù…Ù† Ø§Ø¬Ø§Ø²Ù‡ Nolapro Ø¨Ù‡ Ø§ØªÙ‡Ø§Ù… Ù…Ù† Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø§Ø´ØªØ±Ø§Ú©',0),(551883,15331,'pr','Ù…Ù† Ø§Ø¬Ø§Ø²Ù‡ Nolapro Ø¨Ù‡ Ø§ØªÙ‡Ø§Ù… Ù…Ù† Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ø§Ø´ØªØ±Ø§Ú©',0),(551884,15331,'tr','Nolapro benim Ã¶deme yÃ¶ntemi dosya Ã¼zerinde bu abonelik iÃ§in ÅŸarj etmek iÃ§in yetki',0),(551885,15331,'pl','UpowaÅ¼niam Nolapro do Å‚adowania mojej metody pÅ‚atnoÅ›ci na plik dla tej subskrypcja',0),(551886,15331,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐ°Ð²Ð°Ð¼ Nolapro Ð´Ð° Ð¾Ñ‚Ð³Ð¾Ð²Ð°Ñ€Ñ Ð¼ÐµÑ‚Ð¾Ð´ÑŠÑ‚ Ð¼Ð¸ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð» Ð·Ð° Ñ‚Ð¾Ð·Ð¸ Ð°Ð±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚',0),(551887,15331,'ur','Ù…ÛŒÚº Ù†ÙˆÙ„Ø§Ù¾Ø±Ùˆ Ù…ÛŒØ±ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± Ù¾Ø± Ù…Ø³Ù„ Ø§Ø³ Ú©ÛŒ Ø±Ú©Ù†ÛŒØª Ú©Û’ Ù„Ø¦Û’ Ú†Ø§Ø±Ø¬ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÙ†Ø§',0),(551888,15331,'sr','ÐžÐ´Ð¾Ð±Ñ€Ð°Ð²Ð°Ð¼ ÐÐ¾Ð»Ð°Ð¿Ñ€Ð¾ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ð¼Ð¾Ñ˜ Ð½Ð°Ñ‡Ð¸Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸ Ð·Ð° Ð¾Ð²Ñƒ Ð¿Ñ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ñƒ',0),(551889,15331,'vi','TÃ´i cho phÃ©p Nolapro Ä‘á»ƒ tÃ­nh phÃ­ cá»§a tÃ´i phÆ°Æ¡ng thá»©c thanh toÃ¡n trÃªn tá»‡p cho cÃ¡c thuÃª bao nÃ y',0),(551890,15331,'af','Ek magtig Nolapro te hef My betaling metode op lÃªer vir hierdie inskrywing',0),(551891,15331,'ro','Autorizez Nolapro sÄƒ perceapÄƒ metoda mea de platÄƒ pe dosar pentru acest abonament',0),(551892,15331,'et','Ma lubada Nolapro kÃ¼sida minu maksemeetod faili see tellimus',0),(551893,15331,'si','SoglaÅ¡am, da Nolapro moj naÄin plaÄila na datoteko zaraÄunavati naroÄnina',0),(551894,15331,'ba','Saya otorisasi Nolapro biaya metode pembayaran saya pada File untuk berlangganan ini',0),(551895,15331,'nl','Ik toestaan Nolapro mijn betalingsmethode bestand opladen voor dit abonnement',0),(551896,15331,'fi','Annan luvan veloittaa valitsemaani maksuvÃ¤linettÃ¤ tiedosto tÃ¤mÃ¤n tilauksen Nolapro',0),(551897,15331,'no','Jeg godkjenne Nolapro Ã¥ belaste min betalingsmÃ¥te pÃ¥ filen For dette abonnementet',0),(551898,15331,'da','Jeg tillader Nolapro at oplade min betalingsmetode pÃ¥ fil For dette abonnement',0),(551899,15331,'ko','ì´ êµ¬ë…ì— ëŒ€ í•œ íŒŒì¼ì— ë‚´ ê²°ì œ ë°©ë²• ì¶©ì „ Nolapro ìŠ¹ì¸í•  ìˆ˜ ìžˆìŠµë‹ˆê¹Œ',0),(551900,15331,'he','×× ×™ ×œ××©×¨ Nolapro ×œ×—×™×™×‘ ××ª ×©×™×˜×ª ×”×ª×©×œ×•× ×©×œ×™ ×¢×œ ×§×•×‘×¥ ×¢×‘×•×¨ ×ž× ×•×™ ×–×”',0),(551901,15331,'el','Î•Î¾Î¿Ï…ÏƒÎ¹Î¿Î´Î¿Ï„ÏŽ Nolapro Î½Î± Ï‡ÏÎµÏŽÏƒÎµÏ„Îµ Ï„Î· Î¼Î­Î¸Î¿Î´Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î¼Î¿Ï… ÏƒÏ„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î³Î¹Î± Î±Ï…Ï„Î®Î½ Ï„Î· ÏƒÏ…Î½Î´ÏÎ¿Î¼Î®',0),(551902,15331,'zh','æœ¬äººæŽˆæƒ Nolapro å¯¹æ­¤è®¢é˜…æ”¶è´¹æ–‡ä»¶æˆ‘ä»˜æ¬¾æ–¹æ³•',0),(551903,15331,'sv','Jag befullmÃ¤ktigar Nolapro ta ut min betalningsmetod pÃ¥ fil fÃ¶r detta abonnemang',0),(551904,15331,'it','Autorizzo Nolapro per caricare il mio metodo di pagamento su File per questo abbonamento',0),(551905,15331,'tl','',0),(551906,15331,'th','à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸à¸²à¸£ Nolapro à¸„à¹ˆà¸²à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸‰à¸±à¸™à¸šà¸™à¹à¸Ÿà¹‰à¸¡à¸ªà¸³à¸«à¸£à¸±à¸š',0),(551907,15331,'hi','à¤®à¥ˆà¤‚ Nolapro à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¤° à¤…à¤ªà¤¨à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¦à¥à¤§à¤¤à¤¿ à¤‡à¤¸ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤°à¥à¤œ à¤•à¥‹ à¤…à¤§à¤¿à¤•à¥ƒà¤¤',0),(551908,15331,'ms','Saya membenarkan Nolapro untuk mengenakan saya kaedah pembayaran dalam fail untuk langganan ini',0),(551909,15331,'ar','Ø£Ù†Ø§ ÙŠØ£Ø°Ù† Ù†ÙˆÙ„Ø§Ø¨Ø±Ùˆ Ù„ØªÙˆØ¬ÙŠÙ‡ Ø§Ù„Ø§ØªÙ‡Ø§Ù… Ù„ÙŠ Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹ ÙÙŠ Ø§Ù„Ù…Ù„Ù Ù„Ù‡Ø°Ø§ Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(551910,15331,'fr','J\'autorise Nolapro Ã  charger mon mode de paiement au dossier pour m\'inscrire',0),(551911,15331,'jp','ã“ã®ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã®ãƒ•ã‚¡ã‚¤ãƒ«ã«æ”¯æ‰•ã„æ–¹æ³•ã‚’è«‹æ±‚ã™ã‚‹ Nolapro ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(551912,15331,'pt','Autorizo o Nolapro cobrar meu mÃ©todo de pagamento em arquivo para essa assinatura',0),(551913,15331,'ru','Ð¯ Ñ€Ð°Ð·Ñ€ÐµÑˆÐ°ÑŽ Nolapro Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¼Ð½Ðµ ÑÐ¿Ð¾ÑÐ¾Ð± Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð½Ð° Ñ„Ð°Ð¹Ð» Ð´Ð»Ñ ÑÑ‚Ð¾Ð¹ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ¸',0),(551914,15331,'es','Autorizo a Nolapro para cargar mi mÃ©todo de pago en el archivo de esta suscripciÃ³n',0),(551915,15331,'de','Ich ermÃ¤chtige Artikel meine Zahlungsart hinterlegt fÃ¼r dieses Abonnement kostenlos',0),(551916,15331,'en','I Authorize Nolapro To Charge My Payment Method On File For This Subscription',0),(551917,15332,'is','',0),(551918,15332,'dr','Ø§Ø´ØªØ±Ø§Ú© Ø¨Ø±ÙˆØ²',0),(551919,15332,'pr','Ø§Ø´ØªØ±Ø§Ú© Ø¨Ø±ÙˆØ²',0),(551920,15332,'tr','GÃ¼ncelleme abonelik',0),(551921,15332,'pl','Subskrypcja aktualizacji',0),(551922,15332,'bg','ÐÐ±Ð¾Ð½Ð°Ð¼ÐµÐ½Ñ‚ ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°',0),(551923,15332,'ur','Ø±Ú©Ù†ÛŒØª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(551924,15332,'sr','ÐŸÑ€ÐµÑ‚Ð¿Ð»Ð°Ñ‚Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°',0),(551925,15332,'vi','ÄÄƒng kÃ½ Cáº­p Nháº­t',0),(551926,15332,'af','Intekengeld bygewerk',0),(551927,15332,'ro','Abonament actualizat',0),(551928,15332,'et','Uuendatud tellimus',0),(551929,15332,'si','NaroÄnina posodobljena',0),(551930,15332,'ba','Berlangganan Diperbarui',0),(551931,15332,'nl','Abonnement bijgewerkt',0),(551932,15332,'fi','Tilaus ajan tasalla',0),(551933,15332,'no','Abonnementet oppdatert',0),(551934,15332,'da','Abonnementet opdateret',0),(551935,15332,'ko','êµ¬ë… ì—…ë°ì´íŠ¸',0),(551936,15332,'he','×ž× ×•×™ ×ž×¢×•×“×›×Ÿ',0),(551937,15332,'el','Î£Ï…Î½Î´ÏÎ¿Î¼Î® ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(551938,15332,'zh','æ›´æ–°è®¢é˜…',0),(551939,15332,'sv','Prenumeration uppdateras',0),(551940,15332,'it','Abbonamento aggiornato',0),(551941,15332,'tl','',0),(551942,15332,'th','à¸ªà¸¡à¸²à¸Šà¸´à¸à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(551943,15332,'hi','à¤¨à¤µà¥€à¤¨à¥€à¤•à¥ƒà¤¤ à¤¸à¤¦à¤¸à¥à¤¯à¤¤à¤¾',0),(551944,15332,'ms','Langganan yang dikemaskini',0),(551945,15332,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø§Ø´ØªØ±Ø§Ùƒ',0),(551946,15332,'fr','Abonnement mis Ã  jour',0),(551947,15332,'jp','ã‚µãƒ–ã‚¹ã‚¯ãƒªãƒ—ã‚·ãƒ§ãƒ³ã®æ›´æ–°',0),(551948,15332,'pt','Assinatura atualizada',0),(551949,15332,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð´Ð¿Ð¸ÑÐºÐ¸',0),(551950,15332,'es','SuscripciÃ³n actualizada',0),(551951,15332,'de','Abonnement aktualisiert',0),(551952,15332,'en','Subscription Updated',0),(551953,15333,'is','',0),(551954,15333,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØµØ¯ÙˆØ± ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(551955,15333,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØµØ¯ÙˆØ± ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(551956,15333,'tr','Fatura bilgileri girin',0),(551957,15333,'pl','WprowadÅº informacje rozliczeniowe',0),(551958,15333,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(551959,15333,'ur','Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(551960,15333,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(551961,15333,'vi','Nháº­p thÃ´ng tin thanh toÃ¡n',0),(551962,15333,'af','Tik inligting vir fakturering',0),(551963,15333,'ro','IntroduceÅ£i informaÅ£iile de facturare',0),(551964,15333,'et','Sisestage maksja andmed',0),(551965,15333,'si','Vnos informacij za obraÄun.',0),(551966,15333,'ba','Masukkan informasi penagihan',0),(551967,15333,'nl','Voer de factureringsgegevens',0),(551968,15333,'fi','Kirjoita laskutustiedot',0),(551969,15333,'no','Angi faktureringsinformasjon',0),(551970,15333,'da','Indtaste faktureringsoplysninger',0),(551971,15333,'ko','ê²°ì œ ì •ë³´ ìž…ë ¥',0),(551972,15333,'he','×”×–×Ÿ ×ž×™×“×¢ ××•×“×•×ª ×”×—×™×•×‘',0),(551973,15333,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚',0),(551974,15333,'zh','è¾“å…¥å¸å•ä¿¡æ¯',0),(551975,15333,'sv','Ange faktureringsinformation',0),(551976,15333,'it','Immettere le informazioni di fatturazione',0),(551977,15333,'tl','',0),(551978,15333,'th','à¸›à¹‰à¸­à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(551979,15333,'hi','à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(551980,15333,'ms','Masukkan maklumat bil',0),(551981,15333,'ar','Ø£Ø¯Ø®Ù„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ÙÙˆØªØ±Ø©',0),(551982,15333,'fr','Entrez les informations de facturation',0),(551983,15333,'jp','èª²é‡‘æƒ…å ±ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(551984,15333,'pt','Insira as informaÃ§Ãµes de faturamento',0),(551985,15333,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾Ð± Ð¾Ð¿Ð»Ð°Ñ‚Ðµ',0),(551986,15333,'es','Introducir informaciÃ³n de facturaciÃ³n',0),(551987,15333,'de','Rechnungsinformationen eingeben',0),(551988,15333,'en','Enter Billing Information',0),(551989,15334,'is','',0),(551990,15334,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ú©Ø§Ù† ØºÛŒØ±Ù…Ø¹ØªØ¨Ø±',0),(551991,15334,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù…Ú©Ø§Ù† ØºÛŒØ±Ù…Ø¹ØªØ¨Ø±',0),(551992,15334,'tr','GeÃ§ersiz konum kimliÄŸi',0),(551993,15334,'pl','NieprawidÅ‚owe poÅ‚oÅ¼enie ID',0),(551994,15334,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð˜Ð” Ð·Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(551995,15334,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø´Ù†Ø§Ø®Øª',0),(551996,15334,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ Ð˜Ð” Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(551997,15334,'vi','Vá»‹ trÃ­ khÃ´ng há»£p lá»‡ ID',0),(551998,15334,'af','Ongeldige lokaliteit ID',0),(551999,15334,'ro','LocaÈ›ie nevalidÄƒ ID',0),(552000,15334,'et','Lubamatu asukoha-ID',0),(552001,15334,'si','Neveljavno mesto ID',0),(552002,15334,'ba','ID valid lokasi',0),(552003,15334,'nl','Ongeldige locatie-ID',0),(552004,15334,'fi','Virheellinen sijainnin tunnus',0),(552005,15334,'no','Ugyldig Steds-ID',0),(552006,15334,'da','Ugyldig placering ID',0),(552007,15334,'ko','ìž˜ëª» ëœ ìœ„ì¹˜ ID',0),(552008,15334,'he','×ž×–×”×” ×ž×™×§×•× ×œ× ×—×•×§×™',0),(552009,15334,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· Î¸Î­ÏƒÎ· ID',0),(552010,15334,'zh','æ— æ•ˆçš„ä½ç½® ID',0),(552011,15334,'sv','Ogiltig plats-ID',0),(552012,15334,'it','ID di percorso non valido',0),(552013,15334,'tl','',0),(552014,15334,'th','à¸£à¸«à¸±à¸ªà¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(552015,15334,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤¸à¥à¤¥à¤¾à¤¨ ID',0),(552016,15334,'ms','ID tidak sah lokasi',0),(552017,15334,'ar','Ù…Ø¹Ø±Ù Ù…ÙˆÙ‚Ø¹ ØºÙŠØ± ØµØ§Ù„Ø­',0),(552018,15334,'fr','CODE d\'emplacement non valide',0),(552019,15334,'jp','ç„¡åŠ¹ãªå ´æ‰€ ID',0),(552020,15334,'pt','ID da localizaÃ§Ã£o invÃ¡lida',0),(552021,15334,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð¾Ðµ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ ID',0),(552022,15334,'es','ID de la ubicaciÃ³n no vÃ¡lida',0),(552023,15334,'de','UngÃ¼ltigen Speicherort-ID',0),(552024,15334,'en','Invalid Location ID',0),(552025,15335,'is','',0),(552026,15335,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(552027,15335,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(552028,15335,'tr','GeÃ§ersiz satÄ±cÄ± kimliÄŸi',0),(552029,15335,'pl','NieprawidÅ‚owe Vendor ID',0),(552030,15335,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð½Ð° Ð˜Ð”',0),(552031,15335,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² ÙˆÛŒÙ†ÚˆØ± Ø´Ù†Ø§Ø®Øª',0),(552032,15335,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð˜Ð”',0),(552033,15335,'vi','NhÃ  cung cáº¥p khÃ´ng há»£p lá»‡ ID',0),(552034,15335,'af','Ongeldige handelaar ID',0),(552035,15335,'ro','ID furnizor nevalid',0),(552036,15335,'et','Kehtetu tarnija ID',0),(552037,15335,'si','Neveljaven dobavitelja ID',0),(552038,15335,'ba','ID valid Vendor',0),(552039,15335,'nl','Ongeldige leverancier-ID',0),(552040,15335,'fi','Virheellinen tunnus',0),(552041,15335,'no','Ugyldig leverandÃ¸r-ID',0),(552042,15335,'da','Ugyldig leverandÃ¸r-ID',0),(552043,15335,'ko','ìž˜ëª» ëœ ê³µê¸‰ ì—…ì²´ ID',0),(552044,15335,'he','×ž×–×”×” ×¡×¤×§ ×œ× ×—×•×§×™',0),(552045,15335,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ· Vendor ID',0),(552046,15335,'zh','æ— æ•ˆçš„ä¾›åº”å•† ID',0),(552047,15335,'sv','Ogiltig vendÃ¶r ID',0),(552048,15335,'it','ID non valido fornitore',0),(552049,15335,'tl','',0),(552050,15335,'th','à¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(552051,15335,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ ID',0),(552052,15335,'ms','Tidak sah Vendor ID',0),(552053,15335,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…ÙˆØ±Ø¯ ØºÙŠØ± ØµØ­ÙŠØ­',0),(552054,15335,'fr','ID de fournisseur non valide',0),(552055,15335,'jp','ç„¡åŠ¹ãªãƒ™ãƒ³ãƒ€ãƒ¼ ID',0),(552056,15335,'pt','ID do fornecedor invÃ¡lido',0),(552057,15335,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº ID',0),(552058,15335,'es','ID de proveedor no vÃ¡lida',0),(552059,15335,'de','UngÃ¼ltige VerkÃ¤ufer-ID',0),(552060,15335,'en','Invalid Vendor ID',0),(552061,15336,'is','',0),(552062,15336,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙˆØ§Ø±Ø¯ ØªØ§ Ø­Ø¯ÛŒ',0),(552063,15336,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ ÙˆØ§Ø±Ø¯ ØªØ§ Ø­Ø¯ÛŒ',0),(552064,15336,'tr','Stok veri kÄ±smen ithal',0),(552065,15336,'pl','Magazynowych dane importowane czÄ™Å›ciowo',0),(552066,15336,'bg','Ð¡ÐºÐ»Ð°Ð´ Ð´Ð°Ð½Ð½Ð¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ Ñ‡Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾',0),(552067,15336,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ ÚˆÛŒÙ¹Ø§ Ø¬Ø²ÙˆÛŒ Ø·ÙˆØ± Ù¾Ø± Ø¯Ø±Ø¢Ù…Ø¯ Ú©ÛŒØ§',0),(552068,15336,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ ÐºÐ¾Ñ˜Ð¸ ÑÑƒ Ð´ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð¾ ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸',0),(552069,15336,'vi','HÃ ng tá»“n kho dá»¯ liá»‡u nháº­p kháº©u má»™t pháº§n',0),(552070,15336,'af','Voorraad Data ingevoer gedeeltelik',0),(552071,15336,'ro','Inventarul datele importate parÅ£ial',0),(552072,15336,'et','Inventuuri andmed osaliselt imporditud',0),(552073,15336,'si','Podatke o uvoÅ¾enih delno',0),(552074,15336,'ba','Inventarisasi Data yang diimpor sebagian',0),(552075,15336,'nl','Voorraadgegevens gedeeltelijk ingevoerd',0),(552076,15336,'fi','Inventaarion tuotu osittain',0),(552077,15336,'no','Lagerdata importert delvis',0),(552078,15336,'da','Lagerdata importeres delvist',0),(552079,15336,'ko','ë¶€ë¶„ì ìœ¼ë¡œ ê°€ì ¸ì˜¨ ìž¬ê³  ë°ì´í„°',0),(552080,15336,'he','× ×ª×•× ×™ ×ž×œ××™ ×ž×™×•×‘××™× ×‘××•×¤×Ÿ ×—×œ×§×™',0),(552081,15336,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Ï„Ï‰Î½ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼ÎµÏÎ¹ÎºÏŽÏ‚',0),(552082,15336,'zh','å¯¼å…¥éƒ¨åˆ†çš„åº“å­˜æ•°æ®',0),(552083,15336,'sv','Inventeringsdata importeras delvis',0),(552084,15336,'it','Dati di inventario importati parzialmente',0),(552085,15336,'tl','',0),(552086,15336,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸—à¸µà¹ˆà¸™à¸³à¹€à¸‚à¹‰à¸²à¸šà¸²à¸‡à¸ªà¹ˆà¸§à¸™',0),(552087,15336,'hi','à¤†à¤‚à¤¶à¤¿à¤• à¤°à¥‚à¤ª à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ à¤®à¤¾à¤² à¤¡à¥‡à¤Ÿà¤¾',0),(552088,15336,'ms','Data inventori yang diimport separa',0),(552089,15336,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¬Ø±Ø¯ Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø© Ø¬Ø²Ø¦ÙŠØ§',0),(552090,15336,'fr','DonnÃ©es d\'inventaire importÃ©es partiellement',0),(552091,15336,'jp','ã‚¤ãƒ³ãƒ™ãƒ³ãƒˆãƒª ãƒ‡ãƒ¼ã‚¿ã‚’éƒ¨åˆ†çš„ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(552092,15336,'pt','Dados de inventÃ¡rio importados parcialmente',0),(552093,15336,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… Ñ‡Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾',0),(552094,15336,'es','Datos de los inventarios importados parcialmente',0),(552095,15336,'de','Bestandsdaten, die teilweise importiert',0),(552096,15336,'en','Inventory Data Imported Partially',0),(552097,15337,'is','',0),(552098,15337,'dr','Ú†Ù†Ø¯ Ù…ÙˆØ±Ø¯ Ù¾ÛŒØ¯Ø§ Ú©Ø±Ø¯Ù…',0),(552099,15337,'pr','Ú†Ù†Ø¯ Ù…ÙˆØ±Ø¯ Ù¾ÛŒØ¯Ø§ Ú©Ø±Ø¯Ù…',0),(552100,15337,'tr','Birden Ã§ok bileÅŸen bulundu',0),(552101,15337,'pl','Wiele przedmiotÃ³w znalezionych',0),(552102,15337,'bg','ÐÐ°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð¼Ð½Ð¾Ð¶ÐµÑÑ‚Ð²Ð¾ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(552103,15337,'ur','Ú©Ø«ÛŒØ± Ø§Ø´ÛŒØ§ Ù¾Ø§ÛŒØ§',0),(552104,15337,'sr','Ð’Ð¸ÑˆÐµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(552105,15337,'vi','Nhiá»u khoáº£n má»¥c tÃ¬m tháº¥y',0),(552106,15337,'af','Meervoudige Items gevind',0),(552107,15337,'ro','Mai multe elemente gÄƒsite',0),(552108,15337,'et','Leidsin mitu Ã¼ksust',0),(552109,15337,'si','VeÄ elementov',0),(552110,15337,'ba','Beberapa item yang ditemukan',0),(552111,15337,'nl','Meerdere objecten gevonden',0),(552112,15337,'fi','Useita kohteita lÃ¶ytyi',0),(552113,15337,'no','Flere elementer',0),(552114,15337,'da','Flere emner fundet',0),(552115,15337,'ko','ì—¬ëŸ¬ í•­ëª© ë°œê²¬',0),(552116,15337,'he','×ž×¡×¤×¨ ×¤×¨×™×˜×™× × ×ž×¦××•',0),(552117,15337,'el','Î Î¿Î»Î»Î¬ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(552118,15337,'zh','å‘çŽ°çš„å¤šä¸ªé¡¹ç›®',0),(552119,15337,'sv','Flera objekt hittades',0),(552120,15337,'it','PiÃ¹ elementi trovati',0),(552121,15337,'tl','',0),(552122,15337,'th','à¸«à¸¥à¸²à¸¢à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¸žà¸š',0),(552123,15337,'hi','à¤à¤•à¤¾à¤§à¤¿à¤• à¤†à¤‡à¤Ÿà¤® à¤ªà¤¾à¤¯à¤¾',0),(552124,15337,'ms','Item berbilang yang ditemui',0),(552125,15337,'ar','Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¹Ù†Ø§ØµØ± Ù…ØªØ¹Ø¯Ø¯Ø©',0),(552126,15337,'fr','Plusieurs Ã©lÃ©ments trouvÃ©s',0),(552127,15337,'jp','è¤‡æ•°ã®ã‚¢ã‚¤ãƒ†ãƒ ã‚’ç™ºè¦‹',0),(552128,15337,'pt','VÃ¡rios itens encontrados',0),(552129,15337,'ru','ÐÐ°Ð¹Ð´ÐµÐ½Ð¾ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(552130,15337,'es','MÃºltiples artÃ­culos encontrados',0),(552131,15337,'de','Mehrere EintrÃ¤ge gefunden',0),(552132,15337,'en','Multiple Items Found',0),(552133,15338,'is','',0),(552134,15338,'dr','Ù‡ÛŒÚ† Ø´Ù†Ø§Ø³Ù‡ Ø³ÙØ§Ø±Ø´',0),(552135,15338,'pr','Ù‡ÛŒÚ† Ø´Ù†Ø§Ø³Ù‡ Ø³ÙØ§Ø±Ø´',0),(552136,15338,'tr','HiÃ§bir sipariÅŸ No',0),(552137,15338,'pl','Nie ID zamÃ³wienia',0),(552138,15338,'bg','ÐÑÐ¼Ð° Ð˜Ð” Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(552139,15338,'ur','Ú©Ø³ÛŒ Ù†Ø¸Ù… Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(552140,15338,'sr','ÐÐµÐ¼Ð° Ð˜Ð” Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(552141,15338,'vi','KhÃ´ng cÃ³ ID Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(552142,15338,'af','Geen bestelling ID',0),(552143,15338,'ro','Nici un ID de comandÄƒ',0),(552144,15338,'et','Tellimuse ID',0),(552145,15338,'si','Ni ID naroÄila',0),(552146,15338,'ba','ID pesanan tidak',0),(552147,15338,'nl','Geen Order-ID',0),(552148,15338,'fi','Tilauksen tunnus',0),(552149,15338,'no','Ingen ordre-ID',0),(552150,15338,'da','Ingen ordre-ID',0),(552151,15338,'ko','ì£¼ë¬¸ ID',0),(552152,15338,'he','×œ× ×ž×–×”×” ×”×–×ž× ×”',0),(552153,15338,'el','Î”ÎµÎ½ Î Î±ÏÎ±Î³Î³',0),(552154,15338,'zh','æ²¡æœ‰è®¢å• ID',0),(552155,15338,'sv','Ingen Order-ID',0),(552156,15338,'it','Nessun ID di ordine',0),(552157,15338,'tl','',0),(552158,15338,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸«à¸±à¸ªà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(552159,15338,'hi','à¤•à¥‹à¤ˆ à¤•à¥à¤°à¤® ID',0),(552160,15338,'ms','Tiada ID perintah',0),(552161,15338,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…Ø¹Ø±Ù Ø§Ù„Ù†Ø¸Ø§Ù…',0),(552162,15338,'fr','Aucun ID de commande',0),(552163,15338,'jp','æ³¨æ–‡ ID ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(552164,15338,'pt','Nenhum ID de ordem',0),(552165,15338,'ru','ÐÐµÑ‚ ID Ð·Ð°ÐºÐ°Ð·Ð°',0),(552166,15338,'es','NingÃºn ID de orden',0),(552167,15338,'de','Keine Bestell-ID',0),(552168,15338,'en','No Order ID',0),(552169,15339,'is','',0),(552170,15339,'dr','Ù‡ÛŒÚ† Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(552171,15339,'pr','Ù‡ÛŒÚ† Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(552172,15339,'tr','SatÄ±cÄ± kimliÄŸi',0),(552173,15339,'pl','Brak identyfikatora dostawcy',0),(552174,15339,'bg','ÐÑÐ¼Ð° Ð˜Ð” Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°',0),(552175,15339,'ur','Ú©ÙˆØ¦ÛŒ ÙˆÛŒÙ†ÚˆØ± Ø´Ù†Ø§Ø®Øª',0),(552176,15339,'sr','ÐÐµÐ¼Ð° Ð˜Ð” Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(552177,15339,'vi','KhÃ´ng cÃ³ ID nhÃ  cung cáº¥p',0),(552178,15339,'af','Geen handelaar ID',0),(552179,15339,'ro','Nici un ID de furnizor',0),(552180,15339,'et','Hankija ID',0),(552181,15339,'si','Ni ID prodajalca',0),(552182,15339,'ba','Ada Penjual ID',0),(552183,15339,'nl','Geen Vendor-ID',0),(552184,15339,'fi','Toimittajatunnus',0),(552185,15339,'no','Ingen leverandÃ¸r-ID',0),(552186,15339,'da','Ingen leverandÃ¸r-ID',0),(552187,15339,'ko','ê³µê¸‰ ì—…ì²´ ID',0),(552188,15339,'he','×œ× ×ž×–×”×” ×¡×¤×§',0),(552189,15339,'el','Î§Ï‰ÏÎ¯Ï‚ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(552190,15339,'zh','æ²¡æœ‰ä¾›åº”å•† ID',0),(552191,15339,'sv','Ingen-ID fÃ¶r leverantÃ¶r',0),(552192,15339,'it','Nessun ID fornitore',0),(552193,15339,'tl','',0),(552194,15339,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸‚à¸²à¸¢',0),(552195,15339,'hi','à¤•à¥‹à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ ID',0),(552196,15339,'ms','Tiada nombor Vendor ID',0),(552197,15339,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…Ø¹Ø±Ù Ø§Ù„Ù…ÙˆØ±Ø¯',0),(552198,15339,'fr','Aucun ID de fournisseur',0),(552199,15339,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ID ãªã—',0),(552200,15339,'pt','Sem ID do fornecedor',0),(552201,15339,'ru','ÐÐµÑ‚ ID Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(552202,15339,'es','No identificaciÃ³n del vendedor',0),(552203,15339,'de','Keine Hersteller-ID',0),(552204,15339,'en','No Vendor ID',0),(552205,15340,'is','',0),(552206,15340,'dr','Ø´Ù…Ø§Ø±Ù‡ ØµÙ†Ø¯ÙˆÙ‚ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(552207,15340,'pr','Ø´Ù…Ø§Ø±Ù‡ ØµÙ†Ø¯ÙˆÙ‚ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(552208,15340,'tr','Zaten kullanÄ±lan PO numarasÄ±',0),(552209,15340,'pl','Numer zamÃ³wienia juÅ¼ uÅ¼ywane',0),(552210,15340,'bg','PO Ð½Ð¾Ð¼ÐµÑ€ Ð²ÐµÑ‡Ðµ ÑÐµ Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°',0),(552211,15340,'ur','Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± Ù¾ÛÙ„Û’ ÛÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©ÛŒØ§',0),(552212,15340,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐÐ°Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ðµ Ð²ÐµÑ› ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸',0),(552213,15340,'vi','Sá»‘ PO Ä‘Ã£ Ä‘Æ°á»£c sá»­ dá»¥ng',0),(552214,15340,'af','Posbus nommer reeds gebruik',0),(552215,15340,'ro','NumÄƒrul bonului de comandÄƒ folosit deja',0),(552216,15340,'et','PO Number juba kasutatud',0),(552217,15340,'si','Å tevilka NaroÄilnice, ki se Å¾e uporabljajo',0),(552218,15340,'ba','Nomor PO sudah digunakan',0),(552219,15340,'nl','PO-nummer al gebruikt',0),(552220,15340,'fi','Ostotilauksen numero kÃ¤ytÃ¶ssÃ¤',0),(552221,15340,'no','InnkjÃ¸psordrenummer allerede brukt',0),(552222,15340,'da','PO-nummer allerede brugt',0),(552223,15340,'ko','ì£¼ë¬¸ì„œ ë²ˆí˜¸ ì´ë¯¸ ì‚¬ìš©',0),(552224,15340,'he','×ž×¡×¤×¨ ×”-PO ×›×‘×¨ ×‘×©×™×ž×•×©',0),(552225,15340,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î•Î½Ï„Î¿Î»Î®Ï‚ Ï€Î¿Ï… Î®Î´Î· Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹ÎµÎ¯Ï„Î±Î¹',0),(552226,15340,'zh','å·²ä½¿ç”¨çš„é‡‡è´­è®¢å•ç¼–å·',0),(552227,15340,'sv','InkÃ¶psordernummer som redan anvÃ¤nds',0),(552228,15340,'it','Numero di PO giÃ  utilizzato',0),(552229,15340,'tl','',0),(552230,15340,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ PO à¸—à¸µà¹ˆà¹ƒà¸Šà¹‰à¹à¸¥à¹‰à¸§',0),(552231,15340,'hi','PO à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤¸à¥à¤¤à¥‡à¤®à¤¾à¤² à¤•à¤¿à¤¯à¤¾',0),(552232,15340,'ms','Nombor PO yang telah digunakan',0),(552233,15340,'ar','Ø±Ù‚Ù… Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡ Ø§Ù„ØªÙŠ Ø§Ø³ØªØ®Ø¯Ù…Øª Ø¨Ø§Ù„ÙØ¹Ù„',0),(552234,15340,'fr','NumÃ©ro d\'ordre d\'achat dÃ©jÃ  utilisÃ©',0),(552235,15340,'jp','PO ç•ªå·ãŒæ—¢ã«ä½¿ç”¨ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(552236,15340,'pt','NÃºmero de po jÃ¡ utilizado',0),(552237,15340,'ru','PO Ð½Ð¾Ð¼ÐµÑ€ ÑƒÐ¶Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐµÑ‚ÑÑ',0),(552238,15340,'es','NÃºmero de PO ya',0),(552239,15340,'de','PA-Nummer bereits verwendet',0),(552240,15340,'en','PO Number Already Used',0),(552241,15341,'is','',0),(552242,15341,'dr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø§ÛŒØ¬Ø§Ø¯ ØµÙ†Ø¯ÙˆÙ‚',0),(552243,15341,'pr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø§ÛŒØ¬Ø§Ø¯ ØµÙ†Ø¯ÙˆÙ‚',0),(552244,15341,'tr','Otomatik oluÅŸtur PO',0),(552245,15341,'pl','Automatyczne tworzenie PO',0),(552246,15341,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° PO',0),(552247,15341,'ur','Ø¢Ù¹Ùˆ ØªØ®Ù„ÛŒÙ‚ Ù¾Ùˆ',0),(552248,15341,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¿Ð¾-Ð°',0),(552249,15341,'vi','Tá»± Ä‘á»™ng táº¡o PO',0),(552250,15341,'af','Outomatiese skep PO',0),(552251,15341,'ro','Auto crea PO',0),(552252,15341,'et','Auto luua PO',0),(552253,15341,'si','Samodejno ustvariti PO',0),(552254,15341,'ba','Auto membuat PO',0),(552255,15341,'nl','Auto Inkooporders maken',0),(552256,15341,'fi','Luo Ostotilaus automaattisesti',0),(552257,15341,'no','Automatisk opprette PO',0),(552258,15341,'da','Automatisk oprette PO',0),(552259,15341,'ko','ìžë™ ë§Œë“¤ê¸°ê°€',0),(552260,15341,'he','××•×˜×•×ž×˜×™ ×œ×™×¦×•×¨ ×¤×•',0),(552261,15341,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î· PO',0),(552262,15341,'zh','è‡ªåŠ¨åˆ›å»ºé‡‡è´­è®¢å•',0),(552263,15341,'sv','Automatiskt skapa PO',0),(552264,15341,'it','Auto creare PO',0),(552265,15341,'tl','',0),(552266,15341,'th','à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¸ªà¸£à¹‰à¸²à¸‡ PO',0),(552267,15341,'hi','à¤‘à¤Ÿà¥‹ à¤¬à¤¨à¤¾à¤à¤ à¤ªà¥‹',0),(552268,15341,'ms','Auto buat PO',0),(552269,15341,'ar','Ø¥Ù†Ø´Ø§Ø¡ ØªÙ„Ù‚Ø§Ø¦ÙŠ Ø¨Ùˆ',0),(552270,15341,'fr','La crÃ©ation automatique PO',0),(552271,15341,'jp','PO ã®è‡ªå‹•ä½œæˆã—ã¾ã™ã€‚',0),(552272,15341,'pt','Auto criar PO',0),(552273,15341,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ðµ PO',0),(552274,15341,'es','Auto crear PO',0),(552275,15341,'de','Automatisch erstellen PO',0),(552276,15341,'en','Auto Create PO',0),(552277,15342,'is','',0),(552278,15342,'dr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø¯Ø±ÛŒØ§ÙØª ØµÙ†Ø¯ÙˆÙ‚',0),(552279,15342,'pr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø¯Ø±ÛŒØ§ÙØª ØµÙ†Ø¯ÙˆÙ‚',0),(552280,15342,'tr','Otomatik al PO',0),(552281,15342,'pl','Auto otrzyma PO',0),(552282,15342,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ PO',0),(552283,15342,'ur','Ø®ÙˆØ¯ ÙˆØµÙˆÙ„ Ù¾Ùˆ',0),(552284,15342,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼ ÐŸÐž',0),(552285,15342,'vi','Tá»± Ä‘á»™ng nháº­n Ä‘Æ°á»£c PO',0),(552286,15342,'af','Outomatiese ontvang PO',0),(552287,15342,'ro','Auto primi PO',0),(552288,15342,'et','Automaatne vastuvÃµtt PO',0),(552289,15342,'si','Samodejno Prejmi PO',0),(552290,15342,'ba','Auto menerima PO',0),(552291,15342,'nl','Automatisch ontvangen PO',0),(552292,15342,'fi','Automaattinen vastaanotto PO',0),(552293,15342,'no','Automatisk motta PO',0),(552294,15342,'da','Automatisk modtage PO',0),(552295,15342,'ko','ìžë™ ìˆ˜ì‹  í¬',0),(552296,15342,'he','××•×˜×•×ž×˜×™ ×ž×§×‘×œ×™× ×¤×•',0),(552297,15342,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î·Ï‚ Î»Î®ÏˆÎ·Ï‚ PO',0),(552298,15342,'zh','è‡ªåŠ¨æŽ¥æ”¶ PO',0),(552299,15342,'sv','Ta emot automatiskt PO',0),(552300,15342,'it','Ricezione automatica PO',0),(552301,15342,'tl','',0),(552302,15342,'th','à¸›à¸­à¸£à¸±à¸šà¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(552303,15342,'hi','à¤¸à¥à¤µà¤¤: à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤ªà¥‹',0),(552304,15342,'ms','Auto menerima PO',0),(552305,15342,'ar','Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª ØªÙ„Ù‚ÙŠ Ø¨Ùˆ',0),(552306,15342,'fr','Auto recevoir PO',0),(552307,15342,'jp','è‡ªå‹•å—ä¿¡ PO',0),(552308,15342,'pt','Auto receber PO',0),(552309,15342,'ru','ÐÐ²Ñ‚Ð¾Ð¿Ñ€Ð¸ÐµÐ¼Ðµ PO',0),(552310,15342,'es','Auto recibir PO',0),(552311,15342,'de','Auto erhalten PO',0),(552312,15342,'en','Auto Receive PO',0),(552313,15343,'is','',0),(552314,15343,'dr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø¯Ø³ØªÙˆØ± Ú©Ø´ØªÛŒ',0),(552315,15343,'pr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø¯Ø³ØªÙˆØ± Ú©Ø´ØªÛŒ',0),(552316,15343,'tr','Otomatik gemi sipariÅŸ',0),(552317,15343,'pl','Auto statek zamÃ³wienia',0),(552318,15343,'bg','Auto ÐºÐ¾Ñ€Ð°Ð± Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(552319,15343,'ur','Ø®ÙˆØ¯ Ú©Ø§Ø± Ø¬ÛØ§Ø² ØªØ±ØªÛŒØ¨',0),(552320,15343,'sr','ÐÑƒÑ‚Ð¾ Ð±Ñ€Ð¾Ð´ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(552321,15343,'vi','Tá»± Ä‘á»™ng tÃ u thá»© tá»±',0),(552322,15343,'af','Outomatiese skip orde',0),(552323,15343,'ro','Auto-ordonare navei',0),(552324,15343,'et','Auto laevatellimuselt',0),(552325,15343,'si','Auto dobave naloga',0),(552326,15343,'ba','Rangka kapal auto',0),(552327,15343,'nl','Auto schip om',0),(552328,15343,'fi','Automaattinen aluksen jÃ¤rjestys',0),(552329,15343,'no','Skipet AutorekkefÃ¸lge',0),(552330,15343,'da','Auto skib rÃ¦kkefÃ¸lge',0),(552331,15343,'ko','ìžë™ ì„ ë°• ì£¼ë¬¸',0),(552332,15343,'he','×¡×“×¨ ×”×¡×¤×™× ×” ××•×˜×•×ž×˜×™',0),(552333,15343,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Ï€Î»Î¿Î¯Î¿',0),(552334,15343,'zh','æ±½è½¦èˆ¹èˆ¶è®¢å•',0),(552335,15343,'sv','Fartyget standardordning',0),(552336,15343,'it','Ordine di spedizione automatica',0),(552337,15343,'tl','',0),(552338,15343,'th','à¸¥à¸³à¸”à¸±à¸šà¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(552339,15343,'hi','à¤‘à¤Ÿà¥‹ à¤œà¤¹à¤¾à¤œ à¤†à¤¦à¥‡à¤¶',0),(552340,15343,'ms','Auto kapal perintah',0),(552341,15343,'ar','ØªØ±ØªÙŠØ¨ ØªÙ„Ù‚Ø§Ø¦ÙŠ Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(552342,15343,'fr','Ordre de livraison automatique',0),(552343,15343,'jp','è‡ªå‹•è»Šèˆ¹ã®é †åº',0),(552344,15343,'pt','Auto nave ordem',0),(552345,15343,'ru','Ð—Ð°ÐºÐ°Ð· Ð°Ð²Ñ‚Ð¾ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(552346,15343,'es','Auto nave orden',0),(552347,15343,'de','Auto Schiff um',0),(552348,15343,'en','Auto Ship Order',0),(552349,15344,'is','',0),(552350,15344,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(552351,15344,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(552352,15344,'tr','Sevkiyat oluÅŸturma',0),(552353,15344,'pl','TworzÄ…c przesyÅ‚ki',0),(552354,15344,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(552355,15344,'ur','Ú©Ú¾ÛŒÙ¾ Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’',0),(552356,15344,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(552357,15344,'vi','Táº¡o lÃ´ hÃ ng',0),(552358,15344,'af','Skep verskeping',0),(552359,15344,'ro','Crearea de expediere',0),(552360,15344,'et','Saadetise loomine',0),(552361,15344,'si','Ustvarjanje dobavnice',0),(552362,15344,'ba','Membuat pengiriman',0),(552363,15344,'nl','Zending maken',0),(552364,15344,'fi','LÃ¤hetyksen luominen',0),(552365,15344,'no','Oppretting av forsendelse',0),(552366,15344,'da','Oprettelse af leverance',0),(552367,15344,'ko','ì„ ì ì„ ë§Œë“¤ê¸°',0),(552368,15344,'he','×™×¦×™×¨×ª ×ž×©×œ×•×—',0),(552369,15344,'el','Î¤Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï„Î·Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(552370,15344,'zh','åˆ›å»ºè£…è¿',0),(552371,15344,'sv','Du skapar fÃ¶rsÃ¤ndelse',0),(552372,15344,'it','Creazione di spedizione',0),(552373,15344,'tl','',0),(552374,15344,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(552375,15344,'hi','à¤²à¤¦à¤¾à¤¨ à¤•à¤¾ à¤¨à¤¿à¤°à¥à¤®à¤¾à¤£',0),(552376,15344,'ms','Mewujudkan penghantaran',0),(552377,15344,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø´Ø­Ù†Ø©',0),(552378,15344,'fr','CrÃ©ation d\'expÃ©dition',0),(552379,15344,'jp','å‡ºè·ã®ä½œæˆ',0),(552380,15344,'pt','CriaÃ§Ã£o da expediÃ§Ã£o',0),(552381,15344,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(552382,15344,'es','Crear envÃ­o',0),(552383,15344,'de','Erstellen von Versand',0),(552384,15344,'en','Creating Shipment',0),(552385,15345,'is','',0),(552386,15345,'dr','Ø®Ø·Ø§ÛŒ Ø§ÛŒØ¬Ø§Ø¯ ØµÙ†Ø¯ÙˆÙ‚',0),(552387,15345,'pr','Ø®Ø·Ø§ÛŒ Ø§ÛŒØ¬Ø§Ø¯ ØµÙ†Ø¯ÙˆÙ‚',0),(552388,15345,'tr','Hata oluÅŸturma PO',0),(552389,15345,'pl','BÅ‚Ä…d tworzenia PO',0),(552390,15345,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° PO',0),(552391,15345,'ur','Ù†Ù‚Øµ Ù¾Ùˆ Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’',0),(552392,15345,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ð¿Ð¾-Ð°',0),(552393,15345,'vi','Lá»—i táº¡o PO',0),(552394,15345,'af','Fout skep PO',0),(552395,15345,'ro','Eroare crearea PO',0),(552396,15345,'et','TÃµrge loomisel PO',0),(552397,15345,'si','Napaka pri ustvarjanju PO',0),(552398,15345,'ba','Kesalahan membuat PO',0),(552399,15345,'nl','Fout maken PO',0),(552400,15345,'fi','Virhe luoda PO',0),(552401,15345,'no','Feil under oppretting av PO',0),(552402,15345,'da','Fejl skaber PO',0),(552403,15345,'ko','ì˜¤ë¥˜ ë§Œë“¤ê¸° í¬',0),(552404,15345,'he','×©×’×™××” ×‘×™×¦×™×¨×ª ×¤×•',0),(552405,15345,'el','Î£Ï†Î¬Î»Î¼Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î±Ï‚ PO',0),(552406,15345,'zh','é”™è¯¯åˆ›å»ºå¡',0),(552407,15345,'sv','Fel att skapa PO',0),(552408,15345,'it','Errore creazione PO',0),(552409,15345,'tl','',0),(552410,15345,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¸ªà¸£à¹‰à¸²à¸‡ PO',0),(552411,15345,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤ªà¥€à¤“',0),(552412,15345,'ms','Ralat mencipta PO',0),(552413,15345,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ù†Ø´Ø§Ø¡ Øµ. Ø¨.',0),(552414,15345,'fr','Erreur crÃ©ation PO',0),(552415,15345,'jp','ã‚¨ãƒ©ãƒ¼ã‚’ä½œæˆã™ã‚‹ PO',0),(552416,15345,'pt','Erro criando PO',0),(552417,15345,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ PO',0),(552418,15345,'es','Error creando PO',0),(552419,15345,'de','Fehler erstellen PO',0),(552420,15345,'en','Error Creating PO',0),(552421,15346,'is','',0),(552422,15346,'dr','Ø®Ø·Ø§ÛŒ Ø§ÛŒØ¬Ø§Ø¯ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(552423,15346,'pr','Ø®Ø·Ø§ÛŒ Ø§ÛŒØ¬Ø§Ø¯ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(552424,15346,'tr','Hata Sevkiyat oluÅŸturma',0),(552425,15346,'pl','BÅ‚Ä…d tworzenia wysyÅ‚ki',0),(552426,15346,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(552427,15346,'ur','Ù†Ù‚Øµ Ú©Ú¾ÛŒÙ¾ Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’',0),(552428,15346,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(552429,15346,'vi','Lá»—i táº¡o lÃ´ hÃ ng',0),(552430,15346,'af','Fout skep verskeping',0),(552431,15346,'ro','Eroare crearea de expediere',0),(552432,15346,'et','TÃµrge loomisel lÃ¤hetus',0),(552433,15346,'si','Napaka pri ustvarjanju dobavnice',0),(552434,15346,'ba','Kesalahan membuat pengiriman',0),(552435,15346,'nl','Fout maken verzending',0),(552436,15346,'fi','Virhe luoda toimituksen',0),(552437,15346,'no','Feil Ã¥ opprette forsendelsen',0),(552438,15346,'da','Fejl at oprette forsendelsen',0),(552439,15346,'ko','ì˜¤ë¥˜ ë§Œë“¤ê¸° ì„ ì ',0),(552440,15346,'he','×©×’×™××ª ×™×¦×™×¨×ª ×ž×©×œ×•×—',0),(552441,15346,'el','Î£Ï†Î¬Î»Î¼Î± Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(552442,15346,'zh','é”™è¯¯åˆ›å»ºè£…è¿',0),(552443,15346,'sv','Fel att skapa fÃ¶rsÃ¤ndelsen',0),(552444,15346,'it','Errore creazione di spedizione',0),(552445,15346,'tl','',0),(552446,15346,'th','à¸ˆà¸±à¸”à¸ªà¸£à¹‰à¸²à¸‡à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(552447,15346,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤²à¤¦à¤¾à¤¨',0),(552448,15346,'ms','Ralat mencipta penghantaran',0),(552449,15346,'ar','Ø®Ø·Ø£ ÙÙŠ Ø¥Ù†Ø´Ø§Ø¡ Ø´Ø­Ù†Ø©',0),(552450,15346,'fr','Erreur crÃ©ation d\'expÃ©dition',0),(552451,15346,'jp','ã‚¨ãƒ©ãƒ¼ã‚’ä½œæˆã™ã‚‹å‡ºè·',0),(552452,15346,'pt','Erro criando expediÃ§Ã£o',0),(552453,15346,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(552454,15346,'es','Error crear envÃ­o',0),(552455,15346,'de','Fehler erstellen Versand',0),(552456,15346,'en','Error Creating Shipment',0),(552457,15347,'is','',0),(552458,15347,'dr','ÙˆØ¬ÙˆØ¯ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(552459,15347,'pr','ÙˆØ¬ÙˆØ¯ Ù…Ø­Ù…ÙˆÙ„Ù‡',0),(552460,15347,'tr','Sevk irsaliyeleri var',0),(552461,15347,'pl','PrzesyÅ‚ek istnieje',0),(552462,15347,'bg','Ð•ÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‚',0),(552463,15347,'ur','ØªØ±Ø³ÛŒÙ„ Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(552464,15347,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ°',0),(552465,15347,'vi','LÃ´ hÃ ng tá»“n táº¡i',0),(552466,15347,'af','Vervoer bestaan',0),(552467,15347,'ro','Transporturile exista',0),(552468,15347,'et','Saadetiste olemas',0),(552469,15347,'si','PoÅ¡iljke obstaja',0),(552470,15347,'ba','Pengiriman ada',0),(552471,15347,'nl','Zendingen bestaan',0),(552472,15347,'fi','Siirtojen olemassa',0),(552473,15347,'no','Forsendelser finnes',0),(552474,15347,'da','Forsendelser findes',0),(552475,15347,'ko','ì¶œí•˜ ëŸ‰ ì¡´ìž¬',0),(552476,15347,'he','×§×™×™×ž×™× ×ž×©×œ×•×—×™×',0),(552477,15347,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚',0),(552478,15347,'zh','å‡ºè´§é‡å­˜åœ¨',0),(552479,15347,'sv','Transporter finns',0),(552480,15347,'it','Esistono le spedizioni',0),(552481,15347,'tl','',0),(552482,15347,'th','à¸¡à¸µà¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(552483,15347,'hi','à¤²à¤¦à¤¾à¤¨ à¤®à¥Œà¤œà¥‚à¤¦',0),(552484,15347,'ms','Penghantaran wujud',0),(552485,15347,'ar','ØªÙˆØ¬Ø¯ Ø´Ø­Ù†Ø§Øª',0),(552486,15347,'fr','Existent des expÃ©ditions',0),(552487,15347,'jp','å‡ºè·ãŒå­˜åœ¨ã—ã¾ã™ã€‚',0),(552488,15347,'pt','Carregamentos de existem',0),(552489,15347,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð³Ñ€ÑƒÐ·Ð¾Ð²',0),(552490,15347,'es','Existen envÃ­os',0),(552491,15347,'de','Sendungen sind vorhanden',0),(552492,15347,'en','Shipments Exist',0),(552493,15348,'is','',0),(552494,15348,'dr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(552495,15348,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(552496,15348,'tr','GÃ¶rÃ¼nÃ¼m sevk irsaliyesi',0),(552497,15348,'pl','Widok wysyÅ‚ka',0),(552498,15348,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(552499,15348,'ur','Ù…Ù†Ø¸Ø± Ú©Ú¾ÛŒÙ¾',0),(552500,15348,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(552501,15348,'vi','NhÃ¬n lÃ´ hÃ ng',0),(552502,15348,'af','Bekyk verskeping',0),(552503,15348,'ro','Vezi de expediere',0),(552504,15348,'et','Vaade lÃ¤hetus',0),(552505,15348,'si','Pogled dobavnice',0),(552506,15348,'ba','Lihat pengiriman',0),(552507,15348,'nl','Weergave verzending',0),(552508,15348,'fi','NÃ¤ytÃ¤ lÃ¤hetys',0),(552509,15348,'no','Vis levering',0),(552510,15348,'da','Se leverance',0),(552511,15348,'ko','ë³´ê¸° ì„ ì ',0),(552512,15348,'he','×ž×©×œ×•×— ×ª×¦×•×’×”',0),(552513,15348,'el','Î ÏÎ¿Î²Î¿Î»Î® Î±Ï€Î¿ÏƒÏ„Î¿Î»ÏŽÎ½',0),(552514,15348,'zh','æŸ¥çœ‹è£…è¿',0),(552515,15348,'sv','Visa transport',0),(552516,15348,'it','Vista della spedizione',0),(552517,15348,'tl','',0),(552518,15348,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸”à¸¹',0),(552519,15348,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ',0),(552520,15348,'ms','Penghantaran View',0),(552521,15348,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø´Ø­Ù†',0),(552522,15348,'fr','Envoi de l\'avis',0),(552523,15348,'jp','è¡¨ç¤ºå‡ºè·',0),(552524,15348,'pt','ExpediÃ§Ã£o de exibiÃ§Ã£o',0),(552525,15348,'ru','Ð’Ð¸Ð´ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·ÐºÐ¸',0),(552526,15348,'es','Ver envÃ­o',0),(552527,15348,'de','Ansicht-Versand',0),(552528,15348,'en','View Shipment',0),(552529,15349,'is','',0),(552530,15349,'dr','Ø´Ù‡Ø±Ø³ØªØ§Ù†',0),(552531,15349,'pr','Ø´Ù‡Ø±Ø³ØªØ§Ù†',0),(552532,15349,'tr','Ä°lÃ§e',0),(552533,15349,'pl','Hrabstwo',0),(552534,15349,'bg','ÐžÐºÑ€ÑŠÐ³',0),(552535,15349,'ur','Ú©Ø§Ø¤Ù†Ù¹ÛŒ',0),(552536,15349,'sr','ÐžÐºÑ€ÑƒÐ³',0),(552537,15349,'vi','Quáº­n',0),(552538,15349,'af','County',0),(552539,15349,'ro','Comitatul',0),(552540,15349,'et','Maakonnas',0),(552541,15349,'si','County',0),(552542,15349,'ba','County',0),(552543,15349,'nl','County',0),(552544,15349,'fi','County',0),(552545,15349,'no','Fylke',0),(552546,15349,'da','County',0),(552547,15349,'ko','ì¹´ìš´í‹°',0),(552548,15349,'he','×ž×—×•×–',0),(552549,15349,'el','ÎšÎ¿Î¼Î·Ï„ÎµÎ¯Î±',0),(552550,15349,'zh','åŽ¿',0),(552551,15349,'sv','County',0),(552552,15349,'it','Contea di',0),(552553,15349,'tl','',0),(552554,15349,'th','à¹€à¸‚à¸•',0),(552555,15349,'hi','à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€',0),(552556,15349,'ms','County',0),(552557,15349,'ar','Ù…Ù‚Ø§Ø·Ø¹Ø©',0),(552558,15349,'fr','ComtÃ© de',0),(552559,15349,'jp','éƒ¡',0),(552560,15349,'pt','Condado de',0),(552561,15349,'ru','Ð£ÐµÐ·Ð´',0),(552562,15349,'es','Condado de',0),(552563,15349,'de','Grafschaft',0),(552564,15349,'en','County',0),(552565,15350,'is','',0),(552566,15350,'dr','ØªÙˆÙ‚Ù Ø¹Ù…Ù„ÛŒØ§Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù† Ú¯ÛŒØ±ÛŒ',0),(552567,15350,'pr','ØªÙˆÙ‚Ù Ø¹Ù…Ù„ÛŒØ§Øª Ù¾Ø´ØªÛŒØ¨Ø§Ù† Ú¯ÛŒØ±ÛŒ',0),(552568,15350,'tr','Yedekleme atlandÄ±',0),(552569,15350,'pl','Kopia zapasowa pomijane',0),(552570,15350,'bg','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ð¿Ð¸Ñ‚Ð°Ð½',0),(552571,15350,'ur','Ø§Ú†Ù¹ÛŒ Ù¾Ø´ØªØ§Ø±Û',0),(552572,15350,'sr','Ð ÐµÐ·ÐµÑ€Ð²Ð½Ð° ÐºÐ¾Ð¿Ð¸Ñ˜Ð° Ñ˜Ðµ Ð¿Ñ€ÐµÑÐºÐ¾Ñ‡ÐµÐ½Ð°',0),(552573,15350,'vi','Sao lÆ°u Ä‘Ã£ bá» qua',0),(552574,15350,'af','Rugsteun is oorgeslaan',0),(552575,15350,'ro','Sarit de rezervÄƒ',0),(552576,15350,'et','Varundus jÃ¤eti vahele',0),(552577,15350,'si','Varnostno kopiranje preskoÄilo',0),(552578,15350,'ba','Cadangan melewatkan',0),(552579,15350,'nl','Back-up overgeslagen',0),(552580,15350,'fi','Varmuuskopiointi ohitetaan',0),(552581,15350,'no','Sikkerhetskopiering hoppet over',0),(552582,15350,'da','Backup springes over',0),(552583,15350,'ko','ë°±ì—… ìƒëžµ',0),(552584,15350,'he','×”×’×™×‘×•×™ ×“×™×œ×’',0),(552585,15350,'el','Î£Ï„Î®ÏÎ¹Î³Î¼Î± ÎºÎ±ÏÎ±Î²Î¿ÎºÏÏÎ·Ï‚',0),(552586,15350,'zh','è·³è¿‡å¤‡ä»½',0),(552587,15350,'sv','Backup hoppas Ã¶ver',0),(552588,15350,'it','Backup saltato',0),(552589,15350,'tl','',0),(552590,15350,'th','à¸ªà¸³à¸£à¸­à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‚à¹‰à¸²à¸¡',0),(552591,15350,'hi','à¤¬à¥ˆà¤•à¤…à¤ª à¤•à¥‹ à¤›à¥‹à¤¡à¤¼ à¤¦à¤¿à¤¯à¤¾',0),(552592,15350,'ms','Sandaran yang dilangkau',0),(552593,15350,'ar','ØªÙ… ØªØ®Ø·ÙŠ Ø§Ù„Ù†Ø³Ø® Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠ',0),(552594,15350,'fr','SautÃ© de sauvegarde',0),(552595,15350,'jp','ãƒãƒƒã‚¯ã‚¢ãƒƒãƒ—ã‚’ã‚¹ã‚­ãƒƒãƒ—',0),(552596,15350,'pt','Backup de ignorados',0),(552597,15350,'ru','Ð ÐµÐ·ÐµÑ€Ð²Ð½Ð¾Ðµ ÐºÐ¾Ð¿Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð¿ÑƒÑ‰ÐµÐ½',0),(552598,15350,'es','Copia de seguridad omitida',0),(552599,15350,'de','Sicherung Ã¼bersprungen',0),(552600,15350,'en','Backup Skipped',0),(552601,15351,'is','',0),(552602,15351,'dr','ØªØ±Ø§Ø²',0),(552603,15351,'pr','ØªØ±Ø§Ø²',0),(552604,15351,'tr','Hizalama',0),(552605,15351,'pl','WyrÃ³wnaÄ‡',0),(552606,15351,'bg','ÐŸÐ¾Ð´Ñ€Ð°Ð²Ð½ÑÐ²Ð°Ð½Ðµ',0),(552607,15351,'ur','Ø³ÛŒØ¯Ú¾ Ù…ÛŒÚº Ù„Ø§Ø¦ÛŒÚº',0),(552608,15351,'sr','ÐŸÐ¾Ñ€Ð°Ð²Ð½Ð°Ð²Ð°ÑšÐµ',0),(552609,15351,'vi','Sáº¯p xáº¿p',0),(552610,15351,'af','Rig',0),(552611,15351,'ro','AliniaÅ£i',0),(552612,15351,'et','Joondamine',0),(552613,15351,'si','Poravnaj',0),(552614,15351,'ba','Menyelaraskan',0),(552615,15351,'nl','Uitlijnen',0),(552616,15351,'fi','Tasaa',0),(552617,15351,'no','Justere',0),(552618,15351,'da','Juster',0),(552619,15351,'ko','ì •ë ¬',0),(552620,15351,'he','×œ×™×™×©×¨',0),(552621,15351,'el','Î£Ï„Î¿Î¯Ï‡Î¹ÏƒÎ·',0),(552622,15351,'zh','å¯¹é½',0),(552623,15351,'sv','Justera',0),(552624,15351,'it','Allineare',0),(552625,15351,'tl','',0),(552626,15351,'th','à¸à¸²à¸£à¸ˆà¸±à¸”à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡',0),(552627,15351,'hi','à¤¸à¤‚à¤°à¥‡à¤–à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(552628,15351,'ms','Menyelaraskan',0),(552629,15351,'ar','Ù‚Ù… Ø¨Ù…Ø­Ø§Ø°Ø§Ø©',0),(552630,15351,'fr','Aligner',0),(552631,15351,'jp','æ•´åˆ—',0),(552632,15351,'pt','Alinhar',0),(552633,15351,'ru','Ð’Ñ‹Ñ€Ð°Ð²Ð½Ð¸Ð²Ð°Ð½Ð¸Ðµ',0),(552634,15351,'es','Alinear',0),(552635,15351,'de','Ausrichten von',0),(552636,15351,'en','Align',0),(552637,15352,'is','',0),(552638,15352,'dr','Ù‚Ø§Ø¨Ù„ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(552639,15352,'pr','Ù‚Ø§Ø¨Ù„ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(552640,15352,'tr','GÃ¶rÃ¼nÃ¼r',0),(552641,15352,'pl','Widoczne',0),(552642,15352,'bg','Ð’Ð¸Ð´Ð¸Ð¼Ð°',0),(552643,15352,'ur','Ù…Ø±Ø¦ÛŒ',0),(552644,15352,'sr','Ð’Ð¸Ð´Ñ™Ð¸Ð²Ð¾',0),(552645,15352,'vi','CÃ³ thá»ƒ nhÃ¬n tháº¥y',0),(552646,15352,'af','Sigbaar',0),(552647,15352,'ro','Vizibil',0),(552648,15352,'et','NÃ¤htav',0),(552649,15352,'si','Vidna',0),(552650,15352,'ba','Terlihat',0),(552651,15352,'nl','Zichtbaar',0),(552652,15352,'fi','NÃ¤kyvissÃ¤',0),(552653,15352,'no','Synlig',0),(552654,15352,'da','Synlige',0),(552655,15352,'ko','í‘œì‹œ',0),(552656,15352,'he','×’×œ×•×™',0),(552657,15352,'el','ÎŸÏÎ±Ï„Î®',0),(552658,15352,'zh','å¯è§',0),(552659,15352,'sv','Synliga',0),(552660,15352,'it','Visibile',0),(552661,15352,'tl','',0),(552662,15352,'th','à¸¡à¸­à¸‡à¹€à¸«à¹‡à¸™à¹„à¸”à¹‰',0),(552663,15352,'hi','à¤¦à¥ƒà¤¶à¥à¤¯à¤®à¤¾à¤¨',0),(552664,15352,'ms','Boleh dilihat',0),(552665,15352,'ar','Ù…Ø±Ø¦ÙŠØ©',0),(552666,15352,'fr','Visible',0),(552667,15352,'jp','ç›®ã«è¦‹ãˆã‚‹',0),(552668,15352,'pt','VisÃ­vel',0),(552669,15352,'ru','Ð’Ð¸Ð´Ð¸Ð¼Ñ‹Ð¹',0),(552670,15352,'es','Visible',0),(552671,15352,'de','Sichtbar',0),(552672,15352,'en','Visible',0),(552673,15353,'is','',0),(552674,15353,'dr','Ø§Ú¯Ø± Ù‡Ù…Ø§Ù† ÙˆØ±ÙˆØ¯ Ø®Ø§Ù„ÛŒ Ø¨Ú¯Ø°Ø§Ø±ÛŒØ¯',0),(552675,15353,'pr','Ø§Ú¯Ø± Ù‡Ù…Ø§Ù† ÙˆØ±ÙˆØ¯ Ø®Ø§Ù„ÛŒ Ø¨Ú¯Ø°Ø§Ø±ÛŒØ¯',0),(552676,15353,'tr','AynÄ± ise oturum olarak boÅŸ bÄ±rakÄ±n',0),(552677,15353,'pl','Puste, jeÅ›li taki sam jak Login',0),(552678,15353,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ð¾Ð»ÐµÑ‚Ð¾ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð°ÐºÐ¾ Ðµ ÑÑŠÑ‰Ð°Ñ‚Ð° ÐºÐ°Ñ‚Ð¾ Ð²Ñ…Ð¾Ð´',0),(552679,15353,'ur','Ù„Ø§Ú¯ Ø§Ù† Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§ÛŒÚ© ÛÛŒ ØªÙˆ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(552680,15353,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð°ÐºÐ¾ Ñ˜Ðµ Ð¸ÑÑ‚Ð¾ ÐºÐ°Ð¾ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ',0),(552681,15353,'vi','Äá»ƒ trá»‘ng náº¿u tÆ°Æ¡ng tá»± nhÆ° Ä‘Äƒng nháº­p',0),(552682,15353,'af','Laat leeg as dieselfde As teken',0),(552683,15353,'ro','LÄƒsaÈ›i-o necompletatÄƒ dacÄƒ acelasi ca conectare',0),(552684,15353,'et','Kui sama Logi sisse jÃ¤tke tÃ¼hjaks',0),(552685,15353,'si','Pustite prazno, Äe je to isto kot prijava',0),(552686,15353,'ba','Biarkan kosong jika sama seperti Login',0),(552687,15353,'nl','Laat leeg als hetzelfde als Login',0),(552688,15353,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi, jos sama kuin johdonmukaisuus',0),(552689,15353,'no','La stÃ¥ tomt hvis samme som logikk',0),(552690,15353,'da','VÃ¦re tomt, hvis samme som Login',0),(552691,15353,'ko','ë¡œê·¸ì¸ ê°™ì€ ê²½ìš° ë¹„ì›Œ',0),(552692,15353,'he','×ª×©××™×¨ ×¨×™×§ ×× ×‘×“×™×•×§ ×›×ž×• ×›× ×™×¡×”',0),(552693,15353,'el','Î‘Ï†Î®ÏƒÏ„Îµ ÎºÎµÎ½ÏŒ ÎµÎ¬Î½ Ï„Î¿ Î¯Î´Î¹Î¿ Ï‰Ï‚ ÎµÎ¯ÏƒÎ¿Î´Î¿Ï‚',0),(552694,15353,'zh','å¦‚æžœåŒä¸€ç™»å½•èº«ä»½ä¿ç•™ä¸ºç©º',0),(552695,15353,'sv','LÃ¤mna tomt om samma som logga in',0),(552696,15353,'it','Lasciare in bianco se stesso come Login',0),(552697,15353,'tl','',0),(552698,15353,'th','à¸–à¹‰à¸²à¹€à¸«à¸¡à¸·à¸­à¸™à¸à¸±à¸šà¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(552699,15353,'hi','à¤¯à¤¦à¤¿ à¤²à¥‰à¤—à¤¿à¤¨ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤à¤• à¤¹à¥€ à¤–à¤¾à¤²à¥€ à¤›à¥‹à¤¡à¤¼',0),(552700,15353,'ms','Tinggalkan kosong sekiranya sama seperti log masuk',0),(552701,15353,'ar','Ø§ØªØ±Ùƒ Ø§Ù„Ù…Ø³Ø§Ø­Ø© ÙØ§Ø±ØºØ© Ø¥Ø°Ø§ ÙƒØ§Ù† Ù†ÙØ³ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(552702,15353,'fr','Laissez vide si identique de Login',0),(552703,15353,'jp','ãƒ­ã‚°ã‚¤ãƒ³ã¨åŒã˜å ´åˆã¯ç©ºç™½ã®ã¾ã¾ã«',0),(552704,15353,'pt','Deixe em branco se mesmo como Login',0),(552705,15353,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, ÐµÑÐ»Ð¸ Ð¶Ðµ ÐºÐ°Ðº Ð»Ð¾Ð³Ð¸Ð½',0),(552706,15353,'es','Deje en blanco si es igual que el inicio de sesiÃ³n',0),(552707,15353,'de','Freilassen Sie, wenn dieselbe als Login',0),(552708,15353,'en','Leave Blank If Same As Login',0),(552709,15354,'is','',0),(552710,15354,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡',0),(552711,15354,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡',0),(552712,15354,'tr','OluÅŸturulan',0),(552713,15354,'pl','Stworzony',0),(552714,15354,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´ÐµÐ½',0),(552715,15354,'ur','Ø¨Ù†Ø§Ø¦ÛŒ',0),(552716,15354,'sr','Ð¡Ñ‚Ð²Ð¾Ñ€Ð¸Ð¾',0),(552717,15354,'vi','Táº¡o',0),(552718,15354,'af','Geskep',0),(552719,15354,'ro','Creat',0),(552720,15354,'et','Loodud',0),(552721,15354,'si','Ustvaril',0),(552722,15354,'ba','Dibuat',0),(552723,15354,'nl','Gemaakt',0),(552724,15354,'fi','Luotu',0),(552725,15354,'no','Opprettet',0),(552726,15354,'da','Lavet',0),(552727,15354,'ko','ë§Œë“ ',0),(552728,15354,'he','× ×•×¦×¨',0),(552729,15354,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ',0),(552730,15354,'zh','åˆ›å»º',0),(552731,15354,'sv','Skapad',0),(552732,15354,'it','Creato',0),(552733,15354,'tl','',0),(552734,15354,'th','à¸ªà¸£à¹‰à¸²à¸‡',0),(552735,15354,'hi','à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(552736,15354,'ms','Dicipta',0),(552737,15354,'ar','Ø¥Ù†Ø´Ø§Ø¡',0),(552738,15354,'fr','CrÃ©Ã©',0),(552739,15354,'jp','ä½œæˆ',0),(552740,15354,'pt','Criado',0),(552741,15354,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½',0),(552742,15354,'es','Creado',0),(552743,15354,'de','Erstellt',0),(552744,15354,'en','Created',0),(552745,15355,'is','',0),(552746,15355,'dr','Ù…Ø¯ÛŒØ±ÛŒØª ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡ Ù…Ø­Ù„ Ø³Ú©ÙˆÙ†Øª',0),(552747,15355,'pr','Ù…Ø¯ÛŒØ±ÛŒØª ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡ Ù…Ø­Ù„ Ø³Ú©ÙˆÙ†Øª',0),(552748,15355,'tr','Mobil konum yÃ¶netmek',0),(552749,15355,'pl','ZarzÄ…dzaÄ‡ Zdejmowany lokalizacji',0),(552750,15355,'bg','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½Ð° Ð¼Ð¾Ð±Ð¸Ð»Ð½Ð¸ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(552751,15355,'ur','Ù…ÙˆØ¨Ø§Ø¦Ù„ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Ø§ Ø§Ù†ØªØ¸Ø§Ù… Ú©Ø±ÛŒÚº',0),(552752,15355,'sr','Ð£Ð¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐµ Ð¼Ð¾Ð±Ð¸Ð»Ð½Ð¸Ñ… Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(552753,15355,'vi','Äiá»‡n thoáº¡i di Ä‘á»™ng vá»‹ trÃ­ quáº£n lÃ½',0),(552754,15355,'af','Mobiele ligging bestuur',0),(552755,15355,'ro','Mobil locaÅ£ie gestiona',0),(552756,15355,'et','Mobiili asukoha haldamine',0),(552757,15355,'si','Upravljanje mobilne mesto',0),(552758,15355,'ba','Lokasi Mobile mengelola',0),(552759,15355,'nl','Mobiele locatie beheren',0),(552760,15355,'fi','Eloisa sijainti hallinta',0),(552761,15355,'no','Transportabel sted administrere',0),(552762,15355,'da','Mobile placering administrere',0),(552763,15355,'ko','ëª¨ë°”ì¼ ìœ„ì¹˜ ê´€ë¦¬',0),(552764,15355,'he','×ž×™×§×•× × ×™×™×“×™× ×œ× ×™×”×•×œ',0),(552765,15355,'el','ÎšÎ¹Î½Î·Ï„ÏŒ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·',0),(552766,15355,'zh','ç§»åŠ¨å®šä½ç®¡ç†',0),(552767,15355,'sv','Mobila plats hantera',0),(552768,15355,'it','Il gestore di un luogo mobile',0),(552769,15355,'tl','',0),(552770,15355,'th','à¸ˆà¸±à¸”à¸à¸²à¸£à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œà¸¡à¸·à¸­à¸–à¸·à¸­',0),(552771,15355,'hi','à¤®à¥‹à¤¬à¤¾à¤‡à¤² à¤¸à¥à¤¥à¤¾à¤¨ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(552772,15355,'ms','Uruskan telefon mudah alih lokasi',0),(552773,15355,'ar','Ø¥Ø¯Ø§Ø±Ø© Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø¬ÙˆØ§Ù„',0),(552774,15355,'fr','GÃ©rer les emplacement mobile',0),(552775,15355,'jp','ãƒ¢ãƒã‚¤ãƒ«ä½ç½®æƒ…å ±ã‚’ç®¡ç†ã—ã¾ã™ã€‚',0),(552776,15355,'pt','Gerenciar local mÃ³vel',0),(552777,15355,'ru','ÐœÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ð¼Ð¾Ð±Ð¸Ð»ÑŒÐ½Ñ‹Ñ… ÑƒÐ¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ',0),(552778,15355,'es','GestiÃ³n de localizaciÃ³n mÃ³vil',0),(552779,15355,'de','Verwalten von mobilen Lage',0),(552780,15355,'en','Mobile Location Manage',0),(552781,15356,'is','',0),(552782,15356,'dr','Ø±ÙˆÙ†Ø¯ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(552783,15356,'pr','Ø±ÙˆÙ†Ø¯ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(552784,15356,'tr','Ä°ÅŸlem bordro',0),(552785,15356,'pl','Procesu listy pÅ‚ac',0),(552786,15356,'bg','Ð’ÐµÐ´Ð¾Ð¼Ð¾ÑÑ‚Ñ‚Ð° Ð¿Ñ€Ð¾Ñ†ÐµÑ',0),(552787,15356,'ur','Ø¹Ù…Ù„ Ù¾Û’ Ø±ÙˆÙ„',0),(552788,15356,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ',0),(552789,15356,'vi','QuÃ¡ trÃ¬nh biÃªn cháº¿',0),(552790,15356,'af','Proses heeltydse',0),(552791,15356,'ro','Procesul de salarizare',0),(552792,15356,'et','Protsessi Palgaarvestus',0),(552793,15356,'si','Proces na izplaÄane plaÄe',0),(552794,15356,'ba','Proses penggajian',0),(552795,15356,'nl','Proces Payroll',0),(552796,15356,'fi','Prosessin palkanlaskennan',0),(552797,15356,'no','Prosessen lÃ¸nn',0),(552798,15356,'da','Proces lÃ¸nningslisten',0),(552799,15356,'ko','í”„ë¡œì„¸ìŠ¤ ê¸‰ì—¬',0),(552800,15356,'he','×ª×”×œ×™×š ×ž×©×›×•×¨×•×ª',0),(552801,15356,'el','Î”Î¹Î±Î´Î¹ÎºÎ±ÏƒÎ¯Î± Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(552802,15356,'zh','å¤„ç†å·¥èµ„å•',0),(552803,15356,'sv','Processen lÃ¶ne',0),(552804,15356,'it','Processo Payroll',0),(552805,15356,'tl','',0),(552806,15356,'th','à¸à¸£à¸°à¸šà¸§à¸™à¸à¸²à¸£à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(552807,15356,'hi','à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤ªà¥‡à¤°à¥‹à¤²',0),(552808,15356,'ms','Proses pembayaran gaji',0),(552809,15356,'ar','Ø¹Ù…Ù„ÙŠØ© ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(552810,15356,'fr','Processus paie',0),(552811,15356,'jp','çµ¦ä¸Žè¨ˆç®—ãƒ—ãƒ­ã‚»ã‚¹',0),(552812,15356,'pt','Folha de pagamento do processo',0),(552813,15356,'ru','ÐŸÑ€Ð¾Ñ†ÐµÑÑ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(552814,15356,'es','NÃ³mina de proceso',0),(552815,15356,'de','Prozess-Personalabrechnung',0),(552816,15356,'en','Process Payroll',0),(552817,15357,'is','',0),(552818,15357,'dr','Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù…Ø¯ÛŒØ±ÛŒØª ÙØ±ÙˆØ´Ú¯Ø§Ù‡ ID',0),(552819,15357,'pr','Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù…Ø¯ÛŒØ±ÛŒØª ÙØ±ÙˆØ´Ú¯Ø§Ù‡ ID',0),(552820,15357,'tr','GeliÅŸmiÅŸ nakliye YÃ¶neticisi depolama kimliÄŸi',0),(552821,15357,'pl','Zaawansowany menedÅ¼er wysyÅ‚ka sklep ID',0),(552822,15357,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¾ Ð˜Ð” Ð½Ð° Ð´Ð¸ÑÐ¿ÐµÑ‡ÐµÑ€Ð° Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ñ…Ñ€Ð°Ð½Ð¸Ð»Ð¸Ñ‰Ðµ',0),(552823,15357,'ur','Ø§Ø¹Ù„ÛŒ Ø´Ù¾Ù†Ú¯ Ù…Ù†ÛŒØ¬Ø± Ø³Ù¹ÙˆØ± Ø´Ù†Ø§Ø®Øª',0),(552824,15357,'sr','ÐÐ°Ð¿Ñ€ÐµÐ´Ð½Ð¸ Ð˜Ð” ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ñƒ ÐœÐµÐ½Ð°ÑŸÐµÑ€Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(552825,15357,'vi','NÃ¢ng cao quáº£n lÃ½ váº­n chuyá»ƒn cá»­a hÃ ng ID',0),(552826,15357,'af','Gevorderde gestuur Bestuurder Winkel ID',0),(552827,15357,'ro','Avansate transport Manager magazin ID',0),(552828,15357,'et','TÃ¤psem Shipping Manager salve-ID',0),(552829,15357,'si','Napredno ID dostava upravitelja shrambe',0),(552830,15357,'ba','Lanjutan ID manajer pengiriman Store',0),(552831,15357,'nl','Geavanceerde verzending Manager opslag-ID',0),(552832,15357,'fi','Kehittynyt toimitus hallinnan sÃ¤ilÃ¶n tunnus',0),(552833,15357,'no','Avansert Shipping Manager-lager-ID',0),(552834,15357,'da','Avanceret Shipping Manager butiks-ID',0),(552835,15357,'ko','ê³ ê¸‰ ì„ ë°• ê´€ë¦¬ìž ì €ìž¥ì†Œ ID',0),(552836,15357,'he','×ž×–×”×” ×ž× ×”×œ ×”×¡×¤× ×•×ª ×—× ×•×ª ×ž×ª×§×“×',0),(552837,15357,'el','Î ÏÎ¿Î·Î³Î¼Î­Î½Î· Î´Î¹ÎµÏ…Î¸Ï…Î½Ï„Î® Î½Î±Ï…Ï„Î¹Î»Î¯Î±Ï‚ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± Î¤Î±Ï…Ï„ÏŒÏ„Î·Ï„Î±Ï‚',0),(552838,15357,'zh','å…ˆè¿›çš„èˆªè¿ç®¡ç†å™¨å­˜å‚¨ ID',0),(552839,15357,'sv','Avancerade frakt Manager lagrings-ID',0),(552840,15357,'it','Advanced Shipping Manager Store ID',0),(552841,15357,'tl','',0),(552842,15357,'th','à¸£à¸«à¸±à¸ªà¸£à¹‰à¸²à¸™à¸„à¹‰à¸²à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸à¸²à¸£à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡',0),(552843,15357,'hi','à¤‰à¤¨à¥à¤¨à¤¤ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤®à¥ˆà¤¨à¥‡à¤œà¤° à¤¸à¥à¤Ÿà¥‹à¤° ID',0),(552844,15357,'ms','Maju kedai Pengurus perkapalan ID',0),(552845,15357,'ar','Ù…Ø¹Ø±Ù Ù…Ø®Ø²Ù† Ø§Ù„Ø´Ø­Ù† Ø¥Ø¯Ø§Ø±Ø© Ù…ØªÙ‚Ø¯Ù…Ø©',0),(552846,15357,'fr','ID de la base de l\'expÃ©dition gestionnaire avancÃ©',0),(552847,15357,'jp','é«˜åº¦ãªé…å¸ƒãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼ ã‚¹ãƒˆã‚¢ ID',0),(552848,15357,'pt','ID de armazenamento do Gerenciador de transporte avanÃ§ado',0),(552849,15357,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¼ÐµÐ½ÐµÐ´Ð¶ÐµÑ€ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð° ID',0),(552850,15357,'es','ID de envÃ­o Gerente tienda avanzada',0),(552851,15357,'de','Erweiterter Versand-Manager Store ID',0),(552852,15357,'en','Advanced Shipping Manager Store ID',0),(552853,15358,'is','',0),(552854,15358,'dr','Ù†Ø§Ù… ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ù…Ø¯ÛŒØ±ÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(552855,15358,'pr','Ù†Ø§Ù… ÙØ±ÙˆØ´Ú¯Ø§Ù‡ Ù…Ø¯ÛŒØ±ÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(552856,15358,'tr','GeliÅŸmiÅŸ nakliye YÃ¶neticisi depo adÄ±',0),(552857,15358,'pl','Zaawansowane nazwa sklepu Shipping Manager',0),(552858,15358,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¼ÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½ Ð¸Ð¼Ðµ',0),(552859,15358,'ur','Ø§Ø¹Ù„ÛŒ Ø´Ù¾Ù†Ú¯ Ù…Ù†ÛŒØ¬Ø± Ø³Ù¹ÙˆØ± Ú©Û’ Ù†Ø§Ù…',0),(552860,15358,'sr','ÐÐ°Ð¿Ñ€ÐµÐ´Ð½Ð¸ Ð¸Ð¼ÐµÐ½Ð° Ñ€Ð°Ð´ÑšÐµ ÐœÐµÐ½Ð°ÑŸÐµÑ€ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(552861,15358,'vi','NÃ¢ng cao quáº£n lÃ½ váº­n chuyá»ƒn cá»­a hÃ ng tÃªn',0),(552862,15358,'af','Gevorderde gestuur Bestuurder Winkel naam',0),(552863,15358,'ro','Avansate de transport maritim Manager magazin numele',0),(552864,15358,'et','TÃ¤psem Shipping Manager poe nimele',0),(552865,15358,'si','Napredno ime trgovina dostava upravitelja',0),(552866,15358,'ba','Nama toko manajer pengiriman lanjutan',0),(552867,15358,'nl','Geavanceerde verzending Manager winkelnaam',0),(552868,15358,'fi','Kehittynyt toimitus johtaja sÃ¤ilÃ¶n nimi',0),(552869,15358,'no','Avansert Shipping Manager navn',0),(552870,15358,'da','Avanceret Shipping Manager butik navn',0),(552871,15358,'ko','ê³ ê¸‰ ì„ ë°• ê´€ë¦¬ìž ì €ìž¥ì†Œ ì´ë¦„',0),(552872,15358,'he','×©× ×ž××’×¨ ×ž× ×”×œ ×”×¡×¤× ×•×ª ×ž×ª×§×“×',0),(552873,15358,'el','Î ÏÎ¿Î·Î³Î¼Î­Î½Î· Î´Î¹ÎµÏ…Î¸Ï…Î½Ï„Î® Î½Î±Ï…Ï„Î¹Î»Î¯Î±Ï‚ ÏŒÎ½Î¿Î¼Î± Ï‡ÏŽÏÎ¿Ï… Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·Ï‚',0),(552874,15358,'zh','å…ˆè¿›çš„è´§è¿ç»ç†å•†åº—åç§°',0),(552875,15358,'sv','Avancerade frakt Manager Store namn',0),(552876,15358,'it','Nome dell\'archivio Shipping Manager avanzato',0),(552877,15358,'tl','',0),(552878,15358,'th','à¸Šà¸·à¹ˆà¸­à¸£à¹‰à¸²à¸™à¸„à¹‰à¸²à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸à¸²à¸£à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡',0),(552879,15358,'hi','à¤‰à¤¨à¥à¤¨à¤¤ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤ªà¥à¤°à¤¬à¤‚à¤§à¤• à¤•à¥€ à¤¦à¥à¤•à¤¾à¤¨ à¤•à¤¾ à¤¨à¤¾à¤®',0),(552880,15358,'ms','Nama kedai Pengurus perkapalan maju',0),(552881,15358,'ar','Ø§Ø³Ù… Ù…Ø®Ø²Ù† Ø§Ù„Ø´Ø­Ù† Ø¥Ø¯Ø§Ø±Ø© Ù…ØªÙ‚Ø¯Ù…Ø©',0),(552882,15358,'fr','Nom du magasin expÃ©dition gestionnaire avancÃ©',0),(552883,15358,'jp','é«˜åº¦ãªé…å¸ƒãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼ ã‚¹ãƒˆã‚¢å',0),(552884,15358,'pt','Nome de loja gerente de transporte avanÃ§ado',0),(552885,15358,'ru','Ð Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ð¹ Ð¼ÐµÐ½ÐµÐ´Ð¶ÐµÑ€ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¸Ð¼Ñ Ñ…Ñ€Ð°Ð½Ð¸Ð»Ð¸Ñ‰Ð°',0),(552886,15358,'es','Nombre de la tienda de avanzado Administrador de envÃ­o',0),(552887,15358,'de','Erweiterter Versand-Manager GeschÃ¤ftsnamen',0),(552888,15358,'en','Advanced Shipping Manager Store Name',0),(552889,15359,'is','',0),(552890,15359,'dr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù¾ÛŒØ§Ù… Ø§Ú¯Ø± Ø¨Ø§Ù†Ú© Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(552891,15359,'pr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù¾ÛŒØ§Ù… Ø§Ú¯Ø± Ø¨Ø§Ù†Ú© Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(552892,15359,'tr','Deyim mesaj EÄŸer banka hesaplarÄ±mÄ±z var',0),(552893,15359,'pl','Instrukcja wiadomoÅ›Ä‡ jeÅ›li Bank informacji istnieje',0),(552894,15359,'bg','Ð”ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð°ÐºÐ¾ Ð±Ð°Ð½ÐºÐ¾Ð²Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(552895,15359,'ur','Ø¨ÛŒØ§Ù† Ù¾ÛŒØºØ§Ù… Ø§Ú¯Ø± Ø¨ÛŒÙ†Ú© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(552896,15359,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð¸Ð·Ñ˜Ð°Ð²Ð° Ð¿Ð¾Ñ€ÑƒÐºÑƒ Ð°ÐºÐ¾ Ð±Ð°Ð½ÐºÐ° Ð˜Ð½Ñ„Ð¾',0),(552897,15359,'vi','ThÃ´ng tin bÃ¡o cÃ¡o thÆ° náº¿u ngÃ¢n hÃ ng tá»“n táº¡i',0),(552898,15359,'af','Stelling boodskap as Bank inligting bestaan',0),(552899,15359,'ro','ExistÄƒ declaraÅ£ie mesaj dacÄƒ Banca Info',0),(552900,15359,'et','Aruande sÃµnum kui Pangal Info on olemas',0),(552901,15359,'si','Obstaja izjava sporoÄilo Äe banÄni Info',0),(552902,15359,'ba','Ada Info pernyataan pesan jika Bank',0),(552903,15359,'nl','Verklaring van het bericht als Bank Info bestaat',0),(552904,15359,'fi','Ilmoitus viestin jos Bank Info on olemassa',0),(552905,15359,'no','Setningen melding hvis bankinformasjonen finnes',0),(552906,15359,'da','ErklÃ¦ring besked Hvis banken Info findes',0),(552907,15359,'ko','ë¬¸ì´ ë©”ì‹œì§€ ê²½ìš° ì€í–‰ ì •ë³´ ì¡´ìž¬',0),(552908,15359,'he','×§×™×™× ×ž×©×¤×˜ ×”×•×“×¢×” ×× ×‘× ×§ ×¤×¨×˜×™',0),(552909,15359,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î´Î®Î»Ï‰ÏƒÎ· Î¼Î®Î½Ï…Î¼Î± Î±Î½ Î¤ÏÎ¬Ï€ÎµÎ¶Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(552910,15359,'zh','å£°æ˜Žæ¶ˆæ¯å¦‚æžœé“¶è¡Œä¿¡æ¯å­˜åœ¨',0),(552911,15359,'sv','Uttalande meddelande om Bank Info finns',0),(552912,15359,'it','Dichiarazione messaggio se banca Info esiste',0),(552913,15359,'tl','',0),(552914,15359,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸„à¸³à¸ªà¸±à¹ˆà¸‡à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸–à¹‰à¸² à¸˜à¸™à¸²à¸„à¸²à¸£à¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(552915,15359,'hi','à¤¬à¤¯à¤¾à¤¨ à¤¸à¤‚à¤¦à¥‡à¤¶ à¤…à¤—à¤° à¤¬à¥ˆà¤‚à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(552916,15359,'ms','Info Bank penyata mesej jika wujud',0),(552917,15359,'ar','ØªÙˆØ¬Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¨ÙŠØ§Ù† Ø§Ù„Ø±Ø³Ø§Ù„Ø© Ø¥Ø°Ø§ ÙƒØ§Ù† Ø§Ù„Ù…ØµØ±Ù',0),(552918,15359,'fr','Info bilan Message If Banque existe',0),(552919,15359,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆ ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸å ´åˆéŠ€è¡Œæƒ…å ±ãŒå­˜åœ¨ã—ã¾ã™ã€‚',0),(552920,15359,'pt','Existe informaÃ§Ã£o de instruÃ§Ã£o mensagem se banco',0),(552921,15359,'ru','Ð•ÑÐ»Ð¸ Ñ€ÐµÐºÐ²Ð¸Ð·Ð¸Ñ‚Ñ‹ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(552922,15359,'es','InformaciÃ³n DeclaraciÃ³n mensaje If Banco existe',0),(552923,15359,'de','Anweisung Message If Bankverbindung vorhanden ist',0),(552924,15359,'en','Statement Message If Bank Info Exists',0),(552925,15360,'is','',0),(552926,15360,'dr','Ù¾ÛŒØ§Ù… Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø§Ú¯Ø± Ø¨Ø¯ÙˆÙ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ú© ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(552927,15360,'pr','Ù¾ÛŒØ§Ù… Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø§Ú¯Ø± Ø¨Ø¯ÙˆÙ† Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ø§Ù†Ú© ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(552928,15360,'tr','HiÃ§bir banka bilgi varsa deyim mesaj',0),(552929,15360,'pl','WiadomoÅ›Ä‡ instrukcja jeÅ¼eli istnieje nie Bank informacji',0),(552930,15360,'bg','Ð”ÐµÐºÐ»Ð°Ñ€Ð°Ñ†Ð¸Ñ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð°ÐºÐ¾ Ð½Ðµ Ð±Ð°Ð½ÐºÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(552931,15360,'ur','Ø§Ú¯Ø± Ú©ÙˆØ¦ÛŒ Ø¨ÛŒÙ†Ú© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ Ø¨ÛŒØ§Ù† Ù¾ÛŒØºØ§Ù…',0),(552932,15360,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ð° Ð¿Ð¾Ñ€ÑƒÐºÑƒ Ð°ÐºÐ¾ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð˜Ð½Ñ„Ð¾ Ð½Ðµ Ð±Ð°Ð½ÐºÐµ',0),(552933,15360,'vi','TuyÃªn bá»‘ thÃ´ng bÃ¡o náº¿u khÃ´ng cÃ³ thÃ´ng tin ngÃ¢n hÃ ng tá»“n táº¡i',0),(552934,15360,'af','Stelling boodskap Indien geen Bank inligting bestaan',0),(552935,15360,'ro','DeclaraÅ£ie mesaj dacÄƒ existÄƒ nici un Info bancar',0),(552936,15360,'et','Aruande sÃµnum ei panga Info olemasolu',0),(552937,15360,'si','Izjava sporoÄilo Äe ne banÄni Info',0),(552938,15360,'ba','Pernyataan pesan jika Info Bank tidak ada',0),(552939,15360,'nl','Verklaring van het bericht als er geen Bank Info bestaat',0),(552940,15360,'fi','Ilmoitus tulee nÃ¤yttÃ¶Ã¶n, jos ei Bank Info on olemassa',0),(552941,15360,'no','Setningen melding hvis ingen Bank Info',0),(552942,15360,'da','ErklÃ¦ring besked hvis der ingen Bank Info findes',0),(552943,15360,'ko','ë¬¸ì´ ë©”ì‹œì§€ ì—†ëŠ” ì€í–‰ ì •ë³´ ì¡´ìž¬ í•˜ëŠ” ê²½ìš°',0),(552944,15360,'he','×”×•×“×¢×ª ×“×•×— ×× ××™×Ÿ ×ž×™×“×¢ ×‘× ×§ ×§×™×™×',0),(552945,15360,'el','Î”Î®Î»Ï‰ÏƒÎ· Î¼Î®Î½Ï…Î¼Î± Î±Î½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÎºÎ±Î½Î­Î½Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï„ÏÎ¬Ï€ÎµÎ¶Î±',0),(552946,15360,'zh','å¦‚æžœæ²¡æœ‰é“¶è¡Œä¿¡æ¯å­˜åœ¨çš„å£°æ˜Žæ¶ˆæ¯',0),(552947,15360,'sv','Uttalande meddelande om ingen Bank Info finns',0),(552948,15360,'it','Messaggio di istruzione se non esiste nessuna Info Banca',0),(552949,15360,'tl','',0),(552950,15360,'th','à¸„à¸³à¸ªà¸±à¹ˆà¸‡à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸«à¸²à¸à¹„à¸¡à¹ˆà¸£à¸°à¸šà¸¸à¸˜à¸™à¸²à¸„à¸²à¸£',0),(552951,15360,'hi','à¤¯à¤¦à¤¿ à¤•à¥‹à¤ˆ à¤¬à¥ˆà¤‚à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ à¤¬à¤¯à¤¾à¤¨ à¤¸à¤‚à¤¦à¥‡à¤¶',0),(552952,15360,'ms','Mesej penyata jika maklumat Bank tidak wujud',0),(552953,15360,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ø±Ø³Ø§Ù„Ø© ÙÙŠ Ø­Ø§Ù„Ø© ÙˆØ¬ÙˆØ¯ Ø£ÙŠ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¨Ù†Ùƒ',0),(552954,15360,'fr','Message de dÃ©claration si aucune Info Banque n\'existe',0),(552955,15360,'jp','éŠ€è¡Œæƒ…å ±ãŒå­˜åœ¨ã—ãªã„å ´åˆã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆ ãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(552956,15360,'pt','Mensagem de instruÃ§Ã£o que exista nenhuma informaÃ§Ã£o bancÃ¡ria',0),(552957,15360,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ, ÐµÑÐ»Ð¸ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð½Ðµ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ Ñ€ÐµÐºÐ²Ð¸Ð·Ð¸Ñ‚Ñ‹',0),(552958,15360,'es','Mensaje de la declaraciÃ³n si no hay informaciÃ³n del Banco existe',0),(552959,15360,'de','Anweisung-Nachricht, wenn keine Bankverbindung vorhanden ist',0),(552960,15360,'en','Statement Message If No Bank Info Exists',0),(552961,15361,'is','',0),(552962,15361,'dr','Ù„Ø·ÙØ§ ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† SMTP Ú©Ù„Ø§Ø³ÛŒÚ© Ø¨Ø±Ø§ÛŒ Ú¯ÙˆÚ¯Ù„',0),(552963,15361,'pr','Ù„Ø·ÙØ§ ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† SMTP Ú©Ù„Ø§Ø³ÛŒÚ© Ø¨Ø±Ø§ÛŒ Ú¯ÙˆÚ¯Ù„',0),(552964,15361,'tr','LÃ¼tfen klasik SMTP iÃ§in Google izin',0),(552965,15361,'pl','ProszÄ™ wÅ‚Ä…czyÄ‡ klasyczne SMTP dla Google',0),(552966,15361,'bg','ÐœÐ¾Ð»Ñ, Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð¹Ñ‚Ðµ ÐºÐ»Ð°ÑÐ¸Ñ‡ÐµÑÐºÐ¸ SMTP Ð·Ð° Google',0),(552967,15361,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ú¯ÙˆÚ¯Ù„ Ú©Û’ Ù„Ø¦Û’ Ú©Ù„Ø§Ø³ÛŒÚ©ÛŒ SMTP Ø§ÛÙ„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(552968,15361,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° Ð¾Ð¼Ð¾Ð³ÑƒÑ›Ð¸Ñ‚Ðµ ÐºÐ»Ð°ÑÐ¸Ñ‡Ð½Ð¸ Ð¡ÐœÐ¢ÐŸ Ð·Ð° Ð“Ð¾Ð¾Ð³Ð»Ðµ',0),(552969,15361,'vi','Vui lÃ²ng kÃ­ch hoáº¡t cá»• Ä‘iá»ƒn SMTP cho Google',0),(552970,15361,'af','Aktiveer asseblief klassieke SMTP vir Google',0),(552971,15361,'ro','VÄƒ rugÄƒm sÄƒ activaÅ£i clasic SMTP pentru Google',0),(552972,15361,'et','Palun vÃµimaldada klassikaline SMTP Google',0),(552973,15361,'si','Prosimo, omogoÄite SMTP vzoren zakaj varljiva Å¾oga',0),(552974,15361,'ba','Silakan aktifkan klasik SMTP untuk Google',0),(552975,15361,'nl','Activeer klassieke SMTP voor Google',0),(552976,15361,'fi','Ota Google Classic SMTP',0),(552977,15361,'no','Aktiver klassiske SMTP For Google',0),(552978,15361,'da','Venligst aktiver klassiske SMTP til Google',0),(552979,15361,'ko','Googleì— ëŒ€ í•œ ê³ ì „ì ì¸ SMTPë¥¼ í™œì„±í™” í•˜ì‹­ì‹œì˜¤',0),(552980,15361,'he','×× × ×”×¤×¢×œ ×§×œ××¡×™ SMTP ×¢×‘×•×¨ ×’×•×’×œ',0),(552981,15361,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ Ï„Î·Î½ ÎºÎ»Î±ÏƒÎ¹ÎºÎ® SMTP Î³Î¹Î± Ï„Î¿ Google',0),(552982,15361,'zh','è¯·å¯ç”¨ç»å…¸ SMTP è°·æ­Œ',0),(552983,15361,'sv','VÃ¤nligen aktivera klassiska SMTP fÃ¶r Google',0),(552984,15361,'it','Si prega di abilitare SMTP classico per Google',0),(552985,15361,'tl','',0),(552986,15361,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™ SMTP à¸„à¸¥à¸²à¸ªà¸ªà¸´à¸à¸ªà¸³à¸«à¸£à¸±à¸š Google',0),(552987,15361,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤—à¥‚à¤—à¤² à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¾à¤¸à¤¿à¤• SMTP à¤¸à¤•à¥à¤·à¤® à¤•à¤°à¥‡à¤‚',0),(552988,15361,'ms','Sila bolehkan klasik SMTP untuk Google',0),(552989,15361,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªÙ…ÙƒÙŠÙ† SMTP Ø§Ù„ÙƒÙ„Ø§Ø³ÙŠÙƒÙŠØ© Ø¬ÙˆØ¬Ù„',0),(552990,15361,'fr','S\'il vous plaÃ®t activer SMTP classique pour Google',0),(552991,15361,'jp','Google ã®å¤å…¸çš„ãª SMTP ã‚’æœ‰åŠ¹ã«ã—ã¦ãã ã•ã„ã€‚',0),(552992,15361,'pt','Por favor, habilite o clÃ¡ssico SMTP para o Google',0),(552993,15361,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²ÐºÐ»ÑŽÑ‡Ð¸Ñ‚Ðµ ÐºÐ»Ð°ÑÑÐ¸Ñ‡ÐµÑÐºÐ¸Ðµ SMTP Ð´Ð»Ñ Google',0),(552994,15361,'es','Por favor habilitar SMTP clÃ¡sico para Google',0),(552995,15361,'de','Bitte aktivieren Sie klassische SMTP fÃ¼r Google',0),(552996,15361,'en','Please Enable Classic SMTP For Google',0),(552997,15362,'is','',0),(552998,15362,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø§Ø¹Ø´Ø§Ø±',0),(552999,15362,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø§Ø¹Ø´Ø§Ø±',0),(553000,15362,'tr','Stok sayÄ±mÄ± ondalÄ±k',0),(553001,15362,'pl','Inwentaryzacji miejsc po przecinku',0),(553002,15362,'bg','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð±Ñ€Ð¾Ð¹ Ð´ÐµÑÐµÑ‚Ð¸Ñ‡Ð½Ð¸ Ð·Ð½Ð°Ñ†Ð¸',0),(553003,15362,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ø§ Ø´Ù…Ø§Ø± Ø§Ø¹Ø´Ø§Ø±ÛŒÛ’2',0),(553004,15362,'sr','ÐŸÐ¾Ð¿Ð¸ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð° Ð´ÐµÑ†Ð¸Ð¼Ð°Ð»Ðµ',0),(553005,15362,'vi','HÃ ng tá»“n kho sá»‘ tháº­p phÃ¢n',0),(553006,15362,'af','Voorraad telling Decimals',0),(553007,15362,'ro','Inventarul numÄƒrul de zecimale',0),(553008,15362,'et','Varude krahv kÃ¼mnendkohta.',0),(553009,15362,'si','Inventura decimalk',0),(553010,15362,'ba','Menghitung persediaan desimal',0),(553011,15362,'nl','Voorraad aantal decimalen',0),(553012,15362,'fi','Varaston mÃ¤Ã¤rÃ¤ desimaaleja',0),(553013,15362,'no','Lageropptelling desimaler',0),(553014,15362,'da','LageroptÃ¦lling decimaler',0),(553015,15362,'ko','ìž¬ê³  ìˆ˜ ì†Œìˆ˜',0),(553016,15362,'he','×¡×¤×™×¨×ª ×”×ž×œ××™ ×©×‘×¨×™× ×¢×©×¨×•× ×™×™×',0),(553017,15362,'el','ÎšÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ· Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î´ÎµÎºÎ±Î´Î¹ÎºÎ¬ ÏˆÎ·Ï†Î¯Î±',0),(553018,15362,'zh','åº“å­˜ç›˜ç‚¹å°æ•°',0),(553019,15362,'sv','Lagerinventering decimaler',0),(553020,15362,'it','Conteggio inventario decimali',0),(553021,15362,'tl','',0),(553022,15362,'th','à¸—à¸¨à¸™à¸´à¸¢à¸¡à¸ˆà¸³à¸™à¸§à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(553023,15362,'hi','à¤¸à¥‚à¤šà¥€ à¤—à¤¿à¤¨à¤¤à¥€ à¤¦à¤¶à¤®à¤²à¤µ',0),(553024,15362,'ms','Pengiraan inventori perpuluhan',0),(553025,15362,'ar','Ø­ØµØ± Ø¹Ø¯Ø¯ Ø§Ù„Ù…Ù†Ø§Ø²Ù„ Ø§Ù„Ø¹Ø´Ø±ÙŠØ©',0),(553026,15362,'fr','Inventaire de dÃ©cimales',0),(553027,15362,'jp','åœ¨åº«æ•° 10 é€²æ•°',0),(553028,15362,'pt','Decimais de contagem de inventÃ¡rio',0),(553029,15362,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð´ÐµÑÑÑ‚Ð¸Ñ‡Ð½Ñ‹Ðµ Ð´Ñ€Ð¾Ð±Ð¸',0),(553030,15362,'es','Decimales de recuento de inventario',0),(553031,15362,'de','InventurzÃ¤hlung Dezimalzahlen',0),(553032,15362,'en','Inventory Count Decimals',0),(553033,15363,'is','',0),(553034,15363,'dr','Ø¨Ø§Ø·Ù„ Ú©Ø±Ø¯Ù†',0),(553035,15363,'pr','Ø¨Ø§Ø·Ù„ Ú©Ø±Ø¯Ù†',0),(553036,15363,'tr','Geri alma',0),(553037,15363,'pl','Cofnij',0),(553038,15363,'bg','ÐžÑ‚Ð¼ÐµÐ½Ð¸',0),(553039,15363,'ur','Ú©Ø§Ù„Ø¹Ø¯Ù… Ú©Ø±ÛŒÚº',0),(553040,15363,'sr','ÐžÐ¿Ð¾Ð·Ð¾Ð²Ð¸ Ñ€Ð°Ð´ÑšÑƒ',0),(553041,15363,'vi','HoÃ n tÃ¡c',0),(553042,15363,'af','Ontdoen',0),(553043,15363,'ro','Anulare',0),(553044,15363,'et','VÃµta tagasi',0),(553045,15363,'si','Razveljavi',0),(553046,15363,'ba','Membatalkan',0),(553047,15363,'nl','Ongedaan maken',0),(553048,15363,'fi','Kumoa',0),(553049,15363,'no','Angre',0),(553050,15363,'da','Fortryd',0),(553051,15363,'ko','ì‹¤í–‰ ì·¨ì†Œ',0),(553052,15363,'he','×‘×˜×œ',0),(553053,15363,'el','Î‘Î½Î±Î¯ÏÎµÏƒÎ·',0),(553054,15363,'zh','æ’¤æ¶ˆ',0),(553055,15363,'sv','Ã…ngra',0),(553056,15363,'it','Annulla',0),(553057,15363,'tl','',0),(553058,15363,'th','à¹€à¸¥à¸´à¸à¸—à¸³',0),(553059,15363,'hi','à¤ªà¥‚à¤°à¥à¤µà¤µà¤¤à¥ à¤•à¤°à¥‡à¤‚',0),(553060,15363,'ms','Buat asal',0),(553061,15363,'ar','Ø§Ù„ØªØ±Ø§Ø¬Ø¹ Ø¹Ù†',0),(553062,15363,'fr','Annuler',0),(553063,15363,'jp','å…ƒã«æˆ»ã™',0),(553064,15363,'pt','Desfazer',0),(553065,15363,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(553066,15363,'es','Deshacer',0),(553067,15363,'de','RÃ¼ckgÃ¤ngig machen',0),(553068,15363,'en','Undo',0),(553069,15364,'is','',0),(553070,15364,'dr','Ø¨Ù‡ Ù†Ù‚Ù„ Ø§Ø² Ù…Ø¯ÛŒØ± Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(553071,15364,'pr','Ø¨Ù‡ Ù†Ù‚Ù„ Ø§Ø² Ù…Ø¯ÛŒØ± Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù¾ÛŒØ´Ø±ÙØªÙ‡',0),(553072,15364,'tr','GeliÅŸmiÅŸ nakliye YÃ¶neticisi tÄ±rnak',0),(553073,15364,'pl','Zaawansowany menedÅ¼er wysyÅ‚ki Cytaty',0),(553074,15364,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¾ Ð¼ÐµÐ½Ð¸Ð´Ð¶ÑŠÑ€ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÐºÐ°Ð²Ð¸Ñ‡ÐºÐ¸',0),(553075,15364,'ur','Ø§Ø¹Ù„ÛŒ Ø´Ù¾Ù†Ú¯ Ù…Ù†ÛŒØ¬Ø± ÙˆØ§ÙˆÛŒÙ†',0),(553076,15364,'sr','ÐÐ°Ð¿Ñ€ÐµÐ´Ð½Ð¸ Ð¿Ð¾Ð½ÑƒÐ´Ðµ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ ÐœÐµÐ½Ð°ÑŸÐµÑ€',0),(553077,15364,'vi','NÃ¢ng cao quáº£n lÃ½ váº­n chuyá»ƒn bÃ¡o giÃ¡',0),(553078,15364,'af','Gevorderde gestuur Bestuurder aanhalings',0),(553079,15364,'ro','Citate de transport Manager avansat',0),(553080,15364,'et','TÃ¤psem Shipping Manager hinnapakkumisi',0),(553081,15364,'si','Napredne ponudbe dostava Manager',0),(553082,15364,'ba','Advanced kutipan pengiriman Manajer',0),(553083,15364,'nl','Geavanceerde verzending Manager Quotes',0),(553084,15364,'fi','Kehittynyt toimitus johtaja lainausmerkit',0),(553085,15364,'no','Avansert Shipping Manager sitater',0),(553086,15364,'da','Avanceret Shipping Manager citater',0),(553087,15364,'ko','ê³ ê¸‰ ì„ ë°• ê´€ë¦¬ìž ë”°ì˜´í‘œ',0),(553088,15364,'he','×”×¦×¢×•×ª ×ž×—×™×¨ ×”×ž×©×œ×•×— ×ž× ×”×œ ×ž×ª×§×“×',0),(553089,15364,'el','Î ÏÎ¿Î·Î³Î¼Î­Î½Î· Î´Î¹ÎµÏ…Î¸Ï…Î½Ï„Î® Î½Î±Ï…Ï„Î¹Î»Î¯Î±Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î¹ÎºÎ¬',0),(553090,15364,'zh','å…ˆè¿›çš„è´§è¿ç»ç†æŠ¥ä»·',0),(553091,15364,'sv','Avancerade frakt Manager citat',0),(553092,15364,'it','Citazioni di Shipping Manager avanzato',0),(553093,15364,'tl','',0),(553094,15364,'th','à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸à¸²à¸£à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²',0),(553095,15364,'hi','à¤‰à¤¨à¥à¤¨à¤¤ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤ªà¥à¤°à¤¬à¤‚à¤§à¤• à¤‰à¤¦à¥à¤§à¤°à¤£',0),(553096,15364,'ms','Petikan-petikan Pengurus perkapalan yang termaju',0),(553097,15364,'ar','Ù…ØªÙ‚Ø¯Ù…Ø© ÙˆÙ†Ù‚Ù„Øª Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ',0),(553098,15364,'fr','AvancÃ©e des citations Shipping Manager',0),(553099,15364,'jp','é«˜åº¦ãªé…å¸ƒãƒžãƒãƒ¼ã‚¸ãƒ£ãƒ¼ã®å¼•ç”¨ç¬¦',0),(553100,15364,'pt','AvanÃ§ado gerenciador de envio de citaÃ§Ãµes',0),(553101,15364,'ru','Ð Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ð¹ Ð¼ÐµÐ½ÐµÐ´Ð¶ÐµÑ€ ÑÑƒÐ´Ð¾Ñ…Ð¾Ð´ÑÑ‚Ð²Ð¾ ÐºÐ¾Ñ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(553102,15364,'es','Avanzado Administrador de envÃ­o cotizaciones',0),(553103,15364,'de','Erweiterter Versand-Manager-Zitate',0),(553104,15364,'en','Advanced Shipping Manager Quotes',0),(553105,15365,'is','',0),(553106,15365,'dr','Ù…ÛŒØ²Ø§Ù† Ø¨Ø±Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(553107,15365,'pr','Ù…ÛŒØ²Ø§Ù† Ø¨Ø±Ø§ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù„ÛŒÚ© Ú©Ù†ÛŒØ¯',0),(553108,15365,'tr','HÄ±zÄ± seÃ§mek iÃ§in tÄ±klatÄ±n',0),(553109,15365,'pl','StawkÄ™ kliknij aby wybraÄ‡',0),(553110,15365,'bg','Ð©Ñ€Ð°ÐºÐ½ÐµÑ‚Ðµ, Ð·Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ',0),(553111,15365,'ur','Ø´Ø±Ø­ Ù…Ù†ØªØ®Ø¨ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ù„Ú© Ú©Ø±ÛŒÚº',0),(553112,15365,'sr','ÐšÐ»Ð¸ÐºÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ð´ÑƒÐ³Ð¼Ðµ ÐºÑƒÑ€Ñ Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€',0),(553113,15365,'vi','Tá»· lá»‡ nháº¥p chuá»™t Ä‘á»ƒ chá»n',0),(553114,15365,'af','Klik koers te kies',0),(553115,15365,'ro','Rata de clic pentru a selecta',0),(553116,15365,'et','IntressimÃ¤Ã¤ra valimiseks klÃµpsake',0),(553117,15365,'si','Stopnja klikov za izbiro',0),(553118,15365,'ba','Tingkat klik untuk memilih',0),(553119,15365,'nl','Klikfrequentie te selecteren',0),(553120,15365,'fi','Valitse Luokittele, valitse',0),(553121,15365,'no','Klikk hastigheten til Ã¥ velge',0),(553122,15365,'da','Klik pÃ¥ sats til at vÃ¦lge',0),(553123,15365,'ko','ì„ íƒ í´ë¦­ ì†ë„',0),(553124,15365,'he','×œ×—×¥ ×¢×œ ×§×¦×‘ ×›×“×™ ×œ×‘×—×•×¨',0),(553125,15365,'el','Î Î¿ÏƒÎ¿ÏƒÏ„ÏŒ ÎºÎ»Î¹Îº Î³Î¹Î± Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ',0),(553126,15365,'zh','ç‚¹å‡»çŽ‡æ¥é€‰æ‹©',0),(553127,15365,'sv','Klicka pÃ¥ kurs att vÃ¤lja',0),(553128,15365,'it','Tasso di clic per selezionare',0),(553129,15365,'tl','',0),(553130,15365,'th','à¸„à¸¥à¸´à¸à¸à¸²à¸£à¹€à¸¥à¸·à¸­à¸',0),(553131,15365,'hi','à¤¦à¤° à¤•à¥‹ à¤šà¥à¤¨à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤²à¤¿à¤• à¤•à¤°à¥‡à¤‚',0),(553132,15365,'ms','Kadar klik untuk memilih',0),(553133,15365,'ar','Ø§Ù†Ù‚Ø± ÙÙˆÙ‚ Ù…Ø¹Ø¯Ù„ Ù„ØªØ­Ø¯ÙŠØ¯',0),(553134,15365,'fr','Taux de clics pour sÃ©lectionner',0),(553135,15365,'jp','ã‚¯ãƒªãƒƒã‚¯çŽ‡ã‚’é¸æŠžã™ã‚‹ã«ã¯',0),(553136,15365,'pt','Taxa de clique para selecionar',0),(553137,15365,'ru','ÐÐ°Ð¶Ð¼Ð¸Ñ‚Ðµ ÐºÐ½Ð¾Ð¿ÐºÑƒ ÑÑ‚Ð°Ð²ÐºÐ° Ð´Ð»Ñ Ð²Ñ‹Ð±Ð¾Ñ€Ð°',0),(553138,15365,'es','Haga clic en tipo para seleccionar',0),(553139,15365,'de','Klickrate auswÃ¤hlen',0),(553140,15365,'en','Click Rate To Select',0),(553141,15366,'is','',0),(553142,15366,'dr','Ù†Ø§Ù… Ù…ÙˆØ±Ø¯ ØºÛŒØ± ÙØ¹Ø§Ù„ Ùˆ ÛŒØ§ Ú©Ø¯',0),(553143,15366,'pr','Ù†Ø§Ù… Ù…ÙˆØ±Ø¯ ØºÛŒØ± ÙØ¹Ø§Ù„ Ùˆ ÛŒØ§ Ú©Ø¯',0),(553144,15366,'tr','Etkin olmayan Ã¶ÄŸe adÄ± veya kod',0),(553145,15366,'pl','Nazwa elementu nieaktywne lub kod',0),(553146,15366,'bg','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¸Ð¼Ðµ Ð¸Ð»Ð¸ ÐºÐ¾Ð´',0),(553147,15366,'ur','ØºÛŒØ± ÙØ¹Ø§Ù„ Ø´Û’ Ù†Ø§Ù… ÛŒØ§ Ú©ÙˆÚˆ',0),(553148,15366,'sr','Ð˜Ð¼Ðµ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ðµ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð° Ð¸Ð»Ð¸ Ð¨Ð¸Ñ„Ñ€Ð°',0),(553149,15366,'vi','TÃªn khoáº£n má»¥c khÃ´ng hoáº¡t Ä‘á»™ng hoáº·c mÃ£',0),(553150,15366,'af','Onaktiewe Item naam of kode',0),(553151,15366,'ro','Numele elementului inactiv sau codul',0),(553152,15366,'et','Passiivne kirje nimi vÃµi kood',0),(553153,15366,'si','Neaktivne ime ali kodo',0),(553154,15366,'ba','Nama Item tidak aktif atau kode',0),(553155,15366,'nl','Inactieve itemnaam of Code',0),(553156,15366,'fi','Passiivinen kohteen nimi tai koodi',0),(553157,15366,'no','Inaktive navn eller kode',0),(553158,15366,'da','Inaktive varenavn eller kode',0),(553159,15366,'ko','ë¹„í™œì„± í•­ëª© ì´ë¦„ ë˜ëŠ” ì½”ë“œ',0),(553160,15366,'he','×©× ×¤×¨×™×˜ ××™× ×• ×¤×¢×™×œ ××• ×§×•×“',0),(553161,15366,'el','Î‘Î½ÎµÎ½ÎµÏÎ³ÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏŒÎ½Î¿Î¼Î± Î® ÎºÏ‰Î´Î¹ÎºÏŒ',0),(553162,15366,'zh','å¤„äºŽéžæ´»åŠ¨çŠ¶æ€çš„é¡¹ç›®åç§°æˆ–ä»£ç ',0),(553163,15366,'sv','Inaktiva namn eller kod',0),(553164,15366,'it','Nome elemento inattivo o codice',0),(553165,15366,'tl','',0),(553166,15366,'th','à¸Šà¸·à¹ˆà¸­à¸ªà¸´à¸™à¸„à¹‰à¸²à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸«à¸£à¸·à¸­à¸£à¸«à¸±à¸ª',0),(553167,15366,'hi','à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯ à¤†à¤‡à¤Ÿà¤® à¤¨à¤¾à¤® à¤¯à¤¾ à¤•à¥‹à¤¡',0),(553168,15366,'ms','Kod atau nama barang yang tidak aktif',0),(553169,15366,'ar','Ø§Ø³Ù… Ø§Ù„Ø¹Ù†ØµØ± ØºÙŠØ± Ù†Ø´Ø· Ø£Ùˆ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ©',0),(553170,15366,'fr','Code ou nom de l\'Ã©lÃ©ment inactif',0),(553171,15366,'jp','ä½¿ç”¨é »åº¦ã®ä½Žã„ã‚¢ã‚¤ãƒ†ãƒ åã¾ãŸã¯ã‚³ãƒ¼ãƒ‰',0),(553172,15366,'pt','Nome do Item inativos ou cÃ³digo',0),(553173,15366,'ru','ÐÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¸Ð¼Ñ Ð¸Ð»Ð¸ ÐºÐ¾Ð´',0),(553174,15366,'es','CÃ³digo o nombre del elemento inactivo',0),(553175,15366,'de','Inaktive Artikelname oder Code',0),(553176,15366,'en','Inactive Item Name Or Code',0),(553177,15367,'is','',0),(553178,15367,'dr','Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙˆÙ„',0),(553179,15367,'pr','Ø­Ø³Ø§Ø¨ Ø¬Ø¯ÙˆÙ„',0),(553180,15367,'tr','Hesap tablosu',0),(553181,15367,'pl','Tabeli kont',0),(553182,15367,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(553183,15367,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú©ÛŒ Ù…ÛŒØ²',0),(553184,15367,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° ÐºÐ¾Ð½Ñ‚Ð°',0),(553185,15367,'vi','Báº£ng tÃ i khoáº£n',0),(553186,15367,'af','Tabel van rekeninge',0),(553187,15367,'ro','Tabelul de conturi',0),(553188,15367,'et','Kontode tabeli',0),(553189,15367,'si','RaÄunov tabelo',0),(553190,15367,'ba','Tabel account',0),(553191,15367,'nl','Tabel accounts',0),(553192,15367,'fi','Tilit-taulukosta',0),(553193,15367,'no','Tabellen',0),(553194,15367,'da','Konti tabel',0),(553195,15367,'ko','ê³„ì • í…Œì´ë¸”',0),(553196,15367,'he','×˜×‘×œ×” ×—×©×‘×•× ×•×ª',0),(553197,15367,'el','Î Î¯Î½Î±ÎºÎ± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(553198,15367,'zh','å¸ç›®è¡¨',0),(553199,15367,'sv','Konton tabell',0),(553200,15367,'it','Tabella conti',0),(553201,15367,'tl','',0),(553202,15367,'th','à¸šà¸±à¸à¸Šà¸µà¸•à¸²à¸£à¸²à¸‡',0),(553203,15367,'hi','à¤–à¤¾à¤¤à¥‹à¤‚ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553204,15367,'ms','Jadual akaun',0),(553205,15367,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(553206,15367,'fr','Tableau comptes',0),(553207,15367,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®è¡¨',0),(553208,15367,'pt','Tabela de contas',0),(553209,15367,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(553210,15367,'es','Cuadro de cuentas',0),(553211,15367,'de','Kontentabelle',0),(553212,15367,'en','Accounts Table',0),(553213,15368,'is','',0),(553214,15368,'dr','Ø¬Ø¯ÙˆÙ„ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ú©',0),(553215,15368,'pr','Ø¬Ø¯ÙˆÙ„ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ø§Ù†Ú©',0),(553216,15368,'tr','Banka mevduat tablo',0),(553217,15368,'pl','Tabela depozytÃ³w bankowych',0),(553218,15368,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(553219,15368,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ø°Ø®Ø§Ø¦Ø± Ø¬Ø¯ÙˆÙ„',0),(553220,15368,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ðµ Ð±Ð°Ð½ÐºÐµ',0),(553221,15368,'vi','NgÃ¢n hÃ ng tiá»n gá»­i báº£ng',0),(553222,15368,'af','Bank deposito\'s tabel',0),(553223,15368,'ro','Tabel de depozite bancare',0),(553224,15368,'et','Panga hoiused tabel',0),(553225,15368,'si','BanÄni depoziti tabele',0),(553226,15368,'ba','Tabel deposito bank',0),(553227,15368,'nl','Bank deposito\'s tabel',0),(553228,15368,'fi','Pankin talletukset taulukko',0),(553229,15368,'no','Banken innskudd tabell',0),(553230,15368,'da','Bank indbetalinger tabel',0),(553231,15368,'ko','ì€í–‰ ì˜ˆê¸ˆ í…Œì´ë¸”',0),(553232,15368,'he','×‘× ×§ ×”×¤×§×“×•×ª ×˜×‘×œ×”',0),(553233,15368,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÎ¹Ï‚ Ï€Î¯Î½Î±ÎºÎ±',0),(553234,15368,'zh','é“¶è¡Œå­˜æ¬¾è¡¨',0),(553235,15368,'sv','Bankens inlÃ¥ning Table',0),(553236,15368,'it','Tabella di depositi bancari',0),(553237,15368,'tl','',0),(553238,15368,'th','à¸•à¸²à¸£à¸²à¸‡à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸˜à¸™à¸²à¸„à¸²à¸£',0),(553239,15368,'hi','à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553240,15368,'ms','Jadual simpanan Bank',0),(553241,15368,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ©',0),(553242,15368,'fr','Table de dÃ©pÃ´ts bancaires',0),(553243,15368,'jp','éŠ€è¡Œé é‡‘è¡¨',0),(553244,15368,'pt','Tabela de depÃ³sitos do banco',0),(553245,15368,'ru','Ð‘Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ñ‹ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(553246,15368,'es','Mesa de depÃ³sitos del Banco',0),(553247,15368,'de','Bank-Einlagen-Tabelle',0),(553248,15368,'en','Bank Deposits Table',0),(553249,15369,'is','',0),(553250,15369,'dr','Ø¬Ø¯ÙˆÙ„ Ø¨ÙˆØ¯Ø¬Ù‡',0),(553251,15369,'pr','Ø¬Ø¯ÙˆÙ„ Ø¨ÙˆØ¯Ø¬Ù‡',0),(553252,15369,'tr','BÃ¼tÃ§e tablosu',0),(553253,15369,'pl','Budgets tabela',0),(553254,15369,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(553255,15369,'ur','Ø¨Ø¬Ù¹ Ú©ÛŒ Ù…ÛŒØ²',0),(553256,15369,'sr','Ð‘ÑƒÑŸÐµÑ‚Ðµ Ñ‚Ð°Ð±ÐµÐ»Ðµ',0),(553257,15369,'vi','NgÃ¢n sÃ¡ch báº£ng',0),(553258,15369,'af','Begrotings tabel',0),(553259,15369,'ro','Bugetele de masÄƒ',0),(553260,15369,'et','Eelarvete tabel',0),(553261,15369,'si','Tabela proraÄunov',0),(553262,15369,'ba','Anggaran tabel',0),(553263,15369,'nl','Begrotingen tabel',0),(553264,15369,'fi','Budjetit taulukko',0),(553265,15369,'no','Budsjetter tabell',0),(553266,15369,'da','Budget tabel',0),(553267,15369,'ko','ì˜ˆì‚° í‘œ',0),(553268,15369,'he','×˜×‘×œ×” ×ª×§×¦×™×‘×™×',0),(553269,15369,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¯Î½Î±ÎºÎ±',0),(553270,15369,'zh','é¢„ç®—è¡¨',0),(553271,15369,'sv','Budgetar tabell',0),(553272,15369,'it','Tabella budgets',0),(553273,15369,'tl','',0),(553274,15369,'th','à¸•à¸²à¸£à¸²à¸‡à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“',0),(553275,15369,'hi','à¤¬à¤œà¤Ÿ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553276,15369,'ms','Jadual belanjawan',0),(553277,15369,'ar','Ø§Ù„Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª',0),(553278,15369,'fr','Table budgets',0),(553279,15369,'jp','äºˆç®—è¡¨',0),(553280,15369,'pt','Tabela de orÃ§amentos',0),(553281,15369,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ñ‹ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(553282,15369,'es','Tabla de presupuestos',0),(553283,15369,'de','Budget-Tabelle',0),(553284,15369,'en','Budgets Table',0),(553285,15370,'is','',0),(553286,15370,'dr','Ø¬Ø¯ÙˆÙ„ Ú†Ú©',0),(553287,15370,'pr','Ø¬Ø¯ÙˆÙ„ Ú†Ú©',0),(553288,15370,'tr','Denetimleri tablo',0),(553289,15370,'pl','Tabela kontroli',0),(553290,15370,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(553291,15370,'ur','Ú†ÛŒÚ© Ø¬Ø¯ÙˆÙ„',0),(553292,15370,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(553293,15370,'vi','Kiá»ƒm tra báº£ng',0),(553294,15370,'af','Ondersoeke tabel',0),(553295,15370,'ro','Tabelul de control',0),(553296,15370,'et','Kontrolli tabel',0),(553297,15370,'si','Preverjanja tabele',0),(553298,15370,'ba','Cek tabel',0),(553299,15370,'nl','Controles tabel',0),(553300,15370,'fi','Tarkastusten taulukko',0),(553301,15370,'no','Sjekker tabell',0),(553302,15370,'da','Kontroller tabel',0),(553303,15370,'ko','ê²€ì‚¬ í…Œì´ë¸”',0),(553304,15370,'he','×‘×“×™×§×•×ª ×˜×‘×œ×”',0),(553305,15370,'el','Î Î¯Î½Î±ÎºÎ±Ï‚ ÎµÎ»Î­Î³Ï‡Ï‰Î½',0),(553306,15370,'zh','æ£€æŸ¥è¡¨',0),(553307,15370,'sv','Kontroller tabell',0),(553308,15370,'it','Tabella di controlli',0),(553309,15370,'tl','',0),(553310,15370,'th','à¸•à¸²à¸£à¸²à¸‡à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(553311,15370,'hi','à¤œà¤¾à¤à¤šà¥‹à¤‚ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553312,15370,'ms','Jadual semakan',0),(553313,15370,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø´ÙŠÙƒØ§Øª',0),(553314,15370,'fr','Tableau de contrÃ´les',0),(553315,15370,'jp','ãƒã‚§ãƒƒã‚¯è¡¨',0),(553316,15370,'pt','VerificaÃ§Ãµes de tabela',0),(553317,15370,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(553318,15370,'es','Tabla de comprobaciones',0),(553319,15370,'de','Kontrollen-Tabelle',0),(553320,15370,'en','Checks Table',0),(553321,15371,'is','',0),(553322,15371,'dr','Ø¬Ø¯ÙˆÙ„ Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(553323,15371,'pr','Ø¬Ø¯ÙˆÙ„ Ø®Ø±ÛŒØ¯ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(553324,15371,'tr','Kredi kartÄ± SatÄ±nalmalar tablosu',0),(553325,15371,'pl','Karta kredytowa zakupy tabeli',0),(553326,15371,'bg','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(553327,15371,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ø³ÙˆØ¯ÙˆÚº Ú©ÛŒ Ù…ÛŒØ²',0),(553328,15371,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° ÐºÑƒÐ¿Ð¾Ð²Ð¸Ð½Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(553329,15371,'vi','Tháº» tÃ­n dá»¥ng mua hÃ ng báº£ng',0),(553330,15371,'af','Kredietkaart aankope tabel',0),(553331,15371,'ro','Card de credit cumpÄƒrÄƒri tabel',0),(553332,15371,'et','Krediitkaardiga ostude tabel',0),(553333,15371,'si','Kreditne kartice nakupe tabele',0),(553334,15371,'ba','Kartu kredit pembelian tabel',0),(553335,15371,'nl','Credit Card aankopen tabel',0),(553336,15371,'fi','Luottokortti ostot taulukko',0),(553337,15371,'no','Kredittkort kjÃ¸p tabell',0),(553338,15371,'da','Kreditkort KÃ¸b tabel',0),(553339,15371,'ko','ì‹ ìš© ì¹´ë“œ êµ¬ë§¤ í…Œì´ë¸”',0),(553340,15371,'he','×˜×‘×œ×ª ×¨×›×™×©×•×ª ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(553341,15371,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î± Î±Î³Î¿ÏÏŽÎ½ Ï€Î¯Î½Î±ÎºÎ±',0),(553342,15371,'zh','ä¿¡ç”¨å¡è´­ä¹°è¡¨',0),(553343,15371,'sv','Kreditkort inkÃ¶p tabell',0),(553344,15371,'it','Tabella degli acquisti di carta di credito',0),(553345,15371,'tl','',0),(553346,15371,'th','à¸•à¸²à¸£à¸²à¸‡à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•à¸‹à¸·à¹‰à¸­',0),(553347,15371,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤–à¤°à¥€à¤¦ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553348,15371,'ms','Jadual pembelian kad kredit',0),(553349,15371,'ar','Ø¬Ø¯ÙˆÙ„ Ù…Ø´ØªØ±ÙŠØ§Øª Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(553350,15371,'fr','Table d\'achats de carte de crÃ©dit',0),(553351,15371,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰è³¼å…¥è¨˜éŒ²ãƒ†ãƒ¼ãƒ–ãƒ«',0),(553352,15371,'pt','Tabela de compras do cartÃ£o de crÃ©dito',0),(553353,15371,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(553354,15371,'es','Mesa de compras de tarjeta de crÃ©dito',0),(553355,15371,'de','Kreditkarten EinkÃ¤ufe Tabelle',0),(553356,15371,'en','Credit Card Purchases Table',0),(553357,15372,'is','',0),(553358,15372,'dr','Ø¬Ø¯ÙˆÙ„ Ù…Ø´ØªØ±ÛŒ',0),(553359,15372,'pr','Ø¬Ø¯ÙˆÙ„ Ù…Ø´ØªØ±ÛŒ',0),(553360,15372,'tr','MÃ¼ÅŸteri tablosu',0),(553361,15372,'pl','Klienta tabela',0),(553362,15372,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð° \"ÐºÐ»Ð¸ÐµÐ½Ñ‚\"',0),(553363,15372,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ù…ÛŒØ²',0),(553364,15372,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° \"ÐšÑƒÐ¿Ð°Ñ†\"',0),(553365,15372,'vi','KhÃ¡ch hÃ ng báº£ng',0),(553366,15372,'af','KliÃ«nt tabel',0),(553367,15372,'ro','Tabelul de client',0),(553368,15372,'et','Tabelis Klient',0),(553369,15372,'si','Tabelo Kupec',0),(553370,15372,'ba','Meja pelanggan',0),(553371,15372,'nl','Klantentabel',0),(553372,15372,'fi','Asiakasrekisteriin',0),(553373,15372,'no','Kundetabellen',0),(553374,15372,'da','Kundetabellen',0),(553375,15372,'ko','ê³ ê° í…Œì´ë¸”',0),(553376,15372,'he','×˜×‘×œ×ª ×œ×§×•×—×•×ª',0),(553377,15372,'el','Î Î¯Î½Î±ÎºÎ± \"Ï€ÎµÎ»Î¬Ï„Î·Ï‚\"',0),(553378,15372,'zh','å®¢æˆ·è¡¨',0),(553379,15372,'sv','Kundregistret',0),(553380,15372,'it','Tabella Customer',0),(553381,15372,'tl','',0),(553382,15372,'th','à¸•à¸²à¸£à¸²à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(553383,15372,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553384,15372,'ms','Jadual pelanggan',0),(553385,15372,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(553386,15372,'fr','Table Customer',0),(553387,15372,'jp','é¡§å®¢ãƒ†ãƒ¼ãƒ–ãƒ«',0),(553388,15372,'pt','Tabela de clientes',0),(553389,15372,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Customer',0),(553390,15372,'es','Tabla cliente',0),(553391,15372,'de','Customer-Tabelle',0),(553392,15372,'en','Customer Table',0),(553393,15373,'is','',0),(553394,15373,'dr','Ù…ÛŒØ² Ú©Ø§Ø±Ù…Ù†Ø¯ÛŒ',0),(553395,15373,'pr','Ù…ÛŒØ² Ú©Ø§Ø±Ù…Ù†Ø¯ÛŒ',0),(553396,15373,'tr','Ã‡alÄ±ÅŸan tablosu',0),(553397,15373,'pl','Employee tabela',0),(553398,15373,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð° \"ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»\"',0),(553399,15373,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ Ù…ÛŒØ²',0),(553400,15373,'sr','\"Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸\"',0),(553401,15373,'vi','NhÃ¢n viÃªn bÃ n',0),(553402,15373,'af','Werknemer tabel',0),(553403,15373,'ro','Tabel cu angajaÅ£i',0),(553404,15373,'et','TÃ¶Ã¶tajate tabelis',0),(553405,15373,'si','Zaposlenega mizo',0),(553406,15373,'ba','Tabel karyawan',0),(553407,15373,'nl','Werknemerstabel',0),(553408,15373,'fi','TyÃ¶ntekijÃ¤-taulukossa',0),(553409,15373,'no','Ansattabellen',0),(553410,15373,'da','Medarbejdertabellen',0),(553411,15373,'ko','Employee í…Œì´ë¸”',0),(553412,15373,'he','×˜×‘×œ×ª ×”×¢×•×‘×“×™×',0),(553413,15373,'el','Î Î¯Î½Î±ÎºÎ± \"ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿Ï‚\"',0),(553414,15373,'zh','é›‡å‘˜è¡¨',0),(553415,15373,'sv','Medarbetarregistret',0),(553416,15373,'it','Tabella Employee',0),(553417,15373,'tl','',0),(553418,15373,'th','à¸•à¸²à¸£à¸²à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(553419,15373,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553420,15373,'ms','Jadual pekerja',0),(553421,15373,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ù…ÙˆØ¸ÙÙŠÙ†',0),(553422,15373,'fr','Table Employee',0),(553423,15373,'jp','Employee ãƒ†ãƒ¼ãƒ–ãƒ«',0),(553424,15373,'pt','Mesa de empregado',0),(553425,15373,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Employee',0),(553426,15373,'es','Tabla Employee',0),(553427,15373,'de','Employee-Tabelle',0),(553428,15373,'en','Employee Table',0),(553429,15374,'is','',0),(553430,15374,'dr','Ø¬Ø¯ÙˆÙ„ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(553431,15374,'pr','Ø¬Ø¯ÙˆÙ„ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(553432,15374,'tr','Faturalar tablo',0),(553433,15374,'pl','Tabeli faktur',0),(553434,15374,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(553435,15374,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø¬Ø¯ÙˆÙ„',0),(553436,15374,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(553437,15374,'vi','HoÃ¡ Ä‘Æ¡n báº£ng',0),(553438,15374,'af','Fakture tabel',0),(553439,15374,'ro','Facturi de masÄƒ',0),(553440,15374,'et','Arvete tabel',0),(553441,15374,'si','RaÄunov tabelo',0),(553442,15374,'ba','Faktur tabel',0),(553443,15374,'nl','Factureringstabel',0),(553444,15374,'fi','Laskujen taulukko',0),(553445,15374,'no','Fakturaer tabell',0),(553446,15374,'da','Fakturaer tabel',0),(553447,15374,'ko','ì†¡ìž¥ í…Œì´ë¸”',0),(553448,15374,'he','×”×˜×‘×œ×” invoices',0),(553449,15374,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¯Î½Î±ÎºÎ±',0),(553450,15374,'zh','å‘ç¥¨è¡¨',0),(553451,15374,'sv','Fakturor tabell',0),(553452,15374,'it','Tabella fatture',0),(553453,15374,'tl','',0),(553454,15374,'th','à¸•à¸²à¸£à¸²à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(553455,15374,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553456,15374,'ms','Jadual invois',0),(553457,15374,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(553458,15374,'fr','Table des factures',0),(553459,15374,'jp','è«‹æ±‚æ›¸ãƒ†ãƒ¼ãƒ–ãƒ«',0),(553460,15374,'pt','Tabela de facturas',0),(553461,15374,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(553462,15374,'es','Tabla de facturas',0),(553463,15374,'de','Rechnungstabelle',0),(553464,15374,'en','Invoices Table',0),(553465,15375,'is','',0),(553466,15375,'dr','Ø¬Ø¯ÙˆÙ„ Ø§Ù‚Ù„Ø§Ù…',0),(553467,15375,'pr','Ø¬Ø¯ÙˆÙ„ Ø§Ù‚Ù„Ø§Ù…',0),(553468,15375,'tr','Ã–ÄŸeler tablosu',0),(553469,15375,'pl','Elementy tabeli',0),(553470,15375,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ',0),(553471,15375,'ur','Ø§Ø´ÛŒØ§ Ø¬Ø¯ÙˆÙ„ÛŒ',0),(553472,15375,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° ÑÑ‚Ð°Ð²ÐºÐµ',0),(553473,15375,'vi','Má»¥c báº£ng',0),(553474,15375,'af','Items tabel',0),(553475,15375,'ro','Articole de masÄƒ',0),(553476,15375,'et','Tabelis kaubad',0),(553477,15375,'si','Tabele elementov',0),(553478,15375,'ba','Item tabel',0),(553479,15375,'nl','Items tabel',0),(553480,15375,'fi','Nimikkeet-taulussa',0),(553481,15375,'no','Varetabellen',0),(553482,15375,'da','Varetabellen',0),(553483,15375,'ko','í•­ëª© í…Œì´ë¸”',0),(553484,15375,'he','×¤×¨×™×˜×™× ×‘×˜×‘×œ×”',0),(553485,15375,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î¿Ï… Ï€Î¯Î½Î±ÎºÎ±',0),(553486,15375,'zh','é¡¹ç›®è¡¨',0),(553487,15375,'sv','Artikelregistret',0),(553488,15375,'it','Tabella degli elementi',0),(553489,15375,'tl','',0),(553490,15375,'th','à¸•à¸²à¸£à¸²à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(553491,15375,'hi','à¤†à¤‡à¤Ÿà¤® à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553492,15375,'ms','Jadual barangan',0),(553493,15375,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø£ØµÙ†Ø§Ù',0),(553494,15375,'fr','Table des Articles',0),(553495,15375,'jp','ã‚¢ã‚¤ãƒ†ãƒ è¡¨',0),(553496,15375,'pt','Tabela de itens',0),(553497,15375,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(553498,15375,'es','Tabla de elementos',0),(553499,15375,'de','Artikeltabelle',0),(553500,15375,'en','Items Table',0),(553501,15376,'is','',0),(553502,15376,'dr','Ø¬Ø¯ÙˆÙ„ ÙˆØ±ÙˆØ¯ÛŒÙ‡Ø§ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø±',0),(553503,15376,'pr','Ø¬Ø¯ÙˆÙ„ ÙˆØ±ÙˆØ¯ÛŒÙ‡Ø§ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø±',0),(553504,15376,'tr','GÃ¼nlÃ¼k giriÅŸleri tablosu',0),(553505,15376,'pl','Tabela wpisy dziennika',0),(553506,15376,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(553507,15376,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ø¬Ø¯ÙˆÙ„',0),(553508,15376,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° ÑÑ‚Ð°Ð²ÐºÐµ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(553509,15376,'vi','Táº¡p chÃ­ má»¥c báº£ng',0),(553510,15376,'af','Joernaal inskrywings tabel',0),(553511,15376,'ro','Tabelul de intrÄƒri jurnal',0),(553512,15376,'et','TÃ¶Ã¶lehe kanded tabel',0),(553513,15376,'si','Tabeli postavke temeljnice',0),(553514,15376,'ba','Tabel entri jurnal',0),(553515,15376,'nl','Dagboek tabel',0),(553516,15376,'fi','MerkinnÃ¤t kirjauskansiotaulu',0),(553517,15376,'no','Journaltabell oppfÃ¸ringer',0),(553518,15376,'da','Kladdetabel poster',0),(553519,15376,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª© í…Œì´ë¸”',0),(553520,15376,'he','×˜×‘×œ×ª ×¢×¨×›×™ ×™×•×ž×Ÿ',0),(553521,15376,'el','Î•Ï†Î·Î¼ÎµÏÎ¯Î´Î± ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Ï€Î¯Î½Î±ÎºÎ±',0),(553522,15376,'zh','æ—¥è®°æ¡ç›®è¡¨',0),(553523,15376,'sv','Journalregister fÃ¶r poster',0),(553524,15376,'it','Tabella di voci di diario',0),(553525,15376,'tl','',0),(553526,15376,'th','à¸•à¸²à¸£à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™',0),(553527,15376,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553528,15376,'ms','Jadual kemasukan jurnal',0),(553529,15376,'ar','Ø¬Ø¯ÙˆÙ„ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(553530,15376,'fr','Tableau d\'entrÃ©es de journal',0),(553531,15376,'jp','ä»•è¨³å¸³ã®ã‚¨ãƒ³ãƒˆãƒª ãƒ†ãƒ¼ãƒ–ãƒ«',0),(553532,15376,'pt','Tabela de entradas de diÃ¡rio',0),(553533,15376,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ð·Ð°Ð¿Ð¸ÑÐ¸ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(553534,15376,'es','Mesa de entradas de diario',0),(553535,15376,'de','Erfassungstabelle EintrÃ¤ge',0),(553536,15376,'en','Journal Entries Table',0),(553537,15377,'is','',0),(553538,15377,'dr','Ø¬Ø¯ÙˆÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(553539,15377,'pr','Ø¬Ø¯ÙˆÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª',0),(553540,15377,'tr','SipariÅŸler tablosu',0),(553541,15377,'pl','Tabela zlecenia',0),(553542,15377,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð° \"Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸\"',0),(553543,15377,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø¯ÙˆÙ„',0),(553544,15377,'sr','\"ÐŸÐ¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ\"',0),(553545,15377,'vi','ÄÆ¡n Ä‘áº·t hÃ ng báº£ng',0),(553546,15377,'af','Bestellings tabel',0),(553547,15377,'ro','Tabelul Comenzi',0),(553548,15377,'et','Tellimuste tabel',0),(553549,15377,'si','Tabela naroÄil',0),(553550,15377,'ba','Pesanan tabel',0),(553551,15377,'nl','Ordertabel',0),(553552,15377,'fi','Tilaukset-taulukko',0),(553553,15377,'no','Ordrer-tabellen',0),(553554,15377,'da','Ordretabellen',0),(553555,15377,'ko','Orders í…Œì´ë¸”',0),(553556,15377,'he','×”×˜×‘×œ×” orders',0),(553557,15377,'el','Î Î¯Î½Î±ÎºÎ±Ï‚ \"Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚\"',0),(553558,15377,'zh','è®¢å•è¡¨',0),(553559,15377,'sv','Ordertabellen',0),(553560,15377,'it','Tabella ordini',0),(553561,15377,'tl','',0),(553562,15377,'th','à¸•à¸²à¸£à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(553563,15377,'hi','à¤†à¤¦à¥‡à¤¶ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553564,15377,'ms','Jadual pesanan',0),(553565,15377,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ø·Ù„Ø¨ÙŠØ§Øª',0),(553566,15377,'fr','Tableau de commandes',0),(553567,15377,'jp','[å—æ³¨] ãƒ†ãƒ¼ãƒ–ãƒ«',0),(553568,15377,'pt','Tabela de ordens',0),(553569,15377,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Â«Ð—Ð°ÐºÐ°Ð·Ñ‹Â»',0),(553570,15377,'es','Tabla Orders',0),(553571,15377,'de','Tabelle \"Bestellungen\"',0),(553572,15377,'en','Orders Table',0),(553573,15378,'is','',0),(553574,15378,'dr','Ø¬Ø¯ÙˆÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(553575,15378,'pr','Ø¬Ø¯ÙˆÙ„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(553576,15378,'tr','Ã–deme tablosu',0),(553577,15378,'pl','Tabela wypÅ‚at',0),(553578,15378,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(553579,15378,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Ø§ Ø¬Ø¯ÙˆÙ„',0),(553580,15378,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° Ð¸ÑÐ¿Ð»Ð°Ñ‚Ð°',0),(553581,15378,'vi','Thanh toÃ¡n Table',0),(553582,15378,'af','Betalings tabel',0),(553583,15378,'ro','Tabelul de plÄƒÅ£i',0),(553584,15378,'et','Maksete tabel',0),(553585,15378,'si','Tabele plaÄil',0),(553586,15378,'ba','Tabel pembayaran',0),(553587,15378,'nl','Tabel van de betalingen',0),(553588,15378,'fi','Maksut taulukko',0),(553589,15378,'no','Betalinger tabell',0),(553590,15378,'da','Betalinger tabel',0),(553591,15378,'ko','ì§€ë¶ˆ í…Œì´ë¸”',0),(553592,15378,'he','×˜×‘×œ×” ×ª×©×œ×•×ž×™×',0),(553593,15378,'el','Î Î¯Î½Î±ÎºÎ±Ï‚ Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(553594,15378,'zh','ä»˜æ¬¾è¡¨',0),(553595,15378,'sv','Betalningar tabell',0),(553596,15378,'it','Tabella pagamenti',0),(553597,15378,'tl','',0),(553598,15378,'th','à¸•à¸²à¸£à¸²à¸‡à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(553599,15378,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553600,15378,'ms','Jadual pembayaran',0),(553601,15378,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª',0),(553602,15378,'fr','Tableau des paiements',0),(553603,15378,'jp','æ”¯æ‰•ãƒ†ãƒ¼ãƒ–ãƒ«',0),(553604,15378,'pt','Tabela de pagamentos',0),(553605,15378,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(553606,15378,'es','Tabla de pagos',0),(553607,15378,'de','Zahlungen-Tabelle',0),(553608,15378,'en','Payments Table',0),(553609,15379,'is','',0),(553610,15379,'dr','Ø¬Ø¯ÙˆÙ„ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(553611,15379,'pr','Ø¬Ø¯ÙˆÙ„ Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(553612,15379,'tr','Ã–deme planlarÄ± tablo',0),(553613,15379,'pl','Tabela planÃ³w pÅ‚atnoÅ›ci',0),(553614,15379,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾ Ð¿Ð»Ð°Ð½Ð¾Ð²Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(553615,15379,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù…Ù†ØµÙˆØ¨Û Ø¨Ù†Ø¯ÛŒ Ø¬Ø¯ÙˆÙ„',0),(553616,15379,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° Ð¿Ð»Ð°Ð½Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(553617,15379,'vi','Thanh toÃ¡n káº¿ hoáº¡ch báº£ng',0),(553618,15379,'af','Betaling planne tabel',0),(553619,15379,'ro','Tabel de planuri de platÄƒ',0),(553620,15379,'et','Maksmine kavad tabel',0),(553621,15379,'si','Tabela plaÄilo naÄrtov',0),(553622,15379,'ba','Tabel pembayaran rencana',0),(553623,15379,'nl','Betaling plannen tabel',0),(553624,15379,'fi','Maksu suunnitelmat taulukko',0),(553625,15379,'no','Betaling planer tabell',0),(553626,15379,'da','Betaling planer tabel',0),(553627,15379,'ko','ì§€ë¶ˆ ê³„íš í‘œ',0),(553628,15379,'he','×”×ª×©×œ×•× ×ª×•×›× ×™×•×ª ×©×•×œ×—×Ÿ',0),(553629,15379,'el','Î Î¯Î½Î±ÎºÎ±Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ ÏƒÏ‡Î­Î´Î¹Î±',0),(553630,15379,'zh','ä»˜æ¬¾è®¡åˆ’è¡¨',0),(553631,15379,'sv','Betalning planer tabell',0),(553632,15379,'it','Tabella di piani di pagamento',0),(553633,15379,'tl','',0),(553634,15379,'th','à¸•à¸²à¸£à¸²à¸‡à¹à¸œà¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(553635,15379,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¯à¥‹à¤œà¤¨à¤¾ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553636,15379,'ms','Jadual pelan pembayaran',0),(553637,15379,'ar','Ø¬Ø¯ÙˆÙ„ Ø®Ø·Ø· Ø§Ù„Ø¯ÙØ¹',0),(553638,15379,'fr','Table de Plans de paiement',0),(553639,15379,'jp','æ”¯æ‰•è¨ˆç”»è¡¨',0),(553640,15379,'pt','Tabela de planos de pagamento',0),(553641,15379,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ð¿Ð»Ð°Ð½Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(553642,15379,'es','Tabla de planes de pago',0),(553643,15379,'de','Zahlung PlÃ¤ne Tabelle',0),(553644,15379,'en','Payment Plans Table',0),(553645,15380,'is','',0),(553646,15380,'dr','Ø¬Ø¯ÙˆÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÛŒØ¯',0),(553647,15380,'pr','Ø¬Ø¯ÙˆÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÛŒØ¯',0),(553648,15380,'tr','SatÄ±nalma sipariÅŸleri tablosu',0),(553649,15380,'pl','Tabela zamÃ³wienia zakupu',0),(553650,15380,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(553651,15380,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø¬Ø¯ÙˆÙ„',0),(553652,15380,'sr','\"Ð˜Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ\"',0),(553653,15380,'vi','Mua hÃ ng Ä‘Æ¡n Ä‘áº·t hÃ ng báº£ng',0),(553654,15380,'af','Aankoop bestellings tabel',0),(553655,15380,'ro','Tabelul de comenzi de cumpÄƒrare',0),(553656,15380,'et','Ostu tabeli Tellimused',0),(553657,15380,'si','Tabela naroÄil za nakup',0),(553658,15380,'ba','Tabel pesanan pembelian',0),(553659,15380,'nl','Aankoop ordertabel',0),(553660,15380,'fi','Ostaa Tilaukset-taulukon',0),(553661,15380,'no','KjÃ¸p ordretabellen',0),(553662,15380,'da','KÃ¸b ordretabellen',0),(553663,15380,'ko','êµ¬ë§¤ ì£¼ë¬¸ í…Œì´ë¸”',0),(553664,15380,'he','×˜×‘×œ×ª ×”×–×ž× ×•×ª ×¨×›×©',0),(553665,15380,'el','Î‘Î³Î¿ÏÎ¬ Ï„Î¿Ï… Ï€Î¯Î½Î±ÎºÎ± \"Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚\"',0),(553666,15380,'zh','é‡‡è´­è®¢å•è¡¨',0),(553667,15380,'sv','KÃ¶p Order-tabellen',0),(553668,15380,'it','Tabella di ordini di acquisto',0),(553669,15380,'tl','',0),(553670,15380,'th','à¸•à¸²à¸£à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(553671,15380,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553672,15380,'ms','Jadual pesanan pembelian',0),(553673,15380,'ar','Ø¬Ø¯ÙˆÙ„ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(553674,15380,'fr','Table de commandes d\'achat',0),(553675,15380,'jp','è³¼å…¥æ³¨æ–‡ãƒ†ãƒ¼ãƒ–ãƒ«',0),(553676,15380,'pt','Tabela de pedidos de compra',0),(553677,15380,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(553678,15380,'es','Tabla de pedidos de compra',0),(553679,15380,'de','Tabelle \"Bestellungen\" kaufen',0),(553680,15380,'en','Purchase Orders Table',0),(553681,15381,'is','',0),(553682,15381,'dr','Ø¬Ø¯ÙˆÙ„ ÙØ±ÙˆØ´ Ù¾Ø±Ø³Ù†Ù„',0),(553683,15381,'pr','Ø¬Ø¯ÙˆÙ„ ÙØ±ÙˆØ´ Ù¾Ø±Ø³Ù†Ù„',0),(553684,15381,'tr','SatÄ±ÅŸ personeli tablo',0),(553685,15381,'pl','Tabela sprzedaÅ¼y personelu',0),(553686,15381,'bg','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð» Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(553687,15381,'ur','Ø³ÛŒÙ„Ø² Ú©Û’ Ø§ÛÙ„Ú©Ø§Ø±ÙˆÚº Ú©ÛŒ Ù…ÛŒØ²',0),(553688,15381,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ð¾Ð¼ Ð¾ÑÐ¾Ð±Ñ™Ñƒ',0),(553689,15381,'vi','NhÃ¢n viÃªn bÃ¡n hÃ ng báº£ng',0),(553690,15381,'af','Verkope personeel tabel',0),(553691,15381,'ro','Tabelul de personal de vÃ¢nzÄƒri',0),(553692,15381,'et','MÃ¼Ã¼gipersonalile tabel',0),(553693,15381,'si','Prodajno osebje tabele',0),(553694,15381,'ba','Tabel personil penjualan',0),(553695,15381,'nl','Verkooppersoneel tabel',0),(553696,15381,'fi','Myynnin henkilÃ¶stÃ¶-taulukkoon',0),(553697,15381,'no','Selgerne tabell',0),(553698,15381,'da','Salgspersonalet tabel',0),(553699,15381,'ko','íŒë§¤ ì§ì› í…Œì´ë¸”',0),(553700,15381,'he','×× ×©×™ ×ž×›×™×¨×•×ª ×˜×‘×œ×”',0),(553701,15381,'el','Î Î¯Î½Î±ÎºÎ± Ï€ÏÎ¿ÏƒÏ‰Ï€Î¹ÎºÎ¿Ï Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(553702,15381,'zh','é”€å”®äººå‘˜è¡¨',0),(553703,15381,'sv','FÃ¶rsÃ¤ljningspersonal tabell',0),(553704,15381,'it','Tabella del personale di vendita',0),(553705,15381,'tl','',0),(553706,15381,'th','à¸•à¸²à¸£à¸²à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢',0),(553707,15381,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤°à¥à¤®à¤¿à¤¯à¥‹à¤‚ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553708,15381,'ms','Jadual kakitangan jualan',0),(553709,15381,'ar','Ø¬Ø¯ÙˆÙ„ Ù…ÙˆØ¸ÙÙŠ Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(553710,15381,'fr','Tableau du Personnel de vente',0),(553711,15381,'jp','å–¶æ¥­æ‹…å½“è€…è¡¨',0),(553712,15381,'pt','Tabela de vendas pessoal',0),(553713,15381,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¿ÐµÑ€ÑÐ¾Ð½Ð°Ð»',0),(553714,15381,'es','Tabla de personal de ventas',0),(553715,15381,'de','Verkaufspersonal Tabelle',0),(553716,15381,'en','Sales Personnel Table',0),(553717,15382,'is','',0),(553718,15382,'dr','Ø¬Ø¯ÙˆÙ„ Timeclock',0),(553719,15382,'pr','Ø¬Ø¯ÙˆÙ„ Timeclock',0),(553720,15382,'tr','TimeClock tablo',0),(553721,15382,'pl','TimeClock tabeli',0),(553722,15382,'bg','TimeClock Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(553723,15382,'ur','Ù¹Ø§Ù…ÛŒÚ©Ù„ÙˆÚ©Ú© Ù¹ÛŒØ¨Ù„',0),(553724,15382,'sr','Ð¢Ð¸Ð¼ÐµÑ†Ð»Ð¾Ñ†Ðº ÑÑ‚Ð¾Ð»Ð°',0),(553725,15382,'vi','Timeclock báº£ng',0),(553726,15382,'af','Timeclock tafel',0),(553727,15382,'ro','Ceas masa',0),(553728,15382,'et','TimeClock tabel',0),(553729,15382,'si','TimeClock tabele',0),(553730,15382,'ba','Meja timeclock',0),(553731,15382,'nl','Tabel klok',0),(553732,15382,'fi','Timeclock taulukko',0),(553733,15382,'no','TimeClock tabell',0),(553734,15382,'da','Timeclock tabel',0),(553735,15382,'ko','Timeclock í…Œì´ë¸”',0),(553736,15382,'he','Timeclock ×©×•×œ×—×Ÿ',0),(553737,15382,'el','Timeclock Ï€Î¯Î½Î±ÎºÎ±',0),(553738,15382,'zh','æ‰“å¡é’Ÿè¡¨',0),(553739,15382,'sv','Timeclock tabell',0),(553740,15382,'it','Tabella Timeclock',0),(553741,15382,'tl','',0),(553742,15382,'th','à¸•à¸²à¸£à¸²à¸‡ Timeclock',0),(553743,15382,'hi','Timeclock à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553744,15382,'ms','Jadual Timeclock',0),(553745,15382,'ar','Ø¬Ø¯ÙˆÙ„ ØªÙŠÙ…ÙŠÙƒÙ„ÙˆÙƒ',0),(553746,15382,'fr','Timeclock Table',0),(553747,15382,'jp','ã‚¿ã‚¤ãƒ ã‚¯ ãƒ­ãƒƒã‚¯ ãƒ†ãƒ¼ãƒ–ãƒ«',0),(553748,15382,'pt','Tabela de timeclock',0),(553749,15382,'ru','TimeClock Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(553750,15382,'es','Reloj de mesa',0),(553751,15382,'de','Timeclock Tabelle',0),(553752,15382,'en','Timeclock Table',0),(553753,15383,'is','',0),(553754,15383,'dr','Ø¬Ø¯ÙˆÙ„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(553755,15383,'pr','Ø¬Ø¯ÙˆÙ„ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(553756,15383,'tr','SatÄ±cÄ± faturalarÄ± tablo',0),(553757,15383,'pl','Tabela dostawcy rachunki',0),(553758,15383,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ Ð¾Ñ‚ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð°',0),(553759,15383,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ø¬Ø¯ÙˆÙ„',0),(553760,15383,'sr','Ð¢Ð°Ð±ÐµÐ»Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(553761,15383,'vi','NhÃ  cung cáº¥p hÃ³a Ä‘Æ¡n báº£ng',0),(553762,15383,'af','Handelaar tabel van rekeninge',0),(553763,15383,'ro','Furnizor facturi tabel',0),(553764,15383,'et','Tabeli hankija arveid',0),(553765,15383,'si','Tabelo dobavitelj menice',0),(553766,15383,'ba','Penjual tagihan Meja',0),(553767,15383,'nl','Tabel Leverancier rekeningen',0),(553768,15383,'fi','Laskut toimittajataulu',0),(553769,15383,'no','Regninger leverandÃ¸rtabellen',0),(553770,15383,'da','LeverandÃ¸rtabellen regninger',0),(553771,15383,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ í…Œì´ë¸”',0),(553772,15383,'he','×˜×‘×œ×” ×—×©×‘×•× ×•×ª ×¡×¤×§×™×',0),(553773,15383,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¯Î½Î±ÎºÎ± \"Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®Ï‚\"',0),(553774,15383,'zh','ä¾›åº”å•†è´¦å•è¡¨',0),(553775,15383,'sv','LeverantÃ¶rsregistret rÃ¤kningar',0),(553776,15383,'it','Tabella Vendor bollette',0),(553777,15383,'tl','',0),(553778,15383,'th','à¸•à¸²à¸£à¸²à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸•à¸±à¹‹à¸§',0),(553779,15383,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553780,15383,'ms','Jadual bil-bil vendor',0),(553781,15383,'ar','Ø¬Ø¯ÙˆÙ„ ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙˆØ±Ø¯',0),(553782,15383,'fr','Table de factures fournisseur',0),(553783,15383,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸ãƒ†ãƒ¼ãƒ–ãƒ«',0),(553784,15383,'pt','Tabela de notas de Vendor',0),(553785,15383,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(553786,15383,'es','Tabla de facturas de proveedor',0),(553787,15383,'de','Vendor-Rechnungen-Tabelle',0),(553788,15383,'en','Vendor Bills Table',0),(553789,15384,'is','',0),(553790,15384,'dr','Ø¬Ø¯ÙˆÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(553791,15384,'pr','Ø¬Ø¯ÙˆÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(553792,15384,'tr','SatÄ±cÄ± tablo',0),(553793,15384,'pl','Tabela dostawcy',0),(553794,15384,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð° \"Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº\"',0),(553795,15384,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¬Ø¯ÙˆÙ„',0),(553796,15384,'sr','\"Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡\"',0),(553797,15384,'vi','NhÃ  cung cáº¥p bÃ n',0),(553798,15384,'af','Handelaar tabel',0),(553799,15384,'ro','Furnizor de masÄƒ',0),(553800,15384,'et','Tabeli hankija',0),(553801,15384,'si','Tabelo dobavitelj',0),(553802,15384,'ba','Penjual tabel',0),(553803,15384,'nl','Tabel Leverancier',0),(553804,15384,'fi','Toimittaja-taulukosta',0),(553805,15384,'no','LeverandÃ¸r-tabellen',0),(553806,15384,'da','LeverandÃ¸rtabellen',0),(553807,15384,'ko','ê³µê¸‰ ì—…ì²´ í…Œì´ë¸”',0),(553808,15384,'he','×©×•×œ×—×Ÿ ×”×¡×¤×§',0),(553809,15384,'el','Î Î¯Î½Î±ÎºÎ± \"Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®Ï‚\"',0),(553810,15384,'zh','ä¾›åº”å•†è¡¨',0),(553811,15384,'sv','LeverantÃ¶rsregistret',0),(553812,15384,'it','Tabella Vendor',0),(553813,15384,'tl','',0),(553814,15384,'th','à¸•à¸²à¸£à¸²à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(553815,15384,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(553816,15384,'ms','Jadual Penjual',0),(553817,15384,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ†',0),(553818,15384,'fr','Table Vendor',0),(553819,15384,'jp','ä»•å…¥å…ˆãƒ†ãƒ¼ãƒ–ãƒ«',0),(553820,15384,'pt','Tabela de fornecedor',0),(553821,15384,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº',0),(553822,15384,'es','Tabla de fabricante',0),(553823,15384,'de','Vendor-Tabelle',0),(553824,15384,'en','Vendor Table',0),(553825,15385,'is','',0),(553826,15385,'dr','Ø­Ø§Ù„Øª Ù‡Ø§ÛŒ Ø¢Ø±Ø§Ù… CPU',0),(553827,15385,'pr','Ø­Ø§Ù„Øª Ù‡Ø§ÛŒ Ø¢Ø±Ø§Ù… CPU',0),(553828,15385,'tr','YavaÅŸ CPU modu',0),(553829,15385,'pl','Powolny tryb procesora',0),(553830,15385,'bg','Ð‘Ð°Ð²ÐµÐ½ CPU Ñ€ÐµÐ¶Ð¸Ð¼',0),(553831,15385,'ur','CPU Ú©Û’ Ø³Ø³Øª Ù…ÙˆÚˆ',0),(553832,15385,'sr','Ð¡Ð¿Ð¾Ñ€Ð¾ Ð¦ÐŸÐ£ Ñ€ÐµÐ¶Ð¸Ð¼',0),(553833,15385,'vi','Cháº­m CPU cháº¿ Ä‘á»™',0),(553834,15385,'af','Stadige SVE modus',0),(553835,15385,'ro','Lent CPU modul',0),(553836,15385,'et','Aeglase CPU reÅ¾iim',0),(553837,15385,'si','PoÄasi CPU naÄin',0),(553838,15385,'ba','Lambat CPU Mode',0),(553839,15385,'nl','Trage CPU modus',0),(553840,15385,'fi','Hidas CPU tila',0),(553841,15385,'no','Langsom modus',0),(553842,15385,'da','Langsom CPU tilstand',0),(553843,15385,'ko','ëŠë¦° CPU ëª¨ë“œ',0),(553844,15385,'he','×ž×¦×‘ ×”×ž×¢×‘×“ ××™×˜×™',0),(553845,15385,'el','Î‘ÏÎ³Î® Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î± CPU',0),(553846,15385,'zh','ç¼“æ…¢çš„ CPU æ¨¡å¼',0),(553847,15385,'sv','LÃ¥ngsam CPU lÃ¤ge',0),(553848,15385,'it','ModalitÃ  CPU lenta',0),(553849,15385,'tl','',0),(553850,15385,'th','à¹‚à¸«à¸¡à¸” CPU à¸Šà¹‰à¸²',0),(553851,15385,'hi','à¤§à¥€à¤®à¥€ CPU à¤®à¥‹à¤¡',0),(553852,15385,'ms','Perlahan CPU mod',0),(553853,15385,'ar','ÙˆØ¶Ø¹ ÙˆØ­Ø¯Ø© Ø§Ù„Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„Ù…Ø±ÙƒØ²ÙŠØ© Ø¨Ø·ÙŠØ¦Ø©',0),(553854,15385,'fr','Mode \"escargot\" CPU',0),(553855,15385,'jp','ä½Žé€Ÿã® CPU ãƒ¢ãƒ¼ãƒ‰',0),(553856,15385,'pt','Lento modo de CPU',0),(553857,15385,'ru','ÐœÐµÐ´Ð»ÐµÐ½Ð½Ñ‹Ð¹ Ñ€ÐµÐ¶Ð¸Ð¼ Ð¿Ñ€Ð¾Ñ†ÐµÑÑÐ¾Ñ€Ð°',0),(553858,15385,'es','Modo de CPU lento',0),(553859,15385,'de','Langsame CPU-Modus',0),(553860,15385,'en','Slow CPU Mode',0),(553861,15386,'is','',0),(553862,15386,'dr','Ø¨Ø±Ø§ÛŒ Ø§Ø·Ù…ÛŒÙ†Ø§Ù† Ø§Ø² ØµØ­ÛŒØ­ Ú†Ø§Ù¾ Ù„Ø·ÙØ§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú†Ø§Ù¾ Ø§Ø² Ù…Ù†ÙˆÛŒ Ù„ÛŒÙ†Ú©',0),(553863,15386,'pr','Ø¨Ø±Ø§ÛŒ Ø§Ø·Ù…ÛŒÙ†Ø§Ù† Ø§Ø² ØµØ­ÛŒØ­ Ú†Ø§Ù¾ Ù„Ø·ÙØ§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ú†Ø§Ù¾ Ø§Ø² Ù…Ù†ÙˆÛŒ Ù„ÛŒÙ†Ú©',0),(553864,15386,'tr','Emin olmak iÃ§in doÄŸru bir baskÄ± lÃ¼tfen kullanÄ±n baÄŸlantÄ±lar menÃ¼sÃ¼nden YazdÄ±r',0),(553865,15386,'pl','W celu zapewnienia prawidÅ‚owego wydruku proszÄ™ uÅ¼yÄ‡ Drukuj z Menu linki',0),(553866,15386,'bg','Ð—Ð° Ð´Ð° Ð³Ð°Ñ€Ð°Ð½Ñ‚Ð¸Ñ€Ð° Ð¿Ñ€Ð°Ð²Ð¸Ð»ÐµÐ½ Ð¿ÐµÑ‡Ð°Ñ‚ Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¾Ñ‚ Ð¼ÐµÐ½ÑŽÑ‚Ð¾ Ð²Ñ€ÑŠÐ·ÐºÐ¸',0),(553867,15386,'ur','ÛŒÙ‚ÛŒÙ†ÛŒ Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© ØµØ­ÛŒØ­ Ú†Ú¾Ø§Ù¾ÛŒÚº Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº Ø³Û’ Ø±ÙˆØ§Ø¨Ø· Ú©Û’ Ù…ÛŒÙ†ÛŒÙˆ Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(553868,15386,'sr','Ð”Ð° ÑÐµ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð° Ð¸ÑÐ¿Ñ€Ð°Ð²Ð°Ð½ Ð¾Ñ‚Ð¸ÑÐ°Ðº ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚Ðµ ÐŸÑ€Ð¸Ð½Ñ‚ Ð¸Ð· Ð¼ÐµÐ½Ð¸Ñ˜Ð° Ð²ÐµÐ·Ðµ',0),(553869,15386,'vi','Äá»ƒ Ä‘áº£m báº£o má»™t in chÃ­nh xÃ¡c xin vui lÃ²ng sá»­ dá»¥ng in tá»« Menu liÃªn káº¿t',0),(553870,15386,'af','Om te verseker \'n korrekte druk gebruik asseblief druk uit die skakels-kieslys',0),(553871,15386,'ro','Pentru a asigura o imprimare corecte vÄƒ rugÄƒm sÄƒ folosiÅ£i tipar din meniul de link-uri',0),(553872,15386,'et','Tagada korrektne Print Palun kasutage linkide menÃ¼Ã¼st Prindi',0),(553873,15386,'si','Za zagotovitev pravilne Print uporabite Natisni v meniju povezave',0),(553874,15386,'ba','Untuk memastikan cetak yang benar gunakan cetak dari link Menu',0),(553875,15386,'nl','Om ervoor te zorgen een juiste afdruk gebruik afdrukken in het Menu Links',0),(553876,15386,'fi','Varmistaaksesi oikea tulosta, kÃ¤ytÃ¤ tulostaa Links-valikosta',0),(553877,15386,'no','For Ã¥ sikre en korrekt utskrift bruk Print menyen i koblinger',0),(553878,15386,'da','For at sikre en korrekt udskrivning skal du bruge Udskriv fra menuen Links',0),(553879,15386,'ko','ì •í™•í•œ ì¸ì‡„ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤ ì‚¬ìš© í•˜ ì—¬ ë§í¬ ë©”ë‰´ì—ì„œ ì¸ì‡„',0),(553880,15386,'he','×›×“×™ ×œ×”×‘×˜×™×— ×”×“×¤×¡×” × ×›×•× ×” ×× × ×”×©×ª×ž×© ×”×“×¤×¡ ×ž×ª×•×š ×ª×¤×¨×™×˜ ×§×™×©×•×¨×™×',0),(553881,15386,'el','ÎÎ± ÎµÎ¾Î±ÏƒÏ†Î±Î»Î¯ÏƒÎµÎ¹ Î¼Î¹Î± ÏƒÏ‰ÏƒÏ„Î® ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï€Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î·Î½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Î±Ï€ÏŒ Ï„Î¿ Î¼ÎµÎ½Î¿Ï \"ÏƒÏ…Î½Î´Î­ÏƒÎµÎ¹Ï‚\"',0),(553882,15386,'zh','ç¡®ä¿æ­£ç¡®æ‰“å°ï¼Œè¯·ä½¿ç”¨æ‰“å°ä»Žé“¾æŽ¥èœå•',0),(553883,15386,'sv','FÃ¶r att sÃ¤kerstÃ¤lla en korrekt utskrift AnvÃ¤nd Print meny',0),(553884,15386,'it','Per garantire una corretta stampa utilizzare Print dal Menu collegamenti',0),(553885,15386,'tl','',0),(553886,15386,'th','à¹€à¸žà¸·à¹ˆà¸­à¹ƒà¸«à¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸§à¹ˆà¸² à¸žà¸´à¸¡à¸žà¹Œà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡à¸à¸£à¸¸à¸“à¸²à¹ƒà¸Šà¹‰à¸žà¸´à¸¡à¸žà¹Œà¸ˆà¸²à¸à¹€à¸¡à¸™à¸¹à¸¥à¸´à¸‡à¸„à¹Œ',0),(553887,15386,'hi','à¤¯à¤¹ à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤¸à¤¹à¥€ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤²à¤¿à¤‚à¤•à¥à¤¸ à¤®à¥‡à¤¨à¥‚ à¤¸à¥‡ à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ',0),(553888,15386,'ms','Memastikan cetakan yang betul Sila gunakan Print dari Menu pautan',0),(553889,15386,'ar','Ù„Ù„ØªØ£ÙƒØ¯ Ù…Ù† Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø·Ø¨Ø§Ø¹Ø© ØµØ­ÙŠØ­Ø© Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø·Ø¨Ø§Ø¹Ø© Ù…Ù† Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø±ÙˆØ§Ø¨Ø·',0),(553890,15386,'fr','Pour garantir une impression correcte utilisez s\'il vous plaÃ®t imprimer dans le Menu liens',0),(553891,15386,'jp','ç¢ºå®Ÿã«æ­£ã—ã„å°åˆ·ã¯ãƒªãƒ³ã‚¯ ãƒ¡ãƒ‹ãƒ¥ãƒ¼ã‹ã‚‰ãƒ—ãƒªãƒ³ãƒˆã‚’ä½¿ç”¨ã—ã¦ãã ã•ã„ã€‚',0),(553892,15386,'pt','Para garantir uma impressÃ£o correta por favor usar Print do Menu Links',0),(553893,15386,'ru','Ð”Ð»Ñ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ñ Ð¿Ñ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ð¾Ð¹ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ Ð¸Ð· Ð¼ÐµÐ½ÑŽ ÑÑÑ‹Ð»ÐºÐ¸',0),(553894,15386,'es','Para garantizar una impresiÃ³n correcta utilice Print en el menÃº de enlaces',0),(553895,15386,'de','Damit eine richtige Print verwenden Bitte drucken aus dem MenÃ¼ des VerknÃ¼pfungenbedienfelds',0),(553896,15386,'en','To Ensure A Correct Print Please Use Print From The Links Menu',0),(553897,15387,'is','',0),(553898,15387,'dr','Ù†Ù…Ø§ÛŒØ´ Ø­Ø³Ø§Ø¨ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³ Ø¨Ø± Ø±ÙˆÛŒ ÙØ§Ú©ØªÙˆØ± PDF Ø§Ú¯Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(553899,15387,'pr','Ù†Ù…Ø§ÛŒØ´ Ø­Ø³Ø§Ø¨ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³ Ø¨Ø± Ø±ÙˆÛŒ ÙØ§Ú©ØªÙˆØ± PDF Ø§Ú¯Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(553900,15387,'tr','UPS Hesap fatura PDF gÃ¶stermek EÄŸer ayarla',0),(553901,15387,'pl','PokaÅ¼ konta UPS na fakturze PDF JeÅ›li zestaw',0),(553902,15387,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ UPS ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° PDF ÐÐºÐ¾ Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ',0),(553903,15387,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ PDF Ù¾Ø± UPS Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº Ø§Ú¯Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(553904,15387,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð£ÐŸÐ¡ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ ÐŸÐ”Ð¤ Ð°ÐºÐ¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ',0),(553905,15387,'vi','Hiá»ƒn thá»‹ tÃ i khoáº£n UPS trÃªn hÃ³a Ä‘Æ¡n PDF náº¿u thiáº¿t',0),(553906,15387,'af','Onderbrekinglose Kragtoevoer rekening wys op die faktuur PDF as stel',0),(553907,15387,'ro','AratÄƒ cont UPS pe facturÄƒ PDF dacÄƒ setaÅ£i',0),(553908,15387,'et','Kuva UPS konto arve PDF kui seada',0),(553909,15387,'si','Razstava UPS raÄun na raÄun PDF ÄŒe nastavite',0),(553910,15387,'ba','Tampilkan akun UPS di faktur PDF jika menetapkan',0),(553911,15387,'nl','UPS-klantennummer Toon op factuur PDF als instellen',0),(553912,15387,'fi','NÃ¤yttÃ¤Ã¤ UPS-asiakasnumero laskun PDF jos asettaa',0),(553913,15387,'no','Viser UPS konto faktura PDF hvis angitt',0),(553914,15387,'da','Vis UPS konto pÃ¥ fakturaen PDF hvis indstillet',0),(553915,15387,'ko','UPS ê³„ì • ì¸ë³´ì´ìŠ¤ PDFì— í‘œì‹œ í•˜ëŠ” ê²½ìš° ì„¤ì •',0),(553916,15387,'he','×”×¦×’ ×—×©×‘×•×Ÿ UPS ×‘×—×©×‘×•× ×™×ª PDF ×× ×œ×”×’×“×™×¨',0),(553917,15387,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ UPS ÏƒÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ PDF Î±Î½ Î¿ÏÎ¯ÏƒÎµÏ„Îµ',0),(553918,15387,'zh','åœ¨ PDF å‘ç¥¨ä¸Šæ˜¾ç¤ºçš„ UPS å¸æˆ·å¦‚æžœè®¾ç½®',0),(553919,15387,'sv','Visa UPS-konto pÃ¥ faktura PDF om StÃ¤ll',0),(553920,15387,'it','Visualizza il codice cliente UPS sulla fattura PDF se impostato',0),(553921,15387,'tl','',0),(553922,15387,'th','à¹à¸ªà¸”à¸‡à¸šà¸±à¸à¸Šà¸µ UPS à¹ƒà¸™à¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ PDF à¸–à¹‰à¸²à¸•à¸±à¹‰à¸‡',0),(553923,15387,'hi','UPS à¤–à¤¾à¤¤à¥‡ à¤ªà¥€à¤¡à¥€à¤à¤« à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤ à¤¯à¤¦à¤¿ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(553924,15387,'ms','Tunjuk up akaun invois PDF jika ditetapkan',0),(553925,15387,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø­Ø³Ø§Ø¨ UPS Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø© PDF Ø¥Ø°Ø§ ÙƒØ§Ù† ØªØ¹ÙŠÙŠÙ†',0),(553926,15387,'fr','Voir l\'Ã©tablissement compte UPS sur facture PDF Si la valeur',0),(553927,15387,'jp','PDF è«‹æ±‚æ›¸ã« UPS ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’è¡¨ç¤ºå ´åˆè¨­å®š',0),(553928,15387,'pt','Mostrar conta UPS na factura PDF se definir',0),(553929,15387,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÑ‡ÐµÑ‚ UPS Ð½Ð° ÑÑ‡ÐµÑ‚Ð° PDF ÐµÑÐ»Ð¸ Ð·Ð°Ð´Ð°Ñ‚ÑŒ',0),(553930,15387,'es','Mostrar cuenta de UPS en factura PDF si establece',0),(553931,15387,'de','UPS Kundennummer auf Rechnung PDF anzeigen Wenn festgelegt',0),(553932,15387,'en','Show UPS Account On Invoice PDF If Set',0),(553933,15388,'is','',0),(553934,15388,'dr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù‡Ø²ÛŒÙ†Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ù‡ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³',0),(553935,15388,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù‡Ø²ÛŒÙ†Ù‡ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø¨Ù‡ ÛŒÙˆ Ù¾ÛŒ Ø§Ø³',0),(553936,15388,'tr','Fatura iÃ§in UPS navlun Ã¼cretleri',0),(553937,15388,'pl','OpÅ‚aty frachtowe zapowiadane do UPS',0),(553938,15388,'bg','Ð¢Ð¾Ð²Ð°Ñ€ÐµÐ½ Ñ‚Ð°ÐºÑÐ¸, Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð·Ð° UPS',0),(553939,15388,'ur','UPS Ú©Û’ Ø¨Ø§Ù„Ù„Ø§Ø¯ Ø³Ø§Ù…Ø§Ù† Ú©Û’ Ø§Ù„Ø²Ø§Ù…Ø§Øª',0),(553940,15388,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð° Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð£ÐŸÐ¡-Ð°',0),(553941,15388,'vi','Chi phÃ­ váº­n chuyá»ƒn hÃ ng hÃ³a láº­p hoÃ¡ Ä‘Æ¡n cho UPS',0),(553942,15388,'af','Vrag koste weerspieÃ«l om onderbrekinglose Kragtoevoer',0),(553943,15388,'ro','Taxele de transport facturate la UPS',0),(553944,15388,'et','Lasti tasu arve UPS',0),(553945,15388,'si','StroÅ¡ki prevoza, ki se zaraÄunavajo za UPS',0),(553946,15388,'ba','Biaya pengiriman yang ditagih ke UPS',0),(553947,15388,'nl','Vrachtkosten gefactureerd aan UPS',0),(553948,15388,'fi','Rahtikulut laskutetaan UPS',0),(553949,15388,'no','Frakt avgifter faktureres til UPS',0),(553950,15388,'da','Fragtgebyrer faktureres til UPS',0),(553951,15388,'ko','UPSì— ì²­êµ¬ ìš´ì†¡ ë¹„ìš©',0),(553952,15388,'he','×”×•×¦××•×ª ×”×•×‘×œ×” ×œ×—×™×™×‘ UPS',0),(553953,15388,'el','ÎÎ±ÏÎ»Ï‰Î½ Ï€Î¿Ï… Ï‡ÏÎµÏŽÎ½Î¿Ï…Î½ UPS',0),(553954,15388,'zh','è¿è´¹å‘ UPS è®°å¸',0),(553955,15388,'sv','Fraktkostnaden faktureras till UPS',0),(553956,15388,'it','Spese di trasporto fatturate a UPS',0),(553957,15388,'tl','',0),(553958,15388,'th','à¸„à¹ˆà¸²à¸‚à¸™à¸ªà¹ˆà¸‡à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹„à¸›',0),(553959,15388,'hi','à¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤² à¤­à¥‡à¤œà¤¾ à¤®à¤¾à¤² à¤¢à¥à¤²à¤¾à¤ˆ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(553960,15388,'ms','Caj pengangkutan yang dibilkan kepada up',0),(553961,15388,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø´Ø­Ù† ÙØ§ØªÙˆØ±Ø© Ù„Ø´Ø±ÙƒØ© ÙŠÙˆ Ø¨ÙŠ Ø¥Ø³',0),(553962,15388,'fr','Frais de transport facturÃ©s Ã  UPS',0),(553963,15388,'jp','UPS é‹é€æ–™',0),(553964,15388,'pt','Despesas de frete cobradas para UPS',0),(553965,15388,'ru','Ð¤Ñ€Ð°Ñ…Ñ‚, Ð²Ñ‹ÑÑ‚Ð°Ð²Ð»ÐµÐ½ ÑÑ‡ÐµÑ‚ UPS',0),(553966,15388,'es','Fletes facturados a UPS',0),(553967,15388,'de','Frachtkosten in Rechnung gestellt an UPS',0),(553968,15388,'en','Freight Charges Billed To UPS',0),(553969,15389,'is','',0),(553970,15389,'dr','Ø¨Ø®Ø´',0),(553971,15389,'pr','Ø¨Ø®Ø´',0),(553972,15389,'tr','BÃ¶lÃ¼mler',0),(553973,15389,'pl','DziaÅ‚y',0),(553974,15389,'bg','ÐžÑ‚Ð´ÐµÐ»Ð¸',0),(553975,15389,'ur','Ø´Ø¹Ø¨Û Ø¬Ø§Øª',0),(553976,15389,'sr','ÐšÐ°Ñ‚ÐµÐ´Ñ€Ðµ',0),(553977,15389,'vi','Bá»™ pháº­n',0),(553978,15389,'af','Departemente',0),(553979,15389,'ro','Departamente',0),(553980,15389,'et','Osakonnad',0),(553981,15389,'si','Oddelki',0),(553982,15389,'ba','Departemen',0),(553983,15389,'nl','Afdelingen',0),(553984,15389,'fi','Osastot',0),(553985,15389,'no','Avdelinger',0),(553986,15389,'da','Afdelinger',0),(553987,15389,'ko','ë¶€ì„œ',0),(553988,15389,'he','×ž×—×œ×§×•×ª',0),(553989,15389,'el','Î¤Î¼Î®Î¼Î±Ï„Î±',0),(553990,15389,'zh','éƒ¨é—¨',0),(553991,15389,'sv','Avdelningar',0),(553992,15389,'it','Dipartimenti',0),(553993,15389,'tl','',0),(553994,15389,'th','à¹à¸œà¸™à¸',0),(553995,15389,'hi','à¤µà¤¿à¤­à¤¾à¤—à¥‹à¤‚',0),(553996,15389,'ms','Jabatan-Jabatan',0),(553997,15389,'ar','Ø§Ù„Ø¥Ø¯Ø§Ø±Ø§Øª',0),(553998,15389,'fr','MinistÃ¨res',0),(553999,15389,'jp','éƒ¨é–€',0),(554000,15389,'pt','Departamentos',0),(554001,15389,'ru','Ð”ÐµÐ¿Ð°Ñ€Ñ‚Ð°Ð¼ÐµÐ½Ñ‚Ñ‹',0),(554002,15389,'es','Departamentos',0),(554003,15389,'de','Abteilungen',0),(554004,15389,'en','Departments',0),(554005,15390,'is','',0),(554006,15390,'dr','Ú©Ø¯Ù‡Ø§ÛŒ Comp Ú©Ø§Ø±Ú¯Ø±Ø§Ù†',0),(554007,15390,'pr','Ú©Ø¯Ù‡Ø§ÛŒ Comp Ú©Ø§Ø±Ú¯Ø±Ø§Ù†',0),(554008,15390,'tr','Ä°ÅŸÃ§i Comp kodlarÄ±',0),(554009,15390,'pl','Kodami komp pracownikÃ³w',0),(554010,15390,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ‡ÐµÑÐºÐ° Comp ÐºÐ¾Ð´Ð¾Ð²Ðµ',0),(554011,15390,'ur','Ú©Ø§Ø±Ú©Ù†ÙˆÚº Ú©ÛŒ Ú©Ø¹Ù…Ù¾ Ø±Ù…ÙˆØ²',0),(554012,15390,'sr','Ð Ð°Ð´Ð½Ð¸Ñ‡ÐºÐµ Ð¦Ð¾Ð¼Ð¿ ÑˆÐ¸Ñ„Ñ€Ðµ',0),(554013,15390,'vi','CÃ´ng nhÃ¢n Comp mÃ£',0),(554014,15390,'af','Werkers se Comp kodes',0),(554015,15390,'ro','LucrÄƒtorilor Comp coduri',0),(554016,15390,'et','TÃ¶Ã¶tajate Comp koodid',0),(554017,15390,'si','Delavcev Comp kode',0),(554018,15390,'ba','Pekerja Comp kode',0),(554019,15390,'nl','Werknemers Comp Codes',0),(554020,15390,'fi','TyÃ¶ntekijÃ¶iden Comp koodit',0),(554021,15390,'no','Arbeidernes komp koder',0),(554022,15390,'da','Arbejdstagernes Comp koder',0),(554023,15390,'ko','ë…¸ë™ìžì˜ Comp ì½”ë“œ',0),(554024,15390,'he','×§×•×“×™× ×©×œ ×”×¤×•×¢×œ×™× ×§×•×ž×¤',0),(554025,15390,'el','Î•ÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Comp ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚',0),(554026,15390,'zh','å·¥äººçš„ Comp ä»£ç ',0),(554027,15390,'sv','Arbetstagarnas Comp koder',0),(554028,15390,'it','Codici di lavoratori Comp',0),(554029,15390,'tl','',0),(554030,15390,'th','à¸£à¸«à¸±à¸ªà¸„à¹ˆà¸²à¸•à¸­à¸šà¹à¸—à¸™à¸œà¸¹à¹‰à¸›à¸à¸´à¸šà¸±à¸•à¸´à¸‡à¸²à¸™',0),(554031,15390,'hi','à¤¶à¥à¤°à¤®à¤¿à¤• Comp à¤•à¥‹à¤¡à¥à¤¸',0),(554032,15390,'ms','Pekerja Comp kod',0),(554033,15390,'ar','Ø±Ù…ÙˆØ² Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø¹Ù…Ø§Ù„',0),(554034,15390,'fr','Workers\' Comp Codes',0),(554035,15390,'jp','åŠ´åƒè€…ã®ã‚³ãƒ³ãƒ—ã®ã‚³ãƒ¼ãƒ‰',0),(554036,15390,'pt','Comp cÃ³digos trabalhadores',0),(554037,15390,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð² Comp ÐºÐ¾Ð´Ñ‹',0),(554038,15390,'es','CÃ³digos de compensaciÃ³n de trabajadores',0),(554039,15390,'de','Arbeitnehmer-Comp-Codes',0),(554040,15390,'en','Workers\' Comp Codes',0),(554041,15391,'is','',0),(554042,15391,'dr','ÙØ§Ú©ØªÙˆØ± Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§ÛŒØ¯',0),(554043,15391,'pr','ÙØ§Ú©ØªÙˆØ± Ø±Ø§ Ù¾Ø±Ø¯Ø§Ø®Øª Ø´Ø¯Ù‡ Ø¨Ø§ÛŒØ¯',0),(554044,15391,'tr','Ã–deme yapmak iÃ§in fatura tarihinde gÃ¶nderildi',0),(554045,15391,'pl','Faktura musi byÄ‡ wysÅ‚any pocztÄ… wobec dokonaÄ‡ pÅ‚atnoÅ›ci',0),(554046,15391,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(554047,15391,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(554048,15391,'sr','Ð”Ð° Ð±Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(554049,15391,'vi','HÃ³a Ä‘Æ¡n pháº£i Ä‘Æ°á»£c Ä‘Äƒng Ä‘á»ƒ thá»±c hiá»‡n thanh toÃ¡n',0),(554050,15391,'af','Faktuur moet gepos word om die betaling te maak',0),(554051,15391,'ro','Factura trebuie sÄƒ fie Ã®nregistratÄƒ pentru a face plata',0),(554052,15391,'et','Arve konteerimisel makse sooritada',0),(554053,15391,'si','RaÄun morate knjiÅ¾iti plaÄevanje',0),(554054,15391,'ba','Faktur harus dikirim untuk melakukan pembayaran',0),(554055,15391,'nl','Factuur moet worden geboekt om betaling te verrichten',0),(554056,15391,'fi','Lasku on kirjattu maksun',0),(554057,15391,'no','Fakturaen skal bokfÃ¸res Ã¥ lage innbetaling',0),(554058,15391,'da','Fakturaen skal bogfÃ¸res for at gÃ¸re betaling',0),(554059,15391,'ko','ì§€ë¶ˆ ì²­êµ¬ì„œë¥¼ ê²Œì‹œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(554060,15391,'he','×—×©×‘×•× ×™×ª ×—×™×™×‘ ×œ×”×ª×¤×¨×¡× ×œ×‘×¦×¢ ××ª ×”×ª×©×œ×•×',0),(554061,15391,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î·Î¸Î¿ÏÎ½ Ï€Î»Î·ÏÏŽÏƒÎ·',0),(554062,15391,'zh','å¿…é¡»è¿‡å¸å‘ç¥¨ä»˜æ¬¾',0),(554063,15391,'sv','Fakturan mÃ¥ste bokfÃ¶ras fÃ¶r att gÃ¶ra betalning',0),(554064,15391,'it','Fattura deve essere registrata per effettuare il pagamento',0),(554065,15391,'tl','',0),(554066,15391,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸•à¹‰à¸­à¸‡à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(554067,15391,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¨à¤¾à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(554068,15391,'ms','Invois mestilah dihantar untuk membuat pembayaran',0),(554069,15391,'ar','ÙŠØ¬Ø¨ ØªØ±Ø­ÙŠÙ„ ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø¯ÙØ¹',0),(554070,15391,'fr','Facture doit Ãªtre validÃ©e pour effectuer le paiement',0),(554071,15391,'jp','è«‹æ±‚æ›¸ã¯ã€ãŠæ”¯æ‰•ã„ã«æŽ²ç¤ºã•ã‚Œãªã‘ã‚Œã°ãªã‚Šã¾ã›ã‚“ã€‚',0),(554072,15391,'pt','Fatura deve ser postada para fazer o pagamento',0),(554073,15391,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²ÐµÑÑ‚Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(554074,15391,'es','Factura debe ser publicada para realizar el pago',0),(554075,15391,'de','Rechnung muss gebucht werden, um die Zahlung zu leisten',0),(554076,15391,'en','Invoice Must Be Posted To Make Payment',0),(554077,15392,'is','',0),(554078,15392,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† SSN Ø¢Ø®Ø±ÙŠÙ† 4 Ø§Ø² Ú†Ú©',0),(554079,15392,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† SSN Ø¢Ø®Ø±ÙŠÙ† 4 Ø§Ø² Ú†Ú©',0),(554080,15392,'tr','SSN gizle onay son 4',0),(554081,15392,'pl','Ukryj SSN ostatnie 4 z wyboru',0),(554082,15392,'bg','Ð¡ÐºÑ€Ð¸Ð¹ SSN Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ 4 Ð¾Ñ‚ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(554083,15392,'ur','Ø§ÛŒØ³Ø§ÛŒØ³ÛŒÙ† Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº 4 Ú†ÛŒÚ© Ø³Û’ Ø¢Ø®Ø±ÛŒ',0),(554084,15392,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð¡Ð¡Ð Ñ‚Ñ€Ð°Ñ˜Ðµ 4 Ð¸Ð· Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(554085,15392,'vi','áº¨n SSN kÃ©o dÃ i 4 tá»« phÃ²ng',0),(554086,15392,'af','Versteek SSN laaste 4 van kontroleer',0),(554087,15392,'ro','Ascunde SSN dura 4 de la CEC',0),(554088,15392,'et','Peida SSN kesta 4 vÃ¤ljaregistreerimine',0),(554089,15392,'si','Skriti SSN traja 4 od pregled',0),(554090,15392,'ba','Menyembunyikan SSN terakhir 4 dari Check',0),(554091,15392,'nl','Verbergen SSN laatste 4 van selectievakje',0),(554092,15392,'fi','Piilota SSN kestÃ¤vÃ¤t 4 tarkistaa',0),(554093,15392,'no','Skjule SSN siste 4 fra sjekk',0),(554094,15392,'da','Skjule SSN vare 4 fra Check',0),(554095,15392,'ko','SSNì„ ìˆ¨ê¸°ê¸° ì²´í¬ì—ì„œ 4 ë§ˆì§€ë§‰',0),(554096,15392,'he','×œ×”×¡×ª×™×¨ ××ª ×–×”×•×ª ×”××—×¨×•×Ÿ 4 ×ž ×¡×™×ž×•×Ÿ',0),(554097,15392,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· SSN Î´Î¹Î±ÏÎºÎ­ÏƒÎµÎ¹ 4 Î±Ï€ÏŒ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(554098,15392,'zh','éšè— SSN ä»Žæ£€æŸ¥æœ€åŽ 4',0),(554099,15392,'sv','DÃ¶lja SSN sista 4 frÃ¥n Check',0),(554100,15392,'it','Nascondere il SSN durare 4 da Check',0),(554101,15392,'tl','',0),(554102,15392,'th','à¸‹à¹ˆà¸­à¸™ SSN à¸™à¸²à¸™ 4 à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡',0),(554103,15392,'hi','à¤à¤¸à¤à¤¸à¤à¤¨ à¤›à¥à¤ªà¤¾à¤à¤ à¤šà¥‡à¤• à¤¸à¥‡ 4 à¤…à¤‚à¤¤à¤¿à¤®',0),(554104,15392,'ms','Sembunyi SSN berkekalan 4 Daftar',0),(554105,15392,'ar','Ø¥Ø®ÙØ§Ø¡ SSN Ø¢Ø®Ø± 4 Ù…Ù† Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(554106,15392,'fr','Masquer le SSN s\'Ã©couler 4 cocher',0),(554107,15392,'jp','åŽŸå­åŠ›æ½œæ°´è‰¦ã‚’éš ã™ãƒã‚§ãƒƒã‚¯ã‹ã‚‰æœ€å¾Œã® 4 ã¤',0),(554108,15392,'pt','Esconder o SSN Ãºltima 4 da seleÃ§Ã£o',0),(554109,15392,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ SSN Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ 4 Ð¸Ð· Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(554110,15392,'es','Ocultar nÃºmero de seguro social Ãºltimo 4 de cheque',0),(554111,15392,'de','Ausblenden von SSN letzte 4-PrÃ¼fung',0),(554112,15392,'en','Hide SSN Last 4 From Check',0),(554113,15393,'is','',0),(554114,15393,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ØªØ§Ù…ÛŒÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒ',0),(554115,15393,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ØªØ§Ù…ÛŒÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒ',0),(554116,15393,'tr','Sosyal GÃ¼venlik gider',0),(554117,15393,'pl','Koszty zabezpieczenia spoÅ‚ecznego',0),(554118,15393,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° ÑÐ¾Ñ†Ð¸Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€ÑÐ²Ð°Ð½Ðµ',0),(554119,15393,'ur','Ø³ÙˆØ´Ù„ Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(554120,15393,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° ÑÐ¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾Ð³ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ°',0),(554121,15393,'vi','Chi phÃ­ an sinh xÃ£ há»™i',0),(554122,15393,'af','Sosiale sekuriteit uitgawe',0),(554123,15393,'ro','Cheltuieli de asigurÄƒri sociale',0),(554124,15393,'et','Sotsiaalmaks, tÃ¶Ã¶tuskindlustusmaks',0),(554125,15393,'si','StroÅ¡ke socialne varnosti',0),(554126,15393,'ba','Biaya jaminan sosial',0),(554127,15393,'nl','Kosten van de sociale zekerheid',0),(554128,15393,'fi','Sosiaaliturvan kustannuksella',0),(554129,15393,'no','Trygd bekostning',0),(554130,15393,'da','Social sikring udgift',0),(554131,15393,'ko','ì‚¬íšŒ ë³´ìž¥ ë¹„ìš©',0),(554132,15393,'he','×”×•×¦××•×ª ×‘×™×˜×•×— ×œ××•×ž×™',0),(554133,15393,'el','Î•Î¾ÏŒÎ´Ï‰Î½ ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÎºÎ®Ï‚ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚',0),(554134,15393,'zh','ç¤¾ä¼šä¿éšœæ”¯å‡º',0),(554135,15393,'sv','Social trygghet bekostnad',0),(554136,15393,'it','Spese di sicurezza sociale',0),(554137,15393,'tl','',0),(554138,15393,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸‚à¸­à¸‡à¸ªà¸±à¸‡à¸„à¸¡',0),(554139,15393,'hi','à¤¸à¤¾à¤®à¤¾à¤œà¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤–à¤°à¥à¤š',0),(554140,15393,'ms','Perbelanjaan keselamatan sosial',0),(554141,15393,'ar','Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ',0),(554142,15393,'fr','DÃ©penses de sÃ©curitÃ© sociale',0),(554143,15393,'jp','ç¤¾ä¼šä¿éšœè²»ç”¨',0),(554144,15393,'pt','Despesas de seguranÃ§a social',0),(554145,15393,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð½Ð° ÑÐ¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ðµ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ðµ',0),(554146,15393,'es','Gastos de seguridad social',0),(554147,15393,'de','Kosten der sozialen Sicherheit',0),(554148,15393,'en','Social Security Expense',0),(554149,15394,'is','',0),(554150,15394,'dr','ØªØ§Ù…ÛŒÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒ Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(554151,15394,'pr','ØªØ§Ù…ÛŒÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒ Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(554152,15394,'tr','Sosyal GÃ¼venlik Ã¶denecek',0),(554153,15394,'pl','Zabezpieczenia spoÅ‚ecznego wypÅ‚acane',0),(554154,15394,'bg','Ð¡Ð¾Ñ†Ð¸Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€ÑÐ²Ð°Ð½Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¼Ð¸',0),(554155,15394,'ur','Ø³ÙˆØ´Ù„ Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(554156,15394,'sr','Ð¡Ð¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐµ Ð¿Ð»Ð°Ñ›Ð°Ñˆ',0),(554157,15394,'vi','An sinh xÃ£ há»™i pháº£i ná»™p',0),(554158,15394,'af','Sosiale sekuriteit betaalbaar',0),(554159,15394,'ro','AsigurÄƒri sociale plÄƒtibile',0),(554160,15394,'et','Sotsiaalkindlustuse makstav',0),(554161,15394,'si','Socialno varnost plaÄa',0),(554162,15394,'ba','Jamsostek yang dibayar',0),(554163,15394,'nl','Sociale zekerheid te betalen',0),(554164,15394,'fi','Sosiaaliturvan maksettava',0),(554165,15394,'no','Social Security skatt',0),(554166,15394,'da','Social sikring der skal betales',0),(554167,15394,'ko','ì‚¬íšŒ ë³´ìž¥ ì§€ê¸‰',0),(554168,15394,'he','×œ×ª×©×œ×•× ×‘×™×˜×•×— ×œ××•×ž×™',0),(554169,15394,'el','ÎšÎ¿Î¹Î½Ï‰Î½Î¹ÎºÎ®Ï‚ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚ Ï€Î¿Ï… ÎºÎ±Ï„Î±Î²Î¬Î»Î»Î¿Î½Ï„Î±Î¹',0),(554170,15394,'zh','ç¤¾ä¼šä¿éšœæ”¯ä»˜',0),(554171,15394,'sv','Social trygghet som skall betalas',0),(554172,15394,'it','Pagabile in sicurezza sociale',0),(554173,15394,'tl','',0),(554174,15394,'th','à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰à¸ªà¸±à¸‡à¸„à¸¡',0),(554175,15394,'hi','à¤¸à¤¾à¤®à¤¾à¤œà¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤¦à¥‡à¤¯',0),(554176,15394,'ms','Keselamatan sosial yang perlu dibayar',0),(554177,15394,'ar','ÙŠØ¯ÙØ¹ Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ',0),(554178,15394,'fr','SÃ©curitÃ© sociale Payable',0),(554179,15394,'jp','ç¤¾ä¼šä¿éšœæ”¯æ‰•',0),(554180,15394,'pt','SeguranÃ§a social a pagar',0),(554181,15394,'ru','Ð¡Ð¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ñ Ð²Ñ‹Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÑ‚ÑÑ',0),(554182,15394,'es','Seguridad social por pagar',0),(554183,15394,'de','Sozialversicherung zu entrichten',0),(554184,15394,'en','Social Security Payable',0),(554185,15395,'is','',0),(554186,15395,'dr','Ø´Ø±Ú©Øª Ø§Ø³ Ø§Ø³ Ø¯Ø± Ù…Ø¯ÛŒÚ©Ø±',0),(554187,15395,'pr','Ø´Ø±Ú©Øª Ø§Ø³ Ø§Ø³ Ø¯Ø± Ù…Ø¯ÛŒÚ©Ø±',0),(554188,15395,'tr','Åžirket SS/Medicare',0),(554189,15395,'pl','Firma SS/Medicare',0),(554190,15395,'bg','Ð¤Ð¸Ñ€Ð¼Ð° Ð¡Ð¡/Medicare',0),(554191,15395,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ø§ÛŒØ³ Ø§ÛŒØ³/Ù…ÛŒÚˆÛŒ',0),(554192,15395,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¡Ð¡/Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚',0),(554193,15395,'vi','CÃ´ng ty SS/Medicare',0),(554194,15395,'af','Maatskappy SS/Medicare',0),(554195,15395,'ro','Compania SS/Medicare',0),(554196,15395,'et','Firma SS/Medicare',0),(554197,15395,'si','Podjetje SS/Medicare',0),(554198,15395,'ba','Perusahaan SS/Medicare',0),(554199,15395,'nl','Bedrijf SS/Medicare',0),(554200,15395,'fi','Yrityksen SS/Medicare',0),(554201,15395,'no','Selskapet SS/Medicare',0),(554202,15395,'da','Selskabet SS/Medicare',0),(554203,15395,'ko','íšŒì‚¬ SS/ë©”ë””ì¼€ì–´',0),(554204,15395,'he','×—×‘×¨×ª ××¡. ××¡/×ž×“×™×§×¨',0),(554205,15395,'el','Î•Ï„Î±Î¹ÏÎµÎ¯Î± SS/Medicare',0),(554206,15395,'zh','SS/åŒ»ä¿å…¬å¸',0),(554207,15395,'sv','FÃ¶retag SS/Medicare',0),(554208,15395,'it','Azienda SS/Medicare',0),(554209,15395,'tl','',0),(554210,15395,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¹€à¸­à¸ªà¹€à¸­à¸ª/à¹€à¸¡à¸”à¸´à¹à¸„à¸£à¹Œ',0),(554211,15395,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤à¤¸ à¤à¤¸/à¤šà¤¿à¤•à¤¿à¤¤à¥à¤¸à¤¾',0),(554212,15395,'ms','Syarikat SS/Medicare',0),(554213,15395,'ar','Ø´Ø±ÙƒØ© Ø¥Ø³ Ø¥Ø³/Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(554214,15395,'fr','Compagnie SS/assurance maladie',0),(554215,15395,'jp','ä¼šç¤¾ SS/ãƒ¡ãƒ‡ã‚£ã‚±ã‚¢',0),(554216,15395,'pt','Empresa SS/Medicare',0),(554217,15395,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ SS/Medicare',0),(554218,15395,'es','Empresa SS y Medicare',0),(554219,15395,'de','Firma SS/Medicare',0),(554220,15395,'en','Company SS/Medicare',0),(554221,15396,'is','',0),(554222,15396,'dr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ø§Ø³ Ø§Ø³ Ø¯Ø± Ù…Ø¯ÛŒÚ©Ø±',0),(554223,15396,'pr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ø§Ø³ Ø§Ø³ Ø¯Ø± Ù…Ø¯ÛŒÚ©Ø±',0),(554224,15396,'tr','Ã‡alÄ±ÅŸan SS/Medicare',0),(554225,15396,'pl','Pracownik SS/Medicare',0),(554226,15396,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¡Ð¡/Medicare',0),(554227,15396,'ur','Ù…Ù„Ø§Ø²Ù… Ø§ÛŒØ³ Ø§ÛŒØ³/Ù…ÛŒÚˆÛŒ',0),(554228,15396,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¡Ð¡/Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚',0),(554229,15396,'vi','NhÃ¢n viÃªn SS/Medicare',0),(554230,15396,'af','Werknemer SS/Medicare',0),(554231,15396,'ro','Angajat SS/Medicare',0),(554232,15396,'et','TÃ¶Ã¶taja SS/Medicare',0),(554233,15396,'si','Zaposleni SS/Medicare',0),(554234,15396,'ba','Karyawan SS/Medicare',0),(554235,15396,'nl','Werknemer SS/Medicare',0),(554236,15396,'fi','TyÃ¶ntekijÃ¤n SS/Medicare',0),(554237,15396,'no','Ansatt SS/Medicare',0),(554238,15396,'da','Medarbejder SS/Medicare',0),(554239,15396,'ko','ì§ì› SS/ë©”ë””ì¼€ì–´',0),(554240,15396,'he','×”×¢×•×‘×“ ××¡/×ž×“×™×§×¨',0),(554241,15396,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ SS/Medicare',0),(554242,15396,'zh','SS å’Œè€å¹´åŒ»ç–—ä¿é™©å‘˜å·¥',0),(554243,15396,'sv','Medarbetaren SS/Medicare',0),(554244,15396,'it','Dipendente SS/Medicare',0),(554245,15396,'tl','',0),(554246,15396,'th','à¸žà¸™à¸±à¸à¸‡à¸²à¸™ SS/à¹€à¸¡ à¸”à¸´à¹à¸„à¸£à¹Œ',0),(554247,15396,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤à¤¸ à¤à¤¸/à¤šà¤¿à¤•à¤¿à¤¤à¥à¤¸à¤¾',0),(554248,15396,'ms','Pekerja SS/Medicare',0),(554249,15396,'ar','Ø§Ù„Ù…ÙˆØ¸Ù SS/Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(554250,15396,'fr','EmployÃ© SS/assurance maladie',0),(554251,15396,'jp','å¾“æ¥­å“¡ SS/ãƒ¡ãƒ‡ã‚£ã‚±ã‚¢',0),(554252,15396,'pt','Empregado SS/Medicare',0),(554253,15396,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº SS/Medicare',0),(554254,15396,'es','SS y Medicare del empleado',0),(554255,15396,'de','Mitarbeiter SS/Medicare',0),(554256,15396,'en','Employee SS/Medicare',0),(554257,15397,'is','',0),(554258,15397,'dr','Ù†Ù…Ø§ÛŒØ´ Ø±ÛŒØ´Ù‡ Ù‡Ø§ÛŒ Ø¹Ù‚Ø¨ÛŒ',0),(554259,15397,'pr','Ù†Ù…Ø§ÛŒØ´ Ø±ÛŒØ´Ù‡ Ù‡Ø§ÛŒ Ø¹Ù‚Ø¨ÛŒ',0),(554260,15397,'tr','Ardarda sÄ±fÄ±rlarÄ± gÃ¶rÃ¼ntÃ¼leme',0),(554261,15397,'pl','WyÅ›wietlanie zer na koÅ„cu',0),(554262,15397,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÑ€Ð°Ð¹Ð½Ð¸ Ð½ÑƒÐ»Ð¸',0),(554263,15397,'ur','Ù¹Ø±ÛŒÙ„ Ø±ÛÙ†Ù…Ø§ Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(554264,15397,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð½ÑƒÐ»Ðµ',0),(554265,15397,'vi','Hiá»ƒn thá»‹ dáº¥u Zero',0),(554266,15397,'af','Wys rank nulle',0),(554267,15397,'ro','AfiÅŸare zerouri de final',0),(554268,15397,'et','LÃµpunullide kuvamine',0),(554269,15397,'si','Prikazati niÄle',0),(554270,15397,'ba','Tampilan Trailing nol',0),(554271,15397,'nl','Eindnullen in de resultaatwaarde weergeven',0),(554272,15397,'fi','NÃ¤yttÃ¤Ã¤ loppunollia',0),(554273,15397,'no','EtterfÃ¸lgende nuller',0),(554274,15397,'da','Efterstillede nuller',0),(554275,15397,'ko','ë’¤ì— ì˜¤ëŠ” 0ì„ í‘œì‹œ',0),(554276,15397,'he','×”×¦×’×ª ××¤×¡×™× × ×’×¨×¨×™×',0),(554277,15397,'el','Î¤ÎµÎ»Î¹ÎºÎ¬ Î¼Î·Î´ÎµÎ½Î¹ÎºÎ¬ ÎµÏ€Î¯Î´ÎµÎ¹Î¾Î·Ï‚',0),(554278,15397,'zh','æ˜¾ç¤ºå°¾éšé›¶',0),(554279,15397,'sv','Visa efterfÃ¶ljande nollor',0),(554280,15397,'it','Visualizzare gli zeri finali',0),(554281,15397,'tl','',0),(554282,15397,'th','à¹à¸ªà¸”à¸‡à¹€à¸¥à¸‚à¸¨à¸¹à¸™à¸¢à¹Œà¸•à¹ˆà¸­à¸—à¹‰à¸²à¸¢',0),(554283,15397,'hi','à¤…à¤¨à¥à¤—à¤¾à¤®à¥€ à¤¶à¥‚à¤¨à¥à¤¯ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(554284,15397,'ms','Paparkan sifar kosong',0),(554285,15397,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø£ØµÙØ§Ø± Ø§Ù„Ø²Ø§Ø¦Ø¯Ø©',0),(554286,15397,'fr','Afficher les zÃ©ros Ã  droite',0),(554287,15397,'jp','æœ«å°¾ã®ã‚¼ãƒ­ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(554288,15397,'pt','Exibir Zeros Ã  esquerda',0),(554289,15397,'ru','ÐžÑ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ðµ ÐºÐ¾Ð½ÐµÑ‡Ð½Ñ‹Ñ… Ð½ÑƒÐ»ÐµÐ¹',0),(554290,15397,'es','Mostrar ceros',0),(554291,15397,'de','Nachfolgende Nullen anzeigen',0),(554292,15397,'en','Display Trailing Zeros',0),(554293,15398,'is','',0),(554294,15398,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÛŒØ¯ Ú©Ù‡ Ù…ÛŒØ®ÙˆØ§Ù‡ÛŒØ¯ Ù…Ø§Ù„ÛŒØ§Øª Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯ØŸ',0),(554295,15398,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÛŒØ¯ Ú©Ù‡ Ù…ÛŒØ®ÙˆØ§Ù‡ÛŒØ¯ Ù…Ø§Ù„ÛŒØ§Øª Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯ØŸ',0),(554296,15398,'tr','Yinelenen vergi silmek istediÄŸinizden emin misiniz?',0),(554297,15398,'pl','Czy na pewno chcesz usunÄ…Ä‡ zduplikowane podatki?',0),(554298,15398,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸?',0),(554299,15398,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ù…Ø«Ù†ÛŒ Ù¹ÛŒÚ©Ø³ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(554300,15398,'sr','ÐˆÐµÑÐ¸ Ð»Ð¸ ÑÑ‚Ð²Ð°Ñ€Ð½Ð¾ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð±Ñ€Ð¸ÑˆÐµÑ‚Ðµ Ð´ÑƒÐ¿Ð»Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ñ€ÐµÐ·?',0),(554301,15398,'vi','Báº¡n cÃ³ cháº¯c báº¡n muá»‘n xÃ³a bá» trÃ¹ng láº·p thuáº¿ khÃ´ng?',0),(554302,15398,'af','Is jy seker jy wil skrap duplikaat belastings?',0),(554303,15398,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ ÅŸtergeÅ£i duplicat impozitele?',0),(554304,15398,'et','Kas kindlasti kustutada eksemplaris maksud?',0),(554305,15398,'si','Ali ste prepriÄani, da Å¾elite izbrisati podvojene davkov?',0),(554306,15398,'ba','Apakah Anda yakin Anda ingin menghapus duplikat pajak?',0),(554307,15398,'nl','Are You Sure dat You Wish To Delete dubbele belastingen?',0),(554308,15398,'fi','Haluatko varmasti poistaa pÃ¤Ã¤llekkÃ¤isiÃ¤ veroja?',0),(554309,15398,'no','Er du sikker pÃ¥ at du vil slette like skatt?',0),(554310,15398,'da','Er du sikker pÃ¥ du vil slette dublerede skatter?',0),(554311,15398,'ko','ë‹¹ì‹ ì€ ì¤‘ë³µ ì„¸ê¸ˆì„ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(554312,15398,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ×ž×¡×™× ×›×¤×•×œ×™×?',0),(554313,15398,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Ï„Î¹Ï‚ Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€ÎµÏ‚ Ï†ÏŒÏÎ¿Ï…Ï‚;',0),(554314,15398,'zh','ä½ ç¡®å®šä½ æƒ³è¦åˆ é™¤é‡å¤å¾ç¨Ž?',0),(554315,15398,'sv','Ã„r du sÃ¤ker du vill ta bort duplicerade skatter?',0),(554316,15398,'it','Sei sicuro che si desidera eliminare Duplicate tasse?',0),(554317,15398,'tl','',0),(554318,15398,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸¥à¸šà¸ à¸²à¸©à¸µà¸‹à¹‰à¸³à¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(554319,15398,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤•à¤°à¥‹à¤‚ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(554320,15398,'ms','Adakah anda pasti hendak menghapuskan cukai berganda?',0),(554321,15398,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø±ØºØ¨ØªÙƒ ÙÙŠ Ø­Ø°Ù Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…ÙƒØ±Ø±Ø©ØŸ',0),(554322,15398,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer les Taxes en double ?',0),(554323,15398,'jp','é‡è¤‡ã™ã‚‹ç¨Žé‡‘ã‚’å‰Šé™¤ã™ã‚‹ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(554324,15398,'pt','Tem certeza que deseja excluir duplicados impostos?',0),(554325,15398,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð´ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ‚Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð¸?',0),(554326,15398,'es','Â¿EstÃ¡ seguro que desea eliminar impuestos duplicados?',0),(554327,15398,'de','Sind Sie sicher, dass Sie doppelte Steuern lÃ¶schen wollen?',0),(554328,15398,'en','Are You Sure You Wish To Delete Duplicate Taxes?',0),(554329,15399,'is','',0),(554330,15399,'dr','Ù…Ø§Ù„ÛŒØ§Øª Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯',0),(554331,15399,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯',0),(554332,15399,'tr','Yinelenen vergi silmek',0),(554333,15399,'pl','Usuwanie zduplikowanych podatkÃ³w',0),(554334,15399,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(554335,15399,'ur','Ù…Ø«Ù†ÛŒ Ù¹ÛŒÚ©Ø³ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(554336,15399,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸Ñ‚Ðµ Ð´ÑƒÐ¿Ð»Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ñ€ÐµÐ·',0),(554337,15399,'vi','XÃ³a bá» trÃ¹ng láº·p thuáº¿',0),(554338,15399,'af','Skrap duplikaat belastings',0),(554339,15399,'ro','Åžterge duplicat impozite',0),(554340,15399,'et','Kustutage dubleeritud maksud',0),(554341,15399,'si','Izbrisati podvojene davkov',0),(554342,15399,'ba','Menghapus duplikat pajak',0),(554343,15399,'nl','Verwijderen van dubbele belastingen',0),(554344,15399,'fi','Poista kaksoiskappaleet verot',0),(554345,15399,'no','Slette like skatter',0),(554346,15399,'da','Slette dublerede skatter',0),(554347,15399,'ko','ì¤‘ë³µ ì„¸ê¸ˆ ì‚­ì œ',0),(554348,15399,'he','×ž×—×™×§×ª ×ž×¡×™× ×›×¤×•×œ×™×',0),(554349,15399,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÏ„Îµ Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€Î± Ï†ÏŒÏÏ‰Î½',0),(554350,15399,'zh','åˆ é™¤é‡å¤çš„ç¨Ž',0),(554351,15399,'sv','Ta bort duplicerade skatter',0),(554352,15399,'it','Elimina Duplicate tasse',0),(554353,15399,'tl','',0),(554354,15399,'th','à¸¥à¸šà¸ à¸²à¸©à¸µà¸‹à¹‰à¸³',0),(554355,15399,'hi','à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤•à¤°à¥‹à¤‚ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾',0),(554356,15399,'ms','Menghapuskan cukai berganda',0),(554357,15399,'ar','Ø­Ø°Ù Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…ÙƒØ±Ø±Ø©',0),(554358,15399,'fr','Supprimer les Taxes en double',0),(554359,15399,'jp','é‡è¤‡ã™ã‚‹ç¨Žé‡‘ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(554360,15399,'pt','Excluir impostos duplicados',0),(554361,15399,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð´ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ‚Ð¾Ð² Ð½Ð°Ð»Ð¾Ð³Ð¸',0),(554362,15399,'es','Eliminar impuestos duplicados',0),(554363,15399,'de','LÃ¶schen doppelte Steuern',0),(554364,15399,'en','Delete Duplicate Taxes',0),(554365,15400,'is','',0),(554366,15400,'dr','Ø­Ø°Ù',0),(554367,15400,'pr','Ø­Ø°Ù',0),(554368,15400,'tr','KaldÄ±rÄ±ldÄ±',0),(554369,15400,'pl','UsuniÄ™te',0),(554370,15400,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð½Ð°Ñ‚Ð¸',0),(554371,15400,'ur','ÛÙ¹Ø§ Ø¯ÛŒØ§',0),(554372,15400,'sr','Ð£ÐºÐ»Ð¾ÑšÐµÐ½Ð°',0),(554373,15400,'vi','Gá»¡ bá»',0),(554374,15400,'af','Verwyder',0),(554375,15400,'ro','Eliminat',0),(554376,15400,'et','Eemaldatud',0),(554377,15400,'si','Odstrani',0),(554378,15400,'ba','Dihapus',0),(554379,15400,'nl','Verwijderd',0),(554380,15400,'fi','Poistettu',0),(554381,15400,'no','Fjernet',0),(554382,15400,'da','Fjernet',0),(554383,15400,'ko','ì œê±°',0),(554384,15400,'he','×”×•×¡×¨',0),(554385,15400,'el','Î‘Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯',0),(554386,15400,'zh','åˆ é™¤',0),(554387,15400,'sv','Bort',0),(554388,15400,'it','Rimosso',0),(554389,15400,'tl','',0),(554390,15400,'th','à¹€à¸­à¸²à¸­à¸­à¸',0),(554391,15400,'hi','à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(554392,15400,'ms','Dikeluarkan',0),(554393,15400,'ar','Ø¥Ø²Ø§Ù„Ø©',0),(554394,15400,'fr','SupprimÃ©',0),(554395,15400,'jp','å‰Šé™¤',0),(554396,15400,'pt','Removido',0),(554397,15400,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ñ‹',0),(554398,15400,'es','Quitar',0),(554399,15400,'de','Entfernt',0),(554400,15400,'en','Removed',0),(554401,15401,'is','',0),(554402,15401,'dr','Ø­Ø°Ù ØªÚ©Ø±Ø§Ø±ÛŒ Ù…Ø§Ù„ÛŒØ§Øª',0),(554403,15401,'pr','Ø­Ø°Ù ØªÚ©Ø±Ø§Ø±ÛŒ Ù…Ø§Ù„ÛŒØ§Øª',0),(554404,15401,'tr','Yinelenen vergi kaldÄ±rmak',0),(554405,15401,'pl','UsuÅ„ zduplikowane podatkÃ³w',0),(554406,15401,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð²Ð°Ð½Ðµ Ð½Ð° Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(554407,15401,'ur','Ù…Ø«Ù†ÛŒ Ù¹ÛŒÚ©Ø³ ÛÙ¹Ø§Ø¦ÛŒÚº',0),(554408,15401,'sr','Ð£ÐºÐ»Ð°ÑšÐ°ÑšÐµ Ð´ÑƒÐ¿Ð»Ð¸Ñ€Ð°Ð½Ð¸Ñ… Ð¿Ð¾Ñ€ÐµÐ·',0),(554409,15401,'vi','Loáº¡i bá» trÃ¹ng láº·p thuáº¿',0),(554410,15401,'af','Duplikaat belastings verwyder',0),(554411,15401,'ro','Elimina taxele duplicat',0),(554412,15401,'et','Eemalda duplikaat maksud',0),(554413,15401,'si','Odstranite podvojene davkov',0),(554414,15401,'ba','Menghapus duplikat pajak',0),(554415,15401,'nl','Verwijderen van dubbele belastingen',0),(554416,15401,'fi','Poista kaksoiskappaleet verot',0),(554417,15401,'no','Fjerne dupliserte avgifter',0),(554418,15401,'da','Fjerne dublerede skatter',0),(554419,15401,'ko','ì¤‘ë³µ ì„¸ê¸ˆ ì œê±°',0),(554420,15401,'he','×”×¡×¨ ×›×¤×™×œ×•×™×•×ª ×ž×™×¡×™×',0),(554421,15401,'el','ÎšÎ±Ï„Î¬ÏÎ³Î·ÏƒÎ· Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€Î¿ Ï†ÏŒÏÏ‰Î½',0),(554422,15401,'zh','åˆ é™¤é‡å¤çš„ç¨Ž',0),(554423,15401,'sv','Ta bort duplicerade skatter',0),(554424,15401,'it','Rimuovere le tasse Duplicate',0),(554425,15401,'tl','',0),(554426,15401,'th','à¹€à¸­à¸²à¸ à¸²à¸©à¸µà¸‹à¹‰à¸³',0),(554427,15401,'hi','à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚ à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤•à¤°à¥‹à¤‚',0),(554428,15401,'ms','Menghapuskan cukai berganda',0),(554429,15401,'ar','Ø¥Ø²Ø§Ù„Ø© Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…ÙƒØ±Ø±Ø©',0),(554430,15401,'fr','Supprimer les Taxes en double',0),(554431,15401,'jp','é‡è¤‡ã™ã‚‹ç¨Žé‡‘ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(554432,15401,'pt','Remover duplicados impostos',0),(554433,15401,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð½Ð°Ð»Ð¾Ð³Ð¸',0),(554434,15401,'es','Eliminar impuestos duplicados',0),(554435,15401,'de','Entfernen Sie doppelte Steuern',0),(554436,15401,'en','Remove Duplicate Taxes',0),(554437,15402,'is','',0),(554438,15402,'dr','Ù†Ø§Ù‚Øµ',0),(554439,15402,'pr','Ù†Ø§Ù‚Øµ',0),(554440,15402,'tr','Eksik',0),(554441,15402,'pl','Niekompletne',0),(554442,15402,'bg','ÐÐµÐ¿ÑŠÐ»Ð½Ð¾',0),(554443,15402,'ur','Ù†Ø§Ù…Ú©Ù…Ù„',0),(554444,15402,'sr','ÐÐµÐ¿Ð¾Ñ‚Ð¿ÑƒÐ½Ð°',0),(554445,15402,'vi','KhÃ´ng Ä‘áº§y Ä‘á»§',0),(554446,15402,'af','Onvolledige',0),(554447,15402,'ro','Incomplet',0),(554448,15402,'et','Puudulik',0),(554449,15402,'si','Nepopolna',0),(554450,15402,'ba','Tidak lengkap',0),(554451,15402,'nl','Onvolledig',0),(554452,15402,'fi','EpÃ¤tÃ¤ydellinen',0),(554453,15402,'no','Ufullstendig',0),(554454,15402,'da','UfuldstÃ¦ndig',0),(554455,15402,'ko','ë¶ˆì™„ì „ í•œ',0),(554456,15402,'he','×œ× ×©×œ×',0),(554457,15402,'el','Î•Î»Î»Î¹Ï€Î®Ï‚',0),(554458,15402,'zh','ä¸å®Œæ•´',0),(554459,15402,'sv','OfullstÃ¤ndig',0),(554460,15402,'it','Incompleto',0),(554461,15402,'tl','',0),(554462,15402,'th','à¹„à¸¡à¹ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(554463,15402,'hi','à¤…à¤§à¥‚à¤°à¥€',0),(554464,15402,'ms','Tidak lengkap',0),(554465,15402,'ar','ØºÙŠØ± Ù…ÙƒØªÙ…Ù„',0),(554466,15402,'fr','IncomplÃ¨tes',0),(554467,15402,'jp','ä¸å®Œå…¨ã§ã™',0),(554468,15402,'pt','Incompleto',0),(554469,15402,'ru','ÐÐµÐ¿Ð¾Ð»Ð½Ñ‹Ðµ',0),(554470,15402,'es','Incompleta',0),(554471,15402,'de','UnvollstÃ¤ndige',0),(554472,15402,'en','Incomplete',0),(554473,15403,'is','',0),(554474,15403,'dr','Ú¯Ø±ÙˆÙ‡ ÙØ¹Ù„ÛŒ',0),(554475,15403,'pr','Ú¯Ø±ÙˆÙ‡ ÙØ¹Ù„ÛŒ',0),(554476,15403,'tr','GeÃ§erli bÃ¶lÃ¼m',0),(554477,15403,'pl','Departamenty prÄ…du',0),(554478,15403,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¾Ñ‚Ð´ÐµÐ»Ð¸',0),(554479,15403,'ur','Ø­Ø§Ù„ÛŒÛ Ø´Ø¹Ø¨Û Ø¬Ø§Øª',0),(554480,15403,'sr','Ð¡Ñ‚Ñ€ÑƒÑ˜Ð° ÐºÐ°Ñ‚ÐµÐ´Ñ€Ðµ',0),(554481,15403,'vi','Hiá»‡n táº¡i bá»™ pháº­n',0),(554482,15403,'af','Huidige departemente',0),(554483,15403,'ro','Curent departamente',0),(554484,15403,'et','Praegune osakonnad',0),(554485,15403,'si','Tok oddelki',0),(554486,15403,'ba','Saat ini Departemen',0),(554487,15403,'nl','Huidige diensten',0),(554488,15403,'fi','Nykyinen osastot',0),(554489,15403,'no','Gjeldende avdelinger',0),(554490,15403,'da','NuvÃ¦rende afdelinger',0),(554491,15403,'ko','í˜„ìž¬ ë¶€ì„œ',0),(554492,15403,'he','×ž×—×œ×§×•×ª ×”× ×•×›×—×™',0),(554493,15403,'el','Î¡ÎµÏÎ¼Î± Ï„Î¼Î®Î¼Î±Ï„Î±',0),(554494,15403,'zh','å½“å‰éƒ¨é—¨',0),(554495,15403,'sv','Aktuella avdelningar',0),(554496,15403,'it','Dipartimenti di corrente',0),(554497,15403,'tl','',0),(554498,15403,'th','à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¹à¸œà¸™à¸',0),(554499,15403,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤µà¤¿à¤­à¤¾à¤—à¥‹à¤‚',0),(554500,15403,'ms','Jabatan semasa',0),(554501,15403,'ar','Ø§Ù„Ø¥Ø¯Ø§Ø±Ø§Øª Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(554502,15403,'fr','DÃ©partements de courant',0),(554503,15403,'jp','ç¾åœ¨ã®éƒ¨é–€',0),(554504,15403,'pt','Departamentos de corrente',0),(554505,15403,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð´ÐµÐ¿Ð°Ñ€Ñ‚Ð°Ð¼ÐµÐ½Ñ‚Ð¾Ð²',0),(554506,15403,'es','Departamentos de corriente',0),(554507,15403,'de','Aktuelle Abteilungen',0),(554508,15403,'en','Current Departments',0),(554509,15404,'is','',0),(554510,15404,'dr','Ú©Ø¯ Ú¯Ø±ÙˆÙ‡',0),(554511,15404,'pr','Ú©Ø¯ Ú¯Ø±ÙˆÙ‡',0),(554512,15404,'tr','Departman Kodu',0),(554513,15404,'pl','Kod dziaÅ‚u',0),(554514,15404,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð¾Ñ‚Ð´ÐµÐ»',0),(554515,15404,'ur','Ø´Ø¹Ø¨Û Ø¶Ø§Ø¨Ø·Û',0),(554516,15404,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð¾Ð´ÐµÑ™ÐµÑšÐ°',0),(554517,15404,'vi','MÃ£ vÃ¹ng',0),(554518,15404,'af','Departement kode',0),(554519,15404,'ro','Departamentul de cod',0),(554520,15404,'et','Osakonna kood',0),(554521,15404,'si','Å ifra oddelka',0),(554522,15404,'ba','Departemen kode',0),(554523,15404,'nl','Kstnplaats Code',0),(554524,15404,'fi','Osastokoodi',0),(554525,15404,'no','Avdelingskode',0),(554526,15404,'da','Afdelingskode',0),(554527,15404,'ko','ë¶€ì„œ ì½”ë“œ',0),(554528,15404,'he','×ž×—×œ×§×ª ×§×•×“',0),(554529,15404,'el','Î¤Î¼Î®Î¼Î± ÎºÏŽÎ´Î¹ÎºÎ±',0),(554530,15404,'zh','éƒ¨é—¨ä»£ç ',0),(554531,15404,'sv','Avdelningskod',0),(554532,15404,'it','Codice reparto',0),(554533,15404,'tl','',0),(554534,15404,'th','à¸£à¸«à¸±à¸ªà¹à¸œà¸™à¸',0),(554535,15404,'hi','à¤µà¤¿à¤­à¤¾à¤— à¤•à¥‹à¤¡',0),(554536,15404,'ms','Kod Jabatan',0),(554537,15404,'ar','Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ©',0),(554538,15404,'fr','Code du ministÃ¨re',0),(554539,15404,'jp','éƒ¨é–€ã‚³ãƒ¼ãƒ‰',0),(554540,15404,'pt','CÃ³digo de departamento',0),(554541,15404,'ru','ÐšÐ¾Ð´ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸Ñ',0),(554542,15404,'es','CÃ³digo de Departamento',0),(554543,15404,'de','Abteilungscode',0),(554544,15404,'en','Department Code',0),(554545,15405,'is','',0),(554546,15405,'dr','Ù†Ø§Ù… Ø¨Ø®Ø´',0),(554547,15405,'pr','Ù†Ø§Ù… Ø¨Ø®Ø´',0),(554548,15405,'tr','BÃ¶lÃ¼m adÄ±',0),(554549,15405,'pl','Nazwa dziaÅ‚u',0),(554550,15405,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð¾Ñ‚Ð´ÐµÐ»',0),(554551,15405,'ur','Ø´Ø¹Ø¨Û Ú©Ø§ Ù†Ø§Ù…',0),(554552,15405,'sr','Ð˜Ð¼Ðµ Ð¾Ð´ÐµÑ™ÐµÑšÐ°',0),(554553,15405,'vi','TÃªn vÃ¹ng',0),(554554,15405,'af','Departement naam',0),(554555,15405,'ro','Departamentul de nume',0),(554556,15405,'et','Osakonna nimi',0),(554557,15405,'si','Ime oddelka',0),(554558,15405,'ba','Nama Departemen',0),(554559,15405,'nl','Afdelingsnaam',0),(554560,15405,'fi','Osaston nimi',0),(554561,15405,'no','Avdelingsnavn',0),(554562,15405,'da','Afdelingsnavn',0),(554563,15405,'ko','ë¶€ì„œ ì´ë¦„',0),(554564,15405,'he','×©× ×ž×—×œ×§×”',0),(554565,15405,'el','Î¤Î¿ Ï€ÎµÎ´Î¯Î¿ Î¿Î½ÏŒÎ¼Î±Ï„Î¿Ï‚ Ï„Î¼Î®Î¼Î±Ï„Î¿Ï‚',0),(554566,15405,'zh','éƒ¨é—¨åç§°',0),(554567,15405,'sv','Avdelningsnamn',0),(554568,15405,'it','Nome del reparto',0),(554569,15405,'tl','',0),(554570,15405,'th','à¸Šà¸·à¹ˆà¸­à¹à¸œà¸™à¸',0),(554571,15405,'hi','à¤µà¤¿à¤­à¤¾à¤— à¤¨à¤¾à¤®',0),(554572,15405,'ms','Nama Jabatan',0),(554573,15405,'ar','Ø§Ø³Ù… Ø§Ù„Ø¥Ø¯Ø§Ø±Ø©',0),(554574,15405,'fr','Nom du ministÃ¨re',0),(554575,15405,'jp','éƒ¨ç½²å',0),(554576,15405,'pt','Nome do departamento',0),(554577,15405,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¾Ñ‚Ð´ÐµÐ»Ð°',0),(554578,15405,'es','Nombre del Departamento',0),(554579,15405,'de','Name der Abteilung',0),(554580,15405,'en','Department Name',0),(554581,15406,'is','',0),(554582,15406,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨ÛŒÙ…Ù‡ Ø¨ÛŒÚ©Ø§Ø±ÛŒ ÙØ¯Ø±Ø§Ù„',0),(554583,15406,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨ÛŒÙ…Ù‡ Ø¨ÛŒÚ©Ø§Ø±ÛŒ ÙØ¯Ø±Ø§Ù„',0),(554584,15406,'tr','Federal iÅŸsizlik sigorta gideri',0),(554585,15406,'pl','Koszt ubezpieczenia Federalnej bezrobocia',0),(554586,15406,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(554587,15406,'ur','ÙˆÙØ§Ù‚ÛŒ Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ø§Ù†Ø´ÙˆØ±Ù†Ø³ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(554588,15406,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(554589,15406,'vi','Chi phÃ­ báº£o hiá»ƒm tháº¥t nghiá»‡p liÃªn bang',0),(554590,15406,'af','Federale werkloosheid versekering uitgawe',0),(554591,15406,'ro','Cheltuieli de asigurare FederalÄƒ de ÅŸomaj',0),(554592,15406,'et','FÃ¶deraal tÃ¶Ã¶tuse kindlustuse kulul',0),(554593,15406,'si','Zvezni brezposelnosti zavarovalni odhodki',0),(554594,15406,'ba','Biaya asuransi pengangguran Federal',0),(554595,15406,'nl','Federale werkloosheid verzekering kosten',0),(554596,15406,'fi','Federal tyÃ¶ttÃ¶myys vakuutus kustannuksella',0),(554597,15406,'no','FÃ¸derale arbeidsledighet forsikring kostnader',0),(554598,15406,'da','FÃ¸derale arbejdslÃ¸shed forsikring udgift',0),(554599,15406,'ko','ì—°ë°© ì‹¤ì—… ë³´í—˜ ë¹„ìš©',0),(554600,15406,'he','×”×•×¦××•×ª ×‘×™×˜×•×— ××‘×˜×œ×” ×¤×“×¨×œ×™',0),(554601,15406,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® Î±Î½ÎµÏÎ³Î¯Î±Ï‚ Î‘Î£Î¦Î‘Î›Î™Î£Î¤Î¡Î‘',0),(554602,15406,'zh','è”é‚¦å¤±ä¸šä¿é™©è´¹ç”¨',0),(554603,15406,'sv','Federala arbetslÃ¶shet fÃ¶rsÃ¤kring bekostnad',0),(554604,15406,'it','Spese di assicurazione di disoccupazione federale',0),(554605,15406,'tl','',0),(554606,15406,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸à¸²à¸£à¸›à¸£à¸°à¸à¸±à¸™à¸à¸²à¸£à¸§à¹ˆà¸²à¸‡à¸‡à¸²à¸™à¸‚à¸­à¸‡à¸£à¸±à¸à¸šà¸²à¸¥à¸à¸¥à¸²à¸‡',0),(554607,15406,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤¬à¥€à¤®à¤¾ à¤µà¥à¤¯à¤¯',0),(554608,15406,'ms','Perbelanjaan insurans pengangguran Persekutuan',0),(554609,15406,'ar','Ù†ÙÙ‚Ø§Øª Ø§Ù„ØªØ£Ù…ÙŠÙ† Ø¶Ø¯ Ø§Ù„Ø¨Ø·Ø§Ù„Ø© Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©',0),(554610,15406,'fr','Frais d\'assurance-chÃ´mage fÃ©dÃ©rale',0),(554611,15406,'jp','é€£é‚¦æ”¿åºœã®å¤±æ¥­ä¿é™ºè²»ç”¨',0),(554612,15406,'pt','Despesa de seguro de desemprego Federal',0),(554613,15406,'ru','Ð¡Ñ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð² Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹',0),(554614,15406,'es','Gastos de seguro de desempleo federal',0),(554615,15406,'de','FÃ¶derale Arbeitslosigkeit Versicherung Kosten',0),(554616,15406,'en','Federal Unemployment Insurance Expense',0),(554617,15407,'is','',0),(554618,15407,'dr','Ø¹Ù…ÙˆÙ…ÛŒ Ù„Ø¬Ø± Defaullts',0),(554619,15407,'pr','Ø¹Ù…ÙˆÙ…ÛŒ Ù„Ø¬Ø± Defaullts',0),(554620,15407,'tr','Genel muhasebe Defaullts',0),(554621,15407,'pl','General Ledger Defaullts',0),(554622,15407,'bg','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÐ½Ð¸Ð³Ð° Ð·Ð° Defaullts',0),(554623,15407,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø¯ÛŒÙØ§ÙˆÙ„Ù„Ù¹',0),(554624,15407,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» Ð”ÐµÑ„Ð°ÑƒÐ»Ð»Ñ‚Ñ ÐºÑšÐ¸Ð³Ðµ',0),(554625,15407,'vi','General Ledger Defaullts',0),(554626,15407,'af','Algemene grootboek Defaullts',0),(554627,15407,'ro','General Ledger Defaullts',0),(554628,15407,'et','Ãœldised pearaamatu Defaullts',0),(554629,15407,'si','General Ledger Defaullts',0),(554630,15407,'ba','General Ledger Defaullts',0),(554631,15407,'nl','General Ledger Defaullts',0),(554632,15407,'fi','Yleiset kirjanpidon Defaullts',0),(554633,15407,'no','General Ledger Defaullts',0),(554634,15407,'da','General Ledger Defaullts',0),(554635,15407,'ko','ì¼ë°˜ ë ˆì € Defaullts',0),(554636,15407,'he','×’× ×¨×œ ×¨××©×™ Defaullts',0),(554637,15407,'el','Î“ÎµÎ½Î¹ÎºÎ® Î»Î¿Î³Î¹ÏƒÏ„Î¹ÎºÎ® Defaullts',0),(554638,15407,'zh','æ€»åˆ†ç±»å¸ Defaullts',0),(554639,15407,'sv','General Ledger Defaullts',0),(554640,15407,'it','General Ledger Defaullts',0),(554641,15407,'tl','',0),(554642,15407,'th','Defaullts à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(554643,15407,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¬à¤¹à¥€ Defaullts',0),(554644,15407,'ms','Defaullts Lejar Am',0),(554645,15407,'ar','Ø¯ÙŠÙØ§ÙˆÙ„ØªØ³ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(554646,15407,'fr','Defaullts comptabilitÃ© gÃ©nÃ©rale',0),(554647,15407,'jp','ä¸€èˆ¬çš„ãªå…ƒå¸³ Defaullts',0),(554648,15407,'pt','General Ledger Defaullts',0),(554649,15407,'ru','Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð“Ðš Defaullts',0),(554650,15407,'es','Defaullts de contabilidad general',0),(554651,15407,'de','General Ledger Defaullts',0),(554652,15407,'en','General Ledger Defaullts',0),(554653,15408,'is','',0),(554654,15408,'dr','Ù‡ÛŒÚ† Ú¯Ø±ÙˆÙ‡ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(554655,15408,'pr','Ù‡ÛŒÚ† Ú¯Ø±ÙˆÙ‡ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(554656,15408,'tr','HiÃ§bir bÃ¶lÃ¼mler var',0),(554657,15408,'pl','IstniejÄ… nie dziaÅ‚y',0),(554658,15408,'bg','ÐÑÐ¼Ð° Ð¾Ñ‚Ð´ÐµÐ»Ð¸ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‚',0),(554659,15408,'ur','Ú©ÙˆØ¦ÛŒ Ø´Ø¹Ø¨Û Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(554660,15408,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ð¸ Ð±ÐµÐ· ÐºÐ°Ñ‚ÐµÐ´Ñ€Ðµ',0),(554661,15408,'vi','Bá»™ pháº­n khÃ´ng tá»“n táº¡i',0),(554662,15408,'af','Geen departemente bestaan',0),(554663,15408,'ro','Departamentele nu exista',0),(554664,15408,'et','No allosakondi',0),(554665,15408,'si','Ni oddelki obstajajo',0),(554666,15408,'ba','Departemen tidak ada',0),(554667,15408,'nl','Geen diensten bestaan',0),(554668,15408,'fi','Ei yksikÃ¶t olemassa',0),(554669,15408,'no','Ingen avdelinger finnes',0),(554670,15408,'da','Ingen afdelinger findes',0),(554671,15408,'ko','ì•„ë‹ˆ ë¶€ì„œ ì¡´ìž¬',0),(554672,15408,'he','×ž×—×œ×§×•×ª ×œ× ×§×™×™×',0),(554673,15408,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÏƒÏ‡Î¿Î»Î­Ï‚ ÎºÎ±Î¹ Ï„Î¼Î®Î¼Î±Ï„Î± Î´ÎµÎ½',0),(554674,15408,'zh','æ²¡æœ‰éƒ¨é—¨å­˜åœ¨',0),(554675,15408,'sv','Det finns inga institutioner',0),(554676,15408,'it','Non esistano Nessun dipartimenti',0),(554677,15408,'tl','',0),(554678,15408,'th','à¹à¸œà¸™à¸à¹„à¸¡à¹ˆà¸­à¸¢à¸¹à¹ˆ',0),(554679,15408,'hi','à¤•à¥‹à¤ˆ à¤µà¤¿à¤­à¤¾à¤—à¥‹à¤‚ à¤®à¥Œà¤œà¥‚à¤¦',0),(554680,15408,'ms','Jabatan tidak wujud',0),(554681,15408,'ar','Ù„Ø§ Ø£Ù‚Ø³Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(554682,15408,'fr','Aucun dÃ©partements n\'existent',0),(554683,15408,'jp','éƒ¨é–€ãŒå­˜åœ¨ã—ã¾ã›ã‚“ã€‚',0),(554684,15408,'pt','Departamentos nÃ£o existe',0),(554685,15408,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð½ÐµÑ‚ Ð´ÐµÐ¿Ð°Ñ€Ñ‚Ð°Ð¼ÐµÐ½Ñ‚Ð¾Ð²',0),(554686,15408,'es','No departamentos existen',0),(554687,15408,'de','Gibt es keine Abteilungen',0),(554688,15408,'en','No Departments Exist',0),(554689,15409,'is','',0),(554690,15409,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(554691,15409,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ù†Ø§Ù… Ú¯Ø±ÙˆÙ‡ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(554692,15409,'tr','Bir bÃ¶lÃ¼m adÄ± girin',0),(554693,15409,'pl','Podaj nazwÄ™ dziaÅ‚u',0),(554694,15409,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð½Ð° Ð¾Ñ‚Ð´ÐµÐ»',0),(554695,15409,'ur','Ø§ÛŒÚ© Ø´Ø¹Ø¨Û Ú©Ø§ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(554696,15409,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð¾Ð´ÐµÑ™ÐµÑšÐ°',0),(554697,15409,'vi','Vui lÃ²ng nháº­p má»™t tÃªn vÃ¹ng',0),(554698,15409,'af','Tik asseblief \'n naam vir Departement',0),(554699,15409,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un nume de Departamentul',0),(554700,15409,'et','Palun sisestage osakonna nimi',0),(554701,15409,'si','Vnesite ime oddelka',0),(554702,15409,'ba','Silahkan masukkan nama Departemen',0),(554703,15409,'nl','Voer de naam van een afdeling',0),(554704,15409,'fi','Anna osaston nimi',0),(554705,15409,'no','Angi et avdelingsnavn',0),(554706,15409,'da','Angiv et afdelingsnavn',0),(554707,15409,'ko','ë¶€ì„œ ì´ë¦„ì„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤',0),(554708,15409,'he','×× × ×”×›× ×¡ ×©× ×”×ž×—×œ×§×”',0),(554709,15409,'el','Î Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± Ï„Î¼Î®Î¼Î±Ï„Î¿Ï‚',0),(554710,15409,'zh','è¯·è¾“å…¥éƒ¨é—¨åç§°',0),(554711,15409,'sv','Ange ett avdelningsnamn',0),(554712,15409,'it','Si prega di inserire un nome di reparto',0),(554713,15409,'tl','',0),(554714,15409,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸°à¸šà¸¸à¸Šà¸·à¹ˆà¸­à¹à¸œà¸™à¸',0),(554715,15409,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤µà¤¿à¤­à¤¾à¤— à¤•à¤¾ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(554716,15409,'ms','Sila masukkan nama Jabatan',0),(554717,15409,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ø³Ù… Ø§Ù„Ù‚Ø³Ù…',0),(554718,15409,'fr','Veuillez entrer un nom de dÃ©partement',0),(554719,15409,'jp','éƒ¨ç½²åã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(554720,15409,'pt','Por favor digite um nome de departamento',0),(554721,15409,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¾Ñ‚Ð´ÐµÐ»Ð°',0),(554722,15409,'es','Introduzca un nombre de Departamento',0),(554723,15409,'de','Bitte geben Sie einen Name der Abteilung',0),(554724,15409,'en','Please Enter A Department Name',0),(554725,15410,'is','',0),(554726,15410,'dr','Ø¹Ø¯Ù… Ù…ÙˆÙÙ‚ÛŒØª Ø¯Ø± Ø°Ø®ÛŒØ±Ù‡',0),(554727,15410,'pr','Ø¹Ø¯Ù… Ù…ÙˆÙÙ‚ÛŒØª Ø¯Ø± Ø°Ø®ÛŒØ±Ù‡',0),(554728,15410,'tr','Kaydetme baÅŸarÄ±sÄ±z oldu',0),(554729,15410,'pl','Zapisywanie nie powiodÅ‚o siÄ™',0),(554730,15410,'bg','Ð—Ð°Ð¿Ð¸ÑÐ²Ð°Ð½ÐµÑ‚Ð¾ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(554731,15410,'ur','Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©Ø§',0),(554732,15410,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(554733,15410,'vi','LÆ°u khÃ´ng thÃ nh cÃ´ng',0),(554734,15410,'af','Stoor het misluk',0),(554735,15410,'ro','Salvare nereuÈ™itÄƒ',0),(554736,15410,'et','Salvestamine nurjus',0),(554737,15410,'si','Shranjevanje ni uspelo',0),(554738,15410,'ba','Simpan gagal',0),(554739,15410,'nl','Opslaan is mislukt',0),(554740,15410,'fi','Tallennus epÃ¤onnistui',0),(554741,15410,'no','Lagringen mislyktes',0),(554742,15410,'da','Lagringen mislykkedes',0),(554743,15410,'ko','ì €ìž¥ ì‹¤íŒ¨',0),(554744,15410,'he','×©×ž×•×¨ × ×›×©×œ',0),(554745,15410,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î· Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·',0),(554746,15410,'zh','ä¿å­˜å¤±è´¥',0),(554747,15410,'sv','Det gick inte att spara',0),(554748,15410,'it','Impossibile salvare',0),(554749,15410,'tl','',0),(554750,15410,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(554751,15410,'hi','à¤¸à¤¹à¥‡à¤œà¤¨à¤¾ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(554752,15410,'ms','Gagal Simpan',0),(554753,15410,'ar','ÙØ´Ù„ Ø§Ù„Ø­ÙØ¸',0),(554754,15410,'fr','Ã‰chec de l\'enregistrement',0),(554755,15410,'jp','ä¿å­˜ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(554756,15410,'pt','Falha ao salvar',0),(554757,15410,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ',0),(554758,15410,'es','Error al guardar',0),(554759,15410,'de','Speichern fehlgeschlagen ist',0),(554760,15410,'en','Save Failed',0),(554761,15411,'is','',0),(554762,15411,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨ÛŒÙ…Ù‡ Ø¨ÛŒÚ©Ø§Ø±ÛŒ Ø¯ÙˆÙ„Øª',0),(554763,15411,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨ÛŒÙ…Ù‡ Ø¨ÛŒÚ©Ø§Ø±ÛŒ Ø¯ÙˆÙ„Øª',0),(554764,15411,'tr','Devlet iÅŸsizlik sigorta gideri',0),(554765,15411,'pl','Stan bezrobocia ubezpieczenia kosztÃ³w',0),(554766,15411,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(554767,15411,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ø§Ù†Ø´ÙˆØ±Ù†Ø³ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(554768,15411,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(554769,15411,'vi','Chi phÃ­ báº£o hiá»ƒm tháº¥t nghiá»‡p nhÃ  nÆ°á»›c',0),(554770,15411,'af','Staat werkloosheid versekering uitgawe',0),(554771,15411,'ro','Cheltuieli de asigurare stat ÅŸomajului',0),(554772,15411,'et','Riigi tÃ¶Ã¶tuse kindlustuse kulul',0),(554773,15411,'si','Stanje brezposelnosti zavarovalni odhodki',0),(554774,15411,'ba','Biaya asuransi pengangguran negara',0),(554775,15411,'nl','Staat werkloosheid verzekering kosten',0),(554776,15411,'fi','Valtion tyÃ¶ttÃ¶myyden vakuutus kustannuksella',0),(554777,15411,'no','Statlig arbeidsledighet forsikring kostnader',0),(554778,15411,'da','Statslige arbejdslÃ¸shed forsikring udgift',0),(554779,15411,'ko','ì£¼ ì‹¤ì—… ë³´í—˜ ë¹„ìš©',0),(554780,15411,'he','×”×•×¦××•×ª ×‘×™×˜×•×— ××‘×˜×œ×” ×”×ž×“×™× ×”',0),(554781,15411,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Î½ÎµÏÎ³Î¯Î±Ï‚ Î‘Î£Î¦Î‘Î›Î™Î£Î¤Î¡Î‘',0),(554782,15411,'zh','æ”¿åºœæä¾›çš„å¤±ä¸šä¿é™©è´¹ç”¨',0),(554783,15411,'sv','Statlig arbetslÃ¶shet fÃ¶rsÃ¤kring bekostnad',0),(554784,15411,'it','Stato di disoccupazione assicurazione spese',0),(554785,15411,'tl','',0),(554786,15411,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸›à¸£à¸°à¸à¸±à¸™à¸§à¹ˆà¸²à¸‡à¸‡à¸²à¸™à¸£à¸±à¸',0),(554787,15411,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤¬à¥€à¤®à¤¾ à¤µà¥à¤¯à¤¯',0),(554788,15411,'ms','Perbelanjaan insurans pengangguran Negeri',0),(554789,15411,'ar','Ù†ÙÙ‚Ø§Øª Ø§Ù„ØªØ£Ù…ÙŠÙ† Ø¶Ø¯ Ø§Ù„Ø¨Ø·Ø§Ù„Ø© Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(554790,15411,'fr','Frais d\'assurance-chÃ´mage Etat',0),(554791,15411,'jp','å·žã®å¤±æ¥­ä¿é™ºè²»ç”¨',0),(554792,15411,'pt','Despesa de seguros desemprego estadual',0),(554793,15411,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(554794,15411,'es','Gastos de seguro de desempleo estatal',0),(554795,15411,'de','Staatliche Arbeitslosigkeit Versicherung Kosten',0),(554796,15411,'en','State Unemployment Insurance Expense',0),(554797,15412,'is','',0),(554798,15412,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(554799,15412,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(554800,15412,'tr','Ãœcret gider',0),(554801,15412,'pl','Koszt wynagrodzenia',0),(554802,15412,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð°',0),(554803,15412,'ur','Ù…Ù†ÛŒ Ù…Ù… ÙˆÛŒØ¬ Ú©Û’ Ø®Ø±Ú†',0),(554804,15412,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ð¿Ð»Ð°Ñ‚Ð°',0),(554805,15412,'vi','Chi phÃ­ lÆ°Æ¡ng',0),(554806,15412,'af','Salaris uitgawe',0),(554807,15412,'ro','Cheltuieli salariale',0),(554808,15412,'et','Palga arvelt',0),(554809,15412,'si','StroÅ¡ke plaÄ',0),(554810,15412,'ba','Upah pengeluaran',0),(554811,15412,'nl','Loon-kosten',0),(554812,15412,'fi','Palkkojen Expense',0),(554813,15412,'no','LÃ¸nns bekostning',0),(554814,15412,'da','LÃ¸n udgift',0),(554815,15412,'ko','ìž„ê¸ˆ ë¹„ìš©',0),(554816,15412,'he','×”×•×¦××•×ª ×©×›×¨',0),(554817,15412,'el','Î•Î¾ÏŒÎ´Ï‰Î½ Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(554818,15412,'zh','å·¥èµ„è´¹ç”¨',0),(554819,15412,'sv','LÃ¶ne bekostnad',0),(554820,15412,'it','Spese di salario',0),(554821,15412,'tl','',0),(554822,15412,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢',0),(554823,15412,'hi','à¤µà¥‡à¤¤à¤¨ à¤µà¥à¤¯à¤¯',0),(554824,15412,'ms','Perbelanjaan gaji',0),(554825,15412,'ar','Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø£Ø¬ÙˆØ±',0),(554826,15412,'fr','Frais de salaires',0),(554827,15412,'jp','è³ƒé‡‘è²»ç”¨',0),(554828,15412,'pt','Despesa de salÃ¡rios',0),(554829,15412,'ru','Ð¡Ñ‡ÐµÑ‚ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(554830,15412,'es','Gasto de salario',0),(554831,15412,'de','Lohn-Kosten',0),(554832,15412,'en','Wage Expense',0),(554833,15413,'is','',0),(554834,15413,'dr','Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Comp Ù‡Ø²ÛŒÙ†Ù‡',0),(554835,15413,'pr','Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Comp Ù‡Ø²ÛŒÙ†Ù‡',0),(554836,15413,'tr','Ä°ÅŸÃ§i Comp gider',0),(554837,15413,'pl','PracownikÃ³w zÅ‚ koszt',0),(554838,15413,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ‡ÐµÑÐºÐ° Comp Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(554839,15413,'ur','Ú©Ø§Ø±Ú©Ù†ÙˆÚº Ú©ÛŒ Ú©Ø¹Ù…Ù¾ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(554840,15413,'sr','Ðž Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ñ€Ð°Ð´Ð½Ð¸ÐºÐ° Ð¦Ð¾Ð¼Ð¿',0),(554841,15413,'vi','CÃ´ng nhÃ¢n Comp chi phÃ­',0),(554842,15413,'af','Werkers se Comp uitgawe',0),(554843,15413,'ro','LucrÄƒtorilor Comp cheltuieli',0),(554844,15413,'et','TÃ¶Ã¶tajate Comp kulu',0),(554845,15413,'si','Delavcev Comp stroÅ¡ke',0),(554846,15413,'ba','Pekerja Comp biaya',0),(554847,15413,'nl','Werknemers Comp kosten',0),(554848,15413,'fi','TyÃ¶ntekijÃ¶iden Comp kustannuksella',0),(554849,15413,'no','Arbeidernes komp bekostning',0),(554850,15413,'da','Arbejdstagernes Comp udgift',0),(554851,15413,'ko','ë…¸ë™ìžì˜ ë³´ìƒ ë¹„ìš©',0),(554852,15413,'he','×—×©×‘×•×Ÿ ×”×¤×™×¦×•×™×™× ×©×œ ×”×¢×•×‘×“×™×',0),(554853,15413,'el','Î•ÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Comp Î´Î±Ï€Î¬Î½Î·',0),(554854,15413,'zh','å·¥äººçš„ Comp æ”¯å‡º',0),(554855,15413,'sv','Arbetstagarnas Comp bekostnad',0),(554856,15413,'it','Comp spese lavoratori',0),(554857,15413,'tl','',0),(554858,15413,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸„à¹ˆà¸²à¸•à¸­à¸šà¹à¸—à¸™à¸œà¸¹à¹‰à¸›à¸à¸´à¸šà¸±à¸•à¸´à¸‡à¸²à¸™',0),(554859,15413,'hi','à¤¶à¥à¤°à¤®à¤¿à¤• Comp à¤µà¥à¤¯à¤¯',0),(554860,15413,'ms','Pekerja Comp perbelanjaan',0),(554861,15413,'ar','Ø­Ø³Ø§Ø¨ Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø¹Ù…Ø§Ù„',0),(554862,15413,'fr','Comp frais Workers\'',0),(554863,15413,'jp','åŠ´åƒè€…ã® Comp è²»ç”¨',0),(554864,15413,'pt','Comp despesa trabalhadores',0),(554865,15413,'ru','Ð¡Ñ‡ÐµÑ‚ Comp Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð²',0),(554866,15413,'es','Gasto de compensaciÃ³n de trabajadores',0),(554867,15413,'de','Lasten der Arbeitnehmer Comp',0),(554868,15413,'en','Workers\' Comp Expense',0),(554869,15414,'is','',0),(554870,15414,'dr','Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø¨Ù‡ Ù¾Ø³Øª Ø§Ø² Ø¯ÙˆØ±Ù‡ Ø´ÙˆØ¯ØŸ',0),(554871,15414,'pr','Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø¨Ù‡ Ù¾Ø³Øª Ø§Ø² Ø¯ÙˆØ±Ù‡ Ø´ÙˆØ¯ØŸ',0),(554872,15414,'tr','SÃ¼re dÄ±ÅŸarÄ± gÃ¶ndermek istediÄŸinizden emin misiniz?',0),(554873,15414,'pl','Czy na pewno chcesz zaksiÄ™gowaÄ‡ z okresu?',0),(554874,15414,'bg','Ð’Ð¸Ðµ ÑÑ‚Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸, Ñ‡Ðµ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¿ÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ñ‚Ðµ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´?',0),(554875,15414,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ù¾ÙˆØ³Ù¹ Ø³Û’ Ø¯ÙˆØ± Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(554876,15414,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° ÐºÑšÐ¸Ð¶Ð¸Ñ‚Ðµ Ð¸Ð· Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°?',0),(554877,15414,'vi','Báº¡n cÃ³ cháº¯c báº¡n muá»‘n gá»­i ra khá»i thá»i gian khÃ´ng?',0),(554878,15414,'af','Is jy seker jy wil pos uit tydperk?',0),(554879,15414,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ Ã®nregistraÅ£i din perioada?',0),(554880,15414,'et','Kas soovite kindlasti vÃ¤lja perioodi sisestatavate?',0),(554881,15414,'si','Ali ste prepriÄani, da Å¾elite poslati iz obdobja?',0),(554882,15414,'ba','Apakah Anda yakin Anda ingin posting dari masa?',0),(554883,15414,'nl','Weet u zeker dat u wilt posten uit de periode?',0),(554884,15414,'fi','Oletko varma, ettÃ¤ haluat kirjata ulos aikana?',0),(554885,15414,'no','Er du sikker du vil postere av periode?',0),(554886,15414,'da','Er du sikker pÃ¥ du vil sende ud af perioden?',0),(554887,15414,'ko','ë‹¹ì‹ ì€ ê¸°ê°„ ì¤‘ ê²Œì‹œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(554888,15414,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×”×¦×™×‘ ×”×ª×§×•×¤×”?',0),(554889,15414,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÏ„Îµ Î±Ï€ÏŒ Ï€ÎµÏÎ¯Î¿Î´Î¿;',0),(554890,15414,'zh','ä½ ç¡®å®šä½ è¦å¯„å‡ºæœŸ?',0),(554891,15414,'sv','Ã„r du sÃ¤ker du vill bokfÃ¶ra ur Period?',0),(554892,15414,'it','Sei sicuro di che voler postare fuori periodo?',0),(554893,15414,'tl','',0),(554894,15414,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸ˆà¸²à¸à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸—à¸µà¹ˆà¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(554895,15414,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤…à¤µà¤§à¤¿ à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(554896,15414,'ms','Adakah anda pasti anda mahu pos daripada tempoh?',0),(554897,15414,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ ÙˆØ¸ÙŠÙØ© Ù…Ù† Ø£ØµÙ„ Ø§Ù„ÙØªØ±Ø©ØŸ',0),(554898,15414,'fr','ÃŠtes-vous certain de que vouloir poster hors pÃ©riode ?',0),(554899,15414,'jp','æœŸé–“å¤–ã‚’æŠ•ç¨¿ã™ã‚‹ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(554900,15414,'pt','Tem certeza que deseja publicar fora do perÃ­odo?',0),(554901,15414,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ñ‚ÑŒ Ð¸Ð· Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°?',0),(554902,15414,'es','Â¿Es seguro de que desea publicar fuera de plazo?',0),(554903,15414,'de','Sind Sie sicher, dass Sie aus Zeitraum buchen mÃ¶chten?',0),(554904,15414,'en','Are You Sure You Want To Post Out Of Period?',0),(554905,15415,'is','',0),(554906,15415,'dr','Ø§Ø³ Ø§Ø³',0),(554907,15415,'pr','Ø§Ø³ Ø§Ø³',0),(554908,15415,'tr','SS',0),(554909,15415,'pl','SS',0),(554910,15415,'bg','Ð¡Ð¡',0),(554911,15415,'ur','Ø§ÛŒØ³ Ø§ÛŒØ³',0),(554912,15415,'sr','Ð¡Ð¡-Ð',0),(554913,15415,'vi','SS',0),(554914,15415,'af','SS',0),(554915,15415,'ro','SS',0),(554916,15415,'et','SS',0),(554917,15415,'si','SS',0),(554918,15415,'ba','SS',0),(554919,15415,'nl','SS',0),(554920,15415,'fi','SS',0),(554921,15415,'no','SS',0),(554922,15415,'da','SS',0),(554923,15415,'ko','SS',0),(554924,15415,'he','×”××¡. ××¡',0),(554925,15415,'el','SS',0),(554926,15415,'zh','SS',0),(554927,15415,'sv','SS',0),(554928,15415,'it','SS',0),(554929,15415,'tl','',0),(554930,15415,'th','SS',0),(554931,15415,'hi','à¤à¤¸ à¤à¤¸',0),(554932,15415,'ms','SS',0),(554933,15415,'ar','SS',0),(554934,15415,'fr','SS',0),(554935,15415,'jp','SS',0),(554936,15415,'pt','SS',0),(554937,15415,'ru','SS',0),(554938,15415,'es','SS',0),(554939,15415,'de','SS',0),(554940,15415,'en','SS',0),(554941,15416,'is','',0),(554942,15416,'dr','Ù…Ø§Ù„ÛŒØ§Øª Ø´Ø±Ú©Øª Ø§Ø³ Ø§Ø³',0),(554943,15416,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ø´Ø±Ú©Øª Ø§Ø³ Ø§Ø³',0),(554944,15416,'tr','Co SS vergi',0),(554945,15416,'pl','Co SS podatku',0),(554946,15416,'bg','Co Ð¡Ð¡ Ð´Ð°Ð½ÑŠÐº',0),(554947,15416,'ur','Co Ø§ÛŒØ³ Ø§ÛŒØ³ Ù¹ÛŒÚ©Ø³',0),(554948,15416,'sr','Ð¦Ð¾ Ð¡Ð¡ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(554949,15416,'vi','Co SS thuáº¿',0),(554950,15416,'af','Co SS belasting',0),(554951,15416,'ro','Taxa de SS co',0),(554952,15416,'et','Co SS maksu',0),(554953,15416,'si','Co SS davka',0),(554954,15416,'ba','Co SS pajak',0),(554955,15416,'nl','Co SS belasting',0),(554956,15416,'fi','Co SS vero',0),(554957,15416,'no','Co SS Tax',0),(554958,15416,'da','Co SS skat',0),(554959,15416,'ko','Co SS ì„¸ê¸ˆ',0),(554960,15416,'he','Co SS ×ž×¡',0),(554961,15416,'el','SS Ï†ÏŒÏÎ¿Ï… Co',0),(554962,15416,'zh','Co SS ç¨Ž',0),(554963,15416,'sv','Co SS skatt',0),(554964,15416,'it','Co SS fiscale',0),(554965,15416,'tl','',0),(554966,15416,'th','à¸ à¸²à¸©à¸µà¸šà¸£à¸´à¸©à¸±à¸— SS',0),(554967,15416,'hi','à¤¸à¤¹ SS à¤Ÿà¥ˆà¤•à¥à¤¸',0),(554968,15416,'ms','Ko SS cukai',0),(554969,15416,'ar','Ø´Ø±ÙƒØ© SS Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(554970,15416,'fr','Taxe de SS Co',0),(554971,15416,'jp','Co SS ç¨Ž',0),(554972,15416,'pt','Imposto de SS de co',0),(554973,15416,'ru','Co Ð¡Ð¡ Ð½Ð°Ð»Ð¾Ð³',0),(554974,15416,'es','Impuestos de SS Co',0),(554975,15416,'de','Co-Steuer',0),(554976,15416,'en','Co SS Tax',0),(554977,15417,'is','',0),(554978,15417,'dr','Ø§Ø³ Ø§Ø³ Ù…Ø§Ù„ÛŒØ§Øª',0),(554979,15417,'pr','Ø§Ø³ Ø§Ø³ Ù…Ø§Ù„ÛŒØ§Øª',0),(554980,15417,'tr','SS vergi',0),(554981,15417,'pl','Podatek od SS',0),(554982,15417,'bg','Ð¡Ð¡ Ð´Ð°Ð½ÑŠÐº',0),(554983,15417,'ur','Ø§ÛŒØ³ Ø§ÛŒØ³ Ù¹ÛŒÚ©Ø³',0),(554984,15417,'sr','Ð¡Ð¡ Ð¿Ð¾Ñ€ÐµÐ·',0),(554985,15417,'vi','SS thuáº¿',0),(554986,15417,'af','SS belasting',0),(554987,15417,'ro','SS fiscale',0),(554988,15417,'et','SS maksu',0),(554989,15417,'si','SS davka',0),(554990,15417,'ba','SS pajak',0),(554991,15417,'nl','SS belasting',0),(554992,15417,'fi','SS veroja',0),(554993,15417,'no','SS Tax',0),(554994,15417,'da','SS skat',0),(554995,15417,'ko','SS ì„¸ê¸ˆ',0),(554996,15417,'he','×”××¡. ××¡ ×ž×¡',0),(554997,15417,'el','SS Ï†ÏŒÏÎ¿Ï…',0),(554998,15417,'zh','SS ç¨Ž',0),(554999,15417,'sv','SS skatt',0),(555000,15417,'it','SS fiscale',0),(555001,15417,'tl','',0),(555002,15417,'th','à¸ à¸²à¸©à¸µ SS',0),(555003,15417,'hi','à¤à¤¸à¤à¤¸ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(555004,15417,'ms','Cukai SS',0),(555005,15417,'ar','Ø¶Ø±ÙŠØ¨Ø© SS',0),(555006,15417,'fr','ImpÃ´t sÃ©c.',0),(555007,15417,'jp','SS ç¨Ž',0),(555008,15417,'pt','Imposto de SS',0),(555009,15417,'ru','Ð¡Ð¡ Ð½Ð°Ð»Ð¾Ð³',0),(555010,15417,'es','Impuesto de SS',0),(555011,15417,'de','-Steuer',0),(555012,15417,'en','SS Tax',0),(555013,15418,'is','',0),(555014,15418,'dr','Ù†Ø´Ø§Ù† Ø¯Ù‡Ø¯ ÙÙ‚Ø· Ø¬Ù…Ø¹',0),(555015,15418,'pr','Ù†Ø´Ø§Ù† Ø¯Ù‡Ø¯ ÙÙ‚Ø· Ø¬Ù…Ø¹',0),(555016,15418,'tr','YalnÄ±zca toplamlarÄ± gÃ¶ster',0),(555017,15418,'pl','PokaÅ¼ tylko sumy',0),(555018,15418,'bg','ÐŸÐ¾ÐºÐ°Ð¶ÐµÑ‚Ðµ ÑÐ°Ð¼Ð¾ Ð¾Ð±Ñ‰Ð¸Ñ‚Ðµ ÑÑƒÐ¼Ð¸',0),(555019,15418,'ur','ØµØ±Ù Ù…ÛŒØ²Ø§Ù† Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(555020,15418,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÐ°Ð¼Ð¾ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(555021,15418,'vi','Tá»•ng sá»‘ chá»‰ hiá»ƒn thá»‹',0),(555022,15418,'af','Wys enigste totale',0),(555023,15418,'ro','AratÄƒ numai totaluri',0),(555024,15418,'et','Kuvada ainult kogusummad',0),(555025,15418,'si','Pokazati samo vsote',0),(555026,15418,'ba','Tampilkan hanya jumlah',0),(555027,15418,'nl','Toon alleen totalen',0),(555028,15418,'fi','NÃ¤ytÃ¤ vain kokonaissummat',0),(555029,15418,'no','Vise bare Summer',0),(555030,15418,'da','Vis kun totaler',0),(555031,15418,'ko','ë§Œ í•©ê³„ í‘œì‹œ',0),(555032,15418,'he','×œ×”×¨××•×ª ×¡×›×•×ž×™× ×›×•×œ×œ×™× ×‘×œ×‘×“',0),(555033,15418,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î¼ÏŒÎ½Î¿ Ï„Ï‰Î½ ÏƒÏ…Î½ÏŒÎ»Ï‰Î½',0),(555034,15418,'zh','æ˜¾ç¤ºå”¯ä¸€åˆè®¡',0),(555035,15418,'sv','Visa endast summor',0),(555036,15418,'it','Visualizzare solo i totali',0),(555037,15418,'tl','',0),(555038,15418,'th','à¹à¸ªà¸”à¸‡à¹€à¸‰à¸žà¸²à¸°à¸œà¸¥à¸£à¸§à¸¡',0),(555039,15418,'hi','à¤•à¥‡à¤µà¤² à¤¯à¥‹à¤— à¤¦à¤¿à¤–à¤¾à¤¨à¥‡',0),(555040,15418,'ms','Menunjukkan hanya jumlah',0),(555041,15418,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠØ§Øª ÙÙ‚Ø·',0),(555042,15418,'fr','Afficher seulement les totaux',0),(555043,15418,'jp','åˆè¨ˆã®ã¿ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(555044,15418,'pt','Mostrar apenas os totais',0),(555045,15418,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¸Ñ‚Ð¾Ð³Ð¸',0),(555046,15418,'es','Mostrar sÃ³lo los totales',0),(555047,15418,'de','Anzeigen von nur Summen',0),(555048,15418,'en','Show Only Totals',0),(555049,15419,'is','',0),(555050,15419,'dr','Ú©Ø³Ø± ØªØ§ Ø¨Ù‡ Ø§Ù…Ø±ÙˆØ²',0),(555051,15419,'pr','Ú©Ø³Ø± ØªØ§ Ø¨Ù‡ Ø§Ù…Ø±ÙˆØ²',0),(555052,15419,'tr','Kesintiler bugÃ¼ne',0),(555053,15419,'pl','PotrÄ…cenia na bieÅ¼Ä…co',0),(555054,15419,'bg','ÐžÑ‚Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ ÐºÑŠÐ¼ Ð´Ð°Ñ‚Ð°',0),(555055,15419,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ú©Ù¹ÙˆØªÛŒ',0),(555056,15419,'sr','ÐžÐ´Ð±Ð¸Ñ‚ÐºÐµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(555057,15419,'vi','Khoáº£n kháº¥u trá»« Ä‘áº¿n nay',0),(555058,15419,'af','Aftrekkings datum',0),(555059,15419,'ro','Deduceri la data',0),(555060,15419,'et','Mahaarvamiste kuupÃ¤ev',0),(555061,15419,'si','Odbitki za datum',0),(555062,15419,'ba','Pemotongan tanggal',0),(555063,15419,'nl','Aftrek tot nu toe',0),(555064,15419,'fi','PidÃ¤tykset, pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(555065,15419,'no','Fradrag hittil',0),(555066,15419,'da','Fradrag til dato',0),(555067,15419,'ko','ë‚ ì§œë¥¼ ê³µì œ',0),(555068,15419,'he','× ×™×›×•×™×™× ×œ×ª××¨×™×š',0),(555069,15419,'el','ÎœÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î¼Î­Ï‡ÏÎ¹ ÏƒÎ®Î¼ÎµÏÎ±',0),(555070,15419,'zh','åˆ°ç›®å‰ä¸ºæ­¢çš„æ‰£å‡',0),(555071,15419,'sv','Avdrag hittills',0),(555072,15419,'it','Detrazioni per data',0),(555073,15419,'tl','',0),(555074,15419,'th','à¸«à¸±à¸à¸§à¸±à¸™à¸—à¸µà¹ˆ',0),(555075,15419,'hi','à¤¤à¤¿à¤¥à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(555076,15419,'ms','Potongan sehingga kini',0),(555077,15419,'ar','Ø®ØµÙˆÙ…Ø§Øª Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(555078,15419,'fr','Retenues Ã  ce jour',0),(555079,15419,'jp','ã¾ã§æŽ§é™¤',0),(555080,15419,'pt','DeduÃ§Ãµes Ã  data',0),(555081,15419,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚Ñ‹ Ð½Ð° ÑÐµÐ³Ð¾Ð´Ð½ÑÑˆÐ½Ð¸Ð¹ Ð´ÐµÐ½ÑŒ',0),(555082,15419,'es','DeducciÃ³n hasta la fecha',0),(555083,15419,'de','AbzÃ¼ge bis heute',0),(555084,15419,'en','Deductions To Date',0),(555085,15420,'is','',0),(555086,15420,'dr','Ø±ÙˆØ´ Ú©Ø³Ø±',0),(555087,15420,'pr','Ø±ÙˆØ´ Ú©Ø³Ø±',0),(555088,15420,'tr','Kesinti yÃ¶ntemi',0),(555089,15420,'pl','Metoda odliczenia',0),(555090,15420,'bg','ÐœÐµÑ‚Ð¾Ð´ Ð½Ð° Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ',0),(555091,15420,'ur','Ù…Ø¬Ø±Ø§Ø¦ÛŒ Ø·Ø±ÛŒÙ‚Û',0),(555092,15420,'sr','Ð”ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð¼ÐµÑ‚Ð¾Ð´Ð¾Ð¼',0),(555093,15420,'vi','PhÆ°Æ¡ng phÃ¡p kháº¥u trá»«',0),(555094,15420,'af','Aftrekking metode',0),(555095,15420,'ro','MetodÄƒ de deducere',0),(555096,15420,'et','Mahaarvamise meetod',0),(555097,15420,'si','Metoda odbitka',0),(555098,15420,'ba','Metode deduksi',0),(555099,15420,'nl','Methode van aftrek',0),(555100,15420,'fi','VÃ¤hennys menetelmÃ¤',0),(555101,15420,'no','Fradrag metode',0),(555102,15420,'da','Metode med fradrag',0),(555103,15420,'ko','ê³µì œ ë°©ë²•',0),(555104,15420,'he','×©×™×˜×ª × ×™×›×•×™',0),(555105,15420,'el','Î— Î¼Î­Î¸Î¿Î´Î¿Ï‚ Î±Ï†Î±Î¯ÏÎµÏƒÎ·',0),(555106,15420,'zh','æŽ¨å¯¼æ³•',0),(555107,15420,'sv','Avdrag metod',0),(555108,15420,'it','Metodo di deduzione',0),(555109,15420,'tl','',0),(555110,15420,'th','à¸§à¸´à¸˜à¸µà¸«à¸±à¸',0),(555111,15420,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤ªà¤¦à¥à¤§à¤¤à¤¿',0),(555112,15420,'ms','Kaedah potongan',0),(555113,15420,'ar','Ø£Ø³Ù„ÙˆØ¨ Ø§Ù„Ø®ØµÙ…',0),(555114,15420,'fr','MÃ©thode de dÃ©duction',0),(555115,15420,'jp','æŽ§é™¤æ³•',0),(555116,15420,'pt','MÃ©todo de deduÃ§Ã£o',0),(555117,15420,'ru','ÐœÐµÑ‚Ð¾Ð´ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ð¸',0),(555118,15420,'es','MÃ©todo de deducciÃ³n',0),(555119,15420,'de','Abzugsmethode',0),(555120,15420,'en','Deduction Method',0),(555121,15421,'is','',0),(555122,15421,'dr','Ø­Ø¯Ø§Ú©Ø«Ø± Ù…Ù‚Ø¯Ø§Ø±',0),(555123,15421,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± Ù…Ù‚Ø¯Ø§Ø±',0),(555124,15421,'tr','Maksimum tutar',0),(555125,15421,'pl','Maksymalna kwota',0),(555126,15421,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° ÑÑƒÐ¼Ð°',0),(555127,15421,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø±Ù‚Ù…',0),(555128,15421,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ',0),(555129,15421,'vi','Sá»‘ tiá»n tá»‘i Ä‘a',0),(555130,15421,'af','Maksimum bedrag',0),(555131,15421,'ro','Suma maximÄƒ',0),(555132,15421,'et','Maksimumsumma',0),(555133,15421,'si','NajviÅ¡ji znesek',0),(555134,15421,'ba','Jumlah maksimum',0),(555135,15421,'nl','Maximumbedrag',0),(555136,15421,'fi','EnimmÃ¤ismÃ¤Ã¤rÃ¤',0),(555137,15421,'no','Maksimale',0),(555138,15421,'da','MaksimumbelÃ¸b',0),(555139,15421,'ko','ìµœëŒ€ ê¸ˆì•¡',0),(555140,15421,'he','×”×¡×›×•× ×”×ž×§×¡×™×ž×œ×™',0),(555141,15421,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î¿ Ï€Î¿ÏƒÏŒ',0),(555142,15421,'zh','æœ€å¤§é‡‘é¢',0),(555143,15421,'sv','HÃ¶gsta belopp',0),(555144,15421,'it','Importo massimo',0),(555145,15421,'tl','',0),(555146,15421,'th','à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(555147,15421,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤°à¤¾à¤¶à¤¿',0),(555148,15421,'ms','Amaun maksimum yang',0),(555149,15421,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ù„Ù…Ø¨Ù„Øº',0),(555150,15421,'fr','Montant maximal',0),(555151,15421,'jp','æœ€å¤§é‡‘é¡',0),(555152,15421,'pt','Montante mÃ¡ximo',0),(555153,15421,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ ÑÑƒÐ¼Ð¼Ð°',0),(555154,15421,'es','Cantidad mÃ¡xima',0),(555155,15421,'de','HÃ¶chstbetrag',0),(555156,15421,'en','Maximum Amount',0),(555157,15422,'is','',0),(555158,15422,'dr','Ø¨Ø¯ÙˆÙ† Ú©Ø³Ø±',0),(555159,15422,'pr','Ø¨Ø¯ÙˆÙ† Ú©Ø³Ø±',0),(555160,15422,'tr','HiÃ§bir kesintiler',0),(555161,15422,'pl','Nie ma ulg',0),(555162,15422,'bg','ÐÑÐ¼Ð° ÑƒÐ´Ñ€ÑŠÐ¶ÐºÐ¸',0),(555163,15422,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ù¹ÙˆØªÛŒ',0),(555164,15422,'sr','ÐÐµÐ¼Ð° Ð¾Ð´Ð±Ð¸Ñ‚ÐºÐµ',0),(555165,15422,'vi','KhÃ´ng cÃ³ khoáº£n kháº¥u trá»«',0),(555166,15422,'af','Geen aftrekkings',0),(555167,15422,'ro','Nici de reÈ›ineri',0),(555168,15422,'et','Mahaarvamised pole',0),(555169,15422,'si','Brez odbitkov',0),(555170,15422,'ba','Ada pemotongan',0),(555171,15422,'nl','Geen inhoudingen',0),(555172,15422,'fi','Ilman vÃ¤hennyksiÃ¤',0),(555173,15422,'no','Uten fradrag',0),(555174,15422,'da','Ingen fradrag',0),(555175,15422,'ko','ì•„ë¬´ ê³µì œ',0),(555176,15422,'he','××™×Ÿ × ×™×›×•×™×™×',0),(555177,15422,'el','Î”ÎµÎ½ ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½',0),(555178,15422,'zh','æ²¡æœ‰æ‰£å‡',0),(555179,15422,'sv','Inget avdrag',0),(555180,15422,'it','Senza detrazioni',0),(555181,15422,'tl','',0),(555182,15422,'th','à¹„à¸¡à¹ˆà¸«à¸±à¸',0),(555183,15422,'hi','à¤•à¥‹à¤ˆ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(555184,15422,'ms','Tiada potongan',0),(555185,15422,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø§Ù‚ØªØ·Ø§Ø¹Ø§Øª',0),(555186,15422,'fr','Aucune dÃ©duction',0),(555187,15422,'jp','ãªã„æŽ§é™¤',0),(555188,15422,'pt','Sem deduÃ§Ãµes',0),(555189,15422,'ru','Ð‘ÐµÐ· Ð²Ñ‹Ñ‡ÐµÑ‚Ð¾Ð²',0),(555190,15422,'es','Sin deducciones',0),(555191,15422,'de','Ohne Abzug',0),(555192,15422,'en','No Deductions',0),(555193,15423,'is','',0),(555194,15423,'dr','Ù…Ø¯Øª Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(555195,15423,'pr','Ù…Ø¯Øª Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(555196,15423,'tr','Kalan sÃ¼re',0),(555197,15423,'pl','PozostaÅ‚e okresy',0),(555198,15423,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸ Ð½Ð° Ð¾ÑÑ‚Ð°Ð½Ð°Ð»Ð¸Ñ‚Ðµ',0),(555199,15423,'ur','Ø¨Ø§Ù‚ÛŒ Ø§Ø¯ÙˆØ§Ø±',0),(555200,15423,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸ Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾',0),(555201,15423,'vi','Thá»i gian cÃ²n láº¡i',0),(555202,15423,'af','Tydperke oor',0),(555203,15423,'ro','Perioade rÄƒmasÄƒ',0),(555204,15423,'et','ÃœlejÃ¤Ã¤nud perioodide',0),(555205,15423,'si','Obdobja preostale',0),(555206,15423,'ba','Waktu tersisa',0),(555207,15423,'nl','Perioden resterende',0),(555208,15423,'fi','JÃ¤ljellÃ¤ olevien kausien',0),(555209,15423,'no','GjenstÃ¥ende',0),(555210,15423,'da','Perioder resterende',0),(555211,15423,'ko','ë‚¨ì€ ê¸°ê°„',0),(555212,15423,'he','×‘×ª×§×•×¤×•×ª ×”× ×•×ª×¨×™×',0),(555213,15423,'el','Î ÎµÏÎ¹ÏŒÎ´Î¿Ï…Ï‚ Ï€Î¿Ï… Î±Ï€Î¿Î¼Î­Î½Î¿Ï…Î½',0),(555214,15423,'zh','å‰©ä½™çš„æ—¶é—´',0),(555215,15423,'sv','Perioder Ã¥terstÃ¥ende',0),(555216,15423,'it','Restanti periodi',0),(555217,15423,'tl','',0),(555218,15423,'th','à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸—à¸µà¹ˆà¹€à¸«à¸¥à¸·à¸­',0),(555219,15423,'hi','à¤¶à¥‡à¤· à¤…à¤µà¤§à¤¿',0),(555220,15423,'ms','Tempoh tinggal',0),(555221,15423,'ar','Ø§Ù„ÙØªØ±Ø§Øª Ø§Ù„Ù…ØªØ¨Ù‚ÙŠØ©',0),(555222,15423,'fr','PÃ©riodes restantes',0),(555223,15423,'jp','æ®‹ã‚ŠæœŸé–“',0),(555224,15423,'pt','PerÃ­odos remanescentes',0),(555225,15423,'ru','ÐžÑÑ‚Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñ‹',0),(555226,15423,'es','Periodos restantes',0),(555227,15423,'de','Verbleibenden Perioden',0),(555228,15423,'en','Periods Remaining',0),(555229,15424,'is','',0),(555230,15424,'dr','Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Comp Ú©Ø¯',0),(555231,15424,'pr','Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Comp Ú©Ø¯',0),(555232,15424,'tr','Ä°ÅŸÃ§i Comp kodu',0),(555233,15424,'pl','PracownikÃ³w Comp kod',0),(555234,15424,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ‡ÐµÑÐºÐ° Comp ÐºÐ¾Ð´',0),(555235,15424,'ur','Ú©Ø§Ø±Ú©Ù†ÙˆÚº Ú©ÛŒ Ú©Ø¹Ù…Ù¾ Ú©ÙˆÚˆ',0),(555236,15424,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ñ€Ð°Ð´Ð½Ð¸ÐºÐ° Ð¦Ð¾Ð¼Ð¿',0),(555237,15424,'vi','CÃ´ng nhÃ¢n Comp mÃ£',0),(555238,15424,'af','Werkers se Comp kode',0),(555239,15424,'ro','LucrÄƒtorilor Comp cod',0),(555240,15424,'et','TÃ¶Ã¶tajate Comp kood',0),(555241,15424,'si','Delavcev Comp kodo',0),(555242,15424,'ba','Pekerja Comp kode',0),(555243,15424,'nl','Werknemers Comp Code',0),(555244,15424,'fi','TyÃ¶ntekijÃ¶iden Comp koodi',0),(555245,15424,'no','Arbeidernes komp kode',0),(555246,15424,'da','Arbejdstagernes Comp kode',0),(555247,15424,'ko','ë…¸ë™ìžì˜ Comp ì½”ë“œ',0),(555248,15424,'he','Comp ×§×•×“ ×”×¢×•×‘×“×™×',0),(555249,15424,'el','Î•ÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Comp ÎºÏŽÎ´Î¹ÎºÎ±',0),(555250,15424,'zh','å·¥äººçš„ Comp ä»£ç ',0),(555251,15424,'sv','Arbetstagarnas Comp kod',0),(555252,15424,'it','Comp codice lavoratori',0),(555253,15424,'tl','',0),(555254,15424,'th','à¸£à¸«à¸±à¸ªà¸„à¹ˆà¸²à¸•à¸­à¸šà¹à¸—à¸™à¸œà¸¹à¹‰à¸›à¸à¸´à¸šà¸±à¸•à¸´à¸‡à¸²à¸™',0),(555255,15424,'hi','à¤¶à¥à¤°à¤®à¤¿à¤• Comp à¤•à¥‹à¤¡',0),(555256,15424,'ms','Pekerja Comp kod',0),(555257,15424,'ar','Ø±Ù…Ø² Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø¹Ù…Ø§Ù„',0),(555258,15424,'fr','Workers\' Comp Code',0),(555259,15424,'jp','åŠ´åƒè€…ã®ã‚³ãƒ³ãƒ—ã®ã‚³ãƒ¼ãƒ‰',0),(555260,15424,'pt','Comp cÃ³digo trabalhadores',0),(555261,15424,'ru','ÐšÐ¾Ð´ Comp Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð²',0),(555262,15424,'es','CÃ³digo de compensaciÃ³n de trabajadores',0),(555263,15424,'de','Arbeitnehmer-Comp-Code',0),(555264,15424,'en','Workers\' Comp Code',0),(555265,15425,'is','',0),(555266,15425,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(555267,15425,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(555268,15425,'tr','Ã‡alÄ±ÅŸan bir daha gÃ¶zden geÃ§irme',0),(555269,15425,'pl','Oceny pracownika',0),(555270,15425,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€ÐµÐ³Ð»ÐµÐ´',0),(555271,15425,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Ø§ Ø¬Ø§Ø¦Ø²Û',0),(555272,15425,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(555273,15425,'vi','NhÃ¢n viÃªn Ä‘Ã¡nh giÃ¡',0),(555274,15425,'af','Werknemer hersiening',0),(555275,15425,'ro','Angajat Review',0),(555276,15425,'et','TÃ¶Ã¶taja Ã¼levaade',0),(555277,15425,'si','Pregled zaposlenih',0),(555278,15425,'ba','Karyawan Review',0),(555279,15425,'nl','Werknemer Review',0),(555280,15425,'fi','TyÃ¶ntekijÃ¤n tarkastelu',0),(555281,15425,'no','Medarbeider vurdering',0),(555282,15425,'da','Medarbejder anmeldelse',0),(555283,15425,'ko','ì§ì› ê²€í† ',0),(555284,15425,'he','×”×¢×•×‘×“ ×¡×§×™×¨×”',0),(555285,15425,'el','Î‘Î¾Î¹Î¿Î»ÏŒÎ³Î·ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(555286,15425,'zh','å‘˜å·¥è€ƒæ ¸',0),(555287,15425,'sv','Medarbetaren recension',0),(555288,15425,'it','Recensione di dipendente',0),(555289,15425,'tl','',0),(555290,15425,'th','à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(555291,15425,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(555292,15425,'ms','Kajian pekerja',0),(555293,15425,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ù…ÙˆØ¸Ù',0),(555294,15425,'fr','Examen de l\'employÃ©',0),(555295,15425,'jp','å¾“æ¥­å“¡ã®è©•ä¾¡',0),(555296,15425,'pt','RevisÃ£o de empregado',0),(555297,15425,'ru','ÐžÐ±Ð·Ð¾Ñ€ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(555298,15425,'es','Informe de empleado',0),(555299,15425,'de','Mitarbeiter-Review',0),(555300,15425,'en','Employee Review',0),(555301,15426,'is','',0),(555302,15426,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø²Ù…Ø§Ù†',0),(555303,15426,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø²Ù…Ø§Ù†',0),(555304,15426,'tr','Saat Ekle',0),(555305,15426,'pl','Dodaj czas',0),(555306,15426,'bg','Ð”Ð¾Ð±Ð°Ð²Ð¸ Ð²Ñ€ÐµÐ¼Ðµ',0),(555307,15426,'ur','ÙˆÙ‚Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(555308,15426,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð°',0),(555309,15426,'vi','ThÃªm thá»i gian',0),(555310,15426,'af','Voeg tyd',0),(555311,15426,'ro','Adauga timp',0),(555312,15426,'et','Lisa aeg',0),(555313,15426,'si','Dodati Äas',0),(555314,15426,'ba','Menambahkan waktu',0),(555315,15426,'nl','Tijd toevoegen',0),(555316,15426,'fi','LisÃ¤Ã¤ aikaa',0),(555317,15426,'no','Legg tiden',0),(555318,15426,'da','TilfÃ¸je tid',0),(555319,15426,'ko','ì‹œê°„ ì¶”ê°€',0),(555320,15426,'he','×œ×”×•×¡×™×£ ×–×ž×Ÿ',0),(555321,15426,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Ï‡ÏÏŒÎ½Î¿',0),(555322,15426,'zh','æ·»åŠ æ—¶é—´',0),(555323,15426,'sv','LÃ¤gga till tid',0),(555324,15426,'it','Aggiungi Time',0),(555325,15426,'tl','',0),(555326,15426,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸§à¸¥à¸²',0),(555327,15426,'hi','à¤¸à¤®à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(555328,15426,'ms','Tambah masa',0),(555329,15426,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„ÙˆÙ‚Øª',0),(555330,15426,'fr','Ajouter du temps',0),(555331,15426,'jp','æ™‚åˆ»ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(555332,15426,'pt','Adicionar tempo',0),(555333,15426,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ',0),(555334,15426,'es','AÃ±adir tiempo',0),(555335,15426,'de','FÃ¼gen Sie Zeit',0),(555336,15426,'en','Add Time',0),(555337,15427,'is','',0),(555338,15427,'dr','Ù…Ø§Ù„ÛŒØ§Øª Ø§Ø¶Ø§ÙÛŒ',0),(555339,15427,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ø§Ø¶Ø§ÙÛŒ',0),(555340,15427,'tr','Ek vergiler',0),(555341,15427,'pl','Dodatkowe podatki',0),(555342,15427,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ñ‚Ð°ÐºÑÐ¸',0),(555343,15427,'ur','Ø§Ø¶Ø§ÙÛŒ Ù¹ÛŒÚ©Ø³',0),(555344,15427,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(555345,15427,'vi','Khoáº£n thuáº¿ phá»¥ trá»£',0),(555346,15427,'af','Addisionele belasting',0),(555347,15427,'ro','Taxe suplimentare',0),(555348,15427,'et','TÃ¤iendavaid makse',0),(555349,15427,'si','Dodatnih davkov',0),(555350,15427,'ba','Pajak tambahan',0),(555351,15427,'nl','Extra belastingen',0),(555352,15427,'fi','LisÃ¤veroa',0),(555353,15427,'no','Ekstra avgifter',0),(555354,15427,'da','Ekstra skatter',0),(555355,15427,'ko','ì¶”ê°€ ì„¸ê¸ˆ',0),(555356,15427,'he','×ž×¡×™× × ×•×¡×¤×™×',0),(555357,15427,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î¿Î¹ Ï†ÏŒÏÎ¿Î¹',0),(555358,15427,'zh','å¢žç¨Ž',0),(555359,15427,'sv','Ytterligare skatter',0),(555360,15427,'it','Tasse aggiuntive',0),(555361,15427,'tl','',0),(555362,15427,'th','à¸ à¸²à¸©à¸µà¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(555363,15427,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤•à¤°à¥‹à¤‚',0),(555364,15427,'ms','Cukai tambahan',0),(555365,15427,'ar','Ø¶Ø±Ø§Ø¦Ø¨ Ø¥Ø¶Ø§ÙÙŠØ©',0),(555366,15427,'fr','Taxes supplÃ©mentaires',0),(555367,15427,'jp','è¿½åŠ ã®ç¨Žé‡‘',0),(555368,15427,'pt','Impostos adicionais',0),(555369,15427,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¸',0),(555370,15427,'es','Impuestos adicionales',0),(555371,15427,'de','ZusÃ¤tzliche Steuern',0),(555372,15427,'en','Additional Taxes',0),(555373,15428,'is','',0),(555374,15428,'dr','EIC Ù¾Ø±Ø¯Ø§Ø®Øª',0),(555375,15428,'pr','EIC Ù¾Ø±Ø¯Ø§Ø®Øª',0),(555376,15428,'tr','GeliÅŸmiÅŸ EIC Ã¶demeler',0),(555377,15428,'pl','Zaawansowane EIC pÅ‚atnoÅ›ci',0),(555378,15428,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¾ Ð•Ð˜Ð¦ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(555379,15428,'ur','Ø§Ø¹Ù„ÛŒ Ø¯Ø±Ø¬Û’ Ú©ÛŒ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(555380,15428,'sr','ÐÐ°Ð¿Ñ€ÐµÐ´Ð½Ð¸ Ð•Ð˜Ð¦ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(555381,15428,'vi','NÃ¢ng cao EIC thanh toÃ¡n',0),(555382,15428,'af','Gevorderde EIC betalings',0),(555383,15428,'ro','PlÄƒÅ£i EIC avansate',0),(555384,15428,'et','EIC ettemaksete tegemisel',0),(555385,15428,'si','Napredno EIC plaÄila',0),(555386,15428,'ba','Advanced EIC pembayaran',0),(555387,15428,'nl','Geavanceerde EIC betalingen',0),(555388,15428,'fi','EIC ennakot',0),(555389,15428,'no','EIC forhÃ¥ndsbetalinger',0),(555390,15428,'da','Avanceret EIC betalinger',0),(555391,15428,'ko','ê³ ê¸‰ EIC ì§€ë¶ˆ',0),(555392,15428,'he','×ª×©×œ×•×ž×™× EIC ×ž×ª×§×“×',0),(555393,15428,'el','Î ÏÎ¿Î·Î³Î¼Î­Î½Î· Î•ÎšÎ  Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(555394,15428,'zh','å…ˆè¿›çš„ EIC ä»˜æ¬¾',0),(555395,15428,'sv','Avancerade EIC betalningar',0),(555396,15428,'it','EIC pagamenti anticipati',0),(555397,15428,'tl','',0),(555398,15428,'th','EIC à¸Šà¸³à¸£à¸°à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡',0),(555399,15428,'hi','à¤‰à¤¨à¥à¤¨à¤¤ EIC à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(555400,15428,'ms','Pendahuluan EIC',0),(555401,15428,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª EIC Ù…ØªÙ‚Ø¯Ù…Ø©',0),(555402,15428,'fr','Avances de CPN',0),(555403,15428,'jp','EIC å‰æ‰•',0),(555404,15428,'pt','Pagamentos EIC avanÃ§ados',0),(555405,15428,'ru','ÐÐ²Ð°Ð½ÑÐ¾Ð²Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð•Ð˜Ð¦',0),(555406,15428,'es','Anticipos de EIC',0),(555407,15428,'de','EIC Anzahlungen',0),(555408,15428,'en','Advanced EIC Payments',0),(555409,15429,'is','',0),(555410,15429,'dr','Ø³Ù†',0),(555411,15429,'pr','Ø³Ù†',0),(555412,15429,'tr','YaÅŸ',0),(555413,15429,'pl','Wieku',0),(555414,15429,'bg','Ð’ÑŠÐ·Ñ€Ð°ÑÑ‚',0),(555415,15429,'ur','Ø¹Ù…Ø±',0),(555416,15429,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð°Ð¼Ð°',0),(555417,15429,'vi','Tuá»•i',0),(555418,15429,'af','Ouderdom',0),(555419,15429,'ro','VÃ¢rsta',0),(555420,15429,'et','Vanus',0),(555421,15429,'si','Starost',0),(555422,15429,'ba','Umur',0),(555423,15429,'nl','Leeftijd',0),(555424,15429,'fi','IkÃ¤',0),(555425,15429,'no','Alder',0),(555426,15429,'da','Alder',0),(555427,15429,'ko','ë‚˜ì´',0),(555428,15429,'he','×’×™×œ',0),(555429,15429,'el','Î—Î»Î¹ÎºÎ¯Î±',0),(555430,15429,'zh','å¹´é¾„',0),(555431,15429,'sv','Ã…lder',0),(555432,15429,'it','EtÃ ',0),(555433,15429,'tl','',0),(555434,15429,'th','à¸­à¸²à¸¢à¸¸',0),(555435,15429,'hi','à¤†à¤¯à¥',0),(555436,15429,'ms','Umur',0),(555437,15429,'ar','Ø§Ù„Ø¹Ù…Ø±',0),(555438,15429,'fr','Age',0),(555439,15429,'jp','å¹´é½¢',0),(555440,15429,'pt','Idade',0),(555441,15429,'ru','Ð’Ð¾Ð·Ñ€Ð°ÑÑ‚',0),(555442,15429,'es','Edad',0),(555443,15429,'de','Alter',0),(555444,15429,'en','Age',0),(555445,15430,'is','',0),(555446,15430,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒÛŒ Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡',0),(555447,15430,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒÛŒ Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡',0),(555448,15430,'tr','AyrÄ±lmÄ±ÅŸ ipuÃ§larÄ±',0),(555449,15430,'pl','Przydzielone porady',0),(555450,15430,'bg','Ð Ð°Ð·Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ‚Ðµ ÑÑŠÐ²ÐµÑ‚Ð¸',0),(555451,15430,'ur','ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û ØªØ¬Ø§ÙˆÛŒØ²',0),(555452,15430,'sr','Ð”Ð¾Ð´ÐµÑ™ÐµÐ½Ð¸ ÑÐ°Ð²ÐµÑ‚Ð¸',0),(555453,15430,'vi','Máº¹o phÃ¢n bá»•',0),(555454,15430,'af','Toegekende wenke',0),(555455,15430,'ro','Alocate sfaturi',0),(555456,15430,'et','Eraldatud Tips',0),(555457,15430,'si','Dodeljene Nasveti',0),(555458,15430,'ba','Dialokasikan Tips',0),(555459,15430,'nl','Toegewezen Tips',0),(555460,15430,'fi','Kohdistettu vinkkejÃ¤',0),(555461,15430,'no','Tilordnede Tips',0),(555462,15430,'da','Tildelte Tips',0),(555463,15430,'ko','í• ë‹¹ ëœ íŒ',0),(555464,15430,'he','×˜×™×¤×™× ×©×”×•×§×¦×”',0),(555465,15430,'el','Î•ÎºÏ‡Ï‰ÏÎ·Î¼Î­Î½Î¿ ÏƒÏ…Î¼Î²Î¿Ï…Î»Î­Ï‚',0),(555466,15430,'zh','å·²åˆ†é…çš„æç¤º',0),(555467,15430,'sv','Tilldelade Tips',0),(555468,15430,'it','Suggerimenti allocati',0),(555469,15430,'tl','',0),(555470,15430,'th','à¹€à¸„à¸¥à¹‡à¸”à¸¥à¸±à¸šà¸à¸²à¸£à¸›à¸±à¸™à¸ªà¹ˆà¸§à¸™',0),(555471,15430,'hi','à¤†à¤¬à¤‚à¤Ÿà¤¿à¤¤ à¤¯à¥à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤',0),(555472,15430,'ms','Tip-Tip yang diperuntukkan',0),(555473,15430,'ar','Ù†ØµØ§Ø¦Ø­ Ø§Ù„Ù…Ø®ØµØµØ©',0),(555474,15430,'fr','Conseils attribuÃ©s',0),(555475,15430,'jp','å‰²ã‚Šå½“ã¦ã‚‰ã‚ŒãŸãƒ’ãƒ³ãƒˆ',0),(555476,15430,'pt','Dicas alocadas',0),(555477,15430,'ru','Ð’Ñ‹Ð´ÐµÐ»ÐµÐ½Ð½Ñ‹Ðµ ÑÐ¾Ð²ÐµÑ‚Ñ‹',0),(555478,15430,'es','Consejos asignados',0),(555479,15430,'de','Zugewiesene Trinkgelder',0),(555480,15430,'en','Allocated Tips',0),(555481,15431,'is','',0),(555482,15431,'dr','Ù…Ø²Ø§ÛŒØ§ÛŒ',0),(555483,15431,'pr','Ù…Ø²Ø§ÛŒØ§ÛŒ',0),(555484,15431,'tr','FaydalarÄ±',0),(555485,15431,'pl','KorzyÅ›ci',0),(555486,15431,'bg','ÐŸÐ¾Ð»Ð·Ð¸',0),(555487,15431,'ur','ÙÙˆØ§Ø¦Ø¯',0),(555488,15431,'sr','Ð‘ÐµÐ½ÐµÑ„Ð¸Ñ†Ð¸Ñ˜Ðµ',0),(555489,15431,'vi','Lá»£i Ã­ch',0),(555490,15431,'af','Voordele',0),(555491,15431,'ro','Beneficii',0),(555492,15431,'et','Kasu',0),(555493,15431,'si','Koristi',0),(555494,15431,'ba','Manfaat',0),(555495,15431,'nl','Voordelen',0),(555496,15431,'fi','Edut',0),(555497,15431,'no','Fordeler',0),(555498,15431,'da','Fordele',0),(555499,15431,'ko','í˜œíƒ',0),(555500,15431,'he','×”×˜×‘×•×ª',0),(555501,15431,'el','ÎŸÏ†Î­Î»Î·',0),(555502,15431,'zh','ç¦åˆ©',0),(555503,15431,'sv','FÃ¶rdelar',0),(555504,15431,'it','Vantaggi',0),(555505,15431,'tl','',0),(555506,15431,'th','à¸›à¸£à¸°à¹‚à¸¢à¸Šà¸™à¹Œ',0),(555507,15431,'hi','à¤²à¤¾à¤­',0),(555508,15431,'ms','Faedah-faedah',0),(555509,15431,'ar','Ø§Ù„ÙÙˆØ§Ø¦Ø¯',0),(555510,15431,'fr','Avantages',0),(555511,15431,'jp','åˆ©ç‚¹',0),(555512,15431,'pt','BenefÃ­cios',0),(555513,15431,'ru','ÐŸÑ€ÐµÐ¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð°',0),(555514,15431,'es','Beneficios',0),(555515,15431,'de','Vorteile',0),(555516,15431,'en','Benefits',0),(555517,15432,'is','',0),(555518,15432,'dr','Ø´Ù‡Ø± ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡',0),(555519,15432,'pr','Ø´Ù‡Ø± ÙÙˆÙ‚ Ø§Ù„Ø¹Ø§Ø¯Ù‡',0),(555520,15432,'tr','Åžehir ilave',0),(555521,15432,'pl','Miasta dodatkowe',0),(555522,15432,'bg','Ð“Ñ€Ð°Ð´ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾',0),(555523,15432,'ur','Ø´ÛØ± Ø§Ø¶Ø§ÙÛŒ',0),(555524,15432,'sr','Ð“Ñ€Ð°Ð´ ÐµÐºÑÑ‚Ñ€Ð°',0),(555525,15432,'vi','ThÃ nh phá»‘ phá»¥',0),(555526,15432,'af','Stad ekstra',0),(555527,15432,'ro','City plus',0),(555528,15432,'et','City eest',0),(555529,15432,'si','Mesto dodatnih',0),(555530,15432,'ba','Kota tambahan',0),(555531,15432,'nl','Stad Extra',0),(555532,15432,'fi','Kaupungin ylimÃ¤Ã¤rÃ¤istÃ¤',0),(555533,15432,'no','Byen ekstra',0),(555534,15432,'da','Byen ekstra',0),(555535,15432,'ko','ë„ì‹œ ì¶”ê°€',0),(555536,15432,'he','×¢×™×¨ × ×•×¡×¤×ª',0),(555537,15432,'el','Î ÏŒÎ»Î· ÎµÏ€Î¹Ï€Î»Î­Î¿Î½',0),(555538,15432,'zh','åŸŽå¸‚é¢å¤–',0),(555539,15432,'sv','Staden Extra',0),(555540,15432,'it','CittÃ  supplementare',0),(555541,15432,'tl','',0),(555542,15432,'th','à¹€à¸¡à¸·à¸­à¸‡à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(555543,15432,'hi','à¤¶à¤¹à¤° à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤',0),(555544,15432,'ms','Bandar tambahan',0),(555545,15432,'ar','Ù…Ø¯ÙŠÙ†Ø© Ø¥Ø¶Ø§ÙÙŠØ©',0),(555546,15432,'fr','Ville supplÃ©mentaire',0),(555547,15432,'jp','å¸‚ã‚¨ã‚­ã‚¹ãƒˆãƒ©',0),(555548,15432,'pt','Cidade Extra',0),(555549,15432,'ru','Ð“Ð¾Ñ€Ð¾Ð´ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ…',0),(555550,15432,'es','Ciudad Extra',0),(555551,15432,'de','Stadt zusÃ¤tzliche',0),(555552,15432,'en','City Extra',0),(555553,15433,'is','',0),(555554,15433,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ù‡Ø± Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(555555,15433,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ù‡Ø± Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(555556,15433,'tr','Åžehir bilgileri aracÄ±lÄ±ÄŸÄ±yla',0),(555557,15433,'pl','Miasto informacje za poÅ›rednictwem',0),(555558,15433,'bg','Ð“Ñ€Ð°Ð´ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‡Ñ€ÐµÐ·',0),(555559,15433,'ur','Ø´ÛØ± Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(555560,15433,'sr','Ð“Ñ€Ð°Ð´ Ð˜Ð½Ñ„Ð¾ ÐºÑ€Ð¾Ð·',0),(555561,15433,'vi','ThÃ nh phá»‘ thÃ´ng tin thÃ´ng qua',0),(555562,15433,'af','Stad Info deur',0),(555563,15433,'ro','City Info prin',0),(555564,15433,'et','City Info lÃ¤bi',0),(555565,15433,'si','Info mesto preko',0),(555566,15433,'ba','Informasi kota melalui',0),(555567,15433,'nl','City Info via',0),(555568,15433,'fi','Kaupunki-Info kautta',0),(555569,15433,'no','By Info gjennom',0),(555570,15433,'da','Byen Info via',0),(555571,15433,'ko','í†µí•´ ë„ì‹œ ì •ë³´',0),(555572,15433,'he','×”×¢×™×¨ ×‘××ž×¦×¢×•×ª ×ž×™×“×¢',0),(555573,15433,'el','Î ÏŒÎ»Î· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î­ÏƒÏ‰',0),(555574,15433,'zh','é€šè¿‡åŸŽå¸‚ä¿¡æ¯',0),(555575,15433,'sv','City information genom',0),(555576,15433,'it','Info cittÃ  attraverso',0),(555577,15433,'tl','',0),(555578,15433,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸²à¸£à¹€à¸¡à¸·à¸­à¸‡à¸œà¹ˆà¸²à¸™',0),(555579,15433,'hi','à¤¶à¤¹à¤° à¤•à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡',0),(555580,15433,'ms','Maklumat bandar melalui',0),(555581,15433,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø¯ÙŠÙ†Ø© Ù…Ù† Ø®Ù„Ø§Ù„',0),(555582,15433,'fr','Info de la ville par le biais',0),(555583,15433,'jp','çµŒç”±ã§å¸‚ã®æƒ…å ±',0),(555584,15433,'pt','Cidade de informaÃ§Ã£o atravÃ©s de',0),(555585,15433,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð³Ð¾Ñ€Ð¾Ð´Ðµ Ñ‡ÐµÑ€ÐµÐ·',0),(555586,15433,'es','InformaciÃ³n de la ciudad a travÃ©s de',0),(555587,15433,'de','Informationen der Stadt durch',0),(555588,15433,'en','City Info Through',0),(555589,15434,'is','',0),(555590,15434,'dr','ÙˆØ¶Ø¹ÛŒØª Ø´Ù‡Ø±',0),(555591,15434,'pr','ÙˆØ¶Ø¹ÛŒØª Ø´Ù‡Ø±',0),(555592,15434,'tr','Åžehir durumu',0),(555593,15434,'pl','Miasta stanu',0),(555594,15434,'bg','Ð“Ñ€Ð°Ð´ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(555595,15434,'ur','Ø´ÛØ± Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(555596,15434,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð³Ñ€Ð°Ð´Ð°',0),(555597,15434,'vi','ThÃ nh phá»‘',0),(555598,15434,'af','Stad Status',0),(555599,15434,'ro','Statutul de oraÅŸ',0),(555600,15434,'et','Staatuse City',0),(555601,15434,'si','Statusom mesta',0),(555602,15434,'ba','Status kota',0),(555603,15434,'nl','Status van stad',0),(555604,15434,'fi','Kaupungin tila',0),(555605,15434,'no','By',0),(555606,15434,'da','Byen Status',0),(555607,15434,'ko','ë„ì‹œ ìƒíƒœ',0),(555608,15434,'he','×ž×¢×ž×“ ×”×¢×™×¨',0),(555609,15434,'el','ÎšÎ±Î¸ÎµÏƒÏ„ÏŽÏ‚ Ï€ÏŒÎ»Î·Ï‚',0),(555610,15434,'zh','åŸŽå¸‚åœ°ä½',0),(555611,15434,'sv','StadsrÃ¤ttigheter',0),(555612,15434,'it','Status di cittÃ ',0),(555613,15434,'tl','',0),(555614,15434,'th','à¹€à¸¡à¸·à¸­à¸‡à¸—à¸µà¹ˆà¸¡à¸µà¸à¸²à¸™à¸°',0),(555615,15434,'hi','à¤¶à¤¹à¤° à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(555616,15434,'ms','Status bandar raya',0),(555617,15434,'ar','Ù…Ø±ÙƒØ² Ø§Ù„Ù…Ø¯ÙŠÙ†Ø©',0),(555618,15434,'fr','Statut de la ville',0),(555619,15434,'jp','éƒ½å¸‚çŠ¶æ…‹',0),(555620,15434,'pt','Status de cidade',0),(555621,15434,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð³Ð¾Ñ€Ð¾Ð´Ð°',0),(555622,15434,'es','Estado de la ciudad',0),(555623,15434,'de','Stadt-Status',0),(555624,15434,'en','City Status',0),(555625,15435,'is','',0),(555626,15435,'dr','Ø¯',0),(555627,15435,'pr','Ø¯',0),(555628,15435,'tr','D',0),(555629,15435,'pl','D',0),(555630,15435,'bg','D',0),(555631,15435,'ur','D',0),(555632,15435,'sr','Ð”',0),(555633,15435,'vi','D',0),(555634,15435,'af','D',0),(555635,15435,'ro','D',0),(555636,15435,'et','D',0),(555637,15435,'si','D',0),(555638,15435,'ba','D',0),(555639,15435,'nl','D',0),(555640,15435,'fi','D',0),(555641,15435,'no','D',0),(555642,15435,'da','D',0),(555643,15435,'ko','el',0),(555644,15435,'he','D',0),(555645,15435,'el','D',0),(555646,15435,'zh','D',0),(555647,15435,'sv','D',0),(555648,15435,'it','D',0),(555649,15435,'tl','',0),(555650,15435,'th','D',0),(555651,15435,'hi','à¤˜',0),(555652,15435,'ms','D',0),(555653,15435,'ar','Ø¯',0),(555654,15435,'fr','D',0),(555655,15435,'jp','D',0),(555656,15435,'pt','D',0),(555657,15435,'ru','D',0),(555658,15435,'es','D',0),(555659,15435,'de','D',0),(555660,15435,'en','D',0),(555661,15436,'is','',0),(555662,15436,'dr','Ú©Ø³Ø± & Ù¾Ø§Ù†Ø³ÛŒÙˆÙ† Ù‡Ø§ÛŒ',0),(555663,15436,'pr','Ú©Ø³Ø± & Ù¾Ø§Ù†Ø³ÛŒÙˆÙ† Ù‡Ø§ÛŒ',0),(555664,15436,'tr','Kesintiler ve emeklilik',0),(555665,15436,'pl','PotrÄ…cenia idealna emerytur',0),(555666,15436,'bg','Ð£Ð´Ñ€ÑŠÐ¶ÐºÐ¸ & Ð¿ÐµÐ½ÑÐ¸Ð¸',0),(555667,15436,'ur','Ú©Ù¹ÙˆØªÛŒ & Ù¾Ù†Ø´Ù†',0),(555668,15436,'sr','ÐžÐ´Ð±Ð¸Ñ‚ÐºÐµ & Ð¿ÐµÐ½Ð·Ð¸Ñ˜Ðµ',0),(555669,15436,'vi','Khoáº£n kháº¥u trá»« & lÆ°Æ¡ng hÆ°u',0),(555670,15436,'af','Aftrekkings & Pensioene',0),(555671,15436,'ro','Deduceri & pensiuni',0),(555672,15436,'et','Mahaarvamised- & pensionid',0),(555673,15436,'si','Odbitki & pokojnine',0),(555674,15436,'ba','Pengurangan & pensiun',0),(555675,15436,'nl','Inhoudingen & pensioenen',0),(555676,15436,'fi','VÃ¤hennykset & elÃ¤kkeet',0),(555677,15436,'no','Fradrag & pensjoner',0),(555678,15436,'da','Fradrag & pensioner',0),(555679,15436,'ko','ê³µì œ ë° ì—°ê¸ˆ',0),(555680,15436,'he','×‘×ª×™ ×”××¨×—×”, &, × ×™×›×•×™×™×',0),(555681,15436,'el','& Î£Ï…Î½Ï„Î¬Î¾ÎµÎ¹Ï‚ ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½',0),(555682,15436,'zh','æ‰£é™¤ & å…»æ¤é‡‘',0),(555683,15436,'sv','Avdrag & pensioner',0),(555684,15436,'it','Detrazioni & Pensioni',0),(555685,15436,'tl','',0),(555686,15436,'th','à¸«à¸±à¸à¸ªà¸³à¸£à¸­à¸‡à¸Šà¸µà¸ž',0),(555687,15436,'hi','à¤•à¤Ÿà¥Œà¤¤à¤¿à¤¯à¤¾à¤‚ & à¤ªà¥‡à¤‚à¤¶à¤¨',0),(555688,15436,'ms','Potongan & pencen',0),(555689,15436,'ar','Ù…Ø¹Ø§Ø´Ø§Øª Ø¢Ù†Ø¯ Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª',0),(555690,15436,'fr','DÃ©ductions & Pensions',0),(555691,15436,'jp','æŽ§é™¤ãƒ»å¹´é‡‘',0),(555692,15436,'pt','DeduÃ§Ãµes & PensÃµes',0),(555693,15436,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚Ñ‹ & Ð¿ÐµÐ½ÑÐ¸Ð¹',0),(555694,15436,'es','Pensiones y las deducciones',0),(555695,15436,'de','AbzÃ¼ge & Pensionen',0),(555696,15436,'en','Deductions & Pensions',0),(555697,15437,'is','',0),(555698,15437,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª Ú©Ø³Ø±',0),(555699,15437,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª Ú©Ø³Ø±',0),(555700,15437,'tr','Kesintiler detay',0),(555701,15437,'pl','SzczegÃ³Å‚y dotyczÄ…ce odliczeÅ„',0),(555702,15437,'bg','Ð”ÐµÑ‚Ð°Ð¹Ð» Ð¾Ð±Ð»ÐµÐºÑ‡ÐµÐ½Ð¸Ñ',0),(555703,15437,'ur','Ú©Ù¹ÙˆØªÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„',0),(555704,15437,'sr','ÐžÐ´Ð±Ð¸Ñ‚ÐºÐµ Ð´ÐµÑ‚Ð°Ñ™',0),(555705,15437,'vi','Chi tiáº¿t khoáº£n kháº¥u trá»«',0),(555706,15437,'af','Aftrekkings Detail',0),(555707,15437,'ro','Deduceri detaliu',0),(555708,15437,'et','Mahaarvamised Detail',0),(555709,15437,'si','Odbitki podrobnosti',0),(555710,15437,'ba','Pengurangan Detail',0),(555711,15437,'nl','Inhoudingen Detail',0),(555712,15437,'fi','VÃ¤hennykset yksityiskohtaisesti',0),(555713,15437,'no','Fradrag detaljer',0),(555714,15437,'da','Fradrag detaljer',0),(555715,15437,'ko','ê³µì œ ì„¸ë¶€ ì‚¬í•­',0),(555716,15437,'he','×¤×™×¨×•×˜ ×”× ×™×›×•×™×™×',0),(555717,15437,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½',0),(555718,15437,'zh','æ‰£é™¤è¯¦ç»†',0),(555719,15437,'sv','Avdrag detalj',0),(555720,15437,'it','Dettaglio detrazioni',0),(555721,15437,'tl','',0),(555722,15437,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸à¸²à¸£à¸«à¸±à¸',0),(555723,15437,'hi','à¤•à¤Ÿà¥Œà¤¤à¤¿à¤¯à¤¾à¤‚ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(555724,15437,'ms','Perincian potongan',0),(555725,15437,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª',0),(555726,15437,'fr','DÃ©tail des dÃ©ductions',0),(555727,15437,'jp','æŽ§é™¤ã®è©³ç´°',0),(555728,15437,'pt','Detalhe de deduÃ§Ãµes',0),(555729,15437,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚Ñ‹ Ð´ÐµÑ‚Ð°Ð»ÑŒ',0),(555730,15437,'es','Detalle de deducciones',0),(555731,15437,'de','AbzÃ¼ge-Detail',0),(555732,15437,'en','Deductions Detail',0),(555733,15438,'is','',0),(555734,15438,'dr','Ù„ÛŒØ³Øª Ú©Ø³Ø±',0),(555735,15438,'pr','Ù„ÛŒØ³Øª Ú©Ø³Ø±',0),(555736,15438,'tr','Kesintiler listesi',0),(555737,15438,'pl','Lista potrÄ…ceÅ„',0),(555738,15438,'bg','Ð£Ð´Ñ€ÑŠÐ¶ÐºÐ¸ ÑÐ¿Ð¸ÑÑŠÐº',0),(555739,15438,'ur','Ú©Ù¹ÙˆØªÛŒ Ú©ÛŒ ÙÛØ±Ø³Øª',0),(555740,15438,'sr','ÐžÐ´Ð±Ð¸Ñ‚ÐºÐµ Ð»Ð¸ÑÑ‚Ð°',0),(555741,15438,'vi','Khoáº£n kháº¥u trá»« danh sÃ¡ch',0),(555742,15438,'af','Aftrekkings lys',0),(555743,15438,'ro','Deduceri lista',0),(555744,15438,'et','Mahaarvamiste loetelu',0),(555745,15438,'si','Seznam odbitki',0),(555746,15438,'ba','Daftar pemotongan',0),(555747,15438,'nl','Inhoudingen lijst',0),(555748,15438,'fi','VÃ¤hennykset luettelo',0),(555749,15438,'no','Fradrag liste',0),(555750,15438,'da','Fradrag liste',0),(555751,15438,'ko','ê³µì œ ëª©ë¡',0),(555752,15438,'he','×¨×©×™×ž×ª × ×™×›×•×™×™×',0),(555753,15438,'el','Î›Î¯ÏƒÏ„Î± ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½',0),(555754,15438,'zh','æ‰£é™¤åˆ—è¡¨',0),(555755,15438,'sv','Avdrag lista',0),(555756,15438,'it','Elenco di detrazioni',0),(555757,15438,'tl','',0),(555758,15438,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸«à¸±à¸',0),(555759,15438,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤¸à¥‚à¤šà¥€',0),(555760,15438,'ms','Senarai potongan',0),(555761,15438,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª',0),(555762,15438,'fr','Liste de dÃ©ductions',0),(555763,15438,'jp','æŽ§é™¤ä¸€è¦§',0),(555764,15438,'pt','Lista de deduÃ§Ãµes',0),(555765,15438,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ð¹',0),(555766,15438,'es','Lista de deducciones',0),(555767,15438,'de','Liste der AbzÃ¼ge',0),(555768,15438,'en','Deductions List',0),(555769,15439,'is','',0),(555770,15439,'dr','Ø®Ù„Ø§ØµÙ‡ Ú©Ø³Ø±',0),(555771,15439,'pr','Ø®Ù„Ø§ØµÙ‡ Ú©Ø³Ø±',0),(555772,15439,'tr','Kesintiler Ã–zeti',0),(555773,15439,'pl','KrÃ³tki opis potrÄ…ceÅ„',0),(555774,15439,'bg','Ð£Ð´Ñ€ÑŠÐ¶ÐºÐ¸ Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(555775,15439,'ur','Ú©Ù¹ÙˆØªÛŒ Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(555776,15439,'sr','ÐžÐ´Ð±Ð¸Ñ‚ÐºÐµ Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(555777,15439,'vi','Khoáº£n kháº¥u trá»« tÃ³m táº¯t',0),(555778,15439,'af','Aftrekkings opsomming',0),(555779,15439,'ro','Deduceri Rezumat',0),(555780,15439,'et','Mahaarvamised KokkuvÃµte',0),(555781,15439,'si','Odbitki Povzetek',0),(555782,15439,'ba','Pengurangan ringkasan',0),(555783,15439,'nl','Inhoudingen samenvatting',0),(555784,15439,'fi','VÃ¤hennykset Yhteenveto',0),(555785,15439,'no','Fradrag Sammendrag',0),(555786,15439,'da','Fradrag ResumÃ©',0),(555787,15439,'ko','ê³µì œ ìš”ì•½',0),(555788,15439,'he','×¡×™×›×•× × ×™×›×•×™×™×',0),(555789,15439,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Ï„Ï‰Î½ ÎµÎºÏ€Ï„ÏŽÏƒÎµÏ‰Î½',0),(555790,15439,'zh','æ‰£å‡æ‘˜è¦',0),(555791,15439,'sv','Avdrag Sammanfattning',0),(555792,15439,'it','Riepilogo delle detrazioni',0),(555793,15439,'tl','',0),(555794,15439,'th','à¸ªà¸£à¸¸à¸›à¸«à¸±à¸',0),(555795,15439,'hi','à¤•à¤Ÿà¥Œà¤¤à¤¿à¤¯à¤¾à¤‚ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(555796,15439,'ms','Ringkasan potongan',0),(555797,15439,'ar','Ù…Ù„Ø®Øµ Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª',0),(555798,15439,'fr','Sommaire des retenues',0),(555799,15439,'jp','æŽ§é™¤ã®æ¦‚è¦',0),(555800,15439,'pt','Resumo de deduÃ§Ãµes',0),(555801,15439,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚Ñ‹ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(555802,15439,'es','Resumen de las deducciones',0),(555803,15439,'de','AbzÃ¼ge-Zusammenfassung',0),(555804,15439,'en','Deductions Summary',0),(555805,15440,'is','',0),(555806,15440,'dr','Ú©Ø³Ø± Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(555807,15440,'pr','Ú©Ø³Ø± Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(555808,15440,'tr','Kesintiler ile',0),(555809,15440,'pl','PotrÄ…cenia przez',0),(555810,15440,'bg','Ð£Ð´Ñ€ÑŠÐ¶ÐºÐ¸ Ð¿Ñ€ÐµÐ·',0),(555811,15440,'ur','Ú©Ù¹ÙˆØªÛŒ Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(555812,15440,'sr','ÐžÐ´Ð±Ð¸Ñ‚ÐºÐµ ÐºÑ€Ð¾Ð·',0),(555813,15440,'vi','Khoáº£n kháº¥u trá»« qua',0),(555814,15440,'af','Aftrekkings deur',0),(555815,15440,'ro','Deduceri prin',0),(555816,15440,'et','Mahaarvamiste kaudu',0),(555817,15440,'si','Odbitki skozi',0),(555818,15440,'ba','Pemotongan melalui',0),(555819,15440,'nl','Inhoudingen via',0),(555820,15440,'fi','VÃ¤hennysten kautta',0),(555821,15440,'no','Fradrag gjennom',0),(555822,15440,'da','Fradrag gennem',0),(555823,15440,'ko','í†µí•´ ê³µì œ',0),(555824,15440,'he','× ×™×›×•×™×™× ×“×¨×š',0),(555825,15440,'el','ÎšÏÎ±Ï„Î®ÏƒÎµÎ¹Ï‚ Î¼Î­ÏƒÏ‰',0),(555826,15440,'zh','é€šè¿‡æ‰£é™¤',0),(555827,15440,'sv','Avdrag genom',0),(555828,15440,'it','Detrazioni attraverso',0),(555829,15440,'tl','',0),(555830,15440,'th','à¸«à¸±à¸à¸œà¹ˆà¸²à¸™',0),(555831,15440,'hi','à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤•à¤Ÿà¥Œà¤¤à¥€',0),(555832,15440,'ms','Potongan melalui',0),(555833,15440,'ar','Ø§Ù„Ø®ØµÙ… Ù…Ù† Ø®Ù„Ø§Ù„',0),(555834,15440,'fr','Retenues par',0),(555835,15440,'jp','æŽ§é™¤',0),(555836,15440,'pt','DeduÃ§Ãµes por meio',0),(555837,15440,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚Ñ‹ Ñ‡ÐµÑ€ÐµÐ·',0),(555838,15440,'es','Deducciones a travÃ©s de',0),(555839,15440,'de','AbzÃ¼ge durch',0),(555840,15440,'en','Deductions Through',0),(555841,15441,'is','',0),(555842,15441,'dr','Ú©Ø³Ø± Ø­Ø¯Ø§Ú©Ø«Ø±',0),(555843,15441,'pr','Ú©Ø³Ø± Ø­Ø¯Ø§Ú©Ø«Ø±',0),(555844,15441,'tr','Kesinti Max',0),(555845,15441,'pl','PotrÄ…cenie Max',0),(555846,15441,'bg','ÐŸÑ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ ÐœÐ°ÐºÑ',0),(555847,15441,'ur','Ù…Ø§Ø­ØµÙ„ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(555848,15441,'sr','Ð”ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° ÐœÐ°x',0),(555849,15441,'vi','Kháº¥u trá»« Max',0),(555850,15441,'af','Aftrekking Max',0),(555851,15441,'ro','Deducerea Max',0),(555852,15441,'et','Mahaarvamise Max',0),(555853,15441,'si','Odbitek Max',0),(555854,15441,'ba','Pengurangan Max',0),(555855,15441,'nl','Aftrek Max',0),(555856,15441,'fi','VÃ¤hennys Max',0),(555857,15441,'no','Fradrag Max',0),(555858,15441,'da','Fradrag Max',0),(555859,15441,'ko','ê³µì œ ìµœëŒ€',0),(555860,15441,'he','× ×™×›×•×™ ×ž×§×¡',0),(555861,15441,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ· Max',0),(555862,15441,'zh','æ‰£é™¤æœ€å¤§',0),(555863,15441,'sv','Avdrag Max',0),(555864,15441,'it','Detrazione Max',0),(555865,15441,'tl','',0),(555866,15441,'th','à¸¥à¸”à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(555867,15441,'hi','à¤•à¤Ÿà¥Œà¤¤à¥€ à¤®à¥ˆà¤•à¥à¤¸',0),(555868,15441,'ms','Potongan maksimum',0),(555869,15441,'ar','Ù…Ø§ÙƒØ³ Ø®ØµÙ…',0),(555870,15441,'fr','Max de dÃ©duction',0),(555871,15441,'jp','æœ€å¤§æŽ§é™¤',0),(555872,15441,'pt','MÃ¡ximo de deduÃ§Ã£o',0),(555873,15441,'ru','Ð’Ñ‹Ñ‡ÐµÑ‚ ÐœÐ°ÐºÑ',0),(555874,15441,'es','MÃ¡ximo de la deducciÃ³n',0),(555875,15441,'de','Abzug-Max',0),(555876,15441,'en','Deduction Max',0),(555877,15442,'is','',0),(555878,15442,'dr','Ù„ÛŒØ³Øª Ú¯Ø±ÙˆÙ‡',0),(555879,15442,'pr','Ù„ÛŒØ³Øª Ú¯Ø±ÙˆÙ‡',0),(555880,15442,'tr','BÃ¶lÃ¼m listesi',0),(555881,15442,'pl','W departamencie listy',0),(555882,15442,'bg','ÐžÑ‚Ð´ÐµÐ» ÑÐ¿Ð¸ÑÑŠÐº',0),(555883,15442,'ur','Ù…Ø­Ú©Ù…Û Ú©ÛŒ ÙÛØ±Ø³Øª',0),(555884,15442,'sr','ÐžÐ´ÐµÑ™ÐµÑšÐµ Ð»Ð¸ÑÑ‚Ð°',0),(555885,15442,'vi','Danh sÃ¡ch vÃ¹ng',0),(555886,15442,'af','Departement lys',0),(555887,15442,'ro','Departamentul lista',0),(555888,15442,'et','Osakonna nimekiri',0),(555889,15442,'si','Seznama oddelkov',0),(555890,15442,'ba','Daftar Departemen',0),(555891,15442,'nl','Departement lijst',0),(555892,15442,'fi','Osastoluettelo',0),(555893,15442,'no','Department List',0),(555894,15442,'da','Afdelingsliste',0),(555895,15442,'ko','ë¶€ì„œ ëª©ë¡',0),(555896,15442,'he','×ž×—×œ×§×ª ×¨×©×™×ž×”',0),(555897,15442,'el','Î›Î¯ÏƒÏ„Î± Ï„Î¼Î®Î¼Î±',0),(555898,15442,'zh','éƒ¨é—¨åˆ—è¡¨',0),(555899,15442,'sv','Avdelningslistan',0),(555900,15442,'it','Elenco di dipartimento',0),(555901,15442,'tl','',0),(555902,15442,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹à¸œà¸™à¸',0),(555903,15442,'hi','à¤µà¤¿à¤­à¤¾à¤— à¤¸à¥‚à¤šà¥€',0),(555904,15442,'ms','Senarai Jabatan',0),(555905,15442,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø¥Ø¯Ø§Ø±Ø©',0),(555906,15442,'fr','Liste des dÃ©partements',0),(555907,15442,'jp','éƒ¨ä¸€è¦§',0),(555908,15442,'pt','Lista do departamento',0),(555909,15442,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð”ÐµÐ¿Ð°Ñ€Ñ‚Ð°Ð¼ÐµÐ½Ñ‚Ð°',0),(555910,15442,'es','Lista de Departamento',0),(555911,15442,'de','Abteilungsliste',0),(555912,15442,'en','Department List',0),(555913,15443,'is','',0),(555914,15443,'dr','Ú¯Ø±ÙˆÙ‡ Ø¢Ù…ÙˆØ²Ø´ÙŠ Ø®Ù„Ø§ØµÙ‡',0),(555915,15443,'pr','Ú¯Ø±ÙˆÙ‡ Ø¢Ù…ÙˆØ²Ø´ÙŠ Ø®Ù„Ø§ØµÙ‡',0),(555916,15443,'tr','BÃ¶lÃ¼m Ã–zeti',0),(555917,15443,'pl','Department KrÃ³tki opis',0),(555918,15443,'bg','ÐžÑ‚Ð´ÐµÐ» Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(555919,15443,'ur','Ù…Ø­Ú©Ù…Û Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(555920,15443,'sr','ÐžÐ´ÐµÑ™ÐµÑšÐµ Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(555921,15443,'vi','VÃ¹ng tÃ³m táº¯t',0),(555922,15443,'af','Departement opsomming',0),(555923,15443,'ro','Departamentul Rezumat',0),(555924,15443,'et','Department KokkuvÃµte',0),(555925,15443,'si','Oddelek Povzetek',0),(555926,15443,'ba','Departemen ringkasan',0),(555927,15443,'nl','Departement samenvatting',0),(555928,15443,'fi','Osasto TiivistelmÃ¤',0),(555929,15443,'no','Avdeling Sammendrag',0),(555930,15443,'da','Department ResumÃ©',0),(555931,15443,'ko','ë¶€ ìš”ì•½',0),(555932,15443,'he','×ž×—×œ×§×ª ×¡×™×›×•×',0),(555933,15443,'el','Î¤Î¼Î®Î¼Î± Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(555934,15443,'zh','éƒ¨æ‘˜è¦',0),(555935,15443,'sv','Institutionen Sammanfattning',0),(555936,15443,'it','Riepilogo di dipartimento',0),(555937,15443,'tl','',0),(555938,15443,'th','à¸ªà¸£à¸¸à¸›à¸à¸£à¸¡',0),(555939,15443,'hi','à¤µà¤¿à¤­à¤¾à¤— à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(555940,15443,'ms','Ringkasan Jabatan',0),(555941,15443,'ar','Ù…Ù„Ø®Øµ Ø§Ù„Ø¥Ø¯Ø§Ø±Ø©',0),(555942,15443,'fr','RÃ©sumÃ© du ministÃ¨re',0),(555943,15443,'jp','éƒ¨é–€æ¦‚è¦',0),(555944,15443,'pt','Resumo de departamento',0),(555945,15443,'ru','Ð£Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(555946,15443,'es','Resumen de Departamento',0),(555947,15443,'de','Abteilung-Zusammenfassung',0),(555948,15443,'en','Department Summary',0),(555949,15444,'is','',0),(555950,15444,'dr','Ú¯Ø±ÙˆÙ‡ Ø¢Ù…ÙˆØ²Ø´ÙŠ Ø®Ù„Ø§ØµÙ‡ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(555951,15444,'pr','Ú¯Ø±ÙˆÙ‡ Ø¢Ù…ÙˆØ²Ø´ÙŠ Ø®Ù„Ø§ØµÙ‡ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(555952,15444,'tr','BakanlÄ±ÄŸÄ± Ã¼cret Ã–zeti',0),(555953,15444,'pl','W departamencie pÅ‚ace KrÃ³tki opis',0),(555954,15444,'bg','ÐžÑ‚Ð´ÐµÐ» Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(555955,15444,'ur','Ù…Ø­Ú©Ù…Û Ø§Ø¬Ø±Øª Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(555956,15444,'sr','ÐžÐ´ÐµÑ™ÐµÑšÐµ Ð¿Ð»Ð°Ñ‚Ðµ Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(555957,15444,'vi','VÃ¹ng lÆ°Æ¡ng tÃ³m táº¯t',0),(555958,15444,'af','Departement lone opsomming',0),(555959,15444,'ro','Departamentul salariile Rezumat',0),(555960,15444,'et','Osakonna palgad KokkuvÃµte',0),(555961,15444,'si','Povzetek plaÄe oddelek',0),(555962,15444,'ba','Departemen upah ringkasan',0),(555963,15444,'nl','Departement lonen samenvatting',0),(555964,15444,'fi','Osasto palkat TiivistelmÃ¤',0),(555965,15444,'no','Avdeling lÃ¸nn Sammendrag',0),(555966,15444,'da','Afdeling lÃ¸nninger ResumÃ©',0),(555967,15444,'ko','ë¶€ ìž„ê¸ˆ ìš”ì•½',0),(555968,15444,'he','×ž×—×œ×§×ª ×”×©×›×¨ ×¡×™×›×•×',0),(555969,15444,'el','Î¤Î¼Î®Î¼Î± Î¼Î¹ÏƒÎ¸Î¿ÏÏ‚ Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(555970,15444,'zh','éƒ¨é—¨å·¥èµ„æ‘˜è¦',0),(555971,15444,'sv','Institutionen lÃ¶ner Sammanfattning',0),(555972,15444,'it','Dipartimento salari Riepilogo',0),(555973,15444,'tl','',0),(555974,15444,'th','à¹à¸œà¸™à¸à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸ªà¸£à¸¸à¸›',0),(555975,15444,'hi','à¤µà¤¿à¤­à¤¾à¤— à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(555976,15444,'ms','Ringkasan gaji Jabatan',0),(555977,15444,'ar','Ù…Ù„Ø®Øµ Ø¥Ø¯Ø§Ø±Ø© Ø§Ù„Ø£Ø¬ÙˆØ±',0),(555978,15444,'fr','RÃ©sumÃ© des salaires dÃ©partement',0),(555979,15444,'jp','éƒ¨é–€ã®è³ƒé‡‘ã®æ¦‚è¦',0),(555980,15444,'pt','Resumo de salÃ¡rios do departamento',0),(555981,15444,'ru','ÐžÑ‚Ð´ÐµÐ» Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(555982,15444,'es','Resumen de salarios del Departamento',0),(555983,15444,'de','Abteilung LÃ¶hne Zusammenfassung',0),(555984,15444,'en','Department Wages Summary',0),(555985,15445,'is','',0),(555986,15445,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª Ú©Ø§Ø±Ù…Ù†Ø¯',0),(555987,15445,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª Ú©Ø§Ø±Ù…Ù†Ø¯',0),(555988,15445,'tr','Ã‡alÄ±ÅŸan ayrÄ±ntÄ±larÄ±',0),(555989,15445,'pl','Detal pracownika',0),(555990,15445,'bg','Ð”Ð°Ð½Ð½Ð¸ Ð·Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(555991,15445,'ur','Ù…Ù„Ø§Ø²Ù… Ú©ÛŒ ØªÙØµÛŒÙ„',0),(555992,15445,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð´ÐµÑ‚Ð°Ñ™',0),(555993,15445,'vi','NhÃ¢n viÃªn chi tiáº¿t',0),(555994,15445,'af','Werknemer besonderhede',0),(555995,15445,'ro','Angajat detaliu',0),(555996,15445,'et','TÃ¶Ã¶taja Ã¼ksikasjad',0),(555997,15445,'si','Podrobnostmi o zaposlenih',0),(555998,15445,'ba','Karyawan rincian',0),(555999,15445,'nl','Werknemer Detail',0),(556000,15445,'fi','TyÃ¶ntekijÃ¤n tiedot',0),(556001,15445,'no','Ansattdetaljer',0),(556002,15445,'da','Medarbejder detaljer',0),(556003,15445,'ko','ì§ì› ì„¸ë¶€ ì •ë³´',0),(556004,15445,'he','×¤×¨×˜ ×œ×¢×•×‘×“',0),(556005,15445,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î±',0),(556006,15445,'zh','é›‡å‘˜è¯¦ç»†ä¿¡æ¯',0),(556007,15445,'sv','AnstÃ¤lld i detalj',0),(556008,15445,'it','Dettaglio dei dipendenti',0),(556009,15445,'tl','',0),(556010,15445,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(556011,15445,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¤¿à¤µà¤°à¤£',0),(556012,15445,'ms','Butiran pekerja',0),(556013,15445,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…ÙˆØ¸Ù',0),(556014,15445,'fr','DÃ©tail de l\'employÃ©',0),(556015,15445,'jp','å¾“æ¥­å“¡è©³ç´°',0),(556016,15445,'pt','Detalhe de empregado',0),(556017,15445,'ru','Ð”ÐµÑ‚Ð°Ð»ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(556018,15445,'es','Detalle de empleados',0),(556019,15445,'de','Mitarbeiterdetails',0),(556020,15445,'en','Employee Detail',0),(556021,15446,'is','',0),(556022,15446,'dr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ù…Ø§Ù„ÛŒØ§Øª Ø®ÙˆØ¯Ø¯Ø§Ø±ÛŒ Ø®Ù„Ø§ØµÙ‡',0),(556023,15446,'pr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ù…Ø§Ù„ÛŒØ§Øª Ø®ÙˆØ¯Ø¯Ø§Ø±ÛŒ Ø®Ù„Ø§ØµÙ‡',0),(556024,15446,'tr','Ã‡alÄ±ÅŸan vergi stopaj Ã–zeti',0),(556025,15446,'pl','Podsumowanie u ÅºrÃ³dÅ‚a podatku od pracownika',0),(556026,15446,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð´Ð°Ð½ÑŠÐº, ÑƒÐ´ÑŠÑ€Ð¶Ð°Ð½ Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ð¾Ñ‡Ð½Ð¸ÐºÐ° Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(556027,15446,'ur','Ù…Ù„Ø§Ø²Ù… Ù¹ÛŒÚ©Ø³ Ø®Ù„Ø§ØµÛ Ø±ÙˆÚ©Ù†Ø§',0),(556028,15446,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð·Ð° Ð¿Ñ€Ð¸ÐºÑ€Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(556029,15446,'vi','NhÃ¢n viÃªn thuáº¿ giá»¯ láº¡i tÃ³m táº¯t',0),(556030,15446,'af','Werknemer belasting weerhouding opsomming',0),(556031,15446,'ro','Angajat impozitului la sursÄƒ Rezumat',0),(556032,15446,'et','TÃ¶Ã¶taja tulumaksu kinnipidamisel KokkuvÃµte',0),(556033,15446,'si','Zaposleni davÄni odtegljaj Povzetek',0),(556034,15446,'ba','Karyawan pajak pemotongan ringkasan',0),(556035,15446,'nl','Werknemer belasting inhouding samenvatting',0),(556036,15446,'fi','TyÃ¶ntekijÃ¤n veron ennakonpidÃ¤tyksen Yhteenveto',0),(556037,15446,'no','Ansattes skatt forskuddstrekk Sammendrag',0),(556038,15446,'da','Medarbejder skat tilbageholdelse ResumÃ©',0),(556039,15446,'ko','ì§ì› ì„¸ê¸ˆ ì›ì²œ ì§•ìˆ˜ ê°œìš”',0),(556040,15446,'he','×¡×™×›×•× × ×™×›×•×™ ×”×ž×¡ ×©×œ ×”×¢×•×‘×“',0),(556041,15446,'el','Î¥Ï€Î¬Î»Î»Î·Î»Î¿Ï‚ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Ï€Î±ÏÎ±ÎºÏÎ¬Ï„Î·ÏƒÎ· Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(556042,15446,'zh','å‘˜å·¥ç¨Žæ‰£ç¼´æ‘˜è¦',0),(556043,15446,'sv','Medarbetaren skatt undanhÃ¥lla Sammanfattning',0),(556044,15446,'it','Riepilogo di ritenuta fiscale di dipendente',0),(556045,15446,'tl','',0),(556046,15446,'th','à¸ªà¸£à¸¸à¸›à¸à¸²à¸£à¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢à¸ à¸²à¸©à¸µà¸‚à¸­à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(556047,15446,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¤° Withholding à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(556048,15446,'ms','Ringkasan penangguhan cukai pekerja',0),(556049,15446,'ar','Ù…Ù„Ø®Øµ Ø­Ø¬Ø¨ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…ÙˆØ¸Ù',0),(556050,15446,'fr','RÃ©sumÃ© de retenue fiscale employÃ©',0),(556051,15446,'jp','å¾“æ¥­å“¡ç¨Žé‡‘æºæ³‰å¾´åŽã®æ¦‚è¦',0),(556052,15446,'pt','Resumo de retenÃ§Ã£o do funcionÃ¡rio fiscal',0),(556053,15446,'ru','Ð ÐµÐ·ÑŽÐ¼Ðµ ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(556054,15446,'es','Resumen de retenciÃ³n de impuesto de empleado',0),(556055,15446,'de','Mitarbeiter Steuern Quellensteuer Zusammenfassung',0),(556056,15446,'en','Employee Tax Withholding Summary',0),(556057,15447,'is','',0),(556058,15447,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù…Ø¹Ø§Ù',0),(556059,15447,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù…Ø¹Ø§Ù',0),(556060,15447,'tr','Muaf Ã¼cretleri',0),(556061,15447,'pl','Zwolnione wynagrodzenia',0),(556062,15447,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ñ‚ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(556063,15447,'ur','Ù…Ø³ØªØ«Ù†ÛŒ Ø§Ø¬Ø±Øª',0),(556064,15447,'sr','Ð˜Ð·ÑƒÐ·ÐµÑ‚Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ',0),(556065,15447,'vi','Miá»…n tiá»n lÆ°Æ¡ng',0),(556066,15447,'af','Vrygestelde lone',0),(556067,15447,'ro','Salariile scutite',0),(556068,15447,'et','Maksuvaba palk',0),(556069,15447,'si','OproÅ¡Äene plaÄe',0),(556070,15447,'ba','Upah dibebaskan',0),(556071,15447,'nl','Vrijgesteld lonen',0),(556072,15447,'fi','Vapautettu palkat',0),(556073,15447,'no','Unntatt lÃ¸nn',0),(556074,15447,'da','Undtaget lÃ¸n',0),(556075,15447,'ko','ë©´ì œ ìž„ê¸ˆ',0),(556076,15447,'he','×©×›×¨ ×¤×˜×•×¨',0),(556077,15447,'el','Î•Î¾Î±Î¹ÏÎ¿ÏÎ½Ï„Î±Î¹ Î¿Î¹ Î¼Î¹ÏƒÎ¸Î¿Î¯',0),(556078,15447,'zh','è±å…çš„å·¥èµ„',0),(556079,15447,'sv','Undanta lÃ¶ner',0),(556080,15447,'it','Salari esenti',0),(556081,15447,'tl','',0),(556082,15447,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸¢à¸à¹€à¸§à¹‰à¸™',0),(556083,15447,'hi','à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(556084,15447,'ms','Upah dikecualikan',0),(556085,15447,'ar','Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø£Ø¬ÙˆØ±',0),(556086,15447,'fr','Salaires exonÃ©rÃ©s',0),(556087,15447,'jp','é™¤å¤–ã•ã‚Œã‚‹è³ƒé‡‘',0),(556088,15447,'pt','SalÃ¡rios isentos',0),(556089,15447,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ñ‹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(556090,15447,'es','Salarios exentos',0),(556091,15447,'de','Steuerbefreite LÃ¶hne',0),(556092,15447,'en','Exempt Wages',0),(556093,15448,'is','',0),(556094,15448,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ¯Ø±Ø§Ù„ Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(556095,15448,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ¯Ø±Ø§Ù„ Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(556096,15448,'tr','Federal bilgi yoluyla',0),(556097,15448,'pl','Federalny informacji poprzez',0),(556098,15448,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‡Ñ€ÐµÐ·',0),(556099,15448,'ur','ÙˆÙØ§Ù‚ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(556100,15448,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð˜Ð½Ñ„Ð¾ ÐºÑ€Ð¾Ð·',0),(556101,15448,'vi','CÃ¡c thÃ´ng tin liÃªn bang thÃ´ng qua',0),(556102,15448,'af','Federale Info deur',0),(556103,15448,'ro','Info federale prin',0),(556104,15448,'et','FÃ¶deraalse Info lÃ¤bi',0),(556105,15448,'si','Zvezni Info preko',0),(556106,15448,'ba','Federal Info melalui',0),(556107,15448,'nl','Federale Info via',0),(556108,15448,'fi','Liittovaltion Info kautta',0),(556109,15448,'no','FÃ¸derale Info gjennom',0),(556110,15448,'da','FÃ¸derale Info via',0),(556111,15448,'ko','í†µí•´ ì—°ë°© ì •ë³´',0),(556112,15448,'he','×‘××ž×¦×¢×•×ª ×ž×™×“×¢ ×¤×“×¨×œ×™',0),(556113,15448,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î­ÏƒÏ‰',0),(556114,15448,'zh','é€šè¿‡è”é‚¦ä¿¡æ¯',0),(556115,15448,'sv','Federal information genom',0),(556116,15448,'it','Info federale attraverso',0),(556117,15448,'tl','',0),(556118,15448,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‚à¸­à¸‡à¸ à¸²à¸„à¸£à¸±à¸à¸œà¹ˆà¸²à¸™',0),(556119,15448,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡',0),(556120,15448,'ms','Info Persekutuan melalui',0),(556121,15448,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ù…Ù† Ø®Ù„Ø§Ù„',0),(556122,15448,'fr','Info fÃ©dÃ©rale Ã  travers',0),(556123,15448,'jp','çµŒç”±ã§é€£é‚¦ã®æƒ…å ±',0),(556124,15448,'pt','InformaÃ§Ã£o federal atravÃ©s',0),(556125,15448,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‡ÐµÑ€ÐµÐ·',0),(556126,15448,'es','Federal informaciÃ³n a travÃ©s de',0),(556127,15448,'de','Bundes-Info Ã¼ber',0),(556128,15448,'en','Federal Info Through',0),(556129,15449,'is','',0),(556130,15449,'dr','ÙØ¯Ø±Ø§Ù„ Ù…Ø§Ù„ÛŒØ§Øª Ú©Ø³Ø± Ú©Ø±Ø¯Ù‡',0),(556131,15449,'pr','ÙØ¯Ø±Ø§Ù„ Ù…Ø§Ù„ÛŒØ§Øª Ú©Ø³Ø± Ú©Ø±Ø¯Ù‡',0),(556132,15449,'tr','Federal vergi tevkif',0),(556133,15449,'pl','Federalny podatek dochodowy',0),(556134,15449,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð° ÑƒÐ´ÑŠÑ€Ð¶Ð°Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(556135,15449,'ur','ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³ Ú†Ø§ÛØªÛŒ ØªÚ¾ÛŒÚº',0),(556136,15449,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· ÑƒÑÐºÑ€Ð°Ñ‚Ð¸Ð¾',0),(556137,15449,'vi','Thuáº¿ liÃªn bang giá»¯ láº¡i',0),(556138,15449,'af','Federale belasting weerhou',0),(556139,15449,'ro','Federale impozitele retinute',0),(556140,15449,'et','Kinnipeetava Federal makse',0),(556141,15449,'si','Zvezni davki, zadrÅ¾i',0),(556142,15449,'ba','Pajak Federal yang ditahan',0),(556143,15449,'nl','Federale belasting ingehouden',0),(556144,15449,'fi','Liittovaltion verot pidÃ¤tetty',0),(556145,15449,'no','Federal skatt trekkes',0),(556146,15449,'da','FÃ¸derale skatter tilbageholdt',0),(556147,15449,'ko','ì—°ë°© ì„¸ê¸ˆì„ ì›ì²œ ì§•ìˆ˜',0),(556148,15449,'he','×ž×™×¡×™× ×¤×“×¨×œ×™× ×©× ×•×›×” ×‘×ž×§×•×¨',0),(556149,15449,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿ÏÏ‚ Ï†ÏŒÏÎ¿Ï…Ï‚ Ï€Î¿Ï… Ï€Î±ÏÎ±ÎºÏÎ±Ï„Î¿ÏÎ½Ï„Î±Î¹',0),(556150,15449,'zh','è”é‚¦ç¨Žæ‰£ç¼´',0),(556151,15449,'sv','Federala skatter inne',0),(556152,15449,'it','Imposte federali trattenute',0),(556153,15449,'tl','',0),(556154,15449,'th','à¸ à¸²à¸©à¸µà¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(556155,15449,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤•à¤°à¥‹à¤‚ à¤ªà¤° à¤°à¥‹à¤• à¤²à¤—à¤¾à¤ˆ',0),(556156,15449,'ms','Persekutuan cukai yang dipungut',0),(556157,15449,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ø§Ù„Ù…Ø­ØªØ¬Ø²Ø©',0),(556158,15449,'fr','ImpÃ´t fÃ©dÃ©ral retenu',0),(556159,15449,'jp','é€£é‚¦ç¨ŽãŒæºæ³‰å¾´åŽ',0),(556160,15449,'pt','Impostos federais retidos',0),(556161,15449,'ru','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¸ ÑƒÐ´ÐµÑ€Ð¶Ð¸Ð²Ð°ÑŽÑ‚ÑÑ',0),(556162,15449,'es','Impuestos federales retenidos',0),(556163,15449,'de','Bundessteuern zurÃ¼ckgehalten',0),(556164,15449,'en','Federal Taxes Withheld',0),(556165,15450,'is','',0),(556166,15450,'dr','Ù…Ø§Ù„ÛŒØ§Øª ÙØ¯Ø±Ø§Ù„ Ø¨ÛŒÚ©Ø§Ø±ÛŒ',0),(556167,15450,'pr','Ù…Ø§Ù„ÛŒØ§Øª ÙØ¯Ø±Ø§Ù„ Ø¨ÛŒÚ©Ø§Ø±ÛŒ',0),(556168,15450,'tr','Federal iÅŸsizlik vergiler',0),(556169,15450,'pl','PodatkÃ³w federalnych bezrobocia',0),(556170,15450,'bg','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(556171,15450,'ur','Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ú©ÛŒ Ø´Ø±Ø­ ÙˆÙØ§Ù‚ÛŒ Ù¹ÛŒÚ©Ø³',0),(556172,15450,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚ Ð¿Ð¾Ñ€ÐµÐ·',0),(556173,15450,'vi','Tá»· lá»‡ tháº¥t nghiá»‡p liÃªn bang thuáº¿',0),(556174,15450,'af','Federale werkloosheid belasting',0),(556175,15450,'ro','Taxele de ÅŸomaj federale',0),(556176,15450,'et','FÃ¶deraal tÃ¶Ã¶tuse maksud',0),(556177,15450,'si','Zvezni brezposelnosti davkov',0),(556178,15450,'ba','Pengangguran Federal pajak',0),(556179,15450,'nl','Federale werkloosheid belastingen',0),(556180,15450,'fi','Federal tyÃ¶ttÃ¶myys verot',0),(556181,15450,'no','FÃ¸derale arbeidsledighet skatter',0),(556182,15450,'da','FÃ¸derale arbejdslÃ¸shed skatter',0),(556183,15450,'ko','ì—°ë°© ì‹¤ì§ ì„¸ê¸ˆ',0),(556184,15450,'he','××‘×˜×œ×” ×¤×“×¨×œ×™ ×ž×™×¡×™×',0),(556185,15450,'el','ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® Î±Î½ÎµÏÎ³Î¯Î±Ï‚ Ï†ÏŒÏÏ‰Î½',0),(556186,15450,'zh','è”é‚¦å¤±ä¸šç¨Ž',0),(556187,15450,'sv','Federala arbetslÃ¶shet skatter',0),(556188,15450,'it','Tasse di disoccupazione federale',0),(556189,15450,'tl','',0),(556190,15450,'th','à¸ à¸²à¸©à¸µà¸§à¹ˆà¸²à¸‡à¸‡à¸²à¸™à¸£à¸±à¸à¸šà¸²à¸¥à¸à¸¥à¸²à¸‡',0),(556191,15450,'hi','à¤¸à¤‚à¤˜à¥€à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤•à¤°à¥‹à¤‚',0),(556192,15450,'ms','Cukai Persekutuan pengangguran',0),(556193,15450,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ø§Ù„Ø¨Ø·Ø§Ù„Ø©',0),(556194,15450,'fr','Taxes de chÃ´mage fÃ©dÃ©rale',0),(556195,15450,'jp','ä¸­å¤®æ”¿åºœå¤±æ¥­ç¨Ž',0),(556196,15450,'pt','Taxas de desemprego Federal',0),(556197,15450,'ru','ÐÐ°Ð»Ð¾Ð³Ð¸ Ð½Ð° Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹',0),(556198,15450,'es','Impuestos de desempleo federales',0),(556199,15450,'de','FÃ¶derale Arbeitslosigkeit Steuern',0),(556200,15450,'en','Federal Unemployment Taxes',0),(556201,15451,'is','',0),(556202,15451,'dr','Ù…Ø¹Ø§ÙÛŒØª Ù‡Ø§ÛŒ ØªØºØ°ÛŒÙ‡',0),(556203,15451,'pr','Ù…Ø¹Ø§ÙÛŒØª Ù‡Ø§ÛŒ ØªØºØ°ÛŒÙ‡',0),(556204,15451,'tr','Federal muafiyetler',0),(556205,15451,'pl','Karmione zwolnienia',0),(556206,15451,'bg','Ð¤ÐµÐ´ Ð¸Ð·ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ',0),(556207,15451,'ur','ØªÙ†Ú¯ Ø¢ Ú¯ÛŒØ§ Ø§Ø³ØªØ«Ù†Ø§Ø¦ÛŒÚº',0),(556208,15451,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð°Ñ† Ð¸Ð·ÑƒÐ·ÐµÑ›Ð°',0),(556209,15451,'vi','Ä‚n miá»…n trá»«',0),(556210,15451,'af','Gevoed vrystellings',0),(556211,15451,'ro','HrÄƒnite scutiri',0),(556212,15451,'et','Toidetud maksuvabastused',0),(556213,15451,'si','Krmijo izjeme',0),(556214,15451,'ba','Makan pengecualian',0),(556215,15451,'nl','Gevoed vrijstellingen',0),(556216,15451,'fi','KyllÃ¤stynyt vapautukset',0),(556217,15451,'no','Matet unntak',0),(556218,15451,'da','Fodret undtagelser',0),(556219,15451,'ko','ì—°ë°©ëœ ë©´ì œ',0),(556220,15451,'he','×¤×˜×•×¨×™× ×ž×”×‘×•×œ×©×ª',0),(556221,15451,'el','Î¤ÏÎ­Ï†Î¿Î½Ï„Î±Î¹ Î±Ï€Î±Î»Î»Î±Î³Î­Ï‚',0),(556222,15451,'zh','ç¾Žè”å‚¨çš„è±å…',0),(556223,15451,'sv','Fodrat undantag',0),(556224,15451,'it','Nutriti di esenzioni',0),(556225,15451,'tl','',0),(556226,15451,'th','à¹€à¸¥à¸µà¹‰à¸¢à¸‡à¸”à¸¹ Exemptions',0),(556227,15451,'hi','à¤¤à¤‚à¤— à¤† à¤—à¤¯à¤¾ à¤®à¥‡à¤‚ à¤›à¥‚à¤Ÿ',0),(556228,15451,'ms','Pengecualian-pengecualian yang cukup makan',0),(556229,15451,'ar','ØªØºØ°ÙŠØ© Ø§Ù„Ø¥Ø¹ÙØ§Ø¡Ø§Øª',0),(556230,15451,'fr','Nourris des Exemptions',0),(556231,15451,'jp','ä¸Žãˆã‚‰ã‚ŒãŸå…é™¤',0),(556232,15451,'pt','IsenÃ§Ãµes alimentadas',0),(556233,15451,'ru','Ð¤Ð Ð¡ Ð¸Ð·ÑŠÑÑ‚Ð¸Ñ',0),(556234,15451,'es','Exenciones alimentadas',0),(556235,15451,'de','Beschickter Ausnahmen',0),(556236,15451,'en','Fed Exemptions',0),(556237,15452,'is','',0),(556238,15452,'dr','ØªØºØ°ÛŒÙ‡ Ø§Ø¶Ø§ÙÛŒ',0),(556239,15452,'pr','ØªØºØ°ÛŒÙ‡ Ø§Ø¶Ø§ÙÛŒ',0),(556240,15452,'tr','Ekstra beslenen',0),(556241,15452,'pl','Karmione Extra',0),(556242,15452,'bg','Ð¥Ñ€Ð°Ð½ÐµÐ½Ð¸ Ð•ÐºÑÑ‚Ñ€Ð°',0),(556243,15452,'ur','Ø§Ø¶Ø§ÙÛŒ Ú©Ú¾Ù„Ø§ÛŒØ§',0),(556244,15452,'sr','Ð¥Ñ€Ð°Ð½Ð¸Ð¾ Ð•xÑ‚Ñ€Ð°',0),(556245,15452,'vi','Ä‚n thÃªm',0),(556246,15452,'af','Ekstra gevoer',0),(556247,15452,'ro','HrÄƒnite Extra',0),(556248,15452,'et','Toidetud Extra',0),(556249,15452,'si','Krmijo Extra',0),(556250,15452,'ba','Makan Extra',0),(556251,15452,'nl','Extra gevoed',0),(556252,15452,'fi','KyllÃ¤stynyt Extra',0),(556253,15452,'no','Matet ekstra',0),(556254,15452,'da','Fodret ekstra',0),(556255,15452,'ko','ì¶”ê°€ ê³µê¸‰',0),(556256,15452,'he','×”××›×œ×ª × ×•×¡×£',0),(556257,15452,'el','Î¤ÏÎ­Ï†Î¿Î½Ï„Î±Î¹ Extra',0),(556258,15452,'zh','ç¾Žè”å‚¨é¢å¤–',0),(556259,15452,'sv','Fodrat Extra',0),(556260,15452,'it','Alimentato Extra',0),(556261,15452,'tl','',0),(556262,15452,'th','à¸­à¸²à¸«à¸²à¸£à¹€à¸ªà¸£à¸´à¸¡',0),(556263,15452,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤–à¤¿à¤²à¤¾à¤¯à¤¾',0),(556264,15452,'ms','Makan tambahan',0),(556265,15452,'ar','ØªØºØ°ÙŠØ© Ø¥Ø¶Ø§ÙÙŠØ©',0),(556266,15452,'fr','Nourris Extra',0),(556267,15452,'jp','ä½™åˆ†ãªã‚’ä¾›çµ¦',0),(556268,15452,'pt','Alimentados Extra',0),(556269,15452,'ru','ÐšÐ¾Ñ€Ð¼Ð¸Ð»Ð¸ Ð·Ð°Ð³Ð¾Ñ€Ð¾Ð´Ð½Ñ‹Ð¹',0),(556270,15452,'es','AlimentaciÃ³n Extra',0),(556271,15452,'de','Extra gefÃ¼ttert',0),(556272,15452,'en','Fed Extra',0),(556273,15453,'is','',0),(556274,15453,'dr','ÙˆØ¶Ø¹ÛŒØª ØªØºØ°ÛŒÙ‡',0),(556275,15453,'pr','ÙˆØ¶Ø¹ÛŒØª ØªØºØ°ÛŒÙ‡',0),(556276,15453,'tr','Federal durumu',0),(556277,15453,'pl','Karmione Status',0),(556278,15453,'bg','Ð¤ÐµÐ´ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(556279,15453,'ur','ØªÙ†Ú¯ Ø¢ Ú¯ÛŒØ§ Ø­Ø§Ù„Øª',0),(556280,15453,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(556281,15453,'vi','TÃ¬nh tráº¡ng Äƒn',0),(556282,15453,'af','Gevoed Status',0),(556283,15453,'ro','HrÄƒnite statutul',0),(556284,15453,'et','Toidetud olek',0),(556285,15453,'si','Krmijo Status',0),(556286,15453,'ba','Makan Status',0),(556287,15453,'nl','Gevoed Status',0),(556288,15453,'fi','KyllÃ¤stynyt tila',0),(556289,15453,'no','Matet Status',0),(556290,15453,'da','Fodret Status',0),(556291,15453,'ko','ì—°ë°©ëœ ìƒíƒœ',0),(556292,15453,'he','×ž×¦×‘ ×ž×”×‘×•×œ×©×ª',0),(556293,15453,'el','Î¤ÏÎ­Ï†Î¿Î½Ï„Î±Î¹ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(556294,15453,'zh','ç¾Žè”å‚¨çš„åœ°ä½',0),(556295,15453,'sv','Fodrat Status',0),(556296,15453,'it','Stato federale',0),(556297,15453,'tl','',0),(556298,15453,'th','à¸ªà¸–à¸²à¸™à¸°à¸¢à¸±à¸‡à¸„à¸‡',0),(556299,15453,'hi','à¤¤à¤‚à¤— à¤† à¤—à¤¯à¤¾ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(556300,15453,'ms','Status makanan',0),(556301,15453,'ar','Ù…Ø±ÙƒØ² ØªØºØ°ÙŠØ©',0),(556302,15453,'fr','Nourris de statut',0),(556303,15453,'jp','ä¾›çµ¦çŠ¶æ…‹',0),(556304,15453,'pt','Estatuto federal',0),(556305,15453,'ru','Ð¤Ð Ð¡ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(556306,15453,'es','Estado alimentado',0),(556307,15453,'de','Beschickter Status',0),(556308,15453,'en','Fed Status',0),(556309,15454,'is','',0),(556310,15454,'dr','Ø¨Ø§Ù†Ú© ÙØ¯Ø±Ø§Ù„ Ù†Ú©Ø±Ø¯Ù†',0),(556311,15454,'pr','Ø¨Ø§Ù†Ú© ÙØ¯Ø±Ø§Ù„ Ù†Ú©Ø±Ø¯Ù†',0),(556312,15454,'tr','Fed tevkif',0),(556313,15454,'pl','Fed wstrzymane',0),(556314,15454,'bg','Ð¤ÐµÐ´ ÑƒÐ´ÑŠÑ€Ð¶Ð°Ð½Ð¸',0),(556315,15454,'ur','Ú©Ú¾Ù„Ø§ÛŒØ§ Ú†Ø§ÛØªÛŒ ØªÚ¾ÛŒÚº',0),(556316,15454,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ðµ Ñ€ÐµÐ·ÐµÑ€Ð²Ðµ ÐºÑ€Ð¸Ð¾',0),(556317,15454,'vi','Fed giá»¯ láº¡i',0),(556318,15454,'af','Fed weerhou',0),(556319,15454,'ro','Fed reÅ£inute',0),(556320,15454,'et','Fed kinnipeetud',0),(556321,15454,'si','Fed, zadrÅ¾i',0),(556322,15454,'ba','Fed ditahan',0),(556323,15454,'nl','Fed ingehouden',0),(556324,15454,'fi','Fed pidÃ¤tetty',0),(556325,15454,'no','Fed tilbakeholdt',0),(556326,15454,'da','Fed tilbageholdt',0),(556327,15454,'ko','ì—° ì¤€ ì›ì²œ ì§•ìˆ˜',0),(556328,15454,'he','×¤×“×¨×œ×™ ×©× ×•×›×” ×‘×ž×§×•×¨',0),(556329,15454,'el','Fed Ï€Î±ÏÎ±ÎºÏÎ±Ï„Î·Î¸ÎµÎ¯',0),(556330,15454,'zh','ç¾Žè”å‚¨è¢«æ‰£ç•™',0),(556331,15454,'sv','Fed inne',0),(556332,15454,'it','Fed trattenuto',0),(556333,15454,'tl','',0),(556334,15454,'th','à¹€à¸Ÿà¸”à¸„à¸‡à¸„à¹‰à¸²à¸‡',0),(556335,15454,'hi','à¤«à¥‡à¤¡ à¤ªà¤° à¤°à¥‹à¤• à¤²à¤—à¤¾à¤ˆ',0),(556336,15454,'ms','Fed ditahan',0),(556337,15454,'ar','Ø¨Ù†Ùƒ Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠ Ø§Ù„ÙÙŠØ¯Ø±Ø§Ù„ÙŠ Ø§Ù„Ù…Ø­ØªØ¬Ø²Ø©',0),(556338,15454,'fr','FED retenu',0),(556339,15454,'jp','Fed ã®æºæ³‰å¾´åŽ',0),(556340,15454,'pt','FED retido',0),(556341,15454,'ru','Ð¤Ð Ð¡ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð¾',0),(556342,15454,'es','Reserva Federal retenido',0),(556343,15454,'de','Fed zurÃ¼ckgehalten',0),(556344,15454,'en','Fed Withheld',0),(556345,15455,'is','',0),(556346,15455,'dr','FUI GL',0),(556347,15455,'pr','FUI GL',0),(556348,15455,'tr','FUI GL',0),(556349,15455,'pl','FUI GL',0),(556350,15455,'bg','FUI GL',0),(556351,15455,'ur','Ø¬ÛŒØ¬Û’ ÙØ§',0),(556352,15455,'sr','Ð¡Ð˜Ð¢Ð Ð“Ð›',0),(556353,15455,'vi','FUI GL',0),(556354,15455,'af','FUI GL',0),(556355,15455,'ro','FUI GL',0),(556356,15455,'et','FUI GL',0),(556357,15455,'si','FUI GL',0),(556358,15455,'ba','FUI GL',0),(556359,15455,'nl','FUI GL',0),(556360,15455,'fi','FUI GL',0),(556361,15455,'no','FUI GL',0),(556362,15455,'da','FUI GL',0),(556363,15455,'ko','FUI GL',0),(556364,15455,'he','FUI GL',0),(556365,15455,'el','FUI GL',0),(556366,15455,'zh','ç°æ²™ GL',0),(556367,15455,'sv','FUI GL',0),(556368,15455,'it','FUI GL',0),(556369,15455,'tl','',0),(556370,15455,'th','FUI GL',0),(556371,15455,'hi','FUI GL',0),(556372,15455,'ms','FUI GL',0),(556373,15455,'ar','ÙÙŠ Ø¬ÙŠ Ø§Ù„',0),(556374,15455,'fr','FUI GL',0),(556375,15455,'jp','FUI GL',0),(556376,15455,'pt','FUI GL',0),(556377,15455,'ru','FUI GL',0),(556378,15455,'es','FUI GL',0),(556379,15455,'de','FUI GL',0),(556380,15455,'en','FUI GL',0),(556381,15456,'is','',0),(556382,15456,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ FUI',0),(556383,15456,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ FUI',0),(556384,15456,'tr','FUI Ã¼cret',0),(556385,15456,'pl','PÅ‚ace FUI',0),(556386,15456,'bg','FUI Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(556387,15456,'ur','ÙØ§ Ø§Ø¬Ø±Øª',0),(556388,15456,'sr','Ð¡Ð¸Ñ‚Ð° Ð¿Ð»Ð°Ñ‚Ðµ',0),(556389,15456,'vi','Tiá»n lÆ°Æ¡ng FUI',0),(556390,15456,'af','FUI lone',0),(556391,15456,'ro','FUI salariile',0),(556392,15456,'et','FUI palk',0),(556393,15456,'si','PlaÄe FUI',0),(556394,15456,'ba','FUI upah',0),(556395,15456,'nl','FUI lonen',0),(556396,15456,'fi','FUI palkat',0),(556397,15456,'no','FUI lÃ¸nn',0),(556398,15456,'da','FUI lÃ¸n',0),(556399,15456,'ko','FUI ìž„ê¸ˆ',0),(556400,15456,'he','×©×›×¨ FUI',0),(556401,15456,'el','FUI Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(556402,15456,'zh','ç°æ²™å·¥èµ„',0),(556403,15456,'sv','FUI lÃ¶ner',0),(556404,15456,'it','FUI salari',0),(556405,15456,'tl','',0),(556406,15456,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡ FUI',0),(556407,15456,'hi','FUI à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(556408,15456,'ms','Upah FUI',0),(556409,15456,'ar','ÙÙŠ Ø§Ù„Ø£Ø¬ÙˆØ±',0),(556410,15456,'fr','FUI salaires',0),(556411,15456,'jp','FUI è³ƒé‡‘',0),(556412,15456,'pt','FUI salÃ¡rios',0),(556413,15456,'ru','FUI Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(556414,15456,'es','FUI salarios',0),(556415,15456,'de','FUI LÃ¶hne',0),(556416,15456,'en','FUI Wages',0),(556417,15457,'is','',0),(556418,15457,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ú©Ù„ÛŒ Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(556419,15457,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ú©Ù„ÛŒ Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(556420,15457,'tr','Genel toplamlarÄ± Ã¼zerinden',0),(556421,15457,'pl','Sumy przez',0),(556422,15457,'bg','ÐžÐ±Ñ‰Ð¸ ÑÑƒÐ¼Ð¸ Ñ‡Ñ€ÐµÐ·',0),(556423,15457,'ur','Ú¯Ø±ÛŒÙ†Úˆ Ù…ÛŒØ²Ø§Ù† Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(556424,15457,'sr','Ð¡Ð²ÐµÑƒÐºÑƒÐ¿Ð½Ð¸Ñ… ÐºÑ€Ð¾Ð·',0),(556425,15457,'vi','Grand tá»•ng sá»‘ thÃ´ng qua',0),(556426,15457,'af','Grand totale deur',0),(556427,15457,'ro','Totaluri prin',0),(556428,15457,'et','ÃœldkokkuvÃµtete kaudu',0),(556429,15457,'si','Vsote skozi',0),(556430,15457,'ba','Grand Total melalui',0),(556431,15457,'nl','Eindtotalen via',0),(556432,15457,'fi','Loppusummat kautta',0),(556433,15457,'no','Totalsummer gjennom',0),(556434,15457,'da','Hovedtotaler gennem',0),(556435,15457,'ko','í†µí•´ ì´í•©ê³„',0),(556436,15457,'he','×”×¡×›×•×ž×™× ×“×¨×š',0),(556437,15457,'el','Î‘Î¸ÏÎ¿Î¯ÏƒÎ¼Î±Ï„Î± Î¼Î­ÏƒÏ‰',0),(556438,15457,'zh','é€šè¿‡æ€»è®¡',0),(556439,15457,'sv','Totalsummor genom',0),(556440,15457,'it','Totali complessivi attraverso',0),(556441,15457,'tl','',0),(556442,15457,'th','à¸œà¸¥à¸œà¹ˆà¸²à¸™',0),(556443,15457,'hi','à¤®à¤¹à¤¾à¤¯à¥‹à¤— à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡',0),(556444,15457,'ms','Jumlah Grand melalui',0),(556445,15457,'ar','Ø§Ù„Ù…Ø¬Ø§Ù…ÙŠØ¹ Ø§Ù„ÙƒÙ„ÙŠØ© Ù…Ù† Ø®Ù„Ø§Ù„',0),(556446,15457,'fr','Totaux par',0),(556447,15457,'jp','ç·è¨ˆ',0),(556448,15457,'pt','Totais atravÃ©s',0),(556449,15457,'ru','ÐžÐ±Ñ‰Ð¸Ðµ Ð¸Ñ‚Ð¾Ð³Ð¸ Ñ‡ÐµÑ€ÐµÐ·',0),(556450,15457,'es','Totales a travÃ©s de',0),(556451,15457,'de','Gesamtergebnisse durch',0),(556452,15457,'en','Grand Totals Through',0),(556453,15458,'is','',0),(556454,15458,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§Ø®Ø§Ù„Øµ',0),(556455,15458,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§Ø®Ø§Ù„Øµ',0),(556456,15458,'tr','BrÃ¼t Ã¼cret',0),(556457,15458,'pl','Wynagrodzenia brutto',0),(556458,15458,'bg','Ð‘Ñ€ÑƒÑ‚Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(556459,15458,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ Ø§Ø¬Ø±Øª',0),(556460,15458,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð·Ð°Ñ€Ð°Ð´Ðµ',0),(556461,15458,'vi','Tá»•ng tiá»n lÆ°Æ¡ng',0),(556462,15458,'af','Bruto lone',0),(556463,15458,'ro','Salarii brute',0),(556464,15458,'et','Palkade kogusumma',0),(556465,15458,'si','Bruto plaÄe',0),(556466,15458,'ba','Gaji Bruto',0),(556467,15458,'nl','Bruto lonen',0),(556468,15458,'fi','Bruttopalkat',0),(556469,15458,'no','Brutto lÃ¸nn',0),(556470,15458,'da','BruttolÃ¸nnen',0),(556471,15458,'ko','ì´ ìž„ê¸ˆ',0),(556472,15458,'he','×©×›×¨ ×‘×¨×•×˜×•',0),(556473,15458,'el','Î‘ÎºÎ±Î¸Î¬ÏÎ¹ÏƒÏ„ÎµÏ‚ Î±Ï€Î¿Î´Î¿Ï‡Î­Ï‚',0),(556474,15458,'zh','æ¯›å·¥èµ„',0),(556475,15458,'sv','LÃ¶nesummor',0),(556476,15458,'it','Stipendi lordi',0),(556477,15458,'tl','',0),(556478,15458,'th','à¸£à¸§à¸¡à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(556479,15458,'hi','à¤¸à¤•à¤² à¤µà¥‡à¤¤à¤¨',0),(556480,15458,'ms','Gaji kasar',0),(556481,15458,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø£Ø¬ÙˆØ±',0),(556482,15458,'fr','Salaire brut',0),(556483,15458,'jp','è³ƒé‡‘ç·é¡',0),(556484,15458,'pt','SalÃ¡rio bruto',0),(556485,15458,'ru','Ð—Ð°Ñ€Ð¿Ð»Ð°Ñ‚Ð° Ð±Ñ€ÑƒÑ‚Ñ‚Ð¾',0),(556486,15458,'es','Salario bruto',0),(556487,15458,'de','BruttolÃ¶hne',0),(556488,15458,'en','Gross Wages',0),(556489,15459,'is','',0),(556490,15459,'dr','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø·ÙˆÙ„',0),(556491,15459,'pr','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø·ÙˆÙ„',0),(556492,15459,'tr','KiralÄ±k uzunluÄŸu',0),(556493,15459,'pl','Wynajem dÅ‚ugoÅ›ci',0),(556494,15459,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð½Ð° Ð½Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð¾Ð±Ð¸Ð»Ð¸',0),(556495,15459,'ur','Ù„Ù…Ø¨Ø§Ø¦ÛŒ Ú©ÛŒ Ø®Ø¯Ù…Ø§Øª Ø­Ø§ØµÙ„',0),(556496,15459,'sr','Ð£Ð½Ð°Ñ˜Ð¼Ð¸Ñ‚Ðµ Ð´ÑƒÐ¶Ð¸Ð½Ð°',0),(556497,15459,'vi','Chiá»u dÃ i cho thuÃª',0),(556498,15459,'af','Huur lengte',0),(556499,15459,'ro','ÃŽnchiriere lungime',0),(556500,15459,'et','Rendi pikkus',0),(556501,15459,'si','DolÅ¾ina najema',0),(556502,15459,'ba','Penyewaan panjang',0),(556503,15459,'nl','Huren van lengte',0),(556504,15459,'fi','Vuokraus pituus',0),(556505,15459,'no','Ansette lengde',0),(556506,15459,'da','Biludlejning i lÃ¦ngden',0),(556507,15459,'ko','ëŒ€ ê¸¸ì´',0),(556508,15459,'he','×œ×©×›×•×¨ ××•×¨×š',0),(556509,15459,'el','Î•Î½Î¿Î¹ÎºÎ¯Î±ÏƒÎ· Î¼Î®ÎºÎ¿Ï‚',0),(556510,15459,'zh','é›‡ç”¨é•¿åº¦',0),(556511,15459,'sv','Hyra lÃ¤ngd',0),(556512,15459,'it','Lunghezza di noleggio',0),(556513,15459,'tl','',0),(556514,15459,'th','à¹€à¸Šà¹ˆà¸²à¸¢à¸²à¸§',0),(556515,15459,'hi','à¤²à¤‚à¤¬à¤¾à¤ˆ à¤•à¤¿à¤°à¤¾à¤¯à¤¾',0),(556516,15459,'ms','Tempoh Penyewaan',0),(556517,15459,'ar','Ù…Ø¯Ø© Ø§Ù„Ø§Ø³ØªØ¦Ø¬Ø§Ø±',0),(556518,15459,'fr','DurÃ©e de la location',0),(556519,15459,'jp','é•·ã•ã‚’é›‡ã†',0),(556520,15459,'pt','Aluguer de comprimento',0),(556521,15459,'ru','ÐÑ€ÐµÐ½Ð´Ð° Ð´Ð»Ð¸Ð½Ð°',0),(556522,15459,'es','Alquiler de vestido',0),(556523,15459,'de','LÃ¤nge zu mieten',0),(556524,15459,'en','Hire Length',0),(556525,15460,'is','',0),(556526,15460,'dr','Ø³Ø§Ø¹Øª & Ø¯Ø³ØªÙ…Ø²Ø¯',0),(556527,15460,'pr','Ø³Ø§Ø¹Øª & Ø¯Ø³ØªÙ…Ø²Ø¯',0),(556528,15460,'tr','Saat ve Ã¼cret',0),(556529,15460,'pl','Godzin idealna pÅ‚ace',0),(556530,15460,'bg','Ð§Ð°ÑÐ° & Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(556531,15460,'ur','Ú¯Ú¾Ù†Ù¹ÙˆÚº & Ø§Ø¬Ø±Øª',0),(556532,15460,'sr','Ð¡Ð°Ñ‚Ð¸ Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ',0),(556533,15460,'vi','Giá» & lÆ°Æ¡ng',0),(556534,15460,'af','Ure & lone',0),(556535,15460,'ro','Ore & salariile',0),(556536,15460,'et','Tundi- & palk',0),(556537,15460,'si','Ur & plaÄe',0),(556538,15460,'ba','Jam & upah',0),(556539,15460,'nl','Uur & lonen',0),(556540,15460,'fi','Tuntia/Teachers & palkat',0),(556541,15460,'no','Timer & lÃ¸nn',0),(556542,15460,'da','Timer & lÃ¸n',0),(556543,15460,'ko','ì‹œê°„ ë° ìž„ê¸ˆ',0),(556544,15460,'he','×©×›×¨ & ×©×¢×•×ª',0),(556545,15460,'el','ÎÏÎµÏ‚ & Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(556546,15460,'zh','æ—¶é—´ä¸Žå·¥èµ„',0),(556547,15460,'sv','Timmar & lÃ¶ner',0),(556548,15460,'it','Ore & salari',0),(556549,15460,'tl','',0),(556550,15460,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¸„à¸¸à¹‰à¸¡à¸„à¹ˆà¸²',0),(556551,15460,'hi','à¤˜à¤‚à¤Ÿà¥‡ & à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(556552,15460,'ms','Jam & upah',0),(556553,15460,'ar','Ø£Ø¬ÙˆØ± Ø³Ø§Ø¹Ø§Øª &',0),(556554,15460,'fr','Heures des salaires &',0),(556555,15460,'jp','æ™‚é–“ãƒ»è³ƒé‡‘',0),(556556,15460,'pt','Horas e salÃ¡rios',0),(556557,15460,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð° & Ñ‡Ð°ÑÐ¾Ð²',0),(556558,15460,'es','Horas y salarios',0),(556559,15460,'de','Stunden & LÃ¶hne',0),(556560,15460,'en','Hours & Wages',0),(556561,15461,'is','',0),(556562,15461,'dr','Ø´Ø§Ù…Ù„ Ø³ØªÙˆÙ†',0),(556563,15461,'pr','Ø´Ø§Ù…Ù„ Ø³ØªÙˆÙ†',0),(556564,15461,'tr','Ä°Ã§in sÃ¼tunlar eklemek',0),(556565,15461,'pl','ZawierajÄ… kolumny dla',0),(556566,15461,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÐºÐ¾Ð»Ð¾Ð½Ð¸ Ð·Ð°',0),(556567,15461,'ur','Ú©Û’ Ù„ÛŒÛ’ Ú©Ø§Ù„Ù… Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(556568,15461,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð·Ð°',0),(556569,15461,'vi','Bao gá»“m cÃ¡c cá»™t cho',0),(556570,15461,'af','Sluit kolomme vir',0),(556571,15461,'ro','Includ coloane pentru',0),(556572,15461,'et','Lisada veerge',0),(556573,15461,'si','VkljuÄujejo stolpce za',0),(556574,15461,'ba','Mencakup kolom untuk',0),(556575,15461,'nl','Kolommen voor opnemen',0),(556576,15461,'fi','Sarakkeita varten',0),(556577,15461,'no','Inkluder kolonner For',0),(556578,15461,'da','Omfatte kolonner til',0),(556579,15461,'ko','ì— ëŒ€ í•œ ì—´ì„ í¬í•¨',0),(556580,15461,'he','×œ×›×œ×•×œ ×¢×ž×•×“×•×ª ×¢×‘×•×¨',0),(556581,15461,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ ÏƒÏ„Î®Î»ÎµÏ‚ Î³Î¹Î±',0),(556582,15461,'zh','åŒ…å«åˆ—',0),(556583,15461,'sv','LÃ¤gga till kolumner fÃ¶r',0),(556584,15461,'it','Includere colonne per',0),(556585,15461,'tl','',0),(556586,15461,'th','à¸£à¸§à¸¡à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œ',0),(556587,15461,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¤à¤‚à¤­ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(556588,15461,'ms','Termasuk tiang untuk',0),(556589,15461,'ar','Ø¥Ø¯Ø±Ø§Ø¬ Ø£Ø¹Ù…Ø¯Ø©',0),(556590,15461,'fr','Inclure des colonnes pour',0),(556591,15461,'jp','åˆ—ã‚’å«ã‚ã‚‹',0),(556592,15461,'pt','Incluir colunas para',0),(556593,15461,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ ÑÑ‚Ð¾Ð»Ð±Ñ†Ñ‹ Ð´Ð»Ñ',0),(556594,15461,'es','Incluyen columnas para',0),(556595,15461,'de','Eingeschlossene Spalten fÃ¼r',0),(556596,15461,'en','Include Columns For',0),(556597,15462,'is','',0),(556598,15462,'dr','Ù…Ø­Ù„',0),(556599,15462,'pr','Ù…Ø­Ù„',0),(556600,15462,'tr','Yerellik',0),(556601,15462,'pl','MiejscowoÅ›ci',0),(556602,15462,'bg','ÐœÐµÑÑ‚Ð½Ð¾ÑÑ‚',0),(556603,15462,'ur','Ø¹Ù„Ø§Ù‚Û’',0),(556604,15462,'sr','Ð›Ð¾ÐºÐ°Ð»Ð¸Ñ‚ÐµÑ‚',0),(556605,15462,'vi','Äá»‹a phÆ°Æ¡ng',0),(556606,15462,'af','Ligging',0),(556607,15462,'ro','Localitatea',0),(556608,15462,'et','Paikkonnas',0),(556609,15462,'si','Kraja',0),(556610,15462,'ba','Wilayah',0),(556611,15462,'nl','Plaats',0),(556612,15462,'fi','Sijainti',0),(556613,15462,'no','Lokalitet',0),(556614,15462,'da','Lokalitet',0),(556615,15462,'ko','ì§€ì—­',0),(556616,15462,'he','×‘×ž×“×™× ×ª×š',0),(556617,15462,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(556618,15462,'zh','çŽ°åœº',0),(556619,15462,'sv','TÃ¤tort',0),(556620,15462,'it','LocalitÃ ',0),(556621,15462,'tl','',0),(556622,15462,'th','à¸—à¹‰à¸­à¸‡à¸–à¸´à¹ˆà¸™',0),(556623,15462,'hi','à¤‡à¤²à¤¾à¤•à¥‡',0),(556624,15462,'ms','Hakmilik',0),(556625,15462,'ar','Ø§Ù„Ù…ÙƒØ§Ù†',0),(556626,15462,'fr','LocalitÃ©',0),(556627,15462,'jp','å±€æ‰€æ€§',0),(556628,15462,'pt','Localidade',0),(556629,15462,'ru','ÐÐ°ÑÐµÐ»ÐµÐ½Ð½Ñ‹Ð¹ Ð¿ÑƒÐ½ÐºÑ‚',0),(556630,15462,'es','Localidad',0),(556631,15462,'de','Ort',0),(556632,15462,'en','Locality',0),(556633,15463,'is','',0),(556634,15463,'dr','Ù…Ø­Ù„ÛŒ Ø§Ø¶Ø§ÙÛŒ',0),(556635,15463,'pr','Ù…Ø­Ù„ÛŒ Ø§Ø¶Ø§ÙÛŒ',0),(556636,15463,'tr','Yerel ekstra',0),(556637,15463,'pl','Lokalnych Extra',0),(556638,15463,'bg','ÐœÐµÑÑ‚Ð½Ð¾ Ð•ÐºÑÑ‚Ñ€Ð°',0),(556639,15463,'ur','Ù…Ù‚Ø§Ù…ÛŒ Ø§Ø¶Ø§ÙÛŒ',0),(556640,15463,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¸ Ð•xÑ‚Ñ€Ð°',0),(556641,15463,'vi','Äá»‹a phÆ°Æ¡ng thÃªm',0),(556642,15463,'af','Plaaslike ekstra',0),(556643,15463,'ro','Extra locale',0),(556644,15463,'et','Kohaliku Extra',0),(556645,15463,'si','Lokalni Extra',0),(556646,15463,'ba','Tambahan lokal',0),(556647,15463,'nl','Lokale Extra',0),(556648,15463,'fi','Paikallinen Extra',0),(556649,15463,'no','Lokale ekstra',0),(556650,15463,'da','Lokale ekstra',0),(556651,15463,'ko','ì§€ì—­ ì¶”ê°€',0),(556652,15463,'he','×ª×•×¡×¤×ª ×ž×§×•×ž×™',0),(556653,15463,'el','Î¤Î¿Ï€Î¹ÎºÎ® Extra',0),(556654,15463,'zh','é¢å¤–çš„åœ°æ–¹',0),(556655,15463,'sv','Lokala Extra',0),(556656,15463,'it','Locale Extra',0),(556657,15463,'tl','',0),(556658,15463,'th','à¸—à¹‰à¸­à¸‡à¸–à¸´à¹ˆà¸™à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(556659,15463,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤',0),(556660,15463,'ms','Tambahan tempatan',0),(556661,15463,'ar','Ù…Ø­Ù„ÙŠØ© Ø¥Ø¶Ø§ÙÙŠØ©',0),(556662,15463,'fr','Local Extra',0),(556663,15463,'jp','ãƒ­ãƒ¼ã‚«ãƒ«ã®è¿½åŠ ',0),(556664,15463,'pt','Local Extra',0),(556665,15463,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð³Ð¾Ñ€Ð¾Ð´Ð½Ñ‹Ð¹',0),(556666,15463,'es','Extra local',0),(556667,15463,'de','Lokale Extra',0),(556668,15463,'en','Local Extra',0),(556669,15464,'is','',0),(556670,15464,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­Ù„ÛŒ Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(556671,15464,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­Ù„ÛŒ Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(556672,15464,'tr','AracÄ±lÄ±ÄŸÄ±yla yerel bilgi',0),(556673,15464,'pl','Lokalnych informacji poprzez',0),(556674,15464,'bg','ÐœÐµÑÑ‚Ð½Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‡Ñ€ÐµÐ·',0),(556675,15464,'ur','Ù…Ù‚Ø§Ù…ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(556676,15464,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¸ Ð˜Ð½Ñ„Ð¾ ÐºÑ€Ð¾Ð·',0),(556677,15464,'vi','CÃ¡c thÃ´ng tin Ä‘á»‹a phÆ°Æ¡ng thÃ´ng qua',0),(556678,15464,'af','Plaaslike inligting deur',0),(556679,15464,'ro','Informatii locale prin',0),(556680,15464,'et','Kohaliku Info lÃ¤bi',0),(556681,15464,'si','Lokalne informacije skozi',0),(556682,15464,'ba','Info lokal melalui',0),(556683,15464,'nl','Lokale Info via',0),(556684,15464,'fi','Paikallinen Info kautta',0),(556685,15464,'no','Lokale Info gjennom',0),(556686,15464,'da','Lokale Info via',0),(556687,15464,'ko','í†µí•´ ì§€ì—­ ì •ë³´',0),(556688,15464,'he','×‘××ž×¦×¢×•×ª ×ž×™×“×¢ ×ž×§×•×ž×™',0),(556689,15464,'el','Î¤Î¿Ï€Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î­ÏƒÏ‰',0),(556690,15464,'zh','é€šè¿‡æœ¬åœ°ä¿¡æ¯',0),(556691,15464,'sv','Lokal information genom',0),(556692,15464,'it','Info locale attraverso',0),(556693,15464,'tl','',0),(556694,15464,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¹‰à¸­à¸‡à¸–à¸´à¹ˆà¸™à¸œà¹ˆà¸²à¸™',0),(556695,15464,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡',0),(556696,15464,'ms','Info tempatan melalui',0),(556697,15464,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø­Ù„ÙŠØ© Ø¹Ù† Ø·Ø±ÙŠÙ‚',0),(556698,15464,'fr','Infos locales par le biais',0),(556699,15464,'jp','çµŒç”±ã§ãƒ­ãƒ¼ã‚«ãƒ«ã®æƒ…å ±',0),(556700,15464,'pt','InformaÃ§Ã£o local atravÃ©s',0),(556701,15464,'ru','Ð›Ð¾ÐºÐ°Ð»ÑŒÐ½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‡ÐµÑ€ÐµÐ·',0),(556702,15464,'es','InformaciÃ³n local a travÃ©s de',0),(556703,15464,'de','Lokale Infos Ã¼ber',0),(556704,15464,'en','Local Info Through',0),(556705,15465,'is','',0),(556706,15465,'dr','ÙˆØ¶Ø¹ÛŒØª Ù…Ø­Ù„ÛŒ',0),(556707,15465,'pr','ÙˆØ¶Ø¹ÛŒØª Ù…Ø­Ù„ÛŒ',0),(556708,15465,'tr','Yerel durumu',0),(556709,15465,'pl','Lokalnym Status',0),(556710,15465,'bg','ÐœÐµÑÑ‚ÐµÐ½ ÑÑ‚Ð°Ñ‚ÑƒÑ‚',0),(556711,15465,'ur','Ù…Ù‚Ø§Ù…ÛŒ Ø­Ø§Ù„Øª',0),(556712,15465,'sr','Ð›Ð¾ÐºÐ°Ð»Ð½Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(556713,15465,'vi','Tráº¡ng thÃ¡i Ä‘á»‹a phÆ°Æ¡ng',0),(556714,15465,'af','Plaaslike Status',0),(556715,15465,'ro','Statutul de locale',0),(556716,15465,'et','Kohalik olek',0),(556717,15465,'si','Lokalno stanje',0),(556718,15465,'ba','Status lokal',0),(556719,15465,'nl','Lokale Status',0),(556720,15465,'fi','Paikallinen asema',0),(556721,15465,'no','Status for lokal',0),(556722,15465,'da','Lokal Status',0),(556723,15465,'ko','ë¡œì»¬ ìƒíƒœ',0),(556724,15465,'he','×ž×¦×‘ ×ž×§×•×ž×™',0),(556725,15465,'el','Î¤Î¿Ï€Î¹ÎºÎ® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·',0),(556726,15465,'zh','æœ¬åœ°çš„èº«ä»½',0),(556727,15465,'sv','Lokala Status',0),(556728,15465,'it','Stato locale',0),(556729,15465,'tl','',0),(556730,15465,'th','à¸ªà¸–à¸²à¸™à¸°à¹€à¸‰à¸žà¸²à¸°',0),(556731,15465,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥€à¤¯ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(556732,15465,'ms','Status tempatan',0),(556733,15465,'ar','Ø§Ù„ÙˆØ¶Ø¹ Ø§Ù„Ù…Ø­Ù„ÙŠ',0),(556734,15465,'fr','Statut local',0),(556735,15465,'jp','ãƒ­ãƒ¼ã‚«ãƒ«ã®çŠ¶æ…‹',0),(556736,15465,'pt','Status local',0),(556737,15465,'ru','ÐœÐµÑÑ‚Ð½Ñ‹Ð¹ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(556738,15465,'es','Estado local',0),(556739,15465,'de','Lokalen Status',0),(556740,15465,'en','Local Status',0),(556741,15466,'is','',0),(556742,15466,'dr','Ù…Ø¯ÛŒÚ©Ø± GL',0),(556743,15466,'pr','Ù…Ø¯ÛŒÚ©Ø± GL',0),(556744,15466,'tr','Medicare GL',0),(556745,15466,'pl','Medicare GL',0),(556746,15466,'bg','Medicare GL',0),(556747,15466,'ur','Ù…ÛŒÚˆÛŒ Ø¬ÛŒØ¬Û’',0),(556748,15466,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ð“Ð›',0),(556749,15466,'vi','Medicare GL',0),(556750,15466,'af','Medicare GL',0),(556751,15466,'ro','Medicare GL',0),(556752,15466,'et','Medicare GL',0),(556753,15466,'si','Medicare GL',0),(556754,15466,'ba','Medicare GL',0),(556755,15466,'nl','Medicare GL',0),(556756,15466,'fi','Medicare GL',0),(556757,15466,'no','Medicare GL',0),(556758,15466,'da','Medicare GL',0),(556759,15466,'ko','GL ë©”ë””ì¼€ì–´',0),(556760,15466,'he','Medicare GL',0),(556761,15466,'el','Medicare GL',0),(556762,15466,'zh','åŒ»ç–—ä¿é™© GL',0),(556763,15466,'sv','Medicare GL',0),(556764,15466,'it','Medicare GL',0),(556765,15466,'tl','',0),(556766,15466,'th','à¹€à¸¡à¸”à¸´à¹à¸„à¸£à¹Œ GL',0),(556767,15466,'hi','à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤° GL',0),(556768,15466,'ms','Medicare GL',0),(556769,15466,'ar','Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ© GL',0),(556770,15466,'fr','Assurance-maladie GL',0),(556771,15466,'jp','ãƒ¡ãƒ‡ã‚£ã‚±ã‚¢ GL',0),(556772,15466,'pt','Medicare GL',0),(556773,15466,'ru','Medicare GL',0),(556774,15466,'es','Medicare GL',0),(556775,15466,'de','Medicare GL',0),(556776,15466,'en','Medicare GL',0),(556777,15467,'is','',0),(556778,15467,'dr','Ù…Ø¯ÛŒÚ©Ø± Ù…Ø§Ù„ÛŒØ§Øª Ú©Ø³Ø± Ú©Ø±Ø¯Ù‡',0),(556779,15467,'pr','Ù…Ø¯ÛŒÚ©Ø± Ù…Ø§Ù„ÛŒØ§Øª Ú©Ø³Ø± Ú©Ø±Ø¯Ù‡',0),(556780,15467,'tr','Medicare vergi tevkif',0),(556781,15467,'pl','Medicare podatek dochodowy',0),(556782,15467,'bg','Medicare ÑƒÐ´ÑŠÑ€Ð¶Ð°Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(556783,15467,'ur','Ù…ÛŒÚˆÛŒ Ù¹ÛŒÚ©Ø³ Ú†Ø§ÛØªÛŒ ØªÚ¾ÛŒÚº',0),(556784,15467,'sr','Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ð¿Ð¾Ñ€ÐµÐ· ÑƒÑÐºÑ€Ð°Ñ‚Ð¸Ð¾',0),(556785,15467,'vi','Medicare thuáº¿ giá»¯ láº¡i',0),(556786,15467,'af','Medicare belastings weerhou',0),(556787,15467,'ro','Medicare impozitele retinute',0),(556788,15467,'et','Medicare maksud kinni',0),(556789,15467,'si','Medicare davkov, zadrÅ¾i',0),(556790,15467,'ba','Medicare pajak ditahan',0),(556791,15467,'nl','Medicare belastingen ingehouden',0),(556792,15467,'fi','Medicare verot pidÃ¤tetty',0),(556793,15467,'no','Medicare avgifter trukket',0),(556794,15467,'da','Medicare skatter tilbageholdt',0),(556795,15467,'ko','ë©”ë””ì¼€ì–´ ì„¸ê¸ˆ ë³´ë¥˜',0),(556796,15467,'he','Medicare ×ž×¡ ×©× ×•×›×” ×‘×ž×§×•×¨',0),(556797,15467,'el','Medicare Ï†ÏŒÏÎ¿Ï…Ï‚ Ï€Î¿Ï… Ï€Î±ÏÎ±ÎºÏÎ±Ï„Î¿ÏÎ½Ï„Î±Î¹',0),(556798,15467,'zh','åŒ»ç–—ä¿é™©å¾ç¨Ž',0),(556799,15467,'sv','Medicare skatter inne',0),(556800,15467,'it','Medicare nelle trattenute',0),(556801,15467,'tl','',0),(556802,15467,'th','à¹€à¸¡à¸”à¸´à¹à¸„à¸£à¹Œà¸ à¸²à¸©à¸µà¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(556803,15467,'hi','à¤®à¥‡à¤¿à¤¡à¤•à¥‡à¤¯à¤° à¤•à¤°à¥‹à¤‚ à¤ªà¤° à¤°à¥‹à¤• à¤²à¤—à¤¾à¤ˆ',0),(556804,15467,'ms','Medicare cukai yang dipungut',0),(556805,15467,'ar','Ø§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ© Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ù‚ØªØ·Ø¹Ø©',0),(556806,15467,'fr','Retenues de l\'assurance-maladie',0),(556807,15467,'jp','ãƒ¡ãƒ‡ã‚£ã‚±ã‚¢ç¨ŽãŒæºæ³‰å¾´åŽ',0),(556808,15467,'pt','Medicare impostos devidos',0),(556809,15467,'ru','Medicare ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð½Ñ‹Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¸',0),(556810,15467,'es','Impuestos de Medicare retenidos',0),(556811,15467,'de','Medicare einbehaltenen Steuern',0),(556812,15467,'en','Medicare Taxes Withheld',0),(556813,15468,'is','',0),(556814,15468,'dr','Ø­Ù‚ÙˆÙ‚ Ù¾Ø²Ø´Ú©ÛŒ',0),(556815,15468,'pr','Ø­Ù‚ÙˆÙ‚ Ù¾Ø²Ø´Ú©ÛŒ',0),(556816,15468,'tr','Med Ã¼cret',0),(556817,15468,'pl','Med pÅ‚ace',0),(556818,15468,'bg','ÐœÐµÐ´ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(556819,15468,'ur','Ù…ÛŒÚˆ Ø§Ø¬Ø±Øª',0),(556820,15468,'sr','ÐœÐµÐ´Ð¸Ñ†Ð¸Ð½ÑÐºÐ¸ Ð¿Ð»Ð°Ñ‚Ðµ',0),(556821,15468,'vi','Med tiá»n lÆ°Æ¡ng',0),(556822,15468,'af','MED lone',0),(556823,15468,'ro','Cu salariile',0),(556824,15468,'et','Med palk',0),(556825,15468,'si','Med plaÄe',0),(556826,15468,'ba','Med upah',0),(556827,15468,'nl','Med lonen',0),(556828,15468,'fi','Med palkat',0),(556829,15468,'no','Med lÃ¸nn',0),(556830,15468,'da','Med lÃ¸n',0),(556831,15468,'ko','í´ëŸ½ ë©” ë“œ ìž„ê¸ˆ',0),(556832,15468,'he','×©×›×¨ ×œ×¨×¤×•××”',0),(556833,15468,'el','MED Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(556834,15468,'zh','åœ°ä¸­æµ·çš„å·¥èµ„',0),(556835,15468,'sv','Med lÃ¶ner',0),(556836,15468,'it','Salari Med',0),(556837,15468,'tl','',0),(556838,15468,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡ med',0),(556839,15468,'hi','à¤®à¥‡à¤¡ à¤µà¥‡à¤¤à¤¨',0),(556840,15468,'ms','Upah bacaan',0),(556841,15468,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± Ù…ÙŠØ¯',0),(556842,15468,'fr','Salaires med',0),(556843,15468,'jp','Med è³ƒé‡‘',0),(556844,15468,'pt','SalÃ¡rios MED',0),(556845,15468,'ru','ÐœÐµÐ´ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(556846,15468,'es','Salarios Med',0),(556847,15468,'de','Med-LÃ¶hne',0),(556848,15468,'en','Med Wages',0),(556849,15469,'is','',0),(556850,15469,'dr','Ù¾Ø²Ø´Ú©ÛŒ Ù†Ú©Ø±Ø¯Ù†',0),(556851,15469,'pr','Ù¾Ø²Ø´Ú©ÛŒ Ù†Ú©Ø±Ø¯Ù†',0),(556852,15469,'tr','Med tevkif',0),(556853,15469,'pl','Med wstrzymane',0),(556854,15469,'bg','ÐœÐµÐ´ ÑƒÐ´ÑŠÑ€Ð¶Ð°Ð½Ð¸',0),(556855,15469,'ur','Ù…ÛŒÚˆ Ú†Ø§ÛØªÛŒ ØªÚ¾ÛŒÚº',0),(556856,15469,'sr','ÐœÐµÐ´Ð¸Ñ†Ð¸Ð½ÑÐºÐ¸ ÑƒÑÐºÑ€Ð°Ñ‚Ð¸Ð¾',0),(556857,15469,'vi','Giá»¯ láº¡i Med',0),(556858,15469,'af','MED weerhou',0),(556859,15469,'ro','ReÅ£inut med',0),(556860,15469,'et','Med kinnipeetud',0),(556861,15469,'si','Med zadrÅ¾i',0),(556862,15469,'ba','Med ditahan',0),(556863,15469,'nl','Med ingehouden',0),(556864,15469,'fi','Med pidÃ¤tetty',0),(556865,15469,'no','Med tilbakeholdt',0),(556866,15469,'da','Med tilbageholdt',0),(556867,15469,'ko','í´ëŸ½ ë©” ë“œ ì›ì²œ ì§•ìˆ˜',0),(556868,15469,'he','×©× ×•×›×” ×‘×ž×§×•×¨ ×œ×¨×¤×•××”',0),(556869,15469,'el','MED Ï€Î±ÏÎ±ÎºÏÎ±Ï„Î·Î¸ÎµÎ¯',0),(556870,15469,'zh','Med æ‰£ç•™',0),(556871,15469,'sv','Med inne',0),(556872,15469,'it','Trattenuta Med',0),(556873,15469,'tl','',0),(556874,15469,'th','à¹€à¸¡à¹‡à¸”à¸«à¸±à¸',0),(556875,15469,'hi','à¤®à¥‡à¤¡ à¤ªà¤° à¤°à¥‹à¤• à¤²à¤—à¤¾à¤ˆ',0),(556876,15469,'ms','Menyembunyikan bacaan',0),(556877,15469,'ar','Ø­Ø¬Ø¨ Ù…ÙŠØ¯',0),(556878,15469,'fr','Med retenu',0),(556879,15469,'jp','Med æºæ³‰å¾´åŽ',0),(556880,15469,'pt','Reteve MED',0),(556881,15469,'ru','ÐœÐµÐ´ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð¾',0),(556882,15469,'es','Retenida Med',0),(556883,15469,'de','Med zurÃ¼ckgehalten',0),(556884,15469,'en','Med Withheld',0),(556885,15470,'is','',0),(556886,15470,'dr','Mos',0),(556887,15470,'pr','Mos',0),(556888,15470,'tr','Ecek',0),(556889,15470,'pl','Mos',0),(556890,15470,'bg','MOS',0),(556891,15470,'ur','Ø±ÛŒØ§Ø³ØªÙ…Ù†ØªØ±ÛŒ',0),(556892,15470,'sr','ÐœÐ¾Ñ',0),(556893,15470,'vi','Mos',0),(556894,15470,'af','Mos',0),(556895,15470,'ro','Luni',0),(556896,15470,'et','MOS',0),(556897,15470,'si','MOS',0),(556898,15470,'ba','Mos',0),(556899,15470,'nl','Mnd',0),(556900,15470,'fi','Mos',0),(556901,15470,'no','MOS',0),(556902,15470,'da','Mos',0),(556903,15470,'ko','Mos',0),(556904,15470,'he','×ž×•×¡',0),(556905,15470,'el','MOS',0),(556906,15470,'zh','Mos',0),(556907,15470,'sv','Mos',0),(556908,15470,'it','MOS',0),(556909,15470,'tl','',0),(556910,15470,'th','Mos',0),(556911,15470,'hi','à¤°à¤¾à¤œà¥à¤¯à¤®à¤‚à¤¤à¥à¤°à¥€',0),(556912,15470,'ms','MOS',0),(556913,15470,'ar','Ù…ÙˆØ³',0),(556914,15470,'fr','MOS',0),(556915,15470,'jp','Mos',0),(556916,15470,'pt','MÃ³s',0),(556917,15470,'ru','ÐœÐžÐŸ',0),(556918,15470,'es','MOS',0),(556919,15470,'de','Mos',0),(556920,15470,'en','Mos',0),(556921,15471,'is','',0),(556922,15471,'dr','MTD',0),(556923,15471,'pr','MTD',0),(556924,15471,'tr','MODA TASARIMCILARI DERNEÄžÄ°',0),(556925,15471,'pl','MTD',0),(556926,15471,'bg','MTD',0),(556927,15471,'ur','Ø§ØªÙ¹Ø¯',0),(556928,15471,'sr','ÐœÐ¢Ð”',0),(556929,15471,'vi','MTD',0),(556930,15471,'af','MTD',0),(556931,15471,'ro','MTD',0),(556932,15471,'et','MTD',0),(556933,15471,'si','MTD',0),(556934,15471,'ba','MTD',0),(556935,15471,'nl','MTD',0),(556936,15471,'fi','MTD',0),(556937,15471,'no','MTD',0),(556938,15471,'da','MTD',0),(556939,15471,'ko','MTD',0),(556940,15471,'he','MTD',0),(556941,15471,'el','MTD',0),(556942,15471,'zh','MTD',0),(556943,15471,'sv','MTD',0),(556944,15471,'it','MTD',0),(556945,15471,'tl','',0),(556946,15471,'th','MTD',0),(556947,15471,'hi','à¤à¤®à¤Ÿà¥€à¤¡à¥€',0),(556948,15471,'ms','PCB',0),(556949,15471,'ar','Ù…Ù„ÙŠÙˆÙ† Ø¯ÙŠÙ†Ø§Ø±',0),(556950,15471,'fr','MTD',0),(556951,15471,'jp','MTD',0),(556952,15471,'pt','MTD',0),(556953,15471,'ru','MTD',0),(556954,15471,'es','MTD',0),(556955,15471,'de','MTD',0),(556956,15471,'en','MTD',0),(556957,15472,'is','',0),(556958,15472,'dr','Ù…Ù‚Ø¯Ø§Ø± MTD',0),(556959,15472,'pr','Ù…Ù‚Ø¯Ø§Ø± MTD',0),(556960,15472,'tr','MTD tutar',0),(556961,15472,'pl','MTD kwota',0),(556962,15472,'bg','MTD ÑÑƒÐ¼Ð°',0),(556963,15472,'ur','Ø§ØªÙ¹Ø¯ Ø±Ù‚Ù…',0),(556964,15472,'sr','ÐœÐ¢Ð” Ð¸Ð·Ð½Ð¾Ñ',0),(556965,15472,'vi','Sá»‘ tiá»n MTD',0),(556966,15472,'af','MTD bedrag',0),(556967,15472,'ro','MTD suma',0),(556968,15472,'et','MTD summa',0),(556969,15472,'si','MTD znesek',0),(556970,15472,'ba','Jumlah MTD',0),(556971,15472,'nl','MTD bedrag',0),(556972,15472,'fi','MTD mÃ¤Ã¤rÃ¤',0),(556973,15472,'no','MTD belÃ¸p',0),(556974,15472,'da','MTD belÃ¸b',0),(556975,15472,'ko','MTD ê¸ˆì•¡',0),(556976,15472,'he','MTD ×›×ž×•×ª',0),(556977,15472,'el','Î Î¿ÏƒÏŒ MTD',0),(556978,15472,'zh','MTD é‡‘é¢',0),(556979,15472,'sv','MTD belopp',0),(556980,15472,'it','QuantitÃ  MTD',0),(556981,15472,'tl','',0),(556982,15472,'th','à¸ˆà¸³à¸™à¸§à¸™ MTD',0),(556983,15472,'hi','à¤à¤®à¤Ÿà¥€à¤¡à¥€ à¤°à¤¾à¤¶à¤¿',0),(556984,15472,'ms','Amaun PCB',0),(556985,15472,'ar','Ù…Ø¨Ù„Øº Ù…Ù„ÙŠÙˆÙ† Ø¯ÙŠÙ†Ø§Ø±',0),(556986,15472,'fr','Montant MTD',0),(556987,15472,'jp','MTD é‡',0),(556988,15472,'pt','Quantidade MTD',0),(556989,15472,'ru','MTD ÑÑƒÐ¼Ð¼Ð°',0),(556990,15472,'es','Cantidad MTD',0),(556991,15472,'de','MTD-Betrag',0),(556992,15472,'en','MTD Amount',0),(556993,15473,'is','',0),(556994,15473,'dr','MTD Amt',0),(556995,15473,'pr','MTD Amt',0),(556996,15473,'tr','MTD Amt',0),(556997,15473,'pl','MTD Amt',0),(556998,15473,'bg','MTD Amt',0),(556999,15473,'ur','Ø§ØªÙ¹Ø¯ Ø§Ù…Ù¹',0),(557000,15473,'sr','ÐœÐ¢Ð” ÐÐ¼Ñ‚',0),(557001,15473,'vi','MTD Amt',0),(557002,15473,'af','MTD Amt',0),(557003,15473,'ro','MTD Amt',0),(557004,15473,'et','MTD Amt',0),(557005,15473,'si','MTD Amt',0),(557006,15473,'ba','MTD Amt',0),(557007,15473,'nl','MTD Amt',0),(557008,15473,'fi','MTD Amt',0),(557009,15473,'no','MTD Amt',0),(557010,15473,'da','MTD Amt',0),(557011,15473,'ko','MTD Amt',0),(557012,15473,'he','MTD Amt',0),(557013,15473,'el','MTD Amt',0),(557014,15473,'zh','MTD Amt',0),(557015,15473,'sv','MTD Amt',0),(557016,15473,'it','MTD Amt',0),(557017,15473,'tl','',0),(557018,15473,'th','à¸ˆà¸³à¸™à¸§à¸™ MTD',0),(557019,15473,'hi','à¤à¤®à¤Ÿà¥€à¤¡à¥€ Amt',0),(557020,15473,'ms','Amt PCB',0),(557021,15473,'ar','Ù…Ø¨Ù„Øº Ù…Ù„ÙŠÙˆÙ† Ø¯ÙŠÙ†Ø§Ø±',0),(557022,15473,'fr','Amt MTD',0),(557023,15473,'jp','MTD Amt',0),(557024,15473,'pt','MTD Amt',0),(557025,15473,'ru','MTD Amt',0),(557026,15473,'es','MTD Amt',0),(557027,15473,'de','MTD-Amt',0),(557028,15473,'en','MTD Amt',0),(557029,15474,'is','',0),(557030,15474,'dr','MTD Ø¨ÛŒØ´',0),(557031,15474,'pr','MTD Ø¨ÛŒØ´',0),(557032,15474,'tr','MTD aÅŸÄ±rÄ±',0),(557033,15474,'pl','MTD nadmiar',0),(557034,15474,'bg','MTD Ð¸Ð·Ð»Ð¸ÑˆÑŠÐº',0),(557035,15474,'ur','Ø§ØªÙ¹Ø¯ Ø°ÛŒØ§Ø¯ØªÛŒ',0),(557036,15474,'sr','ÐœÐ¢Ð” Ð²Ð¸ÑˆÐºÐ°',0),(557037,15474,'vi','MTD dÆ° thá»«a',0),(557038,15474,'af','MTD oortollige',0),(557039,15474,'ro','MTD exces',0),(557040,15474,'et','MTD Ã¼le',0),(557041,15474,'si','MTD preseÅ¾ek',0),(557042,15474,'ba','Kelebihan MTD',0),(557043,15474,'nl','MTD overmaat',0),(557044,15474,'fi','MTD liikaa',0),(557045,15474,'no','MTD overflÃ¸dig',0),(557046,15474,'da','MTD overskydende',0),(557047,15474,'ko','MTD ì´ˆê³¼',0),(557048,15474,'he','MTD ×¢×•×“×£',0),(557049,15474,'el','Î ÎµÏÎ¯ÏƒÏƒÎµÎ¹Î± MTD',0),(557050,15474,'zh','MTD è¿‡å‰©',0),(557051,15474,'sv','MTD Ã¶verskott',0),(557052,15474,'it','Eccesso MTD',0),(557053,15474,'tl','',0),(557054,15474,'th','à¹€à¸à¸´à¸™ MTD',0),(557055,15474,'hi','à¤à¤®à¤Ÿà¥€à¤¡à¥€ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤',0),(557056,15474,'ms','Lebihan PCB',0),(557057,15474,'ar','ÙØ§Ø¦Ø¶ Ù…Ù„ÙŠÙˆÙ† Ø¯ÙŠÙ†Ø§Ø±',0),(557058,15474,'fr','ExcÃ¨s MTD',0),(557059,15474,'jp','MTD éŽå‰°',0),(557060,15474,'pt','Excesso MTD',0),(557061,15474,'ru','Ð˜Ð·Ð±Ñ‹Ñ‚Ð¾Ðº MTD',0),(557062,15474,'es','Exceso MTD',0),(557063,15474,'de','MTD-Ãœberschuss',0),(557064,15474,'en','MTD Excess',0),(557065,15475,'is','',0),(557066,15475,'dr','MTD Ø³Ø§Ø¹Øª',0),(557067,15475,'pr','MTD Ø³Ø§Ø¹Øª',0),(557068,15475,'tr','MTD saat',0),(557069,15475,'pl','MTD godzin',0),(557070,15475,'bg','MTD Ñ‡Ð°ÑÐ°',0),(557071,15475,'ur','Ø§ØªÙ¹Ø¯ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª',0),(557072,15475,'sr','ÐœÐ¢Ð” ÑÐ°Ñ‚Ð¸',0),(557073,15475,'vi','MTD giá»',0),(557074,15475,'af','MTD ure',0),(557075,15475,'ro','MTD ore',0),(557076,15475,'et','MTD tundi',0),(557077,15475,'si','MTD ur',0),(557078,15475,'ba','MTD jam',0),(557079,15475,'nl','MTD uur',0),(557080,15475,'fi','MTD tuntia',0),(557081,15475,'no','MTD timer',0),(557082,15475,'da','MTD timer',0),(557083,15475,'ko','MTD ì‹œê°„',0),(557084,15475,'he','MTD ×©×¢×•×ª',0),(557085,15475,'el','MTD ÏŽÏÎµÏ‚',0),(557086,15475,'zh','MTD å°æ—¶',0),(557087,15475,'sv','MTD timmar',0),(557088,15475,'it','MTD ore',0),(557089,15475,'tl','',0),(557090,15475,'th','à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡ MTD',0),(557091,15475,'hi','à¤à¤®à¤Ÿà¥€à¤¡à¥€ à¤˜à¤‚à¤Ÿà¥‡',0),(557092,15475,'ms','Jam PCB',0),(557093,15475,'ar','Ø³Ø§Ø¹Ø§Øª Ù…Ù„ÙŠÙˆÙ† Ø¯ÙŠÙ†Ø§Ø±',0),(557094,15475,'fr','Heures MTD',0),(557095,15475,'jp','MTD æ™‚é–“',0),(557096,15475,'pt','MTD horas',0),(557097,15475,'ru','MTD Ñ‡Ð°ÑÐ¾Ð²',0),(557098,15475,'es','Horas MTD',0),(557099,15475,'de','MTD-Stunden',0),(557100,15475,'en','MTD Hours',0),(557101,15476,'is','',0),(557102,15476,'dr','MTD Ù…Ø§Ù„ÛŒØ§Øª',0),(557103,15476,'pr','MTD Ù…Ø§Ù„ÛŒØ§Øª',0),(557104,15476,'tr','Moda TasarÄ±mcÄ±larÄ± DerneÄŸi vergi',0),(557105,15476,'pl','MTD podatku',0),(557106,15476,'bg','MTD Ð´Ð°Ð½ÑŠÐº',0),(557107,15476,'ur','Ø§ØªÙ¹Ø¯ Ù¹ÛŒÚ©Ø³',0),(557108,15476,'sr','ÐœÐ¢Ð” Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(557109,15476,'vi','MTD thuáº¿',0),(557110,15476,'af','MTD belasting',0),(557111,15476,'ro','MTD fiscale',0),(557112,15476,'et','MTD maksu',0),(557113,15476,'si','MTD davka',0),(557114,15476,'ba','MTD pajak',0),(557115,15476,'nl','MTD belasting',0),(557116,15476,'fi','MTD vero',0),(557117,15476,'no','MTD skatt',0),(557118,15476,'da','MTD skat',0),(557119,15476,'ko','MTD ì„¸ê¸ˆ',0),(557120,15476,'he','MTD ×ž×¡',0),(557121,15476,'el','MTD Ï†ÏŒÏÎ¿Ï…',0),(557122,15476,'zh','MTD ç¨Ž',0),(557123,15476,'sv','MTD skatt',0),(557124,15476,'it','MTD fiscale',0),(557125,15476,'tl','',0),(557126,15476,'th','à¸ à¸²à¸©à¸µ MTD',0),(557127,15476,'hi','à¤à¤®à¤Ÿà¥€à¤¡à¥€ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(557128,15476,'ms','Cukai PCB',0),(557129,15476,'ar','Ø¶Ø±ÙŠØ¨Ø© Ù…Ù„ÙŠÙˆÙ† Ø¯ÙŠÙ†Ø§Ø±',0),(557130,15476,'fr','Taxe MTD',0),(557131,15476,'jp','MTD ç¨Ž',0),(557132,15476,'pt','Imposto MTD',0),(557133,15476,'ru','MTD Ð½Ð°Ð»Ð¾Ð³',0),(557134,15476,'es','MTD impuesto',0),(557135,15476,'de','MTD-Steuer',0),(557136,15476,'en','MTD Tax',0),(557137,15477,'is','',0),(557138,15477,'dr','MTD Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(557139,15477,'pr','MTD Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(557140,15477,'tr','MTD vergiye tabi',0),(557141,15477,'pl','MTD opodatkowaniu',0),(557142,15477,'bg','MTD Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾',0),(557143,15477,'ur','Ø§ØªÙ¹Ø¯ Ø¹Ø§Ø¦Ø¯',0),(557144,15477,'sr','ÐœÐ¢Ð” Ð¿Ð»Ð°Ð¶Ð°',0),(557145,15477,'vi','MTD Taxable',0),(557146,15477,'af','MTD belasbare',0),(557147,15477,'ro','MTD impozabile',0),(557148,15477,'et','MTD maksustatav',0),(557149,15477,'si','MTD davÄni',0),(557150,15477,'ba','MTD pajak',0),(557151,15477,'nl','MTD belastbare',0),(557152,15477,'fi','MTD verovelvollinen',0),(557153,15477,'no','MTD skattepliktig',0),(557154,15477,'da','MTD afgiftspligtige',0),(557155,15477,'ko','MTD ê³¼ì„¸',0),(557156,15477,'he','MTD ×—×™×™×‘ ×‘×ž×¡',0),(557157,15477,'el','MTD Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿',0),(557158,15477,'zh','MTD çº³ç¨Ž',0),(557159,15477,'sv','MTD beskattningsbara',0),(557160,15477,'it','Soggetti passivi MTD',0),(557161,15477,'tl','',0),(557162,15477,'th','à¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µ MTD',0),(557163,15477,'hi','à¤à¤®à¤Ÿà¥€à¤¡à¥€ à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯',0),(557164,15477,'ms','PCB dikenakan cukai',0),(557165,15477,'ar','Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ù…Ù„ÙŠÙˆÙ† Ø¯ÙŠÙ†Ø§Ø±',0),(557166,15477,'fr','MTD taxables',0),(557167,15477,'jp','MTD èª²ç¨Ž',0),(557168,15477,'pt','MTD tributÃ¡veis',0),(557169,15477,'ru','MTD Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ',0),(557170,15477,'es','Imponible MTD',0),(557171,15477,'de','MTD-Steuerpflichtige',0),(557172,15477,'en','MTD Taxable',0),(557173,15478,'is','',0),(557174,15478,'dr','MTD Ø¯Ø³ØªÙ…Ø²Ø¯',0),(557175,15478,'pr','MTD Ø¯Ø³ØªÙ…Ø²Ø¯',0),(557176,15478,'tr','Moda TasarÄ±mcÄ±larÄ± DerneÄŸi Ã¼cretleri',0),(557177,15478,'pl','MTD pÅ‚ace',0),(557178,15478,'bg','MTD Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(557179,15478,'ur','Ø§ØªÙ¹Ø¯ Ø§Ø¬Ø±Øª',0),(557180,15478,'sr','ÐœÐ¢Ð” Ð¿Ð»Ð°Ñ‚Ðµ',0),(557181,15478,'vi','MTD lÆ°Æ¡ng',0),(557182,15478,'af','MTD lone',0),(557183,15478,'ro','MTD salariile',0),(557184,15478,'et','MTD palk',0),(557185,15478,'si','MTD plaÄe',0),(557186,15478,'ba','Upah MTD',0),(557187,15478,'nl','MTD lonen',0),(557188,15478,'fi','MTD palkat',0),(557189,15478,'no','MTD lÃ¸nn',0),(557190,15478,'da','MTD lÃ¸n',0),(557191,15478,'ko','MTD ìž„ê¸ˆ',0),(557192,15478,'he','MTD ×©×›×¨',0),(557193,15478,'el','ÎœÎ¹ÏƒÎ¸Î¿Î¯ MTD',0),(557194,15478,'zh','MTD å·¥èµ„',0),(557195,15478,'sv','MTD lÃ¶ner',0),(557196,15478,'it','MTD salari',0),(557197,15478,'tl','',0),(557198,15478,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡ MTD',0),(557199,15478,'hi','à¤à¤®à¤Ÿà¥€à¤¡à¥€ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(557200,15478,'ms','Upah PCB',0),(557201,15478,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± Ù…Ù„ÙŠÙˆÙ† Ø¯ÙŠÙ†Ø§Ø±',0),(557202,15478,'fr','Salaires MTD',0),(557203,15478,'jp','MTD è³ƒé‡‘',0),(557204,15478,'pt','SalÃ¡rios MTD',0),(557205,15478,'ru','MTD Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(557206,15478,'es','Salarios MTD',0),(557207,15478,'de','MTD-LÃ¶hne',0),(557208,15478,'en','MTD Wages',0),(557209,15479,'is','',0),(557210,15479,'dr','ØªÙ†Ù‡Ø§ Ø´Ø§Ù…Ù„ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(557211,15479,'pr','ØªÙ†Ù‡Ø§ Ø´Ø§Ù…Ù„ Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(557212,15479,'tr','YalnÄ±zca Ã¼cretli dÃ¶nemleri dahil',0),(557213,15479,'pl','ZawieraÄ‡ tylko pÅ‚atne okresy',0),(557214,15479,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÑÐ°Ð¼Ð¾ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸',0),(557215,15479,'ur','ØµØ±Ù ØªÙ†Ø®ÙˆØ§Û Ø§Ø¯ÙˆØ§Ø± Ù…ÛŒÚº Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(557216,15479,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð¿Ð»Ð°Ñ›ÐµÐ½Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ðµ',0),(557217,15479,'vi','Chá»‰ bao gá»“m thá»i gian thanh toÃ¡n',0),(557218,15479,'af','Sluit slegs betaal periodes',0),(557219,15479,'ro','Doar includ perioadele de plÄƒtit',0),(557220,15479,'et','Kaasa ainult tasustatud',0),(557221,15479,'si','VkljuÄi plaÄanega obdobja',0),(557222,15479,'ba','Hanya mencakup periode dibayar',0),(557223,15479,'nl','Alleen zijn betaalde periodes',0),(557224,15479,'fi','SisÃ¤ltÃ¤Ã¤ vain palkallisten',0),(557225,15479,'no','Inkluder bare betalt perioder',0),(557226,15479,'da','Kun omfatte betalte perioder',0),(557227,15479,'ko','ìœ ë£Œ ê¸°ê°„ í¬í•¨',0),(557228,15479,'he','×œ×›×œ×•×œ ×¨×§ ×ª×§×•×¤×•×ª ×‘×ª×©×œ×•×',0),(557229,15479,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Î¼ÏŒÎ½Î¿ Ï€Î»Î·ÏÏ‰Î¼Î­Î½Î¿Ï‚ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…Ï‚',0),(557230,15479,'zh','åªåŒ…æ‹¬å¸¦è–ªçš„æ—¶é—´',0),(557231,15479,'sv','Endast omfatta betald',0),(557232,15479,'it','Includere solo periodi di pagamento',0),(557233,15479,'tl','',0),(557234,15479,'th','à¸£à¸§à¸¡à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(557235,15479,'hi','à¤•à¥‡à¤µà¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(557236,15479,'ms','Hanya mempunyai tempoh berbayar',0),(557237,15479,'ar','ÙÙ‚Ø· ØªØ´Ù…Ù„ ÙØªØ±Ø§Øª Ù…Ø¯ÙÙˆØ¹Ø© Ø§Ù„Ø£Ø¬Ø±',0),(557238,15479,'fr','Inclure seulement les pÃ©riodes payÃ©es',0),(557239,15479,'jp','ã®ã¿æœ‰æ–™æœŸé–“ã‚’å«ã‚ã‚‹',0),(557240,15479,'pt','Apenas incluir perÃ­odos pagos',0),(557241,15479,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ð»Ð°Ñ‚Ð½Ñ‹Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¾Ð²',0),(557242,15479,'es','SÃ³lo incluir perÃ­odos de pagadas',0),(557243,15479,'de','Nur bezahlte ZeitrÃ¤ume enthalten',0),(557244,15479,'en','Only Include Paid Periods',0),(557245,15480,'is','',0),(557246,15480,'dr','GL Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(557247,15480,'pr','GL Ù‚Ø§Ø¨Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(557248,15480,'tr','Ã–denecek GL',0),(557249,15480,'pl','PÅ‚atne GL',0),(557250,15480,'bg','ÐŸÐ»Ð°Ñ‚Ð¸Ð¼Ð¸ GL',0),(557251,15480,'ur','Ù‚Ø§Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¬ÛŒØ¬Û’',0),(557252,15480,'sr','Ð”ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð“Ð›',0),(557253,15480,'vi','Pháº£i ná»™p GL',0),(557254,15480,'af','Betaalbaar GL',0),(557255,15480,'ro','PlÄƒtit GL',0),(557256,15480,'et','Makstavate GL',0),(557257,15480,'si','PlaÄa GL',0),(557258,15480,'ba','Dibayarkan GL',0),(557259,15480,'nl','Betaalbaar GL',0),(557260,15480,'fi','Maksettava GL',0),(557261,15480,'no','Betales GL',0),(557262,15480,'da','Betales GL',0),(557263,15480,'ko','ì§€ê¸‰ GL',0),(557264,15480,'he','GL ×–×›××™×',0),(557265,15480,'el','Î Î»Î·ÏÏ‰Ï„Î­Î± GL',0),(557266,15480,'zh','åº”ä»˜å¸æ¬¾ GL',0),(557267,15480,'sv','Betalas GL',0),(557268,15480,'it','Da pagare GL',0),(557269,15480,'tl','',0),(557270,15480,'th','GL à¹€à¸ˆà¹‰à¸²à¸«à¸™à¸µà¹‰',0),(557271,15480,'hi','à¤¦à¥‡à¤¯ GL',0),(557272,15480,'ms','GL dibayar',0),(557273,15480,'ar','GL Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹',0),(557274,15480,'fr','Payable GL',0),(557275,15480,'jp','è²·æŽ›é‡‘ GL',0),(557276,15480,'pt','PagÃ¡vel GL',0),(557277,15480,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‡Ð¸Ð²Ð°ÐµÐ¼Ñ‹Ñ… GL',0),(557278,15480,'es','GL por pagar',0),(557279,15480,'de','Zahlbar GL',0),(557280,15480,'en','Payable GL',0),(557281,15481,'is','',0),(557282,15481,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(557283,15481,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(557284,15481,'tr','Bordro bilgi',0),(557285,15481,'pl','Payroll Info',0),(557286,15481,'bg','Ð¢Ð Ð— Ð¸Ð½Ñ„Ð¾',0),(557287,15481,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(557288,15481,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð˜Ð½Ñ„Ð¾',0),(557289,15481,'vi','Xem thÃ´ng tin biÃªn cháº¿',0),(557290,15481,'af','Salarisstelsel Info',0),(557291,15481,'ro','InformaÅ£ii de salarizare',0),(557292,15481,'et','Palgaarvestuse Info',0),(557293,15481,'si','Info na izplaÄane plaÄe',0),(557294,15481,'ba','Penggajian Info',0),(557295,15481,'nl','Payroll Info',0),(557296,15481,'fi','Palkanlaskennan Info',0),(557297,15481,'no','LÃ¸nn informasjon',0),(557298,15481,'da','LÃ¸nningslisten Info',0),(557299,15481,'ko','ê¸‰ì—¬ ì •ë³´',0),(557300,15481,'he','×©×›×¨ ×¤×¨×˜×™',0),(557301,15481,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(557302,15481,'zh','å·¥èµ„ä¿¡æ¯',0),(557303,15481,'sv','LÃ¶nelistan information',0),(557304,15481,'it','Info libro paga',0),(557305,15481,'tl','',0),(557306,15481,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(557307,15481,'hi','à¤ªà¥‡à¤°à¥‹à¤² à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(557308,15481,'ms','Maklumat gaji',0),(557309,15481,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(557310,15481,'fr','Info sur la paie',0),(557311,15481,'jp','çµ¦ä¸Žæƒ…å ±',0),(557312,15481,'pt','InformaÃ§Ã£o da folha de pagamento',0),(557313,15481,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ðµ',0),(557314,15481,'es','InformaciÃ³n de nÃ³mina',0),(557315,15481,'de','Lohn-Info',0),(557316,15481,'en','Payroll Info',0),(557317,15482,'is','',0),(557318,15482,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(557319,15482,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(557320,15482,'tr','AracÄ±lÄ±ÄŸÄ±yla Ã¶deme',0),(557321,15482,'pl','ZapÅ‚aciÄ‡ za poÅ›rednictwem',0),(557322,15482,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ñ‡Ñ€ÐµÐ·',0),(557323,15482,'ur','Ú©Û’ Ø°Ø±ÛŒØ¹Û’ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(557324,15482,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ ÐºÑ€Ð¾Ð·',0),(557325,15482,'vi','Tráº£ tiá»n thÃ´ng qua',0),(557326,15482,'af','Betaal deur',0),(557327,15482,'ro','PlÄƒtiÅ£i prin',0),(557328,15482,'et','Maksma kaudu',0),(557329,15482,'si','PlaÄati preko',0),(557330,15482,'ba','Membayar melalui',0),(557331,15482,'nl','Betalen via',0),(557332,15482,'fi','Maksaa kautta',0),(557333,15482,'no','Betal gjennom',0),(557334,15482,'da','Betale via',0),(557335,15482,'ko','í†µí•´ ì§€ë¶ˆ',0),(557336,15482,'he','×•×”×ª×©×œ×•×',0),(557337,15482,'el','Î Î»Î·ÏÏŽÏƒÎµÏ„Îµ:',0),(557338,15482,'zh','é€šè¿‡æ”¯ä»˜',0),(557339,15482,'sv','Betala via',0),(557340,15482,'it','Pagare tramite',0),(557341,15482,'tl','',0),(557342,15482,'th','à¸Šà¸³à¸£à¸°à¸œà¹ˆà¸²à¸™à¸—à¸²à¸‡',0),(557343,15482,'hi','à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(557344,15482,'ms','Membayar melalui',0),(557345,15482,'ar','Ø§Ù„Ø¯ÙØ¹ Ù…Ù† Ø®Ù„Ø§Ù„',0),(557346,15482,'fr','Payer par',0),(557347,15482,'jp','å£åº§æŒ¯è¾¼ã—ã¾ã™ã€‚',0),(557348,15482,'pt','Pagar atravÃ©s de',0),(557349,15482,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ñ‡ÐµÑ€ÐµÐ·',0),(557350,15482,'es','Pagar a travÃ©s de',0),(557351,15482,'de','Durch Zahlen',0),(557352,15482,'en','Pay Through',0),(557353,15483,'is','',0),(557354,15483,'dr','Ø¯ÙˆØ±Ù‡ Ø´Ø§Ù…Ù„',0),(557355,15483,'pr','Ø¯ÙˆØ±Ù‡ Ø´Ø§Ù…Ù„',0),(557356,15483,'tr','DÃ¶nemleri dahil',0),(557357,15483,'pl','OkresÃ³w',0),(557358,15483,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸, Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸',0),(557359,15483,'ur','Ø§Ø¯ÙˆØ§Ø± Ø´Ø§Ù…Ù„ ØªÚ¾Û’',0),(557360,15483,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸ ÑƒÐºÑ™ÑƒÑ‡ÐµÐ½Ðµ',0),(557361,15483,'vi','Giai Ä‘oáº¡n bao gá»“m',0),(557362,15483,'af','Periodes ingesluit',0),(557363,15483,'ro','Perioadele incluse',0),(557364,15483,'et','Kaasatud perioodide',0),(557365,15483,'si','Obdobja, ki so vkljuÄeni',0),(557366,15483,'ba','Periode termasuk',0),(557367,15483,'nl','Perioden inbegrepen',0),(557368,15483,'fi','Aikoina mukana',0),(557369,15483,'no','Perioder med',0),(557370,15483,'da','Perioder inkluderet',0),(557371,15483,'ko','í¬í•¨ í•˜ëŠ” ê¸°ê°„',0),(557372,15483,'he','×ª×§×•×¤×•×ª ×›×œ×•×œ',0),(557373,15483,'el','Î ÎµÏÎ¹ÏŒÎ´Î¿Ï…Ï‚ Ï€Î¿Ï… Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹',0),(557374,15483,'zh','æœŸé—´åŒ…æ‹¬',0),(557375,15483,'sv','Perioder som ingÃ¥r',0),(557376,15483,'it','Periodi inclusi',0),(557377,15483,'tl','',0),(557378,15483,'th','à¸£à¸§à¸¡à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²',0),(557379,15483,'hi','à¤…à¤µà¤§à¤¿à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤²',0),(557380,15483,'ms','Tempoh dimasukkan ke',0),(557381,15483,'ar','Ø§Ù„ÙØªØ±Ø§Øª Ø§Ù„ØªÙŠ Ø´Ù…Ù„Øª',0),(557382,15483,'fr','PÃ©riodes inclus',0),(557383,15483,'jp','å«ã¾ã‚Œã¦ã„ã‚‹æœŸé–“',0),(557384,15483,'pt','PerÃ­odos incluÃ­dos',0),(557385,15483,'ru','ÐŸÐµÑ€Ð¸Ð¾Ð´Ñ‹ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹',0),(557386,15483,'es','PerÃ­odos incluidos',0),(557387,15483,'de','ZeitrÃ¤ume enthalten',0),(557388,15483,'en','Periods Included',0),(557389,15484,'is','',0),(557390,15484,'dr','QTD',0),(557391,15484,'pr','QTD',0),(557392,15484,'tr','QTD',0),(557393,15484,'pl','OD POCZÄ„TKU KWARTAÅU',0),(557394,15484,'bg','QTD',0),(557395,15484,'ur','Ù‚Ù¹Ø¯',0),(557396,15484,'sr','QÐ¢Ð”',0),(557397,15484,'vi','QTD',0),(557398,15484,'af','QTD',0),(557399,15484,'ro','QTD',0),(557400,15484,'et','QTD',0),(557401,15484,'si','QTD',0),(557402,15484,'ba','QTD',0),(557403,15484,'nl','QTD',0),(557404,15484,'fi','VUOSINELJÃ„NNEKSEN ALUSTA',0),(557405,15484,'no','VELGE QTD',0),(557406,15484,'da','CITERET',0),(557407,15484,'ko','QTD',0),(557408,15484,'he','QTD',0),(557409,15484,'el','QTD',0),(557410,15484,'zh','QT ç¦»æ•£åº¦å˜åŒ–',0),(557411,15484,'sv','QTD',0),(557412,15484,'it','QTD',0),(557413,15484,'tl','',0),(557414,15484,'th','QTD',0),(557415,15484,'hi','QTD',0),(557416,15484,'ms','QTD',0),(557417,15484,'ar','Ù‚ØªØ¯',0),(557418,15484,'fr','QTD',0),(557419,15484,'jp','QTD',0),(557420,15484,'pt','QTD',0),(557421,15484,'ru','Ð¡ ÐÐÐ§ÐÐ›Ð ÐšÐ’ÐÐ Ð¢ÐÐ›Ð',0),(557422,15484,'es','QTD',0),(557423,15484,'de','QTD',0),(557424,15484,'en','QTD',0),(557425,15485,'is','',0),(557426,15485,'dr','Ù…Ù‚Ø¯Ø§Ø± QTD',0),(557427,15485,'pr','Ù…Ù‚Ø¯Ø§Ø± QTD',0),(557428,15485,'tr','QTD tutar',0),(557429,15485,'pl','Kwota od poczÄ…tku KwartaÅ‚u',0),(557430,15485,'bg','QTD ÑÑƒÐ¼Ð°',0),(557431,15485,'ur','Ù‚Ù¹Ø¯ Ø±Ù‚Ù…',0),(557432,15485,'sr','QÐ¢Ð” Ð¸Ð·Ð½Ð¾Ñ',0),(557433,15485,'vi','Sá»‘ tiá»n QTD',0),(557434,15485,'af','QTD bedrag',0),(557435,15485,'ro','Suma QTD',0),(557436,15485,'et','QTD summa',0),(557437,15485,'si','QTD znesek',0),(557438,15485,'ba','Jumlah QTD',0),(557439,15485,'nl','QTD bedrag',0),(557440,15485,'fi','VuosineljÃ¤nneksen alusta mÃ¤Ã¤rÃ¤',0),(557441,15485,'no','Velge QTD belÃ¸p',0),(557442,15485,'da','Citeret belÃ¸b',0),(557443,15485,'ko','QTD ê¸ˆì•¡',0),(557444,15485,'he','×›×ž×•×ª QTD',0),(557445,15485,'el','QTD Ï€Î¿ÏƒÏŒ',0),(557446,15485,'zh','Qt ç¦»æ•£åº¦å˜åŒ–é‡',0),(557447,15485,'sv','QTD belopp',0),(557448,15485,'it','QTD quantitÃ ',0),(557449,15485,'tl','',0),(557450,15485,'th','à¸ˆà¸³à¸™à¸§à¸™ QTD',0),(557451,15485,'hi','QTD à¤°à¤¾à¤¶à¤¿',0),(557452,15485,'ms','Jumlah QTD',0),(557453,15485,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù‚ØªØ¯',0),(557454,15485,'fr','Montant QTD',0),(557455,15485,'jp','QTD é‡',0),(557456,15485,'pt','QTD quantidade',0),(557457,15485,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð° ÑÑƒÐ¼Ð¼Ð°',0),(557458,15485,'es','Cantidad QTD',0),(557459,15485,'de','QTD Betrag',0),(557460,15485,'en','QTD Amount',0),(557461,15486,'is','',0),(557462,15486,'dr','QTD Amt',0),(557463,15486,'pr','QTD Amt',0),(557464,15486,'tr','QTD Amt',0),(557465,15486,'pl','Amt od poczÄ…tku KwartaÅ‚u',0),(557466,15486,'bg','QTD Amt',0),(557467,15486,'ur','Ù‚Ù¹Ø¯ Ø§Ù…Ù¹',0),(557468,15486,'sr','QÐ¢Ð” ÐÐ¼Ñ‚',0),(557469,15486,'vi','QTD Amt',0),(557470,15486,'af','Amt-QTD',0),(557471,15486,'ro','QTD Amt',0),(557472,15486,'et','QTD Amt',0),(557473,15486,'si','QTD Amt',0),(557474,15486,'ba','QTD Amt',0),(557475,15486,'nl','QTD Amt',0),(557476,15486,'fi','VuosineljÃ¤nneksen alusta Amt',0),(557477,15486,'no','Velge QTD Amt',0),(557478,15486,'da','Citeret Amt',0),(557479,15486,'ko','QTD Amt',0),(557480,15486,'he','QTD Amt',0),(557481,15486,'el','QTD Amt',0),(557482,15486,'zh','Qt ç¦»æ•£åº¦ Amt',0),(557483,15486,'sv','QTD Amt',0),(557484,15486,'it','QTD Amt',0),(557485,15486,'tl','',0),(557486,15486,'th','à¸ˆà¸³à¸™à¸§à¸™ QTD',0),(557487,15486,'hi','QTD Amt',0),(557488,15486,'ms','QTD Amt',0),(557489,15486,'ar','Amt Ù‚ØªØ¯',0),(557490,15486,'fr','Amt QTD',0),(557491,15486,'jp','QTD Amt',0),(557492,15486,'pt','QTD Amt',0),(557493,15486,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð° Amt',0),(557494,15486,'es','QTD Amt',0),(557495,15486,'de','QTD Amt',0),(557496,15486,'en','QTD Amt',0),(557497,15487,'is','',0),(557498,15487,'dr','Ø¨ÛŒØ´ QTD',0),(557499,15487,'pr','Ø¨ÛŒØ´ QTD',0),(557500,15487,'tr','QTD aÅŸÄ±rÄ±',0),(557501,15487,'pl','Nadmiar od poczÄ…tku KwartaÅ‚u',0),(557502,15487,'bg','QTD Ð¸Ð·Ð»Ð¸ÑˆÑŠÐº',0),(557503,15487,'ur','Ù‚Ù¹Ø¯ Ø°ÛŒØ§Ø¯ØªÛŒ',0),(557504,15487,'sr','QÐ¢Ð” Ð²Ð¸ÑˆÐºÐ°',0),(557505,15487,'vi','QTD dÆ° thá»«a',0),(557506,15487,'af','QTD oortollige',0),(557507,15487,'ro','Excesul de QTD',0),(557508,15487,'et','QTD Ã¼letamine',0),(557509,15487,'si','QTD preseÅ¾ek',0),(557510,15487,'ba','Kelebihan QTD',0),(557511,15487,'nl','QTD overmaat',0),(557512,15487,'fi','VuosineljÃ¤nneksen ylimÃ¤Ã¤rÃ¤inen',0),(557513,15487,'no','Velge QTD overflÃ¸dig',0),(557514,15487,'da','Citeret overskydende',0),(557515,15487,'ko','QTD ì´ˆê³¼',0),(557516,15487,'he','×¢×•×“×£ QTD',0),(557517,15487,'el','QTD Ï…Ï€Î­ÏÎ²Î±ÏƒÎ·',0),(557518,15487,'zh','Qt ç¦»æ•£åº¦è¿‡å‰©',0),(557519,15487,'sv','QTD Ã¶verskott',0),(557520,15487,'it','QTD eccesso',0),(557521,15487,'tl','',0),(557522,15487,'th','à¹€à¸à¸´à¸™ QTD',0),(557523,15487,'hi','QTD à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤',0),(557524,15487,'ms','Lebihan QTD',0),(557525,15487,'ar','Ù‚ØªØ¯ Ø§Ù„Ø²Ø§Ø¦Ø¯Ø©',0),(557526,15487,'fr','ExcÃ¨s QTD',0),(557527,15487,'jp','QTD éŽå‰°',0),(557528,15487,'pt','Excesso QTD',0),(557529,15487,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð° Ð¸Ð·Ð±Ñ‹Ñ‚Ð¾Ðº',0),(557530,15487,'es','Exceso QTD',0),(557531,15487,'de','QTD Selbstbeteiligung',0),(557532,15487,'en','QTD Excess',0),(557533,15488,'is','',0),(557534,15488,'dr','Ø³Ø§Ø¹Øª QTD',0),(557535,15488,'pr','Ø³Ø§Ø¹Øª QTD',0),(557536,15488,'tr','QTD saat',0),(557537,15488,'pl','Godzin od poczÄ…tku KwartaÅ‚u',0),(557538,15488,'bg','QTD Ñ‡Ð°ÑÐ°',0),(557539,15488,'ur','Ù‚Ù¹Ø¯ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª',0),(557540,15488,'sr','QÐ¢Ð” ÑÐ°Ñ‚Ð¸',0),(557541,15488,'vi','QTD giá»',0),(557542,15488,'af','QTD ure',0),(557543,15488,'ro','QTD ore',0),(557544,15488,'et','QTD tundi',0),(557545,15488,'si','QTD ur',0),(557546,15488,'ba','QTD jam',0),(557547,15488,'nl','QTD uur',0),(557548,15488,'fi','VuosineljÃ¤nneksen alusta tuntia',0),(557549,15488,'no','Velge QTD timer',0),(557550,15488,'da','Citeret timer',0),(557551,15488,'ko','QTD ì‹œê°„',0),(557552,15488,'he','QTD ×©×¢×•×ª',0),(557553,15488,'el','QTD ÏŽÏÎµÏ‚',0),(557554,15488,'zh','Qt ç¦»æ•£åº¦å°æ—¶',0),(557555,15488,'sv','QTD timmar',0),(557556,15488,'it','QTD ore',0),(557557,15488,'tl','',0),(557558,15488,'th','à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡ QTD',0),(557559,15488,'hi','QTD à¤˜à¤‚à¤Ÿà¥‡',0),(557560,15488,'ms','Jam QTD',0),(557561,15488,'ar','Ø³Ø§Ø¹Ø§Øª Ù‚ØªØ¯',0),(557562,15488,'fr','QTD heures',0),(557563,15488,'jp','QTD æ™‚é–“',0),(557564,15488,'pt','QTD horas',0),(557565,15488,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð° Ñ‡Ð°ÑÐ¾Ð²',0),(557566,15488,'es','QTD horas',0),(557567,15488,'de','QTD Stunden',0),(557568,15488,'en','QTD Hours',0),(557569,15489,'is','',0),(557570,15489,'dr','Ù…Ø§Ù„ÛŒØ§Øª QTD',0),(557571,15489,'pr','Ù…Ø§Ù„ÛŒØ§Øª QTD',0),(557572,15489,'tr','QTD vergi',0),(557573,15489,'pl','Podatek od poczÄ…tku KwartaÅ‚u',0),(557574,15489,'bg','QTD Ð´Ð°Ð½ÑŠÐº',0),(557575,15489,'ur','Ù‚Ù¹Ø¯ Ù¹ÛŒÚ©Ø³',0),(557576,15489,'sr','QÐ¢Ð” Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(557577,15489,'vi','QTD thuáº¿',0),(557578,15489,'af','QTD belasting',0),(557579,15489,'ro','QTD fiscale',0),(557580,15489,'et','QTD maksu',0),(557581,15489,'si','QTD davka',0),(557582,15489,'ba','QTD pajak',0),(557583,15489,'nl','QTD belasting',0),(557584,15489,'fi','VuosineljÃ¤nneksen alusta veron',0),(557585,15489,'no','Velge QTD skatt',0),(557586,15489,'da','Citeret skat',0),(557587,15489,'ko','QTD ì„¸ê¸ˆ',0),(557588,15489,'he','QTD ×ž×¡',0),(557589,15489,'el','Î¦ÏŒÏÎ¿Ï… QTD',0),(557590,15489,'zh','Qt ç¦»æ•£åº¦å˜åŒ–ç¨Ž',0),(557591,15489,'sv','QTD skatt',0),(557592,15489,'it','QTD fiscale',0),(557593,15489,'tl','',0),(557594,15489,'th','à¸ à¸²à¸©à¸µ QTD',0),(557595,15489,'hi','QTD à¤•à¤°',0),(557596,15489,'ms','Cukai QTD',0),(557597,15489,'ar','Ø¶Ø±ÙŠØ¨Ø© Ù‚ØªØ¯',0),(557598,15489,'fr','Taxe QTD',0),(557599,15489,'jp','QTD ç¨Ž',0),(557600,15489,'pt','QTD imposto',0),(557601,15489,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð° Ð½Ð°Ð»Ð¾Ð³',0),(557602,15489,'es','QTD impuesto',0),(557603,15489,'de','QTD Steuer',0),(557604,15489,'en','QTD Tax',0),(557605,15490,'is','',0),(557606,15490,'dr','QTD Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(557607,15490,'pr','QTD Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(557608,15490,'tr','QTD vergiye tabi',0),(557609,15490,'pl','Opodatkowaniu od poczÄ…tku KwartaÅ‚u',0),(557610,15490,'bg','QTD Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾',0),(557611,15490,'ur','Ù‚Ù¹Ø¯ Ø¹Ø§Ø¦Ø¯',0),(557612,15490,'sr','QÐ¢Ð” Ð¿Ð»Ð°Ð¶Ð°',0),(557613,15490,'vi','QTD Taxable',0),(557614,15490,'af','QTD belasbare',0),(557615,15490,'ro','QTD impozabila',0),(557616,15490,'et','QTD maksustatav',0),(557617,15490,'si','QTD davÄni',0),(557618,15490,'ba','QTD pajak',0),(557619,15490,'nl','QTD belastbare',0),(557620,15490,'fi','VuosineljÃ¤nneksen alusta veron',0),(557621,15490,'no','Velge QTD skattepliktig',0),(557622,15490,'da','Citeret afgiftspligtige',0),(557623,15490,'ko','QTD ê³¼ì„¸',0),(557624,15490,'he','QTD ×—×™×™×‘ ×‘×ž×¡',0),(557625,15490,'el','Î¥Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿ QTD',0),(557626,15490,'zh','Qt ç¦»æ•£åº¦åº”çº³ç¨Ž',0),(557627,15490,'sv','QTD beskattningsbara',0),(557628,15490,'it','Soggetti passivi QTD',0),(557629,15490,'tl','',0),(557630,15490,'th','à¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µ QTD',0),(557631,15490,'hi','QTD à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯',0),(557632,15490,'ms','Dikenakan cukai QTD',0),(557633,15490,'ar','Ù‚ØªØ¯ Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(557634,15490,'fr','QTD taxables',0),(557635,15490,'jp','QTD èª²ç¨Ž',0),(557636,15490,'pt','QTD tributÃ¡veis',0),(557637,15490,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð° Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ',0),(557638,15490,'es','QTD imponible',0),(557639,15490,'de','QTD Steuerpflichtige',0),(557640,15490,'en','QTD Taxable',0),(557641,15491,'is','',0),(557642,15491,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ QTD',0),(557643,15491,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ QTD',0),(557644,15491,'tr','QTD Ã¼cret',0),(557645,15491,'pl','Zarobki od poczÄ…tku KwartaÅ‚u',0),(557646,15491,'bg','QTD Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(557647,15491,'ur','Ù‚Ù¹Ø¯ Ø§Ø¬Ø±Øª',0),(557648,15491,'sr','QÐ¢Ð” Ð¿Ð»Ð°Ñ‚Ðµ',0),(557649,15491,'vi','Tiá»n lÆ°Æ¡ng QTD',0),(557650,15491,'af','QTD lone',0),(557651,15491,'ro','QTD salarii',0),(557652,15491,'et','QTD palk',0),(557653,15491,'si','QTD plaÄe',0),(557654,15491,'ba','Upah QTD',0),(557655,15491,'nl','QTD lonen',0),(557656,15491,'fi','VuosineljÃ¤nneksen palkat',0),(557657,15491,'no','Velge QTD lÃ¸nn',0),(557658,15491,'da','Citeret lÃ¸n',0),(557659,15491,'ko','QTD ìž„ê¸ˆ',0),(557660,15491,'he','×©×›×¨ QTD',0),(557661,15491,'el','QTD Î¼Î¹ÏƒÎ¸Î¿Î¯',0),(557662,15491,'zh','Qt ç¦»æ•£åº¦çš„å·¥èµ„',0),(557663,15491,'sv','QTD lÃ¶ner',0),(557664,15491,'it','QTD Salario',0),(557665,15491,'tl','',0),(557666,15491,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡ QTD',0),(557667,15491,'hi','QTD à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(557668,15491,'ms','Upah QTD',0),(557669,15491,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± Ù‚ØªØ¯',0),(557670,15491,'fr','QTD salaires',0),(557671,15491,'jp','QTD è³ƒé‡‘',0),(557672,15491,'pt','QTD salÃ¡rios',0),(557673,15491,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° ÐºÐ²Ð°Ñ€Ñ‚Ð°Ð»Ð° Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(557674,15491,'es','QTD salarios',0),(557675,15491,'de','QTD LÃ¶hne',0),(557676,15491,'en','QTD Wages',0),(557677,15492,'is','',0),(557678,15492,'dr','Ø­Ø¯ÙˆØ¯ Ø³Ø§Ø¹Øª',0),(557679,15492,'pr','Ø­Ø¯ÙˆØ¯ Ø³Ø§Ø¹Øª',0),(557680,15492,'tr','AralÄ±ÄŸÄ± saat',0),(557681,15492,'pl','Zakres godzin',0),(557682,15492,'bg','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ñ‡Ð°ÑÐ°',0),(557683,15492,'ur','Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª',0),(557684,15492,'sr','ÐžÐ¿ÑÐµÐ³ ÑÐ°Ñ‚Ð¸',0),(557685,15492,'vi','Táº§m hoáº¡t Ä‘á»™ng giá»',0),(557686,15492,'af','Reeks ure',0),(557687,15492,'ro','Gama de ore',0),(557688,15492,'et','Vahemikus tundi',0),(557689,15492,'si','Obseg ur',0),(557690,15492,'ba','Berbagai jam',0),(557691,15492,'nl','Bereik uren',0),(557692,15492,'fi','Alueen tuntia',0),(557693,15492,'no','OmrÃ¥det timer',0),(557694,15492,'da','Interval timer',0),(557695,15492,'ko','ì‹œê°„ ë²”ìœ„',0),(557696,15492,'he','×˜×•×•×— ×©×¢×•×ª',0),(557697,15492,'el','Î¦Î¬ÏƒÎ¼Î± ÏŽÏÎµÏ‚',0),(557698,15492,'zh','æ—¶é—´èŒƒå›´',0),(557699,15492,'sv','Rad timmar',0),(557700,15492,'it','Ore di intervallo',0),(557701,15492,'tl','',0),(557702,15492,'th','à¸Šà¹ˆà¸§à¸‡à¹€à¸§à¸¥à¸²',0),(557703,15492,'hi','à¤°à¥‡à¤‚à¤œ à¤˜à¤‚à¤Ÿà¥‡',0),(557704,15492,'ms','Pelbagai jam',0),(557705,15492,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø³Ø§Ø¹Ø§Øª',0),(557706,15492,'fr','Gamme heures',0),(557707,15492,'jp','æ™‚é–“ã®ç¯„å›²ã—ã¾ã™ã€‚',0),(557708,15492,'pt','Horas de intervalo',0),(557709,15492,'ru','ÐÑÑÐ¾Ñ€Ñ‚Ð¸Ð¼ÐµÐ½Ñ‚ Ñ‡Ð°ÑÐ¾Ð²',0),(557710,15492,'es','Rango de horas',0),(557711,15492,'de','Bereich-Stunden',0),(557712,15492,'en','Range Hours',0),(557713,15493,'is','',0),(557714,15493,'dr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ù…Ø§Ù„ÛŒØ§ØªÛŒ',0),(557715,15493,'pr','Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ù…Ø§Ù„ÛŒØ§ØªÛŒ',0),(557716,15493,'tr','AralÄ±ÄŸÄ± vergi',0),(557717,15493,'pl','Zakres podatku',0),(557718,15493,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð°Ñ‚Ð° Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½',0),(557719,15493,'ur','Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù¹ÛŒÚ©Ø³',0),(557720,15493,'sr','ÐžÐ¿ÑÐµÐ³ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(557721,15493,'vi','Pháº¡m vi thuáº¿',0),(557722,15493,'af','Reeks belasting',0),(557723,15493,'ro','Gama fiscale',0),(557724,15493,'et','Range maksu',0),(557725,15493,'si','Obseg davÄne',0),(557726,15493,'ba','Berbagai pajak',0),(557727,15493,'nl','Bereik belasting',0),(557728,15493,'fi','Eri vero',0),(557729,15493,'no','OmrÃ¥det skatt',0),(557730,15493,'da','RÃ¦kke skat',0),(557731,15493,'ko','ë²”ìœ„ ì„¸ê¸ˆ',0),(557732,15493,'he','×˜×•×•×— ×ž×¡',0),(557733,15493,'el','Î£ÎµÎ¹ÏÎ¬ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½',0),(557734,15493,'zh','èŒƒå›´ç¨Ž',0),(557735,15493,'sv','SpÃ¤nna skatt',0),(557736,15493,'it','Fascia fiscale',0),(557737,15493,'tl','',0),(557738,15493,'th','à¸Šà¹ˆà¸§à¸‡à¸ à¸²à¸©à¸µ',0),(557739,15493,'hi','à¤°à¥‡à¤‚à¤œ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(557740,15493,'ms','Pelbagai cukai',0),(557741,15493,'ar','Ù†Ø·Ø§Ù‚ Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(557742,15493,'fr','Taxe de la gamme',0),(557743,15493,'jp','ç¨Žã®ç¯„å›²',0),(557744,15493,'pt','Imposto de gama',0),(557745,15493,'ru','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð½Ð°Ð»Ð¾Ð³',0),(557746,15493,'es','Rango impuesto',0),(557747,15493,'de','Bereich Steuer',0),(557748,15493,'en','Range Tax',0),(557749,15494,'is','',0),(557750,15494,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù…Ø­Ø¯ÙˆØ¯Ù‡',0),(557751,15494,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù…Ø­Ø¯ÙˆØ¯Ù‡',0),(557752,15494,'tr','AralÄ±ÄŸÄ± Ã¼cret',0),(557753,15494,'pl','Zakres wynagrodzenia',0),(557754,15494,'bg','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð½Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ',0),(557755,15494,'ur','Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ú©ÛŒ Ø§Ø¬Ø±Øª',0),(557756,15494,'sr','ÐžÐ¿ÑÐµÐ³ Ð¿Ð»Ð°Ñ‚Ðµ',0),(557757,15494,'vi','Pháº¡m vi lÆ°Æ¡ng',0),(557758,15494,'af','Reeks lone',0),(557759,15494,'ro','Gama salariu',0),(557760,15494,'et','Vahemikku palk',0),(557761,15494,'si','Razpon plaÄe',0),(557762,15494,'ba','Kisaran gaji',0),(557763,15494,'nl','Bereik lonen',0),(557764,15494,'fi','Alueen palkoista',0),(557765,15494,'no','OmrÃ¥det lÃ¸nn',0),(557766,15494,'da','RÃ¦kke lÃ¸n',0),(557767,15494,'ko','ë²”ìœ„ ìž„ê¸ˆ',0),(557768,15494,'he','×˜×•×•×— ×©×›×¨',0),(557769,15494,'el','Î¦Î¬ÏƒÎ¼Î± Î¼Î¹ÏƒÎ¸ÏŒÏ‚',0),(557770,15494,'zh','èŒƒå›´çš„å·¥èµ„',0),(557771,15494,'sv','Rad lÃ¶ner',0),(557772,15494,'it','Salari di gamma',0),(557773,15494,'tl','',0),(557774,15494,'th','à¸Šà¹ˆà¸§à¸‡à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(557775,15494,'hi','à¤°à¥‡à¤‚à¤œ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(557776,15494,'ms','Julat gaji',0),(557777,15494,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø£Ø¬ÙˆØ±',0),(557778,15494,'fr','Ã‰ventail des salaires',0),(557779,15494,'jp','è³ƒé‡‘ã®ç¯„å›²',0),(557780,15494,'pt','Escala de salÃ¡rios',0),(557781,15494,'ru','Ð”Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð·Ð°Ñ€Ð¿Ð»Ð°Ñ‚Ñ‹',0),(557782,15494,'es','Rango de salarios',0),(557783,15494,'de','Bereich LÃ¶hne',0),(557784,15494,'en','Range Wages',0),(557785,15495,'is','',0),(557786,15495,'dr','Ø§Ø² Ù¾Ù†Ø§Ù‡',0),(557787,15495,'pr','Ø§Ø² Ù¾Ù†Ø§Ù‡',0),(557788,15495,'tr','Ãœzerinden korunaklÄ±',0),(557789,15495,'pl','OsÅ‚oniÄ™te od',0),(557790,15495,'bg','Ð—Ð°Ñ‰Ð¸Ñ‚ÐµÐ½Ð¸ Ð¾Ñ‚',0),(557791,15495,'ur','Ø³Û’ Ù¾Ù†Ø§Û',0),(557792,15495,'sr','Ð—Ð°ÑÑ‚Ð¸Ñ†ÐµÐ½ Ð¾Ð´',0),(557793,15495,'vi','Che chá»Ÿ tá»«',0),(557794,15495,'af','Beskutte uit',0),(557795,15495,'ro','AdÄƒpost de',0),(557796,15495,'et','Kaitstud',0),(557797,15495,'si','Zavarovano pred',0),(557798,15495,'ba','Terlindung dari',0),(557799,15495,'nl','Beschut tegen',0),(557800,15495,'fi','Suojassa',0),(557801,15495,'no','Skjermet',0),(557802,15495,'da','LÃ¦',0),(557803,15495,'ko','ìˆ¨ê²¨',0),(557804,15495,'he','×ž×•×’×Ÿ ×ž×Ÿ',0),(557805,15495,'el','Î ÏÎ¿ÏƒÏ„Î±Ï„ÎµÏ…Î¼Î­Î½Î· Î±Ï€ÏŒ',0),(557806,15495,'zh','ä»Žåº‡æŠ¤',0),(557807,15495,'sv','Skyddad frÃ¥n',0),(557808,15495,'it','Al riparo da',0),(557809,15495,'tl','',0),(557810,15495,'th','à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¸ˆà¸²à¸',0),(557811,15495,'hi','à¤¸à¥‡ à¤†à¤¶à¥à¤°à¤¯',0),(557812,15495,'ms','Terlindung dari',0),(557813,15495,'ar','Ù…Ø­Ù…ÙŠØ© Ù…Ù†',0),(557814,15495,'fr','A l\'abri',0),(557815,15495,'jp','å®ˆã‚‰',0),(557816,15495,'pt','Protegido de',0),(557817,15495,'ru','Ð—Ð°Ñ‰Ð¸Ñ‰ÐµÐ½Ð½Ð¾Ð¼ Ð¾Ñ‚',0),(557818,15495,'es','Al abrigo de',0),(557819,15495,'de','Vom',0),(557820,15495,'en','Sheltered From',0),(557821,15496,'is','',0),(557822,15496,'dr','Ø§Ù…Ù†ÛŒØª Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒ GL',0),(557823,15496,'pr','Ø§Ù…Ù†ÛŒØª Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒ GL',0),(557824,15496,'tr','Sosyal GÃ¼venlik GL',0),(557825,15496,'pl','Zabezpieczenia spoÅ‚ecznego GL',0),(557826,15496,'bg','Ð¡Ð¾Ñ†Ð¸Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€ÑÐ²Ð°Ð½Ðµ GL',0),(557827,15496,'ur','Ø³ÙˆØ´Ù„ Ø³ÛŒÚ©ÙˆØ±Ù¹ÛŒ Ø¬ÛŒØ¬Û’',0),(557828,15496,'sr','Ð¡Ð¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐµ Ð“Ð›',0),(557829,15496,'vi','An sinh xÃ£ há»™i GL',0),(557830,15496,'af','Sosiale sekuriteit GL',0),(557831,15496,'ro','Securitate socialÄƒ GL',0),(557832,15496,'et','Sotsiaalkindlustuse GL',0),(557833,15496,'si','Socialne varnosti GL',0),(557834,15496,'ba','Jamsostek GL',0),(557835,15496,'nl','Sociale zekerheid GL',0),(557836,15496,'fi','Sosiaaliturvan GL',0),(557837,15496,'no','Trygd GL',0),(557838,15496,'da','Social sikring GL',0),(557839,15496,'ko','ì‚¬íšŒ ë³´ìž¥ GL',0),(557840,15496,'he','×‘×™×˜×•×— ×œ××•×ž×™ GL',0),(557841,15496,'el','ÎšÎ¿Î¹Î½Ï‰Î½Î¹ÎºÎ®Ï‚ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚ GL',0),(557842,15496,'zh','ç¤¾ä¼šä¿éšœ GL',0),(557843,15496,'sv','Social trygghet GL',0),(557844,15496,'it','Sicurezza sociale GL',0),(557845,15496,'tl','',0),(557846,15496,'th','à¸ªà¸±à¸‡à¸„à¸¡ GL',0),(557847,15496,'hi','à¤¸à¤¾à¤®à¤¾à¤œà¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¾ GL',0),(557848,15496,'ms','Keselamatan Sosial GL',0),(557849,15496,'ar','Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ GL',0),(557850,15496,'fr','SÃ©curitÃ© sociale GL',0),(557851,15496,'jp','ç¤¾ä¼šä¿éšœ GL',0),(557852,15496,'pt','SeguranÃ§a social GL',0),(557853,15496,'ru','Ð¡Ð¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ðµ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ðµ GL',0),(557854,15496,'es','Seguridad social GL',0),(557855,15496,'de','Sozialen Sicherheit GL',0),(557856,15496,'en','Social Security GL',0),(557857,15497,'is','',0),(557858,15497,'dr','Ø§Ø³ Ø§Ø³ Ù…Ø§Ù„ÛŒØ§Øª Ú©Ø³Ø± Ú©Ø±Ø¯Ù‡',0),(557859,15497,'pr','Ø§Ø³ Ø§Ø³ Ù…Ø§Ù„ÛŒØ§Øª Ú©Ø³Ø± Ú©Ø±Ø¯Ù‡',0),(557860,15497,'tr','SS vergisi',0),(557861,15497,'pl','PotrÄ…cony podatek od SS',0),(557862,15497,'bg','Ð¡Ð¡ Ð´Ð°Ð½ÑŠÐº ÑƒÐ´ÑŠÑ€Ð¶Ð°Ð½',0),(557863,15497,'ur','Ø§ÛŒØ³ Ø§ÛŒØ³ Ù¹ÛŒÚ©Ø³ Ú†Ø§ÛØªÛŒ ØªÚ¾ÛŒÚº',0),(557864,15497,'sr','Ð¡Ð¡ Ð¿Ð¾Ñ€ÐµÐ· ÑƒÑÐºÑ€Ð°Ñ‚Ð¸Ð¾',0),(557865,15497,'vi','SS thuáº¿ giá»¯ láº¡i',0),(557866,15497,'af','SS belasting weerhou',0),(557867,15497,'ro','SS impozitul reÅ£inut',0),(557868,15497,'et','SS tulumaksu kinni',0),(557869,15497,'si','SS davek zadrÅ¾i',0),(557870,15497,'ba','SS pajak ditahan',0),(557871,15497,'nl','SS belasting ingehouden',0),(557872,15497,'fi','SS veroja pidÃ¤ttÃ¤Ã¤',0),(557873,15497,'no','SS Tax holdes tilbake',0),(557874,15497,'da','SS skat tilbageholdt',0),(557875,15497,'ko','SS ì„¸ê¸ˆ ë³´ë¥˜',0),(557876,15497,'he','×”××¡. ××¡ ×ž×¡ ×©× ×•×›×” ×‘×ž×§×•×¨',0),(557877,15497,'el','SS Î¦ÎŸÎ¡ÎŸÎ£ Î Î‘Î¡Î‘ÎšÎ¡Î‘Î¤Î—Î˜',0),(557878,15497,'zh','SS ç¨Žä¸äºˆå…¬å¼€',0),(557879,15497,'sv','SS skatt ut',0),(557880,15497,'it','SS IVA trattenuto',0),(557881,15497,'tl','',0),(557882,15497,'th','SS à¸ à¸²à¸©à¸µà¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(557883,15497,'hi','à¤à¤¸à¤à¤¸ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤ªà¤° à¤°à¥‹à¤• à¤²à¤—à¤¾à¤ˆ',0),(557884,15497,'ms','SS cukai dipungut',0),(557885,15497,'ar','Ø­Ø¬Ø¨ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ SS',0),(557886,15497,'fr','Retenues d\'impÃ´t SS',0),(557887,15497,'jp','æºæ³‰å¾´åŽç¨ŽãŒ SS',0),(557888,15497,'pt','SS-imposto retido',0),(557889,15497,'ru','Ð£Ð´ÐµÑ€Ð¶Ð°Ð½ Ð½Ð°Ð»Ð¾Ð³ Ð¡Ð¡',0),(557890,15497,'es','Impuestos SS retenidos',0),(557891,15497,'de','Steuer einbehalten',0),(557892,15497,'en','SS Tax Withheld',0),(557893,15498,'is','',0),(557894,15498,'dr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒÛŒ Ø§Ø³ Ø§Ø³',0),(557895,15498,'pr','Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒÛŒ Ø§Ø³ Ø§Ø³',0),(557896,15498,'tr','SS ipuÃ§larÄ±',0),(557897,15498,'pl','SS porady',0),(557898,15498,'bg','Ð¡Ð¡ ÑÑŠÐ²ÐµÑ‚Ð¸',0),(557899,15498,'ur','Ø§ÛŒØ³ Ø§ÛŒØ³ Ú©ÛŒ ØªØ¬Ø§ÙˆÛŒØ²',0),(557900,15498,'sr','Ð¡Ð¡ ÑÐ°Ð²ÐµÑ‚Ð¸',0),(557901,15498,'vi','SS Máº¹o',0),(557902,15498,'af','SS wenke',0),(557903,15498,'ro','SS sfaturi',0),(557904,15498,'et','SS Tips',0),(557905,15498,'si','SS Nasveti',0),(557906,15498,'ba','SS Tips',0),(557907,15498,'nl','SS Tips',0),(557908,15498,'fi','SS vinkkejÃ¤',0),(557909,15498,'no','SS Tips',0),(557910,15498,'da','SS Tips',0),(557911,15498,'ko','SS íŒ',0),(557912,15498,'he','×˜×™×¤×™× ×”××¡. ××¡',0),(557913,15498,'el','SS ÏƒÏ…Î¼Î²Î¿Ï…Î»Î­Ï‚',0),(557914,15498,'zh','SS å°è´´å£«',0),(557915,15498,'sv','SS Tips',0),(557916,15498,'it','Consigli di SS',0),(557917,15498,'tl','',0),(557918,15498,'th','à¹€à¸„à¸¥à¹‡à¸”à¸¥à¸±à¸š SS',0),(557919,15498,'hi','à¤à¤¸à¤à¤¸ à¤¯à¥à¤•à¥à¤¤à¤¿à¤¯à¤¾à¤',0),(557920,15498,'ms','SS Tips',0),(557921,15498,'ar','Ù†ØµØ§Ø¦Ø­ SS',0),(557922,15498,'fr','Conseils de la SS',0),(557923,15498,'jp','SS ã®ãƒ’ãƒ³ãƒˆ',0),(557924,15498,'pt','Dicas de SS',0),(557925,15498,'ru','Ð¡Ð¡ ÑÐ¾Ð²ÐµÑ‚Ñ‹',0),(557926,15498,'es','Consejos de SS',0),(557927,15498,'de','SS-Tipps',0),(557928,15498,'en','SS Tips',0),(557929,15499,'is','',0),(557930,15499,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§Ø³ Ø§Ø³',0),(557931,15499,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø§Ø³ Ø§Ø³',0),(557932,15499,'tr','SS Ã¼cret',0),(557933,15499,'pl','PÅ‚ace SS',0),(557934,15499,'bg','Ð¡Ð¡ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(557935,15499,'ur','Ø§ÛŒØ³ Ø§ÛŒØ³ Ø§Ø¬Ø±Øª',0),(557936,15499,'sr','Ð¡Ð¡ Ð¿Ð»Ð°Ñ‚Ðµ',0),(557937,15499,'vi','SS lÆ°Æ¡ng',0),(557938,15499,'af','SS lone',0),(557939,15499,'ro','SS salariile',0),(557940,15499,'et','SS palk',0),(557941,15499,'si','SS plaÄe',0),(557942,15499,'ba','SS upah',0),(557943,15499,'nl','SS lonen',0),(557944,15499,'fi','SS palkat',0),(557945,15499,'no','SS lÃ¸nn',0),(557946,15499,'da','SS lÃ¸n',0),(557947,15499,'ko','SS ìž„ê¸ˆ',0),(557948,15499,'he','×©×›×¨ ×”××¡. ××¡',0),(557949,15499,'el','SS Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(557950,15499,'zh','SS å·¥èµ„',0),(557951,15499,'sv','SS lÃ¶ner',0),(557952,15499,'it','Salari di SS',0),(557953,15499,'tl','',0),(557954,15499,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡ SS',0),(557955,15499,'hi','à¤à¤¸à¤à¤¸ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(557956,15499,'ms','Upah SS',0),(557957,15499,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± SS',0),(557958,15499,'fr','Salaires de SS',0),(557959,15499,'jp','SS ã®è³ƒé‡‘',0),(557960,15499,'pt','SalÃ¡rios de SS',0),(557961,15499,'ru','Ð¡Ð¡ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(557962,15499,'es','Salarios de SS',0),(557963,15499,'de','SS-LÃ¶hne',0),(557964,15499,'en','SS Wages',0),(557965,15500,'is','',0),(557966,15500,'dr','Ø§Ø³ Ø§Ø³ Ù†Ú©Ø±Ø¯Ù†',0),(557967,15500,'pr','Ø§Ø³ Ø§Ø³ Ù†Ú©Ø±Ø¯Ù†',0),(557968,15500,'tr','Tevkif SS',0),(557969,15500,'pl','SS wstrzymane',0),(557970,15500,'bg','Ð¡Ð¡ ÑƒÐ´ÑŠÑ€Ð¶Ð°Ð½Ð¸',0),(557971,15500,'ur','Ø§ÛŒØ³ Ø§ÛŒØ³ Ú†Ø§ÛØªÛŒ ØªÚ¾ÛŒÚº',0),(557972,15500,'sr','Ð¡Ð¡ Ñ˜Ðµ ÑÐºÑ€Ð¸Ð²Ð°Ð¾',0),(557973,15500,'vi','SS giá»¯ láº¡i',0),(557974,15500,'af','SS weerhou',0),(557975,15500,'ro','SS reÅ£inute',0),(557976,15500,'et','SS kinnipeetud',0),(557977,15500,'si','SS, zadrÅ¾i',0),(557978,15500,'ba','SS ditahan',0),(557979,15500,'nl','SS ingehouden',0),(557980,15500,'fi','SS pidÃ¤tetty',0),(557981,15500,'no','SS tilbakeholdt',0),(557982,15500,'da','SS tilbageholdt',0),(557983,15500,'ko','SS ë³´ë¥˜',0),(557984,15500,'he','×”××¡. ××¡ ×©× ×•×›×” ×‘×ž×§×•×¨',0),(557985,15500,'el','SS Ï€Î±ÏÎ±ÎºÏÎ±Ï„Î·Î¸ÎµÎ¯',0),(557986,15500,'zh','SS æ‰£ç•™',0),(557987,15500,'sv','SS inne',0),(557988,15500,'it','SS trattenuto',0),(557989,15500,'tl','',0),(557990,15500,'th','SS à¸—à¸µà¹ˆà¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(557991,15500,'hi','à¤à¤¸ à¤à¤¸ à¤ªà¤° à¤°à¥‹à¤• à¤²à¤—à¤¾à¤ˆ',0),(557992,15500,'ms','SS ditahan',0),(557993,15500,'ar','SS Ø§Ù„Ù…Ø­ØªØ¬Ø²Ø©',0),(557994,15500,'fr','SS retenue',0),(557995,15500,'jp','æºæ³‰å¾´åŽ SS',0),(557996,15500,'pt','SS retido',0),(557997,15500,'ru','SS Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð¾',0),(557998,15500,'es','SS retenidos',0),(557999,15500,'de','SS-zurÃ¼ckgehalten',0),(558000,15500,'en','SS Withheld',0),(558001,15501,'is','',0),(558002,15501,'dr','Ø­Ø§Ù„Øª Ø§Ø¶Ø§ÙÛŒ',0),(558003,15501,'pr','Ø­Ø§Ù„Øª Ø§Ø¶Ø§ÙÛŒ',0),(558004,15501,'tr','Ä°lave devlet',0),(558005,15501,'pl','PodaÄ‡ dodatkowe',0),(558006,15501,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¾',0),(558007,15501,'ur','Ø§Ø¶Ø§ÙÛŒ Ø±ÛŒØ§Ø³Øª',0),(558008,15501,'sr','ÐÐ°Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ',0),(558009,15501,'vi','NhÃ  nÆ°á»›c phá»¥',0),(558010,15501,'af','Staat ekstra',0),(558011,15501,'ro','Extra de stat',0),(558012,15501,'et','Riigi eest',0),(558013,15501,'si','Navedite dodatne',0),(558014,15501,'ba','Negara tambahan',0),(558015,15501,'nl','Staat Extra',0),(558016,15501,'fi','Valtion Extra',0),(558017,15501,'no','Oppgi ekstra',0),(558018,15501,'da','Statslige ekstra',0),(558019,15501,'ko','ì£¼ ì¶”ê°€',0),(558020,15501,'he','×ž×“×™× ×” × ×•×¡×¤×ª',0),(558021,15501,'el','Î‘Î½Î±Ï†Î­ÏÎµÎ¹ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½',0),(558022,15501,'zh','é¢å¤–çš„çŠ¶æ€',0),(558023,15501,'sv','Ange Extra',0),(558024,15501,'it','Stato Extra',0),(558025,15501,'tl','',0),(558026,15501,'th','à¹€à¸ªà¸£à¸´à¸¡à¸£à¸±à¸',0),(558027,15501,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤°à¤¾à¤œà¥',0),(558028,15501,'ms','Menyatakan tambahan',0),(558029,15501,'ar','Ø®Ø§Ø±Ø¬ Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(558030,15501,'fr','L\'Ã‰tat supplÃ©mentaire',0),(558031,15501,'jp','ä½™åˆ†ãªçŠ¶æ…‹ã—ã¾ã™ã€‚',0),(558032,15501,'pt','Extra do estado',0),(558033,15501,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ…',0),(558034,15501,'es','Estado adicional',0),(558035,15501,'de','ZusÃ¤tzliche staatliche',0),(558036,15501,'en','State Extra',0),(558037,15502,'is','',0),(558038,15502,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¯ÙˆÙ„ØªÛŒ Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(558039,15502,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¯ÙˆÙ„ØªÛŒ Ø§Ø² Ø·Ø±ÛŒÙ‚',0),(558040,15502,'tr','Devlet bilgi yoluyla',0),(558041,15502,'pl','Stan informacji poprzez',0),(558042,15502,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‡Ñ€ÐµÐ·',0),(558043,15502,'ur','Ø³Ø±Ú©Ø§Ø±ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(558044,15502,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð˜Ð½Ñ„Ð¾ ÐºÑ€Ð¾Ð·',0),(558045,15502,'vi','ThÃ´ng tin nhÃ  nÆ°á»›c thÃ´ng qua',0),(558046,15502,'af','Staat inligting deur',0),(558047,15502,'ro','Info stat prin',0),(558048,15502,'et','Riigi Info lÃ¤bi',0),(558049,15502,'si','DrÅ¾avnih informacij skozi',0),(558050,15502,'ba','Negara Info melalui',0),(558051,15502,'nl','Staat Info via',0),(558052,15502,'fi','Valtion Info kautta',0),(558053,15502,'no','Statlige Info gjennom',0),(558054,15502,'da','Statslige Info via',0),(558055,15502,'ko','í†µí•´ ì£¼ ì •ë³´',0),(558056,15502,'he','×”×ž×“×™× ×” ×‘××ž×¦×¢×•×ª ×ž×™×“×¢',0),(558057,15502,'el','ÎŸÎ¹ ÎºÏÎ±Ï„Î¹ÎºÎ­Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î¼Î­ÏƒÏ‰',0),(558058,15502,'zh','é€šè¿‡çŠ¶æ€ä¿¡æ¯',0),(558059,15502,'sv','Statlig information genom',0),(558060,15502,'it','Info stato attraverso',0),(558061,15502,'tl','',0),(558062,15502,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸£à¸±à¸à¸œà¹ˆà¸²à¸™',0),(558063,15502,'hi','à¤°à¤¾à¤œà¥ à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡',0),(558064,15502,'ms','Info Negeri melalui',0),(558065,15502,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø¯ÙˆÙ„Ø© Ù…Ù† Ø®Ù„Ø§Ù„',0),(558066,15502,'fr','Info Ã‰tat par',0),(558067,15502,'jp','çµŒç”±ã§çŠ¶æ…‹ã®æƒ…å ±',0),(558068,15502,'pt','InformaÃ§Ã£o de estado atravÃ©s de',0),(558069,15502,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ñ‡ÐµÑ€ÐµÐ·',0),(558070,15502,'es','InformaciÃ³n estatal a travÃ©s de',0),(558071,15502,'de','Staatliche Informationen durch',0),(558072,15502,'en','State Info Through',0),(558073,15503,'is','',0),(558074,15503,'dr','ÙˆØ¶Ø¹ÛŒØª Ø¯ÙˆÙ„Øª',0),(558075,15503,'pr','ÙˆØ¶Ø¹ÛŒØª Ø¯ÙˆÙ„Øª',0),(558076,15503,'tr','Devlet durumu',0),(558077,15503,'pl','Stan PaÅ„stwa',0),(558078,15503,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ ÑÑ‚Ð°Ñ‚ÑƒÑ‚',0),(558079,15503,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ø­ÛŒØ«ÛŒØª',0),(558080,15503,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(558081,15503,'vi','NhÃ  nÆ°á»›c tráº¡ng thÃ¡i',0),(558082,15503,'af','Staat Status',0),(558083,15503,'ro','Statutul de stat',0),(558084,15503,'et','Riiklik staatus',0),(558085,15503,'si','DrÅ¾avna Status',0),(558086,15503,'ba','Status negara',0),(558087,15503,'nl','Staat Status',0),(558088,15503,'fi','Valtion tila',0),(558089,15503,'no','Statlige Status',0),(558090,15503,'da','Statens Status',0),(558091,15503,'ko','êµ­ê°€ ìƒíƒœ',0),(558092,15503,'he','×ž×¦×‘ ×”×ž×“×™× ×”',0),(558093,15503,'el','ÎšÏÎ±Ï„Î¹ÎºÏŒ ÎºÎ±Î¸ÎµÏƒÏ„ÏŽÏ‚',0),(558094,15503,'zh','å›½å®¶åœ°ä½',0),(558095,15503,'sv','Statliga Status',0),(558096,15503,'it','Stato stato',0),(558097,15503,'tl','',0),(558098,15503,'th','à¸ªà¸–à¸²à¸™à¸°à¸‚à¸­à¸‡à¸£à¸±à¸',0),(558099,15503,'hi','à¤°à¤¾à¤œà¥ à¤¯ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(558100,15503,'ms','Status Negeri',0),(558101,15503,'ar','Ù…Ø±ÙƒØ² Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(558102,15503,'fr','Statut de l\'Ã‰tat',0),(558103,15503,'jp','çŠ¶æ…‹ã®ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(558104,15503,'pt','Status de estado',0),(558105,15503,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(558106,15503,'es','Estado estado',0),(558107,15503,'de','Staatlichen Status',0),(558108,15503,'en','State Status',0),(558109,15504,'is','',0),(558110,15504,'dr','Ø¯ÙˆÙ„Øª Ù…Ø§Ù„ÛŒØ§Øª Ú©Ø³Ø± Ú©Ø±Ø¯Ù‡',0),(558111,15504,'pr','Ø¯ÙˆÙ„Øª Ù…Ø§Ù„ÛŒØ§Øª Ú©Ø³Ø± Ú©Ø±Ø¯Ù‡',0),(558112,15504,'tr','Devlet vergi tevkif',0),(558113,15504,'pl','PaÅ„stwa podatek dochodowy',0),(558114,15504,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ ÑƒÐ´ÑŠÑ€Ð¶Ð°Ð½Ð¸Ñ Ð´Ð°Ð½ÑŠÐº',0),(558115,15504,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ù¹ÛŒÚ©Ø³ Ú†Ø§ÛØªÛŒ ØªÚ¾ÛŒÚº',0),(558116,15504,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· ÑƒÑÐºÑ€Ð°Ñ‚Ð¸Ð¾',0),(558117,15504,'vi','NhÃ  nÆ°á»›c thuáº¿ giá»¯ láº¡i',0),(558118,15504,'af','Staat belasting weerhou',0),(558119,15504,'ro','Stat impozitul reÅ£inut',0),(558120,15504,'et','Riiklik kinnipeetud maksu',0),(558121,15504,'si','DrÅ¾ava davÄnega odtegljaja',0),(558122,15504,'ba','Pajak negara yang ditahan',0),(558123,15504,'nl','Staat belasting ingehouden',0),(558124,15504,'fi','Valtion veron',0),(558125,15504,'no','Statlige kildeskatt',0),(558126,15504,'da','Statslige skat tilbageholdt',0),(558127,15504,'ko','ì£¼ ì„¸ ì§•ìˆ˜',0),(558128,15504,'he','×”×ž×“×™× ×” ×ž×¡ ×©× ×•×›×” ×‘×ž×§×•×¨',0),(558129,15504,'el','ÎšÏÎ±Ï„Î¹ÎºÎ¿Ï Ï†ÏŒÏÎ¿Ï… Ï€Î¿Ï… Ï€Î±ÏÎ±ÎºÏÎ±Ï„Î®Î¸Î·ÎºÎ±Î½',0),(558130,15504,'zh','å›½å®¶ç¨Žæ¬¾',0),(558131,15504,'sv','Statliga skattebeloppet',0),(558132,15504,'it','Trattenute fiscali statali',0),(558133,15504,'tl','',0),(558134,15504,'th','à¸£à¸±à¸à¸ à¸²à¸©à¸µà¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(558135,15504,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤•à¤° à¤°à¥‹à¤• à¤²à¤—à¤¾à¤ˆ',0),(558136,15504,'ms','Negeri cukai yang dipungut',0),(558137,15504,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ù…Ø­ØªØ¬Ø²Ø©',0),(558138,15504,'fr','Etat impÃ´t retenu',0),(558139,15504,'jp','å·žç¨Žã‚’æºæ³‰å¾´åŽ',0),(558140,15504,'pt','Estado imposto retido',0),(558141,15504,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³, ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð½Ñ‹Ð¹',0),(558142,15504,'es','Impuesto estatal retenido',0),(558143,15504,'de','Staatliche Steuer',0),(558144,15504,'en','State Tax Withheld',0),(558145,15505,'is','',0),(558146,15505,'dr','Ø¨ÛŒÚ©Ø§Ø±ÛŒ Ø¯ÙˆÙ„Øª Ù…Ø§Ù„ÛŒØ§Øª',0),(558147,15505,'pr','Ø¨ÛŒÚ©Ø§Ø±ÛŒ Ø¯ÙˆÙ„Øª Ù…Ø§Ù„ÛŒØ§Øª',0),(558148,15505,'tr','Devlet iÅŸsizlik vergiler',0),(558149,15505,'pl','Stan bezrobocia podatkÃ³w',0),(558150,15505,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²ÐµÐ½ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(558151,15505,'ur','ØµÙˆØ¨Ø§Ø¦ÛŒ Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ú©ÛŒ Ø´Ø±Ø­ Ù¹ÛŒÚ©Ø³',0),(558152,15505,'sr','ÐÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚Ð¸ Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(558153,15505,'vi','Tá»· lá»‡ tháº¥t nghiá»‡p nhÃ  nÆ°á»›c thuáº¿',0),(558154,15505,'af','Staat werkloosheid belasting',0),(558155,15505,'ro','Taxele de stat de ÅŸomaj',0),(558156,15505,'et','Riikliku tÃ¶Ã¶tuskindlustuse maksud',0),(558157,15505,'si','Stanje brezposelnosti davkov',0),(558158,15505,'ba','Pajak negara pengangguran',0),(558159,15505,'nl','Staat werkloosheid belastingen',0),(558160,15505,'fi','Valtion tyÃ¶ttÃ¶myyden verot',0),(558161,15505,'no','Statlig arbeidsledighet skatter',0),(558162,15505,'da','Statslige arbejdslÃ¸shed skatter',0),(558163,15505,'ko','êµ­ê°€ ì‹¤ì§ ì„¸ê¸ˆ',0),(558164,15505,'he','×”××‘×˜×œ×” ×”×ž×“×™× ×” ×ž×™×¡×™×',0),(558165,15505,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Î½ÎµÏÎ³Î¯Î±Ï‚ Ï†ÏŒÏÏ‰Î½',0),(558166,15505,'zh','å›½å®¶å¤±ä¸šç¨Ž',0),(558167,15505,'sv','Statlig arbetslÃ¶shet skatter',0),(558168,15505,'it','Tasse dello stato di disoccupazione',0),(558169,15505,'tl','',0),(558170,15505,'th','à¸§à¹ˆà¸²à¸‡à¸‡à¸²à¸™à¸£à¸±à¸à¸ à¸²à¸©à¸µ',0),(558171,15505,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤•à¤°à¥‹à¤‚',0),(558172,15505,'ms','Pengangguran Negeri cukai',0),(558173,15505,'ar','Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ù„Ø¨Ø·Ø§Ù„Ø©',0),(558174,15505,'fr','Taxes de l\'Ã©tat de chÃ´mage',0),(558175,15505,'jp','å·žã®å¤±æ¥­ç¨Ž',0),(558176,15505,'pt','Taxas de desemprego do estado',0),(558177,15505,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð¸',0),(558178,15505,'es','Impuestos estatales de desempleo',0),(558179,15505,'de','Staatliche Arbeitslosigkeit Steuern',0),(558180,15505,'en','State Unemployment Taxes',0),(558181,15506,'is','',0),(558182,15506,'dr','Ø³ÙˆØ¦ÛŒ GL',0),(558183,15506,'pr','Ø³ÙˆØ¦ÛŒ GL',0),(558184,15506,'tr','SUI GL',0),(558185,15506,'pl','SUI GL',0),(558186,15506,'bg','SUI GL',0),(558187,15506,'ur','Ø³ÙˆØ¦ÛŒ Ø¬ÛŒØ¬Û’',0),(558188,15506,'sr','Ð¡Ð£Ð˜ Ð“Ð›',0),(558189,15506,'vi','SUI GL',0),(558190,15506,'af','SUI GL',0),(558191,15506,'ro','SUI GL',0),(558192,15506,'et','SUI GL',0),(558193,15506,'si','SUI GL',0),(558194,15506,'ba','SUI GL',0),(558195,15506,'nl','SUI GL',0),(558196,15506,'fi','SUI GL',0),(558197,15506,'no','SUI GL',0),(558198,15506,'da','SUI GL',0),(558199,15506,'ko','ìˆ˜ì´ GL',0),(558200,15506,'he','×¡×•××™×™ GL',0),(558201,15506,'el','SUI GL',0),(558202,15506,'zh','éš‹ GL',0),(558203,15506,'sv','SUI GL',0),(558204,15506,'it','SUI GL',0),(558205,15506,'tl','',0),(558206,15506,'th','GL à¸ªà¸¸à¹ˆà¸¢',0),(558207,15506,'hi','à¤¸à¥à¤‡ GL',0),(558208,15506,'ms','SUI GL',0),(558209,15506,'ar','GL ÙØ±ÙŠØ¯ Ù…Ù† Ù†ÙˆØ¹Ù‡',0),(558210,15506,'fr','SUI GL',0),(558211,15506,'jp','éš‹ GL',0),(558212,15506,'pt','SUI GL',0),(558213,15506,'ru','Ð¡Ð£Ð™ GL',0),(558214,15506,'es','GL DE SUI',0),(558215,15506,'de','SUI-GL',0),(558216,15506,'en','SUI GL',0),(558217,15507,'is','',0),(558218,15507,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³ÙˆØ¦ÛŒ',0),(558219,15507,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø³ÙˆØ¦ÛŒ',0),(558220,15507,'tr','SUI Ã¼cret',0),(558221,15507,'pl','SUI pÅ‚ace',0),(558222,15507,'bg','SUI Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(558223,15507,'ur','Ø³ÙˆØ¦ÛŒ Ø§Ø¬Ø±Øª',0),(558224,15507,'sr','Ð¡Ð£Ð˜ Ð¿Ð»Ð°Ñ‚Ðµ',0),(558225,15507,'vi','SUI lÆ°Æ¡ng',0),(558226,15507,'af','SUI lone',0),(558227,15507,'ro','SUI salariile',0),(558228,15507,'et','SUI palk',0),(558229,15507,'si','SUI plaÄe',0),(558230,15507,'ba','Upah SUI',0),(558231,15507,'nl','SUI lonen',0),(558232,15507,'fi','SUI palkat',0),(558233,15507,'no','SUI lÃ¸nn',0),(558234,15507,'da','SUI lÃ¸n',0),(558235,15507,'ko','ìˆ˜ì´ ìž„ê¸ˆ',0),(558236,15507,'he','×©×›×¨ ×¡×•×•×™',0),(558237,15507,'el','ÎœÎ¹ÏƒÎ¸Î¿Î¯ SUI',0),(558238,15507,'zh','éš‹å·¥èµ„',0),(558239,15507,'sv','SUI lÃ¶ner',0),(558240,15507,'it','SUI salari',0),(558241,15507,'tl','',0),(558242,15507,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸ªà¸¸à¹ˆà¸¢',0),(558243,15507,'hi','à¤¸à¥à¤‡ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(558244,15507,'ms','Upah SUI',0),(558245,15507,'ar','ÙØ±ÙŠØ¯ Ù…Ù† Ù†ÙˆØ¹Ù‡ Ù„Ù„Ø£Ø¬ÙˆØ±',0),(558246,15507,'fr','Salaires de SUI',0),(558247,15507,'jp','éš‹ã®è³ƒé‡‘',0),(558248,15507,'pt','SalÃ¡rios de SUI',0),(558249,15507,'ru','Ð¡ÑƒÐ¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(558250,15507,'es','Salarios de SUI',0),(558251,15507,'de','SUI-LÃ¶hne',0),(558252,15507,'en','SUI Wages',0),(558253,15508,'is','',0),(558254,15508,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ GL',0),(558255,15508,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ GL',0),(558256,15508,'tr','Ãœcret GL',0),(558257,15508,'pl','PÅ‚ac GL',0),(558258,15508,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð° GL',0),(558259,15508,'ur','Ù…Ù†ÛŒ Ù…Ù… ÙˆÛŒØ¬ Ø¬ÛŒØ¬Û’',0),(558260,15508,'sr','ÐŸÐ»Ð°Ñ‚Ð° Ð“Ð›',0),(558261,15508,'vi','LÆ°Æ¡ng GL',0),(558262,15508,'af','Loon GL',0),(558263,15508,'ro','Salariul GL',0),(558264,15508,'et','Palga GL',0),(558265,15508,'si','PlaÄe GL',0),(558266,15508,'ba','Upah GL',0),(558267,15508,'nl','Loon GL',0),(558268,15508,'fi','Palkkojen GL',0),(558269,15508,'no','LÃ¸nns GL',0),(558270,15508,'da','LÃ¸n GL',0),(558271,15508,'ko','ìž„ê¸ˆ GL',0),(558272,15508,'he','×©×›×¨ GL',0),(558273,15508,'el','ÎœÎ¹ÏƒÎ¸ÏŒ GL',0),(558274,15508,'zh','å·¥èµ„ GL',0),(558275,15508,'sv','LÃ¶ne GL',0),(558276,15508,'it','Salario GL',0),(558277,15508,'tl','',0),(558278,15508,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡ GL',0),(558279,15508,'hi','à¤®à¤œà¤¦à¥‚à¤°à¥€ GL',0),(558280,15508,'ms','Gaji GL',0),(558281,15508,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± GL',0),(558282,15508,'fr','Salaire GL',0),(558283,15508,'jp','è³ƒé‡‘ GL',0),(558284,15508,'pt','SalÃ¡rio GL',0),(558285,15508,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð° GL',0),(558286,15508,'es','Salario GL',0),(558287,15508,'de','Lohn GL',0),(558288,15508,'en','Wage GL',0),(558289,15509,'is','',0),(558290,15509,'dr','Ù†Ú©Ø±Ø¯Ù†',0),(558291,15509,'pr','Ù†Ú©Ø±Ø¯Ù†',0),(558292,15509,'tr','Tevkif',0),(558293,15509,'pl','Wstrzymana',0),(558294,15509,'bg','Ð—Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ð°',0),(558295,15509,'ur','Ú†Ø§ÛØªÛŒ ØªÚ¾ÛŒÚº',0),(558296,15509,'sr','Ð£ÑÐºÑ€Ð°Ñ‚Ð¸Ð¾',0),(558297,15509,'vi','Giá»¯ láº¡i',0),(558298,15509,'af','Weerhou',0),(558299,15509,'ro','ReÅ£inute',0),(558300,15509,'et','Kinnipeetud',0),(558301,15509,'si','ZadrÅ¾i',0),(558302,15509,'ba','Ditahan',0),(558303,15509,'nl','Ingehouden',0),(558304,15509,'fi','PidÃ¤tetty',0),(558305,15509,'no','Tilbakeholdt',0),(558306,15509,'da','Tilbageholdt',0),(558307,15509,'ko','ì›ì²œ ì§•ìˆ˜',0),(558308,15509,'he','×©× ×•×›×” ×‘×ž×§×•×¨',0),(558309,15509,'el','Î Î±ÏÎ±ÎºÏÎ±Ï„Î·Î¸ÎµÎ¯',0),(558310,15509,'zh','è¢«æ‰£ç•™',0),(558311,15509,'sv','InnehÃ¥llna',0),(558312,15509,'it','Trattenuto',0),(558313,15509,'tl','',0),(558314,15509,'th','à¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢',0),(558315,15509,'hi','à¤ªà¤° à¤°à¥‹à¤• à¤²à¤—à¤¾à¤ˆ',0),(558316,15509,'ms','Ditahan',0),(558317,15509,'ar','Ø­Ø¬Ø¨',0),(558318,15509,'fr','Retenu',0),(558319,15509,'jp','æºæ³‰å¾´åŽ',0),(558320,15509,'pt','Retido',0),(558321,15509,'ru','Ð£Ð´ÐµÑ€Ð¶Ð¸Ð²Ð°ÐµÑ‚ÑÑ',0),(558322,15509,'es','Retenida',0),(558323,15509,'de','Einbehaltene',0),(558324,15509,'en','Withheld',0),(558325,15510,'is','',0),(558326,15510,'dr','Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Comp',0),(558327,15510,'pr','Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Comp',0),(558328,15510,'tr','Ä°ÅŸÃ§i Comp',0),(558329,15510,'pl','Komp pracownikÃ³w',0),(558330,15510,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ‡ÐµÑÐºÐ° Comp',0),(558331,15510,'ur','Ú©Ø§Ø±Ú©Ù†ÙˆÚº Ú©ÛŒ Ú©Ø¹Ù…Ù¾',0),(558332,15510,'sr','Ð Ð°Ð´Ð½Ð¸Ñ‡ÐºÐµ Ð¦Ð¾Ð¼Ð¿',0),(558333,15510,'vi','CÃ´ng nhÃ¢n Comp',0),(558334,15510,'af','Comp-Werkersdag',0),(558335,15510,'ro','LucrÄƒtorilor Comp',0),(558336,15510,'et','TÃ¶Ã¶tajate Comp',0),(558337,15510,'si','Delavcev Comp',0),(558338,15510,'ba','Pekerja Comp',0),(558339,15510,'nl','Werknemers Comp',0),(558340,15510,'fi','TyÃ¶ntekijÃ¶iden Comp',0),(558341,15510,'no','Arbeidernes komp',0),(558342,15510,'da','Arbejdstagernes Comp',0),(558343,15510,'ko','ë…¸ë™ìžì˜ ë³´ìƒ',0),(558344,15510,'he','×”×¢×•×‘×“×™× ×©×œ',0),(558345,15510,'el','Comp ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(558346,15510,'zh','å·¥äººçš„ Comp',0),(558347,15510,'sv','Arbetstagarnas Comp',0),(558348,15510,'it','Comp lavoratori',0),(558349,15510,'tl','',0),(558350,15510,'th','à¸„à¹ˆà¸²à¸•à¸­à¸šà¹à¸—à¸™à¸œà¸¹à¹‰à¸›à¸à¸´à¸šà¸±à¸•à¸´à¸‡à¸²à¸™',0),(558351,15510,'hi','à¤¶à¥à¤°à¤®à¤¿à¤• Comp',0),(558352,15510,'ms','Comp pekerja',0),(558353,15510,'ar','Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø¹Ù…Ø§Ù„',0),(558354,15510,'fr','Workers\' Comp',0),(558355,15510,'jp','åŠ´åƒè€…ã® Comp',0),(558356,15510,'pt','Comp trabalhadores',0),(558357,15510,'ru','Comp Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð²',0),(558358,15510,'es','Comp de los trabajadores',0),(558359,15510,'de','Arbeitnehmer-Comp',0),(558360,15510,'en','Workers\' Comp',0),(558361,15511,'is','',0),(558362,15511,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª ØºØ±Ø§Ù…Øª Ú©Ø§Ø±Ú¯Ø±Ø§Ù†',0),(558363,15511,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª ØºØ±Ø§Ù…Øª Ú©Ø§Ø±Ú¯Ø±Ø§Ù†',0),(558364,15511,'tr','Ä°ÅŸÃ§i tazminatÄ± detay',0),(558365,15511,'pl','Workers\' Compensation detal',0),(558366,15511,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ†Ð¸Ñ‚Ðµ Ð¾Ð±ÐµÐ·Ñ‰ÐµÑ‚ÐµÐ½Ð¸Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»',0),(558367,15511,'ur','Ú©Ø§Ø±Ú©Ù† \' Ù…Ø¹Ø§ÙˆØ¶Û ØªÙØµÛŒÙ„',0),(558368,15511,'sr','Ð”ÐµÑ‚Ð°Ñ™ Ñ€Ð°Ð´Ð½Ð¸ÐºÐ°',0),(558369,15511,'vi','Tai náº¡n lao Ä‘á»™ng chi tiáº¿t',0),(558370,15511,'af','Werkers \' vergoeding Detail',0),(558371,15511,'ro','LucrÄƒtorilor de compensare detaliu',0),(558372,15511,'et','TÃ¶Ã¶tajate hÃ¼vitisi Detail',0),(558373,15511,'si','Delavcev odÅ¡kodnina podrobnosti',0),(558374,15511,'ba','Kompensasi pekerja Detail',0),(558375,15511,'nl','Detail van de compensatie van arbeiders',0),(558376,15511,'fi','TyÃ¶ntekijÃ¶ille maksettavia korvauksia yksityiskohtaisesti',0),(558377,15511,'no','Arbeidernes kompensasjon detaljer',0),(558378,15511,'da','Workers\' Compensation detaljer',0),(558379,15511,'ko','ë…¸ë™ìžì˜ ë³´ìƒ ì„¸ë¶€ ì‚¬í•­',0),(558380,15511,'he','×¤×™×¨×•×˜ ×¤×™×¦×•×™×™×',0),(558381,15511,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± Î±Ï€Î¿Î¶Î·Î¼Î¹ÏŽÏƒÎµÏ‰Î½ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(558382,15511,'zh','å·¥äººèµ”å¿ç»†èŠ‚',0),(558383,15511,'sv','Workers\' Compensation detalj',0),(558384,15511,'it','Dettaglio della compensazione degli operai',0),(558385,15511,'tl','',0),(558386,15511,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸„à¹ˆà¸²à¸•à¸­à¸šà¹à¸—à¸™à¸‚à¸­à¸‡à¹à¸£à¸‡à¸‡à¸²à¸™',0),(558387,15511,'hi','à¤¶à¥à¤°à¤®à¤¿à¤• à¤®à¥à¤†à¤µà¤œà¤¾ à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤°',0),(558388,15511,'ms','Terperinci pampasan pekerja',0),(558389,15511,'ar','ØªÙØ§ØµÙŠÙ„ ØªØ¹ÙˆÙŠØ¶ Ø§Ù„Ø¹Ù…Ø§Ù„',0),(558390,15511,'fr','DÃ©tail de la Workers\' Compensation',0),(558391,15511,'jp','åŠ´åƒè€…ã®è£œå„Ÿã®è©³ç´°',0),(558392,15511,'pt','Detalhe da compensaÃ§Ã£o dos trabalhadores',0),(558393,15511,'ru','ÐšÐ¾Ð¼Ð¿ÐµÐ½ÑÐ°Ñ†Ð¸Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°Ð¼ Ð´ÐµÑ‚Ð°Ð»ÑŒ',0),(558394,15511,'es','Detalle de la compensaciÃ³n',0),(558395,15511,'de','Workers\' Compensation-Detail',0),(558396,15511,'en','Workers\' Compensation Detail',0),(558397,15512,'is','',0),(558398,15512,'dr','Ø®Ù„Ø§ØµÙ‡ ØºØ±Ø§Ù…Øª Ú©Ø§Ø±Ú¯Ø±Ø§Ù†',0),(558399,15512,'pr','Ø®Ù„Ø§ØµÙ‡ ØºØ±Ø§Ù…Øª Ú©Ø§Ø±Ú¯Ø±Ø§Ù†',0),(558400,15512,'tr','Ä°ÅŸÃ§i tazminatÄ± Ã–zeti',0),(558401,15512,'pl','Workers\' Compensation KrÃ³tki opis',0),(558402,15512,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ†Ð¸Ñ‚Ðµ Ð¾Ð±ÐµÐ·Ñ‰ÐµÑ‚ÐµÐ½Ð¸Ðµ Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(558403,15512,'ur','Ú©Ø§Ø±Ú©Ù† \' Ù…Ø¹Ø§ÙˆØ¶Û Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(558404,15512,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ñ€Ð°Ð´Ð½Ð¸ÐºÐ°',0),(558405,15512,'vi','Tai náº¡n lao Ä‘á»™ng tÃ³m táº¯t',0),(558406,15512,'af','Werkers \' vergoeding opsomming',0),(558407,15512,'ro','LucrÄƒtorilor de compensare Rezumat',0),(558408,15512,'et','TÃ¶Ã¶tajate hÃ¼vitisi KokkuvÃµte',0),(558409,15512,'si','Delavcev odÅ¡kodnina Povzetek',0),(558410,15512,'ba','Kompensasi pekerja ringkasan',0),(558411,15512,'nl','Samenvatting van de compensatie van arbeiders',0),(558412,15512,'fi','TyÃ¶ntekijÃ¶ille maksettavia korvauksia Yhteenveto',0),(558413,15512,'no','Arbeidernes kompensasjon Sammendrag',0),(558414,15512,'da','Workers\' Compensation ResumÃ©',0),(558415,15512,'ko','ë…¸ë™ìžì˜ ë³´ìƒ ìš”ì•½',0),(558416,15512,'he','×¡×™×›×•× ×¤×™×¦×•×™×™×',0),(558417,15512,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Ï„Ï‰Î½ Î±Ï€Î¿Î¶Î·Î¼Î¹ÏŽÏƒÎµÏ‰Î½ Ï„Ï‰Î½ ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(558418,15512,'zh','å·¥äººèµ”å¿æ‘˜è¦',0),(558419,15512,'sv','Workers\' Compensation Sammanfattning',0),(558420,15512,'it','Riepilogo di compensazione degli operai',0),(558421,15512,'tl','',0),(558422,15512,'th','à¸ªà¸£à¸¸à¸›à¸„à¹ˆà¸²à¸•à¸­à¸šà¹à¸—à¸™à¸‚à¸­à¸‡à¹à¸£à¸‡à¸‡à¸²à¸™',0),(558423,15512,'hi','à¤¶à¥à¤°à¤®à¤¿à¤• à¤®à¥à¤†à¤µà¤œà¤¾ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(558424,15512,'ms','Ringkasan pampasan pekerja',0),(558425,15512,'ar','Ù…Ù„Ø®Øµ ØªØ¹ÙˆÙŠØ¶ Ø§Ù„Ø¹Ù…Ø§Ù„',0),(558426,15512,'fr','RÃ©sumÃ© de la Workers\' Compensation',0),(558427,15512,'jp','åŠ´åƒè€…ã®è£œå„Ÿã®æ¦‚è¦',0),(558428,15512,'pt','Resumo de compensaÃ§Ã£o dos trabalhadores',0),(558429,15512,'ru','ÐšÐ¾Ð¼Ð¿ÐµÐ½ÑÐ°Ñ†Ð¸Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°Ð¼ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(558430,15512,'es','Resumen de compensaciÃ³n',0),(558431,15512,'de','Zusammenfassung der Arbeiterunfallversicherung',0),(558432,15512,'en','Workers\' Compensation Summary',0),(558433,15513,'is','',0),(558434,15513,'dr','Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Comp GL',0),(558435,15513,'pr','Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Comp GL',0),(558436,15513,'tr','Ä°ÅŸÃ§i Comp GL',0),(558437,15513,'pl','Komp pracownikÃ³w GL',0),(558438,15513,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ‡ÐµÑÐºÐ° Comp GL',0),(558439,15513,'ur','Ú©Ø§Ø±Ú©Ù†ÙˆÚº Ú©ÛŒ Ú©Ø¹Ù…Ù¾ Ø¬ÛŒØ¬Û’',0),(558440,15513,'sr','Ð Ð°Ð´Ð½Ð¸Ñ‡ÐºÐµ Ð¦Ð¾Ð¼Ð¿ Ð“Ð›',0),(558441,15513,'vi','CÃ´ng nhÃ¢n Comp GL',0),(558442,15513,'af','Werkers se Comp GL',0),(558443,15513,'ro','LucrÄƒtorilor Comp GL',0),(558444,15513,'et','TÃ¶Ã¶tajate Comp GL',0),(558445,15513,'si','Delavcev Comp GL',0),(558446,15513,'ba','Pekerja Comp GL',0),(558447,15513,'nl','Werknemers Comp GL',0),(558448,15513,'fi','TyÃ¶ntekijÃ¶iden Comp GL',0),(558449,15513,'no','Arbeidernes komp GL',0),(558450,15513,'da','Arbejdstagernes Comp GL',0),(558451,15513,'ko','ë…¸ë™ìžì˜ Comp GL',0),(558452,15513,'he','Comp ×”×¢×•×‘×“×™× GL',0),(558453,15513,'el','Î•ÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Comp GL',0),(558454,15513,'zh','å·¥äººçš„ Comp GL',0),(558455,15513,'sv','Arbetstagarnas Comp GL',0),(558456,15513,'it','Comp lavoratori GL',0),(558457,15513,'tl','',0),(558458,15513,'th','à¸„à¹ˆà¸²à¸•à¸­à¸šà¹à¸—à¸™à¸œà¸¹à¹‰à¸›à¸à¸´à¸šà¸±à¸•à¸´à¸‡à¸²à¸™à¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(558459,15513,'hi','à¤¶à¥à¤°à¤®à¤¿à¤• Comp GL',0),(558460,15513,'ms','Comp pekerja GL',0),(558461,15513,'ar','Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø¹Ù…Ø§Ù„ GL',0),(558462,15513,'fr','Workers\' Comp GL',0),(558463,15513,'jp','åŠ´åƒè€…ã® Comp GL',0),(558464,15513,'pt','Comp trabalhadores GL',0),(558465,15513,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð² Comp GL',0),(558466,15513,'es','Comp trabajadores GL',0),(558467,15513,'de','Arbeitnehmer Comp GL',0),(558468,15513,'en','Workers\' Comp GL',0),(558469,15514,'is','',0),(558470,15514,'dr','Ø³Ø§Ù„',0),(558471,15514,'pr','Ø³Ø§Ù„',0),(558472,15514,'tr','YÄ±l',0),(558473,15514,'pl','Yrs',0),(558474,15514,'bg','Yrs',0),(558475,15514,'ur','ÛŒØ§',0),(558476,15514,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð°',0),(558477,15514,'vi','Yrs',0),(558478,15514,'af','JR',0),(558479,15514,'ro','Ani',0),(558480,15514,'et','A.',0),(558481,15514,'si','Let',0),(558482,15514,'ba','Thn',0),(558483,15514,'nl','Yrs',0),(558484,15514,'fi','V',0),(558485,15514,'no','Ã…r',0),(558486,15514,'da','Yrs',0),(558487,15514,'ko','ì„¸',0),(558488,15514,'he','Yrs',0),(558489,15514,'el','Yrs',0),(558490,15514,'zh','å²',0),(558491,15514,'sv','Yrs',0),(558492,15514,'it','(Anni)',0),(558493,15514,'tl','',0),(558494,15514,'th','à¸›à¸µ',0),(558495,15514,'hi','Yrs',0),(558496,15514,'ms','THN',0),(558497,15514,'ar','Ø³Ù†ÙˆØ§Øª',0),(558498,15514,'fr','Ans',0),(558499,15514,'jp','æ­³',0),(558500,15514,'pt','Yrs',0),(558501,15514,'ru','Ð›ÐµÑ‚',0),(558502,15514,'es','AÃ±os',0),(558503,15514,'de','Yrs',0),(558504,15514,'en','Yrs',0),(558505,15515,'is','',0),(558506,15515,'dr','Ù…Ù‚Ø¯Ø§Ø± YTD',0),(558507,15515,'pr','Ù…Ù‚Ø¯Ø§Ø± YTD',0),(558508,15515,'tr','YTD tutar',0),(558509,15515,'pl','Od poczÄ…tku roku kwota',0),(558510,15515,'bg','ÐžÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° ÑÑƒÐ¼Ð°',0),(558511,15515,'ur','ÛŒÙ¹Ø¯ Ø±Ù‚Ù…',0),(558512,15515,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(558513,15515,'vi','Sá»‘ tiá»n YTD',0),(558514,15515,'af','YTD bedrag',0),(558515,15515,'ro','YTD suma',0),(558516,15515,'et','YTD summa',0),(558517,15515,'si','YTD znesek',0),(558518,15515,'ba','Jumlah YTD',0),(558519,15515,'nl','YTD bedrag',0),(558520,15515,'fi','Vuoden alusta mÃ¤Ã¤rÃ¤',0),(558521,15515,'no','YTD belÃ¸p',0),(558522,15515,'da','Ã…TD-belÃ¸b',0),(558523,15515,'ko','YTD ê¸ˆì•¡',0),(558524,15515,'he','×›×ž×•×ª ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(558525,15515,'el','YTD Ï€Î¿ÏƒÏŒ',0),(558526,15515,'zh','YTD é‡‘é¢',0),(558527,15515,'sv','YTD belopp',0),(558528,15515,'it','Importo da inizio anno',0),(558529,15515,'tl','',0),(558530,15515,'th','à¸ˆà¸³à¸™à¸§à¸™ YTD',0),(558531,15515,'hi','YTD à¤°à¤¾à¤¶à¤¿',0),(558532,15515,'ms','Jumlah THK',0),(558533,15515,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(558534,15515,'fr','Montant de la CDA',0),(558535,15515,'jp','ç´¯è¨ˆé¡',0),(558536,15515,'pt','Montante acumulado no ano',0),(558537,15515,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð° ÑÑƒÐ¼Ð¼Ð°',0),(558538,15515,'es','AÃ‘O cantidad',0),(558539,15515,'de','YTD Betrag',0),(558540,15515,'en','YTD Amount',0),(558541,15516,'is','',0),(558542,15516,'dr','Ø¨ÛŒØ´ YTD',0),(558543,15516,'pr','Ø¨ÛŒØ´ YTD',0),(558544,15516,'tr','YTD aÅŸÄ±rÄ±',0),(558545,15516,'pl','Nadmiar OPR',0),(558546,15516,'bg','ÐžÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð¸Ð·Ð»Ð¸ÑˆÑŠÐºÑŠÑ‚',0),(558547,15516,'ur','ÛŒÙ¹Ø¯ Ø°ÛŒØ§Ø¯ØªÛŒ',0),(558548,15516,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð²Ð¸ÑˆÐºÐ°',0),(558549,15516,'vi','YTD dÆ° thá»«a',0),(558550,15516,'af','YTD oortollige',0),(558551,15516,'ro','YTD exces',0),(558552,15516,'et','YTD omavastutuse',0),(558553,15516,'si','YTD preseÅ¾ek',0),(558554,15516,'ba','Kelebihan YTD',0),(558555,15516,'nl','YTD overmaat',0),(558556,15516,'fi','Vuoden alusta yli',0),(558557,15516,'no','YTD overflÃ¸dig',0),(558558,15516,'da','Ã…TD-overskydende',0),(558559,15516,'ko','YTD ì´ˆê³¼',0),(558560,15516,'he','×¢×•×“×£ ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(558561,15516,'el','YTD Ï…Ï€Î­ÏÎ²Î±ÏƒÎ·',0),(558562,15516,'zh','YTD è¿‡å‰©',0),(558563,15516,'sv','YTD Ã¶verskott',0),(558564,15516,'it','Eccesso YTD',0),(558565,15516,'tl','',0),(558566,15516,'th','à¹€à¸à¸´à¸™ YTD',0),(558567,15516,'hi','YTD à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤',0),(558568,15516,'ms','THK lebihan',0),(558569,15516,'ar','ÙØ§Ø¦Ø¶ ÙÙŠ Ø§Ù„ØªØ³Ø¹Ø© Ø£Ø´Ù‡Ø±',0),(558570,15516,'fr','ExcÃ¨s de CDA',0),(558571,15516,'jp','YTD éŽå‰°',0),(558572,15516,'pt','Excesso de acumulado no ano',0),(558573,15516,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð° Ð¿Ñ€ÐµÐ²Ñ‹ÑˆÐµÐ½Ð¸Ðµ',0),(558574,15516,'es','Exceso YTD',0),(558575,15516,'de','YTD Selbstbeteiligung',0),(558576,15516,'en','YTD Excess',0),(558577,15517,'is','',0),(558578,15517,'dr','Ø³Ø§Ø¹Øª YTD',0),(558579,15517,'pr','Ø³Ø§Ø¹Øª YTD',0),(558580,15517,'tr','YTD saat',0),(558581,15517,'pl','Godzin od poczÄ…tku roku',0),(558582,15517,'bg','Ð§Ð°ÑÐ° Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(558583,15517,'ur','ÛŒÙ¹Ø¯ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª',0),(558584,15517,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° ÑÐ°Ñ‚Ð¸',0),(558585,15517,'vi','YTD giá»',0),(558586,15517,'af','YTD ure',0),(558587,15517,'ro','YTD ore',0),(558588,15517,'et','YTD tundi',0),(558589,15517,'si','YTD ur',0),(558590,15517,'ba','YTD jam',0),(558591,15517,'nl','YTD uur',0),(558592,15517,'fi','Vuoden alusta tuntia',0),(558593,15517,'no','Hittil i Ã¥r timer',0),(558594,15517,'da','Ã…TD-timer',0),(558595,15517,'ko','YTD ì‹œê°„',0),(558596,15517,'he','×©×¢×•×ª ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(558597,15517,'el','YTD ÏŽÏÎµÏ‚',0),(558598,15517,'zh','YTD å°æ—¶',0),(558599,15517,'sv','YTD timmar',0),(558600,15517,'it','YTD ore',0),(558601,15517,'tl','',0),(558602,15517,'th','à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡ YTD',0),(558603,15517,'hi','YTD à¤˜à¤‚à¤Ÿà¥‡',0),(558604,15517,'ms','THK jam',0),(558605,15517,'ar','Ø³Ø§Ø¹Ø© Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(558606,15517,'fr','YTD heures',0),(558607,15517,'jp','ç´¯è¨ˆæ™‚é–“',0),(558608,15517,'pt','YTD horas',0),(558609,15517,'ru','YTD Ñ‡Ð°ÑÐ¾Ð²',0),(558610,15517,'es','TOTAL horas',0),(558611,15517,'de','YTD Stunden',0),(558612,15517,'en','YTD Hours',0),(558613,15518,'is','',0),(558614,15518,'dr','Ø­Ø¯Ø§Ú©Ø«Ø± YTD',0),(558615,15518,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± YTD',0),(558616,15518,'tr','YTD Max',0),(558617,15518,'pl','YTD Max',0),(558618,15518,'bg','ÐžÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° ÐœÐ°ÐºÑ',0),(558619,15518,'ur','ÛŒÙ¹Ø¯ Ú©ÛŒ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(558620,15518,'sr','ÐœÐ°x Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(558621,15518,'vi','YTD Max',0),(558622,15518,'af','YTD Max',0),(558623,15518,'ro','YTD Max',0),(558624,15518,'et','YTD Max',0),(558625,15518,'si','YTD Max',0),(558626,15518,'ba','YTD Max',0),(558627,15518,'nl','YTD Max',0),(558628,15518,'fi','Vuoden alusta Max',0),(558629,15518,'no','Hittil i Ã¥r Max',0),(558630,15518,'da','Ã…TD-Max',0),(558631,15518,'ko','YTD ìµœëŒ€',0),(558632,15518,'he','×ž×§×¡ ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(558633,15518,'el','YTD Max',0),(558634,15518,'zh','YTD é©¬å…‹æ–¯',0),(558635,15518,'sv','Hittills i Ã¥r Max',0),(558636,15518,'it','YTD Max',0),(558637,15518,'tl','',0),(558638,15518,'th','à¸ªà¸¹à¸‡à¸ªà¸¸à¸” YTD',0),(558639,15518,'hi','YTD à¤®à¥ˆà¤•à¥à¤¸',0),(558640,15518,'ms','Max THK',0),(558641,15518,'ar','Ù…Ø§ÙƒØ³ Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(558642,15518,'fr','YTD Max',0),(558643,15518,'jp','å¹´åˆæ¥æœ€é«˜',0),(558644,15518,'pt','YTD Max',0),(558645,15518,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð° ÐœÐ°ÐºÑ',0),(558646,15518,'es','TOTAL mÃ¡ximo',0),(558647,15518,'de','YTD Max',0),(558648,15518,'en','YTD Max',0),(558649,15519,'is','',0),(558650,15519,'dr','Ù…Ø§Ù„ÛŒØ§Øª YTD',0),(558651,15519,'pr','Ù…Ø§Ù„ÛŒØ§Øª YTD',0),(558652,15519,'tr','YTD vergi',0),(558653,15519,'pl','Od poczÄ…tku roku podatkowego',0),(558654,15519,'bg','ÐžÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð´Ð°Ð½ÑŠÐº',0),(558655,15519,'ur','ÛŒÙ¹Ø¯ Ù¹ÛŒÚ©Ø³',0),(558656,15519,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(558657,15519,'vi','YTD thuáº¿',0),(558658,15519,'af','YTD belasting',0),(558659,15519,'ro','YTD fiscale',0),(558660,15519,'et','YTD maksu',0),(558661,15519,'si','YTD davka',0),(558662,15519,'ba','YTD pajak',0),(558663,15519,'nl','YTD belasting',0),(558664,15519,'fi','Vuoden alusta veron',0),(558665,15519,'no','YTD skatt',0),(558666,15519,'da','Ã…TD-skat',0),(558667,15519,'ko','YTD ì„¸ê¸ˆ',0),(558668,15519,'he','×ž×¡ ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(558669,15519,'el','YTD Ï†ÏŒÏÎ¿Ï…',0),(558670,15519,'zh','YTD ç¨Ž',0),(558671,15519,'sv','YTD skatt',0),(558672,15519,'it','Da inizio anno fiscale',0),(558673,15519,'tl','',0),(558674,15519,'th','à¸ à¸²à¸©à¸µ YTD',0),(558675,15519,'hi','YTD à¤Ÿà¥ˆà¤•à¥à¤¸',0),(558676,15519,'ms','THK cukai',0),(558677,15519,'ar','Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø© Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠØ©',0),(558678,15519,'fr','Taxe de CDA',0),(558679,15519,'jp','YTD ç¨Ž',0),(558680,15519,'pt','Acumulado no ano fiscal',0),(558681,15519,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð° Ð½Ð°Ð»Ð¾Ð³',0),(558682,15519,'es','TOTAL impuestos',0),(558683,15519,'de','YTD Steuer',0),(558684,15519,'en','YTD Tax',0),(558685,15520,'is','',0),(558686,15520,'dr','YTD Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(558687,15520,'pr','YTD Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(558688,15520,'tr','YTD vergiye tabi',0),(558689,15520,'pl','Od poczÄ…tku roku opodatkowaniu',0),(558690,15520,'bg','ÐžÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾',0),(558691,15520,'ur','ÛŒÙ¹Ø¯ Ø¹Ø§Ø¦Ø¯',0),(558692,15520,'sr','ÐŸÐ»Ð°Ð¶Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(558693,15520,'vi','YTD Taxable',0),(558694,15520,'af','YTD belasbare',0),(558695,15520,'ro','YTD impozabile',0),(558696,15520,'et','YTD maksustatav',0),(558697,15520,'si','YTD davÄni',0),(558698,15520,'ba','YTD pajak',0),(558699,15520,'nl','YTD belastbare',0),(558700,15520,'fi','Vuoden alusta veron',0),(558701,15520,'no','YTD skattepliktig',0),(558702,15520,'da','Ã…TD-afgiftspligtige',0),(558703,15520,'ko','YTD ê³¼ì„¸',0),(558704,15520,'he','×—×™×™×‘ ×‘×ž×¡ ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(558705,15520,'el','YTD Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿',0),(558706,15520,'zh','YTD çº³ç¨Ž',0),(558707,15520,'sv','YTD beskattningsbara',0),(558708,15520,'it','Soggetti passivi da inizio anno',0),(558709,15520,'tl','',0),(558710,15520,'th','à¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µ YTD',0),(558711,15520,'hi','YTD à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯',0),(558712,15520,'ms','Dikenakan cukai THK',0),(558713,15520,'ar','Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø¹Ø§Ù… Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(558714,15520,'fr','YTD taxables',0),(558715,15520,'jp','å¹´åˆæ¥ã®èª²ç¨Ž',0),(558716,15520,'pt','Sujeito passivo acumulado no ano',0),(558717,15520,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð° Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ',0),(558718,15520,'es','AÃ‘O gravable',0),(558719,15520,'de','YTD Steuerpflichtige',0),(558720,15520,'en','YTD Taxable',0),(558721,15521,'is','',0),(558722,15521,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ YTD',0),(558723,15521,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ YTD',0),(558724,15521,'tr','YTD Ã¼cret',0),(558725,15521,'pl','Od poczÄ…tku roku pÅ‚ace',0),(558726,15521,'bg','ÐžÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ',0),(558727,15521,'ur','ÛŒÙ¹Ø¯ Ø§Ø¬Ø±Øª',0),(558728,15521,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð¿Ð»Ð°Ñ‚Ðµ',0),(558729,15521,'vi','YTD lÆ°Æ¡ng',0),(558730,15521,'af','YTD lone',0),(558731,15521,'ro','YTD salariile',0),(558732,15521,'et','YTD palk',0),(558733,15521,'si','YTD plaÄe',0),(558734,15521,'ba','Upah YTD',0),(558735,15521,'nl','YTD lonen',0),(558736,15521,'fi','Vuoden alusta palkat',0),(558737,15521,'no','Hittil i Ã¥r lÃ¸nn',0),(558738,15521,'da','Ã…TD-lÃ¸n',0),(558739,15521,'ko','YTD ìž„ê¸ˆ',0),(558740,15521,'he','×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•× ×©×›×¨',0),(558741,15521,'el','YTD Î¼Î¹ÏƒÎ¸ÏŽÎ½',0),(558742,15521,'zh','YTD å·¥èµ„',0),(558743,15521,'sv','YTD lÃ¶ner',0),(558744,15521,'it','Salari YTD',0),(558745,15521,'tl','',0),(558746,15521,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡ YTD',0),(558747,15521,'hi','YTD à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(558748,15521,'ms','Upah THK',0),(558749,15521,'ar','Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø¹Ø§Ù… Ù„Ù„Ø£Ø¬ÙˆØ±',0),(558750,15521,'fr','Depuis un an salaire',0),(558751,15521,'jp','ç´¯è¨ˆè³ƒé‡‘',0),(558752,15521,'pt','YTD salÃ¡rios',0),(558753,15521,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð° Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(558754,15521,'es','TOTAL salarios',0),(558755,15521,'de','YTD LÃ¶hne',0),(558756,15521,'en','YTD Wages',0),(558757,15522,'is','',0),(558758,15522,'dr','Ú©Ø¯Ù‡Ø§ÛŒ ÙØ¹Ù„ÛŒ Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Comp',0),(558759,15522,'pr','Ú©Ø¯Ù‡Ø§ÛŒ ÙØ¹Ù„ÛŒ Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Comp',0),(558760,15522,'tr','GeÃ§erli iÅŸÃ§i Comp kodlarÄ±',0),(558761,15522,'pl','Kodami komp bieÅ¼Ä…ce pracownikÃ³w',0),(558762,15522,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ†Ð¸ Comp ÐºÐ¾Ð´Ð¾Ð²Ðµ',0),(558763,15522,'ur','Ø­Ø§Ù„ÛŒÛ Ú©Ø§Ø±Ú©Ù†ÙˆÚº Ú©ÛŒ Ú©Ø¹Ù…Ù¾ Ø±Ù…ÙˆØ²',0),(558764,15522,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ñ€Ð°Ð´Ð½Ð¸Ñ‡ÐºÐµ Ð¦Ð¾Ð¼Ð¿ ÑˆÐ¸Ñ„Ñ€Ðµ',0),(558765,15522,'vi','Hiá»‡n nay cÃ´ng nhÃ¢n Comp mÃ£',0),(558766,15522,'af','Huidige werkers se Comp kodes',0),(558767,15522,'ro','Curent muncitorilor Comp coduri',0),(558768,15522,'et','Praegune Workers\' Comp koodid',0),(558769,15522,'si','Trenutni delavcev Comp kode',0),(558770,15522,'ba','Saat ini pekerja Comp kode',0),(558771,15522,'nl','Huidige werknemers Comp Codes',0),(558772,15522,'fi','Nykyisten tyÃ¶ntekijÃ¶iden Comp koodit',0),(558773,15522,'no','Gjeldende Workers\' Comp koder',0),(558774,15522,'da','NuvÃ¦rende arbejdstagernes Comp koder',0),(558775,15522,'ko','í˜„ìž¬ ë…¸ë™ìžì˜ Comp ì½”ë“œ',0),(558776,15522,'he','Comp ×§×•×“×™× ×”×¢×•×‘×“×™× ×”× ×•×›×—×™',0),(558777,15522,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Comp ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚',0),(558778,15522,'zh','å½“å‰å·¥äºº Comp ä»£ç ',0),(558779,15522,'sv','Aktuella arbetstagarnas Comp koder',0),(558780,15522,'it','Codici attuali lavoratori Comp',0),(558781,15522,'tl','',0),(558782,15522,'th','à¸£à¸«à¸±à¸ªà¸„à¹ˆà¸²à¸•à¸­à¸šà¹à¸—à¸™à¸œà¸¹à¹‰à¸›à¸à¸´à¸šà¸±à¸•à¸´à¸‡à¸²à¸™à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(558783,15522,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¶à¥à¤°à¤®à¤¿à¤•à¥‹à¤‚ Comp à¤•à¥‹à¤¡à¥à¤¸',0),(558784,15522,'ms','Kod Comp pekerja semasa',0),(558785,15522,'ar','Ø±Ù…ÙˆØ² Ø´Ø±ÙƒØ§Øª Ø§Ù„Ø¹Ù…Ø§Ù„ Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(558786,15522,'fr','Cours Workers\' Comp Codes',0),(558787,15522,'jp','ç¾åœ¨ã®åŠ´åƒè€…ã®ã‚³ãƒ³ãƒ—ã®ã‚³ãƒ¼ãƒ‰',0),(558788,15522,'pt','CÃ³digos de Comp atual dos trabalhadores',0),(558789,15522,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ðµ Comp ÐºÐ¾Ð´Ñ‹',0),(558790,15522,'es','CÃ³digos de Comp de los trabajadores actuales',0),(558791,15522,'de','Aktuellen Arbeitnehmer Comp-Codes',0),(558792,15522,'en','Current Workers\' Comp Codes',0),(558793,15523,'is','',0),(558794,15523,'dr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Comp Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Ø¨Ø¯ÙˆÙ† ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯',0),(558795,15523,'pr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Comp Ú©Ø§Ø±Ú¯Ø±Ø§Ù† Ø¨Ø¯ÙˆÙ† ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯',0),(558796,15523,'tr','HiÃ§bir iÅŸÃ§i Comp girdi var',0),(558797,15523,'pl','Pracownicy nie komp wpisy istniejÄ…',0),(558798,15523,'bg','Ð¡ÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‚ Ð½Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ†Ð¸ Comp Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(558799,15523,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ø§Ø±Ú©Ù†ÙˆÚº Ú©ÛŒ Ú©Ø¹Ù…Ù¾ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(558800,15523,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð±ÐµÐ· Ñ€Ð°Ð´Ð½Ð¸ÐºÐ° Ð¦Ð¾Ð¼Ð¿',0),(558801,15523,'vi','KhÃ´ng cÃ³ cÃ´ng nhÃ¢n Comp má»¥c tá»“n táº¡i',0),(558802,15523,'af','Geen Workers\' Comp inskrywings bestaan',0),(558803,15523,'ro','IntrÄƒrile de Comp lucrÄƒtorilor nu exista',0),(558804,15523,'et','No tÃ¶Ã¶tajate Comp kanded',0),(558805,15523,'si','Brez delavcev Comp vnosi obstajajo',0),(558806,15523,'ba','Ada tidak ada pekerja Comp entri',0),(558807,15523,'nl','Geen werknemers Comp vermeldingen aanwezig',0),(558808,15523,'fi','Ei ole tyÃ¶ntekijÃ¶iden Comp merkinnÃ¤t',0),(558809,15523,'no','Finnes ingen Workers\' Comp oppfÃ¸ringer',0),(558810,15523,'da','Findes ingen arbejdstagernes Comp poster',0),(558811,15523,'ko','ì•„ë‹ˆ ë…¸ë™ìž Comp í•­ëª© ì¡´ìž¬',0),(558812,15523,'he','×§×™×™×ž×™× ×¢×¨×›×™× Comp ××™×Ÿ ×”×¢×•×‘×“×™×',0),(558813,15523,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ ÎºÎ±Î¼Î¯Î± ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½ Comp ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(558814,15523,'zh','æ²¡æœ‰ä¸€ä¸ªå·¥äººçš„ Comp æ¡ç›®å­˜åœ¨',0),(558815,15523,'sv','Finns ingen arbetstagarnas Comp poster',0),(558816,15523,'it','Comp voci nessun lavoratori esistono',0),(558817,15523,'tl','',0),(558818,15523,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸„à¹ˆà¸²à¸•à¸­à¸šà¹à¸—à¸™à¸œà¸¹à¹‰à¸›à¸à¸´à¸šà¸±à¸•à¸´à¸‡à¸²à¸™à¹„à¸¡à¹ˆà¸¡à¸µ',0),(558819,15523,'hi','à¤•à¥‹à¤ˆ à¤¶à¥à¤°à¤®à¤¿à¤• Comp à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤®à¥Œà¤œà¥‚à¤¦',0),(558820,15523,'ms','Entri Comp pekerja tidak wujud',0),(558821,15523,'ar','Ø§Ù„Ø¹Ù…Ø§Ù„ Ù„Ø§ ØªØ±Ø§ÙƒØ¨ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(558822,15523,'fr','Comp entrÃ©es aucun ouvrier existent',0),(558823,15523,'jp','ãªã„åŠ´åƒè€…ã® Comp ã‚¨ãƒ³ãƒˆãƒªãŒå­˜åœ¨ã—ã¾ã™ã€‚',0),(558824,15523,'pt','Comp entradas nÃ£o hÃ¡ trabalhadores existem',0),(558825,15523,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð½ÐµÑ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ¾Ð² Comp Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(558826,15523,'es','Comp entradas no trabajadores existen',0),(558827,15523,'de','Keine Arbeitnehmer Comp EintrÃ¤ge vorhanden sind',0),(558828,15523,'en','No Workers\' Comp Entries Exist',0),(558829,15524,'is','',0),(558830,15524,'dr','Ù„Ø·ÙØ§ Ú©Ø¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(558831,15524,'pr','Ù„Ø·ÙØ§ Ú©Ø¯ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(558832,15524,'tr','LÃ¼tfen bir kodu girin',0),(558833,15524,'pl','WprowadÅº kod',0),(558834,15524,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ð´',0),(558835,15524,'ur','Ø§ÛŒÚ© Ø¶Ø§Ø¨Ø·Û Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(558836,15524,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ ÑˆÐ¸Ñ„Ñ€Ñƒ',0),(558837,15524,'vi','Xin vui lÃ²ng nháº­p mÃ£',0),(558838,15524,'af','Tik asseblief \'n kode',0),(558839,15524,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un cod de',0),(558840,15524,'et','Palun sisesta kood',0),(558841,15524,'si','Vnesite Å¡ifro',0),(558842,15524,'ba','Harap masukkan kode',0),(558843,15524,'nl','Voer een Code',0),(558844,15524,'fi','Anna koodi',0),(558845,15524,'no','Angi en kode',0),(558846,15524,'da','Angiv en kode',0),(558847,15524,'ko','ì½”ë“œë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(558848,15524,'he','× × ×œ×”×–×™×Ÿ ×§×•×“',0),(558849,15524,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ ÎºÏ‰Î´Î¹ÎºÏŒ',0),(558850,15524,'zh','è¯·è¾“å…¥ä»£ç ',0),(558851,15524,'sv','Ange en kod',0),(558852,15524,'it','Si prega di inserire un codice',0),(558853,15524,'tl','',0),(558854,15524,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸£à¸«à¸±à¸ª',0),(558855,15524,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤•à¥‹à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(558856,15524,'ms','Sila masukkan kod',0),(558857,15524,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù…Ø²',0),(558858,15524,'fr','Veuillez saisir un Code',0),(558859,15524,'jp','ã‚³ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(558860,15524,'pt','Por favor, introduza um cÃ³digo',0),(558861,15524,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ¾Ð´',0),(558862,15524,'es','Introduce un cÃ³digo',0),(558863,15524,'de','Bitte geben Sie einen Code',0),(558864,15524,'en','Please Enter A Code',0),(558865,15525,'is','',0),(558866,15525,'dr','Ù…Ø§Ù„ÛŒØ§Øª ØªØ§Ù…ÛŒÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒ',0),(558867,15525,'pr','Ù…Ø§Ù„ÛŒØ§Øª ØªØ§Ù…ÛŒÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒ',0),(558868,15525,'tr','Sosyal gÃ¼venlik vergisi',0),(558869,15525,'pl','Zabezpieczenia spoÅ‚ecznego podatek',0),(558870,15525,'bg','Ð¡Ð¾Ñ†Ð¸Ð°Ð»ÐµÐ½ Ð´Ð°Ð½ÑŠÐº Ð·Ð° ÑÐ¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚',0),(558871,15525,'ur','Ø³ÙˆØ´Ù„ Ø³ÛŒÚ©ÛŒÙˆØ±Ù¹ÛŒ Ù¹ÛŒÚ©Ø³',0),(558872,15525,'sr','Ð¡Ð¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐµ',0),(558873,15525,'vi','Thuáº¿ an sinh xÃ£ há»™i',0),(558874,15525,'af','Sosiale sekuriteit belasting',0),(558875,15525,'ro','Taxa de securitate socialÄƒ',0),(558876,15525,'et','Sotsiaalmaks',0),(558877,15525,'si','Socialna varnost davek',0),(558878,15525,'ba','Jaminan sosial pajak',0),(558879,15525,'nl','Sociale zekerheid belasting',0),(558880,15525,'fi','Sosiaaliturvamaksun',0),(558881,15525,'no','Arbeidsgiveravgift',0),(558882,15525,'da','Social Security skat',0),(558883,15525,'ko','ì‚¬íšŒ ë³´ìž¥ ì„¸ê¸ˆ',0),(558884,15525,'he','×‘×™×˜×•×— ×œ××•×ž×™',0),(558885,15525,'el','Î¦ÏŒÏÎ¿ ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÎºÎ®Ï‚ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚',0),(558886,15525,'zh','ç¤¾ä¼šä¿éšœç¨Ž',0),(558887,15525,'sv','Social Security Tax',0),(558888,15525,'it','Tassa di previdenza sociale',0),(558889,15525,'tl','',0),(558890,15525,'th','à¸ à¸²à¸©à¸µà¸ªà¸±à¸‡à¸„à¸¡',0),(558891,15525,'hi','à¤¸à¤¾à¤®à¤¾à¤œà¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(558892,15525,'ms','Cukai keselamatan sosial',0),(558893,15525,'ar','Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠ',0),(558894,15525,'fr','SÃ©curitÃ© sociale impÃ´t',0),(558895,15525,'jp','ç¤¾ä¼šä¿éšœç¨Ž',0),(558896,15525,'pt','Imposto de seguranÃ§a social',0),(558897,15525,'ru','Ð¡Ð¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³',0),(558898,15525,'es','Impuesto de seguridad social',0),(558899,15525,'de','Sozialversicherungssteuer',0),(558900,15525,'en','Social Security Tax',0),(558901,15526,'is','',0),(558902,15526,'dr','Ø³Ø§Ø®Øª Ù¾Ø§ÛŒÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡',0),(558903,15526,'pr','Ø³Ø§Ø®Øª Ù¾Ø§ÛŒÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡',0),(558904,15526,'tr','VeritabanÄ± oluÅŸturma',0),(558905,15526,'pl','Budowania bazy danych',0),(558906,15526,'bg','Ð˜Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð±Ð°Ð·Ð° Ð´Ð°Ð½Ð½Ð¸',0),(558907,15526,'ur','ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ Ú©ÛŒ ØªØ¹Ù…ÛŒØ±',0),(558908,15526,'sr','Ð’ÐµÑ€Ð·Ð¸Ñ˜Ð° Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(558909,15526,'vi','XÃ¢y dá»±ng cÆ¡ sá»Ÿ dá»¯ liá»‡u',0),(558910,15526,'af','Databasis bou',0),(558911,15526,'ro','Construi baza de date',0),(558912,15526,'et','Andmebaasi ehitada',0),(558913,15526,'si','Sestavljanje zbirke podatkov',0),(558914,15526,'ba','Membangun database',0),(558915,15526,'nl','Database bouwen',0),(558916,15526,'fi','Tietokannan muodostaminen',0),(558917,15526,'no','Databasen bygge',0),(558918,15526,'da','Database opbygning',0),(558919,15526,'ko','ë°ì´í„°ë² ì´ìŠ¤ ë¹Œë“œ',0),(558920,15526,'he','×œ×‘× ×•×ª ×ž×¡×“ × ×ª×•× ×™×',0),(558921,15526,'el','Î’Î¬ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï„Î¿Ï… Î´ÏŒÎ¼Î·ÏƒÎ·',0),(558922,15526,'zh','æ•°æ®åº“ç”Ÿæˆ',0),(558923,15526,'sv','Databasen bygga',0),(558924,15526,'it','Compilazione di database',0),(558925,15526,'tl','',0),(558926,15526,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(558927,15526,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¬à¤¨à¤¾à¤à¤',0),(558928,15526,'ms','Membina pangkalan data',0),(558929,15526,'ar','Ø¨Ù†Ø§Ø¡ Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª',0),(558930,15526,'fr','Construction de la base de donnÃ©es',0),(558931,15526,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã®ãƒ“ãƒ«ãƒ‰',0),(558932,15526,'pt','CompilaÃ§Ã£o de banco de dados',0),(558933,15526,'ru','ÐŸÐ¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ðµ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(558934,15526,'es','ConstrucciÃ³n de base de datos',0),(558935,15526,'de','Datenbank erstellen',0),(558936,15526,'en','Database Build',0),(558937,15527,'is','',0),(558938,15527,'dr','Ù†Ø³Ø®Ù‡ Ù¾Ø§ÛŒÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(558939,15527,'pr','Ù†Ø³Ø®Ù‡ Ù¾Ø§ÛŒÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(558940,15527,'tr','VeritabanÄ± sÃ¼rÃ¼mÃ¼ yazÄ±lÄ±m eÅŸleÅŸmiyor',0),(558941,15527,'pl','Wersja bazy danych jest niezgodny oprogramowanie',0),(558942,15527,'bg','Ð’ÐµÑ€ÑÐ¸ÑÑ‚Ð° Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ Ð½Ðµ ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð° ÑÐ¾Ñ„Ñ‚ÑƒÐµÑ€',0),(558943,15527,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ ÙˆØ±Ú˜Ù† Ø³Ø§ÙÙ¹ ÙˆÛŒØ¦Ø± Ú©Û’ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº',0),(558944,15527,'sr','Ð’ÐµÑ€Ð·Ð¸Ñ˜Ð° Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐµ ÑÐ¾Ñ„Ñ‚Ð²ÐµÑ€',0),(558945,15527,'vi','PhiÃªn báº£n cÆ¡ sá»Ÿ dá»¯ liá»‡u khÃ´ng phÃ¹ há»£p vá»›i pháº§n má»m',0),(558946,15527,'af','Databasis weergawe sagteware pas nie',0),(558947,15527,'ro','Versiunea bazei de date nu se potriveÅŸte cu software-ul',0),(558948,15527,'et','Andmebaasi versioon ei sobi tarkvara',0),(558949,15527,'si','RazliÄica zbirke podatkov se ne ujema programske opreme',0),(558950,15527,'ba','Database versi tidak cocok dengan perangkat lunak',0),(558951,15527,'nl','Databaseversie niet overeenkomt met Software',0),(558952,15527,'fi','Tietokannan versio ei vastaa ohjelmisto',0),(558953,15527,'no','Databaseversjonen samsvarer ikke med programvare',0),(558954,15527,'da','Databaseversion stemmer ikke overens med Software',0),(558955,15527,'ko','ë°ì´í„°ë² ì´ìŠ¤ ë²„ì „ ì†Œí”„íŠ¸ì›¨ì–´ë¥¼ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(558956,15527,'he','×’×™×¨×¡×” ×œ× ×ª×•××ž×ª ×ª×•×›× ×”',0),(558957,15527,'el','ÎˆÎºÎ´Î¿ÏƒÎ· Ï„Î·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î¼Îµ Î»Î¿Î³Î¹ÏƒÎ¼Î¹ÎºÏŒ',0),(558958,15527,'zh','æ•°æ®åº“ç‰ˆæœ¬ä¸Žè½¯ä»¶ä¸åŒ¹é…',0),(558959,15527,'sv','Databasversionen matchar inte programvara',0),(558960,15527,'it','Versione del database non corrisponde a Software',0),(558961,15527,'tl','',0),(558962,15527,'th','à¹€à¸§à¸­à¸£à¹Œà¸Šà¸±à¸™à¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸•à¸£à¸‡à¸à¸±à¸šà¸‹à¸­à¸Ÿà¸•à¹Œà¹à¸§à¸£à¹Œ',0),(558963,15527,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤¸à¥‰à¤«à¥à¤Ÿà¤µà¥‡à¤¯à¤° à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(558964,15527,'ms','Versi pangkalan data tidak padan dengan perisian',0),(558965,15527,'ar','Ù„Ø§ ÙŠØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ø¥ØµØ¯Ø§Ø± Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¨Ø±Ù†Ø§Ù…Ø¬',0),(558966,15527,'fr','Version de base de donnÃ©es ne correspond pas de logiciel',0),(558967,15527,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã®ãƒãƒ¼ã‚¸ãƒ§ãƒ³ãŒã€ã‚½ãƒ•ãƒˆã‚¦ã‚§ã‚¢ã¨ä¸€è‡´ã—ã¾ã›ã‚“',0),(558968,15527,'pt','VersÃ£o do banco de dados nÃ£o Ã© compatÃ­vel com Software',0),(558969,15527,'ru','Ð’ÐµÑ€ÑÐ¸Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¿Ñ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ð½Ð¾Ð³Ð¾ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ñ',0),(558970,15527,'es','VersiÃ³n de la base de datos no coincide con el Software',0),(558971,15527,'de','Datenbankversion stimmt nicht mit der Software Ã¼berein',0),(558972,15527,'en','Database Version Does Not Match Software',0),(558973,15528,'is','',0),(558974,15528,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø¨Ø³ØªÙ‡ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(558975,15528,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø¨Ø³ØªÙ‡ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(558976,15528,'tr','GÃ¼ncelleÅŸtirme paketini karÅŸÄ±dan yÃ¼kle',0),(558977,15528,'pl','Pobierz pakiet aktualizacji',0),(558978,15528,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÐµÑ‚Ðµ Ð¿Ð°ÐºÐµÑ‚Ð° Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(558979,15528,'ur','Ø§Ù¾ ÚˆÛŒÙ¹ Ù¾ÛŒÚ©Ø¬ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(558980,15528,'sr','ÐžÐ´Ð¼Ð°Ñ… Ð¿Ñ€ÐµÑƒÐ·Ð¼Ð¸Ñ‚Ðµ Ð¿Ð°ÐºÐµÑ‚ Ð¸ÑÐ¿Ñ€Ð°Ð²ÐºÐ¸',0),(558981,15528,'vi','Táº£i xuá»‘ng gÃ³i Cáº­p Nháº­t',0),(558982,15528,'af','Laai bywerking pakket',0),(558983,15528,'ro','DescÄƒrcaÅ£i pachetul de actualizare',0),(558984,15528,'et','Lae Update pakett',0),(558985,15528,'si','Travnato griÄevje modernizirati paket',0),(558986,15528,'ba','Download paket pembaruan',0),(558987,15528,'nl','Updatepakket voor downloaden',0),(558988,15528,'fi','Lataa pÃ¤ivityksen paketti',0),(558989,15528,'no','Last ned oppdateringspakken',0),(558990,15528,'da','Hent opdateringspakken',0),(558991,15528,'ko','ì—…ë°ì´íŠ¸ íŒ¨í‚¤ì§€ ë‹¤ìš´ë¡œë“œ',0),(558992,15528,'he','×”×•×¨×“ ××ª ×—×‘×™×œ×ª ×”×¢×“×›×•×Ÿ',0),(558993,15528,'el','Î†Î¼ÎµÏƒÎ· Î»Î®ÏˆÎ· Ï„Î¿Ï… Ï€Î±ÎºÎ­Ï„Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î·Ï‚ Î­ÎºÎ´Î¿ÏƒÎ·Ï‚',0),(558994,15528,'zh','ä¸‹è½½æ›´æ–°åŒ…',0),(558995,15528,'sv','HÃ¤mta uppdateringspaketet',0),(558996,15528,'it','Scaricare il pacchetto di aggiornamento',0),(558997,15528,'tl','',0),(558998,15528,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹à¸žà¸„à¹€à¸à¸ˆà¹‚à¸›à¸£à¹à¸à¸£à¸¡à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(558999,15528,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥ˆà¤•à¥‡à¤œ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(559000,15528,'ms','Muat turun pakej pengemaskinian',0),(559001,15528,'ar','ØªÙ†Ø²ÙŠÙ„ Ø­Ø²Ù…Ø© Ø§Ù„ØªØ­Ø¯ÙŠØ«',0),(559002,15528,'fr','TÃ©lÃ©charger le Package de mise Ã  jour',0),(559003,15528,'jp','æ›´æ–°ãƒ—ãƒ­ã‚°ãƒ©ãƒ  ãƒ‘ãƒƒã‚±ãƒ¼ã‚¸ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(559004,15528,'pt','Baixe o pacote de atualizaÃ§Ã£o',0),(559005,15528,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ Ð¿Ð°ÐºÐµÑ‚ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(559006,15528,'es','Descargar el paquete de actualizaciÃ³n',0),(559007,15528,'de','Updatepaket herunterladen',0),(559008,15528,'en','Download Update Package',0),(559009,15529,'is','',0),(559010,15529,'dr','Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ù†Ø´ÙˆØ¯',0),(559011,15529,'pr','Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù‡ Ù†Ø´ÙˆØ¯',0),(559012,15529,'tr','Daha gÃ¶sterme',0),(559013,15529,'pl','Nie pokazuj',0),(559014,15529,'bg','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(559015,15529,'ur','Ù¾Ú¾Ø± Ù…Øª Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(559016,15529,'sr','ÐÐµ Ð¿Ñ€Ð¸ÐºÐ°Ð·ÑƒÑ˜ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(559017,15529,'vi','KhÃ´ng hiá»ƒn thá»‹ má»™t láº§n ná»¯a',0),(559018,15529,'af','Weer wys nie',0),(559019,15529,'ro','Nu aratÄƒ din nou',0),(559020,15529,'et','Ã„ra enam kuva',0),(559021,15529,'si','Ne kaÅ¾i veÄ',0),(559022,15529,'ba','Jangan Tampilkan lagi',0),(559023,15529,'nl','Niet meer weergeven',0),(559024,15529,'fi','Ã„lÃ¤ NÃ¤ytÃ¤ uudelleen',0),(559025,15529,'no','Ikke Vis igjen',0),(559026,15529,'da','Vis ikke igen',0),(559027,15529,'ko','ë‹¤ì‹œ í‘œì‹œ í•˜ì§€ ì•ŠìŒ',0),(559028,15529,'he','××œ ×ª×¦×™×’ ×©×•×‘',0),(559029,15529,'el','ÎÎ± Î¼Î·Î½ ÎµÎ¼Ï†Î±Î½Î¹ÏƒÏ„ÎµÎ¯ Î¾Î±Î½Î¬',0),(559030,15529,'zh','ä¸è¦å†æ˜¾ç¤º',0),(559031,15529,'sv','Visa inte igen',0),(559032,15529,'it','Non visualizzare di nuovo',0),(559033,15529,'tl','',0),(559034,15529,'th','à¹„à¸¡à¹ˆà¹à¸ªà¸”à¸‡à¸­à¸µà¸',0),(559035,15529,'hi','à¤«à¤¿à¤° à¤¸à¥‡ à¤¨ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(559036,15529,'ms','Jangan Tunjukkan lagi',0),(559037,15529,'ar','Ù„Ø§ ØªØ¸Ù‡Ø± Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(559038,15529,'fr','Ne montrez pas encore',0),(559039,15529,'jp','ä»Šå¾Œè¡¨ç¤ºã—ã¾ã›ã‚“ã€‚',0),(559040,15529,'pt','NÃ£o mostrar novamente',0),(559041,15529,'ru','ÐÐµ Ð¿Ð¾ÐºÐ°Ð·Ñ‹Ð²Ð°Ñ‚ÑŒ ÑÐ½Ð¾Ð²Ð°',0),(559042,15529,'es','No volver a mostrar',0),(559043,15529,'de','Nicht mehr anzeigen',0),(559044,15529,'en','Do Not Show Again',0),(559045,15530,'is','',0),(559046,15530,'dr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ú©Ù‡ Ø´Ù…Ø§ Ø±Ø§ Ø¨Ù‡ Ø§Ù†Ø¬Ø§Ù… Ø¯Ø³ØªÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(559047,15530,'pr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ú©Ù‡ Ø´Ù…Ø§ Ø±Ø§ Ø¨Ù‡ Ø§Ù†Ø¬Ø§Ù… Ø¯Ø³ØªÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(559048,15530,'tr','Bu bir el ile gÃ¼ncelleÅŸtirme gerÃ§ekleÅŸtirmek tavsiye edilir',0),(559049,15530,'pl','Zalecane jest, Å¼e w przypadku rÄ™cznego aktualizowania',0),(559050,15530,'bg','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑŠÑ‡Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ðµ, Ñ‡Ðµ Ð¸Ð·Ð²ÑŠÑ€ÑˆÐ²Ð°Ñ‚Ðµ Ñ€ÑŠÑ‡Ð½Ð¾ Ð¾Ð±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(559051,15530,'ur','ÛŒÛ Ø³ÙØ§Ø±Ø´ Ú©ÛŒ ÛÛ’ Ú©Û Ø¢Ù¾ Ø§ÛŒÚ© Ø¯Ø³ØªÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø§Ù†Ø¬Ø§Ù… Ø¯Û’',0),(559052,15530,'sr','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑƒÑ‡ÑƒÑ˜Ðµ ÑÐµ Ð´Ð° Ð¸Ð·Ð²Ñ€ÑˆÐ¸Ñ‚Ðµ Ñ€ÑƒÑ‡Ð½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(559053,15530,'vi','ÄÃ³ khuyáº¿n cÃ¡o ráº±ng báº¡n thá»±c hiá»‡n má»™t Cáº­p Nháº­t thá»§ cÃ´ng',0),(559054,15530,'af','Dit word aanbeveel dat jy voer \'n handmatige bywerking',0),(559055,15530,'ro','Se recomandÄƒ cÄƒ veÅ£i efectua o actualizare manualÄƒ',0),(559056,15530,'et','On soovitatav, et te tÃ¤ita kÃ¤sitsi Update',0),(559057,15530,'si','PriporoÄamo, da izvedete roÄno posodobitev',0),(559058,15530,'ba','Dianjurkan bahwa Anda melakukan Manual Update',0),(559059,15530,'nl','Het Is aanbevolen dat u een handmatige Update uitvoeren',0),(559060,15530,'fi','On suositeltavaa suorittaa manuaalinen pÃ¤ivitys',0),(559061,15530,'no','Det anbefales at du utfÃ¸rer en manuell oppdatering',0),(559062,15530,'da','Det anbefales, at du udfÃ¸rer en manuel opdatering',0),(559063,15530,'ko','ìˆ˜ë™ ì—…ë°ì´íŠ¸ë¥¼ ìˆ˜í–‰ í•˜ëŠ” ê²ƒì´ ì¢‹ìŠµë‹ˆë‹¤.',0),(559064,15530,'he','×ž×•×ž×œ×¥ ×œ×‘×¦×¢ ×¢×“×›×•×Ÿ ×™×“× ×™',0),(559065,15530,'el','Î£Ï…Î½Î¹ÏƒÏ„Î¬Ï„Î±Î¹ Î½Î± ÎµÎºÏ„ÎµÎ»Î­ÏƒÎµÏ„Îµ Î¼Î¹Î± Î¼Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(559066,15530,'zh','å»ºè®®æ‚¨æ‰§è¡Œæ‰‹åŠ¨æ›´æ–°',0),(559067,15530,'sv','Det rekommenderas att du utfÃ¶r en manuell uppdatering',0),(559068,15530,'it','Ãˆ consigliabile eseguire un aggiornamento manuale',0),(559069,15530,'tl','',0),(559070,15530,'th','à¸‚à¸­à¹à¸™à¸°à¸™à¸³à¹ƒà¸«à¹‰ à¸„à¸¸à¸“à¸—à¸³à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(559071,15530,'hi','à¤¯à¤¹ à¤…à¤¨à¥à¤¶à¤‚à¤¸à¤¿à¤¤ à¤¹à¥ˆ à¤•à¤¿ à¤†à¤ª à¤à¤• à¤®à¥ˆà¤¨à¥à¤…à¤² à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨',0),(559072,15530,'ms','Adalah disyorkan bahawa anda melakukan kaedah pengemaskinian Manual yang',0),(559073,15530,'ar','Ù…Ù† Ø§Ù„Ù…Ø³ØªØ­Ø³Ù† Ø£Ù† ØªÙ‚ÙˆÙ… ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙŠØ¯ÙˆÙŠ',0),(559074,15530,'fr','Il est recommandÃ© que vous effectuez une mise Ã  jour manuelle',0),(559075,15530,'jp','æ‰‹å‹•æ›´æ–°ã‚’å®Ÿè¡Œã™ã‚‹ã“ã¨ã‚’ãŠå‹§ã‚',0),(559076,15530,'pt','Ã‰ recomendÃ¡vel que vocÃª executar uma atualizaÃ§Ã£o Manual',0),(559077,15530,'ru','Ð ÐµÐºÐ¾Ð¼ÐµÐ½Ð´ÑƒÐµÑ‚ÑÑ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ',0),(559078,15530,'es','Se recomienda realizar una actualizaciÃ³n Manual',0),(559079,15530,'de','Es wird empfohlen, dass Sie ein manuelles Update durchfÃ¼hren',0),(559080,15530,'en','It Is Recommended That You Perform A Manual Update',0),(559081,15531,'is','',0),(559082,15531,'dr','Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø³Ø§Ø®Øª',0),(559083,15531,'pr','Ù†Ø±Ù… Ø§ÙØ²Ø§Ø± Ø³Ø§Ø®Øª',0),(559084,15531,'tr','YazÄ±lÄ±m kurmak',0),(559085,15531,'pl','Kompilacja',0),(559086,15531,'bg','Ð¡Ð¾Ñ„Ñ‚ÑƒÐµÑ€ Ð‘Ð¸Ð»Ð´',0),(559087,15531,'ur','Ø³Ø§ÙÙ¹ ÙˆÛŒØ¦Ø± ØªÛŒØ§Ø±',0),(559088,15531,'sr','Ð’ÐµÑ€Ð·Ð¸Ñ˜Ð° ÑÐ¾Ñ„Ñ‚Ð²ÐµÑ€Ð°',0),(559089,15531,'vi','XÃ¢y dá»±ng pháº§n má»m',0),(559090,15531,'af','Sagteware bou',0),(559091,15531,'ro','Software-ul construit',0),(559092,15531,'et','Tarkvara ehitada',0),(559093,15531,'si','Graditi programske opreme',0),(559094,15531,'ba','Membangun perangkat lunak',0),(559095,15531,'nl','Software bouwen',0),(559096,15531,'fi','Ohjelmisto rakentaa',0),(559097,15531,'no','Programvaren bygge',0),(559098,15531,'da','Softwarestruktur',0),(559099,15531,'ko','ì†Œí”„íŠ¸ì›¨ì–´ ë¹Œë“œ',0),(559100,15531,'he','×’×¨×¡×ª ×ª×•×›× ×”',0),(559101,15531,'el','ÎšÎ±Ï„Î±ÏƒÎºÎµÏ…Î® Î»Î¿Î³Î¹ÏƒÎ¼Î¹ÎºÎ¿Ï',0),(559102,15531,'zh','è½¯ä»¶ç”Ÿæˆ',0),(559103,15531,'sv','Programvarustruktur',0),(559104,15531,'it','Compilazione del software',0),(559105,15531,'tl','',0),(559106,15531,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸‹à¸­à¸Ÿà¸•à¹Œà¹à¸§à¸£à¹Œ',0),(559107,15531,'hi','à¤¸à¥‰à¤«à¥à¤Ÿà¤µà¥‡à¤¯à¤° à¤¬à¤¿à¤²à¥à¤¡',0),(559108,15531,'ms','Membina perisian',0),(559109,15531,'ar','Ø¨Ù†Ø§Ø¡ Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ§Øª',0),(559110,15531,'fr','Logiciel de Build',0),(559111,15531,'jp','ã‚½ãƒ•ãƒˆã‚¦ã‚§ã‚¢ã®ãƒ“ãƒ«ãƒ‰',0),(559112,15531,'pt','CompilaÃ§Ã£o de software',0),(559113,15531,'ru','ÐŸÑ€Ð¾Ð³Ñ€Ð°Ð¼Ð¼Ð½Ð¾Ðµ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ñ',0),(559114,15531,'es','ConstrucciÃ³n de software',0),(559115,15531,'de','Software-Builds',0),(559116,15531,'en','Software Build',0),(559117,15532,'is','',0),(559118,15532,'dr','Ù‡ÛŒÚ† Ø¯ÙˆØ±Ù‡ Ø§ÛŒ Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø²Ù…Ø§Ù†ÛŒ',0),(559119,15532,'pr','Ù‡ÛŒÚ† Ø¯ÙˆØ±Ù‡ Ø§ÛŒ Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø²Ù…Ø§Ù†ÛŒ',0),(559120,15532,'tr','HiÃ§bir dÃ¶nem tarih aralÄ±ÄŸÄ±nda',0),(559121,15532,'pl','Nie okresy w zakres dat.',0),(559122,15532,'bg','ÐÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸ Ð² Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(559123,15532,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø¯ÙˆØ§Ø± Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…ÛŒÚº',0),(559124,15532,'sr','ÐÐµÐ¼Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ñƒ Ð¾Ð¿ÑÐµÐ³ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(559125,15532,'vi','KhÃ´ng cÃ³ thá»i gian trong pháº¡m vi ngÃ y',0),(559126,15532,'af','Geen tydperke In datumbestek',0),(559127,15532,'ro','Nici perioadele Ã®n intervalul de Date',0),(559128,15532,'et','No perioodide kuupÃ¤evavahemik',0),(559129,15532,'si','Ni obdobja v datumskem obsegu',0),(559130,15532,'ba','Periode tidak ada dalam rentang tanggal',0),(559131,15532,'nl','Geen perioden In datumbereik',0),(559132,15532,'fi','Ei ole jaksojen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤alue',0),(559133,15532,'no','Ingen perioder i datointervall',0),(559134,15532,'da','Ingen perioder i datointerval',0),(559135,15532,'ko','ë‚ ì§œ ë²”ìœ„ì— ì—†ëŠ” ê¸°ê°„',0),(559136,15532,'he','××™×Ÿ ×ª×§×•×¤×•×ª ×˜×•×•×— ×ª××¨×™×›×™×',0),(559137,15532,'el','Î”ÎµÎ½ Ï€ÎµÏÎ¹ÏŒÎ´Î¿Ï…Ï‚ ÏƒÎµ ÎµÏÏÎ¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½',0),(559138,15532,'zh','æ—¥æœŸèŒƒå›´å†…çš„ä»»ä½•æ—¶é—´',0),(559139,15532,'sv','Ingen perioder i datumintervall',0),(559140,15532,'it','Non ci sono periodi nell\'intervallo di Date',0),(559141,15532,'tl','',0),(559142,15532,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸­à¸šà¹ƒà¸™à¸Šà¹ˆà¸§à¸‡à¸§à¸±à¸™',0),(559143,15532,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤®à¥‡à¤‚ à¤•à¥‹à¤ˆ à¤ªà¥€à¤°à¤¿à¤¯à¤¡',0),(559144,15532,'ms','Tempoh tidak ada di julat tarikh',0),(559145,15532,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ ÙØªØ±Ø§Øª ÙÙŠ Ù†Ø·Ø§Ù‚ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(559146,15532,'fr','Aucune pÃ©riode de plage de dates',0),(559147,15532,'jp','æ—¥ä»˜ã®ç¯„å›²ã§ãªã„æœŸé–“',0),(559148,15532,'pt','NÃ£o hÃ¡ perÃ­odos no intervalo de datas',0),(559149,15532,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²Ð¸Ðµ ÑƒÐºÐ°Ð·Ð°Ð½Ð¸Ñ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¾Ð² Ð² Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ðµ Ð´Ð°Ñ‚',0),(559150,15532,'es','Ausencia de perÃ­odos en el rango de fechas',0),(559151,15532,'de','Keine Perioden im Datumsbereich',0),(559152,15532,'en','No Periods In Date Range',0),(559153,15533,'is','',0),(559154,15533,'dr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ú©Ù‡ Ø´Ù…Ø§ Ø±Ø§ Ø¨Ù‡ Ø§Ù†Ø¬Ø§Ù… Ø¯Ø³ØªÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(559155,15533,'pr','ØªÙˆØµÛŒÙ‡ Ù…ÛŒ Ø´ÙˆØ¯ Ú©Ù‡ Ø´Ù…Ø§ Ø±Ø§ Ø¨Ù‡ Ø§Ù†Ø¬Ø§Ù… Ø¯Ø³ØªÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(559156,15533,'tr','Bu bir el ile gÃ¼ncelleÅŸtirme gerÃ§ekleÅŸtirmek tavsiye edilir',0),(559157,15533,'pl','Zalecane jest, Å¼e w przypadku rÄ™cznego aktualizowania',0),(559158,15533,'bg','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑŠÑ‡Ð¸Ñ‚ÐµÐ»Ð½Ð¾ Ðµ, Ñ‡Ðµ Ð¸Ð·Ð²ÑŠÑ€ÑˆÐ²Ð°Ñ‚Ðµ Ñ€ÑŠÑ‡Ð½Ð¾ Ð¾Ð±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(559159,15533,'ur','ÛŒÛ Ø³ÙØ§Ø±Ø´ Ú©ÛŒ ÛÛ’ Ú©Û Ø¢Ù¾ Ø§ÛŒÚ© Ø¯Ø³ØªÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø§Ù†Ø¬Ø§Ù… Ø¯Û’',0),(559160,15533,'sr','ÐŸÑ€ÐµÐ¿Ð¾Ñ€ÑƒÑ‡ÑƒÑ˜Ðµ ÑÐµ Ð´Ð° Ð¸Ð·Ð²Ñ€ÑˆÐ¸Ñ‚Ðµ Ñ€ÑƒÑ‡Ð½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(559161,15533,'vi','ÄÃ³ khuyáº¿n cÃ¡o ráº±ng báº¡n thá»±c hiá»‡n má»™t Cáº­p Nháº­t thá»§ cÃ´ng',0),(559162,15533,'af','Dit word aanbeveel dat jy voer \'n handmatige bywerking',0),(559163,15533,'ro','Se recomandÄƒ cÄƒ veÅ£i efectua o actualizare manualÄƒ',0),(559164,15533,'et','On soovitatav, et te tÃ¤ita kÃ¤sitsi Update',0),(559165,15533,'si','PriporoÄamo, da izvedete roÄno posodobitev',0),(559166,15533,'ba','Dianjurkan bahwa Anda melakukan Manual Update',0),(559167,15533,'nl','Het Is aanbevolen dat u een handmatige Update uitvoeren',0),(559168,15533,'fi','On suositeltavaa suorittaa manuaalinen pÃ¤ivitys',0),(559169,15533,'no','Det anbefales at du utfÃ¸rer en manuell oppdatering',0),(559170,15533,'da','Det anbefales, at du udfÃ¸rer en manuel opdatering',0),(559171,15533,'ko','ìˆ˜ë™ ì—…ë°ì´íŠ¸ë¥¼ ìˆ˜í–‰ í•˜ëŠ” ê²ƒì´ ì¢‹ìŠµë‹ˆë‹¤.',0),(559172,15533,'he','×ž×•×ž×œ×¥ ×œ×‘×¦×¢ ×¢×“×›×•×Ÿ ×™×“× ×™',0),(559173,15533,'el','Î£Ï…Î½Î¹ÏƒÏ„Î¬Ï„Î±Î¹ Î½Î± ÎµÎºÏ„ÎµÎ»Î­ÏƒÎµÏ„Îµ Î¼Î¹Î± Î¼Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(559174,15533,'zh','å»ºè®®æ‚¨æ‰§è¡Œæ‰‹åŠ¨æ›´æ–°',0),(559175,15533,'sv','Det rekommenderas att du utfÃ¶r en manuell uppdatering',0),(559176,15533,'it','Ãˆ consigliabile eseguire un aggiornamento manuale',0),(559177,15533,'tl','',0),(559178,15533,'th','à¸‚à¸­à¹à¸™à¸°à¸™à¸³à¹ƒà¸«à¹‰ à¸„à¸¸à¸“à¸—à¸³à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(559179,15533,'hi','à¤¯à¤¹ à¤…à¤¨à¥à¤¶à¤‚à¤¸à¤¿à¤¤ à¤¹à¥ˆ à¤•à¤¿ à¤†à¤ª à¤à¤• à¤®à¥ˆà¤¨à¥à¤…à¤² à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨',0),(559180,15533,'ms','Adalah disyorkan bahawa anda melakukan kaedah pengemaskinian Manual yang',0),(559181,15533,'ar','Ù…Ù† Ø§Ù„Ù…Ø³ØªØ­Ø³Ù† Ø£Ù† ØªÙ‚ÙˆÙ… ØªØ­Ø¯ÙŠØ« Ø§Ù„ÙŠØ¯ÙˆÙŠ',0),(559182,15533,'fr','Il est recommandÃ© que vous effectuez une mise Ã  jour manuelle',0),(559183,15533,'jp','æ‰‹å‹•æ›´æ–°ã‚’å®Ÿè¡Œã™ã‚‹ã“ã¨ã‚’ãŠå‹§ã‚',0),(559184,15533,'pt','Ã‰ recomendÃ¡vel que vocÃª executar uma atualizaÃ§Ã£o Manual',0),(559185,15533,'ru','Ð ÐµÐºÐ¾Ð¼ÐµÐ½Ð´ÑƒÐµÑ‚ÑÑ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ',0),(559186,15533,'es','Se recomienda realizar una actualizaciÃ³n Manual',0),(559187,15533,'de','Es wird empfohlen, dass Sie ein manuelles Update durchfÃ¼hren',0),(559188,15533,'en','It Is Recommended That You Perform A Manual Update',0),(559189,15534,'is','',0),(559190,15534,'dr','Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¯Ø³ØªÙˆØ± Ø¯Ø§Ø¯',0),(559191,15534,'pr','Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¯Ø³ØªÙˆØ± Ø¯Ø§Ø¯',0),(559192,15534,'tr','EmrettiÄŸiniz gibi',0),(559193,15534,'pl','Jak zamÃ³wiÄ‡',0),(559194,15534,'bg','Ð¢ÑŠÐ¹ ÐºÐ°Ñ‚Ð¾ Ð¿Ð¾Ð´Ñ€ÐµÐ´ÐµÐ½Ð¸',0),(559195,15534,'ur','Ø¢Ø±ÚˆØ± Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚',0),(559196,15534,'sr','ÐšÐ°Ð¾ ÑˆÑ‚Ð¾ Ñ˜Ðµ Ð½Ð°Ñ€ÐµÐ´Ð¸Ð¾',0),(559197,15534,'vi','Theo lá»‡nh',0),(559198,15534,'af','Soos bestel',0),(559199,15534,'ro','DupÄƒ cum a ordonat',0),(559200,15534,'et','Tellituna',0),(559201,15534,'si','NaroÄenimi',0),(559202,15534,'ba','Seperti yang diperintahkan',0),(559203,15534,'nl','Zoals besteld',0),(559204,15534,'fi','On tilannut',0),(559205,15534,'no','Som bestilt',0),(559206,15534,'da','Som bestilt',0),(559207,15534,'ko','ì£¼ë¬¸',0),(559208,15534,'he','×›×¤×™ ×©×¦×™×•×•×™×ª',0),(559209,15534,'el','Î£ÏÎ¼Ï†Ï‰Î½Î± Î¼Îµ Ï„Î·Î½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(559210,15534,'zh','å¦‚è®¢è´­',0),(559211,15534,'sv','Som bestÃ¤llt',0),(559212,15534,'it','Come ordinato',0),(559213,15534,'tl','',0),(559214,15534,'th','à¸„à¸³à¸ªà¸±à¹ˆà¸‡',0),(559215,15534,'hi','à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤†à¤¦à¥‡à¤¶ à¤¦à¤¿à¤¯à¤¾',0),(559216,15534,'ms','Yang diarahkan',0),(559217,15534,'ar','ÙƒÙ…Ø§ Ø£Ù…Ø±Øª',0),(559218,15534,'fr','Comme l\'a ordonnÃ©',0),(559219,15534,'jp','ãªã£ã¦ãŠã‚Šã¾ã™',0),(559220,15534,'pt','Como ordenado',0),(559221,15534,'ru','ÐšÐ°Ðº Ð·Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ',0),(559222,15534,'es','SegÃºn lo ordenado',0),(559223,15534,'de','Wie bestellt',0),(559224,15534,'en','As Ordered',0),(559225,15535,'is','',0),(559226,15535,'dr','Ù‚Ø§Ù„Ø¨ Ø¬Ø¯ÙˆÙ„ Ú†Ú© Ù„ÛŒØ³Øª ØµÙ†Ø¯ÙˆÙ‚',0),(559227,15535,'pr','Ù‚Ø§Ù„Ø¨ Ø¬Ø¯ÙˆÙ„ Ú†Ú© Ù„ÛŒØ³Øª ØµÙ†Ø¯ÙˆÙ‚',0),(559228,15535,'tr','PO denetim listesi tablo biÃ§iminde',0),(559229,15535,'pl','PO liÅ›cie kontrolnej Format tabeli',0),(559230,15535,'bg','PO ÑÐ¿Ð¸ÑÑŠÐº Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(559231,15535,'ur','Ù¾Ùˆ ÙÛØ±Ø³Øª Ø¬Ø¯ÙˆÙ„ ÙˆØ¶Ø¹ Ú©Ø±ÛŒÚº',0),(559232,15535,'sr','ÐžÐ±Ð»Ð¸Ðº Ñ‚Ð°Ð±ÐµÐ»Ðµ ÐŸÐž ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»Ð½Ðµ Ð»Ð¸ÑÑ‚Ðµ',0),(559233,15535,'vi','Äá»‹nh dáº¡ng báº£ng danh sÃ¡ch kiá»ƒm tra PO',0),(559234,15535,'af','Posbus kontrolelys tabel formaat',0),(559235,15535,'ro','Format de tabel listÄƒ de verificare PO',0),(559236,15535,'et','PO kontrollnimekirja tabelivormingus',0),(559237,15535,'si','PO kontrolni seznam v obliki tabele',0),(559238,15535,'ba','Format Tabel daftar PO',0),(559239,15535,'nl','PO controlelijst tabelindeling',0),(559240,15535,'fi','PO tarkistuslista taulukkomuodossa',0),(559241,15535,'no','PO Sjekkliste tabellformat',0),(559242,15535,'da','PO tjekliste tabelformat',0),(559243,15535,'ko','í¬ ê²€ì‚¬ ëª©ë¡ í…Œì´ë¸” í˜•ì‹',0),(559244,15535,'he','×¢×™×¦×•×‘ ×˜×‘×œ×” ×¨×©×™×ž×ª ×¤×¢×•×œ×•×ª ×œ×‘×™×¦×•×¢ ×©×œ ×¤×•',0),(559245,15535,'el','PO Î¼Î¿ÏÏ†Î® Ï€Î¯Î½Î±ÎºÎ± Ï€Î¯Î½Î±ÎºÎ±Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(559246,15535,'zh','è’²æ¸…å•è¡¨æ ¼æ ¼å¼',0),(559247,15535,'sv','PO checklista tabellformat',0),(559248,15535,'it','Formato tabella Checklist di PO',0),(559249,15535,'tl','',0),(559250,15535,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¸•à¸²à¸£à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š PO',0),(559251,15535,'hi','PO à¤šà¥‡à¤•à¤²à¤¿à¤¸à¥à¤Ÿ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(559252,15535,'ms','PO semak Jadual Format',0),(559253,15535,'ar','Øµ. Ø¨ Ù‚Ø§Ø¦Ù…Ø© ØªÙ†Ø³ÙŠÙ‚ Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(559254,15535,'fr','Format de tableau aide-mÃ©moire PO',0),(559255,15535,'jp','PO ãƒã‚§ãƒƒã‚¯ãƒªã‚¹ãƒˆè¡¨ãƒ•ã‚©ãƒ¼ãƒžãƒƒãƒˆ',0),(559256,15535,'pt','Formato de tabela de lista de verificaÃ§Ã£o de PO',0),(559257,15535,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹ ÐºÐ¾Ð½Ñ‚Ñ€Ð¾Ð»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¸ÑÐ¾Ðº PO',0),(559258,15535,'es','Formato de tabla de lista de PO',0),(559259,15535,'de','PO-Checkliste-Tabellenformat',0),(559260,15535,'en','PO Checklist Table Format',0),(559261,15536,'is','',0),(559262,15536,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¬Ø¹Ø¨Ù‡ ØªØ§Ø±ÛŒØ® Ø®Ø· Ù…ÙˆØ±Ø¯',0),(559263,15536,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¬Ø¹Ø¨Ù‡ ØªØ§Ø±ÛŒØ® Ø®Ø· Ù…ÙˆØ±Ø¯',0),(559264,15536,'tr','SatÄ±r Ã¶ÄŸesi tarihini gÃ¶rÃ¼ntÃ¼le kutusunu',0),(559265,15536,'pl','Pole daty wyÅ›wietlania elementu zamÃ³wienia',0),(559266,15536,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ÐµÐ½Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð° ÐºÑƒÑ‚Ð¸Ñ',0),(559267,15536,'ur','ÚˆØ³Ù¾Ù„Û’ Ù„Ø§Ø¦Ù† Ø´Û’ ØªØ§Ø±ÛŒØ® Ø®Ø§Ù†Û',0),(559268,15536,'sr','ÐŸÐ¾Ñ™Ðµ Ð·Ð° Ð´Ð°Ñ‚ÑƒÐ¼ ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÐ´Ð¼ÐµÑ‚Ð°',0),(559269,15536,'vi','Hiá»ƒn thá»‹ chi tiáº¿t Ä‘Æ¡n hÃ ng ngÃ y há»™p',0),(559270,15536,'af','Lyn-Item datum vertoonkas',0),(559271,15536,'ro','AfiÅŸare element rÃ¢nd data Box',0),(559272,15536,'et','Kuva Ã¼ksuse alguskuupÃ¤eva vÃ¤ljale',0),(559273,15536,'si','Zaslonu vrstiÄno postavko datumsko polje',0),(559274,15536,'ba','Tampilan Item baris tanggal kotak',0),(559275,15536,'nl','Weergave regelitem datumvak',0),(559276,15536,'fi','NÃ¤ytÃ¤ rivinimikkeen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n valinta',0),(559277,15536,'no','Vis linjeelementet boksen',0),(559278,15536,'da','Afkrydsningsfeltet Vis post dato',0),(559279,15536,'ko','ë””ìŠ¤í”Œë ˆì´ í•­ëª© ë‚ ì§œ ìƒìž',0),(559280,15536,'he','×ª×¦×•×’×ª ×¤×¨×™×˜ ×©×•×¨×” ×ª×™×‘×ª ×ª××¨×™×š',0),(559281,15536,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Î»Î±Î¹ÏƒÎ¯Î¿Ï… Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(559282,15536,'zh','æ˜¾ç¤ºè¡Œé¡¹ç›®æ—¥æœŸæ¡†',0),(559283,15536,'sv','Kryssrutan Visa radartikeln datum',0),(559284,15536,'it','Casella di visualizzazione elemento riga data',0),(559285,15536,'tl','',0),(559286,15536,'th','à¸à¸¥à¹ˆà¸­à¸‡à¹à¸ªà¸”à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸§à¸±à¸™',0),(559287,15536,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¬à¥‰à¤•à¥à¤¸ à¤°à¥‡à¤–à¤¾ à¤†à¤‡à¤Ÿà¤®',0),(559288,15536,'ms','Paparan baris Perkara tarikh Peti',0),(559289,15536,'ar','Ø¹Ø±Ø¶ Ø¨Ù†Ø¯ ØªØ§Ø±ÙŠØ® Ù…Ø±Ø¨Ø¹',0),(559290,15536,'fr','Ligne de facturation Date prÃ©sentoir',0),(559291,15536,'jp','è¡¨ç¤ºé …ç›®ã®æ—¥ä»˜ãƒœãƒƒã‚¯ã‚¹',0),(559292,15536,'pt','Caixa de data de Item de linha de exposiÃ§Ã£o',0),(559293,15536,'ru','ÐŸÐ¾Ð»Ðµ Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ ÑÑ‚Ñ€Ð¾ÐºÐ¸ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(559294,15536,'es','Pantalla partida fecha caja',0),(559295,15536,'de','Einzelposten Datum-Aufsteller',0),(559296,15536,'en','Display Line Item Date Box',0),(559297,15537,'is','',0),(559298,15537,'dr','Ù†Ù…Ø§ÛŒØ´ Ø²Ù…ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø³ÙØ§Ø±Ø´ÛŒ Ù‚Ø¨Ù„ Ø§Ø² ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(559299,15537,'pr','Ù†Ù…Ø§ÛŒØ´ Ø²Ù…ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø³ÙØ§Ø±Ø´ÛŒ Ù‚Ø¨Ù„ Ø§Ø² ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(559300,15537,'tr','Notlar Ã¶nce Ã¶zel alanlarÄ± gÃ¶ster',0),(559301,15537,'pl','PokaÅ¼ pola niestandardowe przed notatki',0),(559302,15537,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð° Ð¿Ñ€ÐµÐ´Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(559303,15537,'ur','Ù†ÙˆÙ¹ Ø³Û’ Ù‚Ø¨Ù„ Ø§Ù¾Ù†ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù‚Ø·Ø¹Ø§Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(559304,15537,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð¾Ð³ Ð¿Ð¾Ñ™Ð° Ð¿Ñ€Ðµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(559305,15537,'vi','Hiá»ƒn thá»‹ cÃ¡c lÄ©nh vá»±c tÃ¹y chá»‰nh trÆ°á»›c khi ghi chÃº',0),(559306,15537,'af','Pasgemaakte velde voor notas toon',0),(559307,15537,'ro','AfiÈ™aÈ›i cÃ¢mpurile personalizate Ã®nainte de note',0),(559308,15537,'et','Kohandatud vÃ¤ljade enne mÃ¤rkmete kuvamine',0),(559309,15537,'si','PokaÅ¾i polja po meri pred opombe',0),(559310,15537,'ba','Menunjukkan bidang kustom sebelum catatan',0),(559311,15537,'nl','Aangepaste velden voor notities weergeven',0),(559312,15537,'fi','NÃ¤ytÃ¤ mukautetut kentÃ¤t ennen Notes',0),(559313,15537,'no','Vis egendefinerte felt fÃ¸r notater',0),(559314,15537,'da','Vis brugerdefinerede felter fÃ¸r noter',0),(559315,15537,'ko','ë…¸íŠ¸ í•˜ê¸° ì „ì— ì‚¬ìš©ìž ì •ì˜ í•„ë“œ í‘œì‹œ',0),(559316,15537,'he','×”×¦×’ ×©×“×•×ª ×ž×•×ª××ž×™× ××™×©×™×ª ×œ×¤× ×™ ×”×¢×¨×•×ª',0),(559317,15537,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Ï‰Î½ Ï€ÎµÎ´Î¯Ï‰Î½ Ï€ÏÎ¹Î½ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(559318,15537,'zh','æ˜¾ç¤ºè‡ªå®šä¹‰å­—æ®µä¹‹å‰æ³¨æ„åˆ°',0),(559319,15537,'sv','Visa anpassade fÃ¤lt fÃ¶r anteckningar',0),(559320,15537,'it','Visualizza campi personalizzati prima di note',0),(559321,15537,'tl','',0),(559322,15537,'th','à¹à¸ªà¸”à¸‡à¹€à¸‚à¸•à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹à¸šà¸šà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡à¸à¹ˆà¸­à¸™à¸šà¸±à¸™à¸—à¸¶à¸',0),(559323,15537,'hi','à¤¨à¥‹à¤Ÿà¥‹à¤‚ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤•à¤¸à¥à¤Ÿà¤® à¤«à¤¼à¥€à¤²à¥à¤¡ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(559324,15537,'ms','Menunjukkan bidang adat sebelum Nota-Nota',0),(559325,15537,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ø®ØµØµØ© Ù‚Ø¨Ù„ Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª',0),(559326,15537,'fr','Afficher des champs personnalisÃ©s avant Notes',0),(559327,15537,'jp','ãƒ¡ãƒ¢å‰ã«ã‚«ã‚¹ã‚¿ãƒ  ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(559328,15537,'pt','Mostrar campos personalizados antes de notas',0),(559329,15537,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ð¿Ð¾Ð»Ñ Ð¿ÐµÑ€ÐµÐ´ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(559330,15537,'es','Mostrar campos personalizados antes de notas',0),(559331,15537,'de','Benutzerdefinierte Felder bevor Banknoten zeigen',0),(559332,15537,'en','Show Custom Fields Before Notes',0),(559333,15538,'is','',0),(559334,15538,'dr','Ú©Ù„Ø§Ø³ Ù‡Ø§ÛŒ Ù…Ø§Ù„ÛŒØ§ØªÛŒ',0),(559335,15538,'pr','Ú©Ù„Ø§Ø³ Ù‡Ø§ÛŒ Ù…Ø§Ù„ÛŒØ§ØªÛŒ',0),(559336,15538,'tr','Vergi sÄ±nÄ±flar',0),(559337,15538,'pl','Klasy podatkowe',0),(559338,15538,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ ÐºÐ»Ð°ÑÐ¾Ð²Ðµ',0),(559339,15538,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ú©Ù„Ø§Ø³ÛŒÚº',0),(559340,15538,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€ÐµÐ´Ð°Ð²Ð°ÑšÐ°',0),(559341,15538,'vi','CÃ¡c lá»›p há»c thuáº¿',0),(559342,15538,'af','Belasting klasse',0),(559343,15538,'ro','Clasele de impozit',0),(559344,15538,'et','Maksu klassid',0),(559345,15538,'si','DavÄni razredi',0),(559346,15538,'ba','Pajak Classes',0),(559347,15538,'nl','Belasting klassen',0),(559348,15538,'fi','Veroluokkaan',0),(559349,15538,'no','Skatt klasser',0),(559350,15538,'da','Skat klasser',0),(559351,15538,'ko','ì„¸ê¸ˆ í´ëž˜ìŠ¤',0),(559352,15538,'he','×©×™×¢×•×¨×™ ×”×ž×¡',0),(559353,15538,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ­Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(559354,15538,'zh','ç¨Žæ”¶ç±»',0),(559355,15538,'sv','Skatt-klasser',0),(559356,15538,'it','Codici categoria di imposta',0),(559357,15538,'tl','',0),(559358,15538,'th','à¹€à¸£à¸µà¸¢à¸™à¸ à¸²à¸©à¸µ',0),(559359,15538,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¤•à¥à¤·à¤¾à¤à¤‚',0),(559360,15538,'ms','Kelas cukai',0),(559361,15538,'ar','ÙØ¦Ø§Øª Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(559362,15538,'fr','Classes d\'impÃ´t',0),(559363,15538,'jp','ç¨Žé‡‘ã®ã‚¯ãƒ©ã‚¹',0),(559364,15538,'pt','Classes de impostos',0),(559365,15538,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ ÐºÐ»Ð°ÑÑÑ‹',0),(559366,15538,'es','Clases de impuestos',0),(559367,15538,'de','Steuerklassen',0),(559368,15538,'en','Tax Classes',0),(559369,15539,'is','',0),(559370,15539,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ú©Ù„Ø§Ø³ Ù…Ø§Ù„ÛŒØ§Øª',0),(559371,15539,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ú©Ù„Ø§Ø³ Ù…Ø§Ù„ÛŒØ§Øª',0),(559372,15539,'tr','VarsayÄ±lan vergi sÄ±nÄ±fÄ±',0),(559373,15539,'pl','DomyÅ›lna klasa podatku',0),(559374,15539,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð´Ð°Ð½ÑŠÐº ÐºÐ»Ð°Ñ',0),(559375,15539,'ur','Ø·Û’ Ø´Ø¯Û Ù¹ÛŒÚ©Ø³ Ú©Ù„Ø§Ø³',0),(559376,15539,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· ÐºÐ»Ð°ÑÐµ',0),(559377,15539,'vi','Máº·c Ä‘á»‹nh thuáº¿ lá»›p',0),(559378,15539,'af','Verstek belasting klas',0),(559379,15539,'ro','Clasa de impozitare implicit',0),(559380,15539,'et','Vaikimisi maksu klass',0),(559381,15539,'si','Privzeti davÄni razred',0),(559382,15539,'ba','Standar pajak kelas',0),(559383,15539,'nl','Standaard belasting klasse',0),(559384,15539,'fi','Oletusluokan vero',0),(559385,15539,'no','Standard mva-klassen',0),(559386,15539,'da','Standard skat klasse',0),(559387,15539,'ko','ê¸°ë³¸ ì„¸ê¸ˆ í´ëž˜ìŠ¤',0),(559388,15539,'he','×ž×—×œ×§×ª ×”×ž×¡ ×”×ž×•×’×“×¨×ª ×›×‘×¨×™×¨×ª ×ž×—×“×œ',0),(559389,15539,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎºÎ»Î¬ÏƒÎ· Ï†ÏŒÏÎ¿Ï…',0),(559390,15539,'zh','é»˜è®¤ç¨Žç±»',0),(559391,15539,'sv','Standardklass fÃ¶r skatt',0),(559392,15539,'it','Codice categoria di imposta predefinito',0),(559393,15539,'tl','',0),(559394,15539,'th','à¹€à¸£à¸µà¸¢à¸™à¸ à¸²à¸©à¸µà¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(559395,15539,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤µà¤°à¥à¤—',0),(559396,15539,'ms','Kelas cukai lalai',0),(559397,15539,'ar','ÙØ¦Ø© Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(559398,15539,'fr','CatÃ©gorie d\'imposition par dÃ©faut',0),(559399,15539,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆç¨Žã‚¯ãƒ©ã‚¹',0),(559400,15539,'pt','Classe de fiscal padrÃ£o',0),(559401,15539,'ru','ÐšÐ»Ð°ÑÑ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð½Ð°Ð»Ð¾Ð³',0),(559402,15539,'es','Clase de impuesto por defecto',0),(559403,15539,'de','Standard-Steuerklasse',0),(559404,15539,'en','Default Tax Class',0),(559405,15540,'is','',0),(559406,15540,'dr','ÙØ±Ø§Ø± Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ú©Ù„Ø§Ø³',0),(559407,15540,'pr','ÙØ±Ø§Ø± Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ú©Ù„Ø§Ø³',0),(559408,15540,'tr','Vergi sÄ±nÄ±fÄ± tarafÄ±ndan patlak',0),(559409,15540,'pl','PrzebiÄ‡ przez klasy podatkowej',0),(559410,15540,'bg','Ð˜Ð·Ð±ÑƒÑ…Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº ÐºÐ»Ð°Ñ',0),(559411,15540,'ur','Ù¹ÛŒÚ©Ø³ Ø·Ø¨Ù‚Û’ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªÙˆÚ‘',0),(559412,15540,'sr','Ð˜Ð·Ð±Ð°Ð²Ð¸Ñ‚Ð¸ Ð¾Ð´ Ð¿Ð¾Ñ€ÐµÐ·Ð° ÐºÐ»Ð°ÑÐµ',0),(559413,15540,'vi','ThoÃ¡t ra khá»i bá»Ÿi thuáº¿ lá»›p',0),(559414,15540,'af','Breek deur belasting klas',0),(559415,15540,'ro','Pauza de impozit clasa',0),(559416,15540,'et','Keda see maks puhkeb',0),(559417,15540,'si','Izbruhne po davÄnih razredih',0),(559418,15540,'ba','Keluar oleh pajak kelas',0),(559419,15540,'nl','Break Out door fiscale klasse',0),(559420,15540,'fi','Puhkeaa vero-luokka',0),(559421,15540,'no','Bryte ut av skatt',0),(559422,15540,'da','Bryde ud af skat klasse',0),(559423,15540,'ko','ì„¸ í´ëž˜ìŠ¤ì— ì˜í•´ íƒˆì¶œ',0),(559424,15540,'he','×œ×¤×¨×•×¥ ×”×—×•×¦×” ×¢×œ ×™×“×™ ×ž×—×œ×§×” ×ž×¡',0),(559425,15540,'el','ÎžÎµÏƒÏ€Î¬ÏƒÎµÎ¹ Î±Ï€ÏŒ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Ï„Î¬Î¾Î·',0),(559426,15540,'zh','ç”±ç¨Žç±»çˆ†å‘',0),(559427,15540,'sv','Bryta ut skatt klassvis',0),(559428,15540,'it','Uscire dal codice categoria di imposta',0),(559429,15540,'tl','',0),(559430,15540,'th','à¹à¸šà¹ˆà¸‡à¸­à¸­à¸à¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸—à¸ à¸²à¸©à¸µ',0),(559431,15540,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¥à¤²à¤¾à¤¸ à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤¤à¥‹à¤¡à¤¼',0),(559432,15540,'ms','Tercetus oleh kelas cukai',0),(559433,15540,'ar','Ø§Ù„Ø®Ø±ÙˆØ¬ Ù…Ù† ÙØ¦Ø© Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(559434,15540,'fr','Sortir de la catÃ©gorie d\'imposition',0),(559435,15540,'jp','ç¨Žã‚¯ãƒ©ã‚¹ã§æŠœã‘å‡ºã™',0),(559436,15540,'pt','Sair por classe fiscal',0),(559437,15540,'ru','Ð’Ñ‹Ñ€Ð²Ð°Ñ‚ÑŒÑÑ Ð¸Ð· Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ð¾Ð¹ ÐºÐ»Ð°ÑÑÐ¾Ð¼',0),(559438,15540,'es','Romper por clase de impuestos',0),(559439,15540,'de','Ausbrechen von Steuerklasse',0),(559440,15540,'en','Break Out By Tax Class',0),(559441,15541,'is','',0),(559442,15541,'dr','Ù…Ù‚Ø¯Ø§Ø± Ú©Ù„Ø§Ø³',0),(559443,15541,'pr','Ù…Ù‚Ø¯Ø§Ø± Ú©Ù„Ø§Ø³',0),(559444,15541,'tr','SÄ±nÄ±f tutar',0),(559445,15541,'pl','Kwota Klasa',0),(559446,15541,'bg','ÐšÐ»Ð°Ñ Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(559447,15541,'ur','Ú©Ù„Ø§Ø³ Ú©ÛŒ Ø±Ù‚Ù…',0),(559448,15541,'sr','ÐšÐ»Ð°ÑÐ° Ð¸Ð·Ð½Ð¾Ñ',0),(559449,15541,'vi','Sá»‘ lÆ°á»£ng lá»›p há»c',0),(559450,15541,'af','Klas bedrag',0),(559451,15541,'ro','Clasa suma',0),(559452,15541,'et','Klassi suurus',0),(559453,15541,'si','Razred znesek',0),(559454,15541,'ba','Jumlah kelas',0),(559455,15541,'nl','Klasse bedrag',0),(559456,15541,'fi','Luokan mÃ¤Ã¤rÃ¤',0),(559457,15541,'no','Klassen belÃ¸p',0),(559458,15541,'da','Klasse belÃ¸b',0),(559459,15541,'ko','í´ëž˜ìŠ¤ ê¸ˆì•¡',0),(559460,15541,'he','×¡×›×•× ×©×™×¢×•×¨',0),(559461,15541,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Ï€Î¿ÏƒÏŒ',0),(559462,15541,'zh','ç±»é‡',0),(559463,15541,'sv','Klass belopp',0),(559464,15541,'it','QuantitÃ  di classe',0),(559465,15541,'tl','',0),(559466,15541,'th','à¸Šà¸±à¹‰à¸™à¸¢à¸­à¸”',0),(559467,15541,'hi','à¤•à¤•à¥à¤·à¤¾ à¤°à¤¾à¤¶à¤¿',0),(559468,15541,'ms','Jumlah kelas',0),(559469,15541,'ar','Ø§Ù„ÙØ¦Ø© Ø§Ù„Ù…Ø¨Ù„Øº',0),(559470,15541,'fr','Montant de la classe',0),(559471,15541,'jp','ã‚¯ãƒ©ã‚¹ã®é‡',0),(559472,15541,'pt','Quantidade de classe',0),(559473,15541,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÐ»Ð°ÑÑÐ¾Ð²',0),(559474,15541,'es','Clase cantidad',0),(559475,15541,'de','Klasse-Betrag',0),(559476,15541,'en','Class Amount',0),(559477,15542,'is','',0),(559478,15542,'dr','Ú©Ù„ Ú©Ù„Ø§Ø³',0),(559479,15542,'pr','Ú©Ù„ Ú©Ù„Ø§Ø³',0),(559480,15542,'tr','SÄ±nÄ±f toplam',0),(559481,15542,'pl','Sumie Klasa',0),(559482,15542,'bg','ÐšÐ»Ð°Ñ Ð¾Ð±Ñ‰Ð¾',0),(559483,15542,'ur','Ú©Ù„Ø§Ø³ Ú©ÛŒ Ú©Ù„',0),(559484,15542,'sr','ÐšÐ»Ð°ÑÐ° ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(559485,15542,'vi','Tá»•ng sá»‘ lá»›p',0),(559486,15542,'af','Klas totaal',0),(559487,15542,'ro','Total clasa',0),(559488,15542,'et','Klassi kokku',0),(559489,15542,'si','Razred skupaj',0),(559490,15542,'ba','Total kelas',0),(559491,15542,'nl','Klasse totaal',0),(559492,15542,'fi','Luokka yhteensÃ¤',0),(559493,15542,'no','Klassen totalt',0),(559494,15542,'da','Klasse i alt',0),(559495,15542,'ko','í´ëž˜ìŠ¤ ì´',0),(559496,15542,'he','×¡×š ×”×›×œ ×‘×›×™×ª×”',0),(559497,15542,'el','Î£ÏÎ½Î¿Î»Î¿ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±Ï‚',0),(559498,15542,'zh','ç±»å…±',0),(559499,15542,'sv','Klass totalt',0),(559500,15542,'it','Totale classe',0),(559501,15542,'tl','',0),(559502,15542,'th','à¸Šà¸±à¹‰à¸™à¸£à¸§à¸¡',0),(559503,15542,'hi','à¤µà¤°à¥à¤— à¤•à¥à¤²',0),(559504,15542,'ms','Jumlah kelas',0),(559505,15542,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙØ¦Ø©',0),(559506,15542,'fr','Total de la classe',0),(559507,15542,'jp','ã‚¯ãƒ©ã‚¹åˆè¨ˆ',0),(559508,15542,'pt','Classe Total',0),(559509,15542,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾ ÐºÐ»Ð°ÑÑ',0),(559510,15542,'es','Total de clase',0),(559511,15542,'de','Total Klasse',0),(559512,15542,'en','Class Total',0),(559513,15543,'is','',0),(559514,15543,'dr','Ù‡ÛŒÚ† Ú©Ù„Ø§Ø³ Ù…Ø§Ù„ÛŒØ§Øª Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡',0),(559515,15543,'pr','Ù‡ÛŒÚ† Ú©Ù„Ø§Ø³ Ù…Ø§Ù„ÛŒØ§Øª Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡',0),(559516,15543,'tr','Atanan hiÃ§bir vergi sÄ±nÄ±fÄ±',0),(559517,15543,'pl','Brak podatku klasy przypisany',0),(559518,15543,'bg','ÐšÐ»Ð°ÑÐ° Ð½ÑÐ¼Ð° Ð´Ð°Ð½ÑŠÐº, Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½',0),(559519,15543,'ur','ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ù¹ÛŒÚ©Ø³ Ú©Ù„Ø§Ø³',0),(559520,15543,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° ÐºÐ»Ð°ÑÐµ Ð´Ð¾Ð´ÐµÑ™ÐµÐ½',0),(559521,15543,'vi','KhÃ´ng cÃ³ lá»›p thuáº¿ Ä‘Æ°á»£c giao',0),(559522,15543,'af','Geen belasting klas toegeken',0),(559523,15543,'ro','Nici o clasÄƒ fiscal atribuit',0),(559524,15543,'et','MÃ¤Ã¤ratud Ã¼htegi maksu liik',0),(559525,15543,'si','Ni davÄni razred, doloÄen',0),(559526,15543,'ba','Tidak ada kelas pajak yang ditetapkan',0),(559527,15543,'nl','Geen belasting klasse toegewezen',0),(559528,15543,'fi','Ei veroa luokka',0),(559529,15543,'no','Ingen skatt klasse tildelt',0),(559530,15543,'da','Ingen skat klasse tildelt',0),(559531,15543,'ko','ì•„ë‹ˆ ì„¸ê¸ˆ í´ëž˜ìŠ¤ í• ë‹¹',0),(559532,15543,'he','××™×Ÿ ×©×™×¢×•×¨ ×”×ž×¡ ×©×”×•×§×¦×•',0),(559533,15543,'el','ÎšÎ±Î¼Î¯Î± Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÏƒÏ„Î·Î½ Î¿Ï€Î¿Î¯Î± Î­Ï‡ÎµÎ¹',0),(559534,15543,'zh','æŒ‡å®šæ²¡æœ‰ç¨Žç±»',0),(559535,15543,'sv','Ingen skatt klassen',0),(559536,15543,'it','Nessuna classe fiscale assegnata',0),(559537,15543,'tl','',0),(559538,15543,'th','à¸Šà¸±à¹‰à¸™à¹„à¸¡à¹ˆà¸¡à¸µà¸ à¸²à¸©à¸µà¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”',0),(559539,15543,'hi','à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤•à¥‹à¤ˆ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤µà¤°à¥à¤—',0),(559540,15543,'ms','Tiada kelas cukai yang diberikan',0),(559541,15543,'ar','Ù„Ø§ ÙØ¦Ø© Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¹ÙŠÙ†Ø©',0),(559542,15543,'fr','Aucune catÃ©gorie d\'imposition assignÃ©',0),(559543,15543,'jp','å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ãªã„ç¨Žã‚¯ãƒ©ã‚¹',0),(559544,15543,'pt','Nenhuma classe de imposto atribuÃ­do',0),(559545,15543,'ru','ÐÐµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ ÐºÐ»Ð°ÑÑ',0),(559546,15543,'es','Ninguna clase de impuesto asignada',0),(559547,15543,'de','Keine Steuerklasse zugeordnet',0),(559548,15543,'en','No Tax Class Assigned',0),(559549,15544,'is','',0),(559550,15544,'dr','Ú©Ù„Ø§Ø³ Ù‡Ø§ÛŒ Ù…Ø§Ù„ÛŒØ§ØªÛŒ',0),(559551,15544,'pr','Ú©Ù„Ø§Ø³ Ù‡Ø§ÛŒ Ù…Ø§Ù„ÛŒØ§ØªÛŒ',0),(559552,15544,'tr','Vergi sÄ±nÄ±fÄ±',0),(559553,15544,'pl','Podatek od klasy',0),(559554,15544,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¸ ÐºÐ»Ð°Ñ',0),(559555,15544,'ur','Ù¹ÛŒÚ©Ø³ Ú©Ù„Ø§Ø³',0),(559556,15544,'sr','ÐšÐ»Ð°ÑÐ° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(559557,15544,'vi','Thuáº¿ lá»›p',0),(559558,15544,'af','Belasting klas',0),(559559,15544,'ro','Clasa de impozitare',0),(559560,15544,'et','Maksu klass',0),(559561,15544,'si','DavÄni razred',0),(559562,15544,'ba','Pajak kelas',0),(559563,15544,'nl','Belasting klasse',0),(559564,15544,'fi','ALV-luokka',0),(559565,15544,'no','Skatt klasse',0),(559566,15544,'da','Skat klasse',0),(559567,15544,'ko','ì„¸ê¸ˆ í´ëž˜ìŠ¤',0),(559568,15544,'he','×©×™×¢×•×¨ ×”×ž×¡',0),(559569,15544,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(559570,15544,'zh','ç¨Žæ”¶ç±»',0),(559571,15544,'sv','Skatt klass',0),(559572,15544,'it','Codice categoria di imposta',0),(559573,15544,'tl','',0),(559574,15544,'th','à¸›à¸£à¸°à¹€à¸ à¸—à¸ à¸²à¸©à¸µ',0),(559575,15544,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤µà¤°à¥à¤—',0),(559576,15544,'ms','Kelas cukai',0),(559577,15544,'ar','ÙØ¦Ø© Ø¶Ø±ÙŠØ¨Ø©',0),(559578,15544,'fr','CatÃ©gorie d\'imposition',0),(559579,15544,'jp','ç¨Žé‡‘ã‚¯ãƒ©ã‚¹',0),(559580,15544,'pt','Classe de impostos',0),(559581,15544,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ ÐºÐ»Ð°ÑÑ',0),(559582,15544,'es','Clase de impuestos',0),(559583,15544,'de','Steuerklasse',0),(559584,15544,'en','Tax Class',0),(559585,15545,'is','',0),(559586,15545,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø³Ø§Ø®Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ù‡Ù…Ù‡ Ù…ÙˆØ±Ø¯',0),(559587,15545,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø³Ø§Ø®Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ù‡Ù…Ù‡ Ù…ÙˆØ±Ø¯',0),(559588,15545,'tr','Auto-kurmak iÃ§in tÃ¼m madde',0),(559589,15545,'pl','Nie moÅ¼na zbudowaÄ‡ Auto wszystkie element',0),(559590,15545,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Auto-Ð¸Ð·Ð³Ñ€Ð°Ð¶Ð´Ð°Ð½Ðµ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(559591,15545,'ur','Ø®ÙˆØ¯Ú©Ø§Ø±-ØªØ¹Ù…ÛŒØ± Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§ Ø³Ø¨ Ø´Û’',0),(559592,15545,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸-Ð¸Ð·Ð³Ñ€Ð°Ð´ÑšÑƒ ÑÐ²Ð¸Ñ… Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°',0),(559593,15545,'vi','KhÃ´ng thá»ƒ tá»± Ä‘á»™ng xÃ¢y dá»±ng táº¥t cáº£ cÃ¡c má»¥c',0),(559594,15545,'af','Outo-bou nie al van Item',0),(559595,15545,'ro','Imposibilitatea de a Auto-construi toate element',0),(559596,15545,'et','Suuda Auto-ehitada kÃµik Ã¼ksus',0),(559597,15545,'si','Mogli Auto-graditi vse postavke',0),(559598,15545,'ba','Mampu Auto-membangun Semua Item',0),(559599,15545,'nl','Kunnen Auto-Build aller Item',0),(559600,15545,'fi','Auto-Build kaikki kohteen',0),(559601,15545,'no','Ikke Auto-bygge alle element',0),(559602,15545,'da','AfskÃ¥ret fra Auto-bygge alle vare',0),(559603,15545,'ko','ìžë™ ë¹Œë“œ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ëª¨ë“  í•­ëª©',0),(559604,15545,'he','××™×Ÿ ××¤×©×¨×•×ª ××•×˜×•×ž×˜×™×ª-×œ×‘× ×•×ª ×›×œ ×¤×¨×™×˜',0),(559605,15545,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎºÎ±Ï„Î±ÏƒÎºÎµÏ…Î® ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ ÎµÎ¹Î´ÏŽÎ½',0),(559606,15545,'zh','æ— æ³•è‡ªåŠ¨ç”Ÿæˆæ‰€æœ‰çš„é¡¹ç›®',0),(559607,15545,'sv','Det gÃ¥r inte att Auto-bygga alla av',0),(559608,15545,'it','Grado di Auto-compilazione tutti dell\'elemento',0),(559609,15545,'tl','',0),(559610,15545,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸–à¸¢à¸™à¸•à¹Œà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸‚à¸­à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(559611,15545,'hi','à¤‘à¤Ÿà¥‹-à¤¬à¤¿à¤²à¥à¤¡ à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤•à¥à¤·à¤® à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤¸à¤­à¥€',0),(559612,15545,'ms','Dapat membina Auto Semua Item',0),(559613,15545,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¨Ù†Ø§Ø¡ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª ÙƒÙ„ Ø¨Ù†Ø¯',0),(559614,15545,'fr','Incapable de construire automatiquement tout Ã©lÃ©ment',0),(559615,15545,'jp','è‡ªå‹•ãƒ“ãƒ«ãƒ‰ã§ãã¾ã›ã‚“ã™ã¹ã¦ã®ã‚¢ã‚¤ãƒ†ãƒ ã€‚',0),(559616,15545,'pt','Incapaz de Auto-compilaÃ§Ã£o todos os Item',0),(559617,15545,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ð¾ÑÑ‚Ñ€Ð¾Ð¸Ñ‚ÑŒ Ð°Ð²Ñ‚Ð¾ Ð²ÑÐµ Ð¿ÑƒÐ½ÐºÑ‚Ð°',0),(559618,15545,'es','Incapaz de Auto-Build de elemento',0),(559619,15545,'de','Auto-Build konnte nicht alle Element',0),(559620,15545,'en','Unable To Auto-Build All Of Item',0),(559621,15546,'is','',0),(559622,15546,'dr','Ø³ÙØ§Ø±Ø´ Ø¯ÛŒÚ¯Ø± Ú©Ø´ØªÛŒ',0),(559623,15546,'pr','Ø³ÙØ§Ø±Ø´ Ø¯ÛŒÚ¯Ø± Ú©Ø´ØªÛŒ',0),(559624,15546,'tr','BaÅŸka bir sipariÅŸ gemi',0),(559625,15546,'pl','Statek innej kolejnoÅ›ci',0),(559626,15546,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð½Ð° Ð´Ñ€ÑƒÐ³Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(559627,15546,'ur','Ø§ÛŒÚ© Ø§ÙˆØ± Ø¬ÛØ§Ø²',0),(559628,15546,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÑ‡Ð¸Ñ‚Ð¸ Ð´Ñ€ÑƒÐ³Ñƒ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(559629,15546,'vi','TÃ u má»™t Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(559630,15546,'af','Skip van \'n ander orde',0),(559631,15546,'ro','Un alt ordin de navÄƒ',0),(559632,15546,'et','Laeva muus jÃ¤rjestuses',0),(559633,15546,'si','Ladje Å¡e eno naroÄilo',0),(559634,15546,'ba','Kapal perintah lain',0),(559635,15546,'nl','Een andere bestelling',0),(559636,15546,'fi','Aluksen toinen tilaus',0),(559637,15546,'no','Levere en annen ordre',0),(559638,15546,'da','Sende en anden ordre',0),(559639,15546,'ko','ë‹¤ë¥¸ ìˆœì„œë¥¼ ë°œì†¡',0),(559640,15546,'he','×”×¡×¤×™× ×” ×¦×• × ×•×¡×£',0),(559641,15546,'el','Î‘Ï€Î¿ÏƒÏ„Î­Î»Î»ÎµÏ„Îµ Î¼Î¹Î± Î¬Î»Î»Î· Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(559642,15546,'zh','å¦ä¸€ä¸ªè´§',0),(559643,15546,'sv','Leverera en annan Order',0),(559644,15546,'it','Spedire un altro ordine',0),(559645,15546,'tl','',0),(559646,15546,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸­à¸·à¹ˆà¸™',0),(559647,15546,'hi','à¤à¤• à¤…à¤¨à¥à¤¯ à¤†à¤¦à¥‡à¤¶ à¤œà¤¹à¤¾à¤œ',0),(559648,15546,'ms','Kapal pesanan lagi',0),(559649,15546,'ar','Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø£Ù…Ø± Ø¢Ø®Ø±',0),(559650,15546,'fr','ExpÃ©dier une autre commande',0),(559651,15546,'jp','åˆ¥ã®æ³¨æ–‡ã‚’å‡ºè·ã—ã¾ã™ã€‚',0),(559652,15546,'pt','Enviar outra ordem',0),(559653,15546,'ru','Ð•Ñ‰Ðµ Ð¾Ð´Ð¸Ð½ Ð·Ð°ÐºÐ°Ð·',0),(559654,15546,'es','Enviar otra orden',0),(559655,15546,'de','Eine weitere Bestellung',0),(559656,15546,'en','Ship Another Order',0),(559657,15547,'is','',0),(559658,15547,'dr','Ú©Ù„Ø§Ø³ Ù‡Ø§ÛŒ ÙØ¹Ù„ÛŒ Ù…Ø§Ù„ÛŒØ§Øª',0),(559659,15547,'pr','Ú©Ù„Ø§Ø³ Ù‡Ø§ÛŒ ÙØ¹Ù„ÛŒ Ù…Ø§Ù„ÛŒØ§Øª',0),(559660,15547,'tr','GeÃ§erli vergi sÄ±nÄ±flar',0),(559661,15547,'pl','BieÅ¼Ä…cej klasy podatkowe',0),(559662,15547,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¸ ÐºÐ»Ð°ÑÐ¾Ð²Ðµ',0),(559663,15547,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ú©Ù„Ø§Ø³ÛŒÚº',0),(559664,15547,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€ÐµÐ´Ð°Ð²Ð°ÑšÐ°',0),(559665,15547,'vi','Hiá»‡n nay thuáº¿ cÃ¡c lá»›p há»c',0),(559666,15547,'af','Huidige belasting klasse',0),(559667,15547,'ro','Clase de impozitul curent',0),(559668,15547,'et','Praegune maksu klassid',0),(559669,15547,'si','Trenutne davÄne razrede',0),(559670,15547,'ba','Saat ini pajak Classes',0),(559671,15547,'nl','Huidige Tax klassen',0),(559672,15547,'fi','Nykyinen veroluokkaan',0),(559673,15547,'no','Gjeldende mva-klasser',0),(559674,15547,'da','Aktuel skat klasser',0),(559675,15547,'ko','í˜„ìž¬ ì„¸ê¸ˆ í´ëž˜ìŠ¤',0),(559676,15547,'he','×©×™×¢×•×¨×™ ×”×ž×¡ ×”× ×•×›×—×™×ª',0),(559677,15547,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎµÏ‚ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ­Ï‚ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(559678,15547,'zh','å½“å‰ç¨Žæ”¶ç±»',0),(559679,15547,'sv','Aktuell skatt klasser',0),(559680,15547,'it','Codici categoria di imposta corrente',0),(559681,15547,'tl','',0),(559682,15547,'th','à¹€à¸£à¸µà¸¢à¸™à¸ à¸²à¸©à¸µà¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(559683,15547,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¤•à¥à¤·à¤¾à¤à¤‚',0),(559684,15547,'ms','Kelas-kelas cukai semasa',0),(559685,15547,'ar','ÙØ¦Ø§Øª Ø§Ù„Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(559686,15547,'fr','Classes d\'impÃ´t actuel',0),(559687,15547,'jp','ç¾åœ¨ã®ç¨Žã®ã‚¯ãƒ©ã‚¹',0),(559688,15547,'pt','Classes de imposto atual',0),(559689,15547,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ ÐºÐ»Ð°ÑÑÑ‹',0),(559690,15547,'es','Clases de impuestos actual',0),(559691,15547,'de','Aktuellen Steuerklassen',0),(559692,15547,'en','Current Tax Classes',0),(559693,15548,'is','',0),(559694,15548,'dr','ØºÛŒØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(559695,15548,'pr','ØºÛŒØ± Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(559696,15548,'tr','Sigara vergiye tabi',0),(559697,15548,'pl','Opodatkowaniu nie',0),(559698,15548,'bg','Ð—Ð° Ð´Ð°Ð½ÑŠÑ‡Ð½Ð¾',0),(559699,15548,'ur','ØºÛŒØ± Ø¹Ø§Ø¦Ø¯',0),(559700,15548,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½Ðµ Ð¿Ð»Ð°Ð¶Ð°',0),(559701,15548,'vi','PhÃ²ng KhÃ´ng Taxable',0),(559702,15548,'af','Nie belasbare',0),(559703,15548,'ro','Ne impozabila',0),(559704,15548,'et','Kohaldamata',0),(559705,15548,'si','DavÄni',0),(559706,15548,'ba','Bebas pajak',0),(559707,15548,'nl','Niet belastbare',0),(559708,15548,'fi','Ei verotettavat',0),(559709,15548,'no','Ikke skattepliktig',0),(559710,15548,'da','Ikke afgiftspligtige',0),(559711,15548,'ko','ë¹„ ê³¼ì„¸',0),(559712,15548,'he','×©××™× ×• ×—×™×™×‘ ×‘×ž×¡',0),(559713,15548,'el','ÎœÎ· Ï…Ï€Î¿ÎºÎµÎ¯Î¼ÎµÎ½Î¿ ÏƒÏ„Î¿ Ï†ÏŒÏÎ¿',0),(559714,15548,'zh','éžåº”çº³ç¨Ž',0),(559715,15548,'sv','Icke beskattningsbara',0),(559716,15548,'it','Non sono soggetti passivi',0),(559717,15548,'tl','',0),(559718,15548,'th','à¹„à¸¡à¹ˆà¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µ',0),(559719,15548,'hi','à¤—à¥ˆà¤° à¤•à¤° à¤¯à¥‹à¤—à¥à¤¯',0),(559720,15548,'ms','Bebas cukai',0),(559721,15548,'ar','ØºÙŠØ± Ø§Ù„Ø®Ø§Ø¶Ø¹ Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(559722,15548,'fr','Non imposable',0),(559723,15548,'jp','éžèª²ç¨Ž',0),(559724,15548,'pt','NÃ£o tributÃ¡veis',0),(559725,15548,'ru','ÐÐµ Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼',0),(559726,15548,'es','No imponible',0),(559727,15548,'de','Nicht steuerbaren',0),(559728,15548,'en','Nontaxable',0),(559729,15549,'is','',0),(559730,15549,'dr','ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ Ù‡ÛŒÚ† Ú©Ù„Ø§Ø³ Ù‡Ø§ÛŒ Ù…Ø§Ù„ÛŒØ§ØªÛŒ',0),(559731,15549,'pr','ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯ Ù‡ÛŒÚ† Ú©Ù„Ø§Ø³ Ù‡Ø§ÛŒ Ù…Ø§Ù„ÛŒØ§ØªÛŒ',0),(559732,15549,'tr','HiÃ§bir vergi sÄ±nÄ±flar var',0),(559733,15549,'pl','Nie ma klas podatkowych istnieje',0),(559734,15549,'bg','ÐÐµ Ð´Ð°Ð½ÑŠÐº ÐºÐ»Ð°ÑÐ¾Ð²Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‚',0),(559735,15549,'ur','Ú©ÙˆØ¦ÛŒ Ù¹ÛŒÚ©Ø³ Ú©Ù„Ø§Ø³ÛŒÚº Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(559736,15549,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ðµ ÐºÐ»Ð°ÑÐµ Ð±ÐµÐ· Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(559737,15549,'vi','CÃ¡c lá»›p há»c thuáº¿ khÃ´ng tá»“n táº¡i',0),(559738,15549,'af','Geen belasting klasse bestaan',0),(559739,15549,'ro','Nici clasele de impozit exista',0),(559740,15549,'et','Mingit maksu klasside olemas',0),(559741,15549,'si','Ni davÄne razrede obstaja',0),(559742,15549,'ba','Ada tidak pajak Classes',0),(559743,15549,'nl','Geen belasting klassen bestaan',0),(559744,15549,'fi','Ei veroluokkaan olemassa',0),(559745,15549,'no','Ingen skatt klasser eksisterer',0),(559746,15549,'da','Ingen skat klasser eksisterer',0),(559747,15549,'ko','ì•„ë‹ˆ ì„¸ê¸ˆ í´ëž˜ìŠ¤ ì¡´ìž¬',0),(559748,15549,'he','×©×™×¢×•×¨×™ ×”×ž×¡ ×œ× ×§×™×™×',0),(559749,15549,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î¿Î¹ Ï„Î¬Î¾ÎµÎ¹Ï‚, Ï†ÏŒÏÎ¿Ï‚',0),(559750,15549,'zh','æ²¡æœ‰ç¨Žç±»å­˜åœ¨',0),(559751,15549,'sv','Ingen skatt klasser finns',0),(559752,15549,'it','Nessuna tassa le classi esistono',0),(559753,15549,'tl','',0),(559754,15549,'th','à¸ªà¸­à¸™à¸ à¸²à¸©à¸µà¸­à¸¢à¸¹à¹ˆ',0),(559755,15549,'hi','à¤•à¥‹à¤ˆ à¤Ÿà¥ˆà¤•à¥à¤¸ à¤•à¤•à¥à¤·à¤¾à¤à¤‚ à¤®à¥Œà¤œà¥‚à¤¦',0),(559756,15549,'ms','Kelas cukai tidak wujud',0),(559757,15549,'ar','ØªÙˆØ¬Ø¯ Ù„Ø§ ÙØ¦Ø§Øª Ø§Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(559758,15549,'fr','Aucune taxe sur les Classes n\'existent',0),(559759,15549,'jp','ç¨Žã®ã‚¯ãƒ©ã‚¹ã¯å­˜åœ¨ã—ã¾ã›ã‚“',0),(559760,15549,'pt','Existem Classes sem imposto',0),(559761,15549,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð±ÐµÐ· Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ñ… ÐºÐ»Ð°ÑÑÐ¾Ð²',0),(559762,15549,'es','No hay clases de impuestos existen',0),(559763,15549,'de','Existieren keine Steuerklassen',0),(559764,15549,'en','No Tax Classes Exist',0),(559765,15550,'is','',0),(559766,15550,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ù†Ø§Ù… ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(559767,15550,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ù†Ø§Ù… ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(559768,15550,'tr','LÃ¼tfen bir ad girin',0),(559769,15550,'pl','WprowadÅº nazwÄ™',0),(559770,15550,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ',0),(559771,15550,'ur','Ø§ÛŒÚ© Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(559772,15550,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸Ð¼Ðµ',0),(559773,15550,'vi','Xin vui lÃ²ng nháº­p tÃªn',0),(559774,15550,'af','Tik asseblief \'n naam',0),(559775,15550,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un nume de',0),(559776,15550,'et','Palun sisestage nimi',0),(559777,15550,'si','Vnesite ime',0),(559778,15550,'ba','Masukkan nama',0),(559779,15550,'nl','Voer een naam',0),(559780,15550,'fi','Kirjoita nimi',0),(559781,15550,'no','Skriv inn et navn',0),(559782,15550,'da','Angiv et navn',0),(559783,15550,'ko','ì´ë¦„ì„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤',0),(559784,15550,'he','×× × ×”×›× ×¡ ×©×',0),(559785,15550,'el','Î Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î±',0),(559786,15550,'zh','è¯·è¾“å…¥ä¸€ä¸ªåç§°',0),(559787,15550,'sv','Skriv in ett namn',0),(559788,15550,'it','Si prega di inserire un nome',0),(559789,15550,'tl','',0),(559790,15550,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­',0),(559791,15550,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(559792,15550,'ms','Sila masukkan nama',0),(559793,15550,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ø³Ù…',0),(559794,15550,'fr','Veuillez entrer un nom',0),(559795,15550,'jp','åå‰ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(559796,15550,'pt','Por favor insira um nome',0),(559797,15550,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¸Ð¼Ñ',0),(559798,15550,'es','Introduzca un nombre',0),(559799,15550,'de','Bitte geben Sie einen Namen',0),(559800,15550,'en','Please Enter A Name',0),(559801,15551,'is','',0),(559802,15551,'dr','Ù†Ù…ÛŒ ØªÙˆØ§Ù† Ù‡Ù…Ù‡ Ø±Ø§',0),(559803,15551,'pr','Ù†Ù…ÛŒ ØªÙˆØ§Ù† Ù‡Ù…Ù‡ Ø±Ø§',0),(559804,15551,'tr','TÃ¼m yapÄ±lamÄ±yor',0),(559805,15551,'pl','Nie wszystkie',0),(559806,15551,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸',0),(559807,15551,'ur','ØªÙ…Ø§Ù… Ø¨Ù†Ø§Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù…',0),(559808,15551,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ð¸ ÑÐ²Ðµ',0),(559809,15551,'vi','KhÃ´ng thá»ƒ Ä‘á»ƒ lÃ m cho táº¥t cáº£',0),(559810,15551,'af','Nie almal maak',0),(559811,15551,'ro','Imposibilitatea de a face toate',0),(559812,15551,'et','Ei saa teha kÃµik',0),(559813,15551,'si','Sposobna sprejeti vse',0),(559814,15551,'ba','Mampu membuat semua',0),(559815,15551,'nl','Niet in staat om alle',0),(559816,15551,'fi','Voi tehdÃ¤ kaikki',0),(559817,15551,'no','Kan ikke gjÃ¸re alt',0),(559818,15551,'da','Stand til at gÃ¸re alle',0),(559819,15551,'ko','ëª¨ë‘ë¥¼ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(559820,15551,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×”×¤×•×š ××ª ×›×œ',0),(559821,15551,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„Î® Î· ÏŒÎ»Î±',0),(559822,15551,'zh','ä¸èƒ½ä½¿æ‰€æœ‰',0),(559823,15551,'sv','Det gÃ¥r inte att gÃ¶ra alla',0),(559824,15551,'it','Grado di effettuare tutte le',0),(559825,15551,'tl','',0),(559826,15551,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸—à¸³à¹ƒà¸«à¹‰à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(559827,15551,'hi','à¤¸à¤­à¥€ à¤¬à¤¨à¤¾à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(559828,15551,'ms','Dapat membuat semua',0),(559829,15551,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø¬Ø¹Ù„ ÙƒÙ„',0),(559830,15551,'fr','Incapable de faire tout ce',0),(559831,15551,'jp','ã™ã¹ã¦ã‚’ã™ã‚‹ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(559832,15551,'pt','NÃ£o Ã© possÃ­vel fazer todos os',0),(559833,15551,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ ÑÐ´ÐµÐ»Ð°Ñ‚ÑŒ Ð²ÑÐµ',0),(559834,15551,'es','No se puede hacer todo',0),(559835,15551,'de','Nicht in der Lage, alle machen',0),(559836,15551,'en','Unable To Make All',0),(559837,15552,'is','',0),(559838,15552,'dr','Ù†ÙˆØ¹ Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ù†Ø§Ø¯Ø±Ø³Øª',0),(559839,15552,'pr','Ù†ÙˆØ¹ Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ù†Ø§Ø¯Ø±Ø³Øª',0),(559840,15552,'tr','YanlÄ±ÅŸ dosya tÃ¼rÃ¼',0),(559841,15552,'pl','Niepoprawny plik typu',0),(559842,15552,'bg','ÐÐµÐ¿Ñ€Ð°Ð²Ð¸Ð»ÐµÐ½ Ñ‚Ð¸Ð¿',0),(559843,15552,'ur','Ù†Ø§Ù‚Øµ Ù…Ø³Ù„ Ù‚Ø³Ù…',0),(559844,15552,'sr','ÐŸÐ¾Ð³Ñ€ÐµÑˆÐ°Ð½ Ñ‚Ð¸Ð¿ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(559845,15552,'vi','Loáº¡i táº­p tin khÃ´ng chÃ­nh xÃ¡c',0),(559846,15552,'af','Verkeerde lÃªertipe',0),(559847,15552,'ro','FiÅŸierul incorect tip',0),(559848,15552,'et','Vale faili tÃ¼Ã¼p',0),(559849,15552,'si','Nepravilna vrsta datoteke',0),(559850,15552,'ba','Jenis File salah',0),(559851,15552,'nl','Onjuiste bestandstype',0),(559852,15552,'fi','Virheellinen tiedostomuoto',0),(559853,15552,'no','Feil filtype',0),(559854,15552,'da','Forkert filtype',0),(559855,15552,'ko','ìž˜ëª» ëœ íŒŒì¼ í˜•ì‹',0),(559856,15552,'he','×¡×•×’ ×§×•×‘×¥ ×©×’×•×™',0),(559857,15552,'el','Î•ÏƒÏ†Î±Î»Î¼Î­Î½Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï„ÏÏ€Î¿Ï…',0),(559858,15552,'zh','ä¸æ­£ç¡®çš„æ–‡ä»¶ç±»åž‹',0),(559859,15552,'sv','Felaktig filtyp',0),(559860,15552,'it','Tipo di File non corretto',0),(559861,15552,'tl','',0),(559862,15552,'th','à¸Šà¸™à¸´à¸”à¹à¸Ÿà¹‰à¸¡à¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(559863,15552,'hi','à¤—à¤¼à¤²à¤¤ à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¥à¤°à¤•à¤¾à¤°',0),(559864,15552,'ms','Jenis fail yang tidak betul',0),(559865,15552,'ar','Ù†ÙˆØ¹ Ù…Ù„Ù ØºÙŠØ± ØµØ­ÙŠØ­',0),(559866,15552,'fr','Type de fichier incorrect',0),(559867,15552,'jp','ä¸é©åˆ‡ãªãƒ•ã‚¡ã‚¤ãƒ«ã®ç¨®é¡ž',0),(559868,15552,'pt','Tipo de arquivo incorreto',0),(559869,15552,'ru','Ð¢Ð¸Ð¿ Ñ„Ð°Ð¹Ð»Ð°',0),(559870,15552,'es','Tipo de archivo incorrecto',0),(559871,15552,'de','Falscher Dateityp',0),(559872,15552,'en','Incorrect File Type',0),(559873,15553,'is','',0),(559874,15553,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú©Ø§Ø±',0),(559875,15553,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú©Ø§Ø±',0),(559876,15553,'tr','Ä°ÅŸ eklemek',0),(559877,15553,'pl','Dodaj zadanie',0),(559878,15553,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(559879,15553,'ur','Ø¬Ø§Ø¨ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(559880,15553,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾',0),(559881,15553,'vi','ThÃªm cÃ´ng viá»‡c',0),(559882,15553,'af','Voeg werk',0),(559883,15553,'ro','Adauga Job',0),(559884,15553,'et','Lisa tÃ¶Ã¶de',0),(559885,15553,'si','Dodaj delo',0),(559886,15553,'ba','Tambah pekerjaan',0),(559887,15553,'nl','Job toevoegen',0),(559888,15553,'fi','LisÃ¤Ã¤ tyÃ¶',0),(559889,15553,'no','Legge til jobben',0),(559890,15553,'da','TilfÃ¸j Job',0),(559891,15553,'ko','ìž‘ì—… ì¶”ê°€',0),(559892,15553,'he','×”×•×¡×£ ××ª ×”×¢×‘×•×“×”',0),(559893,15553,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(559894,15553,'zh','æ·»åŠ ä½œä¸š',0),(559895,15553,'sv','LÃ¤gg till jobb',0),(559896,15553,'it','Aggiungi lavoro',0),(559897,15553,'tl','',0),(559898,15553,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸‡à¸²à¸™',0),(559899,15553,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(559900,15553,'ms','Tambah kerja',0),(559901,15553,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ¸ÙŠÙØ©',0),(559902,15553,'fr','Ajouter Job',0),(559903,15553,'jp','ã‚¸ãƒ§ãƒ–ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(559904,15553,'pt','Adicionar emprego',0),(559905,15553,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(559906,15553,'es','Agregar trabajo',0),(559907,15553,'de','Job hinzufÃ¼gen',0),(559908,15553,'en','Add Job',0),(559909,15554,'is','',0),(559910,15554,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ø´ØºÙ„ Ø¬Ø¯ÛŒØ¯ Ø¨Ø§ Ù‡Ø± Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(559911,15554,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ø´ØºÙ„ Ø¬Ø¯ÛŒØ¯ Ø¨Ø§ Ù‡Ø± Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(559912,15554,'tr','Yeni iÅŸ ile her yeni mÃ¼ÅŸteri oluÅŸtur',0),(559913,15554,'pl','UtwÃ³rz nowe zadanie z kaÅ¼dego nowego klienta',0),(559914,15554,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ Ð²ÑÐµÐºÐ¸ Ð½Ð¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(559915,15554,'ur','ÛØ± Ù†Ø¦Û’ Ú¯Ø§ÛÚ© Ú©Û’ Ø³Ø§ØªÚ¾ Ù†ÛŒØ§ Ú©Ø§Ù… Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(559916,15554,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾ ÑÐ° ÑÐ²Ð°ÐºÐ¾Ð³ Ð½Ð¾Ð²Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð°',0),(559917,15554,'vi','Táº¡o ra cÃ´ng viá»‡c má»›i vá»›i má»—i khÃ¡ch hÃ ng má»›i',0),(559918,15554,'af','Skep nuwe taak met elke nuwe kliÃ«nt',0),(559919,15554,'ro','Crea noi locuri de muncÄƒ cu fiecare client nou',0),(559920,15554,'et','Loo uus tÃ¶Ã¶koht iga uue kliendi',0),(559921,15554,'si','Ustvarjanje novih delovnih mest z vsako novo stranko',0),(559922,15554,'ba','Membuat pekerjaan baru dengan setiap pelanggan baru',0),(559923,15554,'nl','Nieuwe baan met elke nieuwe klant maken',0),(559924,15554,'fi','Luo uusi tyÃ¶ kunkin uuden asiakkaan kanssa',0),(559925,15554,'no','Opprette ny jobb med hver ny kunde',0),(559926,15554,'da','Opret nyt Job med hver ny kunde',0),(559927,15554,'ko','ê° ìƒˆë¡œìš´ ê³ ê°ê³¼ ìƒˆë¡œìš´ ì¼ìžë¦¬ë¥¼ ë§Œë“¤',0),(559928,15554,'he','×œ×™×¦×•×¨ ×¢×‘×•×“×” ×—×“×©×” ×¢× ×›×œ ×œ×§×•×— ×—×“×©',0),(559929,15554,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î½Î­Î±Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î¼Îµ ÎºÎ¬Î¸Îµ Î½Î­Î¿ Ï€ÎµÎ»Î¬Ï„Î·',0),(559930,15554,'zh','ä¸Žæ¯ä¸€ä½æ–°å®¢æˆ·åˆ›å»ºæ–°ä½œä¸š',0),(559931,15554,'sv','Skapa nytt jobb med varje ny kund',0),(559932,15554,'it','Creare nuovo lavoro con ogni nuovo cliente',0),(559933,15554,'tl','',0),(559934,15554,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸‡à¸²à¸™à¹ƒà¸«à¸¡à¹ˆà¸à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²à¹à¸•à¹ˆà¸¥à¸°à¸£à¸²à¸¢à¹ƒà¸«à¸¡à¹ˆ',0),(559935,15554,'hi','à¤¹à¤° à¤¨à¤ à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¨à¤¯à¤¾ à¤•à¤¾à¤°à¥à¤¯ à¤¬à¤¨à¤¾à¤à¤',0),(559936,15554,'ms','Mewujudkan pekerjaan baru dengan setiap pelanggan baru',0),(559937,15554,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù…Ù‡Ù…Ø© Ø¬Ø¯ÙŠØ¯Ø© Ù…Ø¹ ÙƒÙ„ Ø¹Ù…ÙŠÙ„ Ø¬Ø¯ÙŠØ¯',0),(559938,15554,'fr','CrÃ©er nouvel emploi avec chaque nouveau client',0),(559939,15554,'jp','ãã‚Œãžã‚Œã®æ–°ã—ã„é¡§å®¢ã«æ–°ã—ã„ã‚¸ãƒ§ãƒ–ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(559940,15554,'pt','Criar um novo trabalho com cada novo cliente',0),(559941,15554,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ð¾Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ Ñ ÐºÐ°Ð¶Ð´Ñ‹Ð¼ Ð½Ð¾Ð²Ñ‹Ð¼ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð¼',0),(559942,15554,'es','Crear nuevo empleo con cada nuevo cliente',0),(559943,15554,'de','Erstellen von neuen Job mit jedem neuen Kunden',0),(559944,15554,'en','Create New Job With Each New Customer',0),(559945,15555,'is','',0),(559946,15555,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ú©Ø§Ø± Ø¬Ø¯ÛŒØ¯',0),(559947,15555,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ú©Ø§Ø± Ø¬Ø¯ÛŒØ¯',0),(559948,15555,'tr','Yeni iÅŸ eklemek',0),(559949,15555,'pl','DodaÄ‡ nowe zadanie',0),(559950,15555,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(559951,15555,'ur','Ù†Ø¦ÛŒ Ø¬Ø§Ø¨ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(559952,15555,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(559953,15555,'vi','ThÃªm cÃ´ng viá»‡c má»›i',0),(559954,15555,'af','Voeg nuwe werk',0),(559955,15555,'ro','Adauga noul loc de muncÄƒ',0),(559956,15555,'et','Lisa uus tÃ¶Ã¶koht',0),(559957,15555,'si','Dodaj novo sluÅ¾bo',0),(559958,15555,'ba','Tambahkan pekerjaan baru',0),(559959,15555,'nl','Nieuwe taak toevoegen',0),(559960,15555,'fi','LisÃ¤Ã¤ uusi tyÃ¶',0),(559961,15555,'no','Legge til nye jobben',0),(559962,15555,'da','TilfÃ¸je nye Job',0),(559963,15555,'ko','ìƒˆ ìž‘ì—… ì¶”ê°€',0),(559964,15555,'he','×”×•×¡×¤×ª ×ž×©×¨×” ×—×“×©×”',0),(559965,15555,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Î½Î­Î±Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(559966,15555,'zh','æ·»åŠ æ–°çš„å·¥ä½œ',0),(559967,15555,'sv','LÃ¤gg till nytt jobb',0),(559968,15555,'it','Aggiungi nuovo lavoro',0),(559969,15555,'tl','',0),(559970,15555,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸‡à¸²à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(559971,15555,'hi','à¤¨à¤¯à¤¾ à¤•à¤¾à¤°à¥à¤¯ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(559972,15555,'ms','Tambah tugas baru',0),(559973,15555,'ar','Ø¥Ø¶Ø§ÙØ© ÙˆØ¸ÙŠÙØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(559974,15555,'fr','Ajouter nouvel emploi',0),(559975,15555,'jp','æ–°ã—ã„ã‚¸ãƒ§ãƒ–ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(559976,15555,'pt','Adicionar novo emprego',0),(559977,15555,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ð¾Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(559978,15555,'es','Agregar nuevo trabajo',0),(559979,15555,'de','FÃ¼gen neuen Job hinzu',0),(559980,15555,'en','Add New Job',0),(559981,15556,'is','',0),(559982,15556,'dr','Ù…Ø´ØªØ±ÛŒ ÛŒØ§ ÙØ§Ú©ØªÙˆØ± ÛŒØ§ÙØª Ù†Ø´Ø¯',0),(559983,15556,'pr','Ù…Ø´ØªØ±ÛŒ ÛŒØ§ ÙØ§Ú©ØªÙˆØ± ÛŒØ§ÙØª Ù†Ø´Ø¯',0),(559984,15556,'tr','MÃ¼ÅŸteri veya fatura bulunamadÄ±',0),(559985,15556,'pl','Klienta lub faktury nie znaleziono',0),(559986,15556,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(559987,15556,'ur','Ú¯Ø§ÛÚ© ÛŒØ§ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(559988,15556,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð¸Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(559989,15556,'vi','KhÃ¡ch hÃ ng hoáº·c hÃ³a Ä‘Æ¡n khÃ´ng Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(559990,15556,'af','KliÃ«nt of faktuur nie gevind nie',0),(559991,15556,'ro','Client sau factura nu a fost gÄƒsit',0),(559992,15556,'et','Kliendi- vÃµi arve ei leitud',0),(559993,15556,'si','Kupca ali raÄun, ni mogoÄe najti',0),(559994,15556,'ba','Pelanggan atau faktur tidak ditemukan',0),(559995,15556,'nl','Klant of factuur niet gevonden',0),(559996,15556,'fi','Asiakkaan tai laskun ei lÃ¶ydy',0),(559997,15556,'no','Kunden eller fakturaen ikke funnet',0),(559998,15556,'da','Kunden eller fakturaen ikke fundet',0),(559999,15556,'ko','ê³ ê° ë˜ëŠ” ì²­êµ¬ì„œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(560000,15556,'he','×œ×§×•×— ××• ×—×©×‘×•× ×™×ª ×œ× × ×ž×¦×',0),(560001,15556,'el','Î ÎµÎ»Î¬Ï„Î· Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(560002,15556,'zh','å®¢æˆ·æˆ–å‘ç¥¨æ‰¾ä¸åˆ°',0),(560003,15556,'sv','Kunden eller faktura hittades inte',0),(560004,15556,'it','Cliente o fattura non trovato',0),(560005,15556,'tl','',0),(560006,15556,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸«à¸£à¸·à¸­à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸žà¸š',0),(560007,15556,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¯à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(560008,15556,'ms','Pelanggan atau invois tidak dijumpai',0),(560009,15556,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø£Ùˆ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(560010,15556,'fr','Client ou facture introuvable',0),(560011,15556,'jp','é¡§å®¢ã¾ãŸã¯è«‹æ±‚æ›¸ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(560012,15556,'pt','Cliente ou factura nÃ£o encontrado',0),(560013,15556,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(560014,15556,'es','Cliente o factura no encontrado',0),(560015,15556,'de','Kunde oder Rechnung nicht gefunden',0),(560016,15556,'en','Customer Or Invoice Not Found',0),(560017,15557,'is','',0),(560018,15557,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(560019,15557,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(560020,15557,'tr','Ã–deme girin',0),(560021,15557,'pl','Wpisz pÅ‚atnoÅ›ci',0),(560022,15557,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(560023,15557,'ur','Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(560024,15557,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(560025,15557,'vi','Nháº­p thanh toÃ¡n',0),(560026,15557,'af','Tik betaling',0),(560027,15557,'ro','IntroduceÅ£i platÄƒ',0),(560028,15557,'et','Sisestage makse',0),(560029,15557,'si','Vnesite plaÄilo',0),(560030,15557,'ba','Masukkan pembayaran',0),(560031,15557,'nl','Betaling invoeren',0),(560032,15557,'fi','SyÃ¶ttÃ¤Ã¤ maksu',0),(560033,15557,'no','Angi betaling',0),(560034,15557,'da','Angive betaling',0),(560035,15557,'ko','ì§€ë¶ˆ ìž…ë ¥',0),(560036,15557,'he','×”×–×Ÿ ××ª ×”×ª×©×œ×•×',0),(560037,15557,'el','Î•Î¹ÏƒÎ±Î³Î¬Î³ÎµÏ„Îµ Ï€Î»Î·ÏÏ‰Î¼Î®',0),(560038,15557,'zh','è¾“å…¥ä»˜æ¬¾',0),(560039,15557,'sv','Skriver du betalning',0),(560040,15557,'it','Immettere il pagamento',0),(560041,15557,'tl','',0),(560042,15557,'th','à¸›à¹‰à¸­à¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(560043,15557,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(560044,15557,'ms','Masukkan bayaran',0),(560045,15557,'ar','Ø£Ø¯Ø®Ù„ Ø§Ù„Ù…Ø¨Ù„Øº',0),(560046,15557,'fr','Entrez le paiement',0),(560047,15557,'jp','æ”¯æ‰•ã‚’å…¥åŠ›ã—ã¾ã™ã€‚',0),(560048,15557,'pt','Insira o pagamento',0),(560049,15557,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(560050,15557,'es','Ingresar pago',0),(560051,15557,'de','Geben Sie die Zahlung',0),(560052,15557,'en','Enter Payment',0),(560053,15558,'is','',0),(560054,15558,'dr','Ù…ÙˆÙÙ‚ Ø¨Ù‡ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(560055,15558,'pr','Ù…ÙˆÙÙ‚ Ø¨Ù‡ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(560056,15558,'tr','Girmek baÅŸarÄ±sÄ±z oldu',0),(560057,15558,'pl','Nie udaÅ‚o siÄ™ wprowadziÄ‡',0),(560058,15558,'bg','ÐÐµ ÑƒÑÐ¿Ñ Ð´Ð° Ð²Ð»ÐµÐ·Ðµ',0),(560059,15558,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Û’ Ù…ÛŒÚº Ù†Ø§Ú©Ø§Ù… Ø±ÛØ§',0),(560060,15558,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÐ»Ð¾',0),(560061,15558,'vi','Tháº¥t báº¡i trong viá»‡c nháº­p',0),(560062,15558,'af','Kon nie sleutel',0),(560063,15558,'ro','Nu a reuÅŸit sÄƒ intre',0),(560064,15558,'et','Ei suutnud sisestada',0),(560065,15558,'si','Ne zadostovati vstopiti',0),(560066,15558,'ba','Gagal masuk',0),(560067,15558,'nl','Failed To Voer',0),(560068,15558,'fi','Ei pÃ¤Ã¤stÃ¤',0),(560069,15558,'no','Kan ikke angi',0),(560070,15558,'da','Undladt at angive',0),(560071,15558,'ko','ìž…ë ¥ í•˜ì§€ ëª»í–ˆìŠµë‹ˆë‹¤.',0),(560072,15558,'he','×œ× ×”×¦×œ×™×— ×œ×”×™×›× ×¡',0),(560073,15558,'el','Î‘Ï€Î­Ï„Ï…Ï‡Îµ Î½Î± ÎµÎ¹ÏƒÎ­Î»Î¸Î¿Ï…Î½',0),(560074,15558,'zh','æœªèƒ½è¿›å…¥',0),(560075,15558,'sv','Det gick inte att ange',0),(560076,15558,'it','Non riuscÃ¬ ad entrare',0),(560077,15558,'tl','',0),(560078,15558,'th','à¹€à¸‚à¹‰à¸²à¹„à¸›',0),(560079,15558,'hi','à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤«à¤²',0),(560080,15558,'ms','Gagal untuk memasuki',0),(560081,15558,'ar','ÙØ´Ù„ ÙÙŠ Ø¥Ø¯Ø®Ø§Ù„',0),(560082,15558,'fr','N\'entre pas',0),(560083,15558,'jp','å…¥åŠ›ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(560084,15558,'pt','Falha ao entrar',0),(560085,15558,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð²Ð¾Ð¹Ñ‚Ð¸',0),(560086,15558,'es','No se pudo entrar',0),(560087,15558,'de','Fehler beim eingeben',0),(560088,15558,'en','Failed To Enter',0),(560089,15559,'is','',0),(560090,15559,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø§Ø² Ù¾Ø±Ø´ÛŒÙ† CSV ØµØ§Ø¯Ø±Ø§Øª ÙˆØ§Ø±Ø¯Ø§Øª',0),(560091,15559,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø§Ø² Ù¾Ø±Ø´ÛŒÙ† CSV ØµØ§Ø¯Ø±Ø§Øª ÙˆØ§Ø±Ø¯Ø§Øª',0),(560092,15559,'tr','Faturalar Quickbooks CSV verme etki alanÄ±ndan alma',0),(560093,15559,'pl','Importu faktur z Quickbooks CSV eksportu',0),(560094,15559,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð¾Ñ‚ Quickbooks CSV ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(560095,15559,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ Ø¨Ø±Ø¢Ù…Ø¯ Ø³Û’ Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ CSV Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(560096,15559,'sr','Ð£Ð²Ð¾Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸Ð· QÑƒÐ¸Ñ†ÐºÐ±Ð¾Ð¾ÐºÑ Ð¦Ð¡Ð’ Ð¸Ð·Ð²Ð¾Ð·',0),(560097,15559,'vi','Nháº­p hÃ³a Ä‘Æ¡n tá»« Quickbooks CSV xuáº¥t kháº©u',0),(560098,15559,'af','Fakture vanaf Quickbooks CSV uitvoer invoer',0),(560099,15559,'ro','Facturi de import la Quickbooks CSV Export',0),(560100,15559,'et','Importida arvete Quickbooks CSV ekspordi',0),(560101,15559,'si','Uvozite raÄune od Quickbooks CSV izvoza',0),(560102,15559,'ba','Impor faktur dari Quickbooks CSV ekspor',0),(560103,15559,'nl','Importeren van facturen van Quickbooks CSV Export',0),(560104,15559,'fi','Laskujen tuominen Quickbooks CSV-vienti',0),(560105,15559,'no','Importere fakturaer fra Quickbooks CSV-eksport',0),(560106,15559,'da','Importere fakturaer fra Quickbooks CSV-eksport',0),(560107,15559,'ko','Quickbooks CSV ìˆ˜ì¶œì—ì„œ ì¸ë³´ì´ìŠ¤ ê°€ì ¸ì˜¤ê¸°',0),(560108,15559,'he','×œ×™×™×‘× ×—×©×‘×•× ×™×•×ª ×™×¦×•× Quickbooks CSV',0),(560109,15559,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Î±Ï€ÏŒ Quickbooks CSV ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚',0),(560110,15559,'zh','ä»Ž Quickbooks CSV å¯¼å‡ºå¯¼å…¥å‘ç¥¨',0),(560111,15559,'sv','Importera fakturor frÃ¥n Quickbooks CSV-Export',0),(560112,15559,'it','Importare le fatture da esportazione CSV Quickbooks',0),(560113,15559,'tl','',0),(560114,15559,'th','à¸™à¸³à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸ªà¹ˆà¸‡à¸­à¸­à¸ Quickbooks CSV',0),(560115,15559,'hi','à¤šà¤¾à¤²à¤¾à¤¨ Quickbooks à¤¸à¥€à¤à¤¸à¤µà¥€ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(560116,15559,'ms','Import invois daripada Quickbooks CSV eksport',0),(560117,15559,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ù…Ù† ØªØµØ¯ÙŠØ± CSV Ù‚Ø±Ø§Ø¡',0),(560118,15559,'fr','Factures d\'importation d\'Export CSV de Quickbooks',0),(560119,15559,'jp','Quickbooks ã® CSV ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã‹ã‚‰è«‹æ±‚æ›¸ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(560120,15559,'pt','Importar faturas de exportaÃ§Ã£o CSV de Quickbooks',0),(560121,15559,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€ Ñ Quickbooks CSV ÑÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(560122,15559,'es','ImportaciÃ³n de facturas de exportaciÃ³n CSV de Quickbooks',0),(560123,15559,'de','Importieren von Rechnungen von Quickbooks CSV-Export',0),(560124,15559,'en','Import Invoices From Quickbooks CSV Export',0),(560125,15560,'is','',0),(560126,15560,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ù¾Ø±Ø´ÛŒÙ† Ù…Ø´ØªØ±ÛŒ ØªØ¹Ø§Ø¯Ù„ Ø¬Ø²Ø¦ÛŒØ§Øª CSV ØµØ§Ø¯Ø±Ø§Øª ÙˆØ§Ø±Ø¯Ø§Øª',0),(560127,15560,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ù¾Ø±Ø´ÛŒÙ† Ù…Ø´ØªØ±ÛŒ ØªØ¹Ø§Ø¯Ù„ Ø¬Ø²Ø¦ÛŒØ§Øª CSV ØµØ§Ø¯Ø±Ø§Øª ÙˆØ§Ø±Ø¯Ø§Øª',0),(560128,15560,'tr','Ã–demeler Quickbooks mÃ¼ÅŸteri denge detay CSV verme etki alanÄ±ndan alma',0),(560129,15560,'pl','Importuj pÅ‚atnoÅ›ci z Quickbooks klienta rÃ³wnowagi szczegÃ³Å‚owoÅ›ci CSV eksportu',0),(560130,15560,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð¾Ñ‚ Quickbooks ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð±Ð°Ð»Ð°Ð½Ñ Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ CSV ÐµÐºÑÐ¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(560131,15560,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù‚Ø§Ú©Ø¨ÙˆÚ©Ø³ Ú©Ø³Ù¹Ù…Ø± Ø¨Ù‚Ø§ÛŒØ§ ØªÙØµÛŒÙ„ CSV Ø¨Ø±Ø¢Ù…Ø¯ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(560132,15560,'sr','Ð£Ð²Ð¾Ð· ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð¸Ð· QÑƒÐ¸Ñ†ÐºÐ±Ð¾Ð¾ÐºÑ ÐºÑƒÐ¿Ñ†Ð° ÑÐ°Ð»Ð´Ð¾ Ð´ÐµÑ‚Ð°Ñ™ Ð¦Ð¡Ð’ Ð¸Ð·Ð²Ð¾Ð·',0),(560133,15560,'vi','Nháº­p cÃ¡c khoáº£n thanh toÃ¡n tá»« khÃ¡ch hÃ ng Quickbooks sá»‘ dÆ° chi tiáº¿t xuáº¥t CSV',0),(560134,15560,'af','Invoer van betalings vanaf Quickbooks kliÃ«nt balans Detail CSV uitvoer',0),(560135,15560,'ro','PlÄƒÅ£ile de import la Quickbooks client echilibru detaliu CSV Export',0),(560136,15560,'et','Maksete importimine Quickbooks kliendi saldo Detail CSV ekspordi',0),(560137,15560,'si','Uvoz plaÄil od kupca Quickbooks ravnovesje podrobnosti CSV izvoza',0),(560138,15560,'ba','Impor pembayaran dari Quickbooks Customer keseimbangan Detail CSV ekspor',0),(560139,15560,'nl','Importeren van betalingen van Quickbooks klant evenwicht Detail CSV Export',0),(560140,15560,'fi','-Maksujen tuominen Quickbooks Asiakkaan saldo yksityiskohtaisesti CSV-vienti',0),(560141,15560,'no','Importerer betalinger fra Quickbooks kunden balanse detalj CSV-eksport',0),(560142,15560,'da','Importerer betalinger fra Quickbooks kundens saldo detaljer CSV-eksport',0),(560143,15560,'ko','ì§€ë¶ˆ Quickbooks ê³ ê° ê· í˜• ì„¸ë¶€ CSV ë‚´ë³´ë‚´ê¸°ì—ì„œ ê°€ì ¸ì˜¤ê¸°',0),(560144,15560,'he','×™×‘× ×ª×©×œ×•×ž×™× ×œ×œ×§×•×— Quickbooks ××™×–×•×Ÿ ×¤×™×¨×•×˜ CSV ×™×™×¦×•×',0),(560145,15560,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î±Ï€ÏŒ Quickbooks Ï€ÎµÎ»Î¬Ï„Î· Î¹ÏƒÎ¿ÏÏÎ¿Ï€Î¯Î± Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹Î± CSV ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚',0),(560146,15560,'zh','ä»Ž Quickbooks å®¢æˆ·å¹³è¡¡ç»†èŠ‚ CSV å¯¼å‡ºå¯¼å…¥ä»˜æ¬¾',0),(560147,15560,'sv','Importera betalningar frÃ¥n Quickbooks kund balans detalj CSV-Export',0),(560148,15560,'it','Importare i pagamenti da clienti Quickbooks equilibrio dettaglio CSV Export',0),(560149,15560,'tl','',0),(560150,15560,'th','à¸™à¸³à¹€à¸‡à¸´à¸™à¸ªà¹ˆà¸‡à¸­à¸­à¸ CSV à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸² Quickbooks',0),(560151,15560,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ Quickbooks à¤—à¥à¤°à¤¾à¤¹à¤• à¤¶à¥‡à¤· à¤µà¤¿à¤¸à¥à¤¤à¤¾à¤° à¤¸à¥€à¤à¤¸à¤µà¥€ à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(560152,15560,'ms','Import pembayaran daripada pelanggan Quickbooks baki terperinci CSV eksport',0),(560153,15560,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ù…Ù† Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù‚Ø±Ø§Ø¡ Ø§Ù„ØªÙˆØ§Ø²Ù† Ø§Ù„ØªÙØµÙŠÙ„ CSV ØªØµØ¯ÙŠØ±',0),(560154,15560,'fr','Importer des paiements de client de Quickbooks Balance dÃ©tail CSV exportation',0),(560155,15560,'jp','Quickbooks é¡§å®¢æ®‹é«˜è©³ç´° CSV ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆã‹ã‚‰æ”¯æ‰•ã„ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(560156,15560,'pt','Pagamentos de importaÃ§Ã£o de exportaÃ§Ã£o CSV do Quickbooks cliente equilÃ­brio detalhe',0),(560157,15560,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð¸Ð· Quickbooks ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð±Ð°Ð»Ð°Ð½Ñ Ð´ÐµÑ‚Ð°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ð¸ CSV ÑÐºÑÐ¿Ð¾Ñ€Ñ‚',0),(560158,15560,'es','Importar los pagos de cliente de Quickbooks Balance detalle CSV ExportaciÃ³n',0),(560159,15560,'de','Import von Zahlungen aus CSV-Export fÃ¼r Quickbooks Customer Balance-Detail',0),(560160,15560,'en','Import Payments From Quickbooks Customer Balance Detail CSV Export',0),(560161,15561,'is','',0),(560162,15561,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(560163,15561,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(560164,15561,'tr','Girilen yeni Ã¶demeler',0),(560165,15561,'pl','Nowe pÅ‚atnoÅ›ci wszedÅ‚',0),(560166,15561,'bg','ÐÐ¾Ð²Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÐ½Ð¸',0),(560167,15561,'ur','Ø¯Ø§Ø®Ù„ Ú©Ø±Ø¯Û Ù†ÛŒØ§ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(560168,15561,'sr','ÐÐ¾Ð²Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ ÑƒÑˆÐ°Ð¾',0),(560169,15561,'vi','Khoáº£n thanh toÃ¡n má»›i nháº­p',0),(560170,15561,'af','Nuwe betalings ingetik',0),(560171,15561,'ro','PlÄƒÅ£i nou intrat',0),(560172,15561,'et','Uus makseid, mis on sisestatud',0),(560173,15561,'si','Nova plaÄila zaÄel',0),(560174,15561,'ba','Pembayaran baru masuk',0),(560175,15561,'nl','Nieuwe betalingen ingevoerd',0),(560176,15561,'fi','Uudet tuet tuli',0),(560177,15561,'no','Nye betalinger som er angitt',0),(560178,15561,'da','Nye betalinger indtastet',0),(560179,15561,'ko','ìƒˆë¡œìš´ ì§€ë¶ˆ ìž…ë ¥',0),(560180,15561,'he','×ª×©×œ×•×ž×™× ×—×“×©×™× ×©×”×•×–× ×•',0),(560181,15561,'el','ÎÎ­ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… ÎµÎ³Î³ÏÎ¬Ï†Î¿Î½Ï„Î±Î¹',0),(560182,15561,'zh','æ–°çš„ä»˜æ¬¾è¾“å…¥',0),(560183,15561,'sv','Nya betalningar in',0),(560184,15561,'it','Nuovi pagamenti immessi',0),(560185,15561,'tl','',0),(560186,15561,'th','à¸›à¹‰à¸­à¸™à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(560187,15561,'hi','à¤¨à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾',0),(560188,15561,'ms','Pembayaran baru yang memasuki',0),(560189,15561,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø§Ù„ØªÙŠ Ø¯Ø®Ù„Øª',0),(560190,15561,'fr','Nouveaux paiements inscrits',0),(560191,15561,'jp','æ–°ã—ã„æ”¯æ‰•å…¥åŠ›',0),(560192,15561,'pt','Novos pagamentos entrados',0),(560193,15561,'ru','Ð’Ð²ÐµÐ´ÐµÐ½Ñ‹ Ð½Ð¾Ð²Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(560194,15561,'es','Nuevos pagos entrados',0),(560195,15561,'de','Neue Zahlungen eingegeben',0),(560196,15561,'en','New Payments Entered',0),(560197,15562,'is','',0),(560198,15562,'dr','Ù‡ÛŒÚ† ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø§Ø² ÛŒØ§ÙØª Ø¨Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡',0),(560199,15562,'pr','Ù‡ÛŒÚ† ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨Ø§Ø² ÛŒØ§ÙØª Ø¨Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡',0),(560200,15562,'tr','HiÃ§bir aÃ§Ä±k faturalarÄ±n Ã¶deme iÃ§in uygulamak iÃ§in bulundu',0),(560201,15562,'pl','Nie otwartych rachunkÃ³w znaleÅºÄ‡ zastosowanie pÅ‚atnoÅ›ci do',0),(560202,15562,'bg','ÐÑÐ¼Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸, Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð´Ð° Ð¿Ñ€Ð¸Ð»Ð¾Ð¶Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÐºÑŠÐ¼',0),(560203,15562,'ur','Ú©ÙˆØ¦ÛŒ Ú©Ú¾Ù„ÛŒ ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¯ÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…Ù„Ø§',0),(560204,15562,'sr','ÐÐµÐ¼Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÑƒÑ‚Ð²Ñ€Ñ’ÐµÐ½Ð¾ Ð´Ð° Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð´Ð°',0),(560205,15562,'vi','KhÃ´ng cÃ³ hoÃ¡ Ä‘Æ¡n má»Ÿ tháº¥y Ã¡p dá»¥ng Ä‘á»ƒ thanh toÃ¡n',0),(560206,15562,'af','Geen oop fakture gevind om betaling aan te wend',0),(560207,15562,'ro','Nr facturi deschis gÄƒsit sÄƒ aplicaÅ£i plata la',0),(560208,15562,'et','Ole avatud arvete makse kohaldada leitud',0),(560209,15562,'si','Ni odprtih raÄunov, ki ugotovi, da uporablja plaÄilo',0),(560210,15562,'ba','Faktur tidak terbuka ditemukan untuk menerapkan pembayaran',0),(560211,15562,'nl','Geen openstaande facturen gevonden om betaling te vereffenen',0),(560212,15562,'fi','Avaa laskuja ei lÃ¶ydy soveltaa maksu',0),(560213,15562,'no','Ingen Ã¥pne fakturaer funnet gjelder betaling',0),(560214,15562,'da','Ingen Ã¥bne fakturaer fundet at anvende betalingen til',0),(560215,15562,'ko','ì•„ë‹ˆ ì˜¤í”ˆ ì²­êµ¬ì„œë¥¼ ì§€ë¶ˆì„ ì ìš©ì„ ë°œê²¬í•©ë‹ˆë‹¤',0),(560216,15562,'he','×œ× × ×ž×¦××• ×›×“×™ ×œ×”×—×™×œ ×ª×©×œ×•× ×—×©×‘×•× ×™×•×ª ×¤×ª×•×—×•×ª',0),(560217,15562,'el','ÎšÎ±Î½Î­Î½Î± Î¬Î½Î¿Î¹Î³Î¼Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± ÎµÏ†Î±ÏÎ¼Î¿Î³Î® Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î½Î±',0),(560218,15562,'zh','æ²¡æœ‰æ‰“å¼€çš„å‘ç¥¨ï¼Œå‘çŽ°ç”³è¯·åˆ°ä»˜æ¬¾',0),(560219,15562,'sv','Inga Ã¶ppna fakturor hittade gÃ¤lla betalning till',0),(560220,15562,'it','Nessun fatture aperte trovate per applicare il pagamento a',0),(560221,15562,'tl','',0),(560222,15562,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸›à¸´à¸”à¹„à¸¡à¹ˆà¸žà¸šà¸à¸²à¸£à¹ƒà¸Šà¹‰à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(560223,15562,'hi','à¤•à¥‹à¤ˆ à¤–à¥à¤²à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¿à¤²à¤¾',0),(560224,15562,'ms','Invois tidak dibuka mendapati membuat pembayaran kepada',0),(560225,15562,'ar','Ù„Ø§ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙØªÙˆØ­Ø© Ø§Ù„ØªÙŠ ÙˆØ¬Ø¯Øª Ù„ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø¯ÙØ¹ Ø¥Ù„Ù‰',0),(560226,15562,'fr','Aucune facture ouverte pouvant s\'appliquer le paiement Ã ',0),(560227,15562,'jp','æœªæ±ºæ¸ˆã®è«‹æ±‚æ›¸ã¯æ”¯æ‰•ã‚’é©ç”¨å¯èƒ½ãªå­˜åœ¨',0),(560228,15562,'pt','NÃ£o encontradas para aplicar o pagamento para as faturas em aberto',0),(560229,15562,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾ Ð¿Ñ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(560230,15562,'es','No facturas abiertas a aplicar el pago a',0),(560231,15562,'de','Keine offenen Rechnungen gefunden, um die Zahlung zu Ã¼bernehmen',0),(560232,15562,'en','No Open Invoices Found To Apply Payment To',0),(560233,15563,'is','',0),(560234,15563,'dr','Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù¾Ø±ÛŒØ¯',0),(560235,15563,'pr','Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù¾Ø±ÛŒØ¯',0),(560236,15563,'tr','Ã–deme kaydÄ± atlandÄ±',0),(560237,15563,'pl','Rekord pÅ‚atnoÅ›ci pomijane',0),(560238,15563,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð·Ð°Ð¿Ð¸Ñ ÐºÐ°Ð¿Ð¸Ñ‚Ð°Ð½',0),(560239,15563,'ur','Ø§Ú†Ù¹ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(560240,15563,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ð·Ð°Ð¿Ð¸Ñ Ð¿Ñ€ÐµÑÐºÐ¾Ñ‡ÐµÐ½Ð°',0),(560241,15563,'vi','Há»“ sÆ¡ thanh toÃ¡n Ä‘Ã£ bá» qua',0),(560242,15563,'af','Betaling rekord oorgeslaan',0),(560243,15563,'ro','Record de platÄƒ de sarit',0),(560244,15563,'et','Makse kirje vahele',0),(560245,15563,'si','PlaÄilo zapis skakaÄ',0),(560246,15563,'ba','Catatan pembayaran melewatkan',0),(560247,15563,'nl','Betaling Record overgeslagen',0),(560248,15563,'fi','Maksutietueeseen ohitetaan',0),(560249,15563,'no','Betalingspostfil hoppet over',0),(560250,15563,'da','Betalingspost springes over',0),(560251,15563,'ko','ì§€ë¶ˆ ê¸°ë¡ ìƒëžµ',0),(560252,15563,'he','×©×™× ×”×ª×©×œ×•× ×‘×•×¦×¢ ×“×™×œ×•×’',0),(560253,15563,'el','Î•Î³Î³ÏÎ±Ï†Î® Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… Ï€Î±ÏÎ±Î»ÎµÎ¯Ï†Î¸Î·ÎºÎ±Î½',0),(560254,15563,'zh','ä»˜æ¬¾è®°å½•è·³è¿‡',0),(560255,15563,'sv','Betalningsposten hoppas Ã¶ver',0),(560256,15563,'it','Record di pagamento saltato',0),(560257,15563,'tl','',0),(560258,15563,'th','à¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¹‰à¸²à¸¡',0),(560259,15563,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤•à¥‹ à¤›à¥‹à¤¡à¤¼ à¤¦à¤¿à¤¯à¤¾',0),(560260,15563,'ms','Rekod pembayaran yang dilangkau',0),(560261,15563,'ar','Ø³Ø¬Ù„ Ø¯ÙØ¹ ØªØ®Ø·ÙŠ',0),(560262,15563,'fr','Enregistrement de paiement sautÃ©',0),(560263,15563,'jp','æ”¯æ‰•ã„ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’ã‚¹ã‚­ãƒƒãƒ—',0),(560264,15563,'pt','Registro de pagamento ignorado',0),(560265,15563,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ Ð¾Ð± Ð¾Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¿ÑƒÑ‰ÐµÐ½',0),(560266,15563,'es','Registro de pago omitido',0),(560267,15563,'de','Zahlungsmoral Ã¼bersprungen',0),(560268,15563,'en','Payment Record Skipped',0),(560269,15564,'is','',0),(560270,15564,'dr','Ù…Ù‚Ø§ÛŒØ³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(560271,15564,'pr','Ù…Ù‚Ø§ÛŒØ³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(560272,15564,'tr','SatÄ±cÄ± fiyat karÅŸÄ±laÅŸtÄ±rma',0),(560273,15564,'pl','PorÃ³wnaÄ‡ dostawcy cen',0),(560274,15564,'bg','Ð¡Ñ€Ð°Ð²Ð½ÐµÑ‚Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ñ†ÐµÐ½Ð¾Ð¾Ð±Ñ€Ð°Ð·ÑƒÐ²Ð°Ð½Ðµ',0),(560275,15564,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† ÙˆÛŒÙ†ÚˆØ± Ú©Ø§ Ù…ÙˆØ§Ø²Ù†Û Ú©Ø±ÛŒÚº',0),(560276,15564,'sr','Ð£Ð¿Ð¾Ñ€ÐµÐ´Ð¸Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(560277,15564,'vi','So sÃ¡nh cÃ¡c nhÃ  cung cáº¥p giÃ¡ cáº£',0),(560278,15564,'af','Handelaar pryse vergelyk',0),(560279,15564,'ro','Compara furnizor de stabilire a preÅ£urilor',0),(560280,15564,'et','VÃµrdle Hinnakujundus hankija',0),(560281,15564,'si','Primerjati cene dobavitelja',0),(560282,15564,'ba','Bandingkan Vendor harga',0),(560283,15564,'nl','Leverancier prijzen vergelijken',0),(560284,15564,'fi','Vertaa Hinnoittelu toimittajan',0),(560285,15564,'no','Sammenligne leverandÃ¸rer priser',0),(560286,15564,'da','Sammenligne sÃ¦lgeren priser',0),(560287,15564,'ko','ê³µê¸‰ ì—…ì²´ ê°€ê²© ë¹„êµ',0),(560288,15564,'he','×œ×”×©×•×•×ª ×‘×™×Ÿ ×”×¡×¤×§ ×ª×ž×—×•×¨',0),(560289,15564,'el','Î£Ï…Î³ÎºÏÎ¯Î½ÎµÏ„Îµ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(560290,15564,'zh','æ¯”è¾ƒä¾›åº”å•†çš„å®šä»·',0),(560291,15564,'sv','JÃ¤mfÃ¶ra leverantÃ¶r prissÃ¤ttning',0),(560292,15564,'it','Confronta prezzi Fornitore',0),(560293,15564,'tl','',0),(560294,15564,'th','à¹€à¸›à¸£à¸µà¸¢à¸šà¹€à¸—à¸µà¸¢à¸šà¸£à¸²à¸„à¸²à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(560295,15564,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾ à¤•à¤°à¥‡à¤‚',0),(560296,15564,'ms','Bandingkan harga Penjual',0),(560297,15564,'ar','Ù‚Ø§Ø±Ù† Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(560298,15564,'fr','Comparer les fournisseurs des prix',0),(560299,15564,'jp','ä»•å…¥å…ˆã®ä¾¡æ ¼ã‚’æ¯”è¼ƒã—ã¾ã™ã€‚',0),(560300,15564,'pt','Compare preÃ§os de fornecedor',0),(560301,15564,'ru','Ð¡Ñ€Ð°Ð²Ð½Ð¸Ñ‚Ðµ Ñ†ÐµÐ½Ñ‹ Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(560302,15564,'es','Comparar precios de proveedores',0),(560303,15564,'de','Anbieter, die Preise zu vergleichen',0),(560304,15564,'en','Compare Vendor Pricing',0),(560305,15565,'is','',0),(560306,15565,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯',0),(560307,15565,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯',0),(560308,15565,'tr','Yeni maliyet',0),(560309,15565,'pl','Koszt nowego',0),(560310,15565,'bg','ÐÐ¾Ð²Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(560311,15565,'ur','Ù†Ø¦ÛŒ Ù‚ÛŒÙ…Øª',0),(560312,15565,'sr','ÐÐ¾Ð²Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(560313,15565,'vi','Má»›i chi phÃ­',0),(560314,15565,'af','Nuwe koste',0),(560315,15565,'ro','Cost nou',0),(560316,15565,'et','Uus maksumus',0),(560317,15565,'si','Nov stroÅ¡ek',0),(560318,15565,'ba','Biaya baru',0),(560319,15565,'nl','Nieuwe kosten',0),(560320,15565,'fi','Uusi kustannus',0),(560321,15565,'no','Nye kostnader',0),(560322,15565,'da','Ny pris',0),(560323,15565,'ko','ìƒˆë¡œìš´ ë¹„ìš©',0),(560324,15565,'he','×¢×œ×•×ª ×—×“×©×”',0),(560325,15565,'el','ÎÎ­Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(560326,15565,'zh','æ–°çš„æˆæœ¬',0),(560327,15565,'sv','Nya kostnaden',0),(560328,15565,'it','Nuovo costo',0),(560329,15565,'tl','',0),(560330,15565,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(560331,15565,'hi','à¤¨à¤ˆ à¤²à¤¾à¤—à¤¤',0),(560332,15565,'ms','Kos baru',0),(560333,15565,'ar','ØªÙƒÙ„ÙØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(560334,15565,'fr','Nouveau prix',0),(560335,15565,'jp','æ–°ã—ã„ã‚³ã‚¹ãƒˆ',0),(560336,15565,'pt','Novo custo',0),(560337,15565,'ru','ÐÐ¾Ð²Ð°Ñ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(560338,15565,'es','Nuevo costo',0),(560339,15565,'de','Neue Kosten',0),(560340,15565,'en','New Cost',0),(560341,15566,'is','',0),(560342,15566,'dr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ø¯ÛŒØ¯',0),(560343,15566,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø¬Ø¯ÛŒØ¯',0),(560344,15566,'tr','Yeni miktar',0),(560345,15566,'pl','IloÅ›Ä‡ nowych',0),(560346,15566,'bg','ÐÐ¾Ð²Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(560347,15566,'ur','Ù†Ø¦Û’ Ù…Ù‚Ø¯Ø§Ø±',0),(560348,15566,'sr','ÐÐ¾Ð²Ñƒ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(560349,15566,'vi','Sá»‘ lÆ°á»£ng má»›i',0),(560350,15566,'af','Nuwe hoeveelheid',0),(560351,15566,'ro','Noua cantitate',0),(560352,15566,'et','Uus kogus',0),(560353,15566,'si','Novo koliÄino',0),(560354,15566,'ba','Jumlah baru',0),(560355,15566,'nl','Nieuwe hoeveelheid',0),(560356,15566,'fi','Uusi mÃ¤Ã¤rÃ¤',0),(560357,15566,'no','Nye antallet',0),(560358,15566,'da','Nye mÃ¦ngde',0),(560359,15566,'ko','ìƒˆë¡œìš´ ìˆ˜ëŸ‰',0),(560360,15566,'he','×”×›×ž×•×ª ×”×—×“×©×”',0),(560361,15566,'el','ÎÎ­Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(560362,15566,'zh','æ–°çš„æ•°é‡',0),(560363,15566,'sv','Ny kvantitet',0),(560364,15566,'it','Nuova quantitÃ ',0),(560365,15566,'tl','',0),(560366,15566,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹ƒà¸«à¸¡à¹ˆ',0),(560367,15566,'hi','à¤¨à¤ˆ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(560368,15566,'ms','Kuantiti yang baru',0),(560369,15566,'ar','ÙƒÙ…ÙŠØ© Ø¬Ø¯ÙŠØ¯Ø©',0),(560370,15566,'fr','Nouvelle quantitÃ©',0),(560371,15566,'jp','æ–°ã—ã„æ•°é‡',0),(560372,15566,'pt','Nova quantidade',0),(560373,15566,'ru','ÐÐ¾Ð²Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾',0),(560374,15566,'es','Nueva cantidad',0),(560375,15566,'de','Neue Menge',0),(560376,15566,'en','New Quantity',0),(560377,15567,'is','',0),(560378,15567,'dr','Ø¨Ø§Ù†Ú© Ùˆ Ø¨ÛŒÙ…Ù‡ & Ù…Ø¹Ù…Ø§Ø±',0),(560379,15567,'pr','Ø¨Ø§Ù†Ú© Ùˆ Ø¨ÛŒÙ…Ù‡ & Ù…Ø¹Ù…Ø§Ø±',0),(560380,15567,'tr','Banka, sigorta ve mimar',0),(560381,15567,'pl','Bankowe, ubezpieczenia idealna architekt',0),(560382,15567,'bg','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð¸, Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð½Ð¸ & Ð°Ñ€Ñ…Ð¸Ñ‚ÐµÐºÑ‚',0),(560383,15567,'ur','Ø¨ÛŒÙ†Ú©ØŒ Ø§Ù†Ø´ÙˆØ±Ù†Ø³ & Ù…Ø¹Ù…Ø§Ø±',0),(560384,15567,'sr','Ð‘Ð°Ð½ÐºÐµ , Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐµ Ð¸ Ð°Ñ€Ñ…Ð¸Ñ‚ÐµÐºÑ‚Ð°',0),(560385,15567,'vi','NgÃ¢n hÃ ng, báº£o hiá»ƒm & kiáº¿n trÃºc sÆ°',0),(560386,15567,'af','Bank, versekering & argitek',0),(560387,15567,'ro','Bancare, de asigurÄƒri & arhitect',0),(560388,15567,'et','Panga-, kindlustus- & arhitekt',0),(560389,15567,'si','Banke, zavarovanja & arhitekt',0),(560390,15567,'ba','Bank, asuransi & arsitek',0),(560391,15567,'nl','Bank, verzekeringen & Architect',0),(560392,15567,'fi','Pankki, vakuutus & arkkitehti',0),(560393,15567,'no','Bank, forsikring & arkitekt',0),(560394,15567,'da','Bank, forsikring & arkitekt',0),(560395,15567,'ko','ì€í–‰, ë³´í—˜ ë° ê±´ì¶•ê°€',0),(560396,15567,'he','×”×‘× ×§, ×‘×™×˜×•×— & ××“×¨×™×›×œ',0),(560397,15567,'el','Î¤ÏÎ¬Ï€ÎµÎ¶Î±, Î±ÏƒÏ†Î±Î»Î¹ÏƒÏ„Î¹ÎºÎ® & Î‘ÏÏ‡Î¹Ï„Î­ÎºÏ„Ï‰Î½',0),(560398,15567,'zh','é“¶è¡Œã€ ä¿é™©ä¸Žå»ºç­‘å¸ˆ',0),(560399,15567,'sv','Bank, fÃ¶rsÃ¤kring & arkitekt',0),(560400,15567,'it','Banca, assicurazione & architetto',0),(560401,15567,'tl','',0),(560402,15567,'th','à¸˜à¸™à¸²à¸„à¸²à¸£ à¸›à¸£à¸°à¸à¸±à¸™à¸ à¸±à¸¢ à¹à¸¥à¸°à¸ªà¸–à¸²à¸›à¸™à¸´à¸',0),(560403,15567,'hi','à¤¬à¥ˆà¤‚à¤•, à¤¬à¥€à¤®à¤¾ & à¤µà¤¾à¤¸à¥à¤¤à¥à¤•à¤¾à¤°',0),(560404,15567,'ms','Bank, insurans & Arkitek',0),(560405,15567,'ar','Ø§Ù„Ù…ØµØ±ÙÙŠØ©ØŒ ÙˆØ§Ù„ØªØ£Ù…ÙŠÙ† Ø¢Ù†Ø¯ Ø§Ù„Ù…Ø¹Ù…Ø§Ø±ÙŠ',0),(560406,15567,'fr','Banque, assurance & architecte',0),(560407,15567,'jp','éŠ€è¡Œã€ä¿é™ºãƒ»å»ºç¯‰å®¶',0),(560408,15567,'pt','Banco, seguros e arquiteto',0),(560409,15567,'ru','Ð‘Ð°Ð½Ðº, ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ðµ & Ð°Ñ€Ñ…Ð¸Ñ‚ÐµÐºÑ‚Ð¾Ñ€',0),(560410,15567,'es','Banco, seguros y arquitecto',0),(560411,15567,'de','Bank, Versicherung & Architekt',0),(560412,15567,'en','Bank, Insurance & Architect',0),(560413,15568,'is','',0),(560414,15568,'dr','Ø­Ø°Ù Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§Ù†Ø¬Ø§Ù… Ø¯Ù‡Ø¯: Ù…ÙˆØ¬ÙˆØ¯ ØµÙ†Ø¯ÙˆÙ‚/Ø´ Ø±Ø³ÛŒØ¯ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(560415,15568,'pr','Ø­Ø°Ù Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§Ù†Ø¬Ø§Ù… Ø¯Ù‡Ø¯: Ù…ÙˆØ¬ÙˆØ¯ ØµÙ†Ø¯ÙˆÙ‚/Ø´ Ø±Ø³ÛŒØ¯ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(560416,15568,'tr','Silme iÅŸlemini gerÃ§ekleÅŸtiremezsiniz: PO/SB makbuzlarÄ± mevcut vardÄ±r',0),(560417,15568,'pl','Nie moÅ¼na wykonaÄ‡ usuwanie: SÄ… istniejÄ…ce PO/SB wpÅ‚ywÃ³w',0),(560418,15568,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¸Ð·Ð¿ÑŠÐ»Ð½ÑÐ²Ð° Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ: Ð˜Ð¼Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ PO/SB Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ¸',0),(560419,15568,'ur','Ø­Ø°Ù Ø§Ù†Ø¬Ø§Ù… Ù†ÛÛŒÚº Ø¯Û’ Ø³Ú©ØªØ§: ÛÛŒÚº Ù…ÙˆØ¬ÙˆØ¯Û Ù¾Ùˆ ÙØ±ÛŒØ¶Û Ø³Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯Û’ Ø±Ø³ÛŒØ¯ÛŒÚº',0),(560420,15568,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¸Ð·Ð²Ñ€ÑˆÐ¸Ñ‚Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÐµ: ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð° ÐŸÐž/Ð¡Ð‘',0),(560421,15568,'vi','KhÃ´ng thá»ƒ thá»±c hiá»‡n viá»‡c xÃ³a: KhÃ´ng cÃ³ biÃªn lai PO/SB sáºµn cÃ³',0),(560422,15568,'af','Kan verrig skrapping: Daar is bestaande PO/SB kwitansies',0),(560423,15568,'ro','Nu pot efectua È™tergerea: ExistÄƒ existente PO/SB Ã®ncasÄƒri',0),(560424,15568,'et','Kustutamist ei saa kÃ¤itada: On olemasolevate PO/SB kviitungid',0),(560425,15568,'si','Ne more izvesti brisanja: Obstajajo obstojeÄih prejemki PO/SB',0),(560426,15568,'ba','Tidak dapat melakukan penghapusan: Ada ada PO/SB penerimaan',0),(560427,15568,'nl','Kan de verwijdering niet uitvoeren: Er zijn bestaande PO/SB ontvangsten',0),(560428,15568,'fi','TehdÃ¤ poisto: On olemassa PO/SB vastaanotot',0),(560429,15568,'no','Kan ikke utfÃ¸re sletting: Det finnes eksisterende PO/SB mottak',0),(560430,15568,'da','Kan ikke udfÃ¸re sletning: Der er eksisterende PO/SB kvitteringer',0),(560431,15568,'ko','ê¸°ì¡´ í¬/SB ì˜ìˆ˜ì¦ ìžˆìŠµë‹ˆë‹¤ ì‚­ì œë¥¼ ìˆ˜í–‰í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤:',0),(560432,15568,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×‘×¦×¢ ×ž×—×™×§×”: ×™×©× × ×§×™×™×ž×•×ª ×”×§×‘×œ×•×ª ×¤×•/SB',0),(560433,15568,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎºÏ„ÎµÎ»Î­ÏƒÎµÎ¹ Î´Î¹Î±Î³ÏÎ±Ï†Î®: Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎµÏ‚ Î±Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ PO/SB',0),(560434,15568,'zh','ä¸èƒ½æ‰§è¡Œåˆ é™¤: æœ‰çŽ°æœ‰çš„å¤§åŸ”/æŸäººæ”¶æ®',0),(560435,15568,'sv','GÃ¥r inte att utfÃ¶ra borttagning: Det finns befintliga PO/SB kvitton',0),(560436,15568,'it','Non Ã¨ possibile eseguire l\'eliminazione: Ci sono conferme di PO/SB esistenti',0),(560437,15568,'tl','',0),(560438,15568,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸—à¸³à¸à¸²à¸£à¸¥à¸š: à¸¡à¸µà¹ƒà¸š PO/SB à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(560439,15568,'hi','à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾: à¤µà¤¹à¤¾à¤ à¤¹à¥ˆà¤‚ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ PO/SB à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿',0),(560440,15568,'ms','Tidak dapat melaksanakan penghapusan: Terdapat resit PO/SB sedia ada',0),(560441,15568,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø¥Ø¬Ø±Ø§Ø¡ Ø§Ù„Ø­Ø°Ù: Ù‡Ù†Ø§Ùƒ Ø¨Ùˆ/SB Ø§Ù„Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(560442,15568,'fr','Impossible d\'exÃ©cuter suppression : Il y a reÃ§us de PO/SB existant',0),(560443,15568,'jp','æ—¢å­˜ã® PO/SB é ˜åŽæ›¸ãŒã‚ã‚Šã¾ã™å‰Šé™¤ã‚’å®Ÿè¡Œã§ãã¾ã›ã‚“ã€‚',0),(560444,15568,'pt','NÃ£o Ã© possÃ­vel executar a exclusÃ£o: Existem recibos de PO/SB existentes',0),(560445,15568,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ðµ: Ð•ÑÑ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð¿Ð¾ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ PO/SB',0),(560446,15568,'es','No puede realizar la eliminaciÃ³n: Hay recibos PO/SB existente',0),(560447,15568,'de','LÃ¶schung kann nicht ausgefÃ¼hrt werden: Sind vorhandene PO/SB-Belege',0),(560448,15568,'en','Cannot Perform Deletion: There Are Existing PO/SB Receipts',0),(560449,15569,'is','',0),(560450,15569,'dr','Ø­Ø°Ù Ù‡Ù…Ù‡ Ù¾Ùˆ/Ø´ & Ú©Ø§Ø± Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯Ø§Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±',0),(560451,15569,'pr','Ø­Ø°Ù Ù‡Ù…Ù‡ Ù¾Ùˆ/Ø´ & Ú©Ø§Ø± Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯Ø§Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±',0),(560452,15569,'tr','Ä°ÅŸ iÃ§in tÃ¼m PO/SB ve iÅŸ bÃ¼tÃ§e verilerini sil',0),(560453,15569,'pl','UsuÅ„ wszystkie PO/SB idealna praca budÅ¼etu danych do pracy',0),(560454,15569,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹ Ð²ÑÐ¸Ñ‡ÐºÐ¸ PO/SB & Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(560455,15569,'ur','Ø³Ø¨ Ù¾Ùˆ ÙØ±ÛŒØ¶Û Ø³Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯Û’ & Ù…Ù„Ø§Ø²Ù…Øª Ø¨Ø¬Ù¹ Ú©ÙˆØ§Ø¦Ù Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù„Ø¦Û’ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(560456,15569,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ ÑÐ²Ðµ ÐŸÐž/Ð¡Ð‘ & Ð¿Ð¾ÑÐ°Ð¾ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð±ÑƒÑŸÐµÑ‚Ñƒ Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(560457,15569,'vi','XÃ³a táº¥t cáº£ cÃ¡c PO/SB & viá»‡c ngÃ¢n sÃ¡ch dá»¯ liá»‡u cho cÃ´ng viá»‡c',0),(560458,15569,'af','Skrap alle PO/SB & werk begroting Data vir werk',0),(560459,15569,'ro','Åžterge toate PO/SB & Job date pentru Job',0),(560460,15569,'et','Kustuta kÃµik PO/SB- & tÃ¶Ã¶ eelarve andmete tÃ¶Ã¶',0),(560461,15569,'si','Izbrisati vse PO/SB & delo podatke o proraÄunu za delo',0),(560462,15569,'ba','Menghapus semua PO/SB & Data pekerjaan anggaran untuk pekerjaan',0),(560463,15569,'nl','Verwijder alle PO/SB & begrotingsgegevens baan voor baan',0),(560464,15569,'fi','Poista kaikki PO/SB & tyÃ¶ budjettitiedot tyÃ¶',0),(560465,15569,'no','Slette alle PO/SB & jobb budsjettdata For jobben',0),(560466,15569,'da','Slet alle PO/SB & Job budgetdata For Job',0),(560467,15569,'ko','ìž‘ì—…ì— ëŒ€ í•œ ëª¨ë“  í¬/SB ë° ìž‘ì—… ì˜ˆì‚° ë°ì´í„°ë¥¼ ì‚­ì œ',0),(560468,15569,'he','×ž×—×™×§×ª ×›×œ ×¤×•/SB & × ×ª×•× ×™ ×ª×§×¦×™×‘ ×¢×‘×•×“×” ×œ×¢×‘×•×“×”',0),(560469,15569,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ ÏŒÎ»Î± PO/SB & ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î³Î¹Î± ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(560470,15569,'zh','åˆ é™¤æ‰€æœ‰ PO/æŸäºº & å·¥ä½œé¢„ç®—æ•°æ®çš„å·¥ä½œ',0),(560471,15569,'sv','Ta bort alla PO/SB & jobb budgetdata fÃ¶r jobb',0),(560472,15569,'it','Elimina tutti i PO/SB & lavoro Budget dati per lavoro',0),(560473,15569,'tl','',0),(560474,15569,'th','à¸¥à¸šà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸” PO/SB à¹à¸¥à¸°à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸‡à¸²à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸‡à¸²à¸™',0),(560475,15569,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ PO/SB & à¤•à¤¾à¤°à¥à¤¯ à¤¬à¤œà¤Ÿ à¤¡à¥‡à¤Ÿà¤¾ à¤¹à¤Ÿà¤¾à¤à¤',0),(560476,15569,'ms','Menghapuskan semua PO/SB & Data bajet kerja bagi kerja',0),(560477,15569,'ar','Ø­Ø°Ù Ø¬Ù…ÙŠØ¹ Ø¨Ùˆ/SB & Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„ÙˆØ¸ÙŠÙØ© Ù„Ù„ÙˆØ¸ÙŠÙØ©',0),(560478,15569,'fr','Supprimer tous les PO/SB & donnÃ©es de Budget des postes d\'emploi',0),(560479,15569,'jp','ã‚¸ãƒ§ãƒ–ã®ã™ã¹ã¦ã® PO/SB ãƒ»ä»•äº‹ã®äºˆç®—ãƒ‡ãƒ¼ã‚¿ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(560480,15569,'pt','Excluir todos os PO/SB & trabalho orÃ§amento dados para trabalho',0),(560481,15569,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð²ÑÐµ PO/SB & Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð´Ð»Ñ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(560482,15569,'es','Borrar todos de PO/SB & datos del presupuesto de trabajo para trabajo',0),(560483,15569,'de','LÃ¶schen Sie alle PO/SB & Budgetdaten Job fÃ¼r Job',0),(560484,15569,'en','Delete All PO/SB & Job Budget Data For Job',0),(560485,15570,'is','',0),(560486,15570,'dr','Ú©Ø§Ø± ØºÛŒØ± ÙØ¹Ø§Ù„',0),(560487,15570,'pr','Ú©Ø§Ø± ØºÛŒØ± ÙØ¹Ø§Ù„',0),(560488,15570,'tr','Ä°ÅŸ etkin olmayan',0),(560489,15570,'pl','Zadanie nieaktywne',0),(560490,15570,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð¸',0),(560491,15570,'ur','Ú©Ø§Ù… ØºÛŒØ± ÙØ¹Ø§Ù„',0),(560492,15570,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ð°',0),(560493,15570,'vi','CÃ´ng viá»‡c khÃ´ng hoáº¡t Ä‘á»™ng',0),(560494,15570,'af','Werk onaktief',0),(560495,15570,'ro','Job inactiv',0),(560496,15570,'et','TÃ¶Ã¶ mitteaktiivsete',0),(560497,15570,'si','Delo, ki je neaktivna',0),(560498,15570,'ba','Pekerjaan tidak aktif',0),(560499,15570,'nl','Baan inactief',0),(560500,15570,'fi','TyÃ¶ aktiivinen',0),(560501,15570,'no','Jobb inaktiv',0),(560502,15570,'da','Job inaktive',0),(560503,15570,'ko','ë¹„í™œì„± ìž‘ì—…',0),(560504,15570,'he','×”×¢×‘×•×“×” ×œ× ×¤×¢×™×œ',0),(560505,15570,'el','Î‘Î½ÎµÎ½ÎµÏÎ³Î® ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(560506,15570,'zh','å¤„äºŽéžæ´»åŠ¨çŠ¶æ€çš„å·¥ä½œ',0),(560507,15570,'sv','Jobb inaktiva',0),(560508,15570,'it','Lavoro inattivo',0),(560509,15570,'tl','',0),(560510,15570,'th','à¸‡à¸²à¸™à¹„à¸¡à¹ˆà¸—à¸³à¸‡à¸²à¸™',0),(560511,15570,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¨à¤¿à¤·à¥à¤•à¥à¤°à¤¿à¤¯',0),(560512,15570,'ms','Pekerjaan yang tidak aktif',0),(560513,15570,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© ØºÙŠØ± Ù†Ø´Ø·',0),(560514,15570,'fr','Travail inactif',0),(560515,15570,'jp','éžã‚¢ã‚¯ãƒ†ã‚£ãƒ–ãªã‚¸ãƒ§ãƒ–',0),(560516,15570,'pt','Trabalho inativo',0),(560517,15570,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð½ÐµÐ°ÐºÑ‚Ð¸Ð²Ð½Ñ‹Ñ…',0),(560518,15570,'es','Trabajo inactivo',0),(560519,15570,'de','Job inaktiv',0),(560520,15570,'en','Job Inactive',0),(560521,15571,'is','',0),(560522,15571,'dr','ØªØ¹Ø¯Ø§Ø¯ Ú©Ø§Ø± Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(560523,15571,'pr','ØªØ¹Ø¯Ø§Ø¯ Ú©Ø§Ø± Ø¨ÙˆØ¯Ø¬Ù‡ Ù‡Ø§ Ø­Ø°Ù Ø´Ø¯Ù‡',0),(560524,15571,'tr','SilinmiÅŸ proje bÃ¼tÃ§e giriÅŸleri sayÄ±sÄ±',0),(560525,15571,'pl','Liczba zapisÃ³w budÅ¼etu zadania usuniÄ™te',0),(560526,15571,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸',0),(560527,15571,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø¨Ø¬Ù¹ Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ø­Ø°Ù Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(560528,15571,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾ Ð±ÑƒÑŸÐµÑ‚Ð° Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(560529,15571,'vi','Sá»‘ lÆ°á»£ng viá»‡c lÃ m ngÃ¢n sÃ¡ch má»¥c Ä‘Ã£ xÃ³a',0),(560530,15571,'af','Aantal werk begroting inskrywings geskrap',0),(560531,15571,'ro','NumÄƒrul de intrÄƒri de buget Job ÅŸters',0),(560532,15571,'et','Projektieelarve kanded jÃ¤etakse vÃ¤lja arv',0),(560533,15571,'si','Å tevilo postavke predraÄuna projekta Ärta',0),(560534,15571,'ba','Jumlah pekerjaan anggaran entri dihapus',0),(560535,15571,'nl','Aantal projectbudgetposten verwijderd',0),(560536,15571,'fi','MÃ¤Ã¤rÃ¤ poistaa projektibudjettitapahtumat',0),(560537,15571,'no','Antall prosjektbudsjettposter slettet',0),(560538,15571,'da','Antallet af sagsbudgetposter slettet',0),(560539,15571,'ko','ì¼ìžë¦¬ ì˜ˆì‚° í•­ëª© ì‚­ì œ ìˆ˜',0),(560540,15571,'he','×ž×¡×¤×¨ ×ª×§×¦×™×‘ ×”×¢×‘×•×“×” ×”×¢×¨×›×™× ×©× ×ž×—×§×•',0),(560541,15571,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï ÎµÏÎ³Î±ÏƒÎ¯Î± Î´Î¹Î±Î³ÏÎ¬Ï†ÎµÏ„Î±Î¹',0),(560542,15571,'zh','åˆ é™¤çš„å·¥ä½œé¢„ç®—æ¡ç›®æ•°',0),(560543,15571,'sv','Antal jobb budgettransaktioner bort',0),(560544,15571,'it','Numero di voci di bilancio di lavoro eliminato',0),(560545,15571,'tl','',0),(560546,15571,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸‚à¸­à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸‡à¸²à¸™à¸¥à¸š',0),(560547,15571,'hi','à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤•à¤¾à¤°à¥à¤¯ à¤¬à¤œà¤Ÿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(560548,15571,'ms','Bilangan penyertaan belanjawan pekerjaan yang dihapuskan',0),(560549,15571,'ar','Ø¹Ø¯Ø¯ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© ÙˆØ¸ÙŠÙØ© Ø­Ø°Ù',0),(560550,15571,'fr','Nombre d\'Ã©critures de Budget de projet supprimÃ©',0),(560551,15571,'jp','å‰Šé™¤ã•ã‚ŒãŸã‚¸ãƒ§ãƒ–äºˆç®—ã‚¨ãƒ³ãƒˆãƒªã®æ•°',0),(560552,15571,'pt','NÃºmero de entradas de orÃ§amento de trabalho excluÃ­do',0),(560553,15571,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¹ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(560554,15571,'es','NÃºmero de movimientos de presupuesto de trabajo eliminado',0),(560555,15571,'de','Anzahl der Projektbudgetposten gelÃ¶scht',0),(560556,15571,'en','Number Of Job Budget Entries Deleted',0),(560557,15572,'is','',0),(560558,15572,'dr','Ø´Ù…Ø§Ø±Ù‡ POs/SBs Ø­Ø°Ù Ø´Ø¯Ù‡',0),(560559,15572,'pr','Ø´Ù…Ø§Ø±Ù‡ POs/SBs Ø­Ø°Ù Ø´Ø¯Ù‡',0),(560560,15572,'tr','POs/SBs silinmiÅŸ sayÄ±sÄ±',0),(560561,15572,'pl','Liczba POs/SBs usuniÄ™te',0),(560562,15572,'bg','Ð‘Ñ€Ð¾Ð¹ Ð½Ð° POs/SBs Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸',0),(560563,15572,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù†/Ø³Ø¨ Ø­Ø°Ù Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(560564,15572,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐŸÐžÑ/Ð¡Ð‘Ñ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(560565,15572,'vi','Sá»‘ POs/SBs Ä‘Ã£ xÃ³a',0),(560566,15572,'af','Aantal POs/SBs geskrap',0),(560567,15572,'ro','Numarul de POs/SBs ÅŸters',0),(560568,15572,'et','POs/SBs jÃ¤etakse vÃ¤lja arv',0),(560569,15572,'si','Å tevilo POs/SBs Ärta',0),(560570,15572,'ba','Jumlah POs/SBs dihapus',0),(560571,15572,'nl','Aantal POs/SBs verwijderd',0),(560572,15572,'fi','MÃ¤Ã¤rÃ¤ SBs ja POs poistaa',0),(560573,15572,'no','Antall POs/SBs slettet',0),(560574,15572,'da','Antallet af POs/SBs slettet',0),(560575,15572,'ko','í¬ìŠ¤/SBs ì‚­ì œ ìˆ˜',0),(560576,15572,'he','×ž×¡×¤×¨ ×§×•×¤×”/SBs ×©× ×ž×—×§×•',0),(560577,15572,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Ï‰Î½ POs/SBs Î´Î¹Î±Î³ÏÎ±Ï†ÎµÎ¯',0),(560578,15572,'zh','POs/SBs åˆ é™¤çš„æ•°ç›®',0),(560579,15572,'sv','Antal POs/SBs bort',0),(560580,15572,'it','Numero di POs/SBs eliminato',0),(560581,15572,'tl','',0),(560582,15572,'th','à¸ˆà¸³à¸™à¸§à¸™ POs à¹à¸¥à¸° SBs à¸¥à¸š',0),(560583,15572,'hi','à¤ªà¥€à¤“à¤à¤¸/SBs à¤¹à¤Ÿà¤¾à¤ à¤—à¤ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(560584,15572,'ms','Bilangan POs/SBs dihapuskan',0),(560585,15572,'ar','Ø¹Ø¯Ø¯ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹/SBs Ø­Ø°Ù',0);
INSERT INTO `langdef` VALUES (560586,15572,'fr','Nombre de PDV/SBs supprimÃ©',0),(560587,15572,'jp','POs/SBs å‰Šé™¤ã®æ•°',0),(560588,15572,'pt','NÃºmero de POs/SBs eliminado',0),(560589,15572,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ POs/SBs ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(560590,15572,'es','NÃºmero de POs/SBs eliminadas',0),(560591,15572,'de','Anzahl der POs/SBs gelÃ¶scht',0),(560592,15572,'en','Number Of POs/SBs Deleted',0),(560593,15573,'is','',0),(560594,15573,'dr','Ù¾Ùˆ/Ø´ & Ú©Ø§Ø± Ø¨ÙˆØ¯Ø¬Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ø°Ù Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ú©Ø§Ø±',0),(560595,15573,'pr','Ù¾Ùˆ/Ø´ & Ú©Ø§Ø± Ø¨ÙˆØ¯Ø¬Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø­Ø°Ù Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ú©Ø§Ø±',0),(560596,15573,'tr','PO/SB ve iÅŸ bÃ¼tÃ§e verilerini bu iÅŸ iÃ§in kaldÄ±rÄ±ldÄ±',0),(560597,15573,'pl','PO/SB idealna praca budÅ¼etu danych zostaÅ‚ usuniÄ™ty z powodu tej pracy',0),(560598,15573,'bg','PO/SB & Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð¾Ñ‚ÑÑ‚Ñ€Ð°Ð½ÐµÐ½Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(560599,15573,'ur','Ù¾Ùˆ ÙØ±ÛŒØ¶Û Ø³Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯Û’ & Ù…Ù„Ø§Ø²Ù…Øª Ø¨Ø¬Ù¹ Ú©ÙˆØ§Ø¦Ù ÛÛ’ Ú¯ÛŒØ§ ÛÙ¹Ø§ Ø§Ø³ Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù„Ø¦Û’',0),(560600,15573,'sr','ÐŸÐž /Ð¡Ð‘ & Ð¿Ð¾ÑÐ°Ð¾ Ð±ÑƒÑŸÐµÑ‚Ð° Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñ˜Ðµ ÑƒÐºÐ»Ð¾ÑšÐµÐ½Ð° Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾',0),(560601,15573,'vi','PO/SB & viá»‡c ngÃ¢n sÃ¡ch dá»¯ liá»‡u Ä‘Ã£ Ä‘Æ°á»£c gá»¡ bá» cho cÃ´ng viá»‡c nÃ y',0),(560602,15573,'af','PO/SB & werk begroting Data is verwyder vir hierdie werk',0),(560603,15573,'ro','PO/SB & date de buget Job a fost eliminat pentru acest loc de muncÄƒ',0),(560604,15573,'et','PO/SB- & tÃ¶Ã¶ eelarve andmete jÃ¤eti selle tÃ¶Ã¶ jaoks',0),(560605,15573,'si','PO/SB & delo proraÄuna podatkov je bil odstranjen za ta posel',0),(560606,15573,'ba','PO/SB & pekerjaan anggaran Data telah dihapus untuk pekerjaan ini',0),(560607,15573,'nl','PO/SB & baan begrotingsgegevens is verwijderd voor deze Job',0),(560608,15573,'fi','PO/SB & tyÃ¶tÃ¤ talousarvion tiedot on poistettu tÃ¤mÃ¤n tyÃ¶n',0),(560609,15573,'no','PO/SB & jobb budsjettdata er fjernet For denne jobben',0),(560610,15573,'da','PO/SB & Job budgetdata er blevet fjernet For dette Job',0),(560611,15573,'ko','í¬/SB ë° ìž‘ì—… ì˜ˆì‚° ë°ì´í„°ê°€ì´ ìž‘ì—…ì— ëŒ€ í•œ ì œê±° ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(560612,15573,'he','×¤×•/SB & × ×ª×•× ×™ ×ª×§×¦×™×‘ ×”×¢×‘×•×“×” ×”×•×¡×¨ ×œ×¢×‘×•×“×” ×”×–××ª',0),(560613,15573,'el','PO/SB & Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î­Ï‡ÎµÎ¹ Î±Ï†Î±Î¹ÏÎµÎ¸ÎµÎ¯ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(560614,15573,'zh','PO/æŸäºº & å·¥ä½œé¢„ç®—æ•°æ®è¢«åˆ é™¤äº†è¿™ä»½å·¥ä½œ',0),(560615,15573,'sv','PO/SB & jobb budgetdata har tagits bort fÃ¶r det hÃ¤r jobbet',0),(560616,15573,'it','PO/SB & lavoro Budget dati Ã¨ stato rimosso per questo lavoro',0),(560617,15573,'tl','',0),(560618,15573,'th','PO/SB à¹à¸¥à¸°à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸‡à¸²à¸™à¹„à¸”à¹‰à¸–à¸¹à¸à¹€à¸­à¸²à¸­à¸­à¸à¸ªà¸³à¸«à¸£à¸±à¸šà¸‡à¸²à¸™à¸™à¸µà¹‰',0),(560619,15573,'hi','PO/SB & à¤•à¤¾à¤°à¥à¤¯ à¤¬à¤œà¤Ÿ à¤¡à¥‡à¤Ÿà¤¾ à¤‡à¤¸ à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(560620,15573,'ms','PO/SB & kerja bajet Data telah dikeluarkan untuk kerja ini',0),(560621,15573,'ar','Øµ. Ø¨/SB & Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© ÙˆØ¸ÙŠÙØ© Ù‚Ø¯ Ø£Ø²ÙŠÙ„Øª Ù„Ù‡Ø°Ù‡ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(560622,15573,'fr','PO/SB & donnÃ©es budgÃ©taires emploi a Ã©tÃ© supprimÃ© pour ce travail',0),(560623,15573,'jp','ã“ã®ä»•äº‹ã® PO/SB ãƒ»ä»•äº‹ã®äºˆç®—ãƒ‡ãƒ¼ã‚¿ãŒå‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(560624,15573,'pt','PO/SB & trabalho orÃ§amento dados foi removido para este trabalho',0),(560625,15573,'ru','PO/SB & Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð±Ñ‹Ð»Ð° ÑƒÐ´Ð°Ð»ÐµÐ½Ð° Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(560626,15573,'es','PO/SB y datos del presupuesto de trabajo ha sido eliminado para este trabajo',0),(560627,15573,'de','PO/SB & Job Budgetdaten wurde fÃ¼r diesen Job entfernt',0),(560628,15573,'en','PO/SB & Job Budget Data Has Been Removed For This Job',0),(560629,15574,'is','',0),(560630,15574,'dr','Ø­Ø°Ù ÙÙˆÙ‚ Ø±Ø³ÛŒØ¯ Ø§ÙˆÙ„ Ùˆ Ø³Ù¾Ø³ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§Ù…ØªØ­Ø§Ù† Ú©Ù†ÛŒØ¯',0),(560631,15574,'pr','Ø­Ø°Ù ÙÙˆÙ‚ Ø±Ø³ÛŒØ¯ Ø§ÙˆÙ„ Ùˆ Ø³Ù¾Ø³ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ø§Ù…ØªØ­Ø§Ù† Ú©Ù†ÛŒØ¯',0),(560632,15574,'tr','YukarÄ±daki giriÅŸ Ã¶nce kaldÄ±rÄ±n ve sonra yeniden deneyin',0),(560633,15574,'pl','Najpierw usunÄ…Ä‡ powyÅ¼sze przychody, a nastÄ™pnie sprÃ³buj ponownie',0),(560634,15574,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð½ÐµÑ‚Ðµ Ð¿Ð¾-Ð³Ð¾Ñ€Ðµ Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð¿ÑŠÑ€Ð²Ð¾ Ð¸ ÑÐ»ÐµÐ´ Ñ‚Ð¾Ð²Ð° Ð¾Ð¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(560635,15574,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø§ÙˆÙ¾Ø± Ø±Ø³ÛŒØ¯ÛŒÚº ÛÙ¹Ø§Ø¦ÛŒÚºØŒ Ù¾Ú¾Ø± Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº',0),(560636,15574,'sr','ÐŸÑ€Ð²Ð¾ ÑƒÐºÐ»Ð¾Ð½Ð¸Ñ‚Ðµ Ð³Ð¾Ñ€Ðµ Ð½Ð°Ð²ÐµÐ´ÐµÐ½Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ, Ð° Ð·Ð°Ñ‚Ð¸Ð¼ Ð¿Ð¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð½Ð¾Ð²Ð¾',0),(560637,15574,'vi','Loáº¡i bá» cÃ¡c hÃ³a Ä‘Æ¡n trÃªn Ä‘áº§u tiÃªn sau Ä‘Ã³ thá»­ láº¡i',0),(560638,15574,'af','Verwyder eers die bogenoemde kwitansies en probeer dan weer',0),(560639,15574,'ro','Elimina Ã®ncasÄƒri mai sus prima, apoi Ã®ncercaÈ›i din nou',0),(560640,15574,'et','Eespool laekunud summad esmalt eemaldada ja proovige uuesti',0),(560641,15574,'si','Odstranite zgoraj prejemki prvi in nato poskusite znova',0),(560642,15574,'ba','Hapus kuitansi di atas pertama kali kemudian coba lagi',0),(560643,15574,'nl','De bovenstaande ontvangsten eerst verwijderen en vervolgens opnieuw',0),(560644,15574,'fi','Poista edellÃ¤ vastaanotot ensin ja yritÃ¤ sitten uudelleen',0),(560645,15574,'no','FÃ¸rst fjerne over kvitteringer og prÃ¸v pÃ¥ nytt',0),(560646,15574,'da','Fjerne de ovennÃ¦vnte indtÃ¦gter fÃ¸rst og derefter prÃ¸ve igen',0),(560647,15574,'ko','ë¨¼ì € ìœ„ì˜ ì˜ìˆ˜ì¦ì„ ì œê±° í›„ ë‹¤ì‹œ ì‹œë„ í•˜ì‹­ì‹œì˜¤',0),(560648,15574,'he','×œ×”×¡×™×¨ ××ª ×”×§×‘×œ×•×ª ×œ×¢×™×œ ×ª×—×™×œ×” ×•×œ××—×¨ ×ž×›×Ÿ × ×¡×” ×©×•×‘',0),(560649,15574,'el','ÎšÎ±Ï„Î±ÏÎ³Î®ÏƒÏ„Îµ Ï€ÏÏŽÏ„Î± Ï„Î·Î½ Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ Î±Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚, Ï„ÏŒÏ„Îµ Î´Î¿ÎºÎ¹Î¼Î¬ÏƒÏ„Îµ Î¾Î±Î½Î¬',0),(560650,15574,'zh','é¦–å…ˆåˆ é™¤ä¸Šè¿°æ”¶æ®ï¼Œç„¶åŽå†è¯•ä¸€æ¬¡',0),(560651,15574,'sv','Ta bort ovan inleveranser fÃ¶rst och fÃ¶rsÃ¶k sedan igen',0),(560652,15574,'it','Rimuovere le conferme di cui sopra in primo luogo, quindi provare di nuovo',0),(560653,15574,'tl','',0),(560654,15574,'th','à¹€à¸­à¸²à¹ƒà¸šà¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¹„à¸›à¸à¹ˆà¸­à¸™ à¹à¸¥à¹‰à¸§à¸¥à¸­à¸‡à¸­à¸µà¸à¸„à¸£à¸±à¹‰à¸‡',0),(560655,15574,'hi','à¤«à¤¿à¤° à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚ à¤œà¥‹ à¤Šà¤ªà¤° à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿ à¤ªà¤¹à¤²à¥‡ à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚',0),(560656,15574,'ms','Keluarkan resit di atas terlebih dahulu dan cuba lagi',0),(560657,15574,'ar','Ø¥Ø²Ø§Ù„Ø© Ø§Ù„Ø¥ÙŠØµØ§Ù„Ø§Øª Ø£Ø¹Ù„Ø§Ù‡ Ø£ÙˆÙ„Ø§Ù‹ Ø«Ù… Ø­Ø§ÙˆÙ„ Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(560658,15574,'fr','Enlevez d\'abord les recettes ci-dessus, puis essayez Ã  nouveau',0),(560659,15574,'jp','ã¾ãšä¸Šè¨˜ã®é ˜åŽæ›¸ã‚’å‰Šé™¤ã—ã€ã‚‚ã†ä¸€åº¦ã‚„ã‚Šç›´ã—ã¦ãã ã•ã„ã€‚',0),(560660,15574,'pt','Remova os recibos acima primeiro, em seguida, tente novamente',0),(560661,15574,'ru','Ð¡Ð½Ð°Ñ‡Ð°Ð»Ð° ÑƒÐ´Ð°Ð»Ð¸Ñ‚Ðµ Ð²Ñ‹ÑˆÐµ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸, Ð° Ð·Ð°Ñ‚ÐµÐ¼ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð¸Ñ‚Ðµ Ð¿Ð¾Ð¿Ñ‹Ñ‚ÐºÑƒ',0),(560662,15574,'es','Quite los recibos anteriores primero intÃ©ntelo de nuevo',0),(560663,15574,'de','Die oben genannten Belege zuerst entfernen, dann versuchen Sie es erneut',0),(560664,15574,'en','Remove The Above Receipts First Then Try Again',0),(560665,15575,'is','',0),(560666,15575,'dr','Ø§ÛŒÙ† Ù‡Ù…Ù‡ Ù¾Ùˆ/Ø´ & Ú©Ø§Ø± Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯Ø§Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ú©Ø§Ø± Ø­Ø°Ù Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(560667,15575,'pr','Ø§ÛŒÙ† Ù‡Ù…Ù‡ Ù¾Ùˆ/Ø´ & Ú©Ø§Ø± Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯Ø§Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ú©Ø§Ø± Ø­Ø°Ù Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(560668,15575,'tr','Bu bu iÅŸ iÃ§in bÃ¼tÃ¼n PO/SB ve iÅŸ bÃ¼tÃ§e verilerini siler',0),(560669,15575,'pl','Spowoduje to usuniÄ™cie wszystkich PO/SB idealna praca budÅ¼etu danych dla tego zadania',0),(560670,15575,'bg','Ð¢Ð¾Ð²Ð° Ñ‰Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ PO/SB & Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ñ‚Ð°Ð·Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(560671,15575,'ur','ÛŒÛ Ø³Ø¨ Ù¾Ùˆ ÙØ±ÛŒØ¶Û Ø³Ø± Ø§Ù†Ø¬Ø§Ù… Ø¯Û’ & Ù…Ù„Ø§Ø²Ù…Øª Ø¨Ø¬Ù¹ Ú©ÙˆØ§Ø¦Ù Ø§Ø³ Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù„Ø¦Û’ Ø­Ø°Ù Ú©Ø± Ø¯Û’ Ú¯Ø§',0),(560672,15575,'sr','ÐžÐ²Ð¾ Ñ›Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ ÑÐ²Ðµ ÐŸÐž/Ð¡Ð‘ & Ð¿Ð¾ÑÐ°Ð¾ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð±ÑƒÑŸÐµÑ‚Ñƒ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾',0),(560673,15575,'vi','Viá»‡c nÃ y sáº½ xÃ³a táº¥t cáº£ cÃ¡c PO/SB & viá»‡c ngÃ¢n sÃ¡ch dá»¯ liá»‡u cho cÃ´ng viá»‡c nÃ y',0),(560674,15575,'af','Dit sal alle PO/SB & werk begroting Data vir hierdie taak skrap',0),(560675,15575,'ro','Aceasta va ÅŸterge toate PO/SB & Job date pentru acest loc de muncÄƒ',0),(560676,15575,'et','See kustutab kÃµik PO/SB- & tÃ¶Ã¶ eelarve andmeid selle tÃ¶Ã¶ jaoks',0),(560677,15575,'si','To bo izbrisalo vse PO/SB & delo podatke o proraÄunu za to delo',0),(560678,15575,'ba','Ini akan menghapus semua PO/SB & Data pekerjaan anggaran untuk pekerjaan ini',0),(560679,15575,'nl','Dit zal alle PO/SB & baan begrotingsgegevens verwijderen voor deze Job',0),(560680,15575,'fi','TÃ¤mÃ¤ poistaa kaikki PO/SB & tyÃ¶ budjettitiedot tÃ¤hÃ¤n tehtÃ¤vÃ¤Ã¤n',0),(560681,15575,'no','Dette vil slette alle PO/SB & jobb budsjettdata For denne jobben',0),(560682,15575,'da','Dette vil slette alle PO/SB & Job budgetdata For dette Job',0),(560683,15575,'ko','ì´ ìž‘ì—…ì— ëŒ€ í•œ ëª¨ë“  í¬/SB ë° ìž‘ì—… ì˜ˆì‚° ë°ì´í„° ì‚­ì œ ë©ë‹ˆë‹¤.',0),(560684,15575,'he','×¤×¢×•×œ×” ×–×• ×ª×’×¨×•× ×œ×ž×—×™×§×ª ×›×œ ×¤×•/SB & × ×ª×•× ×™ ×ª×§×¦×™×‘ ×¢×‘×•×“×” ×œ×¢×‘×•×“×” ×”×–××ª',0),(560685,15575,'el','Î‘Ï…Ï„ÏŒ Î¸Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÎ¹ ÏŒÎ»Î± PO/SB & ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î³Î¹Î± Î±Ï…Ï„Î® Ï„Î· Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(560686,15575,'zh','è¿™å°†åˆ é™¤æ‰€æœ‰ PO/æŸäºº & å·¥ä½œé¢„ç®—æ•°æ®ä¸ºè¿™ä»½å·¥ä½œ',0),(560687,15575,'sv','Detta tar bort alla PO/SB & jobb budgetdata fÃ¶r det hÃ¤r jobbet',0),(560688,15575,'it','CiÃ² eliminerÃ  tutti i PO/SB & lavoro Budget dati per questo lavoro',0),(560689,15575,'tl','',0),(560690,15575,'th','à¸™à¸µà¹‰à¸ˆà¸°à¸¥à¸šà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸” PO/SB à¹à¸¥à¸°à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸‡à¸²à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸‡à¸²à¸™à¸™à¸µà¹‰',0),(560691,15575,'hi','à¤¯à¤¹ à¤‡à¤¸ à¤•à¤¾à¤°à¥à¤¯ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ PO/SB & à¤•à¤¾à¤°à¥à¤¯ à¤¬à¤œà¤Ÿ à¤¡à¥‡à¤Ÿà¤¾ à¤¹à¤Ÿà¤¾ à¤¦à¥‡à¤—à¤¾',0),(560692,15575,'ms','Ini akan menghapuskan semua PO/SB & kerja bajet Data untuk kerja ini',0),(560693,15575,'ar','Ø³ÙŠØ¤Ø¯ÙŠ Ù‡Ø°Ø§ Ø¥Ù„Ù‰ Ø­Ø°Ù Ø¬Ù…ÙŠØ¹ Ø¨Ùˆ/SB & Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ù…Ù‡Ù…Ø© Ù„Ù‡Ø°Ù‡ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(560694,15575,'fr','Ceci supprimera toutes les PO/SB & emploi Budget donnÃ©es pour cette tÃ¢che',0),(560695,15575,'jp','ã“ã‚Œã¯ã“ã®ã‚¸ãƒ§ãƒ–ã®ã™ã¹ã¦ã® PO/SB ãƒ»ä»•äº‹ã®äºˆç®—ãƒ‡ãƒ¼ã‚¿ãŒå‰Šé™¤ã•ã‚Œã¾ã™ã€‚',0),(560696,15575,'pt','Isto irÃ¡ apagar todos os PO/SB & trabalho orÃ§amento dados para este trabalho',0),(560697,15575,'ru','Ð­Ñ‚Ð¾ Ð¿Ñ€Ð¸Ð²ÐµÐ´ÐµÑ‚ Ðº ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸ÑŽ Ð²ÑÐµÑ… PO/SB & Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(560698,15575,'es','Esto borrarÃ¡ todas PO/SB y datos del presupuesto de trabajo para este trabajo',0),(560699,15575,'de','Dadurch werden alle PO/SB & Job Budgetdaten fÃ¼r diesen Auftrag gelÃ¶scht.',0),(560700,15575,'en','This Will Delete All PO/SB & Job Budget Data For This Job',0),(560701,15576,'is','',0),(560702,15576,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡',0),(560703,15576,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡',0),(560704,15576,'tr','Maliyet kodu seÃ§in',0),(560705,15576,'pl','Wybierz koszt kodu',0),(560706,15576,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÐºÐ¾Ð´ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ',0),(560707,15576,'ur','Ù„Ø§Ú¯Øª Ú©ÙˆÚˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(560708,15576,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑˆÐ¸Ñ„Ñ€Ñƒ Ñ‚Ñ€Ð¾ÑˆÐºÐ°',0),(560709,15576,'vi','Chá»n mÃ£ sá»‘ chi phÃ­',0),(560710,15576,'af','Kies koste kode',0),(560711,15576,'ro','SelectaÅ£i codul de Cost',0),(560712,15576,'et','Valige kulude kood',0),(560713,15576,'si','Izberite Å¡ifro stroÅ¡kovno',0),(560714,15576,'ba','Pilih kode biaya',0),(560715,15576,'nl','Kosten Code selecteren',0),(560716,15576,'fi','Valitse kustannuskoodi',0),(560717,15576,'no','Velg pris',0),(560718,15576,'da','VÃ¦lg pris kode',0),(560719,15576,'ko','ë¹„ìš©ëœ ì½”ë“œ ì„ íƒ',0),(560720,15576,'he','×‘×—×¨ ×§×•×“ ×¢×œ×•×ª',0),(560721,15576,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(560722,15576,'zh','é€‰æ‹©æˆæœ¬çš„ä»£ç ',0),(560723,15576,'sv','VÃ¤lj kostnad kod',0),(560724,15576,'it','Selezionare codice di costo',0),(560725,15576,'tl','',0),(560726,15576,'th','à¹€à¸¥à¸·à¸­à¸à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(560727,15576,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(560728,15576,'ms','Pilih kod kos',0),(560729,15576,'ar','Ø­Ø¯Ø¯ Ø±Ù…Ø² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(560730,15576,'fr','SÃ©lectionnez Code de coÃ»t',0),(560731,15576,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(560732,15576,'pt','Selecione o cÃ³digo do custo',0),(560733,15576,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´',0),(560734,15576,'es','Seleccionar el cÃ³digo de costo',0),(560735,15576,'de','WÃ¤hlen Sie Kosten Code',0),(560736,15576,'en','Select Cost Code',0),(560737,15577,'is','',0),(560738,15577,'dr','Ø´Ù…Ø§Ø±Ù‡ ØªØ¬Ø¯ÛŒØ¯ Ù†Ø¸Ø±',0),(560739,15577,'pr','Ø´Ù…Ø§Ø±Ù‡ ØªØ¬Ø¯ÛŒØ¯ Ù†Ø¸Ø±',0),(560740,15577,'tr','DÃ¼zeltme numarasÄ±',0),(560741,15577,'pl','Numer wydania',0),(560742,15577,'bg','ÐŸÑ€ÐµÑ€Ð°Ð·Ð³Ð»ÐµÐ¶Ð´Ð°Ð½Ðµ Ð½Ð¾Ð¼ÐµÑ€',0),(560743,15577,'ur','Ù†Ù…Ø¨Ø± Ù†Ø¸Ø±Ø«Ø§Ù†ÛŒ',0),(560744,15577,'sr','Ð‘Ñ€Ð¾Ñ˜ Ñ€ÐµÐ²Ð¸Ð·Ð¸Ñ˜Ðµ',0),(560745,15577,'vi','Sá»‘ hiá»‡u Ä‘Ã­nh',0),(560746,15577,'af','Hersieningsnommer',0),(560747,15577,'ro','NumÄƒr de revizie',0),(560748,15577,'et','Redaktsiooni Number',0),(560749,15577,'si','Å tevilka revizije',0),(560750,15577,'ba','Angka revisi',0),(560751,15577,'nl','Revisienummer',0),(560752,15577,'fi','Versionumero',0),(560753,15577,'no','Revisjonsnummeret',0),(560754,15577,'da','Revisionsnummer',0),(560755,15577,'ko','ìˆ˜ì • ë²ˆí˜¸',0),(560756,15577,'he','×ž×¡×¤×¨ ×”×ž×”×“×•×¨×”',0),(560757,15577,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î±Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ·Ï‚',0),(560758,15577,'zh','ä¿®è®¢å·',0),(560759,15577,'sv','Revisionsnummer',0),(560760,15577,'it','Numero di Revisione',0),(560761,15577,'tl','',0),(560762,15577,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚',0),(560763,15577,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(560764,15577,'ms','Nombor semakan',0),(560765,15577,'ar','Ø±Ù‚Ù… Ø§Ù„Ù…Ø±Ø§Ø¬Ø¹Ø©',0),(560766,15577,'fr','NumÃ©ro de rÃ©vision',0),(560767,15577,'jp','ãƒªãƒ“ã‚¸ãƒ§ãƒ³ç•ªå·',0),(560768,15577,'pt','NÃºmero de revisÃ£o',0),(560769,15577,'ru','ÐÐ¾Ð¼ÐµÑ€ Ñ€ÐµÐ´Ð°ÐºÑ†Ð¸Ð¸',0),(560770,15577,'es','NÃºmero de revisiÃ³n',0),(560771,15577,'de','Revisionsnummer',0),(560772,15577,'en','Revision Number',0),(560773,15578,'is','',0),(560774,15578,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÛŒØ¯ Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§ÛŒÙ† ÙØ¹Ø§Ù„ Ú©Ù†ÛŒØ¯ØŸ',0),(560775,15578,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÛŒØ¯ Ú©Ù‡ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§ÛŒÙ† ÙØ¹Ø§Ù„ Ú©Ù†ÛŒØ¯ØŸ',0),(560776,15578,'tr','Bu etkinleÅŸtirmek istediÄŸinizden emin misiniz?',0),(560777,15578,'pl','Czy na pewno chcesz aktywowaÄ‡ tego?',0),(560778,15578,'bg','Ð¡ÑŠÑ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¾ÑÑ‚ Ð¶ÐµÐ»Ð°ÐµÑ‚Ðµ Ð´Ð° Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ Ñ‚Ð¾Ð²Ð°?',0),(560779,15578,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ø³ Ø¹Ù…Ù„ Ù…ÛŒÚº Ù„Ø§Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(560780,15578,'sr','ÐˆÐµÑÐ¸ Ð»Ð¸ ÑÐ¸Ð³ÑƒÑ€Ð°Ð½ Ð´Ð° Ð»Ð¸ Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ñ‚Ðµ Ð¾Ð²Ð¾?',0),(560781,15578,'vi','Báº¡n cÃ³ cháº¯c báº¡n muá»‘n kÃ­ch hoáº¡t nÃ y?',0),(560782,15578,'af','Is jy seker jy wil dit aktiveer?',0),(560783,15578,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ activaÅ£i acest lucru?',0),(560784,15578,'et','Kas soovite aktiveerida selle?',0),(560785,15578,'si','Ali ste prepriÄani, da Å¾elite aktivirati to?',0),(560786,15578,'ba','Apakah Anda yakin Anda ingin mengaktifkan ini?',0),(560787,15578,'nl','Weet u zeker dat u wilt activeren dit?',0),(560788,15578,'fi','Oletko varma, ettÃ¤ haluat aktivoida tÃ¤mÃ¤n?',0),(560789,15578,'no','Er du sikker pÃ¥ at du vil aktivere dette?',0),(560790,15578,'da','Er du sikker pÃ¥ du Ã¸nsker at aktivere dette?',0),(560791,15578,'ko','ë‹¹ì‹ ì€ ì´ê²ƒì„ í™œì„±í™” í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(560792,15578,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×”×¤×¢×™×œ ××ª ×–×”?',0),(560793,15578,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒ;',0),(560794,15578,'zh','ä½ ç¡®å®šä½ æƒ³æ¿€æ´»æ­¤åŠŸèƒ½?',0),(560795,15578,'sv','Ã„r du sÃ¤ker pÃ¥ att du vill aktivera detta?',0),(560796,15578,'it','Sei sicuro che si desidera attivare questo?',0),(560797,15578,'tl','',0),(560798,15578,'th','à¸„à¸¸à¸“à¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸™à¸µà¹‰à¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(560799,15578,'hi','à¤•à¥à¤¯à¤¾ à¤†à¤ª à¤µà¤¾à¤•à¤ˆ à¤‡à¤¸ à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(560800,15578,'ms','Adakah anda pasti anda ingin mengaktifkan ini?',0),(560801,15578,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø±ØºØ¨ØªÙƒ ÙÙŠ ØªÙØ¹ÙŠÙ„ Ù‡Ø°Ù‡ØŸ',0),(560802,15578,'fr','ÃŠtes-vous sÃ»r de que vouloir activer cela ?',0),(560803,15578,'jp','ã“ã‚Œã‚’ã‚¢ã‚¯ãƒ†ã‚£ãƒ–ã«ã™ã‚‹ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(560804,15578,'pt','Tens a certeza de que vocÃª deseja ativar isso?',0),(560805,15578,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ð²Ñ‹ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ð¾?',0),(560806,15578,'es','Â¿EstÃ¡ seguro que desea activar esto?',0),(560807,15578,'de','Sind Sie sicher, dass Sie dies aktivieren mÃ¶chten?',0),(560808,15578,'en','Are you sure you wish to activate this?',0),(560809,15579,'is','',0),(560810,15579,'dr','ØªÙ†Ù‡Ø§ Ù¾Ø³ Ø§Ø² ÙØ¹Ø§Ù„ Ø´Ø¯Ù† Ø°Ø®ÛŒØ±Ù‡ Ú©Ø±Ø¯Ù† Ø§ÛŒÙ† ØªØºÛŒÛŒØ±Ø§Øª',0),(560811,15579,'pr','ØªÙ†Ù‡Ø§ Ù¾Ø³ Ø§Ø² ÙØ¹Ø§Ù„ Ø´Ø¯Ù† Ø°Ø®ÛŒØ±Ù‡ Ú©Ø±Ø¯Ù† Ø§ÛŒÙ† ØªØºÛŒÛŒØ±Ø§Øª',0),(560812,15579,'tr','Aktif hale getirildiÄŸinde deÄŸiÅŸiklikler yalnÄ±zca kaydedilir',0),(560813,15579,'pl','Zmiany moÅ¼na zapisaÄ‡ tylko po odpaleniu',0),(560814,15579,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ñ‚ ÑÐ°Ð¼Ð¾ ÑÐ»ÐµÐ´ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ',0),(560815,15579,'ur','ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº ØµØ±Ù ÙØ¹Ø§Ù„ Ú©Ø± Ú©Û’ Ø¨Ø¹Ø¯ Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº Ú©ÛŒ Ø¬Ø§ Ø³Ú©ØªÛŒ',0),(560816,15579,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÑÐ°Ñ‡ÑƒÐ²Ð°Ñ‚Ð¸ ÑÐ°Ð¼Ð¾ Ð½Ð°ÐºÐ¾Ð½ Ð°ÐºÑ‚Ð¸Ð²Ð¸Ñ€Ð°ÑšÐ°',0),(560817,15579,'vi','Thay Ä‘á»•i chá»‰ cÃ³ thá»ƒ Ä‘Æ°á»£c lÆ°u sau khi kÃ­ch hoáº¡t',0),(560818,15579,'af','Veranderinge kan net gered word nadat aktiveer',0),(560819,15579,'ro','ModificÄƒrile pot fi salvate numai dupÄƒ activarea',0),(560820,15579,'et','Muutused saab salvestada ainult aktiveerimise jÃ¤rel',0),(560821,15579,'si','Spremembe lahko shranite samo po aktivaciji',0),(560822,15579,'ba','Perubahan hanya akan disimpan setelah mengaktifkan',0),(560823,15579,'nl','Wijzigingen kunnen alleen worden opgeslagen na het activeren van',0),(560824,15579,'fi','Muutokset voidaan tallentaa aktivoinnin jÃ¤lkeen',0),(560825,15579,'no','Endringer kan bare lagres etter aktivering',0),(560826,15579,'da','Ã†ndringer kan kun reddes efter aktivering',0),(560827,15579,'ko','ë³€ê²½ í™œì„±í™” í›„ì— ì €ìž¥í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(560828,15579,'he','×”×©×™× ×•×™×™× ×™×›×•×œ×™× ×œ×”×™×•×•×©×¢ ×¨×§ ×œ××—×¨ ×”×¤×¢×œ×ª',0),(560829,15579,'el','Î‘Î»Î»Î±Î³Î­Ï‚ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„Î¿ÏÎ½ Î¼ÏŒÎ½Î¿ Î¼ÎµÏ„Î¬ Ï„Î·Î½ ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(560830,15579,'zh','åªæœ‰åœ¨æ¿€æ´»åŽä¿å­˜æ›´æ”¹',0),(560831,15579,'sv','Ã„ndringar kan bara sparas efter aktivering',0),(560832,15579,'it','Le modifiche possono essere salvate solo dopo l\'attivazione',0),(560833,15579,'tl','',0),(560834,15579,'th','à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸ªà¸²à¸¡à¸²à¸£à¸–à¸–à¸¹à¸à¸šà¸±à¸™à¸—à¸¶à¸à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸à¸²à¸£à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(560835,15579,'hi','à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤•à¥‡à¤µà¤² à¤¸à¤•à¥à¤°à¤¿à¤¯ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¬à¤šà¤¾à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(560836,15579,'ms','Perubahan hanya dapat disimpan selepas pengaktifan',0),(560837,15579,'ar','ÙŠÙ…ÙƒÙ† Ø­ÙØ¸ Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª ÙÙ‚Ø· Ø¨Ø¹Ø¯ ØªÙØ¹ÙŠÙ„',0),(560838,15579,'fr','Changements ne peuvent Ãªtre sauvÃ©s aprÃ¨s l\'activation',0),(560839,15579,'jp','å¤‰æ›´ã¯ã€ã‚¢ã‚¯ãƒ†ã‚£ãƒ–åŒ–ã—ãŸå¾Œä¿å­˜ã™ã‚‹ã“ã¨',0),(560840,15579,'pt','As alteraÃ§Ãµes sÃ³ podem ser salvos depois de ativar',0),(560841,15579,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¿Ð¾ÑÐ»Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð°Ñ†Ð¸Ð¸',0),(560842,15579,'es','Cambios se pueden guardar sÃ³lo despuÃ©s de la activaciÃ³n',0),(560843,15579,'de','Ã„nderungen kÃ¶nnen nur nach der Aktivierung gespeichert werden',0),(560844,15579,'en','Changes Can Only Be Saved After Activating',0),(560845,15580,'is','',0),(560846,15580,'dr','Ø´Ø±Ú©Øª ØªÙˆØ³Ø¹Ù‡ ØªÙ…Ø¯Ù†',0),(560847,15580,'pr','Ø´Ø±Ú©Øª ØªÙˆØ³Ø¹Ù‡ ØªÙ…Ø¯Ù†',0),(560848,15580,'tr','Dev Co',0),(560849,15580,'pl','Dev Co',0),(560850,15580,'bg','Dev Co',0),(560851,15580,'ur','Ø¯ÛŒÙˆ Ú©Û’ Ø´Ø±ÛŒÚ©',0),(560852,15580,'sr','Ð”ÐµÐ² Ð¦Ð¾',0),(560853,15580,'vi','Dev Co',0),(560854,15580,'af','Dev Co',0),(560855,15580,'ro','Dev Co',0),(560856,15580,'et','Dev Co',0),(560857,15580,'si','Dev Co',0),(560858,15580,'ba','Dev Co',0),(560859,15580,'nl','Dev Co',0),(560860,15580,'fi','Dev Co',0),(560861,15580,'no','Dev Co',0),(560862,15580,'da','Dev Co',0),(560863,15580,'ko','Dev Co',0),(560864,15580,'he','Dev Co',0),(560865,15580,'el','Dev Co',0),(560866,15580,'zh','å¼€å‘å…¬å¸',0),(560867,15580,'sv','Dev Co',0),(560868,15580,'it','Dev Co',0),(560869,15580,'tl','',0),(560870,15580,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¹€à¸”à¸Ÿ',0),(560871,15580,'hi','à¤¦à¥‡à¤µ à¤¸à¤¹',0),(560872,15580,'ms','Dev Co',0),(560873,15580,'ar','Ø´Ø±ÙƒØ© Ø¯ÙŠÙ',0),(560874,15580,'fr','Dev Co',0),(560875,15580,'jp','Dev Co',0),(560876,15580,'pt','Dev Co',0),(560877,15580,'ru','Dev Co',0),(560878,15580,'es','Co de dev',0),(560879,15580,'de','Dev-Co',0),(560880,15580,'en','Dev Co',0),(560881,15581,'is','',0),(560882,15581,'dr','Ø§Ù…Ú©Ø§Ù† Ø³Ù†Ø¬ÛŒ',0),(560883,15581,'pr','Ø§Ù…Ú©Ø§Ù† Ø³Ù†Ø¬ÛŒ',0),(560884,15581,'tr','Fizibilite',0),(560885,15581,'pl','WykonalnoÅ›ci',0),(560886,15581,'bg','ÐžÑÑŠÑ‰ÐµÑÑ‚Ð²Ð¸Ð¼Ð¾ÑÑ‚',0),(560887,15581,'ur','Ø³Ú¾Ù„',0),(560888,15581,'sr','Ð¡Ñ‚ÑƒÐ´Ð¸Ñ˜Ðµ Ð¸Ð·Ð²Ð¾Ð´Ñ™Ð¸Ð²Ð¾ÑÑ‚Ð¸',0),(560889,15581,'vi','TÃ­nh kháº£ thi',0),(560890,15581,'af','Haalbaarheid',0),(560891,15581,'ro','Fezabilitate',0),(560892,15581,'et','Teostatavuse',0),(560893,15581,'si','Izvedljivosti',0),(560894,15581,'ba','Kelayakan',0),(560895,15581,'nl','Haalbaarheid',0),(560896,15581,'fi','Toteutettavuus',0),(560897,15581,'no','GjennomfÃ¸rbarhet',0),(560898,15581,'da','GennemfÃ¸rligheden',0),(560899,15581,'ko','íƒ€ë‹¹ì„±',0),(560900,15581,'he','×”×™×ª×›× ×•×ª',0),(560901,15581,'el','Î£ÎºÎ¿Ï€Î¹Î¼ÏŒÏ„Î·Ï„Î±Ï‚',0),(560902,15581,'zh','å¯è¡Œæ€§',0),(560903,15581,'sv','GenomfÃ¶rbarhet',0),(560904,15581,'it','FattibilitÃ ',0),(560905,15581,'tl','',0),(560906,15581,'th','à¸„à¸§à¸²à¸¡à¹€à¸›à¹‡à¸™à¹„à¸›à¹„à¸”à¹‰',0),(560907,15581,'hi','à¤µà¥à¤¯à¤µà¤¹à¤¾à¤°à¥à¤¯à¤¤à¤¾',0),(560908,15581,'ms','Daya maju',0),(560909,15581,'ar','Ø§Ù„Ø¬Ø¯ÙˆÙ‰',0),(560910,15581,'fr','FaisabilitÃ©',0),(560911,15581,'jp','å®Ÿç¾å¯èƒ½æ€§',0),(560912,15581,'pt','Viabilidade',0),(560913,15581,'ru','ÐžÑÑƒÑ‰ÐµÑÑ‚Ð²Ð¸Ð¼Ð¾ÑÑ‚ÑŒ',0),(560914,15581,'es','Viabilidad',0),(560915,15581,'de','DurchfÃ¼hrbarkeit',0),(560916,15581,'en','Feasibility',0),(560917,15582,'is','',0),(560918,15582,'dr','ÙˆØ§Ù… Ù…Ø´Ø§Ø±Ú©Øª Ø´Ø±Ú©Øª ØªÙˆØ³Ø¹Ù‡ ØªÙ…Ø¯Ù†',0),(560919,15582,'pr','ÙˆØ§Ù… Ù…Ø´Ø§Ø±Ú©Øª Ø´Ø±Ú©Øª ØªÙˆØ³Ø¹Ù‡ ØªÙ…Ø¯Ù†',0),(560920,15582,'tr','Kredi katkÄ± Dev Co',0),(560921,15582,'pl','PoÅ¼yczki wkÅ‚ad Dev Co',0),(560922,15582,'bg','Ð—Ð°ÐµÐ¼ Ð²Ð½Ð¾ÑÐºÐ° Dev Co',0),(560923,15582,'ur','Ù‚Ø±Ø¶ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ø¯ÛŒÙˆ Co',0),(560924,15582,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾Ñ Ð”ÐµÐ² Ð¦Ð¾',0),(560925,15582,'vi','Vay tiá»n Ä‘Ã³ng gÃ³p Dev Co',0),(560926,15582,'af','Lening bydrae Dev Co',0),(560927,15582,'ro','ÃŽmprumut contribuÅ£ia Dev Co',0),(560928,15582,'et','Laenu panus Dev Co',0),(560929,15582,'si','Posojilo prispevek Dev Co',0),(560930,15582,'ba','Pinjaman kontribusi Dev Co',0),(560931,15582,'nl','Lening bijdrage Dev Co',0),(560932,15582,'fi','Lainan osuus Dev Co',0),(560933,15582,'no','LÃ¥n bidrag Dev Co',0),(560934,15582,'da','LÃ¥n bidrag Dev Co',0),(560935,15582,'ko','ëŒ€ì¶œ ê¸°ì—¬ Dev Co',0),(560936,15582,'he','×”×œ×•×•××” ×”×ª×¨×•×ž×” Dev Co',0),(560937,15582,'el','Î”Î¬Î½ÎµÎ¹Î¿ ÏƒÏ…Î¼Î²Î¿Î»Î® Dev Co',0),(560938,15582,'zh','è´·æ¬¾çš„è´¡çŒ® Dev Co',0),(560939,15582,'sv','LÃ¥n bidrag Dev Co',0),(560940,15582,'it','Prestito contributo Dev Co',0),(560941,15582,'tl','',0),(560942,15582,'th','à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¸ªà¸™à¸±à¸šà¸ªà¸™à¸¸à¸™ Dev Co',0),(560943,15582,'hi','à¤‹à¤£ à¤¯à¥‹à¤—à¤¦à¤¾à¤¨ à¤¦à¥‡à¤µ à¤¸à¤¹',0),(560944,15582,'ms','Pinjaman caruman Dev Co',0),(560945,15582,'ar','Ø§Ù„Ù‚Ø±Ø¶ Ù…Ø³Ø§Ù‡Ù…Ø© Ø´Ø±ÙƒØ© Ø¯ÙŠÙ',0),(560946,15582,'fr','PrÃªt Contribution Dev Co',0),(560947,15582,'jp','èžè³‡è²¢çŒ® Dev Co',0),(560948,15582,'pt','EmprÃ©stimo contribuiÃ§Ã£o Dev Co',0),(560949,15582,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð° Ð²ÐºÐ»Ð°Ð´ Dev Co',0),(560950,15582,'es','PrÃ©stamo aportaciÃ³n Dev Co',0),(560951,15582,'de','Darlehen Beitrag Dev Co',0),(560952,15582,'en','Loan Contribution Dev Co',0),(560953,15583,'is','',0),(560954,15583,'dr','ÙˆØ§Ù… Ù…Ø´Ø§Ø±Ú©Øª ÙˆØ§Ù„Ø¯ÛŒÙ†',0),(560955,15583,'pr','ÙˆØ§Ù… Ù…Ø´Ø§Ø±Ú©Øª ÙˆØ§Ù„Ø¯ÛŒÙ†',0),(560956,15583,'tr','Kredi katkÄ± Ã¼st',0),(560957,15583,'pl','PoÅ¼yczki wkÅ‚ad rodzicÃ³w',0),(560958,15583,'bg','Ð—Ð°ÐµÐ¼ Ð²Ð½Ð¾ÑÐºÐ° Ñ€Ð¾Ð´Ð¸Ñ‚ÐµÐ»',0),(560959,15583,'ur','Ù‚Ø±Ø¶ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Û’ ÙˆØ§Ù„Ø¯ÛŒÙ†',0),(560960,15583,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚ Ð´Ð¾Ð¿Ñ€Ð¸Ð½Ð¾Ñ Ñ€Ð¾Ð´Ð¸Ñ‚ÐµÑ™Ð°',0),(560961,15583,'vi','Vay tiá»n Ä‘Ã³ng gÃ³p phá»¥ huynh',0),(560962,15583,'af','Lening bydrae ouer',0),(560963,15583,'ro','ÃŽmprumut contribuÅ£ia pÄƒrinte',0),(560964,15583,'et','Laenu toetust vanemale',0),(560965,15583,'si','Posojilo prispevek starÅ¡ev',0),(560966,15583,'ba','Pinjaman kontribusi orangtua',0),(560967,15583,'nl','Lening bijdrage bovenliggende',0),(560968,15583,'fi','Lainan osuus vanhemman',0),(560969,15583,'no','LÃ¥n bidrag overordnede',0),(560970,15583,'da','LÃ¥n bidrag forÃ¦lder',0),(560971,15583,'ko','ëŒ€ì¶œ ê¸°ì—¬ ë¶€ëª¨',0),(560972,15583,'he','×”×œ×•×•××” ×”×ª×¨×•×ž×” ×”××‘',0),(560973,15583,'el','Î“Î¿Î½Î¹ÎºÎ® ÏƒÏ…Î¼Î²Î¿Î»Î® Î´Î±Î½ÎµÎ¯Î¿Ï…',0),(560974,15583,'zh','è´·æ¬¾çš„è´¡çŒ®çˆ¶',0),(560975,15583,'sv','LÃ¥n bidrag fÃ¶rÃ¤lder',0),(560976,15583,'it','Padre di contributo prestito',0),(560977,15583,'tl','',0),(560978,15583,'th','à¸à¸¹à¹‰à¹€à¸‡à¸´à¸™à¸ªà¸¡à¸—à¸šà¸«à¸¥à¸±à¸',0),(560979,15583,'hi','à¤‹à¤£ à¤¯à¥‹à¤—à¤¦à¤¾à¤¨ à¤ªà¥ˆà¤°à¥‡à¤‚à¤Ÿ',0),(560980,15583,'ms','Pinjaman caruman ibu bapa',0),(560981,15583,'ar','Ø§Ù„Ù‚Ø±Ø¶ Ù…Ø³Ø§Ù‡Ù…Ø© Ø§Ù„Ø£ØµÙ„',0),(560982,15583,'fr','PrÃªt Contribution Parent',0),(560983,15583,'jp','èžè³‡è²¢çŒ®è¦ª',0),(560984,15583,'pt','Pai de contribuiÃ§Ã£o de emprÃ©stimo',0),(560985,15583,'ru','Ð Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ð¹ Ð²ÐºÐ»Ð°Ð´ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(560986,15583,'es','Matriz de contribuciÃ³n de prÃ©stamo',0),(560987,15583,'de','Darlehen Beitrag Ã¼bergeordneten',0),(560988,15583,'en','Loan Contribution Parent',0),(560989,15584,'is','',0),(560990,15584,'dr','Ù¾Ø¯Ø± Ùˆ Ù…Ø§Ø¯Ø±',0),(560991,15584,'pr','Ù¾Ø¯Ø± Ùˆ Ù…Ø§Ø¯Ø±',0),(560992,15584,'tr','Ãœst',0),(560993,15584,'pl','Rodzic',0),(560994,15584,'bg','Ð Ð¾Ð´Ð¸Ñ‚ÐµÐ»',0),(560995,15584,'ur','Ø¬Ø¯ÛŒ',0),(560996,15584,'sr','ÐÐ°Ð´Ñ€ÐµÑ’ÐµÐ½Ð¸',0),(560997,15584,'vi','Phá»¥ huynh',0),(560998,15584,'af','Ouer',0),(560999,15584,'ro','PÄƒrinte',0),(561000,15584,'et','Lapsevanem',0),(561001,15584,'si','StarÅ¡ev',0),(561002,15584,'ba','Orang tua',0),(561003,15584,'nl','Bovenliggende',0),(561004,15584,'fi','Vanhemman',0),(561005,15584,'no','Overordnede',0),(561006,15584,'da','ForÃ¦lder',0),(561007,15584,'ko','ë¶€ëª¨',0),(561008,15584,'he','×”××‘',0),(561009,15584,'el','Î“Î¿Î½Î­Î±Ï‚',0),(561010,15584,'zh','çˆ¶',0),(561011,15584,'sv','Ã–verordnade',0),(561012,15584,'it','Padre',0),(561013,15584,'tl','',0),(561014,15584,'th','à¸«à¸¥à¸±à¸',0),(561015,15584,'hi','à¤®à¤¾à¤¤à¤¾-à¤ªà¤¿à¤¤à¤¾',0),(561016,15584,'ms','Ibu bapa',0),(561017,15584,'ar','Ø§Ù„Ø£ØµÙ„',0),(561018,15584,'fr','Parent',0),(561019,15584,'jp','è¦ª',0),(561020,15584,'pt','Pai',0),(561021,15584,'ru','Ð Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒ',0),(561022,15584,'es','Padres',0),(561023,15584,'de','Ãœbergeordneten',0),(561024,15584,'en','Parent',0),(561025,15585,'is','',0),(561026,15585,'dr','Ù¾Ø±ÙˆÚ˜Ù‡ Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(561027,15585,'pr','Ù¾Ø±ÙˆÚ˜Ù‡ Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(561028,15585,'tr','Proje yeni/DÃ¼zenle',0),(561029,15585,'pl','Projekt nowego/edycja',0),(561030,15585,'bg','ÐÐ¾Ð² Ð¿Ñ€Ð¾ÐµÐºÑ‚/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(561031,15585,'ur','Ù†Ø¦Û’ Ù…Ù†ØµÙˆØ¨Û’/ØªØ¯ÙˆÛŒÙ†',0),(561032,15585,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÐ°Ñ‚/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(561033,15585,'vi','Dá»± Ã¡n má»›i/Edit',0),(561034,15585,'af','Nuwe projek/redigeer',0),(561035,15585,'ro','Proiect nou/editare',0),(561036,15585,'et','Projekti uus/Muuda',0),(561037,15585,'si','Projekt nove/Uredi',0),(561038,15585,'ba','Proyek baru/Edit',0),(561039,15585,'nl','Project nieuwe/bewerken',0),(561040,15585,'fi','Projektin uusi tai Muokkaa',0),(561041,15585,'no','Prosjektet ny/Rediger',0),(561042,15585,'da','Projekt ny/Rediger',0),(561043,15585,'ko','í”„ë¡œì íŠ¸ ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘',0),(561044,15585,'he','×¤×¨×•×™×™×§×˜ ×—×“×©/×¢×¨×™×›×”',0),(561045,15585,'el','ÎÎ­Î¿ Î­ÏÎ³Î¿/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(561046,15585,'zh','é¡¹ç›®æ–°å»º/ç¼–è¾‘',0),(561047,15585,'sv','Nya projekt/redigera',0),(561048,15585,'it','Progetto nuovo/modifica',0),(561049,15585,'tl','',0),(561050,15585,'th','à¹‚à¸„à¸£à¸‡à¸à¸²à¸£à¹ƒà¸«à¸¡à¹ˆ/à¹à¸à¹‰à¹„à¸‚',0),(561051,15585,'hi','à¤¨à¤ˆ à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤',0),(561052,15585,'ms','Projek baru/Edit',0),(561053,15585,'ar','Ø§Ù„Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ø¬Ø¯ÙŠØ¯/ØªØ­Ø±ÙŠØ±',0),(561054,15585,'fr','Edit/nouveau projet',0),(561055,15585,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆã®ä½œæˆ/ç·¨é›†',0),(561056,15585,'pt','Novo projeto/editar',0),(561057,15585,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ñ€Ð¾ÐµÐºÑ‚/ÐŸÑ€Ð°Ð²ÐºÐ°',0),(561058,15585,'es','Proyecto nuevo/editar',0),(561059,15585,'de','Projekt neu/bearbeiten',0),(561060,15585,'en','Project New/Edit',0),(561061,15586,'is','',0),(561062,15586,'dr','Ù„Ø·ÙØ§ Ú©Ø¯ Ø³Ø§ÛŒØª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(561063,15586,'pr','Ù„Ø·ÙØ§ Ú©Ø¯ Ø³Ø§ÛŒØª Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(561064,15586,'tr','Bir Site kodunu giriniz',0),(561065,15586,'pl','Podaj kod witryny',0),(561066,15586,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÐºÐ¾Ð´ Ð½Ð° ÑÐ°Ð¹Ñ‚Ð°',0),(561067,15586,'ur','Ø§ÛŒÚ© ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ø¶Ø§Ø¨Ø·Û Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(561068,15586,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ ÑˆÐ¸Ñ„Ñ€Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(561069,15586,'vi','Vui lÃ²ng nháº­p mÃ£ trang web',0),(561070,15586,'af','Tik asseblief \'n werf kode',0),(561071,15586,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un cod de site-ul',0),(561072,15586,'et','Palun sisestage saidi kood',0),(561073,15586,'si','Vnesite Å¡ifro mesta',0),(561074,15586,'ba','Harap masukkan kode situs',0),(561075,15586,'nl','Voer een Code van de Site',0),(561076,15586,'fi','Anna sivuston koodi',0),(561077,15586,'no','Angi en omrÃ¥de-kode',0),(561078,15586,'da','Indtast venligst en Site kode',0),(561079,15586,'ko','ì‚¬ì´íŠ¸ ì½”ë“œë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(561080,15586,'he','×× × ×”×–×Ÿ ××ª ×§×•×“ ×”××ª×¨',0),(561081,15586,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± ÎºÏ‰Î´Î¹ÎºÏŒ Î¹ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î±Ï‚',0),(561082,15586,'zh','è¯·è¾“å…¥ä¸€ä¸ªç«™ç‚¹ä»£ç ',0),(561083,15586,'sv','Ange en webbplats kod',0),(561084,15586,'it','Si prega di inserire un codice di sito',0),(561085,15586,'tl','',0),(561086,15586,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸£à¸«à¸±à¸ªà¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ',0),(561087,15586,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¸à¤¾à¤‡à¤Ÿ à¤•à¥‹à¤¡ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(561088,15586,'ms','Sila masukkan kod lokasi',0),(561089,15586,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù…Ø² Ù…ÙˆÙ‚Ø¹',0),(561090,15586,'fr','Veuillez saisir un Code de Site',0),(561091,15586,'jp','ã‚µã‚¤ãƒˆ ã‚³ãƒ¼ãƒ‰ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(561092,15586,'pt','Por favor, introduza um cÃ³digo de Site',0),(561093,15586,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÐºÐ¾Ð´ ÑÐ°Ð¹Ñ‚Ð°',0),(561094,15586,'es','Introduce un cÃ³digo de sitio',0),(561095,15586,'de','Bitte geben Sie einen Site-Code',0),(561096,15586,'en','Please Enter A Site Code',0),(561097,15587,'is','',0),(561098,15587,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ù†Ø§Ù… Ø³Ø§ÛŒØª ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(561099,15587,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ù†Ø§Ù… Ø³Ø§ÛŒØª ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(561100,15587,'tr','LÃ¼tfen bir Site adÄ± girin',0),(561101,15587,'pl','WprowadÅº nazwÄ™ witryny',0),(561102,15587,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð½Ð° ÑÐ°Ð¹Ñ‚',0),(561103,15587,'ur','Ø§ÛŒÚ© ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ú©Ø§ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(561104,15587,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð½Ð°Ð·Ð¸Ð² Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(561105,15587,'vi','Vui lÃ²ng nháº­p tÃªn trang web',0),(561106,15587,'af','Tik asseblief \'n webwerf naam',0),(561107,15587,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un nume de site-ul',0),(561108,15587,'et','Sisestage saidi nimi',0),(561109,15587,'si','Vnesite ime mesta',0),(561110,15587,'ba','Silahkan masukkan nama situs',0),(561111,15587,'nl','Voer de naam van een Site',0),(561112,15587,'fi','Kirjoita sivustonimi',0),(561113,15587,'no','Angi et omrÃ¥denavn',0),(561114,15587,'da','Angiv et webstedsnavn',0),(561115,15587,'ko','ì‚¬ì´íŠ¸ ì´ë¦„ì„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤',0),(561116,15587,'he','×× × ×”×›× ×¡ ×©× ×”××ª×¨',0),(561117,15587,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±Ï‚',0),(561118,15587,'zh','è¯·è¾“å…¥ç«™ç‚¹åç§°',0),(561119,15587,'sv','Ange ett platsnamn',0),(561120,15587,'it','Si prega di inserire un nome di sito',0),(561121,15587,'tl','',0),(561122,15587,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸Šà¸·à¹ˆà¸­à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ',0),(561123,15587,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤¿à¤¸à¥€ à¤¸à¤¾à¤‡à¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(561124,15587,'ms','Sila masukkan nama lokasi',0),(561125,15587,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ø³Ù… Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(561126,15587,'fr','Veuillez entrer un nom de Site',0),(561127,15587,'jp','ã‚µã‚¤ãƒˆåã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(561128,15587,'pt','Por favor digite um nome de Site',0),(561129,15587,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð¸Ð¼Ñ ÑÐ°Ð¹Ñ‚Ð°',0),(561130,15587,'es','Introduzca un nombre de sitio',0),(561131,15587,'de','Bitte geben Sie einen Site-Namen',0),(561132,15587,'en','Please Enter A Site Name',0),(561133,15588,'is','',0),(561134,15588,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³Ø§ÛŒØª',0),(561135,15588,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³Ø§ÛŒØª',0),(561136,15588,'tr','Site seÃ§in',0),(561137,15588,'pl','Wybierz witrynÄ™',0),(561138,15588,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÐ°Ð¹Ñ‚',0),(561139,15588,'ur','Ø³Ø§Ø¦Ù¹ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(561140,15588,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(561141,15588,'vi','Chá»n trang web',0),(561142,15588,'af','Kies werf',0),(561143,15588,'ro','SelectaÅ£i site-ul',0),(561144,15588,'et','Valige sait',0),(561145,15588,'si','Izberite stran',0),(561146,15588,'ba','Pilih situs',0),(561147,15588,'nl','Selecteer Site',0),(561148,15588,'fi','Valitse sivusto',0),(561149,15588,'no','Velg omrÃ¥de',0),(561150,15588,'da','VÃ¦lg sted',0),(561151,15588,'ko','ì‚¬ì´íŠ¸ ì„ íƒ',0),(561152,15588,'he','×‘×—×¨ ××ª×¨',0),(561153,15588,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(561154,15588,'zh','é€‰æ‹©ç«™ç‚¹',0),(561155,15588,'sv','VÃ¤lj plats',0),(561156,15588,'it','Selezionare sito',0),(561157,15588,'tl','',0),(561158,15588,'th','à¹€à¸¥à¸·à¸­à¸à¹„à¸‹à¸•à¹Œ',0),(561159,15588,'hi','à¤¸à¤¾à¤‡à¤Ÿ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(561160,15588,'ms','Pilih tapak',0),(561161,15588,'ar','Ø­Ø¯Ø¯ Ù…ÙˆÙ‚Ø¹',0),(561162,15588,'fr','SÃ©lectionner le Site',0),(561163,15588,'jp','ã‚µã‚¤ãƒˆã‚’é¸æŠžã—ã¾ã™ã€‚',0),(561164,15588,'pt','Selecione o Site',0),(561165,15588,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑÐ°Ð¹Ñ‚',0),(561166,15588,'es','Seleccionar sitio',0),(561167,15588,'de','WÃ¤hlen Sie Site',0),(561168,15588,'en','Select Site',0),(561169,15589,'is','',0),(561170,15589,'dr','Ø³Ø§ÛŒØª Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(561171,15589,'pr','Ø³Ø§ÛŒØª Ø¬Ø¯ÛŒØ¯/ÙˆÛŒØ±Ø§ÛŒØ´',0),(561172,15589,'tr','Site yeni/DÃ¼zenle',0),(561173,15589,'pl','Nowe witryny/edycja',0),(561174,15589,'bg','ÐÐ¾Ð² ÑÐ°Ð¹Ñ‚/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(561175,15589,'ur','Ù†Ø¦ÛŒ ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹/ØªØ¯ÙˆÛŒÙ†',0),(561176,15589,'sr','ÐÐ¾Ð²Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(561177,15589,'vi','Trang web má»›i/Edit',0),(561178,15589,'af','Nuwe webwerf/redigeer',0),(561179,15589,'ro','Site-ul nou/editare',0),(561180,15589,'et','Saidi uus/Muuda',0),(561181,15589,'si','Novo mesto/Uredi',0),(561182,15589,'ba','Situs baru/Edit',0),(561183,15589,'nl','Nieuwe site/bewerken',0),(561184,15589,'fi','Sivuston uusi tai Muokkaa',0),(561185,15589,'no','Siden Ny/Rediger',0),(561186,15589,'da','Site ny/Rediger',0),(561187,15589,'ko','ì‚¬ì´íŠ¸ ìƒˆë¡œ ë§Œë“¤ê¸°/íŽ¸ì§‘',0),(561188,15589,'he','××ª×¨ ×—×“×©/×¢×¨×™×›×”',0),(561189,15589,'el','ÎÎ­Î¿ site/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(561190,15589,'zh','ç½‘ç«™æ–°/ç¼–è¾‘',0),(561191,15589,'sv','Den nya webbplatsen/redigera',0),(561192,15589,'it','Sito nuovo/modifica',0),(561193,15589,'tl','',0),(561194,15589,'th','à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œà¹ƒà¸«à¸¡à¹ˆ/à¹à¸à¹‰à¹„à¸‚',0),(561195,15589,'hi','à¤¨à¤¯à¤¾ à¤¸à¤¾à¤‡à¤Ÿ/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤',0),(561196,15589,'ms','Laman web baru/Edit',0),(561197,15589,'ar','Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø¬Ø¯ÙŠØ¯/ØªØ­Ø±ÙŠØ±',0),(561198,15589,'fr','Nouveau site/modifier',0),(561199,15589,'jp','ã‚µã‚¤ãƒˆä½œæˆ/ç·¨é›†',0),(561200,15589,'pt','Novo site/editar',0),(561201,15589,'ru','ÐÐ¾Ð²Ñ‹Ð¹ ÑÐ°Ð¹Ñ‚ Ð¸ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(561202,15589,'es','Sitio nuevo o editar',0),(561203,15589,'de','Website neu/bearbeiten',0),(561204,15589,'en','Site New/Edit',0),(561205,15590,'is','',0),(561206,15590,'dr','Ø¬Ø¯ÙˆÙ„ Ù…Ø´Ø§ØºÙ„',0),(561207,15590,'pr','Ø¬Ø¯ÙˆÙ„ Ù…Ø´Ø§ØºÙ„',0),(561208,15590,'tr','Ä°ÅŸleri tablo',0),(561209,15590,'pl','Jobs tabela',0),(561210,15590,'bg','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð°Ñ‚Ð° \"Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð¼ÐµÑÑ‚Ð°\"',0),(561211,15590,'ur','Ù…Ù„Ø§Ø²Ù…ØªÙˆÚº Ú©ÛŒ Ù…ÛŒØ²',0),(561212,15590,'sr','ÐŸÐ¾ÑÐ»Ð¾Ð²Ð¸ Ñ‚Ð°Ð±ÐµÐ»Ðµ',0),(561213,15590,'vi','Báº£ng cÃ´ng Äƒn viá»‡c lÃ m',0),(561214,15590,'af','Jobs tabel',0),(561215,15590,'ro','Tabelul de locuri de muncÄƒ',0),(561216,15590,'et','TÃ¶Ã¶de tabeli',0),(561217,15590,'si','Tabelo delovnih mest',0),(561218,15590,'ba','Pekerjaan Meja',0),(561219,15590,'nl','Banen tabel',0),(561220,15590,'fi','TyÃ¶paikkojen taulukon',0),(561221,15590,'no','Jobber tabell',0),(561222,15590,'da','Job bord',0),(561223,15590,'ko','ìž‘ì—… í…Œì´ë¸”',0),(561224,15590,'he','×©×•×œ×—×Ÿ ×¢×‘×•×“×”',0),(561225,15590,'el','Î Î¯Î½Î±ÎºÎ± Jobs',0),(561226,15590,'zh','å·¥ä½œè¡¨',0),(561227,15590,'sv','Jobb tabell',0),(561228,15590,'it','Tabella jobs',0),(561229,15590,'tl','',0),(561230,15590,'th','à¸•à¸²à¸£à¸²à¸‡à¸‡à¸²à¸™',0),(561231,15590,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¤à¤¾à¤²à¤¿à¤•à¤¾',0),(561232,15590,'ms','Jadual kerja',0),(561233,15590,'ar','Ø¬Ø¯ÙˆÙ„ Ø§Ù„ÙˆØ¸Ø§Ø¦Ù',0),(561234,15590,'fr','Table Jobs',0),(561235,15590,'jp','ã‚¸ãƒ§ãƒ– ãƒ†ãƒ¼ãƒ–ãƒ«',0),(561236,15590,'pt','Tabela de empregos',0),(561237,15590,'ru','Ð¢Ð°Ð±Ð»Ð¸Ñ†Ð° Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ðµ Ð¼ÐµÑÑ‚Ð°',0),(561238,15590,'es','Mesa de trabajo',0),(561239,15590,'de','Jobs-Tabelle',0),(561240,15590,'en','Jobs Table',0),(561241,15591,'is','',0),(561242,15591,'dr','Ù…Ø¯Ø§Ø±Ú© Ù¾Ø±ÙˆÚ˜Ù‡',0),(561243,15591,'pr','Ù…Ø¯Ø§Ø±Ú© Ù¾Ø±ÙˆÚ˜Ù‡',0),(561244,15591,'tr','Proje belgeleri',0),(561245,15591,'pl','Projektu dokumentÃ³w',0),(561246,15591,'bg','ÐŸÑ€Ð¾ÐµÐºÑ‚ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(561247,15591,'ur','Ù¾Ø±Ø§Ø¬ÛŒÚ©Ù¹ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(561248,15591,'sr','ÐŸÑ€Ð¾Ñ˜ÐµÐºÑ‚Ð½Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð°Ñ†Ð¸Ñ˜Ðµ',0),(561249,15591,'vi','TÃ i liá»‡u dá»± Ã¡n',0),(561250,15591,'af','Projek dokumente',0),(561251,15591,'ro','Documentele proiectului',0),(561252,15591,'et','Projekti dokumentide',0),(561253,15591,'si','Projektne dokumentacije',0),(561254,15591,'ba','Dokumen proyek',0),(561255,15591,'nl','Projectdocumenten',0),(561256,15591,'fi','Projektin asiakirjat',0),(561257,15591,'no','Prosjektdokumenter',0),(561258,15591,'da','Project-dokumenter',0),(561259,15591,'ko','í”„ë¡œì íŠ¸ ë¬¸ì„œ',0),(561260,15591,'he','×ž×¡×ž×›×™× ×©×œ project',0),(561261,15591,'el','Î•Î³Î³ÏÎ¬Ï†Ï‰Î½ Î­ÏÎ³Î¿Ï…',0),(561262,15591,'zh','é¡¹ç›®æ–‡ä»¶',0),(561263,15591,'sv','Projektdokument',0),(561264,15591,'it','Documenti di progetto',0),(561265,15591,'tl','',0),(561266,15591,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¹‚à¸„à¸£à¸‡à¸à¸²à¸£',0),(561267,15591,'hi','à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œ',0),(561268,15591,'ms','Dokumen-dokumen projek',0),(561269,15591,'ar','ÙˆØ«Ø§Ø¦Ù‚ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹',0),(561270,15591,'fr','Documents de projet',0),(561271,15591,'jp','ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆ ãƒ‰ã‚­ãƒ¥ãƒ¡ãƒ³ãƒˆ',0),(561272,15591,'pt','Documentos do projeto',0),(561273,15591,'ru','ÐŸÑ€Ð¾ÐµÐºÑ‚Ð½Ñ‹Ðµ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ñ‹',0),(561274,15591,'es','Documentos del proyecto',0),(561275,15591,'de','Projektdokumente',0),(561276,15591,'en','Project Documents',0),(561277,15592,'is','',0),(561278,15592,'dr','ÛŒÚ©ÛŒ Ø§Ø² Ù…Ø¬ÙˆØ²Ù‡Ø§ÛŒ Ø²ÛŒØ± Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ø§Ø³Øª',0),(561279,15592,'pr','ÛŒÚ©ÛŒ Ø§Ø² Ù…Ø¬ÙˆØ²Ù‡Ø§ÛŒ Ø²ÛŒØ± Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ø§Ø³Øª',0),(561280,15592,'tr','AÅŸaÄŸÄ±daki izinlerden birini ihtiyaÃ§ vardÄ±r',0),(561281,15592,'pl','Jeden z nastÄ™pujÄ…cych uprawnieÅ„ sÄ… potrzebne',0),(561282,15592,'bg','Ð•Ð´Ð½Ð¾ Ð¾Ñ‚ ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ ÑÐ° Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸',0),(561283,15592,'ur','Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ø§Ø¬Ø§Ø²ØªÛŒÚº Ù…ÛŒÚº Ø³Û’ Ø§ÛŒÚ© Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(561284,15592,'sr','ÐˆÐµÐ´Ð°Ð½ Ð¾Ð´ ÑÐ»ÐµÐ´ÐµÑ›Ðµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ðµ ÑÑƒ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ',0),(561285,15592,'vi','Má»™t trong cÃ¡c quyá»n sau Ä‘Ã¢y lÃ  cáº§n thiáº¿t',0),(561286,15592,'af','Een van die volgende toestemmings nodig is',0),(561287,15592,'ro','Una dintre urmÄƒtoarele permisiuni sunt necesare',0),(561288,15592,'et','Ãœks valikuist on vaja',0),(561289,15592,'si','Eno od naslednjih moÂ¾nosti so potrebni',0),(561290,15592,'ba','Salah satu izin berikut diperlukan',0),(561291,15592,'nl','Een van de volgende machtigingen nodig zijn',0),(561292,15592,'fi','Yksi seuraavat kÃ¤yttÃ¶oikeudet tarvitaan',0),(561293,15592,'no','En av fÃ¸lgende tillatelser kreves',0),(561294,15592,'da','En af de fÃ¸lgende tilladelser er nÃ¸dvendige',0),(561295,15592,'ko','ë‹¤ìŒ ì‚¬ìš© ê¶Œí•œ ì¤‘ í•˜ë‚˜ê°€ í•„ìš” í•˜ë‹¤',0),(561296,15592,'he','×œ××—×“ ×”×”×¨×©××•×ª ×”×‘××•×ª × ×“×¨×©×™×',0),(561297,15592,'el','ÎˆÎ½Î± Î±Ï€ÏŒ Ï„Î± Î±ÎºÏŒÎ»Î¿Ï…Î¸Î± Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Î±Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹',0),(561298,15592,'zh','ä¸‹åˆ—æƒé™ä¹‹ä¸€è¢«éœ€è¦',0),(561299,15592,'sv','En av fÃ¶ljande behÃ¶righeter krÃ¤vs',0),(561300,15592,'it','Una delle autorizzazioni seguenti sono necessarie',0),(561301,15592,'tl','',0),(561302,15592,'th','à¸ªà¸´à¸—à¸˜à¸´à¹Œà¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¸­à¸¢à¹ˆà¸²à¸‡à¹ƒà¸”à¸­à¸¢à¹ˆà¸²à¸‡à¸«à¸™à¸¶à¹ˆà¸‡à¸ˆà¸³à¹€à¸›à¹‡à¸™',0),(561303,15592,'hi','à¤¨à¤¿à¤®à¥à¤¨ à¤…à¤¨à¥à¤®à¤¤à¤¿à¤¯à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¸à¥‡ à¤à¤• à¤°à¤¹à¥‡ à¤¹à¥ˆà¤‚ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(561304,15592,'ms','Salah satu keizinan berikut diperlukan',0),(561305,15592,'ar','Ø£Ø­Ø¯ Ø§Ù„Ø£Ø°ÙˆÙ†Ø§Øª Ø§Ù„ØªØ§Ù„ÙŠØ© Ù…Ø·Ù„ÙˆØ¨Ø©',0),(561306,15592,'fr','Une des autorisations suivantes sont nÃ©cessaires',0),(561307,15592,'jp','æ¬¡ã®æ¨©é™ã®ã„ãšã‚Œã‹ãŒå¿…è¦',0),(561308,15592,'pt','Dentre as seguintes permissÃµes sÃ£o necessÃ¡rias',0),(561309,15592,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð¾Ð´Ð½Ð° Ð¸Ð· ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ñ… Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ð¹',0),(561310,15592,'es','Uno de los siguientes permisos son necesarios',0),(561311,15592,'de','Eine der folgenden Berechtigungen sind erforderlich',0),(561312,15592,'en','One Of The Following Permissions Are Needed',0),(561313,15593,'is','',0),(561314,15593,'dr','Ø¬Ø¯ÙˆÙ„ premissions Ø®Ø±Ø§Ø¨ Ø§Ø³Øª',0),(561315,15593,'pr','Ø¬Ø¯ÙˆÙ„ premissions Ø®Ø±Ø§Ø¨ Ø§Ø³Øª',0),(561316,15593,'tr','Premissions tablo bozuk',0),(561317,15593,'pl','Premissions tabela jest uszkodzony',0),(561318,15593,'bg','Premissions Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° Ðµ Ð¿Ð¾Ð²Ñ€ÐµÐ´ÐµÐ½',0),(561319,15593,'ur','Ù¾Ø±ÛŒÙ…Ø§Ø³Ø³Ø§Ù†Ø³ Ø¬Ø¯ÙˆÙ„ Ø®Ø±Ø§Ø¨ ÛÛ’',0),(561320,15593,'sr','ÐŸÑ€ÐµÐ¼Ð¸ÑÑÐ¸Ð¾Ð½Ñ Ñ‚Ð°Ð±ÐµÐ»Ð° Ñ˜Ðµ Ð¾ÑˆÑ‚ÐµÑ›ÐµÐ½Ð°',0),(561321,15593,'vi','Premissions báº£ng bá»‹ há»ng',0),(561322,15593,'af','Premissions tafel Is korrup',0),(561323,15593,'ro','Premissions tabel este corupt',0),(561324,15593,'et','Premissions tabel on rikutud',0),(561325,15593,'si','Tabela premissions je poÅ¡kodovana',0),(561326,15593,'ba','Premissions tabel korup',0),(561327,15593,'nl','Premissions tabel Is beschadigd',0),(561328,15593,'fi','Premissions taulukko on vioittunut',0),(561329,15593,'no','Premissions tabellen er skadet',0),(561330,15593,'da','Premissions tabel er beskadiget',0),(561331,15593,'ko','Premissions í…Œì´ë¸”ì€ ì†ìƒ',0),(561332,15593,'he','Premissions ×”×˜×‘×œ×” ×¤×’×•×',0),(561333,15593,'el','Premissions Ï€Î¯Î½Î±ÎºÎ± ÎµÎ¯Î½Î±Î¹ ÎºÎ±Ï„ÎµÏƒÏ„ÏÎ±Î¼Î¼Î­Î½Î¿',0),(561334,15593,'zh','æ‰¿è¯ºè¡¨å·²æŸå',0),(561335,15593,'sv','Premissions tabell Ã¤r skadad',0),(561336,15593,'it','Premissions tabella Ã¨ danneggiato',0),(561337,15593,'tl','',0),(561338,15593,'th','à¸•à¸²à¸£à¸²à¸‡ premissions à¹€à¸ªà¸µà¸¢à¸«à¸²à¸¢',0),(561339,15593,'hi','à¤•à¤¿à¤¯à¤¾ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¦à¥‚à¤·à¤¿à¤¤ à¤¹à¥ˆ',0),(561340,15593,'ms','Jadual premissions sudah rosak',0),(561341,15593,'ar','Ø¬Ø¯ÙˆÙ„ premissions ØªØ§Ù„Ù',0),(561342,15593,'fr','Premissions Table est corrompu',0),(561343,15593,'jp','è¨±è«¾æ¡ä»¶ãƒ†ãƒ¼ãƒ–ãƒ«ãŒç ´æã—ã¦ã„ã¾ã™ã€‚',0),(561344,15593,'pt','Tabela de premissions estÃ¡ corrompida',0),(561345,15593,'ru','ÐŸÐ¾Ð²Ñ€ÐµÐ¶Ð´ÐµÐ½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° premissions',0),(561346,15593,'es','Tabla de premissions es corrupto',0),(561347,15593,'de','Premissions Tabelle ist beschÃ¤digt',0),(561348,15593,'en','Premissions Table Is Corrupt',0),(561349,15594,'is','',0),(561350,15594,'dr','Ù…Ø¬ÙˆØ²Ù‡Ø§ÛŒ Ù„Ø§Ø²Ù… Ù†Ø´Ø¯',0),(561351,15594,'pr','Ù…Ø¬ÙˆØ²Ù‡Ø§ÛŒ Ù„Ø§Ø²Ù… Ù†Ø´Ø¯',0),(561352,15594,'tr','Gerekli izinleri bulunamadÄ±',0),(561353,15594,'pl','Wymagane uprawnienia nie znaleziono',0),(561354,15594,'bg','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(561355,15594,'ur','Ù…Ø·Ù„ÙˆØ¨Û Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº Ù…Ù„ÛŒ',0),(561356,15594,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð½Ðµ Ð´Ð¾Ð·Ð²Ð¾Ð»Ðµ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(561357,15594,'vi','Quyá»n yÃªu cáº§u khÃ´ng Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(561358,15594,'af','Vereiste toestemmings nie gevind nie',0),(561359,15594,'ro','Permisiunile necesare, nu a fost gÄƒsit',0),(561360,15594,'et','Ei leia nÃµutud Ãµigused',0),(561361,15594,'si','Zahtevanih dovoljenj ni bilo mogoÄe najti',0),(561362,15594,'ba','Diperlukan izin tidak ditemukan',0),(561363,15594,'nl','Vereiste machtigingen niet gevonden',0),(561364,15594,'fi','Vaadittuja kÃ¤yttÃ¶oikeuksia ei lÃ¶ydy',0),(561365,15594,'no','NÃ¸dvendige tillatelser ikke funnet',0),(561366,15594,'da','NÃ¸dvendige tilladelser ikke fundet',0),(561367,15594,'ko','í•„ìš”í•œ ì‚¬ìš© ê¶Œí•œì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(561368,15594,'he','×”×”×¨×©××•×ª ×”× ×“×¨×©×•×ª ×œ× × ×ž×¦×',0),(561369,15594,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½Î± Î´Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(561370,15594,'zh','æ‰¾ä¸åˆ°æ‰€éœ€çš„æƒé™',0),(561371,15594,'sv','BehÃ¶righeter som krÃ¤vs inte finns',0),(561372,15594,'it','Autorizzazioni necessarie non trovate',0),(561373,15594,'tl','',0),(561374,15594,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸ªà¸´à¸—à¸˜à¸´à¹Œà¸—à¸µà¹ˆà¸ˆà¸³à¹€à¸›à¹‡à¸™',0),(561375,15594,'hi','à¤†à¤µà¤¶à¥à¤¯à¤• à¤…à¤¨à¥à¤®à¤¤à¤¿à¤¯à¤¾à¤ à¤¨à¤¹à¥€à¤‚ à¤ªà¤¾à¤¯à¤¾',0),(561376,15594,'ms','Kebenaran yang diperlukan tidak dijumpai',0),(561377,15594,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø£Ø°ÙˆÙ†Ø§Øª Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(561378,15594,'fr','Autorisations requises introuvables',0),(561379,15594,'jp','å¿…è¦ãªã‚¢ã‚¯ã‚»ã‚¹è¨±å¯ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(561380,15594,'pt','PermissÃµes necessÃ¡rias nÃ£o encontradas',0),(561381,15594,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÐ¼Ñ‹Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°',0),(561382,15594,'es','Permisos necesarios no se encuentran',0),(561383,15594,'de','Erforderlichen Berechtigungen nicht gefunden',0),(561384,15594,'en','Required Permissions Not Found',0),(561385,15595,'is','',0),(561386,15595,'dr','Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù‡Ø²ÛŒÙ†Ù‡ & Ù…Ù‚Ø§Ø¯ÛŒØ± Ø¨Ø§ ØµØ§Ø¯Ø±Ø§Øª Ùˆ ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø¨Ø²Ø§Ø± ÙˆÛŒØ±Ø§ÛŒØ´ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯',0),(561387,15595,'pr','Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù‡Ø²ÛŒÙ†Ù‡ & Ù…Ù‚Ø§Ø¯ÛŒØ± Ø¨Ø§ ØµØ§Ø¯Ø±Ø§Øª Ùˆ ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø¨Ø²Ø§Ø± ÙˆÛŒØ±Ø§ÛŒØ´ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯',0),(561388,15595,'tr','DÄ±ÅŸa aktarma/iÃ§e aktarma aracÄ± ile miktarlarÄ± ve esasÄ±na gÃ¶re madde maliyetlerinin dÃ¼zenleyemezsiniz',0),(561389,15595,'pl','Nie moÅ¼na edytowaÄ‡ elementu kosztÃ³w idealna iloÅ›ci eksportu/importu narzÄ™dzie',0),(561390,15595,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ & ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð° Ñ Ð¸Ð·Ð½Ð¾Ñ/Ð²Ð½Ð¾Ñ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚',0),(561391,15595,'ur','Ø´Û’ Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª & Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø±Ø¢Ù…Ø¯/Ø¨Ø±Ø¢Ù…Ø¯ Ù¹ÙˆÙ„ Ú©Û’ Ø³Ø§ØªÚ¾ ØªØ¯ÙˆÛŒÙ† Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(561392,15595,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÑƒÑ€ÐµÐ´Ð¸Ñ‚Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð° Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ðµ ÑÐ° Ð°Ð»Ð°Ñ‚ÐºÐ° Ð·Ð° Ð¸Ð·Ð²Ð¾Ð·/ÑƒÐ²Ð¾Ð·',0),(561393,15595,'vi','KhÃ´ng thá»ƒ chá»‰nh sá»­a khoáº£n má»¥c chi phÃ­ & lÆ°á»£ng vá»›i xuáº¥t kháº©u, nháº­p kháº©u cÃ´ng cá»¥',0),(561394,15595,'af','Kan nie redigeer nie Item koste & hoeveelhede met uitvoer/invoer instrument',0),(561395,15595,'ro','Nu se poate edita elementul costurile & cantitÄƒÅ£i cu instrument de Export/Import',0),(561396,15595,'et','Ei saa muuta Ã¼ksuse maksab- & koguste eksport/Import tÃ¶Ã¶riist',0),(561397,15595,'si','Ni mogoÄe urejati stroÅ¡kov artikla & koliÄine z izvozom orodje',0),(561398,15595,'ba','Tidak dapat mengedit Item biaya & jumlah dengan ekspor/impor alat',0),(561399,15595,'nl','Niet bewerken Item kosten & hoeveelheden met Export/Import Tool',0),(561400,15595,'fi','Ei voi muokata nimikekustannukset & mÃ¤Ã¤rÃ¤t vienti/tuonti-tyÃ¶kalulla',0),(561401,15595,'no','Kan ikke redigere varekostnader & mengder med eksport-/ importverktÃ¸yet',0),(561402,15595,'da','Kan ikke redigere vareomkostninger & mÃ¦ngder med eksport/Import vÃ¦rktÃ¸j',0),(561403,15595,'ko','í•­ëª© ë¹„ìš© ë° ìˆ˜ëŸ‰ ë‚´ë³´ë‚´ê¸°/ê°€ì ¸ì˜¤ê¸° ë„êµ¬ë¡œ íŽ¸ì§‘í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(561404,15595,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×¢×¨×•×š ××ª ×”×¤×¨×™×˜ ×”×¢×œ×•×™×•×ª & ×›×ž×•×™×•×ª ×‘×›×œ×™ ×™×™×¦×•×/×™×™×‘×•×',0),(561405,15595,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„ÏŒ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ & Ï€Î¿ÏƒÏŒÏ„Î·Ï„ÎµÏ‚ Î¼Îµ Ï„Î¿ ÎµÏÎ³Î±Î»ÎµÎ¯Î¿ ÎµÎ¾Î±Î³Ï‰Î³Î®Ï‚/ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(561406,15595,'zh','ä¸èƒ½ç¼–è¾‘ç‰©æ–™æˆæœ¬åŠæ•°é‡ä¸Žå¯¼å‡º/å¯¼å…¥å·¥å…·',0),(561407,15595,'sv','Kan inte redigera artikelkostnader & mÃ¤ngder med verktyg fÃ¶r Export/Import',0),(561408,15595,'it','Non Ã¨ possibile modificare la voce costi & quantitativi con strumento di esportazione/importazione',0),(561409,15595,'tl','',0),(561410,15595,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹à¸à¹‰à¹„à¸‚à¸•à¹‰à¸™à¸—à¸¸à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¹à¸¥à¸°à¸›à¸£à¸´à¸¡à¸²à¸“ à¸”à¹‰à¸§à¸¢à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¸à¸±à¸™',0),(561411,15595,'hi','à¤†à¤‡à¤Ÿà¤® à¤²à¤¾à¤—à¤¤ & à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤†à¤¯à¤¾à¤¤/à¤¨à¤¿à¤°à¥à¤¯à¤¾à¤¤ à¤‰à¤ªà¤•à¤°à¤£ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(561412,15595,'ms','Tidak boleh mengedit Item kos & kuantiti dengan alat Eksport/Import',0),(561413,15595,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­Ø±ÙŠØ± Ø¹Ù†ØµØ± Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ & ÙƒÙ…ÙŠØ§Øª Ù…Ø¹ Ø£Ø¯Ø§Ø© Ø§Ù„ØªØµØ¯ÙŠØ± ÙˆØ§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(561414,15595,'fr','Ne pouvez pas modifier la question des coÃ»ts & quantitÃ©s avec outil d\'Import/Export',0),(561415,15595,'jp','ã‚¢ã‚¤ãƒ†ãƒ  ã‚³ã‚¹ãƒˆ & ã‚¨ã‚¯ã‚¹ãƒãƒ¼ãƒˆ/ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ãƒ„ãƒ¼ãƒ«ã‚’ä½¿ç”¨é‡ã¯ç·¨é›†ã§ãã¾ã›ã‚“ã€‚',0),(561416,15595,'pt','NÃ£o Ã© possÃ­vel editar Item custos e quantidades com ferramenta de exportaÃ§Ã£o/importaÃ§Ã£o',0),(561417,15595,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð² & ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°Ñ… Ñ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚ ÑÐºÑÐ¿Ð¾Ñ€Ñ‚Ð°/Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(561418,15595,'es','No se puede modificar los costos del artÃ­culo y cantidades con la herramienta de exportaciÃ³n/importaciÃ³n',0),(561419,15595,'de','Element-Kosten & Mengen mit Export/Import-Tool kann nicht bearbeitet werden.',0),(561420,15595,'en','Cannot Edit Item Costs & Quantities With Export/Import Tool',0),(561421,15596,'is','',0),(561422,15596,'dr','Ù„Ø·ÙØ§ Ø§ÛŒØ¬Ø§Ø¯ ÛŒÚ© Ø³Ø§ÛŒØª',0),(561423,15596,'pr','Ù„Ø·ÙØ§ Ø§ÛŒØ¬Ø§Ø¯ ÛŒÚ© Ø³Ø§ÛŒØª',0),(561424,15596,'tr','LÃ¼tfen bir Site oluÅŸturmak',0),(561425,15596,'pl','ProszÄ™ utworzyÄ‡ witrynÄ™',0),(561426,15596,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð¹Ñ‚Ðµ ÑÐ°Ð¹Ñ‚',0),(561427,15596,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§ÛŒÚ© ÙˆÛŒØ¨ Ø³Ø§Ø¦Ù¹ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(561428,15596,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð´Ð° ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ‚Ðµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(561429,15596,'vi','HÃ£y táº¡o ra má»™t trang web',0),(561430,15596,'af','Skep asseblief \'n webwerf',0),(561431,15596,'ro','VÄƒ rugÄƒm sÄƒ creaÅ£i un Site',0),(561432,15596,'et','Palun luua saidi',0),(561433,15596,'si','Ustvarite stran',0),(561434,15596,'ba','Silakan membuat situs',0),(561435,15596,'nl','Maak een Site',0),(561436,15596,'fi','Luo sivusto',0),(561437,15596,'no','Opprett et omrÃ¥de',0),(561438,15596,'da','Opret et websted',0),(561439,15596,'ko','ì‚¬ì´íŠ¸ë¥¼ ë§Œë“¤ì–´ ì£¼ì„¸ìš”',0),(561440,15596,'he','×‘×‘×§×©×” ×œ×™×¦×•×¨ ××ª×¨',0),(561441,15596,'el','ÎœÏ€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Î¼Î¹Î± Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(561442,15596,'zh','è¯·åˆ›å»ºä¸€ä¸ªç«™ç‚¹',0),(561443,15596,'sv','Skapa en webbplats',0),(561444,15596,'it','Si prega di creare un sito',0),(561445,15596,'tl','',0),(561446,15596,'th','à¸à¸£à¸¸à¸“à¸²à¸ªà¸£à¹‰à¸²à¸‡à¹„à¸‹à¸•à¹Œ',0),(561447,15596,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¸à¤¾à¤‡à¤Ÿ à¤¬à¤¨à¤¾à¤à¤',0),(561448,15596,'ms','Sila membuat tapak',0),(561449,15596,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙˆÙ‚Ø¹',0),(561450,15596,'fr','Veuillez crÃ©er un Site',0),(561451,15596,'jp','ã‚µã‚¤ãƒˆã‚’ä½œæˆã—ã¦ãã ã•ã„ã€‚',0),(561452,15596,'pt','Por favor, crie um Site',0),(561453,15596,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑÐ¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ ÑÐ°Ð¹Ñ‚',0),(561454,15596,'es','Por favor, crear un sitio web',0),(561455,15596,'de','Erstellen Sie bitte einen Standort',0),(561456,15596,'en','Please Create A Site',0),(561457,15597,'is','',0),(561458,15597,'dr','Ø§Ù‚Ù„Ø§Ù… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(561459,15597,'pr','Ø§Ù‚Ù„Ø§Ù… ØµÙˆØ±ØªØ­Ø³Ø§Ø¨',0),(561460,15597,'tr','Fatura Ã¶ÄŸeleri',0),(561461,15597,'pl','Rozliczenia pozycji',0),(561462,15597,'bg','Ð¢Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(561463,15597,'ur','Ø¨Ø§Ù„Ù„Ø§Ø¯ Ø§Ø´ÛŒØ§',0),(561464,15597,'sr','ÐšÑƒÐ¿Ð¾Ð²Ð¸Ð½Ð° Ñ‚ÐµÑ€ÐµÑ‚Ð¸Ñ›Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(561465,15597,'vi','Má»¥c quáº£ng cÃ¡o',0),(561466,15597,'af','WeerspieÃ«l Items',0),(561467,15597,'ro','Elementele facturate',0),(561468,15597,'et','Maksustatud minutite Ã¼ksused',0),(561469,15597,'si','Bremenjene elementov',0),(561470,15597,'ba','Ditagih item',0),(561471,15597,'nl','Gefactureerde artikelen',0),(561472,15597,'fi','Laskutetut nimikkeet',0),(561473,15597,'no','Fakturerte varer',0),(561474,15597,'da','Faktureret elementer',0),(561475,15597,'ko','ì²­êµ¬ í•­ëª©',0),(561476,15597,'he','×¤×¨×™×˜×™× ×©×—×•×™×‘',0),(561477,15597,'el','Î§ÏÎµÏ‰Î¸ÎµÎ¯ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(561478,15597,'zh','æ”¶è´¹çš„é¡¹ç›®',0),(561479,15597,'sv','Fakturerade artiklar',0),(561480,15597,'it','Articoli fatturati',0),(561481,15597,'tl','',0),(561482,15597,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(561483,15597,'hi','à¤¬à¤¿à¤² à¤†à¤‡à¤Ÿà¤®',0),(561484,15597,'ms','Item-item yang dibilkan sebanyak',0),(561485,15597,'ar','Ø§Ù„Ø£ØµÙ†Ø§Ù Ø§Ù„Ù…ÙÙˆØªØ±Ø©',0),(561486,15597,'fr','Ã‰lÃ©ments facturÃ©s',0),(561487,15597,'jp','è«‹æ±‚é …ç›®',0),(561488,15597,'pt','Itens faturados',0),(561489,15597,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ ÑÑ‡ÐµÑ‚Ð°',0),(561490,15597,'es','ArtÃ­culos facturados',0),(561491,15597,'de','-Abrechnung Elemente',0),(561492,15597,'en','Billed Items',0),(561493,15598,'is','',0),(561494,15598,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ',0),(561495,15598,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ',0),(561496,15598,'tr','Maliyeti',0),(561497,15598,'pl','Koszty',0),(561498,15598,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(561499,15598,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(561500,15598,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(561501,15598,'vi','Chi phÃ­',0),(561502,15598,'af','Kostes',0),(561503,15598,'ro','Costurile',0),(561504,15598,'et','Kulud',0),(561505,15598,'si','StroÅ¡ki',0),(561506,15598,'ba','Biaya',0),(561507,15598,'nl','Kosten',0),(561508,15598,'fi','Kustannukset',0),(561509,15598,'no','Kostnader',0),(561510,15598,'da','Omkostninger',0),(561511,15598,'ko','ë¹„ìš©',0),(561512,15598,'he','×¢×œ×•×™×•×ª',0),(561513,15598,'el','ÎšÏŒÏƒÏ„Î¿Ï‚',0),(561514,15598,'zh','è´¹ç”¨',0),(561515,15598,'sv','Kostnader',0),(561516,15598,'it','Costi',0),(561517,15598,'tl','',0),(561518,15598,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢',0),(561519,15598,'hi','à¤²à¤¾à¤—à¤¤',0),(561520,15598,'ms','Kos',0),(561521,15598,'ar','Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(561522,15598,'fr','CoÃ»ts',0),(561523,15598,'jp','ã‚³ã‚¹ãƒˆ',0),(561524,15598,'pt','Custos de',0),(561525,15598,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(561526,15598,'es','Costos de',0),(561527,15598,'de','Kosten',0),(561528,15598,'en','Costs',0),(561529,15599,'is','',0),(561530,15599,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ',0),(561531,15599,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ',0),(561532,15599,'tr','Maliyeti toplam',0),(561533,15599,'pl','Koszty ogÃ³Å‚em',0),(561534,15599,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(561535,15599,'ur','Ú©Ù„ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(561536,15599,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(561537,15599,'vi','Tá»•ng cá»™ng chi phÃ­',0),(561538,15599,'af','Koste totaal',0),(561539,15599,'ro','Total costuri',0),(561540,15599,'et','Kulud kokku',0),(561541,15599,'si','StroÅ¡ki skupaj',0),(561542,15599,'ba','Total biaya',0),(561543,15599,'nl','Kosten totaal',0),(561544,15599,'fi','Kustannukset yhteensÃ¤',0),(561545,15599,'no','Kostnader totalt',0),(561546,15599,'da','Udgifter i alt',0),(561547,15599,'ko','ë¹„ìš© í•©ê³„',0),(561548,15599,'he','×¡×” ×› ×¢×œ×•×™×•×ª',0),(561549,15599,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(561550,15599,'zh','è´¹ç”¨æ€»è®¡',0),(561551,15599,'sv','Kostnader totalt',0),(561552,15599,'it','Totale costi',0),(561553,15599,'tl','',0),(561554,15599,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸£à¸§à¸¡',0),(561555,15599,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥à¤²',0),(561556,15599,'ms','Jumlah kos',0),(561557,15599,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(561558,15599,'fr','Total des coÃ»ts',0),(561559,15599,'jp','ã‚³ã‚¹ãƒˆåˆè¨ˆ',0),(561560,15599,'pt','Total de custos',0),(561561,15599,'ru','Ð’ÑÐµÐ³Ð¾ Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(561562,15599,'es','Total de costos',0),(561563,15599,'de','Kosten Total',0),(561564,15599,'en','Costs Total',0),(561565,15600,'is','',0),(561566,15600,'dr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(561567,15600,'pr','Ù…Ø¬Ù…ÙˆØ¹ ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(561568,15600,'tr','Fatura toplam',0),(561569,15600,'pl','Suma faktury',0),(561570,15600,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð¾Ð±Ñ‰Ð¾',0),(561571,15600,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©Ù„',0),(561572,15600,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(561573,15600,'vi','Tá»•ng sá»‘ hÃ³a Ä‘Æ¡n',0),(561574,15600,'af','Fakture totaal',0),(561575,15600,'ro','Total facturi',0),(561576,15600,'et','Arveid kokku',0),(561577,15600,'si','RaÄune skupaj',0),(561578,15600,'ba','Total tagihan',0),(561579,15600,'nl','Facturen totaal',0),(561580,15600,'fi','Laskut yhteensÃ¤',0),(561581,15600,'no','Fakturaer totalt',0),(561582,15600,'da','Fakturaer i alt',0),(561583,15600,'ko','ì²­êµ¬ì„œ í•©ê³„',0),(561584,15600,'he','×¡×” ×› ×—×©×‘×•× ×™×•×ª',0),(561585,15600,'el','Î£ÏÎ½Î¿Î»Î¿ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(561586,15600,'zh','å‘ç¥¨æ€»é¢',0),(561587,15600,'sv','Fakturor totalt',0),(561588,15600,'it','Totale fatture',0),(561589,15600,'tl','',0),(561590,15600,'th','à¸£à¸§à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(561591,15600,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥à¤²',0),(561592,15600,'ms','Invois jumlah',0),(561593,15600,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(561594,15600,'fr','Total des factures',0),(561595,15600,'jp','è«‹æ±‚æ›¸åˆè¨ˆ',0),(561596,15600,'pt','Total de faturas',0),(561597,15600,'ru','Ð’ÑÐµÐ³Ð¾ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(561598,15600,'es','Total de facturas',0),(561599,15600,'de','Rechnungen Gesamt',0),(561600,15600,'en','Invoices Total',0),(561601,15601,'is','',0),(561602,15601,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÛŒØ¯',0),(561603,15601,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø³ÙØ§Ø±Ø´Ø§Øª Ø®Ø±ÛŒØ¯',0),(561604,15601,'tr','SatÄ±nalma sipariÅŸleri toplam',0),(561605,15601,'pl','Suma zamÃ³wienia zakupu',0),(561606,15601,'bg','ÐžÐ±Ñ‰Ð¾ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(561607,15601,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ù„',0),(561608,15601,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(561609,15601,'vi','Mua táº¥t cáº£ cÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(561610,15601,'af','Aankoop bestellings totaal',0),(561611,15601,'ro','Total de comenzi de cumpÄƒrare',0),(561612,15601,'et','Tellimusi kokku osta',0),(561613,15601,'si','Nakup naroÄila skupaj',0),(561614,15601,'ba','Total pesanan pembelian',0),(561615,15601,'nl','Inkoop Orders totaal',0),(561616,15601,'fi','Ostotilaukset yhteensÃ¤',0),(561617,15601,'no','KjÃ¸p ordre totalt',0),(561618,15601,'da','KÃ¸b ordrer alt',0),(561619,15601,'ko','êµ¬ë§¤ ì£¼ë¬¸ í•©ê³„',0),(561620,15601,'he','×¡×” ×› ×”×–×ž× ×•×ª ×¨×›×©',0),(561621,15601,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Î±Î³Î¿ÏÎ¬Ï‚',0),(561622,15601,'zh','é‡‡è´­è®¢å•æ€»é¢',0),(561623,15601,'sv','KÃ¶p order totalt',0),(561624,15601,'it','Totale di ordini di acquisto',0),(561625,15601,'tl','',0),(561626,15601,'th','à¸œà¸¥à¸£à¸§à¸¡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(561627,15601,'hi','à¤†à¤¦à¥‡à¤¶ à¤•à¥à¤² à¤–à¤°à¥€à¤¦',0),(561628,15601,'ms','Jumlah pesanan pembelian',0),(561629,15601,'ar','Ø¹Ø¯Ø¯ Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(561630,15601,'fr','Total des commandes d\'achat',0),(561631,15601,'jp','è³¼å…¥æ³¨æ–‡ã®åˆè¨ˆé¡',0),(561632,15601,'pt','Total de ordens de compra',0),(561633,15601,'ru','Ð’ÑÐµÐ³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð¾Ð² Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(561634,15601,'es','Total de Ã³rdenes de compra',0),(561635,15601,'de','Bestellungen Bestellwert',0),(561636,15601,'en','Purchase Orders Total',0),(561637,15602,'is','',0),(561638,15602,'dr','ØªØ¹ÛŒÛŒÙ† Ø´Ù…Ø§Ø±Ù‡ ØµÙ†Ø¯ÙˆÙ‚ Ø§Ø² Ø³ÙˆØ§Ù„ Ø¨Ø§ Ø´Ù†Ø§Ø³Ù‡',0),(561639,15602,'pr','ØªØ¹ÛŒÛŒÙ† Ø´Ù…Ø§Ø±Ù‡ ØµÙ†Ø¯ÙˆÙ‚ Ø§Ø² Ø³ÙˆØ§Ù„ Ø¨Ø§ Ø´Ù†Ø§Ø³Ù‡',0),(561640,15602,'tr','Soru kimlikli PO numarasÄ± ayarla',0),(561641,15602,'pl','Zestaw numer zamÃ³wienia z pytanie o identyfikatorze',0),(561642,15602,'bg','Ð—Ð°Ð´Ð°Ð¹Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¾Ñ‚ Ð²ÑŠÐ¿Ñ€Ð¾ÑÐ° Ñ Ð˜Ð”',0),(561643,15602,'ur','Ø´Ù†Ø§Ø®Øª Ú©Û’ Ø³Ø§ØªÚ¾ Ø³ÙˆØ§Ù„ Ø³Û’ Ù¾ÙˆØ³Ù¹ Ù†Ù…Ø¨Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(561644,15602,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ ÐÐ°Ñ€ÑƒÑŸÐ±ÐµÐ½Ð¸Ñ†Ðµ Ð¸Ð· Ð¿Ð¸Ñ‚Ð°ÑšÐµ ÑÐ° Ð˜Ð”-Ð¾Ð¼',0),(561645,15602,'vi','Thiáº¿t láº­p sá»‘ PO tá»« cÃ¡c cÃ¢u há»i vá»›i ID',0),(561646,15602,'af','Stel PO vraag met ID nommer',0),(561647,15602,'ro','SetaÅ£i numÄƒrul bonului de comandÄƒ la Ã®ntrebarea cu ID-ul',0),(561648,15602,'et','MÃ¤Ã¤ra PO Number kÃ¼simuse ID',0),(561649,15602,'si','Å tevilka NaroÄilnice iz vpraÅ¡anje z ID-jem',0),(561650,15602,'ba','Mengatur nomor PO dari pertanyaan dengan ID',0),(561651,15602,'nl','PO-nummer van de vraag met ID instellen',0),(561652,15602,'fi','Asettaa Ostosopimusnumeron kysymyksen tunnus',0),(561653,15602,'no','Angi innkjÃ¸psordrenummer fra spÃ¸rsmÃ¥let med ID',0),(561654,15602,'da','Indstille PO-nummer fra spÃ¸rgsmÃ¥l med ID',0),(561655,15602,'ko','Idê°€ ì§ˆë¬¸ì—ì„œ ì£¼ë¬¸ì„œ ë²ˆí˜¸ë¥¼ ì„¤ì •',0),(561656,15602,'he','×œ×”×’×“×™×¨ ××ª ×ž×¡×¤×¨ ×”-PO ×ž×Ÿ ×”×©××œ×” ×¢× ×ž×–×”×”',0),(561657,15602,'el','ÎŸÏÎ¯ÏƒÎµÏ„Îµ Î±ÏÎ¹Î¸Î¼ÏŒ PO Î±Ï€ÏŒ ÎµÏÏŽÏ„Î·ÏƒÎ· Î¼Îµ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ',0),(561658,15602,'zh','ä»Žé—®é¢˜ä¸Ž ID è®¾ç½®é‡‡è´­è®¢å•ç¼–å·',0),(561659,15602,'sv','Ange inkÃ¶psordernummer frÃ¥n frÃ¥ga med ID',0),(561660,15602,'it','Impostare numero PO da domanda con ID',0),(561661,15602,'tl','',0),(561662,15602,'th','à¸•à¸±à¹‰à¸‡à¹€à¸¥à¸‚ PO à¸ˆà¸²à¸à¸„à¸³à¸–à¸²à¸¡à¸à¸±à¸š ID',0),(561663,15602,'hi','PO à¤•à¥à¤°à¤®à¤¾à¤‚à¤• à¤¸à¥‡à¤Ÿ ID à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¸à¤µà¤¾à¤² à¤¸à¥‡',0),(561664,15602,'ms','Set PO nombor soalan dengan ID',0),(561665,15602,'ar','ØªØ¹ÙŠÙŠÙ† Ø±Ù‚Ù… Ø·Ù„Ø¨ Ø§Ù„Ø´Ø±Ø§Ø¡ Ù…Ù† Ø§Ù„Ø³Ø¤Ø§Ù„ Ù…Ø¹ Ù…Ø¹Ø±Ù',0),(561666,15602,'fr','DÃ©finir nombre de PO de Question avec ID',0),(561667,15602,'jp','ID ã®è³ªå•ã‹ã‚‰ PO ç•ªå·ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(561668,15602,'pt','Definir o nÃºmero de PO de pergunta com ID',0),(561669,15602,'ru','Ð—Ð°Ð´Ð°Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð·Ð°ÐºÐ°Ð·Ð° Ð¾Ñ‚ Ð²Ð¾Ð¿Ñ€Ð¾ÑÐ° Ñ ID',0),(561670,15602,'es','Ajustar nÃºmero de PO de pregunta con ID',0),(561671,15602,'de','Legen Sie Auftragsnummer aus Frage mit ID',0),(561672,15602,'en','Set PO Number From Question With ID',0),(561673,15603,'is','',0),(561674,15603,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¯Ú©Ù…Ù‡ Ù‡Ø§ÛŒ Ú©Ø§Ø±',0),(561675,15603,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø¯Ú©Ù…Ù‡ Ù‡Ø§ÛŒ Ú©Ø§Ø±',0),(561676,15603,'tr','Gizle iÅŸ dÃ¼ÄŸmeleri ekleme',0),(561677,15603,'pl','Ukryj dodaÄ‡ przyciski pracy',0),(561678,15603,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚Ðµ Ð±ÑƒÑ‚Ð¾Ð½Ð¸ Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(561679,15603,'ur','Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº Ù…Ù„Ø§Ø²Ù…Øª Ø¨Ù¹Ù†ÙˆÚº Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(561680,15603,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð”Ð¾Ð´Ð°Ñ˜ Ð¿Ð¾ÑÐ°Ð¾ Ð´ÑƒÐ³Ð¼Ð°Ð´',0),(561681,15603,'vi','áº¨n thÃªm viá»‡c nÃºt',0),(561682,15603,'af','Versteek voeg werk knope',0),(561683,15603,'ro','Ascunde adÄƒugaÅ£i butoane cu Job',0),(561684,15603,'et','Peida lisada tÃ¶Ã¶ nupud',0),(561685,15603,'si','Skrij dodate gumbe za delo',0),(561686,15603,'ba','Sembunyikan menambahkan tombol pekerjaan',0),(561687,15603,'nl','Verbergen baan knoppen toevoegen',0),(561688,15603,'fi','Piilota lisÃ¤Ã¤ tyÃ¶tÃ¤ painikkeita',0),(561689,15603,'no','Skjul Legg til jobb knapper',0),(561690,15603,'da','Skjul tilfÃ¸je Job knapper',0),(561691,15603,'ko','ìˆ¨ê¸°ê¸° ìž‘ì—… ë‹¨ì¶” ì¶”ê°€',0),(561692,15603,'he','×”×¡×ª×¨ ×œ×”×•×¡×™×£ ×œ×—×¦× ×™× ×”×¢×‘×•×“×”',0),(561693,15603,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Ï€ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎºÎ¿Ï…Î¼Ï€Î¹Î¬ Î´Î¿Ï…Î»ÎµÎ¹Î¬',0),(561694,15603,'zh','éšè—æ·»åŠ å·¥ä½œæŒ‰é’®',0),(561695,15603,'sv','DÃ¶lj lÃ¤gga jobb knappar',0),(561696,15603,'it','Nascondi aggiungere pulsanti di lavoro',0),(561697,15603,'tl','',0),(561698,15603,'th','à¸‹à¹ˆà¸­à¸™à¹€à¸žà¸´à¹ˆà¸¡à¸›à¸¸à¹ˆà¸¡à¸‡à¸²à¸™',0),(561699,15603,'hi','à¤›à¥à¤ªà¤¾à¤à¤ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚ à¤•à¤¾à¤°à¥à¤¯ à¤¬à¤Ÿà¤¨',0),(561700,15603,'ms','Sembunyi menambah butang kerja',0),(561701,15603,'ar','Ø¥Ø¶Ø§ÙØ© Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø£Ø²Ø±Ø§Ø± Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(561702,15603,'fr','Masquer ajouter des boutons de tÃ¢che',0),(561703,15603,'jp','ã‚¸ãƒ§ãƒ– ãƒœã‚¿ãƒ³ã‚’éžè¡¨ç¤ºã«è¿½åŠ ã—ã¾ã™ã€‚',0),(561704,15603,'pt','Ocultar adicionar botÃµes de emprego',0),(561705,15603,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ ÐºÐ½Ð¾Ð¿Ð¾Ðº',0),(561706,15603,'es','Ocultar agregar botones de trabajo',0),(561707,15603,'de','Ausblenden Job SchaltflÃ¤chen hinzufÃ¼gen',0),(561708,15603,'en','Hide Add Job Buttons',0),(561709,15604,'is','',0),(561710,15604,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² POS Ø¨Ø±Ø§ÛŒ ØªÙ…Ø§Ù… ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¬Ø¯ÛŒØ¯',0),(561711,15604,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² POS Ø¨Ø±Ø§ÛŒ ØªÙ…Ø§Ù… ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¬Ø¯ÛŒØ¯',0),(561712,15604,'tr','POS tÃ¼m yeni faturalarÄ± iÃ§in kullanmak',0),(561713,15604,'pl','UÅ¼yj POS dla wszystkich nowych faktur',0),(561714,15604,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ POS Ð·Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð½Ð¾Ð²Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(561715,15604,'ur','ØªÙ…Ø§Ù… Ù†Ø¦Û’ ÙˆØ¨Ø¬Ù„ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±ÛŒÚº',0),(561716,15604,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÐŸÐžÐ¡ Ð·Ð° ÑÐ²Ðµ Ð½Ð¾Ð²Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(561717,15604,'vi','Sá»­ dá»¥ng POS cho táº¥t cáº£ cÃ¡c hÃ³a Ä‘Æ¡n má»›i',0),(561718,15604,'af','POS vir alle nuwe fakture gebruik',0),(561719,15604,'ro','Utilizarea POS pentru toate facturile noi',0),(561720,15604,'et','Kasutada POS kÃµik uued arved',0),(561721,15604,'si','Za vse nove raÄune uporabiti POS',0),(561722,15604,'ba','Menggunakan POS untuk semua tagihan baru',0),(561723,15604,'nl','POS gebruiken voor alle nieuwe facturen',0),(561724,15604,'fi','KÃ¤yttÃ¤Ã¤ POS uusia laskuja',0),(561725,15604,'no','Bruke POS For alle nye fakturaer',0),(561726,15604,'da','Bruge POS For alle nye fakturaer',0),(561727,15604,'ko','POSë¥¼ ì‚¬ìš© í•˜ ì—¬ ëª¨ë“  ìƒˆ ì†¡ìž¥ì— ëŒ€ í•œ',0),(561728,15604,'he','×”×©×ª×ž×© POS ×¢×œ ×›×œ ×”×—×©×‘×•× ×™×•×ª ×”×—×“×©×”',0),(561729,15604,'el','Î§ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÏ„Îµ POS Î³Î¹Î± ÏŒÎ»Î± Ï„Î± Î½Î­Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(561730,15604,'zh','ä¸ºæ‰€æœ‰æ–°çš„å‘ç¥¨ä½¿ç”¨ POS',0),(561731,15604,'sv','AnvÃ¤nda POS fÃ¶r alla nya fakturor',0),(561732,15604,'it','Utilizzare il POS per tutte le nuove fatture',0),(561733,15604,'tl','',0),(561734,15604,'th','à¹ƒà¸Šà¹‰ POS à¹ƒà¸šà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(561735,15604,'hi','à¤¸à¤­à¥€ à¤¨à¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ POS à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(561736,15604,'ms','Menggunakan POS untuk semua invois baru',0),(561737,15604,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ Ù„ÙƒØ§ÙØ© ÙÙˆØ§ØªÙŠØ± Ø¬Ø¯ÙŠØ¯Ø©',0),(561738,15604,'fr','Utilisez le POS pour toutes les nouvelles factures',0),(561739,15604,'jp','ã™ã¹ã¦ã®æ–°ã—ã„è«‹æ±‚æ›¸ã® POS ã‚’ä½¿ç”¨ã—ã¾ã™ã€‚',0),(561740,15604,'pt','Usar o POS para todas as faturas de novas',0),(561741,15604,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ POS Ð´Ð»Ñ Ð²ÑÐµÑ… Ð½Ð¾Ð²Ñ‹Ñ… ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(561742,15604,'es','Uso de POS para todas las facturas nuevas',0),(561743,15604,'de','Verwenden Sie fÃ¼r alle neuen Rechnungen POS',0),(561744,15604,'en','Use POS For All New Invoices',0),(561745,15605,'is','',0),(561746,15605,'dr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø³Ø§Ø®Øª BOM Ù…Ø­Ø¯ÙˆØ¯ ØªÙˆØ³Ø· Ø§Ø¬Ø²Ø§ÛŒ',0),(561747,15605,'pr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø³Ø§Ø®Øª BOM Ù…Ø­Ø¯ÙˆØ¯ ØªÙˆØ³Ø· Ø§Ø¬Ø²Ø§ÛŒ',0),(561748,15605,'tr','Otomatik yapÄ± Ã¼rÃ¼n ReÃ§etesi bileÅŸenleri sÄ±nÄ±rlÄ±dÄ±r',0),(561749,15605,'pl','Auto budowaÄ‡ BOM ograniczone przez skÅ‚adniki',0),(561750,15605,'bg','ÐÐ²Ñ‚Ð¾ Ð‘Ð¸Ð»Ð´ ÐšÐ˜ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð¸ Ð¾Ñ‚ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð¸',0),(561751,15605,'ur','Ø®ÙˆØ¯ ØªØ¹Ù…ÛŒØ± Ú©Û’ Ø¨Ø§Ù… Ù„Ù…ÛŒÙ¹Úˆ Ú©Û’ Ø§Ø¬Ø²Ø§Ø¡',0),(561752,15605,'sr','ÐÑƒÑ‚Ð¾ Ð‘ÑƒÐ¸Ð»Ð´ Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ðµ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ðµ',0),(561753,15605,'vi','Tá»± Ä‘á»™ng xÃ¢y dá»±ng Há»™i Ä‘á»“ng quáº£n trá»‹ bá»‹ giá»›i háº¡n bá»Ÿi cÃ¡c thÃ nh pháº§n',0),(561754,15605,'af','Outomatiese bou gebore word beperk deur komponente',0),(561755,15605,'ro','Auto Build LM limitat de componente',0),(561756,15605,'et','Auto ehitada Koosluse Limited komponendid',0),(561757,15605,'si','Omejeno Auto graditi Kosovnice komponente',0),(561758,15605,'ba','Auto membangun BOM terbatas oleh komponen',0),(561759,15605,'nl','Auto Build BOM Limited door componenten',0),(561760,15605,'fi','Auto rakentaa Tuoterakenteen rajoitettu osat',0),(561761,15605,'no','Auto bygge Stykkliste begrenset av komponenter',0),(561762,15605,'da','Auto Byg Stykliste begrÃ¦nset af komponenter',0),(561763,15605,'ko','ìžë™ ë¹Œë“œ BOM êµ¬ì„± ìš”ì†Œì— ì˜í•´ ì œí•œ ë¨',0),(561764,15605,'he','××•×˜×•×ž×˜×™ ×œ×‘× ×•×ª BOM ×ž×•×’×‘×œ×ª ×¢×œ-×™×“×™ ×¨×›×™×‘×™',0),(561765,15605,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· BOM Build ÎŸÎ¦Î•Î™Î›Î•Î¤Î‘Î™ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(561766,15605,'zh','è‡ªåŠ¨ç”Ÿæˆç‰©æ–™æ¸…å•æœ‰é™å…¬å¸ç”±ç»„ä»¶',0),(561767,15605,'sv','Auto bygga BOM begrÃ¤nsas av komponenter',0),(561768,15605,'it','Auto Build BOM limitata dai componenti',0),(561769,15605,'tl','',0),(561770,15605,'th','à¸ˆà¸³à¸à¸±à¸” BOM à¸ªà¸£à¹‰à¸²à¸‡à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´ à¹‚à¸”à¸¢à¸„à¸­à¸¡à¹‚à¸žà¹€à¸™à¸™à¸•à¹Œ',0),(561771,15605,'hi','à¤‘à¤Ÿà¥‹ à¤¬à¤¿à¤²à¥à¤¡ BOM à¤˜à¤Ÿà¤•à¥‹à¤‚ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥€à¤®à¤¿à¤¤',0),(561772,15605,'ms','Auto membina BOM terhad mengikut komponen',0),(561773,15605,'ar','Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª Ø¨Ù†Ø§Ø¡ Ø´Ø¬Ø±Ø© Ø§Ù„Ù…ÙˆØ§Ø¯ Ù…Ø­Ø¯ÙˆØ¯Ø© Ø­Ø³Ø¨ Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(561774,15605,'fr','Auto construction BOM Limited par composants',0),(561775,15605,'jp','ã‚³ãƒ³ãƒãƒ¼ãƒãƒ³ãƒˆã«ã‚ˆã£ã¦è‡ªå‹•ãƒ“ãƒ«ãƒ‰ BOM é™å®š',0),(561776,15605,'pt','Auto construir BOM limitada pelos componentes',0),(561777,15605,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¿Ð¾ÑÑ‚Ñ€Ð¾ÐµÐ½Ð¸Ðµ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸ Ð¾Ð³Ñ€Ð°Ð½Ð¸Ñ‡ÐµÐ½Ð½Ð¾Ð¹ ÐºÐ¾Ð¼Ð¿Ð¾Ð½ÐµÐ½Ñ‚Ð°Ð¼Ð¸',0),(561778,15605,'es','Auto construcciÃ³n BOM limitada por los componentes',0),(561779,15605,'de','Auto bauen StÃ¼ckliste Limited von Komponenten',0),(561780,15605,'en','Auto Build BOM Limited By Components',0),(561781,15606,'is','',0),(561782,15606,'dr','Ø±ÙˆØ´Ù† Ø³Ø§Ø¹Øª Ø¨ÛŒÙ…Ø§Ø± Ù‡Ø± Ø³Ø§Ù„',0),(561783,15606,'pr','Ø±ÙˆØ´Ù† Ø³Ø§Ø¹Øª Ø¨ÛŒÙ…Ø§Ø± Ù‡Ø± Ø³Ø§Ù„',0),(561784,15606,'tr','Hasta saat temizlemek her yÄ±l',0),(561785,15606,'pl','Jasne, chory godzin rocznie',0),(561786,15606,'bg','Ð˜Ð·Ñ‡Ð¸ÑÑ‚Ð¸ Ð±Ð¾Ð»Ð½Ð¸ Ñ‡Ð°ÑÐ° Ð²ÑÑÐºÐ° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(561787,15606,'ur','Ø¨ÛŒÙ…Ø§Ø± Ú¯Ú¾Ù†Ù¹Û’ ØµØ§Ù Ú©Ø±ÛŒÚº ÛØ± Ø³Ø§Ù„',0),(561788,15606,'sr','ÐžÐ±Ñ€Ð¸ÑˆÐ¸ Ð±Ð¾Ð»ÐµÑÑ‚Ð°Ð½ ÑÐ°Ñ‚Ð¸ ÑÐ²Ð°ÐºÐµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(561789,15606,'vi','RÃµ rÃ ng bá»‡nh giá» má»—i nÄƒm',0),(561790,15606,'af','Skoon siek ure elke jaar',0),(561791,15606,'ro','Clar bolnav de ore Ã®n fiecare an',0),(561792,15606,'et','TÃ¼hjendage haige tundi aastas',0),(561793,15606,'si','Jasno, bolan ur letno',0),(561794,15606,'ba','Jelas jam sakit setiap tahun',0),(561795,15606,'nl','Duidelijk ziek uur per jaar',0),(561796,15606,'fi','Poista sairas tuntia vuosittain',0),(561797,15606,'no','Fjern syk timer hvert Ã¥r',0),(561798,15606,'da','Ryd syg timer Ã¥rligt',0),(561799,15606,'ko','ì•„í”ˆ ì‹œê°„ ì·¨ì†Œ ë§¤ë…„',0),(561800,15606,'he','× ×§×” ×—×•×œ×” ×©×¢×•×ª ×‘×›×œ ×©× ×”',0),(561801,15606,'el','ÎšÎ±Ï„Î±ÏÎ³Î®ÏƒÏ„Îµ Î¬ÏÏÏ‰ÏƒÏ„Î¿Ï‚ ÏŽÏÎµÏ‚ ÎµÏ„Î·ÏƒÎ¯Ï‰Ï‚',0),(561802,15606,'zh','æ¸…é™¤ç—…å°æ—¶æ¯å¹´',0),(561803,15606,'sv','Rensa sjukt timmar varje Ã¥r',0),(561804,15606,'it','Deselezionare malati ore ogni anno',0),(561805,15606,'tl','',0),(561806,15606,'th','à¸¥à¹‰à¸²à¸‡à¹€à¸§à¸¥à¸²à¸›à¹ˆà¸§à¸¢à¸—à¸¸à¸à¸›à¸µ',0),(561807,15606,'hi','à¤¬à¥€à¤®à¤¾à¤° à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¤¾à¤«à¤¼ à¤•à¤°à¥‡à¤‚ à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤µà¤°à¥à¤·',0),(561808,15606,'ms','Jelas jam sakit setiap tahun',0),(561809,15606,'ar','Ù…Ø³Ø­ Ø§Ù„Ù…Ø±Ø¶Ù‰ Ø³Ø§Ø¹Ø§Øª ÙƒÙ„ Ø³Ù†Ø©',0),(561810,15606,'fr','Effacer les heures malades chaque annÃ©e',0),(561811,15606,'jp','ç—…æ°—ã®æ™‚é–“ã‚’ã‚ªãƒ•ã«æ¯Žå¹´',0),(561812,15606,'pt','Limpar o doentes horas cada ano',0),(561813,15606,'ru','ÐžÑ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ Ð±Ð¾Ð»ÑŒÐ½Ñ‹Ð¼Ð¸ Ñ‡Ð°ÑÐ¾Ð² ÐºÐ°Ð¶Ð´Ñ‹Ð¹ Ð³Ð¾Ð´',0),(561814,15606,'es','Claro horas enfermos cada aÃ±o',0),(561815,15606,'de','Deaktivieren Sie kranke Stunden pro Jahr',0),(561816,15606,'en','Clear Sick Hours Each Year',0),(561817,15607,'is','',0),(561818,15607,'dr','Ø³Ø§Ø¹Øª ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø±ÙˆØ´Ù† Ù‡Ø± Ø³Ø§Ù„',0),(561819,15607,'pr','Ø³Ø§Ø¹Øª ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø±ÙˆØ´Ù† Ù‡Ø± Ø³Ø§Ù„',0),(561820,15607,'tr','Tatil saatleri temizlemek her yÄ±l',0),(561821,15607,'pl','Jasne, urlopy kaÅ¼dego roku',0),(561822,15607,'bg','Ð¯ÑÐµÐ½ Ð²Ð°ÐºÐ°Ð½Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ñ‡Ð°ÑÐ° Ð²ÑÑÐºÐ° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(561823,15607,'ur','Ú†Ú¾Ù¹ÛŒ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª Ù…ÛŒÚº ØµØ§Ù Ú©Ø±ÛŒÚº ÛØ± Ø³Ø§Ù„',0),(561824,15607,'sr','ÐžÐ±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð´Ð¼Ð¾Ñ€ ÑÐ°Ñ‚Ð¸ ÑÐ²Ð°ÐºÐµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(561825,15607,'vi','RÃµ rÃ ng Vacation giá» má»—i nÄƒm',0),(561826,15607,'af','Vakansie-ure duidelik elke jaar',0),(561827,15607,'ro','Clar vacanta ore Ã®n fiecare an',0),(561828,15607,'et','TÃ¼hjendage Puhkusetunde igal aastal',0),(561829,15607,'si','PoÄistite poÄitnice ur letno',0),(561830,15607,'ba','Jelas liburan jam setiap tahun',0),(561831,15607,'nl','Wissen van vakantie-uren per jaar',0),(561832,15607,'fi','Poista loma vuosittain',0),(561833,15607,'no','Fjern ferietimer hvert Ã¥r',0),(561834,15607,'da','Ryd ferietimer hvert Ã¥r',0),(561835,15607,'ko','íœ´ê°€ ì‹œê°„ ì·¨ì†Œ ë§¤ë…„',0),(561836,15607,'he','× ×§×” ×©×¢×•×ª ×—×•×¤×©×” ×›×œ ×©× ×”',0),(561837,15607,'el','ÎšÎ±Ï„Î±ÏÎ³Î®ÏƒÏ„Îµ Î´Î¹Î±ÎºÎ¿Ï€Î­Ï‚ ÏŽÏÎµÏ‚ ÎµÏ„Î·ÏƒÎ¯Ï‰Ï‚',0),(561838,15607,'zh','æ¸…é™¤äº†ä¼‘å‡å°æ—¶æ•°æ¯å¹´',0),(561839,15607,'sv','Rensa semester timmar varje Ã¥r',0),(561840,15607,'it','Deselezionare le ore di ferie ogni anno',0),(561841,15607,'tl','',0),(561842,15607,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¸§à¸±à¸™à¸«à¸¢à¸¸à¸”à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¹ƒà¸™à¹à¸•à¹ˆà¸¥à¸°à¸›à¸µ',0),(561843,15607,'hi','à¤›à¥à¤Ÿà¥à¤Ÿà¥€ à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¤¾à¤«à¤¼ à¤•à¤°à¥‡à¤‚ à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤µà¤°à¥à¤·',0),(561844,15607,'ms','Jelas waktu percutian setiap tahun',0),(561845,15607,'ar','Ø¥Ù„ØºØ§Ø¡ Ø¹Ø·Ù„Ø© Ø³Ø§Ø¹Ø§Øª ÙƒÙ„ Ø³Ù†Ø©',0),(561846,15607,'fr','Effacer les heures de vacances chaque annÃ©e',0),(561847,15607,'jp','ä¼‘æš‡ã®æ™‚é–“ã‚’ã‚ªãƒ•ã«æ¯Žå¹´',0),(561848,15607,'pt','Limpar as horas de fÃ©rias por ano',0),(561849,15607,'ru','Ð¡Ð½Ð¸Ð¼Ð¸Ñ‚Ðµ Ñ‡Ð°ÑÑ‹ Ð¾Ñ‚Ð¿ÑƒÑÐºÐ° ÐºÐ°Ð¶Ð´Ñ‹Ð¹ Ð³Ð¾Ð´',0),(561850,15607,'es','Eliminar horas de vacaciones cada aÃ±o',0),(561851,15607,'de','Deaktivieren Sie Urlaubsstunden pro Jahr',0),(561852,15607,'en','Clear Vacation Hours Each Year',0),(561853,15608,'is','',0),(561854,15608,'dr','Ù…Ø§Ù‡ Ú¯Ø°Ø´ØªÙ‡ Ø¨Ù‡ Ø¯Ø³Øª Ø¢ÙˆØ±Ø¯Ù‡ Ø¯Ø± Ø­ÙØ¸',0),(561855,15608,'pr','Ù…Ø§Ù‡ Ú¯Ø°Ø´ØªÙ‡ Ø¨Ù‡ Ø¯Ø³Øª Ø¢ÙˆØ±Ø¯Ù‡ Ø¯Ø± Ø­ÙØ¸',0),(561856,15608,'tr','GeÃ§en ay iÃ§inde kazanÄ±lan korumak',0),(561857,15608,'pl','ZachowaÄ‡ zarobione w zeszÅ‚ym miesiÄ…cu',0),(561858,15608,'bg','Ð—Ð°Ð¿Ð°Ð·Ð²Ð° ÑÐ¿ÐµÑ‡ÐµÐ»ÐµÐ½Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐ· Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ Ð¼ÐµÑÐµÑ†',0),(561859,15608,'ur','Ú©Ù…Ø§Ø¦ÛŒ Ù…ÛŒÚº Ú¯Ø²Ø´ØªÛ Ù…Ø§Û Ø¨Ø±Ù‚Ø±Ø§Ø± Ø±Ú©Ú¾Ù†Û’',0),(561860,15608,'sr','Ð—Ð°Ð´Ñ€Ð¶Ð¸ Ð·Ð°Ñ€Ð°Ñ’ÐµÐ½Ðµ Ñƒ Ð¿Ñ€Ð¾ÑˆÐ»Ð¾Ð³ Ð¼ÐµÑÐµÑ†Ð°',0),(561861,15608,'vi','Giá»¯ láº¡i kiáº¿m Ä‘Æ°á»£c trong thÃ¡ng trÆ°á»›c',0),(561862,15608,'af','Behou verdien In die laaste maand',0),(561863,15608,'ro','ReÅ£ine cÃ¢ÅŸtigat Ã®n ultima lunÄƒ',0),(561864,15608,'et','Aastal teenitud eelmisel kuul sÃ¤ilitada',0),(561865,15608,'si','Ohraniti zasluÅ¾eni v zadnjem mesecu',0),(561866,15608,'ba','Mempertahankan diterima di bulan',0),(561867,15608,'nl','Behouden verdiende In vorige maand',0),(561868,15608,'fi','SÃ¤ilyttÃ¤Ã¤ ansaittu tÃ¤ssÃ¤ viime kuussa',0),(561869,15608,'no','Beholde opptjent i forrige mÃ¥ned',0),(561870,15608,'da','Bevare tjente i sidste mÃ¥ned',0),(561871,15608,'ko','ì§€ë‚œ ë‹¬ì— ì ë¦½ëœì„ ìœ ì§€í•©ë‹ˆë‹¤',0),(561872,15608,'he','×©×•×ž×¨×™× ×¢×œ ×©× ×¦×‘×¨×• ×‘×—×•×“×© ×©×¢×‘×¨',0),(561873,15608,'el','Î”Î¹Î±Ï„Î·ÏÎ¿ÏÎ½ ÎºÎµÏÎ´Î¯Î¶Ï‰ ÏƒÏ„Î¿Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ Î¼Î®Î½Î±',0),(561874,15608,'zh','ä¿ç•™åœ¨æŒ£ä¸Šä¸ªæœˆ',0),(561875,15608,'sv','BehÃ¥lla intjÃ¤nade i fÃ¶rra mÃ¥naden',0),(561876,15608,'it','Mantenere guadagnati nel mese scorso',0),(561877,15608,'tl','',0),(561878,15608,'th','à¹€à¸à¹‡à¸šà¹„à¸”à¹‰à¹ƒà¸™à¹€à¸”à¸·à¸­à¸™',0),(561879,15608,'hi','à¤®à¥‡à¤‚ à¤…à¤°à¥à¤œà¤¿à¤¤ à¤ªà¤¿à¤›à¤²à¥‡ à¤®à¤¹à¥€à¤¨à¥‡ à¤¬à¤¨à¤¾à¤ à¤°à¤–à¤¨à¥‡',0),(561880,15608,'ms','Mengekalkan bulan lepas yang diperolehi dalam',0),(561881,15608,'ar','Ø§Ù„Ø§Ø­ØªÙØ§Ø¸ Ø¨Ø§Ù„Ù…ÙƒØªØ³Ø¨ ÙÙŠ Ø§Ù„Ø´Ù‡Ø± Ø§Ù„Ù…Ø§Ø¶ÙŠ',0),(561882,15608,'fr','Conserver le mois dernier gagnÃ© dans',0),(561883,15608,'jp','å…ˆæœˆã®ç²å¾—ã‚’ä¿æŒã—ã¾ã™ã€‚',0),(561884,15608,'pt','Manter o ganho no mÃªs passado',0),(561885,15608,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð°Ð½Ð½Ñ‹Ðµ Ð² Ð¿Ñ€Ð¾ÑˆÐ»Ð¾Ð¼ Ð¼ÐµÑÑÑ†Ðµ',0),(561886,15608,'es','Retener el ganado en el mes pasado',0),(561887,15608,'de','Behalten Sie verdienten im vergangenen Monat',0),(561888,15608,'en','Retain Earned In Last Month',0),(561889,15609,'is','',0),(561890,15609,'dr','Ø¨ÛŒÙ…Ø§Ø± & ØªØ¹Ø¯Ø§Ø¯ ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø³Ø§Ù„ Ø¢ØºØ§Ø² Ù…ÛŒ Ø´ÙˆØ¯',0),(561891,15609,'pr','Ø¨ÛŒÙ…Ø§Ø± & ØªØ¹Ø¯Ø§Ø¯ ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø³Ø§Ù„ Ø¢ØºØ§Ø² Ù…ÛŒ Ø´ÙˆØ¯',0),(561892,15609,'tr','Hasta ve tatil sayÄ±sÄ± yÄ±l baÅŸlar',0),(561893,15609,'pl','Chory idealna liczba wakacje roku rozpoczyna siÄ™',0),(561894,15609,'bg','Ð‘Ð¾Ð»Ð½Ð¸ & Ð²Ð°ÐºÐ°Ð½Ñ†Ð¸Ñ Ð³Ñ€Ð°Ñ„ Ð³Ð¾Ð´Ð¸Ð½Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð°',0),(561895,15609,'ur','Ø¨ÛŒÙ…Ø§Ø± & Ú†Ú¾Ù¹ÛŒ Ú©Ø§ Ø´Ù…Ø§Ø± Ø³Ø§Ù„ Ú©Ø§ Ø¢ØºØ§Ø² ÛÙˆØªØ§ ÛÛ’',0),(561896,15609,'sr','Ð‘Ð¾Ð»ÐµÑÐ½Ð° & Ð¾Ð´Ð¼Ð¾Ñ€ Ð³Ñ€Ð¾Ñ„ Ð³Ð¾Ð´Ð¸Ð½Ð° Ð¿Ð¾Ñ‡Ð¸ÑšÐµ',0),(561897,15609,'vi','Bá»‡nh & Vacation Ä‘áº¿m nÄƒm báº¯t Ä‘áº§u',0),(561898,15609,'af','Siek & vakansie telling jaar begin',0),(561899,15609,'ro','Bolnav & vacanta Contele an Ã®ncepe',0),(561900,15609,'et','Haige & puhkus arv aasta algust',0),(561901,15609,'si','Bolan & leto poÄitnice Å¡tetje se zaÄne',0),(561902,15609,'ba','Sakit & Count liburan tahun dimulai',0),(561903,15609,'nl','Zieke & vakantie graaf jaar begint',0),(561904,15609,'fi','Sairas & loma mÃ¤Ã¤rÃ¤ alkua',0),(561905,15609,'no','Syk & ferie antall Ã¥r begynner',0),(561906,15609,'da','Syg & ferie tÃ¦lle Ã¥r begynder',0),(561907,15609,'ko','ì•„í”ˆ & íœ´ê°€ ìˆ˜ ë…„ ì‹œìž‘',0),(561908,15609,'he','×—×•×œ×” & ×©× ×ª ×—×•×¤×©×” ×”×¡×¤×™×¨×” ×ž×ª×—×™×œ×”',0),(561909,15609,'el','Î†ÏÏÏ‰ÏƒÏ„Î¿ & Î­Ï„Î¿Ï‚ Î´Î¹Î±ÎºÎ¿Ï€Î­Ï‚ ÎºÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ· Î¾ÎµÎºÎ¹Î½Î¬',0),(561910,15609,'zh','ç”Ÿç—… & åº¦å‡è®¡æ•°å¼€å­¦',0),(561911,15609,'sv','Sjuk & semester antal Ã¥r bÃ¶rjar',0),(561912,15609,'it','Malato & vacanze totali anno inizia',0),(561913,15609,'tl','',0),(561914,15609,'th','à¸›à¹ˆà¸§à¸¢ à¹à¸¥à¸°à¸›à¸µà¸™à¸±à¸šà¸§à¸±à¸™à¸«à¸¢à¸¸à¸”à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(561915,15609,'hi','à¤¬à¥€à¤®à¤¾à¤° & à¤…à¤µà¤•à¤¾à¤¶ à¤—à¤£à¤¨à¤¾ à¤µà¤°à¥à¤· à¤¶à¥à¤°à¥‚ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ',0),(561916,15609,'ms','Sakit & percutian kiraan tahun bermula',0),(561917,15609,'ar','Ø§Ù„Ù…Ø±Ø¶Ù‰ & ÙŠØ¨Ø¯Ø£ Ø§Ù„Ø¹Ø¯ Ø¹Ø·Ù„Ø© Ø§Ù„Ø³Ù†Ø©',0),(561918,15609,'fr','Malade & vacances comte annÃ©e commence',0),(561919,15609,'jp','ç—…æ°—ä¼‘æš‡æ•°å¹´ã®é–‹å§‹ãƒ»',0),(561920,15609,'pt','Doente & contagem de fÃ©rias ano comeÃ§a',0),(561921,15609,'ru','Ð‘Ð¾Ð»ÑŒÐ½Ñ‹Ðµ & Ð½Ð°Ñ‡Ð¸Ð½Ð°ÐµÑ‚ÑÑ Ð³Ð¾Ð´ Ð¾Ñ‚Ð´Ñ‹Ñ… Ð¤Ð¾Ñ‚Ð¾',0),(561922,15609,'es','Enfermo y la cuenta de vacaciones aÃ±o comienza',0),(561923,15609,'de','Krank & Urlaub Count-Jahr beginnt',0),(561924,15609,'en','Sick & Vacation Count Year Begins',0),(561925,15610,'is','',0),(561926,15610,'dr','ØªØ¹Ø·ÛŒÙ„Ø§Øª & Ù…Ø²Ø§ÛŒØ§ÛŒ Ù…Ø±Ø®ØµÛŒ Ø§Ø³ØªØ¹Ù„Ø§Ø¬ÛŒ',0),(561927,15610,'pr','ØªØ¹Ø·ÛŒÙ„Ø§Øª & Ù…Ø²Ø§ÛŒØ§ÛŒ Ù…Ø±Ø®ØµÛŒ Ø§Ø³ØªØ¹Ù„Ø§Ø¬ÛŒ',0),(561928,15610,'tr','Tatil ve hastalÄ±k izni faydalarÄ±',0),(561929,15610,'pl','Wakacje idealna Å›wiadczenia chorobowe',0),(561930,15610,'bg','Ð’Ð°ÐºÐ°Ð½Ñ†Ð¸Ð¾Ð½ÐµÐ½ & Ð¾Ñ‚Ð¿ÑƒÑÐº Ð¾Ð±ÐµÐ·Ñ‰ÐµÑ‚ÐµÐ½Ð¸Ñ',0),(561931,15610,'ur','Ú†Ú¾Ù¹ÛŒ & Ø¨ÛŒÙ…Ø§Ø± ÙÙˆØ§Ø¦Ø¯ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº Û”',0),(561932,15610,'sr','ÐžÐ´Ð¼Ð¾Ñ€ Ð¸ Ð±Ð¾Ð»Ð¾Ð²Ð°ÑšÐµ Ð±ÐµÐ½ÐµÑ„Ð¸Ñ†Ð¸Ñ˜Ðµ',0),(561933,15610,'vi','Vacation & á»‘m lá»£i Ã­ch',0),(561934,15610,'af','Vakansie & siekteverlof voordele',0),(561935,15610,'ro','Vacanta & concediu medical beneficii',0),(561936,15610,'et','Puhkus- & haiguspuhkuse hÃ¼vitise',0),(561937,15610,'si','PoÄitnice & bolniÅ¡ki dopust koristi',0),(561938,15610,'ba','Liburan & cuti manfaat',0),(561939,15610,'nl','Vakantie & ziekteverlof voordelen',0),(561940,15610,'fi','Loma & Sairausloma edut',0),(561941,15610,'no','Ferie & sykefravÃ¦r fordeler',0),(561942,15610,'da','Ferie & sygeorlov fordele',0),(561943,15610,'ko','íœ´ê°€ ë° ë³‘ê°€ í˜œíƒ',0),(561944,15610,'he','× ×•×¤×© & ×ž×—×œ×” ×”×˜×‘×•×ª',0),(561945,15610,'el','Î”Î¹Î±ÎºÎ¿Ï€Î­Ï‚ & Î¿Ï†Î­Î»Î· Î±Î½Î±ÏÏÏ‰Ï„Î¹ÎºÎ® Î¬Î´ÎµÎ¹Î±',0),(561946,15610,'zh','å‡æœŸå’Œç—…å‡æ´¥è´´',0),(561947,15610,'sv','Semester & sjukfrÃ¥nvaro fÃ¶rdelar',0),(561948,15610,'it','Vacanze & benefici di congedo per malattia',0),(561949,15610,'tl','',0),(561950,15610,'th','à¸§à¸±à¸™à¸«à¸¢à¸¸à¸”à¹à¸¥à¸°à¸›à¸£à¸°à¹‚à¸¢à¸Šà¸™à¹Œà¸¥à¸²à¸›à¹ˆà¸§à¸¢',0),(561951,15610,'hi','à¤›à¥à¤Ÿà¥à¤Ÿà¥€ & à¤¬à¥€à¤®à¤¾à¤° à¤›à¥‹à¤¡à¤¼ à¤²à¤¾à¤­',0),(561952,15610,'ms','Percutian & manfaat cuti sakit',0),(561953,15610,'ar','Ø¹Ø·Ù„Ø© & Ø§Ø³ØªØ­Ù‚Ø§Ù‚Ø§Øª Ø§Ù„Ø¥Ø¬Ø§Ø²Ø© Ø§Ù„Ù…Ø±Ø¶ÙŠØ©',0),(561954,15610,'fr','Vacances & indemnitÃ© de congÃ©',0),(561955,15610,'jp','ä¼‘æš‡ãƒ»ç—…æ°—ä¼‘æš‡ã®åˆ©ç‚¹',0),(561956,15610,'pt','FÃ©rias e licenÃ§a benefÃ­cios',0),(561957,15610,'ru','ÐžÑ‚Ð´Ñ‹Ñ… & Ð±Ð¾Ð»ÐµÐ·Ð½Ð¸ Ð¿Ñ€ÐµÐ¸Ð¼ÑƒÑ‰ÐµÑÑ‚Ð²Ð°',0),(561958,15610,'es','Vacaciones y licencia por enfermedad beneficios',0),(561959,15610,'de','Urlaub & Krankheitstage Vorteile',0),(561960,15610,'en','Vacation & Sick Leave Benefits',0),(561961,15611,'is','',0),(561962,15611,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù†Ø§Ù… Ú†Ú©',0),(561963,15611,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù†Ø§Ù… Ú†Ú©',0),(561964,15611,'tr','AdÄ±na Ã‡ekler iÃ§in Ã¶deme',0),(561965,15611,'pl','OpÅ‚aca siÄ™ nazwa dla kontroli',0),(561966,15611,'bg','Ð—Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð° Ð¸Ð¼Ðµ Ð·Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸Ñ‚Ðµ',0),(561967,15611,'ur','Ù†Ø§Ù… Ù¾Ú‘ØªØ§Ù„ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø¯Ø§',0),(561968,15611,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð° Ð¸Ð¼Ðµ Ð·Ð° Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(561969,15611,'vi','Tráº£ tiá»n Ä‘á»ƒ Ä‘áº·t tÃªn cho kiá»ƒm tra',0),(561970,15611,'af','Betaal om naam vir kontrole',0),(561971,15611,'ro','PlÄƒteascÄƒ nume pentru controalele',0),(561972,15611,'et','Maksma kontrolli nime',0),(561973,15611,'si','PlaÄilo za ime za preglede',0),(561974,15611,'ba','Membayar untuk nama untuk cek',0),(561975,15611,'nl','Betalen aan naam voor controles',0),(561976,15611,'fi','Maksettava nimi tarkastuksia',0),(561977,15611,'no','Betale navn For sjekker',0),(561978,15611,'da','Betale til navn til kontrol',0),(561979,15611,'ko','ì´ë¦„ í™•ì¸ì— ëŒ€ í•œ ì§€ë¶ˆ',0),(561980,15611,'he','×œ×©×œ× ×©× ×¢×‘×•×¨ ×‘×“×™×§×•×ª',0),(561981,15611,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ ÏƒÏ„Î¿ ÏŒÎ½Î¿Î¼Î± Î³Î¹Î± Ï„Î¿Ï…Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï…Ï‚',0),(561982,15611,'zh','æ”¶æ¬¾äººåç§°æ£€æŸ¥',0),(561983,15611,'sv','Betala till namn fÃ¶r kontroller',0),(561984,15611,'it','Pagare per nome per i controlli',0),(561985,15611,'tl','',0),(561986,15611,'th','à¸Šà¸·à¹ˆà¸­à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(561987,15611,'hi','à¤œà¤¾à¤à¤š à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¾à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(561988,15611,'ms','Membayar kepada nama untuk pemeriksaan',0),(561989,15611,'ar','Ø¯ÙØ¹ Ø¥Ù„Ù‰ Ø§Ø³Ù… Ù„Ù„Ø´ÙŠÙƒØ§Øª',0),(561990,15611,'fr','Payer Ã  nom de contrÃ´les',0),(561991,15611,'jp','æ”¯æ‰•ã„å…ˆã®åå‰ãƒã‚§ãƒƒã‚¯',0),(561992,15611,'pt','Pagar ao nome para verificaÃ§Ãµes',0),(561993,15611,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð¸Ð¼Ñ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(561994,15611,'es','Pagar a nombre de cheques',0),(561995,15611,'de','Zahlen Sie, um Namen fÃ¼r PrÃ¼fungen',0),(561996,15611,'en','Pay To Name For Checks',0),(561997,15612,'is','',0),(561998,15612,'dr','Ø§Ú¯Ø± Ù…ØªÙØ§ÙˆØª Ø§Ø² Ø¨Ø§Ù„Ø§',0),(561999,15612,'pr','Ø§Ú¯Ø± Ù…ØªÙØ§ÙˆØª Ø§Ø² Ø¨Ø§Ù„Ø§',0),(562000,15612,'tr','YukarÄ±dan farklÄ± olmasÄ± durumunda',0),(562001,15612,'pl','JeÅ¼eli inne niÅ¼ powyÅ¼ej',0),(562002,15612,'bg','ÐÐºÐ¾ Ðµ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð¾ Ð¾Ñ‚ Ð³Ð¾Ñ€Ðµ',0),(562003,15612,'ur','Ø§Ú¯Ø± Ø§ÙˆÙ¾Ø± Ø³Û’ Ù…Ø®ØªÙ„Ù ÛÙˆ',0),(562004,15612,'sr','ÐÐºÐ¾ ÑÐµ Ñ€Ð°Ð·Ð»Ð¸ÐºÑƒÑ˜Ðµ Ð¾Ð´ Ð³Ð¾Ñ€Ðµ',0),(562005,15612,'vi','Náº¿u khÃ¡c nhau tá»« trÃªn cao',0),(562006,15612,'af','As ander van bo',0),(562007,15612,'ro','DacÄƒ este diferitÄƒ de mai sus',0),(562008,15612,'et','Kui erinevad Ã¼levalpool',0),(562009,15612,'si','ÄŒe se razlikuje od zgoraj',0),(562010,15612,'ba','Jika berbeda dari atas',0),(562011,15612,'nl','Indien verschillend van bovenaf',0),(562012,15612,'fi','TarjouspyyntÃ¶',0),(562013,15612,'no','Hvis annerledes ovenfra',0),(562014,15612,'da','Hvis forskellig fra oven',0),(562015,15612,'ko','ìœ„ì—ì„œ ë‹¤ë¥¸ ê²½ìš°',0),(562016,15612,'he','×× ×–×” ×©×•× ×” ×ž×œ×ž×¢×œ×”',0),(562017,15612,'el','Î‘Î½ Î´Î¹Î±Ï†Î­ÏÎµÎ¹ Î±Ï€ÏŒ ÏˆÎ·Î»Î¬',0),(562018,15612,'zh','å¦‚æžœä»Žä¸Šè¿°ä¸åŒ',0),(562019,15612,'sv','Om annan Ã¤n ovan',0),(562020,15612,'it','Se diverso da sopra',0),(562021,15612,'tl','',0),(562022,15612,'th','à¸–à¹‰à¸²à¹à¸•à¸à¸•à¹ˆà¸²à¸‡à¸ˆà¸²à¸à¸‚à¹‰à¸²à¸‡à¸•à¹‰à¸™',0),(562023,15612,'hi','à¤…à¤—à¤° à¤Šà¤ªà¤° à¤¸à¥‡ à¤…à¤²à¤—',0),(562024,15612,'ms','Jika lain dari atas',0),(562025,15612,'ar','Ø¥Ø°Ø§ ÙƒØ§Ù† Ù…Ø®ØªÙ„ÙØ§Ù‹ Ø¹Ù† Ø§Ù„Ø¹Ù†ÙˆØ§Ù† Ø£Ø¹Ù„Ø§Ù‡',0),(562026,15612,'fr','Si diffÃ©rente de ci-dessus',0),(562027,15612,'jp','ä¸Šè¨˜ã¨ç•°ãªã‚‹å ´åˆ',0),(562028,15612,'pt','Se for diferente de cima',0),(562029,15612,'ru','Ð•ÑÐ»Ð¸ Ð¾Ñ‚Ð»Ð¸Ñ‡Ð°ÐµÑ‚ÑÑ Ð¾Ñ‚ ÑƒÐºÐ°Ð·Ð°Ð½Ð½Ð¾Ð³Ð¾ Ð²Ñ‹ÑˆÐµ',0),(562030,15612,'es','Si es diferente de arriba',0),(562031,15612,'de','Falls von oben abweichend',0),(562032,15612,'en','If Different From Above',0),(562033,15613,'is','',0),(562034,15613,'dr','Ø¨Ù„ÙˆÚ© ØªØ¹Ù‡Ø¯ÛŒ Ø¨ÛŒÙ…Ø§Ø±',0),(562035,15613,'pr','Ø¨Ù„ÙˆÚ© ØªØ¹Ù‡Ø¯ÛŒ Ø¨ÛŒÙ…Ø§Ø±',0),(562036,15613,'tr','Blok hasta tahakkuk',0),(562037,15613,'pl','Bloku chory naliczania',0),(562038,15613,'bg','Ð‘Ð»Ð¾Ðº Ð±Ð¾Ð»Ð½Ð¸ Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ',0),(562039,15613,'ur','Ø¨Ù„Ø§Ú© Ø¨ÛŒÙ…Ø§Ø± Ø§Ú©Ú©Ø±ÙˆØ§Ù„',0),(562040,15613,'sr','Ð‘Ð¾Ð»ÐµÑÐ½Ð° Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°ÑšÐ° Ð±Ð»Ð¾Ðº',0),(562041,15613,'vi','Khá»‘i bá»‡nh Accrual',0),(562042,15613,'af','Blok siek aanwas',0),(562043,15613,'ro','Bloc bolnav angajamente',0),(562044,15613,'et','Block haige tekkepÃµhise',0),(562045,15613,'si','Blok bolan raÄunovodstva',0),(562046,15613,'ba','Blok sakit akrual',0),(562047,15613,'nl','Blok ziek kostentoename',0),(562048,15613,'fi','Block sairas jaksotus',0),(562049,15613,'no','Blokkere syke belastning',0),(562050,15613,'da','Blok syg periodisering',0),(562051,15613,'ko','ë¸”ë¡ ì•„í”ˆ ì ë¦½',0),(562052,15613,'he','×”×ª×©×œ×•× ×—×•×œ×” ×‘×œ×•×§',0),(562053,15613,'el','ÎœÏ€Î»Î¿Îº Î¬ÏÏÏ‰ÏƒÏ„Î¿Ï‚ Î±Ï…Ï„Î¿Ï„Î­Î»ÎµÎ¹Î±Ï‚ Ï„Ï‰Î½ Ï‡ÏÎ®ÏƒÎµÏ‰Î½',0),(562054,15613,'zh','å—ç”Ÿç—…æƒè´£å‘ç”Ÿåˆ¶',0),(562055,15613,'sv','Block sjuk periodisering',0),(562056,15613,'it','Blocco malato Accrual',0),(562057,15613,'tl','',0),(562058,15613,'th','à¸šà¸¥à¹‡à¸­à¸à¸›à¹ˆà¸§à¸¢à¸ªà¸°à¸ªà¸¡',0),(562059,15613,'hi','à¤¬à¥à¤²à¥‰à¤• à¤¬à¥€à¤®à¤¾à¤° à¤ªà¥à¤°à¥‹à¤¦à¥à¤­à¤µà¤¨',0),(562060,15613,'ms','Blok sakit terakru',0),(562061,15613,'ar','ÙƒØªÙ„Ø© Ø§Ù„Ù…Ø±Ø¶Ù‰ Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(562062,15613,'fr','Bloc accumulation malade',0),(562063,15613,'jp','ãƒ–ãƒ­ãƒƒã‚¯ç—…æ°—ç™ºç”Ÿ',0),(562064,15613,'pt','Bloco doente contabilidade',0),(562065,15613,'ru','Ð‘Ð»Ð¾Ðº Ð±Ð¾Ð»ÐµÐ½ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ',0),(562066,15613,'es','Bloque de acumulaciÃ³n enfermo',0),(562067,15613,'de','Block krank Accrual',0),(562068,15613,'en','Block Sick Accrual',0),(562069,15614,'is','',0),(562070,15614,'dr','Ø¨Ù„ÙˆÚ© ØªØ¹Ø·ÛŒÙ„Ø§Øª ØªØ¹Ù‡Ø¯ÛŒ',0),(562071,15614,'pr','Ø¨Ù„ÙˆÚ© ØªØ¹Ø·ÛŒÙ„Ø§Øª ØªØ¹Ù‡Ø¯ÛŒ',0),(562072,15614,'tr','Blok tatil tahakkuk',0),(562073,15614,'pl','Blok wakacje naliczania',0),(562074,15614,'bg','Ð‘Ð»Ð¾Ðº Ð²Ð°ÐºÐ°Ð½Ñ†Ð¸Ñ Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ð½Ðµ',0),(562075,15614,'ur','Ú†Ú¾Ù¹ÛŒ Ø§Ú©Ú©Ø±ÙˆØ§Ù„ Ø¨Ù„Ø§Ú©',0),(562076,15614,'sr','Ð‘Ð»Ð¾Ðº Ð¾Ð´Ð¼Ð¾Ñ€ Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°ÑšÐ°',0),(562077,15614,'vi','Khá»‘i Vacation Accrual',0),(562078,15614,'af','Blok vakansie aanwas',0),(562079,15614,'ro','Angajamente de vacanta bloc',0),(562080,15614,'et','Block puhkus tekkepÃµhise',0),(562081,15614,'si','Blok poÄitnice raÄunovodstva',0),(562082,15614,'ba','Blok liburan akrual',0),(562083,15614,'nl','Toename van de vakantie van de blok',0),(562084,15614,'fi','EstÃ¤Ã¤ loma jaksotus',0),(562085,15614,'no','Blokkere ferie belastning',0),(562086,15614,'da','Blok ferie periodisering',0),(562087,15614,'ko','ë¸”ë¡ íœ´ê°€ ì ë¦½',0),(562088,15614,'he','×œ×—×¡×•× ××ª ×¦×‘×™×¨×ª ×”×—×•×¤×©×”',0),(562089,15614,'el','Î”ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Î· Î²Î¬ÏƒÎ· Î´Î¹Î±ÎºÎ¿Ï€Î­Ï‚ Î¼Ï€Î»Î¿Îº',0),(562090,15614,'zh','å—åº¦å‡æƒè´£å‘ç”Ÿåˆ¶',0),(562091,15614,'sv','Blockera semester periodisering',0),(562092,15614,'it','Blocco vacanze Accrual',0),(562093,15614,'tl','',0),(562094,15614,'th','à¸šà¸¥à¹‡à¸­à¸à¸ªà¸°à¸ªà¸¡à¸§à¸±à¸™à¸«à¸¢à¸¸à¸”à¸žà¸±à¸à¸œà¹ˆà¸­à¸™',0),(562095,15614,'hi','à¤¬à¥à¤²à¥‰à¤• à¤›à¥à¤Ÿà¥à¤Ÿà¥€ à¤ªà¥à¤°à¥‹à¤¦à¥à¤­à¤µà¤¨',0),(562096,15614,'ms','Blok percutian terakru',0),(562097,15614,'ar','ÙƒØªÙ„Ø© Ø¥Ø¬Ø§Ø²Ø© Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(562098,15614,'fr','Bloquer l\'accumulation de vacances',0),(562099,15614,'jp','ä¼‘æš‡ã®ç™ºç”Ÿã‚’ãƒ–ãƒ­ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(562100,15614,'pt','Bloquear a acumulaÃ§Ã£o de fÃ©rias',0),(562101,15614,'ru','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ð¿ÑƒÑÐºÐ°',0),(562102,15614,'es','Bloquear la acumulaciÃ³n de vacaciones',0),(562103,15614,'de','Urlaub-Abgrenzung zu blockieren',0),(562104,15614,'en','Block Vacation Accrual',0),(562105,15615,'is','',0),(562106,15615,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª Ø­Ù‚ÙˆÙ‚',0),(562107,15615,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª Ø­Ù‚ÙˆÙ‚',0),(562108,15615,'tr','Oturum aÃ§ma haklarÄ±',0),(562109,15615,'pl','ZgÅ‚oÅ› siÄ™ do systemu prawa',0),(562110,15615,'bg','Ð’Ñ…Ð¾Ð´ Ð¿Ñ€Ð°Ð²Ð°',0),(562111,15615,'ur','Ù„Ø§Ú¯ Ø§Ù† Ú©Û’ Ø­Ù‚ÙˆÙ‚',0),(562112,15615,'sr','ÐŸÑ€Ð°Ð²Ð° Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ',0),(562113,15615,'vi','ÄÄƒng nháº­p quyá»n',0),(562114,15615,'af','Aantekening regte',0),(562115,15615,'ro','Drepturile de conectare',0),(562116,15615,'et','Login Ãµigused',0),(562117,15615,'si','Prijava pravic',0),(562118,15615,'ba','Hak-hak login',0),(562119,15615,'nl','Inloggen rechten',0),(562120,15615,'fi','Kirjaudu oikeudet',0),(562121,15615,'no','Logikk rettigheter',0),(562122,15615,'da','Login rettigheder',0),(562123,15615,'ko','ë¡œê·¸ì¸ ê¶Œí•œ',0),(562124,15615,'he','×–×›×•×™×•×ª ×›× ×™×¡×”',0),(562125,15615,'el','Î”Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚',0),(562126,15615,'zh','ç™»å½•æƒåˆ©',0),(562127,15615,'sv','Logga in rÃ¤ttigheter',0),(562128,15615,'it','Diritti di accesso',0),(562129,15615,'tl','',0),(562130,15615,'th','à¸ªà¸´à¸—à¸˜à¸´à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(562131,15615,'hi','à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤…à¤§à¤¿à¤•à¤¾à¤°',0),(562132,15615,'ms','Hak-hak log masuk',0),(562133,15615,'ar','Ø­Ù‚ÙˆÙ‚ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(562134,15615,'fr','Droits de connexion',0),(562135,15615,'jp','ãƒ­ã‚°ã‚¤ãƒ³æ¨©é™',0),(562136,15615,'pt','Direitos de logon',0),(562137,15615,'ru','ÐŸÑ€Ð°Ð²Ð° Ð²Ñ…Ð¾Ð´Ð°',0),(562138,15615,'es','Derechos de inicio de sesiÃ³n',0),(562139,15615,'de','Anmelderechte',0),(562140,15615,'en','Login Rights',0),(562141,15616,'is','',0),(562142,15616,'dr','Ø­Ø¯Ø§Ú©Ø«Ø± Ø¯Ø³ØªÙ…Ø²Ø¯ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª Ù‡Ø± Ú©Ø§Ø±Ù…Ù†Ø¯',0),(562143,15616,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± Ø¯Ø³ØªÙ…Ø²Ø¯ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª Ù‡Ø± Ú©Ø§Ø±Ù…Ù†Ø¯',0),(562144,15616,'tr','Ã‡alÄ±ÅŸan baÅŸÄ±na en fazla vergiye tabi Ã¼cret',0),(562145,15616,'pl','Maksymalne wynagrodzenie podatnika na pracownika',0),(562146,15616,'bg','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ðº',0),(562147,15616,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ú¯Ú¾Ù¹Ø§ØªÛ’ ÛÛŒÚº Ø¬Ùˆ Ø§Ø¬Ø±Øª Ù…Ù„Ø§Ø²Ù… ÙÛŒ',0),(562148,15616,'sr','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»Ð½Ð° Ð¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ð¾ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð¼',0),(562149,15616,'vi','Tá»‘i Ä‘a thuáº¿ tiá»n lÆ°Æ¡ng cho má»—i nhÃ¢n viÃªn',0),(562150,15616,'af','Maksimum belasbare loon Per werknemer',0),(562151,15616,'ro','Salariile impozabile maximÄƒ Per angajat',0),(562152,15616,'et','Maksimaalne maksustatava tÃ¶Ã¶tasu tÃ¶Ã¶taja kohta',0),(562153,15616,'si','NajviÅ¡ji obdavÄljivi plaÄe na zaposlenega',0),(562154,15616,'ba','Maksimum kena pajak upah Per karyawan',0),(562155,15616,'nl','Maximaal belastbaar loon Per werknemer',0),(562156,15616,'fi','Suurin veron palkka tyÃ¶ntekijÃ¤Ã¤ kohti',0),(562157,15616,'no','Maksimal skattepliktig lÃ¸nn Per ansatt',0),(562158,15616,'da','Maksimale skattepligtige lÃ¸n pr. medarbejder',0),(562159,15616,'ko','ì§ì› ë‹¹ ìµœëŒ€ ê³¼ì„¸ ëŒ€ìƒ ìž„ê¸ˆ',0),(562160,15616,'he','×ž×¨×‘×™×ª ×—×™×™×‘ ×‘×ž×¡ ×©×›×¨ ×œ×©×›×™×¨',0),(562161,15616,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î· Ï†Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­Î± Î¼Î¹ÏƒÎ¸Î¿Î¯ Î±Î½Î¬ Ï…Ï€Î¬Î»Î»Î·Î»Î¿',0),(562162,15616,'zh','æ¯ä¸ªé›‡å‘˜çš„æœ€é«˜åº”ç¨Žå·¥èµ„',0),(562163,15616,'sv','Maximal skattepliktig lÃ¶n Per anstÃ¤lld',0),(562164,15616,'it','Salario massimo imponibile Per dipendente',0),(562165,15616,'tl','',0),(562166,15616,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µà¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¸•à¹ˆà¸­à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(562167,15616,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤•à¤°-à¤¯à¥‹à¤—à¥ à¤¯ à¤®à¤œà¤¦à¥‚à¤°à¥€ à¤ªà¥à¤°à¤¤à¤¿ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(562168,15616,'ms','Gaji boleh cukai maksimum setiap kakitangan',0),(562169,15616,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ù„Ù„Ø£Ø¬ÙˆØ± Ø§Ù„Ø®Ø§Ø¶Ø¹Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø© Ù„Ù„Ù…ÙˆØ¸Ù Ø§Ù„ÙˆØ§Ø­Ø¯',0),(562170,15616,'fr','Salaire imposable maximum par employÃ©',0),(562171,15616,'jp','å¾“æ¥­å“¡ä¸€äººå½“ãŸã‚Šæœ€å¤§èª²ç¨Žå¯¾è±¡è³ƒé‡‘',0),(562172,15616,'pt','MÃ¡ximo salÃ¡rio tributÃ¡vel por trabalhador',0),(562173,15616,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð¼ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð° Ð½Ð° Ð¾Ð´Ð½Ð¾Ð³Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(562174,15616,'es','Salarios imponibles mÃ¡xima por empleado',0),(562175,15616,'de','Maximale Steuerpflichtige EinkÃ¼nfte pro Mitarbeiter',0),(562176,15616,'en','Maximum Taxable Wages Per Employee',0),(562177,15617,'is','',0),(562178,15617,'dr','Ù…Ø§Ù„ÛŒØ§Øª Ù…Ù‚Ø±Ø±',0),(562179,15617,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ù…Ù‚Ø±Ø±',0),(562180,15617,'tr','Vergi nedeniyle',0),(562181,15617,'pl','Podatku ze wzglÄ™du',0),(562182,15617,'bg','Ð”Ð°Ð½ÑŠÑ†Ð¸ Ð´ÑŠÐ»Ð¶Ð¸',0),(562183,15617,'ur','Ù¹ÛŒÚ©Ø³ ÙˆØ§Ø¬Ø¨',0),(562184,15617,'sr','ÐŸÐ˜Ð‘ ÐºÑ€Ð°Ñ˜ÑšÐ¸',0),(562185,15617,'vi','Thuáº¿ do',0),(562186,15617,'af','Verskuldigde belasting',0),(562187,15617,'ro','Taxe datorate',0),(562188,15617,'et','KÃ¤ibemaksu nÃµuetekohast',0),(562189,15617,'si','Davek zaradi',0),(562190,15617,'ba','Pajak karena',0),(562191,15617,'nl','Fiscale Due',0),(562192,15617,'fi','Vero Due',0),(562193,15617,'no','Skatt forfallsdato',0),(562194,15617,'da','Skat Due',0),(562195,15617,'ko','ë•Œë¬¸ì— ì„¸ê¸ˆ',0),(562196,15617,'he','×ž×¡ ×‘×©×œ',0),(562197,15617,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Î´ÎµÏŒÎ½Ï„Ï‰Ï‚',0),(562198,15617,'zh','ç¨ŽåŠ¡',0),(562199,15617,'sv','Skatt pÃ¥ grund',0),(562200,15617,'it','Debito di imposta',0),(562201,15617,'tl','',0),(562202,15617,'th','à¸ à¸²à¸©à¸µà¸„à¸£à¸š',0),(562203,15617,'hi','à¤Ÿà¥ˆà¤•à¥à¤¸ à¤¨à¤¿à¤¯à¤¤',0),(562204,15617,'ms','Cukai perlu dibayar',0),(562205,15617,'ar','Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„ÙˆØ§Ø¬Ø¨Ø©',0),(562206,15617,'fr','Taxe Due',0),(562207,15617,'jp','ç¨Žé¡',0),(562208,15617,'pt','Imposto devido',0),(562209,15617,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð´Ð¾Ð»Ð¶Ð½Ð¾Ð³Ð¾',0),(562210,15617,'es','Impuesto debido',0),(562211,15617,'de','Steuerliche Due',0),(562212,15617,'en','Tax Due',0),(562213,15618,'is','',0),(562214,15618,'dr','Ø§Ø±Ø³Ø§Ù„ Ø³ÙØ§Ø±Ø´',0),(562215,15618,'pr','Ø§Ø±Ø³Ø§Ù„ Ø³ÙØ§Ø±Ø´',0),(562216,15618,'tr','SipariÅŸi gÃ¶nder',0),(562217,15618,'pl','ZÅ‚oÅ¼yÄ‡ zamÃ³wienie',0),(562218,15618,'bg','ÐŸÐ¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(562219,15618,'ur','Ø¢Ø±ÚˆØ± Ø§Ø±Ø³Ø§Ù„ Ú©Ø±ÛŒÚº',0),(562220,15618,'sr','ÐŸÑ€Ð¾ÑÐ»ÐµÐ´Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ñƒ',0),(562221,15618,'vi','Gá»­i Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(562222,15618,'af','Orde dien',0),(562223,15618,'ro','Trimiteti comanda',0),(562224,15618,'et','Edasta tellimus',0),(562225,15618,'si','PoÅ¡lji naroÄilo',0),(562226,15618,'ba','Kirim Pemesanan',0),(562227,15618,'nl','Order indienen',0),(562228,15618,'fi','LÃ¤hetÃ¤ tilaus',0),(562229,15618,'no','Send inn bestilling',0),(562230,15618,'da','Indsend ordre',0),(562231,15618,'ko','ì£¼ë¬¸ ì œì¶œ',0),(562232,15618,'he','×©×œ×— ×”×–×ž× ×”',0),(562233,15618,'el','Î¥Ï€Î¿Î²Î¿Î»Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(562234,15618,'zh','æäº¤è®¢å•',0),(562235,15618,'sv','Skicka bestÃ¤llning',0),(562236,15618,'it','Invia ordine',0),(562237,15618,'tl','',0),(562238,15618,'th','à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(562239,15618,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤¬à¤®à¤¿à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(562240,15618,'ms','Hantar pesanan',0),(562241,15618,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(562242,15618,'fr','Soumettre la commande',0),(562243,15618,'jp','æ³¨æ–‡ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(562244,15618,'pt','Submeter encomenda',0),(562245,15618,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð·',0),(562246,15618,'es','Enviar orden',0),(562247,15618,'de','Bestellung absenden',0),(562248,15618,'en','Submit Order',0),(562249,15619,'is','',0),(562250,15619,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ±Ø¯ ØªØ§Ø±ÛŒØ®Ú†Ù‡',0),(562251,15619,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù…ÙˆØ±Ø¯ ØªØ§Ø±ÛŒØ®Ú†Ù‡',0),(562252,15619,'tr','Madde geÃ§miÅŸ fatura',0),(562253,15619,'pl','Element zapowiadane historia',0),(562254,15619,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ñ‚Ð°ÐºÑÑƒÐ²Ð°Ð½Ð¸ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ',0),(562255,15619,'ur','Ø´Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø¨Ø§Ù„Ù„Ø§Ø¯',0),(562256,15619,'sr','ÐÑ€Ñ‚Ð¸ÐºÐ°Ð» Ð½Ð°Ð¿Ð»Ð°Ñ›ÐµÐ½ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(562257,15619,'vi','Má»¥c quáº£ng cÃ¡o lá»‹ch sá»­',0),(562258,15619,'af','Item weerspieÃ«l geskiedenis',0),(562259,15619,'ro','Articol facturat istorie',0),(562260,15619,'et','Kauba arve ajalugu',0),(562261,15619,'si','Artikel zaraÄunali zgodovina',0),(562262,15619,'ba','Item ditagih sejarah',0),(562263,15619,'nl','Item gefactureerd geschiedenis',0),(562264,15619,'fi','Kohde laskutetaan historia',0),(562265,15619,'no','Elementet fakturert historie',0),(562266,15619,'da','Vare faktureres historie',0),(562267,15619,'ko','í•­ëª© ì²­êµ¬ ì—­ì‚¬',0),(562268,15619,'he','×”×¤×¨×™×˜ ×ž×—×•×™×‘ ×”×™×¡×˜×•×¨×™×”',0),(562269,15619,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï„Î¹Î¼Î¿Î»Î¿Î³ÎµÎ¯Ï„Î±Î¹ Î¹ÏƒÏ„Î¿ÏÎ¯Î±',0),(562270,15619,'zh','é¡¹ç›®è®¡è´¹åŽ†å²',0),(562271,15619,'sv','Artikeln faktureras historia',0),(562272,15619,'it','Elemento fatturati storia',0),(562273,15619,'tl','',0),(562274,15619,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¸›à¸£à¸°à¸§à¸±à¸•à¸´',0),(562275,15619,'hi','à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸ à¤†à¤‡à¤Ÿà¤® à¤¬à¤¿à¤²',0),(562276,15619,'ms','Item dibilkan sejarah',0),(562277,15619,'ar','Ø§Ù„Ø¨Ù†Ø¯ ÙØ§ØªÙˆØ±Ø© Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(562278,15619,'fr','Ã‰lÃ©ment Ã  bec histoire',0),(562279,15619,'jp','ã‚¢ã‚¤ãƒ†ãƒ èª²é‡‘ã®æ­´å²',0),(562280,15619,'pt','Item de bico histÃ³ria',0),(562281,15619,'ru','ÐžÐ±ÑŠÑÐ²Ð»ÐµÐ½Ð½Ñ‹Ð¹ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚ Ð¸ÑÑ‚Ð¾Ñ€Ð¸Ð¸',0),(562282,15619,'es','ArtÃ­culo anunciado historia',0),(562283,15619,'de','Element in Rechnung gestellt, Geschichte',0),(562284,15619,'en','Item Billed History',0),(562285,15620,'is','',0),(562286,15620,'dr','Ø´Ù†Ø§Ø³Ù‡ Ù‡Ø§ÛŒ Ú¯Ù… Ø´Ø¯Ù‡',0),(562287,15620,'pr','Ø´Ù†Ø§Ø³Ù‡ Ù‡Ø§ÛŒ Ú¯Ù… Ø´Ø¯Ù‡',0),(562288,15620,'tr','KimliÄŸi eksik',0),(562289,15620,'pl','Brakuje identyfikatora',0),(562290,15620,'bg','Ð›Ð¸Ð¿ÑÐ²Ð°Ñ‰ Ð˜Ð”',0),(562291,15620,'ur','Ø´Ù†Ø§Ø®Øª ØºØ§Ø¦Ø¨',0),(562292,15620,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ð˜Ð”',0),(562293,15620,'vi','Thiáº¿u ID',0),(562294,15620,'af','ID vermis',0),(562295,15620,'ro','LipseÅŸte ID',0),(562296,15620,'et','ID puudub.',0),(562297,15620,'si','Manjka ID',0),(562298,15620,'ba','Hilang ID',0),(562299,15620,'nl','Ontbrekende ID',0),(562300,15620,'fi','Tunnus puuttuu',0),(562301,15620,'no','-ID mangler',0),(562302,15620,'da','-ID mangler',0),(562303,15620,'ko','ëˆ„ë½ ëœ ID',0),(562304,15620,'he','×ž×–×”×” ×”×—×¡×¨',0),(562305,15620,'el','Î›ÎµÎ¯Ï€ÎµÎ¹ Ï„Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ',0),(562306,15620,'zh','ç¼ºå°‘ ID',0),(562307,15620,'sv','-ID saknas',0),(562308,15620,'it','ID mancante',0),(562309,15620,'tl','',0),(562310,15620,'th','à¸£à¸«à¸±à¸ªà¸‚à¸²à¸”à¹„à¸›',0),(562311,15620,'hi','à¤†à¤ˆà¤¡à¥€ à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§',0),(562312,15620,'ms','Hilang ID',0),(562313,15620,'ar','Ù…Ø¹Ø±Ù Ù…ÙÙ‚ÙˆØ¯',0),(562314,15620,'fr','ID manquant',0),(562315,15620,'jp','ID ãŒãªã„ã§ã™ã€‚',0),(562316,15620,'pt','Falta a ID',0),(562317,15620,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(562318,15620,'es','Falta de identificaciÃ³n',0),(562319,15620,'de','Fehlende ID',0),(562320,15620,'en','Missing ID',0),(562321,15621,'is','',0),(562322,15621,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…ÙˆØ§Ø±Ø¯',0),(562323,15621,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù…ÙˆØ§Ø±Ø¯',0),(562324,15621,'tr','SatÄ±cÄ± maddeleri',0),(562325,15621,'pl','Pozycji sprzedawcy',0),(562326,15621,'bg','ÐÑ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°',0),(562327,15621,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§Ø´ÛŒØ§Ø¡',0),(562328,15621,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(562329,15621,'vi','NhÃ  bÃ¡n hÃ ng',0),(562330,15621,'af','Handelaar Items',0),(562331,15621,'ro','Elemente de furnizor',0),(562332,15621,'et','Hankija kaubad',0),(562333,15621,'si','Dobaviteljevih artiklov',0),(562334,15621,'ba','Penjual item',0),(562335,15621,'nl','Leverancier Items',0),(562336,15621,'fi','MyyjÃ¤ asiat',0),(562337,15621,'no','LeverandÃ¸r eks',0),(562338,15621,'da','LeverandÃ¸rvarer',0),(562339,15621,'ko','ê³µê¸‰ ì—…ì²´ í•­ëª©',0),(562340,15621,'he','×”×¡×¤×§ ×¤×¨×™×˜×™×',0),(562341,15621,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(562342,15621,'zh','ä¾›åº”å•†ç‰©æ–™',0),(562343,15621,'sv','LeverantÃ¶rsartiklar',0),(562344,15621,'it','Fornitore articoli',0),(562345,15621,'tl','',0),(562346,15621,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(562347,15621,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤†à¤‡à¤Ÿà¤®',0),(562348,15621,'ms','Penjual barang-barang',0),(562349,15621,'ar','Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…ÙˆØ±Ø¯',0),(562350,15621,'fr','Objets du vendeur',0),(562351,15621,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®å•†å“',0),(562352,15621,'pt','Itens do fornecedor',0),(562353,15621,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(562354,15621,'es','Proveedor de artÃ­culos',0),(562355,15621,'de','Kreditor-Elemente',0),(562356,15621,'en','Vendor Items',0),(562357,15622,'is','',0),(562358,15622,'dr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÛŒ Ø®Ø·',0),(562359,15622,'pr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ù‡Ø§ÛŒ Ø®Ø·',0),(562360,15622,'tr','SatÄ±r numaralarÄ±nÄ± gizle',0),(562361,15622,'pl','Ukryj numery linii',0),(562362,15622,'bg','Ð¡ÐºÑ€Ð¸Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ñ€ÐµÐ´Ð¾Ð²Ðµ',0),(562363,15622,'ur','Ù„Ø§Ø¦Ù† Ù†Ù…Ø¨Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(562364,15622,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ‚Ð¸ Ð±Ñ€Ð¾Ñ˜ÐµÐ²Ðµ Ñ€ÐµÐ´Ð¾Ð²Ð°',0),(562365,15622,'vi','áº¨n sá»‘ dÃ²ng',0),(562366,15622,'af','Versteek lyn getalle',0),(562367,15622,'ro','Ascunde numere de linie',0),(562368,15622,'et','Reanumbreid peita',0),(562369,15622,'si','Skriti Å¡tevilk vrstic',0),(562370,15622,'ba','Menyembunyikan nomor baris',0),(562371,15622,'nl','Verbergen van regelnummers',0),(562372,15622,'fi','Piilota rivinumerot',0),(562373,15622,'no','Skjul linjenumre',0),(562374,15622,'da','Skjul linjenumre',0),(562375,15622,'ko','í–‰ ë²ˆí˜¸ ìˆ¨ê¸°ê¸°',0),(562376,15622,'he','×”×¡×ª×¨ ×ž×¡×¤×¨×™ ×©×•×¨×•×ª',0),(562377,15622,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î±ÏÎ¹Î¸Î¼ÏŽÎ½ Î³ÏÎ±Î¼Î¼ÏŽÎ½',0),(562378,15622,'zh','éšè—è¡Œå·',0),(562379,15622,'sv','DÃ¶lja radnummer',0),(562380,15622,'it','Nascondere i numeri di riga',0),(562381,15622,'tl','',0),(562382,15622,'th','à¸‹à¹ˆà¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸£à¸£à¸—à¸±à¸”',0),(562383,15622,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤•à¥à¤°à¤®à¤¾à¤‚à¤• à¤›à¥à¤ªà¤¾à¤à¤',0),(562384,15622,'ms','Sembunyikan nombor talian',0),(562385,15622,'ar','Ø¥Ø®ÙØ§Ø¡ Ø£Ø±Ù‚Ø§Ù… Ø§Ù„Ø£Ø³Ø·Ø±',0),(562386,15622,'fr','Masquer les numÃ©ros de ligne',0),(562387,15622,'jp','è¡Œç•ªå·ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(562388,15622,'pt','Esconder os nÃºmeros de linha',0),(562389,15622,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€Ð° ÑÑ‚Ñ€Ð¾Ðº',0),(562390,15622,'es','Ocultar los nÃºmeros de lÃ­nea',0),(562391,15622,'de','Ausblenden von Zeilennummern',0),(562392,15622,'en','Hide Line Numbers',0),(562393,15623,'is','',0),(562394,15623,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(562395,15623,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(562396,15623,'tr','Gemiye bilgi gizlemek',0),(562397,15623,'pl','Ukryj statek info',0),(562398,15623,'bg','Ð¡ÐºÑ€Ð¸Ð¹ ÐºÐ¾Ñ€Ð°Ð±-Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(562399,15623,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(562400,15623,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð±Ñ€Ð¾Ð´ Ð´Ð° Ð˜Ð½Ñ„Ð¾',0),(562401,15623,'vi','áº¨n con tÃ u Ä‘á»ƒ xem thÃ´ng tin',0),(562402,15623,'af','Versteek skip om inligting',0),(562403,15623,'ro','Ascunde navei la Info',0),(562404,15623,'et','Peida Info laeva',0),(562405,15623,'si','Skriti ladja info',0),(562406,15623,'ba','Sembunyikan kapal untuk Info',0),(562407,15623,'nl','Verbergen van schip naar Info',0),(562408,15623,'fi','Piilota aluksen info',0),(562409,15623,'no','Skjule skipet til Info',0),(562410,15623,'da','Skjule skibet til Info',0),(562411,15623,'ko','ë°° ì •ë³´ë¥¼ ìˆ¨ê¸°ê¸°',0),(562412,15623,'he','×œ×”×¡×ª×™×¨ ××ª ×”×¡×¤×™× ×” ××œ ×ž×™×“×¢',0),(562413,15623,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Ï€Î»Î¿Î¯Î¿ ÏƒÏ„Î¿ Info',0),(562414,15623,'zh','éšè—ä¿¡æ¯èˆ°',0),(562415,15623,'sv','DÃ¶lja fartyget till Info',0),(562416,15623,'it','Nascondere la nave per Info',0),(562417,15623,'tl','',0),(562418,15623,'th','à¸‹à¹ˆà¸­à¸™à¹€à¸£à¸·à¸­à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(562419,15623,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤›à¥à¤ªà¤¾à¤à¤',0),(562420,15623,'ms','Menyembunyikan maklumat kapal',0),(562421,15623,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ù„Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(562422,15623,'fr','Masquer le navire Ã  Info',0),(562423,15623,'jp','èˆ¹æƒ…å ±ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(562424,15623,'pt','Esconder a nave para informaÃ§Ã£o',0),(562425,15623,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(562426,15623,'es','Ocultar la nave a Info',0),(562427,15623,'de','Schiff zu Info ausblenden',0),(562428,15623,'en','Hide Ship To Info',0),(562429,15624,'is','',0),(562430,15624,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ù†Ø§Ù… Ù‡Ø§ÛŒ ÙˆØ§Ø­Ø¯',0),(562431,15624,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ù†Ø§Ù… Ù‡Ø§ÛŒ ÙˆØ§Ø­Ø¯',0),(562432,15624,'tr','Birim adlarÄ± gizle',0),(562433,15624,'pl','Ukrywanie nazwisk jednostki',0),(562434,15624,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¸Ð¼ÐµÐ½Ð°Ñ‚Ð° Ð½Ð° ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(562435,15624,'ur','ÛŒÙˆÙ†Ù¹ Ù†Ø§Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(562436,15624,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð¸Ð¼ÐµÐ½Ð° Ñ˜ÐµÐ´Ð¸Ð½Ð¸Ñ†Ð°',0),(562437,15624,'vi','áº¨n tÃªn Ä‘Æ¡n vá»‹',0),(562438,15624,'af','Verskuil name van eenheid',0),(562439,15624,'ro','Ascunde nume unitate',0),(562440,15624,'et','Peida Ã¼ksus nimed',0),(562441,15624,'si','Skriti imena enote',0),(562442,15624,'ba','Menyembunyikan nama Unit',0),(562443,15624,'nl','De namen van de eenheid verbergen',0),(562444,15624,'fi','Piilota yksikÃ¶n nimi',0),(562445,15624,'no','Skjule enhetsnavn',0),(562446,15624,'da','Skjul enhed navne',0),(562447,15624,'ko','ë‹¨ìœ„ ì´ë¦„ ìˆ¨ê¸°ê¸°',0),(562448,15624,'he','×œ×”×¡×ª×™×¨ ××ª ×©×ž×•×ª ×™×—×™×“×•×ª',0),(562449,15624,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î¿Î½Î¿Î¼Î¬Ï„Ï‰Î½ ÎµÎ½Î¿Ï„Î®Ï„Ï‰Î½',0),(562450,15624,'zh','éšè—å•ä½åç§°',0),(562451,15624,'sv','DÃ¶lja namn',0),(562452,15624,'it','Nascondere i nomi delle unitÃ ',0),(562453,15624,'tl','',0),(562454,15624,'th','à¸‹à¹ˆà¸­à¸™à¸Šà¸·à¹ˆà¸­à¸«à¸™à¹ˆà¸§à¸¢',0),(562455,15624,'hi','à¤‡à¤•à¤¾à¤ˆ à¤¨à¤¾à¤® à¤›à¥à¤ªà¤¾à¤à¤',0),(562456,15624,'ms','Sembunyikan nama-nama Unit',0),(562457,15624,'ar','Ø¥Ø®ÙØ§Ø¡ Ø£Ø³Ù…Ø§Ø¡ Ø§Ù„ÙˆØ­Ø¯Ø©',0),(562458,15624,'fr','Masquer les noms des unitÃ©s',0),(562459,15624,'jp','ãƒ¦ãƒ‹ãƒƒãƒˆåã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(562460,15624,'pt','Esconder nomes de unidade',0),(562461,15624,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¸Ð¼ÐµÐ½Ð° Ð±Ð»Ð¾Ðº',0),(562462,15624,'es','Ocultar nombres de unidad',0),(562463,15624,'de','Ausblenden der Einheitennamen',0),(562464,15624,'en','Hide Unit Names',0),(562465,15625,'is','',0),(562466,15625,'dr','POS Ù†ØªÛŒØ¬Ù‡ Ú†Ø§Ù¾ÛŒ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ÙØ§Ú©ØªÙˆØ± Ø¨Ù‡ Ø¬Ø§ÛŒ Ø¯Ø±ÛŒØ§ÙØª ÙØ±ÙˆØ´ Ø¨Ø±Ú†Ø³Ø¨',0),(562467,15625,'pr','POS Ù†ØªÛŒØ¬Ù‡ Ú†Ø§Ù¾ÛŒ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ÙØ§Ú©ØªÙˆØ± Ø¨Ù‡ Ø¬Ø§ÛŒ Ø¯Ø±ÛŒØ§ÙØª ÙØ±ÙˆØ´ Ø¨Ø±Ú†Ø³Ø¨',0),(562468,15625,'tr','Fatura satÄ±ÅŸ makbuzu yerine olarak POS yazÄ±cÄ± Ã§Ä±ktÄ±sÄ± etiket',0),(562469,15625,'pl','Etykieta POS wydruk jako faktura zamiast paragonem sprzedaÅ¼y',0),(562470,15625,'bg','Ð•Ñ‚Ð¸ÐºÐµÑ‚ POS Ñ€Ð°Ð·Ð¿ÐµÑ‡Ð°Ñ‚ÐºÐ° ÐºÐ°Ñ‚Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð²Ð¼ÐµÑÑ‚Ð¾ ÐºÐ°ÑÐ¾Ð²Ð°',0),(562471,15625,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù¾ÙˆØ²ÛŒØ´Ù† Ù…Ø·Ø¨ÙˆØ¹Û Ø³ÛŒÙ„Ø² Ø±Ø³ÛŒØ¯ Ú©ÛŒ Ø¨Ø¬Ø§Ø¦Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù„ÛŒØ¨Ù„',0),(562472,15625,'sr','ÐžÐ·Ð½Ð°Ñ‡Ð¸Ñ‚Ðµ ÐŸÐžÐ¡ ÐŸÑ€Ð¸Ð½Ñ‚Ð¾ÑƒÑ‚ ÐºÐ°Ð¾ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ ÑƒÐ¼ÐµÑÑ‚Ð¾ ÑƒÐ»Ð°Ð·Ð½Ðµ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð½Ð¸Ñ†Ðµ',0),(562473,15625,'vi','NhÃ£n POS in lÃ  hoÃ¡ Ä‘Æ¡n thay vÃ¬ giáº¥y biÃªn nháº­n bÃ¡n hÃ ng',0),(562474,15625,'af','Etiketteer POS uitdruk As faktuur in plaas van verkope ontvangs',0),(562475,15625,'ro','Eticheta imprimatÄƒ POS ca facturÄƒ Ã®n loc de vÃ¢nzÄƒri primire',0),(562476,15625,'et','Etikett POS vÃ¤ljatrÃ¼kk nagu arve asemel MÃ¼Ã¼gikviitung',0),(562477,15625,'si','Oznaka POS izpis kot raÄun namesto potrdilo o prodaji',0),(562478,15625,'ba','Label POS Printout sebagai faktur bukan struk',0),(562479,15625,'nl','Label POS afdruk als factuur in plaats van kassabon',0),(562480,15625,'fi','Etiketti POS tulosteen sijaan kuitti',0),(562481,15625,'no','Etiketten POS utskriften som fakturaen i stedet for salgskvittering',0),(562482,15625,'da','MÃ¦rke POS udskrift som fakturaen i stedet for kvittering',0),(562483,15625,'ko','íŒë§¤ ì˜ìˆ˜ì¦ ëŒ€ì‹  ì†¡ìž¥ POS ì¸ì‡„ ë ˆì´ë¸”',0),(562484,15625,'he','×ª×•×•×™×ª POS ×”×ª×“×¤×™×¡ ×›×—×©×‘×•× ×™×ª ×‘×ž×§×•× ×—×©×‘×•× ×™×ª ×”×§× ×™×™×”',0),(562485,15625,'el','Î•Ï„Î¹ÎºÎ­Ï„Î± POS ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ· Ï‰Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î±Î½Ï„Î¯ Î³Î¹Î± Î±Ï€ÏŒÎ´ÎµÎ¹Î¾Î· Î»Î¹Î±Î½Î¹ÎºÎ®Ï‚ Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(562486,15625,'zh','ä½œä¸ºå‘ç¥¨è€Œä¸æ˜¯é”€å”®æ”¶æ®æ ‡ç­¾ POS æ‰“å°è¾“å‡º',0),(562487,15625,'sv','MÃ¤rka POS utskriften som faktura istÃ¤llet fÃ¶r kvittot',0),(562488,15625,'it','Etichettare il POS stampa fattura anzichÃ© scontrino',0),(562489,15625,'tl','',0),(562490,15625,'th','à¸›à¹‰à¸²à¸¢à¸‡à¸²à¸™à¸žà¸´à¸¡à¸žà¹Œ POS à¹€à¸›à¹‡à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹à¸—à¸™à¹ƒà¸šà¹€à¸ªà¸£à¹‡à¸ˆà¸£à¸±à¸šà¹€à¸‡à¸´à¸™',0),(562491,15625,'hi','POS à¤ªà¥à¤°à¤¿à¤‚à¤Ÿà¤†à¤‰à¤Ÿ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤°à¤¸à¥€à¤¦ à¤•à¥‡ à¤¬à¤œà¤¾à¤¯ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤²à¥‡à¤¬à¤²',0),(562492,15625,'ms','Label cetakan POS sebagai invois dan bukannya resit pembelian',0),(562493,15625,'ar','ØªØ³Ù…ÙŠØ© Ø§Ù„Ù†Ø³Ø®Ø© Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø© Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹ ÙƒÙØ§ØªÙˆØ±Ø© Ø¨Ø¯Ù„Ø§Ù‹ Ù…Ù† Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(562494,15625,'fr','Ã‰tiquette impression POS comme facture au lieu de facture',0),(562495,15625,'jp','POS å°åˆ·è²©å£²ã®é ˜åŽæ›¸ã§ã¯ãªãè«‹æ±‚æ›¸ã¨ã—ã¦ãƒ©ãƒ™ãƒ«ã‚’ä»˜ã‘ã‚‹',0),(562496,15625,'pt','Rotular a impressÃ£o de POS como factura em vez de recibo de venda',0),(562497,15625,'ru','Ð¯Ñ€Ð»Ñ‹Ðº POS Ñ€Ð°ÑÐ¿ÐµÑ‡Ð°Ñ‚ÐºÑƒ ÑÑ‡ÐµÑ‚Ð° Ð²Ð¼ÐµÑÑ‚Ð¾ ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸',0),(562498,15625,'es','Etiqueta impresiÃ³n POS como factura en lugar de recibo',0),(562499,15625,'de','Label-POS-Ausdruck als Rechnung anstelle von Quittungen',0),(562500,15625,'en','Label POS Printout As Invoice Instead Of Sales Receipt',0),(562501,15626,'is','',0),(562502,15626,'dr','Ù†Ù…Ø§ÛŒØ´ Ø²Ù…ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø³ÙØ§Ø±Ø´ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø²ÛŒØ± Ø¯Ø± Ú©Ø´ØªÛŒ Ø¨Ù‡ Ù…Ù†Ø·Ù‚Ù‡',0),(562503,15626,'pr','Ù†Ù…Ø§ÛŒØ´ Ø²Ù…ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø³ÙØ§Ø±Ø´ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡ Ø²ÛŒØ± Ø¯Ø± Ú©Ø´ØªÛŒ Ø¨Ù‡ Ù…Ù†Ø·Ù‚Ù‡',0),(562504,15626,'tr','Gemi alanÄ±na aÅŸaÄŸÄ±da seÃ§ili Ã¶zel alanlarÄ± gÃ¶ster',0),(562505,15626,'pl','PokaÅ¼ pola niestandardowe zaznaczone poniÅ¼ej statku do obszaru',0),(562506,15626,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð¿Ð¾Ð»ÐµÑ‚Ð°, Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ Ð¿Ð¾-Ð´Ð¾Ð»Ñƒ Ð² ÐºÐ¾Ñ€Ð°Ð± Ð·Ð° Ð¾Ð±Ð»Ð°ÑÑ‚',0),(562507,15626,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ø¹Ù„Ø§Ù‚Û’ Ù…ÛŒÚº Ù†ÛŒÚ†Û’ Ù…Ù†ØªØ®Ø¨ Ù…Ø®ØµÙˆØµ Ù‚Ø·Ø¹Ø§Øª Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(562508,15626,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ñ™Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð¸ÑÐ¿Ð¾Ð´ Ñƒ Ð±Ñ€Ð¾Ð´ Ñƒ Ð¾Ð±Ð»Ð°ÑÑ‚',0),(562509,15626,'vi','Hiá»ƒn thá»‹ cÃ¡c lÄ©nh vá»±c tÃ¹y chá»‰nh Ä‘Æ°á»£c chá»n dÆ°á»›i Ä‘Ã¢y trong con tÃ u Ä‘á»ƒ khu vá»±c',0),(562510,15626,'af','Pasgemaakte velde gekies onder In die skip gebied wys',0),(562511,15626,'ro','AfiÈ™aÈ›i cÃ¢mpurile particularizate selectate mai jos Ã®n navÄƒ zona',0),(562512,15626,'et','Laeva ala allpool valitud kohandatud vÃ¤ljade kuvamine',0),(562513,15626,'si','PokaÅ¾i polj po meri, spodaj v ladje na podroÄju',0),(562514,15626,'ba','Bidang kustom yang dipilih di bawah ini di kapal untuk Area menunjukkan',0),(562515,15626,'nl','Aangepaste velden geselecteerd onder In het schip naar gebied weergeven',0),(562516,15626,'fi','NÃ¤ytÃ¤ mukautetut kentÃ¤t alla aluksen alueelle valitut',0),(562517,15626,'no','Vis egendefinerte felt som er valgt under skip til omrÃ¥det',0),(562518,15626,'da','Vis brugerdefinerede felter markeret nedenfor i skib til omrÃ¥de',0),(562519,15626,'ko','ì•„ëž˜ ë°° ì˜ì—­ì—ì„œ ì„ íƒí•œ ì‚¬ìš©ìž ì •ì˜ í•„ë“œ í‘œì‹œ',0),(562520,15626,'he','×”×¦×’ ×©×“×•×ª ×ž×•×ª××ž×™× ××™×©×™×ª ×©× ×‘×—×¨ ×œ×”×œ×Ÿ ×‘×¡×¤×™× ×” ×œ××–×•×¨',0),(562521,15626,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Ï‰Î½ Ï€ÎµÎ´Î¯Ï‰Î½ ÏƒÏ„Î¹Ï‚ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½ÎµÏ‚ Ï€Î»Î¿Î¯Î¿ ÏƒÎµ Ï€ÎµÏÎ¹Î¿Ï‡Î®',0),(562522,15626,'zh','æ˜¾ç¤ºåœ¨èˆ¹åˆ°åœ°åŒºä¸‹é¢æ‰€é€‰çš„è‡ªå®šä¹‰å­—æ®µ',0),(562523,15626,'sv','Visa anpassade fÃ¤lt markerade nedan i fartyget till omrÃ¥det',0),(562524,15626,'it','Visualizza campi personalizzati, selezionati di seguito In nave alla zona',0),(562525,15626,'tl','',0),(562526,15626,'th','à¹à¸ªà¸”à¸‡à¹€à¸‚à¸•à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹à¸šà¸šà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸à¸”à¹‰à¸²à¸™à¸¥à¹ˆà¸²à¸‡à¹ƒà¸™à¹€à¸£à¸·à¸­à¸žà¸·à¹‰à¸™à¸—à¸µà¹ˆ',0),(562527,15626,'hi','à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤®à¥‡à¤‚ à¤¨à¥€à¤šà¥‡ à¤šà¤¯à¤¨à¤¿à¤¤ à¤•à¤¸à¥à¤Ÿà¤® à¤«à¤¼à¥€à¤²à¥à¤¡à¥à¤¸ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(562528,15626,'ms','Menunjukkan adat bidang yang dipilih di bawah dalam kapal ke kawasan',0),(562529,15626,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ø®ØµØµØ© Ø§Ù„Ù…Ø­Ø¯Ø¯Ø© Ø£Ø¯Ù†Ø§Ù‡ ÙÙŠ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ù„Ù…Ù†Ø·Ù‚Ø©',0),(562530,15626,'fr','Afficher les champs personnalisÃ©s sÃ©lectionnÃ©s en navire Ã  zone',0),(562531,15626,'jp','ä»¥ä¸‹ã§é¸æŠžã—ãŸã‚¨ãƒªã‚¢ã‚’èˆ¹ã§ã‚«ã‚¹ã‚¿ãƒ  ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(562532,15626,'pt','Mostrar campos personalizados selecionados abaixo no navio para Ã¡rea',0),(562533,15626,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒÑÐºÐ¸Ðµ Ð¿Ð¾Ð»Ñ, Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… Ð½Ð¸Ð¶Ðµ Ð² ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð² Ñ€Ð°Ð¹Ð¾Ð½',0),(562534,15626,'es','Mostrar campos personalizados seleccionados abajo en barco al Ã¡rea de',0),(562535,15626,'de','Zeigen Sie benutzerdefinierte Felder unten im Schiff zum Bereich ausgewÃ¤hlten an',0),(562536,15626,'en','Show Custom Fields Selected Below In Ship To Area',0),(562537,15627,'is','',0),(562538,15627,'dr','Ù†Ù…Ø§ÛŒØ´ Ø³ØªÙˆÙ† ØªÙˆØ¶ÛŒØ­Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø³ØªÙˆÙ†',0),(562539,15627,'pr','Ù†Ù…Ø§ÛŒØ´ Ø³ØªÙˆÙ† ØªÙˆØ¶ÛŒØ­Ø§Øª Ù‚Ø¨Ù„ Ø§Ø² Ù…Ù‚Ø¯Ø§Ø± Ø³ØªÙˆÙ†',0),(562540,15627,'tr','AÃ§Ä±klama sÃ¼tunu Ã¶nce miktar sÃ¼tununu gÃ¶ster',0),(562541,15627,'pl','PokaÅ¼ opis kolumna przed Quantity kolumna',0),(562542,15627,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¾Ð½Ð° Ð·Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ñ€ÐµÐ´Ð¸ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐºÐ¾Ð»Ð¾Ð½Ð°',0),(562543,15627,'ur','ØªØ¹Ø¯Ø§Ø¯ Ú©Ø§Ù„Ù… Ø³Û’ Ù¾ÛÙ„Û’ ØªØµØ±ÛŒØ­ Ú©Ø§Ù„Ù… Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(562544,15627,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¾Ð¿Ð¸Ñ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ð¿Ñ€Ðµ ÐºÐ¾Ð»Ð¾Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð°',0),(562545,15627,'vi','Hiá»ƒn thá»‹ cá»™t mÃ´ táº£ trÆ°á»›c khi sá»‘ lÆ°á»£ng cá»™t',0),(562546,15627,'af','Beskrywing kolom voor hoeveelheid kolom wys',0),(562547,15627,'ro','AratÄƒ Descriere coloanÄƒ Ã®nainte cantitate coloana',0),(562548,15627,'et','Kuva enne kogus veeru kirjelduse veerg',0),(562549,15627,'si','Opis stolpec pred koliÄino stolpec',0),(562550,15627,'ba','Kolom Deskripsi Tampilkan sebelum kuantitas kolom',0),(562551,15627,'nl','Beschrijvingskolom voor kolom Quantity weergeven',0),(562552,15627,'fi','NÃ¤ytÃ¤ Kuvaus-sarakkeessa ennen mÃ¤Ã¤rÃ¤-sarake',0),(562553,15627,'no','Vis Beskrivelse-kolonnen fÃ¸r antall-kolonnen',0),(562554,15627,'da','Vis beskrivelse kolonne fÃ¸r mÃ¦ngde kolonne',0),(562555,15627,'ko','ìˆ˜ëŸ‰ ì—´ ì „ì— ì„¤ëª… ì—´ í‘œì‹œ',0),(562556,15627,'he','×”×¦×’ ×‘×¢×ž×•×“×” ×ª×™××•×¨ ×œ×¤× ×™ ×›×ž×•×ª ×¢×ž×•×“×”',0),(562557,15627,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÏ„Î®Î»Î·Ï‚ \"Î ÎµÏÎ¹Î³ÏÎ±Ï†Î®\" Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î· ÏƒÏ„Î®Î»Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î±',0),(562558,15627,'zh','æ˜¾ç¤ºæ•°é‡åˆ—å‰çš„è¯´æ˜Žåˆ—',0),(562559,15627,'sv','Visa i kolumnen Beskrivning fÃ¶re kvantitet kolumnen',0),(562560,15627,'it','Visualizza descrizione colonna prima colonna Quantity',0),(562561,15627,'tl','',0),(562562,15627,'th','à¹à¸ªà¸”à¸‡à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œà¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¸à¹ˆà¸­à¸™à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œà¸›à¸£à¸´à¸¡à¸²à¸“',0),(562563,15627,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤µà¤¿à¤µà¤°à¤£ à¤¸à¥à¤¤à¤‚à¤­ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(562564,15627,'ms','Menunjukkan penerangan lajur sebelum ruangan kuantiti',0),(562565,15627,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø¹Ù…ÙˆØ¯ Ø§Ù„ÙˆØµÙ Ù‚Ø¨Ù„ Ø§Ù„Ø¹Ù…ÙˆØ¯ Ø§Ù„ÙƒÙ…ÙŠØ©',0),(562566,15627,'fr','Voir la Description colonne avant la colonne Quantity',0),(562567,15627,'jp','æ•°é‡åˆ—ã®å‰ã« [èª¬æ˜Ž] åˆ—ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(562568,15627,'pt','Mostrar descriÃ§Ã£o de coluna antes da coluna Quantity',0),(562569,15627,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ ÑÑ‚Ð¾Ð»Ð±Ñ†Ð° Ð¿ÐµÑ€ÐµÐ´ ÑÑ‚Ð¾Ð»Ð±ÐµÑ† Quantity',0),(562570,15627,'es','Mostrar columna de DescripciÃ³n antes columna cantidad',0),(562571,15627,'de','Beschreibungsspalte vor der Mengenspalte anzeigen',0),(562572,15627,'en','Show Description Column Before Quantity Column',0),(562573,15628,'is','',0),(562574,15628,'dr','Ú†Ø§Ù¾ Ù„ÛŒØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ Ù‡Ø§ÛŒ ØªÙ„ÙÛŒÙ‚ÛŒ',0),(562575,15628,'pr','Ú†Ø§Ù¾ Ù„ÛŒØ³Øª Ø§Ù†ØªØ®Ø§Ø¨ Ù‡Ø§ÛŒ ØªÙ„ÙÛŒÙ‚ÛŒ',0),(562576,15628,'tr','Konsolide edilen seÃ§im listesi yazdÄ±rma',0),(562577,15628,'pl','Drukowanie listy skonsolidowanych Pick',0),(562578,15628,'bg','ÐŸÐµÑ‡Ð°Ñ‚ ÐºÐ¾Ð½ÑÐ¾Ð»Ð¸Ð´Ð¸Ñ€Ð°Ð½ ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(562579,15628,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³Ø² Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(562580,15628,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ ÐºÐ¾Ð½ÑÐ¾Ð»Ð¸Ð´Ð¾Ð²Ð°Ð½Ð¾ Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐ°',0),(562581,15628,'vi','In danh sÃ¡ch lá»±a chá»n há»£p nháº¥t',0),(562582,15628,'af','Druk gekonsolideerde kies lys',0),(562583,15628,'ro','ImprimaÈ›i listÄƒ consolidatÄƒ Pick',0),(562584,15628,'et','Prindi konsolideeritud noppimise loend',0),(562585,15628,'si','Tiskanje konsolidirani seznam',0),(562586,15628,'ba','Cetak konsolidasi memilih daftar',0),(562587,15628,'nl','Geconsolideerde picklijst afdrukken',0),(562588,15628,'fi','Tulosta konsernin poimintaluettelo',0),(562589,15628,'no','Skrive ut konsoliderte plukklisten',0),(562590,15628,'da','Udskrive konsoliderede plukliste',0),(562591,15628,'ko','ì¸ì‡„ ì„ íƒ ëª©ë¡ í†µí•©',0),(562592,15628,'he','×”×“×¤×¡ ×¨×©×™×ž×ª ××™×¡×•×£ ×ž××•×—×“',0),(562593,15628,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ½Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î· Pick',0),(562594,15628,'zh','æ‰“å°åˆå¹¶çš„é€‰å–åˆ—è¡¨',0),(562595,15628,'sv','Skriva ut konsoliderad plockning lista',0),(562596,15628,'it','Stampa elenco consolidato',0),(562597,15628,'tl','',0),(562598,15628,'th','à¸žà¸´à¸¡à¸žà¹Œà¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸šà¸´à¸à¸ªà¸´à¸™à¸„à¹‰à¸²à¹à¸šà¸šà¸£à¸§à¸¡',0),(562599,15628,'hi','à¤¸à¤®à¥‡à¤•à¤¿à¤¤ à¤šà¥à¤¨à¥‡à¤‚ à¤¸à¥‚à¤šà¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(562600,15628,'ms','Mencetak senarai memilih disatukan',0),(562601,15628,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ø¡ Ø§Ù„Ù…ÙˆØ­Ø¯',0),(562602,15628,'fr','Imprimer la liste consolidÃ©e',0),(562603,15628,'jp','é€£çµé¸æŠžãƒªã‚¹ãƒˆã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(562604,15628,'pt','Imprimir lista consolidada',0),(562605,15628,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÐ²Ð¾Ð´Ð½Ð¾Ð³Ð¾ ÑÐ¿Ð¸ÑÐºÐ° Ð²Ñ‹Ð±Ð¾Ñ€Ð°',0),(562606,15628,'es','Imprimir lista de selecciÃ³n consolidada',0),(562607,15628,'de','Konsolidierten Kommissionierliste drucken',0),(562608,15628,'en','Print Consolidated Pick List',0),(562609,15629,'is','',0),(562610,15629,'dr','Ú†Ø§Ù¾ Ø§Ù†ØªØ®Ø§Ø¨ ØªÙ„ÙÛŒÙ‚ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª',0),(562611,15629,'pr','Ú†Ø§Ù¾ Ø§Ù†ØªØ®Ø§Ø¨ ØªÙ„ÙÛŒÙ‚ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª',0),(562612,15629,'tr','SeÃ§im listesi seÃ§ili yazdÄ±rma konsolide',0),(562613,15629,'pl','Drukuj wybrane skonsolidowane Pick listy',0),(562614,15629,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸ ÐºÐ¾Ð½ÑÐ¾Ð»Ð¸Ð´Ð¸Ñ€Ð°Ð½ ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(562615,15629,'ur','Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº Ù…Ù†ØªØ®Ø¨ Ø¨Ú¾Ø±Ø§',0),(562616,15629,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð½ÑÐ¾Ð»Ð¸Ð´Ð¾Ð²Ð°Ð½Ð¸ Ð»Ð¸ÑÑ‚Ñƒ Ð·Ð° Ð¸Ð·Ð±Ð¾Ñ€',0),(562617,15629,'vi','In chá»n cá»§ng cá»‘ danh sÃ¡ch lá»±a chá»n',0),(562618,15629,'af','Druk die geselekteerde gekonsolideer kies lys',0),(562619,15629,'ro','Imprimare selectat consolidate Pick lista',0),(562620,15629,'et','Prindi valitud konsolideeritud noppimise loend',0),(562621,15629,'si','Natisni izbrani konsolidirani seznam',0),(562622,15629,'ba','Cetak dipilih konsolidasi memilih daftar',0),(562623,15629,'nl','Print geselecteerd geconsolideerde picklijst',0),(562624,15629,'fi','Tulosta valitut konsolidoitu poimintaluettelo',0),(562625,15629,'no','Skriv ut valgte konsolidert plukklisten',0),(562626,15629,'da','Udskriv valgt konsolideret plukliste',0),(562627,15629,'ko','ì¸ì‡„ ì„ íƒ ì„ íƒ ëª©ë¡ í†µí•©',0),(562628,15629,'he','×”×“×¤×¡×” ×©× ×‘×—×¨×• ×”×ž××•×—×“×™× ×œ×‘×—×•×¨ ×¨×©×™×ž×”',0),(562629,15629,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÎµÎ½Î¿Ï€Î¿Î¹Î·Î¼Î­Î½ÎµÏ‚ Î»Î¯ÏƒÏ„Î± ÏƒÏ…Î»Î»Î¿Î³Î®Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(562630,15629,'zh','æ‰“å°é€‰å®šåˆå¹¶é€‰å–åˆ—è¡¨',0),(562631,15629,'sv','Skriv ut markerade konsoliderade plocklistan',0),(562632,15629,'it','Stampa selezionata consolidato lista di prelievo',0),(562633,15629,'tl','',0),(562634,15629,'th','à¸žà¸´à¸¡à¸žà¹Œà¹€à¸¥à¸·à¸­à¸à¸£à¸§à¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸±à¸š',0),(562635,15629,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤®à¥à¤¦à¥à¤°à¤£ à¤šà¥à¤¨à¥‡à¤‚ à¤¸à¥‚à¤šà¥€ à¤¸à¤®à¥‡à¤•à¤¿à¤¤',0),(562636,15629,'ms','Cetak yang dipilih disatukan memilih senarai',0),(562637,15629,'ar','Ø·Ø¨Ø§Ø¹Ø© ØªØ­Ø¯ÙŠØ¯ Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ­Ø¯Ø©',0),(562638,15629,'fr','Imprimer sÃ©lectionnÃ© consolidÃ© liste de choix',0),(562639,15629,'jp','å°åˆ·é¸æŠžã—ãŸé€£çµé¸æŠžãƒªã‚¹ãƒˆ',0),(562640,15629,'pt','ImpressÃ£o selecionada lista de Pick consolidada',0),(562641,15629,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ñ… ÑÐ²Ð¾Ð´Ð½Ð¾Ð³Ð¾ ÑÐ¿Ð¸ÑÐºÐ° Ð²Ñ‹Ð±Ð¾Ñ€Ð°',0),(562642,15629,'es','ImpresiÃ³n seleccionado consolidado lista de selecciÃ³n',0),(562643,15629,'de','Drucken ausgewÃ¤hlt konsolidierte Auswahlliste',0),(562644,15629,'en','Print Selected Consolidated Pick List',0),(562645,15630,'is','',0),(562646,15630,'dr','Ú†Ø§Ù¾ Ù…Ù†ØªØ®Ø¨ Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª',0),(562647,15630,'pr','Ú†Ø§Ù¾ Ù…Ù†ØªØ®Ø¨ Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª',0),(562648,15630,'tr','SeÃ§ilen seÃ§im listesi yazdÄ±rma',0),(562649,15630,'pl','Wydrukuj wybrane listy wyboru',0),(562650,15630,'bg','ÐŸÐµÑ‡Ð°Ñ‚ Ð½Ð° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð°Ñ‚Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð·Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(562651,15630,'ur','Ù…Ù†ØªØ®Ø¨ Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª Ú†Ú¾Ø§Ù¾ÛŒÚº',0),(562652,15630,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ',0),(562653,15630,'vi','In danh sÃ¡ch Ä‘Ã£ chá»n lá»±a chá»n',0),(562654,15630,'af','Druk die geselekteerde kies lys',0),(562655,15630,'ro','Imprimare selectat culegere lista',0),(562656,15630,'et','Prindi valitud noppimise loend',0),(562657,15630,'si','Natisni izbrani seznam',0),(562658,15630,'ba','Cetak dipilih memilih daftar',0),(562659,15630,'nl','Geselecteerde picklijst afdrukken',0),(562660,15630,'fi','Tulosta valittu poimintaluettelo',0),(562661,15630,'no','Skriv ut valgte plukklisten',0),(562662,15630,'da','Udskrive valgte plukliste',0),(562663,15630,'ko','ì¸ì‡„ ì„ íƒ ì„ íƒ ëª©ë¡',0),(562664,15630,'he','×”×“×¤×¡ ×¨×©×™×ž×ª ×©× ×‘×—×¨×• ×¤×™×§',0),(562665,15630,'el','Î•ÎºÏ„ÏÏ€Ï‰ÏƒÎ· ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Ï‰Î½ Î»Î¯ÏƒÏ„Î± ÏƒÏ…Î»Î»Î¿Î³Î®Ï‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(562666,15630,'zh','æ‰“å°é€‰å®šçš„é€‰å–åˆ—è¡¨',0),(562667,15630,'sv','Skriva ut valda plocklistan',0),(562668,15630,'it','Stampa selezionata lista di prelievo',0),(562669,15630,'tl','',0),(562670,15630,'th','à¸žà¸´à¸¡à¸žà¹Œà¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸šà¸´à¸à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(562671,15630,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ à¤šà¥à¤¨à¥‡à¤‚ à¤¸à¥‚à¤šà¥€ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(562672,15630,'ms','Mencetak senarai memilih terpilih',0),(562673,15630,'ar','Ø·Ø¨Ø§Ø¹Ø© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ø¡ Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(562674,15630,'fr','Imprimer la liste de choix sÃ©lectionnÃ©s',0),(562675,15630,'jp','é¸æŠžã—ãŸé¸æŠžãƒªã‚¹ãƒˆã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(562676,15630,'pt','Imprimir a lista de selecionados',0),(562677,15630,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ ÑÐ¿Ð¸ÑÐºÐ° Ð²Ñ‹Ð±Ñ€Ð°Ð½ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ',0),(562678,15630,'es','ImpresiÃ³n seleccionado lista de selecciÃ³n',0),(562679,15630,'de','AusgewÃ¤hlten Kommissionierliste drucken',0),(562680,15630,'en','Print Selected Pick List',0),(562681,15631,'is','',0),(562682,15631,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª',0),(562683,15631,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª',0),(562684,15631,'tr','Envanter Ã§ekme listesi',0),(562685,15631,'pl','ListÄ™ pobrania zapasÃ³w',0),(562686,15631,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð·Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸',0),(562687,15631,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª',0),(562688,15631,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐ° ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(562689,15631,'vi','Danh sÃ¡ch lá»±a chá»n cá»§a hÃ ng tá»“n kho',0),(562690,15631,'af','Inventaris kies lys',0),(562691,15631,'ro','Lista de culegere stocuri',0),(562692,15631,'et','Varude noppimiste loend',0),(562693,15631,'si','Seznam komisioniranj zaloge',0),(562694,15631,'ba','Persediaan memilih daftar',0),(562695,15631,'nl','Voorraad-Picklijst',0),(562696,15631,'fi','Varaston poimintaluettelo',0),(562697,15631,'no','Plukke inventarliste',0),(562698,15631,'da','Pick lagerliste',0),(562699,15631,'ko','ìž¬ê³  ì„ íƒ ëª©ë¡',0),(562700,15631,'he','×¨×©×™×ž×ª ×ž×œ××™ ×¤×™×§',0),(562701,15631,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î£Ï…Î»Î¿Î³ÏŽÎ½ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(562702,15631,'zh','åº“å­˜é€‰å–åˆ—è¡¨',0),(562703,15631,'sv','Plocka Inventarielista',0),(562704,15631,'it','Lista di prelievo di magazzino',0),(562705,15631,'tl','',0),(562706,15631,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(562707,15631,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤šà¥à¤¨à¥‡à¤‚ à¤¸à¥‚à¤šà¥€',0),(562708,15631,'ms','Pilih senarai inventori',0),(562709,15631,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù†ØªÙ‚Ø§Ø¡ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(562710,15631,'fr','Liste de sÃ©lection de l\'inventaire',0),(562711,15631,'jp','åœ¨åº«é¸æŠžãƒªã‚¹ãƒˆ',0),(562712,15631,'pt','Lista de inventÃ¡rio',0),(562713,15631,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð²Ñ‹Ð±Ð¾Ñ€Ð° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(562714,15631,'es','Lista de selecciÃ³n de inventario',0),(562715,15631,'de','Inventar-Auswahlliste',0),(562716,15631,'en','Inventory Pick List',0),(562717,15632,'is','',0),(562718,15632,'dr','ØªÙ„ÙÛŒÙ‚ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª',0),(562719,15632,'pr','ØªÙ„ÙÛŒÙ‚ÛŒ Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª',0),(562720,15632,'tr','Konsolide edilen seÃ§im listesi',0),(562721,15632,'pl','Skonsolidowanych Pick listy',0),(562722,15632,'bg','ÐšÐ¾Ð½ÑÐ¾Ð»Ð¸Ð´Ð¸Ñ€Ð°Ð½ ÑÐ¿Ð¸ÑÑŠÐº',0),(562723,15632,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³Ø² Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª',0),(562724,15632,'sr','Ð›Ð¸ÑÑ‚Ð° ÐºÐ¾Ð½ÑÐ¾Ð»Ð¸Ð´Ð¾Ð²Ð°Ð½Ð¾ Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐ°',0),(562725,15632,'vi','Danh sÃ¡ch lá»±a chá»n há»£p nháº¥t',0),(562726,15632,'af','Gekonsolideerde kies lys',0),(562727,15632,'ro','Lista de murÄƒturi consolidate',0),(562728,15632,'et','Konsolideeritud noppimise loend',0),(562729,15632,'si','Konsolidirani seznam',0),(562730,15632,'ba','Konsolidasi memilih daftar',0),(562731,15632,'nl','Geconsolideerde picklijst',0),(562732,15632,'fi','Konsernin poimintaluettelo',0),(562733,15632,'no','Konsoliderte plukklisten',0),(562734,15632,'da','Konsolideret plukliste',0),(562735,15632,'ko','ì—°ê²°ëœ ì„ íƒ ëª©ë¡',0),(562736,15632,'he','×¨×©×™×ž×ª ××™×¡×•×£ ×ž××•×—×“',0),(562737,15632,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ ÎµÎ½Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î· Pick',0),(562738,15632,'zh','ç»¼åˆçš„é€‰å–åˆ—è¡¨',0),(562739,15632,'sv','Konsoliderad plockning lista',0),(562740,15632,'it','Elenco consolidato',0),(562741,15632,'tl','',0),(562742,15632,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸§à¸¡à¸£à¸±à¸š',0),(562743,15632,'hi','à¤¸à¤®à¥‡à¤•à¤¿à¤¤ à¤šà¤¯à¤¨ à¤¸à¥‚à¤šà¥€',0),(562744,15632,'ms','Senarai pengangkutan yang disatukan',0),(562745,15632,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø§Ù†ØªÙ‚Ø§Ø¡ Ø§Ù„Ù…ÙˆØ­Ø¯',0),(562746,15632,'fr','Liste consolidÃ©e',0),(562747,15632,'jp','é€£çµé¸æŠžãƒªã‚¹ãƒˆ',0),(562748,15632,'pt','Lista consolidada',0),(562749,15632,'ru','Ð¡Ð²Ð¾Ð´Ð½Ð¾Ð³Ð¾ ÑÐ¿Ð¸ÑÐºÐ°',0),(562750,15632,'es','Lista de selecciÃ³n consolidada',0),(562751,15632,'de','Konsolidierten Auswahlliste',0),(562752,15632,'en','Consolidated Pick List',0),(562753,15633,'is','',0),(562754,15633,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø³ÙØ§Ø±Ø´ Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª',0),(562755,15633,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø³ÙØ§Ø±Ø´ Ø§Ù†ØªØ®Ø§Ø¨ Ù„ÛŒØ³Øª',0),(562756,15633,'tr','Stok sipariÅŸi seÃ§im listesi',0),(562757,15633,'pl','Inwentaryzacji zamÃ³wienia Pick listy',0),(562758,15633,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð·Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð°ÑÐ¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°',0),(562759,15633,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø­Ú©Ù… Ø§Ù†ØªØ®Ø§Ø¨ ÙÛØ±Ø³Øª',0),(562760,15633,'sr','Ð›Ð¸ÑÑ‚Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐ° ÑÐ° Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(562761,15633,'vi','Danh sÃ¡ch lá»±a chá»n tráº­t tá»± hÃ ng tá»“n kho',0),(562762,15633,'af','Voorraad bestelling kies lys',0),(562763,15633,'ro','ListÄƒ de culegere stocuri comandÄƒ',0),(562764,15633,'et','Varude noppimise loend',0),(562765,15633,'si','Seznam komisioniranj zaloge naroÄilo',0),(562766,15633,'ba','Persediaan Order memilih daftar',0),(562767,15633,'nl','Order Pick inventarislijst',0),(562768,15633,'fi','Varaston tilaa poimintaluettelo',0),(562769,15633,'no','Lager plukklisten',0),(562770,15633,'da','Bestil Pick lagerliste',0),(562771,15633,'ko','ìž¬ê³  ìˆœì„œ ì„ íƒ ëª©ë¡',0),(562772,15633,'he','×¨×©×™×ž×ª ×ž×œ××™ ×¡×“×¨ ×¤×™×§',0),(562773,15633,'el','ÎšÎ±Ï„Î¬Î»Î¿Î³Î¿Ï‚ Î£Ï…Î»Î¿Î³ÏŽÎ½ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±',0),(562774,15633,'zh','åº“å­˜è®¢å•é€‰å–åˆ—è¡¨',0),(562775,15633,'sv','Inventarielista fÃ¶r plockning',0),(562776,15633,'it','Lista di prelievo ordine di inventario',0),(562777,15633,'tl','',0),(562778,15633,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(562779,15633,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤•à¥à¤°à¤® à¤šà¥à¤¨à¥‡à¤‚ à¤¸à¥‚à¤šà¥€',0),(562780,15633,'ms','Senarai pengambilan pesanan inventori',0),(562781,15633,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø§Ø®ØªÙŠØ§Ø± Ø£Ù…Ø± Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(562782,15633,'fr','L\'inventaire ordre liste de sÃ©lection',0),(562783,15633,'jp','åœ¨åº«æ³¨æ–‡é¸æŠžãƒªã‚¹ãƒˆ',0),(562784,15633,'pt','Lista de opÃ§Ãµes de ordem de inventÃ¡rio',0),(562785,15633,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð²Ñ‹Ð±Ð¾Ñ€Ð° Ð¿Ð¾Ñ€ÑÐ´ÐºÐ° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(562786,15633,'es','Lista de selecciÃ³n de orden de inventario',0),(562787,15633,'de','Pick-Bestellliste Warenbestand',0),(562788,15633,'en','Inventory Order Pick List',0),(562789,15634,'is','',0),(562790,15634,'dr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± BOM ØªØ¹Ø±ÛŒÙ',0),(562791,15634,'pr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± BOM ØªØ¹Ø±ÛŒÙ',0),(562792,15634,'tr','ÃœrÃ¼n ReÃ§etesi tanÄ±mÄ±nÄ± Kaydet',0),(562793,15634,'pl','Zapisz siÄ™ do definicji BOM',0),(562794,15634,'bg','Ð—Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÐšÐ˜ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ',0),(562795,15634,'ur','Ø¨Ø§Ù… Ú©ÛŒ ØªØ¹Ø±ÛŒÙ Ú©Û’ Ù„Ø¦Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(562796,15634,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ñƒ Ð¡Ð°ÑÑ‚Ð°Ð²Ð½Ð¸Ñ†Ð¸ Ð´ÐµÑ„Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð°',0),(562797,15634,'vi','Tiáº¿t kiá»‡m Ä‘á»‹nh nghÄ©a BOM',0),(562798,15634,'af','Stoor na BOM definisie',0),(562799,15634,'ro','SalvaÅ£i definiÅ£ia LM',0),(562800,15634,'et','Koosluse mÃ¤Ã¤ratluse salvestada',0),(562801,15634,'si','Shranite definicijo Kosovnice',0),(562802,15634,'ba','Simpan ke definisi BOM',0),(562803,15634,'nl','Opslaan met BOM definitie',0),(562804,15634,'fi','Tallenna Tuoterakenteen mÃ¤Ã¤ritelmÃ¤',0),(562805,15634,'no','Lagre stykklistedefinisjonen',0),(562806,15634,'da','Gem BOM definition',0),(562807,15634,'ko','BOM ì •ì˜ì— ì €ìž¥',0),(562808,15634,'he','×œ×©×ž×•×¨ ××ª ×”×’×“×¨×ª ×”-BOM',0),(562809,15634,'el','Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· ÏƒÎµ Ï„ÎµÏ‡Î½Î¹ÎºÎ® Ï€ÏÎ¿Î´Î¹Î±Î³ÏÎ±Ï†Î® Î¿ÏÎ¹ÏƒÎ¼ÏŒ',0),(562810,15634,'zh','å°†ä¿å­˜åˆ° BOM å®šä¹‰',0),(562811,15634,'sv','Spara till BOM Definition',0),(562812,15634,'it','Salvare in BOM definizione',0),(562813,15634,'tl','',0),(562814,15634,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸„à¸³à¸ˆà¸³à¸à¸±à¸”à¸„à¸§à¸²à¸¡à¸‚à¸­à¸‡ BOM',0),(562815,15634,'hi','BOM à¤ªà¤°à¤¿à¤­à¤¾à¤·à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(562816,15634,'ms','Simpan ke definisi BOM',0),(562817,15634,'ar','Ø­ÙØ¸ ØªØ¹Ø±ÙŠÙ Ø´Ø¬Ø±Ø© Ø§Ù„Ù…ÙˆØ§Ø¯',0),(562818,15634,'fr','Enregistrer dans la dÃ©finition de la nomenclature',0),(562819,15634,'jp','BOM å®šç¾©ã«ä¿å­˜ã—ã¾ã™ã€‚',0),(562820,15634,'pt','Salve a definiÃ§Ã£o de BOM',0),(562821,15634,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ ÑÐ¿ÐµÑ†Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(562822,15634,'es','Guardar en la definiciÃ³n de BOM',0),(562823,15634,'de','BOM-Definition speichern',0),(562824,15634,'en','Save To BOM Definition',0),(562825,15635,'is','',0),(562826,15635,'dr','Ø¨ÛŒÙ…Ø§Ø± Ø³Ø§Ø¹Øª Ø¨ÛŒØ´ Ø§Ø² Ø²Ù…Ø§Ù† Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÛŒÙ…Ø§Ø±',0),(562827,15635,'pr','Ø¨ÛŒÙ…Ø§Ø± Ø³Ø§Ø¹Øª Ø¨ÛŒØ´ Ø§Ø² Ø²Ù…Ø§Ù† Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ø¨ÛŒÙ…Ø§Ø±',0),(562828,15635,'tr','Hasta saat kullanÄ±labilir hasta zamanÄ± aÅŸan',0),(562829,15635,'pl','Chory godzin przekracza dostÄ™pnego czasu chory',0),(562830,15635,'bg','Ð‘Ð¾Ð»Ð½Ð¸ Ñ‡Ð°ÑÐ° Ð½Ð°Ð´Ð²Ð¸ÑˆÐ°Ð²Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¾Ñ‚Ð¾ Ð±Ð¾Ð»Ð½Ð¸ Ð²Ñ€ÐµÐ¼Ðµ',0),(562831,15635,'ur','Ø¨ÛŒÙ…Ø§Ø± Ú¯Ú¾Ù†Ù¹Û’ Ø¯Ø³ØªÛŒØ§Ø¨ Ø¨ÛŒÙ…Ø§Ø± ÙˆÙ‚Øª Ø³Û’ ØªØ¬Ø§ÙˆØ²',0),(562832,15635,'sr','Ð‘Ð¾Ð»ÐµÑÐ½Ð° ÑÐ°Ñ‚Ð¸ Ð¿Ñ€ÐµÐ¼Ð°ÑˆÐ¸Ñ‚Ð¸ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½ Ð±Ð¾Ð»Ð¾Ð²Ð°ÑšÐµ',0),(562833,15635,'vi','Giá» bá»‡nh vÆ°á»£t quÃ¡ thá»i gian bá»‹ bá»‡nh cÃ³ sáºµn',0),(562834,15635,'af','Siek uur oorskry beskikbare siek tyd',0),(562835,15635,'ro','Bolnav de ore sÄƒ depÄƒÅŸeascÄƒ timpul disponibil bolnav',0),(562836,15635,'et','Haige tundi pikem saadaval haige aeg',0),(562837,15635,'si','Bolan Äas presega na voljo odsotnost z dela',0),(562838,15635,'ba','Jam sakit melebihi waktu sakit yang tersedia',0),(562839,15635,'nl','Zieke uur overschrijden beschikbaar ziektedagen',0),(562840,15635,'fi','Sairas tuntia yli saatavilla sairasloma',0),(562841,15635,'no','Syk timer overskrider tilgjengelig sykefravÃ¦r',0),(562842,15635,'da','Syg timer overstiger tilgÃ¦ngelige syg tid',0),(562843,15635,'ko','ì•„í”ˆ ì‹œê°„ ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” ë³‘ê°€ ì´ˆê³¼',0),(562844,15635,'he','×—×•×œ×” ×©×¢×•×ª ×™×¢×œ×” ×¢×œ ×–×ž×Ÿ ×¤× ×•×™ ×—×•×œ×”',0),(562845,15635,'el','Î†ÏÏÏ‰ÏƒÏ„Î¿Ï‚ ÏŽÏÎµÏ‚ Ï…Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ Ï„Î¿ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î¿ Ï‡ÏÏŒÎ½Î¿ Î¬ÏÏÏ‰ÏƒÏ„Î¿Ï‚',0),(562846,15635,'zh','ç”Ÿç—…çš„æ—¶é—´è¶…è¿‡å¯ç”¨ç”Ÿç—…çš„æ—¶å€™',0),(562847,15635,'sv','Sjuk arbetstiden Ã¶verstiger tillgÃ¤nglig sjuk tid',0),(562848,15635,'it','Ore malati superare disponibile tempo ammalato',0),(562849,15635,'tl','',0),(562850,15635,'th','à¹€à¸§à¸¥à¸²à¸›à¹ˆà¸§à¸¢à¹€à¸à¸´à¸™à¹€à¸§à¸¥à¸²à¸›à¹ˆà¸§à¸¢',0),(562851,15635,'hi','à¤¬à¥€à¤®à¤¾à¤° à¤˜à¤‚à¤Ÿà¥‡ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¬à¥€à¤®à¤¾à¤° à¤¸à¤®à¤¯ à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(562852,15635,'ms','Jam sakit melebihi masa sakit yang disediakan',0),(562853,15635,'ar','Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ù…Ø±Ø¶Ù‰ ÙŠØªØ¬Ø§ÙˆØ² Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ù…ØªØ§Ø­ Ø§Ù„Ù…Ø±Ø¶Ù‰',0),(562854,15635,'fr','La durÃ©e de malade dÃ©passer congÃ©s disponibles',0),(562855,15635,'jp','ç—…æ°—ã®æ™‚é–“ã‚’è¶…ãˆã‚‹åˆ©ç”¨å¯èƒ½ãªç—…æ¬ ',0),(562856,15635,'pt','Doentes horas excederem o tempo disponÃ­vel do doente',0),(562857,15635,'ru','Ð‘Ð¾Ð»ÑŒÐ½Ð¾Ð¹ Ñ‡Ð°ÑÐ¾Ð² Ð¿Ñ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ Ð¸Ð¼ÐµÑŽÑ‰Ð¸ÐµÑÑ Ð±Ð¾Ð»ÑŒÐ½Ð¾Ðµ Ð²Ñ€ÐµÐ¼Ñ',0),(562858,15635,'es','Horas enfermamos exceda el tiempo enfermo',0),(562859,15635,'de','Krank StundennichtÃ¼berschreiten verfÃ¼gbaren Krankentage',0),(562860,15635,'en','Sick Hours Exceed Available Sick Time',0),(562861,15636,'is','',0),(562862,15636,'dr','ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø³Ø§Ø¹Øª Ø¨ÛŒØ´ Ø§Ø² Ø²Ù…Ø§Ù† ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø¯Ø± Ø¯Ø³ØªØ±Ø³',0),(562863,15636,'pr','ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø³Ø§Ø¹Øª Ø¨ÛŒØ´ Ø§Ø² Ø²Ù…Ø§Ù† ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø¯Ø± Ø¯Ø³ØªØ±Ø³',0),(562864,15636,'tr','Tatil saatleri mevcut tatil zamanÄ± aÅŸan',0),(562865,15636,'pl','Godziny urlopu przekracza dostÄ™pne urlopu',0),(562866,15636,'bg','Ð’Ð°ÐºÐ°Ð½Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ñ‡Ð°ÑÐ° Ð½Ð°Ð´Ñ…Ð²ÑŠÑ€Ð»ÑÑ‚ Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸Ñ‚Ðµ Ð²Ð°ÐºÐ°Ð½Ñ†Ð¸Ñ Ð²Ñ€ÐµÐ¼Ðµ',0),(562867,15636,'ur','Ú†Ú¾Ù¹ÛŒ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª Ø¯Ø³ØªÛŒØ§Ø¨ Ú†Ú¾Ù¹ÛŒ Ú©Û’ Ø§ÙˆÙ‚Ø§Øª Ú©ÛŒ Ø­Ø¯ Ø³Û’ ØªØ¬Ø§ÙˆØ²',0),(562868,15636,'sr','Ð¡Ð°Ñ‚Ð¸ Ð¾Ð´Ð¼Ð¾Ñ€Ð° Ð¿Ñ€ÐµÐ¼Ð°ÑˆÑƒÑ˜Ðµ Ñ€Ð°ÑÐ¿Ð¾Ð»Ð¾Ð¶Ð¸Ð²Ð¸ Ð¾Ð´Ð¼Ð¾Ñ€',0),(562869,15636,'vi','Vacation giá» vÆ°á»£t quÃ¡ thá»i gian nghá»‰ cÃ³ sáºµn',0),(562870,15636,'af','Vakansie-ure oorskry beskikbare vakansie tyd',0),(562871,15636,'ro','Vacanta ore depÄƒÅŸeÅŸte timpul disponibil vacanta',0),(562872,15636,'et','Puhkusetunde Ã¼letada saadaval puhkuse ajal',0),(562873,15636,'si','PoÄitnice Äas presega Äas poÄitnic na voljo',0),(562874,15636,'ba','Liburan jam melebihi waktu liburan tersedia',0),(562875,15636,'nl','Vakantie-uren overschrijden beschikbaar vakantietijd',0),(562876,15636,'fi','Lomatunteja ylittÃ¤Ã¤ kÃ¤ytettÃ¤vissÃ¤ loma-aikaa',0),(562877,15636,'no','Ferietimer overskrider tilgjengelig ferie',0),(562878,15636,'da','Ferietimer overstiger tilgÃ¦ngelige ferietid',0),(562879,15636,'ko','ì‚¬ìš©í•  ìˆ˜ ìžˆëŠ” íœ´ê°€ ì‹œê°„ì„ ì´ˆê³¼ í•˜ëŠ” íœ´ê°€ ì‹œê°„',0),(562880,15636,'he','×©×¢×•×ª ×—×•×¤×©×” ×™×¢×œ×” ×¢×œ ×–×ž×Ÿ ×—×•×¤×©×” ×–×ž×™×Ÿ',0),(562881,15636,'el','Î¥Ï€ÎµÏÎ²Î±Î¯Î½ÎµÎ¹ Ï„Î¹Ï‚ Î´Î¹Î±ÎºÎ¿Ï€Î­Ï‚ Î´Î¹Î±ÎºÎ¿Ï€Î­Ï‚ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î¿ Ï‡ÏÏŒÎ½Î¿',0),(562882,15636,'zh','ä¼‘å‡å°æ—¶æ•°è¶…è¿‡å¯ç”¨å‡æœŸæ—¶é—´',0),(562883,15636,'sv','Semester arbetstiden Ã¶verstiger tillgÃ¤nglig semestertid',0),(562884,15636,'it','Ore di ferie superano il tempo di vacanza disponibili',0),(562885,15636,'tl','',0),(562886,15636,'th','à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¸§à¸±à¸™à¸«à¸¢à¸¸à¸”à¹€à¸à¸´à¸™à¹€à¸§à¸¥à¸²à¸¡à¸µà¸§à¸±à¸™à¸«à¸¢à¸¸à¸”',0),(562887,15636,'hi','à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤›à¥à¤Ÿà¥à¤Ÿà¥€ à¤•à¥‡ à¤¸à¤®à¤¯ à¤›à¥à¤Ÿà¥à¤Ÿà¥€ à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¥‡ à¤…à¤§à¤¿à¤•',0),(562888,15636,'ms','Waktu cuti melebihi cuti yang disediakan',0),(562889,15636,'ar','ÙŠØªØ¬Ø§ÙˆØ² Ø¹Ø¯Ø¯ Ø³Ø§Ø¹Ø§Øª Ø¹Ø·Ù„Ø© Ø§Ù„Ø¥Ø¬Ø§Ø²Ø§Øª Ø§Ù„Ù…ØªØ§Ø­Ø©',0),(562890,15636,'fr','Heures d\'absence dÃ©passent le temps de vacances disponibles',0),(562891,15636,'jp','ä¼‘æš‡æ™‚é–“ã‚’è¶…ãˆã‚‹åˆ©ç”¨å¯èƒ½ãªä¼‘æš‡æ™‚é–“',0),(562892,15636,'pt','Horas de fÃ©rias excederem o tempo de fÃ©rias disponÃ­veis',0),(562893,15636,'ru','Ð§Ð°ÑÑ‹ Ð¾Ñ‚Ð¿ÑƒÑÐºÐ° Ð¿Ñ€ÐµÐ²Ñ‹ÑˆÐ°ÐµÑ‚ Ð¸Ð¼ÐµÑŽÑ‰Ð¸ÐµÑÑ Ð¾Ñ‚Ð¿ÑƒÑÐº',0),(562894,15636,'es','Horas de vacaciones exceden el tiempo de vacaciones disponibles',0),(562895,15636,'de','Urlaubsstunden Ã¼berschreiten verfÃ¼gbar Urlaubszeiten',0),(562896,15636,'en','Vacation Hours Exceed Available Vacation Time',0),(562897,15637,'is','',0),(562898,15637,'dr','Ø³Ø¹ÛŒ Ù…Ø¬Ø¯Ø¯',0),(562899,15637,'pr','Ø³Ø¹ÛŒ Ù…Ø¬Ø¯Ø¯',0),(562900,15637,'tr','Yeniden deneme',0),(562901,15637,'pl','PonÃ³w prÃ³bÄ™',0),(562902,15637,'bg','ÐžÐ¿Ð¸Ñ‚Ð°Ð¹ Ð¾Ñ‚Ð½Ð¾Ð²Ð¾',0),(562903,15637,'ur','Ù¾Ú¾Ø± Ú©ÙˆØ´Ø´ Ú©Ø±ÛŒÚº',0),(562904,15637,'sr','ÐŸÐ¾ÐºÑƒÑˆÐ°Ñ˜ Ð¾Ð¿ÐµÑ‚',0),(562905,15637,'vi','Thá»­ láº¡i',0),(562906,15637,'af','Probeer weer',0),(562907,15637,'ro','ÃŽncercaÈ›i din nou',0),(562908,15637,'et','Proovi uuesti',0),(562909,15637,'si','Poskusi znova',0),(562910,15637,'ba','Coba lagi',0),(562911,15637,'nl','Opnieuw proberen',0),(562912,15637,'fi','YritÃ¤ uudelleen',0),(562913,15637,'no','PrÃ¸v pÃ¥ nytt',0),(562914,15637,'da','Efter flere forsÃ¸g',0),(562915,15637,'ko','ë‹¤ì‹œ ì‹œë„',0),(562916,15637,'he','× ×¡×” ×©× ×™×ª',0),(562917,15637,'el','\"Î•Ï€Î±Î½Î¬Î»Î·ÏˆÎ·\"',0),(562918,15637,'zh','é‡è¯•',0),(562919,15637,'sv','FÃ¶rsÃ¶k igen',0),(562920,15637,'it','Riprova',0),(562921,15637,'tl','',0),(562922,15637,'th','à¸¥à¸­à¸‡à¸­à¸µà¸à¸„à¸£à¸±à¹‰à¸‡',0),(562923,15637,'hi','à¤ªà¥à¤¨: à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚',0),(562924,15637,'ms','Cuba semula',0),(562925,15637,'ar','Ø¥Ø¹Ø§Ø¯Ø© Ø§Ù„Ù…Ø­Ø§ÙˆÙ„Ø©',0),(562926,15637,'fr','Nouvelle tentative',0),(562927,15637,'jp','å†è©¦è¡Œ',0),(562928,15637,'pt','Tente novamente',0),(562929,15637,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€',0),(562930,15637,'es','Vuelva a intentarlo',0),(562931,15637,'de','\"Wiederholen\"',0),(562932,15637,'en','Retry',0),(562933,15638,'is','',0),(562934,15638,'dr','Ø´ØºÙ„ Ø¨Ù‡ Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ',0),(562935,15638,'pr','Ø´ØºÙ„ Ø¨Ù‡ Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ',0),(562936,15638,'tr','Ä°ÅŸ toplam maliyeti',0),(562937,15638,'pl','Razem koszty zleceÅ„',0),(562938,15638,'bg','ÐžÐ±Ñ‰Ð°Ñ‚Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(562939,15638,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ Ú©Ù„ Ù‚ÛŒÙ…Øª',0),(562940,15638,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð¿Ð¾ÑÐ»Ð°',0),(562941,15638,'vi','Viá»‡c lÃ m chi phÃ­ tá»•ng cá»™ng',0),(562942,15638,'af','Werk kos totaal',0),(562943,15638,'ro','Job costÄƒ Total',0),(562944,15638,'et','TÃ¶Ã¶ maksab kokku',0),(562945,15638,'si','Projektni stroÅ¡ki skupaj',0),(562946,15638,'ba','Pekerjaan biaya Total',0),(562947,15638,'nl','Totaal projectkosten',0),(562948,15638,'fi','Projektin kustannusten yhteensÃ¤',0),(562949,15638,'no','Jobben koster totalt',0),(562950,15638,'da','Job koster i alt',0),(562951,15638,'ko','ìž‘ì—… ë¹„ìš© í•©ê³„',0),(562952,15638,'he','×”×¢×‘×•×“×” ×¢×•×œ×” ×¡×”',0),(562953,15638,'el','Î£ÏÎ½Î¿Î»Î¿ ÎµÎ¾ÏŒÎ´Ï‰Î½ Î­ÏÎ³Î¿Ï…',0),(562954,15638,'zh','ä½œä¸šæˆæœ¬æ€»é¢',0),(562955,15638,'sv','Jobb kostar totalt',0),(562956,15638,'it','Lavoro costa totale',0),(562957,15638,'tl','',0),(562958,15638,'th','à¸£à¸§à¸¡à¸•à¹‰à¸™à¸—à¸¸à¸™à¸‡à¸²à¸™',0),(562959,15638,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥€ à¤•à¥à¤² à¤²à¤¾à¤—à¤¤',0),(562960,15638,'ms','Kerja bayaran jumlah',0),(562961,15638,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© ØªØ¨Ù„Øº Ø¥Ø¬Ù…Ø§Ù„ÙŠ',0),(562962,15638,'fr','Travail coÃ»te au Total',0),(562963,15638,'jp','ä»•äº‹ã®è²»ç”¨åˆè¨ˆ',0),(562964,15638,'pt','Total de custos de trabalho',0),(562965,15638,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾ Ñ†ÐµÐ½Ðµ Ð²ÑÐµÐ³Ð¾',0),(562966,15638,'es','Trabajo Costo Total',0),(562967,15638,'de','Job kostet insgesamt',0),(562968,15638,'en','Job Costs Total',0),(562969,15639,'is','',0),(562970,15639,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù†ÛŒØ±ÙˆÛŒ Ú©Ø§Ø±',0),(562971,15639,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù†ÛŒØ±ÙˆÛŒ Ú©Ø§Ø±',0),(562972,15639,'tr','Emek toplam maliyeti',0),(562973,15639,'pl','Razem koszty pracy',0),(562974,15639,'bg','ÐžÐ±Ñ‰Ð¾ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ñ‚Ñ€ÑƒÐ´',0),(562975,15639,'ur','Ù…Ø´Ù‚Øª Ú©ÛŒ Ú©Ù„ Ù‚ÛŒÙ…Øª',0),(562976,15639,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¾ÑÐ¾Ð±Ñ™Ðµ Ð¿Ñ€ÐµÑÐºÑƒÐ¿Ð¾',0),(562977,15639,'vi','Tá»•ng sá»‘ chi phÃ­ lao Ä‘á»™ng',0),(562978,15639,'af','Arbeid totale koste',0),(562979,15639,'ro','Cheltuieli de salarizare Ã®n Total',0),(562980,15639,'et','Palgakulu kokku',0),(562981,15639,'si','Dela stroÅ¡kov skupaj',0),(562982,15639,'ba','Total biaya tenaga kerja',0),(562983,15639,'nl','Totaal van de arbeidskosten',0),(562984,15639,'fi','TyÃ¶voimakustannukset yhteensÃ¤',0),(562985,15639,'no','LÃ¸nnskostnader totalt',0),(562986,15639,'da','Labor omkostninger i alt',0),(562987,15639,'ko','ë…¸ë™ ë¹„ìš© í•©ê³„',0),(562988,15639,'he','×¡×” ×› ×¢×œ×•×™×•×ª ×”×¢×‘×•×“×”',0),(562989,15639,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ ÎºÏŒÏƒÏ„Î· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(562990,15639,'zh','äººå·¥æˆæœ¬æ€»é¢',0),(562991,15639,'sv','Labor kostar totalt',0),(562992,15639,'it','I costi della manodopera totale',0),(562993,15639,'tl','',0),(562994,15639,'th','à¸£à¸§à¸¡à¸„à¹ˆà¸²à¹à¸£à¸‡à¸‡à¸²à¸™',0),(562995,15639,'hi','à¤¶à¥à¤°à¤® à¤•à¥€ à¤•à¥à¤² à¤²à¤¾à¤—à¤¤',0),(562996,15639,'ms','Jumlah kos buruh',0),(562997,15639,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø¹Ù…Ø§Ù„Ø©',0),(562998,15639,'fr','Total des coÃ»ts du travail',0),(562999,15639,'jp','äººä»¶è²»åˆè¨ˆ',0),(563000,15639,'pt','Total de custos trabalhistas',0),(563001,15639,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‡ÑƒÑŽ ÑÐ¸Ð»Ñƒ',0),(563002,15639,'es','Total costos mano de obra',0),(563003,15639,'de','Arbeitskosten insgesamt',0),(563004,15639,'en','Labor Costs Total',0),(563005,15640,'is','',0),(563006,15640,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(563007,15640,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(563008,15640,'tr','SatÄ±cÄ± toplam maliyeti',0),(563009,15640,'pl','Dostawcy koszty caÅ‚kowite',0),(563010,15640,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¾Ð±Ñ‰Ð¾',0),(563011,15640,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÛŒ Ú©Ù„ Ù‚ÛŒÙ…Øª',0),(563012,15640,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(563013,15640,'vi','NhÃ  cung cáº¥p chi phÃ­ táº¥t cáº£',0),(563014,15640,'af','Handelaar koste totaal',0),(563015,15640,'ro','Furnizor costurile totale',0),(563016,15640,'et','Hankija maksab kokku',0),(563017,15640,'si','Prodajalec stroÅ¡ki skupaj',0),(563018,15640,'ba','Penjual biaya Total',0),(563019,15640,'nl','Leverancier kosten totaal',0),(563020,15640,'fi','Toimittajan kustannukset yhteensÃ¤',0),(563021,15640,'no','LeverandÃ¸ren kostnader totalt',0),(563022,15640,'da','Kreditor omkostninger i alt',0),(563023,15640,'ko','ê³µê¸‰ ì—…ì²´ ë¹„ìš© í•©ê³„',0),(563024,15640,'he','×¡×” ×› ×¢×œ×•×™×•×ª ×”×¡×¤×§',0),(563025,15640,'el','Î£ÏÎ½Î¿Î»Î¿ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(563026,15640,'zh','ä¾›åº”å•†æˆæœ¬æ€»é¢',0),(563027,15640,'sv','LeverantÃ¶rens kostnader totalt',0),(563028,15640,'it','Totale costi fornitore',0),(563029,15640,'tl','',0),(563030,15640,'th','à¸£à¸§à¸¡à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(563031,15640,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥à¤² à¤²à¤¾à¤—à¤¤',0),(563032,15640,'ms','Jumlah keseluruhan kos Penjual',0),(563033,15640,'ar','Ù…Ø¬Ù…ÙˆØ¹ ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ù…ÙˆØ±Ø¯',0),(563034,15640,'fr','Total des coÃ»ts du vendeur',0),(563035,15640,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®ã‚³ã‚¹ãƒˆåˆè¨ˆ',0),(563036,15640,'pt','Total de custos do fornecedor',0),(563037,15640,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(563038,15640,'es','Total de costos de proveedores',0),(563039,15640,'de','Hersteller Kosten Total',0),(563040,15640,'en','Vendor Costs Total',0),(563041,15641,'is','',0),(563042,15641,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù†ÛŒØ±ÙˆÛŒ Ú©Ø§Ø±',0),(563043,15641,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù†ÛŒØ±ÙˆÛŒ Ú©Ø§Ø±',0),(563044,15641,'tr','IÅŸgÃ¼cÃ¼ maliyeti',0),(563045,15641,'pl','Koszty pracy',0),(563046,15641,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ñ‚Ñ€ÑƒÐ´',0),(563047,15641,'ur','Ù…Ø²Ø¯ÙˆØ± Ú©Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(563048,15641,'sr','ÐžÑÐ¾Ð±Ñ™Ðµ Ð¿Ñ€ÐµÑÐºÑƒÐ¿Ð¾',0),(563049,15641,'vi','Chi phÃ­ lao Ä‘á»™ng',0),(563050,15641,'af','Labor koste',0),(563051,15641,'ro','Costurile forÅ£ei de muncÄƒ',0),(563052,15641,'et','Palk, sotsiaalmaksud',0),(563053,15641,'si','Dela stroÅ¡kov',0),(563054,15641,'ba','Biaya tenaga kerja',0),(563055,15641,'nl','Arbeidskosten',0),(563056,15641,'fi','TyÃ¶voimakustannukset',0),(563057,15641,'no','LÃ¸nnskostnader',0),(563058,15641,'da','Labor omkostninger',0),(563059,15641,'ko','ë…¸ë™ ë¹„ìš©',0),(563060,15641,'he','×¢×œ×•×™×•×ª ×”×¢×‘×•×“×”',0),(563061,15641,'el','Î¤Î± ÎºÏŒÏƒÏ„Î· ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(563062,15641,'zh','åŠ³åŠ¨åŠ›æˆæœ¬',0),(563063,15641,'sv','Labor kostnader',0),(563064,15641,'it','Costi della manodopera',0),(563065,15641,'tl','',0),(563066,15641,'th','à¸„à¹ˆà¸²à¹à¸£à¸‡à¸‡à¸²à¸™',0),(563067,15641,'hi','à¤¶à¥à¤°à¤® à¤²à¤¾à¤—à¤¤',0),(563068,15641,'ms','Kos buruh',0),(563069,15641,'ar','ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø¹Ù…Ù„',0),(563070,15641,'fr','CoÃ»ts de main d\'oeuvre',0),(563071,15641,'jp','åŠ´åƒã‚³ã‚¹ãƒˆ',0),(563072,15641,'pt','Custos trabalhistas',0),(563073,15641,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð½Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñƒ Ñ‚Ñ€ÑƒÐ´Ð°',0),(563074,15641,'es','Costos de mano de obra',0),(563075,15641,'de','Lohnkosten',0),(563076,15641,'en','Labor Costs',0),(563077,15642,'is','',0),(563078,15642,'dr','Ù…Ù‚ÛŒØ§Ø³',0),(563079,15642,'pr','Ù…Ù‚ÛŒØ§Ø³',0),(563080,15642,'tr','Ã–lÃ§ek',0),(563081,15642,'pl','Skali',0),(563082,15642,'bg','ÐœÐ°Ñ‰Ð°Ð±',0),(563083,15642,'ur','Ù¾ÛŒÙ…Ø§Ù†Û',0),(563084,15642,'sr','Ð¡ÐºÐ°Ð»Ð°',0),(563085,15642,'vi','Quy mÃ´',0),(563086,15642,'af','Skaal',0),(563087,15642,'ro','ScarÄƒ',0),(563088,15642,'et','Skaala',0),(563089,15642,'si','Obsega',0),(563090,15642,'ba','Skala',0),(563091,15642,'nl','Schaal',0),(563092,15642,'fi','Asteikko',0),(563093,15642,'no','Skala',0),(563094,15642,'da','Skala',0),(563095,15642,'ko','ê·œëª¨',0),(563096,15642,'he','×¡×•×œ×',0),(563097,15642,'el','ÎšÎ»Î¯Î¼Î±ÎºÎ±',0),(563098,15642,'zh','è§„æ¨¡',0),(563099,15642,'sv','Skala',0),(563100,15642,'it','Scala',0),(563101,15642,'tl','',0),(563102,15642,'th','à¸¡à¸²à¸•à¸£à¸²à¸ªà¹ˆà¸§à¸™',0),(563103,15642,'hi','à¤¸à¥à¤•à¥‡à¤²',0),(563104,15642,'ms','Skala',0),(563105,15642,'ar','Ù…Ù‚ÙŠØ§Ø³',0),(563106,15642,'fr','Ã‰chelle',0),(563107,15642,'jp','ã‚¹ã‚±ãƒ¼ãƒ«',0),(563108,15642,'pt','Escala',0),(563109,15642,'ru','Ð¨ÐºÐ°Ð»Ð°',0),(563110,15642,'es','Escala',0),(563111,15642,'de','Skala',0),(563112,15642,'en','Scale',0),(563113,15643,'is','',0),(563114,15643,'dr','Ù‡Ù…ÛŒØ´Ù‡ Ø¯ÙˆØ±',0),(563115,15643,'pr','Ù‡Ù…ÛŒØ´Ù‡ Ø¯ÙˆØ±',0),(563116,15643,'tr','Her zaman aÅŸaÄŸÄ± yuvarlama',0),(563117,15643,'pl','Zawsze zaokrÄ…glane w',0),(563118,15643,'bg','Ð’Ð¸Ð½Ð°Ð³Ð¸ Ð·Ð°ÐºÑ€ÑŠÐ³Ð»Ð¸ Ð½Ð°Ð´Ð¾Ð»Ñƒ',0),(563119,15643,'ur','ÛÙ…ÛŒØ´Û Ú¯ÙˆÙ„',0),(563120,15643,'sr','Ð£Ð²ÐµÐº Ð·Ð°Ð¾ÐºÑ€ÑƒÐ¶Ð¸Ñ‚Ðµ',0),(563121,15643,'vi','LuÃ´n luÃ´n vÃ²ng',0),(563122,15643,'af','Altyd rond',0),(563123,15643,'ro','ÃŽntotdeauna rotunjiÅ£i prin',0),(563124,15643,'et','Alati Ã¼mardada',0),(563125,15643,'si','Vedno zaokroÅ¾iti navzdol',0),(563126,15643,'ba','Selalu putaran',0),(563127,15643,'nl','Altijd naar beneden afronden',0),(563128,15643,'fi','Aina alaspÃ¤in',0),(563129,15643,'no','Alltid vil runde ned',0),(563130,15643,'da','Altid vil runde',0),(563131,15643,'ko','í•­ìƒ ë¼ìš´ë“œ',0),(563132,15643,'he','×œ×¢×’×œ ×ª×ž×™×“ ×›×œ×¤×™ ×ž×˜×”',0),(563133,15643,'el','Î£Ï„ÏÎ¿Î³Î³Ï…Î»Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï€Î¬Î½Ï„Î± Ï€ÏÎ¿Ï‚ Ï„Î± ÎºÎ¬Ï„Ï‰',0),(563134,15643,'zh','æ€»æ˜¯å‘ä¸‹èˆå…¥',0),(563135,15643,'sv','Alltid avrunda nedÃ¥t',0),(563136,15643,'it','Sempre arrotondare',0),(563137,15643,'tl','',0),(563138,15643,'th','à¸›à¸±à¸”à¹€à¸¨à¸©à¸¥à¸‡à¹€à¸ªà¸¡à¸­',0),(563139,15643,'hi','à¤¹à¤®à¥‡à¤¶à¤¾ à¤°à¤¾à¤‰à¤‚à¤¡ à¤¡à¤¾à¤‰à¤¨',0),(563140,15643,'ms','Sentiasa pusingan ke bawah',0),(563141,15643,'ar','Ø¬ÙˆÙ„Ø© Ø¯Ø§Ø¦Ù…Ø§Ù‹ Ø¥Ù„Ù‰ Ø£Ø³ÙÙ„',0),(563142,15643,'fr','Toujours arrondir',0),(563143,15643,'jp','å¸¸ã«ä¸¸ã„ãƒ€ã‚¦ãƒ³',0),(563144,15643,'pt','Sempre arredondar para baixo',0),(563145,15643,'ru','Ð’ÑÐµÐ³Ð´Ð° Ð¾ÐºÑ€ÑƒÐ³Ð»ÑÐµÑ‚',0),(563146,15643,'es','Siempre redondeando',0),(563147,15643,'de','Immer abrunden',0),(563148,15643,'en','Always Round Down',0),(563149,15644,'is','',0),(563150,15644,'dr','Ù‡Ù…ÛŒØ´Ù‡ Ø¯ÙˆØ± ØªØ§',0),(563151,15644,'pr','Ù‡Ù…ÛŒØ´Ù‡ Ø¯ÙˆØ± ØªØ§',0),(563152,15644,'tr','Her zaman yuvarlak',0),(563153,15644,'pl','Zawsze zaokrÄ…gliÄ‡ w gÃ³rÄ™',0),(563154,15644,'bg','Ð’Ð¸Ð½Ð°Ð³Ð¸ ÐºÑ€ÑŠÐ³',0),(563155,15644,'ur','ÛÙ…ÛŒØ´Û Ø±Ø§Ø¤Ù†Úˆ',0),(563156,15644,'sr','Ð£Ð²ÐµÐº ÑÐµ Ð¾ÐºÑƒÐ¿Ð¸Ð¼Ð¾',0),(563157,15644,'vi','LuÃ´n luÃ´n trÃ²n',0),(563158,15644,'af','Altyd rond',0),(563159,15644,'ro','ÃŽntotdeauna ridica',0),(563160,15644,'et','Alati Ã¼mardada',0),(563161,15644,'si','Vedno zaokroÅ¾ujejo',0),(563162,15644,'ba','Selalu mengumpulkan',0),(563163,15644,'nl','Altijd naar boven afronden',0),(563164,15644,'fi','PyÃ¶ristÃ¤ aina ylÃ¶s',0),(563165,15644,'no','Alltid vil runde opp',0),(563166,15644,'da','Altid vil runde',0),(563167,15644,'ko','í•­ìƒ ëª¨ì•„',0),(563168,15644,'he','×œ×¢×’×œ ×ª×ž×™×“ ×›×œ×¤×™ ×ž×¢×œ×”',0),(563169,15644,'el','Î Î¬Î½Ï„Î± ÏƒÏ„ÏÎ¿Î³Î³Ï…Î»Î¿Ï€Î¿Î¹ÎµÎ¯ Ï€ÏÎ¿Ï‚ Ï„Î± Ï€Î¬Î½Ï‰',0),(563170,15644,'zh','æ€»æ˜¯åœ†çš„',0),(563171,15644,'sv','Alltid runda upp',0),(563172,15644,'it','Sempre arrotondare',0),(563173,15644,'tl','',0),(563174,15644,'th','à¸›à¸±à¸”à¹€à¸¨à¸©à¸‚à¸¶à¹‰à¸™à¹€à¸ªà¸¡à¸­',0),(563175,15644,'hi','à¤¹à¤®à¥‡à¤¶à¤¾ à¤°à¤¾à¤‰à¤‚à¤¡ à¤…à¤ª',0),(563176,15644,'ms','Sentiasa pusingan',0),(563177,15644,'ar','Ø¯Ø§Ø¦Ù…Ø§Ù‹ Ø­ØªÙ‰ Ø§Ù„Ø¬ÙˆÙ„Ø©',0),(563178,15644,'fr','Toujours arrondir',0),(563179,15644,'jp','å¸¸ã«åˆ‡ã‚Šä¸Šã’ã‚‹',0),(563180,15644,'pt','Sempre arredondar para cima',0),(563181,15644,'ru','Ð’ÑÐµÐ³Ð´Ð° ÐºÑ€ÑƒÐ³Ð»Ñ‹Ð¹ Ð²Ð²ÐµÑ€Ñ…',0),(563182,15644,'es','Siempre redondear',0),(563183,15644,'de','Immer Aufrunden',0),(563184,15644,'en','Always Round Up',0),(563185,15645,'is','',0),(563186,15645,'dr','ØªÙ†Ù‡Ø§ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø®Ø§Øµ',0),(563187,15645,'pr','ØªÙ†Ù‡Ø§ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø®Ø§Øµ',0),(563188,15645,'tr','YalnÄ±zca belirli kullanÄ±cÄ±larÄ±n',0),(563189,15645,'pl','Tylko okreÅ›lonym uÅ¼ytkownikom',0),(563190,15645,'bg','Ð¡Ð°Ð¼Ð¾ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(563191,15645,'ur','ØµØ±Ù Ø§Ø®ØªØµØ§ØµÛŒ ØµØ§Ø±ÙÛŒÙ†',0),(563192,15645,'sr','Ð¡Ð°Ð¼Ð¾ Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¸Ð¼ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸Ð¼Ð°',0),(563193,15645,'vi','Chá»‰ ngÆ°á»i dÃ¹ng cá»¥ thá»ƒ',0),(563194,15645,'af','Slegs spesifieke gebruikers',0),(563195,15645,'ro','Numai anumiÅ£i utilizatori',0),(563196,15645,'et','Ainult kindlatele kasutajatele',0),(563197,15645,'si','Samo doloÄenim uporabnikom',0),(563198,15645,'ba','Hanya pengguna tertentu',0),(563199,15645,'nl','Alleen bepaalde gebruikers',0),(563200,15645,'fi','Vain mÃ¤Ã¤ritetyt kÃ¤yttÃ¤jÃ¤t',0),(563201,15645,'no','Bare bestemte brukere',0),(563202,15645,'da','Kun bestemte brugere',0),(563203,15645,'ko','íŠ¹ì • ì‚¬ìš©ìžë§Œ',0),(563204,15645,'he','×ž×©×ª×ž×©×™× ×ž×¡×•×™×ž×™× ×¨×§',0),(563205,15645,'el','ÎœÏŒÎ½Î¿ ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿Ï…Ï‚ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(563206,15645,'zh','åªæœ‰ç‰¹å®šçš„ç”¨æˆ·',0),(563207,15645,'sv','Endast specifika anvÃ¤ndare',0),(563208,15645,'it','Solo a utenti specifici',0),(563209,15645,'tl','',0),(563210,15645,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸—à¸µà¹ˆà¸£à¸°à¸šà¸¸à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(563211,15645,'hi','à¤•à¥‡à¤µà¤² à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚',0),(563212,15645,'ms','Hanya pengguna yang tertentu',0),(563213,15645,'ar','Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ù…Ø¹ÙŠÙ†ÙŠÙ† ÙÙ‚Ø·',0),(563214,15645,'fr','Seuls les utilisateurs spÃ©cifiques',0),(563215,15645,'jp','ç‰¹å®šã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®ã¿',0),(563216,15645,'pt','Somente usuÃ¡rios especÃ­ficos',0),(563217,15645,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÐºÐ¾Ð½ÐºÑ€ÐµÑ‚Ð½Ñ‹Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸',0),(563218,15645,'es','SÃ³lo usuarios especÃ­ficos',0),(563219,15645,'de','Nur bestimmte Benutzer',0),(563220,15645,'en','Only Specific Users',0),(563221,15646,'is','',0),(563222,15646,'dr','ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Approvers Ø¯Ø± Ù„Ø§ÛŒØ­Ù‡',0),(563223,15646,'pr','ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Approvers Ø¯Ø± Ù„Ø§ÛŒØ­Ù‡',0),(563224,15646,'tr','Onaylayanlar Bill baÅŸÄ±na gerekli sayÄ±da',0),(563225,15646,'pl','Wymagana liczba osÃ³b zatwierdzajÄ…cych na rachunek',0),(563226,15646,'bg','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸Ñ Ð±Ñ€Ð¾Ð¹ Ð¾Ð´Ð¾Ð±Ñ€ÑÐ²Ð°Ñ‰Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(563227,15646,'ur','Ø¨Ù„ ÙÛŒ Ø§Ù¾Ù¾Ø±ÙˆÙˆØ±Ø³ Ú©ÛŒ Ù…Ø·Ù„ÙˆØ¨ ØªØ¹Ø¯Ø§Ø¯',0),(563228,15646,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð°Ð½ Ð±Ñ€Ð¾Ñ˜ Ð¾ÑÐ¾Ð±Ðµ ÐºÐ¾Ñ˜Ðµ Ð²Ñ€ÑˆÐµ Ð¿Ð¾ Ð‘Ð¸Ð»Ð»',0),(563229,15646,'vi','CÃ¡c sá»‘ lÆ°á»£ng yÃªu cáº§u cá»§a Approvers cho má»—i hÃ³a Ä‘Æ¡n',0),(563230,15646,'af','Vereiste aantal Approvers Per Wetsontwerp',0),(563231,15646,'ro','NumÄƒrul necesar de aprobatori Per Bill',0),(563232,15646,'et','Kinnitajad maksja kohta nÃµutava arvu',0),(563233,15646,'si','Zahtevano Å¡tevilo Odobritelji na raÄun',0),(563234,15646,'ba','Diperlukan jumlah Approvers Per tagihan',0),(563235,15646,'nl','Vereiste aantal fiatteurs Per factuur',0),(563236,15646,'fi','Vaadittu mÃ¤Ã¤rÃ¤ hyvÃ¤ksyjiÃ¤ kohti',0),(563237,15646,'no','Antall godkjennere Per stykklistenivÃ¥',0),(563238,15646,'da','NÃ¸dvendige antal godkendere pr. Bill',0),(563239,15646,'ko','ë¹Œ ë‹¹ ìŠ¹ì¸ìžì˜ í•„ìš”í•œ ìˆ˜',0),(563240,15646,'he','×”×ž×¡×¤×¨ ×”× ×“×¨×© ×©×œ ×ž××©×¨×™× ×œ×›×œ ×—×©×‘×•×Ÿ',0),(563241,15646,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ¼ÎµÎ½Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Ï‰Î½ Ï…Ï€ÎµÏÎ¸Ï…Î½Ï‰Î½ Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚ Î±Î½Î¬ Î±Î½Ï„Î¹ÎºÎµÎ¯ÂµÎµÎ½Î¿',0),(563242,15646,'zh','æ¯æ¡ä¾‹è‰æ¡ˆå®¡æ‰¹æ‰€éœ€çš„æ•°ç›®',0),(563243,15646,'sv','Erforderligt antal godkÃ¤nnare Per Bill',0),(563244,15646,'it','Richiesto numero di revisori a Bill',0),(563245,15646,'tl','',0),(563246,15646,'th','à¸ˆà¸³à¸™à¸§à¸™à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸•à¹ˆà¸­à¸£à¸²à¸¢à¸à¸²à¸£',0),(563247,15646,'hi','à¤¬à¤¿à¤² à¤ªà¥à¤°à¤¤à¤¿ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤• à¤•à¥€ à¤…à¤ªà¥‡à¤•à¥à¤·à¤¿à¤¤ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(563248,15646,'ms','Bilangan yang diperlukan Approvers satu rang undang-undang',0),(563249,15646,'ar','Ø§Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨ Ù…Ù† Ø§Ù„Ù…ÙˆØ§ÙÙ‚ÙŠÙ† ÙƒÙ„ ÙØ§ØªÙˆØ±Ø©',0),(563250,15646,'fr','Nombre requis d\'approbateurs par Bill',0),(563251,15646,'jp','å¿…è¦ãªæ³•æ¡ˆã«ã¤ãæ‰¿èªè€…æ•°',0),(563252,15646,'pt','NÃºmero necessÃ¡rio de aprovadores por Bill',0),(563253,15646,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÐ¼Ð¾Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´Ð°ÑŽÑ‰Ð¸Ñ… Ð·Ð° Ð‘Ð¸Ð»Ð»',0),(563254,15646,'es','NÃºmero requerido de aprobadores por Bill',0),(563255,15646,'de','Erforderliche Anzahl der Genehmiger Per Rechnung',0),(563256,15646,'en','Required Number Of Approvers Per Bill',0),(563257,15647,'is','',0),(563258,15647,'dr','ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¯ÙˆØ± Ø¯Ø± Preapproved',0),(563259,15647,'pr','ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¯ÙˆØ± Ø¯Ø± Preapproved',0),(563260,15647,'tr','Yuvarlak varsayÄ±lan Ã¶deme tarihi onaylanmasÄ±nÄ± Ã¼zerinde',0),(563261,15647,'pl','Rundy domyÅ›lna data pÅ‚atnoÅ›ci na wstÄ™pnie zatwierdzonej',0),(563262,15647,'bg','ÐšÑ€ÑŠÐ³Ð»Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€ÐµÐ´Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(563263,15647,'ur','Ú¯ÙˆÙ„ Ø·Û’ Ø´Ø¯Û ØªÙ†Ø®ÙˆØ§Û ØªØ§Ø±ÛŒØ® Ù¾Ø± Ù¾Ø±ÛŒØ§Ù¾Ù¾Ø±ÙˆØ¯',0),(563264,15647,'sr','ÐžÐºÑ€ÑƒÐ³Ð»Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¿Ð»Ð°Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð° Ð¿Ñ€ÐµÐ´ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐµÐ¼',0),(563265,15647,'vi','VÃ²ng máº·c Ä‘á»‹nh tráº£ ngÃ y lá»i',0),(563266,15647,'af','Ronde verstek betaal datum op Preapproved',0),(563267,15647,'ro','Runda implicit plata data Preapproved',0),(563268,15647,'et','Vooru VaikekuupÃ¤ev tasustamise kohta Preapproved',0),(563269,15647,'si','Krog privzeto plaÄilnem dnevu na Predpripravljen',0),(563270,15647,'ba','Tanggal bayar bulat Default pada Preapproved',0),(563271,15647,'nl','Ronde betalen de standaarddatum op vooraf goedgekeurde',0),(563272,15647,'fi','PyÃ¶reÃ¤ maksu oletuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ On Preapproved',0),(563273,15647,'no','Runde standarddatoen Betal pÃ¥ forhÃ¥ndsgodtatte',0),(563274,15647,'da','Runde standard lÃ¸ndato pÃ¥ forhÃ¥ndsgodkendte',0),(563275,15647,'ko','ì‚¬ì „ì— ë¼ìš´ë“œ ê¸°ë³¸ ì§€ë¶ˆ ë‚ ì§œ',0),(563276,15647,'he','×ž×—×“×œ ×¢×’×•×œ ×ª××¨×™×š ×”×ª×©×œ×•× ×¢×œ ×”×¨××©×™×ª ×©××•×©×¨×” ×ž×¨××©',0),(563277,15647,'el','Î£Ï„ÏÎ¿Î³Î³Ï…Î»Î® Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï„Ï‰Î½ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î³Î¹Î± Ï€ÏÎ¿ÎµÎ³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î·',0),(563278,15647,'zh','åœ†çš„é»˜è®¤æ—¥æœŸä»˜ä¸Šé¢„å…ˆæ‰¹å‡†',0),(563279,15647,'sv','Runda standarddatum betal pÃ¥ godkÃ¤nda',0),(563280,15647,'it','Data di pagamento di Default rotondo su preapprovati',0),(563281,15647,'tl','',0),(563282,15647,'th','à¸§à¸±à¸™à¸ˆà¹ˆà¸²à¸¢à¸£à¸­à¸šà¹ƒà¸™à¸‚à¹‰à¸­',0),(563283,15647,'hi','à¤¦à¥Œà¤° à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤¿à¤¥à¤¿ à¤ªà¤° à¤²à¤¿',0),(563284,15647,'ms','Tarikh gaji pusingan lalai pada Preapproved',0),(563285,15647,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¬ÙˆÙ„Ø© Ø¹Ù„Ù‰ ØªØµÙŠØ¨Ù‡Ø§',0),(563286,15647,'fr','Arrondi par dÃ©faut Date de paye sur prÃ©approuvÃ©s',0),(563287,15647,'jp','äº‹å‰æ‰¿èªæ¸ˆã¿ã®ãƒ©ã‚¦ãƒ³ãƒ‰ ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆæ”¯æ‰•æ—¥ä»˜',0),(563288,15647,'pt','Data de pagamento padrÃ£o redondo na prÃ©-aprovado',0),(563289,15647,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ñ€Ð°ÑƒÐ½Ð´Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð½Ð° ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ð¹',0),(563290,15647,'es','Ronda por defecto fecha de pago en aprobaciÃ³n previa',0),(563291,15647,'de','Runde Zahlen Standarddatum auf Alternativformulierungen',0),(563292,15647,'en','Round Default Pay Date On Preapproved',0),(563293,15648,'is','',0),(563294,15648,'dr','Ù†Ø²Ø¯ÛŒÚ© ØªØ±ÛŒÙ† Ø¯ÙˆØ±',0),(563295,15648,'pr','Ù†Ø²Ø¯ÛŒÚ© ØªØ±ÛŒÙ† Ø¯ÙˆØ±',0),(563296,15648,'tr','En yakÄ±n yuvarlak',0),(563297,15648,'pl','OkrÄ…gÅ‚e najbliÅ¼szego',0),(563298,15648,'bg','ÐšÑ€ÑŠÐ³ Ð½Ð°Ð¹-Ð±Ð»Ð¸Ð·ÐºÐ¸Ñ',0),(563299,15648,'ur','Ù‚Ø±ÛŒØ¨ÛŒ Ú†Ø§Ø±ÙˆÚº Ø·Ø±Ù',0),(563300,15648,'sr','Ð ÑƒÐ½Ð´Ð° Ð½Ð°Ñ˜Ð±Ð»Ð¸Ð¶Ð¸',0),(563301,15648,'vi','VÃ²ng gáº§n nháº¥t',0),(563302,15648,'af','Naaste ronde',0),(563303,15648,'ro','Runda cel mai apropiat',0),(563304,15648,'et','Ãœmardada lÃ¤hima',0),(563305,15648,'si','Krog najbliÅ¾je',0),(563306,15648,'ba','Bulat terdekat',0),(563307,15648,'nl','Ronde dichtstbijzijnde',0),(563308,15648,'fi','PyÃ¶ristÃ¤Ã¤ lÃ¤himpÃ¤Ã¤n',0),(563309,15648,'no','Rundt nÃ¦rmeste',0),(563310,15648,'da','Runde nÃ¦rmeste',0),(563311,15648,'ko','ê°€ìž¥ ê°€ê¹Œìš´ ë¼ìš´ë“œ',0),(563312,15648,'he','×¡×™×‘×•×‘ ×”×§×¨×•×‘ ×‘×™×•×ª×¨',0),(563313,15648,'el','Î£Ï„ÏÎ¿Î³Î³Ï…Î»Î® Ï€Î»Î·ÏƒÎ¹Î­ÏƒÏ„ÎµÏÎ¿',0),(563314,15648,'zh','æœ€è¿‘çš„ä¸€è½®',0),(563315,15648,'sv','Runda nÃ¤rmaste',0),(563316,15648,'it','Turno piÃ¹ vicina',0),(563317,15648,'tl','',0),(563318,15648,'th','à¸›à¸±à¸”à¹€à¸¨à¸©à¸—à¸µà¹ˆà¹ƒà¸à¸¥à¹‰à¸—à¸µà¹ˆà¸ªà¸¸à¸”',0),(563319,15648,'hi','à¤¨à¤¿à¤•à¤Ÿà¤¤à¤® à¤¦à¥Œà¤°',0),(563320,15648,'ms','Pusingan yang terdekat',0),(563321,15648,'ar','Ø¬ÙˆÙ„Ø© Ø£Ù‚Ø±Ø¨',0),(563322,15648,'fr','Tour le plus proche',0),(563323,15648,'jp','æœ€å¯„ã‚Šã®ãƒ©ã‚¦ãƒ³ãƒ‰ã—ã¾ã™ã€‚',0),(563324,15648,'pt','Rodada mais prÃ³ximo',0),(563325,15648,'ru','Ð Ð°ÑƒÐ½Ð´ Ð±Ð»Ð¸Ð¶Ð°Ð¹ÑˆÐµÐ³Ð¾',0),(563326,15648,'es','Redondo mÃ¡s cercano',0),(563327,15648,'de','NÃ¤chste Runde',0),(563328,15648,'en','Round Nearest',0),(563329,15649,'is','',0),(563330,15649,'dr','Ø¯ÙˆØ± Ø¨Ø¹Ø¯ Ø§Ø² ØªØ¹Ø·ÛŒÙ„Ø§Øª',0),(563331,15649,'pr','Ø¯ÙˆØ± Ø¨Ø¹Ø¯ Ø§Ø² ØªØ¹Ø·ÛŒÙ„Ø§Øª',0),(563332,15649,'tr','Yuvarlak sonra iÃ§in tatil',0),(563333,15649,'pl','Rundy po wakacje',0),(563334,15649,'bg','ÐšÑ€ÑŠÐ³Ð»Ð¸ Ð´Ð¾ ÑÐ»ÐµÐ´ Ð¿Ð¾Ñ‡Ð¸Ð²ÐºÐ°',0),(563335,15649,'ur','Ú¯ÙˆÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ø¹Ø¯ Ú†Ú¾Ù¹ÛŒ',0),(563336,15649,'sr','ÐžÐºÑ€ÑƒÐ³Ð»Ð° Ð¿Ð¾ÑÐ»Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¸ÐºÐ°',0),(563337,15649,'vi','VÃ²ng sau ká»³ nghá»‰',0),(563338,15649,'af','Ronde om na vakansie',0),(563339,15649,'ro','Runda a dupa vacanta',0),(563340,15649,'et','Vooru pÃ¤rast puhkus',0),(563341,15649,'si','Krog, da po Holiday',0),(563342,15649,'ba','Bulat untuk setelah liburan',0),(563343,15649,'nl','-Ronde kan doen na vakantie',0),(563344,15649,'fi','Kierroksen jÃ¤lkeen Holiday',0),(563345,15649,'no','Runde i etter ferie',0),(563346,15649,'da','Runde til efter ferie',0),(563347,15649,'ko','ë¼ìš´ë“œ í›„ì— íœ´ì¼',0),(563348,15649,'he','×œ×¢×’×œ ××—×¨×™ ×”×—×’',0),(563349,15649,'el','Î£Ï„ÏÎ¿Î³Î³Ï…Î»Î® Î³Î¹Î± Î¼ÎµÏ„Î¬ Ï„Î¹Ï‚ Î´Î¹Î±ÎºÎ¿Ï€Î­Ï‚',0),(563350,15649,'zh','è½®åˆ°åŽå‡æœŸ',0),(563351,15649,'sv','Runda till efter semester',0),(563352,15649,'it','Vacanze rotonda a dopo',0),(563353,15649,'tl','',0),(563354,15649,'th','à¸§à¸±à¸™à¸«à¸¢à¸¸à¸”à¹„à¸›à¸«à¸¥à¸±à¸‡',0),(563355,15649,'hi','à¤¬à¤¾à¤¦ à¤•à¥‡ à¤¦à¥Œà¤° à¤›à¥à¤Ÿà¥à¤Ÿà¥€',0),(563356,15649,'ms','Bulat selepas Holiday',0),(563357,15649,'ar','Ø¬ÙˆÙ„Ø© Ø¥Ù„Ù‰ Ù…Ø§ Ø¨Ø¹Ø¯ Ø§Ù„Ø¹Ø·Ù„Ø©',0),(563358,15649,'fr','Ronde d\'aprÃ¨s vacances',0),(563359,15649,'jp','å¾Œã«ãƒ©ã‚¦ãƒ³ãƒ‰ã®ä¼‘æ—¥',0),(563360,15649,'pt','FÃ©rias para depois',0),(563361,15649,'ru','ÐšÑ€ÑƒÐ³Ð»Ñ‹Ðµ Ð¸Ð»Ð¸ Ð¿Ð¾ÑÐ»Ðµ Ð¿Ñ€Ð°Ð·Ð´Ð½Ð¸ÐºÐ°',0),(563362,15649,'es','Vacaciones ronda despuÃ©s',0),(563363,15649,'de','Runde, nach dem Urlaub',0),(563364,15649,'en','Round To After Holiday',0),(563365,15650,'is','',0),(563366,15650,'dr','Ù¾Ø³ Ø§Ø² Ø¯ÙˆØ± Ø¢Ø®Ø± Ù‡ÙØªÙ‡',0),(563367,15650,'pr','Ù¾Ø³ Ø§Ø² Ø¯ÙˆØ± Ø¢Ø®Ø± Ù‡ÙØªÙ‡',0),(563368,15650,'tr','Yuvarlak sonra iÃ§in hafta sonu',0),(563369,15650,'pl','Rundy po Weekend',0),(563370,15650,'bg','ÐšÑ€ÑŠÐ³Ð»Ð¸ Ð´Ð¾ ÑÐ»ÐµÐ´ ÑƒÐ¸ÐºÐµÐ½Ð´',0),(563371,15650,'ur','Ú¯ÙˆÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ø¨Ø¹Ø¯ ÛÙØªÛ’ Ú©Û’ Ø¢Ø®Ø± Ù…ÛŒÚº',0),(563372,15650,'sr','ÐžÐºÑ€ÑƒÐ³Ð»Ð° Ð¿Ð¾ÑÐ»Ðµ Ð²Ð¸ÐºÐµÐ½Ð´Ð°',0),(563373,15650,'vi','VÃ²ng sau cuá»‘i tuáº§n',0),(563374,15650,'af','Ronde om na naweek',0),(563375,15650,'ro','Runda a dupÄƒ Weekend',0),(563376,15650,'et','Ãœmmargune, et pÃ¤rast nÃ¤dalavahetuse',0),(563377,15650,'si','Krog, da Äez vikend',0),(563378,15650,'ba','Bulat untuk setelah akhir pekan',0),(563379,15650,'nl','Na ronde Weekend',0),(563380,15650,'fi','Kierroksen jÃ¤lkeen viikonloppuna',0),(563381,15650,'no','Runde i etter helgen',0),(563382,15650,'da','Runde til efter weekenden',0),(563383,15650,'ko','ë¼ìš´ë“œ í›„ì— ì£¼ë§',0),(563384,15650,'he','×œ×¢×’×œ ××—×¨×™ ×¡×•×£ ×”×©×‘×•×¢',0),(563385,15650,'el','Î“ÏÏÎ¿ Î½Î± Î¼ÎµÏ„Î¬ Ï„Î¿ Î£Î±Î²Î²Î±Ï„Î¿ÎºÏÏÎ¹Î±ÎºÎ¿',0),(563386,15650,'zh','è½®åˆ°åŽå‘¨æœ«',0),(563387,15650,'sv','Runda till efter helgen',0),(563388,15650,'it','Rotondo a dopo Weekend',0),(563389,15650,'tl','',0),(563390,15650,'th','à¹„à¸›à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸ªà¸¸à¸”à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(563391,15650,'hi','à¤¦à¥Œà¤° à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¸à¤ªà¥à¤¤à¤¾à¤¹à¤¾à¤‚à¤¤',0),(563392,15650,'ms','Bulat selepas hujung minggu',0),(563393,15650,'ar','Ø¬ÙˆÙ„Ø© Ø¥Ù„Ù‰ Ù…Ø§ Ø¨Ø¹Ø¯ Ø¹Ø·Ù„Ø© Ù†Ù‡Ø§ÙŠØ© Ø§Ù„Ø£Ø³Ø¨ÙˆØ¹',0),(563394,15650,'fr','Ronde d\'aprÃ¨s week-end',0),(563395,15650,'jp','ãƒ©ã‚¦ãƒ³ãƒ‰å¾Œã®é€±æœ«',0),(563396,15650,'pt','Fim de semana para depois',0),(563397,15650,'ru','Ð Ð°ÑƒÐ½Ð´Ð° Ð¿Ð¾ÑÐ»Ðµ Ð²Ñ‹Ñ…Ð¾Ð´Ð½Ñ‹Ñ…',0),(563398,15650,'es','Fin de semana redondo para despuÃ©s',0),(563399,15650,'de','Runde bis nach dem Wochenende',0),(563400,15650,'en','Round To After Weekend',0),(563401,15651,'is','',0),(563402,15651,'dr','Ø¯ÙˆØ± Ø¨Ù‡ ØªØ§Ø±ÛŒØ®',0),(563403,15651,'pr','Ø¯ÙˆØ± Ø¨Ù‡ ØªØ§Ø±ÛŒØ®',0),(563404,15651,'tr','Tarihler iÃ§in yuvarlak',0),(563405,15651,'pl','OkrÄ…gÅ‚e do daty',0),(563406,15651,'bg','ÐšÑ€ÑŠÐ³ Ð² Ð´Ð°Ñ‚Ð¸',0),(563407,15651,'ur','ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©Û’ Ù„Ø¦Û’ Ú†Ø§Ø±ÙˆÚº Ø·Ø±Ù',0),(563408,15651,'sr','Ð—Ð°Ð¾ÐºÑ€ÑƒÐ¶Ð¸Ñ‚Ðµ Ð½Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ðµ',0),(563409,15651,'vi','VÃ²ng má»™t ngÃ y',0),(563410,15651,'af','Ronde aan datums',0),(563411,15651,'ro','Rotund la datele',0),(563412,15651,'et','Ãœmmargune kuupÃ¤evad',0),(563413,15651,'si','Krog za datume',0),(563414,15651,'ba','Bulat-tanggal',0),(563415,15651,'nl','Afronden op datums',0),(563416,15651,'fi','PyÃ¶reÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤t',0),(563417,15651,'no','Rundt datoer',0),(563418,15651,'da','Runde til datoer',0),(563419,15651,'ko','ë‚ ì§œë¥¼ ë¼ìš´ë“œ',0),(563420,15651,'he','×¢×’×•×œ×” ×œ×ª××¨×™×›×™',0),(563421,15651,'el','Î“ÏÏÎ¿ ÏƒÏ„Î¹Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(563422,15651,'zh','è½®åˆ°æ—¥æœŸ',0),(563423,15651,'sv','Avrunda till datum',0),(563424,15651,'it','Turno a date',0),(563425,15651,'tl','',0),(563426,15651,'th','à¸£à¸­à¸šà¸§à¸±à¸™',0),(563427,15651,'hi','à¤—à¥‹à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤',0),(563428,15651,'ms','Pusingan untuk tarikh',0),(563429,15651,'ar','Ø¬ÙˆÙ„Ø© Ù„Ù„ØªÙˆØ§Ø±ÙŠØ®',0),(563430,15651,'fr','Tour dates',0),(563431,15651,'jp','ãƒ©ã‚¦ãƒ³ãƒ‰ã®æ—¥ç¨‹',0),(563432,15651,'pt','Arredondar para datas',0),(563433,15651,'ru','Ð¢ÑƒÑ€ Ð´Ð°Ñ‚Ñ‹',0),(563434,15651,'es','A las fechas',0),(563435,15651,'de','Runde auf Termine',0),(563436,15651,'en','Round To Dates',0),(563437,15652,'is','',0),(563438,15652,'dr','Ø¯Ø³ØªØ±Ø³ÛŒ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(563439,15652,'pr','Ø¯Ø³ØªØ±Ø³ÛŒ Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(563440,15652,'tr','Standart eriÅŸim',0),(563441,15652,'pl','DostÄ™p standardowy',0),(563442,15652,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(563443,15652,'ur','Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø±Ø³Ø§Ø¦ÛŒ',0),(563444,15652,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿',0),(563445,15652,'vi','TiÃªu chuáº©n truy cáº­p',0),(563446,15652,'af','Standaard toegang',0),(563447,15652,'ro','Acces standard',0),(563448,15652,'et','Standard juurdepÃ¤Ã¤su',0),(563449,15652,'si','Standardni dostop',0),(563450,15652,'ba','Akses standar',0),(563451,15652,'nl','Standaardtoegang',0),(563452,15652,'fi','Normaalit kÃ¤yttÃ¶oikeudet',0),(563453,15652,'no','Standard tilgang',0),(563454,15652,'da','Standard adgang',0),(563455,15652,'ko','í‘œì¤€ ì•¡ì„¸ìŠ¤',0),(563456,15652,'he','×’×™×©×” ×¡×˜× ×“×¨×˜×™',0),(563457,15652,'el','Î¤Ï…Ï€Î¹ÎºÎ® Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·',0),(563458,15652,'zh','æ ‡å‡†çš„è®¿é—®',0),(563459,15652,'sv','Standard tillgÃ¥ng',0),(563460,15652,'it','Accesso standard',0),(563461,15652,'tl','',0),(563462,15652,'th','à¹€à¸‚à¹‰à¸²à¸¡à¸²à¸•à¸£à¸à¸²à¸™',0),(563463,15652,'hi','à¤®à¤¾à¤¨à¤• à¤ªà¤¹à¥à¤à¤š',0),(563464,15652,'ms','Standard akses',0),(563465,15652,'ar','Ø§Ù„ÙˆØµÙˆÙ„ Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠ',0),(563466,15652,'fr','AccÃ¨s standard',0),(563467,15652,'jp','æ¨™æº–ã‚¢ã‚¯ã‚»ã‚¹',0),(563468,15652,'pt','Acesso padrÃ£o',0),(563469,15652,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð´Ð¾ÑÑ‚ÑƒÐ¿',0),(563470,15652,'es','EstÃ¡ndar de acceso a',0),(563471,15652,'de','Standardzugriff',0),(563472,15652,'en','Standard Access',0),(563473,15653,'is','',0),(563474,15653,'dr','ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø¯Ø± Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ ØªÙ†Ù‡Ø§',0),(563475,15653,'pr','ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø¯Ø± Ø§ÛŒØ§Ù„Ø§Øª Ù…ØªØ­Ø¯Ù‡ Ø¢Ù…Ø±ÛŒÚ©Ø§ ØªÙ†Ù‡Ø§',0),(563476,15653,'tr','ABD tatil sadece',0),(563477,15653,'pl','USA wakacje tylko',0),(563478,15653,'bg','Ð¡ÐÐ© Ð¿Ñ€Ð°Ð·Ð½Ð¸Ñ†Ð¸Ñ‚Ðµ ÑÐ°Ð¼Ð¾',0),(563479,15653,'ur','ØµØ±Ù Ø§Ù…Ø±ÛŒÚ©Û Ú©ÛŒ ØªØ¹Ø·ÛŒÙ„Ø§Øª',0),(563480,15653,'sr','Ð¡Ð°Ð¼Ð¾ Ð·Ð° Ð¿Ñ€Ð°Ð·Ð½Ð¸ÐºÐµ Ð£Ð¡Ð',0),(563481,15653,'vi','Hoa Ká»³ ngÃ y lá»… chá»‰',0),(563482,15653,'af','VSA vakansiedae net',0),(563483,15653,'ro','Vacanta Statele Unite ale Americii numai',0),(563484,15653,'et','Ainult USA Holidays',0),(563485,15653,'si','ZDA poÄitnice samo',0),(563486,15653,'ba','Liburan Amerika Serikat hanya',0),(563487,15653,'nl','USA vakanties alleen',0),(563488,15653,'fi','USA loma vain',0),(563489,15653,'no','USA ferie bare',0),(563490,15653,'da','USA ferie kun',0),(563491,15653,'ko','ë¯¸êµ­ ê³µíœ´ì¼ë§Œ',0),(563492,15653,'he','×”×—×’×™× ×‘××¨×” ×‘ ×‘×œ×‘×“',0),(563493,15653,'el','Î”Î¹Î±ÎºÎ¿Ï€Î­Ï‚ ÏƒÎµ Î—Î Î‘ Î¼ÏŒÎ½Î¿',0),(563494,15653,'zh','ç¾Žå›½å‡æœŸåª',0),(563495,15653,'sv','USA semester bara',0),(563496,15653,'it','USA solo durante le vacanze',0),(563497,15653,'tl','',0),(563498,15653,'th','à¸ªà¸«à¸£à¸±à¸à¸­à¹€à¸¡à¸£à¸´à¸à¸²à¸§à¸±à¸™à¸«à¸¢à¸¸à¸”à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(563499,15653,'hi','à¤•à¥‡à¤µà¤² à¤¸à¤‚à¤¯à¥à¤•à¥à¤¤ à¤°à¤¾à¤œà¥à¤¯ à¤…à¤®à¥‡à¤°à¤¿à¤•à¤¾ à¤›à¥à¤Ÿà¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(563500,15653,'ms','Cuti Amerika Syarikat hanya',0),(563501,15653,'ar','Ø£ÙŠØ§Ù… Ø§Ù„Ø¹Ø·Ù„ ÙÙŠ Ø§Ù„ÙˆÙ„Ø§ÙŠØ§Øª Ø§Ù„Ù…ØªØ­Ø¯Ø© Ø§Ù„Ø£Ù…Ø±ÙŠÙƒÙŠØ© ÙÙ‚Ø·',0),(563502,15653,'fr','USA vacances seulement',0),(563503,15653,'jp','ã‚¢ãƒ¡ãƒªã‚«ä¼‘æ—¥ã®ã¿',0),(563504,15653,'pt','EUA fÃ©rias sÃ³',0),(563505,15653,'ru','ÐŸÑ€Ð°Ð·Ð´Ð½Ð¸ÐºÐ¸ Ð¡Ð¨Ð Ñ‚Ð¾Ð»ÑŒÐºÐ¾',0),(563506,15653,'es','Estados Unidos vacaciones solamente',0),(563507,15653,'de','Nur USA-Urlaub',0),(563508,15653,'en','USA Holidays Only',0),(563509,15654,'is','',0),(563510,15654,'dr','Ú©Ù‡ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø§Ø³Ú©Ù†Ø§Ø³ Ø±Ø§ ØªØ£ÛŒÛŒØ¯ Ú©Ø±Ø¯Ù‡ Ø§Ø³ØªØŸ',0),(563511,15654,'pr','Ú©Ù‡ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø§Ø³Ú©Ù†Ø§Ø³ Ø±Ø§ ØªØ£ÛŒÛŒØ¯ Ú©Ø±Ø¯Ù‡ Ø§Ø³ØªØŸ',0),(563512,15654,'tr','Kim faturalarÄ± onaylamak',0),(563513,15654,'pl','Kto zatwierdza rachunki',0),(563514,15654,'bg','ÐšÐ¾Ð¹ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€ÑÐ²Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ',0),(563515,15654,'ur','Ø¬Ùˆ Ø¨Ù„ Ù…Ù†Ø¸ÙˆØ± Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(563516,15654,'sr','ÐšÐ¾Ñ˜Ð¸ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(563517,15654,'vi','Nhá»¯ng ngÆ°á»i cÃ³ thá»ƒ cháº¥p nháº­n hÃ³a Ä‘Æ¡n',0),(563518,15654,'af','Wat rekeninge kan goedkeur',0),(563519,15654,'ro','Cine poate aproba facturile',0),(563520,15654,'et','Kes Ãµigus kinnitada arveid',0),(563521,15654,'si','Ki lahko odobri raÄune',0),(563522,15654,'ba','Yang dapat menyetujui tagihan',0),(563523,15654,'nl','Die rekeningen kunnen goedkeuren',0),(563524,15654,'fi','Kenen hyvÃ¤ksyÃ¤ laskut',0),(563525,15654,'no','Som kan godkjenne regninger',0),(563526,15654,'da','Der kan godkende regninger',0),(563527,15654,'ko','ëˆ„ê°€ ë²•ì•ˆì„ ìŠ¹ì¸í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤',0),(563528,15654,'he','×ž×™ ×™×›×•×œ ×œ××©×¨ ××ª ×”×—×©×‘×•× ×•×ª',0),(563529,15654,'el','Î Î¿Î¹Î¿Ï‚ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ³ÎºÏÎ¯Î½ÎµÎ¹ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(563530,15654,'zh','å“ªäº›äººå‘˜å¯ä»¥æ‰¹å‡†æ³•æ¡ˆ',0),(563531,15654,'sv','Som kan godkÃ¤nna rÃ¤kningar',0),(563532,15654,'it','Chi puÃ² approvare le bollette',0),(563533,15654,'tl','',0),(563534,15654,'th','à¸—à¸µà¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¹€à¸‡à¸´à¸™à¹„à¸”à¹‰à¸­à¸¢à¹ˆà¸²à¸‡à¹„à¸£',0),(563535,15654,'hi','à¤œà¥‹ à¤¬à¤¿à¤² Approve à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(563536,15654,'ms','Yang boleh meluluskan rang undang-undang',0),(563537,15654,'ar','Ø§Ù„Ø°ÙŠÙ† ÙŠÙ…ÙƒÙ†Ù‡Ù… Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ù…Ø´Ø§Ø±ÙŠØ¹ Ø§Ù„Ù‚ÙˆØ§Ù†ÙŠÙ†',0),(563538,15654,'fr','Qui peut approuver des factures',0),(563539,15654,'jp','æ‰‹å½¢ã‚’æ‰¿èªã§ãã‚‹ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(563540,15654,'pt','Quem pode aprovar as contas',0),(563541,15654,'ru','ÐšÑ‚Ð¾ Ð¼Ð¾Ð¶ÐµÑ‚ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ñ‹',0),(563542,15654,'es','Que puede aprobar proyectos de ley',0),(563543,15654,'de','Wer Rechnungen genehmigt werden kann',0),(563544,15654,'en','Who Can Approve Bills',0),(563545,15655,'is','',0),(563546,15655,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ú©Ø§Ø± Ù†Ø§Ù… Ø³ØªÙˆÙ† Ø¯Ø± Ø¬Ø¯ÙˆÙ„ Ù…Ø´Ø§ØºÙ„',0),(563547,15655,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ú©Ø§Ø± Ù†Ø§Ù… Ø³ØªÙˆÙ† Ø¯Ø± Ø¬Ø¯ÙˆÙ„ Ù…Ø´Ø§ØºÙ„',0),(563548,15655,'tr','Ä°ÅŸleri tablosundaki iÅŸ adÄ± sÃ¼tunu gizle',0),(563549,15655,'pl','Ukryj kolumna Nazwa zadanie w Jobs tabela',0),(563550,15655,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ Ð¸Ð¼Ðµ Ð½Ð° ÐºÐ¾Ð»Ð¾Ð½Ð° Ð² Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð¼ÐµÑÑ‚Ð°',0),(563551,15655,'ur','Ù†ÙˆÚ©Ø±ÛŒØ§Úº Ø¬Ø¯ÙˆÙ„ Ù…ÛŒÚº Ø§ÛŒÙˆØ¨ Ù†Ø§Ù… Ú©Ø§Ù„Ù… Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(563552,15655,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð¿Ð¾ÑÐ°Ð¾ Ð¸Ð¼Ðµ ÐºÐ¾Ð»Ð¾Ð½Ðµ Ñƒ Ñ‚Ð°Ð±ÐµÐ»Ð¸ Ñ€Ð°Ð´Ð½Ð¸Ñ… Ð¼ÐµÑÑ‚Ð°',0),(563553,15655,'vi','áº¨n cá»™t tÃªn cÃ´ng viá»‡c trong báº£ng cÃ´ng Äƒn viá»‡c lÃ m',0),(563554,15655,'af','Versteek werk naam kolom In tabel Jobs',0),(563555,15655,'ro','Ascunde Job nume de coloanÄƒ Ã®n tabelul de locuri de muncÄƒ',0),(563556,15655,'et','Peida tÃ¶Ã¶ tÃ¶Ã¶kohti tabeli veeru nimi',0),(563557,15655,'si','Skriti Job ime stolpca v tabeli delovna mesta',0),(563558,15655,'ba','Menyembunyikan pekerjaan nama kolom dalam tabel pekerjaan',0),(563559,15655,'nl','Verberg de kolom van de naam van de baan In banen tabel',0),(563560,15655,'fi','Piilota projektin nimi-sarakkeesta tyÃ¶paikkojen taulukon',0),(563561,15655,'no','Skjule jobb kolonnenavn i jobber-tabellen',0),(563562,15655,'da','Skjule Job kolonnenavn i job bord',0),(563563,15655,'ko','ìž‘ì—… í…Œì´ë¸”ì—ì„œ ìž‘ì—… ì´ë¦„ ì—´ ìˆ¨ê¸°ê¸°',0),(563564,15655,'he','×œ×”×¡×ª×™×¨ ××ª ×”×¢×‘×•×“×” ×©× ×¢×ž×•×“×” ×‘×˜×‘×œ×ª ×ž×©×¨×•×ª',0),(563565,15655,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÏƒÏ„Î®Î»Î·Ï‚ ÎŒÎ½Î¿Î¼Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÏƒÏ„Î¿Î½ Ï€Î¯Î½Î±ÎºÎ± Î¸Î­ÏƒÎµÏ‰Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(563566,15655,'zh','éšè—å·¥ä½œè¡¨ä¸­çš„å·¥ä½œåç§°åˆ—',0),(563567,15655,'sv','DÃ¶lja jobb namnkolumnen i Jobs tabell',0),(563568,15655,'it','Nascondere la colonna nome lavoro nella tabella Jobs',0),(563569,15655,'tl','',0),(563570,15655,'th','à¸‹à¹ˆà¸­à¸™à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œà¸Šà¸·à¹ˆà¸­à¸‡à¸²à¸™à¹ƒà¸™à¸•à¸²à¸£à¸²à¸‡à¸‡à¸²à¸™',0),(563571,15655,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤°à¥‹à¤œà¤—à¤¾à¤° à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤®à¥‡à¤‚ à¤¸à¥à¤¤à¤‚à¤­ à¤¨à¤¾à¤® à¤›à¥à¤ªà¤¾à¤à¤',0),(563572,15655,'ms','Sembunyi lajur nama kerja dalam jadual kerja',0),(563573,15655,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø¹Ù…ÙˆØ¯ Ø§Ø³Ù… Ø§Ù„Ù…Ù‡Ù…Ø© ÙÙŠ Ø¬Ø¯ÙˆÙ„ Ø§Ù„ÙˆØ¸Ø§Ø¦Ù',0),(563574,15655,'fr','Masquer colonne de nom de Job dans la Table Jobs',0),(563575,15655,'jp','Jobs ãƒ†ãƒ¼ãƒ–ãƒ«ã«ã‚¸ãƒ§ãƒ–å] åˆ—ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(563576,15655,'pt','Ocultar coluna de nome de trabalho na tabela de empregos',0),(563577,15655,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑ‚Ð¾Ð»Ð±ÐµÑ† Ð¸Ð¼Ñ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ Ð² Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ð¹',0),(563578,15655,'es','Ocultar columna de nombre de trabajo en puestos de trabajo tabla',0),(563579,15655,'de','Job-Name-Spalte In der Tabelle Jobs ausblenden',0),(563580,15655,'en','Hide Job Name Column In Jobs Table',0),(563581,15656,'is','',0),(563582,15656,'dr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ø¬Ø¹Ø¨Ù‡ Shift Ù‡Ù†Ú¯Ø§Ù… Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(563583,15656,'pr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ø¬Ø¹Ø¨Ù‡ Shift Ù‡Ù†Ú¯Ø§Ù… Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(563584,15656,'tr','Saat oturum sÄ±rasÄ±nda Ã¼st karakter kutularÄ±nÄ± gizlemek',0),(563585,15656,'pl','Ukryj pola Shift podczas rejestrowania godziny',0),(563586,15656,'bg','Ð¡ÐºÑ€Ð¸Ð¹ ÐºÑƒÑ‚Ð¸Ð¸ ÑÐ¼ÐµÐ½Ð¸ Ð¿Ñ€Ð¸ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ñ‡Ð°ÑÐ°',0),(563587,15656,'ur','Ø¬Ø¨ Ù„Ø§Ú¯Ù†Ú¯ Ú¯Ú¾Ù†Ù¹Û’ Shift Ø®Ø§Ù†ÙˆÚº Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(563588,15656,'sr','Ð¡ÐºÑ€Ð¸Ð²Ð°ÑšÐµ Ð¾ÐºÐ²Ð¸Ñ€Ð° Ð·Ð° Ð¡Ñ…Ð¸Ñ„Ñ‚ Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ€Ð°ÑšÐ° ÑÐ°Ñ‚Ð¸',0),(563589,15656,'vi','áº¨n há»™p Shift khi Ä‘Äƒng nháº­p giá»',0),(563590,15656,'af','Shift bokse versteek wanneer teken ure',0),(563591,15656,'ro','Ascunde casetele de Shift cÃ®nd Logging ore',0),(563592,15656,'et','Peida Shift kastid kui metsaraie tundi',0),(563593,15656,'si','Skriti premik polja ob prijavi ur',0),(563594,15656,'ba','Sembunyikan kotak Shift ketika login jam',0),(563595,15656,'nl','Shift vakken verbergen tijdens de registratie van uren',0),(563596,15656,'fi','Piilota siirtÃ¤Ã¤ laatikot, kun kirjaudut tuntia',0),(563597,15656,'no','Skjule Skift bokser NÃ¥r du logger timer',0),(563598,15656,'da','Skjule Skift kasser hvor journaliserer timer',0),(563599,15656,'ko','ì‹œê°„ì„ ë¡œê·¸ì¸ í•  ë•Œ êµëŒ€ ìƒìž ìˆ¨ê¸°ê¸°',0),(563600,15656,'he','×”×¡×ª×¨×ª ×ª×™×‘×•×ª ×ž×©×ž×¨×ª ×‘×¢×ª ×¨×™×©×•× ×©×¢×•×ª',0),(563601,15656,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Ï€Î»Î±Î¯ÏƒÎ¹Î± Î¼ÎµÏ„Î±Ï„ÏŒÏ€Î¹ÏƒÎ· ÎºÎ±Ï„Î¬ Ï„Î· ÏƒÏÎ½Î´ÎµÏƒÎ· ÏŽÏÎµÏ‚',0),(563602,15656,'zh','éšè—çš„è½¬å˜æ¡†ç™»å½•å°æ—¶æ—¶',0),(563603,15656,'sv','DÃ¶lja SKIFT lÃ¥dor nÃ¤r loggning timmar',0),(563604,15656,'it','Nasconde le finestre MAIUSC durante la registrazione ore',0),(563605,15656,'tl','',0),(563606,15656,'th','à¸‹à¹ˆà¸­à¸™à¸à¸¥à¹ˆà¸­à¸‡à¸à¸°à¹€à¸¡à¸·à¹ˆà¸­à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(563607,15656,'hi','à¤œà¤¬ à¤²à¥‰à¤—à¤¿à¤‚à¤— à¤˜à¤‚à¤Ÿà¥‡ à¤¶à¤¿à¤«à¥à¤Ÿ à¤¬à¤•à¥à¤¸à¥‡ à¤›à¥à¤ªà¤¾à¤à¤',0),(563608,15656,'ms','Sembunyi kotak peralihan apabila log jam',0),(563609,15656,'ar','Ø¥Ø®ÙØ§Ø¡ Ù…Ø±Ø¨Ø¹Ø§Øª Shift Ø¹Ù†Ø¯ ØªØ³Ø¬ÙŠÙ„ Ø³Ø§Ø¹Ø§Øª',0),(563610,15656,'fr','Masquer les cases Ã  Maj lorsque vous vous connectez heures',0),(563611,15656,'jp','æ™‚é–“ã‚’ãƒ­ã‚°ã‚¤ãƒ³ã™ã‚‹ã¨ãã‚·ãƒ•ãƒˆ ãƒœãƒƒã‚¯ã‚¹ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(563612,15656,'pt','Esconder caixas de mudanÃ§a quando o log de horas',0),(563613,15656,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÐ¼ÐµÐ½Ñ‹ ÐºÐ¾Ñ€Ð¾Ð±ÐºÐ¸ Ð¿Ñ€Ð¸ Ð²Ñ…Ð¾Ð´Ðµ Ñ‡Ð°ÑÐ¾Ð²',0),(563614,15656,'es','Ocultar cajas de cambio al registro horas',0),(563615,15656,'de','Ausblenden Sie Shift-Boxen, wenn Stunden Protokollierung',0),(563616,15656,'en','Hide Shift Boxes When Logging Hours',0),(563617,15657,'is','',0),(563618,15657,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±ÛŒ',0),(563619,15657,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±ÛŒ',0),(563620,15657,'tr','Fazla mesai',0),(563621,15657,'pl','Za pracÄ™ w nadgodzinach',0),(563622,15657,'bg','Ð˜Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´ÐµÐ½ Ñ‚Ñ€ÑƒÐ´',0),(563623,15657,'ur','Ø§ÙˆÙˆØ±Ù¹Ø§Ø¦Ù…',0),(563624,15657,'sr','ÐŸÑ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ñ€Ð°Ð´',0),(563625,15657,'vi','LÃ m thÃªm giá»',0),(563626,15657,'af','Oortyd',0),(563627,15657,'ro','Orele suplimentare',0),(563628,15657,'et','ÃœletunnitÃ¶Ã¶',0),(563629,15657,'si','Nadure',0),(563630,15657,'ba','Lembur',0),(563631,15657,'nl','Overuren',0),(563632,15657,'fi','YlityÃ¶',0),(563633,15657,'no','Overtid',0),(563634,15657,'da','Overarbejde',0),(563635,15657,'ko','ì´ˆê³¼ ìž‘ì—… ì‹œê°„',0),(563636,15657,'he','×©×¢×•×ª × ×•×¡×¤×•×ª',0),(563637,15657,'el','Î¥Ï€ÎµÏÏ‰ÏÎ¯ÎµÏ‚',0),(563638,15657,'zh','åŠ ç­',0),(563639,15657,'sv','Ã–vertid',0),(563640,15657,'it','Lavoro straordinario',0),(563641,15657,'tl','',0),(563642,15657,'th','à¸—à¸³à¸‡à¸²à¸™à¸¥à¹ˆà¸§à¸‡à¹€à¸§à¸¥à¸²',0),(563643,15657,'hi','à¤¸à¤®à¤¯à¥‹à¤ªà¤°à¤¿',0),(563644,15657,'ms','Bayaran kerja lebih masa',0),(563645,15657,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ',0),(563646,15657,'fr','Heures supplÃ©mentaires',0),(563647,15657,'jp','è¶…éŽä½œæ¥­æ™‚é–“',0),(563648,15657,'pt','Horas extraordinÃ¡rias',0),(563649,15657,'ru','Ð¡Ð²ÐµÑ€Ñ…ÑƒÑ€Ð¾Ñ‡Ð½Ñ‹Ðµ',0),(563650,15657,'es','Horas extraordinarias',0),(563651,15657,'de','Ãœberstunden',0),(563652,15657,'en','Overtime',0),(563653,15658,'is','',0),(563654,15658,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±ÛŒ Deducts Ø§Ø² Ø±Ø§Ø³Øª Ø²Ù…Ø§Ù† Ù‡Ù†Ú¯Ø§Ù… Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(563655,15658,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±ÛŒ Deducts Ø§Ø² Ø±Ø§Ø³Øª Ø²Ù…Ø§Ù† Ù‡Ù†Ú¯Ø§Ù… Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(563656,15658,'tr','Fazla mesai dÃ¼z dÃ¼ÅŸer zaman saat gÃ¼nlÃ¼ÄŸÃ¼',0),(563657,15658,'pl','Godziny nadliczbowe odlicza prosto czas podczas rejestrowania godziny',0),(563658,15658,'bg','Ð˜Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´ÐµÐ½ Ñ‚Ñ€ÑƒÐ´ Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð° Ð¾Ñ‚ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ðµ ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð²Ð»ÐµÐ·ÐµÑ‚Ðµ Ñ‡Ð°ÑÐ°',0),(563659,15658,'ur','Ø§ÙˆÙˆØ±Ù¹Ø§Ø¦Ù… Ø¯Ø§Ø¯ÙˆÚ©ØªØ³ Ø³Û’ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÙˆÙ‚Øª Ø¬Ø¨ Ú¯Ú¾Ù†Ù¹Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù†Ø§Ù…Û Ù†Ú¯Ø§Ø±ÛŒ',0),(563660,15658,'sr','ÐŸÑ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ñ€Ð°Ð´ Ð¾Ð´Ð±Ð¸Ñ˜Ð° Ð¾Ð´ Ð¿Ñ€Ð°Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ðµ Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ€Ð°ÑšÐ° ÑÐ°Ñ‚Ð¸',0),(563661,15658,'vi','LÃ m thÃªm giá» sai trá»« tá»« tháº³ng thá»i gian khi Ä‘Äƒng nháº­p giá»',0),(563662,15658,'af','Oortyd trek uit reguit wanneer teken uur tyd',0),(563663,15658,'ro','Prelungirile deduce din drept timp cÃ®nd Logging ore',0),(563664,15658,'et','ÃœletunnitÃ¶Ã¶ lahutab: sirge ajal kui metsaraie tundi',0),(563665,15658,'si','Nadure, odÅ¡teje od ravno Äas, ko se prijavite ur',0),(563666,15658,'ba','Lembur memotong dari lurus waktu ketika login jam',0),(563667,15658,'nl','Overuren opstellen in mindering van Straight tijd tijdens de registratie van uren',0),(563668,15658,'fi','YlityÃ¶ vÃ¤hentÃ¤Ã¤ suoraan aika kirjautumisen tunti',0),(563669,15658,'no','Overtid trekker fra rett nÃ¥r Logging timer',0),(563670,15658,'da','Overarbejde fratrÃ¦kker fra Straight nÃ¥r du logge timer',0),(563671,15658,'ko','ì§ì„ ì—ì„œ ê³µì œ ì´ˆê³¼ ì‹œê°„ ì‹œê°„ì„ ë¡œê·¸ì¸ í•  ë•Œ',0),(563672,15658,'he','×©×¢×•×ª × ×•×¡×¤×•×ª ×ž× ×›×” ×ž×Ÿ ×™×©×¨ ×œ××—×¨ ×¨×™×©×•× ×©×¢×•×ª',0),(563673,15658,'el','Î¥Ï€ÎµÏÏ‰ÏÎ¯ÎµÏ‚ Î±Ï†Î±Î¹ÏÎµÎ¯ Î±Ï€ÏŒ ÎºÎ±Ï„ÎµÏ…Î¸ÎµÎ¯Î±Î½ Ï†Î¿ÏÎ¬ ÎºÎ±Ï„Î¬ Ï„Î· ÏƒÏÎ½Î´ÎµÏƒÎ· ÏŽÏÎµÏ‚',0),(563674,15658,'zh','ä»Žç›´æ‰£å‡çš„åŠ ç­æ—¶é—´ç™»å½•å°æ—¶æ—¶',0),(563675,15658,'sv','Ã–vertid drar frÃ¥n stege nÃ¤r loggning timmar',0),(563676,15658,'it','Lavoro straordinario detrae da direttamente durante la registrazione ore del tempo',0),(563677,15658,'tl','',0),(563678,15658,'th','à¸—à¸³à¸‡à¸²à¸™à¸¥à¹ˆà¸§à¸‡à¹€à¸§à¸¥à¸²à¸—à¸µà¹ˆà¸«à¸±à¸à¸ˆà¸²à¸à¸•à¸£à¸‡à¹€à¸§à¸¥à¸²à¹€à¸¡à¸·à¹ˆà¸­à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(563679,15658,'hi','à¤“à¤µà¤°à¤Ÿà¤¾à¤‡à¤® à¤¸à¥‡ à¤¸à¥€à¤§à¥‡ Deducts à¤œà¤¬ à¤²à¥‰à¤—à¤¿à¤‚à¤— à¤˜à¤‚à¤Ÿà¥‡ à¤¸à¤®à¤¯',0),(563680,15658,'ms','Kerja memotong dari terus masa apabila log jam',0),(563681,15658,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ ÙˆÙŠØ®ØµÙ… Ù…Ù† Ù…Ø³ØªÙ‚ÙŠÙ… Ø§Ù„ÙˆÙ‚Øª Ø¹Ù†Ø¯ ØªØ³Ø¬ÙŠÙ„ Ø³Ø§Ø¹Ø§Øª',0),(563682,15658,'fr','Heures supplÃ©mentaires dÃ©duit directement lors de l\'enregistrement des heures de temps',0),(563683,15658,'jp','ã‚¹ãƒˆãƒ¬ãƒ¼ãƒˆã‹ã‚‰è¶…éŽæŽ§é™¤æ™‚é–“ã‚’ãƒ­ã‚°ã‚¤ãƒ³æ™‚',0),(563684,15658,'pt','Horas extras deduz de direto o tempo quando registrando horas',0),(563685,15658,'ru','Ð¡Ð²ÐµÑ€Ñ…ÑƒÑ€Ð¾Ñ‡Ð½Ñ‹Ðµ Ð²Ñ‹Ñ‡Ð¸Ñ‚Ð°ÐµÑ‚ Ð¸Ð· Ð¿Ñ€ÑÐ¼Ð¾Ð¹ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ð¿Ñ€Ð¸ Ð²Ñ…Ð¾Ð´Ðµ Ñ‡Ð°ÑÐ¾Ð²',0),(563686,15658,'es','Resta de horas extras de recto hora horas',0),(563687,15658,'de','Ãœberstunden zieht von gerade mal beim Protokollieren von Stunden',0),(563688,15658,'en','Overtime Deducts From Straight Time When Logging Hours',0),(563689,15659,'is','',0),(563690,15659,'dr','Ù„Ø·ÙØ§ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±ÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(563691,15659,'pr','Ù„Ø·ÙØ§ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø§Ø±ÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(563692,15659,'tr','Fazla mesai seÃ§iniz',0),(563693,15659,'pl','ProszÄ™ wybraÄ‡ nadgodziny',0),(563694,15659,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¸Ð·Ð²ÑŠÐ½Ñ€ÐµÐ´ÐµÐ½ Ñ‚Ñ€ÑƒÐ´',0),(563695,15659,'ur','Ø§ÙˆÙˆØ±Ù¹Ø§Ø¦Ù… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(563696,15659,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐºÐ¾Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸ Ñ€Ð°Ð´',0),(563697,15659,'vi','Vui lÃ²ng chá»n thá»i gian bÃ¹ giá»',0),(563698,15659,'af','Kies asseblief oortyd',0),(563699,15659,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i orele suplimentare',0),(563700,15659,'et','Palun valige Ã¼letunnitÃ¶Ã¶',0),(563701,15659,'si','Izberite nadure',0),(563702,15659,'ba','Silakan pilih lembur',0),(563703,15659,'nl','Selecteer overuren',0),(563704,15659,'fi','Valitse ylityÃ¶n',0),(563705,15659,'no','Velg overtid',0),(563706,15659,'da','VÃ¦lg venligst overarbejde',0),(563707,15659,'ko','ì´ˆê³¼ ìž‘ì—… ì‹œê°„ì„ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(563708,15659,'he','× × ×‘×—×¨ ×©×¢×•×ª × ×•×¡×¤×•×ª',0),(563709,15659,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Ï…Ï€ÎµÏÏ‰ÏÎ¯ÎµÏ‚',0),(563710,15659,'zh','è¯·é€‰æ‹©åŠ ç­',0),(563711,15659,'sv','VÃ¤nligen vÃ¤lj Ã¶vertid',0),(563712,15659,'it','Si prega di selezionare gli straordinari',0),(563713,15659,'tl','',0),(563714,15659,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸¥à¸·à¸­à¸à¸„à¹ˆà¸²à¸¥à¹ˆà¸§à¸‡à¹€à¸§à¸¥à¸²',0),(563715,15659,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤¸à¤®à¤¯ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(563716,15659,'ms','Sila pilih bayaran kerja lebih masa',0),(563717,15659,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ø§Ù„ÙˆÙ‚Øª Ø§Ù„Ø¥Ø¶Ø§ÙÙŠ',0),(563718,15659,'fr','Veuillez sÃ©lectionner les heures supplÃ©mentaires',0),(563719,15659,'jp','è¶…éŽä½œæ¥­æ™‚é–“ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(563720,15659,'pt','Por favor selecione a hora extra',0),(563721,15659,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ, Ð¿Ð¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, ÑÐ²ÐµÑ€Ñ…ÑƒÑ€Ð¾Ñ‡Ð½Ñ‹Ðµ',0),(563722,15659,'es','Por favor, seleccione las horas extraordinarias',0),(563723,15659,'de','Bitte wÃ¤hlen Sie Ãœberstunden',0),(563724,15659,'en','Please Select Overtime',0),(563725,15660,'is','',0),(563726,15660,'dr','Ù„Ø·ÙØ§ Ø²Ù…Ø§Ù† Ø±Ø§Ø³Øª Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(563727,15660,'pr','Ù„Ø·ÙØ§ Ø²Ù…Ø§Ù† Ø±Ø§Ø³Øª Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(563728,15660,'tr','LÃ¼tfen dÃ¼z saati seÃ§in',0),(563729,15660,'pl','Wybierz czas prosto',0),(563730,15660,'bg','ÐœÐ¾Ð»Ñ Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð²Ð¸ Ð²Ñ€ÐµÐ¼Ðµ',0),(563731,15660,'ur','Ø³ÛŒØ¯Ú¾ÛŒ ÙˆÙ‚Øª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(563732,15660,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð²Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(563733,15660,'vi','Vui lÃ²ng chá»n thá»i gian tháº³ng',0),(563734,15660,'af','Kies asseblief reguit tyd',0),(563735,15660,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i drepte timp',0),(563736,15660,'et','Palun valige sirge aeg',0),(563737,15660,'si','Izberite ravno Äas',0),(563738,15660,'ba','Silahkan pilih waktu lurus',0),(563739,15660,'nl','Selecteer rechte tijd',0),(563740,15660,'fi','Valitse Straight Time',0),(563741,15660,'no','Velg rett tid',0),(563742,15660,'da','VÃ¦lg venligst lige tid',0),(563743,15660,'ko','ë°”ë¡œ ì‹œê°„ì„ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(563744,15660,'he','× × ×‘×—×¨ ×–×ž×Ÿ ×™×©×¨',0),(563745,15660,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ ÏƒÏ…Î½ÎµÏ‡ÏŒÎ¼ÎµÎ½Î· Ï†Î¿ÏÎ¬',0),(563746,15660,'zh','è¯·é€‰æ‹©ç›´æ—¶é—´',0),(563747,15660,'sv','VÃ¤nligen vÃ¤lj raka tid',0),(563748,15660,'it','Si prega di selezionare volta dritto',0),(563749,15660,'tl','',0),(563750,15660,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸¥à¸·à¸­à¸à¹€à¸§à¸¥à¸²à¸—à¸µà¹ˆà¸•à¸£à¸‡',0),(563751,15660,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¥€à¤§à¥‡ à¤¸à¤®à¤¯ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(563752,15660,'ms','Sila pilih masa yang lurus',0),(563753,15660,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ ÙˆÙ‚Øª Ù…Ø³ØªÙ‚ÙŠÙ…',0),(563754,15660,'fr','S\'il vous plaÃ®t sÃ©lectionnez temps simple',0),(563755,15660,'jp','ã‚¹ãƒˆãƒ¬ãƒ¼ãƒˆã®æ™‚é–“ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(563756,15660,'pt','Por favor, selecione o tempo em linha reta',0),(563757,15660,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ€Ð°Ð· Ð¿Ð¾Ð´Ñ€ÑÐ´',0),(563758,15660,'es','Por favor, seleccione el tiempo',0),(563759,15660,'de','Bitte wÃ¤hlen Sie gerade mal',0),(563760,15660,'en','Please Select Straight Time',0),(563761,15661,'is','',0),(563762,15661,'dr','Ù…Ù‚ÛŒØ§Ø³ Ø³Ø§Ø¹Øª',0),(563763,15661,'pr','Ù…Ù‚ÛŒØ§Ø³ Ø³Ø§Ø¹Øª',0),(563764,15661,'tr','Ã–lÃ§ek saat',0),(563765,15661,'pl','Skali godzin',0),(563766,15661,'bg','ÐœÐ°Ñ‰Ð°Ð± Ñ‡Ð°ÑÐ°',0),(563767,15661,'ur','Ù¾ÛŒÙ…Ø§Ù†Û Ú¯Ú¾Ù†Ù¹Û’',0),(563768,15661,'sr','Ð¡ÐºÐ°Ð»Ð° ÑÐ°Ñ‚Ð°',0),(563769,15661,'vi','Quy mÃ´ giá»',0),(563770,15661,'af','Skaal ure',0),(563771,15661,'ro','ScarÄƒ de ore',0),(563772,15661,'et','Skaala tundi',0),(563773,15661,'si','Obsega ur',0),(563774,15661,'ba','Skala jam',0),(563775,15661,'nl','Omvang uren',0),(563776,15661,'fi','Mittakaavassa tuntia',0),(563777,15661,'no','Skala timer',0),(563778,15661,'da','Skala timer',0),(563779,15661,'ko','ê·œëª¨ ì‹œê°„',0),(563780,15661,'he','×”×™×§×£ ×©×¢×•×ª',0),(563781,15661,'el','ÎšÎ»Î¯Î¼Î±ÎºÎ± ÏŽÏÎµÏ‚',0),(563782,15661,'zh','è§„æ¨¡å°æ—¶',0),(563783,15661,'sv','Skala timmar',0),(563784,15661,'it','Scala ore',0),(563785,15661,'tl','',0),(563786,15661,'th','à¸¡à¸²à¸•à¸£à¸²à¸ªà¹ˆà¸§à¸™à¹€à¸§à¸¥à¸²',0),(563787,15661,'hi','à¤ªà¥ˆà¤®à¤¾à¤¨à¥‡ à¤ªà¤° à¤˜à¤‚à¤Ÿà¥‡',0),(563788,15661,'ms','Skala waktu',0),(563789,15661,'ar','Ù…Ù‚ÙŠØ§Ø³ Ø³Ø§Ø¹Ø§Øª',0),(563790,15661,'fr','Heures d\'Ã©chelle',0),(563791,15661,'jp','æ™‚é–“ã‚¹ã‚±ãƒ¼ãƒ«ã—ã¾ã™ã€‚',0),(563792,15661,'pt','Horas de escala',0),(563793,15661,'ru','Ð¨ÐºÐ°Ð»Ñ‹ Ñ‡Ð°ÑÐ¾Ð²',0),(563794,15661,'es','Escala horas',0),(563795,15661,'de','Skala-Stunden',0),(563796,15661,'en','Scale Hours',0),(563797,15662,'is','',0),(563798,15662,'dr','Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§ÛŒ ØªØ§Ø±ÛŒØ® Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(563799,15662,'pr','Ø¬Ø¹Ø¨Ù‡ Ù‡Ø§ÛŒ ØªØ§Ø±ÛŒØ® Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù‡Ù†Ú¯Ø§Ù…ÛŒ Ú©Ù‡ Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(563800,15662,'tr','Saat oturum sÄ±rasÄ±nda gÃ¶steri Tarih kutularÄ±',0),(563801,15662,'pl','PokaÅ¼ pola daty, gdy rejestrowanie godzin',0),(563802,15662,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð¹ Ð´Ð°Ñ‚Ð°Ñ‚Ð° ÐºÑƒÑ‚Ð¸Ð¸ Ð¿Ñ€Ð¸ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ñ‡Ð°ÑÐ°',0),(563803,15662,'ur','ØªØ§Ø±ÛŒØ® Ú©Û’ Ø®Ø§Ù†ÙˆÚº Ù…ÛŒÚº Ø¬Ø¨ Ú¯Ú¾Ù†Ù¹Û’ Ù„Ø§Ú¯Ù†Ú¯ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº Û”',0),(563804,15662,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ñ™Ð° Ð·Ð° Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ€Ð°ÑšÐ° ÑÐ°Ñ‚Ð¸',0),(563805,15662,'vi','Hiá»ƒn thá»‹ ngÃ y há»™p khi Ä‘Äƒng nháº­p giá»',0),(563806,15662,'af','Datum bokse wys wanneer teken ure',0),(563807,15662,'ro','AratÄƒ data cutii cÃ®nd Logging ore',0),(563808,15662,'et','NÃ¤ita kuupÃ¤eva vÃ¤ljadele kui metsaraie tundi',0),(563809,15662,'si','Prikazani polji Datum ob prijavi ur',0),(563810,15662,'ba','Tampilkan tanggal kotak ketika login jam',0),(563811,15662,'nl','Toon datumvakken tijdens de registratie van uren',0),(563812,15662,'fi','NÃ¤ytÃ¤ PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ruudut kirjautuessasi tuntia',0),(563813,15662,'no','Vis datobokser nÃ¥r du logger timer',0),(563814,15662,'da','Vis datofelter, nÃ¥r der logges timer',0),(563815,15662,'ko','ì‹œê°„ì„ ë¡œê·¸ì¸ í•  ë•Œ ë‚ ì§œ ìƒìž í‘œì‹œ',0),(563816,15662,'he','×”×¦×’ ×ª×™×‘×•×ª ×ª××¨×™×›×™× ×‘×¢×ª ×¨×™×©×•× ×©×¢×•×ª',0),(563817,15662,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Î»Î±Î¯ÏƒÎ¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±Ï‚ ÎºÎ±Ï„Î¬ Ï„Î· ÏƒÏÎ½Î´ÎµÏƒÎ· ÏŽÏÎµÏ‚',0),(563818,15662,'zh','æ˜¾ç¤ºæ—¥æœŸæ¡†ç™»å½•å°æ—¶æ—¶',0),(563819,15662,'sv','Visa datumrutor nÃ¤r loggning timmar',0),(563820,15662,'it','Visualizza caselle di data durante la registrazione ore',0),(563821,15662,'tl','',0),(563822,15662,'th','à¹à¸ªà¸”à¸‡à¸§à¸±à¸™à¸à¸¥à¹ˆà¸­à¸‡à¹€à¸¡à¸·à¹ˆà¸­à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(563823,15662,'hi','à¤œà¤¬ à¤˜à¤‚à¤Ÿà¥‡ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¬à¥‰à¤•à¥à¤¸ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(563824,15662,'ms','Menunjukkan kotak tarikh apabila log jam',0),(563825,15662,'ar','ØªØ¸Ù‡Ø± Ù…Ø±Ø¨Ø¹Ø§Øª Ø§Ù„ØªØ§Ø±ÙŠØ® Ø¹Ù†Ø¯ ØªØ³Ø¬ÙŠÙ„ Ø³Ø§Ø¹Ø§Øª',0),(563826,15662,'fr','Afficher des boÃ®tes de Date lorsque vous vous connectez heures',0),(563827,15662,'jp','æ™‚é–“ã‚’ãƒ­ã‚°ã‚¤ãƒ³ã™ã‚‹ã¨ãæ—¥ä»˜ãƒœãƒƒã‚¯ã‚¹ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(563828,15662,'pt','Mostrar caixas de data quando registrando horas',0),(563829,15662,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ð¾Ð»Ñ Ð´Ð°Ñ‚ Ð¿Ñ€Ð¸ Ð²Ñ…Ð¾Ð´Ðµ Ñ‡Ð°ÑÐ¾Ð²',0),(563830,15662,'es','Mostrar fecha cajas cuando horas',0),(563831,15662,'de','Karte von Datumsfeldern beim Protokollieren von Stunden',0),(563832,15662,'en','Show Date Boxes When Logging Hours',0),(563833,15663,'is','',0),(563834,15663,'dr','Ù…ØªÙˆØ§Ù„ÛŒ',0),(563835,15663,'pr','Ù…ØªÙˆØ§Ù„ÛŒ',0),(563836,15663,'tr','DÃ¼z zaman',0),(563837,15663,'pl','Prosto po raz',0),(563838,15663,'bg','ÐŸÑ€Ð°Ð² Ð¿ÑŠÑ‚',0),(563839,15663,'ur','Ù…Ø±ØªØ¨Û',0),(563840,15663,'sr','ÐŸÑƒÑ‚ Ð·Ð°Ñ€ÐµÐ´Ð¾Ð¼',0),(563841,15663,'vi','Thá»i gian tháº³ng',0),(563842,15663,'af','Reguit tyd',0),(563843,15663,'ro','Timp drepte',0),(563844,15663,'et','Sirge aeg',0),(563845,15663,'si','Ravno Äas',0),(563846,15663,'ba','Waktu lurus',0),(563847,15663,'nl','Rechte tijd',0),(563848,15663,'fi','Straight Time',0),(563849,15663,'no','Arbeidstid',0),(563850,15663,'da','Lige tid',0),(563851,15663,'ko','ì—°ì† ì‹œê°„',0),(563852,15663,'he','×–×ž×Ÿ ×™×©×¨',0),(563853,15663,'el','Î£Ï…Î½ÎµÏ‡ÏŒÎ¼ÎµÎ½Î· Ï†Î¿ÏÎ¬',0),(563854,15663,'zh','è¿žç»­æ—¶é—´',0),(563855,15663,'sv','Raka tid',0),(563856,15663,'it','Straight Time',0),(563857,15663,'tl','',0),(563858,15663,'th','à¸•à¸£à¸‡à¹€à¸§à¸¥à¸²',0),(563859,15663,'hi','à¤¸à¥€à¤§à¥‡ à¤¸à¤®à¤¯',0),(563860,15663,'ms','Masa yang lurus',0),(563861,15663,'ar','Ø§Ù„ÙˆÙ‚Øª Ù…Ø³ØªÙ‚ÙŠÙ…',0),(563862,15663,'fr','Temps simple',0),(563863,15663,'jp','ã‚¹ãƒˆãƒ¬ãƒ¼ãƒˆæ™‚',0),(563864,15663,'pt','Tempo em linha reta',0),(563865,15663,'ru','Ð Ð°Ð· Ð¿Ð¾Ð´Ñ€ÑÐ´',0),(563866,15663,'es','Vez consecutiva',0),(563867,15663,'de','Gerade mal',0),(563868,15663,'en','Straight Time',0),(563869,15664,'is','',0),(563870,15664,'dr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†',0),(563871,15664,'pr','ØªÙ…ÛŒØ² Ú©Ø±Ø¯Ù†',0),(563872,15664,'tr','Temizlik',0),(563873,15664,'pl','SprzÄ…tanie',0),(563874,15664,'bg','ÐŸÐ¾Ñ‡Ð¸ÑÑ‚Ð²Ð°Ð½Ðµ Ð½Ð°',0),(563875,15664,'ur','ØµØ§Ù Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(563876,15664,'sr','Ð§Ð¸ÑˆÑ›ÐµÑšÐµ',0),(563877,15664,'vi','LÃ m sáº¡ch lÃªn',0),(563878,15664,'af','Opruim',0),(563879,15664,'ro','CurÄƒÅ£area',0),(563880,15664,'et','Puhastamine',0),(563881,15664,'si','ÄŒiÅ¡Äenje',0),(563882,15664,'ba','Membersihkan',0),(563883,15664,'nl','Opruimen',0),(563884,15664,'fi','Puhdistaminen',0),(563885,15664,'no','Opprydding',0),(563886,15664,'da','Oprydning',0),(563887,15664,'ko','ì •ë¦¬',0),(563888,15664,'he','×ž× ×§×”',0),(563889,15664,'el','ÎšÎ±Î¸Î±ÏÎ¹ÏƒÎ¼ÏŒ',0),(563890,15664,'zh','æ¸…ç†',0),(563891,15664,'sv','StÃ¤da upp',0),(563892,15664,'it','Pulizia',0),(563893,15664,'tl','',0),(563894,15664,'th','à¸—à¸³à¸„à¸§à¸²à¸¡à¸ªà¸°à¸­à¸²à¸”',0),(563895,15664,'hi','à¤•à¥à¤²à¥€à¤¨ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(563896,15664,'ms','Membersihkan',0),(563897,15664,'ar','ØªÙ†Ø¸ÙŠÙ',0),(563898,15664,'fr','Nettoyage de',0),(563899,15664,'jp','ã‚¯ãƒªãƒ¼ãƒ³ã‚¢ãƒƒãƒ—',0),(563900,15664,'pt','Limpeza de',0),(563901,15664,'ru','ÐžÑ‡Ð¸ÑÑ‚ÐºÐ°',0),(563902,15664,'es','Limpieza de',0),(563903,15664,'de','AufrÃ¤umen',0),(563904,15664,'en','Cleaning Up',0),(563905,15665,'is','',0),(563906,15665,'dr','Ù…Ù‚Ø§ÛŒØ³Ù‡ Ø³Ø§Ø®ØªØ§Ø± Ø¨Ø§Ù†Ú© Ø§Ø·Ù„Ø§Ø¹Ø§ØªÛŒ',0),(563907,15665,'pr','Ù…Ù‚Ø§ÛŒØ³Ù‡ Ø³Ø§Ø®ØªØ§Ø± Ø¨Ø§Ù†Ú© Ø§Ø·Ù„Ø§Ø¹Ø§ØªÛŒ',0),(563908,15665,'tr','VeritabanÄ± yapÄ±sÄ± karÅŸÄ±laÅŸtÄ±rma',0),(563909,15665,'pl','PorÃ³wnanie struktury bazy danych',0),(563910,15665,'bg','Ð¡Ñ€Ð°Ð²Ð½ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ñ€ÑƒÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸',0),(563911,15665,'ur','ÚˆÛŒÙ¹Ø§ Ø¨ÛŒØ³ ÚˆÚ¾Ø§Ù†Ú†Û’ Ú©Ø§ Ù…ÙˆØ§Ø²Ù†Û',0),(563912,15665,'sr','ÐŸÐ¾Ñ€ÐµÑ’ÐµÑšÐµ ÑÑ‚Ñ€ÑƒÐºÑ‚ÑƒÑ€Ñƒ Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(563913,15665,'vi','So sÃ¡nh cáº¥u trÃºc cÆ¡ sá»Ÿ dá»¯ liá»‡u',0),(563914,15665,'af','Vergelyk databasis struktuur',0),(563915,15665,'ro','Compararea structurii bazei de date',0),(563916,15665,'et','VÃµrreldes andmebaasi struktuuri',0),(563917,15665,'si','Primerja zgradbo zbirke podatkov',0),(563918,15665,'ba','Membandingkan struktur Database',0),(563919,15665,'nl','Vergelijken van de databasestructuur',0),(563920,15665,'fi','Verrataan tietokannan rakenne',0),(563921,15665,'no','Sammenligne databasestrukturen',0),(563922,15665,'da','Sammenligne databasestruktur',0),(563923,15665,'ko','ë°ì´í„°ë² ì´ìŠ¤ êµ¬ì¡°ë¥¼ ë¹„êµ',0),(563924,15665,'he','×”×©×•×•××” ×‘×™×Ÿ ×ž×‘× ×” ×ž×¡×“ ×”× ×ª×•× ×™×',0),(563925,15665,'el','Î£Ï…Î³ÎºÏÎ¯Î½Î¿Î½Ï„Î±Ï‚ Ï„Î· Î´Î¿Î¼Î® Ï„Î·Ï‚ Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(563926,15665,'zh','æ¯”è¾ƒæ•°æ®åº“ç»“æž„',0),(563927,15665,'sv','JÃ¤mfÃ¶ra databasstrukturen',0),(563928,15665,'it','Confrontando la struttura del Database',0),(563929,15665,'tl','',0),(563930,15665,'th','à¹€à¸›à¸£à¸µà¸¢à¸šà¹€à¸—à¸µà¸¢à¸šà¹‚à¸„à¸£à¸‡à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(563931,15665,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤‚à¤°à¤šà¤¨à¤¾ à¤•à¥€ à¤¤à¥à¤²à¤¨à¤¾',0),(563932,15665,'ms','Membandingkan struktur pangkalan data',0),(563933,15665,'ar','Ù…Ù‚Ø§Ø±Ù†Ø© Ù‡ÙŠÙƒÙ„ Ù‚Ø§Ø¹Ø¯Ø© Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(563934,15665,'fr','En comparant la Structure de base de donnÃ©es',0),(563935,15665,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹æ§‹é€ ã®æ¯”è¼ƒ',0),(563936,15665,'pt','Comparando a estrutura de banco de dados',0),(563937,15665,'ru','Ð¡Ñ€Ð°Ð²Ð½ÐµÐ½Ð¸Ðµ ÑÑ‚Ñ€ÑƒÐºÑ‚ÑƒÑ€Ñ‹ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(563938,15665,'es','Comparando la estructura de la base de datos',0),(563939,15665,'de','Vergleich der Datenbankstruktur',0),(563940,15665,'en','Comparing Database Structure',0),(563941,15666,'is','',0),(563942,15666,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ù…ÙˆÙ‚Øª',0),(563943,15666,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ø¬Ø¯ÙˆÙ„ Ù…ÙˆÙ‚Øª',0),(563944,15666,'tr','GeÃ§ici tablo oluÅŸturma',0),(563945,15666,'pl','Tworzenie tabela tymczasowa',0),(563946,15666,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(563947,15666,'ur','Ø¹Ø§Ø±Ø¶ÛŒ Ø¬Ø¯ÙˆÙ„ Ø¨Ù†Ø§ Ø±ÛØ§ ÛÛ’',0),(563948,15666,'sr','ÐŸÑ€Ð¸Ð²Ñ€ÐµÐ¼ÐµÐ½Ðµ Ñ‚Ð°Ð±ÐµÐ»Ðµ',0),(563949,15666,'vi','Táº¡o báº£ng táº¡m thá»i',0),(563950,15666,'af','Skep van tydelike tafel',0),(563951,15666,'ro','Creare tabel temporar',0),(563952,15666,'et','Loomine ajutine tabel',0),(563953,15666,'si','Ustvarjanje zaÄasne tabele',0),(563954,15666,'ba','Membuat tabel sementara',0),(563955,15666,'nl','Tijdelijke tabel maken',0),(563956,15666,'fi','Luo vÃ¤liaikainen taulukko',0),(563957,15666,'no','Opprette midlertidig tabell',0),(563958,15666,'da','Skabe midlertidig tabel',0),(563959,15666,'ko','ìž„ì‹œ í…Œì´ë¸”ì„ ë§Œë“œëŠ”',0),(563960,15666,'he','×™×¦×™×¨×ª ×˜×‘×œ×” ×–×ž× ×™×ª',0),(563961,15666,'el','Î¤Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€ÏÎ¿ÏƒÏ‰ÏÎ¹Î½Î¿Ï Ï€Î¯Î½Î±ÎºÎ±',0),(563962,15666,'zh','åˆ›å»ºä¸´æ—¶è¡¨',0),(563963,15666,'sv','Skapa temporÃ¤r tabell',0),(563964,15666,'it','Creazione tabella temporanea',0),(563965,15666,'tl','',0),(563966,15666,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸•à¸²à¸£à¸²à¸‡à¸Šà¸±à¹ˆà¸§à¸„à¸£à¸²à¸§',0),(563967,15666,'hi','à¤…à¤¸à¥à¤¥à¤¾à¤¯à¥€ à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤¬à¤¨à¤¾ à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(563968,15666,'ms','Mewujudkan Jadual sementara',0),(563969,15666,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¬Ø¯ÙˆÙ„ Ù…Ø¤Ù‚Øª',0),(563970,15666,'fr','CrÃ©ation d\'une Table temporaire',0),(563971,15666,'jp','ä¸€æ™‚ãƒ†ãƒ¼ãƒ–ãƒ«ã®ä½œæˆ',0),(563972,15666,'pt','Criando a tabela temporÃ¡ria',0),(563973,15666,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð½Ð¾Ð¹ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(563974,15666,'es','Crear tabla temporal',0),(563975,15666,'de','TemporÃ¤re Tabelle erstellen',0),(563976,15666,'en','Creating Temporary Table',0),(563977,15667,'is','',0),(563978,15667,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù…ÛŒØ±Ø§Ø« Ø¯Ø³ÛŒ Ø¨Ù„',0),(563979,15667,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù…ÛŒØ±Ø§Ø« Ø¯Ø³ÛŒ Ø¨Ù„',0),(563980,15667,'tr','Eski DB gÃ¼ncelleÅŸtirme denetimi',0),(563981,15667,'pl','Sprawdzanie aktualizacji starszych DB',0),(563982,15667,'bg','ÐÐ°ÑÐ»ÐµÐ´ÐµÐ½Ð¸ DB Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(563983,15667,'ur','ÙˆØ±Ø«Û DB Ø§Ù¾ ÚˆÛŒÙ¹ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(563984,15667,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð·Ð°ÑÑ‚Ð°Ñ€ÐµÐ»Ð¸Ñ… Ð”Ð‘',0),(563985,15667,'vi','Kiá»ƒm tra Cáº­p Nháº­t di sáº£n DB',0),(563986,15667,'af','Verouderde DB werk kontroleer',0),(563987,15667,'ro','MoÅŸtenire DB Update a verifica',0),(563988,15667,'et','PÃ¤rand DB vÃ¤rskendamine sisse',0),(563989,15667,'si','ZapuÅ¡Äina DB modernizirati Äek',0),(563990,15667,'ba','Pemeriksaan pemutakhiran warisan DB',0),(563991,15667,'nl','Oudere DB Update Check',0),(563992,15667,'fi','PerintÃ¶ DB pÃ¤ivitysten tarkistaminen',0),(563993,15667,'no','Eldre DB oppdatere sjekk',0),(563994,15667,'da','Ã†ldre DB opdateringskontrol',0),(563995,15667,'ko','ë ˆê±°ì‹œ DB ì—…ë°ì´íŠ¸ í™•ì¸',0),(563996,15667,'he','×‘×“×™×§×ª ×¢×“×›×•× ×™× DB ×ž×“×•×¨ ×§×•×“×',0),(563997,15667,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ‰Î½ Ï€Î±Î»Î±Î¹Î¿Ï Ï„ÏÏ€Î¿Ï… DB',0),(563998,15667,'zh','æ—§ç‰ˆ DB æ›´æ–°æ£€æŸ¥',0),(563999,15667,'sv','Ã„ldre DB Uppdatera Check',0),(564000,15667,'it','Controllo di aggiornamento DB legacy',0),(564001,15667,'tl','',0),(564002,15667,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸”à¸±à¹‰à¸‡à¹€à¸”à¸´à¸¡ DB',0),(564003,15667,'hi','à¤²à¥€à¤—à¥‡à¤¸à¥€ DB à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(564004,15667,'ms','Legasi DB Kemaskini Daftar',0),(564005,15667,'ar','Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„ØªØ­Ø¯ÙŠØ« DB Ø§Ù„Ù‚Ø¯ÙŠÙ…Ø©',0),(564006,15667,'fr','ContrÃ´le de mise Ã  jour de Legacy DB',0),(564007,15667,'jp','å¾“æ¥ã® DB æ›´æ–°ãƒã‚§ãƒƒã‚¯',0),(564008,15667,'pt','VerificaÃ§Ã£o de atualizaÃ§Ã£o do legado de DB',0),(564009,15667,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ ÑƒÑÑ‚Ð°Ñ€ÐµÐ²ÑˆÐ¸Ñ… DB',0),(564010,15667,'es','VerificaciÃ³n de actualizaciÃ³n DB Legacy',0),(564011,15667,'de','Ã„ltere DB Update Check',0),(564012,15667,'en','Legacy DB Update Check',0),(564013,15668,'is','',0),(564014,15668,'dr','Ø¨Ù„ Ø¢Ù…Ø§Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(564015,15668,'pr','Ø¨Ù„ Ø¢Ù…Ø§Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(564016,15668,'tr','DB gÃ¼ncelleÅŸtirmesi hazÄ±rlanÄ±yor',0),(564017,15668,'pl','Przygotowanie DB do aktualizacji',0),(564018,15668,'bg','ÐŸÐ¾Ð´Ð³Ð¾Ñ‚Ð¾Ð²ÐºÐ° Ð½Ð° DB Ð·Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ',0),(564019,15668,'ur','DB ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Û’ Ù„ÛŒÛ’ ØªÛŒØ§Ø± Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(564020,15668,'sr','ÐŸÑ€Ð¸Ð¿Ñ€ÐµÐ¼Ð° Ð”Ð‘ Ð·Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(564021,15668,'vi','Chuáº©n bá»‹ DB cho Cáº­p Nháº­t',0),(564022,15668,'af','DB voorbereiding vir werk',0),(564023,15668,'ro','PregÄƒtirea DB pentru actualizare',0),(564024,15668,'et','DB valmistub Update',0),(564025,15668,'si','Priprava DB za posodobitev',0),(564026,15668,'ba','Mempersiapkan DB untuk Update',0),(564027,15668,'nl','DB voorbereiden Update',0),(564028,15668,'fi','DB valmistellaan pÃ¤ivitystÃ¤',0),(564029,15668,'no','Forbereder DB oppdatering',0),(564030,15668,'da','Forberede Update DB',0),(564031,15668,'ko','DB ì—…ë°ì´íŠ¸ì— ëŒ€ í•œ ì¤€ë¹„',0),(564032,15668,'he','×”×›× ×ª DB ×¢×‘×•×¨ ×¢×“×›×•×Ÿ',0),(564033,15668,'el','Î ÏÎ¿ÎµÏ„Î¿Î¹Î¼Î±ÏƒÎ¯Î± DB Î³Î¹Î± Ï„Î·Î½ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î· Î­ÎºÎ´Î¿ÏƒÎ·',0),(564034,15668,'zh','DB æ­£åœ¨å‡†å¤‡æ›´æ–°',0),(564035,15668,'sv','FÃ¶rbereda DB fÃ¶r uppdatering',0),(564036,15668,'it','Preparazione aggiornamento DB',0),(564037,15668,'tl','',0),(564038,15668,'th','à¹€à¸•à¸£à¸µà¸¢à¸¡ DB à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(564039,15668,'hi','DB à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¯à¤¾à¤° à¤¹à¥‹ à¤°à¤¹à¤¾',0),(564040,15668,'ms','Menyediakan DB untuk Kemaskini',0),(564041,15668,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ DB Ù„Ù„ØªØ­Ø¯ÙŠØ«',0),(564042,15668,'fr','PrÃ©paration de DB pour mise Ã  jour',0),(564043,15668,'jp','DB ã®æ›´æ–°ã®æº–å‚™',0),(564044,15668,'pt','PreparaÃ§Ã£o de DB para atualizaÃ§Ã£o',0),(564045,15668,'ru','ÐŸÐ¾Ð´Ð³Ð¾Ñ‚Ð¾Ð²ÐºÐ° DB Ð´Ð»Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(564046,15668,'es','PreparaciÃ³n de DB para actualizaciÃ³n',0),(564047,15668,'de','DB vorbereiten Update',0),(564048,15668,'en','Preparing DB For Update',0),(564049,15669,'is','',0),(564050,15669,'dr','Ø®ÙˆØ§Ù†Ø¯Ù† ÙØ§ÛŒÙ„ Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¯Ø³ÛŒ Ø¨Ù„',0),(564051,15669,'pr','Ø®ÙˆØ§Ù†Ø¯Ù† ÙØ§ÛŒÙ„ Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¯Ø³ÛŒ Ø¨Ù„',0),(564052,15669,'tr','VeritabanÄ± gÃ¼ncelleÅŸtirme dosyasÄ± okuma',0),(564053,15669,'pl','Czytanie pliku aktualizacji DB',0),(564054,15669,'bg','Ð§ÐµÑ‚ÐµÐ½Ðµ DB Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ñ„Ð°Ð¹Ð»',0),(564055,15669,'ur','DB ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù…Ø³Ù„ Ù…Ø·Ø§Ù„Ø¹Û',0),(564056,15669,'sr','Ð§Ð¸Ñ‚Ð°ÑšÐµ Ð”Ð‘ ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(564057,15669,'vi','Äá»c DB Cáº­p nháº­t tá»‡p',0),(564058,15669,'af','Lees DB opdatering lÃªer',0),(564059,15669,'ro','Citirea fiÅŸierului de actualizare DB',0),(564060,15669,'et','DB Update faili lugemine',0),(564061,15669,'si','Branju DB Update datoteke',0),(564062,15669,'ba','Membaca DB Update File',0),(564063,15669,'nl','DB updatebestand lezen',0),(564064,15669,'fi','DB pÃ¤ivitystiedoston lukemisen',0),(564065,15669,'no','Lese DB oppdatere arkiv',0),(564066,15669,'da','LÃ¦sning DB opdateringsfilen',0),(564067,15669,'ko','DB ì—…ë°ì´íŠ¸ íŒŒì¼ ì½ê¸°',0),(564068,15669,'he','×§×¨×™××ª ×§×•×‘×¥ ×¢×“×›×•×Ÿ DB',0),(564069,15669,'el','Î‘Î½Î¬Î³Î½Ï‰ÏƒÎ· DB Î±ÏÏ‡ÎµÎ¯Î¿ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¼Î­Î½Î·Ï‚ Î­ÎºÎ´Î¿ÏƒÎ·Ï‚',0),(564070,15669,'zh','è¯»å–æ•°æ®åº“æ›´æ–°æ–‡ä»¶',0),(564071,15669,'sv','LÃ¤sa DB uppdateringsfil',0),(564072,15669,'it','Lettura File di aggiornamento del DB',0),(564073,15669,'tl','',0),(564074,15669,'th','à¸­à¹ˆà¸²à¸™à¹„à¸Ÿà¸¥à¹Œà¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(564075,15669,'hi','DB à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤ªà¤¢à¤¼à¤¤à¥‡',0),(564076,15669,'ms','Membaca fail Kemaskini DB',0),(564077,15669,'ar','Ù‚Ø±Ø§Ø¡Ø© Ù…Ù„Ù Ø§Ù„ØªØ­Ø¯ÙŠØ« DB',0),(564078,15669,'fr','Lecture de fichier de mise Ã  jour DB',0),(564079,15669,'jp','DB æ›´æ–°ãƒ•ã‚¡ã‚¤ãƒ«ã®èª­ã¿å–ã‚Š',0),(564080,15669,'pt','Lendo o arquivo de atualizaÃ§Ã£o do DB',0),(564081,15669,'ru','Ð§Ñ‚ÐµÐ½Ð¸Ðµ Ñ„Ð°Ð¹Ð»Ð° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ DB',0),(564082,15669,'es','Lectura DB archivo de actualizaciÃ³n',0),(564083,15669,'de','DB-Update-Datei lesen',0),(564084,15669,'en','Reading DB Update File',0),(564085,15670,'is','',0),(564086,15670,'dr','Ø´Ø±ÙˆØ¹ DB Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(564087,15670,'pr','Ø´Ø±ÙˆØ¹ DB Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(564088,15670,'tr','DB gÃ¼ncelleÅŸtirmesini baÅŸlatma',0),(564089,15670,'pl','Uruchamianie aktualizacji DB',0),(564090,15670,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð½Ð° Ð´Ð‘',0),(564091,15670,'ur','DB ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø´Ø±ÙˆØ¹ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(564092,15670,'sr','ÐŸÐ¾ÐºÑ€ÐµÑ‚Ð°ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ° Ð”Ð‘',0),(564093,15670,'vi','Báº¯t Ä‘áº§u Cáº­p Nháº­t DB',0),(564094,15670,'af','Begin DB bywerking',0),(564095,15670,'ro','Plecare DB actualizare',0),(564096,15670,'et','Alustades DB Update',0),(564097,15670,'si','ZaÄetni DB Update',0),(564098,15670,'ba','Mulai DB Update',0),(564099,15670,'nl','DB Update starten',0),(564100,15670,'fi','DB pÃ¤ivityksen aloittaminen',0),(564101,15670,'no','Starte DB oppdatering',0),(564102,15670,'da','Startende DB opdatering',0),(564103,15670,'ko','DB ì—…ë°ì´íŠ¸ ì‹œìž‘',0),(564104,15670,'he','×”×—×œ ×¢×“×›×•×Ÿ DB',0),(564105,15670,'el','ÎˆÎ½Î±ÏÎ¾Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚ DB',0),(564106,15670,'zh','å¼€å§‹æ•°æ®åº“æ›´æ–°',0),(564107,15670,'sv','Start DB uppdatering',0),(564108,15670,'it','A partire di aggiornamento DB',0),(564109,15670,'tl','',0),(564110,15670,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡ DB',0),(564111,15670,'hi','DB à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¶à¥à¤°à¥‚',0),(564112,15670,'ms','Permulaan DB Kemaskini',0),(564113,15670,'ar','Ø¨Ø¯Ø¡ ØªØ­Ø¯ÙŠØ« DB',0),(564114,15670,'fr','Mise Ã  jour de dÃ©part BD',0),(564115,15670,'jp','DB æ›´æ–°ã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(564116,15670,'pt','Iniciando a atualizaÃ§Ã£o DB',0),(564117,15670,'ru','ÐÐ°Ñ‡Ð¸Ð½Ð°Ñ Ñ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ DB',0),(564118,15670,'es','A partir de DB actualizaciÃ³n',0),(564119,15670,'de','DB-Update starten',0),(564120,15670,'en','Starting DB Update',0),(564121,15671,'is','',0),(564122,15671,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¨Ù‡ Ø²Ø¨Ø§Ù† Ø§Ù†Ú¯Ù„ÛŒØ³ÛŒ',0),(564123,15671,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¨Ù‡ Ø²Ø¨Ø§Ù† Ø§Ù†Ú¯Ù„ÛŒØ³ÛŒ',0),(564124,15671,'tr','Dil metin gÃ¼ncelleÅŸtiriliyor',0),(564125,15671,'pl','Aktualizowanie tekstu w jÄ™zyku',0),(564126,15671,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚ÐµÐºÑÑ‚ Ð½Ð° ÐµÐ·Ð¸Ðº',0),(564127,15671,'ur','Ø²Ø¨Ø§Ù† Ú©ÛŒ Ù…ØªÙ† Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(564128,15671,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ˜ÐµÐ·Ð¸Ðº Ñ‚ÐµÐºÑÑ‚Ð°',0),(564129,15671,'vi','Cáº­p Nháº­t vÄƒn báº£n ngÃ´n ngá»¯',0),(564130,15671,'af','Outobywerking taal teks',0),(564131,15671,'ro','Actualizarea limba textului',0),(564132,15671,'et','Ajakohastamine keeletekst',0),(564133,15671,'si','Posodabljanje besedila',0),(564134,15671,'ba','Memperbarui aksara',0),(564135,15671,'nl','Bijwerken van taal',0),(564136,15671,'fi','PÃ¤ivittÃ¤minen kieliteksti',0),(564137,15671,'no','Oppdatere sprÃ¥ktekst',0),(564138,15671,'da','Opdatere tekst',0),(564139,15671,'ko','ì–¸ì–´ í…ìŠ¤íŠ¸ ì—…ë°ì´íŠ¸',0),(564140,15671,'he','×¢×“×›×•×Ÿ ×˜×§×¡×˜ ×‘×©×¤×”',0),(564141,15671,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· ÎºÎµÎ¹Î¼Î­Î½Î¿Ï… Î³Î»ÏŽÏƒÏƒÎ±Ï‚',0),(564142,15671,'zh','æ›´æ–°è¯­è¨€æ–‡æœ¬',0),(564143,15671,'sv','Uppdatera sprÃ¥ktext',0),(564144,15671,'it','L\'aggiornamento del testo di lingua',0),(564145,15671,'tl','',0),(564146,15671,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸ à¸²à¸©à¸²',0),(564147,15671,'hi','à¤­à¤¾à¤·à¤¾ à¤ªà¤¾à¤  à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(564148,15671,'ms','Mengemaskini teks bahasa',0),(564149,15671,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ù†Øµ Ø¨Ø§Ù„Ù„ØºØ©',0),(564150,15671,'fr','Mise Ã  jour le texte en langue',0),(564151,15671,'jp','è¨€èªžãƒ†ã‚­ã‚¹ãƒˆã‚’æ›´æ–°',0),(564152,15671,'pt','Atualizar o texto de linguagem',0),(564153,15671,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚ÐµÐºÑÑ‚Ð° Ð½Ð° ÑÐ·Ñ‹ÐºÐµ',0),(564154,15671,'es','ActualizaciÃ³n de texto',0),(564155,15671,'de','Aktualisieren von Text in Sprache',0),(564156,15671,'en','Updating Language Text',0),(564157,15672,'is','',0),(564158,15672,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¬Ø¯ÙˆÙ„',0),(564159,15672,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¬Ø¯ÙˆÙ„',0),(564160,15672,'tr','Tablosunu gÃ¼ncelleÅŸtirme',0),(564161,15672,'pl','Aktualizacja tabeli',0),(564162,15672,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ð°',0),(564163,15672,'ur','Ø¬Ø¯ÙˆÙ„ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(564164,15672,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ñ‚Ð°Ð±ÐµÐ»Ð°',0),(564165,15672,'vi','Cáº­p Nháº­t báº£ng',0),(564166,15672,'af','Outobywerking tabel',0),(564167,15672,'ro','ActualizaÅ£i tabelul',0),(564168,15672,'et','Tabeli uuendamine',0),(564169,15672,'si','Posodabljanje tabele',0),(564170,15672,'ba','Memperbarui tabel',0),(564171,15672,'nl','Tabel bijwerken',0),(564172,15672,'fi','Taulukko pÃ¤ivitetÃ¤Ã¤n',0),(564173,15672,'no','Oppdaterer tabell',0),(564174,15672,'da','Opdaterer tabellen',0),(564175,15672,'ko','í…Œì´ë¸” ì—…ë°ì´íŠ¸',0),(564176,15672,'he','×¢×“×›×•×Ÿ ×”×˜×‘×œ×”',0),(564177,15672,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï€Î¯Î½Î±ÎºÎ±',0),(564178,15672,'zh','æ›´æ–°è¡¨',0),(564179,15672,'sv','Uppdatera tabell',0),(564180,15672,'it','Aggiornamento della tabella',0),(564181,15672,'tl','',0),(564182,15672,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸•à¸²à¸£à¸²à¸‡',0),(564183,15672,'hi','à¤¤à¤¾à¤²à¤¿à¤•à¤¾ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(564184,15672,'ms','Jadual pengemaskinian',0),(564185,15672,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø¬Ø¯ÙˆÙ„',0),(564186,15672,'fr','Mise Ã  jour de Table',0),(564187,15672,'jp','ãƒ†ãƒ¼ãƒ–ãƒ«ã‚’æ›´æ–°',0),(564188,15672,'pt','Atualizando a tabela',0),(564189,15672,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ‚Ð°Ð±Ð»Ð¸Ñ†Ñ‹',0),(564190,15672,'es','Actualizar tabla',0),(564191,15672,'de','Tabelle aktualisieren',0),(564192,15672,'en','Updating Table',0),(564193,15673,'is','',0),(564194,15673,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù…ÙˆØ±Ø¯ Ø¯Ø³ØªÙ‡ Ø¨Ù†Ø¯ÛŒ ØªØ®ÙÛŒÙ',0),(564195,15673,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù…ÙˆØ±Ø¯ Ø¯Ø³ØªÙ‡ Ø¨Ù†Ø¯ÛŒ ØªØ®ÙÛŒÙ',0),(564196,15673,'tr','Madde Kategori indirimler DÃ¼zenle',0),(564197,15673,'pl','Edycja elementu kategorii rabaty',0),(564198,15673,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¾Ñ‚ÑÑ‚ÑŠÐ¿ÐºÐ¸ Ð·Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(564199,15673,'ur','Ø´Û’ Ù…ÛŒÚº Ú†Ú¾ÙˆÙ¹ Ú©Û’ Ø²Ù…Ø±Û’ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(564200,15673,'sr','Ð£Ñ€ÐµÐ´Ð¸ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð¿Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð° Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ',0),(564201,15673,'vi','Chá»‰nh sá»­a má»¥c danh má»¥c giáº£m giÃ¡',0),(564202,15673,'af','Redigeer Item kategorie afslag',0),(564203,15673,'ro','Editare element categoria reduceri',0),(564204,15673,'et','Redigeerige kirje kategooria allahindlusi',0),(564205,15673,'si','Uredi kategorijo Popusti artiklov',0),(564206,15673,'ba','Mengedit Item kategori DISKON',0),(564207,15673,'nl','Artikelkortingen categorie bewerken',0),(564208,15673,'fi','Muokkaa luokka nimikealennuksia',0),(564209,15673,'no','Redigere kategori Varerabatter',0),(564210,15673,'da','Rediger element kategori rabatter',0),(564211,15673,'ko','íŽ¸ì§‘ í•­ëª© ì¹´í…Œê³ ë¦¬ í• ì¸',0),(564212,15673,'he','×¢×¨×™×›×ª ×¤×¨×™×˜ Category ×”× ×—×•×ª',0),(564213,15673,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎºÏ€Ï„ÏŽÏƒÎµÎ¹Ï‚',0),(564214,15673,'zh','ç¼–è¾‘é¡¹ç›®ç±»åˆ«æŠ˜æ‰£',0),(564215,15673,'sv','Redigera kategori artikelrabatter',0),(564216,15673,'it','Modificare voce Categoria Sconti',0),(564217,15673,'tl','',0),(564218,15673,'th','à¹à¸à¹‰à¹„à¸‚à¸ªà¹ˆà¸§à¸™à¸¥à¸”à¸›à¸£à¸°à¹€à¸ à¸—à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(564219,15673,'hi','à¤†à¤‡à¤Ÿà¤® à¤¶à¥à¤°à¥‡à¤£à¥€ à¤›à¥‚à¤Ÿ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(564220,15673,'ms','Mengedit kategori Item diskaun',0),(564221,15673,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¹Ù†ØµØ± Ø§Ù„ÙØ¦Ø© Ø§Ù„Ø®ØµÙˆÙ…Ø§Øª',0),(564222,15673,'fr','Modifier l\'article catÃ©gorie remises',0),(564223,15673,'jp','ã‚¢ã‚¤ãƒ†ãƒ  ã‚«ãƒ†ã‚´ãƒªãƒ¼å‰²å¼•ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(564224,15673,'pt','Editar Item categoria descontos',0),(564225,15673,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ ÑÐºÐ¸Ð´ÐºÐ¸',0),(564226,15673,'es','Editar artÃ­culo categorÃ­a descuentos',0),(564227,15673,'de','Artikelrabatte Kategorie bearbeiten',0),(564228,15673,'en','Edit Item Category Discounts',0),(564229,15674,'is','',0),(564230,15674,'dr','Ø¬Ø§ÛŒ Ø®Ø§Ù„ÛŒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(564231,15674,'pr','Ø¬Ø§ÛŒ Ø®Ø§Ù„ÛŒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(564232,15674,'tr','Bordro boÅŸluÄŸu',0),(564233,15674,'pl','Void listy pÅ‚ac',0),(564234,15674,'bg','Ð¢Ð Ð— Void',0),(564235,15674,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©Û’ Ø®Ù„Ø§',0),(564236,15674,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ñƒ',0),(564237,15674,'vi','BiÃªn cháº¿ Void',0),(564238,15674,'af','Salarisstelsel leemte',0),(564239,15674,'ro','Salarizare Void',0),(564240,15674,'et','Palgaarvestuse Void',0),(564241,15674,'si','IzplaÄane plaÄe praznino',0),(564242,15674,'ba','Penggajian kekosongan',0),(564243,15674,'nl','Payroll leegte',0),(564244,15674,'fi','Palkanlaskennan Void',0),(564245,15674,'no','LÃ¸nn Void',0),(564246,15674,'da','LÃ¸nningslisten tomrum',0),(564247,15674,'ko','ê¸‰ì—¬ ë¬´íš¨',0),(564248,15674,'he','×ž×©×›×•×¨×•×ª Void',0),(564249,15674,'el','ÎšÎµÎ½ÏŒ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(564250,15674,'zh','å·¥èµ„å•è™šç©º',0),(564251,15674,'sv','LÃ¶nelistan Void',0),(564252,15674,'it','Void paghe',0),(564253,15674,'tl','',0),(564254,15674,'th','à¹€à¸›à¹‡à¸™à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(564255,15674,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤‚à¤¬à¤§à¥€ à¤¶à¥‚à¤¨à¥à¤¯',0),(564256,15674,'ms','Kekosongan jawatan gaji',0),(564257,15674,'ar','Ø§Ù„ÙØ±Ø§Øº ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª',0),(564258,15674,'fr','Void paie',0),(564259,15674,'jp','çµ¦ä¸Žãƒœã‚¤ãƒ‰',0),(564260,15674,'pt','Vazio de folha de pagamento',0),(564261,15674,'ru','Void Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹',0),(564262,15674,'es','VacÃ­o de nÃ³mina',0),(564263,15674,'de','Lohn-und Gehaltsabrechnung Void',0),(564264,15674,'en','Payroll Void',0),(564265,15675,'is','',0),(564266,15675,'dr','Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø¨Ø§Ø·Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(564267,15675,'pr','Ù…Ø­Ø§Ø³Ø¨Ø§Øª Ø¨Ø§Ø·Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(564268,15675,'tr','BaÅŸarÄ±lÄ± bir ÅŸekilde hÃ¼kÃ¼msÃ¼z hesaplamalar',0),(564269,15675,'pl','Obliczenia uniewaÅ¼nione pomyÅ›lnie',0),(564270,15675,'bg','Ð˜Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ÑÑ‚Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(564271,15675,'ur','Ø­Ø³Ø§Ø¨ Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ÙˆÙˆØ§ÚˆÛŒØ¯',0),(564272,15675,'sr','Ð˜Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ° ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½',0),(564273,15675,'vi','TÃ­nh toÃ¡n Voided thÃ nh cÃ´ng',0),(564274,15675,'af','Berekeninge ontlaste suksesvol',0),(564275,15675,'ro','Calculele anulat cu succes',0),(564276,15675,'et','Kehtetu edukalt arvutused',0),(564277,15675,'si','IzraÄuni razveljavi uspeÅ¡no',0),(564278,15675,'ba','Perhitungan Voided berhasil',0),(564279,15675,'nl','Berekeningen met succes ongeldig',0),(564280,15675,'fi','Laskelmat pÃ¤tevÃ¤ onnistuneesti',0),(564281,15675,'no','Beregninger annullert vellykket',0),(564282,15675,'da','Beregninger annulleret med succes',0),(564283,15675,'ko','ì„±ê³µì ìœ¼ë¡œ ì·¨ì†Œ í•˜ëŠ” ê³„ì‚°',0),(564284,15675,'he','×—×™×©×•×‘×™× ×‘×•×˜×œ ×‘×”×¦×œ×—×”',0),(564285,15675,'el','Î¥Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Î¯ Î±ÎºÏ…ÏÏŽÎ½ÎµÏ„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(564286,15675,'zh','è®¡ç®—æˆåŠŸä½œåºŸ',0),(564287,15675,'sv','BerÃ¤kningar annullerad framgÃ¥ngsrikt',0),(564288,15675,'it','Calcoli annullati con successo',0),(564289,15675,'tl','',0),(564290,15675,'th','à¸à¸²à¸£à¸„à¸³à¸™à¸§à¸“à¸–à¸¹à¸à¸¢à¸à¹€à¸¥à¸´à¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(564291,15675,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• Voided à¤—à¤£à¤¨à¤¾',0),(564292,15675,'ms','Pengiraan Voided berjaya',0),(564293,15675,'ar','Ø§Ù„Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø­Ø³Ø§Ø¨ÙŠØ© Ø§Ù„ØªÙŠ ØªÙØ±Øº Ø¨Ù†Ø¬Ø§Ø­',0),(564294,15675,'fr','Calculs annulÃ©es avec succÃ¨s',0),(564295,15675,'jp','è¨ˆç®—ãŒæ­£å¸¸ã«ç„¡åŠ¹åŒ–',0),(564296,15675,'pt','CÃ¡lculos anulados com Ãªxito',0),(564297,15675,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ñ‹, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð°',0),(564298,15675,'es','CÃ¡lculos anulados con Ã©xito',0),(564299,15675,'de','Berechnungen, die erfolgreich storniert',0),(564300,15675,'en','Calculations Voided Successfully',0),(564301,15676,'is','',0),(564302,15676,'dr','ØªØºÛŒÛŒØ± Ù…Ø­Ø§Ø³Ø¨Ø§Øª ÙÙ‚Ø· Ø§ÛŒÙ† Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(564303,15676,'pr','ØªØºÛŒÛŒØ± Ù…Ø­Ø§Ø³Ø¨Ø§Øª ÙÙ‚Ø· Ø§ÛŒÙ† Ø¯ÙˆØ±Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(564304,15676,'tr','Bu Ã¶deme dÃ¶nemi iÃ§in hesaplamalarÄ± deÄŸiÅŸtirebilir',0),(564305,15676,'pl','ZmieniÄ‡ obliczeÅ„ dla tylko tego okresu rozliczeniowego',0),(564306,15676,'bg','ÐŸÑ€Ð¾Ð¼ÑÐ½Ð° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ð·Ð° Ñ‚Ð¾Ñ‡Ð½Ð¾ Ñ‚Ð¾Ð·Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(564307,15676,'ur','Ø­Ø³Ø§Ø¨ ØµØ±Ù Ø§Ø³ ØªÙ†Ø®ÙˆØ§Û Ø¹Ø±ØµÛ Ú©Û’ Ù„ÛŒÛ’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(564308,15676,'sr','ÐŸÑ€Ð¾Ð¼ÐµÐ½Ð° Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐ° Ð·Ð° ÑÐ°Ð¼Ð¾ Ð¾Ð²Ð°Ñ˜ ÐŸÐµÑ€Ð¸Ð¾Ð´ Ð¾Ð´ Ð¿Ð»Ð°Ñ‚Ðµ',0),(564309,15676,'vi','Thay Ä‘á»•i tÃ­nh toÃ¡n cho giai Ä‘oáº¡n nÃ y chá»‰ pháº£i tráº£ tiá»n',0),(564310,15676,'af','Berekeninge vir net hierdie betaal tydperk verander',0),(564311,15676,'ro','Schimba calcule doar aceastÄƒ perioadÄƒ de platÄƒ',0),(564312,15676,'et','Muuta Just selles palgaperioodi arvutused',0),(564313,15676,'si','Sprememba izraÄune za samo tej plaÄi',0),(564314,15676,'ba','Perubahan perhitungan untuk hanya membayar masa',0),(564315,15676,'nl','Berekeningen voor slechts dit betalen periode wijzigen',0),(564316,15676,'fi','Muuttaa laskelmat vain tÃ¤lle kaudelle maksu',0),(564317,15676,'no','Endre beregninger For bare denne lÃ¸nnsperioden',0),(564318,15676,'da','Ã†ndre beregninger For netop denne lÃ¸nperiode',0),(564319,15676,'ko','ê·¸ëƒ¥ì´ ì§€ë¶ˆ ê¸°ê°„ì— ëŒ€ í•œ ê³„ì‚°ì„ ë³€ê²½',0),(564320,15676,'he','×©×™× ×•×™ ×—×™×©×•×‘×™× ×œ×ª×§×•×¤×” ×–×• ×œ×©×œ× ×¨×§',0),(564321,15676,'el','Î‘Î»Î»Î±Î³Î® Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚ Î³Î¹Î± Î±ÎºÏÎ¹Î²ÏŽÏ‚ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Ï€ÎµÏÎ¯Î¿Î´Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(564322,15676,'zh','åªæ˜¯è¿™ä»˜è–ªæœŸé—´çš„å˜åŒ–è®¡ç®—',0),(564323,15676,'sv','Ã„ndra berÃ¤kningar fÃ¶r Just denna lÃ¶neperiod',0),(564324,15676,'it','Modificare i calcoli per questo periodo di paga',0),(564325,15676,'tl','',0),(564326,15676,'th','à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸à¸²à¸£à¸„à¸³à¸™à¸§à¸“à¹€à¸žà¸µà¸¢à¸‡à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸Šà¸³à¸£à¸°à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸™à¸µà¹‰',0),(564327,15676,'hi','à¤¬à¤¸ à¤‡à¤¸ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¤£à¤¨à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤',0),(564328,15676,'ms','Pengiraan perubahan untuk hanya tempoh gaji ini',0),(564329,15676,'ar','ØªØºÙŠÙŠØ± Ø­Ø³Ø§Ø¨Ø§Øª ÙØªØ±Ø© Ù‡Ø°Ø§ Ø§Ù„Ø¯ÙØ¹ ÙÙ‚Ø·',0),(564330,15676,'fr','Changement de calculs pour juste cette pÃ©riode de paie',0),(564331,15676,'jp','ã¡ã‚‡ã†ã©ã“ã®æ”¯æ‰•æœŸé–“ã®è¨ˆç®—ã‚’å¤‰æ›´ã—ã¾ã™ã€‚',0),(564332,15676,'pt','Alterar os cÃ¡lculos para apenas este perÃ­odo de pagamento',0),(564333,15676,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð²Ñ‹Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÑÑ‚Ð¾Ñ‚ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(564334,15676,'es','CÃ¡lculos de cambio para apenas este perÃ­odo de pago',0),(564335,15676,'de','Berechnungen fÃ¼r eben diese Lohnperiode Ã¤ndern',0),(564336,15676,'en','Change Calculations For Just This Pay Period',0),(564337,15677,'is','',0),(564338,15677,'dr','ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø®Ø§Ø±Ø¬ Ø§Ø² Ø¯ÙˆØ±Ù‡ Ø§Ø³Øª',0),(564339,15677,'pr','ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ø®Ø§Ø±Ø¬ Ø§Ø² Ø¯ÙˆØ±Ù‡ Ø§Ø³Øª',0),(564340,15677,'tr','Tarihi dÃ¶nemi dÄ±ÅŸÄ±nda Ã¶dÃ¼yor',0),(564341,15677,'pl','Data jest na zewnÄ…trz okresu wypÅ‚aty',0),(564342,15677,'bg','Ð”Ð°Ñ‚Ð°Ñ‚Ð° Ðµ Ð¸Ð·Ð²ÑŠÐ½ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(564343,15677,'ur','ØªØ§Ø±ÛŒØ® Ø¨Ø§ÛØ± Ø¯ÙˆØ± Ú©ÛŒ Ø§Ø¯Ø§ ÛÛ’',0),(564344,15677,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ñ˜Ðµ Ð¸Ð·Ð²Ð°Ð½ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(564345,15677,'vi','NgÃ y lÃ  bÃªn ngoÃ i pháº£i tráº£ khoáº£ng thá»i gian',0),(564346,15677,'af','Datum Is buite tydperk betaal',0),(564347,15677,'ro','Data se plÄƒtesc Ã®n afara perioadei',0),(564348,15677,'et','KuupÃ¤ev on vÃ¤ljaspool maksmise perioodi',0),(564349,15677,'si','Datum je zunaj plaÄati obdobje',0),(564350,15677,'ba','Tanggal adalah membayar di luar periode',0),(564351,15677,'nl','Datum Is buiten betalen periode',0),(564352,15677,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ on ulkopuolella palkanmaksu',0),(564353,15677,'no','Datoen er utenfor betale periode',0),(564354,15677,'da','Dato er udenfor betale periode',0),(564355,15677,'ko','ë‚ ì§œëŠ” ë°–ìœ¼ë¡œ ì§€ë¶ˆ í•˜ëŠ” ê¸°ê°„',0),(564356,15677,'he','×ª××¨×™×š ×–×” ×‘×—×•×¥ ×ž×©×œ× ×ª×§×•×¤×”',0),(564357,15677,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ¯Î½Î±Î¹ Î­Î¾Ï‰ Î½Î± Ï€Î»Î·ÏÏŽÏƒÎµÎ¹ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(564358,15677,'zh','æ—¥æœŸæ˜¯å¤–é¢æ”¯ä»˜æœŸé™',0),(564359,15677,'sv','Datum Ã¤r utanfÃ¶r betala Period',0),(564360,15677,'it','Data Ã¨ pagare fuori periodo',0),(564361,15677,'tl','',0),(564362,15677,'th','à¸§à¸±à¸™à¸„à¸·à¸­ à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸ à¸²à¸¢à¸™à¸­à¸',0),(564363,15677,'hi','à¤¬à¤¾à¤¹à¤° à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤µà¤§à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¹à¥ˆ',0),(564364,15677,'ms','Tarikh adalah membayar di luar tempoh',0),(564365,15677,'ar','ØªØ§Ø±ÙŠØ® Ø¯ÙØ¹ Ø®Ø§Ø±Ø¬ Ø§Ù„ÙØªØ±Ø©',0),(564366,15677,'fr','La date est hors pÃ©riode de paye',0),(564367,15677,'jp','æ—¥ä»˜ã¯æœŸé–“å¤–ã‚’æ”¯æ‰•ã†',0),(564368,15677,'pt','Data Ã© pagar fora o perÃ­odo',0),(564369,15677,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ…Ð¾Ð´Ð¸Ñ‚ÑÑ Ð²Ð½Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(564370,15677,'es','La fecha es pagar fuera plazo',0),(564371,15677,'de','Datum ist auÃŸerhalb Zeitraum bezahlen',0),(564372,15677,'en','Date Is Outside Pay Period',0),(564373,15678,'is','',0),(564374,15678,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(564375,15678,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(564376,15678,'tr','Ä°zin verilen dÃ¼zenleme deÄŸil',0),(564377,15678,'pl','Edycji nie dozwolone',0),(564378,15678,'bg','ÐÐµ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ',0),(564379,15678,'ur','Ø§Ø¬Ø§Ø²Øª ØªØ¯ÙˆÛŒÙ† Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ù†ÛÛŒÚº',0),(564380,15678,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(564381,15678,'vi','Chá»‰nh sá»­a khÃ´ng Ä‘Æ°á»£c phÃ©p',0),(564382,15678,'af','Redigering nie toegelaat',0),(564383,15678,'ro','Editarea nu permise',0),(564384,15678,'et','Redigeerimine ei ole lubatud',0),(564385,15678,'si','Urejanje ni dovoljeno',0),(564386,15678,'ba','Mengedit tidak diperbolehkan',0),(564387,15678,'nl','Bewerken niet toegestaan',0),(564388,15678,'fi','Muokkaus ei ole sallittu',0),(564389,15678,'no','Redigering ikke tillatt',0),(564390,15678,'da','Redigering ikke tilladt',0),(564391,15678,'ko','íŽ¸ì§‘ í—ˆìš©',0),(564392,15678,'he','×¢×¨×™×›×” ×œ× ×ž×•×ª×¨',0),(564393,15678,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î´ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹',0),(564394,15678,'zh','ç¼–è¾‘ä¸å…è®¸',0),(564395,15678,'sv','Redigera inte tillÃ¥tna',0),(564396,15678,'it','Editing non consentiti',0),(564397,15678,'tl','',0),(564398,15678,'th','à¹à¸à¹‰à¹„à¸‚à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(564399,15678,'hi','à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨',0),(564400,15678,'ms','Penyuntingan tidak dibenarkan',0),(564401,15678,'ar','ØªØ­Ø±ÙŠØ± ØºÙŠØ± Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡',0),(564402,15678,'fr','Modification non autorisÃ©e',0),(564403,15678,'jp','è¨±å¯ã®ç·¨é›†',0),(564404,15678,'pt','EdiÃ§Ã£o nÃ£o permitida',0),(564405,15678,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð½Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð½Ñ‹Ñ…',0),(564406,15678,'es','EdiciÃ³n no permitida',0),(564407,15678,'de','Bearbeitung nicht erlaubt',0),(564408,15678,'en','Editing Not Allowed',0),(564409,15679,'is','',0),(564410,15679,'dr','Ø±ÙØªÙ† Ø¨Ù‡ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(564411,15679,'pr','Ø±ÙØªÙ† Ø¨Ù‡ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(564412,15679,'tr','Ã‡alÄ±ÅŸan iÃ§in git',0),(564413,15679,'pl','PrzejdÅº do pracownika',0),(564414,15679,'bg','ÐžÑ‚Ð¸Ð´ÐµÑ‚Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(564415,15679,'ur','Ù…Ù„Ø§Ø²Ù… Ú©Û’ Ù„ÛŒÛ’ Ø¬Ø§Ù†Ø§',0),(564416,15679,'sr','Ð˜Ð´Ð¸ ÑÐ° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ð¼',0),(564417,15679,'vi','Äi Ä‘áº¿n nhÃ¢n viÃªn',0),(564418,15679,'af','Werknemer gaan',0),(564419,15679,'ro','Du-te la angajat',0),(564420,15679,'et','Mine tÃ¶Ã¶taja',0),(564421,15679,'si','Pojdite na zaposlenega',0),(564422,15679,'ba','Pergi ke karyawan',0),(564423,15679,'nl','Ga naar werknemer',0),(564424,15679,'fi','Siirry tyÃ¶ntekijÃ¤n',0),(564425,15679,'no','GÃ¥ til ansatte',0),(564426,15679,'da','GÃ¥ til medarbejder',0),(564427,15679,'ko','ì§ì› ì´ë™',0),(564428,15679,'he','×œ×œ×›×ª ×”×¢×•×‘×“',0),(564429,15679,'el','Î Î¬ÎµÎ¹ ÏƒÎµ ÎµÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿',0),(564430,15679,'zh','è½¬åˆ°å‘˜å·¥',0),(564431,15679,'sv','GÃ¥ till anstÃ¤lld',0),(564432,15679,'it','Vai al dipendente',0),(564433,15679,'tl','',0),(564434,15679,'th','à¹„à¸›à¸¢à¸±à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(564435,15679,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¥‹ à¤œà¤¾à¤¨à¤¾',0),(564436,15679,'ms','Pergi kepada pekerja',0),(564437,15679,'ar','Ø§Ù„Ø°Ù‡Ø§Ø¨ Ù„Ù„Ù…ÙˆØ¸Ù',0),(564438,15679,'fr','Aller Ã  employÃ©',0),(564439,15679,'jp','å¾“æ¥­å“¡ã¸',0),(564440,15679,'pt','Ir ao empregado',0),(564441,15679,'ru','ÐŸÐµÑ€ÐµÐ¹Ñ‚Ð¸ Ðº ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÑƒ',0),(564442,15679,'es','Ir a empleado',0),(564443,15679,'de','Gehen Sie zum Mitarbeiter',0),(564444,15679,'en','Go To Employee',0),(564445,15680,'is','',0),(564446,15680,'dr','Ø³Ø§Ø¹Øª ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(564447,15680,'pr','Ø³Ø§Ø¹Øª ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(564448,15680,'tr','Girilen saat',0),(564449,15680,'pl','Godzin wprowadzone',0),(564450,15680,'bg','Ð§Ð°ÑÐ° Ð²Ð»ÐµÐ·Ðµ',0),(564451,15680,'ur','Ú¯Ú¾Ù†Ù¹ÙˆÚº Ù…ÛŒÚº Ø¯Ø§Ø®Ù„',0),(564452,15680,'sr','Ð¡Ð°Ñ‚Ð¸ Ñ˜Ðµ ÑƒÐ½ÐµÑ‚',0),(564453,15680,'vi','Giá» Ä‘Ã£ nháº­p',0),(564454,15680,'af','Uur ingetik',0),(564455,15680,'ro','Ore a intrat',0),(564456,15680,'et','Tundi sisestatud',0),(564457,15680,'si','Uri zaÄel',0),(564458,15680,'ba','Jam masuk',0),(564459,15680,'nl','Uren ingegeven',0),(564460,15680,'fi','Tunteja syÃ¶tetÃ¤Ã¤n',0),(564461,15680,'no','Ã…pningstider inn',0),(564462,15680,'da','Timer indtastet',0),(564463,15680,'ko','ì‹œê°„ ìž…ë ¥',0),(564464,15680,'he','×”×–× ×ª ×©×¢×•×ª',0),(564465,15680,'el','ÎÏÎµÏ‚ Ï„Î­Î¸Î·ÎºÎµ',0),(564466,15680,'zh','è¾“å…¥æ—¶é—´',0),(564467,15680,'sv','Timmar registreras',0),(564468,15680,'it','Ore inserite',0),(564469,15680,'tl','',0),(564470,15680,'th','à¸›à¹‰à¸­à¸™à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡',0),(564471,15680,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤•à¤¿à¤¯à¤¾',0),(564472,15680,'ms','Jam dimasukkan',0),(564473,15680,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø³Ø§Ø¹Ø§Øª',0),(564474,15680,'fr','Heures entrÃ©es',0),(564475,15680,'jp','æ™‚é–“ã‚’å…¥åŠ›',0),(564476,15680,'pt','Horas entrou',0),(564477,15680,'ru','Ð§Ð°ÑÐ¾Ð² Ð²ÑÑ‚ÑƒÐ¿Ð¸Ð»Ð°',0),(564478,15680,'es','Entraron en horas',0),(564479,15680,'de','Stunden eingegeben',0),(564480,15680,'en','Hours Entered',0),(564481,15681,'is','',0),(564482,15681,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ø§Ø± Ù†Ø±Ø®',0),(564483,15681,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ø§Ø± Ù†Ø±Ø®',0),(564484,15681,'tr','Ä°ÅŸ maliyet fiyatÄ±',0),(564485,15681,'pl','Pracy kosztÃ³w kursu',0),(564486,15681,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(564487,15681,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ Ø´Ø±Ø­ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ Û”',0),(564488,15681,'sr','Ð¡Ñ‚Ð¾Ð¿Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(564489,15681,'vi','Viá»‡c lÃ m chi phÃ­ tá»· lá»‡',0),(564490,15681,'af','Werk kos koers',0),(564491,15681,'ro','Job Costa rata',0),(564492,15681,'et','TÃ¶Ã¶ kulukuse mÃ¤Ã¤r',0),(564493,15681,'si','Projektnih stroÅ¡kov hitrost',0),(564494,15681,'ba','Pekerjaan biaya TARIF',0),(564495,15681,'nl','Tarieven van de baan',0),(564496,15681,'fi','Kustannusten mÃ¤Ã¤rÃ¤',0),(564497,15681,'no','Jobben koster Rate',0),(564498,15681,'da','Job koste sats',0),(564499,15681,'ko','ìž‘ì—… ë¹„ìš© ë¹„ìœ¨',0),(564500,15681,'he','×”×¢×‘×•×“×” ×¢×•×œ×” ×§×¦×‘',0),(564501,15681,'el','Î•ÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(564502,15681,'zh','ä½œä¸šæˆæœ¬çŽ‡',0),(564503,15681,'sv','Jobb kostar kurs',0),(564504,15681,'it','Costo lavoro tasso',0),(564505,15681,'tl','',0),(564506,15681,'th','à¸£à¸²à¸„à¸²à¸•à¹‰à¸™à¸—à¸¸à¸™à¸‡à¸²à¸™',0),(564507,15681,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¦à¤° à¤²à¤¾à¤—à¤¤',0),(564508,15681,'ms','Kadar kos kerja',0),(564509,15681,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„ÙˆØ¸ÙŠÙØ© Ù…Ø¹Ø¯Ù„',0),(564510,15681,'fr','CoÃ»t taux',0),(564511,15681,'jp','ä»•äº‹å˜ä¾¡',0),(564512,15681,'pt','Taxa de custos de trabalho',0),(564513,15681,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ€Ð°ÑÑ…Ð¾Ð´Ð½Ð¾ÑÑ‚Ð¸',0),(564514,15681,'es','Trabajo de costos tasa de',0),(564515,15681,'de','Job-Kostensatz',0),(564516,15681,'en','Job Cost Rate',0),(564517,15682,'is','',0),(564518,15682,'dr','Ø¨Ø¯ÙˆÙ† ØªØºÛŒÛŒØ±',0),(564519,15682,'pr','Ø¨Ø¯ÙˆÙ† ØªØºÛŒÛŒØ±',0),(564520,15682,'tr','DeÄŸiÅŸiklik yok',0),(564521,15682,'pl','Bez zmian',0),(564522,15682,'bg','Ð‘ÐµÐ· Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð°',0),(564523,15682,'ur','Ú©ÙˆØ¦ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒ Ù†ÛÛŒÚº',0),(564524,15682,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð°',0),(564525,15682,'vi','KhÃ´ng cÃ³ thay Ä‘á»•i',0),(564526,15682,'af','Geen verandering',0),(564527,15682,'ro','Nici o schimbare',0),(564528,15682,'et','Muutusteta',0),(564529,15682,'si','Brez sprememb',0),(564530,15682,'ba','Tidak ada perubahan',0),(564531,15682,'nl','Geen verandering',0),(564532,15682,'fi','Ei muutosta',0),(564533,15682,'no','Ingen endring',0),(564534,15682,'da','Ingen Ã¦ndring',0),(564535,15682,'ko','ë³€í™” ì—†ìŒ',0),(564536,15682,'he','××™×Ÿ ×©×™× ×•×™',0),(564537,15682,'el','ÎšÎ±Î¼Î¯Î± Î±Î»Î»Î±Î³Î®',0),(564538,15682,'zh','æ²¡æœ‰å˜åŒ–',0),(564539,15682,'sv','Ingen fÃ¶rÃ¤ndring',0),(564540,15682,'it','Nessun cambiamento',0),(564541,15682,'tl','',0),(564542,15682,'th','à¹„à¸¡à¹ˆà¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(564543,15682,'hi','à¤•à¥‹à¤ˆ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¨à¤¹à¥€à¤‚',0),(564544,15682,'ms','Tiada perubahan',0),(564545,15682,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªØºÙŠÙŠØ±',0),(564546,15682,'fr','Pas de changement',0),(564547,15682,'jp','å¤‰æ›´ãªã—',0),(564548,15682,'pt','Nenhuma mudanÃ§a',0),(564549,15682,'ru','Ð‘ÐµÐ· Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ð¹',0),(564550,15682,'es','No se cambia',0),(564551,15682,'de','Keine Ã„nderung',0),(564552,15682,'en','No Change',0),(564553,15683,'is','',0),(564554,15683,'dr','Ù‡ÛŒÚ† ÙØ¯Ø±Ø§Ù„ FUTA Ø§Ù…Ù†ÛŒØª Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒØŒ Ù…Ø¯ÛŒÚ©Ø± Ù…Ø§Ù„ÛŒØ§Øª',0),(564555,15683,'pr','Ù‡ÛŒÚ† ÙØ¯Ø±Ø§Ù„ FUTA Ø§Ù…Ù†ÛŒØª Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒØŒ Ù…Ø¯ÛŒÚ©Ø± Ù…Ø§Ù„ÛŒØ§Øª',0),(564556,15683,'tr','HiÃ§bir Federal, FUTA, sosyal gÃ¼venlik, Medicare vergi',0),(564557,15683,'pl','Federalnych, FUTA, Social Security, Medicare podatkÃ³w',0),(564558,15683,'bg','ÐÑÐ¼Ð° Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸, Ð¡ÐÐœÐ£Ð˜Ð› Ð² ÑÐ¾Ñ†Ð¸Ð°Ð»Ð½Ð¾Ñ‚Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€ÑÐ²Ð°Ð½Ðµ, Medicare Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(564559,15683,'ur','Ú©ÙˆØ¦ÛŒ ÙˆÙØ§Ù‚ÛŒØŒ ÙØªØŒ Ø³ÙˆØ´Ù„ Ø³ÛŒÚ©ÛŒÙˆØ±Ù¹ÛŒØŒ Ù…ÛŒÚˆÛŒ Ù¹ÛŒÚ©Ø³',0),(564560,15683,'sr','ÐÐµÐ¼Ð° Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸Ñ…, Ð¤Ð£Ð¢Ð, ÑÐ¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐµ, Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ð¿Ð¾Ñ€ÐµÐ·',0),(564561,15683,'vi','KhÃ´ng liÃªn bang, FUTA, an sinh xÃ£ há»™i, Medicare thuáº¿',0),(564562,15683,'af','Geen federale, FUTA, sosiale sekuriteit, Medicare belastings',0),(564563,15683,'ro','Nici un Federal, FUTA, Social Security, Medicare impozite',0),(564564,15683,'et','Federal, FUTA, Social Security, Medicare maksud',0),(564565,15683,'si','Ni zvezna, Medicare FUTA, socialno varnost, davki',0),(564566,15683,'ba','Tidak ada Federal, pajak Medicare FUTA, jaminan sosial,',0),(564567,15683,'nl','Geen federale, FUTA, sociale zekerheid, Medicare belastingen',0),(564568,15683,'fi','Ei ole liittovaltion FUTA, Social Security, Medicare verot',0),(564569,15683,'no','Ingen fÃ¸derale FUTA, Social Security, Medicare skatter',0),(564570,15683,'da','Ingen Federal, FUTA, Social sikring, Medicare skatter',0),(564571,15683,'ko','ì•„ë‹ˆ ì—°ë°©, ë§Œë£Œì¼, ì‚¬íšŒ ë³´ìž¥, ë©”ë””ì¼€ì–´ ì„¸ê¸ˆ',0),(564572,15683,'he','××™×Ÿ ×”×©×œ×˜×•×Ÿ ×”×¤×“×¨×œ×™, ×¤×•×˜×”, ×‘×™×˜×•×— ×œ××•×ž×™, Medicare ×ž×™×¡×™×',0),(564573,15683,'el','ÎšÎ±Î¼Î¯Î± ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ®, FUTA, ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÎºÎ®Ï‚ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚, Medicare Ï†ÏŒÏÎ¿Ï…Ï‚',0),(564574,15683,'zh','æ²¡æœ‰è”é‚¦ã€ å¯Œå¡”ï¼Œç¤¾ä¼šä¿é™©ï¼ŒåŒ»ç–—ä¿é™©ç¨Ž',0),(564575,15683,'sv','Ingen Federal, FUTA, Social trygghet, Medicare skatter',0),(564576,15683,'it','Nessun federale, FUTA, sicurezza sociale, i contributi Medicare',0),(564577,15683,'tl','',0),(564578,15683,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸±à¸à¸šà¸²à¸¥à¸à¸¥à¸²à¸‡ à¸ à¸²à¸©à¸µ FUTA à¸›à¸£à¸°à¸à¸±à¸™à¸ªà¸±à¸‡à¸„à¸¡ à¸›à¸£à¸°à¸à¸±à¸™à¸ªà¸¸à¸‚à¸ à¸²à¸žà¸‚à¸­à¸‡à¸£à¸±à¸à¸šà¸²à¸¥',0),(564579,15683,'hi','à¤•à¥‹à¤ˆ à¤¸à¤‚à¤˜à¥€à¤¯, FUTA, à¤¸à¤¾à¤®à¤¾à¤œà¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¾, à¤šà¤¿à¤•à¤¿à¤¤à¥à¤¸à¤¾ à¤•à¤°à¥‹à¤‚',0),(564580,15683,'ms','Tiada Persekutuan, FUTA, keselamatan sosial, Medicare cukai',0),(564581,15683,'ar','Ù„Ø§ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©ØŒ ÙÙˆØªØ§ØŒ Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠØŒ ÙˆØ§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ© Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(564582,15683,'fr','Aucun fÃ©dÃ©ral, FUTA, sÃ©curitÃ© sociale, assurance-maladie Taxes',0),(564583,15683,'jp','ãªã„ä¸­å¤®æ”¿åºœã€ãƒ•ã‚¿ãƒŠãƒªã€ç¤¾ä¼šä¿éšœã€ãƒ¡ãƒ‡ã‚£ã‚±ã‚¢ç¨Ž',0),(564584,15683,'pt','NÃ£o Federal, FUTA, SeguranÃ§a Social, Medicare impostos',0),(564585,15683,'ru','ÐÐµÑ‚ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾, Ð¤Ð£Ð¢Ð, ÑÐ¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ðµ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ðµ, Medicare Ð½Ð°Ð»Ð¾Ð³Ð¸',0),(564586,15683,'es','No Federal, FUTA, Seguridad Social, impuestos de Medicare',0),(564587,15683,'de','Keine Bundes-, FUTA, Sozialversicherung, Medicare Steuern',0),(564588,15683,'en','No Federal, FUTA, Social Security, Medicare Taxes',0),(564589,15684,'is','',0),(564590,15684,'dr','Ù‡ÛŒÚ† ÙØ¯Ø±Ø§Ù„ Ù…Ø§Ù„ÛŒØ§Øª FUTA',0),(564591,15684,'pr','Ù‡ÛŒÚ† ÙØ¯Ø±Ø§Ù„ Ù…Ø§Ù„ÛŒØ§Øª FUTA',0),(564592,15684,'tr','HiÃ§bir Federal, FUTA vergiler',0),(564593,15684,'pl','Federalnych, FUTA podatkÃ³w',0),(564594,15684,'bg','ÐÐµ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸ FUTA',0),(564595,15684,'ur','Ú©ÙˆØ¦ÛŒ ÙˆÙØ§Ù‚ÛŒØŒ ÙØª Ù¹ÛŒÚ©Ø³',0),(564596,15684,'sr','ÐÐµÐ¼Ð° Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸Ñ…, Ð¤Ð£Ð¢Ð Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(564597,15684,'vi','KhÃ´ng liÃªn bang, FUTA thuáº¿',0),(564598,15684,'af','Geen federale, FUTA belasting',0),(564599,15684,'ro','Nici un Federal, FUTA impozite',0),(564600,15684,'et','Federal, FUTA maksud',0),(564601,15684,'si','Ni zvezni davki FUTA',0),(564602,15684,'ba','Tidak ada Federal, pajak FUTA',0),(564603,15684,'nl','Geen federale, FUTA belastingen',0),(564604,15684,'fi','Ei ole liittovaltion FUTA verot',0),(564605,15684,'no','Ingen fÃ¸derale FUTA skatter',0),(564606,15684,'da','Ingen Federal, FUTA skatter',0),(564607,15684,'ko','ì•„ë‹ˆ ì—°ë°©, ë§Œë£Œì¼ ì„¸ê¸ˆ',0),(564608,15684,'he','××™×Ÿ ×”×©×œ×˜×•×Ÿ ×”×¤×“×¨×œ×™, ×ž×™×¡×™× ×¤×•×˜×”',0),(564609,15684,'el','Î”ÎµÎ½ Ï„Î¿Ï…Ï‚ Î¿Î¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ¿ÏÏ‚, Ï†ÏŒÏÏ‰Î½ FUTA',0),(564610,15684,'zh','æ²¡æœ‰è”é‚¦ã€ å¯Œå¤šç¨Ž',0),(564611,15684,'sv','Ingen Federal, FUTA skatter',0),(564612,15684,'it','Nessun federale, FUTA tasse',0),(564613,15684,'tl','',0),(564614,15684,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸±à¸à¸šà¸²à¸¥à¸à¸¥à¸²à¸‡ FUTA à¸ à¸²à¸©à¸µ',0),(564615,15684,'hi','à¤•à¥‹à¤ˆ à¤¸à¤‚à¤˜à¥€à¤¯, FUTA à¤•à¤°à¥‹à¤‚',0),(564616,15684,'ms','Tiada Persekutuan, cukai FUTA',0),(564617,15684,'ar','Ù„Ø§ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© ÙˆØ§Ù„Ø¶Ø±Ø§Ø¦Ø¨ ÙÙˆØªØ§',0),(564618,15684,'fr','Aucun fÃ©dÃ©ral, Taxes FUTA',0),(564619,15684,'jp','ãªã„ä¸­å¤®æ”¿åºœã€ãƒ•ã‚¿ãƒŠãƒªå¯¾å¥³ç¨Žé‡‘',0),(564620,15684,'pt','NÃ£o Federal, impostos FUTA',0),(564621,15684,'ru','ÐÐµÑ‚ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾, Ð¤Ð£Ð¢Ð Ð½Ð°Ð»Ð¾Ð³Ð¸',0),(564622,15684,'es','No Federal, impuestos FUTA',0),(564623,15684,'de','Keine Bundes-, FUTA Steuern',0),(564624,15684,'en','No Federal, FUTA Taxes',0),(564625,15685,'is','',0),(564626,15685,'dr','Ù‡ÛŒÚ† Ú¯ÙˆÙ†Ù‡ Ù…Ø§Ù„ÛŒØ§Øª ÙØ¯Ø±Ø§Ù„ØŒ ØªØ§Ù…ÛŒÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒØŒ Ù…Ø¯ÛŒÚ©Ø±',0),(564627,15685,'pr','Ù‡ÛŒÚ† Ú¯ÙˆÙ†Ù‡ Ù…Ø§Ù„ÛŒØ§Øª ÙØ¯Ø±Ø§Ù„ØŒ ØªØ§Ù…ÛŒÙ† Ø§Ø¬ØªÙ…Ø§Ø¹ÛŒØŒ Ù…Ø¯ÛŒÚ©Ø±',0),(564628,15685,'tr','Federal, sosyal gÃ¼venlik, Medicare vergi',0),(564629,15685,'pl','Nie podatek Medicare Federalnej, zabezpieczenia spoÅ‚ecznego,',0),(564630,15685,'bg','Ð‘ÐµÐ· Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸, ÑÐ¾Ñ†Ð¸Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€ÑÐ²Ð°Ð½Ðµ, Medicare Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(564631,15685,'ur','Ú©ÙˆØ¦ÛŒ ÙˆÙØ§Ù‚ÛŒØŒ Ø³ÙˆØ´Ù„ Ø³ÛŒÚ©ÛŒÙˆØ±Ù¹ÛŒØŒ Ù…ÛŒÚˆÛŒ Ù¹ÛŒÚ©Ø³',0),(564632,15685,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð·Ð° Ð¦Ñ€Ð²ÐµÐ½Ð¸ ÐºÑ€ÑÑ‚ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸Ñ…, ÑÐ¾Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¾ Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐµ,',0),(564633,15685,'vi','Miá»…n thuáº¿ liÃªn bang, an sinh xÃ£ há»™i, Medicare',0),(564634,15685,'af','Geen federale, sosiale sekuriteit, Medicare belastings',0),(564635,15685,'ro','Nici Federal, Social Security, Medicare taxe',0),(564636,15685,'et','Mitte Liitvabariigi, Social Security, Medicare maksud',0),(564637,15685,'si','Ni zvezna, socialne varnosti, Medicare davkov',0),(564638,15685,'ba','Tidak ada Pajak Federal, jaminan sosial, Medicare',0),(564639,15685,'nl','Geen federale, sociale zekerheid, Medicare belastingen',0),(564640,15685,'fi','Ei ole liittovaltion, sosiaaliturva, Medicare verot',0),(564641,15685,'no','Ingen Federal, Social Security, Medicare skatt',0),(564642,15685,'da','Ingen fÃ¸derale, Social sikring, Medicare skatter',0),(564643,15685,'ko','ì—°ë°©, ì‚¬íšŒ ë³´ìž¥, ë©”ë””ì¼€ì–´ ì„¸ê¸ˆ',0),(564644,15685,'he','. ××™×Ÿ ×ž×™×¡×™× Medicare ×¤×“×¨××œ×™, ×‘×™×˜×•×— ×œ××•×ž×™,',0),(564645,15685,'el','ÎšÎ±Î¼Î¯Î± ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ®, ÎºÎ¿Î¹Î½Ï‰Î½Î¹ÎºÎ®Ï‚ Î±ÏƒÏ†Î¬Î»Î¹ÏƒÎ·Ï‚, Medicare Ï†ÏŒÏÎ¿Ï…Ï‚',0),(564646,15685,'zh','æ²¡æœ‰è”é‚¦ã€ ç¤¾ä¼šä¿éšœã€ åŒ»ç–—ä¿é™©ç¨Ž',0),(564647,15685,'sv','Ingen Federal, Social trygghet, Medicare skatter',0),(564648,15685,'it','Nessuna tassa di Medicare federale, sicurezza sociale,',0),(564649,15685,'tl','',0),(564650,15685,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸±à¸à¸šà¸²à¸¥à¸à¸¥à¸²à¸‡ à¸›à¸£à¸°à¸à¸±à¸™à¸ªà¸±à¸‡à¸„à¸¡ à¸ à¸²à¸©à¸µà¹à¸„à¸£à¹Œ',0),(564651,15685,'hi','à¤•à¥‹à¤ˆ à¤¸à¤‚à¤˜à¥€à¤¯, à¤¸à¤¾à¤®à¤¾à¤œà¤¿à¤• à¤¸à¥à¤°à¤•à¥à¤·à¤¾, à¤šà¤¿à¤•à¤¿à¤¤à¥à¤¸à¤¾ à¤•à¤°à¥‹à¤‚',0),(564652,15685,'ms','Tidak ada cukai Medicare Persekutuan, keselamatan sosial,',0),(564653,15685,'ar','Ù„Ø§ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ©ØŒ Ø§Ù„Ø¶Ù…Ø§Ù† Ø§Ù„Ø§Ø¬ØªÙ…Ø§Ø¹ÙŠØŒ ÙˆØ§Ù„Ø±Ø¹Ø§ÙŠØ© Ø§Ù„Ø·Ø¨ÙŠØ©',0),(564654,15685,'fr','Aucun impÃ´t de Medicare fÃ©dÃ©ral, sÃ©curitÃ© sociale,',0),(564655,15685,'jp','å›½ç¨Žã€ç¤¾ä¼šä¿éšœã€ãƒ¡ãƒ‡ã‚£ã‚±ã‚¢ç¨Ž',0),(564656,15685,'pt','Sem impostos de Medicare Federal, SeguranÃ§a Social,',0),(564657,15685,'ru','ÐÐµÑ‚ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾, ÑÐ¾Ñ†Ð¸Ð°Ð»ÑŒÐ½Ð¾Ðµ Ð¾Ð±ÐµÑÐ¿ÐµÑ‡ÐµÐ½Ð¸Ðµ, Medicare Ð½Ð°Ð»Ð¾Ð³Ð¸',0),(564658,15685,'es','No hay impuestos de Medicare Federal, Seguridad Social,',0),(564659,15685,'de','Keine Bundes-, Sozialversicherung, Medicare Steuern',0),(564660,15685,'en','No Federal, Social Security, Medicare Taxes',0),(564661,15686,'is','',0),(564662,15686,'dr','Ø¨Ø¯ÙˆÙ† Ù…Ø§Ù„ÙŠØ§Øª',0),(564663,15686,'pr','Ø¨Ø¯ÙˆÙ† Ù…Ø§Ù„ÙŠØ§Øª',0),(564664,15686,'tr','HiÃ§bir gelir vergisi',0),(564665,15686,'pl','Nie podatek dochodowy',0),(564666,15686,'bg','ÐÑÐ¼Ð° Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð²ÑŠÑ€Ñ…Ñƒ Ð´Ð¾Ñ…Ð¾Ð´Ð°',0),(564667,15686,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ù†Ú©Ù… Ù¹ÛŒÚ©Ø³ Ù†ÛÛŒÚº',0),(564668,15686,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ðµ',0),(564669,15686,'vi','Miá»…n thuáº¿ thu nháº­p',0),(564670,15686,'af','Geen inkomste belasting',0),(564671,15686,'ro','Nici impozitele pe venit',0),(564672,15686,'et','No tulumaks',0),(564673,15686,'si','Brez dohodnine',0),(564674,15686,'ba','Tidak ada pajak pendapatan',0),(564675,15686,'nl','Geen inkomensbelastingen',0),(564676,15686,'fi','Tuloslaskelman tuloverot',0),(564677,15686,'no','Ingen skatt',0),(564678,15686,'da','Ingen indkomstskatter',0),(564679,15686,'ko','ì†Œë“ì„¸ ì—†ìŒ',0),(564680,15686,'he','××™×Ÿ ×ž×¡ ×”×›× ×¡×”',0),(564681,15686,'el','Î§Ï‰ÏÎ¯Ï‚ Ï„Î¿Ï…Ï‚ Ï†ÏŒÏÎ¿Ï…Ï‚ ÎµÎ¹ÏƒÎ¿Î´Î®Î¼Î±Ï„Î¿Ï‚',0),(564682,15686,'zh','æ²¡æœ‰ä¸ªäººæ‰€å¾—ç¨Ž',0),(564683,15686,'sv','Ingen inkomstskatt',0),(564684,15686,'it','Nessuna tassa di reddito',0),(564685,15686,'tl','',0),(564686,15686,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸ à¸²à¸©à¸µà¹€à¸‡à¸´à¸™à¹„à¸”à¹‰',0),(564687,15686,'hi','à¤•à¥‹à¤ˆ à¤†à¤¯ à¤•à¤°à¥‹à¤‚',0),(564688,15686,'ms','Tiada cukai pendapatan',0),(564689,15686,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¯Ø®Ù„',0),(564690,15686,'fr','Aucun impÃ´t sur le revenu',0),(564691,15686,'jp','æ‰€å¾—ç¨Žãªã—',0),(564692,15686,'pt','Sem impostos sobre o rendimento',0),(564693,15686,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð´Ð¾Ñ…Ð¾Ð´Ð½Ð¾Ð³Ð¾ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(564694,15686,'es','No hay impuestos sobre la renta',0),(564695,15686,'de','Keine Ertragsteuern',0),(564696,15686,'en','No Income Taxes',0),(564697,15687,'is','',0),(564698,15687,'dr','Ù‡ÛŒÚ† Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø§Ù„ÛŒØ§Øª Ø¨ÛŒÚ©Ø§Ø±ÛŒ',0),(564699,15687,'pr','Ù‡ÛŒÚ† Ø¯Ø±Ø¢Ù…Ø¯ Ù…Ø§Ù„ÛŒØ§Øª Ø¨ÛŒÚ©Ø§Ø±ÛŒ',0),(564700,15687,'tr','HiÃ§bir geliri, iÅŸsizlik vergiler',0),(564701,15687,'pl','Å»adnego dochodu, podatki dla bezrobotnych',0),(564702,15687,'bg','ÐÑÐ¼Ð° Ð´Ð¾Ñ…Ð¾Ð´Ð¸, Ð´Ð°Ð½ÑŠÑ†Ð¸, Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ð°',0),(564703,15687,'ur','Ú©ÙˆØ¦ÛŒ Ø¢Ù…Ø¯Ù†ÛŒ Ù†ÛÛŒÚº ÛÛ’ØŒ Ø¨Û’ Ø±ÙˆØ²Ú¯Ø§Ø±ÛŒ Ú©ÛŒ Ø´Ø±Ø­ Ù¹ÛŒÚ©Ø³',0),(564704,15687,'sr','Ð‘ÐµÐ· Ð¿Ñ€Ð¸Ñ…Ð¾Ð´Ð°, Ð½ÐµÐ·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾Ñ€ÐµÐ·',0),(564705,15687,'vi','KhÃ´ng cÃ³ thu nháº­p, thuáº¿ tháº¥t nghiá»‡p',0),(564706,15687,'af','Geen inkomste, werkloosheid belasting',0),(564707,15687,'ro','Nici un venit, somaj taxe',0),(564708,15687,'et','Tulu, tÃ¶Ã¶tuskindlustuse maksud',0),(564709,15687,'si','Brez dohodkov, nezaposlenosti davkov',0),(564710,15687,'ba','Tidak ada pendapatan, pajak pengangguran',0),(564711,15687,'nl','Geen inkomen, werkloosheid belastingen',0),(564712,15687,'fi','Tuloa tyÃ¶ttÃ¶myyden verot',0),(564713,15687,'no','Ingen inntekt, arbeidsledighet skatter',0),(564714,15687,'da','Ingen indkomst, arbejdslÃ¸shed skatter',0),(564715,15687,'ko','ì•„ë¬´ ì†Œë“, ì‹¤ì§ ì„¸ê¸ˆ',0),(564716,15687,'he','×”×›× ×¡×”, ××‘×˜×œ×” ×ž×™×¡×™×',0),(564717,15687,'el','Î§Ï‰ÏÎ¯Ï‚ ÎµÎ¹ÏƒÏŒÎ´Î·Î¼Î±, Î±Î½ÎµÏÎ³Î¯Î± Ï†ÏŒÏÏ‰Î½',0),(564718,15687,'zh','æ²¡æœ‰æ”¶å…¥ï¼Œå¤±ä¸šç¨Ž',0),(564719,15687,'sv','Ingen inkomst, arbetslÃ¶shet skatter',0),(564720,15687,'it','Nessun reddito, tasse di disoccupazione',0),(564721,15687,'tl','',0),(564722,15687,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸²à¸¢à¹„à¸”à¹‰ à¸§à¹ˆà¸²à¸‡à¸‡à¸²à¸™à¸ à¸²à¸©à¸µ',0),(564723,15687,'hi','à¤•à¥‹à¤ˆ à¤†à¤¯, à¤¬à¥‡à¤°à¥‹à¤œà¤—à¤¾à¤°à¥€ à¤•à¤°à¥‹à¤‚',0),(564724,15687,'ms','Tiada pendapatan, cukai pengangguran',0),(564725,15687,'ar','Ù„Ø§ Ø§Ù„Ø¯Ø®Ù„ØŒ ÙˆØ¶Ø±Ø§Ø¦Ø¨ Ø§Ù„Ø¨Ø·Ø§Ù„Ø©',0),(564726,15687,'fr','Aucun revenu, chÃ´mage Taxes',0),(564727,15687,'jp','ç„¡åŽå…¥ã€å¤±æ¥­ç¨Ž',0),(564728,15687,'pt','Sem renda, impostos de desemprego',0),(564729,15687,'ru','ÐÐ¸ÐºÐ°ÐºÐ¸Ñ… Ð´Ð¾Ñ…Ð¾Ð´Ð¾Ð², Ð±ÐµÐ·Ñ€Ð°Ð±Ð¾Ñ‚Ð¸Ñ†Ñ‹ Ð½Ð°Ð»Ð¾Ð³Ð¸',0),(564730,15687,'es','Sin ingresos, impuestos de desempleo',0),(564731,15687,'de','Kein Einkommen, Arbeitslosigkeit Steuern',0),(564732,15687,'en','No Income, Unemployment Taxes',0),(564733,15688,'is','',0),(564734,15688,'dr','Ø¨Ø¯ÙˆÙ† Ù…Ø§Ù„ÛŒØ§Øª',0),(564735,15688,'pr','Ø¨Ø¯ÙˆÙ† Ù…Ø§Ù„ÛŒØ§Øª',0),(564736,15688,'tr','Vergi yok',0),(564737,15688,'pl','Nie podatkÃ³w',0),(564738,15688,'bg','Ð‘ÐµÐ· Ð´Ð°Ð½ÑŠÑ†Ð¸',0),(564739,15688,'ur','Ú©ÙˆØ¦ÛŒ Ù¹ÛŒÚ©Ø³ Ù†ÛÛŒÚº',0),(564740,15688,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(564741,15688,'vi','Miá»…n thuáº¿',0),(564742,15688,'af','Geen belastings',0),(564743,15688,'ro','Nici taxe',0),(564744,15688,'et','Makse',0),(564745,15688,'si','Brez davkov',0),(564746,15688,'ba','Tidak ada pajak',0),(564747,15688,'nl','Geen belastingen',0),(564748,15688,'fi','Ei veroja',0),(564749,15688,'no','Ingen avgifter',0),(564750,15688,'da','Ingen skatter',0),(564751,15688,'ko','ì•„ë‹ˆ ì„¸ê¸ˆ',0),(564752,15688,'he','×‘×œ×™ ×ž×™×¡×™×',0),(564753,15688,'el','Î§Ï‰ÏÎ¯Ï‚ Ï†ÏŒÏÎ¿Ï…Ï‚',0),(564754,15688,'zh','æ— ç¨Ž',0),(564755,15688,'sv','Inga skatter',0),(564756,15688,'it','Non ci sono tasse',0),(564757,15688,'tl','',0),(564758,15688,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸ à¸²à¸©à¸µ',0),(564759,15688,'hi','à¤•à¥‹à¤ˆ à¤•à¤°à¥‹à¤‚',0),(564760,15688,'ms','Tidak ada cukai',0),(564761,15688,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø¶Ø±Ø§Ø¦Ø¨',0),(564762,15688,'fr','Pas de Taxes',0),(564763,15688,'jp','ç¨Žé‡‘',0),(564764,15688,'pt','Sem impostos',0),(564765,15688,'ru','Ð‘ÐµÐ· Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(564766,15688,'es','Sin impuestos',0),(564767,15688,'de','Keine Steuern',0),(564768,15688,'en','No Taxes',0),(564769,15689,'is','',0),(564770,15689,'dr','Ø§ÙØ³Øª',0),(564771,15689,'pr','Ø§ÙØ³Øª',0),(564772,15689,'tr','Ofset',0),(564773,15689,'pl','PrzesuniÄ™cie',0),(564774,15689,'bg','ÐšÐ¾Ð¼Ð¿ÐµÐ½ÑÐ¸Ñ€Ð°',0),(564775,15689,'ur','Ø¢ÙØ³Ù¹',0),(564776,15689,'sr','ÐŸÐ¾Ð¼Ð°Ðº',0),(564777,15689,'vi','BÃ¹ Ä‘áº¯p',0),(564778,15689,'af','Geneutraliseer',0),(564779,15689,'ro','Compensate',0),(564780,15689,'et','Nihe',0),(564781,15689,'si','Odmik',0),(564782,15689,'ba','Offset',0),(564783,15689,'nl','Offset',0),(564784,15689,'fi','SiirtymÃ¤',0),(564785,15689,'no','Forskyvning',0),(564786,15689,'da','Offset',0),(564787,15689,'ko','ì˜¤í”„ì…‹',0),(564788,15689,'he','×”×™×¡×˜',0),(564789,15689,'el','Î‘Î½Ï„Î¹ÏƒÏ„Î¬Î¸Î¼Î¹ÏƒÎ·',0),(564790,15689,'zh','åç§»é‡',0),(564791,15689,'sv','Offset',0),(564792,15689,'it','Offset',0),(564793,15689,'tl','',0),(564794,15689,'th','à¸•à¸£à¸‡à¸‚à¹‰à¸²à¸¡',0),(564795,15689,'hi','à¤‘à¤«à¤¸à¥‡à¤Ÿ',0),(564796,15689,'ms','Mengimbangi',0),(564797,15689,'ar','Ø§Ù„Ø¥Ø²Ø§Ø­Ø©',0),(564798,15689,'fr','CompensÃ©',0),(564799,15689,'jp','ã‚ªãƒ•ã‚»ãƒƒãƒˆ',0),(564800,15689,'pt','Deslocamento',0),(564801,15689,'ru','Ð¡Ð¼ÐµÑ‰ÐµÐ½Ð¸Ðµ',0),(564802,15689,'es','En offset',0),(564803,15689,'de','Versatz',0),(564804,15689,'en','Offset',0),(564805,15690,'is','',0),(564806,15690,'dr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ù‚Ø¨Ù„ÛŒ',0),(564807,15690,'pr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ù‚Ø¨Ù„ÛŒ',0),(564808,15690,'tr','Ã–nceki Ã§alÄ±ÅŸan',0),(564809,15690,'pl','Dotychczasowego pracownika',0),(564810,15690,'bg','ÐŸÑ€ÐµÐ´Ð¸ÑˆÐµÐ½ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ»',0),(564811,15690,'ur','Ø³Ø§Ø¨Ù‚ Ù…Ù„Ø§Ø²Ù…',0),(564812,15690,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¸ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(564813,15690,'vi','NhÃ¢n viÃªn trÆ°á»›c Ä‘Ã¢y',0),(564814,15690,'af','Vorige werknemer',0),(564815,15690,'ro','Respectivul',0),(564816,15690,'et','Eelmine tÃ¶Ã¶taja',0),(564817,15690,'si','PrejÅ¡nje zaposlenih',0),(564818,15690,'ba','Sebelumnya karyawan',0),(564819,15690,'nl','Vorige werknemer',0),(564820,15690,'fi','Entinen tyÃ¶ntekijÃ¤',0),(564821,15690,'no','Tidligere ansatt',0),(564822,15690,'da','Tidligere medarbejder',0),(564823,15690,'ko','ì´ì „ ì§ì›',0),(564824,15690,'he','×”×¢×•×‘×“ ×§×•×“×ž×•×ª',0),(564825,15690,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Î¿Ï‚ Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚',0),(564826,15690,'zh','ä»¥å‰çš„å‘˜å·¥',0),(564827,15690,'sv','Tidigare anstÃ¤lld',0),(564828,15690,'it','Precedente dipendente',0),(564829,15690,'tl','',0),(564830,15690,'th','à¸­à¸”à¸µà¸•à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(564831,15690,'hi','à¤ªà¥‚à¤°à¥à¤µ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€',0),(564832,15690,'ms','Pekerja yang terdahulu',0),(564833,15690,'ar','Ø§Ù„Ù…ÙˆØ¸Ù Ø§Ù„Ø³Ø§Ø¨Ù‚',0),(564834,15690,'fr','Ancien employÃ©',0),(564835,15690,'jp','å‰ã®å¾“æ¥­å“¡',0),(564836,15690,'pt','FuncionÃ¡rio anterior',0),(564837,15690,'ru','ÐŸÑ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(564838,15690,'es','Empleado anterior',0),(564839,15690,'de','FrÃ¼here Mitarbeiter',0),(564840,15690,'en','Previous Employee',0),(564841,15691,'is','',0),(564842,15691,'dr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ Ù‚Ø¨Ù„ÛŒ',0),(564843,15691,'pr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ Ù‚Ø¨Ù„ÛŒ',0),(564844,15691,'tr','Ã–nceki dÃ¶nemlere',0),(564845,15691,'pl','Poprzednich okresÃ³w',0),(564846,15691,'bg','ÐŸÑ€ÐµÐ´Ð¸ÑˆÐ½Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸',0),(564847,15691,'ur','Ø³Ø§Ø¨Ù‚Û Ø§Ø¯ÙˆØ§Ø±',0),(564848,15691,'sr','ÐŸÑ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¾Ð³ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(564849,15691,'vi','TrÆ°á»›c thá»i gian',0),(564850,15691,'af','Vorige tydperke',0),(564851,15691,'ro','Perioadele anterioare',0),(564852,15691,'et','Eelmiste perioodide',0),(564853,15691,'si','PrejÅ¡nja obdobja',0),(564854,15691,'ba','Periode sebelumnya',0),(564855,15691,'nl','Voorgaande perioden',0),(564856,15691,'fi','Edellisten kausien',0),(564857,15691,'no','Tidligere perioder',0),(564858,15691,'da','Tidligere perioder',0),(564859,15691,'ko','ì´ì „ ê¸°ê°„',0),(564860,15691,'he','×ž×ª×§×•×¤×•×ª ×§×•×“×ž×•×ª',0),(564861,15691,'el','Î ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ Ï€ÎµÏÎ¯Î¿Î´Î¿Î¹',0),(564862,15691,'zh','ä»¥å¾€å„æœŸ',0),(564863,15691,'sv','Tidigare perioder',0),(564864,15691,'it','Periodi precedenti',0),(564865,15691,'tl','',0),(564866,15691,'th','à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²',0),(564867,15691,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤…à¤µà¤§à¤¿',0),(564868,15691,'ms','Tempoh-tempoh sebelumnya',0),(564869,15691,'ar','Ø§Ù„ÙØªØ±Ø§Øª Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(564870,15691,'fr','PÃ©riodes antÃ©rieures',0),(564871,15691,'jp','å‰ã®æœŸé–“',0),(564872,15691,'pt','PerÃ­odos anteriores',0),(564873,15691,'ru','ÐŸÑ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñ‹',0),(564874,15691,'es','PerÃ­odos anteriores',0),(564875,15691,'de','Vorperioden',0),(564876,15691,'en','Previous Periods',0),(564877,15692,'is','',0),(564878,15692,'dr','Ø³Ø§Ø¹Øª ØªÙ†Ø¸ÛŒÙ… Ù¾ÛŒØ´ ÙØ±Ø¶',0),(564879,15692,'pr','Ø³Ø§Ø¹Øª ØªÙ†Ø¸ÛŒÙ… Ù¾ÛŒØ´ ÙØ±Ø¶',0),(564880,15692,'tr','VarsayÄ±lan saat',0),(564881,15692,'pl','Ustaw domyÅ›lne godziny',0),(564882,15692,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ‡Ð°ÑÐ°',0),(564883,15692,'ur','Ø·Û’ Ø´Ø¯Û Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ú©Û’ Ø§ÙˆÙ‚Ø§Øª',0),(564884,15692,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾Ð³ ÑÐ°Ñ‚Ð¸',0),(564885,15692,'vi','Thiáº¿t láº­p máº·c Ä‘á»‹nh giá»',0),(564886,15692,'af','Stel verstek ure',0),(564887,15692,'ro','Set Default ore',0),(564888,15692,'et','Vaikesuvandite seadmine tundi',0),(564889,15692,'si','Nastavi privzete ure',0),(564890,15692,'ba','Menetapkan Default jam',0),(564891,15692,'nl','Set standaarduren',0),(564892,15692,'fi','Aseta oletus tuntia',0),(564893,15692,'no','Angi standard timer',0),(564894,15692,'da','SÃ¦t standard timer',0),(564895,15692,'ko','ê¸°ë³¸ ì„¤ì •ëœ ì‹œê°„',0),(564896,15692,'he','×©×¢×•×ª ×©× ×§×‘×¢ ×›×‘×¨×™×¨×ª ×ž×—×“×œ',0),(564897,15692,'el','ÎŸÏÎ¹ÏƒÎ¼ÏŒÏ‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î·Ï‚ ÏŽÏÎµÏ‚',0),(564898,15692,'zh','è®¾ç½®çš„é»˜è®¤å°æ—¶',0),(564899,15692,'sv','Ange timmar',0),(564900,15692,'it','Imposta predefinito ore',0),(564901,15692,'tl','',0),(564902,15692,'th','à¹€à¸§à¸¥à¸²à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(564903,15692,'hi','à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤˜à¤‚à¤Ÿà¥‡',0),(564904,15692,'ms','Jam set lalai',0),(564905,15692,'ar','ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø³Ø§Ø¹Ø§Øª',0),(564906,15692,'fr','Heures de configuration par dÃ©faut',0),(564907,15692,'jp','è¨­å®šã®æ—¢å®šã®æ™‚é–“',0),(564908,15692,'pt','Conjunto padrÃ£o horas',0),(564909,15692,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ñ‡Ð°ÑÐ¾Ð²',0),(564910,15692,'es','Conjunto predeterminado horas',0),(564911,15692,'de','Festlegen von Standard-Stunden',0),(564912,15692,'en','Set Default Hours',0),(564913,15693,'is','',0),(564914,15693,'dr','Ù…Ø§Ù„ÛŒØ§Øª Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(564915,15693,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(564916,15693,'tr','Vergi hesaplamasÄ±',0),(564917,15693,'pl','ZostaÅ‚y obliczone podatki',0),(564918,15693,'bg','Ð”Ð°Ð½ÑŠÑ†Ð¸ ÑÐ° Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸',0),(564919,15693,'ur','Ù¹ÛŒÚ©Ø³ Ú©Ø§ Ø­Ø³Ø§Ø¨ Ù„Ú¯Ø§ÛŒØ§ Ø¬Ø§ØªØ§ Ø±ÛØ§ ÛÛ’',0),(564920,15693,'sr','ÐŸÐ¾Ñ€ÐµÐ·Ð¸ ÑÑƒ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚Ð¸',0),(564921,15693,'vi','Thuáº¿ Ä‘Ã£ Ä‘Æ°á»£c tÃ­nh toÃ¡n',0),(564922,15693,'af','Belasting bereken is',0),(564923,15693,'ro','Taxele au fost calculate',0),(564924,15693,'et','Maksud on arvutatud',0),(564925,15693,'si','Davki so bile izraÄunane',0),(564926,15693,'ba','Pajak telah menghitung',0),(564927,15693,'nl','Belastingen zijn berekend',0),(564928,15693,'fi','Verot on arvioitu',0),(564929,15693,'no','Avgifter er beregnet',0),(564930,15693,'da','Skatter er beregnet',0),(564931,15693,'ko','ì„¸ê¸ˆ ê³„ì‚°',0),(564932,15693,'he','×—×•×©×‘×• ×ž×¡×™×',0),(564933,15693,'el','Î¦ÏŒÏÎ¿Î¹ Î­Ï‡Î¿Ï…Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„ÎµÎ¯',0),(564934,15693,'zh','å·²è®¡ç®—ç¨Žé‡‘',0),(564935,15693,'sv','Skatter har berÃ¤knats',0),(564936,15693,'it','Le tasse sono state calcolate',0),(564937,15693,'tl','',0),(564938,15693,'th','à¸¡à¸µà¸à¸²à¸£à¸„à¸³à¸™à¸§à¸“à¸ à¸²à¸©à¸µ',0),(564939,15693,'hi','à¤•à¤°à¥‹à¤‚ à¤•à¥€ à¤—à¤£à¤¨à¤¾ à¤•à¥€ à¤—à¤ˆ à¤¹à¥ˆ',0),(564940,15693,'ms','Cukai dikira',0),(564941,15693,'ar','ÙˆØªÙ… Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨',0),(564942,15693,'fr','Ont a calculÃ© les impÃ´ts',0),(564943,15693,'jp','ç¨Žé‡‘ãŒè¨ˆç®—ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(564944,15693,'pt','Os impostos foram calculados',0),(564945,15693,'ru','Ð Ð°ÑÑ‡ÐµÑ‚ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²',0),(564946,15693,'es','Se han calculado los impuestos',0),(564947,15693,'de','Steuern wurden berechnet',0),(564948,15693,'en','Taxes Have Been Calculated',0),(564949,15694,'is','',0),(564950,15694,'dr','Ù„ÙˆØ§ÛŒØ­ ØªØµÙˆÛŒØ¨ Ø´Ø¯Ù‡ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(564951,15694,'pr','Ù„ÙˆØ§ÛŒØ­ ØªØµÙˆÛŒØ¨ Ø´Ø¯Ù‡ Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(564952,15694,'tr','FaturalarÄ± Ã¶deme iÃ§in onaylayabilirsiniz',0),(564953,15694,'pl','MoÅ¼na zatwierdziÄ‡ rachunki dla pÅ‚atnoÅ›ci',0),(564954,15694,'bg','ÐœÐ¾Ð¶Ðµ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€ÑÐ²Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(564955,15694,'ur','Ø¨Ù„ÙˆÚº Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©Ø± Ø³Ú©ØªÛ’ ÛÛŒÚº',0),(564956,15694,'sr','ÐœÐ¾Ð³Ñƒ Ð´Ð° Ð¾Ð´Ð¾Ð±Ñ€Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ',0),(564957,15694,'vi','CÃ³ thá»ƒ cháº¥p nháº­n hÃ³a Ä‘Æ¡n thanh toÃ¡n',0),(564958,15694,'af','Rekeninge kan goedkeur vir betaling',0),(564959,15694,'ro','Poate aproba facturi pentru plata',0),(564960,15694,'et','Ã•igus kinnitada arveid maksmiseks',0),(564961,15694,'si','Lahko odobri raÄune za plaÄilo',0),(564962,15694,'ba','Dapat menyetujui tagihan pembayaran',0),(564963,15694,'nl','Rekeningen kunnen goedkeuren voor betaling',0),(564964,15694,'fi','HyvÃ¤ksyÃ¤ laskujen maksamisesta',0),(564965,15694,'no','Kan godkjenne regninger For betaling',0),(564966,15694,'da','Kan godkende regninger til betaling',0),(564967,15694,'ko','ì§€ë¶ˆì„ ìœ„í•œ ì²­êµ¬ì„œë¥¼ ìŠ¹ì¸í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(564968,15694,'he','× ×™×ª×Ÿ ×œ××©×¨ ××ª ×”×—×©×‘×•× ×•×ª ×œ×ª×©×œ×•×',0),(564969,15694,'el','ÎÎ± ÎµÎ³ÎºÏÎ¯Î½Î¿Ï…Î¼Îµ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(564970,15694,'zh','å¯ä»¥ä¸ºä»˜æ¬¾æ‰¹å‡†æ³•æ¡ˆ',0),(564971,15694,'sv','Kan godkÃ¤nna rÃ¤kningar fÃ¶r betalning',0),(564972,15694,'it','PuÃ² approvare le fatture per il pagamento',0),(564973,15694,'tl','',0),(564974,15694,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¹€à¸‡à¸´à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(564975,15694,'hi','à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤•à¤° à¤¸à¤•à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(564976,15694,'ms','Boleh meluluskan rang undang-undang bagi pembayaran',0),(564977,15694,'ar','ÙˆÙŠÙ…ÙƒÙ† Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ù„Ù„Ø¯ÙØ¹',0),(564978,15694,'fr','Peut approuver des factures de paiement',0),(564979,15694,'jp','æ”¯æ‰•æ‰‹å½¢ã‚’æ‰¿èªã™ã‚‹ã“ã¨ãŒ',0),(564980,15694,'pt','Pode aprovar as contas para pagamento',0),(564981,15694,'ru','ÐœÐ¾Ð¶Ð½Ð¾ ÑƒÑ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(564982,15694,'es','Puede aprobar proyectos de ley para el pago',0),(564983,15694,'de','Rechnungen kÃ¶nnen fÃ¼r die Zahlung genehmigt werden.',0),(564984,15694,'en','Can Approve Bills For Payment',0),(564985,15695,'is','',0),(564986,15695,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ú©Ù„',0),(564987,15695,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ú©Ù„',0),(564988,15695,'tr','Toplam maliyeti',0),(564989,15695,'pl','Koszty caÅ‚kowite',0),(564990,15695,'bg','ÐžÐ±Ñ‰Ð¾ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(564991,15695,'ur','Ú©Ù„ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(564992,15695,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(564993,15695,'vi','Tá»•ng chi phÃ­',0),(564994,15695,'af','Totale koste',0),(564995,15695,'ro','Costurile totale',0),(564996,15695,'et','Kulud kokku',0),(564997,15695,'si','Skupni stroÅ¡ki',0),(564998,15695,'ba','Total biaya',0),(564999,15695,'nl','Totale kosten',0),(565000,15695,'fi','Kokonaiskustannukset',0),(565001,15695,'no','Totale kostnader',0),(565002,15695,'da','Samlede omkostninger',0),(565003,15695,'ko','ì´ ë¹„ìš©',0),(565004,15695,'he','×¢×œ×•×™×•×ª',0),(565005,15695,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚',0),(565006,15695,'zh','æ€»æˆæœ¬',0),(565007,15695,'sv','Totala kostnader',0),(565008,15695,'it','Totali costi',0),(565009,15695,'tl','',0),(565010,15695,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸£à¸§à¸¡',0),(565011,15695,'hi','à¤•à¥à¤² à¤²à¤¾à¤—à¤¤',0),(565012,15695,'ms','Jumlah kos',0),(565013,15695,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(565014,15695,'fr','CoÃ»ts totaux',0),(565015,15695,'jp','ç·ã‚³ã‚¹ãƒˆ',0),(565016,15695,'pt','Custos totais',0),(565017,15695,'ru','ÐžÐ±Ñ‰Ð¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(565018,15695,'es','Costos totales',0),(565019,15695,'de','Kosten insgesamt',0),(565020,15695,'en','Total Costs',0),(565021,15696,'is','',0),(565022,15696,'dr','Ù†Ù…Ø§ÛŒØ´ Ø­Ø±ÙˆÙ Ø§ÙˆÙ„ Ø§Ø³Ù… Approvers\' Ø¯Ø± Ú¯Ø²ÛŒÙ†Ù‡ ØªØ±Ù…ÛŒÙ†Ø§Ù„',0),(565023,15696,'pr','Ù†Ù…Ø§ÛŒØ´ Ø­Ø±ÙˆÙ Ø§ÙˆÙ„ Ø§Ø³Ù… Approvers\' Ø¯Ø± Ú¯Ø²ÛŒÙ†Ù‡ ØªØ±Ù…ÛŒÙ†Ø§Ù„',0),(565024,15696,'tr','Onaylayanlar baÅŸ harfleri onay saplama Ã¼zerinde gÃ¶ster',0),(565025,15696,'pl','PokaÅ¼ osÃ³b zatwierdzajÄ…cych inicjaÅ‚y na Stub wyboru',0),(565026,15696,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÑÐ²Ð°Ñ‰Ð¸ Ð² Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ð»Ð¸Ñ‚Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°Ñ‚Ð° Ð²ÑÐµ Ð¾Ñ‰Ðµ Ð¼ÑŠÐ½Ð¸Ñ‡Ðµ',0),(565027,15696,'ur','Ø§Ù¾Ù¾Ø±ÙˆÙˆØ±Ø³ Ú©Û’ Ù…Ø®ØªØµØ± Ø¯Ø³ØªØ®Ø· Ù¾Ú‘ØªØ§Ù„ Ø¯Ø§Ú‘Ú¾ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(565028,15696,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¾ÑÐ¾Ð±Ðµ ÐºÐ¾Ñ˜Ðµ Ð²Ñ€ÑˆÐµ Ð¸Ð½Ð¸Ñ†Ð¸Ñ˜Ð°Ð»Ðµ Ð½Ð° Ð¾Ð´ÑÐµÐ¸Ð°Ðº',0),(565029,15696,'vi','Hiá»ƒn thá»‹ khÃ¡ch sáº¡n Approvers\' táº¯t trÃªn kiá»ƒm tra ngáº«u nhiÃªn',0),(565030,15696,'af','Wys Approvers se voorletters op kontroleer saadjie',0),(565031,15696,'ro','AratÄƒ aprobatori iniÅ£ialele pe Check ciot',0),(565032,15696,'et','Kuva kinnitajad initsiaalid kontrollida jupp',0),(565033,15696,'si','PrikaÅ¾i potrjevalcev zaÄetnice na preverite Å¡krbina',0),(565034,15696,'ba','Lihat inisial Approvers\' Check rintisan',0),(565035,15696,'nl','Toon fiatteurs initialen op selectievakje Stub',0),(565036,15696,'fi','NÃ¤ytÃ¤ hyvÃ¤ksyjÃ¤t nimikirjaimet Tarkista tynkÃ¤',0),(565037,15696,'no','Vis godkjennere initialer pÃ¥ sjekk spire',0),(565038,15696,'da','Vis godkendere initialer pÃ¥ Check Stub',0),(565039,15696,'ko','ì²´í¬ ìŠ¤í…ì— ìŠ¹ì¸ìžì˜ ì´ë‹ˆì…œì„ í‘œì‹œ',0),(565040,15696,'he','×”×¦×’ ××ª ××ª ×¨××©×™ ×”×ª×™×‘×•×ª ×”×ž××©×¨×™× ×¢×œ ×”×¡×™×ž×•×Ÿ Stub',0),(565041,15696,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï„Ï‰Î½ Ï…Ï€ÎµÏÎ¸Ï…Î½Ï‰Î½ Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚ Î±ÏÏ‡Î¹ÎºÎ¬ Î±Ï€ÏŒÎºÎ¿Î¼Î¼Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(565042,15696,'zh','åœ¨æ”¯ç¥¨å­˜æ ¹ä¸Šæ˜¾ç¤ºå®¡æ‰¹è€…çš„å§“åç¼©å†™',0),(565043,15696,'sv','Visa godkÃ¤nnare initialer pÃ¥ Check Stub',0),(565044,15696,'it','Visualizza le iniziali degli approvatori Check Stub',0),(565045,15696,'tl','',0),(565046,15696,'th','à¹à¸ªà¸”à¸‡à¸Šà¸·à¹ˆà¸­à¸¢à¹ˆà¸­à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸‚à¸±à¹‰à¸§',0),(565047,15696,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤• à¤ªà¥à¤°à¤¥à¤®à¤¾à¤•à¥à¤·à¤° à¤šà¥‡à¤• à¤¸à¥à¤Ÿà¤¬ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(565048,15696,'ms','Tunjuk Approvers\' singkatan semak tunas',0),(565049,15696,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø£Ø­Ø±Ù Ø§Ù„Ø£ÙˆÙ„Ù‰ Ø§Ù„Ù…ÙˆØ§ÙÙ‚ÙŠÙ† Ø¹Ù„Ù‰ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ÙƒØ¹Ø¨ Ø§Ù„Ø±ÙˆØªÙŠÙ†',0),(565050,15696,'fr','Voir l\'Ã©tablissement initiales approbateurs sur le talon de chÃ¨que',0),(565051,15696,'jp','ãƒã‚§ãƒƒã‚¯ ã‚¹ã‚¿ãƒ–ã«æ‰¿èªè€…ã®ã‚¤ãƒ‹ã‚·ãƒ£ãƒ«ã‚’ç¤ºã™',0),(565052,15696,'pt','Mostrar as iniciais dos aprovadores no esboÃ§o de seleÃ§Ã£o',0),(565053,15696,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´Ð°ÑŽÑ‰Ð¸Ñ… Ð¸Ð½Ð¸Ñ†Ð¸Ð°Ð»Ñ‹ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð·Ð°Ð³Ð»ÑƒÑˆÐºÐ¸',0),(565054,15696,'es','Muestra las iniciales de los aprobadores en talÃ³n de cheque',0),(565055,15696,'de','Genehmiger Initialen auf Check Stub anzeigen',0),(565056,15696,'en','Show Approvers\' Initials On Check Stub',0),(565057,15697,'is','',0),(565058,15697,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ GL Ù‡Ù†Ú¯Ø§Ù… Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(565059,15697,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ GL Ù‡Ù†Ú¯Ø§Ù… Ø³Ø§Ø¹Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ…',0),(565060,15697,'tr','Saklamak GL rapor saat oturum sÄ±rasÄ±nda',0),(565061,15697,'pl','Ukryj GL kont, gdy rejestrowanie godzin',0),(565062,15697,'bg','Ð¡ÐºÑ€Ð¸Ð¹ GL ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð¿Ñ€Ð¸ Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð½Ð° Ñ‡Ð°ÑÐ°',0),(565063,15697,'ur','Ø¬Ø¨ Ù„Ø§Ú¯Ù†Ú¯ Ú¯Ú¾Ù†Ù¹Û’ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(565064,15697,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð“Ð› ÐºÐ¾Ð½Ñ‚Ð° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ€Ð°ÑšÐ° ÑÐ°Ñ‚Ð¸',0),(565065,15697,'vi','áº¨n GL tÃ i khoáº£n khi Ä‘Äƒng nháº­p giá»',0),(565066,15697,'af','GL rekeninge versteek wanneer teken ure',0),(565067,15697,'ro','Ascunde GL conturile cÃ®nd Logging ore',0),(565068,15697,'et','Peida GL kontosid, kui metsaraie tundi',0),(565069,15697,'si','Skriti GL raÄunov ob prijavi ur',0),(565070,15697,'ba','Menyembunyikan account GL ketika login jam',0),(565071,15697,'nl','GL Accounts verbergen tijdens de registratie van uren',0),(565072,15697,'fi','Piilota GL-tilejÃ¤, kun kirjaudut tuntia',0),(565073,15697,'no','Skjule GL kontoer nÃ¥r Logging timer',0),(565074,15697,'da','Skjule GL konti, nÃ¥r du logger timer',0),(565075,15697,'ko','ì‹œê°„ì„ ë¡œê·¸ì¸ í•  ë•Œ GL ê³„ì • ìˆ¨ê¸°ê¸°',0),(565076,15697,'he','×œ×”×¡×ª×™×¨ ×—×©×‘×•× ×•×ª GL ×‘×¢×ª ×¨×™×©×•× ×©×¢×•×ª',0),(565077,15697,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î³/Î», ÎºÎ±Ï„Î¬ Ï„Î· ÏƒÏÎ½Î´ÎµÏƒÎ· ÏŽÏÎµÏ‚',0),(565078,15697,'zh','éšè— GL å¸æˆ·ç™»å½•å°æ—¶æ—¶',0),(565079,15697,'sv','DÃ¶lja GL konton nÃ¤r loggning timmar',0),(565080,15697,'it','Nascondere i conti di contabilitÃ  generale quando la registrazione ore',0),(565081,15697,'tl','',0),(565082,15697,'th','à¸‹à¹ˆà¸­à¸™à¸šà¸±à¸à¸Šà¸µ GL à¹€à¸¡à¸·à¹ˆà¸­à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(565083,15697,'hi','à¤œà¤¬ à¤˜à¤‚à¤Ÿà¥‡ à¤ªà¥à¤°à¤µà¥‡à¤¶ GL à¤–à¤¾à¤¤à¥‹à¤‚ à¤›à¥à¤ªà¤¾à¤à¤',0),(565084,15697,'ms','Sembunyikan GL akaun apabila log jam',0),(565085,15697,'ar','Ø¥Ø®ÙØ§Ø¡ Ø­Ø³Ø§Ø¨Ø§Øª GL Ø¹Ù†Ø¯ ØªØ³Ø¬ÙŠÙ„ Ø³Ø§Ø¹Ø§Øª',0),(565086,15697,'fr','Masquer les comptes GL lorsque vous vous connectez heures',0),(565087,15697,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’éžè¡¨ç¤ºã«æ™‚é–“ã‚’ãƒ­ã‚°ã‚¤ãƒ³ã™ã‚‹ã¨ã',0),(565088,15697,'pt','Esconder contas GL quando registrando horas',0),(565089,15697,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ GL ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¿Ñ€Ð¸ Ð²Ñ…Ð¾Ð´Ðµ Ñ‡Ð°ÑÐ¾Ð²',0),(565090,15697,'es','Ocultar cuentas GL cuando horas',0),(565091,15697,'de','Auszublenden Sie GL-Konten, wenn Stunden Protokollierung',0),(565092,15697,'en','Hide GL Accounts When Logging Hours',0),(565093,15698,'is','',0),(565094,15698,'dr','Ù¾ÛŒÙˆØ³Øª',0),(565095,15698,'pr','Ù¾ÛŒÙˆØ³Øª',0),(565096,15698,'tr','Eki',0),(565097,15698,'pl','ZaÅ‚Ä…cznik',0),(565098,15698,'bg','ÐŸÑ€Ð¸ÐºÐ°Ñ‡ÐµÐ½ Ñ„Ð°Ð¹Ð»',0),(565099,15698,'ur','Ù…Ù†Ø³Ù„Ú©Û',0),(565100,15698,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð³',0),(565101,15698,'vi','Táº­p tin Ä‘Ã­nh kÃ¨m',0),(565102,15698,'af','Aanhegsel',0),(565103,15698,'ro','AtaÅŸament',0),(565104,15698,'et','Manus',0),(565105,15698,'si','Priloga',0),(565106,15698,'ba','Lampiran',0),(565107,15698,'nl','Bijlage',0),(565108,15698,'fi','Liite',0),(565109,15698,'no','Vedlegg',0),(565110,15698,'da','VedhÃ¦ftet fil',0),(565111,15698,'ko','ì²¨ë¶€ íŒŒì¼',0),(565112,15698,'he','×§×•×‘×¥ ×ž×¦×•×¨×£',0),(565113,15698,'el','Î£Ï…Î½Î·Î¼Î¼Î­Î½Î¿',0),(565114,15698,'zh','é™„ä»¶',0),(565115,15698,'sv','Bifogad fil',0),(565116,15698,'it','Allegato',0),(565117,15698,'tl','',0),(565118,15698,'th','à¸ªà¸´à¹ˆà¸‡à¸—à¸µà¹ˆà¹à¸™à¸šà¸¡à¸²',0),(565119,15698,'hi','à¤…à¤¨à¥à¤²à¤—à¥à¤¨à¤•',0),(565120,15698,'ms','Lampiran',0),(565121,15698,'ar','Ù…Ø±ÙÙ‚',0),(565122,15698,'fr','PiÃ¨ce jointe',0),(565123,15698,'jp','æ·»ä»˜ãƒ•ã‚¡ã‚¤ãƒ«',0),(565124,15698,'pt','Anexo',0),(565125,15698,'ru','Ð’Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(565126,15698,'es','Archivo adjunto',0),(565127,15698,'de','Anlage',0),(565128,15698,'en','Attachment',0),(565129,15699,'is','',0),(565130,15699,'dr','ÙˆØ¶Ø¹ÛŒØª ØªØ§ÛŒÛŒØ¯ÛŒÙ‡',0),(565131,15699,'pr','ÙˆØ¶Ø¹ÛŒØª ØªØ§ÛŒÛŒØ¯ÛŒÙ‡',0),(565132,15699,'tr','Onay durumu',0),(565133,15699,'pl','Stan zatwierdzenia',0),(565134,15699,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸Ðµ',0),(565135,15699,'ur','Ù…Ù†Ø¸ÙˆØ±ÛŒ Ú©ÛŒ Ø­ÛŒØ«ÛŒØª',0),(565136,15699,'sr','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¾Ð´Ð¾Ð±Ñ€ÐµÑšÐ°',0),(565137,15699,'vi','Tráº¡ng thÃ¡i phÃª duyá»‡t',0),(565138,15699,'af','Goedkeuring Status',0),(565139,15699,'ro','Starea de aprobare',0),(565140,15699,'et','Kinnituse olek',0),(565141,15699,'si','Stanje odobritve',0),(565142,15699,'ba','Status persetujuan',0),(565143,15699,'nl','Goedkeuringsstatus',0),(565144,15699,'fi','HyvÃ¤ksynnÃ¤n tila',0),(565145,15699,'no','Godkjenningsstatusen',0),(565146,15699,'da','Godkendelsesstatus',0),(565147,15699,'ko','ìŠ¹ì¸ ìƒíƒœ',0),(565148,15699,'he','×ž×¦×‘ ××™×©×•×¨',0),(565149,15699,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î­Î³ÎºÏÎ¹ÏƒÎ·Ï‚',0),(565150,15699,'zh','å®¡æ‰¹çŠ¶æ€',0),(565151,15699,'sv','GodkÃ¤nnandestatus',0),(565152,15699,'it','Stato di approvazione',0),(565153,15699,'tl','',0),(565154,15699,'th','à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(565155,15699,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(565156,15699,'ms','Status kelulusan',0),(565157,15699,'ar','Ø­Ø§Ù„Ø© Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø©',0),(565158,15699,'fr','Statut d\'approbation',0),(565159,15699,'jp','æ‰¿èªã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(565160,15699,'pt','Status de aprovaÃ§Ã£o',0),(565161,15699,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ñ',0),(565162,15699,'es','Estado de aprobaciÃ³n',0),(565163,15699,'de','Genehmigungsstatus',0),(565164,15699,'en','Approval Status',0),(565165,15700,'is','',0),(565166,15700,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ØªØ§ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡',0),(565167,15700,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ØªØ§ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡',0),(565168,15700,'tr','OnaylanmamÄ±ÅŸ satÄ±cÄ± faturalarÄ±',0),(565169,15700,'pl','Rachunki dostawcÃ³w niezatwierdzonych',0),(565170,15700,'bg','ÐÐµÐ¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(565171,15700,'ur','Ø§Ù†ØªØ¸Ø§Ù…ÛŒÛ ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„',0),(565172,15700,'sr','ÐÐµÐ¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(565173,15700,'vi','HÃ³a Ä‘Æ¡n Ä‘áº¡i lÃ½ khÃ´ng Ä‘Æ°á»£c cháº¥p thuáº­n',0),(565174,15700,'af','Goedgekeurde handelaar rekeninge',0),(565175,15700,'ro','Neomologat poate implica furnizor facturi',0),(565176,15700,'et','Kinnitamata hankija arveid',0),(565177,15700,'si','Neodobrenih prodajalca raÄune',0),(565178,15700,'ba','Vendor tidak disetujui tagihan',0),(565179,15700,'nl','Niet-goedgekeurde leverancier facturen',0),(565180,15700,'fi','HyvÃ¤ksymistÃ¤ odottavat toimittajan laskut',0),(565181,15700,'no','Godkjent leverandÃ¸r regninger',0),(565182,15700,'da','Ikke-godkendt kreditor regninger',0),(565183,15700,'ko','ìŠ¹ì¸ ë˜ì§€ ì•Šì€ ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ',0),(565184,15700,'he','×—×©×‘×•× ×•×ª ×¡×¤×§×™× ×©×œ× ××•×©×¨×•',0),(565185,15700,'el','ÎœÎ· ÎµÎ³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î”Î—ÎœÎŸÎ£Î™ÎŸÎ¥',0),(565186,15700,'zh','æœªç»æ‰¹å‡†ä¾›åº”å•†è´¦å•',0),(565187,15700,'sv','Icke godkÃ¤nd leverantÃ¶rs rÃ¤kningar',0),(565188,15700,'it','Fatture fornitore non approvato',0),(565189,15700,'tl','',0),(565190,15700,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸—à¸µà¹ˆà¸¢à¸±à¸‡à¹„à¸¡à¹ˆà¸­à¸™à¸¸à¸¡à¸±à¸•à¸´',0),(565191,15700,'hi','à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤¨ à¤•à¤¿à¤ à¤—à¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤²',0),(565192,15700,'ms','Bil-bil Vendor yang tidak',0),(565193,15700,'ar','ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙˆØ±Ø¯ ØºÙŠØ± Ù…Ø¹ØªÙ…Ø¯Ø©',0),(565194,15700,'fr','Factures du vendeur non homologuÃ©s',0),(565195,15700,'jp','æœªæ‰¿èªã®ä»•å…¥å…ˆè«‹æ±‚æ›¸',0),(565196,15700,'pt','Contas de fornecedor nÃ£o aprovado',0),(565197,15700,'ru','ÐÐµÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² ÑÑ‡ÐµÑ‚Ð°',0),(565198,15700,'es','Facturas de proveedores no aprobados',0),(565199,15700,'de','Nicht genehmigte Lieferanten-Rechnungen',0),(565200,15700,'en','Unapproved Vendor Bills',0),(565201,15701,'is','',0),(565202,15701,'dr','Ù†Ù…Ø§ÛŒØ´ ÛŒÚ© Ù¾ÛŒØ§Ù… Ù‡Ø´Ø¯Ø§Ø± Ù‡Ù†Ú¯Ø§Ù… Ù¾Ø±Ø¯Ø§Ø®Øª ØªØµÙˆÛŒØ¨ Ù„Ø§ÛŒØ­Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ ÛŒØ§ Ø§ÛŒØ¬Ø§Ø¯ Ø¨ÛŒÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÛŒØ¯ Ø§Ú¯Ø± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÛŒÙ† Ú¯ÙˆØ§Ù‡ÛŒ Ø±Ø§ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯.',0),(565203,15701,'pr','Ù†Ù…Ø§ÛŒØ´ ÛŒÚ© Ù¾ÛŒØ§Ù… Ù‡Ø´Ø¯Ø§Ø± Ù‡Ù†Ú¯Ø§Ù… Ù¾Ø±Ø¯Ø§Ø®Øª ØªØµÙˆÛŒØ¨ Ù„Ø§ÛŒØ­Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ ÛŒØ§ Ø§ÛŒØ¬Ø§Ø¯ Ø¨ÛŒÙ„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¬Ø¯ÛŒØ¯ Ø§Ú¯Ø± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÛŒÙ† Ú¯ÙˆØ§Ù‡ÛŒ Ø±Ø§ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´Ø¯.',0),(565204,15701,'tr','SatÄ±cÄ± fatura onaylama veya satÄ±cÄ±nÄ±n bu sertifika varsa yeni bir SatÄ±cÄ± fatura oluÅŸturma, Ã¶deme yaparken bir uyarÄ± iletisi gÃ¶rÃ¼ntÃ¼ler.',0),(565205,15701,'pl','WyÅ›wietliÄ‡ komunikat ostrzegawczy przy dokonywaniu pÅ‚atnoÅ›ci, zatwierdzania rachunku dostawcy, lub tworzenie nowej ustawy dostawcy, jeÅ›li sprzedawca nie ma tego certyfikatu.',0),(565206,15701,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð° Ð¿Ñ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ´Ð¸Ñ‚ÐµÐ»Ð½Ð¾ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¸ Ð¸Ð·Ð²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½ÐµÑ‚Ð¾, Ð¾Ð´Ð¾Ð±Ñ€ÑÐ²Ð°Ð½Ðµ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°Ñ‚Ð° Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°, Ð¸Ð»Ð¸ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð·Ð°ÐºÐ¾Ð½',0),(565207,15701,'ur','Ø§ÛŒÚ© ØªÙ†Ø¨ÛŒÛÛŒ Ù¾ÛŒØºØ§Ù… ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ù…Ù†Ø¸ÙˆØ± Ú©Ø±Ù†Û’, ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û ÛŒÛ ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û Ù†ÛÛŒÚº ÛÛ’ ØªÙˆ Ø§ÛŒÚ© Ù†ÛŒØ§ ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ø¨Ù†Ø§Ù†Û’ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒØŒ Ù‚Ø¶Ø§Ø¡ Ù…ÙŠÚº Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº Û”',0),(565208,15701,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾Ñ€ÑƒÐºÑƒ ÑƒÐ¿Ð¾Ð·Ð¾Ñ€ÐµÑšÐ° ÐºÐ°Ð´Ð° Ð²Ñ€ÑˆÐ¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°, Ð¾Ð´Ð¾Ð±Ñ€Ð°Ð²Ð°ÑšÐµ Ð‘Ð¸Ð» Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸Ð»Ð¸ ÐºÑ€ÐµÐ¸Ñ€Ð°ÑšÑƒ Ð½Ð°Ñ†Ñ€Ñ‚ Ð½Ð¾Ð²Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð°ÐºÐ¾ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð½ÐµÐ¼Ð° Ð¾Ð²Ð°Ñ˜ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸Ðº',0),(565209,15701,'vi','Hiá»ƒn thá»‹ má»™t thÃ´ng bÃ¡o cáº£nh bÃ¡o khi thá»±c hiá»‡n thanh toÃ¡n, phÃª duyá»‡t nhÃ  cung cáº¥p hÃ³a Ä‘Æ¡n, hoáº·c táº¡o ra má»™t hÃ³a Ä‘Æ¡n ngÆ°á»i bÃ¡n hÃ ng má»›i, náº¿u nhÃ  cung cáº¥p khÃ´ng cÃ³ chá»©ng chá»‰ nÃ y.',0),(565210,15701,'af','Wys \'n waarskuwingboodskap wanneer betaling, goedkeuring handelaar Wetsontwerp, of skep \'n nuwe handelaar Wetsontwerp indien die verkoper hierdie sertifikaat het nie.',0),(565211,15701,'ro','AfiÅŸa un mesaj de avertizare atunci cÃ¢nd se face plata, furnizor de lege de aprobare, sau creÃ¢nd un nou proiect de lege de furnizor Ã®n cazul Ã®n care vÃ¢nzÄƒtorul nu au acest certificat.',0),(565212,15701,'et','Kuva hoiatusteade, makse, hankija arve kinnitamisel vÃµi luua uue hankija arve, kui hankija ei saa selle serdi.',0),(565213,15701,'si','Prikaz opozorilnega sporoÄila, pri plaÄevanju, odobritev dobavitelja raÄun, ali ustvarjanje novega dobavitelja zakona, Äe prodajalec nima tega certifikata.',0),(565214,15701,'ba','Menampilkan pesan peringatan ketika melakukan pembayaran, menyetujui RUU Penjual, atau membuat tagihan Penjual baru jika vendor tidak memiliki sertifikat ini.',0),(565215,15701,'nl','Een waarschuwing weergeven bij het maken van de betaling, factuur van de leverancier goed te keuren, of creÃ«ren van een nieuwe factuur van de leverancier als de leverancier beschikt niet over dit certificaat.',0),(565216,15701,'fi','NÃ¤ytÃ¤ varoitussanoma, kun maksaja, hyvÃ¤ksynnÃ¤n toimittajan tai luomalla uusi toimittaja bill, jos myyjÃ¤ ei ole tÃ¤mÃ¤n todistuksen.',0),(565217,15701,'no','Vis en advarsel nÃ¥r betaling, godkjenning leverandÃ¸r eller opprette en ny leverandÃ¸r regning hvis leverandÃ¸ren ikke har dette sertifikatet.',0),(565218,15701,'da','Vise en advarsel, nÃ¥r du foretager betaling, godkender kreditor bill, eller oprette en ny kreditor bill, hvis leverandÃ¸ren ikke har dette certifikat.',0),(565219,15701,'ko','ê²°ì œ, ìŠ¹ì¸ ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ, ë˜ëŠ” ê³µê¸‰ ì—…ì²´ëŠ”ì´ ì¸ì¦ì„œ ì—†ëŠ” ê²½ìš° ìƒˆë¡œìš´ ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œë¥¼ ë§Œë“¤ ë•Œ ê²½ê³  ë©”ì‹œì§€ë¥¼ í‘œì‹œ í•©ë‹ˆë‹¤.',0),(565220,15701,'he','×œ×”×¦×™×’ ×”×•×“×¢×ª ××–×”×¨×” ×‘×¢×ª ×‘×™×¦×•×¢ ×”×ª×©×œ×•×, ××™×©×•×¨ ×—×©×‘×•×Ÿ ×”×¡×¤×§, ××• ×™×¦×™×¨×ª ×—×©×‘×•×Ÿ ×¡×¤×§ ×—×“×© ×× ×”×¡×¤×§ ××™×Ÿ ××™×©×•×¨ ×–×”.',0),(565221,15701,'el','Î•Î¼Ï†Î±Î½Î¯ÏƒÎµÎ¹ Î­Î½Î± Î¼Î®Î½Ï…Î¼Î± Ï€ÏÎ¿ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚ ÎºÎ±Ï„Î¬ Ï„Î·Î½ Ï€ÏÎ±Î³Î¼Î±Ï„Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½, Î­Î³ÎºÏÎ¹ÏƒÎ· Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚, Î® Ï„Î· Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÎµÎ½ÏŒÏ‚ Î½Î­Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï',0),(565222,15701,'zh','ç¼´è´¹ï¼Œæ‰¹å‡†ä¾›åº”å•†æ¡ä¾‹è‰æ¡ˆï¼Œæˆ–åˆ›å»ºä¸€ä¸ªæ–°çš„ä¾›åº”å•†æ³•æ¡ˆï¼Œå¦‚æžœä¾›åº”å•†ä¸å…·æœ‰æ­¤è¯ä¹¦æ—¶æ˜¾ç¤ºä¸€æ¡è­¦å‘Šæ¶ˆæ¯ã€‚',0),(565223,15701,'sv','Visa ett varningsmeddelande nÃ¤r betalningen, godkÃ¤nna leverantÃ¶r bill eller skapa en ny leverantÃ¶r lagfÃ¶rslag om leverantÃ¶ren inte har detta certifikat.',0),(565224,15701,'it','Visualizzare un messaggio di avviso quando si effettua il pagamento, l\'approvazione effetto fornitore o la creazione di una nuova fattura fornitore se il fornitore non dispone di questo certificato.',0),(565225,15701,'tl','',0),(565226,15701,'th','à¹à¸ªà¸”à¸‡à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¹€à¸•à¸·à¸­à¸™à¹€à¸¡à¸·à¹ˆà¸­à¸—à¸³à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¹€à¸‡à¸´à¸™à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢ à¸«à¸£à¸·à¸­à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸«à¸¡à¹ˆà¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸‚à',0),(565227,15701,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤•à¤¾ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¨ à¤•à¤°à¤¨à¥‡, à¤¯à¤¾ à¤¯à¤¦à¤¿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤‡à¤¸ à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤° à¤•à¥‡ à¤ªà¤¾à¤¸ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ à¤à¤• à¤¨à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾',0),(565228,15701,'ms','Paparkan mesej amaran apabila membuat pembayaran, meluluskan rang undang-undang penjual, atau mewujudkan suatu bil baru penjual jika Penjual tidak mempunyai Sijil ini.',0),(565229,15701,'ar','Ø¹Ø±Ø¶ Ø±Ø³Ø§Ù„Ø© ØªØ­Ø°ÙŠØ± Ø¹Ù†Ø¯ Ø¥Ø¬Ø±Ø§Ø¡ Ø§Ù„Ø¯ÙØ¹ØŒ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…ÙˆØ±Ø¯ØŒ Ø£Ùˆ Ø¥Ù†Ø´Ø§Ø¡ Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ø¬Ø¯ÙŠØ¯ Ù„Ø¨Ø§Ø¦Ø¹ Ø¥Ø°Ø§ Ù„Ù… ÙŠÙ‚Ù… Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ù‡Ø°Ù‡ Ø§Ù„Ø´Ù‡Ø§Ø¯Ø©.',0),(565230,15701,'fr','Afficher un message d\'avertissement lorsque paiement, approuvant le projet de loi du vendeur ou en crÃ©ant un nouveau projet de loi du vendeur si le vendeur ne possÃ¨de pas ce certificat.',0),(565231,15701,'jp','æŒ¯è¾¼ã€ä»•å…¥å…ˆè«‹æ±‚æ›¸ã‚’æ‰¿èªã™ã‚‹ã‹ã€ãƒ™ãƒ³ãƒ€ãƒ¼ã«ã“ã®è¨¼æ˜Žæ›¸ãŒã‚ã‚‹ãªã„å ´åˆã€æ–°ã—ã„ä»•å…¥å…ˆè«‹æ±‚æ›¸ã‚’ä½œæˆã™ã‚‹ã¨ãã¯ã€è­¦å‘Šãƒ¡ãƒƒã‚»ãƒ¼ã‚¸ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(565232,15701,'pt','Exibir uma mensagem de aviso quando efectuar o pagamento, aprovaÃ§Ã£o de conta de fornecedor, ou criar uma nova conta de fornecedor se o fornecedor nÃ£o tem este certificado.',0),(565233,15701,'ru','ÐžÑ‚Ð¾Ð±Ñ€Ð°Ð¶Ð°Ñ‚ÑŒ Ð¿Ñ€ÐµÐ´ÑƒÐ¿Ñ€ÐµÐ¶Ð´Ð°ÑŽÑ‰ÐµÐµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¸ ÑÐ¾Ð²ÐµÑ€ÑˆÐµÐ½Ð¸Ð¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°, ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚, Ð¸Ð»Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° Ð¿Ð¾',0),(565234,15701,'es','Mostrar un mensaje de advertencia al hacer el pago, aprobar la factura de proveedor, o crear una nueva factura de proveedor si el proveedor no tiene este certificado.',0),(565235,15701,'de','Angezeigt wird eine Warnmeldung angezeigt, wenn die Zahlung, Kreditor Rechnung zu genehmigen oder erstellen eine neue Anbieter Rechnung, wenn der VerkÃ¤ufer nicht Ã¼ber dieses Zertifikat verfÃ¼gt.',0),(565236,15701,'en','Display a warning message when making payment, approving vendor bill, or creating a new vendor bill if the vendor does not have this certificate.',0),(565237,15702,'is','',0),(565238,15702,'dr','Ø§Ù†ÙˆØ§Ø¹ Ú©Ø³Ø± Ú©Ø§Ø±Ù…Ù†Ø¯',0),(565239,15702,'pr','Ø§Ù†ÙˆØ§Ø¹ Ú©Ø³Ø± Ú©Ø§Ø±Ù…Ù†Ø¯',0),(565240,15702,'tr','Ã‡alÄ±ÅŸan indirimi tipleri',0),(565241,15702,'pl','Rodzaje odliczenie pracownika',0),(565242,15702,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð²Ð¸Ð´Ð¾Ð²Ðµ',0),(565243,15702,'ur','Ù…Ù„Ø§Ø²Ù… ÛÙˆÙ†Û’Ùˆ Ø§Ù‚Ø³Ø§Ù…',0),(565244,15702,'sr','Ð¢Ð¸Ð¿Ð¾Ð²Ð¸ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(565245,15702,'vi','NhÃ¢n viÃªn kháº¥u trá»« loáº¡i',0),(565246,15702,'af','Werknemer aftrekking tipes',0),(565247,15702,'ro','Tipuri de deducerea angajatului',0),(565248,15702,'et','TÃ¶Ã¶taja mahaarvamise tÃ¼Ã¼bid',0),(565249,15702,'si','Zaposleni odbitek vrste',0),(565250,15702,'ba','Jenis pengurangan karyawan',0),(565251,15702,'nl','Werknemer aftrek typen',0),(565252,15702,'fi','TyÃ¶ntekijÃ¤n vÃ¤hennyksen tyypit',0),(565253,15702,'no','Fradrag ansattyper',0),(565254,15702,'da','Medarbejder fradrag typer',0),(565255,15702,'ko','ì§ì› ê³µì œ ìœ í˜•',0),(565256,15702,'he','×¡×•×’×™ × ×™×›×•×™×™ ×¢×•×‘×“×™×',0),(565257,15702,'el','Î¤ÏÏ€Î¿Î¹ Î­ÎºÏ€Ï„Ï‰ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(565258,15702,'zh','å‘˜å·¥æ‰£ç¼´ç±»åž‹',0),(565259,15702,'sv','Medarbetartyper avdrag',0),(565260,15702,'it','Tipi di detrazione dipendente',0),(565261,15702,'tl','',0),(565262,15702,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸à¸²à¸£à¸«à¸±à¸à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(565263,15702,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¤Ÿà¥Œà¤¤à¥€ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(565264,15702,'ms','Jenis-jenis potongan pekerja',0),(565265,15702,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø®ØµÙ… Ù…Ù† Ø§Ù„Ù…ÙˆØ¸Ù',0),(565266,15702,'fr','EmployÃ© dÃ©duction Types',0),(565267,15702,'jp','å¾“æ¥­å“¡ã®æŽ§é™¤ã®ç¨®é¡ž',0),(565268,15702,'pt','Tipos de deduÃ§Ã£o de empregado',0),(565269,15702,'ru','Ð¢Ð¸Ð¿Ñ‹ ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(565270,15702,'es','Tipos de deducciÃ³n de empleado',0),(565271,15702,'de','Mitarbeiter-Abzug-Typen',0),(565272,15702,'en','Employee Deduction Types',0),(565273,15703,'is','',0),(565274,15703,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ú¯ÙˆØ§Ù‡ÛŒ Ø§Ù†Ø·Ø¨Ø§Ù‚',0),(565275,15703,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ú¯ÙˆØ§Ù‡ÛŒ Ø§Ù†Ø·Ø¨Ø§Ù‚',0),(565276,15703,'tr','SatÄ±cÄ± sertifika uyum',0),(565277,15703,'pl','Dostawcy certyfikatu zgodnoÅ›ci',0),(565278,15703,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð·Ð° ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¸Ðµ',0),(565279,15703,'ur','ÙˆÛŒÙ†ÚˆØ± ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û ØªØ¹Ù…ÛŒÙ„',0),(565280,15703,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ ÑƒÑÐºÐ»Ð°Ñ’ÐµÐ½Ð¾ÑÑ‚Ð¸',0),(565281,15703,'vi','NhÃ  cung cáº¥p giáº¥y chá»©ng nháº­n phÃ¹ há»£p',0),(565282,15703,'af','Handelaar sertifikaat nakoming',0),(565283,15703,'ro','Furnizor certificat de conformitate',0),(565284,15703,'et','Hankija sertifikaadi vastavus',0),(565285,15703,'si','Dobavitelju potrdilo o skladnosti',0),(565286,15703,'ba','Penjual sertifikat kepatuhan',0),(565287,15703,'nl','Leverancier certificaat Compliance',0),(565288,15703,'fi','Toimittajan todistus noudattaminen',0),(565289,15703,'no','LeverandÃ¸ren sertifikat samsvar',0),(565290,15703,'da','Kreditor certifikat overholdelse',0),(565291,15703,'ko','ê³µê¸‰ ì—…ì²´ ì¸ì¦ì„œ ì¤€ìˆ˜',0),(565292,15703,'he','×¡×¤×§ ××™×©×•×¨ ×ª××™×ž×•×ª',0),(565293,15703,'el','Î Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŒ ÏƒÏ…Î¼Î¼ÏŒÏÏ†Ï‰ÏƒÎ·Ï‚ Ï„Î¿Ï… Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(565294,15703,'zh','ä¾›åº”å•†è¯ä¹¦æ³•è§„éµä»Žæ€§',0),(565295,15703,'sv','LeverantÃ¶r intyg Ã¶verensstÃ¤mmelse',0),(565296,15703,'it','Fornitore certificato conformitÃ ',0),(565297,15703,'tl','',0),(565298,15703,'th','à¸›à¸à¸´à¸šà¸±à¸•à¸´à¸•à¸²à¸¡à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(565299,15703,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤° à¤…à¤¨à¥à¤ªà¤¾à¤²à¤¨',0),(565300,15703,'ms','Penjual Sijil pematuhan',0),(565301,15703,'ar','Ø¨Ø§Ø¦Ø¹ Ø´Ù‡Ø§Ø¯Ø© Ø§Ù„Ø§Ù…ØªØ«Ø§Ù„',0),(565302,15703,'fr','Fournisseur de certificat conformitÃ©',0),(565303,15703,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¨¼æ˜Žæ›¸ã®æº–æ‹ ',0),(565304,15703,'pt','Fornecedor certificado de conformidade',0),(565305,15703,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð° ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¸Ñ',0),(565306,15703,'es','Proveedor certificado de conformidad',0),(565307,15703,'de','Zertifikat LieferantenkonformitÃ¤t',0),(565308,15703,'en','Vendor Certificate Compliance',0),(565309,15704,'is','',0),(565310,15704,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ù†ÙˆØ§Ø¹ Ú¯ÙˆØ§Ù‡ÛŒ',0),(565311,15704,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ù†ÙˆØ§Ø¹ Ú¯ÙˆØ§Ù‡ÛŒ',0),(565312,15704,'tr','SatÄ±cÄ± sertifika tÃ¼rleri',0),(565313,15704,'pl','Dostawcy certyfikatu typu',0),(565314,15704,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(565315,15704,'ur','ÙˆÛŒÙ†ÚˆØ± ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(565316,15704,'sr','Ð¢Ð¸Ð¿Ð¾Ð²Ðµ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(565317,15704,'vi','NhÃ  cung cáº¥p cÃ¡c loáº¡i giáº¥y chá»©ng nháº­n',0),(565318,15704,'af','Handelaar sertifikaat tipes',0),(565319,15704,'ro','Tipuri de certificat de furnizor',0),(565320,15704,'et','Hankija tunnistuse tÃ¼Ã¼bid',0),(565321,15704,'si','Vrste certifikatov dobaviteljem',0),(565322,15704,'ba','Penjual sertifikat jenis',0),(565323,15704,'nl','Certificaattypen leverancier',0),(565324,15704,'fi','Toimittajan todistustyypit',0),(565325,15704,'no','LeverandÃ¸ren sertifikattyper',0),(565326,15704,'da','Kreditor certifikattyper',0),(565327,15704,'ko','ê³µê¸‰ ì—…ì²´ ì¸ì¦ì„œ ì¢…ë¥˜',0),(565328,15704,'he','×¡×•×’×™ ××™×©×•×¨×™× ×©×œ ×¡×¤×§',0),(565329,15704,'el','Î¤ÏÏ€Î¿Î¹ Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŽÎ½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(565330,15704,'zh','ä¾›åº”å•†è¯ä¹¦ç±»åž‹',0),(565331,15704,'sv','Intyg leverantÃ¶rstyper',0),(565332,15704,'it','Tipi di certificati del fornitore',0),(565333,15704,'tl','',0),(565334,15704,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(565335,15704,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤° à¤ªà¥à¤°à¤•à¤¾à¤°',0),(565336,15704,'ms','Jenis Sijil Penjual',0),(565337,15704,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø´Ù‡Ø§Ø¯Ø§Øª Ø§Ù„Ù…ÙˆØ±Ø¯',0),(565338,15704,'fr','Types de certificats du vendeur',0),(565339,15704,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¨¼æ˜Žæ›¸ã®ç¨®é¡ž',0),(565340,15704,'pt','Tipos de certificado de fornecedor',0),(565341,15704,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ð²',0),(565342,15704,'es','Tipos de certificados de proveedores',0),(565343,15704,'de','Kreditor-Zertifikattypen',0),(565344,15704,'en','Vendor Certificate Types',0),(565345,15705,'is','',0),(565346,15705,'dr','Ú¯ÙˆØ§Ù‡ÛŒ Ø¨Ø±ÙˆÚ©Ø±',0),(565347,15705,'pr','Ú¯ÙˆØ§Ù‡ÛŒ Ø¨Ø±ÙˆÚ©Ø±',0),(565348,15705,'tr','Sertifika Broker',0),(565349,15705,'pl','Broker certyfikat',0),(565350,15705,'bg','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð±Ñ€Ð¾ÐºÐµÑ€',0),(565351,15705,'ur','ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û Ø¨Ø±ÙˆÚ©Ø±',0),(565352,15705,'sr','Ð¦ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð±Ñ€Ð¾ÐºÐµÑ€Ð°',0),(565353,15705,'vi','Chá»©ng chá»‰ mÃ´i giá»›i',0),(565354,15705,'af','Sertifikaat makelaar',0),(565355,15705,'ro','Certificat de Broker',0),(565356,15705,'et','Sertifikaadi maakler',0),(565357,15705,'si','Certifikata posrednik',0),(565358,15705,'ba','Sertifikat Broker',0),(565359,15705,'nl','Certificaat makelaar',0),(565360,15705,'fi','Todistus vÃ¤littÃ¤jÃ¤',0),(565361,15705,'no','Sertifikatet megler',0),(565362,15705,'da','Certifikat mÃ¦gler',0),(565363,15705,'ko','ì¸ì¦ì„œ ë¸Œë¡œì»¤',0),(565364,15705,'he','×ª×¢×•×“×ª ×ž×ª×•×•×š',0),(565365,15705,'el','Î Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŒ Î¼ÎµÏƒÎ¯Ï„Î·',0),(565366,15705,'zh','è¯ä¹¦çš„ç»çºªäºº',0),(565367,15705,'sv','Intyg mÃ¤klare',0),(565368,15705,'it','Certificato Broker',0),(565369,15705,'tl','',0),(565370,15705,'th','à¸™à¸²à¸¢à¸«à¸™à¹‰à¸²à¸£à¸±à¸šà¸£à¸­à¸‡',0),(565371,15705,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤° à¤¦à¤²à¤¾à¤²',0),(565372,15705,'ms','Sijil Broker',0),(565373,15705,'ar','Ø´Ù‡Ø§Ø¯Ø© ÙˆØ³ÙŠØ·',0),(565374,15705,'fr','Certificat de courtier',0),(565375,15705,'jp','è¨¼æ˜Žæ›¸ãƒ–ãƒ­ãƒ¼ã‚«ãƒ¼',0),(565376,15705,'pt','Corretor de certificado',0),(565377,15705,'ru','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð±Ñ€Ð¾ÐºÐµÑ€',0),(565378,15705,'es','Corredor certificado',0),(565379,15705,'de','Zertifikat-Broker',0),(565380,15705,'en','Certificate Broker',0),(565381,15706,'is','',0),(565382,15706,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù…Ø¬ÙˆØ²',0),(565383,15706,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù…Ø¬ÙˆØ²',0),(565384,15706,'tr','Sertifika ayrÄ±ntÄ±larÄ±',0),(565385,15706,'pl','SzczegÃ³Å‚y certyfikatu',0),(565386,15706,'bg','Ð”Ð°Ð½Ð½Ð¸ Ð·Ð° ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(565387,15706,'ur','ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(565388,15706,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(565389,15706,'vi','Chi tiáº¿t chá»©ng chá»‰',0),(565390,15706,'af','Sertifikaat besonderhede',0),(565391,15706,'ro','Detaliile certificatului',0),(565392,15706,'et','Sertifikaadi andmete',0),(565393,15706,'si','Podrobnosti potrdila',0),(565394,15706,'ba','Rincian sertifikat',0),(565395,15706,'nl','Certificaatgegevens',0),(565396,15706,'fi','Varmenteen tiedot',0),(565397,15706,'no','Sertifikatdetaljene',0),(565398,15706,'da','Certifikatdetaljer',0),(565399,15706,'ko','ì¸ì¦ì„œ ì„¸ë¶€ ì •ë³´',0),(565400,15706,'he','×¤×¨×˜×™ ×”××™×©×•×¨',0),(565401,15706,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï„Î¿Ï… Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÎ¿Ï',0),(565402,15706,'zh','è¯ä¹¦è¯¦ç»†ä¿¡æ¯',0),(565403,15706,'sv','Certifikatinformation',0),(565404,15706,'it','Dettagli del certificato',0),(565405,15706,'tl','',0),(565406,15706,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡',0),(565407,15706,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤° à¤µà¤¿à¤µà¤°à¤£',0),(565408,15706,'ms','Butiran Sijil',0),(565409,15706,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø´Ù‡Ø§Ø¯Ø©',0),(565410,15706,'fr','DÃ©tails du certificat',0),(565411,15706,'jp','è¨¼æ˜Žæ›¸ã®è©³ç´°',0),(565412,15706,'pt','Detalhes do certificado',0),(565413,15706,'ru','Ð¡Ð²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ðµ',0),(565414,15706,'es','Detalles del certificado',0),(565415,15706,'de','Zertifikatsdetails',0),(565416,15706,'en','Certificate Details',0),(565417,15707,'is','',0),(565418,15707,'dr','Ù…Ø¬ÙˆØ² ÙØ§ÛŒÙ„ Ù‡Ø§',0),(565419,15707,'pr','Ù…Ø¬ÙˆØ² ÙØ§ÛŒÙ„ Ù‡Ø§',0),(565420,15707,'tr','Sertifika dosyalarÄ±',0),(565421,15707,'pl','Pliki certyfikatÃ³w',0),(565422,15707,'bg','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð·Ð° Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(565423,15707,'ur','ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û Ù…Ø³Ù„',0),(565424,15707,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(565425,15707,'vi','Giáº¥y chá»©ng nháº­n táº­p tin',0),(565426,15707,'af','Sertifikaat lÃªers',0),(565427,15707,'ro','Certificat de fiÅŸiere',0),(565428,15707,'et','Serdifailid',0),(565429,15707,'si','Certifikatne datoteke',0),(565430,15707,'ba','Sertifikat file',0),(565431,15707,'nl','Certificaatbestanden',0),(565432,15707,'fi','Sertifikaattitiedoston tiedostotunniste',0),(565433,15707,'no','Sertifikatfiler',0),(565434,15707,'da','Certifikatfiler',0),(565435,15707,'ko','ì¸ì¦ì„œ íŒŒì¼',0),(565436,15707,'he','×§×‘×¦×™ ××™×©×•×¨×™×',0),(565437,15707,'el','Î‘ÏÏ‡ÎµÎ¯Î± Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÎ¿Ï',0),(565438,15707,'zh','è¯ä¹¦æ–‡ä»¶',0),(565439,15707,'sv','Certifikatfiler',0),(565440,15707,'it','File di certificato',0),(565441,15707,'tl','',0),(565442,15707,'th','à¹à¸Ÿà¹‰à¸¡à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡',0),(565443,15707,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤° à¤«à¤¼à¤¾à¤‡à¤²',0),(565444,15707,'ms','Fail sijil',0),(565445,15707,'ar','Ù…Ù„ÙØ§Øª Ø´Ù‡Ø§Ø¯Ø§Øª',0),(565446,15707,'fr','Fichiers de certificat',0),(565447,15707,'jp','è¨¼æ˜Žæ›¸ãƒ•ã‚¡ã‚¤ãƒ«',0),(565448,15707,'pt','Arquivos de certificado',0),(565449,15707,'ru','Ð¤Ð°Ð¹Ð»Ñ‹ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ð²',0),(565450,15707,'es','Archivos de certificado',0),(565451,15707,'de','Zertifikatsdateien',0),(565452,15707,'en','Certificate Files',0),(565453,15708,'is','',0),(565454,15708,'dr','Ú¯ÙˆØ§Ù‡ÛŒ Ø§Ø¹Ù„Ø§Ù† Ø§ÛŒÙ…ÛŒÙ„',0),(565455,15708,'pr','Ú¯ÙˆØ§Ù‡ÛŒ Ø§Ø¹Ù„Ø§Ù† Ø§ÛŒÙ…ÛŒÙ„',0),(565456,15708,'tr','Sertifika uyarÄ± e-posta',0),(565457,15708,'pl','Powiadomienie E-mail o certyfikat',0),(565458,15708,'bg','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð° Ð·Ð° Ð¾Ð±ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð¸Ð¼ÐµÐ¹Ð»',0),(565459,15708,'ur','ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û Ù†ÙˆÙ¹Ø³ Ø§ÛŒ Ù…ÛŒÙ„',0),(565460,15708,'sr','Ð¦ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð½Ð°Ñ˜Ð°Ð²Ðµ Ð•Ð¼Ð°Ð¸Ð»',0),(565461,15708,'vi','Email thÃ´ng bÃ¡o giáº¥y chá»©ng nháº­n',0),(565462,15708,'af','Sertifikaat kennisgewing e-pos',0),(565463,15708,'ro','Certificat de notificare E-mail',0),(565464,15708,'et','Sertifikaadi teate e-posti',0),(565465,15708,'si','Potrdilo obvestilo Email',0),(565466,15708,'ba','Sertifikat pemberitahuan Email',0),(565467,15708,'nl','E-mail bericht de certificaat',0),(565468,15708,'fi','Todistus ilmoitus sÃ¤hkÃ¶postitse',0),(565469,15708,'no','Sertifikatet merke e',0),(565470,15708,'da','Certifikat varsel E-mail',0),(565471,15708,'ko','ì¸ì¦ì„œ í†µì§€ ì´ë©”ì¼',0),(565472,15708,'he','×“×•× ×©×œ ×”×•×“×¢×ª ××™×©×•×¨',0),(565473,15708,'el','Î Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŒ: Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ® ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(565474,15708,'zh','è¯ä¹¦çš„ç”µå­é‚®ä»¶é€šçŸ¥',0),(565475,15708,'sv','Intyg anmÃ¤lan e-post',0),(565476,15708,'it','E-mail di avviso di certificato',0),(565477,15708,'tl','',0),(565478,15708,'th','à¸­à¸µà¹€à¸¡à¸¥à¸›à¸£à¸°à¸à¸²à¸¨à¸£à¸±à¸šà¸£à¸­à¸‡',0),(565479,15708,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤° à¤¸à¥‚à¤šà¤¨à¤¾ à¤ˆà¤®à¥‡à¤²',0),(565480,15708,'ms','Sijil notis e-mel',0),(565481,15708,'ar','Ø´Ù‡Ø§Ø¯Ø© Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(565482,15708,'fr','Certificat avis par courriel',0),(565483,15708,'jp','è¨¼æ˜Žæ›¸é€šçŸ¥ãƒ¡ãƒ¼ãƒ«',0),(565484,15708,'pt','E-mail de aviso de certificado',0),(565485,15708,'ru','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(565486,15708,'es','Correo electrÃ³nico de aviso de certificado',0),(565487,15708,'de','Zertifikat und Datenschutz E-Mail',0),(565488,15708,'en','Certificate Notice Email',0),(565489,15709,'is','',0),(565490,15709,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù†ÙˆØ¹ Ú¯ÙˆØ§Ù‡ÛŒ',0),(565491,15709,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª Ù†ÙˆØ¹ Ú¯ÙˆØ§Ù‡ÛŒ',0),(565492,15709,'tr','Sertifika tÃ¼rÃ¼ ayrÄ±ntÄ±larÄ±',0),(565493,15709,'pl','SzczegÃ³Å‚y typu certyfikatu',0),(565494,15709,'bg','Ð”Ð°Ð½Ð½Ð¸ Ð·Ð° Ñ‚Ð¸Ð¿Ð° Ð½Ð° ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(565495,15709,'ur','ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û Ù‚Ø³Ù… Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(565496,15709,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ñ‚Ð¸Ð¿Ð° Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(565497,15709,'vi','Chi tiáº¿t loáº¡i chá»©ng chá»‰',0),(565498,15709,'af','Sertifikaat tipe besonderhede',0),(565499,15709,'ro','Detaliile certificatului de tip',0),(565500,15709,'et','Serdi tÃ¼Ã¼p Ã¼ksikasjad',0),(565501,15709,'si','Certifikat tipa podrobnosti',0),(565502,15709,'ba','Rincian jenis sertifikat',0),(565503,15709,'nl','Type certificaatdetails',0),(565504,15709,'fi','Varmenteen tyypin tiedot',0),(565505,15709,'no','Type sertifikatdetaljene',0),(565506,15709,'da','Type certifikatdetaljer',0),(565507,15709,'ko','ì¸ì¦ì„œ ìœ í˜• ì •ë³´',0),(565508,15709,'he','×¤×¨×˜×™ ×¡×•×’ ×”××™×©×•×¨',0),(565509,15709,'el','Î›ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚ Ï„Î¿Ï… Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÎ¿Ï Ï„ÏÏ€Î¿Ï…',0),(565510,15709,'zh','è¯ä¹¦ç±»åž‹çš„è¯¦ç»†ä¿¡æ¯',0),(565511,15709,'sv','Certifikatinformation typ',0),(565512,15709,'it','Dettagli del tipo di certificato',0),(565513,15709,'tl','',0),(565514,15709,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡',0),(565515,15709,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤° à¤ªà¥à¤°à¤•à¤¾à¤° à¤µà¤¿à¤µà¤°à¤£',0),(565516,15709,'ms','Butiran jenis Sijil',0),(565517,15709,'ar','ØªÙØ§ØµÙŠÙ„ Ù†ÙˆØ¹ Ø§Ù„Ø´Ù‡Ø§Ø¯Ø©',0),(565518,15709,'fr','DÃ©tails du certificat Type',0),(565519,15709,'jp','è¨¼æ˜Žæ›¸ã®ç¨®é¡žã®è©³ç´°',0),(565520,15709,'pt','Detalhes do tipo de certificado',0),(565521,15709,'ru','Ð¡Ð²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾ Ñ‚Ð¸Ð¿Ðµ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(565522,15709,'es','Detalles del certificado tipo',0),(565523,15709,'de','Typ Zertifikatsdetails',0),(565524,15709,'en','Certificate Type Details',0),(565525,15710,'is','',0),(565526,15710,'dr','Ø§Ø¹Ù„Ø§Ù† Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„',0),(565527,15710,'pr','Ø§Ø¹Ù„Ø§Ù† Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„',0),(565528,15710,'tr','E-posta bildirimi',0),(565529,15710,'pl','Powiadomienia e-mail',0),(565530,15710,'bg','Ð˜Ð·Ð²ÐµÑÑ‚Ð¸Ðµ Ð¿Ð¾ Ð¸Ð¼ÐµÐ¹Ð»',0),(565531,15710,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Û’ Ù†ÙˆÙ¹Ø³',0),(565532,15710,'sr','Ð•-Ð¼Ð°Ð¸Ð» Ð½Ð°Ñ˜Ð°Ð²Ðµ',0),(565533,15710,'vi','Email thÃ´ng bÃ¡o',0),(565534,15710,'af','E-pos kennisgewing',0),(565535,15710,'ro','Notificare e-mail',0),(565536,15710,'et','E-posti teate',0),(565537,15710,'si','Email obvestilo',0),(565538,15710,'ba','Email pemberitahuan',0),(565539,15710,'nl','E-mailbericht',0),(565540,15710,'fi','SÃ¤hkÃ¶posti-ilmoitus',0),(565541,15710,'no','E-postmelding',0),(565542,15710,'da','E-mail meddelelse',0),(565543,15710,'ko','ì´ë©”ì¼ í†µì§€',0),(565544,15710,'he','×”×•×“×¢×ª ×“×•×',0),(565545,15710,'el','Î•Î¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(565546,15710,'zh','ç”µå­é‚®ä»¶é€šçŸ¥',0),(565547,15710,'sv','E-post meddelande',0),(565548,15710,'it','Avviso e-mail',0),(565549,15710,'tl','',0),(565550,15710,'th','à¸ªà¹ˆà¸§à¸™',0),(565551,15710,'hi','à¤ˆà¤®à¥‡à¤² à¤¸à¥‚à¤šà¤¨à¤¾',0),(565552,15710,'ms','Notis e-mel',0),(565553,15710,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(565554,15710,'fr','Avis par courriel',0),(565555,15710,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«é€šçŸ¥',0),(565556,15710,'pt','Aviso de e-mail',0),(565557,15710,'ru','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(565558,15710,'es','Aviso de correo electrÃ³nico',0),(565559,15710,'de','E-Mail-Benachrichtigung',0),(565560,15710,'en','Email Notice',0),(565561,15711,'is','',0),(565562,15711,'dr','Ú¯ÙˆØ§Ù‡ÛŒ Ù‡Ø§ÛŒ Ú¯Ù… Ø´Ø¯Ù‡',0),(565563,15711,'pr','Ú¯ÙˆØ§Ù‡ÛŒ Ù‡Ø§ÛŒ Ú¯Ù… Ø´Ø¯Ù‡',0),(565564,15711,'tr','Sertifika eksik',0),(565565,15711,'pl','Brak certyfikatu',0),(565566,15711,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(565567,15711,'ur','ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û ØºØ§Ø¦Ø¨',0),(565568,15711,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(565569,15711,'vi','Giáº¥y chá»©ng nháº­n bá»‹ máº¥t tÃ­ch',0),(565570,15711,'af','Sertifikaat ontbreek',0),(565571,15711,'ro','Certificatul de lipsÄƒ',0),(565572,15711,'et','Puudub sertifikaat',0),(565573,15711,'si','ManjkajoÄe spriÄevalo',0),(565574,15711,'ba','Sertifikat hilang',0),(565575,15711,'nl','Ontbrekende certificaat',0),(565576,15711,'fi','Puuttuu todistus',0),(565577,15711,'no','Manglende sertifikat',0),(565578,15711,'da','Mangler certifikat',0),(565579,15711,'ko','ëˆ„ë½ ëœ ì¸ì¦ì„œ',0),(565580,15711,'he','××™×©×•×¨×™× ×—×¡×¨×™×',0),(565581,15711,'el','Î Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŒ Î»ÎµÎ¯Ï€ÎµÎ¹',0),(565582,15711,'zh','å¤±è¸ªçš„è¯ä¹¦',0),(565583,15711,'sv','Saknade certifikat',0),(565584,15711,'it','Certificato mancante',0),(565585,15711,'tl','',0),(565586,15711,'th','à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡à¸«à¸²à¸¢à¹„à¸›',0),(565587,15711,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤° à¤—à¥à¤®',0),(565588,15711,'ms','Hilang Sijil',0),(565589,15711,'ar','Ø´Ù‡Ø§Ø¯Ø© Ù…ÙÙ‚ÙˆØ¯Ø©',0),(565590,15711,'fr','Certificat manquant',0),(565591,15711,'jp','è¨¼æ˜Žæ›¸ãŒè¦‹ã¤ã‹ã‚‰ãªã„',0),(565592,15711,'pt','Falta de certificado',0),(565593,15711,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(565594,15711,'es','Falta certificado',0),(565595,15711,'de','Fehlendes Zertifikat',0),(565596,15711,'en','Missing Certificate',0),(565597,15712,'is','',0),(565598,15712,'dr','Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯',0),(565599,15712,'pr','Ø¢Ù¾Ù„ÙˆØ¯ Ø´Ø¯',0),(565600,15712,'tr','YÃ¼kledi',0),(565601,15712,'pl','WgraÅ‚eÅ›',0),(565602,15712,'bg','ÐšÐ°Ñ‡Ð¸Ð»',0),(565603,15712,'ur','Ú¯ÛŒÙ… Ø§Ù¾ Ù„ÙˆÚˆ Ú©ÛŒØ§',0),(565604,15712,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð¸Ñ‚Ð¸',0),(565605,15712,'vi','Táº£i lÃªn',0),(565606,15712,'af','Opgelaai',0),(565607,15712,'ro','ÃŽncÄƒrcat',0),(565608,15712,'et','Ãœleslaaditud',0),(565609,15712,'si','NaloÅ¾il',0),(565610,15712,'ba','Upload',0),(565611,15712,'nl','GeÃ¼pload',0),(565612,15712,'fi','Ladattu',0),(565613,15712,'no','Lastet opp',0),(565614,15712,'da','Uploadet',0),(565615,15712,'ko','ì—…ë¡œë“œ',0),(565616,15712,'he','× ×˜×¢×Ÿ',0),(565617,15712,'el','Î‘Î½ÎµÎ²Î¬ÏƒÎµÎ¹',0),(565618,15712,'zh','ä¸Šä¼ ',0),(565619,15712,'sv','Laddat upp',0),(565620,15712,'it','Caricato',0),(565621,15712,'tl','',0),(565622,15712,'th','à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”',0),(565623,15712,'hi','à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(565624,15712,'ms','Upload',0),(565625,15712,'ar','ØªÙ… Ø§Ù„ØªØ­Ù…ÙŠÙ„',0),(565626,15712,'fr','TÃ©lÃ©chargÃ©es',0),(565627,15712,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰',0),(565628,15712,'pt','Carregado',0),(565629,15712,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ¶ÐµÐ½Ñ‹',0),(565630,15712,'es','Subido',0),(565631,15712,'de','Hochgeladen',0),(565632,15712,'en','Uploaded',0),(565633,15713,'is','',0),(565634,15713,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ú¯ÙˆØ§Ù‡ÛŒ',0),(565635,15713,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ú¯ÙˆØ§Ù‡ÛŒ',0),(565636,15713,'tr','SatÄ±cÄ± sertifika',0),(565637,15713,'pl','Certyfikat dostawcy',0),(565638,15713,'bg','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(565639,15713,'ur','ÙˆÛŒÙ†ÚˆØ± ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û',0),(565640,15713,'sr','Ð¦ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(565641,15713,'vi','Giáº¥y chá»©ng nháº­n nhÃ  cung cáº¥p',0),(565642,15713,'af','Handelaar sertifikaat',0),(565643,15713,'ro','Furnizor certificat',0),(565644,15713,'et','Hankija sertifikaat',0),(565645,15713,'si','Dobavitelju potrdilo',0),(565646,15713,'ba','Penjual sertifikat',0),(565647,15713,'nl','Leverancier certificaat',0),(565648,15713,'fi','Toimittajan todistus',0),(565649,15713,'no','LeverandÃ¸r-sertifikat',0),(565650,15713,'da','Kreditor certifikat',0),(565651,15713,'ko','ê³µê¸‰ ì—…ì²´ ì¸ì¦ì„œ',0),(565652,15713,'he','××™×©×•×¨ ×”×¡×¤×§',0),(565653,15713,'el','Î Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(565654,15713,'zh','ä¾›åº”å•†è¯ä¹¦',0),(565655,15713,'sv','LeverantÃ¶r intyg',0),(565656,15713,'it','Fornitore certificato',0),(565657,15713,'tl','',0),(565658,15713,'th','à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(565659,15713,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤°',0),(565660,15713,'ms','Sijil vendor',0),(565661,15713,'ar','Ø´Ù‡Ø§Ø¯Ø© Ø§Ù„Ù…ÙˆØ±Ø¯',0),(565662,15713,'fr','Certificat de vendeur',0),(565663,15713,'jp','è¨¼æ˜Žæ›¸ãƒ™ãƒ³ãƒ€ãƒ¼',0),(565664,15713,'pt','Certificado de fornecedor',0),(565665,15713,'ru','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(565666,15713,'es','Certificado de proveedor',0),(565667,15713,'de','Hersteller-Zertifikat',0),(565668,15713,'en','Vendor Certificate',0),(565669,15714,'is','',0),(565670,15714,'dr','Ù†ÙˆØ¹ Ú¯ÙˆØ§Ù‡ÛŒÙ†Ø§Ù…Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(565671,15714,'pr','Ù†ÙˆØ¹ Ú¯ÙˆØ§Ù‡ÛŒÙ†Ø§Ù…Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(565672,15714,'tr','SatÄ±cÄ± sertifika tÃ¼rÃ¼',0),(565673,15714,'pl','Dostawcy certyfikatu typu',0),(565674,15714,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚ Ð·Ð° Ñ‚Ð¸Ð¿',0),(565675,15714,'ur','ÙˆÛŒÙ†ÚˆØ± Ø³Ø±Ù¹ÛŒÙÚ©ÛŒÙ¹ Ù¹Ø§Ø¦Ù¾',0),(565676,15714,'sr','Ð¢Ð¸Ð¿ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(565677,15714,'vi','NhÃ  cung cáº¥p giáº¥y chá»©ng nháº­n loáº¡i',0),(565678,15714,'af','Handelaar sertifikaat tipe',0),(565679,15714,'ro','Tip de certificat de furnizor',0),(565680,15714,'et','Hankija serdi tÃ¼Ã¼p',0),(565681,15714,'si','Vrsto certifikata dobavitelja',0),(565682,15714,'ba','Penjual sertifikat jenis',0),(565683,15714,'nl','Leverancier certificaattype',0),(565684,15714,'fi','Toimittajan varmenteen tyyppi',0),(565685,15714,'no','LeverandÃ¸ren sertifikattype',0),(565686,15714,'da','Kreditor certifikattype',0),(565687,15714,'ko','ê³µê¸‰ ì—…ì²´ ì¸ì¦ì„œ ì¢…ë¥˜',0),(565688,15714,'he','×¡×•×’ ×”××™×©×•×¨ ×”×¡×¤×§',0),(565689,15714,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¿Ï… Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÎ¿Ï Ï„ÏÏ€Î¿Ï…',0),(565690,15714,'zh','ä¾›åº”å•†è¯ä¹¦ç±»åž‹',0),(565691,15714,'sv','LeverantÃ¶rstyp certifikat',0),(565692,15714,'it','Tipo di fornitore certificato',0),(565693,15714,'tl','',0),(565694,15714,'th','à¸Šà¸™à¸´à¸”à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡à¸—à¸µà¹ˆà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(565695,15714,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤° à¤ªà¥à¤°à¤•à¤¾à¤°',0),(565696,15714,'ms','Jenis Sijil Penjual',0),(565697,15714,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø´Ù‡Ø§Ø¯Ø© Ø§Ù„Ù…ÙˆØ±Ø¯',0),(565698,15714,'fr','Type de certificat fournisseur',0),(565699,15714,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¨¼æ˜Žæ›¸ã®ç¨®é¡ž',0),(565700,15714,'pt','Tipo de certificado de fornecedor',0),(565701,15714,'ru','Ð¢Ð¸Ð¿ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(565702,15714,'es','Tipo de certificado de proveedor',0),(565703,15714,'de','Herstellertyp Zertifikat',0),(565704,15714,'en','Vendor Certificate Type',0),(565705,15715,'is','',0),(565706,15715,'dr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯',0),(565707,15715,'pr','Ø§ÙØ²ÙˆØ¯Ù† Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯',0),(565708,15715,'tr','Yeni dosya ekleme',0),(565709,15715,'pl','Dodaj nowy plik',0),(565710,15715,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½Ð¾Ð² Ñ„Ð°Ð¹Ð»',0),(565711,15715,'ur','Ù†Ø¦ÛŒ Ù…Ø³Ù„ Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(565712,15715,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½Ð¾Ð²Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(565713,15715,'vi','ThÃªm táº­p tin má»›i',0),(565714,15715,'af','Voeg nuwe lÃªer',0),(565715,15715,'ro','AdaugÄƒ fiÅŸier nou',0),(565716,15715,'et','Uue faili lisamine',0),(565717,15715,'si','Dodati novo datoteko',0),(565718,15715,'ba','Tambahkan File baru',0),(565719,15715,'nl','Nieuw bestand toevoegen',0),(565720,15715,'fi','LisÃ¤Ã¤ uusi tiedosto',0),(565721,15715,'no','Legg til ny fil',0),(565722,15715,'da','TilfÃ¸j ny fil',0),(565723,15715,'ko','ìƒˆ íŒŒì¼ ì¶”ê°€',0),(565724,15715,'he','×”×•×¡×¤×ª ×§×•×‘×¥ ×—×“×©',0),(565725,15715,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Î½Î­Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(565726,15715,'zh','æ·»åŠ æ–°æ–‡ä»¶',0),(565727,15715,'sv','LÃ¤gg till ny fil',0),(565728,15715,'it','Aggiungi nuovo File',0),(565729,15715,'tl','',0),(565730,15715,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹à¸Ÿà¹‰à¸¡à¹ƒà¸«à¸¡à¹ˆ',0),(565731,15715,'hi','à¤¨à¤ˆ à¤«à¤¼à¤¾à¤‡à¤² à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(565732,15715,'ms','Tambah fail baru',0),(565733,15715,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ù Ø¬Ø¯ÙŠØ¯',0),(565734,15715,'fr','Ajouter le nouveau fichier',0),(565735,15715,'jp','æ–°ã—ã„ãƒ•ã‚¡ã‚¤ãƒ«ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(565736,15715,'pt','Adicionar novo arquivo',0),(565737,15715,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð½Ð¾Ð²Ñ‹Ð¹ Ñ„Ð°Ð¹Ð»',0),(565738,15715,'es','AÃ±adir nuevo archivo',0),(565739,15715,'de','Neue Datei hinzufÃ¼gen',0),(565740,15715,'en','Add New File',0),(565741,15716,'is','',0),(565742,15716,'dr','Ø¢Ù¾Ù„ÙˆØ¯',0),(565743,15716,'pr','Ø¢Ù¾Ù„ÙˆØ¯',0),(565744,15716,'tr','YÃ¼kleme',0),(565745,15716,'pl','PrzesyÅ‚anie',0),(565746,15716,'bg','ÐšÐ°Ñ‡Ð²Ð°Ð½Ðµ',0),(565747,15716,'ur','Ø§Ù¾ Ù„ÙˆÚˆ',0),(565748,15716,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð°ÑšÐµ',0),(565749,15716,'vi','Táº£i lÃªn',0),(565750,15716,'af','Laai tans',0),(565751,15716,'ro','ÃŽncÄƒrcarea',0),(565752,15716,'et','Uploading',0),(565753,15716,'si','Nalaganje',0),(565754,15716,'ba','Meng-upload',0),(565755,15716,'nl','Uploaden',0),(565756,15716,'fi','Lataaminen',0),(565757,15716,'no','Opplasting',0),(565758,15716,'da','Upload',0),(565759,15716,'ko','ì—…ë¡œë“œ',0),(565760,15716,'he','×”×¢×œ××ª',0),(565761,15716,'el','Î¦ÏŒÏÏ„Ï‰Î¼Î±',0),(565762,15716,'zh','ä¸Šä¼ ',0),(565763,15716,'sv','Ladda upp',0),(565764,15716,'it','Caricamento',0),(565765,15716,'tl','',0),(565766,15716,'th','à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”',0),(565767,15716,'hi','à¤…à¤ªà¤²à¥‹à¤¡',0),(565768,15716,'ms','Meng-upload',0),(565769,15716,'ar','ØªØ­Ù…ÙŠÙ„',0),(565770,15716,'fr','TÃ©lÃ©chargement',0),(565771,15716,'jp','ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰',0),(565772,15716,'pt','Fazer upload',0),(565773,15716,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·ÐºÐ°',0),(565774,15716,'es','Subir',0),(565775,15716,'de','Hochladen',0),(565776,15716,'en','Uploading',0),(565777,15717,'is','',0),(565778,15717,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‡Ø§ÛŒ ØªÙ„ÙÛŒÙ‚ÛŒ Ø³Ø¨Ú© Ù„ÛŒØ³Øª',0),(565779,15717,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù‡Ø§ÛŒ ØªÙ„ÙÛŒÙ‚ÛŒ Ø³Ø¨Ú© Ù„ÛŒØ³Øª',0),(565780,15717,'tr','Konsolide Ã§ekme liste stili',0),(565781,15717,'pl','Skonsolidowanych Pick listy styl',0),(565782,15717,'bg','ÐšÐ¾Ð½ÑÐ¾Ð»Ð¸Ð´Ð¸Ñ€Ð°Ð½Ð° Ð¸Ð·Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ ÑÑ‚Ð¸Ð» Ð½Ð° ÑÐ¿Ð¸ÑÑŠÐº',0),(565783,15717,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³Ø² Ø§Ù†ØªØ®Ø§Ø¨ Ø·Ø±Ø² ÙÛØ±Ø³Øª',0),(565784,15717,'sr','Ð¡Ñ‚Ð¸Ð» Ð»Ð¸ÑÑ‚Ðµ ÐºÐ¾Ð½ÑÐ¾Ð»Ð¸Ð´Ð¾Ð²Ð°Ð½Ð¾ Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐ°',0),(565785,15717,'vi','Cá»§ng cá»‘ nháº­n danh sÃ¡ch phong cÃ¡ch',0),(565786,15717,'af','Gekonsolideerde Pick lys styl',0),(565787,15717,'ro','Stilul de listÄƒ consolidatÄƒ Pick',0),(565788,15717,'et','Konsolideeritud noppimise loendilaadi',0),(565789,15717,'si','Slog seznama konsolidirani Pick',0),(565790,15717,'ba','Konsolidasi memilih daftar gaya',0),(565791,15717,'nl','Geconsolideerde Pick lijststijl',0),(565792,15717,'fi','Konsernin valita luettelotyyli',0),(565793,15717,'no','Konsolidert plukking listestil',0),(565794,15717,'da','Konsolideret pluk opstillingstypografi',0),(565795,15717,'ko','ì—°ê²°ëœ ì„ íƒ ëª©ë¡ ìŠ¤íƒ€ì¼',0),(565796,15717,'he','×¡×’× ×•×Ÿ ×¨×©×™×ž×” ×¤×™×§ ×ž××•×—×“',0),(565797,15717,'el','Î•Î½Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î· Pick ÏƒÏ„Ï…Î» Î»Î¯ÏƒÏ„Î±Ï‚',0),(565798,15717,'zh','ç»¼åˆçš„é€‰æ‹©åˆ—è¡¨æ ·å¼',0),(565799,15717,'sv','Konsoliderad plockning listformat',0),(565800,15717,'it','Stile elenco consolidato Pick',0),(565801,15717,'tl','',0),(565802,15717,'th','à¸¥à¸±à¸à¸©à¸“à¸°à¸‚à¸­à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸±à¸šà¸£à¸§à¸¡',0),(565803,15717,'hi','à¤¸à¤®à¥‡à¤•à¤¿à¤¤ à¤‰à¤ à¤¾à¤“ à¤¸à¥‚à¤šà¥€ à¤¶à¥ˆà¤²à¥€',0),(565804,15717,'ms','Disatukan memilih senarai gaya',0),(565805,15717,'ar','Ù†Ù…Ø· Ø§Ù„Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ù…ÙˆØ­Ø¯Ø© Ø¨ÙŠÙƒ',0),(565806,15717,'fr','Style de liste consolidÃ©e Pick',0),(565807,15717,'jp','é€£çµãƒ”ãƒƒã‚¯ã‚¢ãƒƒãƒ— ãƒªã‚¹ãƒˆ ã‚¹ã‚¿ã‚¤ãƒ«',0),(565808,15717,'pt','Estilo de lista consolidada Pick',0),(565809,15717,'ru','Ð¡Ð²Ð¾Ð´Ð½Ñ‹Ð¹ Ð²Ñ‹Ð±Ð¾Ñ€ ÑÑ‚Ð¸Ð»Ñ ÑÐ¿Ð¸ÑÐºÐ°',0),(565810,15717,'es','Estilo de lista consolidada selecciÃ³n',0),(565811,15717,'de','Konsolidierten Pick Listenformatvorlage',0),(565812,15717,'en','Consolidated Pick List Style',0),(565813,15718,'is','',0),(565814,15718,'dr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÛŒ Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§ Ù‡Ù…',0),(565815,15718,'pr','Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÛŒ Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§ Ù‡Ù…',0),(565816,15718,'tr','Ã–ÄŸeleri GruplandÄ±r birlikte',0),(565817,15718,'pl','Grupa przedmiotÃ³w razem',0),(565818,15718,'bg','Ð“Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ð¹ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð·Ð°ÐµÐ´Ð½Ð¾',0),(565819,15718,'ur','Ø§Ø´ÛŒØ§Ø¡ Ú¯Ø±ÙˆÙ¾ Ø§ÛŒÚ© Ø³Ø§ØªÚ¾',0),(565820,15718,'sr','Ð“Ñ€ÑƒÐ¿Ð° ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð°Ñ˜ÐµÐ´Ð½Ð¾',0),(565821,15718,'vi','NhÃ³m máº·t hÃ ng vá»›i nhau',0),(565822,15718,'af','Groep Items saam',0),(565823,15718,'ro','Grup de elemente Ã®mpreunÄƒ',0),(565824,15718,'et','Ãœksuste rÃ¼hmitamiseks koos',0),(565825,15718,'si','Skupina elementov skupaj',0),(565826,15718,'ba','Item kelompok bersama-sama',0),(565827,15718,'nl','De onderdelen van de groep samen',0),(565828,15718,'fi','Osien ryhmitteleminen yhteen',0),(565829,15718,'no','Gruppeelementer sammen',0),(565830,15718,'da','Gruppeelementer sammen',0),(565831,15718,'ko','í•¨ê»˜ ê·¸ë£¹ í•­ëª©',0),(565832,15718,'he','×§×‘×•×¦×ª ×”×¤×¨×™×˜×™× ×™×—×“',0),(565833,15718,'el','ÎŸÎ¼Î±Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ ÏƒÏ…Î¼Î¼ÎµÏ„Î­Ï‡Î¿Ï…Î½',0),(565834,15718,'zh','åœ¨ä¸€èµ·å¯¹é¡¹ç›®è¿›è¡Œåˆ†ç»„',0),(565835,15718,'sv','Gruppera objekt tillsammans',0),(565836,15718,'it','Raggruppare gli elementi insieme',0),(565837,15718,'tl','',0),(565838,15718,'th','à¸à¸¥à¸¸à¹ˆà¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸§à¸¡',0),(565839,15718,'hi','à¤à¤• à¤¸à¤¾à¤¥ à¤¸à¤®à¥‚à¤¹ à¤†à¤‡à¤Ÿà¤®à¥à¤¸',0),(565840,15718,'ms','Item-item Kumpulan yang bersama-sama',0),(565841,15718,'ar','ØªØ¬Ù…ÙŠØ¹ Ø§Ù„Ø¹Ù†Ø§ØµØ± Ù…Ø¹Ø§',0),(565842,15718,'fr','Ã‰lÃ©ments du groupe ensemble',0),(565843,15718,'jp','ã‚°ãƒ«ãƒ¼ãƒ—ã®é …ç›®ã‚’ä¸€ç·’ã«',0),(565844,15718,'pt','Agrupar itens juntos',0),(565845,15718,'ru','Ð“Ñ€ÑƒÐ¿Ð¿Ð° ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð²Ð¼ÐµÑÑ‚Ðµ',0),(565846,15718,'es','ArtÃ­culos de grupo juntos',0),(565847,15718,'de','Gruppieren von Elementen zusammen',0),(565848,15718,'en','Group Items Together',0),(565849,15719,'is','',0),(565850,15719,'dr','Ø®Ø· Ø¬Ø¯Ø§Ú¯Ø§Ù†Ù‡ Ø¨Ø±Ø§ÛŒ Ù‡Ø± Ù…ÙˆØ±Ø¯ Ø³ÙØ§Ø±Ø´',0),(565851,15719,'pr','Ø®Ø· Ø¬Ø¯Ø§Ú¯Ø§Ù†Ù‡ Ø¨Ø±Ø§ÛŒ Ù‡Ø± Ù…ÙˆØ±Ø¯ Ø³ÙØ§Ø±Ø´',0),(565852,15719,'tr','SatÄ±rÄ± her sipariÅŸ Ã¶ÄŸe iÃ§in ayrÄ±',0),(565853,15719,'pl','Oddzielnych linii dla kaÅ¼dego elementu zamÃ³wienia',0),(565854,15719,'bg','ÐžÑ‚Ð´ÐµÐ»ÐµÐ½ Ñ€ÐµÐ´ Ð·Ð° Ð²ÑÐµÐºÐ¸ Ñ€ÐµÐ´ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»',0),(565855,15719,'ur','Ù„Ø§Ø¦Ù† Ù†Û’ ÛØ± Ø­Ú©Ù… Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¹Ù„ÛŒØ­Ø¯Û Ú©Ø± Ø¯ÛŒÚº Û”',0),(565856,15719,'sr','Ð Ð°Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ Ð»Ð¸Ð½Ð¸Ñ˜Ð° Ð·Ð° ÑÐ²Ð°ÐºÐ¸ Ñ€ÐµÐ´ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°',0),(565857,15719,'vi','RiÃªng dÃ²ng cho má»—i máº·t hÃ ng',0),(565858,15719,'af','Skei lyn vir elke bestelling Item',0),(565859,15719,'ro','Separa linie pentru fiecare element de comandÄƒ',0),(565860,15719,'et','Eraldi rida iga toode',0),(565861,15719,'si','LoÄite vrstico za vsak artikel vrstni red',0),(565862,15719,'ba','Baris yang terpisah untuk setiap Item urutan',0),(565863,15719,'nl','Aparte regels voor elke Order Item',0),(565864,15719,'fi','Erillinen rivi kunkin tilauksen nimikkeen',0),(565865,15719,'no','Separat linje For hvert ordreelement',0),(565866,15719,'da','Separat linje For hver ordrevare',0),(565867,15719,'ko','ê° ì£¼ë¬¸ í•­ëª©ì— ëŒ€ í•œ ë¼ì¸ì„ ë³„ë„',0),(565868,15719,'he','×œ×”×¤×¨×™×“ ×©×•×¨×” ×¢×‘×•×¨ ×›×œ ×¤×¨×™×˜ ×¡×“×¨',0),(565869,15719,'el','ÎžÎµÏ‡Ï‰ÏÎ¹ÏƒÏ„Î® Î³ÏÎ±Î¼Î¼Î® Î³Î¹Î± ÎºÎ¬Î¸Îµ ÎµÎ¯Î´Î¿Ï‚ Ï„Î·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(565870,15719,'zh','ä¸ºæ¯ä¸ªè®¢å•é¡¹åˆ†éš”çº¿',0),(565871,15719,'sv','Separat rad fÃ¶r varje Order',0),(565872,15719,'it','Linea separata per ciascun elemento di ordine',0),(565873,15719,'tl','',0),(565874,15719,'th','à¹à¸¢à¸à¸šà¸£à¸£à¸—à¸±à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¹à¸•à¹ˆà¸¥à¸°à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(565875,15719,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¥‡à¤• à¤‘à¤°à¥à¤¡à¤° à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤…à¤²à¤—',0),(565876,15719,'ms','Baris yang berasingan bagi setiap perkara dalam perintah',0),(565877,15719,'ar','ÙØµÙ„ Ø³Ø·Ø± Ù„ÙƒÙ„ ØµÙ†Ù Ø£Ù…Ø±',0),(565878,15719,'fr','SÃ©parer la ligne pour chaque point de l\'ordre',0),(565879,15719,'jp','æ³¨æ–‡é …ç›®ã”ã¨ã«è¡Œã‚’åˆ†ã‘ã‚‹',0),(565880,15719,'pt','Separar a linha para cada Item da ordem',0),(565881,15719,'ru','ÐžÑ‚Ð´ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÑ‚Ñ€Ð¾ÐºÐ¸ Ð´Ð»Ñ ÐºÐ°Ð¶Ð´Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð·Ð°ÐºÐ°Ð·Ð°',0),(565882,15719,'es','Separar la lÃ­nea para cada artÃ­culo del pedido',0),(565883,15719,'de','Separate Zeile fÃ¼r jede Auftragsposition',0),(565884,15719,'en','Separate Line For Each Order Item',0),(565885,15720,'is','',0),(565886,15720,'dr','Ø¯ÙˆØ± Ø®ÙˆØ¯Ø¯Ø§Ø±ÛŒ ÙØ¯Ø±Ø§Ù„ Ø¨Ù‡ Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† Ø¹Ø¯Ø¯ Ú©Ø§Ù…Ù„',0),(565887,15720,'pr','Ø¯ÙˆØ± Ø®ÙˆØ¯Ø¯Ø§Ø±ÛŒ ÙØ¯Ø±Ø§Ù„ Ø¨Ù‡ Ù†Ø²Ø¯ÛŒÚ©ØªØ±ÛŒÙ† Ø¹Ø¯Ø¯ Ú©Ø§Ù…Ù„',0),(565888,15720,'tr','Yuvarlak Federal yakÄ±n tam sayÄ±ya stopaj',0),(565889,15720,'pl','Rundy federalne wstrzymanie do najbliÅ¼szej liczby caÅ‚kowitej',0),(565890,15720,'bg','ÐšÑ€ÑŠÐ³Ð»Ð° Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¸Ð·Ñ‚Ð¾Ñ‡Ð½Ð¸ÐºÐ° Ð´Ð¾ Ð½Ð°Ð¹-Ð±Ð»Ð¸Ð·ÐºÐ¾Ñ‚Ð¾ Ñ†ÑÐ»Ð¾ Ñ‡Ð¸ÑÐ»Ð¾',0),(565891,15720,'ur','Ú†Ø§Ø±ÙˆÚº Ø·Ø±Ù ÙˆÙØ§Ù‚ÛŒ Ù‚Ø±ÛŒØ¨ÛŒ Ù¾ÙˆØ±Ø§ Ù†Ù…Ø¨Ø± Ú©Ùˆ Ø±ÙˆÚ©Ù†Ø§',0),(565892,15720,'sr','ÐžÐºÑ€ÑƒÐ³Ð»Ð° Ñ„ÐµÐ´ÐµÑ€Ð°Ð»Ð½Ð¸ Ð¿Ñ€Ð¸ÐºÑ€Ð¸Ð²Ð°ÑšÐ° Ð½Ð° Ð½Ð°Ñ˜Ð±Ð»Ð¸Ð¶Ð¸ Ñ†ÐµÐ¾ Ð±Ñ€Ð¾Ñ˜',0),(565893,15720,'vi','Giá»¯ láº¡i liÃªn bang trÃ²n Ä‘áº¿n sá»‘ nguyÃªn gáº§n nháº¥t',0),(565894,15720,'af','Ronde federale weerhouding tot naaste heelgetal',0),(565895,15720,'ro','Retinerea federale rotund la cel mai apropiat numÄƒr Ã®ntreg',0),(565896,15720,'et','Vooru fÃ¶deraalse kinnipeetava lÃ¤hima tÃ¤isarvuni',0),(565897,15720,'si','Krog zvezni odtegljaj najbliÅ¾je celo Å¡tevilo',0),(565898,15720,'ba','Pemotongan Federal putaran ke terdekat bilangan',0),(565899,15720,'nl','Ronde federale inhouding op het dichtstbijzijnde gehele getal',0),(565900,15720,'fi','PyÃ¶reÃ¤ liittovaltion ennakonpidÃ¤tykseksi lÃ¤himpÃ¤Ã¤n kokonaislukuun',0),(565901,15720,'no','Runde fÃ¸derale kildeskatt til nÃ¦rmeste hele tall',0),(565902,15720,'da','Runde fÃ¸derale tilbageholdelse til nÃ¦rmeste hele tal',0),(565903,15720,'ko','ê°€ìž¥ ê°€ê¹Œìš´ ì •ìˆ˜ë¡œ ë¼ìš´ë“œ ì—°ë°© ì›ì²œ ì§•ìˆ˜',0),(565904,15720,'he','×¢×’×•×œ × ×™×›×•×™ ×ž×¡ ×¤×“×¨×œ×™ ×œ×ž×¡×¤×¨ ×”×©×œ× ×”×§×¨×•×‘',0),(565905,15720,'el','Î£Ï„ÏÎ¿Î³Î³Ï…Î»Î® ÎŸÎ¼Î¿ÏƒÏ€Î¿Î½Î´Î¹Î±ÎºÎ® Ï€Î±ÏÎ±ÎºÏÎ¬Ï„Î·ÏƒÎ· Ï€Î»Î·ÏƒÎ¹Î­ÏƒÏ„ÎµÏÎ¿ Î±ÎºÎ­ÏÎ±Î¹Î¿ Î±ÏÎ¹Î¸Î¼ÏŒ',0),(565906,15720,'zh','åœ†å½¢è”é‚¦é¢„æ‰£åˆ°æœ€æŽ¥è¿‘çš„æ•´æ•°',0),(565907,15720,'sv','Runda Federal kÃ¤llskatt till nÃ¤rmaste heltal',0),(565908,15720,'it','Rotonda ritenuta d\'acconto federale numero intero piÃ¹ vicino',0),(565909,15720,'tl','',0),(565910,15720,'th','à¸à¸¥à¸¡à¸à¸¥à¸²à¸‡à¸«à¸±à¸à¸“à¸—à¸µà¹ˆà¸ˆà¹ˆà¸²à¸¢à¸ˆà¸³à¸™à¸§à¸™à¹€à¸•à¹‡à¸¡à¸—à¸µà¹ˆà¹ƒà¸à¸¥à¹‰à¸—à¸µà¹ˆà¸ªà¸¸à¸”',0),(565911,15720,'hi','à¤¦à¥Œà¤° à¤¸à¤‚à¤˜à¥€à¤¯ à¤¨à¤¿à¤•à¤Ÿà¤¤à¤® à¤ªà¥‚à¤°à¥à¤£à¤¾à¤‚à¤• à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¥‹à¤•',0),(565912,15720,'ms','Penangguhan Persekutuan bulat kepada nombor bulat terdekat',0),(565913,15720,'ar','Ø­Ø¬Ø¨ Ø§Ù„Ø§ØªØ­Ø§Ø¯ÙŠØ© Ø¬ÙˆÙ„Ø© Ø¥Ù„Ù‰ Ø£Ù‚Ø±Ø¨ Ø¹Ø¯Ø¯ ØµØ­ÙŠØ­',0),(565914,15720,'fr','Tour fÃ©dÃ©ral retenue au plus proche nombre entier',0),(565915,15720,'jp','æœ€ã‚‚è¿‘ã„æ•´æ•°ã«ãƒ©ã‚¦ãƒ³ãƒ‰é€£é‚¦æºæ³‰å¾´åŽ',0),(565916,15720,'pt','RetenÃ§Ã£o Federal redondo para o nÃºmero inteiro mais prÃ³ximo',0),(565917,15720,'ru','ÐšÑ€ÑƒÐ³Ð»Ð°Ñ Ñ„ÐµÐ´ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð³Ð¾ ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ Ð´Ð¾ Ð±Ð»Ð¸Ð¶Ð°Ð¹ÑˆÐµÐ³Ð¾ Ñ†ÐµÐ»Ð¾Ð³Ð¾ Ñ‡Ð¸ÑÐ»Ð°',0),(565918,15720,'es','RetenciÃ³n Federal ronda al nÃºmero entero mÃ¡s cercano',0),(565919,15720,'de','Runde RÃ¼ckhaltung auf die nÃ¤chste ganze Zahl',0),(565920,15720,'en','Round Federal Withholding To Nearest Whole Number',0),(565921,15721,'is','',0),(565922,15721,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÛŒÙ† Ú¯ÙˆØ§Ù‡ÛŒ Ù…Ø¹ØªØ¨Ø± Ø§Ø³Øª',0),(565923,15721,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§ÛŒÙ† Ú¯ÙˆØ§Ù‡ÛŒ Ù…Ø¹ØªØ¨Ø± Ø§Ø³Øª',0),(565924,15721,'tr','Bu satÄ±cÄ±nÄ±n geÃ§erli bir sertifikasÄ± yok',0),(565925,15721,'pl','Ten sprzedawca ma waÅ¼ny certyfikat',0),(565926,15721,'bg','Ð¢Ð¾Ð·Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð½Ðµ Ñ€Ð°Ð·Ð¿Ð¾Ð»Ð°Ð³Ð° Ñ Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(565927,15721,'ur','Ø§Ø³ ÙˆÛŒÙ†ÚˆØ± Ø§ÛŒÚ© Ø¬Ø§Ø¦Ø² ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û Ú©ÛŒ Ø­Ø§Ù…Ù„ Ù†ÛÛŒÚº',0),(565928,15721,'sr','ÐžÐ²Ð°Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð½Ðµ ÑÐ°Ð´Ñ€Ð¶Ð¸ Ð²Ð°Ð¶ÐµÑ›Ð¸ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(565929,15721,'vi','NgÆ°á»i bÃ¡n hÃ ng nÃ y khÃ´ng cÃ³ chá»©ng chá»‰ há»£p lá»‡',0),(565930,15721,'af','Hierdie handelaar het nie \'n geldige sertifikaat',0),(565931,15721,'ro','Acest furnizor nu are un certificat Valid',0),(565932,15721,'et','Sellele hankijale ei ole kehtiv',0),(565933,15721,'si','Ta dobavitelj nima veljavnega potrdila',0),(565934,15721,'ba','Vendor ini tidak memiliki sertifikat berlaku',0),(565935,15721,'nl','Deze leverancier beschikt niet over een geldig certificaat',0),(565936,15721,'fi','TÃ¤mÃ¤ toimittaja ei ole kelvollinen varmenne',0),(565937,15721,'no','Denne leverandÃ¸ren har ikke et gyldig sertifikat',0),(565938,15721,'da','Denne leverandÃ¸r har ikke et gyldigt certifikat',0),(565939,15721,'ko','ì´ ê³µê¸‰ ì—…ì²´ì— ìœ íš¨í•œ ì¸ì¦ì„œê°€ ì—†ìŠµë‹ˆë‹¤',0),(565940,15721,'he','×¡×¤×§ ×–×” ××™×Ÿ ××™×©×•×¨ ×—×•×§×™',0),(565941,15721,'el','Î‘Ï…Ï„ÏŒÏ‚ Î¿ Ï€Ï‰Î»Î·Ï„Î®Ï‚ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î­Î½Î± Î­Î³ÎºÏ…ÏÎ¿ Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŒ',0),(565942,15721,'zh','æ­¤ä¾›åº”å•†å¹¶æ²¡æœ‰ä¸€ä¸ªæœ‰æ•ˆçš„è¯ä¹¦',0),(565943,15721,'sv','LeverantÃ¶ren har inte ett giltigt certifikat',0),(565944,15721,'it','Questo fornitore non dispone di un certificato valido',0),(565945,15721,'tl','',0),(565946,15721,'th','à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸¡à¸µà¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡à¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(565947,15721,'hi','à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤à¤• à¤®à¤¾à¤¨à¥à¤¯ à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤° à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(565948,15721,'ms','Penjual ini tidak mempunyai sijil yang sah',0),(565949,15721,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆØ±Ø¯ Ù„ÙŠØ³ Ù„Ø¯ÙŠÙ‡ Ø´Ù‡Ø§Ø¯Ø© ØµØ§Ù„Ø­Ø©',0),(565950,15721,'fr','Ce fournisseur n\'a pas un certificat valide',0),(565951,15721,'jp','ã“ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã«æœ‰åŠ¹ãªè¨¼æ˜Žæ›¸ãŒãªã„ã§ã™ã€‚',0),(565952,15721,'pt','Este fornecedor nÃ£o tem um certificado vÃ¡lido',0),(565953,15721,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº Ð½Ðµ Ð¸Ð¼ÐµÐµÑ‚ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(565954,15721,'es','Este proveedor no tiene un certificado vÃ¡lido',0),(565955,15721,'de','Dieser Anbieter verfÃ¼gt nicht Ã¼ber ein gÃ¼ltiges Zertifikat',0),(565956,15721,'en','This Vendor Does Not Have A Valid Certificate',0),(565957,15722,'is','',0),(565958,15722,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú¯ÙˆØ§Ù‡ÛŒ',0),(565959,15722,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú¯ÙˆØ§Ù‡ÛŒ',0),(565960,15722,'tr','Sertifika Ekle',0),(565961,15722,'pl','Dodawanie certyfikatu',0),(565962,15722,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚',0),(565963,15722,'ur','ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(565964,15722,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(565965,15722,'vi','ThÃªm chá»©ng chá»‰',0),(565966,15722,'af','Voeg sertifikaat',0),(565967,15722,'ro','Adauga certificat',0),(565968,15722,'et','Serdi lisamine',0),(565969,15722,'si','Dodajanje potrdila',0),(565970,15722,'ba','Tambahkan sertifikat',0),(565971,15722,'nl','Certificaat toevoegen',0),(565972,15722,'fi','LisÃ¤Ã¤ sertifikaatti',0),(565973,15722,'no','Legge til',0),(565974,15722,'da','TilfÃ¸je certifikat',0),(565975,15722,'ko','ì¸ì¦ì„œ ì¶”ê°€',0),(565976,15722,'he','×œ×”×•×¡×™×£ ××™×©×•×¨',0),(565977,15722,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î¿ Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŒ',0),(565978,15722,'zh','æ·»åŠ è¯ä¹¦',0),(565979,15722,'sv','LÃ¤gga till certifikat',0),(565980,15722,'it','Aggiungere il certificato',0),(565981,15722,'tl','',0),(565982,15722,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡',0),(565983,15722,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(565984,15722,'ms','Tambah Sijil',0),(565985,15722,'ar','Ø¥Ø¶Ø§ÙØ© Ø´Ù‡Ø§Ø¯Ø©',0),(565986,15722,'fr','Ajouter le certificat',0),(565987,15722,'jp','è¨¼æ˜Žæ›¸ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(565988,15722,'pt','Adicionar certificado',0),(565989,15722,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(565990,15722,'es','Agregar certificado',0),(565991,15722,'de','Zertifikat hinzufÃ¼gen',0),(565992,15722,'en','Add Certificate',0),(565993,15723,'is','',0),(565994,15723,'dr','Ú©Ø§Ø±Ú¯Ø²Ø§Ø±',0),(565995,15723,'pr','Ú©Ø§Ø±Ú¯Ø²Ø§Ø±',0),(565996,15723,'tr','Broker',0),(565997,15723,'pl','Broker',0),(565998,15723,'bg','Ð‘Ñ€Ð¾ÐºÐµÑ€',0),(565999,15723,'ur','Ø¯Ù„Ø§Ù„',0),(566000,15723,'sr','Ð‘Ñ€Ð¾ÐºÐµÑ€',0),(566001,15723,'vi','MÃ´i giá»›i',0),(566002,15723,'af','Makelaar',0),(566003,15723,'ro','Broker',0),(566004,15723,'et','Maakler',0),(566005,15723,'si','Posrednik',0),(566006,15723,'ba','Broker',0),(566007,15723,'nl','Makelaar',0),(566008,15723,'fi','VÃ¤littÃ¤jÃ¤',0),(566009,15723,'no','Megler',0),(566010,15723,'da','MÃ¦gler',0),(566011,15723,'ko','ë¸Œë¡œì»¤',0),(566012,15723,'he','×‘×¨×•×§×¨',0),(566013,15723,'el','ÎœÎµÏƒÎ¯Ï„Î·Ï‚',0),(566014,15723,'zh','ç»çºªäºº',0),(566015,15723,'sv','MÃ¤klare',0),(566016,15723,'it','Broker',0),(566017,15723,'tl','',0),(566018,15723,'th','à¸™à¸²à¸¢à¸«à¸™à¹‰à¸²',0),(566019,15723,'hi','à¤¦à¤²à¤¾à¤²',0),(566020,15723,'ms','Broker',0),(566021,15723,'ar','ÙˆØ³ÙŠØ·',0),(566022,15723,'fr','Courtier',0),(566023,15723,'jp','ãƒ–ãƒ­ãƒ¼ã‚«ãƒ¼',0),(566024,15723,'pt','Corretor',0),(566025,15723,'ru','Ð‘Ñ€Ð¾ÐºÐµÑ€',0),(566026,15723,'es','Corredor de',0),(566027,15723,'de','Makler',0),(566028,15723,'en','Broker',0),(566029,15724,'is','',0),(566030,15724,'dr','Ú¯ÙˆØ§Ù‡ÛŒÙ†Ø§Ù…Ù‡ Ù‡Ø§',0),(566031,15724,'pr','Ú¯ÙˆØ§Ù‡ÛŒÙ†Ø§Ù…Ù‡ Ù‡Ø§',0),(566032,15724,'tr','Sertifikalar',0),(566033,15724,'pl','Certyfikaty',0),(566034,15724,'bg','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¸',0),(566035,15724,'ur','ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û’',0),(566036,15724,'sr','Ð¦ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¸',0),(566037,15724,'vi','Giáº¥y chá»©ng nháº­n',0),(566038,15724,'af','Sertifikate',0),(566039,15724,'ro','Certificate',0),(566040,15724,'et','Sertifikaadid',0),(566041,15724,'si','Potrdila',0),(566042,15724,'ba','Sertifikat',0),(566043,15724,'nl','Certificaten',0),(566044,15724,'fi','Sertifikaatit',0),(566045,15724,'no','Sertifikater',0),(566046,15724,'da','Certifikater',0),(566047,15724,'ko','ì¸ì¦ì„œ',0),(566048,15724,'he','××™×©×•×¨×™×',0),(566049,15724,'el','Î Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÎ¬',0),(566050,15724,'zh','è¯ä¹¦',0),(566051,15724,'sv','Certifikat',0),(566052,15724,'it','Certificati',0),(566053,15724,'tl','',0),(566054,15724,'th','à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡',0),(566055,15724,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤°',0),(566056,15724,'ms','Sijil-sijil',0),(566057,15724,'ar','Ø´Ù‡Ø§Ø¯Ø§Øª',0),(566058,15724,'fr','Certificats',0),(566059,15724,'jp','è¨¼æ˜Žæ›¸',0),(566060,15724,'pt','Certificados',0),(566061,15724,'ru','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ñ‹',0),(566062,15724,'es','Certificados',0),(566063,15724,'de','Zertifikate',0),(566064,15724,'en','Certificates',0),(566065,15725,'is','',0),(566066,15725,'dr','Ú¯ÙˆØ§Ù‡ÛŒÙ†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(566067,15725,'pr','Ú¯ÙˆØ§Ù‡ÛŒÙ†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(566068,15725,'tr','SatÄ±cÄ± sertifikalarÄ±',0),(566069,15725,'pl','Dostawcy certyfikatÃ³w',0),(566070,15725,'bg','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¸ Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(566071,15725,'ur','ÙˆÛŒÙ†ÚˆØ± ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û’',0),(566072,15725,'sr','Ð¦ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¸ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(566073,15725,'vi','Giáº¥y chá»©ng nháº­n nhÃ  cung cáº¥p',0),(566074,15725,'af','Handelaar sertifikate',0),(566075,15725,'ro','Furnizor de certificate',0),(566076,15725,'et','Hankija sertifikaadid',0),(566077,15725,'si','Prodajalec potrdil',0),(566078,15725,'ba','Penjual sertifikat',0),(566079,15725,'nl','Leverancier certificaten',0),(566080,15725,'fi','Toimittajan todistukset',0),(566081,15725,'no','LeverandÃ¸ren sertifikater',0),(566082,15725,'da','Kreditor certifikater',0),(566083,15725,'ko','ê³µê¸‰ ì—…ì²´ ì¸ì¦ì„œ',0),(566084,15725,'he','××™×©×•×¨×™× ×©×œ ×¡×¤×§',0),(566085,15725,'el','Î Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÎ¬ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(566086,15725,'zh','ä¾›åº”å•†è¯ä¹¦',0),(566087,15725,'sv','LeverantÃ¶rs certifikat',0),(566088,15725,'it','Certificati del fornitore',0),(566089,15725,'tl','',0),(566090,15725,'th','à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(566091,15725,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤°',0),(566092,15725,'ms','Sijil vendor',0),(566093,15725,'ar','Ø¨Ø§Ø¦Ø¹ Ø§Ù„Ø´Ù‡Ø§Ø¯Ø§Øª',0),(566094,15725,'fr','Fournisseur de certificats',0),(566095,15725,'jp','è¨¼æ˜Žæ›¸ãƒ™ãƒ³ãƒ€ãƒ¼',0),(566096,15725,'pt','Fornecedores certificados',0),(566097,15725,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ð²',0),(566098,15725,'es','Proveedores certificados',0),(566099,15725,'de','Hersteller-Zertifikate',0),(566100,15725,'en','Vendor Certificates',0),(566101,15726,'is','',0),(566102,15726,'dr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø´Ø§Ù…Ù„',0),(566103,15726,'pr','Ø³ÙØ§Ø±Ø´Ø§Øª Ø´Ø§Ù…Ù„',0),(566104,15726,'tr','SipariÅŸleri dahil',0),(566105,15726,'pl','ZamÃ³wienia zawarte',0),(566106,15726,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ¸, Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸',0),(566107,15726,'ur','Ø§Ø­Ú©Ø§Ù…Ø§Øª Ø´Ø§Ù…Ù„ ØªÚ¾Û’',0),(566108,15726,'sr','ÐÐ°Ñ€ÐµÐ´Ð±Ðµ ÑÑƒ ÑƒÐºÑ™ÑƒÑ‡ÐµÐ½Ðµ',0),(566109,15726,'vi','Bao gá»“m cÃ¡c Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(566110,15726,'af','Bestellings ingesluit',0),(566111,15726,'ro','Comenzi incluse',0),(566112,15726,'et','Tellimuste hulka',0),(566113,15726,'si','Naloge, ki so vkljuÄeni',0),(566114,15726,'ba','Order yang termasuk',0),(566115,15726,'nl','Opgenomen bestellingen',0),(566116,15726,'fi','Tilauksia',0),(566117,15726,'no','Bestillinger inkludert',0),(566118,15726,'da','Ordrer inkluderet',0),(566119,15726,'ko','í¬í•¨ í•˜ëŠ” ì£¼ë¬¸',0),(566120,15726,'he','×”×”×•×¨××•×ª ×”×›×œ×•×œ×•×ª',0),(566121,15726,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚ Ï€Î¿Ï… Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹',0),(566122,15726,'zh','è®¢å•åŒ…æ‹¬',0),(566123,15726,'sv','BestÃ¤llningar ingÃ¥r',0),(566124,15726,'it','Ordini inclusi',0),(566125,15726,'tl','',0),(566126,15726,'th','à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸£à¸§à¸¡',0),(566127,15726,'hi','à¤†à¤¦à¥‡à¤¶ à¤¶à¤¾à¤®à¤¿à¤²',0),(566128,15726,'ms','Pesanan yang disertakan',0),(566129,15726,'ar','ÙˆØ´Ù…Ù„Øª Ø£ÙˆØ§Ù…Ø±',0),(566130,15726,'fr','Commandes incluses',0),(566131,15726,'jp','å«ã¾ã‚Œã¦ã„ã‚‹æ³¨æ–‡',0),(566132,15726,'pt','Ordens incluÃ­das',0),(566133,15726,'ru','Ð—Ð°ÐºÐ°Ð·Ñ‹ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ñ‹',0),(566134,15726,'es','Pedidos incluidos',0),(566135,15726,'de','Bestellungen enthalten',0),(566136,15726,'en','Orders Included',0),(566137,15727,'is','',0),(566138,15727,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ØµÙØ­Ø§Øª Ø§Ø¶Ø§ÙÛŒ Ú†Ú© Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø®Ø§Ù„ÛŒ',0),(566139,15727,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ØµÙØ­Ø§Øª Ø§Ø¶Ø§ÙÛŒ Ú†Ú© Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø®Ø§Ù„ÛŒ',0),(566140,15727,'tr','GeÃ§ersiz olduÄŸu ek onay sayfalarÄ± ekle',0),(566141,15727,'pl','Dodaj dodatkowe sprawdzanie strony jako niewaÅ¼ne',0),(566142,15727,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÐºÐ°Ñ‚Ð¾ Void',0),(566143,15727,'ur','Ø®Ù„Ø§ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ø¶Ø§ÙÛŒ Ú†ÛŒÚ© Ø§Ù† ØµÙØ­Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(566144,15727,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ ÐºÐ°Ð¾ \"Ð²Ð¾Ð¸Ð´\"',0),(566145,15727,'vi','ThÃªm cÃ¡c trang bá»• sung kiá»ƒm tra lÃ  Void',0),(566146,15727,'af','Voeg bykomende kontroleer bladsye As leemte',0),(566147,15727,'ro','Adauga pagini de verificare suplimentare ca Void',0),(566148,15727,'et','Lisage tÃ¤iendav vÃ¤ljaregistreerimine lehed tÃ¼hine',0),(566149,15727,'si','Dodaj dodatni pregled strani za praznino',0),(566150,15727,'ba','Menambahkan halaman tambahan Check sebagai Void',0),(566151,15727,'nl','Aanvullende controle pagina\'s toevoegen als leegte',0),(566152,15727,'fi','LisÃ¤Ã¤ uusi tarkistus sivuja Void',0),(566153,15727,'no','Legge til flere sider som Void',0),(566154,15727,'da','TilfÃ¸j ekstra Check sider som tomrum',0),(566155,15727,'ko','Voidë¡œ ì¶”ê°€ í™•ì¸ íŽ˜ì´ì§€ë¥¼ ì¶”ê°€',0),(566156,15727,'he','×œ×”×•×¡×™×£ ×“×¤×™× × ×•×¡×¤×™× ×”×¡×™×ž×•×Ÿ ×›- Void',0),(566157,15727,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ ÏƒÎµÎ»Î¯Î´ÎµÏ‚ Ï‰Ï‚ Void',0),(566158,15727,'zh','æ·»åŠ é™„åŠ æ£€æŸ¥é¡µä¸ºç©ºç™½',0),(566159,15727,'sv','LÃ¤gg till ytterligare kontrollera sidor som Void',0),(566160,15727,'it','Aggiungere ulteriore controllo pagine come Void',0),(566161,15727,'tl','',0),(566162,15727,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸«à¸™à¹‰à¸²à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¹€à¸Šà¹‡à¸„à¹€à¸›à¹‡à¸™à¹‚à¸¡à¸†à¸°',0),(566163,15727,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤šà¥‡à¤• à¤ªà¤¨à¥à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ Void à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(566164,15727,'ms','Menambah halaman daftar tambahan sebagai tidak sah',0),(566165,15727,'ar','Ø¥Ø¶Ø§ÙØ© ØµÙØ­Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ÙƒØ§Ù„ÙØ±Ø§Øº',0),(566166,15727,'fr','Ajouter des Pages de contrÃ´le supplÃ©mentaire comme vide',0),(566167,15727,'jp','Void ã¨ã—ã¦è¿½åŠ ã®ãƒã‚§ãƒƒã‚¯ ãƒšãƒ¼ã‚¸ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(566168,15727,'pt','Adicionar pÃ¡ginas de verificaÃ§Ã£o adicional como Void',0),(566169,15727,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ† ÐºÐ°Ðº Void',0),(566170,15727,'es','Agregar pÃ¡ginas de retenciÃ³n adicionales como vacÃ­o',0),(566171,15727,'de','ZusatzprÃ¼fung Seiten als Void hinzufÃ¼gen',0),(566172,15727,'en','Add Additional Check Pages As Void',0),(566173,15728,'is','',0),(566174,15728,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ØµÙØ­Ø§Øª Ø§Ø¶Ø§ÙÛŒ Ú†Ú© Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø®Ø§Ù„ÛŒ',0),(566175,15728,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† ØµÙØ­Ø§Øª Ø§Ø¶Ø§ÙÛŒ Ú†Ú© Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø®Ø§Ù„ÛŒ',0),(566176,15728,'tr','GeÃ§ersiz olduÄŸu ek onay sayfalarÄ± ekle',0),(566177,15728,'pl','Dodaj dodatkowe sprawdzanie strony jako niewaÅ¼ne',0),(566178,15728,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÐºÐ°Ñ‚Ð¾ Void',0),(566179,15728,'ur','Ø®Ù„Ø§ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ø§Ø¶Ø§ÙÛŒ Ú†ÛŒÚ© Ø§Ù† ØµÙØ­Ø§Øª Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(566180,15728,'sr','Ð”Ð¾Ð´Ð°Ñ˜Ñ‚Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ ÐºÐ°Ð¾ \"Ð²Ð¾Ð¸Ð´\"',0),(566181,15728,'vi','ThÃªm cÃ¡c trang bá»• sung kiá»ƒm tra lÃ  Void',0),(566182,15728,'af','Voeg bykomende kontroleer bladsye As leemte',0),(566183,15728,'ro','Adauga pagini de verificare suplimentare ca Void',0),(566184,15728,'et','Lisage tÃ¤iendav vÃ¤ljaregistreerimine lehed tÃ¼hine',0),(566185,15728,'si','Dodaj dodatni pregled strani za praznino',0),(566186,15728,'ba','Menambahkan halaman tambahan Check sebagai Void',0),(566187,15728,'nl','Aanvullende controle pagina\'s toevoegen als leegte',0),(566188,15728,'fi','LisÃ¤Ã¤ uusi tarkistus sivuja Void',0),(566189,15728,'no','Legge til flere sider som Void',0),(566190,15728,'da','TilfÃ¸j ekstra Check sider som tomrum',0),(566191,15728,'ko','Voidë¡œ ì¶”ê°€ í™•ì¸ íŽ˜ì´ì§€ë¥¼ ì¶”ê°€',0),(566192,15728,'he','×œ×”×•×¡×™×£ ×“×¤×™× × ×•×¡×¤×™× ×”×¡×™×ž×•×Ÿ ×›- Void',0),(566193,15728,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ ÏƒÎµÎ»Î¯Î´ÎµÏ‚ Ï‰Ï‚ Void',0),(566194,15728,'zh','æ·»åŠ é™„åŠ æ£€æŸ¥é¡µä¸ºç©ºç™½',0),(566195,15728,'sv','LÃ¤gg till ytterligare kontrollera sidor som Void',0),(566196,15728,'it','Aggiungere ulteriore controllo pagine come Void',0),(566197,15728,'tl','',0),(566198,15728,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸«à¸™à¹‰à¸²à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¹€à¸Šà¹‡à¸„à¹€à¸›à¹‡à¸™à¹‚à¸¡à¸†à¸°',0),(566199,15728,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤šà¥‡à¤• à¤ªà¤¨à¥à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ Void à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(566200,15728,'ms','Menambah halaman daftar tambahan sebagai tidak sah',0),(566201,15728,'ar','Ø¥Ø¶Ø§ÙØ© ØµÙØ­Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ© Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ÙƒØ§Ù„ÙØ±Ø§Øº',0),(566202,15728,'fr','Ajouter des Pages de contrÃ´le supplÃ©mentaire comme vide',0),(566203,15728,'jp','Void ã¨ã—ã¦è¿½åŠ ã®ãƒã‚§ãƒƒã‚¯ ãƒšãƒ¼ã‚¸ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(566204,15728,'pt','Adicionar pÃ¡ginas de verificaÃ§Ã£o adicional como Void',0),(566205,15728,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ† ÐºÐ°Ðº Void',0),(566206,15728,'es','Agregar pÃ¡ginas de retenciÃ³n adicionales como vacÃ­o',0),(566207,15728,'de','ZusatzprÃ¼fung Seiten als Void hinzufÃ¼gen',0),(566208,15728,'en','Add Additional Check Pages As Void',0),(566209,15729,'is','',0),(566210,15729,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ù†ÙˆØ´ØªØ§Ø± Ø®ÙØ±Ø¯ ÙØ§Ú©ØªÙˆØ± Ù„ÛŒØ³Øª Ø³Ø±Ø±ÛŒØ²',0),(566211,15729,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ù†ÙˆØ´ØªØ§Ø± Ø®ÙØ±Ø¯ ÙØ§Ú©ØªÙˆØ± Ù„ÛŒØ³Øª Ø³Ø±Ø±ÛŒØ²',0),(566212,15729,'tr','Saplama fatura liste taÅŸma kontrol',0),(566213,15729,'pl','SprawdÅº Stub faktury listy przepeÅ‚nienia',0),(566214,15729,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¼ÑŠÐ½Ð¸Ñ‡Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° ÑÐ¿Ð¸ÑÑŠÐº Ð¿Ñ€ÐµÐ¿ÑŠÐ»Ð²Ð°Ð½Ðµ',0),(566215,15729,'ur','Ø¯Ø§Ú‘Ú¾ Ø§Ù†ÙˆØ§Ø¦Ø³ ÙÛØ±Ø³Øª Ú†Ú¾Ù„Ú©Ù†Û’ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(566216,15729,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð¾Ð´ÑÐµÑ‡ÐºÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð»Ð¸ÑÑ‚Ðµ Ð²Ð¸ÑˆÐºÐ°',0),(566217,15729,'vi','Kiá»ƒm tra sÆ¡ khai hoÃ¡ danh trÃ n',0),(566218,15729,'af','Kontroleer saadjie faktuur lys oorloop',0),(566219,15729,'ro','Verifica ciot factura lista preaplin',0),(566220,15729,'et','Kontrollige VÃ¤lislingid arve loendi Ã¼letÃ¤itumine',0),(566221,15729,'si','Preverite Å¡krbina raÄun seznam Overflow',0),(566222,15729,'ba','Periksa rintisan faktur daftar Overflow',0),(566223,15729,'nl','Controleren van Stub factuur lijst overloop',0),(566224,15729,'fi','Tarkista tynkÃ¤ laskun luettelon ylivuoto',0),(566225,15729,'no','Sjekk spire faktura listen overflyt',0),(566226,15729,'da','Kontrollere Stub faktura liste overlÃ¸b',0),(566227,15729,'ko','ìŠ¤í… ì†¡ìž¥ ëª©ë¡ ì˜¤ë²„í”Œë¡œ ê²€ì‚¬',0),(566228,15729,'he','×‘×“×•×§ Stub ×—×©×‘×•× ×™×ª ×¨×©×™×ž×ª ×’×œ×™×©×”',0),(566229,15729,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î¿ ÏƒÏ„Î­Î»ÎµÏ‡Î¿Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î»Î¯ÏƒÏ„Î± Ï…Ï€ÎµÏÏ‡ÎµÎ¯Î»Î¹ÏƒÎ·',0),(566230,15729,'zh','æ£€æŸ¥å­˜æ ¹ ï¼ˆstubï¼‰ å‘ç¥¨åˆ—è¡¨æº¢å‡º',0),(566231,15729,'sv','Kolla bara pÃ¥bÃ¶rjad faktura listan Overflow',0),(566232,15729,'it','Verifica Stub fattura elenco Overflow',0),(566233,15729,'tl','',0),(566234,15729,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸‚à¸±à¹‰à¸§à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸£à¸²à¸¢à¸à¸²à¸£à¸¡à¸²à¸à¹€à¸à¸´à¸™à¹„à¸›',0),(566235,15729,'hi','à¤¸à¥à¤Ÿà¤¬ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¸à¥‚à¤šà¥€ à¤“à¤µà¤°à¤«à¤¼à¥à¤²à¥‹ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(566236,15729,'ms','Semak Senarai invois tunas limpahan',0),(566237,15729,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† ØªØ¬Ø§ÙˆØ² Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙƒØ¹Ø¨ Ø§Ù„Ø±ÙˆØªÙŠÙ†',0),(566238,15729,'fr','VÃ©rifier la Stub facture liste dÃ©bordement',0),(566239,15729,'jp','ã‚¹ã‚¿ãƒ–è«‹æ±‚æ›¸ãƒªã‚¹ãƒˆ ã‚ªãƒ¼ãƒãƒ¼ãƒ•ãƒ­ãƒ¼ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(566240,15729,'pt','Verificar estouro de lista de fatura de esboÃ§o',0),(566241,15729,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð¿ÐµÑ€ÐµÐ¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ ÑÐ¿Ð¸ÑÐ¾Ðº Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ Ð·Ð°Ð³Ð»ÑƒÑˆÐºÐ¸',0),(566242,15729,'es','Compruebe trozo factura lista desbordamiento',0),(566243,15729,'de','ÃœberprÃ¼fen Sie die Stub Rechnung Liste Ãœberlauf',0),(566244,15729,'en','Check Stub Invoice List Overflow',0),(566245,15730,'is','',0),(566246,15730,'dr','Ø¨Ø±Ø±Ø³ÛŒ ØªØ§Ø±ÛŒØ® Ø¨ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±',0),(566247,15730,'pr','Ø¨Ø±Ø±Ø³ÛŒ ØªØ§Ø±ÛŒØ® Ø¨ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±',0),(566248,15730,'tr','Onay iptal tarihi',0),(566249,15730,'pl','SprawdÅº datÄ™ niewaÅ¼ne',0),(566250,15730,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð½ÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(566251,15730,'ur','Ú©Ø§Ù„Ø¹Ø¯Ù… ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(566252,15730,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð°Ð·Ð½Ð¸Ð½Ñƒ',0),(566253,15730,'vi','Kiá»ƒm tra ngÃ y Void',0),(566254,15730,'af','Tjek leemte datum',0),(566255,15730,'ro','VerificaÅ£i data nule',0),(566256,15730,'et','Kontrollige tÃ¼hine kuupÃ¤ev',0),(566257,15730,'si','Preveri neveljavne datum',0),(566258,15730,'ba','Periksa tanggal Batal',0),(566259,15730,'nl','Selectievakje vervallen datum',0),(566260,15730,'fi','Tarkista MitÃ¤tÃ¶innin pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(566261,15730,'no','Ugyldig kontrolldatoen',0),(566262,15730,'da','Kontrol ugyldig dato',0),(566263,15730,'ko','Void ë‚ ì§œ í™•ì¸',0),(566264,15730,'he','×‘×“×•×§ ×ª××¨×™×š ×—×œ×œ',0),(566265,15730,'el','Î†ÎºÏ…ÏÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(566266,15730,'zh','æ£€æŸ¥æ— æ•ˆçš„æ—¥æœŸ',0),(566267,15730,'sv','Kolla ogiltigt datum',0),(566268,15730,'it','Controllare la data di sub',0),(566269,15730,'tl','',0),(566270,15730,'th','à¸§à¸±à¸™à¹‚à¸¡à¸†à¸°à¹€à¸Šà¹‡à¸„',0),(566271,15730,'hi','à¤¶à¥‚à¤¨à¥à¤¯ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(566272,15730,'ms','Semak tarikh Batal',0),(566273,15730,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† ØªØ§Ø±ÙŠØ® Ø¨Ø§Ø·Ù„Ø©',0),(566274,15730,'fr','VÃ©rifier la Date de Sub',0),(566275,15730,'jp','Void ã®æ—¥ä»˜ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(566276,15730,'pt','Verificar data vazia',0),(566277,15730,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Void Ð”Ð°Ñ‚Ð°',0),(566278,15730,'es','Verificar fecha de vacÃ­o',0),(566279,15730,'de','Privatevoid PrÃ¼fdatum',0),(566280,15730,'en','Check Void Date',0),(566281,15731,'is','',0),(566282,15731,'dr','ØªØ§Ø±ÛŒØ® Ú©Ù†ÙˆÙ†ÛŒ',0),(566283,15731,'pr','ØªØ§Ø±ÛŒØ® Ú©Ù†ÙˆÙ†ÛŒ',0),(566284,15731,'tr','GeÃ§erli tarih',0),(566285,15731,'pl','BieÅ¼Ä…ca data',0),(566286,15731,'bg','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ð´Ð°Ñ‚Ð°',0),(566287,15731,'ur','Ø­Ø§Ù„ÛŒÛ ØªØ§Ø±ÛŒØ®',0),(566288,15731,'sr','Ð”Ð°Ð½Ð°ÑˆÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(566289,15731,'vi','NgÃ y hiá»‡n táº¡i',0),(566290,15731,'af','Huidige datum',0),(566291,15731,'ro','Data curentÄƒ',0),(566292,15731,'et','TÃ¤nane kuupÃ¤ev',0),(566293,15731,'si','Trenutni datum',0),(566294,15731,'ba','Tanggal sekarang',0),(566295,15731,'nl','Huidige datum',0),(566296,15731,'fi','Nykyinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(566297,15731,'no','Gjeldende dato',0),(566298,15731,'da','Dags dato',0),(566299,15731,'ko','í˜„ìž¬ ë‚ ì§œ',0),(566300,15731,'he','×”×ª××¨×™×š ×”× ×•×›×—×™',0),(566301,15731,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(566302,15731,'zh','å½“å‰æ—¥æœŸ',0),(566303,15731,'sv','Aktuellt datum',0),(566304,15731,'it','Data corrente',0),(566305,15731,'tl','',0),(566306,15731,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(566307,15731,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(566308,15731,'ms','Tarikh semasa',0),(566309,15731,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(566310,15731,'fr','Date du jour',0),(566311,15731,'jp','ç¾åœ¨ã®æ—¥ä»˜',0),(566312,15731,'pt','Data atual',0),(566313,15731,'ru','Ð¢ÐµÐºÑƒÑ‰Ð°Ñ Ð´Ð°Ñ‚Ð°',0),(566314,15731,'es','Fecha actual',0),(566315,15731,'de','Aktuelle Datum',0),(566316,15731,'en','Current Date',0),(566317,15732,'is','',0),(566318,15732,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø³ÙØ§Ø±Ø´ Ø§Ø²',0),(566319,15732,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø³ÙØ§Ø±Ø´ Ø§Ø²',0),(566320,15732,'tr','VarsayÄ±lan sipariÅŸ',0),(566321,15732,'pl','DomyÅ›lny porzÄ…dek z',0),(566322,15732,'bg','Ð ÐµÐ´ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚',0),(566323,15732,'ur','Ø·Û’ Ø´Ø¯Û ØªØ±ØªÛŒØ¨ Ø³Û’',0),(566324,15732,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð¸Ð·',0),(566325,15732,'vi','Thá»© tá»± máº·c Ä‘á»‹nh tá»«',0),(566326,15732,'af','Verstek orde van',0),(566327,15732,'ro','Ordinea implicitÄƒ de',0),(566328,15732,'et','VaikejÃ¤rjestus:',0),(566329,15732,'si','Privzeti vrstni red od',0),(566330,15732,'ba','Default urutan dari',0),(566331,15732,'nl','Standaardvolgorde van',0),(566332,15732,'fi','OletusjÃ¤rjestyksessÃ¤',0),(566333,15732,'no','StandardrekkefÃ¸lge fra',0),(566334,15732,'da','StandardrÃ¦kkefÃ¸lgen fra',0),(566335,15732,'ko','ê¸°ë³¸ ìˆœì„œ',0),(566336,15732,'he','×¡×“×¨ ×‘×¨×™×¨×ª ×ž×—×“×œ ×ž',0),(566337,15732,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÏƒÎµÎ¹ÏÎ¬ Î±Ï€ÏŒ',0),(566338,15732,'zh','ä»Žé»˜è®¤é¡ºåº',0),(566339,15732,'sv','Standardordning frÃ¥n',0),(566340,15732,'it','Ordine predefinito da',0),(566341,15732,'tl','',0),(566342,15732,'th','à¸¥à¸³à¸”à¸±à¸šà¸à¸²à¸£à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ˆà¸²à¸',0),(566343,15732,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤•à¥à¤°à¤® à¤¸à¥‡',0),(566344,15732,'ms','Pesanan lalai daripada',0),(566345,15732,'ar','Ø§Ù„ØªØ±ØªÙŠØ¨ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ù…Ù†',0),(566346,15732,'fr','Ordre par dÃ©faut de',0),(566347,15732,'jp','æ—¢å®šã®é †åº',0),(566348,15732,'pt','Ordem padrÃ£o de',0),(566349,15732,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¾Ñ‚',0),(566350,15732,'es','Orden por defecto de',0),(566351,15732,'de','Standardreihenfolge aus',0),(566352,15732,'en','Default Order From',0),(566353,15733,'is','',0),(566354,15733,'dr','Ú†Ú© Ù†ÙˆØ´ØªÙ†',0),(566355,15733,'pr','Ú†Ú© Ù†ÙˆØ´ØªÙ†',0),(566356,15733,'tr','Onay yazmayÄ±n',0),(566357,15733,'pl','Nie pisz wyboru',0),(566358,15733,'bg','ÐÐµ Ð¿Ð¸ÑˆÐ° Ñ‡ÐµÐº',0),(566359,15733,'ur','Ú†ÛŒÚ© Ù†Û Ù„Ú©Ú¾ÛŒÚº',0),(566360,15733,'sr','ÐÐµ Ð¿Ð¸ÑÐ¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(566361,15733,'vi','KhÃ´ng viáº¿t kiá»ƒm tra',0),(566362,15733,'af','Kontroleer skryf nie',0),(566363,15733,'ro','Nu scrie Check',0),(566364,15733,'et','Ã„rge kirjutage sisse',0),(566365,15733,'si','Ne piÅ¡ite potrdite',0),(566366,15733,'ba','Jangan menulis Check',0),(566367,15733,'nl','Schrijf niet Check',0),(566368,15733,'fi','Ã„lÃ¤ kirjoita uloskirjautuminen',0),(566369,15733,'no','Ikke skriv av',0),(566370,15733,'da','Skriv ikke Check',0),(566371,15733,'ko','ê²€ì‚¬ë¥¼ ìž‘ì„± í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(566372,15733,'he','××œ ×ª×›×ª×•×‘ ×¦\'×§',0),(566373,15733,'el','ÎœÎ·Î½ Î³ÏÎ¬ÏˆÎµÏ„Îµ ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(566374,15733,'zh','ä¸å†™æ£€æŸ¥',0),(566375,15733,'sv','Skriv inte in',0),(566376,15733,'it','Non scrivere Check',0),(566377,15733,'tl','',0),(566378,15733,'th','à¹€à¸‚à¸µà¸¢à¸™à¹€à¸Šà¹‡à¸„',0),(566379,15733,'hi','à¤šà¥‡à¤• à¤¨à¤¹à¥€à¤‚ à¤²à¤¿à¤– à¤¸à¤•à¤¤à¤¾ à¤¹à¥‚à¤',0),(566380,15733,'ms','Jangan tulis cek',0),(566381,15733,'ar','Ù„Ø§ ØªÙƒØªØ¨ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(566382,15733,'fr','N\'Ã©crivez pas cocher',0),(566383,15733,'jp','ãƒã‚§ãƒƒã‚¯ã¯æ›¸ãè¾¼ã¾ãªã„ã§ãã ã•ã„ã€‚',0),(566384,15733,'pt','NÃ£o cheque',0),(566385,15733,'ru','ÐÐµ Ð½Ð°Ð¿Ð¸ÑÐ°Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ',0),(566386,15733,'es','No escriba el cheque',0),(566387,15733,'de','Schreibe nicht Check',0),(566388,15733,'en','Do Not Write Check',0),(566389,15734,'is','',0),(566390,15734,'dr','Ù„ÛŒØ³Øª Ø·ØºÛŒØ§Ù† Ø¯Ø± ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨ÛŒØ´ Ø§Ø² 45',0),(566391,15734,'pr','Ù„ÛŒØ³Øª Ø·ØºÛŒØ§Ù† Ø¯Ø± ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø¨ÛŒØ´ Ø§Ø² 45',0),(566392,15734,'tr','Liste taÅŸmalarÄ± fazla 45 faturalarÄ±',0),(566393,15734,'pl','PrzepeÅ‚nieÅ„ w ponad 45 faktury',0),(566394,15734,'bg','Ð¡Ð¿Ð¸ÑÑŠÐº Ð·Ð°Ð»ÑÑ‚Ð¾ Ð² Ð¿Ð¾Ð²ÐµÑ‡Ðµ Ð¾Ñ‚ 45 Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(566395,15734,'ur','45 Ø³Û’ Ø²Ø§Ø¦Ø¯ ÙˆØ¨Ø¬Ù„ÛŒ Ù¾Ø± ÙÛØ±Ø³Øª Ø¨Ú‘Ú¾ Ú¯Ø¦ÛŒ',0),(566396,15734,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¸Ð·Ð»Ð¸Ñ˜Ðµ Ð½Ð° Ð²Ð¸ÑˆÐµ Ð¾Ð´ 45 Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(566397,15734,'vi','Danh sÃ¡ch trÃ n táº¡i hÆ¡n 45 hoÃ¡ Ä‘Æ¡n',0),(566398,15734,'af','Lys Overflows by meer as 45 fakture',0),(566399,15734,'ro','Lista revarsÄƒ la mai mult de 45 facturi',0),(566400,15734,'et','Kell rohkem kui 45 arvete nimekiri pÃµhjustab atribuudipikkuse Ã¼letÃ¤itumise',0),(566401,15734,'si','Seznam prelivom na veÄ kot 45 raÄunov',0),(566402,15734,'ba','Daftar melimpah di lebih dari 45 faktur',0),(566403,15734,'nl','Lijst Overflows in meer dan 45 facturen',0),(566404,15734,'fi','Luettelo ylivuodot yli 45 laskut',0),(566405,15734,'no','Listen overflyt pÃ¥ mer enn 45 fakturaer',0),(566406,15734,'da','Listen overlÃ¸b pÃ¥ mere end 45 fakturaer',0),(566407,15734,'ko','45 ê°œ ì´ìƒì˜ ì†¡ìž¥ì—ì„œ ëª©ë¡ ì˜¤ë²„í”Œë¡œ',0),(566408,15734,'he','××œ ×¢×‘×¨ ×¨×©×™×ž×ª ×”×§×¨×™××” ×‘ ×™×•×ª×¨ ×ž 45 ×—×©×‘×•× ×™×•×ª',0),(566409,15734,'el','Î›Î¯ÏƒÏ„Î± Ï…Ï€ÎµÏÏ‡ÎµÎ¹Î»Î¯ÏƒÎµÎ¹Ï‚ ÏƒÎµ Ï€ÎµÏÎ¹ÏƒÏƒÏŒÏ„ÎµÏÎ± Î±Ï€ÏŒ 45 Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(566410,15734,'zh','åœ¨è¶…è¿‡ 45 å‘ç¥¨åˆ—è¡¨æº¢å‡º',0),(566411,15734,'sv','Lista svÃ¤mmar Ã¶ver pÃ¥ mer Ã¤n 45 fakturor',0),(566412,15734,'it','Overflow di elenco fatture oltre 45',0),(566413,15734,'tl','',0),(566414,15734,'th','à¹‚à¸­à¹€à¸§à¸­à¸£à¹Œà¹‚à¸Ÿà¸¥à¸§à¹Œà¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸¡à¸²à¸à¸à¸§à¹ˆà¸² 45',0),(566415,15734,'hi','45 à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤šà¤¾à¤²à¤¾à¤¨ à¤ªà¤° à¤¸à¥‚à¤šà¥€ Overflows',0),(566416,15734,'ms','Senarai melimpahi pada invois lebih daripada 45',0),(566417,15734,'ar','ØªØ¬Ø§ÙˆØ²Ø§Øª Ù‚Ø§Ø¦Ù…Ø© Ø¹Ù„Ù‰ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø£ÙƒØ«Ø± Ù…Ù† 45',0),(566418,15734,'fr','Liste des dÃ©bordements Ã  plus de 45 factures',0),(566419,15734,'jp','45 ä»¥ä¸Šã®è«‹æ±‚æ›¸ã§ãƒªã‚¹ãƒˆã®ã‚ªãƒ¼ãƒãƒ¼ãƒ•ãƒ­ãƒ¼',0),(566420,15734,'pt','Estouros de lista em mais de 45 facturas',0),(566421,15734,'ru','Ð¡Ð¿Ð¸ÑÐ¾Ðº Ð¿ÐµÑ€ÐµÐ¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð² Ð±Ð¾Ð»ÐµÐµ Ñ‡ÐµÐ¼ 45 ÑÑ‡ÐµÑ‚Ð¾Ð²-Ñ„Ð°ÐºÑ‚ÑƒÑ€',0),(566422,15734,'es','Lista de desbordamientos en las facturas de mÃ¡s de 45',0),(566423,15734,'de','Liste ÃœberlÃ¤ufe an mehr als 45 Rechnungen',0),(566424,15734,'en','List Overflows At More Than 45 Invoices',0),(566425,15735,'is','',0),(566426,15735,'dr','Ø§ÙˆÙ„ÛŒÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø­Ø³Ø§Ø¨',0),(566427,15735,'pr','Ø§ÙˆÙ„ÛŒÙ† Ù¾Ø±Ø¯Ø§Ø®Øª Ø­Ø³Ø§Ø¨',0),(566428,15735,'tr','Tercih edilen Ã¶deme hesabÄ±',0),(566429,15735,'pl','Preferowane pÅ‚atnoÅ›ci konto',0),(566430,15735,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(566431,15735,'ur','ÙˆÛŒØª Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(566432,15735,'sr','Ð¥Ñ‚ÐµÐ»Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(566433,15735,'vi','TÃ i khoáº£n thanh toÃ¡n Æ°a thÃ­ch',0),(566434,15735,'af','Voorkeur betaling rekening',0),(566435,15735,'ro','Cont de plata preferat',0),(566436,15735,'et','Eelistatud maksekonto',0),(566437,15735,'si','Raje plaÄilnega raÄuna',0),(566438,15735,'ba','Rekening pembayaran dipilih',0),(566439,15735,'nl','Primaire betaling Account',0),(566440,15735,'fi','Mieluummin maksutilille',0),(566441,15735,'no','Foretrukket betalingskonto',0),(566442,15735,'da','Foretrukne betalingskonto',0),(566443,15735,'ko','ì„ í˜¸ ì§€ë¶ˆ ê³„ì •',0),(566444,15735,'he','×—×©×‘×•×Ÿ ×”×ª×©×œ×•× ×”×ž×•×¢×“×¤×ª',0),(566445,15735,'el','Î ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(566446,15735,'zh','ä¼˜å…ˆä»˜æ¬¾å¸æˆ·',0),(566447,15735,'sv','FÃ¶rmÃ¥nskonto betalning',0),(566448,15735,'it','Conto di pagamento preferito',0),(566449,15735,'tl','',0),(566450,15735,'th','à¸•à¹‰à¸­à¸‡à¸Šà¸³à¸£à¸°à¸šà¸±à¸à¸Šà¸µ',0),(566451,15735,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤–à¤¾à¤¤à¤¾',0),(566452,15735,'ms','Prefered Payment Account',0),(566453,15735,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…ÙØ¶Ù„Ø©',0),(566454,15735,'fr','Compte de paiement prÃ©fÃ©rÃ©',0),(566455,15735,'jp','å¥½ã¾ã—ã„ãŠæ”¯æ‰•ã„å£åº§',0),(566456,15735,'pt','Conta de pagamento preferido',0),(566457,15735,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°ÐµÐ¼Ñ‹Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚',0),(566458,15735,'es','Cuenta de pago preferente',0),(566459,15735,'de','Bevorzugte Abrechnungskonto',0),(566460,15735,'en','Preferred Payment Account',0),(566461,15736,'is','',0),(566462,15736,'dr','Ø§ÙˆÙ„ÛŒÙ† Ú©Ø§Ø±Øª Ù¾Ø±Ø¯Ø§Ø®Øª',0),(566463,15736,'pr','Ø§ÙˆÙ„ÛŒÙ† Ú©Ø§Ø±Øª Ù¾Ø±Ø¯Ø§Ø®Øª',0),(566464,15736,'tr','Tercih edilen Ã¶deme kartÄ±',0),(566465,15736,'pl','Preferowane pÅ‚atnoÅ›ci kartÄ…',0),(566466,15736,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(566467,15736,'ur','ÙˆÛŒØª Ù¾ÛŒÙ…Ù†Ù¹ Ú©Ø§Ø±Úˆ',0),(566468,15736,'sr','Ð¥Ñ‚ÐµÐ»Ð° Ð¿Ð»Ð°Ñ‚Ð½Ðµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(566469,15736,'vi','Tháº» thanh toÃ¡n Æ°a thÃ­ch',0),(566470,15736,'af','Voorkeur betaling kaart',0),(566471,15736,'ro','Card de platÄƒ preferatÄƒ',0),(566472,15736,'et','Eelistatud Maksekaart',0),(566473,15736,'si','Prednost plaÄilnih kartic',0),(566474,15736,'ba','Dipilih pembayaran kartu',0),(566475,15736,'nl','Voorkeur betaalkaart',0),(566476,15736,'fi','Mieluummin maksukortti',0),(566477,15736,'no','Foretrukket betalingskort',0),(566478,15736,'da','Foretrukne betalingskort',0),(566479,15736,'ko','ì„ í˜¸ ì§€ë¶ˆ ì¹´ë“œ',0),(566480,15736,'he','×›×¨×˜×™×¡ ×”×ª×©×œ×•× ×”×ž×•×¢×“×¤×ª',0),(566481,15736,'el','Î ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· ÎºÎ¬ÏÏ„Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(566482,15736,'zh','ä¼˜å…ˆæ”¯ä»˜å¡',0),(566483,15736,'sv','FÃ¶redrog betalkort',0),(566484,15736,'it','Carta di pagamento preferito',0),(566485,15736,'tl','',0),(566486,15736,'th','à¸•à¹‰à¸­à¸‡à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸œà¹ˆà¸²à¸™à¸šà¸±à¸•à¸£',0),(566487,15736,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¾à¤°à¥à¤¡',0),(566488,15736,'ms','Kad bayaran Prefered',0),(566489,15736,'ar','Ø¨Ø·Ø§Ù‚Ø§Øª Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…ÙØ¶Ù„Ø©',0),(566490,15736,'fr','Carte de paiement prÃ©fÃ©rÃ©',0),(566491,15736,'jp','å¥½ã¾ã—ã„æ”¯æ‰•ã‚«ãƒ¼ãƒ‰',0),(566492,15736,'pt','CartÃ£o de pagamento preferido',0),(566493,15736,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°ÐµÐ¼Ñ‹Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð½Ð°Ñ ÐºÐ°Ñ€Ñ‚Ð°',0),(566494,15736,'es','Tarjeta de pago preferido',0),(566495,15736,'de','Bevorzugte Zahlungskarte',0),(566496,15736,'en','Preferred Payment Card',0),(566497,15737,'is','',0),(566498,15737,'dr','Ø§ÙˆÙ„ÛŒÙ† Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(566499,15737,'pr','Ø§ÙˆÙ„ÛŒÙ† Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(566500,15737,'tr','Tercih edilen Ã¶deme yÃ¶ntemi',0),(566501,15737,'pl','Preferowany sposÃ³b pÅ‚atnoÅ›ci',0),(566502,15737,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ Ð½Ð°Ñ‡Ð¸Ð½ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(566503,15737,'ur','ÙˆÛŒØª Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø±',0),(566504,15737,'sr','ÐÐ°Ñ‡Ð¸Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ…Ñ‚ÐµÐ»Ð°',0),(566505,15737,'vi','PhÆ°Æ¡ng thá»©c thanh toÃ¡n Æ°a thÃ­ch',0),(566506,15737,'af','Voorkeur betaling metode',0),(566507,15737,'ro','Metoda de platÄƒ preferatÄƒ',0),(566508,15737,'et','Eelistatud meetod',0),(566509,15737,'si','Raje naÄin plaÄila',0),(566510,15737,'ba','Metode pembayaran yang dipilih',0),(566511,15737,'nl','Primaire betalingsmethode',0),(566512,15737,'fi','Maksutapa',0),(566513,15737,'no','Foretrukket betalingsmÃ¥te',0),(566514,15737,'da','Foretrukne betalingsmetode',0),(566515,15737,'ko','ì„ í˜¸ ì§€ë¶ˆ ë°©ë²•',0),(566516,15737,'he','×©×™×˜×ª ×”×ª×©×œ×•× ×”×ž×•×¢×“×¤×ª',0),(566517,15737,'el','Î¤ÏÏŒÏ€Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(566518,15737,'zh','é¦–é€‰ä»˜æ¬¾æ–¹å¼',0),(566519,15737,'sv','Ã–nskad betalningsmetod',0),(566520,15737,'it','Metodo di pagamento preferito',0),(566521,15737,'tl','',0),(566522,15737,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸•à¹‰à¸­à¸‡',0),(566523,15737,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤§à¤¿',0),(566524,15737,'ms','Kaedah pembayaran Prefered',0),(566525,15737,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…ÙØ¶Ù„Ø©',0),(566526,15737,'fr','Mode de paiement prÃ©fÃ©rÃ©',0),(566527,15737,'jp','å¥½ã¾ã—ã„æ”¯æ‰•ã„æ–¹æ³•',0),(566528,15737,'pt','MÃ©todo de pagamento preferido',0),(566529,15737,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÑÐ¿Ð¾ÑÐ¾Ð± Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(566530,15737,'es','MÃ©todo de pago preferido',0),(566531,15737,'de','Bevorzugte Zahlungsart',0),(566532,15737,'en','Preferred Payment Method',0),(566533,15738,'is','',0),(566534,15738,'dr','Ø§Ù…Ø¶Ø§ÛŒ Ø¯ÛŒØ¬ÛŒØªØ§Ù„ÛŒ Ø±ÙˆÛŒ Ú†Ú© Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ø´Ø§Ù…Ù„ Ù†Ù…ÛŒ Ø´ÙˆØ¯',0),(566535,15738,'pr','Ø§Ù…Ø¶Ø§ÛŒ Ø¯ÛŒØ¬ÛŒØªØ§Ù„ÛŒ Ø±ÙˆÛŒ Ú†Ú© Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø± Ø±Ø§ Ø´Ø§Ù…Ù„ Ù†Ù…ÛŒ Ø´ÙˆØ¯',0),(566536,15738,'tr','Manuel kontroller sayÄ±sal imza ekleme',0),(566537,15738,'pl','Nie zawierajÄ… podpis cyfrowy na rÄ™czne kontrole',0),(566538,15738,'bg','ÐÐµ Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°Ñ‚ Ñ†Ð¸Ñ„Ñ€Ð¾Ð² Ð¿Ð¾Ð´Ð¿Ð¸Ñ Ð½Ð° Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(566539,15738,'ur','Ø¹Ø¯Ø¯ÛŒ Ø¯Ø³ØªØ®Ø· Ù¾Ø± Ø¯Ø³ØªÛŒ Ú†ÛŒÚ© Ø´Ø§Ù…Ù„ Ù†Û Ú©Ø±ÛŒÚº',0),(566540,15738,'sr','ÐÐµ ÑƒÐºÑ™ÑƒÑ‡ÑƒÑ˜ Ð´Ð¸Ð³Ð¸Ñ‚Ð°Ð»Ð½Ð¸ Ð¿Ð¾Ñ‚Ð¿Ð¸Ñ Ð½Ð° Ñ€ÑƒÐºÐ¾Ð¼ Ð¿Ð¸ÑÐ°Ð½Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(566541,15738,'vi','KhÃ´ng bao gá»“m chá»¯ kÃ½ ká»¹ thuáº­t sá»‘ kiá»ƒm tra hÆ°á»›ng dáº«n sá»­ dá»¥ng',0),(566542,15738,'af','Digitale handtekening op handmatige kontrole sluit nie',0),(566543,15738,'ro','Nu includ semnÄƒtura digitalÄƒ de pe controale manuale',0),(566544,15738,'et','Ei sisalda kÃ¤sitsi kontrolli digitaalallkirja',0),(566545,15738,'si','Ne vkljuÄujejo digitalni podpis na roÄno pregledi',0),(566546,15738,'ba','Jangan menyertakan tanda tangan Digital pada cek Manual',0),(566547,15738,'nl','Neem geen digitale handtekening op handmatige controles',0),(566548,15738,'fi','Ã„lÃ¤ sisÃ¤llytÃ¤ digitaalinen allekirjoitus kÃ¤sin tarkistaa',0),(566549,15738,'no','Inneholde ikke Digital signatur pÃ¥ manuell sjekker',0),(566550,15738,'da','Medtag ikke Digital signatur pÃ¥ manuel kontrol',0),(566551,15738,'ko','ë””ì§€í„¸ ì„œëª… ìˆ˜ë™ ê²€ì‚¬ì— í¬í•¨ ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(566552,15738,'he','××™× × ×›×•×œ×œ×™× ×—×ª×™×ž×” ×“×™×’×™×˜×œ×™×ª ×¢×œ ×‘×“×™×§×•×ª ×™×“× ×™×•×ª',0),(566553,15738,'el','Î”ÎµÎ½ Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ ÏˆÎ·Ï†Î¹Î±ÎºÎ® Ï…Ï€Î¿Î³ÏÎ±Ï†Î® ÏƒÎµ ÎµÎ³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î¿ ÎµÎ»Î­Î³Ï‡Ï‰Î½',0),(566554,15738,'zh','ä¸åŒ…æ‹¬ä¸Šæ‰‹åŠ¨æ£€æŸ¥æ•°å­—ç­¾å',0),(566555,15738,'sv','Inkludera inte Digital signatur pÃ¥ manuella kontroller',0),(566556,15738,'it','Non includere la firma digitale sui controlli manuali',0),(566557,15738,'tl','',0),(566558,15738,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸¥à¸²à¸¢à¹€à¸‹à¹‡à¸™à¸”à¸´à¸ˆà¸´à¸—à¸±à¸¥à¸šà¸™à¹€à¸Šà¹‡à¸„à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(566559,15738,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤šà¥‡à¤• à¤ªà¤° à¤¡à¤¿à¤œà¤¿à¤Ÿà¤² à¤¹à¤¸à¥à¤¤à¤¾à¤•à¥à¤·à¤° à¤¶à¤¾à¤®à¤¿à¤² à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(566560,15738,'ms','Tidak termasuk tandatangan Digital pada pemeriksaan secara Manual',0),(566561,15738,'ar','Ù„Ø§ ØªÙ‚Ù… Ø¨ØªØ¶Ù…ÙŠÙ† Ø§Ù„ØªÙˆÙ‚ÙŠØ¹ Ø§Ù„Ø±Ù‚Ù…ÙŠ Ø¹Ù„Ù‰ Ø§Ù„ÙØ­Øµ Ø§Ù„ÙŠØ¯ÙˆÙŠ',0),(566562,15738,'fr','N\'incluez pas de Signature numÃ©rique sur des contrÃ´les manuels',0),(566563,15738,'jp','æ‰‹å‹•ãƒã‚§ãƒƒã‚¯ã®ãƒ‡ã‚¸ã‚¿ãƒ«ç½²åãŒå«ã¾ã‚Œã¦ã„ã¾ã›ã‚“',0),(566564,15738,'pt','NÃ£o inclui a assinatura Digital de controlo Manual',0),(566565,15738,'ru','ÐÐµ Ð²ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ñ†Ð¸Ñ„Ñ€Ð¾Ð²ÑƒÑŽ Ð¿Ð¾Ð´Ð¿Ð¸ÑÑŒ Ð½Ð° Ñ€ÑƒÑ‡Ð½Ð¾Ð¹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(566566,15738,'es','No incluyen la firma Digital en control Manual',0),(566567,15738,'de','Enthalten Sie keine digitale Signatur auf manuelle PrÃ¼fungen',0),(566568,15738,'en','Do Not Include Digital Signature On Manual Checks',0),(566569,15739,'is','',0),(566570,15739,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø´Ø±Ú©Øª',0),(566571,15739,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø´Ø±Ú©Øª',0),(566572,15739,'tr','VarsayÄ±lan ÅŸirket',0),(566573,15739,'pl','DomyÅ›lnie firmy',0),(566574,15739,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(566575,15739,'ur','Ø·Û’ Ø´Ø¯Û Ú©Ù…Ù¾Ù†ÛŒ',0),(566576,15739,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð°',0),(566577,15739,'vi','Máº·c Ä‘á»‹nh cÃ´ng ty',0),(566578,15739,'af','Verstek maatskappy',0),(566579,15739,'ro','Compania implicit',0),(566580,15739,'et','Vaikimisi ettevÃµtte',0),(566581,15739,'si','Privzeto podjetje',0),(566582,15739,'ba','Standar perusahaan',0),(566583,15739,'nl','Standaardbedrijf',0),(566584,15739,'fi','Oletusyrityksen',0),(566585,15739,'no','Standardfirma',0),(566586,15739,'da','Standardregnskabet',0),(566587,15739,'ko','ê¸°ë³¸ íšŒì‚¬',0),(566588,15739,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×”×—×‘×¨×”',0),(566589,15739,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(566590,15739,'zh','é»˜è®¤å…¬å¸',0),(566591,15739,'sv','StandardfÃ¶retag',0),(566592,15739,'it','SocietÃ  predefinita',0),(566593,15739,'tl','',0),(566594,15739,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(566595,15739,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤•à¤‚à¤ªà¤¨à¥€',0),(566596,15739,'ms','Syarikat lalai',0),(566597,15739,'ar','Ø´Ø±ÙƒØ© Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(566598,15739,'fr','SociÃ©tÃ© par dÃ©faut',0),(566599,15739,'jp','æ—¢å®šã®ä¼šç¤¾',0),(566600,15739,'pt','Empresa padrÃ£o',0),(566601,15739,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(566602,15739,'es','Empresa por defecto',0),(566603,15739,'de','Standardunternehmen',0),(566604,15739,'en','Default Company',0),(566605,15740,'is','',0),(566606,15740,'dr','Ø§Ù†ÙˆØ§Ø¹ Ú©Ø³Ø± Ú©Ø§Ø±Ù…Ù†Ø¯ ÙØ¹Ù„ÛŒ',0),(566607,15740,'pr','Ø§Ù†ÙˆØ§Ø¹ Ú©Ø³Ø± Ú©Ø§Ø±Ù…Ù†Ø¯ ÙØ¹Ù„ÛŒ',0),(566608,15740,'tr','GeÃ§erli Ã§alÄ±ÅŸan indirimi tipleri',0),(566609,15740,'pl','BieÅ¼Ä…cego pracownika potrÄ…cenie typy',0),(566610,15740,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð²Ð¸Ð´Ð¾Ð²Ðµ',0),(566611,15740,'ur','Ø­Ø§Ù„ÛŒÛ Ù…Ù„Ø§Ø²Ù… ÛÙˆÙ†Û’Ùˆ Ø§Ù‚Ø³Ø§Ù…',0),(566612,15740,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾Ð³ Ñ‚Ð¸Ð¿Ð° Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(566613,15740,'vi','Hiá»‡n nay cÃ¡c loáº¡i kháº¥u trá»« nhÃ¢n viÃªn',0),(566614,15740,'af','Huidige werknemer aftrekking tipes',0),(566615,15740,'ro','Tipuri de deducere curent angajat',0),(566616,15740,'et','Praeguse tÃ¶Ã¶taja mahaarvamise tÃ¼Ã¼bid',0),(566617,15740,'si','Trenutno zaposlenih odbitek vrste',0),(566618,15740,'ba','Saat ini karyawan pengurangan jenis',0),(566619,15740,'nl','Huidige werknemer aftrek typen',0),(566620,15740,'fi','Nykyisen tyÃ¶ntekijÃ¤n vÃ¤hennyksen tyypit',0),(566621,15740,'no','Gjeldende ansattyper fradrag',0),(566622,15740,'da','NuvÃ¦rende ansat fradrag typer',0),(566623,15740,'ko','í˜„ìž¬ ì§ì› ê³µì œ ìœ í˜•',0),(566624,15740,'he','×¡×•×’×™ × ×™×›×•×™×™ ×”×¢×•×‘×“ ×”× ×•×›×—×™',0),(566625,15740,'el','Î¤ÏÎ­Ï‡Î¿Î½Ï„ÎµÏ‚ Ï„ÏÏ€Î¿Ï…Ï‚ Î­ÎºÏ€Ï„Ï‰ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(566626,15740,'zh','å½“å‰å‘˜å·¥æ‰£ç¼´ç±»åž‹',0),(566627,15740,'sv','Nuvarande medarbetare avdrag typer',0),(566628,15740,'it','Tipi di detrazione dipendente corrente',0),(566629,15740,'tl','',0),(566630,15740,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸à¸²à¸£à¸«à¸±à¸à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(566631,15740,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¤Ÿà¥Œà¤¤à¥€ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(566632,15740,'ms','Jenis-jenis potongan pekerja semasa',0),(566633,15740,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø®ØµÙ… Ø§Ù„Ù…ÙˆØ¸Ù Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(566634,15740,'fr','Types actuels de dÃ©duction employÃ©',0),(566635,15740,'jp','ç¾åœ¨ã®å¾“æ¥­å“¡ã®æŽ§é™¤ã®ç¨®é¡ž',0),(566636,15740,'pt','Atual tipos de deduÃ§Ã£o de empregado',0),(566637,15740,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ñ‚Ð¸Ð¿Ñ‹ ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(566638,15740,'es','Tipos de deducciÃ³n de empleado actual',0),(566639,15740,'de','Aktuelle Mitarbeiter-Abzug-Typen',0),(566640,15740,'en','Current Employee Deduction Types',0),(566641,15741,'is','',0),(566642,15741,'dr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ù†ÙˆØ¹ Ú©Ø³Ø±',0),(566643,15741,'pr','Ú©Ø§Ø±Ù…Ù†Ø¯ Ù†ÙˆØ¹ Ú©Ø³Ø±',0),(566644,15741,'tr','Ã‡alÄ±ÅŸan indirimi tipi',0),(566645,15741,'pl','Typ potrÄ…cenia pracownika',0),(566646,15741,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ñ‚Ð¸Ð¿',0),(566647,15741,'ur','Ù…Ù„Ø§Ø²Ù… ÙˆØ¶Ø¹ Ù‚Ø³Ù…',0),(566648,15741,'sr','Ð¢Ð¸Ð¿ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(566649,15741,'vi','NhÃ¢n viÃªn kháº¥u trá»« loáº¡i',0),(566650,15741,'af','Werknemer aftrekking tipe',0),(566651,15741,'ro','Tipul de deducerea angajatului',0),(566652,15741,'et','TÃ¶Ã¶taja mahaarvamise tÃ¼Ã¼p',0),(566653,15741,'si','Zaposleni tipa odbitek',0),(566654,15741,'ba','Jenis pengurangan karyawan',0),(566655,15741,'nl','Werknemer aftrek Type',0),(566656,15741,'fi','TyÃ¶ntekijÃ¤n vÃ¤hennyksen tyyppi',0),(566657,15741,'no','Fradrag ansattype',0),(566658,15741,'da','Medarbejdertype fradrag',0),(566659,15741,'ko','ì§ì› ê³µì œ ìœ í˜•',0),(566660,15741,'he','×¡×•×’ × ×™×›×•×™ ×”×¢×•×‘×“',0),(566661,15741,'el','Î‘Ï†Î±Î¯ÏÎµÏƒÎ· Ï„ÏÏ€Î¿Ï… Ï…Ï€Î¬Î»Î»Î·Î»Î¿Ï‚',0),(566662,15741,'zh','å‘˜å·¥æ‰£é™¤ç±»åž‹',0),(566663,15741,'sv','Medarbetartypen avdrag',0),(566664,15741,'it','Tipo di detrazione dipendente',0),(566665,15741,'tl','',0),(566666,15741,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸à¸²à¸£à¸«à¸±à¸à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(566667,15741,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¤Ÿà¥Œà¤¤à¥€ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(566668,15741,'ms','Jenis potongan pekerja',0),(566669,15741,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø®ØµÙ… Ù…Ù† Ø§Ù„Ù…ÙˆØ¸Ù',0),(566670,15741,'fr','Type de dÃ©duction d\'employÃ©',0),(566671,15741,'jp','å¾“æ¥­å“¡æŽ§é™¤ã‚¿ã‚¤ãƒ—',0),(566672,15741,'pt','Tipo de deduÃ§Ã£o de empregado',0),(566673,15741,'ru','Ð¢Ð¸Ð¿ ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ñ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð²',0),(566674,15741,'es','Tipo de deducciÃ³n de empleado',0),(566675,15741,'de','Mitarbeiter \"Abzug\"',0),(566676,15741,'en','Employee Deduction Type',0),(566677,15742,'is','',0),(566678,15742,'dr','Ù‡ÛŒÚ† Ù†ÙˆØ¹ Ú©Ø³Ø± Ú©Ø§Ø±Ú©Ù†Ø§Ù† ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(566679,15742,'pr','Ù‡ÛŒÚ† Ù†ÙˆØ¹ Ú©Ø³Ø± Ú©Ø§Ø±Ú©Ù†Ø§Ù† ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(566680,15742,'tr','HiÃ§bir Ã§alÄ±ÅŸan indirimi tipleri mevcuttur',0),(566681,15742,'pl','IstniejÄ… typy odliczenie nie pracownika',0),(566682,15742,'bg','ÐÑÐ¼Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ð¿Ñ€Ð¸ÑÐ¿Ð°Ð´Ð°Ð½Ðµ Ð²Ð¸Ð´Ð¾Ð²Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‚',0),(566683,15742,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ù„Ø§Ø²Ù… ÛÙˆÙ†Û’Ùˆ Ø§Ù‚Ø³Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(566684,15742,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ðµ Ñ‚Ð¸Ð¿Ð¾Ð²Ð¸ Ð´ÐµÐ´ÑƒÐºÑ†Ð¸Ñ˜Ð° Ð½ÐµÐ¼Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¾Ð³',0),(566685,15742,'vi','KhÃ´ng loáº¡i trá»« nhÃ¢n viÃªn tá»“n táº¡i',0),(566686,15742,'af','Geen werknemer aftrekking vorme bestaan',0),(566687,15742,'ro','Nici un salariat deducere tipuri existÄƒ',0),(566688,15742,'et','TÃ¶Ã¶taja mahaarvamine tÃ¼Ã¼pe pole olemas',0),(566689,15742,'si','Obstajajo vrste odbitek ni delavec',0),(566690,15742,'ba','Ada tidak ada jenis pengurangan karyawan',0),(566691,15742,'nl','Bestaan geen werknemer aftrek Types',0),(566692,15742,'fi','Ei tyÃ¶ntekijÃ¤n vÃ¤hennyksen tyyppejÃ¤ on olemassa',0),(566693,15742,'no','Ingen ansatte fradrag typer finnes',0),(566694,15742,'da','Der findes ingen medarbejder fradrag typer',0),(566695,15742,'ko','ì§ì› ê³µì œ í˜•ì‹ì€ ì¡´ìž¬',0),(566696,15742,'he','×§×™×™×ž×™× ×¡×•×’×™ × ×™×›×•×™×™ ×œ× ×¢×•×‘×“',0),(566697,15742,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î´ÎµÎ½ Ï„ÏÏ€Î¿Î¹ Î­ÎºÏ€Ï„Ï‰ÏƒÎ· ÎµÏÎ³Î±Î¶Î¿Î¼Î­Î½Ï‰Î½',0),(566698,15742,'zh','æ²¡æœ‰å‘˜å·¥æ‰£ç¼´ç±»åž‹å­˜åœ¨',0),(566699,15742,'sv','Det finns ingen anstÃ¤lld avdrag typer',0),(566700,15742,'it','Nessun tipo di detrazione dipendente esiste',0),(566701,15742,'tl','',0),(566702,15742,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸à¸²à¸£à¸«à¸±à¸à¸žà¸™à¸±à¸à¸‡à¸²à¸™à¹„à¸¡à¹ˆà¸¡à¸µ',0),(566703,15742,'hi','à¤•à¥‹à¤ˆ à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤•à¤Ÿà¥Œà¤¤à¥€ à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¥Œà¤œà¥‚à¤¦',0),(566704,15742,'ms','Jenis-jenis potongan pekerja tidak wujud',0),(566705,15742,'ar','ØªÙˆØ¬Ø¯ Ù„Ø§ Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø®ØµÙ… Ù…Ù† Ø§Ù„Ù…ÙˆØ¸Ù',0),(566706,15742,'fr','Aucun employÃ© dÃ©duction Types n\'existent',0),(566707,15742,'jp','å¾“æ¥­å“¡ã®æŽ§é™¤ã®ç¨®é¡žãŒå­˜åœ¨ã—ã¾ã›ã‚“ã€‚',0),(566708,15742,'pt','Existem tipos de deduÃ§Ã£o nÃ£o empregado',0),(566709,15742,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‚ Ñ‚Ð¸Ð¿Ñ‹ Ð²Ñ‹Ñ‡ÐµÑ‚ Ð½Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¸ÐºÐ°',0),(566710,15742,'es','No existe ningÃºn tipo de deducciÃ³n de empleado',0),(566711,15742,'de','Es gibt keine Mitarbeiter Abzug-Typen',0),(566712,15742,'en','No Employee Deduction Types Exist',0),(566713,15743,'is','',0),(566714,15743,'dr','YTD ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(566715,15743,'pr','YTD ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(566716,15743,'tr','YTD satÄ±cÄ± Ã¶demeleri',0),(566717,15743,'pl','YTD pÅ‚atnoÅ›ci dostawcy',0),(566718,15743,'bg','ÐžÑ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð¾Ñ‚ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(566719,15743,'ur','ÛŒÙ¹Ø¯ ÙˆÛŒÙ†ÚˆØ± Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(566720,15743,'sr','Ð“Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸Ð¼Ð°',0),(566721,15743,'vi','YTD nhÃ  cung cáº¥p thanh toÃ¡n',0),(566722,15743,'af','YTD handelaar betalings',0),(566723,15743,'ro','YTD furnizor de plÄƒÅ£i',0),(566724,15743,'et','YTD hankijamaksete',0),(566725,15743,'si','PlaÄila dobaviteljem YTD',0),(566726,15743,'ba','YTD Penjual pembayaran',0),(566727,15743,'nl','YTD Betalingsvoorstellen maken',0),(566728,15743,'fi','Vuoden alusta toimittajamaksut',0),(566729,15743,'no','YTD leverandÃ¸rbetalinger',0),(566730,15743,'da','Ã…TD kreditorbetalinger',0),(566731,15743,'ko','YTD ê³µê¸‰ ì—…ì²´ ì§€ë¶ˆ',0),(566732,15743,'he','×ª×©×œ×•×ž×™ ×¡×¤×§ ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(566733,15743,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½ YTD',0),(566734,15743,'zh','YTD ä¾›åº”å•†ä»˜æ¬¾',0),(566735,15743,'sv','YTD leverantÃ¶rsbetalningar',0),(566736,15743,'it','Da inizio anno i pagamenti ai fornitori',0),(566737,15743,'tl','',0),(566738,15743,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸Šà¸³à¸£à¸° YTD',0),(566739,15743,'hi','YTD à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(566740,15743,'ms','THK penjual pembayaran',0),(566741,15743,'ar','Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ† Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(566742,15743,'fr','Paiement des fournisseurs CDA',0),(566743,15743,'jp','ç´¯è¨ˆä»•å…¥å…ˆæ”¯æ‰•',0),(566744,15743,'pt','Pagamentos de fornecedores de acumulado no ano',0),(566745,15743,'ru','Ð¡ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°Ð¼',0),(566746,15743,'es','TOTAL pagos a proveedores',0),(566747,15743,'de','YTD Kreditorenzahlungen',0),(566748,15743,'en','YTD Vendor Payments',0),(566749,15744,'is','',0),(566750,15744,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¢Ø®Ø±ÛŒÙ† 12 Ù…Ø§Ù‡',0),(566751,15744,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø¢Ø®Ø±ÛŒÙ† 12 Ù…Ø§Ù‡',0),(566752,15744,'tr','Ã–demeler son 12 ay',0),(566753,15744,'pl','PÅ‚atnoÅ›ci ostatnie 12 miesiÄ™cy',0),(566754,15744,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð·Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ 12 Ð¼ÐµÑÐµÑ†Ð°',0),(566755,15744,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú¯Ø²Ø´ØªÛ 12 Ù…Ø§Û',0),(566756,15744,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐ¸Ñ… 12 Ð¼ÐµÑÐµÑ†Ð¸',0),(566757,15744,'vi','Thanh toÃ¡n kÃ©o dÃ i 12 thÃ¡ng',0),(566758,15744,'af','Betalings laaste 12 maande',0),(566759,15744,'ro','PlÄƒÅ£i ultimele 12 luni',0),(566760,15744,'et','Maksete viimased 12 kuud',0),(566761,15744,'si','PlaÄila zadnjih 12 mesecev',0),(566762,15744,'ba','Pembayaran terakhir 12 bulan',0),(566763,15744,'nl','Betalingen laatste 12 maanden',0),(566764,15744,'fi','Maksut edelliset 12 kuukautta',0),(566765,15744,'no','Betalinger siste 12 mÃ¥neder',0),(566766,15744,'da','Betaling senest 12 mÃ¥neder',0),(566767,15744,'ko','ì§€ë¶ˆ ì§€ë‚œ 12 ê°œì›”',0),(566768,15744,'he','×ª×©×œ×•×ž×™× ××—×¨×•× ×” 12 ×—×•×“×©×™×',0),(566769,15744,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï„Î¿Ï…Ï‚ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿Ï…Ï‚ 12 Î¼Î®Î½ÎµÏ‚',0),(566770,15744,'zh','æ”¯ä»˜è¿‡åŽ» 12 ä¸ªæœˆ',0),(566771,15744,'sv','Betalning senast 12 mÃ¥nader',0),(566772,15744,'it','Pagamenti ultimi 12 mesi',0),(566773,15744,'tl','',0),(566774,15744,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸¥à¹ˆà¸²à¸ªà¸¸à¸” 12 à¹€à¸”à¸·à¸­à¸™',0),(566775,15744,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¿à¤›à¤²à¥‡ 12 à¤®à¤¹à¥€à¤¨à¥‹à¤‚',0),(566776,15744,'ms','Pembayaran terakhir 12 bulan',0),(566777,15744,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¢Ø®Ø± 12 Ø´Ù‡Ø±Ø§',0),(566778,15744,'fr','Paiements de 12 derniers mois',0),(566779,15744,'jp','æ”¯æ‰•ã„ã®æœ€å¾Œã® 12 ãƒ¶æœˆ',0),(566780,15744,'pt','Pagamentos Ãºltimos 12 meses',0),(566781,15744,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ 12 Ð¼ÐµÑÑÑ†ÐµÐ²',0),(566782,15744,'es','Pagos Ãºltimos 12 meses',0),(566783,15744,'de','Zahlungen der letzten 12 Monate',0),(566784,15744,'en','Payments Last 12 Months',0),(566785,15745,'is','',0),(566786,15745,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ø§Ù„ Ú¯Ø°Ø´ØªÙ‡',0),(566787,15745,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø³Ø§Ù„ Ú¯Ø°Ø´ØªÙ‡',0),(566788,15745,'tr','Ã–demeleri geÃ§en yÄ±l',0),(566789,15745,'pl','Ostatni rok pÅ‚atnoÅ›ci',0),(566790,15745,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð¿Ñ€ÐµÐ· Ð¼Ð¸Ð½Ð°Ð»Ð°Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(566791,15745,'ur','Ú¯Ø²Ø´ØªÛ Ø³Ø§Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(566792,15745,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ Ð¿Ñ€Ð¾ÑˆÐ»Ðµ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(566793,15745,'vi','Cuá»‘i nÄƒm cÃ¡c khoáº£n thanh toÃ¡n',0),(566794,15745,'af','Betalings verlede jaar',0),(566795,15745,'ro','PlÄƒÅ£i anul trecut',0),(566796,15745,'et','Maksete mullu',0),(566797,15745,'si','PlaÄila lani',0),(566798,15745,'ba','Pembayaran tahun lalu',0),(566799,15745,'nl','Betalingen vorig jaar',0),(566800,15745,'fi','Maksut viime vuonna',0),(566801,15745,'no','Betalinger i fjor',0),(566802,15745,'da','Betalinger sidste Ã¥r',0),(566803,15745,'ko','ì§€ë¶ˆ ìž‘ë…„',0),(566804,15745,'he','×ª×©×œ×•×ž×™× ×‘×©× ×” ×©×¢×‘×¨×”',0),(566805,15745,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î­ÏÏ…ÏƒÎ¹',0),(566806,15745,'zh','åŽ»å¹´çš„ä»˜æ¬¾',0),(566807,15745,'sv','Betalningar i fjol',0),(566808,15745,'it','Pagamenti l\'anno scorso',0),(566809,15745,'tl','',0),(566810,15745,'th','à¸›à¸µà¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢à¸‚à¸­à¸‡à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(566811,15745,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¤¿à¤›à¤²à¥‡ à¤¸à¤¾à¤²',0),(566812,15745,'ms','Bayaran tahun lepas',0),(566813,15745,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª ÙÙŠ Ø§Ù„Ø¹Ø§Ù… Ø§Ù„Ù…Ø§Ø¶ÙŠ',0),(566814,15745,'fr','Paiements de l\'annÃ©e derniÃ¨re',0),(566815,15745,'jp','æ˜¨å¹´ã®æ”¯æ‰•ã„',0),(566816,15745,'pt','Pagamentos no ano passado',0),(566817,15745,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ Ð² Ð¿Ñ€Ð¾ÑˆÐ»Ð¾Ð¼ Ð³Ð¾Ð´Ñƒ',0),(566818,15745,'es','Pagos el aÃ±o pasado',0),(566819,15745,'de','Zahlungen im vergangenen Jahr',0),(566820,15745,'en','Payments Last Year',0),(566821,15746,'is','',0),(566822,15746,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª YTD',0),(566823,15746,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª YTD',0),(566824,15746,'tr','Ã–demeler YTD',0),(566825,15746,'pl','PÅ‚atnoÅ›ci od poczÄ…tku roku',0),(566826,15746,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð¾Ñ‚ Ð½Ð°Ñ‡Ð°Ð»Ð¾Ñ‚Ð¾ Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(566827,15746,'ur','ÛŒÙ¹Ø¯ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(566828,15746,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ Ð³Ð¾Ð´Ð¸Ð½Ð° Ð´Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(566829,15746,'vi','Thanh toÃ¡n YTD',0),(566830,15746,'af','Betalings YTD',0),(566831,15746,'ro','PlÄƒÅ£i YTD',0),(566832,15746,'et','Maksete YTD',0),(566833,15746,'si','PlaÄila YTD',0),(566834,15746,'ba','Pembayaran YTD',0),(566835,15746,'nl','Betalingen YTD',0),(566836,15746,'fi','Maksut vuoden alusta',0),(566837,15746,'no','Betalinger YTD',0),(566838,15746,'da','Betalinger Ã…TD',0),(566839,15746,'ko','ì§€ë¶ˆ YTD',0),(566840,15746,'he','×ª×©×œ×•×ž×™× ×ž×ª×—×™×œ×ª ×”×©× ×” ×¢×“ ×”×™×•×',0),(566841,15746,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ YTD',0),(566842,15746,'zh','YTD ä»˜æ¬¾',0),(566843,15746,'sv','Betalningar YTD',0),(566844,15746,'it','Pagamenti da inizio anno',0),(566845,15746,'tl','',0),(566846,15746,'th','à¸Šà¸³à¸£à¸° YTD',0),(566847,15746,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ YTD',0),(566848,15746,'ms','Pembayaran THK',0),(566849,15746,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ù…Ù†Ø° Ø¨Ø¯Ø§ÙŠØ© Ø§Ù„Ø³Ù†Ø©',0),(566850,15746,'fr','Paiements depuis un an',0),(566851,15746,'jp','æ”¯æ‰•ç´¯è¨ˆ',0),(566852,15746,'pt','Pagamentos acumulado no ano',0),(566853,15746,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ Ñ Ð½Ð°Ñ‡Ð°Ð»Ð° Ð³Ð¾Ð´Ð°',0),(566854,15746,'es','Pagos total',0),(566855,15746,'de','Zahlungen YTD',0),(566856,15746,'en','Payments YTD',0),(566857,15747,'is','',0),(566858,15747,'dr','Ú©Ù‡ Ù…Ø§Ù„ÛŒØ§Øª Ø¯Ø± Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(566859,15747,'pr','Ú©Ù‡ Ù…Ø§Ù„ÛŒØ§Øª Ø¯Ø± Ø¨Ø§Ø²Ù†Ø´Ø³ØªÚ¯ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…ÛŒ Ø´ÙˆØ¯',0),(566860,15747,'tr','Hangi vergiler emeklilik miktarÄ±na hesaplanmaz',0),(566861,15747,'pl','Jakie podatki nie sÄ… obliczane na kwotÄ™ emerytury',0),(566862,15747,'bg','ÐšÐ¾Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ð½Ðµ ÑÐµ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð°Ñ‚ Ð½Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€Ð° Ð½Ð° Ð¿ÐµÐ½ÑÐ¸Ð¸Ñ‚Ðµ',0),(566863,15747,'ur','Ø¬Ùˆ Ù¹ÛŒÚ©Ø³ Ù¾Ù†Ø´Ù† Ú©ÛŒ Ø±Ù‚Ù… Ù¾Ø± Ø­Ø³Ø§Ø¨ Ù†ÛÛŒÚº ÛÛŒÚº Û”',0),(566864,15747,'sr','ÐšÐ¾Ñ˜Ðµ Ð¿Ð¾Ñ€ÐµÐ·Ðµ Ð½Ðµ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð° Ð½Ð° Ð¸Ð·Ð½Ð¾Ñ Ð¿ÐµÐ½Ð·Ð¸Ñ˜Ð°',0),(566865,15747,'vi','CÃ¡c loáº¡i thuáº¿ khÃ´ng Ä‘Æ°á»£c tÃ­nh trÃªn sá»‘ tiá»n trá»£ cáº¥p',0),(566866,15747,'af','Watter belastings is nie op pensioen bedrag bereken',0),(566867,15747,'ro','Care taxele nu sunt calculate pe suma de pensii',0),(566868,15747,'et','Millised maksud on arvutatud pensioni summalt',0),(566869,15747,'si','Kateri davki niso izraÄunani na viÅ¡ini pokojnine',0),(566870,15747,'ba','Pajak yang tidak dihitung pada jumlah Pension',0),(566871,15747,'nl','Welke belastingen zijn niet berekend op pensioen bedrag',0),(566872,15747,'fi','MitÃ¤ veroja ei lasketa elÃ¤kkeen mÃ¤Ã¤rÃ¤stÃ¤',0),(566873,15747,'no','Hvilke skatt beregnes ikke pÃ¥ Pension belÃ¸p',0),(566874,15747,'da','Hvilke afgifter er ikke beregnet pÃ¥ Pension belÃ¸b',0),(566875,15747,'ko','ì–´ë–¤ ì„¸ê¸ˆ ì—°ê¸ˆ ê¸ˆì•¡ì— ê³„ì‚° ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(566876,15747,'he','××™×œ×• ×ž×¡×™× ××™× × ×ž×—×•×©×‘×™× ×¢×œ ×¡×›×•× ×”×¤× ×¡×™×”',0),(566877,15747,'el','Î¤Î± Ï„Î­Î»Î· Ï€Î¿Ï… Î´ÎµÎ½ Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î¿ Ï€Î¿ÏƒÏŒ Ï„Î·Ï‚ ÏƒÏÎ½Ï„Î±Î¾Î·Ï‚',0),(566878,15747,'zh','å“ªäº›ç¨Žé¡¹ä¸ä¼šè®¡ç®—å…»æ¤é‡‘æ•°é¢',0),(566879,15747,'sv','Vilka skatter berÃ¤knas inte pÃ¥ Pension belopp',0),(566880,15747,'it','Che le tasse non vengono calcolate sull\'importo di pensione',0),(566881,15747,'tl','',0),(566882,15747,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸„à¸³à¸™à¸§à¸“à¸ à¸²à¸©à¸µà¸‹à¸¶à¹ˆà¸‡à¸¢à¸­à¸”à¹€à¸‡à¸´à¸™à¸šà¸³à¸™à¸²à¸',0),(566883,15747,'hi','à¤œà¥‹ à¤•à¤°à¥‹à¤‚ à¤ªà¤° à¤ªà¥‡à¤‚à¤¶à¤¨ à¤°à¤¾à¤¶à¤¿ à¤ªà¤°à¤¿à¤•à¤²à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆà¤‚',0),(566884,15747,'ms','Cukai yang tidak dikira berdasarkan amaun pencen',0),(566885,15747,'ar','Ù„Ø§ ÙŠØªÙ… Ø§Ø­ØªØ³Ø§Ø¨ Ø£ÙŠ Ø¶Ø±Ø§Ø¦Ø¨ Ø¹Ù„Ù‰ Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø¹Ø§Ø´ Ø§Ù„ØªÙ‚Ø§Ø¹Ø¯ÙŠ',0),(566886,15747,'fr','Les Taxes ne sont pas calculÃ©s sur le montant de la Pension',0),(566887,15747,'jp','ç¨Žé‡‘ã«ã¤ã„ã¦ã¯å¹´é‡‘é¡ã«è¨ˆç®—ã•ã‚Œã¾ã›ã‚“ã€‚',0),(566888,15747,'pt','Quais os impostos nÃ£o sÃ£o calculados sobre o montante da pensÃ£o',0),(566889,15747,'ru','ÐšÐ°ÐºÐ¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¸ Ð½Ðµ Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ð°Ð½Ñ‹ Ð½Ð° Ð¿ÐµÐ½ÑÐ¸Ð¸',0),(566890,15747,'es','Que los impuestos no se calculan sobre el importe de la pensiÃ³n',0),(566891,15747,'de','Welche Steuern werden nicht auf der Renten berechnet.',0),(566892,15747,'en','Which Taxes Are Not Calculated On Pension Amount',0),(566893,15748,'is','',0),(566894,15748,'dr','Ø¢Ø±Ø´ÛŒÙˆ Ú¯Ø²Ø§Ø±Ø´',0),(566895,15748,'pr','Ø¢Ø±Ø´ÛŒÙˆ Ú¯Ø²Ø§Ø±Ø´',0),(566896,15748,'tr','ArÅŸivlenmiÅŸ raporlarÄ±',0),(566897,15748,'pl','Raporty archiwalne',0),(566898,15748,'bg','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(566899,15748,'ur','Ø¬Ù…Ø¹ Ø´Ø¯Û Ø±Ù¾ÙˆØ±Ù¹ÙˆÚº',0),(566900,15748,'sr','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(566901,15748,'vi','LÆ°u trá»¯ bÃ¡o cÃ¡o',0),(566902,15748,'af','Geargiveerde verslae',0),(566903,15748,'ro','Rapoarte arhivate',0),(566904,15748,'et','Arhiivitud aruanded',0),(566905,15748,'si','Arhiviranih poroÄil',0),(566906,15748,'ba','Arsip laporan',0),(566907,15748,'nl','Gearchiveerde rapporten',0),(566908,15748,'fi','Arkistoidut raportit',0),(566909,15748,'no','Arkiverte rapporter',0),(566910,15748,'da','Arkiverede rapporter',0),(566911,15748,'ko','ë³´ê´€ ëœ ë³´ê³ ì„œ',0),(566912,15748,'he','×“×•×—×•×ª ×‘××¨×›×™×•×Ÿ',0),(566913,15748,'el','Î‘ÏÏ‡ÎµÎ¹Î¿Î¸ÎµÏ„Î·Î¼Î­Î½ÎµÏ‚ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚',0),(566914,15748,'zh','å­˜æ¡£çš„æŠ¥å‘Š',0),(566915,15748,'sv','Arkiverade rapporter',0),(566916,15748,'it','Rapporti archiviati',0),(566917,15748,'tl','',0),(566918,15748,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸–à¸²à¸§à¸£',0),(566919,15748,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹à¥€à¤¤ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥à¤¸',0),(566920,15748,'ms','Arkib Laporan',0),(566921,15748,'ar','Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø©',0),(566922,15748,'fr','Rapports archivÃ©s',0),(566923,15748,'jp','ã‚¢ãƒ¼ã‚«ã‚¤ãƒ–ã•ã‚ŒãŸãƒ¬ãƒãƒ¼ãƒˆ',0),(566924,15748,'pt','RelatÃ³rios arquivados',0),(566925,15748,'ru','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹',0),(566926,15748,'es','Informes archivados',0),(566927,15748,'de','Archivierte Berichte',0),(566928,15748,'en','Archived Reports',0),(566929,15749,'is','',0),(566930,15749,'dr','Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(566931,15749,'pr','Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ù…Ø§Ù‡Ø§Ù†Ù‡',0),(566932,15749,'tr','AylÄ±k ArÅŸiv',0),(566933,15749,'pl','Archiwum MiesiÄ™czne',0),(566934,15749,'bg','ÐœÐµÑÐµÑ‡ÐµÐ½ Ð°Ñ€Ñ…Ð¸Ð²',0),(566935,15749,'ur','Ù…Ø§ÛØ§Ù†Û Ù…Ø­ÙÙˆØ¸ Ø´Ø¯Û Ø¯Ø³ØªØ§ÙˆÙŠØ²Ø§Øª',0),(566936,15749,'sr','ÐÑ€Ñ…Ð¸Ð²Ð° Ð¼Ñ˜ÐµÑÐµÑ‡Ð½Ð¾',0),(566937,15749,'vi','LÆ°u trá»¯ hÃ ng thÃ¡ng',0),(566938,15749,'af','Maandelikse argief',0),(566939,15749,'ro','Arhiva lunar',0),(566940,15749,'et','Arhiiv kuu',0),(566941,15749,'si','Arhiv meseÄna',0),(566942,15749,'ba','Arsip bulanan',0),(566943,15749,'nl','Maandelijks Archief',0),(566944,15749,'fi','Arkisto kuukausittain',0),(566945,15749,'no','Arkiv mÃ¥nedlig',0),(566946,15749,'da','Arkiv mÃ¥nedligt',0),(566947,15749,'ko','ì›”ë³„ ì•„ì¹´ì´ë¸Œ',0),(566948,15749,'he','××¨×›×™×•×Ÿ ×—×•×“×©×™',0),(566949,15749,'el','ÎœÎ·Î½Î¹Î±Î¯Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(566950,15749,'zh','æ¯æœˆçš„å­˜æ¡£',0),(566951,15749,'sv','Arkiv varje mÃ¥nad',0),(566952,15749,'it','Archivio mensile',0),(566953,15749,'tl','',0),(566954,15749,'th','à¹€à¸à¹‡à¸šà¸£à¸²à¸¢à¹€à¸”à¸·à¸­à¸™',0),(566955,15749,'hi','à¤®à¤¾à¤¸à¤¿à¤• à¤ªà¥à¤°à¤¾à¤²à¥‡à¤–',0),(566956,15749,'ms','Arkib bulanan',0),(566957,15749,'ar','Ø§Ù„Ø£Ø±Ø´ÙŠÙ Ø§Ù„Ø´Ù‡Ø±ÙŠ',0),(566958,15749,'fr','Archives mensuelles',0),(566959,15749,'jp','æ¯Žæœˆã®ã‚¢ãƒ¼ã‚«ã‚¤ãƒ–',0),(566960,15749,'pt','Arquivo mensal',0),(566961,15749,'ru','Ð•Ð¶ÐµÐ¼ÐµÑÑÑ‡Ð½Ð¾ ÐÑ€Ñ…Ð¸Ð²',0),(566962,15749,'es','Archivo mensual',0),(566963,15749,'de','Archiv monatlich',0),(566964,15749,'en','Archive Monthly',0),(566965,15750,'is','',0),(566966,15750,'dr','Ø¢Ø±Ø´ÛŒÙˆ',0),(566967,15750,'pr','Ø¢Ø±Ø´ÛŒÙˆ',0),(566968,15750,'tr','Åžimdi arÅŸiv',0),(566969,15750,'pl','Archiwum teraz',0),(566970,15750,'bg','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð¹ ÑÐµÐ³Ð°',0),(566971,15750,'ur','Ø§Ø¨ Ù…Ø­ÙÙˆØ¸ Ø´Ø¯Û Ø¯Ø³ØªØ§ÙˆÙŠØ²Ø§Øª',0),(566972,15750,'sr','ÐÑ€Ñ…Ð¸Ð²Ð° ÑÐ°Ð´Ð°',0),(566973,15750,'vi','LÆ°u trá»¯ bÃ¢y giá»',0),(566974,15750,'af','Argief nou',0),(566975,15750,'ro','Arhiva acum',0),(566976,15750,'et','Arhiiv nÃ¼Ã¼d',0),(566977,15750,'si','Arhiv zdaj',0),(566978,15750,'ba','Arsip sekarang',0),(566979,15750,'nl','Archief nu',0),(566980,15750,'fi','Arkisto nyt',0),(566981,15750,'no','Arkiv nÃ¥',0),(566982,15750,'da','Arkiv nu',0),(566983,15750,'ko','ì§€ê¸ˆ ë³´ê´€',0),(566984,15750,'he','××¨×›×™×•×Ÿ ×¢×›×©×™×•',0),(566985,15750,'el','Î¤Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï„ÏŽÏÎ±',0),(566986,15750,'zh','çŽ°åœ¨å­˜æ¡£',0),(566987,15750,'sv','Arkiv nu',0),(566988,15750,'it','Archivio ora',0),(566989,15750,'tl','',0),(566990,15750,'th','à¹€à¸à¹‡à¸šà¸•à¸­à¸™à¸™à¸µà¹‰',0),(566991,15750,'hi','à¤…à¤¬ à¤ªà¥à¤°à¤¾à¤²à¥‡à¤–',0),(566992,15750,'ms','Arkib sekarang',0),(566993,15750,'ar','Ø£Ø±Ø´ÙŠÙ Ø§Ù„Ø¢Ù†',0),(566994,15750,'fr','Maintenant les Archives',0),(566995,15750,'jp','ä»Šã™ããƒãƒƒã‚¯ã‚¢ãƒƒãƒ—ã—ã¾ã™ã€‚',0),(566996,15750,'pt','Arquivo agora',0),(566997,15750,'ru','ÐÑ€Ñ…Ð¸Ð² Ñ‚ÐµÐ¿ÐµÑ€ÑŒ',0),(566998,15750,'es','Archivo ahora',0),(566999,15750,'de','Jetzt Archiv',0),(567000,15750,'en','Archive Now',0),(567001,15751,'is','',0),(567002,15751,'dr','Ù…Ø±ÙˆØ± Ú¯Ø²Ø§Ø±Ø´ Ù‡Ø§ÛŒ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø´Ø¯Ù‡',0),(567003,15751,'pr','Ù…Ø±ÙˆØ± Ú¯Ø²Ø§Ø±Ø´ Ù‡Ø§ÛŒ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø´Ø¯Ù‡',0),(567004,15751,'tr','ArÅŸivlenmiÅŸ raporlarÄ± gÃ¶zden geÃ§irin',0),(567005,15751,'pl','PrzeglÄ…d raportÃ³w archiwalnych',0),(567006,15751,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(567007,15751,'ur','Ø¬Ù…Ø¹ Ø´Ø¯Û Ø±Ù¾ÙˆØ±Ù¹ÙˆÚº Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(567008,15751,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜Ð¸',0),(567009,15751,'vi','Xem xÃ©t bÃ¡o cÃ¡o lÆ°u trá»¯',0),(567010,15751,'af','Geargiveerde verslae hersien',0),(567011,15751,'ro','Rapoarte arhivate de revizuire',0),(567012,15751,'et','Arhiivitud aruannete lÃ¤bivaatamine',0),(567013,15751,'si','Pregled arhiviranih poroÄil',0),(567014,15751,'ba','Meninjau laporan Arsip',0),(567015,15751,'nl','Gearchiveerde rapporten bekijken',0),(567016,15751,'fi','Arvostelu arkistoidut raportit',0),(567017,15751,'no','Se arkiverte rapporter',0),(567018,15751,'da','Anmeld arkiverede rapporter',0),(567019,15751,'ko','ë³´ê´€ ëœ ë³´ê³ ì„œë¥¼ ê²€í† ',0),(567020,15751,'he','×¡×§×™×¨×” ×‘××¨×›×™×•×Ÿ ×“×•×—×•×ª',0),(567021,15751,'el','Î‘ÏÏ‡ÎµÎ¹Î¿Î¸ÎµÏ„Î·Î¼Î­Î½ÎµÏ‚ ÎµÎºÎ¸Î­ÏƒÎµÎ¹Ï‚ Î±Î½Î±ÏƒÎºÏŒÏ€Î·ÏƒÎ·Ï‚',0),(567022,15751,'zh','æŸ¥çœ‹å­˜æ¡£çš„æŠ¥å‘Š',0),(567023,15751,'sv','Granska arkiverade rapporter',0),(567024,15751,'it','Scrivi una recensione su report archiviati',0),(567025,15751,'tl','',0),(567026,15751,'th','à¸£à¸µà¸§à¸´à¸§à¹€à¸à¹‡à¸šà¸£à¸²à¸¢à¸‡à¸²à¸™',0),(567027,15751,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹à¥€à¤¤ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿà¥à¤¸ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¥‡à¤‚',0),(567028,15751,'ms','Meneliti laporan-laporan Arkib',0),(567029,15751,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶ Ø§Ù„ØªÙ‚Ø§Ø±ÙŠØ± Ø§Ù„Ù…Ø­ÙÙˆØ¸Ø©',0),(567030,15751,'fr','Examiner les rapports archivÃ©s',0),(567031,15751,'jp','ã‚¢ãƒ¼ã‚«ã‚¤ãƒ–ã•ã‚ŒãŸãƒ¬ãƒãƒ¼ãƒˆã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(567032,15751,'pt','Rever relatÃ³rios arquivados',0),(567033,15751,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð°Ñ€Ñ…Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚Ñ‹',0),(567034,15751,'es','Revisar los informes archivados',0),(567035,15751,'de','Lesen Sie archivierte Berichte',0),(567036,15751,'en','Review Archived Reports',0),(567037,15752,'is','',0),(567038,15752,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ú¯Ø°Ø´ØªÙ‡',0),(567039,15752,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ú¯Ø°Ø´ØªÙ‡',0),(567040,15752,'tr','GecikmiÅŸ hesaplarÄ±',0),(567041,15752,'pl','ZalegÅ‚e rachunki',0),(567042,15752,'bg','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(567043,15752,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ù…ÙˆØ®Ø±',0),(567044,15752,'sr','ÐÐ°Ð»Ð¾Ð·Ð¸ ÑÐ° Ð¿Ñ€ÐµÐºÐ¾Ñ€Ð°Ñ‡ÐµÐ½Ð¸Ð¼ Ñ€Ð¾ÐºÐ¾Ð¼',0),(567045,15752,'vi','TÃ i khoáº£n quÃ¡ háº¡n',0),(567046,15752,'af','Agterstallige rekeninge',0),(567047,15752,'ro','Conturi scadente',0),(567048,15752,'et','TÃ¤htaja Ã¼letanud kontod',0),(567049,15752,'si','Izkaze, zapadle',0),(567050,15752,'ba','Account tertunda',0),(567051,15752,'nl','Achterstallige accounts',0),(567052,15752,'fi','Osuus myÃ¶hÃ¤ssÃ¤',0),(567053,15752,'no','Kontoer som er forfalt',0),(567054,15752,'da','Konti forfaldne',0),(567055,15752,'ko','ì—°ì²´ ê³„ì •',0),(567056,15752,'he','×—×©×‘×•× ×•×ª ×©×¤×¨×¢×•× ×Ÿ ×—×œ×£',0),(567057,15752,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î»Î·Î¾Î¹Ï€ÏÏŒÎ¸ÎµÏƒÎ¼Ï‰Î½',0),(567058,15752,'zh','å¸æˆ·è¿‡æœŸ',0),(567059,15752,'sv','FÃ¶rfallna konton',0),(567060,15752,'it','Account scaduti',0),(567061,15752,'tl','',0),(567062,15752,'th','à¸šà¸±à¸à¸Šà¸µà¸—à¸µà¹ˆà¹€à¸à¸´à¸™à¸à¸³à¸«à¸™à¸”',0),(567063,15752,'hi','à¤…à¤¤à¤¿à¤¦à¥‡à¤¯ à¤–à¤¾à¤¤à¥‹à¤‚',0),(567064,15752,'ms','Akaun lampau tempoh',0),(567065,15752,'ar','Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(567066,15752,'fr','Comptes en souffrance',0),(567067,15752,'jp','æœŸé™åˆ‡ã‚Œã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(567068,15752,'pt','Contas em atraso',0),(567069,15752,'ru','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(567070,15752,'es','Cuentas atrasadas',0),(567071,15752,'de','FÃ¤llige Konten',0),(567072,15752,'en','Accounts Overdue',0),(567073,15753,'is','',0),(567074,15753,'dr','Chargeback Ú©Ø¯',0),(567075,15753,'pr','Chargeback Ú©Ø¯',0),(567076,15753,'tr','Ters ibraz kodu',0),(567077,15753,'pl','Kod Chargeback',0),(567078,15753,'bg','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ ÐºÐ¾Ð´',0),(567079,15753,'ur','Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ú©ÙˆÚˆ',0),(567080,15753,'sr','Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº Ð¨Ð¸Ñ„Ñ€Ð°',0),(567081,15753,'vi','MÃ£ sá»‘ tiá»n chiáº¿t kháº¥u',0),(567082,15753,'af','Chargeback kode',0),(567083,15753,'ro','Codul de chargeback',0),(567084,15753,'et','SissenÃµudmine kood',0),(567085,15753,'si','PoraÄuna kodo',0),(567086,15753,'ba','Chargeback Kode',0),(567087,15753,'nl','Chargeback Code',0),(567088,15753,'fi','Chargeback koodi',0),(567089,15753,'no','TilbakefÃ¸ring kode',0),(567090,15753,'da','TilbagefÃ¸rslen kode',0),(567091,15753,'ko','í™˜ë¶ˆ ì½”ë“œ',0),(567092,15753,'he','×§×•×“ ×”×—×™×•×‘',0),(567093,15753,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ chargeback',0),(567094,15753,'zh','è®¡è´¹ä»£ç ',0),(567095,15753,'sv','Chargeback kod',0),(567096,15753,'it','Codice di chargeback',0),(567097,15753,'tl','',0),(567098,15753,'th','à¸£à¸«à¸±à¸ªà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(567099,15753,'hi','à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤•à¥‹à¤¡',0),(567100,15753,'ms','Kod caj semula',0),(567101,15753,'ar','Ø±Ù…Ø² ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(567102,15753,'fr','Code de Chargeback',0),(567103,15753,'jp','ãƒãƒ£ãƒ¼ã‚¸ ã‚³ãƒ¼ãƒ‰',0),(567104,15753,'pt','CÃ³digo de chargeback',0),(567105,15753,'ru','ÐšÐ¾Ð´ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(567106,15753,'es','CÃ³digo de cargo al usuario',0),(567107,15753,'de','Chargeback-Code',0),(567108,15753,'en','Chargeback Code',0),(567109,15754,'is','',0),(567110,15754,'dr','Ú©Ø¯Ù‡Ø§ÛŒ Chargeback',0),(567111,15754,'pr','Ú©Ø¯Ù‡Ø§ÛŒ Chargeback',0),(567112,15754,'tr','Ters ibraz kodlarÄ±',0),(567113,15754,'pl','Kody zwrotne',0),(567114,15754,'bg','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ ÐºÐ¾Ð´Ð¾Ð²Ðµ',0),(567115,15754,'ur','Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ú©ÙˆÚˆ',0),(567116,15754,'sr','Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº ÑˆÐ¸Ñ„Ñ€Ðµ',0),(567117,15754,'vi','MÃ£ sá»‘ tiá»n chiáº¿t kháº¥u',0),(567118,15754,'af','Chargeback kodes',0),(567119,15754,'ro','Chargeback coduri',0),(567120,15754,'et','SissenÃµudmine koodid',0),(567121,15754,'si','PoraÄuna kode',0),(567122,15754,'ba','Chargeback Kode',0),(567123,15754,'nl','Terugboeking Codes',0),(567124,15754,'fi','Chargeback koodit',0),(567125,15754,'no','TilbakefÃ¸ring koder',0),(567126,15754,'da','TilbagefÃ¸rslen koder',0),(567127,15754,'ko','í™˜ë¶ˆ ì½”ë“œ',0),(567128,15754,'he','×”×—×™×•×‘ ×§×•×“×™×',0),(567129,15754,'el','Chargeback ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚',0),(567130,15754,'zh','è®¡è´¹ä»£ç ',0),(567131,15754,'sv','Chargeback koder',0),(567132,15754,'it','Codici di chargeback',0),(567133,15754,'tl','',0),(567134,15754,'th','à¸£à¸«à¸±à¸ªà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(567135,15754,'hi','à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤•à¥‹à¤¡à¥à¤¸',0),(567136,15754,'ms','Kod caj semula',0),(567137,15754,'ar','Ø±Ù…ÙˆØ² ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(567138,15754,'fr','Codes de Chargeback',0),(567139,15754,'jp','ãƒãƒ£ãƒ¼ã‚¸ ã‚³ãƒ¼ãƒ‰',0),(567140,15754,'pt','CÃ³digos de chargeback',0),(567141,15754,'ru','ÐšÐ¾Ð´Ñ‹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(567142,15754,'es','CÃ³digos de devoluciÃ³n de cargo',0),(567143,15754,'de','Chargeback-Codes',0),(567144,15754,'en','Chargeback Codes',0),(567145,15755,'is','',0),(567146,15755,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡',0),(567147,15755,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù‡',0),(567148,15755,'tr','KapalÄ± hesap',0),(567149,15755,'pl','Konto zostaÅ‚o zamkniÄ™te',0),(567150,15755,'bg','Ð’Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸',0),(567151,15755,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(567152,15755,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(567153,15755,'vi','TÃ i khoáº£n Ä‘Ã³ng cá»­a',0),(567154,15755,'af','Rekening gesluit',0),(567155,15755,'ro','Cont Ã®nchis',0),(567156,15755,'et','Konto sulgeda',0),(567157,15755,'si','RaÄun zaprt',0),(567158,15755,'ba','Akun yang ditutup',0),(567159,15755,'nl','Account gesloten',0),(567160,15755,'fi','Tilin sulkeminen',0),(567161,15755,'no','Konto stengt',0),(567162,15755,'da','Konto lukket',0),(567163,15755,'ko','ê³„ì • íì‡„',0),(567164,15755,'he','×—×©×‘×•×Ÿ ×¡×’×•×¨',0),(567165,15755,'el','ÎŸ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î­ÎºÎ»ÎµÎ¹ÏƒÎµ',0),(567166,15755,'zh','å…³é—­å¸æˆ·',0),(567167,15755,'sv','Konto stÃ¤ngt',0),(567168,15755,'it','Account chiuso',0),(567169,15755,'tl','',0),(567170,15755,'th','à¸šà¸±à¸à¸Šà¸µà¸—à¸µà¹ˆà¸›à¸´à¸”',0),(567171,15755,'hi','à¤–à¤¾à¤¤à¤¾ à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(567172,15755,'ms','Akaun ditutup',0),(567173,15755,'ar','Ø¥ØºÙ„Ø§Ù‚ Ø­Ø³Ø§Ø¨',0),(567174,15755,'fr','Compte fermÃ©',0),(567175,15755,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’é–‰éŽ–',0),(567176,15755,'pt','Conta encerrada',0),(567177,15755,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð°',0),(567178,15755,'es','Cuenta cerrada',0),(567179,15755,'de','Konto geschlossen',0),(567180,15755,'en','Account Closed',0),(567181,15756,'is','',0),(567182,15756,'dr','Ø§Ø¹ØªØ¨Ø§Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¯Ø± ÙØ§ÛŒÙ„',0),(567183,15756,'pr','Ø§Ø¹ØªØ¨Ø§Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¯Ø± ÙØ§ÛŒÙ„',0),(567184,15756,'tr','Kredi baÅŸvurusu dosya',0),(567185,15756,'pl','Wniosek o kredyt na plik',0),(567186,15756,'bg','ÐœÐ¾Ð»Ð±Ð° Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(567187,15756,'ur','Ù…Ø³Ù„ Ù¾Ø± Ú©Ø±ÛŒÚˆÙ¹ Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù†',0),(567188,15756,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ñƒ Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(567189,15756,'vi','TÃ­n dá»¥ng á»©ng dá»¥ng trÃªn táº­p tin',0),(567190,15756,'af','Krediet aansoek op lÃªer',0),(567191,15756,'ro','Cererea de credit pe fiÅŸier',0),(567192,15756,'et','Krediidi taotlus faili',0),(567193,15756,'si','Vloga za kredit na datoteko',0),(567194,15756,'ba','Aplikasi kredit pada File',0),(567195,15756,'nl','Kredietaanvraag op bestand',0),(567196,15756,'fi','Luottohakemuksen tiedosto',0),(567197,15756,'no','KredittsÃ¸knad fil',0),(567198,15756,'da','KreditansÃ¸gning pÃ¥ fil',0),(567199,15756,'ko','íŒŒì¼ì— ì‹ ìš© ì‘ìš© í”„ë¡œê·¸ëž¨',0),(567200,15756,'he','×‘×§×©×ª ××©×¨××™ ×¢×œ ×§×•×‘×¥',0),(567201,15756,'el','Î‘Î¯Ï„Î·ÏƒÎ· Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚ ÏƒÎµ Î±ÏÏ‡ÎµÎ¯Î¿',0),(567202,15756,'zh','ä¿¡ç”¨åœ¨æ–‡ä»¶ä¸­çš„åº”ç”¨',0),(567203,15756,'sv','KreditansÃ¶kan pÃ¥ fil',0),(567204,15756,'it','Domanda di credito su File',0),(567205,15756,'tl','',0),(567206,15756,'th','à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¸šà¸™à¹à¸Ÿà¹‰à¸¡',0),(567207,15756,'hi','à¤«à¤¾à¤‡à¤² à¤ªà¤° à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤†à¤µà¥‡à¤¦à¤¨',0),(567208,15756,'ms','Permohonan kredit dalam fail',0),(567209,15756,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ÙÙŠ Ø§Ù„Ù…Ù„Ù',0),(567210,15756,'fr','Demande de crÃ©dit au dossier',0),(567211,15756,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(567212,15756,'pt','Pedido de crÃ©dito em arquivo',0),(567213,15756,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ Ð·Ð°ÑÐ²ÐºÐ° Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(567214,15756,'es','Solicitud de crÃ©dito en el archivo',0),(567215,15756,'de','Kredit-Antrag auf Datei',0),(567216,15756,'en','Credit Application On File',0),(567217,15757,'is','',0),(567218,15757,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ú¯Ø²Ø§Ø±ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±',0),(567219,15757,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø¨Ø±Ú¯Ø²Ø§Ø±ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±',0),(567220,15757,'tr','Kredi tutun raporu',0),(567221,15757,'pl','Raport kredytowy Hold',0),(567222,15757,'bg','Ð—Ð°Ð´Ñ€ÑŠÐ¶Ñ‚Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´ ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(567223,15757,'ur','ÛÙˆÙ„Úˆ Ú©ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ø±Ù¾ÙˆØ±Ù¹',0),(567224,15757,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ ÑÐ°Ð´Ñ€Ð¶Ðµ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ Ð¾',0),(567225,15757,'vi','BÃ¡o cÃ¡o tá»• chá»©c tÃ­n dá»¥ng',0),(567226,15757,'af','Krediet hou verslag',0),(567227,15757,'ro','Raport de Hold credit',0),(567228,15757,'et','Hoidke taustinfo',0),(567229,15757,'si','Kreditne poroÄilo o zadrÅ¾anju',0),(567230,15757,'ba','Laporan terus kredit',0),(567231,15757,'nl','Kredietrapport Hold',0),(567232,15757,'fi','PidÃ¤ luottotietoja',0),(567233,15757,'no','Kreditt Hold-rapporten',0),(567234,15757,'da','Kredit Hold rapport',0),(567235,15757,'ko','ì‹ ìš© ë³´ë¥˜ ë³´ê³ ì„œ',0),(567236,15757,'he','×“×•×— ×—×¡×™×ž×” ××©×¨××™',0),(567237,15757,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® Î­ÎºÎ¸ÎµÏƒÎ® ÏƒÎ±Ï‚ ÎºÏÎ±Ï„Î®ÏƒÏ„Îµ',0),(567238,15757,'zh','æŒæœ‰çš„ä¿¡ç”¨æŠ¥å‘Š',0),(567239,15757,'sv','HÃ¥ll kreditupplysning',0),(567240,15757,'it','Rapporto di credito',0),(567241,15757,'tl','',0),(567242,15757,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸«à¸™à¸µà¹‰à¸„à¹‰à¸²à¸‡',0),(567243,15757,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¹à¥‹à¤²à¥à¤¡ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(567244,15757,'ms','Laporan penahanan kredit',0),(567245,15757,'ar','ØªÙ‚Ø±ÙŠØ± Ø¹Ù‚Ø¯ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(567246,15757,'fr','Rapport de crÃ©dit Hold',0),(567247,15757,'jp','ä¿ç•™ãƒ¬ãƒãƒ¼ãƒˆã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ',0),(567248,15757,'pt','RelatÃ³rio de controle de crÃ©dito',0),(567249,15757,'ru','Ð”Ð¾ÐºÐ»Ð°Ð´ Ð¿Ð¾ Ð´Ð¾Ð»Ð³Ð¾Ð²Ñ‹Ð¼T Hold',0),(567250,15757,'es','Informe de retenciÃ³n de crÃ©dito',0),(567251,15757,'de','Kreditauskunft halten',0),(567252,15757,'en','Credit Hold Report',0),(567253,15758,'is','',0),(567254,15758,'dr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø´ØªØ±Ú©ÛŒÙ† Ù…Ø­Ø¯ÙˆØ¯',0),(567255,15758,'pr','Ú¯Ø²Ø§Ø±Ø´ Ù…Ø´ØªØ±Ú©ÛŒÙ† Ù…Ø­Ø¯ÙˆØ¯',0),(567256,15758,'tr','MÃ¼ÅŸteri kredi sÄ±nÄ±rÄ± raporu',0),(567257,15758,'pl','Raport Limit kredytu odbiorcy',0),(567258,15758,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚ÐµÐ½ Ð»Ð¸Ð¼Ð¸Ñ‚ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(567259,15758,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ø­Ø¯ Ú©ÛŒ Ø±Ù¾ÙˆØ±Ù¹',0),(567260,15758,'sr','ÐšÑƒÐ¿Ð°Ñ† ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¸ Ð›Ð¸Ð¼Ð¸Ñ‚ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(567261,15758,'vi','BÃ¡o cÃ¡o giá»›i háº¡n tÃ­n dá»¥ng cá»§a khÃ¡ch hÃ ng',0),(567262,15758,'af','KliÃ«nt krediet limiet verslag',0),(567263,15758,'ro','Raport de limita de Credit client',0),(567264,15758,'et','Kliendile krediidi limiit aruanne',0),(567265,15758,'si','Kupca kreditni Limit poroÄilo',0),(567266,15758,'ba','Laporan batas kredit pelanggan',0),(567267,15758,'nl','Rapport van de limiet van het krediet van de klant',0),(567268,15758,'fi','Asiakkaan luottoraja-raportti',0),(567269,15758,'no','Kunden kreditt grense rapport',0),(567270,15758,'da','Kunde Credit Limit rapport',0),(567271,15758,'ko','ê³ ê°ì˜ ì‹ ìš© í•œë„ ë³´ê³ ì„œ',0),(567272,15758,'he','×“×• ×— ×ž×’×‘×œ×ª ×”××©×¨××™ ×œ×œ×§×•×—',0),(567273,15758,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ Ï€ÎµÎ»Î¬Ï„Î· Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ ÏŒÏÎ¹Î¿',0),(567274,15758,'zh','å®¢æˆ·ä¿¡ç”¨é¢åº¦æŠ¥å‘Š',0),(567275,15758,'sv','Kundens Limit kreditupplysning',0),(567276,15758,'it','Report di limite di credito cliente',0),(567277,15758,'tl','',0),(567278,15758,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸§à¸‡à¹€à¸‡à¸´à¸™à¹€à¸„à¸£à¸”à¸´à¸•à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(567279,15758,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¸à¥€à¤®à¤¾ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(567280,15758,'ms','Laporan had kredit pelanggan',0),(567281,15758,'ar','ØªÙ‚Ø±ÙŠØ± Ø­Ø¯ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„Ø®Ø§Øµ Ø¨Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(567282,15758,'fr','Rapport de limite de crÃ©dit client',0),(567283,15758,'jp','é¡§å®¢ã®ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆåˆ¶é™ãƒ¬ãƒãƒ¼ãƒˆ',0),(567284,15758,'pt','RelatÃ³rio de limite de crÃ©dito do cliente',0),(567285,15758,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¹ Ð»Ð¸Ð¼Ð¸Ñ‚ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(567286,15758,'es','Informe de lÃ­mite de crÃ©dito de cliente',0),(567287,15758,'de','Kundenbericht Credit Limit',0),(567288,15758,'en','Customer Credit Limit Report',0),(567289,15759,'is','',0),(567290,15759,'dr','Ù…Ø´ØªØ±ÛŒ Prelimable',0),(567291,15759,'pr','Ù…Ø´ØªØ±ÛŒ Prelimable',0),(567292,15759,'tr','MÃ¼ÅŸteri Prelimable',0),(567293,15759,'pl','Klienta Prelimable',0),(567294,15759,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Prelimable',0),(567295,15759,'ur','Ú©Ø³Ù¹Ù…Ø± Ù¾Ø±ÛŒÙ„Ø§Ù…Ø§Ø¨Ù„ÛŒ',0),(567296,15759,'sr','ÐšÑƒÐ¿Ð°Ñ† ÐŸÑ€ÐµÐ»Ð¸Ð¼Ð°Ð±Ð»Ðµ',0),(567297,15759,'vi','KhÃ¡ch hÃ ng Prelimable',0),(567298,15759,'af','KliÃ«nt Prelimable',0),(567299,15759,'ro','Client Prelimable',0),(567300,15759,'et','Kliendi Prelimable',0),(567301,15759,'si','Stranka Prelimable',0),(567302,15759,'ba','Pelanggan Prelimable',0),(567303,15759,'nl','Klant Prelimable',0),(567304,15759,'fi','Asiakkaan Prelimable',0),(567305,15759,'no','Kunde Prelimable',0),(567306,15759,'da','Kunde Prelimable',0),(567307,15759,'ko','Prelimable ê³ ê°',0),(567308,15759,'he','×œ×§×•×—×•×ª Prelimable',0),(567309,15759,'el','Prelimable Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(567310,15759,'zh','å®¢æˆ· Prelimable',0),(567311,15759,'sv','Kund Prelimable',0),(567312,15759,'it','Cliente Prelimable',0),(567313,15759,'tl','',0),(567314,15759,'th','à¸¥à¸¹à¸à¸„à¹‰à¸² Prelimable',0),(567315,15759,'hi','Prelimable à¤—à¥à¤°à¤¾à¤¹à¤•',0),(567316,15759,'ms','Baca Prelimable',0),(567317,15759,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø¨Ø±ÙŠÙ„ÙŠÙ…Ø§Ø¨Ù„',0),(567318,15759,'fr','Client Prelimable',0),(567319,15759,'jp','é¡§å®¢ Prelimable',0),(567320,15759,'pt','Cliente Prelimable',0),(567321,15759,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Prelimable',0),(567322,15759,'es','Cliente Prelimable',0),(567323,15759,'de','Kunden Prelimable',0),(567324,15759,'en','Customer Prelimable',0),(567325,15760,'is','',0),(567326,15760,'dr','ØªØ§Ø±ÛŒØ® Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù†',0),(567327,15760,'pr','ØªØ§Ø±ÛŒØ® Ø¨Ø³ØªÙ‡ Ø´Ø¯Ù†',0),(567328,15760,'tr','KapanÄ±ÅŸ tarihi',0),(567329,15760,'pl','Data zakoÅ„czenia',0),(567330,15760,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(567331,15760,'ur','ØªØ§Ø±ÛŒØ® Ú©ÛŒ Ø¨Ù†Ø¯',0),(567332,15760,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐ°',0),(567333,15760,'vi','NgÃ y Ä‘Ã³ng cá»­a',0),(567334,15760,'af','Datum gesluit',0),(567335,15760,'ro','Data Ã®nchisÄƒ',0),(567336,15760,'et','KuupÃ¤ev suletud',0),(567337,15760,'si','Datum zaprtja',0),(567338,15760,'ba','Tanggal tutup',0),(567339,15760,'nl','Afsluitdatum',0),(567340,15760,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤, suljettu',0),(567341,15760,'no','Lukkingsdatoen',0),(567342,15760,'da','Dato, lukket',0),(567343,15760,'ko','ë§ˆê° ë‚ ì§œ',0),(567344,15760,'he','×ª××¨×™×š ×¡×’×•×¨',0),(567345,15760,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ»ÎµÎ¹ÏƒÎ¯Î¼Î±Ï„Î¿Ï‚',0),(567346,15760,'zh','å…³é—­æ—¥æœŸ',0),(567347,15760,'sv','Datum stÃ¤ngd',0),(567348,15760,'it','Data di chiusura',0),(567349,15760,'tl','',0),(567350,15760,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸›à¸´à¸”',0),(567351,15760,'hi','à¤¬à¤‚à¤¦ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(567352,15760,'ms','Tarikh ditutup',0),(567353,15760,'ar','ØªØ§Ø±ÙŠØ® Ø¥ØºÙ„Ø§Ù‚',0),(567354,15760,'fr','Date de fermeture',0),(567355,15760,'jp','çµ‚äº†æ—¥',0),(567356,15760,'pt','Data fechada',0),(567357,15760,'ru','Ð”Ð°Ñ‚Ð° Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¸Ñ',0),(567358,15760,'es','Fecha de cierre',0),(567359,15760,'de','Datum geschlossen',0),(567360,15760,'en','Date Closed',0),(567361,15761,'is','',0),(567362,15761,'dr','ØªØ§Ø±ÛŒØ® Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø±',0),(567363,15761,'pr','ØªØ§Ø±ÛŒØ® Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø±',0),(567364,15761,'tr','AyrÄ± tutmadaki tarihi',0),(567365,15761,'pl','Data zawieszone',0),(567366,15761,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ',0),(567367,15761,'ur','ÛÙˆÙ„Úˆ Ù¾Ø± ØªØ§Ø±ÛŒØ®',0),(567368,15761,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(567369,15761,'vi','NgÃ y táº¡m dá»«ng',0),(567370,15761,'af','Datum op hou',0),(567371,15761,'ro','Data pe \"hold\"',0),(567372,15761,'et','KuupÃ¤eva ootele',0),(567373,15761,'si','Datum na Äakanju',0),(567374,15761,'ba','Tanggal ditahan',0),(567375,15761,'nl','Datum in de wachtstand',0),(567376,15761,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ pitoon',0),(567377,15761,'no','Datoen pÃ¥ vent',0),(567378,15761,'da','Dato pÃ¥ Hold',0),(567379,15761,'ko','ì— ë‚ ì§œ',0),(567380,15761,'he','×ª××¨×™×š ×‘×”×ž×ª× ×”',0),(567381,15761,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÏƒÎµ Î±Î½Î±Î¼Î¿Î½Î®',0),(567382,15761,'zh','æç½®çš„æ—¥æœŸ',0),(567383,15761,'sv','Datum pÃ¥ is',0),(567384,15761,'it','Data in attesa',0),(567385,15761,'tl','',0),(567386,15761,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸„à¸‡à¸„à¹‰à¸²à¸‡',0),(567387,15761,'hi','à¤¹à¥‹à¤²à¥à¤¡ à¤ªà¤° à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(567388,15761,'ms','Tarikh penahanan',0),(567389,15761,'ar','Ø­ØªÙ‰ Ø§Ù„Ø¢Ù† Ø¨Ø´Ø£Ù† Ø¹Ù‚Ø¯',0),(567390,15761,'fr','Date en attente',0),(567391,15761,'jp','é–‹å‚¬æ—¥',0),(567392,15761,'pt','Data em espera',0),(567393,15761,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð° ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ð¸',0),(567394,15761,'es','Fecha en espera',0),(567395,15761,'de','Datum zurÃ¼ckgestellt',0),(567396,15761,'en','Date On Hold',0),(567397,15762,'is','',0),(567398,15762,'dr','ØªØ§Ø±ÛŒØ® Ø®Ø±ÛŒØ¯ Ùˆ ÙØ±ÙˆØ´',0),(567399,15762,'pr','ØªØ§Ø±ÛŒØ® Ø®Ø±ÛŒØ¯ Ùˆ ÙØ±ÙˆØ´',0),(567400,15762,'tr','Ä°lk satÄ±ÅŸ tarihi',0),(567401,15762,'pl','Pierwsza data sprzedaÅ¼y',0),(567402,15762,'bg','ÐŸÑŠÑ€Ð²Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(567403,15762,'ur','Ø³ÛŒÙ„Ø² Ú©ÛŒ Ù¾ÛÙ„ÛŒ ØªØ§Ø±ÛŒØ®',0),(567404,15762,'sr','ÐŸÑ€Ð²Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ',0),(567405,15762,'vi','NgÃ y Ä‘áº§u tiÃªn bÃ¡n hÃ ng',0),(567406,15762,'af','Eerste verkope datum',0),(567407,15762,'ro','Data primei vÃ¢nzÄƒri',0),(567408,15762,'et','Esimene mÃ¼Ã¼gikuupÃ¤ev',0),(567409,15762,'si','Prvi dan prodaje',0),(567410,15762,'ba','Pertama tanggal penjualan',0),(567411,15762,'nl','Datum van de eerste verkoop',0),(567412,15762,'fi','EnsimmÃ¤inen myynti pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(567413,15762,'no','FÃ¸rste salg dato',0),(567414,15762,'da','FÃ¸rste salg dato',0),(567415,15762,'ko','ì²« ë²ˆì§¸ íŒë§¤ ë‚ ì§œ',0),(567416,15762,'he','×ª××¨×™×š ×”×ž×›×™×¨×” ×”×¨××©×•× ×”',0),(567417,15762,'el','Î ÏÏŽÏ„Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(567418,15762,'zh','ç¬¬ä¸€æ¬¡é”€å”®æ—¥æœŸ',0),(567419,15762,'sv','FÃ¶rsta FÃ¶rsÃ¤ljningsdatum',0),(567420,15762,'it','Prima data di vendita',0),(567421,15762,'tl','',0),(567422,15762,'th','à¸§à¸±à¸™à¹à¸£à¸à¸‚à¸²à¸¢',0),(567423,15762,'hi','à¤ªà¤¹à¤²à¥€ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(567424,15762,'ms','Tarikh jualan pertama',0),(567425,15762,'ar','Ø£ÙˆÙ„ ØªØ§Ø±ÙŠØ® Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(567426,15762,'fr','PremiÃ¨re Date de vente',0),(567427,15762,'jp','æœ€åˆã®è²©å£²æ—¥',0),(567428,15762,'pt','Primeiro encontro de vendas',0),(567429,15762,'ru','ÐŸÐµÑ€Ð²Ð°Ñ Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(567430,15762,'es','Primer dÃ­a de ventas',0),(567431,15762,'de','Erstes Verkaufsdatum',0),(567432,15762,'en','First Sales Date',0),(567433,15763,'is','',0),(567434,15763,'dr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ØªÙ…Ø§Ø³',0),(567435,15763,'pr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ØªÙ…Ø§Ø³',0),(567436,15763,'tr','KiÅŸinin son tarihi',0),(567437,15763,'pl','Data ostatniego kontaktu',0),(567438,15763,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(567439,15763,'ur','Ø±Ø§Ø¨Ø·Û ÙØ±Ø¯ Ú©ÛŒ Ø¢Ø®Ø±ÛŒ ØªØ§Ø±ÛŒØ®',0),(567440,15763,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµÐ³ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð°',0),(567441,15763,'vi','NgÃ y cuá»‘i cÃ¹ng cá»§a sá»‘ liÃªn láº¡c',0),(567442,15763,'af','Laaste datum van kontak',0),(567443,15763,'ro','Ultimele Date de Contact',0),(567444,15763,'et','Viimasel pÃ¤eval kontakt',0),(567445,15763,'si','Zadnji datum za stike',0),(567446,15763,'ba','Tanggal terakhir kontak',0),(567447,15763,'nl','Laatste datum van Contact',0),(567448,15763,'fi','Viimeinen yhteystiedot',0),(567449,15763,'no','Siste dato i kontakt',0),(567450,15763,'da','Sidste dato i kontakt',0),(567451,15763,'ko','ì—°ë½ì²˜ì˜ ë§ˆì§€ë§‰ ë‚ ì§œ',0),(567452,15763,'he','×”×ª××¨×™×š ×”××—×¨×•×Ÿ ×©×œ ×ž×’×¢',0),(567453,15763,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÏ€Î±Ï†Î®Ï‚',0),(567454,15763,'zh','è”ç³»äººçš„æœ€åŽæ—¥æœŸ',0),(567455,15763,'sv','Sista datum fÃ¶r kontakt',0),(567456,15763,'it','Ultima data di contatto',0),(567457,15763,'tl','',0),(567458,15763,'th','à¸§à¸±à¸™à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­',0),(567459,15763,'hi','à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤¾ à¤…à¤‚à¤¤à¤¿à¤® à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(567460,15763,'ms','Tarikh akhir hubungan',0),(567461,15763,'ar','Ø¢Ø®Ø± ØªØ§Ø±ÙŠØ® Ù„Ø¬Ù‡Ø© Ø§Ù„Ø§ØªØµØ§Ù„',0),(567462,15763,'fr','DerniÃ¨re Date de Contact',0),(567463,15763,'jp','é€£çµ¡å…ˆã®æœ€çµ‚æ—¥',0),(567464,15763,'pt','Ãšltima data de contato',0),(567465,15763,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð°',0),(567466,15763,'es','Ãšltima fecha de contacto',0),(567467,15763,'de','Letztes Datum des Kontakts',0),(567468,15763,'en','Last Date Of Contact',0),(567469,15764,'is','',0),(567470,15764,'dr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ ØªØ§Ø±ÛŒØ® ÙˆØ±ÙˆØ¯',0),(567471,15764,'pr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ ØªØ§Ø±ÛŒØ® ÙˆØ±ÙˆØ¯',0),(567472,15764,'tr','Not giriÅŸ tarihi',0),(567473,15764,'pl','Uwaga wpis daty',0),(567474,15764,'bg','Ð—Ð°Ð±ÐµÐ»ÐµÐ¶ÐºÐ° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð°',0),(567475,15764,'ur','Ù†ÙˆÙ¹ Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(567476,15764,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð° Ð¿Ð¾Ñ€ÑƒÐºÐ°',0),(567477,15764,'vi','LÆ°u Ã½ nháº­p ngÃ y',0),(567478,15764,'af','Nota inskrywing datum',0),(567479,15764,'ro','Nota data de intrare',0),(567480,15764,'et','MÃ¤rkus kande kuupÃ¤ev',0),(567481,15764,'si','Datum vnosa Opomba',0),(567482,15764,'ba','Tanggal entri catatan',0),(567483,15764,'nl','Opmerking post datum',0),(567484,15764,'fi','Huomautus PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(567485,15764,'no','Merk oppfÃ¸ringsdatoen',0),(567486,15764,'da','BemÃ¦rk tilmeldningsfrist',0),(567487,15764,'ko','ì°¸ê³  í•­ëª© ë‚ ì§œ',0),(567488,15764,'he','×”×¢×¨×” ×¢×¨×š ×ª××¨×™×š',0),(567489,15764,'el','Î£Î·Î¼ÎµÎ¯Ï‰ÏƒÎ·: Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(567490,15764,'zh','æ³¨æ„è¾“å…¥æ—¥æœŸ',0),(567491,15764,'sv','Obs datumet',0),(567492,15764,'it','Data di inserimento nota',0),(567493,15764,'tl','',0),(567494,15764,'th','à¸§à¸±à¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸',0),(567495,15764,'hi','à¤¨à¥‹à¤Ÿ: à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(567496,15764,'ms','Tarikh kemasukan Nota',0),(567497,15764,'ar','Ù…Ù„Ø§Ø­Ø¸Ø© Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ®',0),(567498,15764,'fr','Date dâ€™entrÃ©e de note',0),(567499,15764,'jp','æ³¨: ã‚¨ãƒ³ãƒˆãƒªã®æ—¥ä»˜',0),(567500,15764,'pt','Data de entrada da nota',0),(567501,15764,'ru','Ð”Ð°Ñ‚Ð° Ð²ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(567502,15764,'es','Fecha de entrada de nota',0),(567503,15764,'de','Beachten Sie das Datum',0),(567504,15764,'en','Note Entry Date',0),(567505,15765,'is','',0),(567506,15765,'dr','ØªØ§Ø±ÛŒØ® Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø±',0),(567507,15765,'pr','ØªØ§Ø±ÛŒØ® Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø±',0),(567508,15765,'tr','Beklemeye tarihi',0),(567509,15765,'pl','Przytrzymaj na Data',0),(567510,15765,'bg','Ð—Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(567511,15765,'ur','ØªØ§Ø±ÛŒØ® Ù¾Ø± Ù…Ù†Ø¹Ù‚Ø¯',0),(567512,15765,'sr','ÐÐ° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð´Ð°Ñ‚ÑƒÐ¼',0),(567513,15765,'vi','Vá» tá»• chá»©c ngÃ y',0),(567514,15765,'af','Op datum hou',0),(567515,15765,'ro','Å¢ineÅ£i pe data',0),(567516,15765,'et','Ootel kuupÃ¤ev',0),(567517,15765,'si','ZadrÅ¾ano datum',0),(567518,15765,'ba','Berlangsung tanggal',0),(567519,15765,'nl','Houd op datum',0),(567520,15765,'fi','Estossa-pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(567521,15765,'no','Avvent-dato',0),(567522,15765,'da','Afvent dato',0),(567523,15765,'ko','ì— ë‚ ì§œë¥¼ ìž¡ì•„',0),(567524,15765,'he','×‘×”×ž×ª× ×” ×ª××¨×™×š',0),(567525,15765,'el','Î£Îµ Î±Î½Î±Î¼Î¿Î½Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(567526,15765,'zh','ä¸¾è¡Œæ—¥æœŸ',0),(567527,15765,'sv','Ã… hÃ¥ll datum',0),(567528,15765,'it','In attesa di data',0),(567529,15765,'tl','',0),(567530,15765,'th','à¸„à¸‡à¸„à¹‰à¸²à¸‡à¸§à¸±à¸™',0),(567531,15765,'hi','à¤¹à¥‹à¤²à¥à¤¡ à¤ªà¤° à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(567532,15765,'ms','Tahan pada tarikh',0),(567533,15765,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(567534,15765,'fr','En attente de Date',0),(567535,15765,'jp','æ—¥ä»˜ã‚’ä¿æŒ',0),(567536,15765,'pt','Ã€ espera de data',0),(567537,15765,'ru','Ð¡ Ð¿Ñ€Ð¾Ð²ÐµÑÑ‚Ð¸ Ð”Ð°Ñ‚Ð°',0),(567538,15765,'es','En espera de fecha',0),(567539,15765,'de','Datum zurÃ¼ckgestellt',0),(567540,15765,'en','On Hold Date',0),(567541,15766,'is','',0),(567542,15766,'dr','Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÛŒØ¯ Ø¯Ø± Y/N',0),(567543,15766,'pr','Ù†Ú¯Ù‡ Ø¯Ø§Ø±ÛŒØ¯ Ø¯Ø± Y/N',0),(567544,15766,'tr','Y/N bir dakika',0),(567545,15766,'pl','Na wstrzymanie Y/N',0),(567546,15766,'bg','Ð§Ð°ÐºÐ°Ñ‰ Y/N',0),(567547,15766,'ur','Y/N Ù¾Ø± Ù…Ù†Ø¹Ù‚Ø¯',0),(567548,15766,'sr','ÐÐ° Ñ‡ÐµÐºÐ°ÑšÑƒ Y/Ð',0),(567549,15766,'vi','NgÃ y tá»• chá»©c Y/N',0),(567550,15766,'af','Hou op Y/N',0),(567551,15766,'ro','AÅŸteptare Y/N',0),(567552,15766,'et','Peatatud Y/N',0),(567553,15766,'si','ZadrÅ¾ano Y/N',0),(567554,15766,'ba','Pada mengadakan Y/N',0),(567555,15766,'nl','Wachten J/N',0),(567556,15766,'fi','Estossa Y/N',0),(567557,15766,'no','Avvent Y/N',0),(567558,15766,'da','Afvent Y/N',0),(567559,15766,'ko','Y/Në¥¼ ê°œìµœ',0),(567560,15766,'he','×‘×”×ž×ª× ×” Y/N',0),(567561,15766,'el','Î£Îµ Î±Î½Î±Î¼Î¿Î½Î® Y/N',0),(567562,15766,'zh','å…³äºŽä¸¾è¡Œ Y/N',0),(567563,15766,'sv','Stoppad Y/N',0),(567564,15766,'it','Il tenere premuto Y/N',0),(567565,15766,'tl','',0),(567566,15766,'th','à¸„à¸‡à¸„à¹‰à¸²à¸‡ Y/N',0),(567567,15766,'hi','Y/N à¤ªà¤•à¤¡à¤¼',0),(567568,15766,'ms','Pegangan Y/N',0),(567569,15766,'ar','Ø§Ø¶ØºØ· Ø¹Ù„Ù‰ Y/N',0),(567570,15766,'fr','En attente O/N',0),(567571,15766,'jp','Y/N ã‚’é–‹å‚¬ã—ã¾ã™ã€‚',0),(567572,15766,'pt','Deter, a, S/N',0),(567573,15766,'ru','ÐŸÑ€Ð¾Ð²Ð¾Ð´Ð¸Ñ‚ÑŒ Ð¿Ð¾ Y/N',0),(567574,15766,'es','En espera S/N',0),(567575,15766,'de','Halten Sie auf J/N',0),(567576,15766,'en','On Hold Y/N',0),(567577,15767,'is','',0),(567578,15767,'dr','Ø¯Ø±ØµØ¯ Ø§Ø² ØªØ¹Ø§Ø¯Ù„ Ú¯Ø°Ø´ØªÙ‡ Ø¨Ù‡ Ø¯Ù„ÛŒÙ„',0),(567579,15767,'pr','Ø¯Ø±ØµØ¯ Ø§Ø² ØªØ¹Ø§Ø¯Ù„ Ú¯Ø°Ø´ØªÙ‡ Ø¨Ù‡ Ø¯Ù„ÛŒÙ„',0),(567580,15767,'tr','YÃ¼zde, bakiye vadesi geÃ§miÅŸ',0),(567581,15767,'pl','Procent bilansu zadÅ‚uÅ¼one',0),(567582,15767,'bg','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð½Ð° Ð±Ð°Ð»Ð°Ð½Ñ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸',0),(567583,15767,'ur','ÙÛŒØµØ¯ Ø¹Ø¯Ù… ØªÙˆØ§Ø²Ù† Ú©Ø§ Ù…Ù‚Ø±Ø±Û Ù…Ø§Ø¶ÛŒ',0),(567584,15767,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ñ€Ð°Ð²Ð½Ð¾Ñ‚ÐµÐ¶Ðµ Ð¸ÑÑ‚ÐµÐºÐ»Ðµ',0),(567585,15767,'vi','Pháº§n trÄƒm cá»§a sá»‘ dÆ° qua do',0),(567586,15767,'af','Persentasie van balans sperdatum verby',0),(567587,15767,'ro','Procent din soldul trecut datorate',0),(567588,15767,'et','Protsendiliselt vahekorra Ã¼le tÃ¤htaja',0),(567589,15767,'si','Odstotek bilance zapadle',0),(567590,15767,'ba','Persen dari saldo tagihan yang jatuh tempo',0),(567591,15767,'nl','Percentage van evenwicht achterstallig',0),(567592,15767,'fi','Prosenttia tasapaino erÃ¤Ã¤ntyneet',0),(567593,15767,'no','Prosent av balanse forfalt',0),(567594,15767,'da','Procent af Balance forfaldne',0),(567595,15767,'ko','ê· í˜•ì˜ ë°±ë¶„ìœ¨ ì—°ì²´',0),(567596,15767,'he','××—×•×– ×©×œ ××™×–×•×Ÿ ×©×ž×•×¢×“',0),(567597,15767,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï„Î¿Ï… Ï…Ï€Î¿Î»Î¿Î¯Ï€Î¿Ï… Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½Ï‰Î½ ÎµÎºÏ€ÏÏŒÎ¸ÎµÏƒÎ¼Ï‰Î½',0),(567598,15767,'zh','ç™¾åˆ†æ¯”çš„å¹³è¡¡è¿‡æœŸ',0),(567599,15767,'sv','Procent av balans fÃ¶rfallna',0),(567600,15767,'it','Percentuale del saldo scaduto',0),(567601,15767,'tl','',0),(567602,15767,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸‚à¸­à¸‡à¸¢à¸­à¸”à¸”à¸¸à¸¥à¹€à¸¥à¸¢',0),(567603,15767,'hi','à¤¶à¥‡à¤· à¤°à¤¾à¤¶à¤¿ à¤•à¤¾ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤ªà¤¿à¤›à¤²à¥‡ à¤¨à¤¿à¤¯à¤¤',0),(567604,15767,'ms','Peratus baki lepas habis tempoh',0),(567605,15767,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù„Ù„Ø±ØµÙŠØ¯ Ø¨Ø¹Ø¯ Ø§Ù„Ø§Ø³ØªØ­Ù‚Ø§Ù‚',0),(567606,15767,'fr','Pourcentage du solde en souffrance',0),(567607,15767,'jp','ãƒãƒ©ãƒ³ã‚¹ã®é”æˆæœŸé™',0),(567608,15767,'pt','Por cento do saldo vencido',0),(567609,15767,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ Ð¾Ñ‚ Ð±Ð°Ð»Ð°Ð½ÑÐ° Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ð¾Ð¹',0),(567610,15767,'es','Por ciento del saldo vencido',0),(567611,15767,'de','Prozent des Gleichgewichts Ã¼berfÃ¤llig',0),(567612,15767,'en','Percent Of Balance Past Due',0),(567613,15768,'is','',0),(567614,15768,'dr','Prelimable',0),(567615,15768,'pr','Prelimable',0),(567616,15768,'tr','Prelimable',0),(567617,15768,'pl','Prelimable',0),(567618,15768,'bg','Prelimable',0),(567619,15768,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù…Ø¨Ù„ÛŒ',0),(567620,15768,'sr','ÐŸÑ€ÐµÐ»Ð¸Ð¼Ð°Ð±Ð»Ðµ',0),(567621,15768,'vi','Prelimable',0),(567622,15768,'af','Prelimable',0),(567623,15768,'ro','Prelimable',0),(567624,15768,'et','Prelimable',0),(567625,15768,'si','Prelimable',0),(567626,15768,'ba','Prelimable',0),(567627,15768,'nl','Prelimable',0),(567628,15768,'fi','Prelimable',0),(567629,15768,'no','Prelimable',0),(567630,15768,'da','Prelimable',0),(567631,15768,'ko','Prelimable',0),(567632,15768,'he','Prelimable',0),(567633,15768,'el','Prelimable',0),(567634,15768,'zh','Prelimable',0),(567635,15768,'sv','Prelimable',0),(567636,15768,'it','Prelimable',0),(567637,15768,'tl','',0),(567638,15768,'th','Prelimable',0),(567639,15768,'hi','Prelimable',0),(567640,15768,'ms','Prelimable',0),(567641,15768,'ar','Ø¨Ø±ÙŠÙ„ÙŠÙ…Ø§Ø¨Ù„',0),(567642,15768,'fr','Prelimable',0),(567643,15768,'jp','Prelimable',0),(567644,15768,'pt','Prelimable',0),(567645,15768,'ru','Prelimable',0),(567646,15768,'es','Prelimable',0),(567647,15768,'de','Prelimable',0),(567648,15768,'en','Prelimable',0),(567649,15769,'is','',0),(567650,15769,'dr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ø¢Ø®Ø±ÛŒÙ† ØªÙ…Ø§Ø³ Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(567651,15769,'pr','ØªÙˆØ¬Ù‡ Ø¯Ø§Ø´ØªÙ‡ Ø¨Ø§Ø´ÛŒØ¯ Ø¢Ø®Ø±ÛŒÙ† ØªÙ…Ø§Ø³ Ø±Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(567652,15769,'tr','Son kiÅŸi Not gÃ¶ster',0),(567653,15769,'pl','PokaÅ¼ ostatnie notatki kontaktu',0),(567654,15769,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(567655,15769,'ur','Ø¢Ø®Ø±ÛŒ Ø±Ø§Ø¨Ø·Û Ù†ÙˆÙ¹ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(567656,15769,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐ¸ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ ÐÐ°Ð¿Ð¾Ð¼ÐµÐ½Ð°',0),(567657,15769,'vi','Hiá»ƒn thá»‹ ghi chÃº liÃªn láº¡c cuá»‘i cÃ¹ng',0),(567658,15769,'af','Wys vorige kontak Nota',0),(567659,15769,'ro','AratÄƒ ultima notÄƒ Contact',0),(567660,15769,'et','NÃ¤ita viimast kontakti mÃ¤rkust',0),(567661,15769,'si','PrikaÅ¾i zadnji kontaktne opombe',0),(567662,15769,'ba','Tampilkan catatan kontak terakhir',0),(567663,15769,'nl','Toon laatste maakcontact Opmerking',0),(567664,15769,'fi','NÃ¤ytÃ¤ viimeinen yhteyshenkilÃ¶n Huomautus',0),(567665,15769,'no','Vis siste kontakt notat',0),(567666,15769,'da','Vis sidste kontakt BemÃ¦rk',0),(567667,15769,'ko','ë§ˆì§€ë§‰ìœ¼ë¡œ ì—°ë½ì²˜ ë©”ëª¨ í‘œì‹œ',0),(567668,15769,'he','×”×¦×’ ××ª ×× ×©×™ ×”×§×©×¨ ×”××—×¨×•×Ÿ',0),(567669,15769,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ ÏƒÎ·Î¼ÎµÎ¯Ï‰Î¼Î± ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚',0),(567670,15769,'zh','æ˜¾ç¤ºæœ€åŽä¸€ä¸ªæŽ¥è§¦éŸ³ç¬¦',0),(567671,15769,'sv','Visa senaste kontakt notera',0),(567672,15769,'it','Visualizza ultimo contatto Nota',0),(567673,15769,'tl','',0),(567674,15769,'th','à¹à¸ªà¸”à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸•à¸´à¸”à¸•à¹ˆà¸­à¸„à¸£à¸±à¹‰à¸‡à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(567675,15769,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¸à¤‚à¤ªà¤°à¥à¤• à¤¨à¥‹à¤Ÿ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(567676,15769,'ms','Menunjukkan Nota perhubungan yang lepas',0),(567677,15769,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù…Ù„Ø§Ø­Ø¸Ø© Ø§Ù„Ø§ØªØµØ§Ù„ Ø§Ù„Ø£Ø®ÙŠØ±',0),(567678,15769,'fr','Afficher la derniÃ¨re Note de Contact',0),(567679,15769,'jp','æœ€å¾Œã®é€£çµ¡å…ˆãƒ¡ãƒ¢ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(567680,15769,'pt','Mostrar a Ãºltima nota de contato',0),(567681,15769,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ ÐŸÑ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ðµ',0),(567682,15769,'es','Mostrar Ãºltima nota contacto',0),(567683,15769,'de','Letzten Kontakt Hinweis anzeigen',0),(567684,15769,'en','Show Last Contact Note',0),(567685,15770,'is','',0),(567686,15770,'dr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨',0),(567687,15770,'pr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨',0),(567688,15770,'tr','Hesap sayÄ±sÄ± HaritayÄ±',0),(567689,15770,'pl','PokaÅ¼ liczbÄ™ kont',0),(567690,15770,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ð±Ñ€Ð¾Ñ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ¸Ñ‚Ðµ',0),(567691,15770,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(567692,15770,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(567693,15770,'vi','Hiá»ƒn thá»‹ sá»‘ lÆ°á»£ng tÃ i khoáº£n',0),(567694,15770,'af','Wys die aantal rekeninge',0),(567695,15770,'ro','AratÄƒ numÄƒrul de conturi',0),(567696,15770,'et','NÃ¤ita kontode arv',0),(567697,15770,'si','PokaÅ¾i Å¡tevilo raÄunov',0),(567698,15770,'ba','Tampilkan jumlah account',0),(567699,15770,'nl','Toon aantal Accounts',0),(567700,15770,'fi','NÃ¤ytÃ¤ useita tilejÃ¤',0),(567701,15770,'no','Vis antall kontoer',0),(567702,15770,'da','Vis antallet af konti',0),(567703,15770,'ko','ê³„ì • í‘œì‹œ ìˆ˜',0),(567704,15770,'he','×”×¦×’ ××ª ×ž×¡×¤×¨ ×—×©×‘×•× ×•×ª',0),(567705,15770,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î±ÏÎ¹Î¸Î¼Î¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(567706,15770,'zh','æ˜¾ç¤ºå¸æˆ·æ•°ç›®',0),(567707,15770,'sv','Visa antal konton',0),(567708,15770,'it','Visualizza il numero di account',0),(567709,15770,'tl','',0),(567710,15770,'th','à¹à¸ªà¸”à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µ',0),(567711,15770,'hi','à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(567712,15770,'ms','Menunjukkan bilangan akaun',0),(567713,15770,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø¹Ø¯Ø¯ Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª',0),(567714,15770,'fr','Afficher le nombre de comptes',0),(567715,15770,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®æ•°ã‚’è¡¨ç¤º',0),(567716,15770,'pt','Mostrar o nÃºmero de contas',0),(567717,15770,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(567718,15770,'es','NÃºmero de cuentas',0),(567719,15770,'de','Anzahl der Konten anzeigen',0),(567720,15770,'en','Show Number Of Accounts',0),(567721,15771,'is','',0),(567722,15771,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(567723,15771,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(567724,15771,'tr','Toplam bakiye',0),(567725,15771,'pl','CaÅ‚kowity bilans',0),(567726,15771,'bg','Ð¡Ð°Ð»Ð´Ð¾ Ð¾Ð±Ñ‰Ð¾',0),(567727,15771,'ur','Ú©Ù„ Ù…ÛŒØ²Ø§Ù†',0),(567728,15771,'sr','Ð£ÐºÑƒÐ¿Ð°Ð½ ÑÐ°Ð»Ð´Ð¾',0),(567729,15771,'vi','Tá»•ng sá»‘ dÆ°',0),(567730,15771,'af','Totale balans',0),(567731,15771,'ro','Soldul total',0),(567732,15771,'et','LÃµppsaldo',0),(567733,15771,'si','Skupni saldo',0),(567734,15771,'ba','Keseimbangan Total',0),(567735,15771,'nl','Totaalsaldo',0),(567736,15771,'fi','Taseen loppusumma',0),(567737,15771,'no','Total saldo',0),(567738,15771,'da','Total Balance',0),(567739,15771,'ko','ì´ ìž”ì•¡',0),(567740,15771,'he','×”×ž××–×Ÿ',0),(567741,15771,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ Ï…Ï€ÏŒÎ»Î¿Î¹Ï€Î¿',0),(567742,15771,'zh','æ€»ä½™é¢',0),(567743,15771,'sv','Totalt saldo',0),(567744,15771,'it','Saldo totale',0),(567745,15771,'tl','',0),(567746,15771,'th','à¸¢à¸­à¸”à¸”à¸¸à¸¥à¸£à¸§à¸¡',0),(567747,15771,'hi','à¤•à¥à¤² à¤¶à¥‡à¤·',0),(567748,15771,'ms','Jumlah baki',0),(567749,15771,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø±ØµÙŠØ¯',0),(567750,15771,'fr','Solde total',0),(567751,15771,'jp','ãƒˆãƒ¼ã‚¿ãƒ« ãƒãƒ©ãƒ³ã‚¹',0),(567752,15771,'pt','Saldo total',0),(567753,15771,'ru','ÐžÐ±Ñ‰Ð¸Ð¹ Ð±Ð°Ð»Ð°Ð½Ñ',0),(567754,15771,'es','Saldo total',0),(567755,15771,'de','Gesamtsaldo',0),(567756,15771,'en','Total Balance',0),(567757,15772,'is','',0),(567758,15772,'dr','Ú©Ù„ Ú¯Ø°Ø´ØªÙ‡ Ø¹Ù„Øª',0),(567759,15772,'pr','Ú©Ù„ Ú¯Ø°Ø´ØªÙ‡ Ø¹Ù„Øª',0),(567760,15772,'tr','Toplam geÃ§miÅŸ nedeniyle',0),(567761,15772,'pl','CaÅ‚kowita ostatnich ze wzglÄ™du',0),(567762,15772,'bg','ÐžÐ±Ñ‰Ð¾ Ð¼Ð¸Ð½Ð°Ð»Ð¸ Ð´ÑŠÐ»Ð¶Ð¸Ð¼Ð¸',0),(567763,15772,'ur','Ú©ÛŒ ÙˆØ¬Û Ø³Û’ Ú©Ù„ Ù…Ø§Ø¶ÛŒ',0),(567764,15772,'sr','Ð£ÐºÑƒÐ¿Ð½Ð° Ð¿Ð¾Ñ€ÐµÐ´ Ñ‚ÐµÑ€Ð¼Ð¸Ð½',0),(567765,15772,'vi','Táº¥t cáº£ trong quÃ¡ khá»© do',0),(567766,15772,'af','Verlede totaal verskuldig',0),(567767,15772,'ro','Total trecut datorate',0),(567768,15772,'et','Viimase tÃµttu kokku',0),(567769,15772,'si','Skupaj zapadle',0),(567770,15772,'ba','Total masa lalu karena',0),(567771,15772,'nl','Totale verleden verschuldigde',0),(567772,15772,'fi','Total erÃ¤Ã¤ntyneet',0),(567773,15772,'no','Totalt forfalte',0),(567774,15772,'da','Samlede forbi Due',0),(567775,15772,'ko','ê³¼ê±°ì˜ í•©ê³„',0),(567776,15772,'he','×¡×” ×› ×¢×‘×¨ ×‘×©×œ',0),(567777,15772,'el','Î£ÏÎ½Î¿Î»Î¿ ÎºÎ±Î¸Ï…ÏƒÏ„Î­ÏÎ·ÏƒÎ·',0),(567778,15772,'zh','è¿‡åŽ»åº”ä»˜æ€»é‡‘é¢',0),(567779,15772,'sv','Totala fÃ¶rbi pÃ¥ grund',0),(567780,15772,'it','Totale passato causa',0),(567781,15772,'tl','',0),(567782,15772,'th','à¸£à¸§à¸¡à¸—à¸µà¹ˆà¸œà¹ˆà¸²à¸™à¸¡à¸²à¸„à¸£à¸šà¸à¸³à¸«à¸™à¸”',0),(567783,15772,'hi','à¤•à¥à¤² à¤ªà¤¿à¤›à¤²à¥‡ à¤•à¤¾à¤°à¤£',0),(567784,15772,'ms','Jumlah masa lalu kerana',0),(567785,15772,'ar','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„Ø³Ø§Ø¨Ù‚Ø© Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø©',0),(567786,15772,'fr','Total passÃ© dÃ»',0),(567787,15772,'jp','éŽåŽ»ã®åˆè¨ˆæ”¯æ‰•é¡',0),(567788,15772,'pt','Total passado devido',0),(567789,15772,'ru','Ð’ÑÐµÐ³Ð¾ Ð² Ð¿Ñ€Ð¾ÑˆÐ»Ð¾Ð¼ Ð¸Ð·-Ð·Ð°',0),(567790,15772,'es','Total pasado debido',0),(567791,15772,'de','Insgesamt Vergangenheit aufgrund',0),(567792,15772,'en','Total Past Due',0),(567793,15773,'is','',0),(567794,15773,'dr','A & Ù…Ù† Ø¨Ù‡ Ù¾Ø§ÛŒØ§Ù† Ø±Ø³ÛŒØ¯ ØµÙ†Ø¯ÙˆÙ‚ Ø¨Ø±Ø§ÛŒ AP',0),(567795,15773,'pr','A & Ù…Ù† Ø¨Ù‡ Ù¾Ø§ÛŒØ§Ù† Ø±Ø³ÛŒØ¯ ØµÙ†Ø¯ÙˆÙ‚ Ø¨Ø±Ø§ÛŒ AP',0),(567796,15773,'tr','A ve ben PO AP iÃ§in tamamlandÄ±',0),(567797,15773,'pl','A & wypeÅ‚niony PO AP',0),(567798,15773,'bg','Ð & Ð¸Ð·ÐºÐ°Ñ€Ð°Ñ…Ð¼Ðµ PO Ð°Ð¿',0),(567799,15773,'ur','A & Ù…ÛŒÚº Ù¾Ùˆ AP Ú©Ùˆ Ù…Ú©Ù…Ù„',0),(567800,15773,'sr','Ð & ÑÐ°Ð¼ Ð´Ð¾Ð²Ñ€ÑˆÐ¸Ñ‚Ð¸ ÐŸÐž ÐÐŸ',0),(567801,15773,'vi','A & tÃ´i hoÃ n thÃ nh PO Ä‘áº¿n AP',0),(567802,15773,'af','\'N & ek voltooi PO te AP',0),(567803,15773,'ro','A & am finalizat PO AP',0),(567804,15773,'et','A & ma lÃµpule PO AP',0),(567805,15773,'si','A & sem zakljuÄil PO AP',0),(567806,15773,'ba','A & saya menyelesaikan PO AP',0),(567807,15773,'nl','A & ik voltooid PO aan AP',0),(567808,15773,'fi','A & olen valmistunut PO AP',0),(567809,15773,'no','A & jeg fullfÃ¸rte PO Ã¥ AP',0),(567810,15773,'da','A & jeg afsluttet PO til AP',0),(567811,15773,'ko','A & APì— í¬ë¥¼ ì™„ë£Œ',0),(567812,15773,'he','A & ×”×©×œ×ž×ª×™ ×œ×¤×• AP',0),(567813,15773,'el','A & Î¿Î»Î¿ÎºÎ»Î®ÏÏ‰ÏƒÎ± PO Î±Ï€',0),(567814,15773,'zh','A & å®Œæˆäº†å®åˆ° AP',0),(567815,15773,'sv','A & jag avslutade PO AP',0),(567816,15773,'it','A & ho completato PO AP',0),(567817,15773,'tl','',0),(567818,15773,'th','A à¹à¸¥à¸°à¸‰à¸±à¸™à¹€à¸ªà¸£à¹‡à¸ˆ PO à¸à¸±à¸š AP',0),(567819,15773,'hi','A & à¤®à¥ˆà¤‚ PO AP à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‚à¤°à¤¾ à¤•à¤¿à¤¯à¤¾',0),(567820,15773,'ms','A & saya sudah melengkapkan PO AP',0),(567821,15773,'ar','Ø£ & Ø£ÙƒÙ…Ù„Øª Ø¨Ùˆ Ù„ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(567822,15773,'fr','A & jâ€™ai terminÃ© PO Ã  AP',0),(567823,15773,'jp','A ãƒ» AP ã« PO ã‚’å®Œæˆå“',0),(567824,15773,'pt','A & completei PO para AP',0),(567825,15773,'ru','A & Ñ Ð·Ð°Ð²ÐµÑ€ÑˆÐ¸Ð» PO Ð´Ð»Ñ AP',0),(567826,15773,'es','A y terminÃ© PO a AP',0),(567827,15773,'de','A & absolvierte ich PO mit AP',0),(567828,15773,'en','A&I Completed PO To AP',0),(567829,15774,'is','',0),(567830,15774,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ…',0),(567831,15774,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ…',0),(567832,15774,'tr','DoÄŸrudan masraf Ã¶demeleri',0),(567833,15774,'pl','Koszt pÅ‚atnoÅ›ci bezpoÅ›rednich',0),(567834,15774,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð¿Ñ€ÐµÐºÐ¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(567835,15774,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(567836,15774,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº Ð¸ÑÐ¿Ð»Ð°Ñ‚Ðµ',0),(567837,15774,'vi','Thanh toÃ¡n trá»±c tiáº¿p chi phÃ­',0),(567838,15774,'af','Direkte koste betalings',0),(567839,15774,'ro','Cheltuiala plÄƒÈ›i directe',0),(567840,15774,'et','Otsene kulu vÃ¤ljamakseid',0),(567841,15774,'si','Neposredna plaÄila stroÅ¡kov',0),(567842,15774,'ba','Pembayaran langsung biaya',0),(567843,15774,'nl','Directe kosten betalingen',0),(567844,15774,'fi','Suoraan kustannuksella maksut',0),(567845,15774,'no','Direkte utgifter betalinger',0),(567846,15774,'da','Direkte udgift betalinger',0),(567847,15774,'ko','ì§ì ‘ ë¹„ìš© ì§€ë¶ˆ',0),(567848,15774,'he','×”×•×¦××•×ª ×™×©×™×¨×•×ª ×ª×©×œ×•×ž×™×',0),(567849,15774,'el','Î†Î¼ÎµÏƒÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ ÎµÎ¾ÏŒÎ´Ï‰Î½',0),(567850,15774,'zh','ç›´æŽ¥è´¹ç”¨ä»˜æ¬¾',0),(567851,15774,'sv','Direkt bekostnad betalningar',0),(567852,15774,'it','Spese dei pagamenti diretti',0),(567853,15774,'tl','',0),(567854,15774,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¹‚à¸”à¸¢à¸•à¸£à¸‡',0),(567855,15774,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤µà¥à¤¯à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(567856,15774,'ms','Pembayaran perbelanjaan langsung',0),(567857,15774,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø©',0),(567858,15774,'fr','Paiements de frais directs',0),(567859,15774,'jp','ç›´æŽ¥çµŒè²»ã®æ”¯æ‰•ã„',0),(567860,15774,'pt','Despesa de pagamentos directos',0),(567861,15774,'ru','ÐŸÑ€ÑÐ¼Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ Ð·Ð° ÑÑ‡ÐµÑ‚',0),(567862,15774,'es','Pagos de gasto directo',0),(567863,15774,'de','Kosten Direktzahlungen',0),(567864,15774,'en','Direct Expense Payments',0),(567865,15775,'is','',0),(567866,15775,'dr','Ø§Ù†ÙˆØ§Ø¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ…',0),(567867,15775,'pr','Ø§Ù†ÙˆØ§Ø¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ…',0),(567868,15775,'tr','DoÄŸrudan gider tÃ¼rlerini',0),(567869,15775,'pl','Typy wydatkÃ³w bezpoÅ›rednich',0),(567870,15775,'bg','Ð’Ð¸Ð´Ð¾Ð²Ðµ Ð¿Ñ€ÐµÐºÐ¸ Ñ€Ð°Ð·Ð½Ð¾ÑÐºÐ¸',0),(567871,15775,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ù‚Ø³Ù…ÛŒÚº',0),(567872,15775,'sr','Ð’Ñ€ÑÑ‚Ðµ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(567873,15775,'vi','CÃ¡c loáº¡i chi phÃ­ trá»±c tiáº¿p',0),(567874,15775,'af','Direkte koste tipes',0),(567875,15775,'ro','Tipuri de cheltuieli directe',0),(567876,15775,'et','Otsene kulu tÃ¼Ã¼bid',0),(567877,15775,'si','Vrst neposrednih stroÅ¡kov',0),(567878,15775,'ba','Jenis biaya langsung',0),(567879,15775,'nl','Directe uitgaven Types',0),(567880,15775,'fi','Suora kulutyypit',0),(567881,15775,'no','Direkte utgiftstyper',0),(567882,15775,'da','Direkte udgiftstyper',0),(567883,15775,'ko','ì§ì ‘ ë¹„ìš© ì¢…ë¥˜',0),(567884,15775,'he','×¡×•×’×™ ×”×•×¦××•×ª ×™×©×™×¨×•×ª',0),(567885,15775,'el','Î¤Î± ÎµÎ¯Î´Î· Î¬Î¼ÎµÏƒÏ‰Î½ Î´Î±Ï€Î±Î½ÏŽÎ½',0),(567886,15775,'zh','ç›´æŽ¥æ”¯å‡ºç±»åž‹',0),(567887,15775,'sv','Direkta utgiftstyper',0),(567888,15775,'it','Tipi di spesa diretta',0),(567889,15775,'tl','',0),(567890,15775,'th','à¸Šà¸™à¸´à¸”à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¹‚à¸”à¸¢à¸•à¸£à¸‡',0),(567891,15775,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤µà¥à¤¯à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(567892,15775,'ms','Jenis-jenis perbelanjaan langsung',0),(567893,15775,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø©',0),(567894,15775,'fr','Types de dÃ©penses directes',0),(567895,15775,'jp','ç›´æŽ¥çµŒè²»ã®ç¨®é¡ž',0),(567896,15775,'pt','Tipos de despesa direta',0),(567897,15775,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð¿Ñ€ÑÐ¼Ñ‹Ñ… Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(567898,15775,'es','Tipos de gasto directo',0),(567899,15775,'de','Direkte Kosten-Typen',0),(567900,15775,'en','Direct Expense Types',0),(567901,15776,'is','',0),(567902,15776,'dr','Ø¯Ù„Ø§ÛŒÙ„ Ù†ÙˆØ´ØªÙ†ØŒ Ø®Ø§Ù…ÙˆØ´',0),(567903,15776,'pr','Ø¯Ù„Ø§ÛŒÙ„ Ù†ÙˆØ´ØªÙ†ØŒ Ø®Ø§Ù…ÙˆØ´',0),(567904,15776,'tr','Yazma-off nedenleri',0),(567905,15776,'pl','Odpisanie powodÃ³w',0),(567906,15776,'bg','ÐžÑ‚Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð¸',0),(567907,15776,'ur','Write-Off ÙˆØ¬ÙˆÛØ§Øª',0),(567908,15776,'sr','ÐžÑ‚Ð¿Ð¸Ñ Ñ€Ð°Ð·Ð»Ð¾Ð³Ðµ',0),(567909,15776,'vi','Write-Off lÃ½ do',0),(567910,15776,'af','Afskrywing redes',0),(567911,15776,'ro','Scrie-off motive',0),(567912,15776,'et','Mahakandmine pÃµhjused',0),(567913,15776,'si','Odpis razlogov',0),(567914,15776,'ba','Alasan write-Off',0),(567915,15776,'nl','Afschrijving redenen',0),(567916,15776,'fi','Anteeksi syistÃ¤',0),(567917,15776,'no','Nedskrivningen grunner',0),(567918,15776,'da','Afskrivning grunde',0),(567919,15776,'ko','ì“°ê¸° ì´ìœ ',0),(567920,15776,'he','×¡×™×‘×•×ª ×ž×—×™×§×” ×‘×”×ª××',0),(567921,15776,'el','Î›ÏŒÎ³Î¿Î¹ Î³Î¹Î± Î´Î¹Î±Î³ÏÎ±Ï†Î®',0),(567922,15776,'zh','æ³¨é”€åŽŸå› ',0),(567923,15776,'sv','Avskrivning av skÃ¤l',0),(567924,15776,'it','Motivi di storno',0),(567925,15776,'tl','',0),(567926,15776,'th','à¹€à¸«à¸•à¸¸à¸œà¸¥à¸—à¸µà¹ˆà¸•à¸±à¸”',0),(567927,15776,'hi','à¤²à¤¿à¤–à¤¨à¥‡-à¤¬à¤‚à¤¦ à¤•à¤¾à¤°à¤£à¥‹à¤‚',0),(567928,15776,'ms','Sebab-sebab pelupusan',0),(567929,15776,'ar','Ø£Ø³Ø¨Ø§Ø¨ Ø§Ù„Ø´Ø·Ø¨',0),(567930,15776,'fr','Motifs de radiation',0),(567931,15776,'jp','å„Ÿå´ã®ç†ç”±',0),(567932,15776,'pt','RazÃµes de write-off',0),(567933,15776,'ru','Ð¡Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ñ‹',0),(567934,15776,'es','Razones de cancelaciÃ³n',0),(567935,15776,'de','Abschreibung aus GrÃ¼nden',0),(567936,15776,'en','Write-off Reasons',0),(567937,15777,'is','',0),(567938,15777,'dr','Ø­Ø³Ø§Ø¨ GL',0),(567939,15777,'pr','Ø­Ø³Ø§Ø¨ GL',0),(567940,15777,'tr','GL hesabÄ±',0),(567941,15777,'pl','Konta k/g',0),(567942,15777,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(567943,15777,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(567944,15777,'sr','Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(567945,15777,'vi','TÃ i khoáº£n GL',0),(567946,15777,'af','GL rekening',0),(567947,15777,'ro','GL cont',0),(567948,15777,'et','GL konto',0),(567949,15777,'si','RaÄun glavne knjige',0),(567950,15777,'ba','GL Account',0),(567951,15777,'nl','GL-Account',0),(567952,15777,'fi','Kirjanpitotilin pÃ¤Ã¤tilin',0),(567953,15777,'no','GI-konto',0),(567954,15777,'da','GL konto',0),(567955,15777,'ko','GL ê³„ì •',0),(567956,15777,'he','×—×©×‘×•×Ÿ GL',0),(567957,15777,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(567958,15777,'zh','æ€»å¸ç§‘ç›®',0),(567959,15777,'sv','GL-konto',0),(567960,15777,'it','Conto di contabilitÃ  generale',0),(567961,15777,'tl','',0),(567962,15777,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(567963,15777,'hi','GL à¤–à¤¾à¤¤à¥‡',0),(567964,15777,'ms','GL akaun',0),(567965,15777,'ar','Ø­Ø³Ø§Ø¨ GL',0),(567966,15777,'fr','Compte GL',0),(567967,15777,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(567968,15777,'pt','Conta GL',0),(567969,15777,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ GL',0),(567970,15777,'es','Cuenta de contabilidad',0),(567971,15777,'de','GL-Konto',0),(567972,15777,'en','GL Account',0),(567973,15778,'is','',0),(567974,15778,'dr','Ø¯Ù„ÛŒÙ„ Ù†ÙˆØ´ØªÙ†ØŒ Ø®Ø§Ù…ÙˆØ´',0),(567975,15778,'pr','Ø¯Ù„ÛŒÙ„ Ù†ÙˆØ´ØªÙ†ØŒ Ø®Ø§Ù…ÙˆØ´',0),(567976,15778,'tr','Yazma-off nedeni',0),(567977,15778,'pl','PrzyczynÄ… umorzenia',0),(567978,15778,'bg','ÐžÑ‚Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð°',0),(567979,15778,'ur','Write-Off Ú©ÛŒ ÙˆØ¬Û',0),(567980,15778,'sr','ÐžÑ‚Ð¿Ð¸Ñ Ñ€Ð°Ð·Ð»Ð¾Ð³',0),(567981,15778,'vi','Write-Off lÃ½ do',0),(567982,15778,'af','Afskrywing rede',0),(567983,15778,'ro','Motivul pentru care scrie-off',0),(567984,15778,'et','Mahakandmise pÃµhjus',0),(567985,15778,'si','Odpis razlog',0),(567986,15778,'ba','Alasan write-Off',0),(567987,15778,'nl','Afschrijving reden',0),(567988,15778,'fi','Anteeksi syy',0),(567989,15778,'no','Nedskrivningen grunn',0),(567990,15778,'da','Afskrivning grund',0),(567991,15778,'ko','ì“°ê¸° ì´ìœ ',0),(567992,15778,'he','×ž×—×™×§×” ×‘×”×ª×× ×¡×™×‘×”',0),(567993,15778,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® Î»ÏŒÎ³Î¿Ï‚',0),(567994,15778,'zh','æ³¨é”€åŽŸå› ',0),(567995,15778,'sv','Avskrivning av anledning',0),(567996,15778,'it','Motivo di storno',0),(567997,15778,'tl','',0),(567998,15778,'th','à¹€à¸«à¸•à¸¸à¸œà¸¥à¸—à¸µà¹ˆà¸•à¸±à¸”',0),(567999,15778,'hi','à¤²à¤¿à¤–à¤¨à¥‡-à¤¬à¤‚à¤¦ à¤•à¤¾à¤°à¤£',0),(568000,15778,'ms','Sebab pelupusan',0),(568001,15778,'ar','Ø³Ø¨Ø¨ Ø§Ù„Ø´Ø·Ø¨',0),(568002,15778,'fr','Raison de la radiation',0),(568003,15778,'jp','å„Ÿå´ã®ç†ç”±',0),(568004,15778,'pt','Motivo de anulaÃ§Ã£o',0),(568005,15778,'ru','ÐŸÑ€Ð¸Ñ‡Ð¸Ð½Ð° ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(568006,15778,'es','RazÃ³n de cancelaciÃ³n',0),(568007,15778,'de','Grund der Abschreibung',0),(568008,15778,'en','Write-off Reason',0),(568009,15779,'is','',0),(568010,15779,'dr','Ù†Ø§Ù… Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(568011,15779,'pr','Ù†Ø§Ù… Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(568012,15779,'tr','Dosya adÄ±',0),(568013,15779,'pl','Nazwa pliku',0),(568014,15779,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ñ„Ð°Ð¹Ð»Ð°',0),(568015,15779,'ur','Ù†Ø§Ù… Ù…Ø³Ù„',0),(568016,15779,'sr','Ð˜Ð¼Ðµ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(568017,15779,'vi','TÃªn táº­p tin',0),(568018,15779,'af','LÃªernaam',0),(568019,15779,'ro','Nume fisier',0),(568020,15779,'et','Faili nimi',0),(568021,15779,'si','Ime datoteke',0),(568022,15779,'ba','Nama file',0),(568023,15779,'nl','Bestandsnaam',0),(568024,15779,'fi','Tiedostonimi',0),(568025,15779,'no','Filnavn',0),(568026,15779,'da','Filnavn',0),(568027,15779,'ko','íŒŒì¼ ì´ë¦„',0),(568028,15779,'he','×©× ×§×•×‘×¥',0),(568029,15779,'el','ÎŒÎ½Î¿Î¼Î± Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(568030,15779,'zh','æ–‡ä»¶åç§°',0),(568031,15779,'sv','Filnamn',0),(568032,15779,'it','Nome del file',0),(568033,15779,'tl','',0),(568034,15779,'th','à¸Šà¸·à¹ˆà¸­à¹à¸Ÿà¹‰à¸¡',0),(568035,15779,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤•à¤¾ à¤¨à¤¾à¤®',0),(568036,15779,'ms','Nama fail',0),(568037,15779,'ar','Ø§Ø³Ù… Ø§Ù„Ù…Ù„Ù',0),(568038,15779,'fr','Nom de fichier',0),(568039,15779,'jp','ãƒ•ã‚¡ã‚¤ãƒ«å',0),(568040,15779,'pt','Nome do arquivo',0),(568041,15779,'ru','Ð˜Ð¼Ñ Ñ„Ð°Ð¹Ð»Ð°',0),(568042,15779,'es','Nombre de archivo',0),(568043,15779,'de','Dateiname',0),(568044,15779,'en','File Name',0),(568045,15780,'is','',0),(568046,15780,'dr','3dcart Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(568047,15780,'pr','3dcart Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(568048,15780,'tr','3dcart Ã¶ÄŸeler baÅŸarÄ±yla alÄ±ndÄ±',0),(568049,15780,'pl','3dcart elementy zaimportowane pomyÅ›lnie',0),(568050,15780,'bg','3dcart Ð°Ñ€Ñ‚Ð¸ÐºÑƒÐ»Ð¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(568051,15780,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û 3dcart Ø§Ø´ÛŒØ§Ø¡',0),(568052,15780,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ ÑƒÐ²ÐµÐ·ÐµÐ½Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(568053,15780,'vi','3dcart má»¥c nháº­p thÃ nh cÃ´ng',0),(568054,15780,'af','3dcart Items suksesvol ingevoer',0),(568055,15780,'ro','3dcart elemente importate cu succes',0),(568056,15780,'et','3dcart Ã¼ksused, mis on edukalt imporditud',0),(568057,15780,'si','3dcart elementi uspeÅ¡no uvoÅ¾en',0),(568058,15780,'ba','3dcart item berhasil diimpor',0),(568059,15780,'nl','3dcart Items geÃ¯mporteerd',0),(568060,15780,'fi','3dcart kohteiden tuominen onnistui',0),(568061,15780,'no','3dcart varer importert',0),(568062,15780,'da','3dcart varer importeret',0),(568063,15780,'ko','ì„±ê³µì ìœ¼ë¡œ ê°€ì ¸ì˜¨ 3dcart í•­ëª©',0),(568064,15780,'he','3dcart ×¤×¨×™×˜×™× ×ž×™×•×‘××™× ×‘×”×¦×œ×—×”',0),(568065,15780,'el','3dcart ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(568066,15780,'zh','3dcart é¡¹ç›®å·²æˆåŠŸå¯¼å…¥',0),(568067,15780,'sv','3dcart poster har importerats',0),(568068,15780,'it','3Dcart gli elementi importati con successo',0),(568069,15780,'tl','',0),(568070,15780,'th','3dcart à¸ªà¸´à¸™à¸„à¹‰à¸²à¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(568071,15780,'hi','3dcart à¤†à¤‡à¤Ÿà¤® à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤†à¤¯à¤¾à¤¤',0),(568072,15780,'ms','barang-barang 3dcart yang berjaya diimport',0),(568073,15780,'ar','3dcart Ø§Ù„Ø¹Ù†Ø§ØµØ± Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø© Ø¨Ù†Ø¬Ø§Ø­',0),(568074,15780,'fr','3Dcart Articles importÃ©s avec succÃ¨s',0),(568075,15780,'jp','æ­£å¸¸ã«ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚ŒãŸ 3dcart ã‚¢ã‚¤ãƒ†ãƒ ',0),(568076,15780,'pt','3Dcart itens importados com Ãªxito',0),(568077,15780,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ñ… ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² 3dcart',0),(568078,15780,'es','3DCart artÃ­culos importados con Ã©xito',0),(568079,15780,'de','3dcart Elemente erfolgreich importiert',0),(568080,15780,'en','3dcart Items Imported Successfully',0),(568081,15781,'is','',0),(568082,15781,'dr','3dcart Markups Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(568083,15781,'pr','3dcart Markups Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(568084,15781,'tr','3dcart nakliye iÅŸaretlemeleri baÅŸarÄ±yla alÄ±ndÄ±',0),(568085,15781,'pl','3dcart wysyÅ‚ka znacznikÃ³w Å¹rÃ³dÅ‚o pomyÅ›lnie',0),(568086,15781,'bg','3dcart Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Markups Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(568087,15781,'ur','3dcart Ø´Ù¾Ù†Ú¯ Ù…Ø¢Ø±Ú©Ùˆ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÙˆØ±Ø§ Ú©ÛŒØ§',0),(568088,15781,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ ÐœÐ°Ñ€ÐºÑƒÐ¿Ñ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ð°',0),(568089,15781,'vi','3dcart váº­n chuyá»ƒn Markups láº¥y thÃ nh cÃ´ng',0),(568090,15781,'af','3dcart gestuur Markups suksesvol herwin',0),(568091,15781,'ro','Marcajele de expediere 3dcart adus cu succes',0),(568092,15781,'et','3dcart laevanduse mÃ¤rgete vÃ¤lja otsitud edukalt',0),(568093,15781,'si','3dcart dostava oznak uspeÅ¡no pridobljene.',0),(568094,15781,'ba','3dcart pengiriman markup diperoleh berhasil',0),(568095,15781,'nl','3dcart scheepvaart markeringen met succes ontvangen',0),(568096,15781,'fi','3dcart toimitus katteet onnistui',0),(568097,15781,'no','3dcart frakt markeringer vellykket',0),(568098,15781,'da','3dcart Shipping opmÃ¦rkninger hentet med succes',0),(568099,15781,'ko','3dcart ë°°ì†¡ ë§ˆí¬ì—…ì´ ì„±ê³µì ìœ¼ë¡œ ê²€ìƒ‰',0),(568100,15781,'he','3dcart ×”×¡×¤× ×•×ª ×¡×™×ž×•× ×™× ×©××•×—×–×¨ ×‘×”×¦×œ×—×”',0),(568101,15781,'el','3dcart Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÏ‰Î½ Î±Î½Î±ÎºÏ„Î¬Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(568102,15781,'zh','3dcart è¿è¾“æ ‡è®°æˆåŠŸæ£€ç´¢',0),(568103,15781,'sv','3dcart frakt markeringar HÃ¤mtad framgÃ¥ngsrikt',0),(568104,15781,'it','3Dcart spedizione marcature Estratto con successo',0),(568105,15781,'tl','',0),(568106,15781,'th','à¹€à¸£à¸µà¸¢à¸à¸¡à¸²à¸£à¹Œà¸„ 3dcart à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(568107,15781,'hi','3dcart à¤¶à¤¿à¤ªà¤¿à¤‚à¤— Markups à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(568108,15781,'ms','3dcart penghantaran sedia diambil berjaya',0),(568109,15781,'ar','Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø´Ø­Ù† 3dcart Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø¨Ù†Ø¬Ø§Ø­',0),(568110,15781,'fr','3Dcart expÃ©dition annotations extrait avec succÃ¨s',0),(568111,15781,'jp','æ­£å¸¸ã«å–å¾—ã•ã‚ŒãŸ 3dcart é€æ–™ãƒžãƒ¼ã‚¯ã‚¢ãƒƒãƒ—',0),(568112,15781,'pt','MarcaÃ§Ãµes de transporte 3Dcart obtidas com sucesso',0),(568113,15781,'ru','3dcart Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ð¾Ð¼ÐµÑ‚Ð¾Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(568114,15781,'es','Marcas de envÃ­o 3DCart obtenido con Ã©xito',0),(568115,15781,'de','3dcart Versand Markierungen erfolgreich abgerufen',0),(568116,15781,'en','3dcart Shipping Markups Retrieved Successfully',0),(568117,15782,'is','',0),(568118,15782,'dr','3dcart Ú©Ø´ØªÛŒ ØªÙˆØ³Ø· Ø®ÙˆØ¯ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ',0),(568119,15782,'pr','3dcart Ú©Ø´ØªÛŒ ØªÙˆØ³Ø· Ø®ÙˆØ¯ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ',0),(568120,15782,'tr','3dcart gemileri tarafÄ±ndan kendisi ayarlarÄ± baÅŸarÄ±yla alÄ±ndÄ±',0),(568121,15782,'pl','3dcart statkÃ³w przez siebie ustawienia Å¹rÃ³dÅ‚o pomyÅ›lnie',0),(568122,15782,'bg','3dcart ÐºÐ¾Ñ€Ð°Ð±Ð¸ Ð¾Ñ‚ ÑÐ°Ð¼Ð°Ñ‚Ð° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(568123,15782,'ur','3dcart Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²ÙˆÚº Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø®ÙˆØ¯ Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÙˆØ±Ø§ Ú©ÛŒØ§',0),(568124,15782,'sr','3Ð´Ñ†Ð°Ñ€Ñ‚ Ð±Ñ€Ð¾Ð´Ð¾Ð²Ð¸ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ ÑÐ°Ð¼Ð¾Ð³ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð¿Ñ€ÐµÑƒÐ·ÐµÑ‚Ðµ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(568125,15782,'vi','3dcart tÃ u cá»§a chÃ­nh nÃ³ cÃ i Ä‘áº·t láº¥y thÃ nh cÃ´ng',0),(568126,15782,'af','3dcart skepe deur self instellings herwin suksesvol',0),(568127,15782,'ro','3dcart nave de sine setÄƒrile adus cu succes',0),(568128,15782,'et','3dcart laevade poolt ise seaded vÃ¤lja otsitud edukalt',0),(568129,15782,'si','3dcart ladje, ki jih sama nastavitve uspeÅ¡no pridobljene.',0),(568130,15782,'ba','3dcart kapal oleh sendiri pengaturan diperoleh berhasil',0),(568131,15782,'nl','3dcart schepen door zelf instellingen ontvangen met succes',0),(568132,15782,'fi','3dcart aluksia itse asetukset Haettu onnistuneesti',0),(568133,15782,'no','3dcart skip ved selve innstillinger Hentet vellykket',0),(568134,15782,'da','3dcart skibe af selve indstillinger hentes med succes',0),(568135,15782,'ko','ì— ì˜í•´ 3dcart ë°°ì†¡ ìžì²´ ì„¤ì • ê²€ìƒ‰ ì„±ê³µì ìœ¼ë¡œ',0),(568136,15782,'he','×¡×¤×™× ×•×ª 3dcart ×¢×œ ×™×“×™ ×¢×¦×ž×• ×”×’×“×¨×•×ª ×©××•×—×–×¨ ×‘×”×¦×œ×—×”',0),(568137,15782,'el','3dcart Ï€Î»Î¿Î¯Ï‰Î½ Î±Ï€ÏŒ Ï„Î·Î½ Î¯Î´Î¹Î± ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Î±Î½Î±ÎºÏ„Î·Î¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(568138,15782,'zh','3dcart èˆ¹èˆ¶æœ¬èº«è®¾ç½®æˆåŠŸæ£€ç´¢',0),(568139,15782,'sv','3dcart fartyg av sig instÃ¤llningar HÃ¤mtad framgÃ¥ngsrikt',0),(568140,15782,'it','3Dcart navi da sÃ© le impostazioni recuperate con successo',0),(568141,15782,'tl','',0),(568142,15782,'th','à¹€à¸£à¸·à¸­ 3dcart à¹‚à¸”à¸¢ à¸•à¸±à¸§à¹€à¸­à¸‡à¸„à¹ˆà¸²à¸¡à¸²à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(568143,15782,'hi','3dcart à¤œà¤¹à¤¾à¤œà¥‹à¤‚ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¹à¥€ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(568144,15782,'ms','3dcart kapal-kapal dengan sendirinya seting diambil berjaya',0),(568145,15782,'ar','Ø§Ù„Ø³ÙÙ† 3dcart Ø¨Ø­Ø¯ Ø°Ø§ØªÙ‡ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø¨Ù†Ø¬Ø§Ø­',0),(568146,15782,'fr','3Dcart navires par elle-mÃªme paramÃ¨tres rÃ©cupÃ©rÃ©s avec succÃ¨s',0),(568147,15782,'jp','3dcart èˆ¹è‡ªä½“ã®è¨­å®šãŒæ­£å¸¸ã«å–å¾—',0),(568148,15782,'pt','3Dcart navios por si sÃ³ configuraÃ§Ãµes recuperado com Ãªxito',0),(568149,15782,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»Ð¸ 3dcart ÑÐ°Ð¼ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð²Ð»ÐµÑ‡ÐµÐ½',0),(568150,15782,'es','3DCart naves por sÃ­ recuperan la configuraciÃ³n con Ã©xito',0),(568151,15782,'de','3dcart Schiffe von selbst Einstellungen erfolgreich abgerufen',0),(568152,15782,'en','3dcart Ships By Itself Settings Retrieved Successfully',0),(568153,15783,'is','',0),(568154,15783,'dr','Ø§Ù‚Ù„Ø§Ù… ÙˆØ§Ø±Ø¯Ø§Øª Ø±Ø§ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart Ø§Ú¯Ø± Ù†Ù‡ Ø¯Ø± Ø§ÛŒÙ† Ø³ÛŒØ³ØªÙ…',0),(568155,15783,'pr','Ø§Ù‚Ù„Ø§Ù… ÙˆØ§Ø±Ø¯Ø§Øª Ø±Ø§ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart Ø§Ú¯Ø± Ù†Ù‡ Ø¯Ø± Ø§ÛŒÙ† Ø³ÛŒØ³ØªÙ…',0),(568156,15783,'tr','Bu 3dcart deposundan olmasa bile bu sistemde Ã¶ÄŸeleri alma',0),(568157,15783,'pl','Importuj elementy z tego sklepu 3dcart, jeÅ›li nie w tym systemie',0),(568158,15783,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð¾Ñ‚ Ñ‚Ð¾Ð²Ð° 3dcart Ñ…Ñ€Ð°Ð½Ð¸Ð»Ð¸Ñ‰Ðµ, Ð°ÐºÐ¾ Ð½Ðµ Ð² Ñ‚Ð°Ð·Ð¸ ÑÐ¸ÑÑ‚ÐµÐ¼Ð°',0),(568159,15783,'ur','ÛŒÛ 3dcart Ø§Ø³Ù¹ÙˆØ± Ø³Û’ ÛÛŒ Ø³ÛÛŒ Ø§Ø³ Ù†Ø¸Ø§Ù… Ù…ÛŒÚº Ø§Ø´ÛŒØ§Ø¡ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(568160,15783,'sr','Ð£Ð²Ð¾Ð· ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¸Ð· Ð¾Ð²Ð¾Ð³ 3Ð´Ñ†Ð°Ñ€Ñ‚ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð°, Ð°ÐºÐ¾ Ð½Ðµ Ñƒ Ð¾Ð²Ð¾Ð¼ ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ',0),(568161,15783,'vi','Nháº­p kháº©u máº·t hÃ ng tá»« cá»­a hÃ ng 3dcart nÃ y náº¿u khÃ´ng pháº£i trong há»‡ thá»‘ng nÃ y',0),(568162,15783,'af','Invoer van Items uit hierdie 3dcart Winkel indien nie die droogste In hierdie stelsel',0),(568163,15783,'ro','Import elemente din acest magazin 3dcart, dacÄƒ nu Ã®n acest sistem',0),(568164,15783,'et','Impordi Ã¼ksused 3dcart poest, kui mitte selles sÃ¼steemis',0),(568165,15783,'si','Uvozi elemente iz 3dcart trgovino, Äe ne v tem sistemu',0),(568166,15783,'ba','Impor item dari toko 3dcart ini jika tidak dalam sistem ini',0),(568167,15783,'nl','Items importeren uit deze winkel 3dcart, zo niet In dit systeem',0),(568168,15783,'fi','Tuo kohteet tÃ¤stÃ¤ 3dcart sÃ¤ilÃ¶stÃ¤, jos ei tÃ¤mÃ¤ jÃ¤rjestelmÃ¤',0),(568169,15783,'no','Importer elementer fra denne 3dcart butikken om ikke i dette systemet',0),(568170,15783,'da','Importer emner fra denne 3dcart butik, hvis ikke i dette System',0),(568171,15783,'ko','ì´ ì‹œìŠ¤í…œì— ì—†ëŠ” ê²½ìš°ì´ 3dcart ì €ìž¥ì†Œì—ì„œ í•­ëª© ê°€ì ¸ì˜¤ê¸°',0),(568172,15783,'he','×™×™×‘×•× ×¤×¨×™×˜×™× ×ž×”×—× ×•×ª 3dcart ×× ×œ× ×‘×ž×¢×¨×›×ª ×”×–×•',0),(568173,15783,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ Î±Ï€ÏŒ Ï„Î¿ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± 3dcart, Î±Î½ ÏŒÏ‡Î¹ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(568174,15783,'zh','ä»Žè¿™ä¸ª 3dcart åº—å¦‚æžœä¸æ˜¯åœ¨æ­¤ç³»ç»Ÿä¸­å¯¼å…¥çš„é¡¹ç›®',0),(568175,15783,'sv','Importera objekt frÃ¥n denna 3dcart butik om inte i detta System',0),(568176,15783,'it','Importazione di elementi da questo negozio 3dcart se non In questo sistema',0),(568177,15783,'tl','',0),(568178,15783,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ªà¸´à¸™à¸„à¹‰à¸² à¸ˆà¸²à¸ à¸£à¹‰à¸²à¸™ 3dcart à¸™à¸µà¹‰à¸–à¹‰à¸² à¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸°à¸šà¸šà¸™à¸µà¹‰',0),(568179,15783,'hi','à¤‡à¤¸ à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤¤à¥‹ à¤‡à¤¸ 3dcart à¤¸à¥à¤Ÿà¥‹à¤° à¤¸à¥‡ à¤†à¤‡à¤Ÿà¤® à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(568180,15783,'ms','Mengimport barangan dari kedai 3dcart ini jika tidak dalam sistem ini',0),(568181,15783,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¹Ù†Ø§ØµØ± Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²Ù† 3dcart Ø£Ù† Ù„Ù… ÙŠÙƒÙ† ÙÙŠ Ù‡Ø°Ø§ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(568182,15783,'fr','Importer des Ã©lÃ©ments de ce magasin 3dcart sinon dans ce systÃ¨me',0),(568183,15783,'jp','ã“ã®ã‚·ã‚¹ãƒ†ãƒ ã¯ã¨ã‚‚ã‹ãã“ã® 3dcart ã‚¹ãƒˆã‚¢ã‹ã‚‰ã‚¢ã‚¤ãƒ†ãƒ ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(568184,15783,'pt','Importar itens desta loja 3dcart se nÃ£o for neste sistema',0),(568185,15783,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð² Ð¸Ð· ÑÑ‚Ð¾Ð³Ð¾ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð° 3dcart, ÐµÑÐ»Ð¸ Ð½Ðµ Ð² ÑÑ‚Ð¾Ð¹ ÑÐ¸ÑÑ‚ÐµÐ¼Ðµ',0),(568186,15783,'es','Importar artÃ­culos de esta tienda 3dcart, si no en este sistema',0),(568187,15783,'de','Importieren von Elementen aus diesem 3dcart, wenn nicht In diesem System',0),(568188,15783,'en','Import Items From This 3dcart Store If Not In This System',0),(568189,15784,'is','',0),(568190,15784,'dr','ÙˆØ§Ø±Ø¯ Markups Ø±Ø§ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(568191,15784,'pr','ÙˆØ§Ø±Ø¯ Markups Ø±Ø§ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(568192,15784,'tr','Bu 3dcart maÄŸazadan iÅŸaretlemeleri nakliye ithalat',0),(568193,15784,'pl','ImportowaÄ‡, wysyÅ‚ka znacznikÃ³w z tego sklepu 3dcart',0),(568194,15784,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Markups Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ 3dcart ÐœÐ°Ð³Ð°Ð·Ð¸Ð½',0),(568195,15784,'ur','Ù…Ø¢Ø±Ú©Ùˆ Ø§Ø³ 3dcart Ú©ÛŒ Ø¯Ú©Ø§Ù† Ø³Û’ Ø´Ù¾Ù†Ú¯ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(568196,15784,'sr','Ð£Ð²Ð¾Ð· Ð¸Ð· Ð¾Ð²Ð¾Ð³ 3Ð´Ñ†Ð°Ñ€Ñ‚ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð° Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ ÐœÐ°Ñ€ÐºÑƒÐ¿Ñ',0),(568197,15784,'vi','Nháº­p kháº©u váº­n chuyá»ƒn Markups tá»« cá»­a hÃ ng nÃ y 3dcart',0),(568198,15784,'af','Voer Markups uit hierdie 3dcart Winkel gestuur',0),(568199,15784,'ro','ImportaÅ£i marcaje de transport maritim din acest magazin 3dcart',0),(568200,15784,'et','Importida Shipping mÃ¤rgete see 3dcart pood',0),(568201,15784,'si','Uvoz ladijskega oznak iz te shrambe 3dcart',0),(568202,15784,'ba','Impor pengiriman markup dari toko 3dcart ini',0),(568203,15784,'nl','Importeren markeringen van deze winkel 3dcart verschepen',0),(568204,15784,'fi','Tuo toimitus katteet 3dcart Store',0),(568205,15784,'no','Importere frakt markeringer fra denne 3dcart butikken',0),(568206,15784,'da','Importere Shipping opmÃ¦rkninger fra denne 3dcart butik',0),(568207,15784,'ko','ì´ 3dcartê°€ ê²Œì—ì„œ ë§ˆí¬ì—…ì„ ë°°ì†¡ ê°€ì ¸ì˜¤ê¸°',0),(568208,15784,'he','×™×™×‘× ×ž×©×œ×•×— ×¡×™×ž×•× ×™ ×ž×ž××’×¨ ×–×” 3dcart',0),(568209,15784,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î½Î±Ï…Ï„Î¹Î»Î¹Î±ÎºÏŽÎ½ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± 3dcart',0),(568210,15784,'zh','å¯¼å…¥ä»Ž 3dcart æœ¬åº—å‘è´§æ ‡è®°',0),(568211,15784,'sv','Importera frakt markeringar frÃ¥n denna 3dcart butik',0),(568212,15784,'it','Importare spedizione marcature da questo negozio 3dcart',0),(568213,15784,'tl','',0),(568214,15784,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸¡à¸²à¸£à¹Œà¸„à¸ˆà¸²à¸à¸£à¹‰à¸²à¸™ 3dcart à¸™à¸µà¹‰',0),(568215,15784,'hi','à¤†à¤¯à¤¾à¤¤ à¤‡à¤¸ 3dcart à¤¸à¥à¤Ÿà¥‹à¤° à¤¸à¥‡ Markups à¤¶à¤¿à¤ªà¤¿à¤‚à¤—',0),(568216,15784,'ms','Mengimport penghantaran sedia dari kedai 3dcart ini',0),(568217,15784,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø´Ø­Ù† Ù‡ÙˆØ§Ù…Ø´ Ø§Ù„Ø±Ø¨Ø­ Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²Ù† 3dcart',0),(568218,15784,'fr','Importer des annotations dâ€™expÃ©dition de ce magasin de 3dcart',0),(568219,15784,'jp','ã“ã® 3dcart ã‚¹ãƒˆã‚¢ã‹ã‚‰ãƒžãƒ¼ã‚¯ã‚¢ãƒƒãƒ—ã‚’é€æ–™ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(568220,15784,'pt','ImportaÃ§Ã£o de marcaÃ§Ãµes de transporte desta loja 3dcart',0),(568221,15784,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚, Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ° Ð¿Ð¾Ð¼ÐµÑ‚ÐºÐ¸ Ð¸Ð· ÑÑ‚Ð¾Ð³Ð¾ Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð° 3dcart',0),(568222,15784,'es','Importar marcas de envÃ­o de esta tienda 3dcart',0),(568223,15784,'de','Importieren Sie Markierungen von diesem 3dcart Shop Versand',0),(568224,15784,'en','Import Shipping Markups From This 3dcart Store',0),(568225,15785,'is','',0),(568226,15785,'dr','Ú©Ø´ØªÛŒ Ù‡Ø§ÛŒ Ø®ÙˆØ¯ÛŒ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ØªÙ†Ø¸ÛŒÙ…Ø§Øª',0),(568227,15785,'pr','Ú©Ø´ØªÛŒ Ù‡Ø§ÛŒ Ø®ÙˆØ¯ÛŒ Ø§Ø² Ø§ÛŒÙ† ÙØ±ÙˆØ´Ú¯Ø§Ù‡ 3dcart ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† ØªÙ†Ø¸ÛŒÙ…Ø§Øª',0),(568228,15785,'tr','Gemi tek baÅŸÄ±na bu 3dcart deposundan ayarlarÄ±nÄ± almak',0),(568229,15785,'pl','ZaimportowaÄ‡ statkÃ³w przez siebie ustawienia z tego sklepu 3dcart',0),(568230,15785,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ¾Ñ€Ð°Ð±Ð¸ Ð¾Ñ‚ ÑÐ°Ð¼Ð¾ ÑÐµÐ±Ðµ ÑÐ¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ 3dcart ÐœÐ°Ð³Ð°Ð·Ð¸Ð½',0),(568231,15785,'ur','Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ø®ÙˆØ¯ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº Ø§Ø³ 3dcart Ú©ÛŒ Ø¯Ú©Ø§Ù† Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(568232,15785,'sr','Ð£Ð²Ð¾Ð· Ð±Ñ€Ð¾Ð´Ð¾Ð²Ð° ÑÐ°Ð¼Ð° Ð¾Ð´ ÑÐµÐ±Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð¸Ð· Ð¾Ð²Ð¾Ð³ 3Ð´Ñ†Ð°Ñ€Ñ‚ ÑÐºÐ»Ð°Ð´Ð¸ÑˆÑ‚Ð°',0),(568233,15785,'vi','Nháº­p tÃ u cá»§a chÃ­nh nÃ³ cÃ i Ä‘áº·t tá»« cá»­a hÃ ng nÃ y 3dcart',0),(568234,15785,'af','Invoerinstellings skepe vanself uit hierdie 3dcart Winkel',0),(568235,15785,'ro','SetÄƒrile de import nave de la sine din acest magazin 3dcart',0),(568236,15785,'et','Laevad ise seadete importimine see 3dcart pood',0),(568237,15785,'si','Uvoz ladje sama nastavitev iz te shrambe 3dcart',0),(568238,15785,'ba','Impor kapal sendiri pengaturan dari toko 3dcart ini',0),(568239,15785,'nl','Schepen zelf instellingen importeren uit deze 3dcart winkel',0),(568240,15785,'fi','Alusten yksinÃ¤Ã¤n asetusten tuominen 3dcart Store',0),(568241,15785,'no','Importere skip selv innstillinger fra denne 3dcart butikken',0),(568242,15785,'da','Importere skibe ved selve indstillinger fra denne 3dcart butik',0),(568243,15785,'ko','ë°°ì†¡ ìžì²´ì—ì„œ ì„¤ì •ì„ ê°€ì ¸ì˜¬ì´ 3dcart ì €ìž¥ì†Œ',0),(568244,15785,'he','×™×™×‘×•× ×¡×¤×™× ×•×ª ×‘×¤× ×™ ×¢×¦×ž×• ×”×’×“×¨×•×ª ×ž×”×—× ×•×ª 3dcart',0),(568245,15785,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï€Î»Î¿Î¯Î± Î±Ï€ÏŒ Î¼ÏŒÎ½Î· ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ±Ï„Î¬ÏƒÏ„Î·Î¼Î± 3dcart',0),(568246,15785,'zh','ä»Žå¯¼å…¥èˆ¹èˆ¶æœ¬èº«è®¾ç½®æ­¤ 3dcart å­˜å‚¨',0),(568247,15785,'sv','ImportinstÃ¤llningar fartyg av sig sjÃ¤lv frÃ¥n denna 3dcart butik',0),(568248,15785,'it','Importazione di navi di per sÃ© impostazioni da questo negozio 3dcart',0),(568249,15785,'tl','',0),(568250,15785,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸£à¸·à¸­ à¸”à¹‰à¸§à¸¢à¸•à¸±à¸§à¹€à¸­à¸‡à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ˆà¸²à¸à¸£à¹‰à¸²à¸™ 3dcart à¸™à¸µà¹‰',0),(568251,15785,'hi','à¤œà¤¹à¤¾à¤œà¥‹à¤‚ à¤¸à¥‡ à¤¹à¥€ à¤‡à¤¸ 3dcart à¤¸à¥à¤Ÿà¥‹à¤° à¤¸à¥‡ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(568252,15785,'ms','Import kapal dengan sendirinya seting dari kedai 3dcart ini',0),(568253,15785,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ø³ÙÙ† Ø¨Ù†ÙØ³Ù‡Ø§ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ù…Ù† Ù‡Ø°Ø§ Ø§Ù„Ù…Ø®Ø²Ù† 3dcart',0),(568254,15785,'fr','Importer navires par lui-mÃªme les paramÃ¨tres de ce magasin de 3dcart',0),(568255,15785,'jp','ã“ã® 3dcart ã‚¹ãƒˆã‚¢ã‹ã‚‰è¨­å®šè‡ªä½“ã«ã‚ˆã£ã¦èˆ¹ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(568256,15785,'pt','Importar navios por si sÃ³, configuraÃ§Ãµes da loja 3dcart',0),(568257,15785,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÐºÐ¾Ñ€Ð°Ð±Ð»Ð¸ ÑÐ°Ð¼Ð° Ð¿Ð¾ ÑÐµÐ±Ðµ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð² Ð¸Ð· ÑÑ‚Ð¾Ð¹ 3dcart Ð¼Ð°Ð³Ð°Ð·Ð¸Ð½Ð°',0),(568258,15785,'es','Importar naves por sÃ­ misma configuraciÃ³n desde esta tienda 3dcart',0),(568259,15785,'de','Importeinstellungen Sie Schiffe selbst von diesem 3dcart Shop',0),(568260,15785,'en','Import Ships By Itself Settings From This 3dcart Store',0),(568261,15786,'is','',0),(568262,15786,'dr','3dcart Markups Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(568263,15786,'pr','3dcart Markups Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(568264,15786,'tr','3dcart nakliye iÅŸaretlerini otomatik olarak gÃ¼ncelleÅŸtir',0),(568265,15786,'pl','Automatycznie zaktualizowaÄ‡ 3dcart wysyÅ‚ka znacznikÃ³w',0),(568266,15786,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° 3dcart ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ ÐºÐ¾Ñ€ÐµÐºÑ‚ÑƒÑ€Ð¸',0),(568267,15786,'ur','3dcart Ø´Ù¾Ù†Ú¯ Ù…Ø¢Ø±Ú©Ùˆ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(568268,15786,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ 3Ð´Ñ†Ð°Ñ€Ñ‚ ÐœÐ°Ñ€ÐºÑƒÐ¿Ñ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(568269,15786,'vi','Tá»± Ä‘á»™ng Cáº­p Nháº­t 3dcart váº­n chuyá»ƒn Markups',0),(568270,15786,'af','3dcart gestuur Markups outomaties opdateer',0),(568271,15786,'ro','Actualizarea marcaje de transport 3dcart automat',0),(568272,15786,'et','3dcart laevanduse mÃ¤rgete automaatse vÃ¤rskendamise',0),(568273,15786,'si','3dcart dostava oznak samodejno posodobi',0),(568274,15786,'ba','Memperbarui 3dcart pengiriman markup secara otomatis',0),(568275,15786,'nl','Automatisch bijwerken van 3dcart scheepvaart markeringen',0),(568276,15786,'fi','PÃ¤ivitÃ¤ 3dcart toimitus katteet automaattisesti',0),(568277,15786,'no','Oppdatere 3dcart Shipping markeringer automatisk',0),(568278,15786,'da','Opdatere 3dcart Shipping opmÃ¦rkninger automatisk',0),(568279,15786,'ko','3dcart ë°°ì†¡ ë§ˆí¬ì—…ì„ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(568280,15786,'he','×¢×“×›×Ÿ ××•×˜×•×ž×˜×™×ª ×œ×¡×™×ž×•× ×™× ×ž×©×œ×•×— 3dcart',0),(568281,15786,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart Î½Î±Ï…Ï„Î¹Î»Î¯Î± Ï€ÏÎ¿ÏƒÎ±Ï…Î¾Î®ÏƒÎµÎ¹Ï‚ Î³Î¹Î± Ï„Î· Î´Î¹Î±Î¼ÏŒÏÏ†Ï‰ÏƒÎ·',0),(568282,15786,'zh','è‡ªåŠ¨æ›´æ–° 3dcart èˆªè¿æ ‡è®°',0),(568283,15786,'sv','Uppdatera 3dcart frakt markeringar automatiskt',0),(568284,15786,'it','Aggiornare automaticamente 3dcart spedizione marcature',0),(568285,15786,'tl','',0),(568286,15786,'th','à¸¡à¸²à¸£à¹Œà¸„ 3dcart à¸ªà¹ˆà¸‡à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(568287,15786,'hi','3dcart à¤¶à¤¿à¤ªà¤¿à¤‚à¤— Markups à¤•à¥‹ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(568288,15786,'ms','Kemas kini 3dcart penghantaran sedia secara automatik',0),(568289,15786,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨ØªØ­Ø¯ÙŠØ« Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø´Ø­Ù† 3dcart',0),(568290,15786,'fr','Mettre Ã  jour automatiquement les annotations de livraison 3dcart',0),(568291,15786,'jp','3dcart é€æ–™ãƒžãƒ¼ã‚¯ã‚¢ãƒƒãƒ—ã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(568292,15786,'pt','Atualizar automaticamente o 3dcart marcaÃ§Ãµes de transporte',0),(568293,15786,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ð¾Ð¼ÐµÑ‚Ð¾Ðº',0),(568294,15786,'es','Actualicen 3dcart envÃ­o marcados automÃ¡ticamente',0),(568295,15786,'de','3dcart Versand Markierungen automatisch aktualisieren',0),(568296,15786,'en','Update 3dcart Shipping Markups Automatically',0),(568297,15787,'is','',0),(568298,15787,'dr','3dcart Ú©Ø´ØªÛŒ Ù‡Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¨Ù‡ Ø®ÙˆØ¯ÛŒ Ø®ÙˆØ¯ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø±',0),(568299,15787,'pr','3dcart Ú©Ø´ØªÛŒ Ù‡Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¨Ù‡ Ø®ÙˆØ¯ÛŒ Ø®ÙˆØ¯ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø±',0),(568300,15787,'tr','3dcart gemi tek baÅŸÄ±na ayarlarÄ±nÄ± gÃ¼ncelleÅŸtirme otomatik olarak',0),(568301,15787,'pl','Aktualizacja 3dcart statkÃ³w przez siebie ustawienia automatycznie',0),(568302,15787,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð°Ñ†Ð¸Ñ 3dcart ÐºÐ¾Ñ€Ð°Ð±Ð¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾',0),(568303,15787,'ur','3dcart Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø²ÙˆÚº Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø®ÙˆØ¯ ØªØ±ØªÛŒØ¨Ø§Øª Ú©ÛŒ ØªØ¬Ø¯ÛŒØ¯ Ø®ÙˆØ¯ Ú©Ø§Ø± Ø·ÙˆØ± Ù¾Ø±',0),(568304,15787,'sr','Ð˜ÑÐ¿Ñ€Ð°Ð²ÐºÐ° 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð±Ñ€Ð¾Ð´Ð¾Ð²Ð° ÑÐ°Ð¼Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸',0),(568305,15787,'vi','Cáº­p Nháº­t 3dcart tÃ u cá»§a chÃ­nh nÃ³ cÃ i Ä‘áº·t tá»± Ä‘á»™ng',0),(568306,15787,'af','Werk by 3dcart skepe deur self instellings outomaties',0),(568307,15787,'ro','Actualizare 3dcart nave Ã®n sine setÄƒrile automat',0),(568308,15787,'et','VÃ¤rskenduse 3dcart laevad ise seadeid automaatselt',0),(568309,15787,'si','Posodobitev ladij 3dcart nastavitve samodejno',0),(568310,15787,'ba','Memperbarui 3dcart kapal dengan sendirinya pengaturan otomatis',0),(568311,15787,'nl','Bijwerken van 3dcart schepen zelf instellingen automatisch',0),(568312,15787,'fi','3dcart alukset itse asetusten pÃ¤ivittÃ¤minen automaattisesti',0),(568313,15787,'no','Oppdateringen 3dcart skip alene innstillinger automatisk',0),(568314,15787,'da','Opdatere 3dcart skibe ved selve indstillinger automatisk',0),(568315,15787,'ko','ìžì²´ ì—…ë°ì´íŠ¸ 3dcart ë°°ì†¡ ì„¤ì • ìžë™ìœ¼ë¡œ',0),(568316,15787,'he','×¢×“×›×•×Ÿ 3dcart ×¡×¤×™× ×•×ª ×‘×¤× ×™ ×¢×¦×ž×• ×”×’×“×¨×•×ª ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(568317,15787,'el','Î•Î½Î·Î¼ÎµÏÏ‰Î¸ÎµÎ¯ 3dcart Ï€Î»Î¿Î¯Î± Î¼ÏŒÎ½Î¿ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î±',0),(568318,15787,'zh','æ›´æ–° 3dcart èˆ¹èˆ¶æœ¬èº«è®¾ç½®è‡ªåŠ¨',0),(568319,15787,'sv','Uppdatera 3dcart fartyg i sig instÃ¤llningarna automatiskt',0),(568320,15787,'it','Aggiornare 3dcart navi da sÃ© le impostazioni automaticamente',0),(568321,15787,'tl','',0),(568322,15787,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡ 3dcart à¹€à¸£à¸·à¸­ à¸”à¹‰à¸§à¸¢à¸•à¸±à¸§à¹€à¸­à¸‡à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(568323,15787,'hi','3dcart à¤œà¤¹à¤¾à¤œà¥‹à¤‚ à¤¸à¥‡ à¤¹à¥€ à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡',0),(568324,15787,'ms','Kemaskini Terakhir 3dcart kapal dengan sendirinya seting secara automatik',0),(568325,15787,'ar','ØªØ­Ø¯ÙŠØ« Ø§Ù„Ø³ÙÙ† 3dcart Ø¨Ù†ÙØ³Ù‡Ø§ Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹',0),(568326,15787,'fr','Mise Ã  jour 3dcart navires par lui-mÃªme les paramÃ¨tres automatiquement',0),(568327,15787,'jp','è¨­å®šè‡ªä½“ãŒ 3dcart èˆ¹ã‚’æ›´æ–°ã«è‡ªå‹•çš„ã«',0),(568328,15787,'pt','Atualizar 3dcart navios por si sÃ³ configuraÃ§Ãµes automaticamente',0),(568329,15787,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart ÑÑƒÐ´Ð° ÑÐ°Ð¼Ð¾ Ð¿Ð¾ ÑÐµÐ±Ðµ Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸',0),(568330,15787,'es','Actualizar 3dcart naves por sÃ­ mismo los parÃ¡metros automÃ¡ticamente',0),(568331,15787,'de','3dcart Schiffe von selbst Einstellungen aktualisieren automatisch',0),(568332,15787,'en','Update 3dcart Ships By Itself Settings Automatically',0),(568333,15788,'is','',0),(568334,15788,'dr','Ø¨Ù„ÙˆÚ© Unposting ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(568335,15788,'pr','Ø¨Ù„ÙˆÚ© Unposting ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(568336,15788,'tr','Unposting faturalarÄ± engellemek',0),(568337,15788,'pl','ZablokowaÄ‡ wycofania faktury',0),(568338,15788,'bg','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ðµ Unposting Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(568339,15788,'ur','Ø§Ù†Ù¾ÙˆØ³Ù¹Ø§Ù†Ú¯ ÙˆØ¨Ø¬Ù„ÛŒ Ø¨Ù„Ø§Ú©',0),(568340,15788,'sr','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð° Ð£Ð½Ð¿Ð¾ÑÑ‚Ð¸Ð½Ð³ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(568341,15788,'vi','NgÄƒn cháº·n Unposting hÃ³a Ä‘Æ¡n',0),(568342,15788,'af','Blok Unposting fakture',0),(568343,15788,'ro','Bloc Unposting facturi',0),(568344,15788,'et','Blokeerida Unposting arved',0),(568345,15788,'si','Blok Unposting raÄuni',0),(568346,15788,'ba','Memblokir Unposting faktur',0),(568347,15788,'nl','Blokkeren Unposting facturen',0),(568348,15788,'fi','EstÃ¤Ã¤ Unposting laskut',0),(568349,15788,'no','Blokkere Unposting fakturaer',0),(568350,15788,'da','Blokere Unposting fakturaer',0),(568351,15788,'ko','Unposting ì†¡ìž¥ ì°¨ë‹¨',0),(568352,15788,'he','×œ×—×¡×•× ××ª ×—×©×‘×•× ×™×•×ª Unposting',0),(568353,15788,'el','ÎœÏ€Î»Î¿Îº Unposting Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(568354,15788,'zh','é˜»æ­¢ Unposting å‘ç¥¨',0),(568355,15788,'sv','Blockera Unposting fakturor',0),(568356,15788,'it','Bloccare le fatture Unposting',0),(568357,15788,'tl','',0),(568358,15788,'th','à¸šà¸¥à¹‡à¸­à¸ Unposting à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(568359,15788,'hi','à¤¬à¥à¤²à¥‰à¤• Unposting à¤šà¤¾à¤²à¤¾à¤¨',0),(568360,15788,'ms','Blok Unposting invois',0),(568361,15788,'ar','ÙƒØªÙ„Ø© ÙÙˆØ§ØªÙŠØ± Ø£ÙˆÙ†Ø¨ÙˆØ³ØªÙŠÙ†Ø¬',0),(568362,15788,'fr','Bloquer les factures Unposting',0),(568363,15788,'jp','Unposting è«‹æ±‚æ›¸ã‚’ãƒ–ãƒ­ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(568364,15788,'pt','Bloco de facturas Unposting',0),(568365,15788,'ru','Ð‘Ð»Ð¾Ðº Unposting ÑÑ‡ÐµÑ‚Ð¾Ð²',0),(568366,15788,'es','Bloque de facturas Unposting',0),(568367,15788,'de','Unposting Rechnungen zu blockieren',0),(568368,15788,'en','Block Unposting Invoices',0),(568369,15789,'is','',0),(568370,15789,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø¹Ù„Ø§Ù‚Ù‡ Ø§ÛŒ ØªØ¹Ù„Ù‚ Ø¯Ø± ØµÙØ­Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(568371,15789,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø¹Ù„Ø§Ù‚Ù‡ Ø§ÛŒ ØªØ¹Ù„Ù‚ Ø¯Ø± ØµÙØ­Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(568372,15789,'tr','Tahakkuk eden faiz Ã¶deme sayfasÄ±nda gizle',0),(568373,15789,'pl','Ukryj narosÅ‚e odsetki na stronÄ™ pÅ‚atnoÅ›ci',0),(568374,15789,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸ Ð»Ð¸Ñ…Ð²Ð¸ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(568375,15789,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ ØµÙØ­Û’ Ù¾Ø± ØªÙ…Ø§Ù… ÛÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ø³ÙˆØ¯ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(568376,15789,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð°ÐºÑƒÐ¼ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ°Ð¼Ð°Ñ‚Ðµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(568377,15789,'vi','áº¨n lÃ£i tÃ­ch luá»¹ trÃªn trang thanh toÃ¡n',0),(568378,15789,'af','Versteek opgelope rente op betaling bladsy',0),(568379,15789,'ro','Ascunde dobÃ®nzi la plata filme',0),(568380,15789,'et','Peida kogunenud intressi maksmise lehele',0),(568381,15789,'si','Skriti obresti na plaÄila strani',0),(568382,15789,'ba','Menyembunyikan bunga yang terkumpul pada halaman pembayaran',0),(568383,15789,'nl','Rente op betalingspagina verbergen',0),(568384,15789,'fi','Piilota kertyneen koron maksu-sivulla',0),(568385,15789,'no','Skjule pÃ¥lÃ¸pte renter pÃ¥ betalingssiden',0),(568386,15789,'da','Skjule pÃ¥lÃ¸bne renter pÃ¥ betalingssiden',0),(568387,15789,'ko','ê²°ì œ íŽ˜ì´ì§€ì— ë°œìƒ í•œ ì´ìžë¥¼ ìˆ¨ê¸°ê¸°',0),(568388,15789,'he','×œ×”×¡×ª×™×¨ ××ª ×”×¨×™×‘×™×ª ×”×ž×¦×˜×‘×¨×ª ×‘×“×£ ×”×ª×©×œ×•×',0),(568389,15789,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î´ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Î¿Ï…Ï‚ Ï„ÏŒÎºÎ¿Ï…Ï‚ ÏƒÏ„Î· ÏƒÎµÎ»Î¯Î´Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(568390,15789,'zh','éšè—åº”è®¡çš„åˆ©æ¯ä»˜æ¬¾é¡µé¢',0),(568391,15789,'sv','DÃ¶lja upplupen rÃ¤nta pÃ¥ betalningssidan',0),(568392,15789,'it','Nascondere gli interessi maturati sulla pagina di pagamento',0),(568393,15789,'tl','',0),(568394,15789,'th','à¸‹à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²à¸Šà¸³à¸£à¸°à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¸„à¹‰à¸²à¸‡à¸£à¸±à¸š',0),(568395,15789,'hi','à¤‰à¤ªà¤¾à¤°à¥à¤œà¤¿à¤¤ à¤¬à¥à¤¯à¤¾à¤œ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤›à¥à¤ªà¤¾à¤à¤',0),(568396,15789,'ms','Sembunyi faedah terakru pada halaman pembayaran',0),(568397,15789,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„ÙØ§Ø¦Ø¯Ø© Ø§Ù„Ù…Ø³ØªØ­Ù‚Ø© Ø§Ù„Ø¯ÙØ¹ ÙÙŠ Ø§Ù„ØµÙØ­Ø©',0),(568398,15789,'fr','Cacher les intÃ©rÃªts courus sur la Page de paiement',0),(568399,15789,'jp','ãŠæ”¯æ‰•ã„ãƒšãƒ¼ã‚¸ã«ä¿‚ã‚‹æœªåŽåˆ©æ¯ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(568400,15789,'pt','Esconder os juros acumulados na pÃ¡gina de pagamento',0),(568401,15789,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(568402,15789,'es','Ocultar los intereses devengados en la pÃ¡gina de pago',0),(568403,15789,'de','Aufgelaufene Zinsen auf Zahlungsseite ausblenden',0),(568404,15789,'en','Hide Accrued Interest On Payment Page',0),(568405,15790,'is','',0),(568406,15790,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø¹Ù„Ø§Ù‚Ù‡ Ù…Ø·Ù„Ø¨ Ø¯Ø± ØµÙØ­Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(568407,15790,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø¹Ù„Ø§Ù‚Ù‡ Ù…Ø·Ù„Ø¨ Ø¯Ø± ØµÙØ­Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(568408,15790,'tr','Faiz giriÅŸ Ã¶deme sayfasÄ±nda gizle',0),(568409,15790,'pl','UkryÄ‡ zainteresowania wejÅ›cia na stronÄ™ pÅ‚atnoÅ›ci',0),(568410,15790,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ Ð·Ð°Ð¿Ð¸Ñ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(568411,15790,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ ØµÙØ­Û’ Ù¾Ø± Ø³ÙˆØ¯ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(568412,15790,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÐºÐ°Ð¼Ð°Ñ‚Ð° ÑÑ‚Ð°Ð²ÐºÐ¸ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(568413,15790,'vi','áº¨n má»¥c quan tÃ¢m vÃ o trang thanh toÃ¡n',0),(568414,15790,'af','Rente inskrywing op betaling bladsy versteek',0),(568415,15790,'ro','Ascunde interesul intrarea pe pagina de plÄƒÅ£i',0),(568416,15790,'et','Peida intressi kanne maksmise lehele',0),(568417,15790,'si','Skriti obresti vstop na strani plaÄila',0),(568418,15790,'ba','Menyembunyikan bunga entri pada halaman pembayaran',0),(568419,15790,'nl','Belang vermelding op betalingspagina verbergen',0),(568420,15790,'fi','Piilota etua merkintÃ¤ maksu sivulle',0),(568421,15790,'no','Skjule interesse oppfÃ¸ring pÃ¥ betalingssiden',0),(568422,15790,'da','Skjule interesse post pÃ¥ betalingssiden',0),(568423,15790,'ko','ê²°ì œ íŽ˜ì´ì§€ì—ì„œ ê´€ì‹¬ í•­ëª© ìˆ¨ê¸°ê¸°',0),(568424,15790,'he','×œ×”×¡×ª×™×¨ ××ª ×¢×¨×š ×”×¨×™×‘×™×ª ×‘×“×£ ×”×ª×©×œ×•×',0),(568425,15790,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÏƒÏ„Î· ÏƒÎµÎ»Î¯Î´Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(568426,15790,'zh','éšè—çš„å…´è¶£è¿›å…¥ä»˜æ¬¾é¡µé¢ä¸Š',0),(568427,15790,'sv','DÃ¶lja intresse intrÃ¤de pÃ¥ betalningssidan',0),(568428,15790,'it','Nascondere la voce di interesse nella pagina di pagamento',0),(568429,15790,'tl','',0),(568430,15790,'th','à¸‹à¹ˆà¸­à¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸™à¹ƒà¸ˆà¹ƒà¸™à¸«à¸™à¹‰à¸²à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(568431,15790,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥ƒà¤·à¥à¤  à¤ªà¤° à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤›à¥à¤ªà¤¾à¤à¤',0),(568432,15790,'ms','Menyembunyikan kepentingan entri pada halaman pembayaran',0),(568433,15790,'ar','Ø¥Ø®ÙØ§Ø¡ Ø¯Ø®ÙˆÙ„ Ø§Ù„ÙØ§Ø¦Ø¯Ø© Ø¹Ù„Ù‰ ØµÙØ­Ø© Ø§Ù„Ø¯ÙØ¹',0),(568434,15790,'fr','Masquer lâ€™entrÃ©e dâ€™intÃ©rÃªt sur la Page de paiement',0),(568435,15790,'jp','æ”¯æ‰•ã„ãƒšãƒ¼ã‚¸ã§èˆˆå‘³ã‚¨ãƒ³ãƒˆãƒªã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(568436,15790,'pt','Ocultar a entrada de interesse na pÃ¡gina de pagamento',0),(568437,15790,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(568438,15790,'es','Ocultar entrada de interÃ©s en la pÃ¡gina de pago',0),(568439,15790,'de','Interesse-Eintrag auf der Zahlungsseite zu verstecken',0),(568440,15790,'en','Hide Interest Entry On Payment Page',0),(568441,15791,'is','',0),(568442,15791,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø§ÛŒ ØªØ¹Ù„Ù‚ & Ø³Ø§Ø¹Øª Ø¨ÛŒÙ…Ø§Ø± Ø§Ø² Ø¨Ø±Ø±Ø³ÛŒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(568443,15791,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† ØªØ¹Ø·ÛŒÙ„Ø§Øª Ø§ÛŒ ØªØ¹Ù„Ù‚ & Ø³Ø§Ø¹Øª Ø¨ÛŒÙ…Ø§Ø± Ø§Ø² Ø¨Ø±Ø±Ø³ÛŒ Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯',0),(568444,15791,'tr','Tahakkuk eden tatil ve hasta saat maaÅŸ Ã§eki sonra gizle',0),(568445,15791,'pl','Ukryj naliczony urlop & chore godziny od wyboru listy pÅ‚ac',0),(568446,15791,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ñ‚Ðµ Ð²Ð°ÐºÐ°Ð½Ñ†Ð¸Ñ & Ð±Ð¾Ð»Ð½Ð¸ Ñ‡Ð°ÑÐ¾Ð²Ðµ Ð¾Ñ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ‚Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð° Ñ‡ÐµÐº',0),(568447,15791,'ur','ØªÙ…Ø§Ù… ÛÛŒ ÙˆØ§Ø¬Ø¨ Ø§Ù„Ø§Ø¯Ø§ Ú†Ú¾Ù¹ÛŒ & Ø¨ÛŒÙ…Ø§Ø± Ú¯Ú¾Ù†Ù¹Û’ Ù¾Û’ Ø±ÙˆÙ„ Ú†ÛŒÚ© Ø³Û’ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(568448,15791,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð½Ð°ÐºÑƒÐ¿Ñ™ÐµÐ½Ð¸ Ð¾Ð´Ð¼Ð¾Ñ€ & Ð±Ð¾Ð»ÐµÑÑ‚Ð°Ð½ ÑÐ°Ñ‚Ð¸ Ð¾Ð´ Ð¿Ð»Ð°Ñ‚Ð½Ð¾Ð¼ ÑÐ¿Ð¸ÑÐºÑƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(568449,15791,'vi','áº¨n tÃ­ch luá»¹ Vacation & giá» bá»‡nh tá»« kiá»ƒm tra biÃªn cháº¿',0),(568450,15791,'af','Versteek toegeval vakansie & siek ure van heeltydse kontroleer',0),(568451,15791,'ro','Ascunde acumulate vacanta & bolnav de ore de la salarizare Check',0),(568452,15791,'et','Peida arvestatud, kuid- & haige tundi palgaarvestuse vÃ¤ljaregistreerimine',0),(568453,15791,'si','Skrij obraÄunane poÄitnice & bolan ur iz plaÄe, ali',0),(568454,15791,'ba','Sembunyikan diperoleh liburan & sakit jam dari penggajian Check',0),(568455,15791,'nl','Opgebouwde vakantie & ziek uren van Payroll selectievakje verbergen',0),(568456,15791,'fi','Piilota kertynyt loma & sairas tuntia palkanlaskennan tarkistaa',0),(568457,15791,'no','Skjule pÃ¥lÃ¸pte ferie & syk timer fra lÃ¸nn sjekk',0),(568458,15791,'da','Skjule optjente ferie & syg timer fra lÃ¸n Check',0),(568459,15791,'ko','ë°œìƒ í•œ íœ´ê°€ ë° ê¸‰ì—¬ ì²´í¬ì—ì„œ ì•„í”ˆ ì‹œê°„ì„ ìˆ¨ê¸°ê¸°',0),(568460,15791,'he','×”×¡×ª×¨ ×œ×¦×‘×•×¨ ×—×•×¤×©×” & ×©×¢×•×ª ×—×•×œ×” ×ž ×¦\'×§ ×”×ž×©×›×•×¨×ª',0),(568461,15791,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î´ÎµÎ´Î¿Ï…Î»ÎµÏ…Î¼Î­Î½Ï‰Î½ Î´Î¹Î±ÎºÎ¿Ï€Î­Ï‚ & Î¬ÏÏÏ‰ÏƒÏ„Î¿Ï‚ ÏŽÏÎµÏ‚ Î±Ï€ÏŒ Î­Î»ÎµÎ³Ï‡Î¿Ï‚ Î¼Î¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚',0),(568462,15791,'zh','éšè—ç´¯è®¡çš„å‡æœŸ & ç”Ÿç—…å°æ—¶ä»Žå·¥èµ„æ”¯ç¥¨',0),(568463,15791,'sv','DÃ¶lja upplupna semester & sjuk timmar frÃ¥n lÃ¶nelistan kontrollera',0),(568464,15791,'it','Nascondere le ferie maturate & malate ore dal controllo delle retribuzioni',0),(568465,15791,'tl','',0),(568466,15791,'th','à¸‹à¹ˆà¸­à¸™à¸ªà¸°à¸ªà¸¡à¸§à¸±à¸™à¸«à¸¢à¸¸à¸”à¹à¸¥à¸°à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡à¸—à¸µà¹ˆà¸›à¹ˆà¸§à¸¢à¸ˆà¸²à¸à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(568467,15791,'hi','à¤‰à¤ªà¤¾à¤°à¥à¤œà¤¿à¤¤ à¤…à¤µà¤•à¤¾à¤¶ & à¤¬à¥€à¤®à¤¾à¤° à¤˜à¤‚à¤Ÿà¥‡ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤‚à¤¬à¤§à¥€ à¤šà¥‡à¤• à¤¸à¥‡ à¤›à¥à¤ªà¤¾à¤à¤',0),(568468,15791,'ms','Sembunyi terakru percutian & jam sakit dari Semak gaji',0),(568469,15791,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø¥Ø¬Ø§Ø²Ø§Øª Ø§Ù„Ù…ØªØ±Ø§ÙƒÙ…Ø© & Ø³Ø§Ø¹Ø§Øª Ø§Ù„Ù…Ø±Ø¶Ù‰ Ù…Ù† Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ø±ÙˆØ§ØªØ¨',0),(568470,15791,'fr','Masquer les vacances accumulÃ©es & malades heures de chÃ¨que de paie',0),(568471,15791,'jp','æœªæ‰•ä¼‘æš‡ãƒ»çµ¦ä¸Žãƒã‚§ãƒƒã‚¯ã‹ã‚‰ç—…æ°—ã®æ™‚é–“ã‚’éžè¡¨ç¤ºã«',0),(568472,15791,'pt','Esconder o fÃ©rias acumuladas & doentes horas de cheque de folha de pagamento',0),(568473,15791,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð½ÐµÐ¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð½Ñ‹Ð¹ Ð¾Ñ‚Ð¿ÑƒÑÐº & Ð±Ð¾Ð»ÑŒÐ½Ñ‹Ð¼Ð¸ Ñ‡Ð°ÑÐ¾Ð² Ð¸Ð· Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(568474,15791,'es','Ocultar vacaciones acumuladas y horas enfermamos de cheque de nÃ³mina',0),(568475,15791,'de','Aufgelaufenen Urlaub & krank Stunden vom Check-Lohn-und Gehaltsabrechnung zu verstecken',0),(568476,15791,'en','Hide Accrued Vacation & Sick Hours From Payroll Check',0),(568477,15792,'is','',0),(568478,15792,'dr','Ù…Ø´ØªØ±ÛŒ Ø¯Ø± Ú©Ø§Ø± Ù‡Ù…Ø§Ù† Ø§Ø³Øª Ú©Ù‡ Ø¯Ø± ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ù†ÛŒØ³Øª',0),(568479,15792,'pr','Ù…Ø´ØªØ±ÛŒ Ø¯Ø± Ú©Ø§Ø± Ù‡Ù…Ø§Ù† Ø§Ø³Øª Ú©Ù‡ Ø¯Ø± ØµÙˆØ±Øª Ø­Ø³Ø§Ø¨ Ù†ÛŒØ³Øª',0),(568480,15792,'tr','Ä°ÅŸte mÃ¼ÅŸteri fatura gibi aynÄ± deÄŸildir',0),(568481,15792,'pl','Klienta na pracÄ™ nie jest taki sam, jak na fakturze',0),(568482,15792,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ Ðµ ÑÑŠÑ‰Ð¾Ñ‚Ð¾ ÐºÐ°Ñ‚Ð¾ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°',0),(568483,15792,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ù¾Ø± Ú©Ø³Ù¹Ù…Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ø·ÙˆØ± Ù¾Ø± ÛÛŒ Ù†ÛÛŒÚº ÛÛ’',0),(568484,15792,'sr','ÐšÑƒÐ¿Ñ†Ð° Ð½Ð° Ð¿Ð¾ÑÐ°Ð¾ Ð½Ð¸Ñ˜Ðµ Ð¸ÑÑ‚Ð¾ ÐºÐ°Ð¾ Ð¸ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(568485,15792,'vi','KhÃ¡ch hÃ ng vá» viá»‡c khÃ´ng pháº£i lÃ  tÆ°Æ¡ng tá»± nhÆ° trÃªn hÃ³a Ä‘Æ¡n',0),(568486,15792,'af','KliÃ«nt op werk Is nie dieselfde As op die faktuur',0),(568487,15792,'ro','Client pe Job nu este la fel ca pe factura',0),(568488,15792,'et','Kliendi tÃ¶Ã¶ ei ole sama nagu arvel',0),(568489,15792,'si','Stranka na delo ni enako kot na raÄunu',0),(568490,15792,'ba','Pelanggan pada pekerjaan yang tidak sama seperti pada faktur',0),(568491,15792,'nl','Klant op het werk Is niet hetzelfde als op factuur',0),(568492,15792,'fi','Asiakas tyÃ¶ ei ole sama kuin laskun',0),(568493,15792,'no','Kunden pÃ¥ jobben er ikke det samme som pÃ¥ faktura',0),(568494,15792,'da','Kunde pÃ¥ Job er ikke det samme som pÃ¥ fakturaen',0),(568495,15792,'ko','ì¼ì— ê³ ê° ì†¡ìž¥ì— ë™ì¼ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(568496,15792,'he','×œ×§×•×—×•×ª ×‘×¢×‘×•×“×” ××™× ×” ×–×”×” ×›×ž×• ×‘×—×©×‘×•× ×™×ª',0),(568497,15792,'el','Î ÎµÎ»Î¬Ï„Î· Î­ÏÎ³Î¿Ï… Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Ï„Î¿ Î¯Î´Î¹Î¿ ÏŒÏ€Ï‰Ï‚ ÏƒÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(568498,15792,'zh','åœ¨å·¥ä½œä¸Šçš„å®¢æˆ·ä¸æ˜¯åŒæ ·çš„å‘ç¥¨',0),(568499,15792,'sv','Kund pÃ¥ jobbet Ã¤r inte samma som pÃ¥ faktura',0),(568500,15792,'it','Cliente il lavoro non Ã¨ la stessa presente sulla fattura',0),(568501,15792,'tl','',0),(568502,15792,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸‡à¸²à¸™à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸•à¸²à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(568503,15792,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¤° à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¤° à¤¹à¥€ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(568504,15792,'ms','Pelanggan mengenai pekerjaan itu tidak sama pada invois',0),(568505,15792,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ø¹Ù„Ù‰ Ø§Ù„ÙˆØ¸ÙŠÙØ© Ù„ÙŠØ³ Ù‡Ùˆ Ù†ÙØ³Ù‡ ÙƒÙ…Ø§ ÙÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(568506,15792,'fr','Client sur lâ€™emploi nâ€™est pas la mÃªme que sur la facture',0),(568507,15792,'jp','ä»•äº‹ã«é¡§å®¢ã¯è«‹æ±‚æ›¸ã¨åŒã˜ã§ã¯ãªã„ã§ã™ã€‚',0),(568508,15792,'pt','Cliente no trabalho nÃ£o Ã© o mesmo como na factura',0),(568509,15792,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð½Ðµ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ñ‚Ð°ÐºÐ¸Ð¼ Ð¶Ðµ, ÐºÐ°Ðº Ð½Ð° ÑÑ‡ÐµÑ‚',0),(568510,15792,'es','Cliente en trabajo no es igual que en la factura',0),(568511,15792,'de','Kunde auf Job ist nicht das gleiche wie auf Rechnung',0),(568512,15792,'en','Customer On Job Is Not The Same As On Invoice',0),(568513,15793,'is','',0),(568514,15793,'dr','Unposting Ø§Ø² ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(568515,15793,'pr','Unposting Ø§Ø² ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ù…Ø¬Ø§Ø² Ù†ÛŒØ³Øª',0),(568516,15793,'tr','FaturalarÄ± unposting izin verilmez',0),(568517,15793,'pl','Wycofania faktury nie jest dozwolone',0),(568518,15793,'bg','Unposting Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð½Ðµ Ðµ Ð¿Ð¾Ð·Ð²Ð¾Ð»ÐµÐ½Ð¾',0),(568519,15793,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ú©ÛŒ Ø§Ù†Ù¾ÙˆØ³Ù¹Ø§Ù†Ú¯ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ù†ÛÛŒÚº ÛÛ’',0),(568520,15793,'sr','Ð£Ð½Ð¿Ð¾ÑÑ‚Ð¸Ð½Ð³ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾',0),(568521,15793,'vi','Unposting cá»§a hoÃ¡ Ä‘Æ¡n lÃ  khÃ´ng Ä‘Æ°á»£c phÃ©p',0),(568522,15793,'af','Unposting van fakture word nie toegelaat nie',0),(568523,15793,'ro','Unposting facturilor nu este permis',0),(568524,15793,'et','Arvete unposting pole',0),(568525,15793,'si','Unposting raÄunov ni dovoljeno',0),(568526,15793,'ba','Unposting tagihan tidak diperbolehkan',0),(568527,15793,'nl','Unposting van facturen Is niet toegestaan',0),(568528,15793,'fi','Laskujen unposting ei ole sallittu',0),(568529,15793,'no','Unposting av fakturaer er ikke tillatt',0),(568530,15793,'da','Unposting af fakturaer er ikke tilladt',0),(568531,15793,'ko','ì²­êµ¬ì„œì˜ unpostingì€ í—ˆìš© ë˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(568532,15793,'he','Unposting ×©×œ ×—×©×‘×•× ×™×•×ª ××™× ×” ×ž×•×ª×¨×ª',0),(568533,15793,'el','Î”ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î· unposting Ï„Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(568534,15793,'zh','Unposting çš„å‘ç¥¨ä¸æ˜¯å…è®¸çš„',0),(568535,15793,'sv','Unposting av fakturor Ã¤r inte tillÃ¥tet',0),(568536,15793,'it','Unposting delle fatture non Ã¨ consentito',0),(568537,15793,'tl','',0),(568538,15793,'th','Unposting à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(568539,15793,'hi','Unposting à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(568540,15793,'ms','Unposting invois tidak dibenarkan',0),(568541,15793,'ar','Ø£ÙˆÙ†Ø¨ÙˆØ³ØªÙŠÙ†Ø¬ Ø§Ù„ÙÙˆØ§ØªÙŠØ± ØºÙŠØ± Ù…Ø³Ù…ÙˆØ­',0),(568542,15793,'fr','Unposting des factures nâ€™est pas autorisÃ©',0),(568543,15793,'jp','è«‹æ±‚æ›¸ã® unposting ã¯è¨±å¯ã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(568544,15793,'pt','Unposting de faturas nÃ£o Ã© permitido.',0),(568545,15793,'ru','Unposting ÑÑ‡ÐµÑ‚Ð¾Ð² Ð½Ðµ Ð´Ð¾Ð¿ÑƒÑÐºÐ°ÐµÑ‚ÑÑ',0),(568546,15793,'es','No se permite el unposting de facturas',0),(568547,15793,'de','Unposting von Rechnungen ist nicht zulÃ¤ssig.',0),(568548,15793,'en','Unposting Of Invoices Is Not Allowed',0),(568549,15794,'is','',0),(568550,15794,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù†ÙˆØ´ØªÙ†ØŒ Ø®Ø§Ù…ÙˆØ´',0),(568551,15794,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù†ÙˆØ´ØªÙ†ØŒ Ø®Ø§Ù…ÙˆØ´',0),(568552,15794,'tr','Ä°ndirimi tutarÄ±',0),(568553,15794,'pl','Kwota odpisu',0),(568554,15794,'bg','ÐžÑ‚Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ ÑÑƒÐ¼Ð°',0),(568555,15794,'ur','Write-Off Ø±Ù‚Ù…',0),(568556,15794,'sr','ÐžÑ‚Ð¿Ð¸Ñ Ð´ÑƒÐ³Ð° Ð¸Ð·Ð½Ð¾Ñ',0),(568557,15794,'vi','Write-Off lÆ°á»£ng',0),(568558,15794,'af','Afskrywing bedrag',0),(568559,15794,'ro','Scrie-off suma',0),(568560,15794,'et','Mahakandmise kogus',0),(568561,15794,'si','Odpis zneska',0),(568562,15794,'ba','Jumlah write-Off',0),(568563,15794,'nl','Bedrag van de afschrijving',0),(568564,15794,'fi','Kirjanpidolliseen',0),(568565,15794,'no','Nedskrivningen belÃ¸p',0),(568566,15794,'da','Afskrivning belÃ¸b',0),(568567,15794,'ko','ì“°ê¸° ê¸ˆì•¡',0),(568568,15794,'he','×›×ž×•×ª ×ž×—×™×§×” ×‘×”×ª××',0),(568569,15794,'el','Î Î¿ÏƒÏŒ write-Off',0),(568570,15794,'zh','æ³¨é”€é‡‘é¢',0),(568571,15794,'sv','Avskrivna beloppet',0),(568572,15794,'it','QuantitÃ  di storno',0),(568573,15794,'tl','',0),(568574,15794,'th','à¸•à¸±à¸”à¸¢à¸­à¸”',0),(568575,15794,'hi','à¤²à¤¿à¤–à¤¨à¥‡-à¤¬à¤‚à¤¦ à¤°à¤¾à¤¶à¤¿',0),(568576,15794,'ms','Amaun Hapuskira',0),(568577,15794,'ar','Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„Ù…Ø´Ø·ÙˆØ¨',0),(568578,15794,'fr','QuantitÃ© de radiation',0),(568579,15794,'jp','å„Ÿå´é¡',0),(568580,15794,'pt','Montante de write-off',0),(568581,15794,'ru','Ð¡ÑƒÐ¼Ð¼Ð° ÑÐ¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(568582,15794,'es','Cantidad de pÃ©rdidas y ganancias',0),(568583,15794,'de','Abschreibungsbetrag',0),(568584,15794,'en','Write-off Amount',0),(568585,15795,'is','',0),(568586,15795,'dr','Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡',0),(568587,15795,'pr','Ø±ÙˆØ² Ú¯Ø°Ø´ØªÙ‡',0),(568588,15795,'tr','Vadeyi GeÃ§en gÃ¼n sayÄ±sÄ±',0),(568589,15795,'pl','Dni opÃ³Åºnienia',0),(568590,15795,'bg','Ð”Ð½Ð¸ Ð¿Ñ€Ð¾ÑÑ€Ð¾Ñ‡Ð²Ð°Ð½Ðµ',0),(568591,15795,'ur','Ø¯Ù† Ù…ÙˆØ®Ø±',0),(568592,15795,'sr','Ð”Ð°Ð½Ð°',0),(568593,15795,'vi','NgÃ y quÃ¡ háº¡n',0),(568594,15795,'af','Dae lÃ¡Ã¡t',0),(568595,15795,'ro','Zile restante',0),(568596,15795,'et','PÃ¤eva Ã¼le tÃ¤htaja',0),(568597,15795,'si','Dni v zaostanku',0),(568598,15795,'ba','Hari terlambat',0),(568599,15795,'nl','Dagen te laat',0),(568600,15795,'fi','PÃ¤ivÃ¤Ã¤ myÃ¶hÃ¤ssÃ¤',0),(568601,15795,'no','Dager etter forfall',0),(568602,15795,'da','Kreditdage',0),(568603,15795,'ko','ì¼ ì—°ì²´',0),(568604,15795,'he','×™×ž×™× ××™×—×•×¨',0),(568605,15795,'el','Î›Î·Î¾Î¹Ï€ÏÏŒÎ¸ÎµÏƒÎ¼ÎµÏ‚ Î·Î¼Î­ÏÎµÏ‚',0),(568606,15795,'zh','å¤©è¿‡æœŸ',0),(568607,15795,'sv','FÃ¶rfallna dagar',0),(568608,15795,'it','Giorni di ritardo',0),(568609,15795,'tl','',0),(568610,15795,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸žà¹‰à¸™à¸à¸³à¸«à¸™à¸”',0),(568611,15795,'hi','à¤¦à¤¿à¤¨ à¤µà¤¿à¤²à¤®à¥à¤¬à¤¿à¤¤',0),(568612,15795,'ms','Hari lampau tempoh',0),(568613,15795,'ar','Ø£ÙŠØ§Ù… Ù…ØªØ£Ø®Ø±Ø©',0),(568614,15795,'fr','Jours de retard',0),(568615,15795,'jp','æ—¥é…ã‚Œ',0),(568616,15795,'pt','Dias de atraso',0),(568617,15795,'ru','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð´Ð½Ð¸',0),(568618,15795,'es','DÃ­as vencidos',0),(568619,15795,'de','Tage Ã¼berfÃ¤llig',0),(568620,15795,'en','Days Overdue',0),(568621,15796,'is','',0),(568622,15796,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø´ØªØ±ÛŒ',0),(568623,15796,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª ØªÙ…Ø§Ø³ Ø¨Ø§ Ù…Ø´ØªØ±ÛŒ',0),(568624,15796,'tr','MÃ¼ÅŸteri iletiÅŸim bilgileri gizle',0),(568625,15796,'pl','Ukryj informacje kontaktowe klienta',0),(568626,15796,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(568627,15796,'ur','Ú©Ø³Ù¹Ù…Ø± Ø±Ø§Ø¨Ø·Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(568628,15796,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(568629,15796,'vi','áº¨n thÃ´ng tin liÃªn há»‡ khÃ¡ch hÃ ng',0),(568630,15796,'af','Versteek kliÃ«nt kontak inligting',0),(568631,15796,'ro','Ascunde informaÅ£ii de Contact client',0),(568632,15796,'et','Peida kliendi kontaktinfo',0),(568633,15796,'si','Skriti podatke o stiku kupca',0),(568634,15796,'ba','Sembunyikan Info kontak pelanggan',0),(568635,15796,'nl','Klant Contact Info verbergen',0),(568636,15796,'fi','Piilota asiakkaan yhteystiedot',0),(568637,15796,'no','Skjule kunde kontakt Info',0),(568638,15796,'da','Skjule kunde kontakt Info',0),(568639,15796,'ko','ê³ ê° ì—°ë½ì²˜ ì •ë³´ ìˆ¨ê¸°ê¸°',0),(568640,15796,'he','×œ×”×¡×ª×™×¨ ×¤×¨×˜×™ ×§×©×¨ ×œ×§×•×—',0),(568641,15796,'el','Î‘Ï€Î¿ÎºÏÏÏˆÎµÏ„Îµ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÎµÏ€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î¯Î±Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(568642,15796,'zh','éšè—å®¢æˆ·è”ç³»ä¿¡æ¯',0),(568643,15796,'sv','DÃ¶lja kund kontakt information',0),(568644,15796,'it','Nascondere le informazioni di contatto del cliente',0),(568645,15796,'tl','',0),(568646,15796,'th','à¸‹à¹ˆà¸­à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸à¸²à¸£à¸•à¸´à¸”à¸•à¹ˆà¸­à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(568647,15796,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¤‚à¤ªà¤°à¥à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤›à¤¿à¤ªà¤¾à¤à¤',0),(568648,15796,'ms','Menyembunyikan maklumat pelanggan',0),(568649,15796,'ar','Ø¥Ø®ÙØ§Ø¡ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ø§ØªØµØ§Ù„ Ø¨Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(568650,15796,'fr','Masquer les informations de Contact client',0),(568651,15796,'jp','é¡§å®¢ã®é€£çµ¡å…ˆæƒ…å ±ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(568652,15796,'pt','Esconder informaÃ§Ã£o de contato do cliente',0),(568653,15796,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚Ð½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð°ÐºÐ°Ð·Ñ‡Ð¸ÐºÐ°',0),(568654,15796,'es','Ocultar datos cliente',0),(568655,15796,'de','Blenden Kontakt Kundeninfo aus',0),(568656,15796,'en','Hide Customer Contact Info',0),(568657,15797,'is','',0),(568658,15797,'dr','Ú©Ø§Ø± Prelimable',0),(568659,15797,'pr','Ú©Ø§Ø± Prelimable',0),(568660,15797,'tr','Ä°ÅŸ Prelimable',0),(568661,15797,'pl','Praca Prelimable',0),(568662,15797,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Prelimable',0),(568663,15797,'ur','Ú©Ø§Ù… Ù¾Ø±ÛŒÙ„Ø§Ù…Ø¨Ù„ÛŒ',0),(568664,15797,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÐŸÑ€ÐµÐ»Ð¸Ð¼Ð°Ð±Ð»Ðµ',0),(568665,15797,'vi','Viá»‡c lÃ m Prelimable',0),(568666,15797,'af','Werk Prelimable',0),(568667,15797,'ro','Job Prelimable',0),(568668,15797,'et','TÃ¶Ã¶ Prelimable',0),(568669,15797,'si','Delo Prelimable',0),(568670,15797,'ba','Pekerjaan Prelimable',0),(568671,15797,'nl','Job Prelimable',0),(568672,15797,'fi','TyÃ¶ Prelimable',0),(568673,15797,'no','Jobb Prelimable',0),(568674,15797,'da','Job Prelimable',0),(568675,15797,'ko','ìž‘ì—… Prelimable',0),(568676,15797,'he','×¢×‘×•×“×” Prelimable',0),(568677,15797,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Prelimable',0),(568678,15797,'zh','Prelimable çš„å·¥ä½œ',0),(568679,15797,'sv','Jobb Prelimable',0),(568680,15797,'it','Lavoro Prelimable',0),(568681,15797,'tl','',0),(568682,15797,'th','à¸‡à¸²à¸™ Prelimable',0),(568683,15797,'hi','à¤¨à¥Œà¤•à¤°à¥€ Prelimable',0),(568684,15797,'ms','Kerja Prelimable',0),(568685,15797,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø¨Ø±ÙŠÙ„ÙŠÙ…Ø§Ø¨Ù„',0),(568686,15797,'fr','Emploi Prelimable',0),(568687,15797,'jp','ä»•äº‹ Prelimable',0),(568688,15797,'pt','Trabalho Prelimable',0),(568689,15797,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Prelimable',0),(568690,15797,'es','Trabajo Prelimable',0),(568691,15797,'de','Job Prelimable',0),(568692,15797,'en','Job Prelimable',0),(568693,15798,'is','',0),(568694,15798,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø§ÛŒÙ† ÙØ§Ú©ØªÙˆØ± Ø¯Ø± B2B',0),(568695,15798,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø§ÛŒÙ† ÙØ§Ú©ØªÙˆØ± Ø¯Ø± B2B',0),(568696,15798,'tr','B2B bu faturada gizle',0),(568697,15798,'pl','Ukryj tÄ™ fakturÄ™ na B2B',0),(568698,15798,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ñ‚Ð°Ð·Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ð° B2B',0),(568699,15798,'ur','Ø§Ø³ Ø§Ù†ÙˆØ§Ø¦Ø³ B2B Ù¾Ø± Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(568700,15798,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð¾Ð²Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð½Ð° Ð‘2Ð‘',0),(568701,15798,'vi','áº¨n nÃ y hoÃ¡ Ä‘Æ¡n trÃªn B2B',0),(568702,15798,'af','Hierdie faktuur op B2B versteek',0),(568703,15798,'ro','Ascunde aceastÄƒ facturÄƒ pe B2B',0),(568704,15798,'et','Peida selle arve B2B',0),(568705,15798,'si','Skrij to raÄuna na B2B',0),(568706,15798,'ba','Menyembunyikan faktur ini pada B2B',0),(568707,15798,'nl','Deze factuur op B2B verbergen',0),(568708,15798,'fi','Piilota tÃ¤mÃ¤n laskun B2B',0),(568709,15798,'no','Skjul denne fakturaen pÃ¥ B2B',0),(568710,15798,'da','Skjule denne faktura pÃ¥ B2B',0),(568711,15798,'ko','B2Bì—ì´ ì²­êµ¬ì„œë¥¼ ìˆ¨ê¸°ê¸°',0),(568712,15798,'he','×œ×”×¡×ª×™×¨ ××ª ×—×©×‘×•× ×™×ª ×–×• ×‘- B2B',0),(568713,15798,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Î±Ï…Ï„ÏŒ Ï„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÏƒÏ„Î¿ B2B',0),(568714,15798,'zh','éšè—æ­¤å‘ç¥¨ä¸Š B2B',0),(568715,15798,'sv','DÃ¶lja denna faktura pÃ¥ B2B',0),(568716,15798,'it','Nascondere questa fattura su B2B',0),(568717,15798,'tl','',0),(568718,15798,'th','à¸‹à¹ˆà¸­à¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸™à¸µà¹‰à¸šà¸™ B2B',0),(568719,15798,'hi','à¤‡à¤¸ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ B2B à¤ªà¤° à¤›à¥à¤ªà¤¾à¤à¤',0),(568720,15798,'ms','Sembunyi invois ini pada B2B',0),(568721,15798,'ar','Ø¥Ø®ÙØ§Ø¡ Ù‡Ø°Ù‡ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¹Ù„Ù‰ B2B',0),(568722,15798,'fr','Masquer cette facture sur B2B',0),(568723,15798,'jp','B2B ã«ã“ã®è«‹æ±‚æ›¸ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(568724,15798,'pt','Esconder esta fatura no B2B',0),(568725,15798,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ ÑÑ‡ÐµÑ‚ Ð½Ð° B2B',0),(568726,15798,'es','Ocultar esta factura en B2B',0),(568727,15798,'de','Verstecken Sie diese Rechnung auf B2B',0),(568728,15798,'en','Hide This Invoice On B2B',0),(568729,15799,'is','',0),(568730,15799,'dr','ÙØ§Ú©ØªÙˆØ± Ú©ÙˆÙ¾Ù† Ø±Ø§ Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡.',0),(568731,15799,'pr','ÙØ§Ú©ØªÙˆØ± Ú©ÙˆÙ¾Ù† Ø±Ø§ Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡.',0),(568732,15799,'tr','Fatura fiÅŸ eksik',0),(568733,15799,'pl','Brak zaÅ‚Ä…cznika faktury',0),(568734,15799,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð»Ð¸Ð¿ÑÐ²Ð°',0),(568735,15799,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ ÙˆØ§Ø¤Ú†Ø± ØºØ§Ø¦Ø¨',0),(568736,15799,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ',0),(568737,15799,'vi','HÃ³a Ä‘Æ¡n chá»©ng tá»« thiáº¿u',0),(568738,15799,'af','Faktuur bewys ontbreek',0),(568739,15799,'ro','FacturÄƒ Voucher lipsÄƒ',0),(568740,15799,'et','Arve kande puudu',0),(568741,15799,'si','RaÄun kupon manjka',0),(568742,15799,'ba','Faktur Voucher hilang',0),(568743,15799,'nl','Factuur Voucher ontbreekt',0),(568744,15799,'fi','Laskun tositteen puuttuu',0),(568745,15799,'no','Faktura bilaget mangler',0),(568746,15799,'da','Faktura Voucher mangler',0),(568747,15799,'ko','ì†¡ìž¥ ë°”ìš°ì²˜ ëˆ„ë½',0),(568748,15799,'he','×—×¡×¨×™× ×©×•×‘×¨ ×—×©×‘×•× ×™×ª',0),(568749,15799,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Î»ÎµÎ¯Ï€ÎµÎ¹',0),(568750,15799,'zh','å‘ç¥¨å‡­è¯ä¸¢å¤±',0),(568751,15799,'sv','Fakturan verifikation saknas',0),(568752,15799,'it','Fattura Voucher mancante',0),(568753,15799,'tl','',0),(568754,15799,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸‚à¸²à¸”à¸«à¸²à¸¢à¹„à¸›',0),(568755,15799,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ Voucher à¤²à¤¾à¤ªà¤¤à¤¾',0),(568756,15799,'ms','Invois baucar hilang',0),(568757,15799,'ar','Ø¥ÙŠØµØ§Ù„ Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙÙŠ Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ù…ÙÙ‚ÙˆØ¯ÙŠÙ†',0),(568758,15799,'fr','Facture nÂ° document manquant',0),(568759,15799,'jp','è«‹æ±‚æ›¸ä¼ç¥¨ã®è¡Œæ–¹ä¸æ˜Ž',0),(568760,15799,'pt','Falta de comprovante de factura',0),(568761,15799,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚',0),(568762,15799,'es','Falta de comprobante de factura',0),(568763,15799,'de','Rechnung Gutschein fehlt',0),(568764,15799,'en','Invoice Voucher Missing',0),(568765,15800,'is','',0),(568766,15800,'dr','Ù‡ÛŒÚ† ÙˆØ±ÙˆØ¯ÛŒ Reversing Ø³Ø§Ø®ØªÙ‡ Ø´Ø¯Ù‡',0),(568767,15800,'pr','Ù‡ÛŒÚ† ÙˆØ±ÙˆØ¯ÛŒ Reversing Ø³Ø§Ø®ØªÙ‡ Ø´Ø¯Ù‡',0),(568768,15800,'tr','YapÄ±lan hiÃ§bir ters kayÄ±t giriÅŸi',0),(568769,15800,'pl','Nie wpisu stornujÄ…cego wykonane',0),(568770,15800,'bg','ÐÑÐ¼Ð° Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‰ Ð·Ð°Ð¿Ð¸Ñ Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÐ½Ð¸',0),(568771,15800,'ur','Ú©ÛŒØ§ Ú©ÙˆØ¦ÛŒ Ø±ÛŒÙˆØ±Ø³Ø§Ù†Ú¯ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(568772,15800,'sr','ÐÐµÐ¼Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ð¾',0),(568773,15800,'vi','KhÃ´ng cÃ³ má»¥c nháº­p Ä‘áº£o chiá»u thá»±c hiá»‡n',0),(568774,15800,'af','Geen Reversing inskrywing gemaak',0),(568775,15800,'ro','Nici o intrare de mers Ã®napoi fÄƒcut',0),(568776,15800,'et','Pole tehtud stornokanne',0),(568777,15800,'si','Brez storno postavko, ki',0),(568778,15800,'ba','Tidak ada membalikkan entri yang dibuat',0),(568779,15800,'nl','Geen omkering vermelding gemaakt',0),(568780,15800,'fi','Ei ole tehnyt vastakirjaus',0),(568781,15800,'no','Ingen tilbakefÃ¸ring laget',0),(568782,15800,'da','Ingen post i tilbagefÃ¸ringen lavet',0),(568783,15800,'ko','ì•„ë‹ˆ ì—­ì „ í•­ëª©',0),(568784,15800,'he','××™×Ÿ ×›× ×™×¡×” ×”×”×™×¤×•×š ×’×¨×',0),(568785,15800,'el','ÎšÎ±Î¼Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î® Î±Î½Ï„Î¹Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î­ÎºÎ±Î½Îµ',0),(568786,15800,'zh','ä½œå‡ºä¸å†²é”€åˆ†å½•',0),(568787,15800,'sv','Ingen Ã¥terfÃ¶ringspost gjorde',0),(568788,15800,'it','Nessuna voce storno fatto',0),(568789,15800,'tl','',0),(568790,15800,'th','à¸à¸¥à¸±à¸šà¹„à¸¡à¹ˆà¸¡à¸µà¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¸—à¸³',0),(568791,15800,'hi','à¤•à¥‹à¤ˆ Reversing à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¬à¤¨à¤¾à¤¯à¤¾',0),(568792,15800,'ms','Tiada catatan Reversing yang dibuat di',0),(568793,15800,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø¹ÙƒÙˆØ³ Ø£Ø¯Ù„Ù‰',0),(568794,15800,'fr','Aucune entrÃ©e de marche arriÃ¨re faite',0),(568795,15800,'jp','ãªã—åè»¢ã‚¨ãƒ³ãƒˆãƒªã®ä½œæˆ',0),(568796,15800,'pt','Nenhuma entrada de inversÃ£o feita',0),(568797,15800,'ru','ÐÐµ Ñ€ÐµÐ²ÐµÑ€ÑÐ¸Ð²Ð½Ñ‹Ð¹ Ð·Ð°Ð¿Ð¸ÑÑŒ, ÑÐ´ÐµÐ»Ð°Ð½Ð½Ð°Ñ',0),(568798,15800,'es','No hay marcha atrÃ¡s entrada',0),(568799,15800,'de','Keine RÃ¼ckbuchung gemacht',0),(568800,15800,'en','No Reversing Entry Made',0),(568801,15801,'is','',0),(568802,15801,'dr','Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÛŒ Ù…ÙˆØ±Ø¯',0),(568803,15801,'pr','Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÛŒ Ù…ÙˆØ±Ø¯',0),(568804,15801,'tr','Ã–ÄŸe biÃ§imlendirme',0),(568805,15801,'pl','Element znacznikÃ³w',0),(568806,15801,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð·Ð° Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(568807,15801,'ur','Ø´Û’ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ†',0),(568808,15801,'sr','ÐžÐ·Ð½Ð°Ñ‡Ð°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(568809,15801,'vi','ÄÃ¡nh dáº¥u má»¥c',0),(568810,15801,'af','Item Markup',0),(568811,15801,'ro','Marcare element',0),(568812,15801,'et','Kauba juurdehindlus',0),(568813,15801,'si','OznaÄevalni element',0),(568814,15801,'ba','Item Markup',0),(568815,15801,'nl','Item Markup',0),(568816,15801,'fi','Kohteen merkintÃ¤',0),(568817,15801,'no','Element Markup',0),(568818,15801,'da','Element Markup',0),(568819,15801,'ko','í•­ëª© íƒœê·¸',0),(568820,15801,'he','×¡×™×ž×•×Ÿ ×¤×¨×™×˜',0),(568821,15801,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(568822,15801,'zh','é¡¹ç›®æ ‡è®°',0),(568823,15801,'sv','Objektet Markup',0),(568824,15801,'it','Elemento di Markup',0),(568825,15801,'tl','',0),(568826,15801,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸²à¸„à¸²à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(568827,15801,'hi','à¤†à¤‡à¤Ÿà¤® à¤®à¤¾à¤°à¥à¤•à¤…à¤ª',0),(568828,15801,'ms','Penanda item',0),(568829,15801,'ar','ØªÙˆØµÙŠÙ Ø§Ù„Ø¨Ù†Ø¯',0),(568830,15801,'fr','Ã‰lÃ©ment de balisage',0),(568831,15801,'jp','é …ç›®ã®ãƒžãƒ¼ã‚¯ã‚¢ãƒƒãƒ—',0),(568832,15801,'pt','MarcaÃ§Ã£o de item',0),(568833,15801,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(568834,15801,'es','Elemento marcado',0),(568835,15801,'de','Element-Markup',0),(568836,15801,'en','Item Markup',0),(568837,15802,'is','',0),(568838,15802,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ù†Ø´Ø§Ù† Ø¯Ù‡Ù†Ø¯Ù‡ Ù†Ø±Ø® Ù…Ø°Ø§Ú©Ø±Ù‡',0),(568839,15802,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù†Ø´Ø§Ù† Ø¯Ù‡Ù†Ø¯Ù‡ Ù†Ø±Ø® Ù…Ø°Ø§Ú©Ø±Ù‡',0),(568840,15802,'tr','Toplam Ã¼zerinde anlaÅŸmaya varÄ±lan oranlarÄ± yansÄ±tÄ±r',0),(568841,15802,'pl','Sumie odzwierciedla wynegocjowane stawki',0),(568842,15802,'bg','ÐžÐ±Ñ‰Ð¾ Ð¾Ñ‚Ñ€Ð°Ð·ÑÐ²Ð° Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ñ‚Ð°Ñ€Ð¸Ñ„Ð¸',0),(568843,15802,'ur','Ú©Ù„ Ù…Ø°Ø§Ú©Ø±Ø§ØªÛŒ Ø´Ø±Ø­ Ú©ÛŒ Ø¹Ú©Ø§Ø³ÛŒ Ú©Ø±ØªØ§ ÛÛ’',0),(568844,15802,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ñ˜Ðµ Ð¾Ð´Ñ€Ð°Ð· ÑÐ¿Ð¾Ñ€Ð°Ð·ÑƒÐ¼Ð½Ð¾ ÑÑ‚Ð¾Ð¿Ðµ',0),(568845,15802,'vi','Tá»•ng sá»‘ pháº£n Ã¡nh giÃ¡ thÆ°Æ¡ng lÆ°á»£ng',0),(568846,15802,'af','Totaal weerspieÃ«l onderhandelde tariewe',0),(568847,15802,'ro','Total reflectÄƒ tarife negociate',0),(568848,15802,'et','Kokku kajastab lÃ¤birÃ¤Ã¤kimistega mÃ¤Ã¤rad',0),(568849,15802,'si','Skupaj odraÅ¾a s pogajanji stopnje',0),(568850,15802,'ba','Total mencerminkan harga negosiasi',0),(568851,15802,'nl','Totaal weerspiegelt onderhandelde tarieven',0),(568852,15802,'fi','YhteensÃ¤ heijastaa sopimushinnat',0),(568853,15802,'no','Totalt gjenspeiler forhandlede priser',0),(568854,15802,'da','Alt afspejler aftalte priser',0),(568855,15802,'ko','í˜‘ìƒëœ ìš”ê¸ˆì„ ë°˜ì˜ í•˜ëŠ” ì´',0),(568856,15802,'he','×¡×” ×› ×ž×©×§×£ ××ª ×”×ž×—×™×¨×™× ×ž×©× ×•×ž×ª×Ÿ',0),(568857,15802,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î±Î½Ï„Î±Î½Î±ÎºÎ»Î¬ ÎµÏ†Î±ÏÎ¼Î¿Î³Î®Ï‚ Ï„Î¹Î¼ÏŽÎ½ Î²Î¬ÏƒÎµÎ¹ Î´Î¹Î±Ï€ÏÎ±Î³Î¼Î¬Ï„ÎµÏ…ÏƒÎ·Ï‚',0),(568858,15802,'zh','å…±åæ˜ äº†è°ˆåˆ¤è¾¾æˆçš„çŽ‡',0),(568859,15802,'sv','Totalt Ã¥terspeglar fÃ¶rhandlade priser',0),(568860,15802,'it','Totale riflette tariffe negoziate',0),(568861,15802,'tl','',0),(568862,15802,'th','à¸£à¸§à¸¡à¸–à¸¶à¸‡à¹€à¸ˆà¸£à¸ˆà¸²à¸•à¹ˆà¸­à¸£à¸­à¸‡à¸£à¸²à¸„à¸²',0),(568863,15802,'hi','à¤•à¥à¤² à¤¨à¤¿à¤—à¥‹à¤¶à¤¿à¤à¤Ÿà¥‡à¤¡ à¤¦à¤°à¥‹à¤‚ à¤•à¥‹ à¤¦à¤°à¥à¤¶à¤¾à¤¤à¤¾ à¤¹à¥ˆ',0),(568864,15802,'ms','Jumlah keseluruhan mencerminkan kadar yang dirunding',0),(568865,15802,'ar','ÙˆÙŠØ¹ÙƒØ³ Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø£Ø³Ø¹Ø§Ø± Ù…ØªÙØ§ÙˆØ¶ Ø¹Ù„ÙŠÙ‡Ø§',0),(568866,15802,'fr','Total reflÃ¨te les tarifs nÃ©gociÃ©s',0),(568867,15802,'jp','åˆè¨ˆæ–™é‡‘ãŒåæ˜ ã•ã‚Œã¾ã™ã€‚',0),(568868,15802,'pt','Total reflete tarifas negociadas',0),(568869,15802,'ru','Ð’ÑÐµÐ³Ð¾ Ð¾Ñ‚Ñ€Ð°Ð¶Ð°ÐµÑ‚ Ñ‚Ð°Ñ€Ð¸Ñ„Ð°Ð¼',0),(568870,15802,'es','Total refleja tarifas negociadas',0),(568871,15802,'de','Insgesamt spiegelt ausgehandelten Tarife',0),(568872,15802,'en','Total Reflects Negotiated Rates',0),(568873,15803,'is','',0),(568874,15803,'dr','Ø®Ø§Ù„ÛŒ',0),(568875,15803,'pr','Ø®Ø§Ù„ÛŒ',0),(568876,15803,'tr','BoÅŸ',0),(568877,15803,'pl','Pusty',0),(568878,15803,'bg','ÐŸÑ€Ð°Ð·ÐµÐ½',0),(568879,15803,'ur','Ø®Ø§Ù„ÛŒ',0),(568880,15803,'sr','ÐŸÑ€Ð°Ð·Ð½Ð°',0),(568881,15803,'vi','Sáº£n pháº©m nÃ o',0),(568882,15803,'af','LeÃ«',0),(568883,15803,'ro','Gol',0),(568884,15803,'et','TÃ¼hi',0),(568885,15803,'si','Prazna',0),(568886,15803,'ba','Kosong',0),(568887,15803,'nl','Leeg',0),(568888,15803,'fi','TyhjÃ¤',0),(568889,15803,'no','Tom',0),(568890,15803,'da','Tom',0),(568891,15803,'ko','ë¹ˆ',0),(568892,15803,'he','×¨×™×§',0),(568893,15803,'el','Î†Î´ÎµÎ¹Î¿',0),(568894,15803,'zh','ç©º',0),(568895,15803,'sv','Tom',0),(568896,15803,'it','Vuoto',0),(568897,15803,'tl','',0),(568898,15803,'th','à¸§à¹ˆà¸²à¸‡à¹€à¸›à¸¥à¹ˆà¸²',0),(568899,15803,'hi','à¤°à¤¿à¤•à¥à¤¤',0),(568900,15803,'ms','Kosong',0),(568901,15803,'ar','ÙØ§Ø±ØºØ©',0),(568902,15803,'fr','Vide',0),(568903,15803,'jp','ç©º',0),(568904,15803,'pt','Vazio',0),(568905,15803,'ru','ÐŸÑƒÑÑ‚Ð¾Ð¹',0),(568906,15803,'es','VacÃ­o',0),(568907,15803,'de','Leere',0),(568908,15803,'en','Empty',0),(568909,15804,'is','',0),(568910,15804,'dr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(568911,15804,'pr','Ù†ÙˆØ¹ Ø­Ø³Ø§Ø¨ Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(568912,15804,'tr','GeÃ§ersiz hesap tÃ¼rÃ¼',0),(568913,15804,'pl','Typ nieprawidÅ‚owy konta',0),(568914,15804,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ñ‚Ð¸Ð¿',0),(568915,15804,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(568916,15804,'sr','ÐÐµÐ²Ð°Ð¶ÐµÑ›Ð° Ð²Ñ€ÑÑ‚Ð°',0),(568917,15804,'vi','Loáº¡i tÃ i khoáº£n khÃ´ng há»£p lá»‡',0),(568918,15804,'af','Ongeldige rekeningtipe',0),(568919,15804,'ro','Tip de cont nevalid',0),(568920,15804,'et','Sobimatu kontotÃ¼Ã¼p',0),(568921,15804,'si','Neveljavni raÄun tipa',0),(568922,15804,'ba','Jenis Account tidak valid',0),(568923,15804,'nl','Ongeldige accounttype',0),(568924,15804,'fi','Virheellinen tilityyppi',0),(568925,15804,'no','Ugyldig kontotype',0),(568926,15804,'da','Ugyldig kontotype',0),(568927,15804,'ko','ìž˜ëª» ëœ ê³„ì • ìœ í˜•',0),(568928,15804,'he','×¡×•×’ ×—×©×‘×•×Ÿ ×œ× ×—×•×§×™',0),(568929,15804,'el','Î¤ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ·',0),(568930,15804,'zh','æ— æ•ˆçš„å¸æˆ·ç±»åž‹',0),(568931,15804,'sv','Ogiltig kontotyp',0),(568932,15804,'it','Tipo di Account non valido',0),(568933,15804,'tl','',0),(568934,15804,'th','à¸Šà¸™à¸´à¸”à¸šà¸±à¸à¸Šà¸µà¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(568935,15804,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(568936,15804,'ms','Jenis akaun tidak sah',0),(568937,15804,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø­Ø³Ø§Ø¨ ØºÙŠØ± ØµØ§Ù„Ø­',0),(568938,15804,'fr','Type de compte non valide',0),(568939,15804,'jp','ç„¡åŠ¹ãªã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®ç¨®é¡ž',0),(568940,15804,'pt','Tipo de conta invÃ¡lido',0),(568941,15804,'ru','ÐÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¹ Ñ‚Ð¸Ð¿',0),(568942,15804,'es','Tipo de cuenta no vÃ¡lida',0),(568943,15804,'de','UngÃ¼ltiges Kontotyp',0),(568944,15804,'en','Invalid Account Type',0),(568945,15805,'is','',0),(568946,15805,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ… Ø§Ù†ÙˆØ§Ø¹',0),(568947,15805,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ… Ø§Ù†ÙˆØ§Ø¹',0),(568948,15805,'tr','DoÄŸrudan gider tÃ¼rlerini ekleme',0),(568949,15805,'pl','Dodaj typy wydatkÃ³w bezpoÅ›rednich',0),(568950,15805,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¿Ñ€ÐµÐºÐ¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(568951,15805,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ù‚Ø³Ù… Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(568952,15805,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÑÑ‚Ðµ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(568953,15805,'vi','ThÃªm cÃ¡c loáº¡i chi phÃ­ trá»±c tiáº¿p',0),(568954,15805,'af','Voeg direkte koste tipes',0),(568955,15805,'ro','AdÄƒuga tipuri de cheltuieli directe',0),(568956,15805,'et','Lisada otsene kululiike',0),(568957,15805,'si','Dodaj vrst neposrednih stroÅ¡kov',0),(568958,15805,'ba','Menambahkan jenis biaya langsung',0),(568959,15805,'nl','Directe kosten typen toevoegen',0),(568960,15805,'fi','LisÃ¤tÃ¤ suoraan kustannuksella',0),(568961,15805,'no','Legg til direkte utgiftstyper',0),(568962,15805,'da','TilfÃ¸j direkte udgiftstyper',0),(568963,15805,'ko','ì§ì ‘ ë¹„ìš© ì¢…ë¥˜ ì¶”ê°€',0),(568964,15805,'he','×œ×”×•×¡×™×£ ×¡×•×’×™ ×”×•×¦××•×ª ×™×©×™×¨×•×ª',0),(568965,15805,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„Î± ÎµÎ¯Î´Î· Î¬Î¼ÎµÏƒÏ‰Î½ Î´Î±Ï€Î±Î½ÏŽÎ½',0),(568966,15805,'zh','æ·»åŠ ç›´æŽ¥æ”¯å‡ºç±»åž‹',0),(568967,15805,'sv','LÃ¤gga till direkt utgiftstyper',0),(568968,15805,'it','Aggiungere tipi di spesa diretta',0),(568969,15805,'tl','',0),(568970,15805,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸Šà¸™à¸´à¸”à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¹‚à¸”à¸¢à¸•à¸£à¸‡',0),(568971,15805,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤µà¥à¤¯à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(568972,15805,'ms','Tambah jenis perbelanjaan langsung',0),(568973,15805,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø©',0),(568974,15805,'fr','Ajouter des Types de dÃ©pense directe',0),(568975,15805,'jp','ç›´æŽ¥çµŒè²»ã®ç¨®é¡žã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(568976,15805,'pt','Adicionar tipos de despesa direta',0),(568977,15805,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ñ‚Ð¸Ð¿Ñ‹ Ð¿Ñ€ÑÐ¼Ñ‹Ñ… Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(568978,15805,'es','Agregar tipos de gasto directo',0),(568979,15805,'de','Direkte Kosten Typen hinzufÃ¼gen',0),(568980,15805,'en','Add Direct Expense Types',0),(568981,15806,'is','',0),(568982,15806,'dr','Ø­Ø³Ø§Ø¨ GL',0),(568983,15806,'pr','Ø­Ø³Ø§Ø¨ GL',0),(568984,15806,'tr','Kredi GL hesabÄ±',0),(568985,15806,'pl','Konto kredytowe GL',0),(568986,15806,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(568987,15806,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(568988,15806,'sr','Ð“Ð› ÐºÐ¾Ð½Ñ‚Ð° Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ°',0),(568989,15806,'vi','TÃ i khoáº£n tÃ­n dá»¥ng GL',0),(568990,15806,'af','Krediet GL rekening',0),(568991,15806,'ro','Credit contul GL',0),(568992,15806,'et','GL kreeditkonto',0),(568993,15806,'si','GL konta',0),(568994,15806,'ba','Rekening kredit GL',0),(568995,15806,'nl','GL creditrekening',0),(568996,15806,'fi','GL luottotili',0),(568997,15806,'no','GL kreditkonto',0),(568998,15806,'da','GL kreditkonto',0),(568999,15806,'ko','ì‹ ìš© GL ê³„ì •',0),(569000,15806,'he','×—×©×‘×•×Ÿ ×”××©×¨××™ GL',0),(569001,15806,'el','Î Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(569002,15806,'zh','ä¿¡ç”¨ GL å¸æˆ·',0),(569003,15806,'sv','GL kreditkonto',0),(569004,15806,'it','Conto di credito GL',0),(569005,15806,'tl','',0),(569006,15806,'th','à¹€à¸„à¸£à¸”à¸´à¸•à¸šà¸±à¸à¸Šà¸µ GL',0),(569007,15806,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ GL à¤–à¤¾à¤¤à¥‡',0),(569008,15806,'ms','Akaun kredit GL',0),(569009,15806,'ar','Ø­Ø³Ø§Ø¨ GL Ø¯Ø§Ø¦Ù†',0),(569010,15806,'fr','Compte de crÃ©dit GL',0),(569011,15806,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(569012,15806,'pt','Conta de crÃ©dito GL',0),(569013,15806,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚ ÑÑ‡ÐµÑ‚Ð° GL',0),(569014,15806,'es','Cuenta de crÃ©dito contabilidad',0),(569015,15806,'de','GL-Guthabenkonto',0),(569016,15806,'en','Credit GL Account',0),(569017,15807,'is','',0),(569018,15807,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ GL',0),(569019,15807,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ GL',0),(569020,15807,'tr','BorÃ§ GL hesabÄ±',0),(569021,15807,'pl','Konto debetowe GL',0),(569022,15807,'bg','Ð”ÐµÐ±Ð¸Ñ‚Ð½Ð° GL ÑÐ¼ÐµÑ‚ÐºÐ°',0),(569023,15807,'ur','ÚˆÛŒØ¨Ù¹ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(569024,15807,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð“Ð›',0),(569025,15807,'vi','Ghi ná»£ GL tÃ i khoáº£n',0),(569026,15807,'af','Debiet GL rekening',0),(569027,15807,'ro','Debit contul GL',0),(569028,15807,'et','GL deebetkonto',0),(569029,15807,'si','Breme GL raÄun',0),(569030,15807,'ba','GL debet rekening',0),(569031,15807,'nl','Debetrekening GL',0),(569032,15807,'fi','GL luottotililtÃ¤',0),(569033,15807,'no','GL debetkonto',0),(569034,15807,'da','GL debetkonto',0),(569035,15807,'ko','ì§ë¶ˆ GL ê³„ì •',0),(569036,15807,'he','×—×™×•×‘ ×—×©×‘×•×Ÿ GL',0),(569037,15807,'el','Î§ÏÎµÏ‰ÏƒÏ„Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î³/Î»',0),(569038,15807,'zh','å€Ÿè®°å¡ GL å¸æˆ·',0),(569039,15807,'sv','GL kontokredit',0),(569040,15807,'it','Debito conto di contabilitÃ  generale',0),(569041,15807,'tl','',0),(569042,15807,'th','à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¹€à¸”à¸šà¸´à¸•',0),(569043,15807,'hi','à¤¡à¥‡à¤¬à¤¿à¤Ÿ GL à¤–à¤¾à¤¤à¥‡',0),(569044,15807,'ms','Akaun debit GL',0),(569045,15807,'ar','Ø­Ø³Ø§Ø¨ GL Ø§Ù„Ù…Ø¯ÙŠÙ†',0),(569046,15807,'fr','Compte de dÃ©bit GL',0),(569047,15807,'jp','ãƒ‡ãƒ“ãƒƒãƒˆ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(569048,15807,'pt','Conta de dÃ©bito GL',0),(569049,15807,'ru','Ð”ÐµÐ±ÐµÑ‚ ÑÑ‡ÐµÑ‚Ð° GL',0),(569050,15807,'es','DÃ©bito cuenta de contabilidad',0),(569051,15807,'de','Belastungskonto GL',0),(569052,15807,'en','Debit GL Account',0),(569053,15808,'is','',0),(569054,15808,'dr','Ù†ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ…',0),(569055,15808,'pr','Ù†ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ…',0),(569056,15808,'tr','DoÄŸrudan gider tÃ¼rÃ¼',0),(569057,15808,'pl','Koszt bezpoÅ›redni typu',0),(569058,15808,'bg','Ð¢Ð¸Ð¿ Ð½Ð° Ð¿Ñ€ÐµÐºÐ¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(569059,15808,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ù‚Ø³Ù…',0),(569060,15808,'sr','Ð¢Ð¸Ð¿ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(569061,15808,'vi','Chi phÃ­ trá»±c tiáº¿p loáº¡i',0),(569062,15808,'af','Direkte uitgawe tipe',0),(569063,15808,'ro','Cheltuieli directe de tip',0),(569064,15808,'et','Otsene kulu tÃ¼Ã¼p',0),(569065,15808,'si','Vrste neposredne stroÅ¡ke',0),(569066,15808,'ba','Jenis biaya langsung',0),(569067,15808,'nl','Directe kosten Type',0),(569068,15808,'fi','Suora kulutyyppi',0),(569069,15808,'no','Direkte utgiftstype',0),(569070,15808,'da','Direkte udgiftstypen',0),(569071,15808,'ko','ì§ì ‘ ë¹„ìš© ìœ í˜•',0),(569072,15808,'he','×¡×•×’ ×”×”×•×¦××” ×™×©×™×¨×”',0),(569073,15808,'el','Î¤ÏÏ€Î¿Ï‚ Î¬Î¼ÎµÏƒÎ· Î´Î±Ï€Î¬Î½Î·',0),(569074,15808,'zh','ç›´æŽ¥æ”¯å‡ºç±»åž‹',0),(569075,15808,'sv','Direkta utgiftstyp',0),(569076,15808,'it','Tipo di spesa diretta',0),(569077,15808,'tl','',0),(569078,15808,'th','à¸Šà¸™à¸´à¸”à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¹‚à¸”à¸¢à¸•à¸£à¸‡',0),(569079,15808,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤µà¥à¤¯à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(569080,15808,'ms','Jenis perbelanjaan langsung',0),(569081,15808,'ar','Ù†ÙˆØ¹ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø©',0),(569082,15808,'fr','Type de dÃ©pense directe',0),(569083,15808,'jp','ç›´æŽ¥çµŒè²»ã®ç¨®é¡ž',0),(569084,15808,'pt','Tipo de despesa direta',0),(569085,15808,'ru','Ð¢Ð¸Ð¿ Ð¿Ñ€ÑÐ¼Ñ‹Ñ… Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(569086,15808,'es','Tipo de gasto directo',0),(569087,15808,'de','Direkte Kosten-Typ',0),(569088,15808,'en','Direct Expense Type',0),(569089,15809,'is','',0),(569090,15809,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(569091,15809,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(569092,15809,'tr','Girdi baÅŸarÄ±yla kaydedildi',0),(569093,15809,'pl','Wpis pomyÅ›lnie zapisany',0),(569094,15809,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(569095,15809,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù…Ø­ÙÙˆØ¸ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(569096,15809,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(569097,15809,'vi','Má»¥c lÆ°u thÃ nh cÃ´ng',0),(569098,15809,'af','Inskrywing suksesvol gestoor',0),(569099,15809,'ro','Intrare salvat cu succes',0),(569100,15809,'et','Edukalt salvestatud kirje',0),(569101,15809,'si','Vnos, shranjen',0),(569102,15809,'ba','Entri berhasil',0),(569103,15809,'nl','Entry Saved met succes',0),(569104,15809,'fi','Tallennettu merkintÃ¤',0),(569105,15809,'no','OppfÃ¸ringen lagret',0),(569106,15809,'da','Post gemt med succes',0),(569107,15809,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” í•­ëª©',0),(569108,15809,'he','×•×©×ž×•×¨×•×ª ×‘×”×¦×œ×—×”',0),(569109,15809,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î±Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(569110,15809,'zh','å·²æˆåŠŸä¿å­˜çš„æ¡ç›®',0),(569111,15809,'sv','Posten som sparats',0),(569112,15809,'it','Ingresso salvato correttamente',0),(569113,15809,'tl','',0),(569114,15809,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¸šà¸±à¸™à¸—à¸¶à¸à¹„à¸§à¹‰à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢',0),(569115,15809,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(569116,15809,'ms','Penyertaan yang berjaya disimpan',0),(569117,15809,'ar','Ø¯Ø®ÙˆÙ„ Ø­ÙØ¸Ù‡ Ø¨Ù†Ø¬Ø§Ø­',0),(569118,15809,'fr','EntrÃ©e correctement enregistrÃ©e',0),(569119,15809,'jp','ã‚¨ãƒ³ãƒˆãƒªãŒæ­£å¸¸ã«ä¿å­˜ã•ã‚Œã¾ã—ãŸ',0),(569120,15809,'pt','Entrada com sucesso',0),(569121,15809,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(569122,15809,'es','Entrada guardado correctamente',0),(569123,15809,'de','Eintrag erfolgreich gespeichert',0),(569124,15809,'en','Entry Saved Successfully',0),(569125,15810,'is','',0),(569126,15810,'dr','Ù‡ÛŒÚ† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©',0),(569127,15810,'pr','Ù‡ÛŒÚ† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©',0),(569128,15810,'tr','Banka hesabÄ± ayarlanmadÄ±',0),(569129,15810,'pl','Zestaw nie konto do banku',0),(569130,15810,'bg','ÐÑÐ¼Ð° Ð¿Ñ€ÐµÐ´Ð²Ð¸Ð´ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸ Ð·Ð° Ð±Ð°Ð½ÐºÐ°',0),(569131,15810,'ur','Ø¨ÛŒÙ†Ú© Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(569132,15810,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð¡ÐµÑ‚ Ð·Ð° Ð±Ð°Ð½ÐºÑƒ',0),(569133,15810,'vi','KhÃ´ng cÃ³ thiáº¿t láº­p tÃ i khoáº£n ngÃ¢n hÃ ng',0),(569134,15810,'af','Geen rekening stel vir Bank',0),(569135,15810,'ro','Nici un Set de cont de Banca',0),(569136,15810,'et','Pole kontot seatud panga',0),(569137,15810,'si','Ni nastavljenega raÄun za banke',0),(569138,15810,'ba','Ada Account diatur untuk Bank',0),(569139,15810,'nl','Geen Account Set voor Bank',0),(569140,15810,'fi','Ei tilin asetettu Bank',0),(569141,15810,'no','Ingen konto satt For Bank',0),(569142,15810,'da','Ingen konto sÃ¦t til Bank',0),(569143,15810,'ko','ì€í–‰ì— ëŒ€ í•œ ê³„ì • ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(569144,15810,'he','×œ× ×”×•×’×“×¨×• ×—×©×‘×•×Ÿ ×‘×‘× ×§',0),(569145,15810,'el','ÎšÎ±Î½Î­Î½Î± ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï„ÏÎ¬Ï€ÎµÎ¶Î±Ï‚',0),(569146,15810,'zh','æ²¡æœ‰ä¸ºé“¶è¡Œçš„å¸æˆ·è®¾ç½®',0),(569147,15810,'sv','Inget konto Set fÃ¶r Bank',0),(569148,15810,'it','Nessun Set di Account per banca',0),(569149,15810,'tl','',0),(569150,15810,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£',0),(569151,15810,'hi','à¤¬à¥ˆà¤‚à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿ',0),(569152,15810,'ms','Tiada syarat akaun di Bank',0),(569153,15810,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø­Ø³Ø§Ø¨ Ù„Ù„Ø¨Ù†Ùƒ',0),(569154,15810,'fr','Aucun ensemble de compte de banque',0),(569155,15810,'jp','éŠ€è¡ŒãŒè¨­å®šã•ã‚Œã¦ã„ãªã„ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(569156,15810,'pt','Nenhum conjunto de conta de banco',0),(569157,15810,'ru','ÐÐµÑ‚ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð°Ð±Ð¾Ñ€Ð° Ð´Ð»Ñ Ð±Ð°Ð½ÐºÐ°',0),(569158,15810,'es','NingÃºn conjunto de cuenta para Banco',0),(569159,15810,'de','Keine Konto-Set fÃ¼r Bank',0),(569160,15810,'en','No Account Set For Bank',0),(569161,15811,'is','',0),(569162,15811,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø­Ø³Ø§Ø¨ Ù‡ÛŒÚ† Ù†ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡',0),(569163,15811,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø­Ø³Ø§Ø¨ Ù‡ÛŒÚ† Ù†ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡',0),(569164,15811,'tr','Gider tÃ¼rÃ¼ iÃ§in hesabÄ± ayarlanmadÄ±',0),(569165,15811,'pl','Nie zestaw konto dla typu koszt',0),(569166,15811,'bg','ÐÑÐ¼Ð° Ð¿Ñ€ÐµÐ´Ð²Ð¸Ð´ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸ Ð·Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ñ‚Ð¸Ð¿',0),(569167,15811,'ur','Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ù‚Ø³Ù… Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(569168,15811,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð¡ÐµÑ‚ Ð·Ð° Ñ‚Ð¸Ð¿ Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð°',0),(569169,15811,'vi','KhÃ´ng cÃ³ thiáº¿t láº­p tÃ i khoáº£n cho cÃ¡c loáº¡i chi phÃ­',0),(569170,15811,'af','Geen rekening stel vir uitgawe tipe',0),(569171,15811,'ro','Nici un Set de cont pentru tipul de cheltuialÄƒ',0),(569172,15811,'et','Pole kontot mÃ¤Ã¤ratud kulutÃ¼Ã¼bi',0),(569173,15811,'si','Ni nastavljenega raÄun za stroÅ¡ke vrsta',0),(569174,15811,'ba','Ada Account diatur untuk jenis biaya',0),(569175,15811,'nl','Geen Account Set voor kosten Type',0),(569176,15811,'fi','Ei tilin asetettu kulutyyppi',0),(569177,15811,'no','Ingen konto satt For utgiftstype',0),(569178,15811,'da','Ingen konto sÃ¦t For udgiftstypen',0),(569179,15811,'ko','ë¹„ìš© ì¢…ë¥˜ì— ëŒ€ í•œ ê³„ì • ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(569180,15811,'he','×œ× ×”×•×’×“×¨×• ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×¡×•×’ ×”×•×¦××•×ª',0),(569181,15811,'el','ÎšÎ±Î½Î­Î½Î± ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î³Î¹Î± Î´Î±Ï€Î¬Î½Î· Ï„ÏÏ€Î¿Ï…',0),(569182,15811,'zh','æ²¡æœ‰ä¸ºæ”¯å‡ºç±»åž‹çš„çš„å¸æˆ·è®¾ç½®',0),(569183,15811,'sv','Inget konto Set fÃ¶r utgiftstypen',0),(569184,15811,'it','Nessun Set di Account per tipo di spesa',0),(569185,15811,'tl','',0),(569186,15811,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸±à¸à¸Šà¸µà¸ªà¸³à¸«à¸£à¸±à¸šà¸Šà¸™à¸´à¸”à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢',0),(569187,15811,'hi','à¤µà¥à¤¯à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿ',0),(569188,15811,'ms','Tanpa menetapkan akaun bagi jenis perbelanjaan',0),(569189,15811,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø­Ø³Ø§Ø¨ Ù„Ù†ÙˆØ¹ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª',0),(569190,15811,'fr','Aucun ensemble de compte pour le Type de dÃ©pense',0),(569191,15811,'jp','çµŒè²»ã®ç¨®é¡žãŒè¨­å®šã•ã‚Œã¦ã„ãªã„ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(569192,15811,'pt','Nenhum conjunto de conta por tipo de despesa',0),(569193,15811,'ru','ÐÐ°Ð±Ð¾Ñ€ Ð½Ðµ ÑÑ‡ÐµÑ‚Ð° Ð½Ð° ÑÑ‡ÐµÑ‚ Ñ‚Ð¸Ð¿Ð°',0),(569194,15811,'es','NingÃºn conjunto de cuenta por tipo de gasto',0),(569195,15811,'de','Keine Konto-Set fÃ¼r Spesentyp',0),(569196,15811,'en','No Account Set For Expense Type',0),(569197,15812,'is','',0),(569198,15812,'dr','Ù‡ÛŒÚ† ØªØ¹ÛŒÛŒÙ† Ù…Ù‚Ø¯Ø§Ø±',0),(569199,15812,'pr','Ù‡ÛŒÚ† ØªØ¹ÛŒÛŒÙ† Ù…Ù‚Ø¯Ø§Ø±',0),(569200,15812,'tr','Miktar ayarÄ± yok',0),(569201,15812,'pl','Zestaw nie kwota',0),(569202,15812,'bg','ÐÑÐ¼Ð° ÑÑƒÐ¼Ð° Ð½Ð°Ð±Ð¾Ñ€',0),(569203,15812,'ur','Ø±Ù‚Ù… Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(569204,15812,'sr','ÐÐµÐ¼Ð° Ð¸Ð·Ð½Ð¾Ñ Ð¡ÐµÑ‚',0),(569205,15812,'vi','KhÃ´ng cÃ³ thiáº¿t láº­p sá»‘ lÆ°á»£ng',0),(569206,15812,'af','Geen bedrag stel',0),(569207,15812,'ro','Nici un Set suma',0),(569208,15812,'et','No summa komplekt',0),(569209,15812,'si','Ni znesek iz',0),(569210,15812,'ba','Tidak ada jumlah Set',0),(569211,15812,'nl','Geen bedrag Set',0),(569212,15812,'fi','Ei mÃ¤Ã¤rÃ¤ asetettu',0),(569213,15812,'no','Ingen belÃ¸pet sett',0),(569214,15812,'da','Ingen belÃ¸b sÃ¦t',0),(569215,15812,'ko','ì•„ë‹ˆ ê¸ˆì•¡ ì„¤ì •',0),(569216,15812,'he','×œ× ×”×•×’×“×¨×• ×›×ž×•×ª',0),(569217,15812,'el','ÎšÎ±Î½Î­Î½Î± ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î¿ Ï€Î¿ÏƒÏŒ',0),(569218,15812,'zh','æ²¡æœ‰é‡çš„è®¾ç½®',0),(569219,15812,'sv','Inga belopp Set',0),(569220,15812,'it','Nessun insieme di quantitÃ ',0),(569221,15812,'tl','',0),(569222,15812,'th','à¹„à¸¡à¹ˆà¸•à¸±à¹‰à¸‡à¸¢à¸­à¸”',0),(569223,15812,'hi','à¤•à¥‹à¤ˆ à¤°à¤¾à¤¶à¤¿ à¤¸à¥‡à¤Ÿ',0),(569224,15812,'ms','Tanpa menetapkan jumlah',0),(569225,15812,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…Ø¨Ù„Øº',0),(569226,15812,'fr','Aucun montant indiquÃ©',0),(569227,15812,'jp','é‡ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(569228,15812,'pt','Nenhum conjunto de quantidade',0),(569229,15812,'ru','ÐÐ°Ð±Ð¾Ñ€ Ð½Ðµ ÑÑƒÐ¼Ð¼Ð°',0),(569230,15812,'es','NingÃºn conjunto de cantidad',0),(569231,15812,'de','Kein Betrag gesetzt',0),(569232,15812,'en','No Amount Set',0),(569233,15813,'is','',0),(569234,15813,'dr','Ù‡ÛŒÚ† Ù†ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(569235,15813,'pr','Ù‡ÛŒÚ† Ù†ÙˆØ¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(569236,15813,'tr','HiÃ§bir doÄŸrudan gider tipleri mevcuttur',0),(569237,15813,'pl','IstniejÄ… nie typy bezpoÅ›redni koszt',0),(569238,15813,'bg','ÐÑÐ¼Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‚',0),(569239,15813,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ù‚Ø³Ù…ÛŒÚº Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(569240,15813,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜Ðµ Ð²Ñ€ÑÑ‚Ðµ Ð½ÐµÐ¼Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(569241,15813,'vi','CÃ¡c loáº¡i chi phÃ­ trá»±c tiáº¿p khÃ´ng tá»“n táº¡i',0),(569242,15813,'af','Geen direkte koste vorme bestaan',0),(569243,15813,'ro','Tipuri de cheltuieli directe nu existÄƒ',0),(569244,15813,'et','Otsene kulu tÃ¼Ã¼pe pole olemas',0),(569245,15813,'si','Obstajajo nobene vrste neposredne stroÅ¡ke',0),(569246,15813,'ba','Ada tidak ada jenis biaya langsung',0),(569247,15813,'nl','Geen directe uitgavesoorten bestaan',0),(569248,15813,'fi','Ei suoraan kustannuksella on kolme',0),(569249,15813,'no','Ingen direkte utgiftstyper finnes',0),(569250,15813,'da','Der findes ingen direkte udgiftstyper',0),(569251,15813,'ko','ì§ì ‘ ë¹„ìš© í˜•ì‹ì€ ì¡´ìž¬',0),(569252,15813,'he','×¡×•×’×™ ×”×•×¦××•×ª ×™×©×™×¨×” ×œ× ×§×™×™×',0),(569253,15813,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ Î´ÎµÎ½ Ï„ÏÏ€Î¿Î¹ Î¬Î¼ÎµÏƒÎ· Î´Î±Ï€Î¬Î½Î·',0),(569254,15813,'zh','æ²¡æœ‰ç›´æŽ¥æ”¯å‡ºç±»åž‹å­˜åœ¨',0),(569255,15813,'sv','Det finns ingen direkt bekostnad typer',0),(569256,15813,'it','Non esiste nessun tipo di spesa diretta',0),(569257,15813,'tl','',0),(569258,15813,'th','à¸Šà¸™à¸´à¸”à¹„à¸¡à¹ˆà¸¡à¸µà¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¹‚à¸”à¸¢à¸•à¸£à¸‡à¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(569259,15813,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤µà¥à¤¯à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¥Œà¤œà¥‚à¤¦',0),(569260,15813,'ms','Jenis perbelanjaan langsung tidak wujud',0),(569261,15813,'ar','ØªÙˆØ¬Ø¯ Ù„Ø§ Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø©',0),(569262,15813,'fr','Aucun type de dÃ©pense directe nâ€™existe',0),(569263,15813,'jp','ç›´æŽ¥çµŒè²»ã®ç¨®é¡žãŒå­˜åœ¨ã—ã¾ã›ã‚“ã€‚',0),(569264,15813,'pt','NÃ£o existe nenhum tipo de despesa direta',0),(569265,15813,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð½ÐµÑ‚ Ð¿Ñ€ÑÐ¼Ð¾Ð¹ ÑÑ‡ÐµÑ‚ Ñ‚Ð¸Ð¿Ð°',0),(569266,15813,'es','No existe ningÃºn tipo de gasto directo',0),(569267,15813,'de','Es gibt keine direkte Kosten Arten',0),(569268,15813,'en','No Direct Expense Types Exist',0),(569269,15814,'is','',0),(569270,15814,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÛŒÙ… Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ø®ÛŒØ±',0),(569271,15814,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÛŒÙ… Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ø®ÛŒØ±',0),(569272,15814,'tr','Son doÄŸrudan masraf Ã¶demeleri',0),(569273,15814,'pl','Niedawne pÅ‚atnoÅ›ci bezpoÅ›rednich wydatkÃ³w',0),(569274,15814,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸ Ð¿Ñ€ÐµÐºÐ¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(569275,15814,'ur','Ø­Ø§Ù„ÛŒÛ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(569276,15814,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(569277,15814,'vi','Thanh toÃ¡n trá»±c tiáº¿p chi phÃ­ táº¡i',0),(569278,15814,'af','Onlangse direkte koste betalings',0),(569279,15814,'ro','Ultimele plÄƒÅ£i cheltuieli directe',0),(569280,15814,'et','Tehtud otsene kulu vÃ¤ljamakseid',0),(569281,15814,'si','Zadnje neposredne stroÅ¡ke plaÄila',0),(569282,15814,'ba','Tanggal pembayaran langsung biaya',0),(569283,15814,'nl','Recente betalingen van de directe kosten',0),(569284,15814,'fi','Hotelliin suoraan kustannuksella maksut',0),(569285,15814,'no','Betalinger som nylig direkte utgifter',0),(569286,15814,'da','Seneste direkte udgift betalinger',0),(569287,15814,'ko','ìµœê·¼ ì§ì ‘ ë¹„ìš© ì§€ë¶ˆ',0),(569288,15814,'he','×ª×©×œ×•×ž×™ ×”×•×¦××•×ª ×™×©×™×¨×” ×”××—×¨×•× ×•×ª',0),(569289,15814,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î¬Î¼ÎµÏƒÏ‰Î½ ÎµÎ¾ÏŒÎ´Ï‰Î½',0),(569290,15814,'zh','æœ€è¿‘çš„ç›´æŽ¥è´¹ç”¨æ”¯ä»˜',0),(569291,15814,'sv','De senaste direkt bekostnad betalningar',0),(569292,15814,'it','Pagamenti diretti spese recenti',0),(569293,15814,'tl','',0),(569294,15814,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¹‚à¸”à¸¢à¸•à¸£à¸‡à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(569295,15814,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤µà¥à¤¯à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(569296,15814,'ms','Hari pembayaran perbelanjaan langsung',0),(569297,15814,'ar','Ø¯ÙØ¹ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø© Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(569298,15814,'fr','Paiements directs frais rÃ©cents',0),(569299,15814,'jp','æœ€è¿‘ç›´æŽ¥çµŒè²»æ”¯æ‰•ã„',0),(569300,15814,'pt','Ãšltimos pagamentos de despesas directas',0),(569301,15814,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¸Ðµ Ð¿Ñ€ÑÐ¼Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(569302,15814,'es','Ãšltimos pagos de gasto directo',0),(569303,15814,'de','Den letzten direkten Kosten Zahlungen',0),(569304,15814,'en','Recent Direct Expense Payments',0),(569305,15815,'is','',0),(569306,15815,'dr','Ø§Ù†ÙˆØ§Ø¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ… ÙØ¹Ù„ÛŒ',0),(569307,15815,'pr','Ø§Ù†ÙˆØ§Ø¹ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ… ÙØ¹Ù„ÛŒ',0),(569308,15815,'tr','GeÃ§erli doÄŸrudan gider tÃ¼rlerini',0),(569309,15815,'pl','BieÅ¼Ä…ce typy wydatkÃ³w bezpoÅ›rednich',0),(569310,15815,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¿Ñ€ÐµÐºÐ¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ',0),(569311,15815,'ur','Ø­Ø§Ù„ÛŒÛ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ù‚Ø³Ù…ÛŒÚº',0),(569312,15815,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ðµ Ð²Ñ€ÑÑ‚Ðµ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(569313,15815,'vi','Hiá»‡n nay cÃ¡c loáº¡i chi phÃ­ trá»±c tiáº¿p',0),(569314,15815,'af','Huidige vorme van direkte koste',0),(569315,15815,'ro','Tipuri de cheltuieli directe curent',0),(569316,15815,'et','Otsene kulu tÃ¼Ã¼pidega',0),(569317,15815,'si','Trenutni vrst neposrednih stroÅ¡kov',0),(569318,15815,'ba','Saat ini jenis biaya langsung',0),(569319,15815,'nl','Huidige directe uitgavesoorten',0),(569320,15815,'fi','Nykyinen suora kulutyypit',0),(569321,15815,'no','Gjeldende direkte utgiftstyper',0),(569322,15815,'da','NuvÃ¦rende direkte udgiftstyper',0),(569323,15815,'ko','í˜„ìž¬ ì§ì ‘ ë¹„ìš© ì¢…ë¥˜',0),(569324,15815,'he','×¡×•×’×™ ×”×•×¦××•×ª ×™×©×™×¨×” ×”× ×•×›×—×™×™×',0),(569325,15815,'el','Î¤ÏÎ­Ï‡Î¿Î½Ï„ÎµÏ‚ Ï„ÏÏ€Î¿Ï…Ï‚ Î¬Î¼ÎµÏƒÎ· Î´Î±Ï€Î¬Î½Î·',0),(569326,15815,'zh','å½“å‰ç›´æŽ¥æ”¯å‡ºç±»åž‹',0),(569327,15815,'sv','Aktuella direkt utgiftstyper',0),(569328,15815,'it','Tipi di spesa diretta corrente',0),(569329,15815,'tl','',0),(569330,15815,'th','à¸Šà¸™à¸´à¸”à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¹‚à¸”à¸¢à¸•à¸£à¸‡à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(569331,15815,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤µà¥à¤¯à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(569332,15815,'ms','Jenis-jenis perbelanjaan langsung semasa',0),(569333,15815,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(569334,15815,'fr','Types de dÃ©penses directes actuels',0),(569335,15815,'jp','ç¾åœ¨ã®ç›´æŽ¥çµŒè²»ã®ç¨®é¡ž',0),(569336,15815,'pt','Tipos de despesa direta atual',0),(569337,15815,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ñ‚Ð¸Ð¿Ñ‹ Ð¿Ñ€ÑÐ¼Ñ‹Ñ… Ñ€Ð°ÑÑ…Ð¾Ð´Ð¾Ð²',0),(569338,15815,'es','Tipos actuales de gasto directo',0),(569339,15815,'de','Aktuelle direkte Ausgabearten',0),(569340,15815,'en','Current Direct Expense Types',0),(569341,15816,'is','',0),(569342,15816,'dr','ØªØ§Ø±ÛŒØ® Ø¹Ø¶ÙˆÛŒØª',0),(569343,15816,'pr','ØªØ§Ø±ÛŒØ® Ø¹Ø¶ÙˆÛŒØª',0),(569344,15816,'tr','YayÄ±nlanma tarihi',0),(569345,15816,'pl','Data wystawienia',0),(569346,15816,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð°',0),(569347,15816,'ur','Ù…ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ ØªØ§Ø±ÛŒØ®',0),(569348,15816,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ð±Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐ°',0),(569349,15816,'vi','NgÃ y Ä‘Äƒng',0),(569350,15816,'af','Datum gepos',0),(569351,15816,'ro','Data postat',0),(569352,15816,'et','KuupÃ¤ev',0),(569353,15816,'si','Datum',0),(569354,15816,'ba','Tanggal posting',0),(569355,15816,'nl','Datum geplaatst',0),(569356,15816,'fi','PÃ¤ivÃ¤ys',0),(569357,15816,'no','Dato postet',0),(569358,15816,'da','Dato bogfÃ¸res',0),(569359,15816,'ko','ë‚ ì§œ ê²Œì‹œ ë¨',0),(569360,15816,'he','×ª××¨×™×š ×¢×“×›×•×Ÿ',0),(569361,15816,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î´Î·Î¼Î¿ÏƒÎ¯ÎµÏ…ÏƒÎ·Ï‚',0),(569362,15816,'zh','è¿‡å¸æ—¥æœŸ',0),(569363,15816,'sv','Datum Inlagd',0),(569364,15816,'it','Data di pubblicazione',0),(569365,15816,'tl','',0),(569366,15816,'th','à¸§à¸±à¸™à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(569367,15816,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(569368,15816,'ms','Tarikh dikirim',0),(569369,15816,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ù†Ø´Ø±',0),(569370,15816,'fr','Date de publication',0),(569371,15816,'jp','æŽ²è¼‰æ—¥',0),(569372,15816,'pt','Data postada',0),(569373,15816,'ru','Ð”Ð°Ñ‚Ð° Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(569374,15816,'es','Fecha',0),(569375,15816,'de','Datum gebucht',0),(569376,15816,'en','Date Posted',0),(569377,15817,'is','',0),(569378,15817,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ…',0),(569379,15817,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù…Ø³ØªÙ‚ÛŒÙ…',0),(569380,15817,'tr','DoÄŸrudan gider Ã¶deme',0),(569381,15817,'pl','PÅ‚atnoÅ›ci bezpoÅ›rednich wydatkÃ³w',0),(569382,15817,'bg','ÐŸÑ€ÐµÐºÐ¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(569383,15817,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(569384,15817,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(569385,15817,'vi','Thanh toÃ¡n trá»±c tiáº¿p chi phÃ­',0),(569386,15817,'af','Direkte koste betaling',0),(569387,15817,'ro','Plata cheltuieli directe',0),(569388,15817,'et','Kulu makstakse otse',0),(569389,15817,'si','Neposredno plaÄilo stroÅ¡kov',0),(569390,15817,'ba','Pembayaran langsung biaya',0),(569391,15817,'nl','Rechtstreekse betaling van de kosten',0),(569392,15817,'fi','Suora kulu maksu',0),(569393,15817,'no','Direkte utgifter betaling',0),(569394,15817,'da','Direkte udgift udbetaling',0),(569395,15817,'ko','ì§ì ‘ ë¹„ìš© ì§€ë¶ˆ',0),(569396,15817,'he','×ª×©×œ×•× ×”×•×¦××•×ª ×™×©×™×¨×•×ª',0),(569397,15817,'el','Î‘Ï€ÎµÏ…Î¸ÎµÎ¯Î±Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î® ÎµÎ¾ÏŒÎ´Ï‰Î½',0),(569398,15817,'zh','ç›´æŽ¥è´¹ç”¨æ”¯ä»˜',0),(569399,15817,'sv','Direkt kostnad utbetalning',0),(569400,15817,'it','Spese pagamento diretto',0),(569401,15817,'tl','',0),(569402,15817,'th','à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¹‚à¸”à¸¢à¸•à¸£à¸‡',0),(569403,15817,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤µà¥à¤¯à¤¯ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(569404,15817,'ms','Pembayaran perbelanjaan langsung',0),(569405,15817,'ar','Ø¯ÙØ¹ Ø§Ù„Ù…ØµØ±ÙˆÙØ§Øª Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø©',0),(569406,15817,'fr','Frais de paiement direct',0),(569407,15817,'jp','ç›´æŽ¥çµŒè²»æ”¯æ‰•ã„',0),(569408,15817,'pt','Pagamento de despesas directas',0),(569409,15817,'ru','ÐŸÑ€ÑÐ¼Ñ‹Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(569410,15817,'es','Gasto de pago directo',0),(569411,15817,'de','Direkte Kosten Bezahlung',0),(569412,15817,'en','Direct Expense Payment',0),(569413,15818,'is','',0),(569414,15818,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª',0),(569415,15818,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª',0),(569416,15818,'tr','GiriÅŸ ayrÄ±ntÄ±larÄ±',0),(569417,15818,'pl','SzczegÃ³Å‚y wpisu',0),(569418,15818,'bg','Ð’Ð»Ð¸Ð·Ð°Ð½Ðµ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸',0),(569419,15818,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(569420,15818,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð´ÐµÑ‚Ð°Ñ™Ð°',0),(569421,15818,'vi','Nháº­p thÃ´ng tin chi tiáº¿t',0),(569422,15818,'af','Inskrywing besonderhede',0),(569423,15818,'ro','Intrarea detalii',0),(569424,15818,'et','Kirje Ã¼ksikasjad',0),(569425,15818,'si','Vstop podrobnosti',0),(569426,15818,'ba','Rincian entri',0),(569427,15818,'nl','Vermelding Details',0),(569428,15818,'fi','Tiedot',0),(569429,15818,'no','OppfÃ¸ring detaljer',0),(569430,15818,'da','Post detaljer',0),(569431,15818,'ko','í•­ëª© ì„¸ë¶€ ì •ë³´',0),(569432,15818,'he','×¤×¨×˜×™ ×”×›× ×™×¡×”',0),(569433,15818,'el','Î¤Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(569434,15818,'zh','æ¡ç›®è¯¦ç»†ä¿¡æ¯',0),(569435,15818,'sv','Post Detaljer',0),(569436,15818,'it','Dettagli voce',0),(569437,15818,'tl','',0),(569438,15818,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸£à¸²à¸¢à¸à¸²à¸£',0),(569439,15818,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤µà¤¿à¤µà¤°à¤£',0),(569440,15818,'ms','Butir-butir kemasukan',0),(569441,15818,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(569442,15818,'fr','DÃ©tails de lâ€™entrÃ©e',0),(569443,15818,'jp','ã‚¨ãƒ³ãƒˆãƒªã®è©³ç´°',0),(569444,15818,'pt','Detalhes da entrada',0),(569445,15818,'ru','Ð’Ñ…Ð¾Ð´ Ð´ÐµÑ‚Ð°Ð»Ð¸',0),(569446,15818,'es','Datos de entrada',0),(569447,15818,'de','Eintrag-Details',0),(569448,15818,'en','Entry Details',0),(569449,15819,'is','',0),(569450,15819,'dr','Ù…Ø¬Ù„Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ø´Ù†Ø§Ø³Ù‡ ÙˆØ±ÙˆØ¯',0),(569451,15819,'pr','Ù…Ø¬Ù„Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ø´Ù†Ø§Ø³Ù‡ ÙˆØ±ÙˆØ¯',0),(569452,15819,'tr','GÃ¼nlÃ¼k giriÅŸ kimliÄŸi numarasÄ±',0),(569453,15819,'pl','Numer ID wpisu dziennika',0),(569454,15819,'bg','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº Ð·Ð°Ð¿Ð¸Ñ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½ÐµÐ½ Ð½Ð¾Ð¼ÐµÑ€',0),(569455,15819,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø´Ù†Ø§Ø®Øª Ù†Ù…Ø¨Ø±',0),(569456,15819,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð˜Ð” ÑƒÐ½Ð¾ÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð°',0),(569457,15819,'vi','Táº¡p chÃ­ má»¥c nháº­p ID Number',0),(569458,15819,'af','Joernaal inskrywing ID nommer',0),(569459,15819,'ro','NumÄƒrul de ID-ul intrÄƒrii jurnal',0),(569460,15819,'et','TÃ¶Ã¶lehe kirje ID kood',0),(569461,15819,'si','Å tevilka ID vnosa temeljnice',0),(569462,15819,'ba','Nomor ID entri jurnal',0),(569463,15819,'nl','Item-ID journaalnummer',0),(569464,15819,'fi','Kirjauskansion tunnus numero',0),(569465,15819,'no','OppfÃ¸rings-ID nummer',0),(569466,15819,'da','POST-id kladdenummer',0),(569467,15819,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª© ID ë²ˆí˜¸',0),(569468,15819,'he','×ž×¡×¤×¨ ×ž×–×”×” ×”×¢×¨×š ×™×•×ž×Ÿ',0),(569469,15819,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÎ¿Ï ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(569470,15819,'zh','æ—¥å¿—æ¡ç›® ID ç¼–å·',0),(569471,15819,'sv','Startpost-ID nummer',0),(569472,15819,'it','Numero di ID voce di diario',0),(569473,15819,'tl','',0),(569474,15819,'th','à¹€à¸¥à¸‚à¸£à¸«à¸±à¸ªà¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸™à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™',0),(569475,15819,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ ID à¤•à¥à¤°à¤®à¤¾à¤‚à¤•',0),(569476,15819,'ms','Nombor ID kemasukan jurnal',0),(569477,15819,'ar','Ø±Ù‚Ù… Ù…Ø¹Ø±Ù Ø¥Ø¯Ø®Ø§Ù„ Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(569478,15819,'fr','NumÃ©ro dâ€™identification de lâ€™entrÃ©e de journal',0),(569479,15819,'jp','ä»•è¨³å¸³ã‚¨ãƒ³ãƒˆãƒª ID ç•ªå·',0),(569480,15819,'pt','NÃºmero de identificaÃ§Ã£o de entrada de diÃ¡rio',0),(569481,15819,'ru','ÐÐ¾Ð¼ÐµÑ€ ID Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¶ÑƒÑ€Ð½Ð°Ð»Ð°',0),(569482,15819,'es','NÃºmero de ID de entrada de diario',0),(569483,15819,'de','Eintrags-ID Erfassungsnummer',0),(569484,15819,'en','Journal Entry ID Number',0),(569485,15820,'is','',0),(569486,15820,'dr','ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø± Ù†Ø´Ø¯',0),(569487,15820,'pr','ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø± Ù†Ø´Ø¯',0),(569488,15820,'tr','GÃ¼nlÃ¼k girdisi bulunamadÄ±',0),(569489,15820,'pl','Nie odnaleziono wpisu dziennika',0),(569490,15820,'bg','ÐÐµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½ Ð·Ð°Ð¿Ð¸Ñ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(569491,15820,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(569492,15820,'sr','Ð£Ð½Ð¾Ñ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸Ðº Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(569493,15820,'vi','BÃºt khÃ´ng tÃ¬m tháº¥y',0),(569494,15820,'af','Joernaal inskrywing gevind nie',0),(569495,15820,'ro','Jurnal de intrare nu a fost gÄƒsit',0),(569496,15820,'et','PÃ¤evikukande ei leitud',0),(569497,15820,'si','Vnos v dnevnik ni mogoÄe najti',0),(569498,15820,'ba','Entri jurnal tidak ditemukan',0),(569499,15820,'nl','Logboekitem niet gevonden',0),(569500,15820,'fi','PÃ¤ivyrimerkinnÃ¤n ei lÃ¶ydy',0),(569501,15820,'no','OppfÃ¸ring ikke funnet',0),(569502,15820,'da','Kladdepost ikke fundet',0),(569503,15820,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª©ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(569504,15820,'he','. ×¨×™×©×•× ×™×•×ž×Ÿ ×ž×¡×¤×¨ ×œ× × ×ž×¦×',0),(569505,15820,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(569506,15820,'zh','æ‰¾ä¸åˆ°çš„æ—¥è®°æ¡ç›®',0),(569507,15820,'sv','Journalpost hittades inte',0),(569508,15820,'it','Voce del diario non trovato',0),(569509,15820,'tl','',0),(569510,15820,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™',0),(569511,15820,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€',0),(569512,15820,'ms','Kemasukan jurnal tidak dijumpai',0),(569513,15820,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¥Ø¯Ø®Ø§Ù„ Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(569514,15820,'fr','EntrÃ©e de journal introuvable',0),(569515,15820,'jp','ã‚¸ãƒ£ãƒ¼ãƒŠãƒ« ã‚¨ãƒ³ãƒˆãƒªãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã€‚',0),(569516,15820,'pt','Entrada de diÃ¡rio nÃ£o encontrada',0),(569517,15820,'ru','ÐÐµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð° Ð·Ð°Ð¿Ð¸ÑÑŒ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ',0),(569518,15820,'es','Entrada de diario que no se encuentra',0),(569519,15820,'de','Journal-Eintrag nicht gefunden',0),(569520,15820,'en','Journal Entry Not Found',0),(569521,15821,'is','',0),(569522,15821,'dr','Ù†Ù‡ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(569523,15821,'pr','Ù†Ù‡ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(569524,15821,'tr','YayÄ±nlanan deÄŸil',0),(569525,15821,'pl','Nie napisali',0),(569526,15821,'bg','ÐÐµ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸',0),(569527,15821,'ur','Ù¾ÙˆØ³Ù¹ Ù†ÛÛŒÚº Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(569528,15821,'sr','ÐÐ¸Ñ˜Ðµ Ð¾Ð±Ñ˜Ð°Ð²Ñ™ÐµÐ½Ð°',0),(569529,15821,'vi','KhÃ´ng Ä‘Æ°á»£c Ä‘Äƒng',0),(569530,15821,'af','Nie gepos',0),(569531,15821,'ro','Nu postat',0),(569532,15821,'et','Pole sisestatud',0),(569533,15821,'si','Ni objavljeno',0),(569534,15821,'ba','Tidak diposting',0),(569535,15821,'nl','Niet geplaatst',0),(569536,15821,'fi','Ei lÃ¤hetetty',0),(569537,15821,'no','Ikke postert',0),(569538,15821,'da','Ikke bogfÃ¸rte',0),(569539,15821,'ko','ê²Œì‹œ í•˜ì§€',0),(569540,15821,'he','×œ× ×¤×•×¨×¡×',0),(569541,15821,'el','Î”ÎµÎ½ Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏ„Î·ÎºÎµ',0),(569542,15821,'zh','æœªè¿‡å¸',0),(569543,15821,'sv','Inte bokfÃ¶rts',0),(569544,15821,'it','Non pubblicato',0),(569545,15821,'tl','',0),(569546,15821,'th','à¹„à¸¡à¹ˆà¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(569547,15821,'hi','à¤®à¥‡à¤‚ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(569548,15821,'ms','Tidak hantar',0),(569549,15821,'ar','Ù„Ù… ØªÙ†Ø´Ø±',0),(569550,15821,'fr','Pas affichÃ©',0),(569551,15821,'jp','æŠ•ç¨¿ã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(569552,15821,'pt','NÃ£o publicado',0),(569553,15821,'ru','ÐÐµ ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð¾',0),(569554,15821,'es','No publicada',0),(569555,15821,'de','Nicht gebucht',0),(569556,15821,'en','Not Posted',0),(569557,15822,'is','',0),(569558,15822,'dr','Ù…Ø§Ù„ÛŒØ§ØªÛŒ ØªÙ†Ø¸ÛŒÙ… ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø±',0),(569559,15822,'pr','Ù…Ø§Ù„ÛŒØ§ØªÛŒ ØªÙ†Ø¸ÛŒÙ… ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø±',0),(569560,15822,'tr','GÃ¼nlÃ¼k girdisi ayarlama vergi',0),(569561,15822,'pl','Podatek regulacja pozycja dziennika',0),(569562,15822,'bg','Ð”Ð°Ð½ÑŠÑ‡Ð½Ð¾ Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð°Ð½Ðµ Ð·Ð°Ð¿Ð¸Ñ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(569563,15822,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø§Ø®Ø° Ù¹ÛŒÚ©Ø³',0),(569564,15822,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’Ð°Ð²Ð°ÑšÐµ ÑƒÐ½Ð¾Ñ Ñƒ Ð´Ð½ÐµÐ²Ð½Ð¸Ðº',0),(569565,15822,'vi','Thuáº¿ Ä‘iá»u chá»‰nh bÃºt',0),(569566,15822,'af','Belasting aanpassing joernaal inskrywing',0),(569567,15822,'ro','Taxa de intrare Ã®n jurnal de reglare',0),(569568,15822,'et','Maksu kohandava pÃ¤evikukanne',0),(569569,15822,'si','DavÄno prilagajanje vnosa v dnevnik',0),(569570,15822,'ba','Pajak menyesuaikan entri jurnal',0),(569571,15822,'nl','Belasting dagboekpost aanpassen',0),(569572,15822,'fi','Veron sÃ¤Ã¤tÃ¤minen pÃ¤ivyrimerkinnÃ¤n',0),(569573,15822,'no','Skatt justere loggoppfÃ¸ring',0),(569574,15822,'da','Skat justering journaloptegnelse',0),(569575,15822,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª©ì„ ì¡°ì • í•˜ëŠ” ì„¸ê¸ˆ',0),(569576,15822,'he','×ž×¡ ×”×ª××ž×ª ×¢×¨×š ×™×•×ž×Ÿ',0),(569577,15822,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® ÏÏÎ¸Î¼Î¹ÏƒÎ· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(569578,15822,'zh','ç¨Žæ”¶è°ƒæŽ§çš„æ—¥è®°æ¡ç›®',0),(569579,15822,'sv','Skatt justera journalposten',0),(569580,15822,'it','Tassa di soggiorno dal diario di regolazione',0),(569581,15822,'tl','',0),(569582,15822,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ à¸²à¸©à¸µ',0),(569583,15822,'hi','à¤•à¤° à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(569584,15822,'ms','Cukai yang menyelaraskan kemasukan jurnal',0),(569585,15822,'ar','Ø¶Ø±ÙŠØ¨Ø© ØªØ¹Ø¯ÙŠÙ„ Ø¥Ø¯Ø®Ø§Ù„ Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(569586,15822,'fr','Taxe rÃ©glage entrÃ©e de Journal',0),(569587,15822,'jp','ä»•è¨³å¸³ã®ã‚¨ãƒ³ãƒˆãƒªã‚’èª¿æ•´ã™ã‚‹ç¨Ž',0),(569588,15822,'pt','Fiscal de ajuste diÃ¡rio',0),(569589,15822,'ru','ÐÐ°Ð»Ð¾Ð³, Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€ÑƒÑ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ',0),(569590,15822,'es','Ajuste diario entrada de impuestos',0),(569591,15822,'de','Steuerlichen Anpassung Journaleintrag',0),(569592,15822,'en','Tax Adjusting Journal Entry',0),(569593,15823,'is','',0),(569594,15823,'dr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù…Ø®ØªÙ„Ù Ø¯Ø± 3dcart',0),(569595,15823,'pr','Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ØªÙ†Ø¸ÛŒÙ…Ø§Øª Ù‚Ù„Ù… Ø¯ÙˆÙ… Ø§Ø² Ø§Ù‚Ù„Ø§Ù… Ù…Ø®ØªÙ„Ù Ø¯Ø± 3dcart',0),(569596,15823,'tr','3dcart, Ã§eÅŸitli madde ayarlarÄ± gÃ¼ncelleÅŸtiriliyor',0),(569597,15823,'pl','Aktualizowanie rÃ³Å¼nych ustawieÅ„ elementu o 3dcart',0),(569598,15823,'bg','ÐÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ð¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸ Ð² 3dcart',0),(569599,15823,'ur','3dcart Ù¾Ø± Ù…Ø®ØªÙ„Ù Ø´Û’ Ø³ÛŒÙ¹Ù†Ú¯ÛŒÚº ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(569600,15823,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð° Ñ€Ð°Ð·Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(569601,15823,'vi','Cáº­p Nháº­t cÃ i Ä‘áº·t khoáº£n má»¥c khÃ¡c nhau táº¡i 3dcart',0),(569602,15823,'af','Werk tans by verskeie Item instellings by 3dcart',0),(569603,15823,'ro','Actualizarea diferite setÄƒri de element la 3dcart',0),(569604,15823,'et','Erinevate Ã¼ksuse sÃ¤tete 3dcart vÃ¤rskendamine',0),(569605,15823,'si','Posodabljanje razliÄnih nastavitev elementa v 3dcart',0),(569606,15823,'ba','Memperbarui berbagai Item pengaturan di 3dcart',0),(569607,15823,'nl','Verschillende Objectinstellingen op 3dcart bijwerken',0),(569608,15823,'fi','Eri nimikkeen asetukset 3dcart pÃ¤ivitetÃ¤Ã¤n',0),(569609,15823,'no','Oppdaterer ulike elementet innstillinger pÃ¥ 3dcart',0),(569610,15823,'da','Opdatere forskellige indstillinger pÃ¥ 3dcart',0),(569611,15823,'ko','3dcartì—ì„œ ë‹¤ì–‘ í•œ í•­ëª© ì„¤ì • ì—…ë°ì´íŠ¸',0),(569612,15823,'he','×¢×“×›×•×Ÿ ×”×’×“×¨×•×ª ×©×•× ×•×ª ×¤×¨×™×˜ ×‘- 3dcart',0),(569613,15823,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î´Î¹Î¬Ï†Î¿ÏÎµÏ‚ ÏÏ…Î¸Î¼Î¯ÏƒÎµÎ¹Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ ÏƒÏ„Î¿ 3dcart',0),(569614,15823,'zh','æ›´æ–°åœ¨ 3dcart çš„å„é¡¹è®¾ç½®ã€‚',0),(569615,15823,'sv','Uppdatera olika instÃ¤llningar pÃ¥ 3dcart',0),(569616,15823,'it','L\'aggiornamento delle impostazioni alle 3dcart vari-voce',0),(569617,15823,'tl','',0),(569618,15823,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸•à¹ˆà¸²à¸‡ à¹† à¸—à¸µà¹ˆ 3dcart',0),(569619,15823,'hi','3dcart à¤ªà¤° à¤µà¤¿à¤­à¤¿à¤¨à¥à¤¨ à¤†à¤‡à¤Ÿà¤® à¤¸à¥‡à¤Ÿà¤¿à¤‚à¤—à¥à¤¸ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(569620,15823,'ms','Mengemaskinikan pelbagai butiran pengesetan pada 3dcart',0),(569621,15823,'ar','ØªØ­Ø¯ÙŠØ« Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø¹Ù†ØµØ± Ù…Ø®ØªÙ„Ù ÙÙŠ 3dcart',0),(569622,15823,'fr','Mise Ã  jour de divers paramÃ¨tres de lâ€™article Ã  3dcart',0),(569623,15823,'jp','3dcart ã§æ§˜ã€… ãªé …ç›®ã®è¨­å®šã‚’æ›´æ–°',0),(569624,15823,'pt','Atualizando vÃ¡rias configuraÃ§Ãµes de Item em 3dcart',0),(569625,15823,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ñ€Ð°Ð·Ð»Ð¸Ñ‡Ð½Ñ‹Ñ… Ð¿Ð°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ð¾Ð² ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð½Ð° 3dcart',0),(569626,15823,'es','ActualizaciÃ³n de varias configuraciones de artÃ­culo a 3dcart',0),(569627,15823,'de','Aktualisierung von verschiedenen Einstellungen bei 3dcart',0),(569628,15823,'en','Updating Various Item Settings At 3dcart',0),(569629,15824,'is','',0),(569630,15824,'dr','Ù…Ù‚Ø¯Ø§Ø± ØªØ®Øª',0),(569631,15824,'pr','Ù…Ù‚Ø¯Ø§Ø± ØªØ®Øª',0),(569632,15824,'tr','DÃ¼z tutar',0),(569633,15824,'pl','Kwota zryczaÅ‚towana',0),(569634,15824,'bg','Ð¤Ð¸ÐºÑÐ¸Ñ€Ð°Ð½Ð° ÑÑƒÐ¼Ð°',0),(569635,15824,'ur','ÙÙ„ÛŒÙ¹ Ø±Ù‚Ù…',0),(569636,15824,'sr','Ð Ð°Ð²Ð°Ð½ Ð¸Ð·Ð½Ð¾Ñ',0),(569637,15824,'vi','Sá»‘ lÆ°á»£ng cÄƒn há»™',0),(569638,15824,'af','Plat bedrag',0),(569639,15824,'ro','Suma de plat',0),(569640,15824,'et','Korter summa',0),(569641,15824,'si','Ravno znesek',0),(569642,15824,'ba','Jumlah datar',0),(569643,15824,'nl','Platte bedrag',0),(569644,15824,'fi','KiinteÃ¤ summa',0),(569645,15824,'no','Flat belÃ¸p',0),(569646,15824,'da','Flad belÃ¸b',0),(569647,15824,'ko','í”Œëž« ê¸ˆì•¡',0),(569648,15824,'he','×›×ž×•×ª ×©×˜×•×—',0),(569649,15824,'el','Î£Ï„Î±Î¸ÎµÏÏŒ Ï€Î¿ÏƒÏŒ',0),(569650,15824,'zh','å›ºå®šé‡‘é¢',0),(569651,15824,'sv','Platt belopp',0),(569652,15824,'it','Importo fisso',0),(569653,15824,'tl','',0),(569654,15824,'th','à¸¢à¸­à¸”à¹à¸šà¸™',0),(569655,15824,'hi','à¤«à¥à¤²à¥ˆà¤Ÿ à¤°à¤¾à¤¶à¤¿',0),(569656,15824,'ms','Jumlah yang rata',0),(569657,15824,'ar','Ù…Ù‚Ø¯Ø§Ø± Ù…Ø³Ø·Ø­',0),(569658,15824,'fr','Montant fixe',0),(569659,15824,'jp','å¹³ã‚‰ãªé‡',0),(569660,15824,'pt','Valor fixo',0),(569661,15824,'ru','ÐŸÐ»Ð¾ÑÐºÐ¸Ðµ ÑÑƒÐ¼Ð¼Ð°',0),(569662,15824,'es','Cantidad fija',0),(569663,15824,'de','Pauschalbetrag',0),(569664,15824,'en','Flat Amount',0),(569665,15825,'is','',0),(569666,15825,'dr','Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÛŒ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(569667,15825,'pr','Ù†Ø´Ø§Ù†Ù‡ Ú¯Ø°Ø§Ø±ÛŒ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(569668,15825,'tr','Nakliye biÃ§imlendirme',0),(569669,15825,'pl','WysyÅ‚ka znacznikÃ³w',0),(569670,15825,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð° Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½Ðµ',0),(569671,15825,'ur','Ù†Ø´Ø§Ù† Ø§ØµÙ„Ø§Ø­ Ø´Ù¾Ù†Ú¯',0),(569672,15825,'sr','ÐÐ°Ð·Ð½Ð°ÐºÐµ Ð·Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÑƒ',0),(569673,15825,'vi','Váº­n chuyá»ƒn Ä‘Ã¡nh dáº¥u',0),(569674,15825,'af','Markup gestuur',0),(569675,15825,'ro','Marcare de transport maritim',0),(569676,15825,'et','Laevanduse Markup',0),(569677,15825,'si','Dostava Markup',0),(569678,15825,'ba','Pengiriman Markup',0),(569679,15825,'nl','Verzending Markup',0),(569680,15825,'fi','Toimitus Markup',0),(569681,15825,'no','Frakt markering',0),(569682,15825,'da','Shipping Markup',0),(569683,15825,'ko','ë°°ì†¡ íƒœê·¸',0),(569684,15825,'he','×ž×©×œ×•×— ×¡×™×ž×•×Ÿ',0),(569685,15825,'el','ÎÎ±Ï…Ï„Î¹Î»Î¯Î± ÏƒÎ®Î¼Î±Î½ÏƒÎ·Ï‚',0),(569686,15825,'zh','è¿è¾“æ ‡è®°',0),(569687,15825,'sv','Shipping Markup',0),(569688,15825,'it','Spedizione Markup',0),(569689,15825,'tl','',0),(569690,15825,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸£à¸²à¸„à¸²à¸„à¹ˆà¸²à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(569691,15825,'hi','à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤®à¤¾à¤°à¥à¤•à¤…à¤ª',0),(569692,15825,'ms','Penghantaran penanda',0),(569693,15825,'ar','Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø´Ø­Ù†',0),(569694,15825,'fr','Balisage dâ€™expÃ©dition',0),(569695,15825,'jp','ãƒžãƒ¼ã‚¯ã‚¢ãƒƒãƒ—ã‚’å‡ºè·',0),(569696,15825,'pt','MarcaÃ§Ã£o de envio',0),(569697,15825,'ru','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ€Ð°Ð·Ð¼ÐµÑ‚ÐºÐ¸',0),(569698,15825,'es','Formato de envÃ­o',0),(569699,15825,'de','Versand-Markup',0),(569700,15825,'en','Shipping Markup',0),(569701,15826,'is','',0),(569702,15826,'dr','A & Ù…Ù† Ø­Ø³Ø§Ø¨ Ù…Ø¬Ù…ÙˆØ¹',0),(569703,15826,'pr','A & Ù…Ù† Ø­Ø³Ø§Ø¨ Ù…Ø¬Ù…ÙˆØ¹',0),(569704,15826,'tr','A ve ben toplam fatura',0),(569705,15826,'pl','A idealna I faktury ogÃ³Å‚em',0),(569706,15826,'bg','Ð & Ð°Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¾Ð±Ñ‰Ð°',0),(569707,15826,'ur','A & Ù…ÛŒÚº Ú©Ù„ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(569708,15826,'sr','Ð Ð¸ Ñ˜Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑˆÐµÑ‚Ðµ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(569709,15826,'vi','A & tÃ´i hÃ³a Ä‘Æ¡n tá»•ng sá»‘',0),(569710,15826,'af','\'N & ek faktuur totaal',0),(569711,15826,'ro','A & am factura Total',0),(569712,15826,'et','A- & ma arve kokku',0),(569713,15826,'si','A & sem raÄun skupaj',0),(569714,15826,'ba','A & saya faktur Total',0),(569715,15826,'nl','A & ik totaal factuur',0),(569716,15826,'fi','A & olen laskun loppusummaan',0),(569717,15826,'no','A & jeg faktura totalt',0),(569718,15826,'da','A & jeg fakturerer alt',0),(569719,15826,'ko','A & ì´ ì²­êµ¬ì„œ ë‚˜',0),(569720,15826,'he','A & ×œ×™ ×—×©×‘×•× ×™×ª ×¡×” ×›',0),(569721,15826,'el','A & ÎµÎ³ÏŽ Ï„Î¹Î¼Î¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(569722,15826,'zh','A & æˆ‘çš„å‘ç¥¨åˆè®¡',0),(569723,15826,'sv','A & jag fakturerar totalt',0),(569724,15826,'it','A & ho fattura totale',0),(569725,15826,'tl','',0),(569726,15826,'th','A à¹à¸¥à¸°à¸œà¸¡à¸£à¸§à¸¡à¸‚à¸­à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(569727,15826,'hi','A & à¤®à¥ˆà¤‚ à¤•à¥à¤² à¤šà¤¾à¤²à¤¾à¤¨',0),(569728,15826,'ms','A & saya invois jumlah',0),(569729,15826,'ar','A Ø¢Ù†Ø¯ Ø£Ù†Ø§ Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(569730,15826,'fr','A & je facture Total',0),(569731,15826,'jp','A ãƒ»ç§ã®è«‹æ±‚æ›¸ã®åˆè¨ˆ',0),(569732,15826,'pt','A & eu factura Total',0),(569733,15826,'ru','A & Ñ ÑÑ‡ÐµÑ‚Ð° Ð²ÑÐµÐ³Ð¾',0),(569734,15826,'es','A y me factura Total',0),(569735,15826,'de','A & ich insgesamt in Rechnung zu stellen',0),(569736,15826,'en','A&I Invoice Total',0),(569737,15827,'is','',0),(569738,15827,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ù„ÙˆØ§ÛŒØ­ Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³',0),(569739,15827,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ù„ÙˆØ§ÛŒØ­ Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³',0),(569740,15827,'tr','AP faturalarÄ± oluÅŸturma',0),(569741,15827,'pl','Tworzenie rachunkÃ³w AP',0),(569742,15827,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° AP ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(569743,15827,'ur','AP Ø¨Ù„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(569744,15827,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ ÐÐŸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(569745,15827,'vi','Táº¡o hÃ³a Ä‘Æ¡n AP',0),(569746,15827,'af','Skep GP rekeninge',0),(569747,15827,'ro','Crea facturile de AP',0),(569748,15827,'et','AP arveid luua',0),(569749,15827,'si','Ustvarite raÄune AP',0),(569750,15827,'ba','Membuat AP tagihan',0),(569751,15827,'nl','AP facturen maken',0),(569752,15827,'fi','Luoda AP tuoterakenteita',0),(569753,15827,'no','Opprette AP regninger',0),(569754,15827,'da','Oprette AP regninger',0),(569755,15827,'ko','AP ê³„ì‚° ì„œë¥¼ ë§Œë“¤ê¸°',0),(569756,15827,'he','×œ×™×¦×•×¨ ×—×©×‘×•× ×•×ª AP',0),(569757,15827,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ AP',0),(569758,15827,'zh','åˆ›å»º AP æ³•æ¡ˆ',0),(569759,15827,'sv','Skapa AP rÃ¤kningar',0),(569760,15827,'it','Creare fatture di AP',0),(569761,15827,'tl','',0),(569762,15827,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸ªà¸¹à¸•à¸£ AP',0),(569763,15827,'hi','AP à¤¬à¤¿à¤² à¤¬à¤¨à¤¾',0),(569764,15827,'ms','Mencipta bil AP',0),(569765,15827,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙÙˆØ§ØªÙŠØ± AP',0),(569766,15827,'fr','CrÃ©er des factures de lâ€™AP',0),(569767,15827,'jp','AP æ³•æ¡ˆã‚’ä½œæˆã—ã¾ã™ã€‚',0),(569768,15827,'pt','Criar contas de AP',0),(569769,15827,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð° AP',0),(569770,15827,'es','Crear cuentas de AP',0),(569771,15827,'de','AP-Rechnungen erstellen',0),(569772,15827,'en','Create AP Bills',0),(569773,15828,'is','',0),(569774,15828,'dr','Ø¢ÛŒØªÙ… ÛŒØ§ÙØª Ù†Ø´Ø¯ Ø¯Ø± ÙØ§Ú©ØªÙˆØ±',0),(569775,15828,'pr','Ø¢ÛŒØªÙ… ÛŒØ§ÙØª Ù†Ø´Ø¯ Ø¯Ø± ÙØ§Ú©ØªÙˆØ±',0),(569776,15828,'tr','Madde faturada bulunamadÄ±',0),(569777,15828,'pl','Element nie znajduje siÄ™ na fakturze',0),(569778,15828,'bg','Ð•Ð»ÐµÐ¼ÐµÐ½Ñ‚ÑŠÑ‚ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½ Ð²ÑŠÐ² Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°',0),(569779,15828,'ur','Ø´Û’ Ú©Û’ Ø¨Ù„ Ù¾Ø± Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(569780,15828,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(569781,15828,'vi','Má»¥c khÃ´ng tÃ¬m tháº¥y trÃªn hÃ³a Ä‘Æ¡n',0),(569782,15828,'af','Item nie gevind op die faktuur',0),(569783,15828,'ro','Element negÄƒsit pe facturÄƒ',0),(569784,15828,'et','Ãœksust ei leitud arvel',0),(569785,15828,'si','Elementa ni mogoÄe najti na raÄun',0),(569786,15828,'ba','Item yang tidak ditemukan pada faktur',0),(569787,15828,'nl','Object niet gevonden op factuur',0),(569788,15828,'fi','NimikettÃ¤ ei lÃ¶ydy laskussa',0),(569789,15828,'no','Angitt element finnes ikke pÃ¥ faktura',0),(569790,15828,'da','Elementet blev ikke fundet pÃ¥ fakturaen',0),(569791,15828,'ko','ì†¡ìž¥ì— ì—†ëŠ” í•­ëª©',0),(569792,15828,'he','×”×¤×¨×™×˜ ×œ× × ×ž×¦× ×¢×œ ×”×—×©×‘×•× ×™×ª',0),(569793,15828,'el','Î¤Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ ÏƒÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(569794,15828,'zh','åœ¨å‘ç¥¨ä¸Šæœªæ‰¾åˆ°çš„é¡¹',0),(569795,15828,'sv','Objektet hittades inte pÃ¥ faktura',0),(569796,15828,'it','Elemento non trovato in fattura',0),(569797,15828,'tl','',0),(569798,15828,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸žà¸šà¸šà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(569799,15828,'hi','à¤†à¤‡à¤Ÿà¤® à¤ªà¤° à¤šà¤¾à¤²à¤¾à¤¨ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(569800,15828,'ms','Perkara yang tidak terdapat pada invois',0),(569801,15828,'ar','Ø¹Ù†ØµØ± Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(569802,15828,'fr','Article ne figurant sur la facture',0),(569803,15828,'jp','é …ç›®ãŒè«‹æ±‚æ›¸ã«è¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(569804,15828,'pt','Item nÃ£o encontrado na factura',0),(569805,15828,'ru','Ð­Ð»ÐµÐ¼ÐµÐ½Ñ‚ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½ Ð½Ð° ÑÑ‡ÐµÑ‚',0),(569806,15828,'es','ArtÃ­culo no encontrado en la factura',0),(569807,15828,'de','Artikel nicht gefunden auf Rechnung',0),(569808,15828,'en','Item Not Found On Invoice',0),(569809,15829,'is','',0),(569810,15829,'dr','Ù…Ø³Ø§Ø¨Ù‚Ù‡ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(569811,15829,'pr','Ù…Ø³Ø§Ø¨Ù‚Ù‡ Ø¯Ø± Ø¨Ø± Ø¯Ø§Ø´Øª',0),(569812,15829,'tr','EÅŸleÅŸme bulundu',0),(569813,15829,'pl','Dopasowanie znalezione',0),(569814,15829,'bg','ÐÐ°Ð¼ÐµÑ€ÐµÐ½Ð¾ ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ',0),(569815,15829,'ur','Ù…ÛŒÙ„ Ù†ÛÛŒÚº Ù…Ù„ Ø³Ú©Ø§',0),(569816,15829,'sr','ÐœÐµÑ‡ Ñ˜Ðµ Ð½Ð°ÑˆÐ°Ð¾',0),(569817,15829,'vi','Tráº­n Ä‘áº¥u Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(569818,15829,'af','Pas gevind',0),(569819,15829,'ro','Meci gÄƒsite',0),(569820,15829,'et','Vaste leitud',0),(569821,15829,'si','Tekmo naÅ¡el',0),(569822,15829,'ba','Pertandingan yang ditemukan',0),(569823,15829,'nl','Resultaat gevonden',0),(569824,15829,'fi','LÃ¶ydetty',0),(569825,15829,'no','Kampen fant',0),(569826,15829,'da','Match fundet',0),(569827,15829,'ko','ë°œê²¬ ì¼ì¹˜',0),(569828,15829,'he','× ×ž×¦××” ×”×ª××ž×”',0),(569829,15829,'el','Î’ÏÎ­Î¸Î·ÎºÎµ ÎºÎ±Î½Î­Î½Î± Î±Ï€Î¿Ï„Î­Î»ÎµÏƒÎ¼Î±',0),(569830,15829,'zh','æ‰¾åˆ°çš„åŒ¹é…é¡¹',0),(569831,15829,'sv','Matchen hittade',0),(569832,15829,'it','Corrispondenza trovata',0),(569833,15829,'tl','',0),(569834,15829,'th','à¸•à¸£à¸‡à¸—à¸µà¹ˆà¸žà¸š',0),(569835,15829,'hi','à¤®à¥‡à¤² à¤®à¤¿à¤²à¤¾',0),(569836,15829,'ms','Padanan yang ditemui',0),(569837,15829,'ar','Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ ØªØ·Ø§Ø¨Ù‚',0),(569838,15829,'fr','Correspondance trouvÃ©e',0),(569839,15829,'jp','ä¸€è‡´ã—ãŸã‚‚ã®',0),(569840,15829,'pt','CorrespondÃªncia encontrada',0),(569841,15829,'ru','Ð˜Ð· Ð½Ð°Ð¹Ð´ÐµÐ½Ð½Ñ‹Ñ… ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¸Ð¹',0),(569842,15829,'es','Coincidencia encontrada',0),(569843,15829,'de','Ãœbereinstimmung gefunden',0),(569844,15829,'en','Match Found',0),(569845,15830,'is','',0),(569846,15830,'dr','Ø§Ø³Ú©Ù†Ø§Ø³ Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(569847,15830,'pr','Ø§Ø³Ú©Ù†Ø§Ø³ Ù‡Ø§ÛŒ Ø¬Ø¯ÛŒØ¯ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(569848,15830,'tr','Yeni faturalarÄ± baÅŸarÄ±yla eklendi',0),(569849,15830,'pl','Nowe rachunki dodany pomyÅ›lnie',0),(569850,15830,'bg','ÐÐ¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸, Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(569851,15830,'ur','Ù†Ø¦Û’ Ø¨Ù„ Ù…ÛŒÚº Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø§Ø¶Ø§ÙÛ',0),(569852,15830,'sr','ÐÐ¾Ð²Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(569853,15830,'vi','HÃ³a Ä‘Æ¡n má»›i Ä‘Æ°á»£c gá»­i thÃ nh cÃ´ng',0),(569854,15830,'af','Nuwe rekeninge bygevoeg suksesvol',0),(569855,15830,'ro','Facturile noi adÄƒugate cu succes',0),(569856,15830,'et','Lisatud uued arved',0),(569857,15830,'si','Nove raÄune, ki so dodani',0),(569858,15830,'ba','Tagihan baru ditambahkan berhasil',0),(569859,15830,'nl','Nieuwe biljetten toegevoegd',0),(569860,15830,'fi','Uusien laskujen lisÃ¤Ã¤minen onnistui',0),(569861,15830,'no','Nye regninger lagt',0),(569862,15830,'da','Nye regninger tilfÃ¸jet',0),(569863,15830,'ko','ì„±ê³µì ìœ¼ë¡œ ì¶”ê°€ í•˜ëŠ” ìƒˆë¡œìš´ ë²•ì•ˆ',0),(569864,15830,'he','×©×˜×¨×•×ª ×—×“×©×™× × ×•×¡×£ ×‘×”×¦×œ×—×”',0),(569865,15830,'el','ÎÎ­Î¿Î¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Î¯ Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(569866,15830,'zh','å·²æˆåŠŸæ·»åŠ çš„æ–°æ³•æ¡ˆ',0),(569867,15830,'sv','Nya rÃ¤kningar lagts',0),(569868,15830,'it','Nuove fatture aggiunta con successo',0),(569869,15830,'tl','',0),(569870,15830,'th','à¸ªà¸¹à¸•à¸£à¹ƒà¸«à¸¡à¹ˆà¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(569871,15830,'hi','à¤¨à¤¯à¤¾ à¤¬à¤¿à¤² à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(569872,15830,'ms','Bil baru berjaya menambah',0),(569873,15830,'ar','Ù…Ø´Ø§Ø±ÙŠØ¹ Ø§Ù„Ù‚ÙˆØ§Ù†ÙŠÙ† Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(569874,15830,'fr','Nouveaux projets de loi ajoutÃ©es avec succÃ¨s',0),(569875,15830,'jp','æ­£å¸¸ã«è¿½åŠ ã•ã‚ŒãŸæ–°ã—ã„æ³•æ¡ˆ',0),(569876,15830,'pt','Novas contas adicionadas com sucesso',0),(569877,15830,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ñ‹, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½',0),(569878,15830,'es','Nuevas cuentas se ha agregado correctamente',0),(569879,15830,'de','Neue Rechnungen erfolgreich hinzugefÃ¼gt',0),(569880,15830,'en','New Bills Added Successfully',0),(569881,15831,'is','',0),(569882,15831,'dr','Ù‡ÛŒÚ† Ø¨Ø§Ø²ÛŒ',0),(569883,15831,'pr','Ù‡ÛŒÚ† Ø¨Ø§Ø²ÛŒ',0),(569884,15831,'tr','EÅŸleÅŸme yok',0),(569885,15831,'pl','Nie pasuje',0),(569886,15831,'bg','ÐÑÐ¼Ð° ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ',0),(569887,15831,'ur','Ú©ÙˆØ¦ÛŒ Ù…ÛŒÚ†',0),(569888,15831,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ°',0),(569889,15831,'vi','KhÃ´ng phÃ¹ há»£p',0),(569890,15831,'af','Geen wedstryd',0),(569891,15831,'ro','Nici un meci',0),(569892,15831,'et','Vastet',0),(569893,15831,'si','Nobenega zadetka',0),(569894,15831,'ba','Tidak ada pertandingan',0),(569895,15831,'nl','Geen Match',0),(569896,15831,'fi','Ei vastaa',0),(569897,15831,'no','Ingen Match',0),(569898,15831,'da','Ingen Match',0),(569899,15831,'ko','ì¼ì¹˜',0),(569900,15831,'he','××™×Ÿ ×”×ª××ž×”',0),(569901,15831,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹',0),(569902,15831,'zh','æ²¡æœ‰åŒ¹é…',0),(569903,15831,'sv','Ingen Match',0),(569904,15831,'it','Nessuna corrispondenza',0),(569905,15831,'tl','',0),(569906,15831,'th','à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸™',0),(569907,15831,'hi','à¤•à¥‹à¤ˆ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚',0),(569908,15831,'ms','Tidak sepadan dengan',0),(569909,15831,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ØªØ·Ø§Ø¨Ù‚',0),(569910,15831,'fr','Pas de Match',0),(569911,15831,'jp','ä¸€è‡´ãªã—',0),(569912,15831,'pt','Nenhuma correspondÃªncia',0),(569913,15831,'ru','ÐÐµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚',0),(569914,15831,'es','No coincide con',0),(569915,15831,'de','Keine Ãœbereinstimmung',0),(569916,15831,'en','No Match',0),(569917,15832,'is','',0),(569918,15832,'dr','Ù‡ÛŒÚ† Ø§Ø³Ú©Ù†Ø§Ø³ Ø¬Ø¯ÛŒØ¯ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡',0),(569919,15832,'pr','Ù‡ÛŒÚ† Ø§Ø³Ú©Ù†Ø§Ø³ Ø¬Ø¯ÛŒØ¯ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡',0),(569920,15832,'tr','Yeni fatura eklendi',0),(569921,15832,'pl','Ma nowe rachunki dodane',0),(569922,15832,'bg','ÐÑÐ¼Ð° Ð½Ð¾Ð²Ð¸ ÑÐ¼ÐµÑ‚ÐºÐ¸ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½Ð¸',0),(569923,15832,'ur','Ú©ÙˆØ¦ÛŒ Ù†Ø¦Û’ Ø¨Ù„ Ù…ÛŒÚº Ø´Ø§Ù…Ù„',0),(569924,15832,'sr','ÐÐµÐ¼Ð° Ð½Ð¾Ð²Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ, Ð´Ð¾Ð´Ð°Ð¾ Ñ˜Ðµ',0),(569925,15832,'vi','KhÃ´ng cÃ³ hÃ³a Ä‘Æ¡n má»›i Ä‘Æ°á»£c thÃªm vÃ o',0),(569926,15832,'af','Geen nuwe rekeninge bygevoeg',0),(569927,15832,'ro','Nu facturile noi adÄƒugate',0),(569928,15832,'et','Pole lisatud uusi arveid',0),(569929,15832,'si','Ni novih raÄunov, doda',0),(569930,15832,'ba','Tagihan tidak baru ditambahkan',0),(569931,15832,'nl','Geen nieuwe rekeningen toegevoegd',0),(569932,15832,'fi','Ei uusia laskuja, lisÃ¤tÃ¤Ã¤n',0),(569933,15832,'no','Ingen nye regninger lagt',0),(569934,15832,'da','Ingen nye regninger tilfÃ¸jet',0),(569935,15832,'ko','ì•„ë‹ˆ ìƒˆë¡œìš´ ìš”ê¸ˆ ì¶”ê°€',0),(569936,15832,'he','×‘×œ×™ ×—×©×‘×•× ×•×ª ×—×“×©×™× ×©× ×•×¡×¤×•',0),(569937,15832,'el','ÎšÎ±Î¼Î¯Î± Î½Î­Î± Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î± Ï€Î¿Ï… Ï€ÏÏŒÏƒÎ¸ÎµÏƒÎ±Î½',0),(569938,15832,'zh','æ²¡æœ‰æ·»åŠ çš„æ–°æ³•æ¡ˆ',0),(569939,15832,'sv','Inga nya rÃ¤kningar lÃ¤ggs',0),(569940,15832,'it','Nessuna bolletta nuova aggiunta',0),(569941,15832,'tl','',0),(569942,15832,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸ªà¸¹à¸•à¸£à¹ƒà¸«à¸¡à¹ˆà¹€à¸žà¸´à¹ˆà¸¡',0),(569943,15832,'hi','à¤•à¥‹à¤ˆ à¤¨à¤ à¤¬à¤¿à¤² à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾',0),(569944,15832,'ms','Tiada bil baru yang ditambah',0),(569945,15832,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ù…Ø´Ø§Ø±ÙŠØ¹ Ø§Ù„Ù‚ÙˆØ§Ù†ÙŠÙ† Ø§Ù„Ø¬Ø¯ÙŠØ¯Ø© Ø§Ù„Ù…Ø¶Ø§ÙØ©',0),(569946,15832,'fr','Aucune nouvelle facture ajoutÃ©',0),(569947,15832,'jp','è¿½åŠ æ–°ã—ã„ä»£ã¯ã‹ã‹ã‚Šã¾ã›ã‚“',0),(569948,15832,'pt','Sem contas novas adicionadas',0),(569949,15832,'ru','Ð‘ÐµÐ· Ð½Ð¾Ð²Ñ‹Ñ… Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¾Ð² Ð´Ð¾Ð±Ð°Ð²Ð¸Ð»',0),(569950,15832,'es','Sin expensas nuevo aÃ±adidos',0),(569951,15832,'de','Keine neuen Rechnungen hinzugefÃ¼gt',0),(569952,15832,'en','No New Bills Added',0),(569953,15833,'is','',0),(569954,15833,'dr','Ù‚ÛŒÙ…Øª Ø§Ø² ØªØºÛŒÛŒØ±',0),(569955,15833,'pr','Ù‚ÛŒÙ…Øª Ø§Ø² ØªØºÛŒÛŒØ±',0),(569956,15833,'tr','Fiyat deÄŸiÅŸti',0),(569957,15833,'pl','CenÄ™ z',0),(569958,15833,'bg','Ð¦ÐµÐ½Ð°, Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð¾Ñ‚',0),(569959,15833,'ur','Ù‚ÛŒÙ…Øª Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(569960,15833,'sr','Ð¦ÐµÐ½Ð° Ñ˜Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½Ð° Ð¸Ð·',0),(569961,15833,'vi','GiÃ¡ thay Ä‘á»•i tá»«',0),(569962,15833,'af','Prys verander vanaf',0),(569963,15833,'ro','Pret schimbat de la',0),(569964,15833,'et','Hind muutus alates',0),(569965,15833,'si','Cena spremenila iz',0),(569966,15833,'ba','Harga berubah dari',0),(569967,15833,'nl','Prijs gewijzigd van',0),(569968,15833,'fi','Hinta muuttui',0),(569969,15833,'no','Pris fra',0),(569970,15833,'da','Pris Ã¦ndret fra',0),(569971,15833,'ko','ê°€ê²©ì—ì„œ ë³€ê²½',0),(569972,15833,'he','×”×ž×—×™×¨ ×ž×©×ª× ×” ×ž-',0),(569973,15833,'el','Î¤Î¹Î¼Î® Î±Î»Î»Î¬Î¾ÎµÎ¹ Î±Ï€ÏŒ',0),(569974,15833,'zh','ä»·æ ¼å˜åŒ–ä»Ž',0),(569975,15833,'sv','Priset Ã¤ndras frÃ¥n',0),(569976,15833,'it','Prezzo cambiato da',0),(569977,15833,'tl','',0),(569978,15833,'th','à¸£à¸²à¸„à¸²à¸—à¸µà¹ˆà¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸ˆà¸²à¸',0),(569979,15833,'hi','à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥‡ à¤¬à¤¦à¤²à¤¾',0),(569980,15833,'ms','Harga berubah dari',0),(569981,15833,'ar','ØªØºÙŠÙŠØ± Ø§Ù„Ø³Ø¹Ø± Ù…Ù†',0),(569982,15833,'fr','Prix modifiÃ© de',0),(569983,15833,'jp','ä¾¡æ ¼å¤‰æ›´',0),(569984,15833,'pt','PreÃ§o alterado de',0),(569985,15833,'ru','Ð¦ÐµÐ½Ð° Ð¸Ð·Ð¼ÐµÐ½Ð¸Ð»Ð°ÑÑŒ Ð¾Ñ‚',0),(569986,15833,'es','Precio cambia de',0),(569987,15833,'de','Eine PreisÃ¤nderung von',0),(569988,15833,'en','Price Changed From',0),(569989,15834,'is','',0),(569990,15834,'dr','ØªØºÛŒÛŒØ± Ø§Ø² ØªØ¹Ø¯Ø§Ø¯',0),(569991,15834,'pr','ØªØºÛŒÛŒØ± Ø§Ø² ØªØ¹Ø¯Ø§Ø¯',0),(569992,15834,'tr','Miktar deÄŸiÅŸtirildi',0),(569993,15834,'pl','IloÅ›Ä‡ z',0),(569994,15834,'bg','ÐšÐ¾Ð»-Ð²Ð¾ Ð¿Ñ€Ð¾Ð¼ÑÐ½Ð° Ð¾Ñ‚',0),(569995,15834,'ur','Ù‚ÛŒ Ø³Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§',0),(569996,15834,'sr','ÐšÐ¾Ð» Ñ˜Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÑšÐµÐ½ Ð¸Ð·',0),(569997,15834,'vi','SL Ä‘Ã£ thay Ä‘á»•i tá»«',0),(569998,15834,'af','Qty verander vanaf',0),(569999,15834,'ro','Cantitate s-a schimbat din',0),(570000,15834,'et','Kogus, mis on muutunud',0),(570001,15834,'si','KoliÄina, spremeni iz',0),(570002,15834,'ba','Qty berubah dari',0),(570003,15834,'nl','Aantal gewijzigd ten opzichte van',0),(570004,15834,'fi','MÃ¤Ã¤rÃ¤ muuttui',0),(570005,15834,'no','Antall endret fra',0),(570006,15834,'da','Antal Ã¦ndret fra',0),(570007,15834,'ko','ìˆ˜ëŸ‰ì—ì„œ ë³€ê²½',0),(570008,15834,'he','×›×ž×•×ª ×ž×©×ª× ×” ×ž-',0),(570009,15834,'el','Qty Î¬Î»Î»Î±Î¾Îµ Î±Ï€ÏŒ',0),(570010,15834,'zh','ä»Žæ›´æ”¹æ•°é‡',0),(570011,15834,'sv','Antal Ã¤ndrade frÃ¥n',0),(570012,15834,'it','Qty cambiato da',0),(570013,15834,'tl','',0),(570014,15834,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸ˆà¸²à¸',0),(570015,15834,'hi','à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¸à¥‡ à¤¬à¤¦à¤²à¤¾',0),(570016,15834,'ms','Qty ditukar daripada',0),(570017,15834,'ar','ØªØºÙŠÙŠØ± Ø§Ù„ÙƒÙ…ÙŠØ© Ù…Ù†',0),(570018,15834,'fr','QtÃ© de',0),(570019,15834,'jp','æ•°é‡å¤‰æ›´',0),(570020,15834,'pt','Qty mudou de',0),(570021,15834,'ru','Qty Ð¸Ð·Ð¼ÐµÐ½Ð¸Ð»Ð¾ÑÑŒ Ð¾Ñ‚',0),(570022,15834,'es','Cantidad de',0),(570023,15834,'de','Menge von geÃ¤ndert',0),(570024,15834,'en','Qty Changed From',0),(570025,15835,'is','',0),(570026,15835,'dr','Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ',0),(570027,15835,'pr','Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ',0),(570028,15835,'tr','Alma',0),(570029,15835,'pl','Pobieranie',0),(570030,15835,'bg','Ð˜Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ',0),(570031,15835,'ur','Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(570032,15835,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ',0),(570033,15835,'vi','Truy xuáº¥t',0),(570034,15835,'af','Herwinning',0),(570035,15835,'ro','RegÄƒsirea',0),(570036,15835,'et','Toomine',0),(570037,15835,'si','Pri pridobivanju',0),(570038,15835,'ba','Mengambil',0),(570039,15835,'nl','Ophalen',0),(570040,15835,'fi','Haetaan',0),(570041,15835,'no','Hente',0),(570042,15835,'da','Hentning af',0),(570043,15835,'ko','ê²€ìƒ‰',0),(570044,15835,'he','××—×–×•×¨',0),(570045,15835,'el','Î‘Î½Î¬ÎºÏ„Î·ÏƒÎ·',0),(570046,15835,'zh','æ£€ç´¢',0),(570047,15835,'sv','HÃ¤mta',0),(570048,15835,'it','Recupero',0),(570049,15835,'tl','',0),(570050,15835,'th','à¹€à¸£à¸µà¸¢à¸',0),(570051,15835,'hi','à¤ªà¥à¤¨à¤°à¥à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(570052,15835,'ms','Mendapatkan semula',0),(570053,15835,'ar','Ø§Ø³ØªØ±Ø¯Ø§Ø¯',0),(570054,15835,'fr','RÃ©cupÃ©ration des',0),(570055,15835,'jp','å–å¾—ã—ã¾ã™ã€‚',0),(570056,15835,'pt','Recuperando',0),(570057,15835,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ðµ',0),(570058,15835,'es','Recuperar',0),(570059,15835,'de','Abrufen von',0),(570060,15835,'en','Retrieving',0),(570061,15836,'is','',0),(570062,15836,'dr','Ø¯Ø± Ù¾ÛŒØ±ÛŒ Ú¯Ø²Ø§Ø±Ø´ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(570063,15836,'pr','Ø¯Ø± Ù¾ÛŒØ±ÛŒ Ú¯Ø²Ø§Ø±Ø´ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯',0),(570064,15836,'tr','YaÅŸlandÄ±rma raporunu gÃ¶ster',0),(570065,15836,'pl','PokaÅ¼ Raport Wiekowanie na',0),(570066,15836,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð½Ð° ÑÑ‚Ð°Ñ€ÐµÐµÐ½Ðµ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(570067,15836,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ø®Ø³ØªÛ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(570068,15836,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð½Ð° ÑÑ‚Ð°Ñ€Ð¸Ð¼ Ð¸Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜',0),(570069,15836,'vi','Hiá»ƒn thá»‹ ngÃ y lÃ£o hÃ³a bÃ¡o cÃ¡o',0),(570070,15836,'af','Wys op veroudering verslag',0),(570071,15836,'ro','AratÄƒ pe raportul de imbatranire',0),(570072,15836,'et','Linna Aegumisaruande NÃ¤ita',0),(570073,15836,'si','KaÅ¾ejo na staranje poroÄilo',0),(570074,15836,'ba','Lihat penuaan laporan',0),(570075,15836,'nl','Toon op veroudering verslag',0),(570076,15836,'fi','NÃ¤ytÃ¤ hotelli kaupungin yht.veto-raportin',0),(570077,15836,'no','Vis pÃ¥ aldersfordelt saldoliste',0),(570078,15836,'da','Vis pÃ¥ Aging rapport',0),(570079,15836,'ko','ì—ì´ì§• ë³´ê³ ì„œì— í‘œì‹œ',0),(570080,15836,'he','×”×¦×’ ×¢×œ ×“×•×— ×’×™×•×œ',0),(570081,15836,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Î³Î¹Î± Ï„Î· Î³Î®ÏÎ±Î½ÏƒÎ· Î­ÎºÎ¸ÎµÏƒÎ·',0),(570082,15836,'zh','åœ¨è€åŒ–æŠ¥å‘Šä¸Šæ˜¾ç¤º',0),(570083,15836,'sv','Visa pÃ¥ Ã…ldersrapport',0),(570084,15836,'it','Visualizza il Report di invecchiamento',0),(570085,15836,'tl','',0),(570086,15836,'th','à¹à¸ªà¸”à¸‡à¸šà¸™à¸£à¸²à¸¢à¸‡à¸²à¸™à¸­à¸²à¸¢à¸¸à¸«à¸™à¸µà¹‰',0),(570087,15836,'hi','à¤à¤œà¤¿à¤‚à¤— à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ à¤ªà¤° à¤¦à¤¿à¤–à¤¾à¤à¤',0),(570088,15836,'ms','Tunjuk laporan penuaan',0),(570089,15836,'ar','ÙˆØªØ¸Ù‡Ø± ÙÙŠ Ø§Ù„Ø´ÙŠØ®ÙˆØ®Ø© Ø§Ù„ØªÙ‚Ø±ÙŠØ±',0),(570090,15836,'fr','Afficher le rapport dâ€™ANTERIORITE',0),(570091,15836,'jp','ã‚¨ã‚¤ã‚¸ãƒ³ã‚° ãƒ¬ãƒãƒ¼ãƒˆã«è¡¨ç¤ºã—ã¾ã™ã€‚',0),(570092,15836,'pt','Mostrar no relatÃ³rio do envelhecimento',0),(570093,15836,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð½Ð° ÑÑ‚Ð°Ñ€ÐµÐ½Ð¸Ñ Ð´Ð¾ÐºÐ»Ð°Ð´',0),(570094,15836,'es','Ver informe de envejecimiento',0),(570095,15836,'de','Mit einer veralteten Bericht zeigen',0),(570096,15836,'en','Show On Aging Report',0),(570097,15837,'is','',0),(570098,15837,'dr','Ù‚Ø¨ÙˆÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª Ú©Ù…Ø±',0),(570099,15837,'pr','Ù‚Ø¨ÙˆÙ„ Ø³ÙØ§Ø±Ø´Ø§Øª Ú©Ù…Ø±',0),(570100,15837,'tr','Arka sipariÅŸleri kabul',0),(570101,15837,'pl','PrzyjÄ™cia zamÃ³wienia',0),(570102,15837,'bg','ÐŸÑ€Ð¸ÐµÐ¼Ð°Ð¼ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸ Ð·Ð° Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð¾',0),(570103,15837,'ur','Ù¾ÛŒÙ¹Ú¾ Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©Ùˆ Ù‚Ø¨ÙˆÙ„',0),(570104,15837,'sr','ÐŸÑ€Ð¸Ñ…Ð²Ð°Ñ‚Ð¸ Ð½Ð°Ð³Ð¾Ð¼Ð¸Ð»Ð°Ð½Ð¾Ð³',0),(570105,15837,'vi','Cháº¥p nháº­n Ä‘Æ¡n Ä‘áº·t hÃ ng trá»Ÿ láº¡i',0),(570106,15837,'af','Terug bestellings aanvaar',0),(570107,15837,'ro','Accepta comenzi de spate',0),(570108,15837,'et','Aktsepteeri jÃ¤reltellimused',0),(570109,15837,'si','Sprejeti nazaj naroÄila',0),(570110,15837,'ba','Menerima pesanan kembali',0),(570111,15837,'nl','Accepteren van backorders',0),(570112,15837,'fi','HyvÃ¤ksy jÃ¤lkitoimitukset',0),(570113,15837,'no','Godta restordrer',0),(570114,15837,'da','Acceptere restordrer',0),(570115,15837,'ko','ë‹¤ì‹œ ìˆœì„œë¥¼ ë°›ì•„ë“¤ì¸ë‹¤',0),(570116,15837,'he','×ž×§×‘×œ×™× ×”×–×ž× ×•×ª ×”××—×•×¨×™',0),(570117,15837,'el','Î”ÎµÏ‡Î¸ÎµÎ¯ Î±Î½ÎµÎºÏ„Î­Î»ÎµÏƒÏ„ÎµÏ‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯ÎµÏ‚',0),(570118,15837,'zh','æŽ¥å—è®¢è´§',0),(570119,15837,'sv','Acceptera restorder',0),(570120,15837,'it','Accettare ordini arretrati',0),(570121,15837,'tl','',0),(570122,15837,'th','à¸£à¸±à¸šà¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸à¸¥à¸±à¸š',0),(570123,15837,'hi','à¤ªà¥€à¤  à¤•à¥‡ à¤†à¤¦à¥‡à¤¶ à¤•à¥‹ à¤¸à¥à¤µà¥€à¤•à¤¾à¤°',0),(570124,15837,'ms','Menerima kembali Tempahan',0),(570125,15837,'ar','Ù‚Ø¨ÙˆÙ„ Ø£ÙˆØ§Ù…Ø± Ù…Ø±Ø© Ø£Ø®Ø±Ù‰',0),(570126,15837,'fr','Accepte les commandes en souffrance',0),(570127,15837,'jp','ãƒãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼ã‚‚å—ã‘ä»˜ã‘ã¦ãã ã•ã„ã€‚',0),(570128,15837,'pt','Aceitar pedidos',0),(570129,15837,'ru','ÐŸÑ€Ð¸Ð½Ð¸Ð¼Ð°ÐµÐ¼ Ð·Ð°ÐºÐ°Ð·Ñ‹ Ð½Ð° ÑÐ¿Ð¸Ð½Ðµ',0),(570130,15837,'es','Aceptar Ã³rdenes de espalda',0),(570131,15837,'de','Nachlieferungen zu akzeptieren',0),(570132,15837,'en','Accept Back Orders',0),(570133,15838,'is','',0),(570134,15838,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ ØªØºÛŒÛŒØ±Ø§Øª Ø³ÙØ§Ø±Ø´',0),(570135,15838,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ ØªØºÛŒÛŒØ±Ø§Øª Ø³ÙØ§Ø±Ø´',0),(570136,15838,'tr','SipariÅŸ deÄŸiÅŸiklikler izin',0),(570137,15838,'pl','Zgoda na zmiany w kolejnoÅ›ci',0),(570138,15838,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(570139,15838,'ur','ØªØ±ØªÛŒØ¨ ØªØ±Ø§Ù…ÛŒÙ… Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(570140,15838,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ Ð¼Ð¾Ð´Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(570141,15838,'vi','Cho phÃ©p sá»­a Ä‘á»•i Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(570142,15838,'af','Laat orde modifikasies',0),(570143,15838,'ro','Permit modificÄƒri de ordin',0),(570144,15838,'et','Luba tellimuse muutmine',0),(570145,15838,'si','OmogoÄajo, da spremembe',0),(570146,15838,'ba','Memungkinkan perintah modifikasi',0),(570147,15838,'nl','Volgorde wijzigingen toestaan',0),(570148,15838,'fi','Salli tilauksen muutokset',0),(570149,15838,'no','Tillat rekkefÃ¸lge endringer',0),(570150,15838,'da','Giver mulighed for Ã¦ndringer',0),(570151,15838,'ko','ì£¼ë¬¸ ìˆ˜ì • í—ˆìš©',0),(570152,15838,'he','×œ××¤×©×¨ ×©×™× ×•×™ ×¡×“×¨',0),(570153,15838,'el','Î•Ï€Î¹Ï„ÏÎ­ÏˆÎµÎ¹ Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(570154,15838,'zh','å…è®¸å‘½ä»¤ä¿®æ”¹',0),(570155,15838,'sv','TillÃ¥ta Ã¤ndringar av Order',0),(570156,15838,'it','Consenti modifiche degli ordini',0),(570157,15838,'tl','',0),(570158,15838,'th','à¸­à¸™à¸¸à¸à¸²à¸•à¸à¸²à¸£à¸›à¸£à¸±à¸šà¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(570159,15838,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¤‚à¤¶à¥‹à¤§à¤¨ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿à¤¤ à¤¦à¥‡à¤‚',0),(570160,15838,'ms','Membenarkan perintah pengubahsuaian',0),(570161,15838,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨Ø¥Ø¯Ø®Ø§Ù„ ØªØ¹Ø¯ÙŠÙ„Ø§Øª Ø§Ù„Ù†Ø¸Ø§Ù…',0),(570162,15838,'fr','Autoriser les Modifications de lâ€™ordonnance',0),(570163,15838,'jp','æ³¨æ–‡ã®å¤‰æ›´ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(570164,15838,'pt','Permitir modificaÃ§Ãµes de ordem',0),(570165,15838,'ru','ÐŸÐ¾Ñ€ÑÐ´Ð¾Ðº Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(570166,15838,'es','Permite modificaciones de orden',0),(570167,15838,'de','Ã„nderungen der Bestellung zu ermÃ¶glichen',0),(570168,15838,'en','Allow Order Modifications',0),(570169,15839,'is','',0),(570170,15839,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙˆÛŒÚ˜Ù‡',0),(570171,15839,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ ÙˆÛŒÚ˜Ù‡',0),(570172,15839,'tr','Ã–zel fiyatlandÄ±rma izin',0),(570173,15839,'pl','Zezwalaj na specjalne ceny',0),(570174,15839,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ Ð½Ð° ÑÐ¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ñ†ÐµÐ½Ð¸',0),(570175,15839,'ur','Ø®ØµÙˆØµÛŒ Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(570176,15839,'sr','ÐžÐ¼Ð¾Ð³ÑƒÑ›Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÐµÐ±Ð°Ð½ Ñ†ÐµÐ½Ð¾Ð²Ð½Ð¸Ðº',0),(570177,15839,'vi','Cho phÃ©p giÃ¡ Ä‘áº·c biá»‡t',0),(570178,15839,'af','Spesiale pryse laat',0),(570179,15839,'ro','Permite preÅ£uri speciale',0),(570180,15839,'et','VÃµimaldavad erilisi hinnakujundust',0),(570181,15839,'si','OmogoÄajo posebne cene',0),(570182,15839,'ba','Memungkinkan harga khusus',0),(570183,15839,'nl','Toestaan bijzondere prijzen',0),(570184,15839,'fi','Salli erikoishintaan',0),(570185,15839,'no','Tillate spesialpriser',0),(570186,15839,'da','Giver mulighed for Special prissÃ¦tning',0),(570187,15839,'ko','íŠ¹ë³„ ê°€ê²© í—ˆìš©',0),(570188,15839,'he','×œ××¤×©×¨ ×ª×ž×—×•×¨ ×ž×™×•×—×“',0),(570189,15839,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ ÎµÎ¹Î´Î¹ÎºÎ­Ï‚ Ï„Î¹Î¼Î­Ï‚',0),(570190,15839,'zh','å…è®¸ç‰¹æ®Šå®šä»·',0),(570191,15839,'sv','TillÃ¥ta sÃ¤rskild prissÃ¤ttning',0),(570192,15839,'it','Consentire a un prezzo speciale',0),(570193,15839,'tl','',0),(570194,15839,'th','à¹ƒà¸«à¹‰à¸£à¸²à¸„à¸²à¸žà¸´à¹€à¸¨à¸©',0),(570195,15839,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(570196,15839,'ms','Membenarkan harga istimewa',0),(570197,15839,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ù„ØªØ³Ø¹ÙŠØ± Ø§Ù„Ø®Ø§ØµØ©',0),(570198,15839,'fr','Permettre une tarification spÃ©ciale',0),(570199,15839,'jp','ç‰¹åˆ¥ãªä¾¡æ ¼è¨­å®šã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(570200,15839,'pt','Permitir a preÃ§os especiais',0),(570201,15839,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ ÑÐ¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ñ†ÐµÐ½Ñ‹',0),(570202,15839,'es','Permiten precios especiales',0),(570203,15839,'de','ErmÃ¶glichen, Sonderpreise',0),(570204,15839,'en','Allow Special Pricing',0),(570205,15840,'is','',0),(570206,15840,'dr','Ø®Ø±ÛŒØ¯Ø§Ø±Ø§Ù† ØªÙ†Ù‡Ø§ Ù…Ø¬Ø§Ø²',0),(570207,15840,'pr','Ø®Ø±ÛŒØ¯Ø§Ø±Ø§Ù† ØªÙ†Ù‡Ø§ Ù…Ø¬Ø§Ø²',0),(570208,15840,'tr','Yetkili alÄ±cÄ±lar yalnÄ±zca',0),(570209,15840,'pl','Autoryzowanymi nabywcami tylko',0),(570210,15840,'bg','ÐžÑ‚Ð¾Ñ€Ð¸Ð·Ð¸Ñ€Ð°Ð½ ÐºÑƒÐ¿ÑƒÐ²Ð°Ñ‡Ð¸ ÑÐ°Ð¼Ð¾',0),(570211,15840,'ur','ØµØ±Ù Ù…Ø¬Ø§Ø² Ø®Ø±ÛŒØ¯Ø§Ø±ÙˆÚº',0),(570212,15840,'sr','Ð¡Ð°Ð¼Ð¾ Ð¾Ð²Ð»Ð°ÑˆÑ›ÐµÐ½Ð¸ ÐºÑƒÐ¿Ñ†Ð¸',0),(570213,15840,'vi','Tháº©m quyá»n mua chá»‰',0),(570214,15840,'af','Slegs gemagtigde kopers',0),(570215,15840,'ro','Cumparatori autorizat numai',0),(570216,15840,'et','Ainult volitatud Ostuabi',0),(570217,15840,'si','Le pooblaÅ¡Äeni kupci',0),(570218,15840,'ba','Resmi pembeli hanya',0),(570219,15840,'nl','Alleen geautoriseerde kopers',0),(570220,15840,'fi','Valtuutettu Ostajat Only',0),(570221,15840,'no','Autoriserte innkjÃ¸pere bare',0),(570222,15840,'da','Autoriserede kÃ¸bere kun',0),(570223,15840,'ko','ê¶Œí•œ ìžˆëŠ” êµ¬ë§¤ìžë§Œ',0),(570224,15840,'he','×§×•× ×™× ×ž×•×¨×©×™× ×‘×œ×‘×“',0),(570225,15840,'el','ÎœÏŒÎ½Î¿ ÏƒÎµ ÎµÎ¾Î¿Ï…ÏƒÎ¹Î¿Î´Î¿Ï„Î·Î¼Î­Î½Î¿Ï…Ï‚ Î±Î³Î¿ÏÎ±ÏƒÏ„Î­Ï‚',0),(570226,15840,'zh','åªæœ‰å·²æŽˆæƒçš„ä¹°å®¶',0),(570227,15840,'sv','GodkÃ¤nda kÃ¶pare endast',0),(570228,15840,'it','Solo gli acquirenti autorizzati',0),(570229,15840,'tl','',0),(570230,15840,'th','à¸œà¸¹à¹‰à¸‹à¸·à¹‰à¸­à¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(570231,15840,'hi','à¤•à¥‡à¤µà¤² à¤…à¤§à¤¿à¤•à¥ƒà¤¤ à¤–à¤°à¥€à¤¦à¤¾à¤°à¥‹à¤‚',0),(570232,15840,'ms','Kuasa pembeli sahaja',0),(570233,15840,'ar','Ø¥Ø°Ù† Ø§Ù„Ù…Ø´ØªØ±ÙŠÙ† ÙÙ‚Ø·',0),(570234,15840,'fr','Acheteurs autorisÃ©s uniquement',0),(570235,15840,'jp','æ‰¿èªã•ã‚ŒãŸãƒã‚¤ãƒ¤ãƒ¼ã®ã¿',0),(570236,15840,'pt','Compradores autorizados apenas',0),(570237,15840,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ ÑƒÐ¿Ð¾Ð»Ð½Ð¾Ð¼Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ð¼ Ð¿Ð¾ÐºÑƒÐ¿Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(570238,15840,'es','Compradores autorizados solamente',0),(570239,15840,'de','Autorisierte KÃ¤ufer nur',0),(570240,15840,'en','Authorized Buyers Only',0),(570241,15841,'is','',0),(570242,15841,'dr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¯Ø±ÛŒØ§ÙØª',0),(570243,15841,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¯Ø±ÛŒØ§ÙØª',0),(570244,15841,'tr','AlÄ±nan kredi baÅŸvurusu',0),(570245,15841,'pl','Otrzymanego wniosku kredytowego',0),(570246,15841,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð¾ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚',0),(570247,15841,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù…ÙˆØµÙˆÙ„',0),(570248,15841,'sr','ÐÐ¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð° Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ðµ',0),(570249,15841,'vi','TÃ­n dá»¥ng á»©ng dá»¥ng Ä‘Ã£ nháº­n Ä‘Æ°á»£c',0),(570250,15841,'af','Krediet aansoek ontvang',0),(570251,15841,'ro','Cerere de credit primitÄƒ',0),(570252,15841,'et','Krediidi taotlus sai',0),(570253,15841,'si','Vloga za kredit, prejel',0),(570254,15841,'ba','Aplikasi kredit yang diterima',0),(570255,15841,'nl','Kredietaanvraag ontvangen',0),(570256,15841,'fi','Luottohakemus vastaanotettu',0),(570257,15841,'no','Kredittkort sÃ¸knad mottatt',0),(570258,15841,'da','KreditansÃ¸gning modtaget',0),(570259,15841,'ko','ìˆ˜ì‹  í•˜ëŠ” ì‹ ìš© ì‘ìš© í”„ë¡œê·¸ëž¨',0),(570260,15841,'he','×‘×§×©×ª ×”××©×¨××™ ×©×”×ª×§×‘×œ×•',0),(570261,15841,'el','Î‘Î¯Ï„Î·ÏƒÎ· Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚ Ï€Î¿Ï… Î­Î»Î±Î²Îµ',0),(570262,15841,'zh','æ”¶åˆ°çš„ä¿¡ç”¨ç”³è¯·',0),(570263,15841,'sv','KreditansÃ¶kan fick',0),(570264,15841,'it','Ricevuta della domanda di credito',0),(570265,15841,'tl','',0),(570266,15841,'th','à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­à¹„à¸”à¹‰à¸£à¸±à¸š',0),(570267,15841,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤†à¤µà¥‡à¤¦à¤¨ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(570268,15841,'ms','Permohonan kredit yang diterima',0),(570269,15841,'ar','ØªØ·Ø¨ÙŠÙ‚ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„ÙˆØ§Ø±Ø¯Ø©',0),(570270,15841,'fr','Demande de crÃ©dit reÃ§ue',0),(570271,15841,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆç”³ã—è¾¼ã¿',0),(570272,15841,'pt','Pedido de crÃ©dito recebido',0),(570273,15841,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð°Ñ Ð·Ð°ÑÐ²ÐºÐ° Ð¿Ð¾Ð»ÑƒÑ‡Ð¸Ð»Ð°',0),(570274,15841,'es','Solicitud de crÃ©dito recibida',0),(570275,15841,'de','Kredit-Antrag erhalten',0),(570276,15841,'en','Credit Application Received',0),(570277,15842,'is','',0),(570278,15842,'dr','ØªØ§Ø±ÛŒØ® Ø§Ø¹ØªØ¨Ø§Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¯Ø± ÙØ§ÛŒÙ„',0),(570279,15842,'pr','ØªØ§Ø±ÛŒØ® Ø§Ø¹ØªØ¨Ø§Ø± Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø¯Ø± ÙØ§ÛŒÙ„',0),(570280,15842,'tr','Tarihi kredi baÅŸvurusu dosya',0),(570281,15842,'pl','Data wniosku kredytowego na plik',0),(570282,15842,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¸ÑÐºÐ°Ð½ÐµÑ‚Ð¾ Ð·Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(570283,15842,'ur','ØªØ§Ø±ÛŒØ® ÙˆØµÙˆÙ„ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙØ§Ø¦Ù„ Ù¾Ø±',0),(570284,15842,'sr','ÐÐ¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ Ð·Ð° Ð´Ð°Ñ‚ÑƒÐ¼ Ð½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÑ†Ð¸',0),(570285,15842,'vi','NgÃ y tÃ­n dá»¥ng á»©ng dá»¥ng trÃªn táº­p tin',0),(570286,15842,'af','Datum krediet aansoek op lÃªer',0),(570287,15842,'ro','Data cererea de Credit pe fiÅŸier',0),(570288,15842,'et','KuupÃ¤eva krediidi taotlus faili',0),(570289,15842,'si','Vloga za kredit datum na datoteko',0),(570290,15842,'ba','Tanggal aplikasi kredit pada File',0),(570291,15842,'nl','Datum kredietaanvraag op bestand',0),(570292,15842,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ luottohakemuksen tiedosto',0),(570293,15842,'no','Dato lÃ¥nesÃ¸knad pÃ¥ fil',0),(570294,15842,'da','Dato kreditansÃ¸gning pÃ¥ fil',0),(570295,15842,'ko','íŒŒì¼ ë‚ ì§œ ì‹ ìš© ì‘ìš© í”„ë¡œê·¸ëž¨',0),(570296,15842,'he','×ª××¨×™×š ×‘×§×©×” ×œ××©×¨××™ ×‘×ª×™×§',0),(570297,15842,'el','Î‘Î¯Ï„Î·ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¯ÏƒÏ„Ï‰ÏƒÎ·Ï‚ ÏƒÎµ Î±ÏÏ‡ÎµÎ¯Î¿',0),(570298,15842,'zh','åœ¨æ–‡ä»¶ä¸Šçš„æ—¥æœŸä¿¡ç”¨ç”³è¯·',0),(570299,15842,'sv','Datum kreditansÃ¶kan pÃ¥ fil',0),(570300,15842,'it','Data richiesta di credito su File',0),(570301,15842,'tl','',0),(570302,15842,'th','à¸ªà¸´à¸™à¸§à¸±à¸™à¸—à¸µà¹ˆà¹„à¸Ÿà¸¥à¹Œ',0),(570303,15842,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤— à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¤°',0),(570304,15842,'ms','Tarikh permohonan kredit dalam fail',0),(570305,15842,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† Ø§Ù„ØªØ·Ø¨ÙŠÙ‚ Ø¹Ù„Ù‰ Ù…Ù„Ù',0),(570306,15842,'fr','Date de demande de crÃ©dit au dossier',0),(570307,15842,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®æ—¥ä»˜ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³',0),(570308,15842,'pt','Pedido de crÃ©dito data no arquivo',0),(570309,15842,'ru','Ð”Ð°Ñ‚Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ Ð·Ð°ÑÐ²ÐºÐ¸ Ð½Ð° Ñ„Ð°Ð¹Ð»',0),(570310,15842,'es','Solicitud de crÃ©dito de fecha en el archivo',0),(570311,15842,'de','Datum-Kredit-Antrag auf Datei',0),(570312,15842,'en','Date Credit Application On File',0),(570313,15843,'is','',0),(570314,15843,'dr','ØªØ§Ø±ÛŒØ® Ù…Ø¹Ø§ÙÛŒØª Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ø¨Ø± Ø±ÙˆÛŒ ÙØ§ÛŒÙ„',0),(570315,15843,'pr','ØªØ§Ø±ÛŒØ® Ù…Ø¹Ø§ÙÛŒØª Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ø¨Ø± Ø±ÙˆÛŒ ÙØ§ÛŒÙ„',0),(570316,15843,'tr','Tarihi vergi muafiyeti dosya',0),(570317,15843,'pl','Data zwolnienia z podatku na plik',0),(570318,15843,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð¾ÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ð½Ðµ Ð¾Ñ‚ Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ñ„Ð°Ð¹Ð»',0),(570319,15843,'ur','ØªØ§Ø±ÛŒØ® Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡ Ù…Ø³Ù„ Ù¾Ø±',0),(570320,15843,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½Ð¾Ð³ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(570321,15843,'vi','NgÃ y miá»…n thuáº¿ trÃªn táº­p tin',0),(570322,15843,'af','Datum belasting vrystelling op lÃªer',0),(570323,15843,'ro','Data de scutire de impozit pe fiÅŸier',0),(570324,15843,'et','Faili kuupÃ¤ev maksuvabastus',0),(570325,15843,'si','Datum oprostitev davka na datoteke',0),(570326,15843,'ba','Pembebasan pajak tanggal pada File',0),(570327,15843,'nl','Datum belastingvrijstelling op bestand',0),(570328,15843,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ verovapautus tiedosto',0),(570329,15843,'no','Dato skattefritak pÃ¥ fil',0),(570330,15843,'da','Dato skattefrihed pÃ¥ fil',0),(570331,15843,'ko','íŒŒì¼ ë‚ ì§œ ì„¸ê¸ˆ ë©´ì œ',0),(570332,15843,'he','×ª××¨×™×š ×¤×˜×•×¨ ×ž×ž×¡ ×¢×œ ×§×•×‘×¥',0),(570333,15843,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï†Î¿ÏÎ¿Î±Ï€Î±Î»Î»Î±Î³Î® Î±Ï€ÏŒ Î±ÏÏ‡ÎµÎ¯Î¿',0),(570334,15843,'zh','æ–‡ä»¶æ—¥æœŸå…å¾è¥ä¸šç¨Ž',0),(570335,15843,'sv','Datum skattebefrielse pÃ¥ fil',0),(570336,15843,'it','Esenzione fiscale data sul File',0),(570337,15843,'tl','',0),(570338,15843,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸¢à¸à¹€à¸§à¹‰à¸™à¸ à¸²à¸©à¸µà¸šà¸™à¹à¸Ÿà¹‰à¸¡',0),(570339,15843,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤«à¤¼à¤¾à¤‡à¤² à¤ªà¤° à¤•à¤° à¤›à¥‚à¤Ÿ',0),(570340,15843,'ms','Tarikh pengecualian cukai ke atas fail',0),(570341,15843,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ø¹ÙØ§Ø¡ Ø§Ù„Ø¶Ø±ÙŠØ¨ÙŠ ÙÙŠ Ø§Ù„Ù…Ù„Ù',0),(570342,15843,'fr','Date de la dÃ©fiscalisation sur fichier',0),(570343,15843,'jp','ãƒ•ã‚¡ã‚¤ãƒ«æ—¥ä»˜ç¨Žã‚’å…é™¤',0),(570344,15843,'pt','IsenÃ§Ã£o de imposto de data no arquivo',0),(570345,15843,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ð”Ð°Ñ‚Ð° Ñ„Ð°Ð¹Ð»Ð°',0),(570346,15843,'es','ExenciÃ³n de impuestos de fecha en el archivo',0),(570347,15843,'de','Datum Steuerbefreiung auf Datei',0),(570348,15843,'en','Date Tax Exemption On File',0),(570349,15844,'is','',0),(570350,15844,'dr','ØªØ­ÙˆÛŒÙ„ ÙØ±ÙˆØ´ ØªÙ†Ù‡Ø§',0),(570351,15844,'pr','ØªØ­ÙˆÛŒÙ„ ÙØ±ÙˆØ´ ØªÙ†Ù‡Ø§',0),(570352,15844,'tr','Teslimat satÄ±ÅŸ sadece',0),(570353,15844,'pl','Dostawy sprzedaÅ¼y tylko',0),(570354,15844,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑÐ°Ð¼Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(570355,15844,'ur','ØµØ±Ù Ú©ÛŒ ØªØ±Ø³ÛŒÙ„ Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(570356,15844,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ ÑÐ°Ð¼Ð¾',0),(570357,15844,'vi','PhÃ¢n phá»‘i bÃ¡n hÃ ng chá»‰',0),(570358,15844,'af','Aflewering verkope slegs',0),(570359,15844,'ro','Livrare vÃ¢nzÄƒri numai',0),(570360,15844,'et','Tarne ainult mÃ¼Ã¼gi',0),(570361,15844,'si','Dostava prodaja samo',0),(570362,15844,'ba','Pengiriman hanya penjualan',0),(570363,15844,'nl','Levering verkoop alleen',0),(570364,15844,'fi','Toimitus myynti vain',0),(570365,15844,'no','Levering salg bare',0),(570366,15844,'da','Levering salg kun',0),(570367,15844,'ko','ë°°ë‹¬ íŒë§¤ë§Œ',0),(570368,15844,'he','×ž×©×œ×•×— ×ž×›×™×¨×•×ª ×‘×œ×‘×“',0),(570369,15844,'el','Î Î±ÏÎ¬Î´Î¿ÏƒÎ· Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î¼ÏŒÎ½Î¿',0),(570370,15844,'zh','åªæœ‰äº¤ä»˜é”€å”®',0),(570371,15844,'sv','Leverans fÃ¶rsÃ¤ljning endast',0),(570372,15844,'it','Consegna solo vendita',0),(570373,15844,'tl','',0),(570374,15844,'th','à¸‚à¸²à¸¢à¸ªà¹ˆà¸‡à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(570375,15844,'hi','à¤•à¥‡à¤µà¤² à¤¬à¤¿à¤•à¥à¤°à¥€ à¤µà¤¿à¤¤à¤°à¤£',0),(570376,15844,'ms','Penghantaran jualan sahaja',0),(570377,15844,'ar','ØªØ³Ù„ÙŠÙ… Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª ÙÙ‚Ø·',0),(570378,15844,'fr','Seules les ventes de livraison',0),(570379,15844,'jp','é…ä¿¡è²©å£²ã®ã¿',0),(570380,15844,'pt','Vendas de entrega somente',0),(570381,15844,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð¸ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð² Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(570382,15844,'es','Ventas de entrega solamente',0),(570383,15844,'de','Lieferung nur Verkauf',0),(570384,15844,'en','Delivery Sales Only',0),(570385,15845,'is','',0),(570386,15845,'dr','Ø§ØªÙ‡Ø§Ù… Ù…Ø¹Ø§Ù ØªØ­ÙˆÛŒÙ„',0),(570387,15845,'pr','Ø§ØªÙ‡Ø§Ù… Ù…Ø¹Ø§Ù ØªØ­ÙˆÛŒÙ„',0),(570388,15845,'tr','Muafiyet teslimat giderleri',0),(570389,15845,'pl','Koszt dostawy zwolnione',0),(570390,15845,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð´ÐµÐ½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ñ‚Ð°ÐºÑÐ°',0),(570391,15845,'ur','Ù…Ø³ØªØ«Ù†ÛŒ Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú†Ø§Ø±Ø¬',0),(570392,15845,'sr','ÐÐ•ÐžÐŸÐžÐ Ð•Ð—Ð˜Ð’Ð• Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(570393,15845,'vi','Giao hÃ ng táº­n nÆ¡i miá»…n phÃ­',0),(570394,15845,'af','Vrygestelde lewering las',0),(570395,15845,'ro','Taxa de livrare scutite',0),(570396,15845,'et','Maksuvaba kohaletoimetamise tasu',0),(570397,15845,'si','OproÅ¡Äene dobave brezplaÄno',0),(570398,15845,'ba','Biaya pengiriman dibebaskan',0),(570399,15845,'nl','Vrijgesteld leveringskosten',0),(570400,15845,'fi','Vapautettu toimitusmaksu',0),(570401,15845,'no','Unntatt leveringsgebyr',0),(570402,15845,'da','Undtaget leveringsomkostningerne',0),(570403,15845,'ko','ë©´ì œ ë°°ë‹¬ ìš”ê¸ˆ',0),(570404,15845,'he','×”×ž×©×œ×•×— ×¤×˜×•×¨',0),(570405,15845,'el','ÎˆÎ¾Î¿Î´Î± Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚ Î±Ï€Î±Î»Î»Î¬ÏƒÏƒÎ¿Î½Ï„Î±Î¹',0),(570406,15845,'zh','å…è¿è´¹',0),(570407,15845,'sv','Undanta leverans avgift',0),(570408,15845,'it','Carica di consegna esente',0),(570409,15845,'tl','',0),(570410,15845,'th','à¸„à¹ˆà¸²à¸‚à¸™à¸ªà¹ˆà¸‡à¸¢à¸à¹€à¸§à¹‰à¸™',0),(570411,15845,'hi','à¤®à¥à¤•à¥à¤¤ à¤µà¤¿à¤¤à¤°à¤£ à¤ªà¥à¤°à¤­à¤¾à¤°à¥€',0),(570412,15845,'ms','Caj penghantaran yang dikecualikan',0),(570413,15845,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„ØªØ³Ù„ÙŠÙ… ÙŠØ¹ÙÙŠ',0),(570414,15845,'fr','Frais de livraison exonÃ©rÃ©s',0),(570415,15845,'jp','å…é™¤ã®é…é€æ–™',0),(570416,15845,'pt','Taxa de entrega isenta',0),(570417,15845,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ñ‹ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ð·Ð°Ñ€ÑÐ´Ð°',0),(570418,15845,'es','Cargo por entrega exenta',0),(570419,15845,'de','Befreit ZustellgebÃ¼hr',0),(570420,15845,'en','Exempt Delivery Charge',0),(570421,15846,'is','',0),(570422,15846,'dr','Ø§ØªÙ‡Ø§Ù… Ù…Ø¹Ø§Ù Ø³ÙˆØ®Øª',0),(570423,15846,'pr','Ø§ØªÙ‡Ø§Ù… Ù…Ø¹Ø§Ù Ø³ÙˆØ®Øª',0),(570424,15846,'tr','Muafiyet yakÄ±t giderleri',0),(570425,15846,'pl','Zasyp paliwa zwolnione',0),(570426,15846,'bg','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°Ð²Ð°Ñ‚ Ð³Ð¾Ñ€Ð¸Ð²Ð½Ð° Ñ‚Ð°ÐºÑÐ°',0),(570427,15846,'ur','Ù…Ø³ØªØ«Ù†ÛŒ Ø§ÛŒÙ†Ø¯Ú¾Ù† Ú†Ø§Ø±Ø¬',0),(570428,15846,'sr','ÐŸÑƒÑšÐµÑšÐµ Ð³Ð¾Ñ€Ð¸Ð²Ð° Ð¸Ð·ÑƒÐ·ÐµÑ‚Ð¸',0),(570429,15846,'vi','NhiÃªn liá»‡u miá»…n phÃ­',0),(570430,15846,'af','Vrygestelde brandstof fooi',0),(570431,15846,'ro','Combustibil scutite de taxÄƒ',0),(570432,15846,'et','Maksuvaba kÃ¼tuse kulu',0),(570433,15846,'si','Dajatev oproÅ¡Äene goriva',0),(570434,15846,'ba','Biaya bahan bakar dibebaskan',0),(570435,15846,'nl','Vrijgesteld brandstof kosten',0),(570436,15846,'fi','Vapautettu polttoainemaksusta',0),(570437,15846,'no','Unntatt drivstoff kostnader',0),(570438,15846,'da','Undtaget brÃ¦ndstof afgift',0),(570439,15846,'ko','ë©´ì œ ì—°ë£Œ ì¶©ì „',0),(570440,15846,'he','×ª×©×œ×•× ×“×œ×§ ×¤×˜×•×¨',0),(570441,15846,'el','Î§ÏÎ­Ï‰ÏƒÎ· ÎºÎ±Ï…ÏƒÎ¯Î¼Ï‰Î½ Î±Ï€Î±Î»Î»Î¬ÏƒÏƒÎ¿Î½Ï„Î±Î¹',0),(570442,15846,'zh','è±å…ç‡ƒæ²¹è´¹',0),(570443,15846,'sv','Undanta brÃ¤nsle kostnad',0),(570444,15846,'it','Carica di combustibile esente',0),(570445,15846,'tl','',0),(570446,15846,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸™à¹‰à¸³à¸¡à¸±à¸™à¹€à¸Šà¸·à¹‰à¸­à¹€à¸žà¸¥à¸´à¸‡à¸¢à¸à¹€à¸§à¹‰à¸™',0),(570447,15846,'hi','à¤›à¥‚à¤Ÿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤ˆà¤‚à¤§à¤¨ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(570448,15846,'ms','Caj bahan api yang dikecualikan',0),(570449,15846,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„ÙˆÙ‚ÙˆØ¯ Ø¥Ø¹ÙØ§Ø¡',0),(570450,15846,'fr','Frais de carburant exonÃ©rÃ©',0),(570451,15846,'jp','é™¤å¤–ç‡ƒæ–™ãƒãƒ£ãƒ¼ã‚¸',0),(570452,15846,'pt','Carga de combustÃ­vel isento',0),(570453,15846,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ñ‹ Ñ‚Ð¾Ð¿Ð»Ð¸Ð²Ð½Ð¾Ð³Ð¾ Ð·Ð°Ñ€ÑÐ´Ð°',0),(570454,15846,'es','Carga de combustible exento',0),(570455,15846,'de','Befreit Brennstoff-GebÃ¼hr',0),(570456,15846,'en','Exempt Fuel Charge',0),(570457,15847,'is','',0),(570458,15847,'dr','ØªØ§ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡',0),(570459,15847,'pr','ØªØ§ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡',0),(570460,15847,'tr','DoÄŸrulanmadÄ±',0),(570461,15847,'pl','Nie sprawdzonych',0),(570462,15847,'bg','ÐÐµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¸',0),(570463,15847,'ur','ØªÙˆØ«ÛŒÙ‚ Ù†ÛÛŒÚº Ú©ÛŒÛ’ Ú¯Ø¦Û’',0),(570464,15847,'sr','ÐÐ¸Ñ˜Ðµ Ð¿Ð¾Ñ‚Ð²Ñ€Ñ’ÐµÐ½Ð¾',0),(570465,15847,'vi','KhÃ´ng xÃ¡c minh',0),(570466,15847,'af','Nie geverifieer',0),(570467,15847,'ro','Nu sunt verificate',0),(570468,15847,'et','Kinnitamata',0),(570469,15847,'si','Ni preverjeno',0),(570470,15847,'ba','Tidak terverifikasi',0),(570471,15847,'nl','Niet geverifieerd',0),(570472,15847,'fi','Ei vahvistettu',0),(570473,15847,'no','Ikke bekreftet',0),(570474,15847,'da','Ikke verificeret',0),(570475,15847,'ko','í™•ì¸ ë˜ì§€ ì•Šì€',0),(570476,15847,'he','×œ× ××•×ž×ª×”',0),(570477,15847,'el','Î§Ï‰ÏÎ¯Ï‚ ÎµÏ€Î±Î»Î®Î¸ÎµÏ…ÏƒÎ·',0),(570478,15847,'zh','æœªéªŒè¯',0),(570479,15847,'sv','Inte verifierats',0),(570480,15847,'it','Non verificato',0),(570481,15847,'tl','',0),(570482,15847,'th','à¹„à¸¡à¹ˆà¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(570483,15847,'hi','à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¿à¤¤ à¤¨à¤¹à¥€à¤‚',0),(570484,15847,'ms','Tidak disahkan',0),(570485,15847,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„ØªØ­Ù‚Ù‚',0),(570486,15847,'fr','Non vÃ©rifiÃ©',0),(570487,15847,'jp','ç¢ºèªã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(570488,15847,'pt','NÃ£o verificado',0),(570489,15847,'ru','ÐÐµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¾',0),(570490,15847,'es','No verificado',0),(570491,15847,'de','Nicht Ã¼berprÃ¼ft',0),(570492,15847,'en','Not Verified',0),(570493,15848,'is','',0),(570494,15848,'dr','Ø§Ø¨Ø²Ø§Ø±ÛŒ Ø¨Ø±Ø§ÛŒ ØªØ§ÛŒÛŒØ¯ Ú©Ø§Ø± Ø­Ø³Ø§Ø¨',0),(570495,15848,'pr','Ø§Ø¨Ø²Ø§Ø±ÛŒ Ø¨Ø±Ø§ÛŒ ØªØ§ÛŒÛŒØ¯ Ú©Ø§Ø± Ø­Ø³Ø§Ø¨',0),(570496,15848,'tr','Tamam araÃ§larÄ± iÅŸ hesaplarÄ±',0),(570497,15848,'pl','OK narzÄ™dzia pracy kont',0),(570498,15848,'bg','ÐžÐš Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð¿Ð¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(570499,15848,'ur','Ú©Ø§Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù¾Ø± Ù¹Ú¾ÛŒÚ© ÛÛ’ Ù¹ÙˆÙ„',0),(570500,15848,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ð°Ð»Ð°Ñ‚ÐºÐµ Ð½Ð° Ð¿Ð¾ÑÐ°Ð¾ Ð½Ð°Ð»Ð¾Ð·Ð¸',0),(570501,15848,'vi','CÃ¡c cÃ´ng cá»¥ OK trÃªn tÃ i khoáº£n cÃ´ng viá»‡c',0),(570502,15848,'af','OK gereedskap op werk rekeninge',0),(570503,15848,'ro','Instrumente OK pe conturile de Job',0),(570504,15848,'et','OK tÃ¶Ã¶ kontode tÃ¶Ã¶riistad',0),(570505,15848,'si','OK orodja na raÄunov poslov',0),(570506,15848,'ba','Alat-alat yang OK di account pekerjaan',0),(570507,15848,'nl','OK Tools over de rekeningen van de baan',0),(570508,15848,'fi','OK-tyÃ¶kalut Projektitilit',0),(570509,15848,'no','OK verktÃ¸yene pÃ¥ jobbkontoer',0),(570510,15848,'da','OK vÃ¦rktÃ¸jer pÃ¥ Job regnskab',0),(570511,15848,'ko','ìž‘ì—… ê³„ì •ì— í™•ì¸ ë„êµ¬',0),(570512,15848,'he','×›×œ×™ ×˜×•×‘ ×¢×œ ×—×©×‘×•× ×•×ª ×ž×©×™×ž×”',0),(570513,15848,'el','Î•Î½Ï„Î¬Î¾ÎµÎ¹ ÎµÏÎ³Î±Î»ÎµÎ¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(570514,15848,'zh','å¥½å·¥å…·ä¸Šä½œä¸šå¸æˆ·',0),(570515,15848,'sv','OK verktyg pÃ¥ jobbet konton',0),(570516,15848,'it','OK strumenti sui conti di lavoro',0),(570517,15848,'tl','',0),(570518,15848,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­ OK à¹ƒà¸™à¸‡à¸²à¸™à¸šà¸±à¸à¸Šà¸µ',0),(570519,15848,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤–à¤¾à¤¤à¥‹à¤‚ à¤ªà¤° à¤ à¥€à¤• à¤‰à¤ªà¤•à¤°à¤£',0),(570520,15848,'ms','OK alat kerja akaun',0),(570521,15848,'ar','Ø£Ø¯ÙˆØ§Øª Ù…ÙˆØ§ÙÙ‚ Ø¹Ù„Ù‰ Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(570522,15848,'fr','Outils OK sur les comptes de lâ€™emploi',0),(570523,15848,'jp','ã‚¸ãƒ§ãƒ–ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã® [ok] ãƒ„ãƒ¼ãƒ«',0),(570524,15848,'pt','Okey ferramentas nas contas de trabalho',0),(570525,15848,'ru','ÐžÐš ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð° Ð½Ð° ÑÑ‡ÐµÑ‚Ð°Ñ… Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(570526,15848,'es','Herramientas trabajo cuentas OK',0),(570527,15848,'de','OK-Tools auf Job-Konten',0),(570528,15848,'en','OK Tools On Job Accounts',0),(570529,15849,'is','',0),(570530,15849,'dr','Ø®ÙˆØ¨ Ø¨Ù‡ Ú©Ø´ØªÛŒ Ø§Ú¯Ø± Ù†Ø§Ù‚Øµ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´ØºÙ„ÛŒ',0),(570531,15849,'pr','Ø®ÙˆØ¨ Ø¨Ù‡ Ú©Ø´ØªÛŒ Ø§Ú¯Ø± Ù†Ø§Ù‚Øµ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´ØºÙ„ÛŒ',0),(570532,15849,'tr','EÄŸer eksik gemiye Tamam iÅŸ bilgisi',0),(570533,15849,'pl','OK do statku, jeÅ›li niedokoÅ„czona praca Info',0),(570534,15849,'bg','ÐžÐš Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ, Ð°ÐºÐ¾ Ð½ÐµÐ¿ÑŠÐ»Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(570535,15849,'ur','Ù¹Ú¾ÙŠÚ© ÛÛ’ Ø¬ÛØ§Ø² Ú©Ùˆ Ø§Ú¯Ø± Ù†Ø§Ù…Ú©Ù…Ù„ ÛÙˆ ØªÙˆ Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(570536,15849,'sr','ÐžÐš Ð±Ñ€Ð¾Ð´ Ð°ÐºÐ¾ Ð½ÐµÐ¿Ð¾Ñ‚Ð¿ÑƒÐ½Ð° Ð¿Ð¾ÑÐ°Ð¾ Ð˜Ð½Ñ„Ð¾',0),(570537,15849,'vi','OK Ä‘á»ƒ tÃ u náº¿u khÃ´ng Ä‘áº§y Ä‘á»§ thÃ´ng tin viá»‡c lÃ m',0),(570538,15849,'af','OK om skip as onvolledige inligting werk',0),(570539,15849,'ro','OK pentru a navei, dacÄƒ incomplet Info de locuri de muncÄƒ',0),(570540,15849,'et','OK laeva kui puudulik tÃ¶Ã¶ Info',0),(570541,15849,'si','OK, da ladje, Äe je nepopolna delo Info',0),(570542,15849,'ba','OK untuk kapal tidak lengkap pekerjaan Info',0),(570543,15849,'nl','O.k. aan schip als onvolledig baan Info',0),(570544,15849,'fi','OK aluksen, jos keskenerÃ¤inen tyÃ¶ Info',0),(570545,15849,'no','OK Ã¥ skip hvis ufullstendig jobb Info',0),(570546,15849,'da','OK til skibet, hvis ufuldstÃ¦ndige Job Info',0),(570547,15849,'ko','ë¶ˆì™„ì „ í•œ ê²½ìš° ì„ ë°•ì„ ì¢‹ì•„ ì§ì—… ì •ë³´',0),(570548,15849,'he','××•×§×™×™ ×œ×¡×¤×™× ×ª ×× ×œ× ×”×•×©×œ×ž×” ×¢×‘×•×“×” ×¤×¨×˜×™',0),(570549,15849,'el','Î•Î½Ï„Î¬Î¾ÎµÎ¹ Î½Î± Ï€Î»Î¿Î¯Î¿ Î±Î½ ÎµÎ»Î»Î¹Ï€Î®Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(570550,15849,'zh','å¥½èˆ¹ï¼Œå¦‚æžœä¸å®Œæ•´ï¼Œå·¥ä½œä¿¡æ¯',0),(570551,15849,'sv','OK att fartyget om ofullstÃ¤ndiga jobb information',0),(570552,15849,'it','OK alla nave se incompleto lavoro Info',0),(570553,15849,'tl','',0),(570554,15849,'th','à¸•à¸à¸¥à¸‡à¸ˆà¸°à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸–à¹‰à¸²à¹„à¸¡à¹ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œà¸‡à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(570555,15849,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ à¥€à¤• à¤¹à¥ˆ à¤¯à¤¦à¤¿ à¤…à¤ªà¥‚à¤°à¥à¤£ à¤•à¤¾à¤°à¥à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(570556,15849,'ms','OK ke kapal jika tidak lengkap kerja maklumat',0),(570557,15849,'ar','Ù…ÙˆØ§ÙÙ‚ Ù„Ù„Ø³ÙÙŠÙ†Ø© ÙÙŠ Ø­Ø§Ù„Ø© Ø¹Ø¯Ù… Ø§ÙƒØªÙ…Ø§Ù„ ÙˆØ¸ÙŠÙØ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(570558,15849,'fr','OK pour navire si incomplÃ¨te Job Info',0),(570559,15849,'jp','ä¸å®Œå…¨ãªå ´åˆã€èˆ¹ã« [ok] ä»•äº‹æƒ…å ±',0),(570560,15849,'pt','Okey, a nave se incompleta informaÃ§Ã£o de emprego',0),(570561,15849,'ru','OK Ðº ÑÑƒÐ´Ð½Ñƒ, ÐµÑÐ»Ð¸ Ð½ÐµÐ¿Ð¾Ð»Ð½Ð¾Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð˜Ð½Ñ„Ð¾',0),(570562,15849,'es','OK a la nave si incompleta informaciÃ³n de empleo',0),(570563,15849,'de','OK, Schiff, wenn unvollstÃ¤ndige Arbeit Info',0),(570564,15849,'en','OK To Ship If Incomplete Job Info',0),(570565,15850,'is','',0),(570566,15850,'dr','Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø±',0),(570567,15850,'pr','Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø±',0),(570568,15850,'tr','Beklemede',0),(570569,15850,'pl','Zawieszone',0),(570570,15850,'bg','Ð—Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ð°',0),(570571,15850,'ur','ÛÙˆÙ„Úˆ Ù¾Ø±',0),(570572,15850,'sr','ÐÐ° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(570573,15850,'vi','Giá»¯ láº¡i',0),(570574,15850,'af','Op hou',0),(570575,15850,'ro','Pe \"hold\"',0),(570576,15850,'et','Ootel',0),(570577,15850,'si','Na Äakanju',0),(570578,15850,'ba','Ditahan',0),(570579,15850,'nl','In de wachtstand',0),(570580,15850,'fi','Pidossa',0),(570581,15850,'no','PÃ¥ vent',0),(570582,15850,'da','PÃ¥ Hold',0),(570583,15850,'ko','ë³´ë¥˜',0),(570584,15850,'he','×‘×”×ž×ª× ×”',0),(570585,15850,'el','Î£Îµ Î±Î½Î±Î¼Î¿Î½Î®',0),(570586,15850,'zh','æç½®',0),(570587,15850,'sv','PÃ¥ is',0),(570588,15850,'it','In attesa',0),(570589,15850,'tl','',0),(570590,15850,'th','à¸„à¸‡à¸„à¹‰à¸²à¸‡',0),(570591,15850,'hi','à¤¹à¥‹à¤²à¥à¤¡ à¤ªà¤°',0),(570592,15850,'ms','Penahanan',0),(570593,15850,'ar','Ù…Ø¹Ù„Ù‚Ø©',0),(570594,15850,'fr','En attente',0),(570595,15850,'jp','ãƒ›ãƒ¼ãƒ«ãƒ‰ã‚ªãƒ³',0),(570596,15850,'pt','Em espera',0),(570597,15850,'ru','ÐÐ° ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ð¸',0),(570598,15850,'es','En espera',0),(570599,15850,'de','Auf Eis',0),(570600,15850,'en','On Hold',0),(570601,15851,'is','',0),(570602,15851,'dr','ÙØ±ÙˆØ´ Ú©Ø§Ø± prelim',0),(570603,15851,'pr','ÙØ±ÙˆØ´ Ú©Ø§Ø± prelim',0),(570604,15851,'tr','Prelim iÅŸ satÄ±ÅŸ',0),(570605,15851,'pl','Prelim sprzedaÅ¼y zleceÅ„',0),(570606,15851,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(570607,15851,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(570608,15851,'sr','Ð£Ð²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°',0),(570609,15851,'vi','Prelim cÃ´ng viá»‡c bÃ¡n hÃ ng',0),(570610,15851,'af','Prelim werk verkope',0),(570611,15851,'ro','VÃ¢nzÄƒri de Job preliminare',0),(570612,15851,'et','Esialgne ProjektimÃ¼Ã¼gi',0),(570613,15851,'si','Predhodnega projektne prodaje',0),(570614,15851,'ba','Prelim pekerjaan penjualan',0),(570615,15851,'nl','Kwalificatie projectomzet',0),(570616,15851,'fi','Alustava myynneistÃ¤',0),(570617,15851,'no','Prelim prosjektsalg',0),(570618,15851,'da','Prelim sagssalg',0),(570619,15851,'ko','ì˜ˆì„  ìž‘ì—… íŒë§¤',0),(570620,15851,'he','×ž×›×™×¨×•×ª ××ª ×”×¢×‘×•×“×” ×ž×•×§×“×',0),(570621,15851,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î­ÏÎ³Î¿Ï…',0),(570622,15851,'zh','åˆè¯•å·¥ä½œé”€å”®',0),(570623,15851,'sv','PreliminÃ¤rt projektfÃ¶rsÃ¤ljning',0),(570624,15851,'it','Prelim lavoro vendite',0),(570625,15851,'tl','',0),(570626,15851,'th','à¸‚à¸²à¸¢à¸‡à¸²à¸™ prelim',0),(570627,15851,'hi','Prelim à¤¨à¥Œà¤•à¤°à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(570628,15851,'ms','Prelim kerja jualan',0),(570629,15851,'ar','Prelim ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(570630,15851,'fr','Prelim emploi ventes',0),(570631,15851,'jp','äºˆå‚™ä»•äº‹è²©å£²',0),(570632,15851,'pt','Vendas de trabalho preliminar',0),(570633,15851,'ru','Prelim Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(570634,15851,'es','Prelim trabajo ventas',0),(570635,15851,'de','Vorrunde ProjektverkÃ¤ufe',0),(570636,15851,'en','Prelim Job Sales',0),(570637,15852,'is','',0),(570638,15852,'dr','Ù†Ù…Ø§ÛŒØ´ Ù‚ÛŒÙ…Øª Ø¯Ø± ØªØ­ÙˆÛŒÙ„ ØªØ§ÛŒÛŒØ¯',0),(570639,15852,'pr','Ù†Ù…Ø§ÛŒØ´ Ù‚ÛŒÙ…Øª Ø¯Ø± ØªØ­ÙˆÛŒÙ„ ØªØ§ÛŒÛŒØ¯',0),(570640,15852,'tr','Teslimat OnayÄ± Ã¼zerinde fiyatlarÄ± gÃ¶ster',0),(570641,15852,'pl','PokaÅ¼ ceny na potwierdzenie dostawy',0),(570642,15852,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ñ†ÐµÐ½Ð¸ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ð¾Ñ‚Ð²ÑŠÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(570643,15852,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ù…ÛŒÚº Ø­ÙˆØ§Ù„Ú¯ÛŒ Ú©ÛŒ ØªÙˆØ«ÛŒÙ‚ Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(570644,15852,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ†ÐµÐ½Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð°',0),(570645,15852,'vi','Hiá»ƒn thá»‹ giÃ¡ trÃªn xÃ¡c nháº­n giao hÃ ng',0),(570646,15852,'af','Skou pryse op leweringsbewys',0),(570647,15852,'ro','AratÄƒ preÅ£uri confirmarea de livrare',0),(570648,15852,'et','NÃ¤ita hindu kohaletoimetamise kinnituse',0),(570649,15852,'si','ÄŒistoÄa na dostava potrditev',0),(570650,15852,'ba','Tampilkan harga di konfirmasi pengiriman',0),(570651,15852,'nl','Toon prijzen op ontvangstbevestiging',0),(570652,15852,'fi','NÃ¤ytÃ¤ hinnat toimituksen vahvistus',0),(570653,15852,'no','Vis priser pÃ¥ leveringsbekreftelse',0),(570654,15852,'da','Vis priser pÃ¥ levering bekrÃ¦ftelse',0),(570655,15852,'ko','ë°°ë‹¬ í™•ì¸ì— í‘œì‹œ ê°€ê²©',0),(570656,15852,'he','×”×¦×’ ×ž×—×™×¨×™× ×¢×œ ××™×©×•×¨ ×”×ž×¡×™×¨×”',0),(570657,15852,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î¹Î¼ÏŽÎ½ ÏƒÏ„Î·Î½ ÎµÏ€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(570658,15852,'zh','åœ¨å‘è´§ç¡®è®¤ä¸Šæ˜¾ç¤ºä»·æ ¼',0),(570659,15852,'sv','Visa priser pÃ¥ leveransbekrÃ¤ftelse',0),(570660,15852,'it','Visualizza i prezzi sulla conferma di consegna',0),(570661,15852,'tl','',0),(570662,15852,'th','à¸£à¸²à¸„à¸²à¹à¸ªà¸”à¸‡à¸¢à¸·à¸™à¸¢à¸±à¸™à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(570663,15852,'hi','à¤•à¥€à¤®à¤¤à¥‹à¤‚ à¤ªà¤° à¤¡à¤¿à¤²à¤¿à¤µà¤°à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(570664,15852,'ms','Tunjuk harga pengesahan penghantaran',0),(570665,15852,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø¹Ù„Ù‰ ØªØ£ÙƒÙŠØ¯ Ø§Ù„ØªØ³Ù„ÙŠÙ…',0),(570666,15852,'fr','Indiquer les prix sur la Confirmation de livraison',0),(570667,15852,'jp','é…ä¿¡ç¢ºèªã®è¡¨ç¤ºä¾¡æ ¼',0),(570668,15852,'pt','Mostrar preÃ§os na confirmaÃ§Ã£o de entrega',0),(570669,15852,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ†ÐµÐ½Ñ‹ Ð½Ð° Ð¿Ð¾Ð´Ñ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(570670,15852,'es','Mostrar precios en confirmaciÃ³n de la entrega',0),(570671,15852,'de','Preise auf der LieferbestÃ¤tigung anzeigen',0),(570672,15852,'en','Show Prices On Delivery Confirmation',0),(570673,15853,'is','',0),(570674,15853,'dr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù†Ø±Ø® Ù…Ø°Ø§Ú©Ø±Ù‡',0),(570675,15853,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ù†Ø±Ø® Ù…Ø°Ø§Ú©Ø±Ù‡',0),(570676,15853,'tr','KullanÄ±m oranlarÄ± mÃ¼zakere',0),(570677,15853,'pl','Wykorzystania wynegocjowanych stawek',0),(570678,15853,'bg','Ð˜Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ð¹Ñ‚Ðµ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ñ‚Ð°Ñ€Ð¸Ñ„Ð¸',0),(570679,15853,'ur','Ù…Ø°Ø§Ú©Ø±Ø§ØªÛŒ Ø´Ø±Ø­ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(570680,15853,'sr','ÐšÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ ÑÐ¿Ð¾Ñ€Ð°Ð·ÑƒÐ¼Ð½Ð¾ ÑÑ‚Ð¾Ð¿Ðµ',0),(570681,15853,'vi','Sá»­ dá»¥ng tá»· giÃ¡ thÆ°Æ¡ng lÆ°á»£ng',0),(570682,15853,'af','Gebruik onderhandelde tariewe',0),(570683,15853,'ro','UtilizaÅ£i tarife negociate',0),(570684,15853,'et','Kasutada lÃ¤birÃ¤Ã¤kimistega mÃ¤Ã¤rad',0),(570685,15853,'si','Uporabite s pogajanji stopnje',0),(570686,15853,'ba','Menggunakan TARIF kontraktual',0),(570687,15853,'nl','Gebruik van onderhandelde tarieven',0),(570688,15853,'fi','KÃ¤ytÃ¤ neuvoteltuja hintoja',0),(570689,15853,'no','Bruke forhandlede priser',0),(570690,15853,'da','Brug forhandlet priser',0),(570691,15853,'ko','í˜‘ìƒëœ ìš”ê¸ˆì„ ì‚¬ìš© í•˜ ì—¬',0),(570692,15853,'he','×œ×”×©×ª×ž×© ×‘×ª×¢×¨×™×¤×™ ×ž×©× ×•×ž×ª×Ÿ',0),(570693,15853,'el','Î§ÏÎ®ÏƒÎ· ÎµÏ†Î±ÏÎ¼Î¿Î³Î®Ï‚ Ï„Î¹Î¼ÏŽÎ½ Î²Î¬ÏƒÎµÎ¹ Î´Î¹Î±Ï€ÏÎ±Î³Î¼Î¬Ï„ÎµÏ…ÏƒÎ·Ï‚',0),(570694,15853,'zh','ä½¿ç”¨åè®®çš„ä»·',0),(570695,15853,'sv','AnvÃ¤nda fÃ¶rhandlade priser',0),(570696,15853,'it','Utilizzare tariffe negoziate',0),(570697,15853,'tl','',0),(570698,15853,'th','à¹ƒà¸Šà¹‰à¹€à¸ˆà¸£à¸ˆà¸²à¸•à¹ˆà¸­à¸£à¸­à¸‡à¸£à¸²à¸„à¸²',0),(570699,15853,'hi','à¤¬à¤¾à¤¤à¤šà¥€à¤¤ à¤¦à¤° à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(570700,15853,'ms','Menggunakan kadar yang dirunding',0),(570701,15853,'ar','Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø£Ø³Ø¹Ø§Ø± Ù…ØªÙØ§ÙˆØ¶ Ø¹Ù„ÙŠÙ‡Ø§',0),(570702,15853,'fr','Utilisation de tarifs nÃ©gociÃ©s',0),(570703,15853,'jp','ä½¿ç”¨æ–™é‡‘',0),(570704,15853,'pt','Usar tarifas negociadas',0),(570705,15853,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·ÑƒÐ¹Ñ‚Ðµ Ñ‚Ð°Ñ€Ð¸Ñ„Ð°Ð¼',0),(570706,15853,'es','Uso de tarifas negociadas',0),(570707,15853,'de','Verwenden Sie ausgehandelten Tarife',0),(570708,15853,'en','Use Negotiated Rates',0),(570709,15854,'is','',0),(570710,15854,'dr','ØªØ§ÛŒÛŒØ¯',0),(570711,15854,'pr','ØªØ§ÛŒÛŒØ¯',0),(570712,15854,'tr','DoÄŸrulanmadÄ±',0),(570713,15854,'pl','Zweryfikowane',0),(570714,15854,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¸',0),(570715,15854,'ur','ØªØµØ¯ÛŒÙ‚ Ø´Ø¯Û',0),(570716,15854,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸',0),(570717,15854,'vi','XÃ¡c minh',0),(570718,15854,'af','Geverifieer',0),(570719,15854,'ro','Verificate',0),(570720,15854,'et','Kontrollis',0),(570721,15854,'si','Preveriti',0),(570722,15854,'ba','Diverifikasi',0),(570723,15854,'nl','Geverifieerd',0),(570724,15854,'fi','Tarkistaa',0),(570725,15854,'no','Bekreftet',0),(570726,15854,'da','Verificeret',0),(570727,15854,'ko','í™•ì¸',0),(570728,15854,'he','××•×ž×ª',0),(570729,15854,'el','Î•Ï€Î±Î»Î·Î¸ÎµÏÎµÏ„Î±Î¹',0),(570730,15854,'zh','éªŒè¯',0),(570731,15854,'sv','Verifierat',0),(570732,15854,'it','Verificato',0),(570733,15854,'tl','',0),(570734,15854,'th','à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(570735,15854,'hi','à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¿à¤¤',0),(570736,15854,'ms','Disahkan',0),(570737,15854,'ar','Ø§Ù„ØªØ­Ù‚Ù‚',0),(570738,15854,'fr','VÃ©rifiÃ©',0),(570739,15854,'jp','æ¤œè¨¼',0),(570740,15854,'pt','Verificado',0),(570741,15854,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¾',0),(570742,15854,'es','Verificado',0),(570743,15854,'de','ÃœberprÃ¼ft',0),(570744,15854,'en','Verified',0),(570745,15855,'is','',0),(570746,15855,'dr','Ù…Ø¬Ù„Ù‡ ÙˆØ±ÙˆØ¯ Ø§Ø³Ù†Ø§Ø¯',0),(570747,15855,'pr','Ù…Ø¬Ù„Ù‡ ÙˆØ±ÙˆØ¯ Ø§Ø³Ù†Ø§Ø¯',0),(570748,15855,'tr','GÃ¼nlÃ¼k giriÅŸ belgeleri',0),(570749,15855,'pl','Dziennik dokumentÃ³w',0),(570750,15855,'bg','Ð”Ð½ÐµÐ²Ð½Ð¸Ðº Ð²Ñ…Ð¾Ð´Ð½Ð¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¸',0),(570751,15855,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø¯Ø³ØªØ§ÙˆÛŒØ²Ø§Øª',0),(570752,15855,'sr','Ð”Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ðµ Ð·Ð° ÑƒÐ½Ð¾Ñ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(570753,15855,'vi','Táº¡p chÃ­ má»¥c tÃ i liá»‡u',0),(570754,15855,'af','Joernaal inskrywing dokumente',0),(570755,15855,'ro','Documente de intrare jurnal',0),(570756,15855,'et','TÃ¶Ã¶lehe kanne dokumendid',0),(570757,15855,'si','Listu vhodnih dokumentov',0),(570758,15855,'ba','Dokumen entri jurnal',0),(570759,15855,'nl','Journal item documenten',0),(570760,15855,'fi','MerkintÃ¤ pÃ¤ivÃ¤kirjamerkinnÃ¤t',0),(570761,15855,'no','OppfÃ¸ringen loggdokumenter',0),(570762,15855,'da','Journal Entry dokumenter',0),(570763,15855,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª© ë¬¸ì„œ',0),(570764,15855,'he','×›×ª×‘ ×”×¢×ª ×¢×¨×š ×”×ž×¡×ž×›×™×',0),(570765,15855,'el','ÎˆÎ³Î³ÏÎ±Ï†Î± ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… ÎµÏ†Î·Î¼ÎµÏÎ¯Î´Î±',0),(570766,15855,'zh','æ—¥è®°æ¡ç›®æ–‡æ¡£',0),(570767,15855,'sv','Journal post dokument',0),(570768,15855,'it','Documenti di registrazione della Gazzetta',0),(570769,15855,'tl','',0),(570770,15855,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™',0),(570771,15855,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤¸à¥à¤¤à¤¾à¤µà¥‡à¤œà¤¼',0),(570772,15855,'ms','Dokumen-dokumen kemasukan jurnal',0),(570773,15855,'ar','ÙˆØ«Ø§Ø¦Ù‚ Ø¥Ø¯Ø®Ø§Ù„ Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(570774,15855,'fr','Documents dâ€™entrÃ©e de journal',0),(570775,15855,'jp','ä»•è¨³å¸³ã‚¨ãƒ³ãƒˆãƒªã®æ›¸é¡ž',0),(570776,15855,'pt','Documentos de entrada de diÃ¡rio',0),(570777,15855,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð´Ð¾ÐºÑƒÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(570778,15855,'es','Documentos de entrada de diario',0),(570779,15855,'de','Tagebuch Eintrag Dokumente',0),(570780,15855,'en','Journal Entry Documents',0),(570781,15856,'is','',0),(570782,15856,'dr','ÙØ§Ú©ØªÙˆØ± Ø³Ø±Ø¨Ø±Ú¯ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ù‡ Ø±ÙˆØ² Ú©Ù†Ø¯',0),(570783,15856,'pr','ÙØ§Ú©ØªÙˆØ± Ø³Ø±Ø¨Ø±Ú¯ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ù‡ Ø±ÙˆØ² Ú©Ù†Ø¯',0),(570784,15856,'tr','Fatura Ã¼stbilgi bilgisi gÃ¼ncelleÅŸtirilemiyor',0),(570785,15856,'pl','Nie moÅ¼na zaktualizowaÄ‡ informacji nagÅ‚Ã³wka faktury',0),(570786,15856,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð³Ð¾Ñ€ÐµÐ½ ÐºÐ¾Ð»Ð¾Ð½Ñ‚Ð¸Ñ‚ÑƒÐ» Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(570787,15856,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø³Ø±ØªØ­Ø±ÛŒØ± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(570788,15856,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾ Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(570789,15856,'vi','KhÃ´ng thá»ƒ Cáº­p Nháº­t hÃ³a Ä‘Æ¡n tiÃªu Ä‘á» thÃ´ng tin',0),(570790,15856,'af','Faktuur kopskrif inligting bywerk nie',0),(570791,15856,'ro','Nu se poate actualiza informaÅ£ii de antet facturÄƒ',0),(570792,15856,'et','Ei saa vÃ¤rskendada arve pÃ¤ise Info',0),(570793,15856,'si','Ne more posodobiti informacije o glave raÄuna',0),(570794,15856,'ba','Tidak dapat memperbarui faktur Header Info',0),(570795,15856,'nl','Factuur Header Info bijwerken niet',0),(570796,15856,'fi','Ei voi pÃ¤ivittÃ¤Ã¤ laskun otsikon tiedot',0),(570797,15856,'no','Kan ikke oppdatere faktura filhodet Info',0),(570798,15856,'da','Kan ikke opdatere fakturaen Header Info',0),(570799,15856,'ko','êµ¬ë§¤ì„œ í—¤ë” ì •ë³´ë¥¼ ì—…ë°ì´íŠ¸í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(570800,15856,'he','×œ× × ×™×ª×Ÿ ×œ×¢×“×›×Ÿ ×¤×¨×˜×™ ×›×•×ª×¨×ª ×—×©×‘×•× ×™×ª',0),(570801,15856,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÎ¹ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎºÎµÏ†Î±Î»Î¯Î´Î±Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(570802,15856,'zh','æ— æ³•æ›´æ–°å‘ç¥¨æ ‡é¢˜ä¿¡æ¯',0),(570803,15856,'sv','Kan inte uppdatera fakturan Header information',0),(570804,15856,'it','Non Ã¨ possibile aggiornare le informazioni di intestazione fattura',0),(570805,15856,'tl','',0),(570806,15856,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¹ˆà¸§à¸™à¸«à¸±à¸§à¸‚à¸­à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(570807,15856,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¶à¥€à¤°à¥à¤· à¤²à¥‡à¤– à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(570808,15856,'ms','Tidak dapat mengemaskini maklumat pengepala invois',0),(570809,15856,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­Ø¯ÙŠØ« Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø±Ø£Ø³ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(570810,15856,'fr','Ne peut pas mettre Ã  jour les informations dâ€™en-tÃªte de facture',0),(570811,15856,'jp','è«‹æ±‚æ›¸ãƒ˜ãƒƒãƒ€ãƒ¼æƒ…å ±ã‚’æ›´æ–°ã§ãã¾ã›ã‚“ã€‚',0),(570812,15856,'pt','NÃ£o Ã© possÃ­vel atualizar informaÃ§Ãµes de cabeÃ§alho de factura',0),(570813,15856,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²ÐºÐ° ÑÑ‡ÐµÑ‚Ð°',0),(570814,15856,'es','No se puede actualizar la informaciÃ³n de encabezado de la factura',0),(570815,15856,'de','Rechnung-Header-Informationen kÃ¶nnen nicht aktualisiert werden.',0),(570816,15856,'en','Cannot Update Invoice Header Info',0),(570817,15857,'is','',0),(570818,15857,'dr','Ù¾ÛŒ Ø¯ÛŒ Ø§Ù Ú†Ø§Ù¾ Ù‚Ù„Ù…',0),(570819,15857,'pr','Ù¾ÛŒ Ø¯ÛŒ Ø§Ù Ú†Ø§Ù¾ Ù‚Ù„Ù…',0),(570820,15857,'tr','PDF yazÄ± tipi yazdÄ±rma',0),(570821,15857,'pl','Drukowanie czcionek PDF',0),(570822,15857,'bg','Ð¨Ñ€Ð¸Ñ„Ñ‚ Ð·Ð° Ð¿ÐµÑ‡Ð°Ñ‚ PDF',0),(570823,15857,'ur','Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ù†Ù¹ Ú†Ú¾Ù¾Ø§Ø¦ÛŒ',0),(570824,15857,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°ÑšÐµ ÐŸÐ”Ð¤ Ñ„Ð¾Ð½Ñ‚Ð°',0),(570825,15857,'vi','In PDF Font',0),(570826,15857,'af','Druk die PDF Font',0),(570827,15857,'ro','Imprimare PDF Font',0),(570828,15857,'et','Prindi PDF Font',0),(570829,15857,'si','Tiskanje PDF pisave',0),(570830,15857,'ba','Mencetak PDF Font',0),(570831,15857,'nl','Afdrukken PDF lettertype',0),(570832,15857,'fi','Tulosta PDF fontti',0),(570833,15857,'no','Skrive ut PDF-skrift',0),(570834,15857,'da','Print PDF skrifttype',0),(570835,15857,'ko','ì¸ì‡„ PDF ê¸€ê¼´',0),(570836,15857,'he','×”×“×¤×¡×ª PDF ×’×•×¤×Ÿ',0),(570837,15857,'el','Î“ÏÎ±Î¼Î¼Î±Ï„Î¿ÏƒÎµÎ¹ÏÎ¬ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚ PDF',0),(570838,15857,'zh','æ‰“å° PDF å­—ä½“',0),(570839,15857,'sv','Skriv ut PDF typsnitt',0),(570840,15857,'it','Font di stampa PDF',0),(570841,15857,'tl','',0),(570842,15857,'th','à¸žà¸´à¸¡à¸žà¹Œà¸­à¸±à¸à¸©à¸£ PDF',0),(570843,15857,'hi','à¤ªà¥€à¤¡à¥€à¤à¤« à¤«à¤¼à¥‰à¤¨à¥à¤Ÿ à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(570844,15857,'ms','Fon cetakan PDF',0),(570845,15857,'ar','Ø·Ø¨Ø§Ø¹Ø© Ø§Ù„Ø®Ø· PDF',0),(570846,15857,'fr','Polices dâ€™impression PDF',0),(570847,15857,'jp','PDF ãƒ•ã‚©ãƒ³ãƒˆã‚’å°åˆ·ã—ã¾ã™ã€‚',0),(570848,15857,'pt','Fonte de impressÃ£o PDF',0),(570849,15857,'ru','ÐŸÐµÑ‡Ð°Ñ‚ÑŒ PDF ÑˆÑ€Ð¸Ñ„Ñ‚Ð¾Ð²',0),(570850,15857,'es','Imprimir PDF fuente',0),(570851,15857,'de','Drucken PDF-Schrift',0),(570852,15857,'en','Print PDF Font',0),(570853,15858,'is','',0),(570854,15858,'dr','Ø¢Ù¾Ù„ÙˆØ¯ ÙÙˆÙ†Øª Ù¾ÛŒ Ø¯ÛŒ Ø§Ù',0),(570855,15858,'pr','Ø¢Ù¾Ù„ÙˆØ¯ ÙÙˆÙ†Øª Ù¾ÛŒ Ø¯ÛŒ Ø§Ù',0),(570856,15858,'tr','PDF yazÄ± tipi yÃ¼kle',0),(570857,15858,'pl','PrzesÅ‚aÄ‡ PDF czcionki',0),(570858,15858,'bg','ÐšÐ°Ñ‡ÐµÑ‚Ðµ PDF ÑˆÑ€Ð¸Ñ„Ñ‚',0),(570859,15858,'ur','Ù¾ÛŒ ÚˆÛŒ Ø§ÛŒÙ ÙØ§Ù†Ù¹ Ø§Ù¾ Ù„ÙˆÚˆ Ú©Ø±ÛŒÚº',0),(570860,15858,'sr','ÐžÑ‚Ð¿Ñ€ÐµÐ¼Ð¸ ÐŸÐ”Ð¤ Ñ„Ð¾Ð½Ñ‚Ð°',0),(570861,15858,'vi','Táº£i PDF Font',0),(570862,15858,'af','Laai PDF Font',0),(570863,15858,'ro','ÃŽncÄƒrcaÅ£i PDF Font',0),(570864,15858,'et','Laadida PDF Font',0),(570865,15858,'si','NaloÅ¾ite PDF pisave',0),(570866,15858,'ba','Mengunggah PDF Font',0),(570867,15858,'nl','PDF lettertype uploaden',0),(570868,15858,'fi','Lataa PDF fontti',0),(570869,15858,'no','Laste opp PDF skrift',0),(570870,15858,'da','Uploade PDF skrifttype',0),(570871,15858,'ko','PDF ê¸€ê¼´ì„ ì—…ë¡œë“œ',0),(570872,15858,'he','×œ×”×¢×œ×•×ª PDF ×’×•×¤×Ÿ',0),(570873,15858,'el','Î‘Î½ÎµÎ²Î¬ÏƒÏ„Îµ PDF Î³ÏÎ±Î¼Î¼Î±Ï„Î¿ÏƒÎµÎ¹ÏÎ¬Ï‚',0),(570874,15858,'zh','ä¸Šä¼  PDF å­—ä½“',0),(570875,15858,'sv','Ladda upp PDF typsnitt',0),(570876,15858,'it','Caricare Font PDF',0),(570877,15858,'tl','',0),(570878,15858,'th','à¸­à¸±à¸›à¹‚à¸«à¸¥à¸”à¹à¸šà¸šà¸­à¸±à¸à¸©à¸£ PDF',0),(570879,15858,'hi','à¤«à¤¼à¥‰à¤¨à¥à¤Ÿ PDF à¤…à¤ªà¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(570880,15858,'ms','Meng-upload fon PDF',0),(570881,15858,'ar','ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ø®Ø· PDF',0),(570882,15858,'fr','TÃ©lÃ©charger PDF polices',0),(570883,15858,'jp','PDF ãƒ•ã‚©ãƒ³ãƒˆã‚’ã‚¢ãƒƒãƒ—ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(570884,15858,'pt','Upload de PDF Font',0),(570885,15858,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ PDF ÑˆÑ€Ð¸Ñ„Ñ‚Ð¾Ð²',0),(570886,15858,'es','Subir PDF fuente',0),(570887,15858,'de','Laden Sie PDF-Schrift',0),(570888,15858,'en','Upload PDF Font',0),(570889,15859,'is','',0),(570890,15859,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù¾Ø§Ø³Ø® Ø¨Ù‡ Ø¢Ø¯Ø±Ø³',0),(570891,15859,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù¾Ø§Ø³Ø® Ø¨Ù‡ Ø¢Ø¯Ø±Ø³',0),(570892,15859,'tr','VarsayÄ±lan yanÄ±t adresi iÃ§in',0),(570893,15859,'pl','DomyÅ›lnie odpowiedzi na adres',0),(570894,15859,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ Ð½Ð° Ð°Ð´Ñ€ÐµÑ',0),(570895,15859,'ur','Ø·Û’ Ø´Ø¯Û Ø¬ÙˆØ§Ø¨ÛŒ Ù¾ØªÛ Ú©Ø±Ù†Ø§',0),(570896,15859,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€ Ð½Ð° Ð°Ð´Ñ€ÐµÑÑƒ',0),(570897,15859,'vi','Äá»‹a chá»‰ tráº£ lá»i máº·c Ä‘á»‹nh',0),(570898,15859,'af','Verstek antwoord aan te spreek',0),(570899,15859,'ro','RÄƒspuns implicit la adresa',0),(570900,15859,'et','Vaikimisi vastuse aadress',0),(570901,15859,'si','Privzeti odgovor na naslov',0),(570902,15859,'ba','Default Balasan untuk alamat',0),(570903,15859,'nl','Standaard antwoord op adres',0),(570904,15859,'fi','Oletusarvoinen vastaus osoitteeseen',0),(570905,15859,'no','Standard svar til-adresse',0),(570906,15859,'da','Standard svar til-adresse',0),(570907,15859,'ko','ê¸°ë³¸ íšŒì‹  ì£¼ì†Œ',0),(570908,15859,'he','×ª×’×•×‘×” ×‘×¨×™×¨×ª ×ž×—×“×œ ×œ×›×ª×•×‘×ª',0),(570909,15859,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î±Ï€Î¬Î½Ï„Î·ÏƒÎ· ÏƒÏ„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(570910,15859,'zh','é»˜è®¤ç­”å¤åœ°å€',0),(570911,15859,'sv','Standard svar till adress',0),(570912,15859,'it','Indirizzo di risposta predefinito',0),(570913,15859,'tl','',0),(570914,15859,'th','à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸•à¸­à¸šà¸à¸¥à¸±à¸šà¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(570915,15859,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤ªà¥à¤°à¤¤à¥à¤¯à¥à¤¤à¥à¤¤à¤° à¤ªà¤¤à¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(570916,15859,'ms','Alamat balas lalai',0),(570917,15859,'ar','Ø§Ù„Ø±Ø¯ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¥Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù†',0),(570918,15859,'fr','Adresse de rÃ©ponse par dÃ©faut',0),(570919,15859,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã®è¿”ä¿¡ã‚¢ãƒ‰ãƒ¬ã‚¹',0),(570920,15859,'pt','Resposta padrÃ£o para o endereÃ§o',0),(570921,15859,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¾Ñ‚Ð²ÐµÑ‚Ñ‹ Ð½Ð° Ð°Ð´Ñ€ÐµÑ',0),(570922,15859,'es','Respuesta por defecto a la direcciÃ³n',0),(570923,15859,'de','Standard-Antwort auf Adresse',0),(570924,15859,'en','Default Reply To Address',0),(570925,15860,'is','',0),(570926,15860,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù¾Ø§Ø³Ø® Ø¨Ù‡ Ù†Ø§Ù…',0),(570927,15860,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù¾Ø§Ø³Ø® Ø¨Ù‡ Ù†Ø§Ù…',0),(570928,15860,'tr','AdÄ± iÃ§in varsayÄ±lan yanÄ±t',0),(570929,15860,'pl','OdpowiedÅº domyÅ›lna nazwa',0),(570930,15860,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ Ð½Ð° Ð¸Ð¼Ðµ',0),(570931,15860,'ur','Ù†Ø§Ù… Ú©Ùˆ Ø·Û’ Ø´Ø¯Û Ø¬ÙˆØ§Ø¨ Ø¯ÛŒÚº',0),(570932,15860,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€ Ð½Ð° Ð¸Ð¼Ðµ',0),(570933,15860,'vi','Tráº£ lá»i máº·c Ä‘á»‹nh tÃªn',0),(570934,15860,'af','Verstek antwoord op naam',0),(570935,15860,'ro','RÄƒspuns implicit la numele',0),(570936,15860,'et','Nimi vaikimisi vastuse',0),(570937,15860,'si','Privzeti odgovor za ime',0),(570938,15860,'ba','Balasan default nama',0),(570939,15860,'nl','Standaard antwoord op naam',0),(570940,15860,'fi','Oletusarvo vastaa nimi',0),(570941,15860,'no','Standard svar til navn',0),(570942,15860,'da','Standard svar til navn',0),(570943,15860,'ko','ì´ë¦„ìœ¼ë¡œ ê¸°ë³¸ ì‘ë‹µ',0),(570944,15860,'he','×ª×’×•×‘×” ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×œ×©×',0),(570945,15860,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î±Ï€Î¬Î½Ï„Î·ÏƒÎ· ÏƒÏ„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(570946,15860,'zh','åç§°ä¸ºé»˜è®¤ç­”å¤',0),(570947,15860,'sv','Standard svar till namn',0),(570948,15860,'it','Risposta predefinita al nome',0),(570949,15860,'tl','',0),(570950,15860,'th','à¸•à¸­à¸šà¸à¸¥à¸±à¸šà¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸Šà¸·à¹ˆà¸­',0),(570951,15860,'hi','à¤¨à¤¾à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤‰à¤¤à¥à¤¤à¤° à¤¦à¥‡à¤‚',0),(570952,15860,'ms','Balasan lalai kepada nama',0),(570953,15860,'ar','Ø§Ù„Ø±Ø¯ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø¥Ù„Ù‰ Ø§Ø³Ù…',0),(570954,15860,'fr','RÃ©ponse par dÃ©faut au nom',0),(570955,15860,'jp','åå‰ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã®è¿”ä¿¡',0),(570956,15860,'pt','Resposta padrÃ£o para o nome',0),(570957,15860,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¾Ñ‚Ð²ÐµÑ‚Ñ‹ Ð½Ð° Ð¸Ð¼Ñ',0),(570958,15860,'es','Respuesta por defecto a nombre',0),(570959,15860,'de','Standard-Antwort auf Namen',0),(570960,15860,'en','Default Reply To Name',0),(570961,15861,'is','',0),(570962,15861,'dr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù‡Ø§ÛŒ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø´Ø¯Ù‡',0),(570963,15861,'pr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù‡Ø§ÛŒ Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ Ø´Ø¯Ù‡',0),(570964,15861,'tr','ArÅŸivlenmiÅŸ deyimleri',0),(570965,15861,'pl','Zarchiwizowane instrukcje',0),(570966,15861,'bg','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ð¸ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(570967,15861,'ur','Ø¬Ù…Ø¹ Ø´Ø¯Û Ø¨ÛŒØ§Ù†Ø§Øª',0),(570968,15861,'sr','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð·Ñ˜Ð°Ð²Ðµ',0),(570969,15861,'vi','LÆ°u trá»¯ bÃ¡o cÃ¡o',0),(570970,15861,'af','Geargiveerde state',0),(570971,15861,'ro','Arhiva declaratii',0),(570972,15861,'et','Arhiveeritud avaldused',0),(570973,15861,'si','Arhivirane izjave',0),(570974,15861,'ba','Arsip laporan',0),(570975,15861,'nl','Gearchiveerde verklaringen',0),(570976,15861,'fi','Arkistoidut lausunnot',0),(570977,15861,'no','Arkiverte uttalelser',0),(570978,15861,'da','Arkiverede udtalelser',0),(570979,15861,'ko','ë³´ê´€ ëœ ë¬¸',0),(570980,15861,'he','×”×¦×”×¨×•×ª ×‘××¨×›×™×•×Ÿ',0),(570981,15861,'el','Î‘ÏÏ‡ÎµÎ¹Î¿Î¸ÎµÏ„Î·Î¼Î­Î½Î± Î´Î·Î»ÏŽÏƒÎµÎ¹Ï‚',0),(570982,15861,'zh','å­˜æ¡£çš„è¯­å¥',0),(570983,15861,'sv','Arkiverade rapporter',0),(570984,15861,'it','Istruzioni archiviate',0),(570985,15861,'tl','',0),(570986,15861,'th','à¸›à¸£à¸°à¸à¸²à¸¨à¸‡à¸š',0),(570987,15861,'hi','à¤¸à¤‚à¤—à¥à¤°à¤¹à¥€à¤¤ à¤¬à¤¯à¤¾à¤¨',0),(570988,15861,'ms','Arkib penyata',0),(570989,15861,'ar','Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…Ø¤Ø±Ø´ÙØ©',0),(570990,15861,'fr','DÃ©clarations archivÃ©es',0),(570991,15861,'jp','ã‚¢ãƒ¼ã‚«ã‚¤ãƒ–ã•ã‚ŒãŸã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆ',0),(570992,15861,'pt','DeclaraÃ§Ãµes arquivadas',0),(570993,15861,'ru','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ñ',0),(570994,15861,'es','Declaraciones archivadas',0),(570995,15861,'de','Archivierten Aussagen',0),(570996,15861,'en','Archived Statements',0),(570997,15862,'is','',0),(570998,15862,'dr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø¬Ø¯ÛŒØ¯ Ø§ÛŒÙ…ÛŒÙ„',0),(570999,15862,'pr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ø¬Ø¯ÛŒØ¯ Ø§ÛŒÙ…ÛŒÙ„',0),(571000,15862,'tr','E-posta yeni deyim',0),(571001,15862,'pl','Nowa deklaracja w sprawie e-mail',0),(571002,15862,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð½Ð¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(571003,15862,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø§ Ù†ÛŒØ§ Ø¨ÛŒØ§Ù†',0),(571004,15862,'sr','Ð• -Ð¿Ð¾ÑˆÑ‚Ð° Ð½Ð¾Ð²Ð° Ð¸Ð·Ñ˜Ð°Ð²Ð°',0),(571005,15862,'vi','Email má»›i tuyÃªn bá»‘',0),(571006,15862,'af','E-pos nuwe stelling',0),(571007,15862,'ro','DeclaraÅ£ie de e-mail noi',0),(571008,15862,'et','E-post uus avaldus',0),(571009,15862,'si','Nov email izjavo',0),(571010,15862,'ba','Pernyataan baru email',0),(571011,15862,'nl','Nieuwe e-mail-instructie',0),(571012,15862,'fi','SÃ¤hkÃ¶posti uusi laskelma',0),(571013,15862,'no','E-nye uttalelse',0),(571014,15862,'da','Email nye erklÃ¦ring',0),(571015,15862,'ko','ì´ë©”ì¼ ìƒˆ ë¬¸',0),(571016,15862,'he','×‘×”×¦×”×¨×” New ×“×•×',0),(571017,15862,'el','ÎÎ­Î± Î´Î®Î»Ï‰ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(571018,15862,'zh','ç”µå­é‚®ä»¶æ–°çš„å£°æ˜Ž',0),(571019,15862,'sv','E-nytt uttalande',0),(571020,15862,'it','E-mail nuova istruzione',0),(571021,15862,'tl','',0),(571022,15862,'th','à¸‡à¸šà¹ƒà¸«à¸¡à¹ˆà¸­à¸µ',0),(571023,15862,'hi','à¤¨à¤¯à¤¾ à¤ˆ-à¤®à¥‡à¤² à¤µà¤¿à¤µà¤°à¤£',0),(571024,15862,'ms','Kenyataan terbaru e-mel',0),(571025,15862,'ar','Ø¨ÙŠØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(571026,15862,'fr','Nouvel Ã©noncÃ© de courriel',0),(571027,15862,'jp','ãƒ¡ãƒ¼ãƒ«ã®æ–°ã—ã„æ–‡',0),(571028,15862,'pt','DeclaraÃ§Ã£o de novo e-mail',0),(571029,15862,'ru','ÐÐ¾Ð²Ð¾Ðµ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(571030,15862,'es','Correo electrÃ³nico nueva declaraciÃ³n',0),(571031,15862,'de','Neue e-Mail-Anweisung',0),(571032,15862,'en','Email New Statement',0),(571033,15863,'is','',0),(571034,15863,'dr','Chargeback Ú©Ø¯',0),(571035,15863,'pr','Chargeback Ú©Ø¯',0),(571036,15863,'tr','Ters ibraz kodu',0),(571037,15863,'pl','Kod Chargeback',0),(571038,15863,'bg','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ ÐºÐ¾Ð´',0),(571039,15863,'ur','Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ú©ÙˆÚˆ',0),(571040,15863,'sr','Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº Ð¨Ð¸Ñ„Ñ€Ð°',0),(571041,15863,'vi','MÃ£ sá»‘ tiá»n chiáº¿t kháº¥u',0),(571042,15863,'af','Chargeback kode',0),(571043,15863,'ro','Codul de chargeback',0),(571044,15863,'et','SissenÃµudmine kood',0),(571045,15863,'si','PoraÄuna kodo',0),(571046,15863,'ba','Chargeback Kode',0),(571047,15863,'nl','Chargeback Code',0),(571048,15863,'fi','Chargeback koodi',0),(571049,15863,'no','TilbakefÃ¸ring kode',0),(571050,15863,'da','TilbagefÃ¸rslen kode',0),(571051,15863,'ko','í™˜ë¶ˆ ì½”ë“œ',0),(571052,15863,'he','×§×•×“ ×”×—×™×•×‘',0),(571053,15863,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ chargeback',0),(571054,15863,'zh','è®¡è´¹ä»£ç ',0),(571055,15863,'sv','Chargeback kod',0),(571056,15863,'it','Codice di chargeback',0),(571057,15863,'tl','',0),(571058,15863,'th','à¸£à¸«à¸±à¸ªà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(571059,15863,'hi','à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤•à¥‹à¤¡',0),(571060,15863,'ms','Kod caj semula',0),(571061,15863,'ar','Ø±Ù…Ø² ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(571062,15863,'fr','Code de Chargeback',0),(571063,15863,'jp','ãƒãƒ£ãƒ¼ã‚¸ ã‚³ãƒ¼ãƒ‰',0),(571064,15863,'pt','CÃ³digo de chargeback',0),(571065,15863,'ru','ÐšÐ¾Ð´ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(571066,15863,'es','CÃ³digo de cargo al usuario',0),(571067,15863,'de','Chargeback-Code',0),(571068,15863,'en','Chargeback Code',0),(571069,15864,'is','',0),(571070,15864,'dr','Ú©Ø¯Ù‡Ø§ÛŒ Chargeback',0),(571071,15864,'pr','Ú©Ø¯Ù‡Ø§ÛŒ Chargeback',0),(571072,15864,'tr','Ters ibraz kodlarÄ±',0),(571073,15864,'pl','Kody zwrotne',0),(571074,15864,'bg','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ ÐºÐ¾Ð´Ð¾Ð²Ðµ',0),(571075,15864,'ur','Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ú©ÙˆÚˆ',0),(571076,15864,'sr','Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº ÑˆÐ¸Ñ„Ñ€Ðµ',0),(571077,15864,'vi','MÃ£ sá»‘ tiá»n chiáº¿t kháº¥u',0),(571078,15864,'af','Chargeback kodes',0),(571079,15864,'ro','Chargeback coduri',0),(571080,15864,'et','SissenÃµudmine koodid',0),(571081,15864,'si','PoraÄuna kode',0),(571082,15864,'ba','Chargeback Kode',0),(571083,15864,'nl','Terugboeking Codes',0),(571084,15864,'fi','Chargeback koodit',0),(571085,15864,'no','TilbakefÃ¸ring koder',0),(571086,15864,'da','TilbagefÃ¸rslen koder',0),(571087,15864,'ko','í™˜ë¶ˆ ì½”ë“œ',0),(571088,15864,'he','×”×—×™×•×‘ ×§×•×“×™×',0),(571089,15864,'el','Chargeback ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚',0),(571090,15864,'zh','è®¡è´¹ä»£ç ',0),(571091,15864,'sv','Chargeback koder',0),(571092,15864,'it','Codici di chargeback',0),(571093,15864,'tl','',0),(571094,15864,'th','à¸£à¸«à¸±à¸ªà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(571095,15864,'hi','à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤•à¥‹à¤¡à¥à¤¸',0),(571096,15864,'ms','Kod caj semula',0),(571097,15864,'ar','Ø±Ù…ÙˆØ² ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(571098,15864,'fr','Codes de Chargeback',0),(571099,15864,'jp','ãƒãƒ£ãƒ¼ã‚¸ ã‚³ãƒ¼ãƒ‰',0),(571100,15864,'pt','CÃ³digos de chargeback',0),(571101,15864,'ru','ÐšÐ¾Ð´Ñ‹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(571102,15864,'es','CÃ³digos de devoluciÃ³n de cargo',0),(571103,15864,'de','Chargeback-Codes',0),(571104,15864,'en','Chargeback Codes',0),(571105,15865,'is','',0),(571106,15865,'dr','Ù†Ø§Ù…Ù‡ Ø§ÛŒÙ…ÛŒÙ„ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(571107,15865,'pr','Ù†Ø§Ù…Ù‡ Ø§ÛŒÙ…ÛŒÙ„ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(571108,15865,'tr','E-postayla gÃ¶nderilen mektup',0),(571109,15865,'pl','Pismo wysÅ‚ane w wiadomoÅ›ci e-mail',0),(571110,15865,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾Ñ‚Ð¾ Ð¿Ð¸ÑÐ¼Ð¾',0),(571111,15865,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ø®Ø·',0),(571112,15865,'sr','ÐŸÐ¾ÑˆÑ‚Ð¾Ð¼ Ð¿Ð¸ÑÐ¼Ð¾',0),(571113,15865,'vi','Gá»­i thÆ°',0),(571114,15865,'af','Per e-pos brief',0),(571115,15865,'ro','Scrisoarea prin e-mail',0),(571116,15865,'et','Saadetud kiri',0),(571117,15865,'si','Poslano pismo',0),(571118,15865,'ba','Email Surat',0),(571119,15865,'nl','Maild brief',0),(571120,15865,'fi','LÃ¤hetetty kirje',0),(571121,15865,'no','Sendt brev',0),(571122,15865,'da','Sendt brev',0),(571123,15865,'ko','ë³´ë‚¸ëœ íŽ¸ì§€',0),(571124,15865,'he','×ž×›×ª×‘ ×‘×“×•××¨',0),(571125,15865,'el','Î•ÏƒÏ„Î¬Î»Î·ÏƒÎ±Î½ Î¼Îµ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÏŒ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿ ÎµÏ€Î¹ÏƒÏ„Î¿Î»Î®Ï‚',0),(571126,15865,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€çš„ä¿¡',0),(571127,15865,'sv','E-postade brev',0),(571128,15865,'it','Emailed la lettera',0),(571129,15865,'tl','',0),(571130,15865,'th','à¸ˆà¸”à¸«à¸¡à¸²à¸¢à¸­à¸µà¹€à¸¡à¸¥',0),(571131,15865,'hi','à¤ˆà¤®à¥‡à¤² à¤•à¤¿à¤ à¤ªà¤¤à¥à¤°',0),(571132,15865,'ms','E Surat',0),(571133,15865,'ar','Ø±Ø³Ø§Ù„Ø© Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(571134,15865,'fr','Lettre par courriel',0),(571135,15865,'jp','ãƒ¡ãƒ¼ãƒ«ã®æ‰‹ç´™',0),(571136,15865,'pt','Carta por correio electrÃ³nico',0),(571137,15865,'ru','ÐŸÐ¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ Ð¿Ð¸ÑÑŒÐ¼Ð¾',0),(571138,15865,'es','Carta por correo electrÃ³nico',0),(571139,15865,'de','Per e-Mail schreiben',0),(571140,15865,'en','Emailed Letter',0),(571141,15866,'is','',0),(571142,15866,'dr','Ù‚Ø§Ù„Ø¨ Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„',0),(571143,15866,'pr','Ù‚Ø§Ù„Ø¨ Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„',0),(571144,15866,'tr','Posta ÅŸablonlarÄ±',0),(571145,15866,'pl','Szablony e-mail',0),(571146,15866,'bg','Ð¨Ð°Ð±Ð»Ð¾Ð½Ð¸ Ð·Ð° Ð¿Ð¾Ñ‰Ð°',0),(571147,15866,'ur','Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Û’',0),(571148,15866,'sr','ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð¾Ð±Ñ€Ð°ÑÑ†Ð¸',0),(571149,15866,'vi','Máº«u thÆ°',0),(571150,15866,'af','E-pos patrone',0),(571151,15866,'ro','Åžabloane de poÅŸtÄƒ',0),(571152,15866,'et','Mail Blanketid',0),(571153,15866,'si','PoÅ¡ta predloge',0),(571154,15866,'ba','Email template',0),(571155,15866,'nl','E-mail sjablonen',0),(571156,15866,'fi','SÃ¤hkÃ¶postimallit',0),(571157,15866,'no','E-maler',0),(571158,15866,'da','E-mail-skabeloner',0),(571159,15866,'ko','ë©”ì¼ í…œí”Œë¦¿',0),(571160,15866,'he','×ª×‘× ×™×•×ª ×“×•××¨',0),(571161,15866,'el','Î ÏÏŒÏ„Ï…Ï€Î± Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚',0),(571162,15866,'zh','é‚®ä»¶æ¨¡æ¿',0),(571163,15866,'sv','E-postmallar',0),(571164,15866,'it','Modelli di posta elettronica',0),(571165,15866,'tl','',0),(571166,15866,'th','à¹à¸¡à¹ˆà¹à¸šà¸šà¸ˆà¸”à¸«à¸¡à¸²à¸¢',0),(571167,15866,'hi','à¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿà¥à¤¸',0),(571168,15866,'ms','Mel template',0),(571169,15866,'ar','Ù‚ÙˆØ§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯',0),(571170,15866,'fr','ModÃ¨les de courrier',0),(571171,15866,'jp','ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ',0),(571172,15866,'pt','Modelos de e-mail',0),(571173,15866,'ru','Ð¨Ð°Ð±Ð»Ð¾Ð½Ñ‹ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(571174,15866,'es','Plantillas de correo',0),(571175,15866,'de','Mail-Vorlagen',0),(571176,15866,'en','Mail Templates',0),(571177,15867,'is','',0),(571178,15867,'dr','Ù†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ Ú†Ø§Ù¾ Ø´Ø¯Ù‡',0),(571179,15867,'pr','Ù†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ Ú†Ø§Ù¾ Ø´Ø¯Ù‡',0),(571180,15867,'tr','BasÄ±lÄ± mektup',0),(571181,15867,'pl','List drukowany',0),(571182,15867,'bg','ÐŸÐµÑ‡Ð°Ñ‚Ð½Ð¸ Ð¿Ð¸ÑÐ¼Ð¾',0),(571183,15867,'ur','Ù…Ø·Ø¨ÙˆØ¹Û Ø®Ø·',0),(571184,15867,'sr','Ð¨Ñ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ð¿Ð¸ÑÐ¼Ð¾',0),(571185,15867,'vi','In chá»¯',0),(571186,15867,'af','Gedrukte Letter',0),(571187,15867,'ro','Scrisoarea imprimate',0),(571188,15867,'et','Prinditava kirja',0),(571189,15867,'si','Natisnjeno pismo',0),(571190,15867,'ba','Cetak huruf',0),(571191,15867,'nl','Afgedrukte brief',0),(571192,15867,'fi','Painettu kirjain',0),(571193,15867,'no','Trykte brev',0),(571194,15867,'da','Trykte brev',0),(571195,15867,'ko','ì¸ì‡„ ëœ íŽ¸ì§€',0),(571196,15867,'he','×ž×›×ª×‘ ×ž×•×“×¤×¡',0),(571197,15867,'el','Î¤Ï…Ï€Ï‰Î¼Î­Î½Î· ÎµÏ€Î¹ÏƒÏ„Î¿Î»Î®',0),(571198,15867,'zh','å°åˆ¶çš„ä¿¡ä»¶',0),(571199,15867,'sv','Tryckta brev',0),(571200,15867,'it','Lettera stampata',0),(571201,15867,'tl','',0),(571202,15867,'th','à¸žà¸´à¸¡à¸žà¹Œà¸­à¸±à¸à¸©à¸£',0),(571203,15867,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤ªà¤¤à¥à¤°',0),(571204,15867,'ms','Surat yang bercetak',0),(571205,15867,'ar','Ø±Ø³Ø§Ù„Ø© Ù…Ø·Ø¨ÙˆØ¹Ø©',0),(571206,15867,'fr','Lettre imprimÃ©e',0),(571207,15867,'jp','å°åˆ·æ–‡å­—',0),(571208,15867,'pt','Letra impressa',0),(571209,15867,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð½Ñ‹Ðµ Ð±ÑƒÐºÐ²Ñ‹',0),(571210,15867,'es','Letra impresa',0),(571211,15867,'de','Gedruckten Brief',0),(571212,15867,'en','Printed Letter',0),(571213,15868,'is','',0),(571214,15868,'dr','Ú¯Ø²ÛŒÙ†Ù‡ Ø´Ø§Ø±Ú˜ Ø¨Ù‡Ø±Ù‡',0),(571215,15868,'pr','Ú¯Ø²ÛŒÙ†Ù‡ Ø´Ø§Ø±Ú˜ Ø¨Ù‡Ø±Ù‡',0),(571216,15868,'tr','Faiz Ã¼cret seÃ§eneÄŸi',0),(571217,15868,'pl','Zainteresowanie opcja bezpÅ‚atna',0),(571218,15868,'bg','Ð›Ð¸Ñ…Ð²Ð° Ñ‚Ð°ÐºÑÐ° Ð¾Ð¿Ñ†Ð¸Ñ',0),(571219,15868,'ur','Ø³ÙˆØ¯ Ú†Ø§Ø±Ø¬ Ø§Ø®ØªÛŒØ§Ø±',0),(571220,15868,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ð½Ð° Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(571221,15868,'vi','LÃ£i suáº¥t phÃ­ tÃ¹y chá»n',0),(571222,15868,'af','Rente heffing opsie',0),(571223,15868,'ro','OpÅ£iune de taxa de interes',0),(571224,15868,'et','Huvi tasu valik',0),(571225,15868,'si','Obresti brezplaÄno moÅ¾nost',0),(571226,15868,'ba','Menarik biaya pilihan',0),(571227,15868,'nl','Belang heffing optie',0),(571228,15868,'fi','Edun vaihtoehto',0),(571229,15868,'no','Interesse gratis alternativ',0),(571230,15868,'da','Interesse gebyr indstilling',0),(571231,15868,'ko','ê´€ì‹¬ ìš”ê¸ˆ ì˜µì…˜',0),(571232,15868,'he','××¤×©×¨×•×ª ×ª×©×œ×•× ×¨×™×‘×™×ª',0),(571233,15868,'el','Î•Ï€Î¹Î»Î¿Î³Î® Ï‡ÏÎ­Ï‰ÏƒÎ· Ï„ÏŒÎºÏ‰Î½',0),(571234,15868,'zh','åˆ©æ¯è´¹ç”¨é€‰é¡¹',0),(571235,15868,'sv','Intresse kostnad alternativ',0),(571236,15868,'it','Opzione di pagamento di interesse',0),(571237,15868,'tl','',0),(571238,15868,'th','à¹€à¸¥à¸·à¸­à¸à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢',0),(571239,15868,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤¶à¥à¤²à¥à¤• à¤µà¤¿à¤•à¤²à¥à¤ª',0),(571240,15868,'ms','Pilihan bayaran faedah',0),(571241,15868,'ar','Ø§Ù„Ø®ÙŠØ§Ø± Ø±Ø³ÙˆÙ… Ø§Ù„ÙØ§Ø¦Ø¯Ø©',0),(571242,15868,'fr','Option de frais dâ€™intÃ©rÃªt',0),(571243,15868,'jp','èˆˆå‘³æ–™é‡‘ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(571244,15868,'pt','OpÃ§Ã£o de taxa de juros',0),(571245,15868,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹ Ð·Ð°Ñ€ÑÐ´Ð° Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚',0),(571246,15868,'es','OpciÃ³n de carga de interÃ©s',0),(571247,15868,'de','Interesse kostenlos Option',0),(571248,15868,'en','Interest Charge Option',0),(571249,15869,'is','',0),(571250,15869,'dr','Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ù‡Ø±Ù‡',0),(571251,15869,'pr','Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ù‡Ø±Ù‡',0),(571252,15869,'tr','Faiz Ã¼cret seÃ§enekleri',0),(571253,15869,'pl','Opcje Å‚adowania zainteresowania',0),(571254,15869,'bg','Ð›Ð¸Ñ…Ð²Ð° Ñ‚Ð°ÐºÑÐ° Ð¾Ð¿Ñ†Ð¸Ð¸',0),(571255,15869,'ur','Ø³ÙˆØ¯ Ú†Ø§Ø±Ø¬ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(571256,15869,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(571257,15869,'vi','LÃ£i suáº¥t phÃ­ tÃ¹y chá»n',0),(571258,15869,'af','Rente heffing opsies',0),(571259,15869,'ro','OpÅ£iuni de taxa de interes',0),(571260,15869,'et','Huvi vÃµimalusi',0),(571261,15869,'si','MoÅ¾nosti za brezplaÄno obresti',0),(571262,15869,'ba','Menarik biaya pilihan',0),(571263,15869,'nl','Belang gratis opties',0),(571264,15869,'fi','Korko maksu-optiot',0),(571265,15869,'no','Renter gratis alternativer',0),(571266,15869,'da','Interesse gebyr valgmuligheder',0),(571267,15869,'ko','ê´€ì‹¬ ìš”ê¸ˆ ì˜µì…˜',0),(571268,15869,'he','××¤×©×¨×•×™×•×ª ×ª×©×œ×•× ×¨×™×‘×™×ª',0),(571269,15869,'el','Î•Ï€Î¹Î»Î¿Î³Î­Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚ Ï„ÏŒÎºÏ‰Î½',0),(571270,15869,'zh','åˆ©æ¯è´¹ç”¨é€‰é¡¹',0),(571271,15869,'sv','Intresse kostnad alternativ',0),(571272,15869,'it','Opzioni di pagamento di interesse',0),(571273,15869,'tl','',0),(571274,15869,'th','à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢',0),(571275,15869,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤¶à¥à¤²à¥à¤• à¤µà¤¿à¤•à¤²à¥à¤ª',0),(571276,15869,'ms','Pilihan bayaran faedah',0),(571277,15869,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø±Ø³ÙˆÙ… Ø§Ù„ÙØ§Ø¦Ø¯Ø©',0),(571278,15869,'fr','Options de frais dâ€™intÃ©rÃªt',0),(571279,15869,'jp','èˆˆå‘³æ–™é‡‘ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(571280,15869,'pt','OpÃ§Ãµes de taxa de juros',0),(571281,15869,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ñ‹Ðµ Ð²Ð°Ñ€Ð¸Ð°Ð½Ñ‚Ñ‹',0),(571282,15869,'es','Opciones de carga de interÃ©s',0),(571283,15869,'de','Zinsoptionen kostenlos',0),(571284,15869,'en','Interest Charge Options',0),(571285,15870,'is','',0),(571286,15870,'dr','Ù†Ø±Ø® Ø¨Ù‡Ø±Ù‡',0),(571287,15870,'pr','Ù†Ø±Ø® Ø¨Ù‡Ø±Ù‡',0),(571288,15870,'tr','Faiz oranÄ±',0),(571289,15870,'pl','Stopa procentowa',0),(571290,15870,'bg','Ð›Ð¸Ñ…Ð²ÐµÐ½ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(571291,15870,'ur','Ø´Ø±Ø­ Ø³ÙˆØ¯',0),(571292,15870,'sr','ÐšÐ°Ð¼Ð°Ñ‚Ð½Ð° ÑÑ‚Ð¾Ð¿Ð°',0),(571293,15870,'vi','LÃ£i suáº¥t',0),(571294,15870,'af','Rentekoers',0),(571295,15870,'ro','Rata dobÃ¢nzii',0),(571296,15870,'et','IntressimÃ¤Ã¤r',0),(571297,15870,'si','Obrestna mera',0),(571298,15870,'ba','Suku bunga',0),(571299,15870,'nl','Rente',0),(571300,15870,'fi','Korko',0),(571301,15870,'no','Rente',0),(571302,15870,'da','Rente',0),(571303,15870,'ko','ì´ìžìœ¨',0),(571304,15870,'he','×©×™×¢×•×¨ ×”×¨×™×‘×™×ª',0),(571305,15870,'el','Î•Ï€Î¹Ï„ÏŒÎºÎ¹Î¿',0),(571306,15870,'zh','åˆ©çŽ‡',0),(571307,15870,'sv','RÃ¤ntesats',0),(571308,15870,'it','Tasso di interesse',0),(571309,15870,'tl','',0),(571310,15870,'th','à¸­à¸±à¸•à¸£à¸²à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢',0),(571311,15870,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤¦à¤°',0),(571312,15870,'ms','Kadar faedah',0),(571313,15870,'ar','Ù…Ø¹Ø¯Ù„ Ø§Ù„ÙØ§Ø¦Ø¯Ø©',0),(571314,15870,'fr','Taux dâ€™intÃ©rÃªt',0),(571315,15870,'jp','é‡‘åˆ©',0),(571316,15870,'pt','Taxa de juros',0),(571317,15870,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ð½Ð°Ñ ÑÑ‚Ð°Ð²ÐºÐ°',0),(571318,15870,'es','Tasa de interÃ©s',0),(571319,15870,'de','Zinssatz',0),(571320,15870,'en','Interest Rate',0),(571321,15871,'is','',0),(571322,15871,'dr','Ø§Ù†ÙˆØ§Ø¹ Ø´ØºÙ„',0),(571323,15871,'pr','Ø§Ù†ÙˆØ§Ø¹ Ø´ØºÙ„',0),(571324,15871,'tr','Ä°ÅŸ tÃ¼rleri',0),(571325,15871,'pl','Rodzaje pracy',0),(571326,15871,'bg','Ð’Ð¸Ð´Ð¾Ð²Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(571327,15871,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(571328,15871,'sr','Ð¢Ð¸Ð¿Ð¾Ð²Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(571329,15871,'vi','CÃ¡c loáº¡i cÃ´ng viá»‡c',0),(571330,15871,'af','Werk tipes',0),(571331,15871,'ro','Tipuri de Job',0),(571332,15871,'et','TÃ¶Ã¶tÃ¼Ã¼bid',0),(571333,15871,'si','Vrste poslov',0),(571334,15871,'ba','Jenis pekerjaan',0),(571335,15871,'nl','Taaktypen',0),(571336,15871,'fi','TÃ¶iden tyypit',0),(571337,15871,'no','Jobbtyper',0),(571338,15871,'da','Jobtyper',0),(571339,15871,'ko','ìž‘ì—… ìœ í˜•',0),(571340,15871,'he','×¡×•×’×™ ×”×¢×‘×•×“×”',0),(571341,15871,'el','Î¤ÏÏ€Î¿Ï…Ï‚ ÎµÏÎ³Î±ÏƒÎ¹ÏŽÎ½',0),(571342,15871,'zh','ä½œä¸šç±»åž‹',0),(571343,15871,'sv','Jobbtyper',0),(571344,15871,'it','Tipi di lavoro',0),(571345,15871,'tl','',0),(571346,15871,'th','à¸Šà¸™à¸´à¸”à¸‚à¸­à¸‡à¸‡à¸²à¸™',0),(571347,15871,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(571348,15871,'ms','Jenis kerja',0),(571349,15871,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„ÙˆØ¸Ø§Ø¦Ù',0),(571350,15871,'fr','Types dâ€™emploi',0),(571351,15871,'jp','ã‚¸ãƒ§ãƒ–ã®ç¨®é¡ž',0),(571352,15871,'pt','Tipos de trabalho',0),(571353,15871,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð·Ð°Ð´Ð°Ð½Ð¸Ð¹',0),(571354,15871,'es','Tipos de trabajo',0),(571355,15871,'de','Job-Typen',0),(571356,15871,'en','Job Types',0),(571357,15872,'is','',0),(571358,15872,'dr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… Ù¾Ø±Ø¯Ø§Ø®Øª',0),(571359,15872,'pr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… Ù¾Ø±Ø¯Ø§Ø®Øª',0),(571360,15872,'tr','DoÄŸrudan AR Ã¶demeler',0),(571361,15872,'pl','AR pÅ‚atnoÅ›ci bezpoÅ›rednich',0),(571362,15872,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ, AR',0),(571363,15872,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(571364,15872,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ ÐÐ  ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(571365,15872,'vi','Thanh toÃ¡n trá»±c tiáº¿p AR',0),(571366,15872,'af','Direkte AR betalings',0),(571367,15872,'ro','PlÄƒÈ›ile directe AR',0),(571368,15872,'et','AR otsetoetused',0),(571369,15872,'si','Neposredna plaÄila AR',0),(571370,15872,'ba','Pembayaran langsung AR',0),(571371,15872,'nl','Rechtstreekse betalingen AR',0),(571372,15872,'fi','Tuissa AR',0),(571373,15872,'no','Direkte AR betalinger',0),(571374,15872,'da','Direkte AR betalinger',0),(571375,15872,'ko','ì§ì ‘ ì•„ì¹¸ì†Œ ì§€ë¶ˆ',0),(571376,15872,'he','×ª×©×œ×•×ž×™× ×™×©×™×¨×™× AR',0),(571377,15872,'el','Î†Î¼ÎµÏƒÎµÏ‚ ÎµÎ½Î¹ÏƒÏ‡ÏÏƒÎµÎ¹Ï‚ AR',0),(571378,15872,'zh','ç›´æŽ¥ AR ä»˜æ¬¾',0),(571379,15872,'sv','Betalningar med AR',0),(571380,15872,'it','AR i pagamenti diretti',0),(571381,15872,'tl','',0),(571382,15872,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹‚à¸”à¸¢à¸•à¸£à¸‡ AR',0),(571383,15872,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· AR à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(571384,15872,'ms','Mengarahkan pembayaran AR',0),(571385,15872,'ar','AR Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø©',0),(571386,15872,'fr','Paiements directs AR',0),(571387,15872,'jp','ç›´æŽ¥ AR æ”¯æ‰•ã„',0),(571388,15872,'pt','AR de pagamentos directos',0),(571389,15872,'ru','ÐŸÑ€ÑÐ¼Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸ AR',0),(571390,15872,'es','AR pagos directos',0),(571391,15872,'de','AR-Direktzahlungen',0),(571392,15872,'en','Direct AR Payments',0),(571393,15873,'is','',0),(571394,15873,'dr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… Ø§Ù†ÙˆØ§Ø¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(571395,15873,'pr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… Ø§Ù†ÙˆØ§Ø¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(571396,15873,'tr','DoÄŸrudan AR Ã¶deme ÅŸekli',0),(571397,15873,'pl','Typy pÅ‚atnoÅ›ci bezpoÅ›rednie AR',0),(571398,15873,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ AR Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(571399,15873,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(571400,15873,'sr','Ð¢Ð¸Ð¿Ð¾Ð²Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ðµ ÐÐ ',0),(571401,15873,'vi','HÃ¬nh thá»©c thanh toÃ¡n trá»±c tiáº¿p AR',0),(571402,15873,'af','Direkte AR betaling tipes',0),(571403,15873,'ro','Tipuri de platÄƒ directÄƒ AR',0),(571404,15873,'et','Otsene AR MaksevÃµimalused',0),(571405,15873,'si','Vrste plaÄil neposredno AR',0),(571406,15873,'ba','Jenis pembayaran langsung AR',0),(571407,15873,'nl','Directe AR betaalwijzen',0),(571408,15873,'fi','Suora AR maksutavat',0),(571409,15873,'no','Direkte AR betalingstyper',0),(571410,15873,'da','Direkte AR betalingstyper',0),(571411,15873,'ko','ì§ì ‘ ì•„ì¹¸ì†Œ ì§€ë¶ˆ ìœ í˜•',0),(571412,15873,'he','×¡×•×’×™ ×ª×©×œ×•× ×™×©×™×¨ AR',0),(571413,15873,'el','Î†Î¼ÎµÏƒÎ· AR Ï„ÏÏ€Î¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(571414,15873,'zh','ç›´æŽ¥ AR ä»˜æ¬¾ç±»åž‹',0),(571415,15873,'sv','Direkta AR betalningstyper',0),(571416,15873,'it','Tipi di pagamento diretto AR',0),(571417,15873,'tl','',0),(571418,15873,'th','à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹‚à¸”à¸¢à¸•à¸£à¸‡ AR',0),(571419,15873,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· AR à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(571420,15873,'ms','Jenis pembayaran langsung AR',0),(571421,15873,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± Ø¹',0),(571422,15873,'fr','Types de paiement direct AR',0),(571423,15873,'jp','AR ã®ç›´æŽ¥æ”¯æ‰•ã„ã®ç¨®é¡ž',0),(571424,15873,'pt','Tipos de pagamento de AR direto',0),(571425,15873,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ñ€ÑÐ¼Ñ‹Ðµ AR',0),(571426,15873,'es','Formas de pago directo AR',0),(571427,15873,'de','Direkte AR Zahlungsarten',0),(571428,15873,'en','Direct AR Payment Types',0),(571429,15874,'is','',0),(571430,15874,'dr','Ù…Ø´ØªØ±ÛŒ ØµÙØ­Ù‡ Ù…Ø±Ø§Ø¬Ø¹Ù‡ Ú©Ù†ÛŒØ¯',0),(571431,15874,'pr','Ù…Ø´ØªØ±ÛŒ ØµÙØ­Ù‡ Ù…Ø±Ø§Ø¬Ø¹Ù‡ Ú©Ù†ÛŒØ¯',0),(571432,15874,'tr','MÃ¼ÅŸteri sayfasÄ±na bakÄ±n',0),(571433,15874,'pl','Zobacz stronÄ™ klienta',0),(571434,15874,'bg','Ð’Ð¸Ð¶Ñ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(571435,15874,'ur','Ú©Ø³Ù¹Ù…Ø± ØµÙØ­Û Ù…Ù„Ø§Ø­Ø¸Û Ú©Ø±ÛŒÚº',0),(571436,15874,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ Ð·Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(571437,15874,'vi','Xem khÃ¡ch hÃ ng trang',0),(571438,15874,'af','Sien kliÃ«nt bladsy',0),(571439,15874,'ro','A se vedea pagina de client',0),(571440,15874,'et','Vaata kliendi lk',0),(571441,15874,'si','Glej strani kupca',0),(571442,15874,'ba','Lihat halaman pelanggan',0),(571443,15874,'nl','Zie klantenpagina',0),(571444,15874,'fi','Asiakkaan sivulla',0),(571445,15874,'no','Se siden for kunde',0),(571446,15874,'da','Se kunde side',0),(571447,15874,'ko','ê³ ê° íŽ˜ì´ì§€ë¥¼ ì°¸ì¡° í•˜ì‹­ì‹œì˜¤',0),(571448,15874,'he','×¢×™×™×Ÿ ×‘×“×£ ×œ×§×•×—×•×ª',0),(571449,15874,'el','Î”ÎµÎ¯Ï„Îµ Ï„Î·Î½ ÏƒÎµÎ»Î¯Î´Î± Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(571450,15874,'zh','çœ‹åˆ°å®¢æˆ·é¡µ',0),(571451,15874,'sv','Se kund sida',0),(571452,15874,'it','Vedere pagina clienti',0),(571453,15874,'tl','',0),(571454,15874,'th','à¸”à¸¹à¸«à¸™à¹‰à¸²à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(571455,15874,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¥ƒà¤·à¥à¤  à¤¦à¥‡à¤–à¥‡à¤‚',0),(571456,15874,'ms','Sila lihat halaman pelanggan',0),(571457,15874,'ar','Ø§Ù†Ø¸Ø± ØµÙØ­Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(571458,15874,'fr','Voir la Page client',0),(571459,15874,'jp','ãŠå®¢æ§˜ã®ãƒšãƒ¼ã‚¸ã‚’ã”è¦§ãã ã•ã„ã€‚',0),(571460,15874,'pt','Consulte a pÃ¡gina do cliente',0),(571461,15874,'ru','Ð¡Ð¼Ð¾Ñ‚Ñ€Ð¸Ñ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(571462,15874,'es','Consulte la pÃ¡gina de cliente',0),(571463,15874,'de','Siehe Kundenseite',0),(571464,15874,'en','See Customer Page',0),(571465,15875,'is','',0),(571466,15875,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´ Ù…Ø´ØªØ±ÛŒ',0),(571467,15875,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙØ±ÙˆØ´ Ù…Ø´ØªØ±ÛŒ',0),(571468,15875,'tr','MÃ¼ÅŸteri satÄ±ÅŸ bilgileri',0),(571469,15875,'pl','Informacje na temat sprzedaÅ¼y klienta',0),(571470,15875,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(571471,15875,'ur','Ú©Ø³Ù¹Ù…Ø± Ø³ÛŒÙ„Ø² Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(571472,15875,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð˜Ð½Ñ„Ð¾',0),(571473,15875,'vi','ThÃ´ng tin bÃ¡n hÃ ng khÃ¡ch hÃ ng',0),(571474,15875,'af','KliÃ«nt verkope Info',0),(571475,15875,'ro','Info vÃ¢nzÄƒri client',0),(571476,15875,'et','Kliendi mÃ¼Ã¼giinfo',0),(571477,15875,'si','Kupec prodajnih Info',0),(571478,15875,'ba','Info Pelanggan penjualan',0),(571479,15875,'nl','Klant verkoop Info',0),(571480,15875,'fi','Asiakas myynti-Info',0),(571481,15875,'no','Salg Kundeinfo',0),(571482,15875,'da','Kunde salget Info',0),(571483,15875,'ko','ê³ ê° íŒë§¤ ì •ë³´',0),(571484,15875,'he','×¤×¨×˜×™ ×œ×§×•×— ×ž×›×™×¨×•×ª',0),(571485,15875,'el','Î Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î±Ï„ÎµÏ‚',0),(571486,15875,'zh','å®¢æˆ·é”€å”®ä¿¡æ¯',0),(571487,15875,'sv','Kund fÃ¶rsÃ¤ljning information',0),(571488,15875,'it','Info di vendita del cliente',0),(571489,15875,'tl','',0),(571490,15875,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‚à¸²à¸¢à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(571491,15875,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¬à¤¿à¤•à¥à¤°à¥€ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(571492,15875,'ms','Baca maklumat jualan',0),(571493,15875,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø²Ø¨ÙˆÙ†',0),(571494,15875,'fr','Informations de vente client',0),(571495,15875,'jp','ãŠå®¢æ§˜ã®è²©å£²æƒ…å ±',0),(571496,15875,'pt','InformaÃ§Ã£o de vendas do cliente',0),(571497,15875,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(571498,15875,'es','InformaciÃ³n de ventas al cliente',0),(571499,15875,'de','Kunden Verkauf Info',0),(571500,15875,'en','Customer Sales Info',0),(571501,15876,'is','',0),(571502,15876,'dr','Ú©Ø§Ø± Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡',0),(571503,15876,'pr','Ú©Ø§Ø± Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡',0),(571504,15876,'tr','Ä°ÅŸ eklendi',0),(571505,15876,'pl','Zadanie dodane',0),(571506,15876,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð´Ð¾Ð±Ð°Ð²ÐµÐ½',0),(571507,15876,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ',0),(571508,15876,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð¾',0),(571509,15876,'vi','Viá»‡c lÃ m thÃªm',0),(571510,15876,'af','Werk bygevoeg',0),(571511,15876,'ro','Job adaugat',0),(571512,15876,'et','Lisatud tÃ¶Ã¶',0),(571513,15876,'si','Delo, ki doda',0),(571514,15876,'ba','Pekerjaan ditambahkan',0),(571515,15876,'nl','Baan toegevoegd',0),(571516,15876,'fi','LisÃ¤tty tyÃ¶',0),(571517,15876,'no','Jobb lagt',0),(571518,15876,'da','Job tilfÃ¸jet',0),(571519,15876,'ko','ìž‘ì—… ì¶”ê°€',0),(571520,15876,'he','×¢×‘×•×“×” × ×•×¡×¤×ª',0),(571521,15876,'el','Î”Î¿Ï…Î»ÎµÎ¹Î¬ Ï€Î¿Ï… Ï€ÏÏŒÏƒÎ¸ÎµÏƒÎ±Î½',0),(571522,15876,'zh','æ·»åŠ ä½œä¸š',0),(571523,15876,'sv','Jobb till',0),(571524,15876,'it','Lavoro aggiunto',0),(571525,15876,'tl','',0),(571526,15876,'th','à¸‡à¸²à¸™à¹€à¸žà¸´à¹ˆà¸¡',0),(571527,15876,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤®à¥‡à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾',0),(571528,15876,'ms','Kerja yang ditambah',0),(571529,15876,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…Ø¶Ø§ÙØ©',0),(571530,15876,'fr','Job a ajoutÃ©',0),(571531,15876,'jp','è¿½åŠ ã‚¸ãƒ§ãƒ–',0),(571532,15876,'pt','Trabalho adicionado',0),(571533,15876,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(571534,15876,'es','Trabajo aÃ±adido',0),(571535,15876,'de','Auftrags hinzugefÃ¼gt',0),(571536,15876,'en','Job Added',0),(571537,15877,'is','',0),(571538,15877,'dr','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡',0),(571539,15877,'pr','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡',0),(571540,15877,'tr','KapalÄ± iÅŸ',0),(571541,15877,'pl','Zadania zamkniÄ™te',0),(571542,15877,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(571543,15877,'ur','Ú©Ø§Ù… Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(571544,15877,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(571545,15877,'vi','Viá»‡c Ä‘Ã³ng cá»­a',0),(571546,15877,'af','Werk gesluit',0),(571547,15877,'ro','Job Ã®nchis',0),(571548,15877,'et','TÃ¶Ã¶ suletud',0),(571549,15877,'si','Delo zaprtih',0),(571550,15877,'ba','Pekerjaan yang tertutup',0),(571551,15877,'nl','Baan gesloten',0),(571552,15877,'fi','TyÃ¶ suljettu',0),(571553,15877,'no','Jobb lukket',0),(571554,15877,'da','Opgave lukket',0),(571555,15877,'ko','ì§ìž¥ íì‡„',0),(571556,15877,'he','×”×¢×‘×•×“×” ×¡×’×•×¨',0),(571557,15877,'el','Î”Î¿Ï…Î»ÎµÎ¹Î¬ ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŒ',0),(571558,15877,'zh','å°é—­çš„å·¥ä½œ',0),(571559,15877,'sv','Jobb stÃ¤ngd',0),(571560,15877,'it','Lavoro chiuso',0),(571561,15877,'tl','',0),(571562,15877,'th','à¸›à¸´à¸”à¸‡à¸²à¸™',0),(571563,15877,'hi','à¤•à¤¾à¤® à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(571564,15877,'ms','Kerja yang ditutup',0),(571565,15877,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ù…ØºÙ„Ù‚Ø©',0),(571566,15877,'fr','Emplois fermÃ©s',0),(571567,15877,'jp','ã‚¸ãƒ§ãƒ–çµ‚äº†',0),(571568,15877,'pt','Trabalho encerrado',0),(571569,15877,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°ÐºÑ€Ñ‹Ñ‚',0),(571570,15877,'es','Trabajo cerrado',0),(571571,15877,'de','Job geschlossen',0),(571572,15877,'en','Job Closed',0),(571573,15878,'is','',0),(571574,15878,'dr','Ú©Ø§Ø± ÙØ±ÙˆØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(571575,15878,'pr','Ú©Ø§Ø± ÙØ±ÙˆØ´ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(571576,15878,'tr','Ä°ÅŸ satÄ±ÅŸ bilgileri',0),(571577,15878,'pl','SprzedaÅ¼y informacje o zadaniu',0),(571578,15878,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(571579,15878,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ø³ÛŒÙ„Ø² Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(571580,15878,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð˜Ð½Ñ„Ð¾',0),(571581,15878,'vi','ThÃ´ng tin viá»‡c lÃ m bÃ¡n hÃ ng',0),(571582,15878,'af','Werk verkope Info',0),(571583,15878,'ro','Job vanzari Info',0),(571584,15878,'et','TÃ¶Ã¶ mÃ¼Ã¼gi Info',0),(571585,15878,'si','Delo prodajnih Info',0),(571586,15878,'ba','Info pekerjaan penjualan',0),(571587,15878,'nl','Baan verkoop Info',0),(571588,15878,'fi','Job myynti Info',0),(571589,15878,'no','Jobb salg Info',0),(571590,15878,'da','Job salget Info',0),(571591,15878,'ko','ì¼ íŒë§¤ ì •ë³´',0),(571592,15878,'he','×¢×‘×•×“×” ×¤×¨×˜×™ ×ž×›×™×¨×•×ª',0),(571593,15878,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(571594,15878,'zh','é”€å”®æ‹›è˜ä¿¡æ¯',0),(571595,15878,'sv','Jobb fÃ¶rsÃ¤ljning information',0),(571596,15878,'it','Info vendita lavoro',0),(571597,15878,'tl','',0),(571598,15878,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‡à¸²à¸™à¸‚à¸²à¸¢',0),(571599,15878,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(571600,15878,'ms','Info jualan kerja',0),(571601,15878,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(571602,15878,'fr','Emploi Info vente',0),(571603,15878,'jp','æ±‚äººè²©å£²æƒ…å ±',0),(571604,15878,'pt','Emprego vendas informaÃ§Ã£o',0),(571605,15878,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(571606,15878,'es','Trabajo ventas Info',0),(571607,15878,'de','Job Verkauf Info',0),(571608,15878,'en','Job Sales Info',0),(571609,15879,'is','',0),(571610,15879,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª',0),(571611,15879,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª',0),(571612,15879,'tr','Son Ã¶deme',0),(571613,15879,'pl','Ostatniej pÅ‚atnoÅ›ci',0),(571614,15879,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(571615,15879,'ur','Ø¢Ø®Ø±ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(571616,15879,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(571617,15879,'vi','Thanh toÃ¡n qua',0),(571618,15879,'af','Laaste betaling',0),(571619,15879,'ro','Ultima platÄƒ',0),(571620,15879,'et','Viimane makse',0),(571621,15879,'si','Zadnjega plaÄila',0),(571622,15879,'ba','Pembayaran terakhir',0),(571623,15879,'nl','Laatste betaling',0),(571624,15879,'fi','Viimeinen maksu',0),(571625,15879,'no','Siste betaling',0),(571626,15879,'da','Sidste betaling',0),(571627,15879,'ko','ë§ˆì§€ë§‰ ê²°ì œ',0),(571628,15879,'he','×”×ª×©×œ×•× ×”××—×¨×•×Ÿ',0),(571629,15879,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®',0),(571630,15879,'zh','æœ€åŽä¸€æ¬¡ä»˜æ¬¾',0),(571631,15879,'sv','Sista utbetalningen',0),(571632,15879,'it','Ultimo pagamento',0),(571633,15879,'tl','',0),(571634,15879,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸«à¸¥à¸±à¸‡à¸ªà¸¸à¸”',0),(571635,15879,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(571636,15879,'ms','Tarikh pembayaran',0),(571637,15879,'ar','Ø§Ù„Ø¯ÙØ¹Ø© Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(571638,15879,'fr','Dernier paiement',0),(571639,15879,'jp','æœ€å¾Œã®æ”¯æ‰•ã„',0),(571640,15879,'pt','Ãšltimo pagamento',0),(571641,15879,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(571642,15879,'es','Ãšltimo pago',0),(571643,15879,'de','Letzte Zahlung',0),(571644,15879,'en','Last Payment',0),(571645,15880,'is','',0),(571646,15880,'dr','Ø¢Ø®Ø±ÛŒÙ† ÙØ±ÙˆØ´',0),(571647,15880,'pr','Ø¢Ø®Ø±ÛŒÙ† ÙØ±ÙˆØ´',0),(571648,15880,'tr','Son satÄ±ÅŸ',0),(571649,15880,'pl','Ostatnia sprzedaÅ¼',0),(571650,15880,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(571651,15880,'ur','Ø¢Ø®Ø±ÛŒ ÙØ±ÙˆØ®Øª Û”',0),(571652,15880,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð°',0),(571653,15880,'vi','Cuá»‘i cÃ¹ng bÃ¡n',0),(571654,15880,'af','Laaste verkoop',0),(571655,15880,'ro','Ultima vÃ¢nzare',0),(571656,15880,'et','Viimane mÃ¼Ã¼k',0),(571657,15880,'si','Zadnji prodajo',0),(571658,15880,'ba','Dijual terakhir',0),(571659,15880,'nl','Laatste verkoop',0),(571660,15880,'fi','Viimeinen myynti',0),(571661,15880,'no','Siste salg',0),(571662,15880,'da','Sidste salg',0),(571663,15880,'ko','ë§ˆì§€ë§‰ íŒë§¤',0),(571664,15880,'he','×ž×›×™×¨×” ××—×¨×•× ×”',0),(571665,15880,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Ï€ÏŽÎ»Î·ÏƒÎ·',0),(571666,15880,'zh','åŽ»å¹´é”€å”®',0),(571667,15880,'sv','Senaste fÃ¶rsÃ¤ljning',0),(571668,15880,'it','Ultima vendita',0),(571669,15880,'tl','',0),(571670,15880,'th','à¸‚à¸²à¸¢à¸„à¸£à¸±à¹‰à¸‡à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(571671,15880,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(571672,15880,'ms','Lepas jualan',0),(571673,15880,'ar','Ø¨ÙŠØ¹ Ø¢Ø®Ø±',0),(571674,15880,'fr','DerniÃ¨re vente',0),(571675,15880,'jp','æœ€å¾Œã®è²©å£²',0),(571676,15880,'pt','Ãšltima venda',0),(571677,15880,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(571678,15880,'es','Ãšltima venta',0),(571679,15880,'de','Letzter Verkauf',0),(571680,15880,'en','Last Sale',0),(571681,15881,'is','',0),(571682,15881,'dr','Ù†Ù‡ Prelimable',0),(571683,15881,'pr','Ù†Ù‡ Prelimable',0),(571684,15881,'tr','DeÄŸil Prelimable',0),(571685,15881,'pl','Nie Prelimable',0),(571686,15881,'bg','ÐÐµ Prelimable',0),(571687,15881,'ur','Ù†ÛÛŒÚº Ù¾Ø±ÛŒÙ„Ø§Ù…Ø¨Ù„ÛŒ',0),(571688,15881,'sr','ÐÐµ ÐŸÑ€ÐµÐ»Ð¸Ð¼Ð°Ð±Ð»Ðµ',0),(571689,15881,'vi','KhÃ´ng Prelimable',0),(571690,15881,'af','Nie Prelimable',0),(571691,15881,'ro','Nu Prelimable',0),(571692,15881,'et','Ei Prelimable',0),(571693,15881,'si','Ne Prelimable',0),(571694,15881,'ba','Tidak Prelimable',0),(571695,15881,'nl','Niet Prelimable',0),(571696,15881,'fi','Ei Prelimable',0),(571697,15881,'no','Ikke Prelimable',0),(571698,15881,'da','Ikke Prelimable',0),(571699,15881,'ko','í•˜ì§€ Prelimable',0),(571700,15881,'he','×œ× Prelimable',0),(571701,15881,'el','Î”ÎµÎ½ Prelimable',0),(571702,15881,'zh','ä¸ Prelimable',0),(571703,15881,'sv','Inte Prelimable',0),(571704,15881,'it','Non Prelimable',0),(571705,15881,'tl','',0),(571706,15881,'th','à¹„à¸¡à¹ˆ Prelimable',0),(571707,15881,'hi','à¤¨à¤¹à¥€à¤‚ Prelimable',0),(571708,15881,'ms','Tidak Prelimable',0),(571709,15881,'ar','Ù„Ø§ Ø¨Ø±ÙŠÙ„ÙŠÙ…Ø§Ø¨Ù„',0),(571710,15881,'fr','Pas Prelimable',0),(571711,15881,'jp','ãªã„ Prelimable',0),(571712,15881,'pt','NÃ£o Prelimable',0),(571713,15881,'ru','ÐÐµ Prelimable',0),(571714,15881,'es','No Prelimable',0),(571715,15881,'de','Nicht Prelimable',0),(571716,15881,'en','Not Prelimable',0),(571717,15882,'is','',0),(571718,15882,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø²Ù…ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ú©Ø§Ø±',0),(571719,15882,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø²Ù…ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ú©Ø§Ø±',0),(571720,15882,'tr','Ä°ÅŸ alanlarÄ± gizle',0),(571721,15882,'pl','UkryÄ‡ pola pracy',0),(571722,15882,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ð¾Ð»ÐµÑ‚Ð°',0),(571723,15882,'ur','Ú©Ø§Ù… Ù‚Ø·Ø¹Ø§Øª Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(571724,15882,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ð¿Ð¾ÑÐ°Ð¾ Ð¿Ð¾Ñ™Ð°',0),(571725,15882,'vi','áº¨n cÃ¡c lÄ©nh vá»±c cÃ´ng viá»‡c',0),(571726,15882,'af','Versteek werk velde',0),(571727,15882,'ro','Ascunde cÃ¢mpurile de Job',0),(571728,15882,'et','Peida tÃ¶Ã¶ vÃ¤ljad',0),(571729,15882,'si','Skrivanje delovnih podroÄjih',0),(571730,15882,'ba','Menyembunyikan bidang pekerjaan',0),(571731,15882,'nl','Baan velden verbergen',0),(571732,15882,'fi','Piilota tyÃ¶-kentÃ¤t',0),(571733,15882,'no','Skjule jobb felt',0),(571734,15882,'da','Skjule Job felter',0),(571735,15882,'ko','ìž‘ì—… í•„ë“œ ìˆ¨ê¸°ê¸°',0),(571736,15882,'he','×œ×”×¡×ª×™×¨ ×©×“×•×ª ×”×¢×‘×•×“×”',0),(571737,15882,'el','Î‘Ï€Î¿ÎºÏÏÏˆÎµÏ„Îµ Ï€ÎµÎ´Î¯Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(571738,15882,'zh','éšè—å·¥ä½œé¢†åŸŸ',0),(571739,15882,'sv','DÃ¶lja jobb fÃ¤lt',0),(571740,15882,'it','Nascondere i campi di lavoro',0),(571741,15882,'tl','',0),(571742,15882,'th','à¸‹à¹ˆà¸­à¸™à¹€à¸‚à¸•à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‡à¸²à¸™',0),(571743,15882,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤›à¥à¤ªà¤¾à¤à¤',0),(571744,15882,'ms','Sembunyi bidang kerja',0),(571745,15882,'ar','Ø¥Ø®ÙØ§Ø¡ Ø§Ù„Ø­Ù‚ÙˆÙ„ Ø§Ù„Ù…Ù‡Ù…Ø©',0),(571746,15882,'fr','Masquer les champs de lâ€™emploi',0),(571747,15882,'jp','ä»•äº‹ã®ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(571748,15882,'pt','Ocultar campos de trabalho',0),(571749,15882,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð»ÐµÐ¹',0),(571750,15882,'es','Ocultar los campos de trabajo',0),(571751,15882,'de','Job-Felder ausblenden',0),(571752,15882,'en','Hide Job Fields',0),(571753,15883,'is','',0),(571754,15883,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±',0),(571755,15883,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø±',0),(571756,15883,'tr','GeÃ§erli faturaya Uygula',0),(571757,15883,'pl','Zastosowanie do bieÅ¼Ä…cej faktury',0),(571758,15883,'bg','ÐŸÑ€Ð¸Ð»Ð¾Ð¶Ð¸ ÐºÑŠÐ¼ Ñ‚ÐµÐºÑƒÑ‰Ð°Ñ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(571759,15883,'ur','Ø­Ø§Ù„ÛŒÛ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ú©Ùˆ Ù„Ú¯Ø§Ø¦ÛŒÚº',0),(571760,15883,'sr','Ð”Ð° Ð·Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(571761,15883,'vi','Ãp dá»¥ng cho hiá»‡n táº¡i hÃ³a Ä‘Æ¡n',0),(571762,15883,'af','Van toepassing op die huidige faktuur',0),(571763,15883,'ro','Aplica la factura de curent',0),(571764,15883,'et','Rakenda praeguse arve',0),(571765,15883,'si','Uporabi trenutni raÄun',0),(571766,15883,'ba','Berlaku untuk faktur saat ini',0),(571767,15883,'nl','Huidige factuur toepassen',0),(571768,15883,'fi','Sovellettava nykyisen laskun',0),(571769,15883,'no','Gjelde for gjeldende faktura',0),(571770,15883,'da','GÃ¦lde for aktuelle faktura',0),(571771,15883,'ko','í˜„ìž¬ ì†¡ìž¥ì— ì ìš©',0),(571772,15883,'he','×œ×”×—×™×œ ×¢×œ ×”×—×©×‘×•× ×™×ª ×”× ×•×›×—×™×ª',0),(571773,15883,'el','Î™ÏƒÏ‡ÏÎ¿Ï…Î½ Î³Î¹Î± Ï„Î·Î½ Ï„ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(571774,15883,'zh','é€‚ç”¨äºŽå½“å‰å‘ç¥¨',0),(571775,15883,'sv','GÃ¤ller fÃ¶r aktuell faktura',0),(571776,15883,'it','Applicare a fattura corrente',0),(571777,15883,'tl','',0),(571778,15883,'th','à¹ƒà¸Šà¹‰à¸à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(571779,15883,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¥‚ à¤•à¤°à¥‡à¤‚',0),(571780,15883,'ms','Memohon invois semasa',0),(571781,15883,'ar','ØªÙ†Ø·Ø¨Ù‚ Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø­Ø§Ù„ÙŠØ©',0),(571782,15883,'fr','Sâ€™appliquent Ã  la facture actuelle',0),(571783,15883,'jp','ç¾åœ¨ã®è«‹æ±‚æ›¸ã«é©ç”¨ã—ã¾ã™ã€‚',0),(571784,15883,'pt','Aplicar a fatura atual',0),(571785,15883,'ru','ÐŸÑ€Ð¸Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ðº Ñ‚ÐµÐºÑƒÑ‰ÐµÐ¹ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(571786,15883,'es','Aplicar a la factura actual',0),(571787,15883,'de','Gelten fÃ¼r laufende Rechnung',0),(571788,15883,'en','Apply To Current Invoice',0),(571789,15884,'is','',0),(571790,15884,'dr','Ø¹Ù„Ø§Ù‚Ù‡ Ø¨Ù‡ Ø´Ø§Ø±Ú˜ Ú†Ú¯ÙˆÙ†Ù‡',0),(571791,15884,'pr','Ø¹Ù„Ø§Ù‚Ù‡ Ø¨Ù‡ Ø´Ø§Ø±Ú˜ Ú†Ú¯ÙˆÙ†Ù‡',0),(571792,15884,'tr','NasÄ±l faiz ÅŸarj',0),(571793,15884,'pl','Jak naliczyÄ‡ odsetki',0),(571794,15884,'bg','ÐÐ°Ñ‡Ð¸ÑÐ»ÑÐ²Ð° Ð»Ð¸Ñ…Ð²Ð° ÐºÐ°Ðº',0),(571795,15884,'ur','Ú©Ø³ Ø·Ø±Ø­ Ø³ÙˆØ¯',0),(571796,15884,'sr','ÐšÐ¾Ð»Ð¸ÐºÐ¾ Ð½Ð°Ð¿Ð»Ð°Ñ›ÑƒÑ˜Ðµ ÐºÐ°Ð¼Ð°Ñ‚Ñƒ',0),(571797,15884,'vi','TÃ­nh lÃ£i suáº¥t nhÆ° tháº¿ nÃ o',0),(571798,15884,'af','Hoe rente hef',0),(571799,15884,'ro','Percepe dobÃ¢nda cum',0),(571800,15884,'et','VÃµta huvi kuidas',0),(571801,15884,'si','Kako zaraÄunati obresti',0),(571802,15884,'ba','Mengenakan bunga bagaimana',0),(571803,15884,'nl','Opladen van belang hoe',0),(571804,15884,'fi','Korkoja miten',0),(571805,15884,'no','Beregne rente hvordan',0),(571806,15884,'da','OpkrÃ¦ve renter hvordan',0),(571807,15884,'ko','ì–´ë–»ê²Œ ì´ìžë¥¼ ì²­êµ¬',0),(571808,15884,'he','×’×•×‘×” ×”×¨×™×‘×™×ª?',0),(571809,15884,'el','Î ÏŽÏ‚ Î½Î± Ï‡ÏÎµÏŽÏƒÎµÎ¹ Ï„ÏŒÎºÎ¿Ï…Ï‚',0),(571810,15884,'zh','å¦‚ä½•æ”¶å–åˆ©æ¯',0),(571811,15884,'sv','Debitera rÃ¤nta hur',0),(571812,15884,'it','Addebitare gli interessi come',0),(571813,15884,'tl','',0),(571814,15884,'th','à¸„à¸´à¸”à¸­à¸±à¸•à¸£à¸²à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¸­à¸¢à¹ˆà¸²à¸‡à¹„à¸£',0),(571815,15884,'hi','à¤•à¥ˆà¤¸à¥‡ à¤¬à¥à¤¯à¤¾à¤œ à¤šà¤¾à¤°à¥à¤œ',0),(571816,15884,'ms','Mengenakan faedah bagaimana',0),(571817,15884,'ar','ØªØ­ØµÙŠÙ„ ÙØ§Ø¦Ø¯Ø© ÙƒÙŠÙ',0),(571818,15884,'fr','Comment charger des intÃ©rÃªts',0),(571819,15884,'jp','ã©ã®ã‚ˆã†ã«åˆ©å­ã—ã¾ã™ã€‚',0),(571820,15884,'pt','Cobrar juros como',0),(571821,15884,'ru','ÐšÐ°Ðº Ð½Ð°Ñ‡Ð¸ÑÐ»ÑÑ‚ÑŒ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹',0),(571822,15884,'es','Cobran intereses cÃ³mo',0),(571823,15884,'de','Zinsen wie',0),(571824,15884,'en','Charge Interest How',0),(571825,15885,'is','',0),(571826,15885,'dr','Ø§ÛŒØ¬Ø§Ø¯ ÙØ§Ú©ØªÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(571827,15885,'pr','Ø§ÛŒØ¬Ø§Ø¯ ÙØ§Ú©ØªÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(571828,15885,'tr','Yeni Fatura oluÅŸtur',0),(571829,15885,'pl','UtworzyÄ‡ nowÄ… fakturÄ™',0),(571830,15885,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(571831,15885,'ur','Ù†Ø¦Û’ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(571832,15885,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(571833,15885,'vi','Táº¡o hÃ³a Ä‘Æ¡n má»›i',0),(571834,15885,'af','Skep \'n nuwe faktuur',0),(571835,15885,'ro','Crea noi factura',0),(571836,15885,'et','Uue arve loomiseks',0),(571837,15885,'si','Ustvarite nov raÄun',0),(571838,15885,'ba','Membuat faktur baru',0),(571839,15885,'nl','Nieuwe factuur maken',0),(571840,15885,'fi','Luo uusi lasku',0),(571841,15885,'no','Opprette ny faktura',0),(571842,15885,'da','Opret ny faktura',0),(571843,15885,'ko','ìƒˆ ì†¡ìž¥ ë§Œë“¤ê¸°',0),(571844,15885,'he','×¦×•×¨ ×—×©×‘×•× ×™×ª ×—×“×©×”',0),(571845,15885,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î½Î­Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(571846,15885,'zh','åˆ›å»ºæ–°å‘ç¥¨',0),(571847,15885,'sv','Skapa en ny faktura',0),(571848,15885,'it','Creare nuova fattura',0),(571849,15885,'tl','',0),(571850,15885,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸«à¸¡à¹ˆ',0),(571851,15885,'hi','à¤¨à¤¯à¤¾ à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤¬à¤¨à¤¾à¤à¤',0),(571852,15885,'ms','Mencipta invois baru',0),(571853,15885,'ar','Ø¥Ù†Ø´Ø§Ø¡ ÙØ§ØªÙˆØ±Ø© Ø¬Ø¯ÙŠØ¯Ø©',0),(571854,15885,'fr','CrÃ©er facture',0),(571855,15885,'jp','æ–°ã—ã„è«‹æ±‚æ›¸ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(571856,15885,'pt','Criar nova fatura',0),(571857,15885,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ ÑÑ‡ÐµÑ‚',0),(571858,15885,'es','Crear nueva factura',0),(571859,15885,'de','Neue Rechnung erstellen',0),(571860,15885,'en','Create New Invoice',0),(571861,15886,'is','',0),(571862,15886,'dr','Ù…Ø´Ø§ØºÙ„ Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(571863,15886,'pr','Ù…Ø´Ø§ØºÙ„ Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(571864,15886,'tr','Ä°ÅŸleri mÃ¼ÅŸteri olmalÄ±dÄ±r',0),(571865,15886,'pl','Praca musi mieÄ‡ klienta zestaw',0),(571866,15886,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸Ñ‚Ðµ Ð¼ÐµÑÑ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½Ð°Ð±Ð¾Ñ€ Ð¾Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(571867,15886,'ur','Ø±ÙˆØ²Ú¯Ø§Ø± Ú©Û’ Ù…ÙˆØ§Ù‚Ø¹ Ú©Ø³Ù¹Ù…Ø± Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(571868,15886,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð¼Ð¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° ÐºÑƒÐ¿Ñ†Ð° Ð¡ÐµÑ‚',0),(571869,15886,'vi','CÃ¡c cÃ´ng viá»‡c pháº£i cÃ³ khÃ¡ch hÃ ng thiáº¿t láº­p',0),(571870,15886,'af','Werksgeleenthede moet kliÃ«nt stel het',0),(571871,15886,'ro','Locuri de muncÄƒ trebuie sÄƒ fie stabilit de client',0),(571872,15886,'et','TÃ¶Ã¶kohad peavad olema kliendi',0),(571873,15886,'si','Delovna mesta morajo stranke nabor',0),(571874,15886,'ba','Pekerjaan yang harus memiliki pelanggan Set',0),(571875,15886,'nl','Banen moeten klant Set',0),(571876,15886,'fi','TyÃ¶paikkoja on asiakkaan',0),(571877,15886,'no','Jobber mÃ¥ kunden sett',0),(571878,15886,'da','Arbejdspladser skal Have kunde sÃ¦t',0),(571879,15886,'ko','ìž‘ì—… ê³ ê° ì„¤ì •ì„ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(571880,15886,'he','×¢×‘×•×“×•×ª ×—×™×™×‘ ×œ×”×™×•×ª ×§×‘×•×¦×ª ×œ×§×•×—×•×ª',0),(571881,15886,'el','Î˜Î­ÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡Î¿Ï…Î½ ÏƒÏÎ½Î¿Î»Î¿ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(571882,15886,'zh','ä½œä¸šå¿…é¡»å…·æœ‰å®¢æˆ·ç»„',0),(571883,15886,'sv','Jobben mÃ¥ste kunden Set',0),(571884,15886,'it','I lavori devono avere Set di cliente',0),(571885,15886,'tl','',0),(571886,15886,'th','à¸‡à¸²à¸™à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸Šà¸¸à¸”à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(571887,15886,'hi','à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¤¾à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(571888,15886,'ms','Pekerjaan mestilah mempunyai Set Baca',0),(571889,15886,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ ÙˆØ¸Ø§Ø¦Ù Ù…Ø¬Ù…ÙˆØ¹Ø© Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(571890,15886,'fr','Emplois doivent Ãªtre dÃ©fini de client',0),(571891,15886,'jp','ä»•äº‹ã¯ã€é¡§å®¢ã®ã‚»ãƒƒãƒˆã‚’æŒã¤å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(571892,15886,'pt','Postos de trabalho devem ter o conjunto de cliente',0),(571893,15886,'ru','Ð Ð°Ð±Ð¾Ñ‡Ð¸Ðµ Ð¼ÐµÑÑ‚Ð° Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð¸Ð¼ÐµÑ‚ÑŒ Ð½Ð°Ð±Ð¾Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(571894,15886,'es','Puestos de trabajo deben tener sistema de cliente',0),(571895,15886,'de','ArbeitsplÃ¤tze mÃ¼ssen Kundengruppe',0),(571896,15886,'en','Jobs Must Have Customer Set',0),(571897,15887,'is','',0),(571898,15887,'dr','Ø­Ø¯Ø§Ú©Ø«Ø± Ø¯Ø±ØµØ¯',0),(571899,15887,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± Ø¯Ø±ØµØ¯',0),(571900,15887,'tr','Max yÃ¼zdesi',0),(571901,15887,'pl','Procent Max',0),(571902,15887,'bg','ÐœÐ°ÐºÑ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚',0),(571903,15887,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ø´Ø±Ø­',0),(571904,15887,'sr','ÐœÐ°x Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚',0),(571905,15887,'vi','Tá»· lá»‡ pháº§n trÄƒm tá»‘i Ä‘a',0),(571906,15887,'af','Maksimum persentasie',0),(571907,15887,'ro','Procentul Max',0),(571908,15887,'et','Max protsent',0),(571909,15887,'si','Max odstotek',0),(571910,15887,'ba','Persentase Max',0),(571911,15887,'nl','Percentage van de Max',0),(571912,15887,'fi','Max prosenttiosuus',0),(571913,15887,'no','Max prosent',0),(571914,15887,'da','Max procentdel',0),(571915,15887,'ko','ìµœëŒ€ ë¹„ìœ¨',0),(571916,15887,'he','×ž×§×¡ ××—×•×–',0),(571917,15887,'el','ÎœÎ­Î³Î¹ÏƒÏ„Î¿ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ',0),(571918,15887,'zh','æœ€å¤§ç™¾åˆ†æ¯”',0),(571919,15887,'sv','Max procentandel',0),(571920,15887,'it','Max percentuale',0),(571921,15887,'tl','',0),(571922,15887,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(571923,15887,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(571924,15887,'ms','Peratusan maksimum',0),(571925,15887,'ar','Ø§Ù„Ù†Ø³Ø¨Ø© Ø§Ù„Ù…Ø¦ÙˆÙŠØ© Ù…Ø§ÙƒØ³',0),(571926,15887,'fr','Pourcentage de Max',0),(571927,15887,'jp','æœ€å¤§å‰²åˆ',0),(571928,15887,'pt','Percentagem de Max',0),(571929,15887,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚ ÐœÐ°ÐºÑ',0),(571930,15887,'es','MÃ¡ximo porcentaje',0),(571931,15887,'de','Max-Prozentsatz',0),(571932,15887,'en','Max Percentage',0),(571933,15888,'is','',0),(571934,15888,'dr','Ø§Ù…ÙˆØ± Ù…Ø§Ù„ÛŒ Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÛŒÙ†Ù‡',0),(571935,15888,'pr','Ø§Ù…ÙˆØ± Ù…Ø§Ù„ÛŒ Ø­Ø¯Ø§Ù‚Ù„ Ù‡Ø²ÛŒÙ†Ù‡',0),(571936,15888,'tr','En az Finans Ã¼creti',0),(571937,15888,'pl','OpÅ‚ata minimalna finansÃ³w',0),(571938,15888,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° Ð¼Ð¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¸',0),(571939,15888,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø®Ø²Ø§Ù†Û ÙÛŒØ³',0),(571940,15888,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¸Ñ˜Ð° Ð½Ð°ÐºÐ½Ð°Ð´Ð°',0),(571941,15888,'vi','Chi phÃ­ tÃ i chÃ­nh tá»‘i thiá»ƒu',0),(571942,15888,'af','Minimum Finansies fooi',0),(571943,15888,'ro','Taxa minimÄƒ Finante',0),(571944,15888,'et','Minimaalse rahastamise tasu',0),(571945,15888,'si','Minimalne Finance pristojbina',0),(571946,15888,'ba','Biaya minimum keuangan',0),(571947,15888,'nl','Minimale financiÃ«le vergoeding',0),(571948,15888,'fi','VÃ¤hintÃ¤Ã¤n rahoituksen maksu',0),(571949,15888,'no','Minimum finans avgift',0),(571950,15888,'da','Minimum Finance gebyr',0),(571951,15888,'ko','ìµœì†Œ ê¸ˆìœµ ìˆ˜ìˆ˜ë£Œ',0),(571952,15888,'he','×”××•×¦×¨ ×ž×™× ×™×ž×•× ×“×ž×™',0),(571953,15888,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î· Ï‡ÏÎ·Î¼Î±Ï„Î¿Î´ÏŒÏ„Î·ÏƒÎ· Î±Î¼Î¿Î¹Î²Î®',0),(571954,15888,'zh','æœ€å°çš„è´¢åŠ¡è´¹ç”¨',0),(571955,15888,'sv','Minsta finans avgift',0),(571956,15888,'it','Costo minimo degli interessi',0),(571957,15888,'tl','',0),(571958,15888,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸—à¸²à¸‡à¸à¸²à¸£à¹€à¸‡à¸´à¸™à¸‚à¸±à¹‰à¸™à¸•à¹ˆà¸³',0),(571959,15888,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤µà¤¿à¤¤à¥à¤¤ à¤¶à¥à¤²à¥à¤•',0),(571960,15888,'ms','Yuran kewangan minimum',0),(571961,15888,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰ Ù…Ù† Ø§Ù„ØªÙ…ÙˆÙŠÙ„',0),(571962,15888,'fr','Frais de financement minimal',0),(571963,15888,'jp','æœ€ä½Žé™ã®è²¡å‹™æ–™é‡‘',0),(571964,15888,'pt','Taxa de financiamento mÃ­nimo',0),(571965,15888,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð² Ð¿Ð»Ð°Ñ‚Ð°',0),(571966,15888,'es','Cargo por financiamiento mÃ­nimo',0),(571967,15888,'de','Minimale Finanzierung GebÃ¼hr',0),(571968,15888,'en','Minimum Finance Fee',0),(571969,15889,'is','',0),(571970,15889,'dr','Ù†Ù…Ø§ÛŒØ´ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ Ø¯Ø± Ø¬Ø¹Ø¨Ù‡ Ú©Ø§Ù…Ù„ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(571971,15889,'pr','Ù†Ù…Ø§ÛŒØ´ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ Ø¯Ø± Ø¬Ø¹Ø¨Ù‡ Ú©Ø§Ù…Ù„ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(571972,15889,'tr','MÃ¼ÅŸteri kodu otomatik komple kutularÄ±nda gÃ¶ster',0),(571973,15889,'pl','PokaÅ¼ kod klienta w polach kompletne Auto',0),(571974,15889,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ñ‚ ÐºÐ¾Ð´ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð² Ð°Ð²Ñ‚Ð¾ Ð¿ÑŠÐ»Ð½Ð° ÐºÑƒÑ‚Ð¸Ð¸',0),(571975,15889,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆÚˆ Ø®ÙˆØ¯ Ù…Ú©Ù…Ù„ Ø®Ø§Ù†ÙˆÚº Ù…ÛŒÚº Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(571976,15889,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ ÑˆÐ¸Ñ„Ñ€Ñƒ ÐºÑƒÐ¿Ñ†Ð° Ñƒ ÐÑƒÑ‚Ð¾ ÐºÐ¾Ð¼Ð¿Ð»ÐµÑ‚Ð°Ð½ ÐºÑƒÑ‚Ð¸Ñ˜Ðµ',0),(571977,15889,'vi','Hiá»ƒn thá»‹ khÃ¡ch hÃ ng mÃ£ trong há»™p tá»± Ä‘á»™ng hoÃ n thÃ nh',0),(571978,15889,'af','KliÃ«nt kode In outomatiese voltooi bokse wys',0),(571979,15889,'ro','AratÄƒ codul clientului Ã®n boxe Auto complet',0),(571980,15889,'et','NÃ¤ita kliendi kood Auto tÃ¤ielik kastides',0),(571981,15889,'si','PrikaÅ¾i kupca v Auto popolna polja',0),(571982,15889,'ba','Tampilkan kode pelanggan di Auto lengkap kotak',0),(571983,15889,'nl','Toon klantcode In Auto volledige vakken',0),(571984,15889,'fi','NÃ¤ytÃ¤ asiakkaan koodin automaattinen tÃ¤ydellinen laatikot',0),(571985,15889,'no','Vis kunde i Auto komplett bokser',0),(571986,15889,'da','Vis kunde kode i Auto komplet kasser',0),(571987,15889,'ko','ê³ ê° ì½”ë“œ ìžë™ ì™„ì„± ìƒìžì— í‘œì‹œ',0),(571988,15889,'he','×”×¦×’ ×§×•×“ ×”×œ×§×•×— ×‘×ª×™×‘×•×ª ×œ×”×©×œ×™× ××•×˜×•×ž×˜×™×ª',0),(571989,15889,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎºÏŽÎ´Î¹ÎºÎ± Ï€ÎµÎ»Î¬Ï„Î· ÏƒÎµ ÎºÎ¿Ï…Ï„Î¹Î¬ Ï€Î»Î®ÏÎ· Auto',0),(571990,15889,'zh','åœ¨è‡ªåŠ¨å®Œæˆæ¡†ä¸­æ˜¾ç¤ºå®¢æˆ·ä»£ç ',0),(571991,15889,'sv','Visa kund koden i Auto komplett rutor',0),(571992,15889,'it','Visualizza il codice cliente a scatole Complete Auto',0),(571993,15889,'tl','',0),(571994,15889,'th','à¹à¸ªà¸”à¸‡à¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸²à¹ƒà¸™à¸à¸¥à¹ˆà¸­à¸‡à¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œà¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(571995,15889,'hi','à¤¸à¥à¤µà¤¤: à¤ªà¥‚à¤°à¥à¤£ à¤¬à¤•à¥à¤¸à¥‹à¤‚ à¤®à¥‡à¤‚ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹à¤¡ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(571996,15889,'ms','Menunjukkan kod Baca dalam kotak lengkap Auto',0),(571997,15889,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø© Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ù„Ù„Ø¹Ù…ÙŠÙ„ ÙÙŠ ØµÙ†Ø§Ø¯ÙŠÙ‚ Ø§Ù„Ø³ÙŠØ§Ø±Ø§Øª ÙƒØ§Ù…Ù„Ø©',0),(571998,15889,'fr','Voir la clientÃ¨le Code HTML complÃ¨te dans Auto',0),(571999,15889,'jp','è‡ªå‹•å®Œå…¨ãªãƒœãƒƒã‚¯ã‚¹ã§é¡§å®¢ã‚³ãƒ¼ãƒ‰ã‚’ç´¹ä»‹ã—ã¾ã™ã€‚',0),(572000,15889,'pt','Mostrar o cÃ³digo do cliente em caixas completa de Auto',0),(572001,15889,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ¾Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð² Ð°Ð²Ñ‚Ð¾ Ð¿Ð¾Ð»Ð½Ñ‹Ð¹ ÐºÐ¾Ñ€Ð¾Ð±Ð¾Ðº',0),(572002,15889,'es','Mostrar el cÃ³digo de cliente en cajas completas de Auto',0),(572003,15889,'de','Kundencode In Auto komplette Boxen anzeigen',0),(572004,15889,'en','Show Customer Code In Auto Complete Boxes',0),(572005,15890,'is','',0),(572006,15890,'dr','Ø®Ù„Ø§ØµÙ‡ Ø¹Ù„Ø§Ù‚Ù‡ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ø¯Ø± Ø¨ÛŒØ§Ù†ÛŒÙ‡',0),(572007,15890,'pr','Ø®Ù„Ø§ØµÙ‡ Ø¹Ù„Ø§Ù‚Ù‡ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ø¯Ø± Ø¨ÛŒØ§Ù†ÛŒÙ‡',0),(572008,15890,'tr','Show faiz Ã–zet ekstresi',0),(572009,15890,'pl','PokaÅ¼ podsumowanie interesu na oÅ›wiadczenie',0),(572010,15890,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð° Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(572011,15890,'ur','Ø³ÙˆØ¯ Ú©Ø§ Ø®Ù„Ø§ØµÛ Ø¨ÛŒØ§Ù† Ù¾Ø± Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(572012,15890,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ€ÐµÐ·Ð¸Ð¼Ðµ ÐºÐ°Ð¼Ð°Ñ‚Ðµ Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(572013,15890,'vi','TÃ³m táº¯t quan tÃ¢m Hiá»ƒn thá»‹ trÃªn báº£ng sao kÃª',0),(572014,15890,'af','Rente-opsomming wys op stelling',0),(572015,15890,'ro','AratÄƒ interes rezumat pe declaraÅ£ia',0),(572016,15890,'et','NÃ¤ita huvi KokkuvÃµte vÃ¤ljavÃµttel',0),(572017,15890,'si','PrikaÅ¾i Povzetek obresti na izkaz',0),(572018,15890,'ba','Tampilkan Rangkuman bunga pada pernyataan',0),(572019,15890,'nl','Toon belangstelling samenvatting over de verklaring van',0),(572020,15890,'fi','NÃ¤ytÃ¤ kiinnostusta Yhteenveto tiliotteessa',0),(572021,15890,'no','Vis interesse sammendrag pÃ¥ utdrag',0),(572022,15890,'da','Vis interesse ResumÃ© pÃ¥ erklÃ¦ring',0),(572023,15890,'ko','ë¬¸ì— ê´€ì‹¬ ìš”ì•½ í‘œì‹œ',0),(572024,15890,'he','×”×¦×’ ×ª×§×¦×™×¨ ×¨×™×‘×™×ª ×¢×œ ×”×”×¦×”×¨×”',0),(572025,15890,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï„Î·Ï‚ ÏƒÏÎ½Î¿ÏˆÎ·Ï‚ ÏƒÎµ Î´Î®Î»Ï‰ÏƒÎ· ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½Ï„Î¿Ï‚',0),(572026,15890,'zh','è¯­å¥æ˜¾ç¤ºå…´è¶£æ‘˜è¦',0),(572027,15890,'sv','Visa intresse sammanfattning pÃ¥ kontoutdrag',0),(572028,15890,'it','Mostrare interesse riepilogo sul conto',0),(572029,15890,'tl','',0),(572030,15890,'th','à¹à¸ªà¸”à¸‡à¸ªà¸£à¸¸à¸›à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¹ƒà¸™à¸‡à¸š',0),(572031,15890,'hi','à¤¬à¤¯à¤¾à¤¨ à¤ªà¤° à¤¬à¥à¤¯à¤¾à¤œ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(572032,15890,'ms','Menunjukkan ringkasan kepentingan penyata',0),(572033,15890,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ù…Ù„Ø®Øµ Ø§Ù„ÙØ§Ø¦Ø¯Ø© ÙÙŠ Ø¨ÙŠØ§Ù†',0),(572034,15890,'fr','Afficher la synthÃ¨se intÃ©rÃªt sur dÃ©claration',0),(572035,15890,'jp','æ˜Žç´°æ›¸ã«é–¢å¿ƒã®æ¦‚è¦ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(572036,15890,'pt','Resumo de mostrar interesse na declaraÃ§Ã£o',0),(572037,15890,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ Ñ€ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð° Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(572038,15890,'es','Ver Resumen de interÃ©s en estado de',0),(572039,15890,'de','Zeigen Sie Interesse Zusammenfassung auf Anweisung',0),(572040,15890,'en','Show Interest Summary On Statement',0),(572041,15891,'is','',0),(572042,15891,'dr','Write-offs',0),(572043,15891,'pr','Write-offs',0),(572044,15891,'tr','Off',0),(572045,15891,'pl','Umorzenia naleÅ¼noÅ›ci',0),(572046,15891,'bg','ÐžÑ‚Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(572047,15891,'ur','Write-offs',0),(572048,15891,'sr','ÐžÑ‚Ð¿Ð¸ÑÐ°',0),(572049,15891,'vi','Write-offs',0),(572050,15891,'af','Afskrywings',0),(572051,15891,'ro','Amortizare',0),(572052,15891,'et','Mahakantud laenud',0),(572053,15891,'si','Odpisi',0),(572054,15891,'ba','Penghapusan',0),(572055,15891,'nl','Afschrijvingen',0),(572056,15891,'fi','Arvonalentumiset',0),(572057,15891,'no','Avskrivninger normalperiodene',0),(572058,15891,'da','Afskrivninger',0),(572059,15891,'ko','ì‚­ì œ',0),(572060,15891,'he','×›×ª×™×‘×” offs',0),(572061,15891,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î­Ï‚',0),(572062,15891,'zh','æ³¨é”€',0),(572063,15891,'sv','Bortskrivningar',0),(572064,15891,'it','Write-Off',0),(572065,15891,'tl','',0),(572066,15891,'th','à¸•à¸±à¸”',0),(572067,15891,'hi','à¤²à¤¿à¤–à¤¨à¥‡-à¤¨à¤¾à¤ªà¤¸à¤‚à¤¦',0),(572068,15891,'ms','Pelupusan',0),(572069,15891,'ar','Ø¹Ù…Ù„ÙŠØ§Øª Ø§Ù„Ø´Ø·Ø¨',0),(572070,15891,'fr','Radiations',0),(572071,15891,'jp','å„Ÿå´',0),(572072,15891,'pt','Write-offs',0),(572073,15891,'ru','Ð¡Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(572074,15891,'es','Cancelaciones de la',0),(572075,15891,'de','Abschreibungen',0),(572076,15891,'en','Write-offs',0),(572077,15892,'is','',0),(572078,15892,'dr','Chargeback',0),(572079,15892,'pr','Chargeback',0),(572080,15892,'tr','Ters ibraz',0),(572081,15892,'pl','ObciÄ…Å¼enie zwrotne',0),(572082,15892,'bg','Ð‘Ð°Ðº',0),(572083,15892,'ur','Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú©',0),(572084,15892,'sr','Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº',0),(572085,15892,'vi','Tiá»n chiáº¿t kháº¥u',0),(572086,15892,'af','Chargeback',0),(572087,15892,'ro','Chargeback',0),(572088,15892,'et','SissenÃµudmine',0),(572089,15892,'si','PoraÄuna',0),(572090,15892,'ba','Chargeback',0),(572091,15892,'nl','Terugboeking',0),(572092,15892,'fi','TakaisinperinnÃ¤n',0),(572093,15892,'no','TilbakefÃ¸ring',0),(572094,15892,'da','TilbagefÃ¸rsel',0),(572095,15892,'ko','í™˜ë¶ˆ',0),(572096,15892,'he','×”×—×™×•×‘',0),(572097,15892,'el','Chargeback',0),(572098,15892,'zh','å­˜å‚¨å®¹é‡ä½¿ç”¨è®¡è´¹',0),(572099,15892,'sv','Chargeback',0),(572100,15892,'it','Chargeback',0),(572101,15892,'tl','',0),(572102,15892,'th','à¸›à¸à¸´à¹€à¸ªà¸˜à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(572103,15892,'hi','à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤•',0),(572104,15892,'ms','Caj semula',0),(572105,15892,'ar','ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(572106,15892,'fr','Chargeback',0),(572107,15892,'jp','ãƒãƒ£ãƒ¼ã‚¸ ãƒãƒƒã‚¯',0),(572108,15892,'pt','Chargeback',0),(572109,15892,'ru','Ð§Ð°Ñ€Ð´Ð¶Ð±ÐµÐº',0),(572110,15892,'es','Cargo al usuario',0),(572111,15892,'de','Chargeback',0),(572112,15892,'en','Chargeback',0),(572113,15893,'is','',0),(572114,15893,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø§ÛŒÙ…ÛŒÙ„ Ù‚Ø§Ù„Ø¨',0),(572115,15893,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø­Ø°Ù Ø§ÛŒÙ…ÛŒÙ„ Ù‚Ø§Ù„Ø¨',0),(572116,15893,'tr','Hata silme posta ÅŸablonu',0),(572117,15893,'pl','BÅ‚Ä…d usuwania szablonu poczty',0),(572118,15893,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ñ‚Ñ€Ð¸Ð²Ð°Ð½Ðµ Ð¿Ð¾Ñ‰Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(572119,15893,'ur','Ù†Ù‚Øµ Ø­Ø°Ù Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Ø§',0),(572120,15893,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð±Ñ€Ð¸ÑÐ°ÑšÑƒ Ð¿Ð¾ÑˆÑ‚Ð° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº',0),(572121,15893,'vi','Lá»—i xÃ³a bá» thÆ° máº«u',0),(572122,15893,'af','Fout met skrapping van e-pos sjabloon',0),(572123,15893,'ro','Eroare ÅŸtergerea Mail ÅŸablon',0),(572124,15893,'et','TÃµrge kustutamisel posti malli',0),(572125,15893,'si','Napaka brisanja Mail predlogo',0),(572126,15893,'ba','Error menghapus E-mail Template',0),(572127,15893,'nl','Fout verwijderen E-mail sjabloon',0),(572128,15893,'fi','Virhe poistettaessa Mail mallia',0),(572129,15893,'no','Feil slette e-mal',0),(572130,15893,'da','Fejl slette E-mail-skabelon',0),(572131,15893,'ko','ì˜¤ë¥˜ ì‚­ì œ ë©”ì¼ ì„œì‹ íŒŒì¼',0),(572132,15893,'he','×©×’×™××” ×‘×ž×—×™×§×ª ×ª×‘× ×™×ª ×“×•××¨',0),(572133,15893,'el','Î£Ï†Î¬Î»Î¼Î± Î”Î¹Î±Î³ÏÎ±Ï†Î® Î±Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î±Ï‚ Ï€ÏÏŒÏ„Ï…Ï€Î¿',0),(572134,15893,'zh','é”™è¯¯åˆ é™¤é‚®ä»¶æ¨¡æ¿',0),(572135,15893,'sv','Misstag utplÃ¥nande postmall',0),(572136,15893,'it','Modello di eliminazione di errore posta',0),(572137,15893,'tl','',0),(572138,15893,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¸à¸²à¸£à¸¥à¸šà¸ˆà¸”à¸«à¸¡à¸²à¸¢à¹à¸¡à¹ˆ',0),(572139,15893,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ',0),(572140,15893,'ms','Ralat Menghapuskan mel Template',0),(572141,15893,'ar','Ø®Ø·Ø£ ÙÙŠ Ø­Ø°Ù Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯',0),(572142,15893,'fr','Erreur suppression Mail Template',0),(572143,15893,'jp','ã‚¨ãƒ©ãƒ¼å‰Šé™¤ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ',0),(572144,15893,'pt','Modelo de email erro excluindo',0),(572145,15893,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑƒÐ´Ð°Ð»ÐµÐ½Ð¸Ñ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(572146,15893,'es','Plantilla de correo eliminar error',0),(572147,15893,'de','Fehler lÃ¶schen E-Mail-Vorlage',0),(572148,15893,'en','Error Deleting Mail Template',0),(572149,15894,'is','',0),(572150,15894,'dr','Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(572151,15894,'pr','Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø­Ø°Ù',0),(572152,15894,'tr','Posta ÅŸablonu baÅŸarÄ±yla silindi',0),(572153,15894,'pl','Szablonu poczty pomyÅ›lnie',0),(572154,15894,'bg','Ð¨Ð°Ð±Ð»Ð¾Ð½ Ð·Ð° Ð¿Ð¾Ñ‰Ð°, Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(572155,15894,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ø­Ø°Ù Ø´Ø¯Û Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Ø§',0),(572156,15894,'sr','ÐŸÐ¾ÑˆÑ‚Ð° Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½Ðµ',0),(572157,15894,'vi','Máº«u thÆ° Ä‘Ã£ xÃ³a thÃ nh cÃ´ng',0),(572158,15894,'af','E-pos sjabloon suksesvol geskrap',0),(572159,15894,'ro','Åžablon poÅŸtÄƒ electronicÄƒ ÅŸtearsÄƒ cu succes',0),(572160,15894,'et','Mail malli edukalt kustutatud',0),(572161,15894,'si','PoÅ¡ta predlogo uspeÅ¡no izbrisana',0),(572162,15894,'ba','Template pesan dihapus berhasil',0),(572163,15894,'nl','E-mail sjabloon verwijderd',0),(572164,15894,'fi','SÃ¤hkÃ¶postimalli poistettu',0),(572165,15894,'no','E mal slettet',0),(572166,15894,'da','E-mail skabelon slettet',0),(572167,15894,'ko','ë©”ì¼ ì„œì‹ íŒŒì¼ì„ ì„±ê³µì ìœ¼ë¡œ ì‚­ì œ',0),(572168,15894,'he','×ª×‘× ×™×ª ×“×•××¨ × ×ž×—×§ ×‘×”×¦×œ×—×”',0),(572169,15894,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ mail Î´Î¹Î±Î³ÏÎ¬Ï†Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(572170,15894,'zh','å·²æˆåŠŸåˆ é™¤çš„é‚®ä»¶æ¨¡æ¿',0),(572171,15894,'sv','E-postmall raderades',0),(572172,15894,'it','Modello di posta elettronica eliminato con successo',0),(572173,15894,'tl','',0),(572174,15894,'th','à¹à¸¡à¹ˆà¹à¸šà¸šà¸ˆà¸”à¸«à¸¡à¸²à¸¢à¸—à¸µà¹ˆà¸–à¸¹à¸à¸¥à¸šà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(572175,15894,'hi','à¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¹à¤Ÿà¤¾à¤¯à¤¾',0),(572176,15894,'ms','Template mel dihapuskan dengan jayanya',0),(572177,15894,'ar','Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ù…Ø­Ø°ÙˆÙØ© Ø¨Ù†Ø¬Ø§Ø­',0),(572178,15894,'fr','ModÃ¨le de courrier supprimÃ© avec succÃ¨s',0),(572179,15894,'jp','ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã¯æ­£å¸¸ã«å‰Šé™¤ã•ã‚Œã¾ã—ãŸ',0),(572180,15894,'pt','Modelo de email excluÃ­do com sucesso',0),(572181,15894,'ru','Ð¨Ð°Ð±Ð»Ð¾Ð½ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑƒÐ´Ð°Ð»ÐµÐ½Ñ‹',0),(572182,15894,'es','Plantilla de correo eliminado satisfactoriamente',0),(572183,15894,'de','E-Mail-Vorlage wurde erfolgreich gelÃ¶scht',0),(572184,15894,'en','Mail Template Deleted Successfully',0),(572185,15895,'is','',0),(572186,15895,'dr','AP ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø§Ø±Øª',0),(572187,15895,'pr','AP ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø§Ø±Øª',0),(572188,15895,'tr','Bu kart ile Ã¶deme AP faturalarÄ±',0),(572189,15895,'pl','AP rachunki pÅ‚acone z ta karta',0),(572190,15895,'bg','AP Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð¸ Ð¿Ð»Ð°Ñ‚Ð¸Ð»Ð¸ Ñ Ñ‚Ð°Ð·Ð¸ ÐºÐ°Ñ€Ñ‚Ð°',0),(572191,15895,'ur','Ø§Ø³ Ú©Ø§Ø±Úˆ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ AP Ø¨Ù„',0),(572192,15895,'sr','ÐÐŸ Ñ€Ð°Ñ‡ÑƒÐ½Ð° ÐºÐ¾Ñ˜Ðµ ÑÑƒ Ð¿Ð»Ð°Ñ‚Ð¸Ð»Ð¸ ÑÐ° Ð¾Ð²Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(572193,15895,'vi','AP hÃ³a Ä‘Æ¡n thanh toÃ¡n vá»›i tháº» nÃ y',0),(572194,15895,'af','GP rekeninge betaal met hierdie kaart',0),(572195,15895,'ro','AP facturile platite cu acest Card',0),(572196,15895,'et','AP arveid maksta sellelt kaardilt',0),(572197,15895,'si','AP raÄune plaÄa s to kartico',0),(572198,15895,'ba','AP tagihan dibayar dengan kartu',0),(572199,15895,'nl','AP rekeningen betaald met deze kaart',0),(572200,15895,'fi','AP laskut maksetaan tÃ¤mÃ¤n kortin',0),(572201,15895,'no','AP regningene betalt med dette kortet',0),(572202,15895,'da','AP regninger betalt med kortet',0),(572203,15895,'ko','ì´ ì¹´ë“œì™€ í•¨ê»˜ ì§€ë¶ˆ í•˜ëŠ” AP ì²­êµ¬ì„œ',0),(572204,15895,'he','AP ××ª ×”×—×©×‘×•× ×•×ª ×¢× ×›×¨×˜×™×¡',0),(572205,15895,'el','AP Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï„Î¿Ï…Ï‚ Ï€Î»Î®ÏÏ‰ÏƒÎ±Î½ Î¼Îµ Î±Ï…Ï„Î® Ï„Î·Î½ ÎºÎ¬ÏÏ„Î±',0),(572206,15895,'zh','ç”¨è¿™å¼ å¡æ”¯ä»˜çš„ AP æ³•æ¡ˆ',0),(572207,15895,'sv','AP rÃ¤kningar betalda med detta kort',0),(572208,15895,'it','AP fatture pagate con la carta',0),(572209,15895,'tl','',0),(572210,15895,'th','à¸„à¹ˆà¸² AP à¸ˆà¹ˆà¸²à¸¢à¸šà¸±à¸•à¸£à¸™à¸µà¹‰',0),(572211,15895,'hi','AP à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤‡à¤¸ à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤¸à¤¾à¤¥',0),(572212,15895,'ms','AP bil-bil yang dibayar menggunakan Kad ini',0),(572213,15895,'ar','AP Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø© Ù…Ø¹ Ù‡Ø°Ù‡ Ø§Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(572214,15895,'fr','AP factures payÃ©es avec cette carte',0),(572215,15895,'jp','ã“ã®ã‚«ãƒ¼ãƒ‰ã§ AP æ”¯æ‰•ã„',0),(572216,15895,'pt','AP contas pagas com este cartÃ£o',0),(572217,15895,'ru','AP, Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ñ… Ñ ÑÑ‚Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ð¾Ð¹',0),(572218,15895,'es','AP de facturas pagadas con esta tarjeta',0),(572219,15895,'de','AP-Rechnungen bezahlt mit dieser Karte',0),(572220,15895,'en','AP Bills Paid With This Card',0),(572221,15896,'is','',0),(572222,15896,'dr','Ù„Ø§ÛŒØ­Ù‡ Ø¬Ø¯ÛŒØ¯ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(572223,15896,'pr','Ù„Ø§ÛŒØ­Ù‡ Ø¬Ø¯ÛŒØ¯ Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(572224,15896,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ yeni Bill',0),(572225,15896,'pl','Zobacz Nowy Bill',0),(572226,15896,'bg','ÐÐ¾Ð² Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð·Ð° Ð¸Ð·Ð³Ð»ÐµÐ´',0),(572227,15896,'ur','Ù…Ù†Ø¸Ø± Ù†ÛŒØ§ Ø¨Ù„',0),(572228,15896,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð½Ð¾Ð²Ð¾Ð³ Ð·Ð°ÐºÐ¾Ð½Ð°',0),(572229,15896,'vi','Dá»± luáº­t má»›i xem',0),(572230,15896,'af','Bekyk nuwe Wetsontwerp',0),(572231,15896,'ro','Vezi noua lege',0),(572232,15896,'et','Vaade uue seaduseelnÃµu',0),(572233,15896,'si','Ogled novega zakona',0),(572234,15896,'ba','Lihat undang-undang baru',0),(572235,15896,'nl','Weergave nieuwe Bill',0),(572236,15896,'fi','NÃ¤ytÃ¤ uusi tuoterakenne',0),(572237,15896,'no','Vis ny faktura',0),(572238,15896,'da','Se nye lovforslag',0),(572239,15896,'ko','ë³´ê¸° ìƒˆë¡œìš´ ë¹Œ',0),(572240,15896,'he','×”×¦×¢×ª ×”×—×•×§ ×ª×¦×•×’×”',0),(572241,15896,'el','Î”ÎµÎ¯Ï„Îµ Ï„Î¿ Î½Î­Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(572242,15896,'zh','æŸ¥çœ‹æ–°çš„æ¡ä¾‹è‰æ¡ˆ',0),(572243,15896,'sv','Visa nya Bill',0),(572244,15896,'it','Visualizza nuovo fattura',0),(572245,15896,'tl','',0),(572246,15896,'th','à¸”à¸¹à¸ªà¸¹à¸•à¸£à¹ƒà¸«à¸¡à¹ˆ',0),(572247,15896,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ à¤¨à¤¯à¤¾ à¤¬à¤¿à¤²',0),(572248,15896,'ms','Rang undang-undang baru paparan',0),(572249,15896,'ar','Ø¹Ø±Ø¶ Ù…Ø´Ø±ÙˆØ¹ Ù‚Ø§Ù†ÙˆÙ† Ø¬Ø¯ÙŠØ¯',0),(572250,15896,'fr','Affichage des nouvelles nomenclatures',0),(572251,15896,'jp','ãƒ“ãƒ¥ãƒ¼ã®æ–°ã—ã„ãƒ“ãƒ«',0),(572252,15896,'pt','Nova lei de exibiÃ§Ã£o',0),(572253,15896,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð½Ð¾Ð²Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(572254,15896,'es','Ver nuevo factura',0),(572255,15896,'de','Neue Rechnung anzeigen',0),(572256,15896,'en','View New Bill',0),(572257,15897,'is','',0),(572258,15897,'dr','Ø­Ø³Ø§Ø¨ Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø±',0),(572259,15897,'pr','Ø­Ø³Ø§Ø¨ Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø±',0),(572260,15897,'tr','Hesap beklemeye',0),(572261,15897,'pl','Konto zawieszone',0),(572262,15897,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° Ð½Ð° Ð¸Ð·Ñ‡Ð°ÐºÐ²Ð°Ð½Ðµ',0),(572263,15897,'ur','ÛÙˆÙ„Úˆ Ù¾Ø± Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(572264,15897,'sr','Ð Ð°Ñ‡ÑƒÐ½Ð° Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(572265,15897,'vi','TÃ i khoáº£n giá»¯',0),(572266,15897,'af','Rekening op hou',0),(572267,15897,'ro','Cont suspendat',0),(572268,15897,'et','Konto ootele',0),(572269,15897,'si','RaÄun na Äakanju',0),(572270,15897,'ba','Rekening ditahan',0),(572271,15897,'nl','Account in de wacht',0),(572272,15897,'fi','Huomioon pitoon',0),(572273,15897,'no','Kontoen pÃ¥ vent',0),(572274,15897,'da','Konto pÃ¥ Hold',0),(572275,15897,'ko','ê³„ì •ì—',0),(572276,15897,'he','×—×©×‘×•×Ÿ ×‘×”×ž×ª× ×”',0),(572277,15897,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÏƒÎµ Î±Î½Î±Î¼Î¿Î½Î®',0),(572278,15897,'zh','æç½®çš„å¸æˆ·',0),(572279,15897,'sv','Konto pÃ¥ is',0),(572280,15897,'it','Conto in attesa',0),(572281,15897,'tl','',0),(572282,15897,'th','à¸šà¸±à¸à¸Šà¸µà¸„à¸‡à¸„à¹‰à¸²à¸‡',0),(572283,15897,'hi','à¤¹à¥‹à¤²à¥à¤¡ à¤ªà¤° à¤–à¤¾à¤¤à¤¾',0),(572284,15897,'ms','Akaun ditunda',0),(572285,15897,'ar','Ø­Ø³Ø§Ø¨ Ù…Ø¹Ù„Ù‚Ø©',0),(572286,15897,'fr','Compte en attente',0),(572287,15897,'jp','ä¿ç•™ä¸­ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(572288,15897,'pt','Conta em espera',0),(572289,15897,'ru','Ð¡Ñ‡ÐµÑ‚ Ð½Ð° ÑƒÐ´ÐµÑ€Ð¶Ð°Ð½Ð¸Ð¸',0),(572290,15897,'es','Cuenta en espera',0),(572291,15897,'de','Konto gesperrt',0),(572292,15897,'en','Account On Hold',0),(572293,15898,'is','',0),(572294,15898,'dr','Ù†Ø§Ù…Ù‡',0),(572295,15898,'pr','Ù†Ø§Ù…Ù‡',0),(572296,15898,'tr','Mektuplar',0),(572297,15898,'pl','Litery',0),(572298,15898,'bg','ÐŸÐ¸ÑÐ¼Ð°',0),(572299,15898,'ur','Ø®Ø·ÙˆØ·',0),(572300,15898,'sr','ÐŸÐ¸ÑÐ¼Ð°',0),(572301,15898,'vi','Chá»¯ cÃ¡i',0),(572302,15898,'af','Letters',0),(572303,15898,'ro','Scrisori',0),(572304,15898,'et','TÃ¤hed',0),(572305,15898,'si','ÄŒrke',0),(572306,15898,'ba','Surat',0),(572307,15898,'nl','Brieven',0),(572308,15898,'fi','Kirjaimet',0),(572309,15898,'no','Bokstaver',0),(572310,15898,'da','Bogstaver',0),(572311,15898,'ko','íŽ¸ì§€',0),(572312,15898,'he','××•×ª×™×•×ª',0),(572313,15898,'el','Î“ÏÎ¬Î¼Î¼Î±Ï„Î±',0),(572314,15898,'zh','å­—æ¯',0),(572315,15898,'sv','BokstÃ¤ver',0),(572316,15898,'it','Lettere',0),(572317,15898,'tl','',0),(572318,15898,'th','à¸•à¸±à¸§à¸­à¸±à¸à¸©à¸£',0),(572319,15898,'hi','à¤ªà¤¤à¥à¤°',0),(572320,15898,'ms','Surat-Surat',0),(572321,15898,'ar','Ø±Ø³Ø§Ø¦Ù„',0),(572322,15898,'fr','Lettres',0),(572323,15898,'jp','æ–‡å­—',0),(572324,15898,'pt','Letras',0),(572325,15898,'ru','ÐŸÐ¸ÑÑŒÐ¼Ð°',0),(572326,15898,'es','Letras',0),(572327,15898,'de','Briefe',0),(572328,15898,'en','Letters',0),(572329,15899,'is','',0),(572330,15899,'dr','Ø§Ø¸Ù‡Ø§Ø±Ø§Øª',0),(572331,15899,'pr','Ø§Ø¸Ù‡Ø§Ø±Ø§Øª',0),(572332,15899,'tr','Deyimleri',0),(572333,15899,'pl','Instrukcje',0),(572334,15899,'bg','ÐžÑ‚Ñ‡ÐµÑ‚Ð¸',0),(572335,15899,'ur','Ø¨ÛŒØ§Ù†Ø§Øª',0),(572336,15899,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ðµ',0),(572337,15899,'vi','BÃ¡o cÃ¡o',0),(572338,15899,'af','State',0),(572339,15899,'ro','DeclaraÅ£ii',0),(572340,15899,'et','Avaldused',0),(572341,15899,'si','Izjave',0),(572342,15899,'ba','Pernyataan',0),(572343,15899,'nl','Verklaringen',0),(572344,15899,'fi','Lausunnot',0),(572345,15899,'no','Uttalelser',0),(572346,15899,'da','Udtalelser',0),(572347,15899,'ko','ë¬¸',0),(572348,15899,'he','×”×¦×”×¨×•×ª',0),(572349,15899,'el','Î”Î·Î»ÏŽÏƒÎµÎ¹Ï‚',0),(572350,15899,'zh','å£°æ˜Ž',0),(572351,15899,'sv','Uttalanden',0),(572352,15899,'it','Istruzioni',0),(572353,15899,'tl','',0),(572354,15899,'th','à¸‡à¸š',0),(572355,15899,'hi','à¤¬à¤¯à¤¾à¤¨',0),(572356,15899,'ms','Penyata',0),(572357,15899,'ar','Ø¨ÙŠØ§Ù†Ø§Øª',0),(572358,15899,'fr','DÃ©clarations',0),(572359,15899,'jp','ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆ',0),(572360,15899,'pt','DeclaraÃ§Ãµes',0),(572361,15899,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ñ',0),(572362,15899,'es','Declaraciones',0),(572363,15899,'de','Aussagen',0),(572364,15899,'en','Statements',0),(572365,15900,'is','',0),(572366,15900,'dr','ÙØ§Ú©ØªÙˆØ± Ø¨Ù‡Ø±Ù‡',0),(572367,15900,'pr','ÙØ§Ú©ØªÙˆØ± Ø¨Ù‡Ø±Ù‡',0),(572368,15900,'tr','Fatura vade farkÄ±',0),(572369,15900,'pl','Zainteresowanie faktury',0),(572370,15900,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(572371,15900,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø¯Ù„Ú†Ø³Ù¾ÛŒ',0),(572372,15900,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ ÐºÐ°Ð¼Ð°Ñ‚Ðµ',0),(572373,15900,'vi','Quan tÃ¢m Ä‘áº¿n hÃ³a Ä‘Æ¡n',0),(572374,15900,'af','Faktuur rente',0),(572375,15900,'ro','Interes de facturÄƒ',0),(572376,15900,'et','Arve huvi',0),(572377,15900,'si','RaÄuna obresti',0),(572378,15900,'ba','Faktur bunga',0),(572379,15900,'nl','Factuur belang',0),(572380,15900,'fi','Laskuttaa korkoja',0),(572381,15900,'no','Fakturere renter',0),(572382,15900,'da','Faktura interesse',0),(572383,15900,'ko','ì†¡ìž¥ ê´€ì‹¬',0),(572384,15900,'he','×¢× ×™×™×Ÿ ×”×—×©×‘×•× ×™×ª',0),(572385,15900,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï„ÏŒÎºÏ‰Î½',0),(572386,15900,'zh','å‘ç¥¨çš„å…´è¶£',0),(572387,15900,'sv','Fakturan intresse',0),(572388,15900,'it','Interesse di fattura',0),(572389,15900,'tl','',0),(572390,15900,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢',0),(572391,15900,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¬à¥à¤¯à¤¾à¤œ',0),(572392,15900,'ms','Faedah invois',0),(572393,15900,'ar','Ø§Ù„ÙØ§Ø¦Ø¯Ø© Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(572394,15900,'fr','IntÃ©rÃªt de la facture',0),(572395,15900,'jp','è«‹æ±‚ã®åˆ©ç›Š',0),(572396,15900,'pt','Interesse de factura',0),(572397,15900,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸Ð½Ñ‚ÐµÑ€ÐµÑ',0),(572398,15900,'es','InterÃ©s de factura',0),(572399,15900,'de','Rechnung Zinsen',0),(572400,15900,'en','Invoice Interest',0),(572401,15901,'is','',0),(572402,15901,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ù…Ø´ØªØ±Ú© Ø§Ø³Øª',0),(572403,15901,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ù…Ø´ØªØ±Ú© Ø§Ø³Øª',0),(572404,15901,'tr','Ortak kontrol edilir',0),(572405,15901,'pl','Jest wspÃ³lnego wyboru',0),(572406,15901,'bg','Ð• ÑÑŠÐ²Ð¼ÐµÑÑ‚Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(572407,15901,'ur','Ù…Ø´ØªØ±Ú©Û Ú†ÛŒÚ© ÛÛ’',0),(572408,15901,'sr','ÐˆÐµ Ð·Ð°Ñ˜ÐµÐ´Ð½Ð¸Ñ‡ÐºÐ° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(572409,15901,'vi','Kiá»ƒm tra khá»›p',0),(572410,15901,'af','Is gesamentlike tjek',0),(572411,15901,'ro','Este comun, verificÄƒ',0),(572412,15901,'et','On Ã¼hine vÃ¤ljaregistreerimine',0),(572413,15901,'si','Je skupno preverjanje',0),(572414,15901,'ba','Cek bersama',0),(572415,15901,'nl','Gezamenlijke controle',0),(572416,15901,'fi','On yhteinen tarkistaa',0),(572417,15901,'no','Felles sjekk',0),(572418,15901,'da','Er fÃ¦lles Check',0),(572419,15901,'ko','ê³µë™ ê²€ì‚¬',0),(572420,15901,'he','×”×•× ×œ×‘×“×•×§ ×ž×©×•×ª×¤×ª',0),(572421,15901,'el','Î•Î¯Î½Î±Î¹ Î· ÎºÎ¿Î¹Î½Î® ÎµÏ€Î¹Ï„Î±Î³Î®',0),(572422,15901,'zh','è”åˆæ£€æŸ¥',0),(572423,15901,'sv','Ã„r att gemensamt kontrollera',0),(572424,15901,'it','Ãˆ controllo congiunto',0),(572425,15901,'tl','',0),(572426,15901,'th','à¸£à¹ˆà¸§à¸¡à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(572427,15901,'hi','à¤¸à¤‚à¤¯à¥à¤•à¥à¤¤ à¤œà¤¾à¤à¤š à¤¹à¥ˆ',0),(572428,15901,'ms','Menyemak bersama',0),(572429,15901,'ar','Ù‡Ùˆ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø§Ù„Ù…Ø´ØªØ±Ùƒ',0),(572430,15901,'fr','Est de vÃ©rification conjointe',0),(572431,15901,'jp','é–¢ç¯€ã®ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(572432,15901,'pt','Ã‰ comum verificar',0),(572433,15901,'ru','Ð¡Ð¾Ð²Ð¼ÐµÑÑ‚Ð½Ð°Ñ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(572434,15901,'es','Es comÃºn comprobar',0),(572435,15901,'de','Ist der gemeinsame Check',0),(572436,15901,'en','Is Joint Check',0),(572437,15902,'is','',0),(572438,15902,'dr','Ú©Ø¯Ù‡Ø§ÛŒ Chargeback ÛŒØ§ÙØª',0),(572439,15902,'pr','Ú©Ø¯Ù‡Ø§ÛŒ Chargeback ÛŒØ§ÙØª',0),(572440,15902,'tr','HiÃ§bir ters ibraz kodlarÄ± bulundu',0),(572441,15902,'pl','Nie obciÄ…Å¼enia zwrotnego kody Znalezione',0),(572442,15902,'bg','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ ÐºÐ¾Ð´Ð¾Ð²Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸',0),(572443,15902,'ur','Ù…Ù„Û’ Ú©ÙˆØ¦ÛŒ Ú†Ø¢Ø±Ú¯ÛŒØ¨Ø§Ú© Ø±Ù…ÙˆØ²',0),(572444,15902,'sr','ÐÐµÐ¼Ð° Ð¦Ñ…Ð°Ñ€Ð³ÐµÐ±Ð°Ñ†Ðº ÐºÐ¾Ð´Ð¾Ð²Ð° Ð½Ð°ÑˆÐ°Ð¾',0),(572445,15902,'vi','KhÃ´ng cÃ³ mÃ£ sá»‘ tiá»n chiáº¿t kháº¥u Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(572446,15902,'af','Geen Chargeback kodes gevind',0),(572447,15902,'ro','Nici un Chargeback coduri gÄƒsite',0),(572448,15902,'et','Leitud sissenÃµudmine koodid',0),(572449,15902,'si','PoraÄuna oznak najdete',0),(572450,15902,'ba','Kode Chargeback tidak ditemukan',0),(572451,15902,'nl','Geen Chargeback Codes gevonden',0),(572452,15902,'fi','Chargeback-koodeja ei lÃ¶ydy',0),(572453,15902,'no','Ingen Chargeback koder funnet',0),(572454,15902,'da','Ingen tilbagefÃ¸rsel koder fundet',0),(572455,15902,'ko','ì•„ë‹ˆ í™˜ë¶ˆ ì½”ë“œ ë°œê²¬',0),(572456,15902,'he','××™×Ÿ ×§×•×“×™× ×”×—×™×•×‘ × ×ž×¦××•',0),(572457,15902,'el','ÎŸÎ§Î™ ÎšÎ©Î”Î™ÎšÎŸÎ™ Chargeback Î²ÏÎ­Î¸Î·ÎºÎ±Î½',0),(572458,15902,'zh','å‘çŽ°æ²¡æœ‰è®¡è´¹ä»£ç ',0),(572459,15902,'sv','Ingen Ã¥terbetalning koder hittade',0),(572460,15902,'it','Nessun Chargeback codici trovati',0),(572461,15902,'tl','',0),(572462,15902,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸£à¸«à¸±à¸ªà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™',0),(572463,15902,'hi','à¤•à¥‹à¤ˆ à¤šà¤¾à¤°à¥à¤œà¤¬à¥ˆà¤• à¤•à¥‹à¤¡ à¤ªà¤¾à¤¯à¤¾',0),(572464,15902,'ms','Tiada kod caj semula yang mendapati',0),(572465,15902,'ar','Ø±Ù…ÙˆØ² ØªØ­Ù…ÙŠÙ„ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ Ù„Ø§ ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(572466,15902,'fr','Pas trouvÃ©s de Codes de Chargeback',0),(572467,15902,'jp','ç™ºè¦‹ãªã„ãƒãƒ£ãƒ¼ã‚¸ ã‚³ãƒ¼ãƒ‰',0),(572468,15902,'pt','Sem cÃ³digos de Chargeback encontrados',0),(572469,15902,'ru','ÐÐµ Chargeback ÐºÐ¾Ð´Ñ‹ Ð½Ð°Ð¹Ð´ÐµÐ½Ð¾',0),(572470,15902,'es','No hay cÃ³digos de cargo al usuario encontrados',0),(572471,15902,'de','Keine RÃ¼ckbelastung Codes gefunden',0),(572472,15902,'en','No Chargeback Codes Found',0),(572473,15903,'is','',0),(572474,15903,'dr','Ù†ÙˆØ´ØªÙ†ØŒ Ø®Ø§Ù…ÙˆØ´ Ø¨Ø§Ù„Ø§ØªØ± Ø§Ø² Ø­Ø¯Ø§Ú©Ø«Ø± Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¬Ø§Ø²',0),(572475,15903,'pr','Ù†ÙˆØ´ØªÙ†ØŒ Ø®Ø§Ù…ÙˆØ´ Ø¨Ø§Ù„Ø§ØªØ± Ø§Ø² Ø­Ø¯Ø§Ú©Ø«Ø± Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¬Ø§Ø²',0),(572476,15903,'tr','Yazma-off Max Ã¼zerinde izin verilen deÄŸer',0),(572477,15903,'pl','Odpisu powyÅ¼ej Max dozwolona wartoÅ›Ä‡',0),(572478,15903,'bg','ÐžÑ‚Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð°Ð´ ÐœÐ°ÐºÑ Ð´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(572479,15903,'ur','Write-off Ø§ÙˆÙ¾Ø± Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù‚Ø¯Ø± Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯Û’ Ø¯ÛŒ Û”',0),(572480,15903,'sr','ÐžÑ‚Ð¿Ð¸Ñ Ð´ÑƒÐ³Ð° Ð¸Ð·Ð½Ð°Ð´ ÐœÐ°x Ð´Ð¾Ð·Ð²Ð¾Ñ™ÐµÐ½Ð¾ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(572481,15903,'vi','Write-off trÃªn tá»‘i Ä‘a cho phÃ©p giÃ¡ trá»‹',0),(572482,15903,'af','Afskrywing bo Max toegelaat waarde',0),(572483,15903,'ro','Scrie-off deasupra Max permis valoare',0),(572484,15903,'et','Mahakandmine eespool Max lubatud vÃ¤Ã¤rtus',0),(572485,15903,'si','Odpis nad Max dovoljeno vrednost',0),(572486,15903,'ba','Menghapusbukukan di atas Max diperbolehkan nilai',0),(572487,15903,'nl','Afschrijving boven Max toegestane waarde',0),(572488,15903,'fi','Anteeksi edellÃ¤ Max sallitun arvon',0),(572489,15903,'no','Nedskrivningen over Max tillatte',0),(572490,15903,'da','Afskrivning over Max tilladt vÃ¦rdi',0),(572491,15903,'ko','ì“°ê¸° ìµœëŒ€ ìœ„ì˜ í—ˆìš© ê°’',0),(572492,15903,'he','×ž×—×™×§×” ×‘×”×ª×× ×ž×¢×œ ×ž×§×¡ ×ž×•×ª×¨ ×¢×¨×š',0),(572493,15903,'el','Write-off Ï€Î±ÏÎ±Ï€Î¬Î½Ï‰ Î¼Î­Î³Î¹ÏƒÏ„Î· ÎµÏ€Î¹Ï„ÏÎµÏ€ÏŒÎ¼ÎµÎ½Î· Ï„Î¹Î¼Î®',0),(572494,15903,'zh','æ³¨é”€ä»¥ä¸Šæœ€å¤§å…è®¸å€¼',0),(572495,15903,'sv','Avskrivning Ã¶ver Max tillÃ¥tna vÃ¤rdet',0),(572496,15903,'it','Write-Off sopra Max valore consentito',0),(572497,15903,'tl','',0),(572498,15903,'th','à¸„à¹ˆà¸²à¸•à¸±à¸”à¸ˆà¹ˆà¸²à¸¢à¸‚à¹‰à¸²à¸‡à¸šà¸™à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¸—à¸µà¹ˆà¸­à¸™à¸¸à¸à¸²à¸•',0),(572499,15903,'hi','à¤®à¤¾à¤¨ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤Šà¤ªà¤° à¤²à¤¿à¤–à¤¨à¥‡ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿',0),(572500,15903,'ms','Pelupusan di atas maksimum dibenarkan nilai',0),(572501,15903,'ar','Ø´Ø·Ø¨ Ø£Ø¹Ù„Ø§Ù‡ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰ Ø§Ù„Ù…Ø³Ù…ÙˆØ­ Ø¨Ù‡ Ù‚ÙŠÙ…Ø©',0),(572502,15903,'fr','Radiation ci-dessus Max autorisÃ© valeur',0),(572503,15903,'jp','Max ä¸Šå„Ÿå´è¨±å®¹å€¤',0),(572504,15903,'pt','Write-off acima Max valor permitido',0),(572505,15903,'ru','Ð¡Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð²Ñ‹ÑˆÐµ ÐœÐ°ÐºÑ Ð´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ð¾Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(572506,15903,'es','PÃ©rdidas y ganancias por encima del mÃ¡ximo permitieron valor',0),(572507,15903,'de','Abschreibung Ã¼ber Max zulÃ¤ssige Wert',0),(572508,15903,'en','Write-off Above Max Allowed Value',0),(572509,15904,'is','',0),(572510,15904,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ù‡Ø±Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø¨Ø± Ø§Ø³Ø§Ø³',0),(572511,15904,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ù‡Ø±Ù‡ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø´Ø¯Ù‡ Ø¨Ø± Ø§Ø³Ø§Ø³',0),(572512,15904,'tr','Vade farkÄ± Ã¶demeleri temel alÄ±narak hesaplanÄ±r',0),(572513,15904,'pl','Odsetki obliczane na podstawie',0),(572514,15904,'bg','Ð›Ð¸Ñ…Ð²Ð°Ñ‚Ð°, Ð¸Ð·Ñ‡Ð¸ÑÐ»ÐµÐ½Ð° Ð²ÑŠÐ· Ð¾ÑÐ½Ð¾Ð²Ð° Ð½Ð°',0),(572515,15904,'ur','Ø³ÙˆØ¯ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø¨Ù†ÛŒØ§Ø¯ Ù¾Ø± Ø­Ø³Ø§Ø¨',0),(572516,15904,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ ÐºÐ°Ð¼Ð°Ñ‚Ð° Ð¾Ð±Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð° Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ñƒ',0),(572517,15904,'vi','PhÃ­ lÃ£i suáº¥t Ä‘Æ°á»£c tÃ­nh toÃ¡n dá»±a trÃªn',0),(572518,15904,'af','Rente heffings bereken gebaseer op',0),(572519,15904,'ro','Costuri cu dobÃ¢nda calculatÄƒ pe baza',0),(572520,15904,'et','Intressimakseid arvutada',0),(572521,15904,'si','Obresti, izraÄunane na podlagi',0),(572522,15904,'ba','Biaya bunga dihitung berdasarkan',0),(572523,15904,'nl','Rentelasten berekend op basis van',0),(572524,15904,'fi','Korkokulut lasketaan',0),(572525,15904,'no','Renter beregnes basert pÃ¥',0),(572526,15904,'da','Renter beregnet pÃ¥ grundlag af',0),(572527,15904,'ko','ì´ìž ë¹„ìš©ì— ë”°ë¼ ê³„ì‚°',0),(572528,15904,'he','×¨×™×‘×™×ª ×ž×—×•×©×‘×ª ×¢×œ ×‘×¡×™×¡',0),(572529,15904,'el','Î’Î±ÏƒÎ¯Î¶ÎµÏ„Î±Î¹ ÏƒÎµ Ï…Ï€Î¿Î»ÏŒÎ³Î¹ÏƒÎµ Ï„ÏŒÎºÎ¿Ï…Ï‚',0),(572530,15904,'zh','åŸºäºŽè®¡ç®—åˆ©æ¯è´¹ç”¨',0),(572531,15904,'sv','RÃ¤ntekostnader berÃ¤knas utifrÃ¥n',0),(572532,15904,'it','Spese per interessi calcolati in base alle',0),(572533,15904,'tl','',0),(572534,15904,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¸„à¸³à¸™à¸§à¸“à¸ˆà¸²à¸',0),(572535,15904,'hi','à¤¬à¥à¤¯à¤¾à¤œ à¤¶à¥à¤²à¥à¤• à¤•à¥‡ à¤†à¤§à¤¾à¤° à¤ªà¤° à¤—à¤£à¤¨à¤¾ à¤•à¥€',0),(572536,15904,'ms','Caj faedah dikira berdasarkan',0),(572537,15904,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„ÙØ§Ø¦Ø¯Ø© Ø§Ù„Ù…Ø­Ø³ÙˆØ¨Ø© Ø¹Ù„Ù‰ Ø£Ø³Ø§Ø³',0),(572538,15904,'fr','Frais dâ€™intÃ©rÃªts calculÃ© sur la base',0),(572539,15904,'jp','åˆ©æ¯è¨ˆç®—ã«åŸºã¥ã„ã¦',0),(572540,15904,'pt','Encargos financeiros calculados com base na',0),(572541,15904,'ru','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹ Ñ€Ð°ÑÑÑ‡Ð¸Ñ‚Ñ‹Ð²Ð°ÑŽÑ‚ÑÑ Ð½Ð° Ð¾ÑÐ½Ð¾Ð²Ðµ',0),(572542,15904,'es','Cargos de interÃ©s calculan en base a',0),(572543,15904,'de','Zinsen berechnet auf der Grundlage',0),(572544,15904,'en','Interest Charges Calculated Based On',0),(572545,15905,'is','',0),(572546,15905,'dr','Ø¢Ø®Ø±ÛŒÙ† Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø¨Ù‡Ø±Ù‡',0),(572547,15905,'pr','Ø¢Ø®Ø±ÛŒÙ† Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø¨Ù‡Ø±Ù‡',0),(572548,15905,'tr','Son olarak hesaplanan faizi',0),(572549,15905,'pl','Odsetki oblicza siÄ™ ostatnio na',0),(572550,15905,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð¸Ð·Ñ‡Ð¸ÑÐ»ÑÐ²Ð° Ð»Ð¸Ñ…Ð²Ð°',0),(572551,15905,'ur','Ø¢Ø®Ø±ÛŒ Ù¾Ø± Ø­Ø³Ø§Ø¨ Ø³ÙˆØ¯',0),(572552,15905,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿ÑƒÑ‚ Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ñ‚Ð° ÐºÐ°Ð¼Ð°Ñ‚Ð° Ð½Ð°',0),(572553,15905,'vi','LÃ£i suáº¥t cuá»‘i tÃ­nh ngÃ y',0),(572554,15905,'af','Laaste rente op',0),(572555,15905,'ro','DobÃ¢ndÄƒ calculatÄƒ ultima',0),(572556,15905,'et','Viimati arvutatud intressid',0),(572557,15905,'si','Nazadnje izraÄunane obresti na',0),(572558,15905,'ba','Bunga terakhir dihitung',0),(572559,15905,'nl','Belangstelling voor het laatst is berekend op',0),(572560,15905,'fi','Viimeksi lasketun koron',0),(572561,15905,'no','Renter beregnes sist pÃ¥',0),(572562,15905,'da','Renter beregnet pÃ¥',0),(572563,15905,'ko','ë§ˆì§€ë§‰ì— ê³„ì‚° í•˜ëŠ” ê´€ì‹¬',0),(572564,15905,'he','×¢× ×™×™×Ÿ ××—×¨×•×Ÿ ×ž×—×•×©×‘ ×¢×œ',0),(572565,15905,'el','Î¤Î·Î½ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Ï†Î¿ÏÎ¬ Î³Î¹Î± Ï„Î¿ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½',0),(572566,15905,'zh','æœ€åŽè®¡ç®—åˆ©æ¯',0),(572567,15905,'sv','Senast rÃ¤nta pÃ¥',0),(572568,15905,'it','Interesse calcolato in ultima',0),(572569,15905,'tl','',0),(572570,15905,'th','à¸¥à¹ˆà¸²à¸ªà¸¸à¸” à¸„à¹ˆà¸²',0),(572571,15905,'hi','à¤ªà¤° à¤ªà¤¿à¤›à¤²à¥‡ à¤¬à¥à¤¯à¤¾à¤œ à¤•à¥€ à¤—à¤£à¤¨à¤¾',0),(572572,15905,'ms','Faedah buat dikira',0),(572573,15905,'ar','Ø¢Ø®Ø± Ø§Ø­ØªØ³Ø§Ø¨ Ø§Ù„ÙØ§Ø¦Ø¯Ø© Ø¹Ù„Ù‰',0),(572574,15905,'fr','IntÃ©rÃªts calculÃ©s derniÃ¨re sur',0),(572575,15905,'jp','æœ€å¾Œã«ç®—å‡ºã•ã‚ŒãŸåˆ©æ¯',0),(572576,15905,'pt','Juros calculados Ãºltima sobre',0),(572577,15905,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ñ‹ Ð½Ð°',0),(572578,15905,'es','Ãšltimo se calcula el interÃ©s sobre',0),(572579,15905,'de','Interesse berechnet am zuletzt',0),(572580,15905,'en','Interest Last Calculated On',0),(572581,15906,'is','',0),(572582,15906,'dr','Ø¹Ù…ÙˆÙ…ÛŒ Ù„Ø¬Ø± Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‡Ø§',0),(572583,15906,'pr','Ø¹Ù…ÙˆÙ…ÛŒ Ù„Ø¬Ø± Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‡Ø§',0),(572584,15906,'tr','Genel muhasebe VarsayÄ±lanlarÄ±',0),(572585,15906,'pl','OgÃ³lne ustawienia domyÅ›lne ksiÄ™gi',0),(572586,15906,'bg','ÐžÐ±Ñ‰Ð¸ Ð›ÐµÐ´Ð¶ÑŠÑ€ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(572587,15906,'ur','Ø¬Ù†Ø±Ù„ Ú©Ú¾Ø§ØªØ§ Ø·Û’ Ø´Ø¯Û',0),(572588,15906,'sr','Ð“ÐµÐ½ÐµÑ€Ð°Ð» ÐºÑšÐ¸Ð³Ðµ Ð·Ð°Ð´Ð°Ð½Ðµ Ð²Ñ€Ð¸Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(572589,15906,'vi','General Ledger máº·c Ä‘á»‹nh',0),(572590,15906,'af','Algemene grootboek verstek',0),(572591,15906,'ro','General Ledger implicite',0),(572592,15906,'et','Ãœldised pearaamatu vaikesÃ¤tted',0),(572593,15906,'si','General Ledger neplaÄil',0),(572594,15906,'ba','General Ledger default',0),(572595,15906,'nl','General Ledger Defaults',0),(572596,15906,'fi','General Ledger oletukset',0),(572597,15906,'no','General Ledger standarder',0),(572598,15906,'da','General Ledger standardindstillinger',0),(572599,15906,'ko','ì¼ë°˜ ë ˆì € ê¸°ë³¸ê°’',0),(572600,15906,'he','×’× ×¨×œ ×¨××©×™ ×‘×¨×™×¨×•×ª ×ž×—×“×œ',0),(572601,15906,'el','Î“ÎµÎ½Î¹ÎºÎ¿Ï ÎºÎ±Î¸Î¿Î»Î¹ÎºÎ¿Ï Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³ÏŽÎ½',0),(572602,15906,'zh','æ€»åˆ†ç±»å¸é»˜è®¤å€¼',0),(572603,15906,'sv','General Ledger Defaults',0),(572604,15906,'it','Impostazioni predefinite di contabilitÃ  generale',0),(572605,15906,'tl','',0),(572606,15906,'th','à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(572607,15906,'hi','à¤¸à¤¾à¤®à¤¾à¤¨à¥à¤¯ à¤¤à¥Œà¤° à¤ªà¤° à¤²à¥‡à¤œà¤¼à¤° à¤šà¥‚à¤•',0),(572608,15906,'ms','Lalai Lejar Am',0),(572609,15906,'ar','Ø§Ù„Ø¥Ø¹Ø¯Ø§Ø¯Ø§Øª Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© ÙÙŠ Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ø¹Ø§Ù…',0),(572610,15906,'fr','Valeurs par dÃ©faut de comptabilitÃ© gÃ©nÃ©rale',0),(572611,15906,'jp','ä¸€èˆ¬çš„ãªå…ƒå¸³ã®æ—¢å®šå€¤',0),(572612,15906,'pt','General Ledger padrÃµes',0),(572613,15906,'ru','Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹ ÐºÐ½Ð¸Ð³Ð¸ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(572614,15906,'es','Defectos de contabilidad general',0),(572615,15906,'de','General Ledger Standardwerte',0),(572616,15906,'en','General Ledger Defaults',0),(572617,15907,'is','',0),(572618,15907,'dr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… Ø§Ù†ÙˆØ§Ø¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯',0),(572619,15907,'pr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… Ø§Ù†ÙˆØ§Ø¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯',0),(572620,15907,'tr','DoÄŸrudan AR Ã¶deme tÃ¼rleri ekleme',0),(572621,15907,'pl','Dodaj typy pÅ‚atnoÅ›ci bezpoÅ›rednie AR',0),(572622,15907,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð¿Ñ€ÐµÐºÐ¸ AR Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(572623,15907,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(572624,15907,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ñ€ÑÑ‚Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ðµ ÐÐ ',0),(572625,15907,'vi','ThÃªm hÃ¬nh thá»©c thanh toÃ¡n trá»±c tiáº¿p AR',0),(572626,15907,'af','Voeg direkte AR betaling tipes',0),(572627,15907,'ro','Adauga tipuri de platÄƒ directÄƒ AR',0),(572628,15907,'et','Lisada otsene AR MaksevÃµimalused',0),(572629,15907,'si','Dodamo neposredno AR vrste plaÄil',0),(572630,15907,'ba','Menambahkan jenis pembayaran langsung AR',0),(572631,15907,'nl','Directe AR betalingsmethoden toevoegen',0),(572632,15907,'fi','LisÃ¤tÃ¤ suoraan AR maksutavat',0),(572633,15907,'no','Legg til direkte AR betalingstyper',0),(572634,15907,'da','TilfÃ¸j direkte AR betalingstyper',0),(572635,15907,'ko','ì§ì ‘ ì•„ì¹¸ì†Œ ì§€ë¶ˆ ìœ í˜• ì¶”ê°€',0),(572636,15907,'he','×œ×”×•×¡×™×£ ×¡×•×’×™ ×ª×©×œ×•× ×™×©×™×¨ AR',0),(572637,15907,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Ï„ÏÏ€Î¿Ï…Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î¬Î¼ÎµÏƒÎ· AR',0),(572638,15907,'zh','æ·»åŠ ç›´æŽ¥ AR ä»˜æ¬¾ç±»åž‹',0),(572639,15907,'sv','LÃ¤gga till direkt AR betalningstyper',0),(572640,15907,'it','Aggiungere i tipi di pagamento diretto AR',0),(572641,15907,'tl','',0),(572642,15907,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹‚à¸”à¸¢à¸•à¸£à¸‡ AR',0),(572643,15907,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· AR à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(572644,15907,'ms','Tambah jenis pembayaran langsung AR',0),(572645,15907,'ar','Ø¥Ø¶Ø§ÙØ© Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± Ø¹',0),(572646,15907,'fr','Ajouter des Types de paiement Direct AR',0),(572647,15907,'jp','ç›´æŽ¥ AR æ”¯æ‰•ã‚¿ã‚¤ãƒ—ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(572648,15907,'pt','Adicionar tipos de pagamento de AR direto',0),(572649,15907,'ru','Ð”Ð¾Ð±Ð°Ð²ÑŒÑ‚Ðµ Ñ‚Ð¸Ð¿Ñ‹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ Ð¿Ñ€ÑÐ¼Ñ‹Ðµ AR',0),(572650,15907,'es','Agregar tipos de pago directo AR',0),(572651,15907,'de','FÃ¼gen Sie direkte AR Zahlungsarten',0),(572652,15907,'en','Add Direct AR Payment Types',0),(572653,15908,'is','',0),(572654,15908,'dr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÛŒÙ… Ø¹Ù„ÛŒØ±Ø¶Ø§',0),(572655,15908,'pr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÛŒÙ… Ø¹Ù„ÛŒØ±Ø¶Ø§',0),(572656,15908,'tr','DoÄŸrudan AR Ã¶deme tipi',0),(572657,15908,'pl','Typ pÅ‚atnoÅ›ci bezpoÅ›rednie AR',0),(572658,15908,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ AR Ð²Ð¸Ð´ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(572659,15908,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù…',0),(572660,15908,'sr','Ð’Ñ€ÑÑ‚Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¾ ÐÐ ',0),(572661,15908,'vi','HÃ¬nh thá»©c thanh toÃ¡n trá»±c tiáº¿p AR',0),(572662,15908,'af','Direkte AR betaling tipe',0),(572663,15908,'ro','Tip de platÄƒ directÄƒ AR',0),(572664,15908,'et','Otsene AR liik',0),(572665,15908,'si','Vrsta plaÄila neposredno AR',0),(572666,15908,'ba','Jenis pembayaran langsung AR',0),(572667,15908,'nl','Directe AR betalingstype',0),(572668,15908,'fi','Suora AR tyyppi',0),(572669,15908,'no','Direkte AR betalingstypen',0),(572670,15908,'da','Direkte AR betalingstype',0),(572671,15908,'ko','ì§ì ‘ ì•„ì¹¸ì†Œ ì§€ë¶ˆ ìœ í˜•',0),(572672,15908,'he','×¡×•×’ ×”×ª×©×œ×•× AR ×™×©×™×¨×”',0),(572673,15908,'el','Î¤ÏÏ€Î¿Ï‚ Î¬Î¼ÎµÏƒÎ· AR Ï€Î»Î·ÏÏ‰Î¼ÏŽÎ½',0),(572674,15908,'zh','ç›´æŽ¥ AR ä»˜æ¬¾ç±»åž‹',0),(572675,15908,'sv','Direkta AR betalningstypen',0),(572676,15908,'it','Tipo di pagamento diretto AR',0),(572677,15908,'tl','',0),(572678,15908,'th','à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹‚à¸”à¸¢à¸•à¸£à¸‡ AR',0),(572679,15908,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· AR à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(572680,15908,'ms','Jenis bayaran langsung AR',0),(572681,15908,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± Ø¹',0),(572682,15908,'fr','Type de paiement direct AR',0),(572683,15908,'jp','ç›´æŽ¥ AR æ”¯æ‰•åž‹',0),(572684,15908,'pt','Tipo de pagamento de AR direto',0),(572685,15908,'ru','Ð¢Ð¸Ð¿ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ñ€ÑÐ¼Ñ‹Ðµ AR',0),(572686,15908,'es','Tipo de pago directo AR',0),(572687,15908,'de','Direkte AR Zahlungsart',0),(572688,15908,'en','Direct AR Payment Type',0),(572689,15909,'is','',0),(572690,15909,'dr','Ù‡ÛŒÚ† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÛŒ Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(572691,15909,'pr','Ù‡ÛŒÚ† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø±Ø§ÛŒ Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(572692,15909,'tr','AR Ã¶deme tipi iÃ§in hesabÄ± ayarlanmadÄ±',0),(572693,15909,'pl','Nie zestaw konto dla typu pÅ‚atnoÅ›ci AR',0),(572694,15909,'bg','ÐÑÐ¼Ð° Ð¿Ñ€ÐµÐ´Ð²Ð¸Ð´ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸ Ð·Ð° AR Ð²Ð¸Ð´ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(572695,15909,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ù‚Ø³Ù… Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(572696,15909,'sr','ÐÐµÐ¼Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ð¡ÐµÑ‚ Ð·Ð° ÐÐ  Ð²Ñ€ÑÑ‚Ð° ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(572697,15909,'vi','KhÃ´ng cÃ³ thiáº¿t láº­p tÃ i khoáº£n cho cÃ¡c hÃ¬nh thá»©c thanh toÃ¡n AR',0),(572698,15909,'af','Geen rekening stel vir AR betaling tipe',0),(572699,15909,'ro','Nici un Set de cont pentru tipul de platÄƒ AR',0),(572700,15909,'et','Pole kontot mÃ¤Ã¤ratud AR liik',0),(572701,15909,'si','Ni nastavljenega raÄun za vrsto plaÄila AR',0),(572702,15909,'ba','Ada Account diatur untuk jenis pembayaran AR',0),(572703,15909,'nl','Geen Account is ingesteld voor het betalingstype AR',0),(572704,15909,'fi','Ei tilin asetettu AR tyyppi',0),(572705,15909,'no','Ingen konto satt For AR betalingstypen',0),(572706,15909,'da','Ingen konto sÃ¦t For AR betalingstype',0),(572707,15909,'ko','AR ê²°ì œ í˜•ì‹ì— ëŒ€ í•œ ê³„ì • ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(572708,15909,'he','×œ× ×”×•×’×“×¨×• ×—×©×‘×•×Ÿ ×¢×‘×•×¨ ×¡×•×’ ×”×ª×©×œ×•× AR',0),(572709,15909,'el','ÎšÎ±Î½Î­Î½Î± ÎºÎ±Î¸Î¿ÏÎ¹ÏƒÎ¼Î­Î½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î³Î¹Î± Ï„Î¿Î½ Ï„ÏÏ€Î¿ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ AR',0),(572710,15909,'zh','æ²¡æœ‰ä¸º AR ä»˜æ¬¾ç±»åž‹çš„çš„å¸æˆ·è®¾ç½®',0),(572711,15909,'sv','Inget konto Set fÃ¶r betalningstyp som AR',0),(572712,15909,'it','Nessun Set di Account per tipo di pagamento AR',0),(572713,15909,'tl','',0),(572714,15909,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸±à¸à¸Šà¸µà¸ªà¸³à¸«à¸£à¸±à¸šà¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡ AR',0),(572715,15909,'hi','AR à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿ',0),(572716,15909,'ms','Tiada syarat akaun jenis bayaran AR',0),(572717,15909,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø­Ø³Ø§Ø¨ Ù„Ù†ÙˆØ¹ Ø§Ù„Ø¯ÙØ¹ AR',0),(572718,15909,'fr','Aucun ensemble de compte pour le Type de paiement AR',0),(572719,15909,'jp','AR æ”¯æ‰•ã‚¿ã‚¤ãƒ—ãŒè¨­å®šã•ã‚Œã¦ã„ãªã„ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(572720,15909,'pt','Nenhum conjunto de conta para pagamento de AR tipo',0),(572721,15909,'ru','ÐÐ°Ð±Ð¾Ñ€ Ð½Ðµ ÑÑ‡ÐµÑ‚Ð° Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ñ‚Ð¸Ð¿Ð° AR',0),(572722,15909,'es','NingÃºn conjunto de cuenta para pago de AR tipo',0),(572723,15909,'de','Keine Konto-Set fÃ¼r AR-Zahlungsart',0),(572724,15909,'en','No Account Set For AR Payment Type',0),(572725,15910,'is','',0),(572726,15910,'dr','Ù‡ÛŒÚ† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(572727,15910,'pr','Ù‡ÛŒÚ† Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(572728,15910,'tr','HiÃ§bir doÄŸrudan AR Ã¶deme tipleri mevcuttur',0),(572729,15910,'pl','Istnieje nie typÃ³w pÅ‚atnoÅ›ci bezpoÅ›rednie AR',0),(572730,15910,'bg','ÐÑÐ¼Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ AR Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‚',0),(572731,15910,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§Ù‚Ø³Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯ ÛÛŒÚº',0),(572732,15910,'sr','ÐÐµÐ¼Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸Ñ… ÐÐ  Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ñ‚Ð¸Ð¿Ð¾Ð²Ð° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(572733,15910,'vi','KhÃ´ng cÃ³ hÃ¬nh thá»©c thanh toÃ¡n trá»±c tiáº¿p AR tá»“n táº¡i',0),(572734,15910,'af','Geen direkte AR betaling vorme bestaan',0),(572735,15910,'ro','Nici tipuri de platÄƒ directÄƒ AR exista',0),(572736,15910,'et','Mingit otsest AR MaksevÃµimalused olemas',0),(572737,15910,'si','Obstajajo vrste plaÄilo ni neposredno AR',0),(572738,15910,'ba','Jenis pembayaran langsung AR tidak ada',0),(572739,15910,'nl','Geen directe AR betaalwijzen bestaan',0),(572740,15910,'fi','Ei suoraan AR maksutavat olemassa',0),(572741,15910,'no','Ingen direkte AR betalingstyper finnes',0),(572742,15910,'da','Der findes ingen direkte AR betalingstyper',0),(572743,15910,'ko','ì•„ë‹ˆ ì§ì ‘ ì•„ì¹¸ì†Œ ì§€ë¶ˆ ìœ í˜•ì´',0),(572744,15910,'he','×§×™×™×ž×™× ×¡×•×’×™ ×ª×©×œ×•× ××™×Ÿ AR ×™×©×™×¨×”',0),(572745,15910,'el','Î¥Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÎºÎ±Î¼Î¯Î± Î¬Î¼ÎµÏƒÎ· AR Ï„ÏÏ€Î¿Î¹ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(572746,15910,'zh','æ²¡æœ‰ç›´æŽ¥çš„ AR ä»˜æ¬¾ç±»åž‹å­˜åœ¨',0),(572747,15910,'sv','Det finns ingen direkt AR betalningstyper',0),(572748,15910,'it','Nessun tipo di pagamento diretto AR esiste',0),(572749,15910,'tl','',0),(572750,15910,'th','à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹‚à¸”à¸¢à¸•à¸£à¸‡ AR à¹„à¸¡à¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(572751,15910,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· AR à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤° à¤®à¥Œà¤œà¥‚à¤¦',0),(572752,15910,'ms','Jenis pembayaran AR langsung tidak wujud',0),(572753,15910,'ar','Ù„Ø§ Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± Ø¹ Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(572754,15910,'fr','Aucun type de paiement Direct AR nâ€™existent',0),(572755,15910,'jp','ç›´æŽ¥ AR æ”¯æ‰•åž‹ãŒå­˜åœ¨ã—ã¾ã›ã‚“ã€‚',0),(572756,15910,'pt','Existem tipos de pagamento sem AR direto',0),(572757,15910,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚ Ð½ÐµÑ‚ Ð¿Ñ€ÑÐ¼Ð¾Ð³Ð¾ AR Ñ‚Ð¸Ð¿Ñ‹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹',0),(572758,15910,'es','No existe ningÃºn tipo de pago directo AR',0),(572759,15910,'de','Gibt es keine direkte AR-Zahlungsarten',0),(572760,15910,'en','No Direct AR Payment Types Exist',0),(572761,15911,'is','',0),(572762,15911,'dr','Ø§Ø®ÛŒØ± Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… Ù¾Ø±Ø¯Ø§Ø®Øª',0),(572763,15911,'pr','Ø§Ø®ÛŒØ± Ø¹Ù„ÛŒØ±Ø¶Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… Ù¾Ø±Ø¯Ø§Ø®Øª',0),(572764,15911,'tr','Son doÄŸrudan AR Ã¶demeler',0),(572765,15911,'pl','Niedawne pÅ‚atnoÅ›ci bezpoÅ›rednie AR',0),(572766,15911,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¿Ñ€ÐµÐºÐ¸ AR Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(572767,15911,'ur','Ø­Ø§Ù„ÛŒÛ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(572768,15911,'sr','ÐÐµÐ´Ð°Ð²Ð½Ð° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð° ÐÐ  ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(572769,15911,'vi','Táº¡i AR trá»±c tiáº¿p thanh toÃ¡n',0),(572770,15911,'af','Onlangse AR direkte betalings',0),(572771,15911,'ro','PlÄƒÈ›ile directe AR recente',0),(572772,15911,'et','Tehtud otsesed AR maksed',0),(572773,15911,'si','Nedavnih neposrednem AR plaÄila',0),(572774,15911,'ba','Tanggal pembayaran langsung AR',0),(572775,15911,'nl','Recente directe AR betalingen',0),(572776,15911,'fi','Hotelliin suoraan AR maksut',0),(572777,15911,'no','Betalinger som nylig direkte AR',0),(572778,15911,'da','Seneste direkte AR betalinger',0),(572779,15911,'ko','ìµœê·¼ ì§ì ‘ ì•„ì¹¸ì†Œ ì§€ë¶ˆ',0),(572780,15911,'he','×ª×©×œ×•×ž×™× ×™×©×™×¨×™× AR ×”××—×¨×•× ×•×ª',0),(572781,15911,'el','Î ÏÏŒÏƒÏ†Î±Ï„ÎµÏ‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Î¼Îµ Î¬Î¼ÎµÏƒÎ· AR',0),(572782,15911,'zh','æœ€è¿‘ç›´æŽ¥ AR ä»˜æ¬¾',0),(572783,15911,'sv','De senaste direkt AR betalningar',0),(572784,15911,'it','Pagamenti diretti AR recenti',0),(572785,15911,'tl','',0),(572786,15911,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹‚à¸”à¸¢à¸•à¸£à¸‡ AR à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(572787,15911,'hi','à¤¹à¤¾à¤² à¤¹à¥€ à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· AR à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(572788,15911,'ms','Hari pembayaran langsung AR',0),(572789,15911,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø¨Ø§Ø´Ø±Ø© Ø¹ Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(572790,15911,'fr','Paiements directs AR rÃ©cents',0),(572791,15911,'jp','æœ€è¿‘ç›´æŽ¥ AR æ”¯æ‰•',0),(572792,15911,'pt','Pagamentos recentes de AR direto',0),(572793,15911,'ru','ÐÐµÐ´Ð°Ð²Ð½Ð¸Ðµ Ð¿Ñ€ÑÐ¼Ñ‹Ðµ AR Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(572794,15911,'es','Ãšltimos pagos directo AR',0),(572795,15911,'de','Den letzten direkten AR Zahlungen',0),(572796,15911,'en','Recent Direct AR Payments',0),(572797,15912,'is','',0),(572798,15912,'dr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÛŒÙ… Ø¹Ù„ÛŒØ±Ø¶Ø§ ÙØ¹Ù„ÛŒ',0),(572799,15912,'pr','Ù†ÙˆØ¹ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø³ØªÙ‚ÛŒÙ… Ø¹Ù„ÛŒØ±Ø¶Ø§ ÙØ¹Ù„ÛŒ',0),(572800,15912,'tr','GeÃ§erli doÄŸrudan AR Ã¶deme ÅŸekli',0),(572801,15912,'pl','BieÅ¼Ä…ce typy pÅ‚atnoÅ›ci bezpoÅ›rednie AR',0),(572802,15912,'bg','Ð¢ÐµÐºÑƒÑ‰Ð¸ Ð¿Ñ€ÐµÐºÐ¸ AR Ñ‚Ð¸Ð¿Ð¾Ð²Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(572803,15912,'ur','Ø­Ø§Ù„ÛŒÛ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(572804,15912,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾Ð³ Ñ‚Ð¸Ð¿Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ðµ ÐÐ ',0),(572805,15912,'vi','Hiá»‡n táº¡i cÃ¡c hÃ¬nh thá»©c thanh toÃ¡n trá»±c tiáº¿p AR',0),(572806,15912,'af','Huidige direkte AR betaling tipes',0),(572807,15912,'ro','Tipuri de platÄƒ directÄƒ AR curent',0),(572808,15912,'et','Praegune otsene AR MaksevÃµimalused',0),(572809,15912,'si','Trenutne vrste plaÄil neposredno AR',0),(572810,15912,'ba','Saat ini jenis pembayaran langsung AR',0),(572811,15912,'nl','Huidige directe AR betaalwijzen',0),(572812,15912,'fi','Nykyinen suora AR-maksutavat',0),(572813,15912,'no','Gjeldende direkte AR betalingstyper',0),(572814,15912,'da','NuvÃ¦rende direkte AR betalingstyper',0),(572815,15912,'ko','í˜„ìž¬ ì§ì ‘ ì•„ì¹¸ì†Œ ì§€ë¶ˆ ìœ í˜•',0),(572816,15912,'he','×¡×•×’×™ ×ª×©×œ×•× ×™×©×™×¨ AR × ×•×›×—×™',0),(572817,15912,'el','Î¤ÏÎ­Ï‡Î¿Î½Ï„ÎµÏ‚ Ï„ÏÏ€Î¿Ï…Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î¬Î¼ÎµÏƒÎ· AR',0),(572818,15912,'zh','å½“å‰ç›´æŽ¥ AR ä»˜æ¬¾ç±»åž‹',0),(572819,15912,'sv','Aktuella direkt AR betalningstyper',0),(572820,15912,'it','Tipi di pagamento diretto AR correnti',0),(572821,15912,'tl','',0),(572822,15912,'th','à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹‚à¸”à¸¢à¸•à¸£à¸‡ AR à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(572823,15912,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· AR à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(572824,15912,'ms','Jenis pembayaran AR langsung semasa',0),(572825,15912,'ar','Ø£Ù†ÙˆØ§Ø¹ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…Ø¨Ø§Ø´Ø± Ø¹ Ø§Ù„Ø­Ø§Ù„ÙŠ',0),(572826,15912,'fr','Types actuels de paiement Direct AR',0),(572827,15912,'jp','ç¾åœ¨ç›´æŽ¥ AR æ”¯æ‰•ã„ã®ç¨®é¡ž',0),(572828,15912,'pt','Tipos de pagamento corrente AR direto',0),(572829,15912,'ru','Ð¢ÐµÐºÑƒÑ‰Ð¸Ðµ Ð¿Ñ€ÑÐ¼Ñ‹Ðµ AR Ñ‚Ð¸Ð¿Ñ‹ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(572830,15912,'es','Tipos actuales de pago directo AR',0),(572831,15912,'de','Aktuelle direkte AR-Zahlungsarten',0),(572832,15912,'en','Current Direct AR Payment Types',0),(572833,15913,'is','',0),(572834,15913,'dr','APN',0),(572835,15913,'pr','APN',0),(572836,15913,'tr','APN',0),(572837,15913,'pl','APN',0),(572838,15913,'bg','APN',0),(572839,15913,'ur','Ø¨Ù†',0),(572840,15913,'sr','ÐÐŸÐ',0),(572841,15913,'vi','APN',0),(572842,15913,'af','APN',0),(572843,15913,'ro','APN',0),(572844,15913,'et','APN',0),(572845,15913,'si','APN',0),(572846,15913,'ba','APN',0),(572847,15913,'nl','APN',0),(572848,15913,'fi','APN',0),(572849,15913,'no','APN',0),(572850,15913,'da','APN',0),(572851,15913,'ko','APN',0),(572852,15913,'he','APN',0),(572853,15913,'el','APN',0),(572854,15913,'zh','APN',0),(572855,15913,'sv','APN',0),(572856,15913,'it','APN',0),(572857,15913,'tl','',0),(572858,15913,'th','APN',0),(572859,15913,'hi','APN',0),(572860,15913,'ms','APN',0),(572861,15913,'ar','APN',0),(572862,15913,'fr','APN',0),(572863,15913,'jp','APN',0),(572864,15913,'pt','APN',0),(572865,15913,'ru','APN',0),(572866,15913,'es','APN',0),(572867,15913,'de','APN',0),(572868,15913,'en','APN',0),(572869,15914,'is','',0),(572870,15914,'dr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ø¹Ù†ÙˆØ§Ù†',0),(572871,15914,'pr','ØªÙ…Ø§Ø³ Ø¨Ø§ Ø¹Ù†ÙˆØ§Ù†',0),(572872,15914,'tr','Ä°letiÅŸim baÅŸlÄ±ÄŸÄ±',0),(572873,15914,'pl','Kontakt z tytuÅ‚u',0),(572874,15914,'bg','Ð—Ð°Ð³Ð»Ð°Ð²Ð¸Ðµ Ð½Ð° ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(572875,15914,'ur','Ø¹Ù†ÙˆØ§Ù† Ø³Û’ Ø±Ø§Ø¨Ø·Û Ú©Ø±ÛŒÚº',0),(572876,15914,'sr','ÐžÐ±Ñ€Ð°Ñ‚Ð¸Ñ‚Ðµ ÑÐµ Ð½Ð°ÑÐ»Ð¾Ð²',0),(572877,15914,'vi','LiÃªn há»‡ vá»›i tiÃªu Ä‘á»',0),(572878,15914,'af','Kontak titel',0),(572879,15914,'ro','Contact titlu',0),(572880,15914,'et','Kontakti tiitel',0),(572881,15914,'si','Kontaktni naslov',0),(572882,15914,'ba','Hubungi judul',0),(572883,15914,'nl','Neem contact op met de titel',0),(572884,15914,'fi','YhteyshenkilÃ¶n titteli',0),(572885,15914,'no','Kontakt tittel',0),(572886,15914,'da','Kontakt titel',0),(572887,15914,'ko','ì—°ë½ì²˜ ì œëª©',0),(572888,15914,'he','×¦×•×¨ ×§×©×¨ ×¢× ×”×›×•×ª×¨×ª',0),(572889,15914,'el','Î•Ï€Î¹ÎºÎ¿Î¹Î½Ï‰Î½Î®ÏƒÏ„Îµ Î¼Îµ Ï„Î¯Ï„Î»Î¿',0),(572890,15914,'zh','è”ç³»äººèŒåŠ¡',0),(572891,15914,'sv','Kontakta avdelning',0),(572892,15914,'it','Titolo contatto',0),(572893,15914,'tl','',0),(572894,15914,'th','à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¸•à¸´à¸”à¸•à¹ˆà¸­',0),(572895,15914,'hi','à¤¶à¥€à¤°à¥à¤·à¤• à¤¸à¥‡ à¤¸à¤‚à¤ªà¤°à¥à¤• à¤•à¤°à¥‡à¤‚',0),(572896,15914,'ms','Hubungi tajuk',0),(572897,15914,'ar','Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø§ØªØµØ§Ù„',0),(572898,15914,'fr','Communiquer avec titre',0),(572899,15914,'jp','ãŠå•ã„åˆã‚ã›ã‚¿ã‚¤ãƒˆãƒ«',0),(572900,15914,'pt','Entre em contato com o tÃ­tulo',0),(572901,15914,'ru','ÐšÐ¾Ð½Ñ‚Ð°ÐºÑ‚ ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ',0),(572902,15914,'es','TÃ­tulo contacto',0),(572903,15914,'de','Wenden Sie sich an Titel',0),(572904,15914,'en','Contact Title',0),(572905,15915,'is','',0),(572906,15915,'dr','Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(572907,15915,'pr','Ø´Ù…Ø§Ø±Ù‡ Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(572908,15915,'tr','SÃ¶zleÅŸme numarasÄ±',0),(572909,15915,'pl','Numer umowy',0),(572910,15915,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(572911,15915,'ur','Ù…Ø¹Ø§ÛØ¯Û Ù†Ù…Ø¨Ø±',0),(572912,15915,'sr','Ð‘Ñ€Ð¾Ñ˜ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð°',0),(572913,15915,'vi','Sá»‘ há»£p Ä‘á»“ng',0),(572914,15915,'af','Kontrak nommer',0),(572915,15915,'ro','NumÄƒrul contractului',0),(572916,15915,'et','Lepingu Number',0),(572917,15915,'si','Å tevilka pogodbe',0),(572918,15915,'ba','Jumlah kontrak',0),(572919,15915,'nl','Contractnummer',0),(572920,15915,'fi','Sopimuksen numero',0),(572921,15915,'no','Kontraktnummeret',0),(572922,15915,'da','Kontraktnummer',0),(572923,15915,'ko','ê³„ì•½ ë²ˆí˜¸',0),(572924,15915,'he','×ž×¡×¤×¨ ×—×•×–×”',0),(572925,15915,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÏƒÏ…Î¼Î²Î¿Î»Î±Î¯Î¿Ï…',0),(572926,15915,'zh','åˆåŒå·',0),(572927,15915,'sv','Kontraktsnummer',0),(572928,15915,'it','Numero di contratto',0),(572929,15915,'tl','',0),(572930,15915,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸ªà¸±à¸à¸à¸²',0),(572931,15915,'hi','à¤…à¤¨à¥à¤¬à¤‚à¤§ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(572932,15915,'ms','Nombor kontrak',0),(572933,15915,'ar','Ø±Ù‚Ù… Ø§Ù„Ø¹Ù‚Ø¯',0),(572934,15915,'fr','NumÃ©ro de contrat',0),(572935,15915,'jp','å¥‘ç´„ç•ªå·',0),(572936,15915,'pt','NÃºmero de contrato',0),(572937,15915,'ru','ÐÐ¾Ð¼ÐµÑ€ ÐºÐ¾Ð½Ñ‚Ñ€Ð°ÐºÑ‚Ð°',0),(572938,15915,'es','NÃºmero de contrato',0),(572939,15915,'de','Vertragsnummer',0),(572940,15915,'en','Contract Number',0),(572941,15916,'is','',0),(572942,15916,'dr','Ù…Ø´ØªØ±ÛŒ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(572943,15916,'pr','Ù…Ø´ØªØ±ÛŒ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(572944,15916,'tr','Gerekli mÃ¼ÅŸteri',0),(572945,15916,'pl','Klienta wymagane',0),(572946,15916,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð·Ð¸ÑÐºÐ²Ð°',0),(572947,15916,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(572948,15916,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°',0),(572949,15916,'vi','KhÃ¡ch hÃ ng yÃªu cáº§u',0),(572950,15916,'af','KliÃ«nt vereis',0),(572951,15916,'ro','Client necesare',0),(572952,15916,'et','Kliendi nÃµutud',0),(572953,15916,'si','Stranka, ki zahteva',0),(572954,15916,'ba','Pelanggan yang diperlukan',0),(572955,15916,'nl','Klant nodig',0),(572956,15916,'fi','Asiakkaan tarpeen',0),(572957,15916,'no','Kunden kreves',0),(572958,15916,'da','Kunde krÃ¦ves',0),(572959,15916,'ko','í•„ìš”í•œ ê³ ê°',0),(572960,15916,'he','×”×œ×§×•×— × ×“×¨×©',0),(572961,15916,'el','Î ÎµÎ»Î¬Ï„Î· Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(572962,15916,'zh','å®¢æˆ·éœ€è¦',0),(572963,15916,'sv','Kunden krÃ¤vs',0),(572964,15916,'it','Cliente ha richiesto',0),(572965,15916,'tl','',0),(572966,15916,'th','à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(572967,15916,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(572968,15916,'ms','Pelanggan dikehendaki',0),(572969,15916,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©',0),(572970,15916,'fr','Client requis',0),(572971,15916,'jp','å¿…è¦ãªé¡§å®¢',0),(572972,15916,'pt','Cliente exigido',0),(572973,15916,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñƒ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ',0),(572974,15916,'es','Cliente requerido',0),(572975,15916,'de','Kunden, die erforderlich',0),(572976,15916,'en','Customer Required',0),(572977,15917,'is','',0),(572978,15917,'dr','Ú©Ø§Ø± Ø¯Ø± ÛŒÚ© Ø³Ø§Ù„',0),(572979,15917,'pr','Ú©Ø§Ø± Ø¯Ø± ÛŒÚ© Ø³Ø§Ù„',0),(572980,15917,'tr','NUM iÅŸ yÄ±l',0),(572981,15917,'pl','Lat pracy NUM',0),(572982,15917,'bg','NUM Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð³Ð¾Ð´Ð¸Ð½Ð¸',0),(572983,15917,'ur','Num Ù†ÙˆÚ©Ø±ÛŒ Ú©Û’ Ø³Ø§Ù„',0),(572984,15917,'sr','ÐÐ£Ðœ Ð¿Ð¾ÑÐ°Ð¾ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(572985,15917,'vi','CÃ´ng viá»‡c sá»‘ nÄƒm',0),(572986,15917,'af','NUM werk jaar',0),(572987,15917,'ro','Num Job ani',0),(572988,15917,'et','NUM tÃ¶Ã¶ aasta',0),(572989,15917,'si','NUM delovnih let',0),(572990,15917,'ba','Tahun num pekerjaan',0),(572991,15917,'nl','Num baan jaar',0),(572992,15917,'fi','NUM tyÃ¶paikka vuotta',0),(572993,15917,'no','NUM jobb Ã¥r',0),(572994,15917,'da','NUM Job Ã¥r',0),(572995,15917,'ko','Num ì¼ ë…„',0),(572996,15917,'he','×¢×‘×•×“×” ×ž×¡×¤×¨ ×©× ×™×',0),(572997,15917,'el','NUM Î´Î¿Ï…Î»ÎµÎ¹Î¬ Ï‡ÏÏŒÎ½Î¹Î±',0),(572998,15917,'zh','å…¨å›½çŸ¿å·¥å·¥ä¼šå·¥ä½œå¹´',0),(572999,15917,'sv','NUM jobb Ã¥r',0),(573000,15917,'it','Anni di lavoro num',0),(573001,15917,'tl','',0),(573002,15917,'th','à¸›à¸µà¸‡à¸²à¸™ Num',0),(573003,15917,'hi','Num à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤¾à¤²',0),(573004,15917,'ms','NUM kerja tahun',0),(573005,15917,'ar','Ø³Ù†ÙˆØ§Øª ÙˆØ¸ÙŠÙØ© Num',0),(573006,15917,'fr','AnnÃ©es de travail num',0),(573007,15917,'jp','Num ã‚¸ãƒ§ãƒ–å¹´',0),(573008,15917,'pt','Anos de trabalho num',0),(573009,15917,'ru','Ð›ÐµÑ‚ Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹ num',0),(573010,15917,'es','AÃ±os de trabajo NUM',0),(573011,15917,'de','NUM Job Jahre',0),(573012,15917,'en','Num Job Years',0),(573013,15918,'is','',0),(573014,15918,'dr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ù…Ø¬ÙˆØ²',0),(573015,15918,'pr','Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯ Ù…Ø¬ÙˆØ²',0),(573016,15918,'tr','SÃ¶zleÅŸme izni',0),(573017,15918,'pl','PozwalajÄ… na kontrakt',0),(573018,15918,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸ Ð´Ð¾Ð³Ð¾Ð²Ð¾Ñ€',0),(573019,15918,'ur','Ù…Ø¹Ø§ÛØ¯Û’ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª',0),(573020,15918,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸Ñ‚Ðµ ÑƒÐ³Ð¾Ð²Ð¾Ñ€',0),(573021,15918,'vi','Cho phÃ©p há»£p Ä‘á»“ng',0),(573022,15918,'af','Toe kontrak',0),(573023,15918,'ro','Permis de Contract',0),(573024,15918,'et','Luba leping',0),(573025,15918,'si','Dovoli se pogodba',0),(573026,15918,'ba','Izin kontrak',0),(573027,15918,'nl','Toestaan van Contract',0),(573028,15918,'fi','Salli sopimuksen',0),(573029,15918,'no','Tillat kontrakt',0),(573030,15918,'da','Tillade, at kontrakten',0),(573031,15918,'ko','ê³„ì•½ í—ˆìš©',0),(573032,15918,'he','×œ×”×ª×™×¨ ××ª ×”×—×•×–×”',0),(573033,15918,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î· ÏƒÏÎ¼Î²Î±ÏƒÎ·',0),(573034,15918,'zh','è®¸å¯åˆåŒ',0),(573035,15918,'sv','TillÃ¥ta kontrakt',0),(573036,15918,'it','Permesso di contratto',0),(573037,15918,'tl','',0),(573038,15918,'th','à¸ªà¸±à¸à¸à¸²à¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰',0),(573039,15918,'hi','à¤…à¤¨à¥à¤¬à¤‚à¤§ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿',0),(573040,15918,'ms','Permit kontrak',0),(573041,15918,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ø¨Ø¹Ù‚Ø¯',0),(573042,15918,'fr','Contrat de licence',0),(573043,15918,'jp','å¥‘ç´„ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(573044,15918,'pt','Contrato de licenÃ§a',0),(573045,15918,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ðµ Ð½Ð° ÐºÐ¾Ð½Ñ‚Ñ€Ð°ÐºÑ‚',0),(573046,15918,'es','Permiso de contrato',0),(573047,15918,'de','Vertrag zu ermÃ¶glichen',0),(573048,15918,'en','Permit Contract',0),(573049,15919,'is','',0),(573050,15919,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ù…Ø§Ù„ÛŒ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ­Øª Ø­Ø¯Ø§Ù‚Ù„',0),(573051,15919,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ù…Ø§Ù„ÛŒ Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ­Øª Ø­Ø¯Ø§Ù‚Ù„',0),(573052,15919,'tr','Vade farkÄ± altÄ±nda Minimum Ã¶deme iÃ§in',0),(573053,15919,'pl','Not odsetkowych dla pÅ‚atnoÅ›ci w ramach Minimum',0),(573054,15919,'bg','Ð¤Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ð¸ Ð²Ð·ÐµÐ¼Ð°Ð½Ð¸Ñ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ð¾ Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼',0),(573055,15919,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ú©Û’ ØªØ­Øª Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ú†Ø§Ø±Ø¬Ø²',0),(573056,15919,'sr','Ð—Ð°Ñ‚ÐµÐ·Ð½Ð¸Ñ… ÐºÐ°Ð¼Ð°Ñ‚Ð° Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ Ð¸ÑÐ¿Ð¾Ð´ Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼Ð°',0),(573057,15919,'vi','Phá»¥ trÃ¡ch tÃ i chÃ­nh Ä‘á»ƒ thanh toÃ¡n theo tá»‘i thiá»ƒu',0),(573058,15919,'af','FinansiÃ«le las vir betaling onder Minimum',0),(573059,15919,'ro','Taxa financiarÄƒ conform minim',0),(573060,15919,'et','Viivise alusel vÃ¤hemalt',0),(573061,15919,'si','Bremepis za plaÄilo v okviru najmanj',0),(573062,15919,'ba','Biaya keuangan untuk pembayaran di bawah Minimum',0),(573063,15919,'nl','Rentefactuur voor betaling onder de Minimum',0),(573064,15919,'fi','ViivÃ¤styskulu nojalla vÃ¤hintÃ¤Ã¤n',0),(573065,15919,'no','Rentenota til betaling Under Minimum',0),(573066,15919,'da','Rentenota For betaling Under Minimum',0),(573067,15919,'ko','ìµœì†Œ ì•„ëž˜ ì§€ë¶ˆì— ëŒ€ í•œ ê¸ˆìœµ ë¹„ìš©',0),(573068,15919,'he','×ª×©×œ×•× ×›×¡×¤×™× ×œ×ª×©×œ×•× ×ª×—×ª ×ž×™× ×™×ž×•×',0),(573069,15919,'el','Î¤ÏŒÎºÏ‰Î½ Î³Î¹Î± ÎµÎ½Î¯ÏƒÏ‡Ï…ÏƒÎ· ÏƒÏ„Î± Ï€Î»Î±Î¯ÏƒÎ¹Î± ÎµÎ»Î¬Ï‡Î¹ÏƒÏ„Î¿',0),(573070,15919,'zh','è´¢åŠ¡è´¹ç”¨æ ¹æ®æœ€ä½Žä»˜æ¬¾',0),(573071,15919,'sv','Finans avgift fÃ¶r betalning Under minst',0),(573072,15919,'it','Addebito per pagamento sotto minimo',0),(573073,15919,'tl','',0),(573074,15919,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸à¸²à¸£à¹€à¸‡à¸´à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸ à¸²à¸¢à¹ƒà¸•à¹‰à¸­à¸¢à¹ˆà¸²à¸‡à¸™à¹‰à¸­à¸¢',0),(573075,15919,'hi','à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤•à¥‡ à¤¤à¤¹à¤¤ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤¤à¥à¤¤ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(573076,15919,'ms','Caj kewangan untuk pembayaran di bawah Minimum',0),(573077,15919,'ar','Ø§Ù„Ø±Ø³Ù… Ø§Ù„Ù…Ø§Ù„ÙŠ Ù„Ù„Ø¯ÙØ¹ Ø¨Ù…ÙˆØ¬Ø¨ Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰',0),(573078,15919,'fr','Frais de crÃ©dit de paiement au titre du Minimum',0),(573079,15919,'jp','æœ€ä½Žã®æ”¯æ‰•æ‰‹æ•°æ–™',0),(573080,15919,'pt','Carga de FinanÃ§as para pagamento sob o mÃ­nimo',0),(573081,15919,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° Ñ„Ð¸Ð½Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾ Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼',0),(573082,15919,'es','Cargo por financiamiento para el pago bajo mÃ­nimos',0),(573083,15919,'de','Zinsrechnung fÃ¼r Zahlung unter Minimum',0),(573084,15919,'en','Finance Charge For Payment Under Minimum',0),(573085,15920,'is','',0),(573086,15920,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¹Ù„Ø§Ù† Ø§ÛŒÙ…ÛŒÙ„ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(573087,15920,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¹Ù„Ø§Ù† Ø§ÛŒÙ…ÛŒÙ„ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(573088,15920,'tr','E-postayla gÃ¶nderilen Ã¶deme bildirimi',0),(573089,15920,'pl','PÅ‚atnoÅ›ci powiadomienia pocztÄ… E-mail',0),(573090,15920,'bg','Ð£Ð²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸ÐµÑ‚Ð¾ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÐµÐ¼Ð°Ð¹Ð»',0),(573091,15920,'ur','Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù†ÙˆÙ¹Ø³',0),(573092,15920,'sr','ÐŸÐ»Ð°Ñ›Ð°ÑšÐ° Ð½Ð°Ñ˜Ð°Ð²Ðµ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ð¼ÐµÑ˜Ð»',0),(573093,15920,'vi','ThÃ´ng bÃ¡o thanh toÃ¡n gá»­i qua email',0),(573094,15920,'af','Betaling kennisgewing per e-pos',0),(573095,15920,'ro','Notificare de plata prin E-mail',0),(573096,15920,'et','Tasumise teate e-postiga',0),(573097,15920,'si','PlaÄilo obvestilo po e-poÅ¡ti',0),(573098,15920,'ba','Pembayaran pemberitahuan email',0),(573099,15920,'nl','Kennisgeving van de betaling per E-mail',0),(573100,15920,'fi','Maksun ilmoituksen sÃ¤hkÃ¶postitse',0),(573101,15920,'no','Betaling varsel sendt',0),(573102,15920,'da','Betaling BemÃ¦rk mailede',0),(573103,15920,'ko','ê²°ì œ í†µì§€ ì´ë©”ì¼',0),(573104,15920,'he','×ª×©×œ×•× ×”×•×“×¢×” ×‘×“×•×',0),(573105,15920,'el','Î•Î¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(573106,15920,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€çš„ä»˜æ¬¾é€šçŸ¥',0),(573107,15920,'sv','Betalning varsel via e-post',0),(573108,15920,'it','Avviso di pagamento via E-mail',0),(573109,15920,'tl','',0),(573110,15920,'th','à¹à¸ˆà¹‰à¸‡à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡',0),(573111,15920,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¥‚à¤šà¤¨à¤¾ à¤ˆà¤®à¥‡à¤²',0),(573112,15920,'ms','Notis pembayaran melalui e-mel',0),(573113,15920,'ar','Ø¥Ø´Ø¹Ø§Ø± Ø§Ù„Ø¯ÙØ¹ Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(573114,15920,'fr','Avis de paiement par courriel',0),(573115,15920,'jp','æ”¯æ‰•é€šçŸ¥æ›¸ã‚’ãƒ¡ãƒ¼ãƒ«ã§é€ä¿¡',0),(573116,15920,'pt','Aviso de pagamento por E-mail',0),(573117,15920,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾',0),(573118,15920,'es','Aviso de pago enviado por correo electrÃ³nico',0),(573119,15920,'de','Zahlungsaufforderung per E-Mail',0),(573120,15920,'en','Payment Notice Emailed',0),(573121,15921,'is','',0),(573122,15921,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø´Ø±Ú©Øª',0),(573123,15921,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø´Ø±Ú©Øª',0),(573124,15921,'tr','Åžirket varsayÄ±lan',0),(573125,15921,'pl','Firma domyÅ›lne',0),(573126,15921,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ',0),(573127,15921,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø·Û’ Ø´Ø¯Û',0),(573128,15921,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸',0),(573129,15921,'vi','Máº·c Ä‘á»‹nh cÃ´ng ty',0),(573130,15921,'af','Maatskappy verstek',0),(573131,15921,'ro','Compania implicit',0),(573132,15921,'et','Firma vaikimisi',0),(573133,15921,'si','Podjetje privzeto',0),(573134,15921,'ba','Perusahaan Default',0),(573135,15921,'nl','Bedrijf standaard',0),(573136,15921,'fi','Yrityksen oletus',0),(573137,15921,'no','Selskapet standard',0),(573138,15921,'da','Virksomheden standard',0),(573139,15921,'ko','íšŒì‚¬ ê¸°ë³¸',0),(573140,15921,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×œ ×”×—×‘×¨×”',0),(573141,15921,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(573142,15921,'zh','å…¬å¸è¿çº¦',0),(573143,15921,'sv','FÃ¶retag standard',0),(573144,15921,'it','Azienda predefinito',0),(573145,15921,'tl','',0),(573146,15921,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(573147,15921,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(573148,15921,'ms','Syarikat lalai',0),(573149,15921,'ar','Ø§Ù„Ø´Ø±ÙƒØ© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(573150,15921,'fr','SociÃ©tÃ© par dÃ©faut',0),(573151,15921,'jp','ä¼šç¤¾æ—¢å®š',0),(573152,15921,'pt','Empresa padrÃ£o',0),(573153,15921,'ru','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(573154,15921,'es','Empresa por defecto',0),(573155,15921,'de','Firma Standard',0),(573156,15921,'en','Company Default',0),(573157,15922,'is','',0),(573158,15922,'dr','Ø®Ø±ÛŒØ¯Ø§Ø± Ù…Ø¬Ø§Ø²',0),(573159,15922,'pr','Ø®Ø±ÛŒØ¯Ø§Ø± Ù…Ø¬Ø§Ø²',0),(573160,15922,'tr','Yetkili alÄ±cÄ±',0),(573161,15922,'pl','Uprawniony nabywca',0),(573162,15922,'bg','ÐžÑ‚Ð¾Ñ€Ð¸Ð·Ð¸Ñ€Ð°Ð½ ÐºÑƒÐ¿ÑƒÐ²Ð°Ñ‡',0),(573163,15922,'ur','Ù…Ø¬Ø§Ø² Ø®Ø±ÛŒØ¯Ø§Ø±',0),(573164,15922,'sr','ÐžÐ²Ð»Ð°ÑˆÑ›ÐµÐ½Ð¸ ÐºÑƒÐ¿Ð°Ñ†',0),(573165,15922,'vi','Cho phÃ©p ngÆ°á»i mua',0),(573166,15922,'af','Gemagtigde koper',0),(573167,15922,'ro','Autorizat cumpÄƒrÄƒtor',0),(573168,15922,'et','Volitatud ostja',0),(573169,15922,'si','PooblaÅ¡Äeni kupec',0),(573170,15922,'ba','Resmi pembeli',0),(573171,15922,'nl','Geautoriseerde koper',0),(573172,15922,'fi','Valtuutettu ostaja',0),(573173,15922,'no','Autoriserte kjÃ¸per',0),(573174,15922,'da','Autoriseret kÃ¸ber',0),(573175,15922,'ko','ê¶Œí•œ ìžˆëŠ” êµ¬ë§¤ìž',0),(573176,15922,'he','×§×•× ×” ×ž×•×¨×©×”',0),(573177,15922,'el','Î•ÎžÎŸÎ¥Î£Î™ÎŸÎ”ÎŸÎ¤Î—ÎœÎ•ÎÎŸÎ£ Î‘Î“ÎŸÎ¡Î‘Î£Î¤Î—Î£',0),(573178,15922,'zh','æŽˆæƒçš„ä¹°å®¶',0),(573179,15922,'sv','GodkÃ¤nda kÃ¶pare',0),(573180,15922,'it','Acquirente autorizzato',0),(573181,15922,'tl','',0),(573182,15922,'th','à¸œà¸¹à¹‰à¸‹à¸·à¹‰à¸­à¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(573183,15922,'hi','à¤…à¤§à¤¿à¤•à¥ƒà¤¤ à¤–à¤°à¥€à¤¦à¤¾à¤°',0),(573184,15922,'ms','Pembeli diberi kuasa',0),(573185,15922,'ar','Ø§Ù„Ù…Ø£Ø°ÙˆÙ† Ø¨Ù‡ Ø§Ù„Ù…Ø´ØªØ±ÙŠ',0),(573186,15922,'fr','Acheteur autorisÃ©',0),(573187,15922,'jp','æŒ‡å®šã•ã‚ŒãŸè³¼å…¥è€…',0),(573188,15922,'pt','Comprador autorizado',0),(573189,15922,'ru','Ð£Ð¿Ð¾Ð»Ð½Ð¾Ð¼Ð¾Ñ‡ÐµÐ½Ð½Ð¾Ð³Ð¾ Ð¿Ð¾ÐºÑƒÐ¿Ð°Ñ‚ÐµÐ»Ñ',0),(573190,15922,'es','Comprador autorizado',0),(573191,15922,'de','Autorisierter KÃ¤ufer',0),(573192,15922,'en','Authorized Buyer',0),(573193,15923,'is','',0),(573194,15923,'dr','Ù…Ø´ØªØ±ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ù¾ÛŒÙˆØ³Øª',0),(573195,15923,'pr','Ù…Ø´ØªØ±ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ù¾ÛŒÙˆØ³Øª',0),(573196,15923,'tr','MÃ¼ÅŸteri Ã¶deme ekleri',0),(573197,15923,'pl','ZaÅ‚Ä…czniki pÅ‚atnoÅ›ci klienta',0),(573198,15923,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ñ‡ÐµÐ½Ð¸ Ñ„Ð°Ð¹Ð»Ð¾Ð²Ðµ',0),(573199,15923,'ur','Ú©Ø³Ù¹Ù…Ø± Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…Ù†Ø³Ù„Ú©Ø§Øª',0),(573200,15923,'sr','ÐŸÑ€Ð¸Ð»Ð¾Ð·Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° ÐºÑƒÐ¿Ñ†Ð°',0),(573201,15923,'vi','KhÃ¡ch hÃ ng thanh toÃ¡n pháº§n Ä‘Ã­nh kÃ¨m',0),(573202,15923,'af','KliÃ«nt betaling aanhegsels',0),(573203,15923,'ro','Accesorii de plata client',0),(573204,15923,'et','Kliendi makse manused',0),(573205,15923,'si','Kupca plaÄilo Priloge',0),(573206,15923,'ba','Pelanggan pembayaran lampiran',0),(573207,15923,'nl','Klant betaling bijlagen',0),(573208,15923,'fi','Asiakkaan maksun liitteet',0),(573209,15923,'no','Kundens betaling vedlegg',0),(573210,15923,'da','Kundens betaling vedhÃ¦ftede filer',0),(573211,15923,'ko','ê³ ê° ì§€ë¶ˆ ì²¨ë¶€ íŒŒì¼',0),(573212,15923,'he','×§×‘×¦×™× ×ž×¦×•×¨×¤×™× ×”×ª×©×œ×•× ×©×œ ×”×œ×§×•×—',0),(573213,15923,'el','Î£Ï…Î½Î·Î¼Î¼Î­Î½Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€ÎµÎ»Î¬Ï„Î·',0),(573214,15923,'zh','å®¢æˆ·ä»˜æ¬¾é™„ä»¶',0),(573215,15923,'sv','Kundens betalning bilagor',0),(573216,15923,'it','Allegati di pagamento del cliente',0),(573217,15923,'tl','',0),(573218,15923,'th','à¹€à¸­à¸à¸ªà¸²à¸£à¹à¸™à¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(573219,15923,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤¨à¥à¤²à¤—à¥à¤¨à¤•',0),(573220,15923,'ms','Lampiran pembayaran pelanggan',0),(573221,15923,'ar','Ø§Ù„Ù…Ø±ÙÙ‚Ø§Øª Ø¯ÙØ¹ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(573222,15923,'fr','Accessoires de paiement client',0),(573223,15923,'jp','é¡§å®¢æ”¯æ‰•ã®æ·»ä»˜ãƒ•ã‚¡ã‚¤ãƒ«',0),(573224,15923,'pt','Anexos de pagamento do cliente',0),(573225,15923,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð²Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(573226,15923,'es','Accesorios de pago del cliente',0),(573227,15923,'de','Kunden Zahlung Anlagen',0),(573228,15923,'en','Customer Payment Attachments',0),(573229,15924,'is','',0),(573230,15924,'dr','ACH/EFT/Ø³Ø§ÛŒØ±',0),(573231,15924,'pr','ACH/EFT/Ø³Ø§ÛŒØ±',0),(573232,15924,'tr','ACH/EFT/diÄŸer',0),(573233,15924,'pl','ACH/EFT/inne',0),(573234,15924,'bg','ACH/EFT/Ð´Ñ€ÑƒÐ³Ð¸',0),(573235,15924,'ur','Ø§Ú†/EFT/Ø¯ÛŒÚ¯Ø±',0),(573236,15924,'sr','ÐÑ…/Ð•Ð¤Ð¢/Ð¾ÑÑ‚Ð°Ð»Ðµ',0),(573237,15924,'vi','ACH/EFT/khÃ¡c',0),(573238,15924,'af','ACH/EFT/ander',0),(573239,15924,'ro','ACH/EFT/altele',0),(573240,15924,'et','ACH/EFT/muu',0),(573241,15924,'si','ACH/EFT/druge',0),(573242,15924,'ba','TDE ACH/lainnya',0),(573243,15924,'nl','ACH/EFT/andere',0),(573244,15924,'fi','ACH/EFT/muut',0),(573245,15924,'no','ACH/EFT/andre',0),(573246,15924,'da','ACH/EFT/andre',0),(573247,15924,'ko','ACH/EFT/ê¸°íƒ€',0),(573248,15924,'he','ACH/EFT/××—×¨×™×',0),(573249,15924,'el','ACH/EFT/Î¬Î»Î»Î±',0),(573250,15924,'zh','ACH/EFT/å…¶ä»–',0),(573251,15924,'sv','ACH/EFT/andra',0),(573252,15924,'it','ACH/EFT/altri',0),(573253,15924,'tl','',0),(573254,15924,'th','ACH EFT/à¸­à¸·à¹ˆà¸™ à¹†',0),(573255,15924,'hi','ACH/à¤ˆà¤à¤«à¤¼à¤Ÿà¥€/à¤…à¤¨à¥à¤¯',0),(573256,15924,'ms','MEN/EFT/lain-lain',0),(573257,15924,'ar','Ù…Ù†Ø¸Ù…Ø© Ø§Ù„Ø¹Ù…Ù„ Ø¶Ø¯ Ø§Ù„Ø¬ÙˆØ¹/EFT/Ø£Ø®Ø±Ù‰',0),(573258,15924,'fr','ACH/EFT/autres',0),(573259,15924,'jp','ACH/éŠ€è¡Œå£åº§æŒ¯è¾¼/ãã®ä»–',0),(573260,15924,'pt','ACH/EFT/outros',0),(573261,15924,'ru','ACH/EFT/Ð´Ñ€ÑƒÐ³Ð¸Ðµ',0),(573262,15924,'es','EFT/ACH/otros',0),(573263,15924,'de','ACH/EFT/sonstige',0),(573264,15924,'en','ACH/EFT/Other',0),(573265,15925,'is','',0),(573266,15925,'dr','Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(573267,15925,'pr','Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(573268,15925,'tr','AP Ã¶deme',0),(573269,15925,'pl','AP pÅ‚atnoÅ›ci',0),(573270,15925,'bg','AP Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(573271,15925,'ur','AP Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(573272,15925,'sr','ÐÐŸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(573273,15925,'vi','AP thanh toÃ¡n',0),(573274,15925,'af','GP betaling',0),(573275,15925,'ro','Plata AP',0),(573276,15925,'et','AP makse',0),(573277,15925,'si','AP plaÄilo',0),(573278,15925,'ba','AP pembayaran',0),(573279,15925,'nl','AP betaling',0),(573280,15925,'fi','AP maksu',0),(573281,15925,'no','AP betaling',0),(573282,15925,'da','AP betaling',0),(573283,15925,'ko','AP ê²°ì œ',0),(573284,15925,'he','×”×ª×©×œ×•× AP',0),(573285,15925,'el','AP Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(573286,15925,'zh','AP ä»˜æ¬¾',0),(573287,15925,'sv','AP betalning',0),(573288,15925,'it','Pagamento di AP',0),(573289,15925,'tl','',0),(573290,15925,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ AP',0),(573291,15925,'hi','AP à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(573292,15925,'ms','Pembayaran AP',0),(573293,15925,'ar','Ø¯ÙØ¹ ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(573294,15925,'fr','Paiement de lâ€™AP',0),(573295,15925,'jp','AP æ”¯æ‰•ã„',0),(573296,15925,'pt','Pagamento de AP',0),(573297,15925,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° AP',0),(573298,15925,'es','Pago de AP',0),(573299,15925,'de','AP-Zahlung',0),(573300,15925,'en','AP Payment',0),(573301,15926,'is','',0),(573302,15926,'dr','Ù¾ÛŒØ§Ù… Ù‡Ø§ÛŒ Ø¹Ù…ÙˆÙ…ÛŒ',0),(573303,15926,'pr','Ù¾ÛŒØ§Ù… Ù‡Ø§ÛŒ Ø¹Ù…ÙˆÙ…ÛŒ',0),(573304,15926,'tr','Genel Mesaj',0),(573305,15926,'pl','WiadomoÅ›ci ogÃ³lne',0),(573306,15926,'bg','ÐžÐ±Ñ‰ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(573307,15926,'ur','Ø¬Ù†Ø±Ù„ Ú©Ø§ Ù¾ÛŒØºØ§Ù…',0),(573308,15926,'sr','ÐŸÐ¾Ñ€ÑƒÐºÐ° Ð·Ð° Ð³ÐµÐ½ÐµÑ€Ð°Ð»Ð°',0),(573309,15926,'vi','ThÃ´ng bÃ¡o chung',0),(573310,15926,'af','Algemene boodskap',0),(573311,15926,'ro','Mesaj general',0),(573312,15926,'et','Ãœldine sÃµnum',0),(573313,15926,'si','SploÅ¡no sporoÄilo',0),(573314,15926,'ba','Pesan umum',0),(573315,15926,'nl','Algemeen bericht',0),(573316,15926,'fi','Yleiset viestin',0),(573317,15926,'no','Generell melding',0),(573318,15926,'da','General besked',0),(573319,15926,'ko','ì¼ë°˜ ë©”ì‹œì§€',0),(573320,15926,'he','×”×ž×¡×¨ ×”×›×œ×œ×™',0),(573321,15926,'el','ÎœÎ®Î½Ï…Î¼Î± Î³ÎµÎ½Î¹ÎºÎ¿Ï',0),(573322,15926,'zh','ä¸€èˆ¬æ¶ˆæ¯',0),(573323,15926,'sv','AllmÃ¤nt meddelande',0),(573324,15926,'it','Messaggio generale',0),(573325,15926,'tl','',0),(573326,15926,'th','à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(573327,15926,'hi','à¤œà¤¨à¤°à¤² à¤¸à¤‚à¤¦à¥‡à¤¶',0),(573328,15926,'ms','Perutusan Ketua',0),(573329,15926,'ar','Ø§Ù„Ø±Ø³Ø§Ù„Ø© Ø§Ù„Ø¹Ø§Ù…Ø©',0),(573330,15926,'fr','Message gÃ©nÃ©ral',0),(573331,15926,'jp','ä¸€èˆ¬çš„ãªãƒ¡ãƒƒã‚»ãƒ¼ã‚¸',0),(573332,15926,'pt','Mensagem geral',0),(573333,15926,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð“ÐµÐ½ÐµÑ€Ð°Ð»ÑŒÐ½Ð¾Ð¹',0),(573334,15926,'es','Mensaje general',0),(573335,15926,'de','Allgemeine Mitteilung',0),(573336,15926,'en','General Message',0),(573337,15927,'is','',0),(573338,15927,'dr','ÙØ§Ú©ØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(573339,15927,'pr','ÙØ§Ú©ØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(573340,15927,'tr','Ã–denen faturalar',0),(573341,15927,'pl','OpÅ‚acanie faktur',0),(573342,15927,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð¸',0),(573343,15927,'ur','ÙˆØ¨Ø¬Ù„ÛŒ Ø§Ø¯Ø§',0),(573344,15927,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ Ð¿Ð»Ð°Ñ‚Ð¸Ð¾',0),(573345,15927,'vi','HoÃ¡ Ä‘Æ¡n thanh toÃ¡n',0),(573346,15927,'af','Fakture betaal',0),(573347,15927,'ro','Facturi platite',0),(573348,15927,'et','Makstud arved',0),(573349,15927,'si','RaÄune plaÄa',0),(573350,15927,'ba','Tagihan yang dibayar',0),(573351,15927,'nl','Facturen betaald',0),(573352,15927,'fi','Maksetut laskut',0),(573353,15927,'no','Fakturaer betalt',0),(573354,15927,'da','Fakturaer betalt',0),(573355,15927,'ko','ì§€ë¶ˆ ì²­êµ¬ì„œ',0),(573356,15927,'he','×—×©×‘×•× ×™×•×ª ×©×•×œ×ž×•',0),(573357,15927,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… Ï€Î»Î·ÏÏŽÎ½Î¿Î½Ï„Î±Î¹',0),(573358,15927,'zh','å‘ç¥¨æ”¯ä»˜',0),(573359,15927,'sv','Fakturor betalas',0),(573360,15927,'it','Fatture pagate',0),(573361,15927,'tl','',0),(573362,15927,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸Šà¸³à¸£à¸°',0),(573363,15927,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(573364,15927,'ms','Invois-invois yang dibayar',0),(573365,15927,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø©',0),(573366,15927,'fr','Factures payÃ©es',0),(573367,15927,'jp','è«‹æ±‚æ›¸æ”¯æ‰•ã„',0),(573368,15927,'pt','Faturas pagas',0),(573369,15927,'ru','ÐžÐ¿Ð»Ð°Ñ‡ÐµÐ½Ñ‹ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(573370,15927,'es','Facturas pagadas',0),(573371,15927,'de','Rechnungen bezahlt',0),(573372,15927,'en','Invoices Paid',0),(573373,15928,'is','',0),(573374,15928,'dr','Ø±ÙˆØ² Ù¾Ø±Ø¯Ø§Ø®Øª',0),(573375,15928,'pr','Ø±ÙˆØ² Ù¾Ø±Ø¯Ø§Ø®Øª',0),(573376,15928,'tr','Ã–deme gÃ¼nÃ¼',0),(573377,15928,'pl','DzieÅ„ wypÅ‚aty',0),(573378,15928,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð´ÐµÐ½',0),(573379,15928,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¯Ù†',0),(573380,15928,'sr','Ð”Ð°Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(573381,15928,'vi','NgÃ y thanh toÃ¡n',0),(573382,15928,'af','Betaling dag',0),(573383,15928,'ro','Ziua de platÄƒ',0),(573384,15928,'et','MaksepÃ¤eva',0),(573385,15928,'si','Dan plaÄila',0),(573386,15928,'ba','Hari pembayaran',0),(573387,15928,'nl','Dag van de betaling',0),(573388,15928,'fi','MaksupÃ¤ivÃ¤',0),(573389,15928,'no','Betalingsdagen',0),(573390,15928,'da','Betalingsdagen',0),(573391,15928,'ko','ì§€ë¶ˆ ì¼',0),(573392,15928,'he','×™×•× ×”×ª×©×œ×•×',0),(573393,15928,'el','Î—Î¼Î­ÏÎ± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(573394,15928,'zh','ä»˜æ¬¾æ—¥',0),(573395,15928,'sv','Utbetalningsdagen',0),(573396,15928,'it','Giorno di pagamento',0),(573397,15928,'tl','',0),(573398,15928,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(573399,15928,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¦à¤¿à¤¨',0),(573400,15928,'ms','Hari pembayaran',0),(573401,15928,'ar','ÙŠÙˆÙ… Ø§Ù„Ø¯ÙØ¹',0),(573402,15928,'fr','Jour de paiement',0),(573403,15928,'jp','æ”¯æ‰•æ—¥',0),(573404,15928,'pt','Dia de pagamento',0),(573405,15928,'ru','Ð”ÐµÐ½ÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(573406,15928,'es','DÃ­a de pago',0),(573407,15928,'de','Als Zahlungstag',0),(573408,15928,'en','Payment Day',0),(573409,15929,'is','',0),(573410,15929,'dr','Ù…Ø§Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(573411,15929,'pr','Ù…Ø§Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(573412,15929,'tr','Ã–deme ay',0),(573413,15929,'pl','MiesiÄ…c pÅ‚atnoÅ›ci',0),(573414,15929,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð¼ÐµÑÐµÑ†',0),(573415,15929,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ù…Ø§Û',0),(573416,15929,'sr','ÐœÐµÑÐµÑ† Ð´Ð°Ð½Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(573417,15929,'vi','Thanh toÃ¡n thÃ¡ng',0),(573418,15929,'af','Betaling maand',0),(573419,15929,'ro','Plata lunii',0),(573420,15929,'et','Makse kuu',0),(573421,15929,'si','PlaÄilo mesec',0),(573422,15929,'ba','Pembayaran bulan',0),(573423,15929,'nl','Maand van de betaling',0),(573424,15929,'fi','Maksun kuukauden',0),(573425,15929,'no','Betaling mÃ¥ned',0),(573426,15929,'da','Betaling mÃ¥ned',0),(573427,15929,'ko','ì§€ë¶ˆ ë‹¬',0),(573428,15929,'he','×ª×©×œ×•× ×—×•×“×©',0),(573429,15929,'el','Î Î»Î·ÏÏ‰Î¼Î® Î¼Î®Î½Î±',0),(573430,15929,'zh','æ¯æœˆä»˜æ¬¾',0),(573431,15929,'sv','Betalning mÃ¥nad',0),(573432,15929,'it','Mese di pagamento',0),(573433,15929,'tl','',0),(573434,15929,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹€à¸”à¸·à¸­à¸™',0),(573435,15929,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤®à¤¾à¤¹',0),(573436,15929,'ms','Bulan bayaran',0),(573437,15929,'ar','Ø§Ù„Ø¯ÙØ¹ ÙÙŠ Ø§Ù„Ø´Ù‡Ø±',0),(573438,15929,'fr','Mois de paiement',0),(573439,15929,'jp','ãŠæ”¯æ‰•ã„æœˆ',0),(573440,15929,'pt','MÃªs de pagamento',0),(573441,15929,'ru','ÐœÐµÑÑÑ† Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°',0),(573442,15929,'es','Mes de pago',0),(573443,15929,'de','Zahlung-Monat',0),(573444,15929,'en','Payment Month',0),(573445,15930,'is','',0),(573446,15930,'dr','Ø³Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(573447,15930,'pr','Ø³Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(573448,15930,'tr','Ã–deme yÄ±l',0),(573449,15930,'pl','Rok pÅ‚atnoÅ›ci',0),(573450,15930,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ðµ Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(573451,15930,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø³Ø§Ù„',0),(573452,15930,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(573453,15930,'vi','Thanh toÃ¡n nÄƒm',0),(573454,15930,'af','Betaling jaar',0),(573455,15930,'ro','Plata an',0),(573456,15930,'et','Tasumine aasta',0),(573457,15930,'si','Leto plaÄilo',0),(573458,15930,'ba','Pembayaran tahun',0),(573459,15930,'nl','Jaar van de betaling',0),(573460,15930,'fi','Maksu vuoden',0),(573461,15930,'no','Betaling Ã¥r',0),(573462,15930,'da','Betaling Ã¥r',0),(573463,15930,'ko','ì§€ë¶ˆ í•´',0),(573464,15930,'he','×©× ×ª ×ª×©×œ×•×',0),(573465,15930,'el','ÎˆÏ„Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(573466,15930,'zh','æ”¯ä»˜å¹´',0),(573467,15930,'sv','Betalning Ã¥r',0),(573468,15930,'it','Anno di pagamento',0),(573469,15930,'tl','',0),(573470,15930,'th','à¸Šà¸³à¸£à¸°à¸›à¸µ',0),(573471,15930,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤°à¥à¤·',0),(573472,15930,'ms','Tahun pembayaran',0),(573473,15930,'ar','Ø³Ù†Ø© Ø§Ù„Ø¯ÙØ¹',0),(573474,15930,'fr','AnnÃ©e de paiement',0),(573475,15930,'jp','æ”¯æ‰•å¹´',0),(573476,15930,'pt','Ano de pagamento',0),(573477,15930,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° Ð³Ð¾Ð´',0),(573478,15930,'es','AÃ±o de pago',0),(573479,15930,'de','Jahr der Zahlung',0),(573480,15930,'en','Payment Year',0),(573481,15931,'is','',0),(573482,15931,'dr','Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(573483,15931,'pr','Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(573484,15931,'tr','SatÄ±cÄ± adÄ±',0),(573485,15931,'pl','Nazwa pierwszego dostawcy',0),(573486,15931,'bg','ÐŸÑŠÑ€Ð²Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(573487,15931,'ur','ÙˆÛŒÙ†ÚˆØ± Ù¾ÛÙ„Ø§ Ù†Ø§Ù…',0),(573488,15931,'sr','Ð˜Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(573489,15931,'vi','TÃªn nhÃ  cung cáº¥p',0),(573490,15931,'af','Handelaar Voornaam',0),(573491,15931,'ro','Nume furnizor',0),(573492,15931,'et','Hankija eesnimi',0),(573493,15931,'si','Ime dobavitelja',0),(573494,15931,'ba','Nama Penjual',0),(573495,15931,'nl','De naam van de eerste van de verkoper',0),(573496,15931,'fi','Toimittajan nimi',0),(573497,15931,'no','LeverandÃ¸ren fornavn',0),(573498,15931,'da','Kreditor fornavn',0),(573499,15931,'ko','ê³µê¸‰ ì—…ì²´ ì´ë¦„',0),(573500,15931,'he','×©× ×¤×¨×˜×™ ×¡×¤×§',0),(573501,15931,'el','ÎŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(573502,15931,'zh','ä¾›åº”å•†çš„åå­—',0),(573503,15931,'sv','LeverantÃ¶rens fÃ¶rnamn',0),(573504,15931,'it','Nome fornitore',0),(573505,15931,'tl','',0),(573506,15931,'th','à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(573507,15931,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤¥à¤® à¤¨à¤¾à¤®',0),(573508,15931,'ms','Nama pertama Penjual',0),(573509,15931,'ar','Ø§Ø³Ù… Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ø§Ù„Ø£ÙˆÙ„',0),(573510,15931,'fr','PrÃ©nom du vendeur',0),(573511,15931,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼å',0),(573512,15931,'pt','Nome fornecedor',0),(573513,15931,'ru','Ð˜Ð¼Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(573514,15931,'es','Nombre proveedor',0),(573515,15931,'de','Kreditor-Vorname',0),(573516,15931,'en','Vendor First Name',0),(573517,15932,'is','',0),(573518,15932,'dr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(573519,15932,'pr','Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(573520,15932,'tr','SatÄ±cÄ± adÄ± geÃ§en',0),(573521,15932,'pl','Ostatnia nazwa dostawcy',0),(573522,15932,'bg','Ð¤Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(573523,15932,'ur','ÙˆÛŒÙ†ÚˆØ± Ø®Ø§Ù†Ø¯Ø§Ù†ÛŒ Ù†Ø§Ù…',0),(573524,15932,'sr','ÐŸÑ€ÐµÐ·Ð¸Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(573525,15932,'vi','NhÃ  cung cáº¥p tÃªn cuá»‘i cÃ¹ng',0),(573526,15932,'af','Handelaar verlede naam',0),(573527,15932,'ro','Nume furnizor',0),(573528,15932,'et','Hankija perekonnanimi',0),(573529,15932,'si','Priimek prodajalca',0),(573530,15932,'ba','Nama Penjual',0),(573531,15932,'nl','Achternaam van leverancier',0),(573532,15932,'fi','Toimittajan nimi',0),(573533,15932,'no','LeverandÃ¸ren etternavn',0),(573534,15932,'da','Kreditors efternavn',0),(573535,15932,'ko','ê³µê¸‰ ì—…ì²´ ì„±',0),(573536,15932,'he','×¡×¤×§ ××ª ×©× ×”×ž×©×¤×—×”',0),(573537,15932,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(573538,15932,'zh','ä¾›åº”å•†çš„å§“',0),(573539,15932,'sv','LeverantÃ¶r efternamn',0),(573540,15932,'it','Nome fornitore',0),(573541,15932,'tl','',0),(573542,15932,'th','à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(573543,15932,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤®',0),(573544,15932,'ms','Nama penjual.',0),(573545,15932,'ar','Ø§Ø³Ù… Ù…ÙˆØ±Ø¯ Ø¢Ø®Ø±',0),(573546,15932,'fr','Nom du vendeur',0),(573547,15932,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼å§“',0),(573548,15932,'pt','Ãšltimo nome fornecedor',0),(573549,15932,'ru','Ð˜Ð¼Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(573550,15932,'es','Apellido del proveedor',0),(573551,15932,'de','Kreditor Nachname',0),(573552,15932,'en','Vendor Last Name',0),(573553,15933,'is','',0),(573554,15933,'dr','Ù†Ø§Ù…Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(573555,15933,'pr','Ù†Ø§Ù…Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(573556,15933,'tr','MÃ¼ÅŸteri mektuplar',0),(573557,15933,'pl','Listy klientÃ³w',0),(573558,15933,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¿Ð¸ÑÐ¼Ð°',0),(573559,15933,'ur','Ú©Ø³Ù¹Ù…Ø± Ø®Ø·ÙˆØ·',0),(573560,15933,'sr','ÐŸÐ¸ÑÐ¼Ð° ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(573561,15933,'vi','KhÃ¡ch hÃ ng thÆ°',0),(573562,15933,'af','KliÃ«nt Letters',0),(573563,15933,'ro','Scrisori de clienÅ£i',0),(573564,15933,'et','Kliendikirju',0),(573565,15933,'si','Pisma strank',0),(573566,15933,'ba','Surat-surat pelanggan',0),(573567,15933,'nl','Klant brieven',0),(573568,15933,'fi','AsiakaskirjeitÃ¤',0),(573569,15933,'no','Kunden bokstaver',0),(573570,15933,'da','Kunde breve',0),(573571,15933,'ko','ê³ ê° íŽ¸ì§€',0),(573572,15933,'he','×ž×›×ª×‘×™ ×œ×§×•×—×•×ª',0),(573573,15933,'el','Î ÎµÎ»Î¬Ï„Î·Ï‚ ÎµÏ€Î¹ÏƒÏ„Î¿Î»ÏŽÎ½',0),(573574,15933,'zh','å®¢æˆ·ä¿¡ä»¶',0),(573575,15933,'sv','Kundbrev',0),(573576,15933,'it','Lettere per i clienti',0),(573577,15933,'tl','',0),(573578,15933,'th','à¸•à¸±à¸§à¸­à¸±à¸à¸©à¸£à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(573579,15933,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤ªà¤¤à¥à¤°',0),(573580,15933,'ms','Baca Surat',0),(573581,15933,'ar','Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(573582,15933,'fr','Lettres de client',0),(573583,15933,'jp','é¡§å®¢å®›ã¦ã®ãƒ¬ã‚¿ãƒ¼',0),(573584,15933,'pt','Letras de cliente',0),(573585,15933,'ru','ÐŸÐ¸ÑÑŒÐ¼Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(573586,15933,'es','Cartas de clientes',0),(573587,15933,'de','Kundenbriefe',0),(573588,15933,'en','Customer Letters',0),(573589,15934,'is','',0),(573590,15934,'dr','Ú©Ø§Ù…Ù„--Ø§Ø­ØªÛŒØ§Ø·! Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø´Ø±Ú©Øª Ø±Ø§ Ø­Ø°Ù Ø®ÙˆØ§Ù‡Ø¯ Ú©Ø±Ø¯',0),(573591,15934,'pr','Ú©Ø§Ù…Ù„--Ø§Ø­ØªÛŒØ§Ø·! Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ Ø¯Ø± Ø´Ø±Ú©Øª Ø±Ø§ Ø­Ø°Ù Ø®ÙˆØ§Ù‡Ø¯ Ú©Ø±Ø¯',0),(573592,15934,'tr','Tam - dikkat! Åžirketteki varolan verileri siler',0),(573593,15934,'pl','Full - Uwaga! Spowoduje to usuniÄ™cie istniejÄ…cych danych w firmie',0),(573594,15934,'bg','ÐŸÑŠÐ»ÐµÐ½ - Ð²Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ! Ð©Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸Ñ‚Ðµ Ð´Ð°Ð½Ð½Ð¸ Ð² ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ',0),(573595,15934,'ur','Ù¾ÙˆØ±ÛŒ - Ø§Ø­ØªÛŒØ§Ø·! Ú©Ù…Ù¾Ù†ÛŒ Ù…ÛŒÚº Ù…ÙˆØ¬ÙˆØ¯ Ú©ÙˆØ§Ø¦Ù Ø­Ø°Ù Ú©Ø± Ø¯Û’ Ú¯Ø§',0),(573596,15934,'sr','ÐŸÑƒÐ½ - Ð¾Ð¿Ñ€ÐµÐ·! Ð‹Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ñƒ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð¸',0),(573597,15934,'vi','Äáº§y Ä‘á»§ - cáº©n tháº­n! Sáº½ xÃ³a cÃ¡c dá»¯ liá»‡u sáºµn cÃ³ trong cÃ´ng ty',0),(573598,15934,'af','Vol - waarskuwing! Bestaande Data in maatskappy sal skrap',0),(573599,15934,'ro','Full - atenÅ£ie! Va ÅŸterge datele existente Ã®n societate',0),(573600,15934,'et','Full - Ettevaatust! Kustutab olemasoleva ettevÃµtte andmete',0),(573601,15934,'si','Polno - Pozor! Boste izbrisali obstojeÄe podatke v podjetju',0),(573602,15934,'ba','Penuh - hati-hati! Akan menghapus Data yang ada di perusahaan',0),(573603,15934,'nl','Full - Let op! Bestaande gegevens in bedrijf zal verwijderen',0),(573604,15934,'fi','Full - varoitus! Poistaa nykyiset tiedot yrityksen',0),(573605,15934,'no','Full - advarsel! Sletter eksisterende Data i selskapet',0),(573606,15934,'da','Fuld - forsigtighed! Vil slette eksisterende Data i virksomheden',0),(573607,15934,'ko','ì „ì²´-ì£¼ì˜! íšŒì‚¬ì—ì„œ ê¸°ì¡´ ë°ì´í„°ë¥¼ ì‚­ì œ í•©ë‹ˆë‹¤.',0),(573608,15934,'he','. ×ž×œ××” - ×–×”×™×¨×•×ª! ×ª×ž×—×§ ××ª ×”× ×ª×•× ×™× ×”×§×™×™×ž×™× ×‘×—×‘×¨×”',0),(573609,15934,'el','Î Î»Î®ÏÎ·Ï‚ - Ï€ÏÎ¿ÏƒÎ¿Ï‡Î®! Î˜Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÎ¹ Ï„Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± ÏƒÏ„Î·Î½ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(573610,15934,'zh','å…¨-å°å¿ƒ ï¼å°†åˆ é™¤çŽ°æœ‰æ•°æ®å…¬å¸',0),(573611,15934,'sv','Full - varning! Kommer att ta bort befintliga Data i fÃ¶retaget',0),(573612,15934,'it','Pieno - attenzione! Verranno eliminati i dati esistenti in azienda',0),(573613,15934,'tl','',0),(573614,15934,'th','à¹€à¸•à¹‡à¸¡à¸£à¸¹à¸›à¹à¸šà¸š - à¸‚à¹‰à¸­à¸„à¸§à¸£à¸£à¸°à¸§à¸±à¸‡ à¸ˆà¸°à¸¥à¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸šà¸£à¸´à¸©à¸±à¸—',0),(573615,15934,'hi','à¤ªà¥‚à¤°à¥à¤£ - à¤¸à¤¾à¤µà¤§à¤¾à¤¨à¥€! à¤•à¤‚à¤ªà¤¨à¥€ à¤®à¥‡à¤‚ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤¹à¤Ÿà¤¾ à¤¦à¤¿à¤¯à¤¾ à¤œà¤¾à¤à¤—à¤¾',0),(573616,15934,'ms','Penuh - berhati-hati! Akan memadam Data sedia ada dalam Syarikat',0),(573617,15934,'ar','ÙƒØ§Ù…Ù„--ØªØ­Ø°ÙŠØ±! Ø³ÙŠØªÙ… Ø­Ø°Ù Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø© ÙÙŠ Ø§Ù„Ø´Ø±ÙƒØ©',0),(573618,15934,'fr','Complet - attention ! Supprime les donnÃ©es existantes dans la sociÃ©tÃ©',0),(573619,15934,'jp','ãƒ•ãƒ« - æ³¨æ„!ä¼šç¤¾ã®æ—¢å­˜ã®ãƒ‡ãƒ¼ã‚¿ãŒå‰Šé™¤ã•ã‚Œã¾ã™ã€‚',0),(573620,15934,'pt','Completo - cuidado! Vai apagar os dados existentes na empresa',0),(573621,15934,'ru','ÐŸÐ¾Ð»Ð½Ñ‹Ð¹ - Ð¾ÑÑ‚Ð¾Ñ€Ð¾Ð¶Ð½Ð¾! Ð£Ð´Ð°Ð»Ð¸Ñ‚ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð² ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(573622,15934,'es','Completo - atenciÃ³n! Se eliminarÃ¡n los datos existentes en la empresa',0),(573623,15934,'de','Voll - Vorsicht! LÃ¶scht vorhandene Daten in Unternehmen',0),(573624,15934,'en','Full - Caution! Will Delete Existing Data in Company',0),(573625,15935,'is','',0),(573626,15935,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø±Ø§Ø­ØªÛŒ',0),(573627,15935,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø±Ø§Ø­ØªÛŒ',0),(573628,15935,'tr','KolaylÄ±k Ã¼creti',0),(573629,15935,'pl','OpÅ‚ata za wygodÄ™',0),(573630,15935,'bg','Ð¢Ð°ÐºÑÐ° Ð·Ð° ÑƒÐ´Ð¾Ð±ÑÑ‚Ð²Ð¾',0),(573631,15935,'ur','Ø³ÛÙˆÙ„Øª ÙÛŒØ³',0),(573632,15935,'sr','ÐÐ°ÐºÐ½Ð°Ð´Ð° Ð·Ð° Ð¿Ð¾Ð³Ð¾Ð´Ð½Ð¾ÑÑ‚',0),(573633,15935,'vi','Lá»‡ phÃ­ tiá»‡n lá»£i',0),(573634,15935,'af','Gerief fooi',0),(573635,15935,'ro','Taxa de confort',0),(573636,15935,'et','Mugavus Fee',0),(573637,15935,'si','Pristojbina za udobje',0),(573638,15935,'ba','Biaya kenyamanan',0),(573639,15935,'nl','Gemak vergoeding',0),(573640,15935,'fi','Mukavuus maksu',0),(573641,15935,'no','Bekvemmelighet avgift',0),(573642,15935,'da','Bekvemmelighed gebyr',0),(573643,15935,'ko','íŽ¸ì˜ ìˆ˜ìˆ˜ë£Œ',0),(573644,15935,'he','×ª×©×œ×•× × ×•×—×•×ª',0),(573645,15935,'el','Î•Ï€Î¹Ï€Î»Î­Î¿Î½ Î¼Îµ Ï„Î¿ Ï€Î¿ÏƒÏŒ',0),(573646,15935,'zh','ä¾¿åˆ©è´¹',0),(573647,15935,'sv','Avgift fÃ¶r bekvÃ¤mlighet',0),(573648,15935,'it','Tassa di convenienza',0),(573649,15935,'tl','',0),(573650,15935,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸„à¸§à¸²à¸¡à¸ªà¸°à¸”à¸§à¸à¸ªà¸šà¸²à¸¢',0),(573651,15935,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤¶à¥à¤²à¥à¤•',0),(573652,15935,'ms','Bayaran pemprosesan',0),(573653,15935,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ù„Ø§Ø¡Ù…Ø©',0),(573654,15935,'fr','Frais de commoditÃ©',0),(573655,15935,'jp','ã‚³ãƒ³ãƒ“ãƒ‹ã‚¨ãƒ³ã‚¹æ–™',0),(573656,15935,'pt','Taxa de conveniÃªncia',0),(573657,15935,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° ÑƒÐ´Ð¾Ð±ÑÑ‚Ð²Ð¾',0),(573658,15935,'es','Tarifa de conveniencia por',0),(573659,15935,'de','Komfort-GebÃ¼hr',0),(573660,15935,'en','Convenience Fee',0),(573661,15936,'is','',0),(573662,15936,'dr','Ù†Ø³Ø®Ù‡ Ù¾Ø§ÛŒÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ù…Ù†Ø³ÙˆØ® Ø´Ø¯Ù‡',0),(573663,15936,'pr','Ù†Ø³Ø®Ù‡ Ù¾Ø§ÛŒÚ¯Ø§Ù‡ Ø¯Ø§Ø¯Ù‡ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ù…Ù†Ø³ÙˆØ® Ø´Ø¯Ù‡',0),(573664,15936,'tr','VeritabanÄ± sÃ¼rÃ¼mÃ¼ gÃ¼ncelliÄŸini yitirmiÅŸ olabilir',0),(573665,15936,'pl','Wersja bazy danych moÅ¼e byÄ‡ nieaktualna',0),(573666,15936,'bg','Ð’ÐµÑ€ÑÐ¸ÑÑ‚Ð° Ð½Ð° Ð±Ð°Ð·Ð°Ñ‚Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¾ÑÑ‚Ð°Ñ€ÑÐ»Ð°',0),(573667,15936,'ur','Ú©ÙˆØ§Ø¦ÙÛŒÛ ÙˆØ±Ú˜Ù† Ù¾Ø±Ø§Ù†ÛŒ ÛÙˆ Ø³Ú©ØªØ§ ÛÛ’',0),(573668,15936,'sr','Ð’ÐµÑ€Ð·Ð¸Ñ˜Ð° Ð±Ð°Ð·Ðµ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ð¼Ð¾Ð¶Ð´Ð° Ñ˜Ðµ Ð·Ð°ÑÑ‚Ð°Ñ€Ð¸Ð¾',0),(573669,15936,'vi','PhiÃªn báº£n cÆ¡ sá»Ÿ dá»¯ liá»‡u cÃ³ thá»ƒ lÃ  lá»—i thá»i',0),(573670,15936,'af','Databasis weergawe is dalk verouderd',0),(573671,15936,'ro','Versiunea bazei de date pot fi depÄƒÅŸite',0),(573672,15936,'et','Andmebaasi versioon vÃµib olla aegunud',0),(573673,15936,'si','RazliÄica zbirke podatkov so lahko zastareli',0),(573674,15936,'ba','Database versi dapat usang',0),(573675,15936,'nl','Databaseversie kan worden achterhaald',0),(573676,15936,'fi','Tietokannan versio saattaa olla vanhentunutta',0),(573677,15936,'no','Databaseversjonen kan vÃ¦re utdatert',0),(573678,15936,'da','Databaseversionen kan vÃ¦re forÃ¦ldet',0),(573679,15936,'ko','ë°ì´í„°ë² ì´ìŠ¤ ë²„ì „ì€ ì˜¤ëž˜ ëœ ìžˆì„ ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(573680,15936,'he','×”×’×™×¨×¡×” ×©×œ ×ž×¡×“ ×”× ×ª×•× ×™× ×¢×œ×•×œ ×œ×”×™×•×ª ×ž×™×•×©×Ÿ',0),(573681,15936,'el','ÎˆÎºÎ´Î¿ÏƒÎ· Î²Î¬ÏƒÎ·Ï‚ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÎ¯Î½Î±Î¹ Ï€Î±ÏÏ‰Ï‡Î·Î¼Î­Î½ÎµÏ‚',0),(573682,15936,'zh','æ•°æ®åº“ç‰ˆæœ¬å¯èƒ½å·²ç»è¿‡æ—¶',0),(573683,15936,'sv','Databasversionen kan vara fÃ¶rÃ¥ldrad',0),(573684,15936,'it','Versione del database puÃ² essere superata',0),(573685,15936,'tl','',0),(573686,15936,'th','à¹€à¸§à¸­à¸£à¹Œà¸Šà¸±à¸™à¸à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸­à¸²à¸ˆà¸ˆà¸°à¸¥à¹‰à¸²à¸ªà¸¡à¸±à¸¢',0),(573687,15936,'hi','à¤¡à¥‡à¤Ÿà¤¾à¤¬à¥‡à¤¸ à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤ªà¥à¤°à¤¾à¤¨à¤¾ à¤¹à¥‹ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ',0),(573688,15936,'ms','Versi pangkalan data mungkin ketinggalan zaman',0),(573689,15936,'ar','Ù‚Ø¯ ÙŠÙƒÙˆÙ† Ø¥ØµØ¯Ø§Ø± Ù‚Ø§Ø¹Ø¯Ø© Ø¨ÙŠØ§Ù†Ø§Øª Ù‚Ø¯ÙŠÙ…Ø©',0),(573690,15936,'fr','Version de base de donnÃ©es peut Ãªtre pÃ©rimÃ©e',0),(573691,15936,'jp','ãƒ‡ãƒ¼ã‚¿ãƒ™ãƒ¼ã‚¹ã®ãƒãƒ¼ã‚¸ãƒ§ãƒ³ãŒå¤ã„å¯èƒ½æ€§ãŒã‚ã‚Šã¾ã™ã€‚',0),(573692,15936,'pt','VersÃ£o do banco de dados pode estar desatualizado',0),(573693,15936,'ru','Ð’ÐµÑ€ÑÐ¸Ñ Ð±Ð°Ð·Ñ‹ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ ÑƒÑÑ‚Ð°Ñ€ÐµÐ²ÑˆÐ¸Ð¼Ð¸',0),(573694,15936,'es','VersiÃ³n de la base de datos puede ser anticuado',0),(573695,15936,'de','Datenbankversion kann Ã¼berholt sein.',0),(573696,15936,'en','Database Version May Be Outdated',0),(573697,15937,'is','',0),(573698,15937,'dr','Ø¯Ø± ØµÙˆØ±Øª Ø§Ø¯Ø§Ù…Ù‡ Ø§ÛŒÙ† Ù…Ø´Ú©Ù„ Ù„Ø·ÙØ§ Ø§Ù†Ø¬Ø§Ù… Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¯Ø³ØªÛŒ',0),(573699,15937,'pr','Ø¯Ø± ØµÙˆØ±Øª Ø§Ø¯Ø§Ù…Ù‡ Ø§ÛŒÙ† Ù…Ø´Ú©Ù„ Ù„Ø·ÙØ§ Ø§Ù†Ø¬Ø§Ù… Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ø¯Ø³ØªÛŒ',0),(573700,15937,'tr','Bu sorun devam ederse lÃ¼tfen el ile gÃ¼ncelleÅŸtirme gerÃ§ekleÅŸtirmek',0),(573701,15937,'pl','JeÅ›li ten Problem bÄ™dzie siÄ™ powtarzaÅ‚, naleÅ¼y wykonaÄ‡ rÄ™cznÄ… aktualizacjÄ™',0),(573702,15937,'bg','ÐÐºÐ¾ Ñ‚Ð¾Ð·Ð¸ Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼ Ð¿Ñ€Ð¾Ð´ÑŠÐ»Ð¶Ð°Ð²Ð° Ð¼Ð¾Ð»Ñ ÑÐµ Ð¸Ð·Ð²ÑŠÑ€ÑˆÐ²Ð° Ñ€ÑŠÑ‡Ð½Ð¾ Ð¾Ð±Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ',0),(573703,15937,'ur','Ø§Ú¯Ø± Ù…Ø³Ø¦Ù„Û Ø¬Ø§Ø±ÛŒ Ø±ÛÛ’ ØªÙˆ Ø§ÛŒÚ© Ø¯Ø³ØªÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº Ø³Ø±Ø§Ù†Ø¬Ø§Ù… Ø¯ÛŒÚº',0),(573704,15937,'sr','ÐÐºÐ¾ ÐŸÑ€Ð¾Ð±Ð»ÐµÐ¼ Ð¿Ð¾Ñ‚Ñ€Ð°Ñ˜Ðµ, Ð¼Ð¾Ð»Ð¸Ð¼ Ð²Ð°Ñ Ð¸Ð·Ð²Ñ€ÑˆÐ¸Ñ‚Ðµ Ñ€ÑƒÑ‡Ð½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ',0),(573705,15937,'vi','Náº¿u váº¥n Ä‘á» nÃ y váº«n tiáº¿p tá»¥c xin vui lÃ²ng thá»±c hiá»‡n má»™t Cáº­p Nháº­t hÆ°á»›ng dáº«n sá»­ dá»¥ng',0),(573706,15937,'af','As hierdie probleem aanhou voer asseblief \'n handmatige bywerking',0),(573707,15937,'ro','DacÄƒ aceastÄƒ problemÄƒ persistÄƒ, vÄƒ rugÄƒm sÄƒ efectuaÅ£i o actualizare manualÄƒ',0),(573708,15937,'et','Kui probleem ei lahene palun tÃ¤ita kÃ¤sitsi Update',0),(573709,15937,'si','ÄŒe teÅ¾ave ne morete odpraviti izvedite RoÄna posodobitev',0),(573710,15937,'ba','Jika masalah ini berlanjut silahkan melakukan Manual Update',0),(573711,15937,'nl','Als het probleem blijft bestaan gelieve een handmatige Update uitvoeren',0),(573712,15937,'fi','Jos ongelma ei poistu suorita manuaalinen pÃ¤ivitys',0),(573713,15937,'no','Hvis problemet vedvarer behage oppdatere manuelt',0),(573714,15937,'da','Hvis problemet fortsÃ¦tter skal du udfÃ¸re en manuel opdatering',0),(573715,15937,'ko','ì´ ë¬¸ì œê°€ ê³„ì† ë°œìƒ í•˜ëŠ” ê²½ìš° ìˆ˜ë™ ì—…ë°ì´íŠ¸ë¥¼ ìˆ˜í–‰ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(573716,15937,'he','×× ×‘×¢×™×” ×–×• × ×ž×©×›×ª ×‘×‘×§×©×” ×œ×‘×™×¦×•×¢ ×¢×“×›×•×Ÿ ×™×“× ×™',0),(573717,15937,'el','Î•Î¬Î½ Ï„Î¿ Ï€ÏÏŒÎ²Î»Î·Î¼Î± Î´ÎµÎ½ ÎµÏ€Î¹Î»Ï…Î¸ÎµÎ¯, ÎµÎºÏ„ÎµÎ»Î­ÏƒÏ„Îµ Î¼Î¹Î± Î¼Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(573718,15937,'zh','å¦‚æžœæ­¤é—®é¢˜ä»ç„¶å­˜åœ¨ï¼Œè¯·æ‰§è¡Œæ‰‹åŠ¨æ›´æ–°',0),(573719,15937,'sv','Om problemet kvarstÃ¥r VÃ¤nligen utfÃ¶ra en manuell uppdatering',0),(573720,15937,'it','Se il problema persiste si prega di eseguire un aggiornamento manuale',0),(573721,15937,'tl','',0),(573722,15937,'th','à¸–à¹‰à¸²à¸›à¸±à¸à¸«à¸²à¸™à¸µà¹‰à¸¢à¸±à¸‡à¸„à¸‡à¸¡à¸µà¸­à¸¢à¸¹à¹ˆ à¹‚à¸›à¸£à¸”à¸—à¸³à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(573723,15937,'hi','à¤¯à¤¦à¤¿ à¤¯à¤¹ à¤¸à¤®à¤¸à¥à¤¯à¤¾ à¤¬à¤¨à¥€ à¤°à¤¹à¤¤à¥€ à¤¹à¥ˆ, à¤¤à¥‹ à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡',0),(573724,15937,'ms','Jika masalah ini berterusan sila melakukan kaedah pengemaskinian Manual yang',0),(573725,15937,'ar','Ø¥Ø°Ø§ Ø§Ø³ØªÙ…Ø±Øª Ù‡Ø°Ù‡ Ø§Ù„Ù…Ø´ÙƒÙ„Ø© Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø§Ù„Ù‚ÙŠØ§Ù… Ø¨Ø¹Ù…Ù„ÙŠØ© ØªØ­Ø¯ÙŠØ« ÙŠØ¯ÙˆÙŠ',0),(573726,15937,'fr','Si le problÃ¨me persiste veuillez effectuer une mise Ã  jour manuelle',0),(573727,15937,'jp','ã“ã®å•é¡ŒãŒç¶šãå ´åˆã¯ã€æ‰‹å‹•ã§æ›´æ–°ã‚’å®Ÿè¡Œã—ã¦ãã ã•ã„ã€‚',0),(573728,15937,'pt','Se este problema persistir, por favor, realize uma atualizaÃ§Ã£o Manual',0),(573729,15937,'ru','Ð•ÑÐ»Ð¸ ÑÑ‚Ð° Ð¿Ñ€Ð¾Ð±Ð»ÐµÐ¼Ð° Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶Ð°ÐµÑ‚ Ð²Ñ‹Ð¿Ð¾Ð»Ð½Ð¸Ñ‚Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð²Ñ€ÑƒÑ‡Ð½ÑƒÑŽ',0),(573730,15937,'es','Si el problema persiste por favor realizar una actualizaciÃ³n Manual',0),(573731,15937,'de','Wenn dieses Problem weiterhin besteht, fÃ¼hren Sie eine manuelle Aktualisierung',0),(573732,15937,'en','If This Problem Continues Please Perform A Manual Update',0),(573733,15938,'is','',0),(573734,15938,'dr','Ù…Ø´ØªØ±ÛŒ Ø§Ø¸Ù‡Ø§Ø±Ø§Øª',0),(573735,15938,'pr','Ù…Ø´ØªØ±ÛŒ Ø§Ø¸Ù‡Ø§Ø±Ø§Øª',0),(573736,15938,'tr','MÃ¼ÅŸteri ifadeleri',0),(573737,15938,'pl','Opinie klientÃ³w',0),(573738,15938,'bg','ÐÐ° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¸Ñ‚Ðµ Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¸',0),(573739,15938,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ø¨ÛŒØ§Ù†Ø§Øª',0),(573740,15938,'sr','Ð˜Ð·Ñ˜Ð°Ð²Ðµ ÐºÑƒÐ¿Ð°Ñ†Ð°',0),(573741,15938,'vi','BÃ¡o cÃ¡o khÃ¡ch hÃ ng',0),(573742,15938,'af','KliÃ«nt state',0),(573743,15938,'ro','Declaratiile clientilor',0),(573744,15938,'et','Kliendi aruanded',0),(573745,15938,'si','Izjav strank',0),(573746,15938,'ba','Pernyataan pelanggan',0),(573747,15938,'nl','Rekeningoverzichten voor klanten',0),(573748,15938,'fi','Asiakkaan tiliotteet',0),(573749,15938,'no','Kontoutdrag for kunde',0),(573750,15938,'da','Kundeudtalelser',0),(573751,15938,'ko','ê³ ê° ë¬¸',0),(573752,15938,'he','×”×¦×”×¨×•×ª ×”×œ×§×•×—',0),(573753,15938,'el','Î”Î·Î»ÏŽÏƒÎµÎ¹Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(573754,15938,'zh','å®¢æˆ·å¯¹å¸å•',0),(573755,15938,'sv','Kundutdrag',0),(573756,15938,'it','Istruzioni del cliente',0),(573757,15938,'tl','',0),(573758,15938,'th','à¸‡à¸šà¸à¸²à¸£à¹€à¸‡à¸´à¸™à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(573759,15938,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¥à¤¨à¥‹à¤‚',0),(573760,15938,'ms','Baca penyata',0),(573761,15938,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(573762,15938,'fr','RelevÃ©s des clients',0),(573763,15938,'jp','é¡§å®¢å‘ã‘æ˜Žç´°æ›¸',0),(573764,15938,'pt','DeclaraÃ§Ãµes do cliente',0),(573765,15938,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(573766,15938,'es','Declaraciones del cliente',0),(573767,15938,'de','Kunden-Statements',0),(573768,15938,'en','Customer Statements',0),(573769,15939,'is','',0),(573770,15939,'dr','ÙÚ©Ø³ ÙØ±Ø³ØªØ§Ø¯Ù‡',0),(573771,15939,'pr','ÙÚ©Ø³ ÙØ±Ø³ØªØ§Ø¯Ù‡',0),(573772,15939,'tr','Faks gÃ¶nderildi',0),(573773,15939,'pl','Faks wysyÅ‚any',0),(573774,15939,'bg','Ð¤Ð°ÐºÑ Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½',0),(573775,15939,'ur','Ù…Ø±Ø³Ù„Û ÙÛŒÚ©Ø³',0),(573776,15939,'sr','ÐŸÐ¾ÑÐ»Ð°Ñ‚Ð¸ Ñ„Ð°ÐºÑ',0),(573777,15939,'vi','Gá»­i Fax',0),(573778,15939,'af','Faks gestuur',0),(573779,15939,'ro','Fax trimis',0),(573780,15939,'et','Saadetud Faks',0),(573781,15939,'si','Faks poslan',0),(573782,15939,'ba','Fax dikirim',0),(573783,15939,'nl','Fax verzonden',0),(573784,15939,'fi','Faksi lÃ¤hetetty',0),(573785,15939,'no','Telefaks som sendes',0),(573786,15939,'da','Fax sendes',0),(573787,15939,'ko','íŒ©ìŠ¤ ì „ì†¡',0),(573788,15939,'he','×¤×§×¡ ×©× ×©×œ×—',0),(573789,15939,'el','ÎˆÏƒÏ„ÎµÎ¹Î»Îµ Ï†Î±Î¾',0),(573790,15939,'zh','å‘é€ä¼ çœŸ',0),(573791,15939,'sv','Fax som skickas',0),(573792,15939,'it','Fax inviato',0),(573793,15939,'tl','',0),(573794,15939,'th','à¸ªà¹ˆà¸‡à¹‚à¸—à¸£à¸ªà¸²à¸£',0),(573795,15939,'hi','à¤­à¥‡à¤œà¥‡ à¤—à¤ à¤«à¤¼à¥ˆà¤•à¥à¤¸',0),(573796,15939,'ms','Perkhidmatan Faks yang dihantar',0),(573797,15939,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„ÙØ§ÙƒØ³',0),(573798,15939,'fr','Fax envoyÃ©',0),(573799,15939,'jp','Fax é€ä¿¡',0),(573800,15939,'pt','Fax enviado',0),(573801,15939,'ru','ÐžÑ‚Ð¾ÑÐ»Ð°Ñ‚ÑŒ Ð¤Ð°ÐºÑ',0),(573802,15939,'es','Fax enviado',0),(573803,15939,'de','Fax gesendet',0),(573804,15939,'en','Fax Sent',0),(573805,15940,'is','',0),(573806,15940,'dr','ÙˆØ±ÙˆØ¯ Ú©Ø§Ø±Ø¨Ø±',0),(573807,15940,'pr','ÙˆØ±ÙˆØ¯ Ú©Ø§Ø±Ø¨Ø±',0),(573808,15940,'tr','El ile giriÅŸ',0),(573809,15940,'pl','RÄ™czne wprowadzanie',0),(573810,15940,'bg','Ð ÑŠÑ‡Ð½Ð¾ Ð²ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ',0),(573811,15940,'ur','Ø¯Ø³ØªÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(573812,15940,'sr','Ð ÑƒÑ‡Ð½Ð¸ ÑƒÐ½Ð¾Ñ',0),(573813,15940,'vi','Má»¥c hÆ°á»›ng dáº«n sá»­ dá»¥ng',0),(573814,15940,'af','Handleiding inskrywing',0),(573815,15940,'ro','Intrare manualÄƒ',0),(573816,15940,'et','KÃ¤sitsi sisestamine',0),(573817,15940,'si','RoÄni vnos',0),(573818,15940,'ba','Entri manual',0),(573819,15940,'nl','Handmatige invoer',0),(573820,15940,'fi','Manuaalinen kirjaus',0),(573821,15940,'no','Manuell registrering',0),(573822,15940,'da','Manuel indtastning',0),(573823,15940,'ko','ìˆ˜ë™ ìž…ë ¥',0),(573824,15940,'he','×”×¤×¢×œ×” ×™×“× ×™×ª',0),(573825,15940,'el','Î§ÎµÎ¹ÏÎ¿ÎºÎ¯Î½Î·Ï„Î· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ¹ÏƒÎ·',0),(573826,15940,'zh','æ‰‹åŠ¨è¾“å…¥',0),(573827,15940,'sv','Manuell inmatning',0),(573828,15940,'it','Inserimento manuale',0),(573829,15940,'tl','',0),(573830,15940,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(573831,15940,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(573832,15940,'ms','Manual kemasukan',0),(573833,15940,'ar','Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„ Ø§Ù„ÙŠØ¯ÙˆÙŠ',0),(573834,15940,'fr','Saisie manuelle',0),(573835,15940,'jp','æ‰‹å‹•å…¥åŠ›',0),(573836,15940,'pt','Entrada manual',0),(573837,15940,'ru','Ð ÑƒÑ‡Ð½Ð¾Ð¹ Ð²Ð²Ð¾Ð´',0),(573838,15940,'es','Entrada manual',0),(573839,15940,'de','Manuelle Eingabe',0),(573840,15940,'en','Manual Entry',0),(573841,15941,'is','',0),(573842,15941,'dr','Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯',0),(573843,15941,'pr','Ø§Ø±Ø³Ø§Ù„ Ù†Ø´Ø¯',0),(573844,15941,'tr','GÃ¶nderme baÅŸarÄ±sÄ±z oldu',0),(573845,15941,'pl','WysyÅ‚anie nie powiodÅ‚o siÄ™',0),(573846,15941,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ',0),(573847,15941,'ur','Ù†Ø§Ú©Ø§Ù… Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(573848,15941,'sr','ÐÐµÑƒÑÐ¿ÐµÐ»Ð¾ ÑÐ»Ð°ÑšÐµ',0),(573849,15941,'vi','Gá»­i tháº¥t báº¡i',0),(573850,15941,'af','Stuur het misluk',0),(573851,15941,'ro','Trimitere nu a reuÈ™it',0),(573852,15941,'et','Saatmine nurjus',0),(573853,15941,'si','PoÅ¡iljanje sporoÄila ni uspelo',0),(573854,15941,'ba','Kirim gagal',0),(573855,15941,'nl','Verzenden mislukt',0),(573856,15941,'fi','LÃ¤hettÃ¤minen epÃ¤onnistui',0),(573857,15941,'no','Sendingen mislyktes',0),(573858,15941,'da','Send mislykkedes',0),(573859,15941,'ko','ì†¡ì‹  ì‹¤íŒ¨',0),(573860,15941,'he','×©×œ×™×—×” × ×›×©×œ×”',0),(573861,15941,'el','Î‘Ï€Î¿Ï„Ï…Ï‡Î¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(573862,15941,'zh','å‘é€å¤±è´¥',0),(573863,15941,'sv','Skicka misslyckades',0),(573864,15941,'it','Invio non riuscito',0),(573865,15941,'tl','',0),(573866,15941,'th','à¸ªà¹ˆà¸‡à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(573867,15941,'hi','à¤­à¥‡à¤œà¤¨à¤¾ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(573868,15941,'ms','Hantar yang gagal',0),(573869,15941,'ar','ÙØ´Ù„ Ø§Ù„Ø¥Ø±Ø³Ø§Ù„',0),(573870,15941,'fr','Envoi a Ã©chouÃ©',0),(573871,15941,'jp','é€ä¿¡ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(573872,15941,'pt','Envio falhado',0),(573873,15941,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ',0),(573874,15941,'es','No se pudo enviar',0),(573875,15941,'de','Fehler beim Senden',0),(573876,15941,'en','Send Failed',0),(573877,15942,'is','',0),(573878,15942,'dr','Ø§Ø±Ø³Ø§Ù„ ÙÚ©Ø³ Ø¨Ù‡',0),(573879,15942,'pr','Ø§Ø±Ø³Ø§Ù„ ÙÚ©Ø³ Ø¨Ù‡',0),(573880,15942,'tr','Faksa gÃ¶nder',0),(573881,15942,'pl','WysÅ‚aÄ‡ faks do',0),(573882,15942,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ñ„Ð°ÐºÑ Ð´Ð¾',0),(573883,15942,'ur','ÙÛŒÚ©Ø³ Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(573884,15942,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ñ„Ð°ÐºÑ',0),(573885,15942,'vi','Gá»­i Fax Ä‘áº¿n',0),(573886,15942,'af','Stuur faks na',0),(573887,15942,'ro','Trimite Fax la',0),(573888,15942,'et','Saatke faksi',0),(573889,15942,'si','PoÅ¡lji faks',0),(573890,15942,'ba','Kirim Fax ke',0),(573891,15942,'nl','Fax te verzenden',0),(573892,15942,'fi','LÃ¤hetÃ¤ Faksi',0),(573893,15942,'no','Sende faks',0),(573894,15942,'da','Send Fax til',0),(573895,15942,'ko','íŒ©ìŠ¤ë¥¼ ë³´ë‚´',0),(573896,15942,'he','×œ×©×œ×•×— ×¤×§×¡',0),(573897,15942,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Ï†Î±Î¾ Î³Î¹Î± Î½Î±',0),(573898,15942,'zh','å‘é€ä¼ çœŸè‡³',0),(573899,15942,'sv','Skicka Fax till',0),(573900,15942,'it','Inviare Fax al',0),(573901,15942,'tl','',0),(573902,15942,'th','à¸ªà¹ˆà¸‡à¹‚à¸—à¸£à¸ªà¸²à¸£',0),(573903,15942,'hi','à¤«à¤¼à¥ˆà¤•à¥à¤¸ à¤­à¥‡à¤œà¥‡à¤‚',0),(573904,15942,'ms','Hantar Faks ke',0),(573905,15942,'ar','Ø¥Ø±Ø³Ø§Ù„ ÙØ§ÙƒØ³ Ø¥Ù„Ù‰',0),(573906,15942,'fr','Envoyer des Fax Ã ',0),(573907,15942,'jp','Fax ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(573908,15942,'pt','Enviar Fax para',0),(573909,15942,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¤Ð°ÐºÑ',0),(573910,15942,'es','Enviar Fax a',0),(573911,15942,'de','Fax gesendet',0),(573912,15942,'en','Send Fax To',0),(573913,15943,'is','',0),(573914,15943,'dr','ØªØ§Ø±ÛŒØ® ÙˆØ±ÙˆØ¯',0),(573915,15943,'pr','ØªØ§Ø±ÛŒØ® ÙˆØ±ÙˆØ¯',0),(573916,15943,'tr','GiriÅŸ tarihi',0),(573917,15943,'pl','Data wejÅ›cia',0),(573918,15943,'bg','Ð’Ð»Ð¸Ð·Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð°',0),(573919,15943,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(573920,15943,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð°',0),(573921,15943,'vi','Nháº­p ngÃ y',0),(573922,15943,'af','Datum van inskrywing',0),(573923,15943,'ro','Data de intrare',0),(573924,15943,'et','Kande kuupÃ¤ev',0),(573925,15943,'si','Datum vnosa',0),(573926,15943,'ba','Tanggal entri',0),(573927,15943,'nl','Datum van ingang',0),(573928,15943,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(573929,15943,'no','OppfÃ¸ringsdatoen',0),(573930,15943,'da','Tilmeldningsfrist',0),(573931,15943,'ko','ìž…êµ­ ë‚ ì§œ',0),(573932,15943,'he','×ª××¨×™×š ×›× ×™×¡×”',0),(573933,15943,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎµÎ³Î³ÏÎ±Ï†Î®Ï‚',0),(573934,15943,'zh','è¾“å…¥æ—¥æœŸ',0),(573935,15943,'sv','Bloggpostens datum',0),(573936,15943,'it','Data di inserimento',0),(573937,15943,'tl','',0),(573938,15943,'th','à¸§à¸±à¸™à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£',0),(573939,15943,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(573940,15943,'ms','Tarikh kemasukan',0),(573941,15943,'ar','ØªØ§Ø±ÙŠØ® Ø¯Ø®ÙˆÙ„',0),(573942,15943,'fr','Date dâ€™entrÃ©e',0),(573943,15943,'jp','è¨˜å…¥é …ç›®ã®æ—¥ä»˜',0),(573944,15943,'pt','Data de entrada',0),(573945,15943,'ru','Ð”Ð°Ñ‚Ð° Ð²ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ',0),(573946,15943,'es','Fecha de entrada',0),(573947,15943,'de','Erfassungsdatum',0),(573948,15943,'en','Entry Date',0),(573949,15944,'is','',0),(573950,15944,'dr','Ø®Ø·Ø§Ù‡Ø§ÛŒ',0),(573951,15944,'pr','Ø®Ø·Ø§Ù‡Ø§ÛŒ',0),(573952,15944,'tr','HatalarÄ±',0),(573953,15944,'pl','BÅ‚Ä™dy',0),(573954,15944,'bg','Ð“Ñ€ÐµÑˆÐºÐ¸',0),(573955,15944,'ur','Ù†Ù‚Ø§Ø¦Øµ',0),(573956,15944,'sr','Ð“Ñ€ÐµÑˆÐºÐµ',0),(573957,15944,'vi','Lá»—i',0),(573958,15944,'af','Foute',0),(573959,15944,'ro','Erori',0),(573960,15944,'et','Vead',0),(573961,15944,'si','Napake',0),(573962,15944,'ba','Kesalahan',0),(573963,15944,'nl','Fouten',0),(573964,15944,'fi','VirheitÃ¤',0),(573965,15944,'no','Feil',0),(573966,15944,'da','Fejl',0),(573967,15944,'ko','ì˜¤ë¥˜',0),(573968,15944,'he','×©×’×™××•×ª',0),(573969,15944,'el','Î£Ï†Î¬Î»Î¼Î±Ï„Î±',0),(573970,15944,'zh','é”™è¯¯',0),(573971,15944,'sv','Fel',0),(573972,15944,'it','Errori',0),(573973,15944,'tl','',0),(573974,15944,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(573975,15944,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(573976,15944,'ms','Ralat',0),(573977,15944,'ar','Ø£Ø®Ø·Ø§Ø¡',0),(573978,15944,'fr','Erreurs',0),(573979,15944,'jp','ã‚¨ãƒ©ãƒ¼',0),(573980,15944,'pt','Erros de',0),(573981,15944,'ru','ÐžÑˆÐ¸Ð±ÐºÐ¸',0),(573982,15944,'es','Errores',0),(573983,15944,'de','Fehler',0),(573984,15944,'en','Errors',0),(573985,15945,'is','',0),(573986,15945,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… ÙˆØ§Ø±Ø¯Ø§Øª',0),(573987,15945,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… ÙˆØ§Ø±Ø¯Ø§Øª',0),(573988,15945,'tr','Alma gÃ¼nlÃ¼ÄŸÃ¼',0),(573989,15945,'pl','Dziennik importu',0),(573990,15945,'bg','Ð ÐµÐ³Ð¸ÑÑ‚Ñ€Ð°Ñ†Ð¸Ð¾Ð½ÐµÐ½ Ñ„Ð°Ð¹Ð» Ð½Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(573991,15945,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº',0),(573992,15945,'sr','Ð•Ð²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ð° ÑƒÐ²Ð¾Ð·Ð°',0),(573993,15945,'vi','ÄÄƒng nháº­p',0),(573994,15945,'af','Invoer Log',0),(573995,15945,'ro','Import Log',0),(573996,15945,'et','Impordilogi',0),(573997,15945,'si','Dnevnik uvoza',0),(573998,15945,'ba','Impor Log',0),(573999,15945,'nl','Importlogboek',0),(574000,15945,'fi','Tuontilokin',0),(574001,15945,'no','Importloggen',0),(574002,15945,'da','Importlogfilen',0),(574003,15945,'ko','ê°€ì ¸ì˜¤ê¸° ë¡œê·¸',0),(574004,15945,'he','×™×•×ž×Ÿ ×”×™×™×‘×•×',0),(574005,15945,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ ÎºÎ±Ï„Î±Î³ÏÎ±Ï†Î®Ï‚ Ï„Ï‰Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³ÏŽÎ½',0),(574006,15945,'zh','å¯¼å…¥æ—¥å¿—',0),(574007,15945,'sv','Importloggen',0),(574008,15945,'it','Registro di importazione',0),(574009,15945,'tl','',0),(574010,15945,'th','à¸¥à¹‡à¸­à¸à¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(574011,15945,'hi','à¤†à¤¯à¤¾à¤¤ à¤²à¥‰à¤—',0),(574012,15945,'ms','Import Log',0),(574013,15945,'ar','Ø³Ø¬Ù„ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(574014,15945,'fr','Journal dâ€™importation',0),(574015,15945,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ãƒ­ã‚°',0),(574016,15945,'pt','Log de importaÃ§Ã£o',0),(574017,15945,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(574018,15945,'es','Registro de importaciÃ³n',0),(574019,15945,'de','Import-Protokoll',0),(574020,15945,'en','Import Log',0),(574021,15946,'is','',0),(574022,15946,'dr','Ø¢Ø®Ø±ÛŒÙ† Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(574023,15946,'pr','Ø¢Ø®Ø±ÛŒÙ† Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(574024,15946,'tr','Son YayÄ±nlanan',0),(574025,15946,'pl','Ostatnio wysÅ‚any',0),(574026,15946,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ð¾',0),(574027,15946,'ur','Ø¢Ø®Ø±ÛŒ Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(574028,15946,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿ÑƒÑ‚ Ð±Ð¸Ð¾ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½',0),(574029,15946,'vi','Má»›i Ä‘Æ°á»£c Ä‘Äƒng',0),(574030,15946,'af','Laaste gepos',0),(574031,15946,'ro','Ultimele postat',0),(574032,15946,'et','Viimati postitatud',0),(574033,15946,'si','Zadnje objavljeno',0),(574034,15946,'ba','Terakhir dikirim',0),(574035,15946,'nl','Laatst gepost',0),(574036,15946,'fi','Viimeksi lÃ¤hetetty',0),(574037,15946,'no','Sist postet',0),(574038,15946,'da','Sidst har bogfÃ¸rt',0),(574039,15946,'ko','ë§ˆì§€ë§‰ìœ¼ë¡œ ê²Œì‹œ',0),(574040,15946,'he','×œ××—×¨×•× ×” ×¤×•×¨×¡×',0),(574041,15946,'el','Î”Î·Î¼Î¿ÏƒÎ¹ÎµÏÏ„Î·ÎºÎµ Ï„Î¿ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿',0),(574042,15946,'zh','æœ€åŽå‘å¸ƒ',0),(574043,15946,'sv','Senast Inlagd',0),(574044,15946,'it','Ultimo inviato',0),(574045,15946,'tl','',0),(574046,15946,'th','à¹‚à¸žà¸ªà¸•à¹Œà¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(574047,15946,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(574048,15946,'ms','Buat Posted',0),(574049,15946,'ar','Ù…ÙˆÙ‚Ø¹ Ø¢Ø®Ø±',0),(574050,15946,'fr','Dernier message',0),(574051,15946,'jp','æœ€å¾Œã®æŠ•ç¨¿',0),(574052,15946,'pt','Ãšltimo Postado',0),(574053,15946,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ðµ Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ°Ñ†Ð¸Ð¸',0),(574054,15946,'es','Ultima Publicada',0),(574055,15946,'de','Zuletzt gepostet',0),(574056,15946,'en','Last Posted',0),(574057,15947,'is','',0),(574058,15947,'dr','ØªÚ©Ø±Ø§Ø±ÛŒ Ø§Ø±Ø³Ø§Ù„ Ú©ÙˆÙ¾Ù† Ø¨Ù‡ ØªØ§Ø±ÛŒØ®',0),(574059,15947,'pr','ØªÚ©Ø±Ø§Ø±ÛŒ Ø§Ø±Ø³Ø§Ù„ Ú©ÙˆÙ¾Ù† Ø¨Ù‡ ØªØ§Ø±ÛŒØ®',0),(574060,15947,'tr','Yinelenen fiÅŸ mesaja tarihleri',0),(574061,15947,'pl','Cykliczne Post Voucher do daty',0),(574062,15947,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡ÐµÐ½ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¿Ð¾ÑÑ‚ Ð² Ð´Ð°Ñ‚Ð¸',0),(574063,15947,'ur','ØªØ§Ø±ÛŒØ®ÙˆÚº Ú©Ùˆ Ù…Ú©Ø±Ø± ÙˆØ§Ø¤Ú†Ø± Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº',0),(574064,15947,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ ÐŸÐ¾ÑÑ‚ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð·Ð° Ð´Ð°Ñ‚ÑƒÐ¼Ðµ',0),(574065,15947,'vi','Äá»‹nh ká»³ phiáº¿u Ä‘Äƒng ngÃ y',0),(574066,15947,'af','Herhalende bewys pos aan datums',0),(574067,15947,'ro','Recurente Voucher Post la datele',0),(574068,15947,'et','Korduva kande Post kuupÃ¤evad',0),(574069,15947,'si','PonavljajoÄe se kupon Post na datume',0),(574070,15947,'ba','Posting Voucher berulang untuk tanggal',0),(574071,15947,'nl','Terugkerende Voucher Post naar datums',0),(574072,15947,'fi','Toistuva tosite postitse pÃ¤ivÃ¤mÃ¤Ã¤riÃ¤',0),(574073,15947,'no','Regelmessige bilaget Post datoer',0),(574074,15947,'da','Tilbagevendende Voucher Post til datoer',0),(574075,15947,'ko','ë‚ ì§œì— ë˜í’€ì´ ë°”ìš°ì²˜ ê²Œì‹œë¬¼',0),(574076,15947,'he','×¤×•×¡×˜ ×©×•×‘×¨ ×—×•×–×¨×•×ª ×œ×ª××¨×™×›×™×',0),(574077,15947,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Post Î½Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯ÎµÏ‚',0),(574078,15947,'zh','å®šæœŸå‡­è¯é‚®é€’æ–¹å¼é€äº¤æ—¥æœŸ',0),(574079,15947,'sv','Ã…terkommande verifikationen Post till datum',0),(574080,15947,'it','Ricorrenti Voucher Post date',0),(574081,15947,'tl','',0),(574082,15947,'th','à¹€à¸à¸´à¸”à¸‹à¹‰à¸³à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸¥à¸‡à¸§à¸±à¸™à¸—à¸µà¹ˆ',0),(574083,15947,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ Voucher à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¤¿à¤¥à¤¿à¤¯à¤¾à¤',0),(574084,15947,'ms','Berulang pos baucar tarikh',0),(574085,15947,'ar','ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥ÙŠØµØ§Ù„ Ø§Ù„Ù…ØªÙƒØ±Ø±Ø© Ù„Ù„ØªÙˆØ§Ø±ÙŠØ®',0),(574086,15947,'fr','RÃ©current Post bon aux Dates',0),(574087,15947,'jp','æ—¥ä»˜ã«ã¯å®šæœŸçš„ãªä¼ç¥¨ãƒã‚¹ãƒˆ',0),(574088,15947,'pt','Post de Voucher recorrentes para datas',0),(574089,15947,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¿Ð¾ÑÑ‚ Ð´Ð°Ñ‚',0),(574090,15947,'es','Recurrente Post vale para las fechas',0),(574091,15947,'de','Wiederkehrende Termine Gutschein Post',0),(574092,15947,'en','Recurring Voucher Post To Dates',0),(574093,15948,'is','',0),(574094,15948,'dr','Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø¬Ø³ØªØ¬ÙˆÛŒ Ú©Ø§Ø±',0),(574095,15948,'pr','Ù¾ÛŒØ´Ø±ÙØªÙ‡ Ø¬Ø³ØªØ¬ÙˆÛŒ Ú©Ø§Ø±',0),(574096,15948,'tr','GeliÅŸmiÅŸ iÅŸ arama',0),(574097,15948,'pl','Wyszukiwanie zaawansowane',0),(574098,15948,'bg','Ð Ð°Ð·ÑˆÐ¸Ñ€ÐµÐ½Ð¾ Ñ‚ÑŠÑ€ÑÐµÐ½Ðµ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(574099,15948,'ur','Ø§Ø¹Ù„ÛŒ Ø¯Ø±Ø¬Û’ Ú©ÛŒ Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ ØªÙ„Ø§Ø´',0),(574100,15948,'sr','Ð’Ð¸ÑˆÐµ Ð¾Ð¿Ñ†Ð¸Ñ˜Ð° Ð·Ð° Ñ‚Ñ€Ð°Ð¶ÐµÑšÐµ Ð¿Ð¾ÑÐ»Ð°',0),(574101,15948,'vi','CÃ´ng viá»‡c tÃ¬m kiáº¿m nÃ¢ng cao',0),(574102,15948,'af','Gevorderde werk soek',0),(574103,15948,'ro','Job cautare avansata',0),(574104,15948,'et','TÃ¶Ã¶ TÃ¤ppisotsing',0),(574105,15948,'si','Napredno iskanje zaposlitve',0),(574106,15948,'ba','Pekerjaan pencarian lanjutan',0),(574107,15948,'nl','Geavanceerde Job Search',0),(574108,15948,'fi','TyÃ¶nhaku',0),(574109,15948,'no','Avansert JobbsÃ¸k',0),(574110,15948,'da','Avanceret jobsÃ¸gning',0),(574111,15948,'ko','ê³ ê¸‰ ìž‘ì—… ê²€ìƒ‰',0),(574112,15948,'he','×—×™×¤×•×© ×¢×‘×•×“×” ×ž×ª×§×“×',0),(574113,15948,'el','Î£ÏÎ½Î¸ÎµÏ„Î· Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ· Î¸Î­ÏƒÎµÏ‰Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(574114,15948,'zh','é«˜çº§èŒä½æœç´¢',0),(574115,15948,'sv','Avancerad SÃ¶k jobb',0),(574116,15948,'it','Lavoro ricerca avanzata',0),(574117,15948,'tl','',0),(574118,15948,'th','à¸„à¹‰à¸™à¸«à¸²à¸‡à¸²à¸™à¸‚à¸±à¹‰à¸™à¸ªà¸¹à¸‡',0),(574119,15948,'hi','à¤‰à¤¨à¥à¤¨à¤¤ à¤¨à¥Œà¤•à¤°à¥€ à¤–à¥‹à¤œ',0),(574120,15948,'ms','Carian kerja lanjutan',0),(574121,15948,'ar','ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¨Ø­Ø« Ø§Ù„Ù…ØªÙ‚Ø¯Ù…',0),(574122,15948,'fr','Emploi recherche avancÃ©e',0),(574123,15948,'jp','è©³ç´°æƒ…å ±ã‹ã‚‰æ¤œç´¢',0),(574124,15948,'pt','Trabalho de pesquisa avanÃ§ada',0),(574125,15948,'ru','Ð Ð°ÑÑˆÐ¸Ñ€ÐµÐ½Ð½Ñ‹Ð¹ Ð¿Ð¾Ð¸ÑÐº Ñ€Ð°Ð±Ð¾Ñ‚Ñ‹',0),(574126,15948,'es','Avanzadas de bÃºsqueda de empleo',0),(574127,15948,'de','Erweiterte Stellensuche',0),(574128,15948,'en','Advanced Job Search',0),(574129,15949,'is','',0),(574130,15949,'dr','Ø¨Ø³ØªÙ‡',0),(574131,15949,'pr','Ø¨Ø³ØªÙ‡',0),(574132,15949,'tr','TarafÄ±ndan kapalÄ±',0),(574133,15949,'pl','ZamkniÄ™ty przez',0),(574134,15949,'bg','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½ Ð¿Ð¾',0),(574135,15949,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(574136,15949,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð° Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(574137,15949,'vi','ÄÃ³ng cá»­a do',0),(574138,15949,'af','Deur gesluit',0),(574139,15949,'ro','ÃŽnchise de',0),(574140,15949,'et','Suletud',0),(574141,15949,'si','Zaprta z',0),(574142,15949,'ba','Ditutup oleh',0),(574143,15949,'nl','Gesloten door',0),(574144,15949,'fi','Suljettu',0),(574145,15949,'no','Lukket av',0),(574146,15949,'da','Lukket af',0),(574147,15949,'ko','ì˜í•´ íì‡„',0),(574148,15949,'he','× ×¡×’×¨ ×¢×œ ×™×“×™',0),(574149,15949,'el','ÎšÎ»ÎµÎ¹ÏƒÏ„ÏŒ Î±Ï€ÏŒ',0),(574150,15949,'zh','å…³é—­',0),(574151,15949,'sv','StÃ¤ngt av',0),(574152,15949,'it','Chiuso da',0),(574153,15949,'tl','',0),(574154,15949,'th','à¸›à¸´à¸”à¹‚à¸”à¸¢',0),(574155,15949,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(574156,15949,'ms','Ditutup oleh',0),(574157,15949,'ar','Ù…ØºÙ„Ù‚Ø© Ù…Ù† Ù‚Ø¨Ù„',0),(574158,15949,'fr','FermÃ©e par',0),(574159,15949,'jp','ã«ã‚ˆã£ã¦ã‚’é–‰ã˜',0),(574160,15949,'pt','Fechado por',0),(574161,15949,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ð¾',0),(574162,15949,'es','Cerrado por',0),(574163,15949,'de','Geschlossen von',0),(574164,15949,'en','Closed By',0),(574165,15950,'is','',0),(574166,15950,'dr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(574167,15950,'pr','Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(574168,15950,'tr','SÃ¶zleÅŸme tarihi baÅŸlangÄ±Ã§',0),(574169,15950,'pl','Begin Data umowy',0),(574170,15950,'bg','Ð”Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð° Ð´Ð°Ñ‚Ð° ÐÐ°Ñ‡Ð°Ð»Ð¾',0),(574171,15950,'ur','Ù…Ø¹Ø§ÛØ¯Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø¢ØºØ§Ø²',0),(574172,15950,'sr','Ð£Ð³Ð¾Ð²Ð¾Ñ€ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(574173,15950,'vi','Há»£p Ä‘á»“ng ngÃ y báº¯t Ä‘áº§u',0),(574174,15950,'af','Kontrak datum Begin',0),(574175,15950,'ro','Inceput de data contractului',0),(574176,15950,'et','Lepingu kuupÃ¤ev algus',0),(574177,15950,'si','ZaÄetni datum pogodbe',0),(574178,15950,'ba','Mulai tanggal kontrak',0),(574179,15950,'nl','Contract datum Begin',0),(574180,15950,'fi','Sopimuksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ alkaa',0),(574181,15950,'no','Kontrakten dato begynner',0),(574182,15950,'da','Kontraktens dato Begin',0),(574183,15950,'ko','ê³„ì•½ ë‚ ì§œ ì‹œìž‘',0),(574184,15950,'he','×‘×’×™×Ÿ ×ª××¨×™×š ×—×•×–×”',0),(574185,15950,'el','Î£ÏÎ¼Î²Î±ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(574186,15950,'zh','åˆåŒæ—¥æœŸå¼€å§‹',0),(574187,15950,'sv','Kontrakt datumet pÃ¥bÃ¶rja',0),(574188,15950,'it','Contratto data Begin',0),(574189,15950,'tl','',0),(574190,15950,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸ªà¸±à¸à¸à¸²à¸§à¸±à¸™',0),(574191,15950,'hi','à¤…à¤¨à¥à¤¬à¤‚à¤§ à¤¶à¥à¤°à¥‚ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(574192,15950,'ms','Mulakan tarikh kontrak',0),(574193,15950,'ar','ÙŠØ¨Ø¯Ø£ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¹Ù‚Ø¯',0),(574194,15950,'fr','Contrat Date Begin',0),(574195,15950,'jp','å¥‘ç´„æ—¥é–‹å§‹',0),(574196,15950,'pt','Begin data de contrato',0),(574197,15950,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð° ÐºÐ¾Ð½Ñ‚Ñ€Ð°ÐºÑ‚Ð°',0),(574198,15950,'es','Fecha inicio de contrato',0),(574199,15950,'de','Vertrag Datum beginnen',0),(574200,15950,'en','Contract Date Begin',0),(574201,15951,'is','',0),(574202,15951,'dr','Ù¾Ø§ÛŒØ§Ù† ØªØ§Ø±ÛŒØ® Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(574203,15951,'pr','Ù¾Ø§ÛŒØ§Ù† ØªØ§Ø±ÛŒØ® Ù‚Ø±Ø§Ø±Ø¯Ø§Ø¯',0),(574204,15951,'tr','SÃ¶zleÅŸme tarihi sonu',0),(574205,15951,'pl','Data zakoÅ„czenia umowy',0),(574206,15951,'bg','Ð”Ð¾Ð³Ð¾Ð²Ð¾Ñ€Ð° Ð´Ð°Ñ‚Ð° ÐºÑ€Ð°Ð¹',0),(574207,15951,'ur','Ù…Ø¹Ø§ÛØ¯Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(574208,15951,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ ÑƒÐ³Ð¾Ð²Ð¾Ñ€Ð°',0),(574209,15951,'vi','Há»£p Ä‘á»“ng ngÃ y cuá»‘i',0),(574210,15951,'af','Kontrak datum einde',0),(574211,15951,'ro','SfÃ¢rÅŸitul de data contractului',0),(574212,15951,'et','Lepingu lÃµpu kuupÃ¤ev',0),(574213,15951,'si','KonÄni datum pogodbe',0),(574214,15951,'ba','Akhir tanggal kontrak',0),(574215,15951,'nl','Contract datum einde',0),(574216,15951,'fi','Sopimuksen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ pÃ¤Ã¤ttyessÃ¤',0),(574217,15951,'no','Kontrakten dato slutten',0),(574218,15951,'da','Kontraktens dato slut',0),(574219,15951,'ko','ê³„ì•½ ë‚ ì§œ ë',0),(574220,15951,'he','×”×—×•×–×” ×ª××¨×™×š ×¡×™×•×',0),(574221,15951,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Ï„Î·Ï‚ ÏƒÏÎ¼Î²Î±ÏƒÎ·Ï‚',0),(574222,15951,'zh','åˆåŒæ—¥æœŸç»“æŸ',0),(574223,15951,'sv','Kontraktets datum End',0),(574224,15951,'it','Data di fine contratto',0),(574225,15951,'tl','',0),(574226,15951,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸ªà¸±à¸à¸à¸²à¸§à¸±à¸™',0),(574227,15951,'hi','à¤…à¤¨à¥à¤¬à¤‚à¤§ à¤…à¤‚à¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(574228,15951,'ms','Kontrak tarikh akhir',0),(574229,15951,'ar','Ù†Ù‡Ø§ÙŠØ© ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¹Ù‚Ø¯',0),(574230,15951,'fr','Date de fin de contrat',0),(574231,15951,'jp','å¥‘ç´„æ—¥ä»˜ã‚’çµ‚äº†',0),(574232,15951,'pt','Fim de data de contrato',0),(574233,15951,'ru','Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ ÐºÐ¾Ð½Ñ‚Ñ€Ð°ÐºÑ‚Ð°',0),(574234,15951,'es','Fecha fin de contrato',0),(574235,15951,'de','Datum Vertragsende',0),(574236,15951,'en','Contract Date End',0),(574237,15952,'is','',0),(574238,15952,'dr','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹',0),(574239,15952,'pr','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹',0),(574240,15952,'tr','Tarihi baÅŸlangÄ±Ã§ iÅŸ kapalÄ±',0),(574241,15952,'pl','Zadania zamkniÄ™te Data rozpoczÄ™cia',0),(574242,15952,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½ Ð´Ð°Ñ‚Ð° ÐÐ°Ñ‡Ð°Ð»Ð¾',0),(574243,15952,'ur','ØªØ§Ø±ÛŒØ® Ø¢ØºØ§Ø² Ú©Ø§Ù… Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(574244,15952,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(574245,15952,'vi','Viá»‡c Ä‘Ã³ng cá»­a ngÃ y báº¯t Ä‘áº§u',0),(574246,15952,'af','Werk gesluit datum Begin',0),(574247,15952,'ro','Job Ã®nchis data inceput',0),(574248,15952,'et','TÃ¶Ã¶ suletud kuupÃ¤eva algus',0),(574249,15952,'si','Delo zakljuÄila zaÄetni datum',0),(574250,15952,'ba','Pekerjaan ditutup tanggal mulai',0),(574251,15952,'nl','Baan gesloten datum Begin',0),(574252,15952,'fi','TyÃ¶ suljettu pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ alkaa',0),(574253,15952,'no','Jobb lukket dato begynner',0),(574254,15952,'da','Opgave lukket dato Begin',0),(574255,15952,'ko','ìž‘ì—… ë§ˆê° ë‚ ì§œ ì‹œìž‘',0),(574256,15952,'he','×¢×‘×•×“×” ×¡×’×•×¨×” ×‘×’×™×Ÿ ×ª××¨×™×š',0),(574257,15952,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÎºÎ»ÎµÎ¯ÏƒÎµÎ¹ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(574258,15952,'zh','ä½œä¸šç»“æŸæ—¥æœŸå¼€å§‹',0),(574259,15952,'sv','Jobbet avslutades dagen bÃ¶rja',0),(574260,15952,'it','Lavoro chiuso data Begin',0),(574261,15952,'tl','',0),(574262,15952,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸›à¸´à¸”à¸‡à¸²à¸™',0),(574263,15952,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤¶à¥à¤°à¥‚ à¤•à¤¾à¤® à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(574264,15952,'ms','Kerja ditutup tarikh mulakan',0),(574265,15952,'ar','Ø¥ØºÙ„Ø§Ù‚ Ø§Ù„Ù…Ù‡Ù…Ø© ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(574266,15952,'fr','Offre clÃ´turÃ©e Date Begin',0),(574267,15952,'jp','ä»•äº‹çµ‚äº†æ—¥é–‹å§‹',0),(574268,15952,'pt','Caso encerrado data Begin',0),(574269,15952,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ñ‹ Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(574270,15952,'es','Trabajo cerrado Fecha Inicio',0),(574271,15952,'de','Job geschlossen Datum beginnen',0),(574272,15952,'en','Job Closed Date Begin',0),(574273,15953,'is','',0),(574274,15953,'dr','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ Ù¾Ø§ÛŒØ§Ù† ØªØ§Ø±ÛŒØ®',0),(574275,15953,'pr','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ Ù¾Ø§ÛŒØ§Ù† ØªØ§Ø±ÛŒØ®',0),(574276,15953,'tr','Ä°ÅŸ kapanÄ±ÅŸ tarihi sonu',0),(574277,15953,'pl','Zadania zamkniÄ™te Data zakoÅ„czenia',0),(574278,15953,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð² Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð´Ð°Ñ‚Ð° ÐºÑ€Ð°Ñ',0),(574279,15953,'ur','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù… Ú©Ø§ Ú©Ø§Ù… Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(574280,15953,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(574281,15953,'vi','Viá»‡c Ä‘Ã³ng cá»­a ngÃ y cuá»‘i',0),(574282,15953,'af','Werk geslote datum einde',0),(574283,15953,'ro','Job Ã®nchis data final',0),(574284,15953,'et','TÃ¶Ã¶koha sulgemiskuupÃ¤eva lÃµpp',0),(574285,15953,'si','Delo zaprtih datum konca',0),(574286,15953,'ba','Pekerjaan ditutup tanggal akhir',0),(574287,15953,'nl','Baan gesloten datum einde',0),(574288,15953,'fi','TyÃ¶n sulkemispÃ¤ivÃ¤ pÃ¤Ã¤ttymisestÃ¤',0),(574289,15953,'no','Lukkingsdatoen jobbslutt',0),(574290,15953,'da','Opgave lukket dato slut',0),(574291,15953,'ko','ìž‘ì—…ì´ ë‹«ížŒëœ ë‚ ì§œ ë',0),(574292,15953,'he','×”×¢×‘×•×“×” ×¡×’×•×¨ ×ª××¨×™×š ×¡×™×•×',0),(574293,15953,'el','ÎšÎ»ÎµÎ¹ÏƒÏ„Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(574294,15953,'zh','ä½œä¸šç»“æŸçš„æ—¥æœŸç»“æŸ',0),(574295,15953,'sv','Jobb stÃ¤ngningsdatumet slutet',0),(574296,15953,'it','Lavoro chiuso data fine',0),(574297,15953,'tl','',0),(574298,15953,'th','à¸‡à¸²à¸™à¸›à¸´à¸”à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(574299,15953,'hi','à¤•à¤¾à¤® à¤¬à¤‚à¤¦ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤…à¤‚à¤¤',0),(574300,15953,'ms','Jawatan tarikh tutup akhir',0),(574301,15953,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…ØºÙ„Ù‚Ø© Ù†Ù‡Ø§ÙŠØ© Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(574302,15953,'fr','Offre clÃ´turÃ©e Date de fin',0),(574303,15953,'jp','ä»•äº‹çµ‚äº†æ—¥æœªå®š',0),(574304,15953,'pt','Caso encerrado data final',0),(574305,15953,'ru','Ð”Ð°Ñ‚Ð° Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¸Ñ ÐºÐ¾Ð½Ñ†Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(574306,15953,'es','Trabajo cerrado fecha final',0),(574307,15953,'de','Job geschlossen Datum Ende',0),(574308,15953,'en','Job Closed Date End',0),(574309,15954,'is','',0),(574310,15954,'dr','Ú©Ø§Ø± ÙˆØ±ÙˆØ¯ ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹',0),(574311,15954,'pr','Ú©Ø§Ø± ÙˆØ±ÙˆØ¯ ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹',0),(574312,15954,'tr','Ä°ÅŸe giriÅŸ tarihi baÅŸlangÄ±Ã§',0),(574313,15954,'pl','Praca wpis daty rozpoczÄ™cia',0),(574314,15954,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð° ÐÐ°Ñ‡Ð°Ð»Ð¾',0),(574315,15954,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø¢ØºØ§Ø²',0),(574316,15954,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÑƒÐ½Ð¾Ñ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ°',0),(574317,15954,'vi','Viá»‡c nháº­p cáº£nh ngÃ y báº¯t Ä‘áº§u',0),(574318,15954,'af','Werk inskrywing datum Begin',0),(574319,15954,'ro','Job intrare data inceput',0),(574320,15954,'et','TÃ¶Ã¶ kande kuupÃ¤eva algus',0),(574321,15954,'si','Delo vnos datuma zaÄetek',0),(574322,15954,'ba','Pekerjaan entri tanggal mulai',0),(574323,15954,'nl','Baan post datum Begin',0),(574324,15954,'fi','TyÃ¶ tapahtuma pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ alkaa',0),(574325,15954,'no','Jobb oppfÃ¸ring dato begynner',0),(574326,15954,'da','Job post dato Begin',0),(574327,15954,'ko','ìž‘ì—… í•­ëª© ë‚ ì§œ ì‹œìž‘',0),(574328,15954,'he','×”×¢×‘×•×“×” ×¢×¨×š ×ª××¨×™×š ×”×”×ª×—×œ×”',0),(574329,15954,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(574330,15954,'zh','å·¥ä½œæ¡ç›®æ—¥æœŸå¼€å§‹',0),(574331,15954,'sv','Jobb posten datum Begin',0),(574332,15954,'it','Lavoro voce data Begin',0),(574333,15954,'tl','',0),(574334,15954,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸‡à¸²à¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸§à¸±à¸™',0),(574335,15954,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‚',0),(574336,15954,'ms','Mulakan tarikh kemasukan kerja',0),(574337,15954,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø¥Ø¯Ø®Ø§Ù„ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡',0),(574338,15954,'fr','Poste entrÃ©e Date Begin',0),(574339,15954,'jp','ã‚¸ãƒ§ãƒ– ã‚¨ãƒ³ãƒˆãƒªæ—¥ä»˜é–‹å§‹',0),(574340,15954,'pt','Trabalho entrada data Begin',0),(574341,15954,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(574342,15954,'es','Trabajo entrada Fecha Inicio',0),(574343,15954,'de','Job-Eintrag Datum beginnen',0),(574344,15954,'en','Job Entry Date Begin',0),(574345,15955,'is','',0),(574346,15955,'dr','Ù¾Ø§ÛŒØ§Ù† ØªØ§Ø±ÛŒØ® ÙˆØ±ÙˆØ¯ Ú©Ø§Ø±',0),(574347,15955,'pr','Ù¾Ø§ÛŒØ§Ù† ØªØ§Ø±ÛŒØ® ÙˆØ±ÙˆØ¯ Ú©Ø§Ø±',0),(574348,15955,'tr','Ä°ÅŸe giriÅŸ tarihi sonu',0),(574349,15955,'pl','Praca wpis Data zakoÅ„czenia',0),(574350,15955,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð° ÐºÑ€Ð°Ð¹',0),(574351,15955,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(574352,15955,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÑƒÐ½Ð¾Ñ Ð´Ð°Ñ‚ÑƒÐ¼Ð° Ð·Ð°Ð²Ñ€ÑˆÐµÑ‚ÐºÐ°',0),(574353,15955,'vi','Viá»‡c nháº­p cáº£nh ngÃ y cuá»‘i',0),(574354,15955,'af','Werk inskrywing datum einde',0),(574355,15955,'ro','Job intrare data final',0),(574356,15955,'et','TÃ¶Ã¶ kande kuupÃ¤eva lÃµpp',0),(574357,15955,'si','Delo vnos datuma konca',0),(574358,15955,'ba','Pekerjaan entri tanggal akhir',0),(574359,15955,'nl','Baan post datum einde',0),(574360,15955,'fi','TyÃ¶n tapahtuma pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ pÃ¤Ã¤ttymisestÃ¤',0),(574361,15955,'no','Posten dato jobbslutt',0),(574362,15955,'da','Job post dato slut',0),(574363,15955,'ko','ìž‘ì—… í•­ëª© ë‚ ì§œ ë',0),(574364,15955,'he','×”×¢×‘×•×“×” ×”×–× ×ª ×ª××¨×™×š ×¡×™×•×',0),(574365,15955,'el','Î•ÏÎ³Î±ÏƒÎ¯Î± ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚',0),(574366,15955,'zh','å·¥ä½œæ¡ç›®æ—¥æœŸç»“æŸ',0),(574367,15955,'sv','Jobb posten datum End',0),(574368,15955,'it','EstremitÃ  di Data Entry lavoro',0),(574369,15955,'tl','',0),(574370,15955,'th','à¸‡à¸²à¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(574371,15955,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤…à¤‚à¤¤',0),(574372,15955,'ms','Kerja kemasukan tarikh akhir',0),(574373,15955,'ar','Ù†Ù‡Ø§ÙŠØ© ØªØ§Ø±ÙŠØ® Ø¯Ø®ÙˆÙ„ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(574374,15955,'fr','Date de fin de travail entrÃ©e',0),(574375,15955,'jp','ã‚¸ãƒ§ãƒ– ã‚¨ãƒ³ãƒˆãƒªæ—¥ä»˜ã‚’çµ‚äº†',0),(574376,15955,'pt','Trabalho final de data de entrada',0),(574377,15955,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð”Ð°Ñ‚Ð° ÐºÐ¾Ð½Ñ†Ð°',0),(574378,15955,'es','Fecha de entrada de trabajo final',0),(574379,15955,'de','Job-Eintrag Datum Ende',0),(574380,15955,'en','Job Entry Date End',0),(574381,15956,'is','',0),(574382,15956,'dr','Ø®Ø·Ø± Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ø§Ù†Ù‚Ø¶Ø§ Ø¨ÛŒÙ…Ù‡',0),(574383,15956,'pr','Ø®Ø·Ø± Ø´Ø±ÙˆØ¹ ØªØ§Ø±ÛŒØ® Ø§Ù†Ù‚Ø¶Ø§ Ø¨ÛŒÙ…Ù‡',0),(574384,15956,'tr','Sigorta sona erme tarihi baÅŸlangÄ±Ã§ riske',0),(574385,15956,'pl','Begin Data wygaÅ›niÄ™cia ubezpieczenia ryzyka',0),(574386,15956,'bg','Ð—Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²ÐºÐ° ÑÐ²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð° ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð½Ð° Ñ€Ð¸ÑÐºÐ°',0),(574387,15956,'ur','Ø§Ù†Ø´ÙˆØ±Ù†Ø³ Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ Ú©Ø§ Ø®Ø·Ø±Û',0),(574388,15956,'sr','Ð Ð¸Ð·Ð¸ÐºÑƒÑ˜ÐµÐ¼ Ð¾Ð·Ð½Ð°ÐºÐ° Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð´Ð°Ñ‚ÑƒÐ¼ Ð¸ÑÑ‚ÐµÐºÐ° Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ°',0),(574389,15956,'vi','Rá»§i ro báº£o hiá»ƒm háº¿t háº¡n ngÃ y báº¯t Ä‘áº§u',0),(574390,15956,'af','Risiko versekering verstryking datum Begin',0);
INSERT INTO `langdef` VALUES (574391,15956,'ro','Inceput de data expirare asigurare de risc',0),(574392,15956,'et','Riskide kindlustuse aegumise kuupÃ¤eva algus',0),(574393,15956,'si','Tveganje zavarovanja poteka datum zaÄetek',0),(574394,15956,'ba','Risiko asuransi kadaluarsa tanggal mulai',0),(574395,15956,'nl','Risk verzekeringen verlopen datum Begin',0),(574396,15956,'fi','Riskin vakuutus viimeinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ alkaa',0),(574397,15956,'no','Risiko forsikring utÃ¥nding dato begynner',0),(574398,15956,'da','Risiko forsikring udlÃ¸b dato Begin',0),(574399,15956,'ko','ìœ„í—˜ ë³´í—˜ ë§Œë£Œ ë‚ ì§œ ì‹œìž‘',0),(574400,15956,'he','×¡×™×›×•×Ÿ ×‘×’×™×Ÿ ×ª××¨×™×š ×ª×¤×•×’×” ×‘×™×˜×•×—',0),(574401,15956,'el','ÎšÎ¹Î½Î´ÏÎ½Î¿Ï… Î­Î½Î±ÏÎ¾Î·Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Î±ÏƒÏ†Î¬Î»ÎµÎ¹Î±Ï‚',0),(574402,15956,'zh','é£Žé™©ä¿é™©åˆ°æœŸæ—¥æœŸå¼€å§‹',0),(574403,15956,'sv','Risk fÃ¶rsÃ¤kring utandning datum Begin',0),(574404,15956,'it','Rischio assicurativo scadenza data Begin',0),(574405,15956,'tl','',0),(574406,15956,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸§à¸±à¸™à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¸›à¸£à¸°à¸à¸±à¸™à¸„à¸§à¸²à¸¡à¹€à¸ªà¸µà¹ˆà¸¢à¸‡',0),(574407,15956,'hi','à¤œà¥‹à¤–à¤¿à¤® à¤¬à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¤à¤¿à¤¥à¤¿ à¤¶à¥à¤°à¥‚',0),(574408,15956,'ms','Risiko insurans luput tarikh mulakan',0),(574409,15956,'ar','ÙŠØ¨Ø¯Ø£ ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØªØ£Ù…ÙŠÙ† Ù…Ù† Ø§Ù„Ù…Ø®Ø§Ø·Ø±',0),(574410,15956,'fr','Begin de Date dâ€™Expiration dâ€™assurance des risques',0),(574411,15956,'jp','ä¿é™ºæœ‰åŠ¹æœŸé™æ—¥ä»˜é–‹å§‹ã‚’å±é™ºã«ã•ã‚‰ã™',0),(574412,15956,'pt','O risco de seguro de expiraÃ§Ã£o data Begin',0),(574413,15956,'ru','ÐÐ°Ñ‡Ð°Ð»Ð¾ Ð”Ð°Ñ‚Ð° Ð¸ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ñ ÑÑ€Ð¾ÐºÐ° ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ€Ð¸ÑÐºÐ¾Ð²',0),(574414,15956,'es','El riesgo de inicio de fecha de vencimiento seguro',0),(574415,15956,'de','Risk Versicherung Ablauf Datum beginnen',0),(574416,15956,'en','Risk Insurance Expiration Date Begin',0),(574417,15957,'is','',0),(574418,15957,'dr','Ù¾Ø§ÛŒØ§Ù† ØªØ§Ø±ÛŒØ® Ø§Ù†Ù‚Ø¶Ø§ÛŒ Ø¨ÛŒÙ…Ù‡ Ø®Ø·Ø±',0),(574419,15957,'pr','Ù¾Ø§ÛŒØ§Ù† ØªØ§Ø±ÛŒØ® Ø§Ù†Ù‚Ø¶Ø§ÛŒ Ø¨ÛŒÙ…Ù‡ Ø®Ø·Ø±',0),(574420,15957,'tr','Risk sigorta sona erme tarihi sonu',0),(574421,15957,'pl','ZakoÅ„czenie Data wygaÅ›niÄ™cia ubezpieczenia ryzyka',0),(574422,15957,'bg','Ð Ð¸ÑÐº Ð·Ð°ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²ÐºÐ° ÑÐ²ÑŠÑ€ÑˆÐ²Ð°Ð½Ðµ Ð´Ð°Ñ‚Ð° ÐºÑ€Ð°Ð¹',0),(574423,15957,'ur','Ø±Ø³Ú© Ø§Ù†Ø´ÙˆØ±Ù†Ø³ Ø®ØªÙ… ÛÙˆÙ†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØªØ§Ù…',0),(574424,15957,'sr','ÐšÑ€Ð°Ñ˜ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¸ÑÑ‚ÐµÐºÐ° Ð¾ÑÐ¸Ð³ÑƒÑ€Ð°ÑšÐ° Ñ€Ð¸Ð·Ð¸ÐºÐ°',0),(574425,15957,'vi','Káº¿t thÃºc ngÃ y háº¿t háº¡n báº£o hiá»ƒm rá»§i ro',0),(574426,15957,'af','Risiko versekering verstryking datum einde',0),(574427,15957,'ro','Risc expirare asigurare data final',0),(574428,15957,'et','Riski kindlustuse aegumise kuupÃ¤eva lÃµpp',0),(574429,15957,'si','Tveganje zavarovanja poteka datum konca',0),(574430,15957,'ba','Risiko asuransi kadaluarsa tanggal akhir',0),(574431,15957,'nl','Risico verzekering verlopen datum einde',0),(574432,15957,'fi','Riski vakuutus vanhentumisen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤n loppuun',0),(574433,15957,'no','Risiko forsikring utÃ¥nding dato slutten',0),(574434,15957,'da','Risiko forsikring udlÃ¸b dato slut',0),(574435,15957,'ko','ìœ„í—˜ ë³´í—˜ ë§Œë£Œ ë‚ ì§œ ë',0),(574436,15957,'he','×¡×•×£ ×ª××¨×™×š ×ª×¤×•×’×” ×‘×™×˜×•×— ×¡×™×›×•× ×™×',0),(574437,15957,'el','ÎšÎ¯Î½Î´Ï…Î½Î¿Ï‚ Ï„Î­Î»Î¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚ Î±ÏƒÏ†Î¬Î»ÎµÎ¹Î±Ï‚',0),(574438,15957,'zh','é£Žé™©ä¿é™©åˆ°æœŸæ—¥æœŸç»“æŸ',0),(574439,15957,'sv','Risk fÃ¶rsÃ¤kring utandning datum End',0),(574440,15957,'it','Rischio assicurativo scadenza Data fine',0),(574441,15957,'tl','',0),(574442,15957,'th','à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸§à¸±à¸™à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¸›à¸£à¸°à¸à¸±à¸™à¸„à¸§à¸²à¸¡à¹€à¸ªà¸µà¹ˆà¸¢à¸‡',0),(574443,15957,'hi','à¤œà¥‹à¤–à¤¿à¤® à¤¬à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤…à¤‚à¤¤',0),(574444,15957,'ms','Risiko insurans luput tarikh akhir',0),(574445,15957,'ar','Ù†Ù‡Ø§ÙŠØ© ØªØ§Ø±ÙŠØ® Ø§Ù†ØªÙ‡Ø§Ø¡ Ø§Ù„ØªØ£Ù…ÙŠÙ† Ø¶Ø¯ Ø§Ù„Ù…Ø®Ø§Ø·Ø±',0),(574446,15957,'fr','Risque dâ€™assurance Expiration Date de fin',0),(574447,15957,'jp','ãƒªã‚¹ã‚¯ä¿é™ºæº€äº†æ—¥æœªå®š',0),(574448,15957,'pt','Risco seguro de expiraÃ§Ã£o data final',0),(574449,15957,'ru','ÐšÐ¾Ð½ÐµÑ† Ð”Ð°Ñ‚Ð° Ð¸ÑÑ‚ÐµÑ‡ÐµÐ½Ð¸Ñ ÑÑ€Ð¾ÐºÐ° ÑÑ‚Ñ€Ð°Ñ…Ð¾Ð²Ð°Ð½Ð¸Ñ Ñ€Ð¸ÑÐºÐ¾Ð²',0),(574450,15957,'es','Riesgo seguros vencimiento fecha final',0),(574451,15957,'de','Risiko-Versicherung Ablauf Datum Ende',0),(574452,15957,'en','Risk Insurance Expiration Date End',0),(574453,15958,'is','',0),(574454,15958,'dr','Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ',0),(574455,15958,'pr','Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ',0),(574456,15958,'tr','ArÅŸiv',0),(574457,15958,'pl','Archiwum',0),(574458,15958,'bg','ÐÑ€Ñ…Ð¸Ð²',0),(574459,15958,'ur','Ù…Ø­ÙÙˆØ¸ Ø´Ø¯Û Ø¯Ø³ØªØ§ÙˆÙŠØ²Ø§Øª',0),(574460,15958,'sr','ÐÑ€Ñ…Ð¸Ð²Ð°',0),(574461,15958,'vi','LÆ°u trá»¯',0),(574462,15958,'af','Argief',0),(574463,15958,'ro','Arhiva',0),(574464,15958,'et','Arhiiv',0),(574465,15958,'si','Arhiv',0),(574466,15958,'ba','Arsip',0),(574467,15958,'nl','Archief',0),(574468,15958,'fi','Arkisto',0),(574469,15958,'no','Arkiv',0),(574470,15958,'da','Arkiv',0),(574471,15958,'ko','ì•„ì¹´ì´ë¸Œ',0),(574472,15958,'he','××¨×›×™×•×Ÿ',0),(574473,15958,'el','Î‘ÏÏ‡ÎµÎ¯Î¿',0),(574474,15958,'zh','æ¡£æ¡ˆ',0),(574475,15958,'sv','Arkiv',0),(574476,15958,'it','Archivio',0),(574477,15958,'tl','',0),(574478,15958,'th','à¹€à¸à¹‡à¸šà¸–à¸²à¸§à¸£',0),(574479,15958,'hi','à¤ªà¥à¤°à¤¾à¤²à¥‡à¤–',0),(574480,15958,'ms','Arkib',0),(574481,15958,'ar','Ø£Ø±Ø´ÙŠÙ',0),(574482,15958,'fr','Archives',0),(574483,15958,'jp','ã‚¢ãƒ¼ã‚«ã‚¤ãƒ–',0),(574484,15958,'pt','Arquivo',0),(574485,15958,'ru','ÐÑ€Ñ…Ð¸Ð²',0),(574486,15958,'es','Archivo',0),(574487,15958,'de','Archiv',0),(574488,15958,'en','Archive',0),(574489,15959,'is','',0),(574490,15959,'dr','Ø±Ø¯Ù‡Ù‡Ø§ÛŒ ØµÙØ­Ù‡ GL',0),(574491,15959,'pr','Ø±Ø¯Ù‡Ù‡Ø§ÛŒ ØµÙØ­Ù‡ GL',0),(574492,15959,'tr','GL Kategoriler',0),(574493,15959,'pl','Kategorie GL',0),(574494,15959,'bg','GL ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(574495,15959,'ur','Ø¬ÛŒØ¬Û’ Ø²Ù…Ø±Û Ø¬Ø§Øª',0),(574496,15959,'sr','Ð“Ð› ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(574497,15959,'vi','Thá»ƒ loáº¡i GL',0),(574498,15959,'af','GL kategorieÃ«',0),(574499,15959,'ro','GL categorii',0),(574500,15959,'et','GL Kategooriad',0),(574501,15959,'si','GL kategorije',0),(574502,15959,'ba','GL Kategori',0),(574503,15959,'nl','GL-CategorieÃ«n',0),(574504,15959,'fi','GL-luokka',0),(574505,15959,'no','GL kategorier',0),(574506,15959,'da','GL kategorier',0),(574507,15959,'ko','GL ì¢…ë¥˜',0),(574508,15959,'he','×§×˜×’×•×¨×™×•×ª GL',0),(574509,15959,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚ GL',0),(574510,15959,'zh','GL ç±»åˆ«',0),(574511,15959,'sv','GL kategorier',0),(574512,15959,'it','Categorie GL',0),(574513,15959,'tl','',0),(574514,15959,'th','à¸›à¸£à¸°à¹€à¸ à¸— GL',0),(574515,15959,'hi','GL à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤',0),(574516,15959,'ms','Kategori GL',0),(574517,15959,'ar','ÙØ¦Ø§Øª GL',0),(574518,15959,'fr','CatÃ©gories GL',0),(574519,15959,'jp','GL ã‚«ãƒ†ã‚´ãƒª',0),(574520,15959,'pt','Categorias GL',0),(574521,15959,'ru','GL ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(574522,15959,'es','CategorÃ­as GL',0),(574523,15959,'de','GL-Kategorien',0),(574524,15959,'en','GL Categories',0),(574525,15960,'is','',0),(574526,15960,'dr','Ø®Ø±ÛŒØ¯ ÙˆØ§Ø±Ø¯Ø§Øª Ø³ÛŒ Ø³ÛŒ',0),(574527,15960,'pr','Ø®Ø±ÛŒØ¯ ÙˆØ§Ø±Ø¯Ø§Øª Ø³ÛŒ Ø³ÛŒ',0),(574528,15960,'tr','Alma CC alÄ±mlarÄ±',0),(574529,15960,'pl','Importuj CC zakupÃ³w',0),(574530,15960,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ CC Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(574531,15960,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ù†Ù‚Ù„ Ø¨Ø±Ø§Û“ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(574532,15960,'sr','Ð£Ð²Ð¾Ð· Ð¦Ð¦ Ð½Ð°Ð±Ð°Ð²ÐºÐ¸',0),(574533,15960,'vi','Mua hÃ ng nháº­p kháº©u CC',0),(574534,15960,'af','Aankope invoer CC',0),(574535,15960,'ro','Import CC achiziÅ£ii',0),(574536,15960,'et','Impordi CC ostud',0),(574537,15960,'si','Uvoz CC nakupi',0),(574538,15960,'ba','Pembelian impor CC',0),(574539,15960,'nl','Invoer CC aankopen',0),(574540,15960,'fi','Tuo CC ostot',0),(574541,15960,'no','Importer CC kjÃ¸p',0),(574542,15960,'da','Import CC kÃ¸b',0),(574543,15960,'ko','ê°€ì ¸ì˜¤ê¸° CC êµ¬ë§¤',0),(574544,15960,'he','×¨×›×™×©×•×ª ×™×™×‘×•× CC',0),(574545,15960,'el','Î‘Î³Î¿ÏÎ­Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ CC',0),(574546,15960,'zh','è¿›å£ CC è´­ä¹°',0),(574547,15960,'sv','Importera CC inkÃ¶p',0),(574548,15960,'it','Acquisti di importazione CC',0),(574549,15960,'tl','',0),(574550,15960,'th','à¸‹à¸·à¹‰à¸­à¸™à¸³à¹€à¸‚à¹‰à¸² CC',0),(574551,15960,'hi','à¤†à¤¯à¤¾à¤¤ CC à¤–à¤°à¥€à¤¦',0),(574552,15960,'ms','Pembelian import CC',0),(574553,15960,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù†Ø³Ø®Ø© Ù…Ø´ØªØ±ÙŠØ§Øª',0),(574554,15960,'fr','Achats dâ€™importation CC',0),(574555,15960,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ CC è³¼å…¥',0),(574556,15960,'pt','Compras importaÃ§Ã£o CC',0),(574557,15960,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ CC Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(574558,15960,'es','Compras de importaciÃ³n CC',0),(574559,15960,'de','Import CC EinkÃ¤ufe',0),(574560,15960,'en','Import CC Purchases',0),(574561,15961,'is','',0),(574562,15961,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ø§Ø±Ù…Ù†Ø¯ ÙˆØ§Ø±Ø¯Ø§Øª',0),(574563,15961,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ø§Ø±Ù…Ù†Ø¯ ÙˆØ§Ø±Ø¯Ø§Øª',0),(574564,15961,'tr','Alma Ã§alÄ±ÅŸan giderleri',0),(574565,15961,'pl','ZaimportowaÄ‡ wydatki pracownicze',0),(574566,15961,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐ»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(574567,15961,'ur','Ù…Ù„Ø§Ø²Ù… Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(574568,15961,'sr','Ð£Ð²Ð¾Ð· Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸',0),(574569,15961,'vi','Nháº­p kháº©u chi phÃ­ nhÃ¢n viÃªn',0),(574570,15961,'af','Voer werknemer uitgawes',0),(574571,15961,'ro','Angajat cheltuieli de import',0),(574572,15961,'et','TÃ¶Ã¶tajakulud importida',0),(574573,15961,'si','StroÅ¡ki z zaposlenimi uvoz',0),(574574,15961,'ba','Impor biaya karyawan',0),(574575,15961,'nl','Importeren van personeelskosten',0),(574576,15961,'fi','Tuo TyÃ¶ntekijÃ¤kustannukset',0),(574577,15961,'no','Importere lÃ¸nnskostnader',0),(574578,15961,'da','Importere medarbejderudgifter',0),(574579,15961,'ko','ê°€ì ¸ì˜¤ê¸° ì§ì› ë¹„ìš©',0),(574580,15961,'he','×™×™×‘×•× ×”×¢×•×‘×“×™× ×”×•×¦××•×ª',0),(574581,15961,'el','ÎˆÎ¾Î¿Î´Î± Ï…Ï€Î±Î»Î»Î®Î»Ï‰Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(574582,15961,'zh','å¯¼å…¥å‘˜å·¥è´¹ç”¨',0),(574583,15961,'sv','Importera anstÃ¤lld kostnader',0),(574584,15961,'it','Importare le spese del dipendente',0),(574585,15961,'tl','',0),(574586,15961,'th','à¸™à¸³à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(574587,15961,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥à¤¯à¤¯ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(574588,15961,'ms','Perbelanjaan pekerja import',0),(574589,15961,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù†ÙÙ‚Ø§Øª Ø§Ù„Ù…ÙˆØ¸Ù',0),(574590,15961,'fr','Importer des dÃ©penses des employÃ©s',0),(574591,15961,'jp','å¾“æ¥­å“¡ã®çµŒè²»ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(574592,15961,'pt','Empregado despesas de importaÃ§Ã£o',0),(574593,15961,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ ÑÐ¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ¾Ð² Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(574594,15961,'es','Gastos de importaciÃ³n del empleado',0),(574595,15961,'de','Importieren von Mitarbeiterausgaben',0),(574596,15961,'en','Import Employee Expenses',0),(574597,15962,'is','',0),(574598,15962,'dr','ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø± Ù…Ø¹Ú©ÙˆØ³ Ø¬Ø¯ÛŒØ¯',0),(574599,15962,'pr','ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø± Ù…Ø¹Ú©ÙˆØ³ Ø¬Ø¯ÛŒØ¯',0),(574600,15962,'tr','Yeni ters kayÄ±t gÃ¼nlÃ¼ÄŸÃ¼ giriÅŸi',0),(574601,15962,'pl','Nowy dziennik wpis stornujÄ…cy',0),(574602,15962,'bg','ÐÐ¾Ð² Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‰ Ð·Ð°Ð¿Ð¸Ñ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(574603,15962,'ur','Ù†ÛŒØ§ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Ù†Ù¹Ø±ÛŒÚ©Ø´Ù† Ù…ÛŒÚº ØªØ¨Ø¯ÛŒÙ„',0),(574604,15962,'sr','ÐÐ¾Ð²Ð° ÑÑ‚Ð°Ð²ÐºÐ° Ð·Ð° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(574605,15962,'vi','BÃºt má»›i Ä‘áº£o chiá»u',0),(574606,15962,'af','Nuwe omkeer joernaal inskrywing',0),(574607,15962,'ro','Noua intrare Ã®n jurnal mers Ã®napoi',0),(574608,15962,'et','Uue tÃ¶Ã¶lehe stornokanne',0),(574609,15962,'si','Nov za vzvratno voÅ¾njo vnos v dnevnik',0),(574610,15962,'ba','Entri jurnal membalikkan baru',0),(574611,15962,'nl','Nieuw omkeren logboekitem',0),(574612,15962,'fi','Uusi peruutettaessa pÃ¤ivyrimerkintÃ¤',0),(574613,15962,'no','Snu loggoppfÃ¸ring',0),(574614,15962,'da','Ny baglÃ¦nskÃ¸rsel journaloptegnelse',0),(574615,15962,'ko','ìƒˆ ì—…ë¬´ ì¼ì§€ í•­ëª© ë°˜ì „',0),(574616,15962,'he','×¢×¨×š ×™×•×ž×Ÿ ×—×“×© ×”×™×¤×•×š',0),(574617,15962,'el','ÎÎ­Î± ÎµÎ³Î³ÏÎ±Ï†Î® Î±Î½Ï„Î¹Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï ÎµÏ†Î·Î¼ÎµÏÎ¯Î´Î±',0),(574618,15962,'zh','æ–°æ¢å‘çš„æ—¥è®°æ¡ç›®',0),(574619,15962,'sv','Ny tidning Ã¥terfÃ¶ringspost',0),(574620,15962,'it','Nuova voce diario inversione',0),(574621,15962,'tl','',0),(574622,15962,'th','à¸à¸¥à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(574623,15962,'hi','à¤¨à¤ˆ à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤ªà¥€à¤›à¥‡',0),(574624,15962,'ms','Baru menterbalikkan kemasukan jurnal',0),(574625,15962,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ø¬Ø¯ÙŠØ¯ ÙÙŠ Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ© Ø¹ÙƒØ³',0),(574626,15962,'fr','Nouvelle entrÃ©e du Journal marche arriÃ¨re',0),(574627,15962,'jp','æ–°ã—ã„ä»•è¨³å¸³ã‚¨ãƒ³ãƒˆãƒªã‚’åè»¢',0),(574628,15962,'pt','Nova entrada de diÃ¡rio de inversÃ£o',0),(574629,15962,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ñ€ÐµÐ²ÐµÑ€ÑÐ¸Ð²Ð½Ñ‹Ð¹ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐµ',0),(574630,15962,'es','InversiÃ³n nueva entrada de diario',0),(574631,15962,'de','Neue Zeitschrift Umkehrbuchung',0),(574632,15962,'en','New Reversing Journal Entry',0),(574633,15963,'is','',0),(574634,15963,'dr','Unpost Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ù…Ø¬Ù„Ù‡',0),(574635,15963,'pr','Unpost Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ù…Ø¬Ù„Ù‡',0),(574636,15963,'tr','GÃ¼nlÃ¼k giriÅŸleri unpost',0),(574637,15963,'pl','Unpost zapisy ksiÄ™gowe',0),(574638,15963,'bg','Unpost Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(574639,15963,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ø§Ù†Ù¾ÙˆØ³Ù¹',0),(574640,15963,'sr','ÐŸÐ¾Ð²ÑƒÐ¸Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ð´Ð½ÐµÐ²Ð½Ð¸ÐºÐ°',0),(574641,15963,'vi','Unpost táº¡p chÃ­ Entries',0),(574642,15963,'af','Unpost joernaal inskrywings',0),(574643,15963,'ro','Unpost jurnal',0),(574644,15963,'et','Unpost tÃ¶Ã¶lehe kanded',0),(574645,15963,'si','Unpost dnevnik',0),(574646,15963,'ba','Unpost entri jurnal',0),(574647,15963,'nl','Unpost van logboekitems',0),(574648,15963,'fi','Unpost pÃ¤ivÃ¤kirjamerkinnÃ¤t',0),(574649,15963,'no','Unpost loggoppfÃ¸ringer',0),(574650,15963,'da','Unpost journaloptegnelser',0),(574651,15963,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª©ì„ unpost',0),(574652,15963,'he','Unpost ×¢×¨×›×™ ×™×•×ž×Ÿ',0),(574653,15963,'el','Unpost ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î·Î¼ÎµÏÎ¿Î»Î¿Î³Î¯Î¿Ï…',0),(574654,15963,'zh','Unpost çš„æ—¥è®°æ¡ç›®',0),(574655,15963,'sv','Unpost journalposter',0),(574656,15963,'it','Unpost voci di diario',0),(574657,15963,'tl','',0),(574658,15963,'th','Unpost à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™',0),(574659,15963,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ unpost',0),(574660,15963,'ms','Unpost catatan jurnal',0),(574661,15963,'ar','Ø£ÙˆÙ†Ø¨ÙˆØ³Øª Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(574662,15963,'fr','Unpost entrÃ©es de Journal',0),(574663,15963,'jp','è«‹æ±‚æ›¸ä»•è¨³ã‚’è¨˜å¸³ã—ã¾ã™ã€‚',0),(574664,15963,'pt','Unpost entradas de diÃ¡rio',0),(574665,15963,'ru','Unpost Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¶ÑƒÑ€Ð½Ð°Ð»Ð°',0),(574666,15963,'es','Unpost entradas de diario',0),(574667,15963,'de','Unpost Tagebuch-EintrÃ¤ge',0),(574668,15963,'en','Unpost Journal Entries',0),(574669,15964,'is','',0),(574670,15964,'dr','Ú©Ù„ÛŒØ¯ API Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(574671,15964,'pr','Ú©Ù„ÛŒØ¯ API Ø¨Ø±Ù†Ø§Ù…Ù‡',0),(574672,15964,'tr','API uygulama anahtarÄ±',0),(574673,15964,'pl','Klawisz aplikacji interfejsu API',0),(574674,15964,'bg','API Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ»ÑŽÑ‡',0),(574675,15964,'ur','API Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ Ú†Ø§Ø¨ÛŒ',0),(574676,15964,'sr','ÐÐŸÐ˜ Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ ÐºÑ™ÑƒÑ‡',0),(574677,15964,'vi','KhÃ³a á»©ng dá»¥ng API',0),(574678,15964,'af','API toepassingsleutel',0),(574679,15964,'ro','API-cheie cerere',0),(574680,15964,'et','API Rakendusklahvi',0),(574681,15964,'si','KljuÄ za uporabo API',0),(574682,15964,'ba','Kunci aplikasi API',0),(574683,15964,'nl','API toepassingstoets',0),(574684,15964,'fi','API ahkeruus avain',0),(574685,15964,'no','Program-API-nÃ¸kkel',0),(574686,15964,'da','API programtasten',0),(574687,15964,'ko','API ì‘ìš© í”„ë¡œê·¸ëž¨ í‚¤',0),(574688,15964,'he','×ž×¤×ª×— ×™×™×©×•×ž×™× API',0),(574689,15964,'el','Î Î»Î®ÎºÏ„ÏÎ¿ ÎµÏ†Î±ÏÎ¼Î¿Î³Î®Ï‚ API',0),(574690,15964,'zh','API åº”ç”¨ç¨‹åºé”®',0),(574691,15964,'sv','API Application Key',0),(574692,15964,'it','Chiave di applicazione API',0),(574693,15964,'tl','',0),(574694,15964,'th','à¸„à¸µà¸¢à¹Œà¹à¸­à¸žà¸¥à¸´à¹€à¸„à¸Šà¸±à¸™ API',0),(574695,15964,'hi','API à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤— à¤•à¥à¤‚à¤œà¥€',0),(574696,15964,'ms','API permohonan kekunci',0),(574697,15964,'ar','Ù…ÙØªØ§Ø­ Ø§Ù„ØªØ·Ø¨ÙŠÙ‚ API',0),(574698,15964,'fr','ClÃ© dâ€™API Application',0),(574699,15964,'jp','ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³ã® API ã‚­ãƒ¼',0),(574700,15964,'pt','Chave de aplicativo API',0),(574701,15964,'ru','ÐšÐ»ÑŽÑ‡ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ API',0),(574702,15964,'es','Tecla de aplicaciÃ³n API',0),(574703,15964,'de','API-AnwendungsschlÃ¼ssel',0),(574704,15964,'en','API Application Key',0),(574705,15965,'is','',0),(574706,15965,'dr','API Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§Ø²',0),(574707,15965,'pr','API Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±Ø§Ø²',0),(574708,15965,'tr','API uygulama gizli',0),(574709,15965,'pl','Klucz tajny aplikacji interfejsu API',0),(574710,15965,'bg','API Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ Ñ‚Ð°Ð¹Ð½Ð°',0),(574711,15965,'ur','API Ø§ÛŒÙ¾Ù„ÛŒ Ú©ÛŒØ´Ù† Ø±Ø§Ø²',0),(574712,15965,'sr','ÐÐŸÐ˜ Ð°Ð¿Ð»Ð¸ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ñ‚Ð°Ñ˜Ð½Ð°',0),(574713,15965,'vi','API á»©ng dá»¥ng Secret',0),(574714,15965,'af','API aansoek geheim',0),(574715,15965,'ro','Secretul de aplicare API',0),(574716,15965,'et','API rakendus saladus',0),(574717,15965,'si','API uporabo skrivnost',0),(574718,15965,'ba','Rahasia aplikasi API',0),(574719,15965,'nl','API Application geheim',0),(574720,15965,'fi','API sovelluksen Secret',0),(574721,15965,'no','API Application Secret',0),(574722,15965,'da','API ansÃ¸gning hemmelighed',0),(574723,15965,'ko','API ì‘ìš© í”„ë¡œê·¸ëž¨ ë¹„ë°€',0),(574724,15965,'he','API ×™×™×©×•× ×”×¡×•×“',0),(574725,15965,'el','ÎœÏ…ÏƒÏ„Î¹ÎºÏŒ ÎµÏ†Î±ÏÎ¼Î¿Î³Î® API',0),(574726,15965,'zh','API åº”ç”¨ç¨‹åºå¯†ç ',0),(574727,15965,'sv','API-program hemlighet',0),(574728,15965,'it','Segreto di applicazione di API',0),(574729,15965,'tl','',0),(574730,15965,'th','à¸„à¸§à¸²à¸¡à¸¥à¸±à¸šà¸‚à¸­à¸‡à¹à¸­à¸žà¸¥à¸´à¹€à¸„à¸Šà¸±à¸™ API',0),(574731,15965,'hi','API à¤…à¤¨à¥à¤ªà¥à¤°à¤¯à¥‹à¤— à¤°à¤¹à¤¸à¥à¤¯',0),(574732,15965,'ms','Rahsia aplikasi API',0),(574733,15965,'ar','Ø³Ø± ØªØ·Ø¨ÙŠÙ‚ API',0),(574734,15965,'fr','API Application Secret',0),(574735,15965,'jp','API ã‚¢ãƒ—ãƒªã‚±ãƒ¼ã‚·ãƒ§ãƒ³ ã‚·ãƒ¼ã‚¯ãƒ¬ãƒƒãƒˆ',0),(574736,15965,'pt','Segredo de aplicativo API',0),(574737,15965,'ru','Ð¡ÐµÐºÑ€ÐµÑ‚ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ API',0),(574738,15965,'es','Secretos de aplicaciÃ³n API',0),(574739,15965,'de','API-Anwendung-Geheimnis',0),(574740,15965,'en','API Application Secret',0),(574741,15966,'is','',0),(574742,15966,'dr','ÙˆØ±ÙˆØ¯ Ext',0),(574743,15966,'pr','ÙˆØ±ÙˆØ¯ Ext',0),(574744,15966,'tr','Oturum aÃ§ma Ext',0),(574745,15966,'pl','Ext logowania',0),(574746,15966,'bg','Ð’Ñ…Ð¾Ð´ Ð²ÑŠÑ‚Ñ€',0),(574747,15966,'ur','Ù„Ø§Ú¯ Ø§Ù† Ú©Û’ ØªÙ†',0),(574748,15966,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð° Ð•xÑ‚',0),(574749,15966,'vi','ÄÄƒng nháº­p Ext',0),(574750,15966,'af','Aantekening uitbreiding',0),(574751,15966,'ro','Login Ext',0),(574752,15966,'et','Login Ext',0),(574753,15966,'si','Prijava Ext',0),(574754,15966,'ba','Login Ext',0),(574755,15966,'nl','Inloggen Ext',0),(574756,15966,'fi','Kirjaudu Ext',0),(574757,15966,'no','Logikk Ext',0),(574758,15966,'da','Login Ext',0),(574759,15966,'ko','ë¡œê·¸ì¸ ë‚´ì„ ',0),(574760,15966,'he','×›× ×™×¡×” Ext',0),(574761,15966,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Ext',0),(574762,15966,'zh','ç™»å½• Ext',0),(574763,15966,'sv','Logga in Ext',0),(574764,15966,'it','Accesso Ext',0),(574765,15966,'tl','',0),(574766,15966,'th','à¸•à¹ˆà¸­à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(574767,15966,'hi','à¤²à¥‰à¤—à¤¿à¤¨ Ext',0),(574768,15966,'ms','Log masuk Ext',0),(574769,15966,'ar','ØªØ­ÙˆÙŠÙ„Ù‡ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(574770,15966,'fr','Connexion Ext',0),(574771,15966,'jp','ãƒ­ã‚°ã‚¤ãƒ³ Ext',0),(574772,15966,'pt','Login Ext',0),(574773,15966,'ru','Ð’Ñ…Ð¾Ð´ Ext',0),(574774,15966,'es','Inicio de sesiÃ³n Ext',0),(574775,15966,'de','Login-Ext',0),(574776,15966,'en','Login Ext',0),(574777,15967,'is','',0),(574778,15967,'dr','ÙˆØ±ÙˆØ¯ ØªÙ„ÙÙ†',0),(574779,15967,'pr','ÙˆØ±ÙˆØ¯ ØªÙ„ÙÙ†',0),(574780,15967,'tr','GiriÅŸ telefon',0),(574781,15967,'pl','Logowanie telefon',0),(574782,15967,'bg','Ð’Ñ…Ð¾Ð´ Ð·Ð° Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½',0),(574783,15967,'ur','Ù„Ø§Ú¯ Ø§Ù† ÙÙˆÙ†',0),(574784,15967,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ',0),(574785,15967,'vi','ÄÄƒng nháº­p Ä‘iá»‡n thoáº¡i',0),(574786,15967,'af','Aantekening foon',0),(574787,15967,'ro','Conectare telefon',0),(574788,15967,'et','Logi sisse telefon',0),(574789,15967,'si','Prijava telefon',0),(574790,15967,'ba','Telepon masuk',0),(574791,15967,'nl','Inloggen telefoon',0),(574792,15967,'fi','Kirjaudu sisÃ¤Ã¤n Puhelin',0),(574793,15967,'no','Logikk telefon',0),(574794,15967,'da','Login telefon',0),(574795,15967,'ko','ë¡œê·¸ì¸ ì „í™”',0),(574796,15967,'he','×›× ×™×¡×” ×˜×œ×¤×•×Ÿ',0),(574797,15967,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Ï„Î·Î»ÎµÏ†ÏŽÎ½Î¿Ï…',0),(574798,15967,'zh','ç™»å½•æ‰‹æœº',0),(574799,15967,'sv','Logga in telefonen',0),(574800,15967,'it','Telefono accesso',0),(574801,15967,'tl','',0),(574802,15967,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œ',0),(574803,15967,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤«à¥‹à¤¨',0),(574804,15967,'ms','Daftar Masuk telefon',0),(574805,15967,'ar','Ø§Ù„Ù‡Ø§ØªÙ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(574806,15967,'fr','Connexion tÃ©lÃ©phone',0),(574807,15967,'jp','ãƒ­ã‚°ã‚¤ãƒ³é›»è©±',0),(574808,15967,'pt','Telefone de logon',0),(574809,15967,'ru','Ð’Ñ…Ð¾Ð´ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(574810,15967,'es','TelÃ©fono de inicio de sesiÃ³n',0),(574811,15967,'de','Anmeldung Telefon',0),(574812,15967,'en','Login Phone',0),(574813,15968,'is','',0),(574814,15968,'dr','Ø³Ø±ÙˆÛŒØ³ Ù†Ù…Ø§Ø¨Ø± RingCentral',0),(574815,15968,'pr','Ø³Ø±ÙˆÛŒØ³ Ù†Ù…Ø§Ø¨Ø± RingCentral',0),(574816,15968,'tr','RingCentral Faks hizmeti',0),(574817,15968,'pl','UsÅ‚ugi RingCentral faksowania',0),(574818,15968,'bg','RingCentral Ñ„Ð°ÐºÑ ÑƒÑÐ»ÑƒÐ³Ð¸',0),(574819,15968,'ur','Ø±Ù†Ú¯Ú©Ø§Ù†Ù¹Ø±Ø§Ù„ ÙÛŒÚ©Ø³ Ø®Ø¯Ù…Øª',0),(574820,15968,'sr','Ð Ð¸Ð½Ð³Ð¦ÐµÐ½Ñ‚Ñ€Ð°Ð» Ñ„Ð°ÐºÑ ÑƒÑÐ»ÑƒÐ³Ð°',0),(574821,15968,'vi','Dá»‹ch vá»¥ RingCentral Fax',0),(574822,15968,'af','RingCentral faks diens',0),(574823,15968,'ro','Serviciul de RingCentral Fax',0),(574824,15968,'et','RingCentral faksiteenusega',0),(574825,15968,'si','RingCentral faksne storitve',0),(574826,15968,'ba','Layanan faks RingCentral',0),(574827,15968,'nl','RingCentral faxservice',0),(574828,15968,'fi','RingCentral faksipalvelu',0),(574829,15968,'no','RingCentral Fakstjeneste',0),(574830,15968,'da','RingCentral Fax-tjenesten',0),(574831,15968,'ko','RingCentral íŒ©ìŠ¤ ì„œë¹„ìŠ¤',0),(574832,15968,'he','×©×™×¨×•×ª ×¤×§×¡ RingCentral',0),(574833,15968,'el','Î¥Ï€Î·ÏÎµÏƒÎ¯Î± Ï†Î±Î¾ RingCentral Ï€Î¿Ï… Ï€Î±ÏÎ­Ï‡ÎµÏ„Î±Î¹',0),(574834,15968,'zh','é“ƒä¼ çœŸæœåŠ¡',0),(574835,15968,'sv','RingCentral faxtjÃ¤nsten',0),(574836,15968,'it','RingCentral Fax servizio',0),(574837,15968,'tl','',0),(574838,15968,'th','à¸šà¸£à¸´à¸à¸²à¸£à¹‚à¸—à¸£à¸ªà¸²à¸£ RingCentral',0),(574839,15968,'hi','RingCentral à¤«à¤¼à¥ˆà¤•à¥à¤¸ à¤¸à¥‡à¤µà¤¾',0),(574840,15968,'ms','Khidmat RingCentral Faks',0),(574841,15968,'ar','Ø®Ø¯Ù…Ø© Ø§Ù„ÙØ§ÙƒØ³ RingCentral',0),(574842,15968,'fr','RingCentral Fax Service',0),(574843,15968,'jp','RingCentral Fax ã‚µãƒ¼ãƒ“ã‚¹',0),(574844,15968,'pt','ServiÃ§o de RingCentral Fax',0),(574845,15968,'ru','Ð¤Ð°ÐºÑ RingCentral',0),(574846,15968,'es','Servicio de RingCentral Fax',0),(574847,15968,'de','RingCentral Fax-Service',0),(574848,15968,'en','RingCentral Fax Service',0),(574849,15969,'is','',0),(574850,15969,'dr','Ø¯Ø³ØªÛŒ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(574851,15969,'pr','Ø¯Ø³ØªÛŒ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(574852,15969,'tr','El ile gerektiÄŸi gibi',0),(574853,15969,'pl','RÄ™cznie, w razie potrzeby',0),(574854,15969,'bg','Ð ÑŠÑ‡Ð½Ð¾, Ð°ÐºÐ¾ Ðµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾',0),(574855,15969,'ur','Ø¯Ø³ØªÛŒ Ø·ÙˆØ± Ù¾Ø± Ø¶Ø±ÙˆØ±Øª Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚',0),(574856,15969,'sr','Ð ÑƒÑ‡Ð½Ð¾ Ð¿Ð¾ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸',0),(574857,15969,'vi','Báº±ng tay khi cáº§n thiáº¿t',0),(574858,15969,'af','Handmatig soos nodig',0),(574859,15969,'ro','Manual dupÄƒ cum este necesar',0),(574860,15969,'et','KÃ¤sitsi, vastavalt vajadusele',0),(574861,15969,'si','RoÄno, po potrebi',0),(574862,15969,'ba','Secara manual yang diperlukan',0),(574863,15969,'nl','Handmatig zo nodig',0),(574864,15969,'fi','Manuaalisesti tarvittaessa',0),(574865,15969,'no','Manuelt etter behov',0),(574866,15969,'da','Manuelt efter behov',0),(574867,15969,'ko','í•„ìš”ì— ë”°ë¼ ìˆ˜ë™ìœ¼ë¡œ',0),(574868,15969,'he','×‘××•×¤×Ÿ ×™×“× ×™ ×œ×¤×™ ×”×¦×•×¨×š',0),(574869,15969,'el','ÎœÎµ Ï„Î¿ Ï‡Î­ÏÎ¹',0),(574870,15969,'zh','æ ¹æ®éœ€è¦æ‰‹åŠ¨',0),(574871,15969,'sv','Manuellt vid behov',0),(574872,15969,'it','Manualmente se necessario',0),(574873,15969,'tl','',0),(574874,15969,'th','à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡à¸•à¸²à¸¡à¸„à¸§à¸²à¸¡à¸ˆà¸³à¹€à¸›à¹‡à¸™',0),(574875,15969,'hi','à¤®à¥ˆà¤¨à¥à¤¯à¥à¤…à¤² à¤°à¥‚à¤ª à¤¸à¥‡ à¤†à¤µà¤¶à¥à¤¯à¤• à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚',0),(574876,15969,'ms','Secara manual seperti yang diperlukan',0),(574877,15969,'ar','ÙŠØ¯ÙˆÙŠØ§Ù‹ Ø­Ø³Ø¨ Ø§Ù„Ø­Ø§Ø¬Ø©',0),(574878,15969,'fr','Manuellement au besoin',0),(574879,15969,'jp','å¿…è¦ã«å¿œã˜ã¦æ‰‹å‹•ã§',0),(574880,15969,'pt','Manualmente conforme necessÃ¡rio',0),(574881,15969,'ru','Ð’Ñ€ÑƒÑ‡Ð½ÑƒÑŽ, Ð¿Ñ€Ð¸ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ÑÑ‚Ð¸',0),(574882,15969,'es','Manualmente segÃºn sea necesario',0),(574883,15969,'de','Manuell nach Bedarf',0),(574884,15969,'en','Manually As Needed',0),(574885,15970,'is','',0),(574886,15970,'dr','ÙˆØ±ÙˆØ¯ Ú©Ø§Ø±Ø¨Ø±',0),(574887,15970,'pr','ÙˆØ±ÙˆØ¯ Ú©Ø§Ø±Ø¨Ø±',0),(574888,15970,'tr','GiriÅŸ kullanÄ±cÄ±',0),(574889,15970,'pl','Wpis uÅ¼ytkownika',0),(574890,15970,'bg','Ð’Ð»Ð¸Ð·Ð°Ð½Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(574891,15970,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ ØµØ§Ø±Ù',0),(574892,15970,'sr','Ð£Ð½Ð¾Ñ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(574893,15970,'vi','Nháº­p ngÆ°á»i dÃ¹ng',0),(574894,15970,'af','Inskrywing gebruiker',0),(574895,15970,'ro','Intrare utilizator',0),(574896,15970,'et','Kanne kasutaja',0),(574897,15970,'si','Vnos uporabnika',0),(574898,15970,'ba','Catatan pengguna',0),(574899,15970,'nl','Invoer gebruiker',0),(574900,15970,'fi','Kohta kÃ¤yttÃ¤jÃ¤',0),(574901,15970,'no','-Bruker',0),(574902,15970,'da','Post bruger',0),(574903,15970,'ko','í•­ëª© ì‚¬ìš©ìž',0),(574904,15970,'he','×›× ×™×¡×” ×œ×ž×©×ª×ž×©',0),(574905,15970,'el','Î•Î³Î³ÏÎ±Ï†Î® Ï‡ÏÎ®ÏƒÏ„Î·',0),(574906,15970,'zh','å…¥é—¨ç”¨æˆ·',0),(574907,15970,'sv','Posten anvÃ¤ndare',0),(574908,15970,'it','Ingresso utente',0),(574909,15970,'tl','',0),(574910,15970,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸£à¸²à¸¢à¸à¸²à¸£',0),(574911,15970,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(574912,15970,'ms','Penyertaan pengguna',0),(574913,15970,'ar','Ø¯Ø®ÙˆÙ„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(574914,15970,'fr','EntrÃ©e utilisateur',0),(574915,15970,'jp','ã‚¨ãƒ³ãƒˆãƒª ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(574916,15970,'pt','Entrada de usuÃ¡rio',0),(574917,15970,'ru','Ð’Ñ…Ð¾Ð´ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(574918,15970,'es','Entrada usuario',0),(574919,15970,'de','Eintrag User',0),(574920,15970,'en','Entry User',0),(574921,15971,'is','',0),(574922,15971,'dr','Ø¯Ø³ØªÙ‡ ÙˆØ§Ø±Ø¯Ø§Øª',0),(574923,15971,'pr','Ø¯Ø³ØªÙ‡ ÙˆØ§Ø±Ø¯Ø§Øª',0),(574924,15971,'tr','Ä°Ã§e aktarma toplu',0),(574925,15971,'pl','Import sekwencji wsadowej',0),(574926,15971,'bg','Ð’Ð½Ð¾Ñ Ð¿Ð°Ñ€Ñ‚Ð¸Ð´Ð°',0),(574927,15971,'ur','Ø¨ÛŒÚ† Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(574928,15971,'sr','Ð£Ð²Ð¾Ð· Ð³Ñ€ÑƒÐ¿Ðµ',0),(574929,15971,'vi','Nháº­p kháº©u hÃ ng loáº¡t',0),(574930,15971,'af','Invoer bondel',0),(574931,15971,'ro','Lot de import',0),(574932,15971,'et','Impordi partii',0),(574933,15971,'si','Uvoz paketa',0),(574934,15971,'ba','Batch impor',0),(574935,15971,'nl','Import Batch',0),(574936,15971,'fi','Tuo erÃ¤',0),(574937,15971,'no','Importer Batch',0),(574938,15971,'da','Importbatchen',0),(574939,15971,'ko','ê°€ì ¸ì˜¤ê¸° ë°°ì¹˜',0),(574940,15971,'he','××¦×•×•×” ×™×™×‘×•×',0),(574941,15971,'el','ÎœÎ±Î¶Î¹ÎºÎ® ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(574942,15971,'zh','å¯¼å…¥æ‰¹æ¬¡',0),(574943,15971,'sv','Importera Batch',0),(574944,15971,'it','Batch di importazione',0),(574945,15971,'tl','',0),(574946,15971,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸Šà¸¸à¸”',0),(574947,15971,'hi','à¤†à¤¯à¤¾à¤¤ à¤¬à¥ˆà¤š',0),(574948,15971,'ms','Import Batch',0),(574949,15971,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¯ÙØ¹Ø©',0),(574950,15971,'fr','Lot dâ€™importation',0),(574951,15971,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ãƒãƒƒãƒ',0),(574952,15971,'pt','Lote de importaÃ§Ã£o',0),(574953,15971,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð°ÐºÐµÑ‚Ð°',0),(574954,15971,'es','Lote de importaciÃ³n',0),(574955,15971,'de','Importstapel',0),(574956,15971,'en','Import Batch',0),(574957,15972,'is','',0),(574958,15972,'dr','Ø³ÙˆØ§Ø¨Ù‚ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(574959,15972,'pr','Ø³ÙˆØ§Ø¨Ù‚ ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡',0),(574960,15972,'tr','AlÄ±nan kayÄ±tlar',0),(574961,15972,'pl','Zaimportowanych rekordÃ³w',0),(574962,15972,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(574963,15972,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø´Ø¯Û Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(574964,15972,'sr','Ð£Ð²ÐµÐ·ÐµÐ½Ðµ Ð·Ð°Ð¿Ð¸ÑÐµ',0),(574965,15972,'vi','Há»“ sÆ¡ nháº­p kháº©u',0),(574966,15972,'af','Ingevoerde rekords',0),(574967,15972,'ro','Importate de Ã®nregistrÄƒri',0),(574968,15972,'et','Imporditud kirjed',0),(574969,15972,'si','UvoÅ¾enih zapisov',0),(574970,15972,'ba','Catatan impor',0),(574971,15972,'nl','GeÃ¯mporteerde Records',0),(574972,15972,'fi','Tuodut tietueet',0),(574973,15972,'no','Importerte oppfÃ¸ringer',0),(574974,15972,'da','Importerede poster',0),(574975,15972,'ko','ê°€ì ¸ì˜¨ëœ ë ˆì½”ë“œ',0),(574976,15972,'he','×”×¨×©×•×ž×•×ª ×”×ž×™×•×‘××•×ª',0),(574977,15972,'el','Î•Î¹ÏƒÎ±Î³ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎºÎ±ÏÏ„Î­Î»ÎµÏ‚',0),(574978,15972,'zh','å¯¼å…¥çš„è®°å½•',0),(574979,15972,'sv','Importerade poster',0),(574980,15972,'it','Record importati',0),(574981,15972,'tl','',0),(574982,15972,'th','à¹€à¸£à¸à¸„à¸­à¸£à¹Œà¸”à¸—à¸µà¹ˆà¸™à¸³à¹€à¸‚à¹‰à¸²',0),(574983,15972,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤¿à¤ à¤—à¤ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡',0),(574984,15972,'ms','Rekod yang diimport',0),(574985,15972,'ar','Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… Ø§Ø³ØªÙŠØ±Ø§Ø¯Ù‡Ø§',0),(574986,15972,'fr','Enregistrements importÃ©s',0),(574987,15972,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã•ã‚ŒãŸãƒ¬ã‚³ãƒ¼ãƒ‰',0),(574988,15972,'pt','Registros importados',0),(574989,15972,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐµÐ¼Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(574990,15972,'es','Registros importados',0),(574991,15972,'de','Importierten DatensÃ¤tze',0),(574992,15972,'en','Imported Records',0),(574993,15973,'is','',0),(574994,15973,'dr','Ø§Ø·Ù„Ø§Ø¹ÛŒÙ‡ ÙˆØ§Ø±Ø¯Ø§Øª Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ù‡',0),(574995,15973,'pr','Ø§Ø·Ù„Ø§Ø¹ÛŒÙ‡ ÙˆØ§Ø±Ø¯Ø§Øª Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ù‡',0),(574996,15973,'tr','E-posta alma Bildirimler',0),(574997,15973,'pl','Powiadomienia e-mail importu',0),(574998,15973,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð²Ð½Ð¾Ñ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ Ð·Ð°',0),(574999,15973,'ur','Ø§ÛŒ Ù…ÛŒÙ„ Ú©ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù†ÙˆÙ¹Ø³Ø² Ú©Ø§',0),(575000,15973,'sr','ÐžÐ±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ° ÑƒÐ²Ð¾Ð· Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ',0),(575001,15973,'vi','ThÃ´ng bÃ¡o nháº­p kháº©u email Ä‘áº¿n',0),(575002,15973,'af','E-pos invoer kennisgewings aan',0),(575003,15973,'ro','NotificÄƒrile de Import e-mail la',0),(575004,15973,'et','E-posti importimise teated',0),(575005,15973,'si','Uvoz e-poÅ¡te obvestila',0),(575006,15973,'ba','Pemberitahuan impor email ke',0),(575007,15973,'nl','E-mail importeren mededelingen aan de',0),(575008,15973,'fi','SÃ¤hkÃ¶posti tuonti ilmoitukset',0),(575009,15973,'no','E-post Import meldinger',0),(575010,15973,'da','E-mail Import meddelelser til',0),(575011,15973,'ko','ì „ìž ë©”ì¼ ê°€ì ¸ì˜¤ê¸° í†µì§€',0),(575012,15973,'he','×™×™×‘×•× ×”×•×“×¢×•×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™ ×›×“×™',0),(575013,15973,'el','ÎšÎ¿Î¹Î½Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Î¼Î­ÏƒÏ‰ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î³Î¹Î± Î½Î±',0),(575014,15973,'zh','ç”µå­é‚®ä»¶å¯¼å…¥é€šçŸ¥åˆ°',0),(575015,15973,'sv','E-post importera meddelanden till',0),(575016,15973,'it','Comunicazioni di importazione di e-mail a',0),(575017,15973,'tl','',0),(575018,15973,'th','à¸›à¸£à¸°à¸à¸²à¸¨à¸™à¸³à¹€à¸‚à¹‰à¸²à¸­à¸µà¹€à¸¡à¸¥à¹Œà¹„à¸›',0),(575019,15973,'hi','à¤ˆà¤®à¥‡à¤² à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¥‹à¤Ÿà¤¿à¤¸',0),(575020,15973,'ms','E-mel notis Import',0),(575021,15973,'ar','Ø¥Ø´Ø¹Ø§Ø±Ø§Øª Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¥Ù„Ù‰',0),(575022,15973,'fr','Avis dâ€™importation courriel Ã ',0),(575023,15973,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(575024,15973,'pt','Avisos de importaÃ§Ã£o e-mail para',0),(575025,15973,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(575026,15973,'es','Avisos de importaciÃ³n de correo electrÃ³nico a',0),(575027,15973,'de','E-Mail-Import Mitteilungen an',0),(575028,15973,'en','Email Import Notices To',0),(575029,15974,'is','',0),(575030,15974,'dr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯Ø³ØªÛŒ',0),(575031,15974,'pr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯Ø³ØªÛŒ',0),(575032,15974,'tr','Manuel giriÅŸler',0),(575033,15974,'pl','Wpisy wprowadzane rÄ™cznie',0),(575034,15974,'bg','Ð ÑŠÑ‡Ð½Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(575035,15974,'ur','Ø¯Ø³ØªÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(575036,15974,'sr','Ð ÑƒÑ‡Ð½Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ',0),(575037,15974,'vi','Má»¥c hÆ°á»›ng dáº«n sá»­ dá»¥ng',0),(575038,15974,'af','Handleiding inskrywings',0),(575039,15974,'ro','Manual intrÄƒrile',0),(575040,15974,'et','KÃ¤sitsi sisestamised',0),(575041,15974,'si','RoÄni vnosi',0),(575042,15974,'ba','Entri manual',0),(575043,15974,'nl','Handingangen',0),(575044,15974,'fi','KÃ¤sin tehtyjÃ¤ syÃ¶ttÃ¶jÃ¤',0),(575045,15974,'no','Manuelle oppfÃ¸ringer',0),(575046,15974,'da','Manuel indlÃ¦sning foretaget af',0),(575047,15974,'ko','ìˆ˜ë™ í•­ëª©',0),(575048,15974,'he','×¢×¨×›×™× ×™×“× ×™×ª',0),(575049,15974,'el','Î§ÎµÎ¹ÏÎ¿ÎºÎ¯Î½Î·Ï„ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(575050,15974,'zh','æ‰‹åŠ¨è¾“å…¥',0),(575051,15974,'sv','Manuella angivelser',0),(575052,15974,'it','Inserimenti manuali',0),(575053,15974,'tl','',0),(575054,15974,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(575055,15974,'hi','à¤®à¥ˆà¤¨à¥à¤…à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(575056,15974,'ms','Penyertaan secara manual',0),(575057,15974,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø¯Ù„ÙŠÙ„',0),(575058,15974,'fr','Saisie manuelle',0),(575059,15974,'jp','ãƒžãƒ‹ãƒ¥ã‚¢ãƒ«ã®ã‚¨ãƒ³ãƒˆãƒª',0),(575060,15974,'pt','Entradas manuais',0),(575061,15974,'ru','Ð ÑƒÑ‡Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(575062,15974,'es','Entradas manuales',0),(575063,15974,'de','Manuelle Eingaben',0),(575064,15974,'en','Manual Entries',0),(575065,15975,'is','',0),(575066,15975,'dr','ÛŒÚ© Ø§ÛŒÙ…ÛŒÙ„ Ø¯Ø± Ù‡Ø± Ø®Ø·',0),(575067,15975,'pr','ÛŒÚ© Ø§ÛŒÙ…ÛŒÙ„ Ø¯Ø± Ù‡Ø± Ø®Ø·',0),(575068,15975,'tr','Her satÄ±ra bir e-posta',0),(575069,15975,'pl','Jeden E-mail na liniÄ™',0),(575070,15975,'bg','Ð•Ð´Ð¸Ð½ Ð¸Ð¼ÐµÐ¹Ð» Ð½Ð° Ñ€ÐµÐ´',0),(575071,15975,'ur','Ø§ÛŒÚ© Ø§ÛŒ Ù…ÛŒÙ„ ÙÛŒ Ø³Ø·Ø±',0),(575072,15975,'sr','ÐˆÐµÐ´Ð°Ð½ Ð•Ð¼Ð°Ð¸Ð» Ð¿Ð¾ Ñ€ÐµÐ´Ñƒ',0),(575073,15975,'vi','Má»™t trong nhá»¯ng Email má»—i dÃ²ng',0),(575074,15975,'af','Een e-pos Per lyn',0),(575075,15975,'ro','Un E-mail pe linie',0),(575076,15975,'et','Ãœks e-posti rea kohta',0),(575077,15975,'si','NedoloÄni zaimek Email na vrstico',0),(575078,15975,'ba','Satu Email Per baris',0),(575079,15975,'nl','Ã‰Ã©n E-mail Per regel',0),(575080,15975,'fi','Yksi sÃ¤hkÃ¶postiosoite Per rivi',0),(575081,15975,'no','En e-post Per linje',0),(575082,15975,'da','En E-mail pr linje',0),(575083,15975,'ko','ì„  ë‹¹ 1 ì´ë©”ì¼',0),(575084,15975,'he','×“×•××¨ ××œ×§×˜×¨×•× ×™ ××—×“ ×‘×›×œ ×©×•×¨×”',0),(575085,15975,'el','ÎˆÎ½Î± Email Î³Î¹Î± ÎºÎ¬Î¸Îµ Î³ÏÎ±Î¼Î¼Î®',0),(575086,15975,'zh','æ¯è¡Œä¸€ä¸ªç”µå­é‚®ä»¶',0),(575087,15975,'sv','En e-post Per rad',0),(575088,15975,'it','Una Email per ogni riga',0),(575089,15975,'tl','',0),(575090,15975,'th','à¸­à¸µà¸•à¹ˆà¸­à¸šà¸£à¸£à¸—à¸±à¸”',0),(575091,15975,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤à¤• à¤ˆà¤®à¥‡à¤²',0),(575092,15975,'ms','E-mel satu Per baris',0),(575093,15975,'ar','Ø¨Ø±ÙŠØ¯ Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ ÙˆØ§Ø­Ø¯ ÙÙŠ ÙƒÙ„ Ø³Ø·Ø±',0),(575094,15975,'fr','Un Email par ligne',0),(575095,15975,'jp','1 è¡Œã«ã¤ã 1 ã¤ã®ãƒ¡ãƒ¼ãƒ«',0),(575096,15975,'pt','Um E-mail por linha',0),(575097,15975,'ru','ÐžÐ´Ð¸Ð½ Ð°Ð´Ñ€ÐµÑ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð² ÑÑ‚Ñ€Ð¾ÐºÐµ',0),(575098,15975,'es','Un Email por lÃ­nea',0),(575099,15975,'de','Eine E-Mail pro Zeile',0),(575100,15975,'en','One Email Per Line',0),(575101,15976,'is','',0),(575102,15976,'dr','ØªÙ†Ø¸ÛŒÙ… Ù†Ù…Ø§Ø¨Ø±',0),(575103,15976,'pr','ØªÙ†Ø¸ÛŒÙ… Ù†Ù…Ø§Ø¨Ø±',0),(575104,15976,'tr','Faks ayarlanmamÄ±ÅŸ',0),(575105,15976,'pl','Nie zestaw faksu',0),(575106,15976,'bg','Ð¤Ð°ÐºÑ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼',0),(575107,15976,'ur','ÙÛŒÚ©Ø³ Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(575108,15976,'sr','Ð¤Ð°ÐºÑ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(575109,15976,'vi','Fax khÃ´ng Ä‘Æ°á»£c thiáº¿t láº­p',0),(575110,15976,'af','Faks stel nie',0),(575111,15976,'ro','Fax nu Set',0),(575112,15976,'et','Faks ei mÃ¤Ã¤ra',0),(575113,15976,'si','Faksa ni nastavljena',0),(575114,15976,'ba','Faks tidak diatur',0),(575115,15976,'nl','Fax niet ingesteld',0),(575116,15976,'fi','Faksi ei ole mÃ¤Ã¤ritetty',0),(575117,15976,'no','Faks ikke angitt',0),(575118,15976,'da','Fax ikke indstillet',0),(575119,15976,'ko','íŒ©ìŠ¤ ì„¤ì • í•˜ì§€',0),(575120,15976,'he','×¤×§×¡ ××™× ×• ×ž×•×’×“×¨',0),(575121,15976,'el','Î¦Î±Î¾ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(575122,15976,'zh','ä¼ çœŸæœªè®¾ç½®',0),(575123,15976,'sv','Fax inte instÃ¤lld',0),(575124,15976,'it','Fax non impostato',0),(575125,15976,'tl','',0),(575126,15976,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹‚à¸—à¸£à¸ªà¸²à¸£',0),(575127,15976,'hi','à¤«à¤¼à¥ˆà¤•à¥à¤¸ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(575128,15976,'ms','Perkhidmatan Faks tidak disetkan',0),(575129,15976,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„ÙØ§ÙƒØ³',0),(575130,15976,'fr','TÃ©lÃ©copieur pas dÃ©finie',0),(575131,15976,'jp','Fax ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(575132,15976,'pt','Fax nÃ£o definido',0),(575133,15976,'ru','Ð¤Ð°ÐºÑ Ð½Ðµ Ð·Ð°Ð´Ð°Ð½Ð¾',0),(575134,15976,'es','Fax no establece',0),(575135,15976,'de','Fax wurde nicht festgelegt.',0),(575136,15976,'en','Fax Not Set',0),(575137,15977,'is','',0),(575138,15977,'dr','ÙØ±ÙˆØ´ Ú©Ø§Ø±',0),(575139,15977,'pr','ÙØ±ÙˆØ´ Ú©Ø§Ø±',0),(575140,15977,'tr','Proje satÄ±ÅŸlarÄ±',0),(575141,15977,'pl','SprzedaÅ¼y zleceÅ„',0),(575142,15977,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸',0),(575143,15977,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(575144,15977,'sr','ÐŸÑ€Ð¾Ð´Ð°Ñ˜Ð° Ð¿Ð¾ÑÐ»Ð¾Ð²Ð°',0),(575145,15977,'vi','Viá»‡c lÃ m bÃ¡n hÃ ng',0),(575146,15977,'af','Werk verkope',0),(575147,15977,'ro','Job vanzari',0),(575148,15977,'et','ProjektimÃ¼Ã¼gi',0),(575149,15977,'si','Projektne prodaje',0),(575150,15977,'ba','Pekerjaan penjualan',0),(575151,15977,'nl','Projectomzet',0),(575152,15977,'fi','Projektimyynnin',0),(575153,15977,'no','Prosjektsalg',0),(575154,15977,'da','Sagssalg',0),(575155,15977,'ko','ì¼ íŒë§¤',0),(575156,15977,'he','×¢×‘×•×“×” ×ž×›×™×¨×•×ª',0),(575157,15977,'el','Î Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î­ÏÎ³Î¿Ï…',0),(575158,15977,'zh','å·¥ä½œé”€å”®',0),(575159,15977,'sv','ProjektfÃ¶rsÃ¤ljning',0),(575160,15977,'it','Lavoro vendite',0),(575161,15977,'tl','',0),(575162,15977,'th','à¸‚à¸²à¸¢à¸‡à¸²à¸™',0),(575163,15977,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥€ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(575164,15977,'ms','Kerja jualan',0),(575165,15977,'ar','Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(575166,15977,'fr','Emplois ventes',0),(575167,15977,'jp','ä»•äº‹è²©å£²',0),(575168,15977,'pt','Emprego vendas',0),(575169,15977,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð°',0),(575170,15977,'es','Trabajo ventas',0),(575171,15977,'de','Job Verkauf',0),(575172,15977,'en','Job Sales',0),(575173,15978,'is','',0),(575174,15978,'dr','Ø­Ø¯ Ø§Ø¹ØªØ¨Ø§Ø± prelim',0),(575175,15978,'pr','Ø­Ø¯ Ø§Ø¹ØªØ¨Ø§Ø± prelim',0),(575176,15978,'tr','Prelim kredi limiti',0),(575177,15978,'pl','Limit kredytowy Prelim',0),(575178,15978,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ ÐºÑ€ÐµÐ´Ð¸Ñ‚ÐµÐ½ Ð»Ð¸Ð¼Ð¸Ñ‚',0),(575179,15978,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ú©ÛŒ Ú©Ø±ÛŒÚˆÙ¹ Ú©ÛŒ Ø­Ø¯',0),(575180,15978,'sr','Ð£Ð²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð³ Ð»Ð¸Ð¼Ð¸Ñ‚Ð°',0),(575181,15978,'vi','Háº¡n má»©c tÃ­n dá»¥ng prelim',0),(575182,15978,'af','Prelim kredietlimiet',0),(575183,15978,'ro','Limita de Credit preliminare',0),(575184,15978,'et','Esialgne krediidilimiit',0),(575185,15978,'si','Predhodnega limita',0),(575186,15978,'ba','Batas kredit prelim',0),(575187,15978,'nl','Kwalificatie kredietlimiet',0),(575188,15978,'fi','Alustava luottoraja',0),(575189,15978,'no','Prelim kredittgrensen',0),(575190,15978,'da','Prelim kreditmaksimum',0),(575191,15978,'ko','ì˜ˆì„  ì‹ ìš© í•œë„',0),(575192,15978,'he','×ž×’×‘×œ×ª ×”××©×¨××™ ×ž×•×§×“×',0),(575193,15978,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÏŒ ÏŒÏÎ¹Î¿',0),(575194,15978,'zh','åˆè¯•ä¿¡ç”¨é¢åº¦',0),(575195,15978,'sv','PreliminÃ¤rt kreditgrÃ¤ns',0),(575196,15978,'it','Limite di credito Prelim',0),(575197,15978,'tl','',0),(575198,15978,'th','à¸§à¸‡à¹€à¸‡à¸´à¸™à¸ªà¸´à¸™à¹€à¸Šà¸·à¹ˆà¸­ prelim',0),(575199,15978,'hi','Prelim à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤¸à¥€à¤®à¤¾',0),(575200,15978,'ms','Had kredit prelim',0),(575201,15978,'ar','Ø§Ù„Ø­Ø¯ Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†ÙŠ prelim',0),(575202,15978,'fr','Limite de crÃ©dit Prelim',0),(575203,15978,'jp','äºˆå‚™æ ¼ä»˜ã‘ãƒ»ä¸Žä¿¡é™åº¦é¡',0),(575204,15978,'pt','Limite de crÃ©dito prelim',0),(575205,15978,'ru','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ñ‹Ð¹ Ð»Ð¸Ð¼Ð¸Ñ‚',0),(575206,15978,'es','LÃ­mite de crÃ©dito prelim',0),(575207,15978,'de','Bracelet-Credit-Limit',0),(575208,15978,'en','Prelim Credit Limit',0),(575209,15979,'is','',0),(575210,15979,'dr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ú©ÙˆØ¯Ú©',0),(575211,15979,'pr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ú©ÙˆØ¯Ú©',0),(575212,15979,'tr','Ã‡ocuk giriÅŸleri',0),(575213,15979,'pl','Wpisy podrzÄ™dne',0),(575214,15979,'bg','Ð”ÐµÑ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(575215,15979,'ur','Ø¨Ú†Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(575216,15979,'sr','Ð”ÐµÑ‚Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(575217,15979,'vi','Tráº» em má»›i',0),(575218,15979,'af','Kind inskrywings',0),(575219,15979,'ro','IntrÄƒrile de copil',0),(575220,15979,'et','Lapse kanded',0),(575221,15979,'si','Otrok vpise',0),(575222,15979,'ba','Anak entri',0),(575223,15979,'nl','Kind posten',0),(575224,15979,'fi','Alikohteet',0),(575225,15979,'no','Underordnede oppfÃ¸ringer',0),(575226,15979,'da','Barn poster',0),(575227,15979,'ko','ìžì‹ í•­ëª©',0),(575228,15979,'he','×¢×¨×›×™ ×”×™×œ×“',0),(575229,15979,'el','Î Î±Î¹Î´Î¯ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(575230,15979,'zh','å­æ¡ç›®',0),(575231,15979,'sv','Underordnade poster',0),(575232,15979,'it','Voci figlio',0),(575233,15979,'tl','',0),(575234,15979,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸”à¹‡à¸',0),(575235,15979,'hi','à¤¬à¤šà¥à¤šà¥‡ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(575236,15979,'ms','Penyertaan kanak-kanak',0),(575237,15979,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ø·ÙÙ„',0),(575238,15979,'fr','EntrÃ©es enfant',0),(575239,15979,'jp','å­ã‚¨ãƒ³ãƒˆãƒª',0),(575240,15979,'pt','Entradas de crianÃ§a',0),(575241,15979,'ru','Ð”Ð¾Ñ‡ÐµÑ€Ð½Ð¸Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(575242,15979,'es','Entradas secundarias',0),(575243,15979,'de','Kind-EintrÃ¤ge',0),(575244,15979,'en','Child Entries',0),(575245,15980,'is','',0),(575246,15980,'dr','Ù¾Ø¯Ø± Ùˆ Ù…Ø§Ø¯Ø± Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(575247,15980,'pr','Ù¾Ø¯Ø± Ùˆ Ù…Ø§Ø¯Ø± Ù…Ø´Ø§Ù‡Ø¯Ù‡',0),(575248,15980,'tr','GÃ¶rÃ¼nÃ¼mÃ¼ Ã¼st',0),(575249,15980,'pl','Widoku nadrzÄ™dnego',0),(575250,15980,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ñ€Ð¾Ð´Ð¸Ñ‚ÐµÐ»',0),(575251,15980,'ur','Ù…Ù†Ø¸Ø± ÙˆØ§Ù„Ø¯ÛŒÙ†',0),(575252,15980,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð½Ð°Ð´Ñ€ÐµÑ’ÐµÐ½Ðµ',0),(575253,15980,'vi','Xem phá»¥ huynh',0),(575254,15980,'af','Bekyk ouer',0),(575255,15980,'ro','Vezi pÄƒrinte',0),(575256,15980,'et','Kuva peamine kirje',0),(575257,15980,'si','Pogled nadrejenega',0),(575258,15980,'ba','Lihat induk',0),(575259,15980,'nl','Bovenliggende weergave',0),(575260,15980,'fi','NÃ¤ytÃ¤ ylÃ¤taso',0),(575261,15980,'no','Vis overordnet',0),(575262,15980,'da','Se forÃ¦lder',0),(575263,15980,'ko','ë³´ê¸° ë¶€ëª¨',0),(575264,15980,'he','×ª×¦×•×’×ª ××‘',0),(575265,15980,'el','Î ÏÎ¿Î²Î¿Î»Î® Î³Î¿Î½Î¹ÎºÏŒ',0),(575266,15980,'zh','æŸ¥çœ‹çˆ¶',0),(575267,15980,'sv','Visa fÃ¶rÃ¤lder',0),(575268,15980,'it','Visualizza elemento padre',0),(575269,15980,'tl','',0),(575270,15980,'th','à¸¡à¸¸à¸¡à¸¡à¸­à¸‡à¸«à¸¥à¸±à¸',0),(575271,15980,'hi','à¤¦à¥ƒà¤¶à¥à¤¯ à¤ªà¥ˆà¤°à¥‡à¤‚à¤Ÿ',0),(575272,15980,'ms','Pandangan ibu bapa',0),(575273,15980,'ar','Ø¹Ø±Ø¶ Ø§Ù„Ø£ØµÙ„',0),(575274,15980,'fr','Vue Parent',0),(575275,15980,'jp','ãƒ“ãƒ¥ãƒ¼ã®è¦ª',0),(575276,15980,'pt','Pai de exibiÃ§Ã£o',0),(575277,15980,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ñ€Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ð³Ð¾',0),(575278,15980,'es','Ver padres',0),(575279,15980,'de','View Parent',0),(575280,15980,'en','View Parent',0),(575281,15981,'is','',0),(575282,15981,'dr','ÙˆØ¶Ø¹ÛŒØª Ù‡Ù…Ú¯Ø§Ù… Ø³Ø§Ø²ÛŒ Ù„ØºÙˆ Ø³ÙØ§Ø±Ø´Ø§Øª Ù…ÙˆØ¬ÙˆØ¯',0),(575283,15981,'pr','ÙˆØ¶Ø¹ÛŒØª Ù‡Ù…Ú¯Ø§Ù… Ø³Ø§Ø²ÛŒ Ù„ØºÙˆ Ø³ÙØ§Ø±Ø´Ø§Øª Ù…ÙˆØ¬ÙˆØ¯',0),(575284,15981,'tr','EÅŸitleme iptal varolan sipariÅŸlerinin durumunu',0),(575285,15981,'pl','Stan synchronizacji Anuluj istniejÄ…ce zlecenia',0),(575286,15981,'bg','Ð¡ÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾ Ð½Ð° ÑÐ¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚ÐºÐ°Ð· Ð½Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(575287,15981,'ur','ÛÙ… ÙˆÙ‚Øª Ø³Ø§Ø²ÛŒ Ù…Ù†Ø³ÙˆØ® Ø­Ø§Ù„Øª Ù…ÙˆØ¬ÙˆØ¯Û Ø§Ø­Ú©Ø§Ù…Ø§Øª Ú©ÛŒ',0),(575288,15981,'sr','\"ÐžÑ‚ÐºÐ°Ð¶Ð¸ \" Ð¡Ñ‚Ð°Ñ‚ÑƒÑ ÑÐ¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸Ñ… Ð½Ð°Ð»Ð¾Ð³Ð° Ð·Ð°',0),(575289,15981,'vi','Tráº¡ng thÃ¡i Ä‘á»“ng bá»™ há»§y bá» Ä‘Æ¡n Ä‘áº·t hÃ ng hiá»‡n cÃ³ cá»§a',0),(575290,15981,'af','Kanselleer sinchrostatus van bestaande bestellings',0),(575291,15981,'ro','Stare sincronizare de anulare a ordinelor existente',0),(575292,15981,'et','Olemasolevate tellimuste Loobu sÃ¼nkroonimisolekut',0),(575293,15981,'si','Stanje sinhronizacije ukinitev obstojeÄih naroÄil',0),(575294,15981,'ba','Sinkronisasi membatalkan Status order yang ada',0),(575295,15981,'nl','Annuleren de synchronisatiestatus van bestaande Orders',0),(575296,15981,'fi','Peruuta synkronointitilan tilauksissa',0),(575297,15981,'no','Avbryt synkroniseringsstatus for eksisterende ordrer',0),(575298,15981,'da','Annuller synkroniseringsstatus for eksisterende ordrer',0),(575299,15981,'ko','ê¸°ì¡´ ì£¼ë¬¸ì˜ ë™ê¸°í™” ì·¨ì†Œ ìƒíƒœ',0),(575300,15981,'he','×‘×™×˜×•×œ ×ž×¦×‘ ×”×¡×™× ×›×¨×•×Ÿ ×©×œ ×”×•×¨××•×ª ×©×§×™×™×ž×•×ª',0),(575301,15981,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÏƒÏ…Î³Ï‡ÏÎ¿Î½Î¹ÏƒÎ¼Î¿Ï \"Î†ÎºÏ…ÏÎ¿\" Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎµÏ‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(575302,15981,'zh','åŒæ­¥å–æ¶ˆçŽ°æœ‰è®¢å•çš„çŠ¶æ€',0),(575303,15981,'sv','Avbryt synkroniseringsstatus av existerande order',0),(575304,15981,'it','Stato di Annulla sincronizzazione degli ordini esistenti',0),(575305,15981,'tl','',0),(575306,15981,'th','à¸‹à¸´à¸‡à¸„à¹Œà¸¢à¸à¹€à¸¥à¸´à¸à¸ªà¸–à¸²à¸™à¸°à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(575307,15981,'hi','à¤¸à¤¿à¤‚à¤•à¥à¤°à¤¨à¤¾à¤‡à¤œà¤¼à¥‡à¤¶à¤¨ à¤°à¤¦à¥à¤¦ à¤•à¤°à¥‡à¤‚ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤†à¤¦à¥‡à¤¶à¥‹à¤‚ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(575308,15981,'ms','Status Batal segerak sedia ada pesanan',0),(575309,15981,'ar','Ø­Ø§Ù„Ø© Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ù…Ø²Ø§Ù…Ù†Ø© Ù…Ù† Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù‚Ø§Ø¦Ù…Ø©',0),(575310,15981,'fr','Ã‰tat dâ€™annuler la synchronisation des ordonnances en vigueur',0),(575311,15981,'jp','æ—¢å­˜ã®æ³¨æ–‡ã®åŒæœŸã‚­ãƒ£ãƒ³ã‚»ãƒ« ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(575312,15981,'pt','Status de sincronizaÃ§Ã£o cancelamento de ordens existentes',0),(575313,15981,'ru','ÐžÑ‚Ð¼ÐµÐ½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑÐ° ÑÐ¸Ð½Ñ…Ñ€Ð¾Ð½Ð¸Ð·Ð°Ñ†Ð¸Ð¸ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(575314,15981,'es','Estado de cancelar sincronizaciÃ³n de pedidos existentes',0),(575315,15981,'de','Abbrechen der Synchronisierungsstatus bestehender AuftrÃ¤ge',0),(575316,15981,'en','Sync Cancel Status Of Existing Orders',0),(575317,15982,'is','',0),(575318,15982,'dr','3dcart Ù„ØºÙˆ ÙˆØ¶Ø¹ÛŒØª Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(575319,15982,'pr','3dcart Ù„ØºÙˆ ÙˆØ¶Ø¹ÛŒØª Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(575320,15982,'tr','3dcart iptal durumunu otomatik olarak gÃ¼ncelleÅŸtir',0),(575321,15982,'pl','Automatycznie zaktualizowaÄ‡ stan Anuluj 3dcart',0),(575322,15982,'bg','3dcart Ð¾Ñ‚ÐºÐ°Ð· ÑÑ‚Ð°Ñ‚ÑƒÑ ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾',0),(575323,15982,'ur','3dcart Ù…Ù†Ø³ÙˆØ® Ø­Ø§Ù„Øª Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(575324,15982,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° 3Ð´Ñ†Ð°Ñ€Ñ‚ \"ÐžÑ‚ÐºÐ°Ð¶Ð¸\"',0),(575325,15982,'vi','Tá»± Ä‘á»™ng Cáº­p Nháº­t 3dcart há»§y bá» tÃ¬nh tráº¡ng',0),(575326,15982,'af','3dcart kanselleer Status outomaties opdateer',0),(575327,15982,'ro','Actualiza starea de revocare 3dcart automat',0),(575328,15982,'et','3dcart Loobu olek automaatselt uuendada',0),(575329,15982,'si','Samodejno posodobite stanje PrekliÄi 3dcart',0),(575330,15982,'ba','Memperbarui 3dcart membatalkan Status secara otomatis',0),(575331,15982,'nl','Automatisch bijwerken van 3dcart annuleren Status',0),(575332,15982,'fi','3dcart Peruuta tilan pÃ¤ivittÃ¤minen automaattisesti',0),(575333,15982,'no','Oppdatere 3dcart Avbryt statusen automatisk',0),(575334,15982,'da','3dcart Annuller Status opdateres automatisk',0),(575335,15982,'ko','3dcart ì·¨ì†Œ ìƒíƒœë¥¼ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(575336,15982,'he','×¢×“×›×Ÿ ×ž×¦×‘ ×‘×™×˜×•×œ 3dcart ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(575337,15982,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Ï„Î·Ï‚ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ \"Î†ÎºÏ…ÏÎ¿\" 3dcart',0),(575338,15982,'zh','è‡ªåŠ¨æ›´æ–° 3dcart å–æ¶ˆçŠ¶æ€',0),(575339,15982,'sv','Uppdatera 3dcart Avbryt Status automatiskt',0),(575340,15982,'it','Aggiornare lo stato 3dcart annulla automaticamente',0),(575341,15982,'tl','',0),(575342,15982,'th','3dcart à¸¢à¸à¹€à¸¥à¸´à¸à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(575343,15982,'hi','3dcart à¤°à¤¦à¥à¤¦ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(575344,15982,'ms','Kemas kini Status Batal 3dcart secara automatik',0),(575345,15982,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨ØªØ­Ø¯ÙŠØ« Ø­Ø§Ù„Ø© Ø¥Ù„ØºØ§Ø¡ 3dcart',0),(575346,15982,'fr','Mise Ã  jour de statut Cancel 3dcart automatiquement',0),(575347,15982,'jp','3dcart ã‚­ãƒ£ãƒ³ã‚»ãƒ« ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(575348,15982,'pt','Atualizar automaticamente o Status de cancelar 3dcart',0),(575349,15982,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart Ð¾Ñ‚Ð¼ÐµÐ½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(575350,15982,'es','Actualizar estado de cancelar 3dcart automÃ¡ticamente',0),(575351,15982,'de','3dcart abbrechen Status automatisch aktualisieren',0),(575352,15982,'en','Update 3dcart Cancel Status Automatically',0),(575353,15983,'is','',0),(575354,15983,'dr','3dcart Ù‡Ø²ÛŒÙ†Ù‡ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(575355,15983,'pr','3dcart Ù‡Ø²ÛŒÙ†Ù‡ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(575356,15983,'tr','3dcart nakliye Ã¼creti otomatik olarak gÃ¼ncelleÅŸtir',0),(575357,15983,'pl','Automatycznie zaktualizowaÄ‡ 3dcart opÅ‚at za wysyÅ‚kÄ™',0),(575358,15983,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° 3dcart ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ñ‚Ð°ÐºÑÐ°',0),(575359,15983,'ur','3dcart Ú©ÛŒ Ø´Ù¾Ù†Ú¯ ÙÛŒØ³ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(575360,15983,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¾Ñ‚Ð¿Ñ€ÐµÐ¼Ñƒ',0),(575361,15983,'vi','Tá»± Ä‘á»™ng cáº­p nháº­t cÃ¡c khoáº£n phÃ­ váº­n chuyá»ƒn 3dcart',0),(575362,15983,'af','3dcart gestuur fooi outomaties opdateer',0),(575363,15983,'ro','Actualiza automat taxa de transport maritim 3dcart',0),(575364,15983,'et','3dcart Shipping tasu automaatse vÃ¤rskendamise',0),(575365,15983,'si','Samodejno posodabljanje 3dcart ladijskega pristojbine',0),(575366,15983,'ba','Memperbarui biaya pengiriman 3dcart secara otomatis',0),(575367,15983,'nl','Automatisch bijwerken van 3dcart verzendkosten',0),(575368,15983,'fi','PÃ¤ivitÃ¤ 3dcart postikuluja automaattisesti',0),(575369,15983,'no','Oppdatere 3dcart frakt automatisk',0),(575370,15983,'da','Opdatere 3dcart Shipping gebyr automatisk',0),(575371,15983,'ko','3dcart ì„ ë°• ìš”ê¸ˆì„ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(575372,15983,'he','×¢×“×›×•×Ÿ ×“×ž×™ ×”×ž×©×œ×•×— 3dcart ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(575373,15983,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart ÏƒÏ„Î­Î»Î½Î¿Î½Ï„Î±Ï‚ Î±Î¼Î¿Î¹Î²Î®',0),(575374,15983,'zh','è‡ªåŠ¨æ›´æ–° 3dcart èˆªè¿è´¹',0),(575375,15983,'sv','Uppdatera 3dcart fraktavgift automatiskt',0),(575376,15983,'it','Aggiornare automaticamente il costo di spedizione 3dcart',0),(575377,15983,'tl','',0),(575378,15983,'th','à¸›à¸£à¸±à¸šà¸„à¹ˆà¸²à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ 3dcart',0),(575379,15983,'hi','3dcart à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤¶à¥à¤²à¥à¤• à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(575380,15983,'ms','Kos penghantaran 3dcart kemas kini secara automatik',0),(575381,15983,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨ØªØ­Ø¯ÙŠØ« Ø±Ø³ÙˆÙ… Ø§Ù„Ø´Ø­Ù† 3dcart',0),(575382,15983,'fr','Mettre Ã  jour automatiquement les frais dâ€™expÃ©dition 3dcart',0),(575383,15983,'jp','3dcart é€æ–™ã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(575384,15983,'pt','Atualizar a taxa do transporte 3dcart automaticamente',0),(575385,15983,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(575386,15983,'es','Actualicen 3dcart honorario del envÃ­o automÃ¡ticamente',0),(575387,15983,'de','3dcart Versandkosten automatisch aktualisieren',0),(575388,15983,'en','Update 3dcart Shipping Fee Automatically',0),(575389,15984,'is','',0),(575390,15984,'dr','3dcart Ø§ÙˆÙ„ÙˆÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(575391,15984,'pr','3dcart Ø§ÙˆÙ„ÙˆÛŒØª Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(575392,15984,'tr','3dcart nakliye tercih otomatik olarak gÃ¼ncelleÅŸtir',0),(575393,15984,'pl','Automatyczne aktualizowanie preferencji wysyÅ‚ki 3dcart',0),(575394,15984,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° 3dcart ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½Ð¸Ðµ',0),(575395,15984,'ur','3dcart Ú©ÛŒ Ø´Ù¾Ù†Ú¯ ØªØ±Ø¬ÛŒØ­ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(575396,15984,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ 3Ð´Ñ†Ð°Ñ€Ñ‚ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð¿Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(575397,15984,'vi','Tá»± Ä‘á»™ng Cáº­p Nháº­t 3dcart váº­n chuyá»ƒn Æ°u tiÃªn',0),(575398,15984,'af','3dcart gestuur voorkeur outomaties opdateer',0),(575399,15984,'ro','Actualiza preferinÅ£ele de transport 3dcart automat',0),(575400,15984,'et','3dcart laevanduse eelistus automaatse vÃ¤rskendamise',0),(575401,15984,'si','Samodejno posodabljanje 3dcart ladijskega prometa prednost',0),(575402,15984,'ba','Memperbarui preferensi pengiriman 3dcart secara otomatis',0),(575403,15984,'nl','Automatisch bijwerken van 3dcart scheepvaart voorkeur',0),(575404,15984,'fi','PÃ¤ivitÃ¤ 3dcart toimitus Preference automaattisesti',0),(575405,15984,'no','Oppdatere 3dcart Shipping preferanse automatisk',0),(575406,15984,'da','Opdatere 3dcart Shipping prÃ¦ference automatisk',0),(575407,15984,'ko','3dcart ìš´ì†¡ í™˜ê²½ ì„¤ì •ì„ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(575408,15984,'he','×¢×“×›×•×Ÿ 3dcart ×ž×©×œ×•×— ×”×¢×“×¤×” ××•×˜×•×ž×˜×™×ª',0),(575409,15984,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart Î½Î±Ï…Ï„Î¹Î»Î¯Î± Ï€ÏÎ¿Ï„Î¯Î¼Î·ÏƒÎ·',0),(575410,15984,'zh','è‡ªåŠ¨æ›´æ–° 3dcart èˆªè¿åå¥½',0),(575411,15984,'sv','Uppdatera 3dcart frakt preferens automatiskt',0),(575412,15984,'it','Aggiornare automaticamente 3dcart spedizione preferenza',0),(575413,15984,'tl','',0),(575414,15984,'th','à¸›à¸£à¸±à¸šà¸„à¹ˆà¸²à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡ 3dcart',0),(575415,15984,'hi','3dcart à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤°à¥€à¤¯à¤¤à¤¾ à¤•à¥‹ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(575416,15984,'ms','Kemas kini 3dcart penghantaran keutamaan secara automatik',0),(575417,15984,'ar','ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹ Ø¨ØªØ­Ø¯ÙŠØ« ØªÙØ¶ÙŠÙ„ Ø§Ù„Ù†Ù‚Ù„ Ø§Ù„Ø¨Ø­Ø±ÙŠ 3dcart',0),(575418,15984,'fr','Mettre Ã  jour automatiquement les prÃ©fÃ©rences dâ€™expÃ©dition 3dcart',0),(575419,15984,'jp','3dcart å‡ºè·ã®å„ªå…ˆé †ä½ã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(575420,15984,'pt','Atualizar automaticamente o 3dcart preferÃªncia de envio',0),(575421,15984,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚ÐµÐ½Ð¸Ñ',0),(575422,15984,'es','Actualicen 3dcart envÃ­o preferencia automÃ¡ticamente',0),(575423,15984,'de','3dcart Versand bevorzugt automatisch aktualisieren',0),(575424,15984,'en','Update 3dcart Shipping Preference Automatically',0),(575425,15985,'is','',0),(575426,15985,'dr','Ø¨Ø±Ø§ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø³ÛŒ Ø³ÛŒ GL Ø­Ø³Ø§Ø¨ Ø®Ø§Ù„ÛŒ Ø¨Ú¯Ø°Ø§Ø±ÛŒØ¯',0),(575427,15985,'pr','Ø¨Ø±Ø§ÛŒ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø³ÛŒ Ø³ÛŒ GL Ø­Ø³Ø§Ø¨ Ø®Ø§Ù„ÛŒ Ø¨Ú¯Ø°Ø§Ø±ÛŒØ¯',0),(575428,15985,'tr','CC GL hesap kullanmak iÃ§in boÅŸ bÄ±rakÄ±n',0),(575429,15985,'pl','Pozostaw puste, aby uÅ¼yÄ‡ konta GL CC',0),(575430,15985,'bg','ÐžÑÑ‚Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾, Ð·Ð° Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ CC GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(575431,15985,'ur','CC Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø®Ø§Ù„ÛŒ Ú†Ú¾ÙˆÚ‘ Ø¯ÛŒÚº',0),(575432,15985,'sr','ÐžÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð°Ð·Ð½Ð¾ Ð´Ð° ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð“Ð› Ð¦Ð¦',0),(575433,15985,'vi','Äá»ƒ trá»‘ng Ä‘á»ƒ sá»­ dá»¥ng CC GL khoáº£n',0),(575434,15985,'af','Laat blanko CC GL rekening gebruik',0),(575435,15985,'ro','LÄƒsaÅ£i necompletat pentru a utiliza contul de GL CC',0),(575436,15985,'et','JÃ¤tke tÃ¼hjaks CC GL kontot',0),(575437,15985,'si','Pustite prazno za uporabo CC GL raÄuna',0),(575438,15985,'ba','Biarkan kosong untuk menggunakan CC GL Account',0),(575439,15985,'nl','Laat leeg om CC GL Account te gebruiken',0),(575440,15985,'fi','JÃ¤tÃ¤ tyhjÃ¤ksi CC GL tilillÃ¤',0),(575441,15985,'no','Vil bruke CC gi-konto',0),(575442,15985,'da','Lad stÃ¥ tomt for at bruge CC GL konto',0),(575443,15985,'ko','CC GL ê³„ì •ì„ ì‚¬ìš© í•˜ë„ë¡ ë¹„ì›Œ ë‘¡ë‹ˆë‹¤',0),(575444,15985,'he','×”×©××¨ ××•×ª×• ×¨×™×§ ×›×“×™ ×œ×”×©×ª×ž×© ×‘×—×©×‘×•×Ÿ GL CC',0),(575445,15985,'el','Î‘Ï†Î®ÏƒÏ„Îµ Ï„Î¿ ÎºÎµÎ½ÏŒ Î³Î¹Î± Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» CC',0),(575446,15985,'zh','ä¸ºç©ºåˆ™ä½¿ç”¨ CC GL å¸æˆ·',0),(575447,15985,'sv','LÃ¤mna tomt fÃ¶r att anvÃ¤nda CC GL konto',0),(575448,15985,'it','Lasciare vuoto per utilizzare CC GL Account',0),(575449,15985,'tl','',0),(575450,15985,'th','à¸›à¸¥à¹ˆà¸­à¸¢à¸§à¹ˆà¸²à¸‡à¹„à¸§à¹‰à¹€à¸žà¸·à¹ˆà¸­à¹ƒà¸Šà¹‰à¸šà¸±à¸à¸Šà¸µ GL CC',0),(575451,15985,'hi','CC GL à¤–à¤¾à¤¤à¥‡ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤–à¤¾à¤²à¥€ à¤›à¥‹à¤¡à¤¼ à¤¦à¥‡à¤‚',0),(575452,15985,'ms','Tinggalkan tempat kosong untuk menggunakan akaun GL CC',0),(575453,15985,'ar','Ø§ØªØ±Ùƒ Ø§Ù„Ù…Ø³Ø§Ø­Ø© ÙØ§Ø±ØºØ© Ù„Ø§Ø³ØªØ®Ø¯Ø§Ù… Ø­Ø³Ø§Ø¨ GL CC',0),(575454,15985,'fr','Laissez vide pour utiliser le compte GL CC',0),(575455,15985,'jp','CC GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’ä½¿ç”¨ã™ã‚‹å ´åˆã¯ç©ºç™½ã®ã¾ã¾ã«',0),(575456,15985,'pt','Deixe em branco para usar CC GL conta',0),(575457,15985,'ru','ÐžÑÑ‚Ð°Ð²ÑŒÑ‚Ðµ Ð¿ÑƒÑÑ‚Ñ‹Ð¼, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL CC',0),(575458,15985,'es','Deje en blanco para utilizar CC GL cuenta',0),(575459,15985,'de','Freilassen Sie, CC-GL-Konto verwenden',0),(575460,15985,'en','Leave Blank To Use CC GL Account',0),(575461,15986,'is','',0),(575462,15986,'dr','ÙØ±Ø¶ Ø±Ø¯Ù‡ GL',0),(575463,15986,'pr','ÙØ±Ø¶ Ø±Ø¯Ù‡ GL',0),(575464,15986,'tr','VarsayÄ±lan GL Kategori',0),(575465,15986,'pl','DomyÅ›lnej kategorii GL',0),(575466,15986,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ GL ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(575467,15986,'ur','Ø·Û’ Ø´Ø¯Û Ø¬ÛŒØ¬Û’ Ø²Ù…Ø±Û',0),(575468,15986,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ñƒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð“Ð›',0),(575469,15986,'vi','Máº·c Ä‘á»‹nh GL thá»ƒ loáº¡i',0),(575470,15986,'af','Verstek GL kategorie',0),(575471,15986,'ro','Categoria de GL implicit',0),(575472,15986,'et','GL vaikekategooria',0),(575473,15986,'si','Privzeto GL Category',0),(575474,15986,'ba','Kategori GL standar',0),(575475,15986,'nl','Standaard GL categorie',0),(575476,15986,'fi','GL oletusluokka',0),(575477,15986,'no','GL standardkategori',0),(575478,15986,'da','Standard GL kategori',0),(575479,15986,'ko','ê¸°ë³¸ GL ì¹´í…Œê³ ë¦¬',0),(575480,15986,'he','×§×˜×’×•×¨×™×ª GL ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(575481,15986,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± GL',0),(575482,15986,'zh','é»˜è®¤ GL ç±»åˆ«',0),(575483,15986,'sv','Standardkategori fÃ¶r GL',0),(575484,15986,'it','Categoria predefinita GL',0),(575485,15986,'tl','',0),(575486,15986,'th','à¸›à¸£à¸°à¹€à¸ à¸— GL à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(575487,15986,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ GL à¤¶à¥à¤°à¥‡à¤£à¥€',0),(575488,15986,'ms','Kategori GL lalai',0),(575489,15986,'ar','Ø§Ù„ÙØ¦Ø© GL Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ©',0),(575490,15986,'fr','CatÃ©gorie GL par dÃ©faut',0),(575491,15986,'jp','æ—¢å®šã® GL ã‚«ãƒ†ã‚´ãƒª',0),(575492,15986,'pt','Categoria GL padrÃ£o',0),(575493,15986,'ru','ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ GL',0),(575494,15986,'es','CategorÃ­a de defecto GL',0),(575495,15986,'de','Standardkategorie GL',0),(575496,15986,'en','Default GL Category',0),(575497,15987,'is','',0),(575498,15987,'dr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ ØµÙØ­Ù‡ ÙˆØ¶Ø¹ÛŒØª Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø³Ø§ÛŒØª B2B',0),(575499,15987,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ ØµÙØ­Ù‡ ÙˆØ¶Ø¹ÛŒØª Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø³Ø§ÛŒØª B2B',0),(575500,15987,'tr','B2B sitesi sipariÅŸ durumu sayfasÄ±nda izin',0),(575501,15987,'pl','Zezwalaj na stronie statusu zamÃ³wienia na stronie B2B',0),(575502,15987,'bg','ÐŸÐ¾Ð·Ð²Ð¾Ð»Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ‚Ð° Ð·Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° B2B ÑÐ°Ð¹Ñ‚',0),(575503,15987,'ur','ØªØ±ØªÛŒØ¨ Ø­Ø§Ù„Øª ØµÙØ­Û B2B Ø³Ø§Ø¦Ù¹ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(575504,15987,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸Ñ‚Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸ ÑÑ‚Ð°Ñ‚ÑƒÑÐ° Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸ Ð‘2Ð‘',0),(575505,15987,'vi','Cho phÃ©p Ä‘áº·t hÃ ng tÃ¬nh tráº¡ng trang trÃªn trang web B2B',0),(575506,15987,'af','Orde Status bladsy op B2B werf laat',0),(575507,15987,'ro','Permite pagina de Status comandÄƒ pe site-ul B2B',0),(575508,15987,'et','Luba tellimuse oleku lehele B2B kohapeal',0),(575509,15987,'si','OmogoÄi stanje strani na B2B strani',0),(575510,15987,'ba','Memungkinkan halaman Status Order situs B2B',0),(575511,15987,'nl','Pagina van de Status van de bestelling op B2B Site toestaan',0),(575512,15987,'fi','Salli tilauksen tila B2B-sivuston sivulla',0),(575513,15987,'no','Tillate ordre statusside pÃ¥ B2B nettsted',0),(575514,15987,'da','Tillade ordre statusside pÃ¥ B2B Site',0),(575515,15987,'ko','B2B ì‚¬ì´íŠ¸ì— ì£¼ë¬¸ ìƒíƒœ íŽ˜ì´ì§€ë¥¼ í—ˆìš©',0),(575516,15987,'he','×œ××¤×©×¨ ×¡×“×¨ ×“×£ ×ž×¦×‘ ×‘××ª×¨ B2B',0),(575517,15987,'el','Î•Ï€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï„Î· ÏƒÎµÎ»Î¯Î´Î± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ ÏƒÏ„Î·Î½ Î¹ÏƒÏ„Î¿ÏƒÎµÎ»Î¯Î´Î± Ï„Î·Ï‚ B2B',0),(575518,15987,'zh','å…è®¸åœ¨ B2B ç½‘ç«™ä¸Šçš„è®¢å•çŠ¶æ€é¡µ',0),(575519,15987,'sv','TillÃ¥ta Order statussida pÃ¥ B2B webbplats',0),(575520,15987,'it','Consentire la pagina stato dell\'ordine sul sito B2B',0),(575521,15987,'tl','',0),(575522,15987,'th','à¸­à¸™à¸¸à¸à¸²à¸•à¸«à¸™à¹‰à¸²à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸šà¸™à¹€à¸§à¹‡à¸šà¹„à¸‹à¸•à¹Œ B2B',0),(575523,15987,'hi','à¤†à¤¦à¥‡à¤¶ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤ªà¥ƒà¤·à¥à¤  B2B à¤¸à¤¾à¤‡à¤Ÿ à¤ªà¤° à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(575524,15987,'ms','Benarkan Laman Status pesanan di lokasi B2B',0),(575525,15987,'ar','Ø§Ù„Ø³Ù…Ø§Ø­ Ù„Ù„Ù†Ø¸Ø§Ù… ÙˆØ¶Ø¹ ØµÙØ­Ø© Ø¹Ù„Ù‰ Ù…ÙˆÙ‚Ø¹ B2B',0),(575526,15987,'fr','Laisser la Page dâ€™Ã©tat de commande sur le Site B2B',0),(575527,15987,'jp','B2B ã‚µã‚¤ãƒˆã§æ³¨æ–‡ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ ãƒšãƒ¼ã‚¸ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(575528,15987,'pt','Permitir que a pÃ¡gina de Status de ordem no Site B2B',0),(575529,15987,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑ Ð·Ð°ÐºÐ°Ð·Ð° Ð½Ð° ÑÐ°Ð¹Ñ‚Ðµ B2B',0),(575530,15987,'es','Permitir que la pÃ¡gina de estado de pedido en el sitio de B2B',0),(575531,15987,'de','Bestellung Status-Seite auf B2B-Website',0),(575532,15987,'en','Allow Order Status Page On B2B Site',0),(575533,15988,'is','',0),(575534,15988,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÛŒÙ†Ù‡ Ø±Ø§Ø­ØªÛŒ',0),(575535,15988,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÛŒÙ†Ù‡ Ø±Ø§Ø­ØªÛŒ',0),(575536,15988,'tr','KolaylÄ±k Ã¼cret hesabÄ±',0),(575537,15988,'pl','Wygody opÅ‚aty za konto',0),(575538,15988,'bg','Ð£Ð´Ð¾Ð±ÑÑ‚Ð²Ð¾ Ñ‚Ð°ÐºÑÐ° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(575539,15988,'ur','Ø³ÛÙˆÙ„Øª ÙÛŒØ³ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(575540,15988,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð½Ð°ÐºÐ½Ð°Ð´Ðµ Ð¿Ñ€Ð°ÐºÑ‚Ð¸Ñ‡Ð½Ð¾ÑÑ‚',0),(575541,15988,'vi','Tiá»‡n lá»£i phÃ­ tÃ i khoáº£n',0),(575542,15988,'af','Gerief fooi rekening',0),(575543,15988,'ro','Comoditate taxa de cont',0),(575544,15988,'et','Mugavuse tasu konto',0),(575545,15988,'si','Udobje pristojbina raÄun',0),(575546,15988,'ba','Kenyamanan biaya akun',0),(575547,15988,'nl','Gemak vergoeding rekening',0),(575548,15988,'fi','Mukavuus lisÃ¤maksun tili',0),(575549,15988,'no','Bekvemmelighet avgift konto',0),(575550,15988,'da','Bekvemmelighed gebyr konto',0),(575551,15988,'ko','íŽ¸ì˜ ìˆ˜ìˆ˜ë£Œ ê³„ì •',0),(575552,15988,'he','×—×©×‘×•×Ÿ ×ª×©×œ×•× × ×•×—×•×ª',0),(575553,15988,'el','Î•Ï…ÎºÎ¿Î»Î¯Î± Ï‡ÏÎ­Ï‰ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(575554,15988,'zh','æ–¹ä¾¿çš„è´¹ç”¨å¸æˆ·',0),(575555,15988,'sv','BekvÃ¤mlighet Avgiftskontots',0),(575556,15988,'it','Conto di spese di convenienza',0),(575557,15988,'tl','',0),(575558,15988,'th','à¸šà¸±à¸à¸Šà¸µà¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸„à¸§à¸²à¸¡à¸ªà¸°à¸”à¸§à¸à¸ªà¸šà¸²à¸¢',0),(575559,15988,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤¶à¥à¤²à¥à¤• à¤–à¤¾à¤¤à¥‡',0),(575560,15988,'ms','Akaun yuran kemudahan',0),(575561,15988,'ar','Ø­Ø³Ø§Ø¨ Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ù„Ø§Ø¡Ù…Ø©',0),(575562,15988,'fr','Compte de frais de commoditÃ©',0),(575563,15988,'jp','ä¾¿åˆ©ãªæœ‰æ–™ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(575564,15988,'pt','Conta de taxa de conveniÃªncia',0),(575565,15988,'ru','Ð£Ð´Ð¾Ð±ÑÑ‚Ð²Ð¾ Ð·Ð° ÑÑ‡ÐµÑ‚',0),(575566,15988,'es','Cuenta de la cuota de conveniencia',0),(575567,15988,'de','Komfort-GebÃ¼hrenkonto',0),(575568,15988,'en','Convenience Fee Account',0),(575569,15989,'is','',0),(575570,15989,'dr','Ø§ØªÙ‡Ø§Ù… Ø­Ø¯Ø§Ù‚Ù„ Ø¨Ù‡Ø±Ù‡',0),(575571,15989,'pr','Ø§ØªÙ‡Ø§Ù… Ø­Ø¯Ø§Ù‚Ù„ Ø¨Ù‡Ø±Ù‡',0),(575572,15989,'tr','En dÃ¼ÅŸÃ¼k faizi',0),(575573,15989,'pl','Odsetki minimalne',0),(575574,15989,'bg','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð° ÑÑƒÐ¼Ð° Ð½Ð° Ð»Ð¸Ñ…Ð²Ð°',0),(575575,15989,'ur','Ú©Ù… Ø§Ø² Ú©Ù… Ø¯Ù„Ú†Ø³Ù¾ÛŒ Ú†Ø§Ø±Ø¬',0),(575576,15989,'sr','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ Ð·Ð°Ñ‚ÐµÐ·Ð½Ð¸Ñ… ÐºÐ°Ð¼Ð°Ñ‚Ð°',0),(575577,15989,'vi','LÃ£i suáº¥t tá»‘i thiá»ƒu phÃ­',0),(575578,15989,'af','Minimum rente-heffing',0),(575579,15989,'ro','Taxa de minim interes',0),(575580,15989,'et','Minimaalne intress tasu',0),(575581,15989,'si','NajmanjÅ¡i obrestni znesek',0),(575582,15989,'ba','Biaya bunga minimum',0),(575583,15989,'nl','Minimale rentelasten',0),(575584,15989,'fi','VÃ¤himmÃ¤iskorkokulu',0),(575585,15989,'no','Minimum rentebelÃ¸p',0),(575586,15989,'da','Minimum interesse gebyr',0),(575587,15989,'ko','ìµœì†Œ ê´€ì‹¬ ìš”ê¸ˆ',0),(575588,15989,'he','×ª×©×œ×•× ×¨×™×‘×™×ª ×ž×™× ×™×ž×•×',0),(575589,15989,'el','Î•Î»Î¬Ï‡Î¹ÏƒÏ„Î¿ ÎµÎ½Î´Î¹Î±Ï†Î­ÏÎ¿Î½ Ï‡ÏÎ­Ï‰ÏƒÎ·',0),(575590,15989,'zh','æœ€ä½Žåˆ©æ¯è´¹ç”¨',0),(575591,15989,'sv','MinimirÃ¤nta avgift',0),(575592,15989,'it','Carica di interesse minimo',0),(575593,15989,'tl','',0),(575594,15989,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸”à¸­à¸à¹€à¸šà¸µà¹‰à¸¢à¸•à¹ˆà¸³à¸ªà¸¸à¸”',0),(575595,15989,'hi','à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤¬à¥à¤¯à¤¾à¤œ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(575596,15989,'ms','Caj faedah minimum',0),(575597,15989,'ar','ØªÙ‡Ù…Ø© Ù…ØµÙ„Ø­Ø© Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ø¯Ù†Ù‰',0),(575598,15989,'fr','Charge dâ€™intÃ©rÃªt minimal',0),(575599,15989,'jp','æœ€å°åˆ©å­',0),(575600,15989,'pt','Taxa de juros mÃ­nima',0),(575601,15989,'ru','ÐœÐ¸Ð½Ð¸Ð¼Ð°Ð»ÑŒÐ½Ð°Ñ Ð½Ð°Ñ‡Ð¸ÑÐ»ÐµÐ½Ð¸Ðµ',0),(575602,15989,'es','InterÃ©s mÃ­nimo',0),(575603,15989,'de','Minimale Zinsaufschlag',0),(575604,15989,'en','Minimum Interest Charge',0),(575605,15990,'is','',0),(575606,15990,'dr','Ø¬Ù„ÙˆÚ¯ÛŒØ±ÛŒ Ø§Ø² Ù†Ø§Ù… ØªÚ©Ø±Ø§Ø±ÛŒ Ú©Ø´ØªÛŒ',0),(575607,15990,'pr','Ø¬Ù„ÙˆÚ¯ÛŒØ±ÛŒ Ø§Ø² Ù†Ø§Ù… ØªÚ©Ø±Ø§Ø±ÛŒ Ú©Ø´ØªÛŒ',0),(575608,15990,'tr','Yinelenen gemi adlarÄ± Ã¶nlemek',0),(575609,15990,'pl','Zapobiec statek zduplikowane nazwy',0),(575610,15990,'bg','ÐŸÑ€ÐµÐ´Ð¾Ñ‚Ð²Ñ€Ð°Ñ‚ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ñ€Ð°Ð± Ð¸Ð¼ÐµÐ½Ð°',0),(575611,15990,'ur','Ù…Ø«Ù†ÛŒ Ø¬ÛØ§Ø² Ù†Ø§Ù…ÙˆÚº Ú©ÛŒ Ø±ÙˆÚ© ØªÚ¾Ø§Ù…',0),(575612,15990,'sr','Ð¡Ð¿Ñ€ÐµÑ‡Ð°Ð²Ð°ÑšÐµ Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚Ð° Ð±Ñ€Ð¾Ð´ Ð¸Ð¼ÐµÐ½Ð°',0),(575613,15990,'vi','NgÄƒn cháº·n tÃ u trÃ¹ng láº·p tÃªn',0),(575614,15990,'af','Duplikaat skip name voorkom',0),(575615,15990,'ro','Evita duplicat nava nume',0),(575616,15990,'et','VÃ¤ltida nimede Duplicate laeva',0),(575617,15990,'si','PrepreÄevanje podvojenih ladje imena',0),(575618,15990,'ba','Mencegah nama duplikat kapal',0),(575619,15990,'nl','Voorkomen dat de namen van de dubbele schip',0),(575620,15990,'fi','EstÃ¤Ã¤ kaksoiskappaleiden alusten nimet',0),(575621,15990,'no','UnngÃ¥ dupliserte bÃ¥tens navn',0),(575622,15990,'da','UndgÃ¥ dublerede skib navne',0),(575623,15990,'ko','ì¤‘ë³µ ë°° ì´ë¦„ ë°©ì§€',0),(575624,15990,'he','×œ×ž× ×•×¢ ×©×ž×•×ª ×›×¤×•×œ×™× ×”×¡×¤×™× ×”',0),(575625,15990,'el','Î ÏÏŒÎ»Î·ÏˆÎ· Ï€Î»Î¿Î¯Î¿ Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€Î± Î¿Î½ÏŒÎ¼Î±Ï„Î±',0),(575626,15990,'zh','é˜²æ­¢é‡å¤èˆ¹èˆ¶åç§°',0),(575627,15990,'sv','FÃ¶rhindra dubbletter fartyget namn',0),(575628,15990,'it','Evitare nomi duplicati nave',0),(575629,15990,'tl','',0),(575630,15990,'th','à¸›à¹‰à¸­à¸‡à¸à¸±à¸™à¸Šà¸·à¹ˆà¸­à¸‹à¹‰à¸³à¸à¸±à¸™à¹€à¸£à¸·à¸­',0),(575631,15990,'hi','à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤œà¤¹à¤¾à¤œ à¤¨à¤¾à¤®à¥‹à¤‚ à¤•à¥‹ à¤°à¥‹à¤•à¤¨à¥‡',0),(575632,15990,'ms','Mengelakkan nama pendua kapal',0),(575633,15990,'ar','Ù…Ù†Ø¹ Ø£Ø³Ù…Ø§Ø¡ Ù…ÙƒØ±Ø±Ø© Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(575634,15990,'fr','Ã‰viter les noms de navire en double',0),(575635,15990,'jp','é‡è¤‡ã™ã‚‹èˆ¹ã®åå‰ã‚’é˜²ã',0),(575636,15990,'pt','Evitar nomes duplicados de navio',0),(575637,15990,'ru','ÐŸÑ€ÐµÐ´Ð¾Ñ‚Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¸Ð¼ÐµÐ½Ð°',0),(575638,15990,'es','Evitar nombres duplicados de la nave',0),(575639,15990,'de','Verhindern, dass doppelte Schiffsnamen',0),(575640,15990,'en','Prevent Duplicate Ship Names',0),(575641,15991,'is','',0),(575642,15991,'dr','Ø±Ø¯Ù‡ GL',0),(575643,15991,'pr','Ø±Ø¯Ù‡ GL',0),(575644,15991,'tr','GL Kategori',0),(575645,15991,'pl','Kategorii GL',0),(575646,15991,'bg','GL ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(575647,15991,'ur','Ø¬ÛŒØ¬Û’ Ø²Ù…Ø±Û',0),(575648,15991,'sr','Ð“Ð› ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(575649,15991,'vi','Thá»ƒ loáº¡i GL',0),(575650,15991,'af','GL kategorie',0),(575651,15991,'ro','Categoria GL',0),(575652,15991,'et','GL kategooria',0),(575653,15991,'si','GL Category',0),(575654,15991,'ba','GL Kategori',0),(575655,15991,'nl','GL categorie',0),(575656,15991,'fi','GL-luokka',0),(575657,15991,'no','GL kategori',0),(575658,15991,'da','GL kategori',0),(575659,15991,'ko','GL ì¹´í…Œê³ ë¦¬',0),(575660,15991,'he','×§×˜×’×•×¨×™×” GL',0),(575661,15991,'el','ÎšÎ±Ï„Î·Î³Î¿ÏÎ¯Î± GL',0),(575662,15991,'zh','GL ç±»åˆ«',0),(575663,15991,'sv','GL kategori',0),(575664,15991,'it','Categoria GL',0),(575665,15991,'tl','',0),(575666,15991,'th','à¸›à¸£à¸°à¹€à¸ à¸— GL',0),(575667,15991,'hi','GL à¤¶à¥à¤°à¥‡à¤£à¥€',0),(575668,15991,'ms','Kategori GL',0),(575669,15991,'ar','Ø§Ù„ÙØ¦Ø© Ø¬ÙŠ Ø§Ù„',0),(575670,15991,'fr','CatÃ©gorie GL',0),(575671,15991,'jp','GL ã‚«ãƒ†ã‚´ãƒª',0),(575672,15991,'pt','Categoria GL',0),(575673,15991,'ru','GL ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(575674,15991,'es','CategorÃ­a GL',0),(575675,15991,'de','GL-Kategorie',0),(575676,15991,'en','GL Category',0),(575677,15992,'is','',0),(575678,15992,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ú©Ø§Ø±Øª',0),(575679,15992,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ú©Ø§Ø±Øª',0),(575680,15992,'tr','KartÄ± kurulumunu denetle',0),(575681,15992,'pl','SprawdÅº ustawienia karty',0),(575682,15992,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°Ñ‚Ð° Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°Ñ‚Ð°',0),(575683,15992,'ur','Ú©Ø§Ø±Úˆ Ø³ÛŒÙ¹ Ø§Ù¾ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(575684,15992,'sr','ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(575685,15992,'vi','Kiá»ƒm tra thiáº¿t láº­p Card',0),(575686,15992,'af','Kaart opstelling kontroleer',0),(575687,15992,'ro','Verificare Card Setup',0),(575688,15992,'et','Kontrollige seadistus',0),(575689,15992,'si','Preverite nastavitev kartice',0),(575690,15992,'ba','Periksa kartu Setup',0),(575691,15992,'nl','Kaart-instellingen controleren',0),(575692,15992,'fi','Tarkista asetukset',0),(575693,15992,'no','Sjekk kort oppsett',0),(575694,15992,'da','Check kortopsÃ¦tning',0),(575695,15992,'ko','ì¹´ë“œ ì„¤ì¹˜ í™•ì¸',0),(575696,15992,'he','×”×’×“×¨×ª ×›×¨×˜×™×¡ ×”×¡×™×ž×•×Ÿ',0),(575697,15992,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î· ÏÏÎ¸Î¼Î¹ÏƒÎ· ÎºÎ¬ÏÏ„Î±',0),(575698,15992,'zh','æ£€æŸ¥å¡è®¾ç½®',0),(575699,15992,'sv','Kolla kort Setup',0),(575700,15992,'it','Installazione della scheda di controllo',0),(575701,15992,'tl','',0),(575702,15992,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸±à¸•à¸£',0),(575703,15992,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(575704,15992,'ms','Persediaan Kad Daftar',0),(575705,15992,'ar','ØªØ­Ù‚Ù‚ Ù…Ù† Ø¥Ø¹Ø¯Ø§Ø¯ Ø¨Ø·Ø§Ù‚Ø©',0),(575706,15992,'fr','VÃ©rifiez la configuration carte',0),(575707,15992,'jp','ãƒã‚§ãƒƒã‚¯ ã‚«ãƒ¼ãƒ‰ã®ã‚»ãƒƒãƒˆã‚¢ãƒƒãƒ—',0),(575708,15992,'pt','Verificar a instalaÃ§Ã£o da placa',0),(575709,15992,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(575710,15992,'es','Compruebe la instalaciÃ³n de la tarjeta',0),(575711,15992,'de','ÃœberprÃ¼fen Sie Karteneinstellung',0),(575712,15992,'en','Check Card Setup',0),(575713,15993,'is','',0),(575714,15993,'dr','GL CC Ù…Ø³Ø¦ÙˆÙ„ÛŒØª Ø­Ø³Ø§Ø¨ Ú¯Ù… Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø®Ø·',0),(575715,15993,'pr','GL CC Ù…Ø³Ø¦ÙˆÙ„ÛŒØª Ø­Ø³Ø§Ø¨ Ú¯Ù… Ø´Ø¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø®Ø·',0),(575716,15993,'tr','GL CC sorumluluk hesap satÄ±rÄ± iÃ§in eksik',0),(575717,15993,'pl','Koncie pasywÃ³w CC GL brakuje dla linii',0),(575718,15993,'bg','GL CC Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€Ð½Ð¾ÑÑ‚ ÑÐ¼ÐµÑ‚ÐºÐ° Ð»Ð¸Ð¿ÑÐ²Ð° Ð·Ð° Ð»Ð¸Ð½Ð¸Ñ',0),(575719,15993,'ur','Ø¬ÛŒØ¬Û’ CC Ø°Ù…Û Ø¯Ø§Ø±ÛŒ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù„Ø¦Û’ Ù„Ø§Ø¦Ù† ØºØ§Ø¦Ø¨',0),(575720,15993,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ð¿Ð°ÑÐ¸Ð²Ðµ Ð¦Ð¦ Ð“Ð› Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ñƒ Ð·Ð° Ñ€ÐµÐ´',0),(575721,15993,'vi','GL CC trÃ¡ch nhiá»‡m tÃ i khoáº£n máº¥t tÃ­ch Ä‘á»‘i vá»›i dÃ²ng',0),(575722,15993,'af','GL CC aanspreeklikheid rekening ontbreek vir lyn',0),(575723,15993,'ro','GL CC rÄƒspunderea cont lipsÄƒ pentru linie',0),(575724,15993,'et','GL CC kohustuste konto rea kadunud',0),(575725,15993,'si','GL CC konta obveznosti manjka za vrstico',0),(575726,15993,'ba','GL CC kewajiban Account hilang untuk baris',0),(575727,15993,'nl','GL CC aansprakelijkheid Account ontbreekt voor lijn',0),(575728,15993,'fi','GL CC velkatili puuttuu rivin',0),(575729,15993,'no','GL CC gjeldskonto mangler For linje',0),(575730,15993,'da','GL CC passivkonto mangler For linje',0),(575731,15993,'ko','GL CC ì±…ìž„ ê³„ì • ë¼ì¸ ì‹¤ì¢…',0),(575732,15993,'he','GL CC ××—×¨×™×•×ª ×—×©×‘×•×Ÿ ×—×¡×¨×™× ×¢×‘×•×¨ ×§×•',0),(575733,15993,'el','GL CC Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎµÏ…Î¸ÏÎ½Î· Î³Î¹Î± Ï„Î· Î³ÏÎ±Î¼Î¼Î® Ï€Î¿Ï… Î»ÎµÎ¯Ï€Î¿Ï…Î½',0),(575734,15993,'zh','å¯¹çº¿çš„æ€å¿µçš„ GL CC è´Ÿå€ºç§‘ç›®',0),(575735,15993,'sv','GL CC skuldkonto saknas fÃ¶r linje',0),(575736,15993,'it','Conto di passivitÃ  CC GL mancante per la riga',0),(575737,15993,'tl','',0),(575738,15993,'th','à¸šà¸±à¸à¸Šà¸µà¸«à¸™à¸µà¹‰à¸ªà¸´à¸™ CC GL à¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸£à¸£à¸—à¸±à¸”à¸—à¸µà¹ˆà¸‚à¸²à¸”à¸«à¸²à¸¢à¹„à¸›',0),(575739,15993,'hi','GL CC à¤¦à¤¾à¤¯à¤¿à¤¤à¥à¤µ à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¥‡à¤–à¤¾ à¤²à¤¾à¤ªà¤¤à¤¾',0),(575740,15993,'ms','Akaun liabiliti CC GL hilang untuk talian',0),(575741,15993,'ar','GL Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…Ø³Ø¤ÙˆÙ„ÙŠØ© CC Ù…ÙÙ‚ÙˆØ¯ Ù„Ù„Ø®Ø·',0),(575742,15993,'fr','Compte de passif CC GL manquantes pour la ligne',0),(575743,15993,'jp','GL CC è² å‚µå‹˜å®šè¡Œã®è¡Œæ–¹ä¸æ˜Ž',0),(575744,15993,'pt','GL CC responsabilidade conta faltando para linha',0),(575745,15993,'ru','GL CC Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÐµÐ½Ð½Ð¾ÑÑ‚Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð½Ð° Ð»Ð¸Ð½Ð¸Ð¸',0),(575746,15993,'es','GL CC responsabilidad cuenta que faltan para la lÃ­nea de',0),(575747,15993,'de','GL CC Passivkonto fÃ¼r Zeile fehlt',0),(575748,15993,'en','GL CC Liability Account Missing For Line',0),(575749,15994,'is','',0),(575750,15994,'dr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÛŒÙ†Ù‡ GL Ø¨Ø±Ø§ÛŒ Ø®Ø· Ú¯Ù… Ø´Ø¯Ù‡',0),(575751,15994,'pr','Ø­Ø³Ø§Ø¨ Ù‡Ø²ÛŒÙ†Ù‡ GL Ø¨Ø±Ø§ÛŒ Ø®Ø· Ú¯Ù… Ø´Ø¯Ù‡',0),(575752,15994,'tr','GL gider hesabÄ± iÃ§in satÄ±r eksik',0),(575753,15994,'pl','Konto kosztÃ³w GL brakuje dla linii',0),(575754,15994,'bg','GL Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð»Ð¸Ð¿ÑÐ²Ð° Ð·Ð° Ð»Ð¸Ð½Ð¸Ñ',0),(575755,15994,'ur','Ø¬ÛŒØ¬Û’ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù„Ø¦Û’ Ù„Ø§Ø¦Ù† ØºØ§Ø¦Ø¨',0),(575756,15994,'sr','ÐšÐ¾Ð½Ñ‚Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð“Ð› Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ñƒ Ð·Ð° Ñ€ÐµÐ´',0),(575757,15994,'vi','GL tÃ i khoáº£n chi phÃ­ thiáº¿u Ä‘á»‘i vá»›i dÃ²ng',0),(575758,15994,'af','GL uitgawe rekening ontbreek vir lyn',0),(575759,15994,'ro','Cont cheltuialÄƒ GL lipsÄƒ pentru linie',0),(575760,15994,'et','Puuduva rea GL Kulukonto',0),(575761,15994,'si','Konto stroÅ¡kov GL, manjka za vrstico',0),(575762,15994,'ba','Rekening pengeluaran GL hilang untuk baris',0),(575763,15994,'nl','GL kostenrekening ontbreekt voor lijn',0),(575764,15994,'fi','GL tili puuttuu rivin',0),(575765,15994,'no','GL kostnadskonto mangler For linje',0),(575766,15994,'da','GL udgiftskonto mangler For linje',0),(575767,15994,'ko','GL ë¹„ìš© ê³„ì • ë¼ì¸ ì‹¤ì¢…',0),(575768,15994,'he','×—×©×‘×•×Ÿ ×”×”×•×¦××•×ª GL ×—×¡×¨×™× ×¢×‘×•×¨ ×§×•',0),(575769,15994,'el','GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎµÎ¾ÏŒÎ´Ï‰Î½ Ï€Î¿Ï… Î»ÎµÎ¯Ï€Î¿Ï…Î½ Î³Î¹Î± Î³ÏÎ±Î¼Î¼Î®',0),(575770,15994,'zh','å¯¹çº¿çš„æ€å¿µçš„ GL æ”¯å‡ºå¸æˆ·',0),(575771,15994,'sv','GL utgiftskonto saknas fÃ¶r linje',0),(575772,15994,'it','Conto di spese GL mancante per la riga',0),(575773,15994,'tl','',0),(575774,15994,'th','à¸šà¸±à¸à¸Šà¸µà¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸ªà¸³à¸«à¸£à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¸‚à¸²à¸”à¸«à¸²à¸¢à¹„à¸›',0),(575775,15994,'hi','GL à¤µà¥à¤¯à¤¯ à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤°à¥‡à¤–à¤¾ à¤²à¤¾à¤ªà¤¤à¤¾',0),(575776,15994,'ms','GL akaun perbelanjaan yang hilang untuk talian',0),(575777,15994,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ GL Ù…ÙÙ‚ÙˆØ¯ Ù„Ù„Ø®Ø·',0),(575778,15994,'fr','Compte de dÃ©penses GL manquantes pour la ligne',0),(575779,15994,'jp','GL çµŒè²»å‹˜å®šè¡Œã®è¡Œæ–¹ä¸æ˜Ž',0),(575780,15994,'pt','Conta de despesas GL falta por linha',0),(575781,15994,'ru','GL ÑÑ‡ÐµÑ‚ Ð¾Ñ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð»Ð¸Ð½Ð¸Ð¸',0),(575782,15994,'es','Cuenta de contabilidad gastos faltantes para la lÃ­nea de',0),(575783,15994,'de','GL Aufwandskonto fÃ¼r Zeile fehlt',0),(575784,15994,'en','GL Expense Account Missing For Line',0),(575785,15995,'is','',0),(575786,15995,'dr','Ù„Ø·ÙØ§ ÙˆØ§Ø±Ø¯ Ø­Ø³Ø§Ø¨ Ùˆ ÛŒØ§ Ø´Ø§Ø±Ú˜ Ù†ÙˆØ¹ Ø®Ø·',0),(575787,15995,'pr','Ù„Ø·ÙØ§ ÙˆØ§Ø±Ø¯ Ø­Ø³Ø§Ø¨ Ùˆ ÛŒØ§ Ø´Ø§Ø±Ú˜ Ù†ÙˆØ¹ Ø®Ø·',0),(575788,15995,'tr','LÃ¼tfen bir hesap girin veya satÄ±r iÃ§in Ã¼cret tÃ¼rÃ¼',0),(575789,15995,'pl','Podaj konto lub Å‚adowania typu linii',0),(575790,15995,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð°ÐºÐ°ÑƒÐ½Ñ‚ Ð¸Ð»Ð¸ Ñ‚Ð°ÐºÑÐ° Ñ‚Ð¸Ð¿ Ð·Ð° Ñ€ÐµÐ´',0),(575791,15995,'ur','Ø§ÛŒÚ© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº ÛŒØ§ Ú†Ø§Ø±Ø¬ Ù‚Ø³Ù… Ú©Û’ Ù„Ø¦Û’ Ù„Ø§Ø¦Ù†',0),(575792,15995,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ñ€Ð°Ñ‡ÑƒÐ½ Ð¸Ð»Ð¸ Ð½Ð°Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚Ð¸ Ñ‚Ð¸Ð¿ Ð»Ð¸Ð½Ð¸Ñ˜Ðµ',0),(575793,15995,'vi','HÃ£y nháº­p vÃ o má»™t tÃ i khoáº£n hoáº·c tÃ­nh phÃ­ loáº¡i cho dÃ²ng',0),(575794,15995,'af','Tik asseblief \'n rekening of tipe hef vir lyn',0),(575795,15995,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un cont sau taxa de tip linie',0),(575796,15995,'et','Sisestage konto vÃµi tasu tÃ¼Ã¼p rea',0),(575797,15995,'si','Vnesite raÄun ali vrste za vrstico',0),(575798,15995,'ba','Masukkan Account atau biaya jenis untuk baris',0),(575799,15995,'nl','Voer een Account of Type kosten voor lijn',0),(575800,15995,'fi','Kirjoita tilin tai periÃ¤ tyypin riville',0),(575801,15995,'no','Angi en konto eller lade Type For linje',0),(575802,15995,'da','Angiv en konto eller debitere Type For linje',0),(575803,15995,'ko','ê³„ì •ì„ ìž…ë ¥ ë˜ëŠ” ì„  ì¢…ë¥˜ë¥¼ ë‹´ë‹¹',0),(575804,15995,'he','×× × ×”×–×Ÿ ×—×©×‘×•×Ÿ ××• ×œ×—×™×™×‘ ×¡×•×’ ×¢×œ ×”×§×•',0),(575805,15995,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î® Ï„ÏÏ€Î¿Ï‚ Ï‡ÏÎ­Ï‰ÏƒÎ·Ï‚ Î³Î¹Î± Ï„Î· Î³ÏÎ±Î¼Î¼Î®',0),(575806,15995,'zh','è¯·è¾“å…¥ä¸€ä¸ªå¸æˆ·æˆ–æ”¶çº¿ç±»åž‹',0),(575807,15995,'sv','Ange ett konto eller ladda typ fÃ¶r linje',0),(575808,15995,'it','Si prega di inserire un Account o tipo di carica per linea',0),(575809,15995,'tl','',0),(575810,15995,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸šà¸±à¸à¸Šà¸µ à¸«à¸£à¸·à¸­à¸Šà¸²à¸£à¹Œà¸ˆà¸Šà¸™à¸´à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¸šà¸£à¸£à¸—à¸±à¸”',0),(575811,15995,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤–à¤¾à¤¤à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚ à¤¯à¤¾ à¤šà¤¾à¤°à¥à¤œ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤‡à¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(575812,15995,'ms','Sila masukkan akaun atau mengenakan jenis garisan',0),(575813,15995,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø­Ø³Ø§Ø¨ Ø£Ùˆ Ù…Ù‚Ø§Ø¨Ù„ Ù†ÙˆØ¹ Ø§Ù„Ø®Ø·',0),(575814,15995,'fr','Veuillez entrer un compte ou de charger le Type de ligne',0),(575815,15995,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã¾ãŸã¯è¡Œã®åž‹ã‚’å……é›»',0),(575816,15995,'pt','Por favor, digite uma conta ou cobrar tipo linha',0),(575817,15995,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¸Ð»Ð¸ Ð±ÐµÑÐ¿Ð»Ð°Ñ‚Ð½Ð¾ Ñ‚Ð¸Ð¿ Ð»Ð¸Ð½Ð¸Ð¸',0),(575818,15995,'es','Por favor ingresar una cuenta o tipo de lÃ­nea',0),(575819,15995,'de','Bitte geben Sie ein Konto oder Linie Art kostenlos',0),(575820,15995,'en','Please Enter An Account Or Charge Type For Line',0),(575821,15996,'is','',0),(575822,15996,'dr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù†Ù…Ø§Ø¨Ø±',0),(575823,15996,'pr','ÙØ±Ø³ØªØ§Ø¯Ù† Ù†Ù…Ø§Ø¨Ø±',0),(575824,15996,'tr','Faks gÃ¶nderme',0),(575825,15996,'pl','WysÅ‚aÄ‡ faks',0),(575826,15996,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð¤Ð°ÐºÑ',0),(575827,15996,'ur','ÙÛŒÚ©Ø³ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(575828,15996,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ñ„Ð°ÐºÑ',0),(575829,15996,'vi','Gá»­i Fax',0),(575830,15996,'af','Stuur Faks',0),(575831,15996,'ro','Trimite Fax',0),(575832,15996,'et','Saada Faks',0),(575833,15996,'si','PoÅ¡lji faks',0),(575834,15996,'ba','Kirim Fax',0),(575835,15996,'nl','Fax verzenden',0),(575836,15996,'fi','Faksin lÃ¤hettÃ¤minen',0),(575837,15996,'no','Sende telefaks',0),(575838,15996,'da','Send Fax',0),(575839,15996,'ko','íŒ©ìŠ¤ ë³´ë‚´ê¸°',0),(575840,15996,'he','×œ×©×œ×•×— ×¤×§×¡',0),(575841,15996,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Ï†Î±Î¾',0),(575842,15996,'zh','å‘é€ä¼ çœŸ',0),(575843,15996,'sv','Skicka Fax',0),(575844,15996,'it','Inviare Fax',0),(575845,15996,'tl','',0),(575846,15996,'th','à¸ªà¹ˆà¸‡à¹‚à¸—à¸£à¸ªà¸²à¸£',0),(575847,15996,'hi','à¤«à¤¼à¥ˆà¤•à¥à¤¸ à¤­à¥‡à¤œà¥‡à¤‚',0),(575848,15996,'ms','Menghantar Perkhidmatan Faks',0),(575849,15996,'ar','Ø¥Ø±Ø³Ø§Ù„ ÙØ§ÙƒØ³',0),(575850,15996,'fr','Envoyer des Fax',0),(575851,15996,'jp','Fax ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(575852,15996,'pt','Enviar Fax',0),(575853,15996,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¤Ð°ÐºÑ',0),(575854,15996,'es','Enviar Fax',0),(575855,15996,'de','Fax senden',0),(575856,15996,'en','Send Fax',0),(575857,15997,'is','',0),(575858,15997,'dr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÛŒØ¯ Ú©Ù‡ Ù…ÛŒØ®ÙˆØ§Ù‡ÛŒØ¯ ØªÙ…Ø§Ù… Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯ØŸ',0),(575859,15997,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÛŒØ¯ Ú©Ù‡ Ù…ÛŒØ®ÙˆØ§Ù‡ÛŒØ¯ ØªÙ…Ø§Ù… Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯ØŸ',0),(575860,15997,'tr','TÃ¼m varolan hesaplarÄ± silmek istediÄŸinizden emin misiniz',0),(575861,15997,'pl','Czy na pewno chcesz usunÄ…Ä‡ wszystkie istniejÄ…ce konta',0),(575862,15997,'bg','ÐÐ°Ð¸ÑÑ‚Ð¸Ð½Ð° Ð»Ð¸ Ð¸ÑÐºÐ°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ñ‚Ñ€Ð¸ÐµÑ‚Ðµ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ Ð°ÐºÐ°ÑƒÐ½Ñ‚Ð¸',0),(575863,15997,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ØªÙ…Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚº',0),(575864,15997,'sr','Ð”Ð° Ð»Ð¸ ÑÑ‚Ðµ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ñ‚Ð¸ ÑÐ²Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(575865,15997,'vi','Báº¡n cÃ³ cháº¯c báº¡n muá»‘n xÃ³a bá» táº¥t cáº£ cÃ¡c tÃ i khoáº£n hiá»‡n táº¡i',0),(575866,15997,'af','Is jy seker jy wil alle bestaande rekeninge',0),(575867,15997,'ro','Sigur È™tergeÈ›i toate conturile existente',0),(575868,15997,'et','Kas soovite kindlasti kustutada kÃµik olemasolevad kontod',0),(575869,15997,'si','Ali ste prepriÄani, da Å¾elite izbrisati vse obstojeÄe raÄune',0),(575870,15997,'ba','Apakah Anda yakin Anda ingin menghapus semua account yang ada',0),(575871,15997,'nl','Weet u zeker dat u wilt verwijderen van alle bestaande Accounts',0),(575872,15997,'fi','Oletko varma, ettÃ¤ haluat poistaa kaikki olemassa olevia tilejÃ¤',0),(575873,15997,'no','Er du sikker pÃ¥ at du vil slette alle eksisterende kontoer',0),(575874,15997,'da','Er du sikker pÃ¥ du vil slette alle eksisterende konti',0),(575875,15997,'ko','ë‹¹ì‹ ì€ ëª¨ë“  ê¸°ì¡´ ê³„ì •ì„ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ',0),(575876,15997,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ××ª ×›×œ ×—×©×‘×•× ×•×ª ×§×™×™×ž×™×',0),(575877,15997,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ ÏŒÎ»Î¿Ï…Ï‚ Ï„Î¿Ï…Ï‚ Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„ÎµÏ‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚',0),(575878,15997,'zh','ä½ ç¡®å®šä½ æƒ³è¦åˆ é™¤æ‰€æœ‰çš„çŽ°æœ‰å¸æˆ·ï¼Ÿ',0),(575879,15997,'sv','Ã„r du sÃ¤ker du vill ta bort alla befintliga konton',0),(575880,15997,'it','Sei sicuro di che voler eliminare tutti gli account esistenti',0),(575881,15997,'tl','',0),(575882,15997,'th','à¸„à¸¸à¸“à¹à¸™à¹ˆà¹ƒà¸ˆà¸§à¹ˆà¸²à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸¥à¸šà¸šà¸±à¸à¸Šà¸µà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(575883,15997,'hi','à¤†à¤ª à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤•à¤¿ à¤†à¤ª à¤¸à¤­à¥€ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤–à¤¾à¤¤à¥‡ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(575884,15997,'ms','Adakah anda pasti anda mahu menghapus semua akaun yang sedia ada',0),(575885,15997,'ar','Ù‡Ù„ Ø£Ù†Øª Ù…ØªØ£ÙƒØ¯ Ù…Ù† Ø£Ù†Ùƒ ØªØ±ÙŠØ¯ Ø­Ø°Ù ÙƒØ§ÙØ© Ø§Ù„Ø­Ø³Ø§Ø¨Ø§Øª Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(575886,15997,'fr','ÃŠtes-vous sÃ»r de que vouloir supprimer tous les comptes existants',0),(575887,15997,'jp','æ—¢å­˜ã®ã™ã¹ã¦ã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å‰Šé™¤ã—ã¾ã™',0),(575888,15997,'pt','Tem certeza que quer apagar todas as contas existentes',0),(575889,15997,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð²ÑÐµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ ÑƒÑ‡ÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(575890,15997,'es','EstÃ¡ seguro que desea eliminar todas las cuentas existentes',0),(575891,15997,'de','Sind Sie sicher, dass Sie alle vorhandenen Konten lÃ¶schen mÃ¶chten',0),(575892,15997,'en','Are You Sure You Want To Delete All Existing Accounts',0),(575893,15998,'is','',0),(575894,15998,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(575895,15998,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø°Ø®ÛŒØ±Ù‡',0),(575896,15998,'tr','BÃ¼tÃ§e baÅŸarÄ±yla kaydedildi',0),(575897,15998,'pl','BudÅ¼etu Zapisano pomyÅ›lnie',0),(575898,15998,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚, Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(575899,15998,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ Ù…Ø­ÙÙˆØ¸ ÛÙˆØ§ Ø¨Ø¬Ù¹',0),(575900,15998,'sr','Ð‘ÑƒÑŸÐµÑ‚ Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½',0),(575901,15998,'vi','NgÃ¢n sÃ¡ch lÆ°u thÃ nh cÃ´ng',0),(575902,15998,'af','Begroting suksesvol gestoor',0),(575903,15998,'ro','Buget salvat cu succes',0),(575904,15998,'et','Eelarve on edukalt salvestatud',0),(575905,15998,'si','ProraÄun shranjen',0),(575906,15998,'ba','Anggaran yang berhasil diselamatkan',0),(575907,15998,'nl','Begroting succesvol opgeslagen',0),(575908,15998,'fi','Talousarvion tallennettu',0),(575909,15998,'no','Budsjett lagret',0),(575910,15998,'da','Budget gemt med succes',0),(575911,15998,'ko','ì„±ê³µì ìœ¼ë¡œ ì €ìž¥ í•˜ëŠ” ì˜ˆì‚°',0),(575912,15998,'he','×”×ª×§×¦×™×‘ × ×©×ž×¨ ×‘×”×¦×œ×—×”',0),(575913,15998,'el','Î ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Ï€Î¿Ï… Î±Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(575914,15998,'zh','é¢„ç®—å·²æˆåŠŸä¿å­˜',0),(575915,15998,'sv','Budget som sparats',0),(575916,15998,'it','Bilancio salvato correttamente',0),(575917,15998,'tl','',0),(575918,15998,'th','à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸—à¸µà¹ˆà¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢',0),(575919,15998,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤¬à¤œà¤Ÿ',0),(575920,15998,'ms','Bajet yang berjaya disimpan',0),(575921,15998,'ar','Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø­ÙØ¸ Ø¨Ù†Ø¬Ø§Ø­',0),(575922,15998,'fr','Budget correctement enregistrÃ©',0),(575923,15998,'jp','æ­£å¸¸ã«ä¿å­˜ã•ã‚ŒãŸäºˆç®—',0),(575924,15998,'pt','OrÃ§amento com sucesso',0),(575925,15998,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚, ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹',0),(575926,15998,'es','Presupuesto guardado correctamente',0),(575927,15998,'de','Budget erfolgreich gespeichert',0),(575928,15998,'en','Budget Saved Successfully',0),(575929,15999,'is','',0),(575930,15999,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÛŒØ±Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ø¨ÙˆØ¯Ø¬Ù‡',0),(575931,15999,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÛŒØ±Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ø¨ÙˆØ¯Ø¬Ù‡',0),(575932,15999,'tr','BÃ¼tÃ§e verileri kaydedilirken hata oluÅŸtu',0),(575933,15999,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania danych budÅ¼etu',0),(575934,15999,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´Ð°Ð½Ð½Ð¸ Ð·Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(575935,15999,'ur','Ø¨Ø¬Ù¹ Ú©ÙˆØ§Ø¦Ù Ù…Ø­ÙÙˆØ¸ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’ Ù†Ù‚Øµ',0),(575936,15999,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ¿Ñ€ÐµÐ¼Ð°ÑšÐ° Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð±ÑƒÑŸÐµÑ‚Ñƒ',0),(575937,15999,'vi','Lá»—i khi lÆ°u dá»¯ liá»‡u ngÃ¢n sÃ¡ch',0),(575938,15999,'af','Fout met die stoor van Data begroting',0),(575939,15999,'ro','Eroare la salvarea datelor de buget',0),(575940,15999,'et','Eelarve andmete salvestamise tÃµrge',0),(575941,15999,'si','Napaka pri shranjevanju podatkov proraÄuna',0),(575942,15999,'ba','Kesalahan menyimpan Data anggaran',0),(575943,15999,'nl','Fout bij het opslaan van begrotingsgegevens',0),(575944,15999,'fi','Virhe tallennettaessa budjettitiedot',0),(575945,15999,'no','Feil under lagring av budsjettdata',0),(575946,15999,'da','Fejl under lagring af budgetdata',0),(575947,15999,'ko','ì˜ˆì‚° ë°ì´í„° ì €ìž¥ ì˜¤ë¥˜',0),(575948,15999,'he','×©×’×™××” ×‘×¢×ª ×©×ž×™×¨×ª × ×ª×•× ×™ ×ª×§×¦×™×‘',0),(575949,15999,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½ Ï„Î¿Ï… Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(575950,15999,'zh','ä¿å­˜çš„é¢„ç®—æ•°æ®æ—¶å‡ºé”™',0),(575951,15999,'sv','Fel vid sparande av budgetdata',0),(575952,15999,'it','Errore durante il salvataggio dei dati di bilancio',0),(575953,15999,'tl','',0),(575954,15999,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“',0),(575955,15999,'hi','à¤¬à¤œà¤Ÿ à¤¡à¥‡à¤Ÿà¤¾ à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(575956,15999,'ms','Ralat Menyimpan Data bajet',0),(575957,15999,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸ Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(575958,15999,'fr','Erreur dâ€™enregistrement des donnÃ©es budgÃ©taires',0),(575959,15999,'jp','äºˆç®—ãƒ‡ãƒ¼ã‚¿ã‚’ä¿å­˜ä¸­ã«ã‚¨ãƒ©ãƒ¼',0),(575960,15999,'pt','Erro ao salvar dados do orÃ§amento',0),(575961,15999,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(575962,15999,'es','Error al guardar datos de presupuesto',0),(575963,15999,'de','Fehler beim Speichern des Budgetdaten',0),(575964,15999,'en','Error Saving Budget Data',0),(575965,16000,'is','',0),(575966,16000,'dr','ØªÙ…Ø§Ù… Ù…Ø§Ù‡ Ø±Ø§ Ù‡Ù…Ø§Ù†',0),(575967,16000,'pr','ØªÙ…Ø§Ù… Ù…Ø§Ù‡ Ø±Ø§ Ù‡Ù…Ø§Ù†',0),(575968,16000,'tr','BÃ¼tÃ¼n ay aynÄ±',0),(575969,16000,'pl','Upewnij wszystkich miesiÄ™cy sam',0),(575970,16000,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¼ÐµÑÐµÑ†Ð° ÑÑŠÑ‰Ð°Ñ‚Ð°',0),(575971,16000,'ur','ØªÙ…Ø§Ù… Ù…ÛÛŒÙ†ÙˆÚº Ú©Ùˆ Ø§Ø³ÛŒ',0),(575972,16000,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ ÑÐ²Ðµ Ð¼ÐµÑÐµÑ†Ðµ Ð¸ÑÑ‚Ð¸',0),(575973,16000,'vi','LÃ m cho táº¥t cáº£ cÃ¡c thÃ¡ng cÃ¹ng má»™t',0),(575974,16000,'af','Maak alle maande dieselfde',0),(575975,16000,'ro','Face toate lunile acelaÅŸi',0),(575976,16000,'et','KÃµik kuud teha sama',0),(575977,16000,'si','Da vse mesece isto',0),(575978,16000,'ba','Membuat semua bulan sama',0),(575979,16000,'nl','Maken al maanden dezelfde',0),(575980,16000,'fi','Tee kaikki kuukaudet saman',0),(575981,16000,'no','GjÃ¸re alle mÃ¥neder samme',0),(575982,16000,'da','GÃ¸re alle mÃ¥neder samme',0),(575983,16000,'ko','ëª¨ë“  ë‹¬ ê²Œ ê°™ì€',0),(575984,16000,'he','×œ×”×¤×•×š ××ª ×›×œ ×”×—×•×“×©×™× ××•×ª×•',0),(575985,16000,'el','ÎšÎ¬Î½Î¿Ï…Î½ ÏŒÎ»Î¿Î¹ Î¿Î¹ Î¼Î®Î½ÎµÏ‚ Î¯Î´Î¹Î±',0),(575986,16000,'zh','ä½¿æ‰€æœ‰æœˆä»½ç›¸åŒ',0),(575987,16000,'sv','GÃ¶ra alla mÃ¥nader samma',0),(575988,16000,'it','Rendere tutti i mesi stesso',0),(575989,16000,'tl','',0),(575990,16000,'th','à¸—à¸³à¹ƒà¸«à¹‰à¸—à¸¸à¸à¹€à¸”à¸·à¸­à¸™à¹€à¸«à¸¡à¸·à¸­à¸™à¸à¸±à¸™',0),(575991,16000,'hi','à¤¬à¤¨à¤¾à¤¨à¥‡ à¤•à¥‡ à¤¸à¤­à¥€ à¤®à¤¹à¥€à¤¨à¥‡ à¤à¤• à¤¹à¥€',0),(575992,16000,'ms','Membuat semua bulan sama',0),(575993,16000,'ar','Ø¬Ø¹Ù„ ÙƒØ§ÙØ© Ø§Ù„Ø£Ø´Ù‡Ø± Ù†ÙØ³Ù‡Ø§',0),(575994,16000,'fr','Faire tous les mois mÃªme',0),(575995,16000,'jp','ã™ã¹ã¦ã®æœˆã‚’ä½œã‚‹åŒã˜',0),(575996,16000,'pt','Fazer todos os meses mesmo',0),(575997,16000,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð²ÑÐµ Ð¼ÐµÑÑÑ†Ñ‹ Ð¶Ðµ',0),(575998,16000,'es','Hacer todos los meses mismo',0),(575999,16000,'de','Machen alle Monate gleichen',0),(576000,16000,'en','Make All Months Same',0),(576001,16001,'is','',0),(576002,16001,'dr','Ù‡ÛŒÚ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(576003,16001,'pr','Ù‡ÛŒÚ† Ø¨ÙˆØ¯Ø¬Ù‡ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(576004,16001,'tr','HiÃ§bir bÃ¼tÃ§eleri oluÅŸturulan',0),(576005,16001,'pl','ZostaÅ‚y utworzone nie budÅ¼etÃ³w',0),(576006,16001,'bg','ÐÑÐ¼Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð¸ ÑÐ° Ð±Ð¸Ð»Ð¸ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð¸',0),(576007,16001,'ur','Ú©ÙˆØ¦ÛŒ Ø¨Ø¬Ù¹ Ù¾ÛŒØ¯Ø§ Ú©Ø¦Û’ Ú¯Ø¦Û’ ÛÛŒÚº',0),(576008,16001,'sr','ÐÐµÐ¼Ð° Ð±ÑƒÑŸÐµÑ‚Ð¸ ÑÑƒ ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð¸.',0),(576009,16001,'vi','KhÃ´ng cÃ³ ngÃ¢n sÃ¡ch Ä‘Ã£ Ä‘Æ°á»£c táº¡o ra',0),(576010,16001,'af','Geen begrotings is geskep',0),(576011,16001,'ro','Bugete nu au fost create',0),(576012,16001,'et','Eelarved on loodud',0),(576013,16001,'si','Ni proraÄuni so bile ustvarjene',0),(576014,16001,'ba','Tidak ada anggaran telah dibuat',0),(576015,16001,'nl','Geen begrotingen zijn gemaakt',0),(576016,16001,'fi','Budjetteja ei ole luotu',0),(576017,16001,'no','Ingen budsjetter er opprettet',0),(576018,16001,'da','Ingen budgetter er blevet oprettet',0),(576019,16001,'ko','ì•„ë‹ˆ ì˜ˆì‚°ì€ ë§Œë“¤ì—ˆìŠµë‹ˆë‹¤.',0),(576020,16001,'he','××™×Ÿ ×ª×§×¦×™×‘×™× × ×•×¦×¨×•',0),(576021,16001,'el','ÎˆÏ‡Î¿Ï…Î½ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î·Î¸ÎµÎ¯ ÎºÎ±Î¼Î¯Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿ÏÏ‚',0),(576022,16001,'zh','æ²¡æœ‰é¢„ç®—å·²åˆ›å»º',0),(576023,16001,'sv','Ingen budget har skapats',0),(576024,16001,'it','Nessun budget Ã¨ stato creato',0),(576025,16001,'tl','',0),(576026,16001,'th','à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¹„à¸¡à¹ˆà¹„à¸”à¹‰',0),(576027,16001,'hi','à¤•à¥‹à¤ˆ à¤¬à¤œà¤Ÿ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(576028,16001,'ms','Belanjawan tidak telah diwujudkan',0),(576029,16001,'ar','ÙˆÙ‚Ø¯ Ø£Ù†Ø´Ø¦Øª Ù„Ø§ Ù…ÙŠØ²Ø§Ù†ÙŠØ§Øª',0),(576030,16001,'fr','Aucun des Budgets nâ€™ont Ã©tÃ© crÃ©Ã©s',0),(576031,16001,'jp','äºˆç®—ãŒä½œæˆã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(576032,16001,'pt','NÃ£o hÃ¡ orÃ§amentos foram criados',0),(576033,16001,'ru','ÐÐµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ñ‹ Ð±Ñ‹Ð»Ð¸ ÑÐ¾Ð·Ð´Ð°Ð½Ñ‹',0),(576034,16001,'es','Se han creado sin presupuestos',0),(576035,16001,'de','Keine Budgets wurden erstellt',0),(576036,16001,'en','No Budgets Have Been Created',0),(576037,16002,'is','',0),(576038,16002,'dr','Ù„Ø·ÙØ§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ Ù†Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡',0),(576039,16002,'pr','Ù„Ø·ÙØ§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯ Ù†Ø§Ù… Ø¨ÙˆØ¯Ø¬Ù‡',0),(576040,16002,'tr','Bir bÃ¼tÃ§e adÄ± girin',0),(576041,16002,'pl','ProszÄ™ wprowadziÄ‡ nazwÄ™ budÅ¼etu',0),(576042,16002,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(576043,16002,'ur','Ø§ÛŒÚ© Ø¨Ø¬Ù¹ Ú©Ø§ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(576044,16002,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸Ð¼Ðµ Ð±ÑƒÑŸÐµÑ‚Ð°',0),(576045,16002,'vi','Vui lÃ²ng nháº­p má»™t ngÃ¢n sÃ¡ch',0),(576046,16002,'af','Tik asseblief \'n naam vir begroting',0),(576047,16002,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un nume de buget',0),(576048,16002,'et','Sisestage eelarve nimi',0),(576049,16002,'si','Vnesite ime predraÄuna',0),(576050,16002,'ba','Silahkan masukkan nama anggaran',0),(576051,16002,'nl','Voer de naam van een Budget',0),(576052,16002,'fi','SyÃ¶tÃ¤ budjetin nimi',0),(576053,16002,'no','Angi et Budsjettnavn',0),(576054,16002,'da','Angiv et budgetnavn',0),(576055,16002,'ko','ì˜ˆì‚° ì´ë¦„ì„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤',0),(576056,16002,'he','×× × ×”×›× ×¡ ×©× ×ª×§×¦×™×‘',0),(576057,16002,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿Ï…Î»Î¬Ï‡Î¹ÏƒÏ„Î¿Î½ ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(576058,16002,'zh','è¯·è¾“å…¥é¢„ç®—åç§°',0),(576059,16002,'sv','Ange ett budgetnamn',0),(576060,16002,'it','Si prega di inserire un nome di Budget',0),(576061,16002,'tl','',0),(576062,16002,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸Šà¸·à¹ˆà¸­à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“',0),(576063,16002,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤¬à¤œà¤Ÿ à¤•à¤¾ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(576064,16002,'ms','Sila masukkan nama bajet',0),(576065,16002,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø§Ø³Ù… Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(576066,16002,'fr','Veuillez entrer un nom de Budget',0),(576067,16002,'jp','äºˆç®—åã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(576068,16002,'pt','Por favor digite um nome de orÃ§amento',0),(576069,16002,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(576070,16002,'es','Introduzca un nombre de presupuesto',0),(576071,16002,'de','Bitte geben Sie einen Haushalt Namen',0),(576072,16002,'en','Please Enter A Budget Name',0),(576073,16003,'is','',0),(576074,16003,'dr','Ù„Ø·ÙØ§ Ø¯Ø± Ù…ÙˆØ±Ø¯ Ø³Ø§Ù„ Ù…Ø§Ù„ÛŒ Ø´Ø±ÙˆØ¹',0),(576075,16003,'pr','Ù„Ø·ÙØ§ Ø¯Ø± Ù…ÙˆØ±Ø¯ Ø³Ø§Ù„ Ù…Ø§Ù„ÛŒ Ø´Ø±ÙˆØ¹',0),(576076,16003,'tr','LÃ¼tfen bir mali baÅŸlangÄ±Ã§ yÄ±lÄ±nÄ± girin',0),(576077,16003,'pl','Podaj Rok fiskalny Begin',0),(576078,16003,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð°',0),(576079,16003,'ur','Ø§ÛŒÚ© Ù…Ø§Ù„ÛŒ Ø´Ø±ÙˆØ¹ Ø³Ø§Ù„ Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(576080,16003,'sr','ÐœÐ¾Ð»Ð¸Ð¼Ð¾ Ð²Ð°Ñ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð³Ð¾Ð´Ð¸Ð½Ñƒ Ñ„Ð¸ÑÐºÐ°Ð»Ð½Ð¸ Ð‘ÐµÐ³Ð¸Ð½',0),(576081,16003,'vi','Vui lÃ²ng nháº­p má»™t nÄƒm tÃ i chÃ­nh báº¯t Ä‘áº§u',0),(576082,16003,'af','Tik asseblief \'n Fiskale Begin jaar',0),(576083,16003,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un an Ã®ncepe fiscale',0),(576084,16003,'et','Keskmine hinne: aastas finantsaasta algus',0),(576085,16003,'si','Vnesite davÄno zaÄetek leta',0),(576086,16003,'ba','Masukkan satu tahun fiskal dimulai',0),(576087,16003,'nl','Voer een fiscale Begin jaar',0),(576088,16003,'fi','SyÃ¶tÃ¤ kirjanpidon alkaa vuoden',0),(576089,16003,'no','Angi regnskapsÃ¥ret begynner Ã¥ret',0),(576090,16003,'da','Angiv en skattemÃ¦ssig Begin Ã¥r',0),(576091,16003,'ko','íšŒê³„ ì‹œìž‘ ì—°ë„ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤',0),(576092,16003,'he','× × ×œ×”×–×™×Ÿ ×©× ×” ×‘×’×™×Ÿ ×”×›×¡×¤×™×',0),(576093,16003,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Ï„Î¿ Ï‡ÏÏŒÎ½Î¿ Î­Î½Î±ÏÎ¾Î· Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ®',0),(576094,16003,'zh','è¯·è¾“å…¥è´¢æ”¿å¼€å§‹å¹´ä»½',0),(576095,16003,'sv','Skriv in en skattemÃ¤ssig Begin Ã¥r',0),(576096,16003,'it','Si prega di inserire un anno fiscale Begin',0),(576097,16003,'tl','',0),(576098,16003,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸°à¸šà¸¸à¸›à¸µà¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸—à¸²à¸‡à¸à¸²à¸£à¹€à¸‡à¸´à¸™',0),(576099,16003,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤°à¤¾à¤œà¤•à¥‹à¤·à¥€à¤¯ à¤¶à¥à¤°à¥‚ à¤¸à¤¾à¤² à¤®à¥‡à¤‚ à¤ªà¥à¤°à¤µà¥‡à¤¶',0),(576100,16003,'ms','Isikan tahun fiskal mulakan',0),(576101,16003,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø³Ù†Ø© Ù…Ø§Ù„ÙŠØ© ØªØ¨Ø¯Ø£',0),(576102,16003,'fr','Veuillez entrer une annÃ©e fiscale Begin',0),(576103,16003,'jp','å¹´åº¦ã®é–‹å§‹å¹´ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(576104,16003,'pt','Por favor insira um ano Fiscal Begin',0),(576105,16003,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð³Ð¾Ð´ Ñ„Ð¸Ð½Ð°Ð½ÑÐ¾Ð²Ñ‹Ð¹ Begin',0),(576106,16003,'es','Introduce un aÃ±o Fiscal comience',0),(576107,16003,'de','Bitte geben Sie eine steuerliche Begin-Jahr',0),(576108,16003,'en','Please Enter A Fiscal Begin Year',0),(576109,16004,'is','',0),(576110,16004,'dr','Ø±ØªØ¨Ù‡ Ù†Ø§Ù…Ø¹ØªØ¨Ø± Ø§Ø³Øª',0),(576111,16004,'pr','Ø±ØªØ¨Ù‡ Ù†Ø§Ù…Ø¹ØªØ¨Ø± Ø§Ø³Øª',0),(576112,16004,'tr','SÄ±rasÄ± geÃ§ersiz',0),(576113,16004,'pl','Ranga jest nieprawidÅ‚owy',0),(576114,16004,'bg','Ð Ð°Ð½Ð³ Ðµ Ð½ÐµÐ²Ð°Ð»Ð¸Ð´ÐµÐ½',0),(576115,16004,'ur','Ù…ÛŒÚº Ø§Ø³Û’ Ù†Ø§Ø¬Ø§Ø¦Ø² ÛÛ’ Û”',0),(576116,16004,'sr','Ð Ð°Ð½Ð³ Ñ˜Ðµ Ð½ÐµÐ²Ð°Ð¶ÐµÑ›Ð°',0),(576117,16004,'vi','Xáº¿p háº¡ng lÃ  khÃ´ng há»£p lá»‡',0),(576118,16004,'af','Staanplek Is ongeldig',0),(576119,16004,'ro','Rang nu este valid',0),(576120,16004,'et','Auaste ei sobi',0),(576121,16004,'si','ÄŒin je neveljaven',0),(576122,16004,'ba','Peringkat tidak valid',0),(576123,16004,'nl','Rang Is ongeldig',0),(576124,16004,'fi','Sijoitus on virheellinen',0),(576125,16004,'no','Rangeringen er ugyldig',0),(576126,16004,'da','Rang er ugyldig',0),(576127,16004,'ko','ìˆœìœ„ëŠ” ìœ íš¨ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(576128,16004,'he','×“×¨×’×” ××™× ×” ×—×•×§×™×ª',0),(576129,16004,'el','ÎšÎ±Ï„Î¬Ï„Î±Î¾Î· Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ·',0),(576130,16004,'zh','æŽ’åæ˜¯æ— æ•ˆ',0),(576131,16004,'sv','Rank Ã¤r ogiltig',0),(576132,16004,'it','Rango non Ã¨ valido',0),(576133,16004,'tl','',0),(576134,16004,'th','à¸¥à¸³à¸”à¸±à¸šà¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(576135,16004,'hi','à¤°à¥ˆà¤‚à¤• à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤¹à¥ˆ',0),(576136,16004,'ms','Pangkat tidak sah',0),(576137,16004,'ar','Ø±ØªØ¨Ø© ØºÙŠØ± ØµØ§Ù„Ø­',0),(576138,16004,'fr','Rank nâ€™est pas valide',0),(576139,16004,'jp','ãƒ©ãƒ³ã‚¯ã¯ç„¡åŠ¹',0),(576140,16004,'pt','Rank Ã© invÃ¡lido',0),(576141,16004,'ru','Ð Ð°Ð½Ð³ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð½ÐµÐ´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¼',0),(576142,16004,'es','Rango no es vÃ¡lido',0),(576143,16004,'de','Rang ist ungÃ¼ltig',0),(576144,16004,'en','Rank Is Invalid',0),(576145,16005,'is','',0),(576146,16005,'dr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± Ø¨ÙˆØ¯Ø¬Ù‡',0),(576147,16005,'pr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± Ø¨ÙˆØ¯Ø¬Ù‡',0),(576148,16005,'tr','BÃ¼tÃ§e kaydetmek',0),(576149,16005,'pl','Zapisz budÅ¼etu',0),(576150,16005,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(576151,16005,'ur','Ø¨Ø¬Ù¹ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(576152,16005,'sr','Ð¡Ð¿Ð°ÑÐ¸ Ð±ÑƒÑŸÐµÑ‚',0),(576153,16005,'vi','Tiáº¿t kiá»‡m ngÃ¢n sÃ¡ch',0),(576154,16005,'af','Stoor begroting',0),(576155,16005,'ro','Salva bugetul',0),(576156,16005,'et','Salvesta eelarve',0),(576157,16005,'si','Shranite proraÄuna',0),(576158,16005,'ba','Menghemat anggaran',0),(576159,16005,'nl','Budget opslaan',0),(576160,16005,'fi','Tallenna talousarvion',0),(576161,16005,'no','Lagre budsjett',0),(576162,16005,'da','Gemme Budget',0),(576163,16005,'ko','ì˜ˆì‚°ì„ ì €ìž¥í•©ë‹ˆë‹¤',0),(576164,16005,'he','×œ×”×¦×™×œ ××ª ×”×ª×§×¦×™×‘',0),(576165,16005,'el','Î£ÏŽÏƒÎµÎ¹ Ï„Î¿Î½ Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ',0),(576166,16005,'zh','èŠ‚çœé¢„ç®—',0),(576167,16005,'sv','Spara Budget',0),(576168,16005,'it','Salvare il bilancio',0),(576169,16005,'tl','',0),(576170,16005,'th','à¸›à¸£à¸°à¸«à¸¢à¸±à¸”à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“',0),(576171,16005,'hi','à¤¬à¤œà¤Ÿ à¤•à¥‹ à¤¬à¤šà¤¾à¤¨à¥‡',0),(576172,16005,'ms','Simpan bajet',0),(576173,16005,'ar','Ø­ÙØ¸ Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(576174,16005,'fr','Sauver le Budget',0),(576175,16005,'jp','äºˆç®—ã‚’ç¯€ç´„ã—ã¾ã™ã€‚',0),(576176,16005,'pt','Salvar o orÃ§amento',0),(576177,16005,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ Ð±ÑŽÐ´Ð¶ÐµÑ‚',0),(576178,16005,'es','Ahorre presupuesto',0),(576179,16005,'de','Speichern Sie Budget',0),(576180,16005,'en','Save Budget',0),(576181,16006,'is','',0),(576182,16006,'dr','Ø³Ø§Ù„ Ø§Ø³Øª Ø®Ø§Ø±Ø¬ Ø§Ø² Ù…Ø­Ø¯ÙˆØ¯Ù‡',0),(576183,16006,'pr','Ø³Ø§Ù„ Ø§Ø³Øª Ø®Ø§Ø±Ø¬ Ø§Ø² Ù…Ø­Ø¯ÙˆØ¯Ù‡',0),(576184,16006,'tr','YÄ±l ulaÅŸÄ±lamÄ±yor',0),(576185,16006,'pl','Yearjest poza zakresem',0),(576186,16006,'bg','Ð“Ð¾Ð´Ð¸Ð½Ð°Ñ‚Ð° Ðµ Ð¸Ð·Ð²ÑŠÐ½ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð°',0),(576187,16006,'ur','Ø³Ø§Ù„ Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ø³Û’ Ø¨Ø§ÛØ± ÛÛ’ Û”',0),(576188,16006,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ Ñ˜Ðµ Ð¸Ð·Ð²Ð°Ð½ Ð¾Ð¿ÑÐµÐ³Ð°',0),(576189,16006,'vi','NÄƒm nay lÃ  ra khá»i pháº¡m vi',0),(576190,16006,'af','Jaar Is buite die bestek',0),(576191,16006,'ro','An este Ã®n afara intervalului',0),(576192,16006,'et','Aastal on vahemikust vÃ¤ljas',0),(576193,16006,'si','Leto je zunaj obsega',0),(576194,16006,'ba','Tahun berada di luar jangkauan',0),(576195,16006,'nl','Jaar valt buiten het bereik',0),(576196,16006,'fi','Vuosi on sallitun alueen ulkopuolella',0),(576197,16006,'no','Ã…ret er',0),(576198,16006,'da','Ã…ret er uden for rÃ¦kkevidde',0),(576199,16006,'ko','ë…„ì´ ë²”ìœ„',0),(576200,16006,'he','×©× ×” × ×ž×¦× ×ž×—×•×¥ ×œ×˜×•×•×—',0),(576201,16006,'el','ÎˆÏ„Î¿Ï‚ ÎµÎ¯Î½Î±Î¹ ÎµÎºÏ„ÏŒÏ‚ Ï€ÎµÏÎ¹Î¿Ï‡Î®Ï‚',0),(576202,16006,'zh','ä»Šå¹´æ˜¯è¶…å‡ºèŒƒå›´',0),(576203,16006,'sv','Ã…ret Ã¤r utanfÃ¶r intervallet',0),(576204,16006,'it','L\'anno Ã¨ compreso nell\'intervallo',0),(576205,16006,'tl','',0),(576206,16006,'th','à¸›à¸µà¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸Šà¹ˆà¸§à¸‡',0),(576207,16006,'hi','à¤µà¤°à¥à¤· à¤•à¥€ à¤¸à¥€à¤®à¤¾ à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤¹à¥ˆ',0),(576208,16006,'ms','Tahun adalah di luar julat',0),(576209,16006,'ar','Ø§Ù„Ø¹Ø§Ù… Ø®Ø§Ø±Ø¬ Ø§Ù„Ù†Ø·Ø§Ù‚',0),(576210,16006,'fr','Lâ€™annÃ©e est hors limites',0),(576211,16006,'jp','å¹´ãŒç¯„å›²å¤–ã§ã™ã€‚',0),(576212,16006,'pt','Ano estÃ¡ fora do intervalo',0),(576213,16006,'ru','Ð“Ð¾Ð´ Ð½Ð°Ñ…Ð¾Ð´Ð¸Ñ‚ÑÑ Ð²Ð½Ðµ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½Ð°',0),(576214,16006,'es','AÃ±o estÃ¡ fuera del alcance',0),(576215,16006,'de','Jahr ist auÃŸerhalb des gÃ¼ltigen Bereichs',0),(576216,16006,'en','Year Is Out Of Range',0),(576217,16007,'is','',0),(576218,16007,'dr','ØªÙˆØ³Ø· ØªØ¹Ø¯Ø§Ø¯',0),(576219,16007,'pr','ØªÙˆØ³Ø· ØªØ¹Ø¯Ø§Ø¯',0),(576220,16007,'tr','SayÄ±sÄ±na gÃ¶re',0),(576221,16007,'pl','Hrabia',0),(576222,16007,'bg','ÐžÑ‚ Ð±Ñ€Ð¾Ð¹',0),(576223,16007,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø´Ù…Ø§Ø±',0),(576224,16007,'sr','ÐŸÑ€ÐµÐ¼Ð° ÐµÐ²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ð¸',0),(576225,16007,'vi','Theo sá»‘ lÆ°á»£ng',0),(576226,16007,'af','Deur telling',0),(576227,16007,'ro','NumÄƒrul de',0),(576228,16007,'et','Arvu jÃ¤rgi',0),(576229,16007,'si','S Å¡tetjem',0),(576230,16007,'ba','Oleh Count',0),(576231,16007,'nl','Door graaf',0),(576232,16007,'fi','MÃ¤Ã¤rÃ¤n mukaan',0),(576233,16007,'no','Av greven',0),(576234,16007,'da','Af Grev',0),(576235,16007,'ko','ìˆ˜',0),(576236,16007,'he','×œ×¤×™ ×”×¡×¤×™×¨×”',0),(576237,16007,'el','Î‘Ï€ÏŒ Ï„Î¿ Ï€Î»Î®Î¸Î¿Ï‚',0),(576238,16007,'zh','æŒ‰è®¡æ•°',0),(576239,16007,'sv','Vid rÃ¤kning',0),(576240,16007,'it','Dal conte',0),(576241,16007,'tl','',0),(576242,16007,'th','à¹‚à¸”à¸¢à¸™à¸±à¸šà¸ˆà¸³à¸™à¸§à¸™',0),(576243,16007,'hi','à¤—à¤¿à¤¨à¤¤à¥€ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(576244,16007,'ms','Dengan kiraan',0),(576245,16007,'ar','Ø­Ø³Ø¨ Ø§Ù„Ø¹Ø¯Ø¯',0),(576246,16007,'fr','En fonction du nombre',0),(576247,16007,'jp','æ•°ã«ã‚ˆã£ã¦',0),(576248,16007,'pt','Pela contagem',0),(576249,16007,'ru','Ð“Ñ€Ð°Ñ„',0),(576250,16007,'es','Por cuenta de la',0),(576251,16007,'de','Von Graf',0),(576252,16007,'en','By Count',0),(576253,16008,'is','',0),(576254,16008,'dr','Ù‡Ø± X Ø±ÙˆØ²',0),(576255,16008,'pr','Ù‡Ø± X Ø±ÙˆØ²',0),(576256,16008,'tr','Her gÃ¼n X',0),(576257,16008,'pl','Co X dni',0),(576258,16008,'bg','Ð’ÑÐµÐºÐ¸ X Ð´Ð½Ð¸',0),(576259,16008,'ur','ÛØ± Ø¯Ù† X',0),(576260,16008,'sr','Ð¡Ð²Ð°ÐºÐ¸Ñ… X Ð´Ð°Ð½Ð°',0),(576261,16008,'vi','Má»—i ngÃ y X',0),(576262,16008,'af','Elke X dae',0),(576263,16008,'ro','Fiecare X zile',0),(576264,16008,'et','Iga X pÃ¤eva',0),(576265,16008,'si','Vsakih X dni',0),(576266,16008,'ba','Setiap X hari',0),(576267,16008,'nl','Elke X dagen',0),(576268,16008,'fi','Aina X pÃ¤ivÃ¤n vÃ¤lein',0),(576269,16008,'no','Hver X dager',0),(576270,16008,'da','Hver X dage',0),(576271,16008,'ko','X ì¼ ë§ˆë‹¤',0),(576272,16008,'he','×›×œ X ×™×ž×™×',0),(576273,16008,'el','ÎšÎ¬Î¸Îµ X Î·Î¼Î­ÏÎµÏ‚',0),(576274,16008,'zh','æ¯ X å¤©',0),(576275,16008,'sv','Varje X dagar',0),(576276,16008,'it','Ogni X giorni',0),(576277,16008,'tl','',0),(576278,16008,'th','à¸—à¸¸à¸ à¹† X à¸§à¸±à¸™',0),(576279,16008,'hi','à¤¹à¤° à¤¦à¤¿à¤¨ X',0),(576280,16008,'ms','Tiap-tiap X hari',0),(576281,16008,'ar','ÙƒÙ„ X ÙŠÙˆÙ…',0),(576282,16008,'fr','Chaque X jours',0),(576283,16008,'jp','X æ—¥ã”ã¨',0),(576284,16008,'pt','Cada X dias',0),(576285,16008,'ru','ÐšÐ°Ð¶Ð´Ñ‹Ðµ X Ð´Ð½ÐµÐ¹',0),(576286,16008,'es','Cada X dÃ­as',0),(576287,16008,'de','Alle X Tage',0),(576288,16008,'en','Every X Days',0),(576289,16009,'is','',0),(576290,16009,'dr','Ù‡Ø± X Ù…Ø§Ù‡',0),(576291,16009,'pr','Ù‡Ø± X Ù…Ø§Ù‡',0),(576292,16009,'tr','Her ay X',0),(576293,16009,'pl','KaÅ¼dy X miesiÄ™cy',0),(576294,16009,'bg','Ð’ÑÐµÐºÐ¸ X Ð¼ÐµÑÐµÑ†Ð°',0),(576295,16009,'ur','ÛØ± Ù…Ø§Û X',0),(576296,16009,'sr','Ð¡Ð²Ð°ÐºÐ¸ X Ð¼ÐµÑÐµÑ†Ð¸',0),(576297,16009,'vi','Má»—i X thÃ¡ng',0),(576298,16009,'af','Elke X maande',0),(576299,16009,'ro','Fiecare X luni',0),(576300,16009,'et','Iga X kuud',0),(576301,16009,'si','Vsak X mesecev',0),(576302,16009,'ba','Setiap X bulan',0),(576303,16009,'nl','Elke X maanden',0),(576304,16009,'fi','X kuukauden vÃ¤lein',0),(576305,16009,'no','Hver X mÃ¥neder',0),(576306,16009,'da','Hver X mÃ¥neder',0),(576307,16009,'ko','X ê°œì›” ë§ˆë‹¤',0),(576308,16009,'he','×›×œ X ×—×•×“×©×™×',0),(576309,16009,'el','ÎšÎ¬Î¸Îµ X Î¼Î®Î½ÎµÏ‚',0),(576310,16009,'zh','æ¯ X ä¸ªæœˆ',0),(576311,16009,'sv','Varje X mÃ¥nader',0),(576312,16009,'it','Ogni X mesi',0),(576313,16009,'tl','',0),(576314,16009,'th','à¸—à¸¸à¸ X à¹€à¸”à¸·à¸­à¸™',0),(576315,16009,'hi','à¤¹à¤° à¤®à¤¹à¥€à¤¨à¥‡ X',0),(576316,16009,'ms','Tiap-tiap X bulan',0),(576317,16009,'ar','ÙƒÙ„ X Ø´Ù‡Ø±Ø§',0),(576318,16009,'fr','Chaque X mois',0),(576319,16009,'jp','æ•°ãƒ¶æœˆãŠã',0),(576320,16009,'pt','Cada X meses',0),(576321,16009,'ru','ÐšÐ°Ð¶Ð´Ñ‹Ð¹ X Ð¼ÐµÑÑÑ†ÐµÐ²',0),(576322,16009,'es','Cada X meses',0),(576323,16009,'de','Alle X Monate',0),(576324,16009,'en','Every X Months',0),(576325,16010,'is','',0),(576326,16010,'dr','Ù‡Ø± X Ù‡ÙØªÙ‡',0),(576327,16010,'pr','Ù‡Ø± X Ù‡ÙØªÙ‡',0),(576328,16010,'tr','Her X hafta',0),(576329,16010,'pl','KaÅ¼dy X tygodni',0),(576330,16010,'bg','Ð’ÑÐµÐºÐ¸ X ÑÐµÐ´Ð¼Ð¸Ñ†Ð¸',0),(576331,16010,'ur','ÛØ± ÛÙØªÛ’ X',0),(576332,16010,'sr','Ð¡Ð²Ð°ÐºÐ¸ X ÑÐµÐ´Ð¼Ð¸Ñ†Ð°',0),(576333,16010,'vi','Má»—i X tuáº§n',0),(576334,16010,'af','Elke X weke',0),(576335,16010,'ro','Fiecare X saptamani',0),(576336,16010,'et','Iga X nÃ¤dalat',0),(576337,16010,'si','Vsakih X tednov',0),(576338,16010,'ba','Setiap X minggu',0),(576339,16010,'nl','Elke X weken',0),(576340,16010,'fi','Joka X viikkoa',0),(576341,16010,'no','Hver X uker',0),(576342,16010,'da','Hver X uger',0),(576343,16010,'ko','ëª¨ë“  ì£¼ X',0),(576344,16010,'he','×›×œ X ×©×‘×•×¢×•×ª',0),(576345,16010,'el','ÎšÎ¬Î¸Îµ Î§ Î•Î’Î”ÎŸÎœÎ‘Î”Î•Î£',0),(576346,16010,'zh','æ¯ X å‘¨',0),(576347,16010,'sv','Varje X veckor',0),(576348,16010,'it','Ogni X settimane',0),(576349,16010,'tl','',0),(576350,16010,'th','à¸—à¸¸à¸ X à¸ªà¸±à¸›à¸”à¸²à¸«à¹Œ',0),(576351,16010,'hi','à¤¹à¤° X à¤¸à¤ªà¥à¤¤à¤¾à¤¹',0),(576352,16010,'ms','Tiap-tiap X minggu',0),(576353,16010,'ar','ÙƒÙ„ X Ø£Ø³Ø¨ÙˆØ¹Ø§',0),(576354,16010,'fr','Chaque X semaines',0),(576355,16010,'jp','3 é€±é–“ãŠã',0),(576356,16010,'pt','Cada X semanas',0),(576357,16010,'ru','ÐšÐ°Ð¶Ð´Ñ‹Ð¹ X Ð½ÐµÐ´ÐµÐ»ÑŒ',0),(576358,16010,'es','Cada X semanas',0),(576359,16010,'de','Alle X Wochen',0),(576360,16010,'en','Every X Weeks',0),(576361,16011,'is','',0),(576362,16011,'dr','Ù‡Ø± X Ø³Ø§Ù„',0),(576363,16011,'pr','Ù‡Ø± X Ø³Ø§Ù„',0),(576364,16011,'tr','Her X yÄ±l',0),(576365,16011,'pl','Co X lat',0),(576366,16011,'bg','Ð’ÑÐµÐºÐ¸ X Ð³Ð¾Ð´Ð¸Ð½Ð¸',0),(576367,16011,'ur','ÛØ± Ø³Ø§Ù„ X',0),(576368,16011,'sr','Ð¡Ð²Ð°ÐºÐ¸Ñ… X Ð³Ð¾Ð´Ð¸Ð½Ð°',0),(576369,16011,'vi','Má»—i X nÄƒm',0),(576370,16011,'af','Elke jaar X',0),(576371,16011,'ro','Fiecare X ani',0),(576372,16011,'et','Iga X aastat',0),(576373,16011,'si','Vsak X let',0),(576374,16011,'ba','Setiap X tahun',0),(576375,16011,'nl','Elke X jaar',0),(576376,16011,'fi','Jokainen X vuotta',0),(576377,16011,'no','Hver X Ã¥r',0),(576378,16011,'da','Hver X Ã¥r',0),(576379,16011,'ko','ëª¨ë“  X ë…„',0),(576380,16011,'he','×›×œ X ×©× ×™×',0),(576381,16011,'el','ÎšÎ¬Î¸Îµ Î§ Ï‡ÏÏŒÎ½Î¹Î±',0),(576382,16011,'zh','æ¯å¹´ X',0),(576383,16011,'sv','Varje X Ã¥r',0),(576384,16011,'it','Ogni X anni',0),(576385,16011,'tl','',0),(576386,16011,'th','à¸—à¸¸à¸ X à¸›à¸µ',0),(576387,16011,'hi','à¤¹à¤° à¤¸à¤¾à¤² X',0),(576388,16011,'ms','Tiap-tiap X tahun',0),(576389,16011,'ar','ÙƒÙ„ X Ø³Ù†Ø©',0),(576390,16011,'fr','Chaque X annÃ©es',0),(576391,16011,'jp','å¹´ãŠã',0),(576392,16011,'pt','Cada X anos',0),(576393,16011,'ru','ÐšÐ°Ð¶Ð´Ñ‹Ð¹ X Ð»ÐµÑ‚',0),(576394,16011,'es','Cada X aÃ±os',0),(576395,16011,'de','Alle X Jahre',0),(576396,16011,'en','Every X Years',0),(576397,16012,'is','',0),(576398,16012,'dr','ØªÙ…Ø§Ù… Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ù¾Ø³Øª',0),(576399,16012,'pr','ØªÙ…Ø§Ù… Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ù¾Ø³Øª',0),(576400,16012,'tr','TÃ¼m giriÅŸlerini deftere nakletmek',0),(576401,16012,'pl','Post wszystkie wpisy',0),(576402,16012,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(576403,16012,'ur','ØªÙ…Ø§Ù… Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù¾ÙˆØ³Ù¹',0),(576404,16012,'sr','ÐšÑšÐ¸Ð¶ÐµÑšÐµ ÑÐ²Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸',0),(576405,16012,'vi','Gá»­i táº¥t cáº£ cÃ¡c má»¥c',0),(576406,16012,'af','Plaas alle inskrywings',0),(576407,16012,'ro','Post toate intrÄƒrile',0),(576408,16012,'et','KÃµigi kannete konteerimine',0),(576409,16012,'si','Vse postavke',0),(576410,16012,'ba','Posting semua entri',0),(576411,16012,'nl','Alle posten',0),(576412,16012,'fi','Kaikki tapahtumat',0),(576413,16012,'no','Alle bokfÃ¸re',0),(576414,16012,'da','BogfÃ¸ring af alle poster',0),(576415,16012,'ko','ëª¨ë“  í•­ëª©ì„ ê²Œì‹œ',0),(576416,16012,'he','×¤×•×¡×˜ ×›×œ ×”×¢×¨×›×™×',0),(576417,16012,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(576418,16012,'zh','å‘å¸ƒæ‰€æœ‰æ¡ç›®',0),(576419,16012,'sv','BokfÃ¶ra alla transaktioner',0),(576420,16012,'it','Registrare tutti i movimenti',0),(576421,16012,'tl','',0),(576422,16012,'th','à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(576423,16012,'hi','à¤¸à¤­à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(576424,16012,'ms','Menghantar Semua penyertaan',0),(576425,16012,'ar','Ù†Ø´Ø± ÙƒØ§ÙØ© Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª',0),(576426,16012,'fr','Afficher toutes les entrÃ©es',0),(576427,16012,'jp','ã™ã¹ã¦ã®ã‚¨ãƒ³ãƒˆãƒªã‚’æŠ•ç¨¿ã—ã¾ã™ã€‚',0),(576428,16012,'pt','Registar todos os movimentos',0),(576429,16012,'ru','ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ñ‚ÑŒ Ð²ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(576430,16012,'es','Publicar todas las entradas',0),(576431,16012,'de','Post-alle EintrÃ¤ge',0),(576432,16012,'en','Post All Entries',0),(576433,16013,'is','',0),(576434,16013,'dr','ÙˆØ±ÙˆØ¯ÛŒ Ù‡Ø§ÛŒ ØªÚ©ÛŒ Ø§Ø±Ø³Ø§Ù„',0),(576435,16013,'pr','ÙˆØ±ÙˆØ¯ÛŒ Ù‡Ø§ÛŒ ØªÚ©ÛŒ Ø§Ø±Ø³Ø§Ù„',0),(576436,16013,'tr','SonrasÄ± tek tek giriÅŸler',0),(576437,16013,'pl','Po poszczegÃ³lnych wpisÃ³w',0),(576438,16013,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð¹ Ð¾Ñ‚Ð´ÐµÐ»Ð½Ð¸Ñ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(576439,16013,'ur','Ù¾ÙˆØ³Ù¹ Ø§Ù†ÙØ±Ø§Ø¯ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(576440,16013,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶Ð¸ Ð¿Ð¾Ñ˜ÐµÐ´Ð¸Ð½Ð°Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(576441,16013,'vi','CÃ¡ nhÃ¢n bÃ i má»¥c',0),(576442,16013,'af','Post individuele inskrywings',0),(576443,16013,'ro','IntrÄƒrile individuale post',0),(576444,16013,'et','Postitus Ã¼ksikuid kandeid',0),(576445,16013,'si','Po posameznih postavkah',0),(576446,16013,'ba','Posting setiap entri',0),(576447,16013,'nl','Post afzonderlijke posten',0),(576448,16013,'fi','Kirjaa yksittÃ¤iset tapahtumat',0),(576449,16013,'no','Innlegg enkeltoppfÃ¸ringer',0),(576450,16013,'da','IndlÃ¦g individuelle poster',0),(576451,16013,'ko','ê²Œì‹œë¬¼ ê°œë³„ í•­ëª©',0),(576452,16013,'he','×¢×¨×›×™× ×‘×•×“×“×™× ×¤×•×¡×˜',0),(576453,16013,'el','ÎœÎµÏ„Î¬ Î¼ÎµÎ¼Î¿Î½Ï‰Î¼Î­Î½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(576454,16013,'zh','åŽå„ä¸ªæ¡ç›®',0),(576455,16013,'sv','BokfÃ¶r enskilda transaktioner',0),(576456,16013,'it','Post singole voci',0),(576457,16013,'tl','',0),(576458,16013,'th','à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹à¸•à¹ˆà¸¥à¸°à¸£à¸²à¸¢à¸à¸²à¸£',0),(576459,16013,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤…à¤²à¤—-à¤…à¤²à¤— à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(576460,16013,'ms','Entri Post individu',0),(576461,16013,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„ÙØ±Ø¯ÙŠØ© ÙˆØ¸ÙŠÙØ©',0),(576462,16013,'fr','Inscription individuelle post',0),(576463,16013,'jp','ãƒã‚¹ãƒˆå€‹ã€… ã®ã‚¨ãƒ³ãƒˆãƒª',0),(576464,16013,'pt','Entradas individuais post',0),(576465,16013,'ru','ÐŸÐ¾ÑÐ»Ðµ Ð¾Ñ‚Ð´ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(576466,16013,'es','Entradas post individuales',0),(576467,16013,'de','Post einzelne EintrÃ¤ge',0),(576468,16013,'en','Post Individual Entries',0),(576469,16014,'is','',0),(576470,16014,'dr','ØªÚ©Ø±Ø§Ø±ÛŒ Ø¨Ù‡ Ù¾Ø§ÛŒØ§Ù† Ù…ÛŒ Ø±Ø³Ø¯',0),(576471,16014,'pr','ØªÚ©Ø±Ø§Ø±ÛŒ Ø¨Ù‡ Ù¾Ø§ÛŒØ§Ù† Ù…ÛŒ Ø±Ø³Ø¯',0),(576472,16014,'tr','Biter yinelenen',0),(576473,16014,'pl','PowtarzajÄ…ce siÄ™ koÅ„czy',0),(576474,16014,'bg','ÐŸÐ¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ ÑÐ²ÑŠÑ€ÑˆÐ²Ð°',0),(576475,16014,'ur','Ø§Ù†ØªÛØ§ Ú©Ùˆ Ù…Ú©Ø±Ø±',0),(576476,16014,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ ÐºÑ€Ð°Ñ˜ÐµÐ²Ðµ',0),(576477,16014,'vi','Äá»‹nh ká»³ káº¿t thÃºc',0),(576478,16014,'af','Herhalende eindig',0),(576479,16014,'ro','Recurente se terminÄƒ',0),(576480,16014,'et','Korduv otsad',0),(576481,16014,'si','PonavljajoÄe se konÄa',0),(576482,16014,'ba','Berulang berakhir',0),(576483,16014,'nl','Terugkerende uiteinden',0),(576484,16014,'fi','Toistuva pÃ¤Ã¤ttyy',0),(576485,16014,'no','Regelmessige ender',0),(576486,16014,'da','Tilbagevendende ender',0),(576487,16014,'ko','ìž¬ë°œ í•˜ëŠ” ë',0),(576488,16014,'he','×—×•×–×¨×•×ª ×ž×¡×ª×™×™×',0),(576489,16014,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ Î¬ÎºÏÎ±',0),(576490,16014,'zh','å®šæœŸç»“æŸ',0),(576491,16014,'sv','Ã…terkommande Ã¤ndar',0),(576492,16014,'it','Ricorrenti le estremitÃ ',0),(576493,16014,'tl','',0),(576494,16014,'th','à¹€à¸à¸´à¸”à¸‹à¹‰à¸³à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸¥à¸‡',0),(576495,16014,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ',0),(576496,16014,'ms','Berulang hujung',0),(576497,16014,'ar','Ø§Ù„Ù…ØªÙƒØ±Ø±Ø© ÙŠÙ†ØªÙ‡ÙŠ',0),(576498,16014,'fr','RÃ©current des extrÃ©mitÃ©s',0),(576499,16014,'jp','ä¸¡ç«¯ã‚’å®šæœŸçš„',0),(576500,16014,'pt','Recorrentes de extremidades',0),(576501,16014,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ ÐºÐ¾Ð½Ñ†Ñ‹',0),(576502,16014,'es','Extremos que se repite',0),(576503,16014,'de','Wiederkehrende enden',0),(576504,16014,'en','Recurring Ends',0),(576505,16015,'is','',0),(576506,16015,'dr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(576507,16015,'pr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(576508,16015,'tr','Yinelenen dÃ¶nemi',0),(576509,16015,'pl','Termin cykliczny',0),(576510,16015,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(576511,16015,'ur','Ù…Ú©Ø±Ø± Ø¹Ø±ØµÛ',0),(576512,16015,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(576513,16015,'vi','Khoáº£ng thá»i gian Ä‘á»‹nh ká»³',0),(576514,16015,'af','Herhalende tydperk',0),(576515,16015,'ro','Perioada recurente',0),(576516,16015,'et','Korduva perioodi',0),(576517,16015,'si','PonavljajoÄa se obdobja',0),(576518,16015,'ba','Periode berulang',0),(576519,16015,'nl','Terugkerende periode',0),(576520,16015,'fi','Toistuvan jakson',0),(576521,16015,'no','Regelmessige periode',0),(576522,16015,'da','Tilbagevendende periode',0),(576523,16015,'ko','ë˜í’€ì´ ê¸°ê°„',0),(576524,16015,'he','×ª×§×•×¤×ª ×—×•×–×¨×•×ª',0),(576525,16015,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½Î¿ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(576526,16015,'zh','åå¤å‡ºçŽ°çš„æ—¶æœŸ',0),(576527,16015,'sv','Ã…terkommande Period',0),(576528,16015,'it','Periodo ricorrente',0),(576529,16015,'tl','',0),(576530,16015,'th','à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸—à¸µà¹ˆà¹€à¸à¸´à¸”à¸‹à¹‰à¸³',0),(576531,16015,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤…à¤µà¤§à¤¿',0),(576532,16015,'ms','Tempoh berulang',0),(576533,16015,'ar','Ø§Ù„ÙØªØ±Ø© Ø§Ù„Ù…ØªÙƒØ±Ø±Ø©',0),(576534,16015,'fr','PÃ©riodique de pÃ©riode',0),(576535,16015,'jp','å®šæœŸçš„ãªæœŸé–“',0),(576536,16015,'pt','PerÃ­odo recorrente',0),(576537,16015,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(576538,16015,'es','PerÃ­odo recurrente',0),(576539,16015,'de','Wiederkehrende Periode',0),(576540,16015,'en','Recurring Period',0),(576541,16016,'is','',0),(576542,16016,'dr','Ù¾Ø³Øª Ú†Ú¯ÙˆÙ†Ù‡ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(576543,16016,'pr','Ù¾Ø³Øª Ú†Ú¯ÙˆÙ†Ù‡ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(576544,16016,'tr','MesajÄ±nÄ± nasÄ±l yinelenen',0),(576545,16016,'pl','PowtarzajÄ…ce siÄ™ posty jak',0),(576546,16016,'bg','ÐŸÐ¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð¿Ð¾ÑÑ‚Ð¾Ð²Ðµ ÐºÐ°Ðº',0),(576547,16016,'ur','Ø®Ø·ÙˆØ· Ú©ÛŒØ³Û’ Ù…Ú©Ø±Ø±',0),(576548,16016,'sr','ÐšÐ¾Ð»Ð¸ÐºÐ¾ Ð¿Ð¾Ð½Ð°Ð²Ñ™Ð°ÑšÐ° Ð¾Ð±Ñ˜Ð°Ð²Ðµ',0),(576549,16016,'vi','Äá»‹nh ká»³ bÃ i viáº¿t nhÆ° tháº¿ nÃ o',0),(576550,16016,'af','Hoe poste herhalende',0),(576551,16016,'ro','Recurente mesaje cum',0),(576552,16016,'et','Korduv postitusi kuidas',0),(576553,16016,'si','Ponavljanje objav kako',0),(576554,16016,'ba','Berulang posting bagaimana',0),(576555,16016,'nl','Terugkerende posten hoe',0),(576556,16016,'fi','Toistuva viestejÃ¤ miten',0),(576557,16016,'no','Regelmessig innlegg hvordan',0),(576558,16016,'da','Tilbagevendende indlÃ¦g hvordan',0),(576559,16016,'ko','ê²Œì‹œë¬¼ì„ ì–´ë–»ê²Œ ë˜í’€ì´',0),(576560,16016,'he','×—×•×–×¨×ª ×›×ž×” ×”×•×“×¢×•×ª',0),(576561,16016,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ Î¸Î­ÏƒÎµÎ¹Ï‚ Ï€ÏŽÏ‚',0),(576562,16016,'zh','å¦‚ä½•å®šæœŸå‘˜é¢',0),(576563,16016,'sv','Ã…terkommande inlÃ¤gg hur',0),(576564,16016,'it','Ricorrenti come post',0),(576565,16016,'tl','',0),(576566,16016,'th','à¸‹à¹‰à¸³à¸à¸£à¸°à¸—à¸¹à¹‰à¸§à¸´à¸˜à¸µ',0),(576567,16016,'hi','à¤°à¤¿à¤•à¤°à¤¿à¤‚à¤— à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¥ˆà¤¸à¥‡',0),(576568,16016,'ms','Berulang posting bagaimana',0),(576569,16016,'ar','ØªÙƒØ±Ø§Ø± ÙˆØ¸ÙŠÙØ© ÙƒÙŠÙ',0),(576570,16016,'fr','RÃ©currents de messages Comment',0),(576571,16016,'jp','ã©ã®ã‚ˆã†ã«è¨˜äº‹ã‚’å®šæœŸ',0),(576572,16016,'pt','Recorrente Posts como',0),(576573,16016,'ru','ÐšÐ°Ðº Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(576574,16016,'es','Los mensajes se repite cÃ³mo',0),(576575,16016,'de','Wiederkehrende BeitrÃ¤ge wie',0),(576576,16016,'en','Recurring Posts How',0),(576577,16017,'is','',0),(576578,16017,'dr','Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ Ø¯Ø±',0),(576579,16017,'pr','Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡ Ø¯Ø±',0),(576580,16017,'tr','Yinelenen baÅŸlar',0),(576581,16017,'pl','Cykliczny rozpoczyna siÄ™',0),(576582,16017,'bg','ÐŸÐ¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¾Ñ‡Ð²Ð° Ð½Ð°',0),(576583,16017,'ur','Ù…Ú©Ø±Ø± Ø³Û’ Ø´Ø±ÙˆØ¹',0),(576584,16017,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð¿Ð¾Ñ‡Ð¸ÑšÐµ',0),(576585,16017,'vi','Äá»‹nh ká»³ báº¯t Ä‘áº§u vÃ o',0),(576586,16017,'af','Herhalende begin op',0),(576587,16017,'ro','ÃŽncepe recurente',0),(576588,16017,'et','Korduva algus',0),(576589,16017,'si','PonavljajoÄe se zaÄne na',0),(576590,16017,'ba','Berulang dimulai pada',0),(576591,16017,'nl','Terugkerende begint op',0),(576592,16017,'fi','Toistuva alkaa',0),(576593,16017,'no','Regelmessige starter',0),(576594,16017,'da','Tilbagevendende starter pÃ¥',0),(576595,16017,'ko','ë˜í’€ì´ ì‹œìž‘',0),(576596,16017,'he','×ž×ª×—×™×œ ×—×•×–×¨×•×ª ×‘×™×•×',0),(576597,16017,'el','ÎˆÎ½Î±ÏÎ¾Î·Ï‚ Ï„Î·Ï‚ Ï€ÎµÏÎ¹Î¿Î´Î¹ÎºÎ®Ï‚',0),(576598,16017,'zh','å®šæœŸä»Žå¼€å§‹',0),(576599,16017,'sv','Ã…terkommande startar pÃ¥',0),(576600,16017,'it','Ricorrenti inizia il',0),(576601,16017,'tl','',0),(576602,16017,'th','à¹€à¸£à¸´à¹ˆà¸¡à¹€à¸à¸´à¸”à¸‹à¹‰à¸³à¸šà¸™',0),(576603,16017,'hi','à¤ªà¤° à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤¶à¥à¤°à¥‚ à¤¹à¥‹à¤¤à¤¾ à¤¹à¥ˆ',0),(576604,16017,'ms','Berulang bermula pada',0),(576605,16017,'ar','ÙŠØ¨Ø¯Ø£ Ø§Ù„Ù…ØªÙƒØ±Ø±Ø© ÙÙŠ',0),(576606,16017,'fr','Mises en chantier rÃ©currents sur',0),(576607,16017,'jp','å®šæœŸçš„ãªé–‹å§‹',0),(576608,16017,'pt','ComeÃ§a recorrente na',0),(576609,16017,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð½Ð°Ñ‡Ð¸Ð½Ð°ÐµÑ‚ÑÑ Ð½Ð°',0),(576610,16017,'es','Recurrente, comienza a',0),(576611,16017,'de','Wiederkehrende beginnt am',0),(576612,16017,'en','Recurring Starts On',0),(576613,16018,'is','',0),(576614,16018,'dr','Ø¢Ø®Ø±ÛŒÙ† Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø¨Ù‡ ØªØ§Ø±ÛŒØ®',0),(576615,16018,'pr','Ø¢Ø®Ø±ÛŒÙ† Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡ Ø¨Ù‡ ØªØ§Ø±ÛŒØ®',0),(576616,16018,'tr','Son Tarih iÃ§in Tarih',0),(576617,16018,'pl','Ostatnio opublikowane do tej pory',0),(576618,16018,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¾ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ ÐºÑŠÐ¼ Ð´Ð°Ñ‚Ð°',0),(576619,16018,'ur','Ø¢Ø®Ø±ÛŒ ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(576620,16018,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿ÑƒÑ‚ Ð±Ð¸Ð¾ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½ Ð´Ð°Ñ‚ÑƒÐ¼',0),(576621,16018,'vi','Má»›i Ä‘Æ°á»£c Ä‘Äƒng vÃ o ngÃ y',0),(576622,16018,'af','Laaste datum gepos',0),(576623,16018,'ro','Ultimele postat la data',0),(576624,16018,'et','Viimati sisestatud kuupÃ¤ev',0),(576625,16018,'si','Nazadnje objavil datum',0),(576626,16018,'ba','Terakhir dikirim untuk tanggal',0),(576627,16018,'nl','Laatst gepost tot nu toe',0),(576628,16018,'fi','Viimeksi lÃ¤hetetty tÃ¤hÃ¤n mennessÃ¤',0),(576629,16018,'no','Sist skrevet ennÃ¥',0),(576630,16018,'da','Sidst indsendt til dato',0),(576631,16018,'ko','ë§ˆì§€ë§‰ìœ¼ë¡œ ê²Œì‹œ ë‚ ì§œ',0),(576632,16018,'he','×œ××—×¨×•× ×” ×¤×•×¨×¡× ×¢×“ ×›×”',0),(576633,16018,'el','Î”Î·Î¼Î¿ÏƒÎ¹ÎµÏÏ„Î·ÎºÎµ Ï„Î¿ Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ Î¼Î­Ï‡ÏÎ¹ ÏƒÎ®Î¼ÎµÏÎ±',0),(576634,16018,'zh','æœ€åŽåˆ°æ—¥æœŸçš„è¿‡å¸',0),(576635,16018,'sv','Senast Inlagd hittills',0),(576636,16018,'it','Ultimo pubblicato fino ad oggi',0),(576637,16018,'tl','',0),(576638,16018,'th','à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸¥à¹ˆà¸²à¸ªà¸¸à¸” à¸§à¸±à¸™à¸—à¸µà¹ˆ',0),(576639,16018,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¤à¤¿à¤¥à¤¿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(576640,16018,'ms','Buat dihantar kepada tarikh',0),(576641,16018,'ar','Ù…ÙˆÙ‚Ø¹ Ø¢Ø®Ø± Ù„Ù„ØªØ§Ø±ÙŠØ®',0),(576642,16018,'fr','DerniÃ¨re publication Ã  ce jour',0),(576643,16018,'jp','æœ€çµ‚æ—¥ã¾ã§ã«è»¢è¨˜',0),(576644,16018,'pt','Ãšltimo Postado atÃ© Ã  data',0),(576645,16018,'ru','Ð’ Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ñ€Ð°Ð· Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½Ñ‹ Ð½Ð° ÑÐµÐ³Ð¾Ð´Ð½ÑÑˆÐ½Ð¸Ð¹ Ð´ÐµÐ½ÑŒ',0),(576646,16018,'es','Ãšltimo publicado hasta la fecha',0),(576647,16018,'de','Zuletzt geschrieben bis heute',0),(576648,16018,'en','Last Posted To Date',0),(576649,16019,'is','',0),(576650,16019,'dr','Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø± Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¹ÙˆØ¶',0),(576651,16019,'pr','Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ø±ÙˆØ²Ù†Ú¯Ø§Ø± Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯ Ø¹ÙˆØ¶',0),(576652,16019,'tr','Bunun yerine standart gÃ¼nlÃ¼k girdisi oluÅŸtur',0),(576653,16019,'pl','Zamiast tego utworzyÄ‡ standardowy zapis ksiÄ™gowy',0),(576654,16019,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚ÐµÐ½ Ð´Ð½ÐµÐ²Ð½Ð¸Ðº Ð·Ð°Ð¿Ð¸Ñ Ð²Ð¼ÐµÑÑ‚Ð¾',0),(576655,16019,'ur','Ø§Ø³ Ú©ÛŒ Ø¨Ø¬Ø§Ø¦Û’ Ø§ÛŒÚ© Ù…Ø¹ÛŒØ§Ø±ÛŒ Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(576656,16019,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ ÑÑ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ ÑƒÐ¼ÐµÑÑ‚Ð¾ Ñ‚Ð¾Ð³Ð°',0),(576657,16019,'vi','Táº¡o má»™t má»¥c nháº­p Nháº­t kÃ½ chuáº©n Ä‘á»ƒ thay tháº¿',0),(576658,16019,'af','Skep eerder \'n standaard joernaal inskrywing',0),(576659,16019,'ro','CreaÅ£i o intrare Ã®n jurnal Standard Ã®n schimb',0),(576660,16019,'et','Selle asemel Standard pÃ¤evikukande loomine',0),(576661,16019,'si','Ustvarite vnos v dnevnik Standard namesto',0),(576662,16019,'ba','Membuat entri jurnal standar sebaliknya',0),(576663,16019,'nl','In plaats daarvan een standaard logboekitem maken',0),(576664,16019,'fi','Luo pÃ¤ivÃ¤kirjamerkintÃ¤ sen sijaan',0),(576665,16019,'no','Opprette en Standard oppfÃ¸ring i stedet',0),(576666,16019,'da','Oprette en Standard journaloptegnelse i stedet',0),(576667,16019,'ko','ëŒ€ì‹  í‘œì¤€ ì—…ë¬´ ì¼ì§€ í•­ëª© ë§Œë“¤ê¸°',0),(576668,16019,'he','×¦×•×¨ ×¢×¨×š ×™×•×ž×Ÿ ×¨×’×™×œ×” ×‘×ž×§×•×',0),(576669,16019,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î¼Î¹Î± ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ¹ÏƒÎ· Ï‡ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î±Î½Ï„Î¯',0),(576670,16019,'zh','æ”¹ä¸ºåˆ›å»ºæ ‡å‡†çš„æ—¥è®°æ¡ç›®',0),(576671,16019,'sv','Skapa en Standard journalpost istÃ¤llet',0),(576672,16019,'it','Creare una voce del diario Standard invece',0),(576673,16019,'tl','',0),(576674,16019,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¸¡à¸²à¸•à¸£à¸à¸²à¸™à¹à¸—à¸™',0),(576675,16019,'hi','à¤‡à¤¸à¤•à¥‡ à¤¬à¤œà¤¾à¤¯ à¤à¤• à¤®à¤¾à¤¨à¤• à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¬à¤¨à¤¾à¤à¤',0),(576676,16019,'ms','Mencipta kemasukan jurnal yang Standard yang sebaliknya',0),(576677,16019,'ar','Ø¨Ø¯Ù„Ø§Ù‹ Ù…Ù† Ø°Ù„Ùƒ Ø¨Ø¥Ù†Ø´Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø¯ÙØªØ± ÙŠÙˆÙ…ÙŠØ© Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(576678,16019,'fr','CrÃ©er une Ã©criture de Journal Standard Ã  la place',0),(576679,16019,'jp','ä»£ã‚ã‚Šã«ã€æ¨™æº–çš„ãªä»•è¨³ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(576680,16019,'pt','Criar uma entrada de diÃ¡rio padrÃ£o em vez disso',0),(576681,16019,'ru','Ð’Ð¼ÐµÑÑ‚Ð¾ ÑÑ‚Ð¾Ð³Ð¾ ÑÐ¾Ð·Ð´Ð°Ð¹Ñ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ñ‹Ð¹ Ð¶ÑƒÑ€Ð½Ð°Ð»',0),(576682,16019,'es','Crear una entrada de diario estÃ¡ndar en su lugar',0),(576683,16019,'de','Erstellen Sie stattdessen einen Standard Journaleintrag',0),(576684,16019,'en','Create A Standard Journal Entry Instead',0),(576685,16020,'is','',0),(576686,16020,'dr','ÙˆØ±ÙˆØ¯ÛŒ Ù…Ø¹Ú©ÙˆØ³',0),(576687,16020,'pr','ÙˆØ±ÙˆØ¯ÛŒ Ù…Ø¹Ú©ÙˆØ³',0),(576688,16020,'tr','Ters kayÄ±t giriÅŸi',0),(576689,16020,'pl','Wpis stornujÄ…cy',0),(576690,16020,'bg','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‰ Ð·Ð°Ð¿Ð¸Ñ',0),(576691,16020,'ur','ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(576692,16020,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð·Ð° ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ',0),(576693,16020,'vi','Äáº£o ngÆ°á»£c cÃ¡c má»¥c nháº­p',0),(576694,16020,'af','Omkeer inskrywing',0),(576695,16020,'ro','Intrare de stornare',0),(576696,16020,'et','Stornokanne',0),(576697,16020,'si','Storno postavko',0),(576698,16020,'ba','Membalikkan entri',0),(576699,16020,'nl','Omkering van de vermelding',0),(576700,16020,'fi','Takaisinkirjaus',0),(576701,16020,'no','TilbakefÃ¸ring',0),(576702,16020,'da','TilbagefÃ¸rsel',0),(576703,16020,'ko','í•­ëª© ë°˜ì „',0),(576704,16020,'he','×¢×¨×š ×”×™×¤×•×š',0),(576705,16020,'el','Î•Î³Î³ÏÎ±Ï†Î® Î±Î½Ï„Î¹Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(576706,16020,'zh','å†²é”€åˆ†å½•',0),(576707,16020,'sv','Ã…terfÃ¶ringspost',0),(576708,16020,'it','Voce di retromarcia',0),(576709,16020,'tl','',0),(576710,16020,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸à¸¥à¸±à¸šà¸šà¸±à¸à¸Šà¸µ',0),(576711,16020,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤ªà¥€à¤›à¥‡',0),(576712,16020,'ms','Menterbalikkan kemasukan',0),(576713,16020,'ar','Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø¹ÙƒÙˆØ³',0),(576714,16020,'fr','Inverseur dâ€™entrÃ©e',0),(576715,16020,'jp','ã‚¨ãƒ³ãƒˆãƒªã‚’åè»¢ã•ã›ã‚‹',0),(576716,16020,'pt','Invertendo a entrada',0),(576717,16020,'ru','Ð ÐµÐ²ÐµÑ€ÑÐ¸Ð²Ð½Ñ‹Ð¹ Ð²Ñ…Ð¾Ð´',0),(576718,16020,'es','Entrada de marcha atrÃ¡s',0),(576719,16020,'de','Umkehrbuchung',0),(576720,16020,'en','Reversing Entry',0),(576721,16021,'is','',0),(576722,16021,'dr','ØªØ§Ø±ÛŒØ® Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù…Ø¹Ú©ÙˆØ³',0),(576723,16021,'pr','ØªØ§Ø±ÛŒØ® Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù…Ø¹Ú©ÙˆØ³',0),(576724,16021,'tr','Ters hareket tarihi',0),(576725,16021,'pl','Cofania daty transakcji',0),(576726,16021,'bg','Ð—Ð°Ð´ÐµÐ½ Ð´Ð°Ñ‚Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(576727,16021,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ØªØ§Ø±ÛŒØ® ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(576728,16021,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°ÑšÐµ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(576729,16021,'vi','NgÃ y giao dá»‹ch Ä‘áº£o chiá»u',0),(576730,16021,'af','Omkeer transaksie datum',0),(576731,16021,'ro','Data tranzacÅ£iei de mers Ã®napoi',0),(576732,16021,'et','Tagurdamine kande kuupÃ¤ev',0),(576733,16021,'si','Vzvratno datum transakcije',0),(576734,16021,'ba','Membalikkan tanggal transaksi',0),(576735,16021,'nl','De datum van de transactie van het achteruitrijlicht',0),(576736,16021,'fi','Tapahtuman palautuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(576737,16021,'no','TilbakefÃ¸ringsdato for transaksjonen',0),(576738,16021,'da','Vende posteringsdato',0),(576739,16021,'ko','ë°˜ì „ íŠ¸ëžœìž­ì…˜ ë‚ ì§œ',0),(576740,16021,'he','×”×™×¤×•×š ×ª××¨×™×š ×ª× ×•×¢×”',0),(576741,16021,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î½Ï„Î¹Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(576742,16021,'zh','å†²é”€äº¤æ˜“è®°å½•æ—¥æœŸ',0),(576743,16021,'sv','Backning transaktionsdatum',0),(576744,16021,'it','Data della transazione di retromarcia',0),(576745,16021,'tl','',0),(576746,16021,'th','à¸§à¸±à¸™à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸—à¸µà¹ˆà¸à¸¥à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£',0),(576747,16021,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¥‡ à¤ªà¥€à¤›à¥‡',0),(576748,16021,'ms','Menterbalikkan tarikh urus niaga',0),(576749,16021,'ar','Ø¹ÙƒØ³ Ù…Ø³Ø§Ø± ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø±ÙƒØ©',0),(576750,16021,'fr','Marche arriÃ¨re Date de Transaction',0),(576751,16021,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã®æ—¥ä»˜ã‚’åè»¢',0),(576752,16021,'pt','Invertendo a data da transaÃ§Ã£o',0),(576753,16021,'ru','Ð ÐµÐ²ÐµÑ€ÑÐ¸Ð²Ð½Ñ‹Ð¹ Ð”Ð°Ñ‚Ð° ÑÐ´ÐµÐ»ÐºÐ¸',0),(576754,16021,'es','Fecha de la transacciÃ³n de inversiÃ³n',0),(576755,16021,'de','Buchungsdatum stornieren',0),(576756,16021,'en','Reversing Transaction Date',0),(576757,16022,'is','',0),(576758,16022,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØªÙˆØ³Ø· Ù„ØºÙˆ',0),(576759,16022,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØªÙˆØ³Ø· Ù„ØºÙˆ',0),(576760,16022,'tr','Zaten tarafÄ±ndan iptal edildi',0),(576761,16022,'pl','JuÅ¼ anulowane przez',0),(576762,16022,'bg','Ð’ÐµÑ‡Ðµ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð° Ð¾Ñ‚',0),(576763,16022,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(576764,16022,'sr','Ð’ÐµÑ› Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð¾',0),(576765,16022,'vi','ÄÃ£ bá»‹ há»§y bá» bá»Ÿi',0),(576766,16022,'af','Reeds gekanselleer deur',0),(576767,16022,'ro','Deja anulat de',0),(576768,16022,'et','Poolt tÃ¼histatud',0),(576769,16022,'si','Å½e preklical',0),(576770,16022,'ba','Sudah dibatalkan oleh',0),(576771,16022,'nl','Al geannuleerd door',0),(576772,16022,'fi','Jo peruutti',0),(576773,16022,'no','Allerede avbrutt av',0),(576774,16022,'da','Allerede annulleret af',0),(576775,16022,'ko','ì´ë¯¸ ì·¨ì†Œ',0),(576776,16022,'he','×›×‘×¨ ×‘×•×˜×œ×” ×¢×œ-×™×“×™',0),(576777,16022,'el','Î‰Î´Î· Î±ÎºÏ…ÏÏ‰Î¸ÎµÎ¯ Î±Ï€ÏŒ',0),(576778,16022,'zh','å·²ç»å–æ¶ˆäº†',0),(576779,16022,'sv','Redan avbrutits av',0),(576780,16022,'it','GiÃ  annullato dal',0),(576781,16022,'tl','',0),(576782,16022,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¹à¸¥à¹‰à¸§à¹‚à¸”à¸¢',0),(576783,16022,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(576784,16022,'ms','Telah dibatalkan oleh',0),(576785,16022,'ar','Ø§Ù„ÙØ¹Ù„ Ø¨Ø¥Ù„ØºØ§Ø¡',0),(576786,16022,'fr','DÃ©jÃ  annulÃ© par',0),(576787,16022,'jp','ã«ã‚ˆã£ã¦ã¯æ—¢ã«ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(576788,16022,'pt','JÃ¡ cancelei por',0),(576789,16022,'ru','Ð£Ð¶Ðµ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(576790,16022,'es','Ya cancelado por',0),(576791,16022,'de','Bereits abgebrochen, indem',0),(576792,16022,'en','Already Canceled By',0),(576793,16023,'is','',0),(576794,16023,'dr','Ø´Ù†Ø§Ø³Ù‡ Ú©Ø§Ø±Øª Ø±Ø§ Ù„ØºÙˆ Ù…ÛŒ Ú©Ù†Ø¯',0),(576795,16023,'pr','Ø´Ù†Ø§Ø³Ù‡ Ú©Ø§Ø±Øª Ø±Ø§ Ù„ØºÙˆ Ù…ÛŒ Ú©Ù†Ø¯',0),(576796,16023,'tr','FiÅŸ numarasÄ± iptal eder',0),(576797,16023,'pl','Anuluje Voucher ID',0),(576798,16023,'bg','ÐžÑ‚Ð¼ÐµÐ½Ñ Ð’Ð°ÑƒÑ‡ÑŠÑ€ ID',0),(576799,16023,'ur','ÙˆØ§Ø¤Ú†Ø± ID Ù…Ù†Ø³ÙˆØ®',0),(576800,16023,'sr','ÐžÑ‚ÐºÐ°Ð·ÑƒÑ˜Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð˜Ð”',0),(576801,16023,'vi','Há»§y bá» phiáº¿u ID',0),(576802,16023,'af','Kanselleer bewys ID',0),(576803,16023,'ro','AnuleazÄƒ Voucher ID',0),(576804,16023,'et','TÃ¼histab kande ID',0),(576805,16023,'si','PrekliÄe kupon ID',0),(576806,16023,'ba','Membatalkan Voucher ID',0),(576807,16023,'nl','Hiermee annuleert u de Voucher ID',0),(576808,16023,'fi','Peruuttaa Tositetunnus',0),(576809,16023,'no','Avbryter bilags-IDen',0),(576810,16023,'da','Annullerer Voucher-ID',0),(576811,16023,'ko','ë°”ìš°ì²˜ ID ì·¨ì†Œ',0),(576812,16023,'he','×‘×™×˜×•×œ ×©×•×‘×¨ ×ž×–×”×”',0),(576813,16023,'el','Î‘ÎºÏ…ÏÏŽÎ½ÎµÎ¹ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ ID',0),(576814,16023,'zh','å–æ¶ˆå‡­è¯ ID',0),(576815,16023,'sv','Avbryter Voucher ID',0),(576816,16023,'it','Annulla Voucher ID',0),(576817,16023,'tl','',0),(576818,16023,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸ ID',0),(576819,16023,'hi','Voucher ID à¤°à¤¦à¥à¤¦ à¤•à¤°à¤¤à¤¾ à¤¹à¥ˆ',0),(576820,16023,'ms','Membatalkan baucer ID',0),(576821,16023,'ar','Ø¥Ù„ØºØ§Ø¡ Ù…Ø¹Ø±Ù Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(576822,16023,'fr','Annule le bon ID',0),(576823,16023,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«ä¼ç¥¨ ID',0),(576824,16023,'pt','Cancela o Voucher ID',0),(576825,16023,'ru','ÐžÑ‚Ð¼ÐµÐ½ÑÐµÑ‚ Ð²Ð°ÑƒÑ‡ÐµÑ€ ID',0),(576826,16023,'es','Cancela vale ID',0),(576827,16023,'de','Bricht die Gutschein-ID',0),(576828,16023,'en','Cancels Voucher ID',0),(576829,16024,'is','',0),(576830,16024,'dr','Ø¹Ù…Ù„ Preform Ù†Ù…ÛŒ',0),(576831,16024,'pr','Ø¹Ù…Ù„ Preform Ù†Ù…ÛŒ',0),(576832,16024,'tr','Eylem Preform olamaz',0),(576833,16024,'pl','Moâ”esz wykonaÂµ akcji',0),(576834,16024,'bg','ÐÐµ Ð·Ð°Ð³Ð¾Ñ‚Ð¾Ð²ÐºÐ¸ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ',0),(576835,16024,'ur','Ø¹Ù…Ù„ Ù¾Ø±ÛŒÙØ¢Ø±Ù… Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(576836,16024,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° ÐŸÑ€ÐµÑ„Ð¾Ñ€Ð¼ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(576837,16024,'vi','KhÃ´ng thá»ƒ vÃ o hÃ nh Ä‘á»™ng',0),(576838,16024,'af','Aksie kan Preform',0),(576839,16024,'ro','Nu preforme acÅ£iune',0),(576840,16024,'et','Ei saa Preform tegevus',0),(576841,16024,'si','Ne more predoblik dejanje',0),(576842,16024,'ba','Tidak preform cetakan, topi aksi',0),(576843,16024,'nl','Actie niet kunt uitvoeren',0),(576844,16024,'fi','Ei esimuottien toiminta',0),(576845,16024,'no','Re handling',0),(576846,16024,'da','Kan ikke prÃ¦forme handling',0),(576847,16024,'ko','ì•¡ì…˜ì„ ì˜ˆë¹„ì  í˜•ì„± ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(576848,16024,'he','×œ× Preform ×¤×¢×•×œ×”',0),(576849,16024,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„ÏŒ Î½Î± ÎµÎºÏ„ÎµÎ»Î­ÏƒÎµÎ¹ Ï„Î· Î´ÏÎ¬ÏƒÎ·',0),(576850,16024,'zh','ä¸èƒ½é¢„åˆ¶æ£’è¡ŒåŠ¨',0),(576851,16024,'sv','Kan inte prestera Ã¥tgÃ¤rder',0),(576852,16024,'it','Non Ã¨ possibile Preform azione',0),(576853,16024,'tl','',0),(576854,16024,'th','Preform à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£',0),(576855,16024,'hi','à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤ªà¤¹à¤¿à¤²à¥‡ à¤¸à¥‡ à¤¬à¤¨à¤¾ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(576856,16024,'ms','Tidak boleh Preform tindakan',0),(576857,16024,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£Ù† Ø§Ù„ØªØ´ÙƒÙŠÙ„ Ø¹Ù…Ù„',0),(576858,16024,'fr','Ne peut pas prÃ©forme Action',0),(576859,16024,'jp','ã‚¢ã‚¯ã‚·ãƒ§ãƒ³ã‚’å®Ÿè¡Œã§ãã¾ã›ã‚“ã€‚',0),(576860,16024,'pt','NÃ£o posso prÃ©-forma aÃ§Ã£o',0),(576861,16024,'ru','ÐÐµÐ»ÑŒÐ·Ñ Ð¿Ñ€ÐµÑ„Ð¾Ñ€Ð¼ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ð¹',0),(576862,16024,'es','No se preforma de acciÃ³n',0),(576863,16024,'de','Preform-Aktion kann nicht',0),(576864,16024,'en','Cannot Perform Action',0),(576865,16025,'is','',0),(576866,16025,'dr','Ù„ØºÙˆ ÙˆØ±ÙˆØ¯ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡',0),(576867,16025,'pr','Ù„ØºÙˆ ÙˆØ±ÙˆØ¯ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡',0),(576868,16025,'tr','GiriÅŸi iptal etme oluÅŸturulan',0),(576869,16025,'pl','Utworzone, anulowanie wpis',0),(576870,16025,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´ÐµÐ½ Ð¾Ñ‚Ð¼ÐµÐ½ÑÐ½Ðµ Ð·Ð°Ð¿Ð¸Ñ',0),(576871,16025,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø±ÛØ§ ÛÛ’ Ù¾ÛŒØ¯Ø§',0),(576872,16025,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ð»Ð¸ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ°',0),(576873,16025,'vi','Táº¡o huá»· nháº­p cáº£nh',0),(576874,16025,'af','Kanselleer tans inskrywing geskep',0),(576875,16025,'ro','Creat de revocare intrare',0),(576876,16025,'et','Loodud kande tÃ¼histamine',0),(576877,16025,'si','Ustvaril preklic vstop',0),(576878,16025,'ba','Menciptakan membatalkan entri',0),(576879,16025,'nl','Gemaakt met het annuleren van de post',0),(576880,16025,'fi','Luotu peruuttaminen merkintÃ¤',0),(576881,16025,'no','Opprettet avbryter oppfÃ¸ring',0),(576882,16025,'da','Lavet annullerer posten',0),(576883,16025,'ko','ë§Œë“  í•­ëª© ì·¨ì†Œ',0),(576884,16025,'he','× ×•×¦×¨ ×‘×™×˜×•×œ ×¢×¨×š',0),(576885,16025,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î· Î±ÎºÏÏÏ‰ÏƒÎ· Ï„Î·Ï‚ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚',0),(576886,16025,'zh','åˆ›å»ºå–æ¶ˆæ¡ç›®',0),(576887,16025,'sv','Skapad avbryta transaktionen',0),(576888,16025,'it','Creato l\'annullamento voce',0),(576889,16025,'tl','',0),(576890,16025,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸à¸²à¸£à¸¢à¸à¹€à¸¥à¸´à¸',0),(576891,16025,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ à¤¬à¤¨à¤¾à¤¯à¤¾',0),(576892,16025,'ms','Dicipta membatalkan penyertaan',0),(576893,16025,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„',0),(576894,16025,'fr','CrÃ©Ã© annulation dâ€™entrÃ©e',0),(576895,16025,'jp','ä½œæˆã—ãŸã‚¨ãƒ³ãƒˆãƒªã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(576896,16025,'pt','Criado cancelando a entrada',0),(576897,16025,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½, Ð¾Ñ‚Ð¼ÐµÐ½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(576898,16025,'es','Creado cancelaciÃ³n de entrada',0),(576899,16025,'de','Abbrechen-Eintrag erstellt',0),(576900,16025,'en','Created Canceling Entry',0),(576901,16026,'is','',0),(576902,16026,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ø¬Ø¯ÛŒØ¯ ÙˆØ±ÙˆØ¯ Ù„ØºÙˆ',0),(576903,16026,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ø¬Ø¯ÛŒØ¯ ÙˆØ±ÙˆØ¯ Ù„ØºÙˆ',0),(576904,16026,'tr','Yeni giriÅŸi iptal etme oluÅŸturur',0),(576905,16026,'pl','Tworzy nowy anulowanie wpisu',0),(576906,16026,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð° Ð½Ð¾Ð²Ð¸ Ð¾Ñ‚Ð¼ÐµÐ½ÑÐ½Ðµ Ð·Ð°Ð¿Ð¸Ñ',0),(576907,16026,'ur','Ù†ÛŒØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ù†Ø³ÙˆØ® Ú©Ø±Ù†Ø§ Ø¨Ù†Ø§ØªØ§ ÛÛ’',0),(576908,16026,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð° Ð½Ð¾Ð²Ð¸ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ°',0),(576909,16026,'vi','Táº¡o má»›i huá»· nháº­p cáº£nh',0),(576910,16026,'af','Skep nuwe kansellasie van inskrywing',0),(576911,16026,'ro','CreeazÄƒ noi revocare intrare',0),(576912,16026,'et','Loob uue kande tÃ¼histamine',0),(576913,16026,'si','Ustvari novo preklic vstop',0),(576914,16026,'ba','Menciptakan baru membatalkan entri',0),(576915,16026,'nl','Hiermee maakt u nieuwe post annuleren',0),(576916,16026,'fi','Luo uusi peruuttaminen merkintÃ¤',0),(576917,16026,'no','Oppretter ny avbryter oppfÃ¸ring',0),(576918,16026,'da','Skaber nye annullerer posten',0),(576919,16026,'ko','ìƒˆë¡œìš´ ì·¨ì†Œ í•˜ëŠ” í•­ëª©ì„ ë§Œë“­ë‹ˆë‹¤.',0),(576920,16026,'he','×™×•×¦×¨ ×—×“×© ×‘×™×˜×•×œ ×¢×¨×š',0),(576921,16026,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯ Î½Î­Î± Î±ÎºÏÏÏ‰ÏƒÎ· ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(576922,16026,'zh','åˆ›å»ºæ–°å–æ¶ˆæ¡ç›®',0),(576923,16026,'sv','Skapar nya avbryta transaktionen',0),(576924,16026,'it','Crea nuovo annullamento di voce',0),(576925,16026,'tl','',0),(576926,16026,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸«à¸¡à¹ˆà¸¢à¸à¹€à¸¥à¸´à¸à¸£à¸²à¸¢à¸à¸²à¸£',0),(576927,16026,'hi','à¤¨à¤ˆ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤°à¤¦à¥à¤¦ à¤¬à¤¨à¤¾à¤¤à¤¾ à¤¹à¥ˆ',0),(576928,16026,'ms','Mencipta baru membatalkan penyertaan',0),(576929,16026,'ar','ÙŠÙ‚ÙˆÙ… Ø¨Ø¥Ù„ØºØ§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø¬Ø¯ÙŠØ¯',0),(576930,16026,'fr','CrÃ©e le nouveau annulation dâ€™entrÃ©e',0),(576931,16026,'jp','ä½œæˆã™ã‚‹æ–°ã—ã„ã‚¨ãƒ³ãƒˆãƒªã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(576932,16026,'pt','Cria novo cancelamento de entrada',0),(576933,16026,'ru','Ð¡Ð¾Ð·Ð´Ð°ÐµÑ‚ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¾Ñ‚Ð¼ÐµÐ½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(576934,16026,'es','Crea nueva cancelaciÃ³n de entrada',0),(576935,16026,'de','Schafft neue Eingabe abbrechen',0),(576936,16026,'en','Creates New Canceling Entry',0),(576937,16027,'is','',0),(576938,16027,'dr','Ø­Ø°Ù ÙˆØ±ÙˆØ¯ÛŒ Ø¨Ù‡ Ù„ØºÙˆ Ø§ÙˆÙ„',0),(576939,16027,'pr','Ø­Ø°Ù ÙˆØ±ÙˆØ¯ÛŒ Ø¨Ù‡ Ù„ØºÙˆ Ø§ÙˆÙ„',0),(576940,16027,'tr','Ä°lk giriÅŸi iptal etme Sil',0),(576941,16027,'pl','UsunÄ…Ä‡, anulowanie wpis pierwszy',0),(576942,16027,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹Ñ‚Ðµ Ð¿ÑŠÑ€Ð²Ð¾ Ð¾Ñ‚Ð¼ÐµÐ½ÑÐ½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸Ñ',0),(576943,16027,'ur','Ø³Ø¨ Ø³Û’ Ù¾ÛÙ„Û’ Ø¯Ø§Ø®Ù„Û’ Ù…Ù†Ø³ÙˆØ® Ú©Ø±Ù†Ø§ Ø­Ø°Ù Ú©Ø±ÛŒÚº',0),(576944,16027,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸Ñ‚Ðµ Ð¿Ñ€Ð²Ð¾ Ð¾Ñ‚ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ°',0),(576945,16027,'vi','XÃ³a bá» há»§y bá» má»¥c nháº­p Ä‘áº§u tiÃªn',0),(576946,16027,'af','Skrap kansellasie van eerste inskrywing',0),(576947,16027,'ro','Åžtergere revocare prima intrare',0),(576948,16027,'et','Kustutage esmalt kande tÃ¼histamine',0),(576949,16027,'si','Izbrisati, ukinitev vstopa najprej',0),(576950,16027,'ba','Menghapus membatalkan entri pertama',0),(576951,16027,'nl','Verwijderen annuleren item eerst',0),(576952,16027,'fi','Deletoida, epuuttaa tapahtuma ensin',0),(576953,16027,'no','Slette avbryte oppfÃ¸ringen fÃ¸rst',0),(576954,16027,'da','Slette annullerer posten fÃ¸rst',0),(576955,16027,'ko','í•­ëª©ì„ ë¨¼ì € ì·¨ì†Œ ì‚­ì œ',0),(576956,16027,'he','×ž×—×§ ×‘×™×˜×•×œ ×›× ×™×¡×” ×¨××©×™×ª',0),(576957,16027,'el','Î‘ÎºÏÏÏ‰ÏƒÎ· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚ Ï€ÏÏŽÏ„Î± Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ',0),(576958,16027,'zh','åˆ é™¤ç¬¬ä¸€æ¬¡å–æ¶ˆå…¥å¢ƒ',0),(576959,16027,'sv','Ta bort avbryta transaktionen fÃ¶rst',0),(576960,16027,'it','Eliminare e annullare prima voce',0),(576961,16027,'tl','',0),(576962,16027,'th','à¸¥à¸šà¸à¸²à¸£à¸¢à¸à¹€à¸¥à¸´à¸à¸£à¸²à¸¢à¸à¸²à¸£à¹à¸£à¸',0),(576963,16027,'hi','à¤ªà¤¹à¤²à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¹à¤Ÿà¤¾à¤à¤',0),(576964,16027,'ms','Menghapuskan membatalkan penyertaan pertama',0),(576965,16027,'ar','Ø­Ø°Ù Ø¥Ù„ØºØ§Ø¡ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø£ÙˆÙ„Ø§Ù‹',0),(576966,16027,'fr','Supprimer lâ€™annulation tout dâ€™abord dâ€™entrÃ©e',0),(576967,16027,'jp','æœ€åˆã®ã‚¨ãƒ³ãƒˆãƒªã‚’ã‚­ãƒ£ãƒ³ã‚»ãƒ«ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(576968,16027,'pt','Excluir cancelar entrada primeiro',0),(576969,16027,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ, Ð¾Ñ‚Ð¼ÐµÐ½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸ ÑÐ½Ð°Ñ‡Ð°Ð»Ð°',0),(576970,16027,'es','Borrar cancelar entrada primero',0),(576971,16027,'de','LÃ¶schen, Eintrag zunÃ¤chst abbrechen',0),(576972,16027,'en','Delete Canceling Entry First',0),(576973,16028,'is','',0),(576974,16028,'dr','Ø§ÛŒÙ† Ù…Ø·Ù„Ø¨ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯ Ùˆ ØªØºÛŒÛŒØ±Ø§Øª Ø±Ø§ Ø¨Ù‡ Ú©ÙˆÙ¾Ù† Orignal',0),(576975,16028,'pr','Ø§ÛŒÙ† Ù…Ø·Ù„Ø¨ Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯ Ùˆ ØªØºÛŒÛŒØ±Ø§Øª Ø±Ø§ Ø¨Ù‡ Ú©ÙˆÙ¾Ù† Orignal',0),(576976,16028,'tr','Bu girdiyi silmek ve deÄŸiÅŸiklik yapma Orignal fiÅŸ',0),(576977,16028,'pl','UsuÅ„ ten wpis i wprowadzanie zmian do zaÅ‚Ä…cznika Orignal',0),(576978,16028,'bg','Ð˜Ð·Ñ‚Ñ€Ð¸Ð¹Ñ‚Ðµ Ñ‚Ð¾Ð·Ð¸ Ð·Ð°Ð¿Ð¸Ñ Ð¸ Ð½Ð°Ð¿Ñ€Ð°Ð²ÐµÑ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð² Orignal Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(576979,16028,'ur','ÛŒÛ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø­Ø°Ù Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ø¨Ù†Ø§Ù†Û’ Ú©Û’ Ø§ÙˆØ±ÛŒÚ¯Ù†Ø§Ù„ ÙˆØ§Ø¤Ú†Ø± Ú©Û’ Ù„Ø¦Û’ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ØªØ§ ÛÛ’',0),(576980,16028,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ Ð¸ Ð½Ð°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð½Ð° Ð½Ð°Ñ‚Ñ€Ð°Ð³',0),(576981,16028,'vi','XÃ³a má»¥c nÃ y vÃ  thá»±c hiá»‡n thay Ä‘á»•i Orignal Voucher',0),(576982,16028,'af','Skrap hierdie inskrywing en maak veranderinge aan die Orignal bewys',0),(576983,16028,'ro','È˜tergeÈ›i aceastÄƒ intrare ÅŸi de a face modificÄƒri la documentul justificativ Orignal',0),(576984,16028,'et','Selle kirje kustutamiseks ja Orignal kande muutmine',0),(576985,16028,'si','Izbrisati ta vnos in spremeniti Orignal kupon',0),(576986,16028,'ba','Menghapus entri ini dan membuat perubahan untuk Orignal Voucher',0),(576987,16028,'nl','Verwijder deze vermelding en wijzigingen aanbrengen in de Orignal Voucher',0),(576988,16028,'fi','Poistaa tÃ¤mÃ¤n ja tehdÃ¤ muutoksia Orignal tosite',0),(576989,16028,'no','Slette denne oppfÃ¸ringen og gjÃ¸re endringer i bilaget Orignal',0),(576990,16028,'da','Slet denne lÃ¸sning og foretage Ã¦ndringer af originalkilden Voucher',0),(576991,16028,'ko','ì´ í•­ëª©ì„ ì‚­ì œ í•˜ ê³  í™•ì¸ Orignal ë°”ìš°ì²˜ë¡œ ë³€ê²½',0),(576992,16028,'he','×œ×ž×—×•×§ ××ª ×”×¤×•×¡×˜ ×”×–×”, ×œ×¢×¨×•×š ×©×™× ×•×™×™× ×”×©×•×‘×¨ ×”×’× ×•×¡×˜×™×¦×˜×™×ª',0),(576993,16028,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î·Î½ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÎºÎ±Î¹ ÎºÎ¬Î½Ï„Îµ Î±Î»Î»Î±Î³Î­Ï‚ ÏƒÏ„Î¿ Orignal voucher',0),(576994,16028,'zh','åˆ é™¤æ­¤æ¡ç›®ï¼Œå¹¶å¯¹åŽŸå§‹å‡­è¯è¿›è¡Œæ›´æ”¹',0),(576995,16028,'sv','Ta bort denna post och gÃ¶ra Ã¤ndringar i den ursprungliga verifikationen',0),(576996,16028,'it','Eliminare questa voce e apportare modifiche al giustificativo di Orignal',0),(576997,16028,'tl','',0),(576998,16028,'th','à¸¥à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸™à¸µà¹‰ à¹à¸¥à¸°à¸—à¸³à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸à¸±à¸šà¹ƒà¸šà¸ªà¸³à¸„à¸±à¸ Orignal',0),(576999,16028,'hi','à¤‡à¤¸ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¨à¥‡ à¤”à¤° à¤¬à¤¨à¤¾à¤¨à¥‡ Orignal à¤µà¤¾à¤‰à¤šà¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(577000,16028,'ms','Hapuskan Entri ini dan membuat perubahan untuk baucar Orignal',0),(577001,16028,'ar','Ø­Ø°Ù Ù‡Ø°Ø§ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„ØŒ ÙˆØ¥Ø¬Ø±Ø§Ø¡ ØªØºÙŠÙŠØ±Ø§Øª Ù„Ù„Ø¥ÙŠØµØ§Ù„ Orignal',0),(577002,16028,'fr','Supprimer cette entrÃ©e et apporter des modifications Ã  lâ€™Orignal bon',0),(577003,16028,'jp','ã“ã®ã‚¨ãƒ³ãƒˆãƒªã‚’å‰Šé™¤ã—ã€ã‚ªãƒªã‚¸ãƒŠãƒ«ã®ä¼ç¥¨ã«å¤‰æ›´ã‚’åŠ ãˆã¾ã™',0),(577004,16028,'pt','Excluir esta entrada e fazer alteraÃ§Ãµes para o Voucher Orignal',0),(577005,16028,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚Ðµ ÑÑ‚Ñƒ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¸ Ð²Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð² Orignal Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(577006,16028,'es','Eliminar esta entrada y hacer cambios en el vale de Orignal',0),(577007,16028,'de','LÃ¶schen Sie diesen Eintrag und nehmen Sie Ã„nderungen an der Orignal-Gutschein',0),(577008,16028,'en','Delete This Entry And Make Changes To The Orignal Voucher',0),(577009,16029,'is','',0),(577010,16029,'dr','Ø§ÛŒÙ† Ú©ÙˆÙ¾Ù† Ø§Ù…Ú©Ø§Ù† ÙˆÛŒØ±Ø§ÛŒØ´',0),(577011,16029,'pr','Ø§ÛŒÙ† Ú©ÙˆÙ¾Ù† Ø§Ù…Ú©Ø§Ù† ÙˆÛŒØ±Ø§ÛŒØ´',0),(577012,16029,'tr','Bu fiÅŸ dÃ¼zenlenemez',0),(577013,16029,'pl','Nie moÅ¼na edytowaÄ‡ tego kuponu',0),(577014,16029,'bg','Ð¢Ð¾Ð·Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¼Ð¾Ð¶Ðµ Ð´Ð° ÑÐµ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°',0),(577015,16029,'ur','Ø§Ø³ ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©ØªÛŒ',0),(577016,16029,'sr','ÐžÐ²Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ð° ÑÐµ Ð½Ðµ Ð¼Ð¾Ð³Ñƒ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°Ñ‚Ð¸.',0),(577017,16029,'vi','Voucher nÃ y khÃ´ng thá»ƒ Ä‘Æ°á»£c chá»‰nh sá»­a',0),(577018,16029,'af','Hierdie bewys kan nie geredigeer word',0),(577019,16029,'ro','Acest Voucher poate fi editat',0),(577020,16029,'et','Seda kannet ei saa redigeerida',0),(577021,16029,'si','To bon ni mogoÄe urejati',0),(577022,16029,'ba','Voucher ini tidak dapat diedit',0),(577023,16029,'nl','Deze Voucher kan niet worden bewerkt',0),(577024,16029,'fi','TÃ¤mÃ¤ Tositetta ei voi muokata',0),(577025,16029,'no','Dette bilaget ikke kan redigeres',0),(577026,16029,'da','Denne Voucher kan ikke redigeres',0),(577027,16029,'ko','ì´ ë°”ìš°ì²˜ë¥¼ íŽ¸ì§‘í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(577028,16029,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×¢×¨×•×š ××ª ×”×©×•×‘×¨ ×”×–×”',0),(577029,16029,'el','Î‘Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯',0),(577030,16029,'zh','æ­¤åˆ¸ä¸èƒ½ç¼–è¾‘',0),(577031,16029,'sv','Denna Voucher kan inte redigeras',0),(577032,16029,'it','Questo Voucher non puÃ² essere modificato',0),(577033,16029,'tl','',0),(577034,16029,'th','à¸šà¸±à¸•à¸£à¸à¸³à¸™à¸±à¸¥à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹à¸à¹‰à¹„à¸‚',0),(577035,16029,'hi','à¤‡à¤¸ à¤µà¤¾à¤‰à¤šà¤° à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(577036,16029,'ms','Baucar ini tidak boleh diedit',0),(577037,16029,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­Ø±ÙŠØ± Ù‡Ø°Ø§ Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(577038,16029,'fr','Ce coupon ne peut pas Ãªtre modifiÃ©',0),(577039,16029,'jp','ã“ã®ä¼ç¥¨ã‚’ç·¨é›†ã§ãã¾ã›ã‚“ã€‚',0),(577040,16029,'pt','Este Voucher nÃ£o pode ser editado.',0),(577041,16029,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½',0),(577042,16029,'es','Este bono no puede ser editado',0),(577043,16029,'de','Dieser Gutschein kann nicht bearbeitet werden',0),(577044,16029,'en','This Voucher Cannot Be Edited',0),(577045,16030,'is','',0),(577046,16030,'dr','Ø¨Ø±Ø§ÛŒ ØªØºÛŒÛŒØ±',0),(577047,16030,'pr','Ø¨Ø±Ø§ÛŒ ØªØºÛŒÛŒØ±',0),(577048,16030,'tr','DeÄŸiÅŸtirmek iÃ§in',0),(577049,16030,'pl','Aby zmodyfikowaÄ‡',0),(577050,16030,'bg','Ð—Ð° Ð¼Ð¾Ð´Ð¸Ñ„Ð¸Ñ†Ð¸Ñ€Ð°Ð½Ðµ',0),(577051,16030,'ur','ØªØ±Ù…ÛŒÙ… Ú©Û’ Ù„ÛŒÛ’',0),(577052,16030,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ð»Ð¸',0),(577053,16030,'vi','Äá»ƒ sá»­a Ä‘á»•i',0),(577054,16030,'af','Te wysig',0),(577055,16030,'ro','Pentru a modifica',0),(577056,16030,'et','Muuta',0),(577057,16030,'si','ÄŒe Å¾elite spremeniti',0),(577058,16030,'ba','Untuk mengubah',0),(577059,16030,'nl','Om te wijzigen',0),(577060,16030,'fi','Voit muokata',0),(577061,16030,'no','Endre',0),(577062,16030,'da','At Ã¦ndre',0),(577063,16030,'ko','ìˆ˜ì • í•˜ë ¤ë©´',0),(577064,16030,'he','×›×“×™ ×œ×©× ×•×ª',0),(577065,16030,'el','Î“Î¹Î± Î½Î± Ï„ÏÎ¿Ï€Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ',0),(577066,16030,'zh','è‹¥è¦ä¿®æ”¹',0),(577067,16030,'sv','Att Ã¤ndra',0),(577068,16030,'it','Per modificare',0),(577069,16030,'tl','',0),(577070,16030,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™',0),(577071,16030,'hi','à¤¸à¤‚à¤¶à¥‹à¤§à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(577072,16030,'ms','Untuk mengubah suai',0),(577073,16030,'ar','Ù„ØªØ¹Ø¯ÙŠÙ„',0),(577074,16030,'fr','Pour modifier les',0),(577075,16030,'jp','å¤‰æ›´ã™ã‚‹ã®ã«ã¯',0),(577076,16030,'pt','Para modificar',0),(577077,16030,'ru','Ð”Ð»Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(577078,16030,'es','Para modificar',0),(577079,16030,'de','Ã„ndern',0),(577080,16030,'en','To Modify',0),(577081,16031,'is','',0),(577082,16031,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú©Ø§Ø±Øª ØªÙˆØ³Ø· Ø§ÛŒÙ† Ú©ÙˆÙ¾Ù† Ù„ØºÙˆ',0),(577083,16031,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú©Ø§Ø±Øª ØªÙˆØ³Ø· Ø§ÛŒÙ† Ú©ÙˆÙ¾Ù† Ù„ØºÙˆ',0),(577084,16031,'tr','Bu fiÅŸe gÃ¶re iptal gÃ¶rÃ¼nÃ¼mÃ¼ fiÅŸ',0),(577085,16031,'pl','Zobacz kupon anulowane przez ten kupon',0),(577086,16031,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð²Ð°ÑƒÑ‡ÐµÑ€, Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð° Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(577087,16031,'ur','Ù…Ù†Ø¸Ø± ÙˆØ§Ø¤Ú†Ø± Ø§Ø³ ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(577088,16031,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð¾ Ð¾Ð²Ð¾Ð³ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(577089,16031,'vi','Xem phiáº¿u bá»‹ há»§y bá» bá»Ÿi phiáº¿u nÃ y',0),(577090,16031,'af','Bekyk bewys deur hierdie bewys gekanselleer',0),(577091,16031,'ro','Vezi Voucher anulate prin acest Voucher',0),(577092,16031,'et','Saate vaadata kandeteavet tÃ¼histatud kÃ¤esoleva kande jÃ¤rgi',0),(577093,16031,'si','Ogled kupona preklical ta kupon',0),(577094,16031,'ba','Lihat Voucher dibatalkan oleh Voucher ini',0),(577095,16031,'nl','Weergave Voucher geannuleerd door deze Voucher',0),(577096,16031,'fi','NÃ¤ytÃ¤ tosite peruuttaa TÃ¤mÃ¤ tosite',0),(577097,16031,'no','Vis bilaget avbrutt av dette bilaget',0),(577098,16031,'da','Se Voucher annulleret af denne kupon',0),(577099,16031,'ko','ì´ ì¦ì„œì— ì˜í•´ ì·¨ì†Œ ë³´ê¸° ë°”ìš°ì²˜',0),(577100,16031,'he','× ×•×£ ×©×•×‘×¨ ×‘×•×˜×œ×” ×¢×œ-×™×“×™ ×©×•×‘×¨ ×–×”',0),(577101,16031,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎºÎ¿Ï…Ï€Î¿Î½Î¹Î¿Ï Î±ÎºÏ…ÏÏ‰Î¸ÎµÎ¯ Î±Ï€ÏŒ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(577102,16031,'zh','æŸ¥çœ‹å‡­è¯å–æ¶ˆæ­¤å‡­è¯',0),(577103,16031,'sv','Visa verifikationen avbrutits av denna verifikation',0),(577104,16031,'it','Visualizza Voucher annullata da questo Voucher',0),(577105,16031,'tl','',0),(577106,16031,'th','à¸”à¸¹à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸—à¸µà¹ˆà¸¢à¸à¹€à¸¥à¸´à¸à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸™à¸µà¹‰',0),(577107,16031,'hi','à¤‡à¤¸ à¤µà¤¾à¤‰à¤šà¤° à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤°à¤¦à¥à¤¦ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¦à¥ƒà¤¶à¥à¤¯ à¤µà¤¾à¤‰à¤šà¤°',0),(577108,16031,'ms','Dibatalkan oleh Baucer ini baucer View',0),(577109,16031,'ar','Ø¹Ø±Ø¶ Ù‚Ø³ÙŠÙ…Ø© Ø¨Ø¥Ù„ØºØ§Ø¡ Ù‡Ø°Ø§ Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(577110,16031,'fr','Bon vue annulÃ©e par ce bon',0),(577111,16031,'jp','ã“ã®ãƒã‚¦ãƒãƒ£ãƒ¼ã«ã‚ˆã£ã¦ã‚­ãƒ£ãƒ³ã‚»ãƒ«è¡¨ç¤ºã‚¯ãƒ¼ãƒãƒ³',0),(577112,16031,'pt','Voucher de exibiÃ§Ã£o cancelada por este Voucher',0),(577113,16031,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð²Ð°ÑƒÑ‡ÐµÑ€, Ð¾Ñ‚Ð¼ÐµÐ½Ð¸Ð» ÑÑ‚Ð¾Ñ‚ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(577114,16031,'es','Vale vista cancelada este bono',0),(577115,16031,'de','Ansicht-Gutschein abgebrochen, indem dieser Gutschein',0),(577116,16031,'en','View Voucher Canceled By This Voucher',0),(577117,16032,'is','',0),(577118,16032,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú©ÙˆÙ¾Ù† Ø§ÛŒÙ† Ú©ÙˆÙ¾Ù† Ø¨Ø§ Ù„ØºÙˆ',0),(577119,16032,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ú©ÙˆÙ¾Ù† Ø§ÛŒÙ† Ú©ÙˆÙ¾Ù† Ø¨Ø§ Ù„ØºÙˆ',0),(577120,16032,'tr','Bu fiÅŸi tarafÄ±ndan iptal gÃ¶rÃ¼nÃ¼mÃ¼ fiÅŸ',0),(577121,16032,'pl','Voucher widok, ten kupon jest anulowane przez',0),(577122,16032,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ñ‚Ð¾Ð·Ð¸ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ðµ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð° Ð¾Ñ‚',0),(577123,16032,'ur','Ù…Ù†Ø¸Ø± ÙˆØ§Ø¤Ú†Ø± Ø§Ø³ ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§ ÛÛ’',0),(577124,16032,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¾Ð²Ð°Ñ˜ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð¾',0),(577125,16032,'vi','Xem phiáº¿u Voucher nÃ y bá»‹ há»§y bá» bá»Ÿi',0),(577126,16032,'af','Bekyk bewys hierdie bewys Is deur gekanselleer',0),(577127,16032,'ro','Vezi Voucher acest Voucher este anulat de',0),(577128,16032,'et','Saate vaadata kandeteavet see kanne on tÃ¼histatud',0),(577129,16032,'si','Ogled kupona ta kupon je preklical',0),(577130,16032,'ba','Lihat Voucher Voucher ini dibatalkan oleh',0),(577131,16032,'nl','Weergave Voucher die deze Voucher wordt geannuleerd door',0),(577132,16032,'fi','NÃ¤ytÃ¤ tosite TÃ¤mÃ¤ tosite on peruutettu',0),(577133,16032,'no','Vis bilaget dette bilaget er avbrutt av',0),(577134,16032,'da','Se Voucher denne Voucher er annulleret af',0),(577135,16032,'ko','ì´ ì¦ì„œëŠ” ì·¨ì†Œ ë³´ê¸° ë°”ìš°ì²˜',0),(577136,16032,'he','× ×•×£ ×©×•×‘×¨ ×©×•×‘×¨ ×–×” ×‘×•×˜×œ ×¢×œ ×™×“×™',0),(577137,16032,'el','Î ÏÎ¿Î²Î¿Î»Î® ÎºÎ¿Ï…Ï€Î¿Î½Î¹Î¿Ï Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(577138,16032,'zh','æŸ¥çœ‹å‡­è¯ï¼Œè¯¥å‡­è¯å·²è¢«å–æ¶ˆ',0),(577139,16032,'sv','Visa verifikationen denna verifikation avbryts av',0),(577140,16032,'it','Voucher di vista che questo Voucher viene annullato dal',0),(577141,16032,'tl','',0),(577142,16032,'th','à¸”à¸¹à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸™à¸µà¹‰à¸–à¸¹à¸à¸¢à¸à¹€à¸¥à¸´à¸à¹‚à¸”à¸¢',0),(577143,16032,'hi','à¤‡à¤¸ à¤µà¤¾à¤‰à¤šà¤° à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤°à¤¦à¥à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾ à¤¹à¥ˆ à¤¦à¥ƒà¤¶à¥à¤¯ à¤µà¤¾à¤‰à¤šà¤°',0),(577144,16032,'ms','Paparan baucer baucar ini dibatalkan oleh',0),(577145,16032,'ar','Ø¹Ø±Ø¶ Ù‚Ø³ÙŠÙ…Ø© Ù‡Ùˆ Ø¥Ù„ØºØ§Ø¡ Ù‡Ø°Ø§ Ø§Ù„Ø¥ÙŠØµØ§Ù„ Ù…Ù† Ù‚Ø¨Ù„',0),(577146,16032,'fr','Bon de voir par que ce Voucher est annulÃ©',0),(577147,16032,'jp','ã“ã®ãƒã‚¦ãƒãƒ£ãƒ¼ã¯ã«ã‚ˆã£ã¦å–ã‚Šæ¶ˆã•ã‚Œã¾ã™è¡¨ç¤ºã‚¯ãƒ¼ãƒãƒ³',0),(577148,16032,'pt','Voucher de vista por que este Voucher Ã© cancelada',0),(577149,16032,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€ Ð²Ð°ÑƒÑ‡ÐµÑ€, ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ð¹ ÑÑ‚Ð¾Ñ‚ Ð²Ð°ÑƒÑ‡ÐµÑ€ Ð¾Ñ‚Ð¼ÐµÐ½ÑÐµÑ‚ÑÑ',0),(577150,16032,'es','Vale vista por que este bono es cancelado',0),(577151,16032,'de','Ansicht-Gutschein, die diesen Gutschein von abgebrochen wird',0),(577152,16032,'en','View Voucher This Voucher Is Canceled By',0),(577153,16033,'is','',0),(577154,16033,'dr','Ú©ÙˆÙ¾Ù† ØªÚ©Ø±Ø§Ø±ÛŒ Ø§Ø³Øª',0),(577155,16033,'pr','Ú©ÙˆÙ¾Ù† ØªÚ©Ø±Ø§Ø±ÛŒ Ø§Ø³Øª',0),(577156,16033,'tr','FiÅŸ yinelenen',0),(577157,16033,'pl','Voucher jest cykliczne',0),(577158,16033,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ÑŠÑ‚ Ðµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¾',0),(577159,16033,'ur','ÙˆØ§Ø¤Ú†Ø± Ù…Ú©Ø±Ø± ÛÛ’',0),(577160,16033,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ ÑÐµ Ð¿Ð¾Ð½Ð°Ð²Ñ™Ð°.',0),(577161,16033,'vi','Phiáº¿u mua hÃ ng lÃ  Ä‘á»‹nh ká»³',0),(577162,16033,'af','Bewys Is herhalende',0),(577163,16033,'ro','Bonul este periodicÄƒ',0),(577164,16033,'et','Kanne on korduv',0),(577165,16033,'si','Kupon je ponavljajoÄe se',0),(577166,16033,'ba','Voucher berulang',0),(577167,16033,'nl','Waardebon terugkerend',0),(577168,16033,'fi','Tosite on toistuva',0),(577169,16033,'no','Bilaget er regelmessig',0),(577170,16033,'da','Voucher er tilbagevendende',0),(577171,16033,'ko','ë°”ìš°ì²˜ ë˜í’€ì´',0),(577172,16033,'he','×©×•×‘×¨ ×”×™× ×—×•×–×¨×ª',0),(577173,16033,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ ÎµÎ¯Î½Î±Î¹ Ï€ÎµÏÎ¹Î¿Î´Î¹ÎºÎ®',0),(577174,16033,'zh','å‡­è¯é‡å¤',0),(577175,16033,'sv','Verifikationen Ã¥terkommande',0),(577176,16033,'it','Voucher Ã¨ ricorrente',0),(577177,16033,'tl','',0),(577178,16033,'th','à¹€à¸à¸´à¸”à¸‹à¹‰à¸³à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸',0),(577179,16033,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤¹à¥ˆ',0),(577180,16033,'ms','Baucer berulang',0),(577181,16033,'ar','Ù‡Ùˆ Ù…ØªÙƒØ±Ø± Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(577182,16033,'fr','Bon est rÃ©current',0),(577183,16033,'jp','ã‚¯ãƒ¼ãƒãƒ³ã¯å®šæœŸçš„ãª',0),(577184,16033,'pt','Voucher Ã© recorrente.',0),(577185,16033,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(577186,16033,'es','Vale es recurrente',0),(577187,16033,'de','Gutschein ist wiederkehrend',0),(577188,16033,'en','Voucher Is Recurring',0),(577189,16034,'is','',0),(577190,16034,'dr','ØªÙ…Ø§Ù… Ù…Ø¬Ù„Ø§Øª Unposted Ø¨Ù‡ Ù…Ø§Ù‡ Ù…Ø·Ù„Ø¨ Ù¾Ø³Øª Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(577191,16034,'pr','ØªÙ…Ø§Ù… Ù…Ø¬Ù„Ø§Øª Unposted Ø¨Ù‡ Ù…Ø§Ù‡ Ù…Ø·Ù„Ø¨ Ù¾Ø³Øª Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯',0),(577192,16034,'tr','TÃ¼m deftere nakledilmemiÅŸ GÃ¼nlÃ¼kler iÃ§in giriÅŸ ay yayÄ±nlayacaÄŸÄ±z',0),(577193,16034,'pl','Wszystkie niezaksiÄ™gowane arkusze po miesiÄ…cu WejÅ›cia',0),(577194,16034,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð´Ð½ÐµÐ²Ð½Ð¸Ñ†Ð¸ Ð·Ð° Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ñ‰Ðµ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´Ð¸ ÐºÑŠÐ¼ Ð¼ÐµÑÐµÑ† Ð¾Ñ‚ Ð²Ð»Ð¸Ð·Ð°Ð½ÐµÑ‚Ð¾',0),(577195,16034,'ur','ØªÙ…Ø§Ù… Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ Ø¬Ø±Ù†Ù„ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ù…ÛÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ Ø´Ø§Ø¦Ø¹ Ú©Ø±ÛŒÚº Ú¯Û’',0),(577196,16034,'sr','Ð¡Ð²Ð¸ ÐÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸ Ð½Ð°Ð»Ð¾Ð·Ð¸ Ñ›Ðµ ÑÐµ ÐºÑšÐ¸Ð¶Ð¸Ñ‚Ð¸ Ð½Ð° Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð° ÑƒÐ»Ð°ÑÐºÐ°',0),(577197,16034,'vi','Táº¥t cáº£ cÃ¡c tin bÃ i sáº½ chÆ°a Ä‘Æ°á»£c Ä‘Äƒng táº¡p chÃ­ thÃ¡ng nháº­p cáº£nh',0),(577198,16034,'af','Alle Unposted joernale sal plaas na maand van inskrywing',0),(577199,16034,'ro','Toate jurnalele neÃ®nregistrate va Ã®nregistra pentru luna de intrare',0),(577200,16034,'et','KÃµigi sisestamata tÃ¶Ã¶lehti konteerib kuu kanne',0),(577201,16034,'si','NeknjiÅ¾en vse temeljnice, knjiÅ¾i na mesec zaÄetka',0),(577202,16034,'ba','Semua Unposted jurnal akan memposting ke bulan masuk',0),(577203,16034,'nl','Alle niet-doorgevoerde tijdschriften zal naar maand van invoer posten',0),(577204,16034,'fi','Kaikki kirjaamattomat kirjauskansiot kirjaa kuukauden',0),(577205,16034,'no','Alle ikke-posterte journaler bokfÃ¸res pÃ¥ mÃ¥neden oppfÃ¸ring',0),(577206,16034,'da','Alle ikke-bogfÃ¸rte kladder bogfÃ¸res pÃ¥ mÃ¥ned af post',0),(577207,16034,'ko','ëª¨ë“  ê²Œì‹œ ì €ë„ í•­ëª©ì˜ ë‹¬ ê²Œì‹œí•  ì˜ˆì •ìž…ë‹ˆë‹¤.',0),(577208,16034,'he','× ×¤×¨×¡× ×™×•×ž× ×™× ×©×œ× × ×¨×©×ž×• ×›×œ ×—×•×“×© ×‘×¢×¨×š',0),(577209,16034,'el','ÎŒÎ»Î± Ï„Î± Î¼Î· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½Î± Ï€ÎµÏÎ¹Î¿Î´Î¹ÎºÎ¬ Î¸Î± Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏ…Î¸Î¿ÏÎ½ Î¿Î¹ Î¼Î®Î½Î± ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(577210,16034,'zh','æ‰€æœ‰æœªè¿‡å¸çš„æ—¥è®°å¸å°†è¿‡å¸åˆ°æœˆçš„æ¡ç›®',0),(577211,16034,'sv','Alla bokfÃ¶rda journaler bokfÃ¶rs till mÃ¥nad trÃ¤der',0),(577212,16034,'it','Tutte le riviste non registrate pubblicherÃ  fino al mese di entrata',0),(577213,16034,'tl','',0),(577214,16034,'th','à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¹„à¸”à¹‰à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸ˆà¸°à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸‚à¸­à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(577215,16034,'hi','à¤¸à¤­à¥€ Unposted à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤°à¥‡à¤‚à¤—à¥‡',0),(577216,16034,'ms','Semua jurnal Unposted akan pos ke bulan kemasukan',0),(577217,16034,'ar','Ø³ÙŠØªÙ… Ù†Ø´Ø± Ø¬Ù…ÙŠØ¹ Ø¯ÙØ§ØªØ± ÙŠÙˆÙ…ÙŠØ© ØºÙŠØ± Ø§Ù„Ù…Ù†Ø´ÙˆØ±Ø© Ù„Ù„Ø´Ù‡Ø± Ù„Ù„Ø¯Ø®ÙˆÙ„',0),(577218,16034,'fr','Toutes les revues non comptabilisÃ©es publiera au mois dâ€™entrÃ©e',0),(577219,16034,'jp','ã™ã¹ã¦ã®æœªé€ä¿¡ä»•è¨³å¸³ã‚¨ãƒ³ãƒˆãƒªã®æœˆã«æŽ²è¼‰ã™ã‚‹äºˆå®š',0),(577220,16034,'pt','Todas as revistas nÃ£o lanÃ§adas vou postar para o mÃªs de entrada',0),(577221,16034,'ru','Ð’ÑÐµ Ð½ÐµÐ¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð¶ÑƒÑ€Ð½Ð°Ð»Ñ‹ Ð±ÑƒÐ´ÑƒÑ‚ Ñ€Ð°Ð·Ð¼ÐµÑ‰Ð°Ñ‚ÑŒ Ð½Ð° Ð¼ÐµÑÑÑ† Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(577222,16034,'es','Todas las revistas a publicar al mes de entrada',0),(577223,16034,'de','An Monat Eintrag werden alle nicht gebuchte Zeitschriften verÃ¶ffentlicht.',0),(577224,16034,'en','All Unposted Journals Will Post To Month Of Entry',0),(577225,16035,'is','',0),(577226,16035,'dr','Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø±',0),(577227,16035,'pr','Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø±',0),(577228,16035,'tr','El ile',0),(577229,16035,'pl','RÄ™cznie',0),(577230,16035,'bg','Ð ÑŠÐºÐ¾Ð²Ð¾Ð´ÑÑ‚Ð²Ð¾',0),(577231,16035,'ur','ÛØ¯Ø§ÛŒØª Ù†Ø§Ù…Û',0),(577232,16035,'sr','ÐŸÑ€Ð¸Ñ€ÑƒÑ‡Ð½Ð¸Ðº',0),(577233,16035,'vi','HÆ°á»›ng dáº«n sá»­ dá»¥ng',0),(577234,16035,'af','Handleiding',0),(577235,16035,'ro','Manualul',0),(577236,16035,'et','KÃ¤siraamat',0),(577237,16035,'si','PriroÄnik',0),(577238,16035,'ba','Manual',0),(577239,16035,'nl','Handmatig',0),(577240,16035,'fi','KÃ¤sikirja',0),(577241,16035,'no','Manuell',0),(577242,16035,'da','Manual',0),(577243,16035,'ko','ìˆ˜ë™',0),(577244,16035,'he','×™×“× ×™',0),(577245,16035,'el','Î•Î³Ï‡ÎµÎ¹ÏÎ¯Î´Î¹Î¿',0),(577246,16035,'zh','æ‰‹åŠ¨',0),(577247,16035,'sv','Handbok',0),(577248,16035,'it','Manuale',0),(577249,16035,'tl','',0),(577250,16035,'th','à¸”à¹‰à¸§à¸¢à¸•à¸™à¹€à¸­à¸‡',0),(577251,16035,'hi','à¤®à¥ˆà¤¨à¥à¤…à¤²',0),(577252,16035,'ms','Manual',0),(577253,16035,'ar','Ø¯Ù„ÙŠÙ„',0),(577254,16035,'fr','Manuelle',0),(577255,16035,'jp','æ‰‹å‹•',0),(577256,16035,'pt','Manual',0),(577257,16035,'ru','Ð’Ñ€ÑƒÑ‡Ð½ÑƒÑŽ',0),(577258,16035,'es','Manual',0),(577259,16035,'de','Manuell',0),(577260,16035,'en','Manual',0),(577261,16036,'is','',0),(577262,16036,'dr','Ù…Ù†ØªØ®Ø¨ Ù…Ø¬Ù„Ù‡ Unposted Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ø¨Ù‡ Ù…Ø§Ù‡ Ù…Ø·Ù„Ø¨',0),(577263,16036,'pr','Ù…Ù†ØªØ®Ø¨ Ù…Ø¬Ù„Ù‡ Unposted Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ø¨Ù‡ Ù…Ø§Ù‡ Ù…Ø·Ù„Ø¨',0),(577264,16036,'tr','SeÃ§ili deftere nakledilmemiÅŸ GÃ¼nlÃ¼kler Will Post ay giriÅŸ iÃ§in',0),(577265,16036,'pl','Post bÄ™dzie wybrany niezaksiÄ™gowane arkusze do miesiÄ…ca WejÅ›cia',0),(577266,16036,'bg','ÐŸÐ¾Ð´Ð±Ñ€Ð°Ð½Ð¸ Ð½Ð° Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸Ñ‚Ðµ Ð´Ð½ÐµÐ²Ð½Ð¸Ñ†Ð¸ Ñ‰Ðµ Ð¿Ð¾ÑÑ‚ Ð½Ð° Ð¼ÐµÑÐµÑ† Ð¾Ñ‚ Ð²Ð»Ð¸Ð·Ð°Ð½ÐµÑ‚Ð¾',0),(577267,16036,'ur','Ù…Ù†ØªØ®Ø¨ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ù…ÛÛŒÙ†Û’ Ú©Ùˆ Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ Ø¬Ø±Ù†Ù„ Ú¯Ø§ Ù¾ÙˆØ³Ù¹ Ú©Ø±ÛŒÚº',0),(577268,16036,'sr','ÐŸÐ¾ÑÑ‚ Ð²Ð¾Ñ™Ñƒ Ð½ÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð½Ð°Ð»Ð¾Ð³Ðµ Ð·Ð° Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð° ÑƒÐ»Ð°ÑÐºÐ°',0),(577269,16036,'vi','CÃ¡c táº¡p chÃ­ sáº½ Ä‘Äƒng thÃ¡ng cá»§a má»¥c Ä‘Æ°á»£c chá»n',0),(577270,16036,'af','Geselekteerde Unposted joernale sal Post na maand van inskrywing',0),(577271,16036,'ro','Jurnale neÃ®ncÄƒrcate selectate va Post luna de intrare',0),(577272,16036,'et','Valitud sisestamata tÃ¶Ã¶lehti tahe Post kuu kanne',0),(577273,16036,'si','Izbrani neknjiÅ¾enih revij bo Post mesec zaÄetka',0),(577274,16036,'ba','Jurnal Unposted yang dipilih akan posting untuk bulan masuk',0),(577275,16036,'nl','Geselecteerde niet-doorgevoerde tijdschriften Will Post naar maand van invoer',0),(577276,16036,'fi','Valitun kirjaamattomat kirjauskansiot tulee postitse kuukausi',0),(577277,16036,'no','Valgt ikke-posterte journaler vil innlegget mÃ¥neden oppfÃ¸ring',0),(577278,16036,'da','Udvalgte ikke-bogfÃ¸rte kladder vil Post til mÃ¥ned af post',0),(577279,16036,'ko','ì„ íƒí•œ ê²Œì‹œ ì €ë„ ì§€ ê²Œì‹œë¬¼ í•­ëª©ì˜ ë‹¬',0),(577280,16036,'he','×™×•×ž× ×™× ×©×œ× × ×¨×©×ž×• × ×‘×—×¨×•×ª ×¤×•×¡×˜ ×•×•×™×œ ×œ×—×•×“×© ×‘×¢×¨×š',0),(577281,16036,'el','Î•Ï€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î¼Î· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î¸Î± Post Î½Î± Î¼Î®Î½Î± ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(577282,16036,'zh','é€‰æ‹©æœªè¿‡å¸çš„æ—¥è®°å¸å°†å‘˜é¢æ”¹æœˆçš„æ¡ç›®',0),(577283,16036,'sv','Valda ej bokfÃ¶rda journaler kommer Post till mÃ¥nad trÃ¤der',0),(577284,16036,'it','Selezionato non registrate riviste volontÃ  Post fino al mese di entrata',0),(577285,16036,'tl','',0),(577286,16036,'th','à¹€à¸¥à¸·à¸­à¸à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™à¹„à¸”à¹‰à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸ˆà¸°à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸”à¸·à¸­à¸™à¸‚à¸­à¸‡à¸£à¸²à¸¢à¸à¸²à¸£',0),(577287,16036,'hi','à¤šà¤¯à¤¨à¤¿à¤¤ Unposted à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤•à¥‡ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¹à¥‹à¤—à¤¾ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(577288,16036,'ms','Jurnal Unposted terpilih akan pos ke bulan kemasukan',0),(577289,16036,'ar','ØªØ­Ø¯ÙŠØ¯ ÙˆØ¸ÙŠÙØ© Ø§Ù„Ø¥Ø±Ø§Ø¯Ø© Ø§Ù„ÙŠÙˆÙ…ÙŠØ§Øª ØºÙŠØ± Ø§Ù„Ù…Ù†Ø´ÙˆØ±Ø© Ù„Ù„Ø´Ù‡Ø± Ù„Ù„Ø¯Ø®ÙˆÙ„',0),(577290,16036,'fr','Certaines revues non comptabilisÃ©es Will Post au mois dâ€™entrÃ©e',0),(577291,16036,'jp','ã‚¨ãƒ³ãƒˆãƒªã®æœˆã«æœªé€ä¿¡ã®é›‘èªŒãŒè¨˜äº‹ã‚’é¸æŠž',0),(577292,16036,'pt','Post de Will selecionadas nÃ£o lanÃ§adas revistas para o mÃªs de entrada',0),(577293,16036,'ru','Ð’Ñ‹Ð±Ñ€Ð°Ð½Ð½Ñ‹Ðµ Ð½ÐµÐ¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð¶ÑƒÑ€Ð½Ð°Ð»Ð¾Ð² Ð±ÑƒÐ´ÐµÑ‚ Ð¿Ð¾ÑÑ‚ Ð² Ð¼ÐµÑÑÑ† Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(577294,16036,'es','Revistas seleccionadas sin contabilizar voluntad Post al mes de entrada',0),(577295,16036,'de','Nicht gebuchte Zeitschriften wird Post zum Monat der Eintrag ausgewÃ¤hlt',0),(577296,16036,'en','Selected Unposted Journals Will Post To Month Of Entry',0),(577297,16037,'is','',0),(577298,16037,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø­Ø§Ù„Øª',0),(577299,16037,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø­Ø§Ù„Øª',0),(577300,16037,'tr','Modu seÃ§in',0),(577301,16037,'pl','Wybierz tryb',0),(577302,16037,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ€ÐµÐ¶Ð¸Ð¼',0),(577303,16037,'ur','Ù…ÙˆÚˆ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(577304,16037,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ€ÐµÐ¶Ð¸Ð¼',0),(577305,16037,'vi','Chá»n cháº¿ Ä‘á»™',0),(577306,16037,'af','Kies \'n modus',0),(577307,16037,'ro','SelectaÅ£i modul',0),(577308,16037,'et','Valige reÅ¾iim',0),(577309,16037,'si','Izberite naÄin',0),(577310,16037,'ba','Pilih Mode',0),(577311,16037,'nl','Selecteer modus',0),(577312,16037,'fi','Valitse tila',0),(577313,16037,'no','Velg modus',0),(577314,16037,'da','VÃ¦lg tilstand',0),(577315,16037,'ko','ëª¨ë“œ ì„ íƒ',0),(577316,16037,'he','×‘×—×¨ ×ž×¦×‘',0),(577317,16037,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î»ÎµÎ¹Ï„Î¿Ï…ÏÎ³Î¯Î±',0),(577318,16037,'zh','é€‰æ‹©æ¨¡å¼',0),(577319,16037,'sv','VÃ¤lj lÃ¤ge',0),(577320,16037,'it','Selezionare la modalitÃ ',0),(577321,16037,'tl','',0),(577322,16037,'th','à¹€à¸¥à¸·à¸­à¸à¹‚à¸«à¸¡à¸”',0),(577323,16037,'hi','à¤®à¥‹à¤¡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(577324,16037,'ms','Pilih mod',0),(577325,16037,'ar','ØªØ­Ø¯ÙŠØ¯ ÙˆØ¶Ø¹',0),(577326,16037,'fr','SÃ©lectionnez le Mode',0),(577327,16037,'jp','ãƒ¢ãƒ¼ãƒ‰ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(577328,16037,'pt','Selecione o modo',0),(577329,16037,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ñ€ÐµÐ¶Ð¸Ð¼',0),(577330,16037,'es','Seleccionar el modo de',0),(577331,16037,'de','WÃ¤hlen Sie den Modus',0),(577332,16037,'en','Select Mode',0),(577333,16038,'is','',0),(577334,16038,'dr','Unpost Ù‡Ù…Ù‡ Ú©ÙˆÙ¾Ù† Ø¨Ù‡ Ù…Ø§Ù‡ Ø®Ø§Øµ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(577335,16038,'pr','Unpost Ù‡Ù…Ù‡ Ú©ÙˆÙ¾Ù† Ø¨Ù‡ Ù…Ø§Ù‡ Ø®Ø§Øµ Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(577336,16038,'tr','TÃ¼m fiÅŸler belirli bir aya gÃ¶nderildi unpost',0),(577337,16038,'pl','Unpost wszystkie zaÅ‚Ä…czniki zamieszczone na dany miesiÄ…c',0),(577338,16038,'bg','Unpost Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸, Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ ÐºÑŠÐ¼ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½ Ð¼ÐµÑÐµÑ†',0),(577339,16038,'ur','Ù…ÛŒÚº Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ø§ÛŒÚ© Ù…Ø®ØµÙˆØµ Ù…Ø§Û Ø³Û’ ØªÙ…Ø§Ù… ÙˆÙˆÚ†Ø±Ø² Ø§Ù†Ù¾ÙˆØ³Ù¹',0),(577340,16038,'sr','ÐŸÐ¾Ð²ÑƒÐ¸Ðµ ÑÐ²Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ Ñƒ Ð¾Ð´Ñ€ÐµÑ’ÐµÐ½Ð¾Ð¼ Ð¼ÐµÑÐµÑ†Ñƒ',0),(577341,16038,'vi','Unpost táº¥t cáº£ chá»©ng tá»« gá»­i cho má»™t thÃ¡ng cá»¥ thá»ƒ',0),(577342,16038,'af','Unpost alle bewyse aan \'n spesifieke maand gepos',0),(577343,16038,'ro','Unpost toate voucherele postat la o anumitÄƒ lunÄƒ',0),(577344,16038,'et','KÃµik kanded konteeritakse konkreetse kuus unpost',0),(577345,16038,'si','Unpost vse kupone Objavljeno poseben mesec',0),(577346,16038,'ba','Unpost semua voucher yang dikirim sebulan tertentu',0),(577347,16038,'nl','Unpost alle Vouchers Gepost naar een specifieke maand',0),(577348,16038,'fi','Unpost Kaikki tositteet kirjataan tietyn kuukauden',0),(577349,16038,'no','Unpost alle bilag posteres til en bestemt mÃ¥ned',0),(577350,16038,'da','Unpost alle gavekort sendt til en bestemt mÃ¥ned',0),(577351,16038,'ko','íŠ¹ì • ì›”ì— ê²Œì‹œ ëœ ëª¨ë“  ìƒí’ˆê¶Œ unpost',0),(577352,16038,'he','Unpost ×›×œ ×”×©×•×‘×¨×™× ×¤×•×¨×¡× ×œ×—×•×“×© ×¡×¤×¦×™×¤×™',0),(577353,16038,'el','Unpost ÏŒÎ»Î± Ï„Î± ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î± Ï€Î¿Ï… Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏ„Î·ÎºÎµ ÏƒÎµ Î­Î½Î± ÏƒÏ…Î³ÎºÎµÎºÏÎ¹Î¼Î­Î½Î¿ Î¼Î®Î½Î±',0),(577354,16038,'zh','Unpost æ‰€æœ‰å‡­è¯è¿‡å¸åˆ°ä¸€ä¸ªç‰¹å®šçš„æœˆ',0),(577355,16038,'sv','Unpost alla verifikationer bokfÃ¶rs en viss mÃ¥nad',0),(577356,16038,'it','Unpost tutti i voucher inviati a un mese specifico',0),(577357,16038,'tl','',0),(577358,16038,'th','Unpost à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸—à¸µà¹ˆà¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹ƒà¸™à¹€à¸”à¸·à¸­à¸™à¹ƒà¸”à¹€à¸”à¸·à¸­à¸™à¸«à¸™à¸¶à¹ˆà¸‡',0),(577359,16038,'hi','à¤¸à¤­à¥€ à¤µà¤¾à¤‰à¤šà¤° à¤à¤• à¤µà¤¿à¤¶à¤¿à¤·à¥à¤Ÿ à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¨à¤¾à¤¤ unpost',0),(577360,16038,'ms','Unpost semua baucar kepada satu bulan tertentu',0),(577361,16038,'ar','Ø£ÙˆÙ†Ø¨ÙˆØ³Øª ÙƒØ§ÙØ© Ø§Ù„Ø¥ÙŠØµØ§Ù„Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… ØªØ±Ø­ÙŠÙ„Ù‡Ø§ Ø¥Ù„Ù‰ Ø´Ù‡Ø± Ù…Ø¹ÙŠÙ†',0),(577362,16038,'fr','Unpost toutes les piÃ¨ces justificatives, postÃ©s Ã  un mois spÃ©cifique',0),(577363,16038,'jp','ç‰¹å®šã®æœˆã«æŽ²è¼‰ã®ã™ã¹ã¦ã®ä¼ç¥¨ã‚’é–¢é€£ä»˜ã‘ãŸã‚Š',0),(577364,16038,'pt','Unpost todos os Vouchers postados para um mÃªs especÃ­fico',0),(577365,16038,'ru','Unpost Ð²ÑÐµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹, Ð½Ð°Ð¿Ð¸ÑÐ°Ð» Ð´Ð»Ñ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð½Ð¾Ð³Ð¾ Ð¼ÐµÑÑÑ†Ð°',0),(577366,16038,'es','Unpost todos vales publicados para un mes especÃ­fico',0),(577367,16038,'de','Alle Gutscheine, die in einem bestimmten Monat gepostet unpost',0),(577368,16038,'en','Unpost All Vouchers Posted To A Specific Month',0),(577369,16039,'is','',0),(577370,16039,'dr','Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ù†Ø´Ø¯',0),(577371,16039,'pr','Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ù†Ø´Ø¯',0),(577372,16039,'tr','Maliyet kodu bulunamadÄ±',0),(577373,16039,'pl','Koszt kodu nie znaleziono',0),(577374,16039,'bg','Ð Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÐºÐ¾Ð´ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(577375,16039,'ur','Ù‚ÛŒÙ…Øª Ø¶Ø§Ø¨Ø·Û Ù†ÛÛŒÚº Ù¾Ø§ÛŒØ§',0),(577376,16039,'sr','Ð¢Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¨Ð¸Ñ„Ñ€Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°',0),(577377,16039,'vi','MÃ£ sá»‘ chi phÃ­ khÃ´ng Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(577378,16039,'af','Koste kode nie gevind nie',0),(577379,16039,'ro','Cost cod nu a fost gÄƒsit',0),(577380,16039,'et','Kulu kood ei leitud',0),(577381,16039,'si','StroÅ¡kovno kode ni bilo mogoÄe najti',0),(577382,16039,'ba','Kode biaya tidak ditemukan',0),(577383,16039,'nl','Kosten Code niet gevonden',0),(577384,16039,'fi','Kustannuskoodi ei lÃ¶ydy',0),(577385,16039,'no','Kostnader som blir ikke funnet',0),(577386,16039,'da','Cost kode blev ikke fundet',0),(577387,16039,'ko','ë¹„ìš©ëœ ì½”ë“œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(577388,16039,'he','×§×•×“ ×¢×œ×•×ª ×œ× × ×ž×¦×',0),(577389,16039,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(577390,16039,'zh','æ‰¾ä¸åˆ°çš„æˆæœ¬çš„ä»£ç ',0),(577391,16039,'sv','Kostnad kod hittades inte',0),(577392,16039,'it','Codice di costo non trovato',0),(577393,16039,'tl','',0),(577394,16039,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(577395,16039,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(577396,16039,'ms','Kod kos tidak dijumpai',0),(577397,16039,'ar','Ø§Ù„ØªÙƒÙ„ÙØ© Ø±Ù…Ø² Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(577398,16039,'fr','CoÃ»t Code introuvable',0),(577399,16039,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(577400,16039,'pt','Custo cÃ³digo nÃ£o encontrado',0),(577401,16039,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(577402,16039,'es','Costo cÃ³digo no encontrado',0),(577403,16039,'de','Kostencode nicht gefunden',0),(577404,16039,'en','Cost Code Not Found',0),(577405,16040,'is','',0),(577406,16040,'dr','GL Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø±Ø§ Ø§ÛŒØ¬Ø§Ø¯',0),(577407,16040,'pr','GL Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø±Ø§ Ø§ÛŒØ¬Ø§Ø¯',0),(577408,16040,'tr','GL hareketleri oluÅŸturma',0),(577409,16040,'pl','Nie naleÅ¼y tworzyÄ‡ transakcje GL',0),(577410,16040,'bg','ÐÐµ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ñ‚ GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸Ñ‚Ðµ',0),(577411,16040,'ur','Ø¬ÛŒØ¬Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚ Ù†ÛÛŒÚº ÛÙˆØªÛŒ',0),(577412,16040,'sr','ÐÐµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñƒ Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(577413,16040,'vi','KhÃ´ng táº¡o ra cÃ¡c giao dá»‹ch GL',0),(577414,16040,'af','GL transaksies skep nie',0),(577415,16040,'ro','Crea GL tranzacÅ£ii',0),(577416,16040,'et','GL kannete loomine',0),(577417,16040,'si','Ne ustvarjajo GL transakcije',0),(577418,16040,'ba','Jangan membuat transaksi GL',0),(577419,16040,'nl','Maak geen GL transacties',0),(577420,16040,'fi','Ã„lÃ¤ luo GL tapahtumat',0),(577421,16040,'no','Ikke Opprett GL transaksjoner',0),(577422,16040,'da','Opret ikke GL transaktioner',0),(577423,16040,'ko','GL íŠ¸ëžœìž­ì…˜ì„ ë§Œë“¤ì§€ ë§ˆì‹­ì‹œì˜¤',0),(577424,16040,'he','××œ ×ª×™×¦×•×¨ ×ª× ×•×¢×•×ª GL',0),(577425,16040,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ Î³/Î»',0),(577426,16040,'zh','ä¸åˆ›å»ºæ€»è´¦äº¤æ˜“è®°å½•',0),(577427,16040,'sv','Skapa inte GL transaktioner',0),(577428,16040,'it','Non creare transazioni di contabilitÃ  generale',0),(577429,16040,'tl','',0),(577430,16040,'th','à¹„à¸¡à¹ˆà¸ªà¸£à¹‰à¸²à¸‡à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(577431,16040,'hi','GL à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤¨à¤¹à¥€à¤‚ à¤¬à¤¨à¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(577432,16040,'ms','Tidak membuat urus niaga GL',0),(577433,16040,'ar','Ù„Ø§ ØªÙ‚Ù… Ø¨Ø¥Ù†Ø´Ø§Ø¡ Ø­Ø±ÙƒØ§Øª GL',0),(577434,16040,'fr','Ne crÃ©ez pas de Transactions de GL',0),(577435,16040,'jp','GL ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã‚’ä½œæˆã—ãªã„ã§ãã ã•ã„ã€‚',0),(577436,16040,'pt','NÃ£o criar transaÃ§Ãµes de GL',0),(577437,16040,'ru','ÐÐµ ÑÐ¾Ð·Ð´Ð°Ð²Ð°Ð¹Ñ‚Ðµ GL ÑÐ´ÐµÐ»Ð¾Ðº',0),(577438,16040,'es','No crean las transacciones GL',0),(577439,16040,'de','Erstelle keine GL Transaktionen',0),(577440,16040,'en','Do Not Create GL Transactions',0),(577441,16041,'is','',0),(577442,16041,'dr','GL Ø±Ø¯Ù‡ Ù†Ø´Ø¯',0),(577443,16041,'pr','GL Ø±Ø¯Ù‡ Ù†Ø´Ø¯',0),(577444,16041,'tr','GL kategori bulunamadÄ±',0),(577445,16041,'pl','GL kategorii nie znaleziono',0),(577446,16041,'bg','GL ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÑ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð°',0),(577447,16041,'ur','Ø¬ÛŒØ¬Û’ Ø²Ù…Ø±Û Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(577448,16041,'sr','Ð“Ð› ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°',0),(577449,16041,'vi','GL má»¥c khÃ´ng tÃ¬m tháº¥y',0),(577450,16041,'af','GL kategorie nie gevind nie',0),(577451,16041,'ro','GL categorie nu a fost gÄƒsit',0),(577452,16041,'et','GL kategooriat ei leitud',0),(577453,16041,'si','GL kategorije ni bilo mogoÄe najti',0),(577454,16041,'ba','GL kategori tidak ditemukan',0),(577455,16041,'nl','GL categorie niet gevonden',0),(577456,16041,'fi','GL luokkaa ei lÃ¶ydy',0),(577457,16041,'no','GL kategori ikke funnet',0),(577458,16041,'da','GL kategori ikke fundet',0),(577459,16041,'ko','GL ë²”ì£¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(577460,16041,'he','×§×˜×’×•×¨×™×” GL ×œ× × ×ž×¦×',0),(577461,16041,'el','GL ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(577462,16041,'zh','æ‰¾ä¸åˆ°çš„ GL ç±»åˆ«',0),(577463,16041,'sv','GL kategori hittades inte',0),(577464,16041,'it','GL categoria non trovata',0),(577465,16041,'tl','',0),(577466,16041,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸›à¸£à¸°à¹€à¸ à¸— GL',0),(577467,16041,'hi','GL à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¥€',0),(577468,16041,'ms','Kategori GL yang tidak dijumpai',0),(577469,16041,'ar','Ø§Ù„ÙØ¦Ø© GL Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰',0),(577470,16041,'fr','CatÃ©gorie GL introuvable',0),(577471,16041,'jp','GL ã‚«ãƒ†ã‚´ãƒªãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(577472,16041,'pt','Categoria GL nÃ£o encontrada',0),(577473,16041,'ru','GL ÐšÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°',0),(577474,16041,'es','CategorÃ­a GL no encontrado',0),(577475,16041,'de','GL-Kategorie nicht gefunden',0),(577476,16041,'en','GL Category Not Found',0),(577477,16042,'is','',0),(577478,16042,'dr','Ú©Ø§Ø±Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÛŒØ¯Ø§',0),(577479,16042,'pr','Ú©Ø§Ø±Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾ÛŒØ¯Ø§',0),(577480,16042,'tr','KartÄ± iÃ§in satÄ±cÄ± bulunamadÄ±',0),(577481,16042,'pl','Nie znaleziono dla dostawcy karty',0),(577482,16042,'bg','ÐšÐ°Ñ€Ñ‚Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(577483,16042,'ur','Ú©Ø§Ø±Úˆ Ú©Û’ Ù„Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(577484,16042,'sr','ÐšÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð° Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(577485,16042,'vi','Tháº» khÃ´ng tÃ¬m tháº¥y cho nhÃ  cung cáº¥p',0),(577486,16042,'af','Kaart nie vir handelaar gevind',0),(577487,16042,'ro','Cardul nu a fost gÄƒsit pentru furnizor',0),(577488,16042,'et','Ei leitud hankija kaart',0),(577489,16042,'si','Kartica ni mogoÄe najti za dobavitelja',0),(577490,16042,'ba','Tidak ditemukan untuk Vendor kartu',0),(577491,16042,'nl','Kaart niet gevonden voor leverancier',0),(577492,16042,'fi','Kortti ei lÃ¶ydy toimittajaa varten',0),(577493,16042,'no','Kortet ikke funnet For leverandÃ¸r',0),(577494,16042,'da','Blev ikke fundet For kreditor',0),(577495,16042,'ko','ì¹´ë“œ ê³µê¸‰ ì—…ì²´ì— ëŒ€ í•œ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(577496,16042,'he','×”×›×¨×˜×™×¡ ×œ× × ×ž×¦× ×¢×‘×•×¨ ×¡×¤×§',0),(577497,16042,'el','ÎšÎ¬ÏÏ„Î± Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ Î³Î¹Î± Ï„Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(577498,16042,'zh','å¡æ‰¾ä¸åˆ°ä¾›åº”å•†',0),(577499,16042,'sv','Kort hittades inte fÃ¶r leverantÃ¶r',0),(577500,16042,'it','Scheda non trovata per fornitore',0),(577501,16042,'tl','',0),(577502,16042,'th','à¸šà¸±à¸•à¸£à¹„à¸¡à¹ˆà¸žà¸šà¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(577503,16042,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤•à¤¾à¤°à¥à¤¡',0),(577504,16042,'ms','Kad yang tidak ditemui untuk Vendor',0),(577505,16042,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ù…ÙˆØ±Ø¯ Ø¨Ø·Ø§Ù‚Ø©',0),(577506,16042,'fr','Carte introuvable pour le fournisseur',0),(577507,16042,'jp','ã‚«ãƒ¼ãƒ‰ ãƒ™ãƒ³ãƒ€ãƒ¼ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã€‚',0),(577508,16042,'pt','CartÃ£o nÃ£o foi encontrado para fornecedor',0),(577509,16042,'ru','ÐšÐ°Ñ€Ñ‚Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð° Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(577510,16042,'es','Tarjeta no encontrada para el vendedor',0),(577511,16042,'de','Karte nicht gefunden fÃ¼r VerkÃ¤ufer',0),(577512,16042,'en','Card Not Found For Vendor',0),(577513,16043,'is','',0),(577514,16043,'dr','CC Ø³ØªÙˆÙ†Ù‡Ø§ÛŒ Ø®Ø±ÛŒØ¯',0),(577515,16043,'pr','CC Ø³ØªÙˆÙ†Ù‡Ø§ÛŒ Ø®Ø±ÛŒØ¯',0),(577516,16043,'tr','CC sÃ¼tunlarÄ± alÄ±mlarÄ±',0),(577517,16043,'pl','CC kupuje kolumn',0),(577518,16043,'bg','CC Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÐºÐ¾Ð»Ð¾Ð½Ð¸',0),(577519,16043,'ur','Ù†Ù‚Ù„ Ø¨Ø±Ø§Û“ Ú©Ø§Ù„Ù… Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(577520,16043,'sr','Ð¦Ð¦ Ð½Ð°Ð±Ð°Ð²ÐºÐ°Ð¼Ð° ÐºÐ¾Ð»Ð¾Ð½Ðµ',0),(577521,16043,'vi','CC mua cá»™t',0),(577522,16043,'af','BK aankope kolomme',0),(577523,16043,'ro','Coloanele de la achiziÅ£iile CC',0),(577524,16043,'et','CC ostab veerud',0),(577525,16043,'si','CC kupi stolpcev',0),(577526,16043,'ba','CC pembelian kolom',0),(577527,16043,'nl','CC aankopen kolommen',0),(577528,16043,'fi','CC ostaa sarakkeet',0),(577529,16043,'no','CC KjÃ¸p kolonner',0),(577530,16043,'da','CC kÃ¸b af kolonner',0),(577531,16043,'ko','ì°¸ì¡° ì—´ êµ¬ë§¤',0),(577532,16043,'he','CC ×¨×›×™×©×•×ª ×¢×ž×•×“×•×ª',0),(577533,16043,'el','CC Î±Î³Î¿ÏÎ¬Î¶ÎµÎ¹ ÏƒÏ„Î®Î»ÎµÏ‚',0),(577534,16043,'zh','æŠ„é€è´­ä¹°åˆ—',0),(577535,16043,'sv','CC inkÃ¶p kolumner',0),(577536,16043,'it','CC acquisti colonne',0),(577537,16043,'tl','',0),(577538,16043,'th','à¸‹à¸µà¸‹à¸µà¸‹à¸·à¹‰à¸­à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œ',0),(577539,16043,'hi','CC à¤¸à¥à¤¤à¤‚à¤­ à¤–à¤°à¥€à¤¦',0),(577540,16043,'ms','CC pembelian tiang',0),(577541,16043,'ar','Ø´Ø±Ø§Ø¡ Ù†Ø³Ø®Ø© Ø§Ù„Ø£Ø¹Ù…Ø¯Ø©',0),(577542,16043,'fr','CC les achats de colonnes',0),(577543,16043,'jp','CC è³¼å…¥åˆ—',0),(577544,16043,'pt','CC compras colunas',0),(577545,16043,'ru','CC Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ ÑÑ‚Ð¾Ð»Ð±Ñ†Ñ‹',0),(577546,16043,'es','CC las compras de columnas',0),(577547,16043,'de','CC kauft Spalten',0),(577548,16043,'en','CC Purchases Columns',0),(577549,16044,'is','',0),(577550,16044,'dr','ÙØ§ÛŒÙ„ CSV Ø®Ø±ÛŒØ¯ Ø³ÛŒ Ø³ÛŒ',0),(577551,16044,'pr','ÙØ§ÛŒÙ„ CSV Ø®Ø±ÛŒØ¯ Ø³ÛŒ Ø³ÛŒ',0),(577552,16044,'tr','CC alÄ±mlarÄ± CSV dosya',0),(577553,16044,'pl','Plik CSV zakupy CC',0),(577554,16044,'bg','CC Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ CSV Ñ„Ð°Ð¹Ð»',0),(577555,16044,'ur','CC Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒØ§Úº CSV ÙØ§Ø¦Ù„',0),(577556,16044,'sr','Ð¦Ð¦ Ð½Ð°Ð±Ð°Ð²ÐºÐ¸ Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(577557,16044,'vi','Tá»‡p CSV mua CC',0),(577558,16044,'af','BK aankope CSV-lÃªer',0),(577559,16044,'ro','CC achiziÅ£ii fiÅŸier CSV',0),(577560,16044,'et','CC ostude CSV-faili',0),(577561,16044,'si','CC nakupi CSV datoteke',0),(577562,16044,'ba','File CSV CC pembelian',0),(577563,16044,'nl','CC aankopen CSV-bestand',0),(577564,16044,'fi','CC ostot CSV-tiedosto',0),(577565,16044,'no','CC KjÃ¸p CSV-fil',0),(577566,16044,'da','CC KÃ¸b CSV-fil',0),(577567,16044,'ko','ì°¸ì¡° êµ¬ë§¤ CSV íŒŒì¼',0),(577568,16044,'he','×§×•×‘×¥ ×”-CSV ×¨×›×™×©×•×ª CC',0),(577569,16044,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ CSV Î±Î³Î¿ÏÎ­Ï‚ CC',0),(577570,16044,'zh','æŠ„é€è´­ä¹° CSV æ–‡ä»¶',0),(577571,16044,'sv','CC inkÃ¶p CSV-filen',0),(577572,16044,'it','File CSV gli acquisti CC',0),(577573,16044,'tl','',0),(577574,16044,'th','à¸‹à¸µà¸‹à¸µà¸‹à¸·à¹‰à¸­à¹à¸Ÿà¹‰à¸¡ CSV',0),(577575,16044,'hi','CC à¤–à¤°à¥€à¤¦ CSV à¤«à¤¼à¤¾à¤‡à¤²',0),(577576,16044,'ms','Fail CSV pembelian CC',0),(577577,16044,'ar','Ù…Ù„Ù CSV Ù…Ø´ØªØ±ÙŠØ§Øª CC',0),(577578,16044,'fr','Fichier CSV de CC achats',0),(577579,16044,'jp','CC è³¼å…¥ CSV ãƒ•ã‚¡ã‚¤ãƒ«',0),(577580,16044,'pt','Arquivo CSV compras CC',0),(577581,16044,'ru','CC Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ CSV-Ñ„Ð°Ð¹Ð»Ð°',0),(577582,16044,'es','CC archivo CSV de compras',0),(577583,16044,'de','CC-KÃ¤ufe-CSV-Datei',0),(577584,16044,'en','CC Purchases CSV File',0),(577585,16045,'is','',0),(577586,16045,'dr','Ø®Ø±ÛŒØ¯ Ú¯ÛŒØ±Ù†Ø¯Ù‡ Ú©Ù¾ÛŒ ÙˆØ§Ø±Ø¯',0),(577587,16045,'pr','Ø®Ø±ÛŒØ¯ Ú¯ÛŒØ±Ù†Ø¯Ù‡ Ú©Ù¾ÛŒ ÙˆØ§Ø±Ø¯',0),(577588,16045,'tr','Ä°thal CC alÄ±mlarÄ±',0),(577589,16045,'pl','CC zakupÃ³w importowanych',0),(577590,16045,'bg','CC Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð²Ð½ÐµÑÐµÐ½Ð¸',0),(577591,16045,'ur','CC Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒØ§Úº Ø¯Ø±Ø¢Ù…Ø¯',0),(577592,16045,'sr','Ð¦Ð¦ Ð½Ð°Ð±Ð°Ð²ÐºÐ¸ ÑƒÐ²ÐµÐ·ÐµÐ½',0),(577593,16045,'vi','CC mua hÃ ng nháº­p kháº©u',0),(577594,16045,'af','BK aankope ingevoer',0),(577595,16045,'ro','CC achiziÅ£ii importate',0),(577596,16045,'et','CC ostude imporditud',0),(577597,16045,'si','CC nakupi uvoÅ¾enih',0),(577598,16045,'ba','CC pembelian impor',0),(577599,16045,'nl','CC aankopen geÃ¯mporteerd',0),(577600,16045,'fi','CC ostot tuotu',0),(577601,16045,'no','CC KjÃ¸p importert',0),(577602,16045,'da','CC KÃ¸b importeret',0),(577603,16045,'ko','ê°€ì ¸ì˜¨ CC êµ¬ë§¤',0),(577604,16045,'he','×¨×›×™×©×•×ª CC ×ž×™×•×‘××™×',0),(577605,16045,'el','CC Î±Î³Î¿ÏÎ­Ï‚ Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(577606,16045,'zh','æŠ„é€è´­ä¹°è¿›å£',0),(577607,16045,'sv','CC inkÃ¶p importeras',0),(577608,16045,'it','Acquisti CC importati',0),(577609,16045,'tl','',0),(577610,16045,'th','à¸‹à¸·à¹‰à¸­ CC à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(577611,16045,'hi','CC à¤–à¤°à¥€à¤¦ à¤†à¤¯à¤¾à¤¤',0),(577612,16045,'ms','Pembelian CC yang diimport',0),(577613,16045,'ar','Ø´Ø±Ø§Ø¡ Ù†Ø³Ø®Ø© Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(577614,16045,'fr','CC les achats importÃ©s',0),(577615,16045,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ CC è³¼å…¥',0),(577616,16045,'pt','Compras CC importadas',0),(577617,16045,'ru','CC Ð·Ð°ÐºÑƒÐ¿ÐºÐ¸ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐµÐ¼Ñ‹Ñ…',0),(577618,16045,'es','Compras CC importadas',0),(577619,16045,'de','CC-EinkÃ¤ufe nicht importiert',0),(577620,16045,'en','CC Purchases Imported',0),(577621,16046,'is','',0),(577622,16046,'dr','ØªØ§Ø±ÛŒØ® Ø´Ù†Ø§Ø®ØªÙ‡ Ø´Ø¯Ù‡ Ù†ÛŒØ³Øª',0),(577623,16046,'pr','ØªØ§Ø±ÛŒØ® Ø´Ù†Ø§Ø®ØªÙ‡ Ø´Ø¯Ù‡ Ù†ÛŒØ³Øª',0),(577624,16046,'tr','Tarihi tanÄ±nmadÄ±',0),(577625,16046,'pl','Daty nie rozpoznany',0),(577626,16046,'bg','Ð”Ð°Ñ‚Ð° Ð½Ðµ ÑÐµ Ñ€Ð°Ð·Ð¿Ð¾Ð·Ð½Ð°Ð²Ð°',0),(577627,16046,'ur','ØªØ§Ø±ÛŒØ® Ù¾ÛÚ†Ø§Ù†',0),(577628,16046,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€ÐµÐ¿Ð¾Ð·Ð½Ð°Ñ‚',0),(577629,16046,'vi','NgÃ y khÃ´ng Ä‘Æ°á»£c cÃ´ng nháº­n',0),(577630,16046,'af','Datum nie herken nie',0),(577631,16046,'ro','Data nu este recunoscut',0),(577632,16046,'et','KuupÃ¤eva ei tunnistata',0),(577633,16046,'si','Datum ni prepoznan',0),(577634,16046,'ba','Tanggal tidak diakui',0),(577635,16046,'nl','Datum niet herkend',0),(577636,16046,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ ei tunnisteta',0),(577637,16046,'no','Dato ikke gjenkjent',0),(577638,16046,'da','Dato ikke genkendt',0),(577639,16046,'ko','ì¸ì‹ ë˜ì§€ ì•ŠëŠ” ë‚ ì§œ',0),(577640,16046,'he','×ª××¨×™×š ×œ× ×ž×–×•×”×”',0),(577641,16046,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î´ÎµÎ½ Î±Î½Î±Î³Î½Ï‰ÏÎ¯Î¶ÎµÏ„Î±Î¹',0),(577642,16046,'zh','ä¸èƒ½è¯†åˆ«çš„æ—¥æœŸ',0),(577643,16046,'sv','Datum okÃ¤nt',0),(577644,16046,'it','Data non riconosciuto',0),(577645,16046,'tl','',0),(577646,16046,'th','à¸§à¸±à¸™à¹„à¸¡à¹ˆà¸£à¸¹à¹‰à¸ˆà¸±à¸',0),(577647,16046,'hi','à¤¨ à¤ªà¤¹à¤šà¤¾à¤¨à¤¾ à¤—à¤¯à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(577648,16046,'ms','Tarikh yang tidak diiktiraf',0),(577649,16046,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ù„Ø§ ÙŠØ¹ØªØ±Ù',0),(577650,16046,'fr','Date non reconnu',0),(577651,16046,'jp','æ—¥ä»˜ã¯èªè­˜ã•ã‚Œã¾ã›ã‚“ã€‚',0),(577652,16046,'pt','Data nÃ£o reconhecida',0),(577653,16046,'ru','Ð”Ð°Ñ‚Ð° Ð½Ðµ Ð¿Ñ€Ð¸Ð·Ð½Ð°ÐµÑ‚ÑÑ',0),(577654,16046,'es','Fecha no reconocida',0),(577655,16046,'de','Datum nicht erkannt',0),(577656,16046,'en','Date Not Recognized',0),(577657,16047,'is','',0),(577658,16047,'dr','ØªÙ†Ø¸ÛŒÙ… Ø­Ø³Ø§Ø¨ GL Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±Øª',0),(577659,16047,'pr','ØªÙ†Ø¸ÛŒÙ… Ø­Ø³Ø§Ø¨ GL Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±Øª',0),(577660,16047,'tr','GL hesap kartÄ± iÃ§in ayarlanmamÄ±ÅŸ',0),(577661,16047,'pl','Konta k/g, nie zestaw dla karty',0),(577662,16047,'bg','GL ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼ Ð·Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(577663,16047,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Ø§Ø±Úˆ Ú©Û’ Ù„ÛŒÛ’ Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(577664,16047,'sr','Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½ Ð·Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ñƒ',0),(577665,16047,'vi','GL khoáº£n khÃ´ng Ä‘áº·t tháº»',0),(577666,16047,'af','GL rekening stel nie vir kaart',0),(577667,16047,'ro','GL contul nu setat pentru cartela',0),(577668,16047,'et','GL kontot ei mÃ¤Ã¤ra kaardi',0),(577669,16047,'si','GL raÄun ni nastavljen za kartico',0),(577670,16047,'ba','GL Account tidak diatur untuk kartu',0),(577671,16047,'nl','GL-Account niet is ingesteld voor kaart',0),(577672,16047,'fi','KÃ¤ytetÃ¤Ã¤nkÃ¶ KP-tiliÃ¤ ei ole asetettu kortti',0),(577673,16047,'no','GI-konto ikke angitt For kort',0),(577674,16047,'da','GL konto ikke sat til kort',0),(577675,16047,'ko','GL ê³„ì • ì¹´ë“œì— ëŒ€ í•œ ì„¤ì • í•˜ì§€',0),(577676,16047,'he','GL ×”×—×©×‘×•×Ÿ ××™× ×• ×ž×•×’×“×¨ ×¢×‘×•×¨ ×›×¨×˜×™×¡',0),(577677,16047,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î´ÎµÎ½ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Î³Î¹Î± ÎºÎ¬ÏÏ„Î±',0),(577678,16047,'zh','æ€»å¸å¸æˆ·æ²¡æœ‰è®¾ç½®å¡',0),(577679,16047,'sv','GL hÃ¤nsyn som inte fÃ¶r kort',0),(577680,16047,'it','Conto di contabilitÃ  generale non impostato per carta',0),(577681,16047,'tl','',0),(577682,16047,'th','à¸šà¸±à¸à¸Šà¸µà¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¹Œà¸”',0),(577683,16047,'hi','à¤•à¤¾à¤°à¥à¤¡ à¤•à¥‡ à¤²à¤¿à¤ GL à¤–à¤¾à¤¤à¤¾ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(577684,16047,'ms','GL akaun tidak disetkan untuk Kad',0),(577685,16047,'ar','Ø¹Ø¯Ù… ØªØ¹ÙŠÙŠÙ† Ø­Ø³Ø§Ø¨ GL Ù„Ù„Ø¨Ø·Ø§Ù‚Ø©',0),(577686,16047,'fr','Compte GL nâ€™est pas dÃ©finie pour la carte',0),(577687,16047,'jp','ã‚«ãƒ¼ãƒ‰ã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(577688,16047,'pt','Conta GL nÃ£o definido para o cartÃ£o',0),(577689,16047,'ru','GL ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½ Ð´Ð»Ñ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(577690,16047,'es','GL no configurada cuenta tarjeta',0),(577691,16047,'de','Fibukonto Set nicht fÃ¼r Karte',0),(577692,16047,'en','GL Account Not Set For Card',0),(577693,16048,'is','',0),(577694,16048,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ CC',0),(577695,16048,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ CC',0),(577696,16048,'tr','CC satÄ±cÄ± kimliÄŸi',0),(577697,16048,'pl','Identyfikator dostawcy CC',0),(577698,16048,'bg','Ð˜Ð” Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, CC',0),(577699,16048,'ur','CC ÙˆÛŒÙ†ÚˆØ± Ú©Û’ Ù„ÛŒÛ’ Ø´Ù†Ø§Ø®Øª',0),(577700,16048,'sr','Ð˜Ð” Ð·Ð° Ð¦Ð¦ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(577701,16048,'vi','ID cho cÃ¡c nhÃ  bÃ¡n CC',0),(577702,16048,'af','ID vir die BK handelaar',0),(577703,16048,'ro','ID-ul pentru furnizorul CC',0),(577704,16048,'et','CC hankija ID',0),(577705,16048,'si','ID dobavitelja CC',0),(577706,16048,'ba','ID untuk CC Vendor',0),(577707,16048,'nl','ID voor de leverancier van CC',0),(577708,16048,'fi','CC-toimittajan tunnus',0),(577709,16048,'no','ID For CC leverandÃ¸ren',0),(577710,16048,'da','ID For kreditoren, CC',0),(577711,16048,'ko','CCì˜ ê³µê¸‰ ì—…ì²´ ID',0),(577712,16048,'he','×ž×–×”×” ×¢×‘×•×¨ ×”×¡×¤×§ CC',0),(577713,16048,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Î³Î¹Î± Ï„Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® CC',0),(577714,16048,'zh','æŠ„é€ä¾›åº”å•† ID',0),(577715,16048,'sv','ID fÃ¶r leverantÃ¶ren som CC',0),(577716,16048,'it','ID per il fornitore CC',0),(577717,16048,'tl','',0),(577718,16048,'th','ID à¸ªà¸³à¸«à¸£à¸±à¸šà¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸‹à¸µà¸‹à¸µ',0),(577719,16048,'hi','CC à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ ID',0),(577720,16048,'ms','ID untuk penjual CC',0),(577721,16048,'ar','Ù…Ø¹Ø±Ù Ø§Ù„Ù…ÙˆØ±Ø¯ CC',0),(577722,16048,'fr','ID du fournisseur de CC',0),(577723,16048,'jp','CC ãƒ™ãƒ³ãƒ€ãƒ¼ã® ID',0),(577724,16048,'pt','ID do fornecedor do CC',0),(577725,16048,'ru','Ð˜Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° CC',0),(577726,16048,'es','ID para el proveedor CC',0),(577727,16048,'de','ID fÃ¼r den CC-Kreditor',0),(577728,16048,'en','ID For The CC Vendor',0),(577729,16049,'is','',0),(577730,16049,'dr','ØªØ§Ø¬Ø±',0),(577731,16049,'pr','ØªØ§Ø¬Ø±',0),(577732,16049,'tr','TÃ¼ccar',0),(577733,16049,'pl','Kupiec',0),(577734,16049,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÐµÑ†',0),(577735,16049,'ur','ØªØ§Ø¬Ø±',0),(577736,16049,'sr','Ð¢Ñ€Ð³Ð¾Ð²Ð°Ñ†',0),(577737,16049,'vi','ThÆ°Æ¡ng gia',0),(577738,16049,'af','Handelaar',0),(577739,16049,'ro','Comerciant',0),(577740,16049,'et','Kaupmees',0),(577741,16049,'si','Trgovec',0),(577742,16049,'ba','Pedagang',0),(577743,16049,'nl','Koopman',0),(577744,16049,'fi','Kauppias',0),(577745,16049,'no','KjÃ¸pmann',0),(577746,16049,'da','KÃ¸bmand',0),(577747,16049,'ko','ê°€ë§¹ì ',0),(577748,16049,'he','×¡×•×—×¨',0),(577749,16049,'el','ÎˆÎ¼Ï€Î¿ÏÎ¿Ï‚',0),(577750,16049,'zh','å•†äºº',0),(577751,16049,'sv','KÃ¶pman',0),(577752,16049,'it','Mercante',0),(577753,16049,'tl','',0),(577754,16049,'th','à¸£à¹‰à¸²à¸™à¸„à¹‰à¸²',0),(577755,16049,'hi','à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤°à¥€',0),(577756,16049,'ms','Saudagar',0),(577757,16049,'ar','Ø§Ù„ØªØ§Ø¬Ø±',0),(577758,16049,'fr','Marchand',0),(577759,16049,'jp','å•†äºº',0),(577760,16049,'pt','Comerciante',0),(577761,16049,'ru','ÐšÑƒÐ¿ÐµÑ†',0),(577762,16049,'es','Comerciante',0),(577763,16049,'de','Kaufmann',0),(577764,16049,'en','Merchant',0),(577765,16050,'is','',0),(577766,16050,'dr','Ø¨Ø§ÛŒØ¯ Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ùˆ ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø¨Ù„Øº Ùˆ Ù‡Ø²ÛŒÙ†Ù‡ GL Ø­Ø³Ø§Ø¨ & Ù†Ø§Ù… ØªØ¬Ø§Ø±ÛŒ',0),(577767,16050,'pr','Ø¨Ø§ÛŒØ¯ Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ùˆ ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø¨Ù„Øº Ùˆ Ù‡Ø²ÛŒÙ†Ù‡ GL Ø­Ø³Ø§Ø¨ & Ù†Ø§Ù… ØªØ¬Ø§Ø±ÛŒ',0),(577768,16050,'tr','SatÄ±cÄ± numarasÄ±, Ã¶deme tarihi, Ã¶deme tutarÄ±, gider GL hesabÄ± ve tÃ¼ccar adÄ± olmasÄ± gerekir',0),(577769,16050,'pl','Musi mieÄ‡ numer dostawcy, Data pÅ‚atnoÅ›ci, kwota pÅ‚atnoÅ›ci, konto wydatkÃ³w GL idealna nazwa sprzedawcy',0),(577770,16050,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°, Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, ÑÑƒÐ¼Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, GL ÑÐ¼ÐµÑ‚ÐºÐ° & Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð¸Ð¼Ðµ',0),(577771,16050,'ur','ÙˆÛŒÙ†ÚˆØ± Ù†Ù…Ø¨Ø±ØŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®ØŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù‚Ù…ØŒ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ & ØªØ¬Ø§Ø±ØªÛŒ Ù†Ø§Ù… ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(577772,16050,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð±Ñ€Ð¾Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°, Ð”Ð°Ñ‚ÑƒÐ¼ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ, Ð¸Ð·Ð½Ð¾Ñ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ, ÐšÐ¾Ð½Ñ‚Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð“Ð› & Ñ‚Ñ€Ð³Ð¾Ð²Ð°Ñ†ÐºÐ° Ð¸Ð¼Ðµ',0),(577773,16050,'vi','Pháº£i cÃ³ sá»‘ lÆ°á»£ng ngÆ°á»i bÃ¡n hÃ ng, ngÃ y thanh toÃ¡n, sá»‘ tiá»n thanh toÃ¡n, tÃ i khoáº£n chi phÃ­ GL & tÃªn ngÆ°á»i bÃ¡n',0),(577774,16050,'af','Handelaar nommer, datum van betaling, betaling bedrag, uitgawe GL rekening & handelaar naam moet hÃª',0),(577775,16050,'ro','Trebuie sÄƒ aibÄƒ numÄƒrul furnizorului, data platii, suma de plata, cont de GL cheltuialÄƒ & comerciant numele',0),(577776,16050,'et','Peab olema hankija numbri, makse kuupÃ¤eva, makse summa, kulukonto GL- & kaupmehe nimi',0),(577777,16050,'si','Mora imeti Å¡tevilko dobavitelja, datum plaÄila, znesek plaÄila, Konto stroÅ¡kov GL & trgovsko ime',0),(577778,16050,'ba','Harus memiliki nomor Vendor, tanggal pembayaran, jumlah pembayaran, rekening pengeluaran GL & nama Merchant',0),(577779,16050,'nl','Moet leveranciersnummer, Betaaldatum, betalingsbedrag, GL kostenrekening & handelaar naam',0),(577780,16050,'fi','On oltava toimittajanumeron, maksupÃ¤ivÃ¤, maksusumma, GL kulutili & kauppiaan nimi',0),(577781,16050,'no','MÃ¥ ha leverandÃ¸rnummeret, betalingsdato, betalingsbelÃ¸pet, GL kostnadskonto & forhandlerens navn',0),(577782,16050,'da','Skal kreditornummer, betalingsdato, betalingsbelÃ¸bet, GL udgiftskonto & kÃ¸bmand navn',0),(577783,16050,'ko','ê³µê¸‰ ì—…ì²´ ë²ˆí˜¸, ê²°ì œ ë‚ ì§œ, ê²°ì œ ê¸ˆì•¡, ë¹„ìš© GL ê³„ì • ë° ê°€ë§¹ì  ì´ë¦„ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(577784,16050,'he','×—×™×™×‘ ×œ×”×™×•×ª ×ž×¡×¤×¨ ×”×¡×¤×§, ×ª××¨×™×š ×”×ª×©×œ×•×, ×¡×›×•× ×”×ª×©×œ×•×, ×—×©×‘×•×Ÿ ×”×•×¦××•×ª GL & ×©× ×¡×•×—×¨',0),(577785,16050,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®, Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚, Ï€Î¿ÏƒÏŒ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚, Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î´Î±Ï€Î¬Î½Î· & ÏŒÎ½Î¿Î¼Î± Ï„Î¿Ï… ÎµÎ¼Ï€ÏŒÏÎ¿Ï…',0),(577786,16050,'zh','å¿…é¡»æœ‰ä¾›åº”å•†ç¼–å·ã€ ä»˜æ¬¾æ—¥æœŸã€ ä»˜æ¬¾é‡‘é¢ã€ è´¹ç”¨æ€»å¸å¸æˆ· & å•†æˆ·åç§°',0),(577787,16050,'sv','MÃ¥ste ha leverantÃ¶rsnummer, betalningsdatum, betalningsbeloppet, GL utgiftskonto & handlarens namn',0),(577788,16050,'it','Deve avere il numero del fornitore, data di pagamento, importo del pagamento, conto spese GL & nome del commerciante',0),(577789,16050,'tl','',0),(577790,16050,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸œà¸¹à¹‰à¸‚à¸²à¸¢ à¸§à¸±à¸™à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢ à¹à¸¥à¸°à¸Šà¸·à¹ˆà¸­à¸£à¹‰à¸²à¸™à¸„à¹‰à¸²',0),(577791,16050,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾, à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–, à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿, à¤µà¥à¤¯à¤¯ GL à¤–à¤¾à¤¤à¥‡ & à¤µà¥à¤¯à¤¾à¤ªà¤¾à¤°à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(577792,16050,'ms','Mesti mempunyai nombor Vendor, tarikh pembayaran, jumlah pembayaran, akaun perbelanjaan GL & nama Saudagar',0),(577793,16050,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ø±Ù‚Ù… Ø§Ù„Ù…ÙˆØ±Ø¯ØŒ ÙˆØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹ØŒ ÙˆØ¯ÙØ¹ Ø§Ù„Ù…Ø¨Ù„ØºØŒ ÙˆØ­Ø³Ø§Ø¨ GL Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ & Ø§Ø³Ù… Ø§Ù„ØªØ§Ø¬Ø±',0),(577794,16050,'fr','Doit avoir le numÃ©ro de fournisseur, Date de paiement, montant du paiement, compte de dÃ©penses GL & nom marchand',0),(577795,16050,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ç•ªå·ã€æ”¯æ‰•æ—¥ã€æ”¯æ‰•é‡‘é¡ã€çµŒè²» GL ãƒ»å•†äººã®åå‰ã‚’æŒã¤å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(577796,16050,'pt','Deve ter o nÃºmero do fornecedor, data de pagamento, valor do pagamento, despesa GL conta & nome mercante',0),(577797,16050,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¸Ð¼ÐµÑ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°, Ð´Ð°Ñ‚Ñƒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°, ÑÑƒÐ¼Ð¼Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°, ÑÑ‡ÐµÑ‚ GL & ÐºÑƒÐ¿ÐµÑ† Ð¸Ð¼Ñ',0),(577798,16050,'es','Debe tener nÃºmero de proveedor, fecha de pago, monto del pago, cuenta de contabilidad de costo y nombre comercial',0),(577799,16050,'de','Lieferantennummer, Zahlungsdatum, Zahlungsbetrag, GL Aufwandskonto & HÃ¤ndler Name muss',0),(577800,16050,'en','Must Have Vendor Number, Payment Date, Payment Amount, Expense GL Account & Merchant Name',0),(577801,16051,'is','',0),(577802,16051,'dr','Ø®Ø±ÛŒØ¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± Ø³ÛŒØ³ØªÙ…',0),(577803,16051,'pr','Ø®Ø±ÛŒØ¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± Ø³ÛŒØ³ØªÙ…',0),(577804,16051,'tr','Sistem zaten satÄ±n alma',0),(577805,16051,'pl','Zakup, juÅ¼ w systemie',0),(577806,16051,'bg','ÐŸÐ¾ÐºÑƒÐ¿ÐºÐ° Ð²ÐµÑ‡Ðµ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð°',0),(577807,16051,'ur','Ù†Ø¸Ø§Ù… Ù…ÛŒÚº Ù¾ÛÙ„Û’ Ø³Û’ ÛÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ',0),(577808,16051,'sr','ÐÐ°Ð±Ð°Ð²ÐºÐµ Ð²ÐµÑ› Ñƒ ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ',0),(577809,16051,'vi','ÄÃ£ mua hÃ ng táº¡i há»‡ thá»‘ng',0),(577810,16051,'af','Koop reeds In stelsel',0),(577811,16051,'ro','CumpÄƒrare deja Ã®n sistem',0),(577812,16051,'et','Ostu juba sÃ¼steemis',0),(577813,16051,'si','Nakup Å¾e v sistem',0),(577814,16051,'ba','Pembelian sudah dalam sistem',0),(577815,16051,'nl','Aankoop al In het systeem',0),(577816,16051,'fi','Ostojen jo jÃ¤rjestelmÃ¤ssÃ¤',0),(577817,16051,'no','KjÃ¸p allerede i systemet',0),(577818,16051,'da','KÃ¸b allerede i System',0),(577819,16051,'ko','ì‹œìŠ¤í…œì— ì´ë¯¸ êµ¬ë§¤',0),(577820,16051,'he','×”×¨×›×™×©×” ×›×‘×¨ ×‘×ž×¢×¨×›×ª',0),(577821,16051,'el','Î‘Î³Î¿ÏÎ¬ Î®Î´Î· ÏƒÏ„Î¿ ÏƒÏÏƒÏ„Î·Î¼Î±',0),(577822,16051,'zh','è´­ä¹°å·²ç»åœ¨ç³»ç»Ÿä¸­',0),(577823,16051,'sv','KÃ¶pa redan i systemet',0),(577824,16051,'it','Acquisto giÃ  nel sistema',0),(577825,16051,'tl','',0),(577826,16051,'th','à¸‹à¸·à¹‰à¸­à¹à¸¥à¹‰à¸§à¹ƒà¸™à¸£à¸°à¸šà¸š',0),(577827,16051,'hi','à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤®à¥‡à¤‚ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤–à¤°à¥€à¤¦',0),(577828,16051,'ms','Pembelian sudah dalam sistem',0),(577829,16051,'ar','Ø´Ø±Ø§Ø¡ ÙØ¹Ù„Ø§ ÙÙŠ Ø§Ù„Ù†Ø¸Ø§Ù…',0),(577830,16051,'fr','Acheter dÃ©jÃ  dans le systÃ¨me',0),(577831,16051,'jp','ã‚·ã‚¹ãƒ†ãƒ ã§æ—¢ã«è³¼å…¥',0),(577832,16051,'pt','Compra jÃ¡ no sistema',0),(577833,16051,'ru','ÐŸÑ€Ð¸Ð¾Ð±Ñ€ÐµÑ‚ÐµÐ½Ð¸Ðµ ÑƒÐ¶Ðµ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ðµ',0),(577834,16051,'es','Compra ya en sistema',0),(577835,16051,'de','Kauf bereits im System',0),(577836,16051,'en','Purchase Already In System',0),(577837,16052,'is','',0),(577838,16052,'dr','Ø®Ø±ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡',0),(577839,16052,'pr','Ø®Ø±ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡',0),(577840,16052,'tr','SatÄ±n alma kimliÄŸi',0),(577841,16052,'pl','ID zakupu',0),(577842,16052,'bg','Ð˜Ð” Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°Ñ‚Ð°',0),(577843,16052,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©ÛŒ Ø´Ù†Ø§Ø®Øª',0),(577844,16052,'sr','Ð˜Ð” Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(577845,16052,'vi','Mua ID',0),(577846,16052,'af','Aankoop ID',0),(577847,16052,'ro','ID-ul achiziÅ£iei',0),(577848,16052,'et','Ostu ID',0),(577849,16052,'si','ID nakupa',0),(577850,16052,'ba','Pembelian ID',0),(577851,16052,'nl','Aankoop-ID',0),(577852,16052,'fi','Oston tunnus',0),(577853,16052,'no','KjÃ¸ps-ID',0),(577854,16052,'da','IndkÃ¸bs-ID',0),(577855,16052,'ko','êµ¬ë§¤ ID',0),(577856,16052,'he','×ž×–×”×” ×¨×›×™×©×”',0),(577857,16052,'el','Î¤Î±Ï…Ï„ÏŒÏ„Î·Ï„Î± Î±Î³Î¿ÏÎ¬Ï‚',0),(577858,16052,'zh','é‡‡è´­ ID',0),(577859,16052,'sv','InkÃ¶ps-ID',0),(577860,16052,'it','ID dell\'acquisto',0),(577861,16052,'tl','',0),(577862,16052,'th','à¸£à¸«à¸±à¸ªà¸à¸²à¸£à¸‹à¸·à¹‰à¸­',0),(577863,16052,'hi','à¤–à¤°à¥€à¤¦ ID',0),(577864,16052,'ms','Pembelian ID',0),(577865,16052,'ar','Ù…Ø¹Ø±Ù Ø´Ø±Ø§Ø¡',0),(577866,16052,'fr','ID dâ€™achat',0),(577867,16052,'jp','è³¼å…¥ ID',0),(577868,16052,'pt','IdentificaÃ§Ã£o de compra',0),(577869,16052,'ru','ÐšÐ¾Ð´ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(577870,16052,'es','ID. de compra',0),(577871,16052,'de','Kauf-ID',0),(577872,16052,'en','Purchase ID',0),(577873,16053,'is','',0),(577874,16053,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ù…Ø§Ø±Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(577875,16053,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø´Ù…Ø§Ø±Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(577876,16053,'tr','SatÄ±cÄ± numarasÄ± bilgisi',0),(577877,16053,'pl','Informacje numer dostawcy',0),(577878,16053,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°',0),(577879,16053,'ur','ÙˆÛŒÙ†ÚˆØ± Ù†Ù…Ø¨Ø± Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(577880,16053,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑÐ° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°Ð¼Ð°',0),(577881,16053,'vi','NhÃ  cung cáº¥p thÃ´ng tin sá»‘',0),(577882,16053,'af','Handelaar nommer Info',0),(577883,16053,'ro','Info numÄƒrul furnizorului',0),(577884,16053,'et','Hankija numbri Info',0),(577885,16053,'si','Å tevilo informacij o prodajalcu',0),(577886,16053,'ba','Penjual nomor Info',0),(577887,16053,'nl','Leverancier nummer Info',0),(577888,16053,'fi','Toimittajan numero Info',0),(577889,16053,'no','LeverandÃ¸r nummer Info',0),(577890,16053,'da','LeverandÃ¸r nummer Info',0),(577891,16053,'ko','ê³µê¸‰ ì—…ì²´ ë²ˆí˜¸ ì •ë³´',0),(577892,16053,'he','×¤×¨×˜×™ ×ž×¡×¤×¨ ×”×¡×¤×§',0),(577893,16053,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(577894,16053,'zh','ä¾›åº”å•†ç¼–å·ä¿¡æ¯',0),(577895,16053,'sv','LeverantÃ¶rens nummer information',0),(577896,16053,'it','Info numero fornitore',0),(577897,16053,'tl','',0),(577898,16053,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(577899,16053,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(577900,16053,'ms','Penjual nombor maklumat',0),(577901,16053,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø±Ù‚Ù… Ø§Ù„Ø¨Ø§Ø¦Ø¹',0),(577902,16053,'fr','Fournisseur numÃ©ro Info',0),(577903,16053,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ç•ªå·æƒ…å ±',0),(577904,16053,'pt','InformaÃ§Ã£o de nÃºmero de fornecedor',0),(577905,16053,'ru','Ð§Ð¸ÑÐ»Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(577906,16053,'es','InformaciÃ³n de nÃºmero de proveedor',0),(577907,16053,'de','Kreditor Nummer Info',0),(577908,16053,'en','Vendor Number Info',0),(577909,16054,'is','',0),(577910,16054,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ø§Ø±Ù…Ù†Ø¯ Ø³ØªÙˆÙ†',0),(577911,16054,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ø§Ø±Ù…Ù†Ø¯ Ø³ØªÙˆÙ†',0),(577912,16054,'tr','Ã‡alÄ±ÅŸan gider sÃ¼tun',0),(577913,16054,'pl','Kolumny koszt pracownika',0),(577914,16054,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» ÑÐ¼ÐµÑ‚ÐºÐ° ÐºÐ¾Ð»Ð¾Ð½Ð¸',0),(577915,16054,'ur','Ù…Ù„Ø§Ø²Ù… Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ú©Ø§Ù„Ù…',0),(577916,16054,'sr','ÐšÐ¾Ð»Ð¾Ð½Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸Ñ…',0),(577917,16054,'vi','NhÃ¢n viÃªn chi phÃ­ cá»™t',0),(577918,16054,'af','Werknemer uitgawe kolomme',0),(577919,16054,'ro','Coloane de cheltuieli angajat',0),(577920,16054,'et','TÃ¶Ã¶taja kulul veerud',0),(577921,16054,'si','Zaposlenih stroÅ¡ke stolpcev',0),(577922,16054,'ba','Kolom biaya karyawan',0),(577923,16054,'nl','Werknemer kosten kolommen',0),(577924,16054,'fi','TyÃ¶ntekijÃ¤n kulun sarakkeet',0),(577925,16054,'no','Ansatte bekostning kolonner',0),(577926,16054,'da','Medarbejder udgift kolonner',0),(577927,16054,'ko','ì§ì› ë¹„ìš© ì—´',0),(577928,16054,'he','×¢×ž×•×“×•×ª ×”×•×¦××•×ª ×œ×¢×•×‘×“',0),(577929,16054,'el','Î•ÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿ Î­Î¾Î¿Î´Î± ÏƒÏ„Î®Î»ÎµÏ‚',0),(577930,16054,'zh','å‘˜å·¥è´¹ç”¨åˆ—',0),(577931,16054,'sv','Medarbetaren bekostnad kolumner',0),(577932,16054,'it','Colonne di spesa dipendente',0),(577933,16054,'tl','',0),(577934,16054,'th','à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œà¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(577935,16054,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥à¤¯à¤¯ à¤•à¥‰à¤²à¤®',0),(577936,16054,'ms','Kolum perbelanjaan pekerja',0),(577937,16054,'ar','Ø§Ù„Ù…ÙˆØ¸Ù Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£Ø¹Ù…Ø¯Ø©',0),(577938,16054,'fr','EmployÃ© frais colonnes',0),(577939,16054,'jp','å¾“æ¥­å“¡çµŒè²»åˆ—',0),(577940,16054,'pt','Colunas de despesa de empregado',0),(577941,16054,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð·Ð° ÑÑ‡ÐµÑ‚ ÑÑ‚Ð¾Ð»Ð±Ñ†Ñ‹',0),(577942,16054,'es','Columnas de gastos de empleado',0),(577943,16054,'de','Mitarbeiter Kosten Spalten',0),(577944,16054,'en','Employee Expense Columns',0),(577945,16055,'is','',0),(577946,16055,'dr','ÙØ§ÛŒÙ„ CSV Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(577947,16055,'pr','ÙØ§ÛŒÙ„ CSV Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ø§Ø±Ù…Ù†Ø¯',0),(577948,16055,'tr','Ã‡alÄ±ÅŸan gider CSV dosya',0),(577949,16055,'pl','Pliku CSV koszt pracownika',0),(577950,16055,'bg','Ð¡Ð»ÑƒÐ¶Ð¸Ñ‚ÐµÐ» ÑÐ¼ÐµÑ‚ÐºÐ° CSV Ñ„Ð°Ð¹Ð»',0),(577951,16055,'ur','Ù…Ù„Ø§Ø²Ù… Ø§Ø®Ø±Ø§Ø¬Ø§Øª CSV ÙØ§Ø¦Ù„',0),(577952,16055,'sr','Ð—Ð°Ð¿Ð¾ÑÐ»ÐµÐ½Ð¸ Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸Ð¼Ð° Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(577953,16055,'vi','Tá»‡p CSV vá»›i chi phÃ­ nhÃ¢n viÃªn',0),(577954,16055,'af','Werknemer uitgawe CSV-lÃªer',0),(577955,16055,'ro','Angajat cheltuieli fiÅŸier CSV',0),(577956,16055,'et','TÃ¶Ã¶taja kulul CSV-faili',0),(577957,16055,'si','Datoteka CSV stroÅ¡ke zaposlenih',0),(577958,16055,'ba','File CSV biaya karyawan',0),(577959,16055,'nl','Werknemer kosten CSV-bestand',0),(577960,16055,'fi','TyÃ¶ntekijÃ¤n kulun CSV-tiedosto',0),(577961,16055,'no','Ansatte bekostning CSV-fil',0),(577962,16055,'da','Medarbejder udgift CSV-fil',0),(577963,16055,'ko','ì§ì› ê²½ë¹„ CSV íŒŒì¼',0),(577964,16055,'he','×§×•×‘×¥ ×”-CSV ×”×•×¦××•×ª ×œ×¢×•×‘×“',0),(577965,16055,'el','Î•ÏÎ³Î±Î¶ÏŒÎ¼ÎµÎ½Î¿ Î­Î¾Î¿Î´Î± Î±ÏÏ‡ÎµÎ¯Î¿ CSV',0),(577966,16055,'zh','å‘˜å·¥è´¹ç”¨ CSV æ–‡ä»¶',0),(577967,16055,'sv','Medarbetaren bekostnad CSV-filen',0),(577968,16055,'it','Employee Expense CSV File',0),(577969,16055,'tl','',0),(577970,16055,'th','à¹à¸Ÿà¹‰à¸¡ CSV à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢à¸‚à¸­à¸‡à¸žà¸™à¸±à¸à¸‡à¸²à¸™',0),(577971,16055,'hi','à¤•à¤°à¥à¤®à¤šà¤¾à¤°à¥€ à¤µà¥à¤¯à¤¯ CSV à¤«à¤¼à¤¾à¤‡à¤²',0),(577972,16055,'ms','Fail CSV perbelanjaan pekerja',0),(577973,16055,'ar','Ù…Ù„Ù CSV Ù†ÙÙ‚Ø§Øª Ø§Ù„Ù…ÙˆØ¸Ù',0),(577974,16055,'fr','Dossier CSV employÃ© frais',0),(577975,16055,'jp','å¾“æ¥­å“¡çµŒè²» CSV ãƒ•ã‚¡ã‚¤ãƒ«',0),(577976,16055,'pt','Arquivo CSV do empregado despesas',0),(577977,16055,'ru','Ð¡Ð¾Ñ‚Ñ€ÑƒÐ´Ð½Ð¸ÐºÐ° Ð·Ð° ÑÑ‡ÐµÑ‚ CSV-Ñ„Ð°Ð¹Ð»Ð°',0),(577978,16055,'es','Archivo CSV de gastos de empleado',0),(577979,16055,'de','Mitarbeiter-Kosten-CSV-Datei',0),(577980,16055,'en','Employee Expense CSV File',0),(577981,16056,'is','',0),(577982,16056,'dr','Ø¨Ø§ÛŒØ¯ Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ùˆ ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø¨Ù„Øº Ùˆ Ù‡Ø²ÛŒÙ†Ù‡ GL Ø­Ø³Ø§Ø¨ & Ø§Ù‡Ø¯Ø§Ù Ú©Ø³Ø¨ Ùˆ Ú©Ø§Ø±',0),(577983,16056,'pr','Ø¨Ø§ÛŒØ¯ Ø§Ø² ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø´Ù…Ø§Ø±Ù‡ Ùˆ ØªØ§Ø±ÛŒØ® Ù¾Ø±Ø¯Ø§Ø®Øª Ùˆ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø¨Ù„Øº Ùˆ Ù‡Ø²ÛŒÙ†Ù‡ GL Ø­Ø³Ø§Ø¨ & Ø§Ù‡Ø¯Ø§Ù Ú©Ø³Ø¨ Ùˆ Ú©Ø§Ø±',0),(577984,16056,'tr','SatÄ±cÄ± numarasÄ±, Ã¶deme tarihi, Ã¶deme tutarÄ±, gider GL hesabÄ± ve iÅŸ amaÃ§lÄ± olmasÄ± gerekir',0),(577985,16056,'pl','Musi mieÄ‡ numer dostawcy, Data pÅ‚atnoÅ›ci, kwota pÅ‚atnoÅ›ci, konto wydatkÃ³w GL & celÃ³w biznesowych',0),(577986,16056,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ°, Ð´Ð°Ñ‚Ð°Ñ‚Ð° Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, ÑÑƒÐ¼Ð° Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ, GL ÑÐ¼ÐµÑ‚ÐºÐ° & Ð±Ð¸Ð·Ð½ÐµÑ Ñ†ÐµÐ»',0),(577987,16056,'ur','ÙˆÛŒÙ†ÚˆØ± Ù†Ù…Ø¨Ø±ØŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®ØŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©ÛŒ Ø±Ù‚Ù…ØŒ Ø§Ø®Ø±Ø§Ø¬Ø§Øª Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ & Ú©Ø§Ø±ÙˆØ¨Ø§Ø±ÛŒ Ù…Ù‚ØµØ¯ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(577988,16056,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð±Ñ€Ð¾Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°, Ð”Ð°Ñ‚ÑƒÐ¼ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ, Ð¸Ð·Ð½Ð¾Ñ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ, ÐšÐ¾Ð½Ñ‚Ð¾ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð“Ð› & Ð¿Ð¾ÑÐ»Ð¾Ð²Ð½Ðµ ÑÐ²Ñ€Ñ…Ðµ',0),(577989,16056,'vi','Pháº£i cÃ³ sá»‘ lÆ°á»£ng ngÆ°á»i bÃ¡n hÃ ng, ngÃ y thanh toÃ¡n, sá»‘ tiá»n thanh toÃ¡n, tÃ i khoáº£n chi phÃ­ GL & má»¥c Ä‘Ã­ch kinh doanh',0),(577990,16056,'af','Handelaar nommer, datum van betaling, betaling bedrag, uitgawe GL rekening & sake doel moet hÃª',0),(577991,16056,'ro','Trebuie sÄƒ aibÄƒ numÄƒrul furnizorului, data platii, suma de plata, cont de GL cheltuialÄƒ & scop de afaceri',0),(577992,16056,'et','Peab olema hankija numbri, makse kuupÃ¤eva, makse summa, kulukonto GL- & Ã„riotstarve',0),(577993,16056,'si','Mora imeti Å¡tevilko dobavitelja, datum plaÄila, znesek plaÄila, Konto stroÅ¡kov GL & poslovni namen',0),(577994,16056,'ba','Harus memiliki nomor Vendor, tanggal pembayaran, jumlah pembayaran, rekening pengeluaran GL & tujuan bisnis',0),(577995,16056,'nl','Moet leveranciersnummer, Betaaldatum, betalingsbedrag, GL kostenrekening & bedrijfsdoel',0),(577996,16056,'fi','On oltava toimittajanumeron, maksupÃ¤ivÃ¤, maksusumma, GL kulutili & liiketoiminnassa',0),(577997,16056,'no','MÃ¥ ha leverandÃ¸rnummeret, betalingsdato, betalingsbelÃ¸pet, GL kostnadskonto & forretningsformÃ¥l',0),(577998,16056,'da','Skal kreditornummer, betalingsdato, betalingsbelÃ¸bet, GL udgiftskonto & forretningsformÃ¥l',0),(577999,16056,'ko','ê³µê¸‰ ì—…ì²´ ë²ˆí˜¸, ê²°ì œ ë‚ ì§œ, ê²°ì œ ê¸ˆì•¡, ë¹„ìš© GL ê³„ì • ë° ì‚¬ì—… ëª©ì ì„ê°€ì§€ê³  ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(578000,16056,'he','×—×™×™×‘ ×œ×”×™×•×ª ×ž×¡×¤×¨ ×”×¡×¤×§, ×ª××¨×™×š ×”×ª×©×œ×•×, ×¡×›×•× ×”×ª×©×œ×•×, ×—×©×‘×•×Ÿ ×”×•×¦××•×ª GL & ×ž×˜×¨×” ×¢×¡×§×™×ª',0),(578001,16056,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®, Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚, Ï€Î¿ÏƒÏŒ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚, Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î´Î±Ï€Î¬Î½Î· & ÎµÏ€Î¹Ï‡ÎµÎ¹ÏÎ·Î¼Î±Ï„Î¹ÎºÏŒ ÏƒÎºÎ¿Ï€ÏŒ',0),(578002,16056,'zh','å¿…é¡»æœ‰ä¾›åº”å•†ç¼–å·ã€ ä»˜æ¬¾æ—¥æœŸã€ ä»˜æ¬¾é‡‘é¢ã€ è´¹ç”¨æ€»å¸å¸æˆ·ä¸Žç»è¥å®—æ—¨',0),(578003,16056,'sv','MÃ¥ste ha leverantÃ¶rsnummer, betalningsdatum, betalningsbeloppet, GL utgiftskonto & affÃ¤rssyfte',0),(578004,16056,'it','Deve avere il numero del fornitore, data di pagamento, importo del pagamento, conto spese GL & scopo commerciale',0),(578005,16056,'tl','',0),(578006,16056,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸œà¸¹à¹‰à¸‚à¸²à¸¢ à¸§à¸±à¸™à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢ à¹à¸¥à¸°à¸§à¸±à¸•à¸–à¸¸à¸›à¸£à¸°à¸ªà¸‡à¸„à¹Œà¸',0),(578007,16056,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾, à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¤à¤¾à¤°à¥€à¤–, à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤°à¤¾à¤¶à¤¿, à¤µà¥à¤¯à¤¯ GL à¤–à¤¾à¤¤à¥‡ & à¤µà¥à¤¯à¤µà¤¸à¤¾à¤¯ à¤‰à¤¦à¥à¤¦à¥‡à¤¶à¥à¤¯ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(578008,16056,'ms','Mesti mempunyai nombor Vendor, tarikh pembayaran, jumlah pembayaran, akaun GL perbelanjaan & maksud perniagaan',0),(578009,16056,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ø±Ù‚Ù… Ø§Ù„Ù…ÙˆØ±Ø¯ØŒ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹ØŒ ÙˆØ¯ÙØ¹ Ø§Ù„Ù…Ø¨Ù„ØºØŒ ÙˆØ­Ø³Ø§Ø¨ GL Ø§Ù„Ù…ØµØ§Ø±ÙŠÙ & Ø§Ù„ØºØ±Ø¶ Ø§Ù„ØªØ¬Ø§Ø±ÙŠ',0),(578010,16056,'fr','Doit avoir le numÃ©ro de fournisseur, Date de paiement, montant du paiement, compte de dÃ©penses GL & objectif commercial',0),(578011,16056,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ç•ªå·ã€æ”¯æ‰•æ—¥ã€æ”¯æ‰•é‡‘é¡ã€çµŒè²» GL ãƒ» ãƒ“ã‚¸ãƒã‚¹ç›®çš„ãŒå¿…è¦',0),(578012,16056,'pt','Deve ter o nÃºmero do fornecedor, data de pagamento, valor do pagamento, despesa GL conta & fins comerciais',0),(578013,16056,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¸Ð¼ÐµÑ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°, Ð´Ð°Ñ‚Ñƒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°, ÑÑƒÐ¼Ð¼Ð° Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð°, ÑÑ‡ÐµÑ‚ GL & Ð±Ð¸Ð·Ð½ÐµÑ Ñ†ÐµÐ»Ð¸',0),(578014,16056,'es','Debe tener nÃºmero de proveedor, fecha de pago, monto del pago, cuenta de contabilidad de costo y propÃ³sito de negocio',0),(578015,16056,'de','Lieferantennummer, Zahlungsdatum, Zahlungsbetrag, GL Aufwandskonto & GeschÃ¤ftszweck muss',0),(578016,16056,'en','Must Have Vendor Number, Payment Date, Payment Amount, Expense GL Account & Business Purpose',0),(578017,16057,'is','',0),(578018,16057,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ID Ù†Ø´Ø¯',0),(578019,16057,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ID Ù†Ø´Ø¯',0),(578020,16057,'tr','SatÄ±cÄ± ID deÄŸil kurmak',0),(578021,16057,'pl','Identyfikator dostawcy nie znaleziono',0),(578022,16057,'bg','ÐÐµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½ Ð˜Ð” Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(578023,16057,'ur','ÙˆÛŒÙ†ÚˆØ± Ø´Ù†Ø§Ø®Øª Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(578024,16057,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð˜Ð” Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(578025,16057,'vi','Vendor ID khÃ´ng tÃ¬m tháº¥y',0),(578026,16057,'af','Handelaar ID nie gevind nie',0),(578027,16057,'ro','ID de furnizor negÄƒsit',0),(578028,16057,'et','Hankija ID ei leitud',0),(578029,16057,'si','ID prodajalca, ni mogoÄe najti',0),(578030,16057,'ba','Penjual ID tidak ditemukan',0),(578031,16057,'nl','Leverancier-ID niet gevonden',0),(578032,16057,'fi','Toimittajatunnus ei lÃ¶ydy',0),(578033,16057,'no','LeverandÃ¸r-ID ikke funnet',0),(578034,16057,'da','LeverandÃ¸r-ID blev ikke fundet',0),(578035,16057,'ko','ê³µê¸‰ ì—…ì²´ ID ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(578036,16057,'he','×ž×–×”×” ×¡×¤×§ ×œ× × ×ž×¦×',0),(578037,16057,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(578038,16057,'zh','ä¾›åº”å•† ID æ‰¾ä¸åˆ°',0),(578039,16057,'sv','LeverantÃ¶rs-ID hittades inte',0),(578040,16057,'it','Vendor ID non trovato',0),(578041,16057,'tl','',0),(578042,16057,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(578043,16057,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ ID à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(578044,16057,'ms','Nombor vendor ID tidak dijumpai',0),(578045,16057,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ù…Ø¹Ø±Ù Ø§Ù„Ù…ÙˆØ±Ø¯',0),(578046,16057,'fr','Vendor ID introuvable',0),(578047,16057,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ID ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(578048,16057,'pt','Vendor ID nÃ£o encontrado',0),(578049,16057,'ru','Ð£Ð´Ð¾ÑÑ‚Ð¾Ð²ÐµÑ€ÐµÐ½Ð¸Ðµ Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°',0),(578050,16057,'es','ID de proveedor no se encuentra',0),(578051,16057,'de','Hersteller-ID nicht gefunden',0),(578052,16057,'en','Vendor ID Not Found',0),(578053,16058,'is','',0),(578054,16058,'dr','Y/N',0),(578055,16058,'pr','Y/N',0),(578056,16058,'tr','Y/N',0),(578057,16058,'pl','Y/N',0),(578058,16058,'bg','Y/N',0),(578059,16058,'ur','Y/Ù†',0),(578060,16058,'sr','Y/Ð',0),(578061,16058,'vi','Y/N',0),(578062,16058,'af','Y/N',0),(578063,16058,'ro','Y/N',0),(578064,16058,'et','Y/N',0),(578065,16058,'si','Y/N',0),(578066,16058,'ba','Y/N',0),(578067,16058,'nl','J/N',0),(578068,16058,'fi','Y/N',0),(578069,16058,'no','J/N',0),(578070,16058,'da','Y/N',0),(578071,16058,'ko','Y/N',0),(578072,16058,'he','Y/N',0),(578073,16058,'el','Y/N',0),(578074,16058,'zh','Y/N',0),(578075,16058,'sv','Y/N',0),(578076,16058,'it','Y/N',0),(578077,16058,'tl','',0),(578078,16058,'th','Y/N',0),(578079,16058,'hi','Y/N',0),(578080,16058,'ms','Y/N',0),(578081,16058,'ar','Y/N',0),(578082,16058,'fr','O/N',0),(578083,16058,'jp','Y/N',0),(578084,16058,'pt','S/N',0),(578085,16058,'ru','Y/N',0),(578086,16058,'es','S/N',0),(578087,16058,'de','J/N',0),(578088,16058,'en','Y/N',0),(578089,16059,'is','',0),(578090,16059,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯Ø§Ø¯Ù‡ ÙˆØ§Ø±Ø¯',0),(578091,16059,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø¯Ø§Ø¯Ù‡ ÙˆØ§Ø±Ø¯',0),(578092,16059,'tr','AlÄ±nan bÃ¼tÃ§e verilerini',0),(578093,16059,'pl','Importowane dane budÅ¼etu',0),(578094,16059,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð¸ Ð´Ð°Ð½Ð½Ð¸, Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸',0),(578095,16059,'ur','Ø¨Ø¬Ù¹ Ú©ÙˆØ§Ø¦Ù Ø¯Ø±Ø¢Ù…Ø¯',0),(578096,16059,'sr','Ð‘ÑƒÑŸÐµÑ‚ÑÐºÐ¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸ ÑƒÐ²ÐµÐ·ÐµÐ½Ð¸',0),(578097,16059,'vi','NgÃ¢n sÃ¡ch dá»¯ liá»‡u nháº­p kháº©u',0),(578098,16059,'af','Begroting Data ingevoer',0),(578099,16059,'ro','Buget datele importate',0),(578100,16059,'et','Imporditud eelarve andmete',0),(578101,16059,'si','Uvozi podatke o proraÄunu',0),(578102,16059,'ba','Mengimpor Data anggaran',0),(578103,16059,'nl','Begrotingsgegevens geÃ¯mporteerd',0),(578104,16059,'fi','Budjettitietoja',0),(578105,16059,'no','Budsjettdata importert',0),(578106,16059,'da','Budgetdata importeres',0),(578107,16059,'ko','ê°€ì ¸ì˜¨ ì˜ˆì‚° ë°ì´í„°',0),(578108,16059,'he','× ×ª×•× ×™ ×ª×§×¦×™×‘ ×ž×™×•×‘××™×',0),(578109,16059,'el','ÎŸÎ¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÎ¬ Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï€Î¿Ï… ÎµÎ¹ÏƒÎ¬Î³Î¿Î½Ï„Î±Î¹',0),(578110,16059,'zh','å¯¼å…¥çš„é¢„ç®—æ•°æ®',0),(578111,16059,'sv','Budgetdata importeras',0),(578112,16059,'it','Dati di budget importati',0),(578113,16059,'tl','',0),(578114,16059,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“',0),(578115,16059,'hi','à¤¬à¤œà¤Ÿ à¤¡à¥‡à¤Ÿà¤¾ à¤†à¤¯à¤¾à¤¤',0),(578116,16059,'ms','Data bajet yang diimport',0),(578117,16059,'ar','Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ù…Ø³ØªÙˆØ±Ø¯Ø©',0),(578118,16059,'fr','Budget les donnÃ©es importÃ©es',0),(578119,16059,'jp','äºˆç®—ãƒ‡ãƒ¼ã‚¿ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(578120,16059,'pt','OrÃ§amento dados importados',0),(578121,16059,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€ÑƒÐµÐ¼Ñ‹Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð°',0),(578122,16059,'es','Datos de presupuesto importados',0),(578123,16059,'de','Budgetdaten nicht importiert',0),(578124,16059,'en','Budget Data Imported',0),(578125,16060,'is','',0),(578126,16060,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ Ù…Ø¹ØªØ¨Ø± Ù†ÛŒØ³Øª',0),(578127,16060,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ Ù…Ø¹ØªØ¨Ø± Ù†ÛŒØ³Øª',0),(578128,16060,'tr','BÃ¼tÃ§e yÄ±l geÃ§erli deÄŸil',0),(578129,16060,'pl','Roku budÅ¼etowego nie waÅ¼ne',0),(578130,16060,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð½Ðµ Ðµ Ð²Ð°Ð»Ð¸Ð´ÐµÐ½',0),(578131,16060,'ur','Ø¨Ø¬Ù¹ Ø³Ø§Ù„ Ø¬Ø§Ø¦Ø² Ù†ÛÛŒÚº',0),(578132,16060,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ Ð±ÑƒÑŸÐµÑ‚ Ð½Ð¸Ñ˜Ðµ Ð²Ð°Ð¶ÐµÑ›Ð°',0),(578133,16060,'vi','NgÃ¢n sÃ¡ch nÄƒm khÃ´ng há»£p lá»‡',0),(578134,16060,'af','Begroting jaar nie geldig nie',0),(578135,16060,'ro','An bugetar nu este valabil',0),(578136,16060,'et','Eelarveaastal ei sobi',0),(578137,16060,'si','ProraÄunskega leta ni veljavna',0),(578138,16060,'ba','Tahun anggaran tidak Valid',0),(578139,16060,'nl','Begrotingsjaar niet geldig',0),(578140,16060,'fi','Varainhoitovuoden ei kelpaa',0),(578141,16060,'no','Budsjett Ã¥ret ikke gyldig',0),(578142,16060,'da','RegnskabsÃ¥r ikke gyldigt',0),(578143,16060,'ko','ì˜ˆì‚° 1 ë…„ ìœ íš¨ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(578144,16060,'he','×ª×§×¦×™×‘ ×”×©× ×” ×œ× ×—×•×§×™',0),(578145,16060,'el','ÎŸÎ¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ·',0),(578146,16060,'zh','é¢„ç®—å¹´åº¦æ— æ•ˆ',0),(578147,16060,'sv','BudgetÃ¥r inte giltigt',0),(578148,16060,'it','Bilancio anno non valido',0),(578149,16060,'tl','',0),(578150,16060,'th','à¸›à¸µà¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(578151,16060,'hi','à¤¬à¤œà¤Ÿ à¤µà¤°à¥à¤· à¤®à¤¾à¤¨à¥à¤¯ à¤¨à¤¹à¥€à¤‚',0),(578152,16060,'ms','Tahun belanjawan yang tidak sah',0),(578153,16060,'ar','Ø³Ù†Ø© Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© ØºÙŠØ± ØµØ§Ù„Ø­Ø©',0),(578154,16060,'fr','Exercice budgÃ©taire non valide',0),(578155,16060,'jp','äºˆç®—ã®å¹´ãŒç„¡åŠ¹ã§ã™ã€‚',0),(578156,16060,'pt','Ano de orÃ§amento nÃ£o Ã© vÃ¡lido',0),(578157,16060,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð½Ñ‹Ð¹ Ð³Ð¾Ð´ Ð½Ðµ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¼',0),(578158,16060,'es','Ejercicio no vÃ¡lido',0),(578159,16060,'de','Haushaltsjahr nicht gÃ¼ltig',0),(578160,16060,'en','Budget Year Not Valid',0),(578161,16061,'is','',0),(578162,16061,'dr','GL Ø¨ÙˆØ¯Ø¬Ù‡ Ø³ØªÙˆÙ†',0),(578163,16061,'pr','GL Ø¨ÙˆØ¯Ø¬Ù‡ Ø³ØªÙˆÙ†',0),(578164,16061,'tr','GL bÃ¼tÃ§e sÃ¼tunlarÄ±',0),(578165,16061,'pl','GL budÅ¼etu kolumn',0),(578166,16061,'bg','GL Ð±ÑŽÐ´Ð¶ÐµÑ‚ ÐºÐ¾Ð»Ð¾Ð½Ð¸',0),(578167,16061,'ur','Ø¬ÛŒØ¬Û’ Ø¨Ø¬Ù¹ Ú©Ø§Ù„Ù…',0),(578168,16061,'sr','Ð“Ð› Ð±ÑƒÑŸÐµÑ‚Ð° ÐºÐ¾Ð»Ð¾Ð½Ðµ',0),(578169,16061,'vi','Cá»™t ngÃ¢n sÃ¡ch GL',0),(578170,16061,'af','GL begroting kolomme',0),(578171,16061,'ro','Coloane de buget GL',0),(578172,16061,'et','GL eelarve veerud',0),(578173,16061,'si','GL proraÄuna stolpcev',0),(578174,16061,'ba','GL anggaran kolom',0),(578175,16061,'nl','GL begroting kolommen',0),(578176,16061,'fi','GL budjetin sarakkeet',0),(578177,16061,'no','GL budsjettkolonner',0),(578178,16061,'da','GL Budget kolonner',0),(578179,16061,'ko','GL ì˜ˆì‚° ì—´',0),(578180,16061,'he','×¢×ž×•×“×•×ª ×ª×§×¦×™×‘ GL',0),(578181,16061,'el','GL Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï ÏƒÏ„Î®Î»ÎµÏ‚',0),(578182,16061,'zh','GL é¢„ç®—åˆ—',0),(578183,16061,'sv','GL Budget kolumner',0),(578184,16061,'it','Colonne di Budget di contabilitÃ  generale',0),(578185,16061,'tl','',0),(578186,16061,'th','à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œà¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“ GL',0),(578187,16061,'hi','GL à¤¬à¤œà¤Ÿ à¤•à¥‰à¤²à¤®',0),(578188,16061,'ms','GL bajet tiang',0),(578189,16061,'ar','Ø£Ø¹Ù…Ø¯Ø© GL Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ©',0),(578190,16061,'fr','Colonnes de Budget GL',0),(578191,16061,'jp','GL äºˆç®—åˆ—',0),(578192,16061,'pt','Colunas de orÃ§amento GL',0),(578193,16061,'ru','GL Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° ÑÑ‚Ð¾Ð»Ð±Ñ†Ñ‹',0),(578194,16061,'es','GL presupuesto columnas',0),(578195,16061,'de','GL-Budget-Spalten',0),(578196,16061,'en','GL Budget Columns',0),(578197,16062,'is','',0),(578198,16062,'dr','ÙØ§ÛŒÙ„ CSV Ø¨ÙˆØ¯Ø¬Ù‡ GL',0),(578199,16062,'pr','ÙØ§ÛŒÙ„ CSV Ø¨ÙˆØ¯Ø¬Ù‡ GL',0),(578200,16062,'tr','GL bÃ¼tÃ§e CSV dosya',0),(578201,16062,'pl','Plik CSV budÅ¼etu GL',0),(578202,16062,'bg','GL Ð±ÑŽÐ´Ð¶ÐµÑ‚ CSV Ñ„Ð°Ð¹Ð»',0),(578203,16062,'ur','Ø¬ÛŒØ¬Û’ Ø¨Ø¬Ù¹ CSV ÙØ§Ø¦Ù„',0),(578204,16062,'sr','Ð“Ð› Ð±ÑƒÑŸÐµÑ‚Ð° Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(578205,16062,'vi','Tá»‡p CSV ngÃ¢n sÃ¡ch GL',0),(578206,16062,'af','GL begroting CSV-lÃªer',0),(578207,16062,'ro','GL buget fiÅŸier CSV',0),(578208,16062,'et','GL eelarve CSV-faili',0),(578209,16062,'si','GL proraÄuna CSV datoteke',0),(578210,16062,'ba','File CSV GL anggaran',0),(578211,16062,'nl','GL begroting CSV-bestand',0),(578212,16062,'fi','GL talousarvion CSV-tiedosto',0),(578213,16062,'no','GL budsjett CSV-fil',0),(578214,16062,'da','GL Budget CSV-fil',0),(578215,16062,'ko','GL ì˜ˆì‚° CSV íŒŒì¼',0),(578216,16062,'he','×§×•×‘×¥ ×”-CSV ×ª×§×¦×™×‘ GL',0),(578217,16062,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ CSV Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï Î³/Î»',0),(578218,16062,'zh','GL é¢„ç®— CSV æ–‡ä»¶',0),(578219,16062,'sv','GL Budget CSV-filen',0),(578220,16062,'it','File CSV Budget di contabilitÃ  generale',0),(578221,16062,'tl','',0),(578222,16062,'th','à¹à¸Ÿà¹‰à¸¡ CSV à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“ GL',0),(578223,16062,'hi','GL à¤¬à¤œà¤Ÿ CSV à¤«à¤¼à¤¾à¤‡à¤²',0),(578224,16062,'ms','Fail CSV GL bajet',0),(578225,16062,'ar','Ù…Ù„Ù CSV Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© GL',0),(578226,16062,'fr','Fichier CSV de GL Budget',0),(578227,16062,'jp','GL äºˆç®— CSV ãƒ•ã‚¡ã‚¤ãƒ«',0),(578228,16062,'pt','Arquivo CSV orÃ§amento GL',0),(578229,16062,'ru','GL Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° CSV-Ñ„Ð°Ð¹Ð»Ð°',0),(578230,16062,'es','Archivo CSV de GL presupuesto',0),(578231,16062,'de','GL-Budget-CSV-Datei',0),(578232,16062,'en','GL Budget CSV File',0),(578233,16063,'is','',0),(578234,16063,'dr','Ø¨Ø§ÛŒØ¯ Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ Ø¨ÙˆØ¯Ø¬Ù‡ Ù†Ø§Ù… & Ø­Ø³Ø§Ø¨ GL',0),(578235,16063,'pr','Ø¨Ø§ÛŒØ¯ Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ Ø¨ÙˆØ¯Ø¬Ù‡ Ù†Ø§Ù… & Ø­Ø³Ø§Ø¨ GL',0),(578236,16063,'tr','BÃ¼tÃ§e yÄ±l, bÃ¼tÃ§e adÄ± ve GL hesabÄ± olmasÄ± gerekir',0),(578237,16063,'pl','Musi mieÄ‡ budÅ¼et roku, nazwa budÅ¼etu & konta k/g',0),(578238,16063,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð°, Ð¸Ð¼Ðµ Ð½Ð° Ð±ÑŽÐ´Ð¶ÐµÑ‚ & GL Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(578239,16063,'ur','Ø¨Ø¬Ù¹ Ø³Ø§Ù„ØŒ Ø¨Ø¬Ù¹ Ù†Ø§Ù… & Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(578240,16063,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð±ÑƒÑŸÐµÑ‚ Ð³Ð¾Ð´Ð¸Ð½Ðµ, Ð¸Ð¼Ðµ Ð±ÑƒÑŸÐµÑ‚Ð° & Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(578241,16063,'vi','Pháº£i cÃ³ ngÃ¢n sÃ¡ch nÄƒm nay, ngÃ¢n sÃ¡ch tÃªn & GL khoáº£n',0),(578242,16063,'af','Begrotingsjaar, begroting naam & GL rekening moet hÃª',0),(578243,16063,'ro','Trebuie sÄƒ aibÄƒ an bugetar, Nume buget & GL cont',0),(578244,16063,'et','Peab olema eelarveaasta, eelarve nimi- & GL konto',0),(578245,16063,'si','Mora imeti proraÄunskega leta, ime predraÄuna & GL raÄun',0),(578246,16063,'ba','Harus memiliki anggaran tahun, anggaran nama & GL Account',0),(578247,16063,'nl','Begrotingsjaar, budgetnaam & GL rekening moet',0),(578248,16063,'fi','On oltava varainhoitovuoden, budjetin nimi & Kirjanpitotilin pÃ¤Ã¤tilin',0),(578249,16063,'no','MÃ¥ budsjettet Ã¥ret, Budsjettnavn & gi-konto',0),(578250,16063,'da','Skal Have budgetÃ¥r, Budgetnavn & GL konto',0),(578251,16063,'ko','1 ë…„ ì˜ˆì‚°, ì˜ˆì‚° ì´ë¦„ & GL ê³„ì • ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(578252,16063,'he','×‘×˜×— ×™×© ×ª×§×¦×™×‘ ×”×©× ×”, ×ª×§×¦×™×‘ ×©× & ×—×©×‘×•×Ÿ GL',0),(578253,16063,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚, ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Ï‹Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï & Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(578254,16063,'zh','å¿…é¡»æœ‰é¢„ç®—å¹´åº¦ï¼Œé¢„ç®—åç§°ä¸Žæ€»å¸ç§‘ç›®',0),(578255,16063,'sv','MÃ¥ste ha budgetÃ¥ret, Budgetnamn & GL konto',0),(578256,16063,'it','Necessario disporre di anno di Budget, Budget nome & GL Account',0),(578257,16063,'tl','',0),(578258,16063,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸›à¸µ à¸Šà¸·à¹ˆà¸­à¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“ à¹à¸¥à¸°à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›',0),(578259,16063,'hi','à¤¬à¤œà¤Ÿ à¤µà¤°à¥à¤·, à¤¬à¤œà¤Ÿ à¤¨à¤¾à¤® & GL à¤–à¤¾à¤¤à¤¾ à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤•',0),(578260,16063,'ms','Mesti mempunyai tahun belanjawan, bajet nama & GL akaun',0),(578261,16063,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø³Ù†Ø©ØŒ Ø§Ø³Ù… Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© & Ø­Ø³Ø§Ø¨ GL',0),(578262,16063,'fr','Doit avoir exercice budgÃ©taire, Budget nom & compte GL',0),(578263,16063,'jp','äºˆç®—å¹´åº¦ã€äºˆç®—å & GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒå¿…è¦',0),(578264,16063,'pt','Deve ter ano de orÃ§amento, orÃ§amento nome & conta GL',0),(578265,16063,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð¸Ð¼ÐµÑ‚ÑŒ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð½Ñ‹Ð¹ Ð³Ð¾Ð´, Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð±ÑŽÐ´Ð¶ÐµÑ‚Ð° & GL ÑÑ‡ÐµÑ‚Ð°',0),(578266,16063,'es','Debe tener presupuesto aÃ±o, nombre y cuenta de contabilidad',0),(578267,16063,'de','Haushaltsjahr, Budgetnamen & Fibukonto mÃ¼ssen',0),(578268,16063,'en','Must Have Budget Year, Budget Name & GL Account',0),(578269,16064,'is','',0),(578270,16064,'dr','ØªÙ…Ø§Ù… Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯Ø± Ù¾Ø³Øª Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ Ø¯Ø± ÛŒÚ© Ø¨Ø§Ø±',0),(578271,16064,'pr','ØªÙ…Ø§Ù… Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯Ø± Ù¾Ø³Øª Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ Ø¯Ø± ÛŒÚ© Ø¨Ø§Ø±',0),(578272,16064,'tr','Yinelenen mesajlarÄ± hemen tÃ¼m giriÅŸler',0),(578273,16064,'pl','Wszystkich wpisÃ³w powtarzajÄ…cych posty naraz',0),(578274,16064,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð¿Ð¾ÑÑ‚Ð¾Ð²Ðµ Ð½Ð°Ð²ÐµÐ´Ð½ÑŠÐ¶',0),(578275,16064,'ur','Ø§ÛŒÚ© ÛÛŒ Ø¨Ø§Ø± Ù…ÛŒÚº Ø¨Ø§Ø± Ø¨Ø§Ø± ÛÙˆÙ†Û’ ÙˆØ§Ù„ÛŒ Ù¾ÙˆØ³Ù¹Ø³ Ù…ÛŒÚº ØªÙ…Ø§Ù… Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(578276,16064,'sr','Ð¡Ð²Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ Ð¾Ð±Ñ˜Ð°Ð²Ðµ Ñƒ Ð¸ÑÑ‚Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(578277,16064,'vi','Táº¥t cáº£ cÃ¡c má»¥c trong láº·p láº¡i cÃ¡c bÃ i viáº¿t cÃ¹ng má»™t lÃºc',0),(578278,16064,'af','Alle inskrywings In herhalende poste op een slag',0),(578279,16064,'ro','Toate intrÄƒrile din recurente mesaje dintr-o datÄƒ',0),(578280,16064,'et','Korduva postitusi korraga kÃµiki kirjeid',0),(578281,16064,'si','Vse postavke v ponavljajoÄih delovnih mest hkrati',0),(578282,16064,'ba','Semua Entries dalam berulang posting sekaligus',0),(578283,16064,'nl','Alle vermeldingen In terugkerende berichten in Ã©Ã©n keer',0),(578284,16064,'fi','Kaikki tapahtumat toistuvat viestejÃ¤ kerralla',0),(578285,16064,'no','Alle oppfÃ¸ringer i regelmessige innlegg samtidig',0),(578286,16064,'da','Alle poster i tilbagevendende stillinger pÃ¥ en gang',0),(578287,16064,'ko','ë°˜ë³µ ê²Œì‹œë¬¼ì— í•œ ë²ˆì— ëª¨ë“  í•­ëª©',0),(578288,16064,'he','×›×œ ×”×¢×¨×›×™× ×—×•×–×¨×•×ª ×”×”×•×“×¢×•×ª ×‘×‘×ª ××—×ª',0),(578289,16064,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÏƒÎµ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏƒÎµÎ¹Ï‚ Ï„Î±Ï…Ï„ÏŒÏ‡ÏÎ¿Î½Î±',0),(578290,16064,'zh','å®šæœŸå‘˜é¢ä¸€æ¬¡ä¸­çš„æ‰€æœ‰æ¡ç›®',0),(578291,16064,'sv','Alla poster i Ã¥terkommande inlÃ¤gg pÃ¥ en gÃ¥ng',0),(578292,16064,'it','Tutte le voci ricorrenti post in una sola volta',0),(578293,16064,'tl','',0),(578294,16064,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¹ƒà¸™à¹‚à¸žà¸ªà¸•à¹Œà¸‹à¹‰à¸³à¹ƒà¸™à¸„à¸£à¸±à¹‰à¸‡à¹€à¸”à¸µà¸¢à¸§',0),(578295,16064,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤ªà¤¦à¥‹à¤‚ à¤ªà¤° à¤à¤• à¤¬à¤¾à¤° à¤®à¥‡à¤‚ à¤¸à¤­à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚',0),(578296,16064,'ms','Semua penyertaan dalam posting berulang sekali gus',0),(578297,16064,'ar','ÙƒØ§ÙØ© Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª ÙÙŠ Ø§Ù„ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ù…ØªÙƒØ±Ø±Ø© Ù…Ø±Ø© ÙˆØ§Ø­Ø¯Ø©',0),(578298,16064,'fr','Toutes les entrÃ©es de messages rÃ©currents Ã  la fois',0),(578299,16064,'jp','å®šæœŸçš„ãªè¨˜äº‹ã«ä¸€åº¦ã®ã™ã¹ã¦ã®ã‚¨ãƒ³ãƒˆãƒª',0),(578300,16064,'pt','Todas as entradas em Posts recorrentes ao mesmo tempo',0),(578301,16064,'ru','Ð’ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð² Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ…ÑÑ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ð¹ ÑÑ€Ð°Ð·Ñƒ',0),(578302,16064,'es','Todas las entradas de mensajes recurrentes a la vez',0),(578303,16064,'de','Alle EintrÃ¤ge In wiederkehrende BeitrÃ¤ge auf einmal',0),(578304,16064,'en','All Entries In Recurring Posts At Once',0),(578305,16065,'is','',0),(578306,16065,'dr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª ØªÚ©Ø±Ø§Ø±',0),(578307,16065,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª ØªÚ©Ø±Ø§Ø±',0),(578308,16065,'tr','Yinelenen sayÄ±sÄ±',0),(578309,16065,'pl','Liczba powtarzajÄ…cych',0),(578310,16065,'bg','ÐŸÐ¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð±Ñ€Ð¾Ð¹',0),(578311,16065,'ur','Ù…Ú©Ø±Ø± Ú©Ø§ Ø´Ù…Ø§Ø±',0),(578312,16065,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð³Ñ€Ð¾Ñ„',0),(578313,16065,'vi','Sá»‘ Ä‘á»‹nh ká»³',0),(578314,16065,'af','Herhalende telling',0),(578315,16065,'ro','Contele recurente',0),(578316,16065,'et','Korduva krahv',0),(578317,16065,'si','PonavljajoÄe se Å¡tevilo',0),(578318,16065,'ba','Menghitung berulang',0),(578319,16065,'nl','Terugkerende graaf',0),(578320,16065,'fi','Toistuva mÃ¤Ã¤rÃ¤',0),(578321,16065,'no','Regelmessig antall',0),(578322,16065,'da','Tilbagevendende tÃ¦ller',0),(578323,16065,'ko','ë°˜ë³µ íšŸìˆ˜',0),(578324,16065,'he','×¡×¤×™×¨×” ×—×•×–×¨×ª',0),(578325,16065,'el','Î ÎµÏÎ¹Î¿Î´Î¹ÎºÎ® ÎºÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ·',0),(578326,16065,'zh','é‡å¤è®¡æ•°',0),(578327,16065,'sv','Ã…terkommande Count',0),(578328,16065,'it','Conteggio di ricorso',0),(578329,16065,'tl','',0),(578330,16065,'th','à¸ˆà¸³à¸™à¸§à¸™à¸à¸²à¸£à¹€à¸à¸´à¸”à¸‹à¹‰à¸³',0),(578331,16065,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤—à¤£à¤¨à¤¾',0),(578332,16065,'ms','Kiraan berulang',0),(578333,16065,'ar','Ø¹Ø¯Ø¯ Ù…Ø±Ø§Øª Ù…ØªÙƒØ±Ø±Ø©',0),(578334,16065,'fr','Nombre rÃ©current',0),(578335,16065,'jp','å®šæœŸçš„ãªã‚«ã‚¦ãƒ³ãƒˆ',0),(578336,16065,'pt','Contagem de recorrente',0),(578337,16065,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ñ„Ð¾Ñ‚Ð¾',0),(578338,16065,'es','Recurrente de la cuenta',0),(578339,16065,'de','Wiederkehrende Graf',0),(578340,16065,'en','Recurring Count',0),(578341,16066,'is','',0),(578342,16066,'dr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(578343,16066,'pr','Ø¯ÙˆØ±Ù‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(578344,16066,'tr','Yinelenen dÃ¶nemi',0),(578345,16066,'pl','Termin cykliczny',0),(578346,16066,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(578347,16066,'ur','Ù…Ú©Ø±Ø± Ø¹Ø±ØµÛ',0),(578348,16066,'sr','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ ÐŸÐµÑ€Ð¸Ð¾Ð´',0),(578349,16066,'vi','Khoáº£ng thá»i gian Ä‘á»‹nh ká»³',0),(578350,16066,'af','Herhalende tydperk',0),(578351,16066,'ro','Perioada recurente',0),(578352,16066,'et','Korduva perioodi',0),(578353,16066,'si','PonavljajoÄa se obdobja',0),(578354,16066,'ba','Periode berulang',0),(578355,16066,'nl','Terugkerende periode',0),(578356,16066,'fi','Toistuvan jakson',0),(578357,16066,'no','Regelmessige periode',0),(578358,16066,'da','Tilbagevendende periode',0),(578359,16066,'ko','ë˜í’€ì´ ê¸°ê°„',0),(578360,16066,'he','×ª×§×•×¤×ª ×—×•×–×¨×•×ª',0),(578361,16066,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½Î¿ Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(578362,16066,'zh','åå¤å‡ºçŽ°çš„æ—¶æœŸ',0),(578363,16066,'sv','Ã…terkommande Period',0),(578364,16066,'it','Periodo ricorrente',0),(578365,16066,'tl','',0),(578366,16066,'th','à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸—à¸µà¹ˆà¹€à¸à¸´à¸”à¸‹à¹‰à¸³',0),(578367,16066,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤…à¤µà¤§à¤¿',0),(578368,16066,'ms','Tempoh berulang',0),(578369,16066,'ar','Ø§Ù„ÙØªØ±Ø© Ø§Ù„Ù…ØªÙƒØ±Ø±Ø©',0),(578370,16066,'fr','PÃ©riodique de pÃ©riode',0),(578371,16066,'jp','å®šæœŸçš„ãªæœŸé–“',0),(578372,16066,'pt','PerÃ­odo recorrente',0),(578373,16066,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(578374,16066,'es','PerÃ­odo recurrente',0),(578375,16066,'de','Wiederkehrende Periode',0),(578376,16066,'en','Recurring Period',0),(578377,16067,'is','',0),(578378,16067,'dr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡',0),(578379,16067,'pr','ØªØ§Ø±ÛŒØ® Ø´Ø±ÙˆØ¹ Ø¯ÙˆØ±Ù‡',0),(578380,16067,'tr','Yinelenen baÅŸlangÄ±Ã§ tarihi',0),(578381,16067,'pl','Cykliczne Data rozpoczÄ™cia',0),(578382,16067,'bg','ÐŸÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð½Ð°Ñ‡Ð°Ð»Ð½Ð° Ð´Ð°Ñ‚Ð°',0),(578383,16067,'ur','Ø¨Ø§Ø± Ø¨Ø§Ø± ÛÙˆÙ†Û’ ÙˆØ§Ù„ÛŒ Ø§Ø¨ØªØ¯Ø§Ø¦ÛŒ ØªØ§Ø±ÛŒØ®',0),(578384,16067,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾Ñ‡ÐµÑ‚ÐºÐ° Ð·Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸',0),(578385,16067,'vi','Äá»‹nh ká»³ ngÃ y báº¯t Ä‘áº§u',0),(578386,16067,'af','Herhalende begindatum',0),(578387,16067,'ro','Data de Ã®ncepere a recurente',0),(578388,16067,'et','Korduva alguskuupÃ¤ev',0),(578389,16067,'si','PonavljajoÄe se zaÄetni datum',0),(578390,16067,'ba','Berulang tanggal mulai',0),(578391,16067,'nl','Terugkerende begindatum',0),(578392,16067,'fi','Toistuva alkamispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(578393,16067,'no','Regelmessige startdatoen',0),(578394,16067,'da','Tilbagevendende startdato',0),(578395,16067,'ko','ë˜í’€ì´ ì‹œìž‘ ë‚ ì§œ',0),(578396,16067,'he','×ª××¨×™×š ×”×”×ª×—×œ×” ×—×•×–×¨×•×ª',0),(578397,16067,'el','Î•Ï€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î­Î½Î±ÏÎ¾Î·Ï‚',0),(578398,16067,'zh','å®šæœŸå¼€å§‹æ—¥æœŸ',0),(578399,16067,'sv','Ã…terkommande startdatum',0),(578400,16067,'it','Data di inizio ricorrente',0),(578401,16067,'tl','',0),(578402,16067,'th','à¸§à¸±à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸—à¸µà¹ˆà¹€à¸à¸´à¸”à¸‹à¹‰à¸³',0),(578403,16067,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(578404,16067,'ms','Tarikh mula berulang',0),(578405,16067,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¨Ø¯Ø¡ Ø§Ù„Ù…ØªÙƒØ±Ø±Ø©',0),(578406,16067,'fr','Date de dÃ©but rÃ©current',0),(578407,16067,'jp','å®šæœŸçš„ãªé–‹å§‹æ—¥',0),(578408,16067,'pt','Data de inÃ­cio do recorrente',0),(578409,16067,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸ÐµÑÑ Ð”Ð°Ñ‚Ð° Ð½Ð°Ñ‡Ð°Ð»Ð°',0),(578410,16067,'es','Fecha de inicio de recurrentes',0),(578411,16067,'de','Wiederkehrende Startdatum',0),(578412,16067,'en','Recurring Start Date',0),(578413,16068,'is','',0),(578414,16068,'dr','ØªØ§Ø±ÛŒØ® Ù…Ø¹Ú©ÙˆØ³',0),(578415,16068,'pr','ØªØ§Ø±ÛŒØ® Ù…Ø¹Ú©ÙˆØ³',0),(578416,16068,'tr','Ters kayÄ±t tarihi',0),(578417,16068,'pl','Cofania daty',0),(578418,16068,'bg','Ð—Ð°Ð´ÐµÐ½ Ð´Ð°Ñ‚Ð°',0),(578419,16068,'ur','ØªØ§Ø±ÛŒØ® ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(578420,16068,'sr','Ð¡Ð°Ð»Ð´Ð¾ ÑÑ‚Ð¾Ñ€Ð½Ð¾ Ð´Ð°Ñ‚ÑƒÐ¼',0),(578421,16068,'vi','Äáº£o ngÆ°á»£c cÃ¡c ngÃ y',0),(578422,16068,'af','Omkeer datum',0),(578423,16068,'ro','Data de mers Ã®napoi',0),(578424,16068,'et','Tagurdamine kuupÃ¤ev',0),(578425,16068,'si','Za vzvratno voÅ¾njo datum',0),(578426,16068,'ba','Membalikkan tanggal',0),(578427,16068,'nl','Omkering van de datum',0),(578428,16068,'fi','PalautuspÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(578429,16068,'no','TilbakefÃ¸ringsdato',0),(578430,16068,'da','TilbagefÃ¸rselsdato',0),(578431,16068,'ko','ë‚ ì§œë¥¼ ë°˜ì „',0),(578432,16068,'he','×ª××¨×™×š ×”×”×™×¤×•×š',0),(578433,16068,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±Î½Ï„Î¹Î»Î¿Î³Î¹ÏƒÎ¼Î¿Ï',0),(578434,16068,'zh','å†²é”€æ—¥æœŸ',0),(578435,16068,'sv','Ã…terfÃ¶ringsdatumet',0),(578436,16068,'it','Data di retromarcia',0),(578437,16068,'tl','',0),(578438,16068,'th','à¸§à¸±à¸™à¸à¸¥à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£',0),(578439,16068,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤ªà¥€à¤›à¥‡',0),(578440,16068,'ms','Menterbalikkan tarikh',0),(578441,16068,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¥Ù„ØºØ§Ø¡',0),(578442,16068,'fr','Date de la marche arriÃ¨re',0),(578443,16068,'jp','é€†è»¢ã®æ—¥',0),(578444,16068,'pt','Invertendo a data',0),(578445,16068,'ru','Ð ÐµÐ²ÐµÑ€ÑÐ¸Ð²Ð½Ñ‹Ð¹ Ð”Ð°Ñ‚Ð°',0),(578446,16068,'es','Fecha de inversiÃ³n',0),(578447,16068,'de','RÃ¼ckbuchungsdatum',0),(578448,16068,'en','Reversing Date',0),(578449,16069,'is','',0),(578450,16069,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø²ÛŒÙ†Ù‡ GL',0),(578451,16069,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø²ÛŒÙ†Ù‡ GL',0),(578452,16069,'tr','Maliyet GL hesap numarasÄ±',0),(578453,16069,'pl','Numer konta kosztÃ³w GL',0),(578454,16069,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ GL',0),(578455,16069,'ur','Ù‚ÛŒÙ…Øª Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø±',0),(578456,16069,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÐ¾Ð½Ñ‚Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð“Ð›',0),(578457,16069,'vi','Sá»‘ tÃ i khoáº£n chi phÃ­ GL',0),(578458,16069,'af','Koste GL rekeningnommer',0),(578459,16069,'ro','NumÄƒrul de cont cost GL',0),(578460,16069,'et','GL kulude kontonumbrit',0),(578461,16069,'si','Å tevilka raÄuna stroÅ¡kovno GL',0),(578462,16069,'ba','Nomor rekening biaya GL',0),(578463,16069,'nl','Kosten GL rekeningnummer',0),(578464,16069,'fi','Kustannusten GL tilinumero',0),(578465,16069,'no','Kostnader GL kontonummeret',0),(578466,16069,'da','Omkostninger GL kontonummer',0),(578467,16069,'ko','ë¹„ìš©ëœ GL ê³„ì • ë²ˆí˜¸',0),(578468,16069,'he','×ž×¡×¤×¨ ×—×©×‘×•×Ÿ ×¢×œ×•×ª GL',0),(578469,16069,'el','Î¤Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î³/Î» ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(578470,16069,'zh','æˆæœ¬çš„æ€»å¸ç§‘ç›®ç¼–å·',0),(578471,16069,'sv','Kostnad GL kontonummer',0),(578472,16069,'it','Numero di conto costo GL',0),(578473,16069,'tl','',0),(578474,16069,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢',0),(578475,16069,'hi','à¤²à¤¾à¤—à¤¤ GL à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(578476,16069,'ms','Nombor akaun kos GL',0),(578477,16069,'ar','Ø±Ù‚Ù… Ø­Ø³Ø§Ø¨ GL Ø§Ù„ØªÙƒÙ„ÙØ©',0),(578478,16069,'fr','NumÃ©ro de compte GL coÃ»t',0),(578479,16069,'jp','ã‚³ã‚¹ãƒˆã® GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå·',0),(578480,16069,'pt','NÃºmero de conta de custo GL',0),(578481,16069,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ GL',0),(578482,16069,'es','NÃºmero de cuenta costo GL',0),(578483,16069,'de','Kosten Hauptbuch-Kontonummer',0),(578484,16069,'en','Cost GL Account Number',0),(578485,16070,'is','',0),(578486,16070,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ GL',0),(578487,16070,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ ÙØ±ÙˆØ´ GL',0),(578488,16070,'tr','SatÄ±ÅŸ GL hesap numarasÄ±',0),(578489,16070,'pl','Numer konta sprzedaÅ¼y GL',0),(578490,16070,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ GL',0),(578491,16070,'ur','Ø³ÛŒÙ„Ø² Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø±',0),(578492,16070,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÐ¾Ð½Ñ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð“Ð›',0),(578493,16070,'vi','Sá»‘ tÃ i khoáº£n bÃ¡n hÃ ng GL',0),(578494,16070,'af','Verkope GL rekeningnommer',0),(578495,16070,'ro','NumÄƒrul de cont vÃ¢nzÄƒri GL',0),(578496,16070,'et','MÃ¼Ã¼gi GL kontonumber',0),(578497,16070,'si','Å tevilka raÄuna prodaje GL',0),(578498,16070,'ba','Nomor rekening penjualan GL',0),(578499,16070,'nl','Verkoop GL rekeningnummer',0),(578500,16070,'fi','Myynnin GL tilinumero',0),(578501,16070,'no','Salg GL kontonummer',0),(578502,16070,'da','Salg GL kontonummer',0),(578503,16070,'ko','íŒë§¤ GL ê³„ì • ë²ˆí˜¸',0),(578504,16070,'he','×ž×¡×¤×¨ ×—×©×‘×•×Ÿ ×ž×›×™×¨×•×ª GL',0),(578505,16070,'el','Î¤Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î³/Î» Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(578506,16070,'zh','é”€å”®æ€»å¸ç§‘ç›®ç¼–å·',0),(578507,16070,'sv','FÃ¶rsÃ¤ljning GL kontonummer',0),(578508,16070,'it','Numero di conto vendita GL',0),(578509,16070,'tl','',0),(578510,16070,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µ GL à¸‚à¸²à¸¢',0),(578511,16070,'hi','à¤¬à¤¿à¤•à¥à¤°à¥€ GL à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(578512,16070,'ms','Nombor akaun jualan GL',0),(578513,16070,'ar','Ø±Ù‚Ù… Ø­Ø³Ø§Ø¨ GL Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(578514,16070,'fr','NumÃ©ro de compte de vente GL',0),(578515,16070,'jp','å£²ã‚Šä¸Šã’é«˜ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå·',0),(578516,16070,'pt','NÃºmero da conta de vendas GL',0),(578517,16070,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶ GL',0),(578518,16070,'es','NÃºmero de cuenta de ventas GL',0),(578519,16070,'de','Verkauf Hauptbuch-Kontonummer',0),(578520,16070,'en','Sales GL Account Number',0),(578521,16071,'is','',0),(578522,16071,'dr','ØªÙ†Ù‡Ø§ Ù…ÙˆØ§Ø±Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± Ø¯Ø³Øª Ø¨Ø§Ø´Ø¯',0),(578523,16071,'pr','ØªÙ†Ù‡Ø§ Ù…ÙˆØ§Ø±Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¯Ø± Ø¯Ø³Øª Ø¨Ø§Ø´Ø¯',0),(578524,16071,'tr','Sadece Ã¶ÄŸeleri taraftan ÅŸu anda dahil',0),(578525,16071,'pl','Obejmuje tylko pozycje, obecnie na rÄ™kÄ™',0),(578526,16071,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° ÑÐ°Ð¼Ð¾ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸, ÐºÐ¾Ð¸Ñ‚Ð¾ Ð² Ð¼Ð¾Ð¼ÐµÐ½Ñ‚Ð° ÑÐ° Ð½Ð° Ñ€ÑŠÐºÐ°',0),(578527,16071,'ur','ØµØ±Ù ÛØ§ØªÚ¾ Ù¾Ø± Ø§Ø³ ÙˆÙ‚Øª Ø§Ø´ÛŒØ§Ø¡ Ù…ÛŒÚº Ø´Ø§Ù…Ù„',0),(578528,16071,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ ÑÐ°Ð¼Ð¾ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ðµ Ñ‚Ñ€ÐµÐ½ÑƒÑ‚Ð½Ð¾ Ð½Ð° Ð·Ð°Ð»Ð¸Ñ…Ð°Ð¼Ð°',0),(578529,16071,'vi','Bao gá»“m cÃ¡c chá»‰ má»¥c hiá»‡n cÃ³ trÃªn bÃ n tay',0),(578530,16071,'af','Slegs Items tans op Hand insluit',0),(578531,16071,'ro','Include numai elemente Ã®n prezent pe mÃ¢nÄƒ',0),(578532,16071,'et','Kaasa ainult Ã¼ksused praegu kÃ¼ljest',0),(578533,16071,'si','VkljuÄujejo samo artikli trenutno na zalogi',0),(578534,16071,'ba','Mencakup hanya item saat ini di tangan',0),(578535,16071,'nl','Alleen Items die momenteel op de Hand zijn',0),(578536,16071,'fi','SisÃ¤llyttÃ¤Ã¤ osia vain tÃ¤llÃ¤ hetkellÃ¤ kÃ¤sillÃ¤',0),(578537,16071,'no','Inkluder bare elementene er pÃ¥ hÃ¥nden',0),(578538,16071,'da','Omfatte kun varer i Ã¸jeblikket pÃ¥ hÃ¥nd',0),(578539,16071,'ko','ë°˜ë©´ì— í˜„ìž¬ í•­ëª©ë§Œ í¬í•¨',0),(578540,16071,'he','×œ×›×œ×•×œ ×¨×§ ×¤×¨×™×˜×™× ×›×¢×ª ×¢×œ ×”×™×“',0),(578541,16071,'el','Î£Ï…Î¼Ï€ÎµÏÎ¯Î»Î·ÏˆÎ· Î¼ÏŒÎ½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Ï‰Î½ ÎµÏ€Î¯ Ï„Î¿Ï… Ï€Î±ÏÏŒÎ½Ï„Î¿Ï‚ ÏƒÏ„Î¿ Ï‡Î­ÏÎ¹',0),(578542,16071,'zh','åŒ…æ‹¬ç›®å‰æ‰‹ä¸Šçš„åªæœ‰é¡¹ç›®',0),(578543,16071,'sv','Inkludera endast objekt som fÃ¶r nÃ¤rvarande pÃ¥ Hand',0),(578544,16071,'it','Includere solo gli elementi attualmente in mano',0),(578545,16071,'tl','',0),(578546,16071,'th','à¸£à¸§à¸¡à¹€à¸‰à¸žà¸²à¸°à¸£à¸²à¸¢à¸à¸²à¸£à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸¡à¸·à¸­',0),(578547,16071,'hi','à¤¹à¤¾à¤¥ à¤ªà¤° à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤®à¥‡à¤‚ à¤•à¥‡à¤µà¤² à¤†à¤‡à¤Ÿà¤® à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¥‡à¤‚',0),(578548,16071,'ms','Meliputi hanya perkara-perkara yang sedang di tangan',0),(578549,16071,'ar','ÙˆØªØ´Ù…Ù„ Ø§Ù„Ø¹Ù†Ø§ØµØ± ÙÙ‚Ø· Ø­Ø§Ù„ÙŠØ§ Ø¹Ù„Ù‰ ÙŠØ¯',0),(578550,16071,'fr','Inclure uniquement les points actuellement Ã  main',0),(578551,16071,'jp','ä¸€æ–¹ã§ç¾åœ¨ã®é …ç›®ã®ã¿',0),(578552,16071,'pt','Incluir apenas os itens atualmente na mÃ£o',0),(578553,16071,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ñ‚Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð² Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð½Ð° Ñ€ÑƒÐºÐµ',0),(578554,16071,'es','Incluir sÃ³lo los artÃ­culos actualmente en mano',0),(578555,16071,'de','Enthalten Sie nur Artikel derzeit auf der Seite',0),(578556,16071,'en','Include Only Items Currently On Hand',0),(578557,16072,'is','',0),(578558,16072,'dr','Ø§Ø¨Ø²Ø§Ø± Ù‡Ø§ÛŒ Ø®ÙˆØ¨ Ø¯Ø± Ú©Ø§Ø±',0),(578559,16072,'pr','Ø§Ø¨Ø²Ø§Ø± Ù‡Ø§ÛŒ Ø®ÙˆØ¨ Ø¯Ø± Ú©Ø§Ø±',0),(578560,16072,'tr','Ä°ÅŸ tamam AraÃ§lar',0),(578561,16072,'pl','OK narzÄ™dzia pracy',0),(578562,16072,'bg','ÐžÐš Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ð¸ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(578563,16072,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ù¾Ø± Ù¹Ú¾ÛŒÚ© ÛÛ’ Ù¹ÙˆÙ„',0),(578564,16072,'sr','Ð£ Ñ€ÐµÐ´Ñƒ Ð°Ð»Ð°Ñ‚ÐºÐµ Ð½Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(578565,16072,'vi','CÃ¡c cÃ´ng cá»¥ OK trÃªn cÃ´ng viá»‡c',0),(578566,16072,'af','OK gereedskap op werk',0),(578567,16072,'ro','Instrumente OK la muncÄƒ',0),(578568,16072,'et','OK tÃ¶Ã¶riistad tÃ¶Ã¶d',0),(578569,16072,'si','OK orodij na delo',0),(578570,16072,'ba','Alat-alat yang OK di kerja',0),(578571,16072,'nl','OK Tools op baan',0),(578572,16072,'fi','OK tyÃ¶kaluja tyÃ¶n',0),(578573,16072,'no','OK verktÃ¸yene pÃ¥ jobb',0),(578574,16072,'da','OK vÃ¦rktÃ¸jer pÃ¥ Job',0),(578575,16072,'ko','ìž‘ì—… í™•ì¸ ë„êµ¬',0),(578576,16072,'he','×›×œ×™× ×‘×¡×“×¨ ×‘×¢×‘×•×“×”',0),(578577,16072,'el','Î•Î½Ï„Î¬Î¾ÎµÎ¹ ÎµÏÎ³Î±Î»ÎµÎ¯Î± ÏƒÏ„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(578578,16072,'zh','åœ¨å·¥ä½œä¸Šçš„å¥½å·¥å…·',0),(578579,16072,'sv','OK verktyg pÃ¥ jobbet',0),(578580,16072,'it','OK strumenti sul lavoro',0),(578581,16072,'tl','',0),(578582,16072,'th','à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸¡à¸·à¸­à¸—à¸µà¹ˆà¸”à¸µà¹ƒà¸™à¸‡à¸²à¸™',0),(578583,16072,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¤° à¤ à¥€à¤• à¤‰à¤ªà¤•à¤°à¤£',0),(578584,16072,'ms','Alat-alat OK pada kerja',0),(578585,16072,'ar','Ø£Ø¯ÙˆØ§Øª Ù…ÙˆØ§ÙÙ‚ Ø¹Ù„Ù‰ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(578586,16072,'fr','OK outils de travail',0),(578587,16072,'jp','ä»•äº‹ã® [ok] ãƒ„ãƒ¼ãƒ«',0),(578588,16072,'pt','Okey ferramentas no trabalho',0),(578589,16072,'ru','ÐžÐš Ð¸Ð½ÑÑ‚Ñ€ÑƒÐ¼ÐµÐ½Ñ‚Ñ‹ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ',0),(578590,16072,'es','Herramientas aceptables en el trabajo',0),(578591,16072,'de','OK-Tools im Job',0),(578592,16072,'en','OK Tools On Job',0),(578593,16073,'is','',0),(578594,16073,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù…Ø§Ù„ÛŒØ§Øª Ú¯Ù… Ø´Ø¯Ù‡ Ø¨Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(578595,16073,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ù…Ø§Ù„ÛŒØ§Øª Ú¯Ù… Ø´Ø¯Ù‡ Ø¨Ù‡ Ù…Ø´ØªØ±ÛŒ',0),(578596,16073,'tr','Eksik vergi mÃ¼ÅŸteriye Ekle',0),(578597,16073,'pl','DodaÄ‡ brakujÄ…ce podatkÃ³w do klienta',0),(578598,16073,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð»Ð¸Ð¿ÑÐ²Ð°Ñ‰Ð¸ Ð´Ð°Ð½ÑŠÑ†Ð¸ ÐºÑŠÐ¼ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(578599,16073,'ur','Ú©Ù… Ù¹ÛŒÚ©Ø³ Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù„ÛŒÛ’ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(578600,16073,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ñƒ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° ÐºÑƒÐ¿Ñ†Ð°',0),(578601,16073,'vi','ThÃªm thuáº¿ cÃ²n thiáº¿u vÃ o khÃ¡ch hÃ ng',0),(578602,16073,'af','Voeg ontbreek belastings aan kliÃ«nt',0),(578603,16073,'ro','Adauga lipsesc taxele la client',0),(578604,16073,'et','Lisage puuduv maksude kliendi',0),(578605,16073,'si','Dodaj manjkajoÄe davkov kupcu',0),(578606,16073,'ba','Tambahkan hilang pajak kepada pelanggan',0),(578607,16073,'nl','Toevoegen van ontbrekende belastingen aan klant',0),(578608,16073,'fi','LisÃ¤Ã¤ puuttuvat veroja asiakkaalle',0),(578609,16073,'no','Legg til manglende skatter til kunde',0),(578610,16073,'da','TilfÃ¸j manglende afgifter til kunde',0),(578611,16073,'ko','ê³ ê°ì— ê²Œ ëˆ„ë½ ëœ ì„¸ê¸ˆì„ ì¶”ê°€',0),(578612,16073,'he','×œ×”×•×¡×™×£ ×ž×™×¡×™× ×—×¡×¨×™× ×œ×§×•×—×•×ª',0),(578613,16073,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÎµÏ„Îµ Î»ÎµÎ¯Ï€ÎµÎ¹ Ï†ÏŒÏÎ¿Ï…Ï‚ ÏƒÏ„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(578614,16073,'zh','å‘å®¢æˆ·æ·»åŠ ç¼ºå°‘çš„ç¨Ž',0),(578615,16073,'sv','LÃ¤gg till saknade skatter till kund',0),(578616,16073,'it','Aggiungere le tasse mancante al cliente',0),(578617,16073,'tl','',0),(578618,16073,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸ à¸²à¸©à¸µà¸‚à¸²à¸”à¹„à¸›à¹ƒà¸«à¹‰à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(578619,16073,'hi','à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§ à¤•à¤° à¤œà¥‹à¤¡à¤¼',0),(578620,16073,'ms','Tambah cukai hilang kepada pelanggan',0),(578621,16073,'ar','Ø¥Ø¶Ø§ÙØ© Ø¶Ø±Ø§Ø¦Ø¨ Ù…ÙÙ‚ÙˆØ¯Ø© Ù„Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(578622,16073,'fr','Ajouter les Taxes manquants au client',0),(578623,16073,'jp','ãŠå®¢æ§˜ã«ä¸è¶³ã—ã¦ã„ã‚‹ç¨Žé‡‘ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(578624,16073,'pt','Adicionar faltando impostos ao cliente',0),(578625,16073,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½ÐµÐ´Ð¾ÑÑ‚Ð°ÑŽÑ‰Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ð´Ð»Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(578626,16073,'es','Agregar impuestos faltantes al cliente',0),(578627,16073,'de','Fehlende Steuern zu Kunden hinzufÃ¼gen',0),(578628,16073,'en','Add Missing Taxes To Customer',0),(578629,16074,'is','',0),(578630,16074,'dr','Ø­Ø°Ù Ù…Ø§Ù„ÛŒØ§Øª ØºÛŒØ± Ù…Ù†Ø·Ø¨Ù‚ Ø§Ø² Ø³ÙØ§Ø±Ø´',0),(578631,16074,'pr','Ø­Ø°Ù Ù…Ø§Ù„ÛŒØ§Øª ØºÛŒØ± Ù…Ù†Ø·Ø¨Ù‚ Ø§Ø² Ø³ÙØ§Ø±Ø´',0),(578632,16074,'tr','Sigara eÅŸleÅŸen vergi dÃ¼zeninden kaldÄ±rmak',0),(578633,16074,'pl','UsunÄ…Ä‡ nie pasujÄ…ce podatkÃ³w od zamÃ³wienia',0),(578634,16074,'bg','ÐŸÑ€ÐµÐ¼Ð°Ñ…Ð½ÐµÑ‚Ðµ Ð±ÐµÐ· ÑÑŠÐ²Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð´Ð°Ð½ÑŠÑ†Ð¸ Ñ€ÐµÐ´',0),(578635,16074,'ur','ØºÛŒØ± Ù…Ø´Ø§Ø¨Û Ù¹ÛŒÚ©Ø³ ØªØ±ØªÛŒØ¨ Ø³Û’ ÛÙ¹Ø§Ø¦ÛŒÚº',0),(578636,16074,'sr','Ð£ÐºÐ»Ð¾Ð½Ð¸Ñ‚Ðµ ÐºÐ¾Ñ˜Ð¸ Ð½Ð¸ÑÑƒ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð¸Ð· Ð½Ð°Ð»Ð¾Ð³Ð°',0),(578637,16074,'vi','Loáº¡i bá» cÃ¡c loáº¡i thuáº¿ khÃ´ng phÃ¹ há»£p vá»›i tá»« thá»© tá»±',0),(578638,16074,'af','Verwyder nie bypassende belastings van orde',0),(578639,16074,'ro','EliminaÅ£i Non-potrivire impozitele la comanda',0),(578640,16074,'et','Tellimuse mitte vastavaid maksude eemaldamine',0),(578641,16074,'si','Odstraniti Non ujemanje davkov iz naloga',0),(578642,16074,'ba','Hapus pencocokan bebas pajak dari urutan',0),(578643,16074,'nl','Niet overeenkomende belastingen uit de Order verwijderen',0),(578644,16074,'fi','Poista ei vastaavia veroja tilauksesta',0),(578645,16074,'no','Fjerne ikke samsvarende skatter fra ordre',0),(578646,16074,'da','Fjern ikke matchende skatter fra ordre',0),(578647,16074,'ko','ìˆœì„œì—ì„œ ë¹„ ì¼ì¹˜ ì„¸ê¸ˆ ì œê±°',0),(578648,16074,'he','×œ×”×¡×™×¨ ××ª ×”×ž×™×¡×™× ×©××™× × ×ª×•××ž×™× ×ž×”×”×–×ž× ×”',0),(578649,16074,'el','ÎšÎ±Ï„Î±ÏÎ³Î®ÏƒÎµÏ„Îµ Î¼Î· Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï†ÏŒÏÏ‰Î½ Î±Ï€ÏŒ ÏƒÎµÎ¹ÏÎ¬',0),(578650,16074,'zh','ä»Žè®¢å•ä¸­åˆ é™¤éžåŒ¹é…ç¨Ž',0),(578651,16074,'sv','Ta bort icke matchande skatter frÃ¥n Order',0),(578652,16074,'it','Rimuovere Non corrispondenti imposte dall\'ordine',0),(578653,16074,'tl','',0),(578654,16074,'th','à¹€à¸­à¸²à¸ à¸²à¸©à¸µà¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸ˆà¸²à¸à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(578655,16074,'hi','à¤•à¥à¤°à¤® à¤¸à¥‡ à¤®à¤¿à¤²à¤¾à¤¨ à¤—à¥ˆà¤° à¤•à¤°à¥‹à¤‚ à¤¨à¤¿à¤•à¤¾à¤²',0),(578656,16074,'ms','Keluarkn sepadan bebas cukai perintah',0),(578657,16074,'ar','Ø¥Ø²Ø§Ù„Ø© Ø§Ù„Ø¶Ø±Ø§Ø¦Ø¨ ØºÙŠØ± Ù…Ø·Ø§Ø¨Ù‚Ø© Ù…Ù† Ø§Ù„Ù†Ø¸Ø§Ù…',0),(578658,16074,'fr','Enlever les Taxes Non assortis dâ€™ordre',0),(578659,16074,'jp','ã‚ªãƒ¼ãƒ€ãƒ¼ã‹ã‚‰éžä¸€è‡´ã™ã‚‹ç¨Žé‡‘ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(578660,16074,'pt','Remover os impostos nÃ£o correspondÃªncia da ordem',0),(578661,16074,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ Ð½Ðµ ÑÐ¾Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ð¸Ð· Ð¿Ð¾Ñ€ÑÐ´ÐºÐ°',0),(578662,16074,'es','Eliminar impuestos no coincidentes de orden',0),(578663,16074,'de','Nicht Ã¼bereinstimmende Steuern aus der Bestellung lÃ¶schen',0),(578664,16074,'en','Remove Non Matching Taxes From Order',0),(578665,16075,'is','',0),(578666,16075,'dr','ØªÙ†Ø¸ÛŒÙ… Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ Ø§ÛŒÙ† Ù†Ø¸Ù… Ø³Ø§Ø²Ú¯Ø§Ø± Ù†ÛŒØ³Øª',0),(578667,16075,'pr','ØªÙ†Ø¸ÛŒÙ… Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ Ø§ÛŒÙ† Ù†Ø¸Ù… Ø³Ø§Ø²Ú¯Ø§Ø± Ù†ÛŒØ³Øª',0),(578668,16075,'tr','Bu mÃ¼ÅŸteri iÃ§in satÄ±ÅŸ vergisi Kur sipariÅŸ eÅŸleÅŸmiyor',0),(578669,16075,'pl','Ustawienia podatku od sprzedaÅ¼y dla tego klienta nie jest zgodna z kolejnoÅ›ciÄ…',0),(578670,16075,'bg','ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°Ñ‚Ð° Ð½Ð° Ð´Ð°Ð½ÑŠÐº Ð²ÑŠÑ€Ñ…Ñƒ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸Ñ‚Ðµ Ð·Ð° Ñ‚Ð¾Ð·Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ðµ Ð¾Ñ‚Ð³Ð¾Ð²Ð°Ñ€ÑÑ‚ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ°Ñ‚Ð°',0),(578671,16075,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø³ÛŒÙ¹ Ø§Ù¾ Ø§Ø³ Ú¯Ø§ÛÚ© Ú©Û’ Ù„Ø¦Û’ ØªØ±ØªÛŒØ¨ Ø³Û’ Ù…ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ú¾Ø§ØªØ§',0),(578672,16075,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐ° Ð·Ð° Ð¾Ð²Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð° ÑÐµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐ° Ñ€ÐµÐ´Ð¾ÑÐ»ÐµÐ´',0),(578673,16075,'vi','Thiáº¿t láº­p thuáº¿ bÃ¡n hÃ ng cho khÃ¡ch hÃ ng nÃ y khÃ´ng phÃ¹ há»£p vá»›i Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(578674,16075,'af','Die verkope belasting opstelling vir hierdie kliÃ«nt nie ooreenstem met die volgorde',0),(578675,16075,'ro','Instalare de impozitul pe vÃ¢nzÄƒri pentru acest client nu se potriveÅŸte cu ordinea',0),(578676,16075,'et','KÃ¤ibemaksu seadistamise selle kliendi puhul ei vasta tellimuse',0),(578677,16075,'si','Nastavitvi prometnega davka za to stranko ne ujemajo z vrstni redom',0),(578678,16075,'ba','Pajak Penjualan Setup untuk pelanggan ini tidak sesuai urutan',0),(578679,16075,'nl','De Setup van de Sales Tax voor deze klant komt niet overeen met de volgorde',0),(578680,16075,'fi','Asiakkaan ALV-asetukset ei vastaa tilauksen',0),(578681,16075,'no','Mva-oppsettet For denne kunden tilsvarer ikke rekkefÃ¸lgen',0),(578682,16075,'da','OpsÃ¦tningen Sales Tax For denne kunde svarer ikke til rÃ¦kkefÃ¸lgen',0),(578683,16075,'ko','ì´ ê³ ê°ì— ëŒ€ í•œ íŒë§¤ ì„¸ê¸ˆ ì„¤ì • ìˆœì„œì™€ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(578684,16075,'he','×”×’×“×¨×ª ×ž×¢ ×ž ×¢×‘×•×¨ ×œ×§×•×— ×–×” ××™× ×• ×ª×•×× ××ª ×”×¡×“×¨',0),(578685,16075,'el','Î¤Î¿ Ï€ÏÏŒÎ³ÏÎ±Î¼Î¼Î± ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î· Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î¼Îµ Ï„Î· ÏƒÎµÎ¹ÏÎ¬',0),(578686,16075,'zh','æ­¤å®¢æˆ·çš„å¢žå€¼ç¨Žè®¾ç½®ä¸åŒ¹é…çš„è®¢å•',0),(578687,16075,'sv','MomsinstÃ¤llningarna fÃ¶r kunden matchar inte ordningen',0),(578688,16075,'it','Le impostazioni IVA per questo cliente non corrispondano l\'ordine',0),(578689,16075,'tl','',0),(578690,16075,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢à¸ªà¸³à¸«à¸£à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²à¸£à¸²à¸¢à¸™à¸µà¹‰à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(578691,16075,'hi','à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤° à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¥à¤°à¤® à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(578692,16075,'ms','Persediaan cukai jualan untuk pelanggan tidak sepadan dengan perintah itu',0),(578693,16075,'ar','Ø¥Ø¹Ø¯Ø§Ø¯ Ø¶Ø±ÙŠØ¨Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù…ÙŠÙ„ Ù„Ø§ ÙŠØ·Ø§Ø¨Ù‚ Ø§Ù„ØªØ±ØªÙŠØ¨',0),(578694,16075,'fr','La configuration de la taxe de vente pour ce client ne correspond pas Ã  lâ€™ordre',0),(578695,16075,'jp','ã“ã®é¡§å®¢ã®å£²ä¸Šç¨Žè¨­å®šé †åºãŒä¸€è‡´ã—ã¾ã›ã‚“ã€‚',0),(578696,16075,'pt','O imposto sobre vendas de configuraÃ§Ã£o para este cliente nÃ£o corresponde Ã  ordem',0),(578697,16075,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð½Ðµ ÑÐ¾Ð²Ð¿Ð°Ð´Ð°ÐµÑ‚ Ñ Ð¿Ð¾Ñ€ÑÐ´ÐºÐ¾Ð¼',0),(578698,16075,'es','La configuraciÃ³n del impuesto sobre las ventas para este cliente no coincide con el orden',0),(578699,16075,'de','Die Einrichtung der Mehrwertsteuer fÃ¼r diesen Kunden Ã¼bereinstimmen nicht die Reihenfolge.',0),(578700,16075,'en','The Sales Tax Setup For This Customer Doesn\'t Match The Order',0),(578701,16076,'is','',0),(578702,16076,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯',0),(578703,16076,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯',0),(578704,16076,'tr','DÃ¼zenleyemezsiniz',0),(578705,16076,'pl','Nie moÅ¼na edytowaÄ‡',0),(578706,16076,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°',0),(578707,16076,'ur','ØªØ¯ÙˆÛŒÙ† Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(578708,16076,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÑƒÑ€ÐµÐ´Ð¸Ñ‚Ð¸',0),(578709,16076,'vi','KhÃ´ng thá»ƒ chá»‰nh sá»­a',0),(578710,16076,'af','Kan nie redigeer nie',0),(578711,16076,'ro','Imposibil de editat',0),(578712,16076,'et','Ei saa redigeerida',0),(578713,16076,'si','Ne morete urejati',0),(578714,16076,'ba','Tidak dapat mengedit',0),(578715,16076,'nl','Niet bewerken',0),(578716,16076,'fi','Ei voi muokata',0),(578717,16076,'no','Kan ikke redigere',0),(578718,16076,'da','Kan ikke redigere',0),(578719,16076,'ko','íŽ¸ì§‘í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(578720,16076,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×¢×¨×•×š',0),(578721,16076,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„ÏŒ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(578722,16076,'zh','ä¸èƒ½ç¼–è¾‘',0),(578723,16076,'sv','Kan inte redigera',0),(578724,16076,'it','Non Ã¨ possibile modificare',0),(578725,16076,'tl','',0),(578726,16076,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹à¸à¹‰à¹„à¸‚',0),(578727,16076,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¥‡',0),(578728,16076,'ms','Tidak boleh Edit',0),(578729,16076,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† ØªØ­Ø±ÙŠØ±',0),(578730,16076,'fr','Impossible de modifier',0),(578731,16076,'jp','ç·¨é›†ã§ãã¾ã›ã‚“ã€‚',0),(578732,16076,'pt','NÃ£o Ã© possÃ­vel editar',0),(578733,16076,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(578734,16076,'es','No se puede editar',0),(578735,16076,'de','Kann nicht bearbeitet werden',0),(578736,16076,'en','Cannot Edit',0),(578737,16077,'is','',0),(578738,16077,'dr','Ù…Ø¹Ú©ÙˆØ³ ØªÙˆØ³Ø· Ú©ÙˆÙ¾Ù†',0),(578739,16077,'pr','Ù…Ø¹Ú©ÙˆØ³ ØªÙˆØ³Ø· Ú©ÙˆÙ¾Ù†',0),(578740,16077,'tr','FiÅŸe gÃ¶re ters',0),(578741,16077,'pl','OdwrÃ³cone przez Voucher',0),(578742,16077,'bg','ÐŸÑ€Ð¾Ð¼ÐµÐ½ÐµÐ½Ð° Ñ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(578743,16077,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ù„Ù¹',0),(578744,16077,'sr','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½Ð¾ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(578745,16077,'vi','Äáº£o ngÆ°á»£c báº±ng Voucher',0),(578746,16077,'af','Omgekeer deur bewys',0),(578747,16077,'ro','Inversat de Voucher',0),(578748,16077,'et','ÃœmberpÃ¶Ã¶ratud kande jÃ¤rgi',0),(578749,16077,'si','Razveljavi kupon',0),(578750,16077,'ba','Dibalik dengan Voucher',0),(578751,16077,'nl','Omgekeerd door leveringsbon/aankoopfactuur',0),(578752,16077,'fi','KÃ¤Ã¤nteinen tositteittain',0),(578753,16077,'no','Ved bilag',0),(578754,16077,'da','Vendes af Voucher',0),(578755,16077,'ko','ìƒí’ˆê¶Œìœ¼ë¡œ ë°”ê¿”ì„œ',0),(578756,16077,'he','×”×¤×•×š ×¢×œ-×™×“×™ ×©×•×‘×¨',0),(578757,16077,'el','Î‘Î½Ï„Î¹ÏƒÏ„ÏÎ±Ï†ÎµÎ¯ Î¼Îµ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(578758,16077,'zh','é€†è½¬çš„å‡­è¯',0),(578759,16077,'sv','VÃ¤ndas av verifikation',0),(578760,16077,'it','Invertito tramite Voucher',0),(578761,16077,'tl','',0),(578762,16077,'th','à¸•à¸²à¸¡à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸à¸²à¸£à¸à¸¥à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£',0),(578763,16077,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‰à¤²à¤Ÿ',0),(578764,16077,'ms','Oleh baucer',0),(578765,16077,'ar','Ø¹ÙƒØ³ Ø¨Ø§Ù„Ø§ÙŠØµØ§Ù„',0),(578766,16077,'fr','RenversÃ©e par Voucher',0),(578767,16077,'jp','ã‚¯ãƒ¼ãƒãƒ³ã§é€†è»¢',0),(578768,16077,'pt','Revertida por Voucher',0),(578769,16077,'ru','ÐžÑ‚Ð¼ÐµÐ½ÐµÐ½Ð¾ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(578770,16077,'es','Invierte por vale',0),(578771,16077,'de','Umgekehrt durch Gutschein',0),(578772,16077,'en','Reversed By Voucher',0),(578773,16078,'is','',0),(578774,16078,'dr','Ú©ÙˆÙ¾Ù† Ø±Ø§ Ù…Ø¹Ú©ÙˆØ³ Ù…ÛŒ Ú©Ù†Ø¯',0),(578775,16078,'pr','Ú©ÙˆÙ¾Ù† Ø±Ø§ Ù…Ø¹Ú©ÙˆØ³ Ù…ÛŒ Ú©Ù†Ø¯',0),(578776,16078,'tr','FiÅŸ tersine Ã§evirir',0),(578777,16078,'pl','Odwraca Voucher',0),(578778,16078,'bg','Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð° Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(578779,16078,'ur','ÙˆØ§Ø¤Ú†Ø± Ù…Ø¹Ú©ÙˆØ³ Ú©Ø±ØªØ§ ÛÛ’ Û”',0),(578780,16078,'sr','ÐžÐ±Ñ€Ñ›Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(578781,16078,'vi','Äáº£o ngÆ°á»£c phiáº¿u',0),(578782,16078,'af','Maak ongedaan bewys',0),(578783,16078,'ro','InverseazÄƒ Voucher',0),(578784,16078,'et','TÃ¼histab kanne',0),(578785,16078,'si','Zadnji kupon',0),(578786,16078,'ba','Membalikkan Voucher',0),(578787,16078,'nl','Keert Voucher',0),(578788,16078,'fi','Peruuttaa tositteen',0),(578789,16078,'no','Reverserer bilag',0),(578790,16078,'da','Vender Voucher',0),(578791,16078,'ko','ë°˜ì „ ëœ ë°”ìš°ì²˜',0),(578792,16078,'he','×‘×™×˜×•×œ ×©×•×‘×¨',0),(578793,16078,'el','Î‘Î½Ï„Î¹ÏƒÏ„ÏÎ­Ï†ÎµÎ¹ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(578794,16078,'zh','åè½¬å‡­è¯',0),(578795,16078,'sv','VÃ¤nder om verifikation',0),(578796,16078,'it','Inverte il Voucher',0),(578797,16078,'tl','',0),(578798,16078,'th','à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸à¸²à¸£à¸¢à¹‰à¸­à¸™à¸à¸¥à¸±à¸š',0),(578799,16078,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤•à¥‹ à¤‰à¤²à¤Ÿà¤¤à¤¾ à¤¹à¥ˆ',0),(578800,16078,'ms','Baucer membalikkan',0),(578801,16078,'ar','Ø¹ÙƒØ³ Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(578802,16078,'fr','Bon revers',0),(578803,16078,'jp','ä¼ç¥¨ã‚’å…ƒã«æˆ»ã—ã¾ã™',0),(578804,16078,'pt','Inverte o Voucher',0),(578805,16078,'ru','ÐœÐµÐ½ÑÐµÑ‚ Ð²Ð°ÑƒÑ‡ÐµÑ€',0),(578806,16078,'es','Invierte vale',0),(578807,16078,'de','Kehrt Gutschein',0),(578808,16078,'en','Reverses Voucher',0),(578809,16079,'is','',0),(578810,16079,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ø±Ø§Ø­ØªÛŒ B2B',0),(578811,16079,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ø±Ø§Ø­ØªÛŒ B2B',0),(578812,16079,'tr','B2B kolaylÄ±k Ã¼creti',0),(578813,16079,'pl','OpÅ‚ata za wygodÄ™ B2B',0),(578814,16079,'bg','B2B ÑƒÐ´Ð¾Ð±ÑÑ‚Ð²Ð¾ Ñ‚Ð°ÐºÑÐ°',0),(578815,16079,'ur','B2B Ø³ÛÙˆÙ„Øª ÙÛŒØ³',0),(578816,16079,'sr','Ð‘2Ð‘ Ð¿Ñ€Ð°ÐºÑ‚Ð¸Ñ‡Ð½Ð¾ÑÑ‚ Ð½Ð°ÐºÐ½Ð°Ð´Ð°',0),(578817,16079,'vi','B2B tiá»‡n lá»£i phÃ­',0),(578818,16079,'af','B2B gerief fooi',0),(578819,16079,'ro','Taxa de confort B2B',0),(578820,16079,'et','B2B mugavus Fee',0),(578821,16079,'si','B2B udobje pristojbina',0),(578822,16079,'ba','Biaya kenyamanan B2B',0),(578823,16079,'nl','B2B gemak vergoeding',0),(578824,16079,'fi','B2B mukavuus maksu',0),(578825,16079,'no','B2B bekvemmelighet avgift',0),(578826,16079,'da','B2B bekvemmelighed gebyr',0),(578827,16079,'ko','B2B íŽ¸ì˜ ìˆ˜ìˆ˜ë£Œ',0),(578828,16079,'he','×ª×©×œ×•× × ×•×—×•×ª B2B',0),(578829,16079,'el','B2B ÎµÏ€Î¹Ï€Î»Î­Î¿Î½ Î¼Îµ Ï„Î¿ Ï€Î¿ÏƒÏŒ',0),(578830,16079,'zh','B2B ä¾¿åˆ©è´¹',0),(578831,16079,'sv','B2B Convenience avgift',0),(578832,16079,'it','Tassa di convenienza di B2B',0),(578833,16079,'tl','',0),(578834,16079,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸„à¸§à¸²à¸¡à¸ªà¸°à¸”à¸§à¸ B2B',0),(578835,16079,'hi','B2B à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤¶à¥à¤²à¥à¤•',0),(578836,16079,'ms','Yuran kemudahan B2B',0),(578837,16079,'ar','Ø±Ø³ÙˆÙ… Ø§Ù„Ù…Ù„Ø§Ø¡Ù…Ø© B2B',0),(578838,16079,'fr','Frais de commoditÃ© B2B',0),(578839,16079,'jp','B2B ã‚³ãƒ³ãƒ“ãƒ‹ã‚¨ãƒ³ã‚¹æ–™',0),(578840,16079,'pt','Taxa de conveniÃªncia de B2B',0),(578841,16079,'ru','ÐŸÐ»Ð°Ñ‚Ð° Ð·Ð° ÑƒÐ´Ð¾Ð±ÑÑ‚Ð²Ð¾ B2B',0),(578842,16079,'es','Tarifa de conveniencia por B2B',0),(578843,16079,'de','B2B-Komfort-GebÃ¼hr',0),(578844,16079,'en','B2B Convenience Fee',0),(578845,16080,'is','',0),(578846,16080,'dr','Ú©Ø´ØªÛŒ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø®Ø·Ø§ Ø¨Ù‡--Ù†Ø§Ù… ØªÚ©Ø±Ø§Ø±ÛŒ',0),(578847,16080,'pr','Ú©Ø´ØªÛŒ Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø®Ø·Ø§ Ø¨Ù‡--Ù†Ø§Ù… ØªÚ©Ø±Ø§Ø±ÛŒ',0),(578848,16080,'tr','Hata ekleme gemi--yinelenen ad',0),(578849,16080,'pl','BÅ‚Ä…d dodawania statku--zduplikowane nazwy',0),(578850,16080,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð±Ð°Ð²ÑÐ½Ðµ ÐºÐ¾Ñ€Ð°Ð±--Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ñ‰Ð¾ ÑÐµ Ð¸Ð¼Ðµ',0),(578851,16080,'ur','Ù†Ù‚Øµ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ØŒ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©ÛŒ Û” Û” Ù…Ø«Ù†ÛŒ Ù†Ø§Ù…',0),(578852,16080,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð±Ñ€Ð¾Ð´ Ð´Ð°--Ð´ÑƒÐ¿Ð»Ð¸Ñ€Ð°Ð½Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼',0),(578853,16080,'vi','Lá»—i thÃªm tÃ u... tÃªn trÃ¹ng láº·p',0),(578854,16080,'af','Fout voeg skip na - duplikaat naam',0),(578855,16080,'ro','Eroare adÄƒugÃ¢nd navei sÄƒ--nume duplicat',0),(578856,16080,'et','Viga lisades laeva--duplikaatnimi',0),(578857,16080,'si','Napaka dodajanje ladje--podvojeno ime',0),(578858,16080,'ba','Kapal menambahkan kesalahan--nama duplikat',0),(578859,16080,'nl','Fout toevoegen schip--de dubbele naam',0),(578860,16080,'fi','Virhe lisÃ¤ttÃ¤essÃ¤ aluksen--sama nimi',0),(578861,16080,'no','Feil legge skipet til--duplikatnavn',0),(578862,16080,'da','Fejl tilfÃ¸je skib til--identisk navn',0),(578863,16080,'ko','--ì˜¤ë¥˜ ì¶”ê°€ ì„ ë°• ì¤‘ë³µ ì´ë¦„',0),(578864,16080,'he','×”×¡×¤×™× ×” ×”×•×¡×¤×ª ×©×’×™××”... ×”×©× ×”×›×¤×•×œ',0),(578865,16080,'el','Î£Ï†Î¬Î»Î¼Î± Ï€ÏÎ¿ÏƒÎ¸Î­Ï„Î¿Î½Ï„Î±Ï‚ Ï€Î»Î¿Î¯Î¿ Î½Î±--Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€Î¿ ÏŒÎ½Î¿Î¼Î±',0),(578866,16080,'zh','é”™è¯¯æ·»åŠ èˆ° â€” â€” é‡å¤çš„åç§°',0),(578867,16080,'sv','Fel att lÃ¤gga till fartyget att--dubblettnamn',0),(578868,16080,'it','Errore aggiunta nave... nome duplicato',0),(578869,16080,'tl','',0),(578870,16080,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸£à¸·à¸­ - à¸Šà¸·à¹ˆà¸­à¸‹à¹‰à¸³à¸à¸±à¸™',0),(578871,16080,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ - à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤¨à¤¾à¤®',0),(578872,16080,'ms','Ralat menambah kapal untuk--nama pendua',0),(578873,16080,'ar','Ø®Ø·Ø£ Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰--Ø§Ø³Ù… Ù…ÙƒØ±Ø±',0),(578874,16080,'fr','Erreur ajout Ship To--nom dupliquÃ©',0),(578875,16080,'jp','åå‰ã®é‡è¤‡ã‚¨ãƒ©ãƒ¼-è¿½åŠ èˆ¹',0),(578876,16080,'pt','Erro adicionando nave... nome duplicado',0),(578877,16080,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ--Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰ÐµÐµÑÑ Ð¸Ð¼Ñ',0),(578878,16080,'es','Nave agregar error: nombre duplicado',0),(578879,16080,'de','Fehler hinzufÃ¼gen Schiff--doppelter Name',0),(578880,16080,'en','Error Adding Ship To -- Duplicate Name',0),(578881,16081,'is','',0),(578882,16081,'dr','Ø§Ø®Ø·Ø§Ø± ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù†',0),(578883,16081,'pr','Ø§Ø®Ø·Ø§Ø± ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù†',0),(578884,16081,'tr','Alma bildirimi',0),(578885,16081,'pl','ZaimportowaÄ‡ zawiadomienia',0),(578886,16081,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(578887,16081,'ur','Ù†ÙˆÙ¹Ø³ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(578888,16081,'sr','Ð£Ð²Ð¾Ð· Ð½Ð°Ñ˜Ð°Ð²Ðµ',0),(578889,16081,'vi','ThÃ´ng bÃ¡o nháº­p kháº©u',0),(578890,16081,'af','Voer kennisgewing',0),(578891,16081,'ro','Aviz de import',0),(578892,16081,'et','Impordi teade',0),(578893,16081,'si','Uvoz obvestilo',0),(578894,16081,'ba','Pemberitahuan impor',0),(578895,16081,'nl','Import bericht',0),(578896,16081,'fi','Tuo ilmoitus',0),(578897,16081,'no','Importere varsel',0),(578898,16081,'da','Importere varsel',0),(578899,16081,'ko','ê°€ì ¸ì˜¤ê¸° í†µì§€',0),(578900,16081,'he','×™×™×‘×•× ×”×•×“×¢×”',0),(578901,16081,'el','Î‘Î½Î±ÎºÎ¿Î¯Î½Ï‰ÏƒÎ· ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(578902,16081,'zh','è¿›å£çš„é€šçŸ¥',0),(578903,16081,'sv','Importera varsel',0),(578904,16081,'it','Avviso di importazione',0),(578905,16081,'tl','',0),(578906,16081,'th','à¸›à¸£à¸°à¸à¸²à¸¨à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(578907,16081,'hi','à¤¸à¥‚à¤šà¤¨à¤¾ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(578908,16081,'ms','Notis import',0),(578909,16081,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¥Ø´Ø¹Ø§Ø±',0),(578910,16081,'fr','Avis dâ€™importation',0),(578911,16081,'jp','è¼¸å…¥å…¬è¡¨',0),(578912,16081,'pt','Aviso de importaÃ§Ã£o',0),(578913,16081,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(578914,16081,'es','Aviso de importaciÃ³n',0),(578915,16081,'de','Hinweis zu importieren',0),(578916,16081,'en','Import Notice',0),(578917,16082,'is','',0),(578918,16082,'dr','ØªÙ…Ø§Ù… ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±',0),(578919,16082,'pr','ØªÙ…Ø§Ù… ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ø¨Ø±Ø§ÛŒ Ú©Ø§Ø±',0),(578920,16082,'tr','Ä°ÅŸ iÃ§in tÃ¼m etkinlik',0),(578921,16082,'pl','Wszystkie dziaÅ‚ania dla zadania',0),(578922,16082,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð´ÐµÐ¹Ð½Ð¾ÑÑ‚ Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(578923,16082,'ur','ØªÙ…Ø§Ù… Ø³Ø±Ú¯Ø±Ù…ÛŒ Ù…Ù„Ø§Ø²Ù…Øª Ú©Û’ Ù„ÛŒÛ’',0),(578924,16082,'sr','Ð¡Ð²Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸ Ð·Ð° Ð¿Ð¾ÑÐ°Ð¾',0),(578925,16082,'vi','Táº¥t cáº£ hoáº¡t Ä‘á»™ng cho cÃ´ng viá»‡c',0),(578926,16082,'af','Alle aktiwiteit vir werk',0),(578927,16082,'ro','Orice activitate pentru Job',0),(578928,16082,'et','KÃµik tegevus tÃ¶Ã¶',0),(578929,16082,'si','Vse dejavnosti za delo',0),(578930,16082,'ba','Semua aktivitas untuk pekerjaan',0),(578931,16082,'nl','Alle activiteiten voor baan',0),(578932,16082,'fi','Kaikki toiminta tyÃ¶n',0),(578933,16082,'no','All aktivitet For jobben',0),(578934,16082,'da','Al aktivitet For Job',0),(578935,16082,'ko','ìž‘ì—…ì— ëŒ€ í•œ ëª¨ë“  í™œë™',0),(578936,16082,'he','×›×œ ×¤×¢×™×œ×•×ª ×œ×¢×‘×•×“×”',0),(578937,16082,'el','ÎšÎ¬Î¸Îµ Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î± Î³Î¹Î± Ï„Î·Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(578938,16082,'zh','å·¥ä½œçš„æ‰€æœ‰æ´»åŠ¨',0),(578939,16082,'sv','Alla aktiviteter fÃ¶r jobb',0),(578940,16082,'it','Tutte le attivitÃ  per lavoro',0),(578941,16082,'tl','',0),(578942,16082,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸ªà¸³à¸«à¸£à¸±à¸šà¸‡à¸²à¸™',0),(578943,16082,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¤­à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(578944,16082,'ms','Semua aktiviti kerja',0),(578945,16082,'ar','ÙƒÙ„ Ù†Ø´Ø§Ø· Ù„Ù„ÙˆØ¸ÙŠÙØ©',0),(578946,16082,'fr','Toutes les activitÃ©s dâ€™emploi',0),(578947,16082,'jp','ã‚¸ãƒ§ãƒ–ã®ã™ã¹ã¦ã®ã‚¢ã‚¯ãƒ†ã‚£ãƒ“ãƒ†ã‚£',0),(578948,16082,'pt','Todas as atividades de trabalho',0),(578949,16082,'ru','Ð’ÑÐµ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ Ð´Ð»Ñ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(578950,16082,'es','Toda actividad de trabajo',0),(578951,16082,'de','Alle AktivitÃ¤ten fÃ¼r Job',0),(578952,16082,'en','All Activity For Job',0),(578953,16083,'is','',0),(578954,16083,'dr','Ø¬Ù„ÙˆÚ¯ÛŒØ±ÛŒ Ø§Ø² Ù†Ø§Ù… ØªÚ©Ø±Ø§Ø±ÛŒ Ú©Ø´ØªÛŒ',0),(578955,16083,'pr','Ø¬Ù„ÙˆÚ¯ÛŒØ±ÛŒ Ø§Ø² Ù†Ø§Ù… ØªÚ©Ø±Ø§Ø±ÛŒ Ú©Ø´ØªÛŒ',0),(578956,16083,'tr','Yinelenen gemi adlarÄ± Ã¶nlemek',0),(578957,16083,'pl','Zapobiec statek zduplikowane nazwy',0),(578958,16083,'bg','ÐŸÑ€ÐµÐ´Ð¾Ñ‚Ð²Ñ€Ð°Ñ‚ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ñ€Ð°Ð± Ð¸Ð¼ÐµÐ½Ð°',0),(578959,16083,'ur','Ù…Ø«Ù†ÛŒ Ø¬ÛØ§Ø² Ù†Ø§Ù…ÙˆÚº Ú©ÛŒ Ø±ÙˆÚ© ØªÚ¾Ø§Ù…',0),(578960,16083,'sr','Ð¡Ð¿Ñ€ÐµÑ‡Ð°Ð²Ð°ÑšÐµ Ð´ÑƒÐ¿Ð»Ð¸ÐºÐ°Ñ‚Ð° Ð±Ñ€Ð¾Ð´ Ð¸Ð¼ÐµÐ½Ð°',0),(578961,16083,'vi','NgÄƒn cháº·n tÃ u trÃ¹ng láº·p tÃªn',0),(578962,16083,'af','Duplikaat skip name voorkom',0),(578963,16083,'ro','Evita duplicat nava nume',0),(578964,16083,'et','VÃ¤ltida nimede Duplicate laeva',0),(578965,16083,'si','PrepreÄevanje podvojenih ladje imena',0),(578966,16083,'ba','Mencegah nama duplikat kapal',0),(578967,16083,'nl','Voorkomen dat de namen van de dubbele schip',0),(578968,16083,'fi','EstÃ¤Ã¤ kaksoiskappaleiden alusten nimet',0),(578969,16083,'no','UnngÃ¥ dupliserte bÃ¥tens navn',0),(578970,16083,'da','UndgÃ¥ dublerede skib navne',0),(578971,16083,'ko','ì¤‘ë³µ ë°° ì´ë¦„ ë°©ì§€',0),(578972,16083,'he','×œ×ž× ×•×¢ ×©×ž×•×ª ×›×¤×•×œ×™× ×”×¡×¤×™× ×”',0),(578973,16083,'el','Î ÏÏŒÎ»Î·ÏˆÎ· Ï€Î»Î¿Î¯Î¿ Î´Î¹Ï€Î»ÏŒÏ„Ï…Ï€Î± Î¿Î½ÏŒÎ¼Î±Ï„Î±',0),(578974,16083,'zh','é˜²æ­¢é‡å¤èˆ¹èˆ¶åç§°',0),(578975,16083,'sv','FÃ¶rhindra dubbletter fartyget namn',0),(578976,16083,'it','Evitare nomi duplicati nave',0),(578977,16083,'tl','',0),(578978,16083,'th','à¸›à¹‰à¸­à¸‡à¸à¸±à¸™à¸Šà¸·à¹ˆà¸­à¸‹à¹‰à¸³à¸à¸±à¸™à¹€à¸£à¸·à¸­',0),(578979,16083,'hi','à¤¡à¥à¤ªà¥à¤²à¤¿à¤•à¥‡à¤Ÿ à¤œà¤¹à¤¾à¤œ à¤¨à¤¾à¤®à¥‹à¤‚ à¤•à¥‹ à¤°à¥‹à¤•à¤¨à¥‡',0),(578980,16083,'ms','Mengelakkan nama pendua kapal',0),(578981,16083,'ar','Ù…Ù†Ø¹ Ø£Ø³Ù…Ø§Ø¡ Ù…ÙƒØ±Ø±Ø© Ø§Ù„Ø³ÙÙŠÙ†Ø©',0),(578982,16083,'fr','Ã‰viter les noms de navire en double',0),(578983,16083,'jp','é‡è¤‡ã™ã‚‹èˆ¹ã®åå‰ã‚’é˜²ã',0),(578984,16083,'pt','Evitar nomes duplicados de navio',0),(578985,16083,'ru','ÐŸÑ€ÐµÐ´Ð¾Ñ‚Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¸Ðµ Ð´ÑƒÐ±Ð»Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¸Ð¼ÐµÐ½Ð°',0),(578986,16083,'es','Evitar nombres duplicados de la nave',0),(578987,16083,'de','Verhindern, dass doppelte Schiffsnamen',0),(578988,16083,'en','Prevent Duplicate Ship Names',0),(578989,16084,'is','',0),(578990,16084,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ Ù…Ø¹ØªØ¨Ø± Ù†ÛŒØ³Øª',0),(578991,16084,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø³Ø§Ù„ Ù…Ø¹ØªØ¨Ø± Ù†ÛŒØ³Øª',0),(578992,16084,'tr','BÃ¼tÃ§e yÄ±l geÃ§erli deÄŸil',0),(578993,16084,'pl','Roku budÅ¼etowego nie waÅ¼ne',0),(578994,16084,'bg','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð½Ð° Ð³Ð¾Ð´Ð¸Ð½Ð° Ð½Ðµ Ðµ Ð²Ð°Ð»Ð¸Ð´ÐµÐ½',0),(578995,16084,'ur','Ø¨Ø¬Ù¹ Ø³Ø§Ù„ Ø¬Ø§Ø¦Ø² Ù†ÛÛŒÚº',0),(578996,16084,'sr','Ð“Ð¾Ð´Ð¸Ð½Ðµ Ð±ÑƒÑŸÐµÑ‚ Ð½Ð¸Ñ˜Ðµ Ð²Ð°Ð¶ÐµÑ›Ð°',0),(578997,16084,'vi','NgÃ¢n sÃ¡ch nÄƒm khÃ´ng há»£p lá»‡',0),(578998,16084,'af','Begroting jaar nie geldig nie',0),(578999,16084,'ro','An bugetar nu este valabil',0),(579000,16084,'et','Eelarveaastal ei sobi',0),(579001,16084,'si','ProraÄunskega leta ni veljavna',0),(579002,16084,'ba','Tahun anggaran tidak Valid',0),(579003,16084,'nl','Begrotingsjaar niet geldig',0),(579004,16084,'fi','Varainhoitovuoden ei kelpaa',0),(579005,16084,'no','Budsjett Ã¥ret ikke gyldig',0),(579006,16084,'da','RegnskabsÃ¥r ikke gyldigt',0),(579007,16084,'ko','ì˜ˆì‚° 1 ë…„ ìœ íš¨ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤',0),(579008,16084,'he','×ª×§×¦×™×‘ ×”×©× ×” ×œ× ×—×•×§×™',0),(579009,16084,'el','ÎŸÎ¹ÎºÎ¿Î½Î¿Î¼Î¹ÎºÏŒ Î­Ï„Î¿Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î­Î³ÎºÏ…ÏÎ·',0),(579010,16084,'zh','é¢„ç®—å¹´åº¦æ— æ•ˆ',0),(579011,16084,'sv','BudgetÃ¥r inte giltigt',0),(579012,16084,'it','Bilancio anno non valido',0),(579013,16084,'tl','',0),(579014,16084,'th','à¸›à¸µà¸‡à¸šà¸›à¸£à¸°à¸¡à¸²à¸“à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(579015,16084,'hi','à¤¬à¤œà¤Ÿ à¤µà¤°à¥à¤· à¤®à¤¾à¤¨à¥à¤¯ à¤¨à¤¹à¥€à¤‚',0),(579016,16084,'ms','Tahun belanjawan yang tidak sah',0),(579017,16084,'ar','Ø³Ù†Ø© Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© ØºÙŠØ± ØµØ§Ù„Ø­Ø©',0),(579018,16084,'fr','Exercice budgÃ©taire non valide',0),(579019,16084,'jp','äºˆç®—ã®å¹´ãŒç„¡åŠ¹ã§ã™ã€‚',0),(579020,16084,'pt','Ano de orÃ§amento nÃ£o Ã© vÃ¡lido',0),(579021,16084,'ru','Ð‘ÑŽÐ´Ð¶ÐµÑ‚Ð½Ñ‹Ð¹ Ð³Ð¾Ð´ Ð½Ðµ ÑÐ²Ð»ÑÐµÑ‚ÑÑ Ð´Ð¾Ð¿ÑƒÑÑ‚Ð¸Ð¼Ñ‹Ð¼',0),(579022,16084,'es','Ejercicio no vÃ¡lido',0),(579023,16084,'de','Haushaltsjahr nicht gÃ¼ltig',0),(579024,16084,'en','Budget Year Not Valid',0),(579025,16085,'is','',0),(579026,16085,'dr','Ú©Ø¯ Ø´ØºÙ„',0),(579027,16085,'pr','Ú©Ø¯ Ø´ØºÙ„',0),(579028,16085,'tr','Proje kodu',0),(579029,16085,'pl','Kod pracy',0),(579030,16085,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° ÐºÐ¾Ð´',0),(579031,16085,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©Ø§ Ú©ÙˆÚˆ',0),(579032,16085,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð¿Ð¾Ð´Ñ€ÑƒÑ‡Ñ˜Ð°',0),(579033,16085,'vi','MÃ£ cÃ´ng viá»‡c',0),(579034,16085,'af','Werk kode',0),(579035,16085,'ro','Job cod',0),(579036,16085,'et','TÃ¶Ã¶ kood',0),(579037,16085,'si','Delovnega mesta kodo',0),(579038,16085,'ba','Kode pekerjaan',0),(579039,16085,'nl','Code van de baan',0),(579040,16085,'fi','Projektin koodin',0),(579041,16085,'no','Jobbkode',0),(579042,16085,'da','Job kode',0),(579043,16085,'ko','ìž‘ì—… ì½”ë“œ',0),(579044,16085,'he','×§×•×“ ×ž×©×™×ž×”',0),(579045,16085,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Î­ÏÎ³Î¿Ï…',0),(579046,16085,'zh','ä½œä¸šä»£ç ',0),(579047,16085,'sv','Jobbkod',0),(579048,16085,'it','Codice di lavoro',0),(579049,16085,'tl','',0),(579050,16085,'th','à¸£à¸«à¸±à¸ªà¸‡à¸²à¸™',0),(579051,16085,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¥‹à¤¡',0),(579052,16085,'ms','Kod kerja',0),(579053,16085,'ar','ÙƒÙˆØ¯ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(579054,16085,'fr','Code du travail',0),(579055,16085,'jp','ã‚¸ãƒ§ãƒ– ã‚³ãƒ¼ãƒ‰',0),(579056,16085,'pt','CÃ³digo do trabalho',0),(579057,16085,'ru','ÐšÐ¾Ð´ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(579058,16085,'es','CÃ³digo de trabajo',0),(579059,16085,'de','Job-Code',0),(579060,16085,'en','Job Code',0),(579061,16086,'is','',0),(579062,16086,'dr','Ù†Ø§Ù… Ú©Ø§Ø±',0),(579063,16086,'pr','Ù†Ø§Ù… Ú©Ø§Ø±',0),(579064,16086,'tr','Ä°ÅŸ adÄ±',0),(579065,16086,'pl','Nazwa zadania',0),(579066,16086,'bg','Ð˜Ð¼Ðµ Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(579067,16086,'ur','Ù†Ø§Ù… Ø¬Ø§Ø¨',0),(579068,16086,'sr','ÐÐ°Ð·Ð¸Ð² Ð¿Ð¾ÑÐ»Ð°',0),(579069,16086,'vi','TÃªn cÃ´ng viá»‡c',0),(579070,16086,'af','Naam van rugsteuntaak',0),(579071,16086,'ro','Numele de Job',0),(579072,16086,'et','TÃ¶Ã¶ nimi',0),(579073,16086,'si','Ime posla',0),(579074,16086,'ba','Nama pekerjaan',0),(579075,16086,'nl','Taaknaam',0),(579076,16086,'fi','TyÃ¶n nimi',0),(579077,16086,'no','Jobbnavn',0),(579078,16086,'da','Jobnavn',0),(579079,16086,'ko','ìž‘ì—… ì´ë¦„',0),(579080,16086,'he','×©× ×”×ž×©×™×ž×”',0),(579081,16086,'el','ÎŒÎ½Î¿Î¼Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(579082,16086,'zh','ä½œä¸šåç§°',0),(579083,16086,'sv','Jobbnamn',0),(579084,16086,'it','Nome del lavoro',0),(579085,16086,'tl','',0),(579086,16086,'th','à¸Šà¸·à¹ˆà¸­à¸‡à¸²à¸™',0),(579087,16086,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¤¾ à¤¨à¤¾à¤®',0),(579088,16086,'ms','Nama kerja',0),(579089,16086,'ar','Ø§Ø³Ù… Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(579090,16086,'fr','Nom du travail',0),(579091,16086,'jp','ã‚¸ãƒ§ãƒ–å',0),(579092,16086,'pt','Nome do trabalho',0),(579093,16086,'ru','Ð˜Ð¼Ñ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ',0),(579094,16086,'es','Nombre del trabajo',0),(579095,16086,'de','Job-Name',0),(579096,16086,'en','Job Name',0),(579097,16087,'is','',0),(579098,16087,'dr','ØªØ§Ø±ÛŒØ® prelim',0),(579099,16087,'pr','ØªØ§Ø±ÛŒØ® prelim',0),(579100,16087,'tr','Ã–n duruÅŸma tarihi',0),(579101,16087,'pl','Prelim Data',0),(579102,16087,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð´Ð°Ñ‚Ð°',0),(579103,16087,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(579104,16087,'sr','Ð£Ð²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(579105,16087,'vi','Prelim ngÃ y',0),(579106,16087,'af','Prelim datum',0),(579107,16087,'ro','Data preliminare',0),(579108,16087,'et','Aasta kuupÃ¤ev',0),(579109,16087,'si','Datum predhodnega',0),(579110,16087,'ba','Tanggal prelim',0),(579111,16087,'nl','Datum van de kwalificatie',0),(579112,16087,'fi','Alustava pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(579113,16087,'no','Prelim dato',0),(579114,16087,'da','Prelim dato',0),(579115,16087,'ko','ì˜ˆì„  ë‚ ì§œ',0),(579116,16087,'he','×ª××¨×™×š ×ž×•×§×“×',0),(579117,16087,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(579118,16087,'zh','åˆè¯•æ—¥æœŸ',0),(579119,16087,'sv','PreliminÃ¤rt datum',0),(579120,16087,'it','Data Prelim',0),(579121,16087,'tl','',0),(579122,16087,'th','Prelim à¸§à¸±à¸™',0),(579123,16087,'hi','Prelim à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(579124,16087,'ms','Tarikh prelim',0),(579125,16087,'ar','ØªØ§Ø±ÙŠØ® prelim',0),(579126,16087,'fr','Prelim Date',0),(579127,16087,'jp','äºˆå‚™æ—¥',0),(579128,16087,'pt','Data de exame preliminar',0),(579129,16087,'ru','Prelim Ð”Ð°Ñ‚Ð°',0),(579130,16087,'es','Fecha de prelim',0),(579131,16087,'de','Vorrunde Datum',0),(579132,16087,'en','Prelim Date',0),(579133,16088,'is','',0),(579134,16088,'dr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÛŒ Ù†Ø´Ø¯',0),(579135,16088,'pr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÛŒ Ù†Ø´Ø¯',0),(579136,16088,'tr','Ã‡ek hesabÄ± bulunamadÄ±',0),(579137,16088,'pl','Konto czekowe nie znaleziono',0),(579138,16088,'bg','Ð Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(579139,16088,'ur','Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(579140,16088,'sr','Ð¢ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(579141,16088,'vi','Kiá»ƒm tra tÃ i khoáº£n khÃ´ng Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(579142,16088,'af','Kontroleer tans rekening nie gevind nie',0),(579143,16088,'ro','Cont de verificare nu a fost gÄƒsit',0),(579144,16088,'et','Kontot ei leitud',0),(579145,16088,'si','Preverjanje raÄuna ni bilo mogoÄe najti',0),(579146,16088,'ba','Rekening tidak ditemukan',0),(579147,16088,'nl','Betaalrekening niet gevonden',0),(579148,16088,'fi','Tarkkailun huomioon ei lÃ¶ydy',0),(579149,16088,'no','Brukskonto ikke funnet',0),(579150,16088,'da','Checkkonto ikke fundet',0),(579151,16088,'ko','ë‹¹ì¢Œ ê³„ì •ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(579152,16088,'he','×—×©×‘×•×Ÿ ×‘× ×§ ×œ× × ×ž×¦×',0),(579153,16088,'el','Î¤ÏÎµÏ‡Î¿ÏÎ¼ÎµÎ½Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(579154,16088,'zh','æ”¯ç¥¨è´¦æˆ·æ‰¾ä¸åˆ°',0),(579155,16088,'sv','Checkkonto hittades inte',0),(579156,16088,'it','Conto corrente non trovato',0),(579157,16088,'tl','',0),(579158,16088,'th','à¸šà¸±à¸à¸Šà¸µà¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹„à¸¡à¹ˆà¸žà¸š',0),(579159,16088,'hi','à¤šà¥‡à¤•à¤¿à¤‚à¤— à¤–à¤¾à¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(579160,16088,'ms','Memeriksa akaun tidak dijumpai',0),(579161,16088,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø­Ø³Ø§Ø¨ Ø§Ù„ØªØ­Ù‚Ù‚',0),(579162,16088,'fr','Compte-chÃ¨ques introuvable',0),(579163,16088,'jp','å½“åº§é é‡‘å£åº§ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(579164,16088,'pt','Conta corrente nÃ£o encontrada',0),(579165,16088,'ru','Ð Ð°ÑÑ‡ÐµÑ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(579166,16088,'es','Cuenta de cheques que no se encuentran',0),(579167,16088,'de','Girokonto nicht gefunden',0),(579168,16088,'en','Checking Account Not Found',0),(579169,16089,'is','',0),(579170,16089,'dr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± Ø®Ø·Ø§',0),(579171,16089,'pr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± Ø®Ø·Ø§',0),(579172,16089,'tr','Hata kaydetme',0),(579173,16089,'pl','BÅ‚Ä…d zapisywania',0),(579174,16089,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(579175,16089,'ur','Ù†Ù‚Øµ Ø¨Ú†Øª',0),(579176,16089,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ñ€Ð°Ñ‡ÑƒÐ½Ð°ÑšÐ°',0),(579177,16089,'vi','Lá»—i lÆ°u',0),(579178,16089,'af','Fout stoor',0),(579179,16089,'ro','Eroare de economisire',0),(579180,16089,'et','TÃµrge salvestamine',0),(579181,16089,'si','Napaka varÄevanje',0),(579182,16089,'ba','Kesalahan tabungan',0),(579183,16089,'nl','Fout bij opslaan',0),(579184,16089,'fi','Virhe tallennettaessa',0),(579185,16089,'no','Feil ved lagring',0),(579186,16089,'da','Fejl besparelse',0),(579187,16089,'ko','ì˜¤ë¥˜ ì ˆì•½',0),(579188,16089,'he','×©×’×™××ª ×©×ž×™×¨×”',0),(579189,16089,'el','Î£Ï†Î¬Î»Î¼Î± ÎµÎ¾Î¿Î¹ÎºÎ¿Î½ÏŒÎ¼Î·ÏƒÎ·',0),(579190,16089,'zh','ä¿å­˜æ—¶å‡ºé”™',0),(579191,16089,'sv','Fel sparande',0),(579192,16089,'it','Salvataggio di errore',0),(579193,16089,'tl','',0),(579194,16089,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(579195,16089,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤¬à¤šà¤¤',0),(579196,16089,'ms','Ralat penjimatan',0),(579197,16089,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸',0),(579198,16089,'fr','Ã‰conomie dâ€™erreur',0),(579199,16089,'jp','ä¿å­˜ä¸­ã®ã‚¨ãƒ©ãƒ¼',0),(579200,16089,'pt','Economia de erro',0),(579201,16089,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ',0),(579202,16089,'es','Ahorro de error',0),(579203,16089,'de','Fehler beim Speichern',0),(579204,16089,'en','Error Saving',0),(579205,16090,'is','',0),(579206,16090,'dr','ÙˆØ§Ø±Ø¯Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(579207,16090,'pr','ÙˆØ§Ø±Ø¯Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(579208,16090,'tr','SatÄ±cÄ± Ã¶demeleri alma',0),(579209,16090,'pl','Import pÅ‚atnoÅ›ci dostawcy',0),(579210,16090,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(579211,16090,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(579212,16090,'sr','Ð£Ð²Ð¾Ð· ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸Ð¼Ð°',0),(579213,16090,'vi','NhÃ  cung cáº¥p thanh toÃ¡n nháº­p kháº©u',0),(579214,16090,'af','Voer handelaar betalings',0),(579215,16090,'ro','Furnizor de plÄƒÅ£i de import',0),(579216,16090,'et','Hankija maksete import',0),(579217,16090,'si','Uvozite plaÄila dobaviteljem',0),(579218,16090,'ba','Impor Vendor pembayaran',0),(579219,16090,'nl','Importeren van Betalingsvoorstellen maken',0),(579220,16090,'fi','Toimittajamaksujen tuominen',0),(579221,16090,'no','Importere leverandÃ¸rbetalinger',0),(579222,16090,'da','Importere kreditorbetalinger',0),(579223,16090,'ko','ê°€ì ¸ì˜¤ê¸° ê³µê¸‰ ì—…ì²´ ì§€ë¶ˆ',0),(579224,16090,'he','×ª×©×œ×•×ž×™ ×¡×¤×§ ×™×™×‘×•×',0),(579225,16090,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(579226,16090,'zh','å¯¼å…¥ä¾›åº”å•†ä»˜æ¬¾',0),(579227,16090,'sv','Importera leverantÃ¶rsbetalningar',0),(579228,16090,'it','Importare i pagamenti ai fornitori',0),(579229,16090,'tl','',0),(579230,16090,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(579231,16090,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(579232,16090,'ms','Pembayaran pembekal import',0),(579233,16090,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ†',0),(579234,16090,'fr','Importer des paiements fournisseurs',0),(579235,16090,'jp','ä»•å…¥å…ˆæ”¯æ‰•ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(579236,16090,'pt','Pagamentos de fornecedores de importaÃ§Ã£o',0),(579237,16090,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(579238,16090,'es','Pagos a proveedores de importaciÃ³n',0),(579239,16090,'de','Importieren von Kreditorenzahlungen',0),(579240,16090,'en','Import Vendor Payments',0),(579241,16091,'is','',0),(579242,16091,'dr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÛŒ Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡',0),(579243,16091,'pr','Ø­Ø³Ø§Ø¨ Ø¬Ø§Ø±ÛŒ Ø§Ø² Ø¯Ø³Øª Ø±ÙØªÙ‡',0),(579244,16091,'tr','Ã‡ek hesabÄ± eksik',0),(579245,16091,'pl','Brak konta czekowego',0),(579246,16091,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° Ñ€Ð°Ð·Ð¿Ð»Ð°Ñ‰Ð°Ñ‚ÐµÐ»Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(579247,16091,'ur','Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ ØºØ§Ø¦Ø¨',0),(579248,16091,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½',0),(579249,16091,'vi','Thiáº¿u kiá»ƒm tra tÃ i khoáº£n',0),(579250,16091,'af','Kontroleer tans rekening ontbreek',0),(579251,16091,'ro','Lipsesc cont de verificare',0),(579252,16091,'et','Puudub pangakonto',0),(579253,16091,'si','Manjka banÄni raÄun',0),(579254,16091,'ba','Hilang rekening',0),(579255,16091,'nl','Ontbrekende betaalrekening',0),(579256,16091,'fi','Puuttuu tarkkailun huomioon',0),(579257,16091,'no','Manglende brukskonto',0),(579258,16091,'da','Mangler checkkonto',0),(579259,16091,'ko','ëˆ„ë½ ëœ ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œ',0),(579260,16091,'he','×—×¡×¨ ×—×©×‘×•×Ÿ ×‘× ×§',0),(579261,16091,'el','Î¤Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€Î¿Ï… Î»ÎµÎ¯Ï€Î¿Ï…Î½',0),(579262,16091,'zh','ç¼ºå°‘æ”¯ç¥¨å¸æˆ·',0),(579263,16091,'sv','Saknade lÃ¶nekonto',0),(579264,16091,'it','Conto corrente mancante',0),(579265,16091,'tl','',0),(579266,16091,'th','à¸šà¸±à¸à¸Šà¸µà¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸«à¸²à¸¢à¹„à¸›',0),(579267,16091,'hi','à¤…à¤¨à¥à¤ªà¤²à¤¬à¥à¤§ à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(579268,16091,'ms','Hilang memeriksa akaun',0),(579269,16091,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ø­Ø³Ø§Ø¨ Ù…ÙÙ‚ÙˆØ¯',0),(579270,16091,'fr','Compte-chÃ¨ques manquant',0),(579271,16091,'jp','è¡Œæ–¹ä¸æ˜Žã®å½“åº§é é‡‘å£åº§',0),(579272,16091,'pt','Falta de conta corrente',0),(579273,16091,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÑ‡ÐµÑ‚Ð°',0),(579274,16091,'es','Falta la cuenta de cheques',0),(579275,16091,'de','Fehlende Girokonto',0),(579276,16091,'en','Missing Checking Account',0),(579277,16092,'is','',0),(579278,16092,'dr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ú¯Ù… Ø´Ø¯Ù‡',0),(579279,16092,'pr','Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ú¯Ù… Ø´Ø¯Ù‡',0),(579280,16092,'tr','Eksik fatura numarasÄ±',0),(579281,16092,'pl','Brak numeru faktury',0),(579282,16092,'bg','Ð›Ð¸Ð¿ÑÐ²Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(579283,16092,'ur','ØºØ§Ø¦Ø¨ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(579284,16092,'sr','ÐÐµÐ´Ð¾ÑÑ‚Ð°Ñ˜Ðµ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(579285,16092,'vi','Sá»‘ hÃ³a Ä‘Æ¡n',0),(579286,16092,'af','Vermiste faktuur nommer',0),(579287,16092,'ro','LipseÅŸte numÄƒrul facturii',0),(579288,16092,'et','Puudub arve Number',0),(579289,16092,'si','Manjka Å¡tevilka raÄuna',0),(579290,16092,'ba','Hilang faktur jumlah',0),(579291,16092,'nl','Ontbrekende factuurnummer',0),(579292,16092,'fi','Laskunumero puuttuu',0),(579293,16092,'no','Manglende fakturanummer',0),(579294,16092,'da','Mangler fakturanummer',0),(579295,16092,'ko','ì—†ëŠ” ì†¡ìž¥ ë²ˆí˜¸',0),(579296,16092,'he','×—×¡×¨ ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª',0),(579297,16092,'el','Î›ÎµÎ¯Ï€ÎµÎ¹ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(579298,16092,'zh','ä¸¢å¤±å‘ç¥¨ç¼–å·',0),(579299,16092,'sv','Saknade fakturanummer',0),(579300,16092,'it','Numero di fattura mancante',0),(579301,16092,'tl','',0),(579302,16092,'th','à¸‚à¸²à¸”à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(579303,16092,'hi','à¤²à¤¾à¤ªà¤¤à¤¾ à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(579304,16092,'ms','Hilang nombor invois',0),(579305,16092,'ar','Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù…ÙÙ‚ÙˆØ¯',0),(579306,16092,'fr','NumÃ©ro de la facture manquante',0),(579307,16092,'jp','è¡Œæ–¹ä¸æ˜Žã®è«‹æ±‚æ›¸ç•ªå·',0),(579308,16092,'pt','Faltando nÃºmero da fatura',0),(579309,16092,'ru','ÐžÑ‚ÑÑƒÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°',0),(579310,16092,'es','NÃºmero de factura que falta',0),(579311,16092,'de','Fehlende Rechnungsnummer',0),(579312,16092,'en','Missing Invoice Number',0),(579313,16093,'is','',0),(579314,16093,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ',0),(579315,16093,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ',0),(579316,16093,'tr','MÃ¼ÅŸteri Ã¶demelerini',0),(579317,16093,'pl','Import pÅ‚atnoÅ›ci odbiorcy',0),(579318,16093,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(579319,16093,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(579320,16093,'sr','Ð£Ð²Ð¾Ð· ÑƒÐ¿Ð»Ð°Ñ‚Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(579321,16093,'vi','Nháº­p kháº©u khÃ¡ch hÃ ng thanh toÃ¡n',0),(579322,16093,'af','Voer in verbeteringsprogram vir betalings',0),(579323,16093,'ro','PlÄƒÅ£ile clienÅ£ilor de import',0),(579324,16093,'et','Kliendi impordimaksed',0),(579325,16093,'si','Uvozite plaÄila strank',0),(579326,16093,'ba','Pembayaran nasabah impor',0),(579327,16093,'nl','Importeren van betalingen van klanten',0),(579328,16093,'fi','Tuo asiakasmaksut',0),(579329,16093,'no','Importere kundebetalinger',0),(579330,16093,'da','Importere debitorbetalinger',0),(579331,16093,'ko','ê°€ì ¸ì˜¤ê¸° ê³ ê° ì§€ë¶ˆ',0),(579332,16093,'he','×œ×™×™×‘× ××ª ×”×ª×©×œ×•×ž×™× ×©×œ ×œ×§×•×—×•×ª',0),(579333,16093,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³ÏŽÎ½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(579334,16093,'zh','å¯¼å…¥å®¢æˆ·ä»˜æ¬¾',0),(579335,16093,'sv','Importera kundbetalningar',0),(579336,16093,'it','Importare i pagamenti dei clienti',0),(579337,16093,'tl','',0),(579338,16093,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(579339,16093,'hi','à¤†à¤¯à¤¾à¤¤ à¤—à¥à¤°à¤¾à¤¹à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(579340,16093,'ms','Pembayaran pelanggan import',0),(579341,16093,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(579342,16093,'fr','Importer les paiements des clients',0),(579343,16093,'jp','é¡§å®¢ã®æ”¯æ‰•ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(579344,16093,'pt','Importar os pagamentos do cliente',0),(579345,16093,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(579346,16093,'es','Importe de los pagos del cliente',0),(579347,16093,'de','Importieren von Kundenzahlungen',0),(579348,16093,'en','Import Customer Payments',0),(579349,16094,'is','',0),(579350,16094,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… Ù†Ù…Ø§Ø¨Ø±',0),(579351,16094,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… Ù†Ù…Ø§Ø¨Ø±',0),(579352,16094,'tr','Faks gÃ¼nlÃ¼ÄŸÃ¼',0),(579353,16094,'pl','Dziennika faksÃ³w',0),(579354,16094,'bg','Ð¤Ð°ÐºÑ Ñ€ÐµÐ³Ð¸ÑÑ‚ÑŠÑ€',0),(579355,16094,'ur','ÙÛŒÚ©Ø³ Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº',0),(579356,16094,'sr','Ð¤Ð°ÐºÑ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ðµ',0),(579357,16094,'vi','ÄÄƒng nháº­p Fax',0),(579358,16094,'af','Faks Log',0),(579359,16094,'ro','Jurnal de fax',0),(579360,16094,'et','Faks Logi',0),(579361,16094,'si','Dnevnika faksa',0),(579362,16094,'ba','Faks Log',0),(579363,16094,'nl','Fax Log',0),(579364,16094,'fi','Faksi loki',0),(579365,16094,'no','Faks Logg',0),(579366,16094,'da','Fax Log',0),(579367,16094,'ko','íŒ©ìŠ¤ ë¡œê·¸',0),(579368,16094,'he','×™×•×ž×Ÿ ×¤×§×¡',0),(579369,16094,'el','Î‘ÏÏ‡ÎµÎ¯Î¿Ï… ÎºÎ±Ï„Î±Î³ÏÎ±Ï†Î®Ï‚ Ï†Î±Î¾',0),(579370,16094,'zh','ä¼ çœŸæ—¥å¿—',0),(579371,16094,'sv','Fax Log',0),(579372,16094,'it','Registro fax',0),(579373,16094,'tl','',0),(579374,16094,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¹‚à¸—à¸£à¸ªà¸²à¸£',0),(579375,16094,'hi','à¤«à¤¼à¥ˆà¤•à¥à¤¸ à¤²à¥‰à¤—',0),(579376,16094,'ms','Log masuk Perkhidmatan Faks',0),(579377,16094,'ar','Ø³Ø¬Ù„ Ø§Ù„ÙØ§ÙƒØ³',0),(579378,16094,'fr','Journal de tÃ©lÃ©copies',0),(579379,16094,'jp','Fax ãƒ­ã‚°',0),(579380,16094,'pt','Registro de fax',0),(579381,16094,'ru','Ð¤Ð°ÐºÑ Ð¶ÑƒÑ€Ð½Ð°Ð»',0),(579382,16094,'es','Registro de fax',0),(579383,16094,'de','Faxprotokoll',0),(579384,16094,'en','Fax Log',0),(579385,16095,'is','',0),(579386,16095,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³Ø§Ù„ Ùˆ Ù…Ø§Ù‡',0),(579387,16095,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³Ø§Ù„ Ùˆ Ù…Ø§Ù‡',0),(579388,16095,'tr','Ay seÃ§in',0),(579389,16095,'pl','Wybierz miesiÄ…c',0),(579390,16095,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¼ÐµÑÐµÑ†',0),(579391,16095,'ur','Ù…Ø§Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(579392,16095,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼ÐµÑÐµÑ†',0),(579393,16095,'vi','Chá»n thÃ¡ng',0),(579394,16095,'af','Argiewe',0),(579395,16095,'ro','SelectaÅ£i lunÄƒ',0),(579396,16095,'et','Valige kuu',0),(579397,16095,'si','Izberite mesec',0),(579398,16095,'ba','Pilih bulan',0),(579399,16095,'nl','Selecteer maand',0),(579400,16095,'fi','Valitse kuukausi',0),(579401,16095,'no','Velg mÃ¥ned',0),(579402,16095,'da','VÃ¦lg mÃ¥ned',0),(579403,16095,'ko','ì„ íƒ ë‹¬',0),(579404,16095,'he','×‘×—×¨ ×—×•×“×©',0),(579405,16095,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î®Î½Î±',0),(579406,16095,'zh','é€‰æ‹©æœˆä»½',0),(579407,16095,'sv','VÃ¤lj mÃ¥nad',0),(579408,16095,'it','Selezionare il mese',0),(579409,16095,'tl','',0),(579410,16095,'th','à¹€à¸¥à¸·à¸­à¸à¹€à¸”à¸·à¸­à¸™',0),(579411,16095,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(579412,16095,'ms','Pilih bulan',0),(579413,16095,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø´Ù‡Ø±',0),(579414,16095,'fr','SÃ©lectionnez le mois',0),(579415,16095,'jp','æœˆã‚’é¸æŠžã—ã¾ã™ã€‚',0),(579416,16095,'pt','Selecione o mÃªs',0),(579417,16095,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¼ÐµÑÑÑ†',0),(579418,16095,'es','Seleccionar mes',0),(579419,16095,'de','WÃ¤hlen Sie Monat',0),(579420,16095,'en','Select Month',0),(579421,16096,'is','',0),(579422,16096,'dr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ - Ù…Ø­Ø§Ú©Ù…Ù‡',0),(579423,16096,'pr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ - Ù…Ø­Ø§Ú©Ù…Ù‡',0),(579424,16096,'tr','BilanÃ§o - deneme',0),(579425,16096,'pl','Bilans - Trial',0),(579426,16096,'bg','Ð‘Ð°Ð»Ð°Ð½Ñ - Ð¾Ð¿Ð¸Ñ‚',0),(579427,16096,'ur','ØªÙˆØ§Ø²Ù† ÙˆØ±Ù‚ - Ù…Ù‚Ø¯Ù…Û’ Ú©ÛŒ Ø³Ù…Ø§Ø¹Øª',0),(579428,16096,'sr','Ð‘Ð¸Ð»Ð°Ð½Ñ ÑÑ‚Ð°ÑšÐ° - ÑÑƒÑ’ÐµÑšÐµ',0),(579429,16096,'vi','Balance Sheet - thá»­ nghiá»‡m',0),(579430,16096,'af','Balansstaat - verhoor',0),(579431,16096,'ro','BilanÅ£ul - proces',0),(579432,16096,'et','Bilanss - uuringus',0),(579433,16096,'si','Bilanca stanja - poskus',0),(579434,16096,'ba','Neraca - Trial',0),(579435,16096,'nl','Balans - Trial',0),(579436,16096,'fi','Tase - oikeudenkÃ¤ynti',0),(579437,16096,'no','Balanse - Trial',0),(579438,16096,'da','Balancen - retssag',0),(579439,16096,'ko','ëŒ€ì°¨ ëŒ€ì¡°í‘œ-ìž¬íŒ',0),(579440,16096,'he','×ž××–×Ÿ - ×ž×©×¤×˜',0),(579441,16096,'el','Î™ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ - Î´Î¯ÎºÎ·',0),(579442,16096,'zh','èµ„äº§è´Ÿå€ºè¡¨-å®¡åˆ¤',0),(579443,16096,'sv','BalansrÃ¤kning - rÃ¤ttegÃ¥ng',0),(579444,16096,'it','Stato patrimoniale - prova',0),(579445,16096,'tl','',0),(579446,16096,'th','à¸‡à¸šà¸”à¸¸à¸¥ - à¸—à¸”à¸¥à¸­à¸‡',0),(579447,16096,'hi','à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ - à¤ªà¤°à¥€à¤•à¥à¤·à¤£',0),(579448,16096,'ms','Lembaran imbangan - perbicaraan',0),(579449,16096,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¹Ù…ÙˆÙ…ÙŠØ©-Ø§Ù„Ù…Ø­Ø§ÙƒÙ…Ø©',0),(579450,16096,'fr','Bilan consolidÃ© - procÃ¨s',0),(579451,16096,'jp','è²¸å€Ÿå¯¾ç…§è¡¨ - è©¦ç”¨ç‰ˆ',0),(579452,16096,'pt','BalanÃ§o patrimonial - julgamento',0),(579453,16096,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ - ÑÑƒÐ´Ð°',0),(579454,16096,'es','Balance general - ensayos',0),(579455,16096,'de','Bilanz - Testversion',0),(579456,16096,'en','Balance Sheet - Trial',0),(579457,16097,'is','',0),(579458,16097,'dr','Ø§ØªØµØ§Ù„ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯',0),(579459,16097,'pr','Ø§ØªØµØ§Ù„ Ø§Ù†Ø¬Ø§Ù… Ù†Ø´Ø¯',0),(579460,16097,'tr','BaÄŸlantÄ± baÅŸarÄ±sÄ±z oldu',0),(579461,16097,'pl','PoÅ‚Ä…czenie nie powiodÅ‚o siÄ™',0),(579462,16097,'bg','Ð’Ñ€ÑŠÐ·ÐºÐ°Ñ‚Ð° Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð°',0),(579463,16097,'ur','Ø±Ø§Ø¨Ø·Û Ù†Ø§Ú©Ø§Ù… ÛÙˆÚ¯ÛŒØ§',0),(579464,16097,'sr','Ð’ÐµÐ·Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°',0),(579465,16097,'vi','Káº¿t ná»‘i khÃ´ng thÃ nh cÃ´ng',0),(579466,16097,'af','Verbinding het misluk',0),(579467,16097,'ro','Conexiunea a eÅŸuat',0),(579468,16097,'et','Ãœhendus nurjus',0),(579469,16097,'si','Povezava ni uspela',0),(579470,16097,'ba','Koneksi gagal.',0),(579471,16097,'nl','Verbinding mislukt',0),(579472,16097,'fi','Yhteys epÃ¤onnistui',0),(579473,16097,'no','Tilkobling mislyktes',0),(579474,16097,'da','Forbindelse mislykkedes',0),(579475,16097,'ko','ì—°ê²° ì‹¤íŒ¨',0),(579476,16097,'he','×”×—×™×‘×•×¨ × ×›×©×œ',0),(579477,16097,'el','Î— ÏƒÏÎ½Î´ÎµÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(579478,16097,'zh','è¿žæŽ¥å¤±è´¥',0),(579479,16097,'sv','Anslutning misslyckades',0),(579480,16097,'it','Connessione non riuscita',0),(579481,16097,'tl','',0),(579482,16097,'th','à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¸•à¹ˆà¸­à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(579483,16097,'hi','à¤•à¤¨à¥‡à¤•à¥à¤¶à¤¨ à¤µà¤¿à¤«à¤²',0),(579484,16097,'ms','Sambungan yang gagal',0),(579485,16097,'ar','ÙØ´Ù„ Ø§Ù„Ø§ØªØµØ§Ù„',0),(579486,16097,'fr','Ã‰chouÃ© de la connexion',0),(579487,16097,'jp','æŽ¥ç¶šã«å¤±æ•—ã—ã¾ã—ãŸ',0),(579488,16097,'pt','ConexÃ£o falhado',0),(579489,16097,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾Ð´ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ',0),(579490,16097,'es','Fallado la conexiÃ³n',0),(579491,16097,'de','Verbindung fehlgeschlagen',0),(579492,16097,'en','Connection Failed',0),(579493,16098,'is','',0),(579494,16098,'dr','Ú©Ø§Ø± Ø§ÛŒÙ…ÛŒÙ„ Prelim Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(579495,16098,'pr','Ú©Ø§Ø± Ø§ÛŒÙ…ÛŒÙ„ Prelim Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(579496,16098,'tr','E-postayla gÃ¶nderilen iÅŸ Prelim isteÄŸi',0),(579497,16098,'pl','Å»Ä…dania Prelim zadania e-mailem',0),(579498,16098,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð·Ð°ÑÐ²ÐºÐ°',0),(579499,16098,'ur','Ø¨Ø±Ù‚ÛŒ ÚˆØ§Ú© Ú©Ø§ Ú©Ø§Ù… Ù¾Ø±ÛŒÙ„Ø§Ù… Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(579500,16098,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° ÑƒÐ²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ Ð¿Ð¾ÑˆÑ‚Ð¾Ð¼ Ð¿Ð¾ÑÐ°Ð¾',0),(579501,16098,'vi','Viá»‡c gá»­i Prelim yÃªu cáº§u',0),(579502,16098,'af','Per e-pos werk Prelim versoek',0),(579503,16098,'ro','Cerere de preliminare Job prin e-mail',0),(579504,16098,'et','Saadetud tÃ¶Ã¶ aasta taotluse',0),(579505,16098,'si','Poslano delo predhodnega zahtevo',0),(579506,16098,'ba','Email pekerjaan Prelim permintaan',0),(579507,16098,'nl','Maild baan kwalificatie verzoek',0),(579508,16098,'fi','LÃ¤hetetty tarjouspyyntÃ¶ korj',0),(579509,16098,'no','Sendt jobben Prelim forespÃ¸rsel',0),(579510,16098,'da','E-mailede Job Prelim anmodning',0),(579511,16098,'ko','ì´ë©”ì¼ë¡œ ìž‘ì—… ê²Œìž„ì¸ ìš”ì²­',0),(579512,16098,'he','×‘×§×©×” ×‘×“×•××¨ ××ª ×”×¢×‘×•×“×” ×ž×•×§×“×',0),(579513,16098,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ Î±Î¯Ï„Î·Î¼Î± Î¼Î­ÏƒÏ‰ email ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(579514,16098,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€çš„å·¥ä½œåˆè¯•è¯·æ±‚',0),(579515,16098,'sv','Mejlat jobb Prelim begÃ¤ran',0),(579516,16098,'it','Richiesta di lavoro via e-mail Prelim',0),(579517,16098,'tl','',0),(579518,16098,'th','à¸‚à¸­ Prelim à¸‡à¸²à¸™à¸­à¸µà¹€à¸¡à¸¥',0),(579519,16098,'hi','à¤ˆà¤®à¥‡à¤² à¤•à¤¾à¤°à¥à¤¯ Prelim à¤…à¤¨à¥à¤°à¥‹à¤§',0),(579520,16098,'ms','E kerja Prelim permintaan',0),(579521,16098,'ar','Ø·Ù„Ø¨ Prelim ÙˆØ¸ÙŠÙØ© Ø¹Ø¨Ø± Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(579522,16098,'fr','Demande de Prelim dâ€™emploi par courriel',0),(579523,16098,'jp','ãƒ¡ãƒ¼ãƒ«ã§ä»•äº‹ã«äºˆå‚™ã®è¦æ±‚',0),(579524,16098,'pt','Pedido de exame preliminar emprego por e-mail',0),(579525,16098,'ru','ÐŸÐ¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ñƒ Prelim Ð·Ð°Ð¿Ñ€Ð¾Ñ',0),(579526,16098,'es','Solicitud de empleo por correo electrÃ³nico Prelim',0),(579527,16098,'de','Per e-Mail Jobanforderung Bracelet',0),(579528,16098,'en','Emailed Job Prelim Request',0),(579529,16099,'is','',0),(579530,16099,'dr','Ø§ÛŒÙ…ÛŒÙ„',0),(579531,16099,'pr','Ø§ÛŒÙ…ÛŒÙ„',0),(579532,16099,'tr','E-postalar',0),(579533,16099,'pl','E-maile',0),(579534,16099,'bg','Ð˜Ð¼ÐµÐ¹Ð»Ð¸',0),(579535,16099,'ur','Ø§ÛŒ Ù…ÛŒÙ„Ø²',0),(579536,16099,'sr','Ð•-Ð¼Ð°Ð¸Ð»Ð¾Ð²Ð¸',0),(579537,16099,'vi','Email',0),(579538,16099,'af','E-posse',0),(579539,16099,'ro','E-mailuri',0),(579540,16099,'et','E-kirju',0),(579541,16099,'si','E-poÅ¡to',0),(579542,16099,'ba','Email',0),(579543,16099,'nl','E-mails',0),(579544,16099,'fi','SÃ¤hkÃ¶postit',0),(579545,16099,'no','E-post',0),(579546,16099,'da','E-mails',0),(579547,16099,'ko','ì´ë©”ì¼',0),(579548,16099,'he','×”×•×“×¢×•×ª ×“×•×',0),(579549,16099,'el','ÎœÎ·Î½ÏÎ¼Î±Ï„Î± Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(579550,16099,'zh','ç”µå­é‚®ä»¶',0),(579551,16099,'sv','E-post',0),(579552,16099,'it','Messaggi di posta elettronica',0),(579553,16099,'tl','',0),(579554,16099,'th','à¸­à¸µà¹€à¸¡à¸¥à¹Œ',0),(579555,16099,'hi','à¤ˆà¤®à¥‡à¤²',0),(579556,16099,'ms','E-mel',0),(579557,16099,'ar','Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(579558,16099,'fr','E-mails',0),(579559,16099,'jp','ãƒ¡ãƒ¼ãƒ«',0),(579560,16099,'pt','E-mails',0),(579561,16099,'ru','ÐŸÐ¸ÑÑŒÐ¼Ð°',0),(579562,16099,'es','Mensajes de correo electrÃ³nico',0),(579563,16099,'de','E-Mails',0),(579564,16099,'en','Emails',0),(579565,16100,'is','',0),(579566,16100,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙƒØ§Ø± ÙÚ©Ø³ Prelim',0),(579567,16100,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª ÙƒØ§Ø± ÙÚ©Ø³ Prelim',0),(579568,16100,'tr','Faks iÅŸi Prelim isteÄŸi',0),(579569,16100,'pl','Å»Ä…dania Prelim faksem zadania',0),(579570,16100,'bg','ÐŸÐ¾ Ñ„Ð°ÐºÑ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð·Ð°ÑÐ²ÐºÐ°',0),(579571,16100,'ur','ÙØ§Ø§Ø§Ø¯ Ú©Ø§Ù… Ù¾Ø±ÛŒÙ„Ø§Ù… Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(579572,16100,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° ÑƒÐ²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ Ñ„Ð°ÐºÑÐ¾Ð¼ Ð¿Ð¾ÑÐ°Ð¾',0),(579573,16100,'vi','CÃ´ng viá»‡c Fax Prelim yÃªu cáº§u',0),(579574,16100,'af','Gefaks werk Prelim versoek',0),(579575,16100,'ro','Cerere de preliminare fax Job',0),(579576,16100,'et','Faksi teel tÃ¶Ã¶ aasta taotluse',0),(579577,16100,'si','Faksu delo predhodnega zahtevo',0),(579578,16100,'ba','Pekerjaan Faks Prelim permintaan',0),(579579,16100,'nl','Gefaxte baan kwalificatie verzoek',0),(579580,16100,'fi','Faksilla alustava tarjouspyyntÃ¶',0),(579581,16100,'no','Fakset jobb Prelim forespÃ¸rsel',0),(579582,16100,'da','Faxede Job Prelim anmodning',0),(579583,16100,'ko','íŒ©ìŠ¤ ìž‘ì—… ê²Œìž„ì¸ ìš”ì²­',0),(579584,16100,'he','×”×‘×§×©×” ×©× ×©×œ×— ×‘×¤×§×¡ ××ª ×”×¢×‘×•×“×” ×ž×•×§×“×',0),(579585,16100,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ Î±Î¯Ï„Î·Î¼Î± Î¼Îµ Ï†Î±Î¾ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(579586,16100,'zh','ä¼ çœŸçš„ä½œä¸šåˆè¯•è¯·æ±‚',0),(579587,16100,'sv','Faxade jobb Prelim begÃ¤ran',0),(579588,16100,'it','Richiesta di lavoro via fax Prelim',0),(579589,16100,'tl','',0),(579590,16100,'th','à¸‚à¸­ Prelim à¸‡à¸²à¸™à¸—à¸²à¸‡à¹‚à¸—à¸£à¸ªà¸²à¸£',0),(579591,16100,'hi','à¤«à¤¼à¥ˆà¤•à¥à¤¸ à¤•à¤¾à¤°à¥à¤¯ Prelim à¤…à¤¨à¥à¤°à¥‹à¤§',0),(579592,16100,'ms','Kerja faksimili Prelim permintaan',0),(579593,16100,'ar','Ø·Ù„Ø¨ Prelim Ù…Ù‡Ù…Ø© Ø§Ù„ÙØ§ÙƒØ³',0),(579594,16100,'fr','Emploi par tÃ©lÃ©copieur Prelim demande',0),(579595,16100,'jp','ãƒ•ã‚¡ãƒƒã‚¯ã‚¹ ã‚¸ãƒ§ãƒ–ã«äºˆå‚™ã®è¦æ±‚',0),(579596,16100,'pt','Pedido preliminar de trabalho por fax',0),(579597,16100,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð¿Ð¾ Ñ„Ð°ÐºÑÑƒ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Prelim',0),(579598,16100,'es','Solicitud de empleo por fax Prelim',0),(579599,16100,'de','Gefaxte Jobanforderung Bracelet',0),(579600,16100,'en','Faxed Job Prelim Request',0),(579601,16101,'is','',0),(579602,16101,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ù…Ø´Ø§ØºÙ„',0),(579603,16101,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ù…Ø´Ø§ØºÙ„',0),(579604,16101,'tr','Alma iÅŸleri',0),(579605,16101,'pl','Importowanie zadaÅ„',0),(579606,16101,'bg','Ð—Ð°Ð´Ð°Ñ‡Ð¸ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(579607,16101,'ur','Ø±ÙˆØ²Ú¯Ø§Ø± Ú©Û’ Ù…ÙˆØ§Ù‚Ø¹ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(579608,16101,'sr','ÐŸÐ¾ÑÐ»Ð¾Ð²Ð¸ ÑƒÐ²Ð¾Ð·Ð°',0),(579609,16101,'vi','CÃ¡c cÃ´ng viá»‡c nháº­p kháº©u',0),(579610,16101,'af','Voer take',0),(579611,16101,'ro','Locuri de muncÄƒ de import',0),(579612,16101,'et','Impordi tÃ¶Ã¶kohti',0),(579613,16101,'si','Posli uvoza',0),(579614,16101,'ba','Impor pekerjaan',0),(579615,16101,'nl','Importeren van banen',0),(579616,16101,'fi','Tuonti tyÃ¶paikat',0),(579617,16101,'no','Import jobber',0),(579618,16101,'da','Importjob',0),(579619,16101,'ko','ê°€ì ¸ì˜¤ê¸° ìž‘ì—…',0),(579620,16101,'he','×ž×©×™×ž×•×ª ×™×™×‘×•×',0),(579621,16101,'el','Î•ÏÎ³Î±ÏƒÎ¯ÎµÏ‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(579622,16101,'zh','å¯¼å…¥ä½œä¸š',0),(579623,16101,'sv','Importjobb',0),(579624,16101,'it','Processi di importazione',0),(579625,16101,'tl','',0),(579626,16101,'th','à¸‡à¸²à¸™à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(579627,16101,'hi','à¤†à¤¯à¤¾à¤¤ à¤œà¥‹à¤¬à¥à¤¸',0),(579628,16101,'ms','Pekerjaan import',0),(579629,16101,'ar','ÙˆØ¸Ø§Ø¦Ù Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(579630,16101,'fr','Importer des emplois',0),(579631,16101,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ã‚¸ãƒ§ãƒ–',0),(579632,16101,'pt','Empregos de importaÃ§Ã£o',0),(579633,16101,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ñ€Ð°Ð±Ð¾Ñ‡Ð¸Ñ… Ð¼ÐµÑÑ‚',0),(579634,16101,'es','Empleos de importaciÃ³n',0),(579635,16101,'de','ImportauftrÃ¤ge',0),(579636,16101,'en','Import Jobs',0),(579637,16102,'is','',0),(579638,16102,'dr','Ú©Ø§Ø± Prelim Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡',0),(579639,16102,'pr','Ú©Ø§Ø± Prelim Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¯Ø±ÛŒØ§ÙØª Ø´Ø¯Ù‡',0),(579640,16102,'tr','AlÄ±nan iÅŸ Ã¶n bilgi',0),(579641,16102,'pl','Praca Prelim informacje otrzymane',0),(579642,16102,'bg','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð°Ñ‚Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½',0),(579643,16102,'ur','Ú©Ø§Ù… Ù¾Ø±ÛŒÙ„Ø§Ù… Ø­Ø§ØµÙ„ ÛÙˆÙ†Û’ ÙˆØ§Ù„ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(579644,16102,'sr','Ð”Ð¾Ð±Ð¸Ñ˜ÐµÐ½Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÐ°Ð¾ ÑƒÐ²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ',0),(579645,16102,'vi','Viá»‡c lÃ m Prelim thÃ´ng tin nháº­n Ä‘Æ°á»£c',0),(579646,16102,'af','Werk Prelim inligting ontvang',0),(579647,16102,'ro','Job preliminare informaÅ£iile primite',0),(579648,16102,'et','TÃ¶Ã¶ aasta kohta saadud',0),(579649,16102,'si','Delo predhodnega informacije, prejete',0),(579650,16102,'ba','Pekerjaan Prelim informasi yang diterima',0),(579651,16102,'nl','Kwalificatie taakinformatie ontvangen',0),(579652,16102,'fi','TyÃ¶n alustava Saamiensa',0),(579653,16102,'no','Jobbinformasjonen Prelim mottatt',0),(579654,16102,'da','Job Prelim oplysninger modtaget',0),(579655,16102,'ko','ì¼ ì˜ˆì„  ì •ë³´',0),(579656,16102,'he','×”×¢×‘×•×“×” ×ž×•×§×“× ×ž×™×“×¢ ×©×”×ª×§×‘×œ',0),(579657,16102,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Ï€ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ Î­Î»Î±Î²Îµ',0),(579658,16102,'zh','æ”¶åˆ°çš„å·¥ä½œåˆæ­¥èµ„æ–™',0),(579659,16102,'sv','Prelim jobbinformation fick',0),(579660,16102,'it','Lavoro Prelim informazioni ricevute',0),(579661,16102,'tl','',0),(579662,16102,'th','à¸‡à¸²à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥ Prelim à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸š',0),(579663,16102,'hi','à¤¨à¥Œà¤•à¤°à¥€ Prelim à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤',0),(579664,16102,'ms','Maklumat Prelim kerja yang diterima',0),(579665,16102,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Prelim Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„ÙˆØ§Ø±Ø¯Ø©',0),(579666,16102,'fr','Emploi Prelim informations reÃ§ues',0),(579667,16102,'jp','å—ä¿¡ã—ãŸã‚¸ãƒ§ãƒ–ã«äºˆå‚™æ ¼ä»˜ã‘æƒ…å ±',0),(579668,16102,'pt','Trabalho preliminar informaÃ§Ãµes recebidas',0),(579669,16102,'ru','ÐŸÐ¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ð°Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Prelim Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(579670,16102,'es','Trabajo Prelim informaciÃ³n recibida',0),(579671,16102,'de','Job-Bracelet-Informationen erhalten',0),(579672,16102,'en','Job Prelim Information Received',0),(579673,16103,'is','',0),(579674,16103,'dr','Ù†Ø§Ù…Ù‡ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(579675,16103,'pr','Ù†Ø§Ù…Ù‡ ÙØ±Ø³ØªØ§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(579676,16103,'tr','GÃ¶nderilmiÅŸ postalar',0),(579677,16103,'pl','Poczta wysÅ‚ana',0),(579678,16103,'bg','ÐŸÐ¾Ñ‰Ð°, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð°',0),(579679,16103,'ur','Ù…Ø±Ø³Ù„Û ÚˆØ§Ú©',0),(579680,16103,'sr','ÐŸÐ¾ÑˆÑ‚Ð° Ð¿Ð¾ÑÐ»Ð°Ñ‚Ð°',0),(579681,16103,'vi','ThÆ° gá»­i',0),(579682,16103,'af','E-pos gestuur',0),(579683,16103,'ro','CorespondenÈ›Äƒ trimisÄƒ',0),(579684,16103,'et','Saadetud meilisÃµnumid',0),(579685,16103,'si','PoÅ¡ta, poslana',0),(579686,16103,'ba','E-mail yang dikirim',0),(579687,16103,'nl','E-mail die is verzonden',0),(579688,16103,'fi','LÃ¤hetetyt viestit',0),(579689,16103,'no','Post sendt',0),(579690,16103,'da','Mail sendt',0),(579691,16103,'ko','ë³´ë‚¸ ë©”ì¼',0),(579692,16103,'he','×“×•××¨ ×©× ×©×œ×—',0),(579693,16103,'el','Î‘Î»Î»Î·Î»Î¿Î³ÏÎ±Ï†Î¯Î± Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»ÎµÏ„Î±Î¹',0),(579694,16103,'zh','å‘é€é‚®ä»¶',0),(579695,16103,'sv','E-post',0),(579696,16103,'it','Posta inviata',0),(579697,16103,'tl','',0),(579698,16103,'th','à¸ˆà¸”à¸«à¸¡à¸²à¸¢à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡',0),(579699,16103,'hi','à¤­à¥‡à¤œà¥€ à¤—à¤ˆ à¤®à¥‡à¤²',0),(579700,16103,'ms','Mel yang dihantar',0),(579701,16103,'ar','Ø¨Ø±ÙŠØ¯ Ù…Ø±Ø³Ù„',0),(579702,16103,'fr','Courrier envoyÃ©',0),(579703,16103,'jp','é€ä¿¡ã•ã‚ŒãŸãƒ¡ãƒ¼ãƒ«',0),(579704,16103,'pt','Mail enviado',0),(579705,16103,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð°, Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÑÐµÐ¼Ð°Ñ',0),(579706,16103,'es','Correo enviado',0),(579707,16103,'de','Gesendete Nachrichten',0),(579708,16103,'en','Mail Sent',0),(579709,16104,'is','',0),(579710,16104,'dr','ØªÙ„ÙÙ† Ù‡Ø§ÛŒ',0),(579711,16104,'pr','ØªÙ„ÙÙ† Ù‡Ø§ÛŒ',0),(579712,16104,'tr','TelefonlarÄ±',0),(579713,16104,'pl','Telefony',0),(579714,16104,'bg','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð¸',0),(579715,16104,'ur','ÙÙˆÙ†Ø²',0),(579716,16104,'sr','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ð¸',0),(579717,16104,'vi','Äiá»‡n thoáº¡i',0),(579718,16104,'af','Selfone',0),(579719,16104,'ro','Telefoane',0),(579720,16104,'et','Telefonid',0),(579721,16104,'si','Telefoni',0),(579722,16104,'ba','Telepon',0),(579723,16104,'nl','Telefoons',0),(579724,16104,'fi','Puhelimet',0),(579725,16104,'no','Telefoner',0),(579726,16104,'da','Telefoner',0),(579727,16104,'ko','ì „í™”',0),(579728,16104,'he','×˜×œ×¤×•× ×™×',0),(579729,16104,'el','Î¤Î·Î»Î­Ï†Ï‰Î½Î±',0),(579730,16104,'zh','ç”µè¯',0),(579731,16104,'sv','Telefoner',0),(579732,16104,'it','Telefoni',0),(579733,16104,'tl','',0),(579734,16104,'th','à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œà¸¡à¸·à¸­à¸–à¸·à¸­',0),(579735,16104,'hi','à¤«à¥‹à¤¨',0),(579736,16104,'ms','Telefon',0),(579737,16104,'ar','Ø§Ù„Ù‡ÙˆØ§ØªÙ',0),(579738,16104,'fr','TÃ©lÃ©phones',0),(579739,16104,'jp','é›»è©±',0),(579740,16104,'pt','Telefones',0),(579741,16104,'ru','Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½Ñ‹',0),(579742,16104,'es','TelÃ©fonos',0),(579743,16104,'de','Handys',0),(579744,16104,'en','Phones',0),(579745,16105,'is','',0),(579746,16105,'dr','ØªÙ…Ø§Ø³ Ø¨Ø§ prelim',0),(579747,16105,'pr','ØªÙ…Ø§Ø³ Ø¨Ø§ prelim',0),(579748,16105,'tr','Prelim iletiÅŸim',0),(579749,16105,'pl','Prelim kontakt',0),(579750,16105,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(579751,16105,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ø±Ø§Ø¨Ø·Û',0),(579752,16105,'sr','Ð£Ð²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(579753,16105,'vi','LiÃªn há»‡ prelim',0),(579754,16105,'af','Prelim kontak',0),(579755,16105,'ro','Contact preliminare',0),(579756,16105,'et','Aasta kontakt',0),(579757,16105,'si','Predhodnega stika',0),(579758,16105,'ba','Kontak prelim',0),(579759,16105,'nl','Kwalificatie-Contact',0),(579760,16105,'fi','Alustava yhteys',0),(579761,16105,'no','Prelim kontakt',0),(579762,16105,'da','Prelim kontakt',0),(579763,16105,'ko','ì˜ˆì„  ì—°ë½ì²˜',0),(579764,16105,'he','×§×©×¨ ×ž×•×§×“×',0),(579765,16105,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ ÎµÏ€Î±Ï†Î®',0),(579766,16105,'zh','åˆæ­¥æŽ¥è§¦',0),(579767,16105,'sv','Prelim kontakt',0),(579768,16105,'it','Contatto preliminare',0),(579769,16105,'tl','',0),(579770,16105,'th','à¸•à¸´à¸”à¸•à¹ˆà¸­ prelim',0),(579771,16105,'hi','Prelim à¤¸à¤‚à¤ªà¤°à¥à¤•',0),(579772,16105,'ms','Hubungi prelim',0),(579773,16105,'ar','Ø§Ù„Ø§ØªØµØ§Ù„ prelim',0),(579774,16105,'fr','Prelim Contact',0),(579775,16105,'jp','ãŠå•ã„åˆã‚ã›ã«äºˆå‚™æ ¼ä»˜ã‘',0),(579776,16105,'pt','Contato preliminar',0),(579777,16105,'ru','Prelim ÐºÐ¾Ð½Ñ‚Ð°ÐºÑ‚',0),(579778,16105,'es','Prelim contacto',0),(579779,16105,'de','Bracelet-Kontakt',0),(579780,16105,'en','Prelim Contact',0),(579781,16106,'is','',0),(579782,16106,'dr','Ø´Ù‡Ø±Ø³ØªØ§Ù† prelim',0),(579783,16106,'pr','Ø´Ù‡Ø±Ø³ØªØ§Ù† prelim',0),(579784,16106,'tr','Prelim ÅŸehristanÄ±',0),(579785,16106,'pl','Prelim County',0),(579786,16106,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð¾ÐºÑ€ÑŠÐ³',0),(579787,16106,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ú©Ø§Ø¤Ù†Ù¹ÛŒ',0),(579788,16106,'sr','Ð£Ð²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ Ð¾ÐºÑ€ÑƒÐ³',0),(579789,16106,'vi','Quáº­n prelim',0),(579790,16106,'af','Prelim County',0),(579791,16106,'ro','Preliminare County',0),(579792,16106,'et','Aasta maakonna',0),(579793,16106,'si','Predhodnega County',0),(579794,16106,'ba','Prelim County',0),(579795,16106,'nl','Kwalificatie County',0),(579796,16106,'fi','Alustava County',0),(579797,16106,'no','Prelim County',0),(579798,16106,'da','Prelim County',0),(579799,16106,'ko','ì˜ˆì„  í˜„',0),(579800,16106,'he','×ž×—×•×– ×ž×•×§×“×',0),(579801,16106,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ County',0),(579802,16106,'zh','åˆè¯•åŽ¿',0),(579803,16106,'sv','Prelim County',0),(579804,16106,'it','Contea di Prelim',0),(579805,16106,'tl','',0),(579806,16106,'th','à¹€à¸‚à¸• prelim',0),(579807,16106,'hi','Prelim à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€',0),(579808,16106,'ms','Prelim County',0),(579809,16106,'ar','Ù…Ù‚Ø§Ø·Ø¹Ø© prelim',0),(579810,16106,'fr','ComtÃ© de Prelim',0),(579811,16106,'jp','äºˆå‚™éƒ¡',0),(579812,16106,'pt','Condado de prelim',0),(579813,16106,'ru','Prelim ÐšÐ°ÑƒÐ½Ñ‚Ð¸',0),(579814,16106,'es','Condado de prelim',0),(579815,16106,'de','Prelim County',0),(579816,16106,'en','Prelim County',0),(579817,16107,'is','',0),(579818,16107,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª prelim',0),(579819,16107,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª prelim',0),(579820,16107,'tr','Ã–n duruÅŸma talep bilgisi',0),(579821,16107,'pl','Prelim Info wniosek',0),(579822,16107,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð°ÑÐ²ÐºÐ°',0),(579823,16107,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(579824,16107,'sr','Ð£Ð²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ Ð˜Ð½Ñ„Ð¾ Ð·Ð°Ñ…Ñ‚ÐµÐ²',0),(579825,16107,'vi','Prelim thÃ´ng tin yÃªu cáº§u',0),(579826,16107,'af','Prelim inligting versoek',0),(579827,16107,'ro','Cerere de informaÅ£ii preliminare',0),(579828,16107,'et','Aasta infopÃ¤ring',0),(579829,16107,'si','Predhodnega Info zahtevo',0),(579830,16107,'ba','Prelim Info permintaan',0),(579831,16107,'nl','Kwalificatie Informatieaanvraag',0),(579832,16107,'fi','Alustava Info pyyntÃ¶',0),(579833,16107,'no','Prelim Info forespÃ¸rsel',0),(579834,16107,'da','Prelim Info anmodning',0),(579835,16107,'ko','ì˜ˆì„  ì •ë³´ ìš”ì²­',0),(579836,16107,'he','×‘×§×© ×ž×™×“×¢ ×ž×•×§×“×',0),(579837,16107,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ Î±Î¯Ï„Î·Î¼Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½',0),(579838,16107,'zh','åˆè¯•ä¿¡æ¯è¯·æ±‚',0),(579839,16107,'sv','Prelim information begÃ¤ran',0),(579840,16107,'it','Richiesta Info Prelim',0),(579841,16107,'tl','',0),(579842,16107,'th','à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸‚à¹‰à¸­à¸¡à¸¹à¸¥ prelim',0),(579843,16107,'hi','Prelim à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¨à¥à¤°à¥‹à¤§',0),(579844,16107,'ms','Permintaan maklumat prelim',0),(579845,16107,'ar','Ø·Ù„Ø¨ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª prelim',0),(579846,16107,'fr','Demande Info Prelim',0),(579847,16107,'jp','äºˆå‚™æ ¼ä»˜ã‘æƒ…å ±è¦æ±‚',0),(579848,16107,'pt','Pedido de informaÃ§Ã£o preliminar',0),(579849,16107,'ru','Ð—Ð°Ð¿Ñ€Ð¾Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Prelim',0),(579850,16107,'es','Solicitud de Info prelim',0),(579851,16107,'de','Vorrunde Info Anfrage',0),(579852,16107,'en','Prelim Info Request',0),(579853,16108,'is','',0),(579854,16108,'dr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ prelim',0),(579855,16108,'pr','Ø¯Ø³ØªÙˆØ±Ø§Ù„Ø¹Ù…Ù„ prelim',0),(579856,16108,'tr','Prelim yÃ¶nergeleri',0),(579857,16108,'pl','Prelim instrukcje',0),(579858,16108,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(579859,16108,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… ÛØ¯Ø§ÛŒØ§Øª',0),(579860,16108,'sr','Ð£Ð²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ ÑƒÐ¿ÑƒÑ‚ÑÑ‚Ð²Ð°',0),(579861,16108,'vi','HÆ°á»›ng dáº«n prelim',0),(579862,16108,'af','Prelim instruksies',0),(579863,16108,'ro','InstrucÅ£iuni preliminare',0),(579864,16108,'et','Aasta juhised',0),(579865,16108,'si','Predhodnega navodila',0),(579866,16108,'ba','Prelim petunjuk',0),(579867,16108,'nl','Kwalificatie-instructies',0),(579868,16108,'fi','Alustava ohjeet',0),(579869,16108,'no','Prelim instruksjoner',0),(579870,16108,'da','Prelim instruktioner',0),(579871,16108,'ko','ì˜ˆì„  ì•ˆë‚´',0),(579872,16108,'he','×”×•×¨××•×ª ×ž×•×§×“×',0),(579873,16108,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ Î¿Î´Î·Î³Î¯ÎµÏ‚',0),(579874,16108,'zh','åˆæ­¥è¯´æ˜Ž',0),(579875,16108,'sv','Prelim instruktioner',0),(579876,16108,'it','Prelim istruzioni',0),(579877,16108,'tl','',0),(579878,16108,'th','à¹à¸™à¸°à¸™à¸³ prelim',0),(579879,16108,'hi','Prelim à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶',0),(579880,16108,'ms','Arahan prelim',0),(579881,16108,'ar','ØªØ¹Ù„ÙŠÙ…Ø§Øª prelim',0),(579882,16108,'fr','Prelim Instructions',0),(579883,16108,'jp','æŒ‡ç¤ºã«äºˆå‚™æ ¼ä»˜ã‘',0),(579884,16108,'pt','InstruÃ§Ãµes preliminares',0),(579885,16108,'ru','Prelim Ð¸Ð½ÑÑ‚Ñ€ÑƒÐºÑ†Ð¸Ð¸',0),(579886,16108,'es','Instrucciones de prelim',0),(579887,16108,'de','Bracelet Anleitung',0),(579888,16108,'en','Prelim Instructions',0),(579889,16109,'is','',0),(579890,16109,'dr','ÙˆØ¶Ø¹ÛŒØª prelim',0),(579891,16109,'pr','ÙˆØ¶Ø¹ÛŒØª prelim',0),(579892,16109,'tr','Prelim durumu',0),(579893,16109,'pl','Prelim Status',0),(579894,16109,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(579895,16109,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ø­Ø§Ù„Øª',0),(579896,16109,'sr','Ð£Ð²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(579897,16109,'vi','Tráº¡ng thÃ¡i prelim',0),(579898,16109,'af','Prelim Status',0),(579899,16109,'ro','Statutul preliminare',0),(579900,16109,'et','Aasta staatus',0),(579901,16109,'si','Predhodnega statusa',0),(579902,16109,'ba','Prelim Status',0),(579903,16109,'nl','Kwalificatie-Status',0),(579904,16109,'fi','Alustava tila',0),(579905,16109,'no','Prelim Status',0),(579906,16109,'da','Prelim Status',0),(579907,16109,'ko','ì˜ˆì„  ìƒíƒœ',0),(579908,16109,'he','×ž×¦×‘ ×ž×•×§×“×',0),(579909,16109,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(579910,16109,'zh','åˆè¯•çŠ¶æ€',0),(579911,16109,'sv','Prelim Status',0),(579912,16109,'it','Stato Prelim',0),(579913,16109,'tl','',0),(579914,16109,'th','à¸ªà¸–à¸²à¸™à¸° prelim',0),(579915,16109,'hi','Prelim à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(579916,16109,'ms','Prelim Status',0),(579917,16109,'ar','Ù…Ø±ÙƒØ² prelim',0),(579918,16109,'fr','Prelim statut',0),(579919,16109,'jp','ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã«äºˆå‚™æ ¼ä»˜ã‘',0),(579920,16109,'pt','Prelim Status',0),(579921,16109,'ru','Prelim ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(579922,16109,'es','Estado de prelim',0),(579923,16109,'de','Bracelet-Status',0),(579924,16109,'en','Prelim Status',0),(579925,16110,'is','',0),(579926,16110,'dr','ØªÙ†Ø¸ÛŒÙ… Ù‚Ø§Ù„Ø¨ prelim',0),(579927,16110,'pr','ØªÙ†Ø¸ÛŒÙ… Ù‚Ø§Ù„Ø¨ prelim',0),(579928,16110,'tr','Prelim ÅŸablon ayarlanmamÄ±ÅŸ',0),(579929,16110,'pl','Nie zestaw Prelim szablonu',0),(579930,16110,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼',0),(579931,16110,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ø³Ø§Ù†Ú†Ø§ Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(579932,16110,'sr','Ð£Ð²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ Ð¿Ñ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(579933,16110,'vi','Prelim máº«u khÃ´ng Ä‘Æ°á»£c thiáº¿t láº­p',0),(579934,16110,'af','Prelim sjabloon stel nie',0),(579935,16110,'ro','Preliminare ÅŸablon nu Set',0),(579936,16110,'et','Aasta malli pole seatud',0),(579937,16110,'si','Predhodnega predloga ni nastavljena',0),(579938,16110,'ba','Prelim Template tidak diatur',0),(579939,16110,'nl','Kwalificatie sjabloon niet ingesteld',0),(579940,16110,'fi','Alustava malli ei mÃ¤Ã¤ritetty',0),(579941,16110,'no','Prelim malen ikke angitt',0),(579942,16110,'da','Prelim skabelon ikke indstillet',0),(579943,16110,'ko','ì˜ˆì„  í…œí”Œë¦¿ ì„¤ì • í•˜ì§€',0),(579944,16110,'he','×ª×‘× ×™×ª ×ž×•×§×“× ××™× ×• ×ž×•×’×“×¨',0),(579945,16110,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï€ÏÎ¿Ï„ÏÏ€Î¿Ï… Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(579946,16110,'zh','åˆè¯•æ¨¡æ¿æœªè®¾ç½®',0),(579947,16110,'sv','Prelim mall inte instÃ¤lld',0),(579948,16110,'it','Modello preliminare non impostato',0),(579949,16110,'tl','',0),(579950,16110,'th','Prelim à¹à¸šà¸šà¹„à¸¡à¹ˆà¸à¸³à¸«à¸™à¸”',0),(579951,16110,'hi','Prelim à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(579952,16110,'ms','Prelim Template tidak disetkan',0),(579953,16110,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù‚Ø§Ù„Ø¨ prelim',0),(579954,16110,'fr','Prelim modÃ¨le non dÃ©fini',0),(579955,16110,'jp','äºˆå‚™æ ¼ä»˜ã‘ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(579956,16110,'pt','Modelo de relatÃ³rio preliminar nÃ£o definido',0),(579957,16110,'ru','Prelim ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(579958,16110,'es','Plantilla de prelim no establecida',0),(579959,16110,'de','Vorrunde Vorlage wurde nicht festgelegt.',0),(579960,16110,'en','Prelim Template Not Set',0),(579961,16111,'is','',0),(579962,16111,'dr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Prelim Ú©Ø§Ø± Ú†Ø§Ù¾ Ø´Ø¯Ù‡',0),(579963,16111,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Prelim Ú©Ø§Ø± Ú†Ø§Ù¾ Ø´Ø¯Ù‡',0),(579964,16111,'tr','YazdÄ±rÄ±lan iÅŸ Prelim isteÄŸi',0),(579965,16111,'pl','Å»Ä…danie Prelim wydrukÃ³w',0),(579966,16111,'bg','ÐŸÐµÑ‡Ð°Ñ‚Ð½Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð·Ð°ÑÐ²ÐºÐ°',0),(579967,16111,'ur','Ù…Ø·Ø¨ÙˆØ¹Û Ú©Ø§Ù… Ù¾Ø±ÛŒÙ„Ø§Ù… Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(579968,16111,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° ÑƒÐ²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ð½Ð¸ Ð¿Ð¾ÑÐ°Ð¾',0),(579969,16111,'vi','CÃ¡c cÃ´ng viá»‡c in Prelim yÃªu cáº§u',0),(579970,16111,'af','Gedrukte werk Prelim versoek',0),(579971,16111,'ro','Cerere de preliminare imprimate Job',0),(579972,16111,'et','Prinditud tÃ¶Ã¶ aasta taotluse',0),(579973,16111,'si','Natisnjeno delo predhodnega zahtevo',0),(579974,16111,'ba','Cetak pekerjaan Prelim permintaan',0),(579975,16111,'nl','Afdruktaak afgedrukt kwalificatie verzoek',0),(579976,16111,'fi','Painettu alustava tarjouspyyntÃ¶',0),(579977,16111,'no','Utskrevet jobb Prelim forespÃ¸rsel',0),(579978,16111,'da','Trykte Job Prelim anmodning',0),(579979,16111,'ko','ì¸ì‡„ ìž‘ì—… ê²Œìž„ì¸ ìš”ì²­',0),(579980,16111,'he','×¢×‘×•×“×” ×ž×•×“×¤×¡ ×ž×•×§×“× ×‘×§×©×”',0),(579981,16111,'el','Î‘Î¯Ï„Î·Î¼Î± Ï€ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ Î­Î½Ï„Ï…Ï€Î± ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(579982,16111,'zh','æ‰“å°çš„ä½œä¸šåˆè¯•è¯·æ±‚',0),(579983,16111,'sv','Utskrivna jobb Prelim begÃ¤ran',0),(579984,16111,'it','Richiesta di lavoro stampato Prelim',0),(579985,16111,'tl','',0),(579986,16111,'th','à¸‚à¸­ Prelim à¸‡à¸²à¸™à¸žà¸´à¸¡à¸žà¹Œ',0),(579987,16111,'hi','à¤®à¥à¤¦à¥à¤°à¤¿à¤¤ à¤•à¤¾à¤® Prelim à¤…à¤¨à¥à¤°à¥‹à¤§',0),(579988,16111,'ms','Bercetak kerja Prelim permintaan',0),(579989,16111,'ar','Ø·Ù„Ø¨ Prelim Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„Ù…Ø·Ø¨ÙˆØ¹Ø©',0),(579990,16111,'fr','Demande de travail imprimÃ© Prelim',0),(579991,16111,'jp','å°åˆ·ã‚¸ãƒ§ãƒ–ã«äºˆå‚™ã®è¦æ±‚',0),(579992,16111,'pt','Trabalho impresso pedido de exame preliminar',0),(579993,16111,'ru','ÐŸÐµÑ‡Ð°Ñ‚Ð½Ð°Ñ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Prelim Ð·Ð°Ð¿Ñ€Ð¾Ñ',0),(579994,16111,'es','Impresos trabajo Prelim solicitud',0),(579995,16111,'de','Gedruckte Jobanforderung Bracelet',0),(579996,16111,'en','Printed Job Prelim Request',0),(579997,16112,'is','',0),(579998,16112,'dr','Ø«Ø¨Øª Ø¯Ø±ÛŒØ§ÙØª Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(579999,16112,'pr','Ø«Ø¨Øª Ø¯Ø±ÛŒØ§ÙØª Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(580000,16112,'tr','KayÄ±t bilgi alÄ±nmasÄ±ndan',0),(580001,16112,'pl','Rekordu otrzymania informacji',0),(580002,16112,'bg','Ð—Ð°Ð¿Ð¸Ñ Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(580003,16112,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©Ø§ Ø±ÛŒÚ©Ø§Ø±Úˆ Ø±Ø³ÛŒØ¯',0),(580004,16112,'sr','Ð—Ð°Ð¿Ð¸ÑÐ° Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð° Ð˜Ð½Ñ„Ð¾',0),(580005,16112,'vi','Ghi nháº­n thÃ´ng tin',0),(580006,16112,'af','Rekord ontvangs van inligting',0),(580007,16112,'ro','Record de primirii de informaÅ£ii',0),(580008,16112,'et','Rekord kÃ¤ttesaamise Info',0),(580009,16112,'si','Zapis prejemu informacij',0),(580010,16112,'ba','Mencatat penerimaan Info',0),(580011,16112,'nl','Record ontvangst van Info',0),(580012,16112,'fi','Tietueen vastaanottamisesta Info',0),(580013,16112,'no','Registrere mottak av Info',0),(580014,16112,'da','Registrere modtagelsen af Info',0),(580015,16112,'ko','ì •ë³´ ê¸°ë¡ í™•ì¸',0),(580016,16112,'he','×§×‘×œ×ª ×”×¨×©×•×ž×” ×¤×¨×˜×™',0),(580017,16112,'el','Î¡ÎµÎºÏŒÏ Ï€Î±ÏÎ±Î»Î±Î²Î®Ï‚ Ï„Ï‰Î½ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½',0),(580018,16112,'zh','è®°å½•æ”¶åˆ°çš„ä¿¡æ¯',0),(580019,16112,'sv','Registrera inleverans av Info',0),(580020,16112,'it','Record dal ricevimento delle informazioni',0),(580021,16112,'tl','',0),(580022,16112,'th','à¸£à¸±à¸šà¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(580023,16112,'hi','à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¤¾ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤°à¤¸à¥€à¤¦',0),(580024,16112,'ms','Rekod penerimaan maklumat',0),(580025,16112,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ø³ØªÙ„Ø§Ù… Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(580026,16112,'fr','Record rÃ©ception dâ€™Info',0),(580027,16112,'jp','æƒ…å ±ã®è¨˜éŒ²ã®å—é ˜',0),(580028,16112,'pt','Recibo de registro de informaÃ§Ã£o',0),(580029,16112,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸',0),(580030,16112,'es','Recibo de registro de informaciÃ³n',0),(580031,16112,'de','Rekord Erhalt der Info',0),(580032,16112,'en','Record Receipt Of Info',0),(580033,16113,'is','',0),(580034,16113,'dr','Ø§Ø³Ú©Ù†',0),(580035,16113,'pr','Ø§Ø³Ú©Ù†',0),(580036,16113,'tr','Ä°nceden inceye gÃ¶zden geÃ§irmek',0),(580037,16113,'pl','Skanowanie',0),(580038,16113,'bg','Ð¡ÐºÐ°Ð½Ð¸Ñ€Ð°Ð½Ðµ',0),(580039,16113,'ur','Ø³Ú©ÛŒÙ† Ú©Ø±ÛŒÚº',0),(580040,16113,'sr','Ð¡ÐºÐµÐ½Ð¸Ñ€Ð°ÑšÐµ',0),(580041,16113,'vi','QuÃ©t',0),(580042,16113,'af','Skandeer',0),(580043,16113,'ro','Scanare',0),(580044,16113,'et','Skannimine',0),(580045,16113,'si','Skeniranje',0),(580046,16113,'ba','Memindai',0),(580047,16113,'nl','Scan',0),(580048,16113,'fi','Skannaa',0),(580049,16113,'no','Skanning',0),(580050,16113,'da','Scan',0),(580051,16113,'ko','ìŠ¤ìº”',0),(580052,16113,'he','×¡×¨×•×§',0),(580053,16113,'el','Î£Î¬ÏÏ‰ÏƒÎ·',0),(580054,16113,'zh','æ‰«æ',0),(580055,16113,'sv','Skanna',0),(580056,16113,'it','Scansione',0),(580057,16113,'tl','',0),(580058,16113,'th','à¸à¸²à¸£à¸ªà¹à¸à¸™',0),(580059,16113,'hi','à¤¸à¥à¤•à¥ˆà¤¨',0),(580060,16113,'ms','Imbasan',0),(580061,16113,'ar','Ø§Ù„Ù…Ø³Ø­ Ø§Ù„Ø¶ÙˆØ¦ÙŠ',0),(580062,16113,'fr','Scan',0),(580063,16113,'jp','ã‚¹ã‚­ãƒ£ãƒ³',0),(580064,16113,'pt','DigitalizaÃ§Ã£o',0),(580065,16113,'ru','Ð¡ÐºÐ°Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ',0),(580066,16113,'es','ExploraciÃ³n',0),(580067,16113,'de','Scan',0),(580068,16113,'en','Scan',0),(580069,16114,'is','',0),(580070,16114,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Prelim',0),(580071,16114,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Prelim',0),(580072,16114,'tr','Ã–n duruÅŸma talep bilgisi gÃ¶nder',0),(580073,16114,'pl','WyÅ›lij zapytanie Prelim',0),(580074,16114,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð°ÑÐ²ÐºÐ°',0),(580075,16114,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(580076,16114,'sr','Ð¡Ð»Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° Ð˜Ð½Ñ„Ð¾ ÑƒÐ²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ',0),(580077,16114,'vi','Gá»­i yÃªu cáº§u thÃ´ng tin Prelim',0),(580078,16114,'af','Stuur Prelim inligting versoek',0),(580079,16114,'ro','Trimite solicitarea de informaÅ£ii preliminare',0),(580080,16114,'et','Aasta Info muud kaubad',0),(580081,16114,'si','PoÅ¡lji zahtevo predhodnega Info',0),(580082,16114,'ba','Mengirim Prelim Info permintaan',0),(580083,16114,'nl','Kwalificatie informatieaanvraag verzenden',0),(580084,16114,'fi','LÃ¤hetÃ¤ alustava Info pyyntÃ¶',0),(580085,16114,'no','Sende Prelim Info forespÃ¸rsel',0),(580086,16114,'da','Send Prelim Info anmodning',0),(580087,16114,'ko','ì˜ˆì„  ì •ë³´ ìš”ì²­ ë³´ë‚´ê¸°',0),(580088,16114,'he','×©×œ×— ×‘×§×©×ª ×ž×™×“×¢ ×ž×•×§×“×',0),(580089,16114,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Î±Î¯Ï„Î·Î¼Î± Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¹ÏŽÎ½ Ï€ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(580090,16114,'zh','å‘é€åˆè¯•ä¿¡æ¯è¯·æ±‚',0),(580091,16114,'sv','Skicka Prelim information begÃ¤ran',0),(580092,16114,'it','Invia richiesta Info Prelim',0),(580093,16114,'tl','',0),(580094,16114,'th','à¸ªà¹ˆà¸‡à¸à¸²à¸£à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸‚à¹‰à¸­à¸¡à¸¹à¸¥ Prelim',0),(580095,16114,'hi','Prelim à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤­à¥‡à¤œà¥‡à¤‚',0),(580096,16114,'ms','Menghantar permintaan maklumat Prelim',0),(580097,16114,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø·Ù„Ø¨ Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Prelim',0),(580098,16114,'fr','Envoyer demande Info Prelim',0),(580099,16114,'jp','äºˆå‚™æ ¼ä»˜ã‘æƒ…å ±è¦æ±‚ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(580100,16114,'pt','Enviar pedido de informaÃ§Ã£o preliminar',0),(580101,16114,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ Prelim',0),(580102,16114,'es','Enviar solicitud de Info Prelim',0),(580103,16114,'de','Bracelet-Info-Anfrage senden',0),(580104,16114,'en','Send Prelim Info Request',0),(580105,16115,'is','',0),(580106,16115,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨Ù‡ Zlien',0),(580107,16115,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨Ù‡ Zlien',0),(580108,16115,'tr','Zlien iÃ§in iletimi',0),(580109,16115,'pl','Przekazuje do Zlien',0),(580110,16115,'bg','ÐŸÑ€ÐµÐ´Ð°Ð²Ð°Ñ‚ Ð½Ð° Zlien',0),(580111,16115,'ur','Ø²Ù„ÛŒÙ† Ú©ÛŒ ØªØ±Ø³ÛŒÙ„',0),(580112,16115,'sr','Ð”Ð° Ð¿Ñ€ÐµÐ½ÐµÑÑƒ Ð½Ð° Ð—Ð»Ð¸ÐµÐ½',0),(580113,16115,'vi','Truyá»n Zlien',0),(580114,16115,'af','Oordra na Zlien',0),(580115,16115,'ro','Transmite Zlien',0),(580116,16115,'et','Edastada Zlien',0),(580117,16115,'si','PoÅ¡lje Zlien',0),(580118,16115,'ba','Mengirimkan untuk Zlien',0),(580119,16115,'nl','Doorgeven aan Zlien',0),(580120,16115,'fi','Toimitettava Zlien',0),(580121,16115,'no','OverfÃ¸re til Zlien',0),(580122,16115,'da','Sende Zlien',0),(580123,16115,'ko','Zlien ì „ì†¡',0),(580124,16115,'he','×œ×”×¢×‘×™×¨ Zlien',0),(580125,16115,'el','Î”Î¹Î±Î²Î¹Î²Î¬Î¶ÎµÎ¹ ÏƒÏ„Î¿ Zlien',0),(580126,16115,'zh','ä¼ é€åˆ° Zlien',0),(580127,16115,'sv','Ã–verfÃ¶ra till Zlien',0),(580128,16115,'it','Trasmettere a Zlien',0),(580129,16115,'tl','',0),(580130,16115,'th','à¸ªà¹ˆà¸‡à¹„à¸›à¸¢à¸±à¸‡ Zlien',0),(580131,16115,'hi','à¤¸à¤‚à¤šà¤¾à¤°à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ Zlien',0),(580132,16115,'ms','Hantarkan ke Zlien',0),(580133,16115,'ar','ÙŠØ­ÙŠÙ„ Ø¥Ù„Ù‰ Ø²Ù„ÙŠÙ†',0),(580134,16115,'fr','Transmettre Ã  Zlien',0),(580135,16115,'jp','Zlien ã«é€ä¿¡ã—ã¾ã™ã€‚',0),(580136,16115,'pt','Transmitir a Zlien',0),(580137,16115,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‚ÑŒ Zlien',0),(580138,16115,'es','Transmitir a Zlien',0),(580139,16115,'de','Zlien Ã¼bertragen',0),(580140,16115,'en','Transmit To Zlien',0),(580141,16116,'is','',0),(580142,16116,'dr','Ù†Ø²Ø¯ÛŒÚ© Ù…Ø§Ù‡',0),(580143,16116,'pr','Ù†Ø²Ø¯ÛŒÚ© Ù…Ø§Ù‡',0),(580144,16116,'tr','Ay kapatÄ±n',0),(580145,16116,'pl','Blisko miesiÄ…c',0),(580146,16116,'bg','Ð‘Ð»Ð¸Ð·Ð¾ Ð¼ÐµÑÐµÑ†',0),(580147,16116,'ur','Ù…Ø§Û Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº',0),(580148,16116,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸Ñ‚Ðµ Ð¼ÐµÑÐµÑ†Ð°',0),(580149,16116,'vi','ÄÃ³ng thÃ¡ng',0),(580150,16116,'af','Maand sluit',0),(580151,16116,'ro','Aproape de lunÄƒ',0),(580152,16116,'et','Sulgege kuu',0),(580153,16116,'si','Blizu mesec',0),(580154,16116,'ba','Dekat bulan',0),(580155,16116,'nl','Sluiten van de maand',0),(580156,16116,'fi','Sulje kuukauden',0),(580157,16116,'no','Lukke mÃ¥neden',0),(580158,16116,'da','Luk mÃ¥ned',0),(580159,16116,'ko','ë‹¬ ê°€ê¹Œì´',0),(580160,16116,'he','×œ×¡×’×•×¨ ××ª ×”×—×•×“×©',0),(580161,16116,'el','ÎšÎ»ÎµÎ¯ÏƒÏ„Îµ Ï„Î¿ Î¼Î®Î½Î±',0),(580162,16116,'zh','ä¸ªæœˆæˆªæ­¢',0),(580163,16116,'sv','StÃ¤ng mÃ¥nad',0),(580164,16116,'it','Chiudere il mese',0),(580165,16116,'tl','',0),(580166,16116,'th','à¸›à¸´à¸”à¹€à¸”à¸·à¸­à¸™',0),(580167,16116,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(580168,16116,'ms','Tutup bulan',0),(580169,16116,'ar','Ø¥ØºÙ„Ø§Ù‚ Ø§Ù„Ø´Ù‡Ø±',0),(580170,16116,'fr','Fermer le mois',0),(580171,16116,'jp','æœˆã‚’é–‰ã˜ã‚‹',0),(580172,16116,'pt','Fechar o mÃªs',0),(580173,16116,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ð¸Ðµ Ð¼ÐµÑÑÑ†Ð°',0),(580174,16116,'es','Cierre mes',0),(580175,16116,'de','Monat in der NÃ¤he',0),(580176,16116,'en','Close Month',0),(580177,16117,'is','',0),(580178,16117,'dr','Ù…Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª',0),(580179,16117,'pr','Ù…Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª',0),(580180,16117,'tr','Pozitif Ã¶deme',0),(580181,16117,'pl','PÅ‚atnoÅ›ci dodatnich',0),(580182,16117,'bg','ÐŸÐ¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(580183,16117,'ur','Ù…Ø«Ø¨Øª ØªÙ†Ø®ÙˆØ§Û',0),(580184,16117,'sr','ÐŸÐ¾Ð·Ð¸Ñ‚Ð¸Ð²Ð°Ð½ Ð¿Ð»Ð°Ñ‚Ðµ',0),(580185,16117,'vi','TÃ­ch cá»±c tráº£ tiá»n',0),(580186,16117,'af','Positiewe betaal',0),(580187,16117,'ro','Plata pozitiv',0),(580188,16117,'et','Positiivne tasu',0),(580189,16117,'si','Pozitivno plaÄilo',0),(580190,16117,'ba','Membayar positif',0),(580191,16117,'nl','Positieve beloning',0),(580192,16117,'fi','Positiivinen maksu',0),(580193,16117,'no','Positiv lÃ¸nn',0),(580194,16117,'da','Positive lÃ¸n',0),(580195,16117,'ko','ê¸ì •ì ì¸ ì§€ë¶ˆ',0),(580196,16117,'he','×©×œ× ×—×™×•×‘×™',0),(580197,16117,'el','Î˜ÎµÏ„Î¹ÎºÎ® Pay',0),(580198,16117,'zh','ç§¯æžçš„è–ªé…¬',0),(580199,16117,'sv','Betalningskontroll',0),(580200,16117,'it','Pay positivo',0),(580201,16117,'tl','',0),(580202,16117,'th','à¸šà¸§à¸à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(580203,16117,'hi','à¤¸à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(580204,16117,'ms','Gaji yang positif',0),(580205,16117,'ar','Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø¨ÙŠ',0),(580206,16117,'fr','RÃ©munÃ©ration positive',0),(580207,16117,'jp','è‚¯å®šçš„ãªæ”¯æ‰•',0),(580208,16117,'pt','Pagamento positivo',0),(580209,16117,'ru','ÐŸÐ¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(580210,16117,'es','Pago positivo',0),(580211,16117,'de','Positive Zahlen',0),(580212,16117,'en','Positive Pay',0),(580213,16118,'is','',0),(580214,16118,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØºÛŒØ± ÙØ¹Ø§Ù„',0),(580215,16118,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØºÛŒØ± ÙØ¹Ø§Ù„',0),(580216,16118,'tr','Zaten devre dÄ±ÅŸÄ±',0),(580217,16118,'pl','JuÅ¼ wyÅ‚Ä…czone',0),(580218,16118,'bg','Ð’ÐµÑ‡Ðµ Ð·Ð°Ð±Ñ€Ð°Ð½ÐµÐ½',0),(580219,16118,'ur','Ù¾ÛÙ„Û’ ÛÛŒ Ù†Ø§Ø§ÛÙ„',0),(580220,16118,'sr','Ð’ÐµÑ› Ñ˜Ðµ Ð¾Ð½ÐµÐ¼Ð¾Ð³ÑƒÑ›ÐµÐ½Ð°',0),(580221,16118,'vi','ÄÃ£ bá»‹ vÃ´ hiá»‡u hoÃ¡',0),(580222,16118,'af','Reeds gedeaktiveer',0),(580223,16118,'ro','Deja dezactivat',0),(580224,16118,'et','Juba keelatud',0),(580225,16118,'si','Å½e onemogoÄen',0),(580226,16118,'ba','Sudah dinonaktifkan',0),(580227,16118,'nl','Al uitgeschakeld',0),(580228,16118,'fi','Jo poistettu kÃ¤ytÃ¶stÃ¤',0),(580229,16118,'no','Allerede deaktivert',0),(580230,16118,'da','Allerede deaktiveret',0),(580231,16118,'ko','ì´ë¯¸ ë¹„í™œì„±í™”',0),(580232,16118,'he','×›×‘×¨ ×œ× ×–×ž×™×Ÿ',0),(580233,16118,'el','Î‰Î´Î· Î±Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î¿',0),(580234,16118,'zh','å·²ç¦ç”¨',0),(580235,16118,'sv','Redan inaktiverad',0),(580236,16118,'it','GiÃ  disabilitato',0),(580237,16118,'tl','',0),(580238,16118,'th','à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¹à¸¥à¹‰à¸§',0),(580239,16118,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤µà¤¿à¤•à¤²à¤¾à¤‚à¤—',0),(580240,16118,'ms','Sudah Kurang Upaya',0),(580241,16118,'ar','ØªØ¹Ø·ÙŠÙ„ Ù…Ø³Ø¨Ù‚Ø§Ù‹',0),(580242,16118,'fr','DÃ©jÃ  dÃ©sactivÃ©',0),(580243,16118,'jp','æ—¢ã«ç„¡åŠ¹ã«ãªã£ã¦',0),(580244,16118,'pt','JÃ¡ desativado',0),(580245,16118,'ru','Ð£Ð¶Ðµ Ð¾Ñ‚ÐºÐ»ÑŽÑ‡ÐµÐ½',0),(580246,16118,'es','Ya desactivado',0),(580247,16118,'de','Bereits deaktiviert',0),(580248,16118,'en','Already Disabled',0),(580249,16119,'is','',0),(580250,16119,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø±Ø§ ÙØ¹Ø§Ù„ Ú©Ù†ÛŒØ¯',0),(580251,16119,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø±Ø§ ÙØ¹Ø§Ù„ Ú©Ù†ÛŒØ¯',0),(580252,16119,'tr','Zaten etkin',0),(580253,16119,'pl','JuÅ¼ wÅ‚Ä…czone',0),(580254,16119,'bg','Ð’ÐµÑ‡Ðµ Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½',0),(580255,16119,'ur','Ù¾ÛÙ„Û’ ÛÛŒ ÙØ¹Ø§Ù„',0),(580256,16119,'sr','Ð’ÐµÑ› Ð¾Ð¼Ð¾Ð³ÑƒÑ›ÐµÐ½Ð¾',0),(580257,16119,'vi','ÄÃ£ kÃ­ch hoáº¡t',0),(580258,16119,'af','Reeds geaktiveer',0),(580259,16119,'ro','Deja activat',0),(580260,16119,'et','Juba lubatud',0),(580261,16119,'si','Å½e omogoÄena',0),(580262,16119,'ba','Sudah diaktifkan',0),(580263,16119,'nl','Al ingeschakeld',0),(580264,16119,'fi','Jo kÃ¤ytÃ¶ssÃ¤',0),(580265,16119,'no','Aktivert',0),(580266,16119,'da','Allerede aktiveret',0),(580267,16119,'ko','ì´ë¯¸ í™œì„±í™” ë˜ì–´',0),(580268,16119,'he','×›×‘×¨ ×–×ž×™×Ÿ',0),(580269,16119,'el','Î‰Î´Î· ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î·',0),(580270,16119,'zh','å·²å¯ç”¨',0),(580271,16119,'sv','Redan aktiverat',0),(580272,16119,'it','GiÃ  attivata',0),(580273,16119,'tl','',0),(580274,16119,'th','à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¹à¸¥à¹‰à¸§',0),(580275,16119,'hi','à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤¸à¤•à¥à¤·à¤® à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(580276,16119,'ms','Telah membolehkan',0),(580277,16119,'ar','Ù…Ù…ÙƒÙ† Ø¨Ø§Ù„ÙØ¹Ù„',0),(580278,16119,'fr','DÃ©jÃ  activÃ©',0),(580279,16119,'jp','æ—¢ã«æœ‰åŠ¹ã«ãªã£ã¦ã„ã¾ã™ã€‚',0),(580280,16119,'pt','JÃ¡ habilitado',0),(580281,16119,'ru','Ð£Ð¶Ðµ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½',0),(580282,16119,'es','Ya estÃ¡ habilitado',0),(580283,16119,'de','Bereits aktiviert',0),(580284,16119,'en','Already Enabled',0),(580285,16120,'is','',0),(580286,16120,'dr','Ú†Ú© Ú©Ø±Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ ØªØ¹ÛŒÛŒÙ† Ù†Ø´Ø¯Ù‡',0),(580287,16120,'pr','Ú†Ú© Ú©Ø±Ø¯Ù† Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¨Ø§Ù†Ú©ÛŒ ØªØ¹ÛŒÛŒÙ† Ù†Ø´Ø¯Ù‡',0),(580288,16120,'tr','Banka hesabÄ± numarasÄ±nÄ± kontrol ayarlÄ± deÄŸil',0),(580289,16120,'pl','Sprawdzenie numeru konta bankowego nie ustawiona',0),(580290,16120,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼',0),(580291,16120,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø§Ø±ÛŒ Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(580292,16120,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° Ð±Ñ€Ð¾Ñ˜Ð° Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(580293,16120,'vi','Kiá»ƒm tra tÃ i khoáº£n ngÃ¢n hÃ ng sá»‘ khÃ´ng thiáº¿t láº­p',0),(580294,16120,'af','Bank rekening nommer kontroleer stel nie',0),(580295,16120,'ro','NumÄƒrul de cont bancar de verificare stabilite',0),(580296,16120,'et','Pangakonto numbri kontrollimine seatud',0),(580297,16120,'si','Preverjanje Å¡tevilka banÄnega raÄuna ni nastavljena',0),(580298,16120,'ba','Memeriksa nomor rekening Bank tidak diatur',0),(580299,16120,'nl','Controle Bank rekeningnummer niet ingesteld',0),(580300,16120,'fi','Tarkkailun pankkitilinumero ei asennettu',0),(580301,16120,'no','Sjekke bankkontonummeret angitt ikke',0),(580302,16120,'da','Kontrollere bankkontonummer indstillet ikke',0),(580303,16120,'ko','ì„¤ì • ë˜ì§€ ì•Šì€ ì€í–‰ ê³„ì¢Œ ë²ˆí˜¸ í™•ì¸',0),(580304,16120,'he','×‘×“×™×§×ª ×ž×¡×¤×¨ ×—×©×‘×•×Ÿ ×‘× ×§ ××™× ×• ×ž×•×’×“×¨',0),(580305,16120,'el','ÎˆÎ»ÎµÎ³Ï‡Î¿Ï‚ Î±ÏÎ¹Î¸Î¼Î¿Ï Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(580306,16120,'zh','æ£€æŸ¥é“¶è¡Œå¸å·æœªè®¾ç½®',0),(580307,16120,'sv','Kontrollera bankkontonummer instÃ¤lld inte',0),(580308,16120,'it','Verificare il numero di conto bancario non impostato',0),(580309,16120,'tl','',0),(580310,16120,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²',0),(580311,16120,'hi','à¤œà¤¾à¤à¤š à¤•à¥‡ à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(580312,16120,'ms','Semakan nombor akaun Bank tidak disetkan',0),(580313,16120,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø±Ù‚Ù… Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†Ùƒ Ø¹Ø¯Ù… ØªØ¹ÙŠÙŠÙ†',0),(580314,16120,'fr','VÃ©rification de numÃ©ro de compte bancaire non dÃ©finie',0),(580315,16120,'jp','è¨­å®šã•ã‚Œã¦ã„ãªã„éŠ€è¡Œå£åº§ç•ªå·ã‚’ãƒã‚§ãƒƒã‚¯',0),(580316,16120,'pt','Verificar o nÃºmero da conta bancÃ¡ria nÃ£o definido',0),(580317,16120,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð½Ð¾Ð¼ÐµÑ€ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(580318,16120,'es','NÃºmero de cuenta bancaria no establece',0),(580319,16120,'de','PrÃ¼fen Kontonummer wurde nicht festgelegt',0),(580320,16120,'en','Checking Bank Account Number Not Set',0),(580321,16121,'is','',0),(580322,16121,'dr','ØºÛŒØ± ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(580323,16121,'pr','ØºÛŒØ± ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(580324,16121,'tr','Otomatik gÃ¶ndermeyi devre dÄ±ÅŸÄ± bÄ±rakmak',0),(580325,16121,'pl','WyÅ‚Ä…czyÄ‡ funkcjÄ™ automatycznego wysyÅ‚ania',0),(580326,16121,'bg','Ð—Ð°Ð±Ñ€Ð°Ð½Ð¸ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾Ñ‚Ð¾ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ',0),(580327,16121,'ur','Ø¨Ú¾ÛŒØ¬ Ø±ÛØ§ ÛÛ’ Ø®ÙˆØ¯ Ú©Ùˆ ØºÛŒØ± ÙØ¹Ø§Ù„',0),(580328,16121,'sr','ÐžÐ½ÐµÐ¼Ð¾Ð³ÑƒÑ›Ð¸ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ ÑÐ»Ð°ÑšÐµ',0),(580329,16121,'vi','VÃ´ hiá»‡u hoÃ¡ tá»± Ä‘á»™ng gá»­i',0),(580330,16121,'af','Deaktiveer outomatiese stuur',0),(580331,16121,'ro','DezactiveazÄƒ trimiterea automatÄƒ',0),(580332,16121,'et','Keela automaatne saatmine',0),(580333,16121,'si','OnemogoÄi samodejno poÅ¡iljanje',0),(580334,16121,'ba','Menonaktifkan Auto mengirim',0),(580335,16121,'nl','Uitschakelen automatisch verzenden',0),(580336,16121,'fi','TehdÃ¤ kykenemÃ¤ttÃ¶mÃ¤ksi automaattinen lÃ¤hettÃ¤minen',0),(580337,16121,'no','Deaktiver automatisk Sending',0),(580338,16121,'da','Deaktivere automatisk afsendelse',0),(580339,16121,'ko','ìžë™ ì „ì†¡ ì‚¬ìš© ì•ˆ í•¨',0),(580340,16121,'he','×‘×˜×œ ××•×˜×•×ž×˜×™ ×©×•×œ×—',0),(580341,16121,'el','Î‘Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(580342,16121,'zh','ç¦ç”¨è‡ªåŠ¨å‘é€',0),(580343,16121,'sv','Inaktivera automatisk skicka',0),(580344,16121,'it','Disabilitare l\'invio automatico',0),(580345,16121,'tl','',0),(580346,16121,'th','à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(580347,16121,'hi','à¤¸à¥à¤µà¤¤: à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¥‹ à¤…à¤•à¥à¤·à¤® à¤•à¤°à¥‡à¤‚',0),(580348,16121,'ms','Menyahdayakan penghantaran automatik',0),(580349,16121,'ar','ØªØ¹Ø·ÙŠÙ„ Ø¥Ø±Ø³Ø§Ù„ ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(580350,16121,'fr','DÃ©sactiver lâ€™envoi automatique',0),(580351,16121,'jp','è‡ªå‹•é€ä¿¡ã‚’ç„¡åŠ¹ã«ã—ã¾ã™ã€‚',0),(580352,16121,'pt','Desativar Auto envio',0),(580353,16121,'ru','ÐžÑ‚ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ð¹ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(580354,16121,'es','Desactivar Auto envÃ­o',0),(580355,16121,'de','Automatische senden deaktivieren',0),(580356,16121,'en','Disable Auto Sending',0),(580357,16122,'is','',0),(580358,16122,'dr','Ø§Ø±Ø³Ø§Ù„',0),(580359,16122,'pr','Ø§Ø±Ø³Ø§Ù„',0),(580360,16122,'tr','GÃ¶ndermeyin',0),(580361,16122,'pl','Nie wysyÅ‚aj',0),(580362,16122,'bg','ÐÐµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð¹Ñ‚Ðµ',0),(580363,16122,'ur','Ù…Øª Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(580364,16122,'sr','ÐÐµ ÑˆÐ°Ñ™Ð¸',0),(580365,16122,'vi','KhÃ´ng gá»­i',0),(580366,16122,'af','Moenie stuur nie',0),(580367,16122,'ro','Nu trimite',0),(580368,16122,'et','Ã„ra saada',0),(580369,16122,'si','Ne PoÅ¡lji',0),(580370,16122,'ba','Jangan mengirim',0),(580371,16122,'nl','Stuur geen',0),(580372,16122,'fi','Ã„lÃ¤ lÃ¤hetÃ¤',0),(580373,16122,'no','Ikke Send',0),(580374,16122,'da','Send ikke',0),(580375,16122,'ko','ë³´ë‚´ì§€ ë§ˆì‹­ì‹œì˜¤',0),(580376,16122,'he','××œ ×ª×©×œ×—',0),(580377,16122,'el','ÎœÎ·Î½ ÏƒÏ„Î­Î»Î½ÎµÏ„Îµ',0),(580378,16122,'zh','ä¸å‘é€',0),(580379,16122,'sv','Skicka inte',0),(580380,16122,'it','Non inviare',0),(580381,16122,'tl','',0),(580382,16122,'th','à¹„à¸¡à¹ˆà¸•à¹‰à¸­à¸‡à¸ªà¹ˆà¸‡',0),(580383,16122,'hi','à¤¨ à¤­à¥‡à¤œà¥‡à¤‚',0),(580384,16122,'ms','Jangan hantar',0),(580385,16122,'ar','Ù„Ø§ ØªÙ‚Ù… Ø¨Ø¥Ø±Ø³Ø§Ù„',0),(580386,16122,'fr','Ne pas envoyer',0),(580387,16122,'jp','é€ä¿¡ã—ãªã„ã§ãã ã•ã„ã€‚',0),(580388,16122,'pt','NÃ£o envie',0),(580389,16122,'ru','ÐÐµ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ',0),(580390,16122,'es','No envÃ­e',0),(580391,16122,'de','Senden Sie keine',0),(580392,16122,'en','Do Not Send',0),(580393,16123,'is','',0),(580394,16123,'dr','ÙØ¹Ø§Ù„',0),(580395,16123,'pr','ÙØ¹Ø§Ù„',0),(580396,16123,'tr','Etkin',0),(580397,16123,'pl','WÅ‚Ä…czone',0),(580398,16123,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¾',0),(580399,16123,'ur','Ø§ÛÙ„',0),(580400,16123,'sr','ÐžÐ¼Ð¾Ð³ÑƒÑ›ÐµÐ½Ð¾',0),(580401,16123,'vi','KÃ­ch hoáº¡t',0),(580402,16123,'af','Geaktiveer',0),(580403,16123,'ro','Activat',0),(580404,16123,'et','Lubatud',0),(580405,16123,'si','OmogoÄeno',0),(580406,16123,'ba','Diaktifkan',0),(580407,16123,'nl','Ingeschakeld',0),(580408,16123,'fi','KÃ¤ytÃ¶ssÃ¤',0),(580409,16123,'no','Aktivert',0),(580410,16123,'da','Aktiveret',0),(580411,16123,'ko','ì‚¬ìš© ê°€ëŠ¥',0),(580412,16123,'he','×ž×•×¤×¢×œ',0),(580413,16123,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î·',0),(580414,16123,'zh','å¯ç”¨',0),(580415,16123,'sv','Aktiverat',0),(580416,16123,'it','Abilitato',0),(580417,16123,'tl','',0),(580418,16123,'th','à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(580419,16123,'hi','à¤¸à¤•à¥à¤·à¤® à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(580420,16123,'ms','Membolehkan',0),(580421,16123,'ar','ØªÙ…ÙƒÙŠÙ†',0),(580422,16123,'fr','ActivÃ©',0),(580423,16123,'jp','æœ‰åŠ¹ã«ãªã£ã¦ã„ã¾ã™ã€‚',0),(580424,16123,'pt','Habilitado',0),(580425,16123,'ru','Ð’ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¾',0),(580426,16123,'es','Habilitado',0),(580427,16123,'de','Aktiviert',0),(580428,16123,'en','Enabled',0),(580429,16124,'is','',0),(580430,16124,'dr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(580431,16124,'pr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(580432,16124,'tr','Otomatik gÃ¶nderilmesine izin',0),(580433,16124,'pl','WÅ‚Ä…czyÄ‡ automatyczne wysyÅ‚anie',0),(580434,16124,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ',0),(580435,16124,'ur','Ø¨Ú¾ÛŒØ¬ Ø±ÛØ§ ÛÛ’ Ø®ÙˆØ¯ Ø§ÛÙ„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(580436,16124,'sr','ÐžÐ¼Ð¾Ð³ÑƒÑ›Ð¸ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ ÑÐ»Ð°ÑšÐµ',0),(580437,16124,'vi','Sá»­ tá»± Ä‘á»™ng gá»­i',0),(580438,16124,'af','Ontsper outomatiese stuur',0),(580439,16124,'ro','Permite trimiterea de Auto',0),(580440,16124,'et','Lubade kasutada, programmi automaatne saatmine',0),(580441,16124,'si','OmogoÄi samodejno poÅ¡iljanje',0),(580442,16124,'ba','Mengaktifkan Auto mengirim',0),(580443,16124,'nl','Inschakelen automatisch verzenden',0),(580444,16124,'fi','Ota automaattinen lÃ¤hettÃ¤minen',0),(580445,16124,'no','Aktiver automatisk sende',0),(580446,16124,'da','Aktivere automatisk afsendelse',0),(580447,16124,'ko','ìžë™ ì „ì†¡ ì‚¬ìš©',0),(580448,16124,'he','×œ××¤×©×¨ ×©×œ×™×—×ª ××•×˜×•×ž×˜×™',0),(580449,16124,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î·Î½ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®',0),(580450,16124,'zh','å¯ç”¨è‡ªåŠ¨å‘é€',0),(580451,16124,'sv','Aktivera automatisk skicka',0),(580452,16124,'it','Attivare l\'invio automatico',0),(580453,16124,'tl','',0),(580454,16124,'th','à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(580455,16124,'hi','à¤¸à¥à¤µà¤¤: à¤­à¥‡à¤œà¤¨à¥‡ à¤•à¥‹ à¤¸à¤•à¥à¤·à¤® à¤•à¤°à¥‡à¤‚',0),(580456,16124,'ms','Membolehkan penghantaran automatik',0),(580457,16124,'ar','ØªÙ…ÙƒÙŠÙ† Ø¥Ø±Ø³Ø§Ù„ ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(580458,16124,'fr','Activer lâ€™envoi automatique',0),(580459,16124,'jp','è‡ªå‹•é€ä¿¡ã‚’æœ‰åŠ¹ã«ã—ã¾ã™ã€‚',0),(580460,16124,'pt','Habilitar o envio de Auto',0),(580461,16124,'ru','Ð’ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ð¹ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(580462,16124,'es','Activar Auto envÃ­o',0),(580463,16124,'de','Aktivieren Sie automatische senden',0),(580464,16124,'en','Enable Auto Sending',0),(580465,16125,'is','',0),(580466,16125,'dr','Ø§Ø±Ø³Ø§Ù„ Ø®Ø·Ø§',0),(580467,16125,'pr','Ø§Ø±Ø³Ø§Ù„ Ø®Ø·Ø§',0),(580468,16125,'tr','Hata gÃ¶nderme',0),(580469,16125,'pl','BÅ‚Ä…d wysyÅ‚ania',0),(580470,16125,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ',0),(580471,16125,'ur','Ù†Ù‚Øµ Ø¨Ú¾ÛŒØ¬ Ø±ÛØ§ ÛÛ’ Û”',0),(580472,16125,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ»Ð°ÑšÐ°',0),(580473,16125,'vi','Lá»—i gá»­i',0),(580474,16125,'af','Fout stuur',0),(580475,16125,'ro','Eroare trimitere',0),(580476,16125,'et','Viga saatmisel',0),(580477,16125,'si','Napaka pri poÅ¡iljanju',0),(580478,16125,'ba','Kesalahan pengiriman',0),(580479,16125,'nl','Fout verzenden',0),(580480,16125,'fi','Virhe lÃ¤hettÃ¤Ã¤',0),(580481,16125,'no','Feil sender',0),(580482,16125,'da','Fejl indsendelse',0),(580483,16125,'ko','ì˜¤ë¥˜ ë³´ë‚´ê¸°',0),(580484,16125,'he','×©×’×™××” ×œ×©×œ×•×—',0),(580485,16125,'el','Î£Ï†Î¬Î»Î¼Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(580486,16125,'zh','å‘é€é”™è¯¯',0),(580487,16125,'sv','Fel skicka',0),(580488,16125,'it','Errore invio',0),(580489,16125,'tl','',0),(580490,16125,'th','à¸ªà¹ˆà¸‡à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(580491,16125,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤­à¥‡à¤œà¥€ à¤œà¤¾ à¤°à¤¹à¥€à¤‚',0),(580492,16125,'ms','Ralat menghantar',0),(580493,16125,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø®Ø·Ø£',0),(580494,16125,'fr','Erreur envoi',0),(580495,16125,'jp','é€ä¿¡ã‚¨ãƒ©ãƒ¼',0),(580496,16125,'pt','Erro de envio',0),(580497,16125,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸',0),(580498,16125,'es','Error envÃ­o',0),(580499,16125,'de','Fehler senden',0),(580500,16125,'en','Error Sending',0),(580501,16126,'is','',0),(580502,16126,'dr','Ù…ÛŒØ²Ø¨Ø§Ù† Ø¨Ù‡ ØªÙ†Ø¸ÛŒÙ… Ù†Ø´Ø¯Ù‡',0),(580503,16126,'pr','Ù…ÛŒØ²Ø¨Ø§Ù† Ø¨Ù‡ ØªÙ†Ø¸ÛŒÙ… Ù†Ø´Ø¯Ù‡',0),(580504,16126,'tr','Ev sahibi ayarlanmadÄ±',0),(580505,16126,'pl','Nie ustawiÄ‡ Host',0),(580506,16126,'bg','Ð”Ð¾Ð¼Ð°ÐºÐ¸Ð½ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼',0),(580507,16126,'ur','Ù…ÛŒØ²Ø¨Ø§Ù† Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(580508,16126,'sr','Ð”Ð¾Ð¼Ð°Ñ›Ð¸Ð½ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(580509,16126,'vi','MÃ¡y chá»§ khÃ´ng Ä‘Æ°á»£c thiáº¿t láº­p',0),(580510,16126,'af','Gasheer stel nie',0),(580511,16126,'ro','GazdÄƒ nu Set',0),(580512,16126,'et','VastuvÃµttev ei saa mÃ¤Ã¤rata',0),(580513,16126,'si','Gostitelja ni nastavljena',0),(580514,16126,'ba','Host tidak diatur',0),(580515,16126,'nl','Host niet ingesteld',0),(580516,16126,'fi','IsÃ¤ntÃ¤ ei ole mÃ¤Ã¤ritetty',0),(580517,16126,'no','Vert ikke angitt',0),(580518,16126,'da','VÃ¦rten ikke indstillet',0),(580519,16126,'ko','í˜¸ìŠ¤íŠ¸ ì„¤ì • í•˜ì§€',0),(580520,16126,'he','×”×ž××¨×— ××™× ×• ×ž×•×’×“×¨',0),(580521,16126,'el','ÎšÎµÎ½Ï„ÏÎ¹ÎºÎ¿Ï Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÏ„Î® Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(580522,16126,'zh','ä¸»æœºæœªè®¾ç½®',0),(580523,16126,'sv','VÃ¤rden inte instÃ¤lld',0),(580524,16126,'it','Host non impostato',0),(580525,16126,'tl','',0),(580526,16126,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹‚à¸®à¸ªà¸•à¹Œ',0),(580527,16126,'hi','à¤¹à¥‹à¤¸à¥à¤Ÿ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(580528,16126,'ms','Tuan rumah tidak disetkan',0),(580529,16126,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…Ø¶ÙŠÙ',0),(580530,16126,'fr','HÃ´te non dÃ©fini',0),(580531,16126,'jp','ãƒ›ã‚¹ãƒˆãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(580532,16126,'pt','Host nÃ£o definido',0),(580533,16126,'ru','Ð£Ð·ÐµÐ» Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(580534,16126,'es','Host no establece',0),(580535,16126,'de','Host wurde nicht festgelegt.',0),(580536,16126,'en','Host Not Set',0),(580537,16127,'is','',0),(580538,16127,'dr','Ú†ÛŒØ²ÛŒ Ø¨Ø±Ø§ÛŒ Ø§Ø±Ø³Ø§Ù„',0),(580539,16127,'pr','Ú†ÛŒØ²ÛŒ Ø¨Ø±Ø§ÛŒ Ø§Ø±Ø³Ø§Ù„',0),(580540,16127,'tr','GÃ¶ndermek iÃ§in hiÃ§bir ÅŸey',0),(580541,16127,'pl','Nic do wysyÅ‚ania',0),(580542,16127,'bg','ÐÑÐ¼Ð° Ð½Ð¸Ñ‰Ð¾ Ð·Ð° Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ',0),(580543,16127,'ur','Ø¨Ú¾ÛŒØ¬Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú©Ú†Ú¾ Ø¨Ú¾ÛŒ Ù†ÛÛŒÚº',0),(580544,16127,'sr','ÐÐ¸ÑˆÑ‚Ð° Ð·Ð° ÑÐ»Ð°ÑšÐµ',0),(580545,16127,'vi','KhÃ´ng cÃ³ gÃ¬ Ä‘á»ƒ gá»­i',0),(580546,16127,'af','Niks om te stuur',0),(580547,16127,'ro','Nimic de-a trimite',0),(580548,16127,'et','Midagi saada',0),(580549,16127,'si','NiÄ poÅ¡iljati',0),(580550,16127,'ba','Apa-apa untuk mengirim',0),(580551,16127,'nl','Niets te verzenden',0),(580552,16127,'fi','MitÃ¤Ã¤n lÃ¤hettÃ¤Ã¤',0),(580553,16127,'no','Ingenting Ã¥ sende',0),(580554,16127,'da','Intet at sende',0),(580555,16127,'ko','ì•„ë¬´ê²ƒë„ ì†¡ì‹ ',0),(580556,16127,'he','×“×‘×¨ ×©×œ×—',0),(580557,16127,'el','Î”ÎµÎ½ Î­Ï‡ÎµÎ¹ Ï„Î¯Ï€Î¿Ï„Î± Î½Î± ÏƒÏ„ÎµÎ¯Î»ÎµÎ¹',0),(580558,16127,'zh','å‘é€æ— å…³',0),(580559,16127,'sv','Inget att skicka',0),(580560,16127,'it','Niente da inviare',0),(580561,16127,'tl','',0),(580562,16127,'th','à¸­à¸°à¹„à¸£à¸—à¸µà¹ˆà¸ˆà¸°à¸ªà¹ˆà¸‡',0),(580563,16127,'hi','à¤­à¥‡à¤œà¥‡à¤‚ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤› à¤­à¥€ à¤¨à¤¹à¥€à¤‚',0),(580564,16127,'ms','Apa-apa untuk hantar',0),(580565,16127,'ar','Ù„Ø§ Ø´ÙŠØ¡ Ù„Ø¥Ø±Ø³Ø§Ù„',0),(580566,16127,'fr','Rien Ã  envoyer',0),(580567,16127,'jp','ä½•ã‚‚é€ä¿¡ã™ã‚‹',0),(580568,16127,'pt','Nada para enviar',0),(580569,16127,'ru','ÐÐ¸Ñ‡ÐµÐ³Ð¾ Ð½Ðµ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ',0),(580570,16127,'es','Nada que enviar',0),(580571,16127,'de','Nichts zu senden',0),(580572,16127,'en','Nothing To Send',0),(580573,16128,'is','',0),(580574,16128,'dr','ØªÙ†Ø¸ÛŒÙ… Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ±',0),(580575,16128,'pr','ØªÙ†Ø¸ÛŒÙ… Ú©Ù„Ù…Ù‡ Ø¹Ø¨ÙˆØ±',0),(580576,16128,'tr','DeÄŸil ÅŸifre koymak',0),(580577,16128,'pl','Nie ustawiÄ‡ hasÅ‚o',0),(580578,16128,'bg','ÐÐµ Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(580579,16128,'ur','Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(580580,16128,'sr','Ð›Ð¾Ð·Ð¸Ð½ÐºÐ° Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°.',0),(580581,16128,'vi','Máº­t kháº©u khÃ´ng Ä‘Æ°á»£c thiáº¿t láº­p',0),(580582,16128,'af','Wagwoord stel nie',0),(580583,16128,'ro','Parola nu setaÅ£i',0),(580584,16128,'et','Parooli pole seatud',0),(580585,16128,'si','Geslo ni nastavljeno',0),(580586,16128,'ba','Sandi tidak diatur',0),(580587,16128,'nl','Wachtwoord niet ingesteld',0),(580588,16128,'fi','Salasanaa ei asetettu',0),(580589,16128,'no','Passord ikke angitt',0),(580590,16128,'da','Adgangskode ikke er angivet',0),(580591,16128,'ko','ì•”í˜¸ë¥¼ ì„¤ì • í•˜ì§€',0),(580592,16128,'he','×”×¡×™×¡×ž×” ××™× ×” ×ž×•×’×“×¨×ª',0),(580593,16128,'el','Î”ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(580594,16128,'zh','ä¸è®¾ç½®å¯†ç ',0),(580595,16128,'sv','LÃ¶senord inte har angetts',0),(580596,16128,'it','Password non impostata',0),(580597,16128,'tl','',0),(580598,16128,'th','à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸•à¸±à¹‰à¸‡à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™',0),(580599,16128,'hi','à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(580600,16128,'ms','Kata laluan tidak disetkan',0),(580601,16128,'ar','Ø¹Ø¯Ù… ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ±',0),(580602,16128,'fr','Mot de passe non dÃ©fini',0),(580603,16128,'jp','ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(580604,16128,'pt','Senha nÃ£o definido',0),(580605,16128,'ru','ÐŸÐ°Ñ€Ð¾Ð»ÑŒ Ð½Ðµ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(580606,16128,'es','ContraseÃ±a no establece',0),(580607,16128,'de','Kennwort wurde nicht festgelegt.',0),(580608,16128,'en','Password Not Set',0),(580609,16129,'is','',0),(580610,16129,'dr','Ù…Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ú†Ú©',0),(580611,16129,'pr','Ù…Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ú†Ú©',0),(580612,16129,'tr','Pozitif Ã¶deme Ã§ek',0),(580613,16129,'pl','Kontrole pozytywne Pay',0),(580614,16129,'bg','ÐŸÐ¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(580615,16129,'ur','Ù…Ø«Ø¨Øª ØªÙ†Ø®ÙˆØ§Û Ú†ÛŒÚ©',0),(580616,16129,'sr','ÐŸÐ¾Ð·Ð¸Ñ‚Ð¸Ð²Ð°Ð½ Ð¿Ð»Ð°Ñ‚Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(580617,16129,'vi','TÃ­ch cá»±c tráº£ tiá»n kiá»ƒm tra',0),(580618,16129,'af','Positiewe betaal ondersoeke',0),(580619,16129,'ro','Controalele pozitive plata',0),(580620,16129,'et','Positiivne maksma kontrolli',0),(580621,16129,'si','Pozitivno plaÄati pregledi',0),(580622,16129,'ba','Positif membayar cek',0),(580623,16129,'nl','Positieve beloning controles',0),(580624,16129,'fi','Positiivinen maksu tarkastukset',0),(580625,16129,'no','Positiv betale regningene',0),(580626,16129,'da','Positive lÃ¸n Checks',0),(580627,16129,'ko','ê¸ì •ì ì¸ ì§€ë¶ˆ í™•ì¸',0),(580628,16129,'he','×‘×“×™×§×•×ª ×©×œ× ×—×™×•×‘×™',0),(580629,16129,'el','Î•Î»Î­Î³Ï‡Ï‰Î½ Ï„Ï‰Î½ Î¸ÎµÏ„Î¹ÎºÏŽÎ½ Î±Î¼Î¿Î¹Î²ÏŽÎ½',0),(580630,16129,'zh','ç§¯æžå·¥èµ„æ”¯ç¥¨',0),(580631,16129,'sv','Betalningskontroll kontroller',0),(580632,16129,'it','Controlli positivi di paga',0),(580633,16129,'tl','',0),(580634,16129,'th','à¸šà¸§à¸à¸ˆà¹ˆà¸²à¸¢à¹€à¸Šà¹‡à¸„',0),(580635,16129,'hi','à¤¸à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(580636,16129,'ms','Semakan gaji yang positif',0),(580637,16129,'ar','Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø¨ÙŠ',0),(580638,16129,'fr','ChÃ¨ques de paye positif',0),(580639,16129,'jp','è‚¯å®šçš„ãªæ”¯æ‰•ã„ã‚’ç¢ºèª',0),(580640,16129,'pt','Cheques de pagamento positiva',0),(580641,16129,'ru','ÐŸÐ¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ñ‡ÐµÐºÐ¾Ð²',0),(580642,16129,'es','Cheques de pago positivo',0),(580643,16129,'de','Positiven Schecks',0),(580644,16129,'en','Positive Pay Checks',0),(580645,16130,'is','',0),(580646,16130,'dr','Ù…Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø¹Ù„ÙˆÙ„ÛŒÙ†',0),(580647,16130,'pr','Ù…Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø¹Ù„ÙˆÙ„ÛŒÙ†',0),(580648,16130,'tr','Pozitif Ã¶deme devre dÄ±ÅŸÄ±',0),(580649,16130,'pl','Pozytywne wynagrodzenia osÃ³b niepeÅ‚nosprawnych',0),(580650,16130,'bg','ÐŸÐ¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¸Ð½Ð²Ð°Ð»Ð¸Ð´Ð¸',0),(580651,16130,'ur','Ù…Ø«Ø¨Øª ØªÙ†Ø®ÙˆØ§Û Ù…Ø¹Ø°ÙˆØ±',0),(580652,16130,'sr','ÐŸÐ¾Ð·Ð¸Ñ‚Ð¸Ð²Ð°Ð½ Ð¿Ð»Ð°Ñ‚Ð° Ñ˜Ðµ Ð¾Ð½ÐµÐ¼Ð¾Ð³ÑƒÑ›ÐµÐ½',0),(580653,16130,'vi','TÃ­ch cá»±c tráº£ tiá»n Ä‘Ã¬nh',0),(580654,16130,'af','Positiewe betaal gedeaktiveer',0),(580655,16130,'ro','Plata pozitiv cu handicap',0),(580656,16130,'et','Positiivne maksma puudega',0),(580657,16130,'si','Pozitivno plaÄa nesposoben',0),(580658,16130,'ba','Positif membayar Cacat',0),(580659,16130,'nl','Positieve beloning gehandicapten',0),(580660,16130,'fi','Positiivinen maksu vammaisten',0),(580661,16130,'no','Positiv betale deaktivert',0),(580662,16130,'da','Positive lÃ¸n handicappede',0),(580663,16130,'ko','ê¸ì •ì ì¸ ì§€ë¶ˆ ì‚¬ìš© ì•ˆ í•¨',0),(580664,16130,'he','×©×œ× ×—×™×•×‘×™ × ×›×™×',0),(580665,16130,'el','Î˜ÎµÏ„Î¹ÎºÎ® Î±Î¼Î¿Î¹Î²Î® Î±Ï„ÏŒÎ¼Ï‰Î½ Î¼Îµ ÎµÎ¹Î´Î¹ÎºÎ­Ï‚ Î±Î½Î¬Î³ÎºÎµÏ‚',0),(580666,16130,'zh','ç§¯æžæ”¯ä»˜æ®‹ç–¾äººå£«',0),(580667,16130,'sv','Betalningskontroll funktionshindrade',0),(580668,16130,'it','Positivo Pay per disabili',0),(580669,16130,'tl','',0),(580670,16130,'th','à¸›à¸´à¸”à¸šà¸§à¸à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(580671,16130,'hi','à¤¸à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤…à¤•à¥à¤·à¤®',0),(580672,16130,'ms','Kurang Upaya membayar positif',0),(580673,16130,'ar','ØªØ¹Ø·ÙŠÙ„ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø¨ÙŠ',0),(580674,16130,'fr','Personnes handicapÃ©es rÃ©munÃ©ration positive',0),(580675,16130,'jp','è‚¯å®šçš„ãªæ”¯æ‰•ã„ç„¡åŠ¹',0),(580676,16130,'pt','Positivo de pagamento desativado',0),(580677,16130,'ru','ÐŸÐ¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¸Ð½Ð²Ð°Ð»Ð¸Ð´Ð¾Ð²',0),(580678,16130,'es','Discapacitados de pago positivo',0),(580679,16130,'de','Positive Zahlen Behinderte',0),(580680,16130,'en','Positive Pay Disabled',0),(580681,16131,'is','',0),(580682,16131,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ù…Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ú†Ú©',0),(580683,16131,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ù…Ø«Ø¨Øª Ù¾Ø±Ø¯Ø§Ø®Øª Ú†Ú©',0),(580684,16131,'tr','Ä°nceleme olumlu Ã¶deme Ã§ek',0),(580685,16131,'pl','PrzeglÄ…d kontroli pÅ‚atnoÅ›ci dodatnich',0),(580686,16131,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð¿Ð¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(580687,16131,'ur','Ù…Ø«Ø¨Øª ØªÙ†Ø®ÙˆØ§Û Ú†ÛŒÚ© Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(580688,16131,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð¿Ð¾Ð·Ð¸Ñ‚Ð¸Ð²Ð°Ð½ Ð¿Ð»Ð°Ñ‚Ðµ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(580689,16131,'vi','Xem xÃ©t tráº£ tiá»n tÃ­ch cá»±c kiá»ƒm tra',0),(580690,16131,'af','Hersien positiewe betaal ondersoeke',0),(580691,16131,'ro','Controale de plata pozitiv Review',0),(580692,16131,'et','Keskmiseks positiivne maksma kontrolli',0),(580693,16131,'si','Pregled pregledov pozitiven plaÄilo',0),(580694,16131,'ba','Review positif membayar cek',0),(580695,16131,'nl','Beoordeling positieve beloning controles',0),(580696,16131,'fi','Arvostelu positiivinen maksu tarkastukset',0),(580697,16131,'no','Gjennomgang positiv betale regningene',0),(580698,16131,'da','Anmeld Positive lÃ¸n Checks',0),(580699,16131,'ko','ê¸ì •ì ì¸ ì§€ë¶ˆ í™•ì¸ ê²€í† ',0),(580700,16131,'he','×‘×“×™×§×•×ª ×—×™×•×‘×™ ×©×›×¨ ×¡×§×™×¨×”',0),(580701,16131,'el','Î•Î»Î­Î³Ï‡Ï‰Î½ Ï„Ï‰Î½ Î±Î¼Î¿Î¹Î²ÏŽÎ½ Î¸ÎµÏ„Î¹ÎºÏŽÎ½ ÏƒÏ‡Î¿Î»Î¯Ï‰Î½',0),(580702,16131,'zh','å®¡æŸ¥ç§¯æžå·¥èµ„æ”¯ç¥¨',0),(580703,16131,'sv','Granska Betalningskontroll kontroller',0),(580704,16131,'it','Controlli di paga positiva recensione.',0),(580705,16131,'tl','',0),(580706,16131,'th','à¹€à¸Šà¹‡à¸„à¸ˆà¹ˆà¸²à¸¢à¸šà¸§à¸à¸£à¸µà¸§à¸´à¸§',0),(580707,16131,'hi','à¤¸à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(580708,16131,'ms','Mengkaji semula semakan gaji yang positif',0),(580709,16131,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶ Ø´ÙŠÙƒØ§Øª Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø¨ÙŠ',0),(580710,16131,'fr','Examiner les contrÃ´les positifs paye',0),(580711,16131,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼ã®è‚¯å®šçš„ãªæ”¯æ‰•ã„ã‚’ç¢ºèª',0),(580712,16131,'pt','AvaliaÃ§Ã£o positiva de pagar cheques',0),(580713,16131,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð¿Ð¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ñ‡ÐµÐºÐ¾Ð²',0),(580714,16131,'es','RevisiÃ³n de cheques de pago positivo',0),(580715,16131,'de','ÃœberprÃ¼fen Sie Positive Schecks',0),(580716,16131,'en','Review Positive Pay Checks',0),(580717,16132,'is','',0),(580718,16132,'dr','Ø§Ø±Ø³Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ù…Ø«Ø¨Øª Ø¨Ù‡ Ù‡Ù…Ù‡',0),(580719,16132,'pr','Ø§Ø±Ø³Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ù…Ø«Ø¨Øª Ø¨Ù‡ Ù‡Ù…Ù‡',0),(580720,16132,'tr','TÃ¼m iÃ§in olumlu Ã¶deme gÃ¶ndermek',0),(580721,16132,'pl','WyÅ›lij wszystkie pÅ‚atnoÅ›ci do dodatnich',0),(580722,16132,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÐºÑŠÐ¼ Ð¿Ð¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð¿Ð»Ð°Ñ‚Ð¸',0),(580723,16132,'ur','Ø³Ø¨ Ú©Û’ Ù„Ø¦Û’ Ù…Ø«Ø¨Øª ØªÙ†Ø®ÙˆØ§Û Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(580724,16132,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ ÑÐ²Ðµ Ð´Ð¾ Ð¿Ð¾Ð·Ð¸Ñ‚Ð¸Ð²Ð½Ð¸Ñ… Ð¿Ð»Ð°Ñ‚Ðµ',0),(580725,16132,'vi','Gá»­i táº¥t cáº£ pháº£i tráº£ tiá»n Ä‘á»ƒ tÃ­ch cá»±c',0),(580726,16132,'af','Stuur alle tot positiewe betaal',0),(580727,16132,'ro','Trimite toate pozitive la plata',0),(580728,16132,'et','Saada kÃµik â€“ positiivne maksta',0),(580729,16132,'si','PoÅ¡lji vse do pozitivnih plaÄilo',0),(580730,16132,'ba','Kirim semua membayar untuk positif',0),(580731,16132,'nl','Stuur alle tot positieve beloning',0),(580732,16132,'fi','LÃ¤hetÃ¤ kaikki positiivisen Pay',0),(580733,16132,'no','Sende alle til positiv betale',0),(580734,16132,'da','Send alle til positiv lÃ¸n',0),(580735,16132,'ko','ëª¨ë“  ê²Œ ê¸ì •ì ì¸ ì§€ë¶ˆì„ ë³´ë‚´ê¸°',0),(580736,16132,'he','×©×œ×— ×›×•×œ× ×• × ×©×œ× ×¢×“ ×—×™×•×‘×™×ª',0),(580737,16132,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Ï€Î»Î·ÏÏŽÏƒÎ¿Ï…Î¼Îµ ÏŒÎ»Î¿Î¹ Î³Î¹Î± Ï„Î·Î½ Î¸ÎµÏ„Î¹ÎºÎ®',0),(580738,16132,'zh','å‘é€æ‰€æœ‰åˆ°æ­£é¢æ”¯ä»˜',0),(580739,16132,'sv','Skicka alla till Betalningskontroll',0),(580740,16132,'it','Invia tutta la paga al positivo',0),(580741,16132,'tl','',0),(580742,16132,'th','à¸ªà¹ˆà¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸šà¸§à¸à¸à¸±à¸šà¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(580743,16132,'hi','à¤¸à¤­à¥€ à¤¸à¥‡ à¤¸à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤­à¥‡à¤œà¥‡à¤‚',0),(580744,16132,'ms','Menghantar semua gaji ke positif',0),(580745,16132,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø¨ÙŠ Ø¬Ù…ÙŠØ¹',0),(580746,16132,'fr','Envoyer la rÃ©munÃ©ration Positive Ã  tous les',0),(580747,16132,'jp','ã™ã¹ã¦ã«è‚¯å®šçš„ãªæ”¯æ‰•ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(580748,16132,'pt','Enviar todos os Pay para positivo',0),(580749,16132,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð½Ð° Ð¿Ð¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(580750,16132,'es','Enviar pago a positivo todos',0),(580751,16132,'de','Senden Sie alle zu positiven Zahlen',0),(580752,16132,'en','Send All To Positive Pay',0),(580753,16133,'is','',0),(580754,16133,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø± Ú†Ú©',0),(580755,16133,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¯Ø± Ø§Ù†ØªØ¸Ø§Ø± Ú†Ú©',0),(580756,16133,'tr','Ã‡ek gÃ¶nder',0),(580757,16133,'pl','WyÅ›lij do czasu kontroli',0),(580758,16133,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð´Ð¾ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(580759,16133,'ur','Ú†ÛŒÚ© Ø§Ù„ØªÙˆØ§ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(580760,16133,'sr','Ð¡Ð»Ð°ÑšÐµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ Ñ‡ÐµÐºÐ¾Ð²Ðµ',0),(580761,16133,'vi','Gá»­i trong khi chá» kiá»ƒm tra',0),(580762,16133,'af','Stuur hangende ondersoeke',0),(580763,16133,'ro','Trimite Ã®n aÅŸteptarea controalelor',0),(580764,16133,'et','Saada kontrolli lÃ¤biviimist oodates',0),(580765,16133,'si','PoÅ¡lji ÄakajoÄo pregledi',0),(580766,16133,'ba','Kirim tertunda cek',0),(580767,16133,'nl','Stuur in afwachting van controles',0),(580768,16133,'fi','LÃ¤hetÃ¤ odottavat tarkastukset',0),(580769,16133,'no','Sende ventende sjekker',0),(580770,16133,'da','Send ventende kontrol',0),(580771,16133,'ko','ê²€ì‚¬ ì¤‘ì¸ ë³´ë‚´ê¸°',0),(580772,16133,'he','×©×œ×— ×ž×ž×ª×™× ×™× ×¦\'×§×™×',0),(580773,16133,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÎºÎºÏÎµÎ¼Î¿ÏÎ½ Î­Î»ÎµÎ³Ï‡Î¿Î¹',0),(580774,16133,'zh','å‘é€æŒ‚èµ·çš„æ£€æŸ¥',0),(580775,16133,'sv','Skicka vÃ¤ntande kontroller',0),(580776,16133,'it','Inviare in attesa di verifiche',0),(580777,16133,'tl','',0),(580778,16133,'th','à¸ªà¹ˆà¸‡à¸£à¸­à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(580779,16133,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤œà¤¾à¤‚à¤š à¤­à¥‡à¤œà¥‡à¤‚',0),(580780,16133,'ms','Menghantar sementara menunggu semakan',0),(580781,16133,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù†ØªØ¸Ø§Ø±Ø§ Ù„Ù„Ø´ÙŠÙƒØ§Øª',0),(580782,16133,'fr','Envoyer dans lâ€™attente de vÃ©rifications',0),(580783,16133,'jp','ä¿ç•™ä¸­ã®ãƒã‚§ãƒƒã‚¯ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(580784,16133,'pt','Enviar pendente cheques',0),(580785,16133,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ð¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(580786,16133,'es','Enviar pendientes cheques',0),(580787,16133,'de','Senden Sie ausstehende PrÃ¼fungen',0),(580788,16133,'en','Send Pending Checks',0),(580789,16134,'is','',0),(580790,16134,'dr','Ø§Ø±Ø³Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ù…Ø«Ø¨Øª',0),(580791,16134,'pr','Ø§Ø±Ø³Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ù…Ø«Ø¨Øª',0),(580792,16134,'tr','Pozitif Ã¶deme iÃ§in gÃ¶nderilen',0),(580793,16134,'pl','WysyÅ‚ane do pÅ‚atnoÅ›ci dodatnich',0),(580794,16134,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾ Ð´Ð¾ Ð¿Ð¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(580795,16134,'ur','Ù…Ø«Ø¨Øª ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬Ø§',0),(580796,16134,'sr','ÐŸÐ¾ÑÐ»Ð°Ñ‚Ð¸ Ð¿Ð¾Ð·Ð¸Ñ‚Ð¸Ð²Ð½Ñƒ Ð¿Ð»Ð°Ñ‚Ðµ',0),(580797,16134,'vi','Gá»­i Ä‘áº¿n tráº£ tiá»n tÃ­ch cá»±c',0),(580798,16134,'af','Gestuur om positiewe betaal',0),(580799,16134,'ro','Trimis la plata pozitiv',0),(580800,16134,'et','Saadetav positiivne tasu',0),(580801,16134,'si','Poslati pozitivno plaÄilo',0),(580802,16134,'ba','Dikirim untuk membayar positif',0),(580803,16134,'nl','Verzonden naar positieve beloning',0),(580804,16134,'fi','LÃ¤hetetÃ¤Ã¤n positiivinen maksu',0),(580805,16134,'no','Sendt til positiv lÃ¸nn',0),(580806,16134,'da','Sendt til Positive lÃ¸n',0),(580807,16134,'ko','ê¸ì •ì ì¸ ì§€ë¶ˆ ì „ì†¡',0),(580808,16134,'he','×©×œ×— ×œ×©×œ× ×—×™×•×‘×™',0),(580809,16134,'el','Î‘Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î· Î¸ÎµÏ„Î¹ÎºÎ® Pay',0),(580810,16134,'zh','å‘é€åˆ°ç§¯æžè–ªé…¬',0),(580811,16134,'sv','Skickas till Betalningskontroll',0),(580812,16134,'it','Inviato da pagare positivo',0),(580813,16134,'tl','',0),(580814,16134,'th','à¸ªà¹ˆà¸‡à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹€à¸›à¹‡à¸™à¸šà¸§à¸',0),(580815,16134,'hi','à¤¸à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œà¤¾',0),(580816,16134,'ms','Dihantar kepada gaji yang positif',0),(580817,16134,'ar','Ø£Ø±Ø³Ù„Øª Ø¥Ù„Ù‰ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø¨ÙŠ',0),(580818,16134,'fr','EnvoyÃ© Ã  la rÃ©munÃ©ration de Positive',0),(580819,16134,'jp','è‚¯å®šçš„ãªæ”¯æ‰•ã«é€ä¿¡',0),(580820,16134,'pt','Enviado para pagamento positivo',0),(580821,16134,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¾ Ð½Ð° Ð¿Ð¾Ð·Ð¸Ñ‚Ð¸Ð²Ð½Ð¾Ðµ Ð²Ð¾Ð·Ð½Ð°Ð³Ñ€Ð°Ð¶Ð´ÐµÐ½Ð¸Ðµ',0),(580822,16134,'es','Enviado a pago positivo',0),(580823,16134,'de','Geschickt, um Positive Zahlen',0),(580824,16134,'en','Sent To Positive Pay',0),(580825,16135,'is','',0),(580826,16135,'dr','Ø§Ù†ØªÙ‚Ø§Ù„ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(580827,16135,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ù†Ø§Ù…ÙˆÙÙ‚ Ø¨ÙˆØ¯',0),(580828,16135,'tr','AktarÄ±m baÅŸarÄ±sÄ±z oldu',0),(580829,16135,'pl','Przekazywanie nie powiodÅ‚o siÄ™',0),(580830,16135,'bg','ÐŸÑ€ÐµÑ…Ð²ÑŠÑ€Ð»ÑÐ½ÐµÑ‚Ð¾ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(580831,16135,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ù†Ø§Ú©Ø§Ù…',0),(580832,16135,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ¾',0),(580833,16135,'vi','Chuyá»ƒn khÃ´ng thÃ nh cÃ´ng',0),(580834,16135,'af','Oordrag het misluk',0),(580835,16135,'ro','Transferul nu a reuÈ™it',0),(580836,16135,'et','Ãœlekanne ebaÃµnnestus',0),(580837,16135,'si','Prenos ni uspel',0),(580838,16135,'ba','Mentransfer gagal',0),(580839,16135,'nl','Overdracht mislukt',0),(580840,16135,'fi','Siirto epÃ¤onnistui',0),(580841,16135,'no','OverfÃ¸ringen mislyktes',0),(580842,16135,'da','OverfÃ¸rsel mislykkedes',0),(580843,16135,'ko','ì „ì†¡ ì‹¤íŒ¨',0),(580844,16135,'he','×”×”×¢×‘×¨×” × ×›×©×œ×”',0),(580845,16135,'el','Î— Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬ Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(580846,16135,'zh','ä¼ è¾“å¤±è´¥',0),(580847,16135,'sv','Ã–verfÃ¶ring misslyckades',0),(580848,16135,'it','Trasferimento non riuscito',0),(580849,16135,'tl','',0),(580850,16135,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(580851,16135,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤®à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(580852,16135,'ms','Pemindahan yang gagal',0),(580853,16135,'ar','ÙØ´Ù„ ÙÙŠ Ù†Ù‚Ù„',0),(580854,16135,'fr','Transfert a Ã©chouÃ©',0),(580855,16135,'jp','è»¢é€ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(580856,16135,'pt','TransferÃªncia falhada',0),(580857,16135,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(580858,16135,'es','Transferencia fallida',0),(580859,16135,'de','Transfer fehlgeschlagen',0),(580860,16135,'en','Transfer Failed',0),(580861,16136,'is','',0),(580862,16136,'dr','Ú©Ø§Ø±Ø¨Ø± ØªÙ†Ø¸ÛŒÙ…',0),(580863,16136,'pr','Ú©Ø§Ø±Ø¨Ø± ØªÙ†Ø¸ÛŒÙ…',0),(580864,16136,'tr','KullanÄ±cÄ± ayarlÄ± deÄŸil',0),(580865,16136,'pl','UÅ¼ytkownik nie ustawiona',0),(580866,16136,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÑ‚ Ð½Ðµ Ð·Ð°Ð´Ð°Ð´Ðµ',0),(580867,16136,'ur','ØµØ§Ø±Ù Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(580868,16136,'sr','ÐšÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(580869,16136,'vi','NgÆ°á»i dÃ¹ng khÃ´ng Ä‘Æ°á»£c thiáº¿t láº­p',0),(580870,16136,'af','Gebruiker stel nie',0),(580871,16136,'ro','Utilizatorul nu a stabilit',0),(580872,16136,'et','Kasutaja seatud',0),(580873,16136,'si','Uporabnik ni nastavljena',0),(580874,16136,'ba','Pengguna tidak diatur',0),(580875,16136,'nl','Gebruiker niet instellen',0),(580876,16136,'fi','KÃ¤yttÃ¤jÃ¤ ei ole mÃ¤Ã¤ritetty',0),(580877,16136,'no','Bruker ikke angitt',0),(580878,16136,'da','Brugeren ikke indstille',0),(580879,16136,'ko','ì‚¬ìš©ìž ì„¤ì • í•˜ì§€',0),(580880,16136,'he','×”×ž×©×ª×ž×© ××™× ×• ×ž×•×’×“×¨',0),(580881,16136,'el','Î§ÏÎ®ÏƒÏ„Î· Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(580882,16136,'zh','ç”¨æˆ·æœªè®¾ç½®',0),(580883,16136,'sv','AnvÃ¤ndaren inte ange',0),(580884,16136,'it','Utente non impostato',0),(580885,16136,'tl','',0),(580886,16136,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(580887,16136,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(580888,16136,'ms','Pengguna tidak menetapkan',0),(580889,16136,'ar','Ø¹Ø¯Ù… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(580890,16136,'fr','Utilisateur non dÃ©fini',0),(580891,16136,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(580892,16136,'pt','UsuÃ¡rio nÃ£o definido',0),(580893,16136,'ru','ÐŸÐ¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð½Ðµ Ð·Ð°Ð´Ð°Ð½',0),(580894,16136,'es','Usuario no definido',0),(580895,16136,'de','Benutzer nicht gesetzt',0),(580896,16136,'en','User Not Set',0),(580897,16137,'is','',0),(580898,16137,'dr','Ù¾Ø¯ Ø³Ù…Øª Ø±Ø§Ø³Øª',0),(580899,16137,'pr','Ù¾Ø¯ Ø³Ù…Øª Ø±Ø§Ø³Øª',0),(580900,16137,'tr','Åžu defteri',0),(580901,16137,'pl','Pad w prawo',0),(580902,16137,'bg','ÐŸÐ¾Ð´Ð»Ð¾Ð¶ÐºÐ° Ð¿Ñ€Ð°Ð²Ð¾',0),(580903,16137,'ur','Ù¾ÛŒÚˆ Ø­Ù‚',0),(580904,16137,'sr','ÐŸÐ¾Ð´Ð»Ð¾Ð³Ð° Ð·Ð° Ð¿Ñ€Ð°Ð²Ð¾',0),(580905,16137,'vi','Pad ngay',0),(580906,16137,'af','Pad reg',0),(580907,16137,'ro','Pad-ul imediat',0),(580908,16137,'et','Pad just',0),(580909,16137,'si','Pad desno',0),(580910,16137,'ba','Pad kanan',0),(580911,16137,'nl','Pad rechts',0),(580912,16137,'fi','Pad juuri',0),(580913,16137,'no','Pad rett',0),(580914,16137,'da','Pad hÃ¸jre',0),(580915,16137,'ko','ì˜¤ë¥¸ìª½ íŒ¨ë“œ',0),(580916,16137,'he','×ž×©×˜×— ×™×©×¨',0),(580917,16137,'el','ÎœÎ±Î¾Î¹Î»Î¬ÏÎ¹ Î´ÎµÎ¾Î¹Î¬',0),(580918,16137,'zh','å³åž«',0),(580919,16137,'sv','Pad hÃ¶ger',0),(580920,16137,'it','Pad in',0),(580921,16137,'tl','',0),(580922,16137,'th','à¹à¸œà¹ˆà¸™à¸‚à¸§à¸²',0),(580923,16137,'hi','à¤¦à¤¾à¤à¤ à¤ªà¥ˆà¤¡',0),(580924,16137,'ms','Tuala wanita yang betul-betul',0),(580925,16137,'ar','Ù„ÙˆØ­Ø© Ø§Ù„Ø­Ù‚',0),(580926,16137,'fr','Touche droite',0),(580927,16137,'jp','å³ãƒ‘ãƒƒãƒ‰',0),(580928,16137,'pt','Almofada bem',0),(580929,16137,'ru','Pad Ð²Ð¿Ñ€Ð°Ð²Ð¾',0),(580930,16137,'es','Pad derecha',0),(580931,16137,'de','Pad rechts',0),(580932,16137,'en','Pad Right',0),(580933,16138,'is','',0),(580934,16138,'dr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ GL Ø±Ø§ Ø§ÛŒØ¬Ø§Ø¯',0),(580935,16138,'pr','Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ GL Ø±Ø§ Ø§ÛŒØ¬Ø§Ø¯',0),(580936,16138,'tr','GL giriÅŸleri oluÅŸturma',0),(580937,16138,'pl','Nie naleÅ¼y tworzyÄ‡ wpisy GL',0),(580938,16138,'bg','ÐÐµ ÑÑŠÐ·Ð´Ð°Ð²Ð°Ñ‚ GL Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(580939,16138,'ur','Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚ Ù†ÛÛŒÚº ÛÙˆØªÛŒ',0),(580940,16138,'sr','ÐÐµ ÐºÑ€ÐµÐ¸Ñ€Ð°Ñ˜Ñƒ ÑÑ‚Ð°Ð²ÐºÐµ Ð“Ð›',0),(580941,16138,'vi','KhÃ´ng táº¡o ra cÃ¡c má»¥c GL',0),(580942,16138,'af','GL inskrywings skep nie',0),(580943,16138,'ro','Creare intrÄƒri GL',0),(580944,16138,'et','Loo GL kandeid',0),(580945,16138,'si','Ne ustvari postavke GL',0),(580946,16138,'ba','Jangan membuat entri GL',0),(580947,16138,'nl','Maak geen GL posten',0),(580948,16138,'fi','Ã„lÃ¤ luo GL merkintÃ¶jÃ¤',0),(580949,16138,'no','Opprett ikke GL oppfÃ¸ringer',0),(580950,16138,'da','Opret ikke poster i GL',0),(580951,16138,'ko','GL í•­ëª©ì„ ìƒì„± í•˜ì§€ ë§ˆì‹­ì‹œì˜¤',0),(580952,16138,'he','××œ ×ª×™×¦×•×¨ ×¢×¨×›×™ GL',0),(580953,16138,'el','ÎœÎ·Î½ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯Ï„Îµ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î³/Î»',0),(580954,16138,'zh','ä¸åˆ›å»º GL æ¡ç›®',0),(580955,16138,'sv','Skapa inte GL poster',0),(580956,16138,'it','Non creare voci di contabilitÃ  generale',0),(580957,16138,'tl','',0),(580958,16138,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£ GL',0),(580959,16138,'hi','GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¨à¤¹à¥€à¤‚ à¤¬à¤¨à¤¾à¤¤à¥‡ à¤¹à¥ˆà¤‚',0),(580960,16138,'ms','Tidak membuat entri GL',0),(580961,16138,'ar','Ù„Ø§ ØªÙ‚Ù… Ø¨Ø¥Ù†Ø´Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª GL',0),(580962,16138,'fr','Ne crÃ©ez pas dâ€™entrÃ©es de GL',0),(580963,16138,'jp','GL ã‚¨ãƒ³ãƒˆãƒªã‚’ä½œæˆã—ãªã„ã§ãã ã•ã„ã€‚',0),(580964,16138,'pt','NÃ£o crie entradas GL',0),(580965,16138,'ru','ÐÐµ ÑÐ¾Ð·Ð´Ð°Ð²Ð°Ð¹Ñ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ GL',0),(580966,16138,'es','No se crean entradas GL',0),(580967,16138,'de','Erstelle keine Sachposten',0),(580968,16138,'en','Do Not Create GL Entries',0),(580969,16139,'is','',0),(580970,16139,'dr','Ø¯Ø± ØµÙ',0),(580971,16139,'pr','Ø¯Ø± ØµÙ',0),(580972,16139,'tr','SÄ±raya alÄ±ndÄ±',0),(580973,16139,'pl','W kolejce',0),(580974,16139,'bg','ÐžÐ¿Ð°ÑˆÐºÐ°',0),(580975,16139,'ur','Ù‚Ø·Ø§Ø± Ù…ÛŒÚº',0),(580976,16139,'sr','Ð¡Ñ‚Ð°Ð²Ñ™ÐµÐ½Ð° Ñƒ Ñ€ÐµÐ´',0),(580977,16139,'vi','Xáº¿p hÃ ng',0),(580978,16139,'af','Getou',0),(580979,16139,'ro','Coada de aÅŸteptare',0),(580980,16139,'et','JÃ¤rjekorras',0),(580981,16139,'si','V Äakalni vrsti',0),(580982,16139,'ba','Antri',0),(580983,16139,'nl','In de wachtrij',0),(580984,16139,'fi','Jonossa',0),(580985,16139,'no','I kÃ¸',0),(580986,16139,'da','I kÃ¸',0),(580987,16139,'ko','ëŒ€ê¸°',0),(580988,16139,'he','×‘×ª×•×¨',0),(580989,16139,'el','Î£Ï„Î·Î½ Î¿Ï…ÏÎ¬',0),(580990,16139,'zh','æŽ’é˜Ÿ',0),(580991,16139,'sv','I kÃ¶',0),(580992,16139,'it','In coda',0),(580993,16139,'tl','',0),(580994,16139,'th','à¸ˆà¸±à¸”à¸„à¸´à¸§',0),(580995,16139,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿à¤¬à¤¦à¥à¤§',0),(580996,16139,'ms','Dibariskan',0),(580997,16139,'ar','ÙÙŠ Ù‚Ø§Ø¦Ù…Ø© Ø§Ù„Ø§Ù†ØªØ¸Ø§Ø±',0),(580998,16139,'fr','En file dâ€™attente',0),(580999,16139,'jp','ã‚­ãƒ¥ãƒ¼ã«å…¥ã£ã¦ã„ã¾ã™ã€‚',0),(581000,16139,'pt','Na fila',0),(581001,16139,'ru','Ð’ Ð¾Ñ‡ÐµÑ€ÐµÐ´Ð¸',0),(581002,16139,'es','En cola',0),(581003,16139,'de','In der Warteschlange',0),(581004,16139,'en','Queued',0),(581005,16140,'is','',0),(581006,16140,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ø¨Ù‡ Ù¾Ø§ÛŒØ§Ù† Ø±Ø³ÛŒØ¯',0),(581007,16140,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ø¨Ù‡ Ù¾Ø§ÛŒØ§Ù† Ø±Ø³ÛŒØ¯',0),(581008,16140,'tr','Alma iÅŸlemi tamamlandÄ±',0),(581009,16140,'pl','Import zakoÅ„czony',0),(581010,16140,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸',0),(581011,16140,'ur','Ù…Ú©Ù…Ù„ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(581012,16140,'sr','Ð£Ð²Ð¾Ð· Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½',0),(581013,16140,'vi','Chuyá»ƒn nháº­p hoÃ n táº¥t',0),(581014,16140,'af','Invoer voltooi',0),(581015,16140,'ro','Import finalizat',0),(581016,16140,'et','Importimine on lÃµpule viidud',0),(581017,16140,'si','Uvoz je dokonÄan',0),(581018,16140,'ba','Impor selesai',0),(581019,16140,'nl','Importeren voltooid',0),(581020,16140,'fi','Tuonti on valmis',0),(581021,16140,'no','Import fullfÃ¸rt',0),(581022,16140,'da','Import afsluttet',0),(581023,16140,'ko','ê°€ì ¸ì˜¤ê¸° ì™„ë£Œ',0),(581024,16140,'he','×™×™×‘×•× ×”×•×©×œ×ž×”',0),(581025,16140,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ¸Î·ÎºÎµ',0),(581026,16140,'zh','å¯¼å…¥å®Œæˆ',0),(581027,16140,'sv','Import slutfÃ¶rd',0),(581028,16140,'it','Importazione completata',0),(581029,16140,'tl','',0),(581030,16140,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸´à¹‰à¸™',0),(581031,16140,'hi','à¤†à¤¯à¤¾à¤¤ à¤ªà¥‚à¤°à¥à¤£',0),(581032,16140,'ms','Import selesai',0),(581033,16140,'ar','Ø¥ÙƒÙ…Ø§Ù„ Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(581034,16140,'fr','Importation terminÃ©e',0),(581035,16140,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆãŒå®Œäº†ã—ã¾ã—ãŸ',0),(581036,16140,'pt','ImportaÃ§Ã£o concluÃ­da',0),(581037,16140,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½',0),(581038,16140,'es','ImportaciÃ³n completado',0),(581039,16140,'de','Import abgeschlossen',0),(581040,16140,'en','Import Completed',0),(581041,16141,'is','',0),(581042,16141,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ø¨Ø§ Ø®Ø·Ø§',0),(581043,16141,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ø¨Ø§ Ø®Ø·Ø§',0),(581044,16141,'tr','Hatalarla tamamlandÄ± al',0),(581045,16141,'pl','Importu zostaÅ‚a ukoÅ„czona z bÅ‚Ä™dami',0),(581046,16141,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½ÐµÑ‚Ð¾ Ð·Ð°Ð²ÑŠÑ€ÑˆÐ¸ Ñ Ð³Ñ€ÐµÑˆÐºÐ¸',0),(581047,16141,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº Ù†Ù‚Ø§Ø¦Øµ Ú©Û’ Ø³Ø§ØªÚ¾ Ù…Ú©Ù…Ù„',0),(581048,16141,'sr','Ð£Ð²Ð¾Ð· Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½ ÑÐ° Ð³Ñ€ÐµÑˆÐºÐ°Ð¼Ð°',0),(581049,16141,'vi','Chuyá»ƒn nháº­p hoÃ n táº¥t cÃ³ lá»—i',0),(581050,16141,'af','Invoer voltooi met foute',0),(581051,16141,'ro','Import finalizat cu erori',0),(581052,16141,'et','Import on tÃµrgetega lÃµpule viidud',0),(581053,16141,'si','Uvoz je dokonÄan z napakami',0),(581054,16141,'ba','Impor selesai dengan kesalahan',0),(581055,16141,'nl','Importeren voltooid met fouten',0),(581056,16141,'fi','Tuomisessa esiintyi virheitÃ¤',0),(581057,16141,'no','Import fullfÃ¸rt med feil',0),(581058,16141,'da','Import udfÃ¸rt med fejl',0),(581059,16141,'ko','ê°€ì ¸ì˜¤ê¸° ì˜¤ë¥˜ì™€ í•¨ê»˜ ì™„ë£Œ',0),(581060,16141,'he','×™×™×‘×•× ×”×•×©×œ×ž×” ×¢× ×©×’×™××•×ª',0),(581061,16141,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚ Î¿Î»Î¿ÎºÎ»Î·ÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î±',0),(581062,16141,'zh','å¯¼å…¥å®Œæˆï¼Œé”™è¯¯',0),(581063,16141,'sv','Importen slutfÃ¶rdes med fel',0),(581064,16141,'it','Importazione completata con errori',0),(581065,16141,'tl','',0),(581066,16141,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹€à¸ªà¸£à¹‡à¸ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ à¸¡à¸µà¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(581067,16141,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ªà¥‚à¤°à¥à¤£ à¤†à¤¯à¤¾à¤¤',0),(581068,16141,'ms','Import yang telah siap dibina dengan ralat',0),(581069,16141,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø¥ÙƒÙ…Ø§Ù„ Ù…Ø¹ ÙˆØ¬ÙˆØ¯ Ø®Ø·Ø£',0),(581070,16141,'fr','Importation terminÃ©e avec des erreurs',0),(581071,16141,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆ ã‚¨ãƒ©ãƒ¼ãŒç™ºç”Ÿã—ã¾ã—ãŸ',0),(581072,16141,'pt','ImportaÃ§Ã£o concluÃ­da com erros',0),(581073,16141,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð·Ð°Ð²ÐµÑ€ÑˆÐµÐ½ Ñ Ð¾ÑˆÐ¸Ð±ÐºÐ°Ð¼Ð¸',0),(581074,16141,'es','ImportaciÃ³n completada con errores',0),(581075,16141,'de','Import wurde mit Fehlern abgeschlossen',0),(581076,16141,'en','Import Completed With Errors',0),(581077,16142,'is','',0),(581078,16142,'dr','Ù‡ÛŒÚ† Ú†ÛŒØ² Ø¨Ù‡ ÙˆØ§Ø±Ø¯Ø§Øª',0),(581079,16142,'pr','Ù‡ÛŒÚ† Ú†ÛŒØ² Ø¨Ù‡ ÙˆØ§Ø±Ø¯Ø§Øª',0),(581080,16142,'tr','AlÄ±nacak bir ÅŸey yok',0),(581081,16142,'pl','Nic do importu',0),(581082,16142,'bg','ÐÑÐ¼Ð° Ð½Ð¸Ñ‰Ð¾ Ð·Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(581083,16142,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ú©Û’ Ù„ÛŒÛ’ Ú©Ú†Ú¾ Ø¨Ú¾ÛŒ Ù†ÛÛŒÚº',0),(581084,16142,'sr','ÐÐ¸ÑˆÑ‚Ð° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(581085,16142,'vi','KhÃ´ng cÃ³ gÃ¬ Ä‘á»ƒ nháº­p kháº©u',0),(581086,16142,'af','Niks om te voer',0),(581087,16142,'ro','Nimic de Import',0),(581088,16142,'et','Midagi Import',0),(581089,16142,'si','NiÄ za uvoz',0),(581090,16142,'ba','Apa-apa untuk impor',0),(581091,16142,'nl','Niets te importeren',0),(581092,16142,'fi','MitÃ¤Ã¤n tuonti',0),(581093,16142,'no','Ingenting Ã¥ Import',0),(581094,16142,'da','Intet til Import',0),(581095,16142,'ko','ì•„ë¬´ê²ƒë„ ê°€ì ¸ì˜¤ê¸°',0),(581096,16142,'he','. ×©×•× ×“×‘×¨ ×¢×œ ×™×‘×',0),(581097,16142,'el','Î”ÎµÎ½ Î­Ï‡ÎµÎ¹ Ï„Î¯Ï€Î¿Ï„Î± Î½Î± ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(581098,16142,'zh','å¯¼å…¥æ— å…³',0),(581099,16142,'sv','NÃ¥got att importera',0),(581100,16142,'it','Niente di importazione',0),(581101,16142,'tl','',0),(581102,16142,'th','à¸­à¸°à¹„à¸£à¸—à¸µà¹ˆà¸ˆà¸°à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(581103,16142,'hi','à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥à¤› à¤­à¥€ à¤¨à¤¹à¥€à¤‚',0),(581104,16142,'ms','Apa-apa untuk Import',0),(581105,16142,'ar','Ù„Ø§ Ø´ÙŠØ¡ Ù„Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(581106,16142,'fr','Rien Ã  lâ€™importation',0),(581107,16142,'jp','ä½•ã‚‚ã‚¤ãƒ³ãƒãƒ¼ãƒˆã™ã‚‹',0),(581108,16142,'pt','Nada de importaÃ§Ã£o',0),(581109,16142,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Nothing Ð´Ð»Ñ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(581110,16142,'es','Nada a importaciÃ³n',0),(581111,16142,'de','Nichts zu importieren',0),(581112,16142,'en','Nothing To Import',0),(581113,16143,'is','',0),(581114,16143,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ù‚Ø§Ù„Ø¨',0),(581115,16143,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ù‚Ø§Ù„Ø¨',0),(581116,16143,'tr','Åžablon yÃ¼kleme',0),(581117,16143,'pl','Pobierz szablon',0),(581118,16143,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(581119,16143,'ur','Ø³Ø§Ù†Ú†Ø§ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(581120,16143,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ð¿Ñ€ÐµÐ´Ð»Ð¾ÑˆÐºÐ°',0),(581121,16143,'vi','Táº£i vá» báº£n máº«u',0),(581122,16143,'af','Laai patroon',0),(581123,16143,'ro','DescÄƒrca ÅŸablon',0),(581124,16143,'et','Malli allalaadimine',0),(581125,16143,'si','Download predlogo',0),(581126,16143,'ba','Men-download Template',0),(581127,16143,'nl','Sjabloon downloaden',0),(581128,16143,'fi','Lataa malli',0),(581129,16143,'no','Laste ned malen',0),(581130,16143,'da','Download skabelon',0),(581131,16143,'ko','ì„œì‹ íŒŒì¼ ë‹¤ìš´ë¡œë“œ',0),(581132,16143,'he','×”×•×¨×“×ª ×”×ª×‘× ×™×ª',0),(581133,16143,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿',0),(581134,16143,'zh','ä¸‹è½½æ¨¡æ¿',0),(581135,16143,'sv','HÃ¤mta mall',0),(581136,16143,'it','Scarica modello',0),(581137,16143,'tl','',0),(581138,16143,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹à¸¡à¹ˆà¹à¸šà¸š',0),(581139,16143,'hi','à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤•à¤°à¥‡à¤‚',0),(581140,16143,'ms','Muat turun Template',0),(581141,16143,'ar','ØªØ­Ù…ÙŠÙ„ Ù‚Ø§Ù„Ø¨',0),(581142,16143,'fr','TÃ©lÃ©charger Template',0),(581143,16143,'jp','ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(581144,16143,'pt','Baixar modelo',0),(581145,16143,'ru','Ð¡ÐºÐ°Ñ‡Ð°Ñ‚ÑŒ ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(581146,16143,'es','Descargar plantilla',0),(581147,16143,'de','Vorlage herunterladen',0),(581148,16143,'en','Download Template',0),(581149,16144,'is','',0),(581150,16144,'dr','ÙØ±Ù…Øª ÙØ§ÛŒÙ„',0),(581151,16144,'pr','ÙØ±Ù…Øª ÙØ§ÛŒÙ„',0),(581152,16144,'tr','Dosya biÃ§imi',0),(581153,16144,'pl','Format pliku',0),(581154,16144,'bg','Ð¤Ð°Ð¹Ð»Ð¾Ð² Ñ„Ð¾Ñ€Ð¼Ð°Ñ‚',0),(581155,16144,'ur','ÙØ§Ø¦Ù„ Ú©ÛŒ Ø´Ú©Ù„',0),(581156,16144,'sr','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(581157,16144,'vi','Äá»‹nh dáº¡ng táº­p tin',0),(581158,16144,'af','LÃªer formaat',0),(581159,16144,'ro','Format de fiÅŸier',0),(581160,16144,'et','Faili formaat',0),(581161,16144,'si','Oblika zapisa datoteke',0),(581162,16144,'ba','File Format',0),(581163,16144,'nl','Bestandsindeling',0),(581164,16144,'fi','Tiedostomuoto',0),(581165,16144,'no','Filformat',0),(581166,16144,'da','Filformat',0),(581167,16144,'ko','íŒŒì¼ í˜•ì‹',0),(581168,16144,'he','×ª×‘× ×™×ª ×§×•×‘×¥',0),(581169,16144,'el','ÎœÎ¿ÏÏ†Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï…',0),(581170,16144,'zh','æ–‡ä»¶æ ¼å¼',0),(581171,16144,'sv','Filformat',0),(581172,16144,'it','Formato di file',0),(581173,16144,'tl','',0),(581174,16144,'th','à¸£à¸¹à¸›à¹à¸šà¸šà¹à¸Ÿà¹‰à¸¡',0),(581175,16144,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥à¤µà¤°à¥‚à¤ª',0),(581176,16144,'ms','Format fail',0),(581177,16144,'ar','ØªÙ†Ø³ÙŠÙ‚ Ù…Ù„Ù',0),(581178,16144,'fr','Format de fichier',0),(581179,16144,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã®å½¢å¼',0),(581180,16144,'pt','Formato de arquivo',0),(581181,16144,'ru','Ð¤Ð¾Ñ€Ð¼Ð°Ñ‚ Ñ„Ð°Ð¹Ð»Ð°',0),(581182,16144,'es','Formato de archivo',0),(581183,16144,'de','Datei-Format',0),(581184,16144,'en','File Format',0),(581185,16145,'is','',0),(581186,16145,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø² Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(581187,16145,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø² Ù¾Ø±ÙˆÙ†Ø¯Ù‡',0),(581188,16145,'tr','Dosyadan alma',0),(581189,16145,'pl','Importuj z pliku',0),(581190,16145,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ñ‚ Ñ„Ð°Ð¹Ð»',0),(581191,16145,'ur','Ù…Ø³Ù„ Ø³Û’ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(581192,16145,'sr','Ð£Ð²ÐµÐ·Ð¸ Ð¸Ð· Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ',0),(581193,16145,'vi','Chuyá»ƒn nháº­p tá»« tá»‡p',0),(581194,16145,'af','Voer in vanaf \'n lÃªer',0),(581195,16145,'ro','Import din fiÅŸier',0),(581196,16145,'et','Impordi failist',0),(581197,16145,'si','Uvoz iz datoteke',0),(581198,16145,'ba','Impor dari File',0),(581199,16145,'nl','Importeren uit bestand',0),(581200,16145,'fi','Tuo tiedostosta',0),(581201,16145,'no','Importer fra fil',0),(581202,16145,'da','Importer fra fil',0),(581203,16145,'ko','íŒŒì¼ì—ì„œ ê°€ì ¸ì˜¤ê¸°',0),(581204,16145,'he','×™×™×‘×•× ×ž×§×•×‘×¥',0),(581205,16145,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±Ï€ÏŒ Î±ÏÏ‡ÎµÎ¯Î¿',0),(581206,16145,'zh','ä»Žæ–‡ä»¶å¯¼å…¥',0),(581207,16145,'sv','Importera frÃ¥n fil',0),(581208,16145,'it','Importazione da File',0),(581209,16145,'tl','',0),(581210,16145,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸²à¸à¹„à¸Ÿà¸¥à¹Œ',0),(581211,16145,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¸à¥‡ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(581212,16145,'ms','Import daripada fail',0),(581213,16145,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ù† Ù…Ù„Ù',0),(581214,16145,'fr','Importation de fichier',0),(581215,16145,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‹ã‚‰ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(581216,16145,'pt','ImportaÃ§Ã£o de arquivo',0),(581217,16145,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¸Ð· Ñ„Ð°Ð¹Ð»Ð°',0),(581218,16145,'es','ImportaciÃ³n de archivo',0),(581219,16145,'de','Aus Datei importieren',0),(581220,16145,'en','Import From File',0),(581221,16146,'is','',0),(581222,16146,'dr','ÛŒÚ©ÛŒ Ø¯Ø± Ù‡Ø± Ø®Ø·',0),(581223,16146,'pr','ÛŒÚ©ÛŒ Ø¯Ø± Ù‡Ø± Ø®Ø·',0),(581224,16146,'tr','Her satÄ±rda bir tane',0),(581225,16146,'pl','Jedna linia',0),(581226,16146,'bg','ÐŸÐ¾ ÐµÐ´Ð¸Ð½ Ð½Ð° Ñ€ÐµÐ´',0),(581227,16146,'ur','Ø§ÛŒÚ© Ù„Ø§Ø¦Ù† ÙÛŒ',0),(581228,16146,'sr','ÐˆÐµÐ´Ð½Ñƒ Ð½Ð° ÑÐ²Ð°ÐºÐ¾Ñ˜ Ð»Ð¸Ð½Ð¸Ñ˜Ð¸',0),(581229,16146,'vi','Má»—i dÃ²ng',0),(581230,16146,'af','Een Per lyn',0),(581231,16146,'ro','Una pe linie',0),(581232,16146,'et','Ãœks igale reale',0),(581233,16146,'si','Eno na vrstico',0),(581234,16146,'ba','Satu Per baris',0),(581235,16146,'nl','Ã‰Ã©n Per regel',0),(581236,16146,'fi','Yksi Per rivi',0),(581237,16146,'no','Ã‰n Per linje',0),(581238,16146,'da','Ã‰n pr. linje',0),(581239,16146,'ko','ì¤„ì— í•˜ë‚˜ì”©',0),(581240,16146,'he','××—×“ ×œ×©×•×¨×”',0),(581241,16146,'el','ÎœÎ¯Î± Î±Î½Î¬ Î³ÏÎ±Î¼Î¼Î®',0),(581242,16146,'zh','æ¯è¡Œä¸€ä¸ª',0),(581243,16146,'sv','En Per rad',0),(581244,16146,'it','Uno Per riga',0),(581245,16146,'tl','',0),(581246,16146,'th','à¸«à¸™à¸¶à¹ˆà¸‡à¸ªà¸³à¸«à¸£à¸±à¸šà¹à¸•à¹ˆà¸¥à¸°à¸šà¸£à¸£à¸—à¸±à¸”',0),(581247,16146,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤à¤•',0),(581248,16146,'ms','Satu satu baris',0),(581249,16146,'ar','ÙˆØ§Ø­Ø¯ Ù„ÙƒÙ„ Ø³Ø·Ø±',0),(581250,16146,'fr','Un par ligne',0),(581251,16146,'jp','1è¡Œã«ã¤ã 1 ã¤',0),(581252,16146,'pt','Um por linha',0),(581253,16146,'ru','ÐŸÐ¾ Ð¾Ð´Ð½Ð¾Ð¼Ñƒ Ð² ÑÑ‚Ñ€Ð¾ÐºÐµ',0),(581254,16146,'es','Uno por lÃ­nea',0),(581255,16146,'de','Eine pro Zeile',0),(581256,16146,'en','One Per Line',0),(581257,16147,'is','',0),(581258,16147,'dr','Prelim Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‚Ø§Ù„Ø¨',0),(581259,16147,'pr','Prelim Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‚Ø§Ù„Ø¨',0),(581260,16147,'tr','Prelim istek ÅŸablonu',0),(581261,16147,'pl','Prelim zapytanie szablonu',0),(581262,16147,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ ÑˆÐ°Ð±Ð»Ð¾Ð½ Ð½Ð° Ð·Ð°ÑÐ²ÐºÐ°',0),(581263,16147,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø³Ø§Ù†Ú†Ø§',0),(581264,16147,'sr','ÐžÐ±Ñ€Ð°Ð·Ð°Ñ† Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° ÑƒÐ²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ',0),(581265,16147,'vi','Prelim yÃªu cáº§u máº«u',0),(581266,16147,'af','Prelim versoek sjabloon',0),(581267,16147,'ro','Åžablon de cerere preliminare',0),(581268,16147,'et','Aasta taotluse malli',0),(581269,16147,'si','Predhodnega zahtevo predlogo',0),(581270,16147,'ba','Prelim permintaan Template',0),(581271,16147,'nl','Kwalificatie verzoek sjabloon',0),(581272,16147,'fi','Alustava pyyntÃ¶mallin',0),(581273,16147,'no','Prelim forespÃ¸rsel mal',0),(581274,16147,'da','Prelim anmodning skabelon',0),(581275,16147,'ko','ì˜ˆì„  ìš”ì²­ ì„œì‹ íŒŒì¼',0),(581276,16147,'he','×ª×‘× ×™×ª ×”×‘×§×©×” ×ž×•×§×“×',0),(581277,16147,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ Ï€ÏÏŒÏ„Ï…Ï€Î¿ Î±Î¯Ï„Î·ÏƒÎ·Ï‚',0),(581278,16147,'zh','åˆè¯•è¯·æ±‚æ¨¡æ¿',0),(581279,16147,'sv','Prelim begÃ¤ran mall',0),(581280,16147,'it','Modello di richiesta di Prelim',0),(581281,16147,'tl','',0),(581282,16147,'th','à¹à¸¡à¹ˆà¸‚à¸­ prelim',0),(581283,16147,'hi','Prelim à¤…à¤¨à¥à¤°à¥‹à¤§ à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ',0),(581284,16147,'ms','Prelim permintaan Template',0),(581285,16147,'ar','Ù‚Ø§Ù„Ø¨ Ø·Ù„Ø¨ prelim',0),(581286,16147,'fr','ModÃ¨le de demande de Prelim',0),(581287,16147,'jp','äºˆå‚™æ ¼ä»˜ã‘ä¾é ¼ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ',0),(581288,16147,'pt','Modelo de pedido de exame preliminar',0),(581289,16147,'ru','Ð¨Ð°Ð±Ð»Ð¾Ð½ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Prelim',0),(581290,16147,'es','Plantilla de solicitud de prelim',0),(581291,16147,'de','Vorrunde Anfrage Vorlage',0),(581292,16147,'en','Prelim Request Template',0),(581293,16148,'is','',0),(581294,16148,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨Ø³ÛŒØ§Ø±ÛŒ Ø¨Ø±Ø§ÛŒ Ù†Ù…Ø§ÛŒØ´',0),(581295,16148,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø«Ø¨Øª Ø´Ø¯Ù‡ Ø¨Ø³ÛŒØ§Ø±ÛŒ Ø¨Ø±Ø§ÛŒ Ù†Ù…Ø§ÛŒØ´',0),(581296,16148,'tr','Ã‡ok fazla kayÄ±t gÃ¶rÃ¼ntÃ¼lemek iÃ§in',0),(581297,16148,'pl','Zbyt wiele rekordÃ³w do wyÅ›wietlania',0),(581298,16148,'bg','Ð¢Ð²ÑŠÑ€Ð´Ðµ Ð¼Ð½Ð¾Ð³Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð·Ð° Ð¿Ð¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ',0),(581299,16148,'ur','Ø¯Ú©Ú¾Ø§Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø¨ÛØª Ø²ÛŒØ§Ø¯Û Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(581300,16148,'sr','ÐŸÑ€ÐµÐ²Ð¸ÑˆÐµ Ð·Ð°Ð¿Ð¸ÑÐ° Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð·',0),(581301,16148,'vi','CÃ¡c há»“ sÆ¡ quÃ¡ nhiá»u Ä‘á»ƒ hiá»ƒn thá»‹',0),(581302,16148,'af','Te veel rekords te vertoon',0),(581303,16148,'ro','Prea multe Ã®nregistrÄƒri pentru a afiÅŸa',0),(581304,16148,'et','Kuva kirjeid liiga palju',0),(581305,16148,'si','PreveÄ zapisov za prikaz',0),(581306,16148,'ba','Terlalu banyak catatan untuk tampilan',0),(581307,16148,'nl','Te veel Records weer te geven',0),(581308,16148,'fi','Liian monta tietuetta nÃ¤yttÃ¶',0),(581309,16148,'no','For mange poster skal vises',0),(581310,16148,'da','Alt for mange poster til skÃ¦rm',0),(581311,16148,'ko','ë„ˆë¬´ ë§Žì€ ë ˆì½”ë“œ í‘œì‹œë¥¼',0),(581312,16148,'he','×¨×©×•×ž×•×ª ×¨×‘×•×ª ×ž×“×™ ×œ×”×¦×’×”',0),(581313,16148,'el','Î Î¬ÏÎ± Ï€Î¿Î»Î»Î­Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÏƒÏ„Î·Î½ Î¿Î¸ÏŒÎ½Î·',0),(581314,16148,'zh','è¦æ˜¾ç¤ºçš„è®°å½•å¤ªå¤š',0),(581315,16148,'sv','AlltfÃ¶r mÃ¥nga poster som ska visas',0),(581316,16148,'it','Troppi record al Display',0),(581317,16148,'tl','',0),(581318,16148,'th','à¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸à¸²à¸£à¹à¸ªà¸”à¸‡à¸œà¸¥à¸¡à¸²à¸à¹€à¸à¸´à¸™à¹„à¸›',0),(581319,16148,'hi','à¤ªà¥à¤°à¤¦à¤°à¥à¤¶à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥€ à¤•à¤ˆ à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡',0),(581320,16148,'ms','Rekod-rekod yang terlalu banyak ke paparan',0),(581321,16148,'ar','Ø¹Ø¯Ø¯ ÙƒØ¨ÙŠØ± Ø¬Ø¯Ø§Ù‹ Ù…Ù† Ø§Ù„Ø³Ø¬Ù„Ø§Øª Ù„Ù„Ø¹Ø±Ø¶',0),(581322,16148,'fr','Trop de dossiers Ã  affichage',0),(581323,16148,'jp','è¡¨ç¤ºã™ã‚‹ãƒ¬ã‚³ãƒ¼ãƒ‰ãŒå¤šã™ãŽã¾ã™ã€‚',0),(581324,16148,'pt','NÃºmero excessivo de registros a serem exibidos',0),(581325,16148,'ru','Ð¡Ð»Ð¸ÑˆÐºÐ¾Ð¼ Ð¼Ð½Ð¾Ð³Ð¾ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ Ð´Ð»Ñ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ',0),(581326,16148,'es','Demasiados registros para mostrar',0),(581327,16148,'de','Zu viele DatensÃ¤tze zur Anzeige',0),(581328,16148,'en','Too Many Records To Display',0),(581329,16149,'is','',0),(581330,16149,'dr','ØªÙ…Ø§Ù… AmEx',0),(581331,16149,'pr','ØªÙ…Ø§Ù… AmEx',0),(581332,16149,'tr','TÃ¼m AmEx',0),(581333,16149,'pl','Wszystkie AmEx',0),(581334,16149,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ AmEx',0),(581335,16149,'ur','ØªÙ…Ø§Ù… Ø§Ù…',0),(581336,16149,'sr','Ð¡Ð²Ð¸ ÐÐ¼Ð•x',0),(581337,16149,'vi','Táº¥t cáº£ tháº» AmEx',0),(581338,16149,'af','Alle AmEx',0),(581339,16149,'ro','Toate AmEx',0),(581340,16149,'et','KÃµik AmEx',0),(581341,16149,'si','Vse AmEx',0),(581342,16149,'ba','Semua AmEx',0),(581343,16149,'nl','Alle AmEx',0),(581344,16149,'fi','Kaikki AmEx',0),(581345,16149,'no','Alle AmEx',0),(581346,16149,'da','Alle AmEx',0),(581347,16149,'ko','ëª¨ë“  ì•„ë©•ìŠ¤',0),(581348,16149,'he','×›×œ ××ž×¨×™×§×Ÿ ××§×¡×¤×¨×¡',0),(581349,16149,'el','ÎŒÎ»Î± Ï„Î± AmEx',0),(581350,16149,'zh','æ‰€æœ‰ç¾Žå›½è¿é€š',0),(581351,16149,'sv','Alla AmEx',0),(581352,16149,'it','Tutti AmEx',0),(581353,16149,'tl','',0),(581354,16149,'th','à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸” AmEx',0),(581355,16149,'hi','à¤¸à¤­à¥€ AmEx',0),(581356,16149,'ms','AmEx semua',0),(581357,16149,'ar','ÙƒÙ„ Ø´Ø±ÙƒØ© Ø£Ù…Ø±ÙŠÙƒØ§Ù† Ø¥ÙƒØ³Ø¨Ø±ÙŠØ³',0),(581358,16149,'fr','Tous les AmEx',0),(581359,16149,'jp','ã™ã¹ã¦ã®ã‚¢ãƒ¡ãƒƒã‚¯ã‚¹',0),(581360,16149,'pt','Todos os AmEx',0),(581361,16149,'ru','Ð’ÑÐµ AmEx',0),(581362,16149,'es','Todos AmEx',0),(581363,16149,'de','Alle AmEx',0),(581364,16149,'en','All AmEx',0),(581365,16150,'is','',0),(581366,16150,'dr','Ù‡Ù…Ù‡ Ø³ÛŒ Ø³ÛŒ',0),(581367,16150,'pr','Ù‡Ù…Ù‡ Ø³ÛŒ Ø³ÛŒ',0),(581368,16150,'tr','TÃ¼m CC',0),(581369,16150,'pl','Wszystkie CC',0),(581370,16150,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ CC',0),(581371,16150,'ur','ØªÙ…Ø§Ù… Ø³ÛŒ Ø³ÛŒ',0),(581372,16150,'sr','Ð¡Ð²Ðµ Ð¦Ð¦',0),(581373,16150,'vi','Táº¥t cáº£ CC',0),(581374,16150,'af','Almal CC',0),(581375,16150,'ro','Toate CC',0),(581376,16150,'et','KÃµik CC',0),(581377,16150,'si','Vse CC',0),(581378,16150,'ba','Semua CC',0),(581379,16150,'nl','Alle CC',0),(581380,16150,'fi','Kaikki CC',0),(581381,16150,'no','Alle CC',0),(581382,16150,'da','Alle CC',0),(581383,16150,'ko','ëª¨ë“  ì°¸ì¡°',0),(581384,16150,'he','×›×œ ×¡×ž ×§',0),(581385,16150,'el','ÎŒÎ»Î± CC',0),(581386,16150,'zh','æ‰€æœ‰ CC',0),(581387,16150,'sv','Alla CC',0),(581388,16150,'it','Tutti CC',0),(581389,16150,'tl','',0),(581390,16150,'th','à¸—à¸¸à¸à¸‹à¸µà¸‹à¸µ',0),(581391,16150,'hi','à¤¸à¤­à¥€ à¤ªà¥à¤°à¤¤à¤¿à¤²à¤¿à¤ªà¤¿',0),(581392,16150,'ms','Semua SK',0),(581393,16150,'ar','ÙƒÙ„ Ù†Ø³Ø®Ø©',0),(581394,16150,'fr','Tout CC',0),(581395,16150,'jp','ã™ã¹ã¦ã® CC ã—ã¾ã™ã€‚',0),(581396,16150,'pt','Todos CC',0),(581397,16150,'ru','Ð’ÑÐµ CC',0),(581398,16150,'es','Todos CC',0),(581399,16150,'de','Alle CC',0),(581400,16150,'en','All CC',0),(581401,16151,'is','',0),(581402,16151,'dr','Ú©Ø´Ù Ù‡Ù…Ù‡',0),(581403,16151,'pr','Ú©Ø´Ù Ù‡Ù…Ù‡',0),(581404,16151,'tr','KeÅŸfetmek tÃ¼m-',0),(581405,16151,'pl','Odkryj wszystkie',0),(581406,16151,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð¾Ñ‚ÐºÑ€Ð¸Ð²Ð°Ñ‚',0),(581407,16151,'ur','Ø³Ø¨ Ú©ÛŒ Ø¯Ø±ÛŒØ§ÙØª',0),(581408,16151,'sr','Ð¡Ð²Ðµ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚Ð¸.',0),(581409,16151,'vi','Táº¥t cáº£ cÃ¡c khÃ¡m phÃ¡',0),(581410,16151,'af','Al ontdek',0),(581411,16151,'ro','Descopera toate',0),(581412,16151,'et','Vaadake kÃµiki',0),(581413,16151,'si','Odkrijte vse',0),(581414,16151,'ba','Semua menemukan',0),(581415,16151,'nl','Ontdek alle',0),(581416,16151,'fi','Kaikki lÃ¶ytÃ¤vÃ¤t',0),(581417,16151,'no','Alle oppdage',0),(581418,16151,'da','Alle oplev',0),(581419,16151,'ko','ëª¨ë“  ë°œê²¬',0),(581420,16151,'he','×›×œ ×ž×” ×œ×’×œ×•×ª',0),(581421,16151,'el','Î‘Î½Î±ÎºÎ±Î»ÏÏˆÏ„Îµ ÏŒÎ»Î± Ï„Î±',0),(581422,16151,'zh','æ‰€æœ‰å‘çŽ°',0),(581423,16151,'sv','Alla UpptÃ¤ck',0),(581424,16151,'it','Scoprire tutti',0),(581425,16151,'tl','',0),(581426,16151,'th','à¸„à¹‰à¸™à¸žà¸šà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(581427,16151,'hi','à¤¸à¤­à¥€ à¤–à¥‹à¤œ',0),(581428,16151,'ms','Semua tetamu',0),(581429,16151,'ar','ÙƒÙ„ Ù…Ø§ Ø§ÙƒØªØ´Ù',0),(581430,16151,'fr','Tout dÃ©couvrir',0),(581431,16151,'jp','ã™ã¹ã¦ã®ç™ºè¦‹ã—ã¾ã™ã€‚',0),(581432,16151,'pt','Tudo o que descobrir.',0),(581433,16151,'ru','Ð’ÑÐµ ÐžÑ‚ÐºÑ€Ð¾Ð¹Ñ‚Ðµ Ð´Ð»Ñ ÑÐµÐ±Ñ',0),(581434,16151,'es','Todos descubrir',0),(581435,16151,'de','Alle entdecken',0),(581436,16151,'en','All Discover',0),(581437,16152,'is','',0),(581438,16152,'dr','ØªÙ…Ø§Ù… Ù…Ø³ØªØ±Ú©Ø§Ø±Øª',0),(581439,16152,'pr','ØªÙ…Ø§Ù… Ù…Ø³ØªØ±Ú©Ø§Ø±Øª',0),(581440,16152,'tr','TÃ¼m MasterCard',0),(581441,16152,'pl','Wszystkie MasterCard',0),(581442,16152,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ MasterCard',0),(581443,16152,'ur','ØªÙ…Ø§Ù… Ù…Ø§Ø³Ù¹Ø± Ú©Ø§Ø±Úˆ',0),(581444,16152,'sr','Ð¡Ð²Ðµ ÐœÐ°ÑÑ‚ÐµÑ€Ð¦Ð°Ñ€Ð´',0),(581445,16152,'vi','Táº¥t cáº£ MasterCard',0),(581446,16152,'af','Alle MasterCard',0),(581447,16152,'ro','Toate MasterCard',0),(581448,16152,'et','KÃµik MasterCard',0),(581449,16152,'si','Vse MasterCard',0),(581450,16152,'ba','Semua MasterCard',0),(581451,16152,'nl','Alle MasterCard',0),(581452,16152,'fi','Kaikki MasterCard',0),(581453,16152,'no','Alle MasterCard',0),(581454,16152,'da','Alle MasterCard',0),(581455,16152,'ko','ëª¨ë“  ë§ˆìŠ¤í„°',0),(581456,16152,'he','×ž××¡×˜×¨×§××¨×“ ×›×œ',0),(581457,16152,'el','ÎŒÎ»Î± Ï„Î± MasterCard',0),(581458,16152,'zh','æ‰€æœ‰ä¸‡äº‹è¾¾',0),(581459,16152,'sv','Alla MasterCard',0),(581460,16152,'it','Tutte le MasterCard',0),(581461,16152,'tl','',0),(581462,16152,'th','à¸¡à¸²à¸ªà¹€à¸•à¸­à¸£à¹Œà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(581463,16152,'hi','à¤¸à¤­à¥€ à¤®à¤¾à¤¸à¥à¤Ÿà¤° à¤•à¤¾à¤°à¥à¤¡',0),(581464,16152,'ms','Semua MasterCard',0),(581465,16152,'ar','Ø¬Ù…ÙŠØ¹ Ù…Ø§Ø³ØªØ±ÙƒØ§Ø±Ø¯',0),(581466,16152,'fr','Tous les MasterCard',0),(581467,16152,'jp','ã™ã¹ã¦ã®ãƒžã‚¹ã‚¿ãƒ¼',0),(581468,16152,'pt','Todos MasterCard',0),(581469,16152,'ru','Ð’ÑÐµ MasterCard',0),(581470,16152,'es','MasterCard todos',0),(581471,16152,'de','Alle MasterCard',0),(581472,16152,'en','All MasterCard',0),(581473,16153,'is','',0),(581474,16153,'dr','ØªÙ…Ø§Ù… ÙˆÛŒØ²Ø§',0),(581475,16153,'pr','ØªÙ…Ø§Ù… ÙˆÛŒØ²Ø§',0),(581476,16153,'tr','TÃ¼m vize',0),(581477,16153,'pl','Wszystkie wizy',0),(581478,16153,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ Ð²Ð¸Ð·Ð¸',0),(581479,16153,'ur','ØªÙ…Ø§Ù… ÙˆÛŒØ²Ø§',0),(581480,16153,'sr','Ð¡Ð²Ð¸ Ð²Ð¸Ð·Ð°',0),(581481,16153,'vi','Táº¥t cáº£ Visa',0),(581482,16153,'af','Alle visum',0),(581483,16153,'ro','Toate Visa',0),(581484,16153,'et','KÃµik viisa',0),(581485,16153,'si','Vse Visa',0),(581486,16153,'ba','Semua Visa',0),(581487,16153,'nl','Alle Visa',0),(581488,16153,'fi','Kaikki Visa',0),(581489,16153,'no','Alle visum',0),(581490,16153,'da','Alle Visa',0),(581491,16153,'ko','ëª¨ë“  ë¹„ìž',0),(581492,16153,'he','×›×œ ×•×™×–×”',0),(581493,16153,'el','ÎŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Î¸ÎµÏ‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(581494,16153,'zh','æ‰€æœ‰ç­¾è¯',0),(581495,16153,'sv','Alla visum',0),(581496,16153,'it','Tutti i visti',0),(581497,16153,'tl','',0),(581498,16153,'th','à¸§à¸µà¸‹à¹ˆà¸²à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(581499,16153,'hi','à¤¸à¤­à¥€ à¤µà¥€à¤œà¤¾',0),(581500,16153,'ms','Semua Visa',0),(581501,16153,'ar','Ø¬Ù…ÙŠØ¹ Ø§Ù„ØªØ£Ø´ÙŠØ±Ø§Øª',0),(581502,16153,'fr','Tous les visas',0),(581503,16153,'jp','ã™ã¹ã¦ã®ãƒ“ã‚¶',0),(581504,16153,'pt','Todos os vistos',0),(581505,16153,'ru','Ð’ÑÐµ Ð²Ð¸Ð·Ñ‹',0),(581506,16153,'es','Visa todas',0),(581507,16153,'de','Alle Visa',0),(581508,16153,'en','All Visa',0),(581509,16154,'is','',0),(581510,16154,'dr','Ø­Ø³Ø§Ø¨ Ø¯Ø§Ø±Ø§ÛŒÛŒ Ø³Ù¾Ø±Ø¯Ù‡ GL ÙˆØ±ÙˆØ¯ÛŒ Ø±Ø§ Ù¾ÛŒØ¯Ø§ Ú©Ù†Ø¯',0),(581511,16154,'pr','Ø­Ø³Ø§Ø¨ Ø¯Ø§Ø±Ø§ÛŒÛŒ Ø³Ù¾Ø±Ø¯Ù‡ GL ÙˆØ±ÙˆØ¯ÛŒ Ø±Ø§ Ù¾ÛŒØ¯Ø§ Ú©Ù†Ø¯',0),(581512,16154,'tr','KÄ±ymet hesabÄ±na depozito GL giriÅŸ iÃ§in bulunamadÄ±',0),(581513,16154,'pl','Nie moÅ¼na odnaleÅºÄ‡ konta zasobÃ³w dla depozytu GL wpisu',0),(581514,16154,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð½Ð°Ð¼ÐµÑ€Ð¸ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð·Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ GL Ð·Ð°Ð¿Ð¸Ñ',0),(581515,16154,'ur','Ø¬Ù…Ø¹ Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ú©Û’ Ù„ÛŒÛ’ Ø§Ø«Ø§Ø«Û Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(581516,16154,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ ÐºÐ¾Ð½Ñ‚Ð¾ ÑÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð° Ð·Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐ°',0),(581517,16154,'vi','KhÃ´ng thá»ƒ tÃ¬m tháº¥y tÃ i khoáº£n tÃ i sáº£n Ä‘áº·t cá»c GL nháº­p',0),(581518,16154,'af','Kon nie bate rekening vir deposito GL inskrywing vind',0),(581519,16154,'ro','Nu am putut gÄƒsi contul activ pentru depozit GL intrare',0),(581520,16154,'et','Ei leidnud pÃµhivarakontot tagatisraha GL kandmiseks',0),(581521,16154,'si','Ni bilo mogoÄe najti sredstva raÄun za depozit GL vnos',0),(581522,16154,'ba','Tidak dapat menemukan aset Account untuk Deposit GL entri',0),(581523,16154,'nl','Konden niet vondst Asset Account voor storting GL Entry',0),(581524,16154,'fi','Ei lÃ¶ytÃ¤nyt Internet GL merkintÃ¤ tulotili',0),(581525,16154,'no','Finner ikke anleggsmiddelkonto For innskudd GL oppfÃ¸ring',0),(581526,16154,'da','Kunne ikke finde aktiv konto For depositum GL post',0),(581527,16154,'ko','ìžì‚° ê³„ì • ì˜ˆê¸ˆ GL í•­ëª©ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(581528,16154,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× ××ª ×”× ×›×¡ ×—×©×‘×•×Ÿ ×¤×™×§×“×•×Ÿ GL ×œ×›× ×™×¡×”',0),(581529,16154,'el','Î”ÎµÎ½ Î¼Ï€ÏŒÏÎµÏƒÎ± Î½Î± Î²ÏÏ‰ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î±Î³Î¯Î¿Ï… Î³Î¹Î± ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÎµÎ³Î³ÏÎ±Ï†Î® GL',0),(581530,16154,'zh','æ‰¾ä¸åˆ°èµ„äº§è´¦æˆ·å­˜æ¬¾ GL æ¡ç›®',0),(581531,16154,'sv','Kunde inte hitta tillgÃ¥ngskonto fÃ¶r insÃ¤ttning GL intrÃ¤de',0),(581532,16154,'it','Non riusciva a trovare Account di Asset per deposito GL voce',0),(581533,16154,'tl','',0),(581534,16154,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸šà¸±à¸à¸Šà¸µà¸ªà¸´à¸™à¸—à¸£à¸±à¸žà¸¢à¹Œà¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸à¹€à¸‡à¸´à¸™à¸£à¸²à¸¢à¸à¸²à¸£ GL',0),(581535,16154,'hi','à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤–à¤¾à¤¤à¥‡ à¤œà¤®à¤¾ GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(581536,16154,'ms','Tidak dapat mencari akaun aset untuk Deposit GL kemasukan',0),(581537,16154,'ar','ØªØ¹Ø°Ø± Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø­Ø³Ø§Ø¨ Ø§Ù„Ø£ØµÙˆÙ„ Ù„Ø¯Ø®ÙˆÙ„ GL Ø§Ù„Ø¥ÙŠØ¯Ø§Ø¹',0),(581538,16154,'fr','Compte dâ€™actif pour la saisie des dÃ©pÃ´ts GL est introuvable',0),(581539,16154,'jp','é é‡‘ GL ã‚¨ãƒ³ãƒˆãƒªã®è³‡ç”£ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(581540,16154,'pt','NÃ£o foi possÃ­vel encontrar ativos conta para depÃ³sito GL entrada',0),(581541,16154,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ ÑÑ‡ÐµÑ‚ Ð°ÐºÑ‚Ð¸Ð²Ð¾Ð² Ð´Ð»Ñ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° GL Ð²Ñ…Ð¾Ð´',0),(581542,16154,'es','No se pudo encontrar la cuenta de activo para entrada de GL de depÃ³sito',0),(581543,16154,'de','Anlagekonto fÃ¼r Kaution GL Eintrag konnte nicht gefunden werden.',0),(581544,16154,'en','Could Not Find Asset Account For Deposit GL Entry',0),(581545,16155,'is','',0),(581546,16155,'dr','ÙˆØ±ÙˆØ¯ÛŒ',0),(581547,16155,'pr','ÙˆØ±ÙˆØ¯ÛŒ',0),(581548,16155,'tr','Gelen',0),(581549,16155,'pl','PrzychodzÄ…ce',0),(581550,16155,'bg','Ð’Ñ…Ð¾Ð´ÑÑ‰Ð¸',0),(581551,16155,'ur','Ù…ÙˆØµÙˆÙ„Û',0),(581552,16155,'sr','Ð”Ð¾Ð»Ð°Ð·Ð½Ðµ',0),(581553,16155,'vi','CuoÃ¤c goÃ¯i Ã±eÃ¡n',0),(581554,16155,'af','Inkomende',0),(581555,16155,'ro','Intrare',0),(581556,16155,'et','Saabuva',0),(581557,16155,'si','Dohodni',0),(581558,16155,'ba','Masuk',0),(581559,16155,'nl','Inkomende',0),(581560,16155,'fi','Saapuva',0),(581561,16155,'no','Innkommende',0),(581562,16155,'da','IndgÃ¥ende',0),(581563,16155,'ko','ë“¤ì–´ì˜¤',0),(581564,16155,'he','× ×›× ×¡×•×ª',0),(581565,16155,'el','Î•Î¹ÏƒÎµÏÏ‡ÏŒÎ¼ÎµÎ½ÎµÏ‚',0),(581566,16155,'zh','ä¼ å…¥',0),(581567,16155,'sv','Inkommande',0),(581568,16155,'it','In arrivo',0),(581569,16155,'tl','',0),(581570,16155,'th','à¸‚à¸²à¹€à¸‚à¹‰à¸²',0),(581571,16155,'hi','à¤†à¤µà¤•',0),(581572,16155,'ms','Masuk',0),(581573,16155,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„ÙˆØ§Ø±Ø¯',0),(581574,16155,'fr','Entrants',0),(581575,16155,'jp','ç€ä¿¡',0),(581576,16155,'pt','Entrada',0),(581577,16155,'ru','Ð’Ñ…Ð¾Ð´ÑÑ‰Ð¸Ðµ',0),(581578,16155,'es','Entrada',0),(581579,16155,'de','Eingehende',0),(581580,16155,'en','Incoming',0),(581581,16156,'is','',0),(581582,16156,'dr','Ù…Ù‚Ø¯Ø§Ø± ÙˆØ±ÙˆØ¯ÛŒ Ø®Ø±ÙˆØ¬ÛŒ Ø¬ÙˆØ± Ù†ÛŒØ³Øª',0),(581583,16156,'pr','Ù…Ù‚Ø¯Ø§Ø± ÙˆØ±ÙˆØ¯ÛŒ Ø®Ø±ÙˆØ¬ÛŒ Ø¬ÙˆØ± Ù†ÛŒØ³Øª',0),(581584,16156,'tr','Gelen miktar giden eÅŸleÅŸmiyor',0),(581585,16156,'pl','PrzychodzÄ…ce kwota nie jest zgodny, wychodzÄ…cych',0),(581586,16156,'bg','Ð’Ñ…Ð¾Ð´ÑÑ‰Ð¸ ÑÑƒÐ¼Ð° Ð½Ðµ ÑÑŠÐ²Ð¿Ð°Ð´Ð° Ñ Ð¸Ð·Ñ…Ð¾Ð´ÑÑ‰Ð¸',0),(581587,16156,'ur','Ø¢Ù†Û’ ÙˆØ§Ù„ÛŒ Ø±Ù‚Ù… Ù…Ø±Ø³Ù„Û Ø³Û’ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº',0),(581588,16156,'sr','Ð”Ð¾Ð»Ð°Ð·Ð½Ð¸ Ð¸Ð·Ð½Ð¾Ñ ÑÐµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐ° Ð¾Ð´Ð»Ð°Ð·ÐµÑ›Ð¸',0),(581589,16156,'vi','Äáº¿n sá»‘ tiá»n khÃ´ng phÃ¹ há»£p vá»›i Ä‘i',0),(581590,16156,'af','Inkomende bedrag ooreen nie uitgaande',0),(581591,16156,'ro','Valoarea de intrare nu se potriveÅŸte Ã®ÅŸi Ã®nceteazÄƒ activitatea',0),(581592,16156,'et','Sissetuleva summa ei sobi vÃ¤ljaminev',0),(581593,16156,'si','Dohodne znesek ujema izhodne',0),(581594,16156,'ba','Jumlah masuk tidak cocok keluar',0),(581595,16156,'nl','Binnenkomende bedrag komt niet overeen met de uitgaande',0),(581596,16156,'fi','Saapuvien mÃ¤Ã¤rÃ¤ ei vastaa lÃ¤htevÃ¤n',0),(581597,16156,'no','Innkommende belÃ¸p tilsvarer ikke utgÃ¥ende',0),(581598,16156,'da','IndgÃ¥ende belÃ¸b stemmer ikke overens med udgÃ¥ende',0),(581599,16156,'ko','ë“¤ì–´ì˜¤ëŠ” ê¸ˆì•¡ ë³´ë‚´ëŠ” ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(581600,16156,'he','×›×ž×•×ª ×”× ×›× ×¡×™× ××™× ×” ×ª×•××ž×ª ×”×™×•×¦×',0),(581601,16156,'el','Î•Î¹ÏƒÎµÏÏ‡ÏŒÎ¼ÎµÎ½ÎµÏ‚ Ï€Î¿ÏƒÏŒ Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ ÎµÎ¾ÎµÏÏ‡ÏŒÎ¼ÎµÎ½ÎµÏ‚',0),(581602,16156,'zh','ä¼ å…¥çš„é‡‘é¢ä¸ç¬¦ä¼ å‡º',0),(581603,16156,'sv','Inkommande belopp matchar inte utgÃ¥ende',0),(581604,16156,'it','Importo in entrata non corrisponde in uscita',0),(581605,16156,'tl','',0),(581606,16156,'th','à¹€à¸‚à¹‰à¸²à¸¡à¸²à¸ˆà¸³à¸™à¸§à¸™à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸‚à¸²à¸­à¸­à¸',0),(581607,16156,'hi','à¤†à¤µà¤• à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤œà¤¾à¤µà¤• à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(581608,16156,'ms','Jumlah yang masuk tidak sepadan dengan Keluar',0),(581609,16156,'ar','Ù„Ø§ ÙŠØ·Ø§Ø¨Ù‚ Ø§Ù„Ù…Ø¨Ù„Øº Ø§Ù„ÙˆØ§Ø±Ø¯ Ø§Ù„ØµØ§Ø¯Ø±',0),(581610,16156,'fr','Montant entrant ne correspond pas sortant',0),(581611,16156,'jp','å—ä¿¡é‡ãŒç™ºä¿¡ã¨ä¸€è‡´ã—ã¾ã›ã‚“',0),(581612,16156,'pt','Quantidade de entrada nÃ£o corresponde a saÃ­da',0),(581613,16156,'ru','Ð’Ñ…Ð¾Ð´ÑÑ‰ÐµÐµ ÑÑƒÐ¼Ð¼Ð° Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¸ÑÑ…Ð¾Ð´ÑÑ‰Ð¸Ðµ',0),(581614,16156,'es','Cantidad entrante no coincide con la salida',0),(581615,16156,'de','Eingehenden Betrag entspricht nicht ausgehende',0),(581616,16156,'en','Incoming Amount Does Not Match Outgoing',0),(581617,16157,'is','',0),(581618,16157,'dr','Ø´Ø§Ø±Ú˜ Ø­Ø³Ø§Ø¨ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(581619,16157,'pr','Ø´Ø§Ø±Ú˜ Ø­Ø³Ø§Ø¨ Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ',0),(581620,16157,'tr','Kredi kartÄ± Ã¶deme yapmak',0),(581621,16157,'pl','Dokonaj wpÅ‚aty kartÄ… kredytowÄ…',0),(581622,16157,'bg','ÐÐ°Ð¿Ñ€Ð°Ð²ÐµÑ‚Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(581623,16157,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø¬Ù…Ø¹ Ú©Ø±ÛŒÚº',0),(581624,16157,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¼ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð¾Ð¼',0),(581625,16157,'vi','HÃ£y gá»­i tiá»n tháº» tÃ­n dá»¥ng',0),(581626,16157,'af','Kredietkaart deposito maak',0),(581627,16157,'ro','Depozit de carte de Credit',0),(581628,16157,'et','Teha krediitkaardi deposiit',0),(581629,16157,'si','Depozit kreditna kartica',0),(581630,16157,'ba','Membuat Deposit kartu kredit',0),(581631,16157,'nl','Credit Card storting',0),(581632,16157,'fi','Luottokortti talletuksen',0),(581633,16157,'no','GjÃ¸r kredittkort innskudd',0),(581634,16157,'da','GÃ¸re kreditkort indbetaling',0),(581635,16157,'ko','ì‹ ìš© ì¹´ë“œ ìž…ê¸ˆ',0),(581636,16157,'he','×›×¨×˜×™×¡ ××©×¨××™ ×”×”×¤×§×“×”',0),(581637,16157,'el','ÎšÎ¬Î½ÎµÎ¹ ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(581638,16157,'zh','è®©ä¿¡ç”¨å¡å­˜æ¬¾',0),(581639,16157,'sv','GÃ¶r insÃ¤ttning med kredit',0),(581640,16157,'it','Rendere il deposito con carta di credito',0),(581641,16157,'tl','',0),(581642,16157,'th','à¸à¸²à¸à¹€à¸‡à¸´à¸™à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(581643,16157,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤œà¤®à¤¾ à¤•à¤°à¥‡à¤‚',0),(581644,16157,'ms','Membuat Deposit kad kredit',0),(581645,16157,'ar','Ø¥ÙŠØ¯Ø§Ø¹ Ø¨Ø·Ø§Ù‚Ø© Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù†',0),(581646,16157,'fr','Faire dÃ©pÃ´t de carte de crÃ©dit',0),(581647,16157,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®é é‡‘ã‚’ã—ã¾ã™ã€‚',0),(581648,16157,'pt','FaÃ§a o depÃ³sito de cartÃ£o de crÃ©dito',0),(581649,16157,'ru','Ð¡Ð´ÐµÐ»Ð°Ñ‚ÑŒ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹',0),(581650,16157,'es','Hacer depÃ³sito de tarjeta de crÃ©dito',0),(581651,16157,'de','Einzahlung per Kreditkarte zu machen',0),(581652,16157,'en','Make Credit Card Deposit',0),(581653,16158,'is','',0),(581654,16158,'dr','Ø¨Ø¯ÙˆÙ† Ø´Ø±Ø­',0),(581655,16158,'pr','Ø¨Ø¯ÙˆÙ† Ø´Ø±Ø­',0),(581656,16158,'tr','AÃ§Ä±klama yok',0),(581657,16158,'pl','Brak opisu',0),(581658,16158,'bg','ÐÑÐ¼Ð° Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(581659,16158,'ur','Ú©ÙˆØ¦ÛŒ ØªØµØ±ÛŒØ­',0),(581660,16158,'sr','Ð‘ÐµÐ· Ð¾Ð¿Ð¸ÑÐ°',0),(581661,16158,'vi','KhÃ´ng cÃ³ mÃ´ táº£',0),(581662,16158,'af','Geen beskrywing',0),(581663,16158,'ro','Nici o descriere',0),(581664,16158,'et','Kirjeldust pole',0),(581665,16158,'si','Ni opis',0),(581666,16158,'ba','Tidak ada Deskripsi',0),(581667,16158,'nl','Geen beschrijving',0),(581668,16158,'fi','Ei kuvausta',0),(581669,16158,'no','Ingen beskrivelse',0),(581670,16158,'da','Ingen beskrivelse',0),(581671,16158,'ko','ì—†ìŒ ì„¤ëª…',0),(581672,16158,'he','××™×Ÿ ×ª×™××•×¨',0),(581673,16158,'el','ÎšÎ±Î¼Î¯Î± Î ÎµÏÎ¹Î³ÏÎ±Ï†Î®',0),(581674,16158,'zh','æ²¡æœ‰è¯´æ˜Ž',0),(581675,16158,'sv','Ingen beskrivning',0),(581676,16158,'it','Nessuna descrizione',0),(581677,16158,'tl','',0),(581678,16158,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢',0),(581679,16158,'hi','à¤•à¥‹à¤ˆ à¤µà¤°à¥à¤£à¤¨ à¤¨à¤¹à¥€à¤‚',0),(581680,16158,'ms','Tiada Perihalan',0),(581681,16158,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ ÙˆØµÙ',0),(581682,16158,'fr','Aucune Description',0),(581683,16158,'jp','èª¬æ˜Žã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(581684,16158,'pt','Sem descriÃ§Ã£o',0),(581685,16158,'ru','ÐÐµÑ‚ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ñ',0),(581686,16158,'es','No hay descripciÃ³n',0),(581687,16158,'de','Keine Beschreibung',0),(581688,16158,'en','No Description',0),(581689,16159,'is','',0),(581690,16159,'dr','Ø®Ø±ÙˆØ¬ÛŒ',0),(581691,16159,'pr','Ø®Ø±ÙˆØ¬ÛŒ',0),(581692,16159,'tr','Giden',0),(581693,16159,'pl','WychodzÄ…cych',0),(581694,16159,'bg','Ð˜Ð·Ñ…Ð¾Ð´ÑÑ‰Ð¸',0),(581695,16159,'ur','Ù…Ø±Ø³Ù„Û',0),(581696,16159,'sr','ÐžÐ´Ð»Ð°Ð·ÐµÑ›Ð¸',0),(581697,16159,'vi','Gá»­i Ä‘i',0),(581698,16159,'af','Uitgaande',0),(581699,16159,'ro','IeÅŸire',0),(581700,16159,'et','VÃ¤ljaminev',0),(581701,16159,'si','Odhodne',0),(581702,16159,'ba','Keluar',0),(581703,16159,'nl','Uitgaande',0),(581704,16159,'fi','LÃ¤htevÃ¤',0),(581705,16159,'no','UtgÃ¥ende',0),(581706,16159,'da','UdgÃ¥ende',0),(581707,16159,'ko','ë‚˜ê°€ëŠ”',0),(581708,16159,'he','×™×•×¦××•×ª',0),(581709,16159,'el','Î•Î¾ÎµÏÏ‡ÏŒÎ¼ÎµÎ½Î·',0),(581710,16159,'zh','ä¼ å‡º',0),(581711,16159,'sv','UtgÃ¥ende',0),(581712,16159,'it','In uscita',0),(581713,16159,'tl','',0),(581714,16159,'th','à¸‚à¸²à¸­à¸­à¸',0),(581715,16159,'hi','à¤œà¤¾à¤µà¤•',0),(581716,16159,'ms','Keluar',0),(581717,16159,'ar','Ø§Ù„Ø±Ø³Ø§Ø¦Ù„ Ø§Ù„ØµØ§Ø¯Ø±Ø©',0),(581718,16159,'fr','Sortants',0),(581719,16159,'jp','ç™ºä¿¡',0),(581720,16159,'pt','SaÃ­da',0),(581721,16159,'ru','Ð˜ÑÑ…Ð¾Ð´ÑÑ‰Ð¸Ðµ',0),(581722,16159,'es','Saliente',0),(581723,16159,'de','Ausgehende',0),(581724,16159,'en','Outgoing',0),(581725,16160,'is','',0),(581726,16160,'dr','Ù„Ø·ÙØ§ ØªØºÛŒÛŒØ± Ø­Ø³Ø§Ø¨ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§ÛŒÛŒ',0),(581727,16160,'pr','Ù„Ø·ÙØ§ ØªØºÛŒÛŒØ± Ø­Ø³Ø§Ø¨ Ø³Ù¾Ø±Ø¯Ù‡ Ø¨Ù‡ Ø­Ø³Ø§Ø¨ Ù†ÙˆØ¹ Ø¯Ø§Ø±Ø§ÛŒÛŒ',0),(581728,16160,'tr','LÃ¼tfen mevduat hesabÄ± bir kÄ±ymet tÃ¼rÃ¼ hesabÄ±na deÄŸiÅŸtirme',0),(581729,16160,'pl','ProszÄ™ zmieniÄ‡ konto depozytu na koncie typu aktywÃ³w',0),(581730,16160,'bg','ÐœÐ¾Ð»Ñ, Ð¿Ñ€Ð¾Ð¼ÐµÐ½ÐµÑ‚Ðµ Ð½Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ð°Ñ‚Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð°ÐºÑ‚Ð¸Ð² Ñ‚Ð¸Ð¿ Ð°ÐºÐ°ÑƒÐ½Ñ‚',0),(581731,16160,'ur','Ø¬Ù…Ø¹ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ø§Ø«Ø§Ø«Û Ù‚Ø³Ù… Ø§Ú©Ø§Ø¤Ù†Ù¹ ØªØ¨Ø¯ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(581732,16160,'sr','ÐŸÑ€Ð¾Ð¼Ð¸Ñ˜ÐµÐ½Ð¸Ñ‚Ðµ Ð½Ð° Ñ€Ð°Ñ‡ÑƒÐ½ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð½Ð° ÑÑ€ÐµÐ´ÑÑ‚Ð²Ð¾ Ñ‚Ð¸Ð¿ Ð½Ð°Ð»Ð¾Ð³',0),(581733,16160,'vi','HÃ£y thay Ä‘á»•i tÃ i khoáº£n tiá»n gá»­i vÃ o tÃ i khoáº£n loáº¡i tÃ i sáº£n',0),(581734,16160,'af','Verander asseblief die deposito rekening na \'n bate-tipe rekening',0),(581735,16160,'ro','VÄƒ rugÄƒm sÄƒ schimbaÅ£i cont de depozit la un cont de active de tip',0),(581736,16160,'et','Palun muutke pangaarvele arvele varade liik',0),(581737,16160,'si','Spremenite depozitni raÄun na raÄun, vrsta sredstva',0),(581738,16160,'ba','Ubah Deposit Account ke Account jenis aset',0),(581739,16160,'nl','Gelieve te veranderen de deposito-rekeningen in een actief Type Account',0),(581740,16160,'fi','Vaihda rahaa tilille kÃ¤yttÃ¶omaisuustilille tyyppi',0),(581741,16160,'no','Endre innskudd konto til en eiendelskonto Type',0),(581742,16160,'da','Venligst Ã¦ndre kontoen til en konto for aktiver Type',0),(581743,16160,'ko','ìœ í˜• ìžì‚° ê³„ì •ì— ì˜ˆê¸ˆ ê³„ì¢Œë¥¼ ë³€ê²½ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(581744,16160,'he','×‘×‘×§×©×” ×œ×©× ×•×ª ××ª ×—×©×‘×•×Ÿ ×”×¤×§×“×” ×œ×—×©×‘×•×Ÿ ×¡×•×’ × ×›×¡',0),(581745,16160,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î½Î± Î±Î»Î»Î¬Î¾ÎµÏ„Îµ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ ÎºÎ±Ï„Î±Î¸Î­ÏƒÎµÏ‰Î½ Î½Î± Ï€ÎµÏÎ¹Î¿Ï…ÏƒÎ¹Î±ÎºÏŒ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¤ÏÏ€Î¿Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(581746,16160,'zh','è¯·å°†å­˜æ¬¾å¸æˆ·æ›´æ”¹ä¸ºèµ„äº§ç±»åž‹çš„å¸æˆ·',0),(581747,16160,'sv','VÃ¤nligen Ã¤ndra inlÃ¥ningskonto pÃ¥ ett tillgÃ¥ngskonto fÃ¶r typ',0),(581748,16160,'it','Si prega di cambiare il conto di deposito a un conto del tipo di attivitÃ ',0),(581749,16160,'tl','',0),(581750,16160,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸šà¸±à¸à¸Šà¸µà¹€à¸‡à¸´à¸™à¸à¸²à¸à¸šà¸±à¸à¸Šà¸µà¸›à¸£à¸°à¹€à¸ à¸—à¸ªà¸´à¸™à¸—à¸£à¸±à¸žà¸¢à¹Œ',0),(581751,16160,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤¸à¤‚à¤ªà¤¤à¥à¤¤à¤¿ à¤ªà¥à¤°à¤•à¤¾à¤° à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤®à¤¾ à¤–à¤¾à¤¤à¤¾ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(581752,16160,'ms','Sila tukar akaun Deposit ke akaun jenis aset',0),(581753,16160,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØºÙŠÙŠØ± Ø­Ø³Ø§Ø¨ Ø¥ÙŠØ¯Ø§Ø¹ Ù„Ø­Ø³Ø§Ø¨ Ù†ÙˆØ¹ Ø§Ù„Ø£ØµÙˆÙ„',0),(581754,16160,'fr','Veuillez changer le compte de dÃ©pÃ´t Ã  un compte de Type dâ€™actif',0),(581755,16160,'jp','è³‡ç”£ã®ç¨®é¡žã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã«é é‡‘å£åº§ã‚’å¤‰æ›´ã—ã¦ãã ã•ã„ã€‚',0),(581756,16160,'pt','Por favor, altere a conta de depÃ³sito para uma conta do tipo de activo',0),(581757,16160,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ Ð½Ð° ÑÑ‡ÐµÑ‚ Ñ‚Ð¸Ð¿Ð° Ð°ÐºÑ‚Ð¸Ð²Ð¾Ð²',0),(581758,16160,'es','Por favor, cambia la cuenta de depÃ³sito a una cuenta del tipo de activo',0),(581759,16160,'de','Bitte Ã¤ndern Sie das Depot auf ein Anlagenkonto Typ',0),(581760,16160,'en','Please Change The Deposit Account To An Asset Type Account',0),(581761,16161,'is','',0),(581762,16161,'dr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø³Ù¾Ø±Ø¯Ù‡',0),(581763,16161,'pr','Ú©Ø§Ø±Øª Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø³Ù¾Ø±Ø¯Ù‡',0),(581764,16161,'tr','Kredi kartÄ± para yatÄ±rma',0),(581765,16161,'pl','WpÅ‚aty kartÄ… kredytowÄ…',0),(581766,16161,'bg','Ð”ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð°',0),(581767,16161,'ur','Ú©Ø±ÛŒÚˆÙ¹ Ú©Ø§Ø±Úˆ Ø¬Ù…Ø¹',0),(581768,16161,'sr','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð°',0),(581769,16161,'vi','Tháº» tÃ­n dá»¥ng khoáº£n tiá»n gá»­i',0),(581770,16161,'af','Kredietkaart deposito',0),(581771,16161,'ro','Depozit cu Card de credit',0),(581772,16161,'et','Krediitkaardi tagatisraha',0),(581773,16161,'si','Depozit kreditna kartica',0),(581774,16161,'ba','Deposit kartu kredit',0),(581775,16161,'nl','Credit Card storting',0),(581776,16161,'fi','Luottokortti',0),(581777,16161,'no','Kredittkort innskudd',0),(581778,16161,'da','Kreditkort indbetaling',0),(581779,16161,'ko','ì‹ ìš© ì¹´ë“œ ë³´ì¦ê¸ˆ',0),(581780,16161,'he','×”×¤×§×“×” ×‘×›×¨×˜×™×¡ ××©×¨××™',0),(581781,16161,'el','ÎšÎ±Ï„Î¬Î¸ÎµÏƒÎ· Î¼Îµ Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ® ÎºÎ¬ÏÏ„Î±',0),(581782,16161,'zh','ä¿¡ç”¨å¡å­˜æ¬¾',0),(581783,16161,'sv','Deposition frÃ¥n ditt kreditkort',0),(581784,16161,'it','Deposito con carta di credito',0),(581785,16161,'tl','',0),(581786,16161,'th','à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸šà¸±à¸•à¸£à¹€à¸„à¸£à¸”à¸´à¸•',0),(581787,16161,'hi','à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¤¾à¤°à¥à¤¡ à¤œà¤®à¤¾',0),(581788,16161,'ms','Deposit kad kredit',0),(581789,16161,'ar','Ø¨Ø·Ø§Ù‚Ø© Ø§Ø¦ØªÙ…Ø§Ù†',0),(581790,16161,'fr','DÃ©pÃ´t de carte de crÃ©dit',0),(581791,16161,'jp','ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ ã‚«ãƒ¼ãƒ‰ã®ãƒ‡ãƒã‚¸ãƒƒãƒˆ',0),(581792,16161,'pt','DepÃ³sito de cartÃ£o de crÃ©dito',0),(581793,16161,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ð½Ð¾Ð¹ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚',0),(581794,16161,'es','DepÃ³sito con tarjeta de crÃ©dito',0),(581795,16161,'de','Einzahlung per Kreditkarte',0),(581796,16161,'en','Credit Card Deposit',0),(581797,16162,'is','',0),(581798,16162,'dr','Ù‡Ù†ÙˆØ² Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø±',0),(581799,16162,'pr','Ù‡Ù†ÙˆØ² Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ø¨Ø±Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ú©ØªØ§Ø¨Ú†Ù‡ Ø±Ø§Ù‡Ù†Ù…Ø§ÛŒ Ú©Ø§Ø±Ø¨Ø±',0),(581800,16162,'tr','El ile iÅŸleme iÃ§in gerekli deÄŸildir',0),(581801,16162,'pl','Nie potrzebne do rÄ™cznego przetwarzania',0),(581802,16162,'bg','ÐÐµ ÑÐ° Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸ Ð·Ð° Ñ€ÑŠÑ‡Ð½Ð° Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ°',0),(581803,16162,'ur','Ø¯Ø³ØªÛŒ Ù¾Ø±ÙˆØ³ÛŒØ³Ù†Ú¯ Ú©Û’ Ù„Ø¦Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª Ù†ÛÛŒÚº',0),(581804,16162,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð·Ð° Ð ÑƒÑ‡Ð½Ð° Ð¾Ð±Ñ€Ð°Ð´Ð°',0),(581805,16162,'vi','KhÃ´ng cáº§n hÆ°á»›ng dáº«n sá»­ dá»¥ng cháº¿ biáº¿n',0),(581806,16162,'af','Nie nodig vir handleiding verwerking',0),(581807,16162,'ro','Nu este necesar pentru prelucrarea manualÄƒ',0),(581808,16162,'et','Ei ole vaja kÃ¤sitsi tÃ¶Ã¶tlemiseks',0),(581809,16162,'si','Ni potrebna za roÄna obdelava',0),(581810,16162,'ba','Tidak diperlukan untuk Manual pengolahan',0),(581811,16162,'nl','Niet nodig voor handmatige verwerking',0),(581812,16162,'fi','Ei tarvita manuaalinen kÃ¤sittely',0),(581813,16162,'no','Ikke nÃ¸dvendig For manuell behandling',0),(581814,16162,'da','Ikke nÃ¸dvendig til manuel behandling',0),(581815,16162,'ko','ìˆ˜ë™ ì²˜ë¦¬ì— ëŒ€ í•œ í•„ìš” í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(581816,16162,'he','××™×Ÿ ×¦×•×¨×š ×¢×‘×•×¨ ×¢×™×‘×•×“ ×™×“× ×™',0),(581817,16162,'el','Î“Î¹Î± Î¼Î· Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±, Î´ÎµÎ½ Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(581818,16162,'zh','ä¸éœ€è¦æ‰‹åŠ¨å¤„ç†',0),(581819,16162,'sv','Inte behÃ¶vs fÃ¶r manuell bearbetning',0),(581820,16162,'it','Non necessaria per l\'elaborazione manuale',0),(581821,16162,'tl','',0),(581822,16162,'th','à¹„à¸¡à¹ˆà¸ˆà¸³à¹€à¸›à¹‡à¸™à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸—à¸³à¸‡à¸²à¸™',0),(581823,16162,'hi','à¤®à¥ˆà¤¨à¥à¤…à¤² à¤ªà¥à¤°à¤¸à¤‚à¤¸à¥à¤•à¤°à¤£ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¨à¤¹à¥€à¤‚',0),(581824,16162,'ms','Tidak diperlukan untuk memproses secara Manual',0),(581825,16162,'ar','Ù„ÙŠØ³Øª Ù‡Ù†Ø§Ùƒ Ø­Ø§Ø¬Ø© Ù„Ù„Ù…Ø¹Ø§Ù„Ø¬Ø© Ø§Ù„ÙŠØ¯ÙˆÙŠØ©',0),(581826,16162,'fr','Pas nÃ©cessaire pour le traitement manuel',0),(581827,16162,'jp','æ‰‹å‹•å‡¦ç†ã®ãŸã‚ä¸è¦',0),(581828,16162,'pt','NÃ£o Ã© necessÃ¡rio para o processamento Manual',0),(581829,16162,'ru','ÐÐµ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð´Ð»Ñ Ñ€ÑƒÑ‡Ð½Ð¾Ð¹ Ð¾Ð±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ¸',0),(581830,16162,'es','No es necesario para el procesamiento Manual',0),(581831,16162,'de','Nicht erforderlich fÃ¼r die manuelle Verarbeitung',0),(581832,16162,'en','Not Needed For Manual Processing',0),(581833,16163,'is','',0),(581834,16163,'dr','ÙÙ‚Ø· Ø§Ú¯Ø± ÙˆØ§Ø±Ø¯ Ù‡ÛŒÚ† Ø´Ù…Ø§Ø±Ù‡ Ú©Ø§Ø±Øª Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(581835,16163,'pr','ÙÙ‚Ø· Ø§Ú¯Ø± ÙˆØ§Ø±Ø¯ Ù‡ÛŒÚ† Ø´Ù…Ø§Ø±Ù‡ Ú©Ø§Ø±Øª Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(581836,16163,'tr','HiÃ§bir kart numarasÄ±nÄ± girdiyseniz sadece gerekli',0),(581837,16163,'pl','Wymagany tylko, jeÅ›li nie ma numer karty',0),(581838,16163,'bg','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼ Ðµ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ Ð½ÑÐ¼Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° ÐºÐ°Ñ€Ñ‚Ð° Ð²Ð¿Ð¸ÑÐ²Ð°Ñ‚',0),(581839,16163,'ur','Ø§Ú¯Ø± Ú©ÙˆØ¦ÛŒ Ú©Ø§Ø±Úˆ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©ÛŒØ§ ØµØ±Ù Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(581840,16163,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð°Ð½ Ñ˜Ðµ ÑÐ°Ð¼Ð¾ Ð°ÐºÐ¾ ÑÑ‚Ðµ ÑƒÐ½ÐµÐ»Ð¸ Ð½ÐµÐ¼Ð° Ð±Ñ€Ð¾Ñ˜ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ðµ',0),(581841,16163,'vi','Chá»‰ cáº§n thiáº¿t náº¿u khÃ´ng cÃ³ sá»‘ tháº» nháº­p',0),(581842,16163,'af','Slegs nodig Indien geen kaart nommer ingetik',0),(581843,16163,'ro','NecesarÄƒ numai Ã®n cazul Ã®n care nici un numÄƒr de Card introdus',0),(581844,16163,'et','Vaja ainult siis, kui puudub kaardi Number',0),(581845,16163,'si','Samo Äe vpisana Å¡tevilka kartice je potrebno',0),(581846,16163,'ba','Hanya diperlukan jika tidak ada nomor kartu masuk',0),(581847,16163,'nl','Alleen nodig als geen kaartnummer ingevoerd',0),(581848,16163,'fi','Tarvitaan vain, jos ei numero',0),(581849,16163,'no','Bare nÃ¸dvendig hvis ingen kortnummeret angitt',0),(581850,16163,'da','Kun nÃ¸dvendig, hvis ingen kortnummer ind',0),(581851,16163,'ko','ì¹´ë“œ ë²ˆí˜¸ ìž…ë ¥ í•˜ëŠ” ê²½ìš°ì— í•„ìš”',0),(581852,16163,'he','× ×—×•×¥ ×¨×§ ×× ×ž×¡×¤×¨ ×›×¨×˜×™×¡ ×œ× × ×›× ×¡',0),(581853,16163,'el','Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Î¼ÏŒÎ½Î¿ Î±Î½ Î´ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¬ÏÏ„Î±Ï‚ ÎµÎ¹ÏƒÎ±Ï‡Î¸ÎµÎ¯',0),(581854,16163,'zh','åªéœ€è¦å¦‚æžœæ²¡æœ‰å¡å·è¾“å…¥',0),(581855,16163,'sv','BehÃ¶vs endast om inga kortnummer trÃ¤dde',0),(581856,16163,'it','Necessaria solo se nessun numero di carta inserito',0),(581857,16163,'tl','',0),(581858,16163,'th','à¸ˆà¸³à¹€à¸›à¹‡à¸™à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™ à¸–à¹‰à¸²à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸•à¸£à¹„à¸¡à¹ˆà¸¡à¸µ',0),(581859,16163,'hi','à¤¯à¤¦à¤¿ à¤•à¥‹à¤ˆ à¤•à¤¾à¤°à¥à¤¡ à¤¨à¤‚à¤¬à¤° à¤¦à¤°à¥à¤œ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤•à¥‡à¤µà¤² à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(581860,16163,'ms','Hanya diperlukan jika tiada nombor Kad dimasukkan',0),(581861,16163,'ar','ØªØ­ØªØ§Ø¬ Ø¥Ù„ÙŠÙ‡ ÙÙ‚Ø· Ø¥Ø°Ø§ Ø¯Ø®Ù„Øª Ù„Ø§ Ø±Ù‚Ù… Ø¨Ø·Ø§Ù‚Ø©',0),(581862,16163,'fr','NÃ©cessaire seulement si aucun numÃ©ro de carte nâ€™entrÃ©',0),(581863,16163,'jp','ã‚«ãƒ¼ãƒ‰ç•ªå·ãŒå…¥åŠ›ã•ã‚Œã¦ã„ãªã„å ´åˆã«ã®ã¿å¿…è¦',0),(581864,16163,'pt','SÃ³ precisava se nenhum nÃºmero de cartÃ£o inserido',0),(581865,16163,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ñ‚Ð¾Ð»ÑŒÐºÐ¾, ÐµÑÐ»Ð¸ Ð½ÐµÑ‚ ÐºÐ°Ñ€Ñ‚Ñ‹ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾',0),(581866,16163,'es','SÃ³lo es necesario si No nÃºmero de tarjeta introducido',0),(581867,16163,'de','Nur erforderlich, wenn keine Kartennummer eingegeben',0),(581868,16163,'en','Only Needed If No Card Number Entered',0),(581869,16164,'is','',0),(581870,16164,'dr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(581871,16164,'pr','Ø³ÙØ§Ø±Ø´ Ø¨Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(581872,16164,'tr','Fatura iÃ§in sipariÅŸ',0),(581873,16164,'pl','ZamÃ³wienia do faktury',0),(581874,16164,'bg','ÐŸÐ¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(581875,16164,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ±ØªÛŒØ¨',0),(581876,16164,'sr','ÐÐ°Ð»Ð¾Ð³ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸ÑÐ°ÑšÐµ',0),(581877,16164,'vi','Äá»ƒ hÃ³a Ä‘Æ¡n',0),(581878,16164,'af','Bevel om die faktuur',0),(581879,16164,'ro','ComandÄƒ la facturÄƒ',0),(581880,16164,'et','Tellimuse arve',0),(581881,16164,'si','Nalog za raÄun',0),(581882,16164,'ba','Agar faktur',0),(581883,16164,'nl','Bestellen op factuur',0),(581884,16164,'fi','Jotta lasku',0),(581885,16164,'no','For faktura',0),(581886,16164,'da','Ordre til faktura',0),(581887,16164,'ko','ì†¡ìž¥ì—ëŠ” ì£¼ë¬¸',0),(581888,16164,'he','×ž× ×ª ×—×©×‘×•× ×™×ª',0),(581889,16164,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±, Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(581890,16164,'zh','è®¢å•åˆ°å‘ç¥¨',0),(581891,16164,'sv','Order till faktura',0),(581892,16164,'it','Ordine a fattura',0),(581893,16164,'tl','',0),(581894,16164,'th','à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(581895,16164,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶',0),(581896,16164,'ms','Perintah invois',0),(581897,16164,'ar','ØªØ±ØªÙŠØ¨ Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(581898,16164,'fr','Ordre de facture',0),(581899,16164,'jp','è«‹æ±‚æ›¸ã«æ³¨æ–‡',0),(581900,16164,'pt','Ordem de factura',0),(581901,16164,'ru','Ð—Ð°ÐºÐ°Ð· ÑÑ‡ÐµÑ‚Ð°',0),(581902,16164,'es','Pedido a factura',0),(581903,16164,'de','Bestellung auf Rechnung',0),(581904,16164,'en','Order To Invoice',0),(581905,16165,'is','',0),(581906,16165,'dr','Ú©Ø¯Ù‡Ø§ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø³Øª',0),(581907,16165,'pr','Ú©Ø¯Ù‡Ø§ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø³Øª',0),(581908,16165,'tr','KodlarÄ± maliyeti vardÄ±r',0),(581909,16165,'pl','KosztowaÅ‚a kody',0),(581910,16165,'bg','Ð• ÑÑ‚Ñ€ÑƒÐ²Ð°Ð»Ð¾ ÐºÐ¾Ð´Ð¾Ð²Ðµ',0),(581911,16165,'ur','Ø±Ù…ÙˆØ² Ú©Ùˆ Ø¨Ú¾Ø§Ø±ÛŒ Ù†Ù‚ØµØ§Ù† Ø§ÙÙ¹Ú¾Ø§Ù†Ø§ Ù¾Ú‘Ø§',0),(581912,16165,'sr','ÐšÐ¾ÑˆÑ‚Ð°Ð¾ Ñ˜Ðµ ÑˆÐ¸Ñ„Ñ€Ðµ',0),(581913,16165,'vi','CÃ³ chi phÃ­ mÃ£',0),(581914,16165,'af','Kodes het kos',0),(581915,16165,'ro','A costat coduri',0),(581916,16165,'et','Maksis koodid',0),(581917,16165,'si','Je stroÅ¡ek kode',0),(581918,16165,'ba','Biaya kode',0),(581919,16165,'nl','Codes heeft gekost',0),(581920,16165,'fi','On maksanut koodit',0),(581921,16165,'no','Har kostet koder',0),(581922,16165,'da','Har kostet koder',0),(581923,16165,'ko','ë¹„ìš© ì½”ë“œ',0),(581924,16165,'he','×¢×œ×” ×§×•×“×™×',0),(581925,16165,'el','ÎˆÏ‡ÎµÎ¹ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎµÏ‚',0),(581926,16165,'zh','æœ‰æˆæœ¬ä»£ç ',0),(581927,16165,'sv','Har kostat koder',0),(581928,16165,'it','Ha i codici dei costi',0),(581929,16165,'tl','',0),(581930,16165,'th','à¸¡à¸µà¸•à¹‰à¸™à¸—à¸¸à¸™à¸£à¸«à¸±à¸ª',0),(581931,16165,'hi','à¤•à¥‹à¤¡ à¤²à¤¾à¤—à¤¤ à¤¹à¥ˆ',0),(581932,16165,'ms','Mempunyai kos kod',0),(581933,16165,'ar','ÙˆÙ‚Ø¯ Ø±Ù…ÙˆØ² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(581934,16165,'fr','Codes de coÃ»t a',0),(581935,16165,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰',0),(581936,16165,'pt','Custou a cÃ³digos',0),(581937,16165,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´Ñ‹',0),(581938,16165,'es','Ha costado y',0),(581939,16165,'de','Codes gekostet hat',0),(581940,16165,'en','Has Cost Codes',0),(581941,16166,'is','',0),(581942,16166,'dr','Ø±Ø¯Ù‡Ù‡Ø§ÛŒ ØµÙØ­Ù‡ GL Ø§Ø³Øª',0),(581943,16166,'pr','Ø±Ø¯Ù‡Ù‡Ø§ÛŒ ØµÙØ­Ù‡ GL Ø§Ø³Øª',0),(581944,16166,'tr','GL kategorisi vardÄ±r',0),(581945,16166,'pl','Ma GL kategorie',0),(581946,16166,'bg','Ð˜Ð¼Ð° GL ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(581947,16166,'ur','Ø¬ÛŒØ¬Û’ Ù‚Ø³Ù…ÛŒÚº ÛÛŒÚº',0),(581948,16166,'sr','Ð˜Ð¼Ð° Ð“Ð› ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(581949,16166,'vi','CÃ³ loáº¡i GL',0),(581950,16166,'af','Het GL kategorieÃ«',0),(581951,16166,'ro','A categorii de GL',0),(581952,16166,'et','GL kategooriad on',0),(581953,16166,'si','GL zvrsti',0),(581954,16166,'ba','Memiliki kategori GL',0),(581955,16166,'nl','GL categorieÃ«n heeft',0),(581956,16166,'fi','On GL luokkaa',0),(581957,16166,'no','Har GL kategorier',0),(581958,16166,'da','Har GL kategorier',0),(581959,16166,'ko','GL ì¢…ë¥˜ ìžˆë‹¤',0),(581960,16166,'he','×™×© ×§×˜×’×•×¨×™×•×ª GL',0),(581961,16166,'el','ÎˆÏ‡ÎµÎ¹ GL ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(581962,16166,'zh','æœ‰ GL ç±»åˆ«',0),(581963,16166,'sv','Har GL kategorier',0),(581964,16166,'it','Ha GL categorie',0),(581965,16166,'tl','',0),(581966,16166,'th','à¸¡à¸µà¸›à¸£à¸°à¹€à¸ à¸— GL',0),(581967,16166,'hi','GL à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¥‹à¤‚ à¤¹à¥ˆ',0),(581968,16166,'ms','Mempunyai kategori GL',0),(581969,16166,'ar','ÙØ¦Ø§Øª GL',0),(581970,16166,'fr','A catÃ©gories GL',0),(581971,16166,'jp','GL ã‚’ã‚«ãƒ†ã‚´ãƒªã—ã¾ã™ã€‚',0),(581972,16166,'pt','Tem categorias GL',0),(581973,16166,'ru','Ð•ÑÑ‚ÑŒ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ GL',0),(581974,16166,'es','Tiene categorÃ­as GL',0),(581975,16166,'de','Hat GL Kategorien',0),(581976,16166,'en','Has GL Categories',0),(581977,16167,'is','',0),(581978,16167,'dr','Ø­ØªÙ…Ø§ Ù¾Ø³Øª Ù‡Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡ Unposted Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù‚Ø¨Ù„ Ø§Ø² Ø°Ø®ÛŒØ±Ù‡ Ú©Ø±Ø¯Ù†',0),(581979,16167,'pr','Ø­ØªÙ…Ø§ Ù¾Ø³Øª Ù‡Ø± Ù…Ø¬Ù…ÙˆØ¹Ù‡ Unposted Ù…Ø¹Ø§Ù…Ù„Ù‡ Ù‚Ø¨Ù„ Ø§Ø² Ø°Ø®ÛŒØ±Ù‡ Ú©Ø±Ø¯Ù†',0),(581980,16167,'tr','Kaydetmeden Ã¶nce herhangi bir deftere nakledilmemiÅŸ hareket kÃ¼meleri gÃ¶ndermek iÃ§in emin olun',0),(581981,16167,'pl','Nie zapomnij umieÅ›ciÄ‡ wszystkie zestawy niezaksiÄ™gowanych transakcji, przed zapisaniem',0),(581982,16167,'bg','ÐÐµ Ð·Ð°Ð±Ñ€Ð°Ð²ÑÐ¹Ñ‚Ðµ Ð´Ð° Ð¿ÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ñ‚Ðµ Ð½ÑÐºÐ°ÐºÐ²Ð¸ Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¸ Ð¿Ñ€ÐµÐ´Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(581983,16167,'ur','Ù…Ø­ÙÙˆØ¸ Ú©Ø±Ù†Û’ Ø³Û’ Ù‚Ø¨Ù„ Ú©Ø³ÛŒ Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø³ÛŒÙ¹ Ù¾ÙˆØ³Ù¹ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ Ø¨Ø§Øª Ú©Ø§ ÛŒÙ‚ÛŒÙ† ÛÙˆ',0),(581984,16167,'sr','Ð‘Ð¸Ñ‚Ð¸ ÑÐ¸Ð³ÑƒÑ€Ð½Ð¸ Ð´Ð° Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶Ð¸Ñ‚Ðµ Ð½ÐµÐºÐµ Ð½ÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÑÐºÑƒÐ¿Ð¾Ð²Ð° Ð¿Ñ€Ðµ Ñ‡ÑƒÐ²Ð°ÑšÐ°',0),(581985,16167,'vi','HÃ£y cháº¯c cháº¯n Ä‘á»ƒ gá»­i báº¥t ká»³ táº­p há»£p cÃ¡c giao dá»‹ch trÆ°á»›c khi tiáº¿t kiá»‡m',0),(581986,16167,'af','Maak seker dat jy die pos enige Unposted transaksie stelle voor stoor',0),(581987,16167,'ro','AsiguraÅ£i-vÄƒ cÄƒ pentru a posta orice seturi de tranzacÅ£ie neÃ®nregistrate Ã®nainte de salvare',0),(581988,16167,'et','Kindlasti postitust mis tahes konteerimata tehingu komplekti enne salvestamist',0),(581989,16167,'si','Bodite prepriÄani, da objavite vse neobjavljene transakcije doloÄa pred shranjevanjem',0),(581990,16167,'ba','Pastikan untuk posting apapun set Unposted transaksi sebelum menyimpannya',0),(581991,16167,'nl','Zorg ervoor dat u geen niet-geboekte transactie Sets voor opslaan Post',0),(581992,16167,'fi','Muista lÃ¤hettÃ¤Ã¤ lainkaan kirjaamattomassa tapahtumassa merkintÃ¶jÃ¤ ennen tallentamista',0),(581993,16167,'no','Husk Ã¥ legge noen ikke-posterte transaksjonen sett fÃ¸r lagring',0),(581994,16167,'da','SÃ¸rg for at skrive eventuelle ikke-bogfÃ¸rte transaktion sÃ¦t fÃ¸r du gemmer',0),(581995,16167,'ko','ì €ìž¥ í•˜ê¸° ì „ì— ê²Œì‹œ íŠ¸ëžœìž­ì…˜ ì§‘í•©ì„ ê²Œì‹œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(581996,16167,'he','×”×§×¤×“ ×œ×›×ª×•×‘ ×œ×¢×¨×›×•×ª ×ª× ×•×¢×” ×©×œ× × ×¨×©×ž×” ×œ×¤× ×™ ×©×ž×™×¨×ª×•.',0),(581997,16167,'el','ÎÎ± ÎµÎ¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Ï‚ Î½Î± Î´Î·Î¼Î¿ÏƒÎ¹ÎµÏÏƒÎµÏ„Îµ Î¿Ï€Î¿Î¹Î±Î´Î®Ï€Î¿Ï„Îµ Î¼Î· Î±Î½Î±ÏÏ„Î·Î¼Î­Î½ÎµÏ‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½ ÏƒÏÎ½Î¿Î»Î± Ï€ÏÎ¹Î½ Î±Ï€ÏŒ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·',0),(581998,16167,'zh','ä¸€å®šè¦åœ¨ä¿å­˜å‰ä»»ä½•æœªè¿‡å¸çš„äº¤æ˜“è®°å½•é›†',0),(581999,16167,'sv','Se till att posta nÃ¥got ej bokfÃ¶rda transaktionen uppsÃ¤ttningar innan du sparar',0),(582000,16167,'it','Assicurarsi di inviare qualsiasi set di transazioni non registrate prima del salvataggio',0),(582001,16167,'tl','',0),(582002,16167,'th','à¹ƒà¸«à¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸§à¹ˆà¸²à¸à¸²à¸£à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸Šà¸¸à¸”à¹ƒà¸” à¹† à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¹„à¸”à¹‰à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸à¹ˆà¸­à¸™à¸—à¸³à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸',0),(582003,16167,'hi','à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤•à¥‹à¤ˆ à¤­à¥€ Unposted à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¸à¥‡à¤Ÿ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¸à¥à¤¨à¤¿à¤¶à¥à¤šà¤¿à¤¤ à¤¹à¥‹',0),(582004,16167,'ms','Pastikan anda menghantar mana-mana set urus niaga Unposted sebelum Menyimpan',0),(582005,16167,'ar','ÙˆÙ…Ù† Ø§Ù„Ù…Ø¤ÙƒØ¯ Ø£Ù† ÙˆØ¸ÙŠÙØ© Ø£ÙŠ Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª ØºÙŠØ± Ø§Ù„Ù…Ù†Ø´ÙˆØ±Ø© Ù‚Ø¨Ù„ Ø§Ù„Ø­ÙØ¸',0),(582006,16167,'fr','Nâ€™oubliez pas de poster toute informatisÃ©s non comptabilisÃ©s avant dâ€™enregistrer',0),(582007,16167,'jp','ä¿å­˜ã™ã‚‹å‰ã«ã™ã¹ã¦ã®æœªé€ä¿¡ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ã‚»ãƒƒãƒˆã‚’æŠ•ç¨¿ã—ã¦ãã ã•ã„ã€‚',0),(582008,16167,'pt','NÃ£o se esqueÃ§a de postar quaisquer conjuntos de transaÃ§Ã£o nÃ£o lanÃ§adas antes de salvar',0),(582009,16167,'ru','Ð£Ð±ÐµÐ´Ð¸Ñ‚ÐµÑÑŒ, Ñ‡Ñ‚Ð¾ Ñ€Ð°Ð·Ð¼ÐµÑ‰Ð°Ñ‚ÑŒ Ð»ÑŽÐ±Ñ‹Ðµ Ð½Ð°Ð±Ð¾Ñ€Ñ‹ Ð½ÐµÑ€Ð°Ð·Ð½ÐµÑÐµÐ½Ð½Ñ‹Ðµ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ Ð¿ÐµÑ€ÐµÐ´ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸ÐµÐ¼',0),(582010,16167,'es','AsegÃºrese de registrar cualquier transacciÃ³n no contabilizada conjuntos antes de guardar',0),(582011,16167,'de','Achten Sie darauf, alle nicht gebuchten TransaktionssÃ¤tze vor dem Speichern zu Posten',0),(582012,16167,'en','Be Sure To Post Any Unposted Transaction Sets Before Saving',0),(582013,16168,'is','',0),(582014,16168,'dr','Ø¨Ù„ÙˆÚ© Ù‡Ø§ Ø§Ù…Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… GL',0),(582015,16168,'pr','Ø¨Ù„ÙˆÚ© Ù‡Ø§ Ø§Ù…Ø§ Ù…Ø³ØªÙ‚ÛŒÙ… GL',0),(582016,16168,'tr','Blok tÃ¼m ama doÄŸrudan GL giriÅŸleri',0),(582017,16168,'pl','Blok ale wszystkie bezpoÅ›rednie zapisy k/g',0),(582018,16168,'bg','Ð‘Ð»Ð¾Ðº Ð½Ð¾ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¿Ñ€ÐµÐºÐ¸ GL Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(582019,16168,'ur','Ø¨Ù„Ø§Ú© Ø¨Ù„Ú©Û Ø³Ø¨ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(582020,16168,'sr','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð°Ñ˜ ÑÐ²Ðµ, Ð°Ð»Ð¸ Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐµ',0),(582021,16168,'vi','Cháº·n táº¥t cáº£, nhÆ°ng trá»±c tiáº¿p cÃ¡c má»¥c GL',0),(582022,16168,'af','Blok alle maar direkte GL inskrywings',0),(582023,16168,'ro','IntrÄƒrile de toate, dar Direct GL bloc',0),(582024,16168,'et','Blokeeri kÃµik peale otsese GL kanded',0),(582025,16168,'si','Blokiraj vse, ampak neposredno GL postavke',0),(582026,16168,'ba','Blok semua tapi langsung GL entri',0),(582027,16168,'nl','Blok alles behalve directe GL posten',0),(582028,16168,'fi','EstÃ¤Ã¤ kaikki vaan suoraan GL merkinnÃ¤t',0),(582029,16168,'no','Blokkere alle men direkte GL oppfÃ¸ringer',0),(582030,16168,'da','Blokere alle, men direkte GL poster',0),(582031,16168,'ko','ë¸”ë¡ ëª¨ë“  í•˜ì§€ë§Œ ì§ì ‘ GL í•­ëª©',0),(582032,16168,'he','×‘×œ×•×§ GL ×™×©×™×¨ ×”×›×œ ×ž×œ×‘×“ ×¢×¨×›×™',0),(582033,16168,'el','ÎœÏ€Î»Î¿Îº ÏŒÎ»Î±, Î±Î»Î»Î¬ Î±Ï€ÎµÏ…Î¸ÎµÎ¯Î±Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î³/Î»',0),(582034,16168,'zh','é˜»æ­¢æ‰€æœ‰ä½†ç›´æŽ¥ GL é¡¹',0),(582035,16168,'sv','Blockera alla utom direkt GL poster',0),(582036,16168,'it','Voci di tutti, ma diretto GL blocco',0),(582037,16168,'tl','',0),(582038,16168,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸¥à¹‡à¸­à¸„ GL à¹‚à¸”à¸¢à¸•à¸£à¸‡à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¹à¸•à¹ˆ',0),(582039,16168,'hi','à¤¬à¥à¤²à¥‰à¤• à¤¸à¤­à¥€ à¤²à¥‡à¤•à¤¿à¤¨ GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤·',0),(582040,16168,'ms','Blok l semua tetapi terus masukan',0),(582041,16168,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª GL Ù…Ø¨Ø§Ø´Ø±Ø© Ù„ÙƒÙ† ÙƒÙ„ ÙƒØªÙ„Ø©',0),(582042,16168,'fr','Bloc GL pratiquement Direct entrÃ©es',0),(582043,16168,'jp','ãƒ–ãƒ­ãƒƒã‚¯ã™ã¹ã¦ãŒç›´æŽ¥ GL ã‚¨ãƒ³ãƒˆãƒª',0),(582044,16168,'pt','Entradas GL mas todos direto do bloco',0),(582045,16168,'ru','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²ÑÐµ, Ð½Ð¾ Ð¿Ñ€ÑÐ¼Ñ‹Ðµ GL Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(582046,16168,'es','Bloque GL casi directa las entradas',0),(582047,16168,'de','Alles andere als direkte Sachposten Block',0),(582048,16168,'en','Block All But Direct GL Entries',0),(582049,16169,'is','',0),(582050,16169,'dr','Ù…Ø³Ø¯ÙˆØ¯ Ú©Ø±Ø¯Ù† ØªÙ…Ø§Ù… Ø§Ø±Ø³Ø§Ù„',0),(582051,16169,'pr','Ù…Ø³Ø¯ÙˆØ¯ Ú©Ø±Ø¯Ù† ØªÙ…Ø§Ù… Ø§Ø±Ø³Ø§Ù„',0),(582052,16169,'tr','TÃ¼m deftere nakil engellemek',0),(582053,16169,'pl','ZablokowaÄ‡ wszystkie ksiÄ™gowania',0),(582054,16169,'bg','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ',0),(582055,16169,'ur','ØªÙ…Ø§Ù… Ù¾ÙˆØ³Ù¹Ù†Ú¯ Ø¨Ù„Ø§Ú©',0),(582056,16169,'sr','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð°Ñ˜Ñ‚Ðµ ÑÐ²Ð° ÐºÑšÐ¸Ð¶ÐµÑšÐ°',0),(582057,16169,'vi','Cháº·n táº¥t cáº£ bÃ i viáº¿t',0),(582058,16169,'af','Blokkeer alle pos',0),(582059,16169,'ro','Bloca toate Ã®nregistrare',0),(582060,16169,'et','Blokeeri kÃµik',0),(582061,16169,'si','Blokiranje vseh knjiÅ¾enje',0),(582062,16169,'ba','Memblokir semua Posting',0),(582063,16169,'nl','Blokkeren van alle boekingen',0),(582064,16169,'fi','EstÃ¤ kaikki',0),(582065,16169,'no','Blokkere alle innlegg',0),(582066,16169,'da','Blokere alle bogfÃ¸ring',0),(582067,16169,'ko','ëª¨ë“  ê²Œì‹œ ì°¨ë‹¨',0),(582068,16169,'he','×œ×—×¡×•× ×›×œ ×¨×™×©×•×',0),(582069,16169,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¹ÏƒÎ¼ÏŒÏ‚ ÏŒÎ»Ï‰Î½ Ï„Ï‰Î½ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÏ‰Î½',0),(582070,16169,'zh','é˜»æ­¢æ‰€æœ‰è¿‡å¸',0),(582071,16169,'sv','Blockera alla bokfÃ¶ring',0),(582072,16169,'it','Bloccare tutti i Posting',0),(582073,16169,'tl','',0),(582074,16169,'th','à¸šà¸¥à¹‡à¸­à¸à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸¥à¸‡',0),(582075,16169,'hi','à¤¸à¤­à¥€ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¬à¥à¤²à¥‰à¤•',0),(582076,16169,'ms','Sekat semua Posting',0),(582077,16169,'ar','Ø­Ø¸Ø± Ù†Ø´Ø± Ø¬Ù…ÙŠØ¹',0),(582078,16169,'fr','Bloquer lâ€™affichage de toutes les',0),(582079,16169,'jp','ã™ã¹ã¦ã®è»¢è¨˜ã‚’ãƒ–ãƒ­ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(582080,16169,'pt','Bloquear todas as postagem',0),(582081,16169,'ru','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²ÑÐµ Ð¿Ñ€Ð¾Ð²Ð¾Ð´ÐºÐ¸',0),(582082,16169,'es','Bloquear registro todos',0),(582083,16169,'de','Blockieren Sie alle Buchungen',0),(582084,16169,'en','Block All Posting',0),(582085,16170,'is','',0),(582086,16170,'dr','Ø¯Ø±ÛŒØ§ÙØª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø§Ù‡',0),(582087,16170,'pr','Ø¯Ø±ÛŒØ§ÙØª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø§Ù‡',0),(582088,16170,'tr','Ay bilgi almak',0),(582089,16170,'pl','UzyskaÄ‡ informacji na temat miesiÄ…ca',0),(582090,16170,'bg','Ð’Ð·ÐµÐ¼Ð¸ Ð¼ÐµÑÐµÑ† Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(582091,16170,'ur','Ù…Ø§Û Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø­Ø§ØµÙ„ Ú©Ø±ÛŒÚº',0),(582092,16170,'sr','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ Ð¼ÐµÑÐµÑ† Ð´Ð°Ð½Ð°',0),(582093,16170,'vi','Nháº­n Ä‘Æ°á»£c thÃ´ng tin thÃ¡ng',0),(582094,16170,'af','Maand Info kry',0),(582095,16170,'ro','ObÅ£ineÅ£i informaÅ£ii de lunÄƒ',0),(582096,16170,'et','Saada kuu Info',0),(582097,16170,'si','Dobili mesec Info',0),(582098,16170,'ba','Dapatkan Info bulan',0),(582099,16170,'nl','Toon maand Info',0),(582100,16170,'fi','Kuukauden hankkiminen',0),(582101,16170,'no','Vis mÃ¥ned Info',0),(582102,16170,'da','FÃ¥ mÃ¥ned Info',0),(582103,16170,'ko','ë‹¬ ì •ë³´',0),(582104,16170,'he','×§×‘×œ×ª ×ž×™×“×¢ ×‘×—×•×“×©',0),(582105,16170,'el','ÎÎ± Ï€Î¬ÏÎµÏ„Îµ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î¿ Î¼Î®Î½Î±',0),(582106,16170,'zh','èŽ·å–æœˆä¿¡æ¯',0),(582107,16170,'sv','FÃ¥ mÃ¥naden Info',0),(582108,16170,'it','Raccogli informazioni di mese',0),(582109,16170,'tl','',0),(582110,16170,'th','à¸£à¸±à¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹€à¸”à¸·à¸­à¸™',0),(582111,16170,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¥‡à¤‚',0),(582112,16170,'ms','Mendapatkan maklumat bulan',0),(582113,16170,'ar','Ø§Ù„Ø­ØµÙˆÙ„ Ø¹Ù„Ù‰ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª ÙÙŠ Ø§Ù„Ø´Ù‡Ø±',0),(582114,16170,'fr','Infos du mois',0),(582115,16170,'jp','æœˆæƒ…å ±ã‚’å–å¾—ã—ã¾ã™ã€‚',0),(582116,16170,'pt','Obter informaÃ§Ã£o do mÃªs',0),(582117,16170,'ru','ÐŸÐ¾Ð»ÑƒÑ‡Ð¸Ñ‚ÑŒ Ð¼ÐµÑÑÑ† Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(582118,16170,'es','ObtÃ©n informaciÃ³n de mes',0),(582119,16170,'de','Monat-Infos',0),(582120,16170,'en','Get Month Info',0),(582121,16171,'is','',0),(582122,16171,'dr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ÙˆØ¶Ø¹ÛŒØª',0),(582123,16171,'pr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ÙˆØ¶Ø¹ÛŒØª',0),(582124,16171,'tr','Son durum tarihi',0),(582125,16171,'pl','Data ostatniego stanu',0),(582126,16171,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° ÑÑ‚Ð°Ñ‚ÑƒÑ',0),(582127,16171,'ur','Ø­Ø§Ù„Øª Ú©ÛŒ Ø¢Ø®Ø±ÛŒ ØªØ§Ø±ÛŒØ®',0),(582128,16171,'sr','Ð—Ð°Ð´ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ ÑÑ‚Ð°Ñ‚ÑƒÑÐ°',0),(582129,16171,'vi','NgÃ y tÃ¬nh tráº¡ng cuá»‘i cÃ¹ng',0),(582130,16171,'af','Datum van laaste Status',0),(582131,16171,'ro','Ultima data de stare',0),(582132,16171,'et','Viimane oleku kuupÃ¤ev',0),(582133,16171,'si','Zadnji datum stanja',0),(582134,16171,'ba','Tanggal Status terakhir',0),(582135,16171,'nl','Statusdatum van laatste',0),(582136,16171,'fi','Tilan pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(582137,16171,'no','Siste statusdatoen',0),(582138,16171,'da','Sidste statusdatoen',0),(582139,16171,'ko','ë§ˆì§€ë§‰ ë‚ ì§œ',0),(582140,16171,'he','×ª××¨×™×š ×”×“×™×•×•×— ×”××—×¨×•×Ÿ',0),(582141,16171,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(582142,16171,'zh','æœ€åŽä¸€ä¸ªçŠ¶æ€æ—¥æœŸ',0),(582143,16171,'sv','Senaste statusdatum',0),(582144,16171,'it','Ultima data di stato',0),(582145,16171,'tl','',0),(582146,16171,'th','à¸§à¸±à¸™à¸ªà¸–à¸²à¸™à¸°à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(582147,16171,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(582148,16171,'ms','Tarikh Status',0),(582149,16171,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø§Ù„Ø© Ø§Ù„Ø£Ø®ÙŠØ±Ø©',0),(582150,16171,'fr','DerniÃ¨re Date dâ€™Ã‰tat',0),(582151,16171,'jp','æœ€å¾Œã®çŠ¶æ³å ±å‘Šæ—¥',0),(582152,16171,'pt','Ãšltima data de Status',0),(582153,16171,'ru','Ð”Ð°Ñ‚Ð° Ð¿Ð¾ÑÐ»ÐµÐ´Ð½ÐµÐ³Ð¾ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ñ',0),(582154,16171,'es','Ãšltima fecha de estado',0),(582155,16171,'de','Statusdatum der letzten',0),(582156,16171,'en','Last Status Date',0),(582157,16172,'is','',0),(582158,16172,'dr','Ø¢Ø®Ø±ÛŒÙ† Ú©Ø§Ø±Ø¨Ø±',0),(582159,16172,'pr','Ø¢Ø®Ø±ÛŒÙ† Ú©Ø§Ø±Ø¨Ø±',0),(582160,16172,'tr','Son kullanÄ±cÄ±',0),(582161,16172,'pl','Ostatni uÅ¼ytkownik',0),(582162,16172,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´ÐµÐ½ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(582163,16172,'ur','Ø¢Ø®Ø±ÛŒ ØµØ§Ø±Ù',0),(582164,16172,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº',0),(582165,16172,'vi','NgÆ°á»i dÃ¹ng cuá»‘i',0),(582166,16172,'af','Laaste gebruiker',0),(582167,16172,'ro','Ultimul utilizator',0),(582168,16172,'et','Viimane kasutaja',0),(582169,16172,'si','Zadnji uporabnik',0),(582170,16172,'ba','Pengguna terakhir',0),(582171,16172,'nl','Laatste gebruiker',0),(582172,16172,'fi','Viimeinen kÃ¤yttÃ¤jÃ¤',0),(582173,16172,'no','Siste brukeren',0),(582174,16172,'da','Sidste bruger',0),(582175,16172,'ko','ë§ˆì§€ë§‰ ì‚¬ìš©ìž',0),(582176,16172,'he','×”×ž×©×ª×ž×© ×”××—×¨×•×Ÿ',0),(582177,16172,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚',0),(582178,16172,'zh','æœ€åŽä¸€ä¸ªç”¨æˆ·',0),(582179,16172,'sv','Senaste anvÃ¤ndare',0),(582180,16172,'it','Ultimo utente',0),(582181,16172,'tl','',0),(582182,16172,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(582183,16172,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(582184,16172,'ms','Pengguna terakhir',0),(582185,16172,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ø£Ø®ÙŠØ±',0),(582186,16172,'fr','Dernier utilisateur',0),(582187,16172,'jp','æœ€å¾Œã®ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(582188,16172,'pt','Ãšltimo usuÃ¡rio',0),(582189,16172,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð¸Ð¹ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ',0),(582190,16172,'es','Ãšltimo usuario',0),(582191,16172,'de','Letzte Benutzer',0),(582192,16172,'en','Last User',0),(582193,16173,'is','',0),(582194,16173,'dr','Ù…Ø§Ù‡ Ø¨Ø§Ø²',0),(582195,16173,'pr','Ù…Ø§Ù‡ Ø¨Ø§Ø²',0),(582196,16173,'tr','Ay aÃ§Ä±k',0),(582197,16173,'pl','OtwÃ³rz miesiÄ…c',0),(582198,16173,'bg','ÐœÐµÑÐµÑ† Ð¾Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ',0),(582199,16173,'ur','Ù…Ø§Û Ú©Ú¾ÙˆÙ„ÛŒÚº',0),(582200,16173,'sr','ÐœÐµÑÐµÑ† Ð´Ð°Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾',0),(582201,16173,'vi','ThÃ¡ng má»Ÿ',0),(582202,16173,'af','Maand oop',0),(582203,16173,'ro','Deschis de luni',0),(582204,16173,'et','Kuu avatud',0),(582205,16173,'si','Mesec odprtih',0),(582206,16173,'ba','Bulan terbuka',0),(582207,16173,'nl','Maand Open',0),(582208,16173,'fi','Kuussa avoin',0),(582209,16173,'no','MÃ¥ned Ã¥pen',0),(582210,16173,'da','MÃ¥ned Ã¥bent',0),(582211,16173,'ko','ë‹¬ ì˜¤í”ˆ',0),(582212,16173,'he','×—×•×“×© ×¤×ª×•×—',0),(582213,16173,'el','Î‘Î½Î¿Î¯Î¾Ï„Îµ Ï„Î¿ Î¼Î®Î½Î±',0),(582214,16173,'zh','ä¸ªæœˆå¼€æ”¾',0),(582215,16173,'sv','MÃ¥nad Ã¶ppna',0),(582216,16173,'it','Open mese',0),(582217,16173,'tl','',0),(582218,16173,'th','à¹€à¸›à¸´à¸”à¹€à¸”à¸·à¸­à¸™',0),(582219,16173,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤“à¤ªà¤¨ à¤Ÿà¥‡à¤¨à¤¿à¤¸ à¤ªà¥à¤°à¤¤à¤¿à¤¯à¥‹à¤—à¤¿à¤¤à¤¾',0),(582220,16173,'ms','Bulan terbuka',0),(582221,16173,'ar','ÙØªØ­ Ø§Ù„Ø´Ù‡Ø±',0),(582222,16173,'fr','Ouvert du mois',0),(582223,16173,'jp','1 ãƒ¶æœˆã‚ªãƒ¼ãƒ—ãƒ³',0),(582224,16173,'pt','MÃªs aberto',0),(582225,16173,'ru','ÐœÐµÑÑÑ† Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚ÑŒ',0),(582226,16173,'es','Mes abierto',0),(582227,16173,'de','Monat geÃ¶ffnet',0),(582228,16173,'en','Month Open',0),(582229,16174,'is','',0),(582230,16174,'dr','Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¶Ø¹ÛŒØª Ù…Ø§Ù‡',0),(582231,16174,'pr','Ú¯Ø²Ø§Ø±Ø´ ÙˆØ¶Ø¹ÛŒØª Ù…Ø§Ù‡',0),(582232,16174,'tr','AylÄ±k durum raporu',0),(582233,16174,'pl','Raport stanu miesiÄ…ca',0),(582234,16174,'bg','ÐœÐµÑÐµÑ† ÑÐ¿Ñ€Ð°Ð²ÐºÐ°',0),(582235,16174,'ur','Ù…Ø§Û Ø­Ø§Ù„Øª Ø±Ù¾ÙˆØ±Ù¹',0),(582236,16174,'sr','ÐœÐµÑÐµÑ† Ð´Ð°Ð½Ð° Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ð¸',0),(582237,16174,'vi','ThÃ¡ng tÃ¬nh tráº¡ng bÃ¡o cÃ¡o',0),(582238,16174,'af','Maand Status verslag',0),(582239,16174,'ro','Luna Status Raport',0),(582240,16174,'et','Kuu KokkuvÃµte',0),(582241,16174,'si','Mesec statusno poroÄilo',0),(582242,16174,'ba','Bulan Status laporan',0),(582243,16174,'nl','Verslag van de Status van de maand',0),(582244,16174,'fi','Kuukausi Status raportista',0),(582245,16174,'no','MÃ¥ned statusrapport',0),(582246,16174,'da','MÃ¥neders statusrapport',0),(582247,16174,'ko','ë‹¬ ìƒíƒœ ë³´ê³ ',0),(582248,16174,'he','×“×•×— ×ž×¦×‘ ×—×•×“×©',0),(582249,16174,'el','ÎœÎ®Î½Î±Ï‚ Ï€ÏÎ¿ÏŒÎ´Î¿Ï…',0),(582250,16174,'zh','ä¸€ä¸ªæœˆçŠ¶å†µæŠ¥å‘Š',0),(582251,16174,'sv','MÃ¥nad, lÃ¤gesrapport',0),(582252,16174,'it','Report stato mese',0),(582253,16174,'tl','',0),(582254,16174,'th','à¸£à¸²à¸¢à¸‡à¸²à¸™à¸ªà¸–à¸²à¸™à¸°à¹€à¸”à¸·à¸­à¸™',0),(582255,16174,'hi','à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤•à¥€ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(582256,16174,'ms','Laporan Status bulan',0),(582257,16174,'ar','ØªÙ‚Ø±ÙŠØ± Ø­Ø§Ù„Ø© ÙÙŠ Ø§Ù„Ø´Ù‡Ø±',0),(582258,16174,'fr','Rapport de situation du mois',0),(582259,16174,'jp','æœˆã®ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ ãƒ¬ãƒãƒ¼ãƒˆ',0),(582260,16174,'pt','RelatÃ³rio de Status do mÃªs',0),(582261,16174,'ru','ÐœÐµÑÑÑ† Ð´Ð¾ÐºÐ»Ð°Ð´',0),(582262,16174,'es','Informe de estado del mes',0),(582263,16174,'de','Monat-Statusbericht',0),(582264,16174,'en','Month Status Report',0),(582265,16175,'is','',0),(582266,16175,'dr','Ù‡ÛŒÚ† Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø²Ù…Ø§Ù†ÛŒ Ù…Ø¹ÛŒÙ†',0),(582267,16175,'pr','Ù‡ÛŒÚ† Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø¯Ø± Ù…Ø­Ø¯ÙˆØ¯Ù‡ Ø²Ù…Ø§Ù†ÛŒ Ù…Ø¹ÛŒÙ†',0),(582268,16175,'tr','Verilen tarih aralÄ±ÄŸÄ±nda bulunan herhangi bir hareket',0),(582269,16175,'pl','Brak transakcji w danym zakres dat',0),(582270,16175,'bg','ÐÑÐ¼Ð° ÑÐ´ÐµÐ»ÐºÐ¸, Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¸ Ð² Ð´Ð°Ð´ÐµÐ½ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð¾Ñ‚ Ð´Ð°Ñ‚Ð¸',0),(582271,16175,'ur','Ú©ÙˆØ¦ÛŒ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø¯ÛŒ Ú¯Ø¦ÛŒ ØªØ§Ø±ÛŒØ® Ø­Ø¯ Ø§Ø·Ù„Ø§Ù‚ Ù…ÛŒÚº Ù¾Ø§ÛŒØ§',0),(582272,16175,'sr','ÐÐµÐ¼Ð° Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð° Ñƒ Ð´Ð°Ñ‚Ð¾Ð¼ Ð¾Ð¿ÑÐµÐ³Ñƒ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(582273,16175,'vi','KhÃ´ng cÃ³ giao dá»‹ch trong pháº¡m vi ngÃ y cho trÆ°á»›c',0),(582274,16175,'af','Geen transaksies In die gegewe datum reeks gevind',0),(582275,16175,'ro','Nicio tranzactie gÄƒsit Ã®n intervalul de Date dat',0),(582276,16175,'et','Kandeid ei leitud antud kuupÃ¤evavahemikku',0),(582277,16175,'si','Brez transakcij v danem datumskem obsegu',0),(582278,16175,'ba','Tidak ada transaksi yang ditemukan dalam rentang tanggal tertentu',0),(582279,16175,'nl','Geen transacties gevonden In het opgegeven datumbereik',0),(582280,16175,'fi','Tapahtumia ei lÃ¶ytynyt tietyllÃ¤ pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤vÃ¤lillÃ¤',0),(582281,16175,'no','Ingen transaksjoner i det angitte datoomrÃ¥det',0),(582282,16175,'da','Ingen transaktioner er fundet i det angivne datointerval',0),(582283,16175,'ko','ì§€ì • ëœ ë‚ ì§œ ë²”ìœ„ì—ì„œ ë°œê²¬ ì•„ë¬´ ê±°ëž˜',0),(582284,16175,'he','×œ× × ×ž×¦××• ×‘×˜×•×•×— ×ª××¨×™×š × ×ª×•×Ÿ ×ª× ×•×¢×•×ª',0),(582285,16175,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡Î¿Ï…Î½ ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ ÏƒÏ„Î¿ Î´ÎµÎ´Î¿Î¼Î­Î½Î¿ ÎµÏÏÎ¿Ï‚ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¹ÏŽÎ½',0),(582286,16175,'zh','æ²¡æœ‰æ‰¾åˆ°ç»™å®šçš„æ—¥æœŸèŒƒå›´å†…çš„äº‹åŠ¡',0),(582287,16175,'sv','Inga transaktioner Funna i det angivna datumintervallet',0),(582288,16175,'it','Transazioni non trovate nell\'intervallo di Date specificato',0),(582289,16175,'tl','',0),(582290,16175,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¹ƒà¸™à¸Šà¹ˆà¸§à¸‡à¸§à¸±à¸™à¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”',0),(582291,16175,'hi','à¤¦à¤¿à¤ à¤—à¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¶à¥à¤°à¥‡à¤£à¥€ à¤®à¥‡à¤‚ à¤ªà¤¾à¤¯à¤¾ à¤•à¥‹à¤ˆ à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨',0),(582292,16175,'ms','Sebarang urus niaga dibuat dalam julat tarikh yang diberikan',0),(582293,16175,'ar','Ø£ÙŠØ© Ø­Ø±ÙƒØ§Øª Ù…ÙˆØ¬ÙˆØ¯Ø© ÙÙŠ Ù†Ø·Ø§Ù‚ ØªØ§Ø±ÙŠØ® Ù…Ø¹ÙŠÙ†',0),(582294,16175,'fr','Aucune transaction trouvÃ©e dans la plage de dates donnÃ©e',0),(582295,16175,'jp','ç‰¹å®šã®æ—¥ä»˜ç¯„å›²ã«ã‚ã‚‹ãªã„ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³',0),(582296,16175,'pt','Nenhuma transaÃ§Ã£o encontrada na faixa determinada data',0),(582297,16175,'ru','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸ Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ñ‹ Ð² Ð·Ð°Ð´Ð°Ð½Ð½Ñ‹Ð¹ Ð´Ð¸Ð°Ð¿Ð°Ð·Ð¾Ð½ Ð´Ð°Ñ‚',0),(582298,16175,'es','Ninguna transacciÃ³n en el intervalo de fechas determinado',0),(582299,16175,'de','Keine Transaktionen In den angegebenen Datumsbereich gefunden',0),(582300,16175,'en','No Transactions Found In The Given Date Range',0),(582301,16176,'is','',0),(582302,16176,'dr','Ø§Ø¹ØªØ¨Ø§Ø±Ø§Øª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(582303,16176,'pr','Ø§Ø¹ØªØ¨Ø§Ø±Ø§Øª Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(582304,16176,'tr','Deftere nakledilen kredi',0),(582305,16176,'pl','WysÅ‚any kredytÃ³w',0),(582306,16176,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð¸',0),(582307,16176,'ur','Ø§Ø´ØªÛØ§Ø± Ú©ÛŒ Ú©Ø±ÛŒÚˆÙ¹',0),(582308,16176,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ ÑˆÐ¿Ð¸Ñ†Ð°',0),(582309,16176,'vi','ÄÄƒng cÃ¡c khoáº£n tÃ­n dá»¥ng',0),(582310,16176,'af','Opgelaai krediete',0),(582311,16176,'ro','Postat de credite',0),(582312,16176,'et','Konteeritud krediiti',0),(582313,16176,'si','KnjiÅ¾enih dobropisov',0),(582314,16176,'ba','Posted kredit',0),(582315,16176,'nl','Geboekte Credits',0),(582316,16176,'fi','Kirjattujen luottojen',0),(582317,16176,'no','BokfÃ¸rte studiepoeng',0),(582318,16176,'da','BogfÃ¸rte Credits',0),(582319,16176,'ko','ê²Œì‹œ í¬ë ˆë”§',0),(582320,16176,'he','×§×¨×“×™×˜×™× ×¤×•×¨×¡×',0),(582321,16176,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®Î¸Î·ÎºÎµ Ï€Î¹ÏƒÏ„ÏŽÏƒÎµÎ¹Ï‚',0),(582322,16176,'zh','å·²è¿‡å¸çš„å­¦åˆ†',0),(582323,16176,'sv','BokfÃ¶rda krediter',0),(582324,16176,'it','Crediti inserite',0),(582325,16176,'tl','',0),(582326,16176,'th','à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹€à¸„à¸£à¸”à¸´à¸•',0),(582327,16176,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(582328,16176,'ms','Hantar kredit',0),(582329,16176,'ar','Ø£Ø±Ø³Ù„Øª Ø§Ø¦ØªÙ…Ø§Ù†Ø§Øª',0),(582330,16176,'fr','PostÃ© de crÃ©dits',0),(582331,16176,'jp','æŽ²ç¤ºã•ã‚Œã‚‹ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆ',0),(582332,16176,'pt','CrÃ©ditos postados',0),(582333,16176,'ru','Ð£Ñ‡Ñ‚ÐµÐ½Ð½Ð¾Ð¹ ÐºÑ€ÐµÐ´Ð¸Ñ‚Ñ‹',0),(582334,16176,'es','CrÃ©ditos publicadas',0),(582335,16176,'de','Gebuchten Credits',0),(582336,16176,'en','Posted Credits',0),(582337,16177,'is','',0),(582338,16177,'dr','Ø¨Ø¯Ù‡ÙŠ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(582339,16177,'pr','Ø¨Ø¯Ù‡ÙŠ Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡',0),(582340,16177,'tr','Deftere nakledilen BorÃ§lar',0),(582341,16177,'pl','WysÅ‚any obciÄ…Å¼enia',0),(582342,16177,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ð´ÐµÐ±Ð¸Ñ‚Ð¸',0),(582343,16177,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÛŒØ§ Ú¯ÛŒØ§ Ø¯ÛŒØ¨ØªØ³',0),(582344,16177,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ°',0),(582345,16177,'vi','ÄÄƒng ghi ná»£',0),(582346,16177,'af','Opgelaai debiete',0),(582347,16177,'ro','Postat de debite',0),(582348,16177,'et','Sisestatud deebetsumma',0),(582349,16177,'si','KnjiÅ¾ene v breme',0),(582350,16177,'ba','Posted debet',0),(582351,16177,'nl','Geboekte afschrijvingen',0),(582352,16177,'fi','Kirjatun veloitukset',0),(582353,16177,'no','BokfÃ¸rte debet',0),(582354,16177,'da','BogfÃ¸rte debet',0),(582355,16177,'ko','ê²Œì‹œ ì§ë¶ˆ',0),(582356,16177,'he','×—×™×•×‘×™× ×¤×•×¨×¡×',0),(582357,16177,'el','ÎšÎ±Ï„Î±Ï‡Ï‰ÏÎ®Î¸Î·ÎºÎµ Ï‡ÏÎµÏŽÏƒÎµÏ‰Î½',0),(582358,16177,'zh','å·²è¿‡å¸çš„å€Ÿæ–¹',0),(582359,16177,'sv','BokfÃ¶rda debiteringar',0),(582360,16177,'it','Addebiti inseriti',0),(582361,16177,'tl','',0),(582362,16177,'th','à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹€à¸”à¸šà¸´à¸•',0),(582363,16177,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ Debits',0),(582364,16177,'ms','Debit dihantar',0),(582365,16177,'ar','Ø£Ø±Ø³Ù„Øª Ø§Ù„Ù…Ø¯ÙŠÙ†',0),(582366,16177,'fr','DÃ©bits affichÃ©s',0),(582367,16177,'jp','æŽ²ç¤ºã•ã‚Œã‚‹å€Ÿæ–¹',0),(582368,16177,'pt','Postado dÃ©bitos',0),(582369,16177,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¾ Ð´ÐµÐ±Ð¸Ñ‚Ñ‹',0),(582370,16177,'es','DÃ©bitos publicadas',0),(582371,16177,'de','Gebuchte Lastschriften',0),(582372,16177,'en','Posted Debits',0),(582373,16178,'is','',0),(582374,16178,'dr','ÙˆØ¶Ø¹ÛŒØª Ø§Ø±Ø³Ø§Ù„',0),(582375,16178,'pr','ÙˆØ¶Ø¹ÛŒØª Ø§Ø±Ø³Ø§Ù„',0),(582376,16178,'tr','Deftere nakil durumu',0),(582377,16178,'pl','Stan ksiÄ™gowania',0),(582378,16178,'bg','ÐŸÑƒÐ±Ð»Ð¸ÐºÑƒÐ²Ð°Ð½Ðµ Ð½Ð° ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸ÐµÑ‚Ð¾',0),(582379,16178,'ur','Ø­Ø§Ù„Øª Ø´Ø§Ø¦Ø¹ Ú©Ø±Ù†Ø§',0),(582380,16178,'sr','ÐšÑšÐ¸Ð¶ÐµÑšÐµ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(582381,16178,'vi','Tráº¡ng thÃ¡i gá»­i bÃ i',0),(582382,16178,'af','Plaas Status',0),(582383,16178,'ro','Statutul de Ã®nregistrare',0),(582384,16178,'et','Sisestamise olek',0),(582385,16178,'si','Status knjiÅ¾enja',0),(582386,16178,'ba','Posting Status',0),(582387,16178,'nl','Boeking Status',0),(582388,16178,'fi','Kirjauksen tila',0),(582389,16178,'no','Posteringsstatus',0),(582390,16178,'da','BogfÃ¸ringsstatus',0),(582391,16178,'ko','ê²Œì‹œ ìƒíƒœ',0),(582392,16178,'he','×ž×ž×¦×‘ ×¨×™×©×•×',0),(582393,16178,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚',0),(582394,16178,'zh','è¿‡å¸çŠ¶æ€',0),(582395,16178,'sv','BokfÃ¶ringsstatus',0),(582396,16178,'it','Stato di registrazione',0),(582397,16178,'tl','',0),(582398,16178,'th','à¸ªà¸–à¸²à¸™à¸°à¸à¸²à¸£à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(582399,16178,'hi','à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤ªà¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤—',0),(582400,16178,'ms','Status pengeposan',0),(582401,16178,'ar','Ø­Ø§Ù„Ø© Ø§Ù„ØªØ±Ø­ÙŠÙ„',0),(582402,16178,'fr','Affichage de statut',0),(582403,16178,'jp','è»¢è¨˜ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹',0),(582404,16178,'pt','Status de postagem',0),(582405,16178,'ru','Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð¿Ñ€Ð¾Ð²Ð¾Ð´ÐºÐ¸',0),(582406,16178,'es','Estado de contabilizaciÃ³n',0),(582407,16178,'de','Buchungsstatus',0),(582408,16178,'en','Posting Status',0),(582409,16179,'is','',0),(582410,16179,'dr','Ø¯Ø³ØªÚ¯Ø§Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(582411,16179,'pr','Ø¯Ø³ØªÚ¯Ø§Ù‡ Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(582412,16179,'tr','Hareket kÃ¼meleri',0),(582413,16179,'pl','Zestawy transakcji',0),(582414,16179,'bg','Ð¢Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¸',0),(582415,16179,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø³ÛŒÙ¹ Ú©Ø±ØªØ§ ÛÛ’',0),(582416,16179,'sr','Ð¢Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÑÐºÑƒÐ¿Ð¾Ð²Ð°',0),(582417,16179,'vi','Bá»™ giao dá»‹ch',0),(582418,16179,'af','Transaksie stelle',0),(582419,16179,'ro','Seturi de tranzactie',0),(582420,16179,'et','Tehingu komplekti',0),(582421,16179,'si','Transakcije sklopov',0),(582422,16179,'ba','Transaksi set',0),(582423,16179,'nl','Transactie Sets',0),(582424,16179,'fi','Tapahtuman sarjat',0),(582425,16179,'no','Transaksjonen sett',0),(582426,16179,'da','Transaktionen sÃ¦t',0),(582427,16179,'ko','íŠ¸ëžœìž­ì…˜ ì§‘í•©',0),(582428,16179,'he','×¢×¡×§×ª ×¡×˜×™×',0),(582429,16179,'el','Î£ÏÎ½Î¿Î»Î± ÎºÎ¹Î½Î®ÏƒÎµÏ‰Î½',0),(582430,16179,'zh','äº¤æ˜“è®°å½•é›†',0),(582431,16179,'sv','Transaktionen uppsÃ¤ttningar',0),(582432,16179,'it','Set di transazioni',0),(582433,16179,'tl','',0),(582434,16179,'th','à¸Šà¸¸à¸”à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡',0),(582435,16179,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¸à¥‡à¤Ÿ',0),(582436,16179,'ms','Set urus niaga',0),(582437,16179,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª',0),(582438,16179,'fr','Documents informatisÃ©s',0),(582439,16179,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ã‚»ãƒƒãƒˆ',0),(582440,16179,'pt','Conjuntos de transaÃ§Ã£o',0),(582441,16179,'ru','ÐÐ°Ð±Ð¾Ñ€Ñ‹ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹',0),(582442,16179,'es','Sistemas de transacciÃ³n',0),(582443,16179,'de','TransaktionssÃ¤tze',0),(582444,16179,'en','Transaction Sets',0),(582445,16180,'is','',0),(582446,16180,'dr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ unposted Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(582447,16180,'pr','Ù…Ø¬Ù…ÙˆØ¹Ù‡ unposted Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(582448,16180,'tr','Deftere nakledilmemiÅŸ hareket kÃ¼meleri',0),(582449,16180,'pl','Zestawy niezaksiÄ™gowanych transakcji',0),(582450,16180,'bg','ÐÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚Ð¸',0),(582451,16180,'ur','Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø³ÛŒÙ¹ Ú©Ø±ØªØ§ ÛÛ’',0),(582452,16180,'sr','Ð¡ÐºÑƒÐ¿Ð¾Ð²Ð¸ Ð½ÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ðµ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(582453,16180,'vi','Táº­p há»£p cÃ¡c giao dá»‹ch',0),(582454,16180,'af','Unposted transaksie stelle',0),(582455,16180,'ro','Seturi de tranzacÅ£ie neÃ®nregistrate',0),(582456,16180,'et','Konteerimata tehingu komplekti',0),(582457,16180,'si','Neobjavljene transakcije sklopov',0),(582458,16180,'ba','Set unposted transaksi',0),(582459,16180,'nl','Niet-geboekte transactie Sets',0),(582460,16180,'fi','Kirjaamaton tapahtuma asetetaan',0),(582461,16180,'no','Ikke-posterte transaksjonen sett',0),(582462,16180,'da','Ikke-bogfÃ¸rte transaktion sÃ¦t',0),(582463,16180,'ko','ê²Œì‹œ ë˜ì§€ ì•Šì€ íŠ¸ëžœìž­ì…˜ ì§‘í•©',0),(582464,16180,'he','×¢×¨×›×•×ª ×ª× ×•×¢×” ×©×œ× × ×¨×©×ž×”',0),(582465,16180,'el','ÎœÎ· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ·Î¼Î­Î½ÎµÏ‚ ÏƒÏ…Î½Î±Î»Î»Î±Î³ÏŽÎ½ ÏƒÏÎ½Î¿Î»Î±',0),(582466,16180,'zh','æœªè¿‡å¸çš„äº¤æ˜“è®°å½•é›†',0),(582467,16180,'sv','Ej bokfÃ¶rda transaktionen uppsÃ¤ttningar',0),(582468,16180,'it','Set di transazioni non registrate',0),(582469,16180,'tl','',0),(582470,16180,'th','à¸Šà¸¸à¸”à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¹„à¸”à¹‰à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(582471,16180,'hi','Unposted à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¸à¥‡à¤Ÿ',0),(582472,16180,'ms','Set urus niaga unposted',0),(582473,16180,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª ØºÙŠØ± Ø§Ù„Ù…Ù†Ø´ÙˆØ±Ø©',0),(582474,16180,'fr','Jeux de transactions non validÃ©s',0),(582475,16180,'jp','æœªé€ä¿¡ã®ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ ã‚»ãƒƒãƒˆ',0),(582476,16180,'pt','Conjuntos de transaÃ§Ã£o nÃ£o lanÃ§adas',0),(582477,16180,'ru','ÐÐ°Ð±Ð¾Ñ€Ñ‹ Ð½ÐµÑ€Ð°Ð·Ð½ÐµÑÐµÐ½Ð½Ñ‹Ðµ Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹',0),(582478,16180,'es','Sistemas de transacciÃ³n no contabilizada',0),(582479,16180,'de','Nicht gebuchte TransaktionssÃ¤tze',0),(582480,16180,'en','Unposted Transaction Sets',0),(582481,16181,'is','',0),(582482,16181,'dr','Ù…Ø³ØªÙ‚ÛŒÙ… GL Ù‡Ø§ Ø®ÙˆØ¨',0),(582483,16181,'pr','Ù…Ø³ØªÙ‚ÛŒÙ… GL Ù‡Ø§ Ø®ÙˆØ¨',0),(582484,16181,'tr','GL giriÅŸleri Tamam doÄŸrudan',0),(582485,16181,'pl','BezpoÅ›rednie GL wpisy OK',0),(582486,16181,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ GL Ð·Ð°Ð¿Ð¸ÑÐ¸ OK',0),(582487,16181,'ur','Ø¬ÛŒØ¬Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Û’ Ù„ÛŒÛ’ Ù¹Ú¾ÛŒÚ© ÛÛ’ Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª',0),(582488,16181,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ñ€ÐµÐ´Ñƒ',0),(582489,16181,'vi','Trá»±c tiáº¿p cÃ¡c má»¥c GL OK',0),(582490,16181,'af','Direkte GL inskrywings OK',0),(582491,16181,'ro','Directe GL intrÄƒrile OK',0),(582492,16181,'et','Otsene GL kanded OK',0),(582493,16181,'si','Neposredno GL postavke OK',0),(582494,16181,'ba','Langsung GL entri OK',0),(582495,16181,'nl','Directe GL posten OK',0),(582496,16181,'fi','Suoraa GL OK',0),(582497,16181,'no','Direkte GL oppfÃ¸ringer OK',0),(582498,16181,'da','Direkte GL poster OK',0),(582499,16181,'ko','ì§ì ‘ GL í•­ëª© í™•ì¸',0),(582500,16181,'he','×™×©×™×¨ GL ×¢×¨×›×™× ×‘×¡×“×¨',0),(582501,16181,'el','Î‘Ï€ÎµÏ…Î¸ÎµÎ¯Î±Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ Î³/Î» OK',0),(582502,16181,'zh','ç›´æŽ¥ GL æ¡ç›®ç¡®å®š',0),(582503,16181,'sv','Direkt GL poster OK',0),(582504,16181,'it','Diretto GL voci OK',0),(582505,16181,'tl','',0),(582506,16181,'th','à¸•à¸£à¸‡à¸£à¸²à¸¢à¸à¸²à¸£ GL OK',0),(582507,16181,'hi','GL à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ OK à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤·',0),(582508,16181,'ms','Terus masukan GL OK',0),(582509,16181,'ar','ØªÙˆØ¬ÙŠÙ‡ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª GL Ù…ÙˆØ§ÙÙ‚',0),(582510,16181,'fr','Direct GL entrÃ©es OK',0),(582511,16181,'jp','GL ã‚¨ãƒ³ãƒˆãƒª [ok] ã‚’ç›´æŽ¥ã—ã¾ã™ã€‚',0),(582512,16181,'pt','Direto GL entradas Okey',0),(582513,16181,'ru','ÐŸÑ€ÑÐ¼Ð°Ñ GL Ð·Ð°Ð¿Ð¸ÑÐ¸ OK',0),(582514,16181,'es','Directa GL entradas OK',0),(582515,16181,'de','Direkte Sachposten \"OK\"',0),(582516,16181,'en','Direct GL Entries OK',0),(582517,16182,'is','',0),(582518,16182,'dr','Ø¨Ø§ÛŒØ¯ Ù¾Ø³ Ø§Ø²',0),(582519,16182,'pr','Ø¨Ø§ÛŒØ¯ Ù¾Ø³ Ø§Ø²',0),(582520,16182,'tr','Sonra olmalÄ±dÄ±r',0),(582521,16182,'pl','Musi byÄ‡ po',0),(582522,16182,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ ÑÐ»ÐµÐ´',0),(582523,16182,'ur','Ú©Û’ Ø¨Ø¹Ø¯ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(582524,16182,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ñ˜Ðµ Ð½Ð°ÐºÐ¾Ð½',0),(582525,16182,'vi','Pháº£i sau khi',0),(582526,16182,'af','Moet word na',0),(582527,16182,'ro','Trebuie sÄƒ fie dupÄƒ',0),(582528,16182,'et','Tuleb pÃ¤rast',0),(582529,16182,'si','Mora biti po',0),(582530,16182,'ba','Setelah',0),(582531,16182,'nl','Moet na',0),(582532,16182,'fi','On oltava jÃ¤lkeen',0),(582533,16182,'no','MÃ¥ vÃ¦re etter',0),(582534,16182,'da','Skal efter',0),(582535,16182,'ko','í›„ì— í•´ì•¼',0),(582536,16182,'he','×‘×˜×— ××—×¨×™',0),(582537,16182,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼ÎµÏ„Î¬',0),(582538,16182,'zh','å¿…é¡»åœ¨åŽ',0),(582539,16182,'sv','MÃ¥ste efter',0),(582540,16182,'it','Deve essere dopo',0),(582541,16182,'tl','',0),(582542,16182,'th','à¸•à¹‰à¸­à¸‡à¹„à¸¡à¹ˆ',0),(582543,16182,'hi','à¤•à¥‡ à¤¬à¤¾à¤¦ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(582544,16182,'ms','Mesti selepas',0),(582545,16182,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø¨Ø¹Ø¯',0),(582546,16182,'fr','Doit Ãªtre aprÃ¨s',0),(582547,16182,'jp','å¾Œã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(582548,16182,'pt','Deve ser depois',0),(582549,16182,'ru','Ð”Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ Ð¿Ð¾ÑÐ»Ðµ',0),(582550,16182,'es','Debe ser despuÃ©s de',0),(582551,16182,'de','Muss nach',0),(582552,16182,'en','Must Be After',0),(582553,16183,'is','',0),(582554,16183,'dr','Ø¯Ø± Ø§ÛŒÙ† Ù…Ø§Ù‡',0),(582555,16183,'pr','Ø¯Ø± Ø§ÛŒÙ† Ù…Ø§Ù‡',0),(582556,16183,'tr','Bu ay deÄŸil',0),(582557,16183,'pl','Nie w tych miesiÄ…cach',0),(582558,16183,'bg','ÐÐµ Ð² Ñ‚ÐµÐ·Ð¸ Ð¼ÐµÑÐµÑ†Ð¸',0),(582559,16183,'ur','Ø§Ù† Ù…ÛÛŒÙ†ÙˆÚº Ù…ÛŒÚº Ù†ÛÛŒÚº',0),(582560,16183,'sr','ÐÐµ Ñƒ Ð¾Ð²Ð¸Ñ… Ð¼ÐµÑÐµÑ†Ð¸',0),(582561,16183,'vi','KhÃ´ng pháº£i trong nhá»¯ng thÃ¡ng',0),(582562,16183,'af','Nie In hierdie maande',0),(582563,16183,'ro','Nu Ã®n aceste luni',0),(582564,16183,'et','Nendes kuudes',0),(582565,16183,'si','Ne v teh mesecih',0),(582566,16183,'ba','Tidak dalam bulan ini',0),(582567,16183,'nl','Niet In deze maanden',0),(582568,16183,'fi','NÃ¤issÃ¤ kuukausissa',0),(582569,16183,'no','Ikke i disse mÃ¥nedene',0),(582570,16183,'da','Ikke i disse mÃ¥neder',0),(582571,16183,'ko','ì´ ë‹¬ì—',0),(582572,16183,'he','×œ× ×‘×—×•×“×©×™× ×”××œ×”',0),(582573,16183,'el','Î”ÎµÎ½ ÏƒÎµ Î±Ï…Ï„Î¿ÏÏ‚ Ï„Î¿Ï…Ï‚ Î¼Î®Î½ÎµÏ‚',0),(582574,16183,'zh','ä¸åœ¨è¿™å‡ ä¸ªæœˆ',0),(582575,16183,'sv','Inte under dessa mÃ¥nader',0),(582576,16183,'it','Non In questi mesi',0),(582577,16183,'tl','',0),(582578,16183,'th','à¹ƒà¸™à¹€à¸”à¸·à¸­à¸™à¸™à¸µà¹‰',0),(582579,16183,'hi','à¤‡à¤¨ à¤®à¤¹à¥€à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚',0),(582580,16183,'ms','Tidak pada bulan-bulan ini',0),(582581,16183,'ar','Ù„ÙŠØ³ ÙÙŠ Ù‡Ø°Ù‡ Ø§Ù„Ø£Ø´Ù‡Ø±',0),(582582,16183,'fr','Pas dans ces mois',0),(582583,16183,'jp','ã“ã‚Œã‚‰ã®æœˆã§ã¯ãªã',0),(582584,16183,'pt','NÃ£o nos Ãºltimos meses',0),(582585,16183,'ru','ÐÐµ Ð² ÑÑ‚Ð¸ Ð¼ÐµÑÑÑ†Ñ‹',0),(582586,16183,'es','No en estos meses',0),(582587,16183,'de','Nicht In diesen Monaten',0),(582588,16183,'en','Not In These Months',0),(582589,16184,'is','',0),(582590,16184,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ ÛŒÚ© Ø¯ÙˆØ±Ù‡ Ø¨Ø§Ø² Ùˆ ÛŒØ§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø®ÙˆØ¯Ú©Ø§Ø± Ù¾Ø³Øª',0),(582591,16184,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ ÛŒÚ© Ø¯ÙˆØ±Ù‡ Ø¨Ø§Ø² Ùˆ ÛŒØ§ Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø§Ø² Ø®ÙˆØ¯Ú©Ø§Ø± Ù¾Ø³Øª',0),(582592,16184,'tr','AÃ§Ä±k bir dÃ¶nem iÃ§in nakil veya otomatik yazÄ± kullanÄ±n',0),(582593,16184,'pl','OgÅ‚osiÄ‡ otwarty okres lub uÅ¼yÄ‡ Auto Post',0),(582594,16184,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ ÐºÑŠÐ¼ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´ Ð¸Ð»Ð¸ Ð´Ð° Ð¸Ð·Ð¿Ð¾Ð»Ð·Ð²Ð°Ñ‚Ðµ Auto Post',0),(582595,16184,'ur','Ø§ÛŒÚ© Ú©Ú¾Ù„ÛŒ Ù…Ø¯Øª Ú©Û’ Ù„Ø¦Û’ Ù¾ÙˆØ³Ù¹ ÛŒØ§ Ø®ÙˆØ¯ Ø¹ÛØ¯Û’ Ú©Ø§ Ø§Ø³ØªØ¹Ù…Ø§Ù„',0),(582596,16184,'sr','ÐšÑšÐ¸Ð¶ÐµÑšÐµ Ð½Ð° Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾Ð¼ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñƒ Ð¸Ð»Ð¸ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸Ñ‚Ðµ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ ÐºÑšÐ¸Ð¶ÐµÑšÐµ',0),(582597,16184,'vi','Gá»­i Ä‘áº¿n má»™t khoáº£ng thá»i gian má»Ÿ cá»­a hoáº·c sá»­ dá»¥ng tá»± Ä‘á»™ng Ä‘Äƒng bÃ i',0),(582598,16184,'af','Plaas na \'n oop periode of gebruik outomatiese Post',0),(582599,16184,'ro','Posta la o perioadÄƒ de deschidere sau de a folosi Auto Post',0),(582600,16184,'et','Avatud iga-postitada vÃµi kasutada Auto postitust',0),(582601,16184,'si','Objava na odprto obdobje ali uporabite Auto Post',0),(582602,16184,'ba','Posting ke periode yang terbuka atau menggunakan Auto posting',0),(582603,16184,'nl','Plaatsen met een Open periode of Auto-Post te gebruiken',0),(582604,16184,'fi','LÃ¤hetÃ¤ avoin kausi tai kÃ¤yttÃ¤Ã¤ Auto Post',0),(582605,16184,'no','Legge til en Ã¥pen periode eller bruke Auto Post',0),(582606,16184,'da','BogfÃ¸re til en Ã¥ben periode eller bruge Auto Post',0),(582607,16184,'ko','ì˜¤í”ˆ ê¸°ê°„ì„ ê²Œì‹œ í•˜ê±°ë‚˜ ìžë™ ê²Œì‹œë¬¼ì„ ì‚¬ìš© í•˜ ì—¬',0),(582608,16184,'he','×¤×•×¡×˜ ×ª×§×•×¤×” ×¤×ª×•×— ××• ×œ×”×©×ª×ž×© ××•×˜×•×ž×˜×™ ×¤×•×¡×˜',0),(582609,16184,'el','Î˜Î­ÏƒÎ· ÏƒÎµ Î¼Î¹Î± Î±Î½Î¿Î¹Ï‡Ï„Î® Ï€ÎµÏÎ¯Î¿Î´Î¿ Î® Î½Î± Ï‡ÏÎ·ÏƒÎ¹Î¼Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î·Î½ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Î´Î·Î¼Î¿ÏƒÎ¯ÎµÏ…ÏƒÎ·',0),(582610,16184,'zh','è¿‡å¸åˆ°å¼€æ”¾æœŸé—´æˆ–ä½¿ç”¨è‡ªåŠ¨å…¬å‘Š',0),(582611,16184,'sv','Publicera till en Ã¶ppen Period eller anvÃ¤nda Auto Post',0),(582612,16184,'it','Registrare un periodo aperto o utilizzare Auto Post',0),(582613,16184,'tl','',0),(582614,16184,'th','à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸à¸²à¸£à¹€à¸›à¸´à¸” à¸«à¸£à¸·à¸­à¹ƒà¸Šà¹‰à¹‚à¸žà¸ªà¸•à¹Œà¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(582615,16184,'hi','à¤à¤• à¤–à¥à¤²à¤¾ à¤…à¤µà¤§à¤¿ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¯à¤¾ à¤¸à¥à¤µà¤¤: à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¥‡à¤‚',0),(582616,16184,'ms','Post untuk tempoh yang terbuka atau menggunakan Auto Post',0),(582617,16184,'ar','ÙˆØ¸ÙŠÙØ© Ù„ÙØªØ±Ø© Ù…ÙØªÙˆØ­Ø© Ø£Ùˆ Ø§Ø³ØªØ®Ø¯Ø§Ù… ÙˆØ¸ÙŠÙØ© Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(582618,16184,'fr','Poste pour une pÃ©riode ouverte ou utiliser Auto Post',0),(582619,16184,'jp','ã‚ªãƒ¼ãƒ—ãƒ³æœŸé–“ã«æŠ•ç¨¿ã‚„è‡ªå‹•æŠ•ç¨¿ã‚’ä½¿ç”¨',0),(582620,16184,'pt','Postar um perÃ­odo aberto ou usar Auto Post',0),(582621,16184,'ru','ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ñ‚ÑŒ Ð´Ð»Ñ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ð¾Ð³Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð¸Ð»Ð¸ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Auto Post',0),(582622,16184,'es','Publicar en un perÃ­odo abierto o utilizar Auto Post',0),(582623,16184,'de','Auf einer offenen Periode bereitstellen Sie oder verwenden Sie Auto Post',0),(582624,16184,'en','Post To An Open Period Or Use Auto Post',0),(582625,16185,'is','',0),(582626,16185,'dr','Ú©ÙˆÙ¾Ù† Ø§Ø² Ù…Ø§Ù‡ Ø¨Ø³ØªÙ‡ Ø´Ø¯ Unpost Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯',0),(582627,16185,'pr','Ú©ÙˆÙ¾Ù† Ø§Ø² Ù…Ø§Ù‡ Ø¨Ø³ØªÙ‡ Ø´Ø¯ Unpost Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯',0),(582628,16185,'tr','FiÅŸler kapalÄ± bir ay Unpost olamaz',0),(582629,16185,'pl','Nie Unpost bony z zamkniÄ™tym miesiÄ…cu',0),(582630,16185,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Unpost Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸ Ð¾Ñ‚ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½ Ð¼ÐµÑÐµÑ†',0),(582631,16185,'ur','ÙˆÙˆÚ†Ø±Ø² Ø¨Ù†Ø¯ Ù…ÛÛŒÙ†Û’ Ø³Û’ Ø§Ù†Ù¾ÙˆØ³Ù¹ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(582632,16185,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¿Ð¾Ð²ÑƒÐ¸Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ Ð¸Ð· Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸Ñ… Ð¼ÐµÑÐµÑ†',0),(582633,16185,'vi','KhÃ´ng thá»ƒ Unpost chá»©ng tá»« tá»« má»™t thÃ¡ng Ä‘Ã³ng cá»­a',0),(582634,16185,'af','Bewyse van \'n geslote maand kan Unpost',0),(582635,16185,'ro','Nu Unpost bonuri la o lunÄƒ Ã®nchis',0),(582636,16185,'et','Ei saa Unpost kanded suletud kuu',0),(582637,16185,'si','Ne morem Unpost kuponi iz zaprtih mesec',0),(582638,16185,'ba','Tidak Unpost voucher dari sebulan tertutup',0),(582639,16185,'nl','Vouchers kunnen niet Unpost van een gesloten maand',0),(582640,16185,'fi','Ei Unpost suljetun kuukauden tositteet',0),(582641,16185,'no','Kan ikke Unpost kuponger fra lukkede mÃ¥neden',0),(582642,16185,'da','Kan ikke Unpost gavekort fra en lukket mÃ¥ned',0),(582643,16185,'ko','ë‹«ížŒëœ ë‹¬ì—ì„œ ìƒí’ˆê¶Œì„ Unpost ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(582644,16185,'he','×œ× ×™×›×•×œ Unpost ×©×•×‘×¨×™× ×©×œ ×—×•×“×© ×¡×’×•×¨',0),(582645,16185,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„ÏŒ Î½Î± Unpost ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î± Î±Ï€ÏŒ Î­Î½Î± Î¼Î®Î½Î± ÎºÎ»ÎµÎ¹ÏƒÏ„Î¬',0),(582646,16185,'zh','ä¸èƒ½ä»Žä¸€ä¸ªå°é—­çš„æœˆ Unpost å‡­è¯',0),(582647,16185,'sv','Kan inte Unpost kuponger frÃ¥n en sluten mÃ¥nad',0),(582648,16185,'it','Non puÃ² Unpost i buoni da un mese chiuso',0),(582649,16185,'tl','',0),(582650,16185,'th','à¹„à¸¡à¹ˆ Unpost à¸ªà¸³à¸„à¸±à¸à¸ˆà¸²à¸à¹€à¸”à¸·à¸­à¸™à¸›à¸´à¸”',0),(582651,16185,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤à¤• à¤¬à¤‚à¤¦ à¤®à¤¹à¥€à¤¨à¥‡ à¤¸à¥‡ Unpost à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(582652,16185,'ms','Tidak boleh Unpost baucer dari sebulan tertutup',0),(582653,16185,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø£ÙˆÙ†Ø¨ÙˆØ³Øª Ù‚Ø³Ø§Ø¦Ù… Ù…Ù† Ø´Ù‡Ø± Ù…ØºÙ„Ù‚Ø©',0),(582654,16185,'fr','Ne peut pas Unpost bons un mois fermÃ©',0),(582655,16185,'jp','çµ‚äº†æœˆã‹ã‚‰ãƒã‚¦ãƒãƒ£ãƒ¼ã‚’é–¢é€£ä»˜ã‘ãŸã‚Šã§ãã¾ã›ã‚“ã€‚',0),(582656,16185,'pt','NÃ£o posso Unpost Vouchers de um mÃªs fechado',0),(582657,16185,'ru','ÐÐµ Unpost Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹ Ð¾Ñ‚ Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¾Ð³Ð¾ Ð¼ÐµÑÑÑ†Ð°',0),(582658,16185,'es','No Unpost vales de un mes cerrado',0),(582659,16185,'de','Gutscheine kÃ¶nnen nicht von einem geschlossenen Monat Unpost werden.',0),(582660,16185,'en','Cannot Unpost Vouchers From A Closed Month',0),(582661,16186,'is','',0),(582662,16186,'dr','Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø±Ø¯ÛŒÙ Ø³Ø±ØµÙØ­Ù‡ Ø¨Ø§Ø´Ø¯',0),(582663,16186,'pr','Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ø±Ø¯ÛŒÙ Ø³Ø±ØµÙØ­Ù‡ Ø¨Ø§Ø´Ø¯',0),(582664,16186,'tr','DosyanÄ±n Ã¼stbilgi satÄ±rÄ± iÃ§ermesi gerekir',0),(582665,16186,'pl','Plik musi zawieraÄ‡ wiersz nagÅ‚Ã³wka',0),(582666,16186,'bg','Ð¤Ð°Ð¹Ð»ÑŠÑ‚ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÑŠÐ´ÑŠÑ€Ð¶Ð° Ð·Ð°Ð³Ð»Ð°Ð²ÐµÐ½ Ñ€ÐµÐ´',0),(582667,16186,'ur','Ù…Ø³Ù„ Ø³Ø±ØªØ­Ø±ÛŒØ± ØµÙ Ú©Ø§ Ø­Ø§Ù…Ù„ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(582668,16186,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð¼Ð¾Ñ€Ð° Ð´Ð° ÑÐ°Ð´Ñ€Ð¶Ð¸ Ñ€ÐµÐ´ Ð·Ð°Ð³Ð»Ð°Ð²Ñ™Ð°',0),(582669,16186,'vi','Tá»‡p pháº£i chá»©a hÃ ng tiÃªu Ä‘á»',0),(582670,16186,'af','Die lÃªer moet die kopskrif ry bevat',0),(582671,16186,'ro','FiÅŸierul trebuie sÄƒ conÈ›inÄƒ un rÃ¢nd antet',0),(582672,16186,'et','Fail peab sisaldama pÃ¤iserida',0),(582673,16186,'si','Dokumentacija mora vsebovati naslovno vrstico',0),(582674,16186,'ba','Berkas harus berisi baris Header',0),(582675,16186,'nl','Het bestand moet de rij met kolomkoppen bevatten',0),(582676,16186,'fi','Tiedoston on sisÃ¤llettÃ¤vÃ¤ otsikkorivi',0),(582677,16186,'no','Filen mÃ¥ inneholde overskriftsraden',0),(582678,16186,'da','Filen skal indeholde overskriftsrÃ¦kken',0),(582679,16186,'ko','íŒŒì¼ì€ ë¨¸ë¦¬ê¸€ í–‰ì„ í¬í•¨ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(582680,16186,'he','×”×§×•×‘×¥ ×—×™×™×‘ ×œ×”×›×™×œ ××ª ×©×•×¨×ª ×”×›×•×ª×¨×ª',0),(582681,16186,'el','Î¤Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€ÎµÏÎ¹Î­Ï‡ÎµÎ¹ Ï„Î· Î³ÏÎ±Î¼Î¼Î® ÎºÎµÏ†Î±Î»Î¯Î´Î±Ï‚',0),(582682,16186,'zh','è¯¥æ–‡ä»¶å¿…é¡»åŒ…å«æ ‡é¢˜è¡Œ',0),(582683,16186,'sv','Filen mÃ¥ste innehÃ¥lla rubrikrad',0),(582684,16186,'it','Il File deve contenere la riga di intestazione',0),(582685,16186,'tl','',0),(582686,16186,'th','à¹à¸Ÿà¹‰à¸¡à¸•à¹‰à¸­à¸‡à¸›à¸£à¸°à¸à¸­à¸šà¸”à¹‰à¸§à¸¢à¹à¸–à¸§à¸ªà¹ˆà¸§à¸™à¸«à¸±à¸§',0),(582687,16186,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¶à¥€à¤°à¥à¤· à¤²à¥‡à¤– à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤®à¥‡à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(582688,16186,'ms','Fail mesti mengandungi baris pengepala',0),(582689,16186,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØ­ØªÙˆÙŠ Ø§Ù„Ù…Ù„Ù Ø¹Ù„Ù‰ ØµÙ Ø§Ù„Ø±Ø£Ø³',0),(582690,16186,'fr','Le fichier doit contenir la ligne dâ€™en-tÃªte',0),(582691,16186,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã¯ã€ãƒ˜ãƒƒãƒ€ãƒ¼è¡Œã‚’å«ã‚ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(582692,16186,'pt','O arquivo deve conter a linha de cabeÃ§alho',0),(582693,16186,'ru','Ð¤Ð°Ð¹Ð» Ð´Ð¾Ð»Ð¶ÐµÐ½ ÑÐ¾Ð´ÐµÑ€Ð¶Ð°Ñ‚ÑŒ ÑÑ‚Ñ€Ð¾ÐºÑƒ Ð·Ð°Ð³Ð¾Ð»Ð¾Ð²ÐºÐ°',0),(582694,16186,'es','El archivo debe contener la fila de encabezado',0),(582695,16186,'de','Die Datei muss der Header-Zeile enthalten.',0),(582696,16186,'en','The File Must Contain The Header Row',0),(582697,16187,'is','',0),(582698,16187,'dr','Ø§Ø±Ø²Ø´ Ø§Ù†ØªØ¸Ø§Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾',0),(582699,16187,'pr','Ø§Ø±Ø²Ø´ Ø§Ù†ØªØ¸Ø§Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾',0),(582700,16187,'tr','DeÄŸer bekleyen sipariÅŸ YazdÄ±r',0),(582701,16187,'pl','WartoÅ›Ä‡ wydruku zleceÅ„ oczekujÄ…cych',0),(582702,16187,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð²Ð¸ÑÑÑ‰Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(582703,16187,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø¢Ø±ÚˆØ±Ø² Ú†Ú¾Ù¾Ø§Ø¦ÛŒ Ù‚Ø¯Ø±',0),(582704,16187,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ \"ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾\" ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(582705,16187,'vi','CÃ¡c giÃ¡ trá»‹ Ä‘ang chá» xá»­ lÃ½ Ä‘Æ¡n Ä‘áº·t hÃ ng in',0),(582706,16187,'af','Waarde hangende druk bestellings',0),(582707,16187,'ro','Valoare Ã®n aÅŸteptarea ordine de imprimare',0),(582708,16187,'et','VÃ¤Ã¤rtus kuni trÃ¼kitÃ¶Ã¶de tellimused',0),(582709,16187,'si','Vrednost ÄakajoÄa naroÄila tiskanja',0),(582710,16187,'ba','Nilai Pending Order cetak',0),(582711,16187,'nl','Waarde in afwachting van Orders afdrukken',0),(582712,16187,'fi','Arvo ennen tulosta tilaukset',0),(582713,16187,'no','Verdien ventende bestilling',0),(582714,16187,'da','VÃ¦rdi indtil aftryksbestillinger',0),(582715,16187,'ko','ì¸ì‡„ ì£¼ë¬¸ ë³´ë¥˜ ê°’',0),(582716,16187,'he','×¢×¨×š ×”×“×¤×¡×” ×”×•×¨××•×ª ×ž×ž×ª×™× ×•×ª',0),(582717,16187,'el','Î¤Î¹Î¼Î® ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(582718,16187,'zh','æ‰“å°æŒ‚å•çš„ä»·å€¼',0),(582719,16187,'sv','VÃ¤rdet pÃ¥gÃ¥ende utskriftsbestÃ¤llningar',0),(582720,16187,'it','Valore in attesa di ordini di stampa',0),(582721,16187,'tl','',0),(582722,16187,'th','à¸„à¹ˆà¸²à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(582723,16187,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤²à¤‚à¤¬à¤¿à¤¤ à¤®à¤¾à¤¨',0),(582724,16187,'ms','Nilai cetak pesanan dagangan tertunda',0),(582725,16187,'ar','Ù‚ÙŠÙ…Ø© Ø§Ù†ØªØ¸Ø§Ø± Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(582726,16187,'fr','Valeur dans lâ€™attente de commandes',0),(582727,16187,'jp','ä¿ç•™ä¸­ã®ãƒ—ãƒªãƒ³ãƒˆæ³¨æ–‡å€¤',0),(582728,16187,'pt','Valor imprimir ordens pendentes',0),(582729,16187,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð¾Ñ€Ð´ÐµÑ€Ð°',0),(582730,16187,'es','Valor impresiÃ³n Ã³rdenes pendientes',0),(582731,16187,'de','Wert ausstehenden DruckauftrÃ¤ge',0),(582732,16187,'en','Value Pending Print Orders',0),(582733,16188,'is','',0),(582734,16188,'dr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø«Ø¨Øª',0),(582735,16188,'pr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø«Ø¨Øª',0),(582736,16188,'tr','Pozitif Ã¶deme etkinleÅŸtirmek',0),(582737,16188,'pl','Po pÅ‚atnoÅ›ci dodatnich',0),(582738,16188,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸ Ð¿Ð¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(582739,16188,'ur','Ù…Ø«Ø¨Øª ØªÙ†Ø®ÙˆØ§Û Ø§ÛÙ„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(582740,16188,'sr','ÐžÐ¼Ð¾Ð³ÑƒÑ›Ð¸ Ð¿Ð¾Ð·Ð¸Ñ‚Ð¸Ð²Ð½Ñƒ Ð¿Ð»Ð°Ñ‚Ðµ',0),(582741,16188,'vi','Sá»­ tÃ­ch cá»±c tráº£ tiá»n',0),(582742,16188,'af','Aktiveer positiewe betaal',0),(582743,16188,'ro','Permite plata pozitiv',0),(582744,16188,'et','Lubade kasutada positiivne tasu programmi',0),(582745,16188,'si','OmogoÄiti pozitivno plaÄilo',0),(582746,16188,'ba','Mengaktifkan membayar positif',0),(582747,16188,'nl','Positieve beloning inschakelen',0),(582748,16188,'fi','Ota positiivinen maksu',0),(582749,16188,'no','Aktiver positiv lÃ¸nn',0),(582750,16188,'da','Aktivere Positive lÃ¸n',0),(582751,16188,'ko','ì‚¬ìš© ê¸ì •ì ì¸ ì§€ë¶ˆ',0),(582752,16188,'he','×œ××¤×©×¨ ×ª×©×œ×•× ×—×™×•×‘×™',0),(582753,16188,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¯Î·ÏƒÎ· Î¸ÎµÏ„Î¹ÎºÎ® Pay',0),(582754,16188,'zh','å¯ç”¨ç§¯æžä»˜è–ª',0),(582755,16188,'sv','Aktivera Betalningskontroll',0),(582756,16188,'it','Attivare Pay positivo',0),(582757,16188,'tl','',0),(582758,16188,'th','à¹€à¸›à¸´à¸”à¸šà¸§à¸à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(582759,16188,'hi','à¤¸à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¤•à¥à¤·à¤® à¤•à¤°à¥‡à¤‚',0),(582760,16188,'ms','Membolehkan membayar positif',0),(582761,16188,'ar','ØªÙ…ÙƒÙŠÙ† Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø¨ÙŠ',0),(582762,16188,'fr','Activez la rÃ©munÃ©ration Positive',0),(582763,16188,'jp','è‚¯å®šçš„ãªæ”¯æ‰•ã„ã‚’æœ‰åŠ¹ã«ã—ã¾ã™ã€‚',0),(582764,16188,'pt','Permitir o pagamento positivo',0),(582765,16188,'ru','Ð’ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ðµ Ð¿Ð¾Ð·Ð¸Ñ‚Ð¸Ð²Ð½Ð¾Ð³Ð¾ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(582766,16188,'es','Permiten pago positivo',0),(582767,16188,'de','Positive Zahlen zu ermÃ¶glichen',0),(582768,16188,'en','Enable Positive Pay',0),(582769,16189,'is','',0),(582770,16189,'dr','Ù„ÛŒØ³Øª Ø§Ø±Ø²Ø´ Ø§Ù†ØªØ¸Ø§Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾',0),(582771,16189,'pr','Ù„ÛŒØ³Øª Ø§Ø±Ø²Ø´ Ø§Ù†ØªØ¸Ø§Ø± Ø³ÙØ§Ø±Ø´Ø§Øª Ú†Ø§Ù¾',0),(582772,16189,'tr','Liste deÄŸeri bekleyen sipariÅŸ YazdÄ±r',0),(582773,16189,'pl','WartoÅ›Ä‡ listy wydruku zleceÅ„ oczekujÄ…cych',0),(582774,16189,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð¾Ñ‚ ÑÐ¿Ð¸ÑÑŠÐºÐ° Ð²Ð¸ÑÑÑ‰Ð¸ Ð¿ÐµÑ‡Ð°Ñ‚ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(582775,16189,'ur','ÙÛØ±Ø³Øª Ù‚Ø¯Ø± Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø¢Ø±ÚˆØ±Ø² Ú†Ú¾Ù¾Ø§Ø¦ÛŒ',0),(582776,16189,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð»Ð¸ÑÑ‚Ðµ \"ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾\" ÐžÐ´ÑˆÑ‚Ð°Ð¼Ð¿Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³Ðµ',0),(582777,16189,'vi','Danh sÃ¡ch giÃ¡ trá»‹ Ä‘ang chá» xá»­ lÃ½ Ä‘Æ¡n Ä‘áº·t hÃ ng in',0),(582778,16189,'af','Lys waarde hangende druk bestellings',0),(582779,16189,'ro','Valoarea de listÄƒ Ã®n aÅŸteptare comenzi de imprimare',0),(582780,16189,'et','LoendivÃ¤Ã¤rtuse kuni trÃ¼kitÃ¶Ã¶de tellimused',0),(582781,16189,'si','Vrednost seznama ÄakajoÄa naroÄila tiskanja',0),(582782,16189,'ba','Daftar nilai Pending Order cetak',0),(582783,16189,'nl','Lijstwaarde in afwachting van Orders afdrukken',0),(582784,16189,'fi','Luetteloarvon kunnes tulosta tilaukset',0),(582785,16189,'no','Listeverdien ventende bestilling',0),(582786,16189,'da','ListevÃ¦rdi indtil aftryksbestillinger',0),(582787,16189,'ko','ì¸ì‡„ ì£¼ë¬¸ ë³´ë¥˜ ëª©ë¡ ê°’',0),(582788,16189,'he','×¢×¨×š ×¨×©×™×ž×ª ×ž×ž×ª×™× ×™× ×”×“×¤×¡×•×ª',0),(582789,16189,'el','Î¤Î¹Î¼Î® Î»Î¯ÏƒÏ„Î±Ï‚ ÎµÎºÎºÏÎµÎ¼ÏŽÎ½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½ ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·Ï‚',0),(582790,16189,'zh','æ‰“å°æŒ‚å•çš„åˆ—è¡¨å€¼',0),(582791,16189,'sv','ListvÃ¤rde vÃ¤ntande utskriftsbestÃ¤llningar',0),(582792,16189,'it','Valore dell\'elenco in attesa di ordini di stampa',0),(582793,16189,'tl','',0),(582794,16189,'th','à¸„à¹ˆà¸²à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸­à¸žà¸´à¸¡à¸žà¹Œà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(582795,16189,'hi','à¤®à¥à¤¦à¥à¤°à¤£ à¤†à¤¦à¥‡à¤¶ à¤²à¤‚à¤¬à¤¿à¤¤ à¤¸à¥‚à¤šà¥€ à¤®à¤¾à¤¨',0),(582796,16189,'ms','Nilai senarai menunggu pesanan cetakan',0),(582797,16189,'ar','Ù‚ÙŠÙ…Ø© Ù‚Ø§Ø¦Ù…Ø© Ø§Ù†ØªØ¸Ø§Ø± Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ø·Ø¨Ø§Ø¹Ø©',0),(582798,16189,'fr','Valeur de la liste en attente dâ€™impression',0),(582799,16189,'jp','ä¿ç•™ä¸­ã®ãƒ—ãƒªãƒ³ãƒˆæ³¨æ–‡ãƒªã‚¹ãƒˆã®å€¤',0),(582800,16189,'pt','Valor de lista imprimir ordens pendentes',0),(582801,16189,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ð¾Ð¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ñ… Ð¿ÐµÑ‡Ð°Ñ‚Ð¸ Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(582802,16189,'es','Valor de lista imprimirlos Ã³rdenes pendientes',0),(582803,16189,'de','Listenwert ausstehenden DruckauftrÃ¤ge',0),(582804,16189,'en','List Value Pending Print Orders',0),(582805,16190,'is','',0),(582806,16190,'dr','Ø§Ø±Ø²Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø­Ø§Ù„ Ø§Ù†ØªØ·Ø§Ø±',0),(582807,16190,'pr','Ø§Ø±Ø²Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø­Ø§Ù„ Ø§Ù†ØªØ·Ø§Ø±',0),(582808,16190,'tr','DeÄŸer bekleyen sipariÅŸler',0),(582809,16190,'pl','WartoÅ›Ä‡ zlecenia oczekujÄ…ce',0),(582810,16190,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð½Ð° Ð²Ð¸ÑÑÑ‰Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(582811,16190,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø¢Ø±ÚˆØ±Ø² Ú©ÛŒ Ù‚Ø¯Ø±',0),(582812,16190,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ°',0),(582813,16190,'vi','CÃ¡c giÃ¡ trá»‹ Ä‘ang chá» xá»­ lÃ½ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(582814,16190,'af','Waarde hangende bestellings',0),(582815,16190,'ro','Valoare Ã®n aÅŸteptarea comenzilor',0),(582816,16190,'et','VÃ¤Ã¤rtus kuni tellimused',0),(582817,16190,'si','Vrednost ÄakajoÄa naroÄila',0),(582818,16190,'ba','Nilai Pending Order',0),(582819,16190,'nl','Waarde in afwachting van Orders',0),(582820,16190,'fi','Arvo odottavien toimeksiantojen',0),(582821,16190,'no','Verdien ventende bestillinger',0),(582822,16190,'da','VÃ¦rdi afventende ordrer',0),(582823,16190,'ko','ì£¼ë¬¸ ë³´ë¥˜ ê°’',0),(582824,16190,'he','×¢×¨×š ×”×•×¨××•×ª ×ž×ž×ª×™× ×•×ª',0),(582825,16190,'el','Î¤Î¹Î¼Î® ÎµÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(582826,16190,'zh','æŒ‚å•çš„ä»·å€¼',0),(582827,16190,'sv','VÃ¤rdet avvaktande ordrar',0),(582828,16190,'it','Valore ordini pendenti',0),(582829,16190,'tl','',0),(582830,16190,'th','à¸¡à¸¹à¸¥à¸„à¹ˆà¸²à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(582831,16190,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤‘à¤°à¥à¤¡à¤° à¤®à¤¾à¤¨',0),(582832,16190,'ms','Nilai pesanan dagangan tertunda',0),(582833,16190,'ar','Ù‚ÙŠÙ…Ø© Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(582834,16190,'fr','Valeur de commandes en attente',0),(582835,16190,'jp','ä¿ç•™ä¸­ã®æ³¨æ–‡ã®å€¤',0),(582836,16190,'pt','Valor de ordens pendentes',0),(582837,16190,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¾Ñ‚Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ñ€Ð´ÐµÑ€Ð¾Ð²',0),(582838,16190,'es','Valor de Ã³rdenes pendientes',0),(582839,16190,'de','Wert noch nicht erledigten AuftrÃ¤ge',0),(582840,16190,'en','Value Pending Orders',0),(582841,16191,'is','',0),(582842,16191,'dr','Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø´Ø§Ù…Ù„',0),(582843,16191,'pr','Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø´Ø§Ù…Ù„',0),(582844,16191,'tr','Ä°Ã§ermemelidir',0),(582845,16191,'pl','Nie powinny zawieraÄ‡',0),(582846,16191,'bg','ÐÐµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð²ÐºÐ»ÑŽÑ‡Ð²Ð°',0),(582847,16191,'ur','Ø´Ø§Ù…Ù„ Ù†ÛÛŒÚº ÛÙˆÙ†Ø§ Ú†Ø§ÛØ¦Û’',0),(582848,16191,'sr','ÐÐµ ÑÐ¼Ðµ Ð´Ð° ÑÐ°Ð´Ñ€Ð¶Ð¸',0),(582849,16191,'vi','KhÃ´ng bao gá»“m',0),(582850,16191,'af','Moet insluit nie',0),(582851,16191,'ro','Nu trebuie sÄƒ includÄƒ',0),(582852,16191,'et','Ei tohiks hÃµlmata',0),(582853,16191,'si','Ne sme vkljuÄevati',0),(582854,16191,'ba','Tidak termasuk',0),(582855,16191,'nl','Moet niet bevatten',0),(582856,16191,'fi','Saa sisÃ¤ltÃ¤Ã¤',0),(582857,16191,'no','Kan ikke inkludere',0),(582858,16191,'da','BÃ¸r ikke omfatte',0),(582859,16191,'ko','í¬í•¨ í•´ì„œëŠ” ì•ˆ',0),(582860,16191,'he','×œ× ×¦×¨×™×š ×œ×›×œ×•×œ',0),(582861,16191,'el','Î”ÎµÎ½ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½ÎµÎ¹',0),(582862,16191,'zh','ä¸åº”åŒ…æ‹¬',0),(582863,16191,'sv','BÃ¶r inte omfatta',0),(582864,16191,'it','Non deve includere',0),(582865,16191,'tl','',0),(582866,16191,'th','à¹„à¸¡à¹ˆà¸„à¸§à¸£à¸¡à¸µ',0),(582867,16191,'hi','à¤¶à¤¾à¤®à¤¿à¤² à¤¨à¤¹à¥€à¤‚ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(582868,16191,'ms','Tidak termasuk',0),(582869,16191,'ar','Ù„Ø§ ÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ØªØ´Ù…Ù„',0),(582870,16191,'fr','Ne doit pas inclure',0),(582871,16191,'jp','å«ã‚ã‚‹ã“ã¨ã¯ã§ãã¾ã›ã‚“ã€‚',0),(582872,16191,'pt','NÃ£o deve incluir',0),(582873,16191,'ru','ÐÐµ ÑÐ»ÐµÐ´ÑƒÐµÑ‚ Ð²ÐºÐ»ÑŽÑ‡Ð°Ñ‚ÑŒ',0),(582874,16191,'es','No debe incluir',0),(582875,16191,'de','Darf nicht enthalten',0),(582876,16191,'en','Should Not Include',0),(582877,16192,'is','',0),(582878,16192,'dr','ØªÙ†Ø¸ÛŒÙ… Ú©Ù„ÛŒØ¯',0),(582879,16192,'pr','ØªÙ†Ø¸ÛŒÙ… Ú©Ù„ÛŒØ¯',0),(582880,16192,'tr','AnahtarÄ± ayarlanmamÄ±ÅŸ',0),(582881,16192,'pl','Nie ustawiony klucz',0),(582882,16192,'bg','ÐšÐ»ÑŽÑ‡ Ð½Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²ÑÐ¼',0),(582883,16192,'ur','Ú©Ù„ÛŒØ¯ Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(582884,16192,'sr','ÐšÑ™ÑƒÑ‡ Ð½Ð¸Ñ˜Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(582885,16192,'vi','KhÃ³a khÃ´ng Ä‘Æ°á»£c thiáº¿t láº­p',0),(582886,16192,'af','Sleutel stel nie',0),(582887,16192,'ro','Nu setatÄƒ cheia',0),(582888,16192,'et','VÃµti pole mÃ¤Ã¤ratud',0),(582889,16192,'si','KljuÄ ni nastavljen',0),(582890,16192,'ba','Kunci tidak diatur',0),(582891,16192,'nl','Sleutel niet is ingesteld',0),(582892,16192,'fi','Avain ei ole mÃ¤Ã¤ritetty',0),(582893,16192,'no','NÃ¸kkel ikke angitt',0),(582894,16192,'da','NÃ¸gle ikke indstillet',0),(582895,16192,'ko','í‚¤ë¥¼ ì„¤ì • í•˜ì§€',0),(582896,16192,'he','×œ× ×œ×”×’×“×™×¨ ×ž×¤×ª×—',0),(582897,16192,'el','Î¤Î¿ ÎºÎ»ÎµÎ¹Î´Î¯ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(582898,16192,'zh','æ²¡æœ‰è®¾ç½®é¡¹',0),(582899,16192,'sv','Nyckeln inte instÃ¤lld',0),(582900,16192,'it','Chiave non impostata',0),(582901,16192,'tl','',0),(582902,16192,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸„à¸µà¸¢à¹Œ',0),(582903,16192,'hi','à¤•à¥à¤‚à¤œà¥€ à¤•à¥‹ à¤¸à¥‡à¤Ÿ à¤¨à¤¹à¥€à¤‚',0),(582904,16192,'ms','Kekunci tidak disetkan',0),(582905,16192,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…ÙØªØ§Ø­',0),(582906,16192,'fr','ClÃ© non dÃ©finie',0),(582907,16192,'jp','ã‚­ãƒ¼ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(582908,16192,'pt','Chave nÃ£o definida',0),(582909,16192,'ru','ÐšÐ»ÑŽÑ‡ Ð½Ðµ Ð·Ð°Ð´Ð°Ð½',0),(582910,16192,'es','No configura la clave de',0),(582911,16192,'de','SchlÃ¼ssel nicht festgelegt',0),(582912,16192,'en','Key Not Set',0),(582913,16193,'is','',0),(582914,16193,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… API',0),(582915,16193,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… API',0),(582916,16193,'tr','API gÃ¼nlÃ¼ÄŸe kaydetme',0),(582917,16193,'pl','Rejestrowania interfejsu API',0),(582918,16193,'bg','API ÑÐµÑ‡',0),(582919,16193,'ur','API Ù„Ø§Ú¯ Ø§Ù†',0),(582920,16193,'sr','Ð’Ð¾Ñ’ÐµÑšÐµ ÐµÐ²Ð¸Ð´ÐµÐ½Ñ†Ð¸Ñ˜Ðµ Ð¾ ÐÐŸÐ˜',0),(582921,16193,'vi','API Ä‘Äƒng nháº­p',0),(582922,16193,'af','API loghouding',0),(582923,16193,'ro','API de logare',0),(582924,16193,'et','API metsaraie',0),(582925,16193,'si','API seÄnje',0),(582926,16193,'ba','API Logging',0),(582927,16193,'nl','API-logboekregistratie',0),(582928,16193,'fi','API kirjaaminen',0),(582929,16193,'no','API Logging',0),(582930,16193,'da','LogfÃ¸ring af API',0),(582931,16193,'ko','API ë¡œê¹…',0),(582932,16193,'he','×¨×™×©×•× API',0),(582933,16193,'el','ÎšÎ±Ï„Î±Î³ÏÎ±Ï†Î®Ï‚ API',0),(582934,16193,'zh','API æ—¥å¿—è®°å½•',0),(582935,16193,'sv','API-loggning',0),(582936,16193,'it','Registrazione API',0),(582937,16193,'tl','',0),(582938,16193,'th','à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸à¸‚à¹‰à¸­à¸¡à¸¹à¸¥ API',0),(582939,16193,'hi','API à¤²à¥‰à¤—à¤¿à¤‚à¤—',0),(582940,16193,'ms','Pembalakan API',0),(582941,16193,'ar','ØªØ³Ø¬ÙŠÙ„ API',0),(582942,16193,'fr','API de journalisation',0),(582943,16193,'jp','API ãƒ­ã‚°',0),(582944,16193,'pt','Logging API',0),(582945,16193,'ru','Ð’ÐµÐ´ÐµÐ½Ð¸Ðµ Ð¶ÑƒÑ€Ð½Ð°Ð»Ð° API',0),(582946,16193,'es','Registro de API',0),(582947,16193,'de','API-Protokollierung',0),(582948,16193,'en','API Logging',0),(582949,16194,'is','',0),(582950,16194,'dr','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ù‡Ø´ Ø¨Ø±Ø§ÛŒ API',0),(582951,16194,'pr','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ù‡Ø´ Ø¨Ø±Ø§ÛŒ API',0),(582952,16194,'tr','Karma iÃ§in API gerektirir',0),(582953,16194,'pl','WymagajÄ… mieszania dla interfejsu API',0),(582954,16194,'bg','Ð˜Ð·Ð¸ÑÐºÐ²Ð°Ñ‚ Ñ…ÐµÑˆ Ð·Ð° API',0),(582955,16194,'ur','ÛÛŒØ´ API Ú©Û’ Ù„Ø¦Û’ Ø¶Ø±ÙˆØ±Øª ÛÙˆØªÛŒ ÛÛ’ Û”',0),(582956,16194,'sr','Ð¥Ð°ÑÑ… Ñ˜Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð° Ð·Ð° ÐÐŸÐ˜',0),(582957,16194,'vi','YÃªu cáº§u bÄƒm cho API',0),(582958,16194,'af','Vereis huts vir API',0),(582959,16194,'ro','Necesita Hash pentru API',0),(582960,16194,'et','NÃµuda Hash API',0),(582961,16194,'si','Zahtevajo Hash za API',0),(582962,16194,'ba','Memerlukan Hash untuk API',0),(582963,16194,'nl','Hash voor API vereist',0),(582964,16194,'fi','Vaatia Hash API',0),(582965,16194,'no','Krev Hash For API',0),(582966,16194,'da','KrÃ¦ve Hash For API',0),(582967,16194,'ko','APIì— ëŒ€ í•œ í•´ì‹œë¥¼ í•„ìš”',0),(582968,16194,'he','×“×¨×•×© ×”-Hash ×¢×‘×•×¨ API',0),(582969,16194,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½ ÎºÎ±Ï„Î±ÎºÎµÏÎ¼Î±Ï„Î¹ÏƒÎ¼Î¿Ï Î³Î¹Î± Ï„Î¿ API',0),(582970,16194,'zh','å“ˆå¸Œè¦æ±‚ API',0),(582971,16194,'sv','KrÃ¤v Hash fÃ¶r API',0),(582972,16194,'it','Richiedono l\'Hash per API',0),(582973,16194,'tl','',0),(582974,16194,'th','à¸•à¹‰à¸­à¸‡à¹à¸®à¸ªà¸³à¸«à¸£à¸±à¸š API',0),(582975,16194,'hi','à¤¹à¥ˆà¤¶ à¤•à¥‡ à¤²à¤¿à¤ API à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(582976,16194,'ms','Memerlukan cincangan untuk API',0),(582977,16194,'ar','ØªØªØ·Ù„Ø¨ ØªØ¬Ø²Ø¦Ø© Ù„ API',0),(582978,16194,'fr','Besoin de hachage pour API',0),(582979,16194,'jp','API ã®ãƒãƒƒã‚·ãƒ¥ã‚’å¿…è¦ã¨ã—ã¾ã™ã€‚',0),(582980,16194,'pt','Exigem o Hash para API',0),(582981,16194,'ru','Ð”Ð»Ñ API Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ñ…ÑÑˆ',0),(582982,16194,'es','Requieren de Hash API',0),(582983,16194,'de','Hash fÃ¼r API erforderlich',0),(582984,16194,'en','Require Hash For API',0),(582985,16195,'is','',0),(582986,16195,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø§ÛŒØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø«Ø¨Øª Ø°Ø®ÛŒØ±Ù‡',0),(582987,16195,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø§ÛŒØ¯ Ù‚Ø¨Ù„ Ø§Ø² Ø±Ø§Ù‡ Ø§Ù†Ø¯Ø§Ø²ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ù…Ø«Ø¨Øª Ø°Ø®ÛŒØ±Ù‡',0),(582988,16195,'tr','Hesap olumlu Ã¶deme ayarÄ± Ã¶nce kaydedilmesi gerekir',0),(582989,16195,'pl','Konto musi byÄ‡ zapisany przed konfiguracji pÅ‚atnoÅ›ci dodatnich',0),(582990,16195,'bg','Ð’Ð½Ð¸Ð¼Ð°Ð½Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½ Ð¿Ñ€ÐµÐ´Ð¸ Ð¿Ð¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(582991,16195,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…Ø«Ø¨Øª ØªÙ†Ø®ÙˆØ§Û Ø³ÛŒÙ¹ Ø§Ù¾ Ø³Û’ Ù‚Ø¨Ù„ Ù…Ø­ÙÙˆØ¸ Ú©ÛŒ Ø¬Ø§Ù†ÛŒ Ú†Ø§ÛÛŒÛ’',0),(582992,16195,'sr','ÐÐ°Ð»Ð¾Ð³ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½ Ð¿Ñ€Ðµ Ð¿Ð¾Ð·Ð¸Ñ‚Ð¸Ð²Ð°Ð½ Ð¿Ð»Ð°Ñ‚Ðµ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ',0),(582993,16195,'vi','TÃ i khoáº£n nÃ y pháº£i Ä‘Æ°á»£c lÆ°u trÆ°á»›c khi thiáº¿t láº­p tráº£ tiá»n tÃ­ch cá»±c',0),(582994,16195,'af','Rekening gestoor moet word voordat positiewe betaal opstelling',0),(582995,16195,'ro','Contul trebuie salvat Ã®nainte de plata pozitiv Setup',0),(582996,16195,'et','Konto tuleb salvestada enne positiivne tasu seadistus',0),(582997,16195,'si','RaÄun morate shraniti pred pozitivno plaÄati Setup',0),(582998,16195,'ba','Rekening harus diselamatkan sebelum membayar positif Setup',0),(582999,16195,'nl','Rekening moet worden opgeslagen voordat de positieve beloning Setup',0),(583000,16195,'fi','Asiakas tÃ¤ytyy tallentaa ennen positiivinen maksuasetukset',0),(583001,16195,'no','Forretningsforbindelsen mÃ¥ lagres fÃ¸r positiv lÃ¸nnsoppsettet',0),(583002,16195,'da','Konto skal gemmes, fÃ¸r Positive lÃ¸nopsÃ¦tning',0),(583003,16195,'ko','ê³„ì • ê¸ì •ì ì¸ ì§€ë¶ˆ ì„¤ì • í•˜ê¸° ì „ì— ì €ìž¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(583004,16195,'he','×—×©×‘×•×Ÿ ×—×™×™×‘×™× ×œ×”×™×•×•×©×¢ ×œ×¤× ×™ ×”×”×ª×§× ×” ×©×œ× ×—×™×•×‘×™',0),(583005,16195,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏ…Ï„ÎµÎ¯ Ï€ÏÎ¹Î½ Î¸ÎµÏ„Î¹ÎºÏŒ Î±Î¼Î¿Î¹Î²Î® ÎµÎ³ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚',0),(583006,16195,'zh','å¸æˆ·å¿…é¡»ä¿å­˜ä¹‹å‰ç§¯æžä»˜è–ªè®¾ç½®',0),(583007,16195,'sv','Konto mÃ¥ste sparas innan Betalningskontroll Setup',0),(583008,16195,'it','Conto deve essere salvato prima dell\'installazione di Pay positivo',0),(583009,16195,'tl','',0),(583010,16195,'th','à¸šà¸±à¸à¸Šà¸µà¸•à¹‰à¸­à¸‡à¸šà¸±à¸™à¸—à¸¶à¸à¸à¹ˆà¸­à¸™à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸šà¸§à¸à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡',0),(583011,16195,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¤•à¤¾à¤°à¤¾à¤¤à¥à¤®à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤•à¤°à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¸à¤¹à¥‡à¤œà¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(583012,16195,'ms','Akaun mesti disimpan sebelum persediaan positif gaji',0),(583013,16195,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØªÙ… Ø­ÙØ¸ Ø­Ø³Ø§Ø¨ Ù‚Ø¨Ù„ Ø¥Ø¹Ø¯Ø§Ø¯ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ø¥ÙŠØ¬Ø§Ø¨ÙŠ',0),(583014,16195,'fr','Compte doit Ãªtre enregistrÃ© avant rÃ©munÃ©ration Positive dâ€™installation',0),(583015,16195,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã¯è‚¯å®šçš„ãªæ”¯æ‰•ã®è¨­å®šå‰ã«ä¿å­˜ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(583016,16195,'pt','Conta deve ser salvo antes positivo pagar instalaÃ§Ã£o',0),(583017,16195,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ñ‹ Ð´Ð¾ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ¸ Ð¿Ð¾Ð»Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(583018,16195,'es','Cuenta debe guardarse antes de configuraciÃ³n de pago positivo',0),(583019,16195,'de','Konto muss gespeichert werden, bevor Setup Positive Zahlen',0),(583020,16195,'en','Account Must Be Saved Before Positive Pay Setup',0),(583021,16196,'is','',0),(583022,16196,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ú©Ù„ÛŒØ¯ Ø¹Ù…ÙˆÙ…ÛŒ',0),(583023,16196,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ú©Ù„ÛŒØ¯ Ø¹Ù…ÙˆÙ…ÛŒ',0),(583024,16196,'tr','Genel anahtar download',0),(583025,16196,'pl','Pobierz klucz publiczny',0),(583026,16196,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½Ðµ Ð½Ð° Ð¿ÑƒÐ±Ð»Ð¸Ñ‡ÐµÐ½ ÐºÐ»ÑŽÑ‡',0),(583027,16196,'ur','Ø¹ÙˆØ§Ù…ÛŒ Ú©Ù„ÛŒØ¯ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§',0),(583028,16196,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ñ˜Ð°Ð²Ð½Ð¾Ð³ ÐºÑ™ÑƒÑ‡Ð°',0),(583029,16196,'vi','Táº£i vá» khÃ³a cÃ´ng khai',0),(583030,16196,'af','Publieke sleutel aflaai',0),(583031,16196,'ro','Descarca cheia publicÄƒ',0),(583032,16196,'et','Lae avalik vÃµti',0),(583033,16196,'si','Travnato griÄevje javni kljuÄ',0),(583034,16196,'ba','Download kunci publik',0),(583035,16196,'nl','Downloaden van de openbare sleutel',0),(583036,16196,'fi','Lataa julkinen avain',0),(583037,16196,'no','Last ned fellesnÃ¸kkel',0),(583038,16196,'da','Download offentlige nÃ¸gle',0),(583039,16196,'ko','ê³µê°œ í‚¤ ë‹¤ìš´ë¡œë“œ',0),(583040,16196,'he','×”×•×¨×“ ×ž×¤×ª×— ×¦×™×‘×•×¨×™',0),(583041,16196,'el','ÎšÎ±Ï„ÎµÎ²Î¬ÏƒÏ„Îµ Ï„Î¿ Î´Î·Î¼ÏŒÏƒÎ¹Î¿ ÎºÎ»ÎµÎ¹Î´Î¯',0),(583042,16196,'zh','ä¸‹è½½å…¬é’¥',0),(583043,16196,'sv','HÃ¤mta offentliga nyckel',0),(583044,16196,'it','Scaricare la chiave pubblica',0),(583045,16196,'tl','',0),(583046,16196,'th','à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¸„à¸µà¸¢à¹Œà¸ªà¸²à¸˜à¸²à¸£à¸“à¸°',0),(583047,16196,'hi','à¤¸à¤¾à¤°à¥à¤µà¤œà¤¨à¤¿à¤• à¤•à¥à¤‚à¤œà¥€ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡',0),(583048,16196,'ms','Muat turun kekunci awam',0),(583049,16196,'ar','ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ù…ÙØªØ§Ø­ Ø§Ù„Ø¹Ù…ÙˆÙ…ÙŠ',0),(583050,16196,'fr','TÃ©lÃ©charger la clÃ© publique',0),(583051,16196,'jp','å…¬é–‹ã‚­ãƒ¼ã‚’ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã—ã¾ã™ã€‚',0),(583052,16196,'pt','Baixar chave pÃºblica',0),(583053,16196,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·Ð¸Ñ‚ÑŒ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ð¹ ÐºÐ»ÑŽÑ‡',0),(583054,16196,'es','Descargar la clave pÃºblica',0),(583055,16196,'de','Ã–ffentlichen SchlÃ¼ssel herunterladen',0),(583056,16196,'en','Download Public Key',0),(583057,16197,'is','',0),(583058,16197,'dr','ØªÙˆÙ„ÛŒØ¯ Ú©Ù„ÛŒØ¯ Ø®ØµÙˆØµÛŒ Ø¬Ø¯ÛŒØ¯',0),(583059,16197,'pr','ØªÙˆÙ„ÛŒØ¯ Ú©Ù„ÛŒØ¯ Ø®ØµÙˆØµÛŒ Ø¬Ø¯ÛŒØ¯',0),(583060,16197,'tr','Yeni Ã¶zel anahtar oluÅŸtur',0),(583061,16197,'pl','WygenerowaÄ‡ nowy klucz prywatny',0),(583062,16197,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ð»Ð¸Ñ‡ÐµÐ½ ÐºÐ»ÑŽÑ‡',0),(583063,16197,'ur','Ù†Ø¦Û’ Ù†Ø¬ÛŒ Ú©Ù„ÛŒØ¯ Ù¾ÛŒØ¯Ø§',0),(583064,16197,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°ÑšÐµ Ð½Ð¾Ð²Ð¾Ð³ Ð¿Ñ€Ð¸Ð²Ð°Ñ‚Ð½Ð¾Ð³ ÐºÑ™ÑƒÑ‡Ð°',0),(583065,16197,'vi','Táº¡o má»›i cÃ¡c khÃ³a riÃªng',0),(583066,16197,'af','Genereer nuwe Private sleutel',0),(583067,16197,'ro','Genera nou cheie privatÄƒ',0),(583068,16197,'et','Luua uus privaatne vÃµti',0),(583069,16197,'si','Ustvarjanje novega zasebnega kljuÄa',0),(583070,16197,'ba','Menghasilkan kunci pribadi baru',0),(583071,16197,'nl','Nieuwe privÃ© sleutel genereren',0),(583072,16197,'fi','Luo uusi yksityinen avain',0),(583073,16197,'no','Generere nye privatnÃ¸kkel',0),(583074,16197,'da','Opret ny privat nÃ¸gle',0),(583075,16197,'ko','ìƒˆ ê°œì¸ í‚¤ ìƒì„±',0),(583076,16197,'he','×¦×•×¨ ×ž×¤×ª×— ×¤×¨×˜×™ ×—×“×©',0),(583077,16197,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Î½Î­Î¿ Î¹Î´Î¹Ï‰Ï„Î¹ÎºÏŒ ÎºÎ»ÎµÎ¹Î´Î¯',0),(583078,16197,'zh','ç”Ÿæˆæ–°çš„ä¸“ç”¨å¯†é’¥',0),(583079,16197,'sv','Generera ny privat nyckel',0),(583080,16197,'it','Generare nuova chiave privata',0),(583081,16197,'tl','',0),(583082,16197,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸„à¸µà¸¢à¹Œà¸ªà¹ˆà¸§à¸™à¸•à¸±à¸§à¹ƒà¸«à¸¡à¹ˆ',0),(583083,16197,'hi','à¤¨à¤ˆ à¤¨à¤¿à¤œà¥€ à¤•à¥à¤‚à¤œà¥€ à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(583084,16197,'ms','Menjana kekunci peribadi baru',0),(583085,16197,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙØªØ§Ø­ Ø®Ø§Øµ Ø¬Ø¯ÙŠØ¯',0),(583086,16197,'fr','GÃ©nÃ©rer de nouvelles clÃ©s privÃ©es',0),(583087,16197,'jp','æ–°ã—ã„ç§˜å¯†ã‚­ãƒ¼ã‚’ç”Ÿæˆã—ã¾ã™ã€‚',0),(583088,16197,'pt','Gerar nova chave privada',0),(583089,16197,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ñ‹Ð¹ ÐºÐ»ÑŽÑ‡',0),(583090,16197,'es','Generar nueva clave privada',0),(583091,16197,'de','Neuen privaten SchlÃ¼ssel generieren',0),(583092,16197,'en','Generate New Private Key',0),(583093,16198,'is','',0),(583094,16198,'dr','Ø¬Ø¯ÛŒØ¯ Ø®ØµÙˆØµÛŒ Ú©Ù„ÛŒØ¯ Ø´Ú©Ø³ØªÙ‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ØªÙˆÙ„ÛŒØ¯ Ú©Ù„ÛŒØ¯ Ù‡Ø§ÛŒ Ø¹Ù…ÙˆÙ…ÛŒ Ù‡Ù…Ù‡ Ù…ÙˆØ¬ÙˆØ¯',0),(583095,16198,'pr','Ø¬Ø¯ÛŒØ¯ Ø®ØµÙˆØµÛŒ Ú©Ù„ÛŒØ¯ Ø´Ú©Ø³ØªÙ‡ Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ ØªÙˆÙ„ÛŒØ¯ Ú©Ù„ÛŒØ¯ Ù‡Ø§ÛŒ Ø¹Ù…ÙˆÙ…ÛŒ Ù‡Ù…Ù‡ Ù…ÙˆØ¬ÙˆØ¯',0),(583096,16198,'tr','Yeni Ã¶zel anahtar Will sonu tÃ¼m varolan genel anahtarlar oluÅŸturma',0),(583097,16198,'pl','Generuje nowy podziaÅ‚ bÄ™dzie klucz prywatny wszystkie istniejÄ…ce klucze publiczne',0),(583098,16198,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð² Ñ‡Ð°ÑÑ‚ÐµÐ½ ÐºÐ»ÑŽÑ‡ Ñ‰Ðµ Ð¿Ð¾Ñ‡Ð¸Ð²ÐºÐ° Ð²ÑÐ¸Ñ‡ÐºÐ¸ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ Ð¿ÑƒÐ±Ð»Ð¸Ñ‡Ð½Ð¸ ÐºÐ»ÑŽÑ‡Ð¾Ð²Ðµ',0),(583099,16198,'ur','ØªÙ…Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯Û Ø¹ÙˆØ§Ù…ÛŒ Ú†Ø§Ø¨ÛŒØ§Úº Ø§ÛŒÚ© Ù†Ø¦Û’ Ù†Ø¬ÛŒ Ú©Ù„ÛŒØ¯ Ú©ÛŒ Ù…Ø±Ø¶ÛŒ Ú©Û’ ØªÙˆÚ‘ Ù¾ÛŒØ¯Ø§ Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’',0),(583100,16198,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°ÑšÐµ Ð¿Ð°ÑƒÐ·Ñƒ Ð²Ð¾Ñ™Ð° ÐºÑ™ÑƒÑ‡ Ð½Ð¾Ð²Ð¸ Ð¿Ñ€Ð¸Ð²Ð°Ñ‚Ð½Ð¸ ÑÐ²Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ñ˜Ð°Ð²Ð½Ðµ ÐºÑ™ÑƒÑ‡ÐµÐ²Ðµ',0),(583101,16198,'vi','Táº¡o ra má»™t má»›i Private Key sáº½ phÃ¡ vá»¡ táº¥t cáº£ phÃ­m sáºµn cÃ³ cÃ´ng cá»™ng',0),(583102,16198,'af','Genereer \'n nuwe Private sleutel sal breek alle bestaande publieke sleutels',0),(583103,16198,'ro','GenereazÄƒ un nou Private cheie va rupe toate cheile publice existente',0),(583104,16198,'et','Luua uus privaatne vÃµti tahet murda kÃµik olemasolevad avalikud vÃµtmed',0),(583105,16198,'si','Ustvarjanje novega zasebnega kljuÄa bo odmor vseh obstojeÄih javnih kljuÄev',0),(583106,16198,'ba','Menghasilkan kunci pribadi baru akan istirahat semua kunci publik yang ada',0),(583107,16198,'nl','Het genereren van een nieuw privÃ© sleutel wil einde alle bestaande openbare sleutels',0),(583108,16198,'fi','Uusi yksityinen avain tulee tauko kaikki nykyisten julkisten avainten luonti',0),(583109,16198,'no','Genererer en ny privat nÃ¸kkel vil pause alle eksisterende fellesnÃ¸kler',0),(583110,16198,'da','Generere en ny privat nÃ¸gle vil bryde alle eksisterende offentlige nÃ¸gler',0),(583111,16198,'ko','ìƒˆë¡œìš´ ê°œì¸ í‚¤ ì§€ ë¸Œë ˆì´í¬ ëª¨ë“  ê¸°ì¡´ ê³µê°œ í‚¤ ìƒì„±',0),(583112,16198,'he','×™×¦×™×¨×ª ×”×¤×¡×§×” ×”×—×“×© ×©×œ ×•×•×™×œ ×ž×¤×ª×— ×¤×¨×˜×™ ×›×œ ×ž×¤×ª×—×•×ª ×¦×™×‘×•×¨×™×™× ×§×™×™×ž×™×',0),(583113,16198,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÏŽÎ½Ï„Î±Ï‚ Î­Î½Î± Î½Î­Î¿ Î¹Î´Î¹Ï‰Ï„Î¹ÎºÏŒ ÎºÎ»ÎµÎ¹Î´Î¯ Î¸Î± ÏƒÏ€Î¬ÏƒÎµÎ¹ ÏŒÎ»Î± Ï„Î± Ï…Ï†Î¹ÏƒÏ„Î¬Î¼ÎµÎ½Î± Î´Î·Î¼ÏŒÏƒÎ¹Î± ÎºÎ»ÎµÎ¹Î´Î¹Î¬',0),(583114,16198,'zh','ç”Ÿæˆæ–°çš„ç§äººå¯†é’¥å°†æ‰“ç ´æ‰€æœ‰çŽ°æœ‰å…¬å…±å¯†é’¥',0),(583115,16198,'sv','Generera en ny privat nyckel kommer bryta alla befintliga offentliga nycklar',0),(583116,16198,'it','Generando una nuova interruzione di volontÃ  di chiave privata tutte le chiavi pubbliche esistenti',0),(583117,16198,'tl','',0),(583118,16198,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸•à¸±à¸§à¹à¸šà¹ˆà¸‡à¸ªà¹ˆà¸§à¸™à¸ˆà¸°à¸„à¸µà¸¢à¹Œà¸„à¸µà¸¢à¹Œà¸ªà¸²à¸˜à¸²à¸£à¸“à¸°à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(583119,16198,'hi','à¤à¤• à¤¨à¤ à¤¨à¤¿à¤œà¥€ à¤•à¥à¤‚à¤œà¥€ à¤Ÿà¥‚à¤Ÿ à¤œà¤¾à¤à¤—à¤¾ à¤¸à¤­à¥€ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¸à¤¾à¤°à¥à¤µà¤œà¤¨à¤¿à¤• à¤•à¥à¤‚à¤œà¥€ à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤° à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(583120,16198,'ms','Penjanaan cuti akan kunci peribadi baru semua kekunci awam sedia ada',0),(583121,16198,'ar','ØªÙˆÙ„ÙŠØ¯ ÙƒØ³Ø± Ø¥Ø±Ø§Ø¯Ø© Ø§Ù„Ù…ÙØªØ§Ø­ Ø§Ù„Ø®Ø§Øµ Ø§Ù„Ø¬Ø¯ÙŠØ¯ ÙƒØ§ÙØ© Ø§Ù„Ù…ÙØ§ØªÙŠØ­ Ø§Ù„Ø¹Ù…ÙˆÙ…ÙŠØ© Ø§Ù„Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(583122,16198,'fr','GÃ©nÃ©rer une nouvelle clÃ© privÃ© Will Break toutes les clÃ©s publiques existantes',0),(583123,16198,'jp','æ–°ã—ã„ãƒ—ãƒ©ã‚¤ãƒ™ãƒ¼ãƒˆ ã‚­ãƒ¼ã¯å£Šã‚Œã‚‹ã™ã¹ã¦ã®æ—¢å­˜ã®å…¬é–‹ã‚­ãƒ¼ã‚’ç”Ÿæˆã—ã¾ã™ã€‚',0),(583124,16198,'pt','Gerando um novo privado chave Will Break todas as chaves pÃºblicas existentes',0),(583125,16198,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð½Ð¾Ð²Ð¾Ð³Ð¾ Ñ‡Ð°ÑÑ‚Ð½Ð¾Ð³Ð¾ ÐºÐ»ÑŽÑ‡Ð° ÑÐ²ÐµÑ€Ð½ÑƒÐ» Ð²ÑÐµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ ÐºÐ»ÑŽÑ‡Ð¸',0),(583126,16198,'es','Generando una nueva rotura de voluntad privada clave todas las claves pÃºblicas existentes',0),(583127,16198,'de','Erzeugen eine neue Private SchlÃ¼ssel wird Pause alle vorhandenen Ã¶ffentlichen SchlÃ¼ssel',0),(583128,16198,'en','Generating A New Private Key Will Break All Existing Public Keys',0),(583129,16199,'is','',0),(583130,16199,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ú©Ù„ÛŒØ¯ Ø®ØµÙˆØµÛŒ Ø¬Ø¯ÛŒØ¯',0),(583131,16199,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ú©Ù„ÛŒØ¯ Ø®ØµÙˆØµÛŒ Ø¬Ø¯ÛŒØ¯',0),(583132,16199,'tr','Yeni Ã¶zel anahtar oluÅŸturulan',0),(583133,16199,'pl','Tworzony nowy klucz prywatny',0),(583134,16199,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´ÐµÐ½ Ð½Ð¾Ð² Ð»Ð¸Ñ‡ÐµÐ½ ÐºÐ»ÑŽÑ‡',0),(583135,16199,'ur','Ù†Ø¦Û’ Ù†Ø¬ÛŒ Ú©Ù„ÛŒØ¯ Ø¨Ù†Ø§ÛŒØ§',0),(583136,16199,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ð½ Ñ˜Ðµ Ð½Ð¾Ð²Ð¸ Ð¿Ñ€Ð¸Ð²Ð°Ñ‚Ð½Ð¸ ÐºÑ™ÑƒÑ‡',0),(583137,16199,'vi','KhÃ³a riÃªng má»›i táº¡o ra',0),(583138,16199,'af','Nuwe privaat sleutel geskep',0),(583139,16199,'ro','Cheie privatÄƒ nou creat',0),(583140,16199,'et','Loodud uus salajane vÃµti',0),(583141,16199,'si','Nov zasebni kljuÄ ustvaril',0),(583142,16199,'ba','Kunci pribadi yang baru dibuat',0),(583143,16199,'nl','Nieuwe persoonlijke sleutel gemaakt',0),(583144,16199,'fi','Uusi yksityinen avain luotu',0),(583145,16199,'no','Nye Private nÃ¸kkelen opprettet',0),(583146,16199,'da','Nye Private nÃ¸gle oprettet',0),(583147,16199,'ko','ìƒˆë¡œìš´ ê°œì¸ í‚¤ ìƒì„±',0),(583148,16199,'he','×ž×¤×ª×— ×¤×¨×˜×™ ×—×“×© × ×•×¦×¨',0),(583149,16199,'el','ÎÎ­Î¿ Î¹Î´Î¹Ï‰Ï„Î¹ÎºÏŒ ÎºÎ»ÎµÎ¹Î´Î¯ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯Ï„Î±Î¹',0),(583150,16199,'zh','åˆ›å»ºæ–°çš„ç§äººå¯†é’¥',0),(583151,16199,'sv','Skapa ny privat nyckel',0),(583152,16199,'it','Crea nuova chiave privata',0),(583153,16199,'tl','',0),(583154,16199,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸„à¸µà¸¢à¹Œà¸ªà¹ˆà¸§à¸™à¸•à¸±à¸§à¹ƒà¸«à¸¡à¹ˆ',0),(583155,16199,'hi','à¤¨à¤ˆ à¤¨à¤¿à¤œà¥€ à¤•à¥à¤‚à¤œà¥€ à¤¬à¤¨à¤¾à¤ˆ',0),(583156,16199,'ms','Kunci peribadi yang baru dicipta',0),(583157,16199,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ù…ÙØªØ§Ø­ Ø®Ø§Øµ Ø¬Ø¯ÙŠØ¯',0),(583158,16199,'fr','Nouvelle clÃ© privÃ©e crÃ©Ã©e',0),(583159,16199,'jp','æ–°ã—ã„ç§˜å¯†ã‚­ãƒ¼ã®ä½œæˆ',0),(583160,16199,'pt','Nova chave privada criada',0),(583161,16199,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½ Ð½Ð¾Ð²Ñ‹Ð¹ Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ñ‹Ð¹ ÐºÐ»ÑŽÑ‡',0),(583162,16199,'es','Nueva llave privada',0),(583163,16199,'de','Neue Private SchlÃ¼ssel erstellt',0),(583164,16199,'en','New Private Key Created',0),(583165,16200,'is','',0),(583166,16200,'dr','Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ú©Ø¯ ÛŒØ§ Ù†Ø§Ù…',0),(583167,16200,'pr','Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ú©Ø¯ ÛŒØ§ Ù†Ø§Ù…',0),(583168,16200,'tr','SatÄ±cÄ± kimliÄŸi, kod veya adÄ± olarak ayarlanmalÄ±dÄ±r',0),(583169,16200,'pl','Identyfikator dostawcy, kod lub nazwÄ™ musi byÄ‡ ustawiona',0),(583170,16200,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½ Ð˜Ð” Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº, ÐºÐ¾Ð´ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ',0),(583171,16200,'ur','ÙˆÛŒÙ†ÚˆØ± ID, Ú©ÙˆÚˆ ÛŒØ§ Ù†Ø§Ù… Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(583172,16200,'sr','Ð˜Ð” Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° \",\" Ð¨Ð¸Ñ„Ñ€Ð° \"Ð¸Ð»Ð¸\"Ð¸Ð¼Ðµ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(583173,16200,'vi','Vendor ID, mÃ£ hoáº·c tÃªn pháº£i Ä‘Æ°á»£c thiáº¿t láº­p',0),(583174,16200,'af','Handelaar ID, kode of naam moet opgestel word',0),(583175,16200,'ro','Trebuie setat ID de furnizor, codul sau numele',0),(583176,16200,'et','Hankija ID-kood vÃµi nimi peab olema mÃ¤Ã¤ratud',0),(583177,16200,'si','ID prodajalca, Å¡ifro ali imenom nastavite',0),(583178,16200,'ba','Penjual ID, kode atau nama harus ditetapkan',0),(583179,16200,'nl','Leverancier-ID, Code of naam moet worden ingesteld',0),(583180,16200,'fi','Toimittajatunnus, koodi tai nimi on mÃ¤Ã¤ritettÃ¤vÃ¤',0),(583181,16200,'no','LeverandÃ¸r-ID, kode eller navn mÃ¥ angis',0),(583182,16200,'da','LeverandÃ¸r-ID, kode eller navn skal angives',0),(583183,16200,'ko','ê³µê¸‰ ì—…ì²´ ID, ì½”ë“œ ë˜ëŠ” ì´ë¦„ì„ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(583184,16200,'he','×ž×–×”×” ×¡×¤×§, ×§×•×“ ××• ×©× ×—×™×™×‘ ×œ×”×™×•×ª ×ž×•×’×“×¨',0),(583185,16200,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Ï„Î¿ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®, ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Î® ÏŒÎ½Î¿Î¼Î±',0),(583186,16200,'zh','å¿…é¡»è®¾ç½®ä¾›åº”å•† IDã€ ä»£ç æˆ–åç§°',0),(583187,16200,'sv','LeverantÃ¶rs-ID, kod eller ett namn mÃ¥ste anges',0),(583188,16200,'it','Ãˆ necessario impostare ID fornitore, codice o nome',0),(583189,16200,'tl','',0),(583190,16200,'th','à¸•à¹‰à¸­à¸‡à¸•à¸±à¹‰à¸‡à¸Šà¸·à¹ˆà¸­ à¸«à¸£à¸·à¸­à¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸‚à¸²à¸¢ à¸£à¸«à¸±à¸ª',0),(583191,16200,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ ID, à¤•à¥‹à¤¡ à¤¯à¤¾ à¤¨à¤¾à¤® à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(583192,16200,'ms','Nombor vendor ID, kod atau nama mesti disetkan',0),(583193,16200,'ar','ÙŠØ¬Ø¨ ØªØ¹ÙŠÙŠÙ† Ø§Ø³Ù… Ø£Ùˆ Ø±Ù…Ø² Ø£Ùˆ Ù…Ø¹Ø±Ù Ø§Ù„Ù…ÙˆØ±Ø¯',0),(583194,16200,'fr','Doit avoir la valeur ID de fournisseur, Code ou nom',0),(583195,16200,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ IDã€ã‚³ãƒ¼ãƒ‰ã¾ãŸã¯åå‰ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(583196,16200,'pt','ID do fornecedor, cÃ³digo ou nome deve ser definido',0),(583197,16200,'ru','ÐšÐžÐ” Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°, ÐºÐ¾Ð´ Ð¸Ð»Ð¸ Ð¸Ð¼Ñ Ð´Ð¾Ð»Ð¶Ð½Ð¾ Ð±Ñ‹Ñ‚ÑŒ ÑƒÐºÐ°Ð·Ð°Ð½Ð¾',0),(583198,16200,'es','ID. de proveedor, cÃ³digo o nombre debe establecerse',0),(583199,16200,'de','Hersteller-ID, Code oder Name muss eingestellt werden',0),(583200,16200,'en','Vendor ID, Code or Name must be set',0),(583201,16201,'is','',0),(583202,16201,'dr','Ù‡Ø± ÙØ§Ú©ØªÙˆØ± Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø³Ø§Ø²Ú¯Ø§Ø± Ù†ÛŒØ³Øª',0),(583203,16201,'pr','Ù‡Ø± ÙØ§Ú©ØªÙˆØ± Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø³Ø§Ø²Ú¯Ø§Ø± Ù†ÛŒØ³Øª',0),(583204,16201,'tr','Herhangi bir fatura satÄ±cÄ± iÃ§in eÅŸleÅŸmiyor',0),(583205,16201,'pl','Nie pasuje wszelkie faktury dla dostawcy',0),(583206,16201,'bg','ÐÐµ ÑÑŠÐ²Ð¿Ð°Ð´Ð° Ñ Ð²ÑÑÐºÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(583207,16201,'ur','Ú©Ø³ÛŒ Ø¨Ú¾ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„Ø¦Û’ ÙØ±ÙˆØ´Ù†Ø¯Û Ø³Û’ Ù…ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ú¾Ø§ØªØ§',0),(583208,16201,'sr','ÐÐµ Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð° Ð»Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(583209,16201,'vi','KhÃ´ng phÃ¹ há»£p vá»›i báº¥t ká»³ hoÃ¡ Ä‘Æ¡n cho cÃ¡c nhÃ  cung cáº¥p',0),(583210,16201,'af','Pas nie by enige faktuur vir handelaar',0),(583211,16201,'ro','Nu se potriveÅŸte cu orice facturÄƒ de furnizor',0),(583212,16201,'et','Ei sobi iga arve, hankija',0),(583213,16201,'si','Ne ustreza nobenem raÄunu dobavitelja',0),(583214,16201,'ba','Tidak sesuai faktur apapun untuk Vendor',0),(583215,16201,'nl','Niet overeenkomt met een factuur voor leverancier',0),(583216,16201,'fi','Ei vastaa mitÃ¤Ã¤n laskun toimittajan',0),(583217,16201,'no','Ikke samsvarer med alle fakturaer For leverandÃ¸r',0),(583218,16201,'da','Svarer ikke til nogen fakturaen For kreditor',0),(583219,16201,'ko','ê³µê¸‰ ì—…ì²´ì— ëŒ€ í•œ ëª¨ë“  ì²­êµ¬ì„œë¥¼ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(583220,16201,'he','××™× ×• ×ª×•×× ×›×œ ×—×©×‘×•× ×™×ª ×¢×‘×•×¨ ×¡×¤×§',0),(583221,16201,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î¼Îµ Î¿Ï€Î¿Î¹Î¿Î´Î®Ï€Î¿Ï„Îµ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î³Î¹Î± Ï„Î¿Î½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(583222,16201,'zh','ä¸åŒ¹é…ä»»ä½•å‘ç¥¨ä¾›åº”å•†',0),(583223,16201,'sv','Matchar inte nÃ¥gon faktura fÃ¶r leverantÃ¶r',0),(583224,16201,'it','Non corrisponde alcuna fattura per il fornitore',0),(583225,16201,'tl','',0),(583226,16201,'th','à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹ƒà¸” à¹† à¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(583227,16201,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(583228,16201,'ms','Tidak sepadan dengan sebarang invois pembekal',0),(583229,16201,'ar','Ù„Ø§ ÙŠØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ø£ÙŠ ÙØ§ØªÙˆØ±Ø© Ù„Ù„Ù…ÙˆØ±Ø¯',0),(583230,16201,'fr','Ne correspond pas Ã  une facture fournisseur',0),(583231,16201,'jp','ä»•å…¥å…ˆã®è«‹æ±‚ã‚’ä¸€è‡´ã—ã¾ã›ã‚“ã€‚',0),(583232,16201,'pt','NÃ£o combina com qualquer factura de fornecedor',0),(583233,16201,'ru','ÐÐµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð»ÑŽÐ±Ð¾Ð¹ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹ Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(583234,16201,'es','No coincide con ninguna factura de proveedor',0),(583235,16201,'de','Passt keine Rechnung fÃ¼r Kreditor',0),(583236,16201,'en','Doesnt Match Any Invoice For Vendor',0),(583237,16202,'is','',0),(583238,16202,'dr','Ù…Ø³Ø§Ø¨Ù‚Ø§Øª Muliple ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(583239,16202,'pr','Ù…Ø³Ø§Ø¨Ù‚Ø§Øª Muliple ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(583240,16202,'tr','MaÃ§lar sendromlari faturalar',0),(583241,16202,'pl','Mecze zagnieÅ¼dÅ¼aÄ‡ faktur',0),(583242,16202,'bg','ÐœÐ°Ñ‡Ð¾Ð²Ðµ Muliple Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(583243,16202,'ur','Ù…ÛŒÚ† Muliple ÙˆØ¨Ø¬Ù„ÛŒ',0),(583244,16202,'sr','ÐŸÐ¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° ÐœÑƒÐ»Ð¸Ð¿Ð»Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(583245,16202,'vi','Tráº­n Muliple hÃ³a Ä‘Æ¡n',0),(583246,16202,'af','Pas Muliple fakture',0),(583247,16202,'ro','Meciuri vasular facturi',0),(583248,16202,'et','Sobib Muliple arved',0),(583249,16202,'si','Tekme Muliple raÄunov',0),(583250,16202,'ba','Pertandingan Muliple faktur',0),(583251,16202,'nl','Wedstrijden Muliple facturen',0),(583252,16202,'fi','Ottelut Muliple laskut',0),(583253,16202,'no','Kamper Muliple fakturaer',0),(583254,16202,'da','Kampe Muliple fakturaer',0),(583255,16202,'ko','ì„ ìˆ˜ ë³µìˆ˜ ì²­êµ¬ì„œ',0),(583256,16202,'he','×—×©×‘×•× ×™×•×ª Muliple ×’×¤×¨×•×¨×™×',0),(583257,16202,'el','Î‘Î³ÏŽÎ½ÎµÏ‚ Muliple Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(583258,16202,'zh','æ¯”èµ›å¤šå…ƒå‘ç¥¨',0),(583259,16202,'sv','Matcher Muliple fakturor',0),(583260,16202,'it','Partite Muliple fatture',0),(583261,16202,'tl','',0),(583262,16202,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰ Muliple à¸•à¸£à¸‡à¸à¸±à¸™',0),(583263,16202,'hi','à¤®à¥ˆà¤š Muliple à¤šà¤¾à¤²à¤¾à¤¨',0),(583264,16202,'ms','Invois Muliple perlawanan',0),(583265,16202,'ar','Ù…Ø¨Ø§Ø±ÙŠØ§Øª Muliple Ø§Ù„ÙÙˆØ§ØªÙŠØ±',0),(583266,16202,'fr','Correspondances multiples factures',0),(583267,16202,'jp','ä¸€è‡´ã™ã‚‹è¤‡æ•°ã®è«‹æ±‚',0),(583268,16202,'pt','Jogos Muliple facturas',0),(583269,16202,'ru','ÐœÐ°Ñ‚Ñ‡Ð¸ Muliple ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(583270,16202,'es','Los partidos Muliple facturas',0),(583271,16202,'de','Spiele Muliple Rechnungen',0),(583272,16202,'en','Matches Muliple Invoices',0),(583273,16203,'is','',0),(583274,16203,'dr','Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ ØªÙˆØ¬Ù‡ Ø¨Ù‡ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§Ø²ÛŒ Ù†Ø¯ÛŒØ¯Ù‡ Ùˆ ÛŒØ§ Ú©Ø¯',0),(583275,16203,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ ØªÙˆØ¬Ù‡ Ø¨Ù‡ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§Ø²ÛŒ Ù†Ø¯ÛŒØ¯Ù‡ Ùˆ ÛŒØ§ Ú©Ø¯',0),(583276,16203,'tr','SatÄ±cÄ± kimliÄŸi doesnt maÃ§ satÄ±cÄ± isim veya kod',0),(583277,16203,'pl','Podana nazwa dostawcy nie robi meczu lub kod identyfikator dostawcy',0),(583278,16203,'bg','Ð˜Ð” Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Doesnt Ð¼Ð°Ñ‡ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸Ð¼Ðµ Ð¸Ð»Ð¸ ÐºÐ¾Ð´',0),(583279,16203,'ur','ÙˆÛŒÙ†ÚˆØ± Id Ø¯ÙˆØ§Ø³Ù†Ù¹ Ù…ÛŒÚ† ÙˆÛŒÙ†ÚˆØ± Ù†Ø§Ù… ÛŒØ§ Ú©ÙˆÚˆ Ø¯ÛŒØ§',0),(583280,16203,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð˜Ð´ Ð´Ð°Ð»Ð° Ð¸Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸Ð¸Ð½Ð¸ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐµ Ð¸Ð»Ð¸ Ð¨Ð¸Ñ„Ñ€Ð°',0),(583281,16203,'vi','Vendor Id khÃ´ng phÃ¹ há»£p vá»›i nhÃ  cung cáº¥p tÃªn hoáº·c mÃ£',0),(583282,16203,'af','Handelaar Id Doesnt pas handelaar naam of kode gegee',0),(583283,16203,'ro','Furnizor de ID-ul dat Doesnt meci furnizor numele sau codul',0),(583284,16203,'et','Hankija Id Doesnt mÃ¤ngu hankija nimi vÃµi kood',0),(583285,16203,'si','Id prodajalca, ime dobavitelja Doesnt tekmo ali kodo',0),(583286,16203,'ba','Penjual Id diberikan Doesnt pertandingan Vendor nama atau kode',0),(583287,16203,'nl','Vendor Id gegeven Doesnt-Match leverancier naam of Code',0),(583288,16203,'fi','Toimittajatunnus Doesnt ottelu toimittajan nimi tai koodi',0),(583289,16203,'no','LeverandÃ¸r-Id gitt Doesnt kampen leverandÃ¸r- eller kode',0),(583290,16203,'da','SÃ¦lger Id givet Doesnt Match kreditornavnet eller kode',0),(583291,16203,'ko','ê³µê¸‰ ì—…ì²´ Idê°€ ì¼ì¹˜ ê³µê¸‰ ì—…ì²´ ì´ë¦„ ë˜ëŠ” ì½”ë“œ',0),(583292,16203,'he','×ž×–×”×” ×¡×¤×§ ×©× ×™×ª× ×• ×©× ×”×¡×¤×§ Doesnt ×”×ª××ž×” ××• ×§×•×“',0),(583293,16203,'el','Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î´Î¯Î½ÎµÏ„Î±Î¹ Doesnt Î±Î³ÏŽÎ½Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÏŒÎ½Î¿Î¼Î± Î® ÎšÏ‰Î´Î¹ÎºÏŒÏ‚',0),(583294,16203,'zh','ç»™å‡ºäº†å¹¶ä¸åŒ¹é…ä¾›åº”å•†åç§°æˆ–ä»£ç çš„ä¾›åº”å•† Id',0),(583295,16203,'sv','VendÃ¶r Id ges Doesnt Match leverantÃ¶rens namn eller kod',0),(583296,16203,'it','Id Fornitore dato Doesnt partita fornitore nome o codice',0),(583297,16203,'tl','',0),(583298,16203,'th','à¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¸Šà¸·à¹ˆà¸­à¹€à¸¥à¹ˆà¸™à¸•à¸£à¸‡à¸à¸±à¸šà¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸«à¸£à¸·à¸­à¸£à¸«à¸±à¸ª',0),(583299,16203,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ Id doesn \' t à¤®à¥ˆà¤š à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤•à¥‹à¤¡ à¤¦à¤¿à¤¯à¤¾',0),(583300,16203,'ms','Nombor vendor Id yang diberi nama penjual Doesnt perlawanan atau kod',0),(583301,16203,'ar','ÙˆÙ†Ø¸Ø±Ø§ Ù„ØªØ·Ø§Ø¨Ù‚ Ø¯ÙˆÙŠØ³Ù†Øª Ø§Ø³Ù… Ø§Ù„Ø¨Ø§Ø¦Ø¹ Ø£Ùˆ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ù…Ø¹Ø±Ù Ø§Ù„Ù…ÙˆØ±Ø¯',0),(583302,16203,'fr','Id de fournisseur donnÃ© Code ou nom du vendeur Doesnt Match',0),(583303,16203,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ Id Doesnt ãƒžãƒƒãƒ ãƒ™ãƒ³ãƒ€ãƒ¼åã¾ãŸã¯ã‚³ãƒ¼ãƒ‰ã‚’æŒ‡å®š',0),(583304,16203,'pt','Id do fornecedor nome do fornecedor de Doesnt Match ou cÃ³digo',0),(583305,16203,'ru','ÐšÐ¾Ð´ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Match Ð¸Ð¼Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¸Ð»Ð¸ ÐºÐ¾Ð´',0),(583306,16203,'es','Id. de proveedor dado encuentro proveedor nombre o cÃ³digo',0),(583307,16203,'de','Vendor-Id gegeben Doesnt Match Herstellernamen oder Code',0),(583308,16203,'en','Vendor ID Given Doesn\'t Match Vendor Name Or Code',0),(583309,16204,'is','',0),(583310,16204,'dr','ÙØ§Ú©ØªÙˆØ± Ø¨Ù‡ Ù…Ø´ØªØ±ÛŒ Ú©Ø¯ Ø³Ø§Ø²Ú¯Ø§Ø± Ù†ÛŒØ³Øª',0),(583311,16204,'pr','ÙØ§Ú©ØªÙˆØ± Ø¨Ù‡ Ù…Ø´ØªØ±ÛŒ Ú©Ø¯ Ø³Ø§Ø²Ú¯Ø§Ø± Ù†ÛŒØ³Øª',0),(583312,16204,'tr','Fatura mÃ¼ÅŸteri kodu eÅŸleÅŸmiyor',0),(583313,16204,'pl','Faktury nie pasuje kod klienta',0),(583314,16204,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð½Ðµ ÑÑŠÐ²Ð¿Ð°Ð´Ð° Ñ ÐºÐ¾Ð´Ð° Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(583315,16204,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆÚˆ Ø³Û’ Ù…ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ú¾Ø§ØªØ§',0),(583316,16204,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐµ Ð±Ñ€Ð¾Ñ˜ ÐºÑƒÐ¿Ñ†Ð°',0),(583317,16204,'vi','HoÃ¡ Ä‘Æ¡n khÃ´ng khá»›p vá»›i mÃ£ khÃ¡ch hÃ ng',0),(583318,16204,'af','Faktuur, pas nie by die kliÃ«nt kode',0),(583319,16204,'ro','Factura nu se potriveÅŸte cu cod client',0),(583320,16204,'et','Arve ei vasta kliendi kood',0),(583321,16204,'si','RaÄun ne ujema kupca',0),(583322,16204,'ba','Faktur tidak sesuai kode pelanggan',0),(583323,16204,'nl','Factuur komt niet overeen met klantnummer',0),(583324,16204,'fi','Lasku ei vastaa asiakkaan koodi',0),(583325,16204,'no','Fakturaen samsvarer ikke med kunde',0),(583326,16204,'da','Faktura ikke stemmer overens med kundens kode',0),(583327,16204,'ko','ì†¡ìž¥ ê³ ê° ì½”ë“œì™€ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(583328,16204,'he','×—×©×‘×•× ×™×ª ××™× ×• ×ª×•×× ×§×•×“ ×”×œ×§×•×—',0),(583329,16204,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î¼Îµ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(583330,16204,'zh','å‘ç¥¨ä¸åŒ¹é…å®¢æˆ·ä»£ç ',0),(583331,16204,'sv','Fakturan matchar inte Kundkod',0),(583332,16204,'it','Fattura non corrisponde il codice cliente',0),(583333,16204,'tl','',0),(583334,16204,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸šà¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸²',0),(583335,16204,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹à¤¡ à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(583336,16204,'ms','Invois tidak sepadan dengan kod pelanggan',0),(583337,16204,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù„Ø§ ÙŠØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ø±Ù…Ø² Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(583338,16204,'fr','Facture ne correspond pas Code client',0),(583339,16204,'jp','è«‹æ±‚æ›¸ã¯ã€é¡§å®¢ã‚³ãƒ¼ãƒ‰ã¨ä¸€è‡´ã—ã¾ã›ã‚“ã€‚',0),(583340,16204,'pt','Factura nÃ£o combina com o cÃ³digo de cliente',0),(583341,16204,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÐºÐ¾Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(583342,16204,'es','Factura no coincide con el cÃ³digo cliente',0),(583343,16204,'de','Rechnung Kundennummer stimmt nicht Ã¼berein',0),(583344,16204,'en','Invoice Doesn\'t Match Customer Code',0),(583345,16205,'is','',0),(583346,16205,'dr','ÙØ§Ú©ØªÙˆØ± Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ø³Ø§Ø²Ú¯Ø§Ø± Ù†ÛŒØ³Øª',0),(583347,16205,'pr','ÙØ§Ú©ØªÙˆØ± Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ø³Ø§Ø²Ú¯Ø§Ø± Ù†ÛŒØ³Øª',0),(583348,16205,'tr','Fatura mÃ¼ÅŸteri kimlikleri eÅŸleÅŸmiyor',0),(583349,16205,'pl','Faktury nie pasuje identyfikator klienta',0),(583350,16205,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð½Ðµ ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð° Ð½Ð° Ð˜Ð” Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(583351,16205,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ø³Ù¹Ù…Ø± Id Ø³Û’ Ù…ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ú¾Ø§ØªØ§',0),(583352,16205,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° ÑÐµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐ° Ð˜Ð´ ÐºÑƒÐ¿Ñ†Ð°',0),(583353,16205,'vi','HoÃ¡ Ä‘Æ¡n khÃ´ng khá»›p vá»›i Id khÃ¡ch hÃ ng',0),(583354,16205,'af','Faktuur, pas nie by die kliÃ«nt-Id',0),(583355,16205,'ro','Factura nu se potriveÅŸte cu Id client',0),(583356,16205,'et','Arve ei vasta kliendi Id',0),(583357,16205,'si','RaÄun ne ujema z Id stranke',0),(583358,16205,'ba','Faktur tidak sesuai Id pelanggan',0),(583359,16205,'nl','Factuur komt niet overeen met klant-Id',0),(583360,16205,'fi','Lasku ei vastaa asiakkaan tunnus',0),(583361,16205,'no','Fakturaen samsvarer ikke med kunde-Id',0),(583362,16205,'da','Faktura ikke stemmer overens med kunde-Id',0),(583363,16205,'ko','ì†¡ìž¥ ê³ ê° Idë¥¼ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(583364,16205,'he','×—×©×‘×•× ×™×ª ××™× ×• ×ª×•×× ×ž×–×”×” ×œ×§×•×—',0),(583365,16205,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î¼Îµ Ï„Î¿ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î·',0),(583366,16205,'zh','å‘ç¥¨çš„å®¢æˆ· Id ä¸åŒ¹é…',0),(583367,16205,'sv','Fakturan matchar inte kund-Id',0),(583368,16205,'it','Fattura non corrisponde a Id cliente',0),(583369,16205,'tl','',0),(583370,16205,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸šà¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸²',0),(583371,16205,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• Id à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(583372,16205,'ms','Invois tidak sepadan dengan Id pelanggan',0),(583373,16205,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù„Ø§ ÙŠØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ù…Ø¹Ø±Ù Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(583374,16205,'fr','Facture ne correspond pas Id client',0),(583375,16205,'jp','è«‹æ±‚æ›¸ã¯ã€é¡§å®¢ Id ã¨ä¸€è‡´ã—ã¾ã›ã‚“',0),(583376,16205,'pt','Factura nÃ£o coincide com a identificaÃ§Ã£o do cliente',0),(583377,16205,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¾Ñ€ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(583378,16205,'es','Factura no coincide con el Id de cliente',0),(583379,16205,'de','Kunden-Id stimmt nicht mit Rechnung Ã¼berein',0),(583380,16205,'en','Invoice Doesn\'t Match Customer ID',0),(583381,16206,'is','',0),(583382,16206,'dr','ÙØ§Ú©ØªÙˆØ± Ù…Ø´ØªØ±ÛŒ Ù†Ø§Ù… Ø³Ø§Ø²Ú¯Ø§Ø± Ù†ÛŒØ³Øª',0),(583383,16206,'pr','ÙØ§Ú©ØªÙˆØ± Ù…Ø´ØªØ±ÛŒ Ù†Ø§Ù… Ø³Ø§Ø²Ú¯Ø§Ø± Ù†ÛŒØ³Øª',0),(583384,16206,'tr','Fatura MÃ¼ÅŸteri adÄ± eÅŸleÅŸmiyor',0),(583385,16206,'pl','Faktury nie pasuje Nazwa klienta',0),(583386,16206,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ð½Ðµ ÑÑŠÐ²Ð¿Ð°Ð´Ð° Ñ Ð¸Ð¼Ðµ Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(583387,16206,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ø³Ù¹Ù…Ø± Ú©Û’ Ù†Ø§Ù… Ø³Û’ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº ÛÛ’',0),(583388,16206,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð½Ðµ Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð° Ð¸Ð¼Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(583389,16206,'vi','HoÃ¡ Ä‘Æ¡n khÃ´ng khá»›p vá»›i tÃªn khÃ¡ch hÃ ng',0),(583390,16206,'af','Faktuur kliÃ«nt naam pas nie',0),(583391,16206,'ro','Factura nu se potriveÅŸte cu numele clientului',0),(583392,16206,'et','Arve ei vasta kliendi nimi',0),(583393,16206,'si','RaÄun ne ustreza ime kupca',0),(583394,16206,'ba','Faktur tidak sesuai nama pelanggan',0),(583395,16206,'nl','Factuur komt niet overeen met de klantnaam van de',0),(583396,16206,'fi','Lasku ei vastaa asiakkaan nimi',0),(583397,16206,'no','Fakturaen samsvarer ikke med kundenavn',0),(583398,16206,'da','Faktura matcher ikke Kundenavn',0),(583399,16206,'ko','ì†¡ìž¥ ê³ ê° ì´ë¦„ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(583400,16206,'he','×”×—×©×‘×•× ×™×ª ××™× ×” ×ª×•××ž×ª ××ª ×©× ×”×œ×§×•×—',0),(583401,16206,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î¼Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï€ÎµÎ»Î¬Ï„Î·',0),(583402,16206,'zh','å‘ç¥¨ä¸Žå®¢æˆ·åç§°ä¸åŒ¹é…',0),(583403,16206,'sv','Faktura matchar inte kundens namn',0),(583404,16206,'it','Fattura non corrisponde il nome del cliente',0),(583405,16206,'tl','',0),(583406,16206,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸šà¸Šà¸·à¹ˆà¸­à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(583407,16206,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¤¾ à¤¨à¤¾à¤® à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(583408,16206,'ms','Invois tidak sepadan dengan nama pelanggan',0),(583409,16206,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ù„Ø§ ÙŠØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ø§Ø³Ù… Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(583410,16206,'fr','Facture ne correspond pas le nom du client',0),(583411,16206,'jp','è«‹æ±‚æ›¸ã¯ã€é¡§å®¢åã¨ä¸€è‡´ã—ã¾ã›ã‚“',0),(583412,16206,'pt','Factura nÃ£o combina com o nome do cliente',0),(583413,16206,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð½Ðµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ Ð¸Ð¼ÐµÐ½Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(583414,16206,'es','Factura no coincide con nombre de cliente',0),(583415,16206,'de','Rechnung stimmt nicht Ã¼berein, Kundenname',0),(583416,16206,'en','Invoice Doesn\'t Match Customer Name',0),(583417,16207,'is','',0),(583418,16207,'dr','Ù…Ø´ØªØ±ÛŒ Ø¯Ø± ÙØ§Ú©ØªÙˆØ± Ø¨Ø§ÛŒØ¯ Ø§Ú¯Ø± Ù…Ø³Ø§Ø¨Ù‚Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(583419,16207,'pr','Ù…Ø´ØªØ±ÛŒ Ø¯Ø± ÙØ§Ú©ØªÙˆØ± Ø¨Ø§ÛŒØ¯ Ø§Ú¯Ø± Ù…Ø³Ø§Ø¨Ù‚Ù‡ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(583420,16207,'tr','MÃ¼ÅŸteri Fatura eÅŸleÅŸmesi gerekir ayarla',0),(583421,16207,'pl','Musi odpowiadaÄ‡ na klienta, na fakturze, jeÅ›li zestaw',0),(583422,16207,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ ÑÑ€Ð°Ð²Ð½ÑÐ²Ð°Ñ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°, Ð°ÐºÐ¾ Ð·Ð°Ð´Ð°Ð´ÐµÑ‚Ðµ',0),(583423,16207,'ur','Ú©Ø³Ù¹Ù…Ø± Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù¾Ø± ØªÙˆ Ø³Û’ Ù…Ø´Ø§Ø¨Û ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(583424,16207,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¾Ð´Ð³Ð¾Ð²Ð°Ñ€Ð° ÐºÑƒÐ¿Ñ†Ñƒ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð°ÐºÐ¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ',0),(583425,16207,'vi','Pháº£i phÃ¹ há»£p vá»›i cÃ¡c khÃ¡ch hÃ ng trÃªn hÃ³a Ä‘Æ¡n náº¿u thiáº¿t',0),(583426,16207,'af','KliÃ«nt op die faktuur moet pas as stel',0),(583427,16207,'ro','Trebuie sÄƒ se potriveascÄƒ clientului pe factura, dacÄƒ setaÅ£i',0),(583428,16207,'et','Peavad vastama kliendi arvel, kui seatud',0),(583429,16207,'si','Kupec na raÄunu se morajo ujemati, Äe nastavite',0),(583430,16207,'ba','Harus cocok pelanggan faktur jika menetapkan',0),(583431,16207,'nl','Moet overeenkomen met de klant op de factuur als instellen',0),(583432,16207,'fi','On vastattava asiakkaan laskun, jos asettaa',0),(583433,16207,'no','Samsvare kunden fakturaen hvis angitt',0),(583434,16207,'da','Skal matche kunden pÃ¥ faktura, hvis indstillet',0),(583435,16207,'ko','ê²½ìš° ê³ ê° ì†¡ìž¥ì— ì¼ì¹˜ í•´ì•¼ í•©ë‹ˆë‹¤ ì„¤ì •',0),(583436,16207,'he','×—×™×™×‘ ×œ×”×ª××™× ×”×œ×§×•×— ×‘×—×©×‘×•× ×™×ª ×× ×œ×”×’×“×™×¨',0),(583437,16207,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½ Ï€ÎµÎ»Î¬Ï„Î· ÏƒÏ„Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿, ÎµÎ¬Î½ Î¿ÏÎ¯ÏƒÎµÏ„Îµ',0),(583438,16207,'zh','å¦‚æžœå¿…é¡»åŒ¹é…å®¢æˆ·å‘ç¥¨ä¸Šçš„è®¾ç½®',0),(583439,16207,'sv','MÃ¥ste matcha kunden pÃ¥ fakturan om StÃ¤ll',0),(583440,16207,'it','Deve corrispondere il cliente sulla fattura se impostato',0),(583441,16207,'tl','',0),(583442,16207,'th','à¸•à¹‰à¸­à¸‡à¸•à¸£à¸‡à¸à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²à¸šà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸–à¹‰à¸²à¸•à¸±à¹‰à¸‡',0),(583443,16207,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¤° à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡ à¤®à¥‡à¤² à¤–à¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤, à¤¤à¥‹ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(583444,16207,'ms','Mesti sepadan dengan pelanggan pada invois jika ditetapkan',0),(583445,16207,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø¥Ø°Ø§ ÙƒØ§Ù† ØªØ¹ÙŠÙŠÙ†',0),(583446,16207,'fr','Doit correspondre Ã  client sur la facture si la valeur',0),(583447,16207,'jp','å ´åˆã€è«‹æ±‚æ›¸ã«é¡§å®¢ã‚’ä¸€è‡´ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™è¨­å®š',0),(583448,16207,'pt','Deve corresponder ao cliente na factura se definir',0),(583449,16207,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð¾Ð²Ð°Ñ‚ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ñƒ Ð¿Ð¾ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹, ÐµÑÐ»Ð¸ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(583450,16207,'es','Debe coincidir con el cliente en la factura si establece',0),(583451,16207,'de','MÃ¼ssen Kunden auf Rechnung Ã¼bereinstimmen, wenn festgelegt',0),(583452,16207,'en','Must Match Customer On Invoice If Set',0),(583453,16208,'is','',0),(583454,16208,'dr','Ù‡ÛŒÚ† Ù…Ø´ØªØ±ÛŒ Ø¨Ø±Ø§ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(583455,16208,'pr','Ù‡ÛŒÚ† Ù…Ø´ØªØ±ÛŒ Ø¨Ø±Ø§ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(583456,16208,'tr','HiÃ§bir mÃ¼ÅŸteri fatura iÃ§in bulundu',0),(583457,16208,'pl','Å»aden klient nie znaleziono dla faktury',0),(583458,16208,'bg','ÐÑÐ¼Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(583459,16208,'ur','Ú©ÙˆØ¦ÛŒ Ú¯Ø§ÛÚ© Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ù„Ø¦Û’ Ù…Ù„ Ú¯ÛŒØ§',0),(583460,16208,'sr','ÐÐµÐ¼Ð° ÐºÑƒÐ¿Ñ†Ð° Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(583461,16208,'vi','KhÃ¡ch hÃ ng khÃ´ng tÃ¬m tháº¥y cho hoÃ¡ Ä‘Æ¡n',0),(583462,16208,'af','Geen kliÃ«nt vir faktuur gevind',0),(583463,16208,'ro','Nici un client pentru factura',0),(583464,16208,'et','Mitte Ã¼kski klient arve ei leitud',0),(583465,16208,'si','Nobene stranke, za raÄun',0),(583466,16208,'ba','Tidak ada pelanggan yang ditemukan untuk faktur',0),(583467,16208,'nl','Geen klant gevonden voor factuur',0),(583468,16208,'fi','Ei asiakasta lÃ¶ydy laskun',0),(583469,16208,'no','Ingen kunde funnet For faktura',0),(583470,16208,'da','Ingen kunde fundet For faktura',0),(583471,16208,'ko','ì•„ë‹ˆ ê³ ê° ì†¡ìž¥ì— ëŒ€ í•œ ë°œê²¬',0),(583472,16208,'he','×”×œ×§×•×— ×œ× × ×ž×¦××• ×¢×‘×•×¨ ×—×©×‘×•× ×™×ª',0),(583473,16208,'el','ÎšÎ±Î½Î­Î½Î±Ï‚ Ï€ÎµÎ»Î¬Ï„Î·Ï‚ Î²ÏÎ­Î¸Î·ÎºÎ±Î½ Î³Î¹Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(583474,16208,'zh','æ²¡æœ‰å‘çŽ°å‘ç¥¨çš„å®¢æˆ·',0),(583475,16208,'sv','Ingen kund som hittat fÃ¶r faktura',0),(583476,16208,'it','Nessun cliente trovato per fattura',0),(583477,16208,'tl','',0),(583478,16208,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¹„à¸¡à¹ˆà¸žà¸šà¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(583479,16208,'hi','à¤•à¥‹à¤ˆ à¤—à¥à¤°à¤¾à¤¹à¤• à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¤¿à¤²à¤¾',0),(583480,16208,'ms','Tidak ada pelanggan yang ditemui untuk invois',0),(583481,16208,'ar','Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡ Ù„Ù… ØªØ¨ÙŠÙ† Ù„Ù„ÙØ§ØªÙˆØ±Ø©',0),(583482,16208,'fr','Aucun client trouvÃ© pour la facture',0),(583483,16208,'jp','è«‹æ±‚æ›¸ã®ãªã„é¡§å®¢',0),(583484,16208,'pt','Nenhum cliente encontrado por fatura',0),(583485,16208,'ru','ÐÐµ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð½Ð°Ð¹Ð´ÐµÐ½ Ð´Ð»Ñ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(583486,16208,'es','NingÃºn cliente de factura',0),(583487,16208,'de','Kein Kunde gefunden fÃ¼r Rechnung',0),(583488,16208,'en','No Customer Found For Invoice',0),(583489,16209,'is','',0),(583490,16209,'dr','Ø³Ø¹ÛŒ Ú©Ù†ÛŒØ¯',0),(583491,16209,'pr','Ø³Ø¹ÛŒ Ú©Ù†ÛŒØ¯',0),(583492,16209,'tr','Deneyin',0),(583493,16209,'pl','SprÃ³buj',0),(583494,16209,'bg','ÐžÐ¿Ð¸Ñ‚Ð°Ð¹Ñ‚Ðµ',0),(583495,16209,'ur','Ú©ÙˆØ´Ø´',0),(583496,16209,'sr','ÐŸÐ¾ÐºÑƒÑˆÐ°Ñ˜Ñ‚Ðµ',0),(583497,16209,'vi','Cá»‘ gáº¯ng',0),(583498,16209,'af','Probeer',0),(583499,16209,'ro','ÃŽncercaÅ£i',0),(583500,16209,'et','Proovige',0),(583501,16209,'si','Poskusite',0),(583502,16209,'ba','Coba',0),(583503,16209,'nl','Probeer',0),(583504,16209,'fi','Kokeile',0),(583505,16209,'no','PrÃ¸ve',0),(583506,16209,'da','PrÃ¸v',0),(583507,16209,'ko','ì‹œë„',0),(583508,16209,'he','× ×¡×”',0),(583509,16209,'el','Î”Î¿ÎºÎ¹Î¼Î¬ÏƒÏ„Îµ',0),(583510,16209,'zh','å°è¯•',0),(583511,16209,'sv','FÃ¶rsÃ¶k',0),(583512,16209,'it','Provare',0),(583513,16209,'tl','',0),(583514,16209,'th','à¸¥à¸­à¸‡',0),(583515,16209,'hi','à¤ªà¥à¤°à¤¯à¤¾à¤¸ à¤•à¤°à¥‡à¤‚',0),(583516,16209,'ms','Cuba',0),(583517,16209,'ar','Ø­Ø§ÙˆÙ„',0),(583518,16209,'fr','Essayez',0),(583519,16209,'jp','è©¦ã—ã¦ã¿ã‚‹',0),(583520,16209,'pt','Tente',0),(583521,16209,'ru','ÐŸÐ¾Ð¿Ñ€Ð¾Ð±ÑƒÐ¹Ñ‚Ðµ',0),(583522,16209,'es','Tratar de',0),(583523,16209,'de','Versuchen Sie es',0),(583524,16209,'en','Try',0),(583525,16210,'is','',0),(583526,16210,'dr','Ø§Ø±Ø²Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø­Ø§Ù„ Ø§Ù†ØªØ·Ø§Ø±',0),(583527,16210,'pr','Ø§Ø±Ø²Ø´ Ø³ÙØ§Ø±Ø´Ø§Øª Ø¯Ø± Ø­Ø§Ù„ Ø§Ù†ØªØ·Ø§Ø±',0),(583528,16210,'tr','Bekleyen sipariÅŸler deÄŸeri',0),(583529,16210,'pl','WartoÅ›Ä‡ zlecenia oczekujÄ…ce',0),(583530,16210,'bg','Ð¡Ñ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚Ñ‚Ð° Ð½Ð° Ð²Ð¸ÑÑÑ‰Ð¸ Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ¸',0),(583531,16210,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø¢Ø±ÚˆØ±Ø² Ú©ÛŒ Ù‚Ø¯Ø±',0),(583532,16210,'sr','Ð’Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚ ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¾ Ð½Ð°Ñ€ÐµÐ´Ñ˜ÐµÑšÐ°',0),(583533,16210,'vi','GiÃ¡ trá»‹ Ä‘ang chá» xá»­ lÃ½ Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(583534,16210,'af','Waarde van hangende bestellings',0),(583535,16210,'ro','Valoare de pÃ¢nÄƒ la ordinele',0),(583536,16210,'et','VÃ¤Ã¤rtus kuni tellimused',0),(583537,16210,'si','Vrednost ÄakajoÄa naroÄila',0),(583538,16210,'ba','Nilai dari Pending Order',0),(583539,16210,'nl','Waarde van in afwachting van Orders',0),(583540,16210,'fi','Arvo on odottavien toimeksiantojen',0),(583541,16210,'no','Verdien for ventende ordre',0),(583542,16210,'da','VÃ¦rdien af afventende ordrer',0),(583543,16210,'ko','ì£¼ë¬¸ ë³´ë¥˜ì˜ ê°’',0),(583544,16210,'he','×”×¢×¨×š ×©×œ ×”×•×¨××•×ª ×ž×ž×ª×™× ×•×ª',0),(583545,16210,'el','Î‘Î¾Î¯Î± Ï„Ï‰Î½ ÎµÎºÎºÏÎµÎ¼ÏŽÎ½ Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¹ÏŽÎ½',0),(583546,16210,'zh','æŒ‚å•çš„ä»·å€¼',0),(583547,16210,'sv','VÃ¤rdet av avvaktande ordrar',0),(583548,16210,'it','Valore di ordini pendenti',0),(583549,16210,'tl','',0),(583550,16210,'th','à¸¡à¸¹à¸¥à¸„à¹ˆà¸²à¸‚à¸­à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(583551,16210,'hi','à¤¬à¤¨à¥à¤¦ à¤¹à¥‹à¤¨à¥‡ à¤•à¥€ à¤¸à¥à¤¥à¤¿à¤¤à¤¿à¤¯à¥‹ à¤•à¥€ à¤®à¤¾à¤¨',0),(583552,16210,'ms','Nilai pesanan dagangan tertunda',0),(583553,16210,'ar','Ù‚ÙŠÙ…Ø© Ø§Ù„Ø£ÙˆØ§Ù…Ø± Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(583554,16210,'fr','Valeur de commandes en attente',0),(583555,16210,'jp','ä¿ç•™ä¸­ã®æ³¨æ–‡ã®å€¤',0),(583556,16210,'pt','Valor de ordens pendentes',0),(583557,16210,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ð¾Ñ‚Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ñ€Ð´ÐµÑ€Ð¾Ð²',0),(583558,16210,'es','Valor de Ã³rdenes pendientes',0),(583559,16210,'de','Wert der noch nicht erledigten AuftrÃ¤ge',0),(583560,16210,'en','Value Of Pending Orders',0),(583561,16211,'is','',0),(583562,16211,'dr','Ú©Ù„ÛŒØ¯ Ù…Ø­ØµÙˆÙ„',0),(583563,16211,'pr','Ú©Ù„ÛŒØ¯ Ù…Ø­ØµÙˆÙ„',0),(583564,16211,'tr','ÃœrÃ¼n anahtarÄ±',0),(583565,16211,'pl','Klucz produktu',0),(583566,16211,'bg','ÐŸÑ€Ð¾Ð´ÑƒÐºÑ‚Ð¾Ð² ÐºÐ»ÑŽÑ‡',0),(583567,16211,'ur','Ú©Ù„ÛŒØ¯ Ù…ØµÙ†ÙˆØ¹Û',0),(583568,16211,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(583569,16211,'vi','Sáº£n pháº©m chÃ­nh',0),(583570,16211,'af','Produksleutel',0),(583571,16211,'ro','Rezultat cheie',0),(583572,16211,'et','Tootenumber',0),(583573,16211,'si','KljuÄ izdelka',0),(583574,16211,'ba','Kunci produk',0),(583575,16211,'nl','Productcode',0),(583576,16211,'fi','HedelmÃ¤ avain',0),(583577,16211,'no','Fabrikat nÃ¸kkel',0),(583578,16211,'da','Fabrikat nÃ¸glen',0),(583579,16211,'ko','ì œí’ˆ í‚¤',0),(583580,16211,'he','×ž×¤×ª×— ×”×ž×•×¦×¨',0),(583581,16211,'el','ÎšÎ»ÎµÎ¹Î´Î¯ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚',0),(583582,16211,'zh','äº§å“å¯†é’¥',0),(583583,16211,'sv','Produktnyckel',0),(583584,16211,'it','Chiave del prodotto',0),(583585,16211,'tl','',0),(583586,16211,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œ',0),(583587,16211,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤•à¥à¤‚à¤œà¥€',0),(583588,16211,'ms','Kekunci produk',0),(583589,16211,'ar','Ù…ÙØªØ§Ø­ Ø§Ù„Ù…Ù†ØªØ¬',0),(583590,16211,'fr','ClÃ© de produit',0),(583591,16211,'jp','ãƒ—ãƒ­ãƒ€ã‚¯ãƒˆ ã‚­ãƒ¼',0),(583592,16211,'pt','Chave do produto',0),(583593,16211,'ru','ÐšÐ»ÑŽÑ‡ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(583594,16211,'es','Clave de producto',0),(583595,16211,'de','Product Key',0),(583596,16211,'en','Product Key',0),(583597,16212,'is','',0),(583598,16212,'dr','Ø®Ø·ÙˆØ·',0),(583599,16212,'pr','Ø®Ø·ÙˆØ·',0),(583600,16212,'tr','SatÄ±rlarÄ±',0),(583601,16212,'pl','Linii',0),(583602,16212,'bg','Ð›Ð¸Ð½Ð¸Ð¸',0),(583603,16212,'ur','Ù„Ø§Ø¦Ù†ÛŒÚº',0),(583604,16212,'sr','Ð ÐµÐ´Ð¾Ð²Ð¸',0),(583605,16212,'vi','DÃ¢y chuyá»n',0),(583606,16212,'af','Lyne',0),(583607,16212,'ro','Linii',0),(583608,16212,'et','Read',0),(583609,16212,'si','Vrstice',0),(583610,16212,'ba','Garis',0),(583611,16212,'nl','Lijnen',0),(583612,16212,'fi','Rivit',0),(583613,16212,'no','Linjer',0),(583614,16212,'da','Linjer',0),(583615,16212,'ko','ë¼ì¸',0),(583616,16212,'he','×§×•×•×™×',0),(583617,16212,'el','Î“ÏÎ±Î¼Î¼Î­Ï‚',0),(583618,16212,'zh','çº¿æ¡',0),(583619,16212,'sv','Linjer',0),(583620,16212,'it','Linee',0),(583621,16212,'tl','',0),(583622,16212,'th','à¸šà¸£à¸£à¸—à¸±à¸”',0),(583623,16212,'hi','à¤²à¤¾à¤‡à¤¨à¥‹à¤‚',0),(583624,16212,'ms','Garisan',0),(583625,16212,'ar','Ø®Ø·ÙˆØ·',0),(583626,16212,'fr','Lignes',0),(583627,16212,'jp','ãƒ©ã‚¤ãƒ³',0),(583628,16212,'pt','Linhas',0),(583629,16212,'ru','Ð›Ð¸Ð½Ð¸Ð¸',0),(583630,16212,'es','LÃ­neas de',0),(583631,16212,'de','Linien',0),(583632,16212,'en','Lines',0),(583633,16213,'is','',0),(583634,16213,'dr','ÙØ§ÛŒÙ„ Ù…Ù†ØªÙ‚Ù„ Ù…ÛŒ',0),(583635,16213,'pr','ÙØ§ÛŒÙ„ Ù…Ù†ØªÙ‚Ù„ Ù…ÛŒ',0),(583636,16213,'tr','Dosya taÅŸÄ±nmaz',0),(583637,16213,'pl','Plik nie moÅ¼e byÄ‡ przeniesiony',0),(583638,16213,'bg','Ð¤Ð°Ð¹Ð»ÑŠÑ‚ Ð½Ðµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ñ€ÐµÐ¼ÐµÑÑ‚ÐµÐ½',0),(583639,16213,'ur','Ù…Ø³Ù„ Ù…Ù†ØªÙ‚Ù„ Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§',0),(583640,16213,'sr','Ð”Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð¼Ð¾Ð¶Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¿Ñ€ÐµÐ¼ÐµÑˆÑ‚ÐµÐ½Ð°',0),(583641,16213,'vi','Tá»‡p cÃ³ thá»ƒ khÃ´ng Ä‘Æ°á»£c di chuyá»ƒn',0),(583642,16213,'af','LÃªer kan nie geskuif word nie',0),(583643,16213,'ro','FiÅŸierul nu poate fi mutat',0),(583644,16213,'et','Faili ei saa liigutada',0),(583645,16213,'si','Datoteke ni mogoÄe premakniti',0),(583646,16213,'ba','File tidak dapat dipindahkan',0),(583647,16213,'nl','Bestand kan niet worden verplaatst',0),(583648,16213,'fi','Tiedostoa ei voi siirtÃ¤Ã¤',0),(583649,16213,'no','Filen kan ikke flyttes',0),(583650,16213,'da','Filen kan ikke flyttes',0),(583651,16213,'ko','íŒŒì¼ì„ ì´ë™í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(583652,16213,'he','×œ× × ×™×ª×Ÿ ×œ×”×¢×‘×™×¨ ×§×•×‘×¥',0),(583653,16213,'el','Î¤Î¿ Î±ÏÏ‡ÎµÎ¯Î¿ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î¼ÎµÏ„Î±ÎºÎ¹Î½Î·Î¸ÎµÎ¯',0),(583654,16213,'zh','æ–‡ä»¶ä¸èƒ½ç§»åŠ¨',0),(583655,16213,'sv','Filen kan inte flyttas',0),(583656,16213,'it','File non possa essere spostati',0),(583657,16213,'tl','',0),(583658,16213,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸¢à¹‰à¸²à¸¢à¹à¸Ÿà¹‰à¸¡',0),(583659,16213,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤•à¥‹ à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(583660,16213,'ms','Fail tidak dapat dialihkan',0),(583661,16213,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ù†Ù‚Ù„ Ø§Ù„Ù…Ù„Ù',0),(583662,16213,'fr','Fichier ne peut pas Ãªtre dÃ©placÃ©',0),(583663,16213,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‚’ç§»å‹•ã§ãã¾ã›ã‚“ã€‚',0),(583664,16213,'pt','Arquivo nÃ£o pode ser movido.',0),(583665,16213,'ru','Ð¤Ð°Ð¹Ð» Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÐ¼ÐµÑ‰ÐµÐ½',0),(583666,16213,'es','No se puede mover archivo',0),(583667,16213,'de','Datei kann nicht verschoben werden',0),(583668,16213,'en','File Cannot Be Moved',0),(583669,16214,'is','',0),(583670,16214,'dr','Ø±Ø¯',0),(583671,16214,'pr','Ø±Ø¯',0),(583672,16214,'tr','AtlandÄ±',0),(583673,16214,'pl','PominiÄ™te',0),(583674,16214,'bg','ÐšÐ°Ð¿Ð¸Ñ‚Ð°Ð½',0),(583675,16214,'ur','Ø§Ú†Ù¹ÛŒ',0),(583676,16214,'sr','ÐŸÑ€ÐµÑÐºÐ¾Ñ‡ÐµÐ½Ð°',0),(583677,16214,'vi','Bá» qua',0),(583678,16214,'af','Oorgeslaan',0),(583679,16214,'ro','De sarit',0),(583680,16214,'et','Vahele jÃ¤etud',0),(583681,16214,'si','SkakaÄ',0),(583682,16214,'ba','Melewatkan',0),(583683,16214,'nl','Overgeslagen',0),(583684,16214,'fi','Ohitetaan',0),(583685,16214,'no','Hoppet over',0),(583686,16214,'da','Sprunget over',0),(583687,16214,'ko','ìƒëžµ',0),(583688,16214,'he','×”×ž×¢×¨×›×ª ×“×™×œ×’×”',0),(583689,16214,'el','ÎšÎ±ÏÎ±Î²Î¿ÎºÏÏÎ·Ï‚',0),(583690,16214,'zh','è·³è¿‡',0),(583691,16214,'sv','Hoppade Ã¶ver',0),(583692,16214,'it','Saltato',0),(583693,16214,'tl','',0),(583694,16214,'th','à¸‚à¹‰à¸²à¸¡à¹„à¸›',0),(583695,16214,'hi','à¤›à¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾',0),(583696,16214,'ms','Dilangkau',0),(583697,16214,'ar','ØªØ®Ø·ÙŠ',0),(583698,16214,'fr','IgnorÃ©s',0),(583699,16214,'jp','ã‚¹ã‚­ãƒƒãƒ—',0),(583700,16214,'pt','Ignorada',0),(583701,16214,'ru','ÐŸÑ€Ð¾Ð¿ÑƒÑ‰ÐµÐ½',0),(583702,16214,'es','SaltÃ³',0),(583703,16214,'de','Ãœbersprungen',0),(583704,16214,'en','Skipped',0),(583705,16215,'is','',0),(583706,16215,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ',0),(583707,16215,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ù…Ø´ØªØ±ÛŒ',0),(583708,16215,'tr','MÃ¼ÅŸteri Ã¶demeleri',0),(583709,16215,'pl','PÅ‚atnoÅ›ci od klientÃ³w',0),(583710,16215,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ÑÐºÐ¸ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(583711,16215,'ur','Ú©Ø³Ù¹Ù…Ø± Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(583712,16215,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ ÐºÑƒÐ¿Ñ†Ð°',0),(583713,16215,'vi','KhÃ¡ch hÃ ng thanh toÃ¡n',0),(583714,16215,'af','KliÃ«nt betalings',0),(583715,16215,'ro','PlÄƒÅ£ile clienÅ£ilor',0),(583716,16215,'et','Kliendi maksed',0),(583717,16215,'si','PlaÄila strank',0),(583718,16215,'ba','Pembayaran nasabah',0),(583719,16215,'nl','Betalingen van klanten',0),(583720,16215,'fi','Asiakasmaksut',0),(583721,16215,'no','Kundebetalinger',0),(583722,16215,'da','Debitorbetalinger',0),(583723,16215,'ko','ê³ ê° ì§€ë¶ˆ',0),(583724,16215,'he','×ª×©×œ×•×ž×™ ×œ×§×•×—',0),(583725,16215,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€ÎµÎ»Î±Ï„ÏŽÎ½',0),(583726,16215,'zh','å®¢æˆ·ä»˜æ¬¾',0),(583727,16215,'sv','Kundbetalningar',0),(583728,16215,'it','Pagamenti dei clienti',0),(583729,16215,'tl','',0),(583730,16215,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(583731,16215,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(583732,16215,'ms','Pembayaran pelanggan',0),(583733,16215,'ar','Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(583734,16215,'fr','Paiements des clients',0),(583735,16215,'jp','ãŠå®¢æ§˜ã®ãŠæ”¯æ‰•ã„',0),(583736,16215,'pt','Pagamentos do cliente',0),(583737,16215,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(583738,16215,'es','Pagos del cliente',0),(583739,16215,'de','Zahlungen des Kunden',0),(583740,16215,'en','Customer Payments',0),(583741,16216,'is','',0),(583742,16216,'dr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(583743,16216,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(583744,16216,'tr','SatÄ±cÄ± Ã¶demeleri',0),(583745,16216,'pl','PÅ‚atnoÅ›ci dla dostawcÃ³w',0),(583746,16216,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(583747,16216,'ur','ÙˆÛŒÙ†ÚˆØ± Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(583748,16216,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸Ð¼Ð°',0),(583749,16216,'vi','NhÃ  cung cáº¥p cÃ¡c khoáº£n thanh toÃ¡n',0),(583750,16216,'af','Handelaar betalings',0),(583751,16216,'ro','Furnizor de plÄƒÅ£i',0),(583752,16216,'et','Hankija maksete',0),(583753,16216,'si','PlaÄila dobaviteljem',0),(583754,16216,'ba','Penjual pembayaran',0),(583755,16216,'nl','Betalingsvoorstellen maken',0),(583756,16216,'fi','Toimittajamaksut',0),(583757,16216,'no','LeverandÃ¸r',0),(583758,16216,'da','Kreditorbetalinger',0),(583759,16216,'ko','ê³µê¸‰ ì—…ì²´ ì§€ë¶ˆ',0),(583760,16216,'he','×ª×©×œ×•×ž×™ ×¡×¤×§',0),(583761,16216,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„ÏŽÎ½',0),(583762,16216,'zh','ä¾›åº”å•†ä»˜æ¬¾',0),(583763,16216,'sv','LeverantÃ¶rsbetalningar',0),(583764,16216,'it','Pagamenti ai fornitori',0),(583765,16216,'tl','',0),(583766,16216,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(583767,16216,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(583768,16216,'ms','Pembayaran pembekal',0),(583769,16216,'ar','Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ†',0),(583770,16216,'fr','Paiement des fournisseurs',0),(583771,16216,'jp','ä»•å…¥å…ˆæ”¯æ‰•',0),(583772,16216,'pt','Pagamentos de fornecedores',0),(583773,16216,'ru','ÐŸÐ»Ð°Ñ‚ÐµÐ¶Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(583774,16216,'es','Pagos a proveedores',0),(583775,16216,'de','Kreditorenzahlungen',0),(583776,16216,'en','Vendor Payments',0),(583777,16217,'is','',0),(583778,16217,'dr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(583779,16217,'pr','Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(583780,16217,'tr','Hesap numarasÄ± eÅŸleÅŸmiyor',0),(583781,16217,'pl','Numer konta nie sÄ… zgodne',0),(583782,16217,'bg','ÐÐ¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ° Ð½Ðµ ÑÐ¸ ÑÑŠÐ¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²Ð°Ñ‚',0),(583783,16217,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº',0),(583784,16217,'sr','Ð‘Ñ€Ð¾Ñ˜ ÐºÐ¾Ð½Ñ‚Ð° ÑÐµ Ð½Ðµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð°Ñ˜Ñƒ.',0),(583785,16217,'vi','Sá»‘ tÃ i khoáº£n khÃ´ng khá»›p',0),(583786,16217,'af','Rekening nommer nie ooreenstem met',0),(583787,16217,'ro','NumÄƒrul de cont nu se potrivesc',0),(583788,16217,'et','Konto Number ei vasta',0),(583789,16217,'si','Å tevilka se ujemata',0),(583790,16217,'ba','Nomor rekening tidak cocok',0),(583791,16217,'nl','Rekeningnummer niet overeenkomen met',0),(583792,16217,'fi','Tilinumero eivÃ¤t tÃ¤smÃ¤Ã¤',0),(583793,16217,'no','Kontonummeret samsvarer ikke',0),(583794,16217,'da','Kontonummer passer ikke',0),(583795,16217,'ko','ê³„ì • ë²ˆí˜¸ë¥¼ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(583796,16217,'he','×ž×¡×¤×¨ ×”×—×©×‘×•×Ÿ ××™× × ×ª×•××ž×™×',0),(583797,16217,'el','Î‘ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î´ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶Î¿Ï…Î½',0),(583798,16217,'zh','å¸æˆ·å·ç ä¸åŒ¹é…',0),(583799,16217,'sv','Kontonummer matchar inte',0),(583800,16217,'it','Numero di conto non corrispondono',0),(583801,16217,'tl','',0),(583802,16217,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µà¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸™',0),(583803,16217,'hi','à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥‡',0),(583804,16217,'ms','Nombor akaun tidak padan',0),(583805,16217,'ar','Ù„Ø§ ØªØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(583806,16217,'fr','NumÃ©ro de compte ne correspondent pas',0),(583807,16217,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆæ•°ãŒä¸€è‡´ã—ã¾ã›ã‚“',0),(583808,16217,'pt','NÃºmero da conta nÃ£o corresponde',0),(583809,16217,'ru','ÐÐ¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð½Ðµ ÑÐ¾Ð²Ð¿Ð°Ð´Ð°ÑŽÑ‚',0),(583810,16217,'es','NÃºmero de cuenta no coinciden con',0),(583811,16217,'de','Kontonummer stimmen nicht Ã¼berein',0),(583812,16217,'en','Account Numbers Do Not Match',0),(583813,16218,'is','',0),(583814,16218,'dr','Ø­Ø³Ø§Ø¨ Ø¨Ø±Ú¯Ø´Øª EFT',0),(583815,16218,'pr','Ø­Ø³Ø§Ø¨ Ø¨Ø±Ú¯Ø´Øª EFT',0),(583816,16218,'tr','Arka hesaba EFT',0),(583817,16218,'pl','Rachunku bankowego EFT',0),(583818,16218,'bg','ÐžÐ±Ñ€Ð°Ñ‚Ð½Ð¾ ÑÐ¼ÐµÑ‚ÐºÐ° EFT',0),(583819,16218,'ur','ÙˆØ§Ù¾Ø³ Ø§Ú©Ø§Ø¤Ù†Ù¹ EFT',0),(583820,16218,'sr','Ð—Ð°Ð´ÑšÐ¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð•Ð¤Ð¢',0),(583821,16218,'vi','Quay láº¡i tÃ i khoáº£n EFT',0),(583822,16218,'af','Terug rekening EFT',0),(583823,16218,'ro','Cont spate EFT',0),(583824,16218,'et','Pangakonto EFT',0),(583825,16218,'si','Zadnji raÄun EFT',0),(583826,16218,'ba','Kembali Account TDE',0),(583827,16218,'nl','Terug Account EFT',0),(583828,16218,'fi','Takaisin tilille EFT',0),(583829,16218,'no','Tilbake kontoen EFT',0),(583830,16218,'da','Back konto EFT',0),(583831,16218,'ko','ë‹¤ì‹œ ê³„ì • ì†¡ê¸ˆ',0),(583832,16218,'he','×’×‘ ×—×©×‘×•×Ÿ EFT',0),(583833,16218,'el','Î Î¯ÏƒÏ‰ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ EFT',0),(583834,16218,'zh','EFT å¸æˆ·',0),(583835,16218,'sv','Tillbaka konto EFT',0),(583836,16218,'it','Conto indietro EFT',0),(583837,16218,'tl','',0),(583838,16218,'th','à¸«à¸¥à¸±à¸‡à¸šà¸±à¸à¸Šà¸µ EFT',0),(583839,16218,'hi','à¤ªà¥€à¤  à¤–à¤¾à¤¤à¥‡ à¤ˆà¤à¤«à¤¼à¤Ÿà¥€',0),(583840,16218,'ms','Belakang akaun EFT',0),(583841,16218,'ar','Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¸Ù‡Ø± EFT',0),(583842,16218,'fr','Compte dos EFT',0),(583843,16218,'jp','æˆ»ã‚‹ã‚¢ã‚«ã‚¦ãƒ³ãƒˆéŠ€è¡Œå£åº§æŒ¯è¾¼',0),(583844,16218,'pt','Conta EFT',0),(583845,16218,'ru','ÐÐ°Ð·Ð°Ð´ ÑÑ‡ÐµÑ‚ EFT',0),(583846,16218,'es','Cuenta atrÃ¡s de EFT',0),(583847,16218,'de','ZurÃ¼ck Konto EFT',0),(583848,16218,'en','Bank Account EFT',0),(583849,16219,'is','',0),(583850,16219,'dr','ØªØ§ÛŒÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ',0),(583851,16219,'pr','ØªØ§ÛŒÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø¨Ø§Ù†Ú©ÛŒ',0),(583852,16219,'tr','Banka hesap numarasÄ± onaylamak',0),(583853,16219,'pl','PotwierdÅº numer konta bankowego',0),(583854,16219,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(583855,16219,'ur','Ø¨ÛŒÙ†Ú© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(583856,16219,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð° Ñƒ Ð±Ð°Ð½Ñ†Ð¸',0),(583857,16219,'vi','XÃ¡c nháº­n sá»‘ tÃ i khoáº£n ngÃ¢n hÃ ng',0),(583858,16219,'af','Bank rekening nommer bevestig',0),(583859,16219,'ro','Confirma numarul de cont bancar',0),(583860,16219,'et','Kinnitada pangakonto Number',0),(583861,16219,'si','Potrditev Å¡tevilka banÄnega raÄuna',0),(583862,16219,'ba','Konfirmasikan nomor rekening Bank',0),(583863,16219,'nl','Bankrekeningnummer bevestigen',0),(583864,16219,'fi','Vahvista pankkitilinumero',0),(583865,16219,'no','Bekrefte bankkontonummeret',0),(583866,16219,'da','BekrÃ¦ft Bank Account Number',0),(583867,16219,'ko','ì€í–‰ ê³„ì¢Œ ë²ˆí˜¸ í™•ì¸',0),(583868,16219,'he','×œ××©×¨ ×ž×¡×¤×¨ ×—×©×‘×•×Ÿ ×‘× ×§',0),(583869,16219,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¯Ï‰ÏƒÎ· Î±ÏÎ¹Î¸Î¼Î¿Ï Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ¿Ï Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(583870,16219,'zh','ç¡®è®¤çš„é“¶è¡Œè´¦æˆ·å·ç ',0),(583871,16219,'sv','BekrÃ¤fta bankkontonummer',0),(583872,16219,'it','Confermare il numero di conto bancario',0),(583873,16219,'tl','',0),(583874,16219,'th','à¸¢à¸·à¸™à¸¢à¸±à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µà¸˜à¸™à¸²à¸„à¸²à¸£',0),(583875,16219,'hi','à¤¬à¥ˆà¤‚à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(583876,16219,'ms','Mengesahkan nombor akaun Bank',0),(583877,16219,'ar','ØªØ£ÙƒÙŠØ¯ Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ',0),(583878,16219,'fr','Confirmer le numÃ©ro de compte bancaire',0),(583879,16219,'jp','éŠ€è¡Œå£åº§ç•ªå·ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(583880,16219,'pt','Confirmar o nÃºmero da conta bancÃ¡ria',0),(583881,16219,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(583882,16219,'es','Confirmar nÃºmero de cuenta bancaria',0),(583883,16219,'de','Kontonummer zu bestÃ¤tigen',0),(583884,16219,'en','Confirm Bank Account Number',0),(583885,16220,'is','',0),(583886,16220,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø§Ø±Ø³Ø§Ù„ EFT Ù¾Ø±Ø¯Ø§Ø®Øª',0),(583887,16220,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø§Ø±Ø³Ø§Ù„ EFT Ù¾Ø±Ø¯Ø§Ø®Øª',0),(583888,16220,'tr','Hata gÃ¶nderme EFT Ã¶deme',0),(583889,16220,'pl','BÅ‚Ä…d przesyÅ‚ania pÅ‚atnoÅ›ci EFT',0),(583890,16220,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¿Ð¾Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð•ÐŸÐ¡ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(583891,16220,'ur','Ù†Ù‚Øµ Ø¬Ù…Ø¹ Ú©Ø±ÙˆØ§Ù†Û’ EFT Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(583892,16220,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ð¾Ð´Ð½Ð¾ÑˆÐµÑšÐ° Ð•Ð¤Ð¢ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ°',0),(583893,16220,'vi','Thanh toÃ¡n EFT gá»­i lá»—i',0),(583894,16220,'af','Fout indiening van EFT betaling',0),(583895,16220,'ro','Eroare depunerea EFT plata',0),(583896,16220,'et','Viga esitamise EFT makse',0),(583897,16220,'si','PlaÄilo EFT oddajo napake',0),(583898,16220,'ba','Kesalahan mengirimkan pembayaran TDE',0),(583899,16220,'nl','Fout indienen van EFT betaling',0),(583900,16220,'fi','Virhe lÃ¤hettÃ¤mÃ¤llÃ¤ EFT Payment',0),(583901,16220,'no','Feil sender EFT betaling',0),(583902,16220,'da','Fejl indsendelse EFT betaling',0),(583903,16220,'ko','ì˜¤ë¥˜ ì œì¶œ ì „ìž ì†¡ê¸ˆ ì§€ë¶ˆ',0),(583904,16220,'he','×©×’×™××” ×”×’×©×ª EFT ×”×ª×©×œ×•×',0),(583905,16220,'el','Î£Ï†Î¬Î»Î¼Î± Ï„Î·Î½ Ï…Ï€Î¿Î²Î¿Î»Î® Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ EFT',0),(583906,16220,'zh','é”™è¯¯æäº¤ç”µå­è½¬è´¦ä»˜æ¬¾',0),(583907,16220,'sv','Fel att skicka EFT betalning',0),(583908,16220,'it','Errore invio pagamento EFT',0),(583909,16220,'tl','',0),(583910,16220,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ EFT à¸à¸²à¸£à¸ªà¹ˆà¸‡à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(583911,16220,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤­à¥‡à¤œà¤¨à¥‡ EFT à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(583912,16220,'ms','Ralat menghantar bayaran EFT',0),(583913,16220,'ar','Ø®Ø·Ø£ ØªÙ‚Ø¯ÙŠÙ… EFT Ø§Ù„Ø¯ÙØ¹',0),(583914,16220,'fr','Erreur envoi EFT paiement',0),(583915,16220,'jp','ã‚¨ãƒ©ãƒ¼ã‚’é€ä¿¡ã™ã‚‹éŠ€è¡Œå£åº§æŒ¯è¾¼æ”¯æ‰•ã„',0),(583916,16220,'pt','Erro envio pagamento EFT',0),(583917,16220,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ EFT',0),(583918,16220,'es','Error enviar pago de EFT',0),(583919,16220,'de','Fehler einreichen EFT Zahlung',0),(583920,16220,'en','Error Submitting EFT Payment',0),(583921,16221,'is','',0),(583922,16221,'dr','Ø±ÙˆØ´Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø¯Ø³ØªØ±Ø³',0),(583923,16221,'pr','Ø±ÙˆØ´Ù‡Ø§ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø¯Ø³ØªØ±Ø³',0),(583924,16221,'tr','HiÃ§bir Ã¶deme yÃ¶ntemleri',0),(583925,16221,'pl','Nie dostÄ™pnych metod pÅ‚atnoÅ›ci',0),(583926,16221,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð»Ð¸Ñ‡Ð½Ð¸ Ð¼ÐµÑ‚Ð¾Ð´Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(583927,16221,'ur','Ú©ÙˆØ¦ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Ø±Ù†Û’ Ú©Û’ Ø·Ø±ÛŒÙ‚ÙˆÚº Ø¯Ø³ØªÛŒØ§Ø¨',0),(583928,16221,'sr','ÐÐ°Ñ‡Ð¸Ð½Ð¸ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½',0),(583929,16221,'vi','KhÃ´ng cÃ³ phÆ°Æ¡ng thá»©c thanh toÃ¡n sáºµn',0),(583930,16221,'af','Geen betaling metodes beskikbaar',0),(583931,16221,'ro','Nici metodele de platÄƒ disponibile',0),(583932,16221,'et','Ei ole saadaval makseviisid',0),(583933,16221,'si','Ni na voljo naÄini plaÄila',0),(583934,16221,'ba','Tidak ada metode pembayaran yang tersedia',0),(583935,16221,'nl','Geen beschikbare betalingsmethoden',0),(583936,16221,'fi','Ei maksutapoja',0),(583937,16221,'no','Ingen betalingsmÃ¥ter tilgjengelige',0),(583938,16221,'da','Ingen tilgÃ¦ngelige betalingsmetoder',0),(583939,16221,'ko','ì•„ë‹ˆ ì§€ë¶ˆ ë°©ë²•ì„ ì‚¬ìš©í•  ìˆ˜',0),(583940,16221,'he','××™×Ÿ ×©×™×˜×•×ª ×ª×©×œ×•× ×–×ž×™×Ÿ',0),(583941,16221,'el','ÎšÎ±Î¼Î¯Î± Î¼ÎµÎ¸ÏŒÎ´Î¿Ï…Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Ï€Î¿Ï… Î´Î¹Î±Ï„Î¯Î¸ÎµÎ½Ï„Î±Î¹',0),(583942,16221,'zh','æ²¡æœ‰å¯ç”¨çš„ä»˜æ¬¾æ–¹æ³•',0),(583943,16221,'sv','Inga tillgÃ¤ngliga betalningsmetoder',0),(583944,16221,'it','Senza metodi di pagamento disponibili',0),(583945,16221,'tl','',0),(583946,16221,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹„à¸¡à¹ˆà¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(583947,16221,'hi','à¤•à¥‹à¤ˆ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤¤à¤°à¥€à¤•à¥‡ à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(583948,16221,'ms','Kaedah-kaedah pembayaran yang disediakan',0),(583949,16221,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø·Ø±Ù‚ Ø§Ù„Ø¯ÙØ¹ Ø§Ù„Ù…ØªÙˆÙØ±Ø©',0),(583950,16221,'fr','Sans moyens de paiement disponibles',0),(583951,16221,'jp','åˆ©ç”¨ã§ãã‚‹æ”¯æ‰•æ–¹æ³•ãŒãªã„ã§ã™ã€‚',0),(583952,16221,'pt','NÃ£o hÃ¡ mÃ©todos de pagamento disponÃ­veis',0),(583953,16221,'ru','ÐÐµÑ‚ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ñ… ÑÐ¿Ð¾ÑÐ¾Ð±Ð¾Ð² Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(583954,16221,'es','No hay mÃ©todos de pago disponibles',0),(583955,16221,'de','Keine verfÃ¼gbaren Zahlungsmethoden',0),(583956,16221,'en','No Payment Methods Available',0),(583957,16222,'is','',0),(583958,16222,'dr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(583959,16222,'pr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ø±Ø§ ÙˆØ§Ø±Ø¯ Ú©Ù†ÛŒØ¯',0),(583960,16222,'tr','LÃ¼tfen bir hesap numarasÄ± girmeniz',0),(583961,16222,'pl','ProszÄ™ wpisaÄ‡ numer konta',0),(583962,16222,'bg','ÐœÐ¾Ð»Ñ, Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° ÑÐ¼ÐµÑ‚ÐºÐ°',0),(583963,16222,'ur','Ø§ÛŒÚ© Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(583964,16222,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð±Ñ€Ð¾Ñ˜ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(583965,16222,'vi','Vui lÃ²ng nháº­p má»™t sá»‘ tÃ i khoáº£n',0),(583966,16222,'af','Tik asseblief \'n rekening nommer',0),(583967,16222,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un numÄƒr de cont',0),(583968,16222,'et','Sisestage konto number',0),(583969,16222,'si','Vnesite Å¡tevilko konta',0),(583970,16222,'ba','Harap masukkan nomor rekening',0),(583971,16222,'nl','Voer een rekeningnummer',0),(583972,16222,'fi','Kirjoita tilinumero',0),(583973,16222,'no','Angi et kontonummer',0),(583974,16222,'da','Angiv et kontonummer',0),(583975,16222,'ko','ê³„ì¢Œ ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(583976,16222,'he','× × ×”×–×Ÿ ×ž×¡×¤×¨ ×—×©×‘×•×Ÿ',0),(583977,16222,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î±Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï',0),(583978,16222,'zh','è¯·è¾“å…¥å¸å·',0),(583979,16222,'sv','VÃ¤nligen ange ett kontonummer',0),(583980,16222,'it','Si prega di inserire un numero di conto',0),(583981,16222,'tl','',0),(583982,16222,'th','à¹‚à¸›à¸£à¸”à¸›à¹‰à¸­à¸™à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸šà¸±à¸à¸Šà¸µ',0),(583983,16222,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤à¤• à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(583984,16222,'ms','Sila masukkan nombor akaun',0),(583985,16222,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø§Ù„Ø­Ø³Ø§Ø¨',0),(583986,16222,'fr','Veuillez entrer un numÃ©ro de compte',0),(583987,16222,'jp','å£åº§ç•ªå·ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(583988,16222,'pt','Por favor, digite um nÃºmero de conta',0),(583989,16222,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð°',0),(583990,16222,'es','Por favor ingrese un nÃºmero de cuenta',0),(583991,16222,'de','Bitte geben Sie eine Kontonummer',0),(583992,16222,'en','Please Enter An Account Number',0),(583993,16223,'is','',0),(583994,16223,'dr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ Ù…Ø³ÛŒØ±ÛŒØ§Ø¨ÛŒ',0),(583995,16223,'pr','Ù„Ø·ÙØ§ Ø´Ù…Ø§Ø±Ù‡ Ù…Ø³ÛŒØ±ÛŒØ§Ø¨ÛŒ',0),(583996,16223,'tr','Bir Ã¼retim akÄ±ÅŸÄ± numarasÄ±nÄ± giriniz',0),(583997,16223,'pl','ProszÄ™ wpisaÄ‡ numer marszruty',0),(583998,16223,'bg','ÐœÐ¾Ð»Ñ Ð²ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚',0),(583999,16223,'ur','Ø±ÙˆÙ¹ Ù†Ù…Ø¨Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(584000,16223,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð¸Ð´ÐµÐ½Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ†Ð¸Ð¾Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð±Ð°Ð½ÐºÐµ',0),(584001,16223,'vi','Vui lÃ²ng nháº­p má»™t sá»‘ Ä‘á»‹nh tuyáº¿n',0),(584002,16223,'af','Tik asseblief \'n routing nommer',0),(584003,16223,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i un numÄƒr de rutare',0),(584004,16223,'et','Sisestage marsruudi numbrit',0),(584005,16223,'si','Vnesite Å¡tevilko proizvodnega postopka',0),(584006,16223,'ba','Masukkan nomor routing',0),(584007,16223,'nl','Voer het nummer van een bewerkingsplan',0),(584008,16223,'fi','SyÃ¶tÃ¤ koodi',0),(584009,16223,'no','Oppgi et registreringsnummer',0),(584010,16223,'da','Angiv et registreringsnummer',0),(584011,16223,'ko','ë¼ìš°íŒ… ë²ˆí˜¸ë¥¼ ìž…ë ¥ í•˜ì‹­ì‹œì˜¤',0),(584012,16223,'he','×”×–×™× ×• ××ª ×ž×¡×¤×¨ ×”× ×™×ª×•×‘',0),(584013,16223,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î­Î½Î± ÎºÏ‰Î´Î¹ÎºÏŒ Ï†Î±ÏƒÎµÎ¿Î»Î¿Î³Î¯Î¿Ï…',0),(584014,16223,'zh','è¯·è¾“å…¥è·¯ç”±çš„å·ç ',0),(584015,16223,'sv','VÃ¤nligen ange ett clearingnummer',0),(584016,16223,'it','Si prega di inserire un numero di routing',0),(584017,16223,'tl','',0),(584018,16223,'th','à¸à¸£à¸¸à¸“à¸²à¹ƒà¸ªà¹ˆà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¸ªà¸²à¸¢à¸‡à¸²à¸™à¸à¸²à¸£à¸œà¸¥à¸´à¸•',0),(584019,16223,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¥‹à¤ˆ à¤°à¥‚à¤Ÿà¤¿à¤‚à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(584020,16223,'ms','Sila masukkan nombor penghalaan',0),(584021,16223,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø±Ù‚Ù… Ø§Ù„ØªÙˆØ¬ÙŠÙ‡',0),(584022,16223,'fr','Veuillez entrer un numÃ©ro de routage',0),(584023,16223,'jp','ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå·ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(584024,16223,'pt','Introduza um nÃºmero de roteamento',0),(584025,16223,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð½Ð¾Ð¼ÐµÑ€ Ð¼Ð°Ñ€ÑˆÑ€ÑƒÑ‚Ð°',0),(584026,16223,'es','Por favor ingrese un nÃºmero',0),(584027,16223,'de','Bitte geben Sie eine Bankleitzahl',0),(584028,16223,'en','Please Enter A Routing Number',0),(584029,16224,'is','',0),(584030,16224,'dr','B2b Ø§Ø¬Ø§Ø²Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÛŒ Ø³ÛŒ',0),(584031,16224,'pr','B2b Ø§Ø¬Ø§Ø²Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÛŒ Ø³ÛŒ',0),(584032,16224,'tr','B2b izin Cc Ã¶demeler',0),(584033,16224,'pl','B2B umoÅ¼liwiÄ‡ pÅ‚atnoÅ›ci Cc',0),(584034,16224,'bg','B2B Ð¿Ð¾Ð·Ð²Ð¾Ð»Ð¸ ÑÐº Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(584035,16224,'ur','B2b Cc Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(584036,16224,'sr','Ð‘2Ð± Ð”Ð¾Ð·Ð²Ð¾Ñ™Ð°Ð²Ð°ÑšÐµ Ð´Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð¦Ñ†',0),(584037,16224,'vi','B2b cho phÃ©p thanh toÃ¡n Cc',0),(584038,16224,'af','B2b laat Cc betalings',0),(584039,16224,'ro','B2B permite plÄƒÅ£i Cc',0),(584040,16224,'et','B2B lubada Cc maksed',0),(584041,16224,'si','B2B omogoÄajo Cc plaÄila',0),(584042,16224,'ba','B2B memungkinkan pembayaran kartu kredit',0),(584043,16224,'nl','B2B Cc betalingen toestaan',0),(584044,16224,'fi','B2B avulla Cc maksatusta',0),(584045,16224,'no','B2B tillate Cc betalinger',0),(584046,16224,'da','B2B tillade Cc betalinger',0),(584047,16224,'ko','B2b ìˆ˜ Cc ì§€ë¶ˆ',0),(584048,16224,'he','B2b ×œ××¤×©×¨ ×ª×©×œ×•×ž×™× Cc',0),(584049,16224,'el','B2B ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÎ¹ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Cc',0),(584050,16224,'zh','B2b å…è®¸æŠ„é€ä»˜æ¬¾',0),(584051,16224,'sv','B2B tillÃ¥ta Cc betalningar',0),(584052,16224,'it','B2B permettono pagamenti Cc',0),(584053,16224,'tl','',0),(584054,16224,'th','B2b à¹ƒà¸«à¹‰à¸ªà¸³à¹€à¸™à¸²à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(584055,16224,'hi','B2b à¤¸à¥€à¤¸à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(584056,16224,'ms','B2b membenarkan pembayaran Cc',0),(584057,16224,'ar','ØªØ³Ù…Ø­ B2b Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Cc',0),(584058,16224,'fr','B2B permettent des paiements Cc',0),(584059,16224,'jp','B2b Cc æ”¯æ‰•ã„ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(584060,16224,'pt','B2B permitir pagamentos Cc',0),(584061,16224,'ru','B2B Ð¿Ð¾Ð·Ð²Ð¾Ð»ÑÑŽÑ‚ Cc Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(584062,16224,'es','B2B permite pagos Cc',0),(584063,16224,'de','B2B ermÃ¶glichen Cc Zahlungen',0),(584064,16224,'en','B2B Allow CC Payments',0),(584065,16225,'is','',0),(584066,16225,'dr','Ø¹Ø¯Ù… Ù…ÙˆÙÙ‚ÛŒØª Ø¯Ø± ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… API',0),(584067,16225,'pr','Ø¹Ø¯Ù… Ù…ÙˆÙÙ‚ÛŒØª Ø¯Ø± ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… API',0),(584068,16225,'tr','API oturum aÃ§ma baÅŸarÄ±sÄ±z oldu',0),(584069,16225,'pl','API logowanie nie powiodÅ‚o siÄ™',0),(584070,16225,'bg','ÐÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ API',0),(584071,16225,'ur','API Ù„Ø§Ú¯ Ø§Ù† Ù†Ø§Ú©Ø§Ù…',0),(584072,16225,'sr','ÐÐŸÐ˜ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð° Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿Ñ˜ÐµÐ»Ð°',0),(584073,16225,'vi','API Ä‘Äƒng nháº­p tháº¥t báº¡i',0),(584074,16225,'af','API aantekening het misluk',0),(584075,16225,'ro','Conectare API nu a reuÈ™it',0),(584076,16225,'et','API sisselogimine nurjus',0),(584077,16225,'si','API prijava ni uspela',0),(584078,16225,'ba','API Login gagal',0),(584079,16225,'nl','API-aanmelding is mislukt',0),(584080,16225,'fi','API Kirjautuminen epÃ¤onnistui',0),(584081,16225,'no','API-pÃ¥logging mislyktes',0),(584082,16225,'da','API Login mislykkedes',0),(584083,16225,'ko','API ë¡œê·¸ì¸ ì‹¤íŒ¨',0),(584084,16225,'he','API ×”×›× ×™×¡×” × ×›×©×œ×”',0),(584085,16225,'el','API Î· ÏƒÏÎ½Î´ÎµÏƒÎ· Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(584086,16225,'zh','API ç™»å½•å¤±è´¥',0),(584087,16225,'sv','API-inloggning misslyckades',0),(584088,16225,'it','Impossibile eseguire l\'accesso API',0),(584089,16225,'tl','',0),(584090,16225,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š API à¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(584091,16225,'hi','API à¤²à¥‰à¤—à¤¿à¤¨ à¤µà¤¿à¤«à¤²',0),(584092,16225,'ms','Log masuk API gagal',0),(584093,16225,'ar','ÙØ´Ù„ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ API',0),(584094,16225,'fr','Ã‰chec de la connexion de lâ€™API',0),(584095,16225,'jp','API ã®ãƒ­ã‚°ã‚¤ãƒ³ã«å¤±æ•—ã—ã¾ã—ãŸ',0),(584096,16225,'pt','API Login falhou',0),(584097,16225,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²Ñ…Ð¾Ð´Ð° Ð² API',0),(584098,16225,'es','Error de API de inicio de sesiÃ³n',0),(584099,16225,'de','API-Anmeldung fehlgeschlagen',0),(584100,16225,'en','API Login Failed',0),(584101,16226,'is','',0),(584102,16226,'dr','Ø®Ø·Ø§ÛŒ Sedning',0),(584103,16226,'pr','Ø®Ø·Ø§ÛŒ Sedning',0),(584104,16226,'tr','Hata Sedning',0),(584105,16226,'pl','BÅ‚Ä…d Sedning',0),(584106,16226,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Sedning',0),(584107,16226,'ur','Ø³Ø§Ø¯Ù†Ø§Ù†Ú¯ Ù†Ù‚Øµ',0),(584108,16226,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¡ÐµÐ´Ð½Ð¸Ð½Ð³',0),(584109,16226,'vi','Lá»—i Sedning',0),(584110,16226,'af','Fout Sedning',0),(584111,16226,'ro','Eroare Sedning',0),(584112,16226,'et','TÃµrge Sedning',0),(584113,16226,'si','Napaka Sedning',0),(584114,16226,'ba','Kesalahan Sedning',0),(584115,16226,'nl','Fout Sedning',0),(584116,16226,'fi','Virhe Sedning',0),(584117,16226,'no','Feil Sedning',0),(584118,16226,'da','Fejl Sedning',0),(584119,16226,'ko','ì˜¤ë¥˜ Sedning',0),(584120,16226,'he','×©×’×™××” Sedning',0),(584121,16226,'el','Î£Ï†Î¬Î»Î¼Î± Sedning',0),(584122,16226,'zh','é”™è¯¯ Sedning',0),(584123,16226,'sv','Fel Sedning',0),(584124,16226,'it','Errore Sedning',0),(584125,16226,'tl','',0),(584126,16226,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸” Sedning',0),(584127,16226,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ Sedning',0),(584128,16226,'ms','Ralat Sedning',0),(584129,16226,'ar','Ø³ÙŠØ¯Ù†ÙŠÙ†Ø¬ Ø®Ø·Ø£',0),(584130,16226,'fr','Erreur Sedning',0),(584131,16226,'jp','ã‚¨ãƒ©ãƒ¼ Sedning',0),(584132,16226,'pt','Erro Sedning',0),(584133,16226,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð²Ñ‹Ð±Ð¾Ñ€',0),(584134,16226,'es','Error Sedning',0),(584135,16226,'de','Fehler Sedning',0),(584136,16226,'en','Error Sending',0),(584137,16227,'is','',0),(584138,16227,'dr','Zlien',0),(584139,16227,'pr','Zlien',0),(584140,16227,'tr','Zlien',0),(584141,16227,'pl','Zlien',0),(584142,16227,'bg','Zlien',0),(584143,16227,'ur','Ø²Ù„ÛŒÙ†',0),(584144,16227,'sr','Ð—Ð»Ð¸ÐµÐ½',0),(584145,16227,'vi','Zlien',0),(584146,16227,'af','Zlien',0),(584147,16227,'ro','Zlien',0),(584148,16227,'et','Zlien',0),(584149,16227,'si','Zlien',0),(584150,16227,'ba','Zlien',0),(584151,16227,'nl','Zlien',0),(584152,16227,'fi','Zlien',0),(584153,16227,'no','Zlien',0),(584154,16227,'da','Zlien',0),(584155,16227,'ko','Zlien',0),(584156,16227,'he','Zlien',0),(584157,16227,'el','Zlien',0),(584158,16227,'zh','Zlien',0),(584159,16227,'sv','Zlien',0),(584160,16227,'it','Zlien',0),(584161,16227,'tl','',0),(584162,16227,'th','Zlien',0),(584163,16227,'hi','Zlien',0),(584164,16227,'ms','Zlien',0),(584165,16227,'ar','Ø²Ù„ÙŠÙ†',0),(584166,16227,'fr','Zlien',0),(584167,16227,'jp','Zlien',0),(584168,16227,'pt','Zlien',0),(584169,16227,'ru','Zlien',0),(584170,16227,'es','Zlien',0),(584171,16227,'de','Zlien',0),(584172,16227,'en','Zlien',0),(584173,16228,'is','',0),(584174,16228,'dr','Ø±Ø§Ø² API',0),(584175,16228,'pr','Ø±Ø§Ø² API',0),(584176,16228,'tr','API gizli',0),(584177,16228,'pl','Sekret API',0),(584178,16228,'bg','API Ñ‚Ð°Ð¹Ð½Ð°',0),(584179,16228,'ur','API Ø±Ø§Ø²',0),(584180,16228,'sr','ÐÐŸÐ˜ Ñ‚Ð°Ñ˜Ð½Ð°',0),(584181,16228,'vi','API bÃ­ máº­t',0),(584182,16228,'af','API geheim',0),(584183,16228,'ro','API Secret',0),(584184,16228,'et','API saladus',0),(584185,16228,'si','API skrivnost',0),(584186,16228,'ba','Rahasia API',0),(584187,16228,'nl','API Secret',0),(584188,16228,'fi','API Secret',0),(584189,16228,'no','API Secret',0),(584190,16228,'da','API hemmelighed',0),(584191,16228,'ko','API ë¹„ë°€',0),(584192,16228,'he','×”×¡×•×“ API',0),(584193,16228,'el','API Î¼Ï…ÏƒÏ„Î¹ÎºÏŒ',0),(584194,16228,'zh','API çš„ç§˜å¯†',0),(584195,16228,'sv','API hemlighet',0),(584196,16228,'it','Segreto di API',0),(584197,16228,'tl','',0),(584198,16228,'th','à¸„à¸§à¸²à¸¡à¸¥à¸±à¸šà¸‚à¸­à¸‡ API',0),(584199,16228,'hi','API à¤°à¤¹à¤¸à¥à¤¯',0),(584200,16228,'ms','Rahsia API',0),(584201,16228,'ar','Ø³Ø± API',0),(584202,16228,'fr','Secret de lâ€™API',0),(584203,16228,'jp','API ã®ç§˜å¯†',0),(584204,16228,'pt','Segredo de API',0),(584205,16228,'ru','Ð¡ÐµÐºÑ€ÐµÑ‚ API',0),(584206,16228,'es','Secreto de API',0),(584207,16228,'de','API-Geheimnis',0),(584208,16228,'en','API Secret',0),(584209,16229,'is','',0),(584210,16229,'dr','Ø¢Ø¯Ø±Ø³ API',0),(584211,16229,'pr','Ø¢Ø¯Ø±Ø³ API',0),(584212,16229,'tr','API Url',0),(584213,16229,'pl','Adres Url interfejsu API',0),(584214,16229,'bg','API Url',0),(584215,16229,'ur','API Url',0),(584216,16229,'sr','ÐÐŸÐ˜ Ð£Ñ€Ð»',0),(584217,16229,'vi','API Url',0),(584218,16229,'af','API Url',0),(584219,16229,'ro','API URL-ul',0),(584220,16229,'et','API Url',0),(584221,16229,'si','API Url',0),(584222,16229,'ba','API Url',0),(584223,16229,'nl','API-Url',0),(584224,16229,'fi','API-osoite',0),(584225,16229,'no','API Url',0),(584226,16229,'da','API Url',0),(584227,16229,'ko','API Url',0),(584228,16229,'he','Api ×©×œ ×›×ª×•×‘×ª Url',0),(584229,16229,'el','API Url',0),(584230,16229,'zh','API Url',0),(584231,16229,'sv','API Url',0),(584232,16229,'it','Url di API',0),(584233,16229,'tl','',0),(584234,16229,'th','API Url',0),(584235,16229,'hi','API à¤¯à¥‚à¤†à¤°à¤à¤²',0),(584236,16229,'ms','API Url',0),(584237,16229,'ar','Ø±Ø§Ø¨Ø· API',0),(584238,16229,'fr','Url de lâ€™API',0),(584239,16229,'jp','API ã® Url',0),(584240,16229,'pt','Url da API',0),(584241,16229,'ru','API Url',0),(584242,16229,'es','Url de la API',0),(584243,16229,'de','-API-Url',0),(584244,16229,'en','API URL',0),(584245,16230,'is','',0),(584246,16230,'dr','Ú©Ø§Ø± Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Zlien',0),(584247,16230,'pr','Ú©Ø§Ø± Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ Zlien',0),(584248,16230,'tr','Zlien iÃ§in gÃ¶nderilen iÅŸini',0),(584249,16230,'pl','Zadania wysyÅ‚ane do Zlien',0),(584250,16230,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð°, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¸ Ð½Ð° Zlien',0),(584251,16230,'ur','Ú©Ø§Ù… Ø²Ù„ÛŒÙ† Ú©Û’ Ù„Ø¦Û’ Ø¨Ú¾ÛŒØ¬Ø§',0),(584252,16230,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ Ð¿Ð¾ÑÐ»Ð°Ð¾ Ñƒ Ð—Ð»Ð¸ÐµÐ½',0),(584253,16230,'vi','Viá»‡c gá»­i tá»›i Zlien',0),(584254,16230,'af','Werk na Zlien gestuur',0),(584255,16230,'ro','Job trimis la Zlien',0),(584256,16230,'et','TÃ¶Ã¶d saata Zlien',0),(584257,16230,'si','Delo, poslati Zlien',0),(584258,16230,'ba','Pekerjaan yang dikirim ke Zlien',0),(584259,16230,'nl','Baan naar Zlien gestuurd',0),(584260,16230,'fi','TyÃ¶ lÃ¤hetetÃ¤Ã¤n Zlien',0),(584261,16230,'no','Jobb sendes til Zlien',0),(584262,16230,'da','Job sendes til Zlien',0),(584263,16230,'ko','Zlien ì „ì†¡ ìž‘ì—…',0),(584264,16230,'he','×”×¢×‘×•×“×” × ×©×œ×— Zlien',0),(584265,16230,'el','Î”Î¿Ï…Î»ÎµÎ¹Î¬ Ï€Î¿Ï… Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ Zlien',0),(584266,16230,'zh','å‘é€åˆ° Zlien çš„å·¥ä½œ',0),(584267,16230,'sv','Jobb som skickas till Zlien',0),(584268,16230,'it','Lavoro inviato a Zlien',0),(584269,16230,'tl','',0),(584270,16230,'th','à¸‡à¸²à¸™à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¹„à¸›à¸¢à¸±à¸‡ Zlien',0),(584271,16230,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ Zlien à¤­à¥‡à¤œà¤¾',0),(584272,16230,'ms','Kerja yang dihantar kepada Zlien',0),(584273,16230,'ar','Ù…Ù‡Ù…Ø© Ø£Ø±Ø³Ù„Øª Ø¥Ù„Ù‰ Ø²Ù„ÙŠÙ†',0),(584274,16230,'fr','Emploi Ã  Zlien',0),(584275,16230,'jp','Zlien ã«é€ä¿¡ã•ã‚Œã‚‹ã‚¸ãƒ§ãƒ–',0),(584276,16230,'pt','Trabalho enviado para Zlien',0),(584277,16230,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ, Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð½Ð¾Ðµ Ð² Zlien',0),(584278,16230,'es','Trabajo enviado a Zlien',0),(584279,16230,'de','Auftrag an Zlien gesendet',0),(584280,16230,'en','Job Sent To Zlien',0),(584281,16231,'is','',0),(584282,16231,'dr','Ø§Ø±Ø³Ø§Ù„ Ù…Ø¬Ø¯Ø¯ Ø¨Ù‡ Zlien',0),(584283,16231,'pr','Ø§Ø±Ø³Ø§Ù„ Ù…Ø¬Ø¯Ø¯ Ø¨Ù‡ Zlien',0),(584284,16231,'tr','Zlien iÃ§in\'ni yeniden aktarma',0),(584285,16231,'pl','Retransmisji do Zlien',0),(584286,16231,'bg','ÐŸÑ€ÐµÐ¿Ñ€ÐµÐ´Ð°Ð²Ð° ÐºÑŠÐ¼ Zlien',0),(584287,16231,'ur','Ø²Ù„ÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø±ÛŒÙ¹Ø±Ø§Ù†Ø³Ù…Ø§Ù¹',0),(584288,16231,'sr','ÐŸÑ€ÐµÐ½ÐµÑÐ¸ Ð½Ð° Ð—Ð»Ð¸ÐµÐ½',0),(584289,16231,'vi','Retransmit Ä‘á»ƒ Zlien',0),(584290,16231,'af','Weer te stuur na Zlien',0),(584291,16231,'ro','Retransmite la Zlien',0),(584292,16231,'et','Taasedastada Zlien',0),(584293,16231,'si','Ponovno Zlien',0),(584294,16231,'ba','Retransmit untuk Zlien',0),(584295,16231,'nl','Opnieuw te Zlien',0),(584296,16231,'fi','Edelleen Zlien',0),(584297,16231,'no','Sende Ã¥ Zlien',0),(584298,16231,'da','Videreformidle til Zlien',0),(584299,16231,'ko','Zlienë¥¼ ìž¬ì „ì†¡',0),(584300,16231,'he','×œ×©×“×¨ ×ž×—×“×© ×›×“×™ Zlien',0),(584301,16231,'el','ÎœÎµÏ„Î±Î´ÏŽÏƒÎµÎ¹ ÏƒÎµ Zlien',0),(584302,16231,'zh','ä¼ åˆ° Zlien',0),(584303,16231,'sv','VidaresÃ¤nda till Zlien',0),(584304,16231,'it','Ritrasmettere a Zlien',0),(584305,16231,'tl','',0),(584306,16231,'th','à¸ªà¸­à¸·à¹ˆà¸™à¹€à¸žà¸·à¹ˆà¸­ Zlien',0),(584307,16231,'hi','Retransmit à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ Zlien',0),(584308,16231,'ms','Retransmit ke Zlien',0),(584309,16231,'ar','ÙŠÙ†Ù‚Ù„Ù‡Ø§ Ø¥Ù„Ù‰ Ø²Ù„ÙŠÙ†',0),(584310,16231,'fr','Retransmettre Ã  Zlien',0),(584311,16231,'jp','Zlien ã«å†é€ã—ã¾ã™ã€‚',0),(584312,16231,'pt','Retransmitir para Zlien',0),(584313,16231,'ru','ÐŸÐ¾Ð²Ñ‚Ð¾Ñ€Ð½Ð°Ñ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð° Zlien',0),(584314,16231,'es','Retransmitir a Zlien',0),(584315,16231,'de','Weiterverbreitung, Zlien',0),(584316,16231,'en','Retransmit To Zlien',0),(584317,16232,'is','',0),(584318,16232,'dr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(584319,16232,'pr','Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª',0),(584320,16232,'tr','Ã–deme yÃ¶ntemi mevcut deÄŸil',0),(584321,16232,'pl','Metoda pÅ‚atnoÅ›ci nie jest dostÄ™pna',0),(584322,16232,'bg','ÐœÐµÑ‚Ð¾Ð´ Ð½Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ Ð½Ðµ Ðµ Ð½Ð°Ð»Ð¸Ñ‡ÐµÐ½',0),(584323,16232,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ø·Ø±ÛŒÙ‚Û Ú©Ø§Ø± Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº',0),(584324,16232,'sr','ÐÐ°Ñ‡Ð¸Ð½ Ð¿Ð»Ð°Ñ›Ð°ÑšÐ° Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð°Ð½',0),(584325,16232,'vi','PhÆ°Æ¡ng thá»©c thanh toÃ¡n khÃ´ng cÃ³ sáºµn',0),(584326,16232,'af','Betalingsmetode nie beskikbaar',0),(584327,16232,'ro','Metoda de plata nu este disponibil',0),(584328,16232,'et','Makseviis pole saadaval',0),(584329,16232,'si','NaÄin plaÄila ni na voljo',0),(584330,16232,'ba','Metode pembayaran tidak tersedia',0),(584331,16232,'nl','Betalingsmethode niet beschikbaar',0),(584332,16232,'fi','Maksutapa ei ole kÃ¤ytettÃ¤vissÃ¤',0),(584333,16232,'no','Betalingsmetoden er ikke tilgjengelig',0),(584334,16232,'da','Betalingsmetode ikke tilgÃ¦ngelig',0),(584335,16232,'ko','ì§€ë¶ˆ ë°©ë²•ì„ ì‚¬ìš©í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(584336,16232,'he','×©×™×˜×ª ×”×ª×©×œ×•× ××™× ×• ×–×ž×™×Ÿ',0),(584337,16232,'el','ÎœÎ­Î¸Î¿Î´Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î·',0),(584338,16232,'zh','æ²¡æœ‰å¯ä¾›é€‰æ‹©çš„ä»˜æ¬¾æ–¹æ³•',0),(584339,16232,'sv','Betalningsmetod inte tillgÃ¤ngliga.',0),(584340,16232,'it','Metodo di pagamento non disponibile',0),(584341,16232,'tl','',0),(584342,16232,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹„à¸¡à¹ˆà¸žà¸£à¹‰à¸­à¸¡à¹ƒà¸Šà¹‰à¸‡à¸²à¸™',0),(584343,16232,'hi','à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤§à¤¿ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(584344,16232,'ms','Kaedah pembayaran yang tidak terdapat',0),(584345,16232,'ar','Ø·Ø±ÙŠÙ‚Ø© Ø§Ù„Ø¯ÙØ¹ ØºÙŠØ± Ù…ØªØ§Ø­',0),(584346,16232,'fr','Mode de paiement nâ€™est pas disponible',0),(584347,16232,'jp','ãŠæ”¯æ‰•æ–¹æ³•ã¯ä½¿ç”¨ã§ãã¾ã›ã‚“ã€‚',0),(584348,16232,'pt','MÃ©todo de pagamento nÃ£o estÃ¡ disponÃ­vel',0),(584349,16232,'ru','ÐœÐµÑ‚Ð¾Ð´ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð½ÐµÐ´Ð¾ÑÑ‚ÑƒÐ¿ÐµÐ½',0),(584350,16232,'es','MÃ©todo de pago no disponible',0),(584351,16232,'de','Zahlungsmethode nicht verfÃ¼gbar',0),(584352,16232,'en','Payment Method Not Available',0),(584353,16233,'is','',0),(584354,16233,'dr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…Ø´ØªØ±ÛŒ',0),(584355,16233,'pr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…Ø´ØªØ±ÛŒ',0),(584356,16233,'tr','MÃ¼ÅŸteri ekstresi',0),(584357,16233,'pl','OÅ›wiadczenie klienta',0),(584358,16233,'bg','Ð˜Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(584359,16233,'ur','Ú¯Ø§ÛÚ© Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(584360,16233,'sr','ÐŸÑ€Ð¾Ð¼ÐµÑ‚ ÐºÑƒÐ¿Ñ†Ð°',0),(584361,16233,'vi','BÃ¡o cÃ¡o khÃ¡ch hÃ ng',0),(584362,16233,'af','KliÃ«nt stelling',0),(584363,16233,'ro','Declaratie client',0),(584364,16233,'et','Kliendi vÃ¤ljavÃµte',0),(584365,16233,'si','Izjava kupca',0),(584366,16233,'ba','Pernyataan pelanggan',0),(584367,16233,'nl','Verklaring van de klant',0),(584368,16233,'fi','Asiakkaan tiliote',0),(584369,16233,'no','Kundeutdrag',0),(584370,16233,'da','Kontoudtog',0),(584371,16233,'ko','ê³ ê° ì„±ëª…',0),(584372,16233,'he','×”×¦×”×¨×ª ×”×œ×§×•×—',0),(584373,16233,'el','Î”Î®Î»Ï‰ÏƒÎ· Ï€ÎµÎ»Î¬Ï„Î·',0),(584374,16233,'zh','å®¢æˆ·å¯¹å¸å•',0),(584375,16233,'sv','Kundutdrag',0),(584376,16233,'it','Testimonianza del cliente',0),(584377,16233,'tl','',0),(584378,16233,'th','à¸„à¸³à¸ªà¸±à¹ˆà¸‡à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(584379,16233,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤µà¤¿à¤µà¤°à¤£',0),(584380,16233,'ms','Baca kenyataan',0),(584381,16233,'ar','ÙƒØ´Ù Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(584382,16233,'fr','DÃ©claration du client',0),(584383,16233,'jp','é¡§å®¢æ˜Žç´°æ›¸',0),(584384,16233,'pt','DeclaraÃ§Ã£o do cliente',0),(584385,16233,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(584386,16233,'es','DeclaraciÃ³n del cliente',0),(584387,16233,'de','Kunden-Statement',0),(584388,16233,'en','Customer Statement',0),(584389,16234,'is','',0),(584390,16234,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…Ø´ØªØ±ÛŒ',0),(584391,16234,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…Ø´ØªØ±ÛŒ',0),(584392,16234,'tr','MÃ¼ÅŸteri ifadesini gÃ¶zden geÃ§irme',0),(584393,16234,'pl','W oÅ›wiadczeniu klienta',0),(584394,16234,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ð¹Ñ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(584395,16234,'ur','Ø¢Ù¾ Ú©Û’ Ú¯Ø§ÛÚ© Ø¨ÛŒØ§Ù† Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(584396,16234,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð¸Ð·Ñ˜Ð°Ð²Ñƒ ÐºÑƒÐ¿Ñ†Ð°',0),(584397,16234,'vi','Xem xÃ©t bÃ¡o cÃ¡o khÃ¡ch hÃ ng cá»§a báº¡n',0),(584398,16234,'af','Hersien jou kliÃ«nt stelling',0),(584399,16234,'ro','DeclaraÅ£ia dumneavoastrÄƒ de client de revizuire',0),(584400,16234,'et','Kliendi avaldust',0),(584401,16234,'si','Preglejte vaÅ¡o izjavo kupca',0),(584402,16234,'ba','Meninjau laporan pelanggan Anda',0),(584403,16234,'nl','Uw klant-instructie bekijken',0),(584404,16234,'fi','Asiakas-lauseen tarkistaminen',0),(584405,16234,'no','Vurdere din kundeutdrag',0),(584406,16234,'da','Anmeld dine kontoudtog',0),(584407,16234,'ko','ê³ ê° ë¬¸ì˜ ê²€í† ',0),(584408,16234,'he','×¡×§×•×¨ ××ª ×”×”×¦×”×¨×” ×”×œ×§×•×— ×©×œ×š',0),(584409,16234,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€ÎµÎ»Î¬Ï„Î·',0),(584410,16234,'zh','å®¡æŸ¥ä½ å®¢æˆ·å¯¹å¸å•',0),(584411,16234,'sv','Granska din kundutdrag',0),(584412,16234,'it','Scrivi una recensione su estratto conto cliente',0),(584413,16234,'tl','',0),(584414,16234,'th','à¸Šà¸µà¹‰à¹à¸ˆà¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(584415,16234,'hi','à¤†à¤ªà¤•à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤µà¤¿à¤µà¤°à¤£ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¥‡à¤‚',0),(584416,16234,'ms','Mengkaji semula penyata pelanggan anda',0),(584417,16234,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ø¨ÙŠØ§Ù† Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(584418,16234,'fr','Consulter votre relevÃ© client',0),(584419,16234,'jp','ã‚ãªãŸã®é¡§å®¢ã®ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(584420,16234,'pt','Revisar sua declaraÃ§Ã£o de cliente',0),(584421,16234,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÐµ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(584422,16234,'es','Revisar su estado de cuenta de cliente',0),(584423,16234,'de','ÃœberprÃ¼fen Sie Ihre Kunden',0),(584424,16234,'en','Review Your Customer Statement',0),(584425,16235,'is','',0),(584426,16235,'dr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…Ø´ØªØ±ÛŒ',0),(584427,16235,'pr','Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…Ø´ØªØ±ÛŒ',0),(584428,16235,'tr','MÃ¼ÅŸteri ekstresi',0),(584429,16235,'pl','OÅ›wiadczenie klienta',0),(584430,16235,'bg','Ð˜Ð·Ð²Ð»ÐµÑ‡ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(584431,16235,'ur','Ú¯Ø§ÛÚ© Ú©Ø§ Ø¨ÛŒØ§Ù†',0),(584432,16235,'sr','ÐŸÑ€Ð¾Ð¼ÐµÑ‚ ÐºÑƒÐ¿Ñ†Ð°',0),(584433,16235,'vi','BÃ¡o cÃ¡o khÃ¡ch hÃ ng',0),(584434,16235,'af','KliÃ«nt stelling',0),(584435,16235,'ro','Declaratie client',0),(584436,16235,'et','Kliendi vÃ¤ljavÃµte',0),(584437,16235,'si','Izjava kupca',0),(584438,16235,'ba','Pernyataan pelanggan',0),(584439,16235,'nl','Verklaring van de klant',0),(584440,16235,'fi','Asiakkaan tiliote',0),(584441,16235,'no','Kundeutdrag',0),(584442,16235,'da','Kontoudtog',0),(584443,16235,'ko','ê³ ê° ì„±ëª…',0),(584444,16235,'he','×”×¦×”×¨×ª ×”×œ×§×•×—',0),(584445,16235,'el','Î”Î®Î»Ï‰ÏƒÎ· Ï€ÎµÎ»Î¬Ï„Î·',0),(584446,16235,'zh','å®¢æˆ·å¯¹å¸å•',0),(584447,16235,'sv','Kundutdrag',0),(584448,16235,'it','Testimonianza del cliente',0),(584449,16235,'tl','',0),(584450,16235,'th','à¸„à¸³à¸ªà¸±à¹ˆà¸‡à¸‚à¸­à¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(584451,16235,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤µà¤¿à¤µà¤°à¤£',0),(584452,16235,'ms','Baca kenyataan',0),(584453,16235,'ar','ÙƒØ´Ù Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(584454,16235,'fr','DÃ©claration du client',0),(584455,16235,'jp','é¡§å®¢æ˜Žç´°æ›¸',0),(584456,16235,'pt','DeclaraÃ§Ã£o do cliente',0),(584457,16235,'ru','Ð—Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(584458,16235,'es','DeclaraciÃ³n del cliente',0),(584459,16235,'de','Kunden-Statement',0),(584460,16235,'en','Customer Statement',0),(584461,16236,'is','',0),(584462,16236,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…Ø´ØªØ±ÛŒ',0),(584463,16236,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…Ø´ØªØ±ÛŒ',0),(584464,16236,'tr','MÃ¼ÅŸteri ifadesini gÃ¶zden geÃ§irme',0),(584465,16236,'pl','W oÅ›wiadczeniu klienta',0),(584466,16236,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ð¹Ñ‚Ðµ Ð²Ð°ÑˆÐ¸Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(584467,16236,'ur','Ø¢Ù¾ Ú©Û’ Ú¯Ø§ÛÚ© Ø¨ÛŒØ§Ù† Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(584468,16236,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð¸Ð·Ñ˜Ð°Ð²Ñƒ ÐºÑƒÐ¿Ñ†Ð°',0),(584469,16236,'vi','Xem xÃ©t bÃ¡o cÃ¡o khÃ¡ch hÃ ng cá»§a báº¡n',0),(584470,16236,'af','Hersien jou kliÃ«nt stelling',0),(584471,16236,'ro','DeclaraÅ£ia dumneavoastrÄƒ de client de revizuire',0),(584472,16236,'et','Kliendi avaldust',0),(584473,16236,'si','Preglejte vaÅ¡o izjavo kupca',0),(584474,16236,'ba','Meninjau laporan pelanggan Anda',0),(584475,16236,'nl','Uw klant-instructie bekijken',0),(584476,16236,'fi','Asiakas-lauseen tarkistaminen',0),(584477,16236,'no','Vurdere din kundeutdrag',0),(584478,16236,'da','Anmeld dine kontoudtog',0),(584479,16236,'ko','ê³ ê° ë¬¸ì˜ ê²€í† ',0),(584480,16236,'he','×¡×§×•×¨ ××ª ×”×”×¦×”×¨×” ×”×œ×§×•×— ×©×œ×š',0),(584481,16236,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€ÎµÎ»Î¬Ï„Î·',0),(584482,16236,'zh','å®¡æŸ¥ä½ å®¢æˆ·å¯¹å¸å•',0),(584483,16236,'sv','Granska din kundutdrag',0),(584484,16236,'it','Scrivi una recensione su estratto conto cliente',0),(584485,16236,'tl','',0),(584486,16236,'th','à¸Šà¸µà¹‰à¹à¸ˆà¸‡à¸¥à¸¹à¸à¸„à¹‰à¸²à¸‚à¸­à¸‡à¸„à¸¸à¸“',0),(584487,16236,'hi','à¤†à¤ªà¤•à¥‡ à¤—à¥à¤°à¤¾à¤¹à¤• à¤µà¤¿à¤µà¤°à¤£ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¥‡à¤‚',0),(584488,16236,'ms','Mengkaji semula penyata pelanggan anda',0),(584489,16236,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ø¨ÙŠØ§Ù† Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ',0),(584490,16236,'fr','Consulter votre relevÃ© client',0),(584491,16236,'jp','ã‚ãªãŸã®é¡§å®¢ã®ã‚¹ãƒ†ãƒ¼ãƒˆãƒ¡ãƒ³ãƒˆã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(584492,16236,'pt','Revisar sua declaraÃ§Ã£o de cliente',0),(584493,16236,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð¸Ñ‚Ðµ Ð²Ð°ÑˆÐµ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(584494,16236,'es','Revisar su estado de cuenta de cliente',0),(584495,16236,'de','ÃœberprÃ¼fen Sie Ihre Kunden',0),(584496,16236,'en','Review Your Customer Statement',0),(584497,16237,'is','',0),(584498,16237,'dr','Ù¾Ø³Øª',0),(584499,16237,'pr','Ù¾Ø³Øª',0),(584500,16237,'tr','Posta',0),(584501,16237,'pl','Poczta',0),(584502,16237,'bg','ÐŸÐ¾Ñ‰Ð°',0),(584503,16237,'ur','Ù…ÛŒÙ„',0),(584504,16237,'sr','ÐŸÐ¾ÑˆÑ‚Ð°',0),(584505,16237,'vi','ThÆ°',0),(584506,16237,'af','E-pos',0),(584507,16237,'ro','Mail',0),(584508,16237,'et','E-post',0),(584509,16237,'si','PoÅ¡ta',0),(584510,16237,'ba','Mail',0),(584511,16237,'nl','Mail',0),(584512,16237,'fi','Mail',0),(584513,16237,'no','E-post',0),(584514,16237,'da','Mail',0),(584515,16237,'ko','ë©”ì¼',0),(584516,16237,'he','×“×•××¨',0),(584517,16237,'el','Î¤Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿',0),(584518,16237,'zh','é‚®ä»¶',0),(584519,16237,'sv','E-post',0),(584520,16237,'it','Posta',0),(584521,16237,'tl','',0),(584522,16237,'th','à¸ˆà¸”à¸«à¸¡à¸²à¸¢',0),(584523,16237,'hi','à¤®à¥‡à¤²',0),(584524,16237,'ms','Mel',0),(584525,16237,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯',0),(584526,16237,'fr','Courrier',0),(584527,16237,'jp','ãƒ¡ãƒ¼ãƒ«',0),(584528,16237,'pt','Correio',0),(584529,16237,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð°',0),(584530,16237,'es','Correo',0),(584531,16237,'de','E-Mail',0),(584532,16237,'en','Mail',0),(584533,16238,'is','',0),(584534,16238,'dr','Ø±ÙˆØ´ Ø§Ø·Ù„Ø§Ø¹ Ø±Ø³Ø§Ù†ÛŒ ÙØ§Ú©ØªÙˆØ± Ù…ÙˆØ±Ø¯ Ù†Ø¸Ø±',0),(584535,16238,'pr','Ø±ÙˆØ´ Ø§Ø·Ù„Ø§Ø¹ Ø±Ø³Ø§Ù†ÛŒ ÙØ§Ú©ØªÙˆØ± Ù…ÙˆØ±Ø¯ Ù†Ø¸Ø±',0),(584536,16238,'tr','Tercih edilen fatura bildirim yÃ¶ntem',0),(584537,16238,'pl','Metoda powiadomienie preferowany faktury',0),(584538,16238,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ Ð¼ÐµÑ‚Ð¾Ð´ Ð·Ð° ÑƒÐ²ÐµÐ´Ð¾Ð¼ÑÐ²Ð°Ð½Ðµ',0),(584539,16238,'ur','ØªØ±Ø¬ÛŒØ­ÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹ Ø·Ø±ÛŒÙ‚Û',0),(584540,16238,'sr','ÐŸÑ€ÐµÑ„ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµ Ð¼ÐµÑ‚Ð¾Ð´',0),(584541,16238,'vi','PhÆ°Æ¡ng phÃ¡p thÃ´ng bÃ¡o hÃ³a Ä‘Æ¡n Æ°a thÃ­ch',0),(584542,16238,'af','Faktuur voorkeur metode van kennisgewing',0),(584543,16238,'ro','Metoda de notificare facturi preferat',0),(584544,16238,'et','Eelistatud arve teadete edastamise viis',0),(584545,16238,'si','Raje raÄuna obvestila metoda',0),(584546,16238,'ba','Faktur pilihan pemberitahuan metode',0),(584547,16238,'nl','Voorkeur factuur kennisgeving methode',0),(584548,16238,'fi','Ensisijainen laskun ilmoitus menetelmÃ¤',0),(584549,16238,'no','Foretrukket faktura varsel metode',0),(584550,16238,'da','Foretrukken faktura anmeldelse metode',0),(584551,16238,'ko','ê¸°ë³¸ ì†¡ìž¥ ì•Œë¦¼ ë©”ì„œë“œ',0),(584552,16238,'he','×©×™×˜×ª ×“×™×•×•×— ×—×©×‘×•× ×™×ª ×ž×•×¢×“×£',0),(584553,16238,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î¼Î­Î¸Î¿Î´Î¿ ÎºÎ¿Î¹Î½Î¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚',0),(584554,16238,'zh','é¦–é€‰çš„å‘ç¥¨é€šçŸ¥æ–¹æ³•',0),(584555,16238,'sv','Rekommenderad faktura anmÃ¤lan metod',0),(584556,16238,'it','Metodo di notifica preferito fattura',0),(584557,16238,'tl','',0),(584558,16238,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸•à¹‰à¸­à¸‡à¸à¸²à¸£',0),(584559,16238,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾ à¤µà¤¿à¤§à¤¿',0),(584560,16238,'ms','Kaedah pemberitahuan pilihan invois',0),(584561,16238,'ar','Ø£Ø³Ù„ÙˆØ¨ Ø§Ù„Ø¥Ø¹Ù„Ø§Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…ÙØ¶Ù„',0),(584562,16238,'fr','MÃ©thode de Notification de facture prÃ©fÃ©rÃ©',0),(584563,16238,'jp','æœ€å¯„ã‚Šã®è«‹æ±‚é€šçŸ¥æ–¹æ³•',0),(584564,16238,'pt','MÃ©todo de notificaÃ§Ã£o de factura preferencial',0),(584565,16238,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ñ‚Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ Ð¼ÐµÑ‚Ð¾Ð´ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(584566,16238,'es','MÃ©todo de notificaciÃ³n de factura recomendado:',0),(584567,16238,'de','Bevorzugte Rechnung Benachrichtigungsmethode',0),(584568,16238,'en','Preferred Invoice Notification Method',0),(584569,16239,'is','',0),(584570,16239,'dr','Ú©Ø´ÛŒØ¯Ù†',0),(584571,16239,'pr','Ú©Ø´ÛŒØ¯Ù†',0),(584572,16239,'tr','Ã‡ekme',0),(584573,16239,'pl','PociÄ…gnÄ…Ä‡',0),(584574,16239,'bg','Ð”Ñ€ÑŠÐ¿Ð½ÐµÑ‚Ðµ',0),(584575,16239,'ur','Ú©Ø´Ø´',0),(584576,16239,'sr','ÐŸÐ¾Ð²ÑƒÑ†Ð¸',0),(584577,16239,'vi','KÃ©o',0),(584578,16239,'af','Trek',0),(584579,16239,'ro','Trage',0),(584580,16239,'et','TÃµmmake',0),(584581,16239,'si','Potegnite',0),(584582,16239,'ba','Menarik',0),(584583,16239,'nl','Trek',0),(584584,16239,'fi','VedÃ¤',0),(584585,16239,'no','Trekk',0),(584586,16239,'da','TrÃ¦kke',0),(584587,16239,'ko','í’€',0),(584588,16239,'he','×ž×©×•×š',0),(584589,16239,'el','Î¤ÏÎ±Î²Î®Î¾Ï„Îµ',0),(584590,16239,'zh','æ‹‰',0),(584591,16239,'sv','Dra',0),(584592,16239,'it','Tirare',0),(584593,16239,'tl','',0),(584594,16239,'th','à¸”à¸¶à¸‡',0),(584595,16239,'hi','à¤ªà¥à¤²',0),(584596,16239,'ms','Tarik',0),(584597,16239,'ar','Ø³Ø­Ø¨',0),(584598,16239,'fr','Tirez',0),(584599,16239,'jp','ãƒ—ãƒ«',0),(584600,16239,'pt','Puxe',0),(584601,16239,'ru','Ð¢ÑÐ³Ð°',0),(584602,16239,'es','Tire de',0),(584603,16239,'de','Ziehen Sie',0),(584604,16239,'en','Pull',0),(584605,16240,'is','',0),(584606,16240,'dr','Ø±ÙˆØ´ Ù…ÙˆØ±Ø¯ Ù†Ø¸Ø± Ø§Ø·Ù„Ø§Ø¹ Ø±Ø³Ø§Ù†ÛŒ',0),(584607,16240,'pr','Ø±ÙˆØ´ Ù…ÙˆØ±Ø¯ Ù†Ø¸Ø± Ø§Ø·Ù„Ø§Ø¹ Ø±Ø³Ø§Ù†ÛŒ',0),(584608,16240,'tr','Tercih bildirim yÃ¶ntem',0),(584609,16240,'pl','Preferowane metody',0),(584610,16240,'bg','ÐœÐµÑ‚Ð¾Ð´ Ð·Ð° Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ ÑƒÐ²ÐµÐ´Ð¾Ð¼ÑÐ²Ð°Ð½Ðµ',0),(584611,16240,'ur','ØªØ±Ø¬ÛŒØ­ÛŒ Ø§Ø·Ù„Ø§Ø¹ Ø·Ø±ÛŒÙ‚Û',0),(584612,16240,'sr','ÐŸÑ€ÐµÑ„ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµ Ð¼ÐµÑ‚Ð¾Ð´',0),(584613,16240,'vi','PhÆ°Æ¡ng phÃ¡p Æ°a thÃ­ch thÃ´ng bÃ¡o',0),(584614,16240,'af','Voorkeur kennisgewing metode',0),(584615,16240,'ro','Metoda preferatÄƒ de notificare',0),(584616,16240,'et','Eelistatud teadete edastamise viis',0),(584617,16240,'si','Raje obvestila metoda',0),(584618,16240,'ba','Pilihan pemberitahuan metode',0),(584619,16240,'nl','Voorkeur kennisgeving methode',0),(584620,16240,'fi','Ensisijainen ilmoituksen menetelmÃ¤',0),(584621,16240,'no','Foretrukket tillkjennegiving',0),(584622,16240,'da','Foretrukne anmeldelse metode',0),(584623,16240,'ko','ê¸°ë³¸ ì•Œë¦¼ ë°©ë²•',0),(584624,16240,'he','×©×™×˜×ª ×“×™×•×•×— ×ž×•×¢×“×£',0),(584625,16240,'el','Î— Î¼Î­Î¸Î¿Î´Î¿Ï‚ Ï€ÏÎ¿Ï„Î¹Î¼Î¬Ï„Î±Î¹ ÎµÎ¹Î´Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ‰Î½',0),(584626,16240,'zh','é¦–é€‰çš„é€šçŸ¥æ–¹æ³•',0),(584627,16240,'sv','Rekommenderad anmÃ¤lan metod',0),(584628,16240,'it','Metodo di notifica preferito',0),(584629,16240,'tl','',0),(584630,16240,'th','à¸§à¸´à¸˜à¸µà¸•à¹‰à¸­à¸‡à¹à¸ˆà¹‰à¸‡',0),(584631,16240,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤…à¤§à¤¿à¤¸à¥‚à¤šà¤¨à¤¾ à¤µà¤¿à¤§à¤¿',0),(584632,16240,'ms','Kaedah pemberitahuan pilihan',0),(584633,16240,'ar','Ø£Ø³Ù„ÙˆØ¨ Ø§Ù„Ø¥Ø¹Ù„Ø§Ù… Ø§Ù„Ù…ÙØ¶Ù„',0),(584634,16240,'fr','MÃ©thode de Notification prÃ©fÃ©rÃ©',0),(584635,16240,'jp','æœ€å¯„ã‚Šã®é€šçŸ¥æ–¹æ³•',0),(584636,16240,'pt','MÃ©todo preferencial de notificaÃ§Ã£o',0),(584637,16240,'ru','ÐœÐµÑ‚Ð¾Ð´ Ð¿Ñ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°ÐµÐ¼Ñ‹Ð¹ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(584638,16240,'es','MÃ©todo recomendado: notificaciÃ³n',0),(584639,16240,'de','Bevorzugte Benachrichtigungsmethode',0),(584640,16240,'en','Preferred Notification Method',0),(584641,16241,'is','',0),(584642,16241,'dr','Ø§Ø±Ø³Ø§Ù„',0),(584643,16241,'pr','Ø§Ø±Ø³Ø§Ù„',0),(584644,16241,'tr','Bildirimi gÃ¶nderin',0),(584645,16241,'pl','WyÅ›lij powiadomienia',0),(584646,16241,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(584647,16241,'ur','Ù†ÙˆÙ¹Ø³ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(584648,16241,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐµ',0),(584649,16241,'vi','Gá»­i thÃ´ng bÃ¡o',0),(584650,16241,'af','KENNISGEWING stuur',0),(584651,16241,'ro','Trimite notificare',0),(584652,16241,'et','Saada teade',0),(584653,16241,'si','PoÅ¡lji obvestilo',0),(584654,16241,'ba','Mengirim pemberitahuan',0),(584655,16241,'nl','Stuur bericht',0),(584656,16241,'fi','LÃ¤hettÃ¤Ã¤ ilmoituksen',0),(584657,16241,'no','Send varsel',0),(584658,16241,'da','Send meddelelse',0),(584659,16241,'ko','í†µì§€ë¥¼ ë³´ë‚´ê¸°',0),(584660,16241,'he','×©×œ×— ×”×•×“×¢×”',0),(584661,16241,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÎ¹Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·Ï‚',0),(584662,16241,'zh','å‘é€é€šçŸ¥',0),(584663,16241,'sv','Skicka meddelande',0),(584664,16241,'it','Invia avviso',0),(584665,16241,'tl','',0),(584666,16241,'th','à¸ªà¹ˆà¸‡à¸«à¸™à¸±à¸‡à¸ªà¸·à¸­à¹à¸ˆà¹‰à¸‡',0),(584667,16241,'hi','à¤¸à¥‚à¤šà¤¨à¤¾ à¤­à¥‡à¤œà¥‡à¤‚',0),(584668,16241,'ms','Menghantar notis',0),(584669,16241,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¥Ø´Ø¹Ø§Ø±',0),(584670,16241,'fr','Envoyer des avis',0),(584671,16241,'jp','é€šçŸ¥ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(584672,16241,'pt','Enviar aviso de',0),(584673,16241,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ðµ',0),(584674,16241,'es','Enviar aviso',0),(584675,16241,'de','Mitteilung senden',0),(584676,16241,'en','Send Notice',0),(584677,16242,'is','',0),(584678,16242,'dr','ÙØ§Ú©ØªÙˆØ± Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø§Ø±Ø³Ø§Ù„ Ú©Ù†ÛŒØ¯',0),(584679,16242,'pr','ÙØ§Ú©ØªÙˆØ± Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø§Ø±Ø³Ø§Ù„ Ú©Ù†ÛŒØ¯',0),(584680,16242,'tr','Fatura olarak iÅŸaretlenmiÅŸ olarak gÃ¶ndermeyin',0),(584681,16242,'pl','Faktura jest oznaczony jako nie wysyÅ‚aj',0),(584682,16242,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ðµ Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½ ÐºÐ°Ñ‚Ð¾ Ð½Ðµ Ð¸Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð¹',0),(584683,16242,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ø´Ø§Ù† Ù„Ú¯Ø§ Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’ Ú©Ùˆ Ù†Û Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(584684,16242,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½ ÐºÐ°Ð¾ Ð½Ðµ ÑˆÐ°Ñ™Ð¸',0),(584685,16242,'vi','HÃ³a Ä‘Æ¡n Ä‘Æ°á»£c Ä‘Ã¡nh dáº¥u nhÆ° khÃ´ng gá»­i',0),(584686,16242,'af','Faktuur Is gemerk As stuur nie',0),(584687,16242,'ro','Factura este marcatÄƒ ca nu trimite',0),(584688,16242,'et','Arve on mÃ¤rgitud nagu saatmata',0),(584689,16242,'si','RaÄun je oznaÄen kot ne PoÅ¡lji',0),(584690,16242,'ba','Faktur ditandai sebagai Jangan mengirim',0),(584691,16242,'nl','Factuur Is gemarkeerd als Stuur geen',0),(584692,16242,'fi','Laskua merkitty koska Ã„lÃ¤ lÃ¤hetÃ¤',0),(584693,16242,'no','Fakturaen er merket som ikke Send',0),(584694,16242,'da','Faktura er markeret som sender ikke',0),(584695,16242,'ko','ì†¡ìž¥ í‘œì‹œë¡œ ë³´ë‚´ì§€ ë§ˆì‹­ì‹œì˜¤',0),(584696,16242,'he','×—×©×‘×•× ×™×ª ×ž×¡×•×ž×Ÿ ×›×ž×• ××œ ×ª×©×œ×—',0),(584697,16242,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î­Ï‡ÎµÎ¹ ÎµÏ€Î¹ÏƒÎ·Î¼Î±Î½Î¸ÎµÎ¯ Ï‰Ï‚ Î´ÎµÎ½ Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Ï…Î½',0),(584698,16242,'zh','å‘ç¥¨æ ‡è®°ä¸ºä¸å‘é€',0),(584699,16242,'sv','Faktura Ã¤r markerad som inte skickar',0),(584700,16242,'it','Fattura Ã¨ contrassegnato come non inviare',0),(584701,16242,'tl','',0),(584702,16242,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸–à¸¹à¸à¸—à¸³à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸›à¹‡à¸™à¹„à¸¡à¹ˆà¸ªà¹ˆà¸‡',0),(584703,16242,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤ à¤¹à¥ˆ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤­à¥‡à¤œà¥‡à¤‚',0),(584704,16242,'ms','Invois ditandakan seperti Jangan hantar',0),(584705,16242,'ar','ÙŠØªÙ… ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© Ø¹Ù„Ù‰ Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙƒÙ…Ø§ Ù„Ø§ ØªÙ‚Ù… Ø¨Ø¥Ø±Ø³Ø§Ù„',0),(584706,16242,'fr','Facture est marquÃ©e comme ne pas envoyer',0),(584707,16242,'jp','è«‹æ±‚æ›¸ã‚’ãƒžãƒ¼ã‚¯ã¨ã—ã¦ã¯é€ä¿¡ã—ãªã„ã§ãã ã•ã„',0),(584708,16242,'pt','Fatura Ã© marcada como nÃ£o enviar',0),(584709,16242,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ð¾Ð¼ÐµÑ‡ÐµÐ½ ÐºÐ°Ðº Ð½Ðµ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ',0),(584710,16242,'es','Factura estÃ¡ marcada como no enviar',0),(584711,16242,'de','Rechnung ist gekennzeichnet als nicht senden',0),(584712,16242,'en','Invoice Is Marked As Do Not Send',0),(584713,16243,'is','',0),(584714,16243,'dr','ÙØ§Ú©ØªÙˆØ± Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ú©Ø´ÛŒØ¯Ù†',0),(584715,16243,'pr','ÙØ§Ú©ØªÙˆØ± Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø§Ø³Øª Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ú©Ø´ÛŒØ¯Ù†',0),(584716,16243,'tr','Fatura Ã§ekme iÅŸaretlenir',0),(584717,16243,'pl','Faktura jest oznaczony jako Pull',0),(584718,16243,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ðµ Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½ ÐºÐ°Ñ‚Ð¾ Ð´Ñ€ÑŠÐ¿Ð½ÐµÑ‚Ðµ',0),(584719,16243,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ù¾Ù„ Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†Ø´Ø§Ù† Ø²Ø¯ Ú©ÛŒØ§ ÛÛ’',0),(584720,16243,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½ ÐºÐ°Ð¾ Ð²ÑƒÑ†Ð¸',0),(584721,16243,'vi','HÃ³a Ä‘Æ¡n Ä‘Æ°á»£c Ä‘Ã¡nh dáº¥u lÃ  kÃ©o',0),(584722,16243,'af','Faktuur Is gemerk As trek',0),(584723,16243,'ro','Factura este marcat ca trage',0),(584724,16243,'et','Arve on mÃ¤rgitud Pull',0),(584725,16243,'si','RaÄun je oznaÄen kot Pull',0),(584726,16243,'ba','Faktur ditandai sebagai menarik',0),(584727,16243,'nl','Factuur Is gemarkeerd als Pull',0),(584728,16243,'fi','Lasku on merkitty vetÃ¤Ã¤',0),(584729,16243,'no','Fakturaen er merket som trekk',0),(584730,16243,'da','Faktura er markeret som Pull',0),(584731,16243,'ko','ì†¡ìž¥ í’€ìœ¼ë¡œ í‘œì‹œ',0),(584732,16243,'he','×”×—×©×‘×•× ×™×ª ×©×”×•× ×ž×¡×•×ž×Ÿ ×œ×ž×©×•×š',0),(584733,16243,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï‡Î±ÏÎ±ÎºÏ„Î·ÏÎ¯Î¶ÎµÏ„Î±Î¹ Ï‰Ï‚ Î­Î»Î¾Î·',0),(584734,16243,'zh','å‘ç¥¨è¢«æ ‡è®°ä¸ºæ‹‰',0),(584735,16243,'sv','Faktura Ã¤r markerad som Pull',0),(584736,16243,'it','Fattura Ã¨ contrassegnato come Pull',0),(584737,16243,'tl','',0),(584738,16243,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸–à¸¹à¸à¸—à¸³à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸›à¹‡à¸™à¸”à¸¶à¸‡',0),(584739,16243,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤–à¥€à¤‚à¤šà¤¨à¥‡ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(584740,16243,'ms','Invois ditanda sebagai tarik',0),(584741,16243,'ar','Ø§Ù„ÙØ§ØªÙˆØ±Ø© Ø§Ù„ØªÙŠ ØªÙ… ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© ÙƒØ§Ù„Ø³Ø­Ø¨',0),(584742,16243,'fr','Facture est marquÃ©e comme Pull',0),(584743,16243,'jp','è«‹æ±‚æ›¸ã¯ã€ãƒ—ãƒ«ã¨ã—ã¦ãƒžãƒ¼ã‚¯ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(584744,16243,'pt','Fatura Ã© marcada como Pull',0),(584745,16243,'ru','Ð¡Ñ‡ÐµÑ‚-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ð¾Ð¼ÐµÑ‡ÐµÐ½ ÐºÐ°Ðº Ñ‚ÑÐ½ÑƒÑ‚ÑŒ',0),(584746,16243,'es','Factura estÃ¡ marcada como tirÃ³n',0),(584747,16243,'de','Rechnung wird als Pull gekennzeichnet.',0),(584748,16243,'en','Invoice Is Marked As Pull',0),(584749,16244,'is','',0),(584750,16244,'dr','Ø§Ø±Ø³Ø§Ù„ Ø§Ø¹Ù„Ø§Ù…ÛŒÙ‡',0),(584751,16244,'pr','Ø§Ø±Ø³Ø§Ù„ Ø§Ø¹Ù„Ø§Ù…ÛŒÙ‡',0),(584752,16244,'tr','UyarÄ± gÃ¶nderme',0),(584753,16244,'pl','WyÅ›lij powiadomienia',0),(584754,16244,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ',0),(584755,16244,'ur','Ù†ÙˆÙ¹Ø³ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(584756,16244,'sr','Ð¡Ð»Ð°ÑšÐµ Ð¾Ð±Ð°Ð²ÐµÑˆÑ‚ÐµÑšÐ°',0),(584757,16244,'vi','Gá»­i thÃ´ng bÃ¡o',0),(584758,16244,'af','Stuur kennisgewings',0),(584759,16244,'ro','Trimite notificarile',0),(584760,16244,'et','Saada teated',0),(584761,16244,'si','PoÅ¡lji obvestila',0),(584762,16244,'ba','Mengirim pemberitahuan',0),(584763,16244,'nl','Meldingen verzenden',0),(584764,16244,'fi','LÃ¤hetÃ¤ ilmoituksia',0),(584765,16244,'no','Send varsler',0),(584766,16244,'da','Send meddelelser',0),(584767,16244,'ko','í†µì§€ë¥¼ ë³´ë‚¼',0),(584768,16244,'he','×œ×©×œ×•×— ×”×•×“×¢×•×ª',0),(584769,16244,'el','ÎÎ± Î±Ï€Î¿ÏƒÏ„Î­Î»Î»ÎµÎ¹ ÎµÎ¹Î´Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚',0),(584770,16244,'zh','å‘é€é€šçŸ¥',0),(584771,16244,'sv','Skicka meddelanden',0),(584772,16244,'it','Inviare avvisi',0),(584773,16244,'tl','',0),(584774,16244,'th','à¸ªà¹ˆà¸‡à¸„à¸³à¸šà¸­à¸à¸à¸¥à¹ˆà¸²à¸§',0),(584775,16244,'hi','à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤ à¤­à¥‡à¤œà¥‡à¤‚',0),(584776,16244,'ms','Menghantar notis',0),(584777,16244,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¥Ø´Ø¹Ø§Ø±Ø§Øª',0),(584778,16244,'fr','Envoyer des notifications',0),(584779,16244,'jp','é€šçŸ¥ã‚’é€ã‚‹',0),(584780,16244,'pt','Enviar avisos',0),(584781,16244,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð»ÑÑ‚ÑŒ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ',0),(584782,16244,'es','Enviar avisos',0),(584783,16244,'de','Senden von Mitteilungen',0),(584784,16244,'en','Send Notices',0),(584785,16245,'is','',0),(584786,16245,'dr','Ø§ÙØ²ÙˆÙ†Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(584787,16245,'pr','Ø§ÙØ²ÙˆÙ†Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(584788,16245,'tr','Gerekli Addon',0),(584789,16245,'pl','Addon wymagane',0),(584790,16245,'bg','Addon Ð·Ð°Ð´ÑŠÐ»Ð¶Ð¸Ñ‚ÐµÐ»Ð½Ð¾',0),(584791,16245,'ur','Ø¶Ø±ÙˆØ±Øª Ø¯Ùˆ Ø¨Ø§Ø²Ú¯Ø´Øª Ø§Ù…Ø¯Ø§Ø¯ÛŒÛ',0),(584792,16245,'sr','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð°Ð½ Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ð¸',0),(584793,16245,'vi','ChÆ°Æ¡ng trÃ¬nh bá»• trá»£ yÃªu cáº§u',0),(584794,16245,'af','Byvoegend vereis',0),(584795,16245,'ro','Addon necesar',0),(584796,16245,'et','AddOn NÃµutav',0),(584797,16245,'si','Addon, ki zahteva',0),(584798,16245,'ba','Addon yang diperlukan',0),(584799,16245,'nl','Addon vereist',0),(584800,16245,'fi','Addon tarvittava',0),(584801,16245,'no','Addon nÃ¸dvendig',0),(584802,16245,'da','Addon nÃ¸dvendig',0),(584803,16245,'ko','Addon í•„ìš”',0),(584804,16245,'he','Addon × ×“×¨×©',0),(584805,16245,'el','Addon Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹',0),(584806,16245,'zh','æ‰€éœ€çš„æ’ä»¶',0),(584807,16245,'sv','Addon krÃ¤vs',0),(584808,16245,'it','Addon richiesto',0),(584809,16245,'tl','',0),(584810,16245,'th','Addon à¸ˆà¸³à¹€à¸›à¹‡à¸™',0),(584811,16245,'hi','Addon à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(584812,16245,'ms','Addon diperlukan',0),(584813,16245,'ar','Ø§Ù„Ù…Ù„Ø­Ù‚ Ø§Ù„Ù…Ø·Ù„ÙˆØ¨',0),(584814,16245,'fr','Addon requis',0),(584815,16245,'jp','å¿…è¦ãªã‚¢ãƒ‰ã‚ªãƒ³',0),(584816,16245,'pt','Addon Obrigado',0),(584817,16245,'ru','ÐÐ´Ð´Ð¾Ð½ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ',0),(584818,16245,'es','Addon requerido',0),(584819,16245,'de','Addon benÃ¶tigt',0),(584820,16245,'en','Add-On Required',0),(584821,16246,'is','',0),(584822,16246,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú†Ù†Ø¯ Ù…Ø´ØªØ±ÛŒ B2b Ú©Ø§Ø±Ø¨Ø±',0),(584823,16246,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú†Ù†Ø¯ Ù…Ø´ØªØ±ÛŒ B2b Ú©Ø§Ø±Ø¨Ø±',0),(584824,16246,'tr','Birden Ã§ok mÃ¼ÅŸteri B2b kullanÄ±cÄ± eklemek',0),(584825,16246,'pl','Dodawanie wielu uÅ¼ytkownikÃ³w klienta B2b',0),(584826,16246,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½ÑÐºÐ¾Ð»ÐºÐ¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° B2b Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(584827,16246,'ur','Ø§ÛŒÚ© Ø³Û’ Ø²ÛŒØ§Ø¯Û Ú¯Ø§ÛÚ© B2b ØµØ§Ø±ÙÛŒÙ† Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(584828,16246,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ð¸ÑˆÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð‘2Ð± ÐºÑƒÐ¿Ñ†Ð°',0),(584829,16246,'vi','ThÃªm nhiá»u khÃ¡ch hÃ ng B2b ngÆ°á»i dÃ¹ng',0),(584830,16246,'af','Voeg meervoudige kliÃ«nt B2b gebruikers',0),(584831,16246,'ro','AdÄƒugaÅ£i mai mulÅ£i utilizatori de client B2b',0),(584832,16246,'et','Mitme kliendi B2b kasutaja',0),(584833,16246,'si','Dodati veÄ strank B2b uporabnike',0),(584834,16246,'ba','Menambahkan beberapa pelanggan B2b pengguna',0),(584835,16246,'nl','Meerdere klanten B2b gebruikers toevoegen',0),(584836,16246,'fi','LisÃ¤tÃ¤ useita asiakkaan B2b kÃ¤yttÃ¤jiÃ¤',0),(584837,16246,'no','Legge til flere kunde B2b brukere',0),(584838,16246,'da','TilfÃ¸je flere kunde B2b brugere',0),(584839,16246,'ko','ì—¬ëŸ¬ ê³ ê° B2b ì‚¬ìš©ìž ì¶”ê°€',0),(584840,16246,'he','×œ×”×•×¡×™×£ ×ž×©×ª×ž×©×™× B2b ×œ×§×•×—×•×ª ×ž×¨×•×‘×™×',0),(584841,16246,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€Î¿Î»Î»ÏŽÎ½ Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½ Ï€ÎµÎ»Î±Ï„ÏŽÎ½ B2b',0),(584842,16246,'zh','æ·»åŠ å¤šä¸ªå®¢æˆ· B2b ç”¨æˆ·',0),(584843,16246,'sv','LÃ¤gg till flera kund B2b anvÃ¤ndare',0),(584844,16246,'it','Aggiungere piÃ¹ utenti di cliente B2b',0),(584845,16246,'tl','',0),(584846,16246,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¸¹à¸à¸„à¹‰à¸² B2b à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸«à¸¥à¸²à¸¢à¸„à¸™',0),(584847,16246,'hi','à¤à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤—à¥à¤°à¤¾à¤¹à¤• B2b à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(584848,16246,'ms','Menambah berbilang pengguna B2b Baca',0),(584849,16246,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¹Ø¯ÙŠØ¯ Ù…Ù† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† B2b Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(584850,16246,'fr','Ajouter plusieurs utilisateurs B2b de client',0),(584851,16246,'jp','è¤‡æ•°ã®ãŠå®¢æ§˜ã® B2b ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(584852,16246,'pt','Adicionar vÃ¡rios usuÃ¡rios de clientes B2b',0),(584853,16246,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¸Ñ… Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ B2b ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(584854,16246,'es','Agregar varios usuarios de clientes B2b',0),(584855,16246,'de','Mehrere Kunden B2b Benutzer hinzufÃ¼gen',0),(584856,16246,'en','Add Multiple Customer B2B Users',0),(584857,16247,'is','',0),(584858,16247,'dr','Ú©Ø§Ø±Ø¨Ø± B2b Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(584859,16247,'pr','Ú©Ø§Ø±Ø¨Ø± B2b Ù…Ø´ØªØ±ÛŒ Ø¬Ø¯ÛŒØ¯',0),(584860,16247,'tr','Yeni mÃ¼ÅŸteri B2b kullanÄ±cÄ±',0),(584861,16247,'pl','Nowego klienta B2b uÅ¼ytkownika',0),(584862,16247,'bg','ÐÐ¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚ B2b Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(584863,16247,'ur','Ù†Ø¦Û’ Ú¯Ø§ÛÚ© B2b ØµØ§Ø±Ù',0),(584864,16247,'sr','ÐÐ¾Ð²Ð¸ ÐºÑƒÐ¿Ð°Ñ† Ð‘2Ð± ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(584865,16247,'vi','KhÃ¡ch hÃ ng B2b ngÆ°á»i dÃ¹ng má»›i',0),(584866,16247,'af','Nuwe kliÃ«nt B2b gebruiker',0),(584867,16247,'ro','Utilizator nou client B2b',0),(584868,16247,'et','Uue kliendi B2b kasutaja',0),(584869,16247,'si','Novega kupca B2b uporabnika',0),(584870,16247,'ba','Pengguna baru pelanggan B2b',0),(584871,16247,'nl','Nieuwe klant B2b gebruiker',0),(584872,16247,'fi','Uusi asiakas B2b kÃ¤yttÃ¤jÃ¤',0),(584873,16247,'no','Ny kunde B2b bruker',0),(584874,16247,'da','Ny kunde B2b bruger',0),(584875,16247,'ko','ìƒˆë¡œìš´ ê³ ê° B2b ì‚¬ìš©ìž',0),(584876,16247,'he','×ž×©×ª×ž×© ×—×“×© ×©×œ B2b ×œ×§×•×—×•×ª',0),(584877,16247,'el','ÎÎ­Î¿Ï‚ Ï€ÎµÎ»Î¬Ï„Î·Ï‚ B2b Ï‡ÏÎ®ÏƒÏ„Î·Ï‚',0),(584878,16247,'zh','æ–°å®¢æˆ· B2b ç”¨æˆ·',0),(584879,16247,'sv','Ny kund B2b anvÃ¤ndare',0),(584880,16247,'it','Nuovo utente di cliente B2b',0),(584881,16247,'tl','',0),(584882,16247,'th','à¸¥à¸¹à¸à¸„à¹‰à¸² B2b à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹ƒà¸«à¸¡à¹ˆ',0),(584883,16247,'hi','à¤¨à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• B2b à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(584884,16247,'ms','Baru Baca B2b pengguna',0),(584885,16247,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… B2b Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø§Ù„Ø¬Ø¯ÙŠØ¯',0),(584886,16247,'fr','Nouveaux clients B2b utilisateurs',0),(584887,16247,'jp','æ–°ã—ã„ãŠå®¢æ§˜ã® B2b ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(584888,16247,'pt','Novo usuÃ¡rio de cliente B2b',0),(584889,16247,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ B2b ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(584890,16247,'es','Nuevo cliente B2b usuario',0),(584891,16247,'de','Neuer Kunde-B2b-Benutzer',0),(584892,16247,'en','New Customer B2B User',0),(584893,16248,'is','',0),(584894,16248,'dr','Ú©Ø§Ø±Ø¨Ø± Ø¬Ø¯ÛŒØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ B2b',0),(584895,16248,'pr','Ú©Ø§Ø±Ø¨Ø± Ø¬Ø¯ÛŒØ¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ B2b',0),(584896,16248,'tr','Yeni satÄ±cÄ± B2b kullanÄ±cÄ±',0),(584897,16248,'pl','Nowy uÅ¼ytkownik B2b dostawcÃ³w',0),(584898,16248,'bg','ÐÐ¾Ð² Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº B2b Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(584899,16248,'ur','Ù†Ø¦Û’ ÙˆÛŒÙ†ÚˆØ± B2b ØµØ§Ø±Ù',0),(584900,16248,'sr','ÐÐ¾Ð²Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ðº Ð‘2Ð± Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(584901,16248,'vi','NhÃ  cung cáº¥p B2b ngÆ°á»i dÃ¹ng má»›i',0),(584902,16248,'af','Nuwe handelaar B2b gebruiker',0),(584903,16248,'ro','Utilizator nou furnizor B2b',0),(584904,16248,'et','Uue hankija B2b kasutaja',0),(584905,16248,'si','Novega dobavitelja B2b uporabnika',0),(584906,16248,'ba','Pengguna B2b Vendor baru',0),(584907,16248,'nl','Nieuwe leverancier B2b gebruiker',0),(584908,16248,'fi','Uusi toimittajan B2b kÃ¤yttÃ¤jÃ¤',0),(584909,16248,'no','Ny leverandÃ¸r B2b bruker',0),(584910,16248,'da','Ny forhandler B2b bruger',0),(584911,16248,'ko','ìƒˆë¡œìš´ ê³µê¸‰ ì—…ì²´ B2b ì‚¬ìš©ìž',0),(584912,16248,'he','×ž×©×ª×ž×© B2b ×¡×¤×§ ×—×“×©',0),(584913,16248,'el','ÎÎ­Î¿Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚ B2b Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(584914,16248,'zh','æ–°ä¾›åº”å•† B2b ç”¨æˆ·',0),(584915,16248,'sv','Nya B2b leverantÃ¶rsanvÃ¤ndare',0),(584916,16248,'it','Nuovo utente di B2b di fornitore',0),(584917,16248,'tl','',0),(584918,16248,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰ B2b à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹ƒà¸«à¸¡à¹ˆ',0),(584919,16248,'hi','à¤¨à¤ˆ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ B2b à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(584920,16248,'ms','Pengguna B2b penjual baru',0),(584921,16248,'ar','Ø§Ù„Ù…ÙˆØ±Ø¯ B2b Ù…Ø³ØªØ®Ø¯Ù… Ø¬Ø¯ÙŠØ¯',0),(584922,16248,'fr','Nouvel utilisateur de B2b fournisseur',0),(584923,16248,'jp','æ–°ã—ã„ãƒ™ãƒ³ãƒ€ãƒ¼ã® B2b ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(584924,16248,'pt','Novo fornecedor B2b usuÃ¡rio',0),(584925,16248,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ B2b Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(584926,16248,'es','Nuevo usuario de B2b de proveedores',0),(584927,16248,'de','Neuer Anbieter B2b Benutzer',0),(584928,16248,'en','New Vendor B2B User',0),(584929,16249,'is','',0),(584930,16249,'dr','Ù¾Ø³ Ø§Ø² Ø§ÛŒØ¬Ø§Ø¯',0),(584931,16249,'pr','Ù¾Ø³ Ø§Ø² Ø§ÛŒØ¬Ø§Ø¯',0),(584932,16249,'tr','Åžu tarihten sonra oluÅŸturulan',0),(584933,16249,'pl','Utworzone po',0),(584934,16249,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° ÑÐ»ÐµÐ´',0),(584935,16249,'ur','Ú©Û’ Ø¨Ø¹Ø¯ Ù¾ÛŒØ¯Ø§',0),(584936,16249,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ð½Ðµ Ð½Ð°ÐºÐ¾Ð½',0),(584937,16249,'vi','Táº¡o sau',0),(584938,16249,'af','Geskep na',0),(584939,16249,'ro','Creat dupÄƒ',0),(584940,16249,'et','PÃ¤rast',0),(584941,16249,'si','Ustvaril po',0),(584942,16249,'ba','Dibuat setelah',0),(584943,16249,'nl','Gemaakt na',0),(584944,16249,'fi','Luotu jÃ¤lkeen',0),(584945,16249,'no','Opprettet etter',0),(584946,16249,'da','Lavet efter',0),(584947,16249,'ko','í›„ ìƒì„±',0),(584948,16249,'he','× ×•×¦×¨ ×œ××—×¨',0),(584949,16249,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎ±Î½ Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ',0),(584950,16249,'zh','åˆ›å»ºåŽ',0),(584951,16249,'sv','Skapats efter',0),(584952,16249,'it','Creato dopo',0),(584953,16249,'tl','',0),(584954,16249,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸‚à¸¶à¹‰à¸™à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸',0),(584955,16249,'hi','à¤¬à¤¾à¤¦ à¤¬à¤¨à¤¾à¤¯à¤¾',0),(584956,16249,'ms','Diwujudkan selepas',0),(584957,16249,'ar','Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨Ø¹Ø¯',0),(584958,16249,'fr','CrÃ©Ã© aprÃ¨s',0),(584959,16249,'jp','å¾Œã«ä½œæˆã•ã‚Œã¾ã—ãŸã€‚',0),(584960,16249,'pt','Criado apÃ³s a',0),(584961,16249,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½ Ð¿Ð¾ÑÐ»Ðµ',0),(584962,16249,'es','Creada despuÃ©s de',0),(584963,16249,'de','Erstellt nach',0),(584964,16249,'en','Created After',0),(584965,16250,'is','',0),(584966,16250,'dr','Ù‚Ø¨Ù„ Ø§Ø² Ø§ÛŒØ¬Ø§Ø¯ Ú©Ø±Ø¯Ù‡',0),(584967,16250,'pr','Ù‚Ø¨Ù„ Ø§Ø² Ø§ÛŒØ¬Ø§Ø¯ Ú©Ø±Ø¯Ù‡',0),(584968,16250,'tr','Daha Ã¶nce oluÅŸturulan',0),(584969,16250,'pl','Stworzony przed',0),(584970,16250,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð´ÐµÐ½ Ð¿Ñ€ÐµÐ´Ð¸',0),(584971,16250,'ur','Ø³Û’ Ù¾ÛÙ„Û’ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§',0),(584972,16250,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ð½Ðµ Ð¿Ñ€Ðµ',0),(584973,16250,'vi','Táº¡o ra trÆ°á»›c khi',0),(584974,16250,'af','Voor geskep',0),(584975,16250,'ro','Create Ã®nainte de',0),(584976,16250,'et','Enne',0),(584977,16250,'si','Nastala pred',0),(584978,16250,'ba','Dibuat sebelum',0),(584979,16250,'nl','Gemaakt voor',0),(584980,16250,'fi','Luotu ennen',0),(584981,16250,'no','Opprettet fÃ¸r',0),(584982,16250,'da','Lavet fÃ¸r',0),(584983,16250,'ko','ì´ì „ì— ë§Œë“ ',0),(584984,16250,'he','× ×•×¦×¨ ×œ×¤× ×™',0),(584985,16250,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ',0),(584986,16250,'zh','åˆ›å»ºä¹‹å‰',0),(584987,16250,'sv','Skapad innan',0),(584988,16250,'it','Creata prima',0),(584989,16250,'tl','',0),(584990,16250,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸‚à¸¶à¹‰à¸™à¸à¹ˆà¸­à¸™',0),(584991,16250,'hi','à¤ªà¤¹à¤²à¥‡ à¤¬à¤¨à¤¾à¤ à¤—à¤',0),(584992,16250,'ms','Dicipta sebelum',0),(584993,16250,'ar','Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ù‚Ø¨Ù„',0),(584994,16250,'fr','CrÃ©Ã© avant',0),(584995,16250,'jp','å‰ã«ä½œæˆã—ã¾ã—ãŸã€‚',0),(584996,16250,'pt','Criado antes',0),(584997,16250,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¾ Ð´Ð¾',0),(584998,16250,'es','Creado antes',0),(584999,16250,'de','Erstellt vor',0),(585000,16250,'en','Created Before',0),(585001,16251,'is','',0),(585002,16251,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø´ØªØ±ÛŒØ§Ù†',0),(585003,16251,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø´ØªØ±ÛŒØ§Ù†',0),(585004,16251,'tr','MÃ¼ÅŸteriler\'i seÃ§in',0),(585005,16251,'pl','Wybierz klienci',0),(585006,16251,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(585007,16251,'ur','ØµØ§Ø±ÙÛŒÙ† Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(585008,16251,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÑƒÐ¿Ñ†Ð¸',0),(585009,16251,'vi','Chá»n khÃ¡ch hÃ ng',0),(585010,16251,'af','KliÃ«nte kies',0),(585011,16251,'ro','SelectaÅ£i clienÅ£ii',0),(585012,16251,'et','Valige hotelli',0),(585013,16251,'si','Izberite stranke',0),(585014,16251,'ba','Pilih pelanggan',0),(585015,16251,'nl','Selecteer klanten',0),(585016,16251,'fi','Valitse Asiakkaat',0),(585017,16251,'no','Velge kunder',0),(585018,16251,'da','Udvalgte kunder',0),(585019,16251,'ko','ê³ ê° ì„ íƒ',0),(585020,16251,'he','×‘×—×¨ ××ª ×”×œ×§×•×—×•×ª',0),(585021,16251,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚',0),(585022,16251,'zh','é€‰æ‹©å®¢æˆ·',0),(585023,16251,'sv','VÃ¤lj kunder',0),(585024,16251,'it','Selezionare i clienti',0),(585025,16251,'tl','',0),(585026,16251,'th','à¹€à¸¥à¸·à¸­à¸à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(585027,16251,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(585028,16251,'ms','Pilih pelanggan',0),(585029,16251,'ar','Ø­Ø¯Ø¯ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(585030,16251,'fr','SÃ©lectionnez les clients',0),(585031,16251,'jp','é¡§å®¢ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(585032,16251,'pt','Selecione os clientes',0),(585033,16251,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(585034,16251,'es','Clientes selectos',0),(585035,16251,'de','Kunden (Auswahl)',0),(585036,16251,'en','Select Customers',0),(585037,16252,'is','',0),(585038,16252,'dr','Ù‡ÛŒÚ† Ú©Ø§Ø±Ø¨Ø±ÛŒ Ù…ÙˆØ¬ÙˆØ¯ B2b',0),(585039,16252,'pr','Ù‡ÛŒÚ† Ú©Ø§Ø±Ø¨Ø±ÛŒ Ù…ÙˆØ¬ÙˆØ¯ B2b',0),(585040,16252,'tr','Varolan bir B2b kullanÄ±cÄ±',0),(585041,16252,'pl','Nie ma istniejÄ…cego uÅ¼ytkownika B2b',0),(585042,16252,'bg','ÐÑÐ¼Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ð½Ð° B2b',0),(585043,16252,'ur','Ú©ÙˆØ¦ÛŒ Ù…ÙˆØ¬ÙˆØ¯Û B2b ØµØ§Ø±Ù',0),(585044,16252,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸Ñ… ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð‘2Ð±',0),(585045,16252,'vi','KhÃ´ng cÃ³ ngÆ°á»i dÃ¹ng hiá»‡n táº¡i B2b',0),(585046,16252,'af','Geen bestaande B2b-gebruiker',0),(585047,16252,'ro','Nici un utilizator existent B2b',0),(585048,16252,'et','Ãœkski olemasolev B2b kasutaja',0),(585049,16252,'si','Noben obstojeÄi uporabnik B2b',0),(585050,16252,'ba','Pengguna B2b tidak ada',0),(585051,16252,'nl','Geen bestaande B2b-gebruiker',0),(585052,16252,'fi','Ei B2b kÃ¤yttÃ¤jÃ¤n',0),(585053,16252,'no','Ingen eksisterende B2b-bruker',0),(585054,16252,'da','Ingen eksisterende B2b bruger',0),(585055,16252,'ko','ê¸°ì¡´ B2b ì‚¬ìš©ìž',0),(585056,16252,'he','××™×Ÿ ×ž×©×ª×ž×© B2b ×§×™×™×',0),(585057,16252,'el','ÎšÎ±Î¼Î¯Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Ï‡ÏÎ®ÏƒÏ„Î· B2b',0),(585058,16252,'zh','æ²¡æœ‰çŽ°æœ‰çš„ B2b ç”¨æˆ·',0),(585059,16252,'sv','Ingen befintlig B2b-anvÃ¤ndare',0),(585060,16252,'it','Nessun utente esistente di B2b',0),(585061,16252,'tl','',0),(585062,16252,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰ B2b à¹„à¸¡à¹ˆà¸­à¸¢à¸¹à¹ˆ',0),(585063,16252,'hi','à¤•à¥‹à¤ˆ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ B2b à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾',0),(585064,16252,'ms','Tiada pengguna B2b yang sedia ada',0),(585065,16252,'ar','Ù„Ø§ Ù…Ø³ØªØ®Ø¯Ù… B2b Ù…ÙˆØ¬ÙˆØ¯',0),(585066,16252,'fr','Aucun utilisateur B2b',0),(585067,16252,'jp','ãªã—æ—¢å­˜ã® B2b ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(585068,16252,'pt','Nenhum usuÃ¡rio existente do B2b',0),(585069,16252,'ru','ÐÐµÑ‚ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ B2b',0),(585070,16252,'es','NingÃºn usuario existente de B2b',0),(585071,16252,'de','Keine bestehenden B2b-User',0),(585072,16252,'en','No Existing B2B User',0),(585073,16253,'is','',0),(585074,16253,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ú©Ø§Ø±Ø¨Ø±Ø§Ù†',0),(585075,16253,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ú©Ø§Ø±Ø¨Ø±Ø§Ù†',0),(585076,16253,'tr','KullanÄ±cÄ±larÄ± oluÅŸturun',0),(585077,16253,'pl','Tworzenie uÅ¼ytkownikÃ³w',0),(585078,16253,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(585079,16253,'ur','ØµØ§Ø±ÙÛŒÙ† ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(585080,16253,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(585081,16253,'vi','Táº¡o ngÆ°á»i dÃ¹ng',0),(585082,16253,'af','Gebruikers te skep',0),(585083,16253,'ro','CreaÅ£i utilizatori',0),(585084,16253,'et','Kasutajate loomine',0),(585085,16253,'si','Ustvarite uporabnike',0),(585086,16253,'ba','Membuat pengguna',0),(585087,16253,'nl','Gebruikers maken',0),(585088,16253,'fi','KÃ¤yttÃ¤jien luominen',0),(585089,16253,'no','Opprette brukere',0),(585090,16253,'da','Opret brugere',0),(585091,16253,'ko','ì‚¬ìš©ìž ë§Œë“¤ê¸°',0),(585092,16253,'he','×¦×•×¨ ×ž×©×ª×ž×©×™×',0),(585093,16253,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(585094,16253,'zh','åˆ›å»ºç”¨æˆ·',0),(585095,16253,'sv','Skapa anvÃ¤ndare',0),(585096,16253,'it','Creare utenti',0),(585097,16253,'tl','',0),(585098,16253,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(585099,16253,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¬à¤¨à¤¾à¤à¤',0),(585100,16253,'ms','Mencipta pengguna',0),(585101,16253,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(585102,16253,'fr','CrÃ©er des utilisateurs',0),(585103,16253,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(585104,16253,'pt','Criar usuÃ¡rios',0),(585105,16253,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(585106,16253,'es','Crear usuarios',0),(585107,16253,'de','Benutzer anlegen',0),(585108,16253,'en','Create Users',0),(585109,16254,'is','',0),(585110,16254,'dr','Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø¬Ø¯ÛŒØ¯ B2b',0),(585111,16254,'pr','Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø¬Ø¯ÛŒØ¯ B2b',0),(585112,16254,'tr','Yeni B2b kullanÄ±cÄ±lar',0),(585113,16254,'pl','Nowi uÅ¼ytkownicy B2b',0),(585114,16254,'bg','ÐÐ¾Ð²Ð¸ B2b Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(585115,16254,'ur','B2b Ú©Û’ Ù†Ø¦Û’ ØµØ§Ø±ÙÛŒÙ†',0),(585116,16254,'sr','ÐÐ¾Ð²Ð¸ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸ Ð‘2Ð±',0),(585117,16254,'vi','NgÆ°á»i dÃ¹ng má»›i B2b',0),(585118,16254,'af','Nuwe B2b gebruikers',0),(585119,16254,'ro','Utilizatorii noi B2b',0),(585120,16254,'et','B2b kasutajatelt',0),(585121,16254,'si','Nov uporabnik B2b',0),(585122,16254,'ba','B2b pengguna baru',0),(585123,16254,'nl','Nieuwe B2b-gebruikers',0),(585124,16254,'fi','Uudet B2b kÃ¤yttÃ¤jÃ¤t',0),(585125,16254,'no','Nye B2b-brukere',0),(585126,16254,'da','Nye B2b brugere',0),(585127,16254,'ko','ìƒˆë¡œìš´ B2b ì‚¬ìš©ìž',0),(585128,16254,'he','×ž×©×ª×ž×©×™× ×—×“×©×™× B2b',0),(585129,16254,'el','ÎÎ­Î¿Î¹ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ B2b',0),(585130,16254,'zh','æ–°çš„ B2b ç”¨æˆ·',0),(585131,16254,'sv','Nya B2b-anvÃ¤ndare',0),(585132,16254,'it','Nuovi utenti B2b',0),(585133,16254,'tl','',0),(585134,16254,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¹ƒà¸«à¸¡à¹ˆ B2b',0),(585135,16254,'hi','à¤¨à¤ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‹ B2b',0),(585136,16254,'ms','Pengguna B2b yang baru',0),(585137,16254,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø§Ù„Ø¬Ø¯Ø¯ B2b',0),(585138,16254,'fr','Nouveaux utilisateurs B2b',0),(585139,16254,'jp','æ–°ã—ã„ B2b ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼',0),(585140,16254,'pt','Novos usuÃ¡rios B2b',0),(585141,16254,'ru','ÐÐ¾Ð²Ñ‹Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ð¸ B2b',0),(585142,16254,'es','Nuevos usuarios B2b',0),(585143,16254,'de','Neue B2b-Benutzer',0),(585144,16254,'en','New B2B Users',0),(585145,16255,'is','',0),(585146,16255,'dr','Ù‡ÛŒÚ† Ù†Ø´Ø§Ù†ÛŒ Ù†Ø§Ù…Ù‡ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(585147,16255,'pr','Ù‡ÛŒÚ† Ù†Ø´Ø§Ù†ÛŒ Ù†Ø§Ù…Ù‡ Ù¾ÛŒØ¯Ø§ Ù†Ø´Ø¯',0),(585148,16255,'tr','E-posta adresi bulunamadÄ±',0),(585149,16255,'pl','Nie znaleziono adresÃ³w E-mail',0),(585150,16255,'bg','ÐÐµ Ðµ Ð¾Ñ‚ÐºÑ€Ð¸Ñ‚ Ð¸Ð¼ÐµÐ¹Ð» Ð°Ð´Ñ€ÐµÑ',0),(585151,16255,'ur','Ú©ÙˆØ¦ÛŒ Ø§ÛŒ Ù…ÛŒÙ„ Ù¾ØªØ§ Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(585152,16255,'sr','ÐÐµÐ¼Ð° Ðµ-Ð°Ð´Ñ€ÐµÑÑƒ Ð½Ð°ÑˆÐ°Ð¾',0),(585153,16255,'vi','KhÃ´ng cÃ³ Ä‘á»‹a chá»‰ Email Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(585154,16255,'af','Geen e-pos adres gevind',0),(585155,16255,'ro','Nici o adresÄƒ de E-mail gÄƒsit',0),(585156,16255,'et','Meiliaadresse ei leitud',0),(585157,16255,'si','Ni e-poÅ¡tni naslov najdete',0),(585158,16255,'ba','Alamat Email tidak ditemukan',0),(585159,16255,'nl','Geen e-mailadres gevonden',0),(585160,16255,'fi','Ei sÃ¤hkÃ¶postiosoitteita',0),(585161,16255,'no','Ingen e-postadresser',0),(585162,16255,'da','Ingen E-mail-adresse, der er fundet',0),(585163,16255,'ko','ì´ë©”ì¼ ì£¼ì†Œê°€ ë°œê²¬',0),(585164,16255,'he','×œ× × ×ž×¦××” ×›×ª×•×‘×ª ×“×•×',0),(585165,16255,'el','Î”ÎµÎ½ ÎµÎ½Ï„Î¿Ï€Î¯ÏƒÏ„Î·ÎºÎµ Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ· Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(585166,16255,'zh','æœªå‘çŽ°çš„ç”µå­é‚®ä»¶åœ°å€',0),(585167,16255,'sv','Ingen e-postadress hittade',0),(585168,16255,'it','Nessun indirizzo Email trovato',0),(585169,16255,'tl','',0),(585170,16255,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆà¸­à¸µà¹€à¸¡à¸¥',0),(585171,16255,'hi','à¤•à¥‹à¤ˆ à¤ˆ-à¤®à¥‡à¤² à¤ªà¤¤à¤¾ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾',0),(585172,16255,'ms','Tiada alamat e-mel yang didapati',0),(585173,16255,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø¹Ù†ÙˆØ§Ù† Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ',0),(585174,16255,'fr','Aucune adresse E-mail trouvÃ©e',0),(585175,16255,'jp','é›»å­ãƒ¡ãƒ¼ãƒ« ã‚¢ãƒ‰ãƒ¬ã‚¹ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(585176,16255,'pt','Nenhum endereÃ§o de E-mail encontrado',0),(585177,16255,'ru','ÐÐ´Ñ€ÐµÑ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹, Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(585178,16255,'es','Ninguna direcciÃ³n de correo electrÃ³nico encontrada',0),(585179,16255,'de','Keine e-Mail-Adresse gefunden',0),(585180,16255,'en','No Email Address Found',0),(585181,16256,'is','',0),(585182,16256,'dr','Ø§ÛŒØ¬Ø§Ø¯ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø¨Ø§ Ø¯Ø³ØªØ±Ø³ÛŒ Ø³Ø·Ø­',0),(585183,16256,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ú©Ø§Ø±Ø¨Ø±Ø§Ù† Ø¨Ø§ Ø¯Ø³ØªØ±Ø³ÛŒ Ø³Ø·Ø­',0),(585184,16256,'tr','KullanÄ±cÄ±larÄ±n eriÅŸimi olan dÃ¼zey oluÅŸturma',0),(585185,16256,'pl','Tworzenie uÅ¼ytkownikÃ³w z dostÄ™pem do poziomu',0),(585186,16256,'bg','Ð¡ÑŠÐ·Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸ Ñ Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ð½Ð¸Ð²Ð¾',0),(585187,16256,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©Û’ Ø³Ø§ØªÚ¾ Ø±Ø³Ø§Ø¦ÛŒ Ø³Ø·Ø­ Ø¨Ù†Ø§Ø¦ÛŒÚº Û”',0),(585188,16256,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° ÑÐ° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿Ð¾Ð¼ Ð½Ð¸Ð²Ð¾Ð°',0),(585189,16256,'vi','Táº¡o ngÆ°á»i dÃ¹ng cÃ³ quyá»n truy cáº­p cáº¥p',0),(585190,16256,'af','Skep gebruikers met toegang vlak',0),(585191,16256,'ro','CreaÅ£i utilizatori cu acces la nivel',0),(585192,16256,'et','Luua kasutajate juurdepÃ¤Ã¤su tase',0),(585193,16256,'si','Ustvarite uporabnike z dostopom do ravni',0),(585194,16256,'ba','Membuat pengguna dengan akses tingkat',0),(585195,16256,'nl','Gebruikers met toegang niveau maken',0),(585196,16256,'fi','Luoda kÃ¤yttÃ¤jien pÃ¤Ã¤sy tasolla',0),(585197,16256,'no','Opprette brukere med tilgang',0),(585198,16256,'da','Opret brugere med adgang niveau',0),(585199,16256,'ko','ì•¡ì„¸ìŠ¤ ìˆ˜ì¤€ ì‚¬ìš©ìž ë§Œë“¤ê¸°',0),(585200,16256,'he','×œ×™×¦×•×¨ ×ž×©×ª×ž×©×™× ×¢× ×’×™×©×” ×‘×¨×ž×”',0),(585201,16256,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÏ„Îµ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚ Î¼Îµ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÎµÏ€Î¹Ï€Î­Î´Î¿Ï…',0),(585202,16256,'zh','åˆ›å»ºç”¨æˆ·çš„è®¿é—®çº§åˆ«',0),(585203,16256,'sv','Skapa anvÃ¤ndare med tillgÃ¥ng till nivÃ¥',0),(585204,16256,'it','Creare utenti con accesso livello',0),(585205,16256,'tl','',0),(585206,16256,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¸£à¸°à¸”à¸±à¸š',0),(585207,16256,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ªà¤¹à¥à¤à¤š à¤¸à¥à¤¤à¤° à¤¬à¤¨à¤¾à¤à¤',0),(585208,16256,'ms','Mencipta pengguna dengan capaian aras',0),(585209,16256,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† Ø¨Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ù…Ø³ØªÙˆÙ‰',0),(585210,16256,'fr','CrÃ©er des utilisateurs avec un accÃ¨s niveau',0),(585211,16256,'jp','ãƒ¬ãƒ™ãƒ« ã‚¢ã‚¯ã‚»ã‚¹ã‚’æŒã¤ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(585212,16256,'pt','Criar usuÃ¡rios com acesso nÃ­vel',0),(585213,16256,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ Ñ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð¾Ð¼ ÑƒÑ€Ð¾Ð²Ð½Ñ',0),(585214,16256,'es','Crear usuarios con acceso a nivel',0),(585215,16256,'de','Erstellen von Benutzern mit Zugang Ebene',0),(585216,16256,'en','Create Users With Access Level',0),(585217,16257,'is','',0),(585218,16257,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø§Ù†',0),(585219,16257,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³ÛŒØ³ØªÙ… Ø§ÛŒÙ…ÛŒÙ„ Ø¨Ù‡ Ú©Ø§Ø±Ø¨Ø±Ø§Ù†',0),(585220,16257,'tr','KullanÄ±cÄ±lar e-posta giriÅŸ bilgilerinin',0),(585221,16257,'pl','E-mail dane do logowania uÅ¼ytkownikÃ³w',0),(585222,16257,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð²Ñ…Ð¾Ð´ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(585223,16257,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©Ùˆ Ø§ÛŒ Ù…ÛŒÙ„ Ù…ÛŒÚº Ù„Ø§Ú¯ Ø§Ù† Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(585224,16257,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ†Ð¸Ð¼Ð°',0),(585225,16257,'vi','Email Ä‘Äƒng nháº­p thÃ´ng tin chi tiáº¿t cho ngÆ°á»i dÃ¹ng',0),(585226,16257,'af','E-pos aanteken besonderhede aan gebruikers',0),(585227,16257,'ro','Email datele de logare pentru utilizatori',0),(585228,16257,'et','E-posti sisselogimise andmed kasutajatele',0),(585229,16257,'si','E-poÅ¡ta Prijava Details uporabnikom',0),(585230,16257,'ba','Email rincian Login pengguna',0),(585231,16257,'nl','Email Login-gegevens aan gebruikers',0),(585232,16257,'fi','SÃ¤hkÃ¶posti kirjautumistiedot kÃ¤yttÃ¤jille',0),(585233,16257,'no','E-post logikk detaljene for brukere',0),(585234,16257,'da','Email Login detaljer til brugere',0),(585235,16257,'ko','ì‚¬ìš©ìžì— ê²Œ ì „ìž ìš°íŽ¸ ë¡œê·¸ì¸ ì •ë³´',0),(585236,16257,'he','××ª ×¤×¨×˜×™ ×”×”×ª×—×‘×¨×•×ª ×“×•× ×œ×ž×©×ª×ž×©×™×',0),(585237,16257,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Î³Î¹Î± Ï„Î¿Ï…Ï‚ Ï‡ÏÎ®ÏƒÏ„ÎµÏ‚',0),(585238,16257,'zh','ç»™ç”¨æˆ·çš„ç”µå­é‚®ä»¶ç™»å½•è¯¦ç»†ä¿¡æ¯',0),(585239,16257,'sv','E-inloggningsuppgifter fÃ¶r anvÃ¤ndare',0),(585240,16257,'it','E-mail di login per gli utenti',0),(585241,16257,'tl','',0),(585242,16257,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(585243,16257,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤ˆ-à¤®à¥‡à¤² à¤²à¥‰à¤—à¤¿à¤¨ à¤µà¤¿à¤µà¤°à¤£',0),(585244,16257,'ms','Butiran log masuk e-mel kepada pengguna',0),(585245,16257,'ar','ØªÙØ§ØµÙŠÙ„ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ù„Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ†',0),(585246,16257,'fr','Envoyer les informations de connexion aux utilisateurs',0),(585247,16257,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼ã«ãƒ¡ãƒ¼ãƒ« ãƒ­ã‚°ã‚¤ãƒ³ã®è©³ç´°',0),(585248,16257,'pt','Detalhes de Login de e-mail para usuÃ¡rios',0),(585249,16257,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð´Ð»Ñ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹',0),(585250,16257,'es','Datos de acceso de correo electrÃ³nico a los usuarios',0),(585251,16257,'de','E-Mail-Login-Daten fÃ¼r Benutzer',0),(585252,16257,'en','Email Login Details To Users',0),(585253,16258,'is','',0),(585254,16258,'dr','Ú©Ø§Ø±Ø¨Ø± B2b Ø¢Ù…Ø§Ø¯Ù‡ Ø§Ø³Øª',0),(585255,16258,'pr','Ú©Ø§Ø±Ø¨Ø± B2b Ø¢Ù…Ø§Ø¯Ù‡ Ø§Ø³Øª',0),(585256,16258,'tr','B2b kullanÄ±cÄ±nÄ±z hazÄ±rdÄ±r',0),(585257,16258,'pl','TwÃ³j uÅ¼ytkownik B2b jest gotowy',0),(585258,16258,'bg','Ð’Ð°ÑˆÐ¸Ñ‚Ðµ B2b Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ» Ðµ Ð³Ð¾Ñ‚Ð¾Ð²',0),(585259,16258,'ur','Ø¢Ù¾ B2b ØµØ§Ø±Ù Ú©Û’ Ù„ÛŒÛ’ ØªÛŒØ§Ø± ÛÛ’',0),(585260,16258,'sr','Ð‘2Ð± ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸Ñ‡ÐºÐ¾ Ñ˜Ðµ ÑÐ¿Ñ€ÐµÐ¼Ð°Ð½',0),(585261,16258,'vi','B2b ngÆ°á»i dÃ¹ng cá»§a báº¡n Ä‘Ã£ sáºµn sÃ ng',0),(585262,16258,'af','Jou B2b gebruiker Is gereed',0),(585263,16258,'ro','Utilizator B2b este gata',0),(585264,16258,'et','B2b kasutaja on valmis',0),(585265,16258,'si','B2b uporabnika je pripravljen',0),(585266,16258,'ba','Pengguna B2b Anda sudah siap',0),(585267,16258,'nl','Uw B2b-gebruiker Is klaar',0),(585268,16258,'fi','B2b-kÃ¤yttÃ¤jÃ¤ on valmis',0),(585269,16258,'no','B2b brukeren er klar',0),(585270,16258,'da','Din B2b brugeren er klar',0),(585271,16258,'ko','B2b ì‚¬ìš©ìžê°€ ì¤€ë¹„',0),(585272,16258,'he','×”×ž×©×ª×ž×© B2b ×©×œ×š ×ž×•×›×Ÿ',0),(585273,16258,'el','Î§ÏÎ®ÏƒÏ„Î· B2b ÏƒÎ±Ï‚ ÎµÎ¯Î½Î±Î¹ Î­Ï„Î¿Î¹Î¼Î¿',0),(585274,16258,'zh','ä½ çš„ B2b ç”¨æˆ·æ˜¯å‡†å¤‡å¥½äº†',0),(585275,16258,'sv','Din B2b-anvÃ¤ndaren Ã¤r redo',0),(585276,16258,'it','Il tuo utente B2b Ã¨ pronto',0),(585277,16258,'tl','',0),(585278,16258,'th','à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰ B2b à¸ˆà¸°à¸žà¸£à¹‰à¸­à¸¡',0),(585279,16258,'hi','à¤…à¤ªà¤¨à¥‡ B2b à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤¤à¥ˆà¤¯à¤¾à¤° à¤¹à¥ˆ',0),(585280,16258,'ms','Pengguna B2b anda sudah bersedia',0),(585281,16258,'ar','Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù… Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ B2b Ø¬Ø§Ù‡Ø²',0),(585282,16258,'fr','Votre nom dâ€™utilisateur B2b est prÃªt',0),(585283,16258,'jp','B2b ãƒ¦ãƒ¼ã‚¶ãƒ¼ã¯æº–å‚™ãŒã§ãã¦',0),(585284,16258,'pt','Seu usuÃ¡rio B2b estÃ¡ pronto',0),(585285,16258,'ru','B2b Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ Ð³Ð¾Ñ‚Ð¾Ð²',0),(585286,16258,'es','Tu usuario B2b estÃ¡ listo',0),(585287,16258,'de','Ihre B2b-Benutzer ist bereit',0),(585288,16258,'en','Your B2B User Is Ready',0),(585289,16259,'is','',0),(585290,16259,'dr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú†Ù†Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ B2b Ú©Ø§Ø±Ø¨Ø±',0),(585291,16259,'pr','Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ú†Ù†Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ B2b Ú©Ø§Ø±Ø¨Ø±',0),(585292,16259,'tr','Birden Ã§ok satÄ±cÄ± B2b kullanÄ±cÄ± eklemek',0),(585293,16259,'pl','Dodawanie wielu uÅ¼ytkownikÃ³w B2b dostawcÃ³w',0),(585294,16259,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð½ÑÐºÐ¾Ð»ÐºÐ¾ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° B2b Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»Ð¸',0),(585295,16259,'ur','Ú©Ø«ÛŒØ± ÙˆÛŒÙ†ÚˆØ± B2b ØµØ§Ø±ÙÛŒÙ† Ú©Ø§ Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(585296,16259,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð²Ð¸ÑˆÐµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð‘2Ð± Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(585297,16259,'vi','ThÃªm nhiá»u ngÆ°á»i bÃ¡n hÃ ng B2b ngÆ°á»i dÃ¹ng',0),(585298,16259,'af','Voeg meervoudige handelaar B2b gebruikers',0),(585299,16259,'ro','AdÄƒugaÅ£i mai mulÅ£i utilizatori de B2b distribuitor',0),(585300,16259,'et','Mitme hankija B2b kasutaja',0),(585301,16259,'si','Dodaj veÄ uporabnikov B2b dobavitelja',0),(585302,16259,'ba','Menambahkan beberapa Vendor B2b pengguna',0),(585303,16259,'nl','Meerdere leverancier B2b gebruikers toevoegen',0),(585304,16259,'fi','LisÃ¤tÃ¤ useita toimittajan B2b kÃ¤yttÃ¤jiÃ¤',0),(585305,16259,'no','Legge til flere leverandÃ¸rer B2b brukere',0),(585306,16259,'da','TilfÃ¸je flere brugere ved forhandler B2b',0),(585307,16259,'ko','ì—¬ëŸ¬ ê³µê¸‰ ì—…ì²´ì˜ B2b ì‚¬ìš©ìž ì¶”ê°€',0),(585308,16259,'he','×œ×”×•×¡×™×£ ×ž×©×ª×ž×©×™× ×ž×¨×•×‘×™× ×©×œ B2b ×”×¡×¤×§',0),(585309,16259,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· Ï€Î¿Î»Î»ÏŽÎ½ Ï‡ÏÎ·ÏƒÏ„ÏŽÎ½ B2b Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(585310,16259,'zh','æ·»åŠ å¤šä¸ªä¾›åº”å•† B2b ç”¨æˆ·',0),(585311,16259,'sv','LÃ¤gga till flera anvÃ¤ndare leverantÃ¶r B2b',0),(585312,16259,'it','Aggiungere piÃ¹ utenti B2b di fornitore',0),(585313,16259,'tl','',0),(585314,16259,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢ B2b à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸«à¸¥à¸²à¸¢à¸„à¸™',0),(585315,16259,'hi','à¤à¤• à¤¸à¥‡ à¤…à¤§à¤¿à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ B2b à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(585316,16259,'ms','Menambah berbilang pengguna B2b Penjual',0),(585317,16259,'ar','Ø¥Ø¶Ø§ÙØ© Ø§Ù„Ø¹Ø¯ÙŠØ¯ Ù…Ù† Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…ÙŠÙ† B2b Ø§Ù„Ù…ÙˆØ±Ø¯ÙŠÙ†',0),(585318,16259,'fr','Ajouter plusieurs utilisateurs B2b de fournisseur',0),(585319,16259,'jp','è¤‡æ•°ãƒ™ãƒ³ãƒ€ãƒ¼ã® B2b ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(585320,16259,'pt','Adicionar vÃ¡rios usuÃ¡rios B2b de fornecedor',0),(585321,16259,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¸Ñ… Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÐµÐ¹ B2b Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(585322,16259,'es','Agregar varios usuarios de B2b de proveedores',0),(585323,16259,'de','Mehrere Anbieter B2b Benutzer hinzufÃ¼gen',0),(585324,16259,'en','Add Multiple Vendor B2B Users',0),(585325,16260,'is','',0),(585326,16260,'dr','Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ø§Ø±Ø¨Ø±',0),(585327,16260,'pr','Ù‚Ø§Ù„Ø¨ Ø§ÛŒÙ…ÛŒÙ„ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ø§Ø±Ø¨Ø±',0),(585328,16260,'tr','KullanÄ±cÄ± AyrÄ±ntÄ±lar e-posta ÅŸablonu',0),(585329,16260,'pl','Szablon wiadomoÅ›ci E-mail uÅ¼ytkownika szczegÃ³Å‚y',0),(585330,16260,'bg','ÐŸÐ¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»ÑÐºÐ¸ Ð´ÐµÑ‚Ð°Ð¹Ð»Ð¸ Ð¸Ð¼ÐµÐ¹Ð» ÑˆÐ°Ð±Ð»Ð¾Ð½',0),(585331,16260,'ur','ØµØ§Ø±Ù Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª Ø§ÛŒ Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Ø§',0),(585332,16260,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ° Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(585333,16260,'vi','NgÆ°á»i sá»­ dá»¥ng chi tiáº¿t Email máº«u',0),(585334,16260,'af','Gebruiker besonderhede e-pos sjabloon',0),(585335,16260,'ro','Utilizator detalii E-mail ÅŸablon',0),(585336,16260,'et','Kasutaja Ã¼ksikasjad meilisÃµnumimallid',0),(585337,16260,'si','Uporabnik podrobnosti Email predloga',0),(585338,16260,'ba','Pengguna rincian Email Template',0),(585339,16260,'nl','Gebruiker Details e-mailtemplate',0),(585340,16260,'fi','KÃ¤yttÃ¤jÃ¤n tiedot sÃ¤hkÃ¶postimalli',0),(585341,16260,'no','Brukeren detaljer e-mal',0),(585342,16260,'da','Bruger detaljer emailskabelon',0),(585343,16260,'ko','ì‚¬ìš©ìž ì„¸ë¶€ ì‚¬í•­ ì´ë©”ì¼ í…œí”Œë¦¿',0),(585344,16260,'he','×ª×‘× ×™×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™ ×©×œ ×ž×©×ª×ž×© ×¤×¨×˜×™',0),(585345,16260,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… Ï„Î¿Ï… Ï‡ÏÎ®ÏƒÏ„Î· Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(585346,16260,'zh','ç”¨æˆ·è¯¦ç»†ä¿¡æ¯çš„ç”µå­é‚®ä»¶æ¨¡æ¿',0),(585347,16260,'sv','AnvÃ¤ndar Detaljer e-postmall',0),(585348,16260,'it','Modello di Email di informazioni utente',0),(585349,16260,'tl','',0),(585350,16260,'th','à¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰',0),(585351,16260,'hi','à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤µà¤¿à¤µà¤°à¤£ à¤ˆ-à¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ',0),(585352,16260,'ms','Template e-mel maklumat pengguna',0),(585353,16260,'ar','Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ ØªÙØ§ØµÙŠÙ„ Ø§Ù„Ù…Ø³ØªØ®Ø¯Ù…',0),(585354,16260,'fr','ModÃ¨le de courriel utilisateur dÃ©tails',0),(585355,16260,'jp','ãƒ¦ãƒ¼ã‚¶ãƒ¼è©³ç´°ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ',0),(585356,16260,'pt','Modelo de Email do usuÃ¡rio detalhes',0),(585357,16260,'ru','Email ÑˆÐ°Ð±Ð»Ð¾Ð½Ð° ÑÐ²ÐµÐ´ÐµÐ½Ð¸Ð¹ Ð¾ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ðµ',0),(585358,16260,'es','Plantilla de correo electrÃ³nico de los datos de usuario',0),(585359,16260,'de','E-Mail Benutzerdetailvorlage',0),(585360,16260,'en','User Details Email Template',0),(585361,16261,'is','',0),(585362,16261,'dr','ØªÙ†Ø¸ÛŒÙ… Ù…Ø¬Ø¯Ø¯ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø§ÛŒÙ…ÛŒÙ„',0),(585363,16261,'pr','ØªÙ†Ø¸ÛŒÙ… Ù…Ø¬Ø¯Ø¯ Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø§ÛŒÙ…ÛŒÙ„',0),(585364,16261,'tr','Bir parola sÄ±fÄ±rlama e-posta',0),(585365,16261,'pl','E-mail resetowania hasÅ‚a',0),(585366,16261,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð²ÑŠÐ·ÑÑ‚Ð°Ð½Ð¾Ð²ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°Ñ‚Ð°',0),(585367,16261,'ur','Ø§ÛŒÚ© Ù¾Ø§Ø³ ÙˆØ±Úˆ Ù¾Ú¾Ø± Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº Ø§ÛŒ Ù…ÛŒÙ„ Ú©Ø±ÛŒÚº',0),(585368,16261,'sr','Ð• -Ð¿Ð¾ÑˆÑ‚Ð° Ð·Ð° Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð°Ð²Ð°ÑšÐµ Ð»Ð¾Ð·Ð¸Ð½ÐºÐµ',0),(585369,16261,'vi','Email Ä‘áº·t láº¡i máº­t kháº©u',0),(585370,16261,'af','E-pos \'n wagwoord terugstel',0),(585371,16261,'ro','E-mail o resetare parola',0),(585372,16261,'et','E-posti parooli lÃ¤htestamine',0),(585373,16261,'si','Email ponastavitev gesla',0),(585374,16261,'ba','Email Password Reset',0),(585375,16261,'nl','E-mail een wachtwoord Reset',0),(585376,16261,'fi','SÃ¤hkÃ¶posti salasanan palauttamista',0),(585377,16261,'no','Epost tilbakestille passordet',0),(585378,16261,'da','Email en nulstilling af adgangskode',0),(585379,16261,'ko','ë¹„ë°€ ë²ˆí˜¸ ìž¬ì„¤ì • ì´ë©”ì¼',0),(585380,16261,'he','×“×•× ×œ ××™×¤×•×¡ ×¡×™×¡×ž×”',0),(585381,16261,'el','Email Î±Î»Î»Î±Î³Î®Ï‚ Ï„Î¿Ï… ÎºÏ‰Î´Î¹ÎºÎ¿Ï Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(585382,16261,'zh','é€šè¿‡ç”µå­é‚®ä»¶å‘é€å¯†ç é‡ç½®',0),(585383,16261,'sv','Maila en lÃ¶senordsÃ¥terstÃ¤llning',0),(585384,16261,'it','Reimpostare la Password di posta elettronica',0),(585385,16261,'tl','',0),(585386,16261,'th','à¸­à¸µà¹€à¸¡à¸£à¸µà¹€à¸‹à¹‡à¸•à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™',0),(585387,16261,'hi','à¤à¤• à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤°à¥€à¤¸à¥‡à¤Ÿ à¤ˆ-à¤®à¥‡à¤²',0),(585388,16261,'ms','Set semula kata laluan dalam e-mel',0),(585389,16261,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¥Ø¹Ø§Ø¯Ø© ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ±',0),(585390,16261,'fr','Une rÃ©initialisation de mot de passe par courriel',0),(585391,16261,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«ã®ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã®ãƒªã‚»ãƒƒãƒˆ',0),(585392,16261,'pt','Uma redefiniÃ§Ã£o de senha de e-mail',0),(585393,16261,'ru','Ð¡Ð±Ñ€Ð¾Ñ Ð¿Ð°Ñ€Ð¾Ð»Ñ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ',0),(585394,16261,'es','Un restablecimiento de contraseÃ±a de correo electrÃ³nico',0),(585395,16261,'de','Per e-Mail einen Passwort-Reset',0),(585396,16261,'en','Email A Password Reset',0),(585397,16262,'is','',0),(585398,16262,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª ÙˆØ±ÙˆØ¯ B2b',0),(585399,16262,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª ÙˆØ±ÙˆØ¯ B2b',0),(585400,16262,'tr','B2b giriÅŸ bilgileri',0),(585401,16262,'pl','Dane logowania B2B',0),(585402,16262,'bg','B2B Login Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚',0),(585403,16262,'ur','B2b Ù„Ø§Ú¯ Ø§Ù† Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(585404,16262,'sr','Ð‘2Ð± Ð›Ð¾Ð³Ð¸Ð½ Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(585405,16262,'vi','Chi tiáº¿t Ä‘Äƒng nháº­p B2b',0),(585406,16262,'af','B2b aanteken besonderhede',0),(585407,16262,'ro','Datele de logare B2B',0),(585408,16262,'et','B2B sisselogimise andmed',0),(585409,16262,'si','B2B prepriÄevalnost podrobnost',0),(585410,16262,'ba','Rincian Login B2B',0),(585411,16262,'nl','B2B Login-gegevens',0),(585412,16262,'fi','B2B kirjautumistiedot',0),(585413,16262,'no','B2B pÃ¥loggingsinformasjon',0),(585414,16262,'da','B2B Login detaljer',0),(585415,16262,'ko','B2b ë¡œê·¸ì¸ ì •ë³´',0),(585416,16262,'he','×¤×¨×˜×™ ×”×”×ª×—×‘×¨×•×ª B2b',0),(585417,16262,'el','B2B ÎµÎ¯ÏƒÎ¿Î´Î¿Ï‚ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·',0),(585418,16262,'zh','B2b ç™»å½•è¯¦ç»†ä¿¡æ¯',0),(585419,16262,'sv','B2B inloggningsuppgifter',0),(585420,16262,'it','Dettagli di accesso B2B',0),(585421,16262,'tl','',0),(585422,16262,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š B2b',0),(585423,16262,'hi','B2b à¤²à¥‰à¤—à¤¿à¤¨ à¤µà¤¿à¤µà¤°à¤£',0),(585424,16262,'ms','Butir-butir Login B2b',0),(585425,16262,'ar','ØªÙØ§ØµÙŠÙ„ ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ B2b',0),(585426,16262,'fr','Informations de connexion B2B',0),(585427,16262,'jp','B2b ãƒ­ã‚°ã‚¤ãƒ³ã®è©³ç´°',0),(585428,16262,'pt','Detalhes de Login de B2B',0),(585429,16262,'ru','B2B Ð»Ð¾Ð³Ð¸Ð½',0),(585430,16262,'es','Detalles de inicio de sesiÃ³n de B2B',0),(585431,16262,'de','B2B-Login-Daten',0),(585432,16262,'en','B2B Login Details',0),(585433,16263,'is','',0),(585434,16263,'dr','Ù¾Ø§ÛŒØ§Ù† Ù…ØªÙ† Ù„ÛŒÙ†Ú© ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª',0),(585435,16263,'pr','Ù¾Ø§ÛŒØ§Ù† Ù…ØªÙ† Ù„ÛŒÙ†Ú© ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª',0),(585436,16263,'tr','Son giriÅŸ baÄŸlantÄ± metni',0),(585437,16263,'pl','Koniec tekstu Å‚Ä…cze logowania',0),(585438,16263,'bg','ÐšÑ€Ð°Ð¹ Ð²Ñ…Ð¾Ð´ Ð²Ñ€ÑŠÐ·ÐºÐ° Ñ‚ÐµÐºÑÑ‚',0),(585439,16263,'ur','Ø¢Ø®Ø± Ù„Ø§Ú¯ Ø§Ù† Ù„Ù†Ú© Ù…ØªÙ†',0),(585440,16263,'sr','Ð¢ÐµÐºÑÑ‚ Ð²ÐµÐ·Ðµ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ ÐºÑ€Ð°Ñ˜',0),(585441,16263,'vi','VÄƒn báº£n liÃªn káº¿t thÃºc Ä‘Äƒng nháº­p',0),(585442,16263,'af','Einde Login skakel teks',0),(585443,16263,'ro','Final Text Link-ul de Login',0),(585444,16263,'et','LÃµpuks Login lingi tekst',0),(585445,16263,'si','Besedilo povezave prijava konec',0),(585446,16263,'ba','Akhir teks Link Login',0),(585447,16263,'nl','De tekst van de koppeling van de Login van de einde',0),(585448,16263,'fi','Lopulta Kirjaudu linkkiteksti',0),(585449,16263,'no','Slutten logikk koblingsteksten',0),(585450,16263,'da','Ende Login linktekst',0),(585451,16263,'ko','ìµœì¢… ë¡œê·¸ì¸ ë§í¬ í…ìŠ¤íŠ¸',0),(585452,16263,'he','×˜×§×¡×˜ ×”×§×™×©×•×¨ ×›× ×™×¡×” ×¡×•×£',0),(585453,16263,'el','Î¤Î­Î»Î¿Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ· ÎºÎµÎ¹Î¼Î­Î½Î¿Ï…',0),(585454,16263,'zh','æœ€åŽç™»å½•é“¾æŽ¥æ–‡æœ¬',0),(585455,16263,'sv','Slutet Login lÃ¤nktext',0),(585456,16263,'it','Fine Login Link Text',0),(585457,16263,'tl','',0),(585458,16263,'th','à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”à¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡',0),(585459,16263,'hi','à¤…à¤‚à¤¤ à¤²à¥‰à¤—à¤¿à¤¨ à¤²à¤¿à¤‚à¤• à¤ªà¤¾à¤ ',0),(585460,16263,'ms','Teks pautan log masuk akhir',0),(585461,16263,'ar','Ù†Ù‡Ø§ÙŠØ© Ù†Øµ Ø§Ù„Ø§Ø±ØªØ¨Ø§Ø· ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(585462,16263,'fr','Texte du lien Login fin',0),(585463,16263,'jp','æœ€å¾Œãƒ­ã‚°ã‚¤ãƒ³ ãƒªãƒ³ã‚¯ ãƒ†ã‚­ã‚¹ãƒˆ',0),(585464,16263,'pt','Fim Login Link texto',0),(585465,16263,'ru','ÐšÐ¾Ð½ÐµÑ† Ñ‚ÐµÐºÑÑ‚ ÑÑÑ‹Ð»ÐºÐ¸ Ð´Ð»Ñ Ð²Ñ…Ð¾Ð´Ð°',0),(585466,16263,'es','Texto de enlace de inicio de sesiÃ³n final',0),(585467,16263,'de','Ende-Login-Link-Text',0),(585468,16263,'en','End Login Link Text',0),(585469,16264,'is','',0),(585470,16264,'dr','Ù„ÛŒÙ†Ú© ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª',0),(585471,16264,'pr','Ù„ÛŒÙ†Ú© ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª',0),(585472,16264,'tr','BaÄŸlantÄ± iÃ§in oturum aÃ§ma',0),(585473,16264,'pl','Link do logowania',0),(585474,16264,'bg','Ð’Ñ€ÑŠÐ·ÐºÐ° ÐºÑŠÐ¼ Ð²Ñ…Ð¾Ð´',0),(585475,16264,'ur','Ù„Ø§Ú¯ Ø§Ù† Ú©Ø§ Ø±Ø¨Ø·',0),(585476,16264,'sr','ÐŸÐ¾Ð²ÐµÐ¶Ð¸ ÑÐ° Ð›Ð¾Ð³Ð¸Ð½',0),(585477,16264,'vi','LiÃªn káº¿t Ä‘á»ƒ Ä‘Äƒng nháº­p',0),(585478,16264,'af','Skakel om aan te teken',0),(585479,16264,'ro','Link la spre Login',0),(585480,16264,'et','Lingi Logi sisse',0),(585481,16264,'si','ÄŒlen v prepriÄevalnost',0),(585482,16264,'ba','Link ke Login',0),(585483,16264,'nl','Link naar Login',0),(585484,16264,'fi','KytkeÃ¤ jotta johdonmukaisuus',0),(585485,16264,'no','Koblingen logge inn',0),(585486,16264,'da','Link til Login',0),(585487,16264,'ko','ë¡œê·¸ì¸ ë§í¬',0),(585488,16264,'he','×œ×™× ×§ ×›× ×™×¡×”',0),(585489,16264,'el','Î£ÏÎ½Î´ÎµÏƒÎ· Î³Î¹Î± Î½Î± ÏƒÏ…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ',0),(585490,16264,'zh','é“¾æŽ¥ç™»å½•',0),(585491,16264,'sv','LÃ¤nk till inloggning',0),(585492,16264,'it','Link per effettuare il Login',0),(585493,16264,'tl','',0),(585494,16264,'th','à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š',0),(585495,16264,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¿à¤‚à¤•',0),(585496,16264,'ms','Pautan untuk log masuk',0),(585497,16264,'ar','Ø±Ø§Ø¨Ø· Ù„ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(585498,16264,'fr','Lien pour vous connecter',0),(585499,16264,'jp','ãƒ­ã‚°ã‚¤ãƒ³ã¸ã®ãƒªãƒ³ã‚¯',0),(585500,16264,'pt','Link para Login',0),(585501,16264,'ru','Ð¡ÑÑ‹Ð»ÐºÐ° Ð½Ð° Ð²Ñ…Ð¾Ð´',0),(585502,16264,'es','Enlace para iniciar sesiÃ³n',0),(585503,16264,'de','Link zum Login',0),(585504,16264,'en','Link To Login',0),(585505,16265,'is','',0),(585506,16265,'dr','Ø´Ø±ÙˆØ¹ Ù…ØªÙ† Ù„ÛŒÙ†Ú© ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª',0),(585507,16265,'pr','Ø´Ø±ÙˆØ¹ Ù…ØªÙ† Ù„ÛŒÙ†Ú© ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø³Ø§ÛŒØª',0),(585508,16265,'tr','GiriÅŸ baÄŸlantÄ± metni baÅŸlatmak',0),(585509,16265,'pl','Uruchom logowania Link Text',0),(585510,16265,'bg','Ð—Ð°Ð¿Ð¾Ñ‡Ð½ÐµÑ‚Ðµ Ð²Ñ…Ð¾Ð´ Ð²Ñ€ÑŠÐ·ÐºÐ° Ñ‚ÐµÐºÑÑ‚',0),(585511,16265,'ur','Ù„Ø§Ú¯ Ø§Ù† Ù„Ù†Ú© Ù…ØªÙ† Ø´Ø±ÙˆØ¹ Ú©Ø±ÛŒÚº',0),(585512,16265,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð¸ Ñ‚ÐµÐºÑÑ‚ Ð²ÐµÐ·Ðµ Ð·Ð° Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ñ™Ð¸Ð²Ð°ÑšÐµ',0),(585513,16265,'vi','Báº¯t Ä‘áº§u vÄƒn báº£n liÃªn káº¿t Ä‘Äƒng nháº­p',0),(585514,16265,'af','Aantekening skakel teks begin',0),(585515,16265,'ro','ÃŽncepe textul link-ul de Login',0),(585516,16265,'et','Alustada Login lingi tekst',0),(585517,16265,'si','ZaÄetek Login besedilo povezave',0),(585518,16265,'ba','Mulai teks Link Login',0),(585519,16265,'nl','Begin van de tekst van de koppeling van de Login',0),(585520,16265,'fi','Aloita kirjautuminen linkkiteksti',0),(585521,16265,'no','Starte Login koblingsteksten',0),(585522,16265,'da','Start Login linktekst',0),(585523,16265,'ko','ë¡œê·¸ì¸ ë§í¬ í…ìŠ¤íŠ¸ ì‹œìž‘',0),(585524,16265,'he','×œ×”×ª×—×™×œ ×˜×§×¡×˜ ×”×§×™×©×•×¨ ×›× ×™×¡×”',0),(585525,16265,'el','ÎˆÎ½Î±ÏÎ¾Î· ÏƒÏÎ½Î´ÎµÏƒÎ·Ï‚ ÏƒÏÎ½Î´ÎµÏƒÎ· ÎºÎµÎ¹Î¼Î­Î½Î¿Ï…',0),(585526,16265,'zh','å¼€å§‹ç™»å½•é“¾æŽ¥æ–‡æœ¬',0),(585527,16265,'sv','Starta inloggning lÃ¤nktext',0),(585528,16265,'it','Avviare Login Link Text',0),(585529,16265,'tl','',0),(585530,16265,'th','à¹€à¸£à¸´à¹ˆà¸¡à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¸‚à¹‰à¸­à¸„à¸§à¸²à¸¡',0),(585531,16265,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤²à¤¿à¤‚à¤• à¤ªà¤¾à¤  à¤¶à¥à¤°à¥‚',0),(585532,16265,'ms','Mula teks pautan log masuk',0),(585533,16265,'ar','Ø¨Ø¯Ø¡ Ø§Ù„Ù†Øµ Ø§Ø±ØªØ¨Ø§Ø· ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„',0),(585534,16265,'fr','Commencer le texte du lien Login',0),(585535,16265,'jp','ãƒ­ã‚°ã‚¤ãƒ³ ãƒªãƒ³ã‚¯ ãƒ†ã‚­ã‚¹ãƒˆã‚’é–‹å§‹ã—ã¾ã™ã€‚',0),(585536,16265,'pt','Iniciar o texto do Link de Login',0),(585537,16265,'ru','ÐÐ°Ñ‡Ð½Ð¸Ñ‚Ðµ Ñ‚ÐµÐºÑÑ‚ ÑÑÑ‹Ð»ÐºÐ¸ Ð´Ð»Ñ Ð²Ñ…Ð¾Ð´Ð°',0),(585538,16265,'es','Inicio Inicio de sesiÃ³n texto del enlace',0),(585539,16265,'de','Login-Link-Text zu starten',0),(585540,16265,'en','Start Login Link Text',0),(585541,16266,'is','',0),(585542,16266,'dr','Ø­Ø¬Ù… ÙØ§ÛŒÙ„ Ù…Ú©Ø³',0),(585543,16266,'pr','Ø­Ø¬Ù… ÙØ§ÛŒÙ„ Ù…Ú©Ø³',0),(585544,16266,'tr','Maksimum dosya boyutu',0),(585545,16266,'pl','Maksymalny rozmiar pliku',0),(585546,16266,'bg','Max Ð¿Ð¸Ð»Ð° Ñ€Ð°Ð·Ð¼ÐµÑ€',0),(585547,16266,'ur','Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ù…Ø³Ù„ Ø³Ø§Ø¦Ø²',0),(585548,16266,'sr','Ð’ÐµÐ»Ð¸Ñ‡Ð¸Ð½Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ ÐœÐ°x',0),(585549,16266,'vi','KÃ­ch thÆ°á»›c tá»‘i Ä‘a táº­p tin',0),(585550,16266,'af','Maksimum lÃªergrootte',0),(585551,16266,'ro','Marime Max fisier',0),(585552,16266,'et','Max faili suurus',0),(585553,16266,'si','Max pila velikost',0),(585554,16266,'ba','Max Ukuran File',0),(585555,16266,'nl','Max bestandsgrootte',0),(585556,16266,'fi','Max arkistoida koko',0),(585557,16266,'no','Maks filstÃ¸rrelse',0),(585558,16266,'da','Max filstÃ¸rrelse',0),(585559,16266,'ko','ìµœëŒ€ íŒŒì¼ í¬ê¸°',0),(585560,16266,'he','×’×•×“×œ ×”×§×•×‘×¥ ×ž×§×¡',0),(585561,16266,'el','ÎœÎ­Î³ÎµÎ¸Î¿Ï‚ Î±ÏÏ‡ÎµÎ¯Î¿Ï… Max',0),(585562,16266,'zh','æœ€å¤§æ–‡ä»¶å¤§å°',0),(585563,16266,'sv','Max filstorlek',0),(585564,16266,'it','Dimensione massima File',0),(585565,16266,'tl','',0),(585566,16266,'th','à¸‚à¸™à¸²à¸”à¹à¸Ÿà¹‰à¸¡à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(585567,16266,'hi','à¤…à¤§à¤¿à¤•à¤¤à¤® à¤«à¤¼à¤¾à¤‡à¤² à¤†à¤•à¤¾à¤°',0),(585568,16266,'ms','Saiz fail maksimum',0),(585569,16266,'ar','Ø­Ø¬Ù… Ø§Ù„Ù…Ù„Ù Ø§Ù„Ø­Ø¯ Ø§Ù„Ø£Ù‚ØµÙ‰',0),(585570,16266,'fr','Taille du fichier Max',0),(585571,16266,'jp','æœ€å¤§ãƒ•ã‚¡ã‚¤ãƒ« ã‚µã‚¤ã‚º',0),(585572,16266,'pt','Tamanho do arquivo de Max',0),(585573,16266,'ru','ÐœÐ°ÐºÑÐ¸Ð¼Ð°Ð»ÑŒÐ½Ñ‹Ð¹ Ñ€Ð°Ð·Ð¼ÐµÑ€ Ñ„Ð°Ð¹Ð»Ð°',0),(585574,16266,'es','TamaÃ±o de archivo mÃ¡ximo',0),(585575,16266,'de','Max. DateigrÃ¶ÃŸe',0),(585576,16266,'en','Max File Size',0),(585577,16267,'is','',0),(585578,16267,'dr','ØªÙˆØ¶ÛŒØ­Ø§Øª ØªØ±Ø§Ú©Ù†Ø´',0),(585579,16267,'pr','ØªÙˆØ¶ÛŒØ­Ø§Øª ØªØ±Ø§Ú©Ù†Ø´',0),(585580,16267,'tr','Ä°ÅŸlem aÃ§Ä±klamasÄ±',0),(585581,16267,'pl','Opis transakcji',0),(585582,16267,'bg','Ð’Ð¸Ð´ Ð½Ð° Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð°',0),(585583,16267,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ ØªÙØµÛŒÙ„',0),(585584,16267,'sr','ÐžÐ¿Ð¸Ñ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ð°',0),(585585,16267,'vi','Giao dá»‹ch mÃ´ táº£',0),(585586,16267,'af','Transaksie Beskrywing',0),(585587,16267,'ro','Descrierea tranzactiei',0),(585588,16267,'et','Tehingu kirjeldus',0),(585589,16267,'si','Opis transakcije',0),(585590,16267,'ba','Deskripsi transaksi',0),(585591,16267,'nl','Beschrijving van transactie',0),(585592,16267,'fi','Tapahtuman kuvaus',0),(585593,16267,'no','Transaksjonsbeskrivelsen',0),(585594,16267,'da','Posteringsbeskrivelse',0),(585595,16267,'ko','íŠ¸ëžœìž­ì…˜ ì„¤ëª…',0),(585596,16267,'he','×ª××•×¨ ×¢×¡×§×”',0),(585597,16267,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(585598,16267,'zh','äº¤æ˜“è®°å½•æè¿°',0),(585599,16267,'sv','Transaktionen Beskrivning',0),(585600,16267,'it','Descrizione della transazione',0),(585601,16267,'tl','',0),(585602,16267,'th','à¸­à¸˜à¸´à¸šà¸²à¸¢à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡',0),(585603,16267,'hi','à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤µà¤¿à¤µà¤°à¤£',0),(585604,16267,'ms','Penerangan urus niaga',0),(585605,16267,'ar','ÙˆØµÙ Ø§Ù„Ø­Ø±ÙƒØ©',0),(585606,16267,'fr','Description de la transaction',0),(585607,16267,'jp','ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã®èª¬æ˜Ž',0),(585608,16267,'pt','DescriÃ§Ã£o da transaÃ§Ã£o',0),(585609,16267,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¸',0),(585610,16267,'es','DescripciÃ³n de la transacciÃ³n',0),(585611,16267,'de','Transaktionsbeschreibung',0),(585612,16267,'en','Transaction Description',0),(585613,16268,'is','',0),(585614,16268,'dr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ú©Ø§Ø±Øª',0),(585615,16268,'pr','ØªÙˆØ¶ÛŒØ­Ø§Øª Ú©Ø§Ø±Øª',0),(585616,16268,'tr','FiÅŸ aÃ§Ä±klamasÄ±',0),(585617,16268,'pl','Opis kuponu',0),(585618,16268,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¾Ð¿Ð¸ÑÐ°Ð½Ð¸Ðµ',0),(585619,16268,'ur','ÙˆØ§Ø¤Ú†Ø± Ú©ÛŒ ØªÙØµÛŒÙ„',0),(585620,16268,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð¾Ð¿Ð¸Ñ',0),(585621,16268,'vi','MÃ´ táº£ phiáº¿u',0),(585622,16268,'af','Bewys Beskrywing',0),(585623,16268,'ro','Voucher Descriere',0),(585624,16268,'et','Kande kirjeldus',0),(585625,16268,'si','Kupon opis',0),(585626,16268,'ba','Deskripsi voucher',0),(585627,16268,'nl','Beschrijving van de waardebon',0),(585628,16268,'fi','Tositteen kuvaus',0),(585629,16268,'no','Bilag beskrivelse',0),(585630,16268,'da','Voucher beskrivelse',0),(585631,16268,'ko','ì¿ í° ì„¤ëª…',0),(585632,16268,'he','×ª×™××•×¨ ×©×•×‘×¨',0),(585633,16268,'el','Î ÎµÏÎ¹Î³ÏÎ±Ï†Î® Ï„Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹',0),(585634,16268,'zh','ç¤¼åˆ¸è¯´æ˜Ž',0),(585635,16268,'sv','Verifikationen Beskrivning',0),(585636,16268,'it','Descrizione di voucher',0),(585637,16268,'tl','',0),(585638,16268,'th','à¸„à¸³à¸­à¸˜à¸´à¸šà¸²à¸¢à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸',0),(585639,16268,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤µà¤¿à¤µà¤°à¤£',0),(585640,16268,'ms','Perihal baucar',0),(585641,16268,'ar','ÙˆØµÙ Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(585642,16268,'fr','Description de la piÃ¨ce justificative',0),(585643,16268,'jp','ã‚¯ãƒ¼ãƒãƒ³ã®èª¬æ˜Ž',0),(585644,16268,'pt','DescriÃ§Ã£o de comprovante',0),(585645,16268,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ð°',0),(585646,16268,'es','DescripciÃ³n de vale',0),(585647,16268,'de','Gutschein-Beschreibung',0),(585648,16268,'en','Voucher Description',0),(585649,16269,'is','',0),(585650,16269,'dr','Ø¯Ø³ØªÙ‡ Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Prilim',0),(585651,16269,'pr','Ø¯Ø³ØªÙ‡ Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Prilim',0),(585652,16269,'tr','Toplu iÅŸ gÃ¶nderme Prilim istekleri',0),(585653,16269,'pl','Å»Ä…daÅ„ wsadowych WyÅ›lij Prilim',0),(585654,16269,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Prilim Ð·Ð°Ð¿Ð¸Ñ‚Ð²Ð°Ð½Ð¸Ñ',0),(585655,16269,'ur','Ø¨ÛŒÚ† Ø¨Ú¾ÛŒØ¬ÛŒÚº Ù¾Ø±Ø§Ù„Ø§Ù… Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(585656,16269,'sr','Ð“Ñ€ÑƒÐ¿Ð½Ð¾ ÑÐ»Ð°ÑšÐµ ÐŸÑ€Ð¸Ð»Ð¸Ð¼ Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ',0),(585657,16269,'vi','LÃ´ gá»­i Prilim yÃªu cáº§u',0),(585658,16269,'af','Bondel stuur Prilim versoeke',0),(585659,16269,'ro','Lot trimite Prilim cereri',0),(585660,16269,'et','Partii saada Prilim taotlused',0),(585661,16269,'si','Serija spodbuda Prilim zahteve',0),(585662,16269,'ba','Batch kirim Prilim permintaan',0),(585663,16269,'nl','Batch verzenden Prilim aanvragen',0),(585664,16269,'fi','ErÃ¤n LÃ¤hetÃ¤ Prilim pyynnÃ¶t',0),(585665,16269,'no','KjÃ¸rselen Send Prilim forespÃ¸rsler',0),(585666,16269,'da','Batch Send Prilim anmodninger',0),(585667,16269,'ko','ì¼ê´„ ì²˜ë¦¬ ì†¡ì‹  Prilim ìš”ì²­',0),(585668,16269,'he','××¦×•×•×” ×œ×©×œ×•×— ×‘×§×©×•×ª Prilim',0),(585669,16269,'el','ÎœÎ±Î¶Î¹ÎºÎ® Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® Î±Î¹Ï„Î®ÏƒÎµÏ‰Î½ Prilim',0),(585670,16269,'zh','æ‰¹å‘é€å˜é€Ÿè¯·æ±‚',0),(585671,16269,'sv','Batch skicka Prilim Ã¶nskemÃ¥l',0),(585672,16269,'it','Batch invia richieste di Prilim',0),(585673,16269,'tl','',0),(585674,16269,'th','Prilim à¸Šà¸¸à¸”à¸ªà¹ˆà¸‡à¸„à¸³à¸£à¹‰à¸­à¸‡à¸‚à¸­',0),(585675,16269,'hi','à¤¬à¥ˆà¤š Prilim à¤…à¤¨à¥à¤°à¥‹à¤§ à¤­à¥‡à¤œà¥‡à¤‚',0),(585676,16269,'ms','Kelompok hantar Prilim permintaan',0),(585677,16269,'ar','Ø¯ÙØ¹Ø© Ø¥Ø±Ø³Ø§Ù„ Ø·Ù„Ø¨Ø§Øª Ø¨Ø±ÙŠÙ„ÙŠÙ…',0),(585678,16269,'fr','Lot envoyer Prilim demandes',0),(585679,16269,'jp','ãƒãƒƒãƒé€ä¿¡ Prilim è¦æ±‚',0),(585680,16269,'pt','SolicitaÃ§Ãµes de Prilim de envio de lote',0),(585681,16269,'ru','ÐŸÐ°ÐºÐµÑ‚Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÑ‹ Prilim Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ',0),(585682,16269,'es','Lote enviar solicitudes de Prilim',0),(585683,16269,'de','Batchanforderungen senden Prilim',0),(585684,16269,'en','Batch Send Prelim Requests',0),(585685,16270,'is','',0),(585686,16270,'dr','Ø¯Ø§ÛŒØ±Ú©ØªÙˆØ±ÛŒ Ø¨Ø§ÛŒØ¯ Ù‚Ø§Ø¨Ù„ Ù†ÙˆØ´ØªÙ† Ø¨Ø§Ø´Ø¯',0),(585687,16270,'pr','Ø¯Ø§ÛŒØ±Ú©ØªÙˆØ±ÛŒ Ø¨Ø§ÛŒØ¯ Ù‚Ø§Ø¨Ù„ Ù†ÙˆØ´ØªÙ† Ø¨Ø§Ø´Ø¯',0),(585688,16270,'tr','Dizini yazÄ±labilir olmalÄ±dÄ±r',0),(585689,16270,'pl','Katalog musi byÄ‡ zapisywalny',0),(585690,16270,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸ÑÑ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ðµ Ð´Ð¾ÑÑ‚ÑŠÐ¿Ð½Ð° Ð·Ð° Ð¿Ð¸ÑÐ°Ð½Ðµ',0),(585691,16270,'ur','ÚˆØ§Ø¦Ø±ÛŒÚ©Ù¹Ø±ÛŒ Ù‚Ø§Ø¨Ù„ ØªØ­Ø±ÛŒØ± ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(585692,16270,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð¾Ñ€Ð¸Ñ˜ÑƒÐ¼ Ð¼Ð¾Ñ€Ð° Ð´Ð° Ð±ÑƒÐ´Ðµ ÑƒÐ¿Ð¸ÑÐ¸Ð²',0),(585693,16270,'vi','ThÆ° má»¥c pháº£i Ä‘Æ°á»£c ghi',0),(585694,16270,'af','Gids skryfbare moet word',0),(585695,16270,'ro','Director trebuie sÄƒ fie de scriere',0),(585696,16270,'et','Kataloog peab olema kirjutatav',0),(585697,16270,'si','Imenik mora biti primeren da se napiÅ¡e',0),(585698,16270,'ba','Direktori ini harus bisa ditulisi',0),(585699,16270,'nl','Map moet schrijfbaar',0),(585700,16270,'fi','Hakemistossa on kirjoitettava',0),(585701,16270,'no','Katalogen mÃ¥ vÃ¦re skrivbar',0),(585702,16270,'da','Mappen skal skrivbar',0),(585703,16270,'ko','ë””ë ‰í„°ë¦¬ ì“°ê¸° ê°€ëŠ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(585704,16270,'he','×ž×“×¨×™×š ×œ×”×™×•×ª × ×™×ª× ×™× ×œ×›×ª×™×‘×”',0),(585705,16270,'el','ÎšÎ±Ï„Î±Î»ÏŒÎ³Î¿Ï… Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ ÎµÎ³Î³ÏÎ¬ÏˆÎ¹Î¼Î¿Ï‚',0),(585706,16270,'zh','ç›®å½•å¿…é¡»æ˜¯å¯å†™',0),(585707,16270,'sv','Katalogen mÃ¥ste vara skrivbar',0),(585708,16270,'it','Directory deve essere scrivibile',0),(585709,16270,'tl','',0),(585710,16270,'th','à¹„à¸”à¹€à¸£à¸à¸—à¸­à¸£à¸µà¸•à¹‰à¸­à¸‡à¹€à¸‚à¸µà¸¢à¸™à¹„à¸”à¹‰',0),(585711,16270,'hi','à¤¨à¤¿à¤°à¥à¤¦à¥‡à¤¶à¤¿à¤•à¤¾ à¤²à¤¿à¤–à¤¨à¥‡ à¤¯à¥‹à¤—à¥à¤¯ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(585712,16270,'ms','Direktori mestilah boleh tulis',0),(585713,16270,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø§Ù„Ø¯Ù„ÙŠÙ„ Ù‚Ø§Ø¨Ù„ Ù„Ù„ÙƒØªØ§Ø¨Ø©',0),(585714,16270,'fr','RÃ©pertoire doit Ãªtre accessible en Ã©criture',0),(585715,16270,'jp','ãƒ‡ã‚£ãƒ¬ã‚¯ãƒˆãƒªãŒæ›¸ãè¾¼ã¿å¯èƒ½ã§ã‚ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(585716,16270,'pt','DiretÃ³rio deve ser gravÃ¡vel',0),(585717,16270,'ru','ÐšÐ°Ñ‚Ð°Ð»Ð¾Ð³ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ñ‹Ð¼ Ð´Ð»Ñ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(585718,16270,'es','Directorio debe ser escribible',0),(585719,16270,'de','Verzeichnis muss beschreibbar sein.',0),(585720,16270,'en','Directory Must Be Writable',0),(585721,16271,'is','',0),(585722,16271,'dr','ØªÙ†Ù‡Ø§ Ø´ØºÙ„ Ø¨Ø§ Ù‡ÛŒÚ† Ø¯Ø±Ø®ÙˆØ§Ø³Øª Replim Ù…ÙˆØ¬ÙˆØ¯',0),(585723,16271,'pr','ØªÙ†Ù‡Ø§ Ø´ØºÙ„ Ø¨Ø§ Ù‡ÛŒÚ† Ø¯Ø±Ø®ÙˆØ§Ø³Øª Replim Ù…ÙˆØ¬ÙˆØ¯',0),(585724,16271,'tr','Sadece iÅŸleri ile varolan Replim isteÄŸi yok',0),(585725,16271,'pl','Tylko zadania z nie istniejÄ…cych Å¼Ä…daÅ„ Replim',0),(585726,16271,'bg','Ð¡Ð°Ð¼Ð¾ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð½ÑÐ¼Ð° ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°Ñ‰Ð¸ Replim Ð¸ÑÐºÐ°Ð½Ð¸Ñ',0),(585727,16271,'ur','ØµØ±Ù Ø±ÙˆØ²Ú¯Ø§Ø± Ú©ÙˆØ¦ÛŒ Ù…ÙˆØ¬ÙˆØ¯Û Ø±ÛŒÙ¾Ù„Ø§Ù… Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÙˆÚº Ú©Û’ Ø³Ø§ØªÚ¾',0),(585728,16271,'sr','Ð¡Ð°Ð¼Ð¾ Ð¿Ð¾ÑÐ»Ð¾Ð²Ðµ ÑÐ° Ð½ÐµÐ¼Ð° Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ðµ Ð·Ð° Ð ÐµÐ¿Ð»Ð¸Ð¼',0),(585729,16271,'vi','Chá»‰ cÃ³ cÃ´ng viá»‡c vá»›i cÃ¡c yÃªu cáº§u Replim hiá»‡n khÃ´ng cÃ³',0),(585730,16271,'af','Slegs werk met geen bestaande Replim versoeke',0),(585731,16271,'ro','Doar de locuri de muncÄƒ cu nici cereri de Replim existente',0),(585732,16271,'et','Ainult tÃ¶id ei ole olemasolevate Replim taotlusi',0),(585733,16271,'si','Le delovna mesta z zahteve ne obstojeÄe Replim',0),(585734,16271,'ba','Hanya pekerjaan dengan tidak ada permintaan Replim',0),(585735,16271,'nl','Alleen taken met geen bestaande Replim aanvragen',0),(585736,16271,'fi','Vain tyÃ¶t, joilla ei ole olemassa Replim esitetty',0),(585737,16271,'no','Bare jobber med ingen eksisterende Replim-forespÃ¸rsler',0),(585738,16271,'da','Kun arbejdspladser med eksisterende Replim anmodninger',0),(585739,16271,'ko','ì—†ëŠ” ê¸°ì¡´ Replim ìš”ì²­ ëœ ìž‘ì—…ë§Œ',0),(585740,16271,'he','×¨×§ ××ª ×”×ž×©×™×ž×•×ª ×¢× ×‘×§×©×•×ª ×”×§×™×™× ××™×Ÿ Replim',0),(585741,16271,'el','ÎœÏŒÎ½Î¿ ÎµÏÎ³Î±ÏƒÎ¯ÎµÏ‚ Î¼Îµ Ï…Ï€Î¬ÏÏ‡Î¿Ï…ÏƒÎµÏ‚ Î±Î¹Ï„Î®ÏƒÎµÎ¹Ï‚ Replim Î´ÎµÎ½',0),(585742,16271,'zh','åªæœ‰å·¥ä½œï¼Œæ²¡æœ‰çŽ°æœ‰çš„ Replim è¯·æ±‚',0),(585743,16271,'sv','Endast jobb med inga befintliga Replim-begÃ¤randen',0),(585744,16271,'it','Solo i lavori senza richieste di Replim esistente',0),(585745,16271,'tl','',0),(585746,16271,'th','à¸‡à¸²à¸™à¹€à¸—à¹ˆà¸²à¸à¸±à¸šà¹„à¸¡à¹ˆà¸¡à¸µà¸„à¸³à¸‚à¸­ Replim à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(585747,16271,'hi','à¤•à¥‹à¤ˆ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ Replim à¤…à¤¨à¥à¤°à¥‹à¤§ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤¹à¥€ à¤¨à¥Œà¤•à¤°à¤¿à¤¯à¥‹à¤‚',0),(585748,16271,'ms','Hanya pekerjaan dengan permintaan Replim sedia ada tidak',0),(585749,16271,'ar','Ø§Ù„ÙˆØ¸Ø§Ø¦Ù ÙÙ‚Ø· Ù…Ø¹ Ù„Ø§ Ø·Ù„Ø¨Ø§Øª Ø±ÙŠØ¨Ù„ÙŠÙ… Ù…ÙˆØ¬ÙˆØ¯Ø©',0),(585750,16271,'fr','Uniquement les projets de pas Replim les demandes existantes',0),(585751,16271,'jp','æ—¢å­˜ Replim è¦æ±‚ã‚’æŒã¤ã‚¸ãƒ§ãƒ–ã®ã¿',0),(585752,16271,'pt','Somente trabalhos com nenhum Replim as solicitaÃ§Ãµes existentes',0),(585753,16271,'ru','Ð¢Ð¾Ð»ÑŒÐºÐ¾ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ Ñ Ð½ÐµÑ‚ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð² Replim',0),(585754,16271,'es','SÃ³lo puestos de trabajo No existentes solicitudes Replim',0),(585755,16271,'de','Nur Jobs mit nicht vorhandenen Replim Anforderungen',0),(585756,16271,'en','Only Jobs With No Existing Prelim Requests',0),(585757,16272,'is','',0),(585758,16272,'dr','Ø¯Ø³ØªÙ‡ Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´ØºÙ„ Prilim',0),(585759,16272,'pr','Ø¯Ø³ØªÙ‡ Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø´ØºÙ„ Prilim',0),(585760,16272,'tr','Toplu gÃ¶nder iÅŸ Prilim kiÅŸi',0),(585761,16272,'pl','Å»Ä…daÅ„ wsadowych wyÅ›lij zadanie Prilim',0),(585762,16272,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Prilim Ð·Ð°Ð¿Ð¸Ñ‚Ð²Ð°Ð½Ð¸Ñ',0),(585763,16272,'ur','Ø¨ÛŒÚ† Ø¨Ú¾ÛŒØ¬Ù†Û’ Ú©Ø§ Ú©Ø§Ù… Ù¾Ø±Ø§Ù„Ø§Ù… Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(585764,16272,'sr','Ð“Ñ€ÑƒÐ¿Ð½Ð¾ ÑÐ»Ð°ÑšÐµ Ð¿Ð¾ÑÐ°Ð¾ ÐŸÑ€Ð¸Ð»Ð¸Ð¼ Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ',0),(585765,16272,'vi','LÃ´ gá»­i cÃ´ng viá»‡c yÃªu cáº§u Prilim',0),(585766,16272,'af','Bondel stuur werk Prilim versoeke',0),(585767,16272,'ro','Lot trimite Job Prilim cereri',0),(585768,16272,'et','Partii saada tÃ¶Ã¶koht Prilim taotlused',0),(585769,16272,'si','Paketno poÅ¡iljanje delo Prilim zahteve',0),(585770,16272,'ba','Batch mengirim pekerjaan Prilim permintaan',0),(585771,16272,'nl','Batch verzenden baan Prilim aanvragen',0),(585772,16272,'fi','ErÃ¤n LÃ¤hetÃ¤ tyÃ¶paikkoja Prilim pyyntÃ¶jÃ¤',0),(585773,16272,'no','Satsvise sende jobben Prilim forespÃ¸rsler',0),(585774,16272,'da','Batch sende Job Prilim anmodninger',0),(585775,16272,'ko','ì¼ê´„ ì²˜ë¦¬ ì†¡ì‹  ìž‘ì—… Prilim ìš”ì²­',0),(585776,16272,'he','××¦×•×•×” ×œ×©×œ×•×— ××ª ×”×¢×‘×•×“×” Prilim ×‘×§×©×•×ª',0),(585777,16272,'el','Î‘Î¹Ï„Î®Î¼Î±Ï„Î± Î³Î¹Î± Î¼Î±Î¶Î¹ÎºÎ® Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÏÎ³Î±ÏƒÎ¯Î± Prilim',0),(585778,16272,'zh','æ‰¹å¤„ç†ä½œä¸šå˜é€Ÿè¯·æ±‚å‘é€',0),(585779,16272,'sv','Batch skicka jobb Prilim Ã¶nskemÃ¥l',0),(585780,16272,'it','Richieste batch invio lavoro Prilim',0),(585781,16272,'tl','',0),(585782,16272,'th','à¸Šà¸¸à¸”à¸ªà¹ˆà¸‡à¸‡à¸²à¸™ Prilim à¸„à¸³à¸£à¹‰à¸­à¸‡à¸‚à¸­',0),(585783,16272,'hi','à¤¬à¥ˆà¤š à¤¨à¥Œà¤•à¤°à¥€ Prilim à¤…à¤¨à¥à¤°à¥‹à¤§ à¤­à¥‡à¤œà¥‡à¤‚',0),(585784,16272,'ms','Kelompok hantar kerja Prilim permintaan',0),(585785,16272,'ar','Ø·Ù„Ø¨Ø§Øª Ø¨Ø±ÙŠÙ„ÙŠÙ… Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø¥Ø±Ø³Ø§Ù„ Ø¯ÙØ¹Ø©',0),(585786,16272,'fr','Lot envoyer demandes de Prilim dâ€™emploi',0),(585787,16272,'jp','ãƒãƒƒãƒé€ä¿¡ã‚¸ãƒ§ãƒ– Prilim è¦æ±‚',0),(585788,16272,'pt','Lote enviar solicitaÃ§Ãµes de Prilim de trabalho',0),(585789,16272,'ru','ÐŸÐ°ÐºÐµÑ‚Ð½Ð¾Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²ÐºÐ¸ Prilim Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð²',0),(585790,16272,'es','Solicitudes de lote enviar trabajo Prilim',0),(585791,16272,'de','Batch Job Prilim Sendeanforderungen',0),(585792,16272,'en','Batch Send Job Prelim Requests',0),(585793,16273,'is','',0),(585794,16273,'dr','Ø§ÛŒÙ…ÛŒÙ„ ÙÚ©Ø³ #',0),(585795,16273,'pr','Ø§ÛŒÙ…ÛŒÙ„ ÙÚ©Ø³ #',0),(585796,16273,'tr','E-posta Faks #',0),(585797,16273,'pl','E-mail nr faksu',0),(585798,16273,'bg','Ð˜Ð¼ÐµÐ¹Ð» Ð¤Ð°ÐºÑ #',0),(585799,16273,'ur','Ø§ÛŒ Ù…ÛŒÙ„ ÙÛŒÚ©Ø³ #',0),(585800,16273,'sr','Ð• -Ð¿Ð¾ÑˆÑ‚Ð° Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑÐ°',0),(585801,16273,'vi','Email Fax #',0),(585802,16273,'af','E-pos Faks #',0),(585803,16273,'ro','E-mail # de Fax',0),(585804,16273,'et','E-posti faksi nr',0),(585805,16273,'si','Email Fax #',0),(585806,16273,'ba','Email Faks #',0),(585807,16273,'nl','E-mail Fax #',0),(585808,16273,'fi','SÃ¤hkÃ¶posti Faksi #',0),(585809,16273,'no','Email faks #',0),(585810,16273,'da','E-mail Fax #',0),(585811,16273,'ko','ì´ë©”ì¼ íŒ©ìŠ¤ #',0),(585812,16273,'he','×“×•× ×œ ×¤×§×¡ #',0),(585813,16273,'el','Î—Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï… ÎÎ¿ Ï†Î±Î¾',0),(585814,16273,'zh','ç”µå­é‚®ä»¶ä¼ çœŸ #',0),(585815,16273,'sv','E-post Fax nr',0),(585816,16273,'it','Email Fax n.',0),(585817,16273,'tl','',0),(585818,16273,'th','à¸­à¸µà¹€à¸¡à¸¥à¹‚à¸—à¸£à¸ªà¸²à¸£#',0),(585819,16273,'hi','à¤ˆà¤®à¥‡à¤² à¤«à¥ˆà¤•à¥à¤¸ #',0),(585820,16273,'ms','E-mel Fax #',0),(585821,16273,'ar','Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø±Ù‚Ù… Ø§Ù„ÙØ§ÙƒØ³',0),(585822,16273,'fr','Courriel No de Fax',0),(585823,16273,'jp','ãƒ¡ãƒ¼ãƒ« Fax ç•ªå·',0),(585824,16273,'pt','E-mail Fax #',0),(585825,16273,'ru','Email Ð¤Ð°ÐºÑ #',0),(585826,16273,'es','Correo electrÃ³nico Fax #',0),(585827,16273,'de','E-Mail Fax #',0),(585828,16273,'en','Email Fax #',0),(585829,16274,'is','',0),(585830,16274,'dr','Ø§Ø±Ø³Ø§Ù„ ØªÙˆØ³Ø·',0),(585831,16274,'pr','Ø§Ø±Ø³Ø§Ù„ ØªÙˆØ³Ø·',0),(585832,16274,'tr','TarafÄ±ndan gÃ¶ndermek',0),(585833,16274,'pl','WyÅ›lij przez',0),(585834,16274,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð¾Ñ‚',0),(585835,16274,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(585836,16274,'sr','Ð¡Ð»Ð°ÑšÐµ Ð¿ÑƒÑ‚ÐµÐ¼',0),(585837,16274,'vi','Gá»­i bá»Ÿi',0),(585838,16274,'af','Stuur deur',0),(585839,16274,'ro','Trimite prin',0),(585840,16274,'et','Teel',0),(585841,16274,'si','PoÅ¡lji z',0),(585842,16274,'ba','Kirim oleh',0),(585843,16274,'nl','Stuur door',0),(585844,16274,'fi','LÃ¤hettÃ¤Ã¤',0),(585845,16274,'no','Sende ved',0),(585846,16274,'da','Send af',0),(585847,16274,'ko','ë³´ë‚´ê¸°',0),(585848,16274,'he','×œ×©×œ×•×— ×‘×“×•××¨',0),(585849,16274,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î±Ï€ÏŒ',0),(585850,16274,'zh','é€šè¿‡å‘é€',0),(585851,16274,'sv','Skicka med',0),(585852,16274,'it','Inviare via',0),(585853,16274,'tl','',0),(585854,16274,'th','à¸ªà¹ˆà¸‡à¹‚à¸”à¸¢',0),(585855,16274,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤­à¥‡à¤œà¥‡à¤‚',0),(585856,16274,'ms','Menghantar melalui',0),(585857,16274,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¨ÙˆØ§Ø³Ø·Ø©',0),(585858,16274,'fr','Envoyer par',0),(585859,16274,'jp','æŠ•ç¨¿ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(585860,16274,'pt','Enviar por',0),(585861,16274,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ',0),(585862,16274,'es','Enviar por',0),(585863,16274,'de','Senden per',0),(585864,16274,'en','Send By',0),(585865,16275,'is','',0),(585866,16275,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Prelim',0),(585867,16275,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Prelim',0),(585868,16275,'tr','Prelim istekleri gÃ¶ndermek',0),(585869,16275,'pl','WysyÅ‚anie Å¼Ä…daÅ„ Prelim',0),(585870,16275,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ñ‚Ðµ Ð¸ÑÐºÐ°Ð½Ð¸Ñ Ð·Ð° Ð¿Ñ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½',0),(585871,16275,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº Ø¨Ú¾ÛŒØ¬',0),(585872,16275,'sr','Ð¨Ð°Ñ™Ðµ Ð¿Ð¾Ð·Ð¸Ð²Ðµ Ð·Ð° ÑƒÐ²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ',0),(585873,16275,'vi','Gá»­i yÃªu cáº§u Prelim',0),(585874,16275,'af','Stuur Prelim versoeke',0),(585875,16275,'ro','Trimite cereri preliminare',0),(585876,16275,'et','Aasta pÃ¤ringuid',0),(585877,16275,'si','PoÅ¡lji zahteve predhodnega',0),(585878,16275,'ba','Mengirim permintaan Prelim',0),(585879,16275,'nl','Kwalificatie-aanvragen verzenden',0),(585880,16275,'fi','Alustava pyyntÃ¶nsÃ¤',0),(585881,16275,'no','Sende Prelim forespÃ¸rsler',0),(585882,16275,'da','Send Prelim anmodninger',0),(585883,16275,'ko','ì˜ˆì„  ìš”ì²­ ë³´ë‚´ê¸°',0),(585884,16275,'he','×œ×©×œ×•×— ×‘×§×©×•×ª ×ž×•×§×“×',0),(585885,16275,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® Î±Î¹Ï„Î®ÏƒÎµÏ‰Î½ Ï€ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(585886,16275,'zh','å‘é€è¯·æ±‚ï¼Œåˆè¯•',0),(585887,16275,'sv','Skicka preliminÃ¤rt Ã¶nskemÃ¥l',0),(585888,16275,'it','Inviare richieste di Prelim',0),(585889,16275,'tl','',0),(585890,16275,'th','à¸ªà¹ˆà¸‡à¸„à¸³à¸‚à¸­ Prelim',0),(585891,16275,'hi','Prelim à¤…à¤¨à¥à¤°à¥‹à¤§ à¤­à¥‡à¤œà¥‡à¤‚',0),(585892,16275,'ms','Menghantar permintaan Prelim',0),(585893,16275,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø·Ù„Ø¨Ø§Øª Prelim',0),(585894,16275,'fr','Envoyer des demandes de Prelim',0),(585895,16275,'jp','äºˆå‚™ã®è¦æ±‚ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(585896,16275,'pt','Enviar solicitaÃ§Ãµes de exame preliminar',0),(585897,16275,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾ÑÑ‹ Prelim',0),(585898,16275,'es','Enviar solicitudes de Prelim',0),(585899,16275,'de','Prelim Anfragen senden',0),(585900,16275,'en','Send Prelim Requests',0),(585901,16276,'is','',0),(585902,16276,'dr','Ø­Ø°Ù ÙØ§Ú©ØªÙˆØ± Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù†',0),(585903,16276,'pr','Ø­Ø°Ù ÙØ§Ú©ØªÙˆØ± Ù…Ø´Ø®Øµ Ø´Ø¯Ù‡ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù†',0),(585904,16276,'tr','Olarak iÅŸaretlenmiÅŸ fatura dÄ±ÅŸlamak',0),(585905,16276,'pl','WykluczyÄ‡ faktur oznaczone jako',0),(585906,16276,'bg','Ð˜Ð·ÐºÐ»ÑŽÑ‡Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸, Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð°Ð½ ÐºÐ°Ñ‚Ð¾',0),(585907,16276,'ur','Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†Ø´Ø§Ù† Ø²Ø¯ ÙˆØ¨Ø¬Ù„ÛŒ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(585908,16276,'sr','Ð˜Ð·ÑƒÐ·Ð¼Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½ ÐºÐ°Ð¾',0),(585909,16276,'vi','Loáº¡i trá»« hÃ³a Ä‘Æ¡n Ä‘Æ°á»£c Ä‘Ã¡nh dáº¥u lÃ ',0),(585910,16276,'af','Sluit fakture gemerk As',0),(585911,16276,'ro','Exclude facturi marcate ca',0),(585912,16276,'et','VÃ¤listada mÃ¤rgitud arved',0),(585913,16276,'si','IzkljuÄi raÄunov, ki so oznaÄeni kot',0),(585914,16276,'ba','Mengecualikan faktur ditandai sebagai',0),(585915,16276,'nl','Uitsluiten van facturen die zijn gemarkeerd als',0),(585916,16276,'fi','JÃ¤ttÃ¤Ã¤ pois laskuista, jotka on merkitty',0),(585917,16276,'no','Utelate fakturaer som er merket som',0),(585918,16276,'da','Udelukke fakturaer markeret som',0),(585919,16276,'ko','ë‹µë³€ìœ¼ë¡œ í‘œì‹œ ë¨ ì²­êµ¬ì„œë¥¼ ì œì™¸',0),(585920,16276,'he','×œ× ×œ×›×œ×•×œ ×—×©×‘×•× ×™×•×ª ×ž×¡×•×ž×Ÿ',0),(585921,16276,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¯Î¿Ï…Î½ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î± Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÏ€Î¹ÏƒÎ·Î¼Î±Î½Î¸ÎµÎ¯ Ï‰Ï‚',0),(585922,16276,'zh','æŽ’é™¤å‘ç¥¨æ ‡è®°ä¸º',0),(585923,16276,'sv','Exkludera fakturor som markerats som',0),(585924,16276,'it','Escludere le fatture contrassegnate come',0),(585925,16276,'tl','',0),(585926,16276,'th','à¹„à¸¡à¹ˆà¸£à¸§à¸¡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸—à¸³à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸›à¹‡à¸™',0),(585927,16276,'hi','à¤›à¥‹à¤¡à¤¼à¤¨à¥‡ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(585928,16276,'ms','Tidak termasuk invois yang ditandakan sebagai',0),(585929,16276,'ar','Ø§Ø³ØªØ¨Ø¹Ø§Ø¯ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªÙŠ ØªÙ… ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø©',0),(585930,16276,'fr','Exclure les factures marquÃ©es comme',0),(585931,16276,'jp','è«‹æ±‚æ›¸ã¨ã—ã¦ãƒžãƒ¼ã‚¯ã‚’é™¤å¤–ã—ã¾ã™ã€‚',0),(585932,16276,'pt','Excluir as facturas marcadas como',0),(585933,16276,'ru','Ð˜ÑÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹, Ð¿Ð¾Ð¼ÐµÑ‡ÐµÐ½Ð½Ñ‹Ðµ ÐºÐ°Ðº',0),(585934,16276,'es','Excluir las facturas marcadas como',0),(585935,16276,'de','SchlieÃŸen Sie Rechnungen als gekennzeichnet aus',0),(585936,16276,'en','Exclude Invoices Marked As',0),(585937,16277,'is','',0),(585938,16277,'dr','Ø±ÙˆØ´ Ø§Ø±Ø¬Ø­',0),(585939,16277,'pr','Ø±ÙˆØ´ Ø§Ø±Ø¬Ø­',0),(585940,16277,'tr','Tercih edilen yÃ¶ntem',0),(585941,16277,'pl','Preferowany sposÃ³b',0),(585942,16277,'bg','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°Ð½ Ð¼ÐµÑ‚Ð¾Ð´',0),(585943,16277,'ur','Ø§ Ø·Ø±ÛŒÙ‚Û',0),(585944,16277,'sr','Ð¥Ñ‚ÐµÐ»Ð° Ð¼ÐµÑ‚Ð¾Ð´',0),(585945,16277,'vi','PhÆ°Æ¡ng phÃ¡p Æ°a thÃ­ch',0),(585946,16277,'af','Prefered metode',0),(585947,16277,'ro','Metoda preferatÄƒ',0),(585948,16277,'et','Eelistatud meetod',0),(585949,16277,'si','Prednostna metoda',0),(585950,16277,'ba','Metode dipilih',0),(585951,16277,'nl','Contactmethode',0),(585952,16277,'fi','Suosituin menetelmÃ¤',0),(585953,16277,'no','Foretrukket metode',0),(585954,16277,'da','Foretrukne metode',0),(585955,16277,'ko','ì„ í˜¸ ë©”ì„œë“œ',0),(585956,16277,'he','×”×©×™×˜×” ×”×ž×•×¢×“×¤×ª',0),(585957,16277,'el','Î ÏÎ¿Ï„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Î¼Î­Î¸Î¿Î´Î¿Ï‚',0),(585958,16277,'zh','é¦–é€‰æ–¹æ³•',0),(585959,16277,'sv','FÃ¶redra',0),(585960,16277,'it','Metodo preferito',0),(585961,16277,'tl','',0),(585962,16277,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸•à¹‰à¸­à¸‡',0),(585963,16277,'hi','à¤ªà¤¸à¤‚à¤¦à¥€à¤¦à¤¾ à¤µà¤¿à¤§à¤¿',0),(585964,16277,'ms','Kaedah Prefered',0),(585965,16277,'ar','Ø§Ù„Ø£Ø³Ù„ÙˆØ¨ Ø§Ù„Ù…ÙØ¶Ù„',0),(585966,16277,'fr','MÃ©thode prÃ©fÃ©rÃ©e',0),(585967,16277,'jp','å¥½ã¾ã—ã„æ–¹æ³•',0),(585968,16277,'pt','MÃ©todo preferido',0),(585969,16277,'ru','ÐŸÑ€ÐµÐ´Ð¿Ð¾Ñ‡Ð¸Ñ‚Ð°ÐµÐ¼Ñ‹Ð¹ Ð¼ÐµÑ‚Ð¾Ð´',0),(585970,16277,'es','MÃ©todo preferido',0),(585971,16277,'de','Bevorzugte Methode',0),(585972,16277,'en','Preferred Method',0),(585973,16278,'is','',0),(585974,16278,'dr','Ø¯Ø³ØªØ±Ø³ÛŒ Ø±Ø¯ Ø´Ø¯',0),(585975,16278,'pr','Ø¯Ø³ØªØ±Ø³ÛŒ Ø±Ø¯ Ø´Ø¯',0),(585976,16278,'tr','EriÅŸim engellendi',0),(585977,16278,'pl','Odmowa dostÄ™pu',0),(585978,16278,'bg','ÐžÑ‚ÐºÐ°Ð·Ð°Ð½ Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(585979,16278,'ur','Ø±Ø³Ø§Ø¦ÛŒ Ù†ÛÛŒÚº Ø¯ÛŒ Ú¯Ø¦ÛŒ',0),(585980,16278,'sr','ÐŸÑ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¾Ð´Ð±Ð¸Ñ˜ÐµÐ½',0),(585981,16278,'vi','Truy cáº­p bá»‹ tá»« chá»‘i',0),(585982,16278,'af','Toegang geweier',0),(585983,16278,'ro','Acces interzis',0),(585984,16278,'et','JuurdepÃ¤Ã¤s keelatud',0),(585985,16278,'si','Dostop zavrnjen',0),(585986,16278,'ba','Akses ditolak',0),(585987,16278,'nl','Toegang geweigerd',0),(585988,16278,'fi','KÃ¤yttÃ¶ estetty',0),(585989,16278,'no','Ingen tilgang',0),(585990,16278,'da','Adgang nÃ¦gtet',0),(585991,16278,'ko','ì•¡ì„¸ìŠ¤ ê±°ë¶€',0),(585992,16278,'he','×”×’×™×©×” × ×“×—×ª×”',0),(585993,16278,'el','Î”ÎµÎ½ ÎµÏ€Î¹Ï„ÏÎ­Ï€ÎµÏ„Î±Î¹ Î· Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·',0),(585994,16278,'zh','è®¿é—®è¢«æ‹’ç»',0),(585995,16278,'sv','Ã…tkomst nekad',0),(585996,16278,'it','Accesso negato',0),(585997,16278,'tl','',0),(585998,16278,'th','à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¸–à¸¹à¸à¸›à¸à¸´à¹€à¸ªà¸˜',0),(585999,16278,'hi','à¤ªà¥à¤°à¤µà¥‡à¤¶ à¤¨à¤¿à¤·à¥‡à¤§',0),(586000,16278,'ms','Capaian ditolak',0),(586001,16278,'ar','ØªÙ… Ø±ÙØ¶ Ø§Ù„ÙˆØµÙˆÙ„',0),(586002,16278,'fr','AccÃ¨s refusÃ©',0),(586003,16278,'jp','ã‚¢ã‚¯ã‚»ã‚¹ãŒæ‹’å¦ã•ã‚Œã¾ã—ãŸ',0),(586004,16278,'pt','Acesso negado',0),(586005,16278,'ru','ÐžÑ‚ÐºÐ°Ð·Ð°Ð½Ð¾ Ð² Ð´Ð¾ÑÑ‚ÑƒÐ¿Ðµ',0),(586006,16278,'es','Acceso denegado',0),(586007,16278,'de','Zugriff verweigert',0),(586008,16278,'en','Access Denied',0),(586009,16279,'is','',0),(586010,16279,'dr','ÙˆØ±ÙˆØ¯ Ø§Ø´ØªØ¨Ø§Ù‡',0),(586011,16279,'pr','ÙˆØ±ÙˆØ¯ Ø§Ø´ØªØ¨Ø§Ù‡',0),(586012,16279,'tr','HatalÄ± oturum aÃ§ma',0),(586013,16279,'pl','Login Incorrect',0),(586014,16279,'bg','Login Ð½ÐµÐ¿Ñ€Ð°Ð²Ð¸Ð»Ð½Ð¾',0),(586015,16279,'ur','Ù„Ø§Ú¯ Ø§Ù† ØºÙ„Ø·',0),(586016,16279,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð° Ñ˜Ðµ Ð½ÐµÐ¸ÑÐ¿Ñ€Ð°Ð²Ð½Ð°',0),(586017,16279,'vi','ÄÄƒng nháº­p khÃ´ng chÃ­nh xÃ¡c',0),(586018,16279,'af','Teken verkeerde',0),(586019,16279,'ro','Login incorecte',0),(586020,16279,'et','Login vale',0),(586021,16279,'si','NapaÄna prijava',0),(586022,16279,'ba','Login salah',0),(586023,16279,'nl','Login Incorrect',0),(586024,16279,'fi','Login virheellinen',0),(586025,16279,'no','Logg feil',0),(586026,16279,'da','Login forkert',0),(586027,16279,'ko','ìž˜ëª» ëœ ë¡œê·¸ì¸',0),(586028,16279,'he','×›× ×™×¡×” ×©×’×•×™',0),(586029,16279,'el','Î•ÏƒÏ†Î±Î»Î¼Î­Î½Î· ÏƒÏÎ½Î´ÎµÏƒÎ·',0),(586030,16279,'zh','ç™»å½•é”™è¯¯',0),(586031,16279,'sv','Logga in felaktiga',0),(586032,16279,'it','Accesso non corretto',0),(586033,16279,'tl','',0),(586034,16279,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(586035,16279,'hi','à¤²à¥‰à¤—à¤¿à¤¨ à¤—à¤¼à¤²à¤¤',0),(586036,16279,'ms','Log masuk yang betul',0),(586037,16279,'ar','ØªØ³Ø¬ÙŠÙ„ Ø¯Ø®ÙˆÙ„ ØºÙŠØ± ØµØ­ÙŠØ­Ø©',0),(586038,16279,'fr','Login Incorrect',0),(586039,16279,'jp','ãƒ­ã‚°ã‚¤ãƒ³ãŒæ­£ã—ãã‚ã‚Šã¾ã›ã‚“ã€‚',0),(586040,16279,'pt','Login incorreto',0),(586041,16279,'ru','ÐÐµÐ²ÐµÑ€Ð½Ñ‹Ð¹ Ð»Ð¾Ð³Ð¸Ð½',0),(586042,16279,'es','Inicio de sesiÃ³n incorrecto',0),(586043,16279,'de','Login falsch',0),(586044,16279,'en','Login Incorrect',0),(586045,16280,'is','',0),(586046,16280,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ¬Ø§Ø±ÛŒ AP',0),(586047,16280,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ¬Ø§Ø±ÛŒ AP',0),(586048,16280,'tr','Ticari AP faturalarÄ±',0),(586049,16280,'pl','Rachunki handlowe AP',0),(586050,16280,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ AP ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(586051,16280,'ur','Ú©Ù…Ø±Ø´Ù„ AP Ø¨Ù„',0),(586052,16280,'sr','ÐšÐ¾Ð¼ÐµÑ€Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ ÐÐŸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(586053,16280,'vi','HÃ³a Ä‘Æ¡n thÆ°Æ¡ng máº¡i AP',0),(586054,16280,'af','KommersiÃ«le GP rekeninge',0),(586055,16280,'ro','Facturile comerciale AP',0),(586056,16280,'et','Kaubanduslik AP arved',0),(586057,16280,'si','Menice komercialni AP',0),(586058,16280,'ba','Komersial AP tagihan',0),(586059,16280,'nl','CommerciÃ«le AP rekeningen',0),(586060,16280,'fi','Kaupallinen AP laskut',0),(586061,16280,'no','Kommersielle AP regninger',0),(586062,16280,'da','Kommercielle AP regninger',0),(586063,16280,'ko','ìƒì—…ì ì¸ AP ì²­êµ¬ì„œ',0),(586064,16280,'he','AP ×ž×¡×—×¨×™ ×©×˜×¨×•×ª',0),(586065,16280,'el','Î•Î¼Ï€Î¿ÏÎ¹ÎºÎ® AP Î”Î—ÎœÎŸÎ£Î™ÎŸÎ¥',0),(586066,16280,'zh','å•†ä¸š AP æ³•æ¡ˆ',0),(586067,16280,'sv','Kommersiella AP rÃ¤kningar',0),(586068,16280,'it','Fatture commerciali AP',0),(586069,16280,'tl','',0),(586070,16280,'th','à¸„à¹ˆà¸² AP à¸žà¸²à¸“à¸´à¸Šà¸¢à¹Œ',0),(586071,16280,'hi','à¤µà¤¾à¤£à¤¿à¤œà¥à¤¯à¤¿à¤• AP à¤¬à¤¿à¤²',0),(586072,16280,'ms','Rang undang-undang komersil AP',0),(586073,16280,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ© ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(586074,16280,'fr','Factures commerciales AP',0),(586075,16280,'jp','AP ã®å•†æ¥­æ‰‹å½¢',0),(586076,16280,'pt','AP comercial de contas',0),(586077,16280,'ru','Ð¡Ñ‡ÐµÑ‚Ð° ÐºÐ¾Ð¼Ð¼ÐµÑ€Ñ‡ÐµÑÐºÐ¸Ñ… AP',0),(586078,16280,'es','Cuentas de comercial AP',0),(586079,16280,'de','Kommerzielle AP Rechnungen',0),(586080,16280,'en','Commercial AP Bills',0),(586081,16281,'is','',0),(586082,16281,'dr','Ø¨Ø±Ø±Ø³ÛŒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ¬Ø§Ø±ÛŒ AP',0),(586083,16281,'pr','Ø¨Ø±Ø±Ø³ÛŒ ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ØªØ¬Ø§Ø±ÛŒ AP',0),(586084,16281,'tr','Ticari AP faturalarÄ± gÃ¶zden geÃ§irin',0),(586085,16281,'pl','Opisz rachunki handlowe AP',0),(586086,16281,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð°Ð¿ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(586087,16281,'ur','Ú©Ù…Ø±Ø´Ù„ AP Ú©Û’ Ø¨Ù„ Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(586088,16281,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ ÐºÐ¾Ð¼ÐµÑ€Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ ÐÐŸ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(586089,16281,'vi','Xem xÃ©t hÃ³a Ä‘Æ¡n thÆ°Æ¡ng máº¡i AP',0),(586090,16281,'af','KommersiÃ«le GP Wetsontwerpe hersien',0),(586091,16281,'ro','Revizuirea facturilor comerciale AP',0),(586092,16281,'et','LÃ¤bi Ã¤ri AP arved',0),(586093,16281,'si','Pregled raÄunov komercialnih AP',0),(586094,16281,'ba','Meninjau tagihan AP komersial',0),(586095,16281,'nl','CommerciÃ«le AP facturen bekijken',0),(586096,16281,'fi','Arvostelu kaupallinen AP laskut',0),(586097,16281,'no','Se gjennom kommersielle AP regninger',0),(586098,16281,'da','Anmeld kommercielle AP regninger',0),(586099,16281,'ko','ìƒì—…ì ì¸ AP ê³„ì‚° ì„œ ê²€í† ',0),(586100,16281,'he','×¡×§×•×¨ ××ª ×”×—×©×‘×•× ×•×ª AP ×ž×¡×—×¨×™',0),(586101,16281,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ ÎµÎ¼Ï€Î¿ÏÎ¹ÎºÎ®Ï‚ AP',0),(586102,16281,'zh','å®¡æŸ¥å•†ä¸š AP æ³•æ¡ˆ',0),(586103,16281,'sv','Granska kommersiella AP rÃ¤kningar',0),(586104,16281,'it','Scrivi una recensione su fatture commerciali AP',0),(586105,16281,'tl','',0),(586106,16281,'th','à¸—à¸šà¸—à¸§à¸™à¸ªà¸¹à¸•à¸£ AP à¸žà¸²à¸“à¸´à¸Šà¸¢à¹Œ',0),(586107,16281,'hi','à¤µà¤¾à¤£à¤¿à¤œà¥à¤¯à¤¿à¤• AP à¤¬à¤¿à¤²à¥‹à¤‚ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾',0),(586108,16281,'ms','Mengkaji semula Rang undang-undang komersil AP',0),(586109,16281,'ar','Ø§Ø³ØªØ¹Ø±Ø§Ø¶ Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ© ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³',0),(586110,16281,'fr','Revoir les factures commerciales AP',0),(586111,16281,'jp','AP ã®å•†æ¥­æ‰‹å½¢ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(586112,16281,'pt','RevisÃ£o de contas comerciais AP',0),(586113,16281,'ru','ÐžÐ±Ð·Ð¾Ñ€ ÐºÐ¾Ð¼Ð¼ÐµÑ€Ñ‡ÐµÑÐºÐ¸Ñ… Ð°Ð¿ Ð²ÐµÐºÑÐµÐ»ÐµÐ¹',0),(586114,16281,'es','Revisar cuentas de comercial AP',0),(586115,16281,'de','Kommerzielle AP Rechnungen Ã¼berprÃ¼fen',0),(586116,16281,'en','Review Commercial AP Bills',0),(586117,16282,'is','',0),(586118,16282,'dr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ AP Ù‡Ø§ÛŒ ØªØ¬Ø§Ø±ÛŒ',0),(586119,16282,'pr','Ø§Ø±Ø³Ø§Ù„ Ø¨Ù‡ AP Ù‡Ø§ÛŒ ØªØ¬Ø§Ø±ÛŒ',0),(586120,16282,'tr','TÃ¼m ticari AP iÃ§in gÃ¶ndermek',0),(586121,16282,'pl','WyÅ›lij wszystkie do komercyjnych AP',0),(586122,16282,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð°Ð¿',0),(586123,16282,'ur','ØªÙ…Ø§Ù… Ú©Ù…Ø±Ø´Ù„ AP Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(586124,16282,'sr','ÐŸÐ¾ÑÐ»Ð°Ñ‚Ð¸ ÐºÐ¾Ð¼ÐµÑ€Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ ÐÐŸ',0),(586125,16282,'vi','Gá»­i táº¥t cáº£ Ä‘á»ƒ thÆ°Æ¡ng máº¡i AP',0),(586126,16282,'af','Stuur alle kommersiÃ«le GP',0),(586127,16282,'ro','Trimite toate pentru AP comerciale',0),(586128,16282,'et','Saada kaubanduslikku AP',0),(586129,16282,'si','PoÅ¡lji vse komercialne AP',0),(586130,16282,'ba','Kirim semua ke AP komersial',0),(586131,16282,'nl','Alles verzenden commerciÃ«le AP',0),(586132,16282,'fi','LÃ¤hetÃ¤ kaikki kaupalliset AP',0),(586133,16282,'no','Sende til kommersielle AP',0),(586134,16282,'da','Send alle til kommercielle AP',0),(586135,16282,'ko','ìƒì—…ì ì¸ AP ëª¨ë‘ ë³´ë‚´ê¸°',0),(586136,16282,'he','×œ×©×œ×•×— ×›×œ AP ×ž×¡×—×¨×™',0),(586137,16282,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ ÏŒÎ»Î¿Ï…Ï‚ ÏƒÎµ ÎµÎ¼Ï€Î¿ÏÎ¹ÎºÎ® AP',0),(586138,16282,'zh','æ‰€æœ‰å‘å•†ä¸š AP å‘é€',0),(586139,16282,'sv','Skicka alla till kommersiella AP',0),(586140,16282,'it','Invia tutto a commerciale AP',0),(586141,16282,'tl','',0),(586142,16282,'th','à¸ªà¹ˆà¸‡à¹„à¸›à¸„à¹‰à¸² AP à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(586143,16282,'hi','à¤¸à¤­à¥€ à¤µà¤¾à¤£à¤¿à¤œà¥à¤¯à¤¿à¤• AP à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œà¥‡à¤‚',0),(586144,16282,'ms','Hantar Semua ke a/Pâ€Ÿ komersil',0),(586145,16282,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„ÙƒÙ„ Ù„Ù„Ø¨Ø±ÙˆØªÙˆÙƒÙˆÙ„ Ø§Ù„ØªØ¬Ø§Ø±ÙŠ',0),(586146,16282,'fr','Envoyer tout Ã  Commercial AP',0),(586147,16282,'jp','ã™ã¹ã¦ã®å•†æ¥­ã® AP ã«é€ä¿¡ã—ã¾ã™ã€‚',0),(586148,16282,'pt','Envie tudo para AP comercial',0),(586149,16282,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð²ÑÐµ ÐºÐ¾Ð¼Ð¼ÐµÑ€Ñ‡ÐµÑÐºÐ¸Ðµ AP',0),(586150,16282,'es','Enviar todo a AP comercial',0),(586151,16282,'de','Senden Sie alles an kommerziellen AP',0),(586152,16282,'en','Send All To Commercial AP',0),(586153,16283,'is','',0),(586154,16283,'dr','Ù„Ø·ÙØ§ Ø§ÛŒÙ† ØµÙØ­Ù‡ Ø±Ø§ ØªØ§Ø²Ù‡ Ù†Ù…Ø§ÛŒÛŒØ¯',0),(586155,16283,'pr','Ù„Ø·ÙØ§ Ø§ÛŒÙ† ØµÙØ­Ù‡ Ø±Ø§ ØªØ§Ø²Ù‡ Ù†Ù…Ø§ÛŒÛŒØ¯',0),(586156,16283,'tr','LÃ¼tfen bu sayfayÄ± yenileyin',0),(586157,16283,'pl','OdÅ›wieÅ¼ TÄ™ stronÄ™',0),(586158,16283,'bg','ÐžÐ±Ð½Ð¾Ð²ÐµÑ‚Ðµ Ñ‚Ð°Ð·Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(586159,16283,'ur','Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ Ø§Ø³ ØµÙØ­Û’ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(586160,16283,'sr','ÐžÑÐ²ÐµÐ¶Ð¸Ñ‚Ðµ Ð¾Ð²Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(586161,16283,'vi','Xin vui lÃ²ng lÃ m má»›i Trang nÃ y',0),(586162,16283,'af','Verfris asseblief die bladsy',0),(586163,16283,'ro','ReÃ®mprospÄƒtaÈ›i aceastÄƒ paginÄƒ',0),(586164,16283,'et','VÃ¤rskendage see leht',0),(586165,16283,'si','OsveÅ¾ite to stran',0),(586166,16283,'ba','Silahkan Refresh Halaman ini',0),(586167,16283,'nl','Vernieuw deze pagina',0),(586168,16283,'fi','PÃ¤ivitÃ¤ tÃ¤mÃ¤ sivu',0),(586169,16283,'no','Oppdater siden',0),(586170,16283,'da','Opdater venligst denne side',0),(586171,16283,'ko','ì´ íŽ˜ì´ì§€ë¥¼ ìƒˆë¡œ ê³ ì¹˜ ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(586172,16283,'he','×× × ×¨×¢× ×Ÿ ××ª ×”×“×£',0),(586173,16283,'el','Î Î±ÏÎ±ÎºÎ±Î»Î¿ÏÎ¼Îµ Î±Î½Î±Î½ÎµÏŽÏƒÏ„Îµ Î±Ï…Ï„Î®Î½ Ï„Î· ÏƒÎµÎ»Î¯Î´Î±',0),(586174,16283,'zh','è¯·åˆ·æ–°æ­¤é¡µé¢',0),(586175,16283,'sv','Uppdatera sidan',0),(586176,16283,'it','Si prega di aggiornare questa pagina',0),(586177,16283,'tl','',0),(586178,16283,'th','à¸à¸£à¸¸à¸“à¸²à¸£à¸µà¹€à¸Ÿà¸£à¸Šà¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(586179,16283,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤‡à¤¸ à¤ªà¥ƒà¤·à¥à¤  à¤•à¥‹ à¤¤à¤¾à¤œà¤¼à¤¾ à¤•à¤°à¥‡à¤‚',0),(586180,16283,'ms','Sila Refresh Laman ini',0),(586181,16283,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ« Ù‡Ø°Ù‡ Ø§Ù„ØµÙØ­Ø©',0),(586182,16283,'fr','Veuillez rafraÃ®chir cette Page',0),(586183,16283,'jp','ã“ã®ãƒšãƒ¼ã‚¸ã‚’æ›´æ–°ã—ã¦ãã ã•ã„ã€‚',0),(586184,16283,'pt','Por favor, atualize esta pÃ¡gina',0),(586185,16283,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚Ðµ ÑÑ‚Ñƒ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñƒ',0),(586186,16283,'es','Por favor actualizar esta pÃ¡gina',0),(586187,16283,'de','Bitte aktualisieren Sie diese Seite',0),(586188,16283,'en','Please Refresh This Page',0),(586189,16284,'is','',0),(586190,16284,'dr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø§ÙØ¸Ù‡ Ù†Ù‡Ø§Ù† ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(586191,16284,'pr','Ú¯Ø²Ø§Ø±Ø´ Ø­Ø§ÙØ¸Ù‡ Ù†Ù‡Ø§Ù† ØªÙ…Ø§Ù… Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(586192,16284,'tr','Rapor Ã¶nbellek sÃ¼resi doldu',0),(586193,16284,'pl','Raport pamiÄ™ci podrÄ™cznej wygasÅ‚',0),(586194,16284,'bg','Ð”Ð¾ÐºÐ»Ð°Ð´ ÐºÐµÑˆ Ðµ Ð¸Ð·Ñ‚ÐµÐºÑŠÐ»',0),(586195,16284,'ur','Ø±Ù¾ÙˆØ±Ù¹ Ú©ÛŒØ³Û Ú©ÛŒ Ù…Ø¯Øª Ø®ØªÙ… ÛÙˆ Ú¯Ø¦ÛŒ ÛÛ’',0),(586196,16284,'sr','Ð˜Ð·Ð²ÐµÑˆÑ‚Ð°Ñ˜ ÐºÐµÑˆ Ñ˜Ðµ Ð¸ÑÑ‚ÐµÐºÐ°Ð¾.',0),(586197,16284,'vi','BÃ¡o cÃ¡o bá»™ nhá»› Cache Ä‘Ã£ háº¿t háº¡n',0),(586198,16284,'af','Verslag kas het verval',0),(586199,16284,'ro','Raport Cache a expirat',0),(586200,16284,'et','Aruande vahemÃ¤lu on aegunud',0),(586201,16284,'si','PoroÄilo je poteklih predmetov v predpomnilniku',0),(586202,16284,'ba','Laporan Cache sudah berakhir',0),(586203,16284,'nl','Verslag Cache is verlopen',0),(586204,16284,'fi','Raportin vÃ¤limuisti on vanhentunut',0),(586205,16284,'no','Rapporten Cache er utlÃ¸pt',0),(586206,16284,'da','BetÃ¦nkningen Cache er udlÃ¸bet',0),(586207,16284,'ko','ë³´ê³ ì„œ ìºì‹œ ë§Œë£Œ',0),(586208,16284,'he','×¤×’ ×ª×•×§×¤×• ×©×œ ×“×•×— ×ž×˜×ž×•×Ÿ',0),(586209,16284,'el','Î‘Î½Î±Ï†Î¿ÏÎ¬ Cache Î­Ï‡ÎµÎ¹ Î»Î®Î¾ÎµÎ¹',0),(586210,16284,'zh','æŠ¥å‘Šç¼“å­˜å·²è¿‡æœŸ',0),(586211,16284,'sv','Rapport-Cache har lÃ¶pt ut',0),(586212,16284,'it','Cache del report Ã¨ scaduto',0),(586213,16284,'tl','',0),(586214,16284,'th','à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¸£à¸²à¸¢à¸‡à¸²à¸™à¹à¸„',0),(586215,16284,'hi','à¤•à¥ˆà¤¶ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹ à¤—à¤ˆ à¤¹à¥ˆ à¤°à¤¿à¤ªà¥‹à¤°à¥à¤Ÿ',0),(586216,16284,'ms','Cache laporan telah tamat tempoh',0),(586217,16284,'ar','Ø§Ù†ØªÙ‡Øª Ù…Ø¯Ø© ØµÙ„Ø§Ø­ÙŠØ© Ø°Ø§ÙƒØ±Ø© Ø§Ù„ØªØ®Ø²ÙŠÙ† Ø§Ù„Ù…Ø¤Ù‚Øª Ù„Ù„ØªÙ‚Ø±ÙŠØ±',0),(586218,16284,'fr','Rapport Cache a expirÃ©',0),(586219,16284,'jp','ãƒ¬ãƒãƒ¼ãƒˆ ã‚­ãƒ£ãƒƒã‚·ãƒ¥ã®æœ‰åŠ¹æœŸé™ãŒåˆ‡ã‚ŒãŸ',0),(586220,16284,'pt','RelatÃ³rio de Cache expirou',0),(586221,16284,'ru','Ð˜ÑÑ‚ÐµÐº ÑÑ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐºÑÑˆÐ° Ð¾Ñ‚Ñ‡ÐµÑ‚Ð¾Ð²',0),(586222,16284,'es','Informe memoria cachÃ© ha caducado',0),(586223,16284,'de','Bericht-Cache ist abgelaufen',0),(586224,16284,'en','Report Cache Has Expired',0),(586225,16285,'is','',0),(586226,16285,'dr','ØªØ§Ø±ÛŒØ®',0),(586227,16285,'pr','ØªØ§Ø±ÛŒØ®',0),(586228,16285,'tr','GÃ¼ncel',0),(586229,16285,'pl','Nieaktualne',0),(586230,16285,'bg','ÐžÑÑ‚Ð°Ñ€ÑÐ»',0),(586231,16285,'ur','ÙØ±Ø³ÙˆØ¯Û',0),(586232,16285,'sr','Ð˜ÑÑ‚ÐµÐºÐ°Ð¾ Ñ€Ð¾Ðº Ñ‚Ñ€Ð°Ñ˜Ð°ÑšÐ°',0),(586233,16285,'vi','Háº¿t háº¡n',0),(586234,16285,'af','Verouderd',0),(586235,16285,'ro','Din data',0),(586236,16285,'et','Aegunud',0),(586237,16285,'si','Zastarela',0),(586238,16285,'ba','Dari tanggal',0),(586239,16285,'nl','Out of Date',0),(586240,16285,'fi','Vanhentunut',0),(586241,16285,'no','Utdatert',0),(586242,16285,'da','ForÃ¦ldet',0),(586243,16285,'ko','ìµœì‹ ',0),(586244,16285,'he','×ž×¢×•×“×›×Ÿ',0),(586245,16285,'el','Î‘Ï€ÏŒ Ï„Î·Î½ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(586246,16285,'zh','å·²è¿‡æœŸ',0),(586247,16285,'sv','Inaktuell',0),(586248,16285,'it','Scaduto',0),(586249,16285,'tl','',0),(586250,16285,'th','à¸ˆà¸²à¸à¸§à¸±à¸™',0),(586251,16285,'hi','à¤ªà¥à¤°à¤¾à¤¨à¤¾',0),(586252,16285,'ms','Lapuk',0),(586253,16285,'ar','Ø§Ù„Ø®Ø±ÙˆØ¬ Ù…Ù† Ø§Ù„ØªØ§Ø±ÙŠØ®',0),(586254,16285,'fr','Mis Ã  jour',0),(586255,16285,'jp','æœŸé™åˆ‡ã‚Œ',0),(586256,16285,'pt','Fora da data',0),(586257,16285,'ru','Ð˜Ð· Ð´Ð°Ñ‚Ñ‹',0),(586258,16285,'es','Fuera de fecha',0),(586259,16285,'de','Veraltet',0),(586260,16285,'en','Out Of Date',0),(586261,16286,'is','',0),(586262,16286,'dr','Ø§Ù†ØªØ¸Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø§Ø±Ø³Ø§Ù„',0),(586263,16286,'pr','Ø§Ù†ØªØ¸Ø§Ø± ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ Ø§Ø±Ø³Ø§Ù„',0),(586264,16286,'tr','FaturalarÄ± gÃ¶ndermek',0),(586265,16286,'pl','WyÅ›lij oczekujÄ…ce rachunki',0),(586266,16286,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð´Ð¾ ÑÐ¼ÐµÑ‚ÐºÐ¸',0),(586267,16286,'ur','Ø§Ø´Ø®Ø§Øµ Ú©Û’ Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø¨Ù„ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(586268,16286,'sr','Ð¡Ð»Ð°ÑšÐµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ Ñ€Ð°Ñ‡ÑƒÐ½Ðµ',0),(586269,16286,'vi','Gá»­i Ä‘ang chá» xá»­ lÃ½ hÃ³a Ä‘Æ¡n',0),(586270,16286,'af','Hangende rekeninge stuur',0),(586271,16286,'ro','Trimite pÃ¢nÄƒ la facturile',0),(586272,16286,'et','Saada kuni arved',0),(586273,16286,'si','PoÅ¡lji ÄakajoÄo menice',0),(586274,16286,'ba','Kirim tertunda tagihan',0),(586275,16286,'nl','Stuur in afwachting van de rekeningen',0),(586276,16286,'fi','LÃ¤hetÃ¤ odottavat laskut',0),(586277,16286,'no','Sende ventende regninger',0),(586278,16286,'da','Send ventende regninger',0),(586279,16286,'ko','ì²­êµ¬ì„œì— ë³´ë¥˜ ì¤‘ì¸ ë³´ë‚´ê¸°',0),(586280,16286,'he','×©×œ×— ×ž×ž×ª×™× ×™× ×©×˜×¨×•×ª',0),(586281,16286,'el','Î‘Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎµÎºÎºÏÎµÎ¼ÏŽÎ½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½',0),(586282,16286,'zh','å‘é€æŒ‚èµ·çš„æ¡ä¾‹è‰æ¡ˆ',0),(586283,16286,'sv','Skicka vÃ¤ntande rÃ¤kningar',0),(586284,16286,'it','Inviare in attesa di bollette',0),(586285,16286,'tl','',0),(586286,16286,'th','à¸ªà¹ˆà¸‡à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(586287,16286,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¬à¤¿à¤² à¤­à¥‡à¤œà¥‡à¤‚',0),(586288,16286,'ms','Menghantar bil-bil yang belum selesai',0),(586289,16286,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ù‚ÙˆØ§Ù†ÙŠÙ† Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(586290,16286,'fr','Envoyer dans lâ€™attente de factures',0),(586291,16286,'jp','ä¿ç•™ä¸­ã®æ³•æ¡ˆã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(586292,16286,'pt','Enviar pendente contas',0),(586293,16286,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð¾Ñ‚Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(586294,16286,'es','Enviar proyectos de ley pendientes',0),(586295,16286,'de','Ausstehende Rechnungen schicken',0),(586296,16286,'en','Send Pending Bills',0),(586297,16287,'is','',0),(586298,16287,'dr','Ø®Ø¨Ø± AP ØªØ¬Ø§Ø±ÛŒ',0),(586299,16287,'pr','Ø®Ø¨Ø± AP ØªØ¬Ø§Ø±ÛŒ',0),(586300,16287,'tr','Ticari AP gÃ¶nderdi',0),(586301,16287,'pl','WysÅ‚ane komercyjnych AP',0),(586302,16287,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð¾ Ð½Ð° Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ Ð°Ð¿',0),(586303,16287,'ur','Ú©Ù…Ø±Ø´Ù„ AP Ø¨Ú¾ÛŒØ¬Ø§',0),(586304,16287,'sr','ÐŸÐ¾ÑÐ»Ð°Ð¾ ÐºÐ¾Ð¼ÐµÑ€Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ ÐÐŸ',0),(586305,16287,'vi','Gá»­i thÆ°Æ¡ng máº¡i AP',0),(586306,16287,'af','KommersiÃ«le GP gestuur',0),(586307,16287,'ro','Trimis comerciale AP',0),(586308,16287,'et','Saata kaubandusliku AP',0),(586309,16287,'si','Poslal komercialne AP',0),(586310,16287,'ba','Dikirim AP komersial',0),(586311,16287,'nl','CommerciÃ«le AP verzonden',0),(586312,16287,'fi','LÃ¤hetetty kaupallinen AP',0),(586313,16287,'no','Sendt kommersielle AP',0),(586314,16287,'da','Sendt kommerciel AP',0),(586315,16287,'ko','ìƒì—…ì ì¸ APë¥¼ ë³´ë‚¸',0),(586316,16287,'he','×©×œ×— AP ×ž×¡×—×¨×™',0),(586317,16287,'el','Î‘Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ ÎµÎ¼Ï€Î¿ÏÎ¹ÎºÎ® AP',0),(586318,16287,'zh','å‘é€å•†ä¸š AP',0),(586319,16287,'sv','Skickas kommersiella AP',0),(586320,16287,'it','Inviato commerciale AP',0),(586321,16287,'tl','',0),(586322,16287,'th','à¸ªà¹ˆà¸‡ AP à¸žà¸²à¸“à¸´à¸Šà¸¢à¹Œ',0),(586323,16287,'hi','à¤µà¤¾à¤£à¤¿à¤œà¥à¤¯à¤¿à¤• AP à¤­à¥‡à¤œà¤¾',0),(586324,16287,'ms','Dihantar AP komersil',0),(586325,16287,'ar','Ø£Ø±Ø³Ù„Øª AP Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ©',0),(586326,16287,'fr','Envoi Commercial AP',0),(586327,16287,'jp','å•†æ¥­ã® AP ã‚’é€ä¿¡',0),(586328,16287,'pt','Enviado AP comercial',0),(586329,16287,'ru','ÐŸÐ¾ÑÐ»Ð°Ð» ÐºÐ¾Ð¼Ð¼ÐµÑ€Ñ‡ÐµÑÐºÐ¸Ñ… AP',0),(586330,16287,'es','Enviado AP comercial',0),(586331,16287,'de','Kommerzielle AP gesendet',0),(586332,16287,'en','Sent Commercial AP',0),(586333,16288,'is','',0),(586334,16288,'dr','Ø¨Ø±Ø±Ø³ÛŒ AP ØªØ¬Ø§Ø±ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÛŒ Ø³ÛŒ',0),(586335,16288,'pr','Ø¨Ø±Ø±Ø³ÛŒ AP ØªØ¬Ø§Ø±ÛŒ Ù¾Ø±Ø¯Ø§Ø®Øª Ø³ÛŒ Ø³ÛŒ',0),(586336,16288,'tr','Ticari AP CC Ã¶demeler gÃ¶zden geÃ§irin',0),(586337,16288,'pl','Opisz komercyjnych AP CC pÅ‚atnoÅ›ci',0),(586338,16288,'bg','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ Ñ‚ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ AP CC Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(586339,16288,'ur','Ú©Ù…Ø±Ø´Ù„ AP CC Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ú©Ø§ Ø¬Ø§Ø¦Ø²Û Ù„ÛŒÚº',0),(586340,16288,'sr','ÐŸÑ€ÐµÐ³Ð»ÐµÐ´ ÐºÐ¾Ð¼ÐµÑ€Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸Ñ… ÐÐŸ Ð¦Ð¦ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(586341,16288,'vi','Xem xÃ©t cÃ¡c khoáº£n thanh toÃ¡n thÆ°Æ¡ng máº¡i AP CC',0),(586342,16288,'af','Hersien kommersiÃ«le GP CC betalings',0),(586343,16288,'ro','Revizuire comerciale AP CC plÄƒÅ£i',0),(586344,16288,'et','Keskmiseks kaubandusliku AP CC maksed',0),(586345,16288,'si','Pregled komercialnih AP CC plaÄila',0),(586346,16288,'ba','Meninjau komersial AP pembayaran kartu kredit',0),(586347,16288,'nl','CommerciÃ«le AP CC betalingen bekijken',0),(586348,16288,'fi','Tarkastella kaupallista AP CC maksuja',0),(586349,16288,'no','Se gjennom kommersielle AP CC betalinger',0),(586350,16288,'da','Anmeld kommercielle AP CC betalinger',0),(586351,16288,'ko','ìƒì—…ì ì¸ AP CC ì§€ë¶ˆ ê²€í† ',0),(586352,16288,'he','×¡×§×™×¨×” AP ×ž×¡×—×¨×™ CC ×ª×©×œ×•×ž×™×',0),(586353,16288,'el','Î‘Î½Î±Î¸ÎµÏŽÏÎ·ÏƒÎ· ÎµÎ¼Ï€Î¿ÏÎ¹ÎºÎ® AP CC Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(586354,16288,'zh','å®¡æŸ¥å•†ä¸š AP æŠ„é€ä»˜æ¬¾',0),(586355,16288,'sv','Granska kommersiella AP CC betalningar',0),(586356,16288,'it','Rivedere i pagamenti CC commerciale AP',0),(586357,16288,'tl','',0),(586358,16288,'th','à¸£à¸µà¸§à¸´à¸§ AP à¸žà¸²à¸“à¸´à¸Šà¸¢à¹Œà¸ªà¸³à¹€à¸™à¸²à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(586359,16288,'hi','à¤µà¤¾à¤£à¤¿à¤œà¥à¤¯à¤¿à¤• AP CC à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥€ à¤¸à¤®à¥€à¤•à¥à¤·à¤¾ à¤•à¤°à¥‡à¤‚',0),(586360,16288,'ms','Menyemak AP komersial CC pembayaran',0),(586361,16288,'ar','Ù…Ø±Ø§Ø¬Ø¹Ø© Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ© ÙˆÙƒØ§Ù„Ø© Ø§Ø³ÙˆØ´ÙŠÙŠØªØ¯ Ø¨Ø±Ø³ Ù†Ø³Ø®Ø©',0),(586362,16288,'fr','Examen Commercial AP CC paiements',0),(586363,16288,'jp','ãƒ¬ãƒ“ãƒ¥ãƒ¼å•†ç”¨ AP CC æ”¯æ‰•ã„',0),(586364,16288,'pt','RevisÃ£o AP comercial CC pagamentos',0),(586365,16288,'ru','ÐžÐ±Ð·Ð¾Ñ€ ÐºÐ¾Ð¼Ð¼ÐµÑ€Ñ‡ÐµÑÐºÐ¸Ñ… AP CC Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(586366,16288,'es','Revisar los pagos de CC comercial AP',0),(586367,16288,'de','Kommerzielle AP CC Zahlungen Ã¼berprÃ¼fen',0),(586368,16288,'en','Review Commercial AP CC Payments',0),(586369,16289,'is','',0),(586370,16289,'dr','Ø§Ø±Ø³Ø§Ù„ ØªÙ…Ø§Ù… Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø³ÛŒ Ø³ÛŒ Ø§Ù†ØªØ¸Ø§Ø±',0),(586371,16289,'pr','Ø§Ø±Ø³Ø§Ù„ ØªÙ…Ø§Ù… Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø³ÛŒ Ø³ÛŒ Ø§Ù†ØªØ¸Ø§Ø±',0),(586372,16289,'tr','TÃ¼m bekleyen Cc Ã¶deme gÃ¶ndermek',0),(586373,16289,'pl','WyÅ›lij wszystkie pÅ‚atnoÅ›ci oczekujÄ…ce Cc',0),(586374,16289,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‚Ð¸ Ð²ÑÐ¸Ñ‡ÐºÐ¸ Ð²Ð¸ÑÑÑ‰Ð¸ Cc Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(586375,16289,'ur','ØªÙ…Ø§Ù… Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Cc Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(586376,16289,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ ÑÐ²Ðµ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð¦Ñ†',0),(586377,16289,'vi','Gá»­i táº¥t cáº£ cÃ¡c khoáº£n thanh toÃ¡n Ä‘ang chá» xá»­ lÃ½ Cc',0),(586378,16289,'af','Stuur alle hangende Cc betalings',0),(586379,16289,'ro','Trimite toate plÄƒÅ£ile Ã®n aÅŸteptare Cc',0),(586380,16289,'et','KÃµik ootel Cc maksete',0),(586381,16289,'si','PoÅ¡lji vse ÄakajoÄe Cc plaÄila',0),(586382,16289,'ba','Kirim semua pembayaran yang tertunda Cc',0),(586383,16289,'nl','Alle wachtende Cc betalingen sturen',0),(586384,16289,'fi','LÃ¤hetÃ¤ kaikki odottavat kopio maksut',0),(586385,16289,'no','Sende alle ventende Cc betalinger',0),(586386,16289,'da','Send alle ventende Cc betalinger',0),(586387,16289,'ko','ëª¨ë“  ë³´ë¥˜ ì¤‘ì¸ Cc ì§€ë¶ˆì„ ë³´ë‚´ê¸°',0),(586388,16289,'he','×©×œ×— ××ª ×›×œ ×”×ª×©×œ×•×ž×™× Cc ×ž×ž×ª×™× ×”',0),(586389,16289,'el','Î£Ï„ÎµÎ¯Î»ÎµÏ„Îµ ÏŒÎ»ÎµÏ‚ Ï„Î¹Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€Î¿Ï… ÎµÎºÎºÏÎµÎ¼Î¿ÏÎ½ Cc',0),(586390,16289,'zh','å‘é€æ‰€æœ‰æŒ‚èµ·çš„ Cc ä»˜æ¬¾',0),(586391,16289,'sv','Skicka alla vÃ¤ntande Cc betalningar',0),(586392,16289,'it','Inviare tutti i pagamenti in sospeso Cc',0),(586393,16289,'tl','',0),(586394,16289,'th','à¸ªà¹ˆà¸‡à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™ Cc à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆà¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(586395,16289,'hi','à¤¸à¤­à¥€ à¤²à¤‚à¤¬à¤¿à¤¤ à¤¸à¥€à¤¸à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤­à¥‡à¤œà¥‡à¤‚',0),(586396,16289,'ms','Menghantar semua Cc belum selesai pembayaran',0),(586397,16289,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¬Ù…ÙŠØ¹ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Cc Ù…Ø¹Ù„Ù‚',0),(586398,16289,'fr','Envoyer tous les paiements en attente Cc',0),(586399,16289,'jp','ã™ã¹ã¦ã®ä¿ç•™ä¸­ã® Cc æ”¯æ‰•ã„ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(586400,16289,'pt','Enviar todos os pagamentos pendentes Cc',0),(586401,16289,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²Ð¸Ñ‚ÑŒ Ð²ÑÐµ Ð¾Ð¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ Cc Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(586402,16289,'es','Enviar todos los pagos pendientes de la Cc',0),(586403,16289,'de','Alle ausstehenden Cc Zahlungen senden',0),(586404,16289,'en','Send All Pending CC Payments',0),(586405,16290,'is','',0),(586406,16290,'dr','Ø§Ø±Ø³Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø³ÛŒ Ø³ÛŒ Ø§Ù†ØªØ¸Ø§Ø±',0),(586407,16290,'pr','Ø§Ø±Ø³Ø§Ù„ Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø³ÛŒ Ø³ÛŒ Ø§Ù†ØªØ¸Ø§Ø±',0),(586408,16290,'tr','Bekleyen Cc Ã¶deme gÃ¶ndermek',0),(586409,16290,'pl','WysyÅ‚anie pÅ‚atnoÅ›ci oczekujÄ…ce Cc',0),(586410,16290,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ñ‡Ð°ÐºÐ°Ñ‰Ð¸ Cc Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(586411,16290,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Cc Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(586412,16290,'sr','Ð¡Ð»Ð°ÑšÐµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ Ð¦Ñ† ÑƒÐ¿Ð»Ð°Ñ‚Ðµ',0),(586413,16290,'vi','Gá»­i cÃ¡c khoáº£n thanh toÃ¡n Ä‘ang chá» xá»­ lÃ½ Cc',0),(586414,16290,'af','Stuur hangende Cc betalings',0),(586415,16290,'ro','Trimite plÄƒÅ£ile Ã®n aÅŸteptare Cc',0),(586416,16290,'et','Ootel Cc maksete',0),(586417,16290,'si','PoÅ¡iljanje ÄakajoÄi Cc plaÄila',0),(586418,16290,'ba','Mengirim pembayaran tertunda Cc',0),(586419,16290,'nl','Hangende Cc betalingen sturen',0),(586420,16290,'fi','LÃ¤hetÃ¤ odottavat Cc maksut',0),(586421,16290,'no','Send ventende Cc betalinger',0),(586422,16290,'da','Send ventende Cc betalinger',0),(586423,16290,'ko','ë³´ë¥˜ ì¤‘ì¸ ì°¸ì¡° ì§€ë¶ˆì„ ë³´ë‚´ê¸°',0),(586424,16290,'he','×©×œ×— Cc ×ž×ž×ª×™× ×•×ª ×ª×©×œ×•×ž×™×',0),(586425,16290,'el','Î£Ï„ÎµÎ¯Î»ÎµÏ„Îµ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± Cc',0),(586426,16290,'zh','å‘é€æŒ‚èµ·æŠ„é€ä»˜æ¬¾',0),(586427,16290,'sv','Skicka vÃ¤ntande Cc betalningar',0),(586428,16290,'it','Inviare i pagamenti in sospeso Cc',0),(586429,16290,'tl','',0),(586430,16290,'th','à¸‹à¸µà¸‹à¸µà¸£à¸­à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(586431,16290,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤¸à¥€à¤¸à¥€ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤­à¥‡à¤œà¥‡à¤‚',0),(586432,16290,'ms','Hantar pembayaran Cc belum selesai',0),(586433,16290,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Cc Ù…Ø¹Ù„Ù‚',0),(586434,16290,'fr','Envoyer des paiements en attente Cc',0),(586435,16290,'jp','ä¿ç•™ä¸­ã® Cc æ”¯æ‰•ã„ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(586436,16290,'pt','Enviar pagamentos pendentes Cc',0),(586437,16290,'ru','ÐžÑ‚Ð¿Ñ€Ð°Ð²ÐºÐ° Ð¿Ð»Ð°Ñ‚ÐµÐ¶ÐµÐ¹ Ð´Ð¾ Cc',0),(586438,16290,'es','Enviar pagos pendiente Cc',0),(586439,16290,'de','Ausstehende Cc Zahlungen senden',0),(586440,16290,'en','Send Pending CC Payments',0),(586441,16291,'is','',0),(586442,16291,'dr','AP ØªØ¬Ø§Ø±ÛŒ',0),(586443,16291,'pr','AP ØªØ¬Ø§Ø±ÛŒ',0),(586444,16291,'tr','Ticari AP',0),(586445,16291,'pl','Komercyjne AP',0),(586446,16291,'bg','Ð¢ÑŠÑ€Ð³Ð¾Ð²ÑÐºÐ¸ AP',0),(586447,16291,'ur','Ú©Ù…Ø±Ø´Ù„ AP',0),(586448,16291,'sr','ÐšÐ¾Ð¼ÐµÑ€Ñ†Ð¸Ñ˜Ð°Ð»Ð½Ð¸ ÐÐŸ',0),(586449,16291,'vi','ThÆ°Æ¡ng máº¡i AP',0),(586450,16291,'af','KommersiÃ«le GP',0),(586451,16291,'ro','AP comerciale',0),(586452,16291,'et','Kaubanduslik AP',0),(586453,16291,'si','Komercialne AP',0),(586454,16291,'ba','AP komersial',0),(586455,16291,'nl','CommerciÃ«le AP',0),(586456,16291,'fi','Kaupallinen AP',0),(586457,16291,'no','Kommersielle AP',0),(586458,16291,'da','Kommercielle AP',0),(586459,16291,'ko','ìƒì—… AP',0),(586460,16291,'he','AP ×ž×¡×—×¨×™',0),(586461,16291,'el','Î•Î¼Ï€Î¿ÏÎ¹ÎºÎ® AP',0),(586462,16291,'zh','å•†ä¸š AP',0),(586463,16291,'sv','Kommersiella AP',0),(586464,16291,'it','Commerciali AP',0),(586465,16291,'tl','',0),(586466,16291,'th','AP à¸žà¸²à¸“à¸´à¸Šà¸¢à¹Œ',0),(586467,16291,'hi','à¤µà¤¾à¤£à¤¿à¤œà¥à¤¯à¤¿à¤• AP',0),(586468,16291,'ms','AP komersil',0),(586469,16291,'ar','AP Ø§Ù„ØªØ¬Ø§Ø±ÙŠØ©',0),(586470,16291,'fr','Commercial AP',0),(586471,16291,'jp','å•†æ¥­ AP',0),(586472,16291,'pt','AP comercial',0),(586473,16291,'ru','ÐšÐ¾Ð¼Ð¼ÐµÑ€Ñ‡ÐµÑÐºÐ°Ñ AP',0),(586474,16291,'es','Comercial AP',0),(586475,16291,'de','Kommerzielle AP',0),(586476,16291,'en','Commercial AP',0),(586477,16292,'is','',0),(586478,16292,'dr','!!!!!!!!!!!!!!!!!!! 1',0),(586479,16292,'pr','!!!!!!!!!!!!!!!!!!! 1',0),(586480,16292,'tr','!!!!!!!!!!!!!!!!!!! 1',0),(586481,16292,'pl','!!!!!!!!!!!!!!!!!!! 1',0),(586482,16292,'bg','!!!!!!!!!!!!!!!!!!! 1',0),(586483,16292,'ur','!!!!!!!!!!!!!!!!!!! 1',0),(586484,16292,'sr','!!!!!!!!!!!!!!!!!!! 1',0),(586485,16292,'vi','!!!!!!!!!!!!!!!!!!! 1',0),(586486,16292,'af','!!!!!!!!!!!!!!!!!!! 1',0),(586487,16292,'ro','!!!!!!!!!!!!!!!!!!! 1',0),(586488,16292,'et','!!!!!!!!!!!!!!!!!!! 1',0),(586489,16292,'si','!!!!!!!!!!!!!!!!!!! 1',0),(586490,16292,'ba','!!!!!!!!!!!!!!!!!!! 1',0),(586491,16292,'nl','!!!!!!!!!!!!!!!!!!! 1',0),(586492,16292,'fi','!!!!!!!!!!!!!!!!!!! 1',0),(586493,16292,'no','!!!!!!!!!!!!!!!!!!! 1',0),(586494,16292,'da','!!!!!!!!!!!!!!!!!!! 1',0),(586495,16292,'ko','!!!!!!!!!!!!!!!!!!! 1',0),(586496,16292,'he','!!!!!!!!!!!!!!!!!!! 1',0),(586497,16292,'el','!!!!!!!!!!!!!!!!!!! 1',0),(586498,16292,'zh','!!!!!!!!!!!!!!!!!!!1',0),(586499,16292,'sv','!!!!!!!!!!!!!!!!!!! 1',0),(586500,16292,'it','!!!!!!!!!!!!!!!!!!! 1',0),(586501,16292,'tl','',0),(586502,16292,'th','!!!!!!!!!!!!!!!!!!! 1',0),(586503,16292,'hi','!!!!!!!!!!!!!!!!!!! 1',0),(586504,16292,'ms','!!!!!!!!!!!!!!!!!!! 1',0),(586505,16292,'ar','!!!!!!!!!!!!!!!!!!! 1',0),(586506,16292,'fr','!!!!!!!!!!!!!!!!!!! 1',0),(586507,16292,'jp','!!!!!!!!!!!!!!!!!!!1',0),(586508,16292,'pt','!!!!!!!!!!!!!!!!!!! 1',0),(586509,16292,'ru','!!!!!!!!!!!!!!!!!!! 1',0),(586510,16292,'es','!!!!!!!!!!!!!!!!!!! 1',0),(586511,16292,'de','!!!!!!!!!!!!!!!!!!! 1',0),(586512,16292,'en','Commercial AP',0),(586513,16293,'is','',0),(586514,16293,'dr','Ø®Ø±ÛŒØ¯ Ø§ÛŒÙ…ÛŒÙ„ Ø³ÙØ§Ø±Ø´ Ù‚Ø§Ù„Ø¨',0),(586515,16293,'pr','Ø®Ø±ÛŒØ¯ Ø§ÛŒÙ…ÛŒÙ„ Ø³ÙØ§Ø±Ø´ Ù‚Ø§Ù„Ø¨',0),(586516,16293,'tr','SatÄ±n alma sipariÅŸi e-posta ÅŸablonu',0),(586517,16293,'pl','Szablon wiadomoÅ›ci E-mail zamÃ³wienia zakupu',0),(586518,16293,'bg','Ð¨Ð°Ð±Ð»Ð¾Ð½ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð» Ð·Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ°',0),(586519,16293,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ø§ÛŒ Ù…ÛŒÙ„ Ø³Ø§Ù†Ú†Û’',0),(586520,16293,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶Ð°Ðº Ðµ-Ð¿Ð¾ÑˆÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð°Ð±Ð°Ð²ÐºÐµ',0),(586521,16293,'vi','Mua hÃ ng Ä‘áº·t hÃ ng Email máº«u',0),(586522,16293,'af','Aankoop orde e-pos sjabloon',0),(586523,16293,'ro','ComandÄƒ cumpÄƒrare E-mail ÅŸablon',0),(586524,16293,'et','Ostu tellimuse meilisÃµnumimallid',0),(586525,16293,'si','NaroÄilo e-poÅ¡te',0),(586526,16293,'ba','Template Email Order Pembelian',0),(586527,16293,'nl','Aankoop Order e-mailtemplate',0),(586528,16293,'fi','Tilauksen sÃ¤hkÃ¶posti mallin',0),(586529,16293,'no','KjÃ¸p rekkefÃ¸lge e-mal',0),(586530,16293,'da','KÃ¸b Bestil E-mail-skabelon',0),(586531,16293,'ko','êµ¬ë§¤ ì£¼ë¬¸ ì´ë©”ì¼ í…œí”Œë¦¿',0),(586532,16293,'he','×ª×‘× ×™×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™ ×¨×›×™×©×”',0),(586533,16293,'el','Î ÏÏŒÏ„Ï…Ï€Î¿ Email Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î±Î³Î¿ÏÎ¬Ï‚',0),(586534,16293,'zh','é‡‡è´­è®¢å•çš„ç”µå­é‚®ä»¶æ¨¡æ¿',0),(586535,16293,'sv','InkÃ¶p Order e-postmall',0),(586536,16293,'it','Ordine di acquisto modello di Email',0),(586537,16293,'tl','',0),(586538,16293,'th','à¹à¸¡à¹ˆà¹à¸šà¸šà¸­à¸µà¹€à¸¡à¸¥à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(586539,16293,'hi','à¤–à¤°à¥€à¤¦ à¤†à¤¦à¥‡à¤¶ à¤ˆ-à¤®à¥‡à¤² à¤Ÿà¥‡à¤®à¥à¤ªà¤²à¥‡à¤Ÿ',0),(586540,16293,'ms','Pembelian perintah Template e-mel',0),(586541,16293,'ar','Ù‚Ø§Ù„Ø¨ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø£Ù…Ø± Ø§Ù„Ø´Ø±Ø§Ø¡',0),(586542,16293,'fr','Achat ordre modÃ¨le dâ€™E-mail',0),(586543,16293,'jp','è³¼å…¥æ³¨æ–‡ãƒ¡ãƒ¼ãƒ« ãƒ†ãƒ³ãƒ—ãƒ¬ãƒ¼ãƒˆ',0),(586544,16293,'pt','Modelo de E-mail de ordem de compra',0),(586545,16293,'ru','Ð¨Ð°Ð±Ð»Ð¾Ð½ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹ Ð·Ð°ÐºÐ°Ð·Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸',0),(586546,16293,'es','Plantilla de correo electrÃ³nico de orden de compra',0),(586547,16293,'de','Bestellung e-Mail-Vorlage',0),(586548,16293,'en','Purchase Order Email Template',0),(586549,16294,'is','',0),(586550,16294,'dr','Ù¾Ø³Øª Ù‡Ø§',0),(586551,16294,'pr','Ù¾Ø³Øª Ù‡Ø§',0),(586552,16294,'tr','GiriÅŸlerini deftere nakletmek',0),(586553,16294,'pl','KsiÄ™gowania zapisÃ³w',0),(586554,16294,'bg','ÐžÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(586555,16294,'ur','Ù¾ÙˆØ³Ù¹ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(586556,16294,'sr','ÐšÑšÐ¸Ð¶ÐµÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(586557,16294,'vi','BÃ i má»¥c',0),(586558,16294,'af','Pos-inskrywings',0),(586559,16294,'ro','Postarea intrÄƒrilor',0),(586560,16294,'et','Postitage oma vÃµistlustÃ¶Ã¶d',0),(586561,16294,'si','Objava vnosov',0),(586562,16294,'ba','Mengirim entri',0),(586563,16294,'nl','Posten',0),(586564,16294,'fi','Tapahtumien kirjaaminen',0),(586565,16294,'no','BokfÃ¸re',0),(586566,16294,'da','BogfÃ¸re poster',0),(586567,16294,'ko','ê²Œì‹œë¬¼ í•­ëª©',0),(586568,16294,'he','×¢×¨×›×™ ×¤×•×¡×˜',0),(586569,16294,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(586570,16294,'zh','è¿‡å¸æ¡ç›®',0),(586571,16294,'sv','BokfÃ¶ra transaktioner',0),(586572,16294,'it','Registrare i movimenti',0),(586573,16294,'tl','',0),(586574,16294,'th','à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(586575,16294,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚',0),(586576,16294,'ms','Menghantar penyertaan',0),(586577,16294,'ar','Ø¢Ø®Ø± Ø¥Ø¯Ø®Ø§Ù„Ø§Øª',0),(586578,16294,'fr','Valider les Ã©critures',0),(586579,16294,'jp','ã‚¨ãƒ³ãƒˆãƒªã‚’æŠ•ç¨¿ã—ã¾ã™ã€‚',0),(586580,16294,'pt','Entradas de correio',0),(586581,16294,'ru','ÐžÐ¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(586582,16294,'es','Entradas de post',0),(586583,16294,'de','EintrÃ¤ge',0),(586584,16294,'en','Post Entries',0),(586585,16295,'is','',0),(586586,16295,'dr','Ù¾ÛŒØ´ ÙØ±Ø¶ GL ÙˆØ§Ø±Ø¯ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ø±Ø³Ø§Ù„',0),(586587,16295,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ GL ÙˆØ§Ø±Ø¯ Ù…Ø¹Ø§Ù…Ù„Ø§Øª Ø§Ø±Ø³Ø§Ù„',0),(586588,16295,'tr','Ä°Ã§e aktarÄ±lan GL hareketleri deftere nakil varsayÄ±lan',0),(586589,16295,'pl','DomyÅ›lnie importowane GL transakcji ksiÄ™gowania',0),(586590,16295,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ð¸Ñ‚Ðµ GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¸Ñ‚Ðµ Ð·Ð° Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÑÐ²Ð°Ð½Ðµ',0),(586591,16295,'ur','Ù¾ÙˆØ³Ù¹Ù†Ú¯ Ø¯Ø±Ø¢Ù…Ø¯ Ø¬ÛŒØ¬Û’ Ù„ÛŒÙ† Ø¯ÛŒÙ† Ø·Û’ Ø´Ø¯Û',0),(586592,16295,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ ÑƒÐ²ÐµÐ·ÐµÐ½Ðµ Ð“Ð› Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ ÐºÑšÐ¸Ð¶ÐµÑšÐ°',0),(586593,16295,'vi','Máº·c Ä‘á»‹nh giao dá»‹ch nháº­p kháº©u GL gá»­i bÃ i',0),(586594,16295,'af','Verstek ingevoerde GL transaksies plaas',0),(586595,16295,'ro','Implicit importate GL tranzacÅ£ii posta',0),(586596,16295,'et','Vaikimisi imporditud GL tehingute konteerimine',0),(586597,16295,'si','Privzeto uvoÅ¾eno GL transakcije objavljate',0),(586598,16295,'ba','Standar transaksi impor GL Posting',0),(586599,16295,'nl','Standaard geÃ¯mporteerde GL transacties boeken',0),(586600,16295,'fi','Oletus tuodut GL tapahtumien kirjaaminen',0),(586601,16295,'no','Standard importerte GL transaksjoner postering',0),(586602,16295,'da','Standard importerede GL transaktioner udstationering',0),(586603,16295,'ko','ê°€ì ¸ì˜¨ëœ GL íŠ¸ëžœìž­ì…˜ì„ ê²Œì‹œ ê¸°ë³¸',0),(586604,16295,'he','×‘×¨×™×¨×ª ×ž×—×“×œ GL ×ž×™×•×‘××™× ×¢×¡×§××•×ª ×¤×¨×¡×•×',0),(586605,16295,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· ÎµÎ¹ÏƒÎ±Î³ÏŒÎ¼ÎµÎ½Î± GL ÏƒÏ…Î½Î±Î»Î»Î±Î³Î­Ï‚ Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ·',0),(586606,16295,'zh','é»˜è®¤å¯¼å…¥çš„æ€»å¸äº¤æ˜“è®°å½•è¿‡å¸',0),(586607,16295,'sv','Standard importerade GL transaktioner bokfÃ¶ring',0),(586608,16295,'it','Transazioni di contabilitÃ  generale importati distacco di default',0),(586609,16295,'tl','',0),(586610,16295,'th','à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸™à¸³à¹€à¸‚à¹‰à¸² GL à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸—à¸µà¹ˆà¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µ',0),(586611,16295,'hi','à¤†à¤¯à¤¾à¤¤à¤¿à¤¤ GL à¤²à¥‡à¤¨-à¤¦à¥‡à¤¨ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ',0),(586612,16295,'ms','Lalai transaksi import GL Posting',0),(586613,16295,'ar','Ø§ÙØªØ±Ø§Ø¶ÙŠ Ø§Ù„Ù…Ø¹Ø§Ù…Ù„Ø§Øª GL Ø§Ù„Ù…Ø³ØªÙˆØ±Ø¯Ø© Ø§Ù„ØªØ±Ø­ÙŠÙ„',0),(586614,16295,'fr','Par dÃ©faut le comptable des Transactions importÃ©es GL',0),(586615,16295,'jp','æ—¢å®šã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆã® GL ãƒˆãƒ©ãƒ³ã‚¶ã‚¯ã‚·ãƒ§ãƒ³ã®è»¢è¨˜',0),(586616,16295,'pt','PadrÃ£o de transaÃ§Ãµes de GL importado postando',0),(586617,16295,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ GL Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ð¹ Ð¿Ñ€Ð¾Ð²Ð¾Ð´ÐºÐ¸',0),(586618,16295,'es','Predeterminado de la transacciones GL importado publicar',0),(586619,16295,'de','StandardmÃ¤ÃŸig importiert GL Transaktionen buchen',0),(586620,16295,'en','Default Imported GL Transactions Posting',0),(586621,16296,'is','',0),(586622,16296,'dr','ØºÛŒØ± ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(586623,16296,'pr','ØºÛŒØ± ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(586624,16296,'tr','Otomatik mesaj devre dÄ±ÅŸÄ± bÄ±rakma',0),(586625,16296,'pl','UczyniÄ‡ kalekÄ… Auto Post',0),(586626,16296,'bg','Ð—Ð°Ð±Ñ€Ð°Ð½ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾Ñ‚Ð¾ Ð¿Ð¾ÑÑ‚',0),(586627,16296,'ur','Ø®ÙˆØ¯ Ú©Ø§Ø± Ù¾ÙˆØ³Ù¹ Ù†Ø§Ø§ÛÙ„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(586628,16296,'sr','ÐžÐ½ÐµÐ¼Ð¾Ð³ÑƒÑ›Ð¸ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ ÐºÑšÐ¸Ð¶ÐµÑšÐµ',0),(586629,16296,'vi','VÃ´ hiá»‡u hoÃ¡ tá»± Ä‘á»™ng Ä‘Äƒng bÃ i',0),(586630,16296,'af','Deaktiveer Outo Post',0),(586631,16296,'ro','Nu fi de acord Auto Post',0),(586632,16296,'et','Keela automaatne Post',0),(586633,16296,'si','Onesposobiti avto Post',0),(586634,16296,'ba','Menonaktifkan Auto posting',0),(586635,16296,'nl','Auto Post uitschakelen',0),(586636,16296,'fi','TehdÃ¤ kykenemÃ¤ttÃ¶mÃ¤ksi Auto Post',0),(586637,16296,'no','Deaktivere Auto Post',0),(586638,16296,'da','Deaktivere Auto Post',0),(586639,16296,'ko','ìžë™ ê²Œì‹œë¬¼ì„ ì‚¬ìš© í•˜ì§€ ì•Šë„ë¡ ì„¤ì •',0),(586640,16296,'he','×‘×˜×œ ×”×•×“×¢×” ××•×˜×•×ž×˜×™×ª',0),(586641,16296,'el','Î‘Ï€ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Î´Î·Î¼Î¿ÏƒÎ¯ÎµÏ…ÏƒÎ·',0),(586642,16296,'zh','ç¦ç”¨è‡ªåŠ¨å…¬å‘Š',0),(586643,16296,'sv','Inaktivera Auto Post',0),(586644,16296,'it','Disattivare Auto Post',0),(586645,16296,'tl','',0),(586646,16296,'th','à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸à¸²à¸£à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(586647,16296,'hi','à¤¸à¥à¤µà¤¤à¤ƒ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤•à¥‹ à¤…à¤•à¥à¤·à¤® à¤•à¤°à¥‡à¤‚',0),(586648,16296,'ms','Menyahdayakan Auto Post',0),(586649,16296,'ar','ØªØ¹Ø·ÙŠÙ„ ÙˆØ¸ÙŠÙØ© Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(586650,16296,'fr','DÃ©sactiver lâ€™Auto Post',0),(586651,16296,'jp','è‡ªå‹•æŠ•ç¨¿ã‚’ç„¡åŠ¹ã«ã—ã¾ã™ã€‚',0),(586652,16296,'pt','Desativar Auto posto',0),(586653,16296,'ru','ÐžÑ‚ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(586654,16296,'es','Desactivar Auto Post',0),(586655,16296,'de','Deaktivieren Sie automatische Nachricht',0),(586656,16296,'en','Disable Auto Post',0),(586657,16297,'is','',0),(586658,16297,'dr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(586659,16297,'pr','ÙØ¹Ø§Ù„ Ú©Ø±Ø¯Ù† Ø§Ø±Ø³Ø§Ù„ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(586660,16297,'tr','Otomatik yazÄ± etkinleÅŸtirmek',0),(586661,16297,'pl','WÅ‚Ä…cz automatyczne Post',0),(586662,16297,'bg','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸ Ð°Ð²Ñ‚Ð¾ Ð¿Ð¾ÑÑ‚',0),(586663,16297,'ur','Ø®ÙˆØ¯ Ú©Ø§Ø± Ù¾ÙˆØ³Ù¹ Ø§ÛÙ„ Ø¨Ù†Ø§Ø¦ÛŒÚº',0),(586664,16297,'sr','ÐžÐ¼Ð¾Ð³ÑƒÑ›Ð¸ Ð°ÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ ÐºÑšÐ¸Ð¶ÐµÑšÐµ',0),(586665,16297,'vi','Sá»­ Ä‘Äƒng bÃ i tá»± Ä‘á»™ng',0),(586666,16297,'af','Ontsper outomatiese Post',0),(586667,16297,'ro','Activare Auto Post',0),(586668,16297,'et','Lubade kasutada Auto posti programmi',0),(586669,16297,'si','Usposobiti avto Post',0),(586670,16297,'ba','Mengaktifkan Auto posting',0),(586671,16297,'nl','Auto Post inschakelen',0),(586672,16297,'fi','Ota Auto Post',0),(586673,16297,'no','Aktiver Auto Post',0),(586674,16297,'da','Aktivere automatisk indlÃ¦g',0),(586675,16297,'ko','ìžë™ ê²Œì‹œ ì„¤ì •',0),(586676,16297,'he','×”×¤×¢×œ ××•×˜×•×ž×˜×™×ª ×¤×•×¡×˜',0),(586677,16297,'el','Î•Î½ÎµÏÎ³Î¿Ï€Î¿Î¹Î®ÏƒÎµÏ„Îµ Ï„Î·Î½ Î±Ï…Ï„ÏŒÎ¼Î±Ï„Î· Î´Î·Î¼Î¿ÏƒÎ¯ÎµÏ…ÏƒÎ·',0),(586678,16297,'zh','å¯ç”¨è‡ªåŠ¨å…¬å‘Š',0),(586679,16297,'sv','Aktivera Auto Post',0),(586680,16297,'it','Attivare Auto Post',0),(586681,16297,'tl','',0),(586682,16297,'th','à¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸à¸²à¸£à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(586683,16297,'hi','à¤¸à¥à¤µà¤¤à¤ƒ à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¸à¤•à¥à¤·à¤® à¤•à¤°à¥‡à¤‚',0),(586684,16297,'ms','Mengaktifkan Auto Post',0),(586685,16297,'ar','ØªÙ…ÙƒÙŠÙ† ÙˆØ¸ÙŠÙØ© Ø§Ù„ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(586686,16297,'fr','Activez Auto Post',0),(586687,16297,'jp','è‡ªå‹•æŠ•ç¨¿ã‚’æœ‰åŠ¹ã«ã—ã¾ã™ã€‚',0),(586688,16297,'pt','Ativar Auto posto',0),(586689,16297,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ ÑÐ¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ',0),(586690,16297,'es','Activar Auto Post',0),(586691,16297,'de','Aktivieren Sie automatische Nachricht',0),(586692,16297,'en','Enable Auto Post',0),(586693,16301,'en','Invalid Password',0),(586694,16298,'en','No Statement Available',0),(586695,16299,'en','Product Info',0),(586696,16300,'en','Product Sheet',0),(586697,16302,'en','Set A New Password',0),(586698,16348,'en','Additional Line Items In The Same Invoice Only Need The Customer ID Or Customer Code Or Company Name Or First And Last Name And The Invoice Number',0),(586699,16314,'en','Any Value',0),(586700,16331,'en','AP Closed',0),(586701,16332,'en','AR Closed',0),(586702,16310,'en','A Job With This Code Already Exists',0),(586703,16351,'en','A Job With This Name Already Exists',0),(586704,16352,'en','A Job For This Customer Already Exists',0),(586705,16353,'en','A Job With This Project Number Already Exists',0),(586706,16354,'en','A Job With This Address Already Exists',0),(586707,16326,'en','Billing Postal Code If No Ship To',0),(586708,16342,'en','Blocked Modules',0),(586709,16307,'en','Break Out By Cost Code',0),(586710,16308,'en','Break Out By GL Category',0),(586711,16303,'en','Customer Or Job Must Be Set',0),(586712,16333,'en','Direct GL Closed',0),(586713,16304,'en','Does Not Match Customer',0),(586714,16315,'en','False',0),(586715,16316,'en','First & Last Name',0),(586716,16338,'en','Generated Successfully',0),(586717,16337,'en','Generate Now',0),(586718,16309,'en','Generate Recurring Entries',0),(586719,16359,'en','Generate Recurring Ledger Entries',0),(586720,16339,'en','Generate Reverse Entry',0),(586721,16305,'en','Import Information',0),(586722,16313,'en','Import Invoice Changes',0),(586723,16306,'en','Import Invoice, Customer & Job Changes',0),(586724,16334,'en','Inventory Closed',0),(586725,16355,'en','Job Closed Date',0),(586726,16340,'en','Last Date Generated',0),(586727,16341,'en','Last Transaction Date',0),(586728,16356,'en','Lattitude',0),(586729,16357,'en','Longitude',0),(586730,16311,'en','Multiple Entries Can Be Separated With Commas',0),(586731,16349,'en','Must Have A Customer ID Or Customer Code Or Company Name Or First And Last Name',0),(586732,16345,'en','Must Have A Vendor ID Or Vendor Code Or Vendor Name',0),(586733,16350,'en','Must Have Invoice Number And Customer ID Or Customer Code Or Company Name Or First And Last Name',0),(586734,16346,'en','Must Have Invoice Number And Vendor ID Or Vendor Code Or Vendor Name And Amount And Valid Account Number',0),(586735,16347,'en','Needs To Be A Code',0),(586736,16330,'en','No Value Selected',0),(586737,16317,'en','Number Expected',0),(586738,16360,'en','Over PHP Max Input Vars',0),(586739,16335,'en','Partially Closed',0),(586740,16323,'en','Pay Date',0),(586741,16336,'en','Payroll Closed',0),(586742,16361,'en','Please Enter A Value For',0),(586743,16325,'en','PO Receipts On This Bill',0),(586744,16358,'en','Prelimable Date',0),(586745,16312,'en','Required And Must Be Unique',0),(586746,16322,'en','Send Email Notices When Bill Approved',0),(586747,16327,'en','Ship To Postal Code',0),(586748,16318,'en','Show More',0),(586749,16319,'en','Show State List',0),(586750,16329,'en','Sort By Zip Code',0),(586751,16328,'en','Show Ship To Postal Code',0),(586752,16320,'en','True',0),(586753,16343,'en','Unable To Unpost Vouchers',0),(586754,16324,'en','Vendor Bills Have Been Approved For Payment',0),(586755,16344,'en','Vouchers Unposted OK',0),(586756,16321,'en','You Must Select A GL Account Or Cost Code Or GL Category',0),(586757,16363,'en','A Job For This Customer Already Exists',0),(586758,16364,'en','A Job With This Address Already Exists',0),(586759,16365,'en','A Job With This Code Already Exists',0),(586760,16366,'en','A Job With This Name Already Exists',0),(586761,16362,'en','Show Ship To Postal Code',0),(586763,16298,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ø¨ÙŠØ§Ù† Ù…ØªØ§Ø­',0),(586764,16299,'ar','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø§Ù„Ù…Ù†ØªØ¬',0),(586765,16300,'ar','ÙˆØ±Ù‚Ø© Ø§Ù„Ù…Ù†ØªØ¬',0),(586766,16301,'ar','ÙƒÙ„Ù…Ø© Ø§Ù„Ù…Ø±ÙˆØ± ØºÙŠØ± ØµØ§Ù„Ø­Ø©',0),(586767,16302,'ar','ØªØ¹ÙŠÙŠÙ† ÙƒÙ„Ù…Ø© Ù…Ø±ÙˆØ± Ø¬Ø¯ÙŠØ¯Ø©',0),(586768,16303,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(586769,16304,'ar','Ù„Ø§ ÙŠØªØ·Ø§Ø¨Ù‚ Ù…Ø¹ Ø§Ù„Ø¹Ù…Ù„Ø§Ø¡',0),(586770,16305,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(586771,16306,'ar','Ø§Ù„Ø¹Ù…ÙŠÙ„ ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯ ÙˆØ§Ù„ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù„Ù…Ù‡Ù…Ø©',0),(586772,16307,'ar','ØªÙ†Ø¯Ù„Ø¹ Ø¨Ø±Ù…Ø² Ø§Ù„ØªÙƒÙ„ÙØ©',0),(586773,16308,'ar','Ø§Ù„Ø®Ø±ÙˆØ¬ Ù…Ù† ÙØ¦Ø© Ø¬ÙŠ Ø§Ù„',0),(586774,16309,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ù…ØªÙƒØ±Ø±Ø©',0),(586775,16310,'ar','Ù…Ù‡Ù…Ø© Ù…Ø¹ Ù‡Ø°Ù‡ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø© Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ù…ÙˆØ¬ÙˆØ¯Ø© Ø¨Ø§Ù„ÙØ¹Ù„',0),(586776,16311,'ar','ÙŠÙ…ÙƒÙ† ÙØµÙ„ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø§Ù„Ù…ØªØ¹Ø¯Ø¯Ø© Ø¨ÙÙˆØ§ØµÙ„',0),(586777,16312,'ar','Ø§Ù„Ù…Ø·Ù„ÙˆØ¨Ø©ØŒ ÙˆÙŠØ¬Ø¨ Ø£Ù† ØªÙƒÙˆÙ† ÙØ±ÙŠØ¯Ø© Ù…Ù† Ù†ÙˆØ¹Ù‡Ø§',0),(586778,16313,'ar','Ø§Ù„ØªØºÙŠÙŠØ±Ø§Øª ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ø§Ø³ØªÙŠØ±Ø§Ø¯',0),(586779,16314,'ar','Ø£ÙŠ Ù‚ÙŠÙ…Ø©',0),(586780,16315,'ar','ÙƒØ§Ø°Ø¨Ø©',0),(586781,16316,'ar','Ø§Ù„Ø§Ø³Ù… Ø§Ù„Ø£ÙˆÙ„ Ø¢Ù†Ø¯ Ø§Ù„Ù…Ø§Ø¶ÙŠ',0),(586782,16317,'ar','Ø§Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ù…ØªÙˆÙ‚Ø¹',0),(586783,16318,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù…Ø²ÙŠØ¯',0),(586784,16319,'ar','Ù‚Ø§Ø¦Ù…Ø© Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø¯ÙˆÙ„Ø©',0),(586785,16320,'ar','ØµØ­ÙŠØ­',0),(586786,16321,'ar','ÙŠØ¬Ø¨ ØªØ­Ø¯ÙŠØ¯ Ø­Ø³Ø§Ø¨ GL Ø£Ùˆ ÙƒÙˆØ¯ Ø§Ù„ØªÙƒÙ„ÙØ© Ø£Ùˆ ÙØ¦Ø© GL',0),(586787,16322,'ar','Ø¥Ø±Ø³Ø§Ù„ Ø¥Ø´Ø¹Ø§Ø±Ø§Øª Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø¹Ù†Ø¯ Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ†',0),(586788,16323,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø¯ÙØ¹',0),(586789,16324,'ar','ØªÙ…Øª Ø§Ù„Ù…ÙˆØ§ÙÙ‚Ø© Ø¹Ù„Ù‰ Ø¯ÙØ¹ ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙˆØ±Ø¯',0),(586790,16325,'ar','Øµ. Ø¨ Ø¥ÙŠØµØ§Ù„Ø§Øª Ø¹Ù„Ù‰ Ù…Ø´Ø±ÙˆØ¹ Ø§Ù„Ù‚Ø§Ù†ÙˆÙ† Ù‡Ø°Ø§',0),(586791,16326,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ø¥Ø°Ø§ Ø£ÙŠ Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰',0),(586792,16327,'ar','Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ Ù„Ù„Ø´Ø­Ù†',0),(586793,16328,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(586794,16329,'ar','Ø§Ù„ÙØ±Ø² Ø­Ø³Ø¨ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(586795,16330,'ar','Ù„Ø§ ØªÙˆØ¬Ø¯ Ø§Ù„Ù‚ÙŠÙ…Ø© Ø§Ù„Ù…Ø­Ø¯Ø¯Ø©',0),(586796,16331,'ar','AP Ù…ØºÙ„Ù‚Ø©',0),(586797,16332,'ar','AR Ù…ØºÙ„Ù‚Ø©',0),(586798,16333,'ar','GL Ù…Ø¨Ø§Ø´Ø±Ø© Ù…ØºÙ„Ù‚Ø©',0),(586799,16334,'ar','Ø¥ØºÙ„Ø§Ù‚ Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(586800,16335,'ar','Ø£ØºÙ„Ù‚ Ø¬Ø²Ø¦ÙŠØ§',0),(586801,16336,'ar','ÙƒØ´ÙˆÙ Ø§Ù„Ù…Ø±ØªØ¨Ø§Øª Ù…ØºÙ„Ù‚Ø©',0),(586802,16337,'ar','ÙŠÙˆÙ„Ø¯ Ø§Ù„Ø¢Ù†',0),(586803,16338,'ar','Ø§Ù„ØªÙŠ ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(586804,16339,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ø¹ÙƒØ³ÙŠ',0),(586805,16340,'ar','ØªØ§Ø±ÙŠØ® Ø¥Ù†Ø´Ø§Ø¡',0),(586806,16341,'ar','Ø§Ù„Ù…Ø§Ø¶ÙŠ ØªØ§Ø±ÙŠØ® Ø§Ù„Ø­Ø±ÙƒØ©',0),(586807,16342,'ar','ÙˆØ­Ø¯Ø§Øª Ø§Ù„Ù…Ø­Ø¸ÙˆØ±Ø©',0),(586808,16343,'ar','ØºÙŠØ± Ù‚Ø§Ø¯Ø± Ø¹Ù„Ù‰ Ø£ÙˆÙ†Ø¨ÙˆØ³Øª Ù‚Ø³Ø§Ø¦Ù…',0),(586809,16344,'ar','Ù‚Ø³Ø§Ø¦Ù… Ø§Ù„Ù…Ø±Ø­Ù„ Ù…ÙˆØ§ÙÙ‚',0),(586810,16345,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ù…Ø¹Ø±Ù Ø§Ù„Ù…ÙˆØ±Ø¯ Ø£Ùˆ ÙƒÙˆØ¯ Ø§Ù„Ù…ÙˆØ±Ø¯ Ø£Ùˆ Ø§Ø³Ù… Ø§Ù„Ù…ÙˆØ±Ø¯',0),(586811,16346,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙˆÙ…Ø¹Ø±Ù Ø§Ù„Ù…ÙˆØ±Ø¯ Ø£Ùˆ ÙƒÙˆØ¯ Ø§Ù„Ù…ÙˆØ±Ø¯ Ø£Ùˆ Ø§Ø³Ù… Ø§Ù„Ø¨Ø§Ø¦Ø¹ ÙˆØ§Ù„Ù…Ø¨Ù„Øº ÙˆØ±Ù‚Ù… Ø­Ø³Ø§Ø¨ ØµØ§Ù„Ø­',0),(586812,16347,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ø±Ù…Ø²',0),(586813,16348,'ar','Ø¨Ù†ÙˆØ¯ Ø¥Ø¶Ø§ÙÙŠØ© ÙÙŠ Ù†ÙØ³ Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙÙ‚Ø· Ø¨Ø­Ø§Ø¬Ø© Ø¥Ù„Ù‰ Ù…Ø¹Ø±Ù Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ ÙƒÙˆØ¯ Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø£Ùˆ Ø§Ù„Ø£ÙˆÙ„ ÙˆØ§Ø³Ù… Ø§Ù„Ø¹Ø§Ø¦Ù„Ø© ÙˆØ±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(586814,16349,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ù…Ø¹Ø±Ù Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ ÙƒÙˆØ¯ Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø£Ùˆ Ø§Ù„Ø£ÙˆÙ„ ÙˆØ§Ø³Ù… Ø§Ù„Ø¹Ø§Ø¦Ù„Ø©',0),(586815,16350,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠÙƒÙˆÙ† Ù„Ø¯ÙŠÙƒ Ø±Ù‚Ù… Ø§Ù„ÙØ§ØªÙˆØ±Ø© ÙˆÙ…Ø¹Ø±Ù Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ ÙƒÙˆØ¯ Ø§Ù„Ø¹Ù…ÙŠÙ„ Ø£Ùˆ Ø§Ø³Ù… Ø§Ù„Ø´Ø±ÙƒØ© Ø£Ùˆ Ø§Ù„Ø£ÙˆÙ„ ÙˆØ§Ø³Ù… Ø§Ù„Ø¹Ø§Ø¦Ù„Ø©',0),(586816,16351,'ar','Ù…Ù‡Ù…Ø© Ø¨Ù‡Ø°Ø§ Ø§Ù„Ø§Ø³Ù… Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹',0),(586817,16352,'ar','ÙŠÙˆØ¬Ø¯ Ø¨Ø§Ù„ÙØ¹Ù„ Ø¹Ù„Ù‰ ÙˆØ¸ÙŠÙØ© Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(586818,16353,'ar','Ù…Ù‡Ù…Ø© Ù…Ø¹ Ù‡Ø°Ø§ Ø§Ù„Ø¹Ø¯Ø¯ Ø§Ù„Ù…Ø´Ø±ÙˆØ¹ Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„',0),(586819,16354,'ar','Ù…Ù‡Ù…Ø© Ù…Ø¹ Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù†ÙˆØ§Ù† Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„',0),(586820,16355,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ù…ØºÙ„Ù‚Ø© Ø­ØªÙ‰ Ø§Ù„Ø¢Ù†',0),(586821,16356,'ar','Lattitude',0),(586822,16357,'ar','Ø®Ø· Ø§Ù„Ø·ÙˆÙ„',0),(586823,16358,'ar','ØªØ§Ø±ÙŠØ® Ø¨Ø±ÙŠÙ„ÙŠÙ…Ø§Ø¨Ù„',0),(586824,16359,'ar','Ø¥Ù†Ø´Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ø¯ÙØªØ± Ø§Ù„Ø£Ø³ØªØ§Ø° Ø§Ù„Ù…ØªÙƒØ±Ø±Ø©',0),(586825,16360,'ar','Ø¹Ù„Ù‰ ÙØ£Ø± Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„ Ù…Ø§ÙƒØ³ Ø¨ÙŠ Ø¥ØªØ´ Ø¨ÙŠ',0),(586826,16361,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ Ø¥Ø¯Ø®Ø§Ù„ Ù‚ÙŠÙ…Ø© Ù„',0),(586827,16362,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ø³ÙÙŠÙ†Ø© Ø¥Ù„Ù‰ Ø§Ù„Ø±Ù…Ø² Ø§Ù„Ø¨Ø±ÙŠØ¯ÙŠ',0),(586828,16363,'ar','ÙŠÙˆØ¬Ø¯ Ø¨Ø§Ù„ÙØ¹Ù„ Ø¹Ù„Ù‰ ÙˆØ¸ÙŠÙØ© Ù„Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù…ÙŠÙ„',0),(586829,16364,'ar','Ù…Ù‡Ù…Ø© Ù…Ø¹ Ù‡Ø°Ø§ Ø§Ù„Ø¹Ù†ÙˆØ§Ù† Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„',0),(586830,16365,'ar','Ù…Ù‡Ù…Ø© Ù…Ø¹ Ù‡Ø°Ù‡ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø© Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ù…ÙˆØ¬ÙˆØ¯Ø© Ø¨Ø§Ù„ÙØ¹Ù„',0),(586831,16366,'ar','Ù…Ù‡Ù…Ø© Ø¨Ù‡Ø°Ø§ Ø§Ù„Ø§Ø³Ù… Ù…ÙˆØ¬ÙˆØ¯ Ù…Ø³Ø¨Ù‚Ø§Ù‹',0),(586832,16298,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð»Ð¸Ñ‡ÐµÐ½ Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(586833,16299,'bg','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð·Ð° Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(586834,16300,'bg','Ð›Ð¸ÑÑ‚ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚',0),(586835,16301,'bg','ÐÐµÐ²Ð°Ð»Ð¸Ð´Ð½Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(586836,16302,'bg','Ð—Ð°Ð´Ð°Ð²Ð°Ð½Ðµ Ð½Ð° Ð½Ð¾Ð²Ð° Ð¿Ð°Ñ€Ð¾Ð»Ð°',0),(586837,16303,'bg','ÐšÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»Ð¸',0),(586838,16304,'bg','ÐÐµ ÑÑŠÐ²Ð¿Ð°Ð´Ð° Ñ ÐºÐ»Ð¸ÐµÐ½Ñ‚',0),(586839,16305,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ',0),(586840,16306,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸ Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(586841,16307,'bg','Ð˜Ð·Ð±ÑƒÑ…Ð½Ðµ Ð¾Ñ‚ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ ÐºÐ¾Ð´',0),(586842,16308,'bg','Ð˜Ð·Ð±ÑƒÑ…Ð½Ðµ Ð¾Ñ‚ GL ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(586843,16309,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(586844,16310,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ Ñ‚Ð¾Ð·Ð¸ ÐºÐ¾Ð´ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(586845,16311,'bg','ÐœÐ½Ð¾Ð¶ÐµÑÑ‚Ð²Ð¾ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ð¸ ÑÑŠÑ Ð·Ð°Ð¿ÐµÑ‚Ð°Ð¸',0),(586846,16312,'bg','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¸ Ð¸ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ ÑƒÐ½Ð¸ÐºÐ°Ð»ÐµÐ½',0),(586847,16313,'bg','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸',0),(586848,16314,'bg','Ð’ÑÑÐºÐ° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚',0),(586849,16315,'bg','Ð¤Ð°Ð»ÑˆÐ¸Ð²Ð¸',0),(586850,16316,'bg','ÐŸÑŠÑ€Ð²Ð°Ñ‚Ð° & Ð¿Ð¾ÑÐ»ÐµÐ´Ð½Ð¾Ñ‚Ð¾ Ð¸Ð¼Ðµ',0),(586851,16317,'bg','ÐžÑ‡Ð°ÐºÐ²Ð°Ð½Ð¾ Ñ‡Ð¸ÑÐ»Ð¾',0),(586852,16318,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð¾Ñ‰Ðµ',0),(586853,16319,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÑŠÑÑ‚Ð¾ÑÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÑŠÐº',0),(586854,16320,'bg','Ð’ÑÑ€Ð½Ð¾',0),(586855,16321,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ GL Ð¸Ð»Ð¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ ÐºÐ¾Ð´ Ð¸Ð»Ð¸ GL ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ',0),(586856,16322,'bg','Ð˜Ð·Ð¿Ñ€Ð°Ñ‰Ð°Ð½Ðµ Ð½Ð° Ð¸Ð¼ÐµÐ¹Ð» ÑÑŠÐ¾Ð±Ñ‰ÐµÐ½Ð¸Ñ, ÐºÐ¾Ð³Ð°Ñ‚Ð¾ Ð±Ð¸Ð» Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½',0),(586857,16323,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ñ‚ Ð´Ð°Ñ‚Ð°',0),(586858,16324,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐ¼ÐµÑ‚ÐºÐ¸ ÑÐ° Ð±Ð¸Ð»Ð¸ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(586859,16325,'bg','PO Ñ€Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð½Ð° Ñ‚Ð¾Ð·Ð¸ Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(586860,16326,'bg','ÐŸÐ¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸Ñ€Ð°Ð½Ðµ, Ð°ÐºÐ¾ Ð½ÑÐ¼Ð° ÐºÐ¾Ñ€Ð°Ð± Ð´Ð°',0),(586861,16327,'bg','ÐšÐ¾Ñ€Ð°Ð± Ð·Ð° Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(586862,16328,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(586863,16329,'bg','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð¹ Ð¿Ð¾ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(586864,16330,'bg','ÐÑÐ¼Ð° ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(586865,16331,'bg','AP Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(586866,16332,'bg','AR Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(586867,16333,'bg','Ð”Ð¸Ñ€ÐµÐºÑ‚ÐµÐ½ GL Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(586868,16334,'bg','Ð—Ð°Ð¿Ð°ÑÐ¸ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(586869,16335,'bg','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(586870,16336,'bg','Ð¢Ð Ð— Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½',0),(586871,16337,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÑÐµÐ³Ð°',0),(586872,16338,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(586873,16339,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð° Ð¡Ñ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‰ Ð·Ð°Ð¿Ð¸Ñ',0),(586874,16340,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ð´Ð°Ñ‚Ð° Ð½Ð° Ð³ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ðµ',0),(586875,16341,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° Ñ‚Ñ€Ð°Ð½Ð·Ð°ÐºÑ†Ð¸Ñ',0),(586876,16342,'bg','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ð¸ Ð¼Ð¾Ð´ÑƒÐ»Ð¸',0),(586877,16343,'bg','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Unpost Ð²Ð°ÑƒÑ‡ÐµÑ€Ð¸',0),(586878,16344,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€Ð¸ Ð·Ð° Ð½ÐµÐ¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½Ð¸ OK',0),(586879,16345,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð°Ñ‚ Ð˜Ð” Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð¸Ð»Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° ÐºÐ¾Ð´ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº',0),(586880,16346,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸ Ð˜Ð” Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° Ð¸Ð»Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸ÐºÐ° ÐºÐ¾Ð´ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ð¸ ÑÑƒÐ¼Ð° Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð²Ð°Ð»Ð¸Ð´ÐµÐ½ ÑÐ¼ÐµÑ‚ÐºÐ°',0),(586881,16347,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ ÐºÐ¾Ð´',0),(586882,16348,'bg','Ð”Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¿Ð¾Ð·Ð¸Ñ†Ð¸Ð¸ Ð² ÐµÐ´Ð½Ð° Ð¸ ÑÑŠÑ‰Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° ÑÐ°Ð¼Ð¾ Ð˜Ð” Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ð´ Ð¸Ð»Ð¸ Ð¸Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð°Ñ‚Ð° Ð¸Ð»Ð¸ Ð¿ÑŠÑ€Ð²Ð¾ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ Ð¸ Ð½Ð¾Ð¼ÐµÑ€Ð° Ð½Ð° Ñ„',0),(586883,16349,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð˜Ð” Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ð´ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð° Ð¸Ð»Ð¸ Ð¿ÑŠÑ€Ð²Ð¾ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(586884,16350,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð¸Ð¼Ð° Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð° Ð¸ Ð˜Ð” Ð½Ð° ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ ÐºÐ¾Ð´ Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð½Ð° Ñ„Ð¸Ñ€Ð¼Ð° Ð¸Ð»Ð¸ Ð¿ÑŠÑ€Ð²Ð¾ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð½Ð¾ Ð¸Ð¼Ðµ',0),(586885,16351,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ Ñ‚Ð¾Ð²Ð° Ð¸Ð¼Ðµ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(586886,16352,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(586887,16353,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ Ñ‚Ð¾Ð·Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð½Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(586888,16354,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ Ñ‚Ð¾Ð·Ð¸ Ð°Ð´Ñ€ÐµÑ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(586889,16355,'bg','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð´Ð°Ñ‚Ð° Ð½Ð° Ð·Ð°Ñ‚Ð²Ð°Ñ€ÑÐ½Ðµ',0),(586890,16356,'bg','Lattitude',0),(586891,16357,'bg','Ð”ÑŠÐ»Ð¶Ð¸Ð½Ð°',0),(586892,16358,'bg','Prelimable Ð´Ð°Ñ‚Ð°',0),(586893,16359,'bg','Ð“ÐµÐ½ÐµÑ€Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ð²Ñ‚Ð°Ñ€ÑÑ‰Ð¸ ÑÐµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(586894,16360,'bg','ÐÐ°Ð´ PHP ÐœÐ°ÐºÑ Ð²ÑŠÐ²ÐµÐ¶Ð´Ð°Ð½Ðµ Vars',0),(586895,16361,'bg','Ð’ÑŠÐ²ÐµÐ´ÐµÑ‚Ðµ ÑÑ‚Ð¾Ð¹Ð½Ð¾ÑÑ‚ Ð·Ð°',0),(586896,16362,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÐºÐ¾Ñ€Ð°Ð± Ð´Ð¾ Ð¿Ð¾Ñ‰ÐµÐ½ÑÐºÐ¸ ÐºÐ¾Ð´',0),(586897,16363,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð° Ñ‚Ð¾Ð·Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(586898,16364,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ Ñ‚Ð¾Ð·Ð¸ Ð°Ð´Ñ€ÐµÑ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(586899,16365,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ Ñ‚Ð¾Ð·Ð¸ ÐºÐ¾Ð´ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(586900,16366,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ Ñ‚Ð¾Ð²Ð° Ð¸Ð¼Ðµ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(586901,16298,'zh','æ²¡æœ‰å¯ç”¨çš„å£°æ˜Ž',0),(586902,16299,'zh','äº§å“ä¿¡æ¯',0),(586903,16300,'zh','äº§å“è¡¨',0),(586904,16301,'zh','æ— æ•ˆçš„å¯†ç ',0),(586905,16302,'zh','è®¾ç½®æ–°çš„å¯†ç ',0),(586906,16303,'zh','å¿…é¡»è®¾ç½®å®¢æˆ·æˆ–å·¥ä½œ',0),(586907,16304,'zh','ä¸Žå®¢æˆ·ä¸åŒ¹é…',0),(586908,16305,'zh','å¯¼å…¥ä¿¡æ¯',0),(586909,16306,'zh','å¯¼å…¥å‘ç¥¨å®¢æˆ·å’Œå·¥ä½œå˜åŠ¨',0),(586910,16307,'zh','æ‰“å‡ºæ¥æŒ‰æˆæœ¬ä»£ç ',0),(586911,16308,'zh','æ‰“å‡ºæ¥æŒ‰ GL ç±»åˆ«',0),(586912,16309,'zh','ç”Ÿæˆçš„é‡å¤æ¡ç›®',0),(586913,16310,'zh','æ­¤ä»£ç çš„ä½œä¸šå·²ç»å­˜åœ¨',0),(586914,16311,'zh','å¯ä»¥ç”¨é€—å·åˆ†éš”å¤šä¸ªæ¡ç›®',0),(586915,16312,'zh','éœ€è¦å’Œå¿…é¡»æ˜¯å”¯ä¸€çš„',0),(586916,16313,'zh','å¯¼å…¥å‘ç¥¨å˜åŒ–',0),(586917,16314,'zh','ä»»ä½•å€¼',0),(586918,16315,'zh','å‡',0),(586919,16316,'zh','ç¬¬ä¸€æ¬¡ä¸Žæœ€åŽä¸€å',0),(586920,16317,'zh','é¢„æœŸçš„å·',0),(586921,16318,'zh','æ˜¾ç¤ºæ›´å¤š',0),(586922,16319,'zh','æ˜¾ç¤ºçŠ¶æ€åˆ—è¡¨',0),(586923,16320,'zh','çœŸæ­£',0),(586924,16321,'zh','æ‚¨å¿…é¡»é€‰æ‹©ä¸€ä¸ªæ€»å¸å¸æˆ·æˆ–æˆæœ¬çš„ä»£ç æˆ– GL ç±»åˆ«',0),(586925,16322,'zh','å‘é€ç”µå­é‚®ä»¶é€šçŸ¥ï¼Œå½“æ¡ä¾‹è‰æ¡ˆèŽ·å¾—æ‰¹å‡†',0),(586926,16323,'zh','æ”¯ä»˜æ—¥æœŸ',0),(586927,16324,'zh','ä¾›åº”å•†è´¦å•å·²æ‰¹å‡†ä»˜æ¬¾',0),(586928,16325,'zh','åœ¨è¿™é¡¹æ¡ä¾‹è‰æ¡ˆä¸Šæ”¶è´§è®¢å•',0),(586929,16326,'zh','å¦‚æžœæ²¡æœ‰èˆ¹åˆ°å¸å•é‚®æ”¿ç¼–ç ',0),(586930,16327,'zh','èˆ¹åˆ°é‚®æ”¿ç¼–ç ',0),(586931,16328,'zh','èˆ¹å‘é‚®æ”¿ç¼–ç ',0),(586932,16329,'zh','æŒ‰ Zip ä»£ç æŽ’åº',0),(586933,16330,'zh','æœªé€‰æ‹©å€¼',0),(586934,16331,'zh','AP å…³é—­',0),(586935,16332,'zh','AR å…³é—­',0),(586936,16333,'zh','ç›´æŽ¥ GL å…³é—­',0),(586937,16334,'zh','å…³é—­çš„åº“å­˜',0),(586938,16335,'zh','å±€éƒ¨å°é—­',0),(586939,16336,'zh','å…³é—­çš„å·¥èµ„å•',0),(586940,16337,'zh','çŽ°åœ¨ç”Ÿæˆ',0),(586941,16338,'zh','å·²æˆåŠŸç”Ÿæˆ',0),(586942,16339,'zh','ç”Ÿæˆå†²é”€æ¡ç›®',0),(586943,16340,'zh','ç”Ÿæˆçš„æœ€åŽæ—¥æœŸ',0),(586944,16341,'zh','ä¸Šæ¬¡äº¤æ˜“æ—¥æœŸ',0),(586945,16342,'zh','è¢«é˜»æ­¢çš„æ¨¡å—',0),(586946,16343,'zh','ä¸èƒ½ Unpost å‡­è¯',0),(586947,16344,'zh','ç¡®å®šæœªè¿‡å¸çš„å‡­è¯',0),(586948,16345,'zh','å¿…é¡»æœ‰ä¸€ä¸ªä¾›åº”å•† ID æˆ–ä¾›åº”å•†çš„ä»£ç æˆ–ä¾›åº”å•†åç§°',0),(586949,16346,'zh','å¿…é¡»æœ‰å‘ç¥¨ç¼–å·å’Œä¾›åº”å•† ID æˆ–ä¾›åº”å•†çš„ä»£ç æˆ–ä¾›åº”å•†åç§°ã€ é‡‘é¢å’Œæœ‰æ•ˆå¸æˆ·å·ç ',0),(586950,16347,'zh','éœ€è¦ä»£ç ',0),(586951,16348,'zh','åœ¨åŒä¸€å‘ç¥¨çš„é™„åŠ è¡Œé¡¹ç›®åªéœ€è¦å®¢æˆ· ID æˆ–å®¢æˆ·ä»£ç æˆ–å…¬å¸åç§°æˆ–ç¬¬ä¸€å’Œæœ€åŽä¸€ä¸ªåå­—å’Œå‘ç¥¨ç¼–å·',0),(586952,16349,'zh','å¿…é¡»å…·æœ‰å®¢æˆ· ID æˆ–å®¢æˆ·ä»£ç æˆ–å…¬å¸åç§°æˆ–å§“å’Œå',0),(586953,16350,'zh','å¿…é¡»æœ‰å‘ç¥¨ç¼–å·å’Œå®¢æˆ· ID æˆ–å®¢æˆ·ä»£ç æˆ–å…¬å¸åç§°æˆ–å§“å’Œå',0),(586954,16351,'zh','å…·æœ‰æ­¤åç§°çš„ä½œä¸šå·²ç»å­˜åœ¨',0),(586955,16352,'zh','æ­¤å®¢æˆ·çš„ä½œä¸šå·²ç»å­˜åœ¨',0),(586956,16353,'zh','æ­¤é¡¹ç›®ç¼–å·çš„ä½œä¸šå·²ç»å­˜åœ¨',0),(586957,16354,'zh','æ­¤åœ°å€çš„ä½œä¸šå·²ç»å­˜åœ¨',0),(586958,16355,'zh','ä½œä¸šç»“æŸæ—¥æœŸ',0),(586959,16356,'zh','Lattitude',0),(586960,16357,'zh','ç»åº¦',0),(586961,16358,'zh','Prelimable æ—¥æœŸ',0),(586962,16359,'zh','ç”Ÿæˆåˆ†ç±»å¸çš„é‡å¤æ¡ç›®',0),(586963,16360,'zh','åœ¨ PHP æœ€å¤§è¾“å…¥ Var',0),(586964,16361,'zh','è¯·è¾“å…¥ä¸€ä¸ªå€¼',0),(586965,16362,'zh','èˆ¹å‘é‚®æ”¿ç¼–ç ',0),(586966,16363,'zh','æ­¤å®¢æˆ·çš„ä½œä¸šå·²ç»å­˜åœ¨',0),(586967,16364,'zh','æ­¤åœ°å€çš„ä½œä¸šå·²ç»å­˜åœ¨',0),(586968,16365,'zh','æ­¤ä»£ç çš„ä½œä¸šå·²ç»å­˜åœ¨',0),(586969,16366,'zh','å…·æœ‰æ­¤åç§°çš„ä½œä¸šå·²ç»å­˜åœ¨',0),(586970,16298,'da','Ingen tilgÃ¦ngelige erklÃ¦ring',0),(586971,16299,'da','Produktinfo',0),(586972,16300,'da','Produktark',0),(586973,16301,'da','Ugyldig adgangskode',0),(586974,16302,'da','Angive en ny adgangskode',0),(586975,16303,'da','Kunde eller Job skal angives',0),(586976,16304,'da','Svarer ikke kunde',0),(586977,16305,'da','Importere oplysninger',0),(586978,16306,'da','Import faktura kunde og jobskift',0),(586979,16307,'da','Bryde ud af omkostninger kode',0),(586980,16308,'da','Bryde ud af GL kategori',0),(586981,16309,'da','Generer tilbagevendende poster',0),(586982,16310,'da','Et Job med denne kode findes allerede',0),(586983,16311,'da','Flere poster kan adskilles med kommaer',0),(586984,16312,'da','KrÃ¦ves og skal vÃ¦re entydigt',0),(586985,16313,'da','Import faktura Ã¦ndringer',0),(586986,16314,'da','Enhver vÃ¦rdi',0),(586987,16315,'da','Falsk',0),(586988,16316,'da','FÃ¸rste & sidste navn',0),(586989,16317,'da','Antallet forventes',0),(586990,16318,'da','Vis mere',0),(586991,16319,'da','Vis stat liste',0),(586992,16320,'da','Sandt',0),(586993,16321,'da','Du skal vÃ¦lge en GL konto eller omkostninger kode eller GL kategori',0),(586994,16322,'da','Send E-mail meddelelser, nÃ¥r Bill godkendt',0),(586995,16323,'da','Betale dato',0),(586996,16324,'da','Kreditor regninger er blevet godkendt til betaling',0),(586997,16325,'da','PO kvitteringer pÃ¥ dette lovforslag',0),(586998,16326,'da','Fakturering postnummeret, hvis ingen skib til',0),(586999,16327,'da','Skib til postnummer',0),(587000,16328,'da','Vis skib til postnummer',0),(587001,16329,'da','Sorter efter postnummer',0),(587002,16330,'da','Ingen vÃ¦rdi der er valgt',0),(587003,16331,'da','AP lukket',0),(587004,16332,'da','AR lukket',0),(587005,16333,'da','Direkte GL lukket',0),(587006,16334,'da','OpgÃ¸relse lukket',0),(587007,16335,'da','Delvist lukket',0),(587008,16336,'da','LÃ¸nningslisten lukket',0),(587009,16337,'da','Generere nu',0),(587010,16338,'da','Genereret med succes',0),(587011,16339,'da','Generere tilbagefÃ¸rsel',0),(587012,16340,'da','Sidste dato genereret',0),(587013,16341,'da','Sidste posteringsdato',0),(587014,16342,'da','Blokerede moduler',0),(587015,16343,'da','AfskÃ¥ret fra Unpost gavekort',0),(587016,16344,'da','Gavekort ikke bogfÃ¸rte OK',0),(587017,16345,'da','Skal Have et forhandler-ID eller Kreditorkoden eller kreditornavnet',0),(587018,16346,'da','Skal Have fakturanummer og leverandÃ¸r-ID eller Kreditorkoden eller LeverandÃ¸rnavn og belÃ¸b og gyldigt kontonummer',0),(587019,16347,'da','Skal vÃ¦re en kode',0),(587020,16348,'da','Yderligere linjeelementer i den samme faktura behÃ¸ver kun kunde-ID eller kunde kode eller firmanavn eller fÃ¸rste og sidste navn og fakturanummeret',0),(587021,16349,'da','Skal Have et kunde-ID eller kunde koden eller virksomhedens navn eller fÃ¸rste og sidste navn',0),(587022,16350,'da','Skal Have fakturanummer og kunde-ID eller kunde koden eller virksomhedens navn eller fÃ¸rste og sidste navn',0),(587023,16351,'da','Et Job med dette navn findes allerede',0),(587024,16352,'da','Et Job For denne kunde findes allerede',0),(587025,16353,'da','Et Job med dette projektnummer findes allerede',0),(587026,16354,'da','Et Job med denne adresse findes allerede',0),(587027,16355,'da','Opgave lukket dato',0),(587028,16356,'da','Lattitude',0),(587029,16357,'da','LÃ¦ngdegrad',0),(587030,16358,'da','Prelimable dato',0),(587031,16359,'da','Generer tilbagevendende finansposter',0),(587032,16360,'da','Over PHP Max Input Vars',0),(587033,16361,'da','Angiv en vÃ¦rdi For',0),(587034,16362,'da','Vis skib til postnummer',0),(587035,16363,'da','Et Job For denne kunde findes allerede',0),(587036,16364,'da','Et Job med denne adresse findes allerede',0),(587037,16365,'da','Et Job med denne kode findes allerede',0),(587038,16366,'da','Et Job med dette navn findes allerede',0),(587039,16298,'fa','Ù‡ÛŒÚ† Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…ÙˆØ¬ÙˆØ¯',0),(587040,16299,'fa','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­ØµÙˆÙ„',0),(587041,16300,'fa','Ù…Ø­ØµÙˆÙ„ ÙˆØ±Ù‚',0),(587042,16301,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(587043,16302,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(587044,16303,'fa','Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø§Ø± Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ',0),(587045,16304,'fa','Ù…Ø´ØªØ±ÛŒ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(587046,16305,'fa','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(587047,16306,'fa','Ù…Ø´ØªØ±ÛŒ ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ØªØºÛŒÛŒØ± Ø´ØºÙ„',0),(587048,16307,'fa','ØªÙˆØ³Ø· Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø´Ú©Ø³ØªÙ†',0),(587049,16308,'fa','Ø´Ú©Ø³ØªÙ† Ø¯Ø³ØªÙ‡ GL',0),(587050,16309,'fa','ØªÙˆÙ„ÛŒØ¯ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(587051,16310,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(587052,16311,'fa','Ú†Ù†Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø§ Ú©Ø§Ù…Ø§ Ø§Ø² Ù‡Ù… Ø¬Ø¯Ø§',0),(587053,16312,'fa','Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ùˆ Ø¨Ø§ÛŒØ¯ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯',0),(587054,16313,'fa','ØªØºÛŒÛŒØ±Ø§Øª ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª',0),(587055,16314,'fa','Ù‡Ø± Ù…Ù‚Ø¯Ø§Ø±',0),(587056,16315,'fa','Ù†Ø§Ø¯Ø±Ø³Øª',0),(587057,16316,'fa','Ù†Ø§Ù… Ø§ÙˆÙ„ÛŒÙ† & Ú¯Ø°Ø´ØªÙ‡',0),(587058,16317,'fa','Ø§Ù†ØªØ¸Ø§Ø± Ù…ÛŒ Ø±ÙˆØ¯ ØªØ¹Ø¯Ø§Ø¯',0),(587059,16318,'fa','Ù†Ù…Ø§ÙŠØ´ Ø¨ÙŠØ´ØªØ±',0),(587060,16319,'fa','Ù„ÛŒØ³Øª ÙˆØ¶Ø¹ÛŒØª Ù†Ù…Ø§ÛŒØ´',0),(587061,16320,'fa','Ø¯Ø±Ø³Øª Ø§Ø³Øª',0),(587062,16321,'fa','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ GL Ø­Ø³Ø§Ø¨ ÛŒØ§ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ ÛŒØ§ Ø±Ø¯Ù‡ GL',0),(587063,16322,'fa','Ø§Ø±Ø³Ø§Ù„ Ø§Ø¹Ù„Ø§Ù…ÛŒÙ‡ Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„ ØªØ£ÛŒÛŒØ¯ Ù„Ø§ÛŒØ­Ù‡',0),(587064,16323,'fa','ØªØ§Ø±ÙŠØ®',0),(587065,16324,'fa','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(587066,16325,'fa','Ù¾Ùˆ Ø±Ø³ÛŒØ¯ Ø¯Ø± Ø§ÛŒÙ† Ù„Ø§ÛŒØ­Ù‡',0),(587067,16326,'fa','Ú©Ø¯ Ù¾Ø³ØªÛŒ Ø§Ú¯Ø± Ù‡ÛŒÚ† Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª',0),(587068,16327,'fa','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(587069,16328,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(587070,16329,'fa','Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù† Ø¨Ø± Ø§Ø³Ø§Ø³ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(587071,16330,'fa','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(587072,16331,'fa','AP Ø¨Ø³ØªÙ‡',0),(587073,16332,'fa','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ø¨Ø³ØªÙ‡',0),(587074,16333,'fa','Ù…Ø³ØªÙ‚ÛŒÙ… GL Ø¨Ø³ØªÙ‡',0),(587075,16334,'fa','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø³ØªÙ‡',0),(587076,16335,'fa','Ø¨Ø³ØªÙ‡ ØªØ§ Ø­Ø¯ÛŒ',0),(587077,16336,'fa','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø³ØªÙ‡',0),(587078,16337,'fa','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØªÙˆÙ„ÛŒØ¯',0),(587079,16338,'fa','ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(587080,16339,'fa','Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…Ø¹Ú©ÙˆØ³',0),(587081,16340,'fa','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡',0),(587082,16341,'fa','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(587083,16342,'fa','Ù…Ø§Ú˜ÙˆÙ„ Ù‡Ø§ÛŒ Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯Ù‡',0),(587084,16343,'fa','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Unpost Ú©ÙˆÙ¾Ù†',0),(587085,16344,'fa','Ú©ÙˆÙ¾Ù† Unposted OK',0),(587086,16345,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…',0),(587087,16346,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø¨Ù„Øº Ùˆ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±',0),(587088,16347,'fa','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ú©Ø¯',0),(587089,16348,'fa','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(587090,16349,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(587091,16350,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(587092,16351,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(587093,16352,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(587094,16353,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(587095,16354,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(587096,16355,'fa','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ®',0),(587097,16356,'fa','Lattitude',0),(587098,16357,'fa','Ø·ÙˆÙ„ Ø¬ØºØ±Ø§ÙÛŒØ§ÛŒÛŒ',0),(587099,16358,'fa','ØªØ§Ø±ÛŒØ® prelimable',0),(587100,16359,'fa','ØªÙˆÙ„ÛŒØ¯ ØªÚ©Ø±Ø§Ø±ÛŒ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(587101,16360,'fa','Ø¨ÛŒØ´ Ø§Ø² PHP Ø­Ø¯Ø§Ú©Ø«Ø± ÙˆØ±ÙˆØ¯ÛŒ Vars',0),(587102,16361,'fa','Ù„Ø·ÙØ§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÛŒ',0),(587103,16362,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(587104,16363,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(587105,16364,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(587106,16365,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(587107,16366,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(587108,16298,'nl','Geen verklaring beschikbaar',0),(587109,16299,'nl','Productinfo',0),(587110,16300,'nl','Productfiche',0),(587111,16301,'nl','Ongeldig wachtwoord',0),(587112,16302,'nl','Een nieuw wachtwoord instellen',0),(587113,16303,'nl','Klant of baan moet worden ingesteld',0),(587114,16304,'nl','Komt niet overeen met de klant',0),(587115,16305,'nl','Gegevens importeren',0),(587116,16306,'nl','Import factuur klant en veranderingen van de baan',0),(587117,16307,'nl','Break Out door kosten Code',0),(587118,16308,'nl','Break Out door GL categorie',0),(587119,16309,'nl','Genereren periodieke posten',0),(587120,16310,'nl','Een baan met deze Code bestaat al',0),(587121,16311,'nl','Meerdere items kunnen worden gescheiden met komma \'s',0),(587122,16312,'nl','Vereist en moet uniek zijn',0),(587123,16313,'nl','Import factuur wijzigingen',0),(587124,16314,'nl','Een willekeurige waarde',0),(587125,16315,'nl','Valse',0),(587126,16316,'nl','Eerste & laatste naam',0),(587127,16317,'nl','Verwacht aantal',0),(587128,16318,'nl','Toon meer',0),(587129,16319,'nl','Toon lijst',0),(587130,16320,'nl','Waar',0),(587131,16321,'nl','U moet een GL Account of kosten Code of GL categorie selecteren',0),(587132,16322,'nl','E-mail meldingen te verzenden wanneer Bill goedgekeurd',0),(587133,16323,'nl','Betaal datum',0),(587134,16324,'nl','Facturen van de leverancier zijn goedgekeurd voor betaling',0),(587135,16325,'nl','PO ontvangsten op dit wetsvoorstel',0),(587136,16326,'nl','Facturatie postcode als geen schip',0),(587137,16327,'nl','Postcode voor verzending',0),(587138,16328,'nl','Postal Code schip Toon',0),(587139,16329,'nl','Sorteer op postcode',0),(587140,16330,'nl','Geen waarde geselecteerd',0),(587141,16331,'nl','AP gesloten',0),(587142,16332,'nl','AR gesloten',0),(587143,16333,'nl','Directe GL gesloten',0),(587144,16334,'nl','Inventaris van gesloten',0),(587145,16335,'nl','Gedeeltelijk gesloten',0),(587146,16336,'nl','Payroll gesloten',0),(587147,16337,'nl','Nu genereren',0),(587148,16338,'nl','Gegenereerd met succes',0),(587149,16339,'nl','Genereren van omgekeerde Entry',0),(587150,16340,'nl','Laatste datum gegenereerd',0),(587151,16341,'nl','De datum van de laatste transactie',0),(587152,16342,'nl','Geblokkeerde Modules',0),(587153,16343,'nl','Kunnen Unpost Vouchers',0),(587154,16344,'nl','Vouchers niet-geboekte OK',0),(587155,16345,'nl','Moet een Vendor ID of leverancierscode of naam van de leverancier',0),(587156,16346,'nl','Factuurnummer en Vendor ID of leverancierscode of naam van de leverancier en bedrag en geldig rekeningnummer moet hebben',0),(587157,16347,'nl','Moet een Code',0),(587158,16348,'nl','Extra regelitems In dezelfde factuur hoeft de klant-ID of klantcode of bedrijfsnaam eerste en laatste naam en of het factuurnummer',0),(587159,16349,'nl','Moet een klant-ID of de klantcode of de bedrijfsnaam of de voornaam en de achternaam',0),(587160,16350,'nl','Factuurnummer en klant-ID of klantcode of bedrijfsnaam of voornaam en achternaam moet hebben',0),(587161,16351,'nl','Een baan met deze naam bestaat reeds',0),(587162,16352,'nl','Een baan voor deze klant bestaat al',0),(587163,16353,'nl','Een baan met dit projectnummer bestaat al',0),(587164,16354,'nl','Een baan met dit adres bestaat al',0),(587165,16355,'nl','Baan gesloten datum',0),(587166,16356,'nl','Lattitude',0),(587167,16357,'nl','Lengtegraad',0),(587168,16358,'nl','Prelimable datum',0),(587169,16359,'nl','Genereren van terugkerende posten',0),(587170,16360,'nl','Over PHP Max Input Vars',0),(587171,16361,'nl','Voer een waarde voor',0),(587172,16362,'nl','Postal Code schip Toon',0),(587173,16363,'nl','Een baan voor deze klant bestaat al',0),(587174,16364,'nl','Een baan met dit adres bestaat al',0),(587175,16365,'nl','Een baan met deze Code bestaat al',0),(587176,16366,'nl','Een baan met deze naam bestaat reeds',0),(587177,16298,'et','VastuvÃ¤iteid, mis on saadaval',0),(587178,16299,'et','Toote Info',0),(587179,16300,'et','Toote leht',0),(587180,16301,'et','Sobimatu parool',0),(587181,16302,'et','Uue salasÃµna',0),(587182,16303,'et','Tuleb mÃ¤Ã¤rata kliendi vÃµi tÃ¶Ã¶',0),(587183,16304,'et','Ei vasta kliendi',0),(587184,16305,'et','Teabe importimiseks',0),(587185,16306,'et','Impordi arve kliendi ja tÃ¶Ã¶kohta vahetavate',0),(587186,16307,'et','Kulude koodi puhkeb',0),(587187,16308,'et','GL kategooria puhkeb',0),(587188,16309,'et','Luua korduvaid kandeid',0),(587189,16310,'et','TÃ¶Ã¶ see kood on juba olemas',0),(587190,16311,'et','Mitmekordseks saab eraldada komadega',0),(587191,16312,'et','Vajalik ja erinev teistest',0),(587192,16313,'et','Impordi arve muutused',0),(587193,16314,'et','Suvaline vÃ¤Ã¤rtus',0),(587194,16315,'et','Vale',0),(587195,16316,'et','Esimene & viimase nimi',0),(587196,16317,'et','Eeldatav',0),(587197,16318,'et','NÃ¤ita rohkem',0),(587198,16319,'et','NÃ¤ita riigi nimekirja',0),(587199,16320,'et','TÃµsi',0),(587200,16321,'et','Valige PR-i konto vÃµi kulude kood vÃµi GL kategooria',0),(587201,16322,'et','Saada e-postiga teateid arve peale kinnitamist',0),(587202,16323,'et','Maksmise kuupÃ¤ev',0),(587203,16324,'et','Hankija arvete maksmise heaks',0),(587204,16325,'et','PO teatised nende see seaduseelnÃµu',0),(587205,16326,'et','Kui ei ole laeva arveaadressi sihtnumber',0),(587206,16327,'et','Kauba saaja postiindeks',0),(587207,16328,'et','NÃ¤ita laeva sihtnumber',0),(587208,16329,'et','Sorteeri postiindeks',0),(587209,16330,'et','Valitud vÃ¤Ã¤rtus',0),(587210,16331,'et','AP, mis on suletud',0),(587211,16332,'et','Suletud AR',0),(587212,16333,'et','Otsene GL suletud',0),(587213,16334,'et','Ladu suletud',0),(587214,16335,'et','Osaliselt suletud',0),(587215,16336,'et','Palgaarvestuse suletud',0),(587216,16337,'et','NÃ¼Ã¼d Loo',0),(587217,16338,'et','Edukalt loodud',0),(587218,16339,'et','Luua tÃ¼histav kanne',0),(587219,16340,'et','Viimane kuupÃ¤ev, mis on loodud',0),(587220,16341,'et','Viimase kande kuupÃ¤ev',0),(587221,16342,'et','Blokeeritud moodulid',0),(587222,16343,'et','Ei saa Unpost kanded',0),(587223,16344,'et','OK sisestamata kanded',0),(587224,16345,'et','Peab olema tarnija ID vÃµi hankija koodi vÃµi hankija nimi',0),(587225,16346,'et','Peab olema arve Number ja kuupÃ¤ev vÃµi hankija koodi vÃµi hankija nimi ja summa ja kehtiv konto Number',0),(587226,16347,'et','Tuleb kood',0),(587227,16348,'et','TÃ¤iendavaid kirjeid sama arve vaja ainult kliendi ID vÃµi kliendi kood vÃµi ettevÃµtte nimi vÃµi esimese ja Viimane nimi ja arve Number',0),(587228,16349,'et','Peab olema kliendi ID vÃµi kliendi kood vÃµi ettevÃµtte nimi vÃµi esimene ja Viimane nimi',0),(587229,16350,'et','Peab olema arve Number ja kliendi ID vÃµi kliendi kood vÃµi ettevÃµtte nimi vÃµi esimese ja perekonnanimi',0),(587230,16351,'et','Sellise nimega tÃ¶Ã¶ juba olemas',0),(587231,16352,'et','TÃ¶Ã¶d selle kliendi puhul on juba olemas',0),(587232,16353,'et','TÃ¶Ã¶d selle projekti number on juba olemas',0),(587233,16354,'et','TÃ¶Ã¶kohta, kus see aadress on juba olemas',0),(587234,16355,'et','TÃ¶Ã¶ sulgemiskuupÃ¤ev',0),(587235,16356,'et','Lattitude',0),(587236,16357,'et','Pikkus',0),(587237,16358,'et','Prelimable kuupÃ¤ev',0),(587238,16359,'et','Tekita korduva andmikukannete',0),(587239,16360,'et','PHP Max sisend Vars Ã¼le',0),(587240,16361,'et','Sisestage vÃ¤Ã¤rtus',0),(587241,16362,'et','NÃ¤ita laeva sihtnumber',0),(587242,16363,'et','TÃ¶Ã¶d selle kliendi puhul on juba olemas',0),(587243,16364,'et','TÃ¶Ã¶kohta, kus see aadress on juba olemas',0),(587244,16365,'et','TÃ¶Ã¶ see kood on juba olemas',0),(587245,16366,'et','Sellise nimega tÃ¶Ã¶ juba olemas',0),(587246,16298,'fi','Ei vastausta saatavilla',0),(587247,16299,'fi','Tuotetiedot',0),(587248,16300,'fi','Tuote-esite',0),(587249,16301,'fi','Virheellinen salasana',0),(587250,16302,'fi','Aseta uusi salasana',0),(587251,16303,'fi','Asiakas- tai tyÃ¶ on mÃ¤Ã¤ritettÃ¤vÃ¤',0),(587252,16304,'fi','Ei vastaa asiakkaan',0),(587253,16305,'fi','Tietojen tuominen',0),(587254,16306,'fi','Tuo laskun asiakas- ja vaihtuu',0),(587255,16307,'fi','Kustannuskoodi puhkeaa',0),(587256,16308,'fi','GL-luokan puhkeaa',0),(587257,16309,'fi','Luo toistuvia tapahtumia',0),(587258,16310,'fi','TÃ¤mÃ¤ koodi tyÃ¶tÃ¤ jo',0),(587259,16311,'fi','Useita merkintÃ¶jÃ¤ voidaan erottaa pilkuilla',0),(587260,16312,'fi','Tarvitaan ja on oltava yksilÃ¶llinen',0),(587261,16313,'fi','Tuonnin lasku muutokset',0),(587262,16314,'fi','MikÃ¤ tahansa arvo',0),(587263,16315,'fi','VÃ¤Ã¤rÃ¤',0),(587264,16316,'fi','EnsimmÃ¤inen & viimeinen nimi',0),(587265,16317,'fi','Tarvitaan numero',0),(587266,16318,'fi','NÃ¤ytÃ¤ lisÃ¤Ã¤',0),(587267,16319,'fi','NÃ¤ytÃ¤ valtion luetteloon',0),(587268,16320,'fi','Totta',0),(587269,16321,'fi','Valitse Kirjanpitotilin pÃ¤Ã¤tilin tai kustannuskoodi tai GL-luokka',0),(587270,16322,'fi','LÃ¤hettÃ¤Ã¤ sÃ¤hkÃ¶postitse ilmoituksia, kun Bill hyvÃ¤ksytty',0),(587271,16323,'fi','MaksupÃ¤ivÃ¤',0),(587272,16324,'fi','Toimittajan laskut on hyvÃ¤ksytty maksu',0),(587273,16325,'fi','Ostotilausten vastaanotot Bill',0),(587274,16326,'fi','Laskutusosoitteen postinumero, jos yksikÃ¤Ã¤n laiva ei',0),(587275,16327,'fi','Toimitusosoitteen postinumero',0),(587276,16328,'fi','NÃ¤ytÃ¤ aluksen postinumero',0),(587277,16329,'fi','Lajittele postinumero',0),(587278,16330,'fi','Valittu arvo',0),(587279,16331,'fi','AP suljettu',0),(587280,16332,'fi','AR suljettu',0),(587281,16333,'fi','Suora GL suljettu',0),(587282,16334,'fi','Varasto suljettu',0),(587283,16335,'fi','Osittain',0),(587284,16336,'fi','Palkanlaskennan suljettu',0),(587285,16337,'fi','Luo nyt',0),(587286,16338,'fi','Luonti onnistui',0),(587287,16339,'fi','Luo palautustapahtuma',0),(587288,16340,'fi','Viimeinen pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤ luo',0),(587289,16341,'fi','Viimeinen tapahtumapÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(587290,16342,'fi','Estetyt moduulit',0),(587291,16343,'fi','Voi Unpost tositteet',0),(587292,16344,'fi','Tositteet kirjaamattomien OK',0),(587293,16345,'fi','On oltava Toimittajatunnus tai toimittajan tai toimittajan nimi',0),(587294,16346,'fi','On oltava laskunumero ja Toimittajatunnus tai toimittajan tai toimittajan nimi ja ja kelvollinen tili',0),(587295,16347,'fi','On koodi',0),(587296,16348,'fi','Muita eriÃ¤ samaan laskuun tarvitsee vain Asiakastunnuksen tai asiakkaan tai yrityksen nimi tai ensimmÃ¤inen ja sukunimi ja laskunumero',0),(587297,16349,'fi','On oltava Asiakasnumero tai asiakkaan tai yrityksen nimi tai ensimmÃ¤inen ja sukunimi',0),(587298,16350,'fi','On oltava laskunumero ja Asiakasnumero tai asiakkaan koodin tai yrityksen nimi tai ensimmÃ¤inen ja sukunimi',0),(587299,16351,'fi','TyÃ¶n nimi on jo olemassa',0),(587300,16352,'fi','TyÃ¶ tÃ¤lle asiakkaalle on jo olemassa',0),(587301,16353,'fi','Projektinumero tyÃ¶tÃ¤ jo',0),(587302,16354,'fi','TyÃ¶paikan osoite on jo olemassa',0),(587303,16355,'fi','TyÃ¶ pÃ¤Ã¤ttÃ¤mispÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(587304,16356,'fi','Lattitude',0),(587305,16357,'fi','Leveysaste',0),(587306,16358,'fi','Prelimable pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(587307,16359,'fi','Luo toistuvat tapahtumat',0),(587308,16360,'fi','Yli PHP Max Input Vars',0),(587309,16361,'fi','Anna arvo',0),(587310,16362,'fi','NÃ¤ytÃ¤ aluksen postinumero',0),(587311,16363,'fi','TyÃ¶ tÃ¤lle asiakkaalle on jo olemassa',0),(587312,16364,'fi','TyÃ¶paikan osoite on jo olemassa',0),(587313,16365,'fi','TÃ¤mÃ¤ koodi tyÃ¶tÃ¤ jo',0),(587314,16366,'fi','TyÃ¶n nimi on jo olemassa',0),(587315,16298,'fr','Aucune dÃ©claration disponible',0),(587316,16299,'fr','Informations sur le produit',0),(587317,16300,'fr','Fiche produit',0),(587318,16301,'fr','Mot de passe invalide',0),(587319,16302,'fr','DÃ©finir un nouveau mot de passe',0),(587320,16303,'fr','Client ou emploi doit avoir la valeur',0),(587321,16304,'fr','Ne correspond pas Ã  la clientÃ¨le',0),(587322,16305,'fr','Importer les informations',0),(587323,16306,'fr','Importation facture client et changements dâ€™emploi',0),(587324,16307,'fr','Sortir par Code de coÃ»t',0),(587325,16308,'fr','Sortir de la catÃ©gorie GL',0),(587326,16309,'fr','GÃ©nÃ©rer des Ã©critures rÃ©currentes',0),(587327,16310,'fr','Un travail avec ce Code existe dÃ©jÃ ',0),(587328,16311,'fr','EntrÃ©es multiples peuvent Ãªtre sÃ©parÃ©es par des virgules',0),(587329,16312,'fr','NÃ©cessaires et doit Ãªtre Unique',0),(587330,16313,'fr','Changements de facture dâ€™importation',0),(587331,16314,'fr','Nâ€™importe quelle valeur',0),(587332,16315,'fr','Faux',0),(587333,16316,'fr','PremiÃ¨re & dernier nom',0),(587334,16317,'fr','Nombre attendu',0),(587335,16318,'fr','Afficher plus',0),(587336,16319,'fr','Ã‰tat de voir la liste',0),(587337,16320,'fr','Vrai',0),(587338,16321,'fr','Vous devez sÃ©lectionner un compte GL ou Code de coÃ»t ou une catÃ©gorie GL',0),(587339,16322,'fr','Envoyer des avis par courriel lorsque le projet de loi approuvÃ©',0),(587340,16323,'fr','Date de paiement',0),(587341,16324,'fr','Les factures du vendeur ont Ã©tÃ© approuvÃ©es pour paiement',0),(587342,16325,'fr','Recettes de PO sur ce projet de loi',0),(587343,16326,'fr','Code Postal de facturation si aucun navire Ã ',0),(587344,16327,'fr','ExpÃ©dier Ã  Code Postal',0),(587345,16328,'fr','Voir la Ship To Code Postal',0),(587346,16329,'fr','Trier par Code postal',0),(587347,16330,'fr','Aucune valeur sÃ©lectionnÃ©e',0),(587348,16331,'fr','AP fermÃ©',0),(587349,16332,'fr','AR fermÃ©',0),(587350,16333,'fr','Direct GL fermÃ©',0),(587351,16334,'fr','Inventaire fermÃ©',0),(587352,16335,'fr','Partiellement fermÃ©',0),(587353,16336,'fr','Masse salariale fermÃ©',0),(587354,16337,'fr','GÃ©nÃ©rer des maintenant',0),(587355,16338,'fr','GÃ©nÃ©rÃ© avec succÃ¨s',0),(587356,16339,'fr','GÃ©nÃ©rer lâ€™entrÃ©e inverse',0),(587357,16340,'fr','DerniÃ¨re Date gÃ©nÃ©rÃ©e',0),(587358,16341,'fr','DerniÃ¨re Date de la Transaction',0),(587359,16342,'fr','Modules bloquÃ©s',0),(587360,16343,'fr','Incapable de Unpost bons',0),(587361,16344,'fr','ChÃ¨ques non comptabilisÃ© OK',0),(587362,16345,'fr','Doit avoir un ID de fournisseur du vendeur ou fournisseur nom',0),(587363,16346,'fr','Doit avoir le numÃ©ro de facture et Vendor ID ou nom du vendeur et montant ou un Code fabricant et numÃ©ro de compte valide',0),(587364,16347,'fr','Doit Ãªtre un Code',0),(587365,16348,'fr','Des rubriques supplÃ©mentaires sur la mÃªme facture seulement besoin de lâ€™ID de client ou Code client ou nom de sociÃ©tÃ© ou premiÃ¨re et prÃ©nom et le numÃ©ro de facture',0),(587366,16349,'fr','Doit avoir un ID de client ou Code client ou nom de lâ€™entreprise ou premiÃ¨re et prÃ©nom',0),(587367,16350,'fr','Doit avoir le numÃ©ro de facture et client ID ou Code client ou nom de sociÃ©tÃ© ou premiÃ¨re et prÃ©nom',0),(587368,16351,'fr','Un travail avec ce nom existe dÃ©jÃ ',0),(587369,16352,'fr','Un travail pour ce client existe dÃ©jÃ ',0),(587370,16353,'fr','Un travail avec ce numÃ©ro de projet existe dÃ©jÃ ',0),(587371,16354,'fr','Un travail avec cette adresse existe dÃ©jÃ ',0),(587372,16355,'fr','Offre clÃ´turÃ©e Date',0),(587373,16356,'fr','Lattitude',0),(587374,16357,'fr','Longitude',0),(587375,16358,'fr','Date de prelimable',0),(587376,16359,'fr','GÃ©nÃ©rer des Ã©critures comptables rÃ©currentes',0),(587377,16360,'fr','Cours PHP entrÃ©e Max Vars',0),(587378,16361,'fr','Veuillez entrer une valeur pour',0),(587379,16362,'fr','Voir la Ship To Code Postal',0),(587380,16363,'fr','Un travail pour ce client existe dÃ©jÃ ',0),(587381,16364,'fr','Un travail avec cette adresse existe dÃ©jÃ ',0),(587382,16365,'fr','Un travail avec ce Code existe dÃ©jÃ ',0),(587383,16366,'fr','Un travail avec ce nom existe dÃ©jÃ ',0),(587384,16298,'de','Keine Aussage zur VerfÃ¼gung',0),(587385,16299,'de','Produkt-Info',0),(587386,16300,'de','Produktblatt',0),(587387,16301,'de','UngÃ¼ltiges Kennwort',0),(587388,16302,'de','Ein neues Kennwort festlegen',0),(587389,16303,'de','Kunden oder Job muss eingestellt werden',0),(587390,16304,'de','Kunde stimmt nicht Ã¼berein.',0),(587391,16305,'de','Import-Informationen',0),(587392,16306,'de','Import-Rechnungskunde und Jobwechsel',0),(587393,16307,'de','Ausbrechen von Kostencode',0),(587394,16308,'de','Ausbrechen von GL-Kategorie',0),(587395,16309,'de','Dauerbuchungen zu generieren',0),(587396,16310,'de','Ein Job mit diesem Code ist bereits vorhanden.',0),(587397,16311,'de','Mehrere EintrÃ¤ge kÃ¶nnen mit Kommas getrennt werden',0),(587398,16312,'de','Erforderlich und muss eindeutig sein',0),(587399,16313,'de','Import-Rechnung-Ã„nderungen',0),(587400,16314,'de','Jeder Wert',0),(587401,16315,'de','Falsche',0),(587402,16316,'de','Ersten & letzten Namen',0),(587403,16317,'de','Erwartete Anzahl',0),(587404,16318,'de','Mehr anzeigen',0),(587405,16319,'de','Show-Landesliste',0),(587406,16320,'de','Wahre',0),(587407,16321,'de','Sie mÃ¼ssen ein Hauptbuchkonto oder Kostencode / GL-Kategorie auswÃ¤hlen.',0),(587408,16322,'de','Senden Sie e-Mail-Benachrichtigungen, wenn Bill genehmigt',0),(587409,16323,'de','Zahlungsdatum',0),(587410,16324,'de','Lieferanten-Rechnungen sind fÃ¼r Zahlung genehmigt worden',0),(587411,16325,'de','PO-Quittungen auf dieses Gesetz',0),(587412,16326,'de','Postleitzahl Abrechnung, wenn kein Schiff zu',0),(587413,16327,'de','Versand nach Postleitzahl',0),(587414,16328,'de','Schiff PLZ zeigen',0),(587415,16329,'de','Sortieren nach Postleitzahl',0),(587416,16330,'de','Kein Wert ausgewÃ¤hlt',0),(587417,16331,'de','AP-geschlossen',0),(587418,16332,'de','AR geschlossen',0),(587419,16333,'de','Direkte GL geschlossen',0),(587420,16334,'de','Inventur geschlossen',0),(587421,16335,'de','Teilweise geschlossen',0),(587422,16336,'de','Lohn-und Gehaltsabrechnung geschlossen',0),(587423,16337,'de','Jetzt generieren',0),(587424,16338,'de','Erfolgreich generiert',0),(587425,16339,'de','Reverse Eintrag erzeugen',0),(587426,16340,'de','Datum der letzten generiert',0),(587427,16341,'de','Buchungsdatum der letzten',0),(587428,16342,'de','Blockierte Module',0),(587429,16343,'de','Nicht in der Lage, Gutscheine Unpost',0),(587430,16344,'de','Gutscheine Stellenangebot \"OK\"',0),(587431,16345,'de','Muss ein Hersteller-ID oder Lieferantencode oder Herstellernamen',0),(587432,16346,'de','Rechnungsnummer und Vendor-ID oder Lieferantencode oder Herstellernamen und Menge und gÃ¼ltige Kontonummer mÃ¼ssen',0),(587433,16347,'de','Ein Code muss',0),(587434,16348,'de','ZusÃ¤tzliche Posten In der gleichen Rechnung brauchen nur die Kunden-ID oder Kundencode oder Firmennamen oder erste und Nachname und der Rechnungsnummer',0),(587435,16349,'de','Eine Kunden-ID oder Kundencode oder Firmennamen oder vor- und Nachname mÃ¼ssen',0),(587436,16350,'de','Rechnungsnummer und Kundennummer oder Kundencode oder Firmennamen oder vor- und Nachname mÃ¼ssen',0),(587437,16351,'de','Ein Job mit diesem Namen ist bereits vorhanden.',0),(587438,16352,'de','Ein Job fÃ¼r diesen Debitor ist bereits vorhanden.',0),(587439,16353,'de','Ein Job mit dieser Projektnummer ist bereits vorhanden.',0),(587440,16354,'de','Ein Job mit dieser Adresse ist bereits vorhanden.',0),(587441,16355,'de','Job geschlossen Datum',0),(587442,16356,'de','Breitengrad',0),(587443,16357,'de','LÃ¤nge',0),(587444,16358,'de','Prelimable Datum',0),(587445,16359,'de','Wiederkehrende Posten erzeugen',0),(587446,16360,'de','Ãœber PHP Max Input Vars',0),(587447,16361,'de','Bitte geben Sie einen Wert fÃ¼r',0),(587448,16362,'de','Schiff PLZ zeigen',0),(587449,16363,'de','Ein Job fÃ¼r diesen Debitor ist bereits vorhanden.',0),(587450,16364,'de','Ein Job mit dieser Adresse ist bereits vorhanden.',0),(587451,16365,'de','Ein Job mit diesem Code ist bereits vorhanden.',0),(587452,16366,'de','Ein Job mit diesem Namen ist bereits vorhanden.',0),(587453,16298,'el','ÎšÎ±Î¼Î¯Î± Î´Î®Î»Ï‰ÏƒÎ· Ï€Î¿Ï… Î´Î¹Î±Ï„Î¯Î¸ÎµÏ„Î±Î¹',0),(587454,16299,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ Î³Î¹Î± Ï„Î¿ Ï€ÏÎ¿ÏŠÏŒÎ½',0),(587455,16300,'el','Î¦Ï…Î»Î»Î¬Î´Î¹Î¿ Ï€ÏÎ¿ÏŠÏŒÎ½Ï„Î¿Ï‚',0),(587456,16301,'el','ÎœÎ· Î­Î³ÎºÏ…ÏÎ¿ ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚',0),(587457,16302,'el','ÎŸÏÎ¯ÏƒÏ„Îµ Î­Î½Î± Î½Î­Î¿ ÏƒÏ…Î½Î¸Î·Î¼Î±Ï„Î¹ÎºÏŒ',0),(587458,16303,'el','Î ÎµÎ»Î¬Ï„Î· Î® ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎºÎ±Î¸Î¿ÏÎ¯Î¶Î¿Î½Ï„Î±Î¹',0),(587459,16304,'el','Î”ÎµÎ½ Ï„Î±Î¹ÏÎ¹Î¬Î¶ÎµÎ¹ Î¼Îµ Ï€ÎµÎ»Î¬Ï„Î·',0),(587460,16305,'el','Î Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(587461,16306,'el','Î‘Î»Î»Î±Î³Î® Î¸Î­ÏƒÎ·Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎºÎ±Î¹ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î® Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î·',0),(587462,16307,'el','ÎžÎµÏƒÏ€Î¬ÏƒÎµÎ¹ Î±Ï€ÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ±',0),(587463,16308,'el','ÎžÎµÏƒÏ€Î¬ÏƒÎµÎ¹ Î±Ï€ÏŒ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± GL',0),(587464,16309,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(587465,16310,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Î¹Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î¼Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ ÎºÏŽÎ´Î¹ÎºÎ±',0),(587466,16311,'el','Î Î¿Î»Î»Î±Ï€Î»Î­Ï‚ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚ Î¼Ï€Î¿ÏÎ¿ÏÎ½ Î½Î± Î´Î¹Î±Ï‡Ï‰ÏÎ¹ÏƒÏ„Î¿ÏÎ½ Î¼Îµ ÎºÏŒÎ¼Î¼Î±Ï„Î±',0),(587467,16312,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½Ï„Î±Î¹ ÎºÎ±Î¹ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î¼Î¿Î½Î±Î´Î¹ÎºÏŒ',0),(587468,16313,'el','Î‘Î»Î»Î±Î³Î­Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(587469,16314,'el','ÎŸÏ€Î¿Î¹Î±Î´Î®Ï€Î¿Ï„Îµ Ï„Î¹Î¼Î®',0),(587470,16315,'el','Î¨ÎµÏ…Î´ÎµÎ¯Ï‚',0),(587471,16316,'el','Î ÏÏŽÏ„Î· & Ï„ÎµÎ»ÎµÏ…Ï„Î±Î¯Î¿ ÏŒÎ½Î¿Î¼Î±',0),(587472,16317,'el','Î‘Î½Î±Î¼ÎµÎ½ÏŒÎ¼ÎµÎ½Î¿Ï‚ Î±ÏÎ¹Î¸Î¼ÏŒÏ‚',0),(587473,16318,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€ÎµÏÎ¹ÏƒÏƒÎ¿Ï„Î­ÏÏ‰Î½',0),(587474,16319,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ·Ï‚ Î»Î¯ÏƒÏ„Î±Ï‚',0),(587475,16320,'el','Î‘Î»Î®Î¸ÎµÎ¹Î±',0),(587476,16321,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î® Ï„Î¿ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÏ‰Î´Î¹ÎºÏŒ Î® GL ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î±',0),(587477,16322,'el','Î£Ï„ÎµÎ¯Î»Ï„Îµ Email ÎµÎ¹Î´Î¿Ï€Î¿Î¹Î®ÏƒÎµÎ¹Ï‚ ÏŒÏ„Î±Î½ ÎµÎ½Î­ÎºÏÎ¹Î½Îµ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(587478,16323,'el','Î Î»Î·ÏÏŽÏƒÎµÎ¹ ÏƒÎ®Î¼ÎµÏÎ±',0),(587479,16324,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ³ÎºÏÎ¹Î¸ÎµÎ¯ Î³Î¹Î± Ï€Î»Î·ÏÏ‰Î¼Î®',0),(587480,16325,'el','PO Î±Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ ÏƒÎµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î½Î¿Î¼Î¿ÏƒÏ‡Î­Î´Î¹Î¿',0),(587481,16326,'el','Î§ÏÎ­Ï‰ÏƒÎ·Ï‚ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒ ÎºÏŽÎ´Î¹ÎºÎ±, ÎµÎ¬Î½ ÎºÎ±Î½Î­Î½Î± Ï€Î»Î¿Î¯Î¿ Î½Î±',0),(587482,16327,'el','Î¤Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚',0),(587483,16328,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Î»Î¿Î¯Î¿ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(587484,16329,'el','Î¤Î±Î¾Î¹Î½ÏŒÎ¼Î·ÏƒÎ· ÎºÎ±Ï„Î¬ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒ ÎºÏŽÎ´Î¹ÎºÎ±',0),(587485,16330,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï„Î¹Î¼Î®',0),(587486,16331,'el','AP ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŒ',0),(587487,16332,'el','AR ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŒ',0),(587488,16333,'el','Î†Î¼ÎµÏƒÎ· GL ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŒ',0),(587489,16334,'el','ÎšÎ»ÎµÎ¯ÏƒÎ¹Î¼Î¿ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(587490,16335,'el','ÎœÎµÏÎ¹ÎºÏŽÏ‚ ÎºÎ»ÎµÎ¹ÏƒÏ„Î®',0),(587491,16336,'el','ÎœÎ¹ÏƒÎ¸Î¿Î´Î¿ÏƒÎ¯Î±Ï‚ ÎºÎ»ÎµÎ¹ÏƒÏ„ÏŒ',0),(587492,16337,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ Ï„ÏŽÏÎ±',0),(587493,16338,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³ÎµÎ¯Ï„Î±Î¹ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(587494,16339,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½ Î±Î½Ï„Î¯ÏƒÏ„ÏÎ¿Ï†Î· ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·',0),(587495,16340,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î¿ÏÎ½Ï„Î±Î¹',0),(587496,16341,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÏƒÏ…Î½Î±Î»Î»Î±Î³Î®Ï‚',0),(587497,16342,'el','Î‘Ï€Î¿ÎºÎ»ÎµÎ¹ÏƒÎ¼Î­Î½Î¿ ÎµÎ½ÏŒÏ„Î·Ï„ÎµÏ‚',0),(587498,16343,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯Ï„Îµ Î½Î± Unpost ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹Î±',0),(587499,16344,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹Î± Î¼Î· Î±Î½Î±ÏÏ„Î·Î¼Î­Î½ÎµÏ‚ OK',0),(587500,16345,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î­Î½Î± Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î® ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î® ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(587501,16346,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… ÎºÎ±Î¹ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î® ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Î® ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® ÎºÎ±Î¹ Ï€Î¿ÏƒÏŒ ÎºÎ±Î¹ Î­Î³ÎºÏ…ÏÎ¿ Î±ÏÎ¹Î¸Î¼ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±Ïƒ',0),(587502,16347,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯Î½Î±Î¹ Î­Î½Î±Ï‚ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚',0),(587503,16348,'el','Î ÏÏŒÏƒÎ¸ÎµÏ„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î³ÏÎ±Î¼Î¼Î®Ï‚ ÏƒÏ„Î¿ Î¯Î´Î¹Î¿ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Î¼ÏŒÎ½Î¿ Ï€Î¿Ï… Ï‡ÏÎµÎ¹Î¬Î¶ÎµÏ„Î±Î¹ ÎµÎ¯Î½Î±Î¹ Ï„Î¿ Î±Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï„Î¿Ï… Ï€ÎµÎ»Î¬Ï„Î· Î® ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î· Î® Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±',0),(587504,16349,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î­Î½Î± Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î· Î® ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î· Î® Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î® Ï€ÏÏŽÏ„Î¿ ÎºÎ±Î¹ ÎµÏ€ÏŽÎ½Ï…Î¼Î¿',0),(587505,16350,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î­Ï‡ÎµÏ„Îµ Î±ÏÎ¹Î¸Î¼ÏŒ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï… ÎºÎ±Î¹ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î· Î® ÎºÏ‰Î´Î¹ÎºÏŒ Ï€ÎµÎ»Î¬Ï„Î· Î® Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï„Î·Ï‚ ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚ Î® Ï€ÏÏŽÏ„Î¿ ÎºÎ±Î¹ ÎµÏ€ÏŽÎ½Ï…Î¼Î¿',0),(587506,16351,'el','ÎœÎ¹Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(587507,16352,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Î¹Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(587508,16353,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Î¹Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ Ï€ÏÏŒÏ„Î¶ÎµÎºÏ„',0),(587509,16354,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Î¹Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î¼Îµ Î±Ï…Ï„Î® Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(587510,16355,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± ÎºÎ»ÎµÎ¹ÏƒÎ¯Î¼Î±Ï„Î¿Ï‚ Î¸Î­ÏƒÎµÏ‰Î½ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(587511,16356,'el','Lattitude',0),(587512,16357,'el','Î“ÎµÏ‰Î³ÏÎ±Ï†Î¹ÎºÏŒ Î¼Î®ÎºÎ¿Ï‚',0),(587513,16358,'el','Prelimable Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(587514,16359,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÏ„Îµ ÎµÏ€Î±Î½Î±Î»Î±Î¼Î²Î±Î½ÏŒÎ¼ÎµÎ½ÎµÏ‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚',0),(587515,16360,'el','Î Î­ÏÎ± Î±Ï€ÏŒ Ï„Î·Î½ PHP Max ÎµÎ¹ÏƒÏŒÎ´Î¿Ï… Vars',0),(587516,16361,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÎ¹ÏƒÎ¬Î³ÎµÏ„Îµ Î¼Î¹Î± Ï„Î¹Î¼Î® Î³Î¹Î±',0),(587517,16362,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· Ï€Î»Î¿Î¯Î¿ Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚',0),(587518,16363,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Î¹Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿Î½ Ï€ÎµÎ»Î¬Ï„Î·',0),(587519,16364,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Î¹Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î¼Îµ Î±Ï…Ï„Î® Ï„Î· Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(587520,16365,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î¼Î¹Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î¼Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ ÎºÏŽÎ´Î¹ÎºÎ±',0),(587521,16366,'el','ÎœÎ¹Î± Î´Î¿Ï…Î»ÎµÎ¹Î¬ Î¼Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ ÏŒÎ½Î¿Î¼Î± Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(587522,16298,'he','××™×Ÿ ×”×¦×”×¨×” ×–×ž×™×Ÿ',0),(587523,16299,'he','×ž×™×“×¢ ×¢×œ ×”×ž×•×¦×¨',0),(587524,16300,'he','×’×™×œ×™×•×Ÿ ×”×ž×•×¦×¨',0),(587525,16301,'he','×¡×™×¡×ž×” ×œ× ×—×•×§×™×ª',0),(587526,16302,'he','×œ×”×’×“×™×¨ ×¡×™×¡×ž×” ×—×“×©×”',0),(587527,16303,'he','×œ×§×•×— ××• ×¢×‘×•×“×” ×—×™×™×‘ ×œ×”×™×•×ª ×ž×•×’×“×¨',0),(587528,16304,'he','××™× ×• ×ª×•×× ×œ×§×•×—',0),(587529,16305,'he','×™×™×‘×•× ×ž×™×“×¢',0),(587530,16306,'he','×™×‘× ×—×©×‘×•× ×™×ª ×”×œ×§×•×— ×•×©×™× ×•×™×™× ×”×¢×‘×•×“×”',0),(587531,16307,'he','×œ×¤×¨×•×¥ ×”×—×•×¦×” ×¢×œ-×™×“×™ ×§×•×“ ×¢×œ×•×ª',0),(587532,16308,'he','×œ×¤×¨×•×¥ ×œ×¤×™ ×§×˜×’×•×¨×™×” GL',0),(587533,16309,'he','×œ×™×¦×•×¨ ×¢×¨×›×™× ×—×•×–×¨×™×',0),(587534,16310,'he','×¢×‘×•×“×” ×¢× ×”×§×•×“ ×”×–×” ×›×‘×¨ ×§×™×™×',0),(587535,16311,'he','×¢×¨×›×™× ×ž×¨×•×‘×™× ×™×›×•×œ×™× ×œ×”×™×•×ª ×ž×•×¤×¨×“×™× ×‘××ž×¦×¢×•×ª ×¤×¡×™×§×™×',0),(587536,16312,'he','× ×“×¨×© ×• ×—×™×™×‘ ×œ×”×™×•×ª ×™×™×—×•×“×™',0),(587537,16313,'he','×™×‘× ×—×©×‘×•× ×™×ª ×©×™× ×•×™×™×',0),(587538,16314,'he','×›×œ ×¢×¨×š',0),(587539,16315,'he','×©×•×•×',0),(587540,16316,'he','×”×©× ×”×¨××©×•×Ÿ & ×”××—×¨×•×Ÿ',0),(587541,16317,'he','×”×ž×¡×¤×¨ ×”×¦×¤×•×™',0),(587542,16318,'he','×œ×”×¨××•×ª ×™×•×ª×¨',0),(587543,16319,'he','×‘×¨×©×™×ž×” ×”×¦×’ ×ž×¦×‘',0),(587544,16320,'he','× ×›×•×Ÿ',0),(587545,16321,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×—×©×‘×•×Ÿ GL ××• ×§×•×“ ×¢×œ×•×ª ××• ×§×˜×’×•×¨×™×” GL',0),(587546,16322,'he','×œ×©×œ×•×— ×”×•×“×¢×•×ª ×“×•××¨ ××œ×§×˜×¨×•× ×™ ×›××©×¨ ×‘×™×œ ×ž××•×©×¨×•×ª',0),(587547,16323,'he','×œ×©×œ× ×ª××¨×™×š',0),(587548,16324,'he','×”×¡×¤×§ ×”×—×©×‘×•× ×•×ª ××•×©×¨×• ×œ×ª×©×œ×•×',0),(587549,16325,'he','×”×§×‘×œ×•×ª ×©×œ ×”×–×ž× ×•×ª ×¨×›×© ×œ×¤×™ ×”×—×•×§',0),(587550,16326,'he','×—×™×•×‘ ×ž×™×§×•×“ ×× ××™×Ÿ ×œ×¡×¤×™× ×”',0),(587551,16327,'he','×œ×ž×©×œ×•×— ×ž×™×§×•×“',0),(587552,16328,'he','×”×¦×’ ×”×¡×¤×™× ×” ×›×“×™ ×ž×™×§×•×“',0),(587553,16329,'he','×ž×™×™×Ÿ ×œ×¤×™ ×ž×™×§×•×“',0),(587554,16330,'he','××™×Ÿ ×¢×¨×š × ×‘×—×¨',0),(587555,16331,'he','AP ×¡×’×•×¨',0),(587556,16332,'he','AR ×¡×’×•×¨',0),(587557,16333,'he','GL ×™×©×™×¨×” ×¡×’×•×¨',0),(587558,16334,'he','×”×ž×œ××™ ×¡×’×•×¨',0),(587559,16335,'he','×¡×’×•×¨ ×—×œ×§×™×ª',0),(587560,16336,'he','×ž×©×›×•×¨×•×ª ×¡×’×•×¨',0),(587561,16337,'he','×¦×•×¨ ×¢×›×©×™×•',0),(587562,16338,'he','× ×•×¦×¨ ×‘×”×¦×œ×—×”',0),(587563,16339,'he','×™×•×¦×¨×•×ª ×¢×¨×š ×”×¤×•×š',0),(587564,16340,'he','×”×ª××¨×™×š ×”××—×¨×•×Ÿ ×©× ×•×¦×¨ ×¢×œ ×™×“×™',0),(587565,16341,'he','×ª××¨×™×š ×”×ª× ×•×¢×” ×”××—×¨×•× ×”',0),(587566,16342,'he','×ž×•×“×•×œ×™× ×—×¡×•×ž×™×',0),(587567,16343,'he','××™×Ÿ ××¤×©×¨×•×ª Unpost ×©×•×‘×¨×™×',0),(587568,16344,'he','×©×•×‘×¨×™× × ×¨×©×ž×” ×‘×¡×“×¨',0),(587569,16345,'he','×—×™×™×‘×ª ×œ×›×œ×•×œ ×ž×–×”×” ×¡×¤×§ ××• ×§×•×“ ×¡×¤×§ ××• ×©× ×”×¡×¤×§',0),(587570,16346,'he','×—×™×™×‘ ×œ×”×™×•×ª ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª, ×ž×–×”×” ×¡×¤×§ ××• ×§×•×“ ×¡×¤×§ ××• ×©× ×”×¡×¤×§, ×›×ž×•×ª ×•×ž×¡×¤×¨ ×—×©×‘×•×Ÿ ×—×•×§×™',0),(587571,16347,'he','×¦×¨×™×š ×œ×”×™×•×ª ×§×•×“',0),(587572,16348,'he','×¤×¨×™×˜×™× × ×•×¡×¤×™× ×©×•×¨×” ×‘×—×©×‘×•× ×™×ª ××•×ª×• ×¦×¨×™×š ×¨×§ ××ª ×–×”×•×ª ×”×œ×§×•×— ××• ×§×•×“ ×”×œ×§×•×— ××• ×©× ×”×—×‘×¨×” ××• ×”×¤×¨×˜×™ ×•××ª ×©× ×”×ž×©×¤×—×” ×ž×¡×¤×¨ ×”×—×©×‘×•× ×™×ª',0),(587573,16349,'he','×—×™×™×‘ ×œ×”×™×•×ª ×ž×–×”×” ×œ×§×•×— ××• ×§×•×“ ×”×œ×§×•×— ××• ×©× ×”×—×‘×¨×” ××• ×”×¤×¨×˜×™ ×•×©× ×”×ž×©×¤×—×”',0),(587574,16350,'he','×—×™×™×‘ ×œ×”×™×•×ª ×ž×¡×¤×¨ ×—×©×‘×•× ×™×ª, ×ž×–×”×” ×œ×§×•×— ××• ×§×•×“ ×”×œ×§×•×— ××• ×©× ×”×—×‘×¨×” ××• ×”×¨××©×•×Ÿ ×•×©× ×”×ž×©×¤×—×”',0),(587575,16351,'he','×¢×‘×•×“×” ×‘×©× ×–×” ×›×‘×¨ ×§×™×™×',0),(587576,16352,'he','×¢×‘×•×“×” ×¢×‘×•×¨ ×œ×§×•×— ×–×” ×›×‘×¨ ×§×™×™×',0),(587577,16353,'he','×¢×‘×•×“×” ×¢× ×ž×¡×¤×¨ ×”×¤×¨×•×™×™×§×˜ ×”×–×” ×›×‘×¨ ×§×™×™×',0),(587578,16354,'he','×¢×‘×•×“×” ×¢× ×›×ª×•×‘×ª ×–×• ×›×‘×¨ ×§×™×™×ž×ª',0),(587579,16355,'he','×”×¢×‘×•×“×” ×¡×’×•×¨ ×ª××¨×™×š',0),(587580,16356,'he','Lattitude',0),(587581,16357,'he','×§×• ××•×¨×š',0),(587582,16358,'he','×ª××¨×™×š prelimable',0),(587583,16359,'he','×œ×™×¦×•×¨ ×¤×§×•×“×•×ª ×™×•×ž×Ÿ ×—×•×–×¨×•×ª',0),(587584,16360,'he','×¢×œ PHP ×ž×§×¡ ×§×œ×˜ Vars',0),(587585,16361,'he','× × ×”×–×Ÿ ×¢×¨×š ×¢×‘×•×¨',0),(587586,16362,'he','×”×¦×’ ×”×¡×¤×™× ×” ×›×“×™ ×ž×™×§×•×“',0),(587587,16363,'he','×¢×‘×•×“×” ×¢×‘×•×¨ ×œ×§×•×— ×–×” ×›×‘×¨ ×§×™×™×',0),(587588,16364,'he','×¢×‘×•×“×” ×¢× ×›×ª×•×‘×ª ×–×• ×›×‘×¨ ×§×™×™×ž×ª',0),(587589,16365,'he','×¢×‘×•×“×” ×¢× ×”×§×•×“ ×”×–×” ×›×‘×¨ ×§×™×™×',0),(587590,16366,'he','×¢×‘×•×“×” ×‘×©× ×–×” ×›×‘×¨ ×§×™×™×',0),(587591,16298,'hi','à¤•à¥‹à¤ˆ à¤•à¤¥à¤¨ à¤‰à¤ªà¤²à¤¬à¥à¤§',0),(587592,16299,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€',0),(587593,16300,'hi','à¤‰à¤¤à¥à¤ªà¤¾à¤¦ à¤ªà¤¤à¥à¤°à¤•',0),(587594,16301,'hi','à¤…à¤®à¤¾à¤¨à¥à¤¯ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡',0),(587595,16302,'hi','à¤à¤• à¤¨à¤¯à¤¾ à¤ªà¤¾à¤¸à¤µà¤°à¥à¤¡ à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(587596,16303,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¯à¤¾ à¤•à¤¾à¤°à¥à¤¯ à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(587597,16304,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤¸à¥‡ à¤®à¥‡à¤² à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¥€',0),(587598,16305,'hi','à¤¸à¥‚à¤šà¤¨à¤¾ à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(587599,16306,'hi','à¤†à¤¯à¤¾à¤¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤”à¤° à¤¨à¥Œà¤•à¤°à¥€ à¤®à¥‡à¤‚ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(587600,16307,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¬à¤¾à¤¹à¤° à¤¤à¥‹à¤¡à¤¼',0),(587601,16308,'hi','GL à¤¶à¥à¤°à¥‡à¤£à¥€ à¤¸à¥‡ à¤¬à¤¾à¤¹à¤° à¤¤à¥‹à¤¡à¤¼',0),(587602,16309,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(587603,16310,'hi','à¤‡à¤¸ à¤•à¥‹à¤¡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤•à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(587604,16311,'hi','à¤à¤•à¤¾à¤§à¤¿à¤• à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤…à¤²à¥à¤ªà¤µà¤¿à¤°à¤¾à¤® à¤¸à¥‡ à¤…à¤²à¤— à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(587605,16312,'hi','à¤†à¤µà¤¶à¥à¤¯à¤• à¤”à¤° à¤…à¤¨à¤¨à¥à¤¯ à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ',0),(587606,16313,'hi','à¤†à¤¯à¤¾à¤¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨',0),(587607,16314,'hi','à¤•à¥‹à¤ˆ à¤­à¥€ à¤®à¤¾à¤¨',0),(587608,16315,'hi','à¤à¥‚à¤ à¥€',0),(587609,16316,'hi','à¤ªà¤¹à¤²à¥‡ & à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤®',0),(587610,16317,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤…à¤ªà¥‡à¤•à¥à¤·à¤¿à¤¤',0),(587611,16318,'hi','à¤…à¤§à¤¿à¤• à¤¦à¤¿à¤–à¤¾à¤à¤',0),(587612,16319,'hi','à¤¶à¥‹ à¤°à¤¾à¤œà¥à¤¯ à¤¸à¥‚à¤šà¥€',0),(587613,16320,'hi','à¤¸à¤š',0),(587614,16321,'hi','à¤†à¤ª à¤à¤• GL à¤–à¤¾à¤¤à¥‡ à¤¯à¤¾ à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤¯à¤¾ GL à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(587615,16322,'hi','à¤ˆ-à¤®à¥‡à¤² à¤¸à¥‚à¤šà¤¨à¤¾à¤à¤ à¤­à¥‡à¤œà¥‡à¤‚ à¤œà¤¬ à¤µà¤¿à¤§à¥‡à¤¯à¤• à¤•à¥‹ à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥€',0),(587616,16323,'hi','à¤¤à¤¿à¤¥à¤¿ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(587617,16324,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤…à¤¨à¥à¤®à¥‹à¤¦à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(587618,16325,'hi','à¤‡à¤¸ à¤¬à¤¿à¤² à¤ªà¤° à¤ªà¥‹à¤¸à¥à¤Ÿ à¤‘à¤«à¤¼à¤¿à¤¸ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤à¤¿ à¤¸à¥‚à¤šà¤¨à¤¾',0),(587619,16326,'hi','à¤¯à¤¦à¤¿ à¤•à¥‹à¤ˆ à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤²à¤¿à¤‚à¤— à¤ªà¥‹à¤¸à¥à¤Ÿà¤² à¤•à¥‹à¤¡',0),(587620,16327,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¾à¤• à¤•à¥‹à¤¡',0),(587621,16328,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¾à¤• à¤•à¥‹à¤¡ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(587622,16329,'hi','à¤œà¤¼à¤¿à¤ª à¤•à¥‹à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¸à¥‰à¤°à¥à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(587623,16330,'hi','à¤•à¥‹à¤ˆ à¤®à¤¾à¤¨ à¤šà¤¯à¤¨à¤¿à¤¤',0),(587624,16331,'hi','AP à¤¬à¤‚à¤¦',0),(587625,16332,'hi','AR à¤¬à¤‚à¤¦',0),(587626,16333,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· GL à¤¬à¤‚à¤¦',0),(587627,16334,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¬à¤‚à¤¦',0),(587628,16335,'hi','à¤†à¤‚à¤¶à¤¿à¤• à¤°à¥‚à¤ª à¤¸à¥‡ à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(587629,16336,'hi','à¤µà¥‡à¤¤à¤¨ à¤¬à¤‚à¤¦',0),(587630,16337,'hi','à¤…à¤¬ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨',0),(587631,16338,'hi','à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨',0),(587632,16339,'hi','à¤°à¤¿à¤µà¤°à¥à¤¸ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(587633,16340,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¤à¤¿à¤¥à¤¿ à¤‰à¤¤à¥à¤ªà¤¨à¥à¤¨',0),(587634,16341,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤•à¥€ à¤…à¤‚à¤¤à¤¿à¤® à¤¤à¤¿à¤¥à¤¿',0),(587635,16342,'hi','à¤¬à¥à¤²à¥‰à¤• à¤•à¤¿à¤ à¤—à¤ à¤®à¥‰à¤¡à¥à¤¯à¥‚à¤²',0),(587636,16343,'hi','à¤µà¤¾à¤‰à¤šà¤° Unpost à¤•à¤°à¤¨à¥‡ à¤®à¥‡à¤‚ à¤…à¤¸à¤®à¤°à¥à¤¥',0),(587637,16344,'hi','Unposted OK à¤µà¤¾à¤‰à¤šà¤°',0),(587638,16345,'hi','à¤à¤• à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ ID à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹à¤¡ à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤¾ à¤¨à¤¾à¤® à¤¹à¥‹à¤¨à¤¾ à¤†à¤µà¤¶à¥à¤¯à¤• à¤¹à¥ˆ',0),(587639,16346,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤”à¤° à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ ID à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹à¤¡ à¤¯à¤¾ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‡ à¤¨à¤¾à¤® à¤”à¤° à¤°à¤¾à¤¶à¤¿ à¤”à¤° à¤®à¤¾à¤¨à¥à¤¯ à¤–à¤¾à¤¤à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤¹à¥‹à¤¨à¥€ à¤š',0),(587640,16347,'hi','à¤à¤• à¤•à¥‹à¤¡ à¤•à¥€ à¤œà¤°à¥‚à¤°à¤¤',0),(587641,16348,'hi','à¤¸à¤®à¤¾à¤¨ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤®à¥‡à¤‚ à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡à¤µà¤² à¤—à¥à¤°à¤¾à¤¹à¤• ID à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹à¤¡ à¤¯à¤¾ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® à¤”à¤° à¤…à¤‚à¤¤à¤¿à¤®',0),(587642,16349,'hi','à¤à¤• à¤—à¥à¤°à¤¾à¤¹à¤• ID à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹à¤¡ à¤¯à¤¾ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® à¤”à¤° à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(587643,16350,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤”à¤° à¤—à¥à¤°à¤¾à¤¹à¤• ID à¤¯à¤¾ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‹à¤¡ à¤¯à¤¾ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤ªà¥à¤°à¤¥à¤® à¤”à¤° à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(587644,16351,'hi','à¤‡à¤¸ à¤¨à¤¾à¤® à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤•à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(587645,16352,'hi','à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤•à¤¾à¤°à¥à¤¯ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(587646,16353,'hi','à¤¯à¤¹ à¤ªà¤°à¤¿à¤¯à¥‹à¤œà¤¨à¤¾ à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤•à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(587647,16354,'hi','à¤‡à¤¸ à¤ªà¤¤à¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤•à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(587648,16355,'hi','à¤•à¤¾à¤® à¤¬à¤‚à¤¦ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(587649,16356,'hi','Lattitude',0),(587650,16357,'hi','à¤¦à¥‡à¤¶à¤¾à¤‚à¤¤à¤°',0),(587651,16358,'hi','Prelimable à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(587652,16359,'hi','à¤ªà¥à¤¨à¤°à¤¾à¤µà¤°à¥à¤¤à¥€ à¤²à¥‡à¤œà¤¼à¤° à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤ à¤œà¤¨à¤°à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(587653,16360,'hi','PHP à¤ªà¤° à¤…à¤§à¤¿à¤•à¤¤à¤® à¤‡à¤¨à¤ªà¥à¤Ÿ à¤µà¤¾à¤°à¥à¤¸',0),(587654,16361,'hi','à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤®à¤¾à¤¨ à¤¦à¤°à¥à¤œ à¤•à¤°à¥‡à¤‚',0),(587655,16362,'hi','à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¾à¤• à¤•à¥‹à¤¡ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(587656,16363,'hi','à¤‡à¤¸ à¤—à¥à¤°à¤¾à¤¹à¤• à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤•à¤¾à¤°à¥à¤¯ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(587657,16364,'hi','à¤‡à¤¸ à¤ªà¤¤à¥‡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤•à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(587658,16365,'hi','à¤‡à¤¸ à¤•à¥‹à¤¡ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤•à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(587659,16366,'hi','à¤‡à¤¸ à¤¨à¤¾à¤® à¤•à¥‡ à¤¸à¤¾à¤¥ à¤à¤• à¤•à¤¾à¤® à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(587660,16298,'id','Tidak ada pernyataan yang tersedia',0),(587661,16299,'id','Info Produk',0),(587662,16300,'id','Produk Sheet',0),(587663,16301,'id','Password tidak valid',0),(587664,16302,'id','Menetapkan kata sandi baru',0),(587665,16303,'id','Pelanggan atau pekerjaan harus ditetapkan',0),(587666,16304,'id','Tidak cocok pelanggan',0),(587667,16305,'id','Mengimpor informasi',0),(587668,16306,'id','Impor faktur pelanggan dan perubahan pekerjaan',0),(587669,16307,'id','Keluar oleh biaya kode',0),(587670,16308,'id','Keluar GL Kategori',0),(587671,16309,'id','Menghasilkan berulang entri',0),(587672,16310,'id','Pekerjaan dengan kode ini sudah ada',0),(587673,16311,'id','Beberapa entri dapat dipisahkan dengan koma',0),(587674,16312,'id','Diperlukan dan harus unik',0),(587675,16313,'id','Impor faktur perubahan',0),(587676,16314,'id','Nilai apapun',0),(587677,16315,'id','Palsu',0),(587678,16316,'id','Nama pertama & terakhir',0),(587679,16317,'id','Jumlah yang diharapkan',0),(587680,16318,'id','Selengkapnya',0),(587681,16319,'id','Daftar negara Tampilkan',0),(587682,16320,'id','Benar',0),(587683,16321,'id','Anda harus memilih akun GL atau biaya kode atau kategori GL',0),(587684,16322,'id','Mengirim Email pemberitahuan ketika Bill disetujui',0),(587685,16323,'id','Membayar tanggal',0),(587686,16324,'id','Penjual tagihan telah disetujui untuk pembayaran',0),(587687,16325,'id','PO penerimaan pada RUU ini',0),(587688,16326,'id','Penagihan kode pos jika ada kapal untuk',0),(587689,16327,'id','Kapal ke kode pos',0),(587690,16328,'id','Tampilkan kapal untuk kode pos',0),(587691,16329,'id','Urutkan kode pos',0),(587692,16330,'id','Tidak ada nilai yang dipilih',0),(587693,16331,'id','AP ditutup',0),(587694,16332,'id','AR ditutup',0),(587695,16333,'id','Langsung GL ditutup',0),(587696,16334,'id','Persediaan ditutup',0),(587697,16335,'id','Sebagian ditutup',0),(587698,16336,'id','Penggajian ditutup',0),(587699,16337,'id','Menghasilkan sekarang',0),(587700,16338,'id','Dihasilkan berhasil',0),(587701,16339,'id','Menghasilkan Reverse entri',0),(587702,16340,'id','Tanggal terakhir yang dihasilkan',0),(587703,16341,'id','Tanggal transaksi terakhir',0),(587704,16342,'id','Modul-modul yang diblokir',0),(587705,16343,'id','Mampu Unpost voucher',0),(587706,16344,'id','Voucher Unposted OK',0),(587707,16345,'id','Harus memiliki Vendor ID atau Vendor kode atau nama Penjual',0),(587708,16346,'id','Harus memiliki nomor Invoice dan Vendor ID atau Vendor kode atau nama Penjual dan jumlah dan nomor rekening berlaku',0),(587709,16347,'id','Perlu kode',0),(587710,16348,'id','Item baris tambahan di faktur sama hanya perlu ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir dan nomor faktur',0),(587711,16349,'id','Harus memiliki ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir',0),(587712,16350,'id','Harus memiliki nomor Invoice dan ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir',0),(587713,16351,'id','Pekerjaan dengan nama ini sudah ada',0),(587714,16352,'id','Pekerjaan untuk pelanggan ini sudah ada',0),(587715,16353,'id','Pekerjaan dengan jumlah proyek ini sudah ada',0),(587716,16354,'id','Pekerjaan dengan alamat ini sudah ada',0),(587717,16355,'id','Pekerjaan ditutup tanggal',0),(587718,16356,'id','Tipe Latitude',0),(587719,16357,'id','Bujur',0),(587720,16358,'id','Tanggal prelimable',0),(587721,16359,'id','Menghasilkan berulang entri buku besar',0),(587722,16360,'id','Lebih dari PHP Max Input Vars',0),(587723,16361,'id','Masukkan nilai untuk',0),(587724,16362,'id','Tampilkan kapal untuk kode pos',0),(587725,16363,'id','Pekerjaan untuk pelanggan ini sudah ada',0),(587726,16364,'id','Pekerjaan dengan alamat ini sudah ada',0),(587727,16365,'id','Pekerjaan dengan kode ini sudah ada',0),(587728,16366,'id','Pekerjaan dengan nama ini sudah ada',0),(587729,16298,'it','Nessuna dichiarazione disponibile',0),(587730,16299,'it','Info prodotto',0),(587731,16300,'it','Scheda prodotto',0),(587732,16301,'it','Password non valida',0),(587733,16302,'it','Impostare una nuova password',0),(587734,16303,'it','Cliente o lavoro deve essere impostato',0),(587735,16304,'it','Non corrisponde a cliente',0),(587736,16305,'it','Importare informazioni',0),(587737,16306,'it','Importazione fattura cliente e cambi di lavoro',0),(587738,16307,'it','Uscire dal codice costo',0),(587739,16308,'it','Break Out di categoria GL',0),(587740,16309,'it','Generare le registrazioni periodiche',0),(587741,16310,'it','Esiste giÃ  un processo con questo codice',0),(587742,16311,'it','PiÃ¹ voci possono essere separate con virgole',0),(587743,16312,'it','Necessaria e deve essere univoco',0),(587744,16313,'it','Cambiamenti di fattura Import',0),(587745,16314,'it','Qualsiasi valore',0),(587746,16315,'it','False',0),(587747,16316,'it','Nome primo & ultimo',0),(587748,16317,'it','Numero previsto',0),(587749,16318,'it','Mostra dettagli',0),(587750,16319,'it','Elenco Visualizza stato',0),(587751,16320,'it','Vero',0),(587752,16321,'it','Ãˆ necessario selezionare un conto di contabilitÃ  generale o codice di costo o una categoria GL',0),(587753,16322,'it','Inviare avvisi E-mail quando Bill approvato',0),(587754,16323,'it','Data di pagamento',0),(587755,16324,'it','Le fatture fornitore sono state approvate per il pagamento',0),(587756,16325,'it','PO le ricevute su questo disegno di legge',0),(587757,16326,'it','Codice postale di fatturazione se nessuna nave a',0),(587758,16327,'it','Spedire a codice postale',0),(587759,16328,'it','Visualizza nave per codice postale',0),(587760,16329,'it','Ordina per codice postale',0),(587761,16330,'it','Nessun valore selezionato',0),(587762,16331,'it','AP chiuso',0),(587763,16332,'it','AR chiuso',0),(587764,16333,'it','Diretto GL chiuso',0),(587765,16334,'it','Chiuso per inventario',0),(587766,16335,'it','Parzialmente chiuso',0),(587767,16336,'it','Delle retribuzioni chiusa',0),(587768,16337,'it','Generare ora',0),(587769,16338,'it','Generato con successo',0),(587770,16339,'it','Generare la voce inversa',0),(587771,16340,'it','Data dell\'ultimo generato',0),(587772,16341,'it','Ultima data di transazione',0),(587773,16342,'it','Moduli bloccati',0),(587774,16343,'it','Grado di Unpost buoni',0),(587775,16344,'it','Buoni non registrate OK',0),(587776,16345,'it','Deve avere un ID fornitore o codice fornitore o nome del fornitore',0),(587777,16346,'it','Deve avere il numero di fattura e ID fornitore o codice fornitore o nome del fornitore e quantitÃ  e numero di Account valido',0),(587778,16347,'it','Deve essere un codice',0),(587779,16348,'it','Voci addizionali nella stessa fattura solo bisogno l\'ID cliente o codice cliente o nome della societÃ  o primo e cognome e il numero della fattura',0),(587780,16349,'it','Deve avere un ID cliente o codice cliente o nome della societÃ  o nome e cognome',0),(587781,16350,'it','Deve avere il numero di fattura e ID cliente o codice cliente o nome della societÃ  o nome e cognome',0),(587782,16351,'it','Un lavoro con questo nome esiste giÃ ',0),(587783,16352,'it','Esiste giÃ  un processo per il cliente',0),(587784,16353,'it','Esiste giÃ  un processo con questo numero di progetto',0),(587785,16354,'it','Esiste giÃ  un processo con questo indirizzo',0),(587786,16355,'it','Lavoro chiuso data',0),(587787,16356,'it','Lattitude',0),(587788,16357,'it','Longitudine',0),(587789,16358,'it','Data di prelimable',0),(587790,16359,'it','Generare le registrazioni contabili periodiche',0),(587791,16360,'it','Oltre PHP Max ingresso Vars',0),(587792,16361,'it','Si prega di inserire un valore per',0),(587793,16362,'it','Visualizza nave per codice postale',0),(587794,16363,'it','Esiste giÃ  un processo per il cliente',0),(587795,16364,'it','Esiste giÃ  un processo con questo indirizzo',0),(587796,16365,'it','Esiste giÃ  un processo con questo codice',0),(587797,16366,'it','Un lavoro con questo nome esiste giÃ ',0),(587867,16298,'ko','ì•„ë‹ˆ ì„±ëª… ì‚¬ìš©í•  ìˆ˜',0),(587868,16299,'ko','ì œí’ˆ ì •ë³´',0),(587869,16300,'ko','ì œí’ˆ ì‹œíŠ¸',0),(587870,16301,'ko','ìž˜ëª» ëœ ì•”í˜¸',0),(587871,16302,'ko','ìƒˆ ì•”í˜¸ ì„¤ì •',0),(587872,16303,'ko','ê³ ê° ë˜ëŠ” ìž‘ì—…ì„ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(587873,16304,'ko','ê³ ê°ì„ ì¼ì¹˜ í•˜ì§€ ì•ŠìŠµë‹ˆë‹¤.',0),(587874,16305,'ko','ê°€ì ¸ì˜¤ê¸° ì •ë³´',0),(587875,16306,'ko','ê°€ì ¸ì˜¤ê¸° ì†¡ìž¥ ê³ ê° ë° ìž‘ì—… ë³€ê²½',0),(587876,16307,'ko','ë¹„ìš©ëœ ì½”ë“œì— ì˜í•´ íƒˆì¶œ',0),(587877,16308,'ko','GL ì¹´í…Œê³ ë¦¬ì— ì˜í•´ íƒˆì¶œ',0),(587878,16309,'ko','ë˜í’€ì´ í•­ëª© ìƒì„±',0),(587879,16310,'ko','ì´ ì½”ë“œëŠ” ìž‘ì—…ì´ ì´ë¯¸ ì¡´ìž¬',0),(587880,16311,'ko','ì—¬ëŸ¬ í•­ëª©ì€ ì‰¼í‘œë¡œ ë¶„ë¦¬ ë  ìˆ˜ ìžˆë‹¤',0),(587881,16312,'ko','í•„ìš”í•œ ë° ê³ ìœ  í•´ì•¼ í•©ë‹ˆë‹¤',0),(587882,16313,'ko','ê°€ì ¸ì˜¤ê¸° ì†¡ìž¥ ë³€ê²½',0),(587883,16314,'ko','ëª¨ë“  ê°’',0),(587884,16315,'ko','ê±°ì§“',0),(587885,16316,'ko','ì²« ë²ˆì§¸ ë° ë§ˆì§€ë§‰ ì´ë¦„',0),(587886,16317,'ko','ì˜ˆìƒ ë²ˆí˜¸',0),(587887,16318,'ko','ë” ë³´ê¸°',0),(587888,16319,'ko','í‘œì‹œ ìƒíƒœ ëª©ë¡',0),(587889,16320,'ko','ì‚¬ì‹¤',0),(587890,16321,'ko','GL ê³„ì • ë˜ëŠ” ë¹„ìš©ëœ ì½”ë“œ ë˜ëŠ” GL ì¹´í…Œê³ ë¦¬ë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(587891,16322,'ko','ë²•ì•ˆ ìŠ¹ì¸ í•˜ëŠ” ë•Œ ì´ë©”ì¼ í†µì§€ë¥¼ ë³´ë‚´ê¸°',0),(587892,16323,'ko','ì§€ë¶ˆ ë‚ ì§œ',0),(587893,16324,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ ì§€ë¶ˆì— ëŒ€ í•œ ìŠ¹ì¸',0),(587894,16325,'ko','ì´ ë²•ì•ˆì— PO ì˜ìˆ˜ì¦',0),(587895,16326,'ko','ê²½ìš° ì—†ëŠ” ë°°ë¥¼ ìš°íŽ¸ ë²ˆí˜¸ë¥¼ ê²°ì œ',0),(587896,16327,'ko','ìš´ì†¡ì§€ ìš°íŽ¸ ë²ˆí˜¸',0),(587897,16328,'ko','ìš°íŽ¸ ë²ˆí˜¸ë¥¼ í‘œì‹œ í•¨',0),(587898,16329,'ko','ìš°íŽ¸ ë²ˆí˜¸ì— ì˜í•´ ì •ë ¬',0),(587899,16330,'ko','ê°’ ì„ íƒ',0),(587900,16331,'ko','AP íì‡„',0),(587901,16332,'ko','AR íì‡„',0),(587902,16333,'ko','íì‡„ í•˜ëŠ” ì§ì ‘ GL',0),(587903,16334,'ko','ìž¬ê³  ì¢…ë£Œ',0),(587904,16335,'ko','ë¶€ë¶„ì ìœ¼ë¡œ íì‡„',0),(587905,16336,'ko','íì‡„ í•˜ëŠ” ê¸‰ì—¬',0),(587906,16337,'ko','ì§€ê¸ˆ ìƒì„±',0),(587907,16338,'ko','ì„±ê³µì ìœ¼ë¡œ ìƒì„±',0),(587908,16339,'ko','ì—­ë°©í–¥ í•­ëª© ìƒì„±',0),(587909,16340,'ko','ìƒì„± ëœ ë§ˆì§€ë§‰ ë‚ ì§œ',0),(587910,16341,'ko','ë§ˆì§€ë§‰ íŠ¸ëžœìž­ì…˜ ë‚ ì§œ',0),(587911,16342,'ko','ì°¨ë‹¨ ëœ ëª¨ë“ˆ',0),(587912,16343,'ko','ìƒí’ˆê¶Œì„ Unpost ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(587913,16344,'ko','ìƒí’ˆê¶Œ í™•ì¸ ê²Œì‹œ ë˜ì§€ ì•Šì€',0),(587914,16345,'ko','ê³µê¸‰ ì—…ì²´ ID ë˜ëŠ” ê³µê¸‰ ì—…ì²´ ì½”ë“œ ë˜ëŠ” ê³µê¸‰ ì—…ì²´ ì´ë¦„ì´ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(587915,16346,'ko','ì†¡ìž¥ ë²ˆí˜¸ì™€ ê³µê¸‰ ì—…ì²´ ID ë˜ëŠ” ê³µê¸‰ ì—…ì²´ ì½”ë“œ ë˜ëŠ” ê³µê¸‰ ì—…ì²´ ì´ë¦„ ë° ê¸ˆì•¡ ë° ìœ íš¨í•œ ê³„ì¢Œ ë²ˆí˜¸ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(587916,16347,'ko','ìš”êµ¬ëŠ” ì½”ë“œ',0),(587917,16348,'ko','ê³ ê° ID ë˜ëŠ” ê³ ê° ì½”ë“œ ë˜ëŠ” íšŒì‚¬ ì´ë¦„ ë˜ëŠ” ì²« ë²ˆì§¸ ë° ë§ˆì§€ë§‰ ì´ë¦„ ë° ì†¡ìž¥ ë²ˆí˜¸ ê°™ì€ ì¸ë³´ì´ìŠ¤ì— ì¶”ê°€ ë¼ì¸ í•­ëª© í•„ìš”',0),(587918,16349,'ko','ê³ ê° ID, ê³ ê° ì½”ë“œ ë˜ëŠ” íšŒì‚¬ ì´ë¦„ ë˜ëŠ” ì²« ë²ˆì§¸, ì„±ì´ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(587919,16350,'ko','ì†¡ìž¥ ë²ˆí˜¸ ë° ê³ ê° ID, ê³ ê° ì½”ë“œ ë˜ëŠ” íšŒì‚¬ ì´ë¦„ ë˜ëŠ” ì²« ë²ˆì§¸, ì„±ì´ ìžˆì–´ì•¼ í•©ë‹ˆë‹¤.',0),(587920,16351,'ko','ì´ ì´ë¦„ ê°€ì§„ ìž‘ì—…ì´ ì´ë¯¸ ì¡´ìž¬',0),(587921,16352,'ko','ì´ ê³ ê°ì— ëŒ€ í•œ ìž‘ì—…ì´ ì´ë¯¸ ì¡´ìž¬',0),(587922,16353,'ko','ì´ í”„ë¡œì íŠ¸ ìˆ˜ ìž‘ì—…ì´ ì´ë¯¸ ì¡´ìž¬',0),(587923,16354,'ko','ì´ ì£¼ì†ŒëŠ” ìž‘ì—…ì´ ì´ë¯¸ ì¡´ìž¬',0),(587924,16355,'ko','ìž‘ì—… ë§ˆê° ë‚ ì§œ',0),(587925,16356,'ko','Lattitude',0),(587926,16357,'ko','ê²½ë„',0),(587927,16358,'ko','Prelimable ë‚ ì§œ',0),(587928,16359,'ko','ë˜í’€ì´ ë˜ëŠ” ë ˆì € í•­ëª© ìƒì„±',0),(587929,16360,'ko','PHPë¥¼ í†µí•´ ìµœëŒ€ ìž…ë ¥ ë°”ë¥´',0),(587930,16361,'ko','ì— ëŒ€ í•œ ê°’ì„ ìž…ë ¥ í•´ ì£¼ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(587931,16362,'ko','ìš°íŽ¸ ë²ˆí˜¸ë¥¼ í‘œì‹œ í•¨',0),(587932,16363,'ko','ì´ ê³ ê°ì— ëŒ€ í•œ ìž‘ì—…ì´ ì´ë¯¸ ì¡´ìž¬',0),(587933,16364,'ko','ì´ ì£¼ì†ŒëŠ” ìž‘ì—…ì´ ì´ë¯¸ ì¡´ìž¬',0),(587934,16365,'ko','ì´ ì½”ë“œëŠ” ìž‘ì—…ì´ ì´ë¯¸ ì¡´ìž¬',0),(587935,16366,'ko','ì´ ì´ë¦„ ê°€ì§„ ìž‘ì—…ì´ ì´ë¯¸ ì¡´ìž¬',0),(587936,16298,'ms','Tiada penyata yang disediakan',0),(587937,16299,'ms','Maklumat produk',0),(587938,16300,'ms','Kira-kira produk',0),(587939,16301,'ms','Kata laluan tidak sah',0),(587940,16302,'ms','Set kata laluan baru',0),(587941,16303,'ms','Pelanggan atau kerja mesti disetkan',0),(587942,16304,'ms','Tidak padan dengan pelanggan',0),(587943,16305,'ms','Maklumat import',0),(587944,16306,'ms','Import invois pelanggan dan kerja perubahan',0),(587945,16307,'ms','Break dengan kos kod',0),(587946,16308,'ms','Pecah mengikut kategori GL',0),(587947,16309,'ms','Menghasilkan entri berulang',0),(587948,16310,'ms','Pekerjaan dengan Tatakelakuan ini telah wujud',0),(587949,16311,'ms','Beberapa entri boleh dipisahkan dengan koma',0),(587950,16312,'ms','Yang dikehendaki dan mestilah unik',0),(587951,16313,'ms','Import invois perubahan',0),(587952,16314,'ms','Nilai apa-apa',0),(587953,16315,'ms','Palsu',0),(587954,16316,'ms','Nama pertama & lepas',0),(587955,16317,'ms','Jumlah dijangkakan',0),(587956,16318,'ms','Menunjukkan lebih banyak',0),(587957,16319,'ms','Senarai Negeri Papar',0),(587958,16320,'ms','Benar',0),(587959,16321,'ms','Anda mesti memilih akaun GL atau kos kod atau kategori GL',0),(587960,16322,'ms','Menghantar e-mel notis apabila Rang undang-undang diluluskan',0),(587961,16323,'ms','Tarikh bayar',0),(587962,16324,'ms','Bil-bil vendor telah diluluskan untuk bayaran',0),(587963,16325,'ms','PO resit bil ini',0),(587964,16326,'ms','Bil kod kawasan jika kapal tidak',0),(587965,16327,'ms','Kapal Poskod',0),(587966,16328,'ms','Menunjukkan kapal kepada Poskod',0),(587967,16329,'ms','Susun mengikut Kod Zip',0),(587968,16330,'ms','Tiada nilai yang dipilih',0),(587969,16331,'ms','AP yang ditutup',0),(587970,16332,'ms','AR ditutup',0),(587971,16333,'ms','GL terus ditutup',0),(587972,16334,'ms','Inventori yang ditutup',0),(587973,16335,'ms','Sebahagiannya ditutup',0),(587974,16336,'ms','Gaji yang ditutup',0),(587975,16337,'ms','Menjana sekarang',0),(587976,16338,'ms','Dihasilkan berjaya',0),(587977,16339,'ms','Menghasilkan entri songsang',0),(587978,16340,'ms','Tarikh akhir yang dihasilkan',0),(587979,16341,'ms','Tarikh urus niaga',0),(587980,16342,'ms','Modul-modul yang disekat',0),(587981,16343,'ms','Dapat Unpost baucar',0),(587982,16344,'ms','Baucer Unposted OK',0),(587983,16345,'ms','Mesti mempunyai nombor Vendor ID atau penjual kod atau nama penjual.',0),(587984,16346,'ms','Mesti mempunyai nombor invois dan nombor Vendor ID atau kod pembekal atau penjual nama dan jumlah dan nombor akaun yang sah',0),(587985,16347,'ms','Perlu kod',0),(587986,16348,'ms','Item-item tambahan garisan dalam invois sama hanya perlukan ID pelanggan atau pelanggan kod atau nama Syarikat atau First dan Last Name dan nombor invois',0),(587987,16349,'ms','Mesti mempunyai ID pelanggan atau pelanggan kod atau nama Syarikat atau First dan Last Name',0),(587988,16350,'ms','Mesti mempunyai nombor invois dan ID pelanggan atau pelanggan kod atau nama Syarikat atau First dan Last Name anda',0),(587989,16351,'ms','Pekerjaan dengan nama ini sudah wujud',0),(587990,16352,'ms','Pekerjaan untuk pelanggan yang telah sedia wujud',0),(587991,16353,'ms','Pekerjaan dengan bilangan projek ini telah pun wujud',0),(587992,16354,'ms','Pekerjaan dengan alamat ini sudah wujud',0),(587993,16355,'ms','Tarikh Tutup jawatan',0),(587994,16356,'ms','Lattitude',0),(587995,16357,'ms','Longitud',0),(587996,16358,'ms','Tarikh prelimable',0),(587997,16359,'ms','Menjana berulang catatan Lejar',0),(587998,16360,'ms','Ke atas Vars Max Input USD',0),(587999,16361,'ms','Sila masukkan nilai bagi',0),(588000,16362,'ms','Menunjukkan kapal kepada Poskod',0),(588001,16363,'ms','Pekerjaan untuk pelanggan yang telah sedia wujud',0),(588002,16364,'ms','Pekerjaan dengan alamat ini sudah wujud',0),(588003,16365,'ms','Pekerjaan dengan Tatakelakuan ini telah wujud',0),(588004,16366,'ms','Pekerjaan dengan nama ini sudah wujud',0),(588005,16298,'no','Ingen erklÃ¦ring tilgjengelig',0),(588006,16299,'no','Produktinfo',0),(588007,16300,'no','Produktark',0),(588008,16301,'no','Ugyldig passord',0),(588009,16302,'no','Angi et nytt passord',0),(588010,16303,'no','Kunden eller jobb mÃ¥ angis',0),(588011,16304,'no','Samsvarer ikke med kunden',0),(588012,16305,'no','Importere informasjon',0),(588013,16306,'no','Importer faktura kunde og jobb endringer',0),(588014,16307,'no','Bryte ut av kostnader kode',0),(588015,16308,'no','Bryte ut av GL kategorien',0),(588016,16309,'no','Generere gjentakelsesposter',0),(588017,16310,'no','Det finnes allerede en jobb med denne koden',0),(588018,16311,'no','Flere oppfÃ¸ringer kan skilles med komma',0),(588019,16312,'no','NÃ¸dvendig og mÃ¥ vÃ¦re unikt',0),(588020,16313,'no','Importer faktura endringer',0),(588021,16314,'no','Noen verdi',0),(588022,16315,'no','Falske',0),(588023,16316,'no','FÃ¸rste & siste navn',0),(588024,16317,'no','Mange ventet',0),(588025,16318,'no','Vis mer',0),(588026,16319,'no','Vis status-listen',0),(588027,16320,'no','Sant',0),(588028,16321,'no','Du mÃ¥ velge en gi-konto eller kostnader kode eller GL kategori',0),(588029,16322,'no','Send e-post varsler nÃ¥r Bill godkjent',0),(588030,16323,'no','Betale dato',0),(588031,16324,'no','LeverandÃ¸ren regninger er godkjent For betaling',0),(588032,16325,'no','PO kvitteringer pÃ¥ denne regningen',0),(588033,16326,'no','Fakturering postnummer hvis ingen leveringsadresse',0),(588034,16327,'no','Leveringsgate/postnummer',0),(588035,16328,'no','Vise skipet til postnummer',0),(588036,16329,'no','Sorter etter postnummer',0),(588037,16330,'no','Ingen verdi valgt',0),(588038,16331,'no','AP lukket',0),(588039,16332,'no','AR lukket',0),(588040,16333,'no','Direkte GL lukket',0),(588041,16334,'no','Lager stengt',0),(588042,16335,'no','Delvis lukket',0),(588043,16336,'no','LÃ¸nn lukket',0),(588044,16337,'no','Generere nÃ¥',0),(588045,16338,'no','Er fullfÃ¸rt.',0),(588046,16339,'no','Generere tilbakefÃ¸ringspost',0),(588047,16340,'no','Siste dato generert',0),(588048,16341,'no','Siste transaksjonsdato',0),(588049,16342,'no','Blokkerte moduler',0),(588050,16343,'no','Kan ikke Unpost bilag',0),(588051,16344,'no','Bilag ikke-bokfÃ¸rte OK',0),(588052,16345,'no','MÃ¥ ha en leverandÃ¸r-ID eller leverandÃ¸rkode eller LeverandÃ¸rnavn',0),(588053,16346,'no','MÃ¥ ha fakturanummer og leverandÃ¸r-ID eller leverandÃ¸rkode eller leverandÃ¸rnavnet og belÃ¸p og gyldig kontonummer',0),(588054,16347,'no','MÃ¥ vÃ¦re en kode',0),(588055,16348,'no','Flere linjeelementer i den samme fakturaen bare trenger kunde-IDen eller kunde eller firmanavn eller fÃ¸rste og siste navnet og fakturanummeret',0),(588056,16349,'no','MÃ¥ ha en kunde-ID eller kunde eller firmanavn eller fornavn og etternavn',0),(588057,16350,'no','MÃ¥ ha fakturanummer og kunde-ID eller kunde eller firmanavn eller fornavn og etternavn',0),(588058,16351,'no','En jobb med dette navnet finnes allerede',0),(588059,16352,'no','Det finnes allerede en jobb For denne kunden',0),(588060,16353,'no','En jobb med dette prosjektnummeret finnes allerede',0),(588061,16354,'no','En jobb med denne adressen finnes allerede',0),(588062,16355,'no','Jobb lukkingsdato',0),(588063,16356,'no','Lattitude',0),(588064,16357,'no','Breddegrad',0),(588065,16358,'no','Prelimable dato',0),(588066,16359,'no','Generer periodiske poster',0),(588067,16360,'no','Over PHP Max Input Vars',0),(588068,16361,'no','Angi en verdi For',0),(588069,16362,'no','Vise skipet til postnummer',0),(588070,16363,'no','Det finnes allerede en jobb For denne kunden',0),(588071,16364,'no','En jobb med denne adressen finnes allerede',0),(588072,16365,'no','Det finnes allerede en jobb med denne koden',0),(588073,16366,'no','En jobb med dette navnet finnes allerede',0),(588074,16298,'fa','Ù‡ÛŒÚ† Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…ÙˆØ¬ÙˆØ¯',0),(588075,16299,'fa','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­ØµÙˆÙ„',0),(588076,16300,'fa','Ù…Ø­ØµÙˆÙ„ ÙˆØ±Ù‚',0),(588077,16301,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(588078,16302,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(588079,16303,'fa','Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø§Ø± Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ',0),(588080,16304,'fa','Ù…Ø´ØªØ±ÛŒ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(588081,16305,'fa','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(588082,16306,'fa','Ù…Ø´ØªØ±ÛŒ ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ØªØºÛŒÛŒØ± Ø´ØºÙ„',0),(588083,16307,'fa','ØªÙˆØ³Ø· Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø´Ú©Ø³ØªÙ†',0),(588084,16308,'fa','Ø´Ú©Ø³ØªÙ† Ø¯Ø³ØªÙ‡ GL',0),(588085,16309,'fa','ØªÙˆÙ„ÛŒØ¯ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(588086,16310,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(588087,16311,'fa','Ú†Ù†Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø§ Ú©Ø§Ù…Ø§ Ø§Ø² Ù‡Ù… Ø¬Ø¯Ø§',0),(588088,16312,'fa','Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ùˆ Ø¨Ø§ÛŒØ¯ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯',0),(588089,16313,'fa','ØªØºÛŒÛŒØ±Ø§Øª ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª',0),(588090,16314,'fa','Ù‡Ø± Ù…Ù‚Ø¯Ø§Ø±',0),(588091,16315,'fa','Ù†Ø§Ø¯Ø±Ø³Øª',0),(588092,16316,'fa','Ù†Ø§Ù… Ø§ÙˆÙ„ÛŒÙ† & Ú¯Ø°Ø´ØªÙ‡',0),(588093,16317,'fa','Ø§Ù†ØªØ¸Ø§Ø± Ù…ÛŒ Ø±ÙˆØ¯ ØªØ¹Ø¯Ø§Ø¯',0),(588094,16318,'fa','Ù†Ù…Ø§ÙŠØ´ Ø¨ÙŠØ´ØªØ±',0),(588095,16319,'fa','Ù„ÛŒØ³Øª ÙˆØ¶Ø¹ÛŒØª Ù†Ù…Ø§ÛŒØ´',0),(588096,16320,'fa','Ø¯Ø±Ø³Øª Ø§Ø³Øª',0),(588097,16321,'fa','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ GL Ø­Ø³Ø§Ø¨ ÛŒØ§ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ ÛŒØ§ Ø±Ø¯Ù‡ GL',0),(588098,16322,'fa','Ø§Ø±Ø³Ø§Ù„ Ø§Ø¹Ù„Ø§Ù…ÛŒÙ‡ Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„ ØªØ£ÛŒÛŒØ¯ Ù„Ø§ÛŒØ­Ù‡',0),(588099,16323,'fa','ØªØ§Ø±ÙŠØ®',0),(588100,16324,'fa','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(588101,16325,'fa','Ù¾Ùˆ Ø±Ø³ÛŒØ¯ Ø¯Ø± Ø§ÛŒÙ† Ù„Ø§ÛŒØ­Ù‡',0),(588102,16326,'fa','Ú©Ø¯ Ù¾Ø³ØªÛŒ Ø§Ú¯Ø± Ù‡ÛŒÚ† Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª',0),(588103,16327,'fa','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(588104,16328,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(588105,16329,'fa','Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù† Ø¨Ø± Ø§Ø³Ø§Ø³ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(588106,16330,'fa','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(588107,16331,'fa','AP Ø¨Ø³ØªÙ‡',0),(588108,16332,'fa','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ø¨Ø³ØªÙ‡',0),(588109,16333,'fa','Ù…Ø³ØªÙ‚ÛŒÙ… GL Ø¨Ø³ØªÙ‡',0),(588110,16334,'fa','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø³ØªÙ‡',0),(588111,16335,'fa','Ø¨Ø³ØªÙ‡ ØªØ§ Ø­Ø¯ÛŒ',0),(588112,16336,'fa','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø³ØªÙ‡',0),(588113,16337,'fa','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØªÙˆÙ„ÛŒØ¯',0),(588114,16338,'fa','ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(588115,16339,'fa','Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…Ø¹Ú©ÙˆØ³',0),(588116,16340,'fa','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡',0),(588117,16341,'fa','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(588118,16342,'fa','Ù…Ø§Ú˜ÙˆÙ„ Ù‡Ø§ÛŒ Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯Ù‡',0),(588119,16343,'fa','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Unpost Ú©ÙˆÙ¾Ù†',0),(588120,16344,'fa','Ú©ÙˆÙ¾Ù† Unposted OK',0),(588121,16345,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…',0),(588122,16346,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø¨Ù„Øº Ùˆ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±',0),(588123,16347,'fa','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ú©Ø¯',0),(588124,16348,'fa','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(588125,16349,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(588126,16350,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(588127,16351,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(588128,16352,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(588129,16353,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(588130,16354,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(588131,16355,'fa','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ®',0),(588132,16356,'fa','Lattitude',0),(588133,16357,'fa','Ø·ÙˆÙ„ Ø¬ØºØ±Ø§ÙÛŒØ§ÛŒÛŒ',0),(588134,16358,'fa','ØªØ§Ø±ÛŒØ® prelimable',0),(588135,16359,'fa','ØªÙˆÙ„ÛŒØ¯ ØªÚ©Ø±Ø§Ø±ÛŒ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(588136,16360,'fa','Ø¨ÛŒØ´ Ø§Ø² PHP Ø­Ø¯Ø§Ú©Ø«Ø± ÙˆØ±ÙˆØ¯ÛŒ Vars',0),(588137,16361,'fa','Ù„Ø·ÙØ§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÛŒ',0),(588138,16362,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(588139,16363,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(588140,16364,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(588141,16365,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(588142,16366,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(588143,16298,'pl','Nie instrukcji, ktÃ³re sÄ… dostÄ™pne',0),(588144,16299,'pl','Informacja o produkcie',0),(588145,16300,'pl','Karta produktu',0),(588146,16301,'pl','NieprawidÅ‚owe hasÅ‚o',0),(588147,16302,'pl','Ustaw nowe hasÅ‚o',0),(588148,16303,'pl','Zadania lub klienta musi byÄ‡ ustawiona',0),(588149,16304,'pl','Nie pasuje klienta',0),(588150,16305,'pl','Importowanie informacji',0),(588151,16306,'pl','Importuj faktury klienta i zmiany pracy',0),(588152,16307,'pl','Break Out przez koszt kodu',0),(588153,16308,'pl','WyrwaÄ‡ siÄ™ w kategorii GL',0),(588154,16309,'pl','Generowanie wpisÃ³w do cyklicznego',0),(588155,16310,'pl','Zadanie z ten kod juÅ¼ istnieje',0),(588156,16311,'pl','Wiele wpisÃ³w mogÄ… byÄ‡ oddzielone przecinkami',0),(588157,16312,'pl','Wymagana i musi byÄ‡ unikatowa',0),(588158,16313,'pl','Zmiany faktur importowych',0),(588159,16314,'pl','KaÅ¼da wartoÅ›Ä‡',0),(588160,16315,'pl','FaÅ‚szywe',0),(588161,16316,'pl','Nazwa pierwszego & ostatni',0),(588162,16317,'pl','Spodziewanej liczby',0),(588163,16318,'pl','PokaÅ¼ wiÄ™cej',0),(588164,16319,'pl','PokaÅ¼ stan listy',0);
INSERT INTO `langdef` VALUES (588165,16320,'pl','Prawdziwe',0),(588166,16321,'pl','NaleÅ¼y wybraÄ‡ konto GL lub kodem kosztÃ³w lub kategorii GL',0),(588167,16322,'pl','WyÅ›lij powiadomienia E-mail, gdy Bill zatwierdzone',0),(588168,16323,'pl','PÅ‚aciÄ‡ Data',0),(588169,16324,'pl','Rachunki dostawcÃ³w zostaÅ‚y zatwierdzone dla pÅ‚atnoÅ›ci',0),(588170,16325,'pl','PO wpÅ‚ywy na ten rachunek',0),(588171,16326,'pl','Kod pocztowy do rozliczeÅ„ JeÅ›li Å¼aden statek do',0),(588172,16327,'pl','WyÅ›lij do-kod pocztowy',0),(588173,16328,'pl','PokaÅ¼: WyÅ›lij do-kod pocztowy',0),(588174,16329,'pl','Sortuj wedÅ‚ug kodu pocztowego',0),(588175,16330,'pl','Nie wartoÅ›ci wybrane',0),(588176,16331,'pl','AP ZAMKNIÄ˜TA',0),(588177,16332,'pl','AR ZAMKNIÄ˜TA',0),(588178,16333,'pl','BezpoÅ›redniego GL ZAMKNIÄ˜TA',0),(588179,16334,'pl','ZapasÃ³w ZAMKNIÄ˜TA',0),(588180,16335,'pl','CzÄ™Å›ciowo ZAMKNIÄ˜TA',0),(588181,16336,'pl','Listy pÅ‚ac, ZAMKNIÄ˜TA',0),(588182,16337,'pl','Teraz wygenerowaÄ‡',0),(588183,16338,'pl','ZostaÅ‚ wygenerowany pomyÅ›lnie',0),(588184,16339,'pl','Wygenerowanie zapisu odwrotnego',0),(588185,16340,'pl','Data ostatniego generowany',0),(588186,16341,'pl','Data ostatniej transakcji',0),(588187,16342,'pl','Zablokowanych moduÅ‚Ã³w',0),(588188,16343,'pl','Stanie Unpost bony',0),(588189,16344,'pl','Vouchery niezaksiÄ™gowane OK',0),(588190,16345,'pl','Musi mieÄ‡ identyfikator dostawcy lub kod dostawcy lub nazwa dostawcy',0),(588191,16346,'pl','Musi mieÄ‡ numer faktury i identyfikator dostawcy lub kod dostawcy lub nazwa dostawcy i kwota i poprawny numer konta',0),(588192,16347,'pl','Musi byÄ‡ kod',0),(588193,16348,'pl','Dodatkowe pozycje w tej samej faktury wystarczy tylko identyfikator klienta lub klienta kod lub nazwÄ™ firmy lub pierwszy i nazwisko i numer faktury',0),(588194,16349,'pl','Musi mieÄ‡ identyfikator klienta lub klienta kod lub nazwÄ™ firmy lub imiÄ™ i nazwisko',0),(588195,16350,'pl','Musi mieÄ‡ numer faktury i Numer ID klienta lub klienta kod lub nazwÄ™ firmy lub imiÄ™ i nazwisko',0),(588196,16351,'pl','Zadanie o tej nazwie juÅ¼ istnieje',0),(588197,16352,'pl','Zadanie dla tego klienta juÅ¼ istnieje',0),(588198,16353,'pl','Zadanie z tego numeru projektu juÅ¼ istnieje',0),(588199,16354,'pl','Zadanie z ten adres juÅ¼ istnieje',0),(588200,16355,'pl','Pracy ZAMKNIÄ˜TA dacie',0),(588201,16356,'pl','Lattitude',0),(588202,16357,'pl','DÅ‚ugoÅ›Ä‡ geograficzna',0),(588203,16358,'pl','Prelimable daty',0),(588204,16359,'pl','GenerujÄ… cykliczne wpisy do ksiÄ™gi',0),(588205,16360,'pl','Nad PHP Max wejÅ›cie Vars',0),(588206,16361,'pl','ProszÄ™ wprowadÅº wartoÅ›Ä‡ w polu',0),(588207,16362,'pl','PokaÅ¼: WyÅ›lij do-kod pocztowy',0),(588208,16363,'pl','Zadanie dla tego klienta juÅ¼ istnieje',0),(588209,16364,'pl','Zadanie z ten adres juÅ¼ istnieje',0),(588210,16365,'pl','Zadanie z ten kod juÅ¼ istnieje',0),(588211,16366,'pl','Zadanie o tej nazwie juÅ¼ istnieje',0),(588212,16298,'pt','Nenhuma declaraÃ§Ã£o disponÃ­vel',0),(588213,16299,'pt','InformaÃ§Ã£o do produto',0),(588214,16300,'pt','Folha de produto',0),(588215,16301,'pt','Senha invÃ¡lida',0),(588216,16302,'pt','Definir uma nova senha',0),(588217,16303,'pt','Trabalho ou cliente deve ser definido',0),(588218,16304,'pt','NÃ£o Ã© compatÃ­vel com o cliente',0),(588219,16305,'pt','Importar informaÃ§Ãµes',0),(588220,16306,'pt','Cliente de factura de importaÃ§Ã£o e mudanÃ§as de emprego',0),(588221,16307,'pt','Sair pelo cÃ³digo do custo',0),(588222,16308,'pt','Sair por categoria GL',0),(588223,16309,'pt','Gerar entradas recorrentes',0),(588224,16310,'pt','JÃ¡ existe um trabalho com este cÃ³digo',0),(588225,16311,'pt','VÃ¡rias entradas podem ser separadas por vÃ­rgulas',0),(588226,16312,'pt','NecessÃ¡ria e deve ser exclusivo',0),(588227,16313,'pt','AlteraÃ§Ãµes de nota fiscal de importaÃ§Ã£o',0),(588228,16314,'pt','Qualquer valor',0),(588229,16315,'pt','Falso',0),(588230,16316,'pt','Primeiro e Ãºltimo nome',0),(588231,16317,'pt','NÃºmero esperado',0),(588232,16318,'pt','Mostrar mais',0),(588233,16319,'pt','Mostrar estado lista',0),(588234,16320,'pt','Verdade',0),(588235,16321,'pt','VocÃª deve selecionar um cÃ³digo de custo ou conta GL ou GL categoria',0),(588236,16322,'pt','Enviar avisos por Email quando Bill aprovado',0),(588237,16323,'pt','Data de pagar',0),(588238,16324,'pt','Fornecedor de contas tenham sido aprovadas para pagamento',0),(588239,16325,'pt','PO receitas sobre este projeto de lei',0),(588240,16326,'pt','CÃ³digo Postal de faturamento se nenhum navio para',0),(588241,16327,'pt','Navio de CÃ³digo Postal',0),(588242,16328,'pt','Mostrar o navio para cÃ³digo Postal',0),(588243,16329,'pt','Ordenar por cÃ³digo postal',0),(588244,16330,'pt','Nenhum valor selecionado',0),(588245,16331,'pt','AP-fechado',0),(588246,16332,'pt','AR fechado',0),(588247,16333,'pt','Direto GL fechado',0),(588248,16334,'pt','InventÃ¡rio fechado',0),(588249,16335,'pt','Parcialmente fechada',0),(588250,16336,'pt','Folha de pagamento fechada',0),(588251,16337,'pt','Gerar agora',0),(588252,16338,'pt','Gerado com sucesso',0),(588253,16339,'pt','Gerar entrada reversa',0),(588254,16340,'pt','Data da Ãºltima gerada',0),(588255,16341,'pt','Data da Ãºltima transaÃ§Ã£o',0),(588256,16342,'pt','MÃ³dulos bloqueados',0),(588257,16343,'pt','NÃ£o Ã© possÃ­vel Unpost Vouchers',0),(588258,16344,'pt','Vouchers Unposted Okey',0),(588259,16345,'pt','Deve ter um ID do fornecedor ou fornecedor cÃ³digo ou nome do fornecedor',0),(588260,16346,'pt','Deve ter o nÃºmero da factura e Vendor ID ou cÃ³digo de fornecedor ou nome do fornecedor e quantidade e nÃºmero de conta vÃ¡lido',0),(588261,16347,'pt','Precisa ser um cÃ³digo',0),(588262,16348,'pt','Linhas de itens adicionais na mesma fatura sÃ³ precisa o ID de cliente ou cÃ³digo de cliente ou nome da empresa ou primeiro e Ãºltimo nome e o nÃºmero da factura',0),(588263,16349,'pt','Deve ter um ID de cliente ou cÃ³digo de cliente ou nome da empresa ou primeiro e Ãºltimo nome',0),(588264,16350,'pt','Deve ter o nÃºmero da factura e ID de cliente ou cÃ³digo de cliente ou nome da empresa ou primeiro e Ãºltimo nome',0),(588265,16351,'pt','Um trabalho com este nome jÃ¡ existe.',0),(588266,16352,'pt','JÃ¡ existe um trabalho para este cliente',0),(588267,16353,'pt','JÃ¡ existe um trabalho com esse nÃºmero de projeto',0),(588268,16354,'pt','JÃ¡ existe um trabalho com este endereÃ§o',0),(588269,16355,'pt','Caso encerrado data',0),(588270,16356,'pt','Lattitude',0),(588271,16357,'pt','Longitude',0),(588272,16358,'pt','Data prelimable',0),(588273,16359,'pt','Gerar movimentos recorrentes',0),(588274,16360,'pt','Sobre PHP Max entrada Vars',0),(588275,16361,'pt','Por favor, insira um valor para',0),(588276,16362,'pt','Mostrar o navio para cÃ³digo Postal',0),(588277,16363,'pt','JÃ¡ existe um trabalho para este cliente',0),(588278,16364,'pt','JÃ¡ existe um trabalho com este endereÃ§o',0),(588279,16365,'pt','JÃ¡ existe um trabalho com este cÃ³digo',0),(588280,16366,'pt','Um trabalho com este nome jÃ¡ existe.',0),(588281,16298,'ro','Nici o declaraÈ›ie disponibile',0),(588282,16299,'ro','Informatii despre produs',0),(588283,16300,'ro','FiÅŸa produsului',0),(588284,16301,'ro','ParolÄƒ invalidÄƒ',0),(588285,16302,'ro','SetaÅ£i o parolÄƒ nouÄƒ',0),(588286,16303,'ro','Client sau loc de muncÄƒ trebuie sÄƒ fie setat',0),(588287,16304,'ro','Nu se potriveÅŸte cu clientul',0),(588288,16305,'ro','ImportaÅ£i informaÅ£ii',0),(588289,16306,'ro','Import facturÄƒ client ÅŸi schimbÄƒri de Job',0),(588290,16307,'ro','Pauza de costuri codul de',0),(588291,16308,'ro','Izbucni de categoria GL',0),(588292,16309,'ro','Genereze intrÄƒri recurente',0),(588293,16310,'ro','ExistÄƒ deja un loc de muncÄƒ cu acest cod',0),(588294,16311,'ro','Mai multe intrÄƒri pot fi separate prin virgule',0),(588295,16312,'ro','Necesare ÅŸi trebuie sÄƒ fie unic',0),(588296,16313,'ro','ModificÄƒrile de facturÄƒ de import',0),(588297,16314,'ro','Orice valoare',0),(588298,16315,'ro','Fals',0),(588299,16316,'ro','Prima & ultimul nume',0),(588300,16317,'ro','NumÄƒrul de aÅŸteptat',0),(588301,16318,'ro','AratÄƒ mai multe',0),(588302,16319,'ro','Lista aratÄƒ starea',0),(588303,16320,'ro','AdevÄƒrat',0),(588304,16321,'ro','Trebuie sÄƒ selectaÅ£i un GL cont sau Cost cod GL categoria',0),(588305,16322,'ro','Trimite Email notificÄƒri cÃ¢nd Bill aprobate',0),(588306,16323,'ro','PlÄƒteascÄƒ data',0),(588307,16324,'ro','Furnizor facturi au fost aprobate pentru plata',0),(588308,16325,'ro','PO Ã®ncasÄƒri pe acest proiect de lege',0),(588309,16326,'ro','Cod poÈ™tal de facturare, dacÄƒ nici o navÄƒ pentru a',0),(588310,16327,'ro','Nava-la cod poÅŸtal',0),(588311,16328,'ro','AratÄƒ navei cÄƒtre cod poÅŸtal',0),(588312,16329,'ro','Sortare dupa cod postal',0),(588313,16330,'ro','Nici o valoare selectatÄƒ',0),(588314,16331,'ro','AP Ã®nchis',0),(588315,16332,'ro','AR Ã®nchis',0),(588316,16333,'ro','DirectÄƒ GL Ã®nchis',0),(588317,16334,'ro','Inventar Ã®nchis',0),(588318,16335,'ro','ParÅ£ial Ã®nchis',0),(588319,16336,'ro','Salarizare Ã®nchis',0),(588320,16337,'ro','Genera acum',0),(588321,16338,'ro','Generat cu succes',0),(588322,16339,'ro','Genera inversÄƒ intrare',0),(588323,16340,'ro','Data ultimei generate',0),(588324,16341,'ro','Data ultimei tranzacÅ£ii',0),(588325,16342,'ro','Blocat module',0),(588326,16343,'ro','Imposibil de Unpost vouchere',0),(588327,16344,'ro','Vouchere neÃ®nregistrate OK',0),(588328,16345,'ro','Trebuie sÄƒ aibÄƒ un Vendor ID sau furnizor nume sau cod furnizor',0),(588329,16346,'ro','Trebuie sÄƒ aibÄƒ numÄƒrul facturii ÅŸi Vendor ID sau cod furnizor sau furnizor numele È™i suma È™i numÄƒrul de cont Valid',0),(588330,16347,'ro','Trebuie sÄƒ fie un cod',0),(588331,16348,'ro','Elemente suplimentare de linie Ã®n aceeaÅŸi facturÄƒ nevoie doar de ID client sau cod client sau numele companiei sau prima ÅŸi numele de familie ÅŸi numÄƒrul facturii',0),(588332,16349,'ro','Trebuie sÄƒ aibÄƒ un ID client sau codul clientului sau numele companiei sau primul ÅŸi ultimul nume',0),(588333,16350,'ro','Trebuie sÄƒ aibÄƒ numÄƒrul facturii ÅŸi ID client sau codul clientului sau numele companiei sau primul ÅŸi ultimul nume',0),(588334,16351,'ro','Un loc de muncÄƒ cu acest nume existÄƒ deja',0),(588335,16352,'ro','ExistÄƒ deja un loc de muncÄƒ pentru acest client',0),(588336,16353,'ro','ExistÄƒ deja un loc de muncÄƒ cu acest numÄƒr de proiect',0),(588337,16354,'ro','Un loc de muncÄƒ cu aceasta adresa exista deja',0),(588338,16355,'ro','Job Ã®nchis data',0),(588339,16356,'ro','Lattitude',0),(588340,16357,'ro','Longitudine',0),(588341,16358,'ro','Data de prelimable',0),(588342,16359,'ro','Genera intrÄƒrile din registrul de recurente',0),(588343,16360,'ro','Peste PHP Max de intrare Vars',0),(588344,16361,'ro','VÄƒ rugÄƒm sÄƒ introduceÅ£i o valoare pentru',0),(588345,16362,'ro','AratÄƒ navei cÄƒtre cod poÅŸtal',0),(588346,16363,'ro','ExistÄƒ deja un loc de muncÄƒ pentru acest client',0),(588347,16364,'ro','Un loc de muncÄƒ cu aceasta adresa exista deja',0),(588348,16365,'ro','ExistÄƒ deja un loc de muncÄƒ cu acest cod',0),(588349,16366,'ro','Un loc de muncÄƒ cu acest nume existÄƒ deja',0),(588350,16298,'ru','ÐÐµÑ‚ Ð·Ð°ÑÐ²Ð»ÐµÐ½Ð¸Ðµ',0),(588351,16299,'ru','Ð˜Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ Ð¾ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ðµ',0),(588352,16300,'ru','ÐžÐ¿Ð¸ÑÐ°Ð½Ð¸Ðµ Ð¿Ñ€Ð¾Ð´ÑƒÐºÑ‚Ð°',0),(588353,16301,'ru','ÐÐµÐ²ÐµÑ€Ð½Ñ‹Ð¹ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ',0),(588354,16302,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ Ð¿Ð°Ñ€Ð¾Ð»ÑŒ',0),(588355,16303,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ ÐºÐ»Ð¸ÐµÐ½Ñ‚ Ð¸Ð»Ð¸ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(588356,16304,'ru','ÐÐµ ÑÐ¾Ð¾Ñ‚Ð²ÐµÑ‚ÑÑ‚Ð²ÑƒÐµÑ‚ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ñƒ',0),(588357,16305,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸',0),(588358,16306,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÑ‡ÐµÑ‚Ð¾Ð² ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸ Ð·Ð°Ð´Ð°Ð½Ð¸Ñ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(588359,16307,'ru','Ð’Ñ‹Ñ€Ð²Ð°Ñ‚ÑŒÑÑ Ð¸Ð· ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ð´Ð°',0),(588360,16308,'ru','Ð’Ñ‹Ñ€Ð²Ð°Ñ‚ÑŒÑÑ Ð¸Ð· ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ GL',0),(588361,16309,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ…ÑÑ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(588362,16310,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ñ ÑÑ‚Ð¸Ð¼ ÐºÐ¾Ð´Ð¾Ð¼ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(588363,16311,'ru','ÐÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹ Ð¼Ð¾Ð³ÑƒÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ñ€Ð°Ð·Ð´ÐµÐ»ÐµÐ½Ñ‹ Ð·Ð°Ð¿ÑÑ‚Ñ‹Ð¼Ð¸',0),(588364,16312,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ Ð¸ Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ ÑƒÐ½Ð¸ÐºÐ°Ð»ÑŒÐ½Ñ‹Ð¼',0),(588365,16313,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ',0),(588366,16314,'ru','Ð›ÑŽÐ±Ð¾Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(588367,16315,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ false',0),(588368,16316,'ru','ÐŸÐµÑ€Ð²Ñ‹Ð¹ & ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ Ð¸Ð¼Ñ',0),(588369,16317,'ru','ÐžÐ¶Ð¸Ð´Ð°ÐµÑ‚ÑÑ Ñ‡Ð¸ÑÐ»Ð¾',0),(588370,16318,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð±Ð¾Ð»ÑŒÑˆÐµ',0),(588371,16319,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð¾Ñ‚Ð¾Ð±Ñ€Ð°Ð¶ÐµÐ½Ð¸Ñ ÑÐ¿Ð¸ÑÐºÐ°',0),(588372,16320,'ru','ÐŸÑ€Ð°Ð²Ð´Ð°',0),(588373,16321,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL Ð¸Ð»Ð¸ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ð´ Ð¸Ð»Ð¸ GL ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(588374,16322,'ru','ÐŸÐ¾ÑÑ‹Ð»Ð°Ñ‚ÑŒ ÑƒÐ²ÐµÐ´Ð¾Ð¼Ð»ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ðµ, ÐºÐ¾Ð³Ð´Ð° Ð·Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½',0),(588375,16323,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(588376,16324,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð±Ñ‹Ð»Ð¸ ÑƒÑ‚Ð²ÐµÑ€Ð¶Ð´ÐµÐ½Ñ‹ Ð´Ð»Ñ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹',0),(588377,16325,'ru','ÐŸÐž ÐºÐ²Ð¸Ñ‚Ð°Ð½Ñ†Ð¸Ð¸ Ð½Ð° ÑÑ‚Ð¾Ñ‚ ÑÑ‡ÐµÑ‚',0),(588378,16326,'ru','Ð‘Ð¸Ð»Ð»Ð¸Ð½Ð³ Ð¿Ð¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ ÐºÐ¾Ð´, ÐµÑÐ»Ð¸ Ð½Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(588379,16327,'ru','ÐšÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿Ð¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ ÐºÐ¾Ð´',0),(588380,16328,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿Ð¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ ÐºÐ¾Ð´',0),(588381,16329,'ru','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¿Ð¾ Ð¿Ð¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ Ð¸Ð½Ð´ÐµÐºÑ',0),(588382,16330,'ru','Ð—Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½',0),(588383,16331,'ru','AP Ð·Ð°ÐºÑ€Ñ‹Ñ‚',0),(588384,16332,'ru','AR Ð·Ð°ÐºÑ€Ñ‹Ñ‚',0),(588385,16333,'ru','ÐŸÑ€ÑÐ¼Ð°Ñ GL Ð·Ð°ÐºÑ€Ñ‹Ñ‚',0),(588386,16334,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð·Ð°ÐºÑ€Ñ‹Ñ‚',0),(588387,16335,'ru','Ð§Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾ Ð·Ð°ÐºÑ€Ñ‹Ñ‚',0),(588388,16336,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð° Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¾',0),(588389,16337,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ ÑÐµÐ¹Ñ‡Ð°Ñ',0),(588390,16338,'ru','Ð£ÑÐ¿ÐµÑˆÐ½Ð¾ ÑÐ¾Ð·Ð´Ð°Ð½',0),(588391,16339,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¾Ð±Ñ€Ð°Ñ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(588392,16340,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÑÑ Ð”Ð°Ñ‚Ð° ÑÐ¾Ð·Ð´Ð°Ð½Ð¸Ñ',0),(588393,16341,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÑÑ Ð´Ð°Ñ‚Ð° Ð¿Ñ€Ð¾Ð²Ð¾Ð´ÐºÐ¸',0),(588394,16342,'ru','Ð—Ð°Ð±Ð»Ð¾ÐºÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ñ‹Ðµ Ð¼Ð¾Ð´ÑƒÐ»Ð¸',0),(588395,16343,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Unpost Ð²Ð°ÑƒÑ‡ÐµÑ€Ñ‹',0),(588396,16344,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€Ñ‹ Ð½ÐµÐ¾Ð¿ÑƒÐ±Ð»Ð¸ÐºÐ¾Ð²Ð°Ð½Ð½Ñ‹Ðµ ÐžÐš',0),(588397,16345,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð¼ÐµÑ‚ÑŒ ÑƒÐ´Ð¾ÑÑ‚Ð¾Ð²ÐµÑ€ÐµÐ½Ð¸Ðµ Ð»Ð¸Ñ‡Ð½Ð¾ÑÑ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¸Ð»Ð¸ ÐºÐ¾Ð´ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¸Ð»Ð¸ Ð¸Ð¼Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ°',0),(588398,16346,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð¼ÐµÑ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð¸ ÐºÐ¾Ð´ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¸Ð»Ð¸ ÐºÐ¾Ð´ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¸Ð»Ð¸ Ð¸Ð¼Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¸ ÑÑƒÐ¼Ð¼Ñƒ Ð¸ Ð½Ð¾Ð¼ÐµÑ€ Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚Ð°',0),(588399,16347,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ ÐºÐ¾Ð´',0),(588400,16348,'ru','Ð”Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ðµ ÑÑ‚Ñ€Ð¾ÐºÐ¾Ð²Ñ‹Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Ð² Ñ‚Ð¾Ð¼ Ð¶Ðµ ÑÑ‡ÐµÑ‚Ðµ Ð½ÑƒÐ¶Ð½Ð¾ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ ÐºÐ¾Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ ÐºÐ¾Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð»Ð¸ Ð¿ÐµÑ€Ð²Ð¾Ð¹ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸ÑŽ Ð¸ Ð½Ð¾Ð¼Ð',0),(588401,16349,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð¼ÐµÑ‚ÑŒ ÐºÐ¾Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ ÐºÐ¾Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð»Ð¸ Ð¸Ð¼Ñ Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸ÑŽ',0),(588402,16350,'ru','Ð”Ð¾Ð»Ð¶ÐµÐ½ Ð¸Ð¼ÐµÑ‚ÑŒ Ð½Ð¾Ð¼ÐµÑ€ ÑÑ‡ÐµÑ‚Ð° Ð¸ ÐºÐ¾Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ ÐºÐ¾Ð´ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð»Ð¸ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¸Ð»Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ Ð¸ Ð¸Ð¼Ñ',0),(588403,16351,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ñ Ñ‚Ð°ÐºÐ¸Ð¼ Ð¸Ð¼ÐµÐ½ÐµÐ¼ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(588404,16352,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(588405,16353,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ ÑÑ‚Ð¸Ð¼ Ð½Ð¾Ð¼ÐµÑ€Ð¾Ð¼ Ð¿Ñ€Ð¾ÐµÐºÑ‚Ð° ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(588406,16354,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ñ Ñ‚Ð°ÐºÐ¸Ð¼ Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(588407,16355,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¾ Ð”Ð°Ñ‚Ð°',0),(588408,16356,'ru','Lattitude',0),(588409,16357,'ru','Ð”Ð¾Ð»Ð³Ð¾Ñ‚Ð°',0),(588410,16358,'ru','Prelimable Ð”Ð°Ñ‚Ð°',0),(588411,16359,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€ÑÑŽÑ‰Ð¸Ñ…ÑÑ ÑƒÑ‡Ñ‚ÐµÐ½Ð½Ñ‹Ñ… Ð¾Ð¿ÐµÑ€Ð°Ñ†Ð¸Ð¹',0),(588412,16360,'ru','Ð—Ð° PHP ÐœÐ°ÐºÑ Vars',0),(588413,16361,'ru','Ð’Ð²ÐµÐ´Ð¸Ñ‚Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð´Ð»Ñ',0),(588414,16362,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¿Ð¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ ÐºÐ¾Ð´',0),(588415,16363,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð° ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(588416,16364,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ñ Ñ‚Ð°ÐºÐ¸Ð¼ Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(588417,16365,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ñ ÑÑ‚Ð¸Ð¼ ÐºÐ¾Ð´Ð¾Ð¼ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(588418,16366,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ Ñ Ñ‚Ð°ÐºÐ¸Ð¼ Ð¸Ð¼ÐµÐ½ÐµÐ¼ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(588419,16298,'sr','ÐÐµÐ¼Ð° Ð¸Ð·Ñ˜Ð°Ð²Ñƒ ÐºÐ¾Ñ˜Ð° Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð°',0),(588420,16299,'sr','Ðž Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ñƒ',0),(588421,16300,'sr','Ð›Ð¸ÑÑ‚Ð° Ð¿Ñ€Ð¾Ð¸Ð·Ð²Ð¾Ð´Ð°',0),(588422,16301,'sr','ÐÐµÐ¸ÑÐ¿Ñ€Ð°Ð²Ð½Ð° Ð»Ð¾Ð·Ð¸Ð½ÐºÐ°',0),(588423,16302,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð¾Ð²Ñƒ Ð»Ð¾Ð·Ð¸Ð½ÐºÑƒ',0),(588424,16303,'sr','ÐšÑƒÐ¿Ð°Ñ† Ð¸Ð»Ð¸ Ð¿Ð¾ÑÐ°Ð¾ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(588425,16304,'sr','ÐÐµ Ð¿Ð¾Ð´ÑƒÐ´Ð°Ñ€Ð° ÑÐµ ÑÐ° ÐºÑƒÐ¿Ñ†Ð°',0),(588426,16305,'sr','Ð£Ð²Ð¾Ð· Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð°',0),(588427,16306,'sr','Ð£Ð²Ð¾Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ ÐºÑƒÐ¿Ñ†Ð° Ð¸ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð¿Ð¾ÑÐ°Ð¾',0),(588428,16307,'sr','Ð˜Ð·Ð±Ð¸Ñ˜Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÑˆÐ¸Ñ„Ñ€Ð¾Ð¼',0),(588429,16308,'sr','Ð˜Ð·Ð±Ð¸Ñ˜Ðµ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸ Ð“Ð›',0),(588430,16309,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°ÑšÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(588431,16310,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÑÐ° Ð¾Ð²Ð¾Ð¼ ÑˆÐ¸Ñ„Ñ€Ð¾Ð¼ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(588432,16311,'sr','Ð’Ð¸ÑˆÐµ ÑÑ‚Ð°Ð²ÐºÐ¸ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð±Ð¸Ñ‚Ð¸ Ñ€Ð°Ð·Ð´Ð²Ð¾Ñ˜ÐµÐ½Ðµ Ð·Ð°Ñ€ÐµÐ·Ð¸Ð¼Ð°',0),(588433,16312,'sr','ÐÐµÐ¾Ð¿Ñ…Ð¾Ð´Ð½Ð° Ð¸ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ñ˜ÐµÐ´Ð¸Ð½ÑÑ‚Ð²ÐµÐ½',0),(588434,16313,'sr','Ð£Ð²Ð¾Ð· Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ',0),(588435,16314,'sr','Ð‘Ð¸Ð»Ð¾ ÐºÐ¾Ñ˜Ð° Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚',0),(588436,16315,'sr','Ð¤ÐÐ›Ð¡Ð•',0),(588437,16316,'sr','ÐŸÑ€Ð²Ð¾ Ð¸ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð¸Ð¼Ðµ',0),(588438,16317,'sr','ÐžÑ‡ÐµÐºÐ¸Ð²Ð°Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(588439,16318,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð²Ð¸ÑˆÐµ',0),(588440,16319,'sr','Ð¡Ð¿Ð¸ÑÐ°Ðº Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²Ð° ÑÑ‚Ð°ÑšÐ°',0),(588441,16320,'sr','Ð˜ÑÑ‚Ð¸Ð½Ð°',0),(588442,16321,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð“Ð› Ð¸Ð»Ð¸ ÑˆÐ¸Ñ„Ñ€Ñƒ Ñ‚Ñ€Ð¾ÑˆÐºÐ° Ð¸Ð»Ð¸ Ð“Ð› ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð°',0),(588443,16322,'sr','ÐŸÐ¾ÑˆÐ°Ñ™Ð¸ Ð•Ð¼Ð°Ð¸Ð» ÐºÑ€Ð¸Ñ‚Ð¸ÐºÐµ ÐºÐ°Ð´ Ð‘Ð¸Ð»Ð» Ñ˜Ðµ Ð¾Ð´Ð¾Ð±Ñ€Ð¸Ð¾',0),(588444,16323,'sr','ÐŸÐ»Ð°Ñ‚Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(588445,16324,'sr','Ð Ð°Ñ‡ÑƒÐ½Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑÑƒ Ð¾Ð´Ð¾Ð±Ñ€ÐµÐ½Ð¸ Ð·Ð° Ð¿Ð»Ð°Ñ›Ð°ÑšÐµ',0),(588446,16325,'sr','ÐŸÐž Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ðµ Ð½Ð° Ð¾Ð²Ð°Ñ˜ Ð·Ð°ÐºÐ¾Ð½',0),(588447,16326,'sr','ÐÐ°Ð¿Ð»Ð°Ñ‚Ðµ ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸, Ð°ÐºÐ¾ Ð½ÐµÐ¼Ð° Ð±Ñ€Ð¾Ð´Ð° Ð´Ð°',0),(588448,16327,'sr','Ð˜ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ : Ð¿Ð¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(588449,16328,'sr','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ð±Ñ€Ð¾Ð´: Ð¿Ð¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(588450,16329,'sr','Ð¡Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ñ˜ Ð¿Ð¾ ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(588451,16330,'sr','ÐÐµÐ¼Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ðµ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸',0),(588452,16331,'sr','ÐÐŸ Ñ˜Ðµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð°',0),(588453,16332,'sr','ÐÐ  Ñ˜Ðµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð°',0),(588454,16333,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ð“Ð› Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð°',0),(588455,16334,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ñ˜Ðµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð°',0),(588456,16335,'sr','Ð”ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð¾ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ',0),(588457,16336,'sr','ÐŸÐ»Ð°Ñ‚Ð½Ð¸ ÑÐ¿Ð¸ÑÐ°Ðº Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð°',0),(588458,16337,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°ÑšÐµ ÑÐ°Ð´Ð°',0),(588459,16338,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ð½Ð¾ ÑƒÑÐ¿Ñ˜ÐµÑˆÐ½Ð¾',0),(588460,16339,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°ÑšÐµ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(588461,16340,'sr','Ð”Ð°Ñ‚ÑƒÐ¼ Ð¿Ð¾ÑÐ»ÐµÐ´ÑšÐµ Ð³ÐµÐ½ÐµÑ€Ð¸ÑÐ°Ð½Ð°',0),(588462,16341,'sr','Ð—Ð°Ð´ÑšÐ¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ñ‚Ñ€Ð°Ð½ÑÐ°ÐºÑ†Ð¸Ñ˜Ðµ',0),(588463,16342,'sr','Ð‘Ð»Ð¾ÐºÐ¸Ñ€Ð°Ð½Ð¸ Ð¼Ð¾Ð´ÑƒÐ»Ð¸',0),(588464,16343,'sr','ÐÐµ Ð¼Ð¾Ð³Ñƒ Ð´Ð° Ð¿Ð¾Ð²ÑƒÐ¸Ðµ Ð²Ð°ÑƒÑ‡ÐµÑ€Ðµ',0),(588465,16344,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€Ð¸ Ð½ÐµÐ¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½Ð¸Ñ… Ñƒ Ñ€ÐµÐ´Ñƒ',0),(588466,16345,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð¼Ð°Ñ‚Ðµ Ð˜Ð” Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸Ð»Ð¸ Ð¨Ð¸Ñ„Ñ€Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(588467,16346,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð˜Ð” Ð¸Ð»Ð¸ Ð¨Ð¸Ñ„Ñ€Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¸ Ð¸Ð·Ð½Ð¾Ñ Ð¸ Ð±Ñ€Ð¾Ñ˜ Ð²Ð°Ð¶ÐµÑ›Ðµ Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(588468,16347,'sr','Ð¢Ñ€ÐµÐ±Ð° Ð´Ð° Ð±ÑƒÐ´Ðµ Ð¨Ð¸Ñ„Ñ€Ð°',0),(588469,16348,'sr','Ð”Ð¾Ð´Ð°Ñ‚Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ Ñƒ Ñ€ÐµÐ´Ñƒ Ñƒ Ð¸ÑÑ‚Ñƒ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð½Ð¾ Ñ˜Ðµ ÑÐ°Ð¼Ð¾ Ð˜Ð” ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð»Ð¸ ÑˆÐ¸Ñ„Ñ€Ñƒ ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸Ð»Ð¸ Ð¿Ñ€Ð²Ð¸ Ð¸ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ð¸ Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(588470,16349,'sr','ÐœÐ¾Ñ€Ð° Ð¸Ð¼Ð°Ñ‚Ð¸ Ð˜Ð” ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð»Ð¸ ÑˆÐ¸Ñ„Ñ€Ñƒ ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸Ð»Ð¸ Ð¿Ñ€Ð²Ð¸ Ð¸ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(588471,16350,'sr','ÐœÐ¾Ñ€Ð° Ð´Ð° Ð¸Ð¼Ð° Ð±Ñ€Ð¾Ñ˜ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ Ð¸ Ð˜Ð” ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð»Ð¸ ÑˆÐ¸Ñ„Ñ€Ñƒ ÐºÑƒÐ¿Ñ†Ð° Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸Ð»Ð¸ Ð¿Ñ€Ð²Ð¸ Ð¸ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(588472,16351,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÑÐ° Ð¾Ð²Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(588473,16352,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð·Ð° Ð¾Ð²Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(588474,16353,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÑÐ° Ð¾Ð²Ð°Ñ˜ Ð¿Ñ€Ð¾Ñ˜ÐµÐºÐ°Ñ‚ Ð±Ñ€Ð¾Ñ˜ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(588475,16354,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÑÐ° Ð¾Ð²Ð¾Ð¼ Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(588476,16355,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ñ˜Ðµ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½ ÑÐ°ÑÑ‚Ð°Ð½Ð°Ðº',0),(588477,16356,'sr','Ð›Ð°Ñ‚Ñ‚Ð¸Ñ‚ÑƒÐ´Ðµ',0),(588478,16357,'sr','Ð“ÐµÐ¾Ð³Ñ€Ð°Ñ„ÑÐºÐ° Ð´ÑƒÐ¶Ð¸Ð½Ð°',0),(588479,16358,'sr','ÐŸÑ€ÐµÐ»Ð¸Ð¼Ð°Ð±Ð»Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(588480,16359,'sr','Ð“ÐµÐ½ÐµÑ€Ð¸ÑÐ°ÑšÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð¸Ñ‡Ð½Ðµ ÑÑ‚Ð°Ð²ÐºÐµ ÐºÑšÐ¸Ð³Ðµ',0),(588481,16360,'sr','ÐŸÑ€ÐµÐºÐ¾ ÐŸÐ¥ÐŸ ÐœÐ°x Ð˜Ð½Ð¿ÑƒÑ‚ Ð’Ð°Ñ€Ñ',0),(588482,16361,'sr','Ð£Ð½ÐµÑÐ¸Ñ‚Ðµ Ð²Ñ€Ð¸Ñ˜ÐµÐ´Ð½Ð¾ÑÑ‚ Ð·Ð°',0),(588483,16362,'sr','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚Ð¸ Ð±Ñ€Ð¾Ð´: Ð¿Ð¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜',0),(588484,16363,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð·Ð° Ð¾Ð²Ð¾Ð³ ÐºÑƒÐ¿Ñ†Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(588485,16364,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÑÐ° Ð¾Ð²Ð¾Ð¼ Ð°Ð´Ñ€ÐµÑÐ¾Ð¼ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(588486,16365,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÑÐ° Ð¾Ð²Ð¾Ð¼ ÑˆÐ¸Ñ„Ñ€Ð¾Ð¼ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(588487,16366,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÑÐ° Ð¾Ð²Ð¸Ð¼ Ð¸Ð¼ÐµÐ½Ð¾Ð¼ Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(588488,16298,'sl','Nobene izjave na voljo',0),(588489,16299,'sl','Produktu',0),(588490,16300,'sl','Product list',0),(588491,16301,'sl','Neveljavno geslo',0),(588492,16302,'sl','Nastavite novo geslo',0),(588493,16303,'sl','Stranko ali delo mora biti nastavljen',0),(588494,16304,'sl','Stranka se ne ujema',0),(588495,16305,'sl','Uvoziti podatke',0),(588496,16306,'sl','Uvoznega raÄuna stranke in menjavo delovnih mest',0),(588497,16307,'sl','Izbruhnejo stroÅ¡kovno koda',0),(588498,16308,'sl','Izbruhne po kategoriji GL',0),(588499,16309,'sl','Ustvarjanje ponavljajoÄe se postavke',0),(588500,16310,'sl','Delo s to kodo Å¾e obstaja',0),(588501,16311,'sl','VeÄkratni lahko loÄeni z vejicami',0),(588502,16312,'sl','Potrebno in mora biti enoliÄna',0),(588503,16313,'sl','Uvoznega raÄuna spremembe',0),(588504,16314,'sl','Matrika',0),(588505,16315,'sl','NapaÄne',0),(588506,16316,'sl','Prvi & zadnje ime',0),(588507,16317,'sl','Å tevila priÄakovanih',0),(588508,16318,'sl','PrikaÅ¾i veÄ',0),(588509,16319,'sl','PrikaÅ¾i stanje seznam',0),(588510,16320,'sl','Res',0),(588511,16321,'sl','Izbrati morate GL raÄun ali stroÅ¡kovno kodo ali GL Category',0),(588512,16322,'sl','PoÅ¡lji Email obvestila, ko Bill',0),(588513,16323,'sl','PlaÄati datum',0),(588514,16324,'sl','RaÄune dobavitelja so bili odobreni za plaÄilo',0),(588515,16325,'sl','Prejemki PO na ta raÄun',0),(588516,16326,'sl','ZaraÄunavanje poÅ¡tno Å¡tevilko, Äe nobena ladja, da',0),(588517,16327,'sl','Dostava â€“ poÅ¡tna Å¡tevilka',0),(588518,16328,'sl','PrikaÅ¾i ladji poÅ¡tna Å¡tevilka',0),(588519,16329,'sl','Razvrsti po Zip kodo',0),(588520,16330,'sl','Ni izbrana vrednost',0),(588521,16331,'sl','AP zaprta',0),(588522,16332,'sl','AR, zaprta',0),(588523,16333,'sl','Neposredno GL zaprta',0),(588524,16334,'sl','Zaloge, zaprta',0),(588525,16335,'sl','Delno zaprta',0),(588526,16336,'sl','IzplaÄane plaÄe, zaprta',0),(588527,16337,'sl','Zdaj ustvarjajo',0),(588528,16338,'sl','UspeÅ¡no ustvarjen',0),(588529,16339,'sl','Ustvarite stornirano postavko',0),(588530,16340,'sl','Zadnji datum nastanka',0),(588531,16341,'sl','Zadnji datum transakcije',0),(588532,16342,'sl','Blokirane modulov',0),(588533,16343,'sl','Mogli Unpost boni',0),(588534,16344,'sl','Bonov neknjiÅ¾enih OK',0),(588535,16345,'sl','Mora imeti ID prodajalca ali koda prodajalca ali ime dobavitelja',0),(588536,16346,'sl','Mora imeti Å¡tevilko raÄuna in ID prodajalca ali koda prodajalca ali ime dobavitelja in koliÄino in veljaven raÄun Å¡tevilka',0),(588537,16347,'sl','Mora biti Å¡ifro',0),(588538,16348,'sl','Dodatne vrstiÄne postavke v isti raÄun potrebujete ID stranke ali kupca ali ime podjetja ali prvi in priimek in Å¡tevilko raÄuna',0),(588539,16349,'sl','Mora imeti ID stranke ali kupca ali firma ali ime in priimek',0),(588540,16350,'sl','Mora imeti Å¡tevilko raÄuna in ID stranke ali kupca ali firma ali ime in priimek',0),(588541,16351,'sl','Delo s tem imenom Å¾e obstaja',0),(588542,16352,'sl','Delo za tega kupca Å¾e obstaja',0),(588543,16353,'sl','Delo s to Å¡tevilko projekta Å¾e obstaja',0),(588544,16354,'sl','Delo s tem naslovom Å¾e obstaja',0),(588545,16355,'sl','Job Datum zapiranja',0),(588546,16356,'sl','Lattitude',0),(588547,16357,'sl','DolÅ¾ine',0),(588548,16358,'sl','Prelimable datum',0),(588549,16359,'sl','Ustvarjanje ponavljajoÄe se postavke',0),(588550,16360,'sl','Nad PHP Max vloÅ¾ek Vars',0),(588551,16361,'sl','Vnesite vrednost za',0),(588552,16362,'sl','PrikaÅ¾i ladji poÅ¡tna Å¡tevilka',0),(588553,16363,'sl','Delo za tega kupca Å¾e obstaja',0),(588554,16364,'sl','Delo s tem naslovom Å¾e obstaja',0),(588555,16365,'sl','Delo s to kodo Å¾e obstaja',0),(588556,16366,'sl','Delo s tem imenom Å¾e obstaja',0),(588557,16298,'es','Ninguna declaraciÃ³n disponible',0),(588558,16299,'es','InformaciÃ³n del producto',0),(588559,16300,'es','Hoja de producto',0),(588560,16301,'es','ContraseÃ±a no vÃ¡lida',0),(588561,16302,'es','Establecer una nueva contraseÃ±a',0),(588562,16303,'es','Cliente o trabajo debe establecerse',0),(588563,16304,'es','No coincide con el cliente',0),(588564,16305,'es','Importar informaciÃ³n',0),(588565,16306,'es','ImportaciÃ³n factura cliente y cambios de trabajo',0),(588566,16307,'es','Romper por costo cÃ³digo',0),(588567,16308,'es','Romper por categorÃ­a GL',0),(588568,16309,'es','Generar entradas recurrentes',0),(588569,16310,'es','Un trabajo con este cÃ³digo ya existe',0),(588570,16311,'es','Las entradas mÃºltiples se pueden separar con comas',0),(588571,16312,'es','Necesaria y debe ser Ãºnico',0),(588572,16313,'es','Cambios de factura de importaciÃ³n',0),(588573,16314,'es','Cualquier valor',0),(588574,16315,'es','Falso',0),(588575,16316,'es','Primer y pasado nombre',0),(588576,16317,'es','NÃºmero esperado',0),(588577,16318,'es','Ver mÃ¡s',0),(588578,16319,'es','Lista de mostrar estado',0),(588579,16320,'es','Verdadera',0),(588580,16321,'es','Debe seleccionar una cuenta de contabilidad o cÃ³digo costo o categorÃ­a GL',0),(588581,16322,'es','Enviar notificaciones de correo electrÃ³nico al proyecto de ley aprobado',0),(588582,16323,'es','Fecha de pago',0),(588583,16324,'es','Vendedor cuentas han sido aprobadas para pago',0),(588584,16325,'es','Recibos de PO en este proyecto de ley',0),(588585,16326,'es','FacturaciÃ³n CÃ³digo Postal si ningÃºn barco a',0),(588586,16327,'es','Enviar CÃ³digo Postal',0),(588587,16328,'es','Ver nave CÃ³digo Postal',0),(588588,16329,'es','Ordenar por cÃ³digo postal',0),(588589,16330,'es','NingÃºn valor seleccionado',0),(588590,16331,'es','AP cerrado',0),(588591,16332,'es','AR cerrado',0),(588592,16333,'es','GL directo cerrado',0),(588593,16334,'es','Inventario cerrado',0),(588594,16335,'es','Parcialmente cerrada',0),(588595,16336,'es','NÃ³mina cerrada',0),(588596,16337,'es','Generar ahora',0),(588597,16338,'es','Generado con Ã©xito',0),(588598,16339,'es','Generan entrada de reversa',0),(588599,16340,'es','Fecha de Ãºltima generada',0),(588600,16341,'es','Ãšltima fecha de la transacciÃ³n',0),(588601,16342,'es','MÃ³dulos bloqueados',0),(588602,16343,'es','Incapaz de Unpost vales',0),(588603,16344,'es','Vales sin registrar OK',0),(588604,16345,'es','Debe tener un ID de proveedor, cÃ³digo de proveedor o nombre del proveedor',0),(588605,16346,'es','Debe tener nÃºmero de factura y proveedor ID o cÃ³digo de proveedor o nombre del proveedor y cantidad y nÃºmero de cuenta vÃ¡lido',0),(588606,16347,'es','Debe ser un cÃ³digo',0),(588607,16348,'es','Elementos de lÃ­nea adicionales en la misma factura solo necesitan el ID de cliente o cÃ³digo de cliente o nombre de la empresa o primero y apellido y el nÃºmero de factura',0),(588608,16349,'es','Debe tener un ID de cliente o cÃ³digo de cliente o nombre de la empresa o primero y apellido',0),(588609,16350,'es','Debe tener nÃºmero de factura y ID de cliente o cÃ³digo de cliente o nombre de la empresa o primer y apellido',0),(588610,16351,'es','Un trabajo con este nombre ya existe',0),(588611,16352,'es','Un trabajo de este cliente ya existe',0),(588612,16353,'es','Ya existe un trabajo con este nÃºmero del proyecto',0),(588613,16354,'es','Ya existe un trabajo con esta direcciÃ³n',0),(588614,16355,'es','Trabajo cerrado fecha',0),(588615,16356,'es','Lattitude',0),(588616,16357,'es','Longitud',0),(588617,16358,'es','Fecha prelimable',0),(588618,16359,'es','Generar movimientos recurrentes',0),(588619,16360,'es','Sobre PHP entrada mÃ¡xima Vars',0),(588620,16361,'es','Por favor, introduzca un valor para',0),(588621,16362,'es','Ver nave CÃ³digo Postal',0),(588622,16363,'es','Un trabajo de este cliente ya existe',0),(588623,16364,'es','Ya existe un trabajo con esta direcciÃ³n',0),(588624,16365,'es','Un trabajo con este cÃ³digo ya existe',0),(588625,16366,'es','Un trabajo con este nombre ya existe',0),(588626,16298,'sv','Inga uppgifter tillgÃ¤ngliga',0),(588627,16299,'sv','Produktinfo',0),(588628,16300,'sv','Produktblad',0),(588629,16301,'sv','Ogiltigt lÃ¶senord',0),(588630,16302,'sv','Ange ett nytt lÃ¶senord',0),(588631,16303,'sv','Kunden eller jobb mÃ¥ste stÃ¤llas in',0),(588632,16304,'sv','Matchar inte kunden',0),(588633,16305,'sv','Importera Information',0),(588634,16306,'sv','Importera faktura kunden och jobb Ã¤ndras',0),(588635,16307,'sv','Bryta ut av kostnad kod',0),(588636,16308,'sv','Bryta ut av GL kategori',0),(588637,16309,'sv','Generera Ã¥terkommande poster',0),(588638,16310,'sv','Det finns redan ett jobb med denna kod',0),(588639,16311,'sv','Flera poster kan separeras med kommatecken',0),(588640,16312,'sv','KrÃ¤vs och mÃ¥ste vara unikt',0),(588641,16313,'sv','Importera faktura fÃ¶rÃ¤ndringar',0),(588642,16314,'sv','NÃ¥got vÃ¤rde',0),(588643,16315,'sv','Falska',0),(588644,16316,'sv','FÃ¶rsta & sista namn',0),(588645,16317,'sv','Antalet fÃ¶rvÃ¤ntade',0),(588646,16318,'sv','Visa mer',0),(588647,16319,'sv','Visa staten lista',0),(588648,16320,'sv','Sanna',0),(588649,16321,'sv','Du mÃ¥ste vÃ¤lja en GL konto, kostnad kod eller GL kategori',0),(588650,16322,'sv','Skicka e-post meddelanden nÃ¤r Bill godkÃ¤nd',0),(588651,16323,'sv','Betala datum',0),(588652,16324,'sv','LeverantÃ¶r rÃ¤kningar har godkÃ¤nts fÃ¶r betalning',0),(588653,16325,'sv','PO kvitton pÃ¥ detta lagfÃ¶rslag',0),(588654,16326,'sv','Fakturering postnummer om ingen fartyget till',0),(588655,16327,'sv','Fartyget till postnummer',0),(588656,16328,'sv','Visa fartyget till postnummer',0),(588657,16329,'sv','Sortera efter postnummer',0),(588658,16330,'sv','Inget vÃ¤rde valt',0),(588659,16331,'sv','AP stÃ¤ngd',0),(588660,16332,'sv','AR stÃ¤ngd',0),(588661,16333,'sv','Direkta GL stÃ¤ngd',0),(588662,16334,'sv','Lagret stÃ¤ngt',0),(588663,16335,'sv','Delvis stÃ¤ngt',0),(588664,16336,'sv','LÃ¶nelistan stÃ¤ngd',0),(588665,16337,'sv','Generera nu',0),(588666,16338,'sv','Genererade framgÃ¥ngsrikt',0),(588667,16339,'sv','Generera Ã¥terfÃ¶ringspost',0),(588668,16340,'sv','Sista datumet genereras',0),(588669,16341,'sv','Senaste transaktionsdatum',0),(588670,16342,'sv','Blockerade moduler',0),(588671,16343,'sv','Det gÃ¥r inte att Unpost kuponger',0),(588672,16344,'sv','Kuponger som ej bokfÃ¶rda OK',0),(588673,16345,'sv','MÃ¥ste ha en leverantÃ¶rs-ID eller leverantÃ¶rens kod eller leverantÃ¶rens namn',0),(588674,16346,'sv','MÃ¥ste ha fakturanummer och vendÃ¶r ID eller leverantÃ¶rens kod eller leverantÃ¶rens namn och belopp och giltigt kontonummer',0),(588675,16347,'sv','MÃ¥ste vara en kod',0),(588676,16348,'sv','Ytterligare poster i samma faktura behÃ¶ver bara kund-ID eller Kundkod eller fÃ¶retagsnamn eller fÃ¶rsta och sista namn och fakturanumret',0),(588677,16349,'sv','MÃ¥ste ha ett kundnummer eller Kundkod eller fÃ¶retagsnamn eller fÃ¶rsta och sista namn',0),(588678,16350,'sv','MÃ¥ste ha fakturanummer och kundnummer eller Kundkod eller fÃ¶retagsnamn eller fÃ¶rsta och sista namn',0),(588679,16351,'sv','Ett jobb med det hÃ¤r namnet finns redan',0),(588680,16352,'sv','Ett jobb fÃ¶r den hÃ¤r kunden finns redan',0),(588681,16353,'sv','Ett jobb med detta projektnummer finns redan',0),(588682,16354,'sv','Ett jobb med den hÃ¤r adressen finns redan',0),(588683,16355,'sv','Jobb stÃ¤ngt datum',0),(588684,16356,'sv','Lattitude',0),(588685,16357,'sv','Longitud',0),(588686,16358,'sv','Prelimable datum',0),(588687,16359,'sv','Generera Ã¥terkommande transaktioner',0),(588688,16360,'sv','Ã–ver PHP Max Input Vars',0),(588689,16361,'sv','VÃ¤nligen ange ett vÃ¤rde fÃ¶r',0),(588690,16362,'sv','Visa fartyget till postnummer',0),(588691,16363,'sv','Ett jobb fÃ¶r den hÃ¤r kunden finns redan',0),(588692,16364,'sv','Ett jobb med den hÃ¤r adressen finns redan',0),(588693,16365,'sv','Det finns redan ett jobb med denna kod',0),(588694,16366,'sv','Ett jobb med det hÃ¤r namnet finns redan',0),(588695,16298,'th','à¸‡à¸šà¹„à¸¡à¹ˆà¸¡à¸µ',0),(588696,16299,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œ',0),(588697,16300,'th','à¸œà¸¥à¸´à¸•à¸ à¸±à¸“à¸‘à¹Œà¹à¸œà¹ˆà¸™',0),(588698,16301,'th','à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¹„à¸¡à¹ˆà¸–à¸¹à¸à¸•à¹‰à¸­à¸‡',0),(588699,16302,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸£à¸«à¸±à¸ªà¸œà¹ˆà¸²à¸™à¹ƒà¸«à¸¡à¹ˆ',0),(588700,16303,'th','à¸‡à¸²à¸™à¸«à¸£à¸·à¸­à¸¥à¸¹à¸à¸„à¹‰à¸²à¸•à¹‰à¸­à¸‡à¸à¸²à¸£',0),(588701,16304,'th','à¹„à¸¡à¹ˆà¸•à¸£à¸‡à¸à¸±à¸šà¸¥à¸¹à¸à¸„à¹‰à¸²',0),(588702,16305,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(588703,16306,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸¥à¸¹à¸à¸„à¹‰à¸²à¹à¸¥à¸°à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸‡à¸²à¸™',0),(588704,16307,'th','à¹à¸šà¹ˆà¸‡ à¹‚à¸”à¸¢à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(588705,16308,'th','à¹à¸šà¹ˆà¸‡à¸­à¸­à¸à¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸— GL',0),(588706,16309,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸à¸²à¸£à¹€à¸à¸´à¸”à¸‹à¹‰à¸³',0),(588707,16310,'th','à¸‡à¸²à¸™à¸—à¸µà¹ˆ à¸¡à¸µà¸£à¸«à¸±à¸ªà¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(588708,16311,'th','à¸«à¸¥à¸²à¸¢à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸²à¸¡à¸²à¸£à¸–à¸„à¸±à¹ˆà¸™ à¸”à¹‰à¸§à¸¢à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¸ˆà¸¸à¸¥à¸ à¸²à¸„',0),(588709,16312,'th','à¸ˆà¸³à¹€à¸›à¹‡à¸™ à¹à¸¥à¸°à¸•à¹‰à¸­à¸‡à¹„à¸¡à¹ˆà¸‹à¹‰à¸³à¸à¸±à¸™',0),(588710,16313,'th','à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(588711,16314,'th','à¸„à¹ˆà¸²à¹ƒà¸” à¹†',0),(588712,16315,'th','à¹€à¸›à¹‡à¸™à¹€à¸—à¹‡à¸ˆ',0),(588713,16316,'th','à¸Šà¸·à¹ˆà¸­à¹à¸£à¸ à¹à¸¥à¸°à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(588714,16317,'th','à¸ˆà¸³à¸™à¸§à¸™à¸—à¸µà¹ˆà¸„à¸²à¸”à¹„à¸§à¹‰',0),(588715,16318,'th','à¹à¸ªà¸”à¸‡à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(588716,16319,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¹à¸ªà¸”à¸‡à¸ªà¸–à¸²à¸™à¸°',0),(588717,16320,'th','à¸ˆà¸£à¸´à¸‡',0),(588718,16321,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸šà¸±à¸à¸Šà¸µ à¸«à¸£à¸·à¸­à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™ à¸«à¸£à¸·à¸­à¸›à¸£à¸°à¹€à¸ à¸— GL',0),(588719,16322,'th','à¸ªà¹ˆà¸‡à¸­à¸µà¹€à¸¡à¸¥à¹Œà¹à¸ˆà¹‰à¸‡à¹€à¸¡à¸·à¹ˆà¸­à¹„à¸”à¹‰à¸£à¸±à¸šà¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¹€à¸‡à¸´à¸™',0),(588720,16323,'th','à¸ˆà¹ˆà¸²à¸¢à¸§à¸±à¸™',0),(588721,16324,'th','à¸‚à¸²à¸¢à¸•à¸±à¹‹à¸§à¹„à¸”à¹‰à¸£à¸±à¸šà¸à¸²à¸£à¸­à¸™à¸¸à¸¡à¸±à¸•à¸´à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(588722,16325,'th','à¸£à¸±à¸š PO à¸ˆà¸²à¸à¸ªà¸¹à¸•à¸£à¸™à¸µà¹‰',0),(588723,16326,'th','à¸£à¸«à¸±à¸ªà¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œà¹€à¸£à¸µà¸¢à¸à¹€à¸à¹‡à¸šà¹€à¸‡à¸´à¸™à¸–à¹‰à¸²à¹„à¸¡à¹ˆà¸¡à¸µà¹€à¸£à¸·à¸­',0),(588724,16327,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸—à¸µà¹ˆà¸£à¸«à¸±à¸ªà¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œ',0),(588725,16328,'th','à¹à¸ªà¸”à¸‡à¹€à¸£à¸·à¸­à¸£à¸«à¸±à¸ªà¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œ',0),(588726,16329,'th','à¹€à¸£à¸µà¸¢à¸‡à¸•à¸²à¸¡à¸£à¸«à¸±à¸ªà¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œ',0),(588727,16330,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸„à¹ˆà¸²à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸',0),(588728,16331,'th','AP à¸›à¸´à¸”',0),(588729,16332,'th','à¸›à¸´à¸” AR',0),(588730,16333,'th','à¸›à¸´à¸” GL à¹‚à¸”à¸¢à¸•à¸£à¸‡',0),(588731,16334,'th','à¸›à¸´à¸”à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(588732,16335,'th','à¸›à¸´à¸”à¸šà¸²à¸‡à¸ªà¹ˆà¸§à¸™',0),(588733,16336,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸—à¸µà¹ˆà¸›à¸´à¸”',0),(588734,16337,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸•à¸­à¸™à¸™à¸µà¹‰',0),(588735,16338,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹€à¸ªà¸£à¹‡à¸ˆà¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(588736,16339,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¸à¸¥à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£',0),(588737,16340,'th','à¸§à¸±à¸™à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢à¸—à¸µà¹ˆà¸ªà¸£à¹‰à¸²à¸‡à¸‚à¸¶à¹‰à¸™',0),(588738,16341,'th','à¸§à¸±à¸™à¸˜à¸¸à¸£à¸à¸£à¸£à¸¡à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(588739,16342,'th','à¹‚à¸¡à¸”à¸¹à¸¥à¸—à¸µà¹ˆà¸–à¸¹à¸à¸šà¸¥à¹‡à¸­à¸',0),(588740,16343,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸– Unpost à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸',0),(588741,16344,'th','à¹ƒà¸šà¸ªà¸³à¸„à¸±à¸à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸•à¸à¸¥à¸‡',0),(588742,16345,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µ ID à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸‚à¸²à¸¢ à¸«à¸£à¸·à¸­à¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸‚à¸²à¸¢ à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(588743,16346,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ à¹à¸¥à¸° ID à¸‚à¸­à¸‡à¸œà¸¹à¹‰à¸‚à¸²à¸¢ à¸«à¸£à¸·à¸­à¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸‚à¸²à¸¢ à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢ à¹à¸¥à¸°à¸ˆà¸³à¸™à¸§à¸™à¹€à¸‡à¸´à¸™ à¹à¸¥à¸°à¹€à¸¥à¸‚à¸šà¸±à¸à¸Š',0),(588744,16347,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸£à¸«à¸±à¸ª',0),(588745,16348,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸”à¸µà¸¢à¸§à¸à¸±à¸™à¸•à¹‰à¸­à¸‡à¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸² à¸«à¸£à¸·à¸­à¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸² à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸— à¸«à¸£à¸·à¸­à¹à¸£à¸',0),(588746,16349,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸² à¸«à¸£à¸·à¸­à¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸² à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸— à¸«à¸£à¸·à¸­à¹à¸£à¸ à¹à¸¥à¸°à¸Šà¸·à¹ˆà¸­à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(588747,16350,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ à¹à¸¥à¸°à¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸² à¸«à¸£à¸·à¸­à¸£à¸«à¸±à¸ªà¸¥à¸¹à¸à¸„à¹‰à¸² à¸«à¸£à¸·à¸­à¸Šà¸·à¹ˆà¸­à¸šà¸£à¸´à¸©à¸±à¸— à¸«à¸£à¸·à¸­à¹à¸£à¸ à¹à¸¥à¸°à¸Šà¸·à¹ˆà¸­à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(588748,16351,'th','à¸‡à¸²à¸™à¸—à¸µà¹ˆ à¸¡à¸µà¸Šà¸·à¹ˆà¸­à¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(588749,16352,'th','à¸‡à¸²à¸™à¸™à¸µà¹‰à¸¥à¸¹à¸à¸„à¹‰à¸²à¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(588750,16353,'th','à¸‡à¸²à¸™à¸—à¸µà¹ˆà¸¡à¸µà¹‚à¸„à¸£à¸‡à¸à¸²à¸£à¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(588751,16354,'th','à¸‡à¸²à¸™à¸—à¸µà¹ˆ à¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¸™à¸µà¹‰à¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(588752,16355,'th','à¸‡à¸²à¸™à¸›à¸´à¸”à¸§à¸±à¸™',0),(588753,16356,'th','à¸—à¸µà¹ˆà¸¥à¸°à¸•à¸´à¸ˆà¸¹à¸”',0),(588754,16357,'th','à¸¥à¸­à¸‡à¸ˆà¸´à¸ˆà¸¹à¸”',0),(588755,16358,'th','à¸§à¸±à¸™ prelimable',0),(588756,16359,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸µà¹ˆà¹€à¸à¸´à¸”à¸‹à¹‰à¸³',0),(588757,16360,'th','à¸œà¹ˆà¸²à¸™ PHP Vars à¸ªà¸±à¸à¸à¸²à¸“à¸ªà¸¹à¸‡à¸ªà¸¸à¸”',0),(588758,16361,'th','à¹‚à¸›à¸£à¸”à¹ƒà¸ªà¹ˆà¸„à¹ˆà¸²à¸ªà¸³à¸«à¸£à¸±à¸š',0),(588759,16362,'th','à¹à¸ªà¸”à¸‡à¹€à¸£à¸·à¸­à¸£à¸«à¸±à¸ªà¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œ',0),(588760,16363,'th','à¸‡à¸²à¸™à¸™à¸µà¹‰à¸¥à¸¹à¸à¸„à¹‰à¸²à¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(588761,16364,'th','à¸‡à¸²à¸™à¸—à¸µà¹ˆ à¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¸™à¸µà¹‰à¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(588762,16365,'th','à¸‡à¸²à¸™à¸—à¸µà¹ˆ à¸¡à¸µà¸£à¸«à¸±à¸ªà¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(588763,16366,'th','à¸‡à¸²à¸™à¸—à¸µà¹ˆ à¸¡à¸µà¸Šà¸·à¹ˆà¸­à¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(588764,16298,'tr','AÃ§Ä±klama yok',0),(588765,16299,'tr','ÃœrÃ¼n bilgisi',0),(588766,16300,'tr','ÃœrÃ¼n sayfasÄ±',0),(588767,16301,'tr','GeÃ§ersiz parola',0),(588768,16302,'tr','Yeni ÅŸifre belirle',0),(588769,16303,'tr','MÃ¼ÅŸteri veya iÅŸ ayarlanmasÄ± gerekir',0),(588770,16304,'tr','MÃ¼ÅŸteri ile aynÄ± deÄŸil',0),(588771,16305,'tr','Bilgisini al',0),(588772,16306,'tr','Alma fatura mÃ¼ÅŸteri ve iÅŸ deÄŸiÅŸikliÄŸi',0),(588773,16307,'tr','Maliyet kodu tarafÄ±ndan patlak',0),(588774,16308,'tr','GL kategoriye gÃ¶re patlak',0),(588775,16309,'tr','Yinelenen giriÅŸler oluÅŸturmak',0),(588776,16310,'tr','Bu kod ile bir iÅŸ zaten mevcut',0),(588777,16311,'tr','Birden Ã§ok girdi virgÃ¼lle ayrÄ±lmÄ±ÅŸ',0),(588778,16312,'tr','Gerekli ve benzersiz olmalÄ±dÄ±r',0),(588779,16313,'tr','Alma fatura deÄŸiÅŸiklikleri',0),(588780,16314,'tr','Herhangi bir deÄŸer',0),(588781,16315,'tr','YanlÄ±ÅŸ',0),(588782,16316,'tr','Ä°lk ve son adÄ±',0),(588783,16317,'tr','Beklenen numarasÄ±',0),(588784,16318,'tr','Daha fazla gÃ¶ster',0),(588785,16319,'tr','GÃ¶sterme durumu listesi',0),(588786,16320,'tr','GerÃ§ek',0),(588787,16321,'tr','Bir GL hesap veya maliyet kodu veya GL Kategori seÃ§melisiniz',0),(588788,16322,'tr','Bill onaylÄ± e-posta bildirimleri gÃ¶nder',0),(588789,16323,'tr','Ã–deme tarihi',0),(588790,16324,'tr','SatÄ±cÄ± faturalarÄ± Ã¶deme iÃ§in onaylanmÄ±ÅŸtÄ±r',0),(588791,16325,'tr','Bu tasarÄ±nÄ±n PO bilgisi',0),(588792,16326,'tr','Posta kodu iÃ§in hiÃ§bir gemi EÄŸer fatura',0),(588793,16327,'tr','Posta kodu iÃ§in gemi',0),(588794,16328,'tr','Gemi iÃ§in posta kodu gÃ¶ster',0),(588795,16329,'tr','Posta koduna gÃ¶re sÄ±ralama',0),(588796,16330,'tr','SeÃ§ili deÄŸer',0),(588797,16331,'tr','KapalÄ± AP',0),(588798,16332,'tr','KapalÄ± AR',0),(588799,16333,'tr','DoÄŸrudan GL kapalÄ±',0),(588800,16334,'tr','KapalÄ± stok',0),(588801,16335,'tr','KÄ±smen kapalÄ±',0),(588802,16336,'tr','KapalÄ± bordro',0),(588803,16337,'tr','Åžimdi OluÅŸtur',0),(588804,16338,'tr','BaÅŸarÄ±yla oluÅŸturuldu',0),(588805,16339,'tr','Tersine Ã§evrilmiÅŸ bir giriÅŸ oluÅŸturmak',0),(588806,16340,'tr','OluÅŸturulan son tarihi',0),(588807,16341,'tr','Son iÅŸlem tarihi',0),(588808,16342,'tr','Engellenen modÃ¼lleri',0),(588809,16343,'tr','FiÅŸler Unpost kurulamÄ±yor',0),(588810,16344,'tr','Tamam deftere nakledilmemiÅŸ kuponlarÄ±',0),(588811,16345,'tr','Bir satÄ±cÄ± kimliÄŸi veya satÄ±cÄ± kodunu veya satÄ±cÄ± adÄ± olmasÄ± gerekir',0),(588812,16346,'tr','Fatura numarasÄ± ve satÄ±cÄ± kimliÄŸi veya satÄ±cÄ± kodunu veya satÄ±cÄ± adÄ±nÄ± ve tutarÄ± ve geÃ§erli hesap numarasÄ± olmalÄ±',0),(588813,16347,'tr','Bir kodu gerekir',0),(588814,16348,'tr','Ek satÄ±r Ã¶ÄŸeleri aynÄ± faturasÄ±ndaki mÃ¼ÅŸteri KÄ±mlÄ±ÄŸÄ± veya mÃ¼ÅŸteri kodu veya ÅŸirket adÄ± veya ilk ve son adÄ± ve fatura numarasÄ± yeterlidir',0),(588815,16349,'tr','Bir mÃ¼ÅŸteri kimliÄŸi veya mÃ¼ÅŸteri kodu veya ÅŸirket adÄ± veya ilk ve son adÄ± olmasÄ± gerekir',0),(588816,16350,'tr','Fatura numarasÄ± ve mÃ¼ÅŸteri numarasÄ± veya mÃ¼ÅŸteri kodu veya ÅŸirket adÄ± veya ilk ve son adÄ± olmasÄ± gerekir',0),(588817,16351,'tr','Bu ada sahip bir iÅŸ zaten mevcut',0),(588818,16352,'tr','Bu mÃ¼ÅŸteri iÃ§in bir iÅŸ zaten mevcut',0),(588819,16353,'tr','Bu proje numarasÄ± ile bir iÅŸ zaten mevcut',0),(588820,16354,'tr','Bu adresine sahip bir iÅŸ zaten mevcut',0),(588821,16355,'tr','Ä°ÅŸ kapanÄ±ÅŸ tarihi',0),(588822,16356,'tr','Lattitude',0),(588823,16357,'tr','Boylam',0),(588824,16358,'tr','Prelimable tarihi',0),(588825,16359,'tr','Yinelenen defter giriÅŸleri oluÅŸturmak',0),(588826,16360,'tr','PHP Max yÃ¼kÃ¼ Vars Ã¼zerinde',0),(588827,16361,'tr','LÃ¼tfen bir deÄŸer girin',0),(588828,16362,'tr','Gemi iÃ§in posta kodu gÃ¶ster',0),(588829,16363,'tr','Bu mÃ¼ÅŸteri iÃ§in bir iÅŸ zaten mevcut',0),(588830,16364,'tr','Bu adresine sahip bir iÅŸ zaten mevcut',0),(588831,16365,'tr','Bu kod ile bir iÅŸ zaten mevcut',0),(588832,16366,'tr','Bu ada sahip bir iÅŸ zaten mevcut',0),(588833,16298,'ur','Ú©ÙˆØ¦ÛŒ Ø±ÙˆØ§ÛŒØª Ù‚Ø§Ø¦Ù…',0),(588834,16299,'ur','Ù¾Ø±ÙˆÚˆÚ©Ù¹ Ú©ÛŒ Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(588835,16300,'ur','Ù…ØµÙ†ÙˆØ¹Ø§Øª ÙˆØ±Ù‚',0),(588836,16301,'ur','Ù†Ø§Ø¬Ø§Ø¦Ø² Ù¾Ø§Ø³ ÙˆØ±Úˆ',0),(588837,16302,'ur','Ø§ÛŒÚ© Ù†ÛŒØ§ Ù¾Ø§Ø³ ÙˆØ±Úˆ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(588838,16303,'ur','Ú©Ø³Ù¹Ù…Ø± ÛŒØ§ Ú©Ø§Ù… Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(588839,16304,'ur','Ú¯Ø§ÛÚ© Ø³Û’ Ù…Ø´Ø§Ø¨Û Ù†ÛÛŒÚº',0),(588840,16305,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(588841,16306,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú¯Ø§ÛÚ© Ø§ÙˆØ± Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(588842,16307,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù‚ÛŒÙ…Øª Ú©ÙˆÚˆ ØªÙˆÚ‘Ù†Û’ Ú©Û’',0),(588843,16308,'ur','Ø¬ÛŒØ¬Û’ Ø²Ù…Ø±Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’ ØªÙˆÚ‘',0),(588844,16309,'ur','Ù…Ú©Ø±Ø± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª ØªØ®Ù„ÛŒÙ‚',0),(588845,16310,'ur','Ø§Ø³ Ø¶Ø§Ø¨Ø·Û Ø§Ø®Ù„Ø§Ù‚ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ú©Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(588846,16311,'ur','Ú©Ø§Ù…Ø§ Ú©Û’ Ø³Ø§ØªÚ¾ Ù…ØªØ¹Ø¯Ø¯ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Ùˆ Ø§Ù„Ú¯ Ú©ÛŒØ§ Ø¬Ø§ Ø³Ú©ØªØ§',0),(588847,16312,'ur','Ø¶Ø±ÙˆØ±Øª Ø§ÙˆØ± Ù…Ù†ÙØ±Ø¯ ÛÙˆÙ†Ø§ Ú†Ø§ÛØ¦Û’',0),(588848,16313,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø§Ù†ÙˆØ§Ø¦Ø³ ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº',0),(588849,16314,'ur','Ú©ÙˆØ¦ÛŒ Ù‚Ø¯Ø±',0),(588850,16315,'ur','Ø¬Ú¾ÙˆÙ¹Ø§',0),(588851,16316,'ur','Ù¾ÛÙ„ÛŒ & Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù…',0),(588852,16317,'ur','Ù…ØªÙˆÙ‚Ø¹ Ù†Ù…Ø¨Ø±',0),(588853,16318,'ur','Ø²ÛŒØ§Ø¯Û Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(588854,16319,'ur','ÙÛØ±Ø³Øª Ù†Ù…Ø§ÛŒØ´ Ø±ÛŒØ§Ø³Øª',0),(588855,16320,'ur','Ø³Ú†Ø§',0),(588856,16321,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ ÛŒØ§ Ù‚ÛŒÙ…Øª Ú©ÙˆÚˆ ÛŒØ§ Ø¬ÛŒØ¬Û’ Ø²Ù…Ø±Û Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(588857,16322,'ur','Ø¨Ù„ Ú©ÛŒ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ Ø¬Ø¨ Ø§ÛŒ Ù…ÛŒÙ„ Ú©ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨Ú¾ÛŒØ¬ÛŒÚº',0),(588858,16323,'ur','ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ø§Ø¯Ø§ Ú©Ø±ØªÛ’ ÛÛŒÚº',0),(588859,16324,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†Ø¸ÙˆØ±ÛŒ Ø¯Û’ Ø¯ÛŒ Ú¯Ø¦ÛŒ ÛÛ’',0),(588860,16325,'ur','Ø§Ø³ Ø¨Ù„ Ù¾Ø± Ù¾Ùˆ Ø±Ø³ÛŒØ¯ÛŒÚº',0),(588861,16326,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÙˆÚˆ Ù…ÛŒÚº Ø§Ú¯Ø± Ú©ÙˆØ¦ÛŒ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’ Ø­Ø³Ø§Ø¨ Ú©Ø±Ù†Ø§ Û”',0),(588862,16327,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÙˆÚˆ Ú©Û’ Ù„Ø¦Û’ Ø¬ÛØ§Ø²',0),(588863,16328,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÙˆÚˆ Ú©Û’ Ù„Ø¦Û’ Ø¬ÛØ§Ø² Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(588864,16329,'ur','Ú†Ú¾Ø§Ù†Ù¹ÛŒÚº Ø¨Ù…Ø·Ø§Ø¨Ù‚ Ø²Ù¾ Ú©ÙˆÚˆ',0),(588865,16330,'ur','Ú©ÙˆØ¦ÛŒ Ù‚Ø¯Ø± Ù…Ù†ØªØ®Ø¨',0),(588866,16331,'ur','AP Ø¨Ù†Ø¯',0),(588867,16332,'ur','Ø§Ù„Ø±Ø­ÛŒÙ‚ Ø¨Ù†Ø¯',0),(588868,16333,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª Ø¬ÛŒØ¬Û’ Ø¨Ù†Ø¯',0),(588869,16334,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¨Ù†Ø¯',0),(588870,16335,'ur','Ø¬Ø²ÙˆÛŒ Ø·ÙˆØ± Ù¾Ø± Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(588871,16336,'ur','Ù¾Û’ Ø±ÙˆÙ„ Ú©Ùˆ Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(588872,16337,'ur','Ø§Ø¨ Ù¾ÛŒØ¯Ø§',0),(588873,16338,'ur','Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ Ù¾ÛŒØ¯Ø§',0),(588874,16339,'ur','Ø±ÛŒÙˆØ±Ø³ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù¾ÛŒØ¯Ø§',0),(588875,16340,'ur','Ù¾ÛŒØ¯Ø§ Ú©ÛŒ Ø¢Ø®Ø±ÛŒ ØªØ§Ø±ÛŒØ®',0),(588876,16341,'ur','Ù„ÛŒÙ† Ø¯ÛŒÙ† Ú©ÛŒ Ø¢Ø®Ø±ÛŒ ØªØ§Ø±ÛŒØ®',0),(588877,16342,'ur','Ø¨Ù„Ø§Ú© Ø´Ø¯Û Ù…Ø§ÚˆÛŒÙˆÙ„',0),(588878,16343,'ur','ÙˆÙˆÚ†Ø±Ø² Ø§Ù†Ù¾ÙˆØ³Ù¹ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©Ø§',0),(588879,16344,'ur','Ù¹Ú¾ÛŒÚ© ÛÛ’ Ø§Ù†Ù¾Ø¹Ø«Ù¹ÛŒØ¯ ÙˆÙˆÚ†Ø±Ø²',0),(588880,16345,'ur','Ø§ÛŒÚ© ÙˆÛŒÙ†ÚˆØ± ID ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û Ú©ÙˆÚˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û Ù†Ø§Ù… ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(588881,16346,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø§ÙˆØ± ÙˆÛŒÙ†ÚˆØ± ID ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û Ú©ÙˆÚˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Û Ù†Ø§Ù… Ø§ÙˆØ± Ø±Ù‚Ù… Ø§ÙˆØ± Ø¬Ø§Ø¦Ø² Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø± ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(588882,16347,'ur','Ø§ÛŒÚ© Ú©ÙˆÚˆ Ú©Ø±Ù†Û’ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(588883,16348,'ur','Ø§Ø¶Ø§ÙÛŒ Ù„Ø§Ø¦Ù† Ø§Ø´ÛŒØ§Ø¡ Ø§ÛŒÚ© ÛÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ù…ÛŒÚº ØµØ±Ù Ø®Ø±ÛŒØ¯Ø§Ø± Ú©ÛŒ Ø´Ù†Ø§Ø®Øª ÛŒØ§ Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆÚˆ ÛŒØ§ Ú©Ù…Ù¾Ù†ÛŒ Ú©Ø§ Ù†Ø§Ù… ÛŒØ§ Ù¾ÛÙ„ÛŒ Ø§ÙˆØ± Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ø§ÙˆØ± Ø§Ù†ÙˆØ§Ø¦Ø³ Ù†Ù…Ø¨Ø± Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’',0),(588884,16349,'ur','Ø§ÛŒÚ© Ø®Ø±ÛŒØ¯Ø§Ø± Ú©ÛŒ Ø´Ù†Ø§Ø®Øª ÛŒØ§ Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆÚˆ ÛŒØ§ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù†Ø§Ù… ÛŒØ§ Ù¾ÛÙ„ÛŒ Ø§ÙˆØ± Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(588885,16350,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ø§ÙˆØ± Ø®Ø±ÛŒØ¯Ø§Ø± Ú©ÛŒ Ø´Ù†Ø§Ø®Øª ÛŒØ§ Ú©Ø³Ù¹Ù…Ø± Ú©ÙˆÚˆ ÛŒØ§ Ú©Ù…Ù¾Ù†ÛŒ Ú©Û’ Ù†Ø§Ù… ÛŒØ§ Ù¾ÛÙ„ÛŒ Ø§ÙˆØ± Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(588886,16351,'ur','Ø§Ø³ Ù†Ø§Ù… Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ú©Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(588887,16352,'ur','ÛŒÛ ØµØ§Ø±ÙÛŒÙ† Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ú©Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(588888,16353,'ur','Ø§Ø³ Ù…Ù†ØµÙˆØ¨Û’ Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ú©Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(588889,16354,'ur','Ø§Ø³ Ø¹Ù†ÙˆØ§Ù† Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ú©Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(588890,16355,'ur','ØªØ§Ø±ÛŒØ® Ú©Ø§ Ú©Ø§Ù… Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(588891,16356,'ur','Ø¹Ø±Ø¶ Ø§Ù„Ø¨Ù„Ø¯',0),(588892,16357,'ur','Ø·ÙˆÙ„ Ø§Ù„Ø¨Ù„Ø¯',0),(588893,16358,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù…Ø¨Ù„ÛŒ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(588894,16359,'ur','Ù…Ú©Ø±Ø± Ú©Ú¾Ø§ØªØ§ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª ØªØ®Ù„ÛŒÙ‚',0),(588895,16360,'ur','Ù¾ÛŒ Ø§ÛŒÚ† Ù¾ÛŒ Ù¾Ø± Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û ÙˆØ¢Ø±Ø³ Ø§Ù† Ù¾Ù¹',0),(588896,16361,'ur','Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ù‚Ø¯Ø± Ø¯Ø§Ø®Ù„ Ú©Ø±ÛŒÚº',0),(588897,16362,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÙˆÚˆ Ú©Û’ Ù„Ø¦Û’ Ø¬ÛØ§Ø² Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(588898,16363,'ur','ÛŒÛ ØµØ§Ø±ÙÛŒÙ† Ú©Û’ Ù„Ø¦Û’ Ø§ÛŒÚ© Ú©Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(588899,16364,'ur','Ø§Ø³ Ø¹Ù†ÙˆØ§Ù† Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ú©Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(588900,16365,'ur','Ø§Ø³ Ø¶Ø§Ø¨Ø·Û Ø§Ø®Ù„Ø§Ù‚ Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ú©Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(588901,16366,'ur','Ø§Ø³ Ù†Ø§Ù… Ú©Û’ Ø³Ø§ØªÚ¾ Ø§ÛŒÚ© Ú©Ø§Ù… Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(588902,16298,'vi','KhÃ´ng cÃ³ tuyÃªn bá»‘ sáºµn sÃ ng',0),(588903,16299,'vi','ThÃ´ng tin sáº£n pháº©m',0),(588904,16300,'vi','Sáº£n pháº©m táº¥m',0),(588905,16301,'vi','Máº­t kháº©u khÃ´ng há»£p lá»‡',0),(588906,16302,'vi','Thiáº¿t láº­p má»™t máº­t kháº©u má»›i',0),(588907,16303,'vi','KhÃ¡ch hÃ ng hoáº·c cÃ´ng viá»‡c pháº£i Ä‘Æ°á»£c thiáº¿t láº­p',0),(588908,16304,'vi','KhÃ´ng phÃ¹ há»£p vá»›i khÃ¡ch hÃ ng',0),(588909,16305,'vi','Nháº­p thÃ´ng tin',0),(588910,16306,'vi','Nháº­p hÃ³a Ä‘Æ¡n khÃ¡ch hÃ ng vÃ  thay Ä‘á»•i cÃ´ng viá»‡c',0),(588911,16307,'vi','ThoÃ¡t ra khá»i chi phÃ­ mÃ£',0),(588912,16308,'vi','ThoÃ¡t ra khá»i theo thá»ƒ loáº¡i GL',0),(588913,16309,'vi','Táº¡o ra cÃ¡c má»¥c láº·p láº¡i',0),(588914,16310,'vi','Má»™t cÃ´ng viá»‡c vá»›i mÃ£ nÃ y Ä‘Ã£ tá»“n táº¡i',0),(588915,16311,'vi','Nhiá»u má»¥c cÃ³ thá»ƒ Ä‘Æ°á»£c tÃ¡ch báº±ng dáº¥u pháº©y',0),(588916,16312,'vi','YÃªu cáº§u vÃ  pháº£i lÃ  duy nháº¥t',0),(588917,16313,'vi','Nháº­p hÃ³a Ä‘Æ¡n thay Ä‘á»•i',0),(588918,16314,'vi','Báº¥t ká»³ giÃ¡ trá»‹',0),(588919,16315,'vi','Sai',0),(588920,16316,'vi','TÃªn Ä‘áº§u tiÃªn & cuá»‘i',0),(588921,16317,'vi','Sá»‘ lÆ°á»£ng dá»± kiáº¿n',0),(588922,16318,'vi','Hiá»ƒn thá»‹ nhiá»u hÆ¡n',0),(588923,16319,'vi','Danh sÃ¡ch hiá»ƒn thá»‹ tráº¡ng thÃ¡i',0),(588924,16320,'vi','Sá»± tháº­t',0),(588925,16321,'vi','Báº¡n pháº£i chá»n má»™t GL tÃ i khoáº£n hoáº·c chi phÃ­ mÃ£ hoáº·c GL thá»ƒ loáº¡i',0),(588926,16322,'vi','Gá»­i Email thÃ´ng bÃ¡o khi hÃ³a Ä‘Æ¡n cháº¥p thuáº­n',0),(588927,16323,'vi','NgÃ y tráº£',0),(588928,16324,'vi','NhÃ  bÃ¡n hÃ³a Ä‘Æ¡n Ä‘Ã£ Ä‘Æ°á»£c cháº¥p thuáº­n thanh toÃ¡n',0),(588929,16325,'vi','PO biÃªn lai trÃªn hÃ³a Ä‘Æ¡n nÃ y',0),(588930,16326,'vi','Thanh toÃ¡n mÃ£ bÆ°u Ä‘iá»‡n, náº¿u khÃ´ng cÃ³ tÃ u',0),(588931,16327,'vi','TÃ u Ä‘áº¿n mÃ£ bÆ°u chÃ­nh',0),(588932,16328,'vi','TÃ u Hiá»ƒn thá»‹ mÃ£ bÆ°u chÃ­nh',0),(588933,16329,'vi','Sáº¯p xáº¿p theo sá»‘ zip',0),(588934,16330,'vi','KhÃ´ng cÃ³ giÃ¡ trá»‹ Ä‘Æ°á»£c chá»n',0),(588935,16331,'vi','AP Ä‘Ã³ng cá»­a',0),(588936,16332,'vi','AR Ä‘Ã³ng cá»­a',0),(588937,16333,'vi','GL trá»±c tiáº¿p Ä‘Ã³ng cá»­a',0),(588938,16334,'vi','HÃ ng tá»“n kho Ä‘Ã³ng cá»­a',0),(588939,16335,'vi','Má»™t pháº§n Ä‘Ã³ng cá»­a',0),(588940,16336,'vi','LÆ°Æ¡ng Ä‘Ã³ng cá»­a',0),(588941,16337,'vi','Táº¡o ra bÃ¢y giá»',0),(588942,16338,'vi','ÄÆ°á»£c táº¡o ra thÃ nh cÃ´ng',0),(588943,16339,'vi','Táº¡o má»¥c ngÆ°á»£c',0),(588944,16340,'vi','NgÃ y cuá»‘i cÃ¹ng Ä‘Æ°á»£c táº¡o ra',0),(588945,16341,'vi','NgÃ y giao dá»‹ch cuá»‘i cÃ¹ng',0),(588946,16342,'vi','Cháº·n cÃ¡c mÃ´-Ä‘un',0),(588947,16343,'vi','KhÃ´ng thá»ƒ Unpost chá»©ng tá»«',0),(588948,16344,'vi','Chá»©ng tá»« Unposted OK',0),(588949,16345,'vi','Pháº£i cÃ³ má»™t Vendor ID hoáº·c nhÃ  cung cáº¥p mÃ£ hoáº·c tÃªn nhÃ  cung cáº¥p',0),(588950,16346,'vi','Pháº£i cÃ³ hoÃ¡ Ä‘Æ¡n sá»‘ Vendor ID hoáº·c mÃ£ sá»‘ nhÃ  cung cáº¥p hoáº·c nhÃ  cung cáº¥p tÃªn vÃ  sá»‘ tiá»n vÃ  sá»‘ tÃ i khoáº£n há»£p lá»‡',0),(588951,16347,'vi','Cáº§n cÃ³ má»™t mÃ£ sá»‘',0),(588952,16348,'vi','ThÃªm chi tiáº¿t trong cÃ¹ng má»™t hoÃ¡ Ä‘Æ¡n chá»‰ cáº§n ID khÃ¡ch hÃ ng hoáº·c mÃ£ khÃ¡ch hÃ ng hoáº·c tÃªn cÃ´ng ty hoáº·c Ä‘áº§u tiÃªn vÃ  cuá»‘i cÃ¹ng tÃªn vÃ  sá»‘ hÃ³a Ä‘Æ¡n',0),(588953,16349,'vi','Pháº£i cÃ³ má»™t ID khÃ¡ch hÃ ng hoáº·c mÃ£ khÃ¡ch hÃ ng hoáº·c tÃªn cÃ´ng ty hoáº·c Ä‘áº§u tiÃªn vÃ  tÃªn cuá»‘i cÃ¹ng',0),(588954,16350,'vi','Pháº£i cÃ³ hÃ³a Ä‘Æ¡n vÃ  ID khÃ¡ch hÃ ng hoáº·c mÃ£ khÃ¡ch hÃ ng hoáº·c tÃªn cÃ´ng ty hoáº·c Ä‘áº§u tiÃªn vÃ  tÃªn cuá»‘i cÃ¹ng',0),(588955,16351,'vi','Má»™t cÃ´ng viá»‡c vá»›i tÃªn nÃ y Ä‘Ã£ tá»“n táº¡i',0),(588956,16352,'vi','Má»™t cÃ´ng viá»‡c cho cÃ¡c khÃ¡ch hÃ ng nÃ y Ä‘Ã£ tá»“n táº¡i',0),(588957,16353,'vi','LÃ m viá»‡c cho má»™t sá»‘ dá»± Ã¡n nÃ y Ä‘Ã£ tá»“n táº¡i',0),(588958,16354,'vi','Má»™t cÃ´ng viá»‡c vá»›i Ä‘á»‹a chá»‰ nÃ y Ä‘Ã£ tá»“n táº¡i',0),(588959,16355,'vi','Viá»‡c Ä‘Ã³ng cá»­a ngÃ y',0),(588960,16356,'vi','Lattitude',0),(588961,16357,'vi','Kinh Ä‘á»™',0),(588962,16358,'vi','Prelimable ngÃ y',0),(588963,16359,'vi','Táº¡o ra cÃ¡c má»¥c sá»• káº¿ toÃ¡n Ä‘á»‹nh ká»³',0),(588964,16360,'vi','TrÃªn PHP Max Input Vars',0),(588965,16361,'vi','Vui lÃ²ng nháº­p má»™t giÃ¡ trá»‹ cho',0),(588966,16362,'vi','TÃ u Hiá»ƒn thá»‹ mÃ£ bÆ°u chÃ­nh',0),(588967,16363,'vi','Má»™t cÃ´ng viá»‡c cho cÃ¡c khÃ¡ch hÃ ng nÃ y Ä‘Ã£ tá»“n táº¡i',0),(588968,16364,'vi','Má»™t cÃ´ng viá»‡c vá»›i Ä‘á»‹a chá»‰ nÃ y Ä‘Ã£ tá»“n táº¡i',0),(588969,16365,'vi','Má»™t cÃ´ng viá»‡c vá»›i mÃ£ nÃ y Ä‘Ã£ tá»“n táº¡i',0),(588970,16366,'vi','Má»™t cÃ´ng viá»‡c vá»›i tÃªn nÃ y Ä‘Ã£ tá»“n táº¡i',0),(588971,16298,'fa','Ù‡ÛŒÚ† Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…ÙˆØ¬ÙˆØ¯',0),(588972,16299,'fa','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­ØµÙˆÙ„',0),(588973,16300,'fa','Ù…Ø­ØµÙˆÙ„ ÙˆØ±Ù‚',0),(588974,16301,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(588975,16302,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(588976,16303,'fa','Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø§Ø± Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ',0),(588977,16304,'fa','Ù…Ø´ØªØ±ÛŒ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(588978,16305,'fa','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(588979,16306,'fa','Ù…Ø´ØªØ±ÛŒ ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ØªØºÛŒÛŒØ± Ø´ØºÙ„',0),(588980,16307,'fa','ØªÙˆØ³Ø· Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø´Ú©Ø³ØªÙ†',0),(588981,16308,'fa','Ø´Ú©Ø³ØªÙ† Ø¯Ø³ØªÙ‡ GL',0),(588982,16309,'fa','ØªÙˆÙ„ÛŒØ¯ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(588983,16310,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(588984,16311,'fa','Ú†Ù†Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø§ Ú©Ø§Ù…Ø§ Ø§Ø² Ù‡Ù… Ø¬Ø¯Ø§',0),(588985,16312,'fa','Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ùˆ Ø¨Ø§ÛŒØ¯ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯',0),(588986,16313,'fa','ØªØºÛŒÛŒØ±Ø§Øª ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª',0),(588987,16314,'fa','Ù‡Ø± Ù…Ù‚Ø¯Ø§Ø±',0),(588988,16315,'fa','Ù†Ø§Ø¯Ø±Ø³Øª',0),(588989,16316,'fa','Ù†Ø§Ù… Ø§ÙˆÙ„ÛŒÙ† & Ú¯Ø°Ø´ØªÙ‡',0),(588990,16317,'fa','Ø§Ù†ØªØ¸Ø§Ø± Ù…ÛŒ Ø±ÙˆØ¯ ØªØ¹Ø¯Ø§Ø¯',0),(588991,16318,'fa','Ù†Ù…Ø§ÙŠØ´ Ø¨ÙŠØ´ØªØ±',0),(588992,16319,'fa','Ù„ÛŒØ³Øª ÙˆØ¶Ø¹ÛŒØª Ù†Ù…Ø§ÛŒØ´',0),(588993,16320,'fa','Ø¯Ø±Ø³Øª Ø§Ø³Øª',0),(588994,16321,'fa','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ GL Ø­Ø³Ø§Ø¨ ÛŒØ§ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ ÛŒØ§ Ø±Ø¯Ù‡ GL',0),(588995,16322,'fa','Ø§Ø±Ø³Ø§Ù„ Ø§Ø¹Ù„Ø§Ù…ÛŒÙ‡ Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„ ØªØ£ÛŒÛŒØ¯ Ù„Ø§ÛŒØ­Ù‡',0),(588996,16323,'fa','ØªØ§Ø±ÙŠØ®',0),(588997,16324,'fa','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(588998,16325,'fa','Ù¾Ùˆ Ø±Ø³ÛŒØ¯ Ø¯Ø± Ø§ÛŒÙ† Ù„Ø§ÛŒØ­Ù‡',0),(588999,16326,'fa','Ú©Ø¯ Ù¾Ø³ØªÛŒ Ø§Ú¯Ø± Ù‡ÛŒÚ† Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª',0),(589000,16327,'fa','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589001,16328,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589002,16329,'fa','Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù† Ø¨Ø± Ø§Ø³Ø§Ø³ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589003,16330,'fa','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(589004,16331,'fa','AP Ø¨Ø³ØªÙ‡',0),(589005,16332,'fa','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ø¨Ø³ØªÙ‡',0),(589006,16333,'fa','Ù…Ø³ØªÙ‚ÛŒÙ… GL Ø¨Ø³ØªÙ‡',0),(589007,16334,'fa','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø³ØªÙ‡',0),(589008,16335,'fa','Ø¨Ø³ØªÙ‡ ØªØ§ Ø­Ø¯ÛŒ',0),(589009,16336,'fa','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø³ØªÙ‡',0),(589010,16337,'fa','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØªÙˆÙ„ÛŒØ¯',0),(589011,16338,'fa','ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(589012,16339,'fa','Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…Ø¹Ú©ÙˆØ³',0),(589013,16340,'fa','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡',0),(589014,16341,'fa','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(589015,16342,'fa','Ù…Ø§Ú˜ÙˆÙ„ Ù‡Ø§ÛŒ Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯Ù‡',0),(589016,16343,'fa','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Unpost Ú©ÙˆÙ¾Ù†',0),(589017,16344,'fa','Ú©ÙˆÙ¾Ù† Unposted OK',0),(589018,16345,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…',0),(589019,16346,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø¨Ù„Øº Ùˆ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±',0),(589020,16347,'fa','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ú©Ø¯',0),(589021,16348,'fa','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(589022,16349,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589023,16350,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589024,16351,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589025,16352,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589026,16353,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589027,16354,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589028,16355,'fa','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ®',0),(589029,16356,'fa','Lattitude',0),(589030,16357,'fa','Ø·ÙˆÙ„ Ø¬ØºØ±Ø§ÙÛŒØ§ÛŒÛŒ',0),(589031,16358,'fa','ØªØ§Ø±ÛŒØ® prelimable',0),(589032,16359,'fa','ØªÙˆÙ„ÛŒØ¯ ØªÚ©Ø±Ø§Ø±ÛŒ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(589033,16360,'fa','Ø¨ÛŒØ´ Ø§Ø² PHP Ø­Ø¯Ø§Ú©Ø«Ø± ÙˆØ±ÙˆØ¯ÛŒ Vars',0),(589034,16361,'fa','Ù„Ø·ÙØ§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÛŒ',0),(589035,16362,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589036,16363,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589037,16364,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589038,16365,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589039,16366,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589040,16298,'id','Tidak ada pernyataan yang tersedia',0),(589041,16299,'id','Info Produk',0),(589042,16300,'id','Produk Sheet',0),(589043,16301,'id','Password tidak valid',0),(589044,16302,'id','Menetapkan kata sandi baru',0),(589045,16303,'id','Pelanggan atau pekerjaan harus ditetapkan',0),(589046,16304,'id','Tidak cocok pelanggan',0),(589047,16305,'id','Mengimpor informasi',0),(589048,16306,'id','Impor faktur pelanggan dan perubahan pekerjaan',0),(589049,16307,'id','Keluar oleh biaya kode',0),(589050,16308,'id','Keluar GL Kategori',0),(589051,16309,'id','Menghasilkan berulang entri',0),(589052,16310,'id','Pekerjaan dengan kode ini sudah ada',0),(589053,16311,'id','Beberapa entri dapat dipisahkan dengan koma',0),(589054,16312,'id','Diperlukan dan harus unik',0),(589055,16313,'id','Impor faktur perubahan',0),(589056,16314,'id','Nilai apapun',0),(589057,16315,'id','Palsu',0),(589058,16316,'id','Nama pertama & terakhir',0),(589059,16317,'id','Jumlah yang diharapkan',0),(589060,16318,'id','Selengkapnya',0),(589061,16319,'id','Daftar negara Tampilkan',0),(589062,16320,'id','Benar',0),(589063,16321,'id','Anda harus memilih akun GL atau biaya kode atau kategori GL',0),(589064,16322,'id','Mengirim Email pemberitahuan ketika Bill disetujui',0),(589065,16323,'id','Membayar tanggal',0),(589066,16324,'id','Penjual tagihan telah disetujui untuk pembayaran',0),(589067,16325,'id','PO penerimaan pada RUU ini',0),(589068,16326,'id','Penagihan kode pos jika ada kapal untuk',0),(589069,16327,'id','Kapal ke kode pos',0),(589070,16328,'id','Tampilkan kapal untuk kode pos',0),(589071,16329,'id','Urutkan kode pos',0),(589072,16330,'id','Tidak ada nilai yang dipilih',0),(589073,16331,'id','AP ditutup',0),(589074,16332,'id','AR ditutup',0),(589075,16333,'id','Langsung GL ditutup',0),(589076,16334,'id','Persediaan ditutup',0),(589077,16335,'id','Sebagian ditutup',0),(589078,16336,'id','Penggajian ditutup',0),(589079,16337,'id','Menghasilkan sekarang',0),(589080,16338,'id','Dihasilkan berhasil',0),(589081,16339,'id','Menghasilkan Reverse entri',0),(589082,16340,'id','Tanggal terakhir yang dihasilkan',0),(589083,16341,'id','Tanggal transaksi terakhir',0),(589084,16342,'id','Modul-modul yang diblokir',0),(589085,16343,'id','Mampu Unpost voucher',0),(589086,16344,'id','Voucher Unposted OK',0),(589087,16345,'id','Harus memiliki Vendor ID atau Vendor kode atau nama Penjual',0),(589088,16346,'id','Harus memiliki nomor Invoice dan Vendor ID atau Vendor kode atau nama Penjual dan jumlah dan nomor rekening berlaku',0),(589089,16347,'id','Perlu kode',0),(589090,16348,'id','Item baris tambahan di faktur sama hanya perlu ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir dan nomor faktur',0),(589091,16349,'id','Harus memiliki ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir',0),(589092,16350,'id','Harus memiliki nomor Invoice dan ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir',0),(589093,16351,'id','Pekerjaan dengan nama ini sudah ada',0),(589094,16352,'id','Pekerjaan untuk pelanggan ini sudah ada',0),(589095,16353,'id','Pekerjaan dengan jumlah proyek ini sudah ada',0),(589096,16354,'id','Pekerjaan dengan alamat ini sudah ada',0),(589097,16355,'id','Pekerjaan ditutup tanggal',0),(589098,16356,'id','Tipe Latitude',0),(589099,16357,'id','Bujur',0),(589100,16358,'id','Tanggal prelimable',0),(589101,16359,'id','Menghasilkan berulang entri buku besar',0),(589102,16360,'id','Lebih dari PHP Max Input Vars',0),(589103,16361,'id','Masukkan nilai untuk',0),(589104,16362,'id','Tampilkan kapal untuk kode pos',0),(589105,16363,'id','Pekerjaan untuk pelanggan ini sudah ada',0),(589106,16364,'id','Pekerjaan dengan alamat ini sudah ada',0),(589107,16365,'id','Pekerjaan dengan kode ini sudah ada',0),(589108,16366,'id','Pekerjaan dengan nama ini sudah ada',0),(589178,16298,'fa','Ù‡ÛŒÚ† Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…ÙˆØ¬ÙˆØ¯',0),(589179,16299,'fa','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­ØµÙˆÙ„',0),(589180,16300,'fa','Ù…Ø­ØµÙˆÙ„ ÙˆØ±Ù‚',0),(589181,16301,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(589182,16302,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(589183,16303,'fa','Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø§Ø± Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ',0),(589184,16304,'fa','Ù…Ø´ØªØ±ÛŒ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(589185,16305,'fa','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(589186,16306,'fa','Ù…Ø´ØªØ±ÛŒ ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ØªØºÛŒÛŒØ± Ø´ØºÙ„',0),(589187,16307,'fa','ØªÙˆØ³Ø· Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø´Ú©Ø³ØªÙ†',0),(589188,16308,'fa','Ø´Ú©Ø³ØªÙ† Ø¯Ø³ØªÙ‡ GL',0),(589189,16309,'fa','ØªÙˆÙ„ÛŒØ¯ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(589190,16310,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589191,16311,'fa','Ú†Ù†Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø§ Ú©Ø§Ù…Ø§ Ø§Ø² Ù‡Ù… Ø¬Ø¯Ø§',0),(589192,16312,'fa','Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ùˆ Ø¨Ø§ÛŒØ¯ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯',0),(589193,16313,'fa','ØªØºÛŒÛŒØ±Ø§Øª ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª',0),(589194,16314,'fa','Ù‡Ø± Ù…Ù‚Ø¯Ø§Ø±',0),(589195,16315,'fa','Ù†Ø§Ø¯Ø±Ø³Øª',0),(589196,16316,'fa','Ù†Ø§Ù… Ø§ÙˆÙ„ÛŒÙ† & Ú¯Ø°Ø´ØªÙ‡',0),(589197,16317,'fa','Ø§Ù†ØªØ¸Ø§Ø± Ù…ÛŒ Ø±ÙˆØ¯ ØªØ¹Ø¯Ø§Ø¯',0),(589198,16318,'fa','Ù†Ù…Ø§ÙŠØ´ Ø¨ÙŠØ´ØªØ±',0),(589199,16319,'fa','Ù„ÛŒØ³Øª ÙˆØ¶Ø¹ÛŒØª Ù†Ù…Ø§ÛŒØ´',0),(589200,16320,'fa','Ø¯Ø±Ø³Øª Ø§Ø³Øª',0),(589201,16321,'fa','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ GL Ø­Ø³Ø§Ø¨ ÛŒØ§ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ ÛŒØ§ Ø±Ø¯Ù‡ GL',0),(589202,16322,'fa','Ø§Ø±Ø³Ø§Ù„ Ø§Ø¹Ù„Ø§Ù…ÛŒÙ‡ Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„ ØªØ£ÛŒÛŒØ¯ Ù„Ø§ÛŒØ­Ù‡',0),(589203,16323,'fa','ØªØ§Ø±ÙŠØ®',0),(589204,16324,'fa','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(589205,16325,'fa','Ù¾Ùˆ Ø±Ø³ÛŒØ¯ Ø¯Ø± Ø§ÛŒÙ† Ù„Ø§ÛŒØ­Ù‡',0),(589206,16326,'fa','Ú©Ø¯ Ù¾Ø³ØªÛŒ Ø§Ú¯Ø± Ù‡ÛŒÚ† Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª',0),(589207,16327,'fa','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589208,16328,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589209,16329,'fa','Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù† Ø¨Ø± Ø§Ø³Ø§Ø³ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589210,16330,'fa','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(589211,16331,'fa','AP Ø¨Ø³ØªÙ‡',0),(589212,16332,'fa','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ø¨Ø³ØªÙ‡',0),(589213,16333,'fa','Ù…Ø³ØªÙ‚ÛŒÙ… GL Ø¨Ø³ØªÙ‡',0),(589214,16334,'fa','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø³ØªÙ‡',0),(589215,16335,'fa','Ø¨Ø³ØªÙ‡ ØªØ§ Ø­Ø¯ÛŒ',0),(589216,16336,'fa','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø³ØªÙ‡',0),(589217,16337,'fa','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØªÙˆÙ„ÛŒØ¯',0),(589218,16338,'fa','ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(589219,16339,'fa','Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…Ø¹Ú©ÙˆØ³',0),(589220,16340,'fa','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡',0),(589221,16341,'fa','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(589222,16342,'fa','Ù…Ø§Ú˜ÙˆÙ„ Ù‡Ø§ÛŒ Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯Ù‡',0),(589223,16343,'fa','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Unpost Ú©ÙˆÙ¾Ù†',0),(589224,16344,'fa','Ú©ÙˆÙ¾Ù† Unposted OK',0),(589225,16345,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…',0),(589226,16346,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø¨Ù„Øº Ùˆ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±',0),(589227,16347,'fa','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ú©Ø¯',0),(589228,16348,'fa','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(589229,16349,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589230,16350,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589231,16351,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589232,16352,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589233,16353,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589234,16354,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589235,16355,'fa','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ®',0),(589236,16356,'fa','Lattitude',0),(589237,16357,'fa','Ø·ÙˆÙ„ Ø¬ØºØ±Ø§ÙÛŒØ§ÛŒÛŒ',0),(589238,16358,'fa','ØªØ§Ø±ÛŒØ® prelimable',0),(589239,16359,'fa','ØªÙˆÙ„ÛŒØ¯ ØªÚ©Ø±Ø§Ø±ÛŒ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(589240,16360,'fa','Ø¨ÛŒØ´ Ø§Ø² PHP Ø­Ø¯Ø§Ú©Ø«Ø± ÙˆØ±ÙˆØ¯ÛŒ Vars',0),(589241,16361,'fa','Ù„Ø·ÙØ§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÛŒ',0),(589242,16362,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589243,16363,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589244,16364,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589245,16365,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589246,16366,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589247,16298,'sl','Nobene izjave na voljo',0),(589248,16299,'sl','Produktu',0),(589249,16300,'sl','Product list',0),(589250,16301,'sl','Neveljavno geslo',0),(589251,16302,'sl','Nastavite novo geslo',0),(589252,16303,'sl','Stranko ali delo mora biti nastavljen',0),(589253,16304,'sl','Stranka se ne ujema',0),(589254,16305,'sl','Uvoziti podatke',0),(589255,16306,'sl','Uvoznega raÄuna stranke in menjavo delovnih mest',0),(589256,16307,'sl','Izbruhnejo stroÅ¡kovno koda',0),(589257,16308,'sl','Izbruhne po kategoriji GL',0),(589258,16309,'sl','Ustvarjanje ponavljajoÄe se postavke',0),(589259,16310,'sl','Delo s to kodo Å¾e obstaja',0),(589260,16311,'sl','VeÄkratni lahko loÄeni z vejicami',0),(589261,16312,'sl','Potrebno in mora biti enoliÄna',0),(589262,16313,'sl','Uvoznega raÄuna spremembe',0),(589263,16314,'sl','Matrika',0),(589264,16315,'sl','NapaÄne',0),(589265,16316,'sl','Prvi & zadnje ime',0),(589266,16317,'sl','Å tevila priÄakovanih',0),(589267,16318,'sl','PrikaÅ¾i veÄ',0),(589268,16319,'sl','PrikaÅ¾i stanje seznam',0),(589269,16320,'sl','Res',0),(589270,16321,'sl','Izbrati morate GL raÄun ali stroÅ¡kovno kodo ali GL Category',0),(589271,16322,'sl','PoÅ¡lji Email obvestila, ko Bill',0),(589272,16323,'sl','PlaÄati datum',0),(589273,16324,'sl','RaÄune dobavitelja so bili odobreni za plaÄilo',0),(589274,16325,'sl','Prejemki PO na ta raÄun',0),(589275,16326,'sl','ZaraÄunavanje poÅ¡tno Å¡tevilko, Äe nobena ladja, da',0),(589276,16327,'sl','Dostava â€“ poÅ¡tna Å¡tevilka',0),(589277,16328,'sl','PrikaÅ¾i ladji poÅ¡tna Å¡tevilka',0),(589278,16329,'sl','Razvrsti po Zip kodo',0),(589279,16330,'sl','Ni izbrana vrednost',0),(589280,16331,'sl','AP zaprta',0),(589281,16332,'sl','AR, zaprta',0),(589282,16333,'sl','Neposredno GL zaprta',0),(589283,16334,'sl','Zaloge, zaprta',0),(589284,16335,'sl','Delno zaprta',0),(589285,16336,'sl','IzplaÄane plaÄe, zaprta',0),(589286,16337,'sl','Zdaj ustvarjajo',0),(589287,16338,'sl','UspeÅ¡no ustvarjen',0),(589288,16339,'sl','Ustvarite stornirano postavko',0),(589289,16340,'sl','Zadnji datum nastanka',0),(589290,16341,'sl','Zadnji datum transakcije',0),(589291,16342,'sl','Blokirane modulov',0),(589292,16343,'sl','Mogli Unpost boni',0),(589293,16344,'sl','Bonov neknjiÅ¾enih OK',0),(589294,16345,'sl','Mora imeti ID prodajalca ali koda prodajalca ali ime dobavitelja',0),(589295,16346,'sl','Mora imeti Å¡tevilko raÄuna in ID prodajalca ali koda prodajalca ali ime dobavitelja in koliÄino in veljaven raÄun Å¡tevilka',0),(589296,16347,'sl','Mora biti Å¡ifro',0),(589297,16348,'sl','Dodatne vrstiÄne postavke v isti raÄun potrebujete ID stranke ali kupca ali ime podjetja ali prvi in priimek in Å¡tevilko raÄuna',0),(589298,16349,'sl','Mora imeti ID stranke ali kupca ali firma ali ime in priimek',0),(589299,16350,'sl','Mora imeti Å¡tevilko raÄuna in ID stranke ali kupca ali firma ali ime in priimek',0),(589300,16351,'sl','Delo s tem imenom Å¾e obstaja',0),(589301,16352,'sl','Delo za tega kupca Å¾e obstaja',0),(589302,16353,'sl','Delo s to Å¡tevilko projekta Å¾e obstaja',0),(589303,16354,'sl','Delo s tem naslovom Å¾e obstaja',0),(589304,16355,'sl','Job Datum zapiranja',0),(589305,16356,'sl','Lattitude',0),(589306,16357,'sl','DolÅ¾ine',0),(589307,16358,'sl','Prelimable datum',0),(589308,16359,'sl','Ustvarjanje ponavljajoÄe se postavke',0),(589309,16360,'sl','Nad PHP Max vloÅ¾ek Vars',0),(589310,16361,'sl','Vnesite vrednost za',0),(589311,16362,'sl','PrikaÅ¾i ladji poÅ¡tna Å¡tevilka',0),(589312,16363,'sl','Delo za tega kupca Å¾e obstaja',0),(589313,16364,'sl','Delo s tem naslovom Å¾e obstaja',0),(589314,16365,'sl','Delo s to kodo Å¾e obstaja',0),(589315,16366,'sl','Delo s tem imenom Å¾e obstaja',0),(589316,16298,'fa','Ù‡ÛŒÚ† Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…ÙˆØ¬ÙˆØ¯',0),(589317,16299,'fa','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­ØµÙˆÙ„',0),(589318,16300,'fa','Ù…Ø­ØµÙˆÙ„ ÙˆØ±Ù‚',0),(589319,16301,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(589320,16302,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(589321,16303,'fa','Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø§Ø± Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ',0),(589322,16304,'fa','Ù…Ø´ØªØ±ÛŒ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(589323,16305,'fa','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(589324,16306,'fa','Ù…Ø´ØªØ±ÛŒ ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ØªØºÛŒÛŒØ± Ø´ØºÙ„',0),(589325,16307,'fa','ØªÙˆØ³Ø· Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø´Ú©Ø³ØªÙ†',0),(589326,16308,'fa','Ø´Ú©Ø³ØªÙ† Ø¯Ø³ØªÙ‡ GL',0),(589327,16309,'fa','ØªÙˆÙ„ÛŒØ¯ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(589328,16310,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589329,16311,'fa','Ú†Ù†Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø§ Ú©Ø§Ù…Ø§ Ø§Ø² Ù‡Ù… Ø¬Ø¯Ø§',0),(589330,16312,'fa','Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ùˆ Ø¨Ø§ÛŒØ¯ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯',0),(589331,16313,'fa','ØªØºÛŒÛŒØ±Ø§Øª ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª',0),(589332,16314,'fa','Ù‡Ø± Ù…Ù‚Ø¯Ø§Ø±',0),(589333,16315,'fa','Ù†Ø§Ø¯Ø±Ø³Øª',0),(589334,16316,'fa','Ù†Ø§Ù… Ø§ÙˆÙ„ÛŒÙ† & Ú¯Ø°Ø´ØªÙ‡',0),(589335,16317,'fa','Ø§Ù†ØªØ¸Ø§Ø± Ù…ÛŒ Ø±ÙˆØ¯ ØªØ¹Ø¯Ø§Ø¯',0),(589336,16318,'fa','Ù†Ù…Ø§ÙŠØ´ Ø¨ÙŠØ´ØªØ±',0),(589337,16319,'fa','Ù„ÛŒØ³Øª ÙˆØ¶Ø¹ÛŒØª Ù†Ù…Ø§ÛŒØ´',0),(589338,16320,'fa','Ø¯Ø±Ø³Øª Ø§Ø³Øª',0),(589339,16321,'fa','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ GL Ø­Ø³Ø§Ø¨ ÛŒØ§ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ ÛŒØ§ Ø±Ø¯Ù‡ GL',0),(589340,16322,'fa','Ø§Ø±Ø³Ø§Ù„ Ø§Ø¹Ù„Ø§Ù…ÛŒÙ‡ Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„ ØªØ£ÛŒÛŒØ¯ Ù„Ø§ÛŒØ­Ù‡',0),(589341,16323,'fa','ØªØ§Ø±ÙŠØ®',0),(589342,16324,'fa','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(589343,16325,'fa','Ù¾Ùˆ Ø±Ø³ÛŒØ¯ Ø¯Ø± Ø§ÛŒÙ† Ù„Ø§ÛŒØ­Ù‡',0),(589344,16326,'fa','Ú©Ø¯ Ù¾Ø³ØªÛŒ Ø§Ú¯Ø± Ù‡ÛŒÚ† Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª',0),(589345,16327,'fa','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589346,16328,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589347,16329,'fa','Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù† Ø¨Ø± Ø§Ø³Ø§Ø³ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589348,16330,'fa','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(589349,16331,'fa','AP Ø¨Ø³ØªÙ‡',0),(589350,16332,'fa','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ø¨Ø³ØªÙ‡',0),(589351,16333,'fa','Ù…Ø³ØªÙ‚ÛŒÙ… GL Ø¨Ø³ØªÙ‡',0),(589352,16334,'fa','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø³ØªÙ‡',0),(589353,16335,'fa','Ø¨Ø³ØªÙ‡ ØªØ§ Ø­Ø¯ÛŒ',0),(589354,16336,'fa','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø³ØªÙ‡',0),(589355,16337,'fa','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØªÙˆÙ„ÛŒØ¯',0),(589356,16338,'fa','ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(589357,16339,'fa','Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…Ø¹Ú©ÙˆØ³',0),(589358,16340,'fa','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡',0),(589359,16341,'fa','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(589360,16342,'fa','Ù…Ø§Ú˜ÙˆÙ„ Ù‡Ø§ÛŒ Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯Ù‡',0),(589361,16343,'fa','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Unpost Ú©ÙˆÙ¾Ù†',0),(589362,16344,'fa','Ú©ÙˆÙ¾Ù† Unposted OK',0),(589363,16345,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…',0),(589364,16346,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø¨Ù„Øº Ùˆ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±',0),(589365,16347,'fa','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ú©Ø¯',0),(589366,16348,'fa','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(589367,16349,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589368,16350,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589369,16351,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589370,16352,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589371,16353,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589372,16354,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589373,16355,'fa','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ®',0),(589374,16356,'fa','Lattitude',0),(589375,16357,'fa','Ø·ÙˆÙ„ Ø¬ØºØ±Ø§ÙÛŒØ§ÛŒÛŒ',0),(589376,16358,'fa','ØªØ§Ø±ÛŒØ® prelimable',0),(589377,16359,'fa','ØªÙˆÙ„ÛŒØ¯ ØªÚ©Ø±Ø§Ø±ÛŒ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(589378,16360,'fa','Ø¨ÛŒØ´ Ø§Ø² PHP Ø­Ø¯Ø§Ú©Ø«Ø± ÙˆØ±ÙˆØ¯ÛŒ Vars',0),(589379,16361,'fa','Ù„Ø·ÙØ§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÛŒ',0),(589380,16362,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589381,16363,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589382,16364,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589383,16365,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589384,16366,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589385,16298,'id','Tidak ada pernyataan yang tersedia',0),(589386,16299,'id','Info Produk',0),(589387,16300,'id','Produk Sheet',0),(589388,16301,'id','Password tidak valid',0),(589389,16302,'id','Menetapkan kata sandi baru',0),(589390,16303,'id','Pelanggan atau pekerjaan harus ditetapkan',0),(589391,16304,'id','Tidak cocok pelanggan',0),(589392,16305,'id','Mengimpor informasi',0),(589393,16306,'id','Impor faktur pelanggan dan perubahan pekerjaan',0),(589394,16307,'id','Keluar oleh biaya kode',0),(589395,16308,'id','Keluar GL Kategori',0),(589396,16309,'id','Menghasilkan berulang entri',0),(589397,16310,'id','Pekerjaan dengan kode ini sudah ada',0),(589398,16311,'id','Beberapa entri dapat dipisahkan dengan koma',0),(589399,16312,'id','Diperlukan dan harus unik',0),(589400,16313,'id','Impor faktur perubahan',0),(589401,16314,'id','Nilai apapun',0),(589402,16315,'id','Palsu',0),(589403,16316,'id','Nama pertama & terakhir',0),(589404,16317,'id','Jumlah yang diharapkan',0),(589405,16318,'id','Selengkapnya',0),(589406,16319,'id','Daftar negara Tampilkan',0),(589407,16320,'id','Benar',0),(589408,16321,'id','Anda harus memilih akun GL atau biaya kode atau kategori GL',0),(589409,16322,'id','Mengirim Email pemberitahuan ketika Bill disetujui',0),(589410,16323,'id','Membayar tanggal',0),(589411,16324,'id','Penjual tagihan telah disetujui untuk pembayaran',0),(589412,16325,'id','PO penerimaan pada RUU ini',0),(589413,16326,'id','Penagihan kode pos jika ada kapal untuk',0),(589414,16327,'id','Kapal ke kode pos',0),(589415,16328,'id','Tampilkan kapal untuk kode pos',0),(589416,16329,'id','Urutkan kode pos',0),(589417,16330,'id','Tidak ada nilai yang dipilih',0),(589418,16331,'id','AP ditutup',0),(589419,16332,'id','AR ditutup',0),(589420,16333,'id','Langsung GL ditutup',0),(589421,16334,'id','Persediaan ditutup',0),(589422,16335,'id','Sebagian ditutup',0),(589423,16336,'id','Penggajian ditutup',0),(589424,16337,'id','Menghasilkan sekarang',0),(589425,16338,'id','Dihasilkan berhasil',0),(589426,16339,'id','Menghasilkan Reverse entri',0),(589427,16340,'id','Tanggal terakhir yang dihasilkan',0),(589428,16341,'id','Tanggal transaksi terakhir',0),(589429,16342,'id','Modul-modul yang diblokir',0),(589430,16343,'id','Mampu Unpost voucher',0),(589431,16344,'id','Voucher Unposted OK',0),(589432,16345,'id','Harus memiliki Vendor ID atau Vendor kode atau nama Penjual',0),(589433,16346,'id','Harus memiliki nomor Invoice dan Vendor ID atau Vendor kode atau nama Penjual dan jumlah dan nomor rekening berlaku',0),(589434,16347,'id','Perlu kode',0),(589435,16348,'id','Item baris tambahan di faktur sama hanya perlu ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir dan nomor faktur',0),(589436,16349,'id','Harus memiliki ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir',0),(589437,16350,'id','Harus memiliki nomor Invoice dan ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir',0),(589438,16351,'id','Pekerjaan dengan nama ini sudah ada',0),(589439,16352,'id','Pekerjaan untuk pelanggan ini sudah ada',0),(589440,16353,'id','Pekerjaan dengan jumlah proyek ini sudah ada',0),(589441,16354,'id','Pekerjaan dengan alamat ini sudah ada',0),(589442,16355,'id','Pekerjaan ditutup tanggal',0),(589443,16356,'id','Tipe Latitude',0),(589444,16357,'id','Bujur',0),(589445,16358,'id','Tanggal prelimable',0),(589446,16359,'id','Menghasilkan berulang entri buku besar',0),(589447,16360,'id','Lebih dari PHP Max Input Vars',0),(589448,16361,'id','Masukkan nilai untuk',0),(589449,16362,'id','Tampilkan kapal untuk kode pos',0),(589450,16363,'id','Pekerjaan untuk pelanggan ini sudah ada',0),(589451,16364,'id','Pekerjaan dengan alamat ini sudah ada',0),(589452,16365,'id','Pekerjaan dengan kode ini sudah ada',0),(589453,16366,'id','Pekerjaan dengan nama ini sudah ada',0),(589523,16298,'fa','Ù‡ÛŒÚ† Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…ÙˆØ¬ÙˆØ¯',0),(589524,16299,'fa','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­ØµÙˆÙ„',0),(589525,16300,'fa','Ù…Ø­ØµÙˆÙ„ ÙˆØ±Ù‚',0),(589526,16301,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(589527,16302,'fa','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(589528,16303,'fa','Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø§Ø± Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ',0),(589529,16304,'fa','Ù…Ø´ØªØ±ÛŒ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(589530,16305,'fa','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(589531,16306,'fa','Ù…Ø´ØªØ±ÛŒ ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ØªØºÛŒÛŒØ± Ø´ØºÙ„',0),(589532,16307,'fa','ØªÙˆØ³Ø· Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø´Ú©Ø³ØªÙ†',0),(589533,16308,'fa','Ø´Ú©Ø³ØªÙ† Ø¯Ø³ØªÙ‡ GL',0),(589534,16309,'fa','ØªÙˆÙ„ÛŒØ¯ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(589535,16310,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589536,16311,'fa','Ú†Ù†Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø§ Ú©Ø§Ù…Ø§ Ø§Ø² Ù‡Ù… Ø¬Ø¯Ø§',0),(589537,16312,'fa','Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ùˆ Ø¨Ø§ÛŒØ¯ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯',0),(589538,16313,'fa','ØªØºÛŒÛŒØ±Ø§Øª ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª',0),(589539,16314,'fa','Ù‡Ø± Ù…Ù‚Ø¯Ø§Ø±',0),(589540,16315,'fa','Ù†Ø§Ø¯Ø±Ø³Øª',0),(589541,16316,'fa','Ù†Ø§Ù… Ø§ÙˆÙ„ÛŒÙ† & Ú¯Ø°Ø´ØªÙ‡',0),(589542,16317,'fa','Ø§Ù†ØªØ¸Ø§Ø± Ù…ÛŒ Ø±ÙˆØ¯ ØªØ¹Ø¯Ø§Ø¯',0),(589543,16318,'fa','Ù†Ù…Ø§ÙŠØ´ Ø¨ÙŠØ´ØªØ±',0),(589544,16319,'fa','Ù„ÛŒØ³Øª ÙˆØ¶Ø¹ÛŒØª Ù†Ù…Ø§ÛŒØ´',0),(589545,16320,'fa','Ø¯Ø±Ø³Øª Ø§Ø³Øª',0),(589546,16321,'fa','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ GL Ø­Ø³Ø§Ø¨ ÛŒØ§ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ ÛŒØ§ Ø±Ø¯Ù‡ GL',0),(589547,16322,'fa','Ø§Ø±Ø³Ø§Ù„ Ø§Ø¹Ù„Ø§Ù…ÛŒÙ‡ Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„ ØªØ£ÛŒÛŒØ¯ Ù„Ø§ÛŒØ­Ù‡',0),(589548,16323,'fa','ØªØ§Ø±ÙŠØ®',0),(589549,16324,'fa','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(589550,16325,'fa','Ù¾Ùˆ Ø±Ø³ÛŒØ¯ Ø¯Ø± Ø§ÛŒÙ† Ù„Ø§ÛŒØ­Ù‡',0),(589551,16326,'fa','Ú©Ø¯ Ù¾Ø³ØªÛŒ Ø§Ú¯Ø± Ù‡ÛŒÚ† Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª',0),(589552,16327,'fa','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589553,16328,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589554,16329,'fa','Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù† Ø¨Ø± Ø§Ø³Ø§Ø³ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589555,16330,'fa','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(589556,16331,'fa','AP Ø¨Ø³ØªÙ‡',0),(589557,16332,'fa','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ø¨Ø³ØªÙ‡',0),(589558,16333,'fa','Ù…Ø³ØªÙ‚ÛŒÙ… GL Ø¨Ø³ØªÙ‡',0),(589559,16334,'fa','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø³ØªÙ‡',0),(589560,16335,'fa','Ø¨Ø³ØªÙ‡ ØªØ§ Ø­Ø¯ÛŒ',0),(589561,16336,'fa','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø³ØªÙ‡',0),(589562,16337,'fa','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØªÙˆÙ„ÛŒØ¯',0),(589563,16338,'fa','ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(589564,16339,'fa','Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…Ø¹Ú©ÙˆØ³',0),(589565,16340,'fa','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡',0),(589566,16341,'fa','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(589567,16342,'fa','Ù…Ø§Ú˜ÙˆÙ„ Ù‡Ø§ÛŒ Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯Ù‡',0),(589568,16343,'fa','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Unpost Ú©ÙˆÙ¾Ù†',0),(589569,16344,'fa','Ú©ÙˆÙ¾Ù† Unposted OK',0),(589570,16345,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…',0),(589571,16346,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø¨Ù„Øº Ùˆ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±',0),(589572,16347,'fa','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ú©Ø¯',0),(589573,16348,'fa','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(589574,16349,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589575,16350,'fa','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589576,16351,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589577,16352,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589578,16353,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589579,16354,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589580,16355,'fa','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ®',0),(589581,16356,'fa','Lattitude',0),(589582,16357,'fa','Ø·ÙˆÙ„ Ø¬ØºØ±Ø§ÙÛŒØ§ÛŒÛŒ',0),(589583,16358,'fa','ØªØ§Ø±ÛŒØ® prelimable',0),(589584,16359,'fa','ØªÙˆÙ„ÛŒØ¯ ØªÚ©Ø±Ø§Ø±ÛŒ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(589585,16360,'fa','Ø¨ÛŒØ´ Ø§Ø² PHP Ø­Ø¯Ø§Ú©Ø«Ø± ÙˆØ±ÙˆØ¯ÛŒ Vars',0),(589586,16361,'fa','Ù„Ø·ÙØ§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÛŒ',0),(589587,16362,'fa','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589588,16363,'fa','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589589,16364,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589590,16365,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589591,16366,'fa','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589592,16298,'sl','Nobene izjave na voljo',0),(589593,16299,'sl','Produktu',0),(589594,16300,'sl','Product list',0),(589595,16301,'sl','Neveljavno geslo',0),(589596,16302,'sl','Nastavite novo geslo',0),(589597,16303,'sl','Stranko ali delo mora biti nastavljen',0),(589598,16304,'sl','Stranka se ne ujema',0),(589599,16305,'sl','Uvoziti podatke',0),(589600,16306,'sl','Uvoznega raÄuna stranke in menjavo delovnih mest',0),(589601,16307,'sl','Izbruhnejo stroÅ¡kovno koda',0),(589602,16308,'sl','Izbruhne po kategoriji GL',0),(589603,16309,'sl','Ustvarjanje ponavljajoÄe se postavke',0),(589604,16310,'sl','Delo s to kodo Å¾e obstaja',0),(589605,16311,'sl','VeÄkratni lahko loÄeni z vejicami',0),(589606,16312,'sl','Potrebno in mora biti enoliÄna',0),(589607,16313,'sl','Uvoznega raÄuna spremembe',0),(589608,16314,'sl','Matrika',0),(589609,16315,'sl','NapaÄne',0),(589610,16316,'sl','Prvi & zadnje ime',0),(589611,16317,'sl','Å tevila priÄakovanih',0),(589612,16318,'sl','PrikaÅ¾i veÄ',0),(589613,16319,'sl','PrikaÅ¾i stanje seznam',0),(589614,16320,'sl','Res',0),(589615,16321,'sl','Izbrati morate GL raÄun ali stroÅ¡kovno kodo ali GL Category',0),(589616,16322,'sl','PoÅ¡lji Email obvestila, ko Bill',0),(589617,16323,'sl','PlaÄati datum',0),(589618,16324,'sl','RaÄune dobavitelja so bili odobreni za plaÄilo',0),(589619,16325,'sl','Prejemki PO na ta raÄun',0),(589620,16326,'sl','ZaraÄunavanje poÅ¡tno Å¡tevilko, Äe nobena ladja, da',0),(589621,16327,'sl','Dostava â€“ poÅ¡tna Å¡tevilka',0),(589622,16328,'sl','PrikaÅ¾i ladji poÅ¡tna Å¡tevilka',0),(589623,16329,'sl','Razvrsti po Zip kodo',0),(589624,16330,'sl','Ni izbrana vrednost',0),(589625,16331,'sl','AP zaprta',0),(589626,16332,'sl','AR, zaprta',0),(589627,16333,'sl','Neposredno GL zaprta',0),(589628,16334,'sl','Zaloge, zaprta',0),(589629,16335,'sl','Delno zaprta',0),(589630,16336,'sl','IzplaÄane plaÄe, zaprta',0),(589631,16337,'sl','Zdaj ustvarjajo',0),(589632,16338,'sl','UspeÅ¡no ustvarjen',0),(589633,16339,'sl','Ustvarite stornirano postavko',0),(589634,16340,'sl','Zadnji datum nastanka',0),(589635,16341,'sl','Zadnji datum transakcije',0),(589636,16342,'sl','Blokirane modulov',0),(589637,16343,'sl','Mogli Unpost boni',0),(589638,16344,'sl','Bonov neknjiÅ¾enih OK',0),(589639,16345,'sl','Mora imeti ID prodajalca ali koda prodajalca ali ime dobavitelja',0),(589640,16346,'sl','Mora imeti Å¡tevilko raÄuna in ID prodajalca ali koda prodajalca ali ime dobavitelja in koliÄino in veljaven raÄun Å¡tevilka',0),(589641,16347,'sl','Mora biti Å¡ifro',0),(589642,16348,'sl','Dodatne vrstiÄne postavke v isti raÄun potrebujete ID stranke ali kupca ali ime podjetja ali prvi in priimek in Å¡tevilko raÄuna',0),(589643,16349,'sl','Mora imeti ID stranke ali kupca ali firma ali ime in priimek',0),(589644,16350,'sl','Mora imeti Å¡tevilko raÄuna in ID stranke ali kupca ali firma ali ime in priimek',0),(589645,16351,'sl','Delo s tem imenom Å¾e obstaja',0),(589646,16352,'sl','Delo za tega kupca Å¾e obstaja',0),(589647,16353,'sl','Delo s to Å¡tevilko projekta Å¾e obstaja',0),(589648,16354,'sl','Delo s tem naslovom Å¾e obstaja',0),(589649,16355,'sl','Job Datum zapiranja',0),(589650,16356,'sl','Lattitude',0),(589651,16357,'sl','DolÅ¾ine',0),(589652,16358,'sl','Prelimable datum',0),(589653,16359,'sl','Ustvarjanje ponavljajoÄe se postavke',0),(589654,16360,'sl','Nad PHP Max vloÅ¾ek Vars',0),(589655,16361,'sl','Vnesite vrednost za',0),(589656,16362,'sl','PrikaÅ¾i ladji poÅ¡tna Å¡tevilka',0),(589657,16363,'sl','Delo za tega kupca Å¾e obstaja',0),(589658,16364,'sl','Delo s tem naslovom Å¾e obstaja',0),(589659,16365,'sl','Delo s to kodo Å¾e obstaja',0),(589660,16366,'sl','Delo s tem imenom Å¾e obstaja',0),(589661,16298,'af','Geen verklaring beskikbaar',0),(589662,16299,'af','Produk inligting',0),(589663,16300,'af','Produk vel',0),(589664,16301,'af','Ongeldige wagwoord',0),(589665,16302,'af','Stel \'n nuwe wagwoord',0),(589666,16303,'af','KliÃ«nt of werk moet gestel word',0),(589667,16304,'af','KliÃ«nt ooreen nie',0),(589668,16305,'af','Invoer van inligting',0),(589669,16306,'af','Invoer faktuur kliÃ«nt en werk veranderinge',0),(589670,16307,'af','Breek deur koste kode',0),(589671,16308,'af','Breek deur GL kategorie',0),(589672,16309,'af','Herhalende inskrywings genereer',0),(589673,16310,'af','\'N taak met hierdie kode bestaan reeds',0),(589674,16311,'af','Verskeie inskrywings met kommas geskei kan word',0),(589675,16312,'af','Vereis en moet uniek wees',0),(589676,16313,'af','Invoer faktuur veranderinge',0),(589677,16314,'af','Enige waarde',0),(589678,16315,'af','Valse',0),(589679,16316,'af','Eerste en laaste naam',0),(589680,16317,'af','Nommer verwag',0),(589681,16318,'af','Wys meer',0),(589682,16319,'af','Wys staat lys',0),(589683,16320,'af','Ware',0),(589684,16321,'af','Jy moet \'n GL rekening of koste kode of GL kategorie kies',0),(589685,16322,'af','Stuur e-pos kennisgewings wanneer Wetsontwerp goedgekeur',0),(589686,16323,'af','Datum te betaal',0),(589687,16324,'af','Handelaar Wetsontwerpe goedgekeur het vir betaling',0),(589688,16325,'af','Posbus kwitansies op hierdie Wetsontwerp',0),(589689,16326,'af','Fakturering poskode Indien geen skip te',0),(589690,16327,'af','Skip na poskode',0),(589691,16328,'af','Skip na poskode wys',0),(589692,16329,'af','Rangskik volgens poskode',0),(589693,16330,'af','Geen waarde gekies',0),(589694,16331,'af','GP gesluit',0),(589695,16332,'af','AR gesluit',0),(589696,16333,'af','Direkte GL gesluit',0),(589697,16334,'af','Inventaris gesluit',0),(589698,16335,'af','Gedeeltelik gesluit',0),(589699,16336,'af','Salarisstelsel gesluit',0),(589700,16337,'af','Genereer nou',0),(589701,16338,'af','Suksesvol gegenereer',0),(589702,16339,'af','Genereer omgekeerde inskrywing',0),(589703,16340,'af','Laaste datum gegenereer',0),(589704,16341,'af','Laaste datum van die transaksie',0),(589705,16342,'af','Geblokkeerde Modules',0),(589706,16343,'af','Nie Unpost bewyse',0),(589707,16344,'af','Bewyse Unposted OK',0),(589708,16345,'af','Moet \'n handelaar ID of handelaar kode of handelaar naam het',0),(589709,16346,'af','Faktuur nommer en handelaar ID of handelaar kode of handelaar naam en bedrag en geldige rekeningnommer moet hÃª',0),(589710,16347,'af','Moet \'n kode',0),(589711,16348,'af','Bykomende lyn Items In die dieselfde faktuur moet slegs die kliÃ«nt-ID of kliÃ«nt kode of maatskappynaam of eerste en laaste naam en die faktuur nommer',0),(589712,16349,'af','\'N kliÃ«nt-ID of kliÃ«nt kode of maatskappynaam of eerste en laaste naam moet hÃª',0),(589713,16350,'af','Faktuur nommer en kliÃ«nt-ID of kliÃ«nt kode of maatskappynaam of eerste en laaste naam moet hÃª',0),(589714,16351,'af','\'N taak met hierdie naam bestaan reeds',0),(589715,16352,'af','\'N taak vir hierdie kliÃ«nt bestaan reeds',0),(589716,16353,'af','\'N taak met hierdie projek nommer bestaan reeds',0),(589717,16354,'af','\'N taak met hierdie adres bestaan reeds',0),(589718,16355,'af','Werk gesluit datum',0),(589719,16356,'af','Lattitude',0),(589720,16357,'af','Longitude',0),(589721,16358,'af','Prelimable datum',0),(589722,16359,'af','Herhalende grootboek inskrywings genereer',0),(589723,16360,'af','Oor PHP Max Vars insette',0),(589724,16361,'af','Tik asseblief \'n waarde vir',0),(589725,16362,'af','Skip na poskode wys',0),(589726,16363,'af','\'N taak vir hierdie kliÃ«nt bestaan reeds',0),(589727,16364,'af','\'N taak met hierdie adres bestaan reeds',0),(589728,16365,'af','\'N taak met hierdie kode bestaan reeds',0),(589729,16366,'af','\'N taak met hierdie naam bestaan reeds',0),(589731,16298,'dr','Ù‡ÛŒÚ† Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…ÙˆØ¬ÙˆØ¯',0),(589732,16299,'dr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­ØµÙˆÙ„',0),(589733,16300,'dr','Ù…Ø­ØµÙˆÙ„ ÙˆØ±Ù‚',0),(589734,16301,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(589735,16302,'dr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(589736,16303,'dr','Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø§Ø± Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ',0),(589737,16304,'dr','Ù…Ø´ØªØ±ÛŒ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(589738,16305,'dr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(589739,16306,'dr','Ù…Ø´ØªØ±ÛŒ ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ØªØºÛŒÛŒØ± Ø´ØºÙ„',0),(589740,16307,'dr','ØªÙˆØ³Ø· Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø´Ú©Ø³ØªÙ†',0),(589741,16308,'dr','Ø´Ú©Ø³ØªÙ† Ø¯Ø³ØªÙ‡ GL',0),(589742,16309,'dr','ØªÙˆÙ„ÛŒØ¯ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(589743,16310,'dr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589744,16311,'dr','Ú†Ù†Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø§ Ú©Ø§Ù…Ø§ Ø§Ø² Ù‡Ù… Ø¬Ø¯Ø§',0),(589745,16312,'dr','Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ùˆ Ø¨Ø§ÛŒØ¯ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯',0),(589746,16313,'dr','ØªØºÛŒÛŒØ±Ø§Øª ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª',0),(589747,16314,'dr','Ù‡Ø± Ù…Ù‚Ø¯Ø§Ø±',0),(589748,16315,'dr','Ù†Ø§Ø¯Ø±Ø³Øª',0),(589749,16316,'dr','Ù†Ø§Ù… Ø§ÙˆÙ„ÛŒÙ† & Ú¯Ø°Ø´ØªÙ‡',0),(589750,16317,'dr','Ø§Ù†ØªØ¸Ø§Ø± Ù…ÛŒ Ø±ÙˆØ¯ ØªØ¹Ø¯Ø§Ø¯',0),(589751,16318,'dr','Ù†Ù…Ø§ÙŠØ´ Ø¨ÙŠØ´ØªØ±',0),(589752,16319,'dr','Ù„ÛŒØ³Øª ÙˆØ¶Ø¹ÛŒØª Ù†Ù…Ø§ÛŒØ´',0),(589753,16320,'dr','Ø¯Ø±Ø³Øª Ø§Ø³Øª',0),(589754,16321,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ GL Ø­Ø³Ø§Ø¨ ÛŒØ§ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ ÛŒØ§ Ø±Ø¯Ù‡ GL',0),(589755,16322,'dr','Ø§Ø±Ø³Ø§Ù„ Ø§Ø¹Ù„Ø§Ù…ÛŒÙ‡ Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„ ØªØ£ÛŒÛŒØ¯ Ù„Ø§ÛŒØ­Ù‡',0),(589756,16323,'dr','ØªØ§Ø±ÙŠØ®',0),(589757,16324,'dr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(589758,16325,'dr','Ù¾Ùˆ Ø±Ø³ÛŒØ¯ Ø¯Ø± Ø§ÛŒÙ† Ù„Ø§ÛŒØ­Ù‡',0),(589759,16326,'dr','Ú©Ø¯ Ù¾Ø³ØªÛŒ Ø§Ú¯Ø± Ù‡ÛŒÚ† Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª',0),(589760,16327,'dr','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589761,16328,'dr','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589762,16329,'dr','Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù† Ø¨Ø± Ø§Ø³Ø§Ø³ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589763,16330,'dr','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(589764,16331,'dr','AP Ø¨Ø³ØªÙ‡',0),(589765,16332,'dr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ø¨Ø³ØªÙ‡',0),(589766,16333,'dr','Ù…Ø³ØªÙ‚ÛŒÙ… GL Ø¨Ø³ØªÙ‡',0),(589767,16334,'dr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø³ØªÙ‡',0),(589768,16335,'dr','Ø¨Ø³ØªÙ‡ ØªØ§ Ø­Ø¯ÛŒ',0),(589769,16336,'dr','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø³ØªÙ‡',0),(589770,16337,'dr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØªÙˆÙ„ÛŒØ¯',0),(589771,16338,'dr','ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(589772,16339,'dr','Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…Ø¹Ú©ÙˆØ³',0),(589773,16340,'dr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡',0),(589774,16341,'dr','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(589775,16342,'dr','Ù…Ø§Ú˜ÙˆÙ„ Ù‡Ø§ÛŒ Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯Ù‡',0),(589776,16343,'dr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Unpost Ú©ÙˆÙ¾Ù†',0),(589777,16344,'dr','Ú©ÙˆÙ¾Ù† Unposted OK',0),(589778,16345,'dr','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…',0),(589779,16346,'dr','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø¨Ù„Øº Ùˆ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±',0),(589780,16347,'dr','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ú©Ø¯',0),(589781,16348,'dr','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(589782,16349,'dr','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589783,16350,'dr','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589784,16351,'dr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589785,16352,'dr','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589786,16353,'dr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589787,16354,'dr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589788,16355,'dr','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ®',0),(589789,16356,'dr','Lattitude',0),(589790,16357,'dr','Ø·ÙˆÙ„ Ø¬ØºØ±Ø§ÙÛŒØ§ÛŒÛŒ',0),(589791,16358,'dr','ØªØ§Ø±ÛŒØ® prelimable',0),(589792,16359,'dr','ØªÙˆÙ„ÛŒØ¯ ØªÚ©Ø±Ø§Ø±ÛŒ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(589793,16360,'dr','Ø¨ÛŒØ´ Ø§Ø² PHP Ø­Ø¯Ø§Ú©Ø«Ø± ÙˆØ±ÙˆØ¯ÛŒ Vars',0),(589794,16361,'dr','Ù„Ø·ÙØ§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÛŒ',0),(589795,16362,'dr','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589796,16363,'dr','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589797,16364,'dr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589798,16365,'dr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589799,16366,'dr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589800,16298,'ba','Tidak ada pernyataan yang tersedia',0),(589801,16299,'ba','Info Produk',0),(589802,16300,'ba','Produk Sheet',0),(589803,16301,'ba','Password tidak valid',0),(589804,16302,'ba','Menetapkan kata sandi baru',0),(589805,16303,'ba','Pelanggan atau pekerjaan harus ditetapkan',0),(589806,16304,'ba','Tidak cocok pelanggan',0),(589807,16305,'ba','Mengimpor informasi',0),(589808,16306,'ba','Impor faktur pelanggan dan perubahan pekerjaan',0),(589809,16307,'ba','Keluar oleh biaya kode',0),(589810,16308,'ba','Keluar GL Kategori',0),(589811,16309,'ba','Menghasilkan berulang entri',0),(589812,16310,'ba','Pekerjaan dengan kode ini sudah ada',0),(589813,16311,'ba','Beberapa entri dapat dipisahkan dengan koma',0),(589814,16312,'ba','Diperlukan dan harus unik',0),(589815,16313,'ba','Impor faktur perubahan',0),(589816,16314,'ba','Nilai apapun',0),(589817,16315,'ba','Palsu',0),(589818,16316,'ba','Nama pertama & terakhir',0),(589819,16317,'ba','Jumlah yang diharapkan',0),(589820,16318,'ba','Selengkapnya',0),(589821,16319,'ba','Daftar negara Tampilkan',0),(589822,16320,'ba','Benar',0),(589823,16321,'ba','Anda harus memilih akun GL atau biaya kode atau kategori GL',0),(589824,16322,'ba','Mengirim Email pemberitahuan ketika Bill disetujui',0),(589825,16323,'ba','Membayar tanggal',0),(589826,16324,'ba','Penjual tagihan telah disetujui untuk pembayaran',0),(589827,16325,'ba','PO penerimaan pada RUU ini',0),(589828,16326,'ba','Penagihan kode pos jika ada kapal untuk',0),(589829,16327,'ba','Kapal ke kode pos',0),(589830,16328,'ba','Tampilkan kapal untuk kode pos',0),(589831,16329,'ba','Urutkan kode pos',0),(589832,16330,'ba','Tidak ada nilai yang dipilih',0),(589833,16331,'ba','AP ditutup',0),(589834,16332,'ba','AR ditutup',0),(589835,16333,'ba','Langsung GL ditutup',0),(589836,16334,'ba','Persediaan ditutup',0),(589837,16335,'ba','Sebagian ditutup',0),(589838,16336,'ba','Penggajian ditutup',0),(589839,16337,'ba','Menghasilkan sekarang',0),(589840,16338,'ba','Dihasilkan berhasil',0),(589841,16339,'ba','Menghasilkan Reverse entri',0),(589842,16340,'ba','Tanggal terakhir yang dihasilkan',0),(589843,16341,'ba','Tanggal transaksi terakhir',0),(589844,16342,'ba','Modul-modul yang diblokir',0),(589845,16343,'ba','Mampu Unpost voucher',0),(589846,16344,'ba','Voucher Unposted OK',0),(589847,16345,'ba','Harus memiliki Vendor ID atau Vendor kode atau nama Penjual',0),(589848,16346,'ba','Harus memiliki nomor Invoice dan Vendor ID atau Vendor kode atau nama Penjual dan jumlah dan nomor rekening berlaku',0),(589849,16347,'ba','Perlu kode',0),(589850,16348,'ba','Item baris tambahan di faktur sama hanya perlu ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir dan nomor faktur',0),(589851,16349,'ba','Harus memiliki ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir',0),(589852,16350,'ba','Harus memiliki nomor Invoice dan ID pelanggan atau kode pelanggan atau nama perusahaan atau pertama dan nama terakhir',0),(589853,16351,'ba','Pekerjaan dengan nama ini sudah ada',0),(589854,16352,'ba','Pekerjaan untuk pelanggan ini sudah ada',0),(589855,16353,'ba','Pekerjaan dengan jumlah proyek ini sudah ada',0),(589856,16354,'ba','Pekerjaan dengan alamat ini sudah ada',0),(589857,16355,'ba','Pekerjaan ditutup tanggal',0),(589858,16356,'ba','Tipe Latitude',0),(589859,16357,'ba','Bujur',0),(589860,16358,'ba','Tanggal prelimable',0),(589861,16359,'ba','Menghasilkan berulang entri buku besar',0),(589862,16360,'ba','Lebih dari PHP Max Input Vars',0),(589863,16361,'ba','Masukkan nilai untuk',0),(589864,16362,'ba','Tampilkan kapal untuk kode pos',0),(589865,16363,'ba','Pekerjaan untuk pelanggan ini sudah ada',0),(589866,16364,'ba','Pekerjaan dengan alamat ini sudah ada',0),(589867,16365,'ba','Pekerjaan dengan kode ini sudah ada',0),(589868,16366,'ba','Pekerjaan dengan nama ini sudah ada',0),(589869,16298,'jp','åˆ©ç”¨å¯èƒ½ãªå£°æ˜Ž',0),(589870,16299,'jp','è£½å“æƒ…å ±',0),(589871,16300,'jp','è£½å“ã‚·ãƒ¼ãƒˆ',0),(589872,16301,'jp','ç„¡åŠ¹ãªãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰',0),(589873,16302,'jp','æ–°ã—ã„ãƒ‘ã‚¹ãƒ¯ãƒ¼ãƒ‰ã‚’è¨­å®šã—ã¾ã™ã€‚',0),(589874,16303,'jp','é¡§å®¢ã¾ãŸã¯ã‚¸ãƒ§ãƒ–ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(589875,16304,'jp','é¡§å®¢ã¨ä¸€è‡´ã—ã¾ã›ã‚“',0),(589876,16305,'jp','æƒ…å ±ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(589877,16306,'jp','è¼¸å…¥è«‹æ±‚æ›¸ã®é¡§å®¢ã¨ä»•äº‹ã®å¤‰åŒ–',0),(589878,16307,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã§æŠœã‘å‡ºã™',0),(589879,16308,'jp','GL ã®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’ç ´ã‚‹',0),(589880,16309,'jp','å®šæœŸçš„ãªã‚¨ãƒ³ãƒˆãƒªã‚’ç”Ÿæˆã—ã¾ã™ã€‚',0),(589881,16310,'jp','ã“ã®ã‚³ãƒ¼ãƒ‰ã®ã‚¸ãƒ§ãƒ–ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(589882,16311,'jp','è¤‡æ•°ã®ã‚¨ãƒ³ãƒˆãƒªã¯ã‚³ãƒ³ãƒžã§åˆ†ã‘ã‚‹ã“ã¨ãŒã§ãã¾ã™ã€‚',0),(589883,16312,'jp','å¿…è¦ãªä¸€æ„ã§ã‚ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™',0),(589884,16313,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆè«‹æ±‚æ›¸ã®å¤‰æ›´',0),(589885,16314,'jp','ä»»æ„ã®å€¤',0),(589886,16315,'jp','False',0),(589887,16316,'jp','ãƒ»æœ€åˆã§æœ€å¾Œã®å',0),(589888,16317,'jp','äºˆæœŸã•ã‚Œã‚‹æ•°',0),(589889,16318,'jp','è©³ç´°ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(589890,16319,'jp','ã‚¦ã‚£ãƒ³ãƒ‰ã‚¦ã®è¡¨ç¤ºçŠ¶æ…‹ã®ä¸€è¦§',0),(589891,16320,'jp','çœŸ',0),(589892,16321,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã¾ãŸã¯ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã¾ãŸã¯ GL ã®ã‚«ãƒ†ã‚´ãƒªãƒ¼ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(589893,16322,'jp','æ³•æ¡ˆãŒæ‰¿èªã•ã‚ŒãŸã¨ãã«é›»å­ãƒ¡ãƒ¼ãƒ«é€šçŸ¥ã‚’é€ä¿¡ã—ã¾ã™ã€‚',0),(589894,16323,'jp','æ”¯æ‰•æ—¥',0),(589895,16324,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸ã‚’æ”¯æ‰•æ‰¿èªã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(589896,16325,'jp','ã“ã®è«‹æ±‚æ›¸ã« PO é ˜åŽæ›¸',0),(589897,16326,'jp','å ´åˆã«èˆ¹ã¯éƒµä¾¿ç•ªå·ã‚’è«‹æ±‚',0),(589898,16327,'jp','å‡ºè·å…ˆã®éƒµä¾¿ç•ªå·',0),(589899,16328,'jp','éƒµä¾¿ç•ªå·ã«èˆ¹ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(589900,16329,'jp','éƒµä¾¿ç•ªå·é †',0),(589901,16330,'jp','é¸æŠžã—ãŸå€¤ãŒãªã„ã§ã™ã€‚',0),(589902,16331,'jp','AP é–‰éŽ–',0),(589903,16332,'jp','AR çµ‚äº†',0),(589904,16333,'jp','ç›´æŽ¥ GL çµ‚äº†',0),(589905,16334,'jp','åœ¨åº«çµ‚äº†',0),(589906,16335,'jp','éƒ¨åˆ†çš„ã«é–‰ã˜ã¦ã„ã¾ã™ã€‚',0),(589907,16336,'jp','ä¼‘æ¥­ã®çµ¦ä¸Ž',0),(589908,16337,'jp','ä»Šã™ãç”Ÿæˆã—ã¾ã™ã€‚',0),(589909,16338,'jp','æ­£å¸¸ã«ç”Ÿæˆ',0),(589910,16339,'jp','é€†å¼•ãã‚¨ãƒ³ãƒˆãƒªã‚’ç”Ÿæˆã—ã¾ã™ã€‚',0),(589911,16340,'jp','ç”Ÿæˆã•ã‚ŒãŸæœ€å¾Œã®æ—¥ä»˜',0),(589912,16341,'jp','æœ€çµ‚å–å¼•æ—¥',0),(589913,16342,'jp','ãƒ–ãƒ­ãƒƒã‚¯ ãƒ¢ã‚¸ãƒ¥ãƒ¼ãƒ«',0),(589914,16343,'jp','è«‹æ±‚æ›¸ä¼ç¥¨ã®è¨˜å¸³ã§ãã¾ã›ã‚“ã€‚',0),(589915,16344,'jp','[Ok] æœªé€ä¿¡ã®å¤‰æ›´ã‚¯ãƒ¼ãƒãƒ³',0),(589916,16345,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ID ã¾ãŸã¯ãƒ™ãƒ³ãƒ€ãƒ¼ ã‚³ãƒ¼ãƒ‰ã¾ãŸã¯ãƒ™ãƒ³ãƒ€ãƒ¼åãŒå¿…è¦',0),(589917,16346,'jp','è«‹æ±‚æ›¸ç•ªå·ã¨ãƒ™ãƒ³ãƒ€ãƒ¼ ID ã¾ãŸã¯ãƒ™ãƒ³ãƒ€ãƒ¼ ã‚³ãƒ¼ãƒ‰ã¾ãŸã¯ãƒ™ãƒ³ãƒ€ãƒ¼åã¨é‡ã¨æœ‰åŠ¹ãªã‚¢ã‚«ã‚¦ãƒ³ãƒˆç•ªå·ãŒå¿…è¦',0),(589918,16347,'jp','ã‚³ãƒ¼ãƒ‰ã™ã‚‹ã«ã¯ã€å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(589919,16348,'jp','åŒã˜è«‹æ±‚æ›¸ã«è¿½åŠ ã®è¡Œã‚¢ã‚¤ãƒ†ãƒ ã ã‘ã§é¡§å®¢ ID ã¾ãŸã¯é¡§å®¢ã‚³ãƒ¼ãƒ‰ã€ä¼šç¤¾åã¾ãŸã¯æœ€åˆã¨æœ€å¾Œã®åå‰ã€è«‹æ±‚æ›¸ç•ªå·',0),(589920,16349,'jp','é¡§å®¢ ID ã¾ãŸã¯ãŠå®¢æ§˜ã‚³ãƒ¼ãƒ‰ã¾ãŸã¯ä¼šç¤¾åã¾ãŸã¯æœ€åˆã¨æœ€å¾Œã®åå‰ãŒå¿…è¦',0),(589921,16350,'jp','è«‹æ±‚æ›¸ç•ªå·ã‚„é¡§å®¢ ID ã¾ãŸã¯é¡§å®¢ã‚³ãƒ¼ãƒ‰ã€ä¼šç¤¾åã¾ãŸã¯æœ€åˆã€æœ€å¾Œã®åå‰ãŒå¿…è¦',0),(589922,16351,'jp','ã“ã®åå‰ã®ã‚¸ãƒ§ãƒ–ã¯æ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(589923,16352,'jp','ã“ã®é¡§å®¢ã®ã‚¸ãƒ§ãƒ–ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(589924,16353,'jp','ã“ã®ãƒ—ãƒ­ã‚¸ã‚§ã‚¯ãƒˆç•ªå·ã®ã‚¸ãƒ§ãƒ–ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(589925,16354,'jp','ã“ã®ã‚¢ãƒ‰ãƒ¬ã‚¹ã®ã‚¸ãƒ§ãƒ–ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(589926,16355,'jp','ä»•äº‹ã®çµ‚äº†æ—¥',0),(589927,16356,'jp','Lattitude',0),(589928,16357,'jp','çµŒåº¦',0),(589929,16358,'jp','Prelimable æ—¥',0),(589930,16359,'jp','å®šæœŸçš„ãªç·å‹˜å®šå…ƒå¸³ã®ã‚¨ãƒ³ãƒˆãƒªãŒç”Ÿæˆã•ã‚Œã¾ã™ã€‚',0),(589931,16360,'jp','PHP ã®æœ€å¤§å…¥åŠ›å¤‰æ•°',0),(589932,16361,'jp','å€¤ã‚’å…¥åŠ›ã—ã¦ãã ã•ã„ã€‚',0),(589933,16362,'jp','éƒµä¾¿ç•ªå·ã«èˆ¹ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(589934,16363,'jp','ã“ã®é¡§å®¢ã®ã‚¸ãƒ§ãƒ–ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(589935,16364,'jp','ã“ã®ã‚¢ãƒ‰ãƒ¬ã‚¹ã®ã‚¸ãƒ§ãƒ–ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(589936,16365,'jp','ã“ã®ã‚³ãƒ¼ãƒ‰ã®ã‚¸ãƒ§ãƒ–ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(589937,16366,'jp','ã“ã®åå‰ã®ã‚¸ãƒ§ãƒ–ã¯æ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(589938,16298,'pr','Ù‡ÛŒÚ† Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù…ÙˆØ¬ÙˆØ¯',0),(589939,16299,'pr','Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø­ØµÙˆÙ„',0),(589940,16300,'pr','Ù…Ø­ØµÙˆÙ„ ÙˆØ±Ù‚',0),(589941,16301,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ù†Ø§Ù…Ø¹ØªØ¨Ø±',0),(589942,16302,'pr','Ø±Ù…Ø² Ø¹Ø¨ÙˆØ± Ø¬Ø¯ÛŒØ¯',0),(589943,16303,'pr','Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø§Ø± Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø§ÛŒ',0),(589944,16304,'pr','Ù…Ø´ØªØ±ÛŒ Ù…Ø·Ø§Ø¨Ù‚Øª Ù†Ø¯Ø§Ø±Ø¯',0),(589945,16305,'pr','ÙˆØ§Ø±Ø¯ Ú©Ø±Ø¯Ù† Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(589946,16306,'pr','Ù…Ø´ØªØ±ÛŒ ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª Ùˆ ØªØºÛŒÛŒØ± Ø´ØºÙ„',0),(589947,16307,'pr','ØªÙˆØ³Ø· Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø´Ú©Ø³ØªÙ†',0),(589948,16308,'pr','Ø´Ú©Ø³ØªÙ† Ø¯Ø³ØªÙ‡ GL',0),(589949,16309,'pr','ØªÙˆÙ„ÛŒØ¯ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ ØªÚ©Ø±Ø§Ø±ÛŒ',0),(589950,16310,'pr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589951,16311,'pr','Ú†Ù†Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…ÛŒ ØªÙˆØ§Ù†ÛŒØ¯ Ø¨Ø§ Ú©Ø§Ù…Ø§ Ø§Ø² Ù‡Ù… Ø¬Ø¯Ø§',0),(589952,16312,'pr','Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø² Ùˆ Ø¨Ø§ÛŒØ¯ Ù…Ù†Ø­ØµØ± Ø¨Ù‡ ÙØ±Ø¯',0),(589953,16313,'pr','ØªØºÛŒÛŒØ±Ø§Øª ÙØ§Ú©ØªÙˆØ± ÙˆØ§Ø±Ø¯Ø§Øª',0),(589954,16314,'pr','Ù‡Ø± Ù…Ù‚Ø¯Ø§Ø±',0),(589955,16315,'pr','Ù†Ø§Ø¯Ø±Ø³Øª',0),(589956,16316,'pr','Ù†Ø§Ù… Ø§ÙˆÙ„ÛŒÙ† & Ú¯Ø°Ø´ØªÙ‡',0),(589957,16317,'pr','Ø§Ù†ØªØ¸Ø§Ø± Ù…ÛŒ Ø±ÙˆØ¯ ØªØ¹Ø¯Ø§Ø¯',0),(589958,16318,'pr','Ù†Ù…Ø§ÙŠØ´ Ø¨ÙŠØ´ØªØ±',0),(589959,16319,'pr','Ù„ÛŒØ³Øª ÙˆØ¶Ø¹ÛŒØª Ù†Ù…Ø§ÛŒØ´',0),(589960,16320,'pr','Ø¯Ø±Ø³Øª Ø§Ø³Øª',0),(589961,16321,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯ GL Ø­Ø³Ø§Ø¨ ÛŒØ§ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ ÛŒØ§ Ø±Ø¯Ù‡ GL',0),(589962,16322,'pr','Ø§Ø±Ø³Ø§Ù„ Ø§Ø¹Ù„Ø§Ù…ÛŒÙ‡ Ù‡Ø§ÛŒ Ø§ÛŒÙ…ÛŒÙ„ ØªØ£ÛŒÛŒØ¯ Ù„Ø§ÛŒØ­Ù‡',0),(589963,16323,'pr','ØªØ§Ø±ÙŠØ®',0),(589964,16324,'pr','ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª ØªØ§ÛŒÛŒØ¯ Ø´Ø¯Ù‡ Ø§Ù†Ø¯',0),(589965,16325,'pr','Ù¾Ùˆ Ø±Ø³ÛŒØ¯ Ø¯Ø± Ø§ÛŒÙ† Ù„Ø§ÛŒØ­Ù‡',0),(589966,16326,'pr','Ú©Ø¯ Ù¾Ø³ØªÛŒ Ø§Ú¯Ø± Ù‡ÛŒÚ† Ú©Ø´ØªÛŒ Ø¨Ù‡ Ø­Ø³Ø§Ø¨Ø¯Ø§Ø±ÛŒ Ùˆ Ù…Ø¯ÛŒØ±ÛŒØª',0),(589967,16327,'pr','Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589968,16328,'pr','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589969,16329,'pr','Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù† Ø¨Ø± Ø§Ø³Ø§Ø³ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(589970,16330,'pr','Ù‡ÛŒÚ† Ù…Ù‚Ø¯Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(589971,16331,'pr','AP Ø¨Ø³ØªÙ‡',0),(589972,16332,'pr','Ø¹Ù„ÛŒØ±Ø¶Ø§ Ø¨Ø³ØªÙ‡',0),(589973,16333,'pr','Ù…Ø³ØªÙ‚ÛŒÙ… GL Ø¨Ø³ØªÙ‡',0),(589974,16334,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¨Ø³ØªÙ‡',0),(589975,16335,'pr','Ø¨Ø³ØªÙ‡ ØªØ§ Ø­Ø¯ÛŒ',0),(589976,16336,'pr','Ø­Ù‚ÙˆÙ‚ Ùˆ Ø¯Ø³ØªÙ…Ø²Ø¯ Ø¨Ø³ØªÙ‡',0),(589977,16337,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± ØªÙˆÙ„ÛŒØ¯',0),(589978,16338,'pr','ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª',0),(589979,16339,'pr','Ø§ÛŒØ¬Ø§Ø¯ ÙˆØ±ÙˆØ¯ÛŒ Ù…Ø¹Ú©ÙˆØ³',0),(589980,16340,'pr','ØªØ§Ø±ÛŒØ® Ùˆ Ø²Ù…Ø§Ù† Ø¢Ø®Ø±ÛŒÙ† ØªÙˆÙ„ÛŒØ¯ Ø´Ø¯Ù‡',0),(589981,16341,'pr','ØªØ§Ø±ÛŒØ® Ø¢Ø®Ø±ÛŒÙ† Ù…Ø¹Ø§Ù…Ù„Ù‡',0),(589982,16342,'pr','Ù…Ø§Ú˜ÙˆÙ„ Ù‡Ø§ÛŒ Ù…Ø³Ø¯ÙˆØ¯ Ø´Ø¯Ù‡',0),(589983,16343,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Unpost Ú©ÙˆÙ¾Ù†',0),(589984,16344,'pr','Ú©ÙˆÙ¾Ù† Unposted OK',0),(589985,16345,'pr','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ ÛŒØ§ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù…',0),(589986,16346,'pr','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ù†Ø§Ù… ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ùˆ Ù…Ø¨Ù„Øº Ùˆ Ø´Ù…Ø§Ø±Ù‡ Ø­Ø³Ø§Ø¨ Ù…Ø¹ØªØ¨Ø±',0),(589987,16347,'pr','Ù†ÛŒØ§Ø² Ø¨Ù‡ Ú©Ø¯',0),(589988,16348,'pr','Ù…ÙˆØ§Ø±Ø¯ Ø®Ø· Ø§Ø¶Ø§ÙÛŒ Ø¯Ø± Ù‡Ù…Ø§Ù† ÙØ§Ú©ØªÙˆØ± ÙÙ‚Ø· Ù†ÛŒØ§Ø² Ø¨Ù‡ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ Ùˆ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ±',0),(589989,16349,'pr','Ø¨Ø§ÛŒØ¯ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589990,16350,'pr','Ø¨Ø§ÛŒØ¯ Ø´Ù…Ø§Ø±Ù‡ ÙØ§Ú©ØªÙˆØ± Ùˆ Ø´Ù†Ø§Ø³Ù‡ Ù…Ø´ØªØ±ÛŒ Ùˆ ÛŒØ§ Ú©Ø¯ Ù…Ø´ØªØ±ÛŒ ÛŒØ§ Ù†Ø§Ù… Ø´Ø±Ú©Øª ÛŒØ§ Ø§ÙˆÙ„ Ùˆ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(589991,16351,'pr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589992,16352,'pr','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(589993,16353,'pr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ù¾Ø±ÙˆÚ˜Ù‡ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589994,16354,'pr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(589995,16355,'pr','Ú©Ø§Ø± Ø¨Ø³ØªÙ‡ ØªØ§Ø±ÛŒØ®',0),(589996,16356,'pr','Lattitude',0),(589997,16357,'pr','Ø·ÙˆÙ„ Ø¬ØºØ±Ø§ÙÛŒØ§ÛŒÛŒ',0),(589998,16358,'pr','ØªØ§Ø±ÛŒØ® prelimable',0),(589999,16359,'pr','ØªÙˆÙ„ÛŒØ¯ ØªÚ©Ø±Ø§Ø±ÛŒ Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø¯ÙØªØ± Ú©Ù„',0),(590000,16360,'pr','Ø¨ÛŒØ´ Ø§Ø² PHP Ø­Ø¯Ø§Ú©Ø«Ø± ÙˆØ±ÙˆØ¯ÛŒ Vars',0),(590001,16361,'pr','Ù„Ø·ÙØ§ ÛŒÚ© Ù…Ù‚Ø¯Ø§Ø± Ø¨Ø±Ø§ÛŒ',0),(590002,16362,'pr','Ù†Ù…Ø§ÛŒØ´ Ú©Ø´ØªÛŒ Ø¨Ù‡ Ú©Ø¯ Ù¾Ø³ØªÛŒ',0),(590003,16363,'pr','Ú©Ø§Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ø´ØªØ±ÛŒ Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(590004,16364,'pr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ø¢Ø¯Ø±Ø³ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(590005,16365,'pr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(590006,16366,'pr','Ú©Ø§Ø± Ø¨Ø§ Ø§ÛŒÙ† Ù†Ø§Ù… Ø§Ø² Ù‚Ø¨Ù„ ÙˆØ¬ÙˆØ¯ Ø¯Ø§Ø±Ø¯',0),(590007,16298,'si','Nobene izjave na voljo',0),(590008,16299,'si','Produktu',0),(590009,16300,'si','Product list',0),(590010,16301,'si','Neveljavno geslo',0),(590011,16302,'si','Nastavite novo geslo',0),(590012,16303,'si','Stranko ali delo mora biti nastavljen',0),(590013,16304,'si','Stranka se ne ujema',0),(590014,16305,'si','Uvoziti podatke',0),(590015,16306,'si','Uvoznega raÄuna stranke in menjavo delovnih mest',0),(590016,16307,'si','Izbruhnejo stroÅ¡kovno koda',0),(590017,16308,'si','Izbruhne po kategoriji GL',0),(590018,16309,'si','Ustvarjanje ponavljajoÄe se postavke',0),(590019,16310,'si','Delo s to kodo Å¾e obstaja',0),(590020,16311,'si','VeÄkratni lahko loÄeni z vejicami',0),(590021,16312,'si','Potrebno in mora biti enoliÄna',0),(590022,16313,'si','Uvoznega raÄuna spremembe',0),(590023,16314,'si','Matrika',0),(590024,16315,'si','NapaÄne',0),(590025,16316,'si','Prvi & zadnje ime',0),(590026,16317,'si','Å tevila priÄakovanih',0),(590027,16318,'si','PrikaÅ¾i veÄ',0),(590028,16319,'si','PrikaÅ¾i stanje seznam',0),(590029,16320,'si','Res',0),(590030,16321,'si','Izbrati morate GL raÄun ali stroÅ¡kovno kodo ali GL Category',0),(590031,16322,'si','PoÅ¡lji Email obvestila, ko Bill',0),(590032,16323,'si','PlaÄati datum',0),(590033,16324,'si','RaÄune dobavitelja so bili odobreni za plaÄilo',0),(590034,16325,'si','Prejemki PO na ta raÄun',0),(590035,16326,'si','ZaraÄunavanje poÅ¡tno Å¡tevilko, Äe nobena ladja, da',0),(590036,16327,'si','Dostava â€“ poÅ¡tna Å¡tevilka',0),(590037,16328,'si','PrikaÅ¾i ladji poÅ¡tna Å¡tevilka',0),(590038,16329,'si','Razvrsti po Zip kodo',0),(590039,16330,'si','Ni izbrana vrednost',0),(590040,16331,'si','AP zaprta',0),(590041,16332,'si','AR, zaprta',0),(590042,16333,'si','Neposredno GL zaprta',0),(590043,16334,'si','Zaloge, zaprta',0),(590044,16335,'si','Delno zaprta',0),(590045,16336,'si','IzplaÄane plaÄe, zaprta',0),(590046,16337,'si','Zdaj ustvarjajo',0),(590047,16338,'si','UspeÅ¡no ustvarjen',0),(590048,16339,'si','Ustvarite stornirano postavko',0),(590049,16340,'si','Zadnji datum nastanka',0),(590050,16341,'si','Zadnji datum transakcije',0),(590051,16342,'si','Blokirane modulov',0),(590052,16343,'si','Mogli Unpost boni',0),(590053,16344,'si','Bonov neknjiÅ¾enih OK',0),(590054,16345,'si','Mora imeti ID prodajalca ali koda prodajalca ali ime dobavitelja',0),(590055,16346,'si','Mora imeti Å¡tevilko raÄuna in ID prodajalca ali koda prodajalca ali ime dobavitelja in koliÄino in veljaven raÄun Å¡tevilka',0),(590056,16347,'si','Mora biti Å¡ifro',0),(590057,16348,'si','Dodatne vrstiÄne postavke v isti raÄun potrebujete ID stranke ali kupca ali ime podjetja ali prvi in priimek in Å¡tevilko raÄuna',0),(590058,16349,'si','Mora imeti ID stranke ali kupca ali firma ali ime in priimek',0),(590059,16350,'si','Mora imeti Å¡tevilko raÄuna in ID stranke ali kupca ali firma ali ime in priimek',0),(590060,16351,'si','Delo s tem imenom Å¾e obstaja',0),(590061,16352,'si','Delo za tega kupca Å¾e obstaja',0),(590062,16353,'si','Delo s to Å¡tevilko projekta Å¾e obstaja',0),(590063,16354,'si','Delo s tem naslovom Å¾e obstaja',0),(590064,16355,'si','Job Datum zapiranja',0),(590065,16356,'si','Lattitude',0),(590066,16357,'si','DolÅ¾ine',0),(590067,16358,'si','Prelimable datum',0),(590068,16359,'si','Ustvarjanje ponavljajoÄe se postavke',0),(590069,16360,'si','Nad PHP Max vloÅ¾ek Vars',0),(590070,16361,'si','Vnesite vrednost za',0),(590071,16362,'si','PrikaÅ¾i ladji poÅ¡tna Å¡tevilka',0),(590072,16363,'si','Delo za tega kupca Å¾e obstaja',0),(590073,16364,'si','Delo s tem naslovom Å¾e obstaja',0),(590074,16365,'si','Delo s to kodo Å¾e obstaja',0),(590075,16366,'si','Delo s tem imenom Å¾e obstaja',0),(590077,16378,'en','Clear Search',0),(590078,16385,'en','Define Name',0),(590079,16379,'en','Hide Tab',0),(590080,16368,'en','Job Not Marked As Zlien Ready',0),(590081,16369,'en','Mail Sent With Errors',0),(590082,16370,'en','Nothing Selected',0),(590083,16374,'en','Overdue Invoice',0),(590084,16375,'en','Overdue Invoices',0),(590085,16376,'en','Pending Invoice',0),(590086,16377,'en','Pending Invoices',0),(590087,16372,'en','Pending Payment',0),(590088,16373,'en','Pending Payments',0),(590089,16382,'en','Prelim Request Reply To',0),(590090,16371,'en','Prune Imports After X Days',0),(590091,16383,'en','Show Internal Notes',0),(590092,16380,'en','Show Tab',0),(590093,16381,'en','Update 3dcart Hold Status Automatically',0),(590094,16367,'en','You Must Be A Supervisor To Access This Page',0),(590095,16384,'en','Zlien Ready',0),(590096,16386,'en','Edit Service Order',0),(590097,16387,'en','Edit Item',0),(590098,16388,'en','Testing Something Here',0),(590099,16367,'af','Jy moet \'n toesighouer om toegang tot hierdie bladsy word',0),(590100,16368,'af','Werk nie gemerk As Zlien gereed',0),(590101,16369,'af','E-pos gestuur met foute',0),(590102,16370,'af','Niks gekies',0),(590103,16371,'af','Snoei invoere na X dae',0),(590104,16372,'af','Hangende betaling',0),(590105,16373,'af','Hangende betalings',0),(590106,16374,'af','Agterstallige faktuur',0),(590107,16375,'af','Agterstallige fakture',0),(590108,16376,'af','Hangende faktuur',0),(590109,16377,'af','Hangende fakture',0),(590110,16378,'af','Vee soektog uit',0),(590111,16379,'af','Versteek duimgids',0),(590112,16380,'af','Wys duimgids',0),(590113,16381,'af','3dcart hou Status outomaties opdateer',0),(590114,16382,'af','Prelim versoek antwoord te',0),(590115,16383,'af','Wys interne notas',0),(590116,16384,'af','Zlien gereed',0),(590117,16385,'af','Definieer naam',0),(590118,16386,'af','Redigeer diens bestel',0),(590119,16387,'af','Redigeer Item',0),(590120,16388,'af','Toets iets hier',0),(590121,16367,'ar','ÙŠØ¬Ø¨ Ø£Ù† ØªÙƒÙˆÙ† Ù…Ø´Ø±ÙØ§ Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ù‡Ø°Ù‡ Ø§Ù„ØµÙØ­Ø©',0),(590122,16368,'ar','Ø§Ù„ÙˆØ¸ÙŠÙØ© Ø§Ù„ØªÙŠ Ù„Ù… ÙŠØªÙ… ÙˆØ¶Ø¹ Ø¹Ù„Ø§Ù…Ø© ÙƒØ¬Ø§Ù‡Ø² Ø²Ù„ÙŠÙ†',0),(590123,16369,'ar','Ø¨Ø±ÙŠØ¯ Ù…Ø±Ø³Ù„ Ù…Ø¹ Ø§Ù„Ø£Ø®Ø·Ø§Ø¡',0),(590124,16370,'ar','Ù„Ø§ Ø´ÙŠØ¡ Ù…Ø­Ø¯Ø¯',0),(590125,16371,'ar','ØªÙ‚Ù„ÙŠÙ… Ø§Ù„ÙˆØ§Ø±Ø¯Ø§Øª Ø¨Ø¹Ø¯ X ÙŠÙˆÙ…',0),(590126,16372,'ar','Ø§Ù†ØªØ¸Ø§Ø± Ø§Ù„Ø¯ÙØ¹',0),(590127,16373,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(590128,16374,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(590129,16375,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ØªØ£Ø®Ø±Ø©',0),(590130,16376,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(590131,16377,'ar','Ø§Ù„ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…Ø¹Ù„Ù‚Ø©',0),(590132,16378,'ar','Ù…Ø³Ø­ Ø§Ù„Ø¨Ø­Ø«',0),(590133,16379,'ar','Ø¥Ø®ÙØ§Ø¡ Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¨ÙˆÙŠØ¨',0),(590134,16380,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø¹Ù„Ø§Ù…Ø© Ø§Ù„ØªØ¨ÙˆÙŠØ¨',0),(590135,16381,'ar','ÙŠØªÙ… ØªØ­Ø¯ÙŠØ« Ø­Ø§Ù„Ø© Ø§Ù„Ø§Ø­ØªØ¬Ø§Ø² 3dcart ØªÙ„Ù‚Ø§Ø¦ÙŠØ§Ù‹',0),(590136,16382,'ar','Prelim Ø·Ù„Ø¨ Ø§Ù„Ø±Ø¯ Ø¥Ù„Ù‰',0),(590137,16383,'ar','Ø¥Ø¸Ù‡Ø§Ø± Ø§Ù„Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ø¯Ø§Ø®Ù„ÙŠØ©',0),(590138,16384,'ar','Ø²Ù„ÙŠÙŠÙ† Ø¬Ø§Ù‡Ø²Ø©',0),(590139,16385,'ar','Ù‚Ù… Ø¨ØªØ¹Ø±ÙŠÙ Ø§Ø³Ù…',0),(590140,16386,'ar','ØªØ­Ø±ÙŠØ± Ø£Ù…Ø± Ø§Ù„Ø®Ø¯Ù…Ø©',0),(590141,16387,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø¹Ù†ØµØ±',0),(590142,16388,'ar','Ø§Ø®ØªØ¨Ø§Ø± Ø´ÙŠØ¡ Ù‡Ù†Ø§',0),(590143,16367,'bg','Ð¢Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð½Ð°Ð´Ð·Ð¾Ñ€ÐµÐ½ Ð¾Ñ€Ð³Ð°Ð½ Ð·Ð° Ð´Ð¾ÑÑ‚ÑŠÐ¿ Ð´Ð¾ Ñ‚Ð°Ð·Ð¸ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°',0),(590144,16368,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð½Ðµ ÑÐµ Ð¼Ð°Ñ€ÐºÐ¸Ñ€Ð° ÐºÐ°Ñ‚Ð¾ Zlien Ð³Ð¾Ñ‚Ð¾Ð²',0),(590145,16369,'bg','ÐŸÐ¾Ñ‰Ð°, Ð¸Ð·Ð¿Ñ€Ð°Ñ‚ÐµÐ½Ð° Ñ Ð³Ñ€ÐµÑˆÐºÐ¸',0),(590146,16370,'bg','ÐÐ¸Ñ‰Ð¾ Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(590147,16371,'bg','Ð ÐµÐ¶ÐµÑˆ Ð²Ð½Ð¾Ñ ÑÐ»ÐµÐ´ X Ð´Ð½Ð¸',0),(590148,16372,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ',0),(590149,16373,'bg','ÐŸÑ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸Ñ‚Ðµ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ',0),(590150,16374,'bg','Ð—Ð°ÐºÑŠÑÐ½ÑÐ»Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(590151,16375,'bg','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(590152,16376,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(590153,16377,'bg','Ð§Ð°ÐºÐ°Ñ‰ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð¸',0),(590154,16378,'bg','Ð˜Ð·Ñ‡Ð¸ÑÑ‚Ð¸ Ñ‚ÑŠÑ€ÑÐµÐ½ÐµÑ‚Ð¾',0),(590155,16379,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ñ€Ð°Ð·Ð´ÐµÐ»Ð°',0),(590156,16380,'bg','ÐŸÐ¾ÐºÐ°Ð·Ð²Ð°Ð½Ðµ Ð½Ð° Ñ€Ð°Ð·Ð´ÐµÐ»',0),(590157,16381,'bg','3dcart Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°Ð½Ðµ ÑÑ‚Ð°Ñ‚ÑƒÑ ÑÐµ Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ñ‚ Ð°Ð²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡Ð½Ð¾',0),(590158,16382,'bg','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÐµÐ½ Ð¾Ñ‚Ð³Ð¾Ð²Ð¾Ñ€ Ð½Ð° Ð¸ÑÐºÐ°Ð½ÐµÑ‚Ð¾ Ð½Ð°',0),(590159,16383,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ Ð²ÑŠÑ‚Ñ€ÐµÑˆÐ½Ð¸Ñ‚Ðµ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(590160,16384,'bg','Zlien Ð³Ð¾Ñ‚Ð¾Ð²',0),(590161,16385,'bg','Ð”ÐµÑ„Ð¸Ð½Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¸Ð¼Ðµ',0),(590162,16386,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ð¾Ñ€ÑŠÑ‡ÐºÐ° Ð·Ð° ÑÐµÑ€Ð²Ð¸Ð·',0),(590163,16387,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(590164,16388,'bg','Ð—Ð°ÑÐ²Ð¸Ð´ÐµÑ‚ÐµÐ»ÑÑ‚Ð²ÑƒÐ²Ð°Ð¼ Ð½ÐµÑ‰Ð¾ Ñ‚ÑƒÐº',0),(590165,16367,'zh','ä½ å¿…é¡»æ˜¯ä¸€ä½ä¸»ç®¡æ¥è®¿é—®æ­¤é¡µ',0),(590166,16368,'zh','æœªæ ‡è®°ä¸º Zlien å‡†å¤‡çš„å·¥ä½œ',0),(590167,16369,'zh','ä¸Žé”™è¯¯å‘é€çš„é‚®ä»¶',0),(590168,16370,'zh','æœªé€‰æ‹©ä»»ä½•å†…å®¹',0),(590169,16371,'zh','ä¿®å‰ªåŽ X å¤©çš„è¿›å£',0),(590170,16372,'zh','å¾…ä»˜æ¬¾',0),(590171,16373,'zh','æ¬¾é¡¹',0),(590172,16374,'zh','é€¾æœŸå‘ç¥¨',0),(590173,16375,'zh','é€¾æœŸå‘ç¥¨',0),(590174,16376,'zh','å¾…å®šå‘ç¥¨',0),(590175,16377,'zh','å¾…å®šå‘ç¥¨',0),(590176,16378,'zh','æ¸…é™¤æœç´¢',0),(590177,16379,'zh','éšè—é€‰é¡¹å¡',0),(590178,16380,'zh','æ˜¾ç¤ºé€‰é¡¹å¡',0),(590179,16381,'zh','è‡ªåŠ¨æ›´æ–° 3dcart æš‚åœçŠ¶æ€',0),(590180,16382,'zh','åˆè¯•è¯·æ±‚ç­”å¤',0),(590181,16383,'zh','æ˜¾ç¤ºå†…éƒ¨ç¬”è®°',0),(590182,16384,'zh','Zlien å‡†å¤‡',0),(590183,16385,'zh','å®šä¹‰åç§°',0),(590184,16386,'zh','ç¼–è¾‘æœåŠ¡è®¢å•',0),(590185,16387,'zh','ç¼–è¾‘é¡¹ç›®',0),(590186,16388,'zh','æµ‹è¯•åœ¨è¿™é‡Œçš„ä¸œè¥¿',0),(590187,16367,'da','Du skal vÃ¦re en vejleder til at fÃ¥ adgang til denne side',0),(590188,16368,'da','Job ikke er markeret som Zlien klar',0),(590189,16369,'da','Mail sendt med fejl',0),(590190,16370,'da','Intet valgt',0),(590191,16371,'da','Sveske import efter X dage',0),(590192,16372,'da','Afventer betaling',0),(590193,16373,'da','Ventende betalinger',0),(590194,16374,'da','Forfaldne faktura',0),(590195,16375,'da','Forfaldne fakturaer',0),(590196,16376,'da','Ventende faktura',0),(590197,16377,'da','Ventende fakturaer',0),(590198,16378,'da','Ryd sÃ¸gning',0),(590199,16379,'da','Skjul fanen',0),(590200,16380,'da','Vis fanen',0),(590201,16381,'da','3dcart Hold Status opdateres automatisk',0),(590202,16382,'da','Prelim anmodning svar pÃ¥',0),(590203,16383,'da','Vis interne notater',0),(590204,16384,'da','Zlien klar',0),(590205,16385,'da','Definere navnet',0),(590206,16386,'da','Rediger serviceordre',0),(590207,16387,'da','Rediger element',0),(590208,16388,'da','Teste noget her',0),(590209,16367,'dr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø³Ø±Ù¾Ø±Ø³Øª Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø§ÛŒÙ† ØµÙØ­Ù‡',0),(590210,16368,'dr','Ú©Ø§Ø± Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¢Ù…Ø§Ø¯Ù‡ Zlien Ù…Ø´Ø®Øµ',0),(590211,16369,'dr','Ø§ÛŒÙ…ÛŒÙ„ Ù‡Ø§ÛŒ Ø®Ø·Ø§',0),(590212,16370,'dr','Ù‡ÛŒÚ† Ú†ÛŒØ² Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(590213,16371,'dr','Ø¢Ù„Ùˆ ÙˆØ§Ø±Ø¯Ø§Øª Ù¾Ø³ Ø§Ø² X Ø±ÙˆØ²',0),(590214,16372,'dr','Ø§Ù†ØªØ¸Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(590215,16373,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø§Ù†ØªØ¸Ø§Ø±',0),(590216,16374,'dr','ÙØ§Ú©ØªÙˆØ± Ø³Ø± Ø±Ø³ÛŒØ¯Ù‡',0),(590217,16375,'dr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø³Ø± Ø±Ø³ÛŒØ¯Ù‡',0),(590218,16376,'dr','ÙØ§Ú©ØªÙˆØ± Ù‡Ø§ÛŒ Ø§Ù†ØªØ¸Ø§Ø±',0),(590219,16377,'dr','Ø§Ù†ØªØ¸Ø§Ø± ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(590220,16378,'dr','Ù¾Ø§Ú© Ú©Ø±Ø¯Ù† Ø¬Ø³ØªØ¬Ùˆ',0),(590221,16379,'dr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ø²Ø¨Ø§Ù†Ù‡',0),(590222,16380,'dr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ø±Ú¯Ù‡',0),(590223,16381,'dr','3dcart Ù†Ú¯Ù‡ ÙˆØ¶Ø¹ÛŒØª Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(590224,16382,'dr','Ù¾Ø§Ø³Ø® Ø¯Ø±Ø®ÙˆØ§Ø³Øª prelim',0),(590225,16383,'dr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ø¯Ø§Ø®Ù„ÛŒ',0),(590226,16384,'dr','Zlien Ø¢Ù…Ø§Ø¯Ù‡',0),(590227,16385,'dr','ØªØ¹Ø±ÛŒÙ Ù†Ø§Ù…',0),(590228,16386,'dr','Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ÙˆÛŒØ±Ø§ÛŒØ´',0),(590229,16387,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù…ÙˆØ±Ø¯',0),(590230,16388,'dr','Ú†ÛŒØ²ÛŒ Ø¯Ø± Ø§ÛŒÙ†Ø¬Ø§ ØªØ³Øª',0),(590231,16367,'nl','U moet een toezichthouder om deze pagina te openen',0),(590232,16368,'nl','Baan niet gemarkeerd als Zlien klaar',0),(590233,16369,'nl','Mail verzonden met fouten',0),(590234,16370,'nl','Niets geselecteerd',0),(590235,16371,'nl','Snoeien van invoer na X dagen',0),(590236,16372,'nl','In afwachting van de betaling',0),(590237,16373,'nl','Openstaande posten',0),(590238,16374,'nl','Openstaande factuur',0),(590239,16375,'nl','Openstaande facturen',0),(590240,16376,'nl','Hangende factuur',0),(590241,16377,'nl','Hangende facturen',0),(590242,16378,'nl','Zoekopdracht wissen',0),(590243,16379,'nl','Hide Tab',0),(590244,16380,'nl','Tabblad weergeven',0),(590245,16381,'nl','Automatisch bijwerken van 3dcart Wachtstatus',0),(590246,16382,'nl','Kwalificatie verzoek beantwoorden',0),(590247,16383,'nl','Interne notities weergeven',0),(590248,16384,'nl','Zlien klaar',0),(590249,16385,'nl','Naam definiÃ«ren',0),(590250,16386,'nl','Bewerken van de serviceorder',0),(590251,16387,'nl','Item bewerken',0),(590252,16388,'nl','Testen hier iets',0),(590253,16367,'et','Sa pead olema juhendaja siseneda sellele lehele',0),(590254,16368,'et','Pole mÃ¤rgitud Zlien valmis tÃ¶Ã¶',0),(590255,16369,'et','Post saadetakse vead',0),(590256,16370,'et','Midagi valitud',0),(590257,16371,'et','Ploomi impordi pÃ¤rast X pÃ¤eva',0),(590258,16372,'et','Ootelolev makse',0),(590259,16373,'et','Ootel maksete',0),(590260,16374,'et','TÃ¤htajaks tasumata arve',0),(590261,16375,'et','TÃ¤htajaks tasumata arvete',0),(590262,16376,'et','Ootel arve',0),(590263,16377,'et','Menetluses olevad arved',0),(590264,16378,'et','TÃ¼hjenda otsing',0),(590265,16379,'et','Vahekaartide peitmine',0),(590266,16380,'et','MenÃ¼Ã¼ kuvamine',0),(590267,16381,'et','Automaatse vÃ¤rskendamise olek otsuse ootel 3dcart',0),(590268,16382,'et','Aasta taotluse vastus',0),(590269,16383,'et','NÃ¤ita sisedokumentidele',0),(590270,16384,'et','Zlien valmis',0),(590271,16385,'et','Nime saate mÃ¤Ã¤ratleda',0),(590272,16386,'et','Redigeerida hooldustellimuse',0),(590273,16387,'et','Ãœksuse redigeerimine',0),(590274,16388,'et','Katsetamise midagi siin',0),(590275,16367,'fi','Sinun tÃ¤ytyy olla Esimies voi kÃ¤yttÃ¤Ã¤ tÃ¤tÃ¤ sivua',0),(590276,16368,'fi','TyÃ¶ ei ole merkitty Zlien valmis',0),(590277,16369,'fi','Posti lÃ¤hetetÃ¤Ã¤n virheitÃ¤',0),(590278,16370,'fi','MitÃ¤Ã¤n ei ole valittu',0),(590279,16371,'fi','Karsi tuonnin jÃ¤lkeen X pÃ¤ivÃ¤Ã¤',0),(590280,16372,'fi','VielÃ¤ maksaa',0),(590281,16373,'fi','Kunnes maksut',0),(590282,16374,'fi','ErÃ¤Ã¤ntyneiden laskujen',0),(590283,16375,'fi','ErÃ¤Ã¤ntyneille laskuille',0),(590284,16376,'fi','Odottava lasku',0),(590285,16377,'fi','Odottavat laskut',0),(590286,16378,'fi','TyhjennÃ¤ haku',0),(590287,16379,'fi','Piilota vÃ¤lilehti',0),(590288,16380,'fi','NÃ¤ytÃ¤-vÃ¤lilehti',0),(590289,16381,'fi','PÃ¤ivitÃ¤ 3dcart pidon tila automaattisesti',0),(590290,16382,'fi','Alustava pyyntÃ¶ vastata',0),(590291,16383,'fi','NÃ¤ytÃ¤ sisÃ¤iset huomautukset',0),(590292,16384,'fi','Zlien valmis',0),(590293,16385,'fi','MÃ¤Ã¤ritÃ¤ nimi',0),(590294,16386,'fi','Muokkaa huoltotilausta',0),(590295,16387,'fi','Muokkaa kohdetta',0),(590296,16388,'fi','Testaus jotain',0),(590297,16367,'fr','Vous devez Ãªtre un superviseur pour accÃ©der Ã  cette Page',0),(590298,16368,'fr','Emploi non marquÃ© comme Zlien Ready',0),(590299,16369,'fr','Courrier envoyÃ© avec Erreurs',0),(590300,16370,'fr','Rien nâ€™est sÃ©lectionnÃ©',0),(590301,16371,'fr','Taillez les importations aprÃ¨s X jours',0),(590302,16372,'fr','Paiement en attente',0),(590303,16373,'fr','Paiements en attente',0),(590304,16374,'fr','Facture en retard',0),(590305,16375,'fr','Factures en souffrance',0),(590306,16376,'fr','Facture en attente',0),(590307,16377,'fr','Factures en attente',0),(590308,16378,'fr','Effacer la recherche',0),(590309,16379,'fr','Masquer lâ€™onglet',0),(590310,16380,'fr','Afficher lâ€™onglet',0),(590311,16381,'fr','Mise Ã  jour de statut de suspension 3dcart automatiquement',0),(590312,16382,'fr','Prelim demande rÃ©ponse Ã ',0),(590313,16383,'fr','Montrer les Notes internes',0),(590314,16384,'fr','PrÃªt Zlien',0),(590315,16385,'fr','DÃ©finir le nom',0),(590316,16386,'fr','Modifier une commande de Service',0),(590317,16387,'fr','Modifier lâ€™article',0),(590318,16388,'fr','Tester quelque chose ici',0),(590319,16367,'de','Sie mÃ¼ssen ein Supervisor Zugang zu dieser Seite sein.',0),(590320,16368,'de','Job nicht als Zlien Ready gekennzeichnet',0),(590321,16369,'de','E-Mails mit Fehlern',0),(590322,16370,'de','Nichts ausgewÃ¤hlt',0),(590323,16371,'de','Pflaume-Einfuhren nach X Tagen',0),(590324,16372,'de','Ausstehende Zahlung',0),(590325,16373,'de','Pendente Zahlungen',0),(590326,16374,'de','ÃœberfÃ¤llige Rechnung',0),(590327,16375,'de','ÃœberfÃ¤llige Rechnungen',0),(590328,16376,'de','Ausstehende Rechnung',0),(590329,16377,'de','Ausstehende Rechnungen',0),(590330,16378,'de','Suche lÃ¶schen',0),(590331,16379,'de','Registerkarte \"ausblenden',0),(590332,16380,'de','Registerkarte anzeigen',0),(590333,16381,'de','3dcart Hold Status automatisch aktualisieren',0),(590334,16382,'de','Bracelet-Anforderung-Antwort',0),(590335,16383,'de','Interne Notizen anzeigen',0),(590336,16384,'de','Zlien bereit',0),(590337,16385,'de','Namen definieren',0),(590338,16386,'de','Serviceauftrag bearbeiten',0),(590339,16387,'de','Artikel bearbeiten',0),(590340,16388,'de','Testen hier etwas',0),(590341,16367,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎ¯ÏƒÏ„Îµ Î­Î½Î±Ï‚ ÎµÏ€ÏŒÏ€Ï„Î·Ï‚ Î³Î¹Î± Î½Î± Î±Ï€Î¿ÎºÏ„Î®ÏƒÎµÏ„Îµ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ· ÏƒÎµ Î±Ï…Ï„Î®Î½ Ï„Î· ÏƒÎµÎ»Î¯Î´Î±',0),(590342,16368,'el','Î”Î¿Ï…Î»ÎµÎ¹Î¬ Î´ÎµÎ½ Î­Ï‡ÎµÎ¹ ÏƒÎ·Î¼Î±Î½Î¸ÎµÎ¯ Ï‰Ï‚ Î­Ï„Î¿Î¹Î¼Î¿ Zlien',0),(590343,16369,'el','Mail Ï€Î¿Ï… ÏƒÏ„Î­Î»Î½Î¿Î½Ï„Î±Î¹ Î¼Îµ ÏƒÏ†Î¬Î»Î¼Î±Ï„Î±',0),(590344,16370,'el','Î¤Î¯Ï€Î¿Ï„Î± Î´ÎµÎ½ ÎµÏ€Î¹Î»Î­Î³ÎµÏ„Î±Î¹',0),(590345,16371,'el','ÎšÎ»Î±Î´Î­ÏˆÏ„Îµ Ï„Î¹Ï‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î­Ï‚ Î¼ÎµÏ„Î¬ Î±Ï€ÏŒ X Î·Î¼Î­ÏÎµÏ‚',0),(590346,16372,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï€Î¿Ï… ÎµÎºÎºÏÎµÎ¼ÎµÎ¯',0),(590347,16373,'el','Î•ÎºÎºÏÎµÎ¼ÎµÎ¯Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î­Ï‚',0),(590348,16374,'el','Î•ÎºÏ€ÏÏŒÎ¸ÎµÏƒÎ¼Ï‰Î½ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Ï‰Î½',0),(590349,16375,'el','Î›Î·Î¾Î¹Ï€ÏÏŒÎ¸ÎµÏƒÎ¼Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(590350,16376,'el','Î£Îµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(590351,16377,'el','Î•ÎºÎºÏÎµÎ¼ÎµÎ¯ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î±',0),(590352,16378,'el','Î‘Ï€Î±Î»Î¿Î¹Ï†Î® ÎºÏÎ¹Ï„Î·ÏÎ¯Ï‰Î½ Î±Î½Î±Î¶Î®Ï„Î·ÏƒÎ·Ï‚',0),(590353,16379,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Ï„Î·Ï‚ ÎºÎ±ÏÏ„Î­Î»Î±Ï‚',0),(590354,16380,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎºÎ±ÏÏ„Î­Î»Î±Ï‚',0),(590355,16381,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· 3dcart ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Hold',0),(590356,16382,'el','Î ÏÎ¿ÏƒÏ‡Î­Î´Î¹Î¿ Î±Ï€Î¬Î½Ï„Î·ÏƒÎ· Î±Î¹Ï„Î®Î¼Î±Ï„Î¿Ï‚',0),(590357,16383,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÎµÏƒÏ‰Ï„ÎµÏÎ¹ÎºÎ­Ï‚ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(590358,16384,'el','ÎˆÏ„Î¿Î¹Î¼Î¿ Zlien',0),(590359,16385,'el','ÎšÎ±Î¸Î¿ÏÎ¯ÏƒÎµÏ„Îµ ÏŒÎ½Î¿Î¼Î±',0),(590360,16386,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÎ½Ï„Î¿Î»Î®Ï‚ Ï„/Ï…',0),(590361,16387,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿Ï…',0),(590362,16388,'el','Î”Î¿ÎºÎ¹Î¼Î® ÎºÎ¬Ï„Î¹ ÎµÎ´ÏŽ',0),(590363,16367,'he','××ª×” ×—×™×™×‘ ×œ×”×™×•×ª ×ž×¤×§×— ×›×“×™ ×œ×’×©×ª ×œ×“×£ ×–×”',0),(590364,16368,'he','×¢×‘×•×“×” ××™× ×• ×ž×¡×•×ž×Ÿ ×›×ž×•×›×Ÿ Zlien',0),(590365,16369,'he','×“×•××¨ ×©× ×©×œ×— ×¢× ×©×’×™××•×ª',0),(590366,16370,'he','×©×•× ×“×‘×¨ ×œ× × ×‘×—×¨',0),(590367,16371,'he','×™×‘×•× ×¤×¨×•×Ÿ ×œ××—×¨ X ×™×ž×™×',0),(590368,16372,'he','×”×ª×©×œ×•× ×ª×œ×•×™ ×•×¢×•×ž×“',0),(590369,16373,'he','×ª×©×œ×•×ž×™× ×ž×ž×ª×™× ×”',0),(590370,16374,'he','×—×©×‘×•× ×™×ª ×©×¤×¨×¢×•× ×Ÿ ×—×œ×£',0),(590371,16375,'he','×—×©×‘×•× ×™×•×ª ×©×¤×¨×¢×•× ×Ÿ ×—×œ×£',0),(590372,16376,'he','×—×©×‘×•× ×™×ª ×ž×ž×ª×™× ×”',0),(590373,16377,'he','×—×©×‘×•× ×™×•×ª ×ž×ž×ª×™× ×•×ª',0),(590374,16378,'he','× ×§×” ×—×™×¤×•×©',0),(590375,16379,'he','×”×¡×ª×¨ ××ª ×”×›×¨×˜×™×¡×™×™×”',0),(590376,16380,'he','×”×›×¨×˜×™×¡×™×” ×”×¦×’×ª',0),(590377,16381,'he','×¢×“×›×•×Ÿ ×ž×¦×‘ ×”×—×¡×™×ž×” 3dcart ×‘××•×¤×Ÿ ××•×˜×•×ž×˜×™',0),(590378,16382,'he','×ª×©×•×‘×” ×œ×‘×§×©×” ×ž×•×§×“×',0),(590379,16383,'he','×”×¦×’ ×”×¢×¨×•×ª ×¤× ×™×ž×™×•×ª',0),(590380,16384,'he','Zlien ×ž×•×›×Ÿ',0),(590381,16385,'he','×œ×”×’×“×™×¨ ×©×',0),(590382,16386,'he','×œ×¢×¨×•×š ×”×–×ž× ×ª ×©×™×¨×•×ª',0),(590383,16387,'he','×¢×¨×™×›×ª ×¤×¨×™×˜',0),(590384,16388,'he','×‘×“×™×§×•×ª ×¤×” ×ž×©×”×•',0),(590385,16367,'hi','à¤†à¤ª à¤‡à¤¸ à¤ªà¥ƒà¤·à¥à¤  à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤ªà¤°à¥à¤¯à¤µà¥‡à¤•à¥à¤·à¤• à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(590386,16368,'hi','Zlien à¤¤à¥ˆà¤¯à¤¾à¤° à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤šà¤¿à¤¹à¥à¤¨à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤•à¤¾à¤®',0),(590387,16369,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤­à¥‡à¤œà¥€ à¤—à¤ˆ à¤®à¥‡à¤²',0),(590388,16370,'hi','à¤•à¥à¤› à¤šà¤¯à¤¨à¤¿à¤¤',0),(590389,16371,'hi','X à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤†à¤¯à¤¾à¤¤ à¤›à¤à¤Ÿà¤¾à¤ˆ',0),(590390,16372,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(590391,16373,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(590392,16374,'hi','à¤…à¤¤à¤¿à¤¦à¥‡à¤¯ à¤šà¤¾à¤²à¤¾à¤¨',0),(590393,16375,'hi','à¤…à¤¤à¤¿à¤¦à¥‡à¤¯ à¤šà¤¾à¤²à¤¾à¤¨',0),(590394,16376,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(590395,16377,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤šà¤¾à¤²à¤¾à¤¨',0),(590396,16378,'hi','à¤–à¥‹à¤œ à¤¸à¤¾à¤«à¤¼ à¤•à¤°à¥‡à¤‚',0),(590397,16379,'hi','à¤Ÿà¥ˆà¤¬ à¤›à¥à¤ªà¤¾à¤à¤',0),(590398,16380,'hi','à¤Ÿà¥ˆà¤¬ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(590399,16381,'hi','3dcart à¤¹à¥‹à¤²à¥à¤¡ à¤¸à¥à¤¥à¤¿à¤¤à¤¿ à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(590400,16382,'hi','Prelim à¤…à¤¨à¥à¤°à¥‹à¤§ à¤‰à¤¤à¥à¤¤à¤° à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(590401,16383,'hi','à¤†à¤‚à¤¤à¤°à¤¿à¤• à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(590402,16384,'hi','Zlien à¤•à¥‡ à¤²à¤¿à¤ à¤¤à¥ˆà¤¯à¤¾à¤°',0),(590403,16385,'hi','à¤¨à¤¾à¤® à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(590404,16386,'hi','à¤¸à¥‡à¤µà¤¾ à¤•à¥à¤°à¤® à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(590405,16387,'hi','à¤†à¤‡à¤Ÿà¤® à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(590406,16388,'hi','à¤¯à¤¹à¤¾à¤ à¤•à¥à¤› à¤ªà¤°à¥€à¤•à¥à¤·à¤£',0),(590407,16367,'ba','Anda harus menjadi seorang Supervisor untuk mengakses halaman ini',0),(590408,16368,'ba','Pekerjaan yang tidak ditandai sebagai siap Zlien',0),(590409,16369,'ba','E-mail yang dikirim dengan kesalahan',0),(590410,16370,'ba','Tidak ada yang dipilih',0),(590411,16371,'ba','Memangkas impor setelah X hari',0),(590412,16372,'ba','Pembayaran tertunda',0),(590413,16373,'ba','Pembayaran yang tertunda',0),(590414,16374,'ba','Jatuh tempo faktur',0),(590415,16375,'ba','Jatuh tempo faktur',0),(590416,16376,'ba','Faktur tertunda',0),(590417,16377,'ba','Faktur tertunda',0),(590418,16378,'ba','Clear Search',0),(590419,16379,'ba','Sembunyikan Tab',0),(590420,16380,'ba','Tampilkan Tab',0),(590421,16381,'ba','Memperbarui Status penahanan 3dcart secara otomatis',0),(590422,16382,'ba','Prelim permintaan membalas',0),(590423,16383,'ba','Tampilkan Catatan Internal',0),(590424,16384,'ba','Zlien siap',0),(590425,16385,'ba','Tentukan nama',0),(590426,16386,'ba','Mengedit Service Order',0),(590427,16387,'ba','Mengedit Item',0),(590428,16388,'ba','Pengujian sesuatu di sini',0),(590429,16367,'it','Ãˆ necessario essere un supervisore per accedere a questa pagina',0),(590430,16368,'it','Lavoro non contrassegnato come pronto Zlien',0),(590431,16369,'it','Posta inviata con errori',0),(590432,16370,'it','Non Ã¨ selezionato alcun',0),(590433,16371,'it','Potare le importazioni dopo X giorni',0),(590434,16372,'it','Pagamento in sospeso',0),(590435,16373,'it','Pagamenti in sospeso',0),(590436,16374,'it','Fattura scaduta',0),(590437,16375,'it','Fatture scadute',0),(590438,16376,'it','Fattura in sospeso',0),(590439,16377,'it','Fatture in sospeso',0),(590440,16378,'it','Cancella ricerca',0),(590441,16379,'it','Nascondere la scheda',0),(590442,16380,'it','Visualizza scheda',0),(590443,16381,'it','Aggiornare lo stato di sospensione 3dcart automaticamente',0),(590444,16382,'it','Risposta richiesta preliminare di',0),(590445,16383,'it','Visualizza note interne',0),(590446,16384,'it','Zlien pronto',0),(590447,16385,'it','Definire il nome',0),(590448,16386,'it','Modificare l\'ordine di servizio',0),(590449,16387,'it','Modifica voce',0),(590450,16388,'it','Prova qualcosa qui',0),(590451,16367,'jp','ã“ã®ãƒšãƒ¼ã‚¸ã«ã‚¢ã‚¯ã‚»ã‚¹ã™ã‚‹ãŸã‚ã®ç›£ç£ã‚’ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(590452,16368,'jp','Zlien æº–å‚™å®Œäº†ã¨ã—ã¦ãƒžãƒ¼ã‚¯ã•ã‚Œã¦ã„ãªã„ã‚¸ãƒ§ãƒ–',0),(590453,16369,'jp','ã‚¨ãƒ©ãƒ¼ã§é€ä¿¡ã•ã‚ŒãŸãƒ¡ãƒ¼ãƒ«',0),(590454,16370,'jp','ä½•ã‚‚é¸æŠž',0),(590455,16371,'jp','X æ—¥å¾Œãƒ—ãƒ«ãƒ¼ãƒ³è¼¸å…¥',0),(590456,16372,'jp','ä¿ç•™ä¸­ã®æ”¯æ‰•ã„',0),(590457,16373,'jp','ãŠæ”¯æ‰•ã„ã®ä¿ç•™',0),(590458,16374,'jp','å»¶æ»žè«‹æ±‚æ›¸',0),(590459,16375,'jp','å»¶æ»žè«‹æ±‚æ›¸',0),(590460,16376,'jp','ä¿ç•™ä¸­ã®è«‹æ±‚',0),(590461,16377,'jp','ä¿ç•™ä¸­ã®ã‚¤ãƒ³ãƒœã‚¤ã‚¹',0),(590462,16378,'jp','æ¤œç´¢ã®ã‚¯ãƒªã‚¢',0),(590463,16379,'jp','ã‚¿ãƒ–ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(590464,16380,'jp','[è¡¨ç¤º] ã‚¿ãƒ–',0),(590465,16381,'jp','3dcart ä¿ç•™ã‚¹ãƒ†ãƒ¼ã‚¿ã‚¹ã‚’è‡ªå‹•çš„ã«æ›´æ–°ã—ã¾ã™ã€‚',0),(590466,16382,'jp','ãƒªã‚¯ã‚¨ã‚¹ãƒˆè¿”ä¿¡ã«äºˆå‚™æ ¼ä»˜ã‘',0),(590467,16383,'jp','å†…éƒ¨ãƒ¡ãƒ¢ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(590468,16384,'jp','Zlien å¯¾å¿œ',0),(590469,16385,'jp','åå‰ã‚’å®šç¾©ã—ã¾ã™ã€‚',0),(590470,16386,'jp','ã‚µãƒ¼ãƒ“ã‚¹ã®é †åºã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(590471,16387,'jp','é …ç›®ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(590472,16388,'jp','ã“ã“ã§ä½•ã‹ã‚’ãƒ†ã‚¹ãƒˆ',0),(590473,16367,'ko','ì´ íŽ˜ì´ì§€ì— ì•¡ì„¸ìŠ¤ í•˜ë ¤ë©´ ê´€ë¦¬ìž ì—¬ì•¼ í•©ë‹ˆë‹¤.',0),(590474,16368,'ko','Zlien ì¤€ë¹„ë¡œ í‘œì‹œ ë˜ì§€ ì•Šì€ ìž‘ì—…',0),(590475,16369,'ko','ì˜¤ë¥˜ì™€ í•¨ê»˜ ë³´ë‚¸ ë©”ì¼',0),(590476,16370,'ko','ì•„ë¬´ê²ƒë„ ì„ íƒ',0),(590477,16371,'ko','X ì¼ í›„ ìˆ˜ìž…ì„ ê°€ì§€ ì¹˜ê¸°',0),(590478,16372,'ko','ë³´ë¥˜ ì¤‘ì¸ ì§€ë¶ˆ',0),(590479,16373,'ko','ë³´ë¥˜ ì¤‘ì¸ ì§€ë¶ˆ',0),(590480,16374,'ko','ê¸°í•œì´ ì§€ë‚œ ì†¡ìž¥',0),(590481,16375,'ko','ê¸°í•œì´ ì§€ë‚œ ì†¡ìž¥',0),(590482,16376,'ko','ë³´ë¥˜ ì¤‘ì¸ ì²­êµ¬ì„œ',0),(590483,16377,'ko','ë³´ë¥˜ ì¤‘ì¸ ì²­êµ¬ì„œ',0),(590484,16378,'ko','ì§€ìš°ê¸° ê²€ìƒ‰',0),(590485,16379,'ko','íƒ­ ìˆ¨ê¸°ê¸°',0),(590486,16380,'ko','íƒ­ í‘œì‹œ',0),(590487,16381,'ko','3dcart ë³´ë¥˜ ìƒíƒœë¥¼ ìžë™ìœ¼ë¡œ ì—…ë°ì´íŠ¸',0),(590488,16382,'ko','ì˜ˆì„  ìš”ì²­ íšŒì‹ ',0),(590489,16383,'ko','ë‚´ë¶€ ë…¸íŠ¸ ë³´ê¸°',0),(590490,16384,'ko','Zlien ì¤€ë¹„',0),(590491,16385,'ko','ì´ë¦„ ì •ì˜',0),(590492,16386,'ko','íŽ¸ì§‘ ì„œë¹„ìŠ¤ ìˆœì„œ',0),(590493,16387,'ko','í•­ëª© íŽ¸ì§‘',0),(590494,16388,'ko','ì—¬ê¸°ì— ë­”ê°€ í…ŒìŠ¤íŠ¸',0),(590495,16367,'ms','Anda mesti menjadi seorang penyelia untuk mengakses Laman ini',0),(590496,16368,'ms','Pekerjaan yang tidak ditandakan sebagai sedia Zlien',0),(590497,16369,'ms','Mel dihantar dengan ralat',0),(590498,16370,'ms','Apa-apa yang dipilih',0),(590499,16371,'ms','Menutuh import selepas X hari',0),(590500,16372,'ms','Pembayaran yang belum selesai',0),(590501,16373,'ms','Pembayaran yang belum selesai',0),(590502,16374,'ms','Invois yang tertunggak',0),(590503,16375,'ms','Invois yang tertunggak',0),(590504,16376,'ms','Menunggu invois',0),(590505,16377,'ms','Menunggu invois',0),(590506,16378,'ms','Kosongkan gelintar',0),(590507,16379,'ms','Sembunyi Tab',0),(590508,16380,'ms','Tab Papar',0),(590509,16381,'ms','3dcart memegang Status kemas kini secara automatik',0),(590510,16382,'ms','Prelim permintaan membalas',0),(590511,16383,'ms','Menunjukkan Nota dalaman',0),(590512,16384,'ms','Siap Zlien',0),(590513,16385,'ms','Tentukan nama',0),(590514,16386,'ms','Edit Perkhidmatan Pesanan',0),(590515,16387,'ms','Mengedit Item',0),(590516,16388,'ms','Menguji sesuatu di sini',0),(590517,16367,'no','Du mÃ¥ vÃ¦re en veileder til denne siden',0),(590518,16368,'no','Jobben ikke merket som Zlien klar',0),(590519,16369,'no','Post sendt med feil',0),(590520,16370,'no','Ingenting valgt',0),(590521,16371,'no','BeskjÃ¦re import etter X dager',0),(590522,16372,'no','Ventende betaling',0),(590523,16373,'no','UtestÃ¥ende betalinger',0),(590524,16374,'no','Forfalte faktura',0),(590525,16375,'no','Forfalte fakturaer',0),(590526,16376,'no','Ventende faktura',0),(590527,16377,'no','UtestÃ¥ende fakturaer',0),(590528,16378,'no','Nullstill sÃ¸k',0),(590529,16379,'no','Skjul kategorien',0),(590530,16380,'no','Vis kategorien',0),(590531,16381,'no','Oppdatere 3dcart tak statusen automatisk',0),(590532,16382,'no','Prelim forespÃ¸rsel svar',0),(590533,16383,'no','Vis interne notater',0),(590534,16384,'no','Zlien klar',0),(590535,16385,'no','Definere navn',0),(590536,16386,'no','Redigere serviceordre',0),(590537,16387,'no','Redigere elementet',0),(590538,16388,'no','Teste noe her',0),(590539,16367,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ø³Ø±Ù¾Ø±Ø³Øª Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø§ÛŒÙ† ØµÙØ­Ù‡',0),(590540,16368,'pr','Ú©Ø§Ø± Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ø¢Ù…Ø§Ø¯Ù‡ Zlien Ù…Ø´Ø®Øµ',0),(590541,16369,'pr','Ø§ÛŒÙ…ÛŒÙ„ Ù‡Ø§ÛŒ Ø®Ø·Ø§',0),(590542,16370,'pr','Ù‡ÛŒÚ† Ú†ÛŒØ² Ø§Ù†ØªØ®Ø§Ø¨ Ø´Ø¯Ù‡',0),(590543,16371,'pr','Ø¢Ù„Ùˆ ÙˆØ§Ø±Ø¯Ø§Øª Ù¾Ø³ Ø§Ø² X Ø±ÙˆØ²',0),(590544,16372,'pr','Ø§Ù†ØªØ¸Ø§Ø± Ù¾Ø±Ø¯Ø§Ø®Øª',0),(590545,16373,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ù‡Ø§ÛŒ Ø§Ù†ØªØ¸Ø§Ø±',0),(590546,16374,'pr','ÙØ§Ú©ØªÙˆØ± Ø³Ø± Ø±Ø³ÛŒØ¯Ù‡',0),(590547,16375,'pr','ÙØ§Ú©ØªÙˆØ±Ù‡Ø§ Ø³Ø± Ø±Ø³ÛŒØ¯Ù‡',0),(590548,16376,'pr','ÙØ§Ú©ØªÙˆØ± Ù‡Ø§ÛŒ Ø§Ù†ØªØ¸Ø§Ø±',0),(590549,16377,'pr','Ø§Ù†ØªØ¸Ø§Ø± ÙØ§Ú©ØªÙˆØ±Ù‡Ø§',0),(590550,16378,'pr','Ù¾Ø§Ú© Ú©Ø±Ø¯Ù† Ø¬Ø³ØªØ¬Ùˆ',0),(590551,16379,'pr','Ù…Ø®ÙÛŒ Ú©Ø±Ø¯Ù† Ø²Ø¨Ø§Ù†Ù‡',0),(590552,16380,'pr','Ù†Ù…Ø§ÛŒØ´ Ø¨Ø±Ú¯Ù‡',0),(590553,16381,'pr','3dcart Ù†Ú¯Ù‡ ÙˆØ¶Ø¹ÛŒØª Ø¨Ù‡ ØµÙˆØ±Øª Ø®ÙˆØ¯Ú©Ø§Ø± Ø¨Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(590554,16382,'pr','Ù¾Ø§Ø³Ø® Ø¯Ø±Ø®ÙˆØ§Ø³Øª prelim',0),(590555,16383,'pr','Ù†Ø´Ø§Ù† Ø¯Ø§Ø¯Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ø¯Ø§Ø®Ù„ÛŒ',0),(590556,16384,'pr','Zlien Ø¢Ù…Ø§Ø¯Ù‡',0),(590557,16385,'pr','ØªØ¹Ø±ÛŒÙ Ù†Ø§Ù…',0),(590558,16386,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø¯Ù…Ø§Øª ÙˆÛŒØ±Ø§ÛŒØ´',0),(590559,16387,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù…ÙˆØ±Ø¯',0),(590560,16388,'pr','Ú†ÛŒØ²ÛŒ Ø¯Ø± Ø§ÛŒÙ†Ø¬Ø§ ØªØ³Øª',0),(590561,16367,'pl','Musi byÄ‡ przeÅ‚oÅ¼ony dostÄ™pu do tej strony',0),(590562,16368,'pl','Zadanie nie jest oznaczony jako gotowe Zlien',0),(590563,16369,'pl','Poczta wysyÅ‚ana z bÅ‚Ä™dami',0),(590564,16370,'pl','Nic nie wybrano',0),(590565,16371,'pl','Prune przywozu po X dni',0),(590566,16372,'pl','OczekujÄ…ca pÅ‚atnoÅ›Ä‡',0),(590567,16373,'pl','OczekujÄ…ce pÅ‚atnoÅ›ci',0),(590568,16374,'pl','Przeterminowane faktury',0),(590569,16375,'pl','ZalegÅ‚ych faktur',0),(590570,16376,'pl','OczekujÄ…ce faktury',0),(590571,16377,'pl','OczekujÄ…ce faktury',0),(590572,16378,'pl','WyczyÅ›Ä‡ wyszukiwanie',0),(590573,16379,'pl','Ukryj kartÄ™',0),(590574,16380,'pl','PokaÅ¼ kartÄ™',0),(590575,16381,'pl','Automatycznie zaktualizowaÄ‡ 3dcart posiadajÄ… Status',0),(590576,16382,'pl','Prelim Å¼Ä…danie odpowiedÅº do',0),(590577,16383,'pl','PokaÅ¼ wewnÄ™trzne notatki',0),(590578,16384,'pl','Zlien gotowy',0),(590579,16385,'pl','Zdefiniuj nazwÄ™',0),(590580,16386,'pl','Edycja zlecenia serwisowego',0),(590581,16387,'pl','Edycja elementu',0),(590582,16388,'pl','CoÅ› tutaj testowania',0),(590583,16367,'pt','VocÃª deve ser um Supervisor para acessar esta pÃ¡gina',0),(590584,16368,'pt','NÃ£o Marcado como pronto Zlien de trabalho',0),(590585,16369,'pt','Email enviado com erros',0),(590586,16370,'pt','Nada selecionado',0),(590587,16371,'pt','Podar as importaÃ§Ãµes apÃ³s X dias',0),(590588,16372,'pt','Pagamento pendente',0),(590589,16373,'pt','Pagamentos pendentes',0),(590590,16374,'pt','Fatura em atraso',0),(590591,16375,'pt','Faturas em atraso',0),(590592,16376,'pt','Faturas pendentes',0),(590593,16377,'pt','Faturas pendentes',0),(590594,16378,'pt','Limpar pesquisa',0),(590595,16379,'pt','Ocultar guia',0),(590596,16380,'pt','Mostrar a guia',0),(590597,16381,'pt','Atualizar automaticamente o Status de espera 3dcart',0),(590598,16382,'pt','Resposta de pedido preliminar para',0),(590599,16383,'pt','Mostrar notas internas',0),(590600,16384,'pt','Zlien pronto',0),(590601,16385,'pt','Definir nome',0),(590602,16386,'pt','Editar a ordem de serviÃ§o',0),(590603,16387,'pt','Editar Item',0),(590604,16388,'pt','Testando alguma coisa aqui',0),(590605,16367,'ro','Trebuie sÄƒ aveÅ£i un supraveghetor pentru a accesa aceastÄƒ paginÄƒ',0),(590606,16368,'ro','Job nu sunt marcate ca gata Zlien',0),(590607,16369,'ro','Mail trimis cu erori',0),(590608,16370,'ro','Nimic selectat',0),(590609,16371,'ro','Importurile de prune dupÄƒ X zile',0),(590610,16372,'ro','PlatÄƒ Ã®n aÅŸteptare',0),(590611,16373,'ro','PlÄƒÅ£ile Ã®n aÅŸteptare',0),(590612,16374,'ro','Facturi restante',0),(590613,16375,'ro','Facturi restante',0),(590614,16376,'ro','Factura Ã®n aÅŸteptare',0),(590615,16377,'ro','Facturi Ã®n aÅŸteptare',0),(590616,16378,'ro','CÄƒutaÅ£i clar',0),(590617,16379,'ro','AscundeÅ£i fila',0),(590618,16380,'ro','AratÄƒ Tab',0),(590619,16381,'ro','Actualizare 3dcart deÅ£ine statut automat',0),(590620,16382,'ro','RÄƒspuns cerere preliminare',0),(590621,16383,'ro','AratÄƒ Note interne',0),(590622,16384,'ro','Gata Zlien',0),(590623,16385,'ro','Defini numele',0),(590624,16386,'ro','EditaÅ£i comanda de Service',0),(590625,16387,'ro','Editare element',0),(590626,16388,'ro','Testarea ceva aici',0),(590627,16367,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð±Ñ‹Ñ‚ÑŒ Ñ€ÑƒÐºÐ¾Ð²Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÐµÐ¼ Ð´Ð»Ñ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð° Ðº ÑÑ‚Ð¾Ð¹ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ',0),(590628,16368,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð°, Ð½Ðµ Ð¿Ð¾Ð¼ÐµÑ‡ÐµÐ½Ñ‹ ÐºÐ°Ðº Ð³Ð¾Ñ‚Ð¾Ð²Ñ‹Ðµ Zlien',0),(590629,16369,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð°, Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÑÐµÐ¼Ð°Ñ Ñ Ð¾ÑˆÐ¸Ð±ÐºÐ°Ð¼Ð¸',0),(590630,16370,'ru','ÐÐ¸Ñ‡ÐµÐ³Ð¾ Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð¾',0),(590631,16371,'ru','ÐŸÐ¾Ð´Ñ€ÐµÐ¶ÑŒÑ‚Ðµ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð¾ÑÐ»Ðµ X Ð´Ð½ÐµÐ¹',0),(590632,16372,'ru','ÐžÑ‚Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ð¹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶',0),(590633,16373,'ru','ÐžÑ‚Ð»Ð¾Ð¶ÐµÐ½Ð½Ñ‹Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(590634,16374,'ru','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(590635,16375,'ru','ÐŸÑ€Ð¾ÑÑ€Ð¾Ñ‡ÐµÐ½Ð½Ñ‹Ðµ ÑÑ‡ÐµÑ‚Ð°',0),(590636,16376,'ru','Ð”Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(590637,16377,'ru','ÐžÐ¶Ð¸Ð´Ð°ÑŽÑ‰Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð°-Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñ‹',0),(590638,16378,'ru','ÐžÑ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ Ð¿Ð¾Ð¸ÑÐº',0),(590639,16379,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð²ÐºÐ»Ð°Ð´ÐºÑƒ',0),(590640,16380,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð²ÐºÐ»Ð°Ð´ÐºÑƒ',0),(590641,16381,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¾Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ 3dcart ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(590642,16382,'ru','ÐŸÑ€ÐµÐ´Ð²Ð°Ñ€Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ð¾Ñ‚Ð²ÐµÑ‚Ð¸Ñ‚ÑŒ',0),(590643,16383,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ð²Ð½ÑƒÑ‚Ñ€ÐµÐ½Ð½Ð¸Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(590644,16384,'ru','Zlien Ð³Ð¾Ñ‚Ð¾Ð²',0),(590645,16385,'ru','ÐžÐ¿Ñ€ÐµÐ´ÐµÐ»Ð¸Ñ‚ÑŒ Ð¸Ð¼Ñ',0),(590646,16386,'ru','Ð˜Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ ÑÐµÑ€Ð²Ð¸ÑÐ½Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(590647,16387,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚',0),(590648,16388,'ru','Ð¢ÐµÑÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð·Ð´ÐµÑÑŒ Ñ‡Ñ‚Ð¾-Ñ‚Ð¾',0),(590649,16367,'sr','Ð¢Ð¸ Ð¼Ð¾Ñ€Ð° Ð´Ð° ÑÐ¸ ÑÑƒÐ¿ÐµÑ€Ð²Ð¸Ð·Ð¾Ñ€ Ð·Ð° Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð¾Ð²Ð¾Ñ˜ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(590650,16368,'sr','ÐŸÐ¾ÑÐ°Ð¾ Ð½ÐµÑ›Ðµ Ð±Ð¸Ñ‚Ð¸ Ð¾Ð·Ð½Ð°Ñ‡ÐµÐ½Ð° ÐºÐ°Ð¾ Ð—Ð»Ð¸ÐµÐ½ ÑÐ¿Ñ€ÐµÐ¼Ð°Ð½',0),(590651,16369,'sr','ÐŸÐ¾ÑˆÑ‚Ð° Ð¿Ð¾ÑÐ»Ð°Ñ‚Ð° ÑÐ° Ð³Ñ€ÐµÑˆÐºÐ°Ð¼Ð°',0),(590652,16370,'sr','ÐÐ¸ÑˆÑ‚Ð° Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð°',0),(590653,16371,'sr','Ð¡Ñ™Ð¸Ð²Ð° ÑƒÐ²Ð¾Ð·Ð° Ð½Ð°ÐºÐ¾Ð½ X Ð´Ð°Ð½Ð°',0),(590654,16372,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(590655,16373,'sr','Ð£Ð¿Ð»Ð°Ñ‚Ðµ Ð½Ð° Ñ‡ÐµÐºÐ°ÑšÑƒ',0),(590656,16374,'sr','Ð”Ð¾ÑÐ¿ÐµÐ»Ð¸Ð¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(590657,16375,'sr','Ð”Ð¾ÑÐ¿ÐµÐ»Ð¸Ð¼ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ð¼Ð°',0),(590658,16376,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(590659,16377,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(590660,16378,'sr','ÐŸÑ€ÐµÑ‚Ñ€Ð°Ð³Ð°',0),(590661,16379,'sr','Ð¡ÐºÑ€Ð¸Ð²Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(590662,16380,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð·Ð¸Ð²Ð°ÑšÐµ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð°',0),(590663,16381,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ˜ Ð¡Ñ‚Ð°Ñ‚ÑƒÑ Ð·Ð°Ð´Ñ€ÑˆÐºÐµ 3Ð´Ñ†Ð°Ñ€Ñ‚',0),(590664,16382,'sr','Ð£Ð²Ð¾Ð´Ð½Ðµ Ð±Ð¾Ñ€Ð±Ðµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð¾Ð´Ð³Ð¾Ð²Ð¾Ñ€',0),(590665,16383,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ð¸Ð½Ñ‚ÐµÑ€Ð½Ðµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(590666,16384,'sr','Ð—Ð»Ð¸ÐµÐ½ ÑÐ¿Ñ€ÐµÐ¼Ð°Ð½',0),(590667,16385,'sr','Ð”ÐµÑ„Ð¸Ð½Ð¸ÑˆÐµ Ð¸Ð¼Ðµ',0),(590668,16386,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð·Ð° ÑÐµÑ€Ð²Ð¸Ñ',0),(590669,16387,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐµ',0),(590670,16388,'sr','Ð¢ÐµÑÑ‚Ð¸Ñ€Ð°ÑšÐµ Ð½ÐµÑˆÑ‚Ð¾ Ð¾Ð²Ð´Ðµ',0),(590671,16367,'si','Nadzornik za dostop do te strani, morate biti',0),(590672,16368,'si','Delo, ki niso oznaÄene kot Zlien Ready',0),(590673,16369,'si','PoÅ¡ta, poslana z napakami',0),(590674,16370,'si','Izbrano niÄ',0),(590675,16371,'si','OÃ„Ã§isti uvoz po X dneh',0),(590676,16372,'si','ÄŒakajoÄa plaÄila',0),(590677,16373,'si','ÄŒakajoÄa plaÄila',0),(590678,16374,'si','Zapadli raÄun',0),(590679,16375,'si','Zapadle raÄune',0),(590680,16376,'si','NereÅ¡en raÄun',0),(590681,16377,'si','ÄŒakajoÄe raÄunov',0),(590682,16378,'si','Zapri iskanje',0),(590683,16379,'si','Skriti zavihek',0),(590684,16380,'si','PokaÅ¾i kartico',0),(590685,16381,'si','Samodejno posodabljanje 3dcart imajo Status',0),(590686,16382,'si','Predhodnega zahtevo odgovoriti',0),(590687,16383,'si','Show notranji opombe',0),(590688,16384,'si','Zlien Ready',0),(590689,16385,'si','DoloÄite ime',0),(590690,16386,'si','Urejanje servisni nalog',0),(590691,16387,'si','Urejanje elementa',0),(590692,16388,'si','Testiranje nekaj tukaj',0),(590693,16367,'es','Debe ser un Supervisor para acceder a esta pÃ¡gina',0),(590694,16368,'es','Trabajo no marcado como Zlien',0),(590695,16369,'es','Correo enviado con errores',0),(590696,16370,'es','Nada seleccionado',0),(590697,16371,'es','Podar las importaciones despuÃ©s de X dÃ­as',0),(590698,16372,'es','Pago pendiente',0),(590699,16373,'es','Pagos pendientes',0),(590700,16374,'es','Factura vencida',0),(590701,16375,'es','Facturas vencidas',0),(590702,16376,'es','Factura pendiente',0),(590703,16377,'es','Facturas pendientes',0),(590704,16378,'es','Borrar bÃºsqueda',0),(590705,16379,'es','Ocultar ficha',0),(590706,16380,'es','Ver ficha',0),(590707,16381,'es','Actualizar estado de asimiento 3dcart automÃ¡ticamente',0),(590708,16382,'es','Prelim solicitud respuesta a',0),(590709,16383,'es','Mostrar notas internas',0),(590710,16384,'es','Zlien listo',0),(590711,16385,'es','Definir nombre',0),(590712,16386,'es','Editar orden de servicio',0),(590713,16387,'es','Editar elemento',0),(590714,16388,'es','Prueba algo aquÃ­',0),(590715,16367,'sv','Du mÃ¥ste vara handledare Ã¥t sidan',0),(590716,16368,'sv','Jobb som inte markerats som klar fÃ¶r Zlien',0),(590717,16369,'sv','Mail skickat med fel',0),(590718,16370,'sv','Inget valt',0),(590719,16371,'sv','BeskÃ¤ra import efter X dagar',0),(590720,16372,'sv','VÃ¤ntande betalning',0),(590721,16373,'sv','VÃ¤ntande betalningar',0),(590722,16374,'sv','FÃ¶rsenad faktura',0),(590723,16375,'sv','FÃ¶rfallna fakturor',0),(590724,16376,'sv','PÃ¥gÃ¥ende faktura',0),(590725,16377,'sv','PÃ¥gÃ¥ende fakturor',0),(590726,16378,'sv','Rensa sÃ¶kning',0),(590727,16379,'sv','DÃ¶lj fliken',0),(590728,16380,'sv','Visa fliken',0),(590729,16381,'sv','Uppdatera 3dcart hÃ¥ller Status automatiskt',0),(590730,16382,'sv','Prelim begÃ¤ran svar',0),(590731,16383,'sv','Visa interna anteckningar',0),(590732,16384,'sv','Zlien klar',0),(590733,16385,'sv','Definiera namn',0),(590734,16386,'sv','Redigera serviceorder',0),(590735,16387,'sv','Redigera objekt',0),(590736,16388,'sv','Testa nÃ¥got hÃ¤r',0),(590737,16367,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸›à¹‡à¸™à¸œà¸¹à¹‰à¸„à¸§à¸šà¸„à¸¸à¸¡à¸à¸²à¸£à¹€à¸‚à¹‰à¸²à¸–à¸¶à¸‡à¸«à¸™à¹‰à¸²à¸™à¸µà¹‰',0),(590738,16368,'th','à¸‡à¸²à¸™à¹„à¸¡à¹ˆà¸—à¸³à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸›à¹‡à¸™ Zlien à¸žà¸£à¹‰à¸­à¸¡',0),(590739,16369,'th','à¸ˆà¸”à¸«à¸¡à¸²à¸¢à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡ à¸¡à¸µà¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(590740,16370,'th','à¸­à¸°à¹„à¸£à¹€à¸¥à¸·à¸­à¸',0),(590741,16371,'th','à¸žà¸£à¸¸à¸™à¸™à¸³à¹€à¸‚à¹‰à¸²à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸ X à¸§à¸±à¸™',0),(590742,16372,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(590743,16373,'th','à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(590744,16374,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¹€à¸à¸´à¸™à¸à¸³à¸«à¸™à¸”',0),(590745,16375,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™',0),(590746,16376,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(590747,16377,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(590748,16378,'th','à¸¥à¹‰à¸²à¸‡à¸à¸²à¸£à¸„à¹‰à¸™à¸«à¸²',0),(590749,16379,'th','à¸‹à¹ˆà¸­à¸™à¹à¸—à¹‡à¸š',0),(590750,16380,'th','à¹à¸ªà¸”à¸‡à¹à¸—à¹‡à¸š',0),(590751,16381,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸–à¸²à¸™à¸°à¸£à¸°à¸‡à¸±à¸š 3dcart à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(590752,16382,'th','à¸•à¸­à¸šà¸à¸¥à¸±à¸šà¸„à¸³à¸‚à¸­ prelim',0),(590753,16383,'th','à¹à¸ªà¸”à¸‡à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¸ à¸²à¸¢à¹ƒà¸™',0),(590754,16384,'th','à¸žà¸£à¹‰à¸­à¸¡ Zlien',0),(590755,16385,'th','à¸à¸³à¸«à¸™à¸”à¸Šà¸·à¹ˆà¸­',0),(590756,16386,'th','à¹à¸à¹‰à¹„à¸‚à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸šà¸£à¸´à¸à¸²à¸£',0),(590757,16387,'th','à¹à¸à¹‰à¹„à¸‚à¸£à¸²à¸¢à¸à¸²à¸£',0),(590758,16388,'th','à¸à¸²à¸£à¸—à¸”à¸ªà¸­à¸šà¸šà¸²à¸‡à¸ªà¸´à¹ˆà¸‡à¸šà¸²à¸‡à¸­à¸¢à¹ˆà¸²à¸‡à¸—à¸µà¹ˆà¸™à¸µà¹ˆ',0),(590759,16367,'tr','Bu sayfaya eriÅŸmek iÃ§in bir yÃ¶netici olmanÄ±z gerekir',0),(590760,16368,'tr','Zlien hazÄ±r olarak iÅŸaretlenmemiÅŸ iÅŸ',0),(590761,16369,'tr','HatalarÄ± ile gÃ¶nderilen posta',0),(590762,16370,'tr','HiÃ§bir ÅŸey seÃ§ili',0),(590763,16371,'tr','X gÃ¼n sonra ithalat kuru erik',0),(590764,16372,'tr','Bekleyen Ã¶deme',0),(590765,16373,'tr','Bekleyen Ã¶demeler',0),(590766,16374,'tr','GecikmiÅŸ fatura',0),(590767,16375,'tr','Vadesi geÃ§miÅŸ faturalar',0),(590768,16376,'tr','Bekleyen fatura',0),(590769,16377,'tr','Bekleyen faturalarÄ±',0),(590770,16378,'tr','AramayÄ± Temizle',0),(590771,16379,'tr','Sekmesini gizle',0),(590772,16380,'tr','Sekmesini gÃ¶rÃ¼ntÃ¼leme',0),(590773,16381,'tr','3dcart tutun durumunu otomatik olarak gÃ¼ncelleÅŸtir',0),(590774,16382,'tr','Prelim istek yanÄ±t iÃ§in',0),(590775,16383,'tr','Show iÃ§ notlar',0),(590776,16384,'tr','Zlien hazÄ±r',0),(590777,16385,'tr','Ad tanÄ±mlama',0),(590778,16386,'tr','Servis sipariÅŸi gir',0),(590779,16387,'tr','Ã–ÄŸeyi DÃ¼zenle',0),(590780,16388,'tr','Burada bir ÅŸey test',0),(590781,16367,'ur','Ø¢Ù¾ Ø§Ø³ ØµÙØ­Û ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ú©Û’ Ù„ÛŒÛ’ Ø§ÛŒÚ© Ø³Ù¾Ø±ÙˆØ§Ø¦Ø²Ø± ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(590782,16368,'ur','Ø²Ù„ÛŒÙ† Ú©Û’ Ù„Ø¦Û’ ØªÛŒØ§Ø± Ú©Û’ Ø·ÙˆØ± Ù¾Ø± Ù†Ø´Ø§Ù† Ø²Ø¯ Ù†ÛÛŒÚº Ú©Ø§Ù…',0),(590783,16369,'ur','Ù†Ù‚Ø§Ø¦Øµ Ú©Û’ Ø³Ø§ØªÚ¾ Ø¨Ú¾ÛŒØ¬Û’ Ú¯Ø¦Û’ Ù…ÛŒÙ„',0),(590784,16370,'ur','Ú©Ú†Ú¾ Ù…Ù†ØªØ®Ø¨',0),(590785,16371,'ur','Ø³Ø¬Ù†Ø§ Ø¨Ø¹Ø¯ Ø¯Ø±Ø¢Ù…Ø¯Ø§Øª Ø¯Ù† X',0),(590786,16372,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(590787,16373,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(590788,16374,'ur','Ù…ÙˆØ®Ø± Ø§Ù†ÙˆØ§Ø¦Ø³',0),(590789,16375,'ur','Ù…ÙˆØ®Ø± ÙˆØ¨Ø¬Ù„ÛŒ',0),(590790,16376,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ Ø§Ù†ÙˆØ§Ø¦Ø³',0),(590791,16377,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ ÙˆØ¨Ø¬Ù„ÛŒ',0),(590792,16378,'ur','ØªÙ„Ø§Ø´ Ú©Ùˆ ØµØ§Ù Ú©Ø±',0),(590793,16379,'ur','Ø¬Ø¯ÙˆÙ„ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(590794,16380,'ur','Ø¬Ø¯ÙˆÙ„ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(590795,16381,'ur','3dcart ÛÙˆÙ„Úˆ Ø­Ø§Ù„Øª Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±ÛŒÚº',0),(590796,16382,'ur','Ù¾Ø±ÛŒÙ„Ø§Ù… Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ùˆ Ø¬ÙˆØ§Ø¨ Ø¯ÛŒÚº',0),(590797,16383,'ur','Ø§Ù†Ø¯Ø±ÙˆÙ†ÛŒ Ù†ÙˆÙ¹ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(590798,16384,'ur','Ø²Ù„ÛŒÙ† ØªÛŒØ§Ø±',0),(590799,16385,'ur','Ù†Ø§Ù… ÙˆØ§Ø¶Ø­ Ú©Ø±ÛŒÚº',0),(590800,16386,'ur','Ø®Ø¯Ù…Øª ØªØ±ØªÛŒØ¨ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(590801,16387,'ur','Ø´Û’ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ†',0),(590802,16388,'ur','ÛŒÛØ§Úº Ú©Ú†Ú¾ Ù¹ÛŒØ³Ù¹Ù†Ú¯',0),(590803,16367,'vi','Báº¡n pháº£i cÃ³ má»™t giÃ¡m sÃ¡t viÃªn Ä‘á»ƒ truy cáº­p vÃ o trang nÃ y',0),(590804,16368,'vi','CÃ´ng viá»‡c khÃ´ng Ä‘Æ°á»£c Ä‘Ã¡nh dáº¥u lÃ  sáºµn sÃ ng Zlien',0),(590805,16369,'vi','ThÆ° gá»­i lá»—i',0),(590806,16370,'vi','KhÃ´ng cÃ³ gÃ¬ Ä‘Æ°á»£c chá»n',0),(590807,16371,'vi','Prune nháº­p kháº©u sau ngÃ y X',0),(590808,16372,'vi','Äang chá» xá»­ lÃ½ thanh toÃ¡n',0),(590809,16373,'vi','Khoáº£n thanh toÃ¡n Ä‘ang chá» xá»­ lÃ½',0),(590810,16374,'vi','HÃ³a Ä‘Æ¡n quÃ¡ háº¡n',0),(590811,16375,'vi','HoÃ¡ Ä‘Æ¡n quÃ¡ háº¡n',0),(590812,16376,'vi','Äang chá» xá»­ lÃ½ hÃ³a Ä‘Æ¡n',0),(590813,16377,'vi','Äang chá» xá»­ lÃ½ hÃ³a Ä‘Æ¡n',0),(590814,16378,'vi','Clear Search',0),(590815,16379,'vi','áº¨n Tab',0),(590816,16380,'vi','Hiá»ƒn thá»‹ Tab',0),(590817,16381,'vi','Tá»± Ä‘á»™ng Cáº­p Nháº­t 3dcart giá»¯ tÃ¬nh tráº¡ng',0),(590818,16382,'vi','Tráº£ lá»i yÃªu cáº§u prelim',0),(590819,16383,'vi','Hiá»ƒn thá»‹ ghi chÃº ná»™i bá»™',0),(590820,16384,'vi','Zlien sáºµn sÃ ng',0),(590821,16385,'vi','XÃ¡c Ä‘á»‹nh tÃªn',0),(590822,16386,'vi','Chá»‰nh sá»­a Ä‘Æ¡n Ä‘áº·t hÃ ng dá»‹ch vá»¥',0),(590823,16387,'vi','Chá»‰nh sá»­a má»¥c',0),(590824,16388,'vi','Kiá»ƒm tra má»™t cÃ¡i gÃ¬ Ä‘Ã³ á»Ÿ Ä‘Ã¢y',0),(590825,16389,'en','License Could Not Be Verified Check Internet Access',0),(590826,16390,'en','License Terminated',0),(590827,16392,'en','Add Note',0),(590828,16398,'en','Edit Debit & Credit As One Column',0),(590829,16394,'en','Hide AP Cost Code Fields',0),(590830,16399,'en','Hide Cost Codes On Journal Entry Pages',0),(590831,16395,'en','Hide Payment Entry After POS',0),(590832,16391,'en','Job Notes',0),(590833,16397,'en','Line Date',0),(590834,16396,'en','POS Entry Saved',0),(590835,16400,'en','Recent Activity',0),(590836,16393,'en','Saving',0),(590837,16412,'en','Additional Invoice Options',0),(590838,16419,'en','Company Permissions',0),(590839,16408,'en','Disbursements Out',0),(590840,16405,'en','Entries From Prior Months',0),(590841,16413,'en','Error Retrieving Invoice',0),(590842,16409,'en','Fund',0),(590843,16411,'en','Funds To Include',0),(590844,16401,'en','Fund Details',0),(590845,16402,'en','Fund Summary',0),(590846,16404,'en','High Volume',0),(590847,16414,'en','Invoice Details',0),(590848,16415,'en','Invoice Is Paid',0),(590849,16406,'en','No Data Set',0),(590850,16403,'en','Past',0),(590851,16417,'en','Payments Added',0),(590852,16410,'en','Receipts In',0),(590853,16418,'en','Survey Email Attachment',0),(590854,16407,'en','Total Not Selected',0),(590855,16416,'en','View/Select Entries',0),(590856,16389,'af','Lisensie kon nie geverifieer word nie kontroleer Internet toegang',0),(590857,16390,'af','Lisensie beÃ«indig',0),(590858,16391,'af','Werk notas',0),(590859,16392,'af','Voeg Nota',0),(590860,16393,'af','Stoor',0),(590861,16394,'af','Versteek GP koste kode velde',0),(590862,16395,'af','Versteek betaling inskrywing na POS',0),(590863,16396,'af','POS inskrywing gestoor',0),(590864,16397,'af','Lyn datum',0),(590865,16398,'af','Redigeer debiet en krediet As een kolom',0),(590866,16399,'af','Versteek koste kodes op joernaal inskrywing bladsye',0),(590867,16400,'af','Onlangse aktiwiteit',0),(590868,16401,'af','Fonds besonderhede',0),(590869,16402,'af','Fonds opsomming',0),(590870,16403,'af','Verlede',0),(590871,16404,'af','HoÃ« Volume',0),(590872,16405,'af','Inskrywings van vooraf maande',0),(590873,16406,'af','Geen Data stel',0),(590874,16407,'af','Totaal gekies nie',0),(590875,16408,'af','Disbursements uit',0),(590876,16409,'af','Fonds',0),(590877,16410,'af','Ontvangste In',0),(590878,16411,'af','Fondse in te sluit',0),(590879,16412,'af','Bykomende faktuur opsies',0),(590880,16413,'af','Fout herwinning van faktuur',0),(590881,16414,'af','Faktuur besonderhede',0),(590882,16415,'af','Faktuur betaal word',0),(590883,16416,'af','Bekyk/kies inskrywings',0),(590884,16417,'af','Betalings bygevoeg',0),(590885,16418,'af','Opname e-posaanhegsel is',0),(590886,16419,'af','Maatskappy toestemmings',0),(590887,16389,'ar','Ù„Ø§ ÙŠÙ…ÙƒÙ† Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„ØªØ±Ø®ÙŠØµ Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„ÙˆØµÙˆÙ„ Ø¥Ù„Ù‰ Ø´Ø¨ÙƒØ© Ø§Ù„Ø¥Ù†ØªØ±Ù†Øª',0),(590888,16390,'ar','Ø¥Ù†Ù‡Ø§Ø¡ Ø§Ù„ØªØ±Ø®ÙŠØµ',0),(590889,16391,'ar','Ù…Ù„Ø§Ø­Ø¸Ø§Øª Ø§Ù„Ù…Ù‡Ù…Ø©',0),(590890,16392,'ar','Ø¥Ø¶Ø§ÙØ© Ù…Ù„Ø§Ø­Ø¸Ø©',0),(590891,16393,'ar','Ø­ÙØ¸',0),(590892,16394,'ar','Ø¥Ø®ÙØ§Ø¡ Ø­Ù‚ÙˆÙ„ Ø±Ù…Ø² Ø§Ù„ØªÙƒÙ„ÙØ© AP',0),(590893,16395,'ar','Ø¥Ø®ÙØ§Ø¡ Ø¯Ø®ÙˆÙ„ Ø§Ù„Ø¯ÙØ¹ Ø¨Ø¹Ø¯ Ø§Ù„Ø¨ÙŠØ¹',0),(590894,16396,'ar','Ø­ÙØ¸ Ø¥Ø¯Ø®Ø§Ù„ Ù†Ù‚Ø§Ø· Ø§Ù„Ø¨ÙŠØ¹',0),(590895,16397,'ar','ØªØ§Ø±ÙŠØ® Ø§Ù„Ø®Ø·',0),(590896,16398,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø®ØµÙ… & Ø§Ù„Ø§Ø¦ØªÙ…Ø§Ù† ÙƒØ¹Ù…ÙˆØ¯ ÙˆØ§Ø­Ø¯',0),(590897,16399,'ar','Ø¥Ø®ÙØ§Ø¡ Ø±Ù…ÙˆØ² Ø§Ù„ØªÙƒÙ„ÙØ© Ø¹Ù„Ù‰ ØµÙØ­Ø§Øª Ø¥Ø¯Ø®Ø§Ù„ Ø¯ÙØªØ± Ø§Ù„ÙŠÙˆÙ…ÙŠØ©',0),(590898,16400,'ar','Ø§Ù„Ù†Ø´Ø§Ø· Ø§Ù„Ø£Ø®ÙŠØ±',0),(590899,16401,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„ØµÙ†Ø¯ÙˆÙ‚',0),(590900,16402,'ar','Ù…Ù„Ø®Øµ Ø§Ù„ØµÙ†Ø¯ÙˆÙ‚',0),(590901,16403,'ar','Ø§Ù„Ù…Ø§Ø¶ÙŠ',0),(590902,16404,'ar','ÙˆØ­Ø¯Ø© ØªØ®Ø²ÙŠÙ† Ø¹Ø§Ù„ÙŠØ©',0),(590903,16405,'ar','Ø¥Ø¯Ø®Ø§Ù„Ø§Øª Ù…Ù† Ø§Ù„Ø£Ø´Ù‡Ø± Ø§Ù„Ø³Ø§Ø¨Ù‚Ø©',0),(590904,16406,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª',0),(590905,16407,'ar','Ù…Ø¬Ù…ÙˆØ¹Ø© ØºÙŠØ± Ù…Ø­Ø¯Ø¯Ø©',0),(590906,16408,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª Ø¥Ù„Ù‰',0),(590907,16409,'ar','ØµÙ†Ø¯ÙˆÙ‚',0),(590908,16410,'ar','Ø§Ù„Ø¥ÙŠØµØ§Ù„Ø§Øª ÙÙŠ',0),(590909,16411,'ar','Ø§Ù„Ø£Ù…ÙˆØ§Ù„ ØªØ´Ù…Ù„',0),(590910,16412,'ar','Ø®ÙŠØ§Ø±Ø§Øª Ø¥Ø¶Ø§ÙÙŠØ© Ù…Ù† Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(590911,16413,'ar','Ø®Ø·Ø£ ÙÙŠ Ø§Ø³ØªØ±Ø¯Ø§Ø¯ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(590912,16414,'ar','ØªÙØ§ØµÙŠÙ„ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(590913,16415,'ar','ÙˆØªØ¯ÙØ¹ Ø§Ù„ÙØ§ØªÙˆØ±Ø©',0),(590914,16416,'ar','Ø¹Ø±Ø¶/ØªØ­Ø¯ÙŠØ¯ Ø§Ù„Ø¥Ø¯Ø®Ø§Ù„Ø§Øª',0),(590915,16417,'ar','Ø§Ù„Ù…Ø¯ÙÙˆØ¹Ø§Øª ÙˆØ£Ø¶Ø§Ù',0),(590916,16418,'ar','Ù…Ø³Ø­ Ø§Ù„Ø¨Ø±ÙŠØ¯ Ø§Ù„Ø¥Ù„ÙƒØªØ±ÙˆÙ†ÙŠ Ø§Ù„Ù…Ø±ÙÙ‚',0),(590917,16419,'ar','Ø£Ø°ÙˆÙ†Ø§Øª Ø§Ù„Ø´Ø±ÙƒØ©',0),(590918,16389,'bg','Ð›Ð¸Ñ†ÐµÐ½Ð·ÑŠÑ‚ Ð½Ðµ Ð¼Ð¾Ð¶Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÐ½ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¸Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚ Ð´Ð¾ÑÑ‚ÑŠÐ¿',0),(590919,16390,'bg','ÐŸÑ€ÐµÐºÑ€Ð°Ñ‚ÑÐ²Ð° Ð»Ð¸Ñ†ÐµÐ½Ð·Ð°',0),(590920,16391,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸',0),(590921,16392,'bg','Ð”Ð¾Ð±Ð°Ð²ÑÐ½Ðµ Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ°',0),(590922,16393,'bg','Ð—Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ',0),(590923,16394,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¿Ð¾Ð»ÐµÑ‚Ð°Ñ‚Ð° Ð·Ð° ÐºÐ¾Ð´ Ð½Ð° AP Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(590924,16395,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð·Ð°Ð¿Ð¸Ñ Ð¿Ð»Ð°Ñ‰Ð°Ð½Ðµ ÑÐ»ÐµÐ´ ÐŸÐžÐ—',0),(590925,16396,'bg','POS Ð·Ð°Ð¿Ð¸Ñ Ð·Ð°Ð¿Ð¸ÑÐ°Ð½',0),(590926,16397,'bg','Ð”Ð°Ñ‚Ð° Ð½Ð° Ð»Ð¸Ð½Ð¸Ñ',0),(590927,16398,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð´ÐµÐ±Ð¸Ñ‚Ð½Ð° & ÐºÑ€ÐµÐ´Ð¸Ñ‚ ÐºÐ°Ñ‚Ð¾ ÐµÐ´Ð½Ð° ÐºÐ¾Ð»Ð¾Ð½Ð°',0),(590928,16399,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ñ†ÐµÐ½Ð° ÐºÐ¾Ð´Ð¾Ð²Ðµ Ð½Ð° Ð´Ð½ÐµÐ²Ð½Ð¸Ðº Ð²Ð»Ð¸Ð·Ð°Ð½Ðµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð¸',0),(590929,16400,'bg','Ð¡ÐºÐ¾Ñ€Ð¾ÑˆÐ½Ð° Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚',0),(590930,16401,'bg','Ð¤Ð¾Ð½Ð´ Ð·Ð° Ð¿Ð¾Ð´Ñ€Ð¾Ð±Ð½Ð¾ÑÑ‚Ð¸',0),(590931,16402,'bg','Ð¤Ð¾Ð½Ð´ Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(590932,16403,'bg','ÐœÐ¸Ð½Ð°Ð»Ð¾',0),(590933,16404,'bg','Ð“Ð¾Ð»ÑÐ¼ Ð¾Ð±ÐµÐ¼',0),(590934,16405,'bg','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð¾Ñ‚ Ð¿Ñ€ÐµÐ´Ñ…Ð¾Ð´Ð½Ð¸ Ð¼ÐµÑÐµÑ†Ð°',0),(590935,16406,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð±Ð¾Ñ€ Ð¾Ñ‚ Ð´Ð°Ð½Ð½Ð¸',0),(590936,16407,'bg','ÐžÐ±Ñ‰Ð¾ Ð½Ðµ ÑÐ° Ð¸Ð·Ð±Ñ€Ð°Ð½Ð¸',0),(590937,16408,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸ÑÑ‚Ð°',0),(590938,16409,'bg','Ð¤Ð¾Ð½Ð´',0),(590939,16410,'bg','Ð Ð°Ð·Ð¿Ð¸ÑÐºÐ¸ Ð²',0),(590940,16411,'bg','Ð¡Ñ€ÐµÐ´ÑÑ‚Ð²Ð°Ñ‚Ð° Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸',0),(590941,16412,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð´Ð¾Ð¿ÑŠÐ»Ð½Ð¸Ñ‚ÐµÐ»Ð½Ð¸ Ð¾Ð¿Ñ†Ð¸Ð¸',0),(590942,16413,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð¸Ð·Ð²Ð»Ð¸Ñ‡Ð°Ð½Ðµ Ð½Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(590943,16414,'bg','Ð”Ð°Ð½Ð½Ð¸ Ð·Ð° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð°',0),(590944,16415,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð°Ñ‚Ð° Ðµ Ð¿Ð»Ð°Ñ‚ÐµÐ½Ð°',0),(590945,16416,'bg','Ð˜Ð·Ð³Ð»ÐµÐ´/Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(590946,16417,'bg','ÐŸÐ»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð´Ð¾Ð±Ð°Ð²ÐµÐ½',0),(590947,16418,'bg','ÐŸÑ€Ð¾ÑƒÑ‡Ð²Ð°Ð½Ðµ Ð¸Ð¼ÐµÐ¹Ð» Ð¿Ñ€Ð¸ÐºÐ°Ñ‡ÐµÐ½ Ñ„Ð°Ð¹Ð»',0),(590948,16419,'bg','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸ÑÑ‚Ð° Ñ€Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ',0),(590949,16389,'zh','æ— æ³•éªŒè¯è®¸å¯è¯æ£€æŸ¥äº’è”ç½‘è®¿é—®æƒé™',0),(590950,16390,'zh','è®¸å¯ç»ˆæ­¢',0),(590951,16391,'zh','å·¥ä½œç¬”è®°',0),(590952,16392,'zh','æ·»åŠ æ³¨é‡Š',0),(590953,16393,'zh','ä¿å­˜',0),(590954,16394,'zh','éšè— AP æˆæœ¬ä»£ç å­—æ®µ',0),(590955,16395,'zh','åœ¨ POS åŽéšè—ä»˜æ¬¾æ¡ç›®',0),(590956,16396,'zh','ä¿å­˜äº† POS æ¡ç›®',0),(590957,16397,'zh','è¡Œæ—¥æœŸ',0),(590958,16398,'zh','ç¼–è¾‘å€Ÿè®°å¡ä¸Žä¿¡ç”¨å¡ä½œä¸ºä¸€åˆ—',0),(590959,16399,'zh','éšè—æ—¥å¿—æ¡ç›®é¡µä¸Šçš„æˆæœ¬çš„ä»£ç ',0),(590960,16400,'zh','æœ€è¿‘çš„æ´»åŠ¨',0),(590961,16401,'zh','åŸºé‡‘è¯¦æƒ…',0),(590962,16402,'zh','åŸºé‡‘æ¦‚å†µ',0),(590963,16403,'zh','è¿‡åŽ»',0),(590964,16404,'zh','é«˜å®¹é‡',0),(590965,16405,'zh','å‰å‡ ä¸ªæœˆçš„æ¡ç›®',0),(590966,16406,'zh','æ²¡æœ‰æ•°æ®é›†',0),(590967,16407,'zh','å…±æœ‰æœªé€‰ä¸­',0),(590968,16408,'zh','å‡ºçš„ä»˜æ¬¾',0),(590969,16409,'zh','åŸºé‡‘',0),(590970,16410,'zh','åœ¨æ”¶æ®',0),(590971,16411,'zh','èµ„é‡‘åŒ…æ‹¬',0),(590972,16412,'zh','é¢å¤–çš„å‘ç¥¨é€‰é¡¹',0),(590973,16413,'zh','é”™è¯¯æ£€ç´¢å‘ç¥¨',0),(590974,16414,'zh','å‘ç¥¨è¯¦ç»†ä¿¡æ¯',0),(590975,16415,'zh','æ”¯ä»˜å‘ç¥¨',0),(590976,16416,'zh','è§†å›¾/é€‰æ‹©æ¡ç›®',0),(590977,16417,'zh','æ·»åŠ çš„ä»˜æ¬¾',0),(590978,16418,'zh','è°ƒæŸ¥çš„ç”µå­é‚®ä»¶é™„ä»¶',0),(590979,16419,'zh','å…¬å¸æƒé™',0),(590980,16389,'da','Licens kunne ikke verificeres tjek internetadgang',0),(590981,16390,'da','Licens ophÃ¸rer',0),(590982,16391,'da','Job noter',0),(590983,16392,'da','FÃ¸je Note',0),(590984,16393,'da','Besparelse',0),(590985,16394,'da','Skjule kode AP omkostningsfelter',0),(590986,16395,'da','Skjule betalingsposten efter POS',0),(590987,16396,'da','POS post gemmes',0),(590988,16397,'da','Line dato',0),(590989,16398,'da','Redigere debet & kredit som Ã©n kolonne',0),(590990,16399,'da','Skjule omkostninger koder pÃ¥ Journal Entry sider',0),(590991,16400,'da','Seneste aktivitet',0),(590992,16401,'da','Fonden detaljer',0),(590993,16402,'da','Fonden ResumÃ©',0),(590994,16403,'da','Fortiden',0),(590995,16404,'da','HÃ¸j lydstyrke',0),(590996,16405,'da','Poster fra forudgÃ¥ende mÃ¥neder',0),(590997,16406,'da','Ingen datasÃ¦t',0),(590998,16407,'da','Alt ikke valgt',0),(590999,16408,'da','Udbetalinger ud',0),(591000,16409,'da','Fonden',0),(591001,16410,'da','Tilgange i',0),(591002,16411,'da','Midler til at omfatte',0),(591003,16412,'da','Yderligere faktura indstillinger',0),(591004,16413,'da','Fejl under hentning af faktura',0),(591005,16414,'da','Fakturadetaljer',0),(591006,16415,'da','Faktura er betalt',0),(591007,16416,'da','Se/VÃ¦lg poster',0),(591008,16417,'da','Betalinger tilfÃ¸jet',0),(591009,16418,'da','UndersÃ¸gelsen E-mail vedhÃ¦ftet fil',0),(591010,16419,'da','Virksomheden tilladelse',0),(591011,16389,'dr','Ù…Ø¬ÙˆØ² Ù…ÛŒ Ø´ÙˆØ¯ ØªØ§ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡ Ø¨Ø±Ø±Ø³ÛŒ Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø§ÛŒÙ†ØªØ±Ù†Øª',0),(591012,16390,'dr','Ù…Ø¬ÙˆØ² ÙØ³Ø®',0),(591013,16391,'dr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ú©Ø§Ø±',0),(591014,16392,'dr','Ø§ÙØ²ÙˆØ¯Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª',0),(591015,16393,'dr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ',0),(591016,16394,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø²Ù…ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³',0),(591017,16395,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ù…Ø·Ù„Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¹Ø¯ Ø§Ø² Ø³Ù„Ø§Ù…ØªÛŒ',0),(591018,16396,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ POS Ø±Ø§ Ù†Ø¬Ø§Øª Ø¯Ø§Ø¯',0),(591019,16397,'dr','ØªØ§Ø±ÛŒØ® Ø®Ø·',0),(591020,16398,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø¨Ø¯Ù‡ÛŒ & Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ÛŒÚ© Ø³ØªÙˆÙ†',0),(591021,16399,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ú©Ø¯Ù‡Ø§ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø¯Ø± Ù…Ø¬Ù„Ù‡ ØµÙØ­Ù‡ ÙˆØ±ÙˆØ¯',0),(591022,16400,'dr','ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ø§Ø®ÛŒØ±',0),(591023,16401,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª ØµÙ†Ø¯ÙˆÙ‚',0),(591024,16402,'dr','Ø®Ù„Ø§ØµÙ‡ ØµÙ†Ø¯ÙˆÙ‚',0),(591025,16403,'dr','Ú¯Ø°Ø´ØªÙ‡',0),(591026,16404,'dr','Ø­Ø¬Ù… Ø¨Ø§Ù„Ø§',0),(591027,16405,'dr','Ù‡Ø§ Ø§Ø² Ù…Ø§Ù‡ Ù‚Ø¨Ù„',0),(591028,16406,'dr','Ù‡ÛŒÚ† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(591029,16407,'dr','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡',0),(591030,16408,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ú©Ø±Ø¯Ù†',0),(591031,16409,'dr','ØµÙ†Ø¯ÙˆÙ‚',0),(591032,16410,'dr','Ø±Ø³ÛŒØ¯ Ø¯Ø±',0),(591033,16411,'dr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø´Ø§Ù…Ù„',0),(591034,16412,'dr','Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ ÙØ§Ú©ØªÙˆØ±',0),(591035,16413,'dr','Ø®Ø·Ø§ÛŒ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(591036,16414,'dr','Ø¬Ø²Ø¦ÛŒØ§Øª ÙØ§Ú©ØªÙˆØ±',0),(591037,16415,'dr','ÙØ§Ú©ØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ù…ÛŒ Ø´ÙˆØ¯',0),(591038,16416,'dr','Ù…Ø´Ø§Ù‡Ø¯Ù‡/Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(591039,16417,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡',0),(591040,16418,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø§ÛŒÙ…ÛŒÙ„ Ù¾ÛŒÙˆØ³Øª',0),(591041,16419,'dr','Ù…Ø¬ÙˆØ² Ø´Ø±Ú©Øª',0),(591042,16389,'nl','Licentie kan niet worden geverifieerd internettoegang controleren',0),(591043,16390,'nl','Licentie beÃ«indigd',0),(591044,16391,'nl','Neemt nota van de baan',0),(591045,16392,'nl','Notitie toevoegen',0),(591046,16393,'nl','Opslaan',0),(591047,16394,'nl','AP kostenvelden Code verbergen',0),(591048,16395,'nl','Betalingspost verbergen na POS',0),(591049,16396,'nl','POS item opgeslagen',0),(591050,16397,'nl','Lijn datum',0),(591051,16398,'nl','Bewerken van debet & krediet als Ã©Ã©n kolom',0),(591052,16399,'nl','Kosten Codes op Journal Entry Pages verbergen',0),(591053,16400,'nl','Recente activiteit',0),(591054,16401,'nl','Fonds Details',0),(591055,16402,'nl','Fonds samenvatting',0),(591056,16403,'nl','Verleden',0),(591057,16404,'nl','Hoog Volume',0),(591058,16405,'nl','Posten uit voorafgaande maanden',0),(591059,16406,'nl','Geen gegevensset',0),(591060,16407,'nl','Totaal niet geselecteerd',0),(591061,16408,'nl','Betalingen uit',0),(591062,16409,'nl','Fonds',0),(591063,16410,'nl','Ontvangsten In',0),(591064,16411,'nl','Fondsen op te nemen',0),(591065,16412,'nl','Aanvullende factuur opties',0),(591066,16413,'nl','Fout ophalen factuur',0),(591067,16414,'nl','Factuurgegevens',0),(591068,16415,'nl','Factuur betaald',0),(591069,16416,'nl','Weergave/Select posten',0),(591070,16417,'nl','Betalingen toegevoegd',0),(591071,16418,'nl','Overzicht e-mailbijlage',0),(591072,16419,'nl','Bedrijf machtigingen',0),(591073,16389,'et','Litsentsi ei saa kontrollida kontrollige Interneti-Ã¼hendust',0),(591074,16390,'et','Litsentsi lÃµpetada',0),(591075,16391,'et','TÃ¶Ã¶ mÃ¤rkused',0),(591076,16392,'et','Lisa MÃ¤rkus',0),(591077,16393,'et','Salvestamine',0),(591078,16394,'et','Peitmiseks AP maksumus kood',0),(591079,16395,'et','Peida maksekandele pÃ¤rast POS',0),(591080,16396,'et','POS kanne salvestatud',0),(591081,16397,'et','Rea kuupÃ¤ev',0),(591082,16398,'et','Tehke deebet & krediidi Ã¼he veeru',0),(591083,16399,'et','Peita standardkulu tÃ¶Ã¶lehe kanne lehekÃ¼lgedel',0),(591084,16400,'et','Hiljutised tegevused',0),(591085,16401,'et','Fondi andmed',0),(591086,16402,'et','Fondi KokkuvÃµte',0),(591087,16403,'et','Varem',0),(591088,16404,'et','Suure mahuga',0),(591089,16405,'et','Eelneva kuu kanded',0),(591090,16406,'et','Ole andmekogu',0),(591091,16407,'et','Kokku pole valitud',0),(591092,16408,'et','VÃ¤ljamaksed vÃ¤lja',0),(591093,16409,'et','Fondi',0),(591094,16410,'et','Tulud',0),(591095,16411,'et','Rahaliste vahendite kaasamiseks',0),(591096,16412,'et','TÃ¤iendavaid arve suvandid',0),(591097,16413,'et','TÃµrge allalaadimisel arve',0),(591098,16414,'et','Arve andmed',0),(591099,16415,'et','Arve maksmist',0),(591100,16416,'et','Vaade/Vali kirjed',0),(591101,16417,'et','Maksed on',0),(591102,16418,'et','Uuringu emailile',0),(591103,16419,'et','EttevÃµtte Ãµigused',0),(591104,16389,'fi','KÃ¤yttÃ¶oikeutta ei voitu tarkistaa tarkistaa pysÃ¤kÃ¶inti',0),(591105,16390,'fi','Lisenssi pÃ¤Ã¤ttyy',0),(591106,16391,'fi','TyÃ¶ toteaa',0),(591107,16392,'fi','LisÃ¤Ã¤ huomautus',0),(591108,16393,'fi','Tallentaminen',0),(591109,16394,'fi','Piilota AP kustannuskenttiÃ¤ koodi',0),(591110,16395,'fi','Toimittajatapahtuman himmennÃ¤ POS',0),(591111,16396,'fi','POS-merkintÃ¤ tallennetaan',0),(591112,16397,'fi','PÃ¤ivÃ¤mÃ¤Ã¤rÃ¤Ã¤',0),(591113,16398,'fi','Muokkaa Debit/Teachers & luotto yhden sarakkeen',0),(591114,16399,'fi','Piilota kustannus koodeja kirjauskansion merkintÃ¤ sivuilla',0),(591115,16400,'fi','Ajankohtaiset aktiviteetit',0),(591116,16401,'fi','Rahaston tiedot',0),(591117,16402,'fi','Rahaston Yhteenveto',0),(591118,16403,'fi','Aiemmin',0),(591119,16404,'fi','Suuri mÃ¤Ã¤rÃ¤',0),(591120,16405,'fi','Tapahtumat edelliseltÃ¤ kuukaudelta',0),(591121,16406,'fi','Ei tietojoukon',0),(591122,16407,'fi','YhteensÃ¤ ei ole valittu',0),(591123,16408,'fi','Maksut',0),(591124,16409,'fi','Rahaston',0),(591125,16410,'fi','Vastaanotot',0),(591126,16411,'fi','Keinoja ovat',0),(591127,16412,'fi','LisÃ¤Ã¤ laskun asetukset',0),(591128,16413,'fi','Virhe haettaessa laskun',0),(591129,16414,'fi','Laskutustiedot',0),(591130,16415,'fi','Lasku maksetaan',0),(591131,16416,'fi','Katso/Valitse tapahtumat',0),(591132,16417,'fi','Maksuihin lisÃ¤tÃ¤Ã¤n',0),(591133,16418,'fi','Kyselyn sÃ¤hkÃ¶postin liitetiedostona',0),(591134,16419,'fi','Yrityksen oikeudet',0),(591135,16389,'fr','Licence nâ€™a pas pu Ãªtre vÃ©rifiÃ© vÃ©rifier lâ€™accÃ¨s Ã  Internet',0),(591136,16390,'fr','Licence rÃ©siliÃ©',0),(591137,16391,'fr','Notes de travail',0),(591138,16392,'fr','Ajouter une Note',0),(591139,16393,'fr','Enregistrement',0),(591140,16394,'fr','Masquer les champs de Code AP coÃ»t',0),(591141,16395,'fr','Cacher la saisie des paiements aprÃ¨s POS',0),(591142,16396,'fr','EntrÃ©e de POS sauvÃ©',0),(591143,16397,'fr','Ligne de Date',0),(591144,16398,'fr','Modifier le dÃ©bit & crÃ©dit comme une seule colonne',0),(591145,16399,'fr','Masquer les Codes de coÃ»t sur les Pages dâ€™entrÃ©e de Journal',0),(591146,16400,'fr','ActivitÃ© rÃ©cente',0),(591147,16401,'fr','DÃ©tails du Fonds',0),(591148,16402,'fr','Sommaire des fonds',0),(591149,16403,'fr','PassÃ©',0),(591150,16404,'fr','Volume Ã©levÃ©',0),(591151,16405,'fr','EntrÃ©es Ã  partir des mois prÃ©cÃ©dents',0),(591152,16406,'fr','Aucun jeu de donnÃ©es',0),(591153,16407,'fr','Total non sÃ©lectionnÃ©',0),(591154,16408,'fr','DÃ©caissements hors',0),(591155,16409,'fr','Fonds',0),(591156,16410,'fr','ReÃ§us dans',0),(591157,16411,'fr','Fonds dâ€™inclure',0),(591158,16412,'fr','Options de facture supplÃ©mentaire',0),(591159,16413,'fr','Facture de rÃ©cupÃ©ration dâ€™erreur',0),(591160,16414,'fr','DÃ©tails de la facture',0),(591161,16415,'fr','La facture est payÃ©e',0),(591162,16416,'fr','Affichage/sÃ©lectionner les entrÃ©es',0),(591163,16417,'fr','Paiements a ajoutÃ©',0),(591164,16418,'fr','EnquÃªte sur la piÃ¨ce jointe',0),(591165,16419,'fr','SociÃ©tÃ© des autorisations',0),(591166,16389,'de','Lizenz konnte nicht verifiziert werden Ã¼berprÃ¼fen Sie Internet-Zugang',0),(591167,16390,'de','Lizenz beendet',0),(591168,16391,'de','Job-Notizen',0),(591169,16392,'de','Notiz hinzufÃ¼gen',0),(591170,16393,'de','Speichern',0),(591171,16394,'de','AP Kosten Code Felder ausblenden',0),(591172,16395,'de','Zahlungsposten nach POS ausblenden',0),(591173,16396,'de','POS-Eintrag gespeichert',0),(591174,16397,'de','Zeile Datum',0),(591175,16398,'de','Debit & Kredit als eine Spalte bearbeiten',0),(591176,16399,'de','Kosten-Codes auf Journal Eintrag Seiten ausblenden',0),(591177,16400,'de','Neueste AktivitÃ¤t',0),(591178,16401,'de','Fonds-Details',0),(591179,16402,'de','Fonds-Ãœbersicht',0),(591180,16403,'de','Vergangenheit',0),(591181,16404,'de','Hohes Volumen',0),(591182,16405,'de','EintrÃ¤ge aus der Vormonate',0),(591183,16406,'de','Kein Datensatz',0),(591184,16407,'de','Insgesamt nicht ausgewÃ¤hlt',0),(591185,16408,'de','Auszahlungen aus',0),(591186,16409,'de','Fonds',0),(591187,16410,'de','Belege In',0),(591188,16411,'de','Mittel enthalten',0),(591189,16412,'de','ZusÃ¤tzliche Rechnung Optionen',0),(591190,16413,'de','Fehler beim Abrufen Rechnung',0),(591191,16414,'de','Rechnungsdetails',0),(591192,16415,'de','Rechnung bezahlt',0),(591193,16416,'de','Ansicht/Select EintrÃ¤ge',0),(591194,16417,'de','Zahlungen hinzugefÃ¼gt',0),(591195,16418,'de','Umfrage e-Mail-Anhang',0),(591196,16419,'de','Unternehmen-Berechtigungen',0),(591197,16389,'el','Î†Î´ÎµÎ¹Î± Î´ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÏƒÎ±Î½ Î½Î± ÎµÏ€Î±Î»Î·Î¸ÎµÏ…Î¸Î¿ÏÎ½ Î­Î»ÎµÎ³Ï‡Î¿Ï‚ Ï€ÏÏŒÏƒÎ²Î±ÏƒÎ·Ï‚ ÏƒÏ„Î¿ Î´Î¹Î±Î´Î¯ÎºÏ„Ï…Î¿',0),(591198,16390,'el','Î†Î´ÎµÎ¹Î± Ï„ÎµÏÎ¼Î±Ï„Î¯ÏƒÏ„Î·ÎºÎµ',0),(591199,16391,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(591200,16392,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ· ÏƒÎ·Î¼ÎµÎ¯Ï‰ÏƒÎ·Ï‚',0),(591201,16393,'el','Î•Î¾Î¿Î¹ÎºÎ¿Î½ÏŒÎ¼Î·ÏƒÎ·',0),(591202,16394,'el','Î‘Ï€Î¿ÎºÏÏÏˆÎµÏ„Îµ Ï„Î± Ï€ÎµÎ´Î¯Î± ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ AP',0),(591203,16395,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÎµÎ³Î³ÏÎ±Ï†Î® Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚ Î¼ÎµÏ„Î¬ POS',0),(591204,16396,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ ÏƒÎµ POS ÎµÎ¹ÏƒÏŒÎ´Î¿Ï…',0),(591205,16397,'el','Î—Î¼/Î½Î¯Î±Ï‚ Î³ÏÎ±Î¼Î¼Î®Ï‚',0),(591206,16398,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Ï‡ÏÎµÏ‰ÏƒÏ„Î¹ÎºÎ® & Ï€Î¹ÏƒÏ„Ï‰Ï„Î¹ÎºÎ­Ï‚ Ï‰Ï‚ Î¼Î¯Î± ÏƒÏ„Î®Î»Î·',0),(591207,16399,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚ ÏƒÏ„Î¹Ï‚ ÏƒÎµÎ»Î¯Î´ÎµÏ‚ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(591208,16400,'el','Î ÏÏŒÏƒÏ†Î±Ï„Î· Î´ÏÎ±ÏƒÏ„Î·ÏÎ¹ÏŒÏ„Î·Ï„Î±',0),(591209,16401,'el','Î¤Î±Î¼ÎµÎ¯Î¿ Î»ÎµÏ€Ï„Î¿Î¼Î­ÏÎµÎ¹ÎµÏ‚',0),(591210,16402,'el','Î¤Î±Î¼ÎµÎ¯Î¿ Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(591211,16403,'el','Î Î±ÏÎµÎ»Î¸ÏŒÎ½',0),(591212,16404,'el','Î¥ÏˆÎ·Î»Î® Î­Î½Ï„Î±ÏƒÎ·',0),(591213,16405,'el','Î•Î³Î³ÏÎ±Ï†Î­Ï‚ Î±Ï€ÏŒ Ï€ÏÎ¿Î·Î³Î¿ÏÎ¼ÎµÎ½ÎµÏ‚ Î¼Î®Î½ÎµÏ‚',0),(591214,16406,'el','ÎšÎ±Î½Î­Î½Î± ÏƒÏÎ½Î¿Î»Î¿ Î´ÎµÎ´Î¿Î¼Î­Î½Ï‰Î½',0),(591215,16407,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÎ¬ Î´ÎµÎ½ ÎµÏ€Î¹Î»ÎµÎ³ÎµÎ¯',0),(591216,16408,'el','ÎŸÎ¹ ÎµÎºÏ„Î±Î¼Î¹ÎµÏÏƒÎµÎ¹Ï‚ Î­Î¾Ï‰',0),(591217,16409,'el','Î¤Î±Î¼ÎµÎ¯Î¿',0),(591218,16410,'el','Î‘Ï€Î¿Î´ÎµÎ¯Î¾ÎµÎ¹Ï‚ ÏƒÎµ',0),(591219,16411,'el','ÎšÎµÏ†Î¬Î»Î±Î¹Î± Î½Î± Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½',0),(591220,16412,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÏÏŒÏƒÎ¸ÎµÏ„ÎµÏ‚ ÎµÏ€Î¹Î»Î¿Î³Î­Ï‚',0),(591221,16413,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Î½Î¬ÎºÏ„Î·ÏƒÎ· Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿',0),(591222,16414,'el','Î£Ï„Î¿Î¹Ï‡ÎµÎ¯Î± Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(591223,16415,'el','Î Î»Î·ÏÏ‰Î¼Î® Ï„Î¿Ï… Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(591224,16416,'el','Î”ÎµÎ¯Ï„Îµ/ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(591225,16417,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯',0),(591226,16418,'el','ÎˆÏÎµÏ…Î½Î± ÏƒÏ…Î½Î·Î¼Î¼Î­Î½Î¿ Î·Î»ÎµÎºÏ„ÏÎ¿Î½Î¹ÎºÎ¿Ï Ï„Î±Ï‡Ï…Î´ÏÎ¿Î¼ÎµÎ¯Î¿Ï…',0),(591227,16419,'el','Î”Î¹ÎºÎ±Î¹ÏŽÎ¼Î±Ï„Î± ÎµÏ„Î±Î¹ÏÎµÎ¯Î±Ï‚',0),(591228,16389,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ××ž×ª ××ª ×”×¨×™×©×™×•×Ÿ ×œ×‘×“×•×§ ×’×™×©×” ×œ××™× ×˜×¨× ×˜',0),(591229,16390,'he','×¨×©×™×•×Ÿ ×”×¡×ª×™×™×',0),(591230,16391,'he','×”×¢×‘×•×“×” ×”×¢×¨×•×ª',0),(591231,16392,'he','×œ×”×•×¡×™×£ ×”×¢×¨×”',0),(591232,16393,'he','×©×ž×™×¨×ª',0),(591233,16394,'he','×”×¡×ª×¨ ×©×“×•×ª ×§×•×“ ×¢×œ×•×ª AP',0),(591234,16395,'he','×œ×”×¡×ª×™×¨ ××ª ×ª×©×œ×•× ×”×›× ×™×¡×” ×œ××—×¨ POS',0),(591235,16396,'he','×©×ž×™×¨×ª ×¢×¨×š POS',0),(591236,16397,'he','×§×• ×”×ª××¨×™×š',0),(591237,16398,'he','×œ×¢×¨×•×š ×—×™×•×‘ & ××©×¨××™ ×›×¢×ž×•×“×” ××—×ª',0),(591238,16399,'he','×œ×”×¡×ª×™×¨ ×§×•×“×™ ×¢×œ×•×ª ×‘×“×¤×™ ×›× ×™×¡×” ×™×•×ž×Ÿ',0),(591239,16400,'he','×¤×¢×™×œ×•×ª ×œ××—×¨×•× ×”',0),(591240,16401,'he','×œ×¤×¨×˜×™× ×§×¨×Ÿ',0),(591241,16402,'he','×§×¨×Ÿ ×¡×™×›×•×',0),(591242,16403,'he','×”×¢×‘×¨',0),(591243,16404,'he','× ×¤×— ×’×‘×•×”',0),(591244,16405,'he','×¢×¨×›×™ ×—×•×“×©×™× ×ž×¨××©',0),(591245,16406,'he','××™×Ÿ ×¢×¨×›×ª × ×ª×•× ×™×',0),(591246,16407,'he','×¡×” ×› ×œ× × ×‘×—×¨',0),(591247,16408,'he','×œ×ª×©×œ×•×ž×™×.',0),(591248,16409,'he','×§×¨×Ÿ',0),(591249,16410,'he','×§×‘×œ×•×ª',0),(591250,16411,'he','×”×§×¨× ×•×ª ×œ×›×œ×•×œ',0),(591251,16412,'he','×”×—×©×‘×•× ×™×ª × ×•×¡×¤×™×',0),(591252,16413,'he','×©×’×™××” ×‘××—×–×•×¨ ×—×©×‘×•× ×™×ª',0),(591253,16414,'he','×¤×¨×˜×™ ×—×©×‘×•× ×™×ª',0),(591254,16415,'he','×”×—×©×‘×•× ×™×ª ×©×•×œ×ž×”',0),(591255,16416,'he','×‘×—×¨ ×ª×¦×•×’×ª ×¢×¨×›×™',0),(591256,16417,'he','×ª×©×œ×•×ž×™× × ×•×¡×¤×™×',0),(591257,16418,'he','×”×¡×§×¨ ×”×ž×¦×•×¨×£ ×œ×“×•×',0),(591258,16419,'he','×”×—×‘×¨×” ×”×¨×©××•×ª',0),(591259,16389,'hi','à¤²à¤¾à¤¯à¤¸à¥‡à¤‚à¤¸ à¤¸à¤¤à¥à¤¯à¤¾à¤ªà¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾ à¤¹à¥ˆ à¤‡à¤‚à¤Ÿà¤°à¤¨à¥‡à¤Ÿ à¤¤à¤• à¤ªà¤¹à¥à¤à¤š à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(591260,16390,'hi','à¤²à¤¾à¤‡à¤¸à¥‡à¤‚à¤¸ à¤¸à¤®à¤¾à¤ªà¥à¤¤',0),(591261,16391,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(591262,16392,'hi','à¤¨à¥‹à¤Ÿ à¤œà¥‹à¤¡à¤¼à¥‡à¤‚',0),(591263,16393,'hi','à¤¬à¤šà¤¤',0),(591264,16394,'hi','AP à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤«à¤¼à¥€à¤²à¥à¤¡ à¤›à¥à¤ªà¤¾à¤à¤',0),(591265,16395,'hi','à¤¬à¤¾à¤¦ POS à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤›à¥à¤ªà¤¾à¤à¤',0),(591266,16396,'hi','POS à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¤¹à¥‡à¤œà¥€ à¤—à¤ˆ',0),(591267,16397,'hi','à¤ªà¤‚à¤•à¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(591268,16398,'hi','à¤¡à¥‡à¤¬à¤¿à¤Ÿ & à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤à¤• à¤¸à¥à¤¤à¤‚à¤­ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(591269,16399,'hi','à¤œà¤°à¥à¤¨à¤² à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤ªà¥ƒà¤·à¥à¤ à¥‹à¤‚ à¤ªà¤° à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤›à¥à¤ªà¤¾à¤à¤',0),(591270,16400,'hi','à¤¹à¤¾à¤² à¤•à¥€ à¤—à¤¤à¤¿à¤µà¤¿à¤§à¤¿',0),(591271,16401,'hi','à¤•à¥‹à¤· à¤µà¤¿à¤µà¤°à¤£',0),(591272,16402,'hi','à¤¨à¤¿à¤§à¤¿ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(591273,16403,'hi','à¤…à¤¤à¥€à¤¤',0),(591274,16404,'hi','à¤‰à¤šà¥à¤š à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(591275,16405,'hi','à¤ªà¤¹à¤²à¥‡ à¤®à¤¹à¥€à¤¨à¥‡ à¤¸à¥‡ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(591276,16406,'hi','à¤•à¥‹à¤ˆ à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¥‡à¤Ÿ',0),(591277,16407,'hi','à¤•à¥à¤² à¤šà¤¯à¤¨à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚',0),(591278,16408,'hi','à¤¬à¤¾à¤¹à¤° à¤¸à¤‚à¤µà¤¿à¤¤à¤°à¤£',0),(591279,16409,'hi','à¤¨à¤¿à¤§à¤¿',0),(591280,16410,'hi','à¤°à¤¸à¥€à¤¦ à¤®à¥‡à¤‚',0),(591281,16411,'hi','à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤§à¤¨',0),(591282,16412,'hi','à¤…à¤¤à¤¿à¤°à¤¿à¤•à¥à¤¤ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤µà¤¿à¤•à¤²à¥à¤ª',0),(591283,16413,'hi','à¤¤à¥à¤°à¥à¤Ÿà¤¿ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤° à¤°à¤¹à¤¾ à¤šà¤¾à¤²à¤¾à¤¨',0),(591284,16414,'hi','à¤‡à¤¨à¤µà¥‰à¤¯à¤¸ à¤µà¤¿à¤µà¤°à¤£',0),(591285,16415,'hi','à¤šà¤¾à¤²à¤¾à¤¨ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¤à¤¾ à¤¹à¥ˆ',0),(591286,16416,'hi','à¤¦à¥ƒà¤¶à¥à¤¯/à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(591287,16417,'hi','à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(591288,16418,'hi','à¤¸à¤°à¥à¤µà¥‡à¤•à¥à¤·à¤£ à¤ˆ-à¤®à¥‡à¤² à¤…à¤¨à¥à¤²à¤—à¥à¤¨à¤•',0),(591289,16419,'hi','à¤•à¤‚à¤ªà¤¨à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿à¤¯à¤¾à¤',0),(591290,16389,'ba','Lisensi tidak dapat diverifikasi memeriksa akses Internet',0),(591291,16390,'ba','Lisensi dihentikan',0),(591292,16391,'ba','Catatan pekerjaan',0),(591293,16392,'ba','Tambahkan catatan',0),(591294,16393,'ba','Tabungan',0),(591295,16394,'ba','Menyembunyikan biaya AP kode bidang',0),(591296,16395,'ba','Menyembunyikan pembayaran Entry setelah POS',0),(591297,16396,'ba','POS masuk disimpan',0),(591298,16397,'ba','Tanggal baris',0),(591299,16398,'ba','Mengedit Debit & kredit sebagai satu kolom',0),(591300,16399,'ba','Menyembunyikan biaya kode pada halaman entri jurnal',0),(591301,16400,'ba','Aktivitas terakhir',0),(591302,16401,'ba','Rincian dana',0),(591303,16402,'ba','Dana ringkasan',0),(591304,16403,'ba','Masa lalu',0),(591305,16404,'ba','Volume tinggi',0),(591306,16405,'ba','Masukan dari bulan sebelumnya',0),(591307,16406,'ba','Tidak ada Data Set',0),(591308,16407,'ba','Total tidak dipilih',0),(591309,16408,'ba','Pencairan keluar',0),(591310,16409,'ba','Dana',0),(591311,16410,'ba','Dalam',0),(591312,16411,'ba','Dana untuk memasukkan',0),(591313,16412,'ba','Pilihan tambahan faktur',0),(591314,16413,'ba','Kesalahan mengambil faktur',0),(591315,16414,'ba','Rincian faktur',0),(591316,16415,'ba','Faktur dibayar',0),(591317,16416,'ba','Lihat/pilih entri',0),(591318,16417,'ba','Pembayaran yang ditambahkan',0),(591319,16418,'ba','Survei Email lampiran',0),(591320,16419,'ba','Izin perusahaan',0),(591321,16389,'it','Licenza non puÃ² essere verificato Verifica connessione Internet',0),(591322,16390,'it','Licenza Ã¨ terminato',0),(591323,16391,'it','Note relative al lavoro',0),(591324,16392,'it','Aggiungi nota',0),(591325,16393,'it','Risparmio',0),(591326,16394,'it','Nascondere i campi codice costo AP',0),(591327,16395,'it','Nascondere la voce pagamento dopo POS',0),(591328,16396,'it','POS voce salvata',0),(591329,16397,'it','Linea data',0),(591330,16398,'it','Modificare il debito & credito come una colonna',0),(591331,16399,'it','Nascondere i codici di costo su Gazzetta pagine di entrata',0),(591332,16400,'it','AttivitÃ  recenti',0),(591333,16401,'it','Specifiche del fondo',0),(591334,16402,'it','Riepilogo di fondo',0),(591335,16403,'it','Passato',0),(591336,16404,'it','Ad alto Volume',0),(591337,16405,'it','Voci da mesi precedenti',0),(591338,16406,'it','Nessun Set di dati',0),(591339,16407,'it','Totale non selezionata',0),(591340,16408,'it','Esborsi fuori',0),(591341,16409,'it','Fondo',0),(591342,16410,'it','Ricevute In',0),(591343,16411,'it','Fondi per includere',0),(591344,16412,'it','Opzioni di fattura aggiuntiva',0),(591345,16413,'it','Errore recupero fattura',0),(591346,16414,'it','Dettagli fattura',0),(591347,16415,'it','Pagamento fattura',0),(591348,16416,'it','Visualizza/seleziona le voci',0),(591349,16417,'it','Pagamenti aggiunti',0),(591350,16418,'it','Sondaggio allegato',0),(591351,16419,'it','SocietÃ  l\'autorizzazione',0),(591352,16389,'jp','ãƒ©ã‚¤ã‚»ãƒ³ã‚¹ã‚’ç¢ºèªã§ãã¾ã›ã‚“ã§ã—ãŸã‚¤ãƒ³ã‚¿ãƒ¼ãƒãƒƒãƒˆ ã‚¢ã‚¯ã‚»ã‚¹ã‚’ãƒã‚§ãƒƒã‚¯',0),(591353,16390,'jp','ãƒ©ã‚¤ã‚»ãƒ³ã‚¹ã®çµ‚äº†',0),(591354,16391,'jp','ä»•äº‹ãƒŽãƒ¼ãƒˆ',0),(591355,16392,'jp','ãƒ¡ãƒ¢ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(591356,16393,'jp','ä¿å­˜',0),(591357,16394,'jp','AP ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰] ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ã‚’éžè¡¨ç¤ºã«',0),(591358,16395,'jp','POS å¾Œæ”¯æ‰•ã„ã®ã‚¨ãƒ³ãƒˆãƒªã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(591359,16396,'jp','POS ã‚¨ãƒ³ãƒˆãƒªä¿å­˜',0),(591360,16397,'jp','è¡Œæ—¥',0),(591361,16398,'jp','1 ã¤ã®åˆ—ã¨ã—ã¦ãƒ‡ãƒ“ãƒƒãƒˆ ãƒ» ã‚¯ãƒ¬ã‚¸ãƒƒãƒˆã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(591362,16399,'jp','ã‚¸ãƒ£ãƒ¼ãƒŠãƒ« ã‚¨ãƒ³ãƒˆãƒª ãƒšãƒ¼ã‚¸ã®ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(591363,16400,'jp','æœ€è¿‘ã®æ´»å‹•',0),(591364,16401,'jp','ãƒ•ã‚¡ãƒ³ãƒ‰è©³ç´°',0),(591365,16402,'jp','åŸºé‡‘ã®æ¦‚è¦',0),(591366,16403,'jp','éŽåŽ»',0),(591367,16404,'jp','é«˜ãƒœãƒªãƒ¥ãƒ¼ãƒ ',0),(591368,16405,'jp','æ•°ãƒ¶æœˆå‰ã‹ã‚‰ã®ã‚¨ãƒ³ãƒˆãƒªãƒ¼',0),(591369,16406,'jp','ãƒ‡ãƒ¼ã‚¿ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“',0),(591370,16407,'jp','é¸æŠžã•ã‚Œã¦ã„ãªã„åˆè¨ˆ',0),(591371,16408,'jp','ã†ã¡æ”¯å‡º',0),(591372,16409,'jp','åŸºé‡‘',0),(591373,16410,'jp','é ˜åŽæ›¸ã§',0),(591374,16411,'jp','è³‡é‡‘ã«å«ã‚ã‚‹',0),(591375,16412,'jp','è¿½åŠ è«‹æ±‚æ›¸ã‚ªãƒ—ã‚·ãƒ§ãƒ³',0),(591376,16413,'jp','ã‚¨ãƒ©ãƒ¼å–å¾—è«‹æ±‚',0),(591377,16414,'jp','è«‹æ±‚æ›¸ã®è©³ç´°',0),(591378,16415,'jp','è«‹æ±‚æ›¸ãŒæ”¯æ‰•ã‚ã‚Œã¦',0),(591379,16416,'jp','ã‚¨ãƒ³ãƒˆãƒªã®è¡¨ç¤º/é¸æŠž',0),(591380,16417,'jp','è¿½åŠ æ”¯æ‰•ã„',0),(591381,16418,'jp','é›»å­ãƒ¡ãƒ¼ãƒ«ã®æ·»ä»˜ãƒ•ã‚¡ã‚¤ãƒ«ã®èª¿æŸ»',0),(591382,16419,'jp','ã‚¢ã‚¯ã‚»ã‚¹è¨±å¯ã‚’ä¼šç¤¾',0),(591383,16389,'ko','ë¼ì´ì„¼ìŠ¤ë¥¼ í™•ì¸í•  ìˆ˜ ì—†ëŠ” ì¸í„°ë„· ì ‘ì† í™•ì¸',0),(591384,16390,'ko','ë¼ì´ì„ ìŠ¤ ì¢…ë£Œ',0),(591385,16391,'ko','ìž‘ì—… ë…¸íŠ¸',0),(591386,16392,'ko','ë©”ëª¨ ì¶”ê°€',0),(591387,16393,'ko','ì €ìž¥',0),(591388,16394,'ko','AP ë¹„ìš© ì½”ë“œ í•„ë“œ ìˆ¨ê¸°ê¸°',0),(591389,16395,'ko','í¬ìŠ¤ í›„ ë‚©ë¶€ í•­ëª© ìˆ¨ê¸°ê¸°',0),(591390,16396,'ko','í¬ìŠ¤ í•­ëª© ì €ìž¥',0),(591391,16397,'ko','ë¼ì¸ ë‚ ì§œ',0),(591392,16398,'ko','í•˜ë‚˜ì˜ ì—´ìœ¼ë¡œ ì§ë¶ˆ ë° ì‹ ìš©ì„ íŽ¸ì§‘',0),(591393,16399,'ko','ì—…ë¬´ ì¼ì§€ í•­ëª© íŽ˜ì´ì§€ì— ë¹„ìš©ëœ ì½”ë“œ ìˆ¨ê¸°ê¸°',0),(591394,16400,'ko','ìµœê·¼ í™œë™',0),(591395,16401,'ko','íŽ€ë“œ ì •ë³´',0),(591396,16402,'ko','ê¸°ê¸ˆ ìš”ì•½',0),(591397,16403,'ko','ê³¼ê±°',0),(591398,16404,'ko','ë†’ì€ ë³¼ë¥¨',0),(591399,16405,'ko','ì´ì „ ë‹¬ì—ì„œ í•­ëª©',0),(591400,16406,'ko','ì—†ìŒ ë°ì´í„° ì§‘í•©',0),(591401,16407,'ko','ì´ ì„ íƒ í•˜ì§€',0),(591402,16408,'ko','ë°–ìœ¼ë¡œ ì§€ ì¶œê¸ˆ',0),(591403,16409,'ko','ê¸°ê¸ˆ',0),(591404,16410,'ko','ì˜ìˆ˜ì¦',0),(591405,16411,'ko','í¬í•¨ í•˜ëŠ” ìžê¸ˆ',0),(591406,16412,'ko','ì¶”ê°€ ì†¡ìž¥ ì˜µì…˜',0),(591407,16413,'ko','ì˜¤ë¥˜ ê²€ìƒ‰ ì†¡ìž¥',0),(591408,16414,'ko','ì¸ë³´ì´ìŠ¤ ì„¸ë¶€ ì‚¬í•­',0),(591409,16415,'ko','ì†¡ìž¥ ì§€ë¶ˆ',0),(591410,16416,'ko','ë³´ê¸°/ì„ íƒ í•­ëª©',0),(591411,16417,'ko','ì¶”ê°€ ì§€ë¶ˆ',0),(591412,16418,'ko','ì„¤ë¬¸ ì¡°ì‚¬ ì´ë©”ì¼ ì²¨ë¶€ íŒŒì¼',0),(591413,16419,'ko','íšŒì‚¬ ì‚¬ìš© ê¶Œí•œ',0),(591414,16389,'ms','Lesen tidak boleh ditentu sah semak akses Internet',0),(591415,16390,'ms','Lesen yang ditamatkan',0),(591416,16391,'ms','Nota-Nota kerja',0),(591417,16392,'ms','Tambah Nota',0),(591418,16393,'ms','Penjimatan',0),(591419,16394,'ms','Menyembunyikan kos AP kod bidang',0),(591420,16395,'ms','Sembunyi kemasukan pembayaran selepas POS',0),(591421,16396,'ms','POS entri disimpan',0),(591422,16397,'ms','Garisan tarikh',0),(591423,16398,'ms','Edit Debit & kredit sebagai satu kolum',0),(591424,16399,'ms','Menyembunyikan kos kod di muka surat catatan jurnal',0),(591425,16400,'ms','Aktiviti terkini',0),(591426,16401,'ms','Maklumat Tabung',0),(591427,16402,'ms','Ringkasan dana',0),(591428,16403,'ms','Masa lalu',0),(591429,16404,'ms','Kelantangan yang tinggi',0),(591430,16405,'ms','Penyertaan daripada bulan terlebih dahulu',0),(591431,16406,'ms','Set Data tidak',0),(591432,16407,'ms','Jumlah yang tidak dipilih',0),(591433,16408,'ms','Pengeluaran Keluar',0),(591434,16409,'ms','Dana',0),(591435,16410,'ms','Resit di',0),(591436,16411,'ms','Dana untuk memasukkan',0),(591437,16412,'ms','Invois tambahan pilihan',0),(591438,16413,'ms','Ralat mendapatkan invois',0),(591439,16414,'ms','Butir-butir invois',0),(591440,16415,'ms','Invois dibayar',0),(591441,16416,'ms','Pandangan/Pilih entri',0),(591442,16417,'ms','Pembayaran yang ditambah',0),(591443,16418,'ms','Lampiran e-mel kaji selidik',0),(591444,16419,'ms','Kebenaran Syarikat',0),(591445,16389,'no','Lisensen kan ikke verifiseres nÃ¥r Internett',0),(591446,16390,'no','Lisens avsluttet',0),(591447,16391,'no','Jobb notater',0),(591448,16392,'no','Legge til Merknad',0),(591449,16393,'no','Lagre',0),(591450,16394,'no','Skjule koden AP kostnadsfelt',0),(591451,16395,'no','Skjule betalingsposten etter POS',0),(591452,16396,'no','POS oppfÃ¸ringen lagret',0),(591453,16397,'no','Linje dato',0),(591454,16398,'no','Rediger debet & kreditt som Ã©n kolonne',0),(591455,16399,'no','Skjule pris koder pÃ¥ Journal toppoppfÃ¸ringen sider',0),(591456,16400,'no','Nylig aktivitet',0),(591457,16401,'no','Fondet detaljer',0),(591458,16402,'no','Fondet Sammendrag',0),(591459,16403,'no','Fortiden',0),(591460,16404,'no','HÃ¸yt volum',0),(591461,16405,'no','Poster fra tidligere mÃ¥neder',0),(591462,16406,'no','Ingen datasett',0),(591463,16407,'no','Totalt ikke valgt',0),(591464,16408,'no','Utlegg ut',0),(591465,16409,'no','Fondet',0),(591466,16410,'no','Kvitteringer i',0),(591467,16411,'no','Midler med',0),(591468,16412,'no','Ekstra faktura alternativer',0),(591469,16413,'no','Feil under henting av faktura',0),(591470,16414,'no','Fakturaopplysninger',0),(591471,16415,'no','Fakturaen er betalt',0),(591472,16416,'no','Vise/velge oppfÃ¸ringer',0),(591473,16417,'no','Betalinger lagt',0),(591474,16418,'no','UndersÃ¸kelsen e-postvedlegg',0),(591475,16419,'no','Selskapet tillatelser',0),(591476,16389,'pr','Ù…Ø¬ÙˆØ² Ù…ÛŒ Ø´ÙˆØ¯ ØªØ§ÛŒÛŒØ¯ Ù†Ø´Ø¯Ù‡ Ø¨Ø±Ø±Ø³ÛŒ Ø¯Ø³ØªØ±Ø³ÛŒ Ø¨Ù‡ Ø§ÛŒÙ†ØªØ±Ù†Øª',0),(591477,16390,'pr','Ù…Ø¬ÙˆØ² ÙØ³Ø®',0),(591478,16391,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ú©Ø§Ø±',0),(591479,16392,'pr','Ø§ÙØ²ÙˆØ¯Ù† ÛŒØ§Ø¯Ø¯Ø§Ø´Øª',0),(591480,16393,'pr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ',0),(591481,16394,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ø²Ù…ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³',0),(591482,16395,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ù…Ø·Ù„Ø¨ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ø¹Ø¯ Ø§Ø² Ø³Ù„Ø§Ù…ØªÛŒ',0),(591483,16396,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ POS Ø±Ø§ Ù†Ø¬Ø§Øª Ø¯Ø§Ø¯',0),(591484,16397,'pr','ØªØ§Ø±ÛŒØ® Ø®Ø·',0),(591485,16398,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø¨Ø¯Ù‡ÛŒ & Ø§Ø¹ØªØ¨Ø§Ø±ÛŒ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† ÛŒÚ© Ø³ØªÙˆÙ†',0),(591486,16399,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ú©Ø¯Ù‡Ø§ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø¯Ø± Ù…Ø¬Ù„Ù‡ ØµÙØ­Ù‡ ÙˆØ±ÙˆØ¯',0),(591487,16400,'pr','ÙØ¹Ø§Ù„ÛŒØª Ù‡Ø§ÛŒ Ø§Ø®ÛŒØ±',0),(591488,16401,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª ØµÙ†Ø¯ÙˆÙ‚',0),(591489,16402,'pr','Ø®Ù„Ø§ØµÙ‡ ØµÙ†Ø¯ÙˆÙ‚',0),(591490,16403,'pr','Ú¯Ø°Ø´ØªÙ‡',0),(591491,16404,'pr','Ø­Ø¬Ù… Ø¨Ø§Ù„Ø§',0),(591492,16405,'pr','Ù‡Ø§ Ø§Ø² Ù…Ø§Ù‡ Ù‚Ø¨Ù„',0),(591493,16406,'pr','Ù‡ÛŒÚ† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§',0),(591494,16407,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù†ØªØ®Ø§Ø¨ Ù†Ø´Ø¯Ù‡',0),(591495,16408,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ú©Ø±Ø¯Ù†',0),(591496,16409,'pr','ØµÙ†Ø¯ÙˆÙ‚',0),(591497,16410,'pr','Ø±Ø³ÛŒØ¯ Ø¯Ø±',0),(591498,16411,'pr','Ø¨ÙˆØ¯Ø¬Ù‡ Ø´Ø§Ù…Ù„',0),(591499,16412,'pr','Ú¯Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø§Ø¶Ø§ÙÛŒ ÙØ§Ú©ØªÙˆØ±',0),(591500,16413,'pr','Ø®Ø·Ø§ÛŒ Ø¨Ø§Ø²ÛŒØ§Ø¨ÛŒ ÙØ§Ú©ØªÙˆØ±',0),(591501,16414,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª ÙØ§Ú©ØªÙˆØ±',0),(591502,16415,'pr','ÙØ§Ú©ØªÙˆØ± Ù¾Ø±Ø¯Ø§Ø®Øª Ù…ÛŒ Ø´ÙˆØ¯',0),(591503,16416,'pr','Ù…Ø´Ø§Ù‡Ø¯Ù‡/Ù†ÙˆØ´ØªÙ‡ Ù‡Ø§ÛŒ Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(591504,16417,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡',0),(591505,16418,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø§ÛŒÙ…ÛŒÙ„ Ù¾ÛŒÙˆØ³Øª',0),(591506,16419,'pr','Ù…Ø¬ÙˆØ² Ø´Ø±Ú©Øª',0),(591507,16389,'pl','Nie moÅ¼na zweryfikowaÄ‡ licencji SprawdÅº dostÄ™p do Internetu',0),(591508,16390,'pl','Licencja zakoÅ„czony',0),(591509,16391,'pl','Informacje o pracy',0),(591510,16392,'pl','Dodawanie notatki',0),(591511,16393,'pl','Zapisywanie',0),(591512,16394,'pl','Ukrywanie pÃ³l kod AP koszt',0),(591513,16395,'pl','Ukryj wpis pÅ‚atnoÅ›ci po POS',0),(591514,16396,'pl','Zapisano na wejÅ›cia POS',0),(591515,16397,'pl','Data linii',0),(591516,16398,'pl','EdytowaÄ‡ debetowej & kredytowej jako jedna kolumna',0),(591517,16399,'pl','Ukryj kody kosztÃ³w na strony zapisu ksiÄ™gowego',0),(591518,16400,'pl','Ostatnie dziaÅ‚ania',0),(591519,16401,'pl','Dane Funduszu',0),(591520,16402,'pl','KrÃ³tki opis Funduszu',0),(591521,16403,'pl','PrzeszÅ‚oÅ›ci',0),(591522,16404,'pl','Wysokim poziomie gÅ‚oÅ›noÅ›ci',0),(591523,16405,'pl','Wpisy z poprzednich miesiÄ™cy',0),(591524,16406,'pl','Nie zestaw danych',0),(591525,16407,'pl','Sumie nie zaznaczone',0),(591526,16408,'pl','WypÅ‚at z',0),(591527,16409,'pl','Fundusz',0),(591528,16410,'pl','WpÅ‚ywy w',0),(591529,16411,'pl','Funduszy, aby uwzglÄ™dniÄ‡',0),(591530,16412,'pl','Opcje dodatkowe faktury',0),(591531,16413,'pl','BÅ‚Ä…d pobierania faktury',0),(591532,16414,'pl','SzczegÃ³Å‚y faktury',0),(591533,16415,'pl','ZapÅ‚acenia faktury',0),(591534,16416,'pl','Widok/wybierz wpisy',0),(591535,16417,'pl','PÅ‚atnoÅ›ci dodane',0),(591536,16418,'pl','ZaÅ‚Ä…cznik E-mail badania',0),(591537,16419,'pl','Uprawnienia firmy',0),(591538,16389,'pt','LicenÃ§a nÃ£o pÃ´de ser verificada Verifique o acesso Ã  Internet',0),(591539,16390,'pt','LicenÃ§a terminada',0),(591540,16391,'pt','Notas de trabalho',0),(591541,16392,'pt','Adicionar nota',0),(591542,16393,'pt','Economia',0),(591543,16394,'pt','Ocultar campos de cÃ³digo de custo de AP',0),(591544,16395,'pt','Ocultar a entrada de pagamento depois de POS',0),(591545,16396,'pt','POS entrada guardada',0),(591546,16397,'pt','Linha de data',0),(591547,16398,'pt','Edite o dÃ©bito e crÃ©dito como uma coluna',0),(591548,16399,'pt','Esconder cÃ³digos de custo nas pÃ¡ginas de entrada de diÃ¡rio',0),(591549,16400,'pt','Atividade recente',0),(591550,16401,'pt','Detalhes de fundo',0),(591551,16402,'pt','Resumo do fundo',0),(591552,16403,'pt','Passado',0),(591553,16404,'pt','Alto Volume',0),(591554,16405,'pt','Entradas de meses anteriores',0),(591555,16406,'pt','Nenhum conjunto de dados',0),(591556,16407,'pt','Total nÃ£o selecionado',0),(591557,16408,'pt','Desembolsos para fora',0),(591558,16409,'pt','Fundo',0),(591559,16410,'pt','Recibos em',0),(591560,16411,'pt','Fundos para incluir',0),(591561,16412,'pt','OpÃ§Ãµes adicionais de factura',0),(591562,16413,'pt','Factura de recuperaÃ§Ã£o de erro',0),(591563,16414,'pt','Detalhes da fatura',0),(591564,16415,'pt','Fatura Ã© paga',0),(591565,16416,'pt','SeleÃ§Ã£o de modo de exibiÃ§Ã£o/entradas',0),(591566,16417,'pt','Pagamentos adicionados',0),(591567,16418,'pt','Anexo de E-mail de pesquisa',0),(591568,16419,'pt','PermissÃµes de empresa',0),(591569,16389,'ro','A da un permis nu au putut fi verificate verifica acces Internet',0),(591570,16390,'ro','LicenÅ£Äƒ Ã®ncheiatÄƒ',0),(591571,16391,'ro','Job note',0),(591572,16392,'ro','Adauga nota',0),(591573,16393,'ro','Salvarea',0),(591574,16394,'ro','Ascunde cÃ¢mpurile de cod AP Cost',0),(591575,16395,'ro','Ascunde plata intrare dupÄƒ POS',0),(591576,16396,'ro','POS intrare salvate',0),(591577,16397,'ro','Data de linie',0),(591578,16398,'ro','Editare Debit & Credit ca o coloanÄƒ',0),(591579,16399,'ro','Ascunde codurile Cost pe paginile de intrare jurnal',0),(591580,16400,'ro','Activitatea recentÄƒ',0),(591581,16401,'ro','Fondul detalii',0),(591582,16402,'ro','Fondul Rezumat',0),(591583,16403,'ro','Trecut',0),(591584,16404,'ro','Volum mare',0),(591585,16405,'ro','IntrÄƒrile de luni anterioare',0),(591586,16406,'ro','Nici un Set de date',0),(591587,16407,'ro','Total selectat nu',0),(591588,16408,'ro','PlÄƒÅ£i Ã®n',0),(591589,16409,'ro','Fondul',0),(591590,16410,'ro','ÃŽncasÄƒri Ã®n',0),(591591,16411,'ro','Fonduri pentru a Include',0),(591592,16412,'ro','OpÅ£iuni suplimentare de facturÄƒ',0),(591593,16413,'ro','Eroare recuperare factura',0),(591594,16414,'ro','Detalii facturÄƒ',0),(591595,16415,'ro','Factura se achita',0),(591596,16416,'ro','Vezi/selectaÅ£i intrÄƒri',0),(591597,16417,'ro','AdÄƒugat de plÄƒÅ£i',0),(591598,16418,'ro','AtaÅŸament de E-mail sondaj',0),(591599,16419,'ro','Compania permisiuni',0),(591600,16389,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð»Ð¸Ñ†ÐµÐ½Ð·Ð¸ÑŽ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð´Ð¾ÑÑ‚ÑƒÐ¿ Ð² Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚',0),(591601,16390,'ru','Ð›Ð¸Ñ†ÐµÐ½Ð·Ð¸Ñ Ð¿Ñ€ÐµÐºÑ€Ð°Ñ‰ÐµÐ½Ð°',0),(591602,16391,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð·Ð°Ð¼ÐµÑ‚ÐºÐ¸',0),(591603,16392,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð·Ð°Ð¼ÐµÑ‚ÐºÑƒ',0),(591604,16393,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ',0),(591605,16394,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÐºÐ¾Ð´ Ð¿Ð¾Ð»Ñ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ AP',0),(591606,16395,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð° Ð¿Ð¾ÑÐ»Ðµ POS',0),(591607,16396,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð½Ñ‹Ðµ Ð·Ð°Ð¿Ð¸ÑÐ¸ POS',0),(591608,16397,'ru','Ð”Ð°Ñ‚Ð° Ð»Ð¸Ð½Ð¸Ð¸',0),(591609,16398,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð´ÐµÐ±ÐµÑ‚Ð¾Ð²Ñ‹Ðµ & ÐºÑ€ÐµÐ´Ð¸Ñ‚ ÐºÐ°Ðº Ð¾Ð´Ð¸Ð½ ÑÑ‚Ð¾Ð»Ð±ÐµÑ†',0),(591610,16399,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ ÐºÐ¾Ð´Ñ‹ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ñ… Ð¶ÑƒÑ€Ð½Ð°Ð»Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(591611,16400,'ru','ÐÐµÐ´Ð°Ð²Ð½ÑÑ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚ÑŒ',0),(591612,16401,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ Ñ„Ð¾Ð½Ð´Ð°',0),(591613,16402,'ru','Ð¤Ð¾Ð½Ð´ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(591614,16403,'ru','ÐŸÑ€Ð¾ÑˆÐ»Ð¾Ðµ',0),(591615,16404,'ru','Ð‘Ð¾Ð»ÑŒÑˆÐ¾Ð¹ Ð¾Ð±ÑŠÐµÐ¼',0),(591616,16405,'ru','Ð—Ð°Ð¿Ð¸ÑÐ¸ Ð¸Ð· Ð¿Ñ€ÐµÐ´Ñ‹Ð´ÑƒÑ‰Ð¸Ñ… Ð¼ÐµÑÑÑ†ÐµÐ²',0),(591617,16406,'ru','ÐÐµÑ‚ Ð½Ð°Ð±Ð¾Ñ€Ð° Ð´Ð°Ð½Ð½Ñ‹Ñ…',0),(591618,16407,'ru','Ð’ÑÐµÐ³Ð¾ Ð½Ðµ Ð²Ñ‹Ð±Ñ€Ð°Ð½Ð¾',0),(591619,16408,'ru','Ð’Ñ‹Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¸Ð·',0),(591620,16409,'ru','Ð¤Ð¾Ð½Ð´',0),(591621,16410,'ru','ÐŸÐ¾ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ Ð²',0),(591622,16411,'ru','Ð¡Ñ€ÐµÐ´ÑÑ‚Ð²Ð° Ð´Ð»Ñ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸Ñ',0),(591623,16412,'ru','ÐŸÐ°Ñ€Ð°Ð¼ÐµÑ‚Ñ€Ñ‹ Ð´Ð¾Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð°',0),(591624,16413,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ñ Ð½Ð°ÐºÐ»Ð°Ð´Ð½Ð¾Ð¹',0),(591625,16414,'ru','Ð¡Ð²ÐµÐ´ÐµÐ½Ð¸Ñ Ð¾ ÑÑ‡ÐµÑ‚Ðµ',0),(591626,16415,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¾Ð¿Ð»Ð°Ñ‡ÐµÐ½',0),(591627,16416,'ru','ÐŸÑ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€/Ð²Ñ‹Ð±Ð¾Ñ€ Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(591628,16417,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð¿Ð»Ð°Ñ‚ÐµÐ¶Ð¸',0),(591629,16418,'ru','ÐžÐ±Ð·Ð¾Ñ€ Ð²Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¹ ÑÐ»ÐµÐºÑ‚Ñ€Ð¾Ð½Ð½Ð¾Ð¹ Ð¿Ð¾Ñ‡Ñ‚Ñ‹',0),(591630,16419,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐµÐ½Ð¸Ñ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸',0),(591631,16389,'sr','Ð›Ð¸Ñ†ÐµÐ½Ñ†Ðµ Ð½Ð¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸ Ð¿Ñ€Ð¸ÑÑ‚ÑƒÐ¿ Ð˜Ð½Ñ‚ÐµÑ€Ð½ÐµÑ‚Ñƒ',0),(591632,16390,'sr','Ð›Ð¸Ñ†ÐµÐ½Ñ†Ð° Ñ˜Ðµ Ð¿Ñ€ÐµÐºÐ¸Ð½ÑƒÑ‚',0),(591633,16391,'sr','ÐŸÐ¾ÑÐ°Ð¾ ÑÐ° Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ð°Ð¼Ð°',0),(591634,16392,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ Ð±ÐµÐ»ÐµÑˆÐºÐµ',0),(591635,16393,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ',0),(591636,16394,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÐÐŸ Ñ‚Ñ€Ð¾ÑˆÐ°Ðº ÐºÐ¾Ð´Ð° Ð¿Ð¾Ñ™Ð°',0),(591637,16395,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ ÑÑ‚Ð°Ð²ÐºÑƒ ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð½Ð°ÐºÐ¾Ð½ ÐŸÐžÐ¡',0),(591638,16396,'sr','ÐŸÐžÐ¡ ÑÑ‚Ð°Ð²ÐºÐ° ÑÐ°Ñ‡ÑƒÐ²Ð°Ð½Ð°.',0),(591639,16397,'sr','ÐÐ° Ð»Ð¸Ð½Ð¸Ñ˜Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼Ð°',0),(591640,16398,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð´ÑƒÐ³Ð¾Ð²Ð°ÑšÐ° Ð¸ Ð¿Ð¾Ñ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐ° ÐºÐ°Ð¾ Ñ˜ÐµÐ´Ð½Ñƒ ÐºÐ¾Ð»Ð¾Ð½Ñƒ',0),(591641,16399,'sr','Ð¡Ð°ÐºÑ€Ð¸Ñ˜ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÐºÐ¾Ð´Ð¾Ð²Ðµ Ð½Ð° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð°Ð¼Ð° Ð·Ð° ÑƒÐ½Ð¾Ñ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(591642,16400,'sr','ÐÐµÐ´Ð°Ð²Ð½Ðµ Ð°ÐºÑ‚Ð¸Ð²Ð½Ð¾ÑÑ‚Ð¸',0),(591643,16401,'sr','Ð¤Ð¾Ð½Ð´ Ð·Ð° Ð´ÐµÑ‚Ð°Ñ™Ðµ',0),(591644,16402,'sr','Ð¤Ð¾Ð½Ð´ Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(591645,16403,'sr','ÐŸÑ€Ð¾ÑˆÐ»Ð¾ÑÑ‚',0),(591646,16404,'sr','Ð’Ð¸ÑÐ¾ÐºÐ¸ Ð²Ð¾Ð»ÑƒÐ¼ÐµÐ½',0),(591647,16405,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð¸Ð· Ð¿Ñ€ÐµÑ‚Ñ…Ð¾Ð´Ð½Ð¸Ñ… Ð¼ÐµÑÐµÑ†Ð¸',0),(591648,16406,'sr','ÐÐµÐ¼Ð° ÑÐºÑƒÐ¿ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ°',0),(591649,16407,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð½Ð¸Ñ˜Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð½Ð¾',0),(591650,16408,'sr','Ð˜ÑÐ¿Ð»Ð°Ñ‚Ðµ ÑÐµ',0),(591651,16409,'sr','Ð¤Ð¾Ð½Ð´',0),(591652,16410,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ðµ Ñƒ',0),(591653,16411,'sr','Ð¡Ñ€ÐµÐ´ÑÑ‚Ð²Ð° Ð´Ð° ÑƒÐºÑ™ÑƒÑ‡Ð¸Ñ‚Ðµ',0),(591654,16412,'sr','ÐžÐ¿Ñ†Ð¸Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(591655,16413,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ Ð¿Ñ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐ° Ñ„Ð°ÐºÑ‚ÑƒÑ€Ð°',0),(591656,16414,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(591657,16415,'sr','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ñ˜Ðµ Ð¿Ð»Ð°Ñ›ÐµÐ½Ð°',0),(591658,16416,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð· /Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸ ÑÑ‚Ð°Ð²ÐºÐµ',0),(591659,16417,'sr','Ð˜ÑÐ¿Ð»Ð°Ñ‚Ð° Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð¾',0),(591660,16418,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð¶Ð¸Ð²Ð°ÑšÐµ Ð¿Ñ€Ð¸Ð»Ð¾Ð³Ð° Ðµ-Ð¿Ð¾Ñ€ÑƒÐºÐµ',0),(591661,16419,'sr','ÐšÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ð° Ð´Ð¾Ð·Ð²Ð¾Ð»Ðµ',0),(591662,16389,'si','Ni mogoÄe preveriti dati dovoljenje Äek staÅ¾ist v bolniÅ¡nici postranski',0),(591663,16390,'si','Licence, ki preneha',0),(591664,16391,'si','Delo ugotavlja',0),(591665,16392,'si','Dodajte opombo',0),(591666,16393,'si','VarÄevanje',0),(591667,16394,'si','Skriti stroÅ¡ki AP kodo polja',0),(591668,16395,'si','Skriti postavko plaÄila po POS',0),(591669,16396,'si','POS vstop shranjena',0),(591670,16397,'si','ÄŒrta datum',0),(591671,16398,'si','Urejanje breme & kreditne kot en stolpec',0),(591672,16399,'si','Skriti stroÅ¡ki kode na strani vnos temeljnice',0),(591673,16400,'si','Nedavne dejavnosti',0),(591674,16401,'si','Sklad podrobnosti',0),(591675,16402,'si','Sklad Povzetek',0),(591676,16403,'si','Preteklosti',0),(591677,16404,'si','Velik obseg',0),(591678,16405,'si','Postavke iz predhodnega meseca',0),(591679,16406,'si','Ni nabor podatkov',0),(591680,16407,'si','Skupaj ni izbrana',0),(591681,16408,'si','IzplaÄil',0),(591682,16409,'si','Sklad',0),(591683,16410,'si','Prejemki v',0),(591684,16411,'si','Sredstev za vkljuÄitev',0),(591685,16412,'si','MoÅ¾nosti dodatne raÄuna',0),(591686,16413,'si','Napaka pri pridobivanju raÄuna',0),(591687,16414,'si','Podrobnosti raÄuna',0),(591688,16415,'si','PlaÄati raÄun',0),(591689,16416,'si','Pogled/izberite vnose',0),(591690,16417,'si','PlaÄila, ki se doda',0),(591691,16418,'si','Raziskava e-poÅ¡tno prilogo',0),(591692,16419,'si','Podjetje dovoljenja',0),(591693,16389,'es','No se podrÃ­a verificar licencia Compruebe la conexiÃ³n a Internet',0),(591694,16390,'es','Licencia terminada',0),(591695,16391,'es','Notas de trabajo',0),(591696,16392,'es','AÃ±adir Nota',0),(591697,16393,'es','Ahorro',0),(591698,16394,'es','Ocultar campos de cÃ³digo de costo AP',0),(591699,16395,'es','Ocultar entrada de pago despuÃ©s de POS',0),(591700,16396,'es','POS entrada guardada',0),(591701,16397,'es','LÃ­nea fecha',0),(591702,16398,'es','Editar el dÃ©bito y crÃ©dito como una columna',0),(591703,16399,'es','Ocultar cÃ³digos de costo en las pÃ¡ginas de entrada de diario',0),(591704,16400,'es','Actividad reciente',0),(591705,16401,'es','Detalles de fondo',0),(591706,16402,'es','Resumen de fondo',0),(591707,16403,'es','Pasado',0),(591708,16404,'es','Alto volumen',0),(591709,16405,'es','Entradas de meses anteriores',0),(591710,16406,'es','NingÃºn conjunto de datos',0),(591711,16407,'es','Total no seleccionado',0),(591712,16408,'es','Desembolsos a',0),(591713,16409,'es','Fondo',0),(591714,16410,'es','Recibos en',0),(591715,16411,'es','Fondos para incluir',0),(591716,16412,'es','Opciones adicionales de la factura',0),(591717,16413,'es','Error recuperando factura',0),(591718,16414,'es','Detalles de factura',0),(591719,16415,'es','Se paga la factura',0),(591720,16416,'es','Ver selecciÃ³n de entradas',0),(591721,16417,'es','Pagos aÃ±adidos',0),(591722,16418,'es','Anexo de correo electrÃ³nico de la encuesta',0),(591723,16419,'es','Permisos de la empresa',0),(591724,16389,'sv','Licens kunde inte verifieras kontrollera tillgÃ¥ng till Internet',0),(591725,16390,'sv','Licens avslutas',0),(591726,16391,'sv','Jobb anteckningar',0),(591727,16392,'sv','LÃ¤gga till anteckning',0),(591728,16393,'sv','Spara',0),(591729,16394,'sv','DÃ¶lja AP kod kostnadsfÃ¤lt',0),(591730,16395,'sv','DÃ¶lja betalningstransaktionen efter POS',0),(591731,16396,'sv','Sparad i POS Entry',0),(591732,16397,'sv','Line datum',0),(591733,16398,'sv','Redigera debet & kredit som en kolumn',0),(591734,16399,'sv','DÃ¶lja kostnad koder pÃ¥ tidning posten sidor',0),(591735,16400,'sv','Senaste aktivitet',0),(591736,16401,'sv','Fonden Detaljer',0),(591737,16402,'sv','Sammanfattning',0),(591738,16403,'sv','Tidigare',0),(591739,16404,'sv','HÃ¶g volym',0),(591740,16405,'sv','Transaktioner frÃ¥n fÃ¶regÃ¥ende mÃ¥nader',0),(591741,16406,'sv','Ingen datauppsÃ¤ttning',0),(591742,16407,'sv','Totalt inte markerad',0),(591743,16408,'sv','Utbetalningar ut',0),(591744,16409,'sv','Fonden',0),(591745,16410,'sv','Kvitton i',0),(591746,16411,'sv','Medel fÃ¶r att inkludera',0),(591747,16412,'sv','Ytterligare faktura alternativ',0),(591748,16413,'sv','Fel hÃ¤mtar fakturan',0),(591749,16414,'sv','Fakturadetaljer',0),(591750,16415,'sv','Fakturan Ã¤r betald',0),(591751,16416,'sv','Visa/VÃ¤lj poster',0),(591752,16417,'sv','Betalningar till',0),(591753,16418,'sv','UndersÃ¶kning e-postbilaga',0),(591754,16419,'sv','FÃ¶retaget behÃ¶righeter',0),(591755,16389,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸ªà¸´à¸—à¸˜à¸´à¹Œà¸à¸²à¸£à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸­à¸´à¸™à¹€à¸—à¸­à¸£à¹Œà¹€à¸™à¹‡à¸•à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(591756,16390,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¹ƒà¸šà¸­à¸™à¸¸à¸à¸²à¸•',0),(591757,16391,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸‡à¸²à¸™',0),(591758,16392,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸',0),(591759,16393,'th','à¸›à¸£à¸°à¸«à¸¢à¸±à¸”',0),(591760,16394,'th','à¸‹à¹ˆà¸­à¸™à¹€à¸‚à¸•à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™ AP',0),(591761,16395,'th','à¸‹à¹ˆà¸­à¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸ POS',0),(591762,16396,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸£à¸²à¸¢à¸à¸²à¸£ POS',0),(591763,16397,'th','à¸§à¸±à¸™à¸£à¸²à¸¢à¸à¸²à¸£',0),(591764,16398,'th','à¹à¸à¹‰à¹„à¸‚à¹€à¸”à¸šà¸´à¸•à¹à¸¥à¸°à¹€à¸„à¸£à¸”à¸´à¸•à¹€à¸›à¹‡à¸™à¸«à¸™à¸¶à¹ˆà¸‡à¸„à¸­à¸¥à¸±à¸¡à¸™à¹Œ',0),(591765,16399,'th','à¸‹à¹ˆà¸­à¸™à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™à¸«à¸™à¹‰à¸²à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸¡à¸¸à¸”à¸£à¸²à¸¢à¸§à¸±à¸™',0),(591766,16400,'th','à¸à¸´à¸ˆà¸à¸£à¸£à¸¡à¸¥à¹ˆà¸²à¸ªà¸¸à¸”',0),(591767,16401,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¸à¸­à¸‡à¸—à¸¸à¸™',0),(591768,16402,'th','à¸ªà¸£à¸¸à¸›à¸à¸­à¸‡à¸—à¸¸à¸™',0),(591769,16403,'th','à¸­à¸”à¸µà¸•à¸—à¸µà¹ˆà¸œà¹ˆà¸²à¸™à¸¡à¸²',0),(591770,16404,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸ªà¸¹à¸‡',0),(591771,16405,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸ˆà¸²à¸à¹€à¸”à¸·à¸­à¸™à¸à¹ˆà¸­à¸™à¸«à¸™à¹‰à¸²',0),(591772,16406,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸Šà¸¸à¸”à¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(591773,16407,'th','à¹„à¸¡à¹ˆà¹€à¸¥à¸·à¸­à¸à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(591774,16408,'th','à¹€à¸šà¸´à¸à¸ˆà¹ˆà¸²à¸¢à¸­à¸­à¸',0),(591775,16409,'th','à¸à¸­à¸‡à¸—à¸¸à¸™à¸£à¸§à¸¡',0),(591776,16410,'th','à¸£à¸±à¸šà¹ƒà¸™',0),(591777,16411,'th','à¸à¸­à¸‡à¸—à¸¸à¸™à¸£à¸§à¸¡',0),(591778,16412,'th','à¸•à¸±à¸§à¹€à¸¥à¸·à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(591779,16413,'th','à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸£à¸µà¸¢à¸à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”',0),(591780,16414,'th','à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(591781,16415,'th','à¸¡à¸µà¸Šà¸³à¸£à¸°à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰',0),(591782,16416,'th','à¸”à¸¹/à¹€à¸¥à¸·à¸­à¸à¸£à¸²à¸¢à¸à¸²à¸£',0),(591783,16417,'th','à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹€à¸žà¸´à¹ˆà¸¡',0),(591784,16418,'th','à¹à¸šà¸šà¸ªà¸³à¸£à¸§à¸ˆà¸—à¸µà¹ˆà¹à¸™à¸šà¸­à¸µà¹€à¸¡à¸¥',0),(591785,16419,'th','à¸šà¸£à¸´à¸©à¸±à¸—à¸ªà¸´à¸—à¸˜à¸´à¹Œ',0),(591786,16389,'tr','Lisans doÄŸrulanamadÄ± kontrol Internet baÄŸlantÄ±sÄ±',0),(591787,16390,'tr','Lisans sona erdi',0),(591788,16391,'tr','Ä°ÅŸ notlarÄ±',0),(591789,16392,'tr','Not ekleme',0),(591790,16393,'tr','Kaydetme',0),(591791,16394,'tr','AP maliyet kodu alanlarÄ± gizle',0),(591792,16395,'tr','Ã–deme giriÅŸi POS sonra gizle',0),(591793,16396,'tr','POS giriÅŸ kaydedilir',0),(591794,16397,'tr','SatÄ±rÄ±n tarihi',0),(591795,16398,'tr','Banka ve kredi bir sÃ¼tun DÃ¼zenle',0),(591796,16399,'tr','GÃ¼nlÃ¼k giriÅŸ sayfalarÄ±nda maliyet kodlarÄ± gizle',0),(591797,16400,'tr','Son etkinlik',0),(591798,16401,'tr','Fon detaylarÄ±',0),(591799,16402,'tr','Fon Ã–zeti',0),(591800,16403,'tr','GeÃ§miÅŸ',0),(591801,16404,'tr','YÃ¼ksek hacimli',0),(591802,16405,'tr','Ã–nceki ay giriÅŸler',0),(591803,16406,'tr','HiÃ§bir veri kÃ¼mesi',0),(591804,16407,'tr','SeÃ§ili toplam',0),(591805,16408,'tr','Ã–demeler dÄ±ÅŸarÄ±',0),(591806,16409,'tr','Fonu',0),(591807,16410,'tr','GiriÅŸ iÃ§inde',0),(591808,16411,'tr','Fon eklemek iÃ§in',0),(591809,16412,'tr','Ek fatura seÃ§enekleri',0),(591810,16413,'tr','Hata alma fatura',0),(591811,16414,'tr','Fatura ayrÄ±ntÄ±larÄ±',0),(591812,16415,'tr','Fatura Ã¶deme',0),(591813,16416,'tr','GÃ¶rÃ¼nÃ¼m/giriÅŸleri seÃ§in',0),(591814,16417,'tr','Ã–demeler eklendi',0),(591815,16418,'tr','Anket e-posta eki',0),(591816,16419,'tr','Åžirket izinleri',0),(591817,16389,'ur','Ù„Ø§Ø¦Ø³Ù†Ø³ ØªØµØ¯ÛŒÙ‚ Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©ÛŒ Ø§Ù†Ù¹Ø±Ù†ÛŒÙ¹ ØªÚ© Ø±Ø³Ø§Ø¦ÛŒ Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(591818,16390,'ur','Ù„Ø§Ø¦Ø³Ù†Ø³ Ø®ØªÙ… Ú©Ø± Ø¯ÛŒØ§',0),(591819,16391,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ù†ÙˆÙ¹',0),(591820,16392,'ur','Ù†ÙˆÙ¹ Ø´Ø§Ù…Ù„ Ú©Ø±ÛŒÚº',0),(591821,16393,'ur','Ù…Ø­ÙÙˆØ¸ Ú©Ø± Ø±ÛØ§ ÛÛ’',0),(591822,16394,'ur','AP Ù„Ø§Ú¯Øª Ú©ÙˆÚˆ Ù‚Ø·Ø¹Ø§Øª Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(591823,16395,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ Ø¨Ø¹Ø¯ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(591824,16396,'ur','Ù¾ÙˆØ²ÛŒØ´Ù† Ø§Ù†Ø¯Ø±Ø§Ø¬ Ù…Ø­ÙÙˆØ¸',0),(591825,16397,'ur','Ø³Ø·Ø± ØªØ§Ø±ÛŒØ®',0),(591826,16398,'ur','ÚˆÛŒØ¨Ù¹ & Ú©Ø±ÛŒÚˆÙ¹ Ø§ÛŒÚ© Ú©Ø§Ù„Ù… Ú©Û’ Ø·ÙˆØ± Ù¾Ø± ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(591827,16399,'ur','Ø±ÙˆØ²Ù†Ø§Ù…Ú†Û Ø§Ù†Ø¯Ø±Ø§Ø¬ ØµÙØ­Ø§Øª Ù¾Ø± Ù„Ø§Ú¯Øª Ø¶Ø§Ø¨Ø·Û’ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(591828,16400,'ur','Ø­Ø§Ù„ÛŒÛ Ø³Ø±Ú¯Ø±Ù…ÛŒ',0),(591829,16401,'ur','ÙÙ†Úˆ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(591830,16402,'ur','ÙÙ†Úˆ Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(591831,16403,'ur','Ù…Ø§Ø¶ÛŒ',0),(591832,16404,'ur','Ø§Ø¹Ù„ÛŒ Ø­Ø¬Ù…',0),(591833,16405,'ur','Ú¯Ø²Ø´ØªÛ Ù…Ø§Û Ø³Û’ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(591834,16406,'ur','Ú©ÙˆØ§Ø¦Ù Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(591835,16407,'ur','Ú©Ù„ Ù…Ù†ØªØ®Ø¨ Ù†ÛÛŒÚº',0),(591836,16408,'ur','Ù…Ù†Ú¯ÙˆØ§Ù†Û’ Ú©Û’ Ø¨Ø§ÛØ±',0),(591837,16409,'ur','ÙÙ†Úˆ',0),(591838,16410,'ur','Ø±Ø³ÛŒØ¯ÛŒÚº Ù…ÛŒÚº',0),(591839,16411,'ur','Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ Ø±Ù‚Ù…',0),(591840,16412,'ur','Ø§Ø¶Ø§ÙÛŒ Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Û’ Ø§Ø®ØªÛŒØ§Ø±Ø§Øª',0),(591841,16413,'ur','Ù†Ù‚Øµ Ø§Ù†ÙˆØ§Ø¦Ø³ Ø¨Ø§Ø²Ú¯ÛŒØ± Ú©Ø±Ø±ÛØ§ ÛÛ’',0),(591842,16414,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(591843,16415,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ú©Ùˆ Ø§Ø¯Ø§ Ú©ÛŒØ§ Ø¬Ø§ØªØ§ ÛÛ’',0),(591844,16416,'ur','Ù…Ù†Ø¸Ø±/Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(591845,16417,'ur','Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒÙˆÚº Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ',0),(591846,16418,'ur','Ø³Ø±ÙˆÛ’ Ø§ÛŒ Ù…ÛŒÙ„ Ù…Ù†Ø³Ù„Ú©Û',0),(591847,16419,'ur','Ú©Ù…Ù¾Ù†ÛŒ Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª',0),(591848,16389,'vi','Giáº¥y phÃ©p khÃ´ng Ä‘Æ°á»£c xÃ¡c minh kiá»ƒm tra truy cáº­p Internet',0),(591849,16390,'vi','Giáº¥y phÃ©p bá»‹ cháº¥m dá»©t',0),(591850,16391,'vi','Ghi chÃº cÃ´ng viá»‡c',0),(591851,16392,'vi','ThÃªm ghi chÃº',0),(591852,16393,'vi','Tiáº¿t kiá»‡m',0),(591853,16394,'vi','áº¨n chi phÃ­ AP mÃ£ trÆ°á»ng',0),(591854,16395,'vi','áº¨n má»¥c thanh toÃ¡n sau khi POS',0),(591855,16396,'vi','POS má»¥c lÆ°u',0),(591856,16397,'vi','Line ngÃ y',0),(591857,16398,'vi','Chá»‰nh sá»­a ghi ná»£ & tÃ­n dá»¥ng nhÆ° lÃ  má»™t cá»™t',0),(591858,16399,'vi','áº¨n cÃ¡c mÃ£ sá»‘ chi phÃ­ trÃªn táº¡p chÃ­ má»¥c trang',0),(591859,16400,'vi','Hoáº¡t Ä‘á»™ng gáº§n Ä‘Ã¢y',0),(591860,16401,'vi','Quá»¹ chi tiáº¿t',0),(591861,16402,'vi','Quá»¹ tÃ³m táº¯t',0),(591862,16403,'vi','QuÃ¡ khá»©',0),(591863,16404,'vi','Khá»‘i lÆ°á»£ng lá»›n',0),(591864,16405,'vi','Má»¥c cÃ³ tá»« thÃ¡ng trÆ°á»›c',0),(591865,16406,'vi','KhÃ´ng cÃ³ dá»¯ liá»‡u thiáº¿t láº­p',0),(591866,16407,'vi','Táº¥t cáº£ khÃ´ng Ä‘Æ°á»£c chá»n',0),(591867,16408,'vi','Giáº£i ngÃ¢n ra',0),(591868,16409,'vi','Quá»¹',0),(591869,16410,'vi','Trong cÃ¡c biÃªn lai',0),(591870,16411,'vi','Quá»¹ Ä‘á»ƒ bao gá»“m',0),(591871,16412,'vi','TÃ¹y chá»n bá»• sung hÃ³a Ä‘Æ¡n',0),(591872,16413,'vi','Lá»—i truy xuáº¥t hÃ³a Ä‘Æ¡n',0),(591873,16414,'vi','HoÃ¡ Ä‘Æ¡n chi tiáº¿t',0),(591874,16415,'vi','HÃ³a Ä‘Æ¡n thanh toÃ¡n',0),(591875,16416,'vi','Xem/chá»n má»¥c',0),(591876,16417,'vi','ThÃªm vÃ o cÃ¡c khoáº£n thanh toÃ¡n',0),(591877,16418,'vi','Cuá»™c Ä‘iá»u tra Email Ä‘Ã­nh kÃ¨m',0),(591878,16419,'vi','CÃ´ng ty cáº¥p phÃ©p',0),(591879,16427,'en','Account #',0),(591880,16444,'en','A New Shipment Was Created After You Had Selected To Ship',0),(591881,16437,'en','Balance Remaining',0),(591882,16428,'en','Balance Sheet - Categorized',0),(591883,16457,'en','Blind Ship',0),(591884,16434,'en','Certificate Name',0),(591885,16435,'en','Certificate Type',0),(591886,16420,'en','Check Information',0),(591887,16421,'en','Check Not Found',0),(591888,16422,'en','Check Saved',0),(591889,16432,'en','Cost Summary',0),(591890,16455,'en','Data Updated Successfully',0),(591891,16440,'en','Default Quantity Received To Zero',0),(591892,16442,'en','Default Quantity Shipped To Zero',0),(591893,16438,'en','Direct Download Link',0),(591894,16423,'en','Edit Check',0),(591895,16443,'en','Edit Failed',0),(591896,16451,'en','Entity',0),(591897,16424,'en','Error Saving Check',0),(591898,16447,'en','Estimated Delivery',0),(591899,16441,'en','Hide Check Endorser Boxes',0),(591900,16452,'en','Job Cost Summary',0),(591901,16429,'en','No Grouping',0),(591902,16425,'en','Only AP Checks Can Be Edited',0),(591903,16453,'en','Please Select A Job',0),(591904,16445,'en','Possible Double Data Submission Prevented',0),(591905,16456,'en','Save Cost Code & Job Changes For Hours',0),(591906,16446,'en','Shipment Processing Canceled',0),(591907,16436,'en','Show Certificates Expiring Before',0),(591908,16430,'en','Subtotal By',0),(591909,16458,'en','This Bank Deposit Has Been Cleared On Bank Statement',0),(591910,16426,'en','To Edit This Check You Must Void And Recreate',0),(591911,16454,'en','T Pay',0),(591912,16431,'en','Unassigned',0),(591913,16450,'en','Unbalanced By',0),(591914,16433,'en','Vendor Certificates Expiring',0),(591915,16448,'en','Voucher Has Been Posted',0),(591916,16449,'en','Voucher Is In A Closed Period',0),(591917,16439,'en','Your Download Should Begin Momentarily',0),(591918,16459,'en','Only AP Checks Can Be Edited',0),(591919,16460,'en','Auto Select',0),(591920,16461,'en','This Deposit Has Been Included In A Bank Reconciliation Month',0),(591921,16462,'en','You Must Uncheck It From The Bank Reconciliation Page In Order To Edit',0),(591922,16472,'en','Begin And End Date Must Be Set',0),(591923,16485,'en','Bin Locations',0),(591924,16498,'en','City Wages',0),(591925,16463,'en','Continuing Will Cause The Following Bins To Become Unlinked From These Items',0),(591926,16469,'en','Continuing Will Cause The Following Bins To Become Unlinked From This Zone',0),(591927,16499,'en','Fed Wages',0),(591928,16484,'en','Fund Name',0),(591929,16496,'en','Gross Pay Plus Nontaxable',0),(591930,16497,'en','Gross Pay Plus Nontaxable Per Year',0),(591931,16500,'en','Gross Pay Through',0),(591932,16477,'en','Inquiries',0),(591933,16478,'en','Interbranch Transfers',0),(591934,16488,'en','Job History',0),(591935,16489,'en','Job Summary',0),(591936,16490,'en','Labor Overhead',0),(591937,16491,'en','Labor Time',0),(591938,16486,'en','No Bins Avaible For This Location',0),(591939,16473,'en','No Default Location Set',0),(591940,16474,'en','No Default Price Level Set',0),(591941,16479,'en','POS Sale',0),(591942,16487,'en','Primary Bin',0),(591943,16464,'en','Record Deleted',0),(591944,16480,'en','Sales Invoice',0),(591945,16481,'en','Sales Quote',0),(591946,16492,'en','Sources',0),(591947,16475,'en','Special Sales Pricing',0),(591948,16476,'en','Standard Price',0),(591949,16501,'en','State Withheld',0),(591950,16502,'en','Taxable Wages',0),(591951,16493,'en','Total Labor Costs',0),(591952,16494,'en','Total Vendor Costs',0),(591953,16495,'en','Vendor Bill Payments',0),(591954,16465,'en','Warehouse Bin',0),(591955,16482,'en','Warehouse Bins',0),(591956,16466,'en','Warehouse Bin By This Code Already Exists',0),(591957,16467,'en','Warehouse Bin Code Must Be Set',0),(591958,16468,'en','Warehouse Zone',0),(591959,16483,'en','Warehouse Zones',0),(591960,16470,'en','Warehouse Zone By This Code Already Exists',0),(591961,16471,'en','Warehouse Zone Code Must Be Set',0),(591962,16420,'af','Kontroleer inligting',0),(591963,16421,'af','Kontroleer nie gevind nie',0),(591964,16422,'af','Kontroleer gestoor',0),(591965,16423,'af','Redigeer kontroleer',0),(591966,16424,'af','Fout met die stoor kontroleer',0),(591967,16425,'af','Enigste GP ondersoeke kan nie geredigeer word nie',0),(591968,16426,'af','Om hierdie kontrole te redigeer jy moet leemte en herskep',0),(591969,16427,'af','Rekening #',0),(591970,16428,'af','Balansstaat - sorteer onder geneeskunde',0),(591971,16429,'af','Geen groepering nie',0),(591972,16430,'af','Subtotal deur',0),(591973,16431,'af','Unassigned',0),(591974,16432,'af','Koste opsomming',0),(591975,16433,'af','Handelaar sertifikate verval',0),(591976,16434,'af','Sertifikaat naam',0),(591977,16435,'af','Sertifikaat tipe',0),(591978,16436,'af','Wys sertifikate verval voor',0),(591979,16437,'af','Balans oor',0),(591980,16438,'af','Direkte aflaai skakel',0),(591981,16439,'af','Jou aflaai moet \'n oomblik Begin',0),(591982,16440,'af','Verstek hoeveelheid ontvang na nul',0),(591983,16441,'af','Kontroleer Endorser bokse versteek',0),(591984,16442,'af','Verstek hoeveelheid Shipped na nul',0),(591985,16443,'af','Redigeer het misluk',0),(591986,16444,'af','\'N nuwe verskeping is geskep nadat jy gekies het om te skip',0),(591987,16445,'af','Moontlike dubbele Data voorlegging verhoed',0),(591988,16446,'af','Verskeping verwerking gekanselleer',0),(591989,16447,'af','Geraamde aflewering',0),(591990,16448,'af','Bewys gepos is',0),(591991,16449,'af','Bewys Is In \'n geslote tydperk',0),(591992,16450,'af','Ongebalanseerde deur',0),(591993,16451,'af','Entiteit',0),(591994,16452,'af','Werk kos opsomming',0),(591995,16453,'af','Kies asseblief \'n werk',0),(591996,16454,'af','T betaling',0),(591997,16455,'af','Data suksesvol opgedateer',0),(591998,16456,'af','Stoor koste kode & werk veranderinge vir ure',0),(591999,16457,'af','Blinde skip',0),(592000,16458,'af','Hierdie Bank deposito is skoongemaak op bankstaat',0),(592001,16459,'af','Enigste GP ondersoeke kan nie geredigeer word nie',0),(592002,16460,'af','Outo kies',0),(592003,16461,'af','Hierdie deposito is ingesluit In \'n Bank rekonsiliasie maand',0),(592004,16462,'af','Jy moet as jy dit uit die Bank rekonsiliasie bladsy om te redigeer',0),(592005,16463,'af','Om voort te gaan sal oorsaak die volgende vullisdromme te raak Unlinked van hierdie Items',0),(592006,16464,'af','Rekord geskrap',0),(592007,16465,'af','Pakhuis asblik',0),(592008,16466,'af','Pakhuis asblik deur hierdie kode bestaan reeds',0),(592009,16467,'af','Pakhuis asblik kode moet opgestel word',0),(592010,16468,'af','Pakhuis sone',0),(592011,16469,'af','Om voort te gaan sal oorsaak die volgende dromme word Unlinked vanaf hierdie sone',0),(592012,16470,'af','Pakhuis sone deur hierdie kode bestaan reeds',0),(592013,16471,'af','Pakhuis sone kode moet opgestel word',0),(592014,16472,'af','Begin en Einddatum moet opgestel word',0),(592015,16473,'af','Geen verstek ligging stel',0),(592016,16474,'af','Geen verstek prys vlak stel',0),(592017,16475,'af','Spesiale verkope pryse',0),(592018,16476,'af','Standaard prys',0),(592019,16477,'af','Navrae',0),(592020,16478,'af','Interbranch oordrag',0),(592021,16479,'af','POS verkoop',0),(592022,16480,'af','Verkope faktuur',0),(592023,16481,'af','Verkope aanhaling',0),(592024,16482,'af','Pakhuis dromme',0),(592025,16483,'af','Pakhuis sones',0),(592026,16484,'af','Fonds naam',0),(592027,16485,'af','Asblik liggings',0),(592028,16486,'af','Geen dromme Avaible vir hierdie ligging',0),(592029,16487,'af','PrimÃªre asblik',0),(592030,16488,'af','Werk geskiedenis',0),(592031,16489,'af','Werk opsomming',0),(592032,16490,'af','Arbeid oorhoofse',0),(592033,16491,'af','Labor tyd',0),(592034,16492,'af','Bronne',0),(592035,16493,'af','Totale arbeid koste',0),(592036,16494,'af','Totale handelaar koste',0),(592037,16495,'af','Handelaar Wetsontwerp betalings',0),(592038,16496,'af','Bruto salaris Plus Nontaxable',0),(592039,16497,'af','Bruto salaris Plus Nontaxable Per jaar',0),(592040,16498,'af','Stad lone',0),(592041,16499,'af','Gevoed lone',0),(592042,16500,'af','Bruto salaris deur',0),(592043,16501,'af','Staat weerhou',0),(592044,16502,'af','Belasbare loon',0),(592045,16420,'ar','Ø§Ù„ØªØ­Ù‚Ù‚ Ù…Ù† Ø§Ù„Ù…Ø¹Ù„ÙˆÙ…Ø§Øª',0),(592046,16421,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(592047,16422,'ar','Ø­ÙØ¸ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(592048,16423,'ar','ØªØ­Ø±ÙŠØ± Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(592049,16424,'ar','Ø­Ø¯Ø« Ø®Ø·Ø£ Ø£Ø«Ù†Ø§Ø¡ Ø­ÙØ¸ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø±',0),(592050,16425,'ar','ÙŠÙ…ÙƒÙ† ØªØ­Ø±ÙŠØ± Ø§Ù„Ø´ÙŠÙƒØ§Øª AP ÙÙ‚Ø·',0),(592051,16426,'ar','Ù„ØªØ­Ø±ÙŠØ± Ù‡Ø°Ø§ Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± ÙŠØ¬Ø¨ Ø£Ù† Ø§Ù„ÙØ±Ø§Øº ÙˆØ¥Ø¹Ø§Ø¯Ø©',0),(592052,16427,'ar','Ø­Ø³Ø§Ø¨ #',0),(592053,16428,'ar','Ø§Ù„Ù…ÙŠØ²Ø§Ù†ÙŠØ© Ø§Ù„Ø¹Ù…ÙˆÙ…ÙŠØ©-ØªØµÙ†ÙŠÙ',0),(592054,16429,'ar','Ø¹Ø¯Ù… Ø§Ù„ØªØ¬Ù…ÙŠØ¹',0),(592055,16430,'ar','Ø§Ù„Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ÙØ±Ø¹ÙŠ Ù„Ø·Ø±ÙŠÙ‚',0),(592056,16431,'ar','ØºÙŠØ± Ø§Ù„Ù…Ø¹ÙŠÙ†Ø©',0),(592057,16432,'ar','Ù…Ù„Ø®Øµ Ø§Ù„ØªÙƒÙ„ÙØ©',0),(592058,16433,'ar','Ø¨Ø§Ø¦Ø¹ Ø´Ù‡Ø§Ø¯Ø§Øª ØªÙ†ØªÙ‡ÙŠ',0),(592059,16434,'ar','Ø§Ø³Ù… Ø§Ù„Ø´Ù‡Ø§Ø¯Ø©',0),(592060,16435,'ar','Ù†ÙˆØ¹ Ø§Ù„Ø´Ù‡Ø§Ø¯Ø©',0),(592061,16436,'ar','ÙˆØªØ¨ÙŠÙ† Ø§Ù„Ø´Ù‡Ø§Ø¯Ø§Øª Ø§Ù„ØªÙŠ ØªÙ†ØªÙ‡ÙŠ Ù‚Ø¨Ù„',0),(592062,16437,'ar','Ø§Ù„Ø±ØµÙŠØ¯ Ø§Ù„Ù…ØªØ¨Ù‚ÙŠ',0),(592063,16438,'ar','Ø±Ø§Ø¨Ø· Ø§Ù„ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ù…Ø¨Ø§Ø´Ø±',0),(592064,16439,'ar','ÙˆÙŠÙ†Ø¨ØºÙŠ Ø£Ù† ÙŠØ¨Ø¯Ø£ Ø§Ù„ØªØ­Ù…ÙŠÙ„ Ø§Ù„Ø®Ø§Øµ Ø¨Ùƒ Ù„Ø­Ø¸Ø§Øª',0),(592065,16440,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ø§Ù„ÙˆØ§Ø±Ø¯Ø© Ø¥Ù„Ù‰ Ø§Ù„ØµÙØ±',0),(592066,16441,'ar','Ø¥Ø®ÙØ§Ø¡ Ù…Ø±Ø¨Ø¹Ø§Øª Ø§Ù„Ø§Ø®ØªÙŠØ§Ø± Ø£Ø¯Ø§Ø© Ø§Ù„Ø¥Ø¸Ù‡Ø§Ø±',0),(592067,16442,'ar','Ø§Ù„ÙƒÙ…ÙŠØ© Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠØ© Ø§Ù„ØªÙŠ ÙŠØªÙ… Ø´Ø­Ù†Ù‡Ø§ Ø¥Ù„Ù‰ ØµÙØ±',0),(592068,16443,'ar','ØªØ­Ø±ÙŠØ± ÙØ´Ù„',0),(592069,16444,'ar','Ø´Ø­Ù†Ø© Ø¬Ø¯ÙŠØ¯Ø© ØªÙ… Ø¥Ù†Ø´Ø§Ø¤Ù‡Ø§ Ø¨Ø¹Ø¯ Ù‚Ø¯ Ø­Ø¯Ø¯ØªÙ‡Ø§ Ù„Ù„Ø³ÙÙŠÙ†Ø©',0),(592070,16445,'ar','ØªÙ‚Ø¯ÙŠÙ… Ø¨ÙŠØ§Ù†Ø§Øª Ù…Ø²Ø¯ÙˆØ¬Ø© Ù…Ù…ÙƒÙ† Ø­Ø§Ù„Øª Ø¯ÙˆÙ†',0),(592071,16446,'ar','ØªØ¬Ù‡ÙŠØ² Ø´Ø­Ù†Ø© Ø¥Ù„ØºØ§Ø¡',0),(592072,16447,'ar','Ø§Ù„ØªØ³Ù„ÙŠÙ… Ø§Ù„Ù…Ù‚Ø¯Ø±',0),(592073,16448,'ar','ÙˆÙ‚Ø¯ ØªÙ… ØªØ±Ø­ÙŠÙ„ Ø§Ù„Ø¥ÙŠØµØ§Ù„',0),(592074,16449,'ar','Ø§Ù„Ø¥ÙŠØµØ§Ù„ ÙÙŠ ÙØªØ±Ø© Ù…ØºÙ„Ù‚Ø©',0),(592075,16450,'ar','ØºÙŠØ± Ø§Ù„Ù…ØªÙˆØ§Ø²Ù†Ø© Ø§Ù„ØªÙŠ',0),(592076,16451,'ar','Ø§Ù„ÙƒÙŠØ§Ù†',0),(592077,16452,'ar','ØªÙƒÙ„ÙØ© Ø§Ù„ÙˆØ¸ÙŠÙØ© Ù…Ù„Ø®Øµ',0),(592078,16453,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ ØªØ­Ø¯ÙŠØ¯ Ù…Ù‡Ù…Ø©',0),(592079,16454,'ar','ØªÙŠ Ø¯ÙØ¹',0),(592080,16455,'ar','Ø§Ù„Ø¨ÙŠØ§Ù†Ø§Øª Ø§Ù„ØªÙŠ ØªÙ… ØªØ­Ø¯ÙŠØ«Ù‡Ø§ Ø¨Ù†Ø¬Ø§Ø­',0),(592081,16456,'ar','Ø­ÙØ¸ Ø±Ù…Ø² Ø§Ù„ØªÙƒÙ„ÙØ© & ØªØºÙŠÙŠØ±Ø§Øª Ø§Ù„ÙˆØ¸ÙŠÙØ© Ù„Ù…Ø¯Ø© Ø³Ø§Ø¹Ø©',0),(592082,16457,'ar','Ø³ÙÙŠÙ†Ø© Ø§Ù„Ø£Ø¹Ù…Ù‰',0),(592083,16458,'ar','ØªÙ… Ù…Ø³Ø­ Ù‡Ø°Ù‡ Ø§Ù„ÙˆØ¯Ø§Ø¦Ø¹ Ø§Ù„Ù…ØµØ±ÙÙŠØ© ÙÙŠ ÙƒØ´Ù Ø§Ù„Ø­Ø³Ø§Ø¨ Ø§Ù„Ø¨Ù†ÙƒÙŠ',0),(592084,16459,'ar','ÙŠÙ…ÙƒÙ† ØªØ­Ø±ÙŠØ± Ø§Ù„Ø´ÙŠÙƒØ§Øª AP ÙÙ‚Ø·',0),(592085,16460,'ar','ØªØ­Ø¯ÙŠØ¯ ØªÙ„Ù‚Ø§Ø¦ÙŠ',0),(592086,16461,'ar','Ù‡Ø°Ø§ Ø§Ù„Ù…Ø¨Ù„Øº Ù‚Ø¯ Ø£Ø¯Ø±Ø¬ ÙÙŠ Ø´Ù‡Ø± Ù…ØµØ§Ù„Ø­Ø© Ø§Ù„Ø¨Ù†Ùƒ',0),(592087,16462,'ar','ÙˆÙŠØ¬Ø¨ Ø¥Ù„ØºØ§Ø¡ Ù…Ù† ØµÙØ­Ø© Ø§Ù„Ù…ØµØ§Ù„Ø­Ø© Ø§Ù„Ø¨Ù†Ùƒ Ù…Ù† Ø£Ø¬Ù„ ØªØ­Ø±ÙŠØ±',0),(592088,16463,'ar','Ø§Ø³ØªÙ…Ø±Ø§Ø± Ù‚Ø¶ÙŠØ© Ø¥Ø±Ø§Ø¯Ø© ØµÙ†Ø§Ø¯ÙŠÙ‚ Ø§Ù„ØªØ§Ù„ÙŠØ© Ù„ØªØµØ¨Ø­ ØºÙŠØ± Ø§Ù„Ù…Ø±ØªØ¨Ø·Ø© Ù…Ù† Ù‡Ø°Ù‡ Ø§Ù„Ø¹Ù†Ø§ØµØ±',0),(592089,16464,'ar','Ø­Ø°Ù Ø³Ø¬Ù„',0),(592090,16465,'ar','Ø¨Ù† Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹',0),(592091,16466,'ar','Ø¨Ù† Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹ Ø¨Ù‡Ø°Ù‡ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„',0),(592092,16467,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø±Ù…Ø² Ø¨Ù† Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹',0),(592093,16468,'ar','Ù…Ù†Ø·Ù‚Ø© Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹Ø§Øª',0),(592094,16469,'ar','Ø§Ø³ØªÙ…Ø±Ø§Ø± Ù‚Ø¶ÙŠØ© Ø¥Ø±Ø§Ø¯Ø© ØµÙ†Ø§Ø¯ÙŠÙ‚ Ø§Ù„ØªØ§Ù„ÙŠØ© Ù„ØªØµØ¨Ø­ ØºÙŠØ± Ø§Ù„Ù…Ø±ØªØ¨Ø·Ø© Ù…Ù† Ù‡Ø°Ù‡ Ø§Ù„Ù…Ù†Ø·Ù‚Ø©',0),(592095,16470,'ar','Ù…Ù†Ø·Ù‚Ø© Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹ Ø¨Ù‡Ø°Ù‡ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø© Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ù…ÙˆØ¬ÙˆØ¯Ø© Ø¨Ø§Ù„ÙØ¹Ù„',0),(592096,16471,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø±Ù…Ø² Ø§Ù„Ù…Ù†Ø·Ù‚Ø© Ù…Ø³ØªÙˆØ¯Ø¹',0),(592097,16472,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø¨Ø¯Ø¡ ÙˆØªØ§Ø±ÙŠØ® Ø§Ù„Ø§Ù†ØªÙ‡Ø§Ø¡',0),(592098,16473,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ù…ÙˆÙ‚Ø¹ Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(592099,16474,'ar','Ù„Ù… ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ù…Ø³ØªÙˆÙ‰ Ø§Ù„Ø³Ø¹Ø± Ø§Ù„Ø§ÙØªØ±Ø§Ø¶ÙŠ',0),(592100,16475,'ar','Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª Ø§Ù„Ø®Ø§Øµ Ø§Ù„ØªØ³Ø¹ÙŠØ±',0),(592101,16476,'ar','Ø§Ù„Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ù‚ÙŠØ§Ø³ÙŠØ©',0),(592102,16477,'ar','Ø§Ù„Ø§Ø³ØªÙØ³Ø§Ø±Ø§Øª',0),(592103,16478,'ar','Ù†Ù‚Ù„ Ø¥ÙŠÙ†ØªÙŠØ±Ø¨Ø±Ø§Ù†ØªØ´',0),(592104,16479,'ar','Ø§Ù„Ø¨ÙŠØ¹ POS',0),(592105,16480,'ar','ÙØ§ØªÙˆØ±Ø© Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(592106,16481,'ar','Ø¹Ø±Ø¶ Ø£Ø³Ø¹Ø§Ø± Ø§Ù„Ù…Ø¨ÙŠØ¹Ø§Øª',0),(592107,16482,'ar','Ù…Ø³ØªÙˆØ¯Ø¹ Ø§Ù„Ø­Ø§ÙˆÙŠØ§Øª',0),(592108,16483,'ar','Ù…Ù†Ø§Ø·Ù‚ Ø§Ù„Ù…Ø³ØªÙˆØ¯Ø¹',0),(592109,16484,'ar','Ø§Ø³Ù… Ø§Ù„ØµÙ†Ø¯ÙˆÙ‚',0),(592110,16485,'ar','Ù…ÙˆØ§Ù‚Ø¹ Ø¨Ù†',0),(592111,16486,'ar','Ù„Ø§ Avaible ØµÙ†Ø§Ø¯ÙŠÙ‚ Ù„Ù‡Ø°Ø§ Ø§Ù„Ù…ÙˆÙ‚Ø¹',0),(592112,16487,'ar','Ø¨Ù† Ø§Ù„Ø£ÙˆÙ„ÙŠØ©',0),(592113,16488,'ar','Ø§Ù„ØªØ§Ø±ÙŠØ® Ø§Ù„ÙˆØ¸ÙŠÙÙŠ',0),(592114,16489,'ar','Ù…Ù„Ø®Øµ Ø§Ù„ÙˆØ¸ÙŠÙØ©',0),(592115,16490,'ar','Ø§Ù„Ø¹Ù…Ù„ Ø§Ù„Ù†ÙÙ‚Ø§Øª Ø§Ù„Ø¹Ø§Ù…Ø©',0),(592116,16491,'ar','ÙˆÙ‚Øª Ø§Ù„Ø¹Ù…Ù„',0),(592117,16492,'ar','Ù…ØµØ§Ø¯Ø±',0),(592118,16493,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ ØªÙƒØ§Ù„ÙŠÙ Ø§Ù„Ø¹Ù…Ø§Ù„Ø©',0),(592119,16494,'ar','Ø¨Ø§Ø¦Ø¹ Ù…Ø¬Ù…ÙˆØ¹ Ø§Ù„ØªÙƒØ§Ù„ÙŠÙ',0),(592120,16495,'ar','ØªØ³Ø¯ÙŠØ¯ ÙÙˆØ§ØªÙŠØ± Ø§Ù„Ù…ÙˆØ±Ø¯',0),(592121,16496,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ù†ÙˆÙ†ØªØ§ÙƒØ³Ø§Ø¨Ù„',0),(592122,16497,'ar','Ø§Ù„Ø£Ø¬Ø± Ø§Ù„Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø¨Ø§Ù„Ø¥Ø¶Ø§ÙØ© Ø¥Ù„Ù‰ Ù†ÙˆÙ†ØªØ§ÙƒØ³Ø§Ø¨Ù„ ÙÙŠ Ø§Ù„Ø³Ù†Ø©',0),(592123,16498,'ar','Ù…Ø¯ÙŠÙ†Ø© Ø§Ù„Ø£Ø¬ÙˆØ±',0),(592124,16499,'ar','Ø¨Ù†Ùƒ Ø§Ù„Ø§Ø­ØªÙŠØ§Ø·ÙŠ Ø§Ù„ÙÙŠØ¯Ø±Ø§Ù„ÙŠ Ù„Ù„Ø£Ø¬ÙˆØ±',0),(592125,16500,'ar','Ø¥Ø¬Ù…Ø§Ù„ÙŠ Ø§Ù„Ø¯ÙØ¹ Ù…Ù† Ø®Ù„Ø§Ù„',0),(592126,16501,'ar','Ø§Ù„Ø¯ÙˆÙ„Ø© Ø§Ù„Ù…Ø­ØªØ¬Ø²Ø©',0),(592127,16502,'ar','Ø§Ù„Ø£Ø¬ÙˆØ± Ø§Ù„Ø®Ø§Ø¶Ø¹Ø© Ù„Ù„Ø¶Ø±ÙŠØ¨Ø©',0),(592128,16420,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑÑ‚Ð° Ð·Ð°',0),(592129,16421,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÑ‚Ðµ Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½',0),(592130,16422,'bg','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐ°Ð½Ð¸',0),(592131,16423,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°Ñ‚Ð°',0),(592132,16424,'bg','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸ Ð·Ð°Ð¿Ð¸ÑÐ²Ð°Ð½Ðµ Ð½Ð° Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ°',0),(592133,16425,'bg','Ð¡Ð°Ð¼Ð¾ AP Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ð¸',0),(592134,16426,'bg','Ð—Ð° Ð´Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ñ‚Ðµ Ñ‚Ð°Ð·Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð°Ð½ÑƒÐ»Ð¸Ñ€Ð°Ñ‚Ðµ Ð¸ Ð´Ð° Ð¿Ñ€ÐµÑÑŠÐ·Ð´Ð°Ð´Ðµ',0),(592135,16427,'bg','Ð¡Ð¼ÐµÑ‚ÐºÐ° #',0),(592136,16428,'bg','Ð‘Ð°Ð»Ð°Ð½Ñ - ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸',0),(592137,16429,'bg','ÐÑÐ¼Ð° Ð³Ñ€ÑƒÐ¿Ð¸Ñ€Ð°Ð½Ðµ',0),(592138,16430,'bg','ÐœÐµÐ¶Ð´Ð¸Ð½Ð½Ð° ÑÑƒÐ¼Ð° Ð¾Ñ‚',0),(592139,16431,'bg','ÐÐµÐ¿Ñ€Ð¸ÑÐ²Ð¾ÐµÐ½Ð¸',0),(592140,16432,'bg','Ð¦ÐµÐ½Ð° Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(592141,16433,'bg','Ð”Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¸Ñ‚Ðµ Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°',0),(592142,16434,'bg','Ð˜Ð¼Ðµ Ð½Ð° ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(592143,16435,'bg','Ð¢Ð¸Ð¿ Ð½Ð° ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(592144,16436,'bg','ÐŸÐ¾ÐºÐ°Ð¶Ð¸ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð¸Ñ‚Ðµ, Ð¸Ð·Ñ‚Ð¸Ñ‡Ð°Ñ‰Ð° Ð¿Ñ€ÐµÐ´Ð¸',0),(592145,16437,'bg','ÐžÑÑ‚Ð°Ñ‚ÑŠÐºÑŠÑ‚',0),(592146,16438,'bg','ÐŸÑ€ÑÐº Download Ð—Ð²ÐµÐ½Ð¾',0),(592147,16439,'bg','Ð˜Ð·Ñ‚ÐµÐ³Ð»ÑÐ½ÐµÑ‚Ð¾ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð·Ð°Ð¿Ð¾Ñ‡Ð½Ðµ Ð¼Ð¸Ð³Ð½Ð¾Ð²ÐµÐ½Ð¾',0),(592148,16440,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¾Ñ‚Ð¾ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð° Ð½ÑƒÐ»Ð°',0),(592149,16441,'bg','Ð¡ÐºÑ€Ð¸Ð¹ Ð¿Ð¾Ñ€ÑŠÑ‡Ð¸Ñ‚ÐµÐ» ÐºÐ²Ð°Ð´Ñ€Ð°Ñ‚Ñ‡ÐµÑ‚Ð°',0),(592150,16442,'bg','ÐŸÐ¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ð¸ Ð´Ð¾ Ð½ÑƒÐ»Ð°',0),(592151,16443,'bg','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ Ðµ Ð½ÐµÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(592152,16444,'bg','ÐÐ¾Ð²Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð° Ð±ÐµÐ»ÐµÐ¶ÐºÐ° Ðµ ÑÑŠÐ·Ð´Ð°Ð´ÐµÐ½Ð° ÑÐ»ÐµÐ´ ÐºÐ°Ñ‚Ð¾ ÑÑ‚Ðµ Ð¸Ð·Ð±Ñ€Ð°Ð»Ð¸ Ð·Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ€Ð°Ð½Ðµ',0),(592153,16445,'bg','Ð’ÑŠÐ·Ð¼Ð¾Ð¶Ð½Ð° Ð´Ð²Ð¾Ð¹Ð½Ð° Ð´Ð°Ð½Ð½Ð¸ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð°Ð²ÑÐ½Ðµ Ð¿Ñ€ÐµÐ´Ð¾Ñ‚Ð²Ñ€Ð°Ñ‚ÐµÐ½Ð¸',0),(592154,16446,'bg','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð½Ð° ÐµÐºÑÐ¿ÐµÐ´Ð¸Ñ†Ð¸Ð¾Ð½Ð½Ð¸ Ð±ÐµÐ»ÐµÐ¶ÐºÐ¸ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(592155,16447,'bg','ÐŸÑ€Ð¾Ð³Ð½Ð¾Ð·Ð½Ð° Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(592156,16448,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ÑŠÑ‚ Ðµ Ð¾ÑÑ‡ÐµÑ‚Ð¾Ð²Ð¾Ð´ÐµÐ½',0),(592157,16449,'bg','Ð’Ð°ÑƒÑ‡ÐµÑ€ÑŠÑ‚ Ðµ Ð² Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½ Ð¿ÐµÑ€Ð¸Ð¾Ð´',0),(592158,16450,'bg','ÐÐµÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð°Ð½Ð¸ Ð¾Ñ‚',0),(592159,16451,'bg','ÐžÐ±ÐµÐºÑ‚',0),(592160,16452,'bg','Ð ÐµÐ·ÑŽÐ¼Ðµ Ð½Ð° Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ð¿Ñ€Ð¾ÐµÐºÑ‚',0),(592161,16453,'bg','ÐœÐ¾Ð»Ñ, Ð¸Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ñ€Ð°Ð±Ð¾Ñ‚Ð°',0),(592162,16454,'bg','Ð”Ð° Ð¿Ð»Ð°Ñ‚Ð¸',0),(592163,16455,'bg','Ð”Ð°Ð½Ð½Ð¸, Ð°ÐºÑ‚ÑƒÐ°Ð»Ð¸Ð·Ð¸Ñ€Ð°Ð½Ð¸ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾',0),(592164,16456,'bg','Ð—Ð°Ð¿Ð¸ÑˆÐ¸ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸Ñ‚Ðµ ÐºÐ¾Ð´ & Ñ€Ð°Ð±Ð¾Ñ‚Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸ Ð·Ð° Ñ‡Ð°ÑÐ¾Ð²Ðµ',0),(592165,16457,'bg','Ð¡Ð»ÐµÐ¿Ð¸ ÐºÐ¾Ñ€Ð°Ð±',0),(592166,16458,'bg','Ð¢Ð¾Ð·Ð¸ Ð±Ð°Ð½ÐºÐ¾Ð² Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ðµ Ð¿Ñ€Ð¸ÐºÐ»ÑŽÑ‡ÐµÐ½Ð¾ Ð² Ð±Ð°Ð½ÐºÐ¾Ð² Ð¾Ñ‚Ñ‡ÐµÑ‚',0),(592167,16459,'bg','Ð¡Ð°Ð¼Ð¾ AP Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸ Ð¼Ð¾Ð³Ð°Ñ‚ Ð´Ð° Ð±ÑŠÐ´Ð°Ñ‚ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ð¸',0),(592168,16460,'bg','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÐ½ Ð¸Ð·Ð±Ð¾Ñ€',0),(592169,16461,'bg','Ð¢Ð¾Ð·Ð¸ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ðµ Ð±Ð¸Ð»Ð° Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð° Ð² Ð±Ð°Ð½ÐºÐ¾Ð²Ð°Ñ‚Ð° ÑÑŠÐ¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¼ÐµÑÐµÑ†',0),(592170,16462,'bg','Ð’Ð¸Ðµ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð³Ð¾ Ð¼Ð°Ñ…Ð½ÐµÑ‚Ðµ Ð¾Ñ‚ Ð±Ð°Ð½ÐºÐ¾Ð²Ð° ÑÑŠÐ¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ° ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ð° Ð·Ð° Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(592171,16463,'bg','ÐŸÑ€Ð¾Ð´ÑŠÐ»Ð¶Ð°Ð²Ð°Ð½Ðµ Ñ‰Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð° ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¡Ðš Ð´Ð° ÑÑ‚Ð°Ð½Ðµ Ð¿Ñ€ÐµÐºÑŠÑÐ½Ð°Ñ‚Ð° Ð¾Ñ‚ Ñ‚ÐµÐ·Ð¸ ÐµÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¸',0),(592172,16464,'bg','Ð—Ð°Ð¿Ð¸ÑÑŠÑ‚ Ðµ Ð¸Ð·Ñ‚Ñ€Ð¸Ñ‚',0),(592173,16465,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð²Ð°Ñ‚Ð° ÐºÐ»ÐµÑ‚ÐºÐ°',0),(592174,16466,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð²Ð°Ñ‚Ð° ÐºÐ»ÐµÑ‚ÐºÐ° Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ ÐºÐ¾Ð´ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(592175,16467,'bg','ÐšÐ¾Ð´ Ð½Ð° Ð¡Ðš Ð½Ð° ÑÐºÐ»Ð°Ð´ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»Ð¸',0),(592176,16468,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð²Ð° Ð·Ð¾Ð½Ð°',0),(592177,16469,'bg','ÐŸÑ€Ð¾Ð´ÑŠÐ»Ð¶Ð°Ð²Ð°Ð½Ðµ Ñ‰Ðµ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð° ÑÐ»ÐµÐ´Ð½Ð¸Ñ‚Ðµ Ð¡Ðš Ð´Ð° ÑÑ‚Ð°Ð½Ðµ Ð¿Ñ€ÐµÐºÑŠÑÐ½Ð°Ñ‚Ð° Ð¾Ñ‚ Ñ‚Ð°Ð·Ð¸ Ð·Ð¾Ð½Ð°',0),(592178,16470,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð²Ð° Ð·Ð¾Ð½Ð° Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ ÐºÐ¾Ð´ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(592179,16471,'bg','ÐšÐ¾Ð´ Ð½Ð° ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð° Ð·Ð¾Ð½Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½Ð°',0),(592180,16472,'bg','ÐÐ°Ñ‡Ð°Ð»Ð½Ð° Ð¸ ÐºÑ€Ð°Ð¹Ð½Ð° Ð´Ð°Ñ‚Ð° Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° Ð±ÑŠÐ´Ðµ Ð·Ð°Ð´Ð°Ð´ÐµÐ½',0),(592181,16473,'bg','ÐÑÐ¼Ð° Ð½Ð°Ð±Ð¾Ñ€ Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(592182,16474,'bg','ÐÑÐ¼Ð° Ð¿Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·Ð±Ð¸Ñ€Ð°Ð½Ðµ Ñ†ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾ ÐºÐ¾Ð¼Ð¿Ð»ÐµÐºÑ‚',0),(592183,16475,'bg','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»Ð½Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð¸ Ñ†ÐµÐ½Ð¸',0),(592184,16476,'bg','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð° Ñ†ÐµÐ½Ð°',0),(592185,16477,'bg','Ð—Ð°Ð¿Ð¸Ñ‚Ð²Ð°Ð½Ð¸Ñ',0),(592186,16478,'bg','Ð‘Ñ€Ð°Ð½ÑˆÐ¾Ð²Ð¸Ñ‚Ðµ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(592187,16479,'bg','POS Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(592188,16480,'bg','Ð¤Ð°ÐºÑ‚ÑƒÑ€Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(592189,16481,'bg','ÐžÑ„ÐµÑ€Ñ‚Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð±Ð°',0),(592190,16482,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ ÐºÐ»ÐµÑ‚ÐºÐ¸',0),(592191,16483,'bg','Ð¡ÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ Ð·Ð¾Ð½Ð¸',0),(592192,16484,'bg','Ð˜Ð¼ÐµÑ‚Ð¾ Ð½Ð° Ð¤Ð¾Ð½Ð´Ð°',0),(592193,16485,'bg','Ð¡Ðš Ð¼ÐµÑÑ‚Ð°',0),(592194,16486,'bg','Avaible Ð½ÑÐ¼Ð° ÑÐºÐ»Ð°Ð´Ð¾Ð²Ð¸ ÐºÐ»ÐµÑ‚ÐºÐ¸ Ð·Ð° Ñ‚Ð¾Ð²Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(592195,16487,'bg','ÐžÑÐ½Ð¾Ð²Ð½Ð°Ñ‚Ð° Ð¡Ðš',0),(592196,16488,'bg','Ð¥Ñ€Ð¾Ð½Ð¾Ð»Ð¾Ð³Ð¸ÑÑ‚Ð° Ð½Ð° Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(592197,16489,'bg','Ð Ð°Ð±Ð¾Ñ‚Ð° Ð ÐµÐ·ÑŽÐ¼Ðµ',0),(592198,16490,'bg','Ð¢Ñ€ÑƒÐ´Ð° Ñ€ÐµÐ¶Ð¸Ð¹Ð½Ð¸',0),(592199,16491,'bg','Ð¢Ñ€ÑƒÐ´Ð° Ð²Ñ€ÐµÐ¼Ðµ',0),(592200,16492,'bg','Ð˜Ð·Ñ‚Ð¾Ñ‡Ð½Ð¸Ñ†Ð¸',0),(592201,16493,'bg','ÐžÐ±Ñ‰Ð¸Ñ‚Ðµ Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸ Ð·Ð° Ñ‚Ñ€ÑƒÐ´',0),(592202,16494,'bg','ÐžÐ±Ñ‰Ð¾ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ðº Ñ€Ð°Ð·Ñ…Ð¾Ð´Ð¸',0),(592203,16495,'bg','Ð—Ð°ÐºÐ¾Ð½Ð¾Ð¿Ñ€Ð¾ÐµÐºÑ‚ Ð·Ð° Ð¿Ð»Ð°Ñ‰Ð°Ð½Ð¸Ñ Ð¾Ñ‚ Ð´Ð¾ÑÑ‚Ð°Ð²Ñ‡Ð¸Ñ†Ð¸',0),(592204,16496,'bg','Ð‘Ñ€ÑƒÑ‚Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ð»ÑŽÑ Nontaxable',0),(592205,16497,'bg','Ð‘Ñ€ÑƒÑ‚Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ð¿Ð»ÑŽÑ Nontaxable Ð³Ð¾Ð´Ð¸ÑˆÐ½Ð¾',0),(592206,16498,'bg','Ð“Ñ€Ð°Ð´ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(592207,16499,'bg','Ð¤ÐµÐ´ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(592208,16500,'bg','Ð‘Ñ€ÑƒÑ‚Ð½Ð¸ Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸ Ñ‡Ñ€ÐµÐ·',0),(592209,16501,'bg','Ð”ÑŠÑ€Ð¶Ð°Ð²Ð°Ñ‚Ð° Ð·Ð°Ð´ÑŠÑ€Ð¶Ð°',0),(592210,16502,'bg','ÐžÐ±Ð»Ð°Ð³Ð°ÐµÐ¼Ð° Ð·Ð°Ð¿Ð»Ð°Ñ‚Ð¸',0),(592211,16420,'zh','æ£€æŸ¥ä¿¡æ¯',0),(592212,16421,'zh','æ£€æŸ¥æ‰¾ä¸åˆ°',0),(592213,16422,'zh','æ£€æŸ¥ä¿å­˜',0),(592214,16423,'zh','ç¼–è¾‘æ£€æŸ¥',0),(592215,16424,'zh','ä¿å­˜æ£€æŸ¥æ—¶å‡ºçŽ°é”™è¯¯',0),(592216,16425,'zh','å¯ä»¥ç¼–è¾‘å”¯ä¸€ AP æ£€æŸ¥',0),(592217,16426,'zh','è‹¥è¦ç¼–è¾‘æ­¤æ£€æŸ¥å¿…é¡»ä½œåºŸï¼Œå¹¶é‡æ–°åˆ›å»º',0),(592218,16427,'zh','å¸æˆ·å·',0),(592219,16428,'zh','èµ„äº§è´Ÿå€ºè¡¨-åˆ†ç±»',0),(592220,16429,'zh','æ²¡æœ‰è¿›è¡Œåˆ†ç»„',0),(592221,16430,'zh','ç”±å°è®¡',0),(592222,16431,'zh','æœªåˆ†é…',0),(592223,16432,'zh','è´¹ç”¨çš„æ‘˜è¦',0),(592224,16433,'zh','ä¾›åº”å•†è¯ä¹¦è¿‡æœŸ',0),(592225,16434,'zh','è¯ä¹¦åç§°',0),(592226,16435,'zh','è¯ä¹¦ç±»åž‹',0),(592227,16436,'zh','æ˜¾ç¤ºè¯ä¹¦è¿‡æœŸä¹‹å‰',0),(592228,16437,'zh','ä½™é¢',0),(592229,16438,'zh','ç›´æŽ¥ä¸‹è½½é“¾æŽ¥',0),(592230,16439,'zh','æ‚¨çš„ä¸‹è½½åº”è¯¥é©¬ä¸Šå¼€å§‹',0),(592231,16440,'zh','é»˜è®¤æ•°é‡ä¸ºé›¶æ”¶åˆ°',0),(592232,16441,'zh','éšè—çš„ä»£è¨€äººå¤é€‰æ¡†',0),(592233,16442,'zh','é»˜è®¤æ•°é‡è¿åˆ°é›¶',0),(592234,16443,'zh','ç¼–è¾‘å¤±è´¥',0),(592235,16444,'zh','ä¹‹åŽä½ é€‰æ‹©æ¥èˆ¹è¢«åˆ›å»ºæ–°çš„è£…è¿',0),(592236,16445,'zh','é˜²æ­¢å¯èƒ½çš„åŒé‡æ•°æ®æäº¤',0),(592237,16446,'zh','å–æ¶ˆçš„è´§ä»¶å¤„ç†',0),(592238,16447,'zh','é¢„è®¡çš„äº¤è´§',0),(592239,16448,'zh','è¿‡å¸å‡­è¯',0),(592240,16449,'zh','å‡­è¯æ˜¯åœ¨ä¸€ä¸ªå°é—­çš„æ—¶æœŸ',0),(592241,16450,'zh','ç”±ä¸å¹³è¡¡',0),(592242,16451,'zh','å®žä½“',0),(592243,16452,'zh','ä½œä¸šæˆæœ¬æ‘˜è¦',0),(592244,16453,'zh','è¯·é€‰æ‹©ä¸€ä»½å·¥ä½œ',0),(592245,16454,'zh','T è–ªé…¬',0),(592246,16455,'zh','æ•°æ®å·²æˆåŠŸæ›´æ–°',0),(592247,16456,'zh','å‡ ä¸ªå°æ—¶èŠ‚çœæˆæœ¬çš„ä»£ç  & å·¥ä½œå˜åŠ¨',0),(592248,16457,'zh','ç›²ç›®çš„èˆ¹',0),(592249,16458,'zh','æ­¤é“¶è¡Œå­˜æ¬¾å·²è¢«æ¸…é™¤çš„é“¶è¡Œå¯¹å¸å•',0),(592250,16459,'zh','å¯ä»¥ç¼–è¾‘å”¯ä¸€ AP æ£€æŸ¥',0),(592251,16460,'zh','è‡ªåŠ¨é€‰æ‹©',0),(592252,16461,'zh','è¿™ç¬”å­˜æ¬¾å·²è¢«åˆ—å…¥é“¶è¡Œå’Œè§£æœˆ',0),(592253,16462,'zh','ä½ å¿…é¡»å–æ¶ˆé€‰ä¸­å®ƒä»Žé“¶è¡Œå’Œè§£é¡µè¿›è¡Œç¼–è¾‘',0),(592254,16463,'zh','ç»§ç»­ä¼šå¼•èµ·ä»¥ä¸‹çš„åžƒåœ¾ç®±ï¼Œæˆä¸ºä»Žè¿™äº›é¡¹ç›®çš„é“¾æŽ¥',0),(592255,16464,'zh','åˆ é™¤è®°å½•',0),(592256,16465,'zh','ä»“åº“ä»“',0),(592257,16466,'zh','æ­¤ä»£ç ä»“åº“ä»“å·²å­˜åœ¨',0),(592258,16467,'zh','å¿…é¡»è®¾ç½®ä»“åº“ Bin ä»£ç ',0),(592259,16468,'zh','ä»“åº“åŒº',0),(592260,16469,'zh','ç»§ç»­ä¼šå¼•èµ·ä»¥ä¸‹çš„åžƒåœ¾ç®±ï¼Œä»Žè¯¥åŒºåŸŸæˆä¸ºæœªé“¾æŽ¥',0),(592261,16470,'zh','é€šè¿‡è¿™æ®µä»£ç ä»“åº“åŒºåŸŸå·²ç»å­˜åœ¨',0),(592262,16471,'zh','å¿…é¡»è®¾ç½®ä»“åº“åŒºä»£ç ',0),(592263,16472,'zh','å¿…é¡»è®¾ç½®å¼€å§‹å’Œç»“æŸæ—¥æœŸ',0),(592264,16473,'zh','æ²¡æœ‰è®¾ç½®é»˜è®¤ä½ç½®',0),(592265,16474,'zh','æ²¡æœ‰çº§åˆ«è®¾ç½®çš„é»˜è®¤ä»·æ ¼',0),(592266,16475,'zh','ç‰¹æ®Šçš„é”€å”®å®šä»·',0),(592267,16476,'zh','æ ‡å‡†ä»·æ ¼',0),(592268,16477,'zh','æŸ¥è¯¢',0),(592269,16478,'zh','Interbranch è½¬è®©',0),(592270,16479,'zh','POS é”€å”®',0),(592271,16480,'zh','é”€å”®å‘ç¥¨',0),(592272,16481,'zh','é”€å”®æŠ¥ä»·',0),(592273,16482,'zh','ä»“åº“çš„åžƒåœ¾ç®±',0),(592274,16483,'zh','ä»“åº“åŒº',0),(592275,16484,'zh','åŸºé‡‘åç§°',0),(592276,16485,'zh','Bin ä½ç½®',0),(592277,16486,'zh','æ­¤ä½ç½®æ²¡æœ‰åžƒåœ¾ç®±åŠŸå¤«',0),(592278,16487,'zh','ä¸»å®¾',0),(592279,16488,'zh','ä½œä¸šåŽ†å²è®°å½•',0),(592280,16489,'zh','å·¥ä½œæ‘˜è¦',0),(592281,16490,'zh','åŠ³åŠ¨å¼€é”€',0),(592282,16491,'zh','åŠ³åŠ¨æ—¶é—´',0),(592283,16492,'zh','æ¥æº',0),(592284,16493,'zh','æ€»åŠ³åŠ¨æˆæœ¬',0),(592285,16494,'zh','æ€»ä¾›åº”å•†çš„æˆæœ¬',0),(592286,16495,'zh','ä¾›åº”å•†è´¦å•æ”¯ä»˜',0),(592287,16496,'zh','å·¥èµ„æ€»é¢å†åŠ ä¸Šå…ç¨Ž',0),(592288,16497,'zh','å·¥èµ„æ€»é¢å†åŠ ä¸Šæ¯å¹´å…ç¨Ž',0),(592289,16498,'zh','å¸‚å·¥èµ„',0),(592290,16499,'zh','ç¾Žè”å‚¨çš„å·¥èµ„',0),(592291,16500,'zh','é€šè¿‡å·¥èµ„æ€»é¢',0),(592292,16501,'zh','è¢«æ‰£ç•™çš„çŠ¶æ€',0),(592293,16502,'zh','åº”çº³ç¨Žå·¥èµ„',0),(592294,16420,'da','Kontrollere oplysninger',0),(592295,16421,'da','Kontroller ikke fundet',0),(592296,16422,'da','Check gemt',0),(592297,16423,'da','Redigere indskrive',0),(592298,16424,'da','Fejl under lagring af Check',0),(592299,16425,'da','Eneste AP kontrol kan redigeres',0),(592300,16426,'da','Hvis du vil redigere denne kontrol skal du annullere og genskabe',0),(592301,16427,'da','Konto #',0),(592302,16428,'da','Balancen - kategoriseret',0),(592303,16429,'da','Ingen gruppering',0),(592304,16430,'da','Subtotal af',0),(592305,16431,'da','Ikke-tildelte',0),(592306,16432,'da','Pris oversigt',0),(592307,16433,'da','Kreditor certifikater udlÃ¸ber',0),(592308,16434,'da','Certifikatnavn',0),(592309,16435,'da','Certifikattype',0),(592310,16436,'da','Vis certifikater udlÃ¸ber fÃ¸r',0),(592311,16437,'da','Balance resterende',0),(592312,16438,'da','Lede dataoverfÃ¸re samkÃ¸re',0),(592313,16439,'da','Din Download vil begynde et Ã¸jeblik',0),(592314,16440,'da','Standardantallet modtaget til nul',0),(592315,16441,'da','Skjule Endorser afkrydsningsfelter',0),(592316,16442,'da','Standard mÃ¦ngde afsendt til nul',0),(592317,16443,'da','Rediger mislykkedes',0),(592318,16444,'da','En ny forsendelse blev oprettet efter du havde valgt at skibet',0),(592319,16445,'da','Mulige dobbelte dataindsendelse forhindret',0),(592320,16446,'da','Leverance annulleret',0),(592321,16447,'da','Forventet levering',0),(592322,16448,'da','Bilaget er bogfÃ¸rt',0),(592323,16449,'da','Voucher er i et lukket tidsrum',0),(592324,16450,'da','Ubalanceret af',0),(592325,16451,'da','Enhed',0),(592326,16452,'da','Job koste ResumÃ©',0),(592327,16453,'da','VÃ¦lg et Job',0),(592328,16454,'da','T Pay',0),(592329,16455,'da','Data opdateret',0),(592330,16456,'da','Gem pris kode & jobskift i timer',0),(592331,16457,'da','Blinde skib',0),(592332,16458,'da','Denne bankindbetaling er blevet ryddet pÃ¥ bankens kontoudtog',0),(592333,16459,'da','Eneste AP kontrol kan redigeres',0),(592334,16460,'da','VÃ¦lg automatisk',0),(592335,16461,'da','Dette depositum er blevet medtaget i en Bank forsoning mÃ¥ned',0),(592336,16462,'da','Du skal fjerne markeringen af det fra siden Bank forsoning for at redigere',0),(592337,16463,'da','Fortsat vil hidfÃ¸re de fÃ¸lgende placeringer blive uden hyperlinks fra disse elementer',0),(592338,16464,'da','Posten slettet',0),(592339,16465,'da','Lageret Bin',0),(592340,16466,'da','Lageret Bin denne kode findes allerede',0),(592341,16467,'da','Lageret placeringskode skal angives',0),(592342,16468,'da','Lageret Zone',0),(592343,16469,'da','Fortsat vil hidfÃ¸re de fÃ¸lgende placeringer til at blive fjernet fra denne Zone',0),(592344,16470,'da','Lageret Zone af denne kode findes allerede',0),(592345,16471,'da','Lageret zonekoden skal angives',0),(592346,16472,'da','Start- og slutdato skal angives',0),(592347,16473,'da','Ingen standard placering sÃ¦t',0),(592348,16474,'da','Ingen standard pris niveau sÃ¦t',0),(592349,16475,'da','SÃ¦rligt salg prissÃ¦tning',0),(592350,16476,'da','Standardpriser',0),(592351,16477,'da','ForespÃ¸rgsler',0),(592352,16478,'da','Brancheorganisationer overfÃ¸rsler',0),(592353,16479,'da','POS salg',0),(592354,16480,'da','Salgsfaktura',0),(592355,16481,'da','Salgstilbud',0),(592356,16482,'da','Lagerplaceringerne',0),(592357,16483,'da','Lageret zoner',0),(592358,16484,'da','Fondens navn',0),(592359,16485,'da','Bin steder',0),(592360,16486,'da','Ingen placeringer Avaible For denne placering',0),(592361,16487,'da','PrimÃ¦re Bin',0),(592362,16488,'da','Joboversigt',0),(592363,16489,'da','Job oversigt',0),(592364,16490,'da','Labor Overhead',0),(592365,16491,'da','Labor tid',0),(592366,16492,'da','Kilder',0),(592367,16493,'da','Samlede Labor omkostninger',0),(592368,16494,'da','Total leverandÃ¸r omkostninger',0),(592369,16495,'da','Bill kreditorbetalinger',0),(592370,16496,'da','Brutto lÃ¸n Plus ej',0),(592371,16497,'da','Brutto lÃ¸n Plus ej pr. Ã¥r',0),(592372,16498,'da','Byen lÃ¸n',0),(592373,16499,'da','Fed lÃ¸n',0),(592374,16500,'da','Brutto lÃ¸n gennem',0),(592375,16501,'da','Staten tilbageholdt',0),(592376,16502,'da','Skattepligtig lÃ¸n',0),(592377,16420,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(592378,16421,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ù†Ø´Ø¯',0),(592379,16422,'dr','Ø¨Ø±Ø±Ø³ÛŒ Ø°Ø®ÛŒØ±Ù‡',0),(592380,16423,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø¨Ø±Ø±Ø³ÛŒ',0),(592381,16424,'dr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÛŒØ±Ù‡ Ú†Ú©',0),(592382,16425,'dr','Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³ ØªÙ†Ù‡Ø§ Ú†Ú© Ø±Ø§ Ù…ÛŒ ØªÙˆØ§Ù† ÙˆÛŒØ±Ø§ÛŒØ´',0),(592383,16426,'dr','Ø¨Ø±Ø§ÛŒ ÙˆÛŒØ±Ø§ÛŒØ´ Ø§ÛŒÙ† Ø¨Ø±Ø±Ø³ÛŒ Ø´Ù…Ø§ Ø§Ø² Ø¯Ø±Ø¬Ù‡ Ø§Ø¹ØªØ¨Ø§Ø± Ø³Ø§Ù‚Ø· Ø§Ø² Ù†Ùˆ Ø®Ù„Ù‚ Ú©Ø±Ø¯Ù† Ùˆ Ø¨Ø§ÛŒØ¯',0),(592384,16427,'dr','# Ø­Ø³Ø§Ø¨',0),(592385,16428,'dr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ - Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÛŒ',0),(592386,16429,'dr','Ø¨Ø¯ÙˆÙ† Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÛŒ',0),(592387,16430,'dr','Ù‚ÛŒÙ…Øª Ú©Ù„ ØªÙˆØ³Ø·',0),(592388,16431,'dr','ÙˆØ±Ø²Ø´ Ø¬Ù‡Ø§Ù†',0),(592389,16432,'dr','Ø®Ù„Ø§ØµÙ‡ Ù‡Ø²ÛŒÙ†Ù‡',0),(592390,16433,'dr','Ú¯ÙˆØ§Ù‡ÛŒÙ†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ù†Ù‚Ø¶Ø§ÛŒ',0),(592391,16434,'dr','Ù†Ø§Ù… Ú¯ÙˆØ§Ù‡ÛŒ',0),(592392,16435,'dr','Ù†ÙˆØ¹ Ù…Ø¯Ø±Ú© Ø§Ø®Ø° Ø´Ø¯Ù‡',0),(592393,16436,'dr','Ú¯ÙˆØ§Ù‡ÛŒ Ù†Ø§Ù…Ù‡ Ù‡Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†Ù‚Ø¶Ø§ÛŒ',0),(592394,16437,'dr','ØªØ¹Ø§Ø¯Ù„ Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(592395,16438,'dr','Ù„ÛŒÙ†Ú© Ù…Ø³ØªÙ‚ÛŒÙ… Ø¯Ø§Ù†Ù„ÙˆØ¯',0),(592396,16439,'dr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø®ÙˆØ¯ Ø±Ø§ Ù„Ø­Ø¸Ù‡ Ø§ÛŒ Ø¨Ø§ÛŒØ¯ Ø´Ø±ÙˆØ¹',0),(592397,16440,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¯Ø±ÛŒØ§ÙØª Ø¨Ù‡ ØµÙØ±',0),(592398,16441,'dr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ú©Ø§Ø¯Ø± Ø³ØªØ§ÛŒØ´',0),(592399,16442,'dr','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ù‡ ØµÙØ±',0),(592400,16443,'dr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù†Ø´Ø¯',0),(592401,16444,'dr','Ù¾Ø³ Ø§Ø² Ø´Ù…Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù‡ Ú©Ø´ØªÛŒ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(592402,16445,'dr','Ø«Ø¨Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø¯Ùˆ Ù…Ø§Ù†Ø¹',0),(592403,16446,'dr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù„ØºÙˆ Ø´Ø¯',0),(592404,16447,'dr','ØªØ­ÙˆÛŒÙ„ Ø­Ø¯ÙˆØ¯',0),(592405,16448,'dr','Ú©ÙˆÙ¾Ù† Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(592406,16449,'dr','Ú©ÙˆÙ¾Ù† Ø¯Ø± Ø¯ÙˆØ±Ù‡ Ø¨Ø³ØªÙ‡ Ø§Ø³Øª',0),(592407,16450,'dr','ØªÙˆØ³Ø· Ù†Ø§Ù…ØªØ¹Ø§Ø¯Ù„',0),(592408,16451,'dr','Ù†Ù‡Ø§Ø¯',0),(592409,16452,'dr','Ú©Ø§Ø± Ø®Ù„Ø§ØµÙ‡ Ù‡Ø²ÛŒÙ†Ù‡',0),(592410,16453,'dr','Ù„Ø·ÙØ§ Ú©Ø§Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(592411,16454,'dr','T Ù¾Ø±Ø¯Ø§Ø®Øª',0),(592412,16455,'dr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(592413,16456,'dr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ø¯ & Ú©Ø§Ø± ØªØºÛŒÛŒØ± Ø³Ø§Ø¹Øª',0),(592414,16457,'dr','Ú©Ø´ØªÛŒ Ù‡Ø§ÛŒ Ú©ÙˆØ±',0),(592415,16458,'dr','Ø§ÛŒÙ† Ø¨Ø§Ù†Ú© Ø³Ù¾Ø±Ø¯Ù‡ Ø¯Ø± Ø¨Ø§Ù†Ú© Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù¾Ø§Ú© Ø´Ø¯Ù‡',0),(592416,16459,'dr','Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³ ØªÙ†Ù‡Ø§ Ú†Ú© Ø±Ø§ Ù…ÛŒ ØªÙˆØ§Ù† ÙˆÛŒØ±Ø§ÛŒØ´',0),(592417,16460,'dr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(592418,16461,'dr','Ø§ÛŒÙ† Ø³Ù¾Ø±Ø¯Ù‡ Ø¯Ø± Ø¨Ø§Ù†Ú© Ù…Ø§Ù‡ Ø¢Ø´ØªÛŒ Ú¯Ù†Ø¬Ø§Ù†Ø¯Ù‡ Ø´Ø¯Ù‡',0),(592419,16462,'dr','Ø´Ù…Ø§ Ø§Ø² ØµÙØ­Ù‡ Ø¢Ø´ØªÛŒ Ø¨Ø§Ù†Ú© Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± ÙˆÛŒØ±Ø§ÛŒØ´ Ù„ØºÙˆ Ø¨Ø§ÛŒØ¯',0),(592420,16463,'dr','Ø¹Ù„Øª Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ú¯Ø±Ø¯ Ùˆ ØºØ¨Ø§Ø± Ø²ÛŒØ± Ø¨Ø±Ø§ÛŒ ØªØ¨Ø¯ÛŒÙ„ Ø´Ø¯Ù† Ø§Ø² Ø§ÛŒÙ† Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø¯ÙˆÙ† Ù¾ÛŒÙˆÙ†Ø¯ Ø¨Ù‡ Ø§Ø¯Ø§Ù…Ù‡',0),(592421,16464,'dr','Ø­Ø°Ù Ø±Ú©ÙˆØ±Ø¯',0),(592422,16465,'dr','Ø¨Ù† Ø§Ù†Ø¨Ø§Ø±',0),(592423,16466,'dr','Ø§Ù†Ø¨Ø§Ø± Ø²Ø¨Ø§Ù„Ù‡ ØªÙˆØ³Ø· Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(592424,16467,'dr','Ú©Ø¯ Ø¨Ù† Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ÛŒØ¯ ØªØ¹ÛŒÛŒÙ† Ø´ÙˆØ¯',0),(592425,16468,'dr','Ù…Ù†Ø·Ù‚Ù‡ Ø§Ù†Ø¨Ø§Ø±',0),(592426,16469,'dr','Ø¹Ù„Øª Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ú¯Ø±Ø¯ Ùˆ ØºØ¨Ø§Ø± Ø²ÛŒØ± Ø¨Ø±Ø§ÛŒ ØªØ¨Ø¯ÛŒÙ„ Ø´Ø¯Ù† Ø§Ø² Ø§ÛŒÙ† Ù…Ù†Ø·Ù‚Ù‡ Ø¨Ø¯ÙˆÙ† Ù¾ÛŒÙˆÙ†Ø¯ Ø¨Ù‡ Ø§Ø¯Ø§Ù…Ù‡',0),(592427,16470,'dr','Ø§Ù†Ø¨Ø§Ø± Ù…Ù†Ø·Ù‚Ù‡ ØªÙˆØ³Ø· Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(592428,16471,'dr','Ú©Ø¯ Ù…Ù†Ø·Ù‚Ù‡ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ÛŒØ¯ ØªØ¹ÛŒÛŒÙ† Ø´ÙˆØ¯',0),(592429,16472,'dr','Ø¨Ø§ÛŒØ¯ ØªÙ†Ø¸ÛŒÙ… Ø´Ø±ÙˆØ¹ Ùˆ Ù¾Ø§ÛŒØ§Ù† ØªØ§Ø±ÛŒØ®',0),(592430,16473,'dr','Ù‡ÛŒÚ† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ú©Ø§Ù† Ù¾ÛŒØ´ ÙØ±Ø¶',0),(592431,16474,'dr','Ù‡ÛŒÚ† Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‚ÛŒÙ…Øª ØªØ¹ÛŒÛŒÙ† Ø³Ø·Ø­',0),(592432,16475,'dr','ÙØ±ÙˆØ´ ÙˆÛŒÚ˜Ù‡ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(592433,16476,'dr','Ù‚ÛŒÙ…Øª Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(592434,16477,'dr','Ø³ÙˆØ§Ù„Ø§Øª',0),(592435,16478,'dr','Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª interbranch',0),(592436,16479,'dr','ÙØ±ÙˆØ´ POS',0),(592437,16480,'dr','ÙØ§Ú©ØªÙˆØ± ÙØ±ÙˆØ´',0),(592438,16481,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ ÙØ±ÙˆØ´',0),(592439,16482,'dr','Ù…Ø®Ø§Ø²Ù† Ø§Ù†Ø¨Ø§Ø±',0),(592440,16483,'dr','Ù…Ù†Ø§Ø·Ù‚ Ø§Ù†Ø¨Ø§Ø±',0),(592441,16484,'dr','Ù†Ø§Ù… ØµÙ†Ø¯ÙˆÙ‚',0),(592442,16485,'dr','Ù…Ú©Ø§Ù† Ù‡Ø§ÛŒ Ø¨Ù†',0),(592443,16486,'dr','Ù‡ÛŒÚ† Avaible Ù…Ø®Ø§Ø²Ù† Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ú©Ø§Ù†',0),(592444,16487,'dr','Ø¨Ù† Ø§ÙˆÙ„ÛŒÙ‡',0),(592445,16488,'dr','Ø³Ø§Ø¨Ù‚Ù‡ Ú©Ø§Ø±',0),(592446,16489,'dr','Ø®Ù„Ø§ØµÙ‡ Ú©Ø§Ø±',0),(592447,16490,'dr','Ú©Ø§Ø± Ø¨Ø§Ù„Ø§ÛŒ Ø³Ø±',0),(592448,16491,'dr','Ø²Ù…Ø§Ù† Ú©Ø§Ø±',0),(592449,16492,'dr','Ù…Ù†Ø§Ø¨Ø¹',0),(592450,16493,'dr','Ú©Ù„ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù†ÛŒØ±ÙˆÛŒ Ú©Ø§Ø±',0),(592451,16494,'dr','Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ù„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(592452,16495,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(592453,16496,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§Ø®Ø§Ù„Øµ Ù¾Ù„Ø§Ø³ Nontaxable',0),(592454,16497,'dr','Ù†Ø§Ø®Ø§Ù„Øµ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù‡Ù…Ø±Ø§Ù‡ Nontaxable Ø¯Ø± Ù‡Ø± Ø³Ø§Ù„',0),(592455,16498,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø´Ù‡Ø±',0),(592456,16499,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ ØªØºØ°ÛŒÙ‡',0),(592457,16500,'dr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ø·Ø±ÛŒÙ‚ Ù†Ø§Ø®Ø§Ù„Øµ',0),(592458,16501,'dr','Ø¯ÙˆÙ„Øª Ù†Ú©Ø±Ø¯Ù†',0),(592459,16502,'dr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(592460,16420,'nl','Raadpleeg informatie',0),(592461,16421,'nl','Selectievakje niet gevonden',0),(592462,16422,'nl','Selectievakje opgeslagen',0),(592463,16423,'nl','Selectievakje bewerken',0),(592464,16424,'nl','Fout bij het opslaan van selectievakje',0),(592465,16425,'nl','Enige AP controles kunnen worden bewerkt',0),(592466,16426,'nl','Als u wilt bewerken van deze controle moet u vernietigen en opnieuw',0),(592467,16427,'nl','Account #',0),(592468,16428,'nl','Balans - gecategoriseerd',0),(592469,16429,'nl','Geen groepering',0),(592470,16430,'nl','Subtotaal door',0),(592471,16431,'nl','Niet-toegewezen',0),(592472,16432,'nl','Kosten overzicht',0),(592473,16433,'nl','Leverancier certificaten verlopen',0),(592474,16434,'nl','Certificaatnaam',0),(592475,16435,'nl','Certificaattype',0),(592476,16436,'nl','Toon certificaten die verstrijkt voordat',0),(592477,16437,'nl','Restbedrag',0),(592478,16438,'nl','Directe downloadlink',0),(592479,16439,'nl','Uw Download moet even beginnen',0),(592480,16440,'nl','Standaard hoeveelheid ontvangen op nul',0),(592481,16441,'nl','Selectievakjes Endorser verbergen',0),(592482,16442,'nl','Standaard hoeveelheid verscheept naar nul',0),(592483,16443,'nl','Bewerking mislukt',0),(592484,16444,'nl','Een nieuwe verzending is gemaakt nadat u Had geselecteerd voor schip',0),(592485,16445,'nl','Indienen van de mogelijk dubbele gegevens voorkomen',0),(592486,16446,'nl','Verzendingsverwerking geannuleerd',0),(592487,16447,'nl','De geschatte levertijd',0),(592488,16448,'nl','Bon is geboekt',0),(592489,16449,'nl','Voucher Is In een gesloten periode',0),(592490,16450,'nl','Onevenwichtig door',0),(592491,16451,'nl','Entiteit',0),(592492,16452,'nl','Baan kosten overzicht',0),(592493,16453,'nl','Selecteer een baan',0),(592494,16454,'nl','T betalen',0),(592495,16455,'nl','Gegevens bijgewerkt',0),(592496,16456,'nl','Kosten Code & baan wijzigingen opslaan urenlang',0),(592497,16457,'nl','Blind schip',0),(592498,16458,'nl','Deze Bank Deposit is gewist op bankafschrift',0),(592499,16459,'nl','Enige AP controles kunnen worden bewerkt',0),(592500,16460,'nl','Automatisch selecteren',0),(592501,16461,'nl','Deze storting is opgenomen In een Bank verzoening maand',0),(592502,16462,'nl','U moet het vinkje uit het vanaf de Bank verzoening pagina om te bewerken',0),(592503,16463,'nl','Voortzetting van de oorzaak zal de volgende opslaglocaties worden ontkoppeld van deze Items',0),(592504,16464,'nl','Record is verwijderd',0),(592505,16465,'nl','Magazijn-Bin',0),(592506,16466,'nl','Magazijn Bin door deze Code bestaat al',0),(592507,16467,'nl','De Code van de opslaglocatie van het magazijn moet worden ingesteld',0),(592508,16468,'nl','Magazijn Zone',0),(592509,16469,'nl','Verder zal oorzaak de volgende opslaglocaties worden ontkoppeld van deze Zone',0),(592510,16470,'nl','Magazijn Zone door deze Code bestaat al',0),(592511,16471,'nl','Magazijn zonenummer moet worden ingesteld',0),(592512,16472,'nl','Begin- en einddatum moeten worden ingesteld',0),(592513,16473,'nl','Geen standaard locatie Set',0),(592514,16474,'nl','Geen standaard prijs niveau Set',0),(592515,16475,'nl','Speciale verkoop prijzen',0),(592516,16476,'nl','Standaard prijs',0),(592517,16477,'nl','Onderzoeken',0),(592518,16478,'nl','Interprofessionele Transfers',0),(592519,16479,'nl','POS-verkoop',0),(592520,16480,'nl','Verkoopfactuur',0),(592521,16481,'nl','Verkoopofferte',0),(592522,16482,'nl','Magazijn opslaglocaties',0),(592523,16483,'nl','Magazijn Zones',0),(592524,16484,'nl','De naam van het Fonds',0),(592525,16485,'nl','Bin locaties',0),(592526,16486,'nl','Geen opslaglocaties Avaible voor deze locatie',0),(592527,16487,'nl','Primaire Bin',0),(592528,16488,'nl','Overzicht van functies',0),(592529,16489,'nl','Job overzicht',0),(592530,16490,'nl','Arbeid Overhead',0),(592531,16491,'nl','Labor tijd',0),(592532,16492,'nl','Bronnen',0),(592533,16493,'nl','Totale arbeidskosten',0),(592534,16494,'nl','De leverancier van de totale kosten',0),(592535,16495,'nl','Bill Betalingsvoorstellen',0),(592536,16496,'nl','Brutoloon Plus Nontaxable',0),(592537,16497,'nl','Brutoloon Plus Nontaxable Per jaar',0),(592538,16498,'nl','Stad lonen',0),(592539,16499,'nl','Fed lonen',0),(592540,16500,'nl','Brutoloon via',0),(592541,16501,'nl','Staat ingehouden',0),(592542,16502,'nl','Belastbaar loon',0),(592543,16420,'et','Lugege',0),(592544,16421,'et','Sisse ei leitud',0),(592545,16422,'et','Salvestatud sisse',0),(592546,16423,'et','Redigeeri sisse',0),(592547,16424,'et','Sisse salvestamise tÃµrge',0),(592548,16425,'et','Saab redigeerida ainult AP kontrolli',0),(592549,16426,'et','Muuta selle sisse tuleb tÃ¼histada ja taastada',0),(592550,16427,'et','Konto #',0),(592551,16428,'et','Bilanss - kategoriseeritud',0),(592552,16429,'et','Grupeerida',0),(592553,16430,'et','Vahesumma â€“ poolt',0),(592554,16431,'et','MÃ¤Ã¤ramata',0),(592555,16432,'et','Kulude KokkuvÃµte',0),(592556,16433,'et','Hankija sertifikaatide kuni',0),(592557,16434,'et','Serdi nimi',0),(592558,16435,'et','Serdi tÃ¼Ã¼p',0),(592559,16436,'et','NÃ¤ita tunnistusi, mis lÃµpeb enne',0),(592560,16437,'et','JÃ¤relejÃ¤Ã¤nud',0),(592561,16438,'et','Direct Download Link',0),(592562,16439,'et','Allalaadimine peaks algama hetkeks',0),(592563,16440,'et','Nullini sai Vaikekogus',0),(592564,16441,'et','Peida toetaja ruudud',0),(592565,16442,'et','Vaikimisi null lÃ¤hetatud kogus',0),(592566,16443,'et','Redigeeri nurjus',0),(592567,16444,'et','Uue saadetise loodi pÃ¤rast valimist oli laevale',0),(592568,16445,'et','VÃµimalik Standard andmete esitamise takistas',0),(592569,16446,'et','LÃ¤hetuse tÃ¶Ã¶tlemine tÃ¼histatud',0),(592570,16447,'et','Eeldatav tarne',0),(592571,16448,'et','Kanne on sisestatud',0),(592572,16449,'et','Kanne on suletud perioodil',0),(592573,16450,'et','Tasakaalustamata pÃ¤rast',0),(592574,16451,'et','Ãœksus',0),(592575,16452,'et','TÃ¶Ã¶ maksumus KokkuvÃµte',0),(592576,16453,'et','Palun valige tÃ¶Ã¶',0),(592577,16454,'et','T tasu',0),(592578,16455,'et','Andmed vÃ¤rskendatud',0),(592579,16456,'et','SÃ¤Ã¤sta kulude kood & tÃ¶Ã¶kohta vahetavate tundi',0),(592580,16457,'et','Pime laeva',0),(592581,16458,'et','Panga tagatis tÃ¼hjendamist pangavÃ¤ljavÃµttel',0),(592582,16459,'et','Saab redigeerida ainult AP kontrolli',0),(592583,16460,'et','Vali automaatselt',0),(592584,16461,'et','Tagatisraha on lisatud panga vastavusseviimise kuus',0),(592585,16462,'et','Peate LÃ¼lita see panga vastavusseviimise lehe redigeerimiseks',0),(592586,16463,'et','JÃ¤tkuvat tahet pÃµhjus jÃ¤rgmiste aluste saada summaga: need Ã¼ksused',0),(592587,16464,'et','Kirje on kustutatud',0),(592588,16465,'et','Lao alusele',0),(592589,16466,'et','Lao alusele kÃ¤esolevas seadustikus on juba olemas',0),(592590,16467,'et','Laos aluse tÃ¤his peab olema seatud',0),(592591,16468,'et','Lao tsooni',0),(592592,16469,'et','JÃ¤tkuv tahe pÃµhjus saada linkimata sellest tsoonist jÃ¤rgmised alused',0),(592593,16470,'et','KÃ¤esolevas seadustikus lao tsoon on juba olemas',0),(592594,16471,'et','Tuleb mÃ¤Ã¤rata lao tsooni tÃ¤his',0),(592595,16472,'et','Algus- ja lÃµppkuupÃ¤ev tuleb mÃ¤Ã¤rata',0),(592596,16473,'et','Ei ole vaikimisi asukoht on mÃ¤Ã¤ratud',0),(592597,16474,'et','Ei ole vaikimisi hind kindlaksmÃ¤Ã¤ratud tasemele',0),(592598,16475,'et','Eripakkumiste hinnad',0),(592599,16476,'et','Tavahind',0),(592600,16477,'et','PÃ¤ringud',0),(592601,16478,'et','Tootmisharudevaheliste Ã¼lekanded',0),(592602,16479,'et','POS mÃ¼Ã¼k',0),(592603,16480,'et','MÃ¼Ã¼giarve',0),(592604,16481,'et','MÃ¼Ã¼gipakkumine',0),(592605,16482,'et','Aluseid',0),(592606,16483,'et','Lao tsoonid',0),(592607,16484,'et','Fondi nimi',0),(592608,16485,'et','Aluse asukohad',0),(592609,16486,'et','Ole aluseid Avaible selle asukoha',0),(592610,16487,'et','Esmane alus',0),(592611,16488,'et','TÃ¶Ã¶ ajalugu',0),(592612,16489,'et','TÃ¶Ã¶ KokkuvÃµte',0),(592613,16490,'et','TÃ¶Ã¶ Ã¼ldkulu',0),(592614,16491,'et','TÃ¶Ã¶ aeg',0),(592615,16492,'et','Allikad',0),(592616,16493,'et','TÃ¶Ã¶jÃµu kulud kokku',0),(592617,16494,'et','Kokku mÃ¼Ã¼ja kulud',0),(592618,16495,'et','Hankija arve maksete',0),(592619,16496,'et','Brutopalga pluss Nontaxable',0),(592620,16497,'et','Brutopalga pluss Nontaxable aastas',0),(592621,16498,'et','Linna palgad',0),(592622,16499,'et','TÃ¤is palk',0),(592623,16500,'et','Brutopalga kaudu',0),(592624,16501,'et','Riik kinni',0),(592625,16502,'et','Maksustatav tÃ¶Ã¶tasu',0),(592626,16420,'fi','Tarkista tiedot',0),(592627,16421,'fi','Uloskirjautuminen ei lÃ¶ydy',0),(592628,16422,'fi','Uloskirjautuminen tallennettu',0),(592629,16423,'fi','Muokkaa uloskirjautuminen',0),(592630,16424,'fi','Virhe tallennettaessa uloskirjautuminen',0),(592631,16425,'fi','Ainoa AP tarkastukset voidaan muokata',0),(592632,16426,'fi','Voit muokata tÃ¤tÃ¤ tarkistusta mitÃ¤tÃ¶idÃ¤ ja uudelleen',0),(592633,16427,'fi','Huomioon #',0),(592634,16428,'fi','Tase - luokiteltu',0),(592635,16429,'fi','RyhmittelyÃ¤ ei',0),(592636,16430,'fi','MennessÃ¤ yhteensÃ¤',0),(592637,16431,'fi','MÃ¤Ã¤rittÃ¤mÃ¤ttÃ¶mÃ¤t',0),(592638,16432,'fi','Kustannusten Yhteenveto',0),(592639,16433,'fi','Toimittajan todistusten pÃ¤Ã¤ttyvÃ¤n',0),(592640,16434,'fi','Varmenteen nimi',0),(592641,16435,'fi','Sertifikaattilaji',0),(592642,16436,'fi','NÃ¤yttÃ¤Ã¤ pÃ¤Ã¤ttyvÃ¤n ennen varmenteet',0),(592643,16437,'fi','JÃ¤ljellÃ¤',0),(592644,16438,'fi','Antaa tehtÃ¤vÃ¤ksi Download kytkeÃ¤',0),(592645,16439,'fi','Latauksen pitÃ¤isi alkaa hetkellisesti',0),(592646,16440,'fi','Saanut nolla oletusmÃ¤Ã¤rÃ¤',0),(592647,16441,'fi','Piilota Endorser valintaruudut',0),(592648,16442,'fi','Toimitetaan nolla oletusmÃ¤Ã¤rÃ¤',0),(592649,16443,'fi','Muokkaus epÃ¤onnistui',0),(592650,16444,'fi','Uusi lÃ¤hetys luotiin, kun valitsit aluksen',0),(592651,16445,'fi','Mahdollista kahden tietojen lÃ¤hettÃ¤minen estetÃ¤Ã¤n',0),(592652,16446,'fi','Toimituksen kÃ¤sittely peruutettiin',0),(592653,16447,'fi','Toimitukseen',0),(592654,16448,'fi','Tosite on kirjattu',0),(592655,16449,'fi','Palveluseteli on suljettu ajanjakso',0),(592656,16450,'fi','EpÃ¤symmetrinen jÃ¤lkeen',0),(592657,16451,'fi','YksikÃ¶n',0),(592658,16452,'fi','Kustannusten Yhteenveto',0),(592659,16453,'fi','Valitse tyÃ¶',0),(592660,16454,'fi','T Pay',0),(592661,16455,'fi','Tiedot pÃ¤ivitetty',0),(592662,16456,'fi','Tallenna kustannuskoodi & vaihtuu tuntia',0),(592663,16457,'fi','Sokea aluksen',0),(592664,16458,'fi','Pankkitalletus on selvitetty tiliote',0),(592665,16459,'fi','Ainoa AP tarkastukset voidaan muokata',0),(592666,16460,'fi','Automaattinen valinta',0),(592667,16461,'fi','TÃ¤mÃ¤ talletus on sisÃ¤llytetty pankki sovinnon kuukausi',0),(592668,16462,'fi','Valinta on poistettava se pankki sovinnon-sivun muokkaaminen',0),(592669,16463,'fi','Edelleen tulee aiheuttaa seuraavat jÃ¤teastioita irronnut nÃ¤istÃ¤ kohteista',0),(592670,16464,'fi','Tietue poistettu',0),(592671,16465,'fi','Varaston varastopaikka',0),(592672,16466,'fi','Varaston varastopaikka tÃ¤ssÃ¤ koodeksissa on jo olemassa',0),(592673,16467,'fi','Fyysisen varastoinnin Muutosvarastopaikan koodi on mÃ¤Ã¤ritettÃ¤vÃ¤',0),(592674,16468,'fi','Varaston vyÃ¶hyke',0),(592675,16469,'fi','Edelleen tulee aiheuttaa seuraavat jÃ¤teastioita irronnut tÃ¤ltÃ¤ vyÃ¶hykkeeltÃ¤',0),(592676,16470,'fi','Varaston vyÃ¶hyke tÃ¤ssÃ¤ koodeksissa on jo luotu',0),(592677,16471,'fi','Varaston huoltoalueen koodi on mÃ¤Ã¤ritettÃ¤vÃ¤',0),(592678,16472,'fi','Aloitus- ja pÃ¤Ã¤ttymispÃ¤ivÃ¤ on mÃ¤Ã¤ritettÃ¤vÃ¤',0),(592679,16473,'fi','Ei oletusarvoisesti sijainti',0),(592680,16474,'fi','Ei ole oletuksena hinta taso asetetaan',0),(592681,16475,'fi','AlennusmyyntejÃ¤ hinnoittelu',0),(592682,16476,'fi','Vakiohinta',0),(592683,16477,'fi','Tiedustelut',0),(592684,16478,'fi','Toimialakohtaiset siirrot',0),(592685,16479,'fi','POS myytÃ¤vÃ¤nÃ¤',0),(592686,16480,'fi','Myyntilasku',0),(592687,16481,'fi','Myyntitarjous',0),(592688,16482,'fi','Fyysisen varastoinnin varastopaikkojen',0),(592689,16483,'fi','Varaston alueet',0),(592690,16484,'fi','Rahaston nimi',0),(592691,16485,'fi','Bin sijainnit',0),(592692,16486,'fi','No varastopaikkoja Avaible tÃ¤lle sijainnille',0),(592693,16487,'fi','Ensisijainen Bin',0),(592694,16488,'fi','TyÃ¶historia',0),(592695,16489,'fi','Yhteenveto',0),(592696,16490,'fi','TyÃ¶voiman ylÃ¤puolella',0),(592697,16491,'fi','Labor Time',0),(592698,16492,'fi','LÃ¤hteet',0),(592699,16493,'fi','YhteensÃ¤ tyÃ¶voimakustannukset',0),(592700,16494,'fi','YhteensÃ¤ toimittajien kustannuksista',0),(592701,16495,'fi','Toimittajan laskujen maksu',0),(592702,16496,'fi','Bruttopalkasta Plus Nontaxable',0),(592703,16497,'fi','Bruttopalkasta Plus Nontaxable vuodessa',0),(592704,16498,'fi','Kaupungin palkat',0),(592705,16499,'fi','KyllÃ¤stynyt palkat',0),(592706,16500,'fi','Bruttopalkasta kautta',0),(592707,16501,'fi','Valtio pidÃ¤ttÃ¤Ã¤',0),(592708,16502,'fi','Veron palkat',0),(592709,16420,'fr','Consultez les infos',0),(592710,16421,'fr','Enregistrement non trouvÃ©',0),(592711,16422,'fr','Cocher sauvÃ©',0),(592712,16423,'fr','Modifier le contrÃ´le',0),(592713,16424,'fr','Erreur dâ€™enregistrement Check',0),(592714,16425,'fr','Seul AP contrÃ´les modifiables',0),(592715,16426,'fr','Pour modifier ce contrÃ´le, vous devez annuler et recrÃ©er',0),(592716,16427,'fr','Compte #',0),(592717,16428,'fr','Bilan consolidÃ© - classÃ©',0),(592718,16429,'fr','Aucun regroupement',0),(592719,16430,'fr','Sous-total par',0),(592720,16431,'fr','Non assignÃ©',0),(592721,16432,'fr','RÃ©sumÃ© Ã©conomique',0),(592722,16433,'fr','Fournisseur de certificats qui expire le',0),(592723,16434,'fr','Nom du certificat',0),(592724,16435,'fr','Type de certificat',0),(592725,16436,'fr','Voir lâ€™Ã©tablissement de certificats expirant avant',0),(592726,16437,'fr','Solde restant',0),(592727,16438,'fr','Lien de tÃ©lÃ©chargement direct',0),(592728,16439,'fr','Votre tÃ©lÃ©chargement devrait commencer momentanÃ©ment',0),(592729,16440,'fr','Par dÃ©faut quantitÃ© reÃ§ue Ã  zÃ©ro',0),(592730,16441,'fr','Masquer les cases Ã  cocher endosseur',0),(592731,16442,'fr','Par dÃ©faut quantitÃ© expÃ©diÃ©e Ã  zÃ©ro',0),(592732,16443,'fr','Edit a Ã©chouÃ©',0),(592733,16444,'fr','Une nouvelle expÃ©dition a Ã©tÃ© crÃ©Ã©e aprÃ¨s que vous aviez sÃ©lectionnÃ© au navire',0),(592734,16445,'fr','Soumission de donnÃ©es Double possible empÃªchÃ©e',0),(592735,16446,'fr','Traitement dâ€™expÃ©dition annulÃ©e',0),(592736,16447,'fr','Livraison estimÃ©e',0),(592737,16448,'fr','Bon a Ã©tÃ© affichÃ©',0),(592738,16449,'fr','Voucher est dans une pÃ©riode fermÃ©e',0),(592739,16450,'fr','DÃ©routÃ©s par',0),(592740,16451,'fr','EntitÃ©',0),(592741,16452,'fr','CoÃ»t RÃ©sumÃ©',0),(592742,16453,'fr','Veuillez sÃ©lectionner un emploi',0),(592743,16454,'fr','T Pay',0),(592744,16455,'fr','DonnÃ©es mises Ã  jour avec succÃ¨s',0),(592745,16456,'fr','Enregistrez le Code coÃ»t & changements dâ€™emploi pendant des heures',0),(592746,16457,'fr','Navire aveugle',0),(592747,16458,'fr','Ce dÃ©pÃ´t de banque a Ã©tÃ© rÃ©alisÃ© sur le relevÃ© bancaire',0),(592748,16459,'fr','Seul AP contrÃ´les modifiables',0),(592749,16460,'fr','SÃ©lection automatique',0),(592750,16461,'fr','Ce dÃ©pÃ´t a Ã©tÃ© inclus dans un mois de rapprochement bancaire',0),(592751,16462,'fr','Vous devez dÃ©cocher il partir de la Page de rÃ©conciliation bancaire afin de modifier',0),(592752,16463,'fr','Continuant Ã  Cause de la volontÃ© les emplacements suivants pour devenir dissociÃ©e de ces Ã©lÃ©ments',0),(592753,16464,'fr','Enregistrement de suppression',0),(592754,16465,'fr','Emplacement de lâ€™entrepÃ´t',0),(592755,16466,'fr','Emplacement de lâ€™entrepÃ´t de ce Code existe dÃ©jÃ ',0),(592756,16467,'fr','Code emplacement entrepÃ´t doit avoir la valeur',0),(592757,16468,'fr','Zone dâ€™entrepÃ´t',0),(592758,16469,'fr','Continuant Ã  Cause de la volontÃ© les emplacements suivants pour devenir non liÃ©s de cette Zone',0),(592759,16470,'fr','Zone dâ€™entrepÃ´t par le prÃ©sent Code existe dÃ©jÃ ',0),(592760,16471,'fr','Code de Zone de lâ€™entrepÃ´t doit avoir la valeur',0),(592761,16472,'fr','Begin et End Date doivent avoir la valeur',0),(592762,16473,'fr','Aucun jeu dâ€™emplacement par dÃ©faut',0),(592763,16474,'fr','Aucun jeu de niveau de prix par dÃ©faut',0),(592764,16475,'fr','Prix des ventes spÃ©ciales',0),(592765,16476,'fr','Prix standard',0),(592766,16477,'fr','Demandes de renseignements',0),(592767,16478,'fr','Transferts interprofessionnelles',0),(592768,16479,'fr','Vente de POS',0),(592769,16480,'fr','Facture de vente',0),(592770,16481,'fr','Devis vente',0),(592771,16482,'fr','Bacs dâ€™entrepÃ´t',0),(592772,16483,'fr','Zones de lâ€™entrepÃ´t',0),(592773,16484,'fr','Nom du Fonds',0),(592774,16485,'fr','LocalitÃ©s de bin',0),(592775,16486,'fr','Aucun disponible de bacs pour cet emplacement',0),(592776,16487,'fr','Bac principal',0),(592777,16488,'fr','Historique des travaux',0),(592778,16489,'fr','RÃ©sumÃ© de lâ€™offre',0),(592779,16490,'fr','Travail aÃ©rien',0),(592780,16491,'fr','Temps de travail',0),(592781,16492,'fr','Sources',0),(592782,16493,'fr','Total des coÃ»ts du travail',0),(592783,16494,'fr','CoÃ»t total fournisseur',0),(592784,16495,'fr','Paiements de factures fournisseur',0),(592785,16496,'fr','Salaire brut et non taxable',0),(592786,16497,'fr','Salaire brut et non taxable par an',0),(592787,16498,'fr','Salaires de la ville',0),(592788,16499,'fr','Nourris des salaires',0),(592789,16500,'fr','Par le biais de la rÃ©munÃ©ration brute',0),(592790,16501,'fr','Ã‰tat retenu',0),(592791,16502,'fr','Salaire imposable',0),(592792,16420,'de','Lesen Sie Informationen',0),(592793,16421,'de','ÃœberprÃ¼fung nicht gefunden',0),(592794,16422,'de','Check gespeichert',0),(592795,16423,'de','Check zu bearbeiten',0),(592796,16424,'de','Fehler beim Speichern des Check',0),(592797,16425,'de','Nur AP Checks kÃ¶nnen bearbeitet werden',0),(592798,16426,'de','Um diese PrÃ¼fung zu bearbeiten mÃ¼ssen Sie stornieren und neu erstellen',0),(592799,16427,'de','Konto Nr.',0),(592800,16428,'de','Bilanz - kategorisiert',0),(592801,16429,'de','Keine Gruppierung',0),(592802,16430,'de','Zwischensumme von',0),(592803,16431,'de','Nicht zugewiesen',0),(592804,16432,'de','Kosten Ãœbersicht',0),(592805,16433,'de','Hersteller-Zertifikate ablaufen',0),(592806,16434,'de','Name des Zertifikats',0),(592807,16435,'de','Zertifikatstyp',0),(592808,16436,'de','Zeigen Sie Zertifikate vor Ablauf',0),(592809,16437,'de','Restbetrag',0),(592810,16438,'de','Direkter Download-Link',0),(592811,16439,'de','Ihr Download sollte kurzzeitig beginnen',0),(592812,16440,'de','Standardmenge erhielt auf Null',0),(592813,16441,'de','Endorser KontrollkÃ¤stchen Ausblenden',0),(592814,16442,'de','Standardmenge ausgeliefert auf Null',0),(592815,16443,'de','Fehler beim Bearbeiten',0),(592816,16444,'de','Eine neue Lieferung erstellt wurde, nachdem Sie zu Schiff ausgewÃ¤hlt hatten',0),(592817,16445,'de','MÃ¶gliche doppelte DatenÃ¼bermittlung verhindert',0),(592818,16446,'de','Transportbearbeitung abgebrochen',0),(592819,16447,'de','Voraussichtliche Lieferung',0),(592820,16448,'de','Beleg wurde gebucht',0),(592821,16449,'de','Gutschein ist In einer abgeschlossenen Periode',0),(592822,16450,'de','Durch unausgewogene',0),(592823,16451,'de','EntitÃ¤t',0),(592824,16452,'de','Job Kosten Zusammenfassung',0),(592825,16453,'de','Bitte wÃ¤hlen Sie einen Job',0),(592826,16454,'de','T-Pay',0),(592827,16455,'de','Daten erfolgreich aktualisiert',0),(592828,16456,'de','Kostencode & Jobwechsel stundenlang zu retten',0),(592829,16457,'de','Blinde Schiff',0),(592830,16458,'de','Diese Ãœberweisung ist auf Kontoauszug gelÃ¶scht worden',0),(592831,16459,'de','Nur AP Checks kÃ¶nnen bearbeitet werden',0),(592832,16460,'de','Automatische Auswahl',0),(592833,16461,'de','Diese Kaution ist In einer Bank VersÃ¶hnung Monat aufgenommen worden',0),(592834,16462,'de','Sie mÃ¼ssen es von der Bank VersÃ¶hnung Seite deaktivieren, um zu bearbeiten',0),(592835,16463,'de','Weiterhin wird Ursache die folgenden BehÃ¤lter, aus diesen Elementen getrennt',0),(592836,16464,'de','Datensatz gelÃ¶scht',0),(592837,16465,'de','Lager Bin',0),(592838,16466,'de','Lager Bin durch diesen Code ist bereits vorhanden.',0),(592839,16467,'de','Bin Lagercode muss eingestellt werden',0),(592840,16468,'de','Lager-Zone',0),(592841,16469,'de','Weiterhin wird Ursache die folgenden BehÃ¤lter, aus dieser Zone getrennt',0),(592842,16470,'de','Lager-Zone mit diesem Code ist bereits vorhanden',0),(592843,16471,'de','Lager Zonencode muss eingestellt werden',0),(592844,16472,'de','Anfangs- und Enddatum mÃ¼ssen eingestellt werden',0),(592845,16473,'de','Keine Standard-Lage-Set',0),(592846,16474,'de','Kein Standard Preis eingestellt',0),(592847,16475,'de','Spezielle Verkaufspreiskalkulation',0),(592848,16476,'de','Standardpreis',0),(592849,16477,'de','Anfragen',0),(592850,16478,'de','BranchenÃ¼bergreifenden Transfer',0),(592851,16479,'de','POS-Verkauf',0),(592852,16480,'de','Verkaufsrechnung',0),(592853,16481,'de','Verkaufsangebot',0),(592854,16482,'de','Lager-BehÃ¤lter',0),(592855,16483,'de','Lagerzonen',0),(592856,16484,'de','Fondsname',0),(592857,16485,'de','LagerplÃ¤tzen',0),(592858,16486,'de','Keine BehÃ¤lter Avaible fÃ¼r diesen Standort',0),(592859,16487,'de','PrimÃ¤re Bin',0),(592860,16488,'de','Job-Historie',0),(592861,16489,'de','JobÃ¼bersicht',0),(592862,16490,'de','Arbeits-Aufwand',0),(592863,16491,'de','Personalzeit',0),(592864,16492,'de','Quellen',0),(592865,16493,'de','Summe Arbeitskosten',0),(592866,16494,'de','Insgesamt Anbieter Kosten',0),(592867,16495,'de','Bill Kreditorenzahlungen',0),(592868,16496,'de','Bruttogehalt Plus Nontaxable',0),(592869,16497,'de','Bruttogehalt Plus Nontaxable pro Jahr',0),(592870,16498,'de','Stadt LÃ¶hne',0),(592871,16499,'de','Fed LÃ¶hne',0),(592872,16500,'de','Bruttogehalt durch',0),(592873,16501,'de','Staat einbehalten',0),(592874,16502,'de','Steuerpflichtige LÃ¶hne',0),(592875,16420,'el','Î•Î»Î­Î³Î¾Ï„Îµ Ï„Î¹Ï‚ Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚',0),(592876,16421,'el','Î•Î»Î­Î³Ï‡Î¿Ï… Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(592877,16422,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ ÏƒÎµ Î­Î»ÎµÎ³Ï‡Î¿Ï‚',0),(592878,16423,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(592879,16424,'el','Î£Ï†Î¬Î»Î¼Î± ÎºÎ±Ï„Î¬ Ï„Î·Î½ Î±Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ· Ï„Î¿Ï… ÎµÎ»Î­Î³Ï‡Î¿Ï…',0),(592880,16425,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯ Î¼ÏŒÎ½Î¿ AP Î­Î»ÎµÎ³Ï‡Î¿Î¹',0),(592881,16426,'el','Î“Î¹Î± Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ Î±Ï…Ï„ÏŒÎ½ Ï„Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Î¸Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î±ÎºÏ…ÏÏŽÏƒÎµÎ¹ ÎºÎ±Î¹ Î½Î± Î±Î½Î±Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®ÏƒÎµÎ¹',0),(592882,16427,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ #',0),(592883,16428,'el','Î™ÏƒÎ¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒÏ‚ - ÎºÎ±Ï„Î·Î³Î¿ÏÎ¹Î¿Ï€Î¿Î¹Î¿ÏÎ½Ï„Î±Î¹',0),(592884,16429,'el','ÎšÎ±Î¼Î¯Î± Î¿Î¼Î±Î´Î¿Ï€Î¿Î¯Î·ÏƒÎ·',0),(592885,16430,'el','ÎœÎµÏÎ¹ÎºÏŒ ÏƒÏÎ½Î¿Î»Î¿ Î±Ï€ÏŒ',0),(592886,16431,'el','ÎœÎ· Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯ÏƒÎ¹Î¼Î¿Ï‚',0),(592887,16432,'el','ÎšÏŒÏƒÏ„Î¿Ï‚ Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(592888,16433,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŽÎ½ Ï€Î¿Ï… Î»Î®Î³Î¿Ï…Î½',0),(592889,16434,'el','ÎŒÎ½Î¿Î¼Î± Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÎ¿Ï',0),(592890,16435,'el','Î¤ÏÏ€Î¿Ï‚ Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÎ¿Ï',0),(592891,16436,'el','Î ÏÎ¿Î²Î¿Î»Î® Ï€Î¹ÏƒÏ„Î¿Ï€Î¿Î¹Î·Ï„Î¹ÎºÏŽÎ½ Ï€Î¿Ï… Î»Î®Î³Î¿Ï…Î½ Ï€ÏÎ¹Î½ Î±Ï€ÏŒ',0),(592892,16437,'el','Î¥Ï€ÏŒÎ»Î¿Î¹Ï€Î¿ Ï€Î¿Ï… Î±Ï€Î¿Î¼Î­Î½ÎµÎ¹',0),(592893,16438,'el','Î”Î¹ÎµÏ…Î¸ÏÎ½Ï‰ ÎºÎ±Ï„ÎµÎ²Î¬Î¶Ï‰ ÏƒÏÎ½Î´ÎµÏƒÎ¼Î¿Ï‚',0),(592894,16439,'el','Î— Î»Î®ÏˆÎ· Î¸Î± Î¾ÎµÎºÎ¹Î½Î®ÏƒÎµÎ¹ Ï€ÏÎ¿Ï‚ ÏƒÏ„Î¹Î³Î¼Î®Î½',0),(592895,16440,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î±ÏÎ±Î»Î±Î²Î®Ï‚ ÏƒÏ„Î¿ Î¼Î·Î´Î­Î½',0),(592896,16441,'el','Î‘Ï€ÏŒÎºÏÏ…ÏˆÎ· Ï€Î»Î±Î¯ÏƒÎ¹Î± ÎµÎ»Î­Î³Ï‡Î¿Ï… ÎµÏ€Î¹ÏƒÏ†ÏÎ¬Î³Î¹ÏƒÎ·Ï‚',0),(592897,16442,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Ï€Î¿ÏƒÏ„Î­Î»Î»Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î¿ Î¼Î·Î´Î­Î½',0),(592898,16443,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Ï€Î­Ï„Ï…Ï‡Îµ',0),(592899,16444,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ Î¼Î¹Î± Î½Î­Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®, Î±Ï†Î¿Ï ÎµÎ¯Ï‡Îµ ÎµÏ€Î¹Î»Î­Î¾ÎµÎ¹ ÏƒÎµ Ï€Î»Î¿Î¯Î¿',0),(592900,16445,'el','Î”Ï…Î½Î±Ï„ÏŒÎ½ Î´Î¹Ï€Î»Î¬ Î´ÎµÎ´Î¿Î¼Î­Î½Î± Ï…Ï€Î¿Î²Î¿Î»Î® Ï€ÏÎ¿Î»Î·Ï†Î¸ÎµÎ¯',0),(592901,16446,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Ï€Î¿ÏƒÏ„Î¿Î»Î®Ï‚ Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ',0),(592902,16447,'el','Î•ÎºÏ„Î¹Î¼ÏŽÎ¼ÎµÎ½Î· Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·',0),(592903,16448,'el','Î¤Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ Î­Ï‡ÎµÎ¹ Î±Î½Î±ÏÏ„Î·Î¸ÎµÎ¯',0),(592904,16449,'el','Î¤Î¿ ÎºÎ¿Ï…Ï€ÏŒÎ½Î¹ ÎµÎ¯Î½Î±Î¹ ÏƒÎµ ÎºÎ»ÎµÎ¹ÏƒÏ„Î® Ï€ÎµÏÎ¯Î¿Î´Î¿',0),(592905,16450,'el','Î‘ÏƒÏÎ¼Î¼ÎµÏ„ÏÎ· Î±Ï€ÏŒ',0),(592906,16451,'el','ÎŸÎ½Ï„ÏŒÏ„Î·Ï„Î±',0),(592907,16452,'el','Î•ÏÎ³Î±ÏƒÎ¯Î±Ï‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ Î ÎµÏÎ¯Î»Î·ÏˆÎ·',0),(592908,16453,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ ÎµÏ€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(592909,16454,'el','Î Î»Î·ÏÏ‰Î¼Î® T',0),(592910,16455,'el','Î”ÎµÎ´Î¿Î¼Î­Î½Î± Ï€Î¿Ï… ÎµÎ½Î·Î¼ÎµÏÏŽÎ¸Î·ÎºÎµ Î¼Îµ ÎµÏ€Î¹Ï„Ï…Ï‡Î¯Î±',0),(592911,16456,'el','Î•Î¾Î¿Î¹ÎºÎ¿Î½Î¿Î¼Î®ÏƒÏ„Îµ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ & ÎµÏÎ³Î±ÏƒÎ¯Î± Î±Î»Î»Î±Î³Î­Ï‚ Î³Î¹Î± ÏŽÏÎµÏ‚',0),(592912,16457,'el','Î¤Ï…Ï†Î»Î® Ï€Î»Î¿Î¯Î¿',0),(592913,16458,'el','ÎˆÏ‡ÎµÎ¹ ÎºÎ±Ï„Î±ÏÎ³Î·Î¸ÎµÎ¯ Î±Ï…Ï„ÏŒ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÎ® ÎºÎ±Ï„Î¬Î¸ÎµÏƒÎ· ÏƒÏ„Î¿Î½ Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ',0),(592914,16459,'el','ÎœÏ€Î¿ÏÎµÎ¯ Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯ Î¼ÏŒÎ½Î¿ AP Î­Î»ÎµÎ³Ï‡Î¿Î¹',0),(592915,16460,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÏ€Î¹Î»Î¿Î³Î®',0),(592916,16461,'el','Î‘Ï…Ï„Î® Î· Ï€ÏÎ¿ÎºÎ±Ï„Î±Î²Î¿Î»Î® Î­Ï‡ÎµÎ¹ ÏƒÏ…Î¼Ï€ÎµÏÎ¹Î»Î·Ï†Î¸ÎµÎ¯ ÏƒÎµ Î­Î½Î± Î¼Î®Î½Î± ÏƒÏ…Î¼Ï†Î¹Î»Î¯Ï‰ÏƒÎ· Ï„ÏÎ±Ï€ÎµÎ¶Î¹ÎºÏŽÎ½',0),(592917,16462,'el','Î£Î±Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Uncheck Î±Ï…Ï„ÏŒ Î±Ï€ÏŒ Ï„Î·Î½ Î¤ÏÎ¬Ï€ÎµÎ¶Î± ÏƒÏ…Î¼Ï†Î¹Î»Î¯Ï‰ÏƒÎ· ÏƒÎµÎ»Î¯Î´Î± Î³Î¹Î± Î½Î± ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÏ„ÎµÎ¯Ï„Îµ',0),(592918,16463,'el','Î£Ï…Î½ÎµÏ‡Î¯Î¶Î¿Î½Ï„Î±Ï‚ Î¸Î± Ï€ÏÎ¿ÎºÎ±Î»Î­ÏƒÎµÎ¹ Ï„Î± Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î´Î¿Ï‡ÎµÎ¯Î± Î½Î± Î³Î¯Î½ÎµÎ¹ Î±ÏƒÏÎ½Î´ÎµÏ„Î· Î±Ï€ÏŒ Î±Ï…Ï„Î¬ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(592919,16464,'el','Î”Î¹Î±Î³ÏÎ±Î¼Î¼Î­Î½Î·Ï‚ ÎºÎ±ÏÏ„Î­Î»Î±Ï‚',0),(592920,16465,'el','Î‘Ï€Î¿Î¸Î®ÎºÎ·Ï‚',0),(592921,16466,'el','Î¥Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î· Î±Ï€Î¿Î¸Î®ÎºÎ·Ï‚ Î±Ï€ÏŒ Ï„Î¿Î½ Ï€Î±ÏÏŒÎ½Ï„Î± ÎºÏŽÎ´Î¹ÎºÎ±',0),(592922,16467,'el','Î‘Ï€Î¿Î¸Î®ÎºÎ· Î¸Î­ÏƒÎ· Î±Ï€Î¿Î¸Î®ÎºÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(592923,16468,'el','Î–ÏŽÎ½Î· Î±Ï€Î¿Î¸Î®ÎºÎ·Ï‚',0),(592924,16469,'el','Î£Ï…Î½ÎµÏ‡Î¯Î¶Î¿Î½Ï„Î±Ï‚ Î¸Î± Ï€ÏÎ¿ÎºÎ±Î»Î­ÏƒÎµÎ¹ Ï„Î± Ï€Î±ÏÎ±ÎºÎ¬Ï„Ï‰ Î´Î¿Ï‡ÎµÎ¯Î± Î½Î± Î³Î¯Î½ÎµÎ¹ Î±ÏƒÏÎ½Î´ÎµÏ„Î· Î±Ï€ÏŒ Î±Ï…Ï„Î®Î½ Ï„Î· Î¶ÏŽÎ½Î·',0),(592925,16470,'el','Î‰Î´Î· Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î±Ï€Î¿Î¸Î®ÎºÎ· Î¶ÏŽÎ½Î· Î±Ï€ÏŒ Ï„Î¿Î½ Ï€Î±ÏÏŒÎ½Ï„Î± ÎºÏŽÎ´Î¹ÎºÎ±',0),(592926,16471,'el','ÎšÏ‰Î´Î¹ÎºÏŒ Î¶ÏŽÎ½Î·Ï‚ Î±Ï€Î¿Î¸Î®ÎºÎ·Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(592927,16472,'el','ÎˆÎ½Î±ÏÎ¾Î·Ï‚ ÎºÎ±Î¹ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î»Î®Î¾Î·Ï‚, Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(592928,16473,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î¿ÏÎ¹ÏƒÎ¼ÏŒÏ‚ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±Ï‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î®',0),(592929,16474,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Ï„Î¹Î¼Î® ÎµÏ€Î¯Ï€ÎµÎ´Î¿ ÏƒÏÎ½Î¿Î»Î¿',0),(592930,16475,'el','Î•Î¹Î´Î¹ÎºÎ­Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Ï„Î¹Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚',0),(592931,16476,'el','Î£Ï„Î¬Î½Ï„Î±Ï Ï„Î¹Î¼Î®',0),(592932,16477,'el','ÎˆÏÎµÏ…Î½ÎµÏ‚',0),(592933,16478,'el','Î”Î¹ÎµÏ€Î±Î³Î³ÎµÎ»Î¼Î±Ï„Î¹ÎºÎ­Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Ï‚',0),(592934,16479,'el','Î ÏŽÎ»Î·ÏƒÎ· POS',0),(592935,16480,'el','Î¤Î¹Î¼Î¿Î»ÏŒÎ³Î¹Î¿ Ï€ÏŽÎ»Î·ÏƒÎ·Ï‚',0),(592936,16481,'el','Î ÏÎ¿ÏƒÏ†Î¿ÏÎ¬ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(592937,16482,'el','Î‘Ï€Î¿Î¸Î®ÎºÎ· ÎºÎ¬Î´Î¿Ï…Ï‚',0),(592938,16483,'el','Î–ÏŽÎ½ÎµÏ‚ Î±Ï€Î¿Î¸Î®ÎºÎ·Ï‚',0),(592939,16484,'el','ÎŸÎ½Î¿Î¼Î±ÏƒÎ¯Î± Î¤Î±Î¼ÎµÎ¯Î¿Ï…',0),(592940,16485,'el','Bin Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚',0),(592941,16486,'el','ÎšÎ±Î¼Î¯Î± ÎºÎ¬Î´Î¿Ï…Ï‚ Avaible Î³Î¹Î± Î±Ï…Ï„Î®Î½ Ï„Î·Î½ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(592942,16487,'el','Î ÏÏ‰Ï„Î¿Î³ÎµÎ½Î® ÎœÏ€Î¹Î½',0),(592943,16488,'el','Î™ÏƒÏ„Î¿ÏÎ¹ÎºÏŒ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(592944,16489,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Ï„Î·Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(592945,16490,'el','Î•ÏÎ³Î±Ï„Î¹ÎºÎ¬ ÎºÎ±Î¹ Î“Î’Î•',0),(592946,16491,'el','Î§ÏÏŒÎ½Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(592947,16492,'el','Î Î·Î³Î­Ï‚',0),(592948,16493,'el','Î£Ï…Î½Î¿Î»Î¹ÎºÏŒ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎµÏÎ³Î±ÏƒÎ¯Î±Ï‚',0),(592949,16494,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¿Ï… ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¿Ï ÎºÏŒÏƒÏ„Î¿Ï…Ï‚',0),(592950,16495,'el','Î Î»Î·ÏÏ‰Î¼Î­Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŽÎ½ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(592951,16496,'el','ÎœÎ¹ÎºÏ„Î­Ï‚ Î±Ï€Î¿Î´Î¿Ï‡Î­Ï‚ ÏƒÏ…Î½ Nontaxable',0),(592952,16497,'el','ÎœÎ¹ÎºÏ„Î­Ï‚ Î±Ï€Î¿Î´Î¿Ï‡Î­Ï‚ ÏƒÏ…Î½ Nontaxable Î±Î½Î¬ Î­Ï„Î¿Ï‚',0),(592953,16498,'el','Î ÏŒÎ»Î· Î¼Î¹ÏƒÎ¸Î¿ÏÏ‚',0),(592954,16499,'el','Î¤ÏÎ­Ï†Î¿Î½Ï„Î±Î¹ Î¼Î¹ÏƒÎ¸Î¿ÏÏ‚',0),(592955,16500,'el','ÎœÎ¹ÎºÏ„Î­Ï‚ Î±Ï€Î¿Î´Î¿Ï‡Î­Ï‚ Î¼Î­ÏƒÏ‰',0),(592956,16501,'el','ÎšÏÎ¬Ï„Î¿Ï‚ Ï€Î¿Ï… Ï€Î±ÏÎ±ÎºÏÎ±Ï„Î®Î¸Î·ÎºÎµ',0),(592957,16502,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î·Ï„Î­ÎµÏ‚ Î±Ï€Î¿Î´Î¿Ï‡Î­Ï‚',0),(592958,16420,'he','×‘×“×•×§ ×”×ž×™×“×¢',0),(592959,16421,'he','×”×¡×™×ž×•×Ÿ ×œ× × ×ž×¦×',0),(592960,16422,'he','×”×¡×™×ž×•×Ÿ ×”×¦×™×œ',0),(592961,16423,'he','×¢×¨×™×›×ª ×¡×™×ž×•×Ÿ',0),(592962,16424,'he','×©×’×™××” ×‘×¢×ª ×©×ž×™×¨×ª ×”×¡×™×ž×•×Ÿ',0),(592963,16425,'he','× ×™×ª×Ÿ ×œ×¢×¨×•×š ×‘×“×™×§×•×ª ×”×™×—×™×“×” AP',0),(592964,16426,'he','×›×“×™ ×œ×¢×¨×•×š ×‘×“×™×§×” ×–×• ×™×© ×œ×©×œ×•×œ ××ª ×ž×—×“×©',0),(592965,16427,'he','×—×©×‘×•×Ÿ #',0),(592966,16428,'he','×ž××–×Ÿ - ×ž×¡×•×•×’',0),(592967,16429,'he','×œ×œ× ×§×™×‘×•×¥',0),(592968,16430,'he','×¡×›×•× ×‘×™× ×™×™× ×¢×œ-×™×“×™',0),(592969,16431,'he','×©×œ× ×”×•×§×¦×•',0),(592970,16432,'he','×¡×™×›×•× ×”×¢×œ×•×ª',0),(592971,16433,'he','×”×¡×¤×§ ××™×©×•×¨×™× ×©×¤×’ ×ª×•×§×¤×',0),(592972,16434,'he','×©× ×”××™×©×•×¨',0),(592973,16435,'he','×¡×•×’ ×”××™×©×•×¨',0),(592974,16436,'he','×”×¦×’ ××™×©×•×¨×™× ×©×¤×’ ×ª×•×§×¤× ×œ×¤× ×™',0),(592975,16437,'he','×”×™×ª×¨×” ×©× ×•×ª×¨×”',0),(592976,16438,'he','×”×§×™×©×•×¨ ×œ×”×•×¨×“×” ×™×©×™×¨×”',0),(592977,16439,'he','×”×”×•×¨×“×” ××ž×•×¨×” ×œ×”×ª×—×™×œ ×‘×›×œ ×¨×’×¢',0),(592978,16440,'he','×‘×¨×™×¨×ª ×”×ž×—×“×œ ×”×›×ž×•×ª ×©×”×ª×§×‘×œ×” ×œ××¤×¡',0),(592979,16441,'he','×”×¡×ª×¨ ×ª×™×‘×•×ª ×”×¡×™×ž×•×Ÿ Endorser',0),(592980,16442,'he','×›×ž×•×ª ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×”× ×©×œ×—×•×ª ×œ××¤×¡',0),(592981,16443,'he','×¢×¨×™×›×” × ×›×©×œ',0),(592982,16444,'he','×ž×©×œ×•×— ×—×“×© × ×•×¦×¨ ×œ××—×¨ ×‘×—×¨×ª ×œ×¡×¤×™× ×”',0),(592983,16445,'he','×©×œ×™×—×ª × ×ª×•× ×™× ×›×¤×•×œ ××¤×©×¨×™ ×œ×ž× ×•×¢',0),(592984,16446,'he','×¢×™×‘×•×“ ×”×ž×©×œ×•×— ×‘×•×˜×œ×”',0),(592985,16447,'he','×ž×©×œ×•×— ×ž×©×•×¢×¨',0),(592986,16448,'he','×”×©×•×‘×¨ × ×¨×©×',0),(592987,16449,'he','×”×©×•×‘×¨ × ×ž×¦× ×‘×ª×§×•×¤×” ×¡×’×•×¨×”',0),(592988,16450,'he','×œ× ×ž××•×–×Ÿ ×¢×œ ×™×“×™',0),(592989,16451,'he','×™×©×•×ª',0),(592990,16452,'he','×”×¢×‘×•×“×” ×™×¢×œ×” ×¡×™×›×•×',0),(592991,16453,'he','× × ×‘×—×¨ ×¢×‘×•×“×”',0),(592992,16454,'he','T ×œ×©×œ×',0),(592993,16455,'he','× ×ª×•× ×™× ×¢×•×“×›×Ÿ ×‘×”×¦×œ×—×”',0),(592994,16456,'he','×©×ž×™×¨×ª ×§×•×“ ×¢×œ×•×ª & ×”×¢×‘×•×“×” ×©×™× ×•×™×™× ×‘×ž×©×š ×©×¢×•×ª',0),(592995,16457,'he','×”×¡×¤×™× ×” ×¢×™×•×•×¨',0),(592996,16458,'he','×”×¤×™×§×“×•×Ÿ ×‘×‘× ×§ ×–×” × ×•×§×” ×¢×œ ×”×‘× ×§',0),(592997,16459,'he','× ×™×ª×Ÿ ×œ×¢×¨×•×š ×‘×“×™×§×•×ª ×”×™×—×™×“×” AP',0),(592998,16460,'he','×‘×—×™×¨×” ××•×˜×•×ž×˜×™×ª',0),(592999,16461,'he','×¤×™×§×“×•×Ÿ ×–×” ×›×‘×¨ × ×›×œ×œ ×‘×ª×•×š ×—×•×“×© ×¤×™×•×¡ ×‘× ×§',0),(593000,16462,'he','××ª×” ×‘×˜×— ×‘×˜×œ ×ž×”×¢×ž×•×“ ×¤×™×•×¡ ×”×‘× ×§ ×¢×œ ×ž× ×ª ×œ×¢×¨×•×š',0),(593001,16463,'he','×”×ž×©×š ×›×™ ×”×¦×•×•××” ××ª ×”××¨×’×–×™× ×”×‘××™× ×›×“×™ ×œ×”×™×•×ª ×ž×§×•×©×¨ ×ž×ª×•×š ×¤×¨×™×˜×™× ××œ×”',0),(593002,16464,'he','×¨×©×•×ž×•×ª ×©× ×ž×—×§×•',0),(593003,16465,'he','×ž×—×¡×Ÿ ×¡×œ',0),(593004,16466,'he','×¡×œ ×ž×—×¡×Ÿ ×œ×¤×™ ×”×§×•×“ ×”×–×” ×›×‘×¨ ×§×™×™×',0),(593005,16467,'he','×ž×—×¡×Ÿ ×¡×œ ×§×•×“ ×™×© ×œ×”×’×“×™×¨',0),(593006,16468,'he','××–×•×¨ ×”×ž×—×¡×Ÿ',0),(593007,16469,'he','×”×ž×©×š ×›×™ ×”×¦×•×•××” ××ª ×”××¨×’×–×™× ×”×‘××•×ª ×œ×”×™×•×ª ×œ× ×ž×§×•×©×¨×™× ×ž××–×•×¨ ×–×”',0),(593008,16470,'he','××–×•×¨ ×”×ž×—×¡×Ÿ ×œ×¤×™ ×”×§×•×“ ×”×–×” ×›×‘×¨ ×§×™×™×',0),(593009,16471,'he','×œ×”×’×“×™×¨ ×§×•×“ ××–×•×¨ ×”×ž×—×¡×Ÿ',0),(593010,16472,'he','×‘×’×™×Ÿ ×•×ª××¨×™×š ×”×¡×™×•× ×—×™×™×‘ ×œ×”×™×•×ª ×ž×•×’×“×¨',0),(593011,16473,'he','×œ× ×”×•×’×“×¨×• ×ž×™×§×•× ×‘×¨×™×¨×ª ×”×ž×—×“×œ',0),(593012,16474,'he','×œ× ×”×•×’×“×¨×• ×‘×¨×ž×ª ×ž×—×™×¨ ×©×œ ×‘×¨×™×¨×ª ×”×ž×—×“×œ',0),(593013,16475,'he','×ž×›×™×¨×•×ª ×ž×™×•×—×“×•×ª ×ª×ž×—×•×¨',0),(593014,16476,'he','×ž×—×™×¨ ×¨×’×™×œ',0),(593015,16477,'he','×¤× ×™×•×ª',0),(593016,16478,'he','×”×¢×‘×¨×•×ª interbranch',0),(593017,16479,'he','×ž×›×™×¨×” POS',0),(593018,16480,'he','×—×©×‘×•× ×™×ª ×ž×›×™×¨×”',0),(593019,16481,'he','×”×¦×¢×ª ×ž×—×™×¨ ×ž×›×™×¨×•×ª',0),(593020,16482,'he','×ž×—×¡×Ÿ ××¨×’×–×™×',0),(593021,16483,'he','××–×•×¨×™ ×”×ž×—×¡×Ÿ',0),(593022,16484,'he','×©× ×”×§×¨×Ÿ',0),(593023,16485,'he','×¡×œ ×ž×™×§×•×ž×™×',0),(593024,16486,'he','××™×Ÿ ×”×¨×›×‘×ª ×¤×—×™ ×¢×‘×•×¨ ×ž×™×§×•× ×–×”',0),(593025,16487,'he','×¡×œ ×¨××©×™',0),(593026,16488,'he','×”×™×¡×˜×•×¨×™×™×ª ×¢×‘×•×“×”',0),(593027,16489,'he','×¡×™×›×•× ×”×¢×‘×•×“×”',0),(593028,16490,'he','×”×¢×‘×•×“×” ×ª×§×•×¨×”',0),(593029,16491,'he','×–×ž×Ÿ ×”×¢×‘×•×“×”',0),(593030,16492,'he','×ž×§×•×¨×•×ª',0),(593031,16493,'he','×¢×œ×•×™×•×ª ×”×¢×‘×•×“×”',0),(593032,16494,'he','×”×¡×¤×§ ×¡×” ×› ×¢×œ×•×™×•×ª',0),(593033,16495,'he','×ª×©×œ×•×ž×™ ×—×©×‘×•×Ÿ ×¡×¤×§',0),(593034,16496,'he','×©×›×¨ ×‘×¨×•×˜×• ×¤×œ×•×¡ Nontaxable',0),(593035,16497,'he','×©×›×¨ ×‘×¨×•×˜×• ×¤×œ×•×¡ Nontaxable ×œ×©× ×”',0),(593036,16498,'he','×”×¢×™×¨ ×©×›×¨',0),(593037,16499,'he','×©×›×¨ ×ž×”×‘×•×œ×©×ª',0),(593038,16500,'he','×©×›×¨ ×‘×¨×•×˜×• ×“×¨×š',0),(593039,16501,'he','×”×ž×“×™× ×” ×©× ×•×›×” ×‘×ž×§×•×¨',0),(593040,16502,'he','×—×™×™×‘ ×‘×ž×¡ ×©×›×¨',0),(593041,16420,'hi','à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(593042,16421,'hi','à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤šà¥‡à¤•',0),(593043,16422,'hi','à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾ à¤šà¥‡à¤•',0),(593044,16423,'hi','à¤šà¥‡à¤• à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(593045,16424,'hi','à¤šà¥‡à¤• à¤•à¥‹ à¤¸à¤¹à¥‡à¤œà¤¨à¥‡ à¤®à¥‡à¤‚ à¤¤à¥à¤°à¥à¤Ÿà¤¿',0),(593046,16425,'hi','à¤•à¥‡à¤µà¤² AP à¤œà¤¾à¤à¤š à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(593047,16426,'hi','à¤‡à¤¸ à¤šà¥‡à¤• à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤ª à¤¶à¥‚à¤¨à¥à¤¯ à¤µà¤¿à¤¶à¥à¤°à¤¾à¤® à¤”à¤° à¤šà¤¾à¤¹à¤¿à¤',0),(593048,16427,'hi','à¤–à¤¾à¤¤à¤¾ #',0),(593049,16428,'hi','à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸ à¤¶à¥€à¤Ÿ - à¤µà¤°à¥à¤—à¥€à¤•à¥ƒà¤¤',0),(593050,16429,'hi','à¤•à¥‹à¤ˆ à¤¸à¤®à¥‚à¤¹à¥€à¤•à¤°à¤£',0),(593051,16430,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤‰à¤ª-à¤¯à¥‹à¤—',0),(593052,16431,'hi','à¤…à¤¸à¤¾à¤‡à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¥€ à¤—à¤ˆ',0),(593053,16432,'hi','à¤²à¤¾à¤—à¤¤ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(593054,16433,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤° à¤…à¤µà¤¸à¤¾à¤¨ à¤¹à¥‹ à¤°à¤¹à¤¾ à¤¹à¥ˆ',0),(593055,16434,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£ à¤ªà¤¤à¥à¤° à¤•à¤¾ à¤¨à¤¾à¤®',0),(593056,16435,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤° à¤ªà¥à¤°à¤•à¤¾à¤°',0),(593057,16436,'hi','à¤ªà¥à¤°à¤®à¤¾à¤£à¤ªà¤¤à¥à¤° à¤¸à¤®à¤¯à¤¸à¥€à¤®à¤¾ à¤¸à¤®à¤¾à¤ªà¥à¤¤ à¤¹à¥‹à¤¨à¥‡ à¤¸à¥‡ à¤ªà¤¹à¤²à¥‡ à¤¦à¤¿à¤–à¤¾à¤à¤',0),(593058,16437,'hi','à¤¶à¥‡à¤· à¤¬à¥ˆà¤²à¥‡à¤‚à¤¸',0),(593059,16438,'hi','à¤ªà¥à¤°à¤¤à¥à¤¯à¤•à¥à¤· à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤²à¤¿à¤‚à¤•',0),(593060,16439,'hi','à¤•à¥à¤·à¤£ à¤­à¤° à¤†à¤ªà¤•à¤¾ à¤¡à¤¾à¤‰à¤¨à¤²à¥‹à¤¡ à¤¶à¥à¤°à¥‚ à¤¹à¥‹ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(593061,16440,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤¹à¥à¤†',0),(593062,16441,'hi','à¤›à¤¿à¤ªà¤¾à¤à¤ à¤šà¥‡à¤•à¤¬à¥‰à¤•à¥à¤¸à¥‹à¤‚ Endorser',0),(593063,16442,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤¶à¥‚à¤¨à¥à¤¯ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤­à¥‡à¤œ à¤¦à¤¿à¤¯à¤¾',0),(593064,16443,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤«à¤² à¤°à¤¹à¤¾',0),(593065,16444,'hi','à¤†à¤ªà¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤šà¤¯à¤¨à¤¿à¤¤ à¤¥à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤•à¥‡ à¤¬à¤¾à¤¦ à¤à¤• à¤¨à¤¯à¤¾ à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤¬à¤¨à¤¾à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¥à¤¾',0),(593066,16445,'hi','à¤¸à¤‚à¤­à¤µ à¤¡à¤¬à¤² à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤¬à¤®à¤¿à¤¶à¤¨ à¤•à¥‹ à¤°à¥‹à¤•à¤¾',0),(593067,16446,'hi','à¤²à¤¦à¤¾à¤¨ à¤ªà¥à¤°à¤•à¥à¤°à¤¿à¤¯à¤¾ à¤°à¤¦à¥à¤¦',0),(593068,16447,'hi','à¤…à¤¨à¥à¤®à¤¾à¤¨à¤¿à¤¤ à¤ªà¥à¤°à¤¸à¤µ',0),(593069,16448,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤¨à¤¿à¤¯à¥à¤•à¥à¤¤ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(593070,16449,'hi','à¤µà¤¾à¤‰à¤šà¤° à¤®à¥‡à¤‚ à¤à¤• à¤¬à¤‚à¤¦ à¤…à¤µà¤§à¤¿ à¤¹à¥ˆ',0),(593071,16450,'hi','à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤…à¤¸à¤‚à¤¤à¥à¤²à¤¿à¤¤',0),(593072,16451,'hi','à¤à¤‚à¤Ÿà¤¿à¤Ÿà¥€',0),(593073,16452,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶ à¤²à¤¾à¤—à¤¤',0),(593074,16453,'hi','à¤•à¥ƒà¤ªà¤¯à¤¾ à¤•à¤¿à¤¸à¥€ à¤•à¤¾à¤°à¥à¤¯ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(593075,16454,'hi','à¤Ÿà¥€ à¤µà¥‡à¤¤à¤¨',0),(593076,16455,'hi','à¤¡à¥‡à¤Ÿà¤¾ à¤¸à¤«à¤²à¤¤à¤¾à¤ªà¥‚à¤°à¥à¤µà¤• à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(593077,16456,'hi','à¤˜à¤‚à¤Ÿà¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ & à¤¨à¥Œà¤•à¤°à¥€ à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¨ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(593078,16457,'hi','à¤…à¤‚à¤§à¤¾ à¤œà¤¹à¤¾à¤œ',0),(593079,16458,'hi','à¤‡à¤¸ à¤¬à¥ˆà¤‚à¤• à¤œà¤®à¤¾ à¤¬à¥ˆà¤‚à¤• à¤¸à¥à¤Ÿà¥‡à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤ªà¤° à¤®à¤‚à¤œà¥‚à¤°à¥€ à¤¦à¥‡ à¤¦à¥€ à¤—à¤ˆ à¤¹à¥ˆ',0),(593080,16459,'hi','à¤•à¥‡à¤µà¤² AP à¤œà¤¾à¤à¤š à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(593081,16460,'hi','à¤¸à¥à¤µà¤¤: à¤šà¤¯à¤¨',0),(593082,16461,'hi','à¤¯à¤¹ à¤œà¤®à¤¾ à¤à¤• à¤¬à¥ˆà¤‚à¤• à¤¸à¤¾à¤®à¤‚à¤œà¤¸à¥à¤¯ à¤®à¤¹à¥€à¤¨à¥‡ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¹à¥ˆ',0),(593083,16462,'hi','à¤†à¤ª à¤‡à¤¸à¥‡ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¥ˆà¤‚à¤• à¤¸à¤¾à¤®à¤‚à¤œà¤¸à¥à¤¯ à¤ªà¥ƒà¤·à¥à¤  à¤¸à¥‡ à¤…à¤¨à¤šà¥‡à¤• à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(593084,16463,'hi','à¤‡à¤¨ à¤®à¤¦à¥‹à¤‚ à¤¸à¥‡ à¤…à¤¨à¤²à¤¿à¤‚à¤• à¤¹à¥‹ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤®à¥à¤¨ à¤¡à¤¿à¤¬à¥à¤¬à¥‡ à¤¹à¥‹à¤—à¤¾ à¤•à¤¾à¤°à¤£ à¤œà¤¾à¤°à¥€',0),(593085,16464,'hi','à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¹à¤Ÿà¤¾à¤¯à¤¾ à¤—à¤¯à¤¾',0),(593086,16465,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤¬à¤¿à¤¨',0),(593087,16466,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤¬à¤¿à¤¨ à¤‡à¤¸ à¤•à¥‹à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(593088,16467,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤¬à¤¿à¤¨ à¤•à¥‹à¤¡ à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(593089,16468,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(593090,16469,'hi','à¤‡à¤¸ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤¸à¥‡ à¤…à¤¨à¤²à¤¿à¤‚à¤• à¤¹à¥‹ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤®à¥à¤¨ à¤¡à¤¿à¤¬à¥à¤¬à¥‡ à¤¹à¥‹à¤—à¤¾ à¤•à¤¾à¤°à¤£ à¤œà¤¾à¤°à¥€',0),(593091,16470,'hi','à¤‡à¤¸ à¤•à¥‹à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤—à¥‹à¤¦à¤¾à¤® à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(593092,16471,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤•à¥‹à¤¡ à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(593093,16472,'hi','à¤ªà¥à¤°à¤¾à¤°à¤‚à¤­ à¤”à¤° à¤¸à¤®à¤¾à¤ªà¥à¤¤à¤¿ à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(593094,16473,'hi','à¤•à¥‹à¤ˆ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤¸à¥à¤¥à¤¾à¤¨ à¤¸à¥‡à¤Ÿ',0),(593095,16474,'hi','à¤•à¥‹à¤ˆ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤®à¥‚à¤²à¥à¤¯ à¤¸à¥à¤¤à¤° à¤¸à¥‡à¤Ÿ',0),(593096,16475,'hi','à¤µà¤¿à¤¶à¥‡à¤· à¤¬à¤¿à¤•à¥à¤°à¥€ à¤®à¥‚à¤²à¥à¤¯ à¤¨à¤¿à¤°à¥à¤§à¤¾à¤°à¤£',0),(593097,16476,'hi','à¤®à¤¾à¤¨à¤• à¤•à¥€à¤®à¤¤',0),(593098,16477,'hi','à¤ªà¥‚à¤›à¤¤à¤¾à¤›',0),(593099,16478,'hi','à¤¶à¤¾à¤–à¤¾à¤‚à¤¤à¤—à¤°à¥à¤¤ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤¨à¥à¤¤à¤°à¤£',0),(593100,16479,'hi','POS à¤¬à¤¿à¤•à¥à¤°à¥€',0),(593101,16480,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤‡à¤¨à¤µà¥‰à¤‡à¤¸',0),(593102,16481,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¥‹à¤Ÿ',0),(593103,16482,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤•à¥‡ à¤¡à¤¿à¤¬à¥à¤¬à¥‡',0),(593104,16483,'hi','à¤—à¥‹à¤¦à¤¾à¤® à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(593105,16484,'hi','à¤¨à¤¿à¤§à¤¿ à¤•à¤¾ à¤¨à¤¾à¤®',0),(593106,16485,'hi','à¤¬à¤¿à¤¨ à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚',0),(593107,16486,'hi','à¤‡à¤¸ à¤¸à¥à¤¥à¤¾à¤¨ à¤•à¥‡ à¤²à¤¿à¤ à¤•à¥‹à¤ˆ à¤¡à¤¿à¤¬à¥à¤¬à¥‡ Avaible',0),(593108,16487,'hi','à¤ªà¥à¤°à¤¾à¤¥à¤®à¤¿à¤• à¤¬à¤¿à¤¨',0),(593109,16488,'hi','à¤•à¤¾à¤°à¥à¤¯ à¤•à¤¾ à¤‡à¤¤à¤¿à¤¹à¤¾à¤¸',0),(593110,16489,'hi','à¤¨à¥Œà¤•à¤°à¥€ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(593111,16490,'hi','à¤¶à¥à¤°à¤® à¤‰à¤ªà¤°à¤¿',0),(593112,16491,'hi','à¤¶à¥à¤°à¤® à¤¸à¤®à¤¯',0),(593113,16492,'hi','à¤¸à¥à¤°à¥‹à¤¤à¥‹à¤‚',0),(593114,16493,'hi','à¤•à¥à¤² à¤¶à¥à¤°à¤® à¤²à¤¾à¤—à¤¤',0),(593115,16494,'hi','à¤•à¥à¤² à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤²à¤¾à¤—à¤¤',0),(593116,16495,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¬à¤¿à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨',0),(593117,16496,'hi','à¤¸à¤•à¤² à¤µà¥‡à¤¤à¤¨ à¤ªà¥à¤²à¤¸ Nontaxable',0),(593118,16497,'hi','à¤¸à¤•à¤² à¤µà¥‡à¤¤à¤¨ à¤ªà¥à¤²à¤¸ à¤ªà¥à¤°à¤¤à¤¿ à¤µà¤°à¥à¤· Nontaxable',0),(593119,16498,'hi','à¤¶à¤¹à¤° à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(593120,16499,'hi','à¤¤à¤‚à¤— à¤† à¤—à¤¯à¤¾ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(593121,16500,'hi','à¤¸à¤•à¤² à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤•à¥‡ à¤®à¤¾à¤§à¥à¤¯à¤® à¤¸à¥‡',0),(593122,16501,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤ªà¤° à¤°à¥‹à¤• à¤²à¤—à¤¾à¤ˆ',0),(593123,16502,'hi','à¤•à¤° à¤¯à¥‹à¤—à¥ à¤¯ à¤®à¤œà¤¦à¥‚à¤°à¥€',0),(593124,16420,'ba','Periksa informasi',0),(593125,16421,'ba','Periksa tidak ditemukan',0),(593126,16422,'ba','Check disimpan',0),(593127,16423,'ba','Mengedit Check',0),(593128,16424,'ba','Kesalahan menyimpan Check',0),(593129,16425,'ba','Cek AP hanya dapat diedit',0),(593130,16426,'ba','Untuk mengedit cek ini Anda harus membatalkan dan menciptakan',0),(593131,16427,'ba','Rekening #',0),(593132,16428,'ba','Neraca - dikategorikan',0),(593133,16429,'ba','Pengelompokan tidak',0),(593134,16430,'ba','Subtotal oleh',0),(593135,16431,'ba','Unassigned',0),(593136,16432,'ba','Ringkasan biaya',0),(593137,16433,'ba','Penjual sertifikat yang kedaluwarsa',0),(593138,16434,'ba','Nama pada sertifikat',0),(593139,16435,'ba','Jenis sertifikat',0),(593140,16436,'ba','Menunjukkan sertifikat yang kedaluwarsa sebelum',0),(593141,16437,'ba','Saldo yang tersisa',0),(593142,16438,'ba','Link Download langsung',0),(593143,16439,'ba','Download Anda harus dimulai sesaat',0),(593144,16440,'ba','Kuantitas standar diterima ke nol',0),(593145,16441,'ba','Sembunyikan kotak centang Endorser',0),(593146,16442,'ba','Kuantitas standar dikirim ke nol',0),(593147,16443,'ba','Edit gagal',0),(593148,16444,'ba','Pengiriman baru diciptakan setelah Anda telah memilih untuk kapal',0),(593149,16445,'ba','Penyampaian Data ganda yang mungkin dicegah',0),(593150,16446,'ba','Pengiriman pengolahan dibatalkan',0),(593151,16447,'ba','Diperkirakan pengiriman',0),(593152,16448,'ba','Voucher telah diposting',0),(593153,16449,'ba','Voucher adalah dalam periode tertutup',0),(593154,16450,'ba','Tidak seimbang oleh',0),(593155,16451,'ba','Entitas',0),(593156,16452,'ba','Pekerjaan biaya ringkasan',0),(593157,16453,'ba','Pilih pekerjaan',0),(593158,16454,'ba','T membayar',0),(593159,16455,'ba','Data yang berhasil',0),(593160,16456,'ba','Menghemat biaya kode & perubahan kerja selama jam',0),(593161,16457,'ba','Buta kapal',0),(593162,16458,'ba','Deposito Bank ini telah dibersihkan pada pernyataan Bank',0),(593163,16459,'ba','Cek AP hanya dapat diedit',0),(593164,16460,'ba','Pilih Auto',0),(593165,16461,'ba','Deposit ini telah dimasukkan dalam sebulan rekonsiliasi Bank',0),(593166,16462,'ba','Anda harus Hapus centang dari halaman rekonsiliasi Bank untuk mengedit',0),(593167,16463,'ba','Melanjutkan akan penyebab berikut sampah menjadi tidak tertaut dari barang-barang',0),(593168,16464,'ba','Catatan dihapus',0),(593169,16465,'ba','Gudang Bin',0),(593170,16466,'ba','Gudang Bin oleh kode ini sudah ada',0),(593171,16467,'ba','Gudang Bin kode harus ditetapkan',0),(593172,16468,'ba','Zona gudang',0),(593173,16469,'ba','Melanjutkan akan penyebab berikut sampah menjadi tidak tertaut dari zona ini',0),(593174,16470,'ba','Gudang zona oleh kode ini sudah ada',0),(593175,16471,'ba','Zona gudang kode harus ditetapkan',0),(593176,16472,'ba','Mulai dan tanggal akhir harus ditetapkan',0),(593177,16473,'ba','No Set lokasi Default',0),(593178,16474,'ba','Tidak ada Default harga tingkat Set',0),(593179,16475,'ba','Khusus penjualan harga',0),(593180,16476,'ba','Harga standar',0),(593181,16477,'ba','Pertanyaan',0),(593182,16478,'ba','Interbranch transfer',0),(593183,16479,'ba','POS dijual',0),(593184,16480,'ba','Faktur penjualan',0),(593185,16481,'ba','Penjualan kutipan',0),(593186,16482,'ba','Gudang sampah',0),(593187,16483,'ba','Zona gudang',0),(593188,16484,'ba','Nama dana',0),(593189,16485,'ba','Lokasi bin',0),(593190,16486,'ba','Tidak ada tempat sampah tersedia untuk lokasi ini',0),(593191,16487,'ba','Bin utama',0),(593192,16488,'ba','Riwayat pekerjaan',0),(593193,16489,'ba','Ringkasan pekerjaan',0),(593194,16490,'ba','Tenaga kerja Overhead',0),(593195,16491,'ba','Tenaga kerja waktu',0),(593196,16492,'ba','Sumber',0),(593197,16493,'ba','Total biaya tenaga kerja',0),(593198,16494,'ba','Biaya total Vendor',0),(593199,16495,'ba','Pembayaran tagihan Penjual',0),(593200,16496,'ba','Gaji Bruto ditambah Nontaxable',0),(593201,16497,'ba','Gaji Bruto ditambah Nontaxable Per tahun',0),(593202,16498,'ba','Kota upah',0),(593203,16499,'ba','Makan upah',0),(593204,16500,'ba','Kotor membayar melalui',0),(593205,16501,'ba','Negara yang ditahan',0),(593206,16502,'ba','Upah pajak',0),(593207,16420,'it','Controllare le informazioni',0),(593208,16421,'it','Verifica non trovato',0),(593209,16422,'it','Controllo salvato',0),(593210,16423,'it','Modificare Check',0),(593211,16424,'it','Errore salvataggio Check',0),(593212,16425,'it','Controlli solo AP possono essere modificati',0),(593213,16426,'it','Per modificare questo controllo Ã¨ necessario annullare e ricreare',0),(593214,16427,'it','N # di conto',0),(593215,16428,'it','Stato patrimoniale - Classificato',0),(593216,16429,'it','Nessun raggruppamento',0),(593217,16430,'it','Totale parziale di',0),(593218,16431,'it','Non assegnati',0),(593219,16432,'it','Riepilogo costo',0),(593220,16433,'it','Fornitore dei certificati in scadenza',0),(593221,16434,'it','Nome del certificato',0),(593222,16435,'it','Tipo di certificato',0),(593223,16436,'it','Visualizzare i certificati in scadenza prima',0),(593224,16437,'it','Saldo residuo',0),(593225,16438,'it','Link per il Download diretto',0),(593226,16439,'it','Il Download dovrebbe iniziare momentaneamente',0),(593227,16440,'it','Impostazione predefinita quantitÃ  ricevuta a Zero',0),(593228,16441,'it','Nascondere le caselle di controllo Endorser',0),(593229,16442,'it','Impostazione predefinita quantitÃ  spedita a Zero',0),(593230,16443,'it','Modifica non riuscita',0),(593231,16444,'it','Una nuova spedizione Ã¨ stata creata dopo che avevi selezionato alla nave',0),(593232,16445,'it','Presentazione di dati Double possibile impedito',0),(593233,16446,'it','Elaborazione della spedizione annullata',0),(593234,16447,'it','Consegna stimata',0),(593235,16448,'it','Buono Ã¨ stato pubblicato',0),(593236,16449,'it','Voucher Ã¨ In un periodo chiuso',0),(593237,16450,'it','Non bilanciato da',0),(593238,16451,'it','EntitÃ ',0),(593239,16452,'it','Lavoro costato Riepilogo',0),(593240,16453,'it','Si prega di selezionare un lavoro',0),(593241,16454,'it','T Pay',0),(593242,16455,'it','Dati aggiornati con successo',0),(593243,16456,'it','Salvare il codice di costo & modifiche al lavoro per ore',0),(593244,16457,'it','Nave cieca',0),(593245,16458,'it','Questo deposito bancario Ã¨ stato cancellato su conto bancario',0),(593246,16459,'it','Controlli solo AP possono essere modificati',0),(593247,16460,'it','Selezione automatica',0),(593248,16461,'it','Questo deposito Ã¨ stato incluso In un mese di riconciliazione di banca',0),(593249,16462,'it','Ãˆ necessario deselezionare dalla pagina di riconciliazione della banca al fine di modificare',0),(593250,16463,'it','Continuando volontÃ  causa le seguenti collocazioni diventare separata da questi elementi',0),(593251,16464,'it','Record eliminato',0),(593252,16465,'it','Collocazione di warehouse',0),(593253,16466,'it','Collocazione di warehouse di questo codice esiste giÃ ',0),(593254,16467,'it','Codice di collocazione di magazzino deve essere impostato',0),(593255,16468,'it','Zona di magazzino',0),(593256,16469,'it','Continuando volontÃ  causa le seguenti collocazioni diventare non collegati da questa zona',0),(593257,16470,'it','Zona di magazzino da questo codice esiste giÃ ',0),(593258,16471,'it','Codice della zona di magazzino deve essere impostato',0),(593259,16472,'it','Begin ed End Data deve essere impostati',0),(593260,16473,'it','Nessun Set di posizione predefinita',0),(593261,16474,'it','Impostato alcun livello di prezzo predefinito',0),(593262,16475,'it','Vendite speciali prezzi',0),(593263,16476,'it','Prezzo standard',0),(593264,16477,'it','Richieste di informazioni',0),(593265,16478,'it','Trasferimenti interprofessionali',0),(593266,16479,'it','Vendita di POS',0),(593267,16480,'it','Fattura di vendita',0),(593268,16481,'it','Offerta di vendita',0),(593269,16482,'it','Collocazioni warehouse',0),(593270,16483,'it','Zone di magazzino',0),(593271,16484,'it','Nome del fondo',0),(593272,16485,'it','Ubicazioni',0),(593273,16486,'it','Nessuna bidoni disponibile per questa posizione',0),(593274,16487,'it','Bin primario',0),(593275,16488,'it','Storia di lavoro',0),(593276,16489,'it','Sommario di lavoro',0),(593277,16490,'it','Sovraccarico di lavoro',0),(593278,16491,'it','Tempo del lavoro',0),(593279,16492,'it','Fonti',0),(593280,16493,'it','Totali costi della manodopera',0),(593281,16494,'it','Fornitore totale costi',0),(593282,16495,'it','Pagamenti fattura fornitore',0),(593283,16496,'it','Retribuzione lorda Plus Nontaxable',0),(593284,16497,'it','Retribuzione lorda Plus Nontaxable all\'anno',0),(593285,16498,'it','Salari di cittÃ ',0),(593286,16499,'it','Salari nutriti',0),(593287,16500,'it','Retribuzione lorda attraverso',0),(593288,16501,'it','Stato trattenuto',0),(593289,16502,'it','Passivi salari',0),(593290,16420,'jp','æƒ…å ±ã‚’ãƒã‚§ãƒƒã‚¯ã—ã¾ã™ã€‚',0),(593291,16421,'jp','ãƒã‚§ãƒƒã‚¯ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(593292,16422,'jp','ä¿å­˜ãƒã‚§ãƒƒã‚¯',0),(593293,16423,'jp','ãƒã‚§ãƒƒã‚¯ã‚’ç·¨é›†ã—ã¾ã™ã€‚',0),(593294,16424,'jp','ãƒã‚§ãƒƒã‚¯ã®ä¿å­˜ã‚¨ãƒ©ãƒ¼',0),(593295,16425,'jp','å”¯ä¸€ã® AP ã®ãƒã‚§ãƒƒã‚¯ã‚’ç·¨é›†ã§ãã¾ã™ã€‚',0),(593296,16426,'jp','ã“ã®ãƒã‚§ãƒƒã‚¯ã‚’ç·¨é›†ã™ã‚‹ã«ã¯ç„¡åŠ¹ã«ã—ã¦å†ä½œæˆ',0),(593297,16427,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆæ•°',0),(593298,16428,'jp','è²¸å€Ÿå¯¾ç…§è¡¨ã®åˆ†é¡ž',0),(593299,16429,'jp','ã‚°ãƒ«ãƒ¼ãƒ—åŒ–ãªã—',0),(593300,16430,'jp','é›†è¨ˆã—ã¾ã™ã€‚',0),(593301,16431,'jp','å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(593302,16432,'jp','ã‚³ã‚¹ãƒˆã®æ¦‚è¦',0),(593303,16433,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ã®è¨¼æ˜Žæ›¸ã®æœ‰åŠ¹æœŸé™',0),(593304,16434,'jp','è¨¼æ˜Žæ›¸å',0),(593305,16435,'jp','è¨¼æ˜Žæ›¸ã®ç¨®é¡ž',0),(593306,16436,'jp','å‰ã«æœŸé™åˆ‡ã‚Œã®è¨¼æ˜Žæ›¸ã‚’è¡¨ç¤ºã—ã¾ã™ã€‚',0),(593307,16437,'jp','æ®‹ã‚Šã®ãƒãƒ©ãƒ³ã‚¹',0),(593308,16438,'jp','ç›´æŽ¥ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ ãƒªãƒ³ã‚¯',0),(593309,16439,'jp','ä¸€çž¬ãƒ€ã‚¦ãƒ³ãƒ­ãƒ¼ãƒ‰ã‚’é–‹å§‹',0),(593310,16440,'jp','æ—¢å®šã®æ•°é‡ã¯ã‚¼ãƒ­ã«',0),(593311,16441,'jp','è£æ›¸ã®ãƒã‚§ãƒƒã‚¯ ãƒœãƒƒã‚¯ã‚¹ã‚’éžè¡¨ç¤ºã—ã¾ã™ã€‚',0),(593312,16442,'jp','ã‚¼ãƒ­ã«å‡ºè·æ•°é‡ã®ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆå€¤',0),(593313,16443,'jp','ç·¨é›†ã«å¤±æ•—',0),(593314,16444,'jp','èˆ¹ã‚’é¸æŠžã—ãŸå¾Œã€æ–°ã—ã„å‡ºè·ãŒä½œæˆã•ã‚Œã¾ã—ãŸ',0),(593315,16445,'jp','é˜²æ­¢å¯èƒ½ãªäºŒé‡ãƒ‡ãƒ¼ã‚¿é€ä¿¡',0),(593316,16446,'jp','å‡ºè·å‡¦ç†ã®ã‚­ãƒ£ãƒ³ã‚»ãƒ«',0),(593317,16447,'jp','é…é€äºˆå®š',0),(593318,16448,'jp','ä¼ç¥¨ãŒè»¢è¨˜ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(593319,16449,'jp','ã‚¯ãƒ¼ãƒãƒ³ã¯ã€ä¼‘æ¥­æœŸé–“ã§ã¯',0),(593320,16450,'jp','ã‚¢ãƒ³ãƒãƒ©ãƒ³ã‚¹',0),(593321,16451,'jp','ã‚¨ãƒ³ãƒ†ã‚£ãƒ†ã‚£',0),(593322,16452,'jp','ä»•äº‹ã®è²»ç”¨ã®æ¦‚è¦',0),(593323,16453,'jp','ä»•äº‹ã‚’é¸æŠžã—ã¦ãã ã•ã„ã€‚',0),(593324,16454,'jp','T ãƒšã‚¤',0),(593325,16455,'jp','ãƒ‡ãƒ¼ã‚¿ãŒæ­£å¸¸ã«æ›´æ–°ã•ã‚Œã¾ã—ãŸã€‚',0),(593326,16456,'jp','æ™‚é–“ã®ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ ãƒ» ã‚¸ãƒ§ãƒ–ã®å¤‰æ›´ã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(593327,16457,'jp','ç›²ç›®ã®èˆ¹',0),(593328,16458,'jp','ã“ã®éŠ€è¡Œé é‡‘ã¯ã€éŠ€è¡Œå–å¼•æ˜Žç´°æ›¸ã«ã‚¯ãƒªã‚¢ã•ã‚Œã¦ã„ã¾ã™ã€‚',0),(593329,16459,'jp','å”¯ä¸€ã® AP ã®ãƒã‚§ãƒƒã‚¯ã‚’ç·¨é›†ã§ãã¾ã™ã€‚',0),(593330,16460,'jp','è‡ªå‹•é¸æŠž',0),(593331,16461,'jp','ã“ã®é é‡‘ã¯ã€éŠ€è¡Œå’Œè§£æœˆã«å«ã¾ã‚Œã¦ã„ã¾ã™ã€‚',0),(593332,16462,'jp','ç·¨é›†ã™ã‚‹ãŸã‚ã«éŠ€è¡Œå’Œè§£ãƒšãƒ¼ã‚¸ã‹ã‚‰ã‚ªãƒ•ã«ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(593333,16463,'jp','ç¶™ç¶šã®åŽŸå› ã¨ãªã‚‹ã“ã‚Œã‚‰ã®é …ç›®ã‹ã‚‰ãƒªãƒ³ã‚¯ã•ã‚Œã¦ã„ãªã„ã«ãªã‚‹ã“ã¨æ¬¡ã®ç®±',0),(593334,16464,'jp','å‰Šé™¤ãƒ¬ã‚³ãƒ¼ãƒ‰',0),(593335,16465,'jp','å€‰åº«ã®ç®±',0),(593336,16466,'jp','ã“ã®ã‚³ãƒ¼ãƒ‰ã«ã‚ˆã£ã¦å€‰åº«ã®ç®±ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(593337,16467,'jp','å€‰åº« Bin ã‚³ãƒ¼ãƒ‰ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(593338,16468,'jp','å€‰åº«ã‚¾ãƒ¼ãƒ³',0),(593339,16469,'jp','åŽŸå› ã¨ãªã‚‹ã“ã®ã‚¾ãƒ¼ãƒ³ã‹ã‚‰ãƒªãƒ³ã‚¯ã•ã‚Œã¦ã„ãªã„ã«ãªã‚‹ã“ã¨æ¬¡ã®ãƒ“ãƒ³ã‚’ç¶™ç¶š',0),(593340,16470,'jp','ã“ã®ã‚³ãƒ¼ãƒ‰ã«ã‚ˆã£ã¦å€‰åº«ã‚¾ãƒ¼ãƒ³ãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(593341,16471,'jp','å€‰åº«åœ°å¸¯ã‚³ãƒ¼ãƒ‰ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(593342,16472,'jp','é–‹å§‹æ—¥ã¨çµ‚äº†æ—¥ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(593343,16473,'jp','æ—¢å®šã®å ´æ‰€ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(593344,16474,'jp','æ—¢å®šã®ä¾¡æ ¼ãƒ¬ãƒ™ãƒ«ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(593345,16475,'jp','ç‰¹åˆ¥è²©å£²ä¾¡æ ¼',0),(593346,16476,'jp','æ¨™æº–ä¾¡æ ¼',0),(593347,16477,'jp','ãŠå•ã„åˆã‚ã›',0),(593348,16478,'jp','Interbranch è»¢é€',0),(593349,16479,'jp','POS è²©å£²',0),(593350,16480,'jp','å£²ä¸Šè«‹æ±‚æ›¸',0),(593351,16481,'jp','è²©å£²è¦‹ç©ã‚‚ã‚Šæ›¸',0),(593352,16482,'jp','å€‰åº«ã®ã‚´ãƒŸç®±',0),(593353,16483,'jp','å€‰åº«ã‚¾ãƒ¼ãƒ³',0),(593354,16484,'jp','ãƒ•ã‚¡ãƒ³ãƒ‰å',0),(593355,16485,'jp','ç®±ã®å ´æ‰€',0),(593356,16486,'jp','ã“ã®å ´æ‰€ã®ãªã„ç®±ã®åˆ©ç”¨',0),(593357,16487,'jp','ä¸»ãªç®±',0),(593358,16488,'jp','ã‚¸ãƒ§ãƒ–å±¥æ­´',0),(593359,16489,'jp','ã‚¸ãƒ§ãƒ–ã®æ¦‚è¦',0),(593360,16490,'jp','åŠ´åƒã‚ªãƒ¼ãƒãƒ¼ãƒ˜ãƒƒãƒ‰',0),(593361,16491,'jp','åŠ´åƒæ™‚é–“',0),(593362,16492,'jp','ã‚½ãƒ¼ã‚¹',0),(593363,16493,'jp','ç·äººä»¶è²»',0),(593364,16494,'jp','å…¨ãƒ™ãƒ³ãƒ€ãƒ¼ã®ã‚³ã‚¹ãƒˆ',0),(593365,16495,'jp','ä»•å…¥å…ˆè«‹æ±‚æ›¸ã®æ”¯æ‰•ã„',0),(593366,16496,'jp','çµ¦ä¸Žç·é¡ãƒ—ãƒ©ã‚¹éžèª²ç¨Ž',0),(593367,16497,'jp','çµ¦ä¸Žç·é¡ãƒ—ãƒ©ã‚¹å¹´é–“éžèª²ç¨Ž',0),(593368,16498,'jp','éƒ½å¸‚è³ƒé‡‘',0),(593369,16499,'jp','ä¾›çµ¦ã®è³ƒé‡‘',0),(593370,16500,'jp','çµ¦ä¸Žã‚’ç·é¡ã—ã¾ã™ã€‚',0),(593371,16501,'jp','ä¿ç•™çŠ¶æ…‹',0),(593372,16502,'jp','èª²ç¨Žå¯¾è±¡è³ƒé‡‘',0),(593373,16420,'ko','ì •ë³´ í™•ì¸',0),(593374,16421,'ko','ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ í™•ì¸',0),(593375,16422,'ko','ì €ìž¥ í™•ì¸',0),(593376,16423,'ko','í‘œ íŽ¸ì§‘',0),(593377,16424,'ko','í™•ì¸ ì €ìž¥ ì˜¤ë¥˜',0),(593378,16425,'ko','ìœ ì¼í•œ AP ê²€ì‚¬ë¥¼ íŽ¸ì§‘í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(593379,16426,'ko','ì´ ê²€ì‚¬ë¥¼ íŽ¸ì§‘ì„ ì·¨ì†Œ í•˜ ê³  ë‹¤ì‹œ ë§Œë“¤ì–´ì•¼',0),(593380,16427,'ko','# ê³„ì •',0),(593381,16428,'ko','ëŒ€ì°¨ ëŒ€ì¡°í‘œ-ë¶„ë¥˜',0),(593382,16429,'ko','ì—†ìŒ ê·¸ë£¹í™”',0),(593383,16430,'ko','ì˜í•´ ë¶€ë¶„í•©',0),(593384,16431,'ko','í• ë‹¹ ë˜ì§€ ì•Šì€',0),(593385,16432,'ko','ë¹„ìš©ëœ ìš”ì•½',0),(593386,16433,'ko','ê³µê¸‰ ì—…ì²´ ì¸ì¦ì„œ ë§Œë£Œ',0),(593387,16434,'ko','ì¸ì¦ì„œ ì´ë¦„',0),(593388,16435,'ko','ì¸ì¦ì„œ ì¢…ë¥˜',0),(593389,16436,'ko','ì‡¼ ì¸ì¦ì„œ ì „ì— ë§Œë£Œ',0),(593390,16437,'ko','ë‚¨ì€ ìž”ì•¡',0),(593391,16438,'ko','ì§ì ‘ ë‹¤ìš´ë¡œë“œ ë§í¬',0),(593392,16439,'ko','ë‹¹ì‹ ì˜ ë‹¤ìš´ë¡œë“œ ìˆœê°„ì ìœ¼ë¡œ ì‹œìž‘ í•œë‹¤',0),(593393,16440,'ko','ê¸°ë³¸ ìˆ˜ëŸ‰ 0ìœ¼ë¡œ ë°›ì€',0),(593394,16441,'ko','Endorser í™•ì¸ëž€ì„ ìˆ¨ê¸°ê¸°',0),(593395,16442,'ko','ê¸°ë³¸ ìˆ˜ëŸ‰ 0ì— ë°œì†¡',0),(593396,16443,'ko','íŽ¸ì§‘ ì‹¤íŒ¨',0),(593397,16444,'ko','ìƒˆë¡œìš´ ì„ ì  ì„ ë°•ì„ ì„ íƒí•œ í›„ ë§Œë“¤ì–´ì§„',0),(593398,16445,'ko','ë°©ì§€ ê°€ëŠ¥í•œ Double ë°ì´í„° ì œì¶œ',0),(593399,16446,'ko','ì¶œí•˜ ì²˜ë¦¬ ì·¨ì†Œ',0),(593400,16447,'ko','ì˜ˆìƒëœ ë°°ë‹¬',0),(593401,16448,'ko','ë°”ìš°ì²˜ë¥¼ ê²Œì‹œ',0),(593402,16449,'ko','ë°”ìš°ì²˜ëŠ” ë‹«ížŒëœ ê¸°ê°„ì—',0),(593403,16450,'ko','ì˜í•´ ë¶ˆê· í˜•',0),(593404,16451,'ko','ì—”í„°í‹°',0),(593405,16452,'ko','ìž‘ì—… ë¹„ìš© ìš”ì•½',0),(593406,16453,'ko','ìž‘ì—…ì„ ì„ íƒ í•˜ì‹­ì‹œì˜¤',0),(593407,16454,'ko','T ê¸‰ì—¬',0),(593408,16455,'ko','ì„±ê³µì ìœ¼ë¡œ ì—…ë°ì´íŠ¸ í•˜ëŠ” ë°ì´í„°',0),(593409,16456,'ko','ì‹œê°„ì— ëŒ€ í•œ ë¹„ìš©ëœ ì½”ë“œ ë° ìž‘ì—… ë³€ê²½ ì‚¬í•­ ì €ìž¥',0),(593410,16457,'ko','ë¸”ë¼ì¸ë“œ ë°°',0),(593411,16458,'ko','ì´ ì€í–‰ ì˜ˆê¸ˆ ì€í–‰ ëª…ì„¸ì„œì— ì‚­ì œ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(593412,16459,'ko','ìœ ì¼í•œ AP ê²€ì‚¬ë¥¼ íŽ¸ì§‘í•  ìˆ˜ ìžˆìŠµë‹ˆë‹¤.',0),(593413,16460,'ko','ìžë™ ì„ íƒ',0),(593414,16461,'ko','ì´ ì˜ˆê¸ˆì€ ì€í–‰ í™”í•´ ë‹¬ì— í¬í•¨ ë˜ì—ˆìŠµë‹ˆë‹¤.',0),(593415,16462,'ko','íŽ¸ì§‘ í•˜ë ¤ë©´ ì€í–‰ ì¡°ì • íŽ˜ì´ì§€ì—ì„œ ê·¸ê²ƒì„ ì·¨ì†Œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(593416,16463,'ko','ê³„ì† ê²ƒìž…ë‹ˆë‹¤ ì›ì¸ì´ ë  ì´ëŸ¬í•œ í•­ëª©ì—ì„œ ì—°ê²° ë˜ì§€ ì•Šì€ ë‹¤ìŒ ì“°ë ˆê¸°í†µ',0),(593417,16464,'ko','ë ˆì½”ë“œ ì‚­ì œ',0),(593418,16465,'ko','ì°½ ê³  ë¹ˆ',0),(593419,16466,'ko','ì´ë¯¸ ì¡´ìž¬ í•˜ëŠ”ì´ ì½”ë“œì— ì˜í•´ ì°½ ê³  ë¹ˆ',0),(593420,16467,'ko','ì°½ ê³  ë¹ˆ ì½”ë“œë¥¼ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(593421,16468,'ko','ì°½ ê³  ì§€ì—­',0),(593422,16469,'ko','ê³„ì† ê²ƒ ì´ë‹¤ ì›ì¸ì´ì´ ì˜ì—­ì—ì„œ ì—°ê²° ë˜ì§€ ì•Šì€ ë˜ë„ë¡ ë‹¤ìŒ ì“°ë ˆê¸°í†µ',0),(593423,16470,'ko','ì´ ì½”ë“œì— ì˜í•´ ì°½ ê³  ì˜ì—­ì— ì´ë¯¸',0),(593424,16471,'ko','ì°½ ê³  ì˜ì—­ ì½”ë“œë¥¼ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(593425,16472,'ko','ì‹œìž‘ ë° ë ë‚ ì§œë¥¼ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(593426,16473,'ko','ê¸°ë³¸ ìœ„ì¹˜ ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(593427,16474,'ko','ê¸°ë³¸ ê°€ê²© ìˆ˜ì¤€ ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(593428,16475,'ko','íŠ¹ë³„ íŒë§¤ ê°€ê²©',0),(593429,16476,'ko','í‘œì¤€ ê°€ê²©',0),(593430,16477,'ko','ë¬¸ì˜',0),(593431,16478,'ko','Interbranch ì „ì†¡',0),(593432,16479,'ko','POS íŒë§¤',0),(593433,16480,'ko','íŒë§¤ ì†¡ìž¥',0),(593434,16481,'ko','íŒë§¤ ê²¬ì ',0),(593435,16482,'ko','ì°½ ê³  ì €ìž¥ì†Œ',0),(593436,16483,'ko','ì°½ ê³  ì˜ì—­',0),(593437,16484,'ko','íŽ€ë“œ ì´ë¦„',0),(593438,16485,'ko','ë¹ˆ ìœ„ì¹˜',0),(593439,16486,'ko','ì•„ë‹ˆ ì“°ë ˆê¸°í†µ Avaibleì´ì´ ìœ„ì¹˜ì— ëŒ€ í•œ',0),(593440,16487,'ko','ì£¼ ë¹ˆ',0),(593441,16488,'ko','ìž‘ì—… ê¸°ë¡',0),(593442,16489,'ko','ìž‘ì—… ìš”ì•½',0),(593443,16490,'ko','ë…¸ë™ ì˜¤ë²„ í—¤ë“œ',0),(593444,16491,'ko','ë…¸ë™ ì‹œê°„',0),(593445,16492,'ko','ì†ŒìŠ¤',0),(593446,16493,'ko','ì´ ë…¸ë™ ë¹„ìš©',0),(593447,16494,'ko','ì´ ê³µê¸‰ ì—…ì²´ ë¹„ìš©',0),(593448,16495,'ko','ê³µê¸‰ ì—…ì²´ ì²­êµ¬ì„œ ì§€ë¶ˆ',0),(593449,16496,'ko','ì´ ì§€ë¶ˆ í”ŒëŸ¬ìŠ¤ Nontaxable',0),(593450,16497,'ko','ì´ ì§€ë¶ˆ í”ŒëŸ¬ìŠ¤ ë…„ ë‹¹ Nontaxable',0),(593451,16498,'ko','ë„ì‹œ ìž„ê¸ˆ',0),(593452,16499,'ko','ì—°ë°©ëœ ìž„ê¸ˆ',0),(593453,16500,'ko','í†µí•´ ì´ ì§€ë¶ˆ',0),(593454,16501,'ko','ë³´ë¥˜ ìƒíƒœ',0),(593455,16502,'ko','ê³¼ì„¸ ëŒ€ìƒ ìž„ê¸ˆ',0),(593456,16420,'ms','Semak maklumat',0),(593457,16421,'ms','Semak tidak dijumpai',0),(593458,16422,'ms','Daftar yang disimpan',0),(593459,16423,'ms','Edit semak',0),(593460,16424,'ms','Ralat Menyimpan Daftar',0),(593461,16425,'ms','Cek AP hanya boleh diedit',0),(593462,16426,'ms','Untuk mengedit semakan ini, anda mesti membatalkan dan mencipta semula',0),(593463,16427,'ms','Akaun #',0),(593464,16428,'ms','Lembaran imbangan - dikategorikan',0),(593465,16429,'ms','Tiada Kumpulan',0),(593466,16430,'ms','Jumlah kecil oleh',0),(593467,16431,'ms','Multisiar',0),(593468,16432,'ms','Ringkasan kos',0),(593469,16433,'ms','Penjual Sijil tamat',0),(593470,16434,'ms','Nama sijil',0),(593471,16435,'ms','Jenis Sijil',0),(593472,16436,'ms','Papar Sijil tamat sebelum',0),(593473,16437,'ms','Baki yang tinggal',0),(593474,16438,'ms','Pautan muat-turun langsung',0),(593475,16439,'ms','Muat turun anda harus memulakan seketika',0),(593476,16440,'ms','Lalai kuantiti diterima ke sifar',0),(593477,16441,'ms','Sembunyi kotak semak penyokong',0),(593478,16442,'ms','Kuantiti lalai yang dihantar ke sifar',0),(593479,16443,'ms','Edit yang gagal',0),(593480,16444,'ms','Penghantaran baru yang dicipta selepas anda telah memilih untuk kapal',0),(593481,16445,'ms','Penghantaran Data Double yang mungkin menghalang',0),(593482,16446,'ms','Memproses penghantaran yang dibatalkan',0),(593483,16447,'ms','Penghantaran anggaran',0),(593484,16448,'ms','Baucar telah dipaparkan',0),(593485,16449,'ms','Baucer adalah dalam tempoh tertutup',0),(593486,16450,'ms','Tidak oleh',0),(593487,16451,'ms','Entiti',0),(593488,16452,'ms','Ringkasan kos kerja',0),(593489,16453,'ms','Sila pilih pekerjaan',0),(593490,16454,'ms','Gaji T',0),(593491,16455,'ms','Data berjaya dikemas kini',0),(593492,16456,'ms','Menjimatkan kos kod & perubahan kerja jam',0),(593493,16457,'ms','Kapal yang buta',0),(593494,16458,'ms','Deposit Bank ini telah dikosongkan pada penyata Bank',0),(593495,16459,'ms','Cek AP hanya boleh diedit',0),(593496,16460,'ms','Auto Pilih',0),(593497,16461,'ms','Deposit ini dimasukkan ke dalam Penyata penyesuaian Bank bulan',0),(593498,16462,'ms','Anda mesti nyahtanda dari halaman Penyata penyesuaian Bank untuk mengedit',0),(593499,16463,'ms','Berterusan akan menyebabkan Tong berikut menjadi dinyahpautkan dengan barang-barang',0),(593500,16464,'ms','Rekod yang dipadam',0),(593501,16465,'ms','Gudang Bin',0),(593502,16466,'ms','Gudang Bin oleh Kod ini sudah wujud',0),(593503,16467,'ms','Gudang Bin kod mesti disetkan',0),(593504,16468,'ms','Gudang zon',0),(593505,16469,'ms','Berterusan akan menyebabkan Tong berikut akan dipadam rantaiannya dari zon ini',0),(593506,16470,'ms','Gudang zon dengan Kod ini sudah wujud',0),(593507,16471,'ms','Kod gudang zon mestilah disetkan',0),(593508,16472,'ms','Mulakan dan tarikh akhir perlu ditetapkan',0),(593509,16473,'ms','Tiada Set lokasi lalai',0),(593510,16474,'ms','Set peringkat harga tidak lalai',0),(593511,16475,'ms','Harga jualan yang khas',0),(593512,16476,'ms','Harga Standard',0),(593513,16477,'ms','Sebarang pertanyaan',0),(593514,16478,'ms','Pemindahan niaga',0),(593515,16479,'ms','Jualan POS',0),(593516,16480,'ms','Invois jualan',0),(593517,16481,'ms','Sebut harga jualan',0),(593518,16482,'ms','Gudang Tong',0),(593519,16483,'ms','Gudang zon',0),(593520,16484,'ms','Nama unit amanah',0),(593521,16485,'ms','Lokasi bin',0),(593522,16486,'ms','Tiada Avaible Tong untuk lokasi ini',0),(593523,16487,'ms','Utama Bin',0),(593524,16488,'ms','Sejarah pekerjaan',0),(593525,16489,'ms','Ringkasan kerja',0),(593526,16490,'ms','Overhead buruh',0),(593527,16491,'ms','Masa buruh',0),(593528,16492,'ms','Sumber-sumber',0),(593529,16493,'ms','Jumlah kos buruh',0),(593530,16494,'ms','Penjual jumlah kos',0),(593531,16495,'ms','Pembayaran bil vendor',0),(593532,16496,'ms','Gaji kasar campur Nontaxable',0),(593533,16497,'ms','Gaji kasar campur Nontaxable setahun',0),(593534,16498,'ms','Upah bandar',0),(593535,16499,'ms','Makan gaji',0),(593536,16500,'ms','Gaji kasar melalui',0),(593537,16501,'ms','Negeri ditahan',0),(593538,16502,'ms','Upah boleh dikenakan cukai',0),(593539,16420,'no','Dokumentasjonen',0),(593540,16421,'no','Sjekk ikke funnet',0),(593541,16422,'no','Sjekk lagret',0),(593542,16423,'no','Redigere sjekk',0),(593543,16424,'no','Feil under lagring av',0),(593544,16425,'no','Bare AP sjekker kan redigeres',0),(593545,16426,'no','Hvis du vil redigere denne kontrollen mÃ¥ du annullere og gjenskape',0),(593546,16427,'no','Konto #',0),(593547,16428,'no','Balanse - kategorisert',0),(593548,16429,'no','Ingen gruppering',0),(593549,16430,'no','Delsum ved',0),(593550,16431,'no','Ikke tilordnet',0),(593551,16432,'no','Kostnader Sammendrag',0),(593552,16433,'no','LeverandÃ¸r-sertifikater som utlÃ¸per',0),(593553,16434,'no','Sertifikatnavn',0),(593554,16435,'no','Sertifikattype',0),(593555,16436,'no','Vise sertifikater utlÃ¸per fÃ¸r',0),(593556,16437,'no','Balanse gjenvÃ¦rende',0),(593557,16438,'no','Direkte dataoverfÃ¸re koble sammen',0),(593558,16439,'no','Nedlastingen bÃ¸r begynne Ã¸yeblikk',0),(593559,16440,'no','Standardantall mottatt null',0),(593560,16441,'no','Skjule Endorser avmerkingsbokser',0),(593561,16442,'no','Standardantall sendt til null',0),(593562,16443,'no','Rediger mislyktes',0),(593563,16444,'no','En ny forsendelse ble opprettet etter at du hadde valgt Ã¥ skip',0),(593564,16445,'no','Mulig Double Data innlevering hindret',0),(593565,16446,'no','Leveringsbehandling avbrutt',0),(593566,16447,'no','Leveringstiden',0),(593567,16448,'no','Bilaget er posert',0),(593568,16449,'no','Bilaget er i en lukket periode',0),(593569,16450,'no','Ubalansert av',0),(593570,16451,'no','Enhet',0),(593571,16452,'no','Jobben koster Sammendrag',0),(593572,16453,'no','Velg en jobb',0),(593573,16454,'no','T betaler',0),(593574,16455,'no','Dataene oppdatert',0),(593575,16456,'no','Lagre kostnader koden & jobb endringer For timer',0),(593576,16457,'no','Blind skipet',0),(593577,16458,'no','Denne bankinnskudd har blitt klarert bankkontoutdraget',0),(593578,16459,'no','Bare AP sjekker kan redigeres',0),(593579,16460,'no','Automerking',0),(593580,16461,'no','Depositumet er inkludert i en Bank avstemming mÃ¥ned',0),(593581,16462,'no','Du mÃ¥ fjerne merkingen fra Bank avstemming side for Ã¥ redigere',0),(593582,16463,'no','Fortsetter vil fÃ¸re fÃ¸lgende hyllene blir ikke koblet fra disse elementene',0),(593583,16464,'no','Post slettet',0),(593584,16465,'no','Lager hylle',0),(593585,16466,'no','Lager hylle koden finnes allerede',0),(593586,16467,'no','Lager hylle-kode mÃ¥ angis',0),(593587,16468,'no','Lager sone',0),(593588,16469,'no','Fortsetter vil fÃ¸re fÃ¸lgende hyllene blir ikke koblet fra denne sonen',0),(593589,16470,'no','Lager sonen koden finnes allerede',0),(593590,16471,'no','Lager sone-kode mÃ¥ angis',0),(593591,16472,'no','Start- og sluttdatoen mÃ¥ angis',0),(593592,16473,'no','Ingen standard plassering sett',0),(593593,16474,'no','Ingen standard pris nivÃ¥ sett',0),(593594,16475,'no','Spesielle salg priser',0),(593595,16476,'no','Standard pris',0),(593596,16477,'no','Henvendelser',0),(593597,16478,'no','Interbranch overfÃ¸ringer',0),(593598,16479,'no','POS salg',0),(593599,16480,'no','Salgsfaktura',0),(593600,16481,'no','Tilbud',0),(593601,16482,'no','Lagerhyllene',0),(593602,16483,'no','Lager soner',0),(593603,16484,'no','Fondets navn',0),(593604,16485,'no','Bin steder',0),(593605,16486,'no','Ingen hyller Avaible For denne plasseringen',0),(593606,16487,'no','PrimÃ¦re Bin',0),(593607,16488,'no','Logg',0),(593608,16489,'no','Jobb-Sammendrag',0),(593609,16490,'no','Arbeidskraft Overhead',0),(593610,16491,'no','Ap tid',0),(593611,16492,'no','Kilder',0),(593612,16493,'no','Totalt lÃ¸nnskostnader',0),(593613,16494,'no','Totalt leverandÃ¸r kostnader',0),(593614,16495,'no','Bill leverandÃ¸rbetalinger',0),(593615,16496,'no','BruttolÃ¸nn pluss Nontaxable',0),(593616,16497,'no','BruttolÃ¸nn pluss Nontaxable Per Ã¥r',0),(593617,16498,'no','Byen lÃ¸nn',0),(593618,16499,'no','Matet lÃ¸nn',0),(593619,16500,'no','BruttolÃ¸nn gjennom',0),(593620,16501,'no','Staten tilbakeholdt',0),(593621,16502,'no','Skattepliktig lÃ¸nn',0),(593622,16420,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª',0),(593623,16421,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ù†Ø´Ø¯',0),(593624,16422,'pr','Ø¨Ø±Ø±Ø³ÛŒ Ø°Ø®ÛŒØ±Ù‡',0),(593625,16423,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø¨Ø±Ø±Ø³ÛŒ',0),(593626,16424,'pr','Ø®Ø·Ø§ Ø¯Ø± Ø°Ø®ÛŒØ±Ù‡ Ú†Ú©',0),(593627,16425,'pr','Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³ ØªÙ†Ù‡Ø§ Ú†Ú© Ø±Ø§ Ù…ÛŒ ØªÙˆØ§Ù† ÙˆÛŒØ±Ø§ÛŒØ´',0),(593628,16426,'pr','Ø¨Ø±Ø§ÛŒ ÙˆÛŒØ±Ø§ÛŒØ´ Ø§ÛŒÙ† Ø¨Ø±Ø±Ø³ÛŒ Ø´Ù…Ø§ Ø§Ø² Ø¯Ø±Ø¬Ù‡ Ø§Ø¹ØªØ¨Ø§Ø± Ø³Ø§Ù‚Ø· Ø§Ø² Ù†Ùˆ Ø®Ù„Ù‚ Ú©Ø±Ø¯Ù† Ùˆ Ø¨Ø§ÛŒØ¯',0),(593629,16427,'pr','# Ø­Ø³Ø§Ø¨',0),(593630,16428,'pr','ØªØ±Ø§Ø²Ù†Ø§Ù…Ù‡ - Ø·Ø¨Ù‚Ù‡ Ø¨Ù†Ø¯ÛŒ',0),(593631,16429,'pr','Ø¨Ø¯ÙˆÙ† Ú¯Ø±ÙˆÙ‡ Ø¨Ù†Ø¯ÛŒ',0),(593632,16430,'pr','Ù‚ÛŒÙ…Øª Ú©Ù„ ØªÙˆØ³Ø·',0),(593633,16431,'pr','ÙˆØ±Ø²Ø´ Ø¬Ù‡Ø§Ù†',0),(593634,16432,'pr','Ø®Ù„Ø§ØµÙ‡ Ù‡Ø²ÛŒÙ†Ù‡',0),(593635,16433,'pr','Ú¯ÙˆØ§Ù‡ÛŒÙ†Ø§Ù…Ù‡ Ù‡Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ù†Ù‚Ø¶Ø§ÛŒ',0),(593636,16434,'pr','Ù†Ø§Ù… Ú¯ÙˆØ§Ù‡ÛŒ',0),(593637,16435,'pr','Ù†ÙˆØ¹ Ù…Ø¯Ø±Ú© Ø§Ø®Ø° Ø´Ø¯Ù‡',0),(593638,16436,'pr','Ú¯ÙˆØ§Ù‡ÛŒ Ù†Ø§Ù…Ù‡ Ù‡Ø§ Ù†Ø´Ø§Ù† Ù…ÛŒ Ø¯Ù‡Ø¯ Ù‚Ø¨Ù„ Ø§Ø² Ø§Ù†Ù‚Ø¶Ø§ÛŒ',0),(593639,16437,'pr','ØªØ¹Ø§Ø¯Ù„ Ø¨Ø§Ù‚ÛŒ Ù…Ø§Ù†Ø¯Ù‡',0),(593640,16438,'pr','Ù„ÛŒÙ†Ú© Ù…Ø³ØªÙ‚ÛŒÙ… Ø¯Ø§Ù†Ù„ÙˆØ¯',0),(593641,16439,'pr','Ø¯Ø§Ù†Ù„ÙˆØ¯ Ø®ÙˆØ¯ Ø±Ø§ Ù„Ø­Ø¸Ù‡ Ø§ÛŒ Ø¨Ø§ÛŒØ¯ Ø´Ø±ÙˆØ¹',0),(593642,16440,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¯Ø±ÛŒØ§ÙØª Ø¨Ù‡ ØµÙØ±',0),(593643,16441,'pr','Ù¾Ù†Ù‡Ø§Ù† Ú©Ø±Ø¯Ù† Ú©Ø§Ø¯Ø± Ø³ØªØ§ÛŒØ´',0),(593644,16442,'pr','Ù…Ù‚Ø¯Ø§Ø± Ù¾ÛŒØ´ ÙØ±Ø¶ Ø¨Ù‡ ØµÙØ±',0),(593645,16443,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ù†Ø´Ø¯',0),(593646,16444,'pr','Ù¾Ø³ Ø§Ø² Ø´Ù…Ø§ Ø¯Ø± Ø­Ø§Ù„ Ø§Ù†ØªØ®Ø§Ø¨ Ø¨Ù‡ Ú©Ø´ØªÛŒ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡ Ø§Ø³Øª',0),(593647,16445,'pr','Ø«Ø¨Øª Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ù…Ù…Ú©Ù† Ø§Ø³Øª Ø¯Ùˆ Ù…Ø§Ù†Ø¹',0),(593648,16446,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù¾Ø±Ø¯Ø§Ø²Ø´ Ù„ØºÙˆ Ø´Ø¯',0),(593649,16447,'pr','ØªØ­ÙˆÛŒÙ„ Ø­Ø¯ÙˆØ¯',0),(593650,16448,'pr','Ú©ÙˆÙ¾Ù† Ù†ÙˆØ´ØªÙ‡ Ø´Ø¯Ù‡',0),(593651,16449,'pr','Ú©ÙˆÙ¾Ù† Ø¯Ø± Ø¯ÙˆØ±Ù‡ Ø¨Ø³ØªÙ‡ Ø§Ø³Øª',0),(593652,16450,'pr','ØªÙˆØ³Ø· Ù†Ø§Ù…ØªØ¹Ø§Ø¯Ù„',0),(593653,16451,'pr','Ù†Ù‡Ø§Ø¯',0),(593654,16452,'pr','Ú©Ø§Ø± Ø®Ù„Ø§ØµÙ‡ Ù‡Ø²ÛŒÙ†Ù‡',0),(593655,16453,'pr','Ù„Ø·ÙØ§ Ú©Ø§Ø± Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(593656,16454,'pr','T Ù¾Ø±Ø¯Ø§Ø®Øª',0),(593657,16455,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ Ø¨Ø§ Ù…ÙˆÙÙ‚ÛŒØª Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(593658,16456,'pr','ØµØ±ÙÙ‡ Ø¬ÙˆÛŒÛŒ Ø¯Ø± Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ø¯ & Ú©Ø§Ø± ØªØºÛŒÛŒØ± Ø³Ø§Ø¹Øª',0),(593659,16457,'pr','Ú©Ø´ØªÛŒ Ù‡Ø§ÛŒ Ú©ÙˆØ±',0),(593660,16458,'pr','Ø§ÛŒÙ† Ø¨Ø§Ù†Ú© Ø³Ù¾Ø±Ø¯Ù‡ Ø¯Ø± Ø¨Ø§Ù†Ú© Ø¨ÛŒØ§Ù†ÛŒÙ‡ Ù¾Ø§Ú© Ø´Ø¯Ù‡',0),(593661,16459,'pr','Ø§Ø³ÙˆØ´ÛŒØªØ¯ Ù¾Ø±Ø³ ØªÙ†Ù‡Ø§ Ú†Ú© Ø±Ø§ Ù…ÛŒ ØªÙˆØ§Ù† ÙˆÛŒØ±Ø§ÛŒØ´',0),(593662,16460,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø®ÙˆØ¯Ú©Ø§Ø±',0),(593663,16461,'pr','Ø§ÛŒÙ† Ø³Ù¾Ø±Ø¯Ù‡ Ø¯Ø± Ø¨Ø§Ù†Ú© Ù…Ø§Ù‡ Ø¢Ø´ØªÛŒ Ú¯Ù†Ø¬Ø§Ù†Ø¯Ù‡ Ø´Ø¯Ù‡',0),(593664,16462,'pr','Ø´Ù…Ø§ Ø§Ø² ØµÙØ­Ù‡ Ø¢Ø´ØªÛŒ Ø¨Ø§Ù†Ú© Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± ÙˆÛŒØ±Ø§ÛŒØ´ Ù„ØºÙˆ Ø¨Ø§ÛŒØ¯',0),(593665,16463,'pr','Ø¹Ù„Øª Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ú¯Ø±Ø¯ Ùˆ ØºØ¨Ø§Ø± Ø²ÛŒØ± Ø¨Ø±Ø§ÛŒ ØªØ¨Ø¯ÛŒÙ„ Ø´Ø¯Ù† Ø§Ø² Ø§ÛŒÙ† Ù…ÙˆØ§Ø±Ø¯ Ø¨Ø¯ÙˆÙ† Ù¾ÛŒÙˆÙ†Ø¯ Ø¨Ù‡ Ø§Ø¯Ø§Ù…Ù‡',0),(593666,16464,'pr','Ø­Ø°Ù Ø±Ú©ÙˆØ±Ø¯',0),(593667,16465,'pr','Ø¨Ù† Ø§Ù†Ø¨Ø§Ø±',0),(593668,16466,'pr','Ø§Ù†Ø¨Ø§Ø± Ø²Ø¨Ø§Ù„Ù‡ ØªÙˆØ³Ø· Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(593669,16467,'pr','Ú©Ø¯ Ø¨Ù† Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ÛŒØ¯ ØªØ¹ÛŒÛŒÙ† Ø´ÙˆØ¯',0),(593670,16468,'pr','Ù…Ù†Ø·Ù‚Ù‡ Ø§Ù†Ø¨Ø§Ø±',0),(593671,16469,'pr','Ø¹Ù„Øª Ø±Ø§ Ø¨Ø±Ø§ÛŒ Ú¯Ø±Ø¯ Ùˆ ØºØ¨Ø§Ø± Ø²ÛŒØ± Ø¨Ø±Ø§ÛŒ ØªØ¨Ø¯ÛŒÙ„ Ø´Ø¯Ù† Ø§Ø² Ø§ÛŒÙ† Ù…Ù†Ø·Ù‚Ù‡ Ø¨Ø¯ÙˆÙ† Ù¾ÛŒÙˆÙ†Ø¯ Ø¨Ù‡ Ø§Ø¯Ø§Ù…Ù‡',0),(593672,16470,'pr','Ø§Ù†Ø¨Ø§Ø± Ù…Ù†Ø·Ù‚Ù‡ ØªÙˆØ³Ø· Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(593673,16471,'pr','Ú©Ø¯ Ù…Ù†Ø·Ù‚Ù‡ Ø§Ù†Ø¨Ø§Ø± Ø¨Ø§ÛŒØ¯ ØªØ¹ÛŒÛŒÙ† Ø´ÙˆØ¯',0),(593674,16472,'pr','Ø¨Ø§ÛŒØ¯ ØªÙ†Ø¸ÛŒÙ… Ø´Ø±ÙˆØ¹ Ùˆ Ù¾Ø§ÛŒØ§Ù† ØªØ§Ø±ÛŒØ®',0),(593675,16473,'pr','Ù‡ÛŒÚ† Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ù…Ú©Ø§Ù† Ù¾ÛŒØ´ ÙØ±Ø¶',0),(593676,16474,'pr','Ù‡ÛŒÚ† Ù¾ÛŒØ´ ÙØ±Ø¶ Ù‚ÛŒÙ…Øª ØªØ¹ÛŒÛŒÙ† Ø³Ø·Ø­',0),(593677,16475,'pr','ÙØ±ÙˆØ´ ÙˆÛŒÚ˜Ù‡ Ù‚ÛŒÙ…Øª Ú¯Ø°Ø§Ø±ÛŒ',0),(593678,16476,'pr','Ù‚ÛŒÙ…Øª Ø§Ø³ØªØ§Ù†Ø¯Ø§Ø±Ø¯',0),(593679,16477,'pr','Ø³ÙˆØ§Ù„Ø§Øª',0),(593680,16478,'pr','Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª interbranch',0),(593681,16479,'pr','ÙØ±ÙˆØ´ POS',0),(593682,16480,'pr','ÙØ§Ú©ØªÙˆØ± ÙØ±ÙˆØ´',0),(593683,16481,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ ÙØ±ÙˆØ´',0),(593684,16482,'pr','Ù…Ø®Ø§Ø²Ù† Ø§Ù†Ø¨Ø§Ø±',0),(593685,16483,'pr','Ù…Ù†Ø§Ø·Ù‚ Ø§Ù†Ø¨Ø§Ø±',0),(593686,16484,'pr','Ù†Ø§Ù… ØµÙ†Ø¯ÙˆÙ‚',0),(593687,16485,'pr','Ù…Ú©Ø§Ù† Ù‡Ø§ÛŒ Ø¨Ù†',0),(593688,16486,'pr','Ù‡ÛŒÚ† Avaible Ù…Ø®Ø§Ø²Ù† Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…Ú©Ø§Ù†',0),(593689,16487,'pr','Ø¨Ù† Ø§ÙˆÙ„ÛŒÙ‡',0),(593690,16488,'pr','Ø³Ø§Ø¨Ù‚Ù‡ Ú©Ø§Ø±',0),(593691,16489,'pr','Ø®Ù„Ø§ØµÙ‡ Ú©Ø§Ø±',0),(593692,16490,'pr','Ú©Ø§Ø± Ø¨Ø§Ù„Ø§ÛŒ Ø³Ø±',0),(593693,16491,'pr','Ø²Ù…Ø§Ù† Ú©Ø§Ø±',0),(593694,16492,'pr','Ù…Ù†Ø§Ø¨Ø¹',0),(593695,16493,'pr','Ú©Ù„ Ù‡Ø²ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ù†ÛŒØ±ÙˆÛŒ Ú©Ø§Ø±',0),(593696,16494,'pr','Ù‡Ø²ÛŒÙ†Ù‡ Ú©Ù„ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(593697,16495,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª ØµÙˆØ±ØªØ­Ø³Ø§Ø¨ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(593698,16496,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù†Ø§Ø®Ø§Ù„Øµ Ù¾Ù„Ø§Ø³ Nontaxable',0),(593699,16497,'pr','Ù†Ø§Ø®Ø§Ù„Øµ Ù¾Ø±Ø¯Ø§Ø®Øª Ø¨Ù‡ Ù‡Ù…Ø±Ø§Ù‡ Nontaxable Ø¯Ø± Ù‡Ø± Ø³Ø§Ù„',0),(593700,16498,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ø´Ù‡Ø±',0),(593701,16499,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ ØªØºØ°ÛŒÙ‡',0),(593702,16500,'pr','Ù¾Ø±Ø¯Ø§Ø®Øª Ø§Ø² Ø·Ø±ÛŒÙ‚ Ù†Ø§Ø®Ø§Ù„Øµ',0),(593703,16501,'pr','Ø¯ÙˆÙ„Øª Ù†Ú©Ø±Ø¯Ù†',0),(593704,16502,'pr','Ø¯Ø³ØªÙ…Ø²Ø¯ Ù…Ø´Ù…ÙˆÙ„ Ù…Ø§Ù„ÛŒØ§Øª',0),(593705,16420,'pl','SprawdÅº informacje',0),(593706,16421,'pl','Wyboru nie znaleziono',0),(593707,16422,'pl','Zapisano na wyboru',0),(593708,16423,'pl','EdycjÄ™ wyboru',0),(593709,16424,'pl','WystÄ…piÅ‚ bÅ‚Ä…d podczas zapisywania wyboru',0),(593710,16425,'pl','MoÅ¼na edytowaÄ‡ tylko AP kontrole',0),(593711,16426,'pl','Aby edytowaÄ‡ ten test musi uniewaÅ¼niÄ‡ i odtworzyÄ‡',0),(593712,16427,'pl','Nr konta',0),(593713,16428,'pl','Bilans - kategorie',0),(593714,16429,'pl','Nie grupowanie',0),(593715,16430,'pl','Suma czÄ™Å›ciowa przez',0),(593716,16431,'pl','Nieprzypisane',0),(593717,16432,'pl','Podsumowanie kosztÃ³w',0),(593718,16433,'pl','Wygasaniem certyfikatÃ³w dostawcy',0),(593719,16434,'pl','Nazwa certyfikatu',0),(593720,16435,'pl','Typ certyfikatu',0),(593721,16436,'pl','PokaÅ¼ Certyfikaty koÅ„czÄ…cy siÄ™ przed',0),(593722,16437,'pl','PozostaÅ‚e saldo',0),(593723,16438,'pl','BezpoÅ›redni Link do pobrania',0),(593724,16439,'pl','Pobieranie powinno rozpoczÄ…Ä‡ siÄ™ chwilowo',0),(593725,16440,'pl','DomyÅ›lna iloÅ›Ä‡ otrzymanych do zera',0),(593726,16441,'pl','Ukryj pola wyboru indosanta',0),(593727,16442,'pl','DomyÅ›lna iloÅ›Ä‡ wysyÅ‚anych do zera',0),(593728,16443,'pl','Edytuj, nie powiodÅ‚o siÄ™',0),(593729,16444,'pl','Nowe wydanie zostaÅ‚ stworzony po zostaÅ‚ wybrany do statku',0),(593730,16445,'pl','PrzedÅ‚oÅ¼enia moÅ¼liwe Double danych uniemoÅ¼liwiaÅ‚',0),(593731,16446,'pl','Przetwarzanie przesyÅ‚ek anulowane',0),(593732,16447,'pl','Szacowany czas dostawy',0),(593733,16448,'pl','ZaÅ‚Ä…cznik zostaÅ‚ zaksiÄ™gowany',0),(593734,16449,'pl','Voucher jest w zamkniÄ™tym okresie',0),(593735,16450,'pl','Niesymetryczne przez',0),(593736,16451,'pl','Jednostki',0),(593737,16452,'pl','Podsumowanie kosztÃ³w zleceÅ„',0),(593738,16453,'pl','Wybierz zadanie',0),(593739,16454,'pl','T Pay',0),(593740,16455,'pl','Dane zaktualizowany pomyÅ›lnie',0),(593741,16456,'pl','Zapisz kod kosztu & zmiany pracy na godziny',0),(593742,16457,'pl','Åšlepy statku',0),(593743,16458,'pl','Depozyt ten Bank zostaÅ‚ wyczyszczony na wyciÄ…gu bankowym',0),(593744,16459,'pl','MoÅ¼na edytowaÄ‡ tylko AP kontrole',0),(593745,16460,'pl','Automatyczne wybieranie',0),(593746,16461,'pl','Depozyt ten zostaÅ‚ ujÄ™ty w miesiÄ…c pojednania banku',0),(593747,16462,'pl','NaleÅ¼y odznaczyÄ‡ ze strony pojednania banku w celu edycji',0),(593748,16463,'pl','Nadal bÄ™dzie powodowaÄ‡ nastÄ™pujÄ…ce pojemniki zostaÄ‡ odÅ‚Ä…czone od tych elementÃ³w',0),(593749,16464,'pl','UsuniÄ™ty rekord',0),(593750,16465,'pl','Bin magazynu',0),(593751,16466,'pl','Bin magazynu przez ten kod juÅ¼ istnieje',0),(593752,16467,'pl','Kod pojemnika magazynu musi byÄ‡ ustawiona',0),(593753,16468,'pl','Strefy magazynowej',0),(593754,16469,'pl','Nadal bÄ™dzie powodowaÄ‡ nastÄ™pujÄ…ce pojemniki zostaÄ‡ odÅ‚Ä…czone od tej strefy',0),(593755,16470,'pl','Strefy magazynowej przez ten kod juÅ¼ istnieje',0),(593756,16471,'pl','Kod magazynu strefy musi byÄ‡ ustawiona',0),(593757,16472,'pl','RozpoczÄ™cia i Data zakoÅ„czenia musi byÄ‡ ustawiona',0),(593758,16473,'pl','Nie domyÅ›lnego zestawu lokalizacji',0),(593759,16474,'pl','Nie domyÅ›lnego zestawu poziomu ceny',0),(593760,16475,'pl','Specjalne ceny sprzedaÅ¼y',0),(593761,16476,'pl','Cena standardowa',0),(593762,16477,'pl','Zapytania',0),(593763,16478,'pl','MiÄ™dzybranÅ¼owe transfery',0),(593764,16479,'pl','SprzedaÅ¼y POS',0),(593765,16480,'pl','Faktura sprzedaÅ¼y',0),(593766,16481,'pl','Oferta sprzedaÅ¼y',0),(593767,16482,'pl','Pojemniki magazynowe',0),(593768,16483,'pl','Stref magazynu',0),(593769,16484,'pl','Nazwa Funduszu',0),(593770,16485,'pl','Lokalizacje skÅ‚adowania',0),(593771,16486,'pl','Nie pojemnikÃ³w Avaible dla tej lokalizacji',0),(593772,16487,'pl','Podstawowa skrzynia',0),(593773,16488,'pl','Historia zatrudnienia',0),(593774,16489,'pl','Podsumowanie pracy',0),(593775,16490,'pl','Pracy nad gÅ‚owÄ…',0),(593776,16491,'pl','Czas pracy',0),(593777,16492,'pl','Å¹rÃ³dÅ‚a',0),(593778,16493,'pl','CaÅ‚kowite koszty pracy',0),(593779,16494,'pl','Koszty caÅ‚kowite dostawcy',0),(593780,16495,'pl','Bill pÅ‚atnoÅ›ci dla dostawcÃ³w',0),(593781,16496,'pl','Wynagrodzenia brutto Plus operacji nieopodatkowanych',0),(593782,16497,'pl','Wynagrodzenia brutto Plus operacji nieopodatkowanych rocznie',0),(593783,16498,'pl','Miasto pÅ‚ace',0),(593784,16499,'pl','Karmione pÅ‚ace',0),(593785,16500,'pl','Wynagrodzenia brutto przez',0),(593786,16501,'pl','Stan wstrzymane',0),(593787,16502,'pl','Opodatkowaniu pÅ‚ac',0),(593788,16420,'pt','Verifique as informaÃ§Ãµes',0),(593789,16421,'pt','Cheque nÃ£o encontrado',0),(593790,16422,'pt','SeleÃ§Ã£o salvada',0),(593791,16423,'pt','Editar verificaÃ§Ã£o',0),(593792,16424,'pt','Erro ao salvar seleÃ§Ã£o',0),(593793,16425,'pt','Cheques somente AP podem ser editados.',0),(593794,16426,'pt','Para editar este cheque vocÃª deve anular e recriar',0),(593795,16427,'pt','# De conta',0),(593796,16428,'pt','BalanÃ§o patrimonial - Categorizado',0),(593797,16429,'pt','Nenhum agrupamento',0),(593798,16430,'pt','Subtotal por',0),(593799,16431,'pt','NÃ£o atribuÃ­do',0),(593800,16432,'pt','Resumo de custo',0),(593801,16433,'pt','Fornecedores certificados expirando',0),(593802,16434,'pt','Nome do certificado',0),(593803,16435,'pt','Tipo de certificado',0),(593804,16436,'pt','Visualizar certificados expirar antes',0),(593805,16437,'pt','Saldo remanescente',0),(593806,16438,'pt','Download Link direto',0),(593807,16439,'pt','Seu Download deve comeÃ§ar dentro de momentos',0),(593808,16440,'pt','Quantidade padrÃ£o recebida a Zero',0),(593809,16441,'pt','Esconder as caixas de seleÃ§Ã£o endossante',0),(593810,16442,'pt','Quantidade padrÃ£o enviada para Zero',0),(593811,16443,'pt','Editar falhado',0),(593812,16444,'pt','Uma nova remessa foi criada depois que vocÃª tinha selecionado para navio',0),(593813,16445,'pt','ApresentaÃ§Ã£o de dados duplo possÃ­veis impedida',0),(593814,16446,'pt','Processamento de envio cancelado',0),(593815,16447,'pt','Entrega estimada',0),(593816,16448,'pt','Comprovante foi Postado',0),(593817,16449,'pt','Vale Ã© em um perÃ­odo de fecho',0),(593818,16450,'pt','Desequilibrada pelo',0),(593819,16451,'pt','Entidade',0),(593820,16452,'pt','Resumo de custos de trabalho',0),(593821,16453,'pt','Por favor selecione um trabalho',0),(593822,16454,'pt','Pagamento de T',0),(593823,16455,'pt','Dados atualizados com sucesso',0),(593824,16456,'pt','Salvar o cÃ³digo custo & mudanÃ§as de emprego por horas',0),(593825,16457,'pt','Navio cego',0),(593826,16458,'pt','Este depÃ³sito bancÃ¡rio foi libertado em extrato bancÃ¡rio',0),(593827,16459,'pt','Cheques somente AP podem ser editados.',0),(593828,16460,'pt','Selecione auto',0),(593829,16461,'pt','Este depÃ³sito foi incluÃ­do em um mÃªs de reconciliaÃ§Ã£o bancÃ¡ria',0),(593830,16462,'pt','VocÃª deve desmarcÃ¡-lo na pÃ¡gina de reconciliaÃ§Ã£o bancÃ¡ria para editar',0),(593831,16463,'pt','Continuando a vontade causa os escaninhos seguinte tornar-se desvinculado desses itens',0),(593832,16464,'pt','Registro excluÃ­do',0),(593833,16465,'pt','ArmazÃ©m Bin',0),(593834,16466,'pt','ArmazÃ©m Bin por esse cÃ³digo jÃ¡ existe',0),(593835,16467,'pt','CÃ³digo de posiÃ§Ã£o do armazÃ©m deve ser definido',0),(593836,16468,'pt','Zona de armazÃ©m',0),(593837,16469,'pt','Continuando a vontade causa os seguir escaninhos para tornar-se desvinculado desta zona',0),(593838,16470,'pt','Zona de armazÃ©m por esse cÃ³digo jÃ¡ existe',0),(593839,16471,'pt','CÃ³digo do armazÃ©m zona deve ser definido',0),(593840,16472,'pt','Begin e End data devem ser definidas',0),(593841,16473,'pt','Nenhum conjunto de localizaÃ§Ã£o padrÃ£o',0),(593842,16474,'pt','Nenhum conjunto de nÃ­vel de preÃ§o padrÃ£o',0),(593843,16475,'pt','PreÃ§os de vendas especiais',0),(593844,16476,'pt','PreÃ§o padrÃ£o',0),(593845,16477,'pt','InquÃ©ritos',0),(593846,16478,'pt','TransferÃªncias interprofissionais',0),(593847,16479,'pt','POS venda',0),(593848,16480,'pt','Factura de vendas',0),(593849,16481,'pt','CotaÃ§Ã£o de vendas',0),(593850,16482,'pt','Caixas de depÃ³sito',0),(593851,16483,'pt','Zonas de armazÃ©m',0),(593852,16484,'pt','Nome do fundo',0),(593853,16485,'pt','Locais de bin',0),(593854,16486,'pt','NÃ£o Avaible escaninhos para este local',0),(593855,16487,'pt','Bin primÃ¡rio',0),(593856,16488,'pt','HistÃ³rico do trabalho',0),(593857,16489,'pt','Resumo do trabalho',0),(593858,16490,'pt','Sobrecarga de trabalho',0),(593859,16491,'pt','Tempo do trabalho',0),(593860,16492,'pt','Fontes',0),(593861,16493,'pt','Total dos custos trabalhistas',0),(593862,16494,'pt','Custos totais de fornecedor',0),(593863,16495,'pt','Pagamentos de contas de fornecedor',0),(593864,16496,'pt','SalÃ¡rio bruto mais Nontaxable',0),(593865,16497,'pt','SalÃ¡rio bruto mais Nontaxable por ano',0),(593866,16498,'pt','Cidade de salÃ¡rios',0),(593867,16499,'pt','Federal de salÃ¡rios',0),(593868,16500,'pt','SalÃ¡rio bruto atravÃ©s',0),(593869,16501,'pt','Estado retido',0),(593870,16502,'pt','SalÃ¡rios tributÃ¡veis',0),(593871,16420,'ro','Verifica informaÅ£ii',0),(593872,16421,'ro','Verifica negÄƒsitÄƒ',0),(593873,16422,'ro','Selectare salvate',0),(593874,16423,'ro','Editare verificare',0),(593875,16424,'ro','Eroare la salvarea Check',0),(593876,16425,'ro','AP numai controale pot fi editate',0),(593877,16426,'ro','Pentru a edita aceastÄƒ verificare trebuie sÄƒ anula ÅŸi de a recrea',0),(593878,16427,'ro','Cont #',0),(593879,16428,'ro','BilanÅ£ul - clasificate',0),(593880,16429,'ro','Nici un grup',0),(593881,16430,'ro','Subtotal de',0),(593882,16431,'ro','Neclasificat',0),(593883,16432,'ro','Cost Rezumat',0),(593884,16433,'ro','Furnizor de certificate care expirÄƒ',0),(593885,16434,'ro','Numele de certificat',0),(593886,16435,'ro','Tip de certificat',0),(593887,16436,'ro','AratÄƒ certificate care expirÄƒ Ã®nainte de',0),(593888,16437,'ro','Sold rÄƒmas',0),(593889,16438,'ro','Sincer Sincer Link',0),(593890,16439,'ro','Download-ul ar trebui sÄƒ Ã®nceapÄƒ o clipÄƒ',0),(593891,16440,'ro','Implicit cantitatea primitÄƒ de la Zero',0),(593892,16441,'ro','Ascunde casetele girant',0),(593893,16442,'ro','Implicit cantitatea livratÄƒ la Zero',0),(593894,16443,'ro','Editare a eÅŸuat',0),(593895,16444,'ro','Un transport nou a fost creat dupÄƒ ce a selectat pentru a navei',0),(593896,16445,'ro','Posibil Double Data depunere prevenite',0),(593897,16446,'ro','Procesare expediere anulat',0),(593898,16447,'ro','Estimat de livrare',0),(593899,16448,'ro','S-a Ã®nregistrat voucher',0),(593900,16449,'ro','Voucherul este Ã®ntr-O perioadÄƒ Ã®nchisÄƒ',0),(593901,16450,'ro','Dezechilibrat de',0),(593902,16451,'ro','Entitate',0),(593903,16452,'ro','Job Costa Rezumat',0),(593904,16453,'ro','VÄƒ rugÄƒm sÄƒ selectaÅ£i un loc de muncÄƒ',0),(593905,16454,'ro','T Pay',0),(593906,16455,'ro','Date actualizate cu succes',0),(593907,16456,'ro','Salvare costuri codul & schimbÄƒri de Job pentru ore',0),(593908,16457,'ro','Orb navei',0),(593909,16458,'ro','Acest depozit bancar a fost golitÄƒ pe extrasul de cont',0),(593910,16459,'ro','AP numai controale pot fi editate',0),(593911,16460,'ro','Selectare automatÄƒ',0),(593912,16461,'ro','Acest depozit a fost inclusÄƒ Ã®ntr-O lunÄƒ de reconciliere bancÄƒ',0),(593913,16462,'ro','Tu trebuie sÄƒ debifaÅ£i-l la Banca reconciliere paginÄƒ pentru a edita',0),(593914,16463,'ro','Continuarea va cauza urmÄƒtoarele compartimente pentru a deveni ne-legat de aceste elemente',0),(593915,16464,'ro','ÃŽnregistrare ÅŸtearsÄƒ',0),(593916,16465,'ro','Compartiment de depozitare',0),(593917,16466,'ro','Depozit Bin acest cod existÄƒ deja',0),(593918,16467,'ro','Cod de compartiment depozit trebuie sÄƒ fie setat',0),(593919,16468,'ro','Orar depozit',0),(593920,16469,'ro','Continuarea va cauza urmÄƒtoarele compartimente pentru a deveni ne-legat de aceastÄƒ zonÄƒ',0),(593921,16470,'ro','Depozit zonÄƒ de acest cod existÄƒ deja',0),(593922,16471,'ro','Trebuie setat codul de depozit zona',0),(593923,16472,'ro','ÃŽnceput ÅŸi data de Ã®ncheiere trebuie sÄƒ fie setat',0),(593924,16473,'ro','Nici un Set de locaÅ£ie implicitÄƒ',0),(593925,16474,'ro','Nici o implicit Pret Set nivel',0),(593926,16475,'ro','VÃ¢nzÄƒri speciale de stabilire a preÅ£urilor',0),(593927,16476,'ro','Pret standard',0),(593928,16477,'ro','Anchete',0),(593929,16478,'ro','Transferuri inter-ramurÄƒ',0),(593930,16479,'ro','VÃ¢nzare POS',0),(593931,16480,'ro','FacturÄƒ de vÃ¢nzare',0),(593932,16481,'ro','OfertÄƒ de vÃ¢nzÄƒri',0),(593933,16482,'ro','Compartimente de depozitare',0),(593934,16483,'ro','Zonele de depozit',0),(593935,16484,'ro','Nume fond',0),(593936,16485,'ro','Bin locatii',0),(593937,16486,'ro','Nici un disponibil de compartimente pentru aceastÄƒ locaÅ£ie',0),(593938,16487,'ro','Compartiment principal',0),(593939,16488,'ro','Locuri de muncÄƒ istoria',0),(593940,16489,'ro','Job Rezumat',0),(593941,16490,'ro','Muncii aeriene',0),(593942,16491,'ro','Timpul de muncÄƒ',0),(593943,16492,'ro','Surse',0),(593944,16493,'ro','Costurile totale ale forÅ£ei de muncÄƒ',0),(593945,16494,'ro','Costurile totale furnizor',0),(593946,16495,'ro','PlÄƒÅ£i de factura furnizor',0),(593947,16496,'ro','Salariu brut Plus Nontaxable',0),(593948,16497,'ro','Salariu brut Plus Nontaxable pe an',0),(593949,16498,'ro','City salariile',0),(593950,16499,'ro','HrÄƒnite salariile',0),(593951,16500,'ro','Salariu brut prin',0),(593952,16501,'ro','Stat reÅ£inute',0),(593953,16502,'ro','Salariile impozabile',0),(593954,16420,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸ÑŽ',0),(593955,16421,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÑŒÑ‚Ðµ, Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½',0),(593956,16422,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐºÐ° ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ñ',0),(593957,16423,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÑƒ',0),(593958,16424,'ru','ÐžÑˆÐ¸Ð±ÐºÐ° Ð¿Ñ€Ð¸ ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ð¸ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(593959,16425,'ru','ÐœÐ¾Ð¶Ð½Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ AP Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(593960,16426,'ru','Ð§Ñ‚Ð¾Ð±Ñ‹ Ð¾Ñ‚Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑÑ‚Ñƒ Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÑƒ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð°Ð½Ð½ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð¸ Ð·Ð°Ð½Ð¾Ð²Ð¾',0),(593961,16427,'ru','Ð¡Ñ‡ÐµÑ‚ #',0),(593962,16428,'ru','Ð‘Ð°Ð»Ð°Ð½Ñ - ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(593963,16429,'ru','Ð‘ÐµÐ· Ð³Ñ€ÑƒÐ¿Ð¿Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(593964,16430,'ru','Ð˜Ñ‚Ð¾Ð³Ð¾, Ð¿Ð¾',0),(593965,16431,'ru','ÐÐµ ÑÐ¾Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¾',0),(593966,16432,'ru','Ð¡Ñ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(593967,16433,'ru','Ð¡ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ñ‹ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´Ð°ÑŽÑ‰Ð¸ÐµÑÑ',0),(593968,16434,'ru','Ð˜Ð¼Ñ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(593969,16435,'ru','Ð¢Ð¸Ð¿ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(593970,16436,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ ÑÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ñ‹, ÑÑ€Ð¾Ðº Ð´ÐµÐ¹ÑÑ‚Ð²Ð¸Ñ ÐºÐ¾Ñ‚Ð¾Ñ€Ñ‹Ñ… Ð¸ÑÑ‚ÐµÐºÐ°ÐµÑ‚ Ð´Ð¾',0),(593971,16437,'ru','ÐžÑÑ‚Ð°Ñ‚Ð¾Ðº',0),(593972,16438,'ru','ÐŸÑ€ÑÐ¼Ð°Ñ ÑÑÑ‹Ð»ÐºÐ° Ð´Ð»Ñ Ð·Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸',0),(593973,16439,'ru','Ð—Ð°Ð³Ñ€ÑƒÐ·ÐºÐ° Ð´Ð¾Ð»Ð¶Ð½Ð° Ð½Ð°Ñ‡Ð°Ñ‚ÑŒÑÑ Ð¾Ð´Ð½Ð¾ÐºÑ€Ð°Ñ‚Ð½Ð¾',0),(593974,16440,'ru','ÐŸÐ¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð½Ñ‹Ñ… Ð´Ð¾ Ð½ÑƒÐ»Ñ',0),(593975,16441,'ru','Ð¡ÐºÑ€Ñ‹Ñ‚ÑŒ Ñ„Ð»Ð°Ð¶ÐºÐ¸ Ð¸Ð½Ð´Ð¾ÑÑÐ°Ð½Ñ‚Ð°',0),(593976,16442,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð¾Ñ‚Ð¿Ñ€Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð² Ð½Ð¾Ð»ÑŒ',0),(593977,16443,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ',0),(593978,16444,'ru','ÐÐ¾Ð²Ð°Ñ Ð¿Ð°Ñ€Ñ‚Ð¸Ñ Ð±Ñ‹Ð»Ð° ÑÐ¾Ð·Ð´Ð°Ð½Ð° Ð¿Ð¾ÑÐ»Ðµ Ñ‚Ð¾Ð³Ð¾, ÐºÐ°Ðº Ð²Ñ‹ Ð²Ñ‹Ð±Ñ€Ð°Ð»Ð¸ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(593979,16445,'ru','ÐŸÑ€ÐµÐ´ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð´Ð²Ð¾Ð¹Ð½Ð¾Ð¹ Ð¿Ñ€ÐµÐ´Ð¾Ñ‚Ð²Ñ€Ð°Ñ‰ÐµÐ½Ð¾',0),(593980,16446,'ru','ÐžÐ±Ñ€Ð°Ð±Ð¾Ñ‚ÐºÐ° Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð¾Ñ‚Ð¼ÐµÐ½ÐµÐ½Ð°',0),(593981,16447,'ru','ÐŸÐ¾ Ð¾Ñ†ÐµÐ½ÐºÐ°Ð¼ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(593982,16448,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð±Ñ‹Ð» Ñ€Ð°Ð·Ð¼ÐµÑ‰ÐµÐ½',0),(593983,16449,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð½Ð°Ñ…Ð¾Ð´Ð¸Ñ‚ÑÑ Ð² Ð·Ð°ÐºÑ€Ñ‹Ñ‚Ð¾Ð¼ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ðµ',0),(593984,16450,'ru','ÐÐµÑÐ±Ð°Ð»Ð°Ð½ÑÐ¸Ñ€Ð¾Ð²Ð°Ð½Ð½Ð¾Ð¹',0),(593985,16451,'ru','Ð¡ÑƒÑ‰Ð½Ð¾ÑÑ‚ÑŒ',0),(593986,16452,'ru','Ð—Ð°Ð´Ð°Ð½Ð¸Ðµ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(593987,16453,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð·Ð°Ð´Ð°Ð½Ð¸Ðµ',0),(593988,16454,'ru','T Ð¿Ð»Ð°Ñ‚Ð¸Ñ‚ÑŒ',0),(593989,16455,'ru','Ð”Ð°Ð½Ð½Ñ‹Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ñ‹',0),(593990,16456,'ru','Ð—Ð° Ð¸ÑÐºÐ»ÑŽÑ‡ÐµÐ½Ð¸ÐµÐ¼ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ ÐºÐ¾Ð´ & Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ñ Ð² Ð·Ð°Ð´Ð°Ð½Ð¸Ð¸ Ñ‡Ð°ÑÐ¾Ð²',0),(593991,16457,'ru','Ð¡Ð»ÐµÐ¿Ð¾Ð¹ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(593992,16458,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¸Ð¹ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð±Ñ‹Ð» ÑÐ½ÑÑ‚ Ð½Ð° Ð±Ð°Ð½ÐºÐ¾Ð²ÑÐºÐ¾Ð¹ Ð²Ñ‹Ð¿Ð¸ÑÐºÐµ',0),(593993,16459,'ru','ÐœÐ¾Ð¶Ð½Ð¾ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ñ‚Ð¾Ð»ÑŒÐºÐ¾ AP Ð¿Ñ€Ð¾Ð²ÐµÑ€ÐºÐ¸',0),(593994,16460,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸Ð¹ Ð²Ñ‹Ð±Ð¾Ñ€',0),(593995,16461,'ru','Ð­Ñ‚Ð¾Ñ‚ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ð±Ñ‹Ð» Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½ Ð² Ð¼ÐµÑÑÑ† Ð¿Ñ€Ð¸Ð¼Ð¸Ñ€ÐµÐ½Ð¸Ñ Ð±Ð°Ð½Ðº',0),(593996,16462,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ ÑÐ½ÑÑ‚ÑŒ ÐµÐ³Ð¾ ÑÐ¾ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ñ‹ Ð¿Ñ€Ð¸Ð¼Ð¸Ñ€ÐµÐ½Ð¸Ñ Ð±Ð°Ð½ÐºÐ° Ð´Ð»Ñ Ñ‚Ð¾Ð³Ð¾, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ',0),(593997,16463,'ru','ÐŸÑ€Ð¾Ð´Ð¾Ð»Ð¶ÐµÐ½Ð¸Ðµ Ð±ÑƒÐ´ÐµÑ‚ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð¾Ð¹ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ñ… Ð±ÑƒÐ½ÐºÐµÑ€Ð¾Ð², Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÑ‚Ð°Ñ‚ÑŒ Ð½ÐµÑÐ²ÑÐ·Ð°Ð½Ð½Ð¾Ð¹ Ð¸Ð· ÑÑ‚Ð¸Ñ… ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(593998,16464,'ru','Ð—Ð°Ð¿Ð¸ÑÑŒ ÑƒÐ´Ð°Ð»ÐµÐ½Ð°',0),(593999,16465,'ru','Ð¡ÐºÐ»Ð°Ð´ Ð±Ð¸Ð½',0),(594000,16466,'ru','Ð¡ÐºÐ»Ð°Ð´ Ð±Ð¸Ð½, ÑÑ‚Ð¾Ñ‚ ÐºÐ¾Ð´ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(594001,16467,'ru','ÐšÐ¾Ð´ ÑÑ‡ÐµÐ¹ÐºÐ¸ ÑÐºÐ»Ð°Ð´Ð° Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(594002,16468,'ru','Ð—Ð¾Ð½Ð° ÑÐºÐ»Ð°Ð´Ð°',0),(594003,16469,'ru','ÐŸÑ€Ð¾Ð´Ð¾Ð»Ð¶ÐµÐ½Ð¸Ðµ Ð±ÑƒÐ´ÐµÑ‚ Ð¿Ñ€Ð¸Ñ‡Ð¸Ð½Ð¾Ð¹ ÑÐ»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ñ… Ð±ÑƒÐ½ÐºÐµÑ€Ð¾Ð², Ñ‡Ñ‚Ð¾Ð±Ñ‹ ÑÑ‚Ð°Ñ‚ÑŒ Ð½ÐµÑÐ²ÑÐ·Ð°Ð½Ð½Ð¾Ð¹ Ð¸Ð· ÑÑ‚Ð¾Ð¹ Ð·Ð¾Ð½Ñ‹',0),(594004,16470,'ru','Ð¡ÐºÐ»Ð°Ð´ÑÐºÐ¸Ðµ Ð·Ð¾Ð½Ñ‹ ÑÑ‚Ð¾Ñ‚ ÐºÐ¾Ð´ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(594005,16471,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð·Ð°Ð´Ð°Ñ‚ÑŒ ÐºÐ¾Ð´ ÑÐºÐ»Ð°Ð´Ð° Ð·Ð¾Ð½Ñ‹',0),(594006,16472,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð·Ð°Ð´Ð°Ñ‚ÑŒ Ð½Ð°Ñ‡Ð°Ð»Ð¾ Ð¸ Ð”Ð°Ñ‚Ð° Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ',0),(594007,16473,'ru','ÐÐµÑ‚ Ð½Ð°Ð±Ð¾Ñ€Ð° Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(594008,16474,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½Ð½Ñ‹Ð¹ ÑƒÑ€Ð¾Ð²ÐµÐ½ÑŒ Ñ†ÐµÐ½ Ð½Ðµ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(594009,16475,'ru','Ð¡Ð¿ÐµÑ†Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ñ†ÐµÐ½Ñ‹ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(594010,16476,'ru','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ñ‚Ð½Ð°Ñ Ñ†ÐµÐ½Ð°',0),(594011,16477,'ru','Ð—Ð°Ð¿Ñ€Ð¾ÑÑ‹',0),(594012,16478,'ru','ÐœÐµÐ¶Ñ„Ð¸Ð»Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ñ‹',0),(594013,16479,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð¶Ð° POS',0),(594014,16480,'ru','Ð¡Ñ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(594015,16481,'ru','ÐšÐ²Ð¾Ñ‚Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ð¸',0),(594016,16482,'ru','Ð¡ÐºÐ»Ð°Ð´ÑÐºÐ¸Ðµ ÐºÐ¾Ð½Ñ‚ÐµÐ¹Ð½ÐµÑ€Ñ‹',0),(594017,16483,'ru','Ð¡ÐºÐ»Ð°Ð´ÑÐºÐ¸Ðµ Ð·Ð¾Ð½Ñ‹',0),(594018,16484,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ñ„Ð¾Ð½Ð´Ð°',0),(594019,16485,'ru','Ð‘ÐµÐ½ Ð¼ÐµÑÑ‚Ð°',0),(594020,16486,'ru','No Avaible Ð±ÑƒÐ½ÐºÐµÑ€Ð¾Ð² Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ñ',0),(594021,16487,'ru','ÐŸÐµÑ€Ð²Ð¸Ñ‡Ð½Ñ‹Ð¹ Ð±Ð¸Ð½',0),(594022,16488,'ru','Ð–ÑƒÑ€Ð½Ð°Ð» Ð·Ð°Ð´Ð°Ð½Ð¸Ð¹',0),(594023,16489,'ru','Ð Ð°Ð±Ð¾Ñ‚Ð° Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(594024,16490,'ru','Ð¢Ñ€ÑƒÐ´Ð¾Ð²Ñ‹Ðµ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹',0),(594025,16491,'ru','Ð¢Ñ€ÑƒÐ´Ð¾Ð²Ð¾Ðµ Ð²Ñ€ÐµÐ¼Ñ',0),(594026,16492,'ru','Ð˜ÑÑ‚Ð¾Ñ‡Ð½Ð¸ÐºÐ¸',0),(594027,16493,'ru','Ð’ÑÐµÐ³Ð¾ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚Ñ‹ Ð½Ð° Ñ€Ð°Ð±Ð¾Ñ‡ÑƒÑŽ ÑÐ¸Ð»Ñƒ',0),(594028,16494,'ru','Ð Ð°ÑÑ…Ð¾Ð´Ñ‹ Ð²ÑÐµÐ³Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(594029,16495,'ru','ÐžÐ¿Ð»Ð°Ñ‚Ð° ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(594030,16496,'ru','Ð’Ð°Ð»Ð¾Ð²Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð»ÑŽÑ Nontaxable',0),(594031,16497,'ru','Ð’Ð°Ð»Ð¾Ð²Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð»ÑŽÑ Nontaxable Ð² Ð³Ð¾Ð´',0),(594032,16498,'ru','Ð—Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð° Ð³Ð¾Ñ€Ð¾Ð´Ð°',0),(594033,16499,'ru','Ð¤Ð Ð¡ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð°Ñ Ð¿Ð»Ð°Ñ‚Ð°',0),(594034,16500,'ru','Ð’Ð°Ð»Ð¾Ð²Ð¾Ð¹ Ð·Ð°Ñ€Ð°Ð±Ð¾Ñ‚Ð½Ð¾Ð¹ Ð¿Ð»Ð°Ñ‚Ñ‹ Ñ‡ÐµÑ€ÐµÐ·',0),(594035,16501,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð¾ ÑƒÐ´ÐµÑ€Ð¶Ð¸Ð²Ð°ÐµÑ‚ÑÑ',0),(594036,16502,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð¾Ð±Ð»Ð°Ð³Ð°ÐµÐ¼Ð°Ñ Ð·Ð°Ñ€Ð¿Ð»Ð°Ñ‚Ð°',0),(594037,16420,'sr','ÐŸÐ¾Ð³Ð»ÐµÐ´Ð°Ñ˜Ñ‚Ðµ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ðµ Ð¾',0),(594038,16421,'sr','ÐŸÑ€Ð¾Ð²ÐµÑ€Ð¸ Ð´Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½Ð°',0),(594039,16422,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ñƒ ÑÐ¿Ð°ÑÐ¸Ð¾',0),(594040,16423,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(594041,16424,'sr','Ð“Ñ€ÐµÑˆÐºÐ° Ð¿Ñ€Ð¸Ð»Ð¸ÐºÐ¾Ð¼ ÑÐ¿Ñ€ÐµÐ¼Ð°ÑšÐ° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ',0),(594042,16425,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸ ÐÐŸ Ñ‡ÐµÐºÐ¾Ð²Ð¸ Ð¼Ð¾Ð³Ñƒ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°Ñ‚Ð¸.',0),(594043,16426,'sr','Ð”Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÑ€ÐµÐ´Ð¸Ð»Ð¸ Ð¾Ð²Ñƒ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¼Ð¾Ñ€Ð°Ñ‚Ðµ ÑÑ‚Ð¾Ñ€Ð½Ð¸Ñ€Ð°Ñ‚Ð¸ Ð¸ ÑÑ‚Ð²Ð¾Ñ€Ð¸',0),(594044,16427,'sr','Ð Ð°Ñ‡ÑƒÐ½',0),(594045,16428,'sr','Ð‘Ð¸Ð»Ð°Ð½Ñ ÑÑ‚Ð°ÑšÐ° - ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð·Ð¾Ð²Ð°Ð½Ð¸',0),(594046,16429,'sr','Ð‘ÐµÐ· Ð³Ñ€ÑƒÐ¿Ð¸ÑÐ°ÑšÐ°',0),(594047,16430,'sr','ÐŸÐ¾Ð´Ð·Ð±Ð¸Ñ€ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(594048,16431,'sr','ÐÐµÐ´Ð¾Ð´ÐµÑ™ÐµÐ½Ð¸',0),(594049,16432,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(594050,16433,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ðµ Ð¸ÑÑ‚ÐµÐº',0),(594051,16434,'sr','Ð˜Ð¼Ðµ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(594052,16435,'sr','Ð¢Ð¸Ð¿ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ð°',0),(594053,16436,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ†ÐµÑ€Ñ‚Ð¸Ñ„Ð¸ÐºÐ°Ñ‚Ðµ Ð¸ÑÑ‚ÐµÐº Ð¿Ñ€Ðµ',0),(594054,16437,'sr','Ð¡Ð°Ð»Ð´Ð¾ Ð¿Ñ€ÐµÐ¾ÑÑ‚Ð°Ð»Ð¾',0),(594055,16438,'sr','Ð”Ð¸Ñ€ÐµÐºÑ‚Ð°Ð½ Ð”Ð¾wÐ½Ð»Ð¾Ð°Ð´ Ð›Ð¸Ð½Ðº',0),(594056,16439,'sr','ÐŸÑ€ÐµÑƒÐ·Ð¸Ð¼Ð°ÑšÐµ Ñ‚Ñ€ÐµÐ±Ð° Ð´Ð° Ð¿Ð¾Ñ‡Ð½Ðµ Ð¾Ð´Ð¼Ð°Ñ…',0),(594057,16440,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ñ€Ð¸Ð¼Ñ™ÐµÐ½Ð° Ð½Ð° Ð½ÑƒÐ»Ñƒ',0),(594058,16441,'sr','Ð¡Ð°ÐºÑ€Ð¸Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ™Ð° Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð¶Ð¸Ñ€Ð°Ð½Ñ‚Ð°',0),(594059,16442,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÑ‡ÐµÐ½Ð° Ð½Ð° Ð½ÑƒÐ»Ñƒ',0),(594060,16443,'sr','Ð£Ñ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð½Ð¸Ñ˜Ðµ ÑƒÑÐ¿ÐµÐ»Ð¾',0),(594061,16444,'sr','ÐÐ¾Ð²Ð° Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° ÐºÑ€ÐµÐ¸Ñ€Ð°Ð½Ð° Ð½Ð°ÐºÐ¾Ð½ ÑˆÑ‚Ð¾ ÑÑ‚Ðµ Ð¸Ð·Ð°Ð±Ñ€Ð°Ð»Ð¸ Ð·Ð° Ð±Ñ€Ð¾Ð´',0),(594062,16445,'sr','ÐŸÑ€Ð¾ÑÐ»ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð²Ð¾ÑÑ‚Ñ€ÑƒÐºÐ¾ Ð¿Ð¾Ð´Ð°Ñ‚Ð°ÐºÐ° ÑÐ¿Ñ€ÐµÑ‡Ð¸Ð»Ð°',0),(594063,16446,'sr','ÐžÐ±Ñ€Ð°Ð´Ñƒ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½Ð°',0),(594064,16447,'sr','ÐŸÑ€Ð¾Ñ†ÐµÑšÐµÐ½Ð¸ Ð´Ð¾ÑÑ‚Ð°Ð²Ð°',0),(594065,16448,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ñ˜Ðµ Ð¿Ñ€Ð¾ÐºÑšÐ¸Ð¶ÐµÐ½.',0),(594066,16449,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ñ˜Ðµ Ñƒ Ð·Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾Ð¼ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ñƒ',0),(594067,16450,'sr','ÐÐµÑÐ°Ð»Ð´Ð¸Ñ€Ð°Ð½Ðµ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(594068,16451,'sr','Ð•Ð½Ñ‚Ð¸Ñ‚ÐµÑ‚',0),(594069,16452,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(594070,16453,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð¿Ð¾ÑÐ°Ð¾',0),(594071,16454,'sr','Ð¢ Ð¿Ð»Ð°Ñ‚Ðµ',0),(594072,16455,'sr','ÐŸÐ¾Ð´Ð°Ñ‚Ð°ÐºÐ° Ñ˜Ðµ ÑƒÑÐ¿ÐµÑˆÐ½Ð¾ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(594073,16456,'sr','Ð¡Ð°Ñ‡ÑƒÐ²Ð°Ñ˜ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° Ð¨Ð¸Ñ„Ñ€Ð° & Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ðµ Ð¿Ð¾ÑÐ°Ð¾ ÑÐ°Ñ‚Ð¸Ð¼Ð°',0),(594074,16457,'sr','Ð¡Ð»ÐµÐ¿Ð¸ Ð±Ñ€Ð¾Ð´',0),(594075,16458,'sr','ÐžÐ²Ð° Ð±Ð°Ð½ÐºÐ° Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚Ð° Ð¾Ñ‡Ð¸ÑˆÑ›ÐµÐ½Ð° Ð½Ð° Ð¸Ð·Ð²Ð¾Ð´ Ð¸Ð· Ð±Ð°Ð½ÐºÐµ',0),(594076,16459,'sr','ÐˆÐµÐ´Ð¸Ð½Ð¸ ÐÐŸ Ñ‡ÐµÐºÐ¾Ð²Ð¸ Ð¼Ð¾Ð³Ñƒ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°Ñ‚Ð¸.',0),(594077,16460,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð¸Ð·Ð±Ð¾Ñ€',0),(594078,16461,'sr','ÐžÐ²Ð°Ñ˜ Ð´ÐµÐ¿Ð¾Ð·Ð¸Ñ‚ Ñ˜Ðµ ÑÐ²Ñ€ÑÑ‚Ð°Ð½Ð° Ð½Ð° Ð¼ÐµÑÐµÑ† ÑÑ€Ð°Ð²ÑšÐµÑšÐ° Ð±Ð°Ð½ÐºÐµ',0),(594079,16462,'sr','ÐœÐ¾Ñ€Ð° Ñ˜Ðµ Ð¿Ð¾Ð½Ð¸ÑˆÑ‚Ð¸Ñ‚Ðµ Ð¸Ð· Ð±Ð°Ð½ÐºÐµ Ð¿Ð¾Ð¼Ð¸Ñ€ÐµÑšÐµ ÑÑ‚Ñ€Ð°Ð½Ð¸Ñ†Ðµ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ ÑƒÑ€ÐµÐ´Ð¸Ð»Ð¸',0),(594080,16463,'sr','ÐÐ°ÑÑ‚Ð°Ð²Ñ™Ð°Ñ˜ÑƒÑ›Ð¸ Ð²Ð¾Ñ™Ñƒ Ñ˜ÐµÑ€ ÑÐ»ÐµÐ´ÐµÑ›Ð¸ Ñ€ÐµÐ³Ð°Ð»Ðµ Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°Ð½Ðµ Ñ€Ð°ÑÐºÐ¸Ð½ÑƒÑ‚Ð¸ Ð²ÐµÐ·Ñƒ Ð¸Ð·Ð¼ÐµÑ’Ñƒ Ð¾Ð²Ð¸Ñ… ÑÑ‚Ð°Ð²ÐºÐ¸',0),(594081,16464,'sr','Ð—Ð°Ð¿Ð¸Ñ Ñ˜Ðµ Ð¸Ð·Ð±Ñ€Ð¸ÑÐ°Ð½',0),(594082,16465,'sr','Ð ÐµÐ³Ð°Ð» Ñƒ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ñƒ',0),(594083,16466,'sr','Ð ÐµÐ³Ð°Ð» Ñƒ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ñƒ Ð¾Ð²Ð° Ð¨Ð¸Ñ„Ñ€Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(594084,16467,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ñ€ÐµÐ³Ð°Ð»Ð° Ñƒ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ñƒ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°.',0),(594085,16468,'sr','ÐœÐ°Ð³Ð°Ñ†Ð¸Ð½ Ð·Ð¾Ð½Ð°',0),(594086,16469,'sr','ÐÐ°ÑÑ‚Ð°Ð²Ñ™Ð°Ñ˜ÑƒÑ›Ð¸ Ð²Ð¾Ñ™Ñƒ Ñ˜ÐµÑ€ ÑÐ»ÐµÐ´ÐµÑ›Ð¸ Ñ€ÐµÐ³Ð°Ð»Ðµ Ð´Ð° Ð¿Ð¾ÑÑ‚Ð°Ð½Ðµ Ñ€Ð°ÑÐºÐ¸Ð½ÑƒÑ‚Ð° Ð¸Ð· Ð¾Ð²Ðµ Ð—Ð¾Ð½Ðµ',0),(594087,16470,'sr','ÐœÐ°Ð³Ð°Ñ†Ð¸Ð½ Ð·Ð¾Ð½Ð° Ð¾Ð²Ð° Ð¨Ð¸Ñ„Ñ€Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸',0),(594088,16471,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð—Ð¾Ð½Ðµ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°.',0),(594089,16472,'sr','ÐŸÐ¾Ñ‡ÐµÑ‚Ð½Ð¸ Ð¸ Ð·Ð°Ð²Ñ€ÑˆÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð¼Ð¾Ñ€Ð°Ñ˜Ñƒ Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð¸',0),(594090,16473,'sr','ÐÐµÐ¼Ð° Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ ÑÐºÑƒÐ¿ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(594091,16474,'sr','Ð‘ÐµÐ· Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¾Ð³ Ñ†ÐµÐ½Ð° Ð½Ð¸Ð²Ð¾Ð° ÑÐºÑƒÐ¿Ð°',0),(594092,16475,'sr','ÐŸÐ¾ÑÐµÐ±Ð½Ðµ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð½Ðµ Ñ†ÐµÐ½Ðµ',0),(594093,16476,'sr','Ð¡Ñ‚Ð°Ð½Ð´Ð°Ñ€Ð´Ð½Ð° Ñ†ÐµÐ½Ð°',0),(594094,16477,'sr','Ð˜ÑÑ‚Ñ€Ð°Ð³Ðµ',0),(594095,16478,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð±Ñ€Ð°Ð½Ñ†Ñ… Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(594096,16479,'sr','ÐŸÐžÐ¡-Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð°',0),(594097,16480,'sr','Ð˜Ð·Ð»Ð°Ð·Ð½Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ðµ',0),(594098,16481,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ñƒ',0),(594099,16482,'sr','Ð ÐµÐ³Ð°Ð»Ðµ Ñƒ Ð¼Ð°Ð³Ð°Ñ†Ð¸Ð½Ñƒ',0),(594100,16483,'sr','ÐœÐ°Ð³Ð°Ñ†Ð¸Ð½ Ð·Ð¾Ð½Ðµ',0),(594101,16484,'sr','Ð˜Ð¼Ðµ Ñ„Ð¾Ð½Ð´Ð°',0),(594102,16485,'sr','Ð‘Ð¸Ð½ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(594103,16486,'sr','ÐÐµÐ¼Ð° ÐÐ²Ð°Ð¸Ð±Ð»Ðµ Ñ€ÐµÐ³Ð°Ð»Ðµ Ð·Ð° Ð¾Ð²Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(594104,16487,'sr','ÐŸÑ€Ð¸Ð¼Ð°Ñ€Ð½Ð¸ Ñ€ÐµÐ³Ð°Ð»Ð°',0),(594105,16488,'sr','ÐŸÐ¾Ð´Ð°Ñ‚ÐºÐµ Ð¾ Ð·Ð°Ð¿Ð¾ÑÐ»ÐµÑšÑƒ',0),(594106,16489,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð¿Ð¾ÑÐ»Ð°',0),(594107,16490,'sr','Ð˜Ð½Ð´Ð¸Ñ€ÐµÐºÑ‚Ð½Ð¸ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð¸ Ñ€Ð°Ð´Ð°',0),(594108,16491,'sr','Ð Ð°Ð´Ð½Ð¾ Ð²Ñ€ÐµÐ¼Ðµ',0),(594109,16492,'sr','Ð˜Ð·Ð²Ð¾Ñ€Ð¸',0),(594110,16493,'sr','Ð£ÐºÑƒÐ¿Ð½Ð¾ Ð¾ÑÐ¾Ð±Ñ™Ðµ Ð¿Ñ€ÐµÑÐºÑƒÐ¿Ð¾',0),(594111,16494,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÑƒÐºÑƒÐ¿Ð½Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(594112,16495,'sr','Ð‘Ð¸Ð» ÑƒÐ¿Ð»Ð°Ñ‚Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð¸Ð¼Ð°',0),(594113,16496,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ ÐŸÐ»ÑƒÑ Ð½ÐµÐ¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸Ñ…',0),(594114,16497,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ðµ ÐŸÐ»ÑƒÑ Ð½ÐµÐ¾Ð¿Ð¾Ñ€ÐµÐ·Ð¸Ð²Ð¸Ñ… Ð³Ð¾Ð´Ð¸ÑˆÑšÐµ',0),(594115,16498,'sr','Ð“Ñ€Ð°Ð´ Ð¿Ð»Ð°Ñ‚Ðµ',0),(594116,16499,'sr','Ð¤ÐµÐ´ÐµÑ€Ð°Ð»Ð°Ñ† Ð¿Ð»Ð°Ñ‚Ðµ',0),(594117,16500,'sr','Ð‘Ñ€ÑƒÑ‚Ð¾ Ð¿Ð»Ð°Ñ‚Ð° Ð´Ð¾',0),(594118,16501,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð° Ñ˜Ðµ ÑÐºÑ€Ð¸Ð²Ð°Ð¾',0),(594119,16502,'sr','ÐžÐ¿Ð¾Ñ€ÐµÐ·Ð¸Ð² Ð¿Ð»Ð°Ñ‚Ðµ',0),(594120,16420,'si','Preverite informacije',0),(594121,16421,'si','Preverite, ali ni mogoÄe najti',0),(594122,16422,'si','ÄŒek, shranjene',0),(594123,16423,'si','Urejanje potrdite',0),(594124,16424,'si','Napaka pri shranjevanju potrdite',0),(594125,16425,'si','AP le kontrole, ki jih je mogoÄe urejati',0),(594126,16426,'si','Za urejanje tega pregleda je niÄna in ponovno',0),(594127,16427,'si','RaÄun #',0),(594128,16428,'si','Bilanca stanja - kategorizirane',0),(594129,16429,'si','Nobeno zdruÅ¾enje',0),(594130,16430,'si','SeÅ¡tevek z',0),(594131,16431,'si','Nedodeljeni',0),(594132,16432,'si','StroÅ¡kovno Povzetek',0),(594133,16433,'si','Prodajalec potrdil izteÄe',0),(594134,16434,'si','Ime certifikata',0),(594135,16435,'si','Vrsto certifikata',0),(594136,16436,'si','PokaÅ¾i spriÄevala izteÄe pred',0),(594137,16437,'si','Sredstva, ki ostanejo',0),(594138,16438,'si','Neposreden travnato griÄevje Älen',0),(594139,16439,'si','Prenos je treba zaÄeti trenutek',0),(594140,16440,'si','Privzeta koliÄina prejel niÄ',0),(594141,16441,'si','Skriti Å½irant polja',0),(594142,16442,'si','Privzeta koliÄina odpremljeno v niÄ',0),(594143,16443,'si','Urejanje ni uspela',0),(594144,16444,'si','Novo poÅ¡iljko je bila ustvarjena, ko ste potrdili za ladje',0),(594145,16445,'si','PredloÅ¾itev mogoÄe dvojno podatkov prepreÄiti',0),(594146,16446,'si','Dobavnic, odpovedan',0),(594147,16447,'si','Ocenjena dobave',0),(594148,16448,'si','Kupon je bil objavljen',0),(594149,16449,'si','Kupon je dovoljeno',0),(594150,16450,'si','Z neuravnoteÅ¾eno',0),(594151,16451,'si','Subjekt',0),(594152,16452,'si','Projektnih stroÅ¡kov Povzetek',0),(594153,16453,'si','Izberite zaposlitev',0),(594154,16454,'si','T plaÄati',0),(594155,16455,'si','Podatkov, ki je uspeÅ¡no posodobljena',0),(594156,16456,'si','Shrani stroÅ¡ki kodo & menjavo delovnih mest za ure',0),(594157,16457,'si','Slepi ladje',0),(594158,16458,'si','Ta banÄni depozit je bil izpraznjen na banÄnem izpisku',0),(594159,16459,'si','AP le kontrole, ki jih je mogoÄe urejati',0),(594160,16460,'si','Samodejna izbira',0),(594161,16461,'si','Te vloge je bil vkljuÄen v mesec sprave banke',0),(594162,16462,'si','Morate poÄistite s strani banÄnega usklajevanja za urejanje',0),(594163,16463,'si','Nadaljevanje bo vzrok teh posod za izgubil povezavo iz teh elementov',0),(594164,16464,'si','Zapis izbrisan',0),(594165,16465,'si','Regal skladiÅ¡Änih',0),(594166,16466,'si','Regal skladiÅ¡Änih Å¡ifra Å¾e obstaja',0),(594167,16467,'si','Nastavite Å¡ifro skladiÅ¡Änega regala',0),(594168,16468,'si','SkladiÅ¡Äne cone',0),(594169,16469,'si','Nadaljevanje bo vzrok teh posod za izgubil povezavo iz tega obmoÄja',0),(594170,16470,'si','SkladiÅ¡Äne cone Å¡ifra Å¾e obstaja',0),(594171,16471,'si','Nastavite Å¡ifre skladiÅ¡Äa',0),(594172,16472,'si','ZaÄetni in konÄni datum mora biti nastavljen',0),(594173,16473,'si','Ni nastavljenega privzeto mesto',0),(594174,16474,'si','Ni privzeti nabor ravni cene',0),(594175,16475,'si','Posebne prodaje, cene',0),(594176,16476,'si','Standardne cene',0),(594177,16477,'si','Poizvedbe',0),(594178,16478,'si','MedpanoÅ¾na prenosi',0),(594179,16479,'si','Prodajo POS',0),(594180,16480,'si','Izdani raÄun',0),(594181,16481,'si','Prodajno ponudbo',0),(594182,16482,'si','SkladiÅ¡Äne regale',0),(594183,16483,'si','SkladiÅ¡Äne cone',0),(594184,16484,'si','Ime sklada',0),(594185,16485,'si','Bin lokacijah',0),(594186,16486,'si','Ni Avaible regale za to mesto',0),(594187,16487,'si','Primarni Bin',0),(594188,16488,'si','Zgodovina posla',0),(594189,16489,'si','Povzetek posla',0),(594190,16490,'si','ReÅ¾ijski stroÅ¡ki dela',0),(594191,16491,'si','ÄŒas dela',0),(594192,16492,'si','Virov',0),(594193,16493,'si','Skupnih stroÅ¡kov dela',0),(594194,16494,'si','Skupno prodajalec stroÅ¡ke',0),(594195,16495,'si','Bill plaÄila dobaviteljem',0),(594196,16496,'si','Bruto plaÄo Plus Nontaxable',0),(594197,16497,'si','Bruto plaÄo Plus Nontaxable letno',0),(594198,16498,'si','Mesto plaÄe',0),(594199,16499,'si','Krmijo plaÄe',0),(594200,16500,'si','Bruto plaÄa z',0),(594201,16501,'si','DrÅ¾ava zadrÅ¾i',0),(594202,16502,'si','DavÄni plaÄe',0),(594203,16420,'es','InformaciÃ³n del cheque',0),(594204,16421,'es','Compruebe que no se encuentra',0),(594205,16422,'es','Control guardado',0),(594206,16423,'es','Editar control',0),(594207,16424,'es','Error al guardar el cheque',0),(594208,16425,'es','Se pueden editar solamente AP cheques',0),(594209,16426,'es','Para editar esta comprobaciÃ³n debe anular y recrear',0),(594210,16427,'es','NÃºmero de cuenta',0),(594211,16428,'es','Balance general - clasificado',0),(594212,16429,'es','Ninguna agrupaciÃ³n',0),(594213,16430,'es','Subtotal por',0),(594214,16431,'es','Sin asignar',0),(594215,16432,'es','Resumen costo',0),(594216,16433,'es','Proveedores certificados en extinciÃ³n',0),(594217,16434,'es','Nombre del certificado',0),(594218,16435,'es','Tipo de certificado',0),(594219,16436,'es','Mostrar los certificados caducan antes de',0),(594220,16437,'es','Saldo restante',0),(594221,16438,'es','Enlace de descarga directa',0),(594222,16439,'es','La descarga debe comenzar momentÃ¡neamente',0),(594223,16440,'es','Predeterminada cantidad recibida a cero',0),(594224,16441,'es','Ocultar las casillas de verificaciÃ³n endosante',0),(594225,16442,'es','Predeterminada cantidad enviada a cero',0),(594226,16443,'es','No se pudo editar',0),(594227,16444,'es','Un nuevo envÃ­o se creÃ³ despuÃ©s de que usted habÃ­a seleccionado a la nave',0),(594228,16445,'es','PresentaciÃ³n de datos doble posible prevenida',0),(594229,16446,'es','Proceso de envÃ­o cancelado',0),(594230,16447,'es','Estimado de entrega',0),(594231,16448,'es','Vale ha sido publicado',0),(594232,16449,'es','Vale es un perÃ­odo cerrado',0),(594233,16450,'es','Desequilibrado por',0),(594234,16451,'es','Entidad',0),(594235,16452,'es','Resumen de costos de trabajo',0),(594236,16453,'es','Por favor seleccione un trabajo',0),(594237,16454,'es','T pago',0),(594238,16455,'es','Datos actualizados',0),(594239,16456,'es','Guardar cÃ³digo de costo y cambios de trabajo por horas',0),(594240,16457,'es','Ciego de la nave',0),(594241,16458,'es','Se ha borrado este depÃ³sito bancario en Banco Estado',0),(594242,16459,'es','Se pueden editar solamente AP cheques',0),(594243,16460,'es','Auto Select',0),(594244,16461,'es','Este depÃ³sito ha sido incluido en un mes de reconciliaciÃ³n de Banco',0),(594245,16462,'es','Debe desmarcar de la pÃ¡gina de la reconciliaciÃ³n de banco para poder editar',0),(594246,16463,'es','Continua voluntad causa los siguientes contenedores a ser desvinculados de estos artÃ­culos',0),(594247,16464,'es','Registro eliminado',0),(594248,16465,'es','AlmacÃ©n de depÃ³sito',0),(594249,16466,'es','DepÃ³sito Bin por este cÃ³digo ya existe',0),(594250,16467,'es','CÃ³digo de ubicaciÃ³n del almacÃ©n se debe establecer',0),(594251,16468,'es','Zona de almacÃ©n',0),(594252,16469,'es','Continuar a causa de la voluntad los siguientes contenedores a ser desvinculados de esta zona',0),(594253,16470,'es','Zona de almacÃ©n por este cÃ³digo ya existe',0),(594254,16471,'es','CÃ³digo de zona de almacÃ©n debe establecerse',0),(594255,16472,'es','Inicio y fecha fin se deben establecer',0),(594256,16473,'es','NingÃºn conjunto de ubicaciÃ³n por defecto',0),(594257,16474,'es','No hay precio conjunto nivel',0),(594258,16475,'es','Ventas especiales de precios',0),(594259,16476,'es','Precio estÃ¡ndar',0),(594260,16477,'es','Consultas',0),(594261,16478,'es','Transferencias sectoriales',0),(594262,16479,'es','POS venta',0),(594263,16480,'es','Factura de venta',0),(594264,16481,'es','Presupuesto de ventas',0),(594265,16482,'es','Contenedores de almacÃ©n',0),(594266,16483,'es','Zonas de almacÃ©n',0),(594267,16484,'es','Nombre del fondo',0),(594268,16485,'es','Ubicaciones de bin',0),(594269,16486,'es','No disponible contenedores para esta ubicaciÃ³n',0),(594270,16487,'es','Compartimiento principal',0),(594271,16488,'es','Historia de trabajo',0),(594272,16489,'es','Resumen del puesto',0),(594273,16490,'es','Sobrecarga de trabajo',0),(594274,16491,'es','Tiempo de trabajo',0),(594275,16492,'es','Fuentes',0),(594276,16493,'es','Costos totales de mano de obra',0),(594277,16494,'es','Proveedor total costos',0),(594278,16495,'es','Pagos de facturas de proveedores',0),(594279,16496,'es','Sueldo bruto mÃ¡s sujetos',0),(594280,16497,'es','Sueldo bruto mÃ¡s sujetos por aÃ±o',0),(594281,16498,'es','Salarios de la ciudad',0),(594282,16499,'es','Alimentados los salarios',0),(594283,16500,'es','Pago bruto a travÃ©s de',0),(594284,16501,'es','Estado retenida',0),(594285,16502,'es','Salarios imponibles',0),(594286,16420,'sv','Kontrollera Information',0),(594287,16421,'sv','Kontrollera inte hittat',0),(594288,16422,'sv','Kontrollera Sparad',0),(594289,16423,'sv','Redigera kontrollera',0),(594290,16424,'sv','Fel vid sparande av Check',0),(594291,16425,'sv','Endast AP kontroller kan redigeras',0),(594292,16426,'sv','FÃ¶r att redigera denna kontroll mÃ¥ste du annullera och Ã¥terskapa',0),(594293,16427,'sv','Konto nr',0),(594294,16428,'sv','BalansrÃ¤kning - Kategoriserad',0),(594295,16429,'sv','Ingen gruppering',0),(594296,16430,'sv','Delsumma av',0),(594297,16431,'sv','Otilldelade',0),(594298,16432,'sv','Kostnad Sammanfattning',0),(594299,16433,'sv','LeverantÃ¶r certifikat lÃ¶per ut',0),(594300,16434,'sv','Certifikatnamn',0),(594301,16435,'sv','Certifikattypen',0),(594302,16436,'sv','Visa certifikat lÃ¶per ut innan',0),(594303,16437,'sv','Kvarvarande saldo',0),(594304,16438,'sv','Rikta data Ã¶verfÃ¶r lÃ¤nk',0),(594305,16439,'sv','Din nerladdning bÃ¶r starta Ã¶gonblickligt',0),(594306,16440,'sv','Standardkvantitet som mottas till noll',0),(594307,16441,'sv','DÃ¶lja Endorser kryssrutorna',0),(594308,16442,'sv','Standardkvantiteten skickat till noll',0),(594309,16443,'sv','Redigera misslyckades',0),(594310,16444,'sv','En ny fÃ¶rsÃ¤ndelse skapades nÃ¤r du hade valt att fartyget',0),(594311,16445,'sv','MÃ¶jliga dubbel datainlÃ¤mning fÃ¶rhindras',0),(594312,16446,'sv','Utleveransbearbetning avbryts',0),(594313,16447,'sv','BerÃ¤knad leverans',0),(594314,16448,'sv','Verifikationen har bokfÃ¶rts',0),(594315,16449,'sv','Kupongen Ã¤r i en stÃ¤ngd Period',0),(594316,16450,'sv','Obalanserad av',0),(594317,16451,'sv','Enhet',0),(594318,16452,'sv','Jobbet kostar Sammanfattning',0),(594319,16453,'sv','VÃ¤nligen vÃ¤lj ett jobb',0),(594320,16454,'sv','T Pay',0),(594321,16455,'sv','Uppgifter uppdaterades',0),(594322,16456,'sv','Spara kostnad kod & jobb fÃ¶rÃ¤ndringar i timmar',0),(594323,16457,'sv','Blinda fartyget',0),(594324,16458,'sv','Denna bankinsÃ¤ttning har rensats pÃ¥ kontoutdrag',0),(594325,16459,'sv','Endast AP kontroller kan redigeras',0),(594326,16460,'sv','Automatiskt val',0),(594327,16461,'sv','Denna deposition har inkluderats i en Bank avstÃ¤mning mÃ¥nad',0),(594328,16462,'sv','Du mÃ¥ste avmarkera det frÃ¥n sidan Bank avstÃ¤mning fÃ¶r att redigera',0),(594329,16463,'sv','FortsÃ¤tter kommer att orsaka fÃ¶ljande lagerplatser blir olÃ¤nkade frÃ¥n dessa objekt',0),(594330,16464,'sv','Resurspost som togs bort',0),(594331,16465,'sv','Lagerplats',0),(594332,16466,'sv','Lagerplats genom denna kod finns redan',0),(594333,16467,'sv','Warehouse lagerplatskod mÃ¥ste anges',0),(594334,16468,'sv','LagerstÃ¤llezon',0),(594335,16469,'sv','FortsÃ¤tter kommer att orsaka fÃ¶ljande lagerplatser blir olÃ¤nkade frÃ¥n denna zon',0),(594336,16470,'sv','LagerstÃ¤llezon denna kodex finns redan',0),(594337,16471,'sv','LagerstÃ¤llezon koden mÃ¥ste anges',0),(594338,16472,'sv','Start- och slutdatum mÃ¥ste anges',0),(594339,16473,'sv','Ingen standard lÃ¤ge Set',0),(594340,16474,'sv','Ingen standard pris nivÃ¥ som',0),(594341,16475,'sv','SÃ¤rskild fÃ¶rsÃ¤ljning prissÃ¤ttning',0),(594342,16476,'sv','Standardpris',0),(594343,16477,'sv','FÃ¶rfrÃ¥gningar',0),(594344,16478,'sv','BranschÃ¶vergripande Ã¶verfÃ¶ringar',0),(594345,16479,'sv','POS fÃ¶rsÃ¤ljning',0),(594346,16480,'sv','FÃ¶rsÃ¤ljningsfaktura',0),(594347,16481,'sv','FÃ¶rs.offert',0),(594348,16482,'sv','Distributionslagrets lagerplatser',0),(594349,16483,'sv','LagerstÃ¤llezoner',0),(594350,16484,'sv','Fondens namn',0),(594351,16485,'sv','Lageradresser',0),(594352,16486,'sv','No Avaible lagerplatser fÃ¶r den hÃ¤r platsen',0),(594353,16487,'sv','PrimÃ¤ra Bin',0),(594354,16488,'sv','Jobbhistorik',0),(594355,16489,'sv','Jobb Sammanfattning',0),(594356,16490,'sv','Labor Overhead',0),(594357,16491,'sv','Labor tid',0),(594358,16492,'sv','KÃ¤llor',0),(594359,16493,'sv','Labor totalkostnader',0),(594360,16494,'sv','Total leverantÃ¶r kostnader',0),(594361,16495,'sv','Bill leverantÃ¶rsbetalningar',0),(594362,16496,'sv','BruttolÃ¶n Plus skattefria',0),(594363,16497,'sv','BruttolÃ¶n Plus skattefria Per Ã¥r',0),(594364,16498,'sv','Staden lÃ¶ner',0),(594365,16499,'sv','Fed lÃ¶ner',0),(594366,16500,'sv','BruttolÃ¶n genom',0),(594367,16501,'sv','Staten som innehÃ¥llits',0),(594368,16502,'sv','Skattepliktiga lÃ¶ner',0),(594369,16420,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥',0),(594370,16421,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹„à¸¡à¹ˆà¸žà¸š',0),(594371,16422,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸šà¸±à¸™à¸—à¸¶à¸',0),(594372,16423,'th','à¹à¸à¹‰à¹„à¸‚à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(594373,16424,'th','à¸‚à¹‰à¸­à¸œà¸´à¸”à¸žà¸¥à¸²à¸”à¹ƒà¸™à¸à¸²à¸£à¸šà¸±à¸™à¸—à¸¶à¸à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(594374,16425,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¹à¸à¹‰à¹„à¸‚à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š AP à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(594375,16426,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸¢à¸à¹€à¸¥à¸´à¸ à¹à¸¥à¸°à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¹à¸à¹‰à¹„à¸‚à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸™à¸µà¹‰',0),(594376,16427,'th','à¸šà¸±à¸à¸Šà¸µ#',0),(594377,16428,'th','à¸‡à¸šà¸”à¸¸à¸¥ - à¸à¸²à¸£à¹à¸šà¹ˆà¸‡à¸›à¸£à¸°à¹€à¸ à¸—',0),(594378,16429,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸¥à¸¸à¹ˆà¸¡',0),(594379,16430,'th','à¸œà¸¥à¸£à¸§à¸¡à¸¢à¹ˆà¸­à¸¢à¹‚à¸”à¸¢',0),(594380,16431,'th','à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸à¸³à¸«à¸™à¸”',0),(594381,16432,'th','à¸ªà¸£à¸¸à¸›à¸•à¹‰à¸™à¸—à¸¸à¸™',0),(594382,16433,'th','à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡à¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸',0),(594383,16434,'th','à¸Šà¸·à¹ˆà¸­à¸‚à¸­à¸‡à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡',0),(594384,16435,'th','à¸Šà¸™à¸´à¸”à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡',0),(594385,16436,'th','à¹à¸ªà¸”à¸‡à¹ƒà¸šà¸£à¸±à¸šà¸£à¸­à¸‡à¸—à¸µà¹ˆà¸«à¸¡à¸”à¸­à¸²à¸¢à¸¸à¸à¹ˆà¸­à¸™',0),(594386,16437,'th','à¸¢à¸­à¸”à¸„à¸‡à¹€à¸«à¸¥à¸·à¸­',0),(594387,16438,'th','à¸¥à¸´à¸‡à¸„à¹Œà¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¹‚à¸”à¸¢à¸•à¸£à¸‡',0),(594388,16439,'th','à¸„à¸§à¸£à¹€à¸£à¸´à¹ˆà¸¡à¸à¸²à¸£à¸”à¸²à¸§à¸™à¹Œà¹‚à¸«à¸¥à¸”à¸Šà¸±à¹ˆà¸§à¸‚à¸“à¸°',0),(594389,16440,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸—à¸µà¹ˆà¹„à¸”à¹‰à¸£à¸±à¸šà¹ƒà¸«à¹‰à¹€à¸›à¹‡à¸™à¸¨à¸¹à¸™à¸¢à¹Œ',0),(594390,16441,'th','à¸‹à¹ˆà¸­à¸™à¸à¸¥à¹ˆà¸­à¸‡à¸à¸²à¹€à¸„à¸£à¸·à¹ˆà¸­à¸‡à¸«à¸¡à¸²à¸¢ Endorser',0),(594391,16442,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸—à¸µà¹ˆà¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹„à¸›à¸¢à¸±à¸‡à¸¨à¸¹à¸™à¸¢à¹Œ',0),(594392,16443,'th','à¹à¸à¹‰à¸—à¸µà¹ˆà¸¥à¹‰à¸¡à¹€à¸«à¸¥à¸§',0),(594393,16444,'th','à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹ƒà¸«à¸¡à¹ˆà¸–à¸¹à¸à¸ªà¸£à¹‰à¸²à¸‡à¸‚à¸¶à¹‰à¸™à¸«à¸¥à¸±à¸‡à¸ˆà¸²à¸à¸—à¸µà¹ˆà¸„à¸¸à¸“à¹„à¸”à¹‰à¹€à¸¥à¸·à¸­à¸à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(594394,16445,'th','à¸ªà¹ˆà¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹„à¸”à¹‰à¸ªà¸­à¸‡à¸›à¹‰à¸­à¸‡à¸à¸±à¸™',0),(594395,16446,'th','à¸¢à¸à¹€à¸¥à¸´à¸à¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(594396,16447,'th','à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹‚à¸”à¸¢à¸›à¸£à¸°à¸¡à¸²à¸“',0),(594397,16448,'th','à¸¡à¸µà¸à¸²à¸£à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¹ƒà¸šà¸ªà¸³à¸„à¸±à¸',0),(594398,16449,'th','à¸ªà¸³à¸„à¸±à¸à¸„à¸·à¸­à¹ƒà¸™à¸£à¸­à¸š',0),(594399,16450,'th','à¹„à¸¡à¹ˆà¸ªà¸¡à¸”à¸¸à¸¥à¹‚à¸”à¸¢',0),(594400,16451,'th','à¹€à¸­à¸™à¸—à¸´à¸•à¸µ',0),(594401,16452,'th','à¸ªà¸£à¸¸à¸›à¸•à¹‰à¸™à¸—à¸¸à¸™à¸‡à¸²à¸™',0),(594402,16453,'th','à¸à¸£à¸¸à¸“à¸²à¹€à¸¥à¸·à¸­à¸à¸‡à¸²à¸™',0),(594403,16454,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸—à¸µ',0),(594404,16455,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸£à¸µà¸¢à¸šà¸£à¹‰à¸­à¸¢à¹à¸¥à¹‰à¸§',0),(594405,16456,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™à¹à¸¥à¸°à¸à¸²à¸£à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡à¸‡à¸²à¸™à¸Šà¸±à¹ˆà¸§à¹‚à¸¡à¸‡',0),(594406,16457,'th','à¹€à¸£à¸·à¸­à¸—à¸µà¹ˆà¸•à¸²à¸šà¸­à¸”',0),(594407,16458,'th','à¹€à¸‡à¸´à¸™à¸à¸²à¸à¸˜à¸™à¸²à¸„à¸²à¸£à¸™à¸µà¹‰à¹„à¸”à¹‰à¸–à¸¹à¸à¸¥à¹‰à¸²à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¹ƒà¸™à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸¢à¸­à¸”à¸‚à¸­à¸‡à¸˜à¸™à¸²à¸„à¸²à¸£',0),(594408,16459,'th','à¸ªà¸²à¸¡à¸²à¸£à¸–à¹à¸à¹‰à¹„à¸‚à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š AP à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(594409,16460,'th','à¹€à¸¥à¸·à¸­à¸à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´',0),(594410,16461,'th','à¸¡à¸±à¸”à¸£à¸§à¸¡à¹ƒà¸™à¹€à¸”à¸·à¸­à¸™à¸à¸£à¸°à¸—à¸šà¸¢à¸­à¸”à¸˜à¸™à¸²à¸„à¸²à¸£',0),(594411,16462,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸¢à¸à¹€à¸¥à¸´à¸à¹€à¸¥à¸·à¸­à¸à¸ˆà¸²à¸à¸«à¸™à¹‰à¸²à¸à¸²à¸£à¸à¸£à¸°à¸—à¸šà¸¢à¸­à¸”à¸˜à¸™à¸²à¸„à¸²à¸£à¹€à¸žà¸·à¹ˆà¸­à¹à¸à¹‰à¹„à¸‚',0),(594412,16463,'th','à¸•à¹ˆà¸­à¸ªà¸²à¹€à¸«à¸•à¸¸à¸ˆà¸°à¸Šà¹ˆà¸­à¸‡à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¸ˆà¸°à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡à¸ˆà¸²à¸à¸£à¸²à¸¢à¸à¸²à¸£à¹€à¸«à¸¥à¹ˆà¸²à¸™à¸µà¹‰',0),(594413,16464,'th','à¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸—à¸µà¹ˆà¸–à¸¹à¸à¸¥à¸š',0),(594414,16465,'th','à¸Šà¹ˆà¸­à¸‡à¹€à¸à¹‡à¸šà¸„à¸¥à¸±à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(594415,16466,'th','à¸Šà¹ˆà¸­à¸‡à¹€à¸à¹‡à¸šà¸„à¸¥à¸±à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸£à¸«à¸±à¸ªà¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(594416,16467,'th','à¸•à¹‰à¸­à¸‡à¸à¸³à¸«à¸™à¸”à¸£à¸«à¸±à¸ªà¸Šà¹ˆà¸­à¸‡à¹€à¸à¹‡à¸šà¸„à¸¥à¸±à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(594417,16468,'th','à¹‚à¸‹à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(594418,16469,'th','à¸•à¹ˆà¸­à¸ªà¸²à¹€à¸«à¸•à¸¸à¸ˆà¸°à¸Šà¹ˆà¸­à¸‡à¸•à¹ˆà¸­à¹„à¸›à¸™à¸µà¹‰à¸ˆà¸°à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¹€à¸Šà¸·à¹ˆà¸­à¸¡à¹‚à¸¢à¸‡à¸ˆà¸²à¸à¹‚à¸‹à¸™à¸™à¸µà¹‰',0),(594419,16470,'th','à¹‚à¸‹à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²à¸£à¸«à¸±à¸ªà¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(594420,16471,'th','à¸•à¹‰à¸­à¸‡à¸à¸³à¸«à¸™à¸”à¸£à¸«à¸±à¸ªà¸ªà¸´à¸™à¸„à¹‰à¸²à¹‚à¸‹à¸™',0),(594421,16472,'th','à¸•à¹‰à¸­à¸‡à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¹à¸¥à¸°à¸§à¸±à¸™à¸ªà¸´à¹‰à¸™à¸ªà¸¸à¸”',0),(594422,16473,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(594423,16474,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸£à¸°à¸”à¸±à¸šà¸£à¸²à¸„à¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(594424,16475,'th','à¸à¸²à¸£à¸à¸³à¸«à¸™à¸”à¸£à¸²à¸„à¸²à¸‚à¸²à¸¢à¸žà¸´à¹€à¸¨à¸©',0),(594425,16476,'th','à¸£à¸²à¸„à¸²à¸¡à¸²à¸•à¸£à¸à¸²à¸™',0),(594426,16477,'th','à¸ªà¸­à¸šà¸–à¸²à¸¡',0),(594427,16478,'th','à¹‚à¸­à¸™à¹€à¸‡à¸´à¸™ interbranch',0),(594428,16479,'th','à¸‚à¸²à¸¢ POS',0),(594429,16480,'th','à¸­à¸´à¸™à¸§à¸­à¸¢à¸‹à¹Œà¸à¸²à¸£à¸‚à¸²à¸¢',0),(594430,16481,'th','à¹ƒà¸šà¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸‚à¸²à¸¢',0),(594431,16482,'th','à¸Šà¹ˆà¸­à¸‡à¹€à¸à¹‡à¸šà¸„à¸¥à¸±à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(594432,16483,'th','à¹‚à¸‹à¸™à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(594433,16484,'th','à¸Šà¸·à¹ˆà¸­à¸à¸­à¸‡à¸—à¸¸à¸™',0),(594434,16485,'th','à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸Šà¹ˆà¸­à¸‡à¹€à¸à¹‡à¸š',0),(594435,16486,'th','à¸œà¹‰à¸²à¸«à¸¸à¹‰à¸¡à¹„à¸¡à¹ˆà¸¡à¸µà¸Šà¹ˆà¸­à¸‡à¹€à¸à¹‡à¸šà¸ªà¸³à¸«à¸£à¸±à¸šà¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡à¸™à¸µà¹‰',0),(594436,16487,'th','à¸Šà¹ˆà¸­à¸‡à¸«à¸¥à¸±à¸',0),(594437,16488,'th','à¸›à¸£à¸°à¸§à¸±à¸•à¸´à¸‡à¸²à¸™',0),(594438,16489,'th','à¸ªà¸£à¸¸à¸›à¸‡à¸²à¸™',0),(594439,16490,'th','à¹à¸£à¸‡à¸‡à¸²à¸™à¸„à¹ˆà¸²à¹ƒà¸Šà¹‰à¸ˆà¹ˆà¸²à¸¢',0),(594440,16491,'th','à¹€à¸§à¸¥à¸²à¹à¸£à¸‡à¸‡à¸²à¸™',0),(594441,16492,'th','à¹à¸«à¸¥à¹ˆà¸‡à¸—à¸µà¹ˆà¸¡à¸²',0),(594442,16493,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¹à¸£à¸‡à¸‡à¸²à¸™à¸£à¸§à¸¡',0),(594443,16494,'th','à¸•à¹‰à¸™à¸—à¸¸à¸™à¸‚à¸²à¸¢à¸£à¸§à¸¡',0),(594444,16495,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸£à¸±à¸šà¸Šà¸³à¸£à¸°',0),(594445,16496,'th','à¹€à¸‡à¸´à¸™à¸šà¸§à¸ Nontaxable',0),(594446,16497,'th','à¹€à¸‡à¸´à¸™à¸šà¸§à¸ Nontaxable à¸•à¹ˆà¸­à¸›à¸µ',0),(594447,16498,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¹€à¸¡à¸·à¸­à¸‡',0),(594448,16499,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸­à¸²à¸«à¸²à¸£à¸¡à¸²à¸',0),(594449,16500,'th','à¹€à¸‡à¸´à¸™à¸œà¹ˆà¸²à¸™',0),(594450,16501,'th','à¸ªà¸–à¸²à¸™à¸°à¸„à¸‡à¸„à¹‰à¸²à¸‡',0),(594451,16502,'th','à¸„à¹ˆà¸²à¸ˆà¹‰à¸²à¸‡à¸•à¹‰à¸­à¸‡à¹€à¸ªà¸µà¸¢à¸ à¸²à¸©à¸µ',0),(594452,16420,'tr','Bilgilere bakÄ±n',0),(594453,16421,'tr','BulunamadÄ± kontrol',0),(594454,16422,'tr','Kaydedilen onay',0),(594455,16423,'tr','Onay DÃ¼zenle',0),(594456,16424,'tr','Onay kaydedilirken hata oluÅŸtu',0),(594457,16425,'tr','Sadece AP denetimler dÃ¼zenlenebilir',0),(594458,16426,'tr','Bu Ã§ek dÃ¼zenlemek iÃ§in sen-geÃ§ersiz yeniden ve gerekir',0),(594459,16427,'tr','Hesap #',0),(594460,16428,'tr','BilanÃ§o - kategorize',0),(594461,16429,'tr','Yok bir gruplandÄ±rma',0),(594462,16430,'tr','TarafÄ±ndan alt toplamÄ±',0),(594463,16431,'tr','AtanmamÄ±ÅŸ',0),(594464,16432,'tr','Maliyet Ã–zeti',0),(594465,16433,'tr','SatÄ±cÄ± sertifika expiring',0),(594466,16434,'tr','Sertifika adÄ±',0),(594467,16435,'tr','Sertifika tÃ¼rÃ¼',0),(594468,16436,'tr','Ã–nce sÃ¼resi dolan sertifikalarÄ± gÃ¶stermek',0),(594469,16437,'tr','Kalan bakiye',0),(594470,16438,'tr','Yolu tarif etmek Download baÄŸlantÄ±',0),(594471,16439,'tr','Senin Download an baÅŸlamalÄ±dÄ±r',0),(594472,16440,'tr','SÄ±fÄ±r olarak alÄ±nan varsayÄ±lan miktar',0),(594473,16441,'tr','Onay doÄŸrulayÄ±cÄ± kutularÄ±nÄ± gizlemek',0),(594474,16442,'tr','VarsayÄ±lan miktar sÄ±fÄ±r olarak sevk',0),(594475,16443,'tr','DÃ¼zenleme baÅŸarÄ±sÄ±z oldu',0),(594476,16444,'tr','Gemiye seÃ§miÅŸti sonra yeni bir sevkiyat oluÅŸturuldu',0),(594477,16445,'tr','OlasÄ± Ã§ift veri gÃ¶nderme engelledi',0),(594478,16446,'tr','Sevkiyat iÅŸlemini iptal',0),(594479,16447,'tr','Tahmini teslimat',0),(594480,16448,'tr','FiÅŸ deftere nakledildi',0),(594481,16449,'tr','FiÅŸ kapalÄ± bir dÃ¶nemdir',0),(594482,16450,'tr','TarafÄ±ndan dengesiz',0),(594483,16451,'tr','VarlÄ±k',0),(594484,16452,'tr','Ä°ÅŸ Ã–zeti mal',0),(594485,16453,'tr','LÃ¼tfen iÅŸi seÃ§in',0),(594486,16454,'tr','T Pay',0),(594487,16455,'tr','Veri baÅŸarÄ±yla gÃ¼ncelleÅŸtirildi',0),(594488,16456,'tr','Maliyet kodu ve iÅŸ deÄŸiÅŸikliÄŸi saat kaydetmek',0),(594489,16457,'tr','KÃ¶r gemi',0),(594490,16458,'tr','Bu banka mevduat banka ekstresinde temizlenmiÅŸ oldu',0),(594491,16459,'tr','Sadece AP denetimler dÃ¼zenlenebilir',0),(594492,16460,'tr','Otomatik seÃ§im',0),(594493,16461,'tr','Bu depozito bir banka mutabakatÄ± ayda dahil',0),(594494,16462,'tr','Sen banka mutabakatÄ± sayfasÄ±ndan dÃ¼zenlemek iÃ§in iÅŸaretini kaldÄ±rÄ±n gerekir',0),(594495,16463,'tr','Will neden bu Ã¶ÄŸelerden baÄŸlantÄ±sÄ±z olmak iÃ§in aÅŸaÄŸÄ±daki kutularÄ± devam',0),(594496,16464,'tr','KayÄ±t silindi',0),(594497,16465,'tr','Ambar depo gÃ¶zÃ¼',0),(594498,16466,'tr','Ambar depo gÃ¶zÃ¼ bu kod tarafÄ±ndan zaten var',0),(594499,16467,'tr','Ambar depo gÃ¶zÃ¼ kodu ayarlamanÄ±z gerekir',0),(594500,16468,'tr','Depo bÃ¶lgesi',0),(594501,16469,'tr','Will neden bu bÃ¶lgeden baÄŸlantÄ±sÄ±z olmak iÃ§in aÅŸaÄŸÄ±daki kutularÄ± devam',0),(594502,16470,'tr','Bu kod tarafÄ±ndan depo bÃ¶lgesi zaten',0),(594503,16471,'tr','Ambar alanÄ± kodu ayarlamanÄ±z gerekir',0),(594504,16472,'tr','BaÅŸlangÄ±Ã§ ve bitiÅŸ tarihi olarak ayarlanmalÄ±dÄ±r',0),(594505,16473,'tr','VarsayÄ±lan konum ayarlanmadÄ±',0),(594506,16474,'tr','VarsayÄ±lan fiyat dÃ¼zeyi ayarlanmadÄ±',0),(594507,16475,'tr','FiyatlandÄ±rma Ã¶zel satÄ±ÅŸ',0),(594508,16476,'tr','Standart Fiyat',0),(594509,16477,'tr','Sorular',0),(594510,16478,'tr','Ä°nterbranch transferleri',0),(594511,16479,'tr','POS satÄ±ÅŸ',0),(594512,16480,'tr','SatÄ±ÅŸ faturasÄ±',0),(594513,16481,'tr','SatÄ±ÅŸ teklifi',0),(594514,16482,'tr','Ambar depo gÃ¶zleri',0),(594515,16483,'tr','Ambar bÃ¶lgeleri',0),(594516,16484,'tr','Fon adÄ±',0),(594517,16485,'tr','Depo yerleri',0),(594518,16486,'tr','Bu konum iÃ§in hiÃ§bir depo gÃ¶zleri Klipsli',0),(594519,16487,'tr','Birincil depo gÃ¶zÃ¼',0),(594520,16488,'tr','Ä°ÅŸ geÃ§miÅŸi',0),(594521,16489,'tr','Ä°ÅŸ Ã–zeti',0),(594522,16490,'tr','Ä°ÅŸ yÃ¼kÃ¼',0),(594523,16491,'tr','Emek zaman',0),(594524,16492,'tr','KaynaklarÄ±',0),(594525,16493,'tr','Toplam emek maliyeti',0),(594526,16494,'tr','Toplam satÄ±cÄ± maliyeti',0),(594527,16495,'tr','SatÄ±cÄ± fatura Ã¶demeleri',0),(594528,16496,'tr','BrÃ¼t Ã¶deme artÄ± Nontaxable',0),(594529,16497,'tr','BrÃ¼t Ã¶deme artÄ± yÄ±lda Nontaxable',0),(594530,16498,'tr','Åžehir Ã¼cret',0),(594531,16499,'tr','Federal Ã¼cret',0),(594532,16500,'tr','BrÃ¼t Ã¶deme Ã¼zerinden',0),(594533,16501,'tr','Gizli devlet',0),(594534,16502,'tr','Vergiye tabi Ã¼cret',0),(594535,16420,'ur','Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(594536,16421,'ur','Ú†ÛŒÚ© Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(594537,16422,'ur','Ù…Ø­ÙÙˆØ¸ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(594538,16423,'ur','Ú†ÛŒÚ© Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(594539,16424,'ur','Ù†Ù‚Øµ Ù¾Ú‘ØªØ§Ù„ Ù…Ø­ÙÙˆØ¸ Ú©Ø± Ø±ÛØ§ ÛÛ’ Û”',0),(594540,16425,'ur','ØµØ±Ù AP Ú†ÛŒÚ© ØªØ¯ÙˆÛŒÙ† Ù†ÛÛŒÚº Ú©ÛŒ Ø¬Ø§ Ø³Ú©ØªÛŒ',0),(594541,16426,'ur','Ø§Ø³ Ú†ÛŒÚ© Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø¢Ù¾ ØµÙØ± Ú©Ùˆ Ø¯ÙˆØ¨Ø§Ø±Û ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº Ø§ÙˆØ± Ú†Ø§ÛÛŒÛ’',0),(594542,16427,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ù…Ø¨Ø±',0),(594543,16428,'ur','Ø¨ÛŒÙ„Ù†Ø³ Ø´ÛŒÙ¹ - Ø¯Ø±Ø¬Û Ø¨Ù†Ø¯ÛŒ',0),(594544,16429,'ur','Ú©ÙˆØ¦ÛŒ Ú¯Ø±ÙˆÙ¾ Ø¨Ù†Ø¯ÛŒ',0),(594545,16430,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø°ÛŒÙ„ÛŒ Ù…ÛŒØ²Ø§Ù†',0),(594546,16431,'ur','ØºÛŒØ± Ù…ÙÙˆØ¶Û',0),(594547,16432,'ur','Ù„Ø§Ú¯Øª Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(594548,16433,'ur','ÙˆÛŒÙ†ÚˆØ± ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û’ Ù¾Ø§Ø±Ø§Ù†Ú¯',0),(594549,16434,'ur','Ù†Ø§Ù… ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û',0),(594550,16435,'ur','Ø³Ø±Ù¹ÛŒÙÚ©ÛŒÙ¹ Ù¹Ø§Ø¦Ù¾',0),(594551,16436,'ur','ØªØµØ¯ÛŒÙ‚ Ù†Ø§Ù…Û’ Ø³Û’ Ù¾ÛÙ„Û’ Ù¾Ø§Ø±Ø§Ù†Ú¯ Ú©ÛŒ Ù†Ù…Ø§ÛŒØ´ Ú©Ø±ÛŒÚº',0),(594552,16437,'ur','ØªÙˆØ§Ø²Ù† Ø¨Ø§Ù‚ÛŒ',0),(594553,16438,'ur','Ø¨Ø±Ø§Û Ø±Ø§Ø³Øª ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§ Ù„Ù†Ú©',0),(594554,16439,'ur','Ø¢Ù¾ ÚˆØ§Ø¤Ù† Ù„ÙˆÚˆØŒ Ø§ØªØ§Ø±Ù†Ø§ Ù…ÙˆÙ…Ø§Ù†ØªØ±Ø§Ù„ Ø´Ø±ÙˆØ¹ Ú©Ø±Ù†ÛŒ Ú†Ø§ÛØ¦Û’',0),(594555,16440,'ur','Ø·Û’ Ø´Ø¯Û ØªØ¹Ø¯Ø§Ø¯ ØµÙØ± Ú©Ùˆ Ù…ÙˆØµÙˆÙ„',0),(594556,16441,'ur','Ù¾Ú‘ØªØ§Ù„ Endorser Ø®Ø§Ù†Û’ Ú†Ú¾Ù¾Ø§Ø¦ÛŒÚº',0),(594557,16442,'ur','Ø·Û’ Ø´Ø¯Û ØªØ¹Ø¯Ø§Ø¯ ØµÙØ± Ú©Ùˆ Ø¨Ú¾ÛŒØ¬ Ø¯ÛŒØ§',0),(594558,16443,'ur','Ù†Ø§Ú©Ø§Ù… ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(594559,16444,'ur','Ø¢Ù¾ Ú©Ø´ØªÛŒ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†ØªØ®Ø¨ Ú©ÛŒØ§ ØªÚ¾Ø§ Ø§Ø³ Ú©Û’ Ø¨Ø¹Ø¯ Ø§ÛŒÚ© Ù†Ø¦ÛŒ Ú©Ú¾ÛŒÙ¾ Ù¾ÛŒØ¯Ø§ Ú©ÛŒØ§ Ú¯ÛŒØ§ ØªÚ¾Ø§',0),(594560,16445,'ur','Ù…Ù…Ú©Ù† ÚˆØ¨Ù„ Ú©ÙˆØ§Ø¦Ù Ø¬Ù…Ø¹ Ú©Ø±Ø§Ù†Û’ Ú©Ùˆ Ø±ÙˆÚ© Ø¯ÛŒØ§',0),(594561,16446,'ur','ÛÚ‘Ù¾Û Ú©ÛŒ Ø¹Ù…Ù„ Ú©Ø§Ø±ÛŒ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(594562,16447,'ur','Ø§Ù†Ø¯Ø§Ø²Û’ Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ø­ÙˆØ§Ù„Ú¯ÛŒ',0),(594563,16448,'ur','ÙˆØ§Ø¤Ú†Ø± Ù¾ÙˆØ³Ù¹ Ú©Ø± Ø¯ÛŒØ§ Ú¯ÛŒØ§ ÛÛ’',0),(594564,16449,'ur','ÙˆØ§Ø¤Ú†Ø± Ø§ÛŒÚ© Ø¨Ù†Ø¯ Ø¯ÙˆØ± Ù…ÛŒÚº ÛÛ’ Û”',0),(594565,16450,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ unbalanced',0),(594566,16451,'ur','ÛØ³ØªÛŒ',0),(594567,16452,'ur','Ø¬Ø§Ø¨ Ø®Ù„Ø§ØµÛ Ù„Ø§Ú¯Øª Ø¢Ø¦Û’ Ú¯ÛŒ Û”',0),(594568,16453,'ur','Ø§ÛŒÚ© Ú©Ø§Ù… Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(594569,16454,'ur','T ØªÙ†Ø®ÙˆØ§Û',0),(594570,16455,'ur','Ú©ÙˆØ§Ø¦Ù Ú©ÛŒ Ú©Ø§Ù…ÛŒØ§Ø¨ÛŒ Ø³Û’ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(594571,16456,'ur','Ù‚ÛŒÙ…Øª Ú©ÙˆÚˆ & Ù…Ù„Ø§Ø²Ù…Øª ØªØ¨Ø¯ÛŒÙ„ÛŒØ§Úº Ú¯Ú¾Ù†Ù¹Û’ Ú©Û’ Ù„Ø¦Û’ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(594572,16457,'ur','Ù†Ø§Ø¨ÛŒÙ†Ø§ Ø¬ÛØ§Ø²',0),(594573,16458,'ur','ÛŒÛ Ø¨ÛŒÙ†Ú© ÚˆÙ¾Ø§Ø²Ù¹ Ø¨ÛŒÙ†Ú© Ú©Û’ Ø§ÛŒÚ© Ø¨ÛŒØ§Ù† Ù¾Ø± ØµÙØ§ÛŒØ§ ÛÙˆ Ú†Ú©Ø§ ÛÛ’',0),(594574,16459,'ur','ØµØ±Ù AP Ú†ÛŒÚ© ØªØ¯ÙˆÛŒÙ† Ù†ÛÛŒÚº Ú©ÛŒ Ø¬Ø§ Ø³Ú©ØªÛŒ',0),(594575,16460,'ur','Ø®ÙˆØ¯ Ù…Ù†ØªØ®Ø¨',0),(594576,16461,'ur','ÛŒÛ Ø¬Ù…Ø¹ Ø§ÛŒÚ© Ø¨ÛŒÙ†Ú© Ú©ÛŒ Ù…ÙØ§ÛÙ…Øª Ú©Û’ Ù…ÛÛŒÙ†Û’ Ù…ÛŒÚº Ø´Ø§Ù…Ù„ Ú©ÛŒØ§ Ú¯ÛŒØ§',0),(594577,16462,'ur','Ø¢Ù¾ ÛŒÛ Ø¨ÛŒÙ†Ú© Ù…ÙØ§ÛÙ…Øª ØµÙØ­Û Ø³Û’ Ú©ÛŒ ØªØ¯ÙˆÛŒÙ† Ú©Û’ Ù„ÛŒÛ’ Ø¨Û’ Ù†Ø´Ø§Ù† Ú©Ø±ÛŒÚº Ú©Ø±ÛŒÚº',0),(594578,16463,'ur','Ù…Ø±Ø¶ÛŒ Ú©Û’ Ø³Ø¨Ø¨ Ø§Ù† Ø§Ø´ÛŒØ§Ø¡ Ø³Û’ ØºÛŒØ± Ù…Ø±Ø¨ÙˆØ· Ø¨Ù†Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ø¨ Ø¬Ø§Ø±ÛŒ',0),(594579,16464,'ur','Ø­Ø°Ù Ø´Ø¯Û Ø±ÛŒÚ©Ø§Ø±Úˆ',0),(594580,16465,'ur','Ú¯ÙˆØ¯Ø§Ù… Ø¨Ù†',0),(594581,16466,'ur','Ú¯ÙˆØ¯Ø§Ù… Ø¨Ù† Ø§Ø³ Ø¶Ø§Ø¨Ø·Û Ø§Ø®Ù„Ø§Ù‚ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(594582,16467,'ur','Ú¯ÙˆØ¯Ø§Ù… Ø¨Ù† Ú©ÙˆÚˆ Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(594583,16468,'ur','Ú¯ÙˆØ¯Ø§Ù… Ø²ÙˆÙ†',0),(594584,16469,'ur','Ø§Ø³ Ù…Ù†Ø·Ù‚Û Ø³Û’ ØºÛŒØ± Ù…Ø±Ø¨ÙˆØ· Ø¨Ù†Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø¯Ø±Ø¬ Ø°ÛŒÙ„ Ø¨ Ù…Ø±Ø¶ÛŒ Ú©Û’ Ø³Ø¨Ø¨ Ø¬Ø§Ø±ÛŒ',0),(594585,16470,'ur','Ú¯ÙˆØ¯Ø§Ù… Ø²ÙˆÙ† Ø§Ø³ Ø¶Ø§Ø¨Ø·Û Ø§Ø®Ù„Ø§Ù‚ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(594586,16471,'ur','Ú¯ÙˆØ¯Ø§Ù… Ø²ÙˆÙ† Ú©ÙˆÚˆ Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(594587,16472,'ur','Ø´Ø±ÙˆØ¹ Ø§ÙˆØ± Ø§Ø®ØªØªØ§Ù… ØªØ§Ø±ÛŒØ® Ù…ØªØ¹ÛŒÙ† ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(594588,16473,'ur','Ú©ÙˆØ¦ÛŒ Ø·Û’ Ø´Ø¯Û Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ø³ÛŒÙ¹ Ú©Ø±ÛŒÚº',0),(594589,16474,'ur','Ú©ÙˆØ¦ÛŒ Ø·Û’ Ø´Ø¯Û Ù‚ÛŒÙ…Øª Ø³Ø·Ø­ Ø³ÛŒÙ¹',0),(594590,16475,'ur','Ù‚ÛŒÙ…ØªÙˆÚº Ú©Ø§ ØªØ¹ÛŒÙ† Ø®Ø§Øµ Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(594591,16476,'ur','Ø³Ù¹ÛŒÙ†ÚˆØ±Úˆ Ù‚ÛŒÙ…Øª',0),(594592,16477,'ur','Ø§Ù†Ú©ÙˆØ§Ø¦Ø±ÛŒ',0),(594593,16478,'ur','Ø§Ù†Ù¹Ø±Ø¨Ø±Ø§Ù†Ú† Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(594594,16479,'ur','Ù¾ÙˆØ²ÛŒØ´Ù† ÙØ±ÙˆØ®Øª Û”',0),(594595,16480,'ur','Ø³ÛŒÙ„Ø² Ø§Ù†ÙˆØ§Ø¦Ø³',0),(594596,16481,'ur','Ø³ÛŒÙ„Ø² Ø§Ù‚ØªØ¨Ø§Ø³',0),(594597,16482,'ur','Ú¯ÙˆØ¯Ø§Ù… Ø¨',0),(594598,16483,'ur','Ú¯ÙˆØ¯Ø§Ù… Ø²ÙˆÙ†',0),(594599,16484,'ur','ÙÙ†Úˆ Ú©Û’ Ù†Ø§Ù…',0),(594600,16485,'ur','Ø¨Ù† Ú©Û’ Ù…Ù‚Ø§Ù…Ø§Øª',0),(594601,16486,'ur','Ø§Ø³ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ú©Û’ Ù„ÛŒÛ’ Ú©ÙˆØ¦ÛŒ Ø¨ Ø§Ù¾Ù†Ø§Ù†Û’ Ø§ÙˆÛŒØ¨Ù„ÛŒ',0),(594602,16487,'ur','Ø¨Ù†ÛŒØ§Ø¯ÛŒ Ø¨Ù†',0),(594603,16488,'ur','Ù…Ù„Ø§Ø²Ù…Øª Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(594604,16489,'ur','Ø¬Ø§Ø¨ Ø®Ù„Ø§ØµÛ',0),(594605,16490,'ur','Ø¢Ø³Ù…Ø§Ù† Ø³Û’ ÚˆÚ¾Ù„ Ù…Ø´Ù‚Øª',0),(594606,16491,'ur','Ù…Ø²Ø¯ÙˆØ± ÙˆÙ‚Øª',0),(594607,16492,'ur','Ø°Ø±Ø§Ø¦Ø¹',0),(594608,16493,'ur','Ù„ÛŒØ¨Ø± Ú©Û’ Ú©Ù„ Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(594609,16494,'ur','Ú©Ù„ ÙˆÛŒÙ†ÚˆØ± Ø§Ø®Ø±Ø§Ø¬Ø§Øª',0),(594610,16495,'ur','ÙˆÛŒÙ†ÚˆØ± Ø¨Ù„ Ú©ÛŒ Ø§Ø¯Ø§Ø¦ÛŒÚ¯ÛŒ',0),(594611,16496,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ø¹Ù„Ø§ÙˆÛ Ù†ÙˆÙ†ØªÚ¯Ø²ÛŒØ¨Ù„ÛŒ',0),(594612,16497,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ø¹Ù„Ø§ÙˆÛ ÛØ± Ø³Ø§Ù„ Ù†ÙˆÙ†ØªÚ¯Ø²ÛŒØ¨Ù„ÛŒ',0),(594613,16498,'ur','Ø´ÛØ± Ú©ÛŒ Ø§Ø¬Ø±Øª',0),(594614,16499,'ur','ØªÙ†Ú¯ Ø¢ Ú¯ÛŒØ§ Ø§Ø¬Ø±Øª',0),(594615,16500,'ur','Ù…Ø¬Ù…ÙˆØ¹ÛŒ ØªÙ†Ø®ÙˆØ§Û Ú©Û’ Ø°Ø±ÛŒØ¹Û’',0),(594616,16501,'ur','Ø±ÛŒØ§Ø³Øª Ø±ÙˆÚ©Ø§ Ø¬Ø§ØªØ§',0),(594617,16502,'ur','Ù¹ÛŒÚ©Ø³ ØªÙ†Ø®ÙˆØ§Û',0),(594618,16420,'vi','Kiá»ƒm tra thÃ´ng tin',0),(594619,16421,'vi','Kiá»ƒm tra khÃ´ng Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(594620,16422,'vi','PhÃ²ng lÆ°u',0),(594621,16423,'vi','Chá»‰nh sá»­a phÃ²ng',0),(594622,16424,'vi','Lá»—i khi lÆ°u phÃ²ng',0),(594623,16425,'vi','AP chá»‰ kiá»ƒm tra cÃ³ thá»ƒ Ä‘Æ°á»£c chá»‰nh sá»­a',0),(594624,16426,'vi','Äá»ƒ chá»‰nh sá»­a cÃ¡c kiá»ƒm tra nÃ y, báº¡n pháº£i máº¥t hiá»‡u lá»±c vÃ  tÃ¡i táº¡o',0),(594625,16427,'vi','# TÃ i khoáº£n',0),(594626,16428,'vi','Balance Sheet - phÃ¢n loáº¡i',0),(594627,16429,'vi','KhÃ´ng cÃ³ nhÃ³m',0),(594628,16430,'vi','Subtotal bá»Ÿi',0),(594629,16431,'vi','Unassigned',0),(594630,16432,'vi','Chi phÃ­ báº£n tÃ³m táº¯t',0),(594631,16433,'vi','NhÃ  cung cáº¥p giáº¥y chá»©ng nháº­n háº¿t háº¡n',0),(594632,16434,'vi','TÃªn chá»©ng chá»‰',0),(594633,16435,'vi','Giáº¥y chá»©ng nháº­n loáº¡i',0),(594634,16436,'vi','Hiá»ƒn thá»‹ cÃ¡c giáº¥y chá»©ng nháº­n háº¿t háº¡n trÆ°á»›c khi',0),(594635,16437,'vi','Sá»‘ dÆ° cÃ²n láº¡i',0),(594636,16438,'vi','LiÃªn káº¿t táº£i vá» trá»±c tiáº¿p',0),(594637,16439,'vi','Táº£i vá» cá»§a báº¡n sáº½ báº¯t Ä‘áº§u trong giÃ¢y lÃ¡t.',0),(594638,16440,'vi','Sá»‘ lÆ°á»£ng máº·c Ä‘á»‹nh Ä‘Ã£ nháº­n Ä‘Æ°á»£c 0',0),(594639,16441,'vi','áº¨n há»™p kiá»ƒm Endorser',0),(594640,16442,'vi','Máº·c Ä‘á»‹nh sá»‘ lÆ°á»£ng váº­n chuyá»ƒn báº±ng khÃ´ng',0),(594641,16443,'vi','Chá»‰nh sá»­a khÃ´ng thÃ nh cÃ´ng',0),(594642,16444,'vi','Má»™t lÃ´ hÃ ng má»›i Ä‘Æ°á»£c táº¡o ra sau khi báº¡n Ä‘Ã£ chá»n Ä‘á»ƒ tÃ u',0),(594643,16445,'vi','Dá»¯ liá»‡u cÃ³ thá»ƒ tÄƒng gáº¥p Ä‘Ã´i trÃ¬nh ngÄƒn cháº·n',0),(594644,16446,'vi','Xá»­ lÃ½ lÃ´ hÃ ng bá»‹ há»§y bá»',0),(594645,16447,'vi','Giao hÃ ng Æ°á»›c tÃ­nh',0),(594646,16448,'vi','Phiáº¿u Ä‘Ã£ Ä‘Æ°á»£c Ä‘Äƒng',0),(594647,16449,'vi','Trá»£ cáº¥p lÃ  trong má»™t khoáº£ng thá»i gian Ä‘Ã³ng',0),(594648,16450,'vi','CÃ¢n báº±ng',0),(594649,16451,'vi','Thá»±c thá»ƒ',0),(594650,16452,'vi','Viá»‡c lÃ m chi phÃ­ báº£n tÃ³m táº¯t',0),(594651,16453,'vi','Vui lÃ²ng chá»n má»™t cÃ´ng viá»‡c',0),(594652,16454,'vi','Thanh toÃ¡n T',0),(594653,16455,'vi','Dá»¯ liá»‡u Cáº­p Nháº­t thÃ nh cÃ´ng',0),(594654,16456,'vi','Tiáº¿t kiá»‡m chi phÃ­ mÃ£ & cÃ´ng viá»‡c thay Ä‘á»•i giá»',0),(594655,16457,'vi','MÃ¹ tÃ u',0),(594656,16458,'vi','Tiá»n gá»­i ngÃ¢n hÃ ng nÃ y Ä‘Ã£ bá»‹ xÃ³a trÃªn báº£ng sao kÃª ngÃ¢n hÃ ng',0),(594657,16459,'vi','AP chá»‰ kiá»ƒm tra cÃ³ thá»ƒ Ä‘Æ°á»£c chá»‰nh sá»­a',0),(594658,16460,'vi','Tá»± Ä‘á»™ng chá»n',0),(594659,16461,'vi','Cá»c nÃ y Ä‘Ã£ Ä‘Æ°á»£c bao gá»“m trong má»™t thÃ¡ng hÃ²a giáº£i ngÃ¢n hÃ ng',0),(594660,16462,'vi','Báº¡n pháº£i bá» chá»n nÃ³ tá»« trang hÃ²a giáº£i ngÃ¢n hÃ ng Ä‘á»ƒ chá»‰nh sá»­a',0),(594661,16463,'vi','Tiáº¿p tá»¥c sáº½ gÃ¢y ra cÃ¡c thÃ¹ng sau trá»Ÿ thÃ nh bá» liÃªn káº¿t tá»« cÃ¡c máº·t hÃ ng nÃ y',0),(594662,16464,'vi','Há»“ sÆ¡ Ä‘Ã£ bá»‹ xÃ³a',0),(594663,16465,'vi','Kho bÃ£i rÃ¡c',0),(594664,16466,'vi','Kho bÃ£i rÃ¡c cá»§a mÃ£ nÃ y Ä‘Ã£ tá»“n táº¡i',0),(594665,16467,'vi','Kho hÃ ng Bin mÃ£ pháº£i Ä‘Æ°á»£c Ä‘áº·t',0),(594666,16468,'vi','Khu vá»±c nhÃ  kho',0),(594667,16469,'vi','Tiáº¿p tá»¥c sáº½ gÃ¢y ra cÃ¡c thÃ¹ng sau trá»Ÿ thÃ nh bá» liÃªn káº¿t tá»« vÃ¹ng nÃ y',0),(594668,16470,'vi','Khu nhÃ  kho báº±ng mÃ£ nÃ y Ä‘Ã£ tá»“n táº¡i',0),(594669,16471,'vi','Khu vá»±c nhÃ  kho mÃ£ pháº£i Ä‘Æ°á»£c Ä‘áº·t',0),(594670,16472,'vi','Báº¯t Ä‘áº§u vÃ  ngÃ y káº¿t thÃºc pháº£i Ä‘Æ°á»£c thiáº¿t láº­p',0),(594671,16473,'vi','KhÃ´ng cÃ³ thiáº¿t láº­p vá»‹ trÃ­ máº·c Ä‘á»‹nh',0),(594672,16474,'vi','KhÃ´ng cÃ³ thiáº¿t láº­p má»©c giÃ¡ máº·c Ä‘á»‹nh',0),(594673,16475,'vi','BÃ¡n hÃ ng Ä‘áº·c biá»‡t giÃ¡ cáº£',0),(594674,16476,'vi','GiÃ¡ tiÃªu chuáº©n',0),(594675,16477,'vi','YÃªu cáº§u',0),(594676,16478,'vi','Chuyá»ƒn interbranch',0),(594677,16479,'vi','BÃ¡n hÃ ng POS',0),(594678,16480,'vi','HoÃ¡ Ä‘Æ¡n bÃ¡n hÃ ng',0),(594679,16481,'vi','BÃ¡n hÃ ng bÃ¡o',0),(594680,16482,'vi','Kho thÃ¹ng',0),(594681,16483,'vi','Khu vá»±c nhÃ  kho',0),(594682,16484,'vi','Quá»¹ tÃªn',0),(594683,16485,'vi','Vá»‹ trÃ­ bin',0),(594684,16486,'vi','KhÃ´ng cÃ³ lÃ½ thÃ¹ng cho vá»‹ trÃ­ nÃ y',0),(594685,16487,'vi','ChÃ­nh Bin',0),(594686,16488,'vi','Lá»‹ch sá»­ cÃ´ng viá»‡c',0),(594687,16489,'vi','TÃ³m táº¯t cÃ´ng viá»‡c',0),(594688,16490,'vi','Lao Ä‘á»™ng trÃªn khÃ´ng',0),(594689,16491,'vi','Thá»i gian lao Ä‘á»™ng',0),(594690,16492,'vi','Nguá»“n',0),(594691,16493,'vi','Tá»•ng sá»‘ chi phÃ­ lao Ä‘á»™ng',0),(594692,16494,'vi','NhÃ  cung cáº¥p tá»•ng chi phÃ­',0),(594693,16495,'vi','NhÃ  bÃ¡n hÃ³a Ä‘Æ¡n thanh toÃ¡n',0),(594694,16496,'vi','Pháº£i tráº£ tá»•ng cá»™ng Nontaxable',0),(594695,16497,'vi','Pháº£i tráº£ tá»•ng cá»™ng thÃªm Nontaxable má»—i nÄƒm',0),(594696,16498,'vi','ThÃ nh phá»‘ lÆ°Æ¡ng',0),(594697,16499,'vi','Ä‚n lÆ°Æ¡ng',0),(594698,16500,'vi','Tá»•ng thanh toÃ¡n qua',0),(594699,16501,'vi','NhÃ  nÆ°á»›c giá»¯ láº¡i',0),(594700,16502,'vi','Thuáº¿ lÆ°Æ¡ng',0),(594701,16677,'en','0 For No Max',0),(594702,16678,'en','0 For No Min',0),(594703,16666,'en','13th Period Entries',0),(594704,16663,'en','13th Period Entry',0),(594705,16524,'en','Accepted Date',0),(594706,16552,'en','Account Type Wrong',0),(594707,16606,'en','Add/Edit',0),(594708,16540,'en','Add/Edit County',0),(594709,16583,'en','Add New County',0),(594710,16525,'en','Adjustment Type',0),(594711,16638,'en','Allow Back Order Only From Distribution Centers',0),(594712,16599,'en','Alternate Phone',0),(594713,16567,'en','Appointments Booked',0),(594714,16568,'en','Appointments Open',0),(594715,16569,'en','Appointments Today',0),(594716,16570,'en','Appointments Total',0),(594717,16571,'en','Appointment Length',0),(594718,16572,'en','Appointment List For',0),(594719,16573,'en','Appointment Location',0),(594720,16574,'en','Appointment Name',0),(594721,16541,'en','Appointment Scheduler',0),(594722,16575,'en','Appointment Summary',0),(594723,16657,'en','Archive & Save',0),(594724,16588,'en','Are You Sure You Want To Delete This County?',0),(594725,16621,'en','Are You Sure You Want To Update Your Sales Tax Records?',0),(594726,16526,'en','Assigned',0),(594727,16527,'en','Assigned Date',0),(594728,16639,'en','Automatically Select Sales Tax From Ship To On Fulfillment And POS Orders',0),(594729,16636,'en','Auto Select Sales Tax From Ship To',0),(594730,16679,'en','Avg Qty Per Month',0),(594731,16607,'en','Avg Sales Per Month',0),(594732,16576,'en','B2B Appointment Scheduler',0),(594733,16652,'en','B2B User Login',0),(594734,16696,'en','Back Order',0),(594735,16562,'en','Bank Routing Number',0),(594736,16565,'en','Blank',0),(594737,16697,'en','Cannot Change This Order To Drop Ship',0),(594738,16507,'en','Cannot Read File',0),(594739,16503,'en','Cannot Read Record',0),(594740,16654,'en','Cannot Save As Order Complete',0),(594741,16615,'en','Cities Added',0),(594742,16616,'en','Cities Updated',0),(594743,16622,'en','City Name',0),(594744,16623,'en','City Sales Tax Multiplier',0),(594745,16624,'en','City Use Tax Multiplier',0),(594746,16658,'en','Closed By Cost Code',0),(594747,16659,'en','Closed By GL Category',0),(594748,16660,'en','Close Accounts By Cost Code',0),(594749,16661,'en','Close Accounts By GL Category',0),(594750,16591,'en','Consider Adding A New County',0),(594751,16504,'en','Could Not Be Added',0),(594752,16505,'en','Could Not Be Updated',0),(594753,16528,'en','Counted',0),(594754,16617,'en','Counties Added',0),(594755,16618,'en','Counties Updated',0),(594756,16584,'en','County Name',0),(594757,16625,'en','County Sales Tax Multiplier',0),(594758,16626,'en','County Use Tax Multiplier',0),(594759,16542,'en','Count Management',0),(594760,16553,'en','Count Not Find Account By Name',0),(594761,16554,'en','Count Not Find Checking Account By Name',0),(594762,16555,'en','Count Not Find Shipping Method By Name',0),(594763,16529,'en','Count Type',0),(594764,16680,'en','Created Purchase Order',0),(594765,16577,'en','Create Appointment Openings',0),(594766,16681,'en','Create Purchase Order',0),(594767,16515,'en','Create Transfer',0),(594768,16600,'en','CSV Import File',0),(594769,16698,'en','Current Location',0),(594770,16608,'en','Current Supply',0),(594771,16595,'en','Customers Added',0),(594772,16596,'en','Customers Skipped',0),(594773,16597,'en','Customers Updated',0),(594774,16543,'en','Customer Info Import',0),(594775,16508,'en','Custom Fields Add-on Required',0),(594776,16530,'en','Date Assigned',0),(594777,16662,'en','Date Canceled',0),(594778,16516,'en','Default Intercompany Transfer Offset Account Must Be Set',0),(594779,16563,'en','Default Pay Method',0),(594780,16589,'en','Delete County',0),(594781,16578,'en','Delete Open Appointment',0),(594782,16709,'en','Distribution Center',0),(594783,16682,'en','Distribution Centers',0),(594784,16644,'en','Distribution Center Num Months Sales For Reorder Calculation',0),(594785,16656,'en','Drop Ship',0),(594786,16592,'en','Edit County',0),(594787,16590,'en','Edit Custom County',0),(594788,16631,'en','Existing Data',0),(594789,16640,'en','Final Drop Shipment Requires POD',0),(594790,16506,'en','Form Incomplete',0),(594791,16509,'en','Freight Burden',0),(594792,16510,'en','Freight Burden',0),(594793,16705,'en','If County Not On List',0),(594794,16544,'en','Import Salesman Territories',0),(594795,16545,'en','Import Sales Tax',0),(594796,16546,'en','Import Vendor Order Froms',0),(594797,16511,'en','Include Year End Adjusting Entries',0),(594798,16645,'en','Interbranch Transfer Burden Percentage GL Account',0),(594799,16646,'en','Intercompany Item Transfers - Allow Multiple Locations',0),(594800,16647,'en','Intercompany Item Transfers - Posting',0),(594801,16517,'en','Intercompany Item Transfer - Print',0),(594802,16547,'en','Intercompany Transfer Freight Burden',0),(594803,16512,'en','Inventory Adjustment Request Type',0),(594804,16513,'en','Inventory Adjustment Request Type By This Code Already Exists',0),(594805,16514,'en','Inventory Adjustment Request Type Code Must Be Set',0),(594806,16548,'en','Inventory Adjustment Request Types',0),(594807,16518,'en','Inventory GL Account Must Be Assigned On Item Or Default Account Assigned In Inventory Setup',0),(594808,16648,'en','Inventory In Transit GL Account',0),(594809,16683,'en','Inventory Locations',0),(594810,16690,'en','Is Default Item Vendor?',0),(594811,16710,'en','Is Distribution Center?',0),(594812,16531,'en','Items Counted',0),(594813,16632,'en','Keep Existing Data',0),(594814,16532,'en','Last Updated By',0),(594815,16598,'en','Lines Read',0),(594816,16653,'en','Log In As This User',0),(594817,16556,'en','Matches Muliple Vendors',0),(594818,16684,'en','Max On Hand',0),(594819,16685,'en','Min On Hand',0),(594820,16601,'en','Mobile Phone Carrier',0),(594821,16602,'en','Mobile Phone Number',0),(594822,16686,'en','My Vendors',0),(594823,16549,'en','New Stock Check Request',0),(594824,16579,'en','Next Future Appointment',0),(594825,16649,'en','Non-Distribution Center Num Months Sales For Reorder Calculation',0),(594826,16669,'en','Non-Stock',0),(594827,16674,'en','Non-Stocked',0),(594828,16655,'en','No POD File Attached To Order',0),(594829,16609,'en','No Primary Bin Assigned',0),(594830,16566,'en','No Type Set',0),(594831,16691,'en','Number Of Days',0),(594832,16687,'en','Num Months Sales For Maximum On Hand',0),(594833,16688,'en','Num Months Sales For Minimum On Hand',0),(594834,16519,'en','Num Months Sales For Reorder Qty',0),(594835,16689,'en','Num Months Sales For Reorder Quantity',0),(594836,16520,'en','Num Months To Replenish',0),(594837,16637,'en','On Fulfillment And POS Orders',0),(594838,16699,'en','Order Has Shipments Of Non-Drop Ship Items',0),(594839,16700,'en','Order Quantity Not Available At Location',0),(594840,16670,'en','Other Charge',0),(594841,16671,'en','Other Charges',0),(594842,16585,'en','Parent State',0),(594843,16642,'en','Partial Tax Exemption',0),(594844,16635,'en','Pending Vendor Credits',0),(594845,16533,'en','Percent Counted',0),(594846,16580,'en','Pick A Date To View & Edit Appointments',0),(594847,16557,'en','Postal Code Or State Required',0),(594848,16650,'en','Post By Line',0),(594849,16651,'en','Post By Shipping And Receiving',0),(594850,16704,'en','Primary Buyer',0),(594851,16633,'en','Purge All Existing Data',0),(594852,16634,'en','Purge Existing Data For Vendors In Import',0),(594853,16610,'en','Qty On Transfer',0),(594854,16692,'en','Quote Lead Time',0),(594855,16701,'en','Reduce Order Quantity',0),(594856,16675,'en','Rental',0),(594857,16521,'en','Replenishment',0),(594858,16522,'en','Replenishment Transfers',0),(594859,16611,'en','Replenish Stock From Distribution Center',0),(594860,16534,'en','Request Type',0),(594861,16707,'en','Require Cost Codes If GL Account Has Cost Codes',0),(594862,16708,'en','Require GL Category If GL Account Has GL Categories',0),(594863,16695,'en','RTV Number',0),(594864,16558,'en','Salesman ID',0),(594865,16559,'en','Salesman ID Or Name Must Be Set',0),(594866,16627,'en','Sales Tax Import',0),(594867,16603,'en','Select Invoice Terms',0),(594868,16693,'en','Setting This Vendor As The Default For This Item Will Remove Any Other Default Vendors For This Item',0),(594869,16581,'en','Show Summary',0),(594870,16551,'en','Staging Area',0),(594871,16550,'en','Staging Areas',0),(594872,16619,'en','States Added',0),(594873,16620,'en','States Updated',0),(594874,16604,'en','State Abbreviation',0),(594875,16560,'en','State Code',0),(594876,16628,'en','State Sales Tax Multiplier',0),(594877,16629,'en','State Use Tax Multiplier',0),(594878,16676,'en','Stocked',0),(594879,16535,'en','Stock Check Request',0),(594880,16536,'en','Stock Check Requests',0),(594881,16537,'en','Stock Check Request Status',0),(594882,16605,'en','Street Address',0),(594883,16612,'en','Suggested',0),(594884,16641,'en','Suggest Alternative Purchase Locations When Qty Not Available',0),(594885,16667,'en','Tax Adjusting Entries',0),(594886,16664,'en','Tax Adjusting Entry',0),(594887,16643,'en','Tax Rate Percent',0),(594888,16702,'en','The Following Non-Drop Ship Items To Be Removed',0),(594889,16630,'en','Thomson Reuters Tab File',0),(594890,16672,'en','Transfer Between Locations',0),(594891,16673,'en','Transfer Details',0),(594892,16613,'en','Transfer Qty',0),(594893,16523,'en','Transfer Saved',0),(594894,16582,'en','Unbook Appointment',0),(594895,16706,'en','Update Action',0),(594896,16538,'en','Variance Value Amt',0),(594897,16539,'en','Variance Value Percent',0),(594898,16564,'en','Vendor Code Must Be Set',0),(594899,16561,'en','Vendor Company Name Or Last Name Must Be Set',0),(594900,16694,'en','Vendor UPC',0),(594901,16703,'en','Voucher ID',0),(594902,16668,'en','With Year End Adjusting Entries',0),(594903,16665,'en','Year End Adjusting Entry',0),(594904,16593,'en','Your Selection Is A System Value And Cannot Be Changed',0),(594905,16594,'en','You Must Complete The Form To Continue',0),(594906,16586,'en','You Must Enter A County Name',0),(594907,16587,'en','You Must Select A State',0),(594908,16614,'en','Zone',0),(594909,16711,'en','Checked In',0),(594910,16712,'en','Check In',0),(594911,16713,'en','Check In Now',0),(594912,16714,'en','Check In Time',0),(594913,16715,'en','Save Notes',0),(594914,16716,'en','Update Notes',0),(595025,16503,'af','0',0),(595026,16504,'af','0',0),(595027,16505,'af','0',0),(595028,16506,'af','0',0),(595029,16507,'af','0',0),(595030,16508,'af','0',0),(595031,16509,'af','0',0),(595032,16510,'af','0',0),(595033,16511,'af','0',0),(595034,16512,'af','0',0),(595035,16513,'af','0',0),(595036,16514,'af','0',0),(595037,16515,'af','0',0),(595038,16516,'af','0',0),(595039,16517,'af','0',0),(595040,16518,'af','0',0),(595041,16519,'af','0',0),(595042,16520,'af','0',0),(595043,16521,'af','0',0),(595044,16522,'af','0',0),(595045,16523,'af','0',0),(595046,16524,'af','0',0),(595047,16525,'af','0',0),(595048,16526,'af','0',0),(595049,16527,'af','0',0),(595050,16528,'af','0',0),(595051,16529,'af','0',0),(595052,16530,'af','0',0),(595053,16531,'af','0',0),(595054,16532,'af','0',0),(595055,16533,'af','0',0),(595056,16534,'af','0',0),(595057,16535,'af','0',0),(595058,16536,'af','0',0),(595059,16537,'af','0',0),(595060,16538,'af','0',0),(595061,16539,'af','0',0),(595062,16540,'af','0',0),(595063,16541,'af','0',0),(595064,16542,'af','0',0),(595065,16543,'af','0',0),(595066,16544,'af','0',0),(595067,16545,'af','0',0),(595068,16546,'af','0',0),(595069,16547,'af','0',0),(595070,16548,'af','0',0),(595071,16549,'af','0',0),(595072,16550,'af','0',0),(595073,16551,'af','0',0),(595074,16552,'af','0',0),(595075,16553,'af','0',0),(595076,16554,'af','0',0),(595077,16555,'af','0',0),(595078,16556,'af','0',0),(595079,16557,'af','0',0),(595080,16558,'af','0',0),(595081,16559,'af','0',0),(595082,16560,'af','0',0),(595083,16561,'af','0',0),(595084,16562,'af','0',0),(595085,16563,'af','0',0),(595086,16564,'af','0',0),(595087,16565,'af','0',0),(595088,16566,'af','0',0),(595089,16567,'af','0',0),(595090,16568,'af','0',0),(595091,16569,'af','0',0),(595092,16570,'af','0',0),(595093,16571,'af','0',0),(595094,16572,'af','0',0),(595095,16573,'af','0',0),(595096,16574,'af','0',0),(595097,16575,'af','0',0),(595098,16576,'af','0',0),(595099,16577,'af','0',0),(595100,16578,'af','0',0),(595101,16579,'af','0',0),(595102,16580,'af','0',0),(595103,16581,'af','0',0),(595104,16582,'af','0',0),(595105,16583,'af','0',0),(595106,16584,'af','0',0),(595107,16585,'af','0',0),(595108,16586,'af','0',0),(595109,16587,'af','0',0),(595110,16588,'af','0',0),(595111,16589,'af','0',0),(595112,16590,'af','0',0),(595113,16591,'af','0',0),(595114,16592,'af','0',0),(595115,16593,'af','0',0),(595116,16594,'af','0',0),(595117,16595,'af','0',0),(595118,16596,'af','0',0),(595119,16597,'af','0',0),(595120,16598,'af','0',0),(595121,16599,'af','0',0),(595122,16600,'af','0',0),(595123,16601,'af','0',0),(595124,16602,'af','0',0),(595125,16603,'af','0',0),(595126,16604,'af','0',0),(595127,16605,'af','0',0),(595128,16606,'af','0',0),(595129,16607,'af','0',0),(595130,16608,'af','0',0),(595131,16609,'af','0',0),(595132,16610,'af','0',0),(595133,16611,'af','0',0),(595134,16612,'af','0',0),(595135,16613,'af','0',0),(595136,16614,'af','0',0),(595137,16615,'af','0',0),(595138,16616,'af','0',0),(595139,16617,'af','0',0),(595140,16618,'af','0',0),(595141,16619,'af','0',0),(595142,16620,'af','0',0),(595143,16621,'af','0',0),(595144,16622,'af','0',0),(595145,16623,'af','0',0),(595146,16624,'af','0',0),(595147,16625,'af','0',0),(595148,16626,'af','0',0),(595149,16627,'af','0',0),(595150,16628,'af','0',0),(595151,16629,'af','0',0),(595152,16630,'af','0',0),(595153,16631,'af','0',0),(595154,16632,'af','0',0),(595155,16633,'af','0',0),(595156,16634,'af','0',0),(595157,16635,'af','0',0),(595158,16636,'af','0',0),(595159,16637,'af','0',0),(595160,16638,'af','0',0),(595161,16639,'af','0',0),(595162,16640,'af','0',0),(595163,16641,'af','0',0),(595164,16642,'af','0',0),(595165,16643,'af','0',0),(595166,16644,'af','0',0),(595167,16645,'af','0',0),(595168,16646,'af','0',0),(595169,16647,'af','0',0),(595170,16648,'af','0',0),(595171,16649,'af','0',0),(595172,16650,'af','0',0),(595173,16651,'af','0',0),(595174,16652,'af','0',0),(595175,16653,'af','0',0),(595176,16654,'af','0',0),(595177,16655,'af','0',0),(595178,16656,'af','0',0),(595179,16657,'af','0',0),(595180,16658,'af','0',0),(595181,16659,'af','0',0),(595182,16660,'af','0',0),(595183,16661,'af','0',0),(595184,16662,'af','0',0),(595185,16663,'af','0',0),(595186,16664,'af','0',0),(595187,16665,'af','0',0),(595188,16666,'af','0',0),(595189,16667,'af','0',0),(595190,16668,'af','0',0),(595191,16669,'af','0',0),(595192,16670,'af','0',0),(595193,16671,'af','0',0),(595194,16672,'af','0',0),(595195,16673,'af','0',0),(595196,16674,'af','0',0),(595197,16675,'af','0',0),(595198,16676,'af','0',0),(595199,16677,'af','0',0),(595200,16678,'af','0',0),(595201,16679,'af','0',0),(595202,16680,'af','0',0),(595203,16681,'af','0',0),(595204,16682,'af','0',0),(595205,16683,'af','0',0),(595206,16684,'af','0',0),(595207,16685,'af','0',0),(595208,16686,'af','0',0),(595209,16687,'af','0',0),(595210,16688,'af','0',0),(595211,16689,'af','0',0),(595212,16690,'af','0',0),(595213,16691,'af','0',0),(595214,16692,'af','0',0),(595215,16693,'af','0',0),(595216,16694,'af','0',0),(595217,16695,'af','0',0),(595218,16696,'af','0',0),(595219,16697,'af','0',0),(595220,16698,'af','0',0),(595221,16699,'af','0',0),(595222,16700,'af','0',0),(595223,16701,'af','0',0),(595224,16702,'af','0',0),(595225,16703,'af','0',0),(595226,16704,'af','0',0),(595227,16705,'af','0',0),(595228,16706,'af','0',0),(595229,16707,'af','0',0),(595230,16708,'af','0',0),(595231,16709,'af','0',0),(595232,16710,'af','0',0),(595233,16711,'af','0',0),(595234,16712,'af','0',0),(595235,16713,'af','0',0),(595236,16714,'af','0',0),(595237,16715,'af','0',0),(595238,16716,'af','0',0),(595239,16503,'ar','0',0),(595240,16504,'ar','0',0),(595241,16505,'ar','0',0),(595242,16506,'ar','0',0),(595243,16507,'ar','0',0),(595244,16508,'ar','0',0),(595245,16509,'ar','0',0),(595246,16510,'ar','0',0),(595247,16511,'ar','0',0),(595248,16512,'ar','0',0),(595249,16513,'ar','0',0),(595250,16514,'ar','0',0),(595251,16515,'ar','0',0),(595252,16516,'ar','0',0),(595253,16517,'ar','0',0),(595254,16518,'ar','0',0),(595255,16519,'ar','0',0),(595256,16520,'ar','0',0),(595257,16521,'ar','0',0),(595258,16522,'ar','0',0),(595259,16523,'ar','0',0),(595260,16524,'ar','0',0),(595261,16525,'ar','0',0),(595262,16526,'ar','0',0),(595263,16527,'ar','0',0),(595264,16528,'ar','0',0),(595265,16529,'ar','0',0),(595266,16530,'ar','0',0),(595267,16531,'ar','0',0),(595268,16532,'ar','0',0),(595269,16533,'ar','0',0),(595270,16534,'ar','0',0),(595271,16535,'ar','0',0),(595272,16536,'ar','0',0),(595273,16537,'ar','0',0),(595274,16538,'ar','0',0),(595275,16539,'ar','0',0),(595276,16540,'ar','0',0),(595277,16541,'ar','0',0),(595278,16542,'ar','0',0),(595279,16543,'ar','0',0),(595280,16544,'ar','0',0),(595281,16545,'ar','0',0),(595282,16546,'ar','0',0),(595283,16547,'ar','0',0),(595284,16548,'ar','0',0),(595285,16549,'ar','0',0),(595286,16550,'ar','0',0),(595287,16551,'ar','0',0),(595288,16552,'ar','0',0),(595289,16553,'ar','0',0),(595290,16554,'ar','0',0),(595291,16555,'ar','0',0),(595292,16556,'ar','0',0),(595293,16557,'ar','0',0),(595294,16558,'ar','0',0),(595295,16559,'ar','0',0),(595296,16560,'ar','0',0),(595297,16561,'ar','0',0),(595298,16562,'ar','0',0),(595299,16563,'ar','0',0),(595300,16564,'ar','0',0),(595301,16565,'ar','0',0),(595302,16566,'ar','0',0),(595303,16567,'ar','0',0),(595304,16568,'ar','0',0),(595305,16569,'ar','0',0),(595306,16570,'ar','0',0),(595307,16571,'ar','0',0),(595308,16572,'ar','0',0),(595309,16573,'ar','0',0),(595310,16574,'ar','0',0),(595311,16575,'ar','0',0),(595312,16576,'ar','0',0),(595313,16577,'ar','0',0),(595314,16578,'ar','0',0),(595315,16579,'ar','0',0),(595316,16580,'ar','0',0),(595317,16581,'ar','0',0),(595318,16582,'ar','0',0),(595319,16583,'ar','0',0),(595320,16584,'ar','0',0),(595321,16585,'ar','0',0),(595322,16586,'ar','0',0),(595323,16587,'ar','0',0),(595324,16588,'ar','0',0),(595325,16589,'ar','0',0),(595326,16590,'ar','0',0),(595327,16591,'ar','0',0),(595328,16592,'ar','0',0),(595329,16593,'ar','0',0),(595330,16594,'ar','0',0),(595331,16595,'ar','0',0),(595332,16596,'ar','0',0),(595333,16597,'ar','0',0),(595334,16598,'ar','0',0),(595335,16599,'ar','0',0),(595336,16600,'ar','0',0),(595337,16601,'ar','0',0),(595338,16602,'ar','0',0),(595339,16603,'ar','0',0),(595340,16604,'ar','0',0),(595341,16605,'ar','0',0),(595342,16606,'ar','0',0),(595343,16607,'ar','0',0),(595344,16608,'ar','0',0),(595345,16609,'ar','0',0),(595346,16610,'ar','0',0),(595347,16611,'ar','0',0),(595348,16612,'ar','0',0),(595349,16613,'ar','0',0),(595350,16614,'ar','0',0),(595351,16615,'ar','0',0),(595352,16616,'ar','0',0),(595353,16617,'ar','0',0),(595354,16618,'ar','0',0),(595355,16619,'ar','0',0),(595356,16620,'ar','0',0),(595357,16621,'ar','0',0),(595358,16622,'ar','0',0),(595359,16623,'ar','0',0),(595360,16624,'ar','0',0),(595361,16625,'ar','0',0),(595362,16626,'ar','0',0),(595363,16627,'ar','0',0),(595364,16628,'ar','0',0),(595365,16629,'ar','0',0),(595366,16630,'ar','0',0),(595367,16631,'ar','0',0),(595368,16632,'ar','0',0),(595369,16633,'ar','0',0),(595370,16634,'ar','0',0),(595371,16635,'ar','0',0),(595372,16636,'ar','0',0),(595373,16637,'ar','0',0),(595374,16638,'ar','0',0),(595375,16639,'ar','0',0),(595376,16640,'ar','0',0),(595377,16641,'ar','0',0),(595378,16642,'ar','0',0),(595379,16643,'ar','0',0),(595380,16644,'ar','0',0),(595381,16645,'ar','0',0),(595382,16646,'ar','0',0),(595383,16647,'ar','0',0),(595384,16648,'ar','0',0),(595385,16649,'ar','0',0),(595386,16650,'ar','0',0),(595387,16651,'ar','0',0),(595388,16652,'ar','0',0),(595389,16653,'ar','0',0),(595390,16654,'ar','0',0),(595391,16655,'ar','0',0),(595392,16656,'ar','0',0),(595393,16657,'ar','0',0),(595394,16658,'ar','0',0),(595395,16659,'ar','0',0),(595396,16660,'ar','0',0),(595397,16661,'ar','0',0),(595398,16662,'ar','0',0),(595399,16663,'ar','0',0),(595400,16664,'ar','0',0),(595401,16665,'ar','0',0),(595402,16666,'ar','0',0),(595403,16667,'ar','0',0),(595404,16668,'ar','0',0),(595405,16669,'ar','0',0),(595406,16670,'ar','0',0),(595407,16671,'ar','0',0),(595408,16672,'ar','0',0),(595409,16673,'ar','0',0),(595410,16674,'ar','0',0),(595411,16675,'ar','0',0),(595412,16676,'ar','0',0),(595413,16677,'ar','0',0),(595414,16678,'ar','0',0),(595415,16679,'ar','0',0),(595416,16680,'ar','0',0),(595417,16681,'ar','0',0),(595418,16682,'ar','0',0),(595419,16683,'ar','0',0),(595420,16684,'ar','0',0),(595421,16685,'ar','0',0),(595422,16686,'ar','0',0),(595423,16687,'ar','0',0),(595424,16688,'ar','0',0),(595425,16689,'ar','0',0),(595426,16690,'ar','0',0),(595427,16691,'ar','0',0),(595428,16692,'ar','0',0),(595429,16693,'ar','0',0),(595430,16694,'ar','0',0),(595431,16695,'ar','0',0),(595432,16696,'ar','0',0),(595433,16697,'ar','0',0),(595434,16698,'ar','0',0),(595435,16699,'ar','0',0),(595436,16700,'ar','0',0),(595437,16701,'ar','0',0),(595438,16702,'ar','0',0),(595439,16703,'ar','0',0),(595440,16704,'ar','0',0),(595441,16705,'ar','0',0),(595442,16706,'ar','0',0),(595443,16707,'ar','0',0),(595444,16708,'ar','0',0),(595445,16709,'ar','0',0),(595446,16710,'ar','0',0),(595447,16711,'ar','0',0),(595448,16712,'ar','0',0),(595449,16713,'ar','0',0),(595450,16714,'ar','0',0),(595451,16715,'ar','0',0),(595452,16716,'ar','0',0),(595453,16503,'bg','0',0),(595454,16504,'bg','0',0),(595455,16505,'bg','0',0),(595456,16506,'bg','0',0),(595457,16507,'bg','0',0),(595458,16508,'bg','0',0),(595459,16509,'bg','0',0),(595460,16510,'bg','0',0),(595461,16511,'bg','0',0),(595462,16512,'bg','0',0),(595463,16513,'bg','0',0),(595464,16514,'bg','0',0),(595465,16515,'bg','0',0),(595466,16516,'bg','0',0),(595467,16517,'bg','0',0),(595468,16518,'bg','0',0),(595469,16519,'bg','0',0),(595470,16520,'bg','0',0),(595471,16521,'bg','0',0),(595472,16522,'bg','0',0),(595473,16523,'bg','0',0),(595474,16524,'bg','0',0),(595475,16525,'bg','0',0),(595476,16526,'bg','0',0),(595477,16527,'bg','0',0),(595478,16528,'bg','0',0),(595479,16529,'bg','0',0),(595480,16530,'bg','0',0),(595481,16531,'bg','0',0),(595482,16532,'bg','0',0),(595483,16533,'bg','0',0),(595484,16534,'bg','0',0),(595485,16535,'bg','0',0),(595486,16536,'bg','0',0),(595487,16537,'bg','0',0),(595488,16538,'bg','0',0),(595489,16539,'bg','0',0),(595490,16540,'bg','0',0),(595491,16541,'bg','0',0),(595492,16542,'bg','0',0),(595493,16543,'bg','0',0),(595494,16544,'bg','0',0),(595495,16545,'bg','0',0),(595496,16546,'bg','0',0),(595497,16547,'bg','0',0),(595498,16548,'bg','0',0),(595499,16549,'bg','0',0),(595500,16550,'bg','0',0),(595501,16551,'bg','0',0),(595502,16552,'bg','0',0),(595503,16553,'bg','0',0),(595504,16554,'bg','0',0),(595505,16555,'bg','0',0),(595506,16556,'bg','0',0),(595507,16557,'bg','0',0),(595508,16558,'bg','0',0),(595509,16559,'bg','0',0),(595510,16560,'bg','0',0),(595511,16561,'bg','0',0),(595512,16562,'bg','0',0),(595513,16563,'bg','0',0),(595514,16564,'bg','0',0),(595515,16565,'bg','0',0),(595516,16566,'bg','0',0),(595517,16567,'bg','0',0),(595518,16568,'bg','0',0),(595519,16569,'bg','0',0),(595520,16570,'bg','0',0),(595521,16571,'bg','0',0),(595522,16572,'bg','0',0),(595523,16573,'bg','0',0),(595524,16574,'bg','0',0),(595525,16575,'bg','0',0),(595526,16576,'bg','0',0),(595527,16577,'bg','0',0),(595528,16578,'bg','0',0),(595529,16579,'bg','0',0),(595530,16580,'bg','0',0),(595531,16581,'bg','0',0),(595532,16582,'bg','0',0),(595533,16583,'bg','0',0),(595534,16584,'bg','0',0),(595535,16585,'bg','0',0),(595536,16586,'bg','0',0),(595537,16587,'bg','0',0),(595538,16588,'bg','0',0),(595539,16589,'bg','0',0),(595540,16590,'bg','0',0),(595541,16591,'bg','0',0),(595542,16592,'bg','0',0),(595543,16593,'bg','0',0),(595544,16594,'bg','0',0),(595545,16595,'bg','0',0),(595546,16596,'bg','0',0),(595547,16597,'bg','0',0),(595548,16598,'bg','0',0),(595549,16599,'bg','0',0),(595550,16600,'bg','0',0),(595551,16601,'bg','0',0),(595552,16602,'bg','0',0),(595553,16603,'bg','0',0),(595554,16604,'bg','0',0),(595555,16605,'bg','0',0),(595556,16606,'bg','0',0),(595557,16607,'bg','0',0),(595558,16608,'bg','0',0),(595559,16609,'bg','0',0),(595560,16610,'bg','0',0),(595561,16611,'bg','0',0),(595562,16612,'bg','0',0),(595563,16613,'bg','0',0),(595564,16614,'bg','0',0),(595565,16615,'bg','0',0),(595566,16616,'bg','0',0),(595567,16617,'bg','0',0),(595568,16618,'bg','0',0),(595569,16619,'bg','0',0),(595570,16620,'bg','0',0),(595571,16621,'bg','0',0),(595572,16622,'bg','0',0),(595573,16623,'bg','0',0),(595574,16624,'bg','0',0),(595575,16625,'bg','0',0),(595576,16626,'bg','0',0),(595577,16627,'bg','0',0),(595578,16628,'bg','0',0),(595579,16629,'bg','0',0),(595580,16630,'bg','0',0),(595581,16631,'bg','0',0),(595582,16632,'bg','0',0),(595583,16633,'bg','0',0),(595584,16634,'bg','0',0),(595585,16635,'bg','0',0),(595586,16636,'bg','0',0),(595587,16637,'bg','0',0),(595588,16638,'bg','0',0),(595589,16639,'bg','0',0),(595590,16640,'bg','0',0),(595591,16641,'bg','0',0),(595592,16642,'bg','0',0),(595593,16643,'bg','0',0),(595594,16644,'bg','0',0),(595595,16645,'bg','0',0),(595596,16646,'bg','0',0),(595597,16647,'bg','0',0),(595598,16648,'bg','0',0),(595599,16649,'bg','0',0),(595600,16650,'bg','0',0),(595601,16651,'bg','0',0),(595602,16652,'bg','0',0),(595603,16653,'bg','0',0),(595604,16654,'bg','0',0),(595605,16655,'bg','0',0),(595606,16656,'bg','0',0),(595607,16657,'bg','0',0),(595608,16658,'bg','0',0),(595609,16659,'bg','0',0),(595610,16660,'bg','0',0),(595611,16661,'bg','0',0),(595612,16662,'bg','0',0),(595613,16663,'bg','0',0),(595614,16664,'bg','0',0),(595615,16665,'bg','0',0),(595616,16666,'bg','0',0),(595617,16667,'bg','0',0),(595618,16668,'bg','0',0),(595619,16669,'bg','0',0),(595620,16670,'bg','0',0),(595621,16671,'bg','0',0),(595622,16672,'bg','0',0),(595623,16673,'bg','0',0),(595624,16674,'bg','0',0),(595625,16675,'bg','0',0),(595626,16676,'bg','0',0),(595627,16677,'bg','0',0),(595628,16678,'bg','0',0),(595629,16679,'bg','0',0),(595630,16680,'bg','0',0),(595631,16681,'bg','0',0),(595632,16682,'bg','0',0),(595633,16683,'bg','0',0),(595634,16684,'bg','0',0),(595635,16685,'bg','0',0),(595636,16686,'bg','0',0),(595637,16687,'bg','0',0),(595638,16688,'bg','0',0),(595639,16689,'bg','0',0),(595640,16690,'bg','0',0),(595641,16691,'bg','0',0),(595642,16692,'bg','0',0),(595643,16693,'bg','0',0),(595644,16694,'bg','0',0),(595645,16695,'bg','0',0),(595646,16696,'bg','0',0),(595647,16697,'bg','0',0),(595648,16698,'bg','0',0),(595649,16699,'bg','0',0),(595650,16700,'bg','0',0),(595651,16701,'bg','0',0),(595652,16702,'bg','0',0),(595653,16703,'bg','0',0),(595654,16704,'bg','0',0),(595655,16705,'bg','0',0),(595656,16706,'bg','0',0),(595657,16707,'bg','0',0),(595658,16708,'bg','0',0),(595659,16709,'bg','0',0),(595660,16710,'bg','0',0),(595661,16711,'bg','0',0),(595662,16712,'bg','0',0),(595663,16713,'bg','0',0),(595664,16714,'bg','0',0),(595665,16715,'bg','0',0),(595666,16716,'bg','0',0),(595667,16503,'zh','0',0),(595668,16504,'zh','0',0),(595669,16505,'zh','0',0),(595670,16506,'zh','0',0),(595671,16507,'zh','0',0),(595672,16508,'zh','0',0),(595673,16509,'zh','0',0),(595674,16510,'zh','0',0),(595675,16511,'zh','0',0),(595676,16512,'zh','0',0),(595677,16513,'zh','0',0),(595678,16514,'zh','0',0),(595679,16515,'zh','0',0),(595680,16516,'zh','0',0),(595681,16517,'zh','0',0),(595682,16518,'zh','0',0),(595683,16519,'zh','0',0),(595684,16520,'zh','0',0),(595685,16521,'zh','0',0),(595686,16522,'zh','0',0),(595687,16523,'zh','0',0),(595688,16524,'zh','0',0),(595689,16525,'zh','0',0),(595690,16526,'zh','0',0),(595691,16527,'zh','0',0),(595692,16528,'zh','0',0),(595693,16529,'zh','0',0),(595694,16530,'zh','0',0),(595695,16531,'zh','0',0),(595696,16532,'zh','0',0),(595697,16533,'zh','0',0),(595698,16534,'zh','0',0),(595699,16535,'zh','0',0),(595700,16536,'zh','0',0),(595701,16537,'zh','0',0),(595702,16538,'zh','0',0),(595703,16539,'zh','0',0),(595704,16540,'zh','0',0),(595705,16541,'zh','0',0),(595706,16542,'zh','0',0),(595707,16543,'zh','0',0),(595708,16544,'zh','0',0),(595709,16545,'zh','0',0),(595710,16546,'zh','0',0),(595711,16547,'zh','0',0),(595712,16548,'zh','0',0),(595713,16549,'zh','0',0),(595714,16550,'zh','0',0),(595715,16551,'zh','0',0),(595716,16552,'zh','0',0),(595717,16553,'zh','0',0),(595718,16554,'zh','0',0),(595719,16555,'zh','0',0),(595720,16556,'zh','0',0),(595721,16557,'zh','0',0),(595722,16558,'zh','0',0),(595723,16559,'zh','0',0),(595724,16560,'zh','0',0),(595725,16561,'zh','0',0),(595726,16562,'zh','0',0),(595727,16563,'zh','0',0),(595728,16564,'zh','0',0),(595729,16565,'zh','0',0),(595730,16566,'zh','0',0),(595731,16567,'zh','0',0),(595732,16568,'zh','0',0),(595733,16569,'zh','0',0),(595734,16570,'zh','0',0),(595735,16571,'zh','0',0),(595736,16572,'zh','0',0),(595737,16573,'zh','0',0),(595738,16574,'zh','0',0),(595739,16575,'zh','0',0),(595740,16576,'zh','0',0),(595741,16577,'zh','0',0),(595742,16578,'zh','0',0),(595743,16579,'zh','0',0),(595744,16580,'zh','0',0),(595745,16581,'zh','0',0),(595746,16582,'zh','0',0),(595747,16583,'zh','0',0),(595748,16584,'zh','0',0),(595749,16585,'zh','0',0),(595750,16586,'zh','0',0),(595751,16587,'zh','0',0),(595752,16588,'zh','0',0),(595753,16589,'zh','0',0),(595754,16590,'zh','0',0),(595755,16591,'zh','0',0),(595756,16592,'zh','0',0),(595757,16593,'zh','0',0),(595758,16594,'zh','0',0),(595759,16595,'zh','0',0),(595760,16596,'zh','0',0),(595761,16597,'zh','0',0),(595762,16598,'zh','0',0),(595763,16599,'zh','0',0),(595764,16600,'zh','0',0),(595765,16601,'zh','0',0),(595766,16602,'zh','0',0),(595767,16603,'zh','0',0),(595768,16604,'zh','0',0),(595769,16605,'zh','0',0),(595770,16606,'zh','0',0),(595771,16607,'zh','0',0),(595772,16608,'zh','0',0),(595773,16609,'zh','0',0),(595774,16610,'zh','0',0),(595775,16611,'zh','0',0),(595776,16612,'zh','0',0),(595777,16613,'zh','0',0),(595778,16614,'zh','0',0),(595779,16615,'zh','0',0),(595780,16616,'zh','0',0),(595781,16617,'zh','0',0),(595782,16618,'zh','0',0),(595783,16619,'zh','0',0),(595784,16620,'zh','0',0),(595785,16621,'zh','0',0),(595786,16622,'zh','0',0),(595787,16623,'zh','0',0),(595788,16624,'zh','0',0),(595789,16625,'zh','0',0),(595790,16626,'zh','0',0),(595791,16627,'zh','0',0),(595792,16628,'zh','0',0),(595793,16629,'zh','0',0),(595794,16630,'zh','0',0),(595795,16631,'zh','0',0),(595796,16632,'zh','0',0),(595797,16633,'zh','0',0),(595798,16634,'zh','0',0),(595799,16635,'zh','0',0),(595800,16636,'zh','0',0),(595801,16637,'zh','0',0),(595802,16638,'zh','0',0),(595803,16639,'zh','0',0),(595804,16640,'zh','0',0),(595805,16641,'zh','0',0),(595806,16642,'zh','0',0),(595807,16643,'zh','0',0),(595808,16644,'zh','0',0),(595809,16645,'zh','0',0),(595810,16646,'zh','0',0),(595811,16647,'zh','0',0),(595812,16648,'zh','0',0),(595813,16649,'zh','0',0),(595814,16650,'zh','0',0),(595815,16651,'zh','0',0),(595816,16652,'zh','0',0),(595817,16653,'zh','0',0),(595818,16654,'zh','0',0),(595819,16655,'zh','0',0),(595820,16656,'zh','0',0),(595821,16657,'zh','0',0),(595822,16658,'zh','0',0),(595823,16659,'zh','0',0),(595824,16660,'zh','0',0),(595825,16661,'zh','0',0),(595826,16662,'zh','0',0),(595827,16663,'zh','0',0),(595828,16664,'zh','0',0),(595829,16665,'zh','0',0),(595830,16666,'zh','0',0),(595831,16667,'zh','0',0),(595832,16668,'zh','0',0),(595833,16669,'zh','0',0),(595834,16670,'zh','0',0),(595835,16671,'zh','0',0),(595836,16672,'zh','0',0),(595837,16673,'zh','0',0),(595838,16674,'zh','0',0),(595839,16675,'zh','0',0),(595840,16676,'zh','0',0),(595841,16677,'zh','0',0),(595842,16678,'zh','0',0),(595843,16679,'zh','0',0),(595844,16680,'zh','0',0),(595845,16681,'zh','0',0),(595846,16682,'zh','0',0),(595847,16683,'zh','0',0),(595848,16684,'zh','0',0),(595849,16685,'zh','0',0),(595850,16686,'zh','0',0),(595851,16687,'zh','0',0),(595852,16688,'zh','0',0),(595853,16689,'zh','0',0),(595854,16690,'zh','0',0),(595855,16691,'zh','0',0),(595856,16692,'zh','0',0),(595857,16693,'zh','0',0),(595858,16694,'zh','0',0),(595859,16695,'zh','0',0),(595860,16696,'zh','0',0),(595861,16697,'zh','0',0),(595862,16698,'zh','0',0),(595863,16699,'zh','0',0),(595864,16700,'zh','0',0),(595865,16701,'zh','0',0),(595866,16702,'zh','0',0),(595867,16703,'zh','0',0),(595868,16704,'zh','0',0),(595869,16705,'zh','0',0),(595870,16706,'zh','0',0),(595871,16707,'zh','0',0),(595872,16708,'zh','0',0),(595873,16709,'zh','0',0),(595874,16710,'zh','0',0),(595875,16711,'zh','0',0),(595876,16712,'zh','0',0),(595877,16713,'zh','0',0),(595878,16714,'zh','0',0),(595879,16715,'zh','0',0),(595880,16716,'zh','0',0),(595881,16503,'da','0',0),(595882,16504,'da','0',0),(595883,16505,'da','0',0),(595884,16506,'da','0',0),(595885,16507,'da','0',0),(595886,16508,'da','0',0),(595887,16509,'da','0',0),(595888,16510,'da','0',0),(595889,16511,'da','0',0),(595890,16512,'da','0',0),(595891,16513,'da','0',0),(595892,16514,'da','0',0),(595893,16515,'da','0',0),(595894,16516,'da','0',0),(595895,16517,'da','0',0),(595896,16518,'da','0',0),(595897,16519,'da','0',0),(595898,16520,'da','0',0),(595899,16521,'da','0',0),(595900,16522,'da','0',0),(595901,16523,'da','0',0),(595902,16524,'da','0',0),(595903,16525,'da','0',0),(595904,16526,'da','0',0),(595905,16527,'da','0',0),(595906,16528,'da','0',0),(595907,16529,'da','0',0),(595908,16530,'da','0',0),(595909,16531,'da','0',0),(595910,16532,'da','0',0),(595911,16533,'da','0',0),(595912,16534,'da','0',0),(595913,16535,'da','0',0),(595914,16536,'da','0',0),(595915,16537,'da','0',0),(595916,16538,'da','0',0),(595917,16539,'da','0',0),(595918,16540,'da','0',0),(595919,16541,'da','0',0),(595920,16542,'da','0',0),(595921,16543,'da','0',0),(595922,16544,'da','0',0),(595923,16545,'da','0',0),(595924,16546,'da','0',0),(595925,16547,'da','0',0),(595926,16548,'da','0',0),(595927,16549,'da','0',0),(595928,16550,'da','0',0),(595929,16551,'da','0',0),(595930,16552,'da','0',0),(595931,16553,'da','0',0),(595932,16554,'da','0',0),(595933,16555,'da','0',0),(595934,16556,'da','0',0),(595935,16557,'da','0',0),(595936,16558,'da','0',0),(595937,16559,'da','0',0),(595938,16560,'da','0',0),(595939,16561,'da','0',0),(595940,16562,'da','0',0),(595941,16563,'da','0',0),(595942,16564,'da','0',0),(595943,16565,'da','0',0),(595944,16566,'da','0',0),(595945,16567,'da','0',0),(595946,16568,'da','0',0),(595947,16569,'da','0',0),(595948,16570,'da','0',0),(595949,16571,'da','0',0),(595950,16572,'da','0',0),(595951,16573,'da','0',0),(595952,16574,'da','0',0),(595953,16575,'da','0',0),(595954,16576,'da','0',0),(595955,16577,'da','0',0),(595956,16578,'da','0',0),(595957,16579,'da','0',0),(595958,16580,'da','0',0),(595959,16581,'da','0',0),(595960,16582,'da','0',0),(595961,16583,'da','0',0),(595962,16584,'da','0',0),(595963,16585,'da','0',0),(595964,16586,'da','0',0),(595965,16587,'da','0',0),(595966,16588,'da','0',0),(595967,16589,'da','0',0),(595968,16590,'da','0',0),(595969,16591,'da','0',0),(595970,16592,'da','0',0),(595971,16593,'da','0',0),(595972,16594,'da','0',0),(595973,16595,'da','0',0),(595974,16596,'da','0',0),(595975,16597,'da','0',0),(595976,16598,'da','0',0),(595977,16599,'da','0',0),(595978,16600,'da','0',0),(595979,16601,'da','0',0),(595980,16602,'da','0',0),(595981,16603,'da','0',0),(595982,16604,'da','0',0),(595983,16605,'da','0',0),(595984,16606,'da','0',0),(595985,16607,'da','0',0),(595986,16608,'da','0',0),(595987,16609,'da','0',0),(595988,16610,'da','0',0),(595989,16611,'da','0',0),(595990,16612,'da','0',0),(595991,16613,'da','0',0),(595992,16614,'da','0',0),(595993,16615,'da','0',0),(595994,16616,'da','0',0),(595995,16617,'da','0',0),(595996,16618,'da','0',0),(595997,16619,'da','0',0),(595998,16620,'da','0',0),(595999,16621,'da','0',0),(596000,16622,'da','0',0),(596001,16623,'da','0',0),(596002,16624,'da','0',0),(596003,16625,'da','0',0),(596004,16626,'da','0',0),(596005,16627,'da','0',0),(596006,16628,'da','0',0),(596007,16629,'da','0',0),(596008,16630,'da','0',0),(596009,16631,'da','0',0),(596010,16632,'da','0',0),(596011,16633,'da','0',0),(596012,16634,'da','0',0),(596013,16635,'da','0',0),(596014,16636,'da','0',0),(596015,16637,'da','0',0),(596016,16638,'da','0',0),(596017,16639,'da','0',0),(596018,16640,'da','0',0),(596019,16641,'da','0',0),(596020,16642,'da','0',0),(596021,16643,'da','0',0),(596022,16644,'da','0',0),(596023,16645,'da','0',0),(596024,16646,'da','0',0),(596025,16647,'da','0',0),(596026,16648,'da','0',0),(596027,16649,'da','0',0),(596028,16650,'da','0',0),(596029,16651,'da','0',0),(596030,16652,'da','0',0),(596031,16653,'da','0',0),(596032,16654,'da','0',0),(596033,16655,'da','0',0),(596034,16656,'da','0',0),(596035,16657,'da','0',0),(596036,16658,'da','0',0),(596037,16659,'da','0',0),(596038,16660,'da','0',0),(596039,16661,'da','0',0),(596040,16662,'da','0',0),(596041,16663,'da','0',0),(596042,16664,'da','0',0),(596043,16665,'da','0',0),(596044,16666,'da','0',0),(596045,16667,'da','0',0),(596046,16668,'da','0',0),(596047,16669,'da','0',0),(596048,16670,'da','0',0),(596049,16671,'da','0',0),(596050,16672,'da','0',0),(596051,16673,'da','0',0),(596052,16674,'da','0',0),(596053,16675,'da','0',0),(596054,16676,'da','0',0),(596055,16677,'da','0',0),(596056,16678,'da','0',0),(596057,16679,'da','0',0),(596058,16680,'da','0',0),(596059,16681,'da','0',0),(596060,16682,'da','0',0),(596061,16683,'da','0',0),(596062,16684,'da','0',0),(596063,16685,'da','0',0),(596064,16686,'da','0',0),(596065,16687,'da','0',0),(596066,16688,'da','0',0),(596067,16689,'da','0',0),(596068,16690,'da','0',0),(596069,16691,'da','0',0),(596070,16692,'da','0',0),(596071,16693,'da','0',0),(596072,16694,'da','0',0),(596073,16695,'da','0',0),(596074,16696,'da','0',0),(596075,16697,'da','0',0),(596076,16698,'da','0',0),(596077,16699,'da','0',0),(596078,16700,'da','0',0),(596079,16701,'da','0',0),(596080,16702,'da','0',0),(596081,16703,'da','0',0),(596082,16704,'da','0',0),(596083,16705,'da','0',0),(596084,16706,'da','0',0),(596085,16707,'da','0',0),(596086,16708,'da','0',0),(596087,16709,'da','0',0),(596088,16710,'da','0',0),(596089,16711,'da','0',0),(596090,16712,'da','0',0),(596091,16713,'da','0',0),(596092,16714,'da','0',0),(596093,16715,'da','0',0),(596094,16716,'da','0',0),(596095,16503,'dr','0',0),(596096,16504,'dr','0',0),(596097,16505,'dr','0',0),(596098,16506,'dr','0',0),(596099,16507,'dr','0',0),(596100,16508,'dr','0',0),(596101,16509,'dr','0',0),(596102,16510,'dr','0',0),(596103,16511,'dr','0',0),(596104,16512,'dr','0',0),(596105,16513,'dr','0',0),(596106,16514,'dr','0',0),(596107,16515,'dr','0',0),(596108,16516,'dr','0',0),(596109,16517,'dr','0',0),(596110,16518,'dr','0',0),(596111,16519,'dr','0',0),(596112,16520,'dr','0',0),(596113,16521,'dr','0',0),(596114,16522,'dr','0',0),(596115,16523,'dr','0',0),(596116,16524,'dr','0',0),(596117,16525,'dr','0',0),(596118,16526,'dr','0',0),(596119,16527,'dr','0',0),(596120,16528,'dr','0',0),(596121,16529,'dr','0',0),(596122,16530,'dr','0',0),(596123,16717,'en','Could Not Find GL Account By Name',0),(596124,16717,'af','0',0),(596125,16717,'ar','0',0),(596126,16717,'bg','0',0),(596127,16717,'zh','0',0),(596128,16717,'da','0',0),(596129,16531,'dr','0',0),(596130,16532,'dr','0',0),(596131,16533,'dr','0',0),(596132,16534,'dr','0',0),(596133,16535,'dr','0',0),(596134,16536,'dr','0',0),(596135,16537,'dr','0',0),(596136,16538,'dr','0',0),(596137,16539,'dr','0',0),(596138,16540,'dr','0',0),(596139,16541,'dr','0',0),(596140,16542,'dr','0',0),(596141,16543,'dr','0',0),(596142,16544,'dr','0',0),(596143,16545,'dr','0',0),(596144,16546,'dr','0',0),(596145,16547,'dr','0',0),(596146,16548,'dr','0',0),(596147,16549,'dr','0',0),(596148,16550,'dr','0',0),(596149,16551,'dr','0',0),(596150,16552,'dr','0',0),(596151,16553,'dr','0',0),(596152,16554,'dr','0',0),(596153,16555,'dr','0',0),(596154,16556,'dr','0',0),(596155,16557,'dr','0',0),(596156,16558,'dr','0',0),(596157,16559,'dr','0',0),(596158,16560,'dr','0',0),(596159,16561,'dr','0',0),(596160,16562,'dr','0',0),(596161,16563,'dr','0',0),(596162,16564,'dr','0',0),(596163,16565,'dr','0',0),(596164,16566,'dr','0',0),(596165,16567,'dr','0',0),(596166,16568,'dr','0',0),(596167,16569,'dr','0',0),(596168,16570,'dr','0',0),(596169,16571,'dr','0',0),(596170,16572,'dr','0',0),(596171,16573,'dr','0',0),(596172,16574,'dr','0',0),(596173,16575,'dr','0',0),(596174,16576,'dr','0',0),(596175,16577,'dr','0',0),(596176,16578,'dr','0',0),(596177,16579,'dr','0',0),(596178,16580,'dr','0',0),(596179,16581,'dr','0',0),(596180,16582,'dr','0',0),(596181,16583,'dr','0',0),(596182,16584,'dr','0',0),(596183,16585,'dr','0',0),(596184,16586,'dr','0',0),(596185,16587,'dr','0',0),(596186,16588,'dr','0',0),(596187,16589,'dr','0',0),(596188,16590,'dr','0',0),(596189,16591,'dr','0',0),(596190,16592,'dr','0',0),(596191,16593,'dr','0',0),(596192,16594,'dr','0',0),(596193,16595,'dr','0',0),(596194,16596,'dr','0',0),(596195,16597,'dr','0',0),(596196,16598,'dr','0',0),(596197,16599,'dr','0',0),(596198,16600,'dr','0',0),(596199,16601,'dr','0',0),(596200,16602,'dr','0',0),(596201,16603,'dr','0',0),(596202,16604,'dr','0',0),(596203,16605,'dr','0',0),(596204,16606,'dr','0',0),(596205,16607,'dr','0',0),(596206,16608,'dr','0',0),(596207,16609,'dr','0',0),(596208,16610,'dr','0',0),(596209,16611,'dr','0',0),(596210,16612,'dr','0',0),(596211,16613,'dr','0',0),(596212,16614,'dr','0',0),(596213,16615,'dr','0',0),(596214,16616,'dr','0',0),(596215,16617,'dr','0',0),(596216,16618,'dr','0',0),(596217,16619,'dr','0',0),(596218,16620,'dr','0',0),(596219,16621,'dr','0',0),(596220,16622,'dr','0',0),(596221,16623,'dr','0',0),(596222,16624,'dr','0',0),(596223,16625,'dr','0',0),(596224,16626,'dr','0',0),(596225,16627,'dr','0',0),(596226,16628,'dr','0',0),(596227,16629,'dr','0',0),(596228,16630,'dr','0',0),(596229,16631,'dr','0',0),(596230,16632,'dr','0',0),(596231,16633,'dr','0',0),(596232,16634,'dr','0',0),(596233,16635,'dr','0',0),(596234,16636,'dr','0',0),(596235,16637,'dr','0',0),(596236,16638,'dr','0',0),(596237,16639,'dr','0',0),(596238,16640,'dr','0',0),(596239,16641,'dr','0',0),(596240,16642,'dr','0',0),(596241,16643,'dr','0',0),(596242,16644,'dr','0',0),(596243,16645,'dr','0',0),(596244,16646,'dr','0',0),(596245,16647,'dr','0',0),(596246,16648,'dr','0',0),(596247,16649,'dr','0',0),(596248,16650,'dr','0',0),(596249,16651,'dr','0',0),(596250,16652,'dr','0',0),(596251,16653,'dr','0',0),(596252,16654,'dr','0',0),(596253,16655,'dr','0',0),(596254,16656,'dr','0',0),(596255,16657,'dr','0',0),(596256,16658,'dr','0',0),(596257,16659,'dr','0',0),(596258,16660,'dr','0',0),(596259,16661,'dr','0',0),(596260,16662,'dr','0',0),(596261,16663,'dr','0',0),(596262,16664,'dr','0',0),(596263,16665,'dr','0',0),(596264,16666,'dr','0',0),(596265,16667,'dr','0',0),(596266,16668,'dr','0',0),(596267,16669,'dr','0',0),(596268,16670,'dr','0',0),(596269,16671,'dr','0',0),(596270,16672,'dr','0',0),(596271,16673,'dr','0',0),(596272,16674,'dr','0',0),(596273,16675,'dr','0',0),(596274,16676,'dr','0',0),(596275,16677,'dr','0',0),(596276,16678,'dr','0',0),(596277,16679,'dr','0',0),(596278,16680,'dr','0',0),(596279,16681,'dr','0',0),(596280,16682,'dr','0',0),(596281,16683,'dr','0',0),(596282,16684,'dr','0',0),(596283,16685,'dr','0',0),(596284,16686,'dr','0',0),(596285,16687,'dr','0',0),(596286,16688,'dr','0',0),(596287,16689,'dr','0',0),(596288,16690,'dr','0',0),(596289,16691,'dr','0',0),(596290,16692,'dr','0',0),(596291,16693,'dr','0',0),(596292,16694,'dr','0',0),(596293,16695,'dr','0',0),(596294,16696,'dr','0',0),(596295,16697,'dr','0',0),(596296,16698,'dr','0',0),(596297,16699,'dr','0',0),(596298,16700,'dr','0',0),(596299,16701,'dr','0',0),(596300,16702,'dr','0',0),(596301,16703,'dr','0',0),(596302,16704,'dr','0',0),(596303,16705,'dr','0',0),(596304,16706,'dr','0',0),(596305,16707,'dr','0',0),(596306,16708,'dr','0',0),(596307,16709,'dr','0',0),(596308,16710,'dr','0',0),(596309,16711,'dr','0',0),(596310,16712,'dr','0',0),(596311,16713,'dr','0',0),(596312,16714,'dr','0',0),(596313,16715,'dr','0',0),(596314,16716,'dr','0',0),(596315,16717,'dr','0',0),(596316,16503,'nl','0',0),(596317,16504,'nl','0',0),(596318,16505,'nl','0',0),(596319,16506,'nl','0',0),(596320,16507,'nl','0',0),(596321,16508,'nl','0',0),(596322,16509,'nl','0',0),(596323,16510,'nl','0',0),(596324,16511,'nl','0',0),(596325,16512,'nl','0',0),(596326,16513,'nl','0',0),(596327,16514,'nl','0',0),(596328,16515,'nl','0',0),(596329,16516,'nl','0',0),(596330,16517,'nl','0',0),(596331,16518,'nl','0',0),(596332,16519,'nl','0',0),(596333,16520,'nl','0',0),(596334,16521,'nl','0',0),(596335,16522,'nl','0',0),(596336,16523,'nl','0',0),(596337,16524,'nl','0',0),(596338,16525,'nl','0',0),(596339,16526,'nl','0',0),(596340,16527,'nl','0',0),(596341,16528,'nl','0',0),(596342,16529,'nl','0',0),(596343,16530,'nl','0',0),(596344,16531,'nl','0',0),(596345,16532,'nl','0',0),(596346,16533,'nl','0',0),(596347,16534,'nl','0',0),(596348,16535,'nl','0',0),(596349,16536,'nl','0',0),(596350,16537,'nl','0',0),(596351,16538,'nl','0',0),(596352,16539,'nl','0',0),(596353,16540,'nl','0',0),(596354,16541,'nl','0',0),(596355,16542,'nl','0',0),(596356,16543,'nl','0',0),(596357,16544,'nl','0',0),(596358,16545,'nl','0',0),(596359,16546,'nl','0',0),(596360,16547,'nl','0',0),(596361,16548,'nl','0',0),(596362,16549,'nl','0',0),(596363,16550,'nl','0',0),(596364,16551,'nl','0',0),(596365,16552,'nl','0',0),(596366,16553,'nl','0',0),(596367,16554,'nl','0',0),(596368,16555,'nl','0',0),(596369,16556,'nl','0',0),(596370,16557,'nl','0',0),(596371,16558,'nl','0',0),(596372,16559,'nl','0',0),(596373,16560,'nl','0',0),(596374,16561,'nl','0',0),(596375,16562,'nl','0',0),(596376,16563,'nl','0',0),(596377,16564,'nl','0',0),(596378,16565,'nl','0',0),(596379,16566,'nl','0',0),(596380,16567,'nl','0',0),(596381,16568,'nl','0',0),(596382,16569,'nl','0',0),(596383,16570,'nl','0',0),(596384,16571,'nl','0',0),(596385,16572,'nl','0',0),(596386,16573,'nl','0',0),(596387,16574,'nl','0',0),(596388,16575,'nl','0',0),(596389,16576,'nl','0',0),(596390,16577,'nl','0',0),(596391,16578,'nl','0',0),(596392,16579,'nl','0',0),(596393,16580,'nl','0',0),(596394,16581,'nl','0',0),(596395,16582,'nl','0',0),(596396,16583,'nl','0',0),(596397,16584,'nl','0',0),(596398,16585,'nl','0',0),(596399,16586,'nl','0',0),(596400,16587,'nl','0',0),(596401,16588,'nl','0',0),(596402,16589,'nl','0',0),(596403,16590,'nl','0',0),(596404,16591,'nl','0',0),(596405,16592,'nl','0',0),(596406,16593,'nl','0',0),(596407,16594,'nl','0',0),(596408,16595,'nl','0',0),(596409,16596,'nl','0',0),(596410,16597,'nl','0',0),(596411,16598,'nl','0',0),(596412,16599,'nl','0',0),(596413,16600,'nl','0',0),(596414,16601,'nl','0',0),(596415,16602,'nl','0',0),(596416,16603,'nl','0',0),(596417,16604,'nl','0',0),(596418,16605,'nl','0',0),(596419,16606,'nl','0',0),(596420,16607,'nl','0',0),(596421,16608,'nl','0',0),(596422,16609,'nl','0',0),(596423,16610,'nl','0',0),(596424,16611,'nl','0',0),(596425,16612,'nl','0',0),(596426,16613,'nl','0',0),(596427,16614,'nl','0',0),(596428,16615,'nl','0',0),(596429,16616,'nl','0',0),(596430,16617,'nl','0',0),(596431,16618,'nl','0',0),(596432,16619,'nl','0',0),(596433,16620,'nl','0',0),(596434,16621,'nl','0',0),(596435,16622,'nl','0',0),(596436,16623,'nl','0',0),(596437,16624,'nl','0',0),(596438,16625,'nl','0',0),(596439,16626,'nl','0',0),(596440,16627,'nl','0',0),(596441,16628,'nl','0',0),(596442,16629,'nl','0',0),(596443,16630,'nl','0',0),(596444,16631,'nl','0',0),(596445,16632,'nl','0',0),(596446,16633,'nl','0',0),(596447,16634,'nl','0',0),(596448,16635,'nl','0',0),(596449,16636,'nl','0',0),(596450,16637,'nl','0',0),(596451,16638,'nl','0',0),(596452,16639,'nl','0',0),(596453,16640,'nl','0',0),(596454,16641,'nl','0',0),(596455,16642,'nl','0',0),(596456,16643,'nl','0',0),(596457,16644,'nl','0',0),(596458,16645,'nl','0',0),(596459,16646,'nl','0',0),(596460,16647,'nl','0',0),(596461,16648,'nl','0',0),(596462,16649,'nl','0',0),(596463,16650,'nl','0',0),(596464,16651,'nl','0',0),(596465,16652,'nl','0',0),(596466,16653,'nl','0',0),(596467,16654,'nl','0',0),(596468,16655,'nl','0',0),(596469,16656,'nl','0',0),(596470,16657,'nl','0',0),(596471,16658,'nl','0',0),(596472,16659,'nl','0',0),(596473,16660,'nl','0',0),(596474,16661,'nl','0',0),(596475,16662,'nl','0',0),(596476,16663,'nl','0',0),(596477,16664,'nl','0',0),(596478,16665,'nl','0',0),(596479,16666,'nl','0',0),(596480,16667,'nl','0',0),(596481,16668,'nl','0',0),(596482,16669,'nl','0',0),(596483,16670,'nl','0',0),(596484,16671,'nl','0',0),(596485,16672,'nl','0',0),(596486,16673,'nl','0',0),(596487,16674,'nl','0',0),(596488,16675,'nl','0',0),(596489,16676,'nl','0',0),(596490,16677,'nl','0',0),(596491,16678,'nl','0',0),(596492,16679,'nl','0',0),(596493,16680,'nl','0',0),(596494,16681,'nl','0',0),(596495,16682,'nl','0',0),(596496,16683,'nl','0',0),(596497,16684,'nl','0',0),(596498,16685,'nl','0',0),(596499,16686,'nl','0',0),(596500,16687,'nl','0',0),(596501,16688,'nl','0',0),(596502,16689,'nl','0',0),(596503,16690,'nl','0',0),(596504,16691,'nl','0',0),(596505,16692,'nl','0',0),(596506,16693,'nl','0',0),(596507,16694,'nl','0',0),(596508,16695,'nl','0',0),(596509,16696,'nl','0',0),(596510,16697,'nl','0',0),(596511,16698,'nl','0',0),(596512,16699,'nl','0',0),(596513,16700,'nl','0',0),(596514,16701,'nl','0',0),(596515,16702,'nl','0',0),(596516,16703,'nl','0',0),(596517,16704,'nl','0',0),(596518,16705,'nl','0',0),(596519,16706,'nl','0',0),(596520,16707,'nl','0',0),(596521,16708,'nl','0',0),(596522,16709,'nl','0',0),(596523,16710,'nl','0',0),(596524,16711,'nl','0',0),(596525,16712,'nl','0',0),(596526,16713,'nl','0',0),(596527,16714,'nl','0',0),(596528,16715,'nl','0',0),(596529,16716,'nl','0',0),(596530,16717,'nl','0',0),(596531,16503,'et','0',0),(596532,16504,'et','0',0),(596533,16505,'et','0',0),(596534,16506,'et','0',0),(596535,16507,'et','0',0),(596536,16508,'et','0',0),(596537,16509,'et','0',0),(596538,16510,'et','0',0),(596539,16511,'et','0',0),(596540,16512,'et','0',0),(596541,16513,'et','0',0),(596542,16514,'et','0',0),(596543,16515,'et','0',0),(596544,16516,'et','0',0),(596545,16517,'et','0',0),(596546,16518,'et','0',0),(596547,16519,'et','0',0),(596548,16520,'et','0',0),(596549,16521,'et','0',0),(596550,16522,'et','0',0),(596551,16523,'et','0',0),(596552,16524,'et','0',0),(596553,16525,'et','0',0),(596554,16526,'et','0',0),(596555,16527,'et','0',0),(596556,16528,'et','0',0),(596557,16529,'et','0',0),(596558,16530,'et','0',0),(596559,16531,'et','0',0),(596560,16532,'et','0',0),(596561,16533,'et','0',0),(596562,16534,'et','0',0),(596563,16535,'et','0',0),(596564,16536,'et','0',0),(596565,16537,'et','0',0),(596566,16538,'et','0',0),(596567,16539,'et','0',0),(596568,16540,'et','0',0),(596569,16541,'et','0',0),(596570,16542,'et','0',0),(596571,16543,'et','0',0),(596572,16544,'et','0',0),(596573,16545,'et','0',0),(596574,16546,'et','0',0),(596575,16547,'et','0',0),(596576,16548,'et','0',0),(596577,16549,'et','0',0),(596578,16550,'et','0',0),(596579,16551,'et','0',0),(596580,16552,'et','0',0),(596581,16553,'et','0',0),(596582,16554,'et','0',0),(596583,16555,'et','0',0),(596584,16556,'et','0',0),(596585,16557,'et','0',0),(596586,16558,'et','0',0),(596587,16559,'et','0',0),(596588,16560,'et','0',0),(596589,16561,'et','0',0),(596590,16562,'et','0',0),(596591,16563,'et','0',0),(596592,16564,'et','0',0),(596593,16565,'et','0',0),(596594,16566,'et','0',0),(596595,16567,'et','0',0),(596596,16568,'et','0',0),(596597,16569,'et','0',0),(596598,16570,'et','0',0),(596599,16571,'et','0',0),(596600,16572,'et','0',0),(596601,16573,'et','0',0),(596602,16574,'et','0',0),(596603,16575,'et','0',0),(596604,16576,'et','0',0),(596605,16577,'et','0',0),(596606,16578,'et','0',0),(596607,16579,'et','0',0),(596608,16580,'et','0',0),(596609,16581,'et','0',0),(596610,16582,'et','0',0),(596611,16583,'et','0',0),(596612,16584,'et','0',0),(596613,16585,'et','0',0),(596614,16586,'et','0',0),(596615,16587,'et','0',0),(596616,16588,'et','0',0),(596617,16589,'et','0',0),(596618,16590,'et','0',0),(596619,16591,'et','0',0),(596620,16592,'et','0',0),(596621,16593,'et','0',0),(596622,16594,'et','0',0),(596623,16595,'et','0',0),(596624,16596,'et','0',0),(596625,16597,'et','0',0),(596626,16598,'et','0',0),(596627,16599,'et','0',0),(596628,16600,'et','0',0),(596629,16601,'et','0',0),(596630,16602,'et','0',0),(596631,16603,'et','0',0),(596632,16604,'et','0',0),(596633,16605,'et','0',0),(596634,16606,'et','0',0),(596635,16607,'et','0',0),(596636,16608,'et','0',0),(596637,16609,'et','0',0),(596638,16610,'et','0',0),(596639,16611,'et','0',0),(596640,16612,'et','0',0),(596641,16613,'et','0',0),(596642,16614,'et','0',0),(596643,16615,'et','0',0),(596644,16616,'et','0',0),(596645,16617,'et','0',0),(596646,16618,'et','0',0),(596647,16619,'et','0',0),(596648,16620,'et','0',0),(596649,16621,'et','0',0),(596650,16622,'et','0',0),(596651,16623,'et','0',0),(596652,16624,'et','0',0),(596653,16625,'et','0',0),(596654,16626,'et','0',0),(596655,16627,'et','0',0),(596656,16628,'et','0',0),(596657,16629,'et','0',0),(596658,16630,'et','0',0),(596659,16631,'et','0',0),(596660,16632,'et','0',0),(596661,16633,'et','0',0),(596662,16634,'et','0',0),(596663,16635,'et','0',0),(596664,16636,'et','0',0),(596665,16637,'et','0',0),(596666,16638,'et','0',0),(596667,16639,'et','0',0),(596668,16640,'et','0',0),(596669,16641,'et','0',0),(596670,16642,'et','0',0),(596671,16643,'et','0',0),(596672,16644,'et','0',0),(596673,16645,'et','0',0),(596674,16646,'et','0',0),(596675,16647,'et','0',0),(596676,16648,'et','0',0),(596677,16649,'et','0',0),(596678,16650,'et','0',0),(596679,16651,'et','0',0),(596680,16652,'et','0',0),(596681,16653,'et','0',0),(596682,16654,'et','0',0),(596683,16655,'et','0',0),(596684,16656,'et','0',0),(596685,16657,'et','0',0),(596686,16658,'et','0',0),(596687,16659,'et','0',0),(596688,16660,'et','0',0),(596689,16661,'et','0',0),(596690,16662,'et','0',0),(596691,16663,'et','0',0),(596692,16664,'et','0',0),(596693,16665,'et','0',0),(596694,16666,'et','0',0),(596695,16667,'et','0',0),(596696,16668,'et','0',0),(596697,16669,'et','0',0),(596698,16670,'et','0',0),(596699,16671,'et','0',0),(596700,16672,'et','0',0),(596701,16673,'et','0',0),(596702,16674,'et','0',0),(596703,16675,'et','0',0),(596704,16676,'et','0',0),(596705,16677,'et','0',0),(596706,16678,'et','0',0),(596707,16679,'et','0',0),(596708,16680,'et','0',0),(596709,16681,'et','0',0),(596710,16682,'et','0',0),(596711,16683,'et','0',0),(596712,16684,'et','0',0),(596713,16685,'et','0',0),(596714,16686,'et','0',0),(596715,16687,'et','0',0),(596716,16688,'et','0',0),(596717,16689,'et','0',0),(596718,16690,'et','0',0),(596719,16691,'et','0',0),(596720,16692,'et','0',0),(596721,16693,'et','0',0),(596722,16694,'et','0',0),(596723,16695,'et','0',0),(596724,16696,'et','0',0),(596725,16697,'et','0',0),(596726,16698,'et','0',0),(596727,16699,'et','0',0),(596728,16700,'et','0',0),(596729,16701,'et','0',0),(596730,16702,'et','0',0),(596731,16703,'et','0',0),(596732,16704,'et','0',0),(596733,16705,'et','0',0),(596734,16706,'et','0',0),(596735,16707,'et','0',0),(596736,16708,'et','0',0),(596737,16709,'et','0',0),(596738,16710,'et','0',0),(596739,16711,'et','0',0),(596740,16712,'et','0',0),(596741,16713,'et','0',0),(596742,16714,'et','0',0),(596743,16715,'et','0',0),(596744,16716,'et','0',0),(596745,16717,'et','0',0),(596746,16503,'fi','0',0),(596747,16504,'fi','0',0),(596748,16505,'fi','0',0),(596749,16506,'fi','0',0),(596750,16507,'fi','0',0),(596751,16508,'fi','0',0),(596752,16509,'fi','0',0),(596753,16510,'fi','0',0),(596754,16511,'fi','0',0),(596755,16512,'fi','0',0),(596756,16513,'fi','0',0),(596757,16514,'fi','0',0),(596758,16515,'fi','0',0),(596759,16516,'fi','0',0),(596760,16517,'fi','0',0),(596761,16518,'fi','0',0),(596762,16519,'fi','0',0),(596763,16520,'fi','0',0),(596764,16521,'fi','0',0),(596765,16522,'fi','0',0),(596766,16523,'fi','0',0),(596767,16524,'fi','0',0),(596768,16525,'fi','0',0),(596769,16526,'fi','0',0),(596770,16527,'fi','0',0),(596771,16528,'fi','0',0),(596772,16529,'fi','0',0),(596773,16530,'fi','0',0),(596774,16531,'fi','0',0),(596775,16532,'fi','0',0),(596776,16533,'fi','0',0),(596777,16534,'fi','0',0),(596778,16535,'fi','0',0),(596779,16536,'fi','0',0),(596780,16537,'fi','0',0),(596781,16538,'fi','0',0),(596782,16539,'fi','0',0),(596783,16540,'fi','0',0),(596784,16541,'fi','0',0),(596785,16542,'fi','0',0),(596786,16543,'fi','0',0),(596787,16544,'fi','0',0),(596788,16545,'fi','0',0),(596789,16546,'fi','0',0),(596790,16547,'fi','0',0),(596791,16548,'fi','0',0),(596792,16549,'fi','0',0),(596793,16550,'fi','0',0),(596794,16551,'fi','0',0),(596795,16552,'fi','0',0),(596796,16553,'fi','0',0),(596797,16554,'fi','0',0),(596798,16555,'fi','0',0),(596799,16556,'fi','0',0),(596800,16557,'fi','0',0),(596801,16558,'fi','0',0),(596802,16559,'fi','0',0),(596803,16560,'fi','0',0),(596804,16561,'fi','0',0),(596805,16562,'fi','0',0),(596806,16563,'fi','0',0),(596807,16564,'fi','0',0),(596808,16565,'fi','0',0),(596809,16566,'fi','0',0),(596810,16567,'fi','0',0),(596811,16568,'fi','0',0),(596812,16569,'fi','0',0),(596813,16570,'fi','0',0),(596814,16571,'fi','0',0),(596815,16572,'fi','0',0),(596816,16573,'fi','0',0),(596817,16574,'fi','0',0),(596818,16575,'fi','0',0),(596819,16576,'fi','0',0),(596820,16577,'fi','0',0),(596821,16578,'fi','0',0),(596822,16579,'fi','0',0),(596823,16580,'fi','0',0),(596824,16581,'fi','0',0),(596825,16582,'fi','0',0),(596826,16583,'fi','0',0),(596827,16584,'fi','0',0),(596828,16585,'fi','0',0),(596829,16586,'fi','0',0),(596830,16587,'fi','0',0),(596831,16588,'fi','0',0),(596832,16589,'fi','0',0),(596833,16590,'fi','0',0),(596834,16591,'fi','0',0),(596835,16592,'fi','0',0),(596836,16593,'fi','0',0),(596837,16594,'fi','0',0),(596838,16595,'fi','0',0),(596839,16596,'fi','0',0),(596840,16597,'fi','0',0),(596841,16598,'fi','0',0),(596842,16599,'fi','0',0),(596843,16600,'fi','0',0),(596844,16601,'fi','0',0),(596845,16602,'fi','0',0),(596846,16603,'fi','0',0),(596847,16604,'fi','0',0),(596848,16605,'fi','0',0),(596849,16606,'fi','0',0),(596850,16607,'fi','0',0),(596851,16608,'fi','0',0),(596852,16609,'fi','0',0),(596853,16610,'fi','0',0),(596854,16611,'fi','0',0),(596855,16612,'fi','0',0),(596856,16613,'fi','0',0),(596857,16614,'fi','0',0),(596858,16615,'fi','0',0),(596859,16616,'fi','0',0),(596860,16617,'fi','0',0),(596861,16618,'fi','0',0),(596862,16619,'fi','0',0),(596863,16620,'fi','0',0),(596864,16621,'fi','0',0),(596865,16622,'fi','0',0),(596866,16623,'fi','0',0),(596867,16624,'fi','0',0),(596868,16625,'fi','0',0),(596869,16626,'fi','0',0),(596870,16627,'fi','0',0),(596871,16628,'fi','0',0),(596872,16629,'fi','0',0),(596873,16630,'fi','0',0),(596874,16631,'fi','0',0),(596875,16632,'fi','0',0),(596876,16633,'fi','0',0),(596877,16634,'fi','0',0),(596878,16635,'fi','0',0),(596879,16636,'fi','0',0),(596880,16637,'fi','0',0),(596881,16638,'fi','0',0),(596882,16639,'fi','0',0),(596883,16640,'fi','0',0),(596884,16641,'fi','0',0),(596885,16642,'fi','0',0),(596886,16643,'fi','0',0),(596887,16644,'fi','0',0),(596888,16645,'fi','0',0),(596889,16646,'fi','0',0),(596890,16647,'fi','0',0),(596891,16648,'fi','0',0),(596892,16649,'fi','0',0),(596893,16650,'fi','0',0),(596894,16651,'fi','0',0),(596895,16652,'fi','0',0),(596896,16653,'fi','0',0),(596897,16654,'fi','0',0),(596898,16655,'fi','0',0),(596899,16656,'fi','0',0),(596900,16657,'fi','0',0),(596901,16658,'fi','0',0),(596902,16659,'fi','0',0),(596903,16660,'fi','0',0),(596904,16661,'fi','0',0),(596905,16662,'fi','0',0),(596906,16663,'fi','0',0),(596907,16664,'fi','0',0),(596908,16665,'fi','0',0),(596909,16666,'fi','0',0),(596910,16667,'fi','0',0),(596911,16668,'fi','0',0),(596912,16669,'fi','0',0),(596913,16670,'fi','0',0),(596914,16671,'fi','0',0),(596915,16672,'fi','0',0),(596916,16673,'fi','0',0),(596917,16674,'fi','0',0),(596918,16675,'fi','0',0),(596919,16676,'fi','0',0),(596920,16677,'fi','0',0),(596921,16678,'fi','0',0),(596922,16679,'fi','0',0),(596923,16680,'fi','0',0),(596924,16681,'fi','0',0),(596925,16682,'fi','0',0),(596926,16683,'fi','0',0),(596927,16684,'fi','0',0),(596928,16685,'fi','0',0),(596929,16686,'fi','0',0),(596930,16687,'fi','0',0),(596931,16688,'fi','0',0),(596932,16689,'fi','0',0),(596933,16690,'fi','0',0),(596934,16691,'fi','0',0),(596935,16692,'fi','0',0),(596936,16693,'fi','0',0),(596937,16694,'fi','0',0),(596938,16695,'fi','0',0),(596939,16696,'fi','0',0),(596940,16697,'fi','0',0),(596941,16698,'fi','0',0),(596942,16699,'fi','0',0),(596943,16700,'fi','0',0),(596944,16701,'fi','0',0),(596945,16702,'fi','0',0),(596946,16703,'fi','0',0),(596947,16704,'fi','0',0),(596948,16705,'fi','0',0),(596949,16706,'fi','0',0),(596950,16707,'fi','0',0),(596951,16708,'fi','0',0),(596952,16709,'fi','0',0),(596953,16710,'fi','0',0),(596954,16711,'fi','0',0),(596955,16712,'fi','0',0),(596956,16713,'fi','0',0),(596957,16714,'fi','0',0),(596958,16715,'fi','0',0),(596959,16716,'fi','0',0),(596960,16717,'fi','0',0),(596961,16503,'fr','0',0),(596962,16504,'fr','0',0),(596963,16505,'fr','0',0),(596964,16506,'fr','0',0),(596965,16507,'fr','0',0),(596966,16508,'fr','0',0),(596967,16509,'fr','0',0),(596968,16510,'fr','0',0),(596969,16511,'fr','0',0),(596970,16512,'fr','0',0),(596971,16513,'fr','0',0),(596972,16514,'fr','0',0),(596973,16515,'fr','0',0),(596974,16516,'fr','0',0),(596975,16517,'fr','0',0),(596976,16518,'fr','0',0),(596977,16519,'fr','0',0),(596978,16520,'fr','0',0),(596979,16521,'fr','0',0),(596980,16522,'fr','0',0),(596981,16523,'fr','0',0),(596982,16524,'fr','0',0),(596983,16525,'fr','0',0),(596984,16526,'fr','0',0),(596985,16527,'fr','0',0),(596986,16528,'fr','0',0),(596987,16529,'fr','0',0),(596988,16530,'fr','0',0),(596989,16531,'fr','0',0),(596990,16532,'fr','0',0),(596991,16533,'fr','0',0),(596992,16534,'fr','0',0),(596993,16535,'fr','0',0),(596994,16536,'fr','0',0),(596995,16537,'fr','0',0),(596996,16538,'fr','0',0),(596997,16539,'fr','0',0),(596998,16540,'fr','0',0),(596999,16541,'fr','0',0),(597000,16542,'fr','0',0),(597001,16543,'fr','0',0),(597002,16544,'fr','0',0),(597003,16545,'fr','0',0),(597004,16546,'fr','0',0),(597005,16547,'fr','0',0),(597006,16548,'fr','0',0),(597007,16549,'fr','0',0),(597008,16550,'fr','0',0),(597009,16551,'fr','0',0),(597010,16552,'fr','0',0),(597011,16553,'fr','0',0),(597012,16554,'fr','0',0),(597013,16555,'fr','0',0),(597014,16556,'fr','0',0),(597015,16557,'fr','0',0),(597016,16558,'fr','0',0),(597017,16559,'fr','0',0),(597018,16560,'fr','0',0),(597019,16561,'fr','0',0),(597020,16562,'fr','0',0),(597021,16563,'fr','0',0),(597022,16564,'fr','0',0),(597023,16565,'fr','0',0),(597024,16566,'fr','0',0),(597025,16567,'fr','0',0),(597026,16568,'fr','0',0),(597027,16569,'fr','0',0),(597028,16570,'fr','0',0),(597029,16571,'fr','0',0),(597030,16572,'fr','0',0),(597031,16573,'fr','0',0),(597032,16574,'fr','0',0),(597033,16575,'fr','0',0),(597034,16576,'fr','0',0),(597035,16577,'fr','0',0),(597036,16578,'fr','0',0),(597037,16579,'fr','0',0),(597038,16580,'fr','0',0),(597039,16581,'fr','0',0),(597040,16582,'fr','0',0),(597041,16583,'fr','0',0),(597042,16584,'fr','0',0),(597043,16585,'fr','0',0),(597044,16586,'fr','0',0),(597045,16587,'fr','0',0),(597046,16588,'fr','0',0),(597047,16589,'fr','0',0),(597048,16590,'fr','0',0),(597049,16591,'fr','0',0),(597050,16592,'fr','0',0),(597051,16593,'fr','0',0),(597052,16594,'fr','0',0),(597053,16595,'fr','0',0),(597054,16596,'fr','0',0),(597055,16597,'fr','0',0),(597056,16598,'fr','0',0),(597057,16599,'fr','0',0),(597058,16600,'fr','0',0),(597059,16601,'fr','0',0),(597060,16602,'fr','0',0),(597061,16603,'fr','0',0),(597062,16604,'fr','0',0),(597063,16605,'fr','0',0),(597064,16606,'fr','0',0),(597065,16607,'fr','0',0),(597066,16608,'fr','0',0),(597067,16609,'fr','0',0),(597068,16610,'fr','0',0),(597069,16611,'fr','0',0),(597070,16612,'fr','0',0),(597071,16613,'fr','0',0),(597072,16614,'fr','0',0),(597073,16615,'fr','0',0),(597074,16616,'fr','0',0),(597075,16617,'fr','0',0),(597076,16618,'fr','0',0),(597077,16619,'fr','0',0),(597078,16620,'fr','0',0),(597079,16621,'fr','0',0),(597080,16622,'fr','0',0),(597081,16623,'fr','0',0),(597082,16624,'fr','0',0),(597083,16625,'fr','0',0),(597084,16626,'fr','0',0),(597085,16627,'fr','0',0),(597086,16628,'fr','0',0),(597087,16629,'fr','0',0),(597088,16630,'fr','0',0),(597089,16631,'fr','0',0),(597090,16632,'fr','0',0),(597091,16633,'fr','0',0),(597092,16634,'fr','0',0),(597093,16635,'fr','0',0),(597094,16636,'fr','0',0),(597095,16637,'fr','0',0),(597096,16638,'fr','0',0),(597097,16639,'fr','0',0),(597098,16640,'fr','0',0),(597099,16641,'fr','0',0),(597100,16642,'fr','0',0),(597101,16643,'fr','0',0),(597102,16644,'fr','0',0),(597103,16645,'fr','0',0),(597104,16646,'fr','0',0),(597105,16647,'fr','0',0),(597106,16648,'fr','0',0),(597107,16649,'fr','0',0),(597108,16650,'fr','0',0),(597109,16651,'fr','0',0),(597110,16652,'fr','0',0),(597111,16653,'fr','0',0),(597112,16654,'fr','0',0),(597113,16655,'fr','0',0),(597114,16656,'fr','0',0),(597115,16657,'fr','0',0),(597116,16658,'fr','0',0),(597117,16659,'fr','0',0),(597118,16660,'fr','0',0),(597119,16661,'fr','0',0),(597120,16662,'fr','0',0),(597121,16663,'fr','0',0),(597122,16664,'fr','0',0),(597123,16665,'fr','0',0),(597124,16666,'fr','0',0),(597125,16667,'fr','0',0),(597126,16668,'fr','0',0),(597127,16669,'fr','0',0),(597128,16670,'fr','0',0),(597129,16671,'fr','0',0),(597130,16672,'fr','0',0),(597131,16673,'fr','0',0),(597132,16674,'fr','0',0),(597133,16675,'fr','0',0),(597134,16676,'fr','0',0),(597135,16677,'fr','0',0),(597136,16678,'fr','0',0),(597137,16679,'fr','0',0),(597138,16680,'fr','0',0),(597139,16681,'fr','0',0),(597140,16682,'fr','0',0),(597141,16683,'fr','0',0),(597142,16684,'fr','0',0),(597143,16685,'fr','0',0),(597144,16686,'fr','0',0),(597145,16687,'fr','0',0),(597146,16688,'fr','0',0),(597147,16689,'fr','0',0),(597148,16690,'fr','0',0),(597149,16691,'fr','0',0),(597150,16692,'fr','0',0),(597151,16693,'fr','0',0),(597152,16694,'fr','0',0),(597153,16695,'fr','0',0),(597154,16696,'fr','0',0),(597155,16697,'fr','0',0),(597156,16698,'fr','0',0),(597157,16699,'fr','0',0),(597158,16700,'fr','0',0),(597159,16701,'fr','0',0),(597160,16702,'fr','0',0),(597161,16703,'fr','0',0),(597162,16704,'fr','0',0),(597163,16705,'fr','0',0),(597164,16706,'fr','0',0),(597165,16707,'fr','0',0),(597166,16708,'fr','0',0),(597167,16709,'fr','0',0),(597168,16710,'fr','0',0),(597169,16711,'fr','0',0),(597170,16712,'fr','0',0),(597171,16713,'fr','0',0),(597172,16714,'fr','0',0),(597173,16715,'fr','0',0),(597174,16716,'fr','0',0),(597175,16717,'fr','0',0),(597176,16503,'de','0',0),(597177,16504,'de','0',0),(597178,16505,'de','0',0),(597179,16506,'de','0',0),(597180,16507,'de','0',0),(597181,16508,'de','0',0),(597182,16509,'de','0',0),(597183,16510,'de','0',0),(597184,16511,'de','0',0),(597185,16512,'de','0',0),(597186,16513,'de','0',0),(597187,16514,'de','0',0),(597188,16515,'de','0',0),(597189,16516,'de','0',0),(597190,16517,'de','0',0),(597191,16518,'de','0',0),(597192,16519,'de','0',0),(597193,16520,'de','0',0),(597194,16521,'de','0',0),(597195,16522,'de','0',0),(597196,16523,'de','0',0),(597197,16524,'de','0',0),(597198,16525,'de','0',0),(597199,16526,'de','0',0),(597200,16527,'de','0',0),(597201,16528,'de','0',0),(597202,16529,'de','0',0),(597203,16530,'de','0',0),(597204,16531,'de','0',0),(597205,16532,'de','0',0),(597206,16533,'de','0',0),(597207,16534,'de','0',0),(597208,16535,'de','0',0),(597209,16536,'de','0',0),(597210,16537,'de','0',0),(597211,16538,'de','0',0),(597212,16539,'de','0',0),(597213,16540,'de','0',0),(597214,16541,'de','0',0),(597215,16542,'de','0',0),(597216,16543,'de','0',0),(597217,16544,'de','0',0),(597218,16545,'de','0',0),(597219,16546,'de','0',0),(597220,16719,'en','Fill Day',0),(597221,16720,'en','Last Appointment',0),(597222,16718,'en','Patient Import',0),(597223,16721,'en','Please 777 chmod',0),(597224,16722,'en','All Appointments',0),(597225,16723,'en','Book This Appointment',0),(597226,16724,'en','Command Not Found',0),(597227,16725,'en','Confirm Appointment Time',0),(597228,16726,'en','Feature Not Enabled',0),(597229,16727,'en','Next Appointment',0),(597230,16728,'en','No Upcoming Appointment',0),(597231,16729,'en','Open Appointments For',0),(597232,16732,'en','Schedule An Appointment',0),(597233,16730,'en','Select A Date To View Open Appointments',0),(597234,16733,'en','Select Date',0),(597235,16731,'en','Where',0),(597236,16739,'en','Include Quotes',0),(597237,16734,'en','Inventory Adjustment Request Type',0),(597238,16735,'en','Inventory Adjustment Request Type By This Code Already Exists',0),(597239,16736,'en','Inventory Adjustment Request Type Code Must Be Set',0),(597240,16738,'en','Log In As This User',0),(597241,16737,'en','Post By Shipping & Receiving',0),(597242,16718,'af','PasiÃ«nt invoer',0),(597243,16719,'af','Vul dag',0),(597244,16720,'af','Laaste afspraak',0),(597245,16721,'af','Asseblief 777 chmod',0),(597246,16722,'af','Alle afsprake',0),(597247,16723,'af','Bespreek hierdie aanstelling',0),(597248,16724,'af','Bevel nie gevind nie',0),(597249,16725,'af','Bevestig afspraak tyd',0),(597250,16726,'af','Kenmerk nie geaktiveer',0),(597251,16727,'af','Volgende afspraak',0),(597252,16728,'af','Geen opkomende aanstelling',0),(597253,16729,'af','Oop afsprake vir',0),(597254,16730,'af','Kies \'n datum te bekyk oop afsprake',0),(597255,16731,'af','Waar',0),(597256,16732,'af','Skeduleer \'n afspraak',0),(597257,16733,'af','Kies datum',0),(597258,16734,'af','Inventaris aanpassing versoek tipe',0),(597259,16735,'af','Inventaris aanpassing versoek tipe deur hierdie kode bestaan reeds',0),(597260,16736,'af','Inventaris aanpassing versoek tipe kode moet opgestel word',0),(597261,16737,'af','Post deur gestuur en ontvang',0),(597262,16738,'af','As hierdie gebruiker aanteken',0),(597263,16739,'af','Sluit aanhalings',0),(597264,16718,'ar','Ø§Ø³ØªÙŠØ±Ø§Ø¯ Ø§Ù„Ù…Ø±ÙŠØ¶',0),(597265,16719,'ar','Ø´ØºÙ„ Ø§Ù„ÙŠÙˆÙ…',0),(597266,16720,'ar','Ø§Ù„ØªØ¹ÙŠÙŠÙ† Ø§Ù„Ø£Ø®ÙŠØ±',0),(597267,16721,'ar','Ø§Ù„Ø±Ø¬Ø§Ø¡ 777 chmod',0),(597268,16722,'ar','ÙƒØ§ÙØ© Ø§Ù„Ù…ÙˆØ§Ø¹ÙŠØ¯',0),(597269,16723,'ar','Ø§Ø­Ø¬Ø² Ù‡Ø°Ø§ Ø§Ù„ØªØ¹ÙŠÙŠÙ†',0),(597270,16724,'ar','Ù„Ù… ÙŠØªÙ… Ø§Ù„Ø¹Ø«ÙˆØ± Ø¹Ù„Ù‰ Ø§Ù„Ø£ÙˆØ§Ù…Ø±',0),(597271,16725,'ar','ØªØ£ÙƒÙŠØ¯ ØªØ¹ÙŠÙŠÙ† Ø§Ù„ÙˆÙ‚Øª',0),(597272,16726,'ar','Ù„Ù… ÙŠØªÙ… ØªÙ…ÙƒÙŠÙ† Ù…ÙŠØ²Ø©',0),(597273,16727,'ar','Ø§Ù„Ù…ÙˆØ¹Ø¯ Ø§Ù„ØªØ§Ù„ÙŠ',0),(597274,16728,'ar','Ù„Ø§ ÙŠÙˆØ¬Ø¯ Ù…ÙˆØ¹Ø¯ Ù‚Ø§Ø¯Ù…',0),(597275,16729,'ar','Ù…ÙˆØ§Ø¹ÙŠØ¯ ÙØªØ­',0),(597276,16730,'ar','Ù‚Ù… Ø¨ØªØ­Ø¯ÙŠØ¯ ØªØ§Ø±ÙŠØ® Ù„Ø¹Ø±Ø¶ Ø§Ù„Ù…ÙˆØ§Ø¹ÙŠØ¯ Ø§Ù„Ù…ÙØªÙˆØ­Ø©',0),(597277,16731,'ar','Ø­ÙŠØ«',0),(597278,16732,'ar','Ø¬Ø¯ÙˆÙ„Ø© Ù…ÙˆØ¹Ø¯',0),(597279,16733,'ar','Ø­Ø¯Ø¯ ØªØ§Ø±ÙŠØ®',0),(597280,16734,'ar','Ù†ÙˆØ¹ Ø·Ù„Ø¨ ØªØ³ÙˆÙŠØ© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(597281,16735,'ar','Ù†ÙˆØ¹ Ø·Ù„Ø¨ ØªØ³ÙˆÙŠØ© Ø§Ù„Ù…Ø®Ø²ÙˆÙ† Ø¨Ù‡Ø°Ù‡ Ø§Ù„ØªØ¹Ù„ÙŠÙ…Ø§Øª Ø§Ù„Ø¨Ø±Ù…Ø¬ÙŠØ© Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø§Ù„ÙØ¹Ù„',0),(597282,16736,'ar','ÙŠØ¬Ø¨ Ø£Ù† ÙŠØªÙ… ØªØ¹ÙŠÙŠÙ† Ø±Ù…Ø² Ù†ÙˆØ¹ Ø·Ù„Ø¨ ØªØ³ÙˆÙŠØ© Ø§Ù„Ù…Ø®Ø²ÙˆÙ†',0),(597283,16737,'ar','ÙˆØ¸ÙŠÙØ© Ø¹Ù† Ø·Ø±ÙŠÙ‚ Ø§Ù„Ø´Ø­Ù† & ØªÙ„Ù‚ÙŠ',0),(597284,16738,'ar','ØªØ³Ø¬ÙŠÙ„ Ø§Ù„Ø¯Ø®ÙˆÙ„ ÙƒÙ…Ø³ØªØ®Ø¯Ù… Ù‡Ø°Ø§',0),(597285,16739,'ar','ØªØ¶Ù…ÙŠÙ† Ø¹Ù„Ø§Ù…Ø§Øª Ø§Ù„Ø§Ù‚ØªØ¨Ø§Ø³',0),(597286,16718,'bg','ÐŸÐ°Ñ†Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð¸Ñ€Ð°Ð½Ðµ',0),(597287,16719,'bg','ÐŸÐ¾Ð¿ÑŠÐ»Ð½ÐµÑ‚Ðµ Ð´ÐµÐ½',0),(597288,16720,'bg','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½Ð° ÑÑ€ÐµÑ‰Ð°',0),(597289,16721,'bg','ÐœÐ¾Ð»Ñ 777 chmod',0),(597290,16722,'bg','Ð’ÑÐ¸Ñ‡ÐºÐ¸ ÑÑ€ÐµÑ‰Ð¸',0),(597291,16723,'bg','ÐšÐ½Ð¸Ð³Ð° Ñ‚Ð°Ð·Ð¸ ÑÑ€ÐµÑ‰Ð°',0),(597292,16724,'bg','ÐšÐ¾Ð¼Ð°Ð½Ð´Ð° Ð½Ðµ Ðµ Ð½Ð°Ð¼ÐµÑ€ÐµÐ½Ð¾',0),(597293,16725,'bg','ÐŸÐ¾Ñ‚Ð²ÑŠÑ€Ð´ÐµÑ‚Ðµ Ð²Ñ€ÐµÐ¼Ðµ Ð½Ð° ÑÑ€ÐµÑ‰Ð°Ñ‚Ð°',0),(597294,16726,'bg','ÐÐµ Ð¾Ð¿Ñ†Ð¸Ñ',0),(597295,16727,'bg','Ð¡Ð»ÐµÐ´Ð²Ð°Ñ‰Ð° ÑÑ€ÐµÑ‰Ð°',0),(597296,16728,'bg','ÐÑÐ¼Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸ ÑÑ€ÐµÑ‰Ð¸',0),(597297,16729,'bg','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ ÑÑ€ÐµÑ‰Ð¸ Ð·Ð°',0),(597298,16730,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð°, Ð·Ð° Ð´Ð° Ð²Ð¸Ð´Ð¸Ñ‚Ðµ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ ÑÑ€ÐµÑ‰Ð¸',0),(597299,16731,'bg','ÐšÑŠÐ´ÐµÑ‚Ð¾',0),(597300,16732,'bg','Ð“Ñ€Ð°Ñ„Ð¸Ðº Ð·Ð° ÑÑ€ÐµÑ‰Ð°',0),(597301,16733,'bg','Ð˜Ð·Ð±ÐµÑ€ÐµÑ‚Ðµ Ð´Ð°Ñ‚Ð°',0),(597302,16734,'bg','Ð¡ÐºÐ»Ð°Ð´Ð° Ð²Ð¸Ð´ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ Ð·Ð°ÑÐ²ÐºÐ°',0),(597303,16735,'bg','Ð¡ÐºÐ»Ð°Ð´ Ñ‚Ð¸Ð¿ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ Ð¸ÑÐºÐ°Ð½Ðµ Ð¾Ñ‚ Ñ‚Ð¾Ð·Ð¸ ÐºÐ¾Ð´ Ð²ÐµÑ‡Ðµ ÑÑŠÑ‰ÐµÑÑ‚Ð²ÑƒÐ²Ð°',0),(597304,16736,'bg','Ð¢Ð¸Ð¿ ÐºÐ¾Ð´ ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ Ð·Ð°ÑÐ²ÐºÐ° Ð·Ð°Ð¿Ð°ÑÐ¸ Ñ‚Ñ€ÑÐ±Ð²Ð° Ð´Ð° ÑÐµ Ð¾Ð¿Ñ€ÐµÐ´ÐµÐ»Ð¸',0),(597305,16737,'bg','ÐœÐ½ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ ÐºÐ¾Ñ€Ð°Ð±Ð¾Ð¿Ð»Ð°Ð²Ð°Ð½ÐµÑ‚Ð¾ & Ð¿Ð¾Ð»ÑƒÑ‡Ð°Ð²Ð°Ð½Ðµ',0),(597306,16738,'bg','Ð’Ð»ÐµÐ·Ñ‚Ðµ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ð°Ñ‚Ð° ÐºÐ°Ñ‚Ð¾ Ñ‚Ð¾Ð·Ð¸ Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð¸Ñ‚ÐµÐ»',0),(597307,16739,'bg','Ð’ÐºÐ»ÑŽÑ‡Ð²Ð° Ñ†Ð¸Ñ‚Ð°Ñ‚Ð¸',0),(597308,16718,'zh','ç—…äººçš„å¯¼å…¥',0),(597309,16719,'zh','å¡«è¡¥ä¸€å¤©',0),(597310,16720,'zh','æœ€åŽä¸€ä¸ªçº¦ä¼š',0),(597311,16721,'zh','è¯· 777 chmod',0),(597312,16722,'zh','æ‰€æœ‰çº¦ä¼š',0),(597313,16723,'zh','é¢„è®¢æ­¤çº¦ä¼š',0),(597314,16724,'zh','æ‰¾ä¸åˆ°å‘½ä»¤',0),(597315,16725,'zh','ç¡®è®¤é¢„çº¦æ—¶é—´',0),(597316,16726,'zh','æœªå¯ç”¨çš„åŠŸèƒ½',0),(597317,16727,'zh','ä¸‹ä¸€æ¬¡çº¦ä¼š',0),(597318,16728,'zh','æ²¡æœ‰é¢„å®šçš„çº¦ä¼š',0),(597319,16729,'zh','å¼€æ”¾é¢„çº¦',0),(597320,16730,'zh','é€‰æ‹©è¦æŸ¥çœ‹æ‰“å¼€çš„æ‰€æœ‰çº¦ä¼šçš„æ—¥æœŸ',0),(597321,16731,'zh','åœ¨å“ªé‡Œ',0),(597322,16732,'zh','å®‰æŽ’çº¦ä¼š',0),(597323,16733,'zh','é€‰æ‹©æ—¥æœŸ',0),(597324,16734,'zh','åº“å­˜è°ƒæ•´è¯·æ±‚ç±»åž‹',0),(597325,16735,'zh','åº“å­˜è°ƒæ•´è¯·æ±‚ç±»åž‹çš„æ­¤ä»£ç å·²å­˜åœ¨',0),(597326,16736,'zh','å¿…é¡»è®¾ç½®åº“å­˜è°ƒæ•´è¯·æ±‚ç±»åž‹ä»£ç ',0),(597327,16737,'zh','åŽé€šè¿‡ä¼ é€ä¸ŽæŽ¥æ”¶',0),(597328,16738,'zh','ä½œä¸ºæ­¤ç”¨æˆ·ç™»å½•',0),(597329,16739,'zh','åŒ…å«å¼•å·',0),(597330,16718,'da','Patient Import',0),(597331,16719,'da','Fylde dagen',0),(597332,16720,'da','Sidste udnÃ¦vnelse',0),(597333,16721,'da','Venligst 777 chmod',0),(597334,16722,'da','Alle aftaler',0),(597335,16723,'da','Bestille denne udnÃ¦vnelse',0),(597336,16724,'da','Kommandoen blev ikke fundet',0),(597337,16725,'da','BekrÃ¦fte aftaletidspunkt',0),(597338,16726,'da','Funktionen er ikke aktiveret',0),(597339,16727,'da','NÃ¦ste aftale',0),(597340,16728,'da','Ingen kommende udnÃ¦vnelse',0),(597341,16729,'da','Ã…bne aftaler For',0),(597342,16730,'da','VÃ¦lg en dato for at se Ã¥bne aftaler',0),(597343,16731,'da','Hvor',0),(597344,16732,'da','PlanlÃ¦gge en aftale',0),(597345,16733,'da','VÃ¦lg dato',0),(597346,16734,'da','Lageret reguleringstypen anmodning',0),(597347,16735,'da','Lageret reguleringstypen anmodning om denne kode findes allerede',0),(597348,16736,'da','Lageret regul.placeringskode anmodning Type skal angives',0),(597349,16737,'da','IndlÃ¦g ved forsendelse & modtager',0),(597350,16738,'da','Log ind som denne bruger',0),(597351,16739,'da','Omfatte citater',0),(597352,16718,'dr','ÙˆØ§Ø±Ø¯Ø§Øª Ø¨ÛŒÙ…Ø§Ø±',0),(597353,16719,'dr','Ø±ÙˆØ² Ø±Ø§ Ù¾Ø± Ú©Ù†ÛŒØ¯',0),(597354,16720,'dr','Ø¢Ø®Ø±ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª',0),(597355,16721,'dr','Ù„Ø·ÙØ§ Ø³Ø·Ø­ Ø¯Ø³ØªØ±Ø³ÛŒ 777',0),(597356,16722,'dr','Ù‡Ù…Ù‡ Ù…Ù„Ø§Ù‚Ø§ØªÙ‡Ø§',0),(597357,16723,'dr','Ú©ØªØ§Ø¨ Ø§ÛŒÙ† ÙˆÙ‚Øª',0),(597358,16724,'dr','ÙØ±Ù…Ø§Ù† ÛŒØ§ÙØª Ù†Ø´Ø¯',0),(597359,16725,'dr','ØªØ§ÛŒÛŒØ¯ Ø³Ø§Ø¹ØªØ´',0),(597360,16726,'dr','Ù‚Ø§Ø¨Ù„ÛŒØª ÙØ¹Ø§Ù„ Ù†ÛŒØ³Øª',0),(597361,16727,'dr','Ù…Ù„Ø§Ù‚Ø§Øª Ø¨Ø¹Ø¯ÛŒ',0),(597362,16728,'dr','Ù‡ÛŒÚ† ÙˆÙ‚Øª Ø¢ÛŒÙ†Ø¯Ù‡',0),(597363,16729,'dr','Ø¨Ø§Ø² ÙˆÙ‚Øª Ù…Ù„Ø§Ù‚Ø§Øª Ø¨Ø±Ø§ÛŒ',0),(597364,16730,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø±ÛŒØ® Ø¨Ø±Ø§ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª Ù‡Ø§ Ø¨Ø§Ø²',0),(597365,16731,'dr','Ú©Ù‡ Ø¯Ø± Ø¢Ù†',0),(597366,16732,'dr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù…Ù„Ø§Ù‚Ø§Øª',0),(597367,16733,'dr','Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø±ÛŒØ®',0),(597368,16734,'dr','Ù†ÙˆØ¹ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(597369,16735,'dr','Ù†ÙˆØ¹ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ ØªÙˆØ³Ø· Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(597370,16736,'dr','ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø¯ Ù†ÙˆØ¹ Ø¨Ø§ÛŒØ¯ ØªØ¹ÛŒÛŒÙ† Ø´ÙˆØ¯',0),(597371,16737,'dr','Ù¾Ø³Øª Ø¨Ø§ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ & Ø¯Ø±ÛŒØ§ÙØª',0),(597372,16738,'dr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ú©Ø§Ø±Ø¨Ø± Ø§ÛŒÙ†',0),(597373,16739,'dr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø¹Ø¨Ø§Ø±ØªÙ†Ø¯ Ø§Ø²:',0),(597374,16718,'nl','PatiÃ«nt importeren',0),(597375,16719,'nl','Vullen van de dag',0),(597376,16720,'nl','Laatste afspraak',0),(597377,16721,'nl','Gelieve 777 chmod',0),(597378,16722,'nl','Alle afspraken',0),(597379,16723,'nl','Deze afspraak',0),(597380,16724,'nl','Troepenleiding niet stichten',0),(597381,16725,'nl','Tijdstip afspraak bevestigen',0),(597382,16726,'nl','Functie niet ingeschakeld',0),(597383,16727,'nl','Volgende afspraak',0),(597384,16728,'nl','Geen aankomende afspraak',0),(597385,16729,'nl','Open afspraken voor',0),(597386,16730,'nl','Selecteer een datum om te Open afspraken bekijken',0),(597387,16731,'nl','Waar',0),(597388,16732,'nl','Afspraak plannen',0),(597389,16733,'nl','Selecteer datum',0),(597390,16734,'nl','Inventaris aanpassing verzoektype',0),(597391,16735,'nl','Inventaris herwaarderingssoort van de aanvraag door deze Code bestaat al',0),(597392,16736,'nl','Inventaris aanpassing verzoek Type Code moet worden ingesteld',0),(597393,16737,'nl','Post door verzending & ontvangen',0),(597394,16738,'nl','Als deze gebruiker inloggen',0),(597395,16739,'nl','Aanhalingstekens opnemen',0),(597396,16718,'et','Patsiendi Import',0),(597397,16719,'et','TÃ¤ida pÃ¤ev',0),(597398,16720,'et','Viimase kohtumise',0),(597399,16721,'et','Palun 777 chmod',0),(597400,16722,'et','KÃµik kohtumised',0),(597401,16723,'et','Broneerige kohtumine',0),(597402,16724,'et','KÃ¤sk ei leitud',0),(597403,16725,'et','Kinnita aeg:',0),(597404,16726,'et','Funktsioon pole lubatud',0),(597405,16727,'et','JÃ¤rgmine kohtumine',0),(597406,16728,'et','Tulemas ametisse nimetamisel',0),(597407,16729,'et','Avatud kohtumisi',0),(597408,16730,'et','Vali Vaata avatud kohtumised',0),(597409,16731,'et','Kui',0),(597410,16732,'et','Broneeri aeg',0),(597411,16733,'et','Valige kuupÃ¤ev',0),(597412,16734,'et','Varude tÃ¤psustuse taotluse liik',0),(597413,16735,'et','Varude tÃ¤psustuse taotluse liik kÃ¤esolevas seadustikus on juba olemas',0),(597414,16736,'et','Kaubavaru korrigeerimise taotluse kood peab olema mÃ¤Ã¤ratud',0),(597415,16737,'et','Post By Shipping & saava',0),(597416,16738,'et','Logi sisse kui kasutaja',0),(597417,16739,'et','Sisaldavad hinnapakkumisi',0),(597418,16718,'fi','Potilaan tuonti',0),(597419,16719,'fi','TÃ¤yttÃ¤Ã¤ pÃ¤ivÃ¤',0),(597420,16720,'fi','Viime nimityksen',0),(597421,16721,'fi','Ota 777 chmod',0),(597422,16722,'fi','Kaikki tapaamiset',0),(597423,16723,'fi','Varaa tapaaminen',0),(597424,16724,'fi','Komento ei lÃ¶ytynyt',0),(597425,16725,'fi','Vahvista tapaamisaika',0),(597426,16726,'fi','Ei kÃ¤ytÃ¶ssÃ¤',0),(597427,16727,'fi','Seuraava tapaaminen',0),(597428,16728,'fi','Ei tulevia nimittÃ¤minen',0),(597429,16729,'fi','Avoimia tapaamisia',0),(597430,16730,'fi','Valitse pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤, Katso avoimet tapaamiset',0),(597431,16731,'fi','Jos',0),(597432,16732,'fi','Ajoita tapaaminen',0),(597433,16733,'fi','Valitse pÃ¤ivÃ¤mÃ¤Ã¤rÃ¤',0),(597434,16734,'fi','Varaston muutoksen pyynnÃ¶n tyyppi',0),(597435,16735,'fi','Varaston muutoksen pyynnÃ¶n tyyppi tÃ¤ssÃ¤ koodeksissa on jo olemassa',0),(597436,16736,'fi','Varaston oikaisu pyynnÃ¶n tyyppikoodi on mÃ¤Ã¤ritettÃ¤vÃ¤',0),(597437,16737,'fi','Post By toimitus & vastaanottaminen',0),(597438,16738,'fi','Kirjaudu sisÃ¤Ã¤n tÃ¤llÃ¤ kÃ¤yttÃ¤jÃ¤tunnuksella',0),(597439,16739,'fi','LainausmerkkejÃ¤',0),(597440,16718,'fr','Importation de patients',0),(597441,16719,'fr','Remplir jour',0),(597442,16720,'fr','Dernier rendez-vous',0),(597443,16721,'fr','Sâ€™il vous plaÃ®t de chmod 777',0),(597444,16722,'fr','Toutes les nominations',0),(597445,16723,'fr','Ce rendez vous',0),(597446,16724,'fr','Commande non trouvÃ©e',0),(597447,16725,'fr','Confirmer lâ€™heure de rendez-vous',0),(597448,16726,'fr','FonctionnalitÃ© non activÃ©e',0),(597449,16727,'fr','Prochain rendez-vous',0),(597450,16728,'fr','Aucun rendez-vous Ã  venir',0),(597451,16729,'fr','Rendez-vous ouverts pour',0),(597452,16730,'fr','SÃ©lectionnez une Date pour afficher les rendez-vous ouverts',0),(597453,16731,'fr','OÃ¹',0),(597454,16732,'fr','Planifier un rendez-vous',0),(597455,16733,'fr','SÃ©lectionnez la Date',0),(597456,16734,'fr','Type de demande de rajustement lâ€™inventaire',0),(597457,16735,'fr','Type de demande de rajustement de lâ€™inventaire par le prÃ©sent Code existe dÃ©jÃ ',0),(597458,16736,'fr','Code de Type de demande de rajustement lâ€™inventaire doit avoir la valeur',0),(597459,16737,'fr','Post par expÃ©dition & recevant',0),(597460,16738,'fr','Connectez-vous en tant que cet utilisateur',0),(597461,16739,'fr','Inclure les devis',0),(597462,16547,'de','Intercompany-Transfer Fracht Last',0),(597463,16548,'de','Anpassung Anfrage Inventartypen',0),(597464,16549,'de','BestandsprÃ¼fung Neuanforderung',0),(597465,16550,'de','Staging-Bereiche',0),(597466,16551,'de','Staging-Bereich',0),(597467,16552,'de','Konto falsch eingeben',0),(597468,16553,'de','Anzahl nicht finden Konto mit Namen',0),(597469,16554,'de','Anzahl nicht Girokonto namentlich finden',0),(597470,16555,'de','Graf Versandart nach Namen nicht finden',0),(597471,16556,'de','Spiele Muliple Anbieter',0),(597472,16557,'de','Postleitzahl oder Zustand',0),(597473,16558,'de','VerkÃ¤ufer-ID',0),(597474,16559,'de','VerkÃ¤ufer-ID oder Name muss eingestellt werden',0),(597475,16560,'de','Status-Code',0),(597476,16561,'de','Kreditorenunternehmen Name oder Nachname muss eingestellt werden',0),(597477,16562,'de','Bankleitzahl',0),(597478,16563,'de','Standard-Pay-Verfahren',0),(597479,16564,'de','Herstellercode muss eingestellt werden',0),(597480,16565,'de','Leere',0),(597481,16566,'de','Kein Typ Set',0),(597482,16567,'de','Termine gebucht',0),(597483,16568,'de','Termine Ã¶ffnen',0),(597484,16569,'de','Termine heute',0),(597485,16570,'de','Termine Gesamt',0),(597486,16571,'de','Termin-LÃ¤nge',0),(597487,16572,'de','Terminliste fÃ¼r',0),(597488,16573,'de','Treffpunkt',0),(597489,16574,'de','Termin-Namen',0),(597490,16575,'de','Termin-Ãœbersicht',0),(597491,16576,'de','B2B-Terminplaner',0),(597492,16577,'de','Erstellen von Termin-Ã–ffnungen',0),(597493,16578,'de','Offener Termin lÃ¶schen',0),(597494,16579,'de','ZukÃ¼nftigen Termin',0),(597495,16580,'de','WÃ¤hlen Sie ein Datum zu sehen & Bearbeiten von Terminen',0),(597496,16581,'de','Zusammenfassung anzeigen',0),(597497,16582,'de','Unbook Termin',0),(597498,16583,'de','FÃ¼gen Sie neue County',0),(597499,16584,'de','County-Name',0),(597500,16585,'de','Ãœbergeordneten Status',0),(597501,16586,'de','Sie mÃ¼ssen einen County-Namen eingeben.',0),(597502,16587,'de','Sie mÃ¼ssen ein Bundesland auswÃ¤hlen.',0),(597503,16588,'de','Sind Sie sicher, dass Sie dieser Gemeinde lÃ¶schen mÃ¶chten?',0),(597504,16589,'de','Delete County',0),(597505,16590,'de','Edit Custom County',0),(597506,16591,'de','ErwÃ¤gung ziehen, einen neuen Landkreis',0),(597507,16592,'de','Edit County',0),(597508,16593,'de','Ihre Auswahl ist ein Systemwert und kann nicht geÃ¤ndert werden',0),(597509,16594,'de','Sie mÃ¼ssen das Formular weiterhin ausfÃ¼llen.',0),(597510,16595,'de','Kunden hinzugefÃ¼gt',0),(597511,16596,'de','Kunden, die Ã¼bersprungen',0),(597512,16597,'de','Kunden auf dem laufenden',0),(597513,16598,'de','Zeilen lesen',0),(597514,16599,'de','Alternative Telefonnummer',0),(597515,16600,'de','CSV-Datei importieren',0),(597516,16601,'de','Mobilfunkanbieter',0),(597517,16602,'de','Handy-Nummer',0),(597518,16603,'de','WÃ¤hlen Sie festgelegten Zahlungsbedingungen',0),(597519,16604,'de','Staatliche AbkÃ¼rzung',0),(597520,16605,'de','StraÃŸe und Hausnummer',0),(597521,16606,'de','HinzufÃ¼gen/bearbeiten',0),(597522,16607,'de','AVG-Umsatz pro Monat',0),(597523,16608,'de','Stromversorgung',0),(597524,16609,'de','Keine primÃ¤re Lagerplatz zugeordnet',0),(597525,16610,'de','Qty auf Ãœbertragung',0),(597526,16611,'de','Lager aus Verteilzentrum aufzufÃ¼llen',0),(597527,16612,'de','Vorgeschlagen',0),(597528,16613,'de','Qty Ã¼bertragen',0),(597529,16614,'de','Zone',0),(597530,16615,'de','StÃ¤dte hinzugefÃ¼gt',0),(597531,16616,'de','StÃ¤dte aktualisiert',0),(597532,16617,'de','Grafschaften hinzugefÃ¼gt',0),(597533,16618,'de','Grafschaften aktualisiert',0),(597534,16619,'de','Staaten hinzugefÃ¼gt',0),(597535,16620,'de','Staaten aktualisiert',0),(597536,16621,'de','Sind Sie sicher, dass Sie Ihre Umsatzsteuer-DatensÃ¤tze aktualisieren mÃ¶chten?',0),(597537,16622,'de','Name der Stadt',0),(597538,16623,'de','Stadt-Umsatzsteuer-Multiplikator',0),(597539,16624,'de','Stadt Verwendung Steuern Multiplikator',0),(597540,16625,'de','County-Umsatzsteuer-Multiplikator',0),(597541,16626,'de','Grafschaft Verwendung Steuern Multiplikator',0),(597542,16627,'de','Umsatzsteuer-Import',0),(597543,16628,'de','Staatliche Verkaufssteuer Multiplikator',0),(597544,16629,'de','Staatliche Nutzung Steuer Multiplikator',0),(597545,16630,'de','Thomson Reuters Registerkarte Datei',0),(597546,16631,'de','Vorhandene Daten',0),(597547,16632,'de','Halten Sie die bestehenden Daten',0),(597548,16633,'de','Alle vorhandene Daten lÃ¶schen',0),(597549,16634,'de','SpÃ¼len Sie Anbieter im Import vorhandene Daten',0),(597550,16635,'de','Ausstehende Lieferanten Kredite',0),(597551,16636,'de','Auto Select Umsatzsteuer vom Schiff zur',0),(597552,16637,'de','Auf ErfÃ¼llung und POS-Bestellungen',0),(597553,16638,'de','Nachlieferung nur von Distributionszentren ermÃ¶glichen',0),(597554,16639,'de','WÃ¤hlen Sie automatisch Umsatzsteuer vom Schiff zur ErfÃ¼llung und POS-Bestellungen',0),(597555,16640,'de','Letzte Direktlieferung erfordert POD',0),(597556,16641,'de','Schlagen Sie Alternativen Kauf Standorte bei der Menge nicht verfÃ¼gbar',0),(597557,16642,'de','Teilweisen Steuerbefreiung',0),(597558,16643,'de','Steuer Rate Prozent',0),(597559,16644,'de','Verteilzentrum Num Monate Vertrieb fÃ¼r Nachbestellung Berechnung',0),(597560,16645,'de','BranchenÃ¼bergreifenden Transfer Last Prozentsatz Fibukonto',0),(597561,16646,'de','Intercompany-Element Transfers - mehrere Speicherorte zulassen',0),(597562,16647,'de','Intercompany-Element Transfer - Buchung',0),(597563,16648,'de','Inventar im Transit Fibukonto',0),(597564,16649,'de','Verteilzentrum Num Monate Vertrieb fÃ¼r Nachbestellung Berechnung',0),(597565,16650,'de','Beitrag von Linie',0),(597566,16651,'de','Post von Versand und Empfang',0),(597567,16652,'de','B2B-User-Login',0),(597568,16653,'de','Melden Sie sich als dieser Benutzer',0),(597569,16654,'de','Als komplette Bestellung kann nicht gespeichert werden.',0),(597570,16655,'de','Kein POD-Dateianhang zu bestellen',0),(597571,16656,'de','Drop Ship',0),(597572,16657,'de','Archiv & speichern',0),(597573,16658,'de','Durch Kostencode geschlossen',0),(597574,16659,'de','Geschlossen von GL-Kategorie',0),(597575,16660,'de','SchlieÃŸen Sie die Konten von Kostencode',0),(597576,16661,'de','SchlieÃŸen Sie die Konten von GL-Kategorie',0),(597577,16662,'de','Datum abgebrochen',0),(597578,16663,'de','13.-Posten',0),(597579,16664,'de','Steuern anpassen Eintrag',0),(597580,16665,'de','Jahr Ende anpassen Eintrag',0),(597581,16666,'de','13. Zeit EintrÃ¤ge',0),(597582,16667,'de','Steuerliche KorrektureintrÃ¤ge',0),(597583,16668,'de','Mit Ende des Jahres einstellen EintrÃ¤ge',0),(597584,16669,'de','Non-Stock',0),(597585,16670,'de','Andere berechnen',0),(597586,16671,'de','Sonstige GebÃ¼hren',0),(597587,16672,'de','Transfer zwischen den Standorten',0),(597588,16673,'de','Details zu Ã¼bertragen',0),(597589,16674,'de','Nicht lagernd',0),(597590,16675,'de','Vermietung',0),(597591,16676,'de','Auf Lager',0),(597592,16677,'de','0 fÃ¼r keine Max',0),(597593,16678,'de','0 fÃ¼r keine Min',0),(597594,16679,'de','AVG Qty pro Monat',0),(597595,16680,'de','Erstellte Bestellung',0),(597596,16681,'de','Bestellung anlegen',0),(597597,16682,'de','Distributionszentren',0),(597598,16683,'de','LagerplÃ¤tze fÃ¼r Lagerbestand',0),(597599,16684,'de','Max auf Seite',0),(597600,16685,'de','Min auf der Seite',0),(597601,16686,'de','Mein Anbieter',0),(597602,16687,'de','NUM Monate Vertrieb fÃ¼r maximale auf der Seite',0),(597603,16688,'de','NUM Monate Vertrieb fÃ¼r Minimum auf der Seite',0),(597604,16689,'de','NUM Monate Vertrieb fÃ¼r Bestellmenge',0),(597605,16690,'de','Ist Standard-Artikellieferant?',0),(597606,16691,'de','Anzahl der Tage',0),(597607,16692,'de','Vorbereitungs-und Anlaufzeit zu zitieren',0),(597608,16693,'de','Einstellung dieser Anbieter als Standard fÃ¼r dieses Element wird entfernen andere Standard-Anbieter fÃ¼r diesen Artikel',0),(597609,16694,'de','Anbieter UPC',0),(597610,16695,'de','RTV-Anzahl',0),(597611,16696,'de','Nachlieferung',0),(597612,16697,'de','Diese Reihenfolge Schiff sinken kann nicht geÃ¤ndert werden.',0),(597613,16698,'de','Aktuelle Position',0),(597614,16699,'de','Auftrag hat Sendungen der Non-Drop Schiff Elemente',0),(597615,16700,'de','Bestellmenge, die am Standort nicht verfÃ¼gbar',0),(597616,16701,'de','Bestellmenge reduzieren',0),(597617,16702,'de','Die folgenden Non-Drop Schiff Elemente entfernt werden',0),(597618,16703,'de','Gutschein-ID',0),(597619,16704,'de','PrimÃ¤re KÃ¤ufer',0),(597620,16705,'de','Wenn County nicht auf Liste',0),(597621,16706,'de','Update-Aktion',0),(597622,16707,'de','Erfordern Sie Kosten Codes, wenn Fibukonto Codes gekostet hat',0),(597623,16708,'de','Erfordern Sie GL-Kategorie, wenn Fibukonto GL Kategorien hat',0),(597624,16709,'de','Verteilzentrum',0),(597625,16710,'de','Ist Verteilzentrum?',0),(597626,16711,'de','Eingecheckt',0),(597627,16712,'de','Ankunft',0),(597628,16713,'de','Jetzt einchecken',0),(597629,16714,'de','Check-In Zeit',0),(597630,16715,'de','Speichern von Notizen',0),(597631,16716,'de','Update-Hinweise',0),(597632,16717,'de','GL-Konto mit Namen konnte nicht gefunden werden.',0),(597633,16718,'de','Patienten Import',0),(597634,16719,'de','Tag zu fÃ¼llen',0),(597635,16720,'de','Letzter Termin',0),(597636,16721,'de','Bitte Chmod 777',0),(597637,16722,'de','Alle Termine',0),(597638,16723,'de','Buchen Sie diesen Termin',0),(597639,16724,'de','Befehl nicht gefunden',0),(597640,16725,'de','Termin zu bestÃ¤tigen',0),(597641,16726,'de','Funktion nicht aktiviert',0),(597642,16727,'de','NÃ¤chster Termin',0),(597643,16728,'de','Keine anstehenden Termin',0),(597644,16729,'de','Offene Termine fÃ¼r',0),(597645,16730,'de','WÃ¤hlen Sie ein Datum offene Termine anzeigen',0),(597646,16731,'de','Wo',0),(597647,16732,'de','Vereinbaren Sie einen Termin',0),(597648,16733,'de','WÃ¤hlen Sie Datum',0),(597649,16734,'de','Inventar Anpassung Anforderungstyp',0),(597650,16735,'de','Inventar Anpassung Anforderungstyp durch diesen Code ist bereits vorhanden.',0),(597651,16736,'de','Inventar Anpassung Anforderungscode Typ muss eingestellt werden',0),(597652,16737,'de','Per Post Versand & empfangen',0),(597653,16738,'de','Melden Sie sich als dieser Benutzer',0),(597654,16739,'de','AnfÃ¼hrungszeichen',0),(597655,16503,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î¹Î±Î²Î¬ÏƒÎµÎ¹ Ï„Î·Î½ ÎµÎ³Î³ÏÎ±Ï†Î®',0),(597656,16504,'el','Î”ÎµÎ½ Î®Ï„Î±Î½ Î´Ï…Î½Î±Ï„Î® Î· Ï€ÏÎ¿ÏƒÎ¸Î®ÎºÎ·',0),(597657,16505,'el','Î”ÎµÎ½ Î®Ï„Î±Î½ Î´Ï…Î½Î±Ï„Î® Î· ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(597658,16506,'el','ÎˆÎ½Ï„Ï…Ï€Î¿ ÎµÎ»Î»Î¹Ï€Î­Ï‚',0),(597659,16507,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î´Î¹Î±Î²Î¬ÏƒÎµÎ¹ Ï„Î¿ Î±ÏÏ‡ÎµÎ¯Î¿',0),(597660,16508,'el','Î‘Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹ Ï€ÏÏŒÏƒÎ¸ÎµÏ„Î¿ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î± Ï€ÎµÎ´Î¯Î±',0),(597661,16509,'el','Î’Î¬ÏÎ¿Ï‚ Ï†Î¿ÏÏ„Î¯Î¿Ï…',0),(597662,16510,'el','Î’Î¬ÏÎ¿Ï‚ Ï†Î¿ÏÏ„Î¯Î¿Ï…',0),(597663,16511,'el','Î ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Ï…Î½ Ï„Î¿ Ï„Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î­Ï„Î¿Ï…Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(597664,16512,'el','Î¤ÏÏ€Î¿Ï‚ Î±Î¯Ï„Î·ÏƒÎ·Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(597665,16513,'el','Î¤ÏÏ€Î¿Ï‚ Î±Î¯Ï„Î·ÏƒÎ·Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î±Ï€ÏŒ Ï„Î¿Î½ Ï€Î±ÏÏŒÎ½Ï„Î± ÎºÏŽÎ´Î¹ÎºÎ± Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(597666,16514,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï„ÏÏ€Î¿Ï… Î±Î¯Ï„Î·ÏƒÎ· Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(597667,16515,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬',0),(597668,16516,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Î· Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î´Î¹ÎµÏ„Î±Î¹ÏÎ¹ÎºÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Offset Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬',0),(597669,16517,'el','Î”Î¹ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ­Ï‚ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬ - ÎµÎºÏ„ÏÏ€Ï‰ÏƒÎ·',0),(597670,16518,'el','GL Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÎºÏ‡Ï‰ÏÎµÎ¯Ï„Î±Î¹ ÏƒÏ„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î® Ï„Î¿ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Ï€Î¿Ï… Î±Î½Ï„Î¹ÏƒÏ„Î¿Î¹Ï‡Î¯Î¶ÎµÏ„Î±Î¹ ÏƒÏ„Î·Î½ Ï€Î±ÏÎ±Î¼ÎµÏ„ÏÎ¿Ï€Î¿Î¯Î·ÏƒÎ· Î±Ï€Î¿Î¸ÎµÎ',0),(597671,16519,'el','NUM Î¼Î®Î½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³Î¹Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(597672,16520,'el','NUM Î¼Î®Î½ÎµÏ‚ Î· Î±Î½Î±Ï€Î»Î®ÏÏ‰ÏƒÎ·',0),(597673,16521,'el','Î‘Î½Î±Ï€Î»Î®ÏÏ‰ÏƒÎ·',0),(597674,16522,'el','Î‘Î½Î±Ï€Î»Î®ÏÏ‰ÏƒÎ· Î¼ÎµÏ„Î±Ï†Î¿ÏÎ­Ï‚',0),(597675,16523,'el','Î‘Ï€Î¿Î¸Î·ÎºÎµÏÏ„Î·ÎºÎµ ÏƒÎµ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬',0),(597676,16524,'el','Î‘Ï€Î¿Î´ÎµÎºÏ„Î® Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(597677,16525,'el','Î¤ÏÏ€Î¿Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î®Ï‚',0),(597678,16526,'el','Î Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Î½Î±Ï„ÎµÎ¸ÎµÎ¯',0),(597679,16527,'el','Î•ÎºÏ‡Ï‰ÏÎ·Î¼Î­Î½Î· Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(597680,16528,'el','Î¥Ï€Î¿Î»Î¿Î³Î¯Î¶Î¿Î½Ï„Î±Î¹',0),(597681,16529,'el','Î¤ÏÏ€Î¿Ï… Ï€Î»Î®Î¸Î¿Ï‚',0),(597682,16530,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Î±Î½Î±Ï„ÎµÎ¸ÎµÎ¯',0),(597683,16531,'el','ÎœÎµÏ„ÏÎ¹Î¿ÏÎ½Ï„Î±Î¹ Ï„Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î±',0),(597684,16532,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î±Ï€ÏŒ',0),(597685,16533,'el','Î¤Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ Ï…Ï€Î¿Î»Î¿Î³Î¯Î¶Î¿Î½Ï„Î±Î¹',0),(597686,16534,'el','Î¤ÏÏ€Î¿Ï‚ Î±Î¯Ï„Î·ÏƒÎ·Ï‚',0),(597687,16535,'el','Î‘Î¯Ï„Î·ÏƒÎ· ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(597688,16536,'el','Î‘Î¹Ï„Î®ÏƒÎµÏ‰Î½ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(597689,16537,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Î±Î¹Ï„Î®Î¼Î±Ï„Î¿Ï‚ ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(597690,16538,'el','Î”Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ· Ï„Î¹Î¼Î®Ï‚ Amt',0),(597691,16539,'el','Î‘Î¾Î¯Î± Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î´Î¹Î±ÎºÏÎ¼Î±Î½ÏƒÎ·Ï‚',0),(597692,16540,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± County',0),(597693,16541,'el','Î”Î¹Î¿ÏÎ¹ÏƒÎ¼ÏŒÏ‚ Ï‡ÏÎ¿Î½Î¿Î´Î¹Î±Î³ÏÎ¬Î¼Î¼Î±Ï„Î¿Ï‚',0),(597694,16542,'el','ÎšÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ· Î´Î¹Î±Ï‡ÎµÎ¯ÏÎ¹ÏƒÎ·Ï‚',0),(597695,16543,'el','Î ÎµÎ»Î¬Ï„Î· Ï€Î»Î·ÏÎ¿Ï†Î¿ÏÎ¯ÎµÏ‚ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®Ï‚',0),(597696,16544,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï€Ï‰Î»Î·Ï„Î®Ï‚ ÎµÎ´Î¬Ï†Î·',0),(597697,16545,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï†ÏŒÏÎ¿Ï… Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(597698,16546,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï„Î¬Î¾Î· Froms',0),(597699,16547,'el','Î”Î¹ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ­Ï‚ ÎµÏ€Î¹Î²Î¬ÏÏ…Î½ÏƒÎ· Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚ ÎµÎ¼Ï€Î¿ÏÎµÏ…Î¼Î¬Ï„Ï‰Î½',0),(597700,16548,'el','Î¤ÏÏ€Î¿Î¹ Î±Î¯Ï„Î·ÏƒÎ· Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(597701,16549,'el','ÎÎ­Î± Î±Î¯Ï„Î·ÏƒÎ· ÎµÎ»Î­Î³Ï‡Î¿Ï… Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½',0),(597702,16550,'el','Î£Ï„Î±Î´Î¹Î¿Ï€Î¿Î¯Î·ÏƒÎ· Ï€ÎµÏÎ¹Î¿Ï‡Î­Ï‚',0),(597703,16551,'el','Î ÎµÏÎ¹Î¿Ï‡Î® Î±Î½Î±ÏƒÏ…Î³ÎºÏÏŒÏ„Î·ÏƒÎ·Ï‚',0),(597704,16552,'el','Î›Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÏ„Îµ Î»Î¬Î¸Î¿Ï‚',0),(597705,16553,'el','ÎšÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ· Î´ÎµÎ½ Î²ÏÎµÎ¯Ï„Îµ Ï„Î¿ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒ Î¼Îµ Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(597706,16554,'el','ÎšÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ· Î´ÎµÎ½ Î²ÏÎµÎ¹ Ï„Î¿Î½ Î­Î»ÎµÎ³Ï‡Î¿ Ï„Î¿Ï… Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿Ï Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(597707,16555,'el','ÎšÎ±Ï„Î±Î¼Î­Ï„ÏÎ·ÏƒÎ· Î´ÎµÎ½ Î²ÏÎµÎ¯Ï„Îµ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î·Ï‚ Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(597708,16556,'el','Î‘Î³ÏŽÎ½ÎµÏ‚ Muliple Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚',0),(597709,16557,'el','Î¤Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÏŒÏ‚ ÎºÏŽÎ´Î¹ÎºÎ±Ï‚ Î® ÎºÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· Ï€Î¿Ï… Î±Ï€Î±Î¹Ï„ÎµÎ¯Ï„Î±Î¹',0),(597710,16558,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ',0),(597711,16559,'el','Î Ï‰Î»Î·Ï„Î®Ï‚ Î‘Î½Î±Î³Î½Ï‰ÏÎ¹ÏƒÏ„Î¹ÎºÏŒ Î® ÏŒÎ½Î¿Î¼Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(597712,16560,'el','ÎšÎ±Ï„Î¬ÏƒÏ„Î±ÏƒÎ· ÎšÏ‰Î´Î¹ÎºÏŒÏ‚',0),(597713,16561,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ Î· Ï€Ï‰Î»Î®Ï„ÏÎ¹Î± ÎµÏ„Î±Î¹ÏÎ¯Î± ÏŒÎ½Î¿Î¼Î± Î® ÎµÏ€ÏŽÎ½Ï…Î¼Î¿',0),(597714,16562,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î´ÏÎ¿Î¼Î¿Î»ÏŒÎ³Î·ÏƒÎ·Ï‚ Î¤ÏÎ¬Ï€ÎµÎ¶Î±Ï‚',0),(597715,16563,'el','Î ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î· Î¼Î­Î¸Î¿Î´Î¿Ï‚ Ï€Î»Î·ÏÏ‰Î¼Î®Ï‚',0),(597716,16564,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯ ÎºÏ‰Î´Î¹ÎºÏŒÏ‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(597717,16565,'el','ÎšÎµÎ½ÏŒ',0),(597718,16566,'el','Î¤Î¿ ÏƒÏÎ½Î¿Î»Î¿ Ï„Î¿Ï… Ï„ÏÏ€Î¿Ï… Î´ÎµÎ½',0),(597719,16567,'el','Î¡Î±Î½Ï„ÎµÎ²Î¿Ï',0),(597720,16568,'el','Î†Î½Î¿Î¹Î³Î¼Î± ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(597721,16569,'el','Î¡Î±Î½Ï„ÎµÎ²Î¿Ï ÏƒÎ®Î¼ÎµÏÎ±',0),(597722,16570,'el','Î£Ï…Î½Î±Î½Ï„Î®ÏƒÎµÎ¹Ï‚ ÏƒÏ…Î½Î¿Î»Î¹ÎºÎ¬',0),(597723,16571,'el','Î”Î¹Î¬ÏÎºÎµÎ¹Î± ÏƒÏ…Î½Î¬Î½Ï„Î·ÏƒÎ·Ï‚',0),(597724,16572,'el','Î¡Î±Î½Ï„ÎµÎ²Î¿Ï Î³Î¹Î±',0),(597725,16573,'el','Î¤Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î± ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(597726,16574,'el','ÎŒÎ½Î¿Î¼Î± ÏƒÏ…Î½Î¬Î½Ï„Î·ÏƒÎ·Ï‚',0),(597727,16575,'el','Î ÎµÏÎ¯Î»Î·ÏˆÎ· Î´Î¹Î¿ÏÎ¹ÏƒÎ¼Î¿Ï',0),(597728,16576,'el','Î’2Î’ ÏƒÏ…Î½Î¬Î½Ï„Î·ÏƒÎ· Ï‡ÏÎ¿Î½Î¿Î´Î¹Î±Î³ÏÎ¬Î¼Î¼Î±Ï„Î¿Ï‚',0),(597729,16577,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± ÏƒÏ…Î½Î¬Î½Ï„Î·ÏƒÎ·Ï‚ Î±Î½Î¿Î¯Î³Î¼Î±Ï„Î±',0),(597730,16578,'el','Î”Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Î½Î¿Î¹ÎºÏ„Î® ÏƒÏ…Î½Î¬Î½Ï„Î·ÏƒÎ·',0),(597731,16579,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î¿ Î¼ÎµÎ»Î»Î¿Î½Ï„Î¹ÎºÏŒ Î´Î¹Î¿ÏÎ¹ÏƒÎ¼ÏŒ',0),(597732,16580,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ & ÎµÏ€ÎµÎ¾ÎµÏÎ³Î¬ÏƒÎ¿Ï… Ï„Î± ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(597733,16581,'el','Î•Î¼Ï†Î¬Î½Î¹ÏƒÎ· ÏƒÏÎ½Î¿ÏˆÎ·Ï‚',0),(597734,16582,'el','Unbook ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(597735,16583,'el','Î ÏÎ¿ÏƒÎ¸Î­ÏƒÏ„Îµ Î½Î­Î¿ Î½Î¿Î¼ÏŒ',0),(597736,16584,'el','ÎŒÎ½Î¿Î¼Î± Ï„Î¿Ï… Î½Î¿Î¼Î¿Ï',0),(597737,16585,'el','Î“Î¿Î½Î¹ÎºÏŒ Î¼Î­Î»Î¿Ï‚',0),(597738,16586,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± Ï€Î»Î·ÎºÏ„ÏÎ¿Î»Î¿Î³Î®ÏƒÎµÏ„Îµ Î­Î½Î± ÏŒÎ½Î¿Î¼Î± County',0),(597739,16587,'el','Î ÏÎ­Ï€ÎµÎ¹ Î½Î± ÎµÏ€Î¹Î»Î­Î¾ÎµÏ„Îµ Î­Î½Î± ÎºÏÎ¬Ï„Î¿Ï‚',0),(597740,16588,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± Î´Î¹Î±Î³ÏÎ¬ÏˆÎµÏ„Îµ Î±Ï…Ï„ÏŒ Ï„Î¿ Î½Î¿Î¼ÏŒ;',0),(597741,16589,'el','Î”Î¹Î±Î³ÏÎ±Ï†Î® County',0),(597742,16590,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿ÏƒÎ¼Î­Î½Î· County',0),(597743,16591,'el','Î˜ÎµÏ‰ÏÎ®ÏƒÏ„Îµ Î¼Î¹Î± Î½Î­Î± ÎºÎ¿Î¼Î·Ï„ÎµÎ¯Î±',0),(597744,16592,'el','Î•Ï€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î± County',0),(597745,16593,'el','Î•Ï€Î¹Î»Î¿Î³Î® ÏƒÎ±Ï‚ ÎµÎ¯Î½Î±Î¹ Î— Î±Î¾Î¯Î± Ï„Î¿Ï… ÏƒÏ…ÏƒÏ„Î®Î¼Î±Ï„Î¿Ï‚ ÎºÎ±Î¹ Î´ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î»Î»Î¬Î¾ÎµÎ¹',0),(597746,16594,'el','Î˜Î± Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± ÏƒÏ…Î¼Ï€Î»Î·ÏÏŽÏƒÎµÏ„Îµ Ï„Î· Ï†ÏŒÏÎ¼Î± Î³Î¹Î± Î½Î± ÏƒÏ…Î½ÎµÏ‡Î¯ÏƒÎµÏ„Îµ',0),(597747,16595,'el','Î¤Î¿Ï…Ï‚ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¿Ï… Ï€ÏÎ¿ÏƒÏ„Î­Î¸Î·ÎºÎ±Î½',0),(597748,16596,'el','ÎŸÎ¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ Ï€Î±ÏÎ±Î»Î·Ï†Î¸ÎµÎ¯',0),(597749,16597,'el','ÎŸÎ¹ Ï€ÎµÎ»Î¬Ï„ÎµÏ‚ ÎµÎ½Î·Î¼ÎµÏÏŽÎ½Î¿Î½Ï„Î±Î¹',0),(597750,16598,'el','Î”Î¹Î±Î²Î¬ÏƒÏ„Îµ Ï„Î¹Ï‚ Î³ÏÎ±Î¼Î¼Î­Ï‚',0),(597751,16599,'el','Î•Î½Î±Î»Î»Î±ÎºÏ„Î¹ÎºÎ® Ï„Î·Î»Î­Ï†Ï‰Î½Î¿',0),(597752,16600,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±ÏÏ‡ÎµÎ¯Î¿Ï… CSV',0),(597753,16601,'el','ÎšÎ¹Î½Î·Ï„Î®Ï‚ Ï„Î·Î»ÎµÏ†Ï‰Î½Î¯Î±Ï‚',0),(597754,16602,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ ÎºÎ¹Î½Î·Ï„Î¿Ï Ï„Î·Î»ÎµÏ†ÏŽÎ½Î¿Ï…',0),(597755,16603,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Ï„Î¿Ï…Ï‚ ÏŒÏÎ¿Ï…Ï‚ Ï„Î¹Î¼Î¿Î»Î¿Î³Î¯Î¿Ï…',0),(597756,16604,'el','ÎšÏÎ±Ï„Î¹ÎºÎ® ÏƒÏ…Î½Ï„Î¿Î¼Î¿Î³ÏÎ±Ï†Î¯Î±',0),(597757,16605,'el','Î¤Î±Ï‡Ï…Î´ÏÎ¿Î¼Î¹ÎºÎ® Î´Î¹ÎµÏÎ¸Ï…Î½ÏƒÎ·',0),(597758,16606,'el','Î ÏÎ¿ÏƒÎ¸Î®ÎºÎ·/ÎµÏ€ÎµÎ¾ÎµÏÎ³Î±ÏƒÎ¯Î±',0),(597759,16607,'el','AVG Ï€Ï‰Î»Î®ÏƒÎµÎ¹Ï‚ Î±Î½Î¬ Î¼Î®Î½Î±',0),(597760,16608,'el','Î¤ÏÎ­Ï‡Ï‰Î½ Î±Î½ÎµÏ†Î¿Î´Î¹Î±ÏƒÎ¼ÏŒÏ‚',0),(597761,16609,'el','ÎšÎ±Î¼Î¯Î± ÎºÏÏÎ¹Î± ÎœÏ€Î¹Î½ Î±Î½Î±Ï„ÎµÎ¸ÎµÎ¯',0),(597762,16610,'el','Î Î¿Ïƒ / Ï„Î± ÏƒÎµ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬',0),(597763,16611,'el','Î‘Î½Î±Ï€Î»Î®ÏÏ‰ÏƒÎ· Ï„Ï‰Î½ Î±Ï€Î¿Î¸ÎµÎ¼Î¬Ï„Ï‰Î½ Î±Ï€ÏŒ Ï„Î¿ ÎºÎ­Î½Ï„ÏÎ¿ Î´Î¹Î±Î½Î¿Î¼Î®Ï‚',0),(597764,16612,'el','Î ÏÎ¿Ï„ÎµÎ¹Î½ÏŒÎ¼ÎµÎ½Î·',0),(597765,16613,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ Qty',0),(597766,16614,'el','Î–ÏŽÎ½Î·',0),(597767,16615,'el','Î ÏŒÎ»ÎµÎ¹Ï‚ Î­Ï‡Î¿Ï…Î½ Ï€ÏÎ¿ÏƒÏ„ÎµÎ¸ÎµÎ¯',0),(597768,16616,'el','Î ÏŒÎ»ÎµÎ¹Ï‚ Ï€Î¿Ï… Î­Ï‡Î¿Ï…Î½ ÎµÎ½Î·Î¼ÎµÏÏ‰Î¸ÎµÎ¯',0),(597769,16617,'el','ÎšÎ¿Î¼Î·Ï„ÎµÎ¯ÎµÏ‚ Ï€Î¿Ï… Ï€ÏÏŒÏƒÎ¸ÎµÏƒÎ±Î½',0),(597770,16618,'el','ÎšÎ¿Î¼Î·Ï„ÎµÎ¯ÎµÏ‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·',0),(597771,16619,'el','ÎšÏÎ¬Ï„Î· Î¼Î­Î»Î· Ï€Î¿Ï… Ï€ÏÏŒÏƒÎ¸ÎµÏƒÎ±Î½',0),(597772,16620,'el','Î•Î½Î·Î¼Î­ÏÏ‰ÏƒÎ· Î¼ÎµÎ»ÏŽÎ½',0),(597773,16621,'el','Î•Î¯ÏƒÏ„Îµ Î²Î­Î²Î±Î¹Î¿Î¹ ÏŒÏ„Î¹ Î¸Î­Î»ÎµÏ„Îµ Î½Î± ÎµÎ½Î·Î¼ÎµÏÏŽÏƒÎµÏ„Îµ Ï„Î¹Ï‚ ÎµÎ³Î³ÏÎ±Ï†Î­Ï‚ ÏƒÎ±Ï‚ Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½;',0),(597774,16622,'el','ÎŒÎ½Î¿Î¼Î± Ï€ÏŒÎ»Î·Ï‚',0),(597775,16623,'el','Î ÏŒÎ»Î· Ï†ÏŒÏÎ¿Ï… Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Ï€Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î®',0),(597776,16624,'el','Î ÏŒÎ»Î· Ï‡ÏÎ®ÏƒÎ· Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½ Ï€Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î®',0),(597777,16625,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î®Ï‚ County Ï†ÏŒÏÎ¿Ï‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(597778,16626,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î®Ï‚ Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÎ® Ï‡ÏÎ®ÏƒÎ· County',0),(597779,16627,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï… ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(597780,16628,'el','Î Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î®Ï‚ ÎºÏÎ±Ï„Î¹ÎºÏŒ Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½',0),(597781,16629,'el','ÎšÏÎ±Ï„Î¹ÎºÎ® Ï‡ÏÎ®ÏƒÎ· Ï†Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŽÎ½ Ï€Î¿Î»Î»Î±Ï€Î»Î±ÏƒÎ¹Î±ÏƒÏ„Î®',0),(597782,16630,'el','Thomson Reuters Tab Î±ÏÏ‡ÎµÎ¯Î¿',0),(597783,16631,'el','Î¥Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(597784,16632,'el','Î”Î¹Î±Ï„Î·ÏÎ®ÏƒÏ„Îµ Ï„Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(597785,16633,'el','Î•ÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ· ÏŒÎ»Î± Ï„Î± Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î±',0),(597786,16634,'el','Î•ÎºÎºÎ±Î¸Î¬ÏÎ¹ÏƒÎ· Ï…Ï€Î¬ÏÏ‡Î¿Î½Ï„Î± Î´ÎµÎ´Î¿Î¼Î­Î½Î± Î³Î¹Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ ÏƒÏ„Î·Î½ ÎµÎ¹ÏƒÎ±Î³Ï‰Î³Î®',0),(597787,16635,'el','Î Î¹ÏƒÏ„ÏŽÏƒÎµÎ¹Ï‚ ÏƒÎµ ÎµÎºÎºÏÎµÎ¼ÏŒÏ„Î·Ï„Î± Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®',0),(597788,16636,'el','Auto Select Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î±Ï€ÏŒ Ï„Î¿ Ï€Î»Î¿Î¯Î¿',0),(597789,16637,'el','Î•ÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· ÎºÎ±Î¹ POS ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(597790,16638,'el','Î•Ï€Î¹Ï„ÏÎ­ÏˆÎµÎ¹ Ï„Î·Î½ Ï€Î¯ÏƒÏ‰ ÏƒÎµÎ¹ÏÎ¬ Î¼ÏŒÎ½Î¿ Î±Ï€ÏŒ ÎºÎ­Î½Ï„ÏÎ± Î´Î¹Î±Î½Î¿Î¼Î®Ï‚',0),(597791,16639,'el','Î‘Ï…Ï„ÏŒÎ¼Î±Ï„Î· ÎµÏ€Î¹Î»Î¿Î³Î® Ï†ÏŒÏÎ¿ ÎµÏ€Î¯ Ï„Ï‰Î½ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î±Ï€ÏŒ Ï„Î¿ Ï€Î»Î¿Î¯Î¿ Î³Î¹Î± Ï„Î·Î½ ÎµÎºÏ€Î»Î®ÏÏ‰ÏƒÎ· ÎºÎ±Î¹ POS ÎµÎ½Ï„Î¿Î»Î­Ï‚',0),(597792,16640,'el','Î¤ÎµÎ»Î¹ÎºÎ® Ï„ÏÎ¹Î³Ï‰Î½Î¹ÎºÎ® Î±Ï€Î±Î¹Ï„ÎµÎ¯ POD',0),(597793,16641,'el','Î ÏÎ¿Ï„ÎµÎ¯Î½Ï‰ ÎµÎ½Î±Î»Î»Î±ÎºÏ„Î¹ÎºÎ® Î±Î³Î¿ÏÎ¬ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚ ÏŒÏ„Î±Î½ Qty Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î·',0),(597794,16642,'el','ÎœÎµÏÎ¹ÎºÎ® Î±Ï€Î±Î»Î»Î±Î³Î® Ï„Î¿Ï… Ï†ÏŒÏÎ¿Ï…',0),(597795,16643,'el','Î¦Î¿ÏÎ¿Î»Î¿Î³Î¹ÎºÏŒ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Ï„Î¿Î¹Ï‚ ÎµÎºÎ±Ï„ÏŒ',0),(597796,16644,'el','ÎšÎ­Î½Ï„ÏÎ¿ Î´Î¹Î±Î½Î¿Î¼Î®Ï‚ Num Î¼Î®Î½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³Î¹Î± Ï„Î¿Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(597797,16645,'el','Î”Î¹ÎµÏ€Î±Î³Î³ÎµÎ»Î¼Î±Ï„Î¹ÎºÎ­Ï‚ Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬ Î²Î±ÏÏŽÎ½ Ï€Î¿ÏƒÎ¿ÏƒÏ„ÏŒ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(597798,16646,'el','Î”Î¹ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ­Ï‚ Î´Î¹Î±ÎºÎ¹Î½Î®ÏƒÎµÎ¹Ï‚ ÎµÎ¹Î´ÏŽÎ½ - ÎµÏ€Î¹Ï„ÏÎ­Ï€Î¿Ï…Î½ Ï€Î¿Î»Î»Î±Ï€Î»Î­Ï‚ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯ÎµÏ‚',0),(597799,16647,'el','Î”Î¹ÎµÏ„Î±Î¹ÏÎ¹ÎºÎ­Ï‚ Î´Î¹Î±ÎºÎ¹Î½Î®ÏƒÎµÎ¹Ï‚ ÎµÎ¹Î´ÏŽÎ½ - Î±Ï€ÏŒÏƒÏ€Î±ÏƒÎ·',0),(597800,16648,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Ï„Î¿Ï… Transit Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î»',0),(597801,16649,'el','ÎšÎ­Î½Ï„ÏÎ¿ Î´Î¹Î±Î½Î¿Î¼Î®Ï‚ Î¼Î· Num Î¼Î®Î½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³Î¹Î± Ï„Î¿Î½ Ï…Ï€Î¿Î»Î¿Î³Î¹ÏƒÎ¼ÏŒ Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(597802,16650,'el','Î”Î·Î¼Î¿ÏƒÎ¯ÎµÏ…ÏƒÎ· Î±Ï€ÏŒ Î³ÏÎ±Î¼Î¼Î®',0),(597803,16651,'el','ÎœÎµÏ„Î¬ Î±Ï€ÏŒ Ï„Î·Î½ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® ÎºÎ±Î¹ Î»Î®ÏˆÎ·',0),(597804,16652,'el','B2B Î•Î¯ÏƒÎ¿Î´Î¿Ï‚ Ï‡ÏÎ®ÏƒÏ„Î·',0),(597805,16653,'el','Î£Ï…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Ï‰Ï‚ Î¿ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚',0),(597806,16654,'el','Î”ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Ï…Î½Î±Ï„ÏŒ Î½Î± Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ Ï‰Ï‚ Î Î‘Î¡/Î›Î™Î‘Î£',0),(597807,16655,'el','Î”ÎµÎ½ Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î±ÏÏ‡ÎµÎ¯Î¿ POD ÎµÏ€Î¹ÏƒÏ…Î½Î¬Ï€Ï„ÎµÏ„Î±Î¹ ÏƒÏ„Î·Î½ Ï„Î¬Î¾Î·',0),(597808,16656,'el','Î‘ÎœÎ•Î£ Î‘Î ÎŸÎ£Î¤',0),(597809,16657,'el','Î‘ÏÏ‡ÎµÎ¯Î¿ & Î‘Ï€Î¿Î¸Î®ÎºÎµÏ…ÏƒÎ·',0),(597810,16658,'el','ÎˆÎºÎ»ÎµÎ¹ÏƒÎµ Î¼Îµ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÏŽÎ´Î¹ÎºÎ±',0),(597811,16659,'el','ÎšÎ»ÎµÎ¹ÏƒÏ„Î® Î±Ï€ÏŒ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± GL',0),(597812,16660,'el','ÎšÎ»ÎµÎ¯ÏƒÎµÎ¹ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ ÎºÏŒÏƒÏ„Î¿Ï…Ï‚ ÎºÏ‰Î´Î¹ÎºÏŒ',0),(597813,16661,'el','ÎšÎ»ÎµÎ¯ÏƒÎµÎ¹ Ï„Î¿Ï…Ï‚ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼Î¿ÏÏ‚ Î±Ï€ÏŒ Ï„Î·Î½ ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± GL',0),(597814,16662,'el','Î—Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î±ÎºÏ…ÏÏŽÎ¸Î·ÎºÎµ',0),(597815,16663,'el','13Î· Ï€ÎµÏÎ¯Î¿Î´Î¿Ï‚ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚',0),(597816,16664,'el','Î¦ÏŒÏÎ¿Ï‚ Ï€Î¿Ï… ÏÏÎ¸Î¼Î¹ÏƒÎ· Ï„Î·Ï‚ ÎºÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ·Ï‚',0),(597817,16665,'el','Î•Î³Î³ÏÎ±Ï†Î® ÏÏÎ¸Î¼Î¹ÏƒÎ· Ï„Î­Î»Î¿Ï‚ Î­Ï„Î¿Ï…Ï‚',0),(597818,16666,'el','13Î· Ï€ÎµÏÎ¯Î¿Î´Î¿Ï‚ ÎµÎ³Î³ÏÎ±Ï†ÏŽÎ½',0),(597819,16667,'el','Î¦ÏŒÏÎ¿Ï‚ Ï€Î¿Ï… ÏÏÎ¸Î¼Î¹ÏƒÎ· ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÏ‰Î½',0),(597820,16668,'el','ÎœÎµ Ï„Î¿ Ï„Î­Î»Î¿Ï‚ Ï„Î¿Ï… Î­Ï„Î¿Ï…Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® ÎºÎ±Ï„Î±Ï‡Ï‰ÏÎ®ÏƒÎµÎ¹Ï‚',0),(597821,16669,'el','ÎœÎ·-Stock',0),(597822,16670,'el','Î†Î»Î»Î· ÎµÏ€Î¹Î²Î¬ÏÏ…Î½ÏƒÎ·',0),(597823,16671,'el','Î†Î»Î»ÎµÏ‚ Ï‡ÏÎµÏŽÏƒÎµÎ¹Ï‚',0),(597824,16672,'el','ÎœÎµÏ„Î±Ï†Î¿ÏÎ¬ Î¼ÎµÏ„Î±Î¾Ï Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¹ÏŽÎ½',0),(597825,16673,'el','ÎšÎ±Ï„Î±Ï‡ÏŽÏÎ·ÏƒÎ· Î¼ÎµÏ„Î±Ï†Î¿ÏÎ¬Ï‚',0),(597826,16674,'el','ÎœÎ· ÎµÎ¾Î¿Ï€Î»Î¹ÏƒÎ¼Î­Î½Î¿',0),(597827,16675,'el','Î•Î½Î¿Î¹ÎºÎ¯Î±ÏƒÎ·',0),(597828,16676,'el','Î•Ï†Î¿Î´Î¹Î±ÏƒÎ¼Î­Î½Î¿',0),(597829,16677,'el','0 Î³Î¹Î± ÏŒÏ‡Î¹ Max',0),(597830,16678,'el','0 Î³Î¹Î± ÎºÎ±Î¼Î¯Î± Min',0),(597831,16679,'el','AVG Qty Î±Î½Î¬ Î¼Î®Î½Î±',0),(597832,16680,'el','Î Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î± Î±Î³Î¿ÏÎ¬Ï‚ Î´Î·Î¼Î¹Î¿Ï…ÏÎ³Î®Î¸Î·ÎºÎµ',0),(597833,16681,'el','Î”Î·Î¼Î¹Î¿Ï…ÏÎ³Î¯Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î±Î³Î¿ÏÎ¬Ï‚',0),(597834,16682,'el','ÎšÎ­Î½Ï„ÏÎ± Î´Î¹Î±Î½Î¿Î¼Î®Ï‚',0),(597835,16683,'el','Î‘Ï€Î¿Î³ÏÎ±Ï†Î® Î¸Î­ÏƒÎµÎ¹Ï‚',0),(597836,16684,'el','Max Î±Ï†ÎµÎ½ÏŒÏ‚',0),(597837,16685,'el','Min ÏƒÏ„Î¿ Ï‡Î­ÏÎ¹',0),(597838,16686,'el','Î Ï‰Î»Î·Ï„Î­Ï‚ Î¼Î¿Ï…',0),(597839,16687,'el','NUM Î¼Î®Î½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³Î¹Î± Î¼Î­Î³Î¹ÏƒÏ„Î¿ ÏƒÏ„Î¿ Ï‡Î­ÏÎ¹',0),(597840,16688,'el','NUM Î¼Î®Î½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³Î¹Î± ÎµÎ»Î¬Ï‡Î¹ÏƒÏ„Î¿ ÏƒÏ„Î¿ Ï‡Î­ÏÎ¹',0),(597841,16689,'el','NUM Î¼Î®Î½ÎµÏ‚ Ï€Ï‰Î»Î®ÏƒÎµÏ‰Î½ Î³Î¹Î± Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Î±Î½Î±Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(597842,16690,'el','Î•Î¯Î½Î±Î¹ Ï„Î¿ Ï€ÏÎ¿ÎµÏ€Î¹Î»ÎµÎ³Î¼Î­Î½Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î®;',0),(597843,16691,'el','Î‘ÏÎ¹Î¸Î¼ÏŒÏ‚ Î·Î¼ÎµÏÏŽÎ½',0),(597844,16692,'el','Î Î±ÏÎ±Î¸Î­Ï„Ï‰ Ï‡ÏÏŒÎ½Î¿Ï‚ Ï€Î±ÏÎ¬Î´Î¿ÏƒÎ·Ï‚',0),(597845,16693,'el','Î¡ÏÎ¸Î¼Î¹ÏƒÎ· Î±Ï…Ï„Î® Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® Ï‰Ï‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿ Î¸Î± ÎºÎ±Ï„Î¬ÏÎ³Î·ÏƒÎ· Ï„Ï…Ï‡ÏŒÎ½ Î¬Î»Î»Î¿Ï…Ï‚ Ï€ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î­Ï‚ Ï€ÏÎ¿ÎµÏ€Î¹Î»Î¿Î³Î® Î³Î¹Î± Î±Ï…Ï„ÏŒ Ï„Î¿ ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î¿',0),(597846,16694,'el','Î ÏÎ¿Î¼Î·Î¸ÎµÏ…Ï„Î® UPC',0),(597847,16695,'el','RTV ÏƒÏ„Î¿Î½ Î±ÏÎ¹Î¸Î¼ÏŒ',0),(597848,16696,'el','Î•Ï€Î¹ÏƒÏ„ÏÎ¿Ï†Î® Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(597849,16697,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎµÎ¯ Î½Î± Î±Î»Î»Î¬Î¾ÎµÎ¹ Î±Ï…Ï„Î® Ï„Î· ÏƒÎµÎ¹ÏÎ¬ Î½Î± Ï„Î± Î±Ï€Î¿Î¸Î­ÏƒÎµÏ„Îµ ÏƒÎµ Ï€Î»Î¿Î¯Î¿',0),(597850,16698,'el','Î¤ÏÎ­Ï‡Î¿Ï…ÏƒÎ± Î¸Î­ÏƒÎ·',0),(597851,16699,'el','Î£ÎµÎ¹ÏÎ¬ Î­Ï‡ÎµÎ¹ Ï„Î¹Ï‚ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î­Ï‚ Ï„Ï‰Î½ ÎµÎ¹Î´ÏŽÎ½ Î¼Î·-Ï€Ï„ÏŽÏƒÎ· Ï€Î»Î¿Î¯Î¿Ï…',0),(597852,16700,'el','Î Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚ Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ Î´Î¹Î±Î¸Î­ÏƒÎ¹Î¼Î· ÏƒÏ„Î·Î½ Ï„Î¿Ï€Î¿Î¸ÎµÏƒÎ¯Î±',0),(597853,16701,'el','ÎœÎµÎ¹ÏŽÏƒÏ„Îµ Ï„Î·Î½ Ï€Î¿ÏƒÏŒÏ„Î·Ï„Î± Ï€Î±ÏÎ±Î³Î³ÎµÎ»Î¯Î±Ï‚',0),(597854,16702,'el','Î¤Î± Î±ÎºÏŒÎ»Î¿Ï…Î¸Î± ÏƒÏ„Î¿Î¹Ï‡ÎµÎ¯Î± Î¼Î·-Ï€Ï„ÏŽÏƒÎ· Ï€Î»Î¿Î¯Î¿Ï… Î½Î± Î±Ï€Î¿Î¼Î±ÎºÏÏ…Î½Î¸Î¿ÏÎ½',0),(597855,16703,'el','ÎšÎ¿Ï…Ï€ÏŒÎ½Î¹ ID',0),(597856,16704,'el','ÎšÏÏÎ¹Î± Î±Î³Î¿ÏÎ±ÏƒÏ„Î®',0),(597857,16705,'el','Î‘Î½ Î½Î¿Î¼ÏŽÎ½ Î´ÎµÎ½ Ï€ÎµÏÎ¹Î»Î±Î¼Î²Î¬Î½Î¿Î½Ï„Î±Î¹ ÏƒÏ„Î· Î»Î¯ÏƒÏ„Î±',0),(597858,16706,'el','Î•Î½Î­ÏÎ³ÎµÎ¹Î± ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚',0),(597859,16707,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½ ÎºÏŒÏƒÏ„Î¿Ï‚ ÎºÏ‰Î´Î¹ÎºÎ¿ÏÏ‚ Î±Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î­Ï‡ÎµÎ¹ ÎºÎ¿ÏƒÏ„Î¯ÏƒÎµÎ¹ ÎºÏŽÎ´Î¹ÎºÎµÏ‚',0),(597860,16708,'el','Î‘Ï€Î±Î¹Ï„Î¿ÏÎ½ GL ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯Î± ÎµÎ¬Î½ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î­Ï‡ÎµÎ¹ GL ÎºÎ±Ï„Î·Î³Î¿ÏÎ¯ÎµÏ‚',0),(597861,16709,'el','ÎšÎ­Î½Ï„ÏÎ¿ Î´Î¹Î±Î½Î¿Î¼Î®Ï‚',0),(597862,16710,'el','Î•Î¯Î½Î±Î¹ ÎºÎ­Î½Ï„ÏÎ¿ Î´Î¹Î±Î½Î¿Î¼Î®Ï‚;',0),(597863,16711,'el','Î•Î»Î­Î³Ï‡Î¿Î½Ï„Î±Î¹ ÏƒÎµ',0),(597864,16712,'el','Î ÏÎ±Î³Î¼Î±Ï„Î¿Ï€Î¿Î¯Î·ÏƒÎµ Î­Î»ÎµÎ³Ï‡Î¿',0),(597865,16713,'el','Î”ÎµÎ¯Ï„Îµ Ï„ÏŽÏÎ±',0),(597866,16714,'el','ÎÏÎ± Î¬Ï†Î¹Î¾Î·Ï‚',0),(597867,16715,'el','ÎÎ± Î±Ï€Î¿Î¸Î·ÎºÎµÏÏƒÎµÏ„Îµ ÏƒÎ·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚',0),(597868,16716,'el','Î£Î·Î¼ÎµÎ¹ÏŽÏƒÎµÎ¹Ï‚ ÎµÎ½Î·Î¼Î­ÏÏ‰ÏƒÎ·Ï‚',0),(597869,16717,'el','Î”ÎµÎ½ Î¼Ï€Î¿ÏÎ¿ÏÏƒÎµ Î½Î± Î²ÏÎµÎ¹ Î»Î¿Î³Î±ÏÎ¹Î±ÏƒÎ¼ÏŒÏ‚ Î³/Î» Î¼Îµ Î²Î¬ÏƒÎ· Ï„Î¿ ÏŒÎ½Î¿Î¼Î±',0),(597870,16718,'el','Î•Î¹ÏƒÎ±Î³Ï‰Î³Î® Î±ÏƒÎ¸ÎµÎ½ÏŽÎ½',0),(597871,16719,'el','Î“ÎµÎ¼Î¯ÏƒÏ„Îµ Ï„Î·Î½ Î·Î¼Î­ÏÎ±',0),(597872,16720,'el','Î¤ÎµÎ»ÎµÏ…Ï„Î±Î¯Î± ÏƒÏ…Î½Î¬Î½Ï„Î·ÏƒÎ·',0),(597873,16721,'el','Î Î±ÏÎ±ÎºÎ±Î»ÏŽ 777 chmod',0),(597874,16722,'el','ÎŒÎ»ÎµÏ‚ Î¿Î¹ ÏƒÏ…Î½Î±Î½Ï„Î®ÏƒÎµÎ¹Ï‚',0),(597875,16723,'el','ÎšÎ»ÎµÎ¯ÏƒÏ„Îµ Ï„Î¿ ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(597876,16724,'el','Î•Î½Ï„Î¿Î»Î® Î´ÎµÎ½ Î²ÏÎ­Î¸Î·ÎºÎµ',0),(597877,16725,'el','Î•Ï€Î¹Î²ÎµÎ²Î±Î¹ÏŽÏƒÎµÏ„Îµ Ï„Î·Î½ ÏŽÏÎ± Ï„Î¿Ï… ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(597878,16726,'el','Î— Î´Ï…Î½Î±Ï„ÏŒÏ„Î·Ï„Î± Î´ÎµÎ½ ÎµÎ¯Î½Î±Î¹ ÎµÎ½ÎµÏÎ³Î¿Ï€Î¿Î¹Î·Î¼Î­Î½Î·',0),(597879,16727,'el','Î•Ï€ÏŒÎ¼ÎµÎ½Î¿ ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(597880,16728,'el','ÎšÎ±Î¼Î¯Î± ÎµÏ€ÎµÏÏ‡ÏŒÎ¼ÎµÎ½Î· ÏƒÏ…Î½Î¬Î½Ï„Î·ÏƒÎ·',0),(597881,16729,'el','Î‘Î½Î¿Î¹Ï‡Ï„Î­Ï‚ ÏƒÏ…Î½Î±Î½Ï„Î®ÏƒÎµÎ¹Ï‚ Î³Î¹Î±',0),(597882,16730,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î¼Î¹Î± Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î± Î³Î¹Î± Î½Î± Î´ÎµÎ¯Ï„Îµ Ï„Î¹Ï‚ Î±Î½Î¿Î¹Ï‡Ï„Î­Ï‚ ÏƒÏ…Î½Î±Î½Ï„Î®ÏƒÎµÎ¹Ï‚',0),(597883,16731,'el','ÎŒÏ€Î¿Ï…',0),(597884,16732,'el','Î ÏÎ¿Î³ÏÎ±Î¼Î¼Î±Ï„Î¹ÏƒÎ¼ÏŒÏ‚ ÏÎ±Î½Ï„ÎµÎ²Î¿Ï',0),(597885,16733,'el','Î•Ï€Î¹Î»Î­Î¾Ï„Îµ Î·Î¼ÎµÏÎ¿Î¼Î·Î½Î¯Î±',0),(597886,16734,'el','Î¤ÏÏ€Î¿Ï‚ Î±Î¯Ï„Î·ÏƒÎ·Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚',0),(597887,16735,'el','Î¤ÏÏ€Î¿Ï‚ Î±Î¯Ï„Î·ÏƒÎ·Ï‚ Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Î±Ï€ÏŒ Ï„Î¿Î½ Ï€Î±ÏÏŒÎ½Ï„Î± ÎºÏŽÎ´Î¹ÎºÎ± Ï…Ï€Î¬ÏÏ‡ÎµÎ¹ Î®Î´Î·',0),(597888,16736,'el','ÎšÏ‰Î´Î¹ÎºÏŒÏ‚ Ï„ÏÏ€Î¿Ï… Î±Î¯Ï„Î·ÏƒÎ· Ï€ÏÎ¿ÏƒÎ±ÏÎ¼Î¿Î³Î® Î±Ï€Î¿Î¸Î­Î¼Î±Ï„Î¿Ï‚ Ï€ÏÎ­Ï€ÎµÎ¹ Î½Î± Î¿ÏÎ¹ÏƒÏ„ÎµÎ¯',0),(597889,16737,'el','ÎœÎµÏ„Î¬ Î±Ï€ÏŒ Î±Ï€Î¿ÏƒÏ„Î¿Î»Î® & Î»Î®ÏˆÎ·',0),(597890,16738,'el','Î£Ï…Î½Î´ÎµÎ¸ÎµÎ¯Ï„Îµ Ï‰Ï‚ Î¿ Ï‡ÏÎ®ÏƒÏ„Î·Ï‚',0),(597891,16739,'el','Î ÎµÏÎ¹Î»Î¬Î²ÎµÏ„Îµ Ï„Î± Î±Ï€Î¿ÏƒÏ€Î¬ÏƒÎ¼Î±Ï„Î±',0),(597892,16503,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×§×¨×•× ××ª ×”×¨×©×•×ž×”',0),(597893,16504,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×”×•×¡×™×£',0),(597894,16505,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×¢×“×›×Ÿ',0),(597895,16506,'he','×˜×•×¤×¡ ×œ× ×©×œ×',0),(597896,16507,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×§×¨×•× ×§×•×‘×¥',0),(597897,16508,'he','×”×¨×—×‘×ª ×©×“×•×ª ×ž×•×ª××ž×™× ××™×©×™×ª × ×“×¨×©',0),(597898,16509,'he','× ×˜×œ ×ž×©×',0),(597899,16510,'he','× ×˜×œ ×ž×©×',0),(597900,16511,'he','×›×•×œ×œ×™× ×”×ª××ž×ª ×¢×¨×›×™ ×‘×¡×•×£ ×”×©× ×”',0),(597901,16512,'he','×¡×•×’ ×”×‘×§×©×” ×”×ª××ž×” ×ž×œ××™',0),(597902,16513,'he','×¡×•×’ ×”×‘×§×©×” ×”×ª××ž×” ×”×ž×œ××™ ×œ×¤×™ ×”×§×•×“ ×”×–×” ×›×‘×¨ ×§×™×™×',0),(597903,16514,'he','×§×•×“ ×¡×•×’ ×©×œ ×‘×§×©×” ×”×ª××ž×ª ×”×ž×¦××™ ×œ×”×’×“×™×¨',0),(597904,16515,'he','×¦×•×¨ ×”×¢×‘×¨×”',0),(597905,16516,'he','×œ×”×’×“×™×¨ ×‘×¨×™×¨×ª ×ž×—×“×œ ×‘×™×Ÿ-×—×‘×¨×ª×™ ×”×¢×‘×¨×ª ×”×—×©×‘×•×Ÿ ×”× ×’×“×™',0),(597906,16517,'he','×‘×™×Ÿ-×—×‘×¨×ª×™ ×”×¢×‘×¨×ª ×”×¤×¨×™×˜ - ×”×“×¤×¡×”',0),(597907,16518,'he','×ž×œ××™ GL ×—×©×‘×•×Ÿ ×œ×”×§×¦×•×ª ×¤×¨×™×˜ ××• ×—×©×‘×•×Ÿ ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×©×”×•×§×¦×• ×‘×”×’×“×¨×ª ×ž×œ××™',0),(597908,16519,'he','Num ×—×•×“×©×™× ×ž×›×™×¨×•×ª ×¢×‘×•×¨ ×›×ž×•×ª ×©×œ ×—×™×“×•×©',0),(597909,16520,'he','Num ×—×•×“×©×™× ×œ×—×“×©',0),(597910,16521,'he','×—×™×“×•×© ×ž×œ××™',0),(597911,16522,'he','×”×¢×‘×¨×•×ª ×—×™×“×•×© ×ž×œ××™',0),(597912,16523,'he','×”×¢×‘×¨×ª ×”×¦×™×œ',0),(597913,16524,'he','×”×ª××¨×™×š ×”×ž×§×•×‘×œ',0),(597914,16525,'he','×¡×•×’ ×”×ª××ž×”',0),(597915,16526,'he','×ž×•×§×¦×”',0),(597916,16527,'he','×ª××¨×™×š ×©×”×•×§×¦×•',0),(597917,16528,'he','×¡×¤×¨×ª×™',0),(597918,16529,'he','×¡×•×’ ×¡×¤×™×¨×”',0),(597919,16530,'he','×ª××¨×™×š ×•×ž×•×§×¦×•×ª',0),(597920,16531,'he','×¤×¨×™×˜×™× ×©× ×¡×¤×¨×•',0),(597921,16532,'he','×¢×•×“×›×Ÿ ×œ××—×¨×•× ×” ×¢×œ-×™×“×™',0),(597922,16533,'he','××—×•×– ×¡×¤×¨×ª×™',0),(597923,16534,'he','×¡×•×’ ×”×‘×§×©×”',0),(597924,16535,'he','×‘×§×©×” ×”×¡×™×ž×•×Ÿ ×ž× ×™×•×ª',0),(597925,16536,'he','×‘×§×©×•×ª ×¡×™×ž×•×Ÿ ×ž× ×™×•×ª',0),(597926,16537,'he','×ž×¦×‘ ×”×‘×§×©×” ×”×¡×™×ž×•×Ÿ ×ž× ×™×•×ª',0),(597927,16538,'he','Amt ×¢×¨×š ×”×©×•× ×•×ª',0),(597928,16539,'he','××—×•×– ×¢×¨×š ×”×©×•× ×•×ª',0),(597929,16540,'he','×”×•×¡×¤×”/×¢×¨×™×›×” ×©×œ ×”×ž×—×•×–',0),(597930,16541,'he','×ž×ª×–×ž×Ÿ ×¤×’×™×©×”',0),(597931,16542,'he','× ×™×”×•×œ ×¡×¤×™×¨×ª',0),(597932,16543,'he','×œ×§×•×— ×¤×¨×˜×™ ×™×™×‘×•×',0),(597933,16544,'he','×™×™×‘×•× ×ž×›×™×¨×•×ª ×‘×©×˜×—×™×',0),(597934,16545,'he','×ž×¢ ×ž ×™×™×‘×•×',0),(597935,16546,'he','×™×™×‘×•× ×”×¡×¤×§ ×”×–×ž× ×” Froms',0),(597936,16547,'he','×”×¢×‘×¨×ª ×ž×˜×¢× ×™× ×”× ×˜×œ ×‘×™×Ÿ-×—×‘×¨×ª×™×•×ª',0),(597937,16548,'he','×ž×œ××™ ×”×ª××ž×ª ×”×‘×§×©×” ×¡×•×’×™×',0),(597938,16549,'he','×‘×§×©×” ×”×¡×™×ž×•×Ÿ ×ž× ×™×•×ª ×—×“×©×™×',0),(597939,16550,'he','×©×˜×—×™ ×”×™×¢×¨×›×•×ª',0),(597940,16551,'he','×”×”×™×¢×¨×›×•×ª',0),(597941,16552,'he','×—×©×‘×•×Ÿ ×”×§×œ×“ ×”×œ× × ×›×•×Ÿ',0),(597942,16553,'he','×”×¨×•×–×Ÿ ×œ× ×œ×ž×¦×•× ×—×©×‘×•×Ÿ ×œ×¤×™ ×©×',0),(597943,16554,'he','×”×¨×•×–×Ÿ ×œ× ×œ×ž×¦×•× ×—×©×‘×•×Ÿ ×‘× ×§ ×œ×¤×™ ×©×',0),(597944,16555,'he','×”×¨×•×–×Ÿ ×œ× ×œ×ž×¦×•× ×©×™×˜×ª ×œ×¤×™ ×©× ×ž×©×œ×•×—',0),(597945,16556,'he','×”×ª××ž×•×ª ×¡×¤×§×™× Muliple',0),(597946,16557,'he','×ž×™×§×•×“ ××• ×”×ž×“×™× ×” × ×“×¨×©',0),(597947,16558,'he','×ž×–×”×” ×ž×›×™×¨×•×ª',0),(597948,16559,'he','×ž×›×™×¨×•×ª ×ž×–×”×” ××• ×©× ×—×™×™×‘ ×œ×”×™×•×ª ×ž×•×’×“×¨',0),(597949,16560,'he','×§×•×“ ×ž×¦×‘',0),(597950,16561,'he','×—×™×™×‘ ×œ×”×™×•×ª ×ž×•×’×“×¨ ×©× ×”×—×‘×¨×” ×”×¡×¤×§ ××• ×©× ×”×ž×©×¤×—×”',0),(597951,16562,'he','×ž×¡×¤×¨ ×”× ×™×ª×•×‘ ×©×œ ×”×‘× ×§',0),(597952,16563,'he','×©×™×˜×ª ×ª×©×œ×•× ×”×ž×”×•×•×” ×‘×¨×™×¨×ª ×ž×—×“×œ',0),(597953,16564,'he','×§×•×“ ×¡×¤×§ ×œ×”×’×“×™×¨',0),(597954,16565,'he','×¨×™×§',0),(597955,16566,'he','×œ× ×”×•×’×“×¨×• ×¡×•×’',0),(597956,16567,'he','×¤×’×™×©×•×ª ×”×•×–×ž× ×•',0),(597957,16568,'he','×¤×’×™×©×•×ª ×¤×ª×•×—',0),(597958,16569,'he','×¤×’×™×©×•×ª ×”×™×•×',0),(597959,16570,'he','×¤×’×™×©×•×ª ×¡×”',0),(597960,16571,'he','××•×¨×š ×¤×’×™×©×”',0),(597961,16572,'he','×”×¤×’×™×©×•×ª ×¢×‘×•×¨',0),(597962,16573,'he','×ž×™×§×•× ×”×¤×’×™×©×”',0),(597963,16574,'he','×©× ×¤×¢×™×œ×•×ª',0),(597964,16575,'he','×¡×™×›×•× ×¤×’×™×©×”',0),(597965,16576,'he','×ž×ª×–×ž×Ÿ ×¤×’×™×©×” B2B',0),(597966,16577,'he','×™×¦×™×¨×ª ×¤×ª×—×™× ×¤×’×™×©×”',0),(597967,16578,'he','×ž×—×™×§×ª ×¤×¢×™×œ×•×ª ×¤×ª×•×—×”',0),(597968,16579,'he','×”×¤×’×™×©×” ×”×‘××” ×œ×¢×ª×™×“',0),(597969,16580,'he','×œ×‘×—×•×¨ ×ª××¨×™×š ×›×“×™ ×œ×”×¦×™×’ & ×œ×¢×¨×•×š ×¤×’×™×©×•×ª',0),(597970,16581,'he','×”×¦×’ ×ª×§×¦×™×¨',0),(597971,16582,'he','Unbook ×ª×•×¨',0),(597972,16583,'he','×”×•×¡×£ ×—×“×© ×‘×ž×—×•×–',0),(597973,16584,'he','×©× ×ž×—×•×–',0),(597974,16585,'he','×”×ž×“×™× ×” ×”×•×¨×”',0),(597975,16586,'he','×¢×œ×™×š ×œ×”×–×™×Ÿ ×©× ×”×ž×—×•×–',0),(597976,16587,'he','×¢×œ×™×š ×œ×‘×—×•×¨ ×ž×“×™× ×”',0),(597977,16588,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×œ×ž×—×•×§ ×‘×ž×—×•×– ×”×–×”?',0),(597978,16589,'he','×ž×—×§ ×ž×—×•×–',0),(597979,16590,'he','×¢×¨×™×›×” ××™×©×™×ª ×§××•× ×˜×™',0),(597980,16591,'he','×©×§×•×œ ×œ×”×•×¡×™×£ ×ž×—×•×– ×—×“×©',0),(597981,16592,'he','×¢×¨×™×›×” ×§××•× ×˜×™',0),(597982,16593,'he','×”×‘×—×™×¨×” ×©×œ×š ×”×™× ×¢×¨×š ×”×ž×¢×¨×›×ª ×•××™×Ÿ ××¤×©×¨×•×ª ×œ×©× ×•×ª×',0),(597983,16594,'he','×¢×œ×™×š ×œ×”×©×œ×™× ××ª ×”×˜×•×¤×¡ ×›×“×™ ×œ×”×ž×©×™×š',0),(597984,16595,'he','×”×œ×§×•×—×•×ª ×”×•×¡×™×£',0),(597985,16596,'he','×”×ž×¢×¨×›×ª ×“×™×œ×’×” ×¢×œ ×”×œ×§×•×—×•×ª',0),(597986,16597,'he','×”×œ×§×•×—×•×ª ×ž×¢×•×“×›×Ÿ',0),(597987,16598,'he','×§×¨×™××ª ×§×•×•×™×',0),(597988,16599,'he','×˜×œ×¤×•×Ÿ ×—×œ×•×¤×™×™×',0),(597989,16600,'he','×§×•×‘×¥ ×”×™×™×‘×•× ×‘×ª×‘× ×™×ª CSV',0),(597990,16601,'he','×”×©×™×¨×•×ª×™× ×”×¡×œ×•×œ×¨×™×™×',0),(597991,16602,'he','×ž×¡×¤×¨ ×”×˜×œ×¤×•×Ÿ ×”× ×™×™×“',0),(597992,16603,'he','×‘×—×¨ ×ª× ××™ ×—×©×‘×•× ×™×ª',0),(597993,16604,'he','×§×™×¦×•×¨ ×”×ž×“×™× ×”',0),(597994,16605,'he','×›×ª×•×‘×ª ×¨×—×•×‘',0),(597995,16606,'he','×”×•×¡×¤×”/×¢×¨×™×›×”',0),(597996,16607,'he','×ž×ž×•×¦×¢ ×ž×›×™×¨×•×ª ×œ×—×•×“×©',0),(597997,16608,'he','××¡×¤×§×ª ×”× ×•×›×—×™',0),(597998,16609,'he','××™×Ÿ ×¡×œ ×”×¢×™×§×¨×™ ×©×”×•×§×¦×•',0),(597999,16610,'he','×›×ž×•×ª ×¢×œ ×”×”×¢×‘×¨×”',0),(598000,16611,'he','×œ×—×“×© ××ª ×ž×œ××™ ×ž×ž×¨×›×– ×”×”×¤×¦×”',0),(598001,16612,'he','×”×¦×™×¢',0),(598002,16613,'he','×›×ž×•×ª ×”×¢×‘×¨×”',0),(598003,16614,'he','××–×•×¨',0),(598004,16615,'he','×¢×¨×™× × ×•×¡×¤×•×ª',0),(598005,16616,'he','×¢×¨×™× ×ž×¢×•×“×›×Ÿ',0),(598006,16617,'he','×ž×—×•×–×•×ª ×”×•×¡×™×£',0),(598007,16618,'he','×ž×—×•×–×•×ª ×ž×¢×•×“×›×Ÿ',0),(598008,16619,'he','×ž×“×™× ×•×ª × ×•×¡×¤×•×ª',0),(598009,16620,'he','×”×‘×¨×™×ª ×ž×¢×•×“×›×Ÿ',0),(598010,16621,'he','×”×× ××ª×” ×‘×˜×•×— ×©×‘×¨×¦×•× ×š ×ª×¢×“×›×Ÿ ××ª ×”×ž×¢ ×ž?',0),(598011,16622,'he','×©× ×”×¢×™×¨',0),(598012,16623,'he','×”×¢×™×¨ ×ž×¢ ×ž ×ž×›×¤×™×œ',0),(598013,16624,'he','×”×¢×™×¨ ×©×™×ž×•×© ×ž×¡ ×ž×›×¤×™×œ',0),(598014,16625,'he','×ž×¢ ×ž ×ž×—×•×– ×ž×›×¤×™×œ',0),(598015,16626,'he','×©×™×ž×•×© ×ž×—×•×– ×ž×¡ ×ž×›×¤×™×œ',0),(598016,16627,'he','×ž×¢ ×ž ×™×™×‘×•×',0),(598017,16628,'he','×ž×›×¤×™×œ ×”×ž×“×™× ×” ×ž×¢ ×ž',0),(598018,16629,'he','×©×™×ž×•×© ×”×ž×“×™× ×” ×ž×¡ ×ž×›×¤×™×œ',0),(598019,16630,'he','×ª×•×ž×¡×•×Ÿ ×¨×•×™×˜×¨×¡ ×”×›×¨×˜×™×¡×™×” ×§×•×‘×¥',0),(598020,16631,'he','×”× ×ª×•× ×™× ×”×§×™×™×ž×™×',0),(598021,16632,'he','×œ×©×ž×•×¨ ×¢×œ ×”× ×ª×•× ×™× ×”×§×™×™×ž×™×',0),(598022,16633,'he','×ž×—×§ ×œ×¦×ž×™×ª×•×ª ××ª ×›×œ ×”× ×ª×•× ×™× ×”×§×™×™×ž×™×',0),(598023,16634,'he','× ×§×” × ×ª×•× ×™× ×§×™×™×ž×™× ×¢×‘×•×¨ ×¡×¤×§×™ ×‘×™×™×‘×•×',0),(598024,16635,'he','×”×¡×¤×§ ×ž×ž×ª×™× ×•×ª ×§×¨×“×™×˜×™×',0),(598025,16636,'he','Auto Select ×ž×¢ ×ž ×œ×¡×¤×™× ×”',0),(598026,16637,'he','×¢×œ ×”×’×©×ž×” ×•×”×–×ž× ×•×ª POS',0),(598027,16638,'he','×œ××¤×©×¨ ×”×’×‘ ×›×“×™ ×¨×§ ×ž×ª×•×š ×ž×¨×›×–×™ ×”×¤×¦×”',0),(598028,16639,'he','×‘×—×¨ ××•×˜×•×ž×˜×™×ª ×ž×¢ ×ž ×”×¡×¤×™× ×” ×¢×œ ×”×’×©×ž×” ×•×”×–×ž× ×•×ª POS',0),(598029,16640,'he','×ž×©×œ×•×— ×”×©×—×¨×•×¨ ×”×¡×•×¤×™ ×“×•×¨×© POD',0),(598030,16641,'he','×ž×¦×™×¢ ×ž×™×§×•×ž×™× ×”×¨×›×™×©×” ×—×œ×•×¤×™ ×›××©×¨ ×›×ž×•×ª ×œ× ×–×ž×™×Ÿ',0),(598031,16642,'he','×¤×˜×•×¨ ×ž×ž×¡ ×—×œ×§×™×ª',0),(598032,16643,'he','××—×•×– ×©×™×¢×•×¨ ×”×ž×¡',0),(598033,16644,'he','×ž×¨×›×– ×”×”×¤×¦×” Num ×—×•×“×©×™× ×ž×›×™×¨×•×ª ×œ×—×™×©×•×‘ ×—×™×“×•×©',0),(598034,16645,'he','Interbranch ×”×¢×‘×¨×ª ×”× ×˜×œ ××—×•×– GL ×—×©×‘×•×Ÿ',0),(598035,16646,'he','×‘×™×Ÿ-×—×‘×¨×ª×™ ×¤×¨×™×˜ ×”×¢×‘×¨×•×ª - ×œ××¤×©×¨ ×ž×™×§×•×ž×™× ×ž×¨×•×‘×™×',0),(598036,16647,'he','×”×¢×‘×¨×ª ×”×¤×¨×™×˜ - ×¨×™×©×•× ×‘×™×Ÿ-×—×‘×¨×ª×™',0),(598037,16648,'he','×ž×œ××™ ×‘×—×©×‘×•×Ÿ GL ×˜×¨× ×–×™×˜',0),(598038,16649,'he','×ž×¨×›×– ×”×”×¤×¦×” ×©××™× × Num ×—×•×“×©×™× ×ž×›×™×¨×•×ª ×œ×—×™×©×•×‘ ×—×™×“×•×©',0),(598039,16650,'he','×”×•×“×¢×” ×¢×œ ×™×“×™ ×§×•',0),(598040,16651,'he','×¤×•×¡×˜ ×¢×œ ×™×“×™ ×ž×©×œ×•×— ×•×§×‘×œ×”',0),(598041,16652,'he','B2B ×›× ×™×¡×” ×œ×¨×©×•×ž×™×',0),(598042,16653,'he','×”×™×›× ×¡ ×›×ž×©×ª×ž×© ×”×–×”',0),(598043,16654,'he','××™×Ÿ ××¤×©×¨×•×ª ×œ×©×ž×•×¨ ×›×¡×“×¨ ×ž×œ××”',0),(598044,16655,'he','××™×Ÿ ×§×•×‘×¥ POD ×”×ž×¦×•×¨×£ ×œ×”×–×ž× ×”',0),(598045,16656,'he','×”×¡×¤×™× ×” ×˜×™×¤×”',0),(598046,16657,'he','××¨×›×™×•×Ÿ & ×©×ž×•×¨',0),(598047,16658,'he','× ×¡×’×¨ ×¢×œ ×™×“×™ ×§×•×“ ×¢×œ×•×ª',0),(598048,16659,'he','×¡×’×•×¨ ×œ×¤×™ ×§×˜×’×•×¨×™×” GL',0),(598049,16660,'he','×œ×¡×’×•×¨ ×—×©×‘×•× ×•×ª ×œ×¤×™ ×§×•×“ ×¢×œ×•×ª',0),(598050,16661,'he','×œ×¡×’×•×¨ ×—×©×‘×•× ×•×ª ×œ×¤×™ ×§×˜×’×•×¨×™×” GL',0),(598051,16662,'he','×ª××¨×™×š ×‘×™×˜×•×œ',0),(598052,16663,'he','×›× ×™×¡×” ×”×ž×—×–×•×¨ ×”-13',0),(598053,16664,'he','×ž×¡ ×”×ª××ž×ª ×¢×¨×š',0),(598054,16665,'he','×¢×¨×š ×”×ª××ž×ª ×¡×•×£ ×©× ×”',0),(598055,16666,'he','×¢×¨×›×™ ×”×ž×—×–×•×¨ ×”-13',0),(598056,16667,'he','×ž×¡ ×”×ª××ž×ª ×¢×¨×›×™',0),(598057,16668,'he','×¢× ×¡×•×£ ×”×©× ×” ×”×ª××ž×ª ×¢×¨×›×™',0),(598058,16669,'he','×œ×œ× ×ž× ×™×•×ª',0),(598059,16670,'he','××©×ž×” ××—×¨×ª',0),(598060,16671,'he','×—×™×•×‘×™× ××—×¨×™×',0),(598061,16672,'he','×”×¢×‘×¨×” ×‘×™×Ÿ ×ž×™×§×•×ž×™×',0),(598062,16673,'he','×”×¢×‘×¨×ª ×¤×¨×˜×™×',0),(598063,16674,'he','×©××™× ×• ×ž×¦×•×™×“',0),(598064,16675,'he','×”×©×›×¨×ª',0),(598065,16676,'he','×ž×¦×•×™×“',0),(598066,16677,'he','0 ×¢×‘×•×¨ ×‘×œ×™ ×ž×§×¡',0),(598067,16678,'he','0 ×“×§×•×ª ××™×Ÿ',0),(598068,16679,'he','×›×ž×•×ª ×ž×ž×•×¦×¢ ×œ×—×•×“×©',0),(598069,16680,'he','×”×–×ž× ×ª ×¨×›×© ×©× ×•×¦×¨×•',0),(598070,16681,'he','×¦×•×¨ ×”×–×ž× ×ª ×¨×›×©',0),(598071,16682,'he','×ž×¨×›×–×™ ×”×¤×¦×”',0),(598072,16683,'he','×ž×œ××™ ×ž×™×§×•×ž×™×',0),(598073,16684,'he','×ž×§×¡ ×¢×œ ×™×“',0),(598074,16685,'he','×ž×™×Ÿ ×¢×œ ×”×™×“',0),(598075,16686,'he','×¡×¤×§×™× ×©×œ×™',0),(598076,16687,'he','Num ×—×•×“×©×™× ×ž×›×™×¨×•×ª ×ž×§×¡×™×ž×œ×™×ª ×¢×œ ×”×™×“',0),(598077,16688,'he','Num ×—×•×“×©×™× ×ž×›×™×¨×•×ª ×œ×›×œ ×”×¤×—×•×ª ×¢×œ ×”×™×“',0),(598078,16689,'he','Num ×—×•×“×©×™× ×ž×›×™×¨×•×ª ×¢×‘×•×¨ ×—×™×“×•×© ×›×ž×•×ª',0),(598079,16690,'he','×–×” ×ž×—×“×œ ×œ×¤×¨×™×˜ ×¡×¤×§?',0),(598080,16691,'he','×ž×¡×¤×¨ ×”×™×ž×™×',0),(598081,16692,'he','×–×ž×Ÿ ×—×¤×™×¤×” ×¦×™×˜×•×˜',0),(598082,16693,'he','×”×’×“×¨×ª ×¡×¤×§ ×–×” ×›×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×‘×•×¨ ×”×¡×¨×” ×¨×¦×•×Ÿ ×–×” ×¤×¨×™×˜ ×›×œ×©×”×• ×¡×¤×§×™× ××—×¨×™× ×‘×¨×™×¨×ª ×”×ž×—×“×œ ×¢×‘×•×¨ ×¤×¨×™×˜ ×–×”',0),(598083,16694,'he','×”×¡×¤×§ UPC',0),(598084,16695,'he','RTV ×ž×¡×¤×¨',0),(598085,16696,'he','×›×‘×¨ ×“×™×‘×¨×ª×™',0),(598086,16697,'he','×œ× × ×™×ª×Ÿ ×œ×©× ×•×ª ×¡×“×¨ ×–×” ×œ×¢×–×•×‘ ××ª ×”×¡×¤×™× ×”',0),(598087,16698,'he','×”×ž×™×§×•× ×”× ×•×›×—×™',0),(598088,16699,'he','×¡×“×¨ ×™×© ×ž×©×œ×•×—×™× ×©×œ ×¤×¨×™×˜×™× ×©××™× ×-×”×¡×¤×™× ×” ×˜×™×¤×”',0),(598089,16700,'he','×›×ž×•×ª ×”×”×–×ž× ×” ××™× ×• ×–×ž×™×Ÿ ×‘×ž×™×§×•×',0),(598090,16701,'he','×œ×”×¤×—×™×ª ××ª ×›×ž×•×ª ×”×–×ž× ×”',0),(598091,16702,'he','×”×¤×¨×™×˜×™× ×”×œ×-×”×¡×¤×™× ×” ×˜×™×¤×” ×”×‘××™× ×™×•×¡×¨×•',0),(598092,16703,'he','×©×•×‘×¨ ×ž×–×”×”',0),(598093,16704,'he','×”×§×•× ×” ×¨××©×™',0),(598094,16705,'he','×× ×”×ž×—×•×– ×œ× ×‘×¨×©×™×ž×”',0),(598095,16706,'he','×¢×“×›×•×Ÿ ×¤×¢×™×œ×•×ª',0),(598096,16707,'he','×œ×“×¨×•×© ×§×•×“×™ ×¢×œ×•×ª ×× ×—×©×‘×•×Ÿ GL ×¢×œ×” ×§×•×“×™×',0),(598097,16708,'he','×œ×“×¨×•×© GL ×§×˜×’×•×¨×™×” ×× ×œ×—×©×‘×•×Ÿ GL ×™×© ×§×˜×’×•×¨×™×•×ª GL',0),(598098,16709,'he','×ž×¨×›×– ×”×”×¤×¦×”',0),(598099,16710,'he','×”×× ×ž×¨×›×– ×”×”×¤×¦×”?',0),(598100,16711,'he','×”×•×›× ×¡',0),(598101,16712,'he','×›× ×™×¡×”',0),(598102,16713,'he','×”×ª×™×™×¦×‘×• ×¢×›×©×™×•',0),(598103,16714,'he','×¦\'×§ ××™×Ÿ ×–×ž×Ÿ',0),(598104,16715,'he','×©×ž×™×¨×ª ×¤×ª×§×™×',0),(598105,16716,'he','×¢×“×›×•×Ÿ ×”×¢×¨×•×ª',0),(598106,16717,'he','×œ× ×”×™×ª×” ××¤×©×¨×•×ª ×œ×ž×¦×•× GL ×—×©×‘×•×Ÿ ×œ×¤×™ ×©×',0),(598107,16718,'he','×™×™×‘×•× ×”×—×•×œ×”',0),(598108,16719,'he','×™×•× ××—×¨×™ ×™×•×',0),(598109,16720,'he','×•×”×¤×’×™×©×” ×”××—×¨×•× ×” ×©× ×§×‘×¢×”?',0),(598110,16721,'he','×‘×‘×§×©×” 777 chmod',0),(598111,16722,'he','×›×œ ×”×¤×’×™×©×•×ª',0),(598112,16723,'he','×œ×”×–×ž×™×Ÿ ××ª ×”×¤×’×™×©×”',0),(598113,16724,'he','×”×¤×§×•×“×” ×œ× × ×ž×¦×',0),(598114,16725,'he','×œ××©×¨ ××ª ×ž×•×¢×“ ×”×¤×’×™×©×”',0),(598115,16726,'he','×ª×›×•× ×” ×œ× ×–×ž×™× ×”',0),(598116,16727,'he','×”×¤×’×™×©×” ×”×‘××”',0),(598117,16728,'he','××™×Ÿ ×œ×™ ×¤×’×™×©×” ×”×§×¨×•×‘×”',0),(598118,16729,'he','×¤×’×™×©×•×ª ×¤×ª×•×—×•×ª ×¢×‘×•×¨',0),(598119,16730,'he','×‘×—×¨ ×ª××¨×™×š ×›×“×™ ×œ×”×¦×™×’ ×¤×¢×™×œ×•×™×•×ª ×¤×ª×•×—×•×ª',0),(598120,16731,'he','××™×¤×”',0),(598121,16732,'he','×œ×§×‘×•×¢ ×¤×’×™×©×”',0),(598122,16733,'he','×‘×—×¨ ×ª××¨×™×š',0),(598123,16734,'he','×¡×•×’ ×”×‘×§×©×” ×”×ª××ž×” ×ž×œ××™',0),(598124,16735,'he','×¡×•×’ ×”×‘×§×©×” ×”×ª××ž×” ×”×ž×œ××™ ×œ×¤×™ ×”×§×•×“ ×”×–×” ×›×‘×¨ ×§×™×™×',0),(598125,16736,'he','×§×•×“ ×¡×•×’ ×©×œ ×‘×§×©×” ×”×ª××ž×ª ×”×ž×¦××™ ×œ×”×’×“×™×¨',0),(598126,16737,'he','×¤×•×¡×˜ ×¢×œ ×™×“×™ ×ž×©×œ×•×— & ×§×‘×œ×ª',0),(598127,16738,'he','×”×™×›× ×¡ ×›×ž×©×ª×ž×© ×”×–×”',0),(598128,16739,'he','×›×•×œ×œ ×”×¦×¢×•×ª ×ž×—×™×¨',0),(598129,16503,'hi','à¤…à¤­à¤¿à¤²à¥‡à¤– à¤¨à¤¹à¥€à¤‚ à¤ªà¤¢à¤¼ à¤¸à¤•à¤¤à¤¾',0),(598130,16504,'hi','à¤œà¥‹à¤¡à¤¼à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤¸à¤•à¤¾',0),(598131,16505,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¨à¤¹à¥€à¤‚ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾ à¤¸à¤•à¤¾',0),(598132,16506,'hi','à¤«à¤¾à¤°à¥à¤® à¤…à¤§à¥‚à¤°à¤¾',0),(598133,16507,'hi','à¤«à¤¼à¤¾à¤‡à¤² à¤¨à¤¹à¥€à¤‚ à¤ªà¤¢à¤¼ à¤¸à¤•à¤¤à¤¾',0),(598134,16508,'hi','à¤•à¤¸à¥à¤Ÿà¤® à¤«à¤¼à¥€à¤²à¥à¤¡ à¤†à¤µà¤¶à¥à¤¯à¤• à¤à¤¡-à¤‘à¤¨',0),(598135,16509,'hi','à¤®à¤¾à¤² à¤­à¤¾à¤°',0),(598136,16510,'hi','à¤®à¤¾à¤² à¤­à¤¾à¤°',0),(598137,16511,'hi','à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤µà¤°à¥à¤· à¤…à¤‚à¤¤ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(598138,16512,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(598139,16513,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¥à¤°à¤•à¤¾à¤° à¤‡à¤¸ à¤•à¥‹à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(598140,16514,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‹à¤¡ à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(598141,16515,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤¬à¤¨à¤¾à¤à¤',0),(598142,16516,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ Intercompany à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤‘à¤«à¤¼à¤¸à¥‡à¤Ÿ à¤–à¤¾à¤¤à¥‡ à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(598143,16517,'hi','à¤†à¤‡à¤Ÿà¤® à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ - à¤ªà¥à¤°à¤¿à¤‚à¤Ÿ intercompany',0),(598144,16518,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ GL à¤–à¤¾à¤¤à¥‡ à¤ªà¤° à¤†à¤‡à¤Ÿà¤® à¤¯à¤¾ à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¸à¥‡à¤Ÿà¤…à¤ª à¤®à¥‡à¤‚ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤–à¤¾à¤¤à¤¾ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤œà¤¾à¤¨à¤¾ à¤šà¤¾à¤¹',0),(598145,16519,'hi','Num à¤®à¤¹à¥€à¤¨à¥‡ à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(598146,16520,'hi','Num à¤®à¤¹à¥€à¤¨à¥‹à¤‚ à¤•à¥€ à¤­à¤°à¤ªà¤¾à¤ˆ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤',0),(598147,16521,'hi','à¤ªà¥à¤¨à¤ƒà¤ªà¥‚à¤°à¥à¤¤à¤¿',0),(598148,16522,'hi','à¤ªà¥à¤¨à¤ƒà¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤¨à¥à¤¤à¤°à¤£',0),(598149,16523,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤¸à¤¹à¥‡à¤œà¤¾ à¤—à¤¯à¤¾',0),(598150,16524,'hi','à¤¸à¥à¤µà¥€à¤•à¥ƒà¤¤ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(598151,16525,'hi','à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(598152,16526,'hi','à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(598153,16527,'hi','à¤…à¤¸à¤¾à¤‡à¤‚à¤¡ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(598154,16528,'hi','à¤—à¤¿à¤¨à¤¾',0),(598155,16529,'hi','à¤¸à¤‚à¤–à¥à¤¯à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(598156,16530,'hi','à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾ à¤¦à¤¿à¤¨à¤¾à¤‚à¤•',0),(598157,16531,'hi','à¤†à¤‡à¤Ÿà¤® à¤•à¥€ à¤—à¤¿à¤¨à¤¤à¥€',0),(598158,16532,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤…à¤¦à¥à¤¯à¤¤à¤¨à¤•à¤°à¥à¤¤à¤¾',0),(598159,16533,'hi','à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ à¤•à¥€ à¤—à¤¿à¤¨à¤¤à¥€',0),(598160,16534,'hi','à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(598161,16535,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤šà¥‡à¤• à¤…à¤¨à¥à¤°à¥‹à¤§',0),(598162,16536,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤šà¥‡à¤• à¤…à¤¨à¥à¤°à¥‹à¤§',0),(598163,16537,'hi','à¤¸à¥à¤Ÿà¥‰à¤• à¤šà¥‡à¤• à¤…à¤¨à¥à¤°à¥‹à¤§ à¤¸à¥à¤¥à¤¿à¤¤à¤¿',0),(598164,16538,'hi','à¤ªà¥à¤°à¤¸à¤°à¤£ à¤®à¤¾à¤¨ Amt',0),(598165,16539,'hi','à¤ªà¥à¤°à¤¸à¤°à¤£ à¤®à¤¾à¤¨ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(598166,16540,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€',0),(598167,16541,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¶à¥‡à¤¡à¥à¤¯à¥‚à¤²à¤°',0),(598168,16542,'hi','à¤—à¤£à¤¨à¤¾ à¤ªà¥à¤°à¤¬à¤‚à¤§à¤¨',0),(598169,16543,'hi','à¤—à¥à¤°à¤¾à¤¹à¤• à¤œà¤¾à¤¨à¤•à¤¾à¤°à¥€ à¤†à¤¯à¤¾à¤¤',0),(598170,16544,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥à¤·à¥‡à¤¤à¥à¤° à¤†à¤¯à¤¾à¤¤',0),(598171,16545,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤° à¤†à¤¯à¤¾à¤¤',0),(598172,16546,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥à¤°à¤® Froms à¤†à¤¯à¤¾à¤¤ à¤•à¤°à¥‡à¤‚',0),(598173,16547,'hi','Intercompany à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤­à¤¾à¤¡à¤¼à¤¾ à¤¬à¥‹à¤',0),(598174,16548,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(598175,16549,'hi','à¤¨à¤¯à¤¾ à¤¸à¥à¤Ÿà¥‰à¤• à¤šà¥‡à¤• à¤…à¤¨à¥à¤°à¥‹à¤§',0),(598176,16550,'hi','à¤®à¤šà¤¾à¤¨ à¤•à¥à¤·à¥‡à¤¤à¥à¤°à¥‹à¤‚',0),(598177,16551,'hi','à¤¸à¥à¤Ÿà¥ˆà¤—à¤¿à¤‚à¤— à¤•à¥à¤·à¥‡à¤¤à¥à¤°',0),(598178,16552,'hi','à¤–à¤¾à¤¤à¤¾ à¤ªà¥à¤°à¤•à¤¾à¤° à¤—à¤²à¤¤',0),(598179,16553,'hi','à¤—à¤¿à¤¨à¤¤à¥€ à¤¨à¤¹à¥€à¤‚ à¤–à¤¾à¤¤à¤¾ à¤¨à¤¾à¤® à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤–à¥‹à¤œà¥‡à¤‚',0),(598180,16554,'hi','à¤—à¤¿à¤¨à¤¤à¥€ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤² à¤•à¥‡ à¤¨à¤¾à¤® à¤¸à¥‡ à¤–à¤¾à¤¤à¥‡ à¤•à¥€ à¤œà¤¾à¤à¤š',0),(598181,16555,'hi','à¤—à¤¿à¤¨à¤¤à¥€ à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤² à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤µà¤¿à¤§à¤¿ à¤¨à¤¾à¤® à¤¦à¥à¤µà¤¾à¤°à¤¾',0),(598182,16556,'hi','à¤®à¥ˆà¤š Muliple à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(598183,16557,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿà¤² à¤•à¥‹à¤¡ à¤¯à¤¾ à¤°à¤¾à¤œà¥à¤¯ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(598184,16558,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ ID',0),(598185,16559,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ ID à¤¯à¤¾ à¤¨à¤¾à¤® à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(598186,16560,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤•à¥‹à¤¡',0),(598187,16561,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¤‚à¤ªà¤¨à¥€ à¤•à¤¾ à¤¨à¤¾à¤® à¤¯à¤¾ à¤…à¤‚à¤¤à¤¿à¤® à¤¨à¤¾à¤® à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(598188,16562,'hi','à¤¬à¥ˆà¤‚à¤• à¤°à¥‚à¤Ÿà¤¿à¤‚à¤— à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(598189,16563,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤­à¥à¤—à¤¤à¤¾à¤¨ à¤µà¤¿à¤§à¤¿',0),(598190,16564,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥‹à¤¡ à¤¸à¥‡à¤Ÿ à¤¹à¥‹à¤¨à¤¾ à¤šà¤¾à¤¹à¤¿à¤',0),(598191,16565,'hi','à¤°à¤¿à¤•à¥à¤¤',0),(598192,16566,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤•à¤¾à¤° à¤¸à¥‡à¤Ÿ à¤•à¤°à¥‡à¤‚',0),(598193,16567,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¬à¥à¤• à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(598194,16568,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤–à¥‹à¤²à¥‡à¤‚',0),(598195,16569,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤†à¤œ',0),(598196,16570,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤•à¥à¤²',0),(598197,16571,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤•à¥€ à¤²à¤‚à¤¬à¤¾à¤ˆ',0),(598198,16572,'hi','à¤¨à¤¿à¤¯à¥à¤•à¥à¤¤à¤¿ à¤¸à¥‚à¤šà¥€ à¤•à¥‡ à¤²à¤¿à¤',0),(598199,16573,'hi','à¤¨à¤¿à¤¯à¥à¤•à¥à¤¤à¤¿ à¤¸à¥à¤¥à¤¾à¤¨',0),(598200,16574,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¨à¤¾à¤®',0),(598201,16575,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(598202,16576,'hi','B2B à¤¨à¤¿à¤¯à¥à¤•à¥à¤¤à¤¿ à¤¶à¥‡à¤¡à¥à¤¯à¥‚à¤²à¤°',0),(598203,16577,'hi','à¤‰à¤¦à¥à¤˜à¤¾à¤Ÿà¤¨ à¤•à¥‡ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¬à¤¨à¤¾à¤à¤',0),(598204,16578,'hi','à¤–à¥à¤²à¥‡ à¤¹à¥à¤ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¹à¤Ÿà¤¾à¤à¤',0),(598205,16579,'hi','à¤…à¤—à¤²à¥‡ à¤­à¤µà¤¿à¤·à¥à¤¯ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ',0),(598206,16580,'hi','à¤¦à¥‡à¤–à¥‡à¤‚ & à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤•à¥‹ à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤šà¥à¤¨à¥‡à¤‚',0),(598207,16581,'hi','à¤¦à¤¿à¤–à¤¾à¤à¤ à¤¸à¤¾à¤°à¤¾à¤‚à¤¶',0),(598208,16582,'hi','à¤¨à¤¿à¤¯à¥à¤•à¥à¤¤à¤¿ unbook',0),(598209,16583,'hi','à¤¨à¤ˆ à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡',0),(598210,16584,'hi','à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€ à¤¨à¤¾à¤®',0),(598211,16585,'hi','à¤®à¥‚à¤² à¤°à¤¾à¤œà¥à¤¯',0),(598212,16586,'hi','à¤†à¤ª à¤à¤• à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€ à¤¨à¤¾à¤® à¤¦à¤°à¥à¤œ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(598213,16587,'hi','à¤†à¤ª à¤à¤• à¤°à¤¾à¤œà¥à¤¯ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(598214,16588,'hi','à¤•à¥à¤¯à¤¾ à¤†à¤ª à¤µà¤¾à¤•à¤ˆ à¤‡à¤¸ à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€',0),(598215,16589,'hi','Delete à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€',0),(598216,16590,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤•à¤¸à¥à¤Ÿà¤® à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€',0),(598217,16591,'hi','à¤à¤• à¤¨à¤¯à¤¾ à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€ à¤•à¥‹ à¤œà¥‹à¤¡à¤¼à¤¨à¥‡ à¤ªà¤° à¤µà¤¿à¤šà¤¾à¤°',0),(598218,16592,'hi','à¤¸à¤‚à¤ªà¤¾à¤¦à¤¨ à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€',0),(598219,16593,'hi','à¤†à¤ªà¤•à¤¾ à¤šà¤¯à¤¨ à¤à¤• à¤¸à¤¿à¤¸à¥à¤Ÿà¤® à¤®à¤¾à¤¨ à¤¹à¥ˆ à¤”à¤° à¤¬à¤¦à¤²à¤¾ à¤¨à¤¹à¥€à¤‚ à¤œà¤¾ à¤¸à¤•à¤¤à¤¾',0),(598220,16594,'hi','à¤†à¤ª à¤œà¤¾à¤°à¥€ à¤°à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤ªà¥à¤°à¤ªà¤¤à¥à¤° à¤•à¥‹ à¤ªà¥‚à¤°à¤¾ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(598221,16595,'hi','à¤œà¥‹à¤¡à¤¼à¥‡ à¤—à¤ à¤—à¥à¤°à¤¾à¤¹à¤•',0),(598222,16596,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤•à¥‹ à¤›à¥‹à¤¡à¤¼ à¤¦à¤¿à¤¯à¤¾',0),(598223,16597,'hi','à¤—à¥à¤°à¤¾à¤¹à¤•à¥‹à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(598224,16598,'hi','à¤°à¥‡à¤–à¤¾à¤à¤ à¤ªà¤¢à¤¼à¥‡à¤‚',0),(598225,16599,'hi','à¤µà¥ˆà¤•à¤²à¥à¤ªà¤¿à¤• à¤«à¥‹à¤¨',0),(598226,16600,'hi','CSV à¤†à¤¯à¤¾à¤¤ à¤«à¤¼à¤¾à¤‡à¤²',0),(598227,16601,'hi','à¤®à¥‹à¤¬à¤¾à¤‡à¤² à¤«à¤¼à¥‹à¤¨ à¤µà¤¾à¤¹à¤•',0),(598228,16602,'hi','à¤®à¥‹à¤¬à¤¾à¤‡à¤² à¤«à¤¼à¥‹à¤¨ à¤¨à¤‚à¤¬à¤°',0),(598229,16603,'hi','à¤‡à¤¨à¤µà¥‰à¤‡à¤¸ à¤¨à¤¿à¤¯à¤® à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(598230,16604,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¸à¤‚à¤•à¥à¤·à¤¿à¤ªà¥à¤¤ à¤¨à¤¾à¤®',0),(598231,16605,'hi','à¤¸à¤¡à¤¼à¤• à¤•à¤¾ à¤ªà¤¤à¤¾',0),(598232,16606,'hi','à¤œà¥‹à¤¡à¤¼à¥‡à¤‚/à¤¸à¤‚à¤ªà¤¾à¤¦à¤¿à¤¤ à¤•à¤°à¥‡à¤‚',0),(598233,16607,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤®à¤¾à¤¹ à¤”à¤¸à¤¤ à¤µà¤¿à¤•à¥à¤°à¤¯',0),(598234,16608,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤†à¤ªà¥‚à¤°à¥à¤¤à¤¿',0),(598235,16609,'hi','à¤•à¥‹à¤ˆ à¤ªà¥à¤°à¤¾à¤¥à¤®à¤¿à¤• à¤¬à¤¿à¤¨ à¤…à¤¸à¤¾à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(598236,16610,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£ à¤ªà¤° à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(598237,16611,'hi','à¤µà¤¿à¤¤à¤°à¤£ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤¸à¥‡ à¤¶à¥‡à¤¯à¤° à¤•à¥€ à¤­à¤°à¤ªà¤¾à¤ˆ',0),(598238,16612,'hi','à¤•à¤¾ à¤¸à¥à¤à¤¾à¤µ à¤¦à¤¿à¤¯à¤¾',0),(598239,16613,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(598240,16614,'hi','à¤œà¤¼à¥‹à¤¨',0),(598241,16615,'hi','à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤¶à¤¹à¤°',0),(598242,16616,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¶à¤¹à¤°à¥‹à¤‚',0),(598243,16617,'hi','à¤•à¤¾à¤‰à¤‚à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤œà¥‹à¤¡à¤¼à¤¾',0),(598244,16618,'hi','à¤•à¤¾à¤‰à¤‚à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(598245,16619,'hi','à¤œà¥‹à¤¡à¤¼à¤¾ à¤—à¤¯à¤¾ à¤°à¤¾à¤œà¥à¤¯',0),(598246,16620,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤…à¤¦à¥à¤¯à¤¤à¤¨',0),(598247,16621,'hi','à¤•à¥à¤¯à¤¾ à¤µà¤¾à¤•à¤ˆ à¤†à¤ª à¤…à¤ªà¤¨à¥‡ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤° à¤°à¤¿à¤•à¥‰à¤°à¥à¤¡ à¤•à¥‹ à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤šà¤¾à¤¹à¤¤à¥‡ à¤¹à¥ˆà¤‚?',0),(598248,16622,'hi','à¤¶à¤¹à¤° à¤•à¤¾ à¤¨à¤¾à¤®',0),(598249,16623,'hi','à¤¶à¤¹à¤° à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤° à¤—à¥à¤£à¤•',0),(598250,16624,'hi','à¤¶à¤¹à¤° à¤•à¤¾ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤—à¥à¤£à¤•',0),(598251,16625,'hi','à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤° à¤—à¥à¤£à¤•',0),(598252,16626,'hi','à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤—à¥à¤£à¤•',0),(598253,16627,'hi','à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤° à¤†à¤¯à¤¾à¤¤',0),(598254,16628,'hi','à¤°à¤¾à¤œà¥à¤¯ à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤—à¥à¤£à¤•',0),(598255,16629,'hi','à¤°à¤¾à¤œà¥ à¤¯ à¤‰à¤ªà¤¯à¥‹à¤— à¤•à¤° à¤—à¥à¤£à¤•',0),(598256,16630,'hi','à¤¥à¥‰à¤®à¤¸à¤¨ à¤°à¤¾à¤¯à¤Ÿà¤° à¤Ÿà¥ˆà¤¬ à¤«à¤¼à¤¾à¤‡à¤²',0),(598257,16631,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¡à¥‡à¤Ÿà¤¾',0),(598258,16632,'hi','à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤°à¤–à¥‡à¤‚',0),(598259,16633,'hi','à¤¸à¤­à¥€ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤®à¤¿à¤Ÿà¤¾à¤à¤',0),(598260,16634,'hi','à¤†à¤¯à¤¾à¤¤ à¤®à¥‡à¤‚ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤•à¥‡ à¤²à¤¿à¤ à¤®à¥Œà¤œà¥‚à¤¦à¤¾ à¤¡à¥‡à¤Ÿà¤¾ à¤®à¤¿à¤Ÿà¤¾à¤à¤',0),(598261,16635,'hi','à¤²à¤‚à¤¬à¤¿à¤¤ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤•à¥à¤°à¥‡à¤¡à¤¿à¤Ÿ',0),(598262,16636,'hi','à¤‘à¤Ÿà¥‹ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚ à¤µà¤¿à¤•à¥à¤°à¤¯ à¤•à¤° à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤¸à¥‡',0),(598263,16637,'hi','à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤”à¤° POS à¤†à¤¦à¥‡à¤¶ à¤ªà¤°',0),(598264,16638,'hi','à¤•à¥‡à¤µà¤² à¤µà¤¿à¤¤à¤°à¤£ à¤•à¥‡à¤¨à¥à¤¦à¥à¤°à¥‹à¤‚ à¤¸à¥‡ à¤µà¤¾à¤ªà¤¸ à¤†à¤¦à¥‡à¤¶ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(598265,16639,'hi','à¤¸à¥à¤µà¤šà¤¾à¤²à¤¿à¤¤ à¤°à¥‚à¤ª à¤¸à¥‡ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤œà¤¹à¤¾à¤œ à¤¸à¥‡ à¤ªà¥‚à¤°à¥à¤¤à¤¿ à¤”à¤° POS à¤†à¤¦à¥‡à¤¶ à¤ªà¤° à¤¬à¤¿à¤•à¥à¤°à¥€ à¤•à¤° à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(598266,16640,'hi','à¤…à¤‚à¤¤à¤¿à¤® à¤¡à¥à¤°à¥‰à¤ª à¤¶à¤¿à¤ªà¤®à¥‡à¤‚à¤Ÿ à¤«à¤²à¥€ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾ à¤¹à¥‹à¤¤à¥€ à¤¹à¥ˆ',0),(598267,16641,'hi','à¤µà¥ˆà¤•à¤²à¥à¤ªà¤¿à¤• à¤–à¤°à¥€à¤¦ à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤œà¤¬ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤¸à¥à¤à¤¾à¤µ à¤¹à¥ˆ à¤•à¤¿',0),(598268,16642,'hi','à¤†à¤‚à¤¶à¤¿à¤• à¤•à¤° à¤›à¥‚à¤Ÿ',0),(598269,16643,'hi','à¤•à¤° à¤•à¥€ à¤¦à¤° à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤',0),(598270,16644,'hi','à¤µà¤¿à¤¤à¤°à¤£ à¤•à¥‡à¤‚à¤¦à¥à¤° Num à¤®à¤¹à¥€à¤¨à¥‡ à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤—à¤£à¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(598271,16645,'hi','à¤¶à¤¾à¤–à¤¾à¤‚à¤¤à¤—à¤°à¥à¤¤ à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤¬à¥‹à¤ à¤ªà¥à¤°à¤¤à¤¿à¤¶à¤¤ GL à¤–à¤¾à¤¤à¥‡',0),(598272,16646,'hi','à¤†à¤‡à¤Ÿà¤® à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ - intercompany à¤à¤•à¤¾à¤§à¤¿à¤• à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤•à¥€ à¤…à¤¨à¥à¤®à¤¤à¤¿ à¤¦à¥‡à¤‚',0),(598273,16647,'hi','Intercompany à¤ªà¥‹à¤¸à¥à¤Ÿà¤¿à¤‚à¤— à¤†à¤‡à¤Ÿà¤® à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤¨à¥à¤¤à¤°à¤£-',0),(598274,16648,'hi','à¤ªà¤¾à¤°à¤—à¤®à¤¨ GL à¤–à¤¾à¤¤à¥‡ à¤®à¥‡à¤‚ à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€',0),(598275,16649,'hi','à¤—à¥ˆà¤°-à¤µà¤¿à¤¤à¤°à¤£ à¤•à¥‡à¤‚à¤¦à¥à¤° Num à¤®à¤¹à¥€à¤¨à¥‡ à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤—à¤£à¤¨à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(598276,16650,'hi','à¤°à¥‡à¤–à¤¾ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¥‹à¤¸à¥à¤Ÿ',0),(598277,16651,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— à¤”à¤° à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¤¾',0),(598278,16652,'hi','B2B à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤²à¥‰à¤—à¤¿à¤¨',0),(598279,16653,'hi','à¤‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤²à¥‰à¤— à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(598280,16654,'hi','à¤ªà¥‚à¤°à¥€ à¤µà¥à¤¯à¤µà¤¸à¥à¤¥à¤¾ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤¨à¤¹à¥€à¤‚ à¤¸à¤¹à¥‡à¤œ à¤¸à¤•à¤¤à¤¾',0),(598281,16655,'hi','POD à¤«à¤¼à¤¾à¤‡à¤² à¤…à¤¨à¥à¤²à¤—à¥à¤¨ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤†à¤¦à¥‡à¤¶ à¤¨à¤¹à¥€à¤‚',0),(598282,16656,'hi','à¤¡à¥à¤°à¥‰à¤ª à¤œà¤¹à¤¾à¤œ',0),(598283,16657,'hi','à¤ªà¥à¤°à¤¾à¤²à¥‡à¤– & à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(598284,16658,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(598285,16659,'hi','GL à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¬à¤‚à¤¦ à¤•à¤° à¤¦à¤¿à¤¯à¤¾',0),(598286,16660,'hi','à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤–à¤¾à¤¤à¥‹à¤‚ à¤•à¥‹ à¤¬à¤‚à¤¦ à¤•à¤°à¥‡à¤‚',0),(598287,16661,'hi','GL à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥‡ à¤…à¤¨à¥à¤¸à¤¾à¤° à¤–à¤¾à¤¤à¥‡ à¤¬à¤‚à¤¦',0),(598288,16662,'hi','à¤¤à¤¾à¤°à¥€à¤– à¤°à¤¦à¥à¤¦',0),(598289,16663,'hi','13 à¤…à¤µà¤§à¤¿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿',0),(598290,16664,'hi','à¤•à¤° à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(598291,16665,'hi','à¤µà¤°à¥à¤· à¤…à¤‚à¤¤ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(598292,16666,'hi','13 à¤…à¤µà¤§à¤¿ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¤¾à¤',0),(598293,16667,'hi','Adjusting à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤Ÿà¥ˆà¤•à¥à¤¸',0),(598294,16668,'hi','à¤µà¤°à¥à¤· à¤•à¥‡ à¤…à¤‚à¤¤ à¤•à¥‡ à¤¸à¤¾à¤¥ à¤ªà¥à¤°à¤µà¤¿à¤·à¥à¤Ÿà¤¿à¤¯à¥‹à¤‚ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¿à¤¤ à¤•à¤°à¤¨à¤¾',0),(598295,16669,'hi','à¤—à¥ˆà¤°-à¤¸à¥à¤Ÿà¥‰à¤•',0),(598296,16670,'hi','à¤…à¤¨à¥à¤¯ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(598297,16671,'hi','à¤…à¤¨à¥ à¤¯ à¤ªà¥à¤°à¤­à¤¾à¤°',0),(598298,16672,'hi','à¤¸à¥à¤¥à¤¾à¤¨à¥‹à¤‚ à¤•à¥‡ à¤¬à¥€à¤š à¤¸à¥à¤¥à¤¾à¤¨à¤¾à¤‚à¤¤à¤°à¤£',0),(598299,16673,'hi','à¤¹à¤¸à¥à¤¤à¤¾à¤‚à¤¤à¤°à¤£ à¤µà¤¿à¤µà¤°à¤£',0),(598300,16674,'hi','à¤—à¥ˆà¤°-à¤¸à¥à¤Ÿà¥‰à¤•',0),(598301,16675,'hi','à¤•à¤¿à¤°à¤¾à¤ à¤ªà¤° à¤²à¥‡à¤¨à¥‡ à¤•à¥€',0),(598302,16676,'hi','à¤°à¤–à¤¤à¤¾',0),(598303,16677,'hi','à¤•à¥‹à¤ˆ à¤…à¤§à¤¿à¤•à¤¤à¤® à¤•à¥‡ à¤²à¤¿à¤ 0',0),(598304,16678,'hi','à¤•à¥‹à¤ˆ à¤¨à¥à¤¯à¥‚à¤¨à¤¤à¤® à¤•à¥‡ à¤²à¤¿à¤ 0',0),(598305,16679,'hi','à¤ªà¥à¤°à¤¤à¤¿ à¤®à¤¾à¤¹ à¤”à¤¸à¤¤ à¤®à¤¾à¤¤à¥à¤°à¤¾',0),(598306,16680,'hi','à¤¬à¤¨à¤¾à¤ˆ à¤—à¤ˆ à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶',0),(598307,16681,'hi','à¤•à¥à¤°à¤¯ à¤†à¤¦à¥‡à¤¶ à¤¬à¤¨à¤¾à¤à¤',0),(598308,16682,'hi','à¤µà¤¿à¤¤à¤°à¤£ à¤•à¥‡à¤¨à¥à¤¦à¥à¤°à¥‹à¤‚',0),(598309,16683,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¸à¥à¤¥à¤¾à¤¨',0),(598310,16684,'hi','à¤¹à¤¾à¤¥ à¤ªà¤° à¤…à¤§à¤¿à¤•à¤¤à¤®',0),(598311,16685,'hi','à¤¹à¤¾à¤¥ à¤ªà¤° à¤®à¤¿à¤¨à¤Ÿ',0),(598312,16686,'hi','à¤®à¥‡à¤°à¥‡ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚',0),(598313,16687,'hi','Num à¤®à¤¹à¥€à¤¨à¥‡ à¤¹à¤¾à¤¥ à¤ªà¤° à¤…à¤§à¤¿à¤•à¤¤à¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(598314,16688,'hi','Num à¤®à¤¹à¥€à¤¨à¥‡ à¤•à¤® à¤¸à¥‡ à¤•à¤® à¤¹à¤¾à¤¥ à¤ªà¤° à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(598315,16689,'hi','Num à¤®à¤¹à¥€à¤¨à¥‡ à¤ªà¥à¤¨à¤ƒà¤•à¥à¤°à¤®à¤¿à¤¤ à¤•à¤°à¥‡à¤‚ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‡ à¤²à¤¿à¤ à¤¬à¤¿à¤•à¥à¤°à¥€',0),(598316,16690,'hi','à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤†à¤‡à¤Ÿà¤® à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤¹à¥ˆ?',0),(598317,16691,'hi','à¤¦à¤¿à¤¨à¥‹à¤‚ à¤•à¥€ à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(598318,16692,'hi','à¤¬à¥‹à¤²à¥€ à¤²à¥€à¤¡ à¤¸à¤®à¤¯',0),(598319,16693,'hi','à¤‡à¤¸ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤•à¤¿à¤¸à¥€ à¤­à¥€ à¤…à¤¨à¥à¤¯ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾à¤“à¤‚ à¤¨à¤¿à¤•à¤¾à¤²à¥‡à¤‚ à¤¹à¥‹à¤—à¤¾ à¤‡à¤¸ à¤†à¤‡à¤Ÿà¤® à¤•à¥‡ à¤²à¤¿à¤ à¤¡à¤¿à¤«à¤¼à¥‰à¤²à¥à¤Ÿ ',0),(598320,16694,'hi','à¤µà¤¿à¤•à¥à¤°à¥‡à¤¤à¤¾ UPC',0),(598321,16695,'hi','RTV à¤¸à¤‚à¤–à¥à¤¯à¤¾',0),(598322,16696,'hi','à¤µà¤¾à¤ªà¤¸ à¤†à¤¦à¥‡à¤¶',0),(598323,16697,'hi','à¤¡à¥à¤°à¥‰à¤ª à¤œà¤¹à¤¾à¤œ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤‡à¤¸ à¤•à¥à¤°à¤® à¤ªà¤°à¤¿à¤µà¤°à¥à¤¤à¤¿à¤¤ à¤¨à¤¹à¥€à¤‚ à¤•à¤° à¤¸à¤•à¤¤à¤¾',0),(598324,16698,'hi','à¤µà¤°à¥à¤¤à¤®à¤¾à¤¨ à¤¸à¥à¤¥à¤¾à¤¨',0),(598325,16699,'hi','à¤—à¥ˆà¤°-à¤¡à¥à¤°à¥‰à¤ª à¤œà¤¹à¤¾à¤œ à¤µà¤¸à¥à¤¤à¥à¤“à¤‚ à¤•à¤¾ à¤²à¤¦à¤¾à¤¨ à¤†à¤¦à¥‡à¤¶ à¤¹à¥ˆ',0),(598326,16700,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤®à¥‡à¤‚ à¤¸à¥à¤¥à¤¾à¤¨ à¤‰à¤ªà¤²à¤¬à¥à¤§ à¤¨à¤¹à¥€à¤‚ à¤¹à¥ˆ',0),(598327,16701,'hi','à¤†à¤¦à¥‡à¤¶ à¤®à¤¾à¤¤à¥à¤°à¤¾ à¤•à¥‹ à¤•à¤®',0),(598328,16702,'hi','à¤¨à¤¿à¤•à¤¾à¤²à¤¾ à¤œà¤¾ à¤•à¤°à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤¨à¤¿à¤®à¥à¤¨ à¤—à¥ˆà¤°-à¤¡à¥à¤°à¥‰à¤ª à¤œà¤¹à¤¾à¤œ à¤†à¤‡à¤Ÿà¤®',0),(598329,16703,'hi','à¤µà¤¾à¤‰à¤šà¤° ID',0),(598330,16704,'hi','à¤ªà¥à¤°à¤¾à¤¥à¤®à¤¿à¤• à¤–à¤°à¥€à¤¦à¤¾à¤°',0),(598331,16705,'hi','à¤•à¤¾à¤‰à¤‚à¤Ÿà¥€ à¤¯à¤¦à¤¿ à¤¸à¥‚à¤šà¥€ à¤ªà¤° à¤¨à¤¹à¥€à¤‚',0),(598332,16706,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤•à¤¾à¤°à¥à¤°à¤µà¤¾à¤ˆ',0),(598333,16707,'hi','GL à¤–à¤¾à¤¤à¥‡ à¤•à¥‹à¤¡ à¤²à¤¾à¤—à¤¤ à¤¹à¥ˆ, à¤¤à¥‹ à¤²à¤¾à¤—à¤¤ à¤•à¥‹à¤¡ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(598334,16708,'hi','GL à¤¶à¥à¤°à¥‡à¤£à¤¿à¤¯à¤¾à¤ GL à¤–à¤¾à¤¤à¤¾ à¤¹à¥ˆ, à¤¤à¥‹ GL à¤¶à¥à¤°à¥‡à¤£à¥€ à¤•à¥€ à¤†à¤µà¤¶à¥à¤¯à¤•à¤¤à¤¾',0),(598335,16709,'hi','à¤µà¤¿à¤¤à¤°à¤£ à¤•à¥‡à¤‚à¤¦à¥à¤°',0),(598336,16710,'hi','à¤µà¤¿à¤¤à¤°à¤£ à¤•à¥‡à¤‚à¤¦à¥à¤° à¤¹à¥ˆ?',0),(598337,16711,'hi','à¤šà¥‡à¤• à¤‡à¤¨ à¤•à¤¿à¤¯à¤¾ à¤—à¤¯à¤¾',0),(598338,16712,'hi','à¤šà¥‡à¤• à¤‡à¤¨ à¤•à¤°à¥‹',0),(598339,16713,'hi','à¤…à¤¬ à¤œà¤¾à¤‚à¤š',0),(598340,16714,'hi','à¤®à¥‡à¤‚ à¤¸à¤®à¤¯ à¤•à¥€ à¤œà¤¾à¤à¤š à¤•à¤°à¥‡à¤‚',0),(598341,16715,'hi','à¤¨à¥‹à¤Ÿà¥à¤¸ à¤¸à¤¹à¥‡à¤œà¥‡à¤‚',0),(598342,16716,'hi','à¤…à¤¦à¥à¤¯à¤¤à¤¨ à¤¨à¥‹à¤Ÿà¥à¤¸',0),(598343,16717,'hi','GL à¤–à¤¾à¤¤à¥‡ à¤•à¥‡ à¤¨à¤¾à¤® à¤¸à¥‡ à¤¨à¤¹à¥€à¤‚ à¤¢à¥‚à¤à¤¢ à¤¸à¤•à¤¾',0),(598344,16718,'hi','à¤°à¥‹à¤—à¥€ à¤†à¤¯à¤¾à¤¤',0),(598345,16719,'hi','à¤¦à¤¿à¤¨ à¤­à¤°',0),(598346,16720,'hi','à¤ªà¤¿à¤›à¤²à¥‡ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ',0),(598347,16721,'hi','777 chmod à¤•à¥ƒà¤ªà¤¯à¤¾',0),(598348,16722,'hi','à¤¸à¤­à¥€ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ',0),(598349,16723,'hi','à¤‡à¤¸ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¬à¥à¤•',0),(598350,16724,'hi','à¤¨à¤¹à¥€à¤‚ à¤®à¤¿à¤²à¤¾ à¤†à¤¦à¥‡à¤¶',0),(598351,16725,'hi','à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¸à¤®à¤¯ à¤•à¥€ à¤ªà¥à¤·à¥à¤Ÿà¤¿ à¤•à¤°à¥‡à¤‚',0),(598352,16726,'hi','à¤¸à¥à¤µà¤¿à¤§à¤¾ à¤¸à¤•à¥à¤·à¤® à¤¨à¤¹à¥€à¤‚',0),(598353,16727,'hi','à¤…à¤—à¤²à¤¾ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ',0),(598354,16728,'hi','à¤•à¥‹à¤ˆ à¤†à¤¨à¥‡ à¤µà¤¾à¤²à¥‡ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ',0),(598355,16729,'hi','à¤–à¥à¤²à¥‡ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤•à¥‡ à¤²à¤¿à¤',0),(598356,16730,'hi','à¤–à¥à¤²à¥‡ à¤…à¤ªà¥‰à¤‡à¤‚à¤Ÿà¤®à¥‡à¤‚à¤Ÿ à¤¦à¥‡à¤–à¤¨à¥‡ à¤•à¥‡ à¤²à¤¿à¤ à¤à¤• à¤¤à¤¿à¤¥à¤¿ à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(598357,16731,'hi','à¤œà¤¹à¤¾à¤‚',0),(598358,16732,'hi','à¤…à¤¨à¥à¤¸à¥‚à¤šà¥€ à¤à¤• à¤¨à¤¿à¤¯à¥à¤•à¥à¤¤à¤¿',0),(598359,16733,'hi','à¤¦à¤¿à¤¨à¤¾à¤‚à¤• à¤•à¤¾ à¤šà¤¯à¤¨ à¤•à¤°à¥‡à¤‚',0),(598360,16734,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¥à¤°à¤•à¤¾à¤°',0),(598361,16735,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¥à¤°à¤•à¤¾à¤° à¤‡à¤¸ à¤•à¥‹à¤¡ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤ªà¤¹à¤²à¥‡ à¤¸à¥‡ à¤¹à¥€ à¤®à¥Œà¤œà¥‚à¤¦ à¤¹à¥ˆ',0),(598362,16736,'hi','à¤µà¤¸à¥à¤¤à¥ à¤¸à¥‚à¤šà¥€ à¤¸à¤®à¤¾à¤¯à¥‹à¤œà¤¨ à¤…à¤¨à¥à¤°à¥‹à¤§ à¤ªà¥à¤°à¤•à¤¾à¤° à¤•à¥‹à¤¡ à¤¸à¥‡à¤Ÿ à¤•à¤°à¤¨à¤¾ à¤¹à¥‹à¤—à¤¾',0),(598363,16737,'hi','à¤ªà¥‹à¤¸à¥à¤Ÿ à¤¦à¥à¤µà¤¾à¤°à¤¾ à¤¶à¤¿à¤ªà¤¿à¤‚à¤— & à¤ªà¥à¤°à¤¾à¤ªà¥à¤¤ à¤•à¤°à¤¨à¤¾',0),(598364,16738,'hi','à¤‡à¤¸ à¤‰à¤ªà¤¯à¥‹à¤—à¤•à¤°à¥à¤¤à¤¾ à¤•à¥‡ à¤°à¥‚à¤ª à¤®à¥‡à¤‚ à¤²à¥‰à¤— à¤‡à¤¨ à¤•à¤°à¥‡à¤‚',0),(598365,16739,'hi','à¤‰à¤¦à¥à¤§à¤°à¤£ à¤šà¤¿à¤¹à¥à¤¨à¥‹à¤‚ à¤®à¥‡à¤‚ à¤¶à¤¾à¤®à¤¿à¤² à¤¹à¥ˆà¤‚',0),(598366,16503,'ba','Tidak bisa membaca catatan',0),(598367,16504,'ba','Tidak bisa ditambahkan',0),(598368,16505,'ba','Tidak dapat diperbarui',0),(598369,16506,'ba','Formulir lengkap',0),(598370,16507,'ba','Tidak dapat membaca File',0),(598371,16508,'ba','Bidang kustom Add-on diperlukan',0),(598372,16509,'ba','Beban kargo',0),(598373,16510,'ba','Beban kargo',0),(598374,16511,'ba','Termasuk akhir tahun menyesuaikan entri',0),(598375,16512,'ba','Persediaan penyesuaian permintaan jenis',0),(598376,16513,'ba','Persediaan penyesuaian permintaan jenis dengan kode ini sudah ada',0),(598377,16514,'ba','Persediaan penyesuaian permintaan jenis kode harus ditetapkan',0),(598378,16515,'ba','Membuat Transfer',0),(598379,16516,'ba','Default Intercompany Transfer Offset Account harus ditetapkan',0),(598380,16517,'ba','Antar Item Transfer - cetak',0),(598381,16518,'ba','Persediaan GL Account harus diberikan pada Item atau akun bawaan yang ditetapkan di pengaturan persediaan',0),(598382,16519,'ba','Num bulan penjualan untuk menyusun ulang Qty',0),(598383,16520,'ba','Num bulan untuk mengisi',0),(598384,16521,'ba','Pengisian',0),(598385,16522,'ba','Pengisian transfer',0),(598386,16523,'ba','Transfer yang disimpan',0),(598387,16524,'ba','Diterima tanggal',0),(598388,16525,'ba','Penyesuaian jenis',0),(598389,16526,'ba','Ditetapkan',0),(598390,16527,'ba','Tanggal ditetapkan',0),(598391,16528,'ba','Dihitung',0),(598392,16529,'ba','Jumlah jenis',0),(598393,16530,'ba','Tanggal yang ditetapkan',0),(598394,16531,'ba','Barang-barang yang dihitung',0),(598395,16532,'ba','Terakhir diperbarui oleh',0),(598396,16533,'ba','Persen dihitung',0),(598397,16534,'ba','Tipe permintaan',0),(598398,16535,'ba','Permintaan Check saham',0),(598399,16536,'ba','Permintaan Check saham',0),(598400,16537,'ba','Saham Check Status permintaan',0),(598401,16538,'ba','Varians nilai Amt',0),(598402,16539,'ba','Varians nilai persen',0),(598403,16540,'ba','Tambahkan Edit County',0),(598404,16541,'ba','Pembuat jadwal',0),(598405,16542,'ba','Count manajemen',0),(598406,16543,'ba','Impor Info Pelanggan',0),(598407,16544,'ba','Impor Salesman wilayah',0),(598408,16545,'ba','Impor pajak penjualan',0),(598409,16546,'ba','Impor Vendor urutan Froms',0),(598410,16547,'ba','Antar Transfer Freight beban',0),(598411,16548,'ba','Jenis permintaan inventaris penyesuaian',0),(598412,16549,'ba','Permintaan Check saham baru',0),(598413,16550,'ba','Staging area',0),(598414,16551,'ba','Area Stage',0),(598415,16552,'ba','Rekening jenis salah',0),(598416,16553,'ba','Count tidak menemukan akun dengan nama',0),(598417,16554,'ba','Count tidak menemukan rekening dengan nama',0),(598418,16555,'ba','Count tidak menemukan pengiriman metode oleh nama',0),(598419,16556,'ba','Pertandingan Muliple vendor',0),(598420,16557,'ba','Kode pos atau negara diperlukan',0),(598421,16558,'ba','Salesman ID',0),(598422,16559,'ba','Salesman ID atau nama harus ditetapkan',0),(598423,16560,'ba','Kode negara',0),(598424,16561,'ba','Nama perusahaan Penjual atau nama belakang harus ditetapkan',0),(598425,16562,'ba','Nomor Routing Bank',0),(598426,16563,'ba','Metode membayar standar',0),(598427,16564,'ba','Kode Penjual harus ditetapkan',0),(598428,16565,'ba','Kosong',0),(598429,16566,'ba','Ada Type Set',0),(598430,16567,'ba','Janji yang dipesan',0),(598431,16568,'ba','Janji Open',0),(598432,16569,'ba','Janji hari ini',0),(598433,16570,'ba','Total janji',0),(598434,16571,'ba','Penunjukan panjang',0),(598435,16572,'ba','Daftar wawancara untuk',0),(598436,16573,'ba','Lokasi janji temu',0),(598437,16574,'ba','Nama perjanjian',0),(598438,16575,'ba','Penunjukan ringkasan',0),(598439,16576,'ba','B2B janji Scheduler',0),(598440,16577,'ba','Membuat janji bukaan',0),(598441,16578,'ba','Menghapus janji temu terbuka',0),(598442,16579,'ba','Janji masa depan berikutnya',0),(598443,16580,'ba','Pilihlah tanggal untuk lihat & mengedit janji',0),(598444,16581,'ba','Tampilkan Rangkuman',0),(598445,16582,'ba','Unbook janji',0),(598446,16583,'ba','Menambahkan baru County',0),(598447,16584,'ba','County nama',0),(598448,16585,'ba','Negara induk',0),(598449,16586,'ba','Anda harus memasukkan nama County',0),(598450,16587,'ba','Anda harus memilih sebuah negara',0),(598451,16588,'ba','Apakah Anda yakin Anda ingin menghapus County ini?',0),(598452,16589,'ba','Hapus County',0),(598453,16590,'ba','Edit Custom County',0),(598454,16591,'ba','Pertimbangkan untuk menambahkan baru County',0),(598455,16592,'ba','Edit County',0),(598456,16593,'ba','Pilihan Anda adalah sistem nilai dan tidak dapat diubah',0),(598457,16594,'ba','Anda harus mengisi formulir untuk melanjutkan',0),(598458,16595,'ba','Pelanggan ditambahkan',0),(598459,16596,'ba','Pelanggan yang dilewati',0),(598460,16597,'ba','Pelanggan yang diperbarui',0),(598461,16598,'ba','Membaca baris',0),(598462,16599,'ba','Alternatif telepon',0),(598463,16600,'ba','File impor CSV',0),(598464,16601,'ba','Operator ponsel',0),(598465,16602,'ba','Nomor ponsel',0),(598466,16603,'ba','Pilih faktur persyaratan',0),(598467,16604,'ba','Singkatan negara',0),(598468,16605,'ba','Alamat jalan',0),(598469,16606,'ba','Tambahkan Edit',0),(598470,16607,'ba','AVG penjualan Per bulan',0),(598471,16608,'ba','Pasokan saat ini',0),(598472,16609,'ba','Bin tidak utama ditetapkan',0),(598473,16610,'ba','Qty pada Transfer',0),(598474,16611,'ba','Mengisi saham dari pusat distribusi',0),(598475,16612,'ba','Menyarankan',0),(598476,16613,'ba','Mentransfer Qty',0),(598477,16614,'ba','Zona',0),(598478,16615,'ba','Kota-kota yang ditambahkan',0),(598479,16616,'ba','Kota-kota yang diperbarui',0),(598480,16617,'ba','County ditambahkan',0),(598481,16618,'ba','County Diperbarui',0),(598482,16619,'ba','Negara-negara yang ditambahkan',0),(598483,16620,'ba','Negara-negara yang diperbarui',0),(598484,16621,'ba','Apakah Anda yakin Anda ingin memperbarui catatan pajak penjualan Anda?',0),(598485,16622,'ba','Nama kota',0),(598486,16623,'ba','Kota pajak penjualan Multiplier',0),(598487,16624,'ba','Kota menggunakan pajak Multiplier',0),(598488,16625,'ba','Multiplier pajak penjualan County',0),(598489,16626,'ba','County Use pajak Multiplier',0),(598490,16627,'ba','Impor pajak penjualan',0),(598491,16628,'ba','Multiplier negara pajak penjualan',0),(598492,16629,'ba','Gunakan negara pajak Multiplier',0),(598493,16630,'ba','Thomson Reuters Tab File',0),(598494,16631,'ba','Data yang ada',0),(598495,16632,'ba','Menyimpan Data yang ada',0),(598496,16633,'ba','Membersihkan semua Data yang ada',0),(598497,16634,'ba','Membersihkan Data yang ada untuk vendor di impor',0),(598498,16635,'ba','Tertunda Penjual kredit',0),(598499,16636,'ba','Pilih Auto pajak penjualan dari kapal untuk',0),(598500,16637,'ba','Pada pemenuhan dan POS perintah',0),(598501,16638,'ba','Memungkinkan Pemesanan hanya dari pusat distribusi',0),(598502,16639,'ba','Otomatis memilih pajak penjualan dari kapal untuk pemenuhan dan POS perintah',0),(598503,16640,'ba','Akhir Drop Pengiriman memerlukan POD',0),(598504,16641,'ba','Menyarankan alternatif pembelian lokasi ketika Qty tidak tersedia',0),(598505,16642,'ba','Pembebasan pajak parsial',0),(598506,16643,'ba','Persen tingkat pajak',0),(598507,16644,'ba','Pusat distribusi Num bulan penjualan untuk menyusun ulang perhitungan',0),(598508,16645,'ba','Interbranch Transfer beban persentase GL Account',0),(598509,16646,'ba','Antar Jemput Item - yang memungkinkan beberapa lokasi',0),(598510,16647,'ba','Antar Jemput Item - Posting',0),(598511,16648,'ba','Persediaan di Transit GL Account',0),(598512,16649,'ba','Pusat distribusi bebas Num bulan penjualan untuk menyusun ulang perhitungan',0),(598513,16650,'ba','Posting oleh baris',0),(598514,16651,'ba','Posting oleh pengiriman dan penerimaan',0),(598515,16652,'ba','B2B pengguna Login',0),(598516,16653,'ba','Log In sebagai pengguna ini',0),(598517,16654,'ba','Tidak dapat menyimpan sebagai urutan lengkap',0),(598518,16655,'ba','Tidak ada File POD yang melekat pada urutan',0),(598519,16656,'ba','Drop kapal',0),(598520,16657,'ba','Arsip & Simpan',0),(598521,16658,'ba','Ditutup oleh biaya kode',0),(598522,16659,'ba','Ditutup oleh GL Kategori',0),(598523,16660,'ba','Menutup account dengan biaya kode',0),(598524,16661,'ba','Menutup account dengan kategori GL',0),(598525,16662,'ba','Tanggal yang dibatalkan',0),(598526,16663,'ba','13 periode entri',0),(598527,16664,'ba','Pajak menyesuaikan entri',0),(598528,16665,'ba','Tahun akhir menyesuaikan entri',0),(598529,16666,'ba','13 periode entri',0),(598530,16667,'ba','Pajak menyesuaikan entri',0),(598531,16668,'ba','Dengan akhir tahun menyesuaikan entri',0),(598532,16669,'ba','Saham non-',0),(598533,16670,'ba','Biaya lain',0),(598534,16671,'ba','Biaya lainnya',0),(598535,16672,'ba','Transfer antara lokasi',0),(598536,16673,'ba','Rincian transfer',0),(598537,16674,'ba','Bebas-penuh',0),(598538,16675,'ba','Penyewaan',0),(598539,16676,'ba','Ditebar',0),(598540,16677,'ba','0 untuk Max tidak',0),(598541,16678,'ba','0 min tidak',0),(598542,16679,'ba','AVG Qty Per bulan',0),(598543,16680,'ba','Order Pembelian dibuat',0),(598544,16681,'ba','Membuat pesanan pembelian',0),(598545,16682,'ba','Pusat distribusi',0),(598546,16683,'ba','Lokasi persediaan',0),(598547,16684,'ba','Max di tangan',0),(598548,16685,'ba','Min di tangan',0),(598549,16686,'ba','Vendor saya',0),(598550,16687,'ba','Num bulan penjualan untuk maksimum di tangan',0),(598551,16688,'ba','Num bulan penjualan untuk Minimum di tangan',0),(598552,16689,'ba','Num bulan penjualan untuk menyusun ulang kuantitas',0),(598553,16690,'ba','Adalah Default Item Vendor?',0),(598554,16691,'ba','Jumlah hari',0),(598555,16692,'ba','Mengutip Lead Time',0),(598556,16693,'ba','Pengaturan Vendor ini sebagai Default untuk Item ini akan menghapus vendor Default lainnya untuk Item ini',0),(598557,16694,'ba','Penjual UPC',0),(598558,16695,'ba','RTV nomor',0),(598559,16696,'ba','Kembali urutan',0),(598560,16697,'ba','Tidak dapat mengubah urutan ini untuk menjatuhkan kapal',0),(598561,16698,'ba','Lokasi saat ini',0),(598562,16699,'ba','Urutan memiliki pengiriman barang bebas-Drop kapal',0),(598563,16700,'ba','Kuantitas order yang tidak tersedia di lokasi',0),(598564,16701,'ba','Mengurangi kuantitas Order',0),(598565,16702,'ba','Kapal bebas-Drop item berikut akan dihapus',0),(598566,16703,'ba','Voucher ID',0),(598567,16704,'ba','Pembeli utama',0),(598568,16705,'ba','Jika County tidak pada daftar',0),(598569,16706,'ba','Tindakan Update',0),(598570,16707,'ba','Memerlukan kode biaya jika GL Account memiliki biaya kode',0),(598571,16708,'ba','Memerlukan GL kategori jika rekening GL memiliki kategori GL',0),(598572,16709,'ba','Pusat distribusi',0),(598573,16710,'ba','Apakah pusat distribusi?',0),(598574,16711,'ba','Memeriksa di',0),(598575,16712,'ba','Check in',0),(598576,16713,'ba','Check-In sekarang',0),(598577,16714,'ba','Waktu Check In',0),(598578,16715,'ba','Menyimpan catatan',0),(598579,16716,'ba','Catatan pembaruan',0),(598580,16717,'ba','Tidak dapat menemukan GL akun dengan nama',0),(598581,16718,'ba','Pasien impor',0),(598582,16719,'ba','Mengisi hari',0),(598583,16720,'ba','Reservasi terakhir',0),(598584,16721,'ba','Silahkan 777 chmod',0),(598585,16722,'ba','Semua janji',0),(598586,16723,'ba','Buku penunjukan ini',0),(598587,16724,'ba','Perintah tidak ditemukan',0),(598588,16725,'ba','Konfirmasikan waktu janji temu',0),(598589,16726,'ba','Fitur yang tidak diaktifkan',0),(598590,16727,'ba','Pertemuan berikutnya',0),(598591,16728,'ba','Pengangkatan tidak mendatang',0),(598592,16729,'ba','Buka janji untuk',0),(598593,16730,'ba','Pilih tanggal untuk melihat janji terbuka',0),(598594,16731,'ba','Mana',0),(598595,16732,'ba','Jadwal wawancara.',0),(598596,16733,'ba','Pilih tanggal',0),(598597,16734,'ba','Persediaan penyesuaian permintaan jenis',0),(598598,16735,'ba','Persediaan penyesuaian permintaan jenis dengan kode ini sudah ada',0),(598599,16736,'ba','Persediaan penyesuaian permintaan jenis kode harus ditetapkan',0),(598600,16737,'ba','Posting oleh pengiriman & menerima',0),(598601,16738,'ba','Log In sebagai pengguna ini',0),(598602,16739,'ba','Termasuk kutipan',0),(598603,16503,'it','Impossibile leggere il Record',0),(598604,16504,'it','Potrebbe non essere aggiunto',0),(598605,16505,'it','Potrebbe non essere aggiornato',0),(598606,16506,'it','Modulo incompleto',0),(598607,16507,'it','Impossibile leggere il File',0),(598608,16508,'it','Componente aggiuntivo di campi personalizzati necessario',0),(598609,16509,'it','Onere del trasporto',0),(598610,16510,'it','Onere del trasporto',0),(598611,16511,'it','Sono movimenti di rettifica di fine anno',0),(598612,16512,'it','Tipo di richiesta di adeguamento di inventario',0),(598613,16513,'it','Tipo di richiesta di rettifica inventario da questo codice esiste giÃ ',0),(598614,16514,'it','Codice tipo di inventario regolazione richiesta deve essere impostata',0),(598615,16515,'it','Creare trasferimento',0),(598616,16516,'it','Conto di contropartita trasferimento Intercompany predefinito deve essere impostato',0),(598617,16517,'it','Interaziendale trasferimento articolo - stampa',0),(598618,16518,'it','Per inventario GL Account deve essere assegnato il elemento o Account predefinito assegnato In Setup magazzino',0),(598619,16519,'it','Num mesi vendite per riordinare Qty',0),(598620,16520,'it','Mesi di NUM per ricostituire',0),(598621,16521,'it','Rifornimento',0),(598622,16522,'it','Trasferimenti di rifornimento',0),(598623,16523,'it','Trasferimento salvato',0),(598624,16524,'it','Data accettata',0),(598625,16525,'it','Tipo di regolazione',0),(598626,16526,'it','Assegnate',0),(598627,16527,'it','Data assegnata',0),(598628,16528,'it','Contato',0),(598629,16529,'it','Tipo di conteggio',0),(598630,16530,'it','Data di assegnazione',0),(598631,16531,'it','Elementi contati',0),(598632,16532,'it','Ultimo aggiornamento effettuato da',0),(598633,16533,'it','Contato per cento',0),(598634,16534,'it','Tipo di richiesta',0),(598635,16535,'it','Richiesta di disponibilitÃ ',0),(598636,16536,'it','Richieste di magazzino Check',0),(598637,16537,'it','Stato della richiesta di disponibilitÃ ',0),(598638,16538,'it','Varianza valore Amt',0),(598639,16539,'it','Per cento di valore di varianza',0),(598640,16540,'it','Contea di aggiungere/modificare',0),(598641,16541,'it','Appuntamento Scheduler',0),(598642,16542,'it','Gestione di conteggio',0),(598643,16543,'it','Importazione di informazioni del cliente',0),(598644,16544,'it','Territori di venditore di importazione',0),(598645,16545,'it','IVA per l\'importazione',0),(598646,16546,'it','Importare Froms ordine fornitore',0),(598647,16547,'it','Interaziendale trasferimento merci onere',0),(598648,16548,'it','Tipi di richiesta di rettifica per inventario',0),(598649,16549,'it','Nuova richiesta di magazzino Check',0),(598650,16550,'it','Aree di sosta',0),(598651,16551,'it','Area di gestione temporanea',0),(598652,16552,'it','Account di tipo sbagliato',0),(598653,16553,'it','Conte non trovare Account di nome',0),(598654,16554,'it','Conte non trovare il conto corrente con nome',0),(598655,16555,'it','Conte non trovare metodo dal nome di spedizione',0),(598656,16556,'it','Partite Muliple fornitori',0),(598657,16557,'it','Stato richiesto o codice postale',0),(598658,16558,'it','ID del venditore',0),(598659,16559,'it','Nome o ID del venditore deve essere impostato',0),(598660,16560,'it','Codice stato',0),(598661,16561,'it','SocietÃ  del fornitore nome o cognome deve essere impostato',0),(598662,16562,'it','Numero di Routing banca',0),(598663,16563,'it','Metodo di pagamento predefinito',0),(598664,16564,'it','Codice del fornitore deve essere impostato',0),(598665,16565,'it','In bianco',0),(598666,16566,'it','Nessun Set di tipo',0),(598667,16567,'it','Appuntamenti prenotati',0),(598668,16568,'it','Gli appuntamenti Open',0),(598669,16569,'it','Appuntamenti di oggi',0),(598670,16570,'it','Totale di appuntamenti',0),(598671,16571,'it','Lunghezza di appuntamento',0),(598672,16572,'it','Lista di appuntamenti per',0),(598673,16573,'it','Posizione di appuntamento',0),(598674,16574,'it','Nome di appuntamento',0),(598675,16575,'it','Riepilogo di appuntamento',0),(598676,16576,'it','Pianificazione appuntamento B2B',0),(598677,16577,'it','Creare aperture di appuntamento',0),(598678,16578,'it','Elimina appuntamento aperto',0),(598679,16579,'it','Prossimo appuntamento futuro',0),(598680,16580,'it','Scegliere una data per Mostra & modificare appuntamenti',0),(598681,16581,'it','Visualizza riepilogo',0),(598682,16582,'it','Unbook appuntamento',0),(598683,16583,'it','Aggiungi nuova contea',0),(598684,16584,'it','Contea di nome',0),(598685,16585,'it','Stato di padre',0),(598686,16586,'it','Ãˆ necessario immettere un nome di contea',0),(598687,16587,'it','Ãˆ necessario selezionare uno stato',0),(598688,16588,'it','Sei sicuro di che voler eliminare questa contea?',0),(598689,16589,'it','Contea di Elimina',0),(598690,16590,'it','Edit Custom County',0),(598691,16591,'it','Considerare l\'aggiunta di una nuova contea',0),(598692,16592,'it','Contea di modifica',0),(598693,16593,'it','La selezione Ã¨ un valore di sistema e non puÃ² essere modificata',0),(598694,16594,'it','Ãˆ necessario completare il modulo per continuare',0),(598695,16595,'it','Clienti che hanno aggiunti',0),(598696,16596,'it','Clienti che hanno saltati',0),(598697,16597,'it','Aggiornati i clienti',0),(598698,16598,'it','Linee di lettura',0),(598699,16599,'it','Telefono alternativo',0),(598700,16600,'it','File di importazione CSV',0),(598701,16601,'it','Operatore di telefonia mobile',0),(598702,16602,'it','Numero di telefono cellulare',0),(598703,16603,'it','Selezionare termini di fattura',0),(598704,16604,'it','Abbreviazione di stato',0),(598705,16605,'it','Indirizzo strada',0),(598706,16606,'it','Aggiungere/modificare',0),(598707,16607,'it','Vendite di medio al mese',0),(598708,16608,'it','Rifornimento corrente',0),(598709,16609,'it','Nessun cassetto primario assegnato',0),(598710,16610,'it','Qty sul trasferimento',0),(598711,16611,'it','Ricostituire Stock da centro di distribuzione',0),(598712,16612,'it','Ha suggerito',0),(598713,16613,'it','Qty di trasferimento',0),(598714,16614,'it','Zona',0),(598715,16615,'it','CittÃ  aggiunte',0),(598716,16616,'it','CittÃ  aggiornata',0),(598717,16617,'it','Contee aggiunti',0),(598718,16618,'it','Contee di aggiornamento',0),(598719,16619,'it','Stati aggiunti',0),(598720,16620,'it','Stati aggiornati',0),(598721,16621,'it','Sei sicuro che si desidera aggiornare i record di IVA?',0),(598722,16622,'it','Nome della cittÃ ',0),(598723,16623,'it','Moltiplicatore di imposta sulle vendite di cittÃ ',0),(598724,16624,'it','CittÃ  uso fiscale moltiplicatore',0),(598725,16625,'it','Moltiplicatore di imposta sulle vendite di contea',0),(598726,16626,'it','Uso di County Tax moltiplicatore',0),(598727,16627,'it','Imposta sulle vendite Import',0),(598728,16628,'it','Moltiplicatore di stato IVA',0),(598729,16629,'it','Uso dello stato fiscale moltiplicatore',0),(598730,16630,'it','Thomson Reuters scheda File',0),(598731,16631,'it','Dati esistenti',0),(598732,16632,'it','Mantenere i dati esistenti',0),(598733,16633,'it','Eliminare tutti i dati esistenti',0),(598734,16634,'it','Eliminare i dati esistenti per i fornitori In importazione',0),(598735,16635,'it','Crediti in sospeso fornitore',0),(598736,16636,'it','Auto Select imposta sulle vendite da spedire a',0),(598737,16637,'it','Evasione degli ordini e ordini di POS',0),(598738,16638,'it','Consentire l\'ordine arretrato solo dai centri di distribuzione',0),(598739,16639,'it','Selezionare automaticamente IVA dalla nave di evasione degli ordini e ordini di POS',0),(598740,16640,'it','Spedizione di goccia finale richiede POD',0),(598741,16641,'it','Suggerire percorsi alternativi acquisto quando Qty non disponibile',0),(598742,16642,'it','Esenzione fiscale parziale',0),(598743,16643,'it','Percentuale della tassa',0),(598744,16644,'it','Centro di distribuzione Num mesi vendite per calcolo di riordino',0),(598745,16645,'it','Trasferimento interprofessionali onere percentuale GL Account',0),(598746,16646,'it','Interaziendale i trasferimenti di articoli - Consenti percorsi multipli',0),(598747,16647,'it','Interaziendale i trasferimenti di articoli - distacco',0),(598748,16648,'it','Inventario In transito GL Account',0),(598749,16649,'it','Centro di distribuzione non Num mesi vendite per calcolo di riordino',0),(598750,16650,'it','Inserito da linea',0),(598751,16651,'it','Post di spedizione e ricevimento',0),(598752,16652,'it','Login utente B2B',0),(598753,16653,'it','Login come questo utente',0),(598754,16654,'it','Non Ã¨ possibile salvare come ordine completo',0),(598755,16655,'it','Nessun File POD allegato all\'ordine',0),(598756,16656,'it','Drop Ship',0),(598757,16657,'it','Archivio & Salva',0),(598758,16658,'it','Chiuso dal codice costo',0),(598759,16659,'it','Chiuso da GL categoria',0),(598760,16660,'it','Chiudere i conti di costo codice',0),(598761,16661,'it','Chiudere i conti di contabilitÃ  Generale categoria',0),(598762,16662,'it','Data annullata',0),(598763,16663,'it','13 ingresso periodo',0),(598764,16664,'it','Movimento di rettifica di imposta',0),(598765,16665,'it','Voce di regolazione fine anno',0),(598766,16666,'it','periodo 13 voci',0),(598767,16667,'it','Movimenti di rettifica di imposta',0),(598768,16668,'it','Con movimenti di rettifica di fine anno',0),(598769,16669,'it','Non in Stock',0),(598770,16670,'it','Altri oneri',0),(598771,16671,'it','Altri oneri',0),(598772,16672,'it','Trasferimento tra posizioni',0),(598773,16673,'it','Dettagli del trasferimento',0),(598774,16674,'it','Non a magazzino',0),(598775,16675,'it','Noleggio',0),(598776,16676,'it','Rifornito',0),(598777,16677,'it','0 per nessun Max',0),(598778,16678,'it','0 per nessun Min',0),(598779,16679,'it','AVG Qty al mese',0),(598780,16680,'it','Ordine di acquisto creato',0),(598781,16681,'it','Crea ordine di acquisto',0),(598782,16682,'it','Centri di distribuzione',0),(598783,16683,'it','Ubicazioni di magazzino',0),(598784,16684,'it','Max da lato',0),(598785,16685,'it','Min a mano',0),(598786,16686,'it','Miei fornitori',0),(598787,16687,'it','Num mesi vendite per massimo sulla mano',0),(598788,16688,'it','Num mesi vendite per minimo sulla mano',0),(598789,16689,'it','Num mesi vendite per quantitÃ  di riordino',0),(598790,16690,'it','Ãˆ fornitore di voce di Default?',0),(598791,16691,'it','Numero di giorni',0),(598792,16692,'it','Citare il Lead Time',0),(598793,16693,'it','Impostazione di questo venditore come il valore predefinito per questo elemento Will Remove qualsiasi altri fornitori di predefinito per questo elemento',0),(598794,16694,'it','Fornitore UPC',0),(598795,16695,'it','Numero RTV',0),(598796,16696,'it','Ordine arretrato',0),(598797,16697,'it','Non Ã¨ possibile modificare questo ordine alla nave di goccia',0),(598798,16698,'it','Posizione corrente',0),(598799,16699,'it','Ordine ha le spedizioni di articoli Non-Drop Ship',0),(598800,16700,'it','QuantitÃ  di ordine non disponibile in posizione',0),(598801,16701,'it','Ridurre la quantitÃ  di ordine',0),(598802,16702,'it','I seguenti elementi Non-Drop Ship per essere rimosso',0),(598803,16703,'it','ID voucher',0),(598804,16704,'it','Compratore primario',0),(598805,16705,'it','Se contea non presenti in elenco',0),(598806,16706,'it','Azione di aggiornamento',0),(598807,16707,'it','Richiedono codici di costo se GL Account ha i codici dei costi',0),(598808,16708,'it','Richiedono GL categoria se GL Account ha GL categorie',0),(598809,16709,'it','Centro di distribuzione',0),(598810,16710,'it','Ãˆ il centro di distribuzione?',0),(598811,16711,'it','Check-In',0),(598812,16712,'it','Check-In',0),(598813,16713,'it','Check-In ora',0),(598814,16714,'it','Check-In tempo',0),(598815,16715,'it','Salvare le note',0),(598816,16716,'it','Note di aggiornamento',0),(598817,16717,'it','Non riusciva a trovare GL Account di nome',0),(598818,16718,'it','Importazione di paziente',0),(598819,16719,'it','Riempire la giornata',0),(598820,16720,'it','Ultimo appuntamento',0),(598821,16721,'it','Si prega di chmod 777',0),(598822,16722,'it','Tutti gli appuntamenti',0),(598823,16723,'it','Prenotare questo appuntamento',0),(598824,16724,'it','Comando non trovato',0),(598825,16725,'it','Confermare l\'orario di appuntamento',0),(598826,16726,'it','Funzione non abilitata',0),(598827,16727,'it','Prossimo appuntamento',0),(598828,16728,'it','Nessun appuntamento imminente',0),(598829,16729,'it','Appuntamenti aperti per',0),(598830,16730,'it','Selezionare una data per visualizzare appuntamenti aperti',0),(598831,16731,'it','Dove',0),(598832,16732,'it','Fissare un appuntamento',0),(598833,16733,'it','Seleziona le Date di',0),(598834,16734,'it','Tipo di richiesta di adeguamento di inventario',0),(598835,16735,'it','Tipo di richiesta di rettifica inventario da questo codice esiste giÃ ',0),(598836,16736,'it','Codice tipo di inventario regolazione richiesta deve essere impostata',0),(598837,16737,'it','Post di spedizione & ricezione',0),(598838,16738,'it','Login come questo utente',0),(598839,16739,'it','Includere le virgolette',0),(598840,16503,'jp','ãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’èª­ã¿å–ã‚‹ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(598841,16504,'jp','è¿½åŠ ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(598842,16505,'jp','æ›´æ–°ã§ãã¾ã›ã‚“ã§ã—ãŸã€‚',0),(598843,16506,'jp','ä¸å®Œå…¨ãªãƒ•ã‚©ãƒ¼ãƒ ',0),(598844,16507,'jp','ãƒ•ã‚¡ã‚¤ãƒ«ã‚’èª­ã¿å–ã‚‹ã“ã¨ãŒã§ãã¾ã›ã‚“ã€‚',0),(598845,16508,'jp','ã‚«ã‚¹ã‚¿ãƒ  ãƒ•ã‚£ãƒ¼ãƒ«ãƒ‰ ã‚¢ãƒ‰ã‚ªãƒ³ãŒå¿…è¦',0),(598846,16509,'jp','é‹è³ƒè² æ‹…',0),(598847,16510,'jp','é‹è³ƒè² æ‹…',0),(598848,16511,'jp','å¹´æœ«èª¿æ•´ã‚¨ãƒ³ãƒˆãƒªãŒå«ã¾ã‚Œã¾ã™',0),(598849,16512,'jp','åœ¨åº«èª¿æ•´è¦æ±‚ã®ç¨®é¡ž',0),(598850,16513,'jp','ã“ã®ã‚³ãƒ¼ãƒ‰ã«ã‚ˆã£ã¦åœ¨åº«èª¿æ•´è¦æ±‚ã®ç¨®é¡žãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(598851,16514,'jp','åœ¨åº«èª¿æ•´è¦æ±‚ã®ç¨®é¡žã‚³ãƒ¼ãƒ‰ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(598852,16515,'jp','è»¢é€ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(598853,16516,'jp','æ—¢å®šã®ä¼šç¤¾é–“è»¢é€ç›¸æ‰‹å‹˜å®šã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(598854,16517,'jp','ä¼šç¤¾é–“å“ç›®ã®ç§»å‹• - å°åˆ·',0),(598855,16518,'jp','åœ¨åº« GL å‹˜å®šã¯ã€ã‚¢ã‚¤ãƒ†ãƒ ã¾ãŸã¯åœ¨åº«ã®è¨­å®šã«å‰²ã‚Šå½“ã¦ã‚‰ã‚ŒãŸæ—¢å®šã®ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’å‰²ã‚Šå½“ã¦ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(598856,16519,'jp','æ•°ãƒ¶æœˆç™ºæ³¨æ•°é‡ã®è²©å£²',0),(598857,16520,'jp','è£œå……ã™ã‚‹ãŸã‚ã«æ•°ãƒ¶æœˆ',0),(598858,16521,'jp','è£œå……',0),(598859,16522,'jp','è£œå……è»¢é€',0),(598860,16523,'jp','è»¢é€ä¿å­˜',0),(598861,16524,'jp','å—ä»˜æ—¥æ™‚',0),(598862,16525,'jp','èª¿æ•´ã‚¿ã‚¤ãƒ—',0),(598863,16526,'jp','å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ã¾ã™ã€‚',0),(598864,16527,'jp','ä¾é ¼æ—¥',0),(598865,16528,'jp','ã‚«ã‚¦ãƒ³ãƒˆ',0),(598866,16529,'jp','ã‚«ã‚¦ãƒ³ãƒˆã®ç¨®é¡ž',0),(598867,16530,'jp','å‰²ã‚Šå½“ã¦ã‚‰ã‚ŒãŸæ—¥ä»˜',0),(598868,16531,'jp','å“ç›®ã®ã‚«ã‚¦ãƒ³ãƒˆ',0),(598869,16532,'jp','æœ€çµ‚æ›´æ–°è€…ã€‚',0),(598870,16533,'jp','% ã‚«ã‚¦ãƒ³ãƒˆ',0),(598871,16534,'jp','è¦æ±‚ã®ç¨®é¡ž',0),(598872,16535,'jp','åœ¨åº«ã‚’ç¢ºèªã™ã‚‹è¦æ±‚',0),(598873,16536,'jp','åœ¨åº«ã‚’ç¢ºèªã™ã‚‹è¦æ±‚',0),(598874,16537,'jp','åœ¨åº«ãƒã‚§ãƒƒã‚¯è¦æ±‚ã®çŠ¶æ…‹',0),(598875,16538,'jp','åˆ†æ•£å€¤ Amt',0),(598876,16539,'jp','åˆ†æ•£å€¤ %',0),(598877,16540,'jp','éƒ¡ã®è¿½åŠ /ç·¨é›†',0),(598878,16541,'jp','äºˆç´„ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ©',0),(598879,16542,'jp','ã‚«ã‚¦ãƒ³ãƒˆç®¡ç†',0),(598880,16543,'jp','é¡§å®¢æƒ…å ±ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(598881,16544,'jp','ã‚¤ãƒ³ãƒãƒ¼ãƒˆã®ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³ã®é ˜åœŸ',0),(598882,16545,'jp','è¼¸å…¥æ¶ˆè²»ç¨Ž',0),(598883,16546,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼æ³¨æ–‡ Froms ã‚’ã‚¤ãƒ³ãƒãƒ¼ãƒˆã—ã¾ã™ã€‚',0),(598884,16547,'jp','è»¢é€è²¨ç‰©è² æ‹…ã‚’ä¼šç¤¾é–“ã—ã¾ã™ã€‚',0),(598885,16548,'jp','åœ¨åº«èª¿æ•´è¦æ±‚ã®ç¨®é¡ž',0),(598886,16549,'jp','æ–°ã—ã„åœ¨åº«ãƒã‚§ãƒƒã‚¯è¦æ±‚',0),(598887,16550,'jp','ã‚¹ãƒ†ãƒ¼ã‚¸ãƒ³ã‚° ã‚¨ãƒªã‚¢',0),(598888,16551,'jp','ã‚¹ãƒ†ãƒ¼ã‚¸ãƒ³ã‚° ã‚¨ãƒªã‚¢',0),(598889,16552,'jp','ã‚¢ã‚«ã‚¦ãƒ³ãƒˆå…¥åŠ›é–“é•ã£ã¦',0),(598890,16553,'jp','ã‚«ã‚¦ãƒ³ãƒˆã¯ãªã„åå‰ã§ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’æ¤œç´¢ã—ã¾ã™ã€‚',0),(598891,16554,'jp','ã‚«ã‚¦ãƒ³ãƒˆåã§å£åº§ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(598892,16555,'jp','ã‚«ã‚¦ãƒ³ãƒˆåã«ã‚ˆã£ã¦é€æ–™ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(598893,16556,'jp','ä¸€è‡´ã™ã‚‹è¤‡æ•°ã®ãƒ™ãƒ³ãƒ€ãƒ¼',0),(598894,16557,'jp','éƒµä¾¿ç•ªå·ã‚„å¿…è¦ãªçŠ¶æ…‹',0),(598895,16558,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³ ID',0),(598896,16559,'jp','ã‚»ãƒ¼ãƒ«ã‚¹ãƒžãƒ³ã® ID ã¾ãŸã¯åå‰ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(598897,16560,'jp','çŠ¶æ…‹ã‚³ãƒ¼ãƒ‰',0),(598898,16561,'jp','ä»•å…¥å…ˆä¼šç¤¾åã¾ãŸã¯å§“ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(598899,16562,'jp','éŠ€è¡Œã®ãƒ«ãƒ¼ãƒ†ã‚£ãƒ³ã‚°ç•ªå·',0),(598900,16563,'jp','ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆã®ãŠæ”¯æ‰•ã„æ–¹æ³•',0),(598901,16564,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ ã‚³ãƒ¼ãƒ‰ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(598902,16565,'jp','ç©ºç™½',0),(598903,16566,'jp','ã‚¿ã‚¤ãƒ—ãŒè¨­å®šã•ã‚Œã¦ã„ã¾ã›ã‚“ã€‚',0),(598904,16567,'jp','äºˆå®šã®äºˆç´„ãŒã‚ã‚Šã¾ã—ãŸã€‚',0),(598905,16568,'jp','äºˆå®šã‚’é–‹ã',0),(598906,16569,'jp','æœ¬æ—¥ã®äºˆå®š',0),(598907,16570,'jp','äºˆå®šåˆè¨ˆ',0),(598908,16571,'jp','äºˆå®šã®é•·ã•',0),(598909,16572,'jp','äºˆå®šãƒªã‚¹ãƒˆ',0),(598910,16573,'jp','äºˆå®šã®å ´æ‰€',0),(598911,16574,'jp','äºˆå®šã®åå‰',0),(598912,16575,'jp','äºˆå®šã®æ¦‚è¦',0),(598913,16576,'jp','B2B äºˆç´„ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ©',0),(598914,16577,'jp','äºˆå®šã®é–‹å£éƒ¨ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(598915,16578,'jp','ã‚ªãƒ¼ãƒ—ãƒ³äºˆå®šã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(598916,16579,'jp','å°†æ¥ã®æ¬¡ã®äºˆå®š',0),(598917,16580,'jp','è¡¨ç¤ºãƒ»ç·¨é›†äºˆå®šã®æ—¥ä»˜ã‚’é¸ã¶',0),(598918,16581,'jp','ã‚µãƒžãƒªãƒ¼ã‚’è¡¨ç¤º',0),(598919,16582,'jp','Unbook äºˆå®š',0),(598920,16583,'jp','æ–°ã—ã„éƒ¡ã‚’è¿½åŠ ã—ã¾ã™ã€‚',0),(598921,16584,'jp','éƒ¡å',0),(598922,16585,'jp','è¦ªã®çŠ¶æ…‹',0),(598923,16586,'jp','éƒ¡åã‚’å…¥åŠ›ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(598924,16587,'jp','çŠ¶æ…‹ã‚’é¸æŠžã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(598925,16588,'jp','ã“ã®éƒ¡ã‚’å‰Šé™¤ã™ã‚‹ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(598926,16589,'jp','å‰Šé™¤éƒ¡',0),(598927,16590,'jp','ç·¨é›†ã‚«ã‚¹ã‚¿ãƒ éƒ¡',0),(598928,16591,'jp','æ–°ã—ã„éƒ¡ã®è¿½åŠ ã‚’æ¤œè¨Žã—ã¾ã™ã€‚',0),(598929,16592,'jp','ç·¨é›†éƒ¡',0),(598930,16593,'jp','ã‚ãªãŸã®é¸æŠžã¯ã€ã‚·ã‚¹ãƒ†ãƒ å€¤ã¯å¤‰æ›´ã§ãã¾ã›ã‚“ã€‚',0),(598931,16594,'jp','ç¶šè¡Œã™ã‚‹ãƒ•ã‚©ãƒ¼ãƒ ã‚’å®Œäº†ã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(598932,16595,'jp','è¿½åŠ ã®ãŠå®¢æ§˜',0),(598933,16596,'jp','é¡§å®¢ã‚’ã‚¹ã‚­ãƒƒãƒ—',0),(598934,16597,'jp','æ›´æ–°ã®ãŠå®¢æ§˜',0),(598935,16598,'jp','ãƒ©ã‚¤ãƒ³èª­ã¿',0),(598936,16599,'jp','ãã®ä»–ã®é›»è©±',0),(598937,16600,'jp','CSV ãƒ•ã‚¡ã‚¤ãƒ«ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(598938,16601,'jp','æºå¸¯é›»è©±ã‚­ãƒ£ãƒªã‚¢',0),(598939,16602,'jp','æºå¸¯é›»è©±ç•ªå·',0),(598940,16603,'jp','é¸æŠžã—ãŸè«‹æ±‚åˆ©ç”¨è¦ç´„',0),(598941,16604,'jp','éƒ½é“åºœçœŒã®çœç•¥å½¢',0),(598942,16605,'jp','ä½æ‰€',0),(598943,16606,'jp','è¿½åŠ /ç·¨é›†',0),(598944,16607,'jp','æœˆã‚ãŸã‚Šã®å¹³å‡å£²ã‚Šä¸Šã’',0),(598945,16608,'jp','é›»æµä¾›çµ¦',0),(598946,16609,'jp','å‰²ã‚Šå½“ã¦ã‚‰ã‚Œã¦ã„ãªã„ãƒ—ãƒ©ã‚¤ãƒžãƒªç®±',0),(598947,16610,'jp','è­²æ¸¡æ•°é‡',0),(598948,16611,'jp','ç‰©æµã‚»ãƒ³ã‚¿ãƒ¼ã®åœ¨åº«ã‚’è£œå……ã—ã¾ã™ã€‚',0),(598949,16612,'jp','ç¤ºå”†',0),(598950,16613,'jp','è»¢é€æ•°é‡',0),(598951,16614,'jp','ã‚¾ãƒ¼ãƒ³',0),(598952,16615,'jp','éƒ½å¸‚ãŒè¿½åŠ ã•ã‚Œã¾ã—ãŸ',0),(598953,16616,'jp','éƒ½å¸‚æ›´æ–°',0),(598954,16617,'jp','è¿½åŠ ã®éƒ¡',0),(598955,16618,'jp','æ›´æ–°éƒ¡',0),(598956,16619,'jp','è¿½åŠ çŠ¶æ…‹',0),(598957,16620,'jp','æ›´æ–°ã®çŠ¶æ…‹',0),(598958,16621,'jp','å£²ä¸Šç¨Žãƒ¬ã‚³ãƒ¼ãƒ‰ã‚’æ›´æ–°ã™ã‚‹ã‚ˆã‚ã—ã„ã§ã™ã‹ã€‚',0),(598959,16622,'jp','å¸‚åŒºç”ºæ‘å',0),(598960,16623,'jp','å¸‚å£²ä¸Šç¨Žä¹—æ•°',0),(598961,16624,'jp','å¸‚ã®ä½¿ç”¨ç¨Žã®ä¹—æ•°',0),(598962,16625,'jp','éƒ¡ã®å£²ä¸Šç¨Žä¹—æ•°',0),(598963,16626,'jp','éƒ¡ä½¿ç”¨ç¨Žã®ä¹—æ•°',0),(598964,16627,'jp','å£²ä¸Šç¨Žã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(598965,16628,'jp','å·žå£²ä¸Šç¨Žä¹—æ•°',0),(598966,16629,'jp','å·žä½¿ç”¨ç¨Žã®ä¹—æ•°',0),(598967,16630,'jp','ãƒˆãƒ ã‚½ãƒ³ ãƒ» ãƒ­ã‚¤ã‚¿ãƒ¼ ã‚¿ãƒ– ãƒ•ã‚¡ã‚¤ãƒ«',0),(598968,16631,'jp','æ—¢å­˜ã®ãƒ‡ãƒ¼ã‚¿',0),(598969,16632,'jp','æ—¢å­˜ã®ãƒ‡ãƒ¼ã‚¿ã‚’ä¿æŒã—ã¾ã™ã€‚',0),(598970,16633,'jp','æ—¢å­˜ãƒ‡ãƒ¼ã‚¿ã‚’ã™ã¹ã¦å‰Šé™¤ã—ã¾ã™ã€‚',0),(598971,16634,'jp','è¼¸å…¥ä»•å…¥å…ˆã®æ—¢å­˜ã®ãƒ‡ãƒ¼ã‚¿ã‚’å‰Šé™¤ã—ã¾ã™ã€‚',0),(598972,16635,'jp','ä¿ç•™ä¸­ã®ãƒ™ãƒ³ãƒ€ãƒ¼å˜ä½',0),(598973,16636,'jp','èˆ¹ã‹ã‚‰è‡ªå‹•é¸æŠžæ¶ˆè²»ç¨Ž',0),(598974,16637,'jp','å±¥è¡Œã¨ PO ã®å—æ³¨',0),(598975,16638,'jp','æµé€šã‚»ãƒ³ã‚¿ãƒ¼ã‹ã‚‰ã®ã¿æ³¨æ–‡ã®ãƒãƒƒã‚¯ã‚’è¨±å¯ã—ã¾ã™ã€‚',0),(598976,16639,'jp','å±¥è¡Œã¨ PO ã®å—æ³¨ã«èˆ¹ã‹ã‚‰å£²ä¸Šç¨ŽãŒè‡ªå‹•çš„ã«é¸æŠžã—ã¾ã™ã€‚',0),(598977,16640,'jp','æœ€çµ‚çš„ãªãƒ‰ãƒ­ãƒƒãƒ—ç™ºé€ãƒãƒƒãƒ‰ãŒå¿…è¦ã§ã™ã€‚',0),(598978,16641,'jp','æ™‚åˆ©ç”¨ã§ããªã„æ•°é‡ã®ä»£æ›¿è³¼å…¥å ´æ‰€ã‚’ææ¡ˆã—ã¾ã™ã€‚',0),(598979,16642,'jp','éƒ¨åˆ†çš„ãªç¨Žã®å…é™¤',0),(598980,16643,'jp','ç¨Žé‡‘çŽ‡ %',0),(598981,16644,'jp','ç‰©æµã‚»ãƒ³ã‚¿ãƒ¼æ•°ãƒ¶æœˆç™ºæ³¨è¨ˆç®—ã®è²©å£²',0),(598982,16645,'jp','Interbranch è»¢é€è² æ‹…å‰²åˆ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ',0),(598983,16646,'jp','è¤‡æ•°ã®å ´æ‰€ã‚’è¨±å¯ã™ã‚‹ä¼šç¤¾é–“ã‚¢ã‚¤ãƒ†ãƒ è»¢é€-',0),(598984,16647,'jp','ã‚¢ã‚¤ãƒ†ãƒ è»¢é€ - æŠ•ç¨¿ã‚’ä¼šç¤¾é–“ã—ã¾ã™ã€‚',0),(598985,16648,'jp','ãƒˆãƒ©ãƒ³ã‚¸ãƒƒãƒˆ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã®åœ¨åº«',0),(598986,16649,'jp','éžæµé€šã‚»ãƒ³ã‚¿ãƒ¼æ•°ãƒ¶æœˆç™ºæ³¨è¨ˆç®—ã®è²©å£²',0),(598987,16650,'jp','ãƒ©ã‚¤ãƒ³æŠ•ç¨¿',0),(598988,16651,'jp','ãƒã‚¹ãƒˆã«ã‚ˆã£ã¦å‡ºè·å ´æ‰€ãŠã‚ˆã³å…¥è·',0),(598989,16652,'jp','B2B ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã®ãƒ­ã‚°ã‚¤ãƒ³',0),(598990,16653,'jp','ã“ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã¨ã—ã¦ãƒ­ã‚°ã‚¤ãƒ³',0),(598991,16654,'jp','å®Œå…¨ãªæ³¨æ–‡ã¨ã—ã¦ä¿å­˜ã§ãã¾ã›ã‚“ã€‚',0),(598992,16655,'jp','æ³¨æ–‡ã«æŽ¥ç¶šã•ã‚Œã¦ã„ã‚‹ POD ãƒ•ã‚¡ã‚¤ãƒ«ãŒã‚ã‚Šã¾ã›ã‚“ã€‚',0),(598993,16656,'jp','ãƒ‰ãƒ­ãƒƒãƒ—èˆ¹',0),(598994,16657,'jp','ã‚¢ãƒ¼ã‚«ã‚¤ãƒ– ãƒ»ä¿å­˜',0),(598995,16658,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã«ã‚ˆã£ã¦é–‰ã˜',0),(598996,16659,'jp','GL ã‚«ãƒ†ã‚´ãƒªã«ã‚ˆã£ã¦é–‰ã˜',0),(598997,16660,'jp','ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã«ã‚ˆã£ã¦ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’é–‰ã˜ã‚‹',0),(598998,16661,'jp','GL ã‚«ãƒ†ã‚´ãƒªåˆ¥ã‚¢ã‚«ã‚¦ãƒ³ãƒˆã‚’é–‰ã˜ã‚‹',0),(598999,16662,'jp','ã‚­ãƒ£ãƒ³ã‚»ãƒ«æ—¥',0),(599000,16663,'jp','13 æ—¥ã®æœŸé–“ã®ã‚¨ãƒ³ãƒˆãƒª',0),(599001,16664,'jp','ã‚¨ãƒ³ãƒˆãƒªã‚’èª¿æ•´ã™ã‚‹ç¨Ž',0),(599002,16665,'jp','ä»Šå¹´æœ€å¾Œã®èª¿æ•´ã‚¨ãƒ³ãƒˆãƒª',0),(599003,16666,'jp','13 æœŸã‚¨ãƒ³ãƒˆãƒª',0),(599004,16667,'jp','ã‚¨ãƒ³ãƒˆãƒªã‚’èª¿æ•´ã™ã‚‹ç¨Ž',0),(599005,16668,'jp','ä¼šè¨ˆå¹´åº¦æœ«ã®ã‚¨ãƒ³ãƒˆãƒªã‚’èª¿æ•´ã—ã¾ã™ã€‚',0),(599006,16669,'jp','éžåœ¨åº«',0),(599007,16670,'jp','ãã®ä»–ã®æ–™é‡‘',0),(599008,16671,'jp','ãã®ä»–ã®æ–™é‡‘',0),(599009,16672,'jp','å ´æ‰€é–“ã®è»¢é€ã—ã¾ã™ã€‚',0),(599010,16673,'jp','è»¢é€ã®è©³ç´°',0),(599011,16674,'jp','éžåœ¨åº«',0),(599012,16675,'jp','ãƒ¬ãƒ³ã‚¿ãƒ«',0),(599013,16676,'jp','è²·ã„ç‰©ã‚«ã‚´ã«è¿½åŠ ',0),(599014,16677,'jp','ã„ã„ãˆæœ€å¤§ 0',0),(599015,16678,'jp','ã„ã„ãˆæœ€å° 0',0),(599016,16679,'jp','1 ãƒ¶æœˆã‚ãŸã‚Šã®å¹³å‡æ•°é‡',0),(599017,16680,'jp','ä½œæˆã•ã‚ŒãŸç™ºæ³¨æ›¸',0),(599018,16681,'jp','ç™ºæ³¨æ›¸ã‚’ä½œæˆã—ã¾ã™ã€‚',0),(599019,16682,'jp','æµé€šã‚»ãƒ³ã‚¿ãƒ¼',0),(599020,16683,'jp','åœ¨åº«å ´æ‰€',0),(599021,16684,'jp','ä¸€æ–¹ã§æœ€å¤§ã—ã¾ã™ã€‚',0),(599022,16685,'jp','ä¸€æ–¹ã§åˆ†',0),(599023,16686,'jp','ç§ã®ãƒ™ãƒ³ãƒ€ãƒ¼',0),(599024,16687,'jp','æ•°ãƒ¶æœˆæœ€å¤§æ‰‹ã®è²©å£²',0),(599025,16688,'jp','æ•°ãƒ¶æœˆæ‰‹ã«æœ€ä½Žã®è²©å£²',0),(599026,16689,'jp','æ•°ãƒ¶æœˆå†ç™ºæ³¨æ•°é‡ã®è²©å£²',0),(599027,16690,'jp','æ—¢å®šã‚¢ã‚¤ãƒ†ãƒ ã®ä»•å…¥å…ˆã¨ã¯',0),(599028,16691,'jp','æ—¥æ•°',0),(599029,16692,'jp','ãƒªãƒ¼ãƒ‰ ã‚¿ã‚¤ãƒ ã‚’å¼•ç”¨ã—ã¾ã™ã€‚',0),(599030,16693,'jp','ã“ã®ã‚¢ã‚¤ãƒ†ãƒ ã®ä»–ã®ãƒ‡ãƒ•ã‚©ãƒ«ãƒˆ ãƒ™ãƒ³ãƒ€ãƒ¼ã“ã®é …ç›®ã¯å‰Šé™¤ã®æ—¢å®šå€¤ã¨ã—ã¦ã“ã®ãƒ™ãƒ³ãƒ€ãƒ¼ã‚’è¨­å®š',0),(599031,16694,'jp','ãƒ™ãƒ³ãƒ€ãƒ¼ UPC',0),(599032,16695,'jp','RTV æ•°',0),(599033,16696,'jp','ãƒãƒƒã‚¯ ã‚ªãƒ¼ãƒ€ãƒ¼',0),(599034,16697,'jp','èˆ¹ãƒ‰ãƒ­ãƒƒãƒ—ã™ã‚‹ã“ã®é †åºã¯å¤‰æ›´ã§ãã¾ã›ã‚“ã€‚',0),(599035,16698,'jp','ç¾åœ¨ã®å ´æ‰€',0),(599036,16699,'jp','é †åºã¯éžãƒ‰ãƒ­ãƒƒãƒ—èˆ¹ã‚¢ã‚¤ãƒ†ãƒ ã®å‡ºè·',0),(599037,16700,'jp','å ´æ‰€ã§åˆ©ç”¨ã§ããªã„æ³¨æ–‡æ•°é‡',0),(599038,16701,'jp','æ³¨æ–‡æ•°é‡ã‚’æ¸›ã‚‰ã™',0),(599039,16702,'jp','æ¬¡ã®éžãƒ‰ãƒ­ãƒƒãƒ—èˆ¹é …ç›®ã‚’å‰Šé™¤',0),(599040,16703,'jp','ã‚¯ãƒ¼ãƒãƒ³ç•ªå·',0),(599041,16704,'jp','ä¸»ãªè³¼å…¥è€…',0),(599042,16705,'jp','éƒ¡ã®ä¸€è¦§ã«ãªã„å ´åˆ',0),(599043,16706,'jp','æ›´æ–°ã‚¢ã‚¯ã‚·ãƒ§ãƒ³',0),(599044,16707,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ ã‚³ãƒ¼ãƒ‰ã®ã‚³ã‚¹ãƒˆã¯å ´åˆã®ã‚³ã‚¹ãƒˆ ã‚³ãƒ¼ãƒ‰ã‚’å¿…è¦ã¨ã—ã¾ã™ã€‚',0),(599045,16708,'jp','GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆ GL ã‚«ãƒ†ã‚´ãƒªã‚’æŒã£ã¦ã„ã‚‹å ´åˆã€GL ã‚«ãƒ†ã‚´ãƒªã‚’å¿…è¦ã¨ã—ã¾ã™ã€‚',0),(599046,16709,'jp','ç‰©æµã‚»ãƒ³ã‚¿ãƒ¼',0),(599047,16710,'jp','ç‰©æµã‚»ãƒ³ã‚¿ãƒ¼ã¨ã¯',0),(599048,16711,'jp','ãƒã‚§ãƒƒã‚¯ã‚¤ãƒ³',0),(599049,16712,'jp','ãƒã‚§ãƒƒã‚¯ã‚¤ãƒ³',0),(599050,16713,'jp','ä»Šã™ããƒã‚§ãƒƒã‚¯ã‚¤ãƒ³ã—ã¾ã™ã€‚',0),(599051,16714,'jp','ãƒã‚§ãƒƒã‚¯ã‚¤ãƒ³ ã‚¿ã‚¤ãƒ ',0),(599052,16715,'jp','ãƒŽãƒ¼ãƒˆã‚’ä¿å­˜ã—ã¾ã™ã€‚',0),(599053,16716,'jp','ãƒãƒ¼ã‚¸ãƒ§ãƒ³ã‚¢ãƒƒãƒ—æ™‚ã®æ³¨æ„',0),(599054,16717,'jp','åå‰ã§ GL ã‚¢ã‚«ã‚¦ãƒ³ãƒˆãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“ã§ã—ãŸã€‚',0),(599055,16718,'jp','æ‚£è€…ã®ã‚¤ãƒ³ãƒãƒ¼ãƒˆ',0),(599056,16719,'jp','æ—¥ã‚’è¨˜å…¥ã—ã¾ã™ã€‚',0),(599057,16720,'jp','æœ€å¾Œã®äºˆå®š',0),(599058,16721,'jp','777 chmod ã‚’ã—ã¦ãã ã•ã„ã€‚',0),(599059,16722,'jp','ã™ã¹ã¦ã®äºˆå®š',0),(599060,16723,'jp','ã“ã®äºˆç´„ã—ã¾ã™ã€‚',0),(599061,16724,'jp','ã‚³ãƒžãƒ³ãƒ‰ãŒè¦‹ã¤ã‹ã‚Šã¾ã›ã‚“',0),(599062,16725,'jp','äºˆå®šã®æ™‚åˆ»ã‚’ç¢ºèªã—ã¾ã™ã€‚',0),(599063,16726,'jp','æœ‰åŠ¹ã«ãªã£ã¦ã„ãªã„æ©Ÿèƒ½',0),(599064,16727,'jp','æ¬¡ã®äºˆå®š',0),(599065,16728,'jp','ä»Šå¾Œã®äºˆå®šã¯ã‚ã‚Šã¾ã›ã‚“ã€‚',0),(599066,16729,'jp','ã‚ªãƒ¼ãƒ—ãƒ³äºˆå®š',0),(599067,16730,'jp','ã‚ªãƒ¼ãƒ—ãƒ³äºˆå®šã‚’è¡¨ç¤ºã™ã‚‹æ—¥ä»˜ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(599068,16731,'jp','ã©ã“',0),(599069,16732,'jp','äºˆå®šã‚’ã‚¹ã‚±ã‚¸ãƒ¥ãƒ¼ãƒ«',0),(599070,16733,'jp','æ—¥ä»˜ã‚’é¸æŠžã—ã¾ã™ã€‚',0),(599071,16734,'jp','åœ¨åº«èª¿æ•´è¦æ±‚ã®ç¨®é¡ž',0),(599072,16735,'jp','ã“ã®ã‚³ãƒ¼ãƒ‰ã«ã‚ˆã£ã¦åœ¨åº«èª¿æ•´è¦æ±‚ã®ç¨®é¡žãŒæ—¢ã«å­˜åœ¨ã—ã¾ã™ã€‚',0),(599073,16736,'jp','åœ¨åº«èª¿æ•´è¦æ±‚ã®ç¨®é¡žã‚³ãƒ¼ãƒ‰ã‚’è¨­å®šã™ã‚‹å¿…è¦ãŒã‚ã‚Šã¾ã™ã€‚',0),(599074,16737,'jp','ãƒã‚¹ãƒˆã«ã‚ˆã£ã¦å‡ºè·ãƒ»å—ä¿¡',0),(599075,16738,'jp','ã“ã®ãƒ¦ãƒ¼ã‚¶ãƒ¼ã¨ã—ã¦ãƒ­ã‚°ã‚¤ãƒ³',0),(599076,16739,'jp','å¼•ç”¨ç¬¦ã‚’å«ã‚ã‚‹',0),(599077,16503,'ko','ë ˆì½”ë“œë¥¼ ì½ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(599078,16504,'ko','ì¶”ê°€í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(599079,16505,'ko','ì—…ë°ì´íŠ¸í•  ìˆ˜ ì—†ëŠ”',0),(599080,16506,'ko','ë¶ˆì™„ì „ í•œ í˜•íƒœ',0),(599081,16507,'ko','íŒŒì¼ì„ ì½ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(599082,16508,'ko','í•„ìš”í•œ ì‚¬ìš©ìž ì •ì˜ í•„ë“œ ì¶”ê°€',0),(599083,16509,'ko','ìš´ìž„ ë¶€ë‹´',0),(599084,16510,'ko','ìš´ìž„ ë¶€ë‹´',0),(599085,16511,'ko','ì—°ë§ ì¡°ì • í•­ëª©ì„ í¬í•¨',0),(599086,16512,'ko','ìž¬ê³  ì¡°ì • ìš”ì²­ ìœ í˜•',0),(599087,16513,'ko','ì´ë¯¸ ì¡´ìž¬ í•˜ëŠ”ì´ ì½”ë“œì—ì„œ ìž¬ê³  ì¡°ì • ìš”ì²­ ìœ í˜•',0),(599088,16514,'ko','ìž¬ê³  ì¡°ì • ìš”ì²­ ìœ í˜• ì½”ë“œë¥¼ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(599089,16515,'ko','ì „ì†¡ ë§Œë“¤ê¸°',0),(599090,16516,'ko','ê¸°ë³¸ íšŒì‚¬ ê°„ ì „ì†¡ ì˜¤í”„ì…‹ëœ ê³„ì • ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(599091,16517,'ko','íšŒì‚¬ ê°„ í•­ëª© ì´ë™-ì¸ì‡„',0),(599092,16518,'ko','ìž¬ê³  GL ê³„ì • í•­ëª© ë˜ëŠ” ìž¬ê³  ì„¤ì •ì— í• ë‹¹ ëœ ê¸°ë³¸ ê³„ì •ì— í• ë‹¹ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(599093,16519,'ko','Num ê°œì›” ìˆœì„œ Qtyë¥¼ ìœ„í•œ íŒë§¤',0),(599094,16520,'ko','Num ê°œì›” ë³´ì¶©',0),(599095,16521,'ko','ë³´ì¶©',0),(599096,16522,'ko','ë³´ì¶© ì „ì†¡',0),(599097,16523,'ko','ì €ìž¥ ëœ ì „ì†¡',0),(599098,16524,'ko','ë°›ì•„ë“¤ì—¬ì§„ëœ ë‚ ì§œ',0),(599099,16525,'ko','ì¡°ì • ìœ í˜•',0),(599100,16526,'ko','í• ë‹¹',0),(599101,16527,'ko','í• ë‹¹ ëœ ë‚ ì§œ',0),(599102,16528,'ko','ê³„ì‚°',0),(599103,16529,'ko','ê³„ì‚° ìœ í˜•',0),(599104,16530,'ko','í• ë‹¹ ëœ ë‚ ì§œ',0),(599105,16531,'ko','ê³„ì‚° í•­ëª©',0),(599106,16532,'ko','ì— ì˜í•´ ìµœì¢… ì—…ë°ì´íŠ¸',0),(599107,16533,'ko','% ê³„ì‚°',0),(599108,16534,'ko','ìš”ì²­ ìœ í˜•',0),(599109,16535,'ko','ìž¬ê³  í™•ì¸ ìš”ì²­',0),(599110,16536,'ko','ìž¬ê³  í™•ì¸ ìš”ì²­',0),(599111,16537,'ko','ìž¬ê³  í™•ì¸ ìš”ì²­ ìƒíƒœ',0),(599112,16538,'ko','ë¶„ì‚° ê°’ Amt',0),(599113,16539,'ko','ì°¨ì´ ê°’ ë¹„ìœ¨',0),(599114,16540,'ko','í˜„ ì¶”ê°€/íŽ¸ì§‘',0),(599115,16541,'ko','ì•½ì† ìŠ¤ì¼€ì¤„ëŸ¬',0),(599116,16542,'ko','ìˆ˜ ê´€ë¦¬',0),(599117,16543,'ko','ê³ ê° ì •ë³´ ê°€ì ¸ì˜¤ê¸°',0),(599118,16544,'ko','ê°€ì ¸ì˜¤ê¸° ì„¸ì¼ì¦ˆ ë§¨ ì˜í† ',0),(599119,16545,'ko','ìˆ˜ìž… íŒë§¤ ì„¸ê¸ˆ',0),(599120,16546,'ko','ê³µê¸‰ ì—…ì²´ ìˆœì„œ Fromsë¥¼ ê°€ì ¸ì˜¤ê¸°',0),(599121,16547,'ko','íšŒì‚¬ ê°„ ì „ì†¡ ìš´ìž„ ë¶€ë‹´',0),(599122,16548,'ko','ìž¬ê³  ì¡°ì • ìš”ì²­ ìœ í˜•',0),(599123,16549,'ko','ìƒˆë¡œìš´ ìž¬ê³  í™•ì¸ ìš”ì²­',0),(599124,16550,'ko','ì¤€ë¹„ ì˜ì—­',0),(599125,16551,'ko','ì¤€ë¹„ ì˜ì—­',0),(599126,16552,'ko','ê³„ì • ìž˜ëª» ìž…ë ¥',0),(599127,16553,'ko','ê³„ì • ì´ë¦„ìœ¼ë¡œ ì°¾ì„ ìˆ˜',0),(599128,16554,'ko','ìˆ˜ ì´ë¦„ìœ¼ë¡œ ë‹¹ì¢Œ ì˜ˆê¸ˆ ê³„ì¢Œë¥¼ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(599129,16555,'ko','ìˆ˜ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ì„ ë°• ì´ë¦„ìœ¼ë¡œ ë°©ë²•',0),(599130,16556,'ko','ì„ ìˆ˜ ë³µìˆ˜ ê³µê¸‰ ì—…ì²´',0),(599131,16557,'ko','ìš°íŽ¸ ë²ˆí˜¸ ë˜ëŠ” í•„ìš”í•œ ìƒíƒœ',0),(599132,16558,'ko','ì„¸ì¼ì¦ˆ ë§¨ ID',0),(599133,16559,'ko','ì„¸ì¼ì¦ˆ ë§¨ ID ë˜ëŠ” ì´ë¦„ì„ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(599134,16560,'ko','ìƒíƒœ ì½”ë“œ',0),(599135,16561,'ko','ê³µê¸‰ ì—…ì²´ íšŒì‚¬ ì´ë¦„ ë˜ëŠ” ë§ˆì§€ë§‰ ì´ë¦„ì„ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(599136,16562,'ko','ì€í–‰ ë¼ìš°íŒ… ë²ˆí˜¸',0),(599137,16563,'ko','ê¸°ë³¸ ì§€ë¶ˆ ë°©ë²•',0),(599138,16564,'ko','ê³µê¸‰ ì—…ì²´ ì½”ë“œë¥¼ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(599139,16565,'ko','ë¹ˆ',0),(599140,16566,'ko','í˜•ì‹ ì„¤ì • ë˜ì§€ ì•ŠìŒ',0),(599141,16567,'ko','ì˜ˆì•½ ëœ ì•½ì†',0),(599142,16568,'ko','ì•½ì† ì—´ê¸°',0),(599143,16569,'ko','ì˜¤ëŠ˜ ì•½ì†',0),(599144,16570,'ko','ì•½ì† ì´',0),(599145,16571,'ko','ì•½ì† ê¸¸ì´',0),(599146,16572,'ko','ì•½ì† ëª©ë¡',0),(599147,16573,'ko','ì•½ì† ìœ„ì¹˜',0),(599148,16574,'ko','ì•½ì† ì´ë¦„',0),(599149,16575,'ko','ì•½ì† ìš”ì•½',0),(599150,16576,'ko','B2B ì•½ì† ìŠ¤ì¼€ì¤„ëŸ¬',0),(599151,16577,'ko','ì•½ì† êµ¬ë© ë§Œë“¤ê¸°',0),(599152,16578,'ko','ì˜¤í”ˆ ì•½ì† ì‚­ì œ',0),(599153,16579,'ko','ë‹¤ìŒ ë¯¸ëž˜ì˜ ì•½ì†',0),(599154,16580,'ko','ë‚ ì§œ ë³´ê¸° & ì•½ì† íŽ¸ì§‘ë¥¼ ì„ íƒí•©ë‹ˆë‹¤',0),(599155,16581,'ko','ìš”ì•½ í‘œì‹œ',0),(599156,16582,'ko','Unbook ì•½ì†',0),(599157,16583,'ko','ì¶”ê°€ ìƒˆ í˜„',0),(599158,16584,'ko','í˜„ ì´ë¦„',0),(599159,16585,'ko','ë¶€ëª¨ ìƒíƒœ',0),(599160,16586,'ko','ì¹´ìš´í‹° ì´ë¦„ì„ ìž…ë ¥ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(599161,16587,'ko','ìƒíƒœë¥¼ ì„ íƒ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(599162,16588,'ko','ë‹¹ì‹ ì€ ì •ë§ì´ í˜„ì„ ì‚­ì œ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(599163,16589,'ko','ì‚­ì œ í˜„',0),(599164,16590,'ko','íŽ¸ì§‘ ì‚¬ìš©ìž ì§€ì • í˜„',0),(599165,16591,'ko','ìƒˆë¡œìš´ ì¹´ìš´í‹°ë¥¼ ì¶”ê°€ í•˜ì‹­ì‹œì˜¤',0),(599166,16592,'ko','íŽ¸ì§‘ í˜„',0),(599167,16593,'ko','ì„ íƒì€ ì‹œìŠ¤í…œ ê°’ ì´ë©° ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(599168,16594,'ko','ê³„ì† ì–‘ì‹ì„ ì™„ë£Œ í•´ì•¼ í•©ë‹ˆë‹¤.',0),(599169,16595,'ko','ê³ ê° ì¶”ê°€',0),(599170,16596,'ko','ìƒëžµ í•˜ëŠ” ê³ ê°',0),(599171,16597,'ko','ê³ ê° ì—…ë°ì´íŠ¸',0),(599172,16598,'ko','ë¼ì¸ ì½ê¸°',0),(599173,16599,'ko','ëŒ€ì²´ ì „í™”',0),(599174,16600,'ko','CSV ê°€ì ¸ì˜¤ê¸° íŒŒì¼',0),(599175,16601,'ko','íœ´ëŒ€ ì „í™” ìºë¦¬ì–´',0),(599176,16602,'ko','íœ´ëŒ€ ì „í™” ë²ˆí˜¸',0),(599177,16603,'ko','ì†¡ìž¥ ìš©ì–´ ì„ íƒ',0),(599178,16604,'ko','êµ­ê°€ ì•½ì–´',0),(599179,16605,'ko','ê±°ë¦¬ ì£¼ì†Œ',0),(599180,16606,'ko','ì¶”ê°€/íŽ¸ì§‘',0),(599181,16607,'ko','ë‹¬ ë‹¹ í‰ê·  íŒë§¤',0),(599182,16608,'ko','ì „ë¥˜ ê³µê¸‰',0),(599183,16609,'ko','ì•„ë‹ˆ ê¸°ë³¸ ë¹ˆ í• ë‹¹',0),(599184,16610,'ko','ì´ì „ì— ìˆ˜ëŸ‰',0),(599185,16611,'ko','ìœ í†µ ì„¼í„°ì—ì„œ ìž¬ê³ ë¥¼ ë³´ì¶©',0),(599186,16612,'ko','ì œì•ˆ',0),(599187,16613,'ko','ìˆ˜ëŸ‰ì„ ì „ì†¡',0),(599188,16614,'ko','ì˜ì—­',0),(599189,16615,'ko','ë„ì‹œ ì¶”ê°€',0),(599190,16616,'ko','ë„ì‹œ ì—…ë°ì´íŠ¸',0),(599191,16617,'ko','ì¶”ê°€ í•˜ëŠ” êµ°',0),(599192,16618,'ko','ì¹´ìš´í‹° ì—…ë°ì´íŠ¸',0),(599193,16619,'ko','ì£¼ ì¶”ê°€',0),(599194,16620,'ko','ìƒíƒœ ì—…ë°ì´íŠ¸',0),(599195,16621,'ko','ë‹¹ì‹ ì€ ë‹¹ì‹ ì˜ íŒë§¤ ì„¸ê¸ˆ ë ˆì½”ë“œë¥¼ ì—…ë°ì´íŠ¸ í•˜ ì‹œê² ìŠµë‹ˆê¹Œ?',0),(599196,16622,'ko','ë„ì‹œ ì´ë¦„',0),(599197,16623,'ko','ë„ì‹œ íŒë§¤ì„¸ ìŠ¹ìˆ˜',0),(599198,16624,'ko','ì‹œ ì‚¬ìš© ì„¸ê¸ˆ ìŠ¹ìˆ˜',0),(599199,16625,'ko','ì¹´ìš´í‹° íŒë§¤ì„¸ ìŠ¹ìˆ˜',0),(599200,16626,'ko','ì¹´ìš´í‹° ì‚¬ìš© ì„¸ê¸ˆ ìŠ¹ìˆ˜',0),(599201,16627,'ko','íŒë§¤ ì„¸ê¸ˆ ê°€ì ¸ì˜¤ê¸°',0),(599202,16628,'ko','ì£¼ íŒë§¤ì„¸ ìŠ¹ìˆ˜',0),(599203,16629,'ko','ì£¼ ì‚¬ìš© ì„¸ê¸ˆ ìŠ¹ìˆ˜',0),(599204,16630,'ko','í†°ìŠ¨ ë¡œì´í„° íƒ­ íŒŒì¼',0),(599205,16631,'ko','ê¸°ì¡´ ë°ì´í„°',0),(599206,16632,'ko','ê¸°ì¡´ ë°ì´í„° ìœ ì§€',0),(599207,16633,'ko','ëª¨ë“  ê¸°ì¡´ ë°ì´í„° ì œê±°',0),(599208,16634,'ko','ê°€ì ¸ì˜¤ê¸° ê³µê¸‰ ì—…ì²´ì— ëŒ€ í•œ ê¸°ì¡´ ë°ì´í„° ì œê±°',0),(599209,16635,'ko','ë³´ë¥˜ ì¤‘ì¸ ê³µê¸‰ ì—…ì²´ í¬ë ˆë”§',0),(599210,16636,'ko','ìš°ì£¼ì„ ì—ì„œ ìžë™ ì„ íƒ íŒë§¤ ì„¸ê¸ˆ',0),(599211,16637,'ko','í–‰ ë° POS ì£¼ë¬¸ì—',0),(599212,16638,'ko','ìœ í†µ ì„¼í„° ì—ì„œë§Œì—ì„œ ë‹¤ì‹œ ì£¼ë¬¸ í—ˆìš©',0),(599213,16639,'ko','í–‰ ë° POS ì£¼ë¬¸ ìš°ì£¼ì„ ì—ì„œ íŒë§¤ì„¸ë¥¼ ìžë™ìœ¼ë¡œ ì„ íƒ',0),(599214,16640,'ko','ìµœì¢… ë“œë¡­ ì„ ì  í•„ìš” í¬ë“œ',0),(599215,16641,'ko','ëŒ€ì²´ êµ¬ìž… ìœ„ì¹˜ ë•Œ ìˆ˜ëŸ‰ì„ ì‚¬ìš©í•  ìˆ˜ ì—†ëŠ” ì œì•ˆ',0),(599216,16642,'ko','ë¶€ë¶„ ì„¸ê¸ˆ ë©´ì œ',0),(599217,16643,'ko','ì„¸ê¸ˆ ë¹„ìœ¨ %',0),(599218,16644,'ko','ìœ í†µ ì„¼í„° Num ê°œì›” ìˆœì„œ ê³„ì‚°ì— ëŒ€ í•œ íŒë§¤',0),(599219,16645,'ko','Interbranch ì „ì†¡ ë¶€ë‹´ ë¹„ìœ¨ GL ê³„ì •',0),(599220,16646,'ko','ì—¬ëŸ¬ ìœ„ì¹˜ë¥¼ í—ˆìš© í•˜ëŠ” í•­ëª© ì „ì†¡-íšŒì‚¬ ê°„',0),(599221,16647,'ko','íšŒì‚¬ ê°„ í•­ëª© ì´ë™-ê²Œì‹œ',0),(599222,16648,'ko','ìž¬ê³  ìš´ì†¡ GL ê³„ì •ì—',0),(599223,16649,'ko','ë¹„ ìœ í†µ ì„¼í„° Num ê°œì›” ìˆœì„œ ê³„ì‚°ì— ëŒ€ í•œ íŒë§¤',0),(599224,16650,'ko','ë¼ì¸ì— ì˜í•´ ê²Œì‹œë¬¼',0),(599225,16651,'ko','ê²Œì‹œë¬¼ìœ¼ë¡œ ì „ë‹¬ ë° ìˆ˜ì‹ ',0),(599226,16652,'ko','B2B ì‚¬ìš©ìž ë¡œê·¸ì¸',0),(599227,16653,'ko','ì´ ì‚¬ìš©ìžë¡œ ë¡œê·¸ì¸',0),(599228,16654,'ko','ì£¼ë¬¸ ì™„ë£Œë¡œ ì €ìž¥í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(599229,16655,'ko','ì£¼ë¬¸ì— ì—°ê²° ëœ í¬ë“œ íŒŒì¼ ì—†ìŒ',0),(599230,16656,'ko','í•˜ë½ ë°°',0),(599231,16657,'ko','ë³´ê´€ ë° ì €ìž¥',0),(599232,16658,'ko','ë¹„ìš©ëœ ì½”ë“œì— ì˜í•´ íì‡„',0),(599233,16659,'ko','GL ì¹´í…Œê³ ë¦¬ íì‡„',0),(599234,16660,'ko','ë¹„ìš© ì½”ë“œ ê³„ì •ì„',0),(599235,16661,'ko','ê³„ì •ì„ GL ì¹´í…Œê³ ë¦¬',0),(599236,16662,'ko','ì·¨ì†Œ ë‚ ì§œ',0),(599237,16663,'ko','13 ê¸°ê°„ í•­ëª©',0),(599238,16664,'ko','ì„¸ê¸ˆ í•­ëª© ì¡°ì •',0),(599239,16665,'ko','ì˜¬í•´ ìµœì¢… ì¡°ì • í•­ëª©',0),(599240,16666,'ko','13 ê¸°ê°„ í•­ëª©',0),(599241,16667,'ko','ì„¸ê¸ˆ í•­ëª© ì¡°ì •',0),(599242,16668,'ko','ì—°ë§ ì¡°ì • í•­ëª©ìœ¼ë¡œ',0),(599243,16669,'ko','ë¹„-ìž¬ê³ ',0),(599244,16670,'ko','ë‹¤ë¥¸ ìš”ê¸ˆ',0),(599245,16671,'ko','ë‹¤ë¥¸ ìš”ê¸ˆ',0),(599246,16672,'ko','ìœ„ì¹˜ ì „ì†¡',0),(599247,16673,'ko','ì„¸ë¶€ ì •ë³´ ì „ì†¡',0),(599248,16674,'ko','-ë°©ë¥˜',0),(599249,16675,'ko','ëŒ€ ì—¬',0),(599250,16676,'ko','ë°©ë¥˜',0),(599251,16677,'ko','ì•„ë‹ˆ ë§¥ìŠ¤ 0',0),(599252,16678,'ko','ì•„ë¬´ ë¶„ 0',0),(599253,16679,'ko','ë‹¬ ë‹¹ í‰ê·  ìˆ˜ëŸ‰',0),(599254,16680,'ko','ìž‘ì„±ëœ ëœ êµ¬ë§¤ ì£¼ë¬¸',0),(599255,16681,'ko','ì£¼ë¬¸ì„œ ë§Œë“¤ê¸°',0),(599256,16682,'ko','ìœ í†µ ì„¼í„°',0),(599257,16683,'ko','ìž¬ê³  ìœ„ì¹˜',0),(599258,16684,'ko','ë°˜ë©´ì— ìµœëŒ€',0),(599259,16685,'ko','ë°˜ë©´ì— ë¶„',0),(599260,16686,'ko','ë‚´ ê³µê¸‰ ì—…ì²´',0),(599261,16687,'ko','Num ê°œì›” ì†ì— ìµœëŒ€ íŒë§¤',0),(599262,16688,'ko','Num ê°œì›” ì†ì— ìµœì†Œ íŒë§¤',0),(599263,16689,'ko','Num ê°œì›” ìž¬ì£¼ë¬¸ ìˆ˜ëŸ‰ì— ëŒ€ í•œ íŒë§¤',0),(599264,16690,'ko','ê¸°ë³¸ í•­ëª© ê³µê¸‰ ì—…ì²´ëŠ”?',0),(599265,16691,'ko','ì¼ ìˆ˜',0),(599266,16692,'ko','ë¦¬ë“œ íƒ€ìž„ì„ ì¸ìš©',0),(599267,16693,'ko','ì´ í•­ëª©ì— ëŒ€ í•œ ë‹¤ë¥¸ ê¸°ë³¸ ê³µê¸‰ ì—…ì²´ê°€ í•­ëª© ì§€ ì œê±°ì— ëŒ€ í•œ ê¸°ë³¸ê°’ìœ¼ë¡œì´ ê³µê¸‰ ì—…ì²´ ì„¤ì •',0),(599268,16694,'ko','ê³µê¸‰ ì—…ì²´ ì˜¤ìˆœì ˆ',0),(599269,16695,'ko','RTV ìˆ˜',0),(599270,16696,'ko','ë‹¤ì‹œ ì£¼ë¬¸',0),(599271,16697,'ko','ë“œë¡­ ì„ ë°•ì—ì´ ìˆœì„œë¥¼ ë³€ê²½í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(599272,16698,'ko','í˜„ìž¬ ìœ„ì¹˜',0),(599273,16699,'ko','ìˆœì„œëŠ” ë¹„ í•˜ë½ ë°° í’ˆëª©ì˜ ì¶œí•˜',0),(599274,16700,'ko','ìœ„ì¹˜ì—ì„œ ì‚¬ìš©í•  ìˆ˜ ì—†ìŠµë‹ˆë‹¤ ì£¼ë¬¸ ìˆ˜ëŸ‰',0),(599275,16701,'ko','ì£¼ë¬¸ ìˆ˜ëŸ‰ ê°ì†Œ',0),(599276,16702,'ko','ë‹¤ìŒ ë¹„ í•˜ë½ ë°° í•­ëª© ì œê±°',0),(599277,16703,'ko','ë°”ìš°ì²˜ ID',0),(599278,16704,'ko','ê¸°ë³¸ êµ¬ë§¤ìž',0),(599279,16705,'ko','ì¹´ìš´í‹° ëª©ë¡ì— ì—†ëŠ” ê²½ìš°',0),(599280,16706,'ko','ì—…ë°ì´íŠ¸ ìž‘ì—…',0),(599281,16707,'ko','GL ê³„ì • ì½”ë“œ ë¹„ìš©ì´ ë¹„ìš©ëœ ì½”ë“œ í•„ìš”',0),(599282,16708,'ko','GL ê³„ì •ì— GL ì¹´í…Œê³ ë¦¬ ê²½ìš° GL ì¹´í…Œê³ ë¦¬ë¥¼ í•„ìš”',0),(599283,16709,'ko','ìœ í†µ ì„¼í„°',0),(599284,16710,'ko','ìœ í†µ ì„¼í„°ëŠ”?',0),(599285,16711,'ko','ì²´í¬ ì¸',0),(599286,16712,'ko','ì²´í¬ì¸',0),(599287,16713,'ko','ì§€ê¸ˆ ì²´í¬ ì¸',0),(599288,16714,'ko','ì²´í¬ì¸ ì‹œê°„',0),(599289,16715,'ko','ë…¸íŠ¸ ì €ìž¥',0),(599290,16716,'ko','ì—…ë°ì´íŠ¸ ë…¸íŠ¸',0),(599291,16717,'ko','GL ê³„ì • ì´ë¦„ìœ¼ë¡œ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤.',0),(599292,16718,'ko','í™˜ìž ê°€ì ¸ì˜¤ê¸°',0),(599293,16719,'ko','í•˜ë£¨ë¥¼ ì±„ìš°ê¸°',0),(599294,16720,'ko','ë§ˆì§€ë§‰ ì•½ì†',0),(599295,16721,'ko','777 chmodë¥¼ í•˜ì‹œê¸° ë°”ëžë‹ˆë‹¤',0),(599296,16722,'ko','ëª¨ë“  ì•½ì†',0),(599297,16723,'ko','ì´ ì•½ì†ì„ ì˜ˆì•½',0),(599298,16724,'ko','ëª…ë ¹ì„ ì°¾ì„ ìˆ˜ ì—†ìŠµë‹ˆë‹¤',0),(599299,16725,'ko','ì•½ì† ì‹œê°„ì„ í™•ì¸',0),(599300,16726,'ko','ì‚¬ìš©í•  ìˆ˜ ì—†ëŠ” ê¸°ëŠ¥',0),(599301,16727,'ko','ë‹¤ìŒ ì•½ì†',0),(599302,16728,'ko','ì•„ë‹ˆ ê³§ ì•½ì†',0),(599303,16729,'ko','ëŒ€ í•œ ì—´ê¸° ì•½ì†',0),(599304,16730,'ko','ì˜¤í”ˆ ì•½ì†ì„ ë³´ë ¤ë©´ ë‚ ì§œ ì„ íƒ',0),(599305,16731,'ko','ì–´ë””',0),(599306,16732,'ko','ì¼ì • ì•½ì†',0),(599307,16733,'ko','ë‚ ì§œ ì„ íƒ',0),(599308,16734,'ko','ìž¬ê³  ì¡°ì • ìš”ì²­ ìœ í˜•',0),(599309,16735,'ko','ì´ë¯¸ ì¡´ìž¬ í•˜ëŠ”ì´ ì½”ë“œì—ì„œ ìž¬ê³  ì¡°ì • ìš”ì²­ ìœ í˜•',0),(599310,16736,'ko','ìž¬ê³  ì¡°ì • ìš”ì²­ ìœ í˜• ì½”ë“œë¥¼ ì„¤ì • í•´ì•¼ í•©ë‹ˆë‹¤.',0),(599311,16737,'ko','ê²Œì‹œë¬¼ìœ¼ë¡œ ë°œì†¡ ë° ìˆ˜ì‹ ',0),(599312,16738,'ko','ì´ ì‚¬ìš©ìžë¡œ ë¡œê·¸ì¸',0),(599313,16739,'ko','ì¸ìš© ë¶€í˜¸ë¥¼ í¬í•¨',0),(599314,16503,'ms','Tidak dapat membaca rekod',0),(599315,16504,'ms','Tidak dapat ditambah',0),(599316,16505,'ms','Tidak dapat dikemaskini',0),(599317,16506,'ms','Borang yang tidak lengkap',0),(599318,16507,'ms','Tidak dapat membaca fail',0),(599319,16508,'ms','Tambahan bidang adat yang diperlukan',0),(599320,16509,'ms','Beban muatan',0),(599321,16510,'ms','Beban muatan',0),(599322,16511,'ms','Termasuk membetulkan catatan akhir tahun',0),(599323,16512,'ms','Jenis permintaan Pelarasan Inventori',0),(599324,16513,'ms','Jenis permintaan Pelarasan Inventori oleh Kod ini sudah wujud',0),(599325,16514,'ms','Kod jenis permintaan pelarasan stok mesti disetkan',0),(599326,16515,'ms','Membuat pemindahan',0),(599327,16516,'ms','Lalai Intercompany pemindahan mengimbangi akaun mesti disetkan',0),(599328,16517,'ms','Intercompany pemindahan barang - cetak',0),(599329,16518,'ms','Inventori GL akaun mesti diberikan pada Item atau akaun lalai diperuntukkan dalam persediaan inventori',0),(599330,16519,'ms','NUM bulan jualan untuk Qty susun semula',0),(599331,16520,'ms','NUM bulan untuk mengisi',0),(599332,16521,'ms','Pengisian',0),(599333,16522,'ms','Pengisian pemindahan',0),(599334,16523,'ms','Pemindahan yang disimpan',0),(599335,16524,'ms','Tarikh diterima',0),(599336,16525,'ms','Jenis pelarasan',0),(599337,16526,'ms','Diperuntukkan',0),(599338,16527,'ms','Tarikh yang ditetapkan',0),(599339,16528,'ms','Dikira',0),(599340,16529,'ms','Jenis kiraan',0),(599341,16530,'ms','Tarikh yang diberikan',0),(599342,16531,'ms','Barang-barang yang dikira',0),(599343,16532,'ms','Dikemaskini oleh',0),(599344,16533,'ms','Peratus dikira',0),(599345,16534,'ms','Jenis permintaan',0),(599346,16535,'ms','Daftar stok permintaan',0),(599347,16536,'ms','Permohonan semakan stok',0),(599348,16537,'ms','Daftar stok permintaan Status',0),(599349,16538,'ms','Amt nilai varians',0),(599350,16539,'ms','Peratus nilai varians',0),(599351,16540,'ms','Tambah/Edit County',0),(599352,16541,'ms','Penjadual pelantikan',0),(599353,16542,'ms','Kiraan pengurusan',0),(599354,16543,'ms','Baca maklumat Import',0),(599355,16544,'ms','Import jurujual Wilayah',0),(599356,16545,'ms','Cukai jualan import',0),(599357,16546,'ms','Mengimport penjual perintah Froms',0),(599358,16547,'ms','Intercompany pemindahan muatan beban',0),(599359,16548,'ms','Jenis-jenis permintaan Pelarasan Inventori',0),(599360,16549,'ms','Permohonan semakan stok',0),(599361,16550,'ms','Bidang pementasan',0),(599362,16551,'ms','Kawasan pentas',0),(599363,16552,'ms','Akaun taip salah',0),(599364,16553,'ms','Kiraan tidak mencari akaun dengan nama',0),(599365,16554,'ms','Kiraan tidak mencari akaun memeriksa dengan nama',0),(599366,16555,'ms','Kiraan tidak menemui kaedah dengan nama perkapalan',0),(599367,16556,'ms','Perlawanan Muliple vendor',0),(599368,16557,'ms','Kod kawasan atau Negeri yang dikehendaki',0),(599369,16558,'ms','ID jurujual',0),(599370,16559,'ms','Jurujual ID atau nama mesti disetkan',0),(599371,16560,'ms','Kod Negeri',0),(599372,16561,'ms','Nama Syarikat penjual atau nama akhir mesti disetkan',0),(599373,16562,'ms','Bank nombor penghalaan',0),(599374,16563,'ms','Kaedah membayar lalai',0),(599375,16564,'ms','Kod pembekal mesti disetkan',0),(599376,16565,'ms','Kosong',0),(599377,16566,'ms','Tanpa menetapkan jenis',0),(599378,16567,'ms','Pelantikan terkini',0),(599379,16568,'ms','Buka janji temu',0),(599380,16569,'ms','Pelantikan hari',0),(599381,16570,'ms','Jumlah pelantikan',0),(599382,16571,'ms','Tempoh pelantikan',0),(599383,16572,'ms','Senarai pelantikan untuk',0),(599384,16573,'ms','Lokasi temujanji',0),(599385,16574,'ms','Nama pelantikan',0),(599386,16575,'ms','Ringkasan pelantikan',0),(599387,16576,'ms','Penjadual pelantikan B2B',0),(599388,16577,'ms','Membuat pelantikan bukaan',0),(599389,16578,'ms','Menghapuskan janji temu yang terbuka',0),(599390,16579,'ms','Pelantikan seterusnya pada masa hadapan',0),(599391,16580,'ms','Memilih tarikh yang melihat & Edit pelantikan',0),(599392,16581,'ms','Menunjukkan ringkasan',0),(599393,16582,'ms','Unbook perlantikan',0),(599394,16583,'ms','Tambah baru County',0),(599395,16584,'ms','Nama County',0),(599396,16585,'ms','Keadaan ibu bapa',0),(599397,16586,'ms','Anda harus masukkan nama County',0),(599398,16587,'ms','Awda mesti memilih negeri',0),(599399,16588,'ms','Adakah anda pasti anda mahu menghapus County ini?',0),(599400,16589,'ms','Hapus County',0),(599401,16590,'ms','Edit Custom County',0),(599402,16591,'ms','Mempertimbangkan menambah County yang baru',0),(599403,16592,'ms','Edit County',0),(599404,16593,'ms','Pilihan anda adalah nilai sistem dan tidak boleh ditukar',0),(599405,16594,'ms','Anda perlu melengkapkan borang terus',0),(599406,16595,'ms','Pelanggan yang ditambah',0),(599407,16596,'ms','Pelanggan yang dilangkau',0),(599408,16597,'ms','Pelanggan yang dikemaskini',0),(599409,16598,'ms','Baca garis',0),(599410,16599,'ms','Telefon lain',0),(599411,16600,'ms','Fail Import CSV',0),(599412,16601,'ms','Pembawa telefon mudah alih',0),(599413,16602,'ms','Nombor telefon mudah alih',0),(599414,16603,'ms','Pilih syarat invois',0),(599415,16604,'ms','Singkatan Negeri',0),(599416,16605,'ms','Alamat jalan',0),(599417,16606,'ms','Tambah/Edit',0),(599418,16607,'ms','AVG jualan setiap bulan',0),(599419,16608,'ms','Bekalan semasa',0),(599420,16609,'ms','Tiada Bin utama yang diberikan',0),(599421,16610,'ms','Qty semasa pindahmilik',0),(599422,16611,'ms','Menambah lagi saham dari pusat pengagihan',0),(599423,16612,'ms','Dicadangkan',0),(599424,16613,'ms','Qty pemindahan',0),(599425,16614,'ms','Zon',0),(599426,16615,'ms','Bandar-bandar yang ditambah',0),(599427,16616,'ms','Bandar-bandar yang dikemaskini',0),(599428,16617,'ms','Hillsborough ditambah',0),(599429,16618,'ms','Hillsborough dikemaskini',0),(599430,16619,'ms','Negeri ditambah',0),(599431,16620,'ms','Negeri-negeri yang dikemaskini',0),(599432,16621,'ms','Adakah anda pasti anda mahu untuk mengemaskini rekod-rekod cukai jualan anda?',0),(599433,16622,'ms','Nama bandar',0),(599434,16623,'ms','Bandar cukai jualan pengganda',0),(599435,16624,'ms','Bandar penggunaan cukai pengganda',0),(599436,16625,'ms','Cukai jualan County pengganda',0),(599437,16626,'ms','Pengganda cukai County Use',0),(599438,16627,'ms','Cukai jualan Import',0),(599439,16628,'ms','Pengganda cukai jualan Negeri',0),(599440,16629,'ms','Pengganda cukai Negeri guna',0),(599441,16630,'ms','Thomson Reuters Tab fail',0),(599442,16631,'ms','Data sedia ada',0),(599443,16632,'ms','Menyimpan Data sedia ada',0),(599444,16633,'ms','Singkir semua Data yang sedia ada',0),(599445,16634,'ms','Singkir Data sedia ada untuk vendor dalam Import',0),(599446,16635,'ms','Menunggu pembekal kredit',0),(599447,16636,'ms','Cukai jualan Pilih auto dari kapal',0),(599448,16637,'ms','Memenuhi dan pesanan POS',0),(599449,16638,'ms','Membenarkan perintah belakang hanya dari pusat-pusat pengedaran',0),(599450,16639,'ms','Cukai jualan secara automatik Pilih dari kapal untuk memenuhi dan pesanan POS',0),(599451,16640,'ms','Penghantaran akhir Drop memerlukan POD',0),(599452,16641,'ms','Mencadangkan lokasi pembelian alternatif apabila Qty tidak disediakan',0),(599453,16642,'ms','Pengecualian sebahagian cukai',0),(599454,16643,'ms','Peratus kadar cukai',0),(599455,16644,'ms','Pusat pengagihan Num bulan jualan untuk susun semula pengiraan',0),(599456,16645,'ms','Niaga pemindahan beban peratusan GL akaun',0),(599457,16646,'ms','Intercompany pemindahan barang - membenarkan beberapa lokasi',0),(599458,16647,'ms','Intercompany pemindahan barang - Posting',0),(599459,16648,'ms','Inventori yang terdapat dalam akaun GL Transit',0),(599460,16649,'ms','Pengagihan Pusat Num bulan jualan untuk susun semula pengiraan',0),(599461,16650,'ms','Dihantar oleh garis',0),(599462,16651,'ms','Pos dengan penghantaran dan menerima',0),(599463,16652,'ms','Log masuk pengguna B2B',0),(599464,16653,'ms','Log masuk sebagai pengguna ini',0),(599465,16654,'ms','Tidak dapat menyimpan sebagai pesanan yang lengkap',0),(599466,16655,'ms','Tiada fail POD yang melekat pada perintah',0),(599467,16656,'ms','Jatuh kapal',0),(599468,16657,'ms','Arkib & Simpan',0),(599469,16658,'ms','Ditutup oleh Kod kos',0),(599470,16659,'ms','Ditutup mengikut kategori GL',0),(599471,16660,'ms','Menutup akaun dengan kos kod',0),(599472,16661,'ms','Menutup akaun mengikut kategori GL',0),(599473,16662,'ms','Tarikh yang dibatalkan',0),(599474,16663,'ms','Kemasukan tempoh 13',0),(599475,16664,'ms','Cukai yang menyelaraskan kemasukan',0),(599476,16665,'ms','Tahun akhir menyelaraskan kemasukan',0),(599477,16666,'ms','tempoh penyertaan yang ke-13',0),(599478,16667,'ms','Cukai yang menyelaraskan penyertaan',0),(599479,16668,'ms','Dengan akhir tahun menyelaraskan penyertaan',0),(599480,16669,'ms','Saham',0),(599481,16670,'ms','Caj lain',0),(599482,16671,'ms','Caj-caj lain',0),(599483,16672,'ms','Pindahan antara lokasi',0),(599484,16673,'ms','Butir-butir pemindahan',0),(599485,16674,'ms','Stok',0),(599486,16675,'ms','Penyewaan',0),(599487,16676,'ms','Stok',0),(599488,16677,'ms','0 bagi Max tidak',0),(599489,16678,'ms','0 bagi Min tidak',0),(599490,16679,'ms','AVG Qty sebulan',0),(599491,16680,'ms','Pesanan belian yang dicipta',0),(599492,16681,'ms','Membuat pesanan belian',0),(599493,16682,'ms','Pusat-pusat pengedaran',0),(599494,16683,'ms','Lokasi inventori',0),(599495,16684,'ms','Maksimum di tangan',0),(599496,16685,'ms','Min pada tangan',0),(599497,16686,'ms','Saya pembekal menawarkan',0),(599498,16687,'ms','NUM bulan jualan maksimum pada tangan',0),(599499,16688,'ms','NUM bulan jualan untuk sekurang-kurangnya pada tangan',0),(599500,16689,'ms','NUM bulan jualan untuk susun semula kuantiti',0),(599501,16690,'ms','Adakah penjual perkara lalai?',0),(599502,16691,'ms','Bilangan hari',0),(599503,16692,'ms','Sebut harga masa',0),(599504,16693,'ms','Menetapkan penjual ini sebagai lalai untuk ini Item akan keluarkan mana-mana vendor lalai lain untuk Item ini',0),(599505,16694,'ms','Penjual UPC',0),(599506,16695,'ms','Nombor RTV',0),(599507,16696,'ms','Membuat perintah',0),(599508,16697,'ms','Tidak boleh menukar Perintah ini jatuh kapal',0),(599509,16698,'ms','Lokasi semasa',0),(599510,16699,'ms','Pesanan mempunyai penghantaran item-Drop kapal',0),(599511,16700,'ms','Kuantiti pesanan yang tidak terdapat pada lokasi',0),(599512,16701,'ms','Mengurangkan kuantiti pesanan',0),(599513,16702,'ms','Perkara-perkara kapal-Drop berikut untuk dibuang',0),(599514,16703,'ms','ID baucer',0),(599515,16704,'ms','Pembeli utama',0),(599516,16705,'ms','Jika County bukan dalam senarai',0),(599517,16706,'ms','Tindakan pengemaskinian',0),(599518,16707,'ms','Memerlukan kod kos Jika akaun GL mempunyai kos kod',0),(599519,16708,'ms','Memerlukan GL kategori Jika akaun GL mempunyai kategori GL',0),(599520,16709,'ms','Pusat pengagihan',0),(599521,16710,'ms','Adakah Pusat pengagihan?',0),(599522,16711,'ms','Didaftar masuk',0),(599523,16712,'ms','periksa masuk',0),(599524,16713,'ms','Masuk sekarang',0),(599525,16714,'ms','Masuk waktu',0),(599526,16715,'ms','Simpan Nota-Nota',0),(599527,16716,'ms','Nota-Nota Kemaskini',0),(599528,16717,'ms','Tidak dapat mencari akaun GL mengikut nama',0),(599529,16718,'ms','Import pesakit',0),(599530,16719,'ms','Mengisi hari',0),(599531,16720,'ms','Tarikh Pelantikan',0),(599532,16721,'ms','Sila 777 chmod',0),(599533,16722,'ms','Semua pelantikan',0),(599534,16723,'ms','Menempah pelantikan ini',0),(599535,16724,'ms','Arahan yang tidak dijumpai',0),(599536,16725,'ms','Mengesahkan masa temu janji',0),(599537,16726,'ms','Ciri-ciri yang tidak didayakan',0),(599538,16727,'ms','Pelantikan seterusnya',0),(599539,16728,'ms','Tiada pelantikan yang akan datang',0),(599540,16729,'ms','Temujanji dibuka untuk',0),(599541,16730,'ms','Pilih tarikh untuk melihat pelantikan terbuka',0),(599542,16731,'ms','Di mana',0),(599543,16732,'ms','Jadual temujanji',0),(599544,16733,'ms','Pilih tarikh',0),(599545,16734,'ms','Jenis permintaan Pelarasan Inventori',0),(599546,16735,'ms','Jenis permintaan Pelarasan Inventori oleh Kod ini sudah wujud',0),(599547,16736,'ms','Kod jenis permintaan pelarasan stok mesti disetkan',0),(599548,16737,'ms','Pos penghantaran secara & menerima',0),(599549,16738,'ms','Log masuk sebagai pengguna ini',0),(599550,16739,'ms','Termasuk petikan-petikan',0),(599551,16503,'no','Kan ikke lese posten',0),(599552,16504,'no','Kan ikke legge',0),(599553,16505,'no','Kan ikke oppdatere',0),(599554,16506,'no','Skjemaet ufullstendig',0),(599555,16507,'no','Kan ikke lese filen',0),(599556,16508,'no','Egendefinerte felt Add-on nÃ¸dvendig',0),(599557,16509,'no','Frakt byrden',0),(599558,16510,'no','Frakt byrden',0),(599559,16511,'no','Ta utgangen justere oppfÃ¸ringer',0),(599560,16512,'no','Lager Justeringstypen forespÃ¸rsel',0),(599561,16513,'no','Lager Justeringstypen forespÃ¸rsel koden finnes allerede',0),(599562,16514,'no','Lager justering forespÃ¸rsel kode mÃ¥ angis',0),(599563,16515,'no','Lage',0),(599564,16516,'no','Standard konserninterne overfÃ¸ring motkontoen mÃ¥ angis',0),(599565,16517,'no','Konserninterne overfÃ¸ring - utskrift',0),(599566,16518,'no','GL lagerkontoen mÃ¥ tilordnes pÃ¥ vare- eller standardkonto tildelt i Lageroppsett',0),(599567,16519,'no','NUM mÃ¥neder salg For ordne Ant',0),(599568,16520,'no','NUM mÃ¥neder Ã¥ fylle',0),(599569,16521,'no','PÃ¥fyll',0),(599570,16522,'no','Etterfylling overfÃ¸ringer',0),(599571,16523,'no','OverfÃ¸ring lagret',0),(599572,16524,'no','Godkjent dato',0),(599573,16525,'no','Justeringstypen',0),(599574,16526,'no','Tildelt',0),(599575,16527,'no','Dato',0),(599576,16528,'no','Telt',0),(599577,16529,'no','Antall Type',0),(599578,16530,'no','Tilordningsdatoen',0),(599579,16531,'no','Telt',0),(599580,16532,'no','Sist oppdatert av',0),(599581,16533,'no','Prosent telt',0),(599582,16534,'no','ForespÃ¸rselstype',0),(599583,16535,'no','Lager av forespÃ¸rsel',0),(599584,16536,'no','Lager av forespÃ¸rsler',0),(599585,16537,'no','Lager av forespÃ¸rsel Status',0),(599586,16538,'no','Varians verdien Amt',0),(599587,16539,'no','Varians verdien prosent',0),(599588,16540,'no','Legg til/Rediger County',0),(599589,16541,'no','Avtalen planleggeren',0),(599590,16542,'no','Antall Management',0),(599591,16543,'no','Kunden Info Import',0),(599592,16544,'no','Importer selger territorier',0),(599593,16545,'no','Import-mva',0),(599594,16546,'no','Importere leverandÃ¸r for Froms',0),(599595,16547,'no','Konserninterne overfÃ¸ring frakt byrden',0),(599596,16548,'no','Lager justering forespÃ¸rselstyper',0),(599597,16549,'no','Ny lager av forespÃ¸rsel',0),(599598,16550,'no','Staging omrÃ¥der',0),(599599,16551,'no','KlargjÃ¸ringsomrÃ¥det',0),(599600,16552,'no','Konto Type feil',0),(599601,16553,'no','Teller ikke finne konto etter navn',0),(599602,16554,'no','Teller ikke finne brukskonto etter navn',0),(599603,16555,'no','Teller ikke finne forsendelsesmÃ¥te etter navn',0),(599604,16556,'no','Kamper Muliple leverandÃ¸rer',0),(599605,16557,'no','Postnummer eller pÃ¥krevde statusen',0),(599606,16558,'no','Selger-ID',0),(599607,16559,'no','Selger-ID eller navn mÃ¥ angis',0),(599608,16560,'no','Statuskode',0),(599609,16561,'no','LeverandÃ¸rselskapet navn eller etternavn mÃ¥ angis',0),(599610,16562,'no','Banken rutenummeret',0),(599611,16563,'no','Betal standardmetoden',0),(599612,16564,'no','LeverandÃ¸rkode mÃ¥ angis',0),(599613,16565,'no','Tomme',0),(599614,16566,'no','Ingen Type sett',0),(599615,16567,'no','Avtaler bestilles',0),(599616,16568,'no','Avtaler Ã¥pen',0),(599617,16569,'no','Avtaler i dag',0),(599618,16570,'no','Avtaler totalt',0),(599619,16571,'no','Avtale lengde',0),(599620,16572,'no','Avtalelisten For',0),(599621,16573,'no','Avtale sted',0),(599622,16574,'no','Avtale navn',0),(599623,16575,'no','Avtale Sammendrag',0),(599624,16576,'no','B2B avtalen planleggeren',0),(599625,16577,'no','Opprette avtale Ã¥pninger',0),(599626,16578,'no','Slette Ã¥pne avtale',0),(599627,16579,'no','Neste fremtidige avtale',0),(599628,16580,'no','Velg en dato for Ã¥ vise & redigere avtaler',0),(599629,16581,'no','Vis Sammendrag',0),(599630,16582,'no','Unbook avtale',0),(599631,16583,'no','Legge til nye County',0),(599632,16584,'no','Fylket navn',0),(599633,16585,'no','Overordnede tilstand',0),(599634,16586,'no','Du mÃ¥ angi et fylke navn',0),(599635,16587,'no','Du mÃ¥ velge en tilstand',0),(599636,16588,'no','Er du sikker pÃ¥ at du vil slette dette fylket?',0),(599637,16589,'no','Slett County',0),(599638,16590,'no','Rediger egendefinert County',0),(599639,16591,'no','Vurder Ã¥ legge til et nytt fylke',0),(599640,16592,'no','Rediger County',0),(599641,16593,'no','Valget er en systemverdi og kan ikke endres',0),(599642,16594,'no','Du mÃ¥ fylle ut skjemaet for Ã¥ fortsette',0),(599643,16595,'no','Kundene lagt',0),(599644,16596,'no','Kundene hoppet over',0),(599645,16597,'no','Kundene oppdatert',0),(599646,16598,'no','Linjer Les',0),(599647,16599,'no','Alternative telefon',0),(599648,16600,'no','CSV-importfilen',0),(599649,16601,'no','Mobiltelefon bÃ¦rebÃ¸lge',0),(599650,16602,'no','Mobiltelefonnummer',0),(599651,16603,'no','Velg faktureringsvilkÃ¥r',0),(599652,16604,'no','Statlige forkortelse',0),(599653,16605,'no','Gateadresse',0),(599654,16606,'no','Legge til/redigere',0),(599655,16607,'no','AVG salg Per mÃ¥ned',0),(599656,16608,'no','NÃ¥vÃ¦rende forsyning',0),(599657,16609,'no','Ingen primÃ¦r Bin tildelt',0),(599658,16610,'no','Ant pÃ¥ overfÃ¸ring',0),(599659,16611,'no','Fylle lager fra distribusjonssenter',0),(599660,16612,'no','ForeslÃ¥tt',0),(599661,16613,'no','OverfÃ¸re Ant',0),(599662,16614,'no','Sone',0),(599663,16615,'no','Byer lagt',0),(599664,16616,'no','Byer oppdatert',0),(599665,16617,'no','Fylker lagt',0),(599666,16618,'no','Fylker oppdatert',0),(599667,16619,'no','Stater lagt',0),(599668,16620,'no','Stater oppdatert',0),(599669,16621,'no','Er du sikker pÃ¥ at du vil oppdatere mva-postene?',0),(599670,16622,'no','Navn pÃ¥ poststed',0),(599671,16623,'no','Byen mva-multiplikator',0),(599672,16624,'no','Byen bruk skatt multiplikator',0),(599673,16625,'no','Fylket mva-multiplikator',0),(599674,16626,'no','Fylket bruk skatt multiplikator',0),(599675,16627,'no','Mva-Import',0),(599676,16628,'no','Staten mva-multiplikator',0),(599677,16629,'no','Statlige bruk skatt multiplikator',0),(599678,16630,'no','Thomson Reuters kategorien fil',0),(599679,16631,'no','Eksisterende Data',0),(599680,16632,'no','Beholde eksisterende Data',0),(599681,16633,'no','Slett alle eksisterende Data',0),(599682,16634,'no','Slett eksisterende Data For leverandÃ¸rer i Import',0),(599683,16635,'no','Ventende leverandÃ¸r studiepoeng',0),(599684,16636,'no','Automatisk velger mva fra skip',0),(599685,16637,'no','PÃ¥ oppfyllelse og POS ordrer',0),(599686,16638,'no','Tillate restordrer fra distribusjonssentre',0),(599687,16639,'no','Velg automatisk mva fra skip til oppfyllelse og POS ordrer',0),(599688,16640,'no','Siste direkte levering krever POD',0),(599689,16641,'no','ForeslÃ¥ Alternative KjÃ¸p-steder nÃ¥r antall ikke tilgjengelig',0),(599690,16642,'no','Delvis skattefritak',0),(599691,16643,'no','Rate skatteprosenten',0),(599692,16644,'no','Distribusjonssenter Num mÃ¥neder salg For ordne beregning',0),(599693,16645,'no','Interbranch overfÃ¸ring byrden prosent GI-konto',0),(599694,16646,'no','Konsernintern vare overfÃ¸ringer - tillate flere steder',0),(599695,16647,'no','Konsernintern vare overfÃ¸ringer - postering',0),(599696,16648,'no','Inventar i transitt GI-konto',0),(599697,16649,'no','Ikke-distribusjonssenter Num mÃ¥neder salg For ordne beregning',0),(599698,16650,'no','Innlegg av linje',0),(599699,16651,'no','Innlegg for forsendelse og mottak',0),(599700,16652,'no','B2B brukerpÃ¥logging',0),(599701,16653,'no','Logg pÃ¥ som denne brukeren',0),(599702,16654,'no','Kan ikke lagre som fullstendig',0),(599703,16655,'no','Ingen POD fil knyttet til ordre',0),(599704,16656,'no','Slipp skipet',0),(599705,16657,'no','Arkiv & lagre',0),(599706,16658,'no','Lukket av kostnader kode',0),(599707,16659,'no','Lukket av GL kategori',0),(599708,16660,'no','Lukke kontoer av kostnader kode',0),(599709,16661,'no','Stenge kontoen etter GL kategori',0),(599710,16662,'no','Dato avbrutt',0),(599711,16663,'no','13 perioden oppfÃ¸ring',0),(599712,16664,'no','Skatt justere oppfÃ¸ring',0),(599713,16665,'no','Slutten justere Ã¥rstallet',0),(599714,16666,'no','13 perioden oppfÃ¸ringer',0),(599715,16667,'no','Skatt justeringer',0),(599716,16668,'no','Med Ã¥rsskiftet justere oppfÃ¸ringer',0),(599717,16669,'no','Ikke lager',0),(599718,16670,'no','Andre kostnader',0),(599719,16671,'no','Gebyrer',0),(599720,16672,'no','OverfÃ¸re mellom plasseringer',0),(599721,16673,'no','OverfÃ¸re detaljer',0),(599722,16674,'no','Ikke lager',0),(599723,16675,'no','Utleie',0),(599724,16676,'no','Lager',0),(599725,16677,'no','0 for ingen Max',0),(599726,16678,'no','0 for ingen Min',0),(599727,16679,'no','AVG antall Per mÃ¥ned',0),(599728,16680,'no','Opprettede bestillingen',0),(599729,16681,'no','Opprett bestilling',0),(599730,16682,'no','Distribusjonssentre',0),(599731,16683,'no','Lagerlokasjoner',0),(599732,16684,'no','Max pÃ¥ side',0),(599733,16685,'no','Min beholdning',0),(599734,16686,'no','Min leverandÃ¸rer',0),(599735,16687,'no','NUM mÃ¥neder salg For maksimum beholdning',0),(599736,16688,'no','NUM mÃ¥neder salg For Minimum tilgjengelig',0),(599737,16689,'no','NUM mÃ¥neder salg For gjenbestilling',0),(599738,16690,'no','Er standard VareleverandÃ¸r?',0),(599739,16691,'no','Antall dager',0),(599740,16692,'no','Sitere ledetid',0),(599741,16693,'no','Angi denne leverandÃ¸ren som standard For dette elementet vil fjerne andre standard leverandÃ¸rer For dette elementet',0),(599742,16694,'no','LeverandÃ¸ren UPC',0),(599743,16695,'no','RTV nummer',0),(599744,16696,'no','Restordren',0),(599745,16697,'no','Kan ikke endre denne rekkefÃ¸lgen slippe skipet',0),(599746,16698,'no','Gjeldende plassering',0),(599747,16699,'no','PÃ¥legget forsendelser av ikke-slipp skipet elementer',0),(599748,16700,'no','Ordreantallet som er ikke tilgjengelig pÃ¥ stedet',0),(599749,16701,'no','Redusere antall',0),(599750,16702,'no','FÃ¸lgende ikke-slipp skipet elementer fjernes',0),(599751,16703,'no','Bilags-IDen',0),(599752,16704,'no','PrimÃ¦re kjÃ¸per',0),(599753,16705,'no','Hvis County ikke pÃ¥ listen',0),(599754,16706,'no','Oppdateringshandling',0),(599755,16707,'no','Kreve pris koder hvis GL konto har kostet koder',0),(599756,16708,'no','Kreve GL kategori hvis GL kontoen har GL kategorier',0),(599757,16709,'no','Distribusjonssenter',0),(599758,16710,'no','Er distribusjonssenter?',0),(599759,16711,'no','Sjekket inn',0),(599760,16712,'no','sjekk inn',0),(599761,16713,'no','Innsjekking nÃ¥',0),(599762,16714,'no','Sjekk i tid',0),(599763,16715,'no','Lagre notater',0),(599764,16716,'no','Oppdatere Notes',0),(599765,16717,'no','Finner ikke GI-konto etter navn',0),(599766,16718,'no','Pasienten Import',0),(599767,16719,'no','Fyll dagen',0),(599768,16720,'no','Forrige avtale',0),(599769,16721,'no','Vennligst 777 chmod',0),(599770,16722,'no','Alle avtaler',0),(599771,16723,'no','Bestille denne avtale',0),(599772,16724,'no','Kommando ikke funnet',0),(599773,16725,'no','Bekrefte Avtaletidspunkt',0),(599774,16726,'no','Funksjonen er ikke aktivert',0),(599775,16727,'no','Neste avtale',0),(599776,16728,'no','Ingen kommende avtale',0),(599777,16729,'no','Ã…pne avtaler For',0),(599778,16730,'no','Velg en dato for Ã¥ vise Ã¥pne avtaler',0),(599779,16731,'no','Hvor',0),(599780,16732,'no','Planlegge en avtale',0),(599781,16733,'no','Velg dato',0),(599782,16734,'no','Lager Justeringstypen forespÃ¸rsel',0),(599783,16735,'no','Lager Justeringstypen forespÃ¸rsel koden finnes allerede',0),(599784,16736,'no','Lager justering forespÃ¸rsel kode mÃ¥ angis',0),(599785,16737,'no','Innlegg av Shipping & mottak',0),(599786,16738,'no','Logg pÃ¥ som denne brukeren',0),(599787,16739,'no','Ta sitater',0),(599788,16503,'pr','Ø±Ú©ÙˆØ±Ø¯ Ø±Ø§ Ù†Ù…ÛŒ Ø®ÙˆØ§Ù†Ø¯',0),(599789,16504,'pr','Ù†Ù…ÛŒ ØªÙˆØ§Ù†Ø¯ Ø§ÙØ²ÙˆØ¯Ù‡ Ø´ÙˆØ¯',0),(599790,16505,'pr','Ø¨Ù‡Ù†Ú¯Ø§Ù… Ø¯Ø±Ø¢ÙˆØ±ÛŒ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯',0),(599791,16506,'pr','ÙØ±Ù… Ù†Ø§Ù‚Øµ',0),(599792,16507,'pr','Ù‚Ø§Ø¯Ø± Ø¨Ù‡ Ø®ÙˆØ§Ù†Ø¯Ù† Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ù†Ù…ÛŒ Ø¨Ø§Ø´Ø¯',0),(599793,16508,'pr','Ø²Ù…ÛŒÙ†Ù‡ Ù‡Ø§ÛŒ Ø³ÙØ§Ø±Ø´ÛŒ Ø§ÙØ²ÙˆØ¯Ù†ÛŒ Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(599794,16509,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ø§Ø±',0),(599795,16510,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ø§Ø±',0),(599796,16511,'pr','Ù¾Ø§ÛŒØ§Ù† Ø³Ø§Ù„ ØªÙ†Ø¸ÛŒÙ… Ù‡Ø§ Ø¹Ø¨Ø§Ø±ØªÙ†Ø¯ Ø§Ø²:',0),(599797,16512,'pr','Ù†ÙˆØ¹ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(599798,16513,'pr','Ù†ÙˆØ¹ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ ØªÙˆØ³Ø· Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(599799,16514,'pr','ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø¯ Ù†ÙˆØ¹ Ø¨Ø§ÛŒØ¯ ØªØ¹ÛŒÛŒÙ† Ø´ÙˆØ¯',0),(599800,16515,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ø§Ù†ØªÙ‚Ø§Ù„',0),(599801,16516,'pr','Ø¨Ø§ÛŒØ¯ ØªÙ†Ø¸ÛŒÙ… Ù¾ÛŒØ´ ÙØ±Ø¶ Intercompany Ø§Ù†ØªÙ‚Ø§Ù„ Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø§ÙØ³Øª',0),(599802,16517,'pr','Intercompany Ù…ÙˆØ±Ø¯ Ø§Ù†ØªÙ‚Ø§Ù„ - Ù†Ø³Ø®Ù‡ Ù‚Ø§Ø¨Ù„ Ú†Ø§Ù¾',0),(599803,16518,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø­Ø³Ø§Ø¨ GL Ø¨Ø§ÛŒØ¯ Ø¯Ø± Ù…ÙˆØ±Ø¯ ÛŒØ§ Ø¯Ø± ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø­Ø³Ø§Ø¨ Ù¾ÛŒØ´ ÙØ±Ø¶ ØªØ¹ÛŒÛŒÙ†',0),(599804,16519,'pr','Ø¯Ø± ÛŒÚ© Ù…Ø§Ù‡ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù…Ø¬ÙˆØ²Ù‡Ø§ØŒ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù†',0),(599805,16520,'pr','Ø¯Ø± ÛŒÚ© Ù…Ø§Ù‡ Ø¨Ø±Ø§ÛŒ Ù¾Ø± Ú©Ø±Ø¯Ù†',0),(599806,16521,'pr','Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù¾Ø± Ú©Ø±Ø¯Ù†',0),(599807,16522,'pr','Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù¾Ø± Ú©Ø±Ø¯Ù†',0),(599808,16523,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø°Ø®ÛŒØ±Ù‡',0),(599809,16524,'pr','ØªØ§Ø±ÛŒØ® Ù¾Ø°ÛŒØ±ÙØªÙ‡ Ø´Ø¯Ù‡',0),(599810,16525,'pr','ØªÙ†Ø¸ÛŒÙ… Ù†ÙˆØ¹',0),(599811,16526,'pr','Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡',0),(599812,16527,'pr','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡',0),(599813,16528,'pr','Ø´Ù…Ø§Ø±Ø´',0),(599814,16529,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù†ÙˆØ¹',0),(599815,16530,'pr','ØªØ§Ø±ÛŒØ® Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡',0),(599816,16531,'pr','Ù…ÙˆØ§Ø±Ø¯ Ø´Ù…Ø§Ø±Ø´',0),(599817,16532,'pr','Ø¢Ø®Ø±ÛŒÙ† Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ ØªÙˆØ³Ø·',0),(599818,16533,'pr','Ù…Ø­Ø§Ø³Ø¨Ù‡ Ø¯Ø±ØµØ¯',0),(599819,16534,'pr','Ù†ÙˆØ¹ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(599820,16535,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø±Ø³ÛŒ Ø³Ù‡Ø§Ù…',0),(599821,16536,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø±Ø³ÛŒ Ø³Ù‡Ø§Ù…',0),(599822,16537,'pr','ÙˆØ¶Ø¹ÛŒØª Ø³Ù‡Ø§Ù… Ø¨Ø±Ø±Ø³ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(599823,16538,'pr','ÙˆØ§Ø±ÛŒØ§Ù†Ø³ Ø§Ø±Ø²Ø´ Amt',0),(599824,16539,'pr','Ø¯Ø±ØµØ¯ Ù…Ù‚Ø¯Ø§Ø± ÙˆØ§Ø±ÙŠØ§Ù†Ø³',0),(599825,16540,'pr','Ø´Ù‡Ø±Ø³ØªØ§Ù†/ÙˆÛŒØ±Ø§ÛŒØ´',0),(599826,16541,'pr','Ø§Ù†ØªØµØ§Ø¨ Ø²Ù…Ø§Ù†Ø¨Ù†Ø¯ÛŒ',0),(599827,16542,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù…Ø¯ÛŒØ±ÛŒØª',0),(599828,16543,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø´ØªØ±ÛŒ',0),(599829,16544,'pr','Ø³Ø±Ø²Ù…ÛŒÙ† Ù‡Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÙˆØ§Ø±Ø¯Ø§Øª',0),(599830,16545,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ ÙˆØ§Ø±Ø¯Ø§Øª',0),(599831,16546,'pr','ÙˆØ§Ø±Ø¯Ø§Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø³ÙØ§Ø±Ø´ Froms',0),(599832,16547,'pr','Intercompany Ø§Ù†ØªÙ‚Ø§Ù„ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ø¨Ø§Ø±',0),(599833,16548,'pr','Ù†ÙˆØ¹ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(599834,16549,'pr','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø¨Ø±Ø±Ø³ÛŒ Ø³Ù‡Ø§Ù… Ø¬Ø¯ÛŒØ¯',0),(599835,16550,'pr','Ù…Ø±Ø­Ù„Ù‡ Ø¨Ù†Ø¯ÛŒ Ù…Ù†Ø§Ø·Ù‚',0),(599836,16551,'pr','Ù…Ù†Ø·Ù‚Ù‡ Ø¹Ù…Ù„ÛŒØ§Øª',0),(599837,16552,'pr','Ø­Ø³Ø§Ø¨ Ø§Ø´ØªØ¨Ø§Ù‡ ØªØ§ÛŒÙ¾',0),(599838,16553,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù†ÛŒØ³Øª Ù¾ÛŒØ¯Ø§ Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù†Ø§Ù…',0),(599839,16554,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù†ÛŒØ³Øª Ù¾ÛŒØ¯Ø§ Ú©Ø±Ø¯Ù† Ú†Ú© Ú©Ø±Ø¯Ù† Ø­Ø³Ø§Ø¨ Ø¨Ø§ Ù†Ø§Ù…',0),(599840,16555,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù¾ÛŒØ¯Ø§ Ø±ÙˆØ´ Ø¨Ø§ Ù†Ø§Ù… Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(599841,16556,'pr','Ù…Ø³Ø§Ø¨Ù‚Ø§Øª Muliple ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†',0),(599842,16557,'pr','Ú©Ø¯ Ù¾Ø³ØªÛŒ Ùˆ ÛŒØ§ Ø¯ÙˆÙ„Øª Ù…ÙˆØ±Ø¯ Ù†ÛŒØ§Ø²',0),(599843,16558,'pr','Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡',0),(599844,16559,'pr','Ø¨Ø§ÛŒØ¯ Ù…Ø¬Ù…ÙˆØ¹Ù‡ Ø´Ù†Ø§Ø³Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ÛŒØ§ Ù†Ø§Ù…',0),(599845,16560,'pr','Ú©Ø¯ Ø´Ù†Ø§Ø³Ø§ÛŒÛŒ',0),(599846,16561,'pr','Ø¨Ø§ÛŒØ¯ ØªÙ†Ø¸ÛŒÙ… Ø´Ø±Ú©Øª ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ù†Ø§Ù… ÛŒØ§ Ù†Ø§Ù… Ø®Ø§Ù†ÙˆØ§Ø¯Ú¯ÛŒ',0),(599847,16562,'pr','Ø¨Ø§Ù†Ú© Ø´Ù…Ø§Ø±Ù‡ Ù…Ø³ÛŒØ±ÛŒØ§Ø¨ÛŒ',0),(599848,16563,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ø±ÙˆØ´ Ù¾Ø±Ø¯Ø§Ø®Øª',0),(599849,16564,'pr','Ú©Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø¨Ø§ÛŒØ¯ ØªÙ†Ø¸ÛŒÙ… Ø´ÙˆØ¯',0),(599850,16565,'pr','Ø®Ø§Ù„ÛŒ',0),(599851,16566,'pr','Ù‡ÛŒÚ† Ù†ÙˆØ¹ Ù…Ø¬Ù…ÙˆØ¹Ù‡',0),(599852,16567,'pr','Ø±Ø²Ø±Ùˆ ÙˆÙ‚Øª Ù…Ù„Ø§Ù‚Ø§Øª',0),(599853,16568,'pr','Ø¨Ø§Ø² Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª',0),(599854,16569,'pr','Ù…Ù„Ø§Ù‚Ø§Øª Ø§Ù…Ø±ÙˆØ²',0),(599855,16570,'pr','Ù…Ø¬Ù…ÙˆØ¹ Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª',0),(599856,16571,'pr','Ø§Ù†ØªØµØ§Ø¨ Ø·ÙˆÙ„',0),(599857,16572,'pr','Ù„ÛŒØ³Øª Ù…Ù„Ø§Ù‚Ø§Øª',0),(599858,16573,'pr','Ù…Ø­Ù„ Ù…Ù„Ø§Ù‚Ø§Øª',0),(599859,16574,'pr','Ø§Ù†ØªØµØ§Ø¨ Ù†Ø§Ù…',0),(599860,16575,'pr','Ø®Ù„Ø§ØµÙ‡ Ù‚Ø±Ø§Ø±',0),(599861,16576,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ø±ÛŒØ² Ù‚Ø±Ø§Ø± B2B',0),(599862,16577,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ø¯Ù‡Ø§Ù†Ù‡ Ù‡Ø§ÛŒ Ù…Ù„Ø§Ù‚Ø§Øª',0),(599863,16578,'pr','Ø¨Ø§Ø² Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯',0),(599864,16579,'pr','Ù…Ù„Ø§Ù‚Ø§Øª Ø¨Ø¹Ø¯ÛŒ Ø¢ÛŒÙ†Ø¯Ù‡',0),(599865,16580,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø±ÛŒØ® Ø¨Ø±Ø§ÛŒ Ø¯ÛŒØ¯Ù† & ÙˆÛŒØ±Ø§ÛŒØ´ Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª',0),(599866,16581,'pr','Ø®Ù„Ø§ØµÙ‡ Ù†Ù…Ø§ÛŒØ´',0),(599867,16582,'pr','Unbook Ù…Ù„Ø§Ù‚Ø§Øª',0),(599868,16583,'pr','Ø´Ù‡Ø±Ø³ØªØ§Ù† Ø¬Ø¯ÛŒØ¯ Ø§Ø¶Ø§ÙÙ‡ Ú©Ù†ÛŒØ¯',0),(599869,16584,'pr','Ù†Ø§Ù… Ø´Ù‡Ø±Ø³ØªØ§Ù†',0),(599870,16585,'pr','Ù¾Ø¯Ø± Ùˆ Ù…Ø§Ø¯Ø± Ø¯ÙˆÙ„Øª',0),(599871,16586,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ Ù†Ø§Ù… Ø´Ù‡Ø±Ø³ØªØ§Ù† ÙˆØ§Ø±Ø¯',0),(599872,16587,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ÛŒÚ© Ø­Ø§Ù„Øª Ø±Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ú©Ù†ÛŒØ¯',0),(599873,16588,'pr','Ø¢ÛŒØ§ Ù…Ø·Ù…Ø¦Ù† Ù‡Ø³ØªÛŒØ¯ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø§ÛŒÙ† Ø´Ù‡Ø±Ø³ØªØ§Ù† Ø±Ø§ Ø­Ø°Ù Ú©Ù†ÛŒØ¯ØŸ',0),(599874,16589,'pr','Ø­Ø°Ù Ø´Ù‡Ø±Ø³ØªØ§Ù†',0),(599875,16590,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø³ÙØ§Ø±Ø´ÛŒ Ø´Ù‡Ø±Ø³ØªØ§Ù†',0),(599876,16591,'pr','Ø¯Ø± Ù†Ø¸Ø± Ø§Ø¶Ø§ÙÙ‡ Ú©Ø±Ø¯Ù† Ø´Ù‡Ø±Ø³ØªØ§Ù† Ø¬Ø¯ÛŒØ¯',0),(599877,16592,'pr','ÙˆÛŒØ±Ø§ÛŒØ´ Ø´Ù‡Ø±Ø³ØªØ§Ù†',0),(599878,16593,'pr','Ø§Ù†ØªØ®Ø§Ø¨ Ø³ÛŒØ³ØªÙ… Ø§Ø±Ø²Ø´ Ø§Ø³Øª Ùˆ Ù†Ù…ÛŒ ØªÙˆØ§Ù† ØªØºÛŒÛŒØ± Ø¯Ø§Ø¯',0),(599879,16594,'pr','Ø´Ù…Ø§ Ø¨Ø§ÛŒØ¯ ØªÚ©Ù…ÛŒÙ„ ÙØ±Ù… Ø¨Ù‡ Ø§Ø¯Ø§Ù…Ù‡',0),(599880,16595,'pr','Ù…Ø´ØªØ±ÛŒØ§Ù† Ø§Ø±Ø³Ø§Ù„',0),(599881,16596,'pr','Ù…Ø´ØªØ±ÛŒØ§Ù† Ù¾Ø±ÛŒØ¯',0),(599882,16597,'pr','Ù…Ø´ØªØ±ÛŒØ§Ù† Ø¨Ù‡ Ø±ÙˆØ²',0),(599883,16598,'pr','Ø¯ÙØ¹Ø§Øª Ø¨Ø§Ø²Ø¯ÛŒØ¯: Ø®Ø·ÙˆØ·',0),(599884,16599,'pr','ØªÙ„ÙÙ†',0),(599885,16600,'pr','ÙØ§ÛŒÙ„ ÙˆØ±ÙˆØ¯ CSV',0),(599886,16601,'pr','Ø­Ø§Ù…Ù„ ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡',0),(599887,16602,'pr','Ø´Ù…Ø§Ø±Ù‡ ØªÙ„ÙÙ† Ù‡Ù…Ø±Ø§Ù‡',0),(599888,16603,'pr','Ø´Ø±Ø§ÛŒØ· Ø§Ù†ØªØ®Ø§Ø¨ ÙØ§Ú©ØªÙˆØ±',0),(599889,16604,'pr','Ø­Ø±ÙˆÙ Ø§Ø®ØªØµØ§Ø±ÛŒ Ø§ÛŒØ§Ù„Øª',0),(599890,16605,'pr','Ù†Ø´Ø§Ù†ÛŒ Ø®ÛŒØ§Ø¨Ø§Ù†',0),(599891,16606,'pr','Ø§ÙØ²ÙˆØ¯Ù†/ÙˆÛŒØ±Ø§ÛŒØ´',0),(599892,16607,'pr','Ù…ÛŒØ§Ù†Ú¯ÛŒÙ† ÙØ±ÙˆØ´ Ø¯Ø± Ù‡Ø± Ù…Ø§Ù‡',0),(599893,16608,'pr','Ø¹Ø±Ø¶Ù‡ ÙØ¹Ù„ÛŒ',0),(599894,16609,'pr','Ù‡ÛŒÚ† Ø¨Ù† Ø§ÙˆÙ„ÛŒÙ‡ Ø§Ø®ØªØµØ§Øµ Ø¯Ø§Ø¯Ù‡',0),(599895,16610,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø± Ø§Ù†ØªÙ‚Ø§Ù„',0),(599896,16611,'pr','Ù¾Ø± Ú©Ø±Ø¯Ù† Ø³Ù‡Ø§Ù… Ø§Ø² Ù…Ø±Ú©Ø² Ù¾Ø®Ø´',0),(599897,16612,'pr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯',0),(599898,16613,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø§Ù†ØªÙ‚Ø§Ù„',0),(599899,16614,'pr','Ù…Ù†Ø·Ù‚Ù‡',0),(599900,16615,'pr','Ø´Ù‡Ø±Ø³ØªØ§Ù†Ù‡Ø§ Ø§Ø±Ø³Ø§Ù„',0),(599901,16616,'pr','Ø´Ù‡Ø±Ù‡Ø§ Ø¨Ø±ÙˆØ²',0),(599902,16617,'pr','Ø§Ø³ØªØ§Ù† Ù‡Ø§ Ø§Ø¶Ø§ÙÙ‡ Ø´Ø¯Ù‡',0),(599903,16618,'pr','Ø§Ø³ØªØ§Ù† Ù‡Ø§ Û±Û³Û¹Û°',0),(599904,16619,'pr','Ø§ÛŒØ§Ù„Ø§Øª Ø§Ø±Ø³Ø§Ù„',0),(599905,16620,'pr','Ø§ÛŒØ§Ù„Ø§Øª Ø¨Ø±ÙˆØ²',0),(599906,16621,'pr','Ø´Ù…Ø§ Ù…ÛŒ Ø®ÙˆØ§Ù‡ÛŒØ¯ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ Ù¾Ø±ÙˆÙ†Ø¯Ù‡ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ Ø´ÙˆØ¯ØŸ',0),(599907,16622,'pr','Ù†Ø§Ù… Ø´Ù‡Ø±',0),(599908,16623,'pr','Ø´Ù‡Ø± Ú†Ù†Ø¯ Ø¨Ø±Ø§Ø¨Ø± Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± ÙØ±ÙˆØ´',0),(599909,16624,'pr','Ø´Ù‡Ø± Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…Ø§Ù„ÛŒØ§Øª Ú†Ù†Ø¯ Ø¨Ø±Ø§Ø¨Ø±',0),(599910,16625,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ Ø´Ù‡Ø±Ø³ØªØ§Ù† Ú†Ù†Ø¯ Ø¨Ø±Ø§Ø¨Ø±',0),(599911,16626,'pr','Ø´Ù‡Ø±Ø³ØªØ§Ù† Ø§Ø³ØªÙØ§Ø¯Ù‡ Ù…Ø§Ù„ÛŒØ§Øª Ú†Ù†Ø¯ Ø¨Ø±Ø§Ø¨Ø±',0),(599912,16627,'pr','Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ ÙˆØ§Ø±Ø¯Ø§Øª',0),(599913,16628,'pr','Ú†Ù†Ø¯ Ø¨Ø±Ø§Ø¨Ø± Ù…Ø§Ù„ÛŒØ§Øª ÙØ±ÙˆØ´ Ø§ÛŒØ§Ù„ØªÛŒ',0),(599914,16629,'pr','Ø§Ø³ØªÙØ§Ø¯Ù‡ Ø¯ÙˆÙ„Øª Ù…Ø§Ù„ÛŒØ§Øª Ú†Ù†Ø¯ Ø¨Ø±Ø§Ø¨Ø±',0),(599915,16630,'pr','ÙØ§ÛŒÙ„ Ø¨Ø±Ú¯Ù‡ ØªØ§Ù…Ø³ÙˆÙ† Ø±ÙˆÛŒØªØ±Ø²',0),(599916,16631,'pr','Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯',0),(599917,16632,'pr','Ø­ÙØ¸ Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯',0),(599918,16633,'pr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ ØªÙ…Ø§Ù… Ø¯Ø§Ø¯Ù‡ Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯',0),(599919,16634,'pr','Ù¾Ø§Ú©Ø³Ø§Ø²ÛŒ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…ÙˆØ¬ÙˆØ¯ Ø¨Ø±Ø§ÛŒ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† Ø¯Ø± ÙˆØ§Ø±Ø¯Ø§Øª',0),(599920,16635,'pr','Ø§Ø¹ØªØ¨Ø§Ø± ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ù†ØªØ¸Ø§Ø±',0),(599921,16636,'pr','Ø®ÙˆØ¯Ú©Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ Ø§Ø² Ú©Ø´ØªÛŒ Ø¨Ù‡',0),(599922,16637,'pr','Ø¯Ø± ØªØ­Ù‚Ù‚ Ùˆ Ø³ÙØ§Ø±Ø´Ø§Øª POS',0),(599923,16638,'pr','Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ Ø¨Ù‡ Ù…Ù†Ø¸ÙˆØ± ØªÙ†Ù‡Ø§ Ø§Ø² Ù…Ø±Ø§Ú©Ø² ØªÙˆØ²ÛŒØ¹',0),(599924,16639,'pr','Ø¨Ù‡ Ø·ÙˆØ± Ø®ÙˆØ¯Ú©Ø§Ø± Ø§Ù†ØªØ®Ø§Ø¨ Ù…Ø§Ù„ÛŒØ§Øª Ø¨Ø± ÙØ±ÙˆØ´ Ø§Ø² Ú©Ø´ØªÛŒ Ø¨Ù‡ ØªØ­Ù‚Ù‚ Ùˆ Ø³ÙØ§Ø±Ø´Ø§Øª POS',0),(599925,16640,'pr','Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ù‚Ø·Ø±Ù‡ Ù†Ù‡Ø§ÛŒÛŒ Ù†ÛŒØ§Ø² Ø¨Ù‡ ØºÙ„Ø§Ù',0),(599926,16641,'pr','Ù¾ÛŒØ´Ù†Ù‡Ø§Ø¯ Ø®Ø±ÛŒØ¯ Ø¬Ø§ÛŒÚ¯Ø²ÛŒÙ† Ù…Ú©Ø§Ù† ÙˆÙ‚ØªÛŒ ØªØ¹Ø¯Ø§Ø¯ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÛŒØ³Øª',0),(599927,16642,'pr','Ù…Ø¹Ø§ÙÛŒØª Ù…Ø§Ù„ÛŒØ§ØªÛŒ Ø¬Ø²Ø¦ÛŒ',0),(599928,16643,'pr','Ø¯Ø±ØµØ¯ Ù†Ø±Ø® Ù…Ø§Ù„ÛŒØ§Øª',0),(599929,16644,'pr','Ù…Ø±Ú©Ø² ØªÙˆØ²ÛŒØ¹ Ø¯Ø± ÛŒÚ© Ù…Ø§Ù‡ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÛŒ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬ÙˆØ²Ù‡Ø§ØŒ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù†',0),(599930,16645,'pr','Interbranch Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨Ø§Ø± Ø¯Ø±ØµØ¯ Ø­Ø³Ø§Ø¨ GL',0),(599931,16646,'pr','Ù…ÙˆØ±Ø¯ Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª - intercompany Ø§Ø¬Ø§Ø²Ù‡ Ù…ÛŒ Ø¯Ù‡Ø¯ Ù…Ú©Ø§Ù† Ù‡Ø§ÛŒ Ù…Ø®ØªÙ„Ù',0),(599932,16647,'pr','Intercompany Ù…ÙˆØ±Ø¯ Ù†Ù‚Ù„ Ùˆ Ø§Ù†ØªÙ‚Ø§Ù„Ø§Øª - Ø§Ø±Ø³Ø§Ù„',0),(599933,16648,'pr','Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¯Ø± Ø­Ø³Ø§Ø¨ GL Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„',0),(599934,16649,'pr','Ù…Ø§Ù‡ Ø¯Ø± ÛŒÚ© Ù…Ø±Ú©Ø² ØºÛŒØ± ØªÙˆØ²ÛŒØ¹ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÛŒ Ù…Ø­Ø§Ø³Ø¨Ù‡ Ù…Ø¬ÙˆØ²Ù‡Ø§ØŒ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù†',0),(599935,16650,'pr','Ø§Ø±Ø³Ø§Ù„ Ø´Ø¯Ù‡ ØªÙˆØ³Ø· Ø®Ø·',0),(599936,16651,'pr','Ù¾Ø³Øª Ø¨Ø§ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ Ùˆ Ø¯Ø±ÛŒØ§ÙØª',0),(599937,16652,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ B2B',0),(599938,16653,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ú©Ø§Ø±Ø¨Ø± Ø§ÛŒÙ†',0),(599939,16654,'pr','Ø¹Ù†ÙˆØ§Ù† Ú©Ø§Ù…Ù„ Ø³ÙØ§Ø±Ø´ Ø±Ø§ Ø°Ø®ÛŒØ±Ù‡ Ù…ÛŒ Ú©Ù†Ø¯',0),(599940,16655,'pr','Ù‡ÛŒÚ† ÙØ§ÛŒÙ„ ØºÙ„Ø§Ù Ø¨Ù‡ Ø³ÙØ§Ø±Ø´',0),(599941,16656,'pr','Ù‚Ø·Ø±Ù‡ Ú©Ø´ØªÛŒ',0),(599942,16657,'pr','Ø¨Ø§ÛŒÚ¯Ø§Ù†ÛŒ & Ø°Ø®ÛŒØ±Ù‡',0),(599943,16658,'pr','Ø¨Ø§ Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡ Ø¨Ø³ØªÙ‡',0),(599944,16659,'pr','Ø¨Ø³ØªÙ‡ ØªÙˆØ³Ø· Ø±Ø¯Ù‡ GL',0),(599945,16660,'pr','Ø¨Ø³ØªÙ† Ø­Ø³Ø§Ø¨ ØªÙˆØ³Ø· Ú©Ø¯ Ù‡Ø²ÛŒÙ†Ù‡',0),(599946,16661,'pr','Ø¨Ø³ØªÙ† Ø­Ø³Ø§Ø¨ Ù‡Ø§ÛŒ Ø¯Ø³ØªÙ‡ GL',0),(599947,16662,'pr','ØªØ§Ø±ÛŒØ® Ù„ØºÙˆ Ø´Ø¯',0),(599948,16663,'pr','ÙˆØ±ÙˆØ¯ÛŒ Ù‡Ø§ÛŒ Ø¯ÙˆØ±Ù‡ 13',0),(599949,16664,'pr','Ù…Ø§Ù„ÛŒØ§ØªÛŒ ØªÙ†Ø¸ÛŒÙ… ÙˆØ±ÙˆØ¯',0),(599950,16665,'pr','Ù¾Ø§ÛŒØ§Ù† Ø³Ø§Ù„ ØªÙ†Ø¸ÛŒÙ… ÙˆØ±ÙˆØ¯',0),(599951,16666,'pr','Ø³ÛŒØ²Ø¯Ù‡Ù…ÛŒÙ† Ø¯ÙˆØ±Ù‡ Ù‡Ø§',0),(599952,16667,'pr','Ù…Ø§Ù„ÛŒØ§ØªÛŒ ØªÙ†Ø¸ÛŒÙ… Ù‡Ø§',0),(599953,16668,'pr','Ø¨Ø§ Ù¾Ø§ÛŒØ§Ù† Ø³Ø§Ù„ ØªÙ†Ø¸ÛŒÙ… Ù‡Ø§',0),(599954,16669,'pr','-Ø³Ù‡Ø§Ù…',0),(599955,16670,'pr','Ø§ØªÙ‡Ø§Ù… Ù‡Ø§ÛŒ Ø¯ÛŒÚ¯Ø±',0),(599956,16671,'pr','Ø§ØªÙ‡Ø§Ù…Ø§Øª Ø¯ÛŒÚ¯Ø±',0),(599957,16672,'pr','Ø§Ù†ØªÙ‚Ø§Ù„ Ø¨ÛŒÙ† Ù…Ø­Ù„',0),(599958,16673,'pr','Ø¬Ø²Ø¦ÛŒØ§Øª Ø§Ù†ØªÙ‚Ø§Ù„',0),(599959,16674,'pr','ØºÛŒØ± Ù…ÙˆØ§Ø¬Ù‡ Ù†Ú¯Ø±Ø¯Ù†Ø¯',0),(599960,16675,'pr','Ø§Ø¬Ø§Ø±Ù‡',0),(599961,16676,'pr','Ù…ÙˆØ§Ø¬Ù‡ Ù†Ú¯Ø±Ø¯Ù†Ø¯',0),(599962,16677,'pr','0 Ø¨Ø¯ÙˆÙ† Ù…Ú©Ø³',0),(599963,16678,'pr','0 Ø¯Ù‚ÛŒÙ‚Ù‡',0),(599964,16679,'pr','Ù…ÛŒØ§Ù†Ú¯ÛŒÙ† ØªØ¹Ø¯Ø§Ø¯ Ø¯Ø± Ù‡Ø± Ù…Ø§Ù‡',0),(599965,16680,'pr','Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯ Ø§ÛŒØ¬Ø§Ø¯ Ø´Ø¯Ù‡',0),(599966,16681,'pr','Ø§ÛŒØ¬Ø§Ø¯ Ø³ÙØ§Ø±Ø´ Ø®Ø±ÛŒØ¯',0),(599967,16682,'pr','Ù…Ø±Ø§Ú©Ø² ØªÙˆØ²ÛŒØ¹',0),(599968,16683,'pr','Ù…Ú©Ø§Ù† Ù‡Ø§ÛŒ Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(599969,16684,'pr','Ø­Ø¯Ø§Ú©Ø«Ø± Ø¯Ø± Ø¯Ø³Øª',0),(599970,16685,'pr','Ø­Ø¯Ø§Ù‚Ù„ Ø¯Ø± Ø¯Ø³Øª',0),(599971,16686,'pr','Ù…Ù† ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù†',0),(599972,16687,'pr','Ø¯Ø± ÛŒÚ© Ù…Ø§Ù‡ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÛŒ Ø­Ø¯Ø§Ú©Ø«Ø± Ø¯Ø± Ø¯Ø³Øª',0),(599973,16688,'pr','Ø¯Ø± ÛŒÚ© Ù…Ø§Ù‡ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÛŒ Ø­Ø¯Ø§Ù‚Ù„ Ø¯Ø± Ø¯Ø³Øª',0),(599974,16689,'pr','Ø¯Ø± ÛŒÚ© Ù…Ø§Ù‡ ÙØ±ÙˆØ´ Ø¨Ø±Ø§ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ù…Ø¬ÙˆØ²Ù‡Ø§ØŒ Ø¯ÙˆØ¨Ø§Ø±Ù‡ Ù…Ø±ØªØ¨ Ú©Ø±Ø¯Ù†',0),(599975,16690,'pr','Ù¾ÛŒØ´ ÙØ±Ø¶ Ù…ÙˆØ±Ø¯ ÙØ±ÙˆØ´Ù†Ø¯Ù‡ Ø§Ø³ØªØŸ',0),(599976,16691,'pr','ØªØ¹Ø¯Ø§Ø¯ Ø±ÙˆØ²',0),(599977,16692,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø²Ù…Ø§Ù† Ø³Ø±Ø¨',0),(599978,16693,'pr','Ø§ÛŒÙ† ÙØ±ÙˆØ´Ù†Ø¯Ù‡ ØªÙ†Ø¸ÛŒÙ… Ø¨Ø¹Ù†ÙˆØ§Ù† Ù¾ÛŒØ´ Ú¯Ø²ÛŒØ¯Ù‡ Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…ÙˆØ±Ø¯ Ø­Ø°Ù Ø®ÙˆØ§Ù‡Ø¯ Ø´Ø¯ Ù‡Ø± Ú¯ÙˆÙ†Ù‡ ÙØ±ÙˆØ´Ù†Ø¯Ú¯Ø§Ù† ÙØ±Ø¶ Ø¯ÛŒÚ¯Ø± Ø¨Ø±Ø§ÛŒ Ø§ÛŒÙ† Ù…ÙˆØ±Ø¯',0),(599979,16694,'pr','ÙØ±ÙˆØ´Ù†Ø¯Ù‡ UPC',0),(599980,16695,'pr','RTV Ø´Ù…Ø§Ø±Ù‡',0),(599981,16696,'pr','Ø¨Ø±Ú¯Ø´Øª Ø³ÙØ§Ø±Ø´',0),(599982,16697,'pr','Ø§ÛŒÙ† ØªØ±ØªÛŒØ¨ Ø¨Ù‡ Ø±Ù‡Ø§ Ú©Ø±Ø¯Ù† Ú©Ø´ØªÛŒ Ø±Ø§ ØªØºÛŒÛŒØ± Ø¯Ø§Ø¯',0),(599983,16698,'pr','Ù…Ú©Ø§Ù† ÙØ¹Ù„ÛŒ',0),(599984,16699,'pr','Ø®Ø±ÙŠØ¯ Ù…Ø­Ù…ÙˆÙ„Ù‡ Ú©Ø´ØªÛŒ ØºÛŒØ± Ù‚Ø·Ø±Ù‡ Ø§Ù‚Ù„Ø§Ù… Ø§Ø³Øª',0),(599985,16700,'pr','Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´ Ø¯Ø± Ø¯Ø³ØªØ±Ø³ Ù†ÛŒØ³Øª Ø¯Ø± Ù…Ø­Ù„',0),(599986,16701,'pr','Ú©Ø§Ù‡Ø´ Ù…Ù‚Ø¯Ø§Ø± Ø³ÙØ§Ø±Ø´',0),(599987,16702,'pr','Ù…ÙˆØ§Ø±Ø¯ ØºÛŒØ± Ø§ÙØª Ú©Ø´ØªÛŒ Ø²ÛŒØ± Ø¨Ø±Ø¯Ø§Ø´ØªÙ‡ Ø´ÙˆØ¯',0),(599988,16703,'pr','Ø´Ù†Ø§Ø³Ù‡ Ú©Ø§Ø±Øª',0),(599989,16704,'pr','Ø®Ø±ÛŒØ¯Ø§Ø± Ø§ÙˆÙ„ÛŒÙ‡',0),(599990,16705,'pr','Ø§Ú¯Ø± Ù‡Ù†ÙˆØ² Ø¯Ø± Ù„ÛŒØ³Øª Ø´Ù‡Ø±Ø³ØªØ§Ù†',0),(599991,16706,'pr','Ø¹Ù…Ù„Ú©Ø±Ø¯ update',0),(599992,16707,'pr','Ø§Ú¯Ø± Ø­Ø³Ø§Ø¨ GL Ú©Ø¯Ù‡Ø§ÛŒ Ù‡Ø²ÛŒÙ†Ù‡ Ø§Ø³Øª Ù†ÛŒØ§Ø² Ø¨Ù‡ Ú©Ø¯Ù‡Ø§ÛŒ Ù‡Ø²ÛŒÙ†Ù‡',0),(599993,16708,'pr','Ø§Ú¯Ø± Ø­Ø³Ø§Ø¨ GL GL Ø¯Ø³ØªÙ‡ Ø¯Ø³ØªÙ‡ GL Ù†ÛŒØ§Ø²',0),(599994,16709,'pr','Ù…Ø±Ú©Ø² Ù¾Ø®Ø´',0),(599995,16710,'pr','Ù…Ø±Ú©Ø² Ù¾Ø®Ø´ Ø§Ø³ØªØŸ',0),(599996,16711,'pr','Ø¯Ø± Ø¨Ø±Ø±Ø³ÛŒ',0),(599997,16712,'pr','ÙˆØ±ÙˆØ¯',0),(599998,16713,'pr','Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ø¨Ø±Ø±Ø³ÛŒ',0),(599999,16714,'pr','Ø¯Ø± Ø²Ù…Ø§Ù† Ø¨Ø±Ø±Ø³ÛŒ',0),(600000,16715,'pr','Ø°Ø®ÛŒØ±Ù‡ ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§',0),(600001,16716,'pr','ÛŒØ§Ø¯Ø¯Ø§Ø´Øª Ù‡Ø§ÛŒ Ø¨Ù‡ Ø±ÙˆØ² Ø±Ø³Ø§Ù†ÛŒ',0),(600002,16717,'pr','GL Ø­Ø³Ø§Ø¨ Ù†Ø§Ù… Ø±Ø§ Ù¾ÛŒØ¯Ø§ Ú©Ù†Ø¯',0),(600003,16718,'pr','ÙˆØ§Ø±Ø¯Ø§Øª Ø¨ÛŒÙ…Ø§Ø±',0),(600004,16719,'pr','Ø±ÙˆØ² Ø±Ø§ Ù¾Ø± Ú©Ù†ÛŒØ¯',0),(600005,16720,'pr','Ø¢Ø®Ø±ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª',0),(600006,16721,'pr','Ù„Ø·ÙØ§ Ø³Ø·Ø­ Ø¯Ø³ØªØ±Ø³ÛŒ 777',0),(600007,16722,'pr','Ù‡Ù…Ù‡ Ù…Ù„Ø§Ù‚Ø§ØªÙ‡Ø§',0),(600008,16723,'pr','Ú©ØªØ§Ø¨ Ø§ÛŒÙ† ÙˆÙ‚Øª',0),(600009,16724,'pr','ÙØ±Ù…Ø§Ù† ÛŒØ§ÙØª Ù†Ø´Ø¯',0),(600010,16725,'pr','ØªØ§ÛŒÛŒØ¯ Ø³Ø§Ø¹ØªØ´',0),(600011,16726,'pr','Ù‚Ø§Ø¨Ù„ÛŒØª ÙØ¹Ø§Ù„ Ù†ÛŒØ³Øª',0),(600012,16727,'pr','Ù…Ù„Ø§Ù‚Ø§Øª Ø¨Ø¹Ø¯ÛŒ',0),(600013,16728,'pr','Ù‡ÛŒÚ† ÙˆÙ‚Øª Ø¢ÛŒÙ†Ø¯Ù‡',0),(600014,16729,'pr','Ø¨Ø§Ø² ÙˆÙ‚Øª Ù…Ù„Ø§Ù‚Ø§Øª Ø¨Ø±Ø§ÛŒ',0),(600015,16730,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø±ÛŒØ® Ø¨Ø±Ø§ÛŒ Ù…Ø´Ø§Ù‡Ø¯Ù‡ Ù‚Ø±Ø§Ø± Ù…Ù„Ø§Ù‚Ø§Øª Ù‡Ø§ Ø¨Ø§Ø²',0),(600016,16731,'pr','Ú©Ù‡ Ø¯Ø± Ø¢Ù†',0),(600017,16732,'pr','Ø¨Ø±Ù†Ø§Ù…Ù‡ Ù…Ù„Ø§Ù‚Ø§Øª',0),(600018,16733,'pr','Ø§Ù†ØªØ®Ø§Ø¨ ØªØ§Ø±ÛŒØ®',0),(600019,16734,'pr','Ù†ÙˆØ¹ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ',0),(600020,16735,'pr','Ù†ÙˆØ¹ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ ØªÙˆØ³Ø· Ø§ÛŒÙ† Ú©Ø¯ Ø¯Ø± Ø­Ø§Ù„ Ø­Ø§Ø¶Ø± Ù…ÙˆØ¬ÙˆØ¯',0),(600021,16736,'pr','ØªÙ†Ø¸ÛŒÙ… Ù…ÙˆØ¬ÙˆØ¯ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©Ø¯ Ù†ÙˆØ¹ Ø¨Ø§ÛŒØ¯ ØªØ¹ÛŒÛŒÙ† Ø´ÙˆØ¯',0),(600022,16737,'pr','Ù¾Ø³Øª Ø¨Ø§ Ø­Ù…Ù„ Ùˆ Ù†Ù‚Ù„ & Ø¯Ø±ÛŒØ§ÙØª',0),(600023,16738,'pr','ÙˆØ±ÙˆØ¯ Ø¨Ù‡ Ø¹Ù†ÙˆØ§Ù† Ú©Ø§Ø±Ø¨Ø± Ø§ÛŒÙ†',0),(600024,16739,'pr','Ù†Ù‚Ù„ Ù‚ÙˆÙ„ Ø¹Ø¨Ø§Ø±ØªÙ†Ø¯ Ø§Ø²:',0),(600025,16503,'pl','Nie moÅ¼na odczytaÄ‡ rekordu',0),(600026,16504,'pl','Nie moÅ¼na dodaÄ‡',0),(600027,16505,'pl','Nie moÅ¼e byÄ‡ zaktualizowane',0),(600028,16506,'pl','Postaci niekompletne',0),(600029,16507,'pl','Nie moÅ¼na odczytaÄ‡ pliku',0),(600030,16508,'pl','Niestandardowe pola Add-on wymagane',0),(600031,16509,'pl','ObciÄ…Å¼enie do frachtu',0),(600032,16510,'pl','ObciÄ…Å¼enie do frachtu',0),(600033,16511,'pl','To koniec roku wpisÃ³w korygujÄ…cych',0),(600034,16512,'pl','Typ Å¼Ä…dania korekty zapasÃ³w',0),(600035,16513,'pl','Typ Å¼Ä…dania korekty zapasÃ³w przez ten kod juÅ¼ istnieje',0),(600036,16514,'pl','Kod typu Å¼Ä…danie korekty zapasÃ³w musi byÄ‡ ustawiona',0),(600037,16515,'pl','Tworzenie transferu',0),(600038,16516,'pl','Musi byÄ‡ ustawiona domyÅ›lna miÄ™dzyfirmowe transferu konta przeciwstawnego',0),(600039,16517,'pl','MiÄ™dzyfirmowe element Transfer - Druk',0),(600040,16518,'pl','Konto zapasÃ³w GL musi byÄ‡ przypisany na zapas lub konto domyÅ›lne przypisane w ustawieniach gospodarki zapasami',0),(600041,16519,'pl','NUM miesiÄ™cy sprzedaÅ¼y dla iloÅ›Ä‡ ponownego zamÃ³wienia',0),(600042,16520,'pl','NUM miesiÄ™cy do uzupeÅ‚nienia',0),(600043,16521,'pl','UzupeÅ‚nianie zapasÃ³w',0),(600044,16522,'pl','UzupeÅ‚nianie zapasÃ³w transferÃ³w',0),(600045,16523,'pl','Zapisano na transfer',0),(600046,16524,'pl','Data zaakceptowania',0),(600047,16525,'pl','Typ dopasowania',0),(600048,16526,'pl','Przypisany',0),(600049,16527,'pl','Data przypisana',0),(600050,16528,'pl','Liczone',0),(600051,16529,'pl','Typ Liczba',0),(600052,16530,'pl','Data przypisana',0),(600053,16531,'pl','Przedmioty brane pod uwagÄ™',0),(600054,16532,'pl','Ostatnio zaktualizowane przez',0),(600055,16533,'pl','Procent liczone',0),(600056,16534,'pl','Typ Å¼Ä…dania',0),(600057,16535,'pl','Å»Ä…danie sprawdzania stanu magazynu',0),(600058,16536,'pl','Czas wyboru wnioskÃ³w',0),(600059,16537,'pl','Stan Å¼Ä…dania sprawdzania stanu magazynu',0),(600060,16538,'pl','Odchylenie wartoÅ›ci Amt',0),(600061,16539,'pl','Odchylenie wartoÅ›ci procentowe',0),(600062,16540,'pl','Dodawanie/edycja County',0),(600063,16541,'pl','Wyznaczenie harmonogramu',0),(600064,16542,'pl','ZarzÄ…dzania zliczaniem',0),(600065,16543,'pl','Import informacji klienta',0),(600066,16544,'pl','Import sprzedawca terytoriÃ³w',0),(600067,16545,'pl','Podatek od sprzedaÅ¼y importu',0),(600068,16546,'pl','ZaimportowaÄ‡ dostawcy zamÃ³wienia Froms',0),(600069,16547,'pl','MiÄ™dzyfirmowe transferu towarÃ³w obciÄ…Å¼enia',0),(600070,16548,'pl','Typy Å¼Ä…dania korekty zapasÃ³w',0),(600071,16549,'pl','Nowe Å¼Ä…danie sprawdzania stanu magazynu',0),(600072,16550,'pl','Obszary tymczasowego',0),(600073,16551,'pl','Obszar tymczasowego',0),(600074,16552,'pl','Konta typu Åºle',0),(600075,16553,'pl','Licznik nie znaleÅºÄ‡ konta wedÅ‚ug nazwy',0),(600076,16554,'pl','Licznik nie znaleÅºÄ‡ konto czekowe wedÅ‚ug nazwy',0),(600077,16555,'pl','Licznik nie znaleÅºÄ‡ metody przez nazwa dostawy',0),(600078,16556,'pl','Mecze wielu dostawcÃ³w',0),(600079,16557,'pl','Kod pocztowy lub stan wymagane',0),(600080,16558,'pl','Identyfikator sprzedawcy',0),(600081,16559,'pl','Sprzedawca identyfikator lub nazwÄ™ musi byÄ‡ ustawiona',0),(600082,16560,'pl','Kod stanu',0),(600083,16561,'pl','Nazwisko lub nazwa firmy dostawcy musi byÄ‡ ustawiona',0),(600084,16562,'pl','Numer rozliczeniowy banku',0),(600085,16563,'pl','DomyÅ›lna metoda pÅ‚atnoÅ›ci',0),(600086,16564,'pl','Kod dostawcy musi byÄ‡ ustawiona',0),(600087,16565,'pl','Puste',0),(600088,16566,'pl','Nie zestaw typu',0),(600089,16567,'pl','Rezerwacja terminÃ³w',0),(600090,16568,'pl','Otwarte terminy',0),(600091,16569,'pl','Wizyt dzisiaj',0),(600092,16570,'pl','OgÃ³Å‚em wizyt',0),(600093,16571,'pl','DÅ‚ugoÅ›Ä‡ terminu',0),(600094,16572,'pl','Lista nominacji dla',0),(600095,16573,'pl','Wyznaczenie lokalizacji',0),(600096,16574,'pl','Nazwa terminu',0),(600097,16575,'pl','KrÃ³tki opis termin',0),(600098,16576,'pl','B2B Wyznaczenie harmonogramu',0),(600099,16577,'pl','UtworzyÄ‡ otwory mianowania',0),(600100,16578,'pl','UsuÅ„ otwarty termin',0),(600101,16579,'pl','NastÄ™pne spotkanie przyszÅ‚ych',0),(600102,16580,'pl','Wybierz datÄ™, aby wyÅ›wietliÄ‡ & edytowanie terminÃ³w',0),(600103,16581,'pl','PokaÅ¼ podsumowanie',0),(600104,16582,'pl','Unbook spotkanie',0),(600105,16583,'pl','Dodaj nowy County',0),(600106,16584,'pl','Nazwa County',0),(600107,16585,'pl','Stan obiektu nadrzÄ™dnego',0),(600108,16586,'pl','NaleÅ¼y wprowadziÄ‡ nazwÄ™ County',0),(600109,16587,'pl','NaleÅ¼y wybraÄ‡ stan',0),(600110,16588,'pl','Czy na pewno chcesz usunÄ…Ä‡ tego powiatu?',0),(600111,16589,'pl','DELETE County',0),(600112,16590,'pl','Edycja niestandardowego County',0),(600113,16591,'pl','NaleÅ¼y rozwaÅ¼yÄ‡ dodanie nowej gminie',0),(600114,16592,'pl','Hrabstwo Edytuj',0),(600115,16593,'pl','TwÃ³j wybÃ³r jest System wartoÅ›ci i nie mogÄ… byÄ‡ zmieniane',0),(600116,16594,'pl','NaleÅ¼y wypeÅ‚niÄ‡ formularz, aby kontynuowaÄ‡',0),(600117,16595,'pl','Klienci dodane',0),(600118,16596,'pl','Klienci pomijane',0),(600119,16597,'pl','Klienci aktualizacja',0),(600120,16598,'pl','Wiersze odczytu',0),(600121,16599,'pl','Alternatywnego telefonu',0),(600122,16600,'pl','Plik importu CSV',0),(600123,16601,'pl','Operator telefonii komÃ³rkowej',0),(600124,16602,'pl','Numer telefonu komÃ³rkowego',0),(600125,16603,'pl','Wybierz na fakturze',0),(600126,16604,'pl','SkrÃ³t PaÅ„stwa',0),(600127,16605,'pl','Ulica i numer',0),(600128,16606,'pl','Dodawanie/edycja',0),(600129,16607,'pl','Åšrednia sprzedaÅ¼ miesiÄ™cznie',0),(600130,16608,'pl','Zasilanie prÄ…dem',0),(600131,16609,'pl','Nie przypisano pojemnik podstawowy',0),(600132,16610,'pl','IloÅ›Ä‡ na Transfer',0),(600133,16611,'pl','UzupeÅ‚niaÄ‡ zapasy z centrum dystrybucji',0),(600134,16612,'pl','Sugerowane',0),(600135,16613,'pl','IloÅ›Ä‡ transferu',0),(600136,16614,'pl','Strefy',0),(600137,16615,'pl','Miast dodaÅ‚',0),(600138,16616,'pl','Miast, aktualizacja',0),(600139,16617,'pl','PowiatÃ³w dodane',0),(600140,16618,'pl','PowiatÃ³w aktualizacja',0),(600141,16619,'pl','PaÅ„stwa dodane',0),(600142,16620,'pl','Aktualizacja StanÃ³w',0),(600143,16621,'pl','Czy na pewno chcesz zaktualizowaÄ‡ rekordy podatek od sprzedaÅ¼y?',0),(600144,16622,'pl','Nazwa miasta',0),(600145,16623,'pl','MnoÅ¼nik podatek miasta',0),(600146,16624,'pl','Miasto stosowania podatku mnoÅ¼nik',0),(600147,16625,'pl','MnoÅ¼nik County podatku',0),(600148,16626,'pl','Gminie stosowania podatku mnoÅ¼nik',0),(600149,16627,'pl','Podatek od sprzedaÅ¼y Import',0),(600150,16628,'pl','MnoÅ¼nik PaÅ„stwa podatku od sprzedaÅ¼y',0),(600151,16629,'pl','Wykorzystanie PaÅ„stwa podatku mnoÅ¼nik',0),(600152,16630,'pl','Thomson Reuters karta plik',0),(600153,16631,'pl','IstniejÄ…ce dane',0),(600154,16632,'pl','Zachowaj istniejÄ…ce dane',0),(600155,16633,'pl','UsuÅ„ wszystkie istniejÄ…ce dane',0),(600156,16634,'pl','WyczyÅ›Ä‡ istniejÄ…ce dane dla dostawcÃ³w w Import',0),(600157,16635,'pl','OczekujÄ…ce dostawcy kredytÃ³w',0),(600158,16636,'pl','Wybierz auto podatek od statku do',0),(600159,16637,'pl','Realizacja i zamÃ³wieniach POS',0),(600160,16638,'pl','Zezwalaj na tylnej porzÄ…dku tylko od centrÃ³w dystrybucji',0),(600161,16639,'pl','Automatycznie wybierz podatek od statku do speÅ‚nienia i zamÃ³wieniach POS',0),(600162,16640,'pl','KoÅ„cowe bezpoÅ›redniej wymaga POD',0),(600163,16641,'pl','SugerowaÄ‡ miejsca zakupu alternatywne, gdy iloÅ›Ä‡ nie jest dostÄ™pny',0),(600164,16642,'pl','CzÄ™Å›ciowego zwolnienia z podatku',0),(600165,16643,'pl','Procent stawki podatku',0),(600166,16644,'pl','Centrum dystrybucji Num miesiÄ™cy sprzedaÅ¼y dla ponownego obliczania',0),(600167,16645,'pl','MiÄ™dzybranÅ¼owe przeniesienia ciÄ™Å¼aru procent GL konta',0),(600168,16646,'pl','MiÄ™dzyfirmowe przesuniÄ™cia - Zezwalaj na wiele lokalizacji',0),(600169,16647,'pl','PrzesuniÄ™cia - KsiÄ™gowanie miÄ™dzyfirmowe',0),(600170,16648,'pl','ZapasÃ³w w GL zapasÃ³w w drodze',0),(600171,16649,'pl','-Dystrybucji Center Num miesiÄ™cy sprzedaÅ¼y dla ponownego obliczania',0),(600172,16650,'pl','Post przez linii',0),(600173,16651,'pl','Post przez wysyÅ‚anie i odbieranie',0),(600174,16652,'pl','Logowanie uÅ¼ytkownika B2B',0),(600175,16653,'pl','Zaloguj siÄ™ jako ten uÅ¼ytkownik',0),(600176,16654,'pl','Nie moÅ¼na zapisaÄ‡ jako zamÃ³wienie kompletne',0),(600177,16655,'pl','Plik POD, nie doÅ‚Ä…czone do zamÃ³wienia',0),(600178,16656,'pl','Drop Ship',0),(600179,16657,'pl','Zapisz & Archiwum',0),(600180,16658,'pl','ZamkniÄ™ty przez koszt kodu',0),(600181,16659,'pl','ZAMKNIÄ˜TA w kategorii GL',0),(600182,16660,'pl','Zamknij konta kodem kosztÃ³w',0),(600183,16661,'pl','Zamknij konta wedÅ‚ug kategorii GL',0),(600184,16662,'pl','Data anulowania',0),(600185,16663,'pl','13 wpis okresu',0),(600186,16664,'pl','Podatek Regulacja wejÅ›cia',0),(600187,16665,'pl','Rok zakoÅ„czenia Regulacja wejÅ›cia',0),(600188,16666,'pl','13 wpisÃ³w okresu',0),(600189,16667,'pl','Podatek wpisÃ³w korygujÄ…cych',0),(600190,16668,'pl','Z koÅ„cem roku wpisÃ³w korygujÄ…cych',0),(600191,16669,'pl','-Stock',0),(600192,16670,'pl','Innych opÅ‚at',0),(600193,16671,'pl','Inne opÅ‚aty',0),(600194,16672,'pl','Transfer miÄ™dzy lokalizacjami',0),(600195,16673,'pl','Dane do przelewu',0),(600196,16674,'pl','Zaopatrzony',0),(600197,16675,'pl','Wynajem',0),(600198,16676,'pl','Zapasy',0),(600199,16677,'pl','0 na nie Max',0),(600200,16678,'pl','0 nie min',0),(600201,16679,'pl','IloÅ›Ä‡ AVG na miesiÄ…c',0),(600202,16680,'pl','ZamÃ³wienie zakupu utworzone',0),(600203,16681,'pl','UtwÃ³rz zamÃ³wienie zakupu',0),(600204,16682,'pl','Centra dystrybucji',0),(600205,16683,'pl','Lokalizacje zapasÃ³w',0),(600206,16684,'pl','Max z strony',0),(600207,16685,'pl','Min na rÄ™kÄ™',0),(600208,16686,'pl','Moich dostawcÃ³w',0),(600209,16687,'pl','NUM miesiÄ™cy sprzedaÅ¼y dla maksymalnie na rÄ™kÄ™',0),(600210,16688,'pl','NUM miesiÄ™cy sprzedaÅ¼y dla Minimum na rÄ™kÄ™',0),(600211,16689,'pl','NUM miesiÄ™cy sprzedaÅ¼y na iloÅ›Ä‡ ponownego zamÃ³wienia',0),(600212,16690,'pl','Jest domyÅ›lny dostawca zapasu?',0),(600213,16691,'pl','Liczba dni',0),(600214,16692,'pl','Cytat czas realizacji zamÃ³wienia',0),(600215,16693,'pl','Ustawienie tego dostawcy jako wartoÅ›Ä‡ domyÅ›lna dla tego elementu bÄ™dzie usunÄ…Ä‡ jakiekolwiek innych dostawcÃ³w domyÅ›lnie dla tego elementu',0),(600216,16694,'pl','Dostawcy UPC',0),(600217,16695,'pl','Numer RTV',0),(600218,16696,'pl','ZamÃ³wienie niezrealizowane',0),(600219,16697,'pl','Nie moÅ¼na zmieniÄ‡ tego zeby spadek statku',0),(600220,16698,'pl','BieÅ¼Ä…cej lokalizacji',0),(600221,16699,'pl','Zlecenie ma przesyÅ‚ek-Drop Ship elementÃ³w',0),(600222,16700,'pl','ZamÃ³wienie nie jest dostÄ™pna w miejscu',0),(600223,16701,'pl','ZmniejszyÄ‡ iloÅ›Ä‡ zamÃ³wienia',0),(600224,16702,'pl','NastÄ™pujÄ…ce elementy-Drop Ship, aby usunÄ…Ä‡',0),(600225,16703,'pl','Identyfikator kupon',0),(600226,16704,'pl','Podstawowego kupujÄ…cego',0),(600227,16705,'pl','JeÅ¼eli powiat nie ma na liÅ›cie',0),(600228,16706,'pl','Akcja aktualizacji',0),(600229,16707,'pl','WymagaÄ‡ kodÃ³w kosztÃ³w, jeÅ›li konta k/g kosztowaÅ‚a kody',0),(600230,16708,'pl','WymagajÄ… GL kategorii, jeÅ›li konta k/g ma GL kategorie',0),(600231,16709,'pl','Centrum dystrybucji',0),(600232,16710,'pl','Jest centrum dystrybucji?',0),(600233,16711,'pl','Sprawdzone',0),(600234,16712,'pl','Zamelduj siÄ™',0),(600235,16713,'pl','Odpraw siÄ™ teraz',0),(600236,16714,'pl','SprawdÅº w czasie',0),(600237,16715,'pl','Zapisywanie notatek',0),(600238,16716,'pl','Aktualizuj notatki',0),(600239,16717,'pl','Nie moÅ¼na odnaleÅºÄ‡ konta GL wedÅ‚ug nazwy',0),(600240,16718,'pl','Import pacjenta',0),(600241,16719,'pl','WypeÅ‚niÄ‡ dzieÅ„',0),(600242,16720,'pl','Ostatni termin',0),(600243,16721,'pl','ProszÄ™ 777 chmod',0),(600244,16722,'pl','Wszystkie terminy',0),(600245,16723,'pl','Zarezerwuj ten termin',0),(600246,16724,'pl','Nie znaleziono polecenia',0),(600247,16725,'pl','Potwierdzenie terminu',0),(600248,16726,'pl','Funkcja nie wÅ‚Ä…czona',0),(600249,16727,'pl','NastÄ™pne spotkanie',0),(600250,16728,'pl','Nie nadchodzÄ…cych mianowania',0),(600251,16729,'pl','Otwarte terminy dla',0),(600252,16730,'pl','Wybierz datÄ™, aby wyÅ›wietliÄ‡ otwarte terminy',0),(600253,16731,'pl','Gdzie',0),(600254,16732,'pl','UmÃ³wiÄ‡ siÄ™ na spotkanie',0),(600255,16733,'pl','Wybierz datÄ™',0),(600256,16734,'pl','Typ Å¼Ä…dania korekty zapasÃ³w',0),(600257,16735,'pl','Typ Å¼Ä…dania korekty zapasÃ³w przez ten kod juÅ¼ istnieje',0),(600258,16736,'pl','Kod typu Å¼Ä…danie korekty zapasÃ³w musi byÄ‡ ustawiona',0),(600259,16737,'pl','Post przez wysyÅ‚ka & otrzymujÄ…cych',0),(600260,16738,'pl','Zaloguj siÄ™ jako ten uÅ¼ytkownik',0),(600261,16739,'pl','Obejmuje cytaty',0),(600262,16503,'pt','NÃ£o posso ler o registro',0),(600263,16504,'pt','NÃ£o pÃ´de ser adicionado',0),(600264,16505,'pt','NÃ£o pÃ´de ser atualizado',0),(600265,16506,'pt','FormulÃ¡rio incompleto',0),(600266,16507,'pt','NÃ£o consigo ler o arquivo',0),(600267,16508,'pt','Campos personalizados complemento necessÃ¡rio',0),(600268,16509,'pt','Encargos de frete',0),(600269,16510,'pt','Encargos de frete',0),(600270,16511,'pt','Incluir entradas de ajuste de final de ano',0),(600271,16512,'pt','Tipo de solicitaÃ§Ã£o de ajuste de inventÃ¡rio',0),(600272,16513,'pt','Tipo de solicitaÃ§Ã£o de ajuste de inventÃ¡rio por esse cÃ³digo jÃ¡ existe',0),(600273,16514,'pt','CÃ³digo de tipo de solicitaÃ§Ã£o de ajuste de inventÃ¡rio deve ser definido',0),(600274,16515,'pt','Criar a transferÃªncia',0),(600275,16516,'pt','Conta de deslocamento padrÃ£o Intercompany transferÃªncia deve ser definida',0),(600276,16517,'pt','Inter-empresas Item transferÃªncia - Print',0),(600277,16518,'pt','Conta de estoque GL deve ser atribuÃ­da no Item ou conta padrÃ£o atribuÃ­do na configuraÃ§Ã£o do inventÃ¡rio',0),(600278,16519,'pt','Num meses vendas para reordenar Qty',0),(600279,16520,'pt','Num meses para repor',0),(600280,16521,'pt','Reabastecimento',0),(600281,16522,'pt','TransferÃªncias de reabastecimento',0),(600282,16523,'pt','TransferÃªncia salvou',0),(600283,16524,'pt','Data aceita',0),(600284,16525,'pt','Tipo de ajuste',0),(600285,16526,'pt','AtribuÃ­do',0),(600286,16527,'pt','Data atribuÃ­da',0),(600287,16528,'pt','Contados',0),(600288,16529,'pt','Tipo de contagem',0),(600289,16530,'pt','Data atribuÃ­da',0),(600290,16531,'pt','Itens contados',0),(600291,16532,'pt','Ãšltima atualizaÃ§Ã£o feita por',0),(600292,16533,'pt','Contado por cento',0),(600293,16534,'pt','Tipo de solicitaÃ§Ã£o',0),(600294,16535,'pt','Pedido de verificaÃ§Ã£o de estoque',0),(600295,16536,'pt','Pedidos de verificaÃ§Ã£o de estoque',0),(600296,16537,'pt','Status da solicitaÃ§Ã£o de verificaÃ§Ã£o de estoque',0),(600297,16538,'pt','VariaÃ§Ã£o valor Amt',0),(600298,16539,'pt','Por cento de valor de variÃ¢ncia',0),(600299,16540,'pt','Condado de adicionar/editar',0),(600300,16541,'pt','Agendador de nomeaÃ§Ã£o',0),(600301,16542,'pt','GestÃ£o de contagem',0),(600302,16543,'pt','ImportaÃ§Ã£o de informaÃ§Ã£o do cliente',0),(600303,16544,'pt','TerritÃ³rios de vendedor de importaÃ§Ã£o',0),(600304,16545,'pt','Imposto de importaÃ§Ã£o',0),(600305,16546,'pt','Importar o fornecedor ordem Froms',0),(600306,16547,'pt','Inter-empresas encargos de frete de transferÃªncia',0),(600307,16548,'pt','Tipos de solicitaÃ§Ã£o de ajuste de inventÃ¡rio',0),(600308,16549,'pt','Novo pedido de verificaÃ§Ã£o de estoque',0),(600309,16550,'pt','Ãreas de preparaÃ§Ã£o',0),(600310,16551,'pt','Ãrea de transferÃªncia',0),(600311,16552,'pt','Conta tipo errado',0),(600312,16553,'pt','Contagem de nÃ£o encontrar a conta pelo nome',0),(600313,16554,'pt','Contagem de nÃ£o encontrar a conta corrente pelo nome',0),(600314,16555,'pt','Contagem nÃ£o encontrar mÃ©todo pelo nome do transporte',0),(600315,16556,'pt','Jogos Muliple fornecedores',0),(600316,16557,'pt','CÃ³digo postal ou o estado necessÃ¡rio',0),(600317,16558,'pt','ID do vendedor',0),(600318,16559,'pt','Nome ou ID do vendedor deve ser definido',0),(600319,16560,'pt','CÃ³digo estadual',0),(600320,16561,'pt','Nome da empresa do fornecedor ou Ãºltimo nome deve ser definido',0),(600321,16562,'pt','NÃºmero de roteamento do banco',0),(600322,16563,'pt','MÃ©todo de pagamento padrÃ£o',0),(600323,16564,'pt','CÃ³digo do fornecedor deve ser definido',0),(600324,16565,'pt','Em branco',0),(600325,16566,'pt','Nenhum conjunto de tipo',0),(600326,16567,'pt','NomeaÃ§Ãµes-recente',0),(600327,16568,'pt','Consultas abertas',0),(600328,16569,'pt','Compromissos de hoje',0),(600329,16570,'pt','Total de nomeaÃ§Ãµes',0),(600330,16571,'pt','Comprimento de nomeaÃ§Ã£o',0),(600331,16572,'pt','Lista de nomeaÃ§Ã£o para',0),(600332,16573,'pt','LocalizaÃ§Ã£o de nomeaÃ§Ã£o',0),(600333,16574,'pt','Nome de nomeaÃ§Ã£o',0),(600334,16575,'pt','Resumo de nomeaÃ§Ã£o',0),(600335,16576,'pt','Agendador de nomeaÃ§Ã£o de B2B',0),(600336,16577,'pt','Criar aberturas de nomeaÃ§Ã£o',0),(600337,16578,'pt','Excluir a consulta aberta',0),(600338,16579,'pt','PrÃ³ximo compromisso futuro',0),(600339,16580,'pt','Escolha uma data para ver os & editar compromissos',0),(600340,16581,'pt','Mostrar Resumo',0),(600341,16582,'pt','Cancele a consulta',0),(600342,16583,'pt','Adicionar novo Condado',0),(600343,16584,'pt','Condado de nome',0),(600344,16585,'pt','Estado de pai',0),(600345,16586,'pt','VocÃª deve digitar um nome de Condado',0),(600346,16587,'pt','VocÃª deve selecionar um estado',0),(600347,16588,'pt','Tem certeza que deseja excluir este concelho?',0),(600348,16589,'pt','Condado de Delete',0),(600349,16590,'pt','Edit Custom County',0),(600350,16591,'pt','Considere a adiÃ§Ã£o de um novo paÃ­s',0),(600351,16592,'pt','Condado de editar',0),(600352,16593,'pt','Sua seleÃ§Ã£o Ã© um sistema de valor e nÃ£o pode ser alterada',0),(600353,16594,'pt','VocÃª deve preencher o formulÃ¡rio para continuar',0),(600354,16595,'pt','Clientes adicionados',0),(600355,16596,'pt','Os clientes ignorada',0),(600356,16597,'pt','Clientes atualizados',0),(600357,16598,'pt','Linhas de leitura',0),(600358,16599,'pt','Telefone alternativo',0),(600359,16600,'pt','Arquivo de importaÃ§Ã£o CSV',0),(600360,16601,'pt','Operadora de telefonia mÃ³vel',0),(600361,16602,'pt','NÃºmero do telefone celular',0),(600362,16603,'pt','Selecione os termos de factura',0),(600363,16604,'pt','Abreviatura de estado',0),(600364,16605,'pt','EndereÃ§o de rua',0),(600365,16606,'pt','Adicionar/editar',0),(600366,16607,'pt','AVG vendas por mÃªs',0),(600367,16608,'pt','AlimentaÃ§Ã£o em corrente',0),(600368,16609,'pt','NÃ£o Bin primÃ¡rio atribuÃ­do',0),(600369,16610,'pt','Qtde de transferÃªncia',0),(600370,16611,'pt','Reabastecer o estoque do centro de distribuiÃ§Ã£o',0),(600371,16612,'pt','Sugeriu',0),(600372,16613,'pt','Qtde de transferÃªncia',0),(600373,16614,'pt','Zona',0),(600374,16615,'pt','Cidades adicionadas',0),(600375,16616,'pt','Cidades-atualizadas',0),(600376,16617,'pt','Condados adicionados',0),(600377,16618,'pt','Condados atualizados',0),(600378,16619,'pt','Estados-membros adicionados',0),(600379,16620,'pt','Estados-membros atualizados',0),(600380,16621,'pt','Tem certeza de que deseja atualizar seus registros de imposto sobre vendas?',0),(600381,16622,'pt','Nome da cidade',0),(600382,16623,'pt','Multiplicador de impostos sobre as vendas do City',0),(600383,16624,'pt','Multiplicador de impostos de uso cidade',0),(600384,16625,'pt','Multiplicador de imposto sobre vendas no Condado',0),(600385,16626,'pt','Uso do concelho fiscal multiplicador',0),(600386,16627,'pt','ImportaÃ§Ã£o de imposto sobre vendas',0),(600387,16628,'pt','Multiplicador de impostos estaduais',0),(600388,16629,'pt','Multiplicador de imposto estadual de uso',0),(600389,16630,'pt','Thomson Reuters guia arquivo',0),(600390,16631,'pt','Dados existentes',0),(600391,16632,'pt','Manter os dados existentes',0),(600392,16633,'pt','Limpar todos os dados existentes',0),(600393,16634,'pt','Limpar dados existentes para vendedores na importaÃ§Ã£o',0),(600394,16635,'pt','CrÃ©ditos pendentes do fornecedor',0),(600395,16636,'pt','Auto selecione imposto sobre vendas de navio para',0),(600396,16637,'pt','Em cumprimento e ordens de POS',0),(600397,16638,'pt','Permitir a fim de volta apenas a partir de centros de distribuiÃ§Ã£o',0),(600398,16639,'pt','Selecionar automaticamente o imposto sobre vendas de navio para cumprimento e ordens de POS',0),(600399,16640,'pt','Envio directo final requer POD',0),(600400,16641,'pt','Sugerir locais alternativos de compra quando Qty nÃ£o disponÃ­vel',0),(600401,16642,'pt','IsenÃ§Ã£o fiscal parcial',0),(600402,16643,'pt','Por cento de taxa de imposto',0),(600403,16644,'pt','Centro de distribuiÃ§Ã£o Num meses vendas para reordenar cÃ¡lculo',0),(600404,16645,'pt','TransferÃªncia interprofissionais carga percentual GL conta',0),(600405,16646,'pt','Inter-empresas Item transferÃªncias - permitir que vÃ¡rios locais',0),(600406,16647,'pt','Inter-empresas Item transferÃªncias - postando',0),(600407,16648,'pt','InventÃ¡rio em trÃ¢nsito GL conta',0),(600408,16649,'pt','Meses de Num centro de distribuiÃ§Ã£o nÃ£o vendas para reordenar cÃ¡lculo',0),(600409,16650,'pt','Post por linha',0),(600410,16651,'pt','Post por envio e recebimento de',0),(600411,16652,'pt','Login de usuÃ¡rio B2B',0),(600412,16653,'pt','Logar como este usuÃ¡rio',0),(600413,16654,'pt','NÃ£o Ã© possÃ­vel salvar como ordem completa',0),(600414,16655,'pt','Nenhum arquivo POD anexado Ã  ordem',0),(600415,16656,'pt','Navio da gota',0),(600416,16657,'pt','Arquivo e salvar',0),(600417,16658,'pt','Fechado pelo cÃ³digo do custo',0),(600418,16659,'pt','Fechado por categoria GL',0),(600419,16660,'pt','Fechar as contas pelo cÃ³digo do custo',0),(600420,16661,'pt','Fechar as contas por categoria GL',0),(600421,16662,'pt','Encontro cancelado',0),(600422,16663,'pt','13 entrada PerÃ­oda',0),(600423,16664,'pt','RegulaÃ§Ã£o da entrada de impostos',0),(600424,16665,'pt','Entrada de ajuste de fim de ano',0),(600425,16666,'pt','13 entradas PerÃ­odas',0),(600426,16667,'pt','Imposto sobre as entradas de ajuste',0),(600427,16668,'pt','Com o fim de ano, ajustando as entradas',0),(600428,16669,'pt','NÃ£o-estoque',0),(600429,16670,'pt','Outra acusaÃ§Ã£o',0),(600430,16671,'pt','Outros encargos',0),(600431,16672,'pt','TransferÃªncia entre locais',0),(600432,16673,'pt','Detalhes de transferÃªncia',0),(600433,16674,'pt','NÃ£o abastecido',0),(600434,16675,'pt','Aluguer de automÃ³veis',0),(600435,16676,'pt','Estocados',0),(600436,16677,'pt','0 para nenhum Max',0),(600437,16678,'pt','0 para nenhuma Min',0),(600438,16679,'pt','AVG Qty por mÃªs',0),(600439,16680,'pt','Ordem de compra criado',0),(600440,16681,'pt','Criar ordem de compra',0),(600441,16682,'pt','Centros de distribuiÃ§Ã£o',0),(600442,16683,'pt','Locais de estoque',0),(600443,16684,'pt','MÃ¡ximo por lado',0),(600444,16685,'pt','Min na mÃ£o',0),(600445,16686,'pt','Meus fornecedores',0),(600446,16687,'pt','Num meses vendas para mÃ¡ximo na mÃ£o',0),(600447,16688,'pt','Num meses vendas para mÃ­nimo na mÃ£o',0),(600448,16689,'pt','Num meses vendas para reordenar quantidade',0),(600449,16690,'pt','Ã‰ o padrÃ£o Item fornecedor?',0),(600450,16691,'pt','NÃºmero de dias',0),(600451,16692,'pt','Citar o prazo de execuÃ§Ã£o',0),(600452,16693,'pt','Definindo este fornecedor como padrÃ£o para este Item irÃ¡ remover qualquer padrÃ£o de outros fornecedores para este Item',0),(600453,16694,'pt','Vendedor de UPC',0),(600454,16695,'pt','NÃºmero RTV',0),(600455,16696,'pt','Fim de volta',0),(600456,16697,'pt','NÃ£o Ã© possÃ­vel alterar esta ordem de navio da gota',0),(600457,16698,'pt','LocalizaÃ§Ã£o atual',0),(600458,16699,'pt','A ordem tem embarques de itens nÃ£o-nave',0),(600459,16700,'pt','Quantidade de ordem nÃ£o estÃ¡ disponÃ­vel no local',0),(600460,16701,'pt','Reduzir a quantidade da ordem',0),(600461,16702,'pt','Os seguintes itens nÃ£o-nave a ser removido',0),(600462,16703,'pt','ID de comprovante',0),(600463,16704,'pt','Principal comprador',0),(600464,16705,'pt','Se o municÃ­pio nÃ£o estÃ¡ na lista',0),(600465,16706,'pt','AÃ§Ã£o de atualizaÃ§Ã£o',0),(600466,16707,'pt','Requerem cÃ³digos de custo se GL conta custou cÃ³digos',0),(600467,16708,'pt','Exigir categoria GL se conta GL tem categorias GL',0),(600468,16709,'pt','Centro de distribuiÃ§Ã£o',0),(600469,16710,'pt','Ã‰ o centro de distribuiÃ§Ã£o?',0),(600470,16711,'pt','Check-In',0),(600471,16712,'pt','Fazer Check-in',0),(600472,16713,'pt','Check-In agora',0),(600473,16714,'pt','Check-In Time',0),(600474,16715,'pt','Salvar anotaÃ§Ãµes',0),(600475,16716,'pt','Notas de atualizaÃ§Ã£o',0),(600476,16717,'pt','NÃ£o foi possÃ­vel encontrar o GL conta pelo nome',0),(600477,16718,'pt','ImportaÃ§Ã£o de paciente',0),(600478,16719,'pt','Preencha o dia',0),(600479,16720,'pt','Ãšltima consulta',0),(600480,16721,'pt','Por favor chmod 777',0),(600481,16722,'pt','Todos os compromissos',0),(600482,16723,'pt','Marcar esta consulta',0),(600483,16724,'pt','Comando nÃ£o encontrado',0),(600484,16725,'pt','Confirmar horÃ¡rio',0),(600485,16726,'pt','Recurso nÃ£o habilitado',0),(600486,16727,'pt','PrÃ³ximo compromisso',0),(600487,16728,'pt','Nenhuma nomeaÃ§Ã£o prÃ³xima',0),(600488,16729,'pt','Abertas as indicaÃ§Ãµes para',0),(600489,16730,'pt','Selecione uma data para ver os compromissos abertos',0),(600490,16731,'pt','Onde',0),(600491,16732,'pt','Agende uma entrevista',0),(600492,16733,'pt','Selecione a data',0),(600493,16734,'pt','Tipo de solicitaÃ§Ã£o de ajuste de inventÃ¡rio',0),(600494,16735,'pt','Tipo de solicitaÃ§Ã£o de ajuste de inventÃ¡rio por esse cÃ³digo jÃ¡ existe',0),(600495,16736,'pt','CÃ³digo de tipo de solicitaÃ§Ã£o de ajuste de inventÃ¡rio deve ser definido',0),(600496,16737,'pt','Post por envio e recebimento',0),(600497,16738,'pt','Logar como este usuÃ¡rio',0),(600498,16739,'pt','Incluir aspas',0),(600499,16503,'ro','Imposibil de citit Ã®nregistrarea',0),(600500,16504,'ro','Nu ar putea fi adÄƒugat',0),(600501,16505,'ro','Imposibil de actualizat',0),(600502,16506,'ro','Forma incompleta',0),(600503,16507,'ro','Nu poate citi fiÈ™ierul',0),(600504,16508,'ro','Custom domenii supliment necesare',0),(600505,16509,'ro','Transport de marfÄƒ sarcina',0),(600506,16510,'ro','Transport de marfÄƒ sarcina',0),(600507,16511,'ro','Includ sfÃ¢rÅŸitul anului ajustarea intrÄƒrilor',0),(600508,16512,'ro','Inventar ajustare cerere tip',0),(600509,16513,'ro','Inventar ajustare cererea tip de acest cod existÄƒ deja',0),(600510,16514,'ro','Trebuie stabilit inventarul ajustare cerere tip cod',0),(600511,16515,'ro','Crea Transfer',0),(600512,16516,'ro','Trebuie setat implicit inter-companii transferul contului Offset',0),(600513,16517,'ro','Intercompanii element Transfer - Print',0),(600514,16518,'ro','Cont de GL inventar trebuie sÄƒ se atribuie pe articol sau cont implicit alocat Ã®n parametrizarea stocurilor',0),(600515,16519,'ro','Luni Ã®ntr-o vÃ¢nzare de reluare a comenzii cantitate',0),(600516,16520,'ro','ÃŽntr-o luni pentru a reface',0),(600517,16521,'ro','Reumplere',0),(600518,16522,'ro','Transferuri de reaprovizionare',0),(600519,16523,'ro','Salvate de transfer',0),(600520,16524,'ro','Data acceptate',0),(600521,16525,'ro','Tip de ajustare',0),(600522,16526,'ro','Atribuit',0),(600523,16527,'ro','AtribuitÄƒ data',0),(600524,16528,'ro','NumÄƒrate',0),(600525,16529,'ro','Tip contor',0),(600526,16530,'ro','Data atribuite',0),(600527,16531,'ro','Elementele luate Ã®n considerare',0),(600528,16532,'ro','Ultima actualizare de',0),(600529,16533,'ro','La sutÄƒ numÄƒrate',0),(600530,16534,'ro','Cerere tip',0),(600531,16535,'ro','Cererea de verificare stoc',0),(600532,16536,'ro','Cereri verificare stoc',0),(600533,16537,'ro','Starea de solicitare verificare stoc',0),(600534,16538,'ro','VariaÅ£ia valorii Amt',0),(600535,16539,'ro','VariaÅ£ia valorii la sutÄƒ',0),(600536,16540,'ro','AdÄƒugare/Editare County',0),(600537,16541,'ro','Numirea Scheduler',0),(600538,16542,'ro','Contele Management',0),(600539,16543,'ro','Importul de Info client',0),(600540,16544,'ro','Teritoriile de vanzator de import',0),(600541,16545,'ro','TVA import',0),(600542,16546,'ro','ApÄƒrea de ordine furnizor de import',0),(600543,16547,'ro','Intercompanii de Transfer de transport de marfÄƒ sarcina',0),(600544,16548,'ro','Tipuri de cerere inventar ajustare',0),(600545,16549,'ro','Cererea de verificare stoc nou',0),(600546,16550,'ro','Zonele de aÈ™teptare',0),(600547,16551,'ro','ZonÄƒ de aÈ™teptare',0),(600548,16552,'ro','Cont tip greÅŸit',0),(600549,16553,'ro','Count nu gÄƒsi contul de nume',0),(600550,16554,'ro','Count nu gÄƒsi cont de verificare nume',0),(600551,16555,'ro','Count nu gÄƒseÅŸte metoda de nume de transport',0),(600552,16556,'ro','Furnizori de vasular meciuri',0),(600553,16557,'ro','Cod postal sau de stat necesare',0),(600554,16558,'ro','ID vanzator',0),(600555,16559,'ro','Trebuie setat ID vanzator sau numele',0),(600556,16560,'ro','Cod de stare',0),(600557,16561,'ro','Numele companiei furnizoare sau numele de familie trebuie sÄƒ fie setat',0),(600558,16562,'ro','Banca numÄƒrul de circuit',0),(600559,16563,'ro','MetodÄƒ de platÄƒ prestabilitÄƒ',0),(600560,16564,'ro','Cod furnizor trebuie sÄƒ fie setat',0),(600561,16565,'ro','Gol',0),(600562,16566,'ro','Nici un Set de tip',0),(600563,16567,'ro','ÃŽntÃ¢lniri recente',0),(600564,16568,'ro','Numiri Open',0),(600565,16569,'ro','Numiri astÄƒzi',0),(600566,16570,'ro','Numiri Total',0),(600567,16571,'ro','Numirea lungime',0),(600568,16572,'ro','ListÄƒ de programare pentru',0),(600569,16573,'ro','Rezervare locatie',0),(600570,16574,'ro','Numirea nume',0),(600571,16575,'ro','Rezumat rezervare',0),(600572,16576,'ro','Planificator de numirea B2B',0),(600573,16577,'ro','Numirea deschideri a crea',0),(600574,16578,'ro','ÅžtergeÅ£i deschis numirea',0),(600575,16579,'ro','UrmÄƒtoarea Ã®ntÃ¢lnire viitoare',0),(600576,16580,'ro','Alege o datÄƒ sÄƒ Vezi & editaÅ£i numiri',0),(600577,16581,'ro','AratÄƒ Sumar',0),(600578,16582,'ro','Unbook numirea',0),(600579,16583,'ro','Adauga noi County',0),(600580,16584,'ro','Denumire JudeÅ£',0),(600581,16585,'ro','Starea pÄƒrinte',0),(600582,16586,'ro','IntroduceÅ£i un nume de judeÅ£',0),(600583,16587,'ro','Trebuie sÄƒ selectaÅ£i o stare',0),(600584,16588,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ ÅŸtergeÅ£i acest judeÅ£?',0),(600585,16589,'ro','Åžterge County',0),(600586,16590,'ro','Editare Custom County',0),(600587,16591,'ro','LuaÅ£i Ã®n considerare adÄƒugÃ¢nd un nou comitat',0),(600588,16592,'ro','Editare County',0),(600589,16593,'ro','SelecÅ£ia dumneavoastrÄƒ este o valoare de sistem ÅŸi nu poate fi schimbat',0),(600590,16594,'ro','Trebuie sÄƒ completaÅ£i formularul pentru a continua',0),(600591,16595,'ro','ClienÅ£ii adÄƒugat',0),(600592,16596,'ro','ClienÅ£ii de sarit',0),(600593,16597,'ro','ClienÅ£ii actualizate',0),(600594,16598,'ro','Linii de citire',0),(600595,16599,'ro','Supleant telefon',0),(600596,16600,'ro','FiÅŸier de Import CSV',0),(600597,16601,'ro','Operator de transport telefon mobil',0),(600598,16602,'ro','NumÄƒrul de telefon mobil',0),(600599,16603,'ro','SelectaÅ£i factura termeni',0),(600600,16604,'ro','Abrevierea de stat',0),(600601,16605,'ro','AdresÄƒ stradÄƒ',0),(600602,16606,'ro','AdÄƒugare/Editare',0),(600603,16607,'ro','AVG vÃ¢nzÄƒri pe lunÄƒ',0),(600604,16608,'ro','Alimentare cu curent',0),(600605,16609,'ro','Nici un Bin primar asociat',0),(600606,16610,'ro','Cantit pe transferul',0),(600607,16611,'ro','Reface stocul la centru de distributie',0),(600608,16612,'ro','Sugerat',0),(600609,16613,'ro','Transfera-cantit',0),(600610,16614,'ro','Zona',0),(600611,16615,'ro','OraÅŸe adÄƒugate',0),(600612,16616,'ro','OraÅŸe actualizat',0),(600613,16617,'ro','AdÄƒugat de judete',0),(600614,16618,'ro','Judete actualizat',0),(600615,16619,'ro','Statele adÄƒugat',0),(600616,16620,'ro','Statele actualizat',0),(600617,16621,'ro','SunteÅ£i sigur cÄƒ doriÅ£i sÄƒ actualizaÅ£i Ã®nregistrÄƒrile de TVA?',0),(600618,16622,'ro','Numele oraÅŸului',0),(600619,16623,'ro','Multiplicator de impozitul pe vÃ¢nzÄƒri City',0),(600620,16624,'ro','City utilizarea taxa multiplicare',0),(600621,16625,'ro','Comitatul TVA de multiplicare',0),(600622,16626,'ro','Multiplicator de taxa utilizare County',0),(600623,16627,'ro','TVA Import',0),(600624,16628,'ro','Multiplicator de stat impozitul pe vÃ¢nzÄƒri',0),(600625,16629,'ro','Multiplicator de fiscale stat utilizarea',0),(600626,16630,'ro','Thomson Reuters Tab dosar',0),(600627,16631,'ro','Datele existente',0),(600628,16632,'ro','PÄƒstraÅ£i datele existente',0),(600629,16633,'ro','Toate datele existente de epurare',0),(600630,16634,'ro','Datele existente de epurare pentru furnizori din Import',0),(600631,16635,'ro','Credite furnizor Ã®n aÅŸteptare',0),(600632,16636,'ro','Auto selectare TVA de la nava la',0),(600633,16637,'ro','ÃŽmplinirea ÅŸi POS comenzi',0),(600634,16638,'ro','Permite restantÄƒ doar la centrele de distribuÅ£ie',0),(600635,16639,'ro','Selecteze automat TVA la nava la Ã®mplinire ÅŸi POS comenzi',0),(600636,16640,'ro','LivrÄƒri finalÄƒ necesitÄƒ POD',0),(600637,16641,'ro','SugereazÄƒ locaÅ£ii Alternative cumpÄƒrare cÃ¢nd cantitate nu este disponibil',0),(600638,16642,'ro','Scutire parÅ£ialÄƒ',0),(600639,16643,'ro','Fiscale % rata',0),(600640,16644,'ro','Centru de distribuÅ£ie Ã®ntr-o luni vÃ¢nzÄƒri pentru calculul de reluare a comenzii',0),(600641,16645,'ro','Transfer inter-ramurÄƒ povara procentul GL cont',0),(600642,16646,'ro','Intercompanii transferurile de articol - permite mai multe locatii',0),(600643,16647,'ro','Intercompanii element transferuri - postarea',0),(600644,16648,'ro','Inventarul Ã®n tranzit GL cont',0),(600645,16649,'ro','Luni de Num non-distributie centru vÃ¢nzÄƒri pentru calculul de reluare a comenzii',0),(600646,16650,'ro','Post de linie',0),(600647,16651,'ro','Post de transport maritim ÅŸi primirea',0),(600648,16652,'ro','Autentificare de utilizator B2B',0),(600649,16653,'ro','LogheazÄƒ-te ca acest utilizator',0),(600650,16654,'ro','Imposibil de salvat ca ordine complet',0),(600651,16655,'ro','Nici un POD fiÅŸier ataÅŸat la comanda',0),(600652,16656,'ro','PicÄƒturÄƒ de navÄƒ',0),(600653,16657,'ro','Arhiva & salvare',0),(600654,16658,'ro','ÃŽnchis de costuri codul',0),(600655,16659,'ro','ÃŽnchis de categoria GL',0),(600656,16660,'ro','Inchide conturile de costuri codul',0),(600657,16661,'ro','Inchide conturile de categoria GL',0),(600658,16662,'ro','Data anulat',0),(600659,16663,'ro','Intrare perioada 13',0),(600660,16664,'ro','Taxa intrare de reglare',0),(600661,16665,'ro','An scop ajustarea intrare',0),(600662,16666,'ro','IntrÄƒrile perioada 13',0),(600663,16667,'ro','Fiscal, ajustarea intrÄƒrilor',0),(600664,16668,'ro','Cu sfÃ¢rÅŸitul anului ajustarea intrÄƒrilor',0),(600665,16669,'ro','Non-stoc',0),(600666,16670,'ro','Alte taxe',0),(600667,16671,'ro','Alte taxe',0),(600668,16672,'ro','Transfer intre locatii',0),(600669,16673,'ro','Detalii Transfer',0),(600670,16674,'ro','Ne-a Ã®nzestrat',0),(600671,16675,'ro','ÃŽnchiriere',0),(600672,16676,'ro','Aprovizionat',0),(600673,16677,'ro','0 pentru nici o Max',0),(600674,16678,'ro','0 pentru nici o Min',0),(600675,16679,'ro','AVG cantit pe lunÄƒ',0),(600676,16680,'ro','ComandÄƒ cumpÄƒrare create',0),(600677,16681,'ro','CreaÅ£i comanda de cumpÄƒrare',0),(600678,16682,'ro','Centre de distribuÅ£ie',0),(600679,16683,'ro','Inventar locatii',0),(600680,16684,'ro','Max pe parte',0),(600681,16685,'ro','Min pe mÃ¢nÄƒ',0),(600682,16686,'ro','Meu furnizori',0),(600683,16687,'ro','ÃŽntr-o luni vÃ¢nzÄƒri pentru maxim pe mÃ¢nÄƒ',0),(600684,16688,'ro','ÃŽntr-o luni vÃ¢nzÄƒri pentru minim pe parte',0),(600685,16689,'ro','Luni Ã®ntr-o vÃ¢nzare de reluare a comenzii cantitate',0),(600686,16690,'ro','Este furnizor de element implicit?',0),(600687,16691,'ro','NumÄƒrul de zile',0),(600688,16692,'ro','Citat de plumb timp',0),(600689,16693,'ro','Setarea acestui furnizor ca implicit pentru acest element va elimina orice alÅ£i furnizori implicitÄƒ pentru acest element',0),(600690,16694,'ro','Furnizor UPC',0),(600691,16695,'ro','RTV numÄƒrul',0),(600692,16696,'ro','Ordinea spate',0),(600693,16697,'ro','Imposibil de modificat aceastÄƒ ordine sÄƒ renunÅ£e la navÄƒ',0),(600694,16698,'ro','LocaÅ£ia curentÄƒ',0),(600695,16699,'ro','Ordinul a transporturilor de elemente Non-Drop Ship',0),(600696,16700,'ro','Cantitate de comandÄƒ nu este disponibilÄƒ la locaÅ£ie',0),(600697,16701,'ro','Reduce Cantitate comandÄƒ',0),(600698,16702,'ro','UrmÄƒtoarele elemente Non-Drop navei sÄƒ fie eliminate',0),(600699,16703,'ro','Voucher ID',0),(600700,16704,'ro','Primar cumpÄƒrÄƒtor',0),(600701,16705,'ro','DacÄƒ judeÅ£ul nu pe lista',0),(600702,16706,'ro','AcÅ£iunea de actualizare',0),(600703,16707,'ro','NecesitÄƒ coduri de Cost dacÄƒ GL cont a costat coduri',0),(600704,16708,'ro','Necesita GL categorie Ã®n cazul GL contul GL categorii',0),(600705,16709,'ro','Centru de distributie',0),(600706,16710,'ro','Este centru de distribuÅ£ie?',0),(600707,16711,'ro','Verificate',0),(600708,16712,'ro','cazeazÄƒ-te',0),(600709,16713,'ro','Acum a verifica',0),(600710,16714,'ro','Check-In timp',0),(600711,16715,'ro','Memora note',0),(600712,16716,'ro','Notele de actualizare',0),(600713,16717,'ro','Nu am putut gÄƒsi GL cont numele de',0),(600714,16718,'ro','Pacient de Import',0),(600715,16719,'ro','Umple ziua',0),(600716,16720,'ro','Ultima rezervare',0),(600717,16721,'ro','VÄƒ rugÄƒm sÄƒ 777 chmod',0),(600718,16722,'ro','Toate rezervÄƒrile',0),(600719,16723,'ro','Rezerva aceasta programare',0),(600720,16724,'ro','Nu a gÄƒsit de comandÄƒ',0),(600721,16725,'ro','Confirma ora rezervÄƒrii',0),(600722,16726,'ro','Caracteristica nu este activat',0),(600723,16727,'ro','UrmÄƒtoarea Ã®ntÃ¢lnire',0),(600724,16728,'ro','Nici o Ã®ntÃ¢lnire viitoare',0),(600725,16729,'ro','RezervÄƒrile deschise pentru',0),(600726,16730,'ro','SelectaÅ£i o datÄƒ pentru a vizualiza rezervÄƒrile deschise',0),(600727,16731,'ro','ÃŽn cazul Ã®n care',0),(600728,16732,'ro','ProgrameazÄƒ o Ã®ntÃ¢lnire',0),(600729,16733,'ro','SelectaÈ›i data',0),(600730,16734,'ro','Inventar ajustare cerere tip',0),(600731,16735,'ro','Inventar ajustare cererea tip de acest cod existÄƒ deja',0),(600732,16736,'ro','Trebuie stabilit inventarul ajustare cerere tip cod',0),(600733,16737,'ro','Post de transport & primirea',0),(600734,16738,'ro','LogheazÄƒ-te ca acest utilizator',0),(600735,16739,'ro','Includ citate',0),(600736,16503,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(600737,16504,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð´Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ',0),(600738,16505,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ',0),(600739,16506,'ru','ÐÐµÐ¿Ð¾Ð»Ð½Ð°Ñ Ñ„Ð¾Ñ€Ð¼Ð°',0),(600740,16507,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚ÑŒ Ñ„Ð°Ð¹Ð»',0),(600741,16508,'ru','ÐÐ°ÑÑ‚Ñ€Ð°Ð¸Ð²Ð°ÐµÐ¼Ñ‹Ðµ Ð¿Ð¾Ð»Ñ Ð´Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ',0),(600742,16509,'ru','Ð“Ñ€ÑƒÐ·Ð¾Ð²Ñ‹Ðµ Ð±Ñ€ÐµÐ¼Ñ',0),(600743,16510,'ru','Ð“Ñ€ÑƒÐ·Ð¾Ð²Ñ‹Ðµ Ð±Ñ€ÐµÐ¼Ñ',0),(600744,16511,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ Ð² ÐºÐ¾Ð½Ñ†Ðµ Ð³Ð¾Ð´Ð° ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ° Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(600745,16512,'ru','Ð¢Ð¸Ð¿ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(600746,16513,'ru','Ð¢Ð¸Ð¿ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ ÑÑ‚Ð¾Ð¼Ñƒ ÐºÐ¾Ð´Ñƒ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(600747,16514,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð·Ð°Ð´Ð°Ñ‚ÑŒ ÐºÐ¾Ð´ Ñ‚Ð¸Ð¿Ð° Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(600748,16515,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´',0),(600749,16516,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð·Ð°Ð´Ð°Ñ‚ÑŒ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð²Ð½ÑƒÑ‚Ñ€Ð¸Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð½Ð¾Ð³Ð¾ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ð° ÐºÐ¾Ñ€Ñ€',0),(600750,16517,'ru','Ð’Ð½ÑƒÑ‚Ñ€Ð¸Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð½Ñ‹Ðµ Ð¿ÑƒÐ½ÐºÑ‚ ÐŸÐµÑ€ÐµÐ´Ð°Ñ‡Ð° - Ð¿ÐµÑ‡Ð°Ñ‚ÑŒ',0),(600751,16518,'ru','Ð£Ñ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ GL Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð´Ð¾Ð»Ð¶Ð½Ð° Ð±Ñ‹Ñ‚ÑŒ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð° Ð¿Ð¾ Ð¿ÑƒÐ½ÐºÑ‚Ñƒ Ð¸Ð»Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð¾Ð¹ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ, Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ð¹ Ð² ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ°',0),(600752,16519,'ru','Num Ð¼ÐµÑÑÑ†ÐµÐ² Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ Ð´Ð¾Ð·Ð°ÐºÐ°Ð·Ð° ÐšÐ¾Ð»-Ð²Ð¾',0),(600753,16520,'ru','ÐœÐµÑÑÑ†ÐµÐ² num Ð´Ð»Ñ Ð¿Ð¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ',0),(600754,16521,'ru','ÐŸÐ¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ',0),(600755,16522,'ru','ÐŸÐ¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ð¾Ð²',0),(600756,16523,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‡Ð° ÑÐ¾Ñ…Ñ€Ð°Ð½ÐµÐ½',0),(600757,16524,'ru','ÐŸÑ€Ð¸Ð½ÑÑ‚Ñ‹Ðµ Ð”Ð°Ñ‚Ð°',0),(600758,16525,'ru','Ð¢Ð¸Ð¿ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ†Ð¸Ð¸',0),(600759,16526,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½',0),(600760,16527,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð½Ñ‹Ðµ Ð”Ð°Ñ‚Ð°',0),(600761,16528,'ru','ÐŸÐ¾Ð´ÑÑ‡ÐµÑ‚',0),(600762,16529,'ru','Ð¢Ð¸Ð¿ ÑÑ‡ÐµÑ‚Ñ‡Ð¸ÐºÐ°',0),(600763,16530,'ru','Ð”Ð°Ñ‚Ð° Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(600764,16531,'ru','ÐŸÐ¾Ð´ÑÑ‡ÐµÑ‚ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð¾Ð²',0),(600765,16532,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(600766,16533,'ru','ÐŸÐ¾Ð´ÑÑ‡ÐµÑ‚ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚Ð¾Ð²',0),(600767,16534,'ru','Ð¢Ð¸Ð¿ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ°',0),(600768,16535,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¼Ñƒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾Ñ',0),(600769,16536,'ru','Ð¤Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¼Ñƒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ Ð·Ð°Ð¿Ñ€Ð¾ÑÑ‹',0),(600770,16537,'ru','Ð¡Ð¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¼Ñƒ Ð¿Ñ€Ð¾Ð²ÐµÑ€Ð¸Ñ‚ÑŒ',0),(600771,16538,'ru','ÐžÑ‚ÐºÐ»Ð¾Ð½ÐµÐ½Ð¸Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Amt',0),(600772,16539,'ru','ÐžÑ‚ÐºÐ»Ð¾Ð½ÐµÐ½Ð¸Ðµ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ %',0),(600773,16540,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ/Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑƒÐµÐ·Ð´',0),(600774,16541,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¿Ð»Ð°Ð½Ð¸Ñ€Ð¾Ð²Ñ‰Ð¸Ðº',0),(600775,16542,'ru','Ð¤Ð¾Ñ‚Ð¾ ÑƒÐ¿Ñ€Ð°Ð²Ð»ÐµÐ½Ð¸Ñ',0),(600776,16543,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ð¸ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð°',0),(600777,16544,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¿Ñ€Ð¾Ð´Ð°Ð²ÐµÑ† Ñ‚ÐµÑ€Ñ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ð¹',0),(600778,16545,'ru','ÐÐ°Ð»Ð¾Ð³ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(600779,16546,'ru','Ð˜Ð¼Ð¿Ð¾Ñ€Ñ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð·Ð°ÐºÐ°Ð·Ð° Froms',0),(600780,16547,'ru','Ð’Ð½ÑƒÑ‚Ñ€Ð¸Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð½Ñ‹Ðµ Ð±Ñ€ÐµÐ¼Ñ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸ Ð³Ñ€ÑƒÐ·Ð°',0),(600781,16548,'ru','Ð¢Ð¸Ð¿Ñ‹ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ¾Ð² ÐÐ°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ° Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(600782,16549,'ru','ÐÐ¾Ð²Ñ‹Ð¹ Ð·Ð°Ð¿Ñ€Ð¾Ñ Ñ„Ð¾Ð½Ð´Ð¾Ð²Ð¾Ð¼Ñƒ Ð§ÐµÐº',0),(600783,16550,'ru','ÐŸÑ€Ð¾Ð¼ÐµÐ¶ÑƒÑ‚Ð¾Ñ‡Ð½Ñ‹Ðµ Ð¾Ð±Ð»Ð°ÑÑ‚Ð¸',0),(600784,16551,'ru','ÐŸÑ€Ð¾Ð¼ÐµÐ¶ÑƒÑ‚Ð¾Ñ‡Ð½Ð°Ñ Ð¾Ð±Ð»Ð°ÑÑ‚ÑŒ',0),(600785,16552,'ru','Ð¡Ñ‡ÐµÑ‚Ð° Ñ‚Ð¸Ð¿Ð° Ð½ÐµÐ¿Ñ€Ð°Ð²Ð¸Ð»ÑŒÐ½Ð¾',0),(600786,16553,'ru','Count Ð½Ðµ Ð½Ð°Ð¹Ñ‚Ð¸ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ Ð¿Ð¾ Ð¸Ð¼ÐµÐ½Ð¸',0),(600787,16554,'ru','Count Ð½Ðµ Ð½Ð°Ð¹Ñ‚Ð¸ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð½Ð¾Ð³Ð¾ ÑÑ‡ÐµÑ‚Ð° Ð¿Ð¾ Ð¸Ð¼ÐµÐ½Ð¸',0),(600788,16555,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ðµ Ð½Ð°Ð¹Ñ‚Ð¸ ÑÐ¿Ð¾ÑÐ¾Ð± Ð¿Ð¾ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸ÑŽ Ð´Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸',0),(600789,16556,'ru','ÐœÐ°Ñ‚Ñ‡Ð¸ Muliple Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(600790,16557,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ Ð¸Ð½Ð´ÐµÐºÑ Ð¸Ð»Ð¸ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ Ð½ÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ÑÑ‚Ð¸',0),(600791,16558,'ru','ÐŸÑ€Ð¾Ð´Ð°Ð²ÐµÑ† ID',0),(600792,16559,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð·Ð°Ð´Ð°Ñ‚ÑŒ Ð¸Ð¼Ñ Ð¸Ð»Ð¸ ID Ð¿Ñ€Ð¾Ð´Ð°Ð²Ñ†Ð°',0),(600793,16560,'ru','ÐšÐ¾Ð´ Ð³Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð°',0),(600794,16561,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð·Ð°Ð´Ð°Ñ‚ÑŒ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¸Ð»Ð¸ Ñ„Ð°Ð¼Ð¸Ð»Ð¸Ñ',0),(600795,16562,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð±Ð°Ð½ÐºÐ°',0),(600796,16563,'ru','ÐœÐµÑ‚Ð¾Ð´ Ð¾Ð¿Ð»Ð°Ñ‚Ñ‹ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ',0),(600797,16564,'ru','ÐšÐ¾Ð´ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð´Ð¾Ð»Ð¶ÐµÐ½ Ð±Ñ‹Ñ‚ÑŒ ÑƒÑÑ‚Ð°Ð½Ð¾Ð²Ð»ÐµÐ½',0),(600798,16565,'ru','ÐŸÑƒÑÑ‚Ð¾Ð¹',0),(600799,16566,'ru','ÐÐ°Ð±Ð¾Ñ€ Ð½Ðµ Ñ‚Ð¸Ð¿',0),(600800,16567,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð·Ð°Ð±Ñ€Ð¾Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ñ‹',0),(600801,16568,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð²ÑÑ‚Ñ€ÐµÑ‡Ð¸',0),(600802,16569,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ ÑÐµÐ³Ð¾Ð´Ð½Ñ',0),(600803,16570,'ru','Ð’ÑÐµÐ³Ð¾ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ð¹',0),(600804,16571,'ru','ÐŸÑ€Ð¾Ð´Ð¾Ð»Ð¶Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾ÑÑ‚ÑŒ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(600805,16572,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ ÑÐ¿Ð¸ÑÐºÐ° Ð´Ð»Ñ',0),(600806,16573,'ru','ÐœÐµÑÑ‚Ð¾ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(600807,16574,'ru','Ð˜Ð¼Ñ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(600808,16575,'ru','ÐÐ°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(600809,16576,'ru','B2B Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¿Ð»Ð°Ð½Ð¸Ñ€Ð¾Ð²Ñ‰Ð¸Ðº',0),(600810,16577,'ru','Ð¡Ð¾Ð·Ð´Ð°Ð½Ð¸Ðµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð¾Ñ‚Ð²ÐµÑ€ÑÑ‚Ð¸Ð¹',0),(600811,16578,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(600812,16579,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰ÐµÐµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð±ÑƒÐ´ÑƒÑ‰ÐµÐ³Ð¾',0),(600813,16580,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ñƒ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° & Ñ€ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ñ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ð¹',0),(600814,16581,'ru','ÐŸÐ¾ÐºÐ°Ð·Ð°Ñ‚ÑŒ Ñ€ÐµÐ·ÑŽÐ¼Ðµ',0),(600815,16582,'ru','Unbook Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(600816,16583,'ru','Ð”Ð¾Ð±Ð°Ð²Ð¸Ñ‚ÑŒ Ð½Ð¾Ð²Ñ‹Ð¹ ÑƒÐµÐ·Ð´',0),(600817,16584,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¾ÐºÑ€ÑƒÐ³Ð°',0),(600818,16585,'ru','Ð Ð¾Ð´Ð¸Ñ‚ÐµÐ»ÑŒÑÐºÐ¾Ðµ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(600819,16586,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ð²ÐµÑÑ‚Ð¸ Ð½Ð°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð¾ÐºÑ€ÑƒÐ³Ð°',0),(600820,16587,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð²Ñ‹Ð±Ñ€Ð°Ñ‚ÑŒ ÑÐ¾ÑÑ‚Ð¾ÑÐ½Ð¸Ðµ',0),(600821,16588,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ ÑƒÐµÐ·Ð´?',0),(600822,16589,'ru','Ð£Ð´Ð°Ð»Ð¸Ñ‚ÑŒ ÑƒÐµÐ·Ð´',0),(600823,16590,'ru','Ð˜Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ Ð½Ð°ÑÑ‚Ñ€Ð°Ð¸Ð²Ð°ÐµÐ¼Ñ‹Ð¹ ÑƒÐµÐ·Ð´',0),(600824,16591,'ru','Ð Ð°ÑÑÐ¼Ð¾Ñ‚Ñ€Ð¸Ñ‚Ðµ Ð²Ð¾Ð·Ð¼Ð¾Ð¶Ð½Ð¾ÑÑ‚ÑŒ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ñ Ð½Ð¾Ð²Ð¾Ð³Ð¾ ÑƒÐµÐ·Ð´',0),(600825,16592,'ru','Ð ÐµÐ´Ð°ÐºÑ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ ÑƒÐµÐ·Ð´',0),(600826,16593,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ ÑÐ¸ÑÑ‚ÐµÐ¼Ñ‹ Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð¸ Ð½Ðµ Ð¼Ð¾Ð¶ÐµÑ‚ Ð±Ñ‹Ñ‚ÑŒ Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½',0),(600827,16594,'ru','Ð’Ñ‹ Ð´Ð¾Ð»Ð¶Ð½Ñ‹ Ð·Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ñ„Ð¾Ñ€Ð¼Ñƒ Ð´Ð»Ñ Ð¿Ñ€Ð¾Ð´Ð¾Ð»Ð¶ÐµÐ½Ð¸Ñ',0),(600828,16595,'ru','ÐšÐ»Ð¸ÐµÐ½Ñ‚Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð¸Ð»Ð¸',0),(600829,16596,'ru','ÐŸÑ€Ð¾Ð¿ÑƒÑ‰ÐµÐ½ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ñ‹',0),(600830,16597,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ ÐºÐ»Ð¸ÐµÐ½Ñ‚Ð¾Ð²',0),(600831,16598,'ru','Ð§Ñ‚ÐµÐ½Ð¸Ðµ ÑÑ‚Ñ€Ð¾Ðº',0),(600832,16599,'ru','ÐÐ»ÑŒÑ‚ÐµÑ€Ð½Ð°Ñ‚Ð¸Ð²Ð½Ñ‹Ð¹ Ð¢ÐµÐ»ÐµÑ„Ð¾Ð½',0),(600833,16600,'ru','CSV-Ñ„Ð°Ð¹Ð» Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ð°',0),(600834,16601,'ru','ÐœÐ¾Ð±Ð¸Ð»ÑŒÐ½Ñ‹Ð¹ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð·Ñ‡Ð¸ÐºÐ°',0),(600835,16602,'ru','ÐÐ¾Ð¼ÐµÑ€ Ð¼Ð¾Ð±Ð¸Ð»ÑŒÐ½Ð¾Ð³Ð¾ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(600836,16603,'ru','Ð’Ñ‹Ð±Ð¾Ñ€ ÑƒÑÐ»Ð¾Ð²Ð¸Ð¹ ÑÑ‡ÐµÑ‚Ð°',0),(600837,16604,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ð°Ñ Ð°Ð±Ð±Ñ€ÐµÐ²Ð¸Ð°Ñ‚ÑƒÑ€Ð°',0),(600838,16605,'ru','ÐŸÐ¾Ñ‡Ñ‚Ð¾Ð²Ñ‹Ð¹ Ð°Ð´Ñ€ÐµÑ',0),(600839,16606,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ð¸Ðµ/Ð¸Ð·Ð¼ÐµÐ½ÐµÐ½Ð¸Ðµ',0),(600840,16607,'ru','AVG Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð² Ð¼ÐµÑÑÑ†',0),(600841,16608,'ru','Ð’ Ð½Ð°ÑÑ‚Ð¾ÑÑ‰ÐµÐµ Ð²Ñ€ÐµÐ¼Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ°',0),(600842,16609,'ru','ÐÐµÑ‚ Ð¿ÐµÑ€Ð²Ð¸Ñ‡Ð½Ð¾Ð¹ Ð±Ð¸Ð½ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½',0),(600843,16610,'ru','ÐšÐ¾Ð»-Ð²Ð¾ Ð¿Ð¾ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ðµ',0),(600844,16611,'ru','ÐŸÐ¾Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¿Ð°ÑÐ¾Ð² Ð¾Ñ‚ Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ð³Ð¾ Ñ†ÐµÐ½Ñ‚Ñ€Ð°',0),(600845,16612,'ru','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶ÐµÐ½Ð¾',0),(600846,16613,'ru','ÐžÐ±ÑŠÐµÐ¼ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸',0),(600847,16614,'ru','Ð—Ð¾Ð½Ð°',0),(600848,16615,'ru','Ð”Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹ Ð³Ð¾Ñ€Ð¾Ð´Ð°',0),(600849,16616,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð³Ð¾Ñ€Ð¾Ð´Ð¾Ð²',0),(600850,16617,'ru','Ð£ÐµÐ·Ð´Ñ‹ Ð´Ð¾Ð±Ð°Ð²Ð»ÐµÐ½Ñ‹',0),(600851,16618,'ru','Ð£ÐµÐ·Ð´Ñ‹ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð°',0),(600852,16619,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð° Ð´Ð¾Ð±Ð°Ð²Ð¸Ð»Ð¸',0),(600853,16620,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²Ð° Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ',0),(600854,16621,'ru','Ð’Ñ‹ ÑƒÐ²ÐµÑ€ÐµÐ½Ñ‹, Ñ‡Ñ‚Ð¾ Ñ…Ð¾Ñ‚Ð¸Ñ‚Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð¸Ñ‚ÑŒ Ð²Ð°ÑˆÐ¸ Ð·Ð°Ð¿Ð¸ÑÐ¸ Ð½Ð°Ð»Ð¾Ð³Ð° Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶?',0),(600855,16622,'ru','ÐÐ°Ð·Ð²Ð°Ð½Ð¸Ðµ Ð³Ð¾Ñ€Ð¾Ð´Ð°',0),(600856,16623,'ru','Ð“Ð¾Ñ€Ð¾Ð´ÑÐºÐ¾Ð¹ Ð½Ð°Ð»Ð¾Ð³ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÑƒÐ¼Ð½Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒ',0),(600857,16624,'ru','Ð“Ð¾Ñ€Ð¾Ð´ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÑŒ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð¼ÑƒÐ»ÑŒÑ‚Ð¸Ð¿Ð»Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(600858,16625,'ru','ÐœÐ½Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒ ÐšÐ°ÑƒÐ½Ñ‚Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶',0),(600859,16626,'ru','Ð˜ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð£ÐµÐ·Ð´ ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð¼ÑƒÐ»ÑŒÑ‚Ð¸Ð¿Ð»Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(600860,16627,'ru','ÐÐ°Ð»Ð¾Ð³ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ñƒ Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(600861,16628,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ñ‹Ð¹ Ð½Ð°Ð»Ð¾Ð³ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ ÑƒÐ¼Ð½Ð¾Ð¶Ð¸Ñ‚ÐµÐ»ÑŒ',0),(600862,16629,'ru','Ð“Ð¾ÑÑƒÐ´Ð°Ñ€ÑÑ‚Ð²ÐµÐ½Ð½Ð¾Ðµ Ð¸ÑÐ¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ð¹ Ð¼ÑƒÐ»ÑŒÑ‚Ð¸Ð¿Ð»Ð¸ÐºÐ°Ñ‚Ð¾Ñ€',0),(600863,16630,'ru','Thomson Reuters Ð²ÐºÐ»Ð°Ð´ÐºÐ° Ñ„Ð°Ð¹Ð»',0),(600864,16631,'ru','Ð¡ÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(600865,16632,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(600866,16633,'ru','ÐžÑ‡Ð¸ÑÑ‚Ð¸Ñ‚ÑŒ Ð²ÑÐµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ðµ Ð´Ð°Ð½Ð½Ñ‹Ðµ',0),(600867,16634,'ru','Ð£Ð´Ð°Ð»ÐµÐ½Ð¸Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÑŽÑ‰Ð¸Ñ… Ð´Ð°Ð½Ð½Ñ‹Ñ… Ð´Ð»Ñ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð² Ð² Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚Ðµ',0),(600868,16635,'ru','ÐšÑ€ÐµÐ´Ð¸Ñ‚Ñ‹ Ð´Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð²',0),(600869,16636,'ru','ÐÐ²Ñ‚Ð¾ Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ñ Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ñ ÐºÐ¾Ñ€Ð°Ð±Ð»Ñ',0),(600870,16637,'ru','ÐÐ° Ð²Ñ‹Ð¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ðµ Ð¸ POS Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(600871,16638,'ru','Ð Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð½ÐµÐ´Ð¾Ð¿Ð¾ÑÑ‚Ð°Ð²Ð»ÐµÐ½Ð½Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° Ñ‚Ð¾Ð»ÑŒÐºÐ¾ Ð¸Ð· Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ñ… Ñ†ÐµÐ½Ñ‚Ñ€Ð¾Ð²',0),(600872,16639,'ru','ÐÐ²Ñ‚Ð¾Ð¼Ð°Ñ‚Ð¸Ñ‡ÐµÑÐºÐ¸ Ð²Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³ Ð½Ð° Ð¿Ñ€Ð¾Ð´Ð°Ð¶Ñƒ Ð¾Ñ‚ ÑÑƒÐ´Ð½Ð° Ð´Ð¾ Ð¸ÑÐ¿Ð¾Ð»Ð½ÐµÐ½Ð¸Ñ Ð¸ POS Ð·Ð°ÐºÐ°Ð·Ð¾Ð²',0),(600873,16640,'ru','ÐžÐºÐ¾Ð½Ñ‡Ð°Ñ‚ÐµÐ»ÑŒÐ½Ð¾Ðµ Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ñ‚Ñ€ÐµÐ±ÑƒÐµÑ‚ Ð¡Ð¢Ð Ð£Ð§ÐšÐ',0),(600874,16641,'ru','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶Ð¸Ñ‚ÑŒ Ð°Ð»ÑŒÑ‚ÐµÑ€Ð½Ð°Ñ‚Ð¸Ð²Ð½Ñ‹Ðµ Ð¿Ð¾ÐºÑƒÐ¿ÐºÐ¸ Ð¼ÐµÑÑ‚Ð°Ñ…, ÐºÐ¾Ð³Ð´Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð½Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾',0),(600875,16642,'ru','ÐžÑÐ²Ð¾Ð±Ð¾Ð¶Ð´ÐµÐ½Ð¸Ðµ Ð¾Ñ‚ Ð½Ð°Ð»Ð¾Ð³Ð¾Ð² Ñ‡Ð°ÑÑ‚Ð¸Ñ‡Ð½Ð¾Ðµ',0),(600876,16643,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ð°Ñ ÑÑ‚Ð°Ð²ÐºÐ° %',0),(600877,16644,'ru','Ð Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»Ð¸Ñ‚ÐµÐ»ÑŒÐ½Ñ‹Ð¹ Ñ†ÐµÐ½Ñ‚Ñ€ Num Ð¼ÐµÑÑÑ†ÐµÐ² Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð° Reorder',0),(600878,16645,'ru','ÐœÐµÐ¶Ñ„Ð¸Ð»Ð¸Ð°Ð»ÑŒÐ½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸ Ð½Ð°Ð³Ñ€ÑƒÐ·ÐºÐ¸ Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ñ‚ GL ÑÑ‡ÐµÑ‚Ð°',0),(600879,16646,'ru','Ð’Ð½ÑƒÑ‚Ñ€Ð¸Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð½Ñ‹Ðµ Ð¿ÑƒÐ½ÐºÑ‚ Ð¿ÐµÑ€ÐµÐ´Ð°Ñ‡Ð¸ - Ñ€Ð°Ð·Ñ€ÐµÑˆÐ¸Ñ‚ÑŒ Ð½ÐµÑÐºÐ¾Ð»ÑŒÐºÐ¾ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ð¹',0),(600880,16647,'ru','Ð’Ð½ÑƒÑ‚Ñ€Ð¸Ñ„Ð¸Ñ€Ð¼ÐµÐ½Ð½Ñ‹Ðµ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ñ‹ Ð¿ÑƒÐ½ÐºÑ‚ - Ð¿Ñ€Ð¾Ð²Ð¾Ð´ÐºÐ°',0),(600881,16648,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð² Ñ‚Ñ€Ð°Ð½Ð·Ð¸Ñ‚Ð½Ñ‹Ð¹ ÑÑ‡ÐµÑ‚ GL',0),(600882,16649,'ru','Non Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑŒÑŽÑ‚Ð¾Ñ€ÑÐºÐ¸Ð¹ Ñ†ÐµÐ½Ñ‚Ñ€ Num Ð¼ÐµÑÑÑ†ÐµÐ² Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ Ñ€Ð°ÑÑ‡ÐµÑ‚Ð° Reorder',0),(600883,16650,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ Ð¿Ð¾ Ð»Ð¸Ð½Ð¸Ð¸',0),(600884,16651,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ, Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° Ð¸ Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ðµ',0),(600885,16652,'ru','B2B Ð»Ð¾Ð³Ð¸Ð½ Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»Ñ',0),(600886,16653,'ru','Ð’Ð¾Ð¹Ð´Ð¸Ñ‚Ðµ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ ÐºÐ°Ðº Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ',0),(600887,16654,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ ÐºÐ°Ðº Ð¿Ð¾Ð»Ð½Ñ‹Ð¹',0),(600888,16655,'ru','ÐÐµ POD Ñ„Ð°Ð¹Ð», Ð¿Ñ€Ð¸ÐºÑ€ÐµÐ¿Ð»ÐµÐ½Ð½Ñ‹Ð¹ Ðº Ð¿Ð¾Ñ€ÑÐ´ÐºÑƒ',0),(600889,16656,'ru','ÐŸÐ°Ð´ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»Ñ',0),(600890,16657,'ru','ÐÑ€Ñ…Ð¸Ð² & ÑÐ¾Ñ…Ñ€Ð°Ð½Ð¸Ñ‚ÑŒ',0),(600891,16658,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ð¾ Ð¿Ð¾ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ð´Ð°',0),(600892,16659,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ð¾ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸ GL',0),(600893,16660,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¿Ð¾ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚Ð¸ ÐºÐ¾Ð´Ð°',0),(600894,16661,'ru','Ð—Ð°ÐºÑ€Ñ‹Ñ‚Ð¸Ðµ ÑÑ‡ÐµÑ‚Ð¾Ð² Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸ÑÐ¼ GL',0),(600895,16662,'ru','Ð”Ð°Ñ‚Ð° Ð¾Ñ‚Ð¼ÐµÐ½Ñ‹',0),(600896,16663,'ru','13-Ð¾Ð³Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð²ÑÑ‚ÑƒÐ¿Ð»ÐµÐ½Ð¸Ñ',0),(600897,16664,'ru','Ð ÐµÐ³ÑƒÐ»Ð¸Ñ€Ð¾Ð²Ð¾Ñ‡Ð½Ñ‹Ñ… Ð½Ð°Ð»Ð¾Ð³',0),(600898,16665,'ru','Ð“Ð¾Ð´ Ð¾ÐºÐ¾Ð½Ñ‡Ð°Ð½Ð¸Ñ Ñ€ÐµÐ³ÑƒÐ»Ð¸Ñ€ÑƒÑ Ð·Ð°Ð¿Ð¸ÑÑŒ',0),(600899,16666,'ru','13-Ð¾Ð³Ð¾ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð° Ð·Ð°Ð¿Ð¸ÑÐ¸',0),(600900,16667,'ru','ÐÐ°Ð»Ð¾Ð³Ð¾Ð²Ñ‹Ðµ ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€Ð¾Ð²ÐºÐ¸',0),(600901,16668,'ru','Ð¡ ÐºÐ¾Ð½Ñ†Ð° Ð³Ð¾Ð´Ð° ÐºÐ¾Ñ€Ñ€ÐµÐºÑ‚Ð¸Ñ€ÑƒÑŽÑ‰Ð¸Ñ… Ð·Ð°Ð¿Ð¸ÑÐµÐ¹',0),(600902,16669,'ru','ÐÐµ ÑÐºÐ»Ð°Ð´Ðµ',0),(600903,16670,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ð¾Ð±ÑÐ·Ð°Ð½Ð½Ð¾ÑÑ‚Ð¸',0),(600904,16671,'ru','Ð”Ñ€ÑƒÐ³Ð¸Ðµ Ñ€Ð°ÑÑ…Ð¾Ð´Ñ‹',0),(600905,16672,'ru','ÐŸÐµÑ€ÐµÐ´Ð°Ñ‡Ð° Ð¼ÐµÐ¶Ð´Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸ÑÐ¼Ð¸',0),(600906,16673,'ru','Ð”ÐµÑ‚Ð°Ð»Ð¸ Ð¿ÐµÑ€ÐµÐ²Ð¾Ð´Ð°',0),(600907,16674,'ru','ÐÐµ Ð·Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð½Ñ‹Ð¹',0),(600908,16675,'ru','ÐÑ€ÐµÐ½Ð´Ð°',0),(600909,16676,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½ÐµÐ½Ð½Ñ‹Ð¹',0),(600910,16677,'ru','0 Ð½ÐµÑ‚ ÐœÐ°ÐºÑ.',0),(600911,16678,'ru','0 Ð½ÐµÑ‚ Ð¼Ð¸Ð½',0),(600912,16679,'ru','AVG Qty Ð² Ð¼ÐµÑÑÑ†',0),(600913,16680,'ru','Ð—Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ ÑÐ¾Ð·Ð´Ð°Ð½',0),(600914,16681,'ru','Ð¡Ð¾Ð·Ð´Ð°Ñ‚ÑŒ Ð·Ð°ÐºÐ°Ð· Ð½Ð° Ð¿Ð¾ÐºÑƒÐ¿ÐºÑƒ',0),(600915,16682,'ru','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑŒÑŽÑ‚Ð¾Ñ€ÑÐºÐ¸Ðµ Ñ†ÐµÐ½Ñ‚Ñ€Ñ‹',0),(600916,16683,'ru','Ð˜Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ñ Ð¼ÐµÑÑ‚',0),(600917,16684,'ru','ÐœÐ°ÐºÑ Ð½Ð° ÑÑ‚Ð¾Ñ€Ð¾Ð½Ñ‹',0),(600918,16685,'ru','Min Ð½Ð° Ñ€ÑƒÐºÐµ',0),(600919,16686,'ru','ÐœÐ¾Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸',0),(600920,16687,'ru','Num Ð¼ÐµÑÑÑ†ÐµÐ² Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ Ð¼Ð°ÐºÑÐ¸Ð¼ÑƒÐ¼Ð° Ð½Ð° Ñ€ÑƒÐºÐµ',0),(600921,16688,'ru','Num Ð¼ÐµÑÑÑ†ÐµÐ² Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð¼Ð¸Ð½Ð¸Ð¼ÑƒÐ¼ Ð½Ð° Ñ€ÑƒÐºÐµ',0),(600922,16689,'ru','Num Ð¼ÐµÑÑÑ†ÐµÐ² Ð¿Ñ€Ð¾Ð´Ð°Ð¶ Ð´Ð»Ñ Ð¿Ð¾Ð²Ñ‚Ð¾Ñ€Ð½Ð¾Ð³Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð°',0),(600923,16690,'ru','Ð¯Ð²Ð»ÑÐµÑ‚ÑÑ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¾Ð¼ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ?',0),(600924,16691,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð´Ð½ÐµÐ¹',0),(600925,16692,'ru','Ð¦Ð¸Ñ‚Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒ Ð²Ñ€ÐµÐ¼Ñ',0),(600926,16693,'ru','Ð£ÑÑ‚Ð°Ð½Ð¾Ð²ÐºÐ° ÑÑ‚Ð¾Ð³Ð¾ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ° Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð° Ð±ÑƒÐ´ÐµÑ‚ ÑƒÐ´Ð°Ð»Ð¸Ñ‚ÑŒ Ð»ÑŽÐ±Ñ‹Ðµ Ð´Ñ€ÑƒÐ³Ð¸Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ‰Ð¸ÐºÐ¸ Ð¿Ð¾ ÑƒÐ¼Ð¾Ð»Ñ‡Ð°Ð½Ð¸ÑŽ Ð´Ð»Ñ ÑÑ‚Ð¾Ð³Ð¾ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ð°',0),(600927,16694,'ru','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ‰Ð¸Ðº UPC',0),(600928,16695,'ru','RTV Ð½Ð¾Ð¼ÐµÑ€',0),(600929,16696,'ru','ÐÐ°Ð·Ð°Ð´ Ð·Ð°ÐºÐ°Ð·Ð°Ñ‚ÑŒ',0),(600930,16697,'ru','ÐÐµ ÑƒÐ´Ð°ÐµÑ‚ÑÑ Ð¸Ð·Ð¼ÐµÐ½Ð¸Ñ‚ÑŒ ÑÑ‚Ð¾Ñ‚ Ð¿Ð¾Ñ€ÑÐ´Ð¾Ðº, Ñ‡Ñ‚Ð¾Ð±Ñ‹ Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ',0),(600931,16698,'ru','Ð¢ÐµÐºÑƒÑ‰ÐµÐµ Ð¼ÐµÑÑ‚Ð¾Ð¿Ð¾Ð»Ð¾Ð¶ÐµÐ½Ð¸Ðµ',0),(600932,16699,'ru','Ð—Ð°ÐºÐ°Ð· Ð¸Ð¼ÐµÐµÑ‚ Ð¿Ð¾ÑÑ‚Ð°Ð²ÐºÐ¸ Ñ‚Ð¾Ð²Ð°Ñ€Ð¾Ð² Ð½Ðµ Ð¿Ð°Ð´ÐµÐ½Ð¸Ðµ ÐºÐ¾Ñ€Ð°Ð±Ð»Ñ',0),(600933,16700,'ru','ÐšÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð°ÐºÐ°Ð·Ð° Ð½ÐµÐ´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð¾ Ð½Ð° Ð¼ÐµÑÑ‚Ðµ',0),(600934,16701,'ru','Ð£Ð¼ÐµÐ½ÑŒÑˆÐ¸Ñ‚ÑŒ ÐºÐ¾Ð»Ð¸Ñ‡ÐµÑÑ‚Ð²Ð¾ Ð·Ð°ÐºÐ°Ð·Ð°',0),(600935,16702,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰Ð¸Ðµ ÑÐ»ÐµÐ¼ÐµÐ½Ñ‚Ñ‹ Non-Drop ÐºÐ¾Ñ€Ð°Ð±Ð»ÑŒ Ð¸Ð·Ð²Ð»ÐµÑ‡ÑŒÑÑ',0),(600936,16703,'ru','Ð’Ð°ÑƒÑ‡ÐµÑ€ ID',0),(600937,16704,'ru','ÐŸÐµÑ€Ð²Ð¸Ñ‡Ð½Ñ‹Ð¹ Ð¿Ð¾ÐºÑƒÐ¿Ð°Ñ‚ÐµÐ»ÑŒ',0),(600938,16705,'ru','Ð•ÑÐ»Ð¸ Ð³Ñ€Ð°Ñ„ÑÑ‚Ð²Ð¾ Ð½Ðµ Ð½Ð° ÑÐ¿Ð¸ÑÐºÐµ',0),(600939,16706,'ru','Ð”ÐµÐ¹ÑÑ‚Ð²Ð¸Ðµ Ð¾Ð±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ñ',0),(600940,16707,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ Ð·Ð°Ñ‚Ñ€Ð°Ñ‚ ÐºÐ¾Ð´Ð¾Ð², ÐµÑÐ»Ð¸ ÑÑ‡ÐµÑ‚ GL Ð¸Ð¼ÐµÐµÑ‚ ÑÑ‚Ð¾Ð¸Ð¼Ð¾ÑÑ‚ÑŒ ÐºÐ¾Ð´Ñ‹',0),(600941,16708,'ru','Ð¢Ñ€ÐµÐ±ÑƒÐµÑ‚ÑÑ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ GL, ÐµÑÐ»Ð¸ ÑƒÑ‡ÐµÑ‚Ð½Ð°Ñ Ð·Ð°Ð¿Ð¸ÑÑŒ GL GL ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ð¸',0),(600942,16709,'ru','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑŒÑŽÑ‚Ð¾Ñ€ÑÐºÐ¸Ð¹ Ñ†ÐµÐ½Ñ‚Ñ€',0),(600943,16710,'ru','Ð¯Ð²Ð»ÑÐµÑ‚ÑÑ Ð»Ð¸ Ñ†ÐµÐ½Ñ‚Ñ€ Ñ€Ð°ÑÐ¿Ñ€ÐµÐ´ÐµÐ»ÐµÐ½Ð¸Ñ?',0),(600944,16711,'ru','ÐŸÑ€Ð¾Ð²ÐµÑ€ÐµÐ½Ð¾',0),(600945,16712,'ru','Ð—Ð°Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€ÑƒÐ¹ÑÑ',0),(600946,16713,'ru','Ð—Ð°Ñ€ÐµÐ³Ð¸ÑÑ‚Ñ€Ð¸Ñ€Ð¾Ð²Ð°Ñ‚ÑŒÑÑ ÑÐµÐ¹Ñ‡Ð°Ñ',0),(600947,16714,'ru','Ð’Ñ€ÐµÐ¼Ñ Ð·Ð°ÐµÐ·Ð´Ð°',0),(600948,16715,'ru','Ð¡Ð¾Ñ…Ñ€Ð°Ð½ÐµÐ½Ð¸Ðµ Ð·Ð°Ð¼ÐµÑ‚Ð¾Ðº',0),(600949,16716,'ru','ÐžÐ±Ð½Ð¾Ð²Ð»ÐµÐ½Ð¸Ðµ Ð¿Ñ€Ð¸Ð¼ÐµÑ‡Ð°Ð½Ð¸Ñ',0),(600950,16717,'ru','ÐÐµ ÑƒÐ´Ð°Ð»Ð¾ÑÑŒ Ð½Ð°Ð¹Ñ‚Ð¸ ÑƒÑ‡ÐµÑ‚Ð½ÑƒÑŽ Ð·Ð°Ð¿Ð¸ÑÑŒ GL Ð¿Ð¾ Ð¸Ð¼ÐµÐ½Ð¸',0),(600951,16718,'ru','ÐŸÐ°Ñ†Ð¸ÐµÐ½Ñ‚Ð° Ð¸Ð¼Ð¿Ð¾Ñ€Ñ‚',0),(600952,16719,'ru','Ð—Ð°Ð¿Ð¾Ð»Ð½Ð¸Ñ‚ÑŒ Ð´ÐµÐ½ÑŒ',0),(600953,16720,'ru','ÐŸÐ¾ÑÐ»ÐµÐ´Ð½ÐµÐµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(600954,16721,'ru','ÐŸÐ¾Ð¶Ð°Ð»ÑƒÐ¹ÑÑ‚Ð°, 777 chmod',0),(600955,16722,'ru','Ð’ÑÐµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(600956,16723,'ru','ÐšÐ½Ð¸Ð³Ð° ÑÑ‚Ð¾ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(600957,16724,'ru','ÐšÐ¾Ð¼Ð°Ð½Ð´Ð° Ð½Ðµ Ð½Ð°Ð¹Ð´ÐµÐ½Ð°',0),(600958,16725,'ru','ÐŸÐ¾Ð´Ñ‚Ð²ÐµÑ€Ð´Ð¸Ñ‚Ðµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ Ð²Ñ€ÐµÐ¼ÐµÐ½Ð¸',0),(600959,16726,'ru','ÐÐµ Ð²ÐºÐ»ÑŽÑ‡ÐµÐ½Ð° Ñ„ÑƒÐ½ÐºÑ†Ð¸Ñ',0),(600960,16727,'ru','Ð¡Ð»ÐµÐ´ÑƒÑŽÑ‰ÐµÐµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ðµ',0),(600961,16728,'ru','ÐÐµÑ‚ Ð¿Ñ€ÐµÐ´ÑÑ‚Ð¾ÑÑ‰Ð¸Ñ… Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ',0),(600962,16729,'ru','ÐžÑ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ðµ Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ñ Ð´Ð»Ñ',0),(600963,16730,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ñƒ Ð´Ð»Ñ Ð¿Ñ€Ð¾ÑÐ¼Ð¾Ñ‚Ñ€Ð° Ð¾Ñ‚ÐºÑ€Ñ‹Ñ‚Ñ‹Ñ… Ð½Ð°Ð·Ð½Ð°Ñ‡ÐµÐ½Ð¸Ð¹',0),(600964,16731,'ru','Ð“Ð´Ðµ',0),(600965,16732,'ru','ÐŸÐ»Ð°Ð½Ð¸Ñ€Ð¾Ð²Ð°Ð½Ð¸Ðµ Ð²ÑÑ‚Ñ€ÐµÑ‡Ð¸',0),(600966,16733,'ru','Ð’Ñ‹Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚Ñƒ',0),(600967,16734,'ru','Ð¢Ð¸Ð¿ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(600968,16735,'ru','Ð¢Ð¸Ð¿ Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸ Ð¿Ð¾ ÑÑ‚Ð¾Ð¼Ñƒ ÐºÐ¾Ð´Ñƒ ÑƒÐ¶Ðµ ÑÑƒÑ‰ÐµÑÑ‚Ð²ÑƒÐµÑ‚',0),(600969,16736,'ru','ÐÐµÐ¾Ð±Ñ…Ð¾Ð´Ð¸Ð¼Ð¾ Ð·Ð°Ð´Ð°Ñ‚ÑŒ ÐºÐ¾Ð´ Ñ‚Ð¸Ð¿Ð° Ð·Ð°Ð¿Ñ€Ð¾ÑÐ° Ð½Ð°ÑÑ‚Ñ€Ð¾Ð¹ÐºÐ¸ Ð¸Ð½Ð²ÐµÐ½Ñ‚Ð°Ñ€Ð¸Ð·Ð°Ñ†Ð¸Ð¸',0),(600970,16737,'ru','Ð¡Ð¾Ð¾Ð±Ñ‰ÐµÐ½Ð¸Ðµ, Ð”Ð¾ÑÑ‚Ð°Ð²ÐºÐ° & Ð¿Ð¾Ð»ÑƒÑ‡ÐµÐ½Ð¸Ðµ',0),(600971,16738,'ru','Ð’Ð¾Ð¹Ð´Ð¸Ñ‚Ðµ Ð² ÑÐ¸ÑÑ‚ÐµÐ¼Ñƒ ÐºÐ°Ðº Ð¿Ð¾Ð»ÑŒÐ·Ð¾Ð²Ð°Ñ‚ÐµÐ»ÑŒ',0),(600972,16739,'ru','Ð’ÐºÐ»ÑŽÑ‡Ð¸Ñ‚ÑŒ ÐºÐ°Ð²Ñ‹Ñ‡ÐºÐ¸',0),(600973,16503,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ñ‡Ð¸Ñ‚Ð°Ñ‚Ð¸ Ð·Ð°Ð¿Ð¸Ñ',0),(600974,16504,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð´Ð¾Ð´Ð°Ñ‚Ð¸',0),(600975,16505,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ð¸',0),(600976,16506,'sr','ÐžÐ±Ñ€Ð°Ð·Ð°Ñ† Ð½Ð¸Ñ˜Ðµ Ð´Ð¾Ð²Ñ€ÑˆÐµÐ½Ð¾',0),(600977,16507,'sr','ÐÐµ Ð¼Ð¾Ð¶Ðµ Ð´Ð° Ñ‡Ð¸Ñ‚Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÑƒ',0),(600978,16508,'sr','ÐŸÑ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ð° Ð¿Ð¾Ñ™Ð° Ð´Ð¾Ð´Ð°Ñ‚Ð°Ðº Ð¿Ð¾Ñ‚Ñ€ÐµÐ±Ð°Ð½',0),(600979,16509,'sr','Ð¢ÐµÑ€ÐµÑ‚Ð½Ð¸ Ñ‚ÐµÑ€ÐµÑ‚',0),(600980,16510,'sr','Ð¢ÐµÑ€ÐµÑ‚Ð½Ð¸ Ñ‚ÐµÑ€ÐµÑ‚',0),(600981,16511,'sr','Ð£ÐºÑ™ÑƒÑ‡Ð¸ ÐºÑ€Ð°Ñ˜Ð° Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(600982,16512,'sr','Ð’Ñ€ÑÑ‚Ð° Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(600983,16513,'sr','Ð’Ñ€ÑÑ‚Ð° Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¾Ð²Ð° Ð¨Ð¸Ñ„Ñ€Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(600984,16514,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð²Ñ€ÑÑ‚Ðµ Ð·Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°.',0),(600985,16515,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€',0),(600986,16516,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¼ÐµÑ’ÑƒÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜ÑÐºÐ¸Ñ… Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€ Ð¿Ð¾Ð¼Ð°ÐºÐ° Ð½Ð°Ð»Ð¾Ð³ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°.',0),(600987,16517,'sr','ÐœÐµÑ’ÑƒÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜ÑÐºÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€ - ÐŸÑ€Ð¸Ð½Ñ‚',0),(600988,16518,'sr','Ð“Ð› ÐºÐ¾Ð½Ñ‚Ð¾ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð´Ð¾Ð´ÐµÑ™ÐµÐ½ Ð½Ð° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð¸Ð»Ð¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð½Ð°Ð»Ð¾Ð³ Ð´Ð¾Ð´ÐµÑ™ÐµÐ½ Ñƒ Ð¿Ñ€Ð¾Ð·Ð¾Ñ€Ñƒ ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(600989,16519,'sr','ÐÐ£Ðœ Ð¼ÐµÑÐµÑ†Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐµ ÐšÐ¾Ð».',0),(600990,16520,'sr','ÐÐ£Ðœ Ð¼ÐµÑÐµÑ†Ð¸ Ð·Ð° Ð´Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ',0),(600991,16521,'sr','Ð”Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(600992,16522,'sr','Ð”Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐ° Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸',0),(600993,16523,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ ÑÐ¿Ð°ÑÐ¸Ð¾',0),(600994,16524,'sr','ÐŸÑ€Ð¸Ñ…Ð²Ð°Ñ›ÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(600995,16525,'sr','Ð’Ñ€ÑÑ‚Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ',0),(600996,16526,'sr','Ð”Ð¾Ð´ÐµÑ™ÐµÐ½',0),(600997,16527,'sr','Ð”Ð¾Ð´ÐµÑ™ÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(600998,16528,'sr','Ð‘Ñ€Ð¾Ñ˜Ð°Ð¾',0),(600999,16529,'sr','Ð“Ñ€Ð¾Ñ„ Ñ‚Ð¸Ð¿',0),(601000,16530,'sr','Ð”Ð¾Ð´ÐµÑ™ÐµÐ½Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼',0),(601001,16531,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐµ Ð±Ñ€Ð¾Ñ˜Ð°Ð¾',0),(601002,16532,'sr','ÐŸÐ¾ÑÐ»ÐµÐ´ÑšÐ¸ Ð¿ÑƒÑ‚ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½Ð¾ Ð¾Ð´ ÑÑ‚Ñ€Ð°Ð½Ðµ',0),(601003,16533,'sr','ÐŸÐ¾ÑÑ‚Ð¾ Ñ˜Ðµ Ð±Ñ€Ð¾Ñ˜Ð°Ð¾',0),(601004,16534,'sr','Ð’Ñ€ÑÑ‚Ð° Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°',0),(601005,16535,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ ÐŸÑ€Ð¾Ð²ÐµÑ€Ð° Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°',0),(601006,16536,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð°Ñ…Ñ‚Ñ˜ÐµÐ²Ðµ',0),(601007,16537,'sr','Ð‘ÐµÑ€Ð·Ð°Ð½ÑÐºÐ¸ Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð·Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° Ð¡Ñ‚Ð°Ñ‚ÑƒÑ',0),(601008,16538,'sr','Ð’Ð°Ñ€Ð¸Ñ˜Ð°Ð½ÑÐ° Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð Ð•Ð¤. Ð’Ð°Ð».',0),(601009,16539,'sr','ÐŸÑ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ñ€Ð°Ð·Ð»Ð¸ÐºÐµ',0),(601010,16540,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ /ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð¾ÐºÑ€ÑƒÐ³',0),(601011,16541,'sr','Ð¡Ð°ÑÑ‚Ð°Ð½Ð°Ðº Ð¿Ð»Ð°Ð½ÐµÑ€',0),(601012,16542,'sr','Ð“Ñ€Ð¾Ñ„ ÑƒÐ¿Ñ€Ð°Ð²Ñ™Ð°ÑšÐ°',0),(601013,16543,'sr','Ð£Ð²Ð¾Ð· Ð¸Ð½Ñ„Ð¾Ñ€Ð¼Ð°Ñ†Ð¸Ñ˜Ð° Ð¾ ÐºÑƒÐ¿Ñ†Ñƒ',0),(601014,16544,'sr','Ð£Ð²Ð¾Ð· Ð¿Ñ€Ð¾Ð´Ð°Ð²Ð°Ñ† Ñ‚ÐµÑ€Ð¸Ñ‚Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(601015,16545,'sr','Ð£Ð²ÐµÑÑ‚Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(601016,16546,'sr','Ð£Ð²Ð¾Ð· Ð°Ñ€Ñ…Ð¸Ð²Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð°',0),(601017,16547,'sr','ÐœÐµÑ’ÑƒÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜ÑÐºÐµ Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€ Ð¿Ñ€ÐµÐ²Ð¾Ð·Ð° Ñ‚ÐµÑ€ÐµÑ‚Ð°',0),(601018,16548,'sr','Ð¢Ð¸Ð¿Ð¾Ð²Ð¸ Ð·Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(601019,16549,'sr','ÐÐ¾Ð²Ð¸ Ð¿Ð¾Ð·Ð¸Ð² Ð·Ð° Ð¿Ð¾Ñ‚Ð²Ñ€Ð´Ñƒ Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(601020,16550,'sr','ÐŸÑ€Ð¸Ð¿Ñ€ÐµÐ¼Ð½Ð¾Ð³ Ð¿Ð¾Ð´Ñ€ÑƒÑ‡Ñ˜Ð°',0),(601021,16551,'sr','ÐŸÑ€Ð¸Ð¿Ñ€ÐµÐ¼Ð½Ð¾ Ð¿Ð¾Ð´Ñ€ÑƒÑ‡Ñ˜Ðµ',0),(601022,16552,'sr','Ð Ð°Ñ‡ÑƒÐ½Ð° ÑƒÐ¿Ð¸ÑˆÐ¸Ñ‚Ðµ Ð¿Ð¾Ð³Ñ€ÐµÑˆÐ½Ð¾',0),(601023,16553,'sr','Ð“Ñ€Ð¾Ñ„ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°ÑˆÐ°Ð¾ Ð½Ð°Ð»Ð¾Ð³ Ð¿Ð¾ Ð¸Ð¼ÐµÐ½Ñƒ',0),(601024,16554,'sr','Ð“Ñ€Ð¾Ñ„ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°ÑˆÐ°Ð¾ Ñ‚ÐµÐºÑƒÑ›Ð¸ Ñ€Ð°Ñ‡ÑƒÐ½ Ð¿Ð¾ Ð¸Ð¼ÐµÐ½Ñƒ',0),(601025,16555,'sr','Ð“Ñ€Ð¾Ñ„ Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°ÑˆÐ°Ð¾ Ð½Ð°Ñ‡Ð¸Ð½ Ð¿Ð¾ Ð¸Ð¼ÐµÐ½Ñƒ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ',0),(601026,16556,'sr','ÐŸÐ¾Ð´ÑƒÐ´Ð°Ñ€Ð°ÑšÐ° ÐœÑƒÐ»Ð¸Ð¿Ð»Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(601027,16557,'sr','ÐŸÐ¾ÑˆÑ‚Ð°Ð½ÑÐºÐ¸ Ð±Ñ€Ð¾Ñ˜ Ð¸Ð»Ð¸ ÑÑ‚Ð°ÑšÐµ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð°',0),(601028,16558,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ† Ð˜Ð”',0),(601029,16559,'sr','ÐŸÑ€Ð¾Ð´Ð°Ð²Ð°Ñ† Ð˜Ð” Ð¸Ð»Ð¸ Ð¸Ð¼Ðµ Ð¼Ð¾Ñ€Ð° Ð´Ð° Ð±ÑƒÐ´Ðµ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(601030,16560,'sr','Ð¨Ð¸Ñ„Ñ€Ð° ÑÑ‚Ð°ÑšÐ°',0),(601031,16561,'sr','Ð˜Ð¼Ðµ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜Ðµ Ð¸Ð»Ð¸ Ð¿Ñ€ÐµÐ·Ð¸Ð¼Ðµ Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½',0),(601032,16562,'sr','Ð‘Ð°Ð½ÐºÐ¾Ð²Ð½Ð¸ Ð±Ñ€Ð¾Ñ˜',0),(601033,16563,'sr','ÐŸÐ¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð¼ÐµÑ‚Ð¾Ð´ Ð¿Ð»Ð°Ñ‚Ðµ',0),(601034,16564,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° Ð¼Ð¾Ñ€Ð°Ñ˜Ñƒ Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð¸',0),(601035,16565,'sr','ÐŸÑ€Ð°Ð·Ð°Ð½',0),(601036,16566,'sr','ÐÐµÐ¼Ð° Ñ‚Ð¸Ð¿ Ð¡ÐµÑ‚',0),(601037,16567,'sr','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ Ñ€ÐµÐ·ÐµÑ€Ð²Ð¸ÑÐ°Ð¾',0),(601038,16568,'sr','ÐžÑ‚Ð²Ð¾Ñ€Ð¸ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(601039,16569,'sr','ÐžÐ±Ð°Ð²ÐµÐ·Ð° Ð´Ð°Ð½Ð°Ñ',0),(601040,16570,'sr','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ ÑƒÐºÑƒÐ¿Ð½Ð¾',0),(601041,16571,'sr','Ð”ÑƒÐ¶Ð¸Ð½Ð° Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(601042,16572,'sr','Ð˜Ð¼ÐµÐ½Ð¾Ð²Ð°ÑšÐµ Ð»Ð¸ÑÑ‚Ðµ Ð·Ð°',0),(601043,16573,'sr','Ð˜Ð¼ÐµÐ½Ð¾Ð²Ð°ÑšÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ',0),(601044,16574,'sr','Ð—Ð°ÐºÐ°Ð·Ð°Ð½Ð° Ð¾Ð±Ð°Ð²ÐµÐ·Ð° Ð¸Ð¼Ðµ',0),(601045,16575,'sr','Ð ÐµÐ·Ð¸Ð¼Ðµ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(601046,16576,'sr','Ð‘2Ð‘ ÑÐ°ÑÑ‚Ð°Ð½Ð°Ðº Ð¿Ð»Ð°Ð½ÐµÑ€',0),(601047,16577,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ Ð¾Ñ‚Ð²Ð°Ñ€Ð°ÑšÐ°',0),(601048,16578,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ ÑÐ°ÑÑ‚Ð°Ð½Ð°Ðº',0),(601049,16579,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ ÑÐ°ÑÑ‚Ð°Ð½Ð°Ðº Ð·Ð° Ð±ÑƒÐ´ÑƒÑ›Ðµ',0),(601050,16580,'sr','ÐžÐ´Ð°Ð±ÐµÑ€Ð¸ Ð´Ð°Ñ‚ÑƒÐ¼ Ð·Ð° Ð¿Ñ€Ð¸ÐºÐ°Ð· Ð¸ ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(601051,16581,'sr','ÐŸÑ€Ð¸ÐºÐ°Ð¶Ð¸ Ñ€ÐµÐ·Ð¸Ð¼Ðµ',0),(601052,16582,'sr','Ð£Ð½Ð±Ð¾Ð¾Ðº ÑÐ°ÑÑ‚Ð°Ð½Ð°Ðº',0),(601053,16583,'sr','Ð”Ð¾Ð´Ð°Ñ˜ Ð½Ð¾Ð²Ð¸ Ð¾ÐºÑ€ÑƒÐ³',0),(601054,16584,'sr','Ð˜Ð¼Ðµ Ð¾ÐºÑ€ÑƒÐ³Ð°',0),(601055,16585,'sr','ÐÐ°Ð´Ñ€ÐµÑ’ÐµÐ½Ð¸ Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸',0),(601056,16586,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° ÑƒÐ½ÐµÑÐµÑ‚Ðµ Ð¸Ð¼Ðµ Ð¾ÐºÑ€ÑƒÐ³Ð°',0),(601057,16587,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð°Ð±ÐµÑ€ÐµÑ‚Ðµ ÑÑ‚Ð°ÑšÐµ',0),(601058,16588,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð¸Ð·Ð±Ñ€Ð¸ÑˆÐµÑ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ð¾ÐºÑ€ÑƒÐ³?',0),(601059,16589,'sr','Ð˜Ð·Ð±Ñ€Ð¸ÑˆÐ¸ Ð¾ÐºÑ€ÑƒÐ³',0),(601060,16590,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’ÐµÐ½Ðµ Ð¾ÐºÑ€ÑƒÐ³',0),(601061,16591,'sr','Ð Ð°Ð·Ð¼Ð¸ÑÐ»Ð¸Ñ‚Ðµ Ð¾ Ð´Ð¾Ð´Ð°Ð²Ð°ÑšÑƒ Ð½Ð¾Ð²Ð¸Ñ… Ð¾ÐºÑ€ÑƒÐ³',0),(601062,16592,'sr','Ð£Ñ€ÐµÐ´Ð¸ Ð¾ÐºÑ€ÑƒÐ³',0),(601063,16593,'sr','Ð¢Ð²Ð¾Ñ˜ Ð¸Ð·Ð±Ð¾Ñ€ Ñ˜Ðµ ÑÐ¸ÑÑ‚ÐµÐ¼ Ð²Ñ€ÐµÐ´Ð½Ð¾ÑÑ‚Ð¸ Ð¸ Ð¼Ð¾Ð³ÑƒÑ›Ð°',0),(601064,16594,'sr','ÐœÐ¾Ñ€Ð°Ñ‚Ðµ Ð¿Ð¾Ð¿ÑƒÐ½Ð¸Ñ‚Ð¸ Ð¾Ð±Ñ€Ð°Ð·Ð°Ñ† Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð½Ð°ÑÑ‚Ð°Ð²Ð¸Ð»Ð¸',0),(601065,16595,'sr','ÐšÑƒÐ¿Ñ†Ð¸ , Ð´Ð¾Ð´Ð°Ð¾ Ñ˜Ðµ',0),(601066,16596,'sr','ÐšÑƒÐ¿Ñ†Ð¸ Ð¿Ñ€ÐµÑÐºÐ¾Ñ‡ÐµÐ½Ð°',0),(601067,16597,'sr','ÐšÑƒÐ¿Ñ†Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(601068,16598,'sr','Ð ÐµÐ´Ð¾Ð²Ð¸ Ñ‡Ð¸Ñ‚Ð°ÑšÐµ',0),(601069,16599,'sr','ÐÐ»Ñ‚ÐµÑ€Ð½Ð°Ñ‚Ð¸Ð²Ð½Ð¸ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½ÑÐºÐ¸',0),(601070,16600,'sr','Ð¦Ð¡Ð’ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ° Ð·Ð° ÑƒÐ²Ð¾Ð·',0),(601071,16601,'sr','ÐžÐ¿ÐµÑ€Ð°Ñ‚ÐµÑ€Ð° Ð¼Ð¾Ð±Ð¸Ð»Ð½Ðµ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð¸Ñ˜Ðµ',0),(601072,16602,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð¼Ð¾Ð±Ð¸Ð»Ð½Ð¾Ð³ Ñ‚ÐµÐ»ÐµÑ„Ð¾Ð½Ð°',0),(601073,16603,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ ÑƒÑÐ»Ð¾Ð²Ðµ Ñ„Ð°ÐºÑ‚ÑƒÑ€Ñƒ',0),(601074,16604,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð½Ð¸ ÑÐºÑ€Ð°Ñ›ÐµÐ½Ð¸Ñ†Ð°',0),(601075,16605,'sr','ÐÐ´Ñ€ÐµÑÐ°',0),(601076,16606,'sr','Ð”Ð¾Ð´Ð°Ð²Ð°ÑšÐµ/ÑƒÑ€ÐµÑ’Ð¸Ð²Ð°ÑšÐµ',0),(601077,16607,'sr','ÐÐ²Ð³ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ð° Ð¼ÐµÑÐµÑ‡Ð½Ð¾',0),(601078,16608,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ðµ Ð·Ð°Ð»Ð¸Ñ…Ðµ',0),(601079,16609,'sr','Ð”Ð¾Ð´ÐµÑ™ÐµÐ½ Ð½ÐµÐ¼Ð° Ð¿Ñ€Ð¸Ð¼Ð°Ñ€Ð½Ð¸ Ñ€ÐµÐ³Ð°Ð»',0),(601080,16610,'sr','ÐšÐ¾Ð» Ð½Ð° Ð¢Ñ€Ð°Ð½ÑÑ„ÐµÑ€',0),(601081,16611,'sr','Ð”Ð¾Ð¿ÑƒÑšÐ°Ð²Ð°ÑšÐµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¸Ð· Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¸Ð²Ð½Ð¾Ð³ Ñ†ÐµÐ½Ñ‚Ñ€Ð°',0),(601082,16612,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶Ð¸Ð¾',0),(601083,16613,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ ÐšÐ¾Ð».',0),(601084,16614,'sr','Ð—Ð¾Ð½Ð°',0),(601085,16615,'sr','Ð“Ñ€Ð°Ð´Ð¾Ð²Ð¸ , Ð´Ð¾Ð´Ð°Ð¾ Ñ˜Ðµ',0),(601086,16616,'sr','Ð“Ñ€Ð°Ð´Ð¾Ð²Ð¸ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(601087,16617,'sr','Ð–ÑƒÐ¿Ð°Ð½Ð¸Ñ˜Ð° Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð¾',0),(601088,16618,'sr','Ð–ÑƒÐ¿Ð°Ð½Ð¸Ñ˜Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(601089,16619,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð° Ñ˜Ðµ Ð´Ð¾Ð´Ð°Ð¾',0),(601090,16620,'sr','Ð”Ñ€Ð¶Ð°Ð²Ð° Ñ˜Ðµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ð½',0),(601091,16621,'sr','Ð¡Ð¸Ð³ÑƒÑ€Ð½Ð¸ ÑÑ‚Ðµ Ð´Ð° Ð¶ÐµÐ»Ð¸Ñ‚Ðµ Ð´Ð° Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°Ñ‚Ðµ Ð²Ð°ÑˆÐµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð·Ð° Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚?',0),(601092,16622,'sr','Ð˜Ð¼Ðµ Ð³Ñ€Ð°Ð´Ð°',0),(601093,16623,'sr','ÐœÐ½Ð¾Ð¶Ð¸Ð»Ð°Ñ† Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ñƒ Ð³Ñ€Ð°Ð´Ñƒ',0),(601094,16624,'sr','Ð“Ñ€Ð°Ð´ ÐºÐ¾Ñ€Ð¸ÑÑ‚Ð¸ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð¼Ð½Ð¾Ð¶Ð¸Ð»Ð°Ñ†',0),(601095,16625,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ñƒ Ð¾ÐºÑ€ÑƒÐ³Ñƒ Ð¼Ð½Ð¾Ð¶Ð¸Ð»Ð°Ñ†',0),(601096,16626,'sr','ÐžÐºÑ€ÑƒÐ³ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ Ð¼Ð½Ð¾Ð¶Ð¸Ð»Ð°Ñ† Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(601097,16627,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ ÑƒÐ²Ð¾Ð·',0),(601098,16628,'sr','ÐœÐ½Ð¾Ð¶Ð¸Ð»Ð°Ñ† Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚',0),(601099,16629,'sr','ÐœÐ½Ð¾Ð¶Ð¸Ð»Ð°Ñ† Ð´Ñ€Ð¶Ð°Ð²Ð½Ð¸ ÑƒÐ¿Ð¾Ñ‚Ñ€ÐµÐ±Ñƒ Ð¿Ð¾Ñ€ÐµÐ·Ð°',0),(601100,16630,'sr','Ð¢Ð¾Ð¼ÑÐ¾Ð½ Ð Ð¾Ñ˜Ñ‚ÐµÑ€Ñ ÐºÐ°Ñ€Ñ‚Ð¸Ñ†Ð° Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐ°',0),(601101,16631,'sr','ÐŸÐ¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸ Ð¿Ð¾Ð´Ð°Ñ†Ð¸',0),(601102,16632,'sr','Ð¡Ðµ Ð·Ð°Ð´Ñ€Ð¶Ð°Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ',0),(601103,16633,'sr','ÐžÑ‡Ð¸ÑÑ‚Ð¸ ÑÐ²Ðµ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ',0),(601104,16634,'sr','ÐžÑ‡Ð¸ÑÑ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð¾Ñ˜ÐµÑ›Ðµ Ð¿Ð¾Ð´Ð°Ñ‚ÐºÐµ Ð·Ð° Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ Ñƒ ÑƒÐ²Ð¾Ð·Ñƒ',0),(601105,16635,'sr','ÐÐµÐ¾Ð±Ñ€Ð°Ñ’ÐµÐ½Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÐºÑ€ÐµÐ´Ð¸Ñ‚Ð°',0),(601106,16636,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¾ Ð¸Ð·Ð´Ð²Ð°Ñ˜Ð°ÑšÐµ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¸Ð· Ð±Ñ€Ð¾Ð´Ð° Ð´Ð°',0),(601107,16637,'sr','ÐÐ° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð¸ ÐŸÐžÐ¡ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(601108,16638,'sr','Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ ÑÐ°Ð¼Ð¾ Ð¸Ð· Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¸Ð²Ð½Ð¸Ñ… Ñ†ÐµÐ½Ñ‚Ð°Ñ€Ð°',0),(601109,16639,'sr','ÐÑƒÑ‚Ð¾Ð¼Ð°Ñ‚ÑÐºÐ¸ Ð¸Ð·Ð°Ð±ÐµÑ€Ð¸ Ð¿Ð¾Ñ€ÐµÐ· Ð½Ð° Ð¿Ñ€Ð¾Ð¼ÐµÑ‚ Ð¸Ð· Ð±Ñ€Ð¾Ð´Ð° Ð´Ð° Ð½Ð° Ð¸ÑÐ¿ÑƒÑšÐµÑšÐµ Ð¸ ÐŸÐžÐ¡ Ð½Ð°Ñ€ÐµÐ´Ð±Ðµ',0),(601110,16640,'sr','ÐšÐ¾Ð½Ð°Ñ‡Ð½Ð¾Ð¼ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ¾Ð¼ Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° ÐšÐÐŸÐ¡Ð£Ð›Ð£',0),(601111,16641,'sr','ÐŸÑ€ÐµÐ´Ð»Ð¾Ð¶Ð¸Ñ‚Ð¸ Ð°Ð»Ñ‚ÐµÑ€Ð½Ð°Ñ‚Ð¸Ð²Ð½Ðµ Ð½Ð°Ð±Ð°Ð²ÐºÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ ÐºÐ°Ð´Ð° ÐšÐ¾Ð» Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð°',0),(601112,16642,'sr','ÐžÐ´Ð±Ð¸Ñ˜ÐµÐ½Ð¾Ð³ Ð¿Ð¾Ñ€ÐµÐ·Ð° Ð´ÐµÐ»Ð¸Ð¼Ð¸Ñ‡Ð½Ð¾',0),(601113,16643,'sr','ÐŸÐ¾Ñ€ÐµÑÐºÐ° ÑÑ‚Ð¾Ð¿Ð° %',0),(601114,16644,'sr','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¸Ð²Ð½Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ ÐÑƒÐ¼ Ð¼ÐµÑÐµÑ†Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(601115,16645,'sr','Ð˜Ð½Ñ‚ÐµÑ€Ð±Ñ€Ð°Ð½Ñ†Ñ… Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ Ñ‚ÐµÑ€ÐµÑ‚Ð° Ð¿Ñ€Ð¾Ñ†ÐµÐ½Ð°Ñ‚ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(601116,16646,'sr','ÐœÐµÑ’ÑƒÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜ÑÐºÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸ - Ð”Ð¾Ð·Ð²Ð¾Ð»Ð¸ Ð²Ð¸ÑˆÐµ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(601117,16647,'sr','ÐœÐµÑ’ÑƒÐºÐ¾Ð¼Ð¿Ð°Ð½Ð¸Ñ˜ÑÐºÐµ ÑÑ‚Ð°Ð²ÐºÐµ Ñ‚Ñ€Ð°Ð½ÑÑ„ÐµÑ€Ð¸ - ÐºÑšÐ¸Ð¶ÐµÑšÐ°',0),(601118,16648,'sr','Ð—Ð°Ð»Ð¸Ñ…Ð° Ñƒ Ñ‚Ñ€Ð°Ð½Ð·Ð¸Ñ‚Ñƒ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½Ð°',0),(601119,16649,'sr','ÐÐ¾Ð½ -Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¸Ð²Ð½Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€ ÐÑƒÐ¼ Ð¼ÐµÑÐµÑ†Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° Ð¸Ð·Ñ€Ð°Ñ‡ÑƒÐ½Ð°Ð²Ð°ÑšÐµ Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(601120,16650,'sr','ÐŸÐ¾ÑÑ‚ Ð‘y Ñ€ÐµÐ´',0),(601121,16651,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶Ð¸ Ð´Ð¾ Ñ‚Ñ€Ð°Ð½ÑÐ¿Ð¾Ñ€Ñ‚Ð° Ð¸ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð°',0),(601122,16652,'sr','Ð‘2Ð‘ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð° ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(601123,16653,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ ÑÐµ ÐºÐ°Ð¾ Ð¾Ð²Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(601124,16654,'sr','ÐÐ¸Ñ˜Ðµ Ð¼Ð¾Ð³ÑƒÑ›Ðµ ÑÐ°Ñ‡ÑƒÐ²Ð°Ñ‚Ð¸ ÐºÐ°Ð¾ Ð¿Ð¾Ñ‚Ð¿ÑƒÐ½Ð¸ Ñ€ÐµÐ´',0),(601125,16655,'sr','ÐÐµÐ¼Ð° ÐšÐÐŸÐ¡Ð£Ð›Ð£ Ð´Ð°Ñ‚Ð¾Ñ‚ÐµÐºÐµ Ð¿Ñ€Ð¸Ð»Ð¾Ð¶ÐµÐ½Ðµ Ð½Ð°Ð»Ð¾Ð³Ð°',0),(601126,16656,'sr','Ð¡Ð¿ÑƒÑÑ‚Ð¸ Ð±Ñ€Ð¾Ð´',0),(601127,16657,'sr','ÐÑ€Ñ…Ð¸Ð²Ð¸Ñ€Ð°ÑšÐµ Ð¸ Ñ‡ÑƒÐ²Ð°ÑšÐµ',0),(601128,16658,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¾ ÑˆÐ¸Ñ„Ñ€Ð¾Ð¼ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(601129,16659,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸ Ð“Ð›',0),(601130,16660,'sr','Ð—Ð°Ñ‚Ð²Ð°Ñ€Ð°ÑšÐµ ÐºÐ¾Ð½Ñ‚Ð° Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÑˆÐ¸Ñ„Ñ€Ð¾Ð¼',0),(601131,16661,'sr','Ð—Ð°Ñ‚Ð²Ð¾Ñ€Ð¸ ÐÐ°Ð»Ð¾Ð·Ð¸ Ð¿Ð¾ ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ð¸ Ð“Ð›',0),(601132,16662,'sr','Ð¡Ð°ÑÑ‚Ð°Ð½Ð°Ðº Ñ˜Ðµ Ð¾Ñ‚ÐºÐ°Ð·Ð°Ð½',0),(601133,16663,'sr','13 ÑÑ‚Ð°Ð²ÐºÐ¾Ð¼ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(601134,16664,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° ÐºÐ¾Ñ€Ð¸Ð³Ð¾Ð²Ð°ÑšÐµ ÑƒÐ½Ð¾ÑÐ°',0),(601135,16665,'sr','Ð¡Ñ‚Ð°Ð²ÐºÐ° Ð·Ð° Ð¿Ñ€Ð¸Ð»Ð°Ð³Ð¾Ñ’Ð°Ð²Ð°ÑšÐµ ÐºÑ€Ð°Ñ˜ Ð³Ð¾Ð´Ð¸Ð½Ðµ',0),(601136,16666,'sr','13 ÑÑ‚Ð°Ð²ÐºÐµ Ð¿ÐµÑ€Ð¸Ð¾Ð´Ð°',0),(601137,16667,'sr','ÐŸÐ¾Ñ€ÐµÐ· Ð½Ð° ÐŸÐ¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(601138,16668,'sr','Ð¡Ð° ÐºÑ€Ð°Ñ˜Ð° Ð³Ð¾Ð´Ð¸Ð½Ðµ Ð¿Ð¾Ð´ÐµÑˆÐ°Ð²Ð°ÑšÐµ ÑÑ‚Ð°Ð²ÐºÐ¸',0),(601139,16669,'sr','ÐÐ¾Ð½-Ð°ÐºÑ†Ð¸Ñ˜Ðµ',0),(601140,16670,'sr','Ð”Ñ€ÑƒÐ³Ð¸Ñ… Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð°',0),(601141,16671,'sr','ÐžÑÑ‚Ð°Ð»Ðµ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ðµ',0),(601142,16672,'sr','ÐŸÑ€ÐµÐ½Ð¾Ñ Ð¸Ð·Ð¼ÐµÑ’Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð°',0),(601143,16673,'sr','Ð”ÐµÑ‚Ð°Ñ™Ð¸ Ð·Ð° Ð¿Ñ€ÐµÐ½Ð¾Ñ',0),(601144,16674,'sr','ÐšÐ¾Ñ˜Ð¸ Ð½Ð¸ÑÑƒ Ð¾Ð¿Ñ€ÐµÐ¼Ñ™ÐµÐ½Ð¸',0),(601145,16675,'sr','Ð˜Ð·Ð½Ð°Ñ˜Ð¼Ñ™Ð¸Ð²Ð°ÑšÐµ',0),(601146,16676,'sr','ÐÐ°Ð¿ÑƒÑšÐµÐ½',0),(601147,16677,'sr','0 Ð·Ð° Ð½ÐµÐ¼Ð° ÐœÐ°ÐºÑÐ°',0),(601148,16678,'sr','0 Ð½ÐµÐ¼Ð° Ð¼Ð¸Ð½',0),(601149,16679,'sr','ÐÐ²Ð³ ÐšÐ¾Ð» Ð¼ÐµÑÐµÑ‡Ð½Ð¾',0),(601150,16680,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°Ð½Ðµ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(601151,16681,'sr','ÐšÑ€ÐµÐ¸Ñ€Ð°ÑšÐµ Ð¸Ð·Ð»Ð°Ð·Ð½Ðµ Ð¿Ð¾Ñ€ÑƒÑŸÐ±Ð¸Ð½Ðµ',0),(601152,16682,'sr','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¸Ð²Ð½Ð¸ Ñ†ÐµÐ½Ñ‚Ñ€Ð¸',0),(601153,16683,'sr','Ð›Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(601154,16684,'sr','ÐœÐ°ÐºÑ Ð¿Ñ€Ð¸ Ñ€ÑƒÑ†Ð¸',0),(601155,16685,'sr','ÐœÐ¸Ð½ Ð½Ð° Ñ€ÑƒÑ†Ð¸',0),(601156,16686,'sr','ÐœÐ¾Ñ˜ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ',0),(601157,16687,'sr','ÐÐ£Ðœ Ð¼ÐµÑÐµÑ†Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° Ð¼Ð°ÐºÑÐ¸Ð¼ÑƒÐ¼ Ð½Ð° Ñ€ÑƒÑ†Ð¸',0),(601158,16688,'sr','ÐÐ£Ðœ Ð¼ÐµÑÐµÑ†Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° ÐœÐ¸Ð½Ð¸Ð¼ÑƒÐ¼ Ð½Ð° Ñ€ÑƒÑ†Ð¸',0),(601159,16689,'sr','ÐÐ£Ðœ Ð¼ÐµÑÐµÑ†Ð¸ Ð¿Ñ€Ð¾Ð´Ð°Ñ˜Ðµ Ð·Ð° ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð¿Ð¾Ñ€ÑƒÑ‡Ð¸Ð²Ð°ÑšÐ°',0),(601160,16690,'sr','Ð”Ð° Ð»Ð¸ Ñ˜Ðµ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð°Ñ€Ñ‚Ð¸ÐºÐ»Ð°?',0),(601161,16691,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð´Ð°Ð½Ð°',0),(601162,16692,'sr','ÐŸÐ¾Ð½ÑƒÐ´Ð° Ð·Ð° Ð²Ñ€ÐµÐ¼Ðµ Ñ†Ð¸ÐºÐ»ÑƒÑÐ°',0),(601163,16693,'sr','ÐŸÐ¾ÑÑ‚Ð°Ð²Ñ™Ð°ÑšÐµ Ð¾Ð²Ð¾Ð³ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ð° ÐºÐ°Ð¾ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð·Ð° Ð¾Ð²Ð°Ñ˜ Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð» Ð²Ð¾Ñ™Ñƒ ÑƒÐºÐ»Ð¾Ð½Ð¸ ÑÐ²Ð°ÐºÐ¸ Ð¿Ð¾Ð´Ñ€Ð°Ð·ÑƒÐ¼ÐµÐ²Ð°Ð½Ð¸ Ð´Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡Ðµ Ð·Ð° Ð¾Ð²Ñƒ ÑÑ‚Ð°Ð²ÐºÑƒ',0),(601164,16694,'sr','Ð”Ð¾Ð±Ð°Ð²Ñ™Ð°Ñ‡ Ð£ÐŸÐ¦',0),(601165,16695,'sr','Ð‘Ñ€Ð¾Ñ˜ Ð Ð¢Ð’',0),(601166,16696,'sr','ÐÐ°Ð¿Ñ€Ð°Ð²Ð¸Ñ‚Ðµ Ð½Ð°Ð»Ð¾Ð³',0),(601167,16697,'sr','ÐÐµ Ð¼Ð¾Ð¶ÐµÑ‚Ðµ Ð´Ð° Ð¿Ñ€Ð¾Ð¼ÐµÐ½Ð¸Ñ‚Ðµ Ð¾Ð²Ð°Ñ˜ Ð½Ð°Ð»Ð¾Ð³ Ð´Ð° Ð±Ð°Ñ†Ð¸ Ð±Ñ€Ð¾Ð´',0),(601168,16698,'sr','Ð¢Ñ€ÐµÐ½ÑƒÑ‚Ð½Ñƒ Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ñƒ',0),(601169,16699,'sr','ÐÐ°Ð»Ð¾Ð³ Ñ˜Ðµ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐ° Ð°Ñ€Ñ‚Ð¸ÐºÐ°Ð»Ð°-Ð¾Ñ‚Ð¿ÑƒÑÑ‚Ð¸ Ð±Ñ€Ð¾Ð´',0),(601170,16700,'sr','ÐšÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ð° Ð½Ð°Ð»Ð¾Ð³Ð° Ð½Ð¸Ñ˜Ðµ Ð´Ð¾ÑÑ‚ÑƒÐ¿Ð½Ð° Ð½Ð° Ð»Ð¾ÐºÐ°Ñ†Ð¸Ñ˜Ð¸',0),(601171,16701,'sr','Ð¡Ð¼Ð°ÑšÐ¸Ñ‚Ðµ ÐºÐ¾Ð»Ð¸Ñ‡Ð¸Ð½Ñƒ',0),(601172,16702,'sr','ÐÐ° ÑÑ™ÐµÐ´ÐµÑ›Ðµ-Ð¾Ñ‚Ð¿ÑƒÑÑ‚Ð¸ Ð±Ñ€Ð¾Ð´ Ð´Ð° ÑÐµ ÑƒÐºÐ»Ð¾Ð½Ð¸',0),(601173,16703,'sr','Ð’Ð°ÑƒÑ‡ÐµÑ€ Ð˜Ð”',0),(601174,16704,'sr','ÐŸÑ€Ð¸Ð¼Ð°Ñ€Ð½Ð¸ ÐºÑƒÐ¿Ð°Ñ†',0),(601175,16705,'sr','ÐÐºÐ¾ Ð¾ÐºÑ€ÑƒÐ³Ð° Ð½Ð¸Ñ˜Ðµ Ð½Ð° Ð»Ð¸ÑÑ‚Ð¸',0),(601176,16706,'sr','Ð Ð°Ð´ÑšÐµ Ð°Ð¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐ°',0),(601177,16707,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°Ñ˜Ñƒ Ñ‚Ñ€Ð¾ÑˆÐºÐ¾Ð²Ð° ÑˆÐ¸Ñ„Ñ€Ðµ Ð°ÐºÐ¾ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½ ÐºÐ¾ÑˆÑ‚Ð°Ð¾ Ñ˜Ðµ ÑˆÐ¸Ñ„Ñ€Ðµ',0),(601178,16708,'sr','Ð—Ð°Ñ…Ñ‚ÐµÐ²Ð°Ñ˜Ñƒ Ð“Ð› ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ñƒ Ð°ÐºÐ¾ Ð“Ð› Ñ€Ð°Ñ‡ÑƒÐ½ Ð¸Ð¼Ð° Ð“Ð› ÐºÐ°Ñ‚ÐµÐ³Ð¾Ñ€Ð¸Ñ˜Ðµ',0),(601179,16709,'sr','Ð”Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¸Ð²Ð½Ð¸ Ñ†ÐµÐ½Ñ‚Ð°Ñ€',0),(601180,16710,'sr','Ð”Ð° Ð»Ð¸ Ñ˜Ðµ Ð´Ð¸ÑÑ‚Ñ€Ð¸Ð±ÑƒÑ‚Ð¸Ð²Ð½Ð¾Ð³ Ñ†ÐµÐ½Ñ‚Ñ€Ð°?',0),(601181,16711,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸Ð¾',0),(601182,16712,'sr','Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ð¸ ÑÐµ',0),(601183,16713,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ ÑÐµ ÑÐ°Ð´Ð°',0),(601184,16714,'sr','Ð’Ñ€ÐµÐ¼Ðµ Ð¿Ñ€Ð¸Ñ˜Ð°Ð²Ðµ',0),(601185,16715,'sr','Ð§ÑƒÐ²Ð°ÑšÐµ Ð±ÐµÐ»ÐµÐ¶Ð°ÐºÐ°',0),(601186,16716,'sr','ÐÐ¶ÑƒÑ€Ð¸Ñ€Ð°ÑšÐµ Ð½Ð°Ð¿Ð¾Ð¼ÐµÐ½Ðµ',0),(601187,16717,'sr','ÐÐ¸Ñ˜Ðµ Ð±Ð¸Ð»Ð¾ Ð¼Ð¾Ð³ÑƒÑ›Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ›Ð¸ Ð“Ð› Ð½Ð°Ð»Ð¾Ð³ Ð¿Ð¾ Ð¸Ð¼ÐµÐ½Ñƒ',0),(601188,16718,'sr','ÐŸÐ°Ñ†Ð¸Ñ˜ÐµÐ½Ñ‚ ÑƒÐ²Ð¾Ð·Ð°',0),(601189,16719,'sr','ÐÐ°Ð¿ÑƒÐ½Ð¸ Ð´Ð°Ð½',0),(601190,16720,'sr','Ð—Ð°Ð´ÑšÐ¸ ÑÐ°ÑÑ‚Ð°Ð½Ð°Ðº',0),(601191,16721,'sr','ÐœÐ¾Ð»Ð¸Ð¼ Ñ‚Ðµ 777 Ñ†Ñ…Ð¼Ð¾Ð´',0),(601192,16722,'sr','Ð¡Ð²Ðµ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(601193,16723,'sr','ÐšÑšÐ¸Ð³Ð° Ð¾Ð²Ð¾Ð³ ÑÐ°ÑÑ‚Ð°Ð½ÐºÐ°',0),(601194,16724,'sr','ÐšÐ¾Ð¼Ð°Ð½Ð´Ð° Ð½Ð¸Ñ˜Ðµ Ð¿Ñ€Ð¾Ð½Ð°Ñ’ÐµÐ½',0),(601195,16725,'sr','ÐŸÐ¾Ñ‚Ð²Ñ€Ð´Ð¸Ñ‚Ðµ Ñ‚ÐµÑ€Ð¼Ð¸Ð½',0),(601196,16726,'sr','Ð¤ÑƒÐ½ÐºÑ†Ð¸Ñ˜Ð° Ð½Ð¸Ñ˜Ðµ Ð¾Ð¼Ð¾Ð³ÑƒÑ›ÐµÐ½Ð°',0),(601197,16727,'sr','Ð¡Ð»ÐµÐ´ÐµÑ›Ð¸ ÑÐ°ÑÑ‚Ð°Ð½Ð°Ðº',0),(601198,16728,'sr','ÐÐµÐ¼Ð° Ð¿Ñ€ÐµÐ´ÑÑ‚Ð¾Ñ˜ÐµÑ›Ð¸Ñ… Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ð¾',0),(601199,16729,'sr','ÐžÑ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ Ð·Ð°',0),(601200,16730,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼ Ð´Ð° Ð±Ð¸ÑÑ‚Ðµ Ð¿Ñ€Ð¸ÐºÐ°Ð·Ð°Ð»Ð¸ Ð¾Ñ‚Ð²Ð¾Ñ€ÐµÐ½Ðµ Ð·Ð°ÐºÐ°Ð·Ð°Ð½Ðµ Ð¾Ð±Ð°Ð²ÐµÐ·Ðµ',0),(601201,16731,'sr','Ð“Ð´Ðµ',0),(601202,16732,'sr','Ð—Ð°ÐºÐ°Ð·Ð°Ñ‚Ð¸ ÑÐ°ÑÑ‚Ð°Ð½Ð°Ðº',0),(601203,16733,'sr','Ð˜Ð·Ð°Ð±ÐµÑ€Ð¸Ñ‚Ðµ Ð´Ð°Ñ‚ÑƒÐ¼',0),(601204,16734,'sr','Ð’Ñ€ÑÑ‚Ð° Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð°',0),(601205,16735,'sr','Ð’Ñ€ÑÑ‚Ð° Ð·Ð°Ñ…Ñ‚ÐµÐ²Ð° Ð·Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ðµ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¾Ð²Ð° Ð¨Ð¸Ñ„Ñ€Ð° Ð²ÐµÑ› Ð¿Ð¾ÑÑ‚Ð¾Ñ˜Ð¸.',0),(601206,16736,'sr','Ð¨Ð¸Ñ„Ñ€Ð° Ð²Ñ€ÑÑ‚Ðµ Ð·Ð°Ñ…Ñ‚ÐµÐ² Ð·Ð° ÐºÐ¾Ñ€ÐµÐºÑ†Ð¸Ñ˜Ñƒ Ð·Ð°Ð»Ð¸Ñ…Ð° Ð¼Ð¾Ñ€Ð° Ð±Ð¸Ñ‚Ð¸ Ð¿Ð¾ÑÑ‚Ð°Ð²Ñ™ÐµÐ½Ð°.',0),(601207,16737,'sr','ÐŸÑ€Ð¾ÐºÑšÐ¸Ð¶Ð¸ Ð´Ð¾ Ð¸ÑÐ¿Ð¾Ñ€ÑƒÐºÐµ Ð¸ Ð¿Ñ€Ð¸Ñ˜ÐµÐ¼Ð°',0),(601208,16738,'sr','ÐŸÑ€Ð¸Ñ˜Ð°Ð²Ð¸Ñ‚Ðµ ÑÐµ ÐºÐ°Ð¾ Ð¾Ð²Ð¾Ð³ ÐºÐ¾Ñ€Ð¸ÑÐ½Ð¸ÐºÐ°',0),(601209,16739,'sr','Ð£ÐºÑ™ÑƒÑ‡ÑƒÑ˜Ñƒ Ð¿Ð¾Ð½ÑƒÐ´Ðµ',0),(601210,16503,'si','Ne morem prebrati zapisa',0),(601211,16504,'si','Ni mogoÄe dodati',0),(601212,16505,'si','Ni mogoÄe posodobiti',0),(601213,16506,'si','Nepopoln obrazec',0),(601214,16507,'si','Ne more brati datoteke',0),(601215,16508,'si','Potrebno poveÄati-naprej polja po meri',0),(601216,16509,'si','Obremenitve tovornega prometa',0),(601217,16510,'si','Obremenitve tovornega prometa',0),(601218,16511,'si','VkljuÄujejo konec leta, prilagajanje vnosa',0),(601219,16512,'si','Vrsta zahtevo popravka zaloge',0),(601220,16513,'si','Zahteva vrsto popravka zaloge Å¡ifra Å¾e obstaja',0),(601221,16514,'si','Nastavite zaloge prilagoditev zahtevo koda vrste',0),(601222,16515,'si','Ustvarite prenos',0),(601223,16516,'si','Nastavite privzeto znotraj podjetja prenos odmik raÄuna',0),(601224,16517,'si','Znotraj podjetja Transfer element - Print',0),(601225,16518,'si','GL konto zaloge morajo biti dodeljena na artikel ali konto privzeto dodeljen v nastavitev zaloge',0),(601226,16519,'si','NUM mesecih prodaje za koliÄina vnoviÄnega naroÄila',0),(601227,16520,'si','NUM mesecev za dopolnitev',0),(601228,16521,'si','Dopolnitev',0),(601229,16522,'si','Dopolnitve zalog prenos',0),(601230,16523,'si','Prenos shranjene',0),(601231,16524,'si','Sprejeto datum',0),(601232,16525,'si','Vrsta popravka',0),(601233,16526,'si','Dodeljeno',0),(601234,16527,'si','Dodeljeni datum',0),(601235,16528,'si','Å tejejo',0),(601236,16529,'si','Å tevilo tipa',0),(601237,16530,'si','Dodeljeni datum',0),(601238,16531,'si','Elementi, ki Å¡tejejo',0),(601239,16532,'si','Nazadnje posodobil',0),(601240,16533,'si','Odstotkov preÅ¡tetih',0),(601241,16534,'si','Vrsta zahteve',0),(601242,16535,'si','Borzni pregled zahtevo',0),(601243,16536,'si','Borzni pregled zahtev',0),(601244,16537,'si','Zalog preveri zahtevo stanje',0),(601245,16538,'si','Varianco vrednosti Amt',0),(601246,16539,'si','Odstotek vrednost odmika',0),(601247,16540,'si','Dodaj/Uredi County',0),(601248,16541,'si','Imenovanje razporejevalnika',0),(601249,16542,'si','Å tevilo upravljanje',0),(601250,16543,'si','Kupec Info uvoz',0),(601251,16544,'si','Uvoz prodajalec ozemlja',0),(601252,16545,'si','Uvozni davek',0),(601253,16546,'si','Uvoz prodajalec naroÄilo Froms',0),(601254,16547,'si','Znotraj podjetja prenos tovora breme',0),(601255,16548,'si','Vrste zahteva prilagoditev zaloge',0),(601256,16549,'si','Novo zahtevo za pregled zalog',0),(601257,16550,'si','PoÄivaliÅ¡Äe podroÄjih',0),(601258,16551,'si','Izvajalno obmoÄje',0),(601259,16552,'si','RaÄun stavek narobe',0),(601260,16553,'si','Count ne najdete raÄun z imenom',0),(601261,16554,'si','Grof ni najti banÄni raÄun z imenom',0),(601262,16555,'si','Grof ni najti, ladijski promet metodo z imenom',0),(601263,16556,'si','Tekme Muliple prodajalci',0),(601264,16557,'si','PoÅ¡tno Å¡tevilko ali drÅ¾ava, ki zahteva',0),(601265,16558,'si','Prodajalec ID',0),(601266,16559,'si','Prodajalec ID ali ime morate doloÄiti',0),(601267,16560,'si','Koda stanja',0),(601268,16561,'si','Ime dobavitelja podjetja ali priimek mora biti nastavljen',0),(601269,16562,'si','BanÄna Å¡tevilka proizvodnega postopka',0),(601270,16563,'si','Privzeti naÄin plaÄila',0),(601271,16564,'si','Nastavite koda prodajalca',0),(601272,16565,'si','Prazno',0),(601273,16566,'si','Ni nastavljenega tipa',0),(601274,16567,'si','Imenovanja knjiÅ¾iti',0),(601275,16568,'si','Odprte sestanke',0),(601276,16569,'si','Sestanke, danes',0),(601277,16570,'si','Skupni sestanki',0),(601278,16571,'si','Imenovanje dolÅ¾ina',0),(601279,16572,'si','Imenovanje seznam za',0),(601280,16573,'si','Imenovanje lokacije',0),(601281,16574,'si','Ime sestanka',0),(601282,16575,'si','Povzetek sestanka',0),(601283,16576,'si','B2B imenovanje razporejevalnika',0),(601284,16577,'si','Ustvariti sestanek odprtine',0),(601285,16578,'si','IzbriÅ¡i odprti sestanek',0),(601286,16579,'si','Naslednji prihodnji sestanek',0),(601287,16580,'si','Pick datum PrikaÅ¾i & urejanje sestankov',0),(601288,16581,'si','PrikaÅ¾i Povzetek',0),(601289,16582,'si','Unbook sestanek',0),(601290,16583,'si','Dodaj nov County',0),(601291,16584,'si','County ime',0),(601292,16585,'si','MatiÄna drÅ¾ava',0),(601293,16586,'si','Vnesti morate ime County',0),(601294,16587,'si','Izberite stanje',0),(601295,16588,'si','Ali ste prepriÄani, da Å¾elite izbrisati ta County?',0),(601296,16589,'si','IzbriÅ¡i County',0),(601297,16590,'si','Uredi po meri County',0),(601298,16591,'si','Razmislite o dodajanju novih County',0),(601299,16592,'si','Urejanje County',0),(601300,16593,'si','VaÅ¡ izbor je vrednost sistema in ni mogoÄe spremeniti',0),(601301,16594,'si','Izpolnite obrazec, da bi Å¡e',0),(601302,16595,'si','Uporabniki, ki so dodani',0),(601303,16596,'si','Uporabniki, ki so izpuÅ¡Äene',0),(601304,16597,'si','Uporabniki, ki so posodobljene',0),(601305,16598,'si','Branje vrstic',0),(601306,16599,'si','Nadomestno telefonsko',0),(601307,16600,'si','Uvozne datoteke CSV',0),(601308,16601,'si','Ponudnika mobilne telefonije',0),(601309,16602,'si','Å tevilko mobilnega telefona',0),(601310,16603,'si','Izberite pogoje raÄuna',0),(601311,16604,'si','Kratica drÅ¾ave',0),(601312,16605,'si','Naslov â€“ ulica',0),(601313,16606,'si','Dodaj/Uredi',0),(601314,16607,'si','AVG prodaje na mesec',0),(601315,16608,'si','ElektriÄno napajanje',0),(601316,16609,'si','Ni dodeljen primarni regal',0),(601317,16610,'si','KoliÄina na prenos',0),(601318,16611,'si','Dopolnitev zalog iz distribucijski Center',0),(601319,16612,'si','Predlagal',0),(601320,16613,'si','Prenos koliÄina',0),(601321,16614,'si','ObmoÄje',0),(601322,16615,'si','Mesta, dodana',0),(601323,16616,'si','Posodobitev mesta',0),(601324,16617,'si','Okrajih, doda',0),(601325,16618,'si','Okrajih, posodobljen',0),(601326,16619,'si','DrÅ¾ave, ki se doda',0),(601327,16620,'si','DrÅ¾ave, ki se posodablja',0),(601328,16621,'si','Ali ste prepriÄani, da Å¾elite posodobiti zapise prometnega davka?',0),(601329,16622,'si','Ime mesta',0),(601330,16623,'si','Mesto prometnega davka multiplikator',0),(601331,16624,'si','Mesto uporabe davÄne multiplikator',0),(601332,16625,'si','Multiplikator County prometnega davka',0),(601333,16626,'si','County uporabo davka multiplikator',0),(601334,16627,'si','Uvozni davek',0),(601335,16628,'si','Multiplikator drÅ¾avni prometni davek',0),(601336,16629,'si','DrÅ¾avni uporabo davka multiplikator',0),(601337,16630,'si','Thomson Reuters jeziÄek datoteke',0),(601338,16631,'si','ObstojeÄih podatkov',0),(601339,16632,'si','ObdrÅ¾ati obstojeÄe podatke',0),(601340,16633,'si','Odstrani vse obstojeÄe podatke',0),(601341,16634,'si','Odstrani obstojeÄe podatke za dobavitelje v uvoz',0),(601342,16635,'si','Krediti do dobavitelja',0),(601343,16636,'si','Auto izberite prometnega davka od ladje',0),(601344,16637,'si','Na izpolnitev in naloge POS',0),(601345,16638,'si','OmogoÄajo nalogih samo iz distribucijskih centrov',0),(601346,16639,'si','Samodejno Izberi prometnega davka iz ladje na izpolnitev in naloge POS',0),(601347,16640,'si','KonÄni neposredno dobavo zahteva POD',0),(601348,16641,'si','KaÅ¾ejo moÅ¾nost nakupa lokacijah, ko koliÄina ni na voljo',0),(601349,16642,'si','Delni oprostitvi davka',0),(601350,16643,'si','DavÄna stopnja odstotkov',0),(601351,16644,'si','Distribucijski Center Num mesecih prodaje za izraÄun naroÄanja',0),(601352,16645,'si','MedpanoÅ¾na prenos obremenitev odstotek GL raÄun',0),(601353,16646,'si','Znotraj podjetja prenosov artiklov - omogoÄa veÄ lokacijah',0),(601354,16647,'si','Znotraj podjetja prenosov artiklov - knjiÅ¾enje',0),(601355,16648,'si','Zaloge v raÄun tranzita GL',0),(601356,16649,'si','Distribucijski Center Num mesecih prodaje za izraÄun naroÄanja',0),(601357,16650,'si','Post Ärta',0),(601358,16651,'si','Post za poÅ¡iljanje in prejemanje',0),(601359,16652,'si','B2B uporabnik prepriÄevalnost',0),(601360,16653,'si','Prijavite kot uporabnik',0),(601361,16654,'si','Ni mogoÄe shraniti kot vrstni red popolnega',0),(601362,16655,'si','Ni priloÅ¾eno nalog POD datoteko',0),(601363,16656,'si','Padec ladja',0),(601364,16657,'si','Arhiv & shrani',0),(601365,16658,'si','Zaprti stroÅ¡kov koda',0),(601366,16659,'si','Zaprta po kategoriji GL',0),(601367,16660,'si','Zapri raÄuni po stroÅ¡kovno kodo',0),(601368,16661,'si','Zapiranje raÄunov po kategoriji GL',0),(601369,16662,'si','Datuma preklicana',0),(601370,16663,'si','13. obdobja zaÄetka',0),(601371,16664,'si','DavÄno prilagajanje vnosa',0),(601372,16665,'si','Leto konca prilagajanje vnosa',0),(601373,16666,'si','13. postavke v obdobju',0),(601374,16667,'si','DavÄna prilagoditev postavk',0),(601375,16668,'si','S konca leta prilagajanje vnosa',0),(601376,16669,'si','Zalog',0),(601377,16670,'si','Drugih dajatev',0),(601378,16671,'si','Drugih stroÅ¡kov',0),(601379,16672,'si','Prenos med lokacijami',0),(601380,16673,'si','Prenos podrobnosti',0),(601381,16674,'si','Non-zaloÅ¾iti',0),(601382,16675,'si','Najem',0),(601383,16676,'si','Na zalogi',0),(601384,16677,'si','0 za noben Max',0),(601385,16678,'si','0 za noben Min',0),(601386,16679,'si','AVG koliÄina na mesec',0),(601387,16680,'si','Nabavnega naloga',0),(601388,16681,'si','Ustvarite nabavni nalog',0),(601389,16682,'si','Distribucijski centri',0),(601390,16683,'si','Lokacijami inventarja',0),(601391,16684,'si','Max na strani',0),(601392,16685,'si','Min na strani',0),(601393,16686,'si','Moj prodajalci',0),(601394,16687,'si','NUM mesecih prodaje za najveÄ na roko',0),(601395,16688,'si','NUM mesecih prodaje najmanj na roko',0),(601396,16689,'si','NUM mesecih prodaje za koliÄina vnoviÄnega naroÄila',0),(601397,16690,'si','Je privzeto artikla dobavitelja?',0),(601398,16691,'si','Å tevilo dni',0),(601399,16692,'si','Citiram pretoÄni Äas',0),(601400,16693,'si','Nastavitev tega prodajalca kot privzetega za to odstrani element bo drugih prodajalcev privzeto za ta element',0),(601401,16694,'si','Prodajalec UPC',0),(601402,16695,'si','Å tevilo RTV',0),(601403,16696,'si','Vrnjeno',0),(601404,16697,'si','Ne morete spremeniti nalogu spusti ladje',0),(601405,16698,'si','Trenutno lokacijo',0),(601406,16699,'si','Naloga je poÅ¡iljke ne spusti ladjo elementov',0),(601407,16700,'si','KoliÄina naloga ni na voljo na mestu',0),(601408,16701,'si','ZmanjÅ¡ati koliÄino naloga',0),(601409,16702,'si','Naslednje ne spusti ladjo odpravijo',0),(601410,16703,'si','Kupon ID',0),(601411,16704,'si','Glavni kupec',0),(601412,16705,'si','ÄŒe obÄine ne na seznam',0),(601413,16706,'si','Dejanje posodobitve',0),(601414,16707,'si','Zahtevajo stroÅ¡kovno kode, Äe raÄun GL je stroÅ¡ek kode',0),(601415,16708,'si','Zahtevajo GL Category, Äe raÄun GL je GL kategorije',0),(601416,16709,'si','Distribucijski Center',0),(601417,16710,'si','Je distribucijski Center?',0),(601418,16711,'si','Preveri',0),(601419,16712,'si','sprostiti',0),(601420,16713,'si','Preverite zdaj',0),(601421,16714,'si','Preverite v Äasu',0),(601422,16715,'si','Â¾elite shraniti beleÂ¾ke',0),(601423,16716,'si','Opombe modernizirati',0),(601424,16717,'si','RaÄun glavne Knjige po imenu ni bilo mogoÄe najti.',0),(601425,16718,'si','Bolnika uvoz',0),(601426,16719,'si','Izpolnite dan',0),(601427,16720,'si','PrejÅ¡nji sestanek',0),(601428,16721,'si','Prosim 777 chmod',0),(601429,16722,'si','Vsi sestanki',0),(601430,16723,'si','Knjiga sestanek',0),(601431,16724,'si','Zapoved ne ustanavljati',0),(601432,16725,'si','Potrditi Äas sestanka',0),(601433,16726,'si','Funkcija ni omogoÄena',0),(601434,16727,'si','Naslednji sestanek',0),(601435,16728,'si','Ni prihajajoÄe sreÄanje',0),(601436,16729,'si','Odprte sestanke za',0),(601437,16730,'si','Izberite datum za ogled odprte sestanke',0),(601438,16731,'si','Kjer',0),(601439,16732,'si','NaÄrtovati sestanek',0),(601440,16733,'si','Izberite datum',0),(601441,16734,'si','Vrsta zahtevo popravka zaloge',0),(601442,16735,'si','Zahteva vrsto popravka zaloge Å¡ifra Å¾e obstaja',0),(601443,16736,'si','Nastavite zaloge prilagoditev zahtevo koda vrste',0),(601444,16737,'si','Post z ladijskega & prejemajo',0),(601445,16738,'si','Prijavite kot uporabnik',0),(601446,16739,'si','VÅ¡tevajo ponudbe',0),(601447,16503,'es','No se puede leer disco',0),(601448,16504,'es','No se pudo agregar',0),(601449,16505,'es','No podrÃ­a ser actualizado',0),(601450,16506,'es','Forma incompleta',0),(601451,16507,'es','No puede leer archivo',0),(601452,16508,'es','Campos personalizados adicionales requeridos',0),(601453,16509,'es','Carga carga',0),(601454,16510,'es','Carga carga',0),(601455,16511,'es','Incluyen las entradas de ajuste de fin de aÃ±o',0),(601456,16512,'es','Tipo de solicitud de ajuste de inventario',0),(601457,16513,'es','Tipo de solicitud de ajuste de inventario por este cÃ³digo ya existe',0),(601458,16514,'es','CÃ³digo de tipo de solicitud de ajuste de inventario se debe establecer',0),(601459,16515,'es','Crear transferencia',0),(601460,16516,'es','Cuenta de contrapartida de transferencia predeterminado entre empresas vinculadas debe establecerse',0),(601461,16517,'es','IntercompaÃ±Ã­as a artÃ­culo transferencia - imprimir',0),(601462,16518,'es','Cuenta de Contabilidad de inventario debe tener asignado el elemento o cuenta predeterminada asignado en la configuraciÃ³n de inventario',0),(601463,16519,'es','NÃºmero meses ventas por cantidad de reorden',0),(601464,16520,'es','NÃºmero de meses para reponer',0),(601465,16521,'es','ReposiciÃ³n',0),(601466,16522,'es','Transferencias de reposiciÃ³n',0),(601467,16523,'es','Transferencia de guardado',0),(601468,16524,'es','Fecha aceptada',0),(601469,16525,'es','Tipo de ajuste',0),(601470,16526,'es','Asignado',0),(601471,16527,'es','Fecha asignada',0),(601472,16528,'es','Contado',0),(601473,16529,'es','Tipo de cuenta',0),(601474,16530,'es','Fecha asignada',0),(601475,16531,'es','ArtÃ­culos de contado',0),(601476,16532,'es','Ãšltima actualizaciÃ³n de',0),(601477,16533,'es','Por ciento cuenta',0),(601478,16534,'es','Tipo de solicitud',0),(601479,16535,'es','Solicitud de verificaciÃ³n de stock',0),(601480,16536,'es','Solicitudes de verificaciÃ³n de stock',0),(601481,16537,'es','AcciÃ³n Compruebe el estado del pedido',0),(601482,16538,'es','VariaciÃ³n valor Amt',0),(601483,16539,'es','Porcentaje de variaciÃ³n de valor',0),(601484,16540,'es','Condado de agregar/editar',0),(601485,16541,'es','Programador de cita',0),(601486,16542,'es','GestiÃ³n de cuenta',0),(601487,16543,'es','ImportaciÃ³n de informaciÃ³n al cliente',0),(601488,16544,'es','Territorios de vendedor de importaciÃ³n',0),(601489,16545,'es','Impuestos de importaciÃ³n',0),(601490,16546,'es','Importar proveedores orden Froms',0),(601491,16547,'es','Transferencia de la carga carga de intercompaÃ±Ã­as',0),(601492,16548,'es','Tipos de solicitud de ajuste de inventario',0),(601493,16549,'es','Nueva solicitud de verificaciÃ³n de Stock',0),(601494,16550,'es','Ãreas de estacionamiento',0),(601495,16551,'es','Ãrea de staging',0),(601496,16552,'es','Cuenta de tipo incorrecto',0),(601497,16553,'es','Cuenta buscar no cuenta por su nombre',0),(601498,16554,'es','Cuenta no encontrar cuenta de cheques por nombre',0),(601499,16555,'es','Cuenta no encontrar mÃ©todo por nombre de envÃ­o',0),(601500,16556,'es','Proveedores de Muliple de partidos',0),(601501,16557,'es','CÃ³digo postal o estado requeridas',0),(601502,16558,'es','ID del vendedor',0),(601503,16559,'es','Nombre o ID de vendedor debe establecerse',0),(601504,16560,'es','CÃ³digo de estado',0),(601505,16561,'es','Proveedor nombre o apellido debe establecerse',0),(601506,16562,'es','NÃºmero de ruta del Banco',0),(601507,16563,'es','MÃ©todo de pago predeterminado',0),(601508,16564,'es','CÃ³digo de proveedor se debe establecer',0),(601509,16565,'es','En blanco',0),(601510,16566,'es','NingÃºn conjunto de tipo',0),(601511,16567,'es','Citas reservados',0),(601512,16568,'es','Libre de citas',0),(601513,16569,'es','Citas de hoy',0),(601514,16570,'es','Total de citas',0),(601515,16571,'es','Longitud de la cita',0),(601516,16572,'es','Lista de nombramiento para',0),(601517,16573,'es','UbicaciÃ³n de la cita',0),(601518,16574,'es','Nombre de la cita',0),(601519,16575,'es','Resumen de la cita',0),(601520,16576,'es','Programador de cita de B2B',0),(601521,16577,'es','Crear cita aberturas',0),(601522,16578,'es','Borrar cita abierta',0),(601523,16579,'es','PrÃ³xima cita futura',0),(601524,16580,'es','Escoger una fecha para ver y editar citas',0),(601525,16581,'es','Mostrar Resumen',0),(601526,16582,'es','Unbook cita',0),(601527,16583,'es','AÃ±adir nuevo Condado',0),(601528,16584,'es','Condado de nombre',0),(601529,16585,'es','Estado de los padres',0),(601530,16586,'es','Debe introducir un nombre de condado',0),(601531,16587,'es','Debe seleccionar un estado',0),(601532,16588,'es','Â¿EstÃ¡ seguro que desea eliminar este condado?',0),(601533,16589,'es','Condado de eliminar',0),(601534,16590,'es','Editar Custom County',0),(601535,16591,'es','Considerar la adiciÃ³n de un condado nuevo',0),(601536,16592,'es','Condado de la ediciÃ³n',0),(601537,16593,'es','Su selecciÃ³n es un valor del sistema y no se puede cambiar',0),(601538,16594,'es','Usted debe completar el formulario para continuar',0),(601539,16595,'es','Clientes ha aÃ±adido',0),(601540,16596,'es','Clientes saltados',0),(601541,16597,'es','Clientes actualizados',0),(601542,16598,'es','Lectura de lÃ­neas',0),(601543,16599,'es','TelÃ©fono alternativo',0),(601544,16600,'es','Archivo de importaciÃ³n CSV',0),(601545,16601,'es','Operadora de telefonÃ­a mÃ³vil',0),(601546,16602,'es','NÃºmero de telÃ©fono mÃ³vil',0),(601547,16603,'es','Seleccionar tÃ©rminos de factura',0),(601548,16604,'es','Abreviatura del estado',0),(601549,16605,'es','DirecciÃ³n de la calle',0),(601550,16606,'es','Agregar/editar',0),(601551,16607,'es','Promedio de ventas por mes',0),(601552,16608,'es','Fuente actual',0),(601553,16609,'es','No Bin primaria asignada',0),(601554,16610,'es','Cantidad de transferencia',0),(601555,16611,'es','Reponer el Stock de centro de distribuciÃ³n',0),(601556,16612,'es','Sugerido',0),(601557,16613,'es','Transferencia de cantidad',0),(601558,16614,'es','Zona',0),(601559,16615,'es','Ciudades aÃ±adidas',0),(601560,16616,'es','Ciudades actualizadas',0),(601561,16617,'es','Condados de aÃ±adido',0),(601562,16618,'es','Condados de actualizado',0),(601563,16619,'es','AÃ±adido los Estados',0),(601564,16620,'es','Actualizadas los Estados',0),(601565,16621,'es','Â¿EstÃ¡ seguro que desea actualizar sus registros de impuestos sobre las ventas?',0),(601566,16622,'es','Nombre de la ciudad',0),(601567,16623,'es','Multiplicador de impuestos de la ciudad',0),(601568,16624,'es','Multiplicador de impuestos de uso de ciudad',0),(601569,16625,'es','Multiplicador de impuestos del Condado',0),(601570,16626,'es','Multiplicador de impuestos uso del Condado',0),(601571,16627,'es','Impuestos de importaciÃ³n',0),(601572,16628,'es','Multiplicador de impuestos estatales',0),(601573,16629,'es','Multiplicador de impuestos estatales de uso',0),(601574,16630,'es','Thomson Reuters ficha archivo',0),(601575,16631,'es','Datos existentes',0),(601576,16632,'es','Mantener los datos existentes',0),(601577,16633,'es','Purga todos los datos existentes',0),(601578,16634,'es','Purgar los datos existentes para los proveedores de importaciÃ³n',0),(601579,16635,'es','CrÃ©ditos de proveedores pendientes',0),(601580,16636,'es','Auto seleccione impuesto sobre las ventas de la nave a',0),(601581,16637,'es','En POS de Ã³rdenes y el cumplimiento',0),(601582,16638,'es','Permitir a pedido sÃ³lo de centros de distribuciÃ³n',0),(601583,16639,'es','Seleccionar automÃ¡ticamente el impuesto sobre las ventas de nave en POS de Ã³rdenes y el cumplimiento',0),(601584,16640,'es','EnvÃ­o de la gota final requiere VAINA',0),(601585,16641,'es','Sugerir lugares de compra alternativa cuando la cantidad no disponible',0),(601586,16642,'es','ExenciÃ³n parcial de impuestos',0),(601587,16643,'es','Por ciento de tasa de impuesto',0),(601588,16644,'es','Centro de distribuciÃ³n Num meses ventas para cÃ¡lculo de reposiciÃ³n',0),(601589,16645,'es','Sectoriales de transferencia carga porcentaje GL cuenta',0),(601590,16646,'es','IntercompaÃ±Ã­as a transferencias artÃ­culo - permite mÃºltiples ubicaciones',0),(601591,16647,'es','ArtÃ­culo transferencias - registro de intercompaÃ±Ã­as',0),(601592,16648,'es','Inventario en trÃ¡nsito GL cuenta',0),(601593,16649,'es','Centro de distribuciÃ³n no Num meses ventas para cÃ¡lculo de reposiciÃ³n',0),(601594,16650,'es','Mensaje por lÃ­nea',0),(601595,16651,'es','Post por envÃ­o y recepciÃ³n',0),(601596,16652,'es','Inicio de sesiÃ³n de usuario B2B',0),(601597,16653,'es','Inicie sesiÃ³n como este usuario',0),(601598,16654,'es','No se puede guardar como orden completa',0),(601599,16655,'es','No hay ningÃºn archivo de VAINA atado orden',0),(601600,16656,'es','Nave de la gota',0),(601601,16657,'es','Archivo y guardar',0),(601602,16658,'es','Cerrado por costo cÃ³digo',0),(601603,16659,'es','Cerrado por categorÃ­a GL',0),(601604,16660,'es','Cerrar cuentas por costo cÃ³digo',0),(601605,16661,'es','Cerrar cuentas por categorÃ­a GL',0),(601606,16662,'es','Fecha cancelada',0),(601607,16663,'es','13 entrada perÃ­odo',0),(601608,16664,'es','Entrada ajuste de impuestos',0),(601609,16665,'es','Entrada de ajuste de final de aÃ±o',0),(601610,16666,'es','13 entradas perÃ­odas',0),(601611,16667,'es','Impuesto sobre las entradas de ajuste',0),(601612,16668,'es','Con las entradas de ajuste de fin de aÃ±o',0),(601613,16669,'es','No Stock',0),(601614,16670,'es','Otro tipo de cargas',0),(601615,16671,'es','Otros cargos',0),(601616,16672,'es','Traslado entre ubicaciones',0),(601617,16673,'es','Transferencia de datos',0),(601618,16674,'es','No surtido',0),(601619,16675,'es','Alquiler',0),(601620,16676,'es','Surtido',0),(601621,16677,'es','0 No Max',0),(601622,16678,'es','0 para ninguna Min',0),(601623,16679,'es','Cantidad promedio por mes',0),(601624,16680,'es','Orden de compra creada',0),(601625,16681,'es','Crear orden de compra',0),(601626,16682,'es','Centros de distribuciÃ³n',0),(601627,16683,'es','Ubicaciones de inventario',0),(601628,16684,'es','MÃ¡ximo por parte',0),(601629,16685,'es','Min por lado',0),(601630,16686,'es','Mis proveedores',0),(601631,16687,'es','NÃºmero meses ventas por mÃ¡ximo por lado',0),(601632,16688,'es','Meses de NUM ventas mÃ­nimo por parte',0),(601633,16689,'es','NÃºmero meses ventas por cantidad de reorden',0),(601634,16690,'es','Â¿Es proveedor de elemento por defecto?',0),(601635,16691,'es','NÃºmero de dÃ­as',0),(601636,16692,'es','Plazo de ejecuciÃ³n de presupuesto',0),(601637,16693,'es','ConfiguraciÃ³n de este proveedor como el valor predeterminado para este elemento voluntad quitar cualquier otros proveedores por defecto para este artÃ­culo',0),(601638,16694,'es','Proveedores UPC',0),(601639,16695,'es','NÃºmero RTV',0),(601640,16696,'es','Pedido',0),(601641,16697,'es','No se puede cambiar este orden a la nave de la gota',0),(601642,16698,'es','UbicaciÃ³n actual',0),(601643,16699,'es','Orden tiene envÃ­os de artÃ­culos de la nave de la gota no',0),(601644,16700,'es','Cantidad de la orden no estÃ¡ disponible en la ubicaciÃ³n',0),(601645,16701,'es','Reducir la cantidad de la orden',0),(601646,16702,'es','Los siguientes artÃ­culos de la nave de la gota no extirpar',0),(601647,16703,'es','Vale ID',0),(601648,16704,'es','Comprador primario',0),(601649,16705,'es','Si su condado no estÃ¡ en lista',0),(601650,16706,'es','AcciÃ³n de actualizaciÃ³n',0),(601651,16707,'es','Requieren cÃ³digos de costo si cuenta GL ha costado cÃ³digos',0),(601652,16708,'es','Necesitan categorÃ­a GL GL cuenta categorÃ­as GL',0),(601653,16709,'es','Centro de distribuciÃ³n',0),(601654,16710,'es','Â¿Es el centro de distribuciÃ³n?',0),(601655,16711,'es','Comprobado',0),(601656,16712,'es','Check-in',0),(601657,16713,'es','Check-In ahora',0),(601658,16714,'es','Hora de entrada',0),(601659,16715,'es','Guardar notas',0),(601660,16716,'es','Notas de actualizaciÃ³n',0),(601661,16717,'es','No se pudo encontrar GL cuenta por nombre',0),(601662,16718,'es','ImportaciÃ³n de paciente',0),(601663,16719,'es','Llenar el dÃ­a',0),(601664,16720,'es','Ãšltima cita',0),(601665,16721,'es','Por favor, chmod 777',0),(601666,16722,'es','Todas las citas',0),(601667,16723,'es','Esta cita del libro',0),(601668,16724,'es','Command Not Found',0),(601669,16725,'es','Confirmar hora de la cita',0),(601670,16726,'es','FunciÃ³n no activada',0),(601671,16727,'es','PrÃ³xima cita',0),(601672,16728,'es','No hay cita prÃ³xima',0),(601673,16729,'es','Citas abiertas para',0),(601674,16730,'es','Seleccione una fecha para ver citas abiertas',0),(601675,16731,'es','Donde',0),(601676,16732,'es','Programar una cita',0),(601677,16733,'es','Seleccione fecha',0),(601678,16734,'es','Tipo de solicitud de ajuste de inventario',0),(601679,16735,'es','Tipo de solicitud de ajuste de inventario por este cÃ³digo ya existe',0),(601680,16736,'es','CÃ³digo de tipo de solicitud de ajuste de inventario se debe establecer',0),(601681,16737,'es','Post por envÃ­o y recepciÃ³n de',0),(601682,16738,'es','Inicie sesiÃ³n como este usuario',0),(601683,16739,'es','Incluir citas',0),(601684,16503,'sv','Kan inte lÃ¤sa post',0),(601685,16504,'sv','Kunde inte lÃ¤ggas',0),(601686,16505,'sv','Kunde inte uppdateras',0),(601687,16506,'sv','Form ofullstÃ¤ndig',0),(601688,16507,'sv','Kan inte lÃ¤sa filen',0),(601689,16508,'sv','Anpassade fÃ¤lt tillÃ¤gg krÃ¤vs',0),(601690,16509,'sv','Frakt bÃ¶rda',0),(601691,16510,'sv','Frakt bÃ¶rda',0),(601692,16511,'sv','Inkludera Ã¥rets slut justera poster',0),(601693,16512,'sv','Typ av lager justering begÃ¤ran',0),(601694,16513,'sv','Inventering justeringstypen begÃ¤ran av denna kod finns redan',0),(601695,16514,'sv','Lager justering begÃ¤ran typkod mÃ¥ste anges',0),(601696,16515,'sv','Skapa Ã¶verfÃ¶ring',0),(601697,16516,'sv','Standard koncernintern Ã¶verfÃ¶ring motkontot mÃ¥ste anges',0),(601698,16517,'sv','Koncernintern post Ã¶verfÃ¶ring - Print',0),(601699,16518,'sv','GL lagerkontot mÃ¥ste tilldelas pÃ¥ objekt eller standardkontot tilldelas i LagerinstÃ¤llningar',0),(601700,16519,'sv','NUM mÃ¥nader fÃ¶rsÃ¤ljning fÃ¶r ordna Qty',0),(601701,16520,'sv','NUM mÃ¥nader att fylla pÃ¥',0),(601702,16521,'sv','PÃ¥fyllning',0),(601703,16522,'sv','PÃ¥fyllnad Ã¶verfÃ¶ringar',0),(601704,16523,'sv','Ã–verfÃ¶ring Sparad',0),(601705,16524,'sv','Accepterade datum',0),(601706,16525,'sv','Justeringstypen',0),(601707,16526,'sv','Tilldelade',0),(601708,16527,'sv','Tilldelade datum',0),(601709,16528,'sv','RÃ¤knas',0),(601710,16529,'sv','Antal typ',0),(601711,16530,'sv','Tilldelningsdatum',0),(601712,16531,'sv','Artiklar rÃ¤knas',0),(601713,16532,'sv','Senast uppdaterad av',0),(601714,16533,'sv','Procent rÃ¤knat',0),(601715,16534,'sv','Typ av begÃ¤ran',0),(601716,16535,'sv','Lager Kontrollera begÃ¤ran',0),(601717,16536,'sv','Lager kontrollera fÃ¶rfrÃ¥gningar',0),(601718,16537,'sv','Lager kontrollera Status fÃ¶r begÃ¤ran',0),(601719,16538,'sv','Varians vÃ¤rde Amt',0),(601720,16539,'sv','Kostnadsavvikelse vÃ¤rde, procent',0),(601721,16540,'sv','LÃ¤gga till eller redigera County',0),(601722,16541,'sv','Avtalad tid Scheduler',0),(601723,16542,'sv','RÃ¤kna Management',0),(601724,16543,'sv','Kund Info Import',0),(601725,16544,'sv','Import sÃ¤ljare territorier',0),(601726,16545,'sv','Import moms',0),(601727,16546,'sv','Importera leverantÃ¶rens ordning Froms',0),(601728,16547,'sv','Koncernintern Ã¶verfÃ¶ring frakt bÃ¶rda',0),(601729,16548,'sv','Lagertyper justering begÃ¤ran',0),(601730,16549,'sv','Nya lager Kontrollera begÃ¤ran',0),(601731,16550,'sv','Staging omrÃ¥den',0),(601732,16551,'sv','MellanlagringsomrÃ¥det',0),(601733,16552,'sv','Konto typ fel',0),(601734,16553,'sv','RÃ¤kna inte hitta konto vid namn',0),(601735,16554,'sv','RÃ¤kna inte hitta checkkonto med namn',0),(601736,16555,'sv','RÃ¤kna inte hitta fraktsÃ¤tt vid namn',0),(601737,16556,'sv','Matcher Muliple leverantÃ¶rer',0),(601738,16557,'sv','Postnummer eller tillstÃ¥nd som krÃ¤vs',0),(601739,16558,'sv','SÃ¤ljare-ID',0),(601740,16559,'sv','SÃ¤ljare-ID eller namn mÃ¥ste anges',0),(601741,16560,'sv','Statligt kod',0),(601742,16561,'sv','LeverantÃ¶rens namn eller efternamn mÃ¥ste anges',0),(601743,16562,'sv','Bank clearingnummer',0),(601744,16563,'sv','Standardmetod fÃ¶r lÃ¶n',0),(601745,16564,'sv','LeverantÃ¶rens kod mÃ¥ste anges',0),(601746,16565,'sv','Tomt',0),(601747,16566,'sv','Ingen typ Set',0),(601748,16567,'sv','Avtalade tider bokade',0),(601749,16568,'sv','Avtalade tider Ã¶ppen',0),(601750,16569,'sv','Avtalade tider idag',0),(601751,16570,'sv','Avtalade tider totalt',0),(601752,16571,'sv','Avtalad tid lÃ¤ngd',0),(601753,16572,'sv','Avtalad tid lista fÃ¶r',0),(601754,16573,'sv','Avtalad tid lÃ¤ge',0),(601755,16574,'sv','Avtalad tid namn',0),(601756,16575,'sv','Avtalad tid sammanfattning',0),(601757,16576,'sv','B2B utnÃ¤mning Scheduler',0),(601758,16577,'sv','Skapa avtalad tid Ã¶ppningar',0),(601759,16578,'sv','Ta bort Ã¶ppen avtalad tid',0),(601760,16579,'sv','NÃ¤sta kommande mÃ¶te',0),(601761,16580,'sv','VÃ¤lj ett datum fÃ¶r att visa & redigera avtalade tider',0),(601762,16581,'sv','Visa Sammanfattning',0),(601763,16582,'sv','Unbook utnÃ¤mning',0),(601764,16583,'sv','LÃ¤gga till nya County',0),(601765,16584,'sv','County namn',0),(601766,16585,'sv','Ã–verordnad stat',0),(601767,16586,'sv','Du mÃ¥ste ange ett County namn',0),(601768,16587,'sv','Du mÃ¥ste vÃ¤lja en stat',0),(601769,16588,'sv','Ã„r du sÃ¤ker du vill ta bort detta lÃ¤n?',0),(601770,16589,'sv','Ta bort County',0),(601771,16590,'sv','Redigera anpassade County',0),(601772,16591,'sv','Ã–vervÃ¤g att lÃ¤gga till en ny County',0),(601773,16592,'sv','Redigera County',0),(601774,16593,'sv','Ditt val Ã¤r ett System vÃ¤rde och kan inte Ã¤ndras',0),(601775,16594,'sv','Du mÃ¥ste fylla i formulÃ¤ret fÃ¶r att fortsÃ¤tta',0),(601776,16595,'sv','Kunder som lagt till',0),(601777,16596,'sv','Kunder hoppas Ã¶ver',0),(601778,16597,'sv','Kunder uppdaterad',0),(601779,16598,'sv','Linjerna LÃ¤s',0),(601780,16599,'sv','Alternativa telefonnummer',0),(601781,16600,'sv','CSV-importfilen',0),(601782,16601,'sv','MobiloperatÃ¶r',0),(601783,16602,'sv','Mobiltelefonnummer',0),(601784,16603,'sv','VÃ¤lj faktura villkor',0),(601785,16604,'sv','Statliga fÃ¶rkortning',0),(601786,16605,'sv','Gatuadress',0),(601787,16606,'sv','LÃ¤gg till/redigera',0),(601788,16607,'sv','AVG Sales Per mÃ¥nad',0),(601789,16608,'sv','StrÃ¶mtillfÃ¶rselen',0),(601790,16609,'sv','Ingen primÃ¤r Bin som tilldelats',0),(601791,16610,'sv','KVT pÃ¥ Ã¶verfÃ¶ring',0),(601792,16611,'sv','Fylla pÃ¥ lager frÃ¥n distributionscentral',0),(601793,16612,'sv','FÃ¶reslog',0),(601794,16613,'sv','Ã–verfÃ¶ra Qty',0),(601795,16614,'sv','Zonen',0),(601796,16615,'sv','StÃ¤der till',0),(601797,16616,'sv','StÃ¤der uppdaterad',0),(601798,16617,'sv','LÃ¤n har lagt till det',0),(601799,16618,'sv','Counties uppdaterad',0),(601800,16619,'sv','Har lagt till',0),(601801,16620,'sv','Staterna uppdaterad',0),(601802,16621,'sv','Ã„r du sÃ¤ker du vill uppdatera din moms Records?',0),(601803,16622,'sv','Ortsnamn',0),(601804,16623,'sv','Staden moms multiplikator',0),(601805,16624,'sv','Staden anvÃ¤ndning skatt multiplikator',0),(601806,16625,'sv','Countys moms multiplikator',0),(601807,16626,'sv','County anvÃ¤ndning skatt multiplikator',0),(601808,16627,'sv','Moms Import',0),(601809,16628,'sv','Statliga omsÃ¤ttningsskatten multiplikator',0),(601810,16629,'sv','Statliga anvÃ¤ndning skatt multiplikator',0),(601811,16630,'sv','Thomson Reuters Tab fil',0),(601812,16631,'sv','Befintliga Data',0),(601813,16632,'sv','BehÃ¥lla befintliga Data',0),(601814,16633,'sv','Rensa alla befintliga Data',0),(601815,16634,'sv','Rensa befintliga Data fÃ¶r leverantÃ¶rer i Import',0),(601816,16635,'sv','VÃ¤ntande krediter',0),(601817,16636,'sv','Auto vÃ¤ljer moms frÃ¥n fartyget till',0),(601818,16637,'sv','Uppfyllelse och POS order',0),(601819,16638,'sv','TillÃ¥ta restorder endast frÃ¥n distributionscentraler',0),(601820,16639,'sv','Automatiskt vÃ¤lja moms frÃ¥n skepp till uppfyllelse och POS order',0),(601821,16640,'sv','Sista Drop Shipment krÃ¤ver POD',0),(601822,16641,'sv','FÃ¶reslÃ¥ alternativa kÃ¶p platser nÃ¤r Qty inte tillgÃ¤ngliga.',0),(601823,16642,'sv','Delvisa skattebefrielsen',0),(601824,16643,'sv','Skatt rÃ¤nta procent',0),(601825,16644,'sv','Distributionscenter Num mÃ¥nader fÃ¶rsÃ¤ljning fÃ¶r ordna berÃ¤kning',0),(601826,16645,'sv','BranschÃ¶vergripande Ã¶verfÃ¶ring bÃ¶rda procentandel GL konto',0),(601827,16646,'sv','Koncernintern artikelÃ¶verfÃ¶ringar - tillÃ¥ta flera platser',0),(601828,16647,'sv','Koncernintern artikelÃ¶verfÃ¶ringar - bokfÃ¶ring',0),(601829,16648,'sv','Inventering i konto Transit GL',0),(601830,16649,'sv','Icke-Distribution Center Num mÃ¥nader fÃ¶rsÃ¤ljning fÃ¶r ordna berÃ¤kning',0),(601831,16650,'sv','InlÃ¤gg av linje',0),(601832,16651,'sv','InlÃ¤gget av frakt och ta emot',0),(601833,16652,'sv','B2B AnvÃ¤ndarlogin',0),(601834,16653,'sv','Logga In som anvÃ¤ndaren',0),(601835,16654,'sv','Kan inte spara som ordern komplett',0),(601836,16655,'sv','Ingen POD fil bifogas bestÃ¤llning',0),(601837,16656,'sv','Drop Ship',0),(601838,16657,'sv','Arkiv & Spara',0),(601839,16658,'sv','StÃ¤ngt av kostnad kod',0),(601840,16659,'sv','StÃ¤ngt av GL kategori',0),(601841,16660,'sv','StÃ¤nga konton av kostnad kod',0),(601842,16661,'sv','StÃ¤nga konton efter GL kategori',0),(601843,16662,'sv','Datum avbryts',0),(601844,16663,'sv','13 lagerperiodtransaktioner',0),(601845,16664,'sv','Skatt justera posten',0),(601846,16665,'sv','Ã…r slutet justera posten',0),(601847,16666,'sv','13: e perioden poster',0),(601848,16667,'sv','Skatt justera poster',0),(601849,16668,'sv','Med Ã¥rsskiftet justera poster',0),(601850,16669,'sv','Icke-lager',0),(601851,16670,'sv','Andra avgifter',0),(601852,16671,'sv','Andra avgifter',0),(601853,16672,'sv','Ã–verfÃ¶ra mellan platser',0),(601854,16673,'sv','Ã–verfÃ¶ra Detaljer',0),(601855,16674,'sv','Icke lager',0),(601856,16675,'sv','Uthyrning',0),(601857,16676,'sv','Finns i lager',0),(601858,16677,'sv','0 fÃ¶r ingen Max',0),(601859,16678,'sv','0 fÃ¶r ingen Min',0),(601860,16679,'sv','AVG Qty Per mÃ¥nad',0),(601861,16680,'sv','Skapade inkÃ¶psordern',0),(601862,16681,'sv','Skapa inkÃ¶psorder',0),(601863,16682,'sv','Distributionscentraler',0),(601864,16683,'sv','Lagerplatser',0),(601865,16684,'sv','Max Ã¥',0),(601866,16685,'sv','Min Ã¥',0),(601867,16686,'sv','Mina leverantÃ¶rer',0),(601868,16687,'sv','NUM mÃ¥nader fÃ¶rsÃ¤ljning fÃ¶r maximal Ã¥',0),(601869,16688,'sv','NUM mÃ¥nader fÃ¶rsÃ¤ljning fÃ¶r Minimum Ã¥',0),(601870,16689,'sv','NUM mÃ¥nader fÃ¶rsÃ¤ljning fÃ¶r orderkvantitet kvantitet',0),(601871,16690,'sv','Ã„r standard Artikelns leverantÃ¶r?',0),(601872,16691,'sv','Antal dagar',0),(601873,16692,'sv','Citera ledtid',0),(601874,16693,'sv','StÃ¤lla in leverantÃ¶ren som standard fÃ¶r detta objekt kommer att ta bort eventuella andra standard leverantÃ¶rer fÃ¶r objektet',0),(601875,16694,'sv','LeverantÃ¶r UPC',0),(601876,16695,'sv','RTV nummer',0),(601877,16696,'sv','Restorder',0),(601878,16697,'sv','Kan inte Ã¤ndra denna ordning att slÃ¤ppa fartyget',0),(601879,16698,'sv','Nuvarande plats',0),(601880,16699,'sv','Order har transporter av icke-Drop Ship objekt',0),(601881,16700,'sv','Orderkvantiteten inte tillgÃ¤ngliga pÃ¥ plats',0),(601882,16701,'sv','Minska kvantiteten',0),(601883,16702,'sv','FÃ¶ljande icke-Drop Ship objekt tas bort',0),(601884,16703,'sv','Kupong-ID',0),(601885,16704,'sv','PrimÃ¤ra kÃ¶paren',0),(601886,16705,'sv','Om lÃ¤net inte pÃ¥ listan',0),(601887,16706,'sv','UppdateringsÃ¥tgÃ¤rden',0),(601888,16707,'sv','KrÃ¤ver kostnad koder om GL-konto har kostat koder',0),(601889,16708,'sv','KrÃ¤ver GL kategori om GL konto har GL kategorier',0),(601890,16709,'sv','Distribution Center',0),(601891,16710,'sv','Ã„r distributionscenter?',0),(601892,16711,'sv','Kontrolleras',0),(601893,16712,'sv','Checka in',0),(601894,16713,'sv','Checka In nu',0),(601895,16714,'sv','Kontrollera i tid',0),(601896,16715,'sv','Spara anteckningar',0),(601897,16716,'sv','Uppdatering anteckningar',0),(601898,16717,'sv','Kunde inte hitta GL konto vid namn',0),(601899,16718,'sv','Patienten Import',0),(601900,16719,'sv','Fyll dag',0),(601901,16720,'sv','Senaste mÃ¶te',0),(601902,16721,'sv','VÃ¤nligen 777 chmod',0),(601903,16722,'sv','Alla avtalade tider',0),(601904,16723,'sv','Boka denna utnÃ¤mning',0),(601905,16724,'sv','Kommandot hittades inte',0),(601906,16725,'sv','BekrÃ¤fta tid',0),(601907,16726,'sv','Funktionen Ã¤r inte aktiverad',0),(601908,16727,'sv','NÃ¤sta mÃ¶te',0),(601909,16728,'sv','Inga kommande utnÃ¤mningen',0),(601910,16729,'sv','Ã–ppna mÃ¶ten fÃ¶r',0),(601911,16730,'sv','VÃ¤lj ett datum fÃ¶r att visa Ã¶ppna avtalade tider',0),(601912,16731,'sv','DÃ¤r',0),(601913,16732,'sv','SchemalÃ¤gga en avtalad tid',0),(601914,16733,'sv','VÃ¤lj datum',0),(601915,16734,'sv','Typ av lager justering begÃ¤ran',0),(601916,16735,'sv','Inventering justeringstypen begÃ¤ran av denna kod finns redan',0),(601917,16736,'sv','Lager justering begÃ¤ran typkod mÃ¥ste anges',0),(601918,16737,'sv','InlÃ¤gget av frakt & emot',0),(601919,16738,'sv','Logga In som anvÃ¤ndaren',0),(601920,16739,'sv','Citattecken',0),(601921,16503,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸­à¹ˆà¸²à¸™à¸£à¸°à¹€à¸šà¸µà¸¢à¸™',0),(601922,16504,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸žà¸´à¹ˆà¸¡',0),(601923,16505,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(601924,16506,'th','à¹à¸šà¸šà¸Ÿà¸­à¸£à¹Œà¸¡à¸—à¸µà¹ˆà¹„à¸¡à¹ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(601925,16507,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸­à¹ˆà¸²à¸™à¹à¸Ÿà¹‰à¸¡',0),(601926,16508,'th','à¸Ÿà¸´à¸¥à¸”à¹Œà¹à¸šà¸šà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡ Add-on à¸—à¸µà¹ˆà¸ˆà¸³à¹€à¸›à¹‡à¸™',0),(601927,16509,'th','à¸ à¸²à¸£à¸°à¸„à¹ˆà¸²à¸‚à¸™à¸ªà¹ˆà¸‡',0),(601928,16510,'th','à¸ à¸²à¸£à¸°à¸„à¹ˆà¸²à¸‚à¸™à¸ªà¹ˆà¸‡',0),(601929,16511,'th','à¸£à¸§à¸¡à¸£à¸²à¸¢à¸à¸²à¸£à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¹‰à¸™à¸›à¸µ',0),(601930,16512,'th','à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(601931,16513,'th','à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸£à¸«à¸±à¸ªà¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(601932,16514,'th','à¸•à¹‰à¸­à¸‡à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸£à¸«à¸±à¸ªà¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(601933,16515,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(601934,16516,'th','à¸•à¹‰à¸­à¸‡à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡ à¸šà¸£à¸´à¸©à¸±à¸—à¹‚à¸­à¸™à¸šà¸±à¸à¸Šà¸µà¸•à¸£à¸‡à¸‚à¹‰à¸²à¸¡',0),(601935,16517,'th','à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸šà¸£à¸´à¸©à¸±à¸—à¸—à¸µà¹ˆà¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸² - à¸žà¸´à¸¡à¸žà¹Œ',0),(601936,16518,'th','à¸•à¹‰à¸­à¸‡à¸à¸³à¸«à¸™à¸”à¸šà¸±à¸à¸Šà¸µà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸šà¸™à¸£à¸²à¸¢à¸à¸²à¸£à¸«à¸£à¸·à¸­à¸šà¸±à¸à¸Šà¸µà¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”à¹ƒà¸«à¹‰à¹ƒà¸™à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±',0),(601937,16519,'th','Num à¹€à¸”à¸·à¸­à¸™à¸‚à¸²à¸¢à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸£à¸´à¸¡à¸²à¸“à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¹ƒà¸«à¸¡à¹ˆ',0),(601938,16520,'th','Num à¹€à¸”à¸·à¸­à¸™à¸à¸²à¸£à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(601939,16521,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(601940,16522,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(601941,16523,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(601942,16524,'th','à¸§à¸±à¸™à¸¢à¸­à¸¡à¸£à¸±à¸š',0),(601943,16525,'th','à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(601944,16526,'th','à¸à¸³à¸«à¸™à¸”à¹ƒà¸«à¹‰',0),(601945,16527,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”',0),(601946,16528,'th','à¸™à¸±à¸š',0),(601947,16529,'th','à¸Šà¸™à¸´à¸”à¸ˆà¸³à¸™à¸§à¸™',0),(601948,16530,'th','à¸§à¸±à¸™à¸—à¸µà¹ˆà¸à¸³à¸«à¸™à¸”',0),(601949,16531,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸•à¸£à¸§à¸ˆà¸™à¸±à¸š',0),(601950,16532,'th','à¸¥à¹ˆà¸²à¸ªà¸¸à¸”à¹‚à¸”à¸¢',0),(601951,16533,'th','à¸™à¸±à¸šà¸£à¹‰à¸­à¸¢',0),(601952,16534,'th','à¸›à¸£à¸°à¹€à¸ à¸—à¸„à¸³à¸‚à¸­',0),(601953,16535,'th','à¸„à¸³à¸‚à¸­à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸«à¸¸à¹‰à¸™',0),(601954,16536,'th','à¸„à¸³à¸‚à¸­à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸«à¸¸à¹‰à¸™',0),(601955,16537,'th','à¸ªà¸–à¸²à¸™à¸°à¸„à¸³à¸‚à¸­à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¸«à¸¸à¹‰à¸™',0),(601956,16538,'th','à¸œà¸¥à¸•à¹ˆà¸²à¸‡à¸„à¹ˆà¸² Amt',0),(601957,16539,'th','à¸£à¹‰à¸­à¸¢à¸¥à¸°à¸„à¹ˆà¸²à¸„à¸§à¸²à¸¡à¹à¸›à¸£à¸›à¸£à¸§à¸™',0),(601958,16540,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚à¹€à¸‚à¸•',0),(601959,16541,'th','à¸ˆà¸±à¸”à¸à¸³à¸«à¸™à¸”à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(601960,16542,'th','à¸à¸²à¸£à¸ˆà¸±à¸”à¸à¸²à¸£à¸ˆà¸³à¸™à¸§à¸™',0),(601961,16543,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(601962,16544,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸‚à¸²à¸¢à¸”à¸´à¸™à¹à¸”à¸™',0),(601963,16545,'th','à¸ à¸²à¸©à¸µà¸™à¸³à¹€à¸‚à¹‰à¸²',0),(601964,16546,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸ªà¸±à¹ˆà¸‡ Froms',0),(601965,16547,'th','à¸ à¸²à¸£à¸°à¸‚à¸™à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸šà¸£à¸´à¸©à¸±à¸—',0),(601966,16548,'th','à¸Šà¸™à¸´à¸”à¸„à¸³à¸‚à¸­à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(601967,16549,'th','à¸‚à¸­à¹€à¸Šà¹‡à¸„à¸ªà¸•à¹‡à¸­à¸à¹ƒà¸«à¸¡à¹ˆ',0),(601968,16550,'th','à¸à¸²à¸£à¹à¸šà¹ˆà¸‡à¸£à¸°à¸¢à¸°à¸žà¸·à¹‰à¸™à¸—à¸µà¹ˆ',0),(601969,16551,'th','à¸ˆà¸±à¸”à¹€à¸•à¸£à¸µà¸¢à¸¡',0),(601970,16552,'th','à¸šà¸±à¸à¸Šà¸µà¸žà¸´à¸¡à¸žà¹Œà¸œà¸´à¸”',0),(601971,16553,'th','à¸ˆà¸³à¸™à¸§à¸™à¹„à¸¡à¹ˆà¸žà¸šà¸šà¸±à¸à¸Šà¸µà¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸•à¸²à¸¡à¸Šà¸·à¹ˆà¸­',0),(601972,16554,'th','à¸•à¸£à¸§à¸ˆà¸™à¸±à¸šà¹„à¸¡à¹ˆà¸žà¸šà¸šà¸±à¸à¸Šà¸µà¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š à¹‚à¸”à¸¢à¸Šà¸·à¹ˆà¸­',0),(601973,16555,'th','à¸ˆà¸³à¸™à¸§à¸™à¹„à¸¡à¹ˆà¸«à¸²à¸§à¸´à¸˜à¸µà¸•à¸²à¸¡à¸Šà¸·à¹ˆà¸­à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(601974,16556,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸•à¸£à¸‡à¸à¸±à¸™ Muliple',0),(601975,16557,'th','à¸£à¸«à¸±à¸ªà¹„à¸›à¸£à¸©à¸“à¸µà¸¢à¹Œà¸«à¸£à¸·à¸­à¸ªà¸–à¸²à¸™à¸°à¸—à¸µà¹ˆà¸ˆà¸³à¹€à¸›à¹‡à¸™',0),(601976,16558,'th','à¸‚à¸²à¸¢ ID',0),(601977,16559,'th','à¸•à¹‰à¸­à¸‡à¸•à¸±à¹‰à¸‡à¸Šà¸·à¹ˆà¸­à¸«à¸£à¸·à¸­à¸£à¸«à¸±à¸ªà¸žà¸™à¸±à¸à¸‡à¸²à¸™à¸‚à¸²à¸¢',0),(601978,16560,'th','à¸£à¸«à¸±à¸ªà¸ªà¸–à¸²à¸™à¸°',0),(601979,16561,'th','à¸•à¹‰à¸­à¸‡à¸•à¸±à¹‰à¸‡à¸Šà¸·à¹ˆà¸­ à¸šà¸£à¸´à¸©à¸±à¸—à¸œà¸¹à¹‰à¸‚à¸²à¸¢',0),(601980,16562,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹€à¸ªà¹‰à¸™à¸—à¸²à¸‡à¸˜à¸™à¸²à¸„à¸²à¸£',0),(601981,16563,'th','à¸§à¸´à¸˜à¸µà¸à¸²à¸£à¸Šà¸³à¸£à¸°à¹€à¸‡à¸´à¸™à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(601982,16564,'th','à¸•à¹‰à¸­à¸‡à¸à¸³à¸«à¸™à¸”à¸£à¸«à¸±à¸ªà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢',0),(601983,16565,'th','à¸§à¹ˆà¸²à¸‡à¹€à¸›à¸¥à¹ˆà¸²',0),(601984,16566,'th','à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸Šà¸™à¸´à¸”',0),(601985,16567,'th','à¸ˆà¸­à¸‡à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(601986,16568,'th','à¹€à¸›à¸´à¸”à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(601987,16569,'th','à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¸§à¸±à¸™à¸™à¸µà¹‰',0),(601988,16570,'th','à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(601989,16571,'th','à¸„à¸§à¸²à¸¡à¸¢à¸²à¸§à¸‚à¸­à¸‡à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(601990,16572,'th','à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¸£à¸²à¸¢à¸à¸²à¸£à¸ªà¸³à¸«à¸£à¸±à¸š',0),(601991,16573,'th','à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(601992,16574,'th','à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¸Šà¸·à¹ˆà¸­',0),(601993,16575,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸ªà¸£à¸¸à¸›à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(601994,16576,'th','à¸ˆà¸±à¸”à¸à¸³à¸«à¸™à¸”à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢ B2B',0),(601995,16577,'th','à¸ªà¸£à¹‰à¸²à¸‡à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¹€à¸›à¸´à¸”',0),(601996,16578,'th','à¸¥à¸šà¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¸—à¸µà¹ˆà¹€à¸›à¸´à¸”',0),(601997,16579,'th','à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¹ƒà¸™à¸­à¸™à¸²à¸„à¸•à¸•à¹ˆà¸­à¹„à¸›',0),(601998,16580,'th','à¹€à¸¥à¸·à¸­à¸à¸§à¸±à¸™à¸—à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹ à¹à¸¥à¸°à¹à¸à¹‰à¹„à¸‚à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(601999,16581,'th','à¹à¸ªà¸”à¸‡à¸ªà¸£à¸¸à¸›',0),(602000,16582,'th','Unbook à¹à¸•à¹ˆà¸‡à¸•à¸±à¹‰à¸‡',0),(602001,16583,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸‚à¸•à¹ƒà¸«à¸¡à¹ˆ',0),(602002,16584,'th','à¸Šà¸·à¹ˆà¸­à¹€à¸‚à¸•',0),(602003,16585,'th','à¸œà¸¹à¹‰à¸›à¸à¸„à¸£à¸­à¸‡à¸£à¸±à¸',0),(602004,16586,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸›à¹‰à¸­à¸™à¸Šà¸·à¹ˆà¸­à¹€à¸‚à¸•',0),(602005,16587,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¹€à¸¥à¸·à¸­à¸à¸ªà¸–à¸²à¸™à¸°',0),(602006,16588,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸¥à¸šà¹€à¸‚à¸•à¸™à¸µà¹‰à¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(602007,16589,'th','à¸¥à¸šà¹€à¸‚à¸•',0),(602008,16590,'th','à¹à¸à¹‰à¹„à¸‚à¹à¸šà¸šà¸à¸³à¸«à¸™à¸”à¹€à¸­à¸‡à¹€à¸‚à¸•',0),(602009,16591,'th','à¸žà¸´à¸ˆà¸²à¸£à¸“à¸²à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸‚à¸•à¹ƒà¸«à¸¡à¹ˆ',0),(602010,16592,'th','à¹à¸à¹‰à¸„à¸±à¸™',0),(602011,16593,'th','à¹€à¸¥à¸·à¸­à¸à¸‚à¸­à¸‡à¸„à¸¸à¸“à¹€à¸›à¹‡à¸™à¸„à¹ˆà¸²à¸£à¸°à¸šà¸š à¹à¸¥à¸°à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¹à¸›à¸¥à¸‡',0),(602012,16594,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸£à¸­à¸à¹à¸šà¸šà¸Ÿà¸­à¸£à¹Œà¸¡à¹€à¸žà¸·à¹ˆà¸­à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸•à¹ˆà¸­à¹„à¸›',0),(602013,16595,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸¥à¸¹à¸à¸„à¹‰à¸²',0),(602014,16596,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸‚à¹‰à¸²à¸¡à¹„à¸›',0),(602015,16597,'th','à¸¥à¸¹à¸à¸„à¹‰à¸²à¸—à¸µà¹ˆà¸¡à¸µà¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(602016,16598,'th','à¸­à¹ˆà¸²à¸™à¸šà¸£à¸£à¸—à¸±à¸”',0),(602017,16599,'th','à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œà¸ªà¸³à¸£à¸­à¸‡',0),(602018,16600,'th','à¸™à¸³à¹€à¸‚à¹‰à¸²à¹à¸Ÿà¹‰à¸¡ CSV',0),(602019,16601,'th','à¸œà¸¹à¹‰à¹ƒà¸«à¹‰à¸šà¸£à¸´à¸à¸²à¸£à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œà¸¡à¸·à¸­à¸–à¸·à¸­',0),(602020,16602,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚à¹‚à¸—à¸£à¸¨à¸±à¸žà¸—à¹Œà¸¡à¸·à¸­à¸–à¸·à¸­',0),(602021,16603,'th','à¹€à¸¥à¸·à¸­à¸à¹ƒà¸šà¹à¸ˆà¹‰à¸‡à¸«à¸™à¸µà¹‰à¹€à¸‡à¸·à¹ˆà¸­à¸™à¹„à¸‚',0),(602022,16604,'th','à¸Šà¸·à¹ˆà¸­à¸¢à¹ˆà¸­à¸£à¸±à¸',0),(602023,16605,'th','à¸—à¸µà¹ˆà¸­à¸¢à¸¹à¹ˆ',0),(602024,16606,'th','à¹€à¸žà¸´à¹ˆà¸¡à¸«à¸£à¸·à¸­à¹à¸à¹‰à¹„à¸‚',0),(602025,16607,'th','à¸¢à¸­à¸”à¸‚à¸²à¸¢à¹€à¸‰à¸¥à¸µà¹ˆà¸¢à¸•à¹ˆà¸­à¹€à¸”à¸·à¸­à¸™',0),(602026,16608,'th','à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™à¸­à¸¸à¸›à¸—à¸²à¸™',0),(602027,16609,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸Šà¹ˆà¸­à¸‡à¸«à¸¥à¸±à¸',0),(602028,16610,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹ƒà¸™à¸à¸²à¸£à¹‚à¸­à¸™',0),(602029,16611,'th','à¹€à¸•à¸´à¸¡à¸ªà¸•à¹‡à¸­à¸à¸ˆà¸²à¸à¸¨à¸¹à¸™à¸¢à¹Œà¸à¸£à¸°à¸ˆà¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(602030,16612,'th','à¹à¸™à¸°à¸™à¸³',0),(602031,16613,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸à¸²à¸£à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢',0),(602032,16614,'th','à¹‚à¸‹à¸™',0),(602033,16615,'th','à¹€à¸¡à¸·à¸­à¸‡à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸•à¸´à¸¡',0),(602034,16616,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸¡à¸·à¸­à¸‡',0),(602035,16617,'th','à¹€à¸žà¸´à¹ˆà¸¡à¹€à¸‚à¸•',0),(602036,16618,'th','à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¹€à¸‚à¸•',0),(602037,16619,'th','à¸­à¹€à¸¡à¸£à¸´à¸à¸²à¹€à¸žà¸´à¹ˆà¸¡',0),(602038,16620,'th','à¸£à¸±à¸à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(602039,16621,'th','à¸„à¸¸à¸“à¸•à¹‰à¸­à¸‡à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸°à¹€à¸šà¸µà¸¢à¸™à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢à¸‚à¸­à¸‡à¸„à¸¸à¸“à¹à¸™à¹ˆà¹ƒà¸ˆà¸«à¸£à¸·à¸­à¹„à¸¡à¹ˆ',0),(602040,16622,'th','à¸Šà¸·à¹ˆà¸­à¹€à¸¡à¸·à¸­à¸‡',0),(602041,16623,'th','à¹€à¸¡à¸·à¸­à¸‡à¸„à¸¹à¸“à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢',0),(602042,16624,'th','à¹€à¸¡à¸·à¸­à¸‡à¹ƒà¸Šà¹‰à¸ à¸²à¸©à¸µà¸„à¸¹à¸“',0),(602043,16625,'th','à¸•à¸±à¸§à¸„à¸¹à¸“à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢à¸‚à¸­à¸‡à¹€à¸‚à¸•',0),(602044,16626,'th','à¸•à¸±à¸§à¸„à¸¹à¸“à¸ à¸²à¸©à¸µà¹ƒà¸Šà¹‰à¹€à¸‚à¸•',0),(602045,16627,'th','à¸ à¸²à¸©à¸µà¸™à¸³à¹€à¸‚à¹‰à¸²',0),(602046,16628,'th','à¸•à¸±à¸§à¸„à¸¹à¸“à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢',0),(602047,16629,'th','à¸£à¸±à¸à¹ƒà¸Šà¹‰à¸ à¸²à¸©à¸µà¸„à¸¹à¸“',0),(602048,16630,'th','à¸—à¸­à¸¡à¸ªà¸±à¸™à¸£à¸­à¸¢à¹€à¸•à¸­à¸£à¹Œà¹à¸—à¹‡à¸šà¹à¸Ÿà¹‰à¸¡',0),(602049,16631,'th','à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(602050,16632,'th','à¹€à¸à¹‡à¸šà¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(602051,16633,'th','à¸¥à¹‰à¸²à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆ',0),(602052,16634,'th','à¸¥à¹‰à¸²à¸‡à¸‚à¹‰à¸­à¸¡à¸¹à¸¥à¸—à¸µà¹ˆà¸¡à¸µà¸­à¸¢à¸¹à¹ˆà¸ªà¸³à¸«à¸£à¸±à¸šà¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¹ƒà¸™à¸à¸²à¸£à¸™à¸³à¹€à¸‚à¹‰à¸²',0),(602053,16635,'th','à¹€à¸„à¸£à¸”à¸´à¸•à¸œà¸¹à¹‰à¸ˆà¸±à¸”à¸ˆà¸³à¸«à¸™à¹ˆà¸²à¸¢à¸—à¸µà¹ˆà¸„à¹‰à¸²à¸‡à¸­à¸¢à¸¹à¹ˆ',0),(602054,16636,'th','à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¹€à¸¥à¸·à¸­à¸à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢à¸ˆà¸²à¸à¹€à¸£à¸·à¸­',0),(602055,16637,'th','à¸•à¸­à¸šà¸ªà¸™à¸­à¸‡à¹à¸¥à¸°à¸ªà¸±à¹ˆà¸‡ POS',0),(602056,16638,'th','à¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ˆà¸²à¸à¸¨à¸¹à¸™à¸¢à¹Œà¸à¸£à¸°à¸ˆà¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²à¹€à¸—à¹ˆà¸²à¸™à¸±à¹‰à¸™',0),(602057,16639,'th','à¸ à¸²à¸©à¸µà¸‚à¸²à¸¢à¸—à¸µà¹ˆà¹€à¸¥à¸·à¸­à¸à¹‚à¸”à¸¢à¸­à¸±à¸•à¹‚à¸™à¸¡à¸±à¸•à¸´à¸ˆà¸²à¸à¹€à¸£à¸·à¸­à¹€à¸žà¸·à¹ˆà¸­à¸•à¸­à¸šà¸ªà¸™à¸­à¸‡à¹à¸¥à¸°à¸ªà¸±à¹ˆà¸‡ POS',0),(602058,16640,'th','à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢à¸à¸²à¸à¸ªà¹ˆà¸‡à¸•à¹‰à¸­à¸‡à¹ƒà¸Šà¹‰ POD',0),(602059,16641,'th','à¹à¸™à¸°à¸™à¸³à¸ªà¸–à¸²à¸™à¸‹à¸·à¹‰à¸­à¸—à¸µà¹ˆà¸­à¸·à¹ˆà¸™à¹€à¸¡à¸·à¹ˆà¸­à¸¡à¸µà¸›à¸£à¸´à¸¡à¸²à¸“',0),(602060,16642,'th','à¸¢à¸à¹€à¸§à¹‰à¸™à¸ à¸²à¸©à¸µà¸šà¸²à¸‡à¸ªà¹ˆà¸§à¸™',0),(602061,16643,'th','à¸ à¸²à¸©à¸µà¸­à¸±à¸•à¸£à¸²à¸£à¹‰à¸­à¸¢à¸¥à¸°',0),(602062,16644,'th','à¸¨à¸¹à¸™à¸¢à¹Œà¸à¸£à¸°à¸ˆà¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸² Num à¹€à¸”à¸·à¸­à¸™à¸‚à¸²à¸¢à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸„à¸³à¸™à¸§à¸“à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¹ƒà¸«à¸¡à¹ˆ',0),(602063,16645,'th','à¹€à¸›à¸­à¸£à¹Œà¹€à¸‹à¹‡à¸™à¸•à¹Œà¸ à¸²à¸£à¸° interbranch à¹‚à¸­à¸™à¸šà¸±à¸à¸Šà¸µ',0),(602064,16646,'th','à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸šà¸£à¸´à¸©à¸±à¸—à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸² - à¸­à¸™à¸¸à¸à¸²à¸•à¹ƒà¸«à¹‰à¸«à¸¥à¸²à¸¢à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡',0),(602065,16647,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸² - à¸à¸²à¸£à¸¥à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸šà¸±à¸à¸Šà¸µà¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸šà¸£à¸´à¸©à¸±à¸—',0),(602066,16648,'th','à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¹ƒà¸™à¸šà¸±à¸à¸Šà¸µà¹à¸¢à¸à¸›à¸£à¸°à¹€à¸ à¸—à¸—à¸±à¹ˆà¸§à¹„à¸›à¸‚à¸™à¸ªà¹ˆà¸‡',0),(602067,16649,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸¨à¸¹à¸™à¸¢à¹Œà¸¯ Num à¹€à¸”à¸·à¸­à¸™à¸‚à¸²à¸¢à¸ªà¸³à¸«à¸£à¸±à¸šà¸à¸²à¸£à¸„à¸³à¸™à¸§à¸“à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¹ƒà¸«à¸¡à¹ˆ',0),(602068,16650,'th','à¹‚à¸žà¸ªà¸•à¹Œ à¹‚à¸”à¸¢à¸šà¸£à¸£à¸—à¸±à¸”',0),(602069,16651,'th','à¹‚à¸žà¸ªà¸•à¹Œà¹‚à¸”à¸¢à¸ªà¹ˆà¸‡ à¹à¸¥à¸°à¸£à¸±à¸š',0),(602070,16652,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸š B2B',0),(602071,16653,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¹ƒà¸™à¸à¸²à¸™à¸°à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸™à¸µà¹‰',0),(602072,16654,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¸šà¸±à¸™à¸—à¸¶à¸à¹€à¸›à¹‡à¸™à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸—à¸µà¹ˆà¸ªà¸¡à¸šà¸¹à¸£à¸“à¹Œ',0),(602073,16655,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¹à¸Ÿà¹‰à¸¡ POD à¸—à¸µà¹ˆà¹à¸™à¸šà¸à¸±à¸šà¹ƒà¸šà¸ªà¸±à¹ˆà¸‡',0),(602074,16656,'th','à¹€à¸£à¸·à¸­à¸¥à¸”à¸¥à¸‡',0),(602075,16657,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¹à¸¥à¸°à¹€à¸à¹‡à¸š',0),(602076,16658,'th','à¸›à¸´à¸” à¹‚à¸”à¸¢à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(602077,16659,'th','à¸›à¸´à¸”à¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸— GL',0),(602078,16660,'th','à¸›à¸´à¸”à¸šà¸±à¸à¸Šà¸µ à¸”à¹‰à¸§à¸¢à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™',0),(602079,16661,'th','à¸›à¸´à¸”à¸šà¸±à¸à¸Šà¸µà¸•à¸²à¸¡à¸›à¸£à¸°à¹€à¸ à¸— GL',0),(602080,16662,'th','à¸§à¸±à¸™à¸¢à¸à¹€à¸¥à¸´à¸',0),(602081,16663,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸Šà¹ˆà¸§à¸‡à¹€à¸§à¸¥à¸² 13',0),(602082,16664,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ à¸²à¸©à¸µ',0),(602083,16665,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¹‰à¸™à¸›à¸µ',0),(602084,16666,'th','à¸£à¸²à¸¢à¸à¸²à¸£à¸£à¸­à¸šà¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²à¸—à¸µà¹ˆ 13',0),(602085,16667,'th','à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸£à¸²à¸¢à¸à¸²à¸£à¸ à¸²à¸©à¸µ',0),(602086,16668,'th','à¸à¸±à¸šà¸£à¸²à¸¢à¸à¸²à¸£à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¹‰à¸™à¸›à¸µ',0),(602087,16669,'th','-à¸«à¸¸à¹‰à¸™',0),(602088,16670,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸­à¸·à¹ˆà¸™ à¹†',0),(602089,16671,'th','à¸„à¹ˆà¸²à¸˜à¸£à¸£à¸¡à¹€à¸™à¸µà¸¢à¸¡à¸­à¸·à¹ˆà¸™ à¹†',0),(602090,16672,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸£à¸°à¸«à¸§à¹ˆà¸²à¸‡à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡',0),(602091,16673,'th','à¹‚à¸­à¸™à¸¢à¹‰à¸²à¸¢à¸£à¸²à¸¢à¸¥à¸°à¹€à¸­à¸µà¸¢à¸”',0),(602092,16674,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸ªà¸•à¹‡à¸­à¸',0),(602093,16675,'th','à¹ƒà¸«à¹‰à¹€à¸Šà¹ˆà¸²',0),(602094,16676,'th','à¸¡à¸µà¹ƒà¸™à¸ªà¸•à¹‡à¸­à¸',0),(602095,16677,'th','0 à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¹„à¸¡à¹ˆ',0),(602096,16678,'th','0 à¸™à¸²à¸—à¸µà¹„à¸¡à¹ˆ',0),(602097,16679,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¹€à¸‰à¸¥à¸µà¹ˆà¸¢à¸•à¹ˆà¸­à¹€à¸”à¸·à¸­à¸™',0),(602098,16680,'th','à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¸—à¸µà¹ˆà¸ªà¸£à¹‰à¸²à¸‡à¸‚à¸¶à¹‰à¸™',0),(602099,16681,'th','à¸ªà¸£à¹‰à¸²à¸‡à¹ƒà¸šà¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(602100,16682,'th','à¸¨à¸¹à¸™à¸¢à¹Œà¸à¸£à¸°à¸ˆà¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(602101,16683,'th','à¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆà¹€à¸à¹‡à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(602102,16684,'th','à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¹ƒà¸™à¸¡à¸·à¸­',0),(602103,16685,'th','à¸™à¸²à¸—à¸µà¸šà¸™à¸¡à¸·à¸­',0),(602104,16686,'th','à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸‚à¸­à¸‡à¸‰à¸±à¸™',0),(602105,16687,'th','Num à¹€à¸”à¸·à¸­à¸™à¸‚à¸²à¸¢à¸ªà¸¹à¸‡à¸ªà¸¸à¸”à¹ƒà¸™à¸¡à¸·à¸­',0),(602106,16688,'th','Num à¹€à¸”à¸·à¸­à¸™à¸‚à¸²à¸¢à¸­à¸¢à¹ˆà¸²à¸‡à¸™à¹‰à¸­à¸¢à¸„à¸‡',0),(602107,16689,'th','Num à¹€à¸”à¸·à¸­à¸™à¸‚à¸²à¸¢à¸ªà¸³à¸«à¸£à¸±à¸šà¸›à¸£à¸´à¸¡à¸²à¸“à¸—à¸µà¹ˆà¸ªà¸±à¹ˆà¸‡',0),(602108,16690,'th','à¹€à¸›à¹‡à¸™à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™',0),(602109,16691,'th','à¸ˆà¸³à¸™à¸§à¸™à¸§à¸±à¸™',0),(602110,16692,'th','à¹€à¸ªà¸™à¸­à¸£à¸²à¸„à¸²à¸£à¸°à¸¢à¸°à¹€à¸§à¸¥à¸²',0),(602111,16693,'th','à¸à¸²à¸£à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸œà¸¹à¹‰à¸‚à¸²à¸¢à¸™à¸µà¹‰à¹€à¸›à¹‡à¸™à¸„à¹ˆà¸²à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸™à¸µà¹‰à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ˆà¸°à¹€à¸­à¸²à¸‚à¸²à¸¢à¹€à¸£à¸´à¹ˆà¸¡à¸•à¹‰à¸™à¸­à¸·à¹ˆà¸™ à¹† à¸ªà¸³à¸«à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸™à¸µà¹‰',0),(602112,16694,'th','à¸‚à¸²à¸¢ UPC',0),(602113,16695,'th','à¸«à¸¡à¸²à¸¢à¹€à¸¥à¸‚ RTV',0),(602114,16696,'th','à¸«à¸¥à¸±à¸‡à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(602115,16697,'th','à¹„à¸¡à¹ˆà¸ªà¸²à¸¡à¸²à¸£à¸–à¹€à¸›à¸¥à¸µà¹ˆà¸¢à¸™à¸¥à¸³à¸”à¸±à¸šà¸à¸²à¸£à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡',0),(602116,16698,'th','à¸•à¸³à¹à¸«à¸™à¹ˆà¸‡à¸—à¸µà¹ˆà¸•à¸±à¹‰à¸‡à¸›à¸±à¸ˆà¸ˆà¸¸à¸šà¸±à¸™',0),(602117,16699,'th','à¸ªà¸±à¹ˆà¸‡à¹„à¸”à¹‰à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸ˆà¸±à¸”à¸ªà¹ˆà¸‡à¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆà¸›à¸¥à¹ˆà¸­à¸¢',0),(602118,16700,'th','à¸›à¸£à¸´à¸¡à¸²à¸“à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­à¹„à¸¡à¹ˆà¸¡à¸µà¸ªà¸–à¸²à¸™à¸—à¸µà¹ˆ',0),(602119,16701,'th','à¸¥à¸”à¸›à¸£à¸´à¸¡à¸²à¸“à¸à¸²à¸£à¸ªà¸±à¹ˆà¸‡à¸‹à¸·à¹‰à¸­',0),(602120,16702,'th','à¸•à¹ˆà¸­à¹„à¸›à¹„à¸¡à¹ˆà¹ƒà¸Šà¹ˆà¸›à¸¥à¹ˆà¸­à¸¢à¹€à¸£à¸·à¸­à¸ˆà¸°à¸–à¸¹à¸à¹€à¸­à¸²à¸­à¸­à¸',0),(602121,16703,'th','à¸£à¸«à¸±à¸ªà¸„à¸¹à¸›à¸­à¸‡',0),(602122,16704,'th','à¸œà¸¹à¹‰à¸‹à¸·à¹‰à¸­à¸«à¸¥à¸±à¸',0),(602123,16705,'th','à¸–à¹‰à¸²à¹€à¸‚à¸•à¹„à¸¡à¹ˆà¹„à¸”à¹‰à¸­à¸¢à¸¹à¹ˆà¹ƒà¸™à¸£à¸²à¸¢à¸à¸²à¸£',0),(602124,16706,'th','à¸”à¸³à¹€à¸™à¸´à¸™à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(602125,16707,'th','à¹ƒà¸Šà¹‰à¸£à¸«à¸±à¸ªà¸•à¹‰à¸™à¸—à¸¸à¸™à¸–à¹‰à¸²à¸šà¸±à¸à¸Šà¸µà¸¡à¸µà¸•à¹‰à¸™à¸—à¸¸à¸™à¸£à¸«à¸±à¸ª',0),(602126,16708,'th','à¸•à¹‰à¸­à¸‡à¸¡à¸µà¸›à¸£à¸°à¹€à¸ à¸— GL à¸šà¸±à¸à¸Šà¸µ GL à¸¡à¸µà¸›à¸£à¸°à¹€à¸ à¸— GL',0),(602127,16709,'th','à¸¨à¸¹à¸™à¸¢à¹Œà¸à¸£à¸°à¸ˆà¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(602128,16710,'th','à¹€à¸›à¹‡à¸™à¸¨à¸¹à¸™à¸¢à¹Œà¸à¸£à¸°à¸ˆà¸²à¸¢à¸ªà¸´à¸™à¸„à¹‰à¸²',0),(602129,16711,'th','à¹ƒà¸™à¸à¸²à¸£à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸š',0),(602130,16712,'th','à¹€à¸Šà¹‡à¸„à¸­à¸´à¸™',0),(602131,16713,'th','à¸•à¸£à¸§à¸ˆà¸ªà¸­à¸šà¹ƒà¸™à¸‚à¸“à¸°à¸™à¸µà¹‰',0),(602132,16714,'th','à¹€à¸§à¸¥à¸²à¹€à¸Šà¹‡à¸„à¸­à¸´à¸™',0),(602133,16715,'th','à¸šà¸±à¸™à¸—à¸¶à¸à¸šà¸±à¸™à¸—à¸¶à¸à¸¢à¹ˆà¸­',0),(602134,16716,'th','à¸«à¸¡à¸²à¸¢à¹€à¸«à¸•à¸¸à¹‚à¸›à¸£à¹à¸à¸£à¸¡à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡',0),(602135,16717,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸šà¸±à¸à¸Šà¸µ GL à¸•à¸²à¸¡à¸Šà¸·à¹ˆà¸­',0),(602136,16718,'th','à¸™à¸³à¸œà¸¹à¹‰à¸›à¹ˆà¸§à¸¢',0),(602137,16719,'th','à¹€à¸•à¸´à¸¡à¸§à¸±à¸™',0),(602138,16720,'th','à¸™à¸±à¸”à¸ªà¸¸à¸”à¸—à¹‰à¸²à¸¢',0),(602139,16721,'th','à¸à¸£à¸¸à¸“à¸² 777 chmod',0),(602140,16722,'th','à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¸—à¸±à¹‰à¸‡à¸«à¸¡à¸”',0),(602141,16723,'th','à¸ˆà¸­à¸‡à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¸™à¸µà¹‰',0),(602142,16724,'th','à¹„à¸¡à¹ˆà¸žà¸šà¸„à¸³à¸ªà¸±à¹ˆà¸‡',0),(602143,16725,'th','à¸¢à¸·à¸™à¸¢à¸±à¸™à¹€à¸§à¸¥à¸²à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(602144,16726,'th','à¹„à¸¡à¹ˆà¹€à¸›à¸´à¸”à¹ƒà¸Šà¹‰à¸‡à¸²à¸™à¸„à¸¸à¸“à¸¥à¸±à¸à¸©à¸“à¸°',0),(602145,16727,'th','à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¸–à¸±à¸”à¹„à¸›',0),(602146,16728,'th','à¹„à¸¡à¹ˆà¸¡à¸µà¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¹€à¸à¸´à¸”à¸‚à¸¶à¹‰à¸™',0),(602147,16729,'th','à¹€à¸›à¸´à¸”à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¸ªà¸³à¸«à¸£à¸±à¸š',0),(602148,16730,'th','à¹€à¸¥à¸·à¸­à¸à¸§à¸±à¸™à¸—à¸µà¹ˆà¹€à¸žà¸·à¹ˆà¸­à¸”à¸¹à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢à¸—à¸µà¹ˆà¹€à¸›à¸´à¸”',0),(602149,16731,'th','à¸—à¸µà¹ˆ',0),(602150,16732,'th','à¸ˆà¸±à¸”à¸à¸³à¸«à¸™à¸”à¸à¸²à¸£à¸™à¸±à¸”à¸«à¸¡à¸²à¸¢',0),(602151,16733,'th','à¹€à¸¥à¸·à¸­à¸à¸§à¸±à¸™',0),(602152,16734,'th','à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(602153,16735,'th','à¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸›à¸£à¸¸à¸‡à¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡à¸£à¸«à¸±à¸ªà¸™à¸µà¹‰à¸­à¸¢à¸¹à¹ˆà¹à¸¥à¹‰à¸§',0),(602154,16736,'th','à¸•à¹‰à¸­à¸‡à¸•à¸±à¹‰à¸‡à¸„à¹ˆà¸²à¸£à¸«à¸±à¸ªà¸Šà¸™à¸´à¸”à¸à¸²à¸£à¸£à¹‰à¸­à¸‡à¸‚à¸­à¸à¸²à¸£à¸›à¸£à¸±à¸šà¸ªà¸´à¸™à¸„à¹‰à¸²à¸„à¸‡à¸„à¸¥à¸±à¸‡',0),(602155,16737,'th','à¹‚à¸žà¸ªà¸•à¹Œà¹‚à¸”à¸¢à¸ªà¹ˆà¸‡ à¹à¸¥à¸°à¸£à¸±à¸š',0),(602156,16738,'th','à¹€à¸‚à¹‰à¸²à¸ªà¸¹à¹ˆà¸£à¸°à¸šà¸šà¹ƒà¸™à¸à¸²à¸™à¸°à¸œà¸¹à¹‰à¹ƒà¸Šà¹‰à¸™à¸µà¹‰',0),(602157,16739,'th','à¸£à¸§à¸¡à¸„à¸³à¸„à¸¡',0),(602158,16503,'tr','KaydÄ± okunamÄ±yor',0),(602159,16504,'tr','Eklenemedi',0),(602160,16505,'tr','GÃ¼ncelleÅŸtirilemedi',0),(602161,16506,'tr','Formu eksik',0),(602162,16507,'tr','DosyayÄ± okuyamÄ±yor',0),(602163,16508,'tr','Gerekli Ã¶zel alanlar eklemek-Ã¼stÃ¼nde',0),(602164,16509,'tr','Navlun yÃ¼k',0),(602165,16510,'tr','Navlun yÃ¼k',0),(602166,16511,'tr','YÄ±l sonu giriÅŸleri ayarlama dahil',0),(602167,16512,'tr','Stok ayarlama isteÄŸi tÃ¼rÃ¼',0),(602168,16513,'tr','Stok ayarlama isteÄŸi tÃ¼rÃ¼ bu kod tarafÄ±ndan zaten var',0),(602169,16514,'tr','Stok ayarlama isteÄŸi tÃ¼rÃ¼ kodu ayarlamanÄ±z gerekir',0),(602170,16515,'tr','Transfer oluÅŸturmak',0),(602171,16516,'tr','VarsayÄ±lan ÅŸirketlerarasÄ± Transfer mahsup hesabÄ± ayarlamanÄ±z gerekir',0),(602172,16517,'tr','Ã–ÄŸe Transfer - BaskÄ± ÅŸirketlerarasÄ±',0),(602173,16518,'tr','Madde veya stok kurulumunda atanan varsayÄ±lan hesap stok GL hesabÄ± atanmalÄ±dÄ±r',0),(602174,16519,'tr','NUM ay satÄ±ÅŸ iÃ§in yeniden sipariÅŸ Mkt.',0),(602175,16520,'tr','Num ay doldurmak iÃ§in',0),(602176,16521,'tr','Stok yenileme',0),(602177,16522,'tr','Stok yenileme transferler',0),(602178,16523,'tr','Kaydedilen transfer',0),(602179,16524,'tr','Kabul edilen tarihi',0),(602180,16525,'tr','Ayarlama tipi',0),(602181,16526,'tr','Atanan',0),(602182,16527,'tr','Atanan Tarih',0),(602183,16528,'tr','SaydÄ±m',0),(602184,16529,'tr','SayÄ±sÄ± tÃ¼rÃ¼',0),(602185,16530,'tr','Atanan Tarih',0),(602186,16531,'tr','SayÄ±lan Ã¶ÄŸeler',0),(602187,16532,'tr','Son GÃ¼ncellenme Tarihi tarafÄ±ndan',0),(602188,16533,'tr','YÃ¼zde sayÄ±lÄ±r',0),(602189,16534,'tr','Ä°stek tÃ¼rÃ¼',0),(602190,16535,'tr','Stok onay isteÄŸi',0),(602191,16536,'tr','Stok onay isteklerini',0),(602192,16537,'tr','Stok onay isteÄŸi durumu',0),(602193,16538,'tr','Varyans deÄŸeri Amt',0),(602194,16539,'tr','FarkÄ± deÄŸer yÃ¼zdesi',0),(602195,16540,'tr','Ä°lÃ§e Ekle/DÃ¼zenle',0),(602196,16541,'tr','Randevu zamanlayÄ±cÄ±',0),(602197,16542,'tr','Count yÃ¶netimi',0),(602198,16543,'tr','MÃ¼ÅŸteri bilgi alma',0),(602199,16544,'tr','Alma satÄ±cÄ± topraklarÄ±',0),(602200,16545,'tr','SatÄ±ÅŸ vergisi alma',0),(602201,16546,'tr','SatÄ±cÄ± sipariÅŸ su alma',0),(602202,16547,'tr','Transfer navlun yÃ¼k ÅŸirketlerarasÄ±',0),(602203,16548,'tr','Stok ayarlama istek tÃ¼rleri',0),(602204,16549,'tr','Yeni stok onay isteÄŸi',0),(602205,16550,'tr','Ã‡alÄ±ÅŸma alanlarÄ±',0),(602206,16551,'tr','DÃ¼zeylendirme alanÄ±na',0),(602207,16552,'tr','Hesap tÃ¼rÃ¼ yanlÄ±ÅŸ',0),(602208,16553,'tr','AdÄ±yla hesabÄ± deÄŸil bulduk',0),(602209,16554,'tr','Ã‡ek hesabÄ± ada gÃ¶re deÄŸil bulduk',0),(602210,16555,'tr','Sevkiyat yÃ¶ntemi ada gÃ¶re deÄŸil bulduk',0),(602211,16556,'tr','MaÃ§lar sendromlari satÄ±cÄ±lar',0),(602212,16557,'tr','Posta kodu veya gerekli devlet',0),(602213,16558,'tr','SatÄ±cÄ± kimliÄŸi',0),(602214,16559,'tr','SatÄ±cÄ± numarasÄ± ya da isim olarak ayarlanmalÄ±dÄ±r',0),(602215,16560,'tr','Durum kodu',0),(602216,16561,'tr','SatÄ±cÄ± Firma adÄ± veya soyadÄ± ayarlanmasÄ± gerekir',0),(602217,16562,'tr','Banka yÃ¶nlendirme numarasÄ±',0),(602218,16563,'tr','VarsayÄ±lan Ã¶deme yÃ¶ntemi',0),(602219,16564,'tr','SatÄ±cÄ± kodu ayarlamanÄ±z gerekir',0),(602220,16565,'tr','BoÅŸ',0),(602221,16566,'tr','TÃ¼rÃ¼ ayarÄ± yok',0),(602222,16567,'tr','AyÄ±rtÄ±ldÄ± randevular',0),(602223,16568,'tr','Randevu aÃ§',0),(602224,16569,'tr','Randevu bugÃ¼n',0),(602225,16570,'tr','Randevular toplam',0),(602226,16571,'tr','Randevu uzunluÄŸu',0),(602227,16572,'tr','Ä°Ã§in randevu listesi',0),(602228,16573,'tr','Randevu yeri',0),(602229,16574,'tr','Randevu adÄ±',0),(602230,16575,'tr','Randevu Ã–zeti',0),(602231,16576,'tr','B2B randevu zamanlayÄ±cÄ±',0),(602232,16577,'tr','Randevu aÃ§Ä±klÄ±klar oluÅŸturmak',0),(602233,16578,'tr','AÃ§Ä±k randevuyu Sil',0),(602234,16579,'tr','Gelecek bir sonraki randevu',0),(602235,16580,'tr','GÃ¶rÃ¼ntÃ¼lemek ve randevularÄ± dÃ¼zenlemek iÃ§in bir tarih seÃ§in',0),(602236,16581,'tr','Show Ã–zet',0),(602237,16582,'tr','Randevu unbook',0),(602238,16583,'tr','Yeni BÃ¶lge Ekle',0),(602239,16584,'tr','Ä°lÃ§e adÄ±',0),(602240,16585,'tr','Ãœst devlet',0),(602241,16586,'tr','Ä°lÃ§e adÄ± girmeniz gerekir',0),(602242,16587,'tr','Bir devlet seÃ§meniz gerekir',0),(602243,16588,'tr','Bu ilÃ§e silmek istediÄŸinizden emin misiniz?',0),(602244,16589,'tr','DELETE ÅŸehristanÄ±',0),(602245,16590,'tr','DÃ¼zenle Ã¶zel ÅŸehristanÄ±',0),(602246,16591,'tr','Yeni bir ilÃ§e eklemeyi dÃ¼ÅŸÃ¼nÃ¼n',0),(602247,16592,'tr','DÃ¼zenle ÅŸehristanÄ±',0),(602248,16593,'tr','SeÃ§iminiz bir sistem deÄŸerdir ve deÄŸiÅŸtirilemez',0),(602249,16594,'tr','Devam etmek iÃ§in Form doldurmanÄ±z gerekir',0),(602250,16595,'tr','MÃ¼ÅŸteriler eklendi',0),(602251,16596,'tr','MÃ¼ÅŸteriler atlandÄ±',0),(602252,16597,'tr','GÃ¼ncel mÃ¼ÅŸteriler',0),(602253,16598,'tr','SatÄ±rlarÄ± oku',0),(602254,16599,'tr','DiÄŸer telefon',0),(602255,16600,'tr','CSV alma dosyasÄ±',0),(602256,16601,'tr','Cep telefonu taÅŸÄ±yÄ±cÄ±',0),(602257,16602,'tr','Cep telefonu numarasÄ±',0),(602258,16603,'tr','Fatura ÅŸartlarÄ±nÄ± seÃ§in',0),(602259,16604,'tr','Eyalet kÄ±saltmasÄ±',0),(602260,16605,'tr','Sokak adresi',0),(602261,16606,'tr','Ekle/DÃ¼zenle',0),(602262,16607,'tr','AVG satÄ±ÅŸ aylÄ±k',0),(602263,16608,'tr','GeÃ§erli tedarik',0),(602264,16609,'tr','AtanmÄ±ÅŸ hiÃ§bir birincil depo gÃ¶zÃ¼',0),(602265,16610,'tr','Miktar transfer',0),(602266,16611,'tr','DaÄŸÄ±tÄ±m Merkezi stoktan doldurmak',0),(602267,16612,'tr','Ã–nerilen',0),(602268,16613,'tr','Miktar transfer',0),(602269,16614,'tr','BÃ¶lge',0),(602270,16615,'tr','Åžehirler eklendi',0),(602271,16616,'tr','GÃ¼ncellenme Tarihi ÅŸehirler',0),(602272,16617,'tr','Ä°lÃ§eler eklendi',0),(602273,16618,'tr','GÃ¼ncelleme ilÃ§eler',0),(602274,16619,'tr','BirleÅŸik eklendi',0),(602275,16620,'tr','GÃ¼ncelleme BirleÅŸik',0),(602276,16621,'tr','Vergi kayÄ±tlarÄ±nÄ±zÄ±n istediÄŸinizden emin misiniz?',0),(602277,16622,'tr','Åžehir adÄ±',0),(602278,16623,'tr','Åžehir satÄ±ÅŸ vergisi Ã§arpanÄ±',0),(602279,16624,'tr','Åžehir kullanÄ±m vergisi Ã§arpanÄ±',0),(602280,16625,'tr','Ä°lÃ§e satÄ±ÅŸ vergisi Ã§arpanÄ±',0),(602281,16626,'tr','Ä°lÃ§e kullanÄ±m vergisi Ã§arpanÄ±',0),(602282,16627,'tr','SatÄ±ÅŸ vergisi alma',0),(602283,16628,'tr','Eyalet satÄ±ÅŸ vergisi Ã§arpanÄ±',0),(602284,16629,'tr','Devlet kullanÄ±m vergisi Ã§arpanÄ±',0),(602285,16630,'tr','Thomson Reuters sekmesini dosya',0),(602286,16631,'tr','Varolan veri',0),(602287,16632,'tr','Varolan verileri tutmak',0),(602288,16633,'tr','Varolan tÃ¼m verileri temizlemek',0),(602289,16634,'tr','Alma satÄ±cÄ±lar iÃ§in varolan verilerini temizle',0),(602290,16635,'tr','Bekleyen satÄ±cÄ± kredisi',0),(602291,16636,'tr','Auto Select SatÄ±ÅŸ vergisinden gemiye',0),(602292,16637,'tr','Yerine getirilmesi ve POS sipariÅŸler',0),(602293,16638,'tr','YalnÄ±zca daÄŸÄ±tÄ±m merkezleri Ã¼zerinden sipariÅŸ bakiyesi izin',0),(602294,16639,'tr','Otomatik olarak satÄ±ÅŸ vergisi yerine getirilmesi ve POS sipariÅŸler iÃ§in gemide seÃ§in',0),(602295,16640,'tr','Son Sevkiyat POD gerektirir',0),(602296,16641,'tr','Alternatif satÄ±n alma konumlarÄ± miktar zaman mevcut deÄŸil Ã¶nermek',0),(602297,16642,'tr','KÄ±smi vergi muafiyeti',0),(602298,16643,'tr','Vergi oranÄ± yÃ¼zde',0),(602299,16644,'tr','DaÄŸÄ±tÄ±m Merkezi Num ay yeniden sÄ±ralama hesaplamasÄ± iÃ§in satÄ±ÅŸ',0),(602300,16645,'tr','Ä°nterbranch Transfer yÃ¼kÃ¼ yÃ¼zde GL hesap',0),(602301,16646,'tr','Birden fazla yerde izin madde transferler - ÅŸirketlerarasÄ±',0),(602302,16647,'tr','ÅžirketlerarasÄ± Deftere nakil madde transferler-',0),(602303,16648,'tr','Transit GL hesap stokta',0),(602304,16649,'tr','Sigara daÄŸÄ±tÄ±m merkezi Num ay yeniden sÄ±ralama hesaplamasÄ± iÃ§in satÄ±ÅŸ',0),(602305,16650,'tr','SatÄ±r gÃ¶nderen',0),(602306,16651,'tr','Posta ile teslimat ve alÄ±ÅŸ',0),(602307,16652,'tr','B2B kullanÄ±cÄ± giriÅŸi',0),(602308,16653,'tr','Bu kullanÄ±cÄ± oturum aÃ§Ä±n',0),(602309,16654,'tr','SipariÅŸ tam kaydedilemiyor',0),(602310,16655,'tr','SipariÅŸe iliÅŸtirilmiÅŸ hiÃ§bir POD dosya',0),(602311,16656,'tr','AÃ§Ä±lan gemi',0),(602312,16657,'tr','ArÅŸiv ve Kaydet',0),(602313,16658,'tr','Maliyet kodu tarafÄ±ndan kapalÄ±',0),(602314,16659,'tr','GL kategoriye gÃ¶re kapalÄ±',0),(602315,16660,'tr','Maliyet koduna gÃ¶re hesaplarÄ± kapatmak',0),(602316,16661,'tr','GL kategoriye gÃ¶re hesaplarÄ± kapatmak',0),(602317,16662,'tr','Ä°ptal tarihi',0),(602318,16663,'tr','13 dÃ¶nem giriÅŸ',0),(602319,16664,'tr','Vergi giriÅŸ ayarlama',0),(602320,16665,'tr','YÄ±l sonu giriÅŸ ayarlama',0),(602321,16666,'tr','13 dÃ¶nem giriÅŸleri',0),(602322,16667,'tr','Vergi giriÅŸlerini ayarlama',0),(602323,16668,'tr','GiriÅŸleri ile yÄ±l sonu ayarlama',0),(602324,16669,'tr','Olmayan hazÄ±r',0),(602325,16670,'tr','DiÄŸer Ã¼cret',0),(602326,16671,'tr','DiÄŸer masraflar',0),(602327,16672,'tr','Konumlar arasÄ±nda transfer',0),(602328,16673,'tr','Transfer detaylarÄ±',0),(602329,16674,'tr','Sigara dolu',0),(602330,16675,'tr','Kiralama',0),(602331,16676,'tr','Stoklanan',0),(602332,16677,'tr','0 hiÃ§bir Max iÃ§in',0),(602333,16678,'tr','Herhangi bir dk iÃ§in 0',0),(602334,16679,'tr','AVG miktar aylÄ±k',0),(602335,16680,'tr','OluÅŸturulan satÄ±nalma sipariÅŸi',0),(602336,16681,'tr','SatÄ±nalma sipariÅŸi oluÅŸtur',0),(602337,16682,'tr','DaÄŸÄ±tÄ±m merkezleri',0),(602338,16683,'tr','Stok konumlarÄ±',0),(602339,16684,'tr','Yandan max',0),(602340,16685,'tr','Dk yandan',0),(602341,16686,'tr','Benim satÄ±cÄ±lar',0),(602342,16687,'tr','NUM ay satÄ±ÅŸ iÃ§in en yÃ¼ksek derece elde',0),(602343,16688,'tr','NUM ay Minimum eldeki iÃ§in satÄ±ÅŸ',0),(602344,16689,'tr','NUM ay satÄ±ÅŸ iÃ§in yeniden sipariÅŸ miktarÄ±',0),(602345,16690,'tr','VarsayÄ±lan madde satÄ±cÄ±sÄ± mÄ±?',0),(602346,16691,'tr','GÃ¼n sayÄ±sÄ±',0),(602347,16692,'tr','SaÄŸlama sÃ¼resi alÄ±ntÄ±',0),(602348,16693,'tr','Bu Ã¶ÄŸe iÃ§in diÄŸer varsayÄ±lan satÄ±cÄ± bu satÄ±cÄ± bu madde Will KaldÄ±r iÃ§in varsayÄ±lan olarak ayarlama',0),(602349,16694,'tr','SatÄ±cÄ± UPC',0),(602350,16695,'tr','RTV numarasÄ±',0),(602351,16696,'tr','SipariÅŸ bakiyesi',0),(602352,16697,'tr','Gemi dÃ¼ÅŸmesi bu sÄ±rayÄ± deÄŸiÅŸtiremezsiniz',0),(602353,16698,'tr','GeÃ§erli konumu',0),(602354,16699,'tr','SipariÅŸ gemiye olmayan maddelerin sevk irsaliyeleri vardÄ±r',0),(602355,16700,'tr','SipariÅŸ miktarÄ± mevcut deÄŸil yeri',0),(602356,16701,'tr','SipariÅŸ miktarÄ±nÄ± azaltmak',0),(602357,16702,'tr','KaldÄ±rÄ±lacak aÅŸaÄŸÄ±daki olmayan gemiye Ã¶ÄŸeleri',0),(602358,16703,'tr','FiÅŸ numarasÄ±',0),(602359,16704,'tr','Birincil alÄ±cÄ±',0),(602360,16705,'tr','EÄŸer listede bulunmayan Ä°lÃ§e',0),(602361,16706,'tr','GÃ¼ncelleÅŸtir eylemi',0),(602362,16707,'tr','GL hesap kodlarÄ± maliyeti vardÄ±r maliyet kodlarÄ± gerektirir',0),(602363,16708,'tr','GL hesap GL kategorisi bulunuyorsa GL Kategori gerektirir',0),(602364,16709,'tr','DaÄŸÄ±tÄ±m Merkezi',0),(602365,16710,'tr','DaÄŸÄ±tÄ±m Merkezi mi?',0),(602366,16711,'tr','Ä°ade edildi',0),(602367,16712,'tr','Teslim etme',0),(602368,16713,'tr','Åžimdi kontrol edin',0),(602369,16714,'tr','SÃ¼re iÃ§inde kontrol',0),(602370,16715,'tr','NotlarÄ± kaydetme',0),(602371,16716,'tr','GÃ¼ncelleme notlarÄ±',0),(602372,16717,'tr','AdÄ±yla GL hesabÄ± bulunamadÄ±',0),(602373,16718,'tr','Hasta alma',0),(602374,16719,'tr','GÃ¼n doldurun',0),(602375,16720,'tr','Son randevu',0),(602376,16721,'tr','777 chmod lÃ¼tfen',0),(602377,16722,'tr','TÃ¼m randevular',0),(602378,16723,'tr','Bu randevu',0),(602379,16724,'tr','Komut bulunamadÄ±',0),(602380,16725,'tr','Randevu saati onaylamak',0),(602381,16726,'tr','Ã–zelliÄŸi etkin deÄŸil',0),(602382,16727,'tr','Bir sonraki randevu',0),(602383,16728,'tr','Gelecek randevu',0),(602384,16729,'tr','AÃ§Ä±k randevular iÃ§in',0),(602385,16730,'tr','AÃ§Ä±k randevularÄ± gÃ¶rÃ¼ntÃ¼lemek iÃ§in bir tarih seÃ§in',0),(602386,16731,'tr','Nerede',0),(602387,16732,'tr','Randevu planlama',0),(602388,16733,'tr','Tarih seÃ§in',0),(602389,16734,'tr','Stok ayarlama isteÄŸi tÃ¼rÃ¼',0),(602390,16735,'tr','Stok ayarlama isteÄŸi tÃ¼rÃ¼ bu kod tarafÄ±ndan zaten var',0),(602391,16736,'tr','Stok ayarlama isteÄŸi tÃ¼rÃ¼ kodu ayarlamanÄ±z gerekir',0),(602392,16737,'tr','SonrasÄ± ile aktarma ve alma',0),(602393,16738,'tr','Bu kullanÄ±cÄ± oturum aÃ§Ä±n',0),(602394,16739,'tr','TÄ±rnak iÅŸaretleri iÃ§ine',0),(602395,16503,'ur','Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©Ø§ Ù…Ø·Ø§Ù„Ø¹Û Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(602396,16504,'ur','Ø§Ø¶Ø§ÙÛ Ù†ÛÛŒÚº ÛÙˆ Ø³Ú©Ø§',0),(602397,16505,'ur','Ø²Û Ú©Ø§Ø±ÛŒ Ù†ÛÛŒÚº ÛÙˆØ¦ÛŒ',0),(602398,16506,'ur','Ø´Ú©Ù„ Ù†Ø§Ù…Ú©Ù…Ù„',0),(602399,16507,'ur','Ù…Ø³Ù„ Ù†ÛÛŒÚº Ù¾Ú‘Ú¾ Ø³Ú©ØªØ§',0),(602400,16508,'ur','Ø¶Ø±ÙˆØ±Øª Ù…Ø®ØµÙˆØµ Ù‚Ø·Ø¹Ø§Øª Ø¨Ø±-Ø§ Ø¶Ø§ÙÛ',0),(602401,16509,'ur','Ù…Ø§Ù„ Ú©ÛŒ Ú‘Ù„Ø§Ø¦ Ø¨ÙˆØ¬Ú¾',0),(602402,16510,'ur','Ù…Ø§Ù„ Ú©ÛŒ Ú‘Ù„Ø§Ø¦ Ø¨ÙˆØ¬Ú¾',0),(602403,16511,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ø§Ø®Ø° Ø±ÙˆØ§Úº Ø³Ø§Ù„ Ú©Û’ Ø¢Ø®Ø± Ù…ÛŒÚº Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(602404,16512,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‚Ø³Ù…',0),(602405,16513,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ Ù‚Ø³Ù… Ø§Ø³ Ø¶Ø§Ø¨Ø·Û Ø§Ø®Ù„Ø§Ù‚ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(602406,16514,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‚Ø³Ù… Ú©ÙˆÚˆ Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(602407,16515,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(602408,16516,'ur','Ø·Û’ Ø´Ø¯Û Ø§Ù†Ù¹Ø±Ú©ÙˆÙ…Ù¾Ù†ÛŒ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ø¢ÙØ³Ù¹ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(602409,16517,'ur','Ø´Û’ Ù…Ù†ØªÙ‚Ù„ - Ù¾Ø±Ù†Ù¹ Ø§Ù†Ù¹Ø±Ú©ÙˆÙ…Ù¾Ù†ÛŒ',0),(602410,16518,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø´Û’ ÛŒØ§ Ø·Û’ Ø´Ø¯Û Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ø³ÛŒÙ¹ Ø§Ù¾ Ù…ÛŒÚº ØªÙÙˆÛŒØ¶ Ù¾Ø± ØªÙÙˆÛŒØ¶ Ú©Ø±Ù†Ø§ Ø¶Ø±ÙˆØ±ÛŒ',0),(602411,16519,'ur','Num Ù…Ø§Û Ù‚ÛŒ Ú©Ùˆ Ù¾Ú¾Ø± ØªØ±ØªÛŒØ¨ Ø¯ÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ Ø³ÛŒÙ„Ø²',0),(602412,16520,'ur','Ø¨Ú¾Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Num Ù…Ø§Û',0),(602413,16521,'ur','Ù…Ø¹Ù…ÙˆØ±ÛŒ',0),(602414,16522,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ Ø°Ø®ÛŒØ±Û Ú©Ø§Ø±ÛŒ',0),(602415,16523,'ur','Ù…Ø­ÙÙˆØ¸ Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(602416,16524,'ur','Ù‚Ø¨ÙˆÙ„ Ú©Ø±Ø¯Û ØªØ§Ø±ÛŒØ®',0),(602417,16525,'ur','Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©ÛŒ Ù‚Ø³Ù…',0),(602418,16526,'ur','ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û',0),(602419,16527,'ur','ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û ØªØ§Ø±ÛŒØ®',0),(602420,16528,'ur','Ú¯Ù†ØªÛŒ',0),(602421,16529,'ur','Ø´Ù…Ø§Ø± Ù‚Ø³Ù…',0),(602422,16530,'ur','ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û ØªØ§Ø±ÛŒØ®',0),(602423,16531,'ur','Ø´Ù…Ø§Ø± Ø§Ø´ÛŒØ§Ø¡',0),(602424,16532,'ur','Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¸Ø§ÛØ± Ú©Ø±Ù†Û’ Ú©ÛŒ ØªØ§Ø±ÛŒØ®',0),(602425,16533,'ur','ÙÛŒØµØ¯ Ø´Ù…Ø§Ø± Ú©ÛŒØ§',0),(602426,16534,'ur','Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ Ù‚Ø³Ù…',0),(602427,16535,'ur','Ø³Ù¹Ø§Ú© Ú†ÛŒÚ© Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(602428,16536,'ur','Ø³Ù¹Ø§Ú© Ú†ÛŒÚ© Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³ØªÛŒÚº',0),(602429,16537,'ur','Ø³Ù¹Ø§Ú© Ú†ÛŒÚ© Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ø­Ø§Ù„Øª',0),(602430,16538,'ur','ØªØºÛŒØ± Ù‚Ø¯Ø± Ø§Ù…Ù¹',0),(602431,16539,'ur','ØªØºÛŒØ± Ù‚Ø¯Ø± ÙÛŒØµØ¯',0),(602432,16540,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº Ú©Ø§Ø¤Ù†Ù¹ÛŒ',0),(602433,16541,'ur','Ù…Ù„Ø§Ù‚Ø§Øª Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ÛŒ',0),(602434,16542,'ur','Ø´Ù…Ø§Ø± Ø§Ù†ØªØ¸Ø§Ù…',0),(602435,16543,'ur','Ú¯Ø§ÛÚ© Ù…Ø¹Ù„ÙˆÙ…Ø§Øª Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(602436,16544,'ur','Ø¯Ø±Ø¢Ù…Ø¯ Ø¨Ù†Ø§Ú©Ø± Ø¹Ù„Ø§Ù‚Û Ø¬Ø§Øª',0),(602437,16545,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(602438,16546,'ur','ÙˆÛŒÙ†ÚˆØ± ØªØ±ØªÛŒØ¨ ÙØ±ÙˆÙ…Ø³ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(602439,16547,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©Û’ Ù…Ø§Ù„ Ú©ÛŒ Ú‘Ù„Ø§Ø¦ Ø¨ÙˆØ¬Ú¾ Ø§Ù†Ù¹Ø±Ú©ÙˆÙ…Ù¾Ù†ÛŒ',0),(602440,16548,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ Ø§Ù‚Ø³Ø§Ù…',0),(602441,16549,'ur','Ù†Ø¦Û’ Ø³Ù¹Ø§Ú© Ú†ÛŒÚ© Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª',0),(602442,16550,'ur','Ù…Ú†Ø§Ù† Ø¹Ù„Ø§Ù‚ÙˆÚº',0),(602443,16551,'ur','Ù…Ú†Ø§Ù† Ø¹Ù„Ø§Ù‚Û’',0),(602444,16552,'ur','Ø§Ú©Ø§Ø¤Ù†Ù¹ ØºÙ„Ø· Ù¹Ø§Ø¦Ù¾ Ú©Ø±ÛŒÚº',0),(602445,16553,'ur','Ø´Ù…Ø§Ø± Ù†ÛÛŒÚº Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ø§Ù… Ø³Û’ ØªÙ„Ø§Ø´',0),(602446,16554,'ur','Ø´Ù…Ø§Ø± Ù†ÛÛŒÚº Ú†ÛŒÚ©Ù†Ú¯ Ø§Ú©Ø§Ø¦ÙˆÙ†Ù¹ Ú©Û’ Ù†Ø§Ù… Ø³Û’ ØªÙ„Ø§Ø´',0),(602447,16555,'ur','Ø´Ù…Ø§Ø± Ù†ÛÛŒÚº Ù…Ù„ØªØ§ Ø¬Ùˆ Ø·Ø±ÛŒÙ‚Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù†Ø§Ù… Ø´Ù¾Ù†Ú¯',0),(602448,16556,'ur','Ù…ÛŒÚ† Muliple Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº',0),(602449,16557,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÙˆÚˆ ÛŒØ§ Ø±ÛŒØ§Ø³Øª Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª',0),(602450,16558,'ur','Ø¨Ù†Ø§Ú©Ø± Ø´Ù†Ø§Ø®Øª',0),(602451,16559,'ur','Ø¨Ù†Ø§Ú©Ø± ID ÛŒØ§ Ù†Ø§Ù… Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(602452,16560,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ú©ÙˆÚˆ',0),(602453,16561,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©Ù…Ù¾Ù†ÛŒ Ù†Ø§Ù… Ø§ÙˆØ± Ø¢Ø®Ø±ÛŒ Ù†Ø§Ù… Ù…ØªØ¹ÛŒÙ† ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒÛ’',0),(602454,16562,'ur','Ø¨ÛŒÙ†Ú© Ø±ÙˆÙ¹ Ù†Ù…Ø¨Ø±',0),(602455,16563,'ur','Ø·Û’ Ø´Ø¯Û ØªÙ†Ø®ÙˆØ§Û Ø·Ø±ÛŒÙ‚Û',0),(602456,16564,'ur','ÙˆÛŒÙ†ÚˆØ± Ú©ÙˆÚˆ Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(602457,16565,'ur','Ø®Ø§Ù„ÛŒ',0),(602458,16566,'ur','Ù‚Ø³Ù… Ø³ÛŒÙ¹ Ù†ÛÛŒÚº',0),(602459,16567,'ur','Ø¨Ú© ØªØ¹ÛŒÙ†Ø§Øª Ù…Ù„Ø§Ù‚Ø§Øª',0),(602460,16568,'ur','ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ú©Ú¾ÙˆÙ„ÛŒÚº',0),(602461,16569,'ur','Ø¢Ø¬ ØªØ¹ÛŒÙ†Ø§Øª Ù…Ù„Ø§Ù‚Ø§Øª',0),(602462,16570,'ur','ØªØ¹ÛŒÙ†Ø§Øª Ù…Ù„Ø§Ù‚Ø§Øª Ú©Ù„',0),(602463,16571,'ur','ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ú©ÛŒ Ù„Ù…Ø¨Ø§Ø¦ÛŒ',0),(602464,16572,'ur','ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ú©ÛŒ ÙÛØ±Ø³Øª Ú©Û’ Ù„ÛŒÛ’',0),(602465,16573,'ur','ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(602466,16574,'ur','ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ú©Ø§ Ù†Ø§Ù…',0),(602467,16575,'ur','Ù…Ù„Ø§Ù‚Ø§Øª Ú©Ø§ Ø®Ù„Ø§ØµÛ',0),(602468,16576,'ur','B2B Ù…Ù„Ø§Ù‚Ø§Øª Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ÛŒ',0),(602469,16577,'ur','Ø³ÙˆØ±Ø§Ø® Ù…Ù„Ø§Ù‚Ø§Øª ØªØ®Ù„ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(602470,16578,'ur','Ú©Ú¾Ù„ÛŒ Ù…Ù„Ø§Ù‚Ø§Øª Ú©Ùˆ Ø®Ø§Ø±Ø¬ Ú©Ø±ÛŒÚº',0),(602471,16579,'ur','Ø§Ú¯Ù„Û’ Ø¢Ø¦Ù†Ø¯Û Ù…Ù„Ø§Ù‚Ø§Øª',0),(602472,16580,'ur','Ø§ÛŒÚ© ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ø¯ÛŒÚ©Ú¾ÛŒÚº & Ù…Ù„Ø§Ù‚Ø§ØªÙˆÚº Ù…ÛŒÚº ØªØ±Ù…ÛŒÙ… Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ø§Ù¹Ú¾Ø§Ùˆ',0),(602473,16581,'ur','Ø®Ù„Ø§ØµÛ Ø¯Ú©Ú¾Ø§Ø¦ÛŒÚº',0),(602474,16582,'ur','Ù…Ù„Ø§Ù‚Ø§Øª ÛŒÙˆÙ†Ø¨ÙˆÚ©',0),(602475,16583,'ur','Ù†Ø¦Û’ Ú©Ø§Ø¤Ù†Ù¹ÛŒ Ú©Ø§ Ø§ Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº',0),(602476,16584,'ur','Ú©Ø§Ø¤Ù†Ù¹ÛŒ Ú©Û’ Ù†Ø§Ù…',0),(602477,16585,'ur','ÙˆØ§Ù„Ø¯ÛŒÙ† Ø±ÛŒØ§Ø³Øª',0),(602478,16586,'ur','Ø¢Ù¾ Ú©Ùˆ Ú©Ø§Ø¤Ù†Ù¹ÛŒ Ú©Û’ Ù†Ø§Ù… Ø¯Ø§Ø®Ù„ Ú©Ø±Ù†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(602479,16587,'ur','Ø¢Ù¾ Ø§ÛŒÚ© Ø±ÛŒØ§Ø³Øª Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(602480,16588,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ ÛŒÛ Ú©Ø§Ø¤Ù†Ù¹ÛŒ Ø­Ø°Ù Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(602481,16589,'ur','Ø­Ø°Ù Ú©Ø§Ø¤Ù†Ù¹ÛŒ',0),(602482,16590,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº Ù…Ø®ØµÙˆØµ Ú©Ø§Ø¤Ù†Ù¹ÛŒ',0),(602483,16591,'ur','Ø§ÛŒÚ© Ù†ÛŒØ§ Ú©Ø§Ø¤Ù†Ù¹ÛŒ Ø´Ø§Ù…Ù„ Ú©Ø±Ù†Û’ Ù¾Ø± ØºÙˆØ±',0),(602484,16592,'ur','ØªØ¯ÙˆÛŒÙ† Ú©Ø§Ø¤Ù†Ù¹ÛŒ',0),(602485,16593,'ur','Ø¢Ù¾ Ú©Ø§ Ø§Ù†ØªØ®Ø§Ø¨ Ø§ÛŒÚ© Ù†Ø¸Ø§Ù… Ú©ÛŒ Ù‚Ø¯Ø± ÛÛ’ Ø§ÙˆØ± ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©ÛŒ Ø¬Ø§ Ø³Ú©ØªÛŒ',0),(602486,16594,'ur','Ø¬Ø§Ø±ÛŒ Ø±Ú©Ú¾Ù†Û’ Ú©Û’ Ù„ÛŒÛ’ ÙØ§Ø±Ù… Ù…Ú©Ù…Ù„ Ú©Ø±Ù†Ø§ Ø¶Ø±ÙˆØ±ÛŒ',0),(602487,16595,'ur','ØµØ§Ø±ÙÛŒÙ† Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(602488,16596,'ur','Ú¯Ø§ÛÚ© Ø§Ú†Ù¹ Ø¯ÛŒ',0),(602489,16597,'ur','Ú¯Ø§ÛÚ©ÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(602490,16598,'ur','Ù„Ø§Ø¦Ù†ÛŒÚº Ù¾Ú‘Ú¾ÛŒÚº',0),(602491,16599,'ur','Ù…ØªØ¨Ø§Ø¯Ù„ ÙÙˆÙ†',0),(602492,16600,'ur','CSV Ø¯Ø±Ø¢Ù…Ø¯ÛŒ ÙØ§Ø¦Ù„',0),(602493,16601,'ur','Ù…ÙˆØ¨Ø§Ø¦Ù„ ÙÙˆÙ† Ú©ÛŒØ±ÛŒØ¦Ø±',0),(602494,16602,'ur','Ù…ÙˆØ¨Ø§Ø¦Ù„ ÙÙˆÙ† Ù†Ù…Ø¨Ø±',0),(602495,16603,'ur','Ø§Ù†ÙˆØ§Ø¦Ø³ Ø´Ø±Ø§Ø¦Ø· Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(602496,16604,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ø§Ø®ØªØµØ§Ø±',0),(602497,16605,'ur','Ú¯Ù„ÛŒ Ú©Ø§ Ù¾ØªÛ',0),(602498,16606,'ur','Ø§Ø¶Ø§ÙÛ Ú©Ø±ÛŒÚº/ØªØ¯ÙˆÛŒÙ† Ú©Ø±ÛŒÚº',0),(602499,16607,'ur','Ù…Ø§ÛØ§Ù†Û Ø§ÙˆØ³Ø· Ú©ÛŒ ÙØ±ÙˆØ®Øª',0),(602500,16608,'ur','Ø­Ø§Ù„ÛŒÛ Ú©ÛŒ ÙØ±Ø§ÛÙ…ÛŒ',0),(602501,16609,'ur','ØªÙÙˆÛŒØ¶ Ú©Ø±Ø¯Û Ú©ÙˆØ¦ÛŒ Ø¨Ù†ÛŒØ§Ø¯ÛŒ Ø¨Ù†',0),(602502,16610,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ù¾Ø± Ù‚ÛŒ',0),(602503,16611,'ur','Ø§Ø³Ù¹Ø§Ú© ÚˆØ³Ù¹Ø±ÛŒ Ø¨ÛŒÙˆØ´Ù† Ø³ÛŒÙ†Ù¹Ø± Ø³Û’ Ø¨Ú¾Ø±Ù†Û’',0),(602504,16612,'ur','ØªØ¬ÙˆÛŒØ² Ù¾ÛŒØ´ Ú©ÛŒ',0),(602505,16613,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ Ù‚ÛŒ',0),(602506,16614,'ur','Ù…Ù†Ø·Ù‚Û',0),(602507,16615,'ur','Ø´ÛØ±ÙˆÚº Ù…ÛŒÚº Ø´Ø§Ù…Ù„',0),(602508,16616,'ur','Ø´ÛØ±ÙˆÚº Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(602509,16617,'ur','Ú©Ø§Ø¤Ù†Ù¹ÛŒØ² Ù…ÛŒÚº Ø§Ø¶Ø§ÙÛ',0),(602510,16618,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©ÛŒ Ù…Ù…Ù„Ú©ØªÛŒÚº',0),(602511,16619,'ur','Ø§Ù…Ø±ÛŒÚ©Û Ú©Ø§ Ø§Ø¶Ø§ÙÛ',0),(602512,16620,'ur','Ø§Ù…Ø±ÛŒÚ©Û Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ',0),(602513,16621,'ur','Ø§Ø«Ø¨Ø§Øª Ú©Ø±ÛŒÚº Ú©Û Ø¢Ù¾ Ø§Ù¾Ù†Û’ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ú©Û’ Ø±ÛŒÚ©Ø§Ø±Úˆ Ú©ÛŒ ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ú©Ø±Ù†Ø§ Ú†Ø§ÛØªÛ’ ÛÛŒÚºØŸ',0),(602514,16622,'ur','Ø´ÛØ± Ú©Ø§ Ù†Ø§Ù…',0),(602515,16623,'ur','Ø´ÛØ± Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø¶Ø§Ø±Ø¨',0),(602516,16624,'ur','Ø´ÛØ± Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù¹ÛŒÚ©Ø³ Ø¶Ø§Ø±Ø¨',0),(602517,16625,'ur','Ú©Ø§Ø¤Ù†Ù¹ÛŒ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø¶Ø§Ø±Ø¨',0),(602518,16626,'ur','Ú©Ø§Ø¤Ù†Ù¹ÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù¹ÛŒÚ©Ø³ Ø¶Ø§Ø±Ø¨',0),(602519,16627,'ur','Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(602520,16628,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø¶Ø§Ø±Ø¨',0),(602521,16629,'ur','Ø±ÛŒØ§Ø³ØªÛŒ Ø§Ø³ØªØ¹Ù…Ø§Ù„ Ù¹ÛŒÚ©Ø³ Ø¶Ø§Ø±Ø¨',0),(602522,16630,'ur','ØªÚ¾Ø§Ù…Ø³Ù† Ø±Ø§Ø¦Ù¹Ø±Ø² Ø¬Ø¯ÙˆÙ„ Ù…Ø³Ù„',0),(602523,16631,'ur','Ù…ÙˆØ¬ÙˆØ¯ Ú©ÙˆØ§Ø¦Ù',0),(602524,16632,'ur','Ù…ÙˆØ¬ÙˆØ¯Û Ú©ÙˆØ§Ø¦Ù Ø±ÛÛŒÚº',0),(602525,16633,'ur','ØªÙ…Ø§Ù… Ù…ÙˆØ¬ÙˆØ¯Û Ú©ÙˆØ§Ø¦Ù ØµØ§Ù Ú©Ø±ÛŒÚº',0),(602526,16634,'ur','Ù…ÙˆØ¬ÙˆØ¯ Ú©ÙˆØ§Ø¦Ù Ø¯Ø±Ø¢Ù…Ø¯ Ù…ÛŒÚº Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº Ú©Û’ Ù„Ø¦Û’ ØµØ§Ù Ú©Ø±ÛŒÚº',0),(602527,16635,'ur','Ø²ÛŒØ± Ø§Ù„ØªÙˆØ§Ø¡ ÙˆÛŒÙ†ÚˆØ± Ú©Ø±ÛŒÚˆÙ¹',0),(602528,16636,'ur','Ø®ÙˆØ¯ Ù…Ù†ØªØ®Ø¨ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ø³Û’ Ø¨Ø­Ø±ÛŒ Ø¬ÛØ§Ø² Ú©Û’',0),(602529,16637,'ur','ØªÚ©Ù…ÛŒÙ„ Ø§ÙˆØ± Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø±',0),(602530,16638,'ur','ØªÙ‚Ø³ÛŒÙ… Ú©Û’ Ù…Ø±Ø§Ú©Ø² Ù…ÛŒÚº Ø³Û’ ØµØ±Ù ÙˆØ§Ù¾Ø³ Ø­Ú©Ù… Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(602531,16639,'ur','ØªÚ©Ù…ÛŒÙ„ Ø§ÙˆØ± Ù¾ÙˆØ²ÛŒØ´Ù† Ú©Û’ Ø§Ø­Ú©Ø§Ù…Ø§Øª Ù¾Ø± Ø¬ÛØ§Ø² Ø³Û’ Ø®ÙˆØ¯ Ø¨Ø®ÙˆØ¯ Ø³ÛŒÙ„Ø² Ù¹ÛŒÚ©Ø³ Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(602532,16640,'ur','Ø¢Ø®Ø±ÛŒ Ù‚Ø·Ø±Û Ú©Ú¾ÛŒÙ¾ Ù¾Ú¾Ù„ÛŒ Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÛ’ Û”',0),(602533,16641,'ur','Ù…ØªØ¨Ø§Ø¯Ù„ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ù…Ù‚Ø§Ù…Ø§Øª Ù‚ÛŒ Ø¬Ø¨ Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº ØªØ¬ÙˆÛŒØ² Ú©Ø±ÛŒÚº',0),(602534,16642,'ur','Ø¬Ø²ÙˆÛŒ Ù¹ÛŒÚ©Ø³ Ø§Ø³ØªØ«Ù†Ø§Ø¡',0),(602535,16643,'ur','Ù¹ÛŒÚ©Ø³ Ú©ÛŒ Ø´Ø±Ø­ ÙÛŒØµØ¯',0),(602536,16644,'ur','ÚˆØ³Ù¹Ø±ÛŒ Ø¨ÛŒÙˆØ´Ù† Ø³ÛŒÙ†Ù¹Ø± Num Ù…Ø§Û Ø­Ø³Ø§Ø¨ Ú©Ùˆ Ù¾Ú¾Ø± ØªØ±ØªÛŒØ¨ Ø¯ÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ Ø³ÛŒÙ„Ø²',0),(602537,16645,'ur','Ø§Ù†Ù¹Ø±Ø¨Ø±Ø§Ù†Ú† Ù…Ù†ØªÙ‚Ù„ÛŒ Ø¨ÙˆØ¬Ú¾ ØªÙ†Ø§Ø³Ø¨ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹',0),(602538,16646,'ur','Ø´Û’ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ - Ø§Ù†Ù¹Ø±Ú©ÙˆÙ…Ù¾Ù†ÛŒ Ù…ØªØ¹Ø¯Ø¯ Ù…Ù‚Ø§Ù…Ø§Øª Ú©ÛŒ Ø§Ø¬Ø§Ø²Øª Ø¯ÛŒÚº',0),(602539,16647,'ur','Ø´Û’ Ú©ÛŒ Ù…Ù†ØªÙ‚Ù„ÛŒ Ù¾ÙˆØ³Ù¹Ù†Ú¯ - Ø§Ù†Ù¹Ø±Ú©ÙˆÙ…Ù¾Ù†ÛŒ',0),(602540,16648,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù¹Ø±Ø§Ù†Ø²Ù¹ Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù…ÛŒÚº',0),(602541,16649,'ur','ØºÛŒØ± ØªÙ‚Ø³ÛŒÙ…ÛŒ Ù…Ø±Ú©Ø² Num Ù…Ø§Û Ø­Ø³Ø§Ø¨ Ú©Ùˆ Ù¾Ú¾Ø± ØªØ±ØªÛŒØ¨ Ø¯ÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ Ø³ÛŒÙ„Ø²',0),(602542,16650,'ur','Ù„Ø§Ø¦Ù† Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾ÙˆØ³Ù¹',0),(602543,16651,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø´Ù¾Ù†Ú¯ Ø§ÙˆØ± ÙˆØµÙˆÙ„ Ú©Ø±ØªÛ’ ÛÙˆØ¦Û’',0),(602544,16652,'ur','B2B ØµØ§Ø±Ù Ù„Ø§Ú¯ Ø§Ù†',0),(602545,16653,'ur','Ù…ÛŒÚº Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº Ø§Ø³ ØµØ§Ø±Ù Ú©Û’ Ø·ÙˆØ± Ù¾Ø±',0),(602546,16654,'ur','ØªØ±ØªÛŒØ¨ Ù…Ú©Ù…Ù„ Ø·ÙˆØ± Ù¾Ø± Ù…Ø­ÙÙˆØ¸ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(602547,16655,'ur','Ø¢Ø±ÚˆØ± Ú©Ø±Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ù…Ù†Ø³Ù„Ú© Ú©ÙˆØ¦ÛŒ Ù¾Ú¾Ù„ÛŒ Ù…Ø³Ù„',0),(602548,16656,'ur','Ù‚Ø·Ø±Û Ø¬ÛØ§Ø²',0),(602549,16657,'ur','Ù…Ø­ÙÙˆØ¸ Ø´Ø¯Û Ø¯Ø³ØªØ§ÙˆÙŠØ²Ø§Øª & Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(602550,16658,'ur','Ù‚ÛŒÙ…Øª Ú©ÙˆÚˆ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(602551,16659,'ur','Ø¬ÛŒØ¬Û’ Ø²Ù…Ø±Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø¨Ù†Ø¯ Ú©Ø± Ø¯ÛŒØ§',0),(602552,16660,'ur','Ø§Ù†Ø¯Ø§Ø²ÙˆÚº Ú©Û’ Ù…Ø·Ø§Ø¨Ù‚ Ù‚ÛŒÙ…Øª Ø¶Ø§Ø¨Ø·Û Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº',0),(602553,16661,'ur','Ø¬ÛŒØ¬Û’ Ø²Ù…Ø±Û Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¨Ù†Ø¯ Ú©Ø±ÛŒÚº',0),(602554,16662,'ur','ØªØ§Ø±ÛŒØ® Ú©Ùˆ Ù…Ù†Ø³ÙˆØ® Ú©Ø± Ø¯ÛŒØ§',0),(602555,16663,'ur','13 Ø¯ÙˆØ± Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(602556,16664,'ur','Ø§Ù†Ø¯Ø±Ø§Ø¬ Ø§Ø®Ø° Ù¹ÛŒÚ©Ø³',0),(602557,16665,'ur','Ø³Ø§Ù„ Ø§Ø®ØªØªØ§Ù… Ø§Ø®Ø° Ø§Ù†Ø¯Ø±Ø§Ø¬',0),(602558,16666,'ur','13 Ø¯ÙˆØ± Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª',0),(602559,16667,'ur','Ù¹ÛŒÚ©Ø³ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ú©Ùˆ Ø§ÛŒÚˆØ¬Ø³Ù¹ Ú©Ø±ØªÛ’',0),(602560,16668,'ur','Ø³Ø§Ù„ Ú©Û’ Ø§Ø®ØªØªØ§Ù… Ú©Û’ Ø³Ø§ØªÚ¾ Ø§Ù†Ø¯Ø±Ø§Ø¬Ø§Øª Ø§Ø®Ø°',0),(602561,16669,'ur','ØºÛŒØ± Ø§Ø³Ù¹Ø§Ú©',0),(602562,16670,'ur','Ø¯ÛŒÚ¯Ø± Ú†Ø§Ø±Ø¬',0),(602563,16671,'ur','Ø¯ÛŒÚ¯Ø± Ú†Ø§Ø±Ø¬Ø²',0),(602564,16672,'ur','Ù…Ù‚Ø§Ù…Ø§Øª Ú©Û’ Ø¯Ø±Ù…ÛŒØ§Ù† Ù…Ù†ØªÙ‚Ù„ÛŒ',0),(602565,16673,'ur','Ù…Ù†ØªÙ‚Ù„ÛŒ Ú©ÛŒ ØªÙØµÛŒÙ„Ø§Øª',0),(602566,16674,'ur','ØºÛŒØ± Ø°Ø®ÛŒØ±Û',0),(602567,16675,'ur','Ú©Ø±Ø§ÛŒÛ',0),(602568,16676,'ur','Ø°Ø®ÛŒØ±Û',0),(602569,16677,'ur','Ú©ÙˆØ¦ÛŒ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ú©Û’ Ù„ÛŒÛ’ 0',0),(602570,16678,'ur','Ú©ÙˆØ¦ÛŒ Ù…Ù†Ù¹ Ú©Û’ Ù„ÛŒÛ’ 0',0),(602571,16679,'ur','Ù…Ø§ÛØ§Ù†Û Ø§ÙˆØ³Ø· Ú©ÛŒ Ù‚ÛŒ',0),(602572,16680,'ur','Ø¨Ù†Ø§Ø¦ÛŒ Ú¯Ø¦ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ±',0),(602573,16681,'ur','Ø®Ø±ÛŒØ¯Ø§Ø±ÛŒ Ú©Û’ Ø¢Ø±ÚˆØ± Ú©ÛŒ ØªØ®Ù„ÛŒÙ‚',0),(602574,16682,'ur','ØªÙ‚Ø³ÛŒÙ… Ú©Û’ Ù…Ø±Ø§Ú©Ø²',0),(602575,16683,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ù…Ù‚Ø§Ù…Ø§Øª',0),(602576,16684,'ur','ÛØ§ØªÚ¾ Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û',0),(602577,16685,'ur','Ú©Ù… Ø§Ø² Ú©Ù… ÛØ§ØªÚ¾ Ù¾Ø±',0),(602578,16686,'ur','Ù…ÛŒØ±Û’ Ø¯Ú©Ø§Ù†Ø¯Ø§Ø±ÙˆÚº',0),(602579,16687,'ur','Num Ù…Ø§Û ÛØ§ØªÚ¾ Ù¾Ø± Ø²ÛŒØ§Ø¯Û Ø³Û’ Ø²ÛŒØ§Ø¯Û Ú©Û’ Ù„Ø¦Û’ Ø³ÛŒÙ„Ø²',0),(602580,16688,'ur','Num Ù…Ø§Û Ú©Ù… Ø§Ø² Ú©Ù… ÛØ§ØªÚ¾ Ù¾Ø± Ø¨Ø±Ø§Ø¦Û’ ÙØ±ÙˆØ®Øª',0),(602581,16689,'ur','Num Ù…Ø§Û Ù…Ù‚Ø¯Ø§Ø± Ú©Ùˆ Ù¾Ú¾Ø± ØªØ±ØªÛŒØ¨ Ø¯ÛŒÙ†Û’ Ú©Û’ Ù„Ø¦Û’ Ø³ÛŒÙ„Ø²',0),(602582,16690,'ur','Ø·Û’ Ø´Ø¯Û Ø´Û’ ÙˆÛŒÙ†ÚˆØ± ÛÛ’ØŸ',0),(602583,16691,'ur','Ø¯Ù†ÙˆÚº Ú©ÛŒ ØªØ¹Ø¯Ø§Ø¯',0),(602584,16692,'ur','Ø¯ÙŠÙƒÚ¾ÙŠÚº: Ù„Û’ Ø¬Ø§ØªÛ’ ÙˆÙ‚Øª',0),(602585,16693,'ur','Ø§Ø³ Ø´Û’ Ú©Û’ Ù„ÛŒÛ’ Ú©Ø³ÛŒ Ø¨Ú¾ÛŒ Ø¯ÛŒÚ¯Ø± Ø·Û’ Ø´Ø¯Û ÙˆÛŒÙ†ÚˆØ±Ø² Ø§Ø³ Ø´Û’ Ú©ÛŒ Ù…Ø±Ø¶ÛŒ ÛÙ¹Ø§Ø¦ÛŒÚº Ú©Û’ Ù„ÛŒÛ’ Ø·Û’ Ø´Ø¯Û Ø·ÙˆØ± Ù¾Ø± ÛŒÛ ÙˆÛŒÙ†ÚˆØ± Ø³ÛŒÙ¹Ù†Ú¯',0),(602586,16694,'ur','ÙˆÛŒÙ†ÚˆØ± UPC',0),(602587,16695,'ur','Ø±Ù¹Ùˆ Ù†Ù…Ø¨Ø±',0),(602588,16696,'ur','ÙˆØ§Ù¾Ø³ Ø­Ú©Ù…',0),(602589,16697,'ur','Ø¬ÛØ§Ø² Ú©Û’ Ù„Ø¦Û’ Ø§Ø³ Ø­Ú©Ù… Ú©Ùˆ ØªØ¨Ø¯ÛŒÙ„ Ù†ÛÛŒÚº Ú©Ø± Ø³Ú©ØªØ§',0),(602590,16698,'ur','Ø­Ø§Ù„ÛŒÛ Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹',0),(602591,16699,'ur','Ø¢Ø±ÚˆØ±-ÚˆØ±Ø§Ù¾ Ø§Ø´ÛŒØ§Ø¡ Ú©ÛŒ ØªØ±Ø³ÛŒÙ„ ÛÛ’ Û”',0),(602592,16700,'ur','ØªØ±ØªÛŒØ¨ Ù…Ù‚Ø¯Ø§Ø± Ø¯Ø³ØªÛŒØ§Ø¨ Ù†ÛÛŒÚº Ù…Ø­Ù„ ÙˆÙ‚ÙˆØ¹ Ù¾Ø±',0),(602593,16701,'ur','Ø¢Ø±ÚˆØ± Ú©ÛŒ Ù…Ù‚Ø¯Ø§Ø± Ù…ÛŒÚº Ú©Ù…ÛŒ',0),(602594,16702,'ur','Ø¯Ø±Ø¬ Ø°ÛŒÙ„ ØºÛŒØ± Ù‚Ø·Ø±Û Ø¬ÛØ§Ø² Ø§Ø´ÛŒØ§ ÛÙ¹Ø§ Ø¯ÛŒØ§ Ø¬Ø§Ø¦Û’',0),(602595,16703,'ur','ÙˆØ§Ø¤Ú†Ø± Ø´Ù†Ø§Ø®Øª',0),(602596,16704,'ur','Ø¨Ù†ÛŒØ§Ø¯ÛŒ Ø®Ø±ÛŒØ¯Ø§Ø±',0),(602597,16705,'ur','Ú©Ø§Ø¤Ù†Ù¹ÛŒ Ø§Ú¯Ø± ÙÛØ±Ø³Øª Ù¾Ø± Ù†ÛÛŒÚº',0),(602598,16706,'ur','ØªØ§Ø²Û Ú©Ø§Ø±ÛŒ Ø¹Ù…Ù„',0),(602599,16707,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø±Ù…ÙˆØ² Ø¨Ú¾Ø§Ø±ÛŒ Ù†Ù‚ØµØ§Ù† Ø§ÙÙ¹Ú¾Ø§Ù†Ø§ Ù¾Ú‘Ø§ ØªÙˆ Ù‚ÛŒÙ…Øª Ú©ÙˆÚˆØ² Ú©ÛŒ Ø¶Ø±ÙˆØ±Øª ÛÙˆØªÛŒ ÛÛ’',0),(602600,16708,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ø¬ÛŒØ¬Û’ Ù‚Ø³Ù…ÛŒÚº ÛÛŒÚº Ø§ÛŒÚ© ØªÙˆ Ø¬ÛŒØ¬Û’ Ø²Ù…Ø±Û Ø¶Ø±ÙˆØ±Øª ÛÙˆØªÛŒ ÛÛ’ Û”',0),(602601,16709,'ur','ÚˆØ³Ù¹Ø±ÛŒ Ø¨ÛŒÙˆØ´Ù† Ø³ÛŒÙ†Ù¹Ø±',0),(602602,16710,'ur','ÚˆØ³Ù¹Ø±ÛŒ Ø¨ÛŒÙˆØ´Ù† Ø³ÛŒÙ†Ù¹Ø± ÛÛ’ØŸ',0),(602603,16711,'ur','Ù¾Ú‘ØªØ§Ù„',0),(602604,16712,'ur','Ú†ÙŠÚ© Ø§Ù†',0),(602605,16713,'ur','Ù…ÛŒÚº Ø§Ø¨ Ú†ÛŒÚ© Ú©Ø±ÛŒÚº',0),(602606,16714,'ur','Ù…ÛŒÚº ÙˆÙ‚Øª Ú©ÛŒ Ù¾Ú‘ØªØ§Ù„ Ú©Ø±ÛŒÚº',0),(602607,16715,'ur','Ù†ÙˆÙ¹ Ù…Ø­ÙÙˆØ¸ Ú©Ø±ÛŒÚº',0),(602608,16716,'ur','Ø§Ù¾ ÚˆÛŒÙ¹ Ù†ÙˆÙ¹',0),(602609,16717,'ur','Ø¬ÛŒØ¬Û’ Ø§Ú©Ø§Ø¤Ù†Ù¹ Ù†Ø§Ù… Ù†ÛÛŒÚº Ù…Ù„ Ø³Ú©Ø§',0),(602610,16718,'ur','Ù…Ø±ÛŒØ¶ Ø¯Ø±Ø¢Ù…Ø¯ Ú©Ø±ÛŒÚº',0),(602611,16719,'ur','Ø¯Ù† Ø¨Ú¾Ø±',0),(602612,16720,'ur','Ø¢Ø®Ø±ÛŒ Ù…Ù„Ø§Ù‚Ø§Øª',0),(602613,16721,'ur','777 Ú†Ù… Ø¨Ø±Ø§Û Ù…ÛØ±Ø¨Ø§Ù†ÛŒ',0),(602614,16722,'ur','ØªÙ…Ø§Ù… ØªØ¹ÛŒÙ†Ø§Øª Ù…Ù„Ø§Ù‚Ø§Øª',0),(602615,16723,'ur','ÛŒÛ ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ú©ÛŒ Ú©ØªØ§Ø¨',0),(602616,16724,'ur','Ø­Ú©Ù… Ù†ÛÛŒÚº Ù…Ù„Ø§',0),(602617,16725,'ur','Ù…Ù„Ø§Ù‚Ø§Øª Ú©Û’ ÙˆÙ‚Øª Ú©ÛŒ ØªØµØ¯ÛŒÙ‚ Ú©Ø±ÛŒÚº',0),(602618,16726,'ur','ÙÛŒÚ†Ø± Ø§ÛÙ„ Ù†ÛÛŒÚº',0),(602619,16727,'ur','Ø§Ú¯Ù„ÛŒ Ù…Ù„Ø§Ù‚Ø§Øª',0),(602620,16728,'ur','Ú©ÙˆØ¦ÛŒ Ø¢Ø¦Ù†Ø¯Û Ù…Ù„Ø§Ù‚Ø§Øª',0),(602621,16729,'ur','Ú©Ú¾Ù„ÛŒ ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ú©Û’ Ù„ÛŒÛ’',0),(602622,16730,'ur','Ú©Ú¾Ù„ÛŒ ØªØ¹ÛŒÙ† Ù…Ù„Ø§Ù‚Ø§Øª Ø¯ÛŒÚ©Ú¾Ù†Û’ Ú©Û’ Ù„Ø¦Û’ Ú©ÙˆØ¦ÛŒ ØªØ§Ø±ÛŒØ® Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(602623,16731,'ur','Ø¬ÛØ§Úº',0),(602624,16732,'ur','Ù…ÛŒÙ‚Ø§Øª Ø¨Ù†Ø¯ÛŒ Ù…Ù„Ø§Ù‚Ø§Øª',0),(602625,16733,'ur','ØªØ§Ø±ÛŒØ® Ù…Ù†ØªØ®Ø¨ Ú©Ø±ÛŒÚº',0),(602626,16734,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‚Ø³Ù…',0),(602627,16735,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ú©ÛŒ Ù‚Ø³Ù… Ø§Ø³ Ø¶Ø§Ø¨Ø·Û Ø§Ø®Ù„Ø§Ù‚ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ù¾ÛÙ„Û’ ÛÛŒ Ù…ÙˆØ¬ÙˆØ¯ ÛÛ’',0),(602628,16736,'ur','Ø§Ù†ÙˆÛŒÙ†Ù¹Ø±ÛŒ Ú©Ø§ Ø¯Ø±Ø¬Û Ø§ÛŒÚˆØ¬Ø³Ù¹Ù…Ù†Ù¹ Ú©ÛŒ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Ù‚Ø³Ù… Ú©ÙˆÚˆ Ø³ÛŒÙ¹ ÛÙˆÙ†Ø§ Ú†Ø§ÛÛŒØ¦Û’',0),(602629,16737,'ur','Ù¾ÙˆØ³Ù¹ Ú©ÛŒ Ø·Ø±Ù Ø³Û’ Ø´Ù¾Ù†Ú¯ & ÙˆØµÙˆÙ„ Ú©Ø±Ù†Ø§',0),(602630,16738,'ur','Ù…ÛŒÚº Ù„Ø§Ú¯ Ø§Ù† Ú©Ø±ÛŒÚº Ø§Ø³ ØµØ§Ø±Ù Ú©Û’ Ø·ÙˆØ± Ù¾Ø±',0),(602631,16739,'ur','ÙˆØ§ÙˆÛŒÙ† Ø´Ø§Ù…Ù„ ÛÛŒÚº',0),(602632,16503,'vi','KhÃ´ng thá»ƒ Ä‘á»c há»“ sÆ¡',0),(602633,16504,'vi','KhÃ´ng thá»ƒ thÃªm',0),(602634,16505,'vi','CÃ³ thá»ƒ khÃ´ng Ä‘Æ°á»£c Cáº­p Nháº­t',0),(602635,16506,'vi','HÃ¬nh thá»©c khÃ´ng Ä‘áº§y Ä‘á»§',0),(602636,16507,'vi','KhÃ´ng thá»ƒ Ä‘á»c táº­p tin',0),(602637,16508,'vi','Tiá»‡n Ã­ch tÃ¹y chá»‰nh cÃ¡c lÄ©nh vá»±c cáº§n thiáº¿t',0),(602638,16509,'vi','GÃ¡nh náº·ng váº­n chuyá»ƒn hÃ ng hÃ³a',0),(602639,16510,'vi','GÃ¡nh náº·ng váº­n chuyá»ƒn hÃ ng hÃ³a',0),(602640,16511,'vi','Bao gá»“m cÃ¡c Ä‘iá»u chá»‰nh má»¥c cuá»‘i nÄƒm',0),(602641,16512,'vi','HÃ ng tá»“n kho Ä‘iá»u chá»‰nh yÃªu cáº§u loáº¡i',0),(602642,16513,'vi','Loáº¡i cá»§a yÃªu cáº§u Ä‘iá»u chá»‰nh hÃ ng tá»“n kho cá»§a mÃ£ nÃ y Ä‘Ã£ tá»“n táº¡i',0),(602643,16514,'vi','MÃ£ sá»‘ loáº¡i yÃªu cáº§u Ä‘iá»u chá»‰nh hÃ ng tá»“n kho pháº£i Ä‘Æ°á»£c thiáº¿t láº­p',0),(602644,16515,'vi','Táº¡o ra chuyá»ƒn',0),(602645,16516,'vi','Pháº£i Ä‘Æ°á»£c Ä‘áº·t thÃ nh máº·c Ä‘á»‹nh Intercompany chuyá»ƒn tÃ i khoáº£n bÃ¹ Ä‘áº¯p',0),(602646,16517,'vi','Intercompany má»¥c chuyá»ƒn - in',0),(602647,16518,'vi','HÃ ng tá»“n kho GL khoáº£n pháº£i Ä‘Æ°á»£c gÃ¡n vÃ o má»¥c hoáº·c tÃ i khoáº£n máº·c Ä‘á»‹nh Ä‘Æ°á»£c chá»‰ Ä‘á»‹nh trong thiáº¿t láº­p hÃ ng tá»“n kho',0),(602648,16519,'vi','NUM thÃ¡ng bÃ¡n hÃ ng Ä‘á»ƒ sáº¯p xáº¿p láº¡i SL',0),(602649,16520,'vi','NUM vÃ i thÃ¡ng Ä‘á»ƒ bá»• sung',0),(602650,16521,'vi','Bá»• sung',0),(602651,16522,'vi','Chuyá»ƒn tiáº¿p',0),(602652,16523,'vi','Chuyá»ƒn giao lÆ°u',0),(602653,16524,'vi','NgÃ y Ä‘Æ°á»£c cháº¥p nháº­n',0),(602654,16525,'vi','Äiá»u chá»‰nh loáº¡i',0),(602655,16526,'vi','PhÃ¢n cÃ´ng',0),(602656,16527,'vi','NgÃ y Ä‘Æ°á»£c chá»‰ Ä‘á»‹nh',0),(602657,16528,'vi','TÃ­nh',0),(602658,16529,'vi','Sá»‘ loáº¡i',0),(602659,16530,'vi','NgÃ y Ä‘Æ°á»£c chá»‰ Ä‘á»‹nh',0),(602660,16531,'vi','Má»¥c tÃ­nh',0),(602661,16532,'vi','Cáº­p Nháº­t láº§n cuá»‘i bá»Ÿi',0),(602662,16533,'vi','TÃ­nh pháº§n trÄƒm',0),(602663,16534,'vi','YÃªu cáº§u cÃ¡c loáº¡i',0),(602664,16535,'vi','YÃªu cáº§u kiá»ƒm tra cá»• phiáº¿u',0),(602665,16536,'vi','YÃªu cáº§u kiá»ƒm tra cá»• phiáº¿u',0),(602666,16537,'vi','Cá»• phiáº¿u kiá»ƒm tra yÃªu cáº§u tráº¡ng thÃ¡i',0),(602667,16538,'vi','PhÆ°Æ¡ng sai giÃ¡ trá»‹ Amt',0),(602668,16539,'vi','PhÆ°Æ¡ng sai giÃ¡ trá»‹ pháº§n trÄƒm',0),(602669,16540,'vi','ThÃªm/chá»‰nh sá»­a County',0),(602670,16541,'vi','Láº­p lá»‹ch biá»ƒu cuá»™c háº¹n',0),(602671,16542,'vi','Quáº£n lÃ½ tÃ­nh',0),(602672,16543,'vi','Nháº­p thÃ´ng tin khÃ¡ch hÃ ng',0),(602673,16544,'vi','VÃ¹ng lÃ£nh thá»• nhÃ¢n viÃªn bÃ¡n hÃ ng nháº­p kháº©u',0),(602674,16545,'vi','Thuáº¿ bÃ¡n hÃ ng nháº­p kháº©u',0),(602675,16546,'vi','Nháº­p kháº©u Ä‘áº¡i lÃ½ Ä‘áº·t hÃ ng Froms',0),(602676,16547,'vi','Intercompany gÃ¡nh náº·ng váº­n chuyá»ƒn',0),(602677,16548,'vi','HÃ ng tá»“n kho cÃ¡c loáº¡i yÃªu cáº§u Ä‘iá»u chá»‰nh',0),(602678,16549,'vi','YÃªu cáº§u kiá»ƒm tra hÃ ng má»›i',0),(602679,16550,'vi','Khu vá»±c dÃ n dá»±ng',0),(602680,16551,'vi','Khu vá»±c táº­p trung',0),(602681,16552,'vi','TÃ i khoáº£n nháº­p sai',0),(602682,16553,'vi','Count khÃ´ng tÃ¬m tháº¥y cÃ¡c tÃ i khoáº£n báº±ng tÃªn',0),(602683,16554,'vi','Count khÃ´ng tÃ¬m tháº¥y trÆ°Æ¡ng má»¥c theo tÃªn',0),(602684,16555,'vi','Count khÃ´ng tÃ¬m tháº¥y váº­n chuyá»ƒn phÆ°Æ¡ng phÃ¡p theo tÃªn',0),(602685,16556,'vi','NhÃ  cung cáº¥p cÃ´ng cá»¥ phÃ¹ há»£p Muliple',0),(602686,16557,'vi','MÃ£ bÆ°u Ä‘iá»‡n hoáº·c nhÃ  nÆ°á»›c yÃªu cáº§u',0),(602687,16558,'vi','NhÃ¢n viÃªn bÃ¡n hÃ ng ID',0),(602688,16559,'vi','NhÃ¢n viÃªn bÃ¡n hÃ ng ID hoáº·c tÃªn pháº£i Ä‘Æ°á»£c thiáº¿t láº­p',0),(602689,16560,'vi','MÃ£ nÆ°á»›c',0),(602690,16561,'vi','TÃªn nhÃ  cung cáº¥p cÃ´ng ty hay tÃªn cuá»‘i cÃ¹ng pháº£i Ä‘Æ°á»£c thiáº¿t láº­p',0),(602691,16562,'vi','Sá»‘ Ä‘á»‹nh tuyáº¿n ngÃ¢n hÃ ng',0),(602692,16563,'vi','PhÆ°Æ¡ng thá»©c thanh toÃ¡n máº·c Ä‘á»‹nh',0),(602693,16564,'vi','MÃ£ sá»‘ nhÃ  cung cáº¥p pháº£i Ä‘Æ°á»£c thiáº¿t láº­p',0),(602694,16565,'vi','Trá»‘ng',0),(602695,16566,'vi','KhÃ´ng cÃ³ loáº¡i thiáº¿t',0),(602696,16567,'vi','Äáº·t cuá»™c háº¹n',0),(602697,16568,'vi','Má»Ÿ cuá»™c háº¹n',0),(602698,16569,'vi','Cuá»™c háº¹n vÃ o ngÃ y hÃ´m nay',0),(602699,16570,'vi','Táº¥t cáº£ cÃ¡c cuá»™c háº¹n',0),(602700,16571,'vi','Cuá»™c háº¹n chiá»u dÃ i',0),(602701,16572,'vi','Danh sÃ¡ch cÃ¡c cuá»™c háº¹n cho',0),(602702,16573,'vi','Äá»‹a Ä‘iá»ƒm háº¹n',0),(602703,16574,'vi','TÃªn cuá»™c háº¹n',0),(602704,16575,'vi','TÃ³m táº¯t cuá»™c háº¹n',0),(602705,16576,'vi','Láº­p lá»‹ch biá»ƒu cuá»™c háº¹n B2B',0),(602706,16577,'vi','Táº¡o cuá»™c háº¹n há»Ÿ',0),(602707,16578,'vi','XÃ³a má»Ÿ cuá»™c háº¹n',0),(602708,16579,'vi','Tiáº¿p theo cuá»™c háº¹n trong tÆ°Æ¡ng lai',0),(602709,16580,'vi','Chá»n má»™t ngÃ y Ä‘á»ƒ xem & chá»‰nh sá»­a cuá»™c háº¹n',0),(602710,16581,'vi','Hiá»ƒn thá»‹ báº£n tÃ³m táº¯t',0),(602711,16582,'vi','Unbook cuá»™c háº¹n',0),(602712,16583,'vi','ThÃªm má»›i quáº­n',0),(602713,16584,'vi','Quáº­n TÃªn',0),(602714,16585,'vi','Phá»¥ huynh bang',0),(602715,16586,'vi','Báº¡n pháº£i nháº­p tÃªn quáº­n',0),(602716,16587,'vi','Báº¡n pháº£i chá»n má»™t tiá»ƒu bang',0),(602717,16588,'vi','Báº¡n cÃ³ cháº¯c báº¡n muá»‘n xÃ³a bá» cÃ¡c háº¡t nÃ y khÃ´ng?',0),(602718,16589,'vi','Delete County',0),(602719,16590,'vi','Edit Custom County',0),(602720,16591,'vi','HÃ£y xem xÃ©t thÃªm má»™t quáº­n má»›i',0),(602721,16592,'vi','Chá»‰nh sá»­a County',0),(602722,16593,'vi','Lá»±a chá»n cá»§a báº¡n lÃ  má»™t giÃ¡ trá»‹ há»‡ thá»‘ng vÃ  khÃ´ng thá»ƒ thay Ä‘á»•i',0),(602723,16594,'vi','Báº¡n pháº£i Ä‘iá»n vÃ o máº«u Ä‘á»ƒ tiáº¿p tá»¥c',0),(602724,16595,'vi','KhÃ¡ch thÃªm',0),(602725,16596,'vi','KhÃ¡ch hÃ ng Ä‘Ã£ bá» qua',0),(602726,16597,'vi','KhÃ¡ch hÃ ng Cáº­p Nháº­t',0),(602727,16598,'vi','Äá»c dÃ²ng',0),(602728,16599,'vi','Äiá»‡n thoáº¡i thay tháº¿',0),(602729,16600,'vi','Tá»‡p nháº­p CSV',0),(602730,16601,'vi','Äiá»‡n thoáº¡i di Ä‘á»™ng trÃªn tÃ u sÃ¢n bay',0),(602731,16602,'vi','Sá»‘ Ä‘iá»‡n thoáº¡i',0),(602732,16603,'vi','Chá»n Ä‘iá»u kiá»‡n hÃ³a Ä‘Æ¡n',0),(602733,16604,'vi','TÃªn viáº¿t táº¯t cá»§a nhÃ  nÆ°á»›c',0),(602734,16605,'vi','Äá»‹a chá»‰ Ä‘Æ°á»ng phá»‘',0),(602735,16606,'vi','ThÃªm/chá»‰nh sá»­a',0),(602736,16607,'vi','AVG bÃ¡n hÃ ng má»—i thÃ¡ng',0),(602737,16608,'vi','Hiá»‡n táº¡i cung cáº¥p',0),(602738,16609,'vi','KhÃ´ng cÃ³ rÃ¡c chÃ­nh Ä‘Æ°á»£c giao',0),(602739,16610,'vi','Qty chuyá»ƒn nhÆ°á»£ng',0),(602740,16611,'vi','Bá»• sung cá»• phiáº¿u tá»« Trung tÃ¢m phÃ¢n phá»‘i',0),(602741,16612,'vi','Äá» nghá»‹',0),(602742,16613,'vi','Chuyá»ƒn SL',0),(602743,16614,'vi','Khu vá»±c',0),(602744,16615,'vi','CÃ¡c thÃ nh phá»‘ thÃªm',0),(602745,16616,'vi','CÃ¡c thÃ nh phá»‘ Cáº­p Nháº­t',0),(602746,16617,'vi','Háº¡t bá»• sung',0),(602747,16618,'vi','Quáº­n Cáº­p Nháº­t',0),(602748,16619,'vi','Ká»³ nháº­p',0),(602749,16620,'vi','Ká»³ Cáº­p Nháº­t',0),(602750,16621,'vi','Báº¡n cÃ³ cháº¯c báº¡n muá»‘n cáº­p nháº­t há»“ sÆ¡ thuáº¿ bÃ¡n hÃ ng cá»§a báº¡n?',0),(602751,16622,'vi','TÃªn thÃ nh phá»‘',0),(602752,16623,'vi','ThÃ nh phá»‘ thuáº¿ doanh thu nhÃ¢n',0),(602753,16624,'vi','ThÃ nh phá»‘ sá»­ dá»¥ng thuáº¿ nhÃ¢n',0),(602754,16625,'vi','Há»‡ sá»‘ quáº­n bÃ¡n hÃ ng thuáº¿',0),(602755,16626,'vi','Quáº­n sá»­ dá»¥ng thuáº¿ sá»‘ nhÃ¢n',0),(602756,16627,'vi','Thuáº¿ bÃ¡n hÃ ng nháº­p kháº©u',0),(602757,16628,'vi','Há»‡ sá»‘ doanh thu thuáº¿ nhÃ  nÆ°á»›c',0),(602758,16629,'vi','NhÃ  nÆ°á»›c sá»­ dá»¥ng thuáº¿ sá»‘ nhÃ¢n',0),(602759,16630,'vi','Thomson Reuters Tab File',0),(602760,16631,'vi','Dá»¯ liá»‡u',0),(602761,16632,'vi','Giá»¯ cho dá»¯ liá»‡u sáºµn cÃ³',0),(602762,16633,'vi','Dá»n sáº¡ch táº¥t cáº£ dá»¯ liá»‡u hiá»‡n cÃ³',0),(602763,16634,'vi','Dá»n sáº¡ch cÃ¡c dá»¯ liá»‡u sáºµn cÃ³ cho cÃ¡c nhÃ  cung cáº¥p trong nháº­p kháº©u',0),(602764,16635,'vi','Äang chá» nhÃ  cung cáº¥p tÃ­n dá»¥ng',0),(602765,16636,'vi','Tá»± Ä‘á»™ng chá»n doanh thu thuáº¿ tá»« tÃ u',0),(602766,16637,'vi','Thá»±c hiá»‡n vÃ  Ä‘Æ¡n Ä‘áº·t hÃ ng POS',0),(602767,16638,'vi','Cho phÃ©p quay láº¡i hÃ ng chá»‰ tá»« cÃ¡c trung tÃ¢m phÃ¢n phá»‘i',0),(602768,16639,'vi','Tá»± Ä‘á»™ng chá»n thuáº¿ bÃ¡n hÃ ng tÃ u chiáº¿n Ä‘á»ƒ thá»±c hiá»‡n vÃ  Ä‘Æ¡n Ä‘áº·t hÃ ng POS',0),(602769,16640,'vi','Cuá»‘i cÃ¹ng tháº£ hÃ ng Ä‘Ã²i há»i POD',0),(602770,16641,'vi','Gá»£i Ã½ Ä‘á»‹a Ä‘iá»ƒm mua hÃ ng thay tháº¿ khi Qty khÃ´ng sáºµn dÃ¹ng',0),(602771,16642,'vi','Miá»…n má»™t pháº§n thuáº¿',0),(602772,16643,'vi','Thuáº¿ tá»· lá»‡ pháº§n trÄƒm',0),(602773,16644,'vi','Trung tÃ¢m phÃ¢n phá»‘i in a thÃ¡ng bÃ¡n hÃ ng Ä‘á»ƒ sáº¯p xáº¿p láº¡i tÃ­nh',0),(602774,16645,'vi','Interbranch chuyá»ƒn gÃ¡nh náº·ng tá»· lá»‡ pháº§n trÄƒm GL khoáº£n',0),(602775,16646,'vi','Intercompany má»¥c chuyá»ƒn - cho phÃ©p nhiá»u vá»‹ trÃ­',0),(602776,16647,'vi','Intercompany váº­n chuyá»ƒn hÃ ng - gá»­i bÃ i',0),(602777,16648,'vi','HÃ ng tá»“n kho trong quÃ¡ cáº£nh GL tÃ i khoáº£n',0),(602778,16649,'vi','Trung tÃ¢m phÃ¢n phá»‘i khÃ´ng Num thÃ¡ng bÃ¡n hÃ ng Ä‘á»ƒ sáº¯p xáº¿p láº¡i tÃ­nh',0),(602779,16650,'vi','ÄÄƒng bá»Ÿi dÃ²ng',0),(602780,16651,'vi','ÄÄƒng bá»Ÿi váº­n chuyá»ƒn vÃ  tiáº¿p nháº­n',0),(602781,16652,'vi','B2B ngÆ°á»i dÃ¹ng Ä‘Äƒng nháº­p',0),(602782,16653,'vi','ÄÄƒng nháº­p vá»›i tÃªn ngÆ°á»i dÃ¹ng nÃ y',0),(602783,16654,'vi','KhÃ´ng thá»ƒ lÆ°u nhÆ° tá»± hoÃ n táº¥t',0),(602784,16655,'vi','KhÃ´ng cÃ³ tá»‡p POD Ä‘Æ°á»£c Ä‘Ã­nh kÃ¨m Ä‘á»ƒ Ä‘áº·t hÃ ng',0),(602785,16656,'vi','Tháº£ tÃ u',0),(602786,16657,'vi','LÆ°u trá»¯ & lÆ°u',0),(602787,16658,'vi','ÄÃ³ng cá»­a do chi phÃ­ mÃ£',0),(602788,16659,'vi','ÄÃ³ng cá»­a theo thá»ƒ loáº¡i GL',0),(602789,16660,'vi','ÄÃ³ng tÃ i khoáº£n chi phÃ­ mÃ£',0),(602790,16661,'vi','ÄÃ³ng tÃ i khoáº£n theo thá»ƒ loáº¡i GL',0),(602791,16662,'vi','NgÃ y bá»‹ há»§y bá»',0),(602792,16663,'vi','Nháº­p khoáº£ng thá»i gian 13',0),(602793,16664,'vi','Thuáº¿ nháº­p Ä‘iá»u chá»‰nh',0),(602794,16665,'vi','NÄƒm káº¿t thÃºc viá»‡c Ä‘iá»u chá»‰nh há»c',0),(602795,16666,'vi','13 giai Ä‘oáº¡n má»›i',0),(602796,16667,'vi','Thuáº¿ Ä‘iá»u chá»‰nh má»¥c',0),(602797,16668,'vi','Vá»›i Ä‘iá»u chá»‰nh má»¥c cuá»‘i nÄƒm',0),(602798,16669,'vi','Stock',0),(602799,16670,'vi','PhÃ­ khÃ¡c',0),(602800,16671,'vi','Chi phÃ­ khÃ¡c',0),(602801,16672,'vi','Chuyá»ƒn giá»¯a cÃ¡c Ä‘á»‹a Ä‘iá»ƒm',0),(602802,16673,'vi','Chuyá»ƒn thÃ´ng tin chi tiáº¿t',0),(602803,16674,'vi','KhÃ´ng tháº£',0),(602804,16675,'vi','Cho thuÃª',0),(602805,16676,'vi','Tháº£',0),(602806,16677,'vi','0 cho khÃ´ng cÃ³ Max',0),(602807,16678,'vi','0 cho No Min',0),(602808,16679,'vi','AVG Qty má»—i thÃ¡ng',0),(602809,16680,'vi','Táº¡o Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(602810,16681,'vi','Táº¡o Ä‘Æ¡n Ä‘áº·t hÃ ng',0),(602811,16682,'vi','Trung tÃ¢m phÃ¢n phá»‘i',0),(602812,16683,'vi','Äá»‹a Ä‘iá»ƒm kho',0),(602813,16684,'vi','Tá»‘i Ä‘a trÃªn tay',0),(602814,16685,'vi','Min trÃªn bÃ n tay',0),(602815,16686,'vi','NhÃ  cung cáº¥p cá»§a tÃ´i',0),(602816,16687,'vi','NUM thÃ¡ng bÃ¡n hÃ ng cho tá»‘i Ä‘a trÃªn bÃ n tay',0),(602817,16688,'vi','NUM thÃ¡ng bÃ¡n hÃ ng cho tá»‘i thiá»ƒu lÃ  trÃªn bÃ n tay',0),(602818,16689,'vi','NUM thÃ¡ng bÃ¡n hÃ ng Ä‘á»ƒ sáº¯p xáº¿p láº¡i sá»‘ lÆ°á»£ng',0),(602819,16690,'vi','LÃ  nhÃ  cung cáº¥p máº·t hÃ ng máº·c Ä‘á»‹nh?',0),(602820,16691,'vi','Sá»‘ ngÃ y',0),(602821,16692,'vi','TrÃ­ch dáº«n thá»i gian',0),(602822,16693,'vi','Thiáº¿t láº­p nÃ y nhÃ  cung cáº¥p nhÆ° lÃ  máº·c Ä‘á»‹nh cho nÃ y má»¥c sáº½ loáº¡i bá» báº¥t ká»³ nhÃ  cung cáº¥p máº·c Ä‘á»‹nh khÃ¡c cho khoáº£n má»¥c nÃ y',0),(602823,16694,'vi','NhÃ  bÃ¡n UPC',0),(602824,16695,'vi','RTV sá»‘',0),(602825,16696,'vi','Quay láº¡i tráº­t tá»±',0),(602826,16697,'vi','KhÃ´ng thá»ƒ thay Ä‘á»•i thá»© tá»± nÃ y Ä‘á»ƒ tháº£ tÃ u',0),(602827,16698,'vi','Vá»‹ trÃ­ hiá»‡n táº¡i',0),(602828,16699,'vi','Äáº·t hÃ ng cÃ³ doanh sá»‘-tháº£ tÃ u má»¥c',0),(602829,16700,'vi','Sá»‘ lÆ°á»£ng Ä‘Æ¡n Ä‘áº·t hÃ ng khÃ´ng cÃ³ sáºµn táº¡i Ä‘á»‹a Ä‘iá»ƒm',0),(602830,16701,'vi','Giáº£m sá»‘ lÆ°á»£ng Ä‘áº·t hÃ ng',0),(602831,16702,'vi','Tháº£ tÃ u má»¥c sau Ä‘Ã¢y Ä‘á»ƒ Ä‘Æ°á»£c gá»¡ bá»',0),(602832,16703,'vi','Phiáº¿u quÃ  táº·ng ID',0),(602833,16704,'vi','ChÃ­nh ngÆ°á»i mua',0),(602834,16705,'vi','Náº¿u quáº­n khÃ´ng pháº£i trÃªn danh sÃ¡ch',0),(602835,16706,'vi','HÃ nh Ä‘á»™ng Cáº­p Nháº­t',0),(602836,16707,'vi','YÃªu cáº§u mÃ£ chi phÃ­ náº¿u GL khoáº£n Ä‘Ã£ chi phÃ­ mÃ£',0),(602837,16708,'vi','Cáº§n GL Category náº¿u tÃ i khoáº£n GL cÃ³ thá»ƒ loáº¡i GL',0),(602838,16709,'vi','Trung tÃ¢m phÃ¢n phá»‘i',0),(602839,16710,'vi','Trung tÃ¢m phÃ¢n phá»‘i lÃ ?',0),(602840,16711,'vi','Kiá»ƒm tra trong',0),(602841,16712,'vi','ÄÄƒng kÃ½',0),(602842,16713,'vi','Kiá»ƒm tra bÃ¢y giá»',0),(602843,16714,'vi','Kiá»ƒm tra trong thá»i gian',0),(602844,16715,'vi','LÆ°u ghi chÃº',0),(602845,16716,'vi','Ghi chÃº Cáº­p Nháº­t',0),(602846,16717,'vi','KhÃ´ng thá»ƒ tÃ¬m tháº¥y GL tÃ i khoáº£n báº±ng tÃªn',0),(602847,16718,'vi','Bá»‡nh nhÃ¢n nháº­p kháº©u',0),(602848,16719,'vi','Äiá»n ngÃ y',0),(602849,16720,'vi','Cuá»‘i cuá»™c háº¹n',0),(602850,16721,'vi','Xin vui lÃ²ng 777 chmod',0),(602851,16722,'vi','Táº¥t cáº£ cÃ¡c cuá»™c háº¹n',0),(602852,16723,'vi','Äáº·t cuá»™c háº¹n nÃ y',0),(602853,16724,'vi','Lá»‡nh khÃ´ng Ä‘Æ°á»£c tÃ¬m tháº¥y',0),(602854,16725,'vi','XÃ¡c nháº­n thá»i gian cuá»™c háº¹n',0),(602855,16726,'vi','TÃ­nh nÄƒng khÃ´ng Ä‘Æ°á»£c kÃ­ch hoáº¡t',0),(602856,16727,'vi','Cuá»™c háº¹n tiáº¿p theo',0),(602857,16728,'vi','KhÃ´ng cÃ³ cuá»™c háº¹n sáº¯p tá»›i',0),(602858,16729,'vi','Má»Ÿ cuá»™c háº¹n cho',0),(602859,16730,'vi','Chá»n má»™t ngÃ y Ä‘á»ƒ xem má»Ÿ cuá»™c háº¹n',0),(602860,16731,'vi','NÆ¡i',0),(602861,16732,'vi','Lá»‹ch trÃ¬nh má»™t cuá»™c háº¹n',0),(602862,16733,'vi','Chá»n ngÃ y',0),(602863,16734,'vi','HÃ ng tá»“n kho Ä‘iá»u chá»‰nh yÃªu cáº§u loáº¡i',0),(602864,16735,'vi','Loáº¡i cá»§a yÃªu cáº§u Ä‘iá»u chá»‰nh hÃ ng tá»“n kho cá»§a mÃ£ nÃ y Ä‘Ã£ tá»“n táº¡i',0),(602865,16736,'vi','MÃ£ sá»‘ loáº¡i yÃªu cáº§u Ä‘iá»u chá»‰nh hÃ ng tá»“n kho pháº£i Ä‘Æ°á»£c thiáº¿t láº­p',0),(602866,16737,'vi','ÄÄƒng bá»Ÿi váº­n chuyá»ƒn & nháº­n',0),(602867,16738,'vi','ÄÄƒng nháº­p vá»›i tÃªn ngÆ°á»i dÃ¹ng nÃ y',0),(602868,16739,'vi','Bao gá»“m cÃ¡c dáº¥u ngoáº·c kÃ©p',0),(602869,16828,'en','Accept Suggested Taxes',0),(602870,16826,'en','Account Deleted',0),(602871,16827,'en','Account Missing',0),(602872,16849,'en','All Records Could Not Be Displayed',0),(602873,16885,'en','Already Shipped',0),(602874,16809,'en','Appointment Host',0),(602875,16810,'en','Appointment Service',0),(602876,16740,'en','Are You Sure You Want To Cancel Your Upcoming Appointment?',0),(602877,16757,'en','Assigned User',0),(602878,16752,'en','Bank Rec Date',0),(602879,16842,'en','Box 10 Dependent Care Benefits',0),(602880,16788,'en','Burden',0),(602881,16741,'en','Cancellation Window Closed',0),(602882,16742,'en','Cancel This Appointment',0),(602883,16789,'en','Cannot Process Transfer',0),(602884,16852,'en','Card Not Found For Vendor ID',0),(602885,16811,'en','Change Service Type',0),(602886,16853,'en','Code For The CC Vendor',0),(602887,16886,'en','Created For Sales Order',0),(602888,16829,'en','Current Sales Tax',0),(602889,16755,'en','Customer Must Be Set',0),(602890,16830,'en','Customer Record',0),(602891,16784,'en','Customer Sales Tax Updated',0),(602892,16790,'en','Default Inventory Account Must Be Set',0),(602893,16876,'en','Default Pricing',0),(602894,16817,'en','Delete Existing',0),(602895,16818,'en','Delete This Discount',0),(602896,16795,'en','Discharged',0),(602897,16819,'en','Discount Name',0),(602898,16758,'en','Due Date End',0),(602899,16759,'en','Due Date Start',0),(602900,16820,'en','Edit Item Category Discounts Per Price Level',0),(602901,16861,'en','Edit Item Location',0),(602902,16760,'en','Entry Date End',0),(602903,16761,'en','Entry Date Start',0),(602904,16887,'en','Error Saving An Order That Contains An Item Transfer',0);
INSERT INTO `langdef` VALUES (602905,16894,'en','For Insufficient Qty',0),(602906,16762,'en','From/Supplier',0),(602907,16796,'en','Half Program Joined',0),(602908,16851,'en','Hide Accounts With No Activity',0),(602909,16854,'en','ID Or Code Required',0),(602910,16773,'en','Import Customer Invoices',0),(602911,16774,'en','Import Customer Invoice Changes',0),(602912,16756,'en','Import Customer Ship Tos',0),(602913,16775,'en','Import Distributor Sales',0),(602914,16776,'en','Import Patient Info',0),(602915,16791,'en','Interbranch Transfer Burden Percentage GL Account Must Be Set',0),(602916,16771,'en','Intercompany Item Transfer Shipment',0),(602917,16862,'en','Intercompany Transfer',0),(602918,16892,'en','Invoice List Overflows At More Than',0),(602919,16777,'en','Item Category Discounts',0),(602920,16893,'en','Item Category Discounts For Price Levels',0),(602921,16821,'en','Item Category Match Term',0),(602922,16792,'en','Item Not Set',0),(602923,16763,'en','Item Transfer Management',0),(602924,16750,'en','I have the authority to authorize and do authorize the above bank account to be debited for the listed amount.',0),(602925,16797,'en','Joined',0),(602926,16793,'en','Location Not Set',0),(602927,16822,'en','Matching Item Categories',0),(602928,16831,'en','Maximum Of 3 Tax Rates Per Customer Or Ship To Record',0),(602929,16805,'en','Membership Report',0),(602930,16798,'en','Membership Summary',0),(602931,16794,'en','Multiple Location Combinations',0),(602932,16857,'en','Must Have Vendor ID Or Code, Payment Date, Payment Amount, Expense GL Account & Business Purpose',0),(602933,16855,'en','Must Have Vendor ID Or Code, Payment Date, Payment Amount, Expense GL Account & Merchant Name',0),(602934,16778,'en','New Rental Order',0),(602935,16779,'en','New Rental Quote',0),(602936,16786,'en','New Unassigned',0),(602937,16764,'en','Nobody',0),(602938,16799,'en','Not Joined',0),(602939,16765,'en','No Active Transfers Assigned To User',0),(602940,16888,'en','No Changes Made To Transfer',0),(602941,16800,'en','No Show',0),(602942,16766,'en','Num Items Picked',0),(602943,16845,'en','Overrides',0),(602944,16878,'en','Over Commit Qty',0),(602945,16753,'en','Paid On Invoice',0),(602946,16843,'en','Payment After Discount',0),(602947,16868,'en','Per Day',0),(602948,16869,'en','Per Week',0),(602949,16767,'en','Picked',0),(602950,16863,'en','Please Change Your Active Company To Edit This',0),(602951,16870,'en','Price Per Day',0),(602952,16858,'en','Price Per Day At Level',0),(602953,16871,'en','Price Per Month',0),(602954,16859,'en','Price Per Month At Level',0),(602955,16872,'en','Price Per Week',0),(602956,16860,'en','Price Per Week  At Level',0),(602957,16815,'en','Primary Location',0),(602958,16812,'en','Printer Friendly Summary',0),(602959,16780,'en','Print Picking Tickets',0),(602960,16768,'en','Print Pick Ticket',0),(602961,16864,'en','Print Posted Entries',0),(602962,16865,'en','Prior Shipments',0),(602963,16801,'en','Professional Courtesy',0),(602964,16879,'en','Purchase From Vendor',0),(602965,16814,'en','Purge Existing Data For Customers In Import',0),(602966,16875,'en','Receipt Batch ID',0),(602967,16873,'en','Receipt Failed',0),(602968,16787,'en','Received/Completed',0),(602969,16874,'en','Received No PO',0),(602970,16844,'en','Recent Orders',0),(602971,16743,'en','Records Updated',0),(602972,16806,'en','Referral Report',0),(602973,16804,'en','Referral Summary',0),(602974,16754,'en','Ref #',0),(602975,16785,'en','Rental Order',0),(602976,16781,'en','Rental Orders',0),(602977,16848,'en','Rental Orders Only',0),(602978,16846,'en','Rental Order Deposit',0),(602979,16847,'en','Rental Order Number',0),(602980,16850,'en','Rental Order Quotes',0),(602981,16825,'en','Rental Quote',0),(602982,16782,'en','Rental Quotes',0),(602983,16880,'en','Rental Quote Number',0),(602984,16813,'en','Repeat',0),(602985,16832,'en','Sales Tax Conflict',0),(602986,16833,'en','Sales Tax Preference',0),(602987,16834,'en','Selection Limit Exceeded',0),(602988,16807,'en','Select Date Range',0),(602989,16808,'en','Select Report Options',0),(602990,16744,'en','Select Service',0),(602991,16881,'en','Sell From',0),(602992,16772,'en','Shipment Date',0),(602993,16866,'en','Shipped By',0),(602994,16835,'en','Ship To Record',0),(602995,16896,'en','Show Item Search Icon In Header',0),(602996,16802,'en','Signup Date',0),(602997,16748,'en','Stored Payment Methods',0),(602998,16816,'en','Street Address Line 2',0),(602999,16836,'en','Suggested Sales Tax',0),(603000,16837,'en','Tax Order By Address',0),(603001,16838,'en','Tax Ship To',0),(603002,16823,'en','The Following Discount Will Be Deleted',0),(603003,16839,'en','This Action Will Remove Set Taxes For This Customer',0),(603004,16889,'en','This Order Has Multiple Transfers Assigned',0),(603005,16882,'en','This Popup Can Be Disabled Under',0),(603006,16803,'en','Total Members',0),(603007,16769,'en','To/Requester',0),(603008,16783,'en','Transfers',0),(603009,16770,'en','Transfers Assigned To',0),(603010,16883,'en','Transfer From',0),(603011,16895,'en','Transfer Inventory From',0),(603012,16867,'en','Transfer Update Partially Successful',0),(603013,16890,'en','Tried To Create A PO For An Item Without A Vendor',0),(603014,16824,'en','Use Percent Character As A Wildcard Match',0),(603015,16840,'en','Use Selected Taxes',0),(603016,16856,'en','Vendor ID Info',0),(603017,16884,'en','Wait On Backorder',0),(603018,16841,'en','Will Be Updated',0),(603019,16891,'en','Will Not Be Changed',0),(603020,16745,'en','With',0),(603021,16751,'en','You Must Authorize This Transaction',0),(603022,16877,'en','You Must Enter A Vendor PO Number Or Receipt Batch ID',0),(603023,16749,'en','You Must Provide A Payment Method To Book An Appointment',0),(603024,16746,'en','You Will Receive An Email Shortly As Confirmation',0),(603025,16747,'en','You Will Receive An Email Shortly With Your Appointment Details',0),(603026,16897,'en','Cannot Process Transfer',0),(603027,16898,'en','Multiple Location Combinations',0),(603028,16908,'en','Changing This Order To Drop Ship Will Make The Following Changes',0),(603029,16907,'en','Charge Type Not Set For',0),(603030,16903,'en','Dismiss',0),(603031,16901,'en','Dismiss PO Item Import Popup Warning',0),(603032,16909,'en','Hide 2nd Stub Header',0),(603033,16910,'en','Hide Discount Total',0),(603034,16911,'en','Hide Interest Total',0),(603035,16899,'en','Import Customer Contacts',0),(603036,16900,'en','Import Vendor Contacts',0),(603037,16904,'en','Items Skipped During Import',0),(603038,16905,'en','Please Verify Your Item Codes',0),(603039,16912,'en','Show Bill Comments On Stub',0),(603040,16906,'en','The Following Items Could Not Be Imported',0),(603041,16902,'en','Vendor Address',0),(603042,16919,'en','Actual Appointments',0),(603043,16920,'en','All Dates',0),(603044,16921,'en','Appointment History For',0),(603045,16930,'en','Approved Bills',0),(603046,16929,'en','Approved Bills Report',0),(603047,16922,'en','Cancellations Or Reschedules',0),(603048,16917,'en','Customer Appointments',0),(603049,16926,'en','Customer Appointment Report Options',0),(603050,16914,'en','Customer Contacts',0),(603051,16915,'en','Customer ID, Code, Or Name Must Be Set',0),(603052,16932,'en','Default Line Note',0),(603053,16913,'en','Ending',0),(603054,16927,'en','Generate Report',0),(603055,16923,'en','Missed',0),(603056,16924,'en','Missed Appointments',0),(603057,16918,'en','New Bank Reconciliation',0),(603058,16931,'en','Payment Total',0),(603059,16925,'en','Total Bookings',0),(603060,16916,'en','Vendor Contacts',0),(603061,16928,'en','You Must Select A Customer To Proceed',0),(603062,16933,'en','Convert Selected',0),(603063,16934,'en','Convert To PO',0),(603064,16942,'en','Enable Commercial AP',0),(603065,16943,'en','Max Invoices',0),(603066,16941,'en','No Federal Income Taxes',0),(603067,16944,'en','Number Of Invoice Sections On Stub',0),(603068,16945,'en','# Sections',0),(603069,16935,'en','Order Line #',0),(603070,16936,'en','PO Proposal Management',0),(603071,16937,'en','Proposals Converted',0),(603072,16938,'en','Proposal Converted',0),(603073,16939,'en','Proposal #',0),(603074,16940,'en','Selected Proposals',0),(603075,16946,'en','Show Invoice Comments On Stub',0),(603076,16947,'en','Show Invoice Discounts On Stub',0),(603077,16953,'en','All Hosts',0),(603078,17001,'en','Apply Discounts Even If Past Discount Date',0),(603079,16954,'en','Are You Sure You Want To Continue?',0),(603080,16961,'en','Automatically Sync Customers',0),(603081,16962,'en','Automatically Sync Items',0),(603082,16963,'en','Automatically Sync Item Tags',0),(603083,16964,'en','Automatically Sync Orders',0),(603084,16965,'en','Automatically Sync Payments',0),(603085,16966,'en','Automatically Sync Shipping',0),(603086,16967,'en','Before Attempting To Edit Your Credentials',0),(603087,17014,'en','Block Deductions',0),(603088,16968,'en','Check For Missing Data',0),(603089,16969,'en','Click Here For Help',0),(603090,16970,'en','Click OK To Open The Link In A New Window For Verification',0),(603091,17008,'en','Color Code',0),(603092,16971,'en','Could Not Connect With Provided Information',0),(603093,16972,'en','Customer Creation',0),(603094,16973,'en','Customer Deletion',0),(603095,16974,'en','Customer Disable',0),(603096,16975,'en','Customer Enable',0),(603097,17009,'en','Default Length',0),(603098,17002,'en','Discount Filter',0),(603099,16976,'en','Edit Credentials',0),(603100,16977,'en','Event List',0),(603101,16955,'en','Filter',0),(603102,17003,'en','Force Discounts',0),(603103,16978,'en','For Shopify To Automatically Send Data To Your Application You Must Add Your Webhook URL To The Shopify Events Listed Below',0),(603104,16979,'en','Integration Options',0),(603105,17000,'en','Link To Your Shopify Store',0),(603106,17010,'en','Lock Price & Cost During Sale',0),(603107,16980,'en','Make Sure The URL Below Points To Your Shopify Store',0),(603108,16948,'en','New Intercompany Journal Entry',0),(603109,16956,'en','Note Conflict',0),(603110,16957,'en','Note Has Changed Since Last Refresh',0),(603111,17004,'en','No EFT Data Sent As Vendor Does Not Have Bank Info',0),(603112,17013,'en','No Pay For Selected Period',0),(603113,17011,'en','No Pay For Selected Periods',0),(603114,16981,'en','Order Cancellation',0),(603115,16982,'en','Order Creation',0),(603116,16983,'en','Order Deletion',0),(603117,16984,'en','Order Fulfillment',0),(603118,16985,'en','Order Payment',0),(603119,16986,'en','Plan',0),(603120,16987,'en','Product Creation',0),(603121,16988,'en','Product Deletion',0),(603122,16989,'en','Product Update',0),(603123,16950,'en','Required Feature Not Found',0),(603124,16990,'en','Save Options',0),(603125,16991,'en','Shared Secret',0),(603126,16992,'en','Shopify Has An API Usage Limit',0),(603127,16993,'en','Shopify Integration Manager',0),(603128,16949,'en','Shopify Setup',0),(603129,17005,'en','Show All Bills',0),(603130,17012,'en','Show Employees With No Pay',0),(603131,17006,'en','Show Only Bills With Pay Dates AFTER Discount Dates',0),(603132,17007,'en','Show Only Bills With Pay Dates ON Or BEFORE Discount Dates',0),(603133,16951,'en','Store Configuration Deleted',0),(603134,16952,'en','Store Configuration Saved',0),(603135,16994,'en','Store Info',0),(603136,16995,'en','Store Name',0),(603137,16958,'en','Theirs',0),(603138,16996,'en','Use Shopify Payments',0),(603139,16997,'en','Use Shopify Shipping Quotes',0),(603140,16998,'en','Verify Store URL',0),(603141,16959,'en','Yours',0),(603142,16999,'en','Your Webhook URL',0),(603143,16960,'en','You Have Unsaved Changes',0),(603144,17015,'en','Force Discounts To Be Taken',0),(603145,17017,'en','Show Only Bills Without Discounts',0),(603146,17018,'en','Show Only Bills With Discounts',0),(603147,17016,'en','Take Discount Even If Paying After Discount Date',0),(603148,17019,'en','Batch Send Job Prelim Requests',0),(603149,17020,'en','Only Jobs With No Existing Prelim Requests',0),(603150,17021,'en','Preferred Method',0),(603151,17053,'en','Allow Editing Note Dates',0),(603152,17034,'en','Auto Refresh In',0),(603153,17035,'en','Auto Refresh Preference',0),(603154,17054,'en','Can Override FO/POS Prices',0),(603155,17047,'en','Customer Not Set',0),(603156,17024,'en','Decline',0),(603157,17036,'en','Do Not Auto Refresh',0),(603158,17037,'en','Enable Auto Refresh',0),(603159,17038,'en','Every - 10 Minutes',0),(603160,17039,'en','Every - 15 Minutes',0),(603161,17040,'en','Every - 20 Minutes',0),(603162,17041,'en','Every - 5 Minutes',0),(603163,17042,'en','For Customer',0),(603164,17043,'en','For Item',0),(603165,17032,'en','Initial Consult',0),(603166,17052,'en','Notices',0),(603167,17048,'en','Pending Price Requests Have Been Applied',0),(603168,17022,'en','Price Override Request',0),(603169,17023,'en','Price Override Requests',0),(603170,17025,'en','Requested',0),(603171,17044,'en','Requested Price',0),(603172,17045,'en','Requested Time',0),(603173,17046,'en','Requested User',0),(603174,17049,'en','Request Authorization',0),(603175,17050,'en','Request Price',0),(603176,17051,'en','Request Price Change',0),(603177,17026,'en','Set Price',0),(603178,17027,'en','This Request Cannot Be Modified',0),(603179,17028,'en','This Request Has Already Been Approved',0),(603180,17029,'en','This Request Has Already Been Denied',0),(603181,17030,'en','This Request Has Been Approved',0),(603182,17031,'en','This Request Has Been Denied',0),(603183,17033,'en','Total Status Changes',0),(603184,17055,'en','User Rights For Company',0),(603185,17056,'en','Appointment On',0),(603186,17057,'en','Appointment To Cancel',0),(603187,17058,'en','Are You Sure You Want To Reschedule This Appointment?',0),(603188,17059,'en','Available Appointments',0),(603189,17060,'en','Change Appointment',0),(603190,17070,'en','Checking Account Files',0),(603191,17065,'en','Check Total',0),(603192,17066,'en','Check Total Is Negative So Removing Bills From Check Run',0),(603193,17064,'en','If Already Set',0),(603194,17061,'en','I Want To',0),(603195,17062,'en','Keep',0),(603196,17068,'en','More Options',0),(603197,17067,'en','Orig Amt',0),(603198,17063,'en','Reschedule',0),(603199,17069,'en','Show Invoice Original Amount',0),(603200,17071,'en','Vendor Statements',0),(603201,17072,'en','You may need to adjust your firewall to allow traffic from the following IP address into your network to communicate with the terminal',0),(603202,17099,'en','Allow Zero Quantity On Quotes',0),(603203,17106,'en','An Error Occurred During Connection',0),(603204,17115,'en','Billing Cycle Date',0),(603205,17120,'en','Can View & Edit Customer Bank Info',0),(603206,17121,'en','Can View & Edit Vendor Bank Info',0),(603207,17073,'en','CC Terminal',0),(603208,17084,'en','Certificate Expired Email',0),(603209,17085,'en','Certificate Expiring Soon Email',0),(603210,17086,'en','Certificate Missing Email',0),(603211,17091,'en','Change Appointment Host',0),(603212,17107,'en','Charge',0),(603213,17074,'en','Checking Account Not Set For CC Terminal',0),(603214,17108,'en','Collection Payment From Terminal',0),(603215,17109,'en','Collect Payment',0),(603216,17083,'en','Credit Card Terminals',0),(603217,17077,'en','Credit Card Terminals History',0),(603218,17075,'en','Declined',0),(603219,17097,'en','Default Payment Email Template',0),(603220,17094,'en','Detach',0),(603221,17100,'en','Download Not Allowed',0),(603222,17087,'en','Email Template Not Set On Certificate Type',0),(603223,17088,'en','Expiration Date No Set',0),(603224,17076,'en','IP Address',0),(603225,17079,'en','Mail Log',0),(603226,17080,'en','Mail Log Entry',0),(603227,17081,'en','Mail Log Open',0),(603228,17116,'en','Manual Credit Card Processing',0),(603229,17101,'en','Must Have Customer Bank Info Rights',0),(603230,17119,'en','Must Have Customer Bank Info Rights To View Or Modify',0),(603231,17102,'en','Must Have Vendor Bank Info Rights',0),(603232,17118,'en','Must Have Vendor Bank Info Rights To View Or Modify',0),(603233,17103,'en','Not Allowed',0),(603234,17095,'en','No CC Terminal Selected',0),(603235,17092,'en','No Credit Card Terminals Found',0),(603236,17096,'en','Only SMTP Emails Will Log Message Sent',0),(603237,17110,'en','Please Check With Your CC Processor To See If The Transaction Was Approved',0),(603238,17105,'en','Print AP Batch',0),(603239,17104,'en','Print Batch',0),(603240,17111,'en','Select A CC Terminal',0),(603241,17098,'en','Send Emails For Which Payment Types',0),(603242,17089,'en','Send Emails To All',0),(603243,17090,'en','Send Selected Emails',0),(603244,17082,'en','Show Only Failed',0),(603245,17093,'en','Show Terminals From Other Locations',0),(603246,17078,'en','Terminal',0),(603247,17117,'en','Terminal Credit Card Processing',0),(603248,17113,'en','Transaction Failed',0),(603249,17114,'en','Transaction Number',0),(603250,17112,'en','Waiting On Payment',0),(603251,17122,'en','An Error Occurred During Connection',0),(603252,17123,'en','Collect Payment From Terminal',0),(603253,17124,'en','Please Check With Your CC Processor To See If The Transaction Was Approved',0),(603254,17125,'en','Are You Sure You Want To Reschedule Your Appointment?',0),(603255,17126,'en','Change This Appointment',0),(603256,17127,'en','Change Your Appointment',0),(603257,17131,'en','Clone Service Order',0),(603258,17132,'en','Clone Without Time',0),(603259,17133,'en','Clone With Time Records',0),(603260,17129,'en','Invalid Request',0),(603261,17128,'en','My Appointment On',0),(603262,17134,'en','Select Action',0),(603263,17130,'en','Service Order Cloned Successfully',0),(603264,17141,'en','Also The Date Range Will Be Changed To Cover Whole Months',0),(603265,17135,'en','AP Variance',0),(603266,17142,'en','AP Variance Tracker',0),(603267,17143,'en','Bill Disc Pmt Diff',0),(603268,17144,'en','Bill GL Entries',0),(603269,17145,'en','Difference Exists',0),(603270,17146,'en','End Period Balance',0),(603271,17147,'en','GL Entries To AP From The AP Module But No Reference',0),(603272,17148,'en','GL Entries To AP Outside The AP Module',0),(603273,17149,'en','GL Net AP',0),(603274,17150,'en','GL Values',0),(603275,17151,'en','If Unchecked Post Date Will Be Used For Posted Transactions',0),(603276,17136,'en','Order Changed',0),(603277,17137,'en','Order Changed By User',0),(603278,17138,'en','Order Deleted By User',0),(603279,17152,'en','Payment GL Entries',0),(603280,17153,'en','Period Net Activity',0),(603281,17139,'en','Send Email To Admins When Fulfillment Order Is Modified',0),(603282,17140,'en','Send Email To Salesperson When Fulfillment Order Is Modified',0),(603283,17162,'en','Show AP Details',0),(603284,17154,'en','Sign Flipped',0),(603285,17155,'en','Total Bills',0),(603286,17156,'en','Total Bills Open',0),(603287,17157,'en','Total Bill Details',0),(603288,17158,'en','Total Discounts',0),(603289,17159,'en','Total GL Bills',0),(603290,17160,'en','Total GL Payments',0),(603291,17161,'en','Use Only Entry Date',0),(603292,17211,'en','2nd Stub Is A Copy',0),(603293,17217,'en','Add This Option Group To All Items',0),(603294,17212,'en','Always Pay On Which Date',0),(603295,17210,'en','An Employee With This Social Security Number Already Exists',0),(603296,17169,'en','AP Import From eBay As Buyer',0),(603297,17170,'en','AR Import From eBay As Seller',0),(603298,17190,'en','Attach To',0),(603299,17164,'en','Bank Reconciliations Table',0),(603300,17195,'en','Based On Prelim Amount',0),(603301,17199,'en','Bill Total',0),(603302,17221,'en','Certificate',0),(603303,17188,'en','Created RMAs',0),(603304,17171,'en','Create Multiple RMAs',0),(603305,17218,'en','Default Option Group For All New Items',0),(603306,17183,'en','Duplicate Line Removed',0),(603307,17172,'en','eBay Setup',0),(603308,17179,'en','Employee Certificate',0),(603309,17182,'en','Employee Certificates',0),(603310,17180,'en','Employee Certificate Type',0),(603311,17173,'en','Employee Certificate Types',0),(603312,17220,'en','Expired Certificates',0),(603313,17178,'en','Generate QR Code',0),(603314,17163,'en','GL Account Deposited To',0),(603315,17216,'en','Hide Customer Overdue Notice',0),(603316,17196,'en','Hide Item Codes',0),(603317,17197,'en','Hide Job Code',0),(603318,17181,'en','Import Vendor',0),(603319,17209,'en','Include Customer Notes',0),(603320,17175,'en','Items On Return',0),(603321,17198,'en','Job Credit Limit Markup',0),(603322,17192,'en','Next RMA Number',0),(603323,17165,'en','Prelim Amount',0),(603324,17166,'en','Prelim Estimate',0),(603325,17174,'en','QR Document Scanner',0),(603326,17184,'en','Quantity',0),(603327,17189,'en','Record',0),(603328,17219,'en','Remove This Option Group From All Items',0),(603329,17176,'en','Return Qty',0),(603330,17191,'en','Review Uploads',0),(603331,17185,'en','RMA Action',0),(603332,17186,'en','RMA Condition',0),(603333,17177,'en','RMA #',0),(603334,17187,'en','RMA Reason',0),(603335,17193,'en','RMA Return Policy',0),(603336,17194,'en','RMA Settings',0),(603337,17167,'en','Sales Tax Code',0),(603338,17168,'en','Sales Tax Not Found',0),(603339,17214,'en','Send Confirmations',0),(603340,17215,'en','Send Quotes',0),(603341,17207,'en','Show Cost Codes For Direct GL Entries',0),(603342,17208,'en','Show GL Categories For Direct GL Entries',0),(603343,17200,'en','Show Only Entries With Differences',0),(603344,17201,'en','Total Bills Dated Inside This Period But Posted Outside This Period',0),(603345,17202,'en','Total Bills Dated Outside This Period But Posted Inside This Period',0),(603346,17203,'en','Total Bills Net',0),(603347,17204,'en','Total Payments Dated Inside This Period But Posted Outside This Period',0),(603348,17205,'en','Total Payments Dated Outside This Period But Posted Inside This Period',0),(603349,17206,'en','Total Payments Net',0),(603350,17213,'en','Use Default Dates',0),(603351,17222,'en','Hide Customer Number',0),(603352,17223,'en','Show Cost Code As Separate Column',0),(603353,16740,'af','Is jy seker jy wil kanselleer jou komende afspraak?',0),(603354,16741,'af','Kansellasie venster gesluit',0),(603355,16742,'af','Kanselleer hierdie aanstelling',0),(603356,16743,'af','Rekords opgedateer',0),(603357,16744,'af','Kies diens',0),(603358,16745,'af','Met',0),(603359,16746,'af','Jy sal \'n e-pos kort As bevestiging ontvang',0),(603360,16747,'af','Jy sal \'n e-pos ontvang kort met jou aanstelling besonderhede',0),(603361,16748,'af','Gestoorde betaling metodes',0),(603362,16749,'af','Jy moet \'n betalingsmetode bespreek \'n afspraak verskaf',0),(603363,16750,'af','Ek het die gesag om te magtig en magtig die bogenoemde bankrekening om vir die gelyste bedrag gedebiteer word.',0),(603364,16751,'af','Jy moet hierdie transaksie magtig',0),(603365,16752,'af','Bank Rec datum',0),(603366,17353,'en','Access Token',0),(603367,17419,'en','Account Closed Date',0),(603368,17242,'en','Account Configuration Saved',0),(603369,17243,'en','Account Error',0),(603370,17329,'en','Account ID',0),(603371,17330,'en','Account Info',0),(603372,17331,'en','Account Nickname',0),(603373,17332,'en','Account Status',0),(603374,17244,'en','Account Configuration Deleted',0),(603375,17374,'en','Add New Store',0),(603376,17333,'en','Allow Automatic Order Imports',0),(603377,17325,'en','All Statuses',0),(603378,17259,'en','Already Exists At Location',0),(603379,17250,'en','Already In System',0),(603380,17406,'en','Assign Invoice Attachments',0),(603381,17423,'en','Assign Order Attachments',0),(603382,17424,'en','Assign Quote Attachments',0),(603383,17432,'en','Attach',0),(603384,17251,'en','Attach To Sub Code',0),(603385,17407,'en','Authorized & Accepted By',0),(603386,17238,'en','Billtrust',0),(603387,17260,'en','Bin',0),(603388,17261,'en','Bin Code',0),(603389,17391,'en','Block GL Auto Fill For New Bills',0),(603390,17300,'en','Both Customer And Vendor Cannot Be Set',0),(603391,17426,'en','Capitalize Payee Name',0),(603392,17334,'en','Close The eBay Window After Authorizing',0),(603393,17392,'en','Combine Line Item Tax Before Rounding',0),(603394,17422,'en','Committed Qty',0),(603395,17224,'en','Created Invoices',0),(603396,17284,'en','Creation Date',0),(603397,17229,'en','CRM Tasks',0),(603398,17230,'en','CRM Task Activity',0),(603399,17252,'en','Customer Code If For Job',0),(603400,17301,'en','Customer Or Vendor Code Must Be Set',0),(603401,17231,'en','Customer Ship Tos',0),(603402,17408,'en','Date Of Acceptance',0),(603403,17326,'en','Date Set',0),(603404,17356,'en','Days To Look Back',0),(603405,17433,'en','Default Attachment',0),(603406,17335,'en','Default Inventory Location',0),(603407,17336,'en','Default Invoice Terms',0),(603408,17337,'en','Default Item Price Unit',0),(603409,17338,'en','Default Item Usage Unit',0),(603410,17367,'en','Default Refund Account',0),(603411,17339,'en','Default Sales Account',0),(603412,17340,'en','Default Sales Tax Account',0),(603413,17341,'en','Default Tax Exemption If Exempt',0),(603414,17427,'en','Delivery Mode',0),(603415,17395,'en','Display Sales Person Info In Quotes Header',0),(603416,17396,'en','Display Signature Line In Quotes Footer',0),(603417,17293,'en','Download For Manual Sending',0),(603418,17368,'en','Do Not Close This Page',0),(603419,17308,'en','Due And Payable On Or Before',0),(603420,17416,'en','Due Date Not Recognized',0),(603421,17420,'en','Each Voucher Can Only Have One Currency',0),(603422,17357,'en','eBay Account',0),(603423,17309,'en','eBay Customer',0),(603424,17310,'en','eBay Customer Email',0),(603425,17311,'en','eBay Customer Phone',0),(603426,17312,'en','eBay ID',0),(603427,17342,'en','eBay Integration Manager',0),(603428,17232,'en','Employee Expenses',0),(603429,17369,'en','Error Creating Webhooks',0),(603430,17322,'en','Error Log',0),(603431,17239,'en','Export Balances',0),(603432,17241,'en','Export Customer Balances',0),(603433,17240,'en','Export Invoices',0),(603434,17285,'en','File Categories',0),(603435,17249,'en','File Category',0),(603436,17253,'en','File Location',0),(603437,17254,'en','File Location Must Be Set',0),(603438,17397,'en','FTP Host',0),(603439,17398,'en','FTP Password',0),(603440,17399,'en','FTP User',0),(603441,17343,'en','Getting Token From eBay',0),(603442,17354,'en','Get Access Token',0),(603443,17286,'en','Import CRM Tasks',0),(603444,17287,'en','Import CRM Task Activity',0),(603445,17323,'en','Import Errors',0),(603446,17255,'en','Import Files',0),(603447,17269,'en','Import Inventory Purchase Orders',0),(603448,17266,'en','Import Inventory Transfers',0),(603449,17282,'en','Import Item Activity',0),(603450,17275,'en','Import Item Location Details',0),(603451,17288,'en','Import Item Search Categories',0),(603452,17274,'en','Import Motorstate Item Changes',0),(603453,17358,'en','Import Orders From eBay',0),(603454,17376,'en','Import Selected Customers',0),(603455,17382,'en','Import Selected Items',0),(603456,17363,'en','Import Selected Orders',0),(603457,17386,'en','Import Selected Quotes',0),(603458,17377,'en','Import Shopify Customers',0),(603459,17383,'en','Import Shopify Items',0),(603460,17385,'en','Import Shopify Orders',0),(603461,17387,'en','Import Shopify Quotes',0),(603462,17388,'en','Import Source',0),(603463,17280,'en','Import Special Sales Pricing',0),(603464,17262,'en','Import Warehouse Bin',0),(603465,17264,'en','Import Warehouse Bin Items',0),(603466,17271,'en','Import Warehouse Zone',0),(603467,17256,'en','Invalid',0),(603468,17267,'en','Inventory Location From',0),(603469,17268,'en','Inventory Location To',0),(603470,17400,'en','Invoice Attachments',0),(603471,17417,'en','Invoice Date Not Recognized',0),(603472,17265,'en','Is Primary',0),(603473,17270,'en','Is Proposal',0),(603474,17384,'en','Item Code SKU',0),(603475,17233,'en','Item Location Details',0),(603476,17234,'en','Item Search Categories',0),(603477,17289,'en','Item Transfer',0),(603478,17412,'en','Last Shipment',0),(603479,17344,'en','Link To Your eBay Account',0),(603480,17295,'en','List Of Usernames Separated By Tilde',0),(603481,17296,'en','List Of User Groups Separated By Tilde',0),(603482,17431,'en','Locations Where Inventory Is Kept',0),(603483,17294,'en','Log',0),(603484,17421,'en','Mark As Accepted',0),(603485,17276,'en','Max Stock',0),(603486,17327,'en','Membership Status',0),(603487,17290,'en','Membership Status Report',0),(603488,17277,'en','Min Stock',0),(603489,17297,'en','Module Must Be Either',0),(603490,17324,'en','More Errors Can Be Reviewed In The Import Log',0),(603491,17345,'en','Name Cannot Be Empty',0),(603492,17405,'en','New Fulfillment Order',0),(603493,17302,'en','Next Task Action',0),(603494,17303,'en','Next Task Action Date',0),(603495,17245,'en','Not Enough Search Data',0),(603496,17281,'en','Not Found For Customer',0),(603497,17263,'en','Not Found For Location',0),(603498,17225,'en','No Invoice Created',0),(603499,17359,'en','Orders Per Page',0),(603500,17401,'en','Order Attachments',0),(603501,17378,'en','Or Specific IDs',0),(603502,17364,'en','Or Specify Order Numbers',0),(603503,17428,'en','Payee Name Font Size',0),(603504,17418,'en','Payment Date Not Recognized',0),(603505,17402,'en','Pending Documents',0),(603506,17379,'en','Per Page',0),(603507,17346,'en','Please Wait',0),(603508,17380,'en','Please Wait While Your Data Is Imported',0),(603509,17246,'en','Prev',0),(603510,17409,'en','Purchase Order # Or Project Reference',0),(603511,17403,'en','Quote Attachments',0),(603512,17247,'en','Redirecting To Admin',0),(603513,17291,'en','Referral Source Report',0),(603514,17328,'en','Referrer',0),(603515,17347,'en','Renew Token Now',0),(603516,17306,'en','Required For',0),(603517,17257,'en','Resolves To Multiple Records',0),(603518,17393,'en','Round Each Line Item Tax Individually',0),(603519,17304,'en','Sales Amount Confidence %',0),(603520,17248,'en','Search Error',0),(603521,17365,'en','Search Settings',0),(603522,17355,'en','Select eBay Account',0),(603523,17389,'en','Select Shopify Import Task',0),(603524,17375,'en','Select Shopify Store',0),(603525,17413,'en','Set Attachments',0),(603526,17278,'en','Set Cost',0),(603527,17279,'en','Set On Hand',0),(603528,17307,'en','SFTP',0),(603529,17366,'en','Shipments',0),(603530,17226,'en','Ship & Invoice All',0),(603531,17227,'en','Ship & Invoice Selected',0),(603532,17228,'en','Ship Multiple Orders',0),(603533,17313,'en','Shopify Address Phone',0),(603534,17314,'en','Shopify Customer Created',0),(603535,17315,'en','Shopify Customer Email',0),(603536,17316,'en','Shopify Customer Phone',0),(603537,17317,'en','Shopify Default Address Phone',0),(603538,17318,'en','Shopify ID',0),(603539,17292,'en','Shopify Import',0),(603540,17319,'en','Shopify Item Created',0),(603541,17320,'en','Shopify Shipping Address Phone',0),(603542,17390,'en','Shopify Store',0),(603543,17321,'en','Shopify Tracking Number',0),(603544,17360,'en','Show Orders From',0),(603545,17361,'en','Show Orders To',0),(603546,17414,'en','Soft Close',0),(603547,17415,'en','Soft Closings',0),(603548,17362,'en','Specify Order Numbers',0),(603549,17370,'en','Store Domain',0),(603550,17429,'en','System Will Deliver File Directly To Bank',0),(603551,17348,'en','Take Me To eBay',0),(603552,17298,'en','Task Name',0),(603553,17299,'en','Task Name Is Required',0),(603554,17394,'en','Tax Rounding',0),(603555,17235,'en','Territories',0),(603556,17349,'en','Token Expires',0),(603557,17381,'en','Total Spent',0),(603558,17350,'en','To Authorize Access To Your eBay Account You Must Leave This Page And Sign In At eBay',0),(603559,17258,'en','Unsupported',0),(603560,17283,'en','Unused',0),(603561,17351,'en','Update Nickname',0),(603562,17434,'en','Uploaded For This Invoice',0),(603563,17435,'en','Uploaded For This Order',0),(603564,17436,'en','Uploaded For This Quote',0),(603565,17404,'en','Upload New Pending Documents',0),(603566,17410,'en','SurePost 1 lb or Greater',0),(603567,17411,'en','SurePost Less than 1 lb',0),(603568,17236,'en','Vendor Order Froms',0),(603569,17425,'en','Vendor Pricing',0),(603570,17371,'en','Verifying Webhooks',0),(603571,17237,'en','Warehouse Bin Items',0),(603572,17372,'en','Webhooks',0),(603573,17373,'en','Webhooks Established',0),(603574,17305,'en','Wrong Module Type',0),(603575,17352,'en','Your Store Logo',0),(603576,17430,'en','You Must Generate Download & Send File Manually',0),(603577,17272,'en','Zone Code',0),(603578,17273,'en','Zone Code Must Be Set',0),(603579,17437,'en','Account Configuration Deleted',0),(603580,17438,'en','Customer Code If For Job',0),(603581,17440,'en','Sales Amount Confidence %',0),(603582,17439,'en','Task Name Is Required',0),(603583,17451,'en','Apply Change',0),(603584,17454,'en','Auto Import Customer Payments - Do Not Create GL Transactions',0),(603585,17455,'en','Auto Import Invoices - Do Not Create GL Transactions',0),(603586,17444,'en','Certificate Not Compliant Email',0),(603587,17465,'en','Check Total Is Negative Or 0 So Removing Bills From Check Run',0),(603588,17466,'en','Commodity Code',0),(603589,17445,'en','Delete All',0),(603590,17446,'en','Delete Selected',0),(603591,17450,'en','Delivery Charge',0),(603592,17456,'en','Delivery Charge Item Code',0),(603593,17457,'en','Delivery Charge Maximum Order Total',0),(603594,17458,'en','Force Single Customer Email Per Input',0),(603595,17459,'en','Fuel Charge Item Code',0),(603596,17460,'en','Fuel Charge Maximum Order Total',0),(603597,17447,'en','Inactive Since',0),(603598,17441,'en','Inactive Vendors',0),(603599,17448,'en','Is Not Compliant',0),(603600,17461,'en','Our Truck Shipping Method',0),(603601,17462,'en','Paid On Account Item Code',0),(603602,17443,'en','Product Type Tax',0),(603603,17442,'en','Product Type Taxes',0),(603604,17463,'en','Select Inventory Type For FO/POS Page',0),(603605,17464,'en','Stocked Rental Cost Percentage',0),(603606,17452,'en','Suggested Changes',0),(603607,17453,'en','Update 3dcart Warehouse Bin Automatically',0),(603608,17449,'en','Vendors Inactive Since',0),(603609,17468,'en','Admin Email Subject',0),(603610,17469,'en','Admin Notification Email Address',0),(603611,17470,'en','Appointment Date & Time',0),(603612,17471,'en','Appointment Host Name',0),(603613,17472,'en','Appointment Location Name',0),(603614,17473,'en','Appointment Service Name',0),(603615,17492,'en','Authorized Buyers',0),(603616,17474,'en','Customer\\\'s Full Name',0),(603617,17467,'en','Customizable Customer List',0),(603618,17475,'en','Disable Email Reminders',0),(603619,17476,'en','Do Not Redirect B2B Login To Appointments',0),(603620,17477,'en','Do Not Require Payment Method To Book',0),(603621,17478,'en','Edit Email Template',0),(603622,17491,'en','EFT Transactions Over Max Amount',0),(603623,17479,'en','Email Subject',0),(603624,17480,'en','Email Template Help',0),(603625,17495,'en','Invoice Imported With Not Found Job Code',0),(603626,17487,'en','Max Daily EFT Transaction Amount',0),(603627,17488,'en','Max Single EFT Transaction Amount',0),(603628,17498,'en','Method Markup Flat',0),(603629,17481,'en','No Changes',0),(603630,17482,'en','No Payment Method Message',0),(603631,17486,'en','PayPal Payment Account',0),(603632,17489,'en','Place Link With Template Field',0),(603633,17483,'en','Previous Appointment Information',0),(603634,17497,'en','Purchased By',0),(603635,17496,'en','Purchased By Contact',0),(603636,17484,'en','Select Template',0),(603637,17485,'en','Template Error',0),(603638,17490,'en','Transactions Will Not Be Sent If Over Limit',0),(603639,17494,'en','Unauthorized Buyer',0),(603640,17493,'en','Unauthorized Buyers',0),(603641,17499,'en','Invoice Imported But Job Code Not Found',0),(603642,17615,'en','Additional Options',0),(603643,17522,'en','Address Fields',0),(603644,17523,'en','Address Verified',0),(603645,17616,'en','Alert',0),(603646,17617,'en','All Write-In Items Must Be Converted To Inventory Items Before You Can Convert This Quote To An Order',0),(603647,17524,'en','Area ID',0),(603648,17623,'en','A Deleted Vendor Exists With This Vendor Code',0),(603649,17624,'en','A Vendor Already Exists For Vendor Code',0),(603650,17525,'en','B2B Allow CC Pay',0),(603651,17526,'en','B2B No Payment Fee',0),(603652,17527,'en','Billing Fields',0),(603653,17611,'en','Both',0),(603654,17528,'en','Cancel User ID',0),(603655,17501,'en','Capabilities',0),(603656,17502,'en','CC Processor Not Set For CC Terminal',0),(603657,17503,'en','Checking Account Not Set For CC Processor',0),(603658,17575,'en','Claim',0),(603659,17529,'en','Closed Date',0),(603660,17530,'en','Closed User ID',0),(603661,17531,'en','Company Name 2',0),(603662,17504,'en','Contactless',0),(603663,17532,'en','Contact Fields',0),(603664,17613,'en','Cost Code Required But Not Found',0),(603665,17533,'en','Current Sales Process',0),(603666,17534,'en','Customer Type ID',0),(603667,17576,'en','Custom Customer List',0),(603668,17505,'en','Debit MSR',0),(603669,17506,'en','Device Key',0),(603670,17572,'en','Direct Cash Payments',0),(603671,17577,'en','Display Options',0),(603672,17584,'en','Do Not Import Item Categories',0),(603673,17574,'en','Edit Vendor Settings',0),(603674,17598,'en','EFT Transactions Total Is Over The Daily Limit',0),(603675,17535,'en','Email 1',0),(603676,17536,'en','Email 1 Comment',0),(603677,17537,'en','Email 2',0),(603678,17538,'en','Email 2 Comment',0),(603679,17507,'en','EMV',0),(603680,17621,'en','Entries Missing Department Or WC',0),(603681,17539,'en','Entry User ID',0),(603682,17612,'en','Expense',0),(603683,17578,'en','Field Selection',0),(603684,17508,'en','Firmware',0),(603685,17608,'en','Freight Cost',0),(603686,17609,'en','GL Cash Account Must Be Set',0),(603687,17614,'en','GL Category Required But Not Found',0),(603688,17593,'en','GL Post Date',0),(603689,17540,'en','Group ID',0),(603690,17630,'en','Hide GL Info On Order Page',0),(603691,17586,'en','Hide Invoice Terms',0),(603692,17571,'en','Imported GL Entries From Anzio',0),(603693,17627,'en','Incoming Transfers',0),(603694,17606,'en','Incoming Transfers Not On Statement',0),(603695,17607,'en','Incoming Transfers On Statement',0),(603696,17625,'en','Ignore',0),(603697,17587,'en','Invoice Header Bottom Message',0),(603698,17588,'en','Invoice Header Top Message',0),(603699,17541,'en','Invoice Terms ID',0),(603700,17542,'en','Last Change User ID',0),(603701,17509,'en','Make',0),(603702,17618,'en','Make New Item',0),(603703,17573,'en','Mass Update',0),(603704,17599,'en','Max Amount Allowed',0),(603705,17620,'en','Max Yearly Deduction Amount',0),(603706,17510,'en','Model',0),(603707,17543,'en','Name Fields',0),(603708,17511,'en','New Castles Terminal',0),(603709,17512,'en','New PAX Terminal',0),(603710,17513,'en','New Terminal',0),(603711,17603,'en','Not Posted Yet',0),(603712,17544,'en','No Credit',0),(603713,17545,'en','No Credit Note',0),(603714,17579,'en','No Space Between Rows',0),(603715,17589,'en','Only Allow Inventory Items When Converting Quote To Order',0),(603716,17631,'en','Only Assigned Location',0),(603717,17546,'en','On Hold User ID',0),(603718,17590,'en','Page Footer Text',0),(603719,17514,'en','Pairing Code',0),(603720,17632,'en','Payments Daily Close Management',0),(603721,17619,'en','Pay For Something From Cash Drawer',0),(603722,17547,'en','Phone 1',0),(603723,17548,'en','Phone 1 Comment',0),(603724,17549,'en','Phone 1 Type',0),(603725,17550,'en','Phone 2 Comment',0),(603726,17551,'en','Phone 2 Type',0),(603727,17552,'en','Phone 3',0),(603728,17553,'en','Phone 3 Comment',0),(603729,17554,'en','Phone 3 Type',0),(603730,17555,'en','Phone 4',0),(603731,17556,'en','Phone 4 Comment',0),(603732,17557,'en','Phone 4 Type',0),(603733,17580,'en','Plain Table Display',0),(603734,17558,'en','Points Earned',0),(603735,17500,'en','PO #',0),(603736,17628,'en','Prelims',0),(603737,17600,'en','Prior Total',0),(603738,17559,'en','Promotions Accepted',0),(603739,17626,'en','Reactivate Vendor',0),(603740,17610,'en','Recent Direct Cash Payments',0),(603741,17560,'en','Sales Category ID',0),(603742,17561,'en','Sales GL Account ID',0),(603743,17581,'en','Search Criteria',0),(603744,17515,'en','Select CC Processor',0),(603745,17516,'en','Serial',0),(603746,17562,'en','Service Rep ID',0),(603747,17563,'en','Service Work Type ID',0),(603748,17591,'en','Ship To Sub Text',0),(603749,17604,'en','Show Only Never Cashed',0),(603750,17605,'en','Show Only Not Yet Cashed Or Cashed After Period',0),(603751,17585,'en','Show Purchase From Cash Drawer Link On POS',0),(603752,17517,'en','Signature Capture',0),(603753,17601,'en','Skipping EFT Payments',0),(603754,17595,'en','Skipping Sending EFT Transaction Over Allowed Amount',0),(603755,17596,'en','Skipping Sending EFT Transaction Over Allowed Daily Maximum',0),(603756,17629,'en','Sold At',0),(603757,17592,'en','Sold To Sub Text',0),(603758,17582,'en','Sort Descending',0),(603759,17518,'en','Swipe',0),(603760,17564,'en','System Fields',0),(603761,17565,'en','Tax Exemption Date',0),(603762,17566,'en','Tax Exempt ID',0),(603763,17567,'en','Tax Group ID',0),(603764,17568,'en','Temperature Unit',0),(603765,17519,'en','Terminal Is In Use By User',0),(603766,17583,'en','Test',0),(603767,17602,'en','This Batch Total',0),(603768,17520,'en','Timeout',0),(603769,17569,'en','Time Zone ID',0),(603770,17597,'en','Transactions Will Not Be Sent If Over Daily Limit',0),(603771,17594,'en','Use GL Post Date',0),(603772,17622,'en','View Entries Missing Department Or WC',0),(603773,17570,'en','Weather Zip',0),(603774,17639,'en','Actual Cash',0),(603775,17669,'en','Actual Cash Appears To Be Incorrect',0),(603776,17640,'en','Actual CC',0),(603777,17641,'en','Actual Checks',0),(603778,17633,'en','Appointment Date',0),(603779,17634,'en','Appointment Time',0),(603780,17642,'en','Balanced',0),(603781,17643,'en','Checking Account Not Set On Default CC Processor',0),(603782,17644,'en','Cost Code Not Set For This Inventory Location',0),(603783,17676,'en','Credit Card Terminal Log',0),(603784,17664,'en','Custom Order Numbering',0),(603785,17665,'en','Daily Close',0),(603786,17645,'en','Daily Drawer Close',0),(603787,17646,'en','Daily Drawer Close Log',0),(603788,17666,'en','Define Order Numbering',0),(603789,17670,'en','Deposit Appears To Be Incorrect',0),(603790,17672,'en','Direct Cash Expenses',0),(603791,17671,'en','Expected Value',0),(603792,17647,'en','Float Amount',0),(603793,17648,'en','GL Account Not Set In CC Processor Setup',0),(603794,17649,'en','GL Account Not Set On Default Checking Account',0),(603795,17650,'en','GL Cash Total',0),(603796,17651,'en','GL CC Total',0),(603797,17652,'en','GL Checks Total',0),(603798,17673,'en','Last Drawer Float',0),(603799,17653,'en','New Daily Close',0),(603800,17654,'en','No Default CC Processor Set',0),(603801,17655,'en','No Default Checking Account Set',0),(603802,17656,'en','Over/Short',0),(603803,17635,'en','Patient Name',0),(603804,17636,'en','Phone Alternate',0),(603805,17667,'en','Prefix',0),(603806,17668,'en','Previous Order Numbers Shown. The Next Order Will Increase The Appropriate Number By 1.',0),(603807,17677,'en','Reactivate Vendor',0),(603808,17637,'en','Settings Updated',0),(603809,17657,'en','Short',0),(603810,17658,'en','System Cash',0),(603811,17659,'en','System Cash Total',0),(603812,17674,'en','System Cash Total Summary',0),(603813,17660,'en','System CC',0),(603814,17661,'en','System CC Total',0),(603815,17662,'en','System Checks',0),(603816,17663,'en','System Checks Total',0),(603817,17675,'en','System Checks Total Summary',0),(603818,17638,'en','Update Failure',0),(603819,17678,'en','Expected Value',0),(603820,17716,'en','Account Setup Already Exists',0),(603821,17704,'en','Active & Expired',0),(603822,17705,'en','Add Waiver',0),(603823,17770,'en','Allowed Cost Codes',0),(603824,17771,'en','Allowed GL Categories',0),(603825,17763,'en','All Deductions',0),(603826,17680,'en','All Entries Are Already On An Existing Deposit',0),(603827,17689,'en','Amazon Setup',0),(603828,17717,'en','Australia',0),(603829,17730,'en','AWS Access Key',0),(603830,17753,'en','A Job With This Address Already Exists For Another Customer',0),(603831,17754,'en','A Job With This Address Already Exists For This Customer',0),(603832,17681,'en','Bank Deposits Created',0),(603833,17682,'en','Bank Deposit Created',0),(603834,17764,'en','Begin/End Dates',0),(603835,17718,'en','Brazil',0),(603836,17695,'en','Broker Email',0),(603837,17696,'en','Broker Name',0),(603838,17697,'en','Broker Phone',0),(603839,17719,'en','Canada',0),(603840,17683,'en','Card Holder',0),(603841,17698,'en','Certificate Cannot Be Assigned To Multiple Types',0),(603842,17699,'en','Certificate Expires Date Must Be Assigned',0),(603843,17700,'en','Certificate Type Must Be Assigned',0),(603844,17720,'en','China',0),(603845,17755,'en','Click Here To Assign Defaults',0),(603846,17773,'en','Click the Renew Session button to continue your work.',0),(603847,17756,'en','Convert Deferred Expenses To',0),(603848,17740,'en','Convert Deferred Revenue & Expenses When Closing Jobs',0),(603849,17757,'en','Convert Deferred Revenue To',0),(603850,17750,'en','Cost Code Not Allowed For This Account',0),(603851,17744,'en','Customer Group Filter',0),(603852,17706,'en','Date Issued',0),(603853,17707,'en','Date Through',0),(603854,17758,'en','Deferred Conversion For Job',0),(603855,17759,'en','Deferred Conversion Transaction Date',0),(603856,17760,'en','Deferred Conversion Voucher',0),(603857,17738,'en','Deferred Expenses',0),(603858,17731,'en','Developer ID',0),(603859,17746,'en','Displayed In The Order Entries Went Into The Database',0),(603860,17684,'en','Entries Not Found In System',0),(603861,17761,'en','Error In Deferred Account Setup',0),(603862,17713,'en','Error Restoring',0),(603863,17708,'en','Exceptions',0),(603864,17721,'en','France',0),(603865,17722,'en','Germany',0),(603866,17751,'en','GL Category Not Allowed For This Account',0),(603867,17752,'en','GL COGS Or Asset Account',0),(603868,17745,'en','GL Sales Or Liability Account',0),(603869,17690,'en','Import USAePay Batch CC Deposit',0),(603870,17691,'en','Import Vendor Certificates',0),(603871,17723,'en','India',0),(603872,17701,'en','Is Type Of',0),(603873,17724,'en','Italy',0),(603874,17725,'en','Japan',0),(603875,17709,'en','Job Waiver',0),(603876,17712,'en','Job Waiver Type',0),(603877,17692,'en','Job Waiver Types',0),(603878,17772,'en','Leave Blank For All',0),(603879,17736,'en','Link To Your Amazon Store',0),(603880,17774,'en','Logout Warning',0),(603881,17775,'en','Log Out Now',0),(603882,17765,'en','Mandatory Deductions',0),(603883,17693,'en','Mass Insurance Update',0),(603884,17694,'en','Mass Vendor Update',0),(603885,17726,'en','Mexico',0),(603886,17686,'en','Motorstate Item Changes',0),(603887,17739,'en','Nothing Deferred',0),(603888,17710,'en','Only Active',0),(603889,17766,'en','Percent Of Gross',0),(603890,17767,'en','Percent Of Net',0),(603891,17741,'en','Portal URL',0),(603892,17769,'en','Prelim Request',0),(603893,17714,'en','Record Restored',0),(603894,17776,'en','Renew Session',0),(603895,17715,'en','Restore',0),(603896,17762,'en','Rev Deferred Conversion For Job',0),(603897,17732,'en','Secret Key',0),(603898,17737,'en','Select Amazon Store',0),(603899,17733,'en','Select Your Marketplace',0),(603900,17734,'en','Seller ID',0),(603901,17748,'en','Send Invoices',0),(603902,17749,'en','Send Prelims',0),(603903,17687,'en','Send Statements',0),(603904,17685,'en','Some Entries Are Already On An Existing Deposit',0),(603905,17747,'en','Sort By Transaction ID',0),(603906,17727,'en','Spain',0),(603907,17679,'en','Store Setup Added Successfully',0),(603908,17743,'en','System User',0),(603909,17768,'en','Taxes & Retirement',0),(603910,17777,'en','Time Remaining',0),(603911,17728,'en','United Kingdom',0),(603912,17729,'en','United States',0),(603913,17702,'en','Vendor Email',0),(603914,17703,'en','Vendor Has No Certificates',0),(603915,17742,'en','Verify Addresses Via USPS',0),(603916,17688,'en','Waivers',0),(603917,17711,'en','Waiver Type',0),(603918,17778,'en','Your session is inactive and will be logged out.',0),(603919,17735,'en','You Must Set A Default Sales Tax Account',0),(603920,17792,'en','Add Job Cost Items',0),(603921,17848,'en','Add New Line',0),(603922,17845,'en','Another User Has Recently Made A Change To This Order',0),(603923,17814,'en','API Mode',0),(603924,17859,'en','A Customer Already Exists With This Customer Code',0),(603925,17856,'en','A Vendor Already Exists With This Vendor Code',0),(603926,17779,'en','Bank Deposit Documents',0),(603927,17861,'en','Barcode Label For Item Number',0),(603928,17862,'en','Barcode Label For Order Number',0),(603929,17863,'en','Barcode Label For PO Number',0),(603930,17869,'en','Cannot View Job Cost Labor Rates',0),(603931,17870,'en','Can Change User When Adding Job Cost Items',0),(603932,17822,'en','Cash Payment Not Found',0),(603933,17864,'en','Check Permissions Of Your Includes Directory',0),(603934,17815,'en','Choose Import Preference',0),(603935,17789,'en','Client Project #',0),(603936,17816,'en','Confirm Action',0),(603937,17835,'en','Could Not Locate Any Invoices That Match The Given Invoice Number',0),(603938,17836,'en','Could Not Locate Any Invoices That Match The Given Invoice Number And PO Number',0),(603939,17837,'en','Could Not Locate Any Invoices That Match The Given PO Number',0),(603940,17804,'en','Counties',0),(603941,17868,'en','Credit Card Terminal',0),(603942,17834,'en','Customer Not Added',0),(603943,17838,'en','Date Received Must Be Set',0),(603944,17855,'en','Default To Hours Of Previous Pay Period',0),(603945,17849,'en','Editing Session Has Expired',0),(603946,17793,'en','Error Deleting Job Item',0),(603947,17794,'en','Error Deleting Records',0),(603948,17865,'en','Error Downloading Libraries',0),(603949,17795,'en','Error Saving Job Item',0),(603950,17796,'en','Error Updating Voucher',0),(603951,17851,'en','Failed To Resolve GL Account By Name',0),(603952,17820,'en','Generate Customer Code For New Customers',0),(603953,17819,'en','Generate Vendor Code For New Vendors',0),(603954,17866,'en','Generating PDF',0),(603955,17850,'en','GL Account Not Set For Transaction',0),(603956,17823,'en','Has No Voucher',0),(603957,17817,'en','Import All',0),(603958,17818,'en','Import All Except Non-searchable',0),(603959,17824,'en','Incoming Value',0),(603960,17857,'en','Insurance',0),(603961,17805,'en','Insurance Email',0),(603962,17806,'en','Insurance Phone',0),(603963,17797,'en','Invalid Form Or Form Has Already Been Submitted',0),(603964,17798,'en','Invalid ID',0),(603965,17807,'en','Issued By',0),(603966,17790,'en','Item Costs Total',0),(603967,17853,'en','Job Cost Items For Order',0),(603968,17799,'en','Job Item',0),(603969,17800,'en','Job Item Deleted Successfully',0),(603970,17801,'en','Job Item Saved Successfully',0),(603971,17825,'en','Joint Check',0),(603972,17858,'en','Leave Blank To Auto Generate',0),(603973,17821,'en','Link Prelim Date And Contract Date',0),(603974,17867,'en','No Results',0),(603975,17780,'en','Order Numbers',0),(603976,17846,'en','Overwrite Changes',0),(603977,17826,'en','Outgoing Value',0),(603978,17839,'en','Payment Method Must Be Set',0),(603979,17840,'en','Please Enter One Of The Following',0),(603980,17781,'en','Possible Duplicate Customer',0),(603981,17847,'en','PO Number',0),(603982,17808,'en','Print All',0),(603983,17860,'en','Quick Barcode Search',0),(603984,17802,'en','Record Already Deleted',0),(603985,17854,'en','See Shipment',0),(603986,17841,'en','Select All Invoices For Customer',0),(603987,17871,'en','Show Barcode Search Icon In Header',0),(603988,17782,'en','Sick & Vacation Time Liability',0),(603989,17783,'en','Sick Available',0),(603990,17784,'en','Sick Liability',0),(603991,17785,'en','Sick Limit',0),(603992,17852,'en','Total Item Costs',0),(603993,17791,'en','Total Open',0),(603994,17844,'en','Unbilled Rental Orders',0),(603995,17803,'en','Updating Not Available',0),(603996,17786,'en','Vacation Liability',0),(603997,17787,'en','Vacation Available',0),(603998,17788,'en','Vacation Limit',0),(603999,17827,'en','Voucher Does Not Exist',0),(604000,17828,'en','Voucher Has No Transactions',0),(604001,17842,'en','Voucher Must Be Set',0),(604002,17843,'en','Voucher Number Must Be Set',0),(604003,17829,'en','Voucher Transactions Are Unbalanced',0),(604004,17830,'en','Voucher Transaction Does Not Have Proper Account Type',0),(604005,17831,'en','Voucher Transaction Has No Amount',0),(604006,17832,'en','Voucher Transactions Have Mismatched Currency',0),(604007,17833,'en','Wrong Company',0),(604008,17809,'en','You Must Enter A Valid Quantity',0),(604009,17810,'en','You Must Select An Item',0),(604010,17811,'en','You Must Select An Order',0),(604011,17812,'en','You Must Select A Job',0),(604012,17813,'en','You Must Set A Transaction Date',0),(604013,17876,'en','Overwrite Changes',0),(604014,17875,'en','Select All Invoices For Customer',0),(604015,17872,'en','Vacation Liability',0),(604016,17873,'en','Voucher Transaction Does Not Have Proper Account Type',0),(604017,17874,'en','Voucher Transaction Has No Amount',0),(604018,18041,'en','Accept Self-Signed Certificates',0),(604019,17947,'en','Add Job Budget Entry',0),(604020,18036,'en','Allow Login Using Email Address',0),(604021,17995,'en','Always Show Box On Invoice Summary',0),(604022,18037,'en','Always Use High Volume Edit Page For Journal Entries',0),(604023,17962,'en','Amazon ID',0),(604024,17970,'en','Amazon Integration Manager',0),(604025,17957,'en','Amazon Orders',0),(604026,17920,'en','And All Items Locked By This Process Will Be Unlocked',0),(604027,17983,'en','Are You Sure You Want To Delete Your Physical Inventory Progress?',0),(604028,17878,'en','Are You Sure You Would Like To Invoice All?',0),(604029,17913,'en','Assigned Date Range',0),(604030,17914,'en','Assigned On',0),(604031,17879,'en','At Least One Rental Period Must Be Included',0),(604032,17973,'en','B2B Booking Lead Days',0),(604033,18028,'en','Bill Rental When',0),(604034,18000,'en','Block Item Activity During Physical Inventory',0),(604035,18025,'en','Budget Margin',0),(604036,17938,'en','Budget Total',0),(604037,17948,'en','Budget Type',0),(604038,18011,'en','Cannot Do Partial Line Shipments On Rental Orders',0),(604039,17939,'en','Cannot Send - Job Not Marked As Prelimable',0),(604040,17940,'en','Check #',0),(604041,17921,'en','Click Post If You Are Sure You Are Ready To Finalize The Physical Inventory Process',0),(604042,17961,'en','Compliant',0),(604043,18029,'en','Convert To Rental Order',0),(604044,17880,'en','Could Not Create Invoices',0),(604045,17922,'en','Counts Entered',0),(604046,17923,'en','Counts Entered Will Be Posted',0),(604047,17915,'en','Create A Pickup Request First',0),(604048,18034,'en','Customer After Picture',0),(604049,18035,'en','Customer Before Picture',0),(604050,17898,'en','Deleted By',0),(604051,17984,'en','Delete All Records',0),(604052,17924,'en','Delete Unposted Counts',0),(604053,17985,'en','Display Existing Quantities',0),(604054,18038,'en','Do Not Auto Load UI Tables',0),(604055,17986,'en','Do Not Delete Anything',0),(604056,18042,'en','Do Not Verify Peer Name',0),(604057,17881,'en','Entry Has Been Marked As Returned But Has An Invalid Return Date',0),(604058,17949,'en','Error Deleting Job Budget',0),(604059,17925,'en','Error Posting Inventory Adjustments',0),(604060,17950,'en','Error Saving Job Budget',0),(604061,17941,'en','Export Jobs To Zlien',0),(604062,17926,'en','Finalizing This Processes Cannot Be Undone',0),(604063,17927,'en','Finish & Post Counts',0),(604064,18043,'en','Full Server Validation',0),(604065,18015,'en','General Budget',0),(604066,17882,'en','Generate Invoices For Billable Rentals',0),(604067,17974,'en','Higher Numbers Further Increase This Lead Time',0),(604068,17963,'en','Imported From Amazon',0),(604069,17971,'en','Import Amazon Orders',0),(604070,17958,'en','Import Job Budgets',0),(604071,17951,'en','Import Job Budget Data',0),(604072,17942,'en','Include Jobs Previously Sent To Zlien',0),(604073,17883,'en','Include Rental Periods',0),(604074,17964,'en','Inventory Lockdown',0),(604075,17884,'en','Invoice All',0),(604076,17885,'en','Invoice Rentals',0),(604077,17886,'en','Invoice Selected',0),(604078,17967,'en','In Advance',0),(604079,17968,'en','In Arrears',0),(604080,17928,'en','In-Progress Records Will Be Discarded',0),(604081,18016,'en','Item Budget',0),(604082,17956,'en','Item Costs',0),(604083,17987,'en','Item Counts In Progress',0),(604084,17919,'en','Item Location Stats',0),(604085,18017,'en','Item Variance',0),(604086,17943,'en','Job Account Open Item Details',0),(604087,17952,'en','Job Budget Deleted Successfully',0),(604088,17953,'en','Job Budget Has Been Deleted',0),(604089,17954,'en','Job Budget Saved Successfully',0),(604090,17955,'en','Job Budget Variance',0),(604091,17944,'en','Job Failed To Send',0),(604092,17887,'en','Job Invoices',0),(604093,18018,'en','Labor Budget',0),(604094,18019,'en','Labor Variance',0),(604095,17888,'en','Last Billed',0),(604096,17899,'en','Last Modified',0),(604097,18039,'en','Limit Access To Only Entries Created By This User',0),(604098,18004,'en','List Of Locked Items',0),(604099,17980,'en','Load',0),(604100,17972,'en','Load More Results',0),(604101,18005,'en','Locked Items Are Blocking This Action',0),(604102,17988,'en','Lock All Matching Items',0),(604103,18006,'en','Make Adjustments Or Retry After Inventory Finalized',0),(604104,18012,'en','Make Quantity Adjustments Or Retry After Inventory Finalized',0),(604105,18026,'en','Margin Variance',0),(604106,17982,'en','New Inventory Count',0),(604107,18002,'en','New Overpayment',0),(604108,18003,'en','New Overpayment From',0),(604109,17916,'en','New Pickup',0),(604110,18007,'en','Next Bill Date',0),(604111,17996,'en','Next Customer Code',0),(604112,17994,'en','Next Vendor Code',0),(604113,18030,'en','Non-Prelimable Items',0),(604114,18008,'en','No Billable Entries',0),(604115,17929,'en','No Changes Have Been Made',0),(604116,17889,'en','# Periods',0),(604117,17981,'en','Old',0),(604118,17975,'en','One Means To Allow Booking On The Preceding Day',0),(604119,17890,'en','Order Has Unbilled Shipments',0),(604120,17930,'en','Physical Inventory Adjustment',0),(604121,17969,'en','Picked Up',0),(604122,17900,'en','Picked Up Date',0),(604123,17901,'en','Pickup From',0),(604124,17902,'en','Pickup Request Sheet',0),(604125,17931,'en','Post Counts',0),(604126,17932,'en','Post Physical Inventory Counts',0),(604127,17997,'en','Prelim Request Email Options',0),(604128,17977,'en','Qty To Collect',0),(604129,17891,'en','Quantity',0),(604130,18044,'en','Relaxed',0),(604131,18031,'en','Remove Items',0),(604132,17917,'en','Rentals',0),(604133,18009,'en','Rental Began',0),(604134,17998,'en','Rental Billing',0),(604135,17903,'en','Rental Ends',0),(604136,18010,'en','Rental Items',0),(604137,18013,'en','Rental Periods',0),(604138,17904,'en','Rental Pickup',0),(604139,17959,'en','Rental Pickups',0),(604140,17905,'en','Rental Pickup Details',0),(604141,17906,'en','Rental Pickup Request',0),(604142,17907,'en','Rental Shipments',0),(604143,17978,'en','Rental Shipment Details',0),(604144,17908,'en','Rental Started',0),(604145,17892,'en','Rental Status',0),(604146,17909,'en','Rented To',0),(604147,17910,'en','Return Items To',0),(604148,17933,'en','Review/Continue Open Counts',0),(604149,17979,'en','Search By Appointment Date',0),(604150,17911,'en','Search Rental Orders',0),(604151,17934,'en','Search/Enter Counts',0),(604152,18045,'en','Security Verification',0),(604153,17989,'en','Select Which Items To Lock',0),(604154,17945,'en','Send All',0),(604155,17946,'en','Send Selected',0),(604156,17991,'en','Set Price Level From Tags',0),(604157,17992,'en','Set Sales Category From Tags',0),(604158,17912,'en','Shipment Created',0),(604159,17918,'en','Shipment Date Range',0),(604160,17893,'en','Shipment #',0),(604161,17999,'en','Show Bin Location',0),(604162,18027,'en','Show Cost Code & GL Category As Separate Columns',0),(604163,18001,'en','Show Only My Entries',0),(604164,18032,'en','Signature Required',0),(604165,17935,'en','The Physical Inventory Process Will Finalize',0),(604166,17965,'en','This Action Cannot Be Completed Because The Physical Inventory Process Is In Progress',0),(604167,17990,'en','This Action Will Unlock Any Items That Are Currently Locked By This Process',0),(604168,17936,'en','This Means',0),(604169,17894,'en','This Order Was To Be Billed In Advance But No Invoices Exists',0),(604170,17895,'en','Through Date',0),(604171,17877,'en','Too Many Invoices Selected To Print',0),(604172,18020,'en','Total Budget',0),(604173,17937,'en','Total Items In Process',0),(604174,18021,'en','Total Variance',0),(604175,17966,'en','Try Again After The Physical Inventory Counts Have Been Posted',0),(604176,18033,'en','Unlink Job From Order',0),(604177,17993,'en','Upload Item HTML & Images',0),(604178,18040,'en','User Receives Overpayment Notices',0),(604179,18022,'en','Vendor Bill Budget',0),(604180,18023,'en','Vendor Bill Costs',0),(604181,18024,'en','Vendor Bill Variance',0),(604182,18014,'en','View Other Locations',0),(604183,17960,'en','Waiver Search',0),(604184,17896,'en','Will Be Billed Through',0),(604185,17897,'en','You May Need To Bill This Rental Again',0),(604186,17976,'en','Zero Means To Allow Same Day Booking',0),(604187,18047,'en','Create A Pickup Request First',0),(604188,18046,'en','Will Be Billed Through',0),(604189,18078,'en','Accounts Payable Entries Related To Bill',0),(604190,18092,'en','Account Requires A Cost Code',0),(604191,18093,'en','Account Requires A GL Category',0),(604192,18085,'en','Amount Over Credit Limit',0),(604193,18094,'en','AP GL Account Not Allowed',0),(604194,18091,'en','Archive As Of Date',0),(604195,18049,'en','Building Record Set',0),(604196,18090,'en','Caching Language Files',0),(604197,18082,'en','Cannot Print Order Confirmation Until All Qty Is Shipped',0),(604198,18059,'en','Cannot Send Job To Zlien',0),(604199,18100,'en','Changed From',0),(604200,18048,'en','Committed For Order',0),(604201,18050,'en','Compare As Of Date',0),(604202,18051,'en','Counting',0),(604203,18105,'en','Current Value',0),(604204,18052,'en','Customer Does Not Exist',0),(604205,18101,'en','Customer Invoicing',0),(604206,18098,'en','Customer Is Over Credit Limit',0),(604207,18053,'en','Customer Totals',0),(604208,18106,'en','Default Value',0),(604209,18075,'en','Display Signature Line In Order Confirmation Footer',0),(604210,18076,'en','Do Not Allow Shipping If Missing Costs On Fulfillment Order',0),(604211,18077,'en','Do Not Allow Shipping Or POS Sale If Shipment Or Sale Goes Over Credit Limit',0),(604212,18064,'en','Error Creating Category At 3dcart',0),(604213,18065,'en','Error Exporting Categories To 3dcart',0),(604214,18066,'en','Error Updating Product Category',0),(604215,18067,'en','Export Search Categories (3dcart Product Categories) To This 3dcart Store',0),(604216,18068,'en','Finished Exporting Category Info To 3dcart',0),(604217,18069,'en','Finished Importing Category Info From 3dcart',0),(604218,18079,'en','GL Entries That Hit AP More Than Once In The Same Set',0),(604219,18054,'en','GL Posted To Date',0),(604220,18070,'en','Import Search Categories (3dcart Product Categories) From This 3dcart Store',0),(604221,18102,'en','Invoice Update By User',0),(604222,18071,'en','Items Sent',0),(604223,18060,'en','Jobs Over Limit',0),(604224,18061,'en','Jobs Over Prelim Credit Limit',0),(604225,18062,'en','Job Not Marked As Prelimable',0),(604226,18083,'en','Last Ship Date',0),(604227,18095,'en','List Of Allowed Periods',0),(604228,18099,'en','Max Allowed Taxes On A Single Line Is 3',0),(604229,18072,'en','New Categories',0),(604230,18073,'en','New Item Category Links',0),(604231,18058,'en','Non-Rentals',0),(604232,18096,'en','No Charge',0),(604233,18063,'en','Open Amount',0),(604234,18074,'en','Option Only Available With Rest API',0),(604235,18057,'en','% At/Over The Limit',0),(604236,18084,'en','Pick Qty',0),(604237,18055,'en','Processing Records',0),(604238,18103,'en','Recommitted For Order',0),(604239,18097,'en','Seasons',0),(604240,18056,'en','Show GL Posted To Date',0),(604241,18107,'en','The Default Settings For The Selected Item Category Does Not Match The Current Values',0),(604242,18086,'en','This Shipment Puts Customer Over Credit Limit',0),(604243,18080,'en','Total Deleted Bills Inside This Period But Posted Outside This Period',0),(604244,18081,'en','Total Deleted Bills Outside This Period But Posted Inside This Period',0),(604245,18104,'en','Used For Order',0),(604246,18087,'en','Value Of Outstanding Balance',0),(604247,18088,'en','Value Of Shipment',0),(604248,18089,'en','Value Of Shipment Plus Outstanding Balance',0),(604249,18111,'en','Amount To Authorize',0),(604250,18108,'en','Appointment Became Unavailable',0),(604251,18112,'en','Appointment Details',0),(604252,18129,'en','Appointment Merge',0),(604253,18126,'en','Appointment No Show Fee',0),(604254,18113,'en','Authorization Denied',0),(604255,18114,'en','Authorization Details',0),(604256,18115,'en','Authorization Success',0),(604257,18116,'en','Authorize My Card And Book This Appointment',0),(604258,18117,'en','Card To Use',0),(604259,18118,'en','Click Here To Proceed To Your Appointment Summary',0),(604260,18119,'en','Click Here To View More Appointment Times',0),(604261,18131,'en','Combine This Amount In The Line Above Or Remove This Line',0),(604262,18133,'en','Customer Invoicing',0),(604263,18134,'en','DOB',0),(604264,18130,'en','Force All Appointment Data To The Master Customer',0),(604265,18135,'en','Gender',0),(604266,18120,'en','Important',0),(604267,18132,'en','Line Is The Same As The One Above',0),(604268,18121,'en','No Appointment Information Found. This information may have been removed to protect you from duplicate authorizations. If you believe this to be an error, please restart the booking process and contact us if the issue persists.',0),(604269,18127,'en','Only Applies If Requiring Payment Method To Book',0),(604270,18122,'en','Payment Authorization Required',0),(604271,18123,'en','Please Review And Confirm The Following Details',0),(604272,18109,'en','Please Select A Different Appointment Time Or Contact Us For Assistance',0),(604273,18124,'en','Processing Error',0),(604274,18128,'en','Require CC Auth To Book Amount',0),(604275,18136,'en','The Default Settings For The Selected Item Category Do Not Match The Current Values',0),(604276,18110,'en','Use The Calendar To Select A Date',0),(604277,18125,'en','Your Card Authorization Has Been Approved But Your Appointment Time Has Since Been Reserved By An Administrator',0),(604278,18137,'en','The Default Settings For The Selected Item Category Do Not Match The Current Values',0),(604279,18138,'en','Your Card Authorization Has Been Approved But Your Appointment Time Has Since Been Reserved By An Administrator',0),(604280,18221,'en','Above Fields Required',0),(604281,18204,'en','Account Not Found',0),(604282,18205,'en','Accrued Purchases',0),(604283,18280,'en','Add Line',0),(604284,18281,'en','Adjustment Cost',0),(604285,18282,'en','Adjustment GL Account',0),(604286,18283,'en','Adjustment Qty',0),(604287,18248,'en','Adjust This Shipment',0),(604288,18246,'en','All Zones Counted',0),(604289,18236,'en','Are You Sure You Want To Delete This Record?',0),(604290,18182,'en','Assign Stock Check Request',0),(604291,18183,'en','Assign To User',0),(604292,18253,'en','Auto Import Invoices - Do Not Change Inventory Levels',0),(604293,18148,'en','Begin Shipment',0),(604294,18324,'en','Block Customer Editing',0),(604295,18254,'en','Block Invoicing Shipments Without Document Attached',0),(604296,18325,'en','Block Order Entry Additional Line Item Options',0),(604297,18255,'en','Block Sales Of Items With No Price',0),(604298,18265,'en','Both By Using Accrued',0),(604299,18267,'en','Box 14 Other',0),(604300,18241,'en','Cannot Create Shipment Adjustment',0),(604301,18305,'en','Cannot Enter More Qty Than What Is Ordered',0),(604302,18269,'en','Can Only Clear Entries Already Designated For This Account',0),(604303,18330,'en','Category Items',0),(604304,18327,'en','Charge No Taxes For Orders If Ship To Is Outside This State',0),(604305,18167,'en','Check Your Device And Internet Connection',0),(604306,18184,'en','Clear All Last Count Dates',0),(604307,18139,'en','Completed Purchase Orders Not Sent To AP',0),(604308,18223,'en','Configuration',0),(604309,18249,'en','Confirm New Password',0),(604310,18169,'en','Container',0),(604311,18262,'en','Contra Rental',0),(604312,18256,'en','Convenience Fee As Percentage Not Flat Fee',0),(604313,18185,'en','Cost Of Goods From Sales',0),(604314,18201,'en','Cost Received',0),(604315,18202,'en','Cost Unreceived',0),(604316,18296,'en','Create New Entry',0),(604317,18141,'en','Credit From',0),(604318,18250,'en','Current Password',0),(604319,18216,'en','Current Password Is Wrong',0),(604320,18277,'en','Customer Edit Restrictions',0),(604321,18322,'en','Customer Pickup',0),(604322,18306,'en','Customer Will Pick Up',0),(604323,18186,'en','Cycle',0),(604324,18257,'en','Days After Invoice Date To Charge Interest',0),(604325,18224,'en','Day(s)',0),(604326,18266,'en','Default Inventory Location For Rental Transfers',0),(604327,18316,'en','Default Ship To Tax Exemption',0),(604328,18278,'en','Default To Payment On Account',0),(604329,18270,'en','Deposit To Bank Account',0),(604330,18279,'en','Do Not Change Inventory Levels',0),(604331,18252,'en','Drop Ship Default Shipping Method',0),(604332,18149,'en','Effective Shipped',0),(604333,18242,'en','Effective Shipped Cannot Be Negative',0),(604334,18160,'en','Emails Sent',0),(604335,18328,'en','Email Transfer Notices',0),(604336,18187,'en','Enter Counts',0),(604337,18208,'en','Enter Stock Counts',0),(604338,18161,'en','Error Sending Email',0),(604339,18273,'en','Exclude Non-Stock Items',0),(604340,18314,'en','Exclude This Vendor',0),(604341,18162,'en','Export Billtrust Balances',0),(604342,18163,'en','Export Billtrust Invoices',0),(604343,18307,'en','Extensive',0),(604344,18308,'en','Faster',0),(604345,18164,'en','Faxes Sent',0),(604346,18165,'en','Fax Invoices',0),(604347,18206,'en','Field Required',0),(604348,18170,'en','For Order',0),(604349,18271,'en','From/To',0),(604350,18258,'en','Hide The Number Of Periods For Rental Orders',0),(604351,18231,'en','Include All Vendors',0),(604352,18188,'en','Inventory Count',0),(604353,18166,'en','Invoice Delivery',0),(604354,18142,'en','Invoice Pick List',0),(604355,18284,'en','Items Adjusted Successfully',0),(604356,18285,'en','Item Adjustment',0),(604357,18286,'en','Item Adjustments Failed',0),(604358,18309,'en','Item Lookup Method',0),(604359,18189,'en','Last Counted',0),(604360,18232,'en','Legend',0),(604361,18209,'en','Manage Plans',0),(604362,18210,'en','Manage Subscriptions',0),(604363,18211,'en','Manual Processing',0),(604364,18190,'en','Mark As Count Completed',0),(604365,18225,'en','Month(s)',0),(604366,18274,'en','Needs Doc',0),(604367,18191,'en','New/Edit',0),(604368,18192,'en','New Inventory Count Created',0),(604369,18234,'en','New Inventory Transfer',0),(604370,18251,'en','New Password',0),(604371,18217,'en','New Passwords Do Not Match',0),(604372,18218,'en','New Password Cannot Match Current Password',0),(604373,18259,'en','Nontaxable Sales',0),(604374,18287,'en','No Default Inventory Account Set',0),(604375,18288,'en','No Default Inventory Loss Account Set',0),(604376,18301,'en','No Distribution Center Assigned',0),(604377,18237,'en','No Email For Invoice For Customer',0),(604378,18238,'en','No Fax Number For Customer',0),(604379,18302,'en','No Purchase Order Created',0),(604380,18297,'en','No Save Configuration Only',0),(604381,18171,'en','No Transfers Found',0),(604382,18144,'en','Only Used If New Item',0),(604383,18323,'en','On Account',0),(604384,18317,'en','On Account Not Allowed When Credit Disabled',0),(604385,18150,'en','Orders Due Date',0),(604386,18303,'en','Order To DC',0),(604387,18304,'en','Order To Distribution Center',0),(604388,18263,'en','Out On Rental',0),(604389,18140,'en','Overdue Orders Waiting On PO',0),(604390,18219,'en','Password Set Successfully',0),(604391,18233,'en','Payments In Period',0),(604392,18222,'en','Payment On Account',0),(604393,18212,'en','Payment On Account Entry',0),(604394,18151,'en','Pending Purchase Order',0),(604395,18145,'en','Period Count',0),(604396,18226,'en','Period Length',0),(604397,18172,'en','Pick',0),(604398,18213,'en','Pick My Transfers',0),(604399,18173,'en','Pick Transfer',0),(604400,18289,'en','Please Enter An Adjustment Date',0),(604401,18290,'en','Please Enter An Adjustment GL Account',0),(604402,18291,'en','Please Enter An Item',0),(604403,18295,'en','Please Input Category For GL Accounts',0),(604404,18260,'en','POA Bank Account',0),(604405,18152,'en','Previous Reduction',0),(604406,18276,'en','Price Must Be Set',0),(604407,18153,'en','Print Packing Slips',0),(604408,18243,'en','Qty Shipped Cannot Be Greater Than Qty Ordered',0),(604409,18310,'en','Quick',0),(604410,18174,'en','Receive Transfer',0),(604411,18214,'en','Receive Transfers',0),(604412,18227,'en','Recurring Billing Plan',0),(604413,18154,'en','Reduce By',0),(604414,18235,'en','Remaining Available',0),(604415,18146,'en','Rental Period',0),(604416,18143,'en','Rental Period Changed',0),(604417,18239,'en','Rental Return',0),(604418,18240,'en','Rental Return Rev',0),(604419,18175,'en','Request',0),(604420,18245,'en','Required Field Not Set',0),(604421,18298,'en','Rerental',0),(604422,18155,'en','Return Qty To On Hand',0),(604423,18193,'en','Review Active Inventory Counts',0),(604424,18156,'en','Route',0),(604425,18311,'en','Search Exact Matches Only For Item Code Or UPC',0),(604426,18312,'en','Search Within Item Code, Description, UPC, Vendor Product Code',0),(604427,18292,'en','Select An Item And Click Add Line',0),(604428,18331,'en','Set Defaults For All',0),(604429,18332,'en','Set Defaults This Item Only',0),(604430,18194,'en','Shelf/Bin',0),(604431,18157,'en','Shipment Adjustment',0),(604432,18321,'en','Shipment Documents',0),(604433,18147,'en','Shippable Orders With Received PO',0),(604434,18176,'en','Shipping Container',0),(604435,18158,'en','Shipping Route',0),(604436,18215,'en','Shipping Routes',0),(604437,18159,'en','Ship By Route',0),(604438,18326,'en','Show Notes On Order Datatable By Default',0),(604439,18195,'en','Show Only On Hand Items',0),(604440,18196,'en','Show Only Uncounted',0),(604441,18197,'en','Show X Day COGS',0),(604442,18293,'en','Skipping',0),(604443,18313,'en','Slower',0),(604444,18247,'en','Stats',0),(604445,18261,'en','Taxable Sales',0),(604446,18333,'en','Taxes Not Found For Customer',0),(604447,18334,'en','Taxes Not Found For Ship To',0),(604448,18318,'en','Taxes Will Be Auto Selected Based On These Details',0),(604449,18168,'en','Terminal Did Not Respond',0),(604450,18319,'en','These Selected Taxes May Be Overridden By The Taxes That Apply To The Entered Ship To Address',0),(604451,18244,'en','This Shipment Has Already Been Invoiced',0),(604452,18177,'en','This Transfer Has Been Received',0),(604453,18178,'en','This Transfer Has Been Shipped',0),(604454,18179,'en','This Transfer Has Not Been Shipped',0),(604455,18180,'en','This Transfer Is Deleted',0),(604456,18294,'en','Total Adjustment Cost',0),(604457,18275,'en','Total Shipment Value',0),(604458,18272,'en','Transactions From Bank Account',0),(604459,18207,'en','Transfer Short',0),(604460,18181,'en','Transfer To',0),(604461,18198,'en','Uncounted',0),(604462,18203,'en','Unshipped Orders That Have Qty Received From PO',0),(604463,18199,'en','Unzoned',0),(604464,18320,'en','Update Current Ship To Tax Exemptions With Default',0),(604465,18268,'en','User Password Expire Days',0),(604466,18329,'en','Use Walk-In Taxes For Orders If Ship To Is In This State',0),(604467,18264,'en','Use Walk-In Taxes For Service Orders',0),(604468,18315,'en','Vendor Payments Report',0),(604469,18335,'en','Walk-In Taxes Not Found',0),(604470,18228,'en','Week(s)',0),(604471,18299,'en','Would You Like To Copy These Defaults To All Matching Existing Items?',0),(604472,18229,'en','Year(s)',0),(604473,18300,'en','Yes - Save & Copy Defaults',0),(604474,18220,'en','You Are Required To Set A New Password',0),(604475,18230,'en','Zip Codes',0),(604476,18200,'en','Zones',0),(604477,18336,'en','Customer Will Pick Up',0),(604478,18346,'en','Adjust Shipment',0),(604479,18339,'en','Are You Sure Want To Clear All Count Dates?',0),(604480,18348,'en','Cost Of Goods Variance',0),(604481,18340,'en','Cost Of Missing Goods',0),(604482,18349,'en','Default To My User & Location On UI Tables',0),(604483,18341,'en','Expected',0),(604484,18342,'en','Inventory Count Adjustment',0),(604485,18343,'en','Mark As Complete',0),(604486,18344,'en','Partially Assigned',0),(604487,18345,'en','Post On Hand Adjustments',0),(604488,18347,'en','Review & Post Counts',0),(604489,18337,'en','Shipment Search',0),(604490,18338,'en','Shipment Search Results',0),(604491,18359,'en','Default Invoice Payment Amount To Zero',0),(604492,18350,'en','In Transit',0),(604493,18360,'en','Is Rental Distribution Center',0),(604494,18351,'en','Must Be In Transit',0),(604495,18352,'en','Qty Requested',0),(604496,18361,'en','Rental Distribution Center',0),(604497,18353,'en','Shipped By User',0),(604498,18354,'en','Skipping Line',0),(604499,18355,'en','Will Default To Current Date',0),(604500,18356,'en','Will Default To Current User',0),(604501,18357,'en','Will Default To Item Settings',0),(604502,18358,'en','Will Default To Vendor Settings',0),(604503,18416,'en','Add/Remove Item',0),(604504,18386,'en','Allow Customer Credit',0),(604505,18463,'en','Are You Sure You Want To Copy Pricing To All Locations?',0),(604506,18364,'en','Are You Sure You Want To Delete This Contact?',0),(604507,18424,'en','Are You Sure You Want To Proceed?',0),(604508,18441,'en','Attachment Required',0),(604509,18457,'en','A Rental Order Can Only Have One Shipment',0),(604510,18369,'en','B2B User Updated Successfully',0),(604511,18370,'en','B2B User Update Failed',0),(604512,18438,'en','Block Item Profit Changes For Stock Items',0),(604513,18439,'en','Block Sales Without A Purchased By Contact Assigned',0),(604514,18440,'en','Block When Line Item Is Stock',0),(604515,18371,'en','Cannot Accept Login Credentials',0),(604516,18442,'en','Click To Repair',0),(604517,18423,'en','Collect',0),(604518,18385,'en','Collect Convenience Fee',0),(604519,18464,'en','Copy Pricing To All Locations',0),(604520,18436,'en','County Rate Is Included In City Rate And Both Reported Under City',0),(604521,18387,'en','Create New Plan Template',0),(604522,18372,'en','Customer Information Updated Successfully',0),(604523,18373,'en','Customer Update Failed',0),(604524,18415,'en','Delete Check-in',0),(604525,18365,'en','Delete This Contact',0),(604526,18388,'en','Disable Automatic Billing',0),(604527,18374,'en','Edit Contacts',0),(604528,18389,'en','Edit Subscription',0),(604529,18466,'en','Email Stock Purchase Request',0),(604530,18390,'en','Error Processing First Period',0),(604531,18391,'en','Error Processing Subscription',0),(604532,18443,'en','Exemption Type',0),(604533,18459,'en','File Must Be Writable',0),(604534,18392,'en','First Period Processed',0),(604535,18393,'en','How Many Periods Are A Trial?',0),(604536,18394,'en','Invoice Template',0),(604537,18425,'en','Invoice Total Cannot Be Zero',0),(604538,18426,'en','Is Incomplete And Will Be Deleted',0),(604539,18427,'en','Is Incomplete And Will Be Ignored',0),(604540,18417,'en','Item Added',0),(604541,18418,'en','Item Already Selected',0),(604542,18419,'en','Item Is Not Currently Selected',0),(604543,18420,'en','Item Removed',0),(604544,18460,'en','Item Rental Type',0),(604545,18422,'en','Look Up Item',0),(604546,18395,'en','Manual Processing Only',0),(604547,18396,'en','Manual Processing Will Invoice All Periods Due By The Specified Date',0),(604548,18397,'en','New Subscription',0),(604549,18461,'en','Non Rentals Only',0),(604550,18444,'en','No District Assigned To Line Items',0),(604551,18375,'en','No Prelim',0),(604552,18421,'en','Number Of Items Selected',0),(604553,18376,'en','Off Rent',0),(604554,18383,'en','Open Amount Greater Than',0),(604555,18384,'en','Open Balance',0),(604556,18445,'en','Out Of State Sale',0),(604557,18382,'en','Out On Rent Items',0),(604558,18446,'en','Partial Exemption %',0),(604559,18447,'en','Partial Exemption Type',0),(604560,18398,'en','Pay Invoices With Credit When Available',0),(604561,18448,'en','% Paid',0),(604562,18399,'en','Period Limit',0),(604563,18379,'en','PO Receipts',0),(604564,18400,'en','Processing Aborted',0),(604565,18401,'en','Processing Complete',0),(604566,18402,'en','Process Selection',0),(604567,18412,'en','Quantity Needed',0),(604568,18380,'en','Receipt Date',0),(604569,18381,'en','Receipt ID',0),(604570,18403,'en','Recurring Billing Plan Invoice',0),(604571,18428,'en','Recurring Billing Plan Invoice Template',0),(604572,18404,'en','Recurring Billing Plan Subscription',0),(604573,18405,'en','Remaining Balance',0),(604574,18462,'en','Rentals Only',0),(604575,18377,'en','Rental Returned',0),(604576,18465,'en','Required Field',0),(604577,18362,'en','Restricted Access',0),(604578,18406,'en','Review Invoice Details',0),(604579,18366,'en','Save Contact',0),(604580,18367,'en','Select A Contact To Edit',0),(604581,18449,'en','Ship County',0),(604582,18450,'en','Ship Postal Code',0),(604583,18451,'en','Sold From State',0),(604584,18437,'en','States With No County Tax If There Is A City Tax',0),(604585,18413,'en','Stock Purchase Request',0),(604586,18407,'en','Subscription ID',0),(604587,18414,'en','Subscription Trial Period',0),(604588,18452,'en','Tax Detail Repair Complete',0),(604589,18453,'en','Tax District',0),(604590,18454,'en','Tax District Totals',0),(604591,18455,'en','Tax Total',0),(604592,18368,'en','This Action Will Remove All Data Shown On This Page',0),(604593,18363,'en','This Page Is Not Available To B2B Users',0),(604594,18408,'en','Total Per Invoice',0),(604595,18378,'en','To Be Picked',0),(604596,18409,'en','Trial Period Length',0),(604597,18410,'en','Trial Period Price',0),(604598,18456,'en','Use Which Date',0),(604599,18429,'en','Will Be Deleted',0),(604600,18458,'en','You Have Entered A Partial Quantity To Ship',0),(604601,18430,'en','You Must Enter A Plan Number',0),(604602,18431,'en','You Must Select A Default Price Level',0),(604603,18432,'en','You Must Select A Location',0),(604604,18433,'en','You Must Select A Sales Category',0),(604605,18434,'en','You Must Select A Sales GL Account',0),(604606,18435,'en','You Must Select Invoice Terms',0),(604607,18411,'en','Zero Means Unlimited',0),(604608,18538,'en','Additional Software Required',0),(604609,18666,'en','Add Direct Cash Payment Types',0),(604610,18594,'en','Add Inventory Location Code To End Of PO Numbers',0),(604611,18684,'en','Add Misc GL Entry',0),(604612,18713,'en','Allow User Substitute Reply To',0),(604613,18635,'en','Always',0),(604614,18600,'en','Always Collect Convenience Fee',0),(604615,18707,'en','American Express',0),(604616,18591,'en','Amount Below Minimum',0),(604617,18581,'en','Assigned Primary',0),(604618,18522,'en','Assign Zone',0),(604619,18555,'en','Authorization Services',0),(604620,18479,'en','Avg Lines Per Invoice',0),(604621,18480,'en','Avg Sales Per Invoice',0),(604622,18525,'en','Back Ordered Stock',0),(604623,18621,'en','Bill Details Updated Successfully',0),(604624,18515,'en','Bin Items',0),(604625,18601,'en','Block Non Direct GL Entry Editing',0),(604626,18636,'en','Block On Account Payment Method',0),(604627,18602,'en','Calculate Based On Ledger Total',0),(604628,18603,'en','Calculate Based On System Total',0),(604629,18695,'en','Cannot Create Deposit For Both Cash And CC At Same Time',0),(604630,18686,'en','Cannot Create PO For Item',0),(604631,18634,'en','Cannot Print Deleted Order',0),(604632,18467,'en','Cannot Process A Day Already Closed',0),(604633,18698,'en','Cannot Set To Minimum Price Level & Not Allowed To Request Price Overrides',0),(604634,18699,'en','Cannot Set To Minimum Price Level But Can Request Price Overrides',0),(604635,18700,'en','Can Set Below Minimum Price Level On All Orders & Approve Below Minimum',0),(604636,18701,'en','Can Set To Minimum Price Level On All Orders, Approve To Minimum & Request Below',0),(604637,18702,'en','Can Set To Minimum Price Level On Own Orders & Request Below',0),(604638,18558,'en','Cash Entered',0),(604639,18559,'en','CC Entered',0),(604640,18696,'en','Checking Account Must Have A Ledger Account Assigned',0),(604641,18560,'en','Checks Entered',0),(604642,18510,'en','Check For Next Update',0),(604643,18668,'en','Click Here To View Instead',0),(604644,18561,'en','Close Date',0),(604645,18564,'en','Contractor',0),(604646,18615,'en','Contractor Exemption',0),(604647,18468,'en','Created Bank Deposit',0),(604648,18481,'en','Created Credit Memo',0),(604649,18482,'en','Created New Invoice',0),(604650,18483,'en','Created Tax Adjustment',0),(604651,18708,'en','Create Separate Deposits For These CC Types',0),(604652,18484,'en','Credit Memo',0),(604653,18485,'en','Credit Memos',0),(604654,18575,'en','Credit Total',0),(604655,18566,'en','Credit Type',0),(604656,18577,'en','Current Taxes',0),(604657,18578,'en','Current Taxes Total',0),(604658,18523,'en','Current Zone',0),(604659,18637,'en','Customer Add Restrictions',0),(604660,18697,'en','Customer Credit Limit',0),(604661,18709,'en','Daily Close Bank Deposit',0),(604662,18562,'en','Daily Close Log',0),(604663,18469,'en','Daily Close Over',0),(604664,18614,'en','Daily Close Over Short',0),(604665,18604,'en','Daily Close Over Short Method',0),(604666,18470,'en','Daily Close Short',0),(604667,18486,'en','Daily Sales Inquiry',0),(604668,18605,'en','Default Bank Deposit Account',0),(604669,18606,'en','Default Bank Deposit Cost Code',0),(604670,18617,'en','Default Rental Price Level',0),(604671,18710,'en','Discover',0),(604672,18627,'en','Download All Results',0),(604673,18669,'en','Editing Non Direct GL Entries Is Forbidden By Company Configuration',0),(604674,18545,'en','Edit Region',0),(604675,18567,'en','Enter Price Adjustment Details',0),(604676,18568,'en','Enter Return Details',0),(604677,18569,'en','Enter Tax Adjustment Details',0),(604678,18471,'en','Error Creating Bank Deposit',0),(604679,18565,'en','Exemption',0),(604680,18509,'en','Export Billtrust Statement',0),(604681,18502,'en','Extended Sale Price',0),(604682,18472,'en','Failed To Create Over Or Short Variance GL Entry',0),(604683,18487,'en','First Rentals',0),(604684,18703,'en','FO/POS Price Overrides',0),(604685,18685,'en','For Misc Entry #',0),(604686,18675,'en','For Period',0),(604687,18519,'en','From Location',0),(604688,18638,'en','From Order Entry',0),(604689,18511,'en','Generate Customer Statements',0),(604690,18473,'en','GL Cash',0),(604691,18474,'en','GL CC',0),(604692,18475,'en','GL Checks',0),(604693,18488,'en','Gross Margin',0),(604694,18676,'en','Hazardous Materials',0),(604695,18607,'en','Hide Carrier Name & Show Only Service',0),(604696,18608,'en','Hide Qty/Price Box',0),(604697,18570,'en','Hide This Credit Memo On B2B',0),(604698,18595,'en','Hide Vendor Add In PO Process',0),(604699,18539,'en','ImageMagick Has No Supported Formats',0),(604700,18540,'en','ImageMagick Version Should Match PHP Extension Version',0),(604701,18530,'en','Import Item Vendor Details',0),(604702,18628,'en','Interest Charges',0),(604703,18672,'en','Internal Buying Notes',0),(604704,18673,'en','Internal Selling Notes',0),(604705,18516,'en','Inventory Location Must Be Set',0),(604706,18476,'en','Inventory Location Must Have A Default Checking Account Assigned',0),(604707,18489,'en','Invoice Activity',0),(604708,18490,'en','Invoice Must Be Unposted',0),(604709,18571,'en','Issue Credit',0),(604710,18491,'en','Issue Price Adjustment Credit',0),(604711,18492,'en','Issue Simple Credit',0),(604712,18493,'en','Issue Tax Adjustment',0),(604713,18687,'en','Job Credit Limit',0),(604714,18688,'en','Job Is Over Credit Limit',0),(604715,18623,'en','Last Calculated',0),(604716,18477,'en','Last Close Date',0),(604717,18478,'en','Last Float',0),(604718,18596,'en','Location For PO Header',0),(604719,18639,'en','Lock Allow Order Modifications',0),(604720,18640,'en','Lock Authorized Buyers',0),(604721,18641,'en','Lock Back Orders',0),(604722,18642,'en','Lock Bank Info',0),(604723,18643,'en','Lock Contacts',0),(604724,18644,'en','Lock Credit Application Received',0),(604725,18645,'en','Lock Customer Credit',0),(604726,18646,'en','Lock Delivery Sales Only',0),(604727,18647,'en','Lock Exempt Delivery Charge',0),(604728,18648,'en','Lock Exempt Fuel Charge',0),(604729,18649,'en','Lock General',0),(604730,18650,'en','Lock Invoice Terms',0),(604731,18651,'en','Lock Job Number Required',0),(604732,18652,'en','Lock OK Tools On Job Accounts',0),(604733,18653,'en','Lock OK To Ship If Incomplete Job Info',0),(604734,18654,'en','Lock Order From',0),(604735,18655,'en','Lock Payment',0),(604736,18656,'en','Lock Pay To',0),(604737,18657,'en','Lock Prelim Job Sales',0),(604738,18658,'en','Lock Price Level',0),(604739,18659,'en','Lock Sales GL',0),(604740,18660,'en','Lock Sales Person',0),(604741,18661,'en','Lock Sales Rep',0),(604742,18662,'en','Lock Show Prices On Delivery Confirmation',0),(604743,18663,'en','Lock Special Pricing',0),(604744,18664,'en','Lock Vendor Terms',0),(604745,18584,'en','Look Up Item',0),(604746,18711,'en','Mastercard',0),(604747,18704,'en','Maximum Write-off Allowed',0),(604748,18705,'en','Maximum Write-off Percentage',0),(604749,18592,'en','Minimum Price',0),(604750,18609,'en','Minimum Price Level',0),(604751,18629,'en','Must Cancel Deposit First',0),(604752,18579,'en','New Taxes',0),(604753,18580,'en','New Taxes Total',0),(604754,18576,'en','New Unit Price',0),(604755,18678,'en','Next Page',0),(604756,18585,'en','Non Prelim Bal',0),(604757,18586,'en','Non Prelim Balance',0),(604758,18587,'en','Non Prelim Limit',0),(604759,18494,'en','Nothing To Save',0),(604760,18689,'en','Not Allowed To Select Price Level',0),(604761,18582,'en','Not Assigned',0),(604762,18526,'en','No Default Vendor',0),(604763,18667,'en','No Direct Cash Payment Types Exist',0),(604764,18541,'en','No New Invoice',0),(604765,18512,'en','No Open Invoices Found',0),(604766,18690,'en','No Vendor',0),(604767,18674,'en','Number Of Months To Expire',0),(604768,18618,'en','Only Allow Transfers From Distribution Center',0),(604769,18625,'en','Only Non-Prelimable',0),(604770,18626,'en','Only Prelimable',0),(604771,18630,'en','On Bank Deposit',0),(604772,18503,'en','Out On Rent',0),(604773,18624,'en','Overpayment Invoice',0),(604774,18531,'en','Over Qty',0),(604775,18495,'en','Payment Types By Location',0),(604776,18593,'en','Percent Below Minimum',0),(604777,18542,'en','PHP Is Unable To Execute Shell Commands',0),(604778,18543,'en','PHP Must Have Access To',0),(604779,18517,'en','Picker Transfer',0),(604780,18572,'en','Policy Adjustment',0),(604781,18682,'en','PO Line Note',0),(604782,18616,'en','Prelimable Materials Exempt',0),(604783,18588,'en','Prelim Bal',0),(604784,18589,'en','Prelim Balance',0),(604785,18590,'en','Prelim Limit',0),(604786,18679,'en','Previous Page',0),(604787,18563,'en','Price Adjustment Credits',0),(604788,18496,'en','Price Adjustment',0),(604789,18691,'en','Price Is Below Minimum Allowed',0),(604790,18536,'en','Proceed',0),(604791,18527,'en','Quantity Back Ordered',0),(604792,18554,'en','Quantity Needed',0),(604793,18680,'en','Receipt Line ID',0),(604794,18683,'en','Receiving Notes',0),(604795,18533,'en','Region Management',0),(604796,18546,'en','Region Manager',0),(604797,18547,'en','Region Name',0),(604798,18622,'en','Related GL Entries Updated Successfully',0),(604799,18513,'en','Remittance Amount',0),(604800,18504,'en','Rental Last Bill Date',0),(604801,18505,'en','Rental Qty Returned',0),(604802,18506,'en','Rental Return Date',0),(604803,18534,'en','Requests At Or Above Minimum',0),(604804,18535,'en','Requests Below Minimum',0),(604805,18693,'en','Restricted',0),(604806,18497,'en','Returned Goods',0),(604807,18498,'en','Sales & Margin By Shipping & Branch',0),(604808,18499,'en','Save Credit Memo',0),(604809,18500,'en','Save Tax Adjustment',0),(604810,18548,'en','Select Region',0),(604811,18528,'en','Set Cost Each',0),(604812,18633,'en','Shipments For',0),(604813,18544,'en','Shipment Already Invoiced',0),(604814,18507,'en','Shipped Date',0),(604815,18518,'en','Shipper Transfer',0),(604816,18610,'en','Show Cost Code Options On Payment Page',0),(604817,18611,'en','Show Credit Card Add Link After Customer Add',0),(604818,18612,'en','Show Inventory Location Options On Payment Page',0),(604819,18597,'en','Show Main Page Note In PO Header',0),(604820,18529,'en','Show Only Needing Reordered',0),(604821,18681,'en','Show Only Receipts Not Passed To AP',0),(604822,18520,'en','Show Only Unfulfillable Quantities',0),(604823,18670,'en','Show Prices On Packing Slip',0),(604824,18613,'en','Show Vendor Item Code',0),(604825,18573,'en','Simple Credit',0),(604826,18619,'en','Stock Check Request Default Cycle Count Adjustment Type',0),(604827,18620,'en','Stock Check Request Default Physical Count Adjustment Type',0),(604828,18556,'en','System Checks GL Summary',0),(604829,18574,'en','Tax Adjustment',0),(604830,18549,'en','Territory Code',0),(604831,18550,'en','Territory Name',0),(604832,18551,'en','Territory Region Management',0),(604833,18537,'en','This Action May Collect Payment',0),(604834,18552,'en','This Action Will Delete Existing Records For This Company',0),(604835,18583,'en','This Bin',0),(604836,18553,'en','This Code Is Used To Generate Territory Codes',0),(604837,18632,'en','This Shipment Puts The Job Over The Credit Limit',0),(604838,18514,'en','To Insure Proper Credit Please Detach At Perforation And Return Top Portion With Your Remittance',0),(604839,18521,'en','To Location',0),(604840,18692,'en','Uncheck, Create PO, Or Edit Items To Proceed',0),(604841,18508,'en','Unit Sale Price',0),(604842,18631,'en','UN Number',0),(604843,18671,'en','Update Existing Customer Record When Customer Code Matches',0),(604844,18532,'en','Up To This Qty',0),(604845,18598,'en','Use Company Info',0),(604846,18706,'en','Use Company Write-off Settings',0),(604847,18665,'en','Vendor Edit Restrictions',0),(604848,18677,'en','Vendor Required For Non-Stock Items',0),(604849,18557,'en','View Voucher Details',0),(604850,18712,'en','Visa',0),(604851,18501,'en','Voided Invoices',0),(604852,18599,'en','You Do Not Currently Have Any Location Codes Entered',0),(604853,18694,'en','You Must Set A GL Account For This Checking Account',0),(604854,18524,'en','Zone Bins',0),(604855,18714,'en','Created Tax Adjustment',0),(604856,18715,'en','Generate Customer Statements',0),(604857,18717,'en','ImageMagick Version Should Match PHP Extension Version',0),(604858,18719,'en','Mastercard',0),(604859,18718,'en','Price Adjustment Credits',0),(604860,18716,'en','Quantity Back Ordered',0),(604861,18727,'en','2nd Truck Needed',0),(604862,18762,'en','Allow On POS',0),(604863,18737,'en','All Units Are In Points',0),(604864,18786,'en','Applies To POS & Pickup',0),(604865,18736,'en','Attach Files',0),(604866,18753,'en','Bin Code Missing',0),(604867,18787,'en','Block Access To Edit Item Bin Locations',0),(604868,18788,'en','Block Editing Of Customer, Vendor And Item Codes',0),(604869,18738,'en','Bottom',0),(604870,18776,'en','Buyer',0),(604871,18789,'en','Cannot Create New Stock Items',0),(604872,18790,'en','Cannot Create POS For Stock Items',0),(604873,18785,'en','Clear',0),(604874,18782,'en','Click For Internal Sales Note',0),(604875,18725,'en','Convert To Sale/Damaged',0),(604876,18747,'en','Count Adjustment',0),(604877,18748,'en','Cycle Count Variance',0),(604878,18749,'en','Damaged Material',0),(604879,18720,'en','Days With Openings Are Highlighted',0),(604880,18754,'en','Delete From This Bin',0),(604881,18778,'en','Duplicate Item Code Found',0),(604882,18768,'en','Email New Item Notices To',0),(604883,18779,'en','Error Checking For Duplicate Item Codes',0),(604884,18733,'en','Exact Item Code Required',0),(604885,18791,'en','Except For Non-Stock Items',0),(604886,18750,'en','Expired Material',0),(604887,18794,'en','Expire Days',0),(604888,18728,'en','Final Pickup',0),(604889,18780,'en','Found A Vendor Product Code That Matches This Item Code',0),(604890,18773,'en','Hide Bank, Insurance & Architect Section',0),(604891,18774,'en','Hide Invoicing Section',0),(604892,18792,'en','Hide Order Profit',0),(604893,18767,'en','Hide This Option When Creating A New Customer From POS',0),(604894,18721,'en','If You Would Like To Select A Different Service, Please Change Your Selection Above',0),(604895,18758,'en','Internal Buyer Note',0),(604896,18772,'en','Internal Sales Note',0),(604897,18734,'en','Item Count Status',0),(604898,18775,'en','Job Add Restrictions',0),(604899,18755,'en','Keep In This Bin',0),(604900,18777,'en','Must Have Buyer User Right',0),(604901,18763,'en','Next Job Code',0),(604902,18722,'en','No Available Appointments For The Selected Service',0),(604903,18726,'en','No Unbilled',0),(604904,18729,'en','Off Rent Date',0),(604905,18739,'en','Page Height',0),(604906,18740,'en','Page Margin',0),(604907,18741,'en','Page Width',0),(604908,18730,'en','Partial Pickup',0),(604909,18735,'en','Pending Count',0),(604910,18723,'en','Please Select Another Date Using The Calendar Above',0),(604911,18724,'en','Please Select Another Date Using The Calendar On The Left',0),(604912,18756,'en','Primary',0),(604913,18742,'en','Print One QR Code Per Line',0),(604914,18759,'en','Print Proof Of Delivery',0),(604915,18784,'en','Print QR Code',0),(604916,18761,'en','QR Code',0),(604917,18743,'en','QR Code Padding',0),(604918,18744,'en','QR Printer Setup',0),(604919,18731,'en','Qty Rented',0),(604920,18764,'en','Read-Only Inventory Location On Payment Page',0),(604921,18732,'en','Record Already Exists',0),(604922,18765,'en','Rental Contract Text',0),(604923,18771,'en','Rental Packing Slip',0),(604924,18745,'en','Right',0),(604925,18746,'en','Set As 0 For Continuous Feed',0),(604926,18769,'en','Show Barcode Popup After Creating A New Item',0),(604927,18766,'en','Show Invoice Page Footer Text On Packing Slip',0),(604928,18770,'en','Stock Type Items Only',0),(604929,18752,'en','Tax Adjustments Not Shown In Total',0),(604930,18751,'en','Transfer Variance',0),(604931,18757,'en','Unknown Zone',0),(604932,18793,'en','User Is A Buyer',0),(604933,18781,'en','Vendor Product',0),(604934,18783,'en','You Do Not Have Rights To Add Stock Items To POS',0),(604935,18760,'en','You Must Attach A File Before Saving',0),(604936,18795,'en','Block Access To Edit Item Bin Locations',0),(604937,18796,'en','Except For Non-Stock Items',0),(604938,18805,'en','Are You Sure You Want To Mark Them All As Shipped?',0),(604939,18811,'en','Barcode Mass Print',0),(604940,18821,'en','Block Rental Credit For First Period',0),(604941,18829,'en','Cannot Create Purchase Orders For Stock Items',0),(604942,18803,'en','Check CC Processor Settings',0),(604943,18817,'en','Clear Queue',0),(604944,18807,'en','Cost Of Sales',0),(604945,18797,'en','Daily Sales Report',0),(604946,18822,'en','Default Days In The Future',0),(604947,18823,'en','Default Prelim Request Search Min Open Amount',0),(604948,18818,'en','Delete Row',0),(604949,18830,'en','Email This User A Daily List Of Sales',0),(604950,18828,'en','Exempt Percent',0),(604951,18798,'en','Final Return Credit For This Item From Order',0),(604952,18813,'en','Introduction',0),(604953,18814,'en','Introductory Service',0),(604954,18799,'en','Invoice Line Note',0),(604955,18824,'en','Max Days In The Future',0),(604956,18808,'en','Minimum Sales Criteria Value',0),(604957,18815,'en','Note Not Saved',0),(604958,18831,'en','Only Email Invoices With A Sales Margin Under',0),(604959,18800,'en','Original Periods',0),(604960,18801,'en','Periods Adjusted',0),(604961,18809,'en','Period To Monitor',0),(604962,18819,'en','Print Queue',0),(604963,18810,'en','Sales Criteria',0),(604964,18802,'en','Sales Margin',0),(604965,18820,'en','Select Items For Barcode Print',0),(604966,18816,'en','Server Error',0),(604967,18825,'en','Set 0 For No Limit',0),(604968,18804,'en','Source Key Not Found',0),(604969,18806,'en','There Are Multiple Transfers',0),(604970,18827,'en','This Quote Has Expired',0),(604971,18832,'en','This Value Needs Saved',0),(604972,18812,'en','Total Amount To Collect',0),(604973,18826,'en','Void Credit',0),(604974,18833,'en','There Are Multiple Transfers',0),(604975,18835,'en','All Returned',0),(604976,18858,'en','Apply To All Inventory Locations',0),(604977,18836,'en','Assign By Zone',0),(604978,18865,'en','Assign Now',0),(604979,18863,'en','Cannot Mark Complete',0),(604980,18843,'en','Can Only Purchase From Assigned Vendors',0),(604981,18848,'en','Check Vendors\\\' Payment Types Allowed',0),(604982,18859,'en','Create Return PO For Damaged Items',0),(604983,18873,'en','Email This User When A Purchase Order Created By This User Is Received',0),(604984,18854,'en','Error Checking For Duplicate Vendor Codes',0),(604985,18834,'en','Final Return Invoice For This Item From Order',0),(604986,18851,'en','If A Rental Invoice',0),(604987,18844,'en','If Pricing Is Updated The Quote Can Be Unlocked',0),(604988,18866,'en','Item Not Found By ID',0),(604989,18860,'en','Item Unreceive',0),(604990,18874,'en','Last Changed By',0),(604991,18837,'en','List Invoices',0),(604992,18845,'en','Lock Expired Quotes',0),(604993,18847,'en','Login Failures Until Ban',0),(604994,18867,'en','Must Be Assigned To Vendor',0),(604995,18852,'en','Number Of Rental Periods',0),(604996,18855,'en','Number Per Purchase Unit',0),(604997,18838,'en','Payment Plan Invoices',0),(604998,18840,'en','PHP Is Missing Imagick Extension',0),(604999,18864,'en','PO Total Does Not Match Prepaid By CC Total',0),(605000,18846,'en','Prevents Conversion To Order, Saving And Changes To Expires Date',0),(605001,18842,'en','Print Selection',0),(605002,18871,'en','Purchase Order Notes',0),(605003,18861,'en','Quantity Damaged',0),(605004,18841,'en','Received Purchase Order',0),(605005,18853,'en','Rental Period Begin Date For The Period Being Invoiced',0),(605006,18862,'en','Show Only Receipts With Damaged Items',0),(605007,18868,'en','Skipping Vendor Update',0),(605008,18869,'en','The Total Payment Must Equal The PO Total',0),(605009,18872,'en','Transfer Notes',0),(605010,18856,'en','Up To This Quantity Of Purchase Units',0),(605011,18857,'en','Vendor Product Code Already Exists For Item',0),(605012,18839,'en','Which Period',0),(605013,18849,'en','You Must Enter A Date Of Invoice',0),(605014,18850,'en','You Must Enter A Vendor',0),(605015,18870,'en','You Must Save To Apply This Setting',0),(605016,18876,'en','Transfer Notes',0),(605017,18875,'en','Up To This Quantity Of Purchase Units',0),(605018,18907,'en','Added When Receiving',0),(605019,18958,'en','Adjustment Comments Required',0),(605020,18932,'en','Allow Any Account Type For Payment Plan Sales Account',0),(605021,18947,'en','Also Applies To Password Reset Failures',0),(605022,18930,'en','Always Use Last Cost And Not Vendor Pricing',0),(605023,18895,'en','Amount Applied',0),(605024,18948,'en','Are You Sure You Want To Purge All Password Reset Failures?',0),(605025,18940,'en','Are You Sure You Want To Send A Group Email Instead Of Private?',0),(605026,18949,'en','Begin Converting Files',0),(605027,18950,'en','Begin Converting Files Again',0),(605028,18968,'en','Blocked Account',0),(605029,18933,'en','Block Not For Sale Item Selection On Orders',0),(605030,18905,'en','Block Posting',0),(605031,18973,'en','Block Posting To This Account',0),(605032,18970,'en','Cannot Add/Edit Items With Inventory Type',0),(605033,18908,'en','Cannot Add Item To Count',0),(605034,18971,'en','Cannot Create POs For Other Charges Items',0),(605035,18972,'en','Cannot Create Purchase Orders For Other Charges Items',0),(605036,18885,'en','CC Account',0),(605037,18886,'en','Checking Account Is Assigned To A GL Account With No Cost Codes Allowed',0),(605038,18926,'en','Click To Open Files',0),(605039,18927,'en','Click To Open History',0),(605040,18941,'en','Confirmation Required',0),(605041,18888,'en','Continued Billing',0),(605042,18889,'en','Continued Rentals',0),(605043,18951,'en','Conversion Has Started',0),(605044,18952,'en','Convert Uploaded Files From DB To Disk',0),(605045,18962,'en','Copy Pricing To All Available Locations',0),(605046,18896,'en','Cost Code Must Be Consistent For All Lines Of Same Payment',0),(605047,18923,'en','Credit Cards GL Summary',0),(605048,18976,'en','Daily Close Drawer Float Account',0),(605049,18977,'en','Default Deposit Bank Account',0),(605050,18934,'en','Default Email Center To Private Emails',0),(605051,18935,'en','Default Item Costs On Orders To Static Cost But Override During Shipping',0),(605052,18959,'en','Default Vendor Cost Required',0),(605053,18960,'en','Default Vendor Required',0),(605054,18919,'en','Don\\\'t Show Non Prelimed Jobs',0),(605055,18900,'en','Employee Filters',0),(605056,18879,'en','Error Making Sub Directory To Save Uploaded File To Disk',0),(605057,18902,'en','Error Saving File To Disk',0),(605058,18880,'en','Error Saving Uploaded File To Disk',0),(605059,18881,'en','Error Setting Up File Upload Disk Storage',0),(605060,18953,'en','Files Will Not Be Deleted From DB When Done',0),(605061,18903,'en','Finished Converting Files',0),(605062,18910,'en','First Sale',0),(605063,18921,'en','Generate Invoices For Rentals',0),(605064,18957,'en','Has A Blocked Account',0),(605065,18890,'en','Hide Customer Sub Totals',0),(605066,18961,'en','If Cost Unknown Remove Vendor To Proceed',0),(605067,18942,'en','Ignore Spaces In Item Search Box',0),(605068,18891,'en','Include Non-Stock Rentals',0),(605069,18911,'en','Include Number Of Months For Sales Averages',0),(605070,18909,'en','Inventory Count ID',0),(605071,18912,'en','Items By Buyer',0),(605072,18925,'en','Item Doesn\\\'t Match This Inventory Count\\\'s Filters',0),(605073,18913,'en','Last Received Date',0),(605074,18914,'en','Last Sale Date',0),(605075,18936,'en','Lock Job Codes',0),(605076,18937,'en','Lowest Price Override Level For Quotes',0),(605077,18974,'en','Meta Menu',0),(605078,18892,'en','Never Billed Before',0),(605079,18904,'en','No Records To Update',0),(605080,18954,'en','Num Files In DB',0),(605081,18920,'en','Only Show Jobs Over X Days Since 1st Sale',0),(605082,18938,'en','Orders Must Have A Ship To City And Zip Set',0),(605083,18964,'en','Original Cost',0),(605084,18965,'en','Original Margin',0),(605085,18898,'en','Over Credit Limit',0),(605086,18928,'en','Patient Files',0),(605087,18929,'en','Patient History',0),(605088,18877,'en','Payment Note',0),(605089,18878,'en','Payment Note For Invoice',0),(605090,18931,'en','PO Entry Hide GL Account Field',0),(605091,18955,'en','Purge Password Reset Failures',0),(605092,18924,'en','Records',0),(605093,18893,'en','Rental Billing Type',0),(605094,18915,'en','Report On Only Default Vendor For Items',0),(605095,18943,'en','Require Category For New Items',0),(605096,18944,'en','Require Comments On Item Adjustments',0),(605097,18945,'en','Require Item Location Price For Stock Items',0),(605098,18946,'en','Require Vendor For New Items',0),(605099,18882,'en','Reverting To Database Storage',0),(605100,18916,'en','Sales Average',0),(605101,18883,'en','Saving File To Database Instead',0),(605102,18897,'en','Shipments Table',0),(605103,18975,'en','Shipment Meta Menu',0),(605104,18966,'en','Show Margin',0),(605105,18917,'en','Show Only Items With A Negative Available Count',0),(605106,18894,'en','Show PO Number',0),(605107,18901,'en','Sick & Vacation Liability',0),(605108,18906,'en','Standard Summarization',0),(605109,18956,'en','This Action Will Allow Further Password Reset Attempts Immediately',0),(605110,18887,'en','This GL Account Is Used By A CC Account',0),(605111,18884,'en','Unable To Create Directory',0),(605112,18899,'en','Unset',0),(605113,18939,'en','Users With Override Levels Below This Will Be Upgraded To This Level For Quotes Minus Approval Ability',0),(605114,18918,'en','Vendor Item Code',0),(605115,18922,'en','View Account Activity',0),(605116,18969,'en','When Converted To Order',0),(605117,18967,'en','You Do Not Have Rights To Add Other Charges Items To POs',0),(605118,18963,'en','You Must Complete At Least One Price Level',0),(605119,18978,'en','Checking Account Is Assigned To A GL Account With No Cost Codes Allowed',0),(605120,19104,'en','All Credits',0),(605121,19131,'en','All Except Distribution Centers',0),(605122,19132,'en','All Locations Except Distribution Centers',0),(605123,19133,'en','All My Vendors',0),(605124,19020,'en','Apply Changes',0),(605125,19083,'en','Apply Taxes To This Credit',0),(605126,19143,'en','At Location',0),(605127,19091,'en','Automatically Email Order Confirmation When Shipping',0),(605128,19005,'en','Back Order Value',0),(605129,19134,'en','Below Min',0),(605130,19011,'en','Billtrust Invoice Send Log',0),(605131,19012,'en','Billtrust Sent',0),(605132,19092,'en','Block Non-Stock Item Sales On POS',0),(605133,19093,'en','Block Unposting Invoices After Invoice Date',0),(605134,19135,'en','Buyer Notes',0),(605135,19000,'en','Cannot Process More Qty Than Shipped',0),(605136,19150,'en','Cannot Switch To POS With Non-Stock Items',0),(605137,18980,'en','Cannot Unpost Invoice That Has Returns',0),(605138,18981,'en','Cannot Unpost Paid Invoice',0),(605139,19159,'en','Can Always Unpost Invoices Regardless Of Company Block Unpost Setting',0),(605140,19155,'en','Cash On Delivery',0),(605141,19153,'en','Check Invoice For Payment',0),(605142,19123,'en','Clearing Release Cache',0),(605143,19094,'en','Combine Taxes To One Line',0),(605144,19144,'en','Company Average',0),(605145,19129,'en','Company-wide',0),(605146,19054,'en','Confirmed As OK Leaving Variance As Additional Stock',0),(605147,19055,'en','Confirmed As OK Leaving Variance As Lost Stock',0),(605148,19056,'en','Confirm As OK Leaving Variance As Additional Stock',0),(605149,19057,'en','Confirm As OK Leaving Variance As Lost Stock',0),(605150,18982,'en','Converted To Sale',0),(605151,19069,'en','Cost At Shipment',0),(605152,19070,'en','Cost Method',0),(605153,19021,'en','Create New Ship To With The Below Values',0),(605154,19105,'en','Credits',0),(605155,19022,'en','Current Committed Qty',0),(605156,19071,'en','Current Cost Value',0),(605157,19023,'en','Current Ship Method',0),(605158,19095,'en','Default Credit Card Account',0),(605159,19096,'en','Default Credit Card Account For B2B',0),(605160,19097,'en','Default Order Confirmation Email Template',0),(605161,19098,'en','Default Quantity To Ship',0),(605162,19041,'en','Deleted Transfer',0),(605163,19042,'en','Delete Transfer',0),(605164,19124,'en','Destroying Temp Tables',0),(605165,19013,'en','Disable Auto Invoice Sending',0),(605166,19099,'en','Display Total Details On Packing Slip',0),(605167,19146,'en','Do Not Update Last PO Cost',0),(605168,19014,'en','Enable Auto Invoice Sending',0),(605169,19118,'en','Entry Date Begin',0),(605170,19058,'en','Exclude Completed Transfers',0),(605171,19059,'en','Exclude Entries Already Handled',0),(605172,19015,'en','Failed To Send File To Billtrust',0),(605173,19103,'en','Federal Tax ID Required To Save',0),(605174,18983,'en','Find Bill Through Date',0),(605175,19106,'en','First Rental Invoices',0),(605176,19100,'en','Force Checking Account For Payments',0),(605177,19136,'en','Hide Internal Buyer Notes',0),(605178,19107,'en','Ignore Returns',0),(605179,19137,'en','Include Items With Zero Minimum Quantity',0),(605180,19138,'en','Include Rental Items',0),(605181,19060,'en','Increase Stock Qty By Variance At',0),(605182,19016,'en','Invoices Sent To Billtrust',0),(605183,19017,'en','Invoice Last Modified',0),(605184,19101,'en','Invoice Unposting',0),(605185,19139,'en','Item Buyer',0),(605186,19147,'en','Item Transaction',0),(605187,19024,'en','Job Created Date',0),(605188,19072,'en','Last Bill Date',0),(605189,19130,'en','Last PO Cost',0),(605190,19025,'en','Leave As Is',0),(605191,18984,'en','Limit Generated Bill Through Date To',0),(605192,19145,'en','Location Average',0),(605193,19108,'en','Look At Void Date Not Invoice Date',0),(605194,19140,'en','Max Level',0),(605195,19001,'en','Minimum Billing Date',0),(605196,18985,'en','Min Bill Date',0),(605197,19141,'en','Min Level',0),(605198,19043,'en','Multiple Locations',0),(605199,19026,'en','New Address',0),(605200,19027,'en','New Ship Method',0),(605201,19028,'en','Non-Prelimable Jobs Assigned To Prelimable Customers',0),(605202,19151,'en','Non-Stock Items Not Allowed On POS',0),(605203,19006,'en','Not Returned To On Hand',0),(605204,19109,'en','No Credits',0),(605205,19110,'en','No Credit Invoices',0),(605206,19073,'en','No Item ID Assigned',0),(605207,19074,'en','No Item Set',0),(605208,19075,'en','No Location Set',0),(605209,18986,'en','No Matching Taxes Found',0),(605210,19002,'en','No Rental Period Set',0),(605211,19029,'en','No Value',0),(605212,19111,'en','Only Continuing/Additional Rental Invoices',0),(605213,19112,'en','Only First Rental Invoices',0),(605214,19113,'en','Only Rental Invoices',0),(605215,19061,'en','Only Show Entries With A Variance',0),(605216,19065,'en','On Floor',0),(605217,19076,'en','On Rent',0),(605218,19044,'en','On Transfer',0),(605219,19030,'en','On Transfer Qty',0),(605220,19119,'en','Order Appears To Be Complete But Is Not Marked As Complete',0),(605221,19120,'en','Order Appears To Be Incomplete But Is Marked As Complete',0),(605222,18998,'en','Order Confirmation For Order',0),(605223,19142,'en','Order To',0),(605224,19114,'en','Other Ship Method',0),(605225,19077,'en','Out On Rent Items Detail',0),(605226,19040,'en','Overwrite',0),(605227,19066,'en','Overwrite Assigned User If Already Set',0),(605228,19154,'en','Payment May Not Have Saved',0),(605229,18987,'en','Payment Types By Cost Code',0),(605230,19125,'en','Phase',0),(605231,19062,'en','Picked Qty',0),(605232,19045,'en','Picker Transfer To',0),(605233,18988,'en','POS Pick List',0),(605234,18979,'en','Print New Statement',0),(605235,19046,'en','Qty Committed Before',0),(605236,19047,'en','Qty Committed Now',0),(605237,19003,'en','Quantity Reduced',0),(605238,18989,'en','Recalculate Missing Taxes',0),(605239,18990,'en','Recalculate Taxes',0),(605240,19063,'en','Reduced Stock Qty By Variance At',0),(605241,19064,'en','Reduce Stock Qty By Variance At',0),(605242,19085,'en','Related Vendor Bills',0),(605243,19126,'en','Removing Database Update File',0),(605244,19078,'en','Rental Value',0),(605245,19079,'en','Rental Value At Time Of Shipment',0),(605246,18991,'en','Report By',0),(605247,19048,'en','Restored Transfer',0),(605248,19049,'en','Restore Transfer',0),(605249,19007,'en','Returned To On Hand',0),(605250,19004,'en','Return To Branch',0),(605251,19050,'en','Revalidate All Transfer Item Committed Records',0),(605252,18992,'en','Sales & Margin By Shipping & Cost Code',0),(605253,18993,'en','Sales & Margin By Shipping & Location',0),(605254,19157,'en','Save Not Permitted',0),(605255,19018,'en','Send Statements To Billtrust',0),(605256,19031,'en','Set Item Category',0),(605257,19084,'en','Set Last Billed Date',0),(605258,19086,'en','Set Last Cost',0),(605259,19122,'en','Shipment Adjustments',0),(605260,19089,'en','Shipment Has Been Invoiced',0),(605261,19090,'en','Shipment Has Been Voided',0),(605262,19032,'en','Shipped Out',0),(605263,19051,'en','Shipper Transfer To',0),(605264,19033,'en','Shipping Method Not Found',0),(605265,19121,'en','Shipping More Qty Than On Order',0),(605266,19152,'en','Shipping Preference For This Order',0),(605267,19008,'en','Ship Tax',0),(605268,19156,'en','Ship To Exemption Also Applies To POS And Pickup',0),(605269,19034,'en','Ship To Not Found',0),(605270,19009,'en','Ship Value',0),(605271,19087,'en','Show Next Page',0),(605272,19102,'en','Show Shipping Preference Confirmation Before Saving Order',0),(605273,19127,'en','Split Transfer By Zone',0),(605274,19158,'en','System Is Read-only',0),(605275,18994,'en','Tax Exempt',0),(605276,19088,'en','There Are More Prelims That Can Be Sent',0),(605277,19081,'en','The Uploaded File Exceeds The Server Limits',0),(605278,19116,'en','This Invoice Is Paid',0),(605279,18995,'en','This Is Not A Filter',0),(605280,18996,'en','This Setting Will Set A Max Value Generated For The Column',0),(605281,19019,'en','Totals Are Current And May Not Reflect Values At The Time Of Sending',0),(605282,19035,'en','Transaction',0),(605283,19036,'en','Transaction Details',0),(605284,19128,'en','Transfer Complete',0),(605285,19052,'en','Transfer Does Not Contain Multiple Zones',0),(605286,19148,'en','Transfer In',0),(605287,19053,'en','Transfer Not Found',0),(605288,19149,'en','Transfer Out',0),(605289,19037,'en','Transfer Split From',0),(605290,19067,'en','Unassign',0),(605291,19068,'en','Unassign Users',0),(605292,19038,'en','Unfulfilled Order Qty',0),(605293,19080,'en','Uninvoiced Shipments By Location',0),(605294,19010,'en','Uninvoiced Shipment Totals',0),(605295,18997,'en','Unpost Now',0),(605296,19082,'en','Upload Failed',0),(605297,19115,'en','Using Void Date',0),(605298,19039,'en','Will Call',0),(605299,18999,'en','Your Order Confirmation Is Attached For Order',0),(605300,19117,'en','You Do Not Have Rights To Perform This Action',0),(605301,19162,'en','Current Committed Qty',0),(605302,19163,'en','Deleted Transfer',0),(605303,19164,'en','Delete Transfer',0),(605304,19165,'en','Multiple Locations',0),(605305,19166,'en','Qty Committed Before',0),(605306,19167,'en','Qty Committed Now',0),(605307,19160,'en','Quantity Reduced',0),(605308,19168,'en','Restored Transfer',0),(605309,19169,'en','Restore Transfer',0),(605310,19170,'en','Revalidate All Transfer Item Committed Records',0),(605311,19161,'en','Send Statements To Billtrust',0),(605312,19171,'en','Transfer Does Not Contain Multiple Zones',0),(605313,19185,'en','Add Items To Bin',0),(605314,19186,'en','Add Item To Bin',0),(605315,19225,'en','Allow Users To Set Custom Restock Fee',0),(605316,19172,'en','Archived',0),(605317,19270,'en','Assign Account To This Company',0),(605318,19229,'en','B2B Payment Location',0),(605319,19246,'en','Begin Transaction Date',0),(605320,19218,'en','Bin Labels',0),(605321,19264,'en','Calculating',0),(605322,19210,'en','Cannot Invoice Canceled Shipment',0),(605323,19247,'en','Cash Payments',0),(605324,19271,'en','Changes Required',0),(605325,19248,'en','Check Payments',0),(605326,19272,'en','Cost Centers Cannot Be Used With GL Accounts For All Companies',0),(605327,19193,'en','Could Not Find Item At Location',0),(605328,19173,'en','Created Date',0),(605329,19273,'en','Create New Account',0),(605330,19230,'en','Create New Interest Invoice For Each Customer',0),(605331,19231,'en','Create New Interest Invoice For Each Invoice',0),(605332,19187,'en','Current Bins',0),(605333,19221,'en','Current Cost',0),(605334,19183,'en','Customer Billtrust Statements',0),(605335,19194,'en','Data Not Set',0),(605336,19232,'en','Default Job Shipping Method',0),(605337,19280,'en','Default To',0),(605338,19213,'en','Delete Invoice',0),(605339,19267,'en','Delete Reason',0),(605340,19249,'en','Deposit Info',0),(605341,19217,'en','Deposit Voided By User',0),(605342,19209,'en','Deposit Void For Order',0),(605343,19222,'en','Diff From Minimum',0),(605344,19174,'en','Emailed',0),(605345,19224,'en','Email Associated Order Salesman On Receive',0),(605346,19250,'en','End Transaction Date',0),(605347,19179,'en','Exclude Invoices After',0),(605348,19175,'en','Exclude Zero Balance Invoices',0),(605349,19214,'en','Explanation Required',0),(605350,19176,'en','Fax New Statement',0),(605351,19177,'en','Fax Sent To',0),(605352,19259,'en','Flat Fee',0),(605353,19275,'en','From And To Locations Cannot Be The Same',0),(605354,19196,'en','From Location On Hand Will Go Negative If Marked',0),(605355,19233,'en','Fulfillment Order Ship To Addresses Require City, State And Zip',0),(605356,19178,'en','Generate New Statement',0),(605357,19226,'en','Group Restock Fees As A Single Invoice Line',0),(605358,19251,'en','Hide Cash Payments',0),(605359,19234,'en','Hide POS Print Invoice Button',0),(605360,19235,'en','Hide POS Print Options Until After Payment',0),(605361,19180,'en','Hourly Invoice Activity',0),(605362,19245,'en','Intercompany Item Transfers - Block Edit Once Assigned',0),(605363,19207,'en','Interest For Invoice',0),(605364,19204,'en','Invoice Deleted',0),(605365,19211,'en','Invoice Deleted By User',0),(605366,19208,'en','Invoice Payment Void',0),(605367,19195,'en','Item Already Exists At This Location And Bin',0),(605368,19188,'en','Item To Add',0),(605369,19236,'en','Job Credit Limit Default',0),(605370,19181,'en','Job Prelim',0),(605371,19199,'en','Job Prelim Request Received',0),(605372,19252,'en','Lock Begin & End Dates',0),(605373,19189,'en','Make Primary Bin',0),(605374,19279,'en','Missing Ship To',0),(605375,19254,'en','Multiplied By A Monthly Rate Of',0),(605376,19190,'en','No Bins, Zone, Or Location Set',0),(605377,19265,'en','No Fax',0),(605378,19191,'en','No New Items Added Yet',0),(605379,19197,'en','No Zone Or Location Set',0),(605380,19237,'en','Only Charge Interest To Customers With A Balance Over',0),(605381,19200,'en','Only Jobs With No Existing Prelim Request Received',0),(605382,19201,'en','Only Jobs With No Existing Prelim Request Sent',0),(605383,19255,'en','Only One Month Will Be Charged',0),(605384,19202,'en','Only Show Jobs With Open Amounts Over',0),(605385,19203,'en','Only Show Jobs With Prelim Amounts Over',0),(605386,19253,'en','Other Payments',0),(605387,19216,'en','Payment Voided By User',0),(605388,19260,'en','Percentage',0),(605389,19223,'en','% Diff From Minimum',0),(605390,19182,'en','Please See Attached File',0),(605391,19281,'en','Preferred Statement Notification Method',0),(605392,19220,'en','Print Proof Of Delivery',0),(605393,19215,'en','Reason For Deletion',0),(605394,19212,'en','Recalculating Taxes',0),(605395,19261,'en','Percentage',0),(605396,19238,'en','Reload Prices When Sales Location Changes',0),(605397,19274,'en','Remove Cost Center',0),(605398,19205,'en','Replacement For Invoice',0),(605399,19239,'en','Require Explanation To Delete Orders, Invoices And Payments',0),(605400,19240,'en','Require Shipping Preference',0),(605401,19206,'en','Restock Fee',0),(605402,19227,'en','Restock Fee Is Taxed',0),(605403,19262,'en','Restock Fee Method',0),(605404,19266,'en','Send Customer Statements',0),(605405,19184,'en','Sent Billtrust Statement Details',0),(605406,19263,'en','Set All Restock Fee Details',0),(605407,19269,'en','Shipment Is Canceled',0),(605408,19241,'en','Show Extra Value Summary On Order Confirmation',0),(605409,19256,'en','Skip Previous Months\\\' Interest Charges',0),(605410,19242,'en','Statement Header Email',0),(605411,19228,'en','This Is The Default Condition',0),(605412,19243,'en','Use Company Default',0),(605413,19244,'en','Use Customer Default',0),(605414,19257,'en','Void Reason',0),(605415,19258,'en','Void Reason Required',0),(605416,19192,'en','Warehouse Bin Labels',0),(605417,19198,'en','Warehouse Zone Labels',0),(605418,19278,'en','Your User Does Not Have Rights To Create Stock Items',0),(605419,19268,'en','You Do Not Have Rights To Perform This Action',0),(605420,19276,'en','You Must Select A From Location',0),(605421,19277,'en','You Must Select A To Location',0),(605422,19219,'en','Zone Labels',0),(605423,19282,'en','Fulfillment Order Ship To Addresses Require City, State And Zip',0),(605424,19283,'en','Only One Month Will Be Charged',0),(605425,19313,'en','WARNING: California Prop 65 Cancer and Reproductive Harm! www.p65warnings.ca.gov',0),(605426,19446,'en','Added',0),(605427,19447,'en','Added By',0),(605428,19311,'en','Add Pension Plan',0),(605429,19445,'en','Add PO Number To Description',0),(605430,19372,'en','Add Territory To Region',0),(605431,19437,'en','Any Deposit',0),(605432,19449,'en','Are You Sure The Qty Should Be Zero',0),(605433,19284,'en','Assigned Invoice Terms',0),(605434,19425,'en','Avg Xfers Per Month',0),(605435,19419,'en','Bank Routing',0),(605436,19420,'en','Bank Routing & Account Number Must Be Set',0),(605437,19392,'en','Barcode Format',0),(605438,19393,'en','Barcode Printer',0),(605439,19322,'en','Based On Territory',0),(605440,19299,'en','Bins',0),(605441,19317,'en','Block',0),(605442,19465,'en','Block Location From Count Management',0),(605443,19466,'en','Block Location From Item Reorder List',0),(605444,19429,'en','Break Out By Location',0),(605445,19323,'en','Calculate Sales Method',0),(605446,19440,'en','Cannot Be Imported',0),(605447,19308,'en','Cannot Create A Return Against Interest Invoice',0),(605448,19324,'en','Changes In Sales',0),(605449,19373,'en','Could Not Find Territory Region',0),(605450,19292,'en','Counted COGS',0),(605451,19325,'en','Credit Allowed Customers',0),(605452,19347,'en','Current On Floor',0),(605453,19374,'en','Current Region',0),(605454,19456,'en','Customer Added',0),(605455,19450,'en','Customer On Hold',0),(605456,19326,'en','Customer Tax Details',0),(605457,19369,'en','Customer Tax Setup Report',0),(605458,19327,'en','Decrease In Sales',0),(605459,19405,'en','Default Allow Order Modifications',0),(605460,19457,'en','Default For Customers On Hold',0),(605461,19406,'en','Default No Credit Allowed Terms',0),(605462,19407,'en','Default Show Prices On Delivery Confirmation',0),(605463,19408,'en','Default Show Prices On Packing Slip',0),(605464,19328,'en','Default Tax Exemption',0),(605465,19375,'en','Delete Existing Data',0),(605466,19398,'en','Delete From This Region',0),(605467,19409,'en','Display Unit Of Measure',0),(605468,19303,'en','Don\\\'t Ship/Next',0),(605469,19388,'en','Edit Picked Qty',0),(605470,19421,'en','Emails For Invoices',0),(605471,19422,'en','Emails Not For Invoices',0),(605472,19458,'en','Email When Order Created',0),(605473,19390,'en','Enter Serial Number',0),(605474,19293,'en','Entries Counted',0),(605475,19294,'en','Entries Pending Review',0),(605476,19376,'en','Error Adding Territory',0),(605477,19339,'en','Event Log',0),(605478,19340,'en','Event Ref',0),(605479,19341,'en','Event Table',0),(605480,19357,'en','Excess',0),(605481,19358,'en','Excess Qty',0),(605482,19359,'en','Excess Total',0),(605483,19410,'en','Exclude Previously Shipped Items From Packing Slip',0),(605484,19360,'en','Exclude Rentals',0),(605485,19467,'en','Exclude This Location From Physical Inventory Counts',0),(605486,19285,'en','Expected Values',0),(605487,19441,'en','Export Contacts',0),(605488,19286,'en','Find Mismatched',0),(605489,19438,'en','Full Deposit',0),(605490,19411,'en','Hide Line Number On Order Confirmation',0),(605491,19432,'en','Hide Non-Stocked Items',0),(605492,19305,'en','Hide Payment Terms On Order Confirmation',0),(605493,19433,'en','Hide Vendors',0),(605494,19289,'en','ID Not Found',0),(605495,19298,'en','Include Message',0),(605496,19361,'en','Include Rentals',0),(605497,19329,'en','Increase In Sales',0),(605498,19384,'en','Interest Payment',0),(605499,19287,'en','Invoices With Terms Not Matching Customer',0),(605500,19386,'en','In Advance Rentals Will Bill Full Period',0),(605501,19399,'en','Keep In This Region',0),(605502,19387,'en','Key',0),(605503,19431,'en','Keyword In Item Code',0),(605504,19342,'en','Label Size',0),(605505,19362,'en','Last Sold',0),(605506,19370,'en','Manage Territories',0),(605507,19290,'en','Mass Ship',0),(605508,19426,'en','Min Avg Sales Per Month',0),(605509,19307,'en','Monthly Finance Charge',0),(605510,19460,'en','New Pending Order Number',0),(605511,19461,'en','New Pending Rental Order Number',0),(605512,19377,'en','New Territories',0),(605513,19385,'en','Non-Interest Payment',0),(605514,19434,'en','Non-Stocked Items',0),(605515,19412,'en','Notify Sales Person For New Customers With Credit',0),(605516,19413,'en','Notify Sales Person For New Jobs',0),(605517,19391,'en','No Bins Found',0),(605518,19302,'en','No Bin Assigned',0),(605519,19442,'en','No Cost Code',0),(605520,19451,'en','No Credit Allowed For This Customer',0),(605521,19367,'en','No Customer Or Job Selected',0),(605522,19439,'en','No Deposit',0),(605523,19443,'en','No GL Category',0),(605524,19378,'en','No New Territories Added Yet',0),(605525,19354,'en','No Notes',0),(605526,19379,'en','No Territory Set',0),(605527,19310,'en','Only Interest Invoices',0),(605528,19363,'en','Only Items With A Shelf Life',0),(605529,19295,'en','On Hand COGS',0),(605530,19355,'en','On Purchase Order',0),(605531,19371,'en','Overstock',0),(605532,19364,'en','Overstock Report',0),(605533,19318,'en','Page Customizer',0),(605534,19314,'en','Payment Details',0),(605535,19315,'en','Payment',0),(605536,19319,'en','Phone',0),(605537,19320,'en','Picker Notes',0),(605538,19312,'en','Plan #',0),(605539,19348,'en','Post All On Hand Adjustments',0),(605540,19368,'en','Pricing Will Apply To All',0),(605541,19452,'en','Print Confirmation',0),(605542,19343,'en','Print Item Barcodes',0),(605543,19344,'en','Print Item List',0),(605544,19394,'en','Print Mode',0),(605545,19453,'en','Print Paper Proof Mylar Request',0),(605546,19454,'en','Print Pick List',0),(605547,19309,'en','Print Statements That Would Be Sent To Billtrust',0),(605548,19349,'en','Print Variances',0),(605549,19330,'en','Prior 12345 Months Of Sales',0),(605550,19427,'en','Purchase Remotely',0),(605551,19455,'en','Qty Must Be Numeric',0),(605552,19389,'en','Qty Picked',0),(605553,19331,'en','Recent 12345 Months Of Sales',0),(605554,19350,'en','Recount',0),(605555,19351,'en','Recount All Variances',0),(605556,19316,'en','Ref #',0),(605557,19380,'en','Region Territories',0),(605558,19332,'en','Report On',0),(605559,19423,'en','Return To Location',0),(605560,19333,'en','Sales Changes Analysis',0),(605561,19334,'en','Sales Difference Period',0),(605562,19335,'en','Sales Dollars',0),(605563,19468,'en','Sales Region',0),(605564,19336,'en','Sales Tax 1 District',0),(605565,19448,'en','Sales Territory',0),(605566,19352,'en','Save Selected',0),(605567,19414,'en','Send Email To Admins When Orders, Invoices Or Payments Deleted',0),(605568,19459,'en','Send Interest Invoices',0),(605569,19462,'en','Send Order Confirmations',0),(605570,19345,'en','Serial Numbers',0),(605571,19401,'en','Set',0),(605572,19396,'en','Set New Maximum',0),(605573,19397,'en','Set New Minimum',0),(605574,19402,'en','Set Zip Code',0),(605575,19304,'en','Ship/Next',0),(605576,19337,'en','Ship To Tax Exemption',0),(605577,19365,'en','Show Avg Sales Since',0),(605578,19321,'en','Show Invoice Terms',0),(605579,19306,'en','Show Invoice Terms On Order Confirmation',0),(605580,19356,'en','Show Item Subtotals',0),(605581,19435,'en','Show Non-Stocked Items',0),(605582,19366,'en','Show Only Rentals',0),(605583,19415,'en','Show Quantity Backordered On Packing Slip',0),(605584,19338,'en','Show Records With A Difference',0),(605585,19416,'en','Show Shipped Quantity On Order Confirmation',0),(605586,19436,'en','Show Vendors',0),(605587,19417,'en','Show Weight With UN Number',0),(605588,19346,'en','SN',0),(605589,19424,'en','Sold From Location',0),(605590,19430,'en','Sort By Quantity',0),(605591,19300,'en','Split Transfers By Zone',0),(605592,19395,'en','Standard Printer',0),(605593,19381,'en','Territory Added Successfully',0),(605594,19382,'en','Territory Already Assigned To This Region',0),(605595,19383,'en','Territory To Add',0),(605596,19296,'en','Total Entries',0),(605597,19291,'en','Transfers Shipped',0),(605598,19301,'en','Transfer IDs',0),(605599,19288,'en','Unincorporated Area',0),(605600,19464,'en','User\\\'s First & Last Name',0),(605601,19418,'en','Use Inventory Location Info Instead Of Company Info',0),(605602,19444,'en','Use Only Default Vendors',0),(605603,19403,'en','Verifying Address',0),(605604,19404,'en','Verifying Ship To Address',0),(605605,19297,'en','View Active Counts',0),(605606,19463,'en','Waiver Files',0),(605607,19428,'en','YTD Purchases',0),(605608,19400,'en','Zip Code',0),(605609,19353,'en','Zone Or Bin',0),(605610,19469,'en','Only Items With A Shelf Life',0),(605611,19475,'en','All Lines Must Have An Item Assigned',0),(605612,19472,'en','Block Rentals For Customers Marked As No Credit',0),(605613,19473,'en','Do Not Allow Ship To Address Edits On Orders',0),(605614,19470,'en','Qty Variance',0),(605615,19476,'en','Rentals Not Allowed For Customers Marked As No Credit',0),(605616,19474,'en','Require Inventory Item For All Sales',0),(605617,19471,'en','Transfer Fill Rate Analysis',0),(605618,19477,'en','Rentals Not Allowed For Customers Marked As No Credit',0),(605619,19478,'en','Appointment Notification Method',0),(605620,19486,'en','Assigned Bins',0),(605621,19500,'en','Bins With A Variance Over',0),(605622,19503,'en','Block Changing PO Vendor Terms',0),(605623,19513,'en','Can Always Change PO Vendor Terms Regardless Of Company Setting',0),(605624,19514,'en','Can View And Edit Job Prelimable Settings',0),(605625,19496,'en','Change Item\\\'s Assigned Bins',0),(605626,19495,'en','Click To Read Barcode',0),(605627,19487,'en','Count ID',0),(605628,19508,'en','Create Ship To From Current Job',0),(605629,19485,'en','Customers With No Sales Last',0),(605630,19512,'en','Email For 3dcart Login',0),(605631,19506,'en','Email Min/Max Change Notices To',0),(605632,19504,'en','Email Regional Sales Manager Each Day List Of Customers With No Sales In Last 90 Days',0),(605633,19515,'en','Hidden To All Users',0),(605634,19511,'en','Hours Trailing Decimals',0),(605635,19497,'en','Ignore All',0),(605636,19501,'en','Items With A Variance Over',0),(605637,19488,'en','Item Bins Saved',0),(605638,19493,'en','Item Min And Max Changes',0),(605639,19509,'en','Last Changed',0),(605640,19519,'en','Max Changed',0),(605641,19520,'en','Min Changed',0),(605642,19479,'en','Mobile Carrier',0),(605643,19480,'en','My Preferences',0),(605644,19498,'en','New Items Have Been Added To This List',0),(605645,19494,'en','New Value',0),(605646,19481,'en','No Mobile Carrier Selected',0),(605647,19489,'en','Other Bins',0),(605648,19482,'en','Please Select A Mobile Carrier',0),(605649,19502,'en','Recount By',0),(605650,19490,'en','Recount Variances',0),(605651,19483,'en','Reminder Phone',0),(605652,19510,'en','Rental Order Added',0),(605653,19499,'en','Select Item And Location',0),(605654,19507,'en','Select Specific Invoices To Print',0),(605655,19505,'en','Send Email To Salesperson For New Rental Orders',0),(605656,19484,'en','Text Message',0),(605657,19516,'en','Time Report Cost Access',0),(605658,19491,'en','Toggle Check All',0),(605659,19492,'en','View Assigned Bins For Location',0),(605660,19517,'en','Visible To All Users',0),(605661,19518,'en','Visible To Users With Payroll Access',0),(605662,19521,'en','Email Salesman Weekly An Open Order Summary',0),(605663,19522,'en','Email Salesman Weekly An Open Order Summary',0),(605664,19551,'en','Accounts Without Stored Cards',0),(605665,19552,'en','Accounts With Stored Cards',0),(605666,19561,'en','All Entries In This Bin Have Already Been Counted',0),(605667,19562,'en','All Items In Current Bin Have Not Been Marked As Counted',0),(605668,19588,'en','Amount Needed To Make This Shipment',0),(605669,19563,'en','Are You Sure You Want To Change Bins?',0),(605670,19553,'en','Are You Sure You Want To Delete The Selected Authorize.net Accounts?',0),(605671,19548,'en','Authorize.net CIM Card Report',0),(605672,19527,'en','Barcode',0),(605673,19559,'en','Bin Counted',0),(605674,19525,'en','Bin ID',0),(605675,19578,'en','Cannot Charge Interest When Customer Total Is A Credit',0),(605676,19591,'en','Continue Unsaved Order',0),(605677,19535,'en','Counted By',0),(605678,19576,'en','Create Profile',0),(605679,19564,'en','Current Bin',0),(605680,19536,'en','Current Time',0),(605681,19577,'en','Customer Does Not Have An Authorize.net Profile',0),(605682,19572,'en','Days To Prelim',0),(605683,19528,'en','Delete All Bins',0),(605684,19554,'en','Delete Selected Authorize.net Accounts Without Stored Card',0),(605685,19555,'en','Delete Selected Authorize.net Accounts With Stored Card',0),(605686,19534,'en','Delete Transfers',0),(605687,19537,'en','Do Not Post To GL',0),(605688,19574,'en','Email Cycle Count Complete Summaries To',0),(605689,19592,'en','Email Cycle Count Complete Summary',0),(605690,19575,'en','Email Physical Count Complete Summaries To',0),(605691,19593,'en','Email Physical Count Complete Summary',0),(605692,19560,'en','Entering Counts For Items In Bin',0),(605693,19523,'en','Error Deleting Authorize.net Customer Profile',0),(605694,19587,'en','Exclude Cash Customers',0),(605695,19582,'en','Exempt Sales In District',0),(605696,19583,'en','Exempt Sales Total',0),(605697,19590,'en','First Invoice Date',0),(605698,19569,'en','Ignore 3dcart Taxes And Reassign Based On System Setup',0),(605699,19550,'en','Import Cities Without Tax Rates',0),(605700,19579,'en','Interest Charged',0),(605701,19580,'en','Interest Invoice Number',0),(605702,19558,'en','Inventory Bins',0),(605703,19538,'en','Inventory Cycle Count Posted',0),(605704,19539,'en','Inventory Cycle Count Summary',0),(605705,19540,'en','Inventory Physical Count Posted',0),(605706,19541,'en','Inventory Physical Count Summary',0),(605707,19542,'en','Inventory Zones',0),(605708,19543,'en','Items Pending Variance Recount',0),(605709,19565,'en','Item Or Bin Not Found',0),(605710,19573,'en','Limit Ship To Entry To Only Known Cities And Zip Codes',0),(605711,19549,'en','Manage Alternative Zip Codes',0),(605712,19570,'en','Match Against Taxes In System Based On Rate',0),(605713,19581,'en','New Interest Total',0),(605714,19544,'en','New On Hand',0),(605715,19568,'en','New Zip Code',0),(605716,19567,'en','Only Rentals',0),(605717,19545,'en','Posted By',0),(605718,19529,'en','Print Barcode Commands',0),(605719,19530,'en','Print Bin Codes',0),(605720,19531,'en','Quick Item Bin Maintenance',0),(605721,19532,'en','Quick Item Bin Maintenance Commands',0),(605722,19524,'en','Records Deleted Successfully',0),(605723,19533,'en','Restart',0),(605724,19546,'en','Review Active Inventory Count',0),(605725,19526,'en','Save And Change Warehouse Bin',0),(605726,19556,'en','Select Or Scan An Item To Begin',0),(605727,19557,'en','Select Or Scan A Bin To Assign',0),(605728,19584,'en','Taxable Sales In District',0),(605729,19571,'en','Tax Method',0),(605730,19589,'en','This Order\\\'s Deposit Has Been Applied To Other Orders Or Invoices',0),(605731,19585,'en','Total Rate',0),(605732,19586,'en','Total Sales In District',0),(605733,19566,'en','View All Bins',0),(605734,19547,'en','Zone Bin Or Item',0),(605735,19595,'en','Action Required',0),(605736,19660,'en','Add Extra To Commission Total',0),(605737,19649,'en','Allowed On Jobs',0),(605738,19645,'en','Allow Shipment Of Order With Deposit In Full',0),(605739,19596,'en','All Bins',0),(605740,19636,'en','All Found Items Are Already Selected',0),(605741,19686,'en','Are You Sure The Price Should Be Zero',0),(605742,19661,'en','Are You Sure You Want To Delete This Commission',0),(605743,19642,'en','Are You Sure You Want To Resend This Confirmation Email?',0),(605744,19597,'en','Assigned Bins On This Count Are Not Valid',0),(605745,19662,'en','Assistant',0),(605746,19663,'en','Assistant Not Found',0),(605747,19664,'en','Assistant Total',0),(605748,19629,'en','Authorization Services 2',0),(605749,19632,'en','Authorize Credit Card',0),(605750,19621,'en','Average Cost',0),(605751,19622,'en','Average Cost History',0),(605752,19637,'en','Begin & End Range Must Be Set',0),(605753,19598,'en','Bin Or Item',0),(605754,19633,'en','Book',0),(605755,19665,'en','Calculate Assistant Commissions',0),(605756,19599,'en','Cannot Add Item',0),(605757,19600,'en','Cannot Create New Count Until Current Physical Count Is Completed',0),(605758,19594,'en','CC Account',0),(605759,19601,'en','Click To Resend',0),(605760,19666,'en','Commissions For',0),(605761,19667,'en','Commissions Saved Successfully',0),(605762,19668,'en','Commission For These Settings Already Exists',0),(605763,19602,'en','Completing',0),(605764,19603,'en','Count Entries',0),(605765,19669,'en','Current Commission Items',0),(605766,19627,'en','Custom Commissions',0),(605767,19646,'en','Default Checking Accounts',0),(605768,19647,'en','Default Cost Of Goods Sold GL Account',0),(605769,19670,'en','Default Items',0),(605770,19648,'en','Default Sales GL Account',0),(605771,19657,'en','Deposit In Full Required When Credit Not Available',0),(605772,19658,'en','Deposit Required',0),(605773,19671,'en','Driver Assistant Commission',0),(605774,19672,'en','Driver Commission',0),(605775,19673,'en','Driver Total',0),(605776,19674,'en','Driver Total Must Be A Number',0),(605777,19604,'en','Duplicate Count Entries',0),(605778,19605,'en','Emailing',0),(605779,19606,'en','Entries Marked For Recount',0),(605780,19607,'en','Entry Was Modified',0),(605781,19675,'en','Error Saving Commissions',0),(605782,19655,'en','Include Voided Invoices',0),(605783,19608,'en','Invalid Bin',0),(605784,19609,'en','Invalid Bins For Items On Count',0),(605785,19676,'en','Invoice Status',0),(605786,19638,'en','Items Selected',0),(605787,19628,'en','Item Avg Cost History',0),(605788,19677,'en','Item Commission Deleted Successfully',0),(605789,19678,'en','Item Commission Settings Added Successfully',0),(605790,19640,'en','Item Must Be Set',0),(605791,19679,'en','Item Option Choice',0),(605792,19680,'en','Item Option Group',0),(605793,19641,'en','Location Must Be Set',0),(605794,19681,'en','Manage Items',0),(605795,19630,'en','Minimum Book Amount For Auth',0),(605796,19610,'en','Missing Bin',0),(605797,19611,'en','Missing Bins For Items On Count',0),(605798,19656,'en','Non-Rental',0),(605799,19639,'en','No Items Found In Range',0),(605800,19682,'en','No Item Selected',0),(605801,19612,'en','Old On Hand',0),(605802,19613,'en','Physical Count Ready To Be Posted',0),(605803,19614,'en','Physical Cycle Ready To Be Posted',0),(605804,19615,'en','Posting',0),(605805,19687,'en','Requires',0),(605806,19631,'en','Require CC Auth To Book Amount 2',0),(605807,19650,'en','Require Email Confirmation To Post Cycle Counts',0),(605808,19651,'en','Require Email Confirmation To Post Physical Counts',0),(605809,19652,'en','Require Unique Vendor Product Codes',0),(605810,19616,'en','Reset Entered Counts Of Other Bins',0),(605811,19623,'en','Running Qty',0),(605812,19624,'en','Running Value',0),(605813,19644,'en','Selected States Only',0),(605814,19653,'en','Send Confirmations To',0),(605815,19643,'en','Set Average Cost',0),(605816,19683,'en','Set Commission Items',0),(605817,19684,'en','Set Default Commission Items',0),(605818,19685,'en','Set Default Item Commission Settings Here',0),(605819,19659,'en','Shipment Declined',0),(605820,19617,'en','Show More Results',0),(605821,19634,'en','Stored Cards',0),(605822,19618,'en','This Item Is Already Part Of Inventory Count',0),(605823,19619,'en','This Item Was Already Recounted',0),(605824,19625,'en','Transaction Cost',0),(605825,19626,'en','Transaction Qty',0),(605826,19654,'en','Use Same Average Cost For All Locations',0),(605827,19620,'en','Variance Recount',0),(605828,19635,'en','Without Stored Cards',0),(605829,19689,'en','Commissions Saved Successfully',0),(605830,19688,'en','Entry Was Modified',0),(605831,19690,'en','Discount Available',0),(605832,19691,'en','Show Discount Available',0),(605833,19692,'en','As Of Date',0),(605834,19693,'en','Default PO Font Size',0),(605835,19700,'en','Max PO Amount',0),(605836,19694,'en','PO Is Over Your Allowed Limit',0),(605837,19698,'en','PO Receipt Batch',0),(605838,19699,'en','PO Receipt Documents',0),(605839,19695,'en','Show Cost Code',0),(605840,19696,'en','Show GL Account',0),(605841,19697,'en','Show GL Category',0),(605842,19779,'en','Additional Fields',0),(605843,19747,'en','Admin New Patient',0),(605844,19748,'en','Admin New Patient Notification Email Address',0),(605845,19749,'en','Admin New Patient Notification Service Type',0),(605846,19768,'en','Allow B2B Users To Reset Password',0),(605847,19781,'en','Are You Sure You Want To Delete This Invoice?',0),(605848,19751,'en','Authorize Credit Card Error',0),(605849,19756,'en','Auto Import',0),(605850,19739,'en','A Default Inventory Location Must Be Set',0),(605851,19740,'en','A Default Price Level Must Be Set',0),(605852,19765,'en','Block Transfers For Inventory Types',0),(605853,19795,'en','Cannot Issue Customer Credit',0),(605854,19719,'en','Cannot Save When Unassigned Entries Exist',0),(605855,19752,'en','Check Customer ID And Customer Numbers',0),(605856,19753,'en','Check Customer USAePay Settings',0),(605857,19708,'en','Click Here To Login',0),(605858,19709,'en','Click Here To Reset Your Password',0),(605859,19785,'en','Convert Both Rentals And Nonrentals',0),(605860,19786,'en','Convert Non-Rentals Only',0),(605861,19787,'en','Convert Rentals Only',0),(605862,19782,'en','Convert To Special Sales Pricing',0),(605863,19772,'en','Cost Account Total',0),(605864,19783,'en','Cost Code Not Allowed For Sales',0),(605865,19744,'en','Created From Quote',0),(605866,19788,'en','Created Special Item Price List',0),(605867,19718,'en','Credit Limit Over',0),(605868,19729,'en','Customer Default',0),(605869,19757,'en','Do Not Show',0),(605870,19769,'en','Emails Do Not Match',0),(605871,19766,'en','Email Item Special Pricing Changes',0),(605872,19770,'en','Email Not Valid',0),(605873,19754,'en','Error Booking Appointment',0),(605874,19789,'en','Error Converting',0),(605875,19790,'en','Existing Price List Already Contains This Item',0),(605876,19745,'en','Fixed Margin',0),(605877,19746,'en','Fixed Price',0),(605878,19710,'en','Forgotten Password Reset',0),(605879,19758,'en','General Entry',0),(605880,19750,'en','General Patient Email',0),(605881,19711,'en','Hi',0),(605882,19712,'en','If you did not request a password reset, please ignore this email.',0),(605883,19791,'en','Items Must Be Set And Include Pricing',0),(605884,19724,'en','Item And Cost Code',0),(605885,19725,'en','Item And Location',0),(605886,19731,'en','Item Cost Changed By',0),(605887,19726,'en','Item Only',0),(605888,19732,'en','Item Special Pricing Changed',0),(605889,19780,'en','Item Vendor',0),(605890,19701,'en','Make Payment On Selected Invoices',0),(605891,19730,'en','Min Cost',0),(605892,19784,'en','Missing Sales Pricing',0),(605893,19741,'en','Must Have Access To Each Group Below',0),(605894,19720,'en','New On Hand Valuation',0),(605895,19733,'en','New Price',0),(605896,19734,'en','New Profit Margin',0),(605897,19792,'en','Nothing To Convert',0),(605898,19778,'en','Not Allowed For Sales',0),(605899,19721,'en','Not All Entries Assigned',0),(605900,19722,'en','Not Complete',0),(605901,19755,'en','No Card On File',0),(605902,19735,'en','Old Price',0),(605903,19736,'en','Old Profit Margin',0),(605904,19759,'en','Order Line Item Lookup',0),(605905,19742,'en','Over Or Equal To',0),(605906,19713,'en','Password Reset',0),(605907,19771,'en','Payment Must Be Greater Than Zero',0),(605908,19704,'en','Please Check Your Email For Instructions On How To Complete Your Password Reset',0),(605909,19705,'en','Please Check Your Email For New Password',0),(605910,19702,'en','Print Selected Invoices',0),(605911,19703,'en','Print Selected PODs',0),(605912,19773,'en','Sales Account Total',0),(605913,19716,'en','Sales Only',0),(605914,19738,'en','Sales Over - 20 Days',0),(605915,19767,'en','Sends Notice Of Price Changes To Price List Entry User',0),(605916,19706,'en','Send Reset Email',0),(605917,19793,'en','Separate Orders',0),(605918,19774,'en','Show Cost Account Total',0),(605919,19775,'en','Show Sales Account Total',0),(605920,19760,'en','Show Under Additional Options',0),(605921,19761,'en','Show Warning When Saving A Line With Zero Price',0),(605922,19762,'en','Show Warning When Saving A Line With Zero Qty',0),(605923,19737,'en','Special Pricing Changed By',0),(605924,19763,'en','Special Sales Pricing Method',0),(605925,19714,'en','Temporary Password',0),(605926,19717,'en','This Invoice Date Will Be Set On All Generated Invoices',0),(605927,19794,'en','This Quote Has Both Rental And Non-Rental Items',0),(605928,19776,'en','This Shipment Puts The Job Over The Non-Prelimable Credit Limit',0),(605929,19777,'en','This Shipment Puts The Job Over The Prelimable Credit Limit',0),(605930,19727,'en','Transferred In',0),(605931,19728,'en','Transferred Out',0),(605932,19723,'en','Unassigned Entries',0),(605933,19796,'en','Unbalanced Entry Set',0),(605934,19743,'en','Under Or Equal To',0),(605935,19764,'en','Use Paginated Item Lookup Layout',0),(605936,19707,'en','Your Password Has Been Reset Successfully',0),(605937,19715,'en','You Recently Requested To Reset Your Password For Your Account',0),(605938,19797,'en','Cannot Save When Unassigned Entries Exist',0),(605939,19798,'en','Transferred In',0),(605940,19799,'en','Transferred Out',0),(605941,19806,'en','Added Missing Records',0),(605942,19869,'en','Address 1',0),(605943,19870,'en','Address 2',0),(605944,19856,'en','Add/Edit Shipping Routes',0),(605945,19824,'en','Applies To All Locations',0),(605946,19832,'en','Applies To Order Entry And POS',0),(605947,19841,'en','Based On Rental Price',0),(605948,19833,'en','Block Email Edits For 3dcart Customers',0),(605949,19837,'en','Block Outdated Tax Selection',0),(605950,19838,'en','Block When Newer Tax Exists With Same Name',0),(605951,19839,'en','Block When Newer Tax Exists With Same Name Or Same City, State And County',0),(605952,19819,'en','Cached On Hand Difference',0),(605953,19807,'en','Cannot Add Items To Completed Count',0),(605954,19860,'en','Cannot Create Customer Pickup Sale For Delivery Only Customer',0),(605955,19861,'en','Cannot Create POS Sale For Delivery Only Customer',0),(605956,19853,'en','Cannot Use Value',0),(605957,19857,'en','Can Edit Min Max When Not Allowed To Edit Item',0),(605958,19859,'en','City, State, Zip Required',0),(605959,19801,'en','Click Here To Verify Email Address',0),(605960,19867,'en','Coach',0),(605961,19864,'en','Converted',0),(605962,19865,'en','Converted By',0),(605963,19820,'en','Cost Difference',0),(605964,19828,'en','Credit Card Denied',0),(605965,19829,'en','Credit Card Error',0),(605966,19830,'en','Credit Card Processing Error',0),(605967,19871,'en','Deleted By User',0),(605968,19872,'en','Deleted Date',0),(605969,19821,'en','Differences In Cached On Hand Records',0),(605970,19840,'en','Do Not Block',0),(605971,19842,'en','Do Not Create On Rent Ledger Transactions When Shipping And Receiving Inventory Types',0),(605972,19858,'en','Edit Avg Cost',0),(605973,19826,'en','Email Region Manager New/Converted Quotes',0),(605974,19808,'en','Find And Add Missing Items',0),(605975,19811,'en','First Rental Started',0),(605976,19802,'en','If you did not request this verification, please ignore this email.',0),(605977,19847,'en','Include Credit Balance Customers',0),(605978,19812,'en','Include Customer Name',0),(605979,19813,'en','Include First Rental Date',0),(605980,19814,'en','Include Number Of Months Of History',0),(605981,19815,'en','Include Order Number',0),(605982,19848,'en','Invoice AR Account Total',0),(605983,19816,'en','Item And Order',0),(605984,19843,'en','Jobs Must Have City, State, Zip Set',0),(605985,19873,'en','Job Closed By',0),(605986,19831,'en','Job Deleted',0),(605987,19874,'en','Last Changed Date',0),(605988,19817,'en','Last Received',0),(605989,19805,'en','Logging In',0),(605990,19854,'en','Minimum Order Number',0),(605991,19827,'en','Min Quote Amount For Email',0),(605992,19852,'en','Monthly Sales Avg Last 12',0),(605993,19809,'en','No Missing Records Found',0),(605994,19810,'en','Physical Counts Only',0),(605995,19800,'en','Please Check Your Email To Verify Login Credentials',0),(605996,19849,'en','Pmt AR Account Total',0),(605997,19855,'en','Preparing DB For Update',0),(605998,19818,'en','Qty Balance',0),(605999,19822,'en','Qty Difference',0),(606000,19823,'en','Rebuild Cache Values',0),(606001,19844,'en','Rental Cost Percentage',0),(606002,19866,'en','Sending Survey',0),(606003,19835,'en','Show CC Bills In Separate Tab',0),(606004,19850,'en','Show Invoice AR Account Total',0),(606005,19851,'en','Show Payment AR Account Total',0),(606006,19868,'en','Show Price Levels On Item Status Details Page',0),(606007,19862,'en','The Order Will Be Deleted',0),(606008,19846,'en','Transfer Variance Adjustment Type',0),(606009,19834,'en','Update 3dcart On-Order Levels Automatically',0),(606010,19845,'en','Used By',0),(606011,19825,'en','Vendor Product Code Must Be Set',0),(606012,19803,'en','Verify WordPress Login',0),(606013,19836,'en','Will Be Included In Vendor Bills Tab If Not Checked',0),(606014,19863,'en','You Have Opened An Existing Order And Chosen To Save As Point Of Sale',0),(606015,19804,'en','You Recently Tried To Access NolaPro With CompassFatLoss Credentials',0),(606016,19875,'en','You Have Opened An Existing Order And Chosen To Save As Point Of Sale',0),(606017,19876,'en','Please Check Your Email To Verify Login Credentials',0),(606018,19931,'en','Active Special Sales Pricing',0),(606019,20087,'en','Add Invoice To Payment List',0),(606020,19964,'en','Add Zip To Territory',0),(606021,20043,'en','Affects Checks Only',0),(606022,20008,'en','Allow Discounts On Credits',0),(606023,20044,'en','Allow New Payments Against Paid Complete Invoices',0),(606024,20014,'en','All Converted To Sale',0),(606025,20081,'en','All Invoices',0),(606026,20131,'en','All Item Pages Will Be Affected',0),(606027,20132,'en','Any Unsaved Changes Will Be Lost',0),(606028,20028,'en','An Error Has Occurred Booking This Appointment',0),(606029,20088,'en','Apply Payment To Oldest Invoices',0),(606030,20084,'en','Apply Write Off To Oldest Invoices',0),(606031,20122,'en','Are You Sure You Want To Save As Committed',0),(606032,20161,'en','AR Invoice Write-off',0),(606033,19885,'en','Assigned To PO',0),(606034,20036,'en','Assign Coaches To Members',0),(606035,20029,'en','Assign Membership Coaches',0),(606036,19965,'en','Avg Margin',0),(606037,19966,'en','Avg Profit',0),(606038,19932,'en','Avg Profit Margin',0),(606039,20095,'en','Avg Sales Qty Per Month',0),(606040,20096,'en','Avg Xfers Qty Per Month',0),(606041,19912,'en','A New Item Was Added To Count ID',0),(606042,20137,'en','A Recent Open PO Already Exists For This Item And Vendor',0),(606043,20138,'en','A Recent Open PO With Stock Items Already Exists For This Vendor',0),(606044,19888,'en','B2B User Activity',0),(606045,19889,'en','B2B User Payments',0),(606046,19878,'en','Bad Write-off',0),(606047,20045,'en','Bank Deposits Can Include Refunds',0),(606048,20046,'en','Bank Deposits Include Direct Cash Payments',0),(606049,20116,'en','Bank GL Account Not Allowed This Cost Code',0),(606050,20117,'en','Bank GL Account Not Allowed This GL Category',0),(606051,20118,'en','Bank GL Account Requires A Cost Code',0),(606052,20119,'en','Bank GL Account Requires A GL Category',0),(606053,20136,'en','Best Buy',0),(606054,20047,'en','Block POS For Customers Marked As',0),(606055,20048,'en','Block Saving Negative Quantity Sales',0),(606056,20049,'en','Block Shipment',0),(606057,20115,'en','Box Is Over Max Carrier Rate',0),(606058,19993,'en','Bullpenning Enabled',0),(606059,19894,'en','Bullpenning Invoices',0),(606060,19926,'en','Cached Value',0),(606061,19927,'en','Calculated Qty',0),(606062,19928,'en','Calculated Value',0),(606063,19913,'en','Cannot Add Items',0),(606064,19914,'en','Cannot Add Items To Location',0),(606065,20159,'en','Cannot Add Payment To Deleted Invoice',0),(606066,20160,'en','Cannot Add Payment To Deleted Order',0),(606067,20152,'en','Cannot Save Order When Qty Is Negative',0),(606068,20169,'en','Can Edit Buyer Notes',0),(606069,20080,'en','Can Only Clear Entries Already Designated For This Account Unless A Direct AR Payment',0),(606070,20050,'en','Can Select Other Customer Invoices',0),(606071,19920,'en','Change Used Serial Number',0),(606072,19943,'en','Change Used Serial Numbers',0),(606073,20035,'en','Charge Code',0),(606074,20103,'en','Click To View Order Acknowledgment',0),(606075,20167,'en','Column Text Size',0),(606076,19909,'en','Confirm As OK Keeping Sent Qty Equal To Received Qty',0),(606077,20051,'en','Convenience Fee GL Category',0),(606078,20147,'en','Cost Code Must Be Set For Misc Entry #',0),(606079,19918,'en','Cost Received Not Sent',0),(606080,20083,'en','Create Unapplied Payment',0),(606081,20139,'en','Current Line',0),(606082,19929,'en','Current Qty',0),(606083,19967,'en','Current Territory',0),(606084,20153,'en','Customer POS Blocked',0),(606085,20151,'en','Customer Role',0),(606086,20094,'en','Customer Salesperson',0),(606087,19933,'en','Customer Summary',0),(606088,20052,'en','Daily Drawer Close Creates Bank Deposit',0),(606089,20165,'en','Deactivate',0),(606090,20053,'en','Default GL Category For Rentals',0),(606091,19930,'en','Differences In Cached Item Bin Records',0),(606092,20017,'en','DNS Not Found',0),(606093,20111,'en','Do You Want To Receive This Item First?',0),(606094,19921,'en','Edit Order Serial Numbers',0),(606095,19968,'en','Edit Territory',0),(606096,20054,'en','EFT Payments Cannot Be Made Void',0),(606097,20055,'en','Email Invoices From Address',0),(606098,20056,'en','Email Order Confirmations From Address',0),(606099,20057,'en','Email Prelim Requests From Address',0),(606100,20005,'en','Email Purchase Orders From Address',0),(606101,20058,'en','Email Quotes From Address',0),(606102,20059,'en','Email Statements From Address',0),(606103,20004,'en','Email Template Must Be Set',0),(606104,20006,'en','Email Vendor Certificate Requests From Address',0),(606105,20060,'en','Enabled By Default',0),(606106,20097,'en','End Sales Date',0),(606107,20162,'en','Error Adding Write-off',0),(606108,19890,'en','Events End',0),(606109,19891,'en','Events Start',0),(606110,19994,'en','Exclude After Days',0),(606111,19999,'en','Exclude All Invoices For Customer When Customer Has Any Invoices To Be Sent',0),(606112,19998,'en','Exclude All On Last Day Of Month',0),(606113,19995,'en','Exclude Customers With Invoices Totaling Over',0),(606114,20000,'en','Exclude Delivery Types',0),(606115,19997,'en','Exclude Invoices With Total Over',0),(606116,20091,'en','Exclude Write-offs',0),(606117,19934,'en','Expiring Soon Special Sales Pricing',0),(606118,20024,'en','Express',0),(606119,20025,'en','Express Service',0),(606120,19898,'en','Faxes',0),(606121,20010,'en','Fax Failed',0),(606122,20140,'en','For Order Line',0),(606123,19899,'en','Freight Burden',0),(606124,19900,'en','From Location Available Will Go Negative If Marked',0),(606125,20148,'en','GL Category Must Be Set For Misc Entry #',0),(606126,20079,'en','GL Entries To AP From The AP Module But GL Entry Manually Deleted',0),(606127,20012,'en','Group Rights',0),(606128,20171,'en','Header Notes',0),(606129,20061,'en','Hide Aging On Statement',0),(606130,20062,'en','Hide Job Name',0),(606131,20170,'en','If User Is Not A Buyer',0),(606132,19935,'en','Include Expired',0),(606133,19901,'en','Include Unprinted',0),(606134,20133,'en','Increase All By Percent',0),(606135,20134,'en','Increase Prices By',0),(606136,20126,'en','Internal Buy Notes',0),(606137,20018,'en','Invalid Email Address',0),(606138,20104,'en','Inventory On Open Orders For',0),(606139,20105,'en','Inventory On Open Quotes For',0),(606140,20089,'en','Invoice Already Listed',0),(606141,19892,'en','Invoice Count',0),(606142,19880,'en','Invoice Document',0),(606143,20085,'en','Invoice Write-off Added Successfully',0),(606144,20030,'en','Is Ready For Maintenance Plan',0),(606145,20127,'en','Is This Item Hazardous Material?',0),(606146,20099,'en','Item Report Of Profit Percent Avg',0),(606147,20100,'en','Item Report Of Profit Total',0),(606148,20101,'en','Item Report Of Qty Sold',0),(606149,20102,'en','Item Report Of Sales Total',0),(606150,20033,'en','Item Returned',0),(606151,20175,'en','Job Contact Name',0),(606152,20176,'en','Job Phone',0),(606153,20037,'en','Join Date',0),(606154,20141,'en','Keep Values As Is',0),(606155,19884,'en','Last Note User',0),(606156,19923,'en','Last Received Quantity',0),(606157,19922,'en','Line Qty',0),(606158,19915,'en','Location Count Completed',0),(606159,20163,'en','Maintenance Plan',0),(606160,20026,'en','Maintenance Plan Alert Appointment Limit',0),(606161,20027,'en','Maintenance Plan Alert Day Limit',0),(606162,19944,'en','Manage Regions',0),(606163,19955,'en','Manage Sales Regions',0),(606164,19969,'en','Manage Sales Territories',0),(606165,19902,'en','Mass Assign',0),(606166,19895,'en','Merging Pages',0),(606167,20007,'en','Mgmt Expense Fee',0),(606168,20020,'en','Missing Discount Payment',0),(606169,20021,'en','Missing Payment',0),(606170,20019,'en','MX Not Found',0),(606171,19992,'en','Never',0),(606172,20016,'en','New Customer Added',0),(606173,19883,'en','New Daily Drawer Close',0),(606174,19916,'en','New Items Were Added To Count ID',0),(606175,19956,'en','New Region',0),(606176,19970,'en','New Territory',0),(606177,19971,'en','New Zip Codes',0),(606178,20063,'en','Note Below Order Total',0),(606179,20112,'en','Not All Items Have Been Received Yet',0),(606180,19972,'en','Not Assigned A Territory',0),(606181,20123,'en','Not Committed',0),(606182,20015,'en','Not Returned',0),(606183,20064,'en','No Action',0),(606184,19973,'en','No New Zip Codes Added Yet',0),(606185,19957,'en','No Region Assigned',0),(606186,19974,'en','No Zip Set',0),(606187,20065,'en','Number Of Days To Send Before Expired',0),(606188,19924,'en','On Transfer In',0),(606189,19925,'en','On Transfer Out',0),(606190,20164,'en','Order Acknowledgment',0),(606191,19881,'en','Order Document',0),(606192,20154,'en','Over Customer Credit Limit',0),(606193,20022,'en','Over Discount Payment',0),(606194,20155,'en','Over Job Credit Limit',0),(606195,20023,'en','Over Payment',0),(606196,19919,'en','Partial',0),(606197,20038,'en','Patient',0),(606198,19887,'en','Pickup Status',0),(606199,20124,'en','Pick Completed',0),(606200,19917,'en','Please Count Before Posting',0),(606201,19975,'en','Please Select A Territory',0),(606202,20009,'en','PO Return Restock Fee',0),(606203,19936,'en','Price Sold At',0),(606204,20156,'en','Pricing Ends',0),(606205,20098,'en','Primary Vendor',0),(606206,20157,'en','Print Acknowledgment',0),(606207,20108,'en','Print Customer Inventory On Order',0),(606208,20110,'en','Print Customer Inventory On Quotes',0),(606209,20034,'en','Print Invoices Through',0),(606210,19896,'en','Print PDF',0),(606211,19937,'en','Print Without Cost And Margin',0),(606212,19938,'en','Print Without Cost And Margin And Standard Pricing',0),(606213,19945,'en','Process Queue',0),(606214,19952,'en','Process Started',0),(606215,20082,'en','Profitability',0),(606216,19897,'en','Profitability Report',0),(606217,20109,'en','Qty At DC',0),(606218,20031,'en','Ready For Maintenance Plan',0),(606219,20146,'en','Received Short',0),(606220,19976,'en','Region Code',0),(606221,19946,'en','Region Sales By Customer',0),(606222,19958,'en','Region Sales Details For',0),(606223,19947,'en','Region Sales Summary',0),(606224,19959,'en','Region Sales Summary For',0),(606225,19960,'en','Region Total',0),(606226,20113,'en','Remaining Deposit',0),(606227,19910,'en','Removed Sent Qty Transactions',0),(606228,19911,'en','Remove Sent Qty Transactions',0),(606229,20128,'en','Rental Conversion Cost Of Goods',0),(606230,20129,'en','Rental Conversion To Sales',0),(606231,19879,'en','Rental Docs',0),(606232,19882,'en','Rental Order History',0),(606233,20041,'en','Requested Margin',0),(606234,19954,'en','RSM',0),(606235,19953,'en','Run When',0),(606236,20120,'en','Sales Entries Outside Invoicing',0),(606237,19903,'en','Sales Order',0),(606238,19961,'en','Sales Region Has Been Deleted',0),(606239,19962,'en','Sales Region With This Code Already Exists',0),(606240,19893,'en','Sales Territories',0),(606241,19977,'en','Sales Territory Has Been Deleted',0),(606242,19978,'en','Sales Territory With This Code Already Exists',0),(606243,20066,'en','Save Order Entry Delay In Seconds',0),(606244,20042,'en','Search Menu',0),(606245,20142,'en','Selected Line',0),(606246,20143,'en','Selected Lines Do Not Match The Entered Line Details',0),(606247,20144,'en','Select An Order Line',0),(606248,19886,'en','Select Order Line',0),(606249,20040,'en','Select Or Transfer To Edit',0),(606250,19979,'en','Select Territory',0),(606251,20002,'en','Sends To Inventory Location Contact',0),(606252,20011,'en','Send Faxes',0),(606253,20067,'en','Send New Customer Email To Region Mgr And Territory Salesman',0),(606254,20001,'en','Send Notice When Item Added To Count',0),(606255,20068,'en','Send Special Pricing Expiring Soon Notice',0),(606256,20069,'en','Send Special Pricing Weekly Summaries',0),(606257,20003,'en','Send Transfer Notices To Entry User',0),(606258,20070,'en','Sent To Customer\\\'s Salesperson',0),(606259,19996,'en','Set As Zero To Disable',0),(606260,20071,'en','Set Customer Invoice Terms From Last Sale',0),(606261,20032,'en','Set Start Date',0),(606262,20145,'en','Set Values From Order Line',0),(606263,20072,'en','Shipping Items From Unreceived PO Action',0),(606264,20166,'en','Show Inactive Contacts',0),(606265,20092,'en','Show Only Order Deposits',0),(606266,20093,'en','Show Only Write-offs',0),(606267,20073,'en','Show Pricing On Packing Slip',0),(606268,20121,'en','Special Filtering',0),(606269,20158,'en','Special Item Pricing',0),(606270,19939,'en','Special Price List ID',0),(606271,19940,'en','Special Pricing',0),(606272,20168,'en','Special Sales Pricing Expired',0),(606273,19941,'en','Special Sales Pricing Usage',0),(606274,19904,'en','Split By Zone And Save',0),(606275,20076,'en','Split Payment',0),(606276,20077,'en','Split Payment Is Unbalanced',0),(606277,20078,'en','Split Payment Parts',0),(606278,19948,'en','Territory Account Performance',0),(606279,19949,'en','Territory Customer Sales Analysis',0),(606280,19950,'en','Territory Item Sales',0),(606281,19980,'en','Territory Item Sales For',0),(606282,19981,'en','Territory Sales For',0),(606283,19982,'en','Territory Zip Codes',0),(606284,19951,'en','This Request Is Deleted',0),(606285,19983,'en','This Salesperson',0),(606286,19963,'en','Total For Territory',0),(606287,20106,'en','Total Ordered',0),(606288,20107,'en','Total Shipped',0),(606289,19905,'en','Transfer Deleted',0),(606290,20125,'en','Transfer Must Have At Least One Item',0),(606291,19906,'en','Transfer Received',0),(606292,19907,'en','Transfer Shipped',0),(606293,20013,'en','Updated By',0),(606294,20135,'en','Updated Items',0),(606295,20039,'en','Update Was Not Successful',0),(606296,20172,'en','Use Address On Order',0),(606297,20173,'en','Use A Different Address',0),(606298,20174,'en','Use Custom Address',0),(606299,20114,'en','Value Of This Shipment',0),(606300,20149,'en','Vendor Bill Discount Total Does Not Match Payments Total',0),(606301,20150,'en','Vendor Bill Total Does Not Match Payments Total',0),(606302,20075,'en','Verify Email DNS Before Sending',0),(606303,20090,'en','Voiding EFT Payment Is Not Allowed',0),(606304,20074,'en','Warn User',0),(606305,19942,'en','Weekly Special Sales Pricing Summary',0),(606306,19990,'en','When Converting PO To AP Bill',0),(606307,19991,'en','When Receiving POs Based On Weight',0),(606308,19877,'en','Write-off',0),(606309,20086,'en','Write-off Account Must Be Set In Billing Setup Standard Accounts',0),(606310,19908,'en','Written By',0),(606311,19984,'en','Year Costs',0),(606312,19985,'en','Year Margin',0),(606313,19986,'en','Year Sales',0),(606314,20130,'en','Zero Movement Items Only',0),(606315,19987,'en','Zip Added Successfully',0),(606316,19988,'en','Zip Already Assigned To A Territory',0),(606317,19989,'en','Zip Code To Add',0),(606318,20177,'en','Bullpenning Invoices',0),(606319,20183,'en','Over Job Credit Limit',0),(606320,20182,'en','Selected Lines Do Not Match The Entered Line Details',0),(606321,20178,'en','Sends To Inventory Location Contact',0),(606322,20179,'en','Send Transfer Notices To Entry User',0),(606323,20180,'en','Shipping Items From Unreceived PO Action',0),(606324,20181,'en','Voiding EFT Payments Is Not Allowed',0),(606325,20184,'en','Show Subtotals On Checks',0),(606326,20246,'en','Add New Non-printing Price List',0),(606327,20234,'en','Adjusted Balance',0),(606328,20250,'en','Allow Negative Quantity Sales',0),(606329,20237,'en','Are You Sure You Want To Create Purchase Orders For The Selected?',0),(606330,20216,'en','At Time Of Invoicing',0),(606331,20215,'en','At Time Of Order Entry',0),(606332,20253,'en','Cannot Save Invoice As It Has Been Deleted Or Modified',0),(606333,20251,'en','Change Vendor Product Code',0),(606334,20235,'en','Compare To Last 12 Months Sales',0),(606335,20249,'en','Cost Code/GL Category Validation Disabled',0),(606336,20238,'en','Created Transfer',0),(606337,20239,'en','Create Purchase Orders For Selected',0),(606338,20240,'en','Create Transfers From DC For Selected',0),(606339,20245,'en','Delete This Non-printing Operation Size Pricing',0),(606340,20247,'en','Delete This Non-printing Price List',0),(606341,20248,'en','Disable Cost Code/GL Category Validation',0),(606342,20252,'en','Do Not Show Prices On Packing Slip',0),(606343,20221,'en','Do Not Show Pricing On Packing Slip',0),(606344,20219,'en','Duplicate',0),(606345,20218,'en','Duplicate Request',0),(606346,20222,'en','Enlarge Order Info Text On Order Confirmation',0),(606347,20223,'en','Exclude Credits From Invoice Aging',0),(606348,20213,'en','From Approved List Only',0),(606349,20187,'en','GL Sales Amount',0),(606350,20188,'en','GL Sales Amount From Canceled Invoices In Other Periods',0),(606351,20189,'en','GL Sales Amount From Invoice Editing Not Tied To Main Invoice Voucher',0),(606352,20190,'en','GL Sales Amount Not From Invoicing',0),(606353,20191,'en','GL Sales Entries From Canceled Invoices In Other Periods',0),(606354,20192,'en','GL Sales Entries From Invoice Editing Not Tied To Main Invoice Voucher',0),(606355,20193,'en','GL Sales Entries Not From Invoicing',0),(606356,20224,'en','Group Items On Order Confirmation',0),(606357,20225,'en','Hide Due Date On Payment Page',0),(606358,20207,'en','Hide Zero Balance Lines',0),(606359,20185,'en','ID End',0),(606360,20186,'en','ID Start',0),(606361,20256,'en','Import To Continue',0),(606362,20194,'en','Invoices Posted To Month',0),(606363,20226,'en','Invoice Aging Uses Which Date',0),(606364,20195,'en','Invoice May Be Posted To A Different Month Than These Entries Occurred',0),(606365,20196,'en','Invoice Non Sales Account Total',0),(606366,20197,'en','Invoice Post Date',0),(606367,20198,'en','Invoice Subtotal',0),(606368,20199,'en','Invoice Subtotal Less Non Sales',0),(606369,20214,'en','Item Invoicing Uses Accounts Set',0),(606370,20200,'en','Less',0),(606371,20201,'en','Non Sales Account Line Items',0),(606372,20255,'en','Other Vouchers For This Invoice',0),(606373,20257,'en','Press Next To Continue',0),(606374,20236,'en','Previous Year',0),(606375,20227,'en','Price History For Orders',0),(606376,20228,'en','Price History Length',0),(606377,20202,'en','Reconciliation Summary',0),(606378,20220,'en','Remove Duplicates Before Saving',0),(606379,20203,'en','Sales Reconciliation',0),(606380,20258,'en','Save To Continue',0),(606381,20241,'en','Select To Create PO',0),(606382,20242,'en','Select To Create PO Or Transfer',0),(606383,20243,'en','Select To Create Transfer',0),(606384,20244,'en','Select To Print',0),(606385,20229,'en','Show Adjusted Balance On Payment Page',0),(606386,20230,'en','Show Amount And Due Date In Bottom Left Of Footer',0),(606387,20231,'en','Show Date On Payment Page',0),(606388,20204,'en','Show/Hide Invoices',0),(606389,20205,'en','Show/Hide Transactions',0),(606390,20232,'en','Show Invoiced Prices',0),(606391,20209,'en','Show Months Of Excess Qty',0),(606392,20233,'en','Show Order Prices',0),(606393,20254,'en','System Is Busy',0),(606394,20211,'en','Transfer Titles',0),(606395,20208,'en','Transfer Titles',0),(606396,20206,'en','Updated From',0),(606397,20210,'en','Users Can Change Vendor Product Codes During PO Entry',0),(606398,20212,'en','User Can Enter Any Title',0),(606399,20217,'en','Vendor Profitability Details',0),(606400,20259,'en','No Tools Allowed On Jobs',0),(606401,20263,'en','Adjust Cost On PO When Customer Order Cost Changes',0),(606402,20262,'en','Adjust Qty On PO When Customer Order Qty Changes',0),(606403,20260,'en','Last PO Received Date',0),(606404,20261,'en','Last Transfer Received Date',0),(606405,20264,'en','Not Allowed To Uncheck Tax Boxes On Line Items',0),(606406,20265,'en','No Check Payment',0),(606407,20266,'en','No Credit Card Payment',0);
/*!40000 ALTER TABLE `langdef` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `langfield`
--

DROP TABLE IF EXISTS `langfield`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `langfield` (
  `id` int(11) NOT NULL auto_increment,
  `tablename` varchar(255) NOT NULL default '',
  `fieldname` varchar(255) NOT NULL default '',
  `recordid` int(11) NOT NULL default '0',
  `en` text,
  `de` text,
  `es` text,
  `ru` text,
  `jp` text,
  `pt` text,
  `fr` text,
  `zh` text,
  `ar` text,
  `ms` text,
  `hi` text,
  `th` text,
  `tl` text,
  `it` text,
  `sv` text,
  `el` text,
  `he` text,
  `ko` text,
  `da` text,
  `no` text,
  `fi` text,
  `nl` text,
  `ba` text,
  `si` text,
  `vi` text,
  `ur` text,
  `sr` text,
  `pl` text,
  `et` text,
  `bg` text,
  `af` text,
  `ro` text,
  `tr` text,
  `pr` text,
  `dr` text,
  PRIMARY KEY  (`id`),
  KEY `recordid` (`recordid`),
  KEY `fieldname` (`fieldname`),
  KEY `tablename` (`tablename`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `langfield`
--

LOCK TABLES `langfield` WRITE;
/*!40000 ALTER TABLE `langfield` DISABLE KEYS */;
/*!40000 ALTER TABLE `langfield` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `langmatch`
--

DROP TABLE IF EXISTS `langmatch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `langmatch` (
  `id` int(11) NOT NULL auto_increment,
  `langid` int(11) NOT NULL default '0',
  `page` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `langid` (`langid`),
  KEY `page` (`page`)
) ENGINE=MyISAM AUTO_INCREMENT=20818366 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `langmatch`
--

LOCK TABLES `langmatch` WRITE;
/*!40000 ALTER TABLE `langmatch` DISABLE KEYS */;
INSERT INTO `langmatch` VALUES (20779675,16258,'./!/application/controllers/b2buser.php'),(20806241,3432,'./nporder.php'),(20781748,3319,'./!/application/controllers/item.php'),(20781750,3360,'./!/application/controllers/item.php'),(20781749,5309,'./!/application/controllers/item.php'),(20781435,6669,'./!/application/controllers/invpo.php'),(20781432,16614,'./!/application/controllers/invcountbatch_livecount.php'),(20781431,3271,'./!/application/controllers/invcountbatch_livecount.php'),(20781430,18199,'./!/application/controllers/invcountbatch_livecount.php'),(20781429,19296,'./!/application/controllers/invcountbatch_livecount.php'),(20783078,15743,'./!/application/controllers/main.php'),(20783079,14790,'./!/application/controllers/main.php'),(20781967,19737,'./!/application/controllers/itempricespecialchange.php'),(20781964,19734,'./!/application/controllers/itempricespecialchange.php'),(20781965,19735,'./!/application/controllers/itempricespecialchange.php'),(20814507,6013,'./includes/initial_setup.php'),(20814506,3299,'./includes/initial_setup.php'),(20814505,3291,'./includes/initial_setup.php'),(20814504,3158,'./includes/initial_setup.php'),(20814503,3145,'./includes/initial_setup.php'),(20814502,2915,'./includes/initial_setup.php'),(20814501,2918,'./includes/initial_setup.php'),(20814500,2815,'./includes/initial_setup.php'),(20814499,2814,'./includes/initial_setup.php'),(20814498,2807,'./includes/initial_setup.php'),(20814497,2686,'./includes/initial_setup.php'),(20814496,2682,'./includes/initial_setup.php'),(20814495,2675,'./includes/initial_setup.php'),(20814494,2567,'./includes/initial_setup.php'),(20814493,2563,'./includes/initial_setup.php'),(20814492,2405,'./includes/initial_setup.php'),(20814491,2346,'./includes/initial_setup.php'),(20814490,2291,'./includes/initial_setup.php'),(20814489,2251,'./includes/initial_setup.php'),(20814486,2160,'./includes/initial_setup.php'),(20814487,2161,'./includes/initial_setup.php'),(20814488,2284,'./includes/initial_setup.php'),(20814421,14578,'./includes/glverifysetup_functions.php'),(20814420,19877,'./includes/glverifysetup_functions.php'),(20814419,3404,'./includes/glverifysetup_functions.php'),(20814418,3403,'./includes/glverifysetup_functions.php'),(20814417,9491,'./includes/glverifysetup_functions.php'),(20814416,3480,'./includes/glverifysetup_functions.php'),(20814415,3019,'./includes/glverifysetup_functions.php'),(20814414,2948,'./includes/glverifysetup_functions.php'),(20814413,2944,'./includes/glverifysetup_functions.php'),(20814412,2943,'./includes/glverifysetup_functions.php'),(20814411,11425,'./includes/glverifysetup_functions.php'),(20814410,15394,'./includes/glverifysetup_functions.php'),(20814409,15393,'./includes/glverifysetup_functions.php'),(20814408,2837,'./includes/glverifysetup_functions.php'),(20814407,14577,'./includes/glverifysetup_functions.php'),(20814406,5509,'./includes/glverifysetup_functions.php'),(20814405,5627,'./includes/glverifysetup_functions.php'),(20814404,2702,'./includes/glverifysetup_functions.php'),(20814403,2686,'./includes/glverifysetup_functions.php'),(20814402,5688,'./includes/glverifysetup_functions.php'),(20814401,2673,'./includes/glverifysetup_functions.php'),(20814400,2664,'./includes/glverifysetup_functions.php'),(20814399,6826,'./includes/glverifysetup_functions.php'),(20814398,6600,'./includes/glverifysetup_functions.php'),(20814397,5792,'./includes/glverifysetup_functions.php'),(20814396,2586,'./includes/glverifysetup_functions.php'),(20814395,13806,'./includes/glverifysetup_functions.php'),(20814394,14576,'./includes/glverifysetup_functions.php'),(20814393,3739,'./includes/glverifysetup_functions.php'),(20814392,16635,'./includes/glverifysetup_functions.php'),(20814391,6200,'./includes/glverifysetup_functions.php'),(20814390,2279,'./includes/glverifysetup_functions.php'),(20814389,2270,'./includes/glverifysetup_functions.php'),(20814388,5341,'./includes/glverifysetup_functions.php'),(20814387,2258,'./includes/glverifysetup_functions.php'),(20814386,2200,'./includes/glverifysetup_functions.php'),(20814385,4608,'./includes/glverifysetup_functions.php'),(20814384,14575,'./includes/glverifysetup_functions.php'),(20814383,7463,'./includes/glverifysetup_functions.php'),(20814382,1905,'./includes/glverifysetup_functions.php'),(20814381,7710,'./includes/glverifysetup_functions.php'),(20814380,1899,'./includes/glverifysetup_functions.php'),(20814379,1875,'./includes/glverifysetup_functions.php'),(20814378,1874,'./includes/glverifysetup_functions.php'),(20814377,1770,'./includes/glverifysetup_functions.php'),(20814376,6405,'./includes/glverifysetup_functions.php'),(20814375,1696,'./includes/glverifysetup_functions.php'),(20814374,4940,'./includes/glverifysetup_functions.php'),(20814373,8975,'./includes/glverifysetup_functions.php'),(20814372,1655,'./includes/glverifysetup_functions.php'),(20814371,1647,'./includes/glverifysetup_functions.php'),(20814370,16648,'./includes/glverifysetup_functions.php'),(20814369,1639,'./includes/glverifysetup_functions.php'),(20814368,1628,'./includes/glverifysetup_functions.php'),(20814367,1627,'./includes/glverifysetup_functions.php'),(20814366,16645,'./includes/glverifysetup_functions.php'),(20814365,1519,'./includes/glverifysetup_functions.php'),(20814364,1512,'./includes/glverifysetup_functions.php'),(20814363,1508,'./includes/glverifysetup_functions.php'),(20814362,1507,'./includes/glverifysetup_functions.php'),(20814361,1506,'./includes/glverifysetup_functions.php'),(20814360,1503,'./includes/glverifysetup_functions.php'),(20814359,1499,'./includes/glverifysetup_functions.php'),(20814358,3634,'./includes/glverifysetup_functions.php'),(20814357,3632,'./includes/glverifysetup_functions.php'),(20814356,1465,'./includes/glverifysetup_functions.php'),(20814355,1391,'./includes/glverifysetup_functions.php'),(20814354,1390,'./includes/glverifysetup_functions.php'),(20814353,11422,'./includes/glverifysetup_functions.php'),(20814352,1384,'./includes/glverifysetup_functions.php'),(20814351,989,'./includes/glverifysetup_functions.php'),(20814350,925,'./includes/glverifysetup_functions.php'),(20814349,896,'./includes/glverifysetup_functions.php'),(20814348,887,'./includes/glverifysetup_functions.php'),(20814347,14574,'./includes/glverifysetup_functions.php'),(20814346,5205,'./includes/glverifysetup_functions.php'),(20814345,6424,'./includes/glverifysetup_functions.php'),(20814344,13483,'./includes/glverifysetup_functions.php'),(20814343,795,'./includes/glverifysetup_functions.php'),(20814342,9115,'./includes/glverifysetup_functions.php'),(20814341,5661,'./includes/glverifysetup_functions.php'),(20814340,697,'./includes/glverifysetup_functions.php'),(20814339,9411,'./includes/glverifysetup_functions.php'),(20814338,6049,'./includes/glverifysetup_functions.php'),(20814337,638,'./includes/glverifysetup_functions.php'),(20814336,637,'./includes/glverifysetup_functions.php'),(20814335,576,'./includes/glverifysetup_functions.php'),(20814334,6449,'./includes/glverifysetup_functions.php'),(20814333,504,'./includes/glverifysetup_functions.php'),(20814332,503,'./includes/glverifysetup_functions.php'),(20814331,15892,'./includes/glverifysetup_functions.php'),(20814328,3544,'./includes/glverifysetup_functions.php'),(20814329,445,'./includes/glverifysetup_functions.php'),(20814330,6048,'./includes/glverifysetup_functions.php'),(20814324,3421,'./includes/glfunctions.php'),(20814323,2983,'./includes/glfunctions.php'),(20814322,7181,'./includes/glfunctions.php'),(20814321,2910,'./includes/glfunctions.php'),(20814320,6374,'./includes/glfunctions.php'),(20814319,2070,'./includes/glfunctions.php'),(20814318,1973,'./includes/glfunctions.php'),(20814317,1963,'./includes/glfunctions.php'),(20814316,17772,'./includes/glfunctions.php'),(20814315,16166,'./includes/glfunctions.php'),(20814314,16165,'./includes/glfunctions.php'),(20814313,6957,'./includes/glfunctions.php'),(20814312,1485,'./includes/glfunctions.php'),(20814311,1483,'./includes/glfunctions.php'),(20814310,4028,'./includes/glfunctions.php'),(20814309,1244,'./includes/glfunctions.php'),(20814308,1243,'./includes/glfunctions.php'),(20814307,8936,'./includes/glfunctions.php'),(20814306,1170,'./includes/glfunctions.php'),(20814305,1145,'./includes/glfunctions.php'),(20814304,1144,'./includes/glfunctions.php'),(20814303,1079,'./includes/glfunctions.php'),(20814302,1050,'./includes/glfunctions.php'),(20814301,1049,'./includes/glfunctions.php'),(20814300,1048,'./includes/glfunctions.php'),(20814299,5229,'./includes/glfunctions.php'),(20814298,1035,'./includes/glfunctions.php'),(20814297,944,'./includes/glfunctions.php'),(20814296,936,'./includes/glfunctions.php'),(20814295,5205,'./includes/glfunctions.php'),(20814294,15986,'./includes/glfunctions.php'),(20814293,13479,'./includes/glfunctions.php'),(20814292,573,'./includes/glfunctions.php'),(20814291,18973,'./includes/glfunctions.php'),(20814290,315,'./includes/glfunctions.php'),(20814289,202,'./includes/glfunctions.php'),(20814288,17771,'./includes/glfunctions.php'),(20814287,17770,'./includes/glfunctions.php'),(20814286,104,'./includes/glfunctions.php'),(20814285,7180,'./includes/glfunctions.php'),(20814284,39,'./includes/glfunctions.php'),(20814283,37,'./includes/glfunctions.php'),(20814282,35,'./includes/glfunctions.php'),(20814281,32,'./includes/glfunctions.php'),(20814280,9478,'./includes/glfunctions.php'),(20814279,27,'./includes/glfunctions.php'),(20814273,6523,'./includes/genuserrights.functions.php'),(20814272,8936,'./includes/genuserrights.functions.php'),(20815255,16384,'./includes/tamg.php'),(20779288,17897,'./!/application/controllers/arinvoice.php'),(20781966,19736,'./!/application/controllers/itempricespecialchange.php'),(20814833,3355,'./includes/invoicesoldshipformat.php'),(20814832,1,'./includes/invoicesoldshipformat.php'),(20815279,4015,'./includes/wizard.php'),(20784636,16745,'./!/application/views/appointments/appointment_report.php'),(20814278,26,'./includes/glfunctions.php'),(20781955,7069,'./!/application/controllers/itempricespecial.php'),(20816611,4911,'./includes/home/printing/profitability_order_month.php'),(20814451,15386,'./includes/header.php'),(20814452,15311,'./includes/header.php'),(20814453,15312,'./includes/header.php'),(20814454,17778,'./includes/header.php'),(20814271,9606,'./includes/genfunctions.php'),(20814270,3421,'./includes/genfunctions.php'),(20814269,8016,'./includes/genfunctions.php'),(20814268,3410,'./includes/genfunctions.php'),(20814267,3354,'./includes/genfunctions.php'),(20814266,19518,'./includes/genfunctions.php'),(20814265,19517,'./includes/genfunctions.php'),(20814264,8015,'./includes/genfunctions.php'),(20814263,7965,'./includes/genfunctions.php'),(20814262,9306,'./includes/genfunctions.php'),(20814261,10477,'./includes/genfunctions.php'),(20814260,18706,'./includes/genfunctions.php'),(20814259,3264,'./includes/genfunctions.php'),(20814258,13137,'./includes/genfunctions.php'),(20814257,3262,'./includes/genfunctions.php'),(20814256,17055,'./includes/genfunctions.php'),(20814255,18040,'./includes/genfunctions.php'),(20814254,3256,'./includes/genfunctions.php'),(20814253,9283,'./includes/genfunctions.php'),(20814252,14920,'./includes/genfunctions.php'),(20814251,18793,'./includes/genfunctions.php'),(20814250,8354,'./includes/genfunctions.php'),(20814249,10799,'./includes/genfunctions.php'),(20814248,3255,'./includes/genfunctions.php'),(20814247,13910,'./includes/genfunctions.php'),(20814246,15858,'./includes/genfunctions.php'),(20814245,19516,'./includes/genfunctions.php'),(20814244,8453,'./includes/genfunctions.php'),(20814243,9410,'./includes/genfunctions.php'),(20814242,13136,'./includes/genfunctions.php'),(20814241,13135,'./includes/genfunctions.php'),(20814240,13134,'./includes/genfunctions.php'),(20814239,13133,'./includes/genfunctions.php'),(20814238,13132,'./includes/genfunctions.php'),(20814237,13131,'./includes/genfunctions.php'),(20814236,7964,'./includes/genfunctions.php'),(20814235,2987,'./includes/genfunctions.php'),(20814234,2970,'./includes/genfunctions.php'),(20814233,2950,'./includes/genfunctions.php'),(20814232,2936,'./includes/genfunctions.php'),(20814231,9175,'./includes/genfunctions.php'),(20814230,15385,'./includes/genfunctions.php'),(20814229,19868,'./includes/genfunctions.php'),(20814228,18326,'./includes/genfunctions.php'),(20814227,16896,'./includes/genfunctions.php'),(20814226,17871,'./includes/genfunctions.php'),(20814225,11890,'./includes/genfunctions.php'),(20814224,8329,'./includes/genfunctions.php'),(20814223,2847,'./includes/genfunctions.php'),(20814222,2805,'./includes/genfunctions.php'),(20814221,6540,'./includes/genfunctions.php'),(20814220,16708,'./includes/genfunctions.php'),(20814219,16707,'./includes/genfunctions.php'),(20814218,8633,'./includes/genfunctions.php'),(20814217,13130,'./includes/genfunctions.php'),(20814216,13129,'./includes/genfunctions.php'),(20814215,13128,'./includes/genfunctions.php'),(20814214,2581,'./includes/genfunctions.php'),(20814213,11403,'./includes/genfunctions.php'),(20814212,10747,'./includes/genfunctions.php'),(20814211,15857,'./includes/genfunctions.php'),(20814210,2401,'./includes/genfunctions.php'),(20814209,10476,'./includes/genfunctions.php'),(20814208,9174,'./includes/genfunctions.php'),(20814207,2376,'./includes/genfunctions.php'),(20814206,9612,'./includes/genfunctions.php'),(20814205,2270,'./includes/genfunctions.php'),(20814204,14531,'./includes/genfunctions.php'),(20814203,17632,'./includes/genfunctions.php'),(20814202,14629,'./includes/genfunctions.php'),(20814201,2236,'./includes/genfunctions.php'),(20814200,14628,'./includes/genfunctions.php'),(20814199,2235,'./includes/genfunctions.php'),(20814198,2237,'./includes/genfunctions.php'),(20814197,2234,'./includes/genfunctions.php'),(20814196,16671,'./includes/genfunctions.php'),(20814195,13127,'./includes/genfunctions.php'),(20814194,13126,'./includes/genfunctions.php'),(20814193,13125,'./includes/genfunctions.php'),(20814192,7960,'./includes/genfunctions.php'),(20814191,8757,'./includes/genfunctions.php'),(20814190,2160,'./includes/genfunctions.php'),(20814189,8328,'./includes/genfunctions.php'),(20814188,18831,'./includes/genfunctions.php'),(20814187,17631,'./includes/genfunctions.php'),(20814186,8014,'./includes/genfunctions.php'),(20814185,14626,'./includes/genfunctions.php'),(20814184,14625,'./includes/genfunctions.php'),(20814183,14624,'./includes/genfunctions.php'),(20814182,14623,'./includes/genfunctions.php'),(20814181,8327,'./includes/genfunctions.php'),(20814180,1974,'./includes/genfunctions.php'),(20814179,9282,'./includes/genfunctions.php'),(20814178,14575,'./includes/genfunctions.php'),(20814177,16669,'./includes/genfunctions.php'),(20814176,2070,'./includes/genfunctions.php'),(20814175,1973,'./includes/genfunctions.php'),(20814174,13124,'./includes/genfunctions.php'),(20814173,13123,'./includes/genfunctions.php'),(20814172,1965,'./includes/genfunctions.php'),(20814171,1963,'./includes/genfunctions.php'),(20814170,7899,'./includes/genfunctions.php'),(20814169,1935,'./includes/genfunctions.php'),(20814168,1912,'./includes/genfunctions.php'),(20814167,1911,'./includes/genfunctions.php'),(20814166,18609,'./includes/genfunctions.php'),(20814165,19700,'./includes/genfunctions.php'),(20814164,18705,'./includes/genfunctions.php'),(20814163,18704,'./includes/genfunctions.php'),(20814162,1815,'./includes/genfunctions.php'),(20814161,11426,'./includes/genfunctions.php'),(20814160,18039,'./includes/genfunctions.php'),(20814159,1758,'./includes/genfunctions.php'),(20814158,1752,'./includes/genfunctions.php'),(20814157,13122,'./includes/genfunctions.php'),(20814156,13121,'./includes/genfunctions.php'),(20814155,13120,'./includes/genfunctions.php'),(20814154,1647,'./includes/genfunctions.php'),(20814153,1639,'./includes/genfunctions.php'),(20814152,20170,'./includes/genfunctions.php'),(20814151,9488,'./includes/genfunctions.php'),(20814150,8012,'./includes/genfunctions.php'),(20814149,18792,'./includes/genfunctions.php'),(20814148,17630,'./includes/genfunctions.php'),(20814147,17216,'./includes/genfunctions.php'),(20814146,16399,'./includes/genfunctions.php'),(20814145,19515,'./includes/genfunctions.php'),(20814144,12179,'./includes/genfunctions.php'),(20814143,8632,'./includes/genfunctions.php'),(20814142,1482,'./includes/genfunctions.php'),(20814141,14024,'./includes/genfunctions.php'),(20814140,1476,'./includes/genfunctions.php'),(20814139,7705,'./includes/genfunctions.php'),(20814138,18703,'./includes/genfunctions.php'),(20814137,8011,'./includes/genfunctions.php'),(20814136,1429,'./includes/genfunctions.php'),(20814135,1386,'./includes/genfunctions.php'),(20814134,1373,'./includes/genfunctions.php'),(20814133,7954,'./includes/genfunctions.php'),(20814132,5072,'./includes/genfunctions.php'),(20814131,18796,'./includes/genfunctions.php'),(20814130,1339,'./includes/genfunctions.php'),(20814129,1321,'./includes/genfunctions.php'),(20814128,1320,'./includes/genfunctions.php'),(20814127,6539,'./includes/genfunctions.php'),(20814126,1258,'./includes/genfunctions.php'),(20814108,18349,'./includes/genfunctions.php'),(20814109,7841,'./includes/genfunctions.php'),(20814110,16296,'./includes/genfunctions.php'),(20814111,18038,'./includes/genfunctions.php'),(20814112,16398,'./includes/genfunctions.php'),(20814113,981,'./includes/genfunctions.php'),(20814114,14113,'./includes/genfunctions.php'),(20814115,18830,'./includes/genfunctions.php'),(20814116,18873,'./includes/genfunctions.php'),(20814117,989,'./includes/genfunctions.php'),(20814118,16297,'./includes/genfunctions.php'),(20814119,1066,'./includes/genfunctions.php'),(20814120,1067,'./includes/genfunctions.php'),(20814121,1127,'./includes/genfunctions.php'),(20814122,1128,'./includes/genfunctions.php'),(20814123,1157,'./includes/genfunctions.php'),(20814124,1207,'./includes/genfunctions.php'),(20814125,8936,'./includes/genfunctions.php'),(20814011,3431,'./includes/functions.php'),(20814010,8045,'./includes/functions.php'),(20814009,8044,'./includes/functions.php'),(20814008,5130,'./includes/functions.php'),(20814007,11051,'./includes/functions.php'),(20814006,8971,'./includes/functions.php'),(20814005,3421,'./includes/functions.php'),(20814004,5310,'./includes/functions.php'),(20814003,3415,'./includes/functions.php'),(20814002,3414,'./includes/functions.php'),(20814001,19877,'./includes/functions.php'),(20814000,3410,'./includes/functions.php'),(20813999,18969,'./includes/functions.php'),(20813998,10948,'./includes/functions.php'),(20813997,9090,'./includes/functions.php'),(20813996,5309,'./includes/functions.php'),(20813995,3358,'./includes/functions.php'),(20813994,15352,'./includes/functions.php'),(20813993,17425,'./includes/functions.php'),(20813992,3297,'./includes/functions.php'),(20813991,3295,'./includes/functions.php'),(20813990,3292,'./includes/functions.php'),(20813989,15932,'./includes/functions.php'),(20813988,15931,'./includes/functions.php'),(20813987,3278,'./includes/functions.php'),(20813986,6141,'./includes/functions.php'),(20813985,3274,'./includes/functions.php'),(20813984,19464,'./includes/functions.php'),(20813983,9642,'./includes/functions.php'),(20813982,3172,'./includes/functions.php'),(20813981,14667,'./includes/functions.php'),(20813980,3154,'./includes/functions.php'),(20813979,3153,'./includes/functions.php'),(20813978,3152,'./includes/functions.php'),(20813977,12830,'./includes/functions.php'),(20813976,18876,'./includes/functions.php'),(20813975,16895,'./includes/functions.php'),(20813974,3126,'./includes/functions.php'),(20813973,3090,'./includes/functions.php'),(20813972,3072,'./includes/functions.php'),(20813971,3063,'./includes/functions.php'),(20813970,3062,'./includes/functions.php'),(20813969,13053,'./includes/functions.php'),(20813968,3050,'./includes/functions.php'),(20813967,3049,'./includes/functions.php'),(20813966,14139,'./includes/functions.php'),(20813965,10887,'./includes/functions.php'),(20813964,3033,'./includes/functions.php'),(20813963,2998,'./includes/functions.php'),(20813962,6384,'./includes/functions.php'),(20813961,19158,'./includes/functions.php'),(20813960,2987,'./includes/functions.php'),(20813959,10884,'./includes/functions.php'),(20813958,16676,'./includes/functions.php'),(20813957,14529,'./includes/functions.php'),(20813956,14528,'./includes/functions.php'),(20813955,14527,'./includes/functions.php'),(20813954,8222,'./includes/functions.php'),(20813953,6257,'./includes/functions.php'),(20813952,2936,'./includes/functions.php'),(20813951,16265,'./includes/functions.php'),(20813950,20168,'./includes/functions.php'),(20813949,2886,'./includes/functions.php'),(20813948,2885,'./includes/functions.php'),(20813947,2884,'./includes/functions.php'),(20813946,2883,'./includes/functions.php'),(20813945,2859,'./includes/functions.php'),(20813944,2847,'./includes/functions.php'),(20813943,2846,'./includes/functions.php'),(20813942,14138,'./includes/functions.php'),(20813941,2827,'./includes/functions.php'),(20813940,2810,'./includes/functions.php'),(20813939,2809,'./includes/functions.php'),(20813938,2808,'./includes/functions.php'),(20813937,2805,'./includes/functions.php'),(20813936,2798,'./includes/functions.php'),(20813935,9586,'./includes/functions.php'),(20813934,9585,'./includes/functions.php'),(20813933,9089,'./includes/functions.php'),(20813932,10947,'./includes/functions.php'),(20813931,9584,'./includes/functions.php'),(20813930,9241,'./includes/functions.php'),(20813929,2782,'./includes/functions.php'),(20813928,2751,'./includes/functions.php'),(20813927,14403,'./includes/functions.php'),(20813926,5449,'./includes/functions.php'),(20813925,19157,'./includes/functions.php'),(20813924,2701,'./includes/functions.php'),(20813923,2620,'./includes/functions.php'),(20813922,15594,'./includes/functions.php'),(20813921,5689,'./includes/functions.php'),(20813920,14655,'./includes/functions.php'),(20813919,2588,'./includes/functions.php'),(20813918,2591,'./includes/functions.php'),(20813917,2589,'./includes/functions.php'),(20813916,2581,'./includes/functions.php'),(20813915,13985,'./includes/functions.php'),(20813914,5849,'./includes/functions.php'),(20813913,2561,'./includes/functions.php'),(20813912,13984,'./includes/functions.php'),(20813911,13983,'./includes/functions.php'),(20813910,13982,'./includes/functions.php'),(20813909,13981,'./includes/functions.php'),(20813908,13980,'./includes/functions.php'),(20813907,13979,'./includes/functions.php'),(20813906,4877,'./includes/functions.php'),(20813905,2540,'./includes/functions.php'),(20813904,14823,'./includes/functions.php'),(20813903,15321,'./includes/functions.php'),(20813902,2531,'./includes/functions.php'),(20813901,2529,'./includes/functions.php'),(20813900,6427,'./includes/functions.php'),(20813899,3522,'./includes/functions.php'),(20813898,18871,'./includes/functions.php'),(20813897,2501,'./includes/functions.php'),(20813896,12823,'./includes/functions.php'),(20813895,4095,'./includes/functions.php'),(20813894,20156,'./includes/functions.php'),(20813893,2405,'./includes/functions.php'),(20813892,13933,'./includes/functions.php'),(20813891,2455,'./includes/functions.php'),(20813890,5085,'./includes/functions.php'),(20813889,2404,'./includes/functions.php'),(20813888,15593,'./includes/functions.php'),(20813887,17769,'./includes/functions.php'),(20813886,2363,'./includes/functions.php'),(20813885,9171,'./includes/functions.php'),(20813884,9170,'./includes/functions.php'),(20813883,11050,'./includes/functions.php'),(20813882,16361,'./includes/functions.php'),(20813881,9638,'./includes/functions.php'),(20813880,2332,'./includes/functions.php'),(20813879,12968,'./includes/functions.php'),(20813878,2321,'./includes/functions.php'),(20813877,2292,'./includes/functions.php'),(20813642,14629,'./includes/form_validator_js.php'),(20813641,14628,'./includes/form_validator_js.php'),(20813640,14626,'./includes/form_validator_js.php'),(20813639,14625,'./includes/form_validator_js.php'),(20815254,3432,'./includes/tamg.php'),(20813635,12779,'./includes/footer.php'),(20813634,5070,'./includes/footer.php'),(20813633,11442,'./includes/footer.php'),(20813632,12677,'./includes/footer.php'),(20813618,11874,'./includes/footer.php'),(20813619,13334,'./includes/footer.php'),(20813620,11928,'./includes/footer.php'),(20813621,8597,'./includes/footer.php'),(20813622,11879,'./includes/footer.php'),(20813623,17867,'./includes/footer.php'),(20813624,16360,'./includes/footer.php'),(20813625,2459,'./includes/footer.php'),(20813626,17860,'./includes/footer.php'),(20813627,11886,'./includes/footer.php'),(20813628,12678,'./includes/footer.php'),(20813629,15531,'./includes/footer.php'),(20813599,6174,'./includes/filesystemdb.php'),(20813598,19463,'./includes/filesystemdb.php'),(20813597,6173,'./includes/filesystemdb.php'),(20813596,17071,'./includes/filesystemdb.php'),(20813595,9083,'./includes/filesystemdb.php'),(20813594,9082,'./includes/filesystemdb.php'),(20813593,3252,'./includes/filesystemdb.php'),(20813592,6176,'./includes/filesystemdb.php'),(20813591,17436,'./includes/filesystemdb.php'),(20813590,17435,'./includes/filesystemdb.php'),(20813589,17434,'./includes/filesystemdb.php'),(20813588,10553,'./includes/filesystemdb.php'),(20813587,18884,'./includes/filesystemdb.php'),(20813586,19158,'./includes/filesystemdb.php'),(20813585,9245,'./includes/filesystemdb.php'),(20813584,16418,'./includes/filesystemdb.php'),(20813583,2886,'./includes/filesystemdb.php'),(20813582,18321,'./includes/filesystemdb.php'),(20813581,16113,'./includes/filesystemdb.php'),(20813580,18883,'./includes/filesystemdb.php'),(20813579,2702,'./includes/filesystemdb.php'),(20813578,9081,'./includes/filesystemdb.php'),(20813577,18882,'./includes/filesystemdb.php'),(20813576,17403,'./includes/filesystemdb.php'),(20813575,9080,'./includes/filesystemdb.php'),(20813574,11559,'./includes/filesystemdb.php'),(20813573,15591,'./includes/filesystemdb.php'),(20813572,19699,'./includes/filesystemdb.php'),(20813571,9079,'./includes/filesystemdb.php'),(20813570,17401,'./includes/filesystemdb.php'),(20813569,2165,'./includes/filesystemdb.php'),(20813568,13142,'./includes/filesystemdb.php'),(20813567,6172,'./includes/filesystemdb.php'),(20813566,2103,'./includes/filesystemdb.php'),(20813565,2070,'./includes/filesystemdb.php'),(20813564,8551,'./includes/filesystemdb.php'),(20813563,11006,'./includes/filesystemdb.php'),(20813562,6171,'./includes/filesystemdb.php'),(20813561,9783,'./includes/filesystemdb.php'),(20813560,10906,'./includes/filesystemdb.php'),(20813559,15855,'./includes/filesystemdb.php'),(20813558,11005,'./includes/filesystemdb.php'),(20813557,9078,'./includes/filesystemdb.php'),(20813556,17400,'./includes/filesystemdb.php'),(20813555,9077,'./includes/filesystemdb.php'),(20813554,9076,'./includes/filesystemdb.php'),(20813553,9075,'./includes/filesystemdb.php'),(20813552,7972,'./includes/filesystemdb.php'),(20813551,9074,'./includes/filesystemdb.php'),(20813550,9073,'./includes/filesystemdb.php'),(20813549,9072,'./includes/filesystemdb.php'),(20813548,9071,'./includes/filesystemdb.php'),(20813547,11558,'./includes/filesystemdb.php'),(20813546,6170,'./includes/filesystemdb.php'),(20813545,6169,'./includes/filesystemdb.php'),(20813544,6168,'./includes/filesystemdb.php'),(20813543,9070,'./includes/filesystemdb.php'),(20813542,6167,'./includes/filesystemdb.php'),(20813508,2102,'./includes/filebrowser.php'),(20813864,16671,'./includes/functions.php'),(20813865,4023,'./includes/functions.php'),(20813866,2234,'./includes/functions.php'),(20813867,7772,'./includes/functions.php'),(20813868,2258,'./includes/functions.php'),(20813869,8912,'./includes/functions.php'),(20813870,5366,'./includes/functions.php'),(20813871,15928,'./includes/functions.php'),(20813872,2260,'./includes/functions.php'),(20813873,15929,'./includes/functions.php'),(20813874,15930,'./includes/functions.php'),(20813875,5866,'./includes/functions.php'),(20813876,2270,'./includes/functions.php'),(20814834,3432,'./includes/invoicesoldshipformat.php'),(20814756,11410,'./includes/invfunctions.php'),(20814757,18329,'./includes/invfunctions.php'),(20814758,3292,'./includes/invfunctions.php'),(20814759,7570,'./includes/invfunctions.php'),(20814760,18712,'./includes/invfunctions.php'),(20814761,3354,'./includes/invfunctions.php'),(20814762,3362,'./includes/invfunctions.php'),(20814763,3365,'./includes/invfunctions.php'),(20814764,3373,'./includes/invfunctions.php'),(20814765,3394,'./includes/invfunctions.php'),(20814766,13833,'./includes/invfunctions.php'),(20814767,13888,'./includes/invfunctions.php'),(20814768,3421,'./includes/invfunctions.php'),(20814769,3432,'./includes/invfunctions.php'),(20813507,3415,'./includes/featurepurchase.functions.php'),(20813506,3358,'./includes/featurepurchase.functions.php'),(20813505,3480,'./includes/featurepurchase.functions.php'),(20813504,3479,'./includes/featurepurchase.functions.php'),(20813503,3238,'./includes/featurepurchase.functions.php'),(20813502,4531,'./includes/featurepurchase.functions.php'),(20813501,3090,'./includes/featurepurchase.functions.php'),(20813500,15300,'./includes/featurepurchase.functions.php'),(20813499,12715,'./includes/featurepurchase.functions.php'),(20813492,4023,'./includes/featurepurchase.functions.php'),(20813493,2404,'./includes/featurepurchase.functions.php'),(20813494,12064,'./includes/featurepurchase.functions.php'),(20813495,10963,'./includes/featurepurchase.functions.php'),(20813496,3438,'./includes/featurepurchase.functions.php'),(20813497,12065,'./includes/featurepurchase.functions.php'),(20813498,2535,'./includes/featurepurchase.functions.php'),(20813456,8936,'./includes/eftcanada.php'),(20813541,6166,'./includes/filesystemdb.php'),(20814105,16295,'./includes/genfunctions.php'),(20814106,14703,'./includes/genfunctions.php'),(20814107,14704,'./includes/genfunctions.php'),(20813247,757,'./includes/dbupdate.functions.php'),(20813246,11346,'./includes/dbupdate.functions.php'),(20813245,14797,'./includes/createmenu2.inc'),(20813244,14790,'./includes/createmenu2.inc'),(20813243,15743,'./includes/createmenu2.inc'),(20813242,3891,'./includes/createmenu2.inc'),(20813241,15776,'./includes/createmenu2.inc'),(20813240,3890,'./includes/createmenu2.inc'),(20813239,7177,'./includes/createmenu2.inc'),(20813238,5696,'./includes/createmenu2.inc'),(20813237,5397,'./includes/createmenu2.inc'),(20813236,3888,'./includes/createmenu2.inc'),(20813235,3886,'./includes/createmenu2.inc'),(20813234,3885,'./includes/createmenu2.inc'),(20813233,14348,'./includes/createmenu2.inc'),(20813232,3381,'./includes/createmenu2.inc'),(20813231,11286,'./includes/createmenu2.inc'),(20813230,10740,'./includes/createmenu2.inc'),(20813229,10905,'./includes/createmenu2.inc'),(20813228,10746,'./includes/createmenu2.inc'),(20813227,7825,'./includes/createmenu2.inc'),(20813226,3402,'./includes/createmenu2.inc'),(20813225,15390,'./includes/createmenu2.inc'),(20813224,3884,'./includes/createmenu2.inc'),(20813223,3883,'./includes/createmenu2.inc'),(20813222,7949,'./includes/createmenu2.inc'),(20813221,11860,'./includes/createmenu2.inc'),(20813220,3882,'./includes/createmenu2.inc'),(20813219,3881,'./includes/createmenu2.inc'),(20813218,5357,'./includes/createmenu2.inc'),(20813217,5356,'./includes/createmenu2.inc'),(20813216,8318,'./includes/createmenu2.inc'),(20813215,3879,'./includes/createmenu2.inc'),(20813214,3877,'./includes/createmenu2.inc'),(20813213,3878,'./includes/createmenu2.inc'),(20813212,11897,'./includes/createmenu2.inc'),(20813211,3876,'./includes/createmenu2.inc'),(20813210,3871,'./includes/createmenu2.inc'),(20813209,3870,'./includes/createmenu2.inc'),(20813208,5563,'./includes/createmenu2.inc'),(20813207,7948,'./includes/createmenu2.inc'),(20813206,9468,'./includes/createmenu2.inc'),(20813205,14569,'./includes/createmenu2.inc'),(20813204,9464,'./includes/createmenu2.inc'),(20813203,8901,'./includes/createmenu2.inc'),(20813202,3299,'./includes/createmenu2.inc'),(20813201,15384,'./includes/createmenu2.inc'),(20813200,8872,'./includes/createmenu2.inc'),(20813199,3867,'./includes/createmenu2.inc'),(20813198,3866,'./includes/createmenu2.inc'),(20813197,15704,'./includes/createmenu2.inc'),(20813196,15703,'./includes/createmenu2.inc'),(20813195,15383,'./includes/createmenu2.inc'),(20813194,7946,'./includes/createmenu2.inc'),(20813193,6404,'./includes/createmenu2.inc'),(20813192,13423,'./includes/createmenu2.inc'),(20813191,3480,'./includes/createmenu2.inc'),(20813190,3865,'./includes/createmenu2.inc'),(20813189,3271,'./includes/createmenu2.inc'),(20813188,16210,'./includes/createmenu2.inc'),(20813187,14336,'./includes/createmenu2.inc'),(20813186,13180,'./includes/createmenu2.inc'),(20813185,13219,'./includes/createmenu2.inc'),(20813184,11470,'./includes/createmenu2.inc'),(20813183,3479,'./includes/createmenu2.inc'),(20813182,7945,'./includes/createmenu2.inc'),(20813181,7944,'./includes/createmenu2.inc'),(20813180,7943,'./includes/createmenu2.inc'),(20813179,7942,'./includes/createmenu2.inc'),(20813178,7941,'./includes/createmenu2.inc'),(20813177,7940,'./includes/createmenu2.inc'),(20813176,3861,'./includes/createmenu2.inc'),(20813175,7939,'./includes/createmenu2.inc'),(20813174,14792,'./includes/createmenu2.inc'),(20813173,15963,'./includes/createmenu2.inc'),(20813172,3858,'./includes/createmenu2.inc'),(20813171,11290,'./includes/createmenu2.inc'),(20813170,10505,'./includes/createmenu2.inc'),(20813169,3859,'./includes/createmenu2.inc'),(20813168,7776,'./includes/createmenu2.inc'),(20813167,7938,'./includes/createmenu2.inc'),(20813166,13141,'./includes/createmenu2.inc'),(20813165,13100,'./includes/createmenu2.inc'),(20813164,13199,'./includes/createmenu2.inc'),(20813163,3130,'./includes/createmenu2.inc'),(20813162,4015,'./includes/createmenu2.inc'),(20813161,8449,'./includes/createmenu2.inc'),(20813160,5734,'./includes/createmenu2.inc'),(20813159,5733,'./includes/createmenu2.inc'),(20813158,3856,'./includes/createmenu2.inc'),(20813157,3855,'./includes/createmenu2.inc'),(20813156,15382,'./includes/createmenu2.inc'),(20813155,8452,'./includes/createmenu2.inc'),(20813154,8446,'./includes/createmenu2.inc'),(20813153,11442,'./includes/createmenu2.inc'),(20813152,11275,'./includes/createmenu2.inc'),(20813151,10558,'./includes/createmenu2.inc'),(20813150,13081,'./includes/createmenu2.inc'),(20813149,7937,'./includes/createmenu2.inc'),(20813148,7936,'./includes/createmenu2.inc'),(20813147,15538,'./includes/createmenu2.inc'),(20813146,14956,'./includes/createmenu2.inc'),(20813145,14954,'./includes/createmenu2.inc'),(20813144,14952,'./includes/createmenu2.inc'),(20813143,8989,'./includes/createmenu2.inc'),(20813142,14169,'./includes/createmenu2.inc'),(20813141,9236,'./includes/createmenu2.inc'),(20813140,9198,'./includes/createmenu2.inc'),(20813139,9244,'./includes/createmenu2.inc'),(20813138,12163,'./includes/createmenu2.inc'),(20813137,9462,'./includes/createmenu2.inc'),(20813136,3853,'./includes/createmenu2.inc'),(20813135,3852,'./includes/createmenu2.inc'),(20813134,3851,'./includes/createmenu2.inc'),(20813133,2985,'./includes/createmenu2.inc'),(20813132,11272,'./includes/createmenu2.inc'),(20813131,3850,'./includes/createmenu2.inc'),(20813130,4417,'./includes/createmenu2.inc'),(20813129,3849,'./includes/createmenu2.inc'),(20813128,2950,'./includes/createmenu2.inc'),(20813127,6047,'./includes/createmenu2.inc'),(20813126,12171,'./includes/createmenu2.inc'),(20813125,3847,'./includes/createmenu2.inc'),(20813124,8105,'./includes/createmenu2.inc'),(20813123,8104,'./includes/createmenu2.inc'),(20813122,3984,'./includes/createmenu2.inc'),(20813121,3846,'./includes/createmenu2.inc'),(20813120,3845,'./includes/createmenu2.inc'),(20813119,14699,'./includes/createmenu2.inc'),(20813118,3842,'./includes/createmenu2.inc'),(20813117,7645,'./includes/createmenu2.inc'),(20813116,16550,'./includes/createmenu2.inc'),(20813115,14323,'./includes/createmenu2.inc'),(20813114,11267,'./includes/createmenu2.inc'),(20813113,3839,'./includes/createmenu2.inc'),(20813112,3838,'./includes/createmenu2.inc'),(20813111,7935,'./includes/createmenu2.inc'),(20813110,14497,'./includes/createmenu2.inc'),(20813109,12172,'./includes/createmenu2.inc'),(20813108,4153,'./includes/createmenu2.inc'),(20813107,7933,'./includes/createmenu2.inc'),(20813106,7932,'./includes/createmenu2.inc'),(20813105,3818,'./includes/createmenu2.inc'),(20813104,5928,'./includes/createmenu2.inc'),(20813103,3817,'./includes/createmenu2.inc'),(20813102,9521,'./includes/createmenu2.inc'),(20813101,6609,'./includes/createmenu2.inc'),(20813100,14572,'./includes/createmenu2.inc'),(20813099,13885,'./includes/createmenu2.inc'),(20813098,3835,'./includes/createmenu2.inc'),(20813097,13968,'./includes/createmenu2.inc'),(20813096,7931,'./includes/createmenu2.inc'),(20813095,7930,'./includes/createmenu2.inc'),(20813094,14347,'./includes/createmenu2.inc'),(20813093,3833,'./includes/createmenu2.inc'),(20813092,5752,'./includes/createmenu2.inc'),(20813091,3832,'./includes/createmenu2.inc'),(20813090,3831,'./includes/createmenu2.inc'),(20813089,3830,'./includes/createmenu2.inc'),(20813088,3829,'./includes/createmenu2.inc'),(20813087,3828,'./includes/createmenu2.inc'),(20813086,5751,'./includes/createmenu2.inc'),(20813085,3827,'./includes/createmenu2.inc'),(20813084,3826,'./includes/createmenu2.inc'),(20813083,3825,'./includes/createmenu2.inc'),(20813082,7928,'./includes/createmenu2.inc'),(20813081,3823,'./includes/createmenu2.inc'),(20813080,3822,'./includes/createmenu2.inc'),(20813079,3821,'./includes/createmenu2.inc'),(20813078,3820,'./includes/createmenu2.inc'),(20813077,3819,'./includes/createmenu2.inc'),(20813076,12848,'./includes/createmenu2.inc'),(20813075,2805,'./includes/createmenu2.inc'),(20813074,5520,'./includes/createmenu2.inc'),(20813073,9528,'./includes/createmenu2.inc'),(20813072,7926,'./includes/createmenu2.inc'),(20813071,5488,'./includes/createmenu2.inc'),(20813070,7924,'./includes/createmenu2.inc'),(20813069,5518,'./includes/createmenu2.inc'),(20813068,10596,'./includes/createmenu2.inc'),(20813067,6129,'./includes/createmenu2.inc'),(20813066,2747,'./includes/createmenu2.inc'),(20813065,7175,'./includes/createmenu2.inc'),(20813064,3814,'./includes/createmenu2.inc'),(20813063,3813,'./includes/createmenu2.inc'),(20813062,5767,'./includes/createmenu2.inc'),(20813061,2696,'./includes/createmenu2.inc'),(20813060,3811,'./includes/createmenu2.inc'),(20813059,3810,'./includes/createmenu2.inc'),(20813058,3809,'./includes/createmenu2.inc'),(20813057,3812,'./includes/createmenu2.inc'),(20813056,5989,'./includes/createmenu2.inc'),(20813055,12169,'./includes/createmenu2.inc'),(20813054,15381,'./includes/createmenu2.inc'),(20813053,3807,'./includes/createmenu2.inc'),(20813052,2671,'./includes/createmenu2.inc'),(20813051,13317,'./includes/createmenu2.inc'),(20813050,7174,'./includes/createmenu2.inc'),(20813049,7173,'./includes/createmenu2.inc'),(20813048,7172,'./includes/createmenu2.inc'),(20813047,7922,'./includes/createmenu2.inc'),(20813046,3804,'./includes/createmenu2.inc'),(20813045,3803,'./includes/createmenu2.inc'),(20813044,10855,'./includes/createmenu2.inc'),(20813043,13405,'./includes/createmenu2.inc'),(20813042,11131,'./includes/createmenu2.inc'),(20813041,3800,'./includes/createmenu2.inc'),(20813040,5468,'./includes/createmenu2.inc'),(20813039,6128,'./includes/createmenu2.inc'),(20813038,6127,'./includes/createmenu2.inc'),(20813037,3799,'./includes/createmenu2.inc'),(20813036,5467,'./includes/createmenu2.inc'),(20813035,5383,'./includes/createmenu2.inc'),(20813034,15224,'./includes/createmenu2.inc'),(20813033,3798,'./includes/createmenu2.inc'),(20813032,3797,'./includes/createmenu2.inc'),(20813031,16522,'./includes/createmenu2.inc'),(20813030,11130,'./includes/createmenu2.inc'),(20813029,13884,'./includes/createmenu2.inc'),(20813028,3796,'./includes/createmenu2.inc'),(20813027,5693,'./includes/createmenu2.inc'),(20813026,3795,'./includes/createmenu2.inc'),(20813025,3794,'./includes/createmenu2.inc'),(20813024,5799,'./includes/createmenu2.inc'),(20813023,7063,'./includes/createmenu2.inc'),(20813022,3793,'./includes/createmenu2.inc'),(20813021,3792,'./includes/createmenu2.inc'),(20813020,3791,'./includes/createmenu2.inc'),(20813019,3790,'./includes/createmenu2.inc'),(20813018,10904,'./includes/createmenu2.inc'),(20813017,11557,'./includes/createmenu2.inc'),(20813016,3789,'./includes/createmenu2.inc'),(20813015,4034,'./includes/createmenu2.inc'),(20813014,3788,'./includes/createmenu2.inc'),(20813013,7921,'./includes/createmenu2.inc'),(20813012,4857,'./includes/createmenu2.inc'),(20813011,2540,'./includes/createmenu2.inc'),(20813010,13182,'./includes/createmenu2.inc'),(20813009,3784,'./includes/createmenu2.inc'),(20813008,11972,'./includes/createmenu2.inc'),(20813007,3783,'./includes/createmenu2.inc'),(20813006,15380,'./includes/createmenu2.inc'),(20813005,8754,'./includes/createmenu2.inc'),(20813004,11129,'./includes/createmenu2.inc'),(20813003,11556,'./includes/createmenu2.inc'),(20813002,10504,'./includes/createmenu2.inc'),(20813001,10492,'./includes/createmenu2.inc'),(20813000,11555,'./includes/createmenu2.inc'),(20812999,3782,'./includes/createmenu2.inc'),(20812998,3781,'./includes/createmenu2.inc'),(20812997,3780,'./includes/createmenu2.inc'),(20812996,3779,'./includes/createmenu2.inc'),(20812995,3778,'./includes/createmenu2.inc'),(20812994,12233,'./includes/createmenu2.inc'),(20812993,9826,'./includes/createmenu2.inc'),(20812992,7918,'./includes/createmenu2.inc'),(20812991,3777,'./includes/createmenu2.inc'),(20812990,3775,'./includes/createmenu2.inc'),(20812989,3774,'./includes/createmenu2.inc'),(20812988,3773,'./includes/createmenu2.inc'),(20812987,5750,'./includes/createmenu2.inc'),(20812986,4033,'./includes/createmenu2.inc'),(20812985,3770,'./includes/createmenu2.inc'),(20812984,2480,'./includes/createmenu2.inc'),(20812983,13757,'./includes/createmenu2.inc'),(20812982,5749,'./includes/createmenu2.inc'),(20812981,3768,'./includes/createmenu2.inc'),(20812980,3767,'./includes/createmenu2.inc'),(20812979,3766,'./includes/createmenu2.inc'),(20812978,3988,'./includes/createmenu2.inc'),(20812977,3765,'./includes/createmenu2.inc'),(20812976,3764,'./includes/createmenu2.inc'),(20812975,3763,'./includes/createmenu2.inc'),(20812974,3762,'./includes/createmenu2.inc'),(20812973,3760,'./includes/createmenu2.inc'),(20812972,3761,'./includes/createmenu2.inc'),(20812971,3759,'./includes/createmenu2.inc'),(20812970,3758,'./includes/createmenu2.inc'),(20812969,3757,'./includes/createmenu2.inc'),(20812968,3756,'./includes/createmenu2.inc'),(20812967,3755,'./includes/createmenu2.inc'),(20812966,3754,'./includes/createmenu2.inc'),(20812965,3753,'./includes/createmenu2.inc'),(20812964,3752,'./includes/createmenu2.inc'),(20812963,3751,'./includes/createmenu2.inc'),(20812962,3749,'./includes/createmenu2.inc'),(20812961,2487,'./includes/createmenu2.inc'),(20812960,3747,'./includes/createmenu2.inc'),(20812959,2415,'./includes/createmenu2.inc'),(20812958,11858,'./includes/createmenu2.inc'),(20812957,5085,'./includes/createmenu2.inc'),(20812956,3745,'./includes/createmenu2.inc'),(20812955,12847,'./includes/createmenu2.inc'),(20812954,14346,'./includes/createmenu2.inc'),(20812953,15082,'./includes/createmenu2.inc'),(20812952,7916,'./includes/createmenu2.inc'),(20812951,5343,'./includes/createmenu2.inc'),(20812950,3746,'./includes/createmenu2.inc'),(20812949,16117,'./includes/createmenu2.inc'),(20812948,10745,'./includes/createmenu2.inc'),(20812947,5494,'./includes/createmenu2.inc'),(20812946,11554,'./includes/createmenu2.inc'),(20812945,7167,'./includes/createmenu2.inc'),(20812944,8747,'./includes/createmenu2.inc'),(20812943,3742,'./includes/createmenu2.inc'),(20812942,3741,'./includes/createmenu2.inc'),(20812941,3740,'./includes/createmenu2.inc'),(20812940,3739,'./includes/createmenu2.inc'),(20812939,7166,'./includes/createmenu2.inc'),(20812938,7165,'./includes/createmenu2.inc'),(20812937,3738,'./includes/createmenu2.inc'),(20812936,4874,'./includes/createmenu2.inc'),(20812935,15192,'./includes/createmenu2.inc'),(20812934,5852,'./includes/createmenu2.inc'),(20812933,13755,'./includes/createmenu2.inc'),(20812932,3726,'./includes/createmenu2.inc'),(20812931,7812,'./includes/createmenu2.inc'),(20812930,7054,'./includes/createmenu2.inc'),(20812929,7053,'./includes/createmenu2.inc'),(20812928,7052,'./includes/createmenu2.inc'),(20812927,14993,'./includes/createmenu2.inc'),(20812926,3737,'./includes/createmenu2.inc'),(20812925,15481,'./includes/createmenu2.inc'),(20812924,3736,'./includes/createmenu2.inc'),(20812923,11823,'./includes/createmenu2.inc'),(20812922,3735,'./includes/createmenu2.inc'),(20812921,2270,'./includes/createmenu2.inc'),(20812920,3732,'./includes/createmenu2.inc'),(20812919,15379,'./includes/createmenu2.inc'),(20812918,7911,'./includes/createmenu2.inc'),(20812917,15378,'./includes/createmenu2.inc'),(20812916,3733,'./includes/createmenu2.inc'),(20812915,3731,'./includes/createmenu2.inc'),(20812914,3730,'./includes/createmenu2.inc'),(20812913,3729,'./includes/createmenu2.inc'),(20812912,3728,'./includes/createmenu2.inc'),(20812911,3727,'./includes/createmenu2.inc'),(20812910,2258,'./includes/createmenu2.inc'),(20812909,16718,'./includes/createmenu2.inc'),(20812908,3725,'./includes/createmenu2.inc'),(20812907,3722,'./includes/createmenu2.inc'),(20812906,4616,'./includes/createmenu2.inc'),(20812905,3721,'./includes/createmenu2.inc'),(20812904,3720,'./includes/createmenu2.inc'),(20812903,4317,'./includes/createmenu2.inc'),(20812902,9433,'./includes/createmenu2.inc'),(20812901,12175,'./includes/createmenu2.inc'),(20812900,3717,'./includes/createmenu2.inc'),(20812899,13318,'./includes/createmenu2.inc'),(20812898,14533,'./includes/createmenu2.inc'),(20812897,7909,'./includes/createmenu2.inc'),(20812896,6754,'./includes/createmenu2.inc'),(20812895,15377,'./includes/createmenu2.inc'),(20812894,4609,'./includes/createmenu2.inc'),(20812893,5677,'./includes/createmenu2.inc'),(20812892,7163,'./includes/createmenu2.inc'),(20812891,5672,'./includes/createmenu2.inc'),(20812890,7162,'./includes/createmenu2.inc'),(20812889,3718,'./includes/createmenu2.inc'),(20812888,7744,'./includes/createmenu2.inc'),(20812887,2200,'./includes/createmenu2.inc'),(20812886,8991,'./includes/createmenu2.inc'),(20812885,3713,'./includes/createmenu2.inc'),(20812884,3711,'./includes/createmenu2.inc'),(20812883,3710,'./includes/createmenu2.inc'),(20812882,10744,'./includes/createmenu2.inc'),(20812881,7908,'./includes/createmenu2.inc'),(20812880,13883,'./includes/createmenu2.inc'),(20812879,8362,'./includes/createmenu2.inc'),(20812878,14698,'./includes/createmenu2.inc'),(20812877,7161,'./includes/createmenu2.inc'),(20812876,10046,'./includes/createmenu2.inc'),(20812875,13829,'./includes/createmenu2.inc'),(20812874,5377,'./includes/createmenu2.inc'),(20812873,3709,'./includes/createmenu2.inc'),(20812872,1961,'./includes/createmenu2.inc'),(20812871,11857,'./includes/createmenu2.inc'),(20812870,5234,'./includes/createmenu2.inc'),(20812869,11856,'./includes/createmenu2.inc'),(20812868,15962,'./includes/createmenu2.inc'),(20812867,7907,'./includes/createmenu2.inc'),(20812866,3990,'./includes/createmenu2.inc'),(20812865,3708,'./includes/createmenu2.inc'),(20812864,3707,'./includes/createmenu2.inc'),(20812863,7906,'./includes/createmenu2.inc'),(20812862,7905,'./includes/createmenu2.inc'),(20812861,3706,'./includes/createmenu2.inc'),(20812860,11906,'./includes/createmenu2.inc'),(20812859,3705,'./includes/createmenu2.inc'),(20812858,9392,'./includes/createmenu2.inc'),(20812857,7904,'./includes/createmenu2.inc'),(20812856,7903,'./includes/createmenu2.inc'),(20812855,7902,'./includes/createmenu2.inc'),(20812854,12004,'./includes/createmenu2.inc'),(20812853,12003,'./includes/createmenu2.inc'),(20812852,11855,'./includes/createmenu2.inc'),(20812851,11854,'./includes/createmenu2.inc'),(20812850,7901,'./includes/createmenu2.inc'),(20812849,8727,'./includes/createmenu2.inc'),(20812848,1948,'./includes/createmenu2.inc'),(20812847,7899,'./includes/createmenu2.inc'),(20812846,3704,'./includes/createmenu2.inc'),(20812845,8030,'./includes/createmenu2.inc'),(20812844,5350,'./includes/createmenu2.inc'),(20812843,8588,'./includes/createmenu2.inc'),(20812842,8628,'./includes/createmenu2.inc'),(20812841,8689,'./includes/createmenu2.inc'),(20812840,8687,'./includes/createmenu2.inc'),(20812839,7561,'./includes/createmenu2.inc'),(20812838,13489,'./includes/createmenu2.inc'),(20812837,14039,'./includes/createmenu2.inc'),(20812836,5396,'./includes/createmenu2.inc'),(20812835,12685,'./includes/createmenu2.inc'),(20812834,1820,'./includes/createmenu2.inc'),(20812833,11204,'./includes/createmenu2.inc'),(20812832,11289,'./includes/createmenu2.inc'),(20812831,15866,'./includes/createmenu2.inc'),(20812830,14974,'./includes/createmenu2.inc'),(20812829,5643,'./includes/createmenu2.inc'),(20812828,11822,'./includes/createmenu2.inc'),(20812827,5642,'./includes/createmenu2.inc'),(20812826,7896,'./includes/createmenu2.inc'),(20812825,1790,'./includes/createmenu2.inc'),(20812824,8047,'./includes/createmenu2.inc'),(20812823,7973,'./includes/createmenu2.inc'),(20812822,17431,'./includes/createmenu2.inc'),(20812821,11004,'./includes/createmenu2.inc'),(20812820,10655,'./includes/createmenu2.inc'),(20812819,16189,'./includes/createmenu2.inc'),(20812818,3690,'./includes/createmenu2.inc'),(20812817,10123,'./includes/createmenu2.inc'),(20812816,3689,'./includes/createmenu2.inc'),(20812815,3688,'./includes/createmenu2.inc'),(20812814,3687,'./includes/createmenu2.inc'),(20812813,7160,'./includes/createmenu2.inc'),(20812812,7894,'./includes/createmenu2.inc'),(20812811,3686,'./includes/createmenu2.inc'),(20812810,3685,'./includes/createmenu2.inc'),(20812809,3682,'./includes/createmenu2.inc'),(20812808,3681,'./includes/createmenu2.inc'),(20812807,3680,'./includes/createmenu2.inc'),(20812806,3679,'./includes/createmenu2.inc'),(20812805,3678,'./includes/createmenu2.inc'),(20812804,8008,'./includes/createmenu2.inc'),(20812803,3677,'./includes/createmenu2.inc'),(20812802,4134,'./includes/createmenu2.inc'),(20812801,3674,'./includes/createmenu2.inc'),(20812800,12227,'./includes/createmenu2.inc'),(20812799,3673,'./includes/createmenu2.inc'),(20812798,4133,'./includes/createmenu2.inc'),(20812797,7453,'./includes/createmenu2.inc'),(20812796,4026,'./includes/createmenu2.inc'),(20812795,8326,'./includes/createmenu2.inc'),(20812794,3698,'./includes/createmenu2.inc'),(20812793,5967,'./includes/createmenu2.inc'),(20812792,3697,'./includes/createmenu2.inc'),(20812791,3696,'./includes/createmenu2.inc'),(20812790,3695,'./includes/createmenu2.inc'),(20812789,7892,'./includes/createmenu2.inc'),(20812788,3694,'./includes/createmenu2.inc'),(20812787,8113,'./includes/createmenu2.inc'),(20812786,8154,'./includes/createmenu2.inc'),(20812785,3692,'./includes/createmenu2.inc'),(20812784,6489,'./includes/createmenu2.inc'),(20812783,6523,'./includes/createmenu2.inc'),(20812782,3672,'./includes/createmenu2.inc'),(20812781,11361,'./includes/createmenu2.inc'),(20812780,11128,'./includes/createmenu2.inc'),(20812779,10503,'./includes/createmenu2.inc'),(20812778,3521,'./includes/createmenu2.inc'),(20812777,5517,'./includes/createmenu2.inc'),(20812776,3671,'./includes/createmenu2.inc'),(20812775,3670,'./includes/createmenu2.inc'),(20812774,15376,'./includes/createmenu2.inc'),(20812773,7890,'./includes/createmenu2.inc'),(20812772,15590,'./includes/createmenu2.inc'),(20812771,9390,'./includes/createmenu2.inc'),(20812770,13811,'./includes/createmenu2.inc'),(20812769,7158,'./includes/createmenu2.inc'),(20812768,8937,'./includes/createmenu2.inc'),(20812767,3668,'./includes/createmenu2.inc'),(20812766,13406,'./includes/createmenu2.inc'),(20812765,8174,'./includes/createmenu2.inc'),(20812764,3667,'./includes/createmenu2.inc'),(20812763,3666,'./includes/createmenu2.inc'),(20812762,1732,'./includes/createmenu2.inc'),(20812761,11853,'./includes/createmenu2.inc'),(20812760,10595,'./includes/createmenu2.inc'),(20812759,4381,'./includes/createmenu2.inc'),(20812758,14015,'./includes/createmenu2.inc'),(20812757,12864,'./includes/createmenu2.inc'),(20812756,9921,'./includes/createmenu2.inc'),(20812755,13597,'./includes/createmenu2.inc'),(20812754,3665,'./includes/createmenu2.inc'),(20812753,8802,'./includes/createmenu2.inc'),(20812752,6402,'./includes/createmenu2.inc'),(20812751,11852,'./includes/createmenu2.inc'),(20812750,7157,'./includes/createmenu2.inc'),(20812749,6373,'./includes/createmenu2.inc'),(20812748,3663,'./includes/createmenu2.inc'),(20812747,3662,'./includes/createmenu2.inc'),(20812746,9123,'./includes/createmenu2.inc'),(20812745,15308,'./includes/createmenu2.inc'),(20812744,7569,'./includes/createmenu2.inc'),(20812743,1702,'./includes/createmenu2.inc'),(20812742,16777,'./includes/createmenu2.inc'),(20812741,3661,'./includes/createmenu2.inc'),(20812740,9106,'./includes/createmenu2.inc'),(20812739,15619,'./includes/createmenu2.inc'),(20812738,5809,'./includes/createmenu2.inc'),(20812737,7156,'./includes/createmenu2.inc'),(20812736,3660,'./includes/createmenu2.inc'),(20812735,8251,'./includes/createmenu2.inc'),(20812734,15375,'./includes/createmenu2.inc'),(20812733,12168,'./includes/createmenu2.inc'),(20812732,8155,'./includes/createmenu2.inc'),(20812731,12893,'./includes/createmenu2.inc'),(20812730,8513,'./includes/createmenu2.inc'),(20812729,3659,'./includes/createmenu2.inc'),(20812728,12922,'./includes/createmenu2.inc'),(20812727,12877,'./includes/createmenu2.inc'),(20812726,1685,'./includes/createmenu2.inc'),(20812725,12846,'./includes/createmenu2.inc'),(20812724,10594,'./includes/createmenu2.inc'),(20812723,11238,'./includes/createmenu2.inc'),(20812722,15374,'./includes/createmenu2.inc'),(20812721,9467,'./includes/createmenu2.inc'),(20812720,4940,'./includes/createmenu2.inc'),(20812719,3658,'./includes/createmenu2.inc'),(20812718,3657,'./includes/createmenu2.inc'),(20812717,16683,'./includes/createmenu2.inc'),(20812716,7155,'./includes/createmenu2.inc'),(20812715,8940,'./includes/createmenu2.inc'),(20812714,3655,'./includes/createmenu2.inc'),(20812713,8173,'./includes/createmenu2.inc'),(20812712,3654,'./includes/createmenu2.inc'),(20812711,3653,'./includes/createmenu2.inc'),(20812710,3652,'./includes/createmenu2.inc'),(20812709,3651,'./includes/createmenu2.inc'),(20812708,3650,'./includes/createmenu2.inc'),(20812707,3649,'./includes/createmenu2.inc'),(20812706,7568,'./includes/createmenu2.inc'),(20812705,1645,'./includes/createmenu2.inc'),(20812704,11981,'./includes/createmenu2.inc'),(20812703,9281,'./includes/createmenu2.inc'),(20812702,3647,'./includes/createmenu2.inc'),(20812701,1639,'./includes/createmenu2.inc'),(20812700,12723,'./includes/createmenu2.inc'),(20812699,14550,'./includes/createmenu2.inc'),(20812698,16547,'./includes/createmenu2.inc'),(20812697,13507,'./includes/createmenu2.inc'),(20812696,14520,'./includes/createmenu2.inc'),(20812695,3986,'./includes/createmenu2.inc'),(20812694,3985,'./includes/createmenu2.inc'),(20812693,8250,'./includes/createmenu2.inc'),(20812692,7489,'./includes/createmenu2.inc'),(20812691,16090,'./includes/createmenu2.inc'),(20812690,16546,'./includes/createmenu2.inc'),(20812689,14261,'./includes/createmenu2.inc'),(20812688,14260,'./includes/createmenu2.inc'),(20812687,15081,'./includes/createmenu2.inc'),(20812686,5702,'./includes/createmenu2.inc'),(20812685,14807,'./includes/createmenu2.inc'),(20812684,11851,'./includes/createmenu2.inc'),(20812683,14241,'./includes/createmenu2.inc'),(20812682,15099,'./includes/createmenu2.inc'),(20812681,15945,'./includes/createmenu2.inc'),(20812680,16101,'./includes/createmenu2.inc'),(20812679,16313,'./includes/createmenu2.inc'),(20812678,14259,'./includes/createmenu2.inc'),(20812677,14258,'./includes/createmenu2.inc'),(20812676,7154,'./includes/createmenu2.inc'),(20812675,7153,'./includes/createmenu2.inc'),(20812674,8032,'./includes/createmenu2.inc'),(20812673,7670,'./includes/createmenu2.inc'),(20812672,13264,'./includes/createmenu2.inc'),(20812671,6070,'./includes/createmenu2.inc'),(20812670,10065,'./includes/createmenu2.inc'),(20812669,3645,'./includes/createmenu2.inc'),(20812668,14893,'./includes/createmenu2.inc'),(20812667,15961,'./includes/createmenu2.inc'),(20812666,7785,'./includes/createmenu2.inc'),(20812665,7152,'./includes/createmenu2.inc'),(20812664,16093,'./includes/createmenu2.inc'),(20812663,3643,'./includes/createmenu2.inc'),(20812662,15080,'./includes/createmenu2.inc'),(20812661,3644,'./includes/createmenu2.inc'),(20812660,6094,'./includes/createmenu2.inc'),(20812659,6093,'./includes/createmenu2.inc'),(20812658,15960,'./includes/createmenu2.inc'),(20812657,12921,'./includes/createmenu2.inc'),(20812656,12902,'./includes/createmenu2.inc'),(20812655,14760,'./includes/createmenu2.inc'),(20812654,14373,'./includes/createmenu2.inc'),(20812653,1590,'./includes/createmenu2.inc'),(20812652,12949,'./includes/createmenu2.inc'),(20812651,7889,'./includes/createmenu2.inc'),(20812650,8084,'./includes/createmenu2.inc'),(20812649,14538,'./includes/createmenu2.inc'),(20812648,8599,'./includes/createmenu2.inc'),(20812647,11982,'./includes/createmenu2.inc'),(20812646,11996,'./includes/createmenu2.inc'),(20812645,11237,'./includes/createmenu2.inc'),(20812644,14181,'./includes/createmenu2.inc'),(20812643,9910,'./includes/createmenu2.inc'),(20812642,7150,'./includes/createmenu2.inc'),(20812641,7149,'./includes/createmenu2.inc'),(20812640,15959,'./includes/createmenu2.inc'),(20812639,16359,'./includes/createmenu2.inc'),(20812638,16309,'./includes/createmenu2.inc'),(20812637,11471,'./includes/createmenu2.inc'),(20812636,3640,'./includes/createmenu2.inc'),(20812635,3639,'./includes/createmenu2.inc'),(20812634,3638,'./includes/createmenu2.inc'),(20812633,13474,'./includes/createmenu2.inc'),(20812632,3637,'./includes/createmenu2.inc'),(20812631,3636,'./includes/createmenu2.inc'),(20812630,1480,'./includes/createmenu2.inc'),(20812629,3634,'./includes/createmenu2.inc'),(20812628,3633,'./includes/createmenu2.inc'),(20812627,3632,'./includes/createmenu2.inc'),(20812626,14164,'./includes/createmenu2.inc'),(20812625,16402,'./includes/createmenu2.inc'),(20812624,16401,'./includes/createmenu2.inc'),(20812623,7887,'./includes/createmenu2.inc'),(20812622,7886,'./includes/createmenu2.inc'),(20812621,12912,'./includes/createmenu2.inc'),(20812620,16094,'./includes/createmenu2.inc'),(20812619,11786,'./includes/createmenu2.inc'),(20812618,9933,'./includes/createmenu2.inc'),(20812617,13022,'./includes/createmenu2.inc'),(20812616,3631,'./includes/createmenu2.inc'),(20812615,15118,'./includes/createmenu2.inc'),(20812614,12843,'./includes/createmenu2.inc'),(20812613,1355,'./includes/createmenu2.inc'),(20812612,9943,'./includes/createmenu2.inc'),(20812611,13454,'./includes/createmenu2.inc'),(20812610,8936,'./includes/createmenu2.inc'),(20812609,10819,'./includes/createmenu2.inc'),(20812608,11234,'./includes/createmenu2.inc'),(20812607,10551,'./includes/createmenu2.inc'),(20812606,14697,'./includes/createmenu2.inc'),(20812605,3630,'./includes/createmenu2.inc'),(20812604,13882,'./includes/createmenu2.inc'),(20812603,3629,'./includes/createmenu2.inc'),(20812602,3628,'./includes/createmenu2.inc'),(20812601,3626,'./includes/createmenu2.inc'),(20812600,8900,'./includes/createmenu2.inc'),(20812599,7885,'./includes/createmenu2.inc'),(20812598,3625,'./includes/createmenu2.inc'),(20812597,3622,'./includes/createmenu2.inc'),(20812596,3621,'./includes/createmenu2.inc'),(20812595,3620,'./includes/createmenu2.inc'),(20812594,3619,'./includes/createmenu2.inc'),(20812593,3618,'./includes/createmenu2.inc'),(20812592,8720,'./includes/createmenu2.inc'),(20812591,3615,'./includes/createmenu2.inc'),(20812590,8451,'./includes/createmenu2.inc'),(20812589,3614,'./includes/createmenu2.inc'),(20812588,7148,'./includes/createmenu2.inc'),(20812587,8450,'./includes/createmenu2.inc'),(20812586,3613,'./includes/createmenu2.inc'),(20812585,3611,'./includes/createmenu2.inc'),(20812584,3610,'./includes/createmenu2.inc'),(20812583,3609,'./includes/createmenu2.inc'),(20812582,8719,'./includes/createmenu2.inc'),(20812581,3607,'./includes/createmenu2.inc'),(20812580,3606,'./includes/createmenu2.inc'),(20812579,4132,'./includes/createmenu2.inc'),(20812578,3603,'./includes/createmenu2.inc'),(20812577,6124,'./includes/createmenu2.inc'),(20812576,3602,'./includes/createmenu2.inc'),(20812575,5516,'./includes/createmenu2.inc'),(20812574,5515,'./includes/createmenu2.inc'),(20812573,7884,'./includes/createmenu2.inc'),(20812572,7147,'./includes/createmenu2.inc'),(20812571,14047,'./includes/createmenu2.inc'),(20812570,3601,'./includes/createmenu2.inc'),(20812569,3600,'./includes/createmenu2.inc'),(20812568,7883,'./includes/createmenu2.inc'),(20812567,3597,'./includes/createmenu2.inc'),(20812566,11821,'./includes/createmenu2.inc'),(20812565,3596,'./includes/createmenu2.inc'),(20812564,3595,'./includes/createmenu2.inc'),(20812563,14197,'./includes/createmenu2.inc'),(20812562,5818,'./includes/createmenu2.inc'),(20812561,6538,'./includes/createmenu2.inc'),(20812560,5805,'./includes/createmenu2.inc'),(20812559,7882,'./includes/createmenu2.inc'),(20812558,15373,'./includes/createmenu2.inc'),(20812557,7146,'./includes/createmenu2.inc'),(20812556,3593,'./includes/createmenu2.inc'),(20812555,11840,'./includes/createmenu2.inc'),(20812554,12167,'./includes/createmenu2.inc'),(20812553,3589,'./includes/createmenu2.inc'),(20812552,15702,'./includes/createmenu2.inc'),(20812551,993,'./includes/createmenu2.inc'),(20812550,7057,'./includes/createmenu2.inc'),(20812549,12166,'./includes/createmenu2.inc'),(20812548,3467,'./includes/createmenu2.inc'),(20812547,3462,'./includes/createmenu2.inc'),(20812546,3461,'./includes/createmenu2.inc'),(20812545,14182,'./includes/createmenu2.inc'),(20812544,12020,'./includes/createmenu2.inc'),(20812543,11849,'./includes/createmenu2.inc'),(20812542,7880,'./includes/createmenu2.inc'),(20812541,11848,'./includes/createmenu2.inc'),(20812540,11974,'./includes/createmenu2.inc'),(20812539,7879,'./includes/createmenu2.inc'),(20812538,11847,'./includes/createmenu2.inc'),(20812537,7145,'./includes/createmenu2.inc'),(20812536,7878,'./includes/createmenu2.inc'),(20812535,11973,'./includes/createmenu2.inc'),(20812534,3588,'./includes/createmenu2.inc'),(20812533,7876,'./includes/createmenu2.inc'),(20812532,5060,'./includes/createmenu2.inc'),(20812531,11905,'./includes/createmenu2.inc'),(20812530,3586,'./includes/createmenu2.inc'),(20812529,6923,'./includes/createmenu2.inc'),(20812528,7875,'./includes/createmenu2.inc'),(20812527,7874,'./includes/createmenu2.inc'),(20812526,7144,'./includes/createmenu2.inc'),(20812525,7873,'./includes/createmenu2.inc'),(20812524,11976,'./includes/createmenu2.inc'),(20812523,3585,'./includes/createmenu2.inc'),(20812522,7871,'./includes/createmenu2.inc'),(20812521,7870,'./includes/createmenu2.inc'),(20812520,8717,'./includes/createmenu2.inc'),(20812519,951,'./includes/createmenu2.inc'),(20812518,7866,'./includes/createmenu2.inc'),(20812517,13613,'./includes/createmenu2.inc'),(20812516,11812,'./includes/createmenu2.inc'),(20812515,6969,'./includes/createmenu2.inc'),(20812514,13730,'./includes/createmenu2.inc'),(20812513,3581,'./includes/createmenu2.inc'),(20812512,15775,'./includes/createmenu2.inc'),(20812511,15774,'./includes/createmenu2.inc'),(20812510,7865,'./includes/createmenu2.inc'),(20812509,15873,'./includes/createmenu2.inc'),(20812508,15872,'./includes/createmenu2.inc'),(20812507,3580,'./includes/createmenu2.inc'),(20812506,7143,'./includes/createmenu2.inc'),(20812505,15389,'./includes/createmenu2.inc'),(20812504,10455,'./includes/createmenu2.inc'),(20812503,12829,'./includes/createmenu2.inc'),(20812502,12828,'./includes/createmenu2.inc'),(20812501,3579,'./includes/createmenu2.inc'),(20812500,3578,'./includes/createmenu2.inc'),(20812499,5286,'./includes/createmenu2.inc'),(20812498,12174,'./includes/createmenu2.inc'),(20812497,10625,'./includes/createmenu2.inc'),(20812496,8351,'./includes/createmenu2.inc'),(20812495,8336,'./includes/createmenu2.inc'),(20812494,8308,'./includes/createmenu2.inc'),(20812493,17467,'./includes/createmenu2.inc'),(20812492,15372,'./includes/createmenu2.inc'),(20812491,8800,'./includes/createmenu2.inc'),(20812490,5500,'./includes/createmenu2.inc'),(20812489,6755,'./includes/createmenu2.inc'),(20812488,9812,'./includes/createmenu2.inc'),(20812487,7864,'./includes/createmenu2.inc'),(20812486,7142,'./includes/createmenu2.inc'),(20812485,7141,'./includes/createmenu2.inc'),(20812484,15758,'./includes/createmenu2.inc'),(20812483,6316,'./includes/createmenu2.inc'),(20812482,16917,'./includes/createmenu2.inc'),(20812481,6317,'./includes/createmenu2.inc'),(20812480,11846,'./includes/createmenu2.inc'),(20812479,6465,'./includes/createmenu2.inc'),(20812478,3458,'./includes/createmenu2.inc'),(20812477,8441,'./includes/createmenu2.inc'),(20812476,12776,'./includes/createmenu2.inc'),(20812475,12775,'./includes/createmenu2.inc'),(20812474,14696,'./includes/createmenu2.inc'),(20812473,15757,'./includes/createmenu2.inc'),(20812472,7121,'./includes/createmenu2.inc'),(20812471,15371,'./includes/createmenu2.inc'),(20812470,8653,'./includes/createmenu2.inc'),(20812469,7863,'./includes/createmenu2.inc'),(20812468,11845,'./includes/createmenu2.inc'),(20812467,5372,'./includes/createmenu2.inc'),(20812466,7451,'./includes/createmenu2.inc'),(20812465,7623,'./includes/createmenu2.inc'),(20812464,17171,'./includes/createmenu2.inc'),(20812463,3575,'./includes/createmenu2.inc'),(20812462,7862,'./includes/createmenu2.inc'),(20812461,12804,'./includes/createmenu2.inc'),(20812460,7861,'./includes/createmenu2.inc'),(20812459,7860,'./includes/createmenu2.inc'),(20812458,3573,'./includes/createmenu2.inc'),(20812457,3572,'./includes/createmenu2.inc'),(20812456,7139,'./includes/createmenu2.inc'),(20812455,7859,'./includes/createmenu2.inc'),(20812454,3571,'./includes/createmenu2.inc'),(20812453,5346,'./includes/createmenu2.inc'),(20812452,11227,'./includes/createmenu2.inc'),(20812451,13459,'./includes/createmenu2.inc'),(20812450,11820,'./includes/createmenu2.inc'),(20812449,13729,'./includes/createmenu2.inc'),(20812448,10593,'./includes/createmenu2.inc'),(20812447,10592,'./includes/createmenu2.inc'),(20812446,11844,'./includes/createmenu2.inc'),(20812445,11843,'./includes/createmenu2.inc'),(20812444,3570,'./includes/createmenu2.inc'),(20812443,3569,'./includes/createmenu2.inc'),(20812442,3989,'./includes/createmenu2.inc'),(20812441,4601,'./includes/createmenu2.inc'),(20812440,7560,'./includes/createmenu2.inc'),(20812439,3567,'./includes/createmenu2.inc'),(20812438,3566,'./includes/createmenu2.inc'),(20812437,3565,'./includes/createmenu2.inc'),(20812436,576,'./includes/createmenu2.inc'),(20812435,7137,'./includes/createmenu2.inc'),(20812434,7136,'./includes/createmenu2.inc'),(20812433,11037,'./includes/createmenu2.inc'),(20812432,16291,'./includes/createmenu2.inc'),(20812431,5623,'./includes/createmenu2.inc'),(20812430,16116,'./includes/createmenu2.inc'),(20812429,3563,'./includes/createmenu2.inc'),(20812428,7858,'./includes/createmenu2.inc'),(20812427,14310,'./includes/createmenu2.inc'),(20812426,495,'./includes/createmenu2.inc'),(20812425,15370,'./includes/createmenu2.inc'),(20812424,513,'./includes/createmenu2.inc'),(20812423,3562,'./includes/createmenu2.inc'),(20812422,3558,'./includes/createmenu2.inc'),(20812421,3519,'./includes/createmenu2.inc'),(20812420,15864,'./includes/createmenu2.inc'),(20812419,3557,'./includes/createmenu2.inc'),(20812418,3556,'./includes/createmenu2.inc'),(20812417,8725,'./includes/createmenu2.inc'),(20812416,8777,'./includes/createmenu2.inc'),(20812415,8724,'./includes/createmenu2.inc'),(20812414,8723,'./includes/createmenu2.inc'),(20812413,6684,'./includes/createmenu2.inc'),(20812412,7135,'./includes/createmenu2.inc'),(20812411,12803,'./includes/createmenu2.inc'),(20812410,12802,'./includes/createmenu2.inc'),(20812409,12827,'./includes/createmenu2.inc'),(20812408,3551,'./includes/createmenu2.inc'),(20812407,3550,'./includes/createmenu2.inc'),(20812406,7856,'./includes/createmenu2.inc'),(20812405,3549,'./includes/createmenu2.inc'),(20812404,408,'./includes/createmenu2.inc'),(20812403,7702,'./includes/createmenu2.inc'),(20812402,12165,'./includes/createmenu2.inc'),(20812401,3548,'./includes/createmenu2.inc'),(20812400,3547,'./includes/createmenu2.inc'),(20812399,15369,'./includes/createmenu2.inc'),(20812398,4105,'./includes/createmenu2.inc'),(20812397,3987,'./includes/createmenu2.inc'),(20812396,11047,'./includes/createmenu2.inc'),(20812395,3544,'./includes/createmenu2.inc'),(20812394,3904,'./includes/createmenu2.inc'),(20812393,7854,'./includes/createmenu2.inc'),(20812392,15597,'./includes/createmenu2.inc'),(20812391,3543,'./includes/createmenu2.inc'),(20812390,6537,'./includes/createmenu2.inc'),(20812389,5817,'./includes/createmenu2.inc'),(20812388,14861,'./includes/createmenu2.inc'),(20812387,3542,'./includes/createmenu2.inc'),(20812386,11727,'./includes/createmenu2.inc'),(20812385,5899,'./includes/createmenu2.inc'),(20812384,5898,'./includes/createmenu2.inc'),(20812383,15368,'./includes/createmenu2.inc'),(20812382,11842,'./includes/createmenu2.inc'),(20812381,3541,'./includes/createmenu2.inc'),(20812380,7853,'./includes/createmenu2.inc'),(20812379,8215,'./includes/createmenu2.inc'),(20812378,5386,'./includes/createmenu2.inc'),(20812377,8127,'./includes/createmenu2.inc'),(20812376,11841,'./includes/createmenu2.inc'),(20812375,7852,'./includes/createmenu2.inc'),(20812374,6419,'./includes/createmenu2.inc'),(20812373,15216,'./includes/createmenu2.inc'),(20812372,15773,'./includes/createmenu2.inc'),(20812371,11487,'./includes/createmenu2.inc'),(20812370,8713,'./includes/createmenu2.inc'),(20812369,8065,'./includes/createmenu2.inc'),(20812368,8247,'./includes/createmenu2.inc'),(20812367,11363,'./includes/createmenu2.inc'),(20812366,10499,'./includes/createmenu2.inc'),(20812365,11798,'./includes/createmenu2.inc'),(20812364,15748,'./includes/createmenu2.inc'),(20812363,8440,'./includes/createmenu2.inc'),(20812362,8439,'./includes/createmenu2.inc'),(20812361,9842,'./includes/createmenu2.inc'),(20812360,8352,'./includes/createmenu2.inc'),(20812359,3539,'./includes/createmenu2.inc'),(20812358,3538,'./includes/createmenu2.inc'),(20812357,195,'./includes/createmenu2.inc'),(20812356,3536,'./includes/createmenu2.inc'),(20812355,3537,'./includes/createmenu2.inc'),(20812354,10696,'./includes/createmenu2.inc'),(20812353,9601,'./includes/createmenu2.inc'),(20812352,7851,'./includes/createmenu2.inc'),(20812351,3535,'./includes/createmenu2.inc'),(20812350,3533,'./includes/createmenu2.inc'),(20812349,7850,'./includes/createmenu2.inc'),(20812348,5716,'./includes/createmenu2.inc'),(20812347,3532,'./includes/createmenu2.inc'),(20812346,12080,'./includes/createmenu2.inc'),(20812324,11442,'./includes/content_top.php'),(20812323,17111,'./includes/content_top.php'),(20812322,2738,'./includes/content_top.php'),(20812321,6443,'./includes/content_top.php'),(20812320,17860,'./includes/content_top.php'),(20812319,17052,'./includes/content_top.php'),(20812318,8030,'./includes/content_top.php'),(20812317,1794,'./includes/content_top.php'),(20812316,6520,'./includes/content_top.php'),(20812311,3432,'./includes/contactinfo.php'),(20812310,2948,'./includes/contactinfo.php'),(20812309,2936,'./includes/contactinfo.php'),(20812308,20166,'./includes/contactinfo.php'),(20812307,17687,'./includes/contactinfo.php'),(20812306,17215,'./includes/contactinfo.php'),(20812305,17749,'./includes/contactinfo.php'),(20812304,19462,'./includes/contactinfo.php'),(20812303,17748,'./includes/contactinfo.php'),(20812302,6217,'./includes/contactinfo.php'),(20812301,2702,'./includes/contactinfo.php'),(20812300,14823,'./includes/contactinfo.php'),(20812299,2324,'./includes/contactinfo.php'),(20812298,6216,'./includes/contactinfo.php'),(20812297,1935,'./includes/contactinfo.php'),(20812296,4720,'./includes/contactinfo.php'),(20812295,6215,'./includes/contactinfo.php'),(20812294,1598,'./includes/contactinfo.php'),(20812293,6214,'./includes/contactinfo.php'),(20812292,1476,'./includes/contactinfo.php'),(20812291,6213,'./includes/contactinfo.php'),(20812290,8936,'./includes/contactinfo.php'),(20812289,981,'./includes/contactinfo.php'),(20812288,6212,'./includes/contactinfo.php'),(20812287,6211,'./includes/contactinfo.php'),(20812286,6210,'./includes/contactinfo.php'),(20812285,799,'./includes/contactinfo.php'),(20812284,20165,'./includes/contactinfo.php'),(20812283,659,'./includes/contactinfo.php'),(20812282,6209,'./includes/contactinfo.php'),(20812281,6208,'./includes/contactinfo.php'),(20812280,606,'./includes/contactinfo.php'),(20812279,6207,'./includes/contactinfo.php'),(20812278,6206,'./includes/contactinfo.php'),(20812264,4023,'./includes/color_functions.php'),(20812263,3409,'./includes/code_explanation.inc'),(20812262,3408,'./includes/code_explanation.inc'),(20812261,3407,'./includes/code_explanation.inc'),(20812260,3406,'./includes/code_explanation.inc'),(20812259,15124,'./includes/ckeditor.php'),(20812258,416,'./includes/ckeditor.php'),(20812257,7104,'./includes/ccpayment_manual.php'),(20812256,7103,'./includes/ccpayment_manual.php'),(20812255,7100,'./includes/ccpayment_manual.php'),(20812254,3156,'./includes/ccpayment_factory.php'),(20812253,7131,'./includes/ccpayment_factory.php'),(20812252,7130,'./includes/ccpayment_factory.php'),(20812251,7129,'./includes/ccpayment_factory.php'),(20812250,2998,'./includes/ccpayment_factory.php'),(20812249,14023,'./includes/ccpayment_factory.php'),(20812248,14078,'./includes/ccpayment_factory.php'),(20812247,13326,'./includes/ccpayment_factory.php'),(20812246,2833,'./includes/ccpayment_factory.php'),(20812245,11761,'./includes/ccpayment_factory.php'),(20812244,2751,'./includes/ccpayment_factory.php'),(20812243,2702,'./includes/ccpayment_factory.php'),(20812242,7128,'./includes/ccpayment_factory.php'),(20812241,4329,'./includes/ccpayment_factory.php'),(20812240,2324,'./includes/ccpayment_factory.php'),(20812239,7127,'./includes/ccpayment_factory.php'),(20812238,7126,'./includes/ccpayment_factory.php'),(20812237,6346,'./includes/ccpayment_factory.php'),(20812236,1758,'./includes/ccpayment_factory.php'),(20812235,14077,'./includes/ccpayment_factory.php'),(20812234,7125,'./includes/ccpayment_factory.php'),(20812233,1429,'./includes/ccpayment_factory.php'),(20812232,7124,'./includes/ccpayment_factory.php'),(20812231,7123,'./includes/ccpayment_factory.php'),(20812230,981,'./includes/ccpayment_factory.php'),(20812229,7122,'./includes/ccpayment_factory.php'),(20812228,7121,'./includes/ccpayment_factory.php'),(20812227,14081,'./includes/ccpayment_factory.php'),(20812198,13967,'./includes/ccpayment_epay.php'),(20812197,7110,'./includes/ccpayment_authorizenet.php'),(20812196,7109,'./includes/ccpayment.php'),(20812195,2702,'./includes/ccpayment.php'),(20812194,7108,'./includes/ccpayment.php'),(20812193,7107,'./includes/ccpayment.php'),(20812192,7106,'./includes/ccpayment.php'),(20812191,7972,'./includes/ccpayment.php'),(20812190,1047,'./includes/ccpayment.php'),(20812189,7105,'./includes/ccpayment.php'),(20812188,799,'./includes/ccpayment.php'),(20812187,670,'./includes/ccpayment.php'),(20812186,7104,'./includes/ccpayment.php'),(20812174,14811,'./includes/batchhelper.php'),(20812173,1770,'./includes/batchhelper.php'),(20812172,16081,'./includes/batchhelper.php'),(20812171,17323,'./includes/batchhelper.php'),(20812168,13560,'./includes/autoupdate.php'),(20812167,13557,'./includes/autoupdate.php'),(20812166,13556,'./includes/autoupdate.php'),(20812165,13555,'./includes/autoupdate.php'),(20812164,13554,'./includes/autoupdate.php'),(20812163,3134,'./includes/autoupdate.php'),(20812162,13550,'./includes/autoupdate.php'),(20812161,13549,'./includes/autoupdate.php'),(20812160,13548,'./includes/autoupdate.php'),(20812159,13547,'./includes/autoupdate.php'),(20812158,13546,'./includes/autoupdate.php'),(20812157,16721,'./includes/autoupdate.php'),(20812156,13545,'./includes/autoupdate.php'),(20812136,14070,'./includes/authorizenet_cim.php'),(20812135,8936,'./includes/authorizenet_cim.php'),(20812134,4023,'./includes/auth.functions.php'),(20812133,12841,'./includes/auth.functions.php'),(20812132,16279,'./includes/auth.functions.php'),(20812131,16390,'./includes/auth.functions.php'),(20812130,16389,'./includes/auth.functions.php'),(20812129,12840,'./includes/auth.functions.php'),(20812123,8936,'./includes/asmquote.php'),(20781963,19733,'./!/application/controllers/itempricespecialchange.php'),(20781962,19732,'./!/application/controllers/itempricespecialchange.php'),(20781961,19731,'./!/application/controllers/itempricespecialchange.php'),(20781960,1696,'./!/application/controllers/itempricespecialchange.php'),(20782229,16227,'./!/application/controllers/job.php'),(20782228,3432,'./!/application/controllers/job.php'),(20783926,3432,'./!/application/controllers/vendor.php'),(20783225,3252,'./!/application/controllers/priceoverriderequest.php'),(20784421,19746,'./!/application/models/itempricespecial_model.php'),(20784768,16960,'./!/application/views/appointments/summary.php'),(20779624,19010,'./!/application/controllers/arordership.php'),(20792080,8908,'./arcustupd.php'),(20784767,16959,'./!/application/views/appointments/summary.php'),(20784766,16745,'./!/application/views/appointments/summary.php'),(20784765,10526,'./!/application/views/appointments/summary.php'),(20784764,16716,'./!/application/views/appointments/summary.php'),(20784763,16582,'./!/application/views/appointments/summary.php'),(20785128,14648,'./!/application/views/chunks/ui_style_properties.php'),(20787734,16227,'./adminarcompanyupd.php'),(20785194,3948,'./!/application/views/customer/emailSalesmanNotice.php'),(20787732,3431,'./adminarcompanyupd.php'),(20786652,14951,'./!/application/views/task/historyrpt.php'),(20786651,3784,'./!/application/views/task/historyrpt.php'),(20786649,15221,'./!/application/views/task/historyrpt.php'),(20786650,7676,'./!/application/views/task/historyrpt.php'),(20812122,13105,'./includes/arstateviewfpdf.functions.php'),(20812057,5569,'./includes/arinvoiceviewfpdf.functions.php'),(20812056,8216,'./includes/arinvoiceviewfpdf.functions.php'),(20812055,19877,'./includes/arinvoiceviewfpdf.functions.php'),(20812054,13105,'./includes/arinvoiceviewfpdf.functions.php'),(20812053,3172,'./includes/arinvoiceviewfpdf.functions.php'),(20812052,6894,'./includes/arinvoiceviewfpdf.functions.php'),(20812051,5458,'./includes/arinvoiceviewfpdf.functions.php'),(20812050,3090,'./includes/arinvoiceviewfpdf.functions.php'),(20812049,3948,'./includes/arinvoiceviewfpdf.functions.php'),(20812048,14143,'./includes/arinvoiceviewfpdf.functions.php'),(20812047,3035,'./includes/arinvoiceviewfpdf.functions.php'),(20812046,2998,'./includes/arinvoiceviewfpdf.functions.php'),(20812045,2977,'./includes/arinvoiceviewfpdf.functions.php'),(20812044,17629,'./includes/arinvoiceviewfpdf.functions.php'),(20812043,5581,'./includes/arinvoiceviewfpdf.functions.php'),(20812042,7241,'./includes/arinvoiceviewfpdf.functions.php'),(20812041,2833,'./includes/arinvoiceviewfpdf.functions.php'),(20812040,6770,'./includes/arinvoiceviewfpdf.functions.php'),(20812039,4680,'./includes/arinvoiceviewfpdf.functions.php'),(20812038,6741,'./includes/arinvoiceviewfpdf.functions.php'),(20812037,13086,'./includes/arinvoiceviewfpdf.functions.php'),(20812036,13085,'./includes/arinvoiceviewfpdf.functions.php'),(20812035,5689,'./includes/arinvoiceviewfpdf.functions.php'),(20812034,2529,'./includes/arinvoiceviewfpdf.functions.php'),(20812033,2361,'./includes/arinvoiceviewfpdf.functions.php'),(20812032,13915,'./includes/arinvoiceviewfpdf.functions.php'),(20812031,2315,'./includes/arinvoiceviewfpdf.functions.php'),(20812030,16642,'./includes/arinvoiceviewfpdf.functions.php'),(20812029,2225,'./includes/arinvoiceviewfpdf.functions.php'),(20812028,2222,'./includes/arinvoiceviewfpdf.functions.php'),(20812027,13353,'./includes/arinvoiceviewfpdf.functions.php'),(20812026,6739,'./includes/arinvoiceviewfpdf.functions.php'),(20812025,2208,'./includes/arinvoiceviewfpdf.functions.php'),(20812024,15329,'./includes/arinvoiceviewfpdf.functions.php'),(20812023,6234,'./includes/arinvoiceviewfpdf.functions.php'),(20812022,1781,'./includes/arinvoiceviewfpdf.functions.php'),(20812021,16397,'./includes/arinvoiceviewfpdf.functions.php'),(20812020,5081,'./includes/arinvoiceviewfpdf.functions.php'),(20812019,1709,'./includes/arinvoiceviewfpdf.functions.php'),(20812018,1678,'./includes/arinvoiceviewfpdf.functions.php'),(20812017,1672,'./includes/arinvoiceviewfpdf.functions.php'),(20812016,1668,'./includes/arinvoiceviewfpdf.functions.php'),(20812015,1629,'./includes/arinvoiceviewfpdf.functions.php'),(20812014,1625,'./includes/arinvoiceviewfpdf.functions.php'),(20812013,15388,'./includes/arinvoiceviewfpdf.functions.php'),(20812012,1373,'./includes/arinvoiceviewfpdf.functions.php'),(20812011,5363,'./includes/arinvoiceviewfpdf.functions.php'),(20812010,18828,'./includes/arinvoiceviewfpdf.functions.php'),(20812009,12720,'./includes/arinvoiceviewfpdf.functions.php'),(20812008,8936,'./includes/arinvoiceviewfpdf.functions.php'),(20812007,932,'./includes/arinvoiceviewfpdf.functions.php'),(20812006,6736,'./includes/arinvoiceviewfpdf.functions.php'),(20812005,886,'./includes/arinvoiceviewfpdf.functions.php'),(20812004,869,'./includes/arinvoiceviewfpdf.functions.php'),(20812003,737,'./includes/arinvoiceviewfpdf.functions.php'),(20812002,13084,'./includes/arinvoiceviewfpdf.functions.php'),(20812001,719,'./includes/arinvoiceviewfpdf.functions.php'),(20811999,4481,'./includes/arinvoiceviewfpdf.functions.php'),(20812000,717,'./includes/arinvoiceviewfpdf.functions.php'),(20811988,12796,'./includes/arfunctions.php'),(20811987,3421,'./includes/arfunctions.php'),(20811986,19877,'./includes/arfunctions.php'),(20811985,7567,'./includes/arfunctions.php'),(20811984,3373,'./includes/arfunctions.php'),(20811983,8054,'./includes/arfunctions.php'),(20811982,3354,'./includes/arfunctions.php'),(20811981,8244,'./includes/arfunctions.php'),(20811980,8243,'./includes/arfunctions.php'),(20811979,3907,'./includes/arfunctions.php'),(20811978,15854,'./includes/arfunctions.php'),(20811977,3292,'./includes/arfunctions.php'),(20811976,3274,'./includes/arfunctions.php'),(20811975,7099,'./includes/arfunctions.php'),(20811974,15853,'./includes/arfunctions.php'),(20811973,15076,'./includes/arfunctions.php'),(20811972,14135,'./includes/arfunctions.php'),(20811971,18320,'./includes/arfunctions.php'),(20811970,3225,'./includes/arfunctions.php'),(20811969,3180,'./includes/arfunctions.php'),(20811968,3450,'./includes/arfunctions.php'),(20811967,19288,'./includes/arfunctions.php'),(20811966,3156,'./includes/arfunctions.php'),(20811965,3128,'./includes/arfunctions.php'),(20811964,3127,'./includes/arfunctions.php'),(20811963,3114,'./includes/arfunctions.php'),(20811962,3118,'./includes/arfunctions.php'),(20811961,3072,'./includes/arfunctions.php'),(20811960,15075,'./includes/arfunctions.php'),(20811959,16458,'./includes/arfunctions.php'),(20811958,18319,'./includes/arfunctions.php'),(20811957,17235,'./includes/arfunctions.php'),(20811956,3022,'./includes/arfunctions.php'),(20811955,13087,'./includes/arfunctions.php'),(20811954,3016,'./includes/arfunctions.php'),(20811953,3012,'./includes/arfunctions.php'),(20811952,3010,'./includes/arfunctions.php'),(20811951,3008,'./includes/arfunctions.php'),(20811950,3007,'./includes/arfunctions.php'),(20811949,3005,'./includes/arfunctions.php'),(20811948,7566,'./includes/arfunctions.php'),(20811947,3001,'./includes/arfunctions.php'),(20811946,18318,'./includes/arfunctions.php'),(20811945,2998,'./includes/arfunctions.php'),(20811944,8546,'./includes/arfunctions.php'),(20811943,6045,'./includes/arfunctions.php'),(20811942,3847,'./includes/arfunctions.php'),(20811941,2936,'./includes/arfunctions.php'),(20811940,19763,'./includes/arfunctions.php'),(20811939,2902,'./includes/arfunctions.php'),(20811938,2898,'./includes/arfunctions.php'),(20811937,18670,'./includes/arfunctions.php'),(20811936,15852,'./includes/arfunctions.php'),(20811935,14267,'./includes/arfunctions.php'),(20811934,2849,'./includes/arfunctions.php'),(20811933,19156,'./includes/arfunctions.php'),(20811932,2819,'./includes/arfunctions.php'),(20811931,6735,'./includes/arfunctions.php'),(20811930,2844,'./includes/arfunctions.php'),(20811929,2838,'./includes/arfunctions.php'),(20811928,2835,'./includes/arfunctions.php'),(20811927,8366,'./includes/arfunctions.php'),(20811926,2827,'./includes/arfunctions.php'),(20811925,2803,'./includes/arfunctions.php'),(20811924,17687,'./includes/arfunctions.php'),(20811923,17215,'./includes/arfunctions.php'),(20811922,16275,'./includes/arfunctions.php'),(20811921,14695,'./includes/arfunctions.php'),(20811920,19459,'./includes/arfunctions.php'),(20811919,17214,'./includes/arfunctions.php'),(20811918,11761,'./includes/arfunctions.php'),(20811917,6593,'./includes/arfunctions.php'),(20811916,7098,'./includes/arfunctions.php'),(20811915,8242,'./includes/arfunctions.php'),(20811914,8545,'./includes/arfunctions.php'),(20811913,19448,'./includes/arfunctions.php'),(20811912,2694,'./includes/arfunctions.php'),(20811911,8744,'./includes/arfunctions.php'),(20811910,2691,'./includes/arfunctions.php'),(20811909,2690,'./includes/arfunctions.php'),(20811908,2689,'./includes/arfunctions.php'),(20811907,2688,'./includes/arfunctions.php'),(20811906,2686,'./includes/arfunctions.php'),(20811905,2681,'./includes/arfunctions.php'),(20811904,2679,'./includes/arfunctions.php'),(20811903,2678,'./includes/arfunctions.php'),(20811902,2676,'./includes/arfunctions.php'),(20811901,2673,'./includes/arfunctions.php'),(20811900,3961,'./includes/arfunctions.php'),(20811899,2699,'./includes/arfunctions.php'),(20811898,19954,'./includes/arfunctions.php'),(20811897,6826,'./includes/arfunctions.php'),(20811896,2635,'./includes/arfunctions.php'),(20811895,13662,'./includes/arfunctions.php'),(20811894,14518,'./includes/arfunctions.php'),(20811893,14789,'./includes/arfunctions.php'),(20811892,17998,'./includes/arfunctions.php'),(20811891,5876,'./includes/arfunctions.php'),(20811890,2589,'./includes/arfunctions.php'),(20811889,11864,'./includes/arfunctions.php'),(20811888,2549,'./includes/arfunctions.php'),(20811887,2547,'./includes/arfunctions.php'),(20811886,2545,'./includes/arfunctions.php'),(20811885,2543,'./includes/arfunctions.php'),(20811884,2542,'./includes/arfunctions.php'),(20811883,14694,'./includes/arfunctions.php'),(20811882,4857,'./includes/arfunctions.php'),(20811881,3472,'./includes/arfunctions.php'),(20811880,2405,'./includes/arfunctions.php'),(20811879,11473,'./includes/arfunctions.php'),(20811878,15851,'./includes/arfunctions.php'),(20811877,17628,'./includes/arfunctions.php'),(20811876,15768,'./includes/arfunctions.php'),(20811875,19281,'./includes/arfunctions.php'),(20811874,16238,'./includes/arfunctions.php'),(20811873,15737,'./includes/arfunctions.php'),(20811872,2363,'./includes/arfunctions.php'),(20811871,2376,'./includes/arfunctions.php'),(20811870,17781,'./includes/arfunctions.php'),(20811869,2331,'./includes/arfunctions.php'),(20811868,2330,'./includes/arfunctions.php'),(20811867,2329,'./includes/arfunctions.php'),(20811866,2327,'./includes/arfunctions.php'),(20811865,2326,'./includes/arfunctions.php'),(20811864,2324,'./includes/arfunctions.php'),(20811863,15149,'./includes/arfunctions.php'),(20811862,2270,'./includes/arfunctions.php'),(20811861,2260,'./includes/arfunctions.php'),(20811860,13768,'./includes/arfunctions.php'),(20811859,3933,'./includes/arfunctions.php'),(20811858,2208,'./includes/arfunctions.php'),(20811857,8068,'./includes/arfunctions.php'),(20811856,6886,'./includes/arfunctions.php'),(20811855,2200,'./includes/arfunctions.php'),(20811854,2162,'./includes/arfunctions.php'),(20811853,2160,'./includes/arfunctions.php'),(20811852,2151,'./includes/arfunctions.php'),(20811851,2140,'./includes/arfunctions.php'),(20811850,15850,'./includes/arfunctions.php'),(20811849,18317,'./includes/arfunctions.php'),(20811848,7097,'./includes/arfunctions.php'),(20811847,13767,'./includes/arfunctions.php'),(20811846,15849,'./includes/arfunctions.php'),(20811845,15848,'./includes/arfunctions.php'),(20811844,14693,'./includes/arfunctions.php'),(20811843,14796,'./includes/arfunctions.php'),(20811842,2051,'./includes/arfunctions.php'),(20811841,2044,'./includes/arfunctions.php'),(20811840,2034,'./includes/arfunctions.php'),(20811839,1992,'./includes/arfunctions.php'),(20811838,11124,'./includes/arfunctions.php'),(20811837,11123,'./includes/arfunctions.php'),(20811836,20266,'./includes/arfunctions.php'),(20811835,11122,'./includes/arfunctions.php'),(20811834,20265,'./includes/arfunctions.php'),(20811833,15847,'./includes/arfunctions.php'),(20811832,2094,'./includes/arfunctions.php'),(20811831,2093,'./includes/arfunctions.php'),(20811830,20264,'./includes/arfunctions.php'),(20811829,13140,'./includes/arfunctions.php'),(20811828,15241,'./includes/arfunctions.php'),(20811827,2103,'./includes/arfunctions.php'),(20811826,5726,'./includes/arfunctions.php'),(20811825,2070,'./includes/arfunctions.php'),(20811824,1973,'./includes/arfunctions.php'),(20811823,15148,'./includes/arfunctions.php'),(20811822,13766,'./includes/arfunctions.php'),(20811821,1942,'./includes/arfunctions.php'),(20811820,9422,'./includes/arfunctions.php'),(20811819,14172,'./includes/arfunctions.php'),(20811818,12853,'./includes/arfunctions.php'),(20811817,1935,'./includes/arfunctions.php'),(20811816,1934,'./includes/arfunctions.php'),(20811815,17119,'./includes/arfunctions.php'),(20811814,8544,'./includes/arfunctions.php'),(20811813,17498,'./includes/arfunctions.php'),(20811812,15147,'./includes/arfunctions.php'),(20811811,1844,'./includes/arfunctions.php'),(20811810,10534,'./includes/arfunctions.php'),(20811809,20163,'./includes/arfunctions.php'),(20811808,1810,'./includes/arfunctions.php'),(20811807,16237,'./includes/arfunctions.php'),(20811806,1765,'./includes/arfunctions.php'),(20811805,17858,'./includes/arfunctions.php'),(20811804,1759,'./includes/arfunctions.php'),(20811803,1758,'./includes/arfunctions.php'),(20811802,8739,'./includes/arfunctions.php'),(20811801,18874,'./includes/arfunctions.php'),(20811800,8505,'./includes/arfunctions.php'),(20811799,18687,'./includes/arfunctions.php'),(20811798,5081,'./includes/arfunctions.php'),(20811797,1740,'./includes/arfunctions.php'),(20811796,11446,'./includes/arfunctions.php'),(20811795,15079,'./includes/arfunctions.php'),(20811794,17968,'./includes/arfunctions.php'),(20811793,17967,'./includes/arfunctions.php'),(20811792,10562,'./includes/arfunctions.php'),(20811791,18102,'./includes/arfunctions.php'),(20811790,1692,'./includes/arfunctions.php'),(20811789,1691,'./includes/arfunctions.php'),(20811788,5931,'./includes/arfunctions.php'),(20811787,1689,'./includes/arfunctions.php'),(20811786,1688,'./includes/arfunctions.php'),(20811785,1687,'./includes/arfunctions.php'),(20811784,1685,'./includes/arfunctions.php'),(20811783,1678,'./includes/arfunctions.php'),(20811782,1676,'./includes/arfunctions.php'),(20811781,1672,'./includes/arfunctions.php'),(20811780,13765,'./includes/arfunctions.php'),(20811779,4940,'./includes/arfunctions.php'),(20811778,1668,'./includes/arfunctions.php'),(20811777,1647,'./includes/arfunctions.php'),(20811776,15905,'./includes/arfunctions.php'),(20811775,1625,'./includes/arfunctions.php'),(20811774,15137,'./includes/arfunctions.php'),(20811773,14692,'./includes/arfunctions.php'),(20811772,8686,'./includes/arfunctions.php'),(20811771,12741,'./includes/arfunctions.php'),(20811770,16705,'./includes/arfunctions.php'),(20811769,1578,'./includes/arfunctions.php'),(20811768,8241,'./includes/arfunctions.php'),(20811767,1559,'./includes/arfunctions.php'),(20811766,15798,'./includes/arfunctions.php'),(20811765,13717,'./includes/arfunctions.php'),(20811764,6079,'./includes/arfunctions.php'),(20811763,14606,'./includes/arfunctions.php'),(20811762,5930,'./includes/arfunctions.php'),(20811761,1519,'./includes/arfunctions.php'),(20811760,15991,'./includes/arfunctions.php'),(20811759,7096,'./includes/arfunctions.php'),(20811758,7095,'./includes/arfunctions.php'),(20811757,1499,'./includes/arfunctions.php'),(20811756,1476,'./includes/arfunctions.php'),(20811755,18135,'./includes/arfunctions.php'),(20811754,11862,'./includes/arfunctions.php'),(20811753,1456,'./includes/arfunctions.php'),(20811752,1446,'./includes/arfunctions.php'),(20811751,15146,'./includes/arfunctions.php'),(20811750,1429,'./includes/arfunctions.php'),(20811749,12740,'./includes/arfunctions.php'),(20811748,1381,'./includes/arfunctions.php'),(20811747,1373,'./includes/arfunctions.php'),(20811746,7954,'./includes/arfunctions.php'),(20811745,5072,'./includes/arfunctions.php'),(20811744,15846,'./includes/arfunctions.php'),(20811743,15845,'./includes/arfunctions.php'),(20811742,1318,'./includes/arfunctions.php'),(20811741,1312,'./includes/arfunctions.php'),(20811740,1311,'./includes/arfunctions.php'),(20811739,1310,'./includes/arfunctions.php'),(20811738,1305,'./includes/arfunctions.php'),(20811737,1279,'./includes/arfunctions.php'),(20811736,1278,'./includes/arfunctions.php'),(20811735,1264,'./includes/arfunctions.php'),(20811734,1263,'./includes/arfunctions.php'),(20811733,1254,'./includes/arfunctions.php'),(20811732,3995,'./includes/arfunctions.php'),(20811731,1240,'./includes/arfunctions.php'),(20811730,1232,'./includes/arfunctions.php'),(20811729,8936,'./includes/arfunctions.php'),(20811728,1205,'./includes/arfunctions.php'),(20811727,1202,'./includes/arfunctions.php'),(20811726,1201,'./includes/arfunctions.php'),(20811725,1200,'./includes/arfunctions.php'),(20811724,1197,'./includes/arfunctions.php'),(20811723,1175,'./includes/arfunctions.php'),(20811722,1174,'./includes/arfunctions.php'),(20811721,1161,'./includes/arfunctions.php'),(20811720,1160,'./includes/arfunctions.php'),(20811719,1153,'./includes/arfunctions.php'),(20811718,1143,'./includes/arfunctions.php'),(20811717,20162,'./includes/arfunctions.php'),(20811716,1134,'./includes/arfunctions.php'),(20811715,1132,'./includes/arfunctions.php'),(20811714,1124,'./includes/arfunctions.php'),(20811713,16080,'./includes/arfunctions.php'),(20811712,1119,'./includes/arfunctions.php'),(20811711,1118,'./includes/arfunctions.php'),(20811710,1117,'./includes/arfunctions.php'),(20811709,1114,'./includes/arfunctions.php'),(20811708,6044,'./includes/arfunctions.php'),(20811707,1090,'./includes/arfunctions.php'),(20811706,1071,'./includes/arfunctions.php'),(20811705,1070,'./includes/arfunctions.php'),(20811704,1067,'./includes/arfunctions.php'),(20811703,1060,'./includes/arfunctions.php'),(20811702,1047,'./includes/arfunctions.php'),(20811701,15145,'./includes/arfunctions.php'),(20811700,989,'./includes/arfunctions.php'),(20811699,19458,'./includes/arfunctions.php'),(20811698,14526,'./includes/arfunctions.php'),(20811697,988,'./includes/arfunctions.php'),(20811696,984,'./includes/arfunctions.php'),(20811695,7094,'./includes/arfunctions.php'),(20811694,19512,'./includes/arfunctions.php'),(20811693,983,'./includes/arfunctions.php'),(20811692,981,'./includes/arfunctions.php'),(20811691,5409,'./includes/arfunctions.php'),(20811690,939,'./includes/arfunctions.php'),(20811689,932,'./includes/arfunctions.php'),(20811688,8756,'./includes/arfunctions.php'),(20811687,18134,'./includes/arfunctions.php'),(20811686,898,'./includes/arfunctions.php'),(20811685,893,'./includes/arfunctions.php'),(20811684,894,'./includes/arfunctions.php'),(20811683,892,'./includes/arfunctions.php'),(20811682,890,'./includes/arfunctions.php'),(20811681,9522,'./includes/arfunctions.php'),(20811680,12852,'./includes/arfunctions.php'),(20811679,869,'./includes/arfunctions.php'),(20811678,15844,'./includes/arfunctions.php'),(20811677,807,'./includes/arfunctions.php'),(20811676,864,'./includes/arfunctions.php'),(20811675,5205,'./includes/arfunctions.php'),(20811674,18278,'./includes/arfunctions.php'),(20811673,19280,'./includes/arfunctions.php'),(20811672,18316,'./includes/arfunctions.php'),(20811671,798,'./includes/arfunctions.php'),(20811670,15144,'./includes/arfunctions.php'),(20811669,14257,'./includes/arfunctions.php'),(20811668,5727,'./includes/arfunctions.php'),(20811667,5816,'./includes/arfunctions.php'),(20811666,19457,'./includes/arfunctions.php'),(20811665,9451,'./includes/arfunctions.php'),(20811664,13309,'./includes/arfunctions.php'),(20811663,14598,'./includes/arfunctions.php'),(20811662,8010,'./includes/arfunctions.php'),(20811661,4973,'./includes/arfunctions.php'),(20811660,15843,'./includes/arfunctions.php'),(20811659,15842,'./includes/arfunctions.php'),(20811658,737,'./includes/arfunctions.php'),(20811657,717,'./includes/arfunctions.php'),(20811656,716,'./includes/arfunctions.php'),(20811655,4481,'./includes/arfunctions.php'),(20811654,15078,'./includes/arfunctions.php'),(20811653,18133,'./includes/arfunctions.php'),(20811652,8730,'./includes/arfunctions.php'),(20811651,6602,'./includes/arfunctions.php'),(20811650,18697,'./includes/arfunctions.php'),(20811649,6228,'./includes/arfunctions.php'),(20811645,684,'./includes/arfunctions.php'),(20811646,697,'./includes/arfunctions.php'),(20811647,19456,'./includes/arfunctions.php'),(20811648,702,'./includes/arfunctions.php'),(20811513,3432,'./includes/apfunctions.php'),(20811512,18694,'./includes/apfunctions.php'),(20811511,18870,'./includes/apfunctions.php'),(20811510,17430,'./includes/apfunctions.php'),(20811509,3421,'./includes/apfunctions.php'),(20811508,3354,'./includes/apfunctions.php'),(20811507,3324,'./includes/apfunctions.php'),(20811506,3319,'./includes/apfunctions.php'),(20811505,6027,'./includes/apfunctions.php'),(20811504,8899,'./includes/apfunctions.php'),(20811503,3306,'./includes/apfunctions.php'),(20811502,3302,'./includes/apfunctions.php'),(20811501,3301,'./includes/apfunctions.php'),(20811500,3299,'./includes/apfunctions.php'),(20811499,18315,'./includes/apfunctions.php'),(20811498,3292,'./includes/apfunctions.php'),(20811497,6142,'./includes/apfunctions.php'),(20811496,15077,'./includes/apfunctions.php'),(20811495,13017,'./includes/apfunctions.php'),(20811494,6141,'./includes/apfunctions.php'),(20811493,12989,'./includes/apfunctions.php'),(20811492,3277,'./includes/apfunctions.php'),(20811491,11785,'./includes/apfunctions.php'),(20811490,17213,'./includes/apfunctions.php'),(20811489,15076,'./includes/apfunctions.php'),(20811488,3252,'./includes/apfunctions.php'),(20811487,3225,'./includes/apfunctions.php'),(20811486,15075,'./includes/apfunctions.php'),(20811485,2998,'./includes/apfunctions.php'),(20811484,17429,'./includes/apfunctions.php'),(20811483,8546,'./includes/apfunctions.php'),(20811482,11345,'./includes/apfunctions.php'),(20811481,2936,'./includes/apfunctions.php'),(20811480,12988,'./includes/apfunctions.php'),(20811479,14934,'./includes/apfunctions.php'),(20811478,13612,'./includes/apfunctions.php'),(20811477,10193,'./includes/apfunctions.php'),(20811476,17069,'./includes/apfunctions.php'),(20811475,16947,'./includes/apfunctions.php'),(20811474,16946,'./includes/apfunctions.php'),(20811473,2848,'./includes/apfunctions.php'),(20811472,17307,'./includes/apfunctions.php'),(20811471,5506,'./includes/apfunctions.php'),(20811470,5280,'./includes/apfunctions.php'),(20811469,8545,'./includes/apfunctions.php'),(20811468,8744,'./includes/apfunctions.php'),(20811467,2690,'./includes/apfunctions.php'),(20811466,2686,'./includes/apfunctions.php'),(20811465,5955,'./includes/apfunctions.php'),(20811464,6026,'./includes/apfunctions.php'),(20811463,12920,'./includes/apfunctions.php'),(20811462,2585,'./includes/apfunctions.php'),(20811461,17677,'./includes/apfunctions.php'),(20811460,16704,'./includes/apfunctions.php'),(20811459,12794,'./includes/apfunctions.php'),(20811458,10278,'./includes/apfunctions.php'),(20811457,13408,'./includes/apfunctions.php'),(20811456,13407,'./includes/apfunctions.php'),(20811455,7697,'./includes/apfunctions.php'),(20811454,7091,'./includes/apfunctions.php'),(20811453,6069,'./includes/apfunctions.php'),(20811452,5945,'./includes/apfunctions.php'),(20811451,2390,'./includes/apfunctions.php'),(20811450,2376,'./includes/apfunctions.php'),(20811449,16117,'./includes/apfunctions.php'),(20811448,2337,'./includes/apfunctions.php'),(20811447,8743,'./includes/apfunctions.php'),(20811446,2331,'./includes/apfunctions.php'),(20811445,8742,'./includes/apfunctions.php'),(20811444,2330,'./includes/apfunctions.php'),(20811443,8741,'./includes/apfunctions.php'),(20811442,2329,'./includes/apfunctions.php'),(20811441,2324,'./includes/apfunctions.php'),(20811440,6271,'./includes/apfunctions.php'),(20811439,2251,'./includes/apfunctions.php'),(20811438,15611,'./includes/apfunctions.php'),(20811437,2248,'./includes/apfunctions.php'),(20811436,2246,'./includes/apfunctions.php'),(20811435,2241,'./includes/apfunctions.php'),(20811434,2270,'./includes/apfunctions.php'),(20811433,7090,'./includes/apfunctions.php'),(20811432,2262,'./includes/apfunctions.php'),(20811431,6497,'./includes/apfunctions.php'),(20811430,15920,'./includes/apfunctions.php'),(20811429,6318,'./includes/apfunctions.php'),(20811428,17428,'./includes/apfunctions.php'),(20811427,2238,'./includes/apfunctions.php'),(20811426,8889,'./includes/apfunctions.php'),(20811425,8888,'./includes/apfunctions.php'),(20811424,8887,'./includes/apfunctions.php'),(20811423,2177,'./includes/apfunctions.php'),(20811422,8886,'./includes/apfunctions.php'),(20811421,8885,'./includes/apfunctions.php'),(20811420,2176,'./includes/apfunctions.php'),(20811419,8884,'./includes/apfunctions.php'),(20811418,8883,'./includes/apfunctions.php'),(20811417,2175,'./includes/apfunctions.php'),(20811416,8882,'./includes/apfunctions.php'),(20811415,8881,'./includes/apfunctions.php'),(20811414,2174,'./includes/apfunctions.php'),(20811413,3470,'./includes/apfunctions.php'),(20811412,2162,'./includes/apfunctions.php'),(20811411,11784,'./includes/apfunctions.php'),(20811410,16945,'./includes/apfunctions.php'),(20811409,16944,'./includes/apfunctions.php'),(20811408,2051,'./includes/apfunctions.php'),(20811407,6199,'./includes/apfunctions.php'),(20811406,2044,'./includes/apfunctions.php'),(20811405,5539,'./includes/apfunctions.php'),(20811404,1973,'./includes/apfunctions.php'),(20811403,16199,'./includes/apfunctions.php'),(20811402,1942,'./includes/apfunctions.php'),(20811401,9422,'./includes/apfunctions.php'),(20811400,12853,'./includes/apfunctions.php'),(20811399,12919,'./includes/apfunctions.php'),(20811398,1935,'./includes/apfunctions.php'),(20811397,1934,'./includes/apfunctions.php'),(20811396,17118,'./includes/apfunctions.php'),(20811395,5953,'./includes/apfunctions.php'),(20811394,15074,'./includes/apfunctions.php'),(20811393,15073,'./includes/apfunctions.php'),(20811392,15072,'./includes/apfunctions.php'),(20811391,8544,'./includes/apfunctions.php'),(20811390,16943,'./includes/apfunctions.php'),(20811389,16035,'./includes/apfunctions.php'),(20811388,1818,'./includes/apfunctions.php'),(20811387,1810,'./includes/apfunctions.php'),(20811386,4720,'./includes/apfunctions.php'),(20811385,17858,'./includes/apfunctions.php'),(20811384,1758,'./includes/apfunctions.php'),(20811383,1755,'./includes/apfunctions.php'),(20811382,8739,'./includes/apfunctions.php'),(20811381,1689,'./includes/apfunctions.php'),(20811380,7089,'./includes/apfunctions.php'),(20811379,7088,'./includes/apfunctions.php'),(20811378,17857,'./includes/apfunctions.php'),(20811377,5279,'./includes/apfunctions.php'),(20811376,5278,'./includes/apfunctions.php'),(20811375,5277,'./includes/apfunctions.php'),(20811374,5276,'./includes/apfunctions.php'),(20811373,13991,'./includes/apfunctions.php'),(20811372,15612,'./includes/apfunctions.php'),(20811371,1578,'./includes/apfunctions.php'),(20811370,10277,'./includes/apfunctions.php'),(20811369,1560,'./includes/apfunctions.php'),(20811368,6025,'./includes/apfunctions.php'),(20811367,16911,'./includes/apfunctions.php'),(20811366,16910,'./includes/apfunctions.php'),(20811365,16909,'./includes/apfunctions.php'),(20811364,1505,'./includes/apfunctions.php'),(20811363,1499,'./includes/apfunctions.php'),(20811362,16198,'./includes/apfunctions.php'),(20811361,16197,'./includes/apfunctions.php'),(20811360,1476,'./includes/apfunctions.php'),(20811359,1467,'./includes/apfunctions.php'),(20811358,5952,'./includes/apfunctions.php'),(20811357,5944,'./includes/apfunctions.php'),(20811356,5943,'./includes/apfunctions.php'),(20811355,10276,'./includes/apfunctions.php'),(20811354,7087,'./includes/apfunctions.php'),(20811353,5140,'./includes/apfunctions.php'),(20811352,6270,'./includes/apfunctions.php'),(20811351,1429,'./includes/apfunctions.php'),(20811350,5538,'./includes/apfunctions.php'),(20811349,6269,'./includes/apfunctions.php'),(20811348,14183,'./includes/apfunctions.php'),(20811347,1381,'./includes/apfunctions.php'),(20811346,1373,'./includes/apfunctions.php'),(20811345,18314,'./includes/apfunctions.php'),(20811344,1324,'./includes/apfunctions.php'),(20811343,1311,'./includes/apfunctions.php'),(20811342,1307,'./includes/apfunctions.php'),(20811341,1258,'./includes/apfunctions.php'),(20811340,1256,'./includes/apfunctions.php'),(20811339,1255,'./includes/apfunctions.php'),(20811338,1248,'./includes/apfunctions.php'),(20811337,1247,'./includes/apfunctions.php'),(20811336,1246,'./includes/apfunctions.php'),(20811335,3995,'./includes/apfunctions.php'),(20811334,8936,'./includes/apfunctions.php'),(20811333,1208,'./includes/apfunctions.php'),(20811332,1175,'./includes/apfunctions.php'),(20811331,1155,'./includes/apfunctions.php'),(20811330,1143,'./includes/apfunctions.php'),(20811329,5393,'./includes/apfunctions.php'),(20811328,1131,'./includes/apfunctions.php'),(20811327,7086,'./includes/apfunctions.php'),(20811326,1118,'./includes/apfunctions.php'),(20811325,1115,'./includes/apfunctions.php'),(20811324,5139,'./includes/apfunctions.php'),(20811323,1079,'./includes/apfunctions.php'),(20811322,1066,'./includes/apfunctions.php'),(20811321,1064,'./includes/apfunctions.php'),(20811320,1053,'./includes/apfunctions.php'),(20811319,1052,'./includes/apfunctions.php'),(20811318,3994,'./includes/apfunctions.php'),(20811317,16188,'./includes/apfunctions.php'),(20811316,16942,'./includes/apfunctions.php'),(20811315,984,'./includes/apfunctions.php'),(20811314,983,'./includes/apfunctions.php'),(20811313,9224,'./includes/apfunctions.php'),(20811312,981,'./includes/apfunctions.php'),(20811311,6496,'./includes/apfunctions.php'),(20811310,962,'./includes/apfunctions.php'),(20811309,14681,'./includes/apfunctions.php'),(20811308,15733,'./includes/apfunctions.php'),(20811307,15738,'./includes/apfunctions.php'),(20811306,16196,'./includes/apfunctions.php'),(20811305,898,'./includes/apfunctions.php'),(20811304,893,'./includes/apfunctions.php'),(20811303,894,'./includes/apfunctions.php'),(20811302,12918,'./includes/apfunctions.php'),(20811301,12917,'./includes/apfunctions.php'),(20811300,9522,'./includes/apfunctions.php'),(20811299,12852,'./includes/apfunctions.php'),(20811298,5942,'./includes/apfunctions.php'),(20811297,869,'./includes/apfunctions.php'),(20811296,10275,'./includes/apfunctions.php'),(20811295,10274,'./includes/apfunctions.php'),(20811294,10273,'./includes/apfunctions.php'),(20811293,10272,'./includes/apfunctions.php'),(20811292,10253,'./includes/apfunctions.php'),(20811291,17427,'./includes/apfunctions.php'),(20811290,14933,'./includes/apfunctions.php'),(20811289,5951,'./includes/apfunctions.php'),(20811288,7841,'./includes/apfunctions.php'),(20811287,14021,'./includes/apfunctions.php'),(20811286,6140,'./includes/apfunctions.php'),(20811285,9323,'./includes/apfunctions.php'),(20811284,8194,'./includes/apfunctions.php'),(20811283,15732,'./includes/apfunctions.php'),(20811282,795,'./includes/apfunctions.php'),(20811281,8880,'./includes/apfunctions.php'),(20811280,794,'./includes/apfunctions.php'),(20811279,5537,'./includes/apfunctions.php'),(20811278,791,'./includes/apfunctions.php'),(20811277,4973,'./includes/apfunctions.php'),(20811276,698,'./includes/apfunctions.php'),(20811275,15731,'./includes/apfunctions.php'),(20811274,9341,'./includes/apfunctions.php'),(20811273,673,'./includes/apfunctions.php'),(20811272,6053,'./includes/apfunctions.php'),(20811271,659,'./includes/apfunctions.php'),(20811270,606,'./includes/apfunctions.php'),(20811269,605,'./includes/apfunctions.php'),(20811268,7085,'./includes/apfunctions.php'),(20811267,16097,'./includes/apfunctions.php'),(20811266,581,'./includes/apfunctions.php'),(20811265,5274,'./includes/apfunctions.php'),(20811264,16291,'./includes/apfunctions.php'),(20811263,542,'./includes/apfunctions.php'),(20811262,524,'./includes/apfunctions.php'),(20811261,14256,'./includes/apfunctions.php'),(20811260,15730,'./includes/apfunctions.php'),(20811259,15729,'./includes/apfunctions.php'),(20811258,5941,'./includes/apfunctions.php'),(20811257,11344,'./includes/apfunctions.php'),(20811256,5950,'./includes/apfunctions.php'),(20811255,11343,'./includes/apfunctions.php'),(20811254,6565,'./includes/apfunctions.php'),(20811253,484,'./includes/apfunctions.php'),(20811252,6028,'./includes/apfunctions.php'),(20811251,6024,'./includes/apfunctions.php'),(20811250,7449,'./includes/apfunctions.php'),(20811249,513,'./includes/apfunctions.php'),(20811248,511,'./includes/apfunctions.php'),(20811247,507,'./includes/apfunctions.php'),(20811246,506,'./includes/apfunctions.php'),(20811245,504,'./includes/apfunctions.php'),(20811244,479,'./includes/apfunctions.php'),(20811243,445,'./includes/apfunctions.php'),(20811242,17426,'./includes/apfunctions.php'),(20811241,10271,'./includes/apfunctions.php'),(20811240,5940,'./includes/apfunctions.php'),(20811203,14255,'./includes/aiproducts.php'),(20811201,8936,'./zipinfo.php'),(20811200,6155,'./voucherdetail.php'),(20811199,6154,'./voucherdetail.php'),(20811198,3333,'./voucherdetail.php'),(20811197,3324,'./voucherdetail.php'),(20811196,16032,'./voucherdetail.php'),(20811195,16031,'./voucherdetail.php'),(20811194,11898,'./voucherdetail.php'),(20811193,11895,'./voucherdetail.php'),(20811192,6153,'./voucherdetail.php'),(20811191,6152,'./voucherdetail.php'),(20811190,3118,'./voucherdetail.php'),(20811189,3072,'./voucherdetail.php'),(20811188,16078,'./voucherdetail.php'),(20811187,16077,'./voucherdetail.php'),(20811186,18693,'./voucherdetail.php'),(20811185,16785,'./voucherdetail.php'),(20811184,2459,'./voucherdetail.php'),(20811183,6009,'./voucherdetail.php'),(20811182,6007,'./voucherdetail.php'),(20811181,6151,'./voucherdetail.php'),(20811180,6150,'./voucherdetail.php'),(20811179,2225,'./voucherdetail.php'),(20811178,20255,'./voucherdetail.php'),(20811177,2165,'./voucherdetail.php'),(20811176,2136,'./voucherdetail.php'),(20811175,2103,'./voucherdetail.php'),(20811174,5081,'./voucherdetail.php'),(20811173,6149,'./voucherdetail.php'),(20811172,6148,'./voucherdetail.php'),(20811171,1668,'./voucherdetail.php'),(20811170,6147,'./voucherdetail.php'),(20811169,1640,'./voucherdetail.php'),(20811168,15991,'./voucherdetail.php'),(20811167,1467,'./voucherdetail.php'),(20811166,1446,'./voucherdetail.php'),(20811165,8936,'./voucherdetail.php'),(20811164,6146,'./voucherdetail.php'),(20811163,1032,'./voucherdetail.php'),(20811162,6054,'./voucherdetail.php'),(20811161,941,'./voucherdetail.php'),(20811160,869,'./voucherdetail.php'),(20811159,5878,'./voucherdetail.php'),(20811158,5205,'./voucherdetail.php'),(20811157,799,'./voucherdetail.php'),(20811156,776,'./voucherdetail.php'),(20811155,740,'./voucherdetail.php'),(20811154,6145,'./voucherdetail.php'),(20811153,9341,'./voucherdetail.php'),(20811152,6053,'./voucherdetail.php'),(20811151,670,'./voucherdetail.php'),(20811150,16026,'./voucherdetail.php'),(20811149,9492,'./voucherdetail.php'),(20811148,542,'./voucherdetail.php'),(20811147,479,'./voucherdetail.php'),(20811146,445,'./voucherdetail.php'),(20811145,16076,'./voucherdetail.php'),(20811144,5877,'./voucherdetail.php'),(20811143,5424,'./voucherdetail.php'),(20811142,416,'./voucherdetail.php'),(20811141,18968,'./voucherdetail.php'),(20811136,3953,'./view_duedate_history.php'),(20811135,3072,'./view_duedate_history.php'),(20811134,1467,'./view_duedate_history.php'),(20811133,8292,'./view_duedate_history.php'),(20811132,1032,'./view_duedate_history.php'),(20811131,5226,'./view_duedate_history.php'),(20811130,542,'./view_duedate_history.php'),(20811129,13181,'./usershippingrights.php'),(20811128,13180,'./usershippingrights.php'),(20811127,13179,'./usershippingrights.php'),(20811126,13178,'./usershippingrights.php'),(20811125,13177,'./usershippingrights.php'),(20811124,13176,'./usershippingrights.php'),(20811123,13175,'./usershippingrights.php'),(20811122,13174,'./usershippingrights.php'),(20811121,13173,'./usershippingrights.php'),(20811120,2767,'./usershippingrights.php'),(20811119,5990,'./usershippingrights.php'),(20811118,2702,'./usershippingrights.php'),(20811117,6352,'./usershippingrights.php'),(20811116,10989,'./usershippingrights.php'),(20811115,13172,'./usershippingrights.php'),(20811114,13171,'./usershippingrights.php'),(20811113,13170,'./usershippingrights.php'),(20811112,8936,'./usershippingrights.php'),(20811111,315,'./usershippingrights.php'),(20811110,13169,'./usershippingrights.php'),(20811109,7081,'./user_barcode_list.php'),(20811108,542,'./user_barcode_list.php'),(20811107,12957,'./upgrade.php'),(20811106,12956,'./upgrade.php'),(20811105,12955,'./upgrade.php'),(20811104,12954,'./upgrade.php'),(20811103,5289,'./upgrade.php'),(20811102,3186,'./upgrade.php'),(20811101,5237,'./upgrade.php'),(20811100,14917,'./upgrade.php'),(20811099,12958,'./upgrade.php'),(20811098,12953,'./upgrade.php'),(20811097,12952,'./upgrade.php'),(20811096,13527,'./upgrade.php'),(20811095,5407,'./upgrade.php'),(20731784,12957,'./update.php'),(20731783,12956,'./update.php'),(20731782,12955,'./update.php'),(20731781,12954,'./update.php'),(20731780,3186,'./update.php'),(20731779,12953,'./update.php'),(20731778,12952,'./update.php'),(20731777,5407,'./update.php'),(20731776,12945,'./update.php'),(20811094,13728,'./translation.php'),(20811093,3221,'./translation.php'),(20811092,14684,'./translation.php'),(20811091,13856,'./translation.php'),(20811090,13727,'./translation.php'),(20811089,2850,'./translation.php'),(20811088,13726,'./translation.php'),(20811087,2849,'./translation.php'),(20811086,13725,'./translation.php'),(20811085,13724,'./translation.php'),(20811084,2748,'./translation.php'),(20811083,13723,'./translation.php'),(20811082,2702,'./translation.php'),(20811081,13722,'./translation.php'),(20811080,2627,'./translation.php'),(20811079,13721,'./translation.php'),(20811078,2401,'./translation.php'),(20811077,13720,'./translation.php'),(20811076,2224,'./translation.php'),(20811075,2222,'./translation.php'),(20811074,13719,'./translation.php'),(20811073,5786,'./translation.php'),(20811072,4048,'./translation.php'),(20811071,1963,'./translation.php'),(20811070,3521,'./translation.php'),(20811069,1752,'./translation.php'),(20811068,13718,'./translation.php'),(20811067,13717,'./translation.php'),(20811066,13716,'./translation.php'),(20811065,13715,'./translation.php'),(20811064,13714,'./translation.php'),(20811063,591,'./translation.php'),(20811062,13713,'./translation.php'),(20811061,7035,'./translation.php'),(20811060,13712,'./translation.php'),(20811059,13711,'./translation.php'),(20811058,3090,'./topdollar_customers.php'),(20811057,2405,'./topdollar_customers.php'),(20811056,2324,'./topdollar_customers.php'),(20811055,4166,'./topdollar_customers.php'),(20811054,2008,'./topdollar_customers.php'),(20811053,1963,'./topdollar_customers.php'),(20811052,14171,'./topdollar_customers.php'),(20811051,1894,'./topdollar_customers.php'),(20811050,5470,'./topdollar_customers.php'),(20811049,981,'./topdollar_customers.php'),(20811048,901,'./topdollar_customers.php'),(20811047,748,'./topdollar_customers.php'),(20811046,6463,'./topdollar_customers.php'),(20811045,6465,'./topdollar_customers.php'),(20811044,697,'./topdollar_customers.php'),(20811043,665,'./topdollar_customers.php'),(20811042,5469,'./topdollar_customers.php'),(20811041,315,'./topdollar_customers.php'),(20811040,185,'./topdollar_customers.php'),(20811039,8402,'./timeclock_viewwork.php'),(20811038,8438,'./timeclock_viewwork.php'),(20811037,8437,'./timeclock_viewwork.php'),(20811036,8750,'./timeclock_viewwork.php'),(20811035,8780,'./timeclock_viewwork.php'),(20811034,8748,'./timeclock_viewwork.php'),(20811033,7823,'./timeclock_viewwork.php'),(20811032,3118,'./timeclock_viewwork.php'),(20811031,3090,'./timeclock_viewwork.php'),(20811030,8436,'./timeclock_viewwork.php'),(20811029,5733,'./timeclock_viewwork.php'),(20811028,8435,'./timeclock_viewwork.php'),(20811027,8399,'./timeclock_viewwork.php'),(20811026,4457,'./timeclock_viewwork.php'),(20811025,8434,'./timeclock_viewwork.php'),(20811024,2812,'./timeclock_viewwork.php'),(20811023,8433,'./timeclock_viewwork.php'),(20811022,2565,'./timeclock_viewwork.php'),(20811021,2529,'./timeclock_viewwork.php'),(20811020,8736,'./timeclock_viewwork.php'),(20811019,8861,'./timeclock_viewwork.php'),(20811018,8503,'./timeclock_viewwork.php'),(20811017,8693,'./timeclock_viewwork.php'),(20811016,8397,'./timeclock_viewwork.php'),(20811015,8459,'./timeclock_viewwork.php'),(20811014,2315,'./timeclock_viewwork.php'),(20811013,2292,'./timeclock_viewwork.php'),(20811012,2238,'./timeclock_viewwork.php'),(20811011,8502,'./timeclock_viewwork.php'),(20811010,2208,'./timeclock_viewwork.php'),(20811009,8432,'./timeclock_viewwork.php'),(20811008,11736,'./timeclock_viewwork.php'),(20811007,8394,'./timeclock_viewwork.php'),(20811006,1963,'./timeclock_viewwork.php'),(20811005,1935,'./timeclock_viewwork.php'),(20811004,11735,'./timeclock_viewwork.php'),(20811003,8393,'./timeclock_viewwork.php'),(20811002,5081,'./timeclock_viewwork.php'),(20811001,1570,'./timeclock_viewwork.php'),(20811000,1567,'./timeclock_viewwork.php'),(20810999,8749,'./timeclock_viewwork.php'),(20810998,1337,'./timeclock_viewwork.php'),(20810997,1014,'./timeclock_viewwork.php'),(20810996,1013,'./timeclock_viewwork.php'),(20810995,998,'./timeclock_viewwork.php'),(20810994,989,'./timeclock_viewwork.php'),(20810993,4973,'./timeclock_viewwork.php'),(20810992,737,'./timeclock_viewwork.php'),(20810991,665,'./timeclock_viewwork.php'),(20810990,542,'./timeclock_viewwork.php'),(20810989,6075,'./timeclock_viewwork.php'),(20810988,333,'./timeclock_viewwork.php'),(20810987,8431,'./timeclock_viewwork.php'),(20810986,8430,'./timeclock_viewwork.php'),(20810985,315,'./timeclock_viewwork.php'),(20810984,8501,'./timeclock_viewwork.php'),(20810983,11737,'./timeclock_viewwork.php'),(20810982,8691,'./timeclock_viewwork.php'),(20810981,214,'./timeclock_viewwork.php'),(20810980,207,'./timeclock_viewwork.php'),(20810979,197,'./timeclock_viewwork.php'),(20810978,57,'./timeclock_viewwork.php'),(20810977,47,'./timeclock_viewwork.php'),(20810976,8402,'./timeclock_viewstatus.php'),(20810975,8429,'./timeclock_viewstatus.php'),(20810974,4457,'./timeclock_viewstatus.php'),(20810973,8428,'./timeclock_viewstatus.php'),(20810972,8393,'./timeclock_viewstatus.php'),(20810971,989,'./timeclock_viewstatus.php'),(20810970,6042,'./timeclock_viewstatus.php'),(20810969,6075,'./timeclock_viewstatus.php'),(20810968,47,'./timeclock_viewstatus.php'),(20810967,8435,'./timeclock_piecework_conflict.php'),(20810966,11706,'./timeclock_piecework_conflict.php'),(20810965,2508,'./timeclock_piecework_conflict.php'),(20810964,8735,'./timeclock_piecework_conflict.php'),(20810963,1963,'./timeclock_piecework_conflict.php'),(20810962,5081,'./timeclock_piecework_conflict.php'),(20810961,1014,'./timeclock_piecework_conflict.php'),(20810960,989,'./timeclock_piecework_conflict.php'),(20810959,737,'./timeclock_piecework_conflict.php'),(20810958,665,'./timeclock_piecework_conflict.php'),(20810957,333,'./timeclock_piecework_conflict.php'),(20810956,315,'./timeclock_piecework_conflict.php'),(20810955,47,'./timeclock_piecework_conflict.php'),(20810954,3421,'./timeclock_othertimeadd.php'),(20810953,8427,'./timeclock_othertimeadd.php'),(20810952,2902,'./timeclock_othertimeadd.php'),(20810951,2702,'./timeclock_othertimeadd.php'),(20810950,8424,'./timeclock_othertimeadd.php'),(20810949,8423,'./timeclock_othertimeadd.php'),(20810948,8374,'./timeclock_othertimeadd.php'),(20810947,315,'./timeclock_othertimeadd.php'),(20810946,176,'./timeclock_othertimeadd.php'),(20810945,3421,'./timeclock_othertime.php'),(20810944,3225,'./timeclock_othertime.php'),(20810943,8426,'./timeclock_othertime.php'),(20810942,2902,'./timeclock_othertime.php'),(20810941,2702,'./timeclock_othertime.php'),(20810940,8424,'./timeclock_othertime.php'),(20810939,2044,'./timeclock_othertime.php'),(20810938,2094,'./timeclock_othertime.php'),(20810937,8423,'./timeclock_othertime.php'),(20810936,3995,'./timeclock_othertime.php'),(20810935,1143,'./timeclock_othertime.php'),(20810934,941,'./timeclock_othertime.php'),(20810933,864,'./timeclock_othertime.php'),(20810932,799,'./timeclock_othertime.php'),(20810931,5203,'./timeclock_othertime.php'),(20810930,59,'./timeclock_othertime.php'),(20810929,8435,'./timeclock_jobtime.php'),(20810928,2508,'./timeclock_jobtime.php'),(20810927,8734,'./timeclock_jobtime.php'),(20810926,1358,'./timeclock_jobtime.php'),(20810925,989,'./timeclock_jobtime.php'),(20810924,737,'./timeclock_jobtime.php'),(20810923,542,'./timeclock_jobtime.php'),(20810922,47,'./timeclock_jobtime.php'),(20731602,3202,'./timeclock_general.php'),(20731601,8452,'./timeclock_general.php'),(20731600,8500,'./timeclock_general.php'),(20731599,8421,'./timeclock_general.php'),(20731598,6944,'./timeclock_general.php'),(20731597,2710,'./timeclock_general.php'),(20731596,8499,'./timeclock_general.php'),(20731595,8498,'./timeclock_general.php'),(20731594,8684,'./timeclock_general.php'),(20731593,8420,'./timeclock_general.php'),(20731592,8419,'./timeclock_general.php'),(20731591,8418,'./timeclock_general.php'),(20731590,8417,'./timeclock_general.php'),(20731589,8416,'./timeclock_general.php'),(20731588,8415,'./timeclock_general.php'),(20731587,8414,'./timeclock_general.php'),(20731586,8413,'./timeclock_general.php'),(20731585,8412,'./timeclock_general.php'),(20731584,8411,'./timeclock_general.php'),(20731583,8410,'./timeclock_general.php'),(20731582,8409,'./timeclock_general.php'),(20731581,8408,'./timeclock_general.php'),(20731580,8407,'./timeclock_general.php'),(20731579,8405,'./timeclock_general.php'),(20731578,8806,'./timeclock_general.php'),(20731577,8497,'./timeclock_general.php'),(20731576,8496,'./timeclock_general.php'),(20731575,8683,'./timeclock_general.php'),(20731574,6565,'./timeclock_general.php'),(20731573,8495,'./timeclock_general.php'),(20731572,8494,'./timeclock_general.php'),(20731571,8404,'./timeclock_general.php'),(20731570,8403,'./timeclock_general.php'),(20810921,8402,'./timeclock_editwork.php'),(20810920,3221,'./timeclock_editwork.php'),(20810919,8401,'./timeclock_editwork.php'),(20810918,8400,'./timeclock_editwork.php'),(20810917,3090,'./timeclock_editwork.php'),(20810916,8399,'./timeclock_editwork.php'),(20810915,4457,'./timeclock_editwork.php'),(20810914,12093,'./timeclock_editwork.php'),(20810913,2710,'./timeclock_editwork.php'),(20810912,2702,'./timeclock_editwork.php'),(20810911,8398,'./timeclock_editwork.php'),(20810910,2565,'./timeclock_editwork.php'),(20810909,2529,'./timeclock_editwork.php'),(20810908,8503,'./timeclock_editwork.php'),(20810907,8397,'./timeclock_editwork.php'),(20810906,8459,'./timeclock_editwork.php'),(20810905,2315,'./timeclock_editwork.php'),(20810904,2292,'./timeclock_editwork.php'),(20810903,8396,'./timeclock_editwork.php'),(20810902,8502,'./timeclock_editwork.php'),(20810901,8395,'./timeclock_editwork.php'),(20810900,2103,'./timeclock_editwork.php'),(20810899,8394,'./timeclock_editwork.php'),(20810898,1963,'./timeclock_editwork.php'),(20810897,1935,'./timeclock_editwork.php'),(20810896,8393,'./timeclock_editwork.php'),(20810895,5081,'./timeclock_editwork.php'),(20810894,1598,'./timeclock_editwork.php'),(20810893,8392,'./timeclock_editwork.php'),(20810892,8391,'./timeclock_editwork.php'),(20810891,3995,'./timeclock_editwork.php'),(20810890,1014,'./timeclock_editwork.php'),(20810889,1013,'./timeclock_editwork.php'),(20810888,989,'./timeclock_editwork.php'),(20810887,5640,'./timeclock_editwork.php'),(20810886,737,'./timeclock_editwork.php'),(20810885,665,'./timeclock_editwork.php'),(20810884,6075,'./timeclock_editwork.php'),(20810883,333,'./timeclock_editwork.php'),(20810882,8389,'./timeclock_editwork.php'),(20810881,315,'./timeclock_editwork.php'),(20810880,8388,'./timeclock_editwork.php'),(20810879,8440,'./timeclock_editwork.php'),(20810878,214,'./timeclock_editwork.php'),(20810877,207,'./timeclock_editwork.php'),(20810876,197,'./timeclock_editwork.php'),(20810875,47,'./timeclock_editwork.php'),(20731522,3432,'./tcapayrpt.php'),(20731521,3414,'./tcapayrpt.php'),(20731520,6964,'./tcapayrpt.php'),(20731519,3118,'./tcapayrpt.php'),(20731518,13081,'./tcapayrpt.php'),(20731517,13080,'./tcapayrpt.php'),(20731516,2936,'./tcapayrpt.php'),(20731515,2324,'./tcapayrpt.php'),(20731514,2260,'./tcapayrpt.php'),(20731513,8912,'./tcapayrpt.php'),(20731512,2151,'./tcapayrpt.php'),(20731511,1963,'./tcapayrpt.php'),(20731510,1941,'./tcapayrpt.php'),(20731509,1933,'./tcapayrpt.php'),(20731508,1672,'./tcapayrpt.php'),(20731507,9137,'./tcapayrpt.php'),(20731506,13079,'./tcapayrpt.php'),(20731505,1668,'./tcapayrpt.php'),(20731504,7125,'./tcapayrpt.php'),(20731503,8936,'./tcapayrpt.php'),(20731502,1014,'./tcapayrpt.php'),(20731501,981,'./tcapayrpt.php'),(20731500,932,'./tcapayrpt.php'),(20731499,8730,'./tcapayrpt.php'),(20731498,697,'./tcapayrpt.php'),(20731497,4632,'./tcapayrpt.php'),(20731496,524,'./tcapayrpt.php'),(20731495,13078,'./tcapayrpt.php'),(20731494,6977,'./tcapayrpt.php'),(20731493,13077,'./tcapayrpt.php'),(20731492,333,'./tcapayrpt.php'),(20731491,185,'./tcapayrpt.php'),(20731490,3432,'./tcadocrequestreport.php'),(20731489,3221,'./tcadocrequestreport.php'),(20731488,2936,'./tcadocrequestreport.php'),(20731487,2702,'./tcadocrequestreport.php'),(20731486,11814,'./tcadocrequestreport.php'),(20731485,11813,'./tcadocrequestreport.php'),(20731484,1963,'./tcadocrequestreport.php'),(20731483,8936,'./tcadocrequestreport.php'),(20731482,1014,'./tcadocrequestreport.php'),(20731481,981,'./tcadocrequestreport.php'),(20731480,11812,'./tcadocrequestreport.php'),(20731479,737,'./tcadocrequestreport.php'),(20731478,524,'./tcadocrequestreport.php'),(20731477,333,'./tcadocrequestreport.php'),(20731476,19877,'./tcaarinvoicesum.php'),(20731475,8317,'./tcaarinvoicesum.php'),(20731474,5378,'./tcaarinvoicesum.php'),(20731473,3179,'./tcaarinvoicesum.php'),(20731472,3450,'./tcaarinvoicesum.php'),(20731471,4974,'./tcaarinvoicesum.php'),(20731470,3090,'./tcaarinvoicesum.php'),(20731469,2998,'./tcaarinvoicesum.php'),(20731468,8267,'./tcaarinvoicesum.php'),(20731467,7997,'./tcaarinvoicesum.php'),(20731466,2986,'./tcaarinvoicesum.php'),(20731465,3853,'./tcaarinvoicesum.php'),(20731464,8304,'./tcaarinvoicesum.php'),(20731463,8266,'./tcaarinvoicesum.php'),(20731462,2977,'./tcaarinvoicesum.php'),(20731461,2948,'./tcaarinvoicesum.php'),(20731460,6732,'./tcaarinvoicesum.php'),(20731459,6731,'./tcaarinvoicesum.php'),(20731458,6229,'./tcaarinvoicesum.php'),(20731457,2860,'./tcaarinvoicesum.php'),(20731456,2819,'./tcaarinvoicesum.php'),(20731455,2833,'./tcaarinvoicesum.php'),(20731454,5991,'./tcaarinvoicesum.php'),(20731453,2673,'./tcaarinvoicesum.php'),(20731452,2612,'./tcaarinvoicesum.php'),(20731451,5388,'./tcaarinvoicesum.php'),(20731450,2529,'./tcaarinvoicesum.php'),(20731449,2494,'./tcaarinvoicesum.php'),(20731448,2404,'./tcaarinvoicesum.php'),(20731447,6730,'./tcaarinvoicesum.php'),(20731446,7730,'./tcaarinvoicesum.php'),(20731445,2225,'./tcaarinvoicesum.php'),(20731444,2170,'./tcaarinvoicesum.php'),(20731443,6370,'./tcaarinvoicesum.php'),(20731442,7678,'./tcaarinvoicesum.php'),(20731441,2151,'./tcaarinvoicesum.php'),(20731440,2021,'./tcaarinvoicesum.php'),(20731439,1963,'./tcaarinvoicesum.php'),(20731438,1771,'./tcaarinvoicesum.php'),(20731437,1740,'./tcaarinvoicesum.php'),(20731436,1684,'./tcaarinvoicesum.php'),(20731435,1678,'./tcaarinvoicesum.php'),(20731434,1672,'./tcaarinvoicesum.php'),(20731433,4111,'./tcaarinvoicesum.php'),(20731432,1503,'./tcaarinvoicesum.php'),(20731431,6729,'./tcaarinvoicesum.php'),(20731430,6728,'./tcaarinvoicesum.php'),(20731429,1446,'./tcaarinvoicesum.php'),(20731428,5470,'./tcaarinvoicesum.php'),(20731427,932,'./tcaarinvoicesum.php'),(20731426,886,'./tcaarinvoicesum.php'),(20731425,869,'./tcaarinvoicesum.php'),(20731424,4481,'./tcaarinvoicesum.php'),(20731423,697,'./tcaarinvoicesum.php'),(20731422,665,'./tcaarinvoicesum.php'),(20731421,616,'./tcaarinvoicesum.php'),(20731420,8316,'./tcaarinvoicesum.php'),(20731419,8303,'./tcaarinvoicesum.php'),(20731418,5469,'./tcaarinvoicesum.php'),(20731417,325,'./tcaarinvoicesum.php'),(20731416,197,'./tcaarinvoicesum.php'),(20811644,675,'./includes/arfunctions.php'),(20731415,3274,'./tcaapbilllist.php'),(20731414,6668,'./tcaapbilllist.php'),(20731413,3118,'./tcaapbilllist.php'),(20731412,2985,'./tcaapbilllist.php'),(20731411,6667,'./tcaapbilllist.php'),(20731410,6666,'./tcaapbilllist.php'),(20731409,2849,'./tcaapbilllist.php'),(20731408,8018,'./tcaapbilllist.php'),(20731407,2656,'./tcaapbilllist.php'),(20731406,4157,'./tcaapbilllist.php'),(20731405,6665,'./tcaapbilllist.php'),(20731404,2589,'./tcaapbilllist.php'),(20731403,2363,'./tcaapbilllist.php'),(20731402,4979,'./tcaapbilllist.php'),(20731401,6664,'./tcaapbilllist.php'),(20731400,5366,'./tcaapbilllist.php'),(20731399,2225,'./tcaapbilllist.php'),(20731398,2170,'./tcaapbilllist.php'),(20731397,2151,'./tcaapbilllist.php'),(20731396,2109,'./tcaapbilllist.php'),(20731395,2014,'./tcaapbilllist.php'),(20731394,2099,'./tcaapbilllist.php'),(20731393,1963,'./tcaapbilllist.php'),(20731392,1941,'./tcaapbilllist.php'),(20731391,1692,'./tcaapbilllist.php'),(20731390,1678,'./tcaapbilllist.php'),(20731389,1674,'./tcaapbilllist.php'),(20731388,4138,'./tcaapbilllist.php'),(20731387,1672,'./tcaapbilllist.php'),(20731386,1671,'./tcaapbilllist.php'),(20731385,1668,'./tcaapbilllist.php'),(20731384,1449,'./tcaapbilllist.php'),(20731383,1235,'./tcaapbilllist.php'),(20731382,1017,'./tcaapbilllist.php'),(20731381,932,'./tcaapbilllist.php'),(20731380,874,'./tcaapbilllist.php'),(20731379,737,'./tcaapbilllist.php'),(20731378,9370,'./tcaapbilllist.php'),(20731377,607,'./tcaapbilllist.php'),(20731376,543,'./tcaapbilllist.php'),(20731375,336,'./tcaapbilllist.php'),(20731374,315,'./tcaapbilllist.php'),(20731373,226,'./tcaapbilllist.php'),(20731372,197,'./tcaapbilllist.php'),(20731371,20,'./tcaapbilllist.php'),(20810874,3421,'./taxclass.php'),(20810873,15538,'./taxclass.php'),(20810872,15544,'./taxclass.php'),(20810871,15410,'./taxclass.php'),(20810870,2710,'./taxclass.php'),(20810869,2702,'./taxclass.php'),(20810868,9807,'./taxclass.php'),(20810867,15550,'./taxclass.php'),(20810866,15549,'./taxclass.php'),(20810865,15548,'./taxclass.php'),(20810864,1973,'./taxclass.php'),(20810863,1935,'./taxclass.php'),(20810862,7972,'./taxclass.php'),(20810861,1480,'./taxclass.php'),(20810860,8936,'./taxclass.php'),(20810859,941,'./taxclass.php'),(20810858,799,'./taxclass.php'),(20810857,15547,'./taxclass.php'),(20810856,13994,'./taxclass.php'),(20810855,315,'./taxclass.php'),(20810854,5203,'./taxclass.php'),(20810853,59,'./taxclass.php'),(20811643,673,'./includes/arfunctions.php'),(20810852,15071,'./taskuser.php'),(20810851,3322,'./taskuser.php'),(20810850,15070,'./taskuser.php'),(20810849,3292,'./taskuser.php'),(20810848,3274,'./taskuser.php'),(20810847,3479,'./taskuser.php'),(20810846,3252,'./taskuser.php'),(20810845,14667,'./taskuser.php'),(20810844,16148,'./taskuser.php'),(20810843,15215,'./taskuser.php'),(20810842,14951,'./taskuser.php'),(20810841,2948,'./taskuser.php'),(20810840,15259,'./taskuser.php'),(20810839,2782,'./taskuser.php'),(20810838,2751,'./taskuser.php'),(20810837,8580,'./taskuser.php'),(20810836,2702,'./taskuser.php'),(20810835,15069,'./taskuser.php'),(20810834,2622,'./taskuser.php'),(20810833,9962,'./taskuser.php'),(20810832,15068,'./taskuser.php'),(20810831,15067,'./taskuser.php'),(20810830,15066,'./taskuser.php'),(20810829,15065,'./taskuser.php'),(20810828,15064,'./taskuser.php'),(20810827,8361,'./taskuser.php'),(20810826,2103,'./taskuser.php'),(20810825,15063,'./taskuser.php'),(20810824,15062,'./taskuser.php'),(20810823,15061,'./taskuser.php'),(20810822,15060,'./taskuser.php'),(20810821,1963,'./taskuser.php'),(20810820,15249,'./taskuser.php'),(20810819,15248,'./taskuser.php'),(20810818,15059,'./taskuser.php'),(20810817,15057,'./taskuser.php'),(20810816,15056,'./taskuser.php'),(20810815,15055,'./taskuser.php'),(20810814,15054,'./taskuser.php'),(20810813,15053,'./taskuser.php'),(20810812,1754,'./taskuser.php'),(20810811,5081,'./taskuser.php'),(20810810,15258,'./taskuser.php'),(20810809,15052,'./taskuser.php'),(20810808,15051,'./taskuser.php'),(20810807,15050,'./taskuser.php'),(20810806,15049,'./taskuser.php'),(20810805,8936,'./taskuser.php'),(20810804,869,'./taskuser.php'),(20810803,4481,'./taskuser.php'),(20810802,697,'./taskuser.php'),(20810801,15048,'./taskuser.php'),(20810800,15047,'./taskuser.php'),(20810799,605,'./taskuser.php'),(20810798,6165,'./taskuser.php'),(20810797,315,'./taskuser.php'),(20810796,15046,'./taskuser.php'),(20810795,226,'./taskuser.php'),(20810794,15045,'./taskuser.php'),(20810793,15044,'./taskuser.php'),(20810788,15039,'./taskstatus.php'),(20810787,15038,'./taskstatus.php'),(20810786,15037,'./taskstatus.php'),(20810785,14955,'./taskstatus.php'),(20810784,2702,'./taskstatus.php'),(20810783,1935,'./taskstatus.php'),(20810782,8936,'./taskstatus.php'),(20810781,941,'./taskstatus.php'),(20810780,799,'./taskstatus.php'),(20810779,315,'./taskstatus.php'),(20810778,8125,'./taskstatus.php'),(20810777,59,'./taskstatus.php'),(20810776,8936,'./taskfetcher.php'),(20810775,15036,'./taskaction.php'),(20810774,15035,'./taskaction.php'),(20810773,15034,'./taskaction.php'),(20810772,14953,'./taskaction.php'),(20810771,2702,'./taskaction.php'),(20810770,1935,'./taskaction.php'),(20810769,8936,'./taskaction.php'),(20810768,941,'./taskaction.php'),(20810767,799,'./taskaction.php'),(20810766,315,'./taskaction.php'),(20810765,8125,'./taskaction.php'),(20810764,59,'./taskaction.php'),(20810763,6197,'./task.php'),(20810762,3480,'./task.php'),(20810761,15033,'./task.php'),(20810760,14667,'./task.php'),(20810759,3156,'./task.php'),(20810758,15032,'./task.php'),(20810757,15031,'./task.php'),(20810756,15030,'./task.php'),(20810755,14951,'./task.php'),(20810754,15836,'./task.php'),(20810753,2782,'./task.php'),(20810752,2751,'./task.php'),(20810751,2702,'./task.php'),(20810750,2664,'./task.php'),(20810749,3784,'./task.php'),(20810748,15029,'./task.php'),(20810747,15028,'./task.php'),(20810746,1935,'./task.php'),(20810745,15027,'./task.php'),(20810744,15026,'./task.php'),(20810743,1476,'./task.php'),(20810742,15025,'./task.php'),(20810741,8936,'./task.php'),(20810740,15024,'./task.php'),(20810739,941,'./task.php'),(20810738,869,'./task.php'),(20810737,799,'./task.php'),(20810736,15247,'./task.php'),(20810735,3458,'./task.php'),(20810734,15023,'./task.php'),(20810733,15022,'./task.php'),(20810732,6165,'./task.php'),(20810731,15021,'./task.php'),(20810730,13994,'./task.php'),(20810729,315,'./task.php'),(20810728,15246,'./task.php'),(20810727,15020,'./task.php'),(20810726,15019,'./task.php'),(20810725,15018,'./task.php'),(20810724,8125,'./task.php'),(20810723,11618,'./task.php'),(20810722,262,'./task.php'),(20810721,197,'./task.php'),(20810720,59,'./task.php'),(20810719,9223,'./survey.php'),(20810718,9222,'./survey.php'),(20810717,9221,'./survey.php'),(20810716,3037,'./survey.php'),(20810715,9220,'./survey.php'),(20810714,9219,'./survey.php'),(20810713,9218,'./survey.php'),(20810712,2702,'./survey.php'),(20810711,9217,'./survey.php'),(20810710,9216,'./survey.php'),(20810709,9215,'./survey.php'),(20810708,9637,'./survey.php'),(20810707,541,'./survey.php'),(20810706,13881,'./survey.php'),(20810705,5830,'./std_acts_popup.php'),(20810704,5823,'./std_acts_popup.php'),(20810703,5777,'./std_acts_popup.php'),(20810702,1590,'./std_acts_popup.php'),(20810701,542,'./std_acts_popup.php'),(20810700,315,'./std_acts_popup.php'),(20810699,6000,'./state_addupdate.php'),(20810698,5999,'./state_addupdate.php'),(20810697,6001,'./state_addupdate.php'),(20810696,14399,'./state_addupdate.php'),(20810695,14398,'./state_addupdate.php'),(20810694,2936,'./state_addupdate.php'),(20810693,13895,'./state_addupdate.php'),(20810692,5998,'./state_addupdate.php'),(20810691,5997,'./state_addupdate.php'),(20810690,2702,'./state_addupdate.php'),(20810689,14397,'./state_addupdate.php'),(20810688,12811,'./state_addupdate.php'),(20810687,12008,'./state_addupdate.php'),(20810686,1935,'./state_addupdate.php'),(20810685,14396,'./state_addupdate.php'),(20810684,4699,'./state_addupdate.php'),(20810683,5271,'./state_addupdate.php'),(20810682,5996,'./state_addupdate.php'),(20810681,941,'./state_addupdate.php'),(20810680,5995,'./state_addupdate.php'),(20810679,799,'./state_addupdate.php'),(20810678,659,'./state_addupdate.php'),(20810677,315,'./state_addupdate.php'),(20810676,4871,'./state_addupdate.php'),(20810675,14395,'./state_addupdate.php'),(20810674,5994,'./state_addupdate.php'),(20810673,59,'./state_addupdate.php'),(20810672,9827,'./stagechangeorders.php'),(20810671,13051,'./stagechangeorders.php'),(20810670,13050,'./stagechangeorders.php'),(20810669,9135,'./stagechangeorders.php'),(20810668,13049,'./stagechangeorders.php'),(20810667,2702,'./stagechangeorders.php'),(20810666,9826,'./stagechangeorders.php'),(20810665,13048,'./stagechangeorders.php'),(20810664,13047,'./stagechangeorders.php'),(20810663,2182,'./stagechangeorders.php'),(20810662,2099,'./stagechangeorders.php'),(20810661,1963,'./stagechangeorders.php'),(20810660,13046,'./stagechangeorders.php'),(20810659,13045,'./stagechangeorders.php'),(20810658,13044,'./stagechangeorders.php'),(20810657,9827,'./stagechange.php'),(20810656,9826,'./stagechange.php'),(20810655,8114,'./stagechange.php'),(20810654,9827,'./stagebarcodelist.php'),(20810653,13043,'./stagebarcodelist.php'),(20810652,8936,'./stagebarcodelist.php'),(20810651,542,'./stagebarcodelist.php'),(20731146,15589,'./site.php'),(20731145,10025,'./site.php'),(20731144,10027,'./site.php'),(20731143,9966,'./site.php'),(20731142,15588,'./site.php'),(20731141,15410,'./site.php'),(20731140,2710,'./site.php'),(20731139,8580,'./site.php'),(20731138,2702,'./site.php'),(20731137,15587,'./site.php'),(20731136,15586,'./site.php'),(20731135,9877,'./site.php'),(20731134,9876,'./site.php'),(20731133,1788,'./site.php'),(20731132,10021,'./site.php'),(20731131,1476,'./site.php'),(20731130,941,'./site.php'),(20731129,799,'./site.php'),(20731128,10020,'./site.php'),(20731127,13994,'./site.php'),(20731126,315,'./site.php'),(20731125,5203,'./site.php'),(20731124,59,'./site.php'),(20690531,8019,'./sidemenu.php'),(20690530,9032,'./sidemenu.php'),(20690529,9022,'./sidemenu.php'),(20690528,9031,'./sidemenu.php'),(20690527,9021,'./sidemenu.php'),(20690526,9030,'./sidemenu.php'),(20690525,9020,'./sidemenu.php'),(20690524,9029,'./sidemenu.php'),(20690523,9019,'./sidemenu.php'),(20690522,9028,'./sidemenu.php'),(20690521,9018,'./sidemenu.php'),(20690520,9027,'./sidemenu.php'),(20690519,9017,'./sidemenu.php'),(20690518,9026,'./sidemenu.php'),(20690517,9016,'./sidemenu.php'),(20690516,9025,'./sidemenu.php'),(20690515,9015,'./sidemenu.php'),(20690514,9024,'./sidemenu.php'),(20690513,9014,'./sidemenu.php'),(20690512,9104,'./sidemenu.php'),(20690511,8936,'./sidemenu.php'),(20690510,9023,'./sidemenu.php'),(20690509,5225,'./shipping.php'),(20690508,5224,'./shipping.php'),(20690507,2833,'./shipping.php'),(20690506,2702,'./shipping.php'),(20690505,4583,'./shipping.php'),(20690504,5223,'./shipping.php'),(20690503,5222,'./shipping.php'),(20690502,5221,'./shipping.php'),(20690501,5119,'./shipping.php'),(20690500,5220,'./shipping.php'),(20690499,5219,'./shipping.php'),(20690498,5218,'./shipping.php'),(20690497,5217,'./shipping.php'),(20690496,5216,'./shipping.php'),(20690495,5215,'./shipping.php'),(20690494,416,'./shipping.php'),(20690493,59,'./shipping.php'),(20810650,3381,'./serviceorder_time_view.php'),(20810649,5637,'./serviceorder_time_view.php'),(20810648,5617,'./serviceorder_time_view.php'),(20810647,3090,'./serviceorder_time_view.php'),(20810646,5656,'./serviceorder_time_view.php'),(20810645,5633,'./serviceorder_time_view.php'),(20810644,2103,'./serviceorder_time_view.php'),(20810643,1564,'./serviceorder_time_view.php'),(20810642,737,'./serviceorder_time_view.php'),(20810641,3947,'./serviceorder_time_view.php'),(20810640,542,'./serviceorder_time_view.php'),(20810639,3381,'./serviceorder_time_reporter.php'),(20810638,5617,'./serviceorder_time_reporter.php'),(20810637,5616,'./serviceorder_time_reporter.php'),(20810636,7079,'./serviceorder_time_reporter.php'),(20810635,3097,'./serviceorder_time_reporter.php'),(20810634,7078,'./serviceorder_time_reporter.php'),(20810633,7077,'./serviceorder_time_reporter.php'),(20810632,3090,'./serviceorder_time_reporter.php'),(20810631,5732,'./serviceorder_time_reporter.php'),(20810630,5631,'./serviceorder_time_reporter.php'),(20810629,5731,'./serviceorder_time_reporter.php'),(20810628,7840,'./serviceorder_time_reporter.php'),(20810627,5730,'./serviceorder_time_reporter.php'),(20810626,7839,'./serviceorder_time_reporter.php'),(20810625,5633,'./serviceorder_time_reporter.php'),(20810624,2165,'./serviceorder_time_reporter.php'),(20810623,2103,'./serviceorder_time_reporter.php'),(20810622,1963,'./serviceorder_time_reporter.php'),(20810621,7076,'./serviceorder_time_reporter.php'),(20810620,7071,'./serviceorder_time_reporter.php'),(20810619,19511,'./serviceorder_time_reporter.php'),(20810618,1564,'./serviceorder_time_reporter.php'),(20810617,9598,'./serviceorder_time_reporter.php'),(20810616,1019,'./serviceorder_time_reporter.php'),(20810615,5613,'./serviceorder_time_reporter.php'),(20810614,901,'./serviceorder_time_reporter.php'),(20810613,737,'./serviceorder_time_reporter.php'),(20810612,4481,'./serviceorder_time_reporter.php'),(20810611,3947,'./serviceorder_time_reporter.php'),(20810610,607,'./serviceorder_time_reporter.php'),(20810609,9597,'./serviceorder_time_reporter.php'),(20810608,7837,'./serviceorder_time_reporter.php'),(20810607,7836,'./serviceorder_time_reporter.php'),(20810606,7835,'./serviceorder_time_reporter.php'),(20810605,7834,'./serviceorder_time_reporter.php'),(20810604,8064,'./serviceorder_time_reporter.php'),(20810603,337,'./serviceorder_time_reporter.php'),(20810602,315,'./serviceorder_time_reporter.php'),(20810600,5637,'./serviceorder_time_editor.php'),(20810599,4298,'./serviceorder_time_editor.php'),(20810598,5617,'./serviceorder_time_editor.php'),(20810597,5616,'./serviceorder_time_editor.php'),(20810596,3221,'./serviceorder_time_editor.php'),(20810595,3202,'./serviceorder_time_editor.php'),(20810594,5636,'./serviceorder_time_editor.php'),(20810593,5732,'./serviceorder_time_editor.php'),(20810592,7075,'./serviceorder_time_editor.php'),(20810591,2849,'./serviceorder_time_editor.php'),(20810590,7833,'./serviceorder_time_editor.php'),(20810589,2702,'./serviceorder_time_editor.php'),(20810588,5633,'./serviceorder_time_editor.php'),(20810587,5933,'./serviceorder_time_editor.php'),(20810586,12091,'./serviceorder_time_editor.php'),(20810585,2103,'./serviceorder_time_editor.php'),(20810584,7683,'./serviceorder_time_editor.php'),(20810583,1564,'./serviceorder_time_editor.php'),(20810582,1019,'./serviceorder_time_editor.php'),(20810581,7873,'./serviceorder_time_editor.php'),(20810580,5613,'./serviceorder_time_editor.php'),(20810579,901,'./serviceorder_time_editor.php'),(20810578,799,'./serviceorder_time_editor.php'),(20810577,737,'./serviceorder_time_editor.php'),(20810576,3947,'./serviceorder_time_editor.php'),(20810575,337,'./serviceorder_time_editor.php'),(20810574,315,'./serviceorder_time_editor.php'),(20810573,204,'./serviceorder_time_editor.php'),(20811202,8936,'./includes/aiproducts.php'),(20810572,3381,'./serviceorder_time.php'),(20810571,5617,'./serviceorder_time.php'),(20810570,5616,'./serviceorder_time.php'),(20810569,3202,'./serviceorder_time.php'),(20810568,15257,'./serviceorder_time.php'),(20810567,5615,'./serviceorder_time.php'),(20810566,7832,'./serviceorder_time.php'),(20810565,5614,'./serviceorder_time.php'),(20810564,5631,'./serviceorder_time.php'),(20810563,8124,'./serviceorder_time.php'),(20810562,14916,'./serviceorder_time.php'),(20810561,2702,'./serviceorder_time.php'),(20810560,6043,'./serviceorder_time.php'),(20810559,12845,'./serviceorder_time.php'),(20810558,12844,'./serviceorder_time.php'),(20810557,6887,'./serviceorder_time.php'),(20810556,2165,'./serviceorder_time.php'),(20810555,5629,'./serviceorder_time.php'),(20810554,7072,'./serviceorder_time.php'),(20810553,7071,'./serviceorder_time.php'),(20810552,7831,'./serviceorder_time.php'),(20810551,7830,'./serviceorder_time.php'),(20810550,7829,'./serviceorder_time.php'),(20810549,1564,'./serviceorder_time.php'),(20810548,5613,'./serviceorder_time.php'),(20810547,737,'./serviceorder_time.php'),(20810546,3930,'./serviceorder_time.php'),(20810545,5612,'./serviceorder_time.php'),(20810544,6042,'./serviceorder_time.php'),(20810543,5936,'./serviceorder_time.php'),(20810542,315,'./serviceorder_time.php'),(20810541,5628,'./serviceorder_time.php'),(20810540,8093,'./serviceorder_prepaid_time.php'),(20810539,4298,'./serviceorder_prepaid_time.php'),(20810538,8090,'./serviceorder_prepaid_time.php'),(20810537,3202,'./serviceorder_prepaid_time.php'),(20810536,8092,'./serviceorder_prepaid_time.php'),(20810535,7832,'./serviceorder_prepaid_time.php'),(20810534,2702,'./serviceorder_prepaid_time.php'),(20810533,2565,'./serviceorder_prepaid_time.php'),(20810532,9367,'./serviceorder_prepaid_time.php'),(20810531,8091,'./serviceorder_prepaid_time.php'),(20810530,2165,'./serviceorder_prepaid_time.php'),(20810529,8086,'./serviceorder_prepaid_time.php'),(20810528,8085,'./serviceorder_prepaid_time.php'),(20810527,7831,'./serviceorder_prepaid_time.php'),(20810526,8101,'./serviceorder_prepaid_time.php'),(20810525,7829,'./serviceorder_prepaid_time.php'),(20810524,1564,'./serviceorder_prepaid_time.php'),(20810523,799,'./serviceorder_prepaid_time.php'),(20810522,737,'./serviceorder_prepaid_time.php'),(20810521,5936,'./serviceorder_prepaid_time.php'),(20810520,315,'./serviceorder_prepaid_time.php'),(20810519,4825,'./saveorder.inc'),(20810518,5604,'./saveorder.inc'),(20810517,3922,'./saveorder.inc'),(20810516,4809,'./saveorder.inc'),(20810515,4850,'./saveorder.inc'),(20810514,1922,'./saveorder.inc'),(20810513,4849,'./saveorder.inc'),(20810512,5599,'./saveorder.inc'),(20810511,4776,'./saveorder.inc'),(20810510,4745,'./saveorder.inc'),(20810509,3125,'./salestracker_addupdate.php'),(20810508,3971,'./salestracker_addupdate.php'),(20810507,3972,'./salestracker_addupdate.php'),(20810506,2702,'./salestracker_addupdate.php'),(20810505,7828,'./salestracker_addupdate.php'),(20810504,2666,'./salestracker_addupdate.php'),(20810503,2698,'./salestracker_addupdate.php'),(20810502,2490,'./salestracker_addupdate.php'),(20810501,2103,'./salestracker_addupdate.php'),(20810500,1968,'./salestracker_addupdate.php'),(20810499,1966,'./salestracker_addupdate.php'),(20810498,1967,'./salestracker_addupdate.php'),(20810497,806,'./salestracker_addupdate.php'),(20810496,799,'./salestracker_addupdate.php'),(20810495,737,'./salestracker_addupdate.php'),(20810494,3968,'./salestracker_addupdate.php'),(20810493,315,'./salestracker_addupdate.php'),(20810492,3967,'./salestracker_addupdate.php'),(20810491,4871,'./salestracker_addupdate.php'),(20810490,260,'./salestracker_addupdate.php'),(20810489,67,'./salestracker_addupdate.php'),(20810488,59,'./salestracker_addupdate.php'),(20730960,7070,'./salesterritory.php'),(20730959,7069,'./salesterritory.php'),(20730958,2710,'./salesterritory.php'),(20730957,2702,'./salesterritory.php'),(20730956,7068,'./salesterritory.php'),(20730955,7067,'./salesterritory.php'),(20730954,7066,'./salesterritory.php'),(20730953,851,'./salesterritory.php'),(20730952,806,'./salesterritory.php'),(20730951,799,'./salesterritory.php'),(20730950,542,'./salesterritory.php'),(20730949,7065,'./salesterritory.php'),(20730948,315,'./salesterritory.php'),(20730947,5203,'./salesterritory.php'),(20810487,3164,'./salesstatlst.php'),(20810486,2948,'./salesstatlst.php'),(20810485,2899,'./salesstatlst.php'),(20810484,2685,'./salesstatlst.php'),(20810483,2674,'./salesstatlst.php'),(20810482,2698,'./salesstatlst.php'),(20810481,2368,'./salesstatlst.php'),(20810480,2324,'./salesstatlst.php'),(20810479,2292,'./salesstatlst.php'),(20810478,2206,'./salesstatlst.php'),(20810477,4116,'./salesstatlst.php'),(20810476,2103,'./salesstatlst.php'),(20810475,1963,'./salesstatlst.php'),(20810474,1934,'./salesstatlst.php'),(20810473,1797,'./salesstatlst.php'),(20810472,1795,'./salesstatlst.php'),(20810471,1764,'./salesstatlst.php'),(20810470,1555,'./salesstatlst.php'),(20810469,1530,'./salesstatlst.php'),(20810468,1372,'./salesstatlst.php'),(20810467,1347,'./salesstatlst.php'),(20810466,1336,'./salesstatlst.php'),(20810465,1335,'./salesstatlst.php'),(20810464,901,'./salesstatlst.php'),(20810463,869,'./salesstatlst.php'),(20810462,697,'./salesstatlst.php'),(20810461,607,'./salesstatlst.php'),(20810460,605,'./salesstatlst.php'),(20810459,564,'./salesstatlst.php'),(20810458,563,'./salesstatlst.php'),(20810457,451,'./salesstatlst.php'),(20810456,3164,'./salesprocess_addupdate.php'),(20810455,2899,'./salesprocess_addupdate.php'),(20810454,2776,'./salesprocess_addupdate.php'),(20810453,2717,'./salesprocess_addupdate.php'),(20810452,2705,'./salesprocess_addupdate.php'),(20810451,2702,'./salesprocess_addupdate.php'),(20810450,2685,'./salesprocess_addupdate.php'),(20810449,7827,'./salesprocess_addupdate.php'),(20810448,2670,'./salesprocess_addupdate.php'),(20810447,2698,'./salesprocess_addupdate.php'),(20810446,2493,'./salesprocess_addupdate.php'),(20810445,2492,'./salesprocess_addupdate.php'),(20810444,2491,'./salesprocess_addupdate.php'),(20810443,2490,'./salesprocess_addupdate.php'),(20810442,2489,'./salesprocess_addupdate.php'),(20810441,2370,'./salesprocess_addupdate.php'),(20810440,2368,'./salesprocess_addupdate.php'),(20810439,2324,'./salesprocess_addupdate.php'),(20810438,2292,'./salesprocess_addupdate.php'),(20810437,2130,'./salesprocess_addupdate.php'),(20810436,2103,'./salesprocess_addupdate.php'),(20810435,1934,'./salesprocess_addupdate.php'),(20810434,1795,'./salesprocess_addupdate.php'),(20810433,1764,'./salesprocess_addupdate.php'),(20810432,1526,'./salesprocess_addupdate.php'),(20810431,1530,'./salesprocess_addupdate.php'),(20810430,1472,'./salesprocess_addupdate.php'),(20810429,1372,'./salesprocess_addupdate.php'),(20810428,1347,'./salesprocess_addupdate.php'),(20810427,1337,'./salesprocess_addupdate.php'),(20810426,981,'./salesprocess_addupdate.php'),(20810425,963,'./salesprocess_addupdate.php'),(20810424,947,'./salesprocess_addupdate.php'),(20810423,941,'./salesprocess_addupdate.php'),(20810422,806,'./salesprocess_addupdate.php'),(20810421,799,'./salesprocess_addupdate.php'),(20810420,3969,'./salesprocess_addupdate.php'),(20810419,3970,'./salesprocess_addupdate.php'),(20810418,605,'./salesprocess_addupdate.php'),(20810417,596,'./salesprocess_addupdate.php'),(20810416,573,'./salesprocess_addupdate.php'),(20810415,451,'./salesprocess_addupdate.php'),(20810414,315,'./salesprocess_addupdate.php'),(20810413,4871,'./salesprocess_addupdate.php'),(20810412,160,'./salesprocess_addupdate.php'),(20810411,5281,'./salesprocess_addupdate.php'),(20810410,138,'./salesprocess_addupdate.php'),(20810409,136,'./salesprocess_addupdate.php'),(20810408,59,'./salesprocess_addupdate.php'),(20690235,4117,'./salescat_addupdate.php'),(20690234,2704,'./salescat_addupdate.php'),(20690233,2702,'./salescat_addupdate.php'),(20690232,7826,'./salescat_addupdate.php'),(20690231,953,'./salescat_addupdate.php'),(20690230,941,'./salescat_addupdate.php'),(20690229,802,'./salescat_addupdate.php'),(20690228,799,'./salescat_addupdate.php'),(20690227,459,'./salescat_addupdate.php'),(20690226,455,'./salescat_addupdate.php'),(20690225,452,'./salescat_addupdate.php'),(20690224,451,'./salescat_addupdate.php'),(20690223,315,'./salescat_addupdate.php'),(20690222,4871,'./salescat_addupdate.php'),(20690221,93,'./salescat_addupdate.php'),(20690220,59,'./salescat_addupdate.php'),(20810407,3164,'./salesactionlst.php'),(20810406,2948,'./salesactionlst.php'),(20810405,2899,'./salesactionlst.php'),(20810404,2685,'./salesactionlst.php'),(20810403,2668,'./salesactionlst.php'),(20810402,2698,'./salesactionlst.php'),(20810401,2368,'./salesactionlst.php'),(20810400,2324,'./salesactionlst.php'),(20810399,2292,'./salesactionlst.php'),(20810398,4116,'./salesactionlst.php'),(20810397,2103,'./salesactionlst.php'),(20810396,1963,'./salesactionlst.php'),(20810395,1939,'./salesactionlst.php'),(20810394,1934,'./salesactionlst.php'),(20810393,1795,'./salesactionlst.php'),(20810392,1764,'./salesactionlst.php'),(20810391,1530,'./salesactionlst.php'),(20810390,1372,'./salesactionlst.php'),(20810389,1347,'./salesactionlst.php'),(20810388,5044,'./salesactionlst.php'),(20810387,901,'./salesactionlst.php'),(20810386,737,'./salesactionlst.php'),(20810385,697,'./salesactionlst.php'),(20810384,607,'./salesactionlst.php'),(20810383,451,'./salesactionlst.php'),(20810382,5043,'./salesactionlst.php'),(20810381,260,'./salesactionlst.php'),(20810380,4115,'./salesactionlst.php'),(20810379,47,'./salesactionlst.php'),(20810378,9690,'./reset_password.php'),(20810377,9661,'./reset_password.php'),(20810376,2622,'./reset_password.php'),(20810375,14629,'./reset_password.php'),(20810374,13188,'./reset_password.php'),(20810373,13186,'./reset_password.php'),(20810372,13185,'./reset_password.php'),(20810371,14628,'./reset_password.php'),(20810370,2237,'./reset_password.php'),(20810369,2234,'./reset_password.php'),(20730817,3427,'./reprint_order_ticketpdf.php'),(20730816,3450,'./reprint_order_ticketpdf.php'),(20730815,5125,'./reprint_order_ticketpdf.php'),(20730814,5124,'./reprint_order_ticketpdf.php'),(20730813,5123,'./reprint_order_ticketpdf.php'),(20730812,5122,'./reprint_order_ticketpdf.php'),(20730811,4569,'./reprint_order_ticketpdf.php'),(20730810,2819,'./reprint_order_ticketpdf.php'),(20730809,4732,'./reprint_order_ticketpdf.php'),(20730808,2816,'./reprint_order_ticketpdf.php'),(20730807,5121,'./reprint_order_ticketpdf.php'),(20730806,4680,'./reprint_order_ticketpdf.php'),(20730805,4729,'./reprint_order_ticketpdf.php'),(20730804,4728,'./reprint_order_ticketpdf.php'),(20730803,4803,'./reprint_order_ticketpdf.php'),(20730802,5120,'./reprint_order_ticketpdf.php'),(20730801,5119,'./reprint_order_ticketpdf.php'),(20730800,5118,'./reprint_order_ticketpdf.php'),(20730799,5117,'./reprint_order_ticketpdf.php'),(20730798,5116,'./reprint_order_ticketpdf.php'),(20730797,5115,'./reprint_order_ticketpdf.php'),(20730796,4725,'./reprint_order_ticketpdf.php'),(20730795,5114,'./reprint_order_ticketpdf.php'),(20730794,2367,'./reprint_order_ticketpdf.php'),(20730793,5113,'./reprint_order_ticketpdf.php'),(20730792,5112,'./reprint_order_ticketpdf.php'),(20730791,5111,'./reprint_order_ticketpdf.php'),(20730790,5110,'./reprint_order_ticketpdf.php'),(20730789,5109,'./reprint_order_ticketpdf.php'),(20730788,5108,'./reprint_order_ticketpdf.php'),(20730787,5107,'./reprint_order_ticketpdf.php'),(20730786,5106,'./reprint_order_ticketpdf.php'),(20730785,4721,'./reprint_order_ticketpdf.php'),(20730784,5105,'./reprint_order_ticketpdf.php'),(20730783,5104,'./reprint_order_ticketpdf.php'),(20730782,5103,'./reprint_order_ticketpdf.php'),(20730781,5081,'./reprint_order_ticketpdf.php'),(20730780,5102,'./reprint_order_ticketpdf.php'),(20730779,1610,'./reprint_order_ticketpdf.php'),(20730778,1425,'./reprint_order_ticketpdf.php'),(20730777,1373,'./reprint_order_ticketpdf.php'),(20730776,981,'./reprint_order_ticketpdf.php'),(20730775,869,'./reprint_order_ticketpdf.php'),(20730774,5101,'./reprint_order_ticketpdf.php'),(20730773,4364,'./reprint_order_ticketpdf.php'),(20730772,5100,'./reprint_order_ticketpdf.php'),(20730771,695,'./reprint_order_ticketpdf.php'),(20730770,5099,'./reprint_order_ticketpdf.php'),(20730769,540,'./reprint_order_ticketpdf.php'),(20730768,5098,'./reprint_order_ticketpdf.php'),(20730767,5097,'./reprint_order_ticketpdf.php'),(20730766,5096,'./reprint_order_ticketpdf.php'),(20730765,5095,'./reprint_order_ticketpdf.php'),(20810358,3421,'./reprint_order_ticket.php'),(20810357,4739,'./reprint_order_ticket.php'),(20810356,3273,'./reprint_order_ticket.php'),(20810355,3450,'./reprint_order_ticket.php'),(20810354,3156,'./reprint_order_ticket.php'),(20810353,4738,'./reprint_order_ticket.php'),(20810352,4737,'./reprint_order_ticket.php'),(20810351,4736,'./reprint_order_ticket.php'),(20810350,4735,'./reprint_order_ticket.php'),(20810349,4734,'./reprint_order_ticket.php'),(20810348,4733,'./reprint_order_ticket.php'),(20810347,5610,'./reprint_order_ticket.php'),(20810346,4732,'./reprint_order_ticket.php'),(20810345,4663,'./reprint_order_ticket.php'),(20810344,4731,'./reprint_order_ticket.php'),(20810343,2661,'./reprint_order_ticket.php'),(20810342,4730,'./reprint_order_ticket.php'),(20810341,4729,'./reprint_order_ticket.php'),(20810340,4806,'./reprint_order_ticket.php'),(20810339,4728,'./reprint_order_ticket.php'),(20810338,2529,'./reprint_order_ticket.php'),(20810337,4727,'./reprint_order_ticket.php'),(20810336,2471,'./reprint_order_ticket.php'),(20810335,4725,'./reprint_order_ticket.php'),(20810334,3906,'./reprint_order_ticket.php'),(20810333,4724,'./reprint_order_ticket.php'),(20810332,2324,'./reprint_order_ticket.php'),(20810331,5609,'./reprint_order_ticket.php'),(20810330,3436,'./reprint_order_ticket.php'),(20810329,4723,'./reprint_order_ticket.php'),(20810328,2182,'./reprint_order_ticket.php'),(20810327,2136,'./reprint_order_ticket.php'),(20810326,2125,'./reprint_order_ticket.php'),(20810325,4102,'./reprint_order_ticket.php'),(20810324,2123,'./reprint_order_ticket.php'),(20810323,5608,'./reprint_order_ticket.php'),(20810322,5607,'./reprint_order_ticket.php'),(20810321,4722,'./reprint_order_ticket.php'),(20810320,2103,'./reprint_order_ticket.php'),(20810319,2090,'./reprint_order_ticket.php'),(20810318,1973,'./reprint_order_ticket.php'),(20810317,1963,'./reprint_order_ticket.php'),(20810316,4721,'./reprint_order_ticket.php'),(20810315,1884,'./reprint_order_ticket.php'),(20810314,4720,'./reprint_order_ticket.php'),(20810313,4719,'./reprint_order_ticket.php'),(20810312,3435,'./reprint_order_ticket.php'),(20810311,1592,'./reprint_order_ticket.php'),(20810310,1589,'./reprint_order_ticket.php'),(20810309,1425,'./reprint_order_ticket.php'),(20810308,1373,'./reprint_order_ticket.php'),(20810307,4718,'./reprint_order_ticket.php'),(20810306,1030,'./reprint_order_ticket.php'),(20810305,981,'./reprint_order_ticket.php'),(20810304,869,'./reprint_order_ticket.php'),(20810303,865,'./reprint_order_ticket.php'),(20810302,4717,'./reprint_order_ticket.php'),(20810301,4416,'./reprint_order_ticket.php'),(20810300,4363,'./reprint_order_ticket.php'),(20810299,6228,'./reprint_order_ticket.php'),(20810298,697,'./reprint_order_ticket.php'),(20810297,695,'./reprint_order_ticket.php'),(20810296,4690,'./reprint_order_ticket.php'),(20810295,606,'./reprint_order_ticket.php'),(20810294,3981,'./reprint_order_ticket.php'),(20810293,4715,'./reprint_order_ticket.php'),(20810292,4714,'./reprint_order_ticket.php'),(20810291,4713,'./reprint_order_ticket.php'),(20810290,3274,'./recent_vendors.php'),(20810289,14508,'./recent_vendors.php'),(20810288,2022,'./recent_vendors.php'),(20810287,5003,'./recent_pr_paychanges.php'),(20810286,2022,'./recent_pr_paychanges.php'),(20810285,1935,'./recent_pr_paychanges.php'),(20810284,1556,'./recent_pr_paychanges.php'),(20810283,7056,'./recent_pr_paychanges.php'),(20810282,4991,'./recent_pr_layoffs.php'),(20810281,2022,'./recent_pr_layoffs.php'),(20810280,1935,'./recent_pr_layoffs.php'),(20810279,1556,'./recent_pr_layoffs.php'),(20810278,4999,'./recent_pr_layoffs.php'),(20810277,2022,'./recent_pr_hires.php'),(20810276,5002,'./recent_pr_hires.php'),(20810275,1935,'./recent_pr_hires.php'),(20810274,1556,'./recent_pr_hires.php'),(20810273,14507,'./recent_items.php'),(20810272,2022,'./recent_items.php'),(20810271,1713,'./recent_items.php'),(20810270,1709,'./recent_items.php'),(20810269,3432,'./recent_customers.php'),(20810268,2936,'./recent_customers.php'),(20810267,3434,'./recent_customers.php'),(20810266,10122,'./recent_customers.php'),(20810265,10591,'./recent_customers.php'),(20810264,7063,'./recent_customers.php'),(20810263,2324,'./recent_customers.php'),(20810262,2170,'./recent_customers.php'),(20810261,8350,'./recent_customers.php'),(20810260,2018,'./recent_customers.php'),(20810259,1963,'./recent_customers.php'),(20810258,7062,'./recent_customers.php'),(20810257,11351,'./recent_customers.php'),(20810256,6718,'./recent_customers.php'),(20810255,1036,'./recent_customers.php'),(20810254,11350,'./recent_customers.php'),(20810253,10120,'./recent_customers.php'),(20810252,1014,'./recent_customers.php'),(20810251,11349,'./recent_customers.php'),(20810250,11348,'./recent_customers.php'),(20810249,4481,'./recent_customers.php'),(20810248,697,'./recent_customers.php'),(20810247,665,'./recent_customers.php'),(20810246,524,'./recent_customers.php'),(20810245,6565,'./recent_customers.php'),(20810244,315,'./recent_customers.php'),(20810243,250,'./recent_customers.php'),(20810242,8349,'./recent_customers.php'),(20810241,226,'./recent_customers.php'),(20810240,185,'./recent_customers.php'),(20810239,8860,'./qbimport_vendor.php'),(20810238,3035,'./qbimport_vendor.php'),(20810237,8859,'./qbimport_vendor.php'),(20810236,2324,'./qbimport_vendor.php'),(20810235,2044,'./qbimport_vendor.php'),(20810234,8835,'./qbimport_vendor.php'),(20810233,1373,'./qbimport_vendor.php'),(20810232,981,'./qbimport_vendor.php'),(20810231,581,'./qbimport_vendor.php'),(20810230,185,'./qbimport_vendor.php'),(20810229,30,'./qbimport_vendor.php'),(20810228,8858,'./qbimport_terms.php'),(20810227,3035,'./qbimport_terms.php'),(20810226,2044,'./qbimport_terms.php'),(20810225,1942,'./qbimport_terms.php'),(20810224,898,'./qbimport_terms.php'),(20810223,894,'./qbimport_terms.php'),(20810222,8871,'./qbimport_salestax.php'),(20810221,2565,'./qbimport_salestax.php'),(20810220,2044,'./qbimport_salestax.php'),(20810219,1935,'./qbimport_salestax.php'),(20810218,8857,'./qbimport_salesrep.php'),(20810217,2044,'./qbimport_salesrep.php'),(20810216,1935,'./qbimport_salesrep.php'),(20810215,8856,'./qbimport_pricelevel.php'),(20810214,2044,'./qbimport_pricelevel.php'),(20810213,1935,'./qbimport_pricelevel.php'),(20810212,3274,'./qbimport_item.php'),(20810211,2665,'./qbimport_item.php'),(20810210,2515,'./qbimport_item.php'),(20810209,2404,'./qbimport_item.php'),(20810208,2044,'./qbimport_item.php'),(20810207,6342,'./qbimport_item.php'),(20810206,8855,'./qbimport_item.php'),(20810205,1709,'./qbimport_item.php'),(20810204,8854,'./qbimport_item.php'),(20810203,869,'./qbimport_item.php'),(20810202,616,'./qbimport_item.php'),(20810201,8853,'./qbimport_item.php'),(20810200,55,'./qbimport_item.php'),(20810199,3035,'./qbimport_invoice.php'),(20810198,2363,'./qbimport_invoice.php'),(20810197,2225,'./qbimport_invoice.php'),(20810196,2044,'./qbimport_invoice.php'),(20810195,8870,'./qbimport_invoice.php'),(20810194,1678,'./qbimport_invoice.php'),(20810193,8867,'./qbimport_invoice.php'),(20810192,8936,'./qbimport_invoice.php'),(20810191,932,'./qbimport_invoice.php'),(20810190,697,'./qbimport_invoice.php'),(20810189,9010,'./qbimport_invoice.php'),(20810188,9009,'./qbimport_invoice.php'),(20810187,325,'./qbimport_invoice.php'),(20810186,5144,'./qbimport_invoice.php'),(20810185,5145,'./qbimport_invoice.php'),(20810184,226,'./qbimport_invoice.php'),(20810183,8852,'./qbimport_glaccount.php'),(20810182,8851,'./qbimport_glaccount.php'),(20810181,2285,'./qbimport_glaccount.php'),(20810180,2109,'./qbimport_glaccount.php'),(20810179,2044,'./qbimport_glaccount.php'),(20810178,8850,'./qbimport_glaccount.php'),(20810177,8849,'./qbimport_glaccount.php'),(20810176,1935,'./qbimport_glaccount.php'),(20810175,1663,'./qbimport_glaccount.php'),(20810174,8848,'./qbimport_glaccount.php'),(20810173,8847,'./qbimport_glaccount.php'),(20810172,325,'./qbimport_glaccount.php'),(20810171,285,'./qbimport_glaccount.php'),(20810170,268,'./qbimport_glaccount.php'),(20810169,3421,'./qbimport_functions.php'),(20810168,3090,'./qbimport_functions.php'),(20810167,5008,'./qbimport_functions.php'),(20810166,8846,'./qbimport_functions.php'),(20810165,8845,'./qbimport_functions.php'),(20810164,1973,'./qbimport_functions.php'),(20810163,1561,'./qbimport_functions.php'),(20810162,8844,'./qbimport_functions.php'),(20810161,8878,'./qbimport_functions.php'),(20810160,8877,'./qbimport_functions.php'),(20810159,3267,'./qbimport_employee.php'),(20810158,2914,'./qbimport_employee.php'),(20810157,8843,'./qbimport_employee.php'),(20810156,2324,'./qbimport_employee.php'),(20810155,2244,'./qbimport_employee.php'),(20810154,2243,'./qbimport_employee.php'),(20810153,2044,'./qbimport_employee.php'),(20810152,1935,'./qbimport_employee.php'),(20810151,7051,'./qbimport_employee.php'),(20810150,1373,'./qbimport_employee.php'),(20810149,8842,'./qbimport_employee.php'),(20810148,8841,'./qbimport_employee.php'),(20810147,8840,'./qbimport_employee.php'),(20810146,981,'./qbimport_employee.php'),(20810145,8839,'./qbimport_employee.php'),(20810144,8838,'./qbimport_employee.php'),(20810143,8837,'./qbimport_employee.php'),(20810142,185,'./qbimport_employee.php'),(20810141,55,'./qbimport_employee.php'),(20810140,3035,'./qbimport_customer.php'),(20810139,8836,'./qbimport_customer.php'),(20810138,2324,'./qbimport_customer.php'),(20810137,2044,'./qbimport_customer.php'),(20810136,2103,'./qbimport_customer.php'),(20810135,8835,'./qbimport_customer.php'),(20810134,981,'./qbimport_customer.php'),(20810133,8834,'./qbimport_customer.php'),(20810132,675,'./qbimport_customer.php'),(20810131,581,'./qbimport_customer.php'),(20810130,8833,'./qbimport_customer.php'),(20810129,30,'./qbimport_customer.php'),(20810128,8832,'./qbimport_buttons.php'),(20810127,8831,'./qbimport_buttons.php'),(20810126,8868,'./qbimport_buttons.php'),(20810125,1963,'./qbimport_buttons.php'),(20810124,5271,'./qbimport_buttons.php'),(20810123,315,'./qbimport_buttons.php'),(20810122,8830,'./qbimport_buttons.php'),(20810121,3421,'./qbimport_bill.php'),(20810120,3274,'./qbimport_bill.php'),(20810119,3035,'./qbimport_bill.php'),(20810118,2238,'./qbimport_bill.php'),(20810117,2225,'./qbimport_bill.php'),(20810116,2044,'./qbimport_bill.php'),(20810115,1973,'./qbimport_bill.php'),(20810114,1678,'./qbimport_bill.php'),(20810113,8867,'./qbimport_bill.php'),(20810112,932,'./qbimport_bill.php'),(20810111,9008,'./qbimport_bill.php'),(20810110,8865,'./qbimport_bill.php'),(20810109,226,'./qbimport_bill.php'),(20810108,12770,'./qbimport.php'),(20810107,13473,'./qbimport.php'),(20810106,3480,'./qbimport.php'),(20810105,13472,'./qbimport.php'),(20810104,12769,'./qbimport.php'),(20810103,3035,'./qbimport.php'),(20810102,2948,'./qbimport.php'),(20810101,13471,'./qbimport.php'),(20810100,3812,'./qbimport.php'),(20810099,8829,'./qbimport.php'),(20810098,8864,'./qbimport.php'),(20810097,13470,'./qbimport.php'),(20810096,8827,'./qbimport.php'),(20810095,8826,'./qbimport.php'),(20810094,8825,'./qbimport.php'),(20810093,8824,'./qbimport.php'),(20810092,8876,'./qbimport.php'),(20810091,12767,'./qbimport.php'),(20810090,12761,'./qbimport.php'),(20810089,13469,'./qbimport.php'),(20810088,2234,'./qbimport.php'),(20810087,1963,'./qbimport.php'),(20810086,1911,'./qbimport.php'),(20810085,1740,'./qbimport.php'),(20810084,4940,'./qbimport.php'),(20810083,11851,'./qbimport.php'),(20810082,13468,'./qbimport.php'),(20810081,13467,'./qbimport.php'),(20810080,13466,'./qbimport.php'),(20810079,5271,'./qbimport.php'),(20810078,8822,'./qbimport.php'),(20810077,8821,'./qbimport.php'),(20810076,13465,'./qbimport.php'),(20810075,6166,'./qbimport.php'),(20810074,12766,'./qbimport.php'),(20810073,8936,'./qbimport.php'),(20810072,1047,'./qbimport.php'),(20810071,3467,'./qbimport.php'),(20810070,8863,'./qbimport.php'),(20810069,3458,'./qbimport.php'),(20810068,8820,'./qbimport.php'),(20810067,8862,'./qbimport.php'),(20810066,8875,'./qbimport.php'),(20810065,13710,'./qbimport.php'),(20810064,12765,'./qbexportstatus.php'),(20810063,12764,'./qbexportstatus.php'),(20810062,12763,'./qbexportstatus.php'),(20810061,12097,'./qbexportstatus.php'),(20810060,12761,'./qbexportstatus.php'),(20810059,12760,'./qbexportstatus.php'),(20810058,12759,'./qbexportstatus.php'),(20810057,1911,'./qbexportstatus.php'),(20810056,12758,'./qbexportstatus.php'),(20810055,12757,'./qbexportstatus.php'),(20810054,12756,'./qbexportstatus.php'),(20810053,12755,'./qbexportstatus.php'),(20810052,12754,'./qbexportstatus.php'),(20810051,12753,'./qbexportstatus.php'),(20810050,12752,'./qbexportstatus.php'),(20810049,12751,'./qbexportstatus.php'),(20810048,12843,'./qbexportstatus.php'),(20810047,12750,'./qbexportstatus.php'),(20810046,8936,'./qbexportstatus.php'),(20810045,12749,'./qbexportstatus.php'),(20810044,745,'./qbexportstatus.php'),(20810043,8936,'./qbexportfile.php'),(20810042,3415,'./prworkmanscomp.php'),(20810041,7825,'./prworkmanscomp.php'),(20810040,7824,'./prworkmanscomp.php'),(20810039,3402,'./prworkmanscomp.php'),(20810038,15424,'./prworkmanscomp.php'),(20810037,17622,'./prworkmanscomp.php'),(20810036,7047,'./prworkmanscomp.php'),(20810035,7046,'./prworkmanscomp.php'),(20810034,7823,'./prworkmanscomp.php'),(20810033,3090,'./prworkmanscomp.php'),(20810032,3068,'./prworkmanscomp.php'),(20810031,3067,'./prworkmanscomp.php'),(20810030,3031,'./prworkmanscomp.php'),(20810029,2998,'./prworkmanscomp.php'),(20810028,2981,'./prworkmanscomp.php'),(20810027,2939,'./prworkmanscomp.php'),(20810026,2936,'./prworkmanscomp.php'),(20810025,3434,'./prworkmanscomp.php'),(20810024,15415,'./prworkmanscomp.php'),(20810023,15525,'./prworkmanscomp.php'),(20810022,2773,'./prworkmanscomp.php'),(20810021,7045,'./prworkmanscomp.php'),(20810020,2565,'./prworkmanscomp.php'),(20810019,2535,'./prworkmanscomp.php'),(20810018,2321,'./prworkmanscomp.php'),(20810017,2315,'./prworkmanscomp.php'),(20810016,2251,'./prworkmanscomp.php'),(20810015,2225,'./prworkmanscomp.php'),(20810014,5985,'./prworkmanscomp.php'),(20810013,2120,'./prworkmanscomp.php'),(20810012,2055,'./prworkmanscomp.php'),(20810011,2044,'./prworkmanscomp.php'),(20810010,1963,'./prworkmanscomp.php'),(20810009,1945,'./prworkmanscomp.php'),(20810008,1935,'./prworkmanscomp.php'),(20810007,1913,'./prworkmanscomp.php'),(20810006,1906,'./prworkmanscomp.php'),(20810005,1902,'./prworkmanscomp.php'),(20810004,1900,'./prworkmanscomp.php'),(20810003,5706,'./prworkmanscomp.php'),(20810002,1872,'./prworkmanscomp.php'),(20810001,1785,'./prworkmanscomp.php'),(20810000,1782,'./prworkmanscomp.php'),(20809999,7044,'./prworkmanscomp.php'),(20809998,1598,'./prworkmanscomp.php'),(20809997,7043,'./prworkmanscomp.php'),(20809996,7042,'./prworkmanscomp.php'),(20809995,7041,'./prworkmanscomp.php'),(20809994,7040,'./prworkmanscomp.php'),(20809993,7811,'./prworkmanscomp.php'),(20809992,7808,'./prworkmanscomp.php'),(20809991,1536,'./prworkmanscomp.php'),(20809990,7807,'./prworkmanscomp.php'),(20809989,7806,'./prworkmanscomp.php'),(20809988,1471,'./prworkmanscomp.php'),(20809987,1377,'./prworkmanscomp.php'),(20809986,17621,'./prworkmanscomp.php'),(20809985,1014,'./prworkmanscomp.php'),(20809984,1007,'./prworkmanscomp.php'),(20809983,989,'./prworkmanscomp.php'),(20809982,13738,'./prworkmanscomp.php'),(20809981,5715,'./prworkmanscomp.php'),(20809980,7284,'./prworkmanscomp.php'),(20809979,781,'./prworkmanscomp.php'),(20809970,15413,'./prworkerscomp.php'),(20809969,15390,'./prworkerscomp.php'),(20809968,15424,'./prworkerscomp.php'),(20809967,15410,'./prworkerscomp.php'),(20809966,2710,'./prworkerscomp.php'),(20809965,2702,'./prworkerscomp.php'),(20809964,9807,'./prworkerscomp.php'),(20809963,15524,'./prworkerscomp.php'),(20809962,8958,'./prworkerscomp.php'),(20809961,15523,'./prworkerscomp.php'),(20809960,1935,'./prworkerscomp.php'),(20809959,7972,'./prworkerscomp.php'),(20809958,1499,'./prworkerscomp.php'),(20809957,15906,'./prworkerscomp.php'),(20809956,1480,'./prworkerscomp.php'),(20809955,8936,'./prworkerscomp.php'),(20809954,941,'./prworkerscomp.php'),(20809953,799,'./prworkerscomp.php'),(20809952,15522,'./prworkerscomp.php'),(20809951,548,'./prworkerscomp.php'),(20809950,13994,'./prworkerscomp.php'),(20809949,315,'./prworkerscomp.php'),(20809948,5203,'./prworkerscomp.php'),(20809947,59,'./prworkerscomp.php'),(20809946,3427,'./prw2printfpdf.php'),(20809945,7060,'./prw2printfpdf.php'),(20809944,4149,'./prw2printfpdf.php'),(20809943,542,'./prw2printfpdf.php'),(20809942,7059,'./prw2printfpdf.php'),(20809941,315,'./prw2printfpdf.php'),(20730346,3427,'./prw2print.php'),(20730345,4149,'./prw2print.php'),(20730344,540,'./prw2print.php'),(20730343,315,'./prw2print.php'),(20809940,12916,'./prw2file.php'),(20809939,13585,'./prw2file.php'),(20809938,4149,'./prw2file.php'),(20809937,12915,'./prw2file.php'),(20809936,315,'./prw2file.php'),(20809935,12913,'./prw2file.php'),(20809934,3415,'./prw2.php'),(20809933,7949,'./prw2.php'),(20809932,4148,'./prw2.php'),(20809931,2483,'./prw2.php'),(20809930,2459,'./prw2.php'),(20809929,2037,'./prw2.php'),(20809928,12912,'./prw2.php'),(20809927,989,'./prw2.php'),(20809926,12911,'./prw2.php'),(20809925,315,'./prw2.php'),(20809924,12910,'./prw2.php'),(20809923,204,'./prw2.php'),(20809922,3393,'./prtworktypes.php'),(20809921,3381,'./prtworktypes.php'),(20809920,4299,'./prtworktypes.php'),(20809919,4298,'./prtworktypes.php'),(20809918,4297,'./prtworktypes.php'),(20809917,4296,'./prtworktypes.php'),(20809916,4295,'./prtworktypes.php'),(20809915,4294,'./prtworktypes.php'),(20809914,4293,'./prtworktypes.php'),(20809913,4292,'./prtworktypes.php'),(20809912,4291,'./prtworktypes.php'),(20809911,4290,'./prtworktypes.php'),(20809910,4289,'./prtworktypes.php'),(20809909,4288,'./prtworktypes.php'),(20809908,4287,'./prtworktypes.php'),(20809907,2702,'./prtworktypes.php'),(20809906,4265,'./prtworktypes.php'),(20809905,4286,'./prtworktypes.php'),(20809904,4285,'./prtworktypes.php'),(20809903,1963,'./prtworktypes.php'),(20809902,4284,'./prtworktypes.php'),(20809901,4283,'./prtworktypes.php'),(20809900,1935,'./prtworktypes.php'),(20809899,4282,'./prtworktypes.php'),(20809898,4281,'./prtworktypes.php'),(20809897,4239,'./prtworktypes.php'),(20809896,4238,'./prtworktypes.php'),(20809895,4280,'./prtworktypes.php'),(20809894,941,'./prtworktypes.php'),(20809893,4279,'./prtworktypes.php'),(20809892,869,'./prtworktypes.php'),(20809891,799,'./prtworktypes.php'),(20809890,4278,'./prtworktypes.php'),(20809889,451,'./prtworktypes.php'),(20809888,4277,'./prtworktypes.php'),(20809887,4276,'./prtworktypes.php'),(20809886,315,'./prtworktypes.php'),(20809885,5203,'./prtworktypes.php'),(20809884,222,'./prtworktypes.php'),(20809883,4275,'./prtworktypes.php'),(20809882,4274,'./prtworktypes.php'),(20809881,4273,'./prtworktypes.php'),(20809880,4272,'./prtworktypes.php'),(20809879,59,'./prtworktypes.php'),(20809878,4349,'./prtstock_purpose_add.php'),(20809877,2958,'./prtstock_purpose_add.php'),(20809876,2702,'./prtstock_purpose_add.php'),(20809875,3994,'./prtstock_purpose_add.php'),(20809874,315,'./prtstock_purpose_add.php'),(20809873,222,'./prtstock_purpose_add.php'),(20809872,3429,'./prtshipping.php'),(20809871,4591,'./prtshipping.php'),(20809870,4126,'./prtshipping.php'),(20809869,4590,'./prtshipping.php'),(20809868,4589,'./prtshipping.php'),(20809867,4588,'./prtshipping.php'),(20809866,4587,'./prtshipping.php'),(20809865,4586,'./prtshipping.php'),(20809864,4585,'./prtshipping.php'),(20809863,4569,'./prtshipping.php'),(20809862,2819,'./prtshipping.php'),(20809861,2816,'./prtshipping.php'),(20809860,4584,'./prtshipping.php'),(20809859,2795,'./prtshipping.php'),(20809858,5067,'./prtshipping.php'),(20809857,2702,'./prtshipping.php'),(20809856,2606,'./prtshipping.php'),(20809855,4583,'./prtshipping.php'),(20809854,2459,'./prtshipping.php'),(20809853,4582,'./prtshipping.php'),(20809852,4581,'./prtshipping.php'),(20809851,4565,'./prtshipping.php'),(20809850,4580,'./prtshipping.php'),(20809849,4579,'./prtshipping.php'),(20809848,2182,'./prtshipping.php'),(20809847,4578,'./prtshipping.php'),(20809846,2199,'./prtshipping.php'),(20809845,2094,'./prtshipping.php'),(20809844,2103,'./prtshipping.php'),(20809843,1963,'./prtshipping.php'),(20809842,4577,'./prtshipping.php'),(20809841,1810,'./prtshipping.php'),(20809840,4576,'./prtshipping.php'),(20809839,4575,'./prtshipping.php'),(20809838,4574,'./prtshipping.php'),(20809837,4573,'./prtshipping.php'),(20809836,5214,'./prtshipping.php'),(20809835,1047,'./prtshipping.php'),(20809834,799,'./prtshipping.php'),(20809833,4572,'./prtshipping.php'),(20809832,4571,'./prtshipping.php'),(20809831,315,'./prtshipping.php'),(20809830,5203,'./prtshipping.php'),(20809829,258,'./prtshipping.php'),(20809828,4153,'./prtshippedorder.php'),(20809827,2508,'./prtshippedorder.php'),(20809826,2165,'./prtshippedorder.php'),(20809825,4623,'./prtshippedorder.php'),(20809824,2103,'./prtshippedorder.php'),(20809823,1963,'./prtshippedorder.php'),(20809822,4625,'./prtshippedorder.php'),(20809821,869,'./prtshippedorder.php'),(20809820,4416,'./prtshippedorder.php'),(20809819,697,'./prtshippedorder.php'),(20809818,607,'./prtshippedorder.php'),(20809817,4624,'./prtshippedorder.php'),(20809816,5768,'./prtscheduled_shipments.php'),(20809815,5581,'./prtscheduled_shipments.php'),(20809814,2819,'./prtscheduled_shipments.php'),(20809813,5767,'./prtscheduled_shipments.php'),(20809812,2656,'./prtscheduled_shipments.php'),(20809811,2508,'./prtscheduled_shipments.php'),(20809810,2471,'./prtscheduled_shipments.php'),(20809809,2165,'./prtscheduled_shipments.php'),(20809808,1963,'./prtscheduled_shipments.php'),(20809807,1014,'./prtscheduled_shipments.php'),(20809806,4760,'./prtscheduled_shipments.php'),(20809805,697,'./prtscheduled_shipments.php'),(20809804,607,'./prtscheduled_shipments.php'),(20809803,333,'./prtscheduled_shipments.php'),(20689557,3290,'./prtpo_enter_or_update.php'),(20689556,5213,'./prtpo_enter_or_update.php'),(20689555,3212,'./prtpo_enter_or_update.php'),(20689554,5212,'./prtpo_enter_or_update.php'),(20689553,2702,'./prtpo_enter_or_update.php'),(20689552,7822,'./prtpo_enter_or_update.php'),(20689551,1963,'./prtpo_enter_or_update.php'),(20689550,941,'./prtpo_enter_or_update.php'),(20689549,5211,'./prtpo_enter_or_update.php'),(20689548,5210,'./prtpo_enter_or_update.php'),(20689547,5209,'./prtpo_enter_or_update.php'),(20689546,5208,'./prtpo_enter_or_update.php'),(20689545,59,'./prtpo_enter_or_update.php'),(20689544,4855,'./prtpicker.php'),(20689543,1776,'./prtpicker.php'),(20689542,713,'./prtpicker.php'),(20689541,315,'./prtpicker.php'),(20809802,16210,'./prtpendingorder.php'),(20809801,3269,'./prtpendingorder.php'),(20809800,3090,'./prtpendingorder.php'),(20809799,3738,'./prtpendingorder.php'),(20809798,2165,'./prtpendingorder.php'),(20809797,4873,'./prtpendingorder.php'),(20809796,2155,'./prtpendingorder.php'),(20809795,932,'./prtpendingorder.php'),(20809794,869,'./prtpendingorder.php'),(20809793,697,'./prtpendingorder.php'),(20809792,3427,'./prtpackingslip.php'),(20809791,4570,'./prtpackingslip.php'),(20809790,3072,'./prtpackingslip.php'),(20809789,4569,'./prtpackingslip.php'),(20809788,4568,'./prtpackingslip.php'),(20809787,4567,'./prtpackingslip.php'),(20809786,2529,'./prtpackingslip.php'),(20809785,4566,'./prtpackingslip.php'),(20809784,2232,'./prtpackingslip.php'),(20809783,4565,'./prtpackingslip.php'),(20809782,4564,'./prtpackingslip.php'),(20809781,4563,'./prtpackingslip.php'),(20809780,1963,'./prtpackingslip.php'),(20809779,1810,'./prtpackingslip.php'),(20809778,1467,'./prtpackingslip.php'),(20809777,4562,'./prtpackingslip.php'),(20809776,4561,'./prtpackingslip.php'),(20809775,869,'./prtpackingslip.php'),(20809774,737,'./prtpackingslip.php'),(20809773,542,'./prtpackingslip.php'),(20809772,540,'./prtpackingslip.php'),(20809771,6161,'./prtordersearch.php'),(20809770,4455,'./prtordersearch.php'),(20809769,2819,'./prtordersearch.php'),(20809768,2816,'./prtordersearch.php'),(20809767,2645,'./prtordersearch.php'),(20809766,6924,'./prtordersearch.php'),(20809765,2615,'./prtordersearch.php'),(20809764,5084,'./prtordersearch.php'),(20809763,2508,'./prtordersearch.php'),(20809762,2480,'./prtordersearch.php'),(20809761,2363,'./prtordersearch.php'),(20809760,2361,'./prtordersearch.php'),(20809759,2165,'./prtordersearch.php'),(20809758,5083,'./prtordersearch.php'),(20809757,1963,'./prtordersearch.php'),(20809756,5082,'./prtordersearch.php'),(20809755,5081,'./prtordersearch.php'),(20809754,1534,'./prtordersearch.php'),(20809753,1456,'./prtordersearch.php'),(20809752,3995,'./prtordersearch.php'),(20809751,1036,'./prtordersearch.php'),(20809750,5080,'./prtordersearch.php'),(20809749,5079,'./prtordersearch.php'),(20809748,7531,'./prtordersearch.php'),(20809747,6923,'./prtordersearch.php'),(20809746,941,'./prtordersearch.php'),(20809745,869,'./prtordersearch.php'),(20809744,6918,'./prtordersearch.php'),(20809743,799,'./prtordersearch.php'),(20809742,4363,'./prtordersearch.php'),(20809741,4481,'./prtordersearch.php'),(20809740,697,'./prtordersearch.php'),(20809739,610,'./prtordersearch.php'),(20809738,606,'./prtordersearch.php'),(20809737,5078,'./prtordersearch.php'),(20809736,5077,'./prtordersearch.php'),(20809735,5076,'./prtordersearch.php'),(20809734,5075,'./prtordersearch.php'),(20809733,5203,'./prtordersearch.php'),(20809732,7559,'./prtopenorder_close.php'),(20809731,2702,'./prtopenorder_close.php'),(20809730,2508,'./prtopenorder_close.php'),(20809729,2471,'./prtopenorder_close.php'),(20809728,2165,'./prtopenorder_close.php'),(20809727,2103,'./prtopenorder_close.php'),(20809726,932,'./prtopenorder_close.php'),(20809725,869,'./prtopenorder_close.php'),(20809724,4416,'./prtopenorder_close.php'),(20809723,697,'./prtopenorder_close.php'),(20809722,7558,'./prtopenorder_close.php'),(20809721,7557,'./prtopenorder_close.php'),(20809720,7556,'./prtopenorder_close.php'),(20809719,4614,'./prtopenorder.php'),(20809718,4613,'./prtopenorder.php'),(20809717,4612,'./prtopenorder.php'),(20809716,2656,'./prtopenorder.php'),(20809715,4611,'./prtopenorder.php'),(20809714,2645,'./prtopenorder.php'),(20809713,4596,'./prtopenorder.php'),(20809712,2540,'./prtopenorder.php'),(20809711,2508,'./prtopenorder.php'),(20809710,2497,'./prtopenorder.php'),(20809709,2480,'./prtopenorder.php'),(20809708,2471,'./prtopenorder.php'),(20809707,2459,'./prtopenorder.php'),(20809706,4610,'./prtopenorder.php'),(20809705,3738,'./prtopenorder.php'),(20809704,2292,'./prtopenorder.php'),(20809703,3436,'./prtopenorder.php'),(20809702,4609,'./prtopenorder.php'),(20809701,2165,'./prtopenorder.php'),(20809700,4608,'./prtopenorder.php'),(20809699,4607,'./prtopenorder.php'),(20809698,2103,'./prtopenorder.php'),(20809697,4606,'./prtopenorder.php'),(20809696,4222,'./prtopenorder.php'),(20809695,4605,'./prtopenorder.php'),(20809694,1564,'./prtopenorder.php'),(20809693,4604,'./prtopenorder.php'),(20809692,4603,'./prtopenorder.php'),(20809691,941,'./prtopenorder.php'),(20809690,932,'./prtopenorder.php'),(20809689,4602,'./prtopenorder.php'),(20809688,869,'./prtopenorder.php'),(20809687,6918,'./prtopenorder.php'),(20809686,4416,'./prtopenorder.php'),(20809685,697,'./prtopenorder.php'),(20809684,4601,'./prtopenorder.php'),(20809683,596,'./prtopenorder.php'),(20809682,4600,'./prtopenorder.php'),(20809681,5203,'./prtopenorder.php'),(20809680,4599,'./prtopenorder.php'),(20809679,4032,'./prtonholdorder.php'),(20809678,2508,'./prtonholdorder.php'),(20809677,2165,'./prtonholdorder.php'),(20809676,4619,'./prtonholdorder.php'),(20809675,2103,'./prtonholdorder.php'),(20809674,2099,'./prtonholdorder.php'),(20809673,932,'./prtonholdorder.php'),(20809672,869,'./prtonholdorder.php'),(20809671,4416,'./prtonholdorder.php'),(20809670,697,'./prtonholdorder.php'),(20809669,4618,'./prtonholdorder.php'),(20811642,14594,'./includes/arfunctions.php'),(20809668,3432,'./prtneworder.php'),(20809667,4827,'./prtneworder.php'),(20809666,4825,'./prtneworder.php'),(20809665,6231,'./prtneworder.php'),(20809664,4824,'./prtneworder.php'),(20809663,3381,'./prtneworder.php'),(20809662,4823,'./prtneworder.php'),(20809661,4821,'./prtneworder.php'),(20809660,4848,'./prtneworder.php'),(20809659,3072,'./prtneworder.php'),(20809658,3071,'./prtneworder.php'),(20809657,4820,'./prtneworder.php'),(20809656,4847,'./prtneworder.php'),(20809655,4846,'./prtneworder.php'),(20809654,2975,'./prtneworder.php'),(20809653,4819,'./prtneworder.php'),(20809652,4593,'./prtneworder.php'),(20809651,2936,'./prtneworder.php'),(20809650,4569,'./prtneworder.php'),(20809649,4818,'./prtneworder.php'),(20809648,4733,'./prtneworder.php'),(20809647,2821,'./prtneworder.php'),(20809646,2820,'./prtneworder.php'),(20809645,5754,'./prtneworder.php'),(20809644,4817,'./prtneworder.php'),(20809643,4816,'./prtneworder.php'),(20809642,3922,'./prtneworder.php'),(20809641,4815,'./prtneworder.php'),(20809640,4814,'./prtneworder.php'),(20809639,4813,'./prtneworder.php'),(20809638,4812,'./prtneworder.php'),(20809637,4811,'./prtneworder.php'),(20809636,4810,'./prtneworder.php'),(20809635,2661,'./prtneworder.php'),(20809634,4730,'./prtneworder.php'),(20809633,4809,'./prtneworder.php'),(20809632,8291,'./prtneworder.php'),(20809631,2645,'./prtneworder.php'),(20809630,4807,'./prtneworder.php'),(20809629,4806,'./prtneworder.php'),(20809628,4805,'./prtneworder.php'),(20809627,4804,'./prtneworder.php'),(20809626,4728,'./prtneworder.php'),(20809625,2615,'./prtneworder.php'),(20809624,4802,'./prtneworder.php'),(20809623,2529,'./prtneworder.php'),(20809622,4727,'./prtneworder.php'),(20809621,6230,'./prtneworder.php'),(20809620,2488,'./prtneworder.php'),(20809619,4800,'./prtneworder.php'),(20809618,2480,'./prtneworder.php'),(20809617,2471,'./prtneworder.php'),(20809616,5740,'./prtneworder.php'),(20809615,4798,'./prtneworder.php'),(20809614,4844,'./prtneworder.php'),(20809613,2367,'./prtneworder.php'),(20809612,4797,'./prtneworder.php'),(20809611,2324,'./prtneworder.php'),(20809610,4796,'./prtneworder.php'),(20809609,5606,'./prtneworder.php'),(20809608,4795,'./prtneworder.php'),(20809607,4794,'./prtneworder.php'),(20809606,3978,'./prtneworder.php'),(20809605,4868,'./prtneworder.php'),(20809604,4173,'./prtneworder.php'),(20809603,2182,'./prtneworder.php'),(20809602,4842,'./prtneworder.php'),(20809601,4841,'./prtneworder.php'),(20809600,4791,'./prtneworder.php'),(20809599,4840,'./prtneworder.php'),(20809598,2136,'./prtneworder.php'),(20809597,2125,'./prtneworder.php'),(20809596,2123,'./prtneworder.php'),(20809595,4839,'./prtneworder.php'),(20809594,5605,'./prtneworder.php'),(20809593,5596,'./prtneworder.php'),(20809592,5595,'./prtneworder.php'),(20809591,5594,'./prtneworder.php'),(20809590,2103,'./prtneworder.php'),(20809589,5739,'./prtneworder.php'),(20809588,2090,'./prtneworder.php'),(20809587,2071,'./prtneworder.php'),(20809586,1963,'./prtneworder.php'),(20809585,4721,'./prtneworder.php'),(20809584,4785,'./prtneworder.php'),(20809583,4783,'./prtneworder.php'),(20809582,1810,'./prtneworder.php'),(20809581,4782,'./prtneworder.php'),(20809580,4017,'./prtneworder.php'),(20809579,4780,'./prtneworder.php'),(20809578,4779,'./prtneworder.php'),(20809577,1724,'./prtneworder.php'),(20809576,7820,'./prtneworder.php'),(20809575,1592,'./prtneworder.php'),(20809574,4778,'./prtneworder.php'),(20809573,4777,'./prtneworder.php'),(20809572,4776,'./prtneworder.php'),(20809571,1467,'./prtneworder.php'),(20809570,3914,'./prtneworder.php'),(20809569,4837,'./prtneworder.php'),(20809568,1425,'./prtneworder.php'),(20809567,4772,'./prtneworder.php'),(20809566,1373,'./prtneworder.php'),(20809565,4718,'./prtneworder.php'),(20809564,12712,'./prtneworder.php'),(20809563,4836,'./prtneworder.php'),(20809562,4768,'./prtneworder.php'),(20809561,4767,'./prtneworder.php'),(20809560,4835,'./prtneworder.php'),(20809559,941,'./prtneworder.php'),(20809558,5738,'./prtneworder.php'),(20809557,5737,'./prtneworder.php'),(20809556,938,'./prtneworder.php'),(20809555,932,'./prtneworder.php'),(20809554,5736,'./prtneworder.php'),(20809553,5735,'./prtneworder.php'),(20809552,875,'./prtneworder.php'),(20809551,4766,'./prtneworder.php'),(20809550,869,'./prtneworder.php'),(20809549,4765,'./prtneworder.php'),(20809548,4764,'./prtneworder.php'),(20809547,4763,'./prtneworder.php'),(20809546,4762,'./prtneworder.php'),(20809545,838,'./prtneworder.php'),(20809544,4834,'./prtneworder.php'),(20809543,4761,'./prtneworder.php'),(20809542,737,'./prtneworder.php'),(20809541,4759,'./prtneworder.php'),(20809540,4758,'./prtneworder.php'),(20809539,3954,'./prtneworder.php'),(20809538,716,'./prtneworder.php'),(20809537,715,'./prtneworder.php'),(20809536,4481,'./prtneworder.php'),(20809535,4833,'./prtneworder.php'),(20809534,697,'./prtneworder.php'),(20809533,695,'./prtneworder.php'),(20809532,663,'./prtneworder.php'),(20809531,5729,'./prtneworder.php'),(20809530,4690,'./prtneworder.php'),(20809529,606,'./prtneworder.php'),(20809528,4757,'./prtneworder.php'),(20809527,5593,'./prtneworder.php'),(20809526,5592,'./prtneworder.php'),(20809525,4756,'./prtneworder.php'),(20809524,524,'./prtneworder.php'),(20809523,4755,'./prtneworder.php'),(20809522,4832,'./prtneworder.php'),(20809521,4752,'./prtneworder.php'),(20809520,4831,'./prtneworder.php'),(20809519,4751,'./prtneworder.php'),(20809518,4750,'./prtneworder.php'),(20809517,6076,'./prtneworder.php'),(20809516,4749,'./prtneworder.php'),(20809515,387,'./prtneworder.php'),(20809514,4748,'./prtneworder.php'),(20809513,315,'./prtneworder.php'),(20809512,12711,'./prtneworder.php'),(20809511,4274,'./prtneworder.php'),(20809510,4830,'./prtneworder.php'),(20809509,185,'./prtneworder.php'),(20809508,4828,'./prtneworder.php'),(20809507,4746,'./prtneworder.php'),(20809506,4745,'./prtneworder.php'),(20809505,59,'./prtneworder.php'),(20809504,47,'./prtneworder.php'),(20809503,4271,'./prtmachines.php'),(20809502,4270,'./prtmachines.php'),(20809501,4269,'./prtmachines.php'),(20809500,4268,'./prtmachines.php'),(20809499,4267,'./prtmachines.php'),(20809498,4266,'./prtmachines.php'),(20809497,2702,'./prtmachines.php'),(20809496,4265,'./prtmachines.php'),(20809495,2466,'./prtmachines.php'),(20809494,2214,'./prtmachines.php'),(20809493,4264,'./prtmachines.php'),(20809492,4263,'./prtmachines.php'),(20809491,4245,'./prtmachines.php'),(20809490,4244,'./prtmachines.php'),(20809489,4262,'./prtmachines.php'),(20809488,4261,'./prtmachines.php'),(20809487,4260,'./prtmachines.php'),(20809486,1824,'./prtmachines.php'),(20809485,4259,'./prtmachines.php'),(20809484,4258,'./prtmachines.php'),(20809483,4257,'./prtmachines.php'),(20809482,1803,'./prtmachines.php'),(20809481,4256,'./prtmachines.php'),(20809480,4255,'./prtmachines.php'),(20809479,4254,'./prtmachines.php'),(20809478,1799,'./prtmachines.php'),(20809477,1788,'./prtmachines.php'),(20809476,4253,'./prtmachines.php'),(20809475,4239,'./prtmachines.php'),(20809474,941,'./prtmachines.php'),(20809473,799,'./prtmachines.php'),(20809472,4252,'./prtmachines.php'),(20809471,315,'./prtmachines.php'),(20809470,5203,'./prtmachines.php'),(20809469,222,'./prtmachines.php'),(20809468,114,'./prtmachines.php'),(20809467,4251,'./prtmachines.php'),(20809466,59,'./prtmachines.php'),(20729867,2702,'./prtlocations_add.php'),(20729866,2467,'./prtlocations_add.php'),(20729865,70,'./prtlocations_add.php'),(20729864,59,'./prtlocations_add.php'),(20729863,2710,'./prtlocations.php'),(20729862,2702,'./prtlocations.php'),(20729861,2474,'./prtlocations.php'),(20729860,1654,'./prtlocations.php'),(20729859,832,'./prtlocations.php'),(20729858,799,'./prtlocations.php'),(20729857,315,'./prtlocations.php'),(20729856,5203,'./prtlocations.php'),(20729855,113,'./prtlocations.php'),(20729854,59,'./prtlocations.php'),(20809465,4617,'./prtlateorder.php'),(20809464,2656,'./prtlateorder.php'),(20809463,2508,'./prtlateorder.php'),(20809462,4616,'./prtlateorder.php'),(20809461,2165,'./prtlateorder.php'),(20809460,2103,'./prtlateorder.php'),(20809459,1963,'./prtlateorder.php'),(20809458,932,'./prtlateorder.php'),(20809457,4615,'./prtlateorder.php'),(20809456,869,'./prtlateorder.php'),(20809455,4416,'./prtlateorder.php'),(20809454,697,'./prtlateorder.php'),(20809453,2702,'./prtlate_reason_add.php'),(20809452,5198,'./prtlate_reason_add.php'),(20809451,4348,'./prtlate_reason_add.php'),(20809450,1760,'./prtlate_reason_add.php'),(20809449,4347,'./prtlate_reason_add.php'),(20809448,315,'./prtlate_reason_add.php'),(20809447,3221,'./prtlate_reason.php'),(20809446,2702,'./prtlate_reason.php'),(20809445,5197,'./prtlate_reason.php'),(20809444,1760,'./prtlate_reason.php'),(20809443,3995,'./prtlate_reason.php'),(20809442,1143,'./prtlate_reason.php'),(20809441,941,'./prtlate_reason.php'),(20809440,864,'./prtlate_reason.php'),(20809439,799,'./prtlate_reason.php'),(20809438,315,'./prtlate_reason.php'),(20809437,5203,'./prtlate_reason.php'),(20809436,59,'./prtlate_reason.php'),(20809435,6884,'./prtjobcopy.php'),(20809434,4745,'./prtjobcopy.php'),(20809433,4326,'./prtformulas.php'),(20809432,3156,'./prtformulas.php'),(20809431,4325,'./prtformulas.php'),(20809430,5610,'./prtformulas.php'),(20809429,4324,'./prtformulas.php'),(20809428,4323,'./prtformulas.php'),(20809427,2702,'./prtformulas.php'),(20809426,4322,'./prtformulas.php'),(20809425,4321,'./prtformulas.php'),(20809424,4320,'./prtformulas.php'),(20809423,4725,'./prtformulas.php'),(20809422,4319,'./prtformulas.php'),(20809421,4318,'./prtformulas.php'),(20809420,5606,'./prtformulas.php'),(20809419,4317,'./prtformulas.php'),(20809418,4316,'./prtformulas.php'),(20809417,4315,'./prtformulas.php'),(20809416,2123,'./prtformulas.php'),(20809415,4314,'./prtformulas.php'),(20809414,2117,'./prtformulas.php'),(20809413,3977,'./prtformulas.php'),(20809412,3980,'./prtformulas.php'),(20809411,4313,'./prtformulas.php'),(20809410,6236,'./prtformulas.php'),(20809409,3949,'./prtformulas.php'),(20809408,4312,'./prtformulas.php'),(20809407,1592,'./prtformulas.php'),(20809406,4311,'./prtformulas.php'),(20809405,4310,'./prtformulas.php'),(20809404,4309,'./prtformulas.php'),(20809403,4308,'./prtformulas.php'),(20809402,4307,'./prtformulas.php'),(20809401,4306,'./prtformulas.php'),(20809400,7555,'./prtformulas.php'),(20809399,7554,'./prtformulas.php'),(20809398,4305,'./prtformulas.php'),(20809397,869,'./prtformulas.php'),(20809396,799,'./prtformulas.php'),(20809395,5196,'./prtformulas.php'),(20809394,7553,'./prtformulas.php'),(20809393,4304,'./prtformulas.php'),(20809392,315,'./prtformulas.php'),(20809391,59,'./prtformulas.php'),(20809390,4657,'./prtfamily_order.php'),(20809389,2905,'./prtfamily_order.php'),(20809388,2702,'./prtfamily_order.php'),(20809387,1803,'./prtfamily_order.php'),(20809386,7552,'./prtfamily_order.php'),(20809385,315,'./prtfamily_order.php'),(20809384,4249,'./prtfamily_calculations.php'),(20809383,4214,'./prtfamily_calculations.php'),(20809382,2702,'./prtfamily_calculations.php'),(20809381,4232,'./prtfamily_calculations.php'),(20809380,2539,'./prtfamily_calculations.php'),(20809379,2230,'./prtfamily_calculations.php'),(20809378,4248,'./prtfamily_calculations.php'),(20809377,4247,'./prtfamily_calculations.php'),(20809376,4246,'./prtfamily_calculations.php'),(20809375,4245,'./prtfamily_calculations.php'),(20809374,4244,'./prtfamily_calculations.php'),(20809373,1963,'./prtfamily_calculations.php'),(20809372,4243,'./prtfamily_calculations.php'),(20809371,4250,'./prtfamily_calculations.php'),(20809370,4242,'./prtfamily_calculations.php'),(20809369,1639,'./prtfamily_calculations.php'),(20809368,4241,'./prtfamily_calculations.php'),(20809367,4240,'./prtfamily_calculations.php'),(20809366,4239,'./prtfamily_calculations.php'),(20809365,4238,'./prtfamily_calculations.php'),(20809364,4237,'./prtfamily_calculations.php'),(20809363,799,'./prtfamily_calculations.php'),(20809362,4236,'./prtfamily_calculations.php'),(20809361,4234,'./prtfamily_calculations.php'),(20809360,3394,'./prtfamily.php'),(20809359,4230,'./prtfamily.php'),(20809358,4229,'./prtfamily.php'),(20809357,5195,'./prtfamily.php'),(20809356,5194,'./prtfamily.php'),(20809355,4228,'./prtfamily.php'),(20809354,3165,'./prtfamily.php'),(20809353,4217,'./prtfamily.php'),(20809352,4216,'./prtfamily.php'),(20809351,5604,'./prtfamily.php'),(20809350,2886,'./prtfamily.php'),(20809349,3923,'./prtfamily.php'),(20809348,3922,'./prtfamily.php'),(20809347,4215,'./prtfamily.php'),(20809346,4214,'./prtfamily.php'),(20809345,4233,'./prtfamily.php'),(20809344,2710,'./prtfamily.php'),(20809343,2702,'./prtfamily.php'),(20809342,4232,'./prtfamily.php'),(20809341,12710,'./prtfamily.php'),(20809340,12709,'./prtfamily.php'),(20809339,2539,'./prtfamily.php'),(20809338,4213,'./prtfamily.php'),(20809337,4212,'./prtfamily.php'),(20809336,7551,'./prtfamily.php'),(20809335,5740,'./prtfamily.php'),(20809334,7550,'./prtfamily.php'),(20809333,4211,'./prtfamily.php'),(20809332,2165,'./prtfamily.php'),(20809331,4210,'./prtfamily.php'),(20809330,7549,'./prtfamily.php'),(20809329,4209,'./prtfamily.php'),(20809328,5743,'./prtfamily.php'),(20809327,1963,'./prtfamily.php'),(20809326,1960,'./prtfamily.php'),(20809325,4227,'./prtfamily.php'),(20809324,4226,'./prtfamily.php'),(20809323,1932,'./prtfamily.php'),(20809322,4225,'./prtfamily.php'),(20809321,4224,'./prtfamily.php'),(20809320,1922,'./prtfamily.php'),(20809319,5284,'./prtfamily.php'),(20809318,5603,'./prtfamily.php'),(20809317,1895,'./prtfamily.php'),(20809316,4223,'./prtfamily.php'),(20809315,4206,'./prtfamily.php'),(20809314,5283,'./prtfamily.php'),(20809313,5602,'./prtfamily.php'),(20809312,5601,'./prtfamily.php'),(20809311,5600,'./prtfamily.php'),(20809310,1803,'./prtfamily.php'),(20809309,4204,'./prtfamily.php'),(20809308,5599,'./prtfamily.php'),(20809307,4222,'./prtfamily.php'),(20809306,1765,'./prtfamily.php'),(20809305,5598,'./prtfamily.php'),(20809304,4203,'./prtfamily.php'),(20809303,4231,'./prtfamily.php'),(20809302,4221,'./prtfamily.php'),(20809301,4220,'./prtfamily.php'),(20809300,4202,'./prtfamily.php'),(20809299,941,'./prtfamily.php'),(20809298,5742,'./prtfamily.php'),(20809297,5741,'./prtfamily.php'),(20809296,799,'./prtfamily.php'),(20809295,315,'./prtfamily.php'),(20809294,7548,'./prtfamily.php'),(20809293,5203,'./prtfamily.php'),(20809292,128,'./prtfamily.php'),(20809291,5193,'./prtfamily.php'),(20809290,4218,'./prtfamily.php'),(20809289,5192,'./prtfamily.php'),(20809288,59,'./prtfamily.php'),(20809287,3156,'./prtdefault_responses.php'),(20809286,4303,'./prtdefault_responses.php'),(20809285,2702,'./prtdefault_responses.php'),(20809284,2539,'./prtdefault_responses.php'),(20809283,4302,'./prtdefault_responses.php'),(20809282,1963,'./prtdefault_responses.php'),(20809281,4239,'./prtdefault_responses.php'),(20809280,4301,'./prtdefault_responses.php'),(20809279,4300,'./prtdefault_responses.php'),(20809278,315,'./prtdefault_responses.php'),(20809277,2656,'./prtclosedorder.php'),(20809276,2508,'./prtclosedorder.php'),(20809275,2165,'./prtclosedorder.php'),(20809274,2103,'./prtclosedorder.php'),(20809273,1963,'./prtclosedorder.php'),(20809272,4441,'./prtclosedorder.php'),(20809271,4621,'./prtclosedorder.php'),(20809270,901,'./prtclosedorder.php'),(20809269,869,'./prtclosedorder.php'),(20809268,4416,'./prtclosedorder.php'),(20809267,697,'./prtclosedorder.php'),(20809266,607,'./prtclosedorder.php'),(20809265,3563,'./prtclosedorder.php'),(20809264,4620,'./prtclosedorder.php'),(20809263,1963,'./prtchange_order_price.php'),(20809262,1776,'./prtchange_order_price.php'),(20809261,7819,'./prtchange_order_price.php'),(20809260,315,'./prtchange_order_price.php'),(20809259,3427,'./prtboxlabel.php'),(20809258,3072,'./prtboxlabel.php'),(20809257,3070,'./prtboxlabel.php'),(20809256,5088,'./prtboxlabel.php'),(20809255,2182,'./prtboxlabel.php'),(20809254,4789,'./prtboxlabel.php'),(20809253,1963,'./prtboxlabel.php'),(20809252,4720,'./prtboxlabel.php'),(20809251,5093,'./prtboxlabel.php'),(20809250,5091,'./prtboxlabel.php'),(20809249,542,'./prtboxlabel.php'),(20809248,540,'./prtboxlabel.php'),(20809247,5086,'./prtboxlabel.php'),(20809246,185,'./prtboxlabel.php'),(20809245,4522,'./prtactual_work.php'),(20809244,4521,'./prtactual_work.php'),(20809243,4520,'./prtactual_work.php'),(20809242,4519,'./prtactual_work.php'),(20809241,4518,'./prtactual_work.php'),(20809240,2234,'./prtactual_work.php'),(20809239,1963,'./prtactual_work.php'),(20809238,4517,'./prtactual_work.php'),(20809237,542,'./prtactual_work.php'),(20809236,3172,'./prtactual_detail.php'),(20809235,4415,'./prtactual_detail.php'),(20809234,3165,'./prtactual_detail.php'),(20809233,2950,'./prtactual_detail.php'),(20809232,2702,'./prtactual_detail.php'),(20809231,3794,'./prtactual_detail.php'),(20809230,2529,'./prtactual_detail.php'),(20809229,2404,'./prtactual_detail.php'),(20809228,2363,'./prtactual_detail.php'),(20809227,4114,'./prtactual_detail.php'),(20809226,2103,'./prtactual_detail.php'),(20809225,4414,'./prtactual_detail.php'),(20809224,1564,'./prtactual_detail.php'),(20809223,1357,'./prtactual_detail.php'),(20809222,4413,'./prtactual_detail.php'),(20809221,989,'./prtactual_detail.php'),(20809220,4412,'./prtactual_detail.php'),(20809219,869,'./prtactual_detail.php'),(20809218,799,'./prtactual_detail.php'),(20809217,737,'./prtactual_detail.php'),(20809216,542,'./prtactual_detail.php'),(20809215,4411,'./prtactual_detail.php'),(20809214,4410,'./prtactual_detail.php'),(20809213,4409,'./prtactual_detail.php'),(20809212,4408,'./prtactual_detail.php'),(20809211,3221,'./prt_stockpurpose.php'),(20809210,2958,'./prt_stockpurpose.php'),(20809209,2905,'./prt_stockpurpose.php'),(20809208,2702,'./prt_stockpurpose.php'),(20809207,3995,'./prt_stockpurpose.php'),(20809206,1143,'./prt_stockpurpose.php'),(20809205,941,'./prt_stockpurpose.php'),(20809204,864,'./prt_stockpurpose.php'),(20809203,799,'./prt_stockpurpose.php'),(20809202,315,'./prt_stockpurpose.php'),(20809201,5203,'./prt_stockpurpose.php'),(20809200,59,'./prt_stockpurpose.php'),(20809199,2702,'./prt_orientation_add.php'),(20809198,5748,'./prt_orientation_add.php'),(20809197,5744,'./prt_orientation_add.php'),(20809196,5747,'./prt_orientation_add.php'),(20809195,5746,'./prt_orientation_add.php'),(20809194,315,'./prt_orientation_add.php'),(20809193,3221,'./prt_orientation.php'),(20809192,2702,'./prt_orientation.php'),(20809191,5745,'./prt_orientation.php'),(20809190,5744,'./prt_orientation.php'),(20809189,3995,'./prt_orientation.php'),(20809188,1143,'./prt_orientation.php'),(20809187,941,'./prt_orientation.php'),(20809186,864,'./prt_orientation.php'),(20809185,799,'./prt_orientation.php'),(20809184,315,'./prt_orientation.php'),(20809183,5203,'./prt_orientation.php'),(20809182,59,'./prt_orientation.php'),(20809181,4692,'./prt_lists_unconfirmed.php'),(20809180,4691,'./prt_lists_unconfirmed.php'),(20809179,2907,'./prt_lists_unconfirmed.php'),(20809178,2044,'./prt_lists_unconfirmed.php'),(20809177,3912,'./prt_lists_unconfirmed.php'),(20809176,4414,'./prt_lists_unconfirmed.php'),(20809175,1358,'./prt_lists_unconfirmed.php'),(20809174,932,'./prt_lists_unconfirmed.php'),(20809173,869,'./prt_lists_unconfirmed.php'),(20809172,697,'./prt_lists_unconfirmed.php'),(20809171,4690,'./prt_lists_unconfirmed.php'),(20809170,4689,'./prt_lists_unconfirmed.php'),(20809169,7559,'./prt_cutout.php'),(20809168,5114,'./prt_cutout.php'),(20809167,7632,'./prt_cutout.php'),(20809166,7631,'./prt_cutout.php'),(20809165,4463,'./prt_addtime.php'),(20809164,4462,'./prt_addtime.php'),(20809163,3319,'./prt_addtime.php'),(20809162,3274,'./prt_addtime.php'),(20809161,4461,'./prt_addtime.php'),(20809160,3165,'./prt_addtime.php'),(20809159,3076,'./prt_addtime.php'),(20809158,4460,'./prt_addtime.php'),(20809157,3071,'./prt_addtime.php'),(20809156,4459,'./prt_addtime.php'),(20809155,4458,'./prt_addtime.php'),(20809154,4457,'./prt_addtime.php'),(20809153,4456,'./prt_addtime.php'),(20809152,4455,'./prt_addtime.php'),(20809151,2833,'./prt_addtime.php'),(20809150,4454,'./prt_addtime.php'),(20809149,4453,'./prt_addtime.php'),(20809148,4452,'./prt_addtime.php'),(20809147,2702,'./prt_addtime.php'),(20809146,4451,'./prt_addtime.php'),(20809145,4450,'./prt_addtime.php'),(20809144,3794,'./prt_addtime.php'),(20809143,2589,'./prt_addtime.php'),(20809142,4449,'./prt_addtime.php'),(20809141,4448,'./prt_addtime.php'),(20809140,2404,'./prt_addtime.php'),(20809139,2361,'./prt_addtime.php'),(20809138,4447,'./prt_addtime.php'),(20809137,2230,'./prt_addtime.php'),(20809136,3436,'./prt_addtime.php'),(20809135,2186,'./prt_addtime.php'),(20809134,2182,'./prt_addtime.php'),(20809133,2199,'./prt_addtime.php'),(20809132,4392,'./prt_addtime.php'),(20809131,4446,'./prt_addtime.php'),(20809130,4445,'./prt_addtime.php'),(20809129,2103,'./prt_addtime.php'),(20809128,1963,'./prt_addtime.php'),(20809127,1934,'./prt_addtime.php'),(20809126,4444,'./prt_addtime.php'),(20809125,1810,'./prt_addtime.php'),(20809124,1794,'./prt_addtime.php'),(20809123,1724,'./prt_addtime.php'),(20809122,4414,'./prt_addtime.php'),(20809121,3917,'./prt_addtime.php'),(20809120,4443,'./prt_addtime.php'),(20809119,4442,'./prt_addtime.php'),(20809118,1564,'./prt_addtime.php'),(20809117,4441,'./prt_addtime.php'),(20809116,1411,'./prt_addtime.php'),(20809115,4440,'./prt_addtime.php'),(20809114,4439,'./prt_addtime.php'),(20809113,4438,'./prt_addtime.php'),(20809112,1337,'./prt_addtime.php'),(20809111,4377,'./prt_addtime.php'),(20809110,4437,'./prt_addtime.php'),(20809109,1032,'./prt_addtime.php'),(20809108,4436,'./prt_addtime.php'),(20809107,4435,'./prt_addtime.php'),(20809106,941,'./prt_addtime.php'),(20809105,3952,'./prt_addtime.php'),(20809104,4433,'./prt_addtime.php'),(20809103,869,'./prt_addtime.php'),(20809102,4432,'./prt_addtime.php'),(20809101,745,'./prt_addtime.php'),(20809100,4363,'./prt_addtime.php'),(20809099,4431,'./prt_addtime.php'),(20809098,697,'./prt_addtime.php'),(20809097,4430,'./prt_addtime.php'),(20809096,541,'./prt_addtime.php'),(20809095,4429,'./prt_addtime.php'),(20809094,4428,'./prt_addtime.php'),(20809093,4427,'./prt_addtime.php'),(20809092,4426,'./prt_addtime.php'),(20809091,4411,'./prt_addtime.php'),(20809090,4425,'./prt_addtime.php'),(20809089,416,'./prt_addtime.php'),(20809088,408,'./prt_addtime.php'),(20809087,4424,'./prt_addtime.php'),(20809086,4423,'./prt_addtime.php'),(20809085,315,'./prt_addtime.php'),(20809084,4422,'./prt_addtime.php'),(20809083,4421,'./prt_addtime.php'),(20809082,12036,'./prt_addtime.php'),(20809081,4420,'./prt_addtime.php'),(20809080,127,'./prt_addtime.php'),(20809079,185,'./prt_addtime.php'),(20809078,4419,'./prt_addtime.php'),(20809077,4658,'./prt_addtime.php'),(20809076,57,'./prt_addtime.php'),(20809075,4408,'./prt_addtime.php'),(20809074,3432,'./prrpt.php'),(20809073,15521,'./prrpt.php'),(20809072,15520,'./prrpt.php'),(20809071,15519,'./prrpt.php'),(20809070,15518,'./prrpt.php'),(20809069,15517,'./prrpt.php'),(20809068,15516,'./prrpt.php'),(20809067,13020,'./prrpt.php'),(20809066,15515,'./prrpt.php'),(20809065,5753,'./prrpt.php'),(20809064,15514,'./prrpt.php'),(20809063,3414,'./prrpt.php'),(20809062,15513,'./prrpt.php'),(20809061,15512,'./prrpt.php'),(20809060,15511,'./prrpt.php'),(20809059,15510,'./prrpt.php'),(20809058,15509,'./prrpt.php'),(20809057,15508,'./prrpt.php'),(20809056,3352,'./prrpt.php'),(20809055,14667,'./prrpt.php'),(20809054,16431,'./prrpt.php'),(20809053,3090,'./prrpt.php'),(20809052,6016,'./prrpt.php'),(20809051,3022,'./prrpt.php'),(20809050,15617,'./prrpt.php'),(20809049,16502,'./prrpt.php'),(20809048,15507,'./prrpt.php'),(20809047,15506,'./prrpt.php'),(20809046,16501,'./prrpt.php'),(20809045,2945,'./prrpt.php'),(20809044,15505,'./prrpt.php'),(20809043,15504,'./prrpt.php'),(20809042,2939,'./prrpt.php'),(20809041,15503,'./prrpt.php'),(20809040,15502,'./prrpt.php'),(20809039,15501,'./prrpt.php'),(20809038,2937,'./prrpt.php'),(20809037,2936,'./prrpt.php'),(20809036,15500,'./prrpt.php'),(20809035,15499,'./prrpt.php'),(20809034,15498,'./prrpt.php'),(20809033,15497,'./prrpt.php'),(20809032,2914,'./prrpt.php'),(20809031,15496,'./prrpt.php'),(20809030,2898,'./prrpt.php'),(20809029,15495,'./prrpt.php'),(20809028,2782,'./prrpt.php'),(20809027,2751,'./prrpt.php'),(20809026,2663,'./prrpt.php'),(20809025,2612,'./prrpt.php'),(20809024,2606,'./prrpt.php'),(20809023,2565,'./prrpt.php'),(20809022,15494,'./prrpt.php'),(20809021,15493,'./prrpt.php'),(20809020,15492,'./prrpt.php'),(20809019,3444,'./prrpt.php'),(20809018,15491,'./prrpt.php'),(20809017,15490,'./prrpt.php'),(20809016,15489,'./prrpt.php'),(20809015,15488,'./prrpt.php'),(20809014,15487,'./prrpt.php'),(20809013,15486,'./prrpt.php'),(20809012,15485,'./prrpt.php'),(20809011,15484,'./prrpt.php'),(20809010,10152,'./prrpt.php'),(20809009,2324,'./prrpt.php'),(20809008,15423,'./prrpt.php'),(20809007,15483,'./prrpt.php'),(20809006,2315,'./prrpt.php'),(20809005,3739,'./prrpt.php'),(20809004,2251,'./prrpt.php'),(20809003,15481,'./prrpt.php'),(20809002,15480,'./prrpt.php'),(20809001,2238,'./prrpt.php'),(20809000,15479,'./prrpt.php'),(20808999,1963,'./prrpt.php'),(20808998,1935,'./prrpt.php'),(20808997,15478,'./prrpt.php'),(20808996,15477,'./prrpt.php'),(20808995,15476,'./prrpt.php'),(20808994,15475,'./prrpt.php'),(20808993,15474,'./prrpt.php'),(20808992,15473,'./prrpt.php'),(20808991,15472,'./prrpt.php'),(20808990,15471,'./prrpt.php'),(20808989,15470,'./prrpt.php'),(20808988,1907,'./prrpt.php'),(20808987,15469,'./prrpt.php'),(20808986,15468,'./prrpt.php'),(20808985,15467,'./prrpt.php'),(20808984,15466,'./prrpt.php'),(20808983,1872,'./prrpt.php'),(20808982,15616,'./prrpt.php'),(20808981,1798,'./prrpt.php'),(20808980,1787,'./prrpt.php'),(20808979,15465,'./prrpt.php'),(20808978,15464,'./prrpt.php'),(20808977,15463,'./prrpt.php'),(20808976,1783,'./prrpt.php'),(20808975,15462,'./prrpt.php'),(20808974,15461,'./prrpt.php'),(20808973,1598,'./prrpt.php'),(20808972,1578,'./prrpt.php'),(20808971,15460,'./prrpt.php'),(20808970,1564,'./prrpt.php'),(20808969,1561,'./prrpt.php'),(20808968,15459,'./prrpt.php'),(20808967,1556,'./prrpt.php'),(20808966,16500,'./prrpt.php'),(20808965,1536,'./prrpt.php'),(20808964,15457,'./prrpt.php'),(20808963,4106,'./prrpt.php'),(20808962,3633,'./prrpt.php'),(20808961,15456,'./prrpt.php'),(20808960,15455,'./prrpt.php'),(20808959,15454,'./prrpt.php'),(20808958,16499,'./prrpt.php'),(20808957,15453,'./prrpt.php'),(20808956,15452,'./prrpt.php'),(20808955,15451,'./prrpt.php'),(20808954,15450,'./prrpt.php'),(20808953,15449,'./prrpt.php'),(20808952,1385,'./prrpt.php'),(20808951,15448,'./prrpt.php'),(20808950,1379,'./prrpt.php'),(20808949,11023,'./prrpt.php'),(20808948,15447,'./prrpt.php'),(20808947,8936,'./prrpt.php'),(20808946,1014,'./prrpt.php'),(20808945,15446,'./prrpt.php'),(20808944,996,'./prrpt.php'),(20808943,15445,'./prrpt.php'),(20808942,993,'./prrpt.php'),(20808941,989,'./prrpt.php'),(20808940,981,'./prrpt.php'),(20808939,15444,'./prrpt.php'),(20808938,15443,'./prrpt.php'),(20808937,15442,'./prrpt.php'),(20808936,7284,'./prrpt.php'),(20808935,15441,'./prrpt.php'),(20808934,15440,'./prrpt.php'),(20808933,15439,'./prrpt.php'),(20808932,15438,'./prrpt.php'),(20808931,15437,'./prrpt.php'),(20808930,15436,'./prrpt.php'),(20808929,790,'./prrpt.php'),(20808928,781,'./prrpt.php'),(20808927,4973,'./prrpt.php'),(20808926,741,'./prrpt.php'),(20808925,15435,'./prrpt.php'),(20808924,15403,'./prrpt.php'),(20808923,607,'./prrpt.php'),(20808922,548,'./prrpt.php'),(20808921,541,'./prrpt.php'),(20808920,16498,'./prrpt.php'),(20808919,15434,'./prrpt.php'),(20808918,15433,'./prrpt.php'),(20808917,15432,'./prrpt.php'),(20808916,525,'./prrpt.php'),(20808915,524,'./prrpt.php'),(20808914,6165,'./prrpt.php'),(20808913,10751,'./prrpt.php'),(20808912,15431,'./prrpt.php'),(20808911,333,'./prrpt.php'),(20808910,315,'./prrpt.php'),(20808903,8063,'./prpaychange.php'),(20808902,2242,'./prpaychange.php'),(20808901,737,'./prpaychange.php'),(20808900,542,'./prpaychange.php'),(20729287,10323,'./project.php'),(20729286,3225,'./project.php'),(20729285,10793,'./project.php'),(20729284,10792,'./project.php'),(20729283,10791,'./project.php'),(20729282,3118,'./project.php'),(20729281,2948,'./project.php'),(20729280,10641,'./project.php'),(20729279,9966,'./project.php'),(20729278,10790,'./project.php'),(20729277,10640,'./project.php'),(20729276,2702,'./project.php'),(20729275,10639,'./project.php'),(20729274,10788,'./project.php'),(20729273,2606,'./project.php'),(20729272,10787,'./project.php'),(20729271,15585,'./project.php'),(20729270,8897,'./project.php'),(20729269,10320,'./project.php'),(20729268,10638,'./project.php'),(20729267,8959,'./project.php'),(20729266,10319,'./project.php'),(20729265,10313,'./project.php'),(20729264,10312,'./project.php'),(20729263,10311,'./project.php'),(20729262,10310,'./project.php'),(20729261,10318,'./project.php'),(20729260,2292,'./project.php'),(20729259,15584,'./project.php'),(20729258,9877,'./project.php'),(20729257,2218,'./project.php'),(20729256,2151,'./project.php'),(20729255,9876,'./project.php'),(20729254,10317,'./project.php'),(20729253,1963,'./project.php'),(20729252,10786,'./project.php'),(20729251,10785,'./project.php'),(20729250,1788,'./project.php'),(20729249,15583,'./project.php'),(20729248,15582,'./project.php'),(20729247,10782,'./project.php'),(20729246,10309,'./project.php'),(20729245,10308,'./project.php'),(20729244,10307,'./project.php'),(20729243,10306,'./project.php'),(20729242,10305,'./project.php'),(20729241,10304,'./project.php'),(20729240,10303,'./project.php'),(20729239,10302,'./project.php'),(20729238,10636,'./project.php'),(20729237,1476,'./project.php'),(20729236,10780,'./project.php'),(20729235,10301,'./project.php'),(20729234,10300,'./project.php'),(20729233,10299,'./project.php'),(20729232,15581,'./project.php'),(20729231,10298,'./project.php'),(20729230,10297,'./project.php'),(20729229,10316,'./project.php'),(20729228,10296,'./project.php'),(20729227,10295,'./project.php'),(20729226,8936,'./project.php'),(20729225,1012,'./project.php'),(20729224,15580,'./project.php'),(20729223,799,'./project.php'),(20729222,10020,'./project.php'),(20729221,10294,'./project.php'),(20729220,10635,'./project.php'),(20729219,10634,'./project.php'),(20729218,10293,'./project.php'),(20729217,10292,'./project.php'),(20729216,10291,'./project.php'),(20729215,10290,'./project.php'),(20729214,10289,'./project.php'),(20729213,10288,'./project.php'),(20729212,10287,'./project.php'),(20729211,10633,'./project.php'),(20729210,596,'./project.php'),(20729209,591,'./project.php'),(20729208,5583,'./project.php'),(20729207,15579,'./project.php'),(20729206,5424,'./project.php'),(20729205,13994,'./project.php'),(20729204,315,'./project.php'),(20729203,5203,'./project.php'),(20729202,15578,'./project.php'),(20729201,10315,'./project.php'),(20729200,185,'./project.php'),(20729199,59,'./project.php'),(20729198,52,'./project.php'),(20808899,8401,'./prloghours_table.php'),(20808898,8400,'./prloghours_table.php'),(20808897,3090,'./prloghours_table.php'),(20808896,3055,'./prloghours_table.php'),(20808895,2804,'./prloghours_table.php'),(20808894,2774,'./prloghours_table.php'),(20808893,2702,'./prloghours_table.php'),(20808892,2663,'./prloghours_table.php'),(20808891,2381,'./prloghours_table.php'),(20808890,2319,'./prloghours_table.php'),(20808889,2317,'./prloghours_table.php'),(20808888,2316,'./prloghours_table.php'),(20808887,2315,'./prloghours_table.php'),(20808886,2244,'./prloghours_table.php'),(20808885,2238,'./prloghours_table.php'),(20808884,2036,'./prloghours_table.php'),(20808883,1995,'./prloghours_table.php'),(20808882,1963,'./prloghours_table.php'),(20808881,1935,'./prloghours_table.php'),(20808880,11822,'./prloghours_table.php'),(20808879,1790,'./prloghours_table.php'),(20808878,1564,'./prloghours_table.php'),(20808877,1561,'./prloghours_table.php'),(20808876,1029,'./prloghours_table.php'),(20808875,995,'./prloghours_table.php'),(20808874,607,'./prloghours_table.php'),(20808873,5202,'./prloghours_table.php'),(20808872,214,'./prloghours_table.php'),(20808871,207,'./prloghours_table.php'),(20808870,59,'./prloghours_table.php'),(20810792,15041,'./taskuser.php'),(20808869,15424,'./prloghours.php'),(20808868,3325,'./prloghours.php'),(20808867,15636,'./prloghours.php'),(20808866,14667,'./prloghours.php'),(20808865,3113,'./prloghours.php'),(20808864,3109,'./prloghours.php'),(20808863,3118,'./prloghours.php'),(20808862,3067,'./prloghours.php'),(20808861,3055,'./prloghours.php'),(20808860,3048,'./prloghours.php'),(20808859,15693,'./prloghours.php'),(20808858,2936,'./prloghours.php'),(20808857,15635,'./prloghours.php'),(20808856,2812,'./prloghours.php'),(20808855,15692,'./prloghours.php'),(20808854,2774,'./prloghours.php'),(20808853,2782,'./prloghours.php'),(20808852,2751,'./prloghours.php'),(20808851,2750,'./prloghours.php'),(20808850,16456,'./prloghours.php'),(20808849,2702,'./prloghours.php'),(20808848,2663,'./prloghours.php'),(20808847,2565,'./prloghours.php'),(20808846,15691,'./prloghours.php'),(20808845,15690,'./prloghours.php'),(20808844,2381,'./prloghours.php'),(20808843,8387,'./prloghours.php'),(20808842,8386,'./prloghours.php'),(20808841,5787,'./prloghours.php'),(20808840,2319,'./prloghours.php'),(20808839,2317,'./prloghours.php'),(20808838,2316,'./prloghours.php'),(20808837,2315,'./prloghours.php'),(20808836,3739,'./prloghours.php'),(20808835,2251,'./prloghours.php'),(20808834,8752,'./prloghours.php'),(20808833,8751,'./prloghours.php'),(20808832,15689,'./prloghours.php'),(20808831,15688,'./prloghours.php'),(20808830,2036,'./prloghours.php'),(20808829,15687,'./prloghours.php'),(20808828,15686,'./prloghours.php'),(20808827,15685,'./prloghours.php'),(20808826,16941,'./prloghours.php'),(20808825,15684,'./prloghours.php'),(20808824,15683,'./prloghours.php'),(20808823,1995,'./prloghours.php'),(20808822,15682,'./prloghours.php'),(20808821,2099,'./prloghours.php'),(20808820,7468,'./prloghours.php'),(20808819,1964,'./prloghours.php'),(20808818,1963,'./prloghours.php'),(20808817,1935,'./prloghours.php'),(20808816,1907,'./prloghours.php'),(20808815,1898,'./prloghours.php'),(20808814,1790,'./prloghours.php'),(20808813,1782,'./prloghours.php'),(20808812,15681,'./prloghours.php'),(20808811,5081,'./prloghours.php'),(20808810,1575,'./prloghours.php'),(20808809,15680,'./prloghours.php'),(20808808,1564,'./prloghours.php'),(20808807,1561,'./prloghours.php'),(20808806,10388,'./prloghours.php'),(20808805,10940,'./prloghours.php'),(20808804,15679,'./prloghours.php'),(20808803,15991,'./prloghours.php'),(20808802,1499,'./prloghours.php'),(20808801,3633,'./prloghours.php'),(20808800,1427,'./prloghours.php'),(20808799,1379,'./prloghours.php'),(20808769,4861,'./printorder_picker.php'),(20808768,4860,'./printorder_picker.php'),(20808767,4859,'./printorder_picker.php'),(20808766,2948,'./printorder_picker.php'),(20808765,3434,'./printorder_picker.php'),(20808764,4858,'./printorder_picker.php'),(20808763,4857,'./printorder_picker.php'),(20808762,4856,'./printorder_picker.php'),(20808761,4855,'./printorder_picker.php'),(20808760,4854,'./printorder_picker.php'),(20808759,2367,'./printorder_picker.php'),(20808758,2223,'./printorder_picker.php'),(20808757,2182,'./printorder_picker.php'),(20808756,2034,'./printorder_picker.php'),(20808755,1963,'./printorder_picker.php'),(20808754,1776,'./printorder_picker.php'),(20808753,4853,'./printorder_picker.php'),(20808752,1014,'./printorder_picker.php'),(20808751,932,'./printorder_picker.php'),(20808750,869,'./printorder_picker.php'),(20808749,4481,'./printorder_picker.php'),(20808748,697,'./printorder_picker.php'),(20808747,4632,'./printorder_picker.php'),(20808746,596,'./printorder_picker.php'),(20808745,315,'./printorder_picker.php'),(20808744,4852,'./printorder_picker.php'),(20808743,4851,'./printorder_picker.php'),(20808742,211,'./printorder_picker.php'),(20808741,55,'./printorder_picker.php'),(20808740,6161,'./printorder2invoice.php'),(20808739,3126,'./printorder2invoice.php'),(20808738,3090,'./printorder2invoice.php'),(20808737,4598,'./printorder2invoice.php'),(20808736,4597,'./printorder2invoice.php'),(20808735,2977,'./printorder2invoice.php'),(20808734,5225,'./printorder2invoice.php'),(20808733,2833,'./printorder2invoice.php'),(20808732,7058,'./printorder2invoice.php'),(20808731,2791,'./printorder2invoice.php'),(20808730,2661,'./printorder2invoice.php'),(20808729,4596,'./printorder2invoice.php'),(20808728,5052,'./printorder2invoice.php'),(20808727,5466,'./printorder2invoice.php'),(20808726,2459,'./printorder2invoice.php'),(20808725,2374,'./printorder2invoice.php'),(20808724,2301,'./printorder2invoice.php'),(20808723,2182,'./printorder2invoice.php'),(20808722,2165,'./printorder2invoice.php'),(20808721,2044,'./printorder2invoice.php'),(20808720,2103,'./printorder2invoice.php'),(20808719,1963,'./printorder2invoice.php'),(20808718,1668,'./printorder2invoice.php'),(20808717,1463,'./printorder2invoice.php'),(20808716,4014,'./printorder2invoice.php'),(20808715,869,'./printorder2invoice.php'),(20808714,4416,'./printorder2invoice.php'),(20808713,697,'./printorder2invoice.php'),(20808712,4595,'./printorder2invoice.php'),(20808711,4594,'./printorder2invoice.php'),(20808710,5145,'./printorder2invoice.php'),(20808709,6160,'./printorder2invoice.php'),(20808708,6159,'./printorder2invoice.php'),(20808707,16,'./printorder2invoice.php'),(20808706,3415,'./prepd7a.php'),(20808705,13756,'./prepd7a.php'),(20808704,13755,'./prepd7a.php'),(20808703,13754,'./prepd7a.php'),(20808702,1913,'./prepd7a.php'),(20808701,13753,'./prepd7a.php'),(20808700,13752,'./prepd7a.php'),(20808699,13751,'./prepd7a.php'),(20808698,13750,'./prepd7a.php'),(20808697,13749,'./prepd7a.php'),(20808696,13748,'./prepd7a.php'),(20808695,13747,'./prepd7a.php'),(20808694,13746,'./prepd7a.php'),(20808693,13745,'./prepd7a.php'),(20808692,13744,'./prepd7a.php'),(20808691,232,'./prepd7a.php'),(20808690,13743,'./prepd7a.php'),(20808689,3402,'./premplweekupd.php'),(20808688,3090,'./premplweekupd.php'),(20808687,3068,'./premplweekupd.php'),(20808686,3067,'./premplweekupd.php'),(20808685,2998,'./premplweekupd.php'),(20808684,2981,'./premplweekupd.php'),(20808683,15417,'./premplweekupd.php'),(20808682,2774,'./premplweekupd.php'),(20808681,12034,'./premplweekupd.php'),(20808680,2565,'./premplweekupd.php'),(20808679,2317,'./premplweekupd.php'),(20808678,2316,'./premplweekupd.php'),(20808677,2251,'./premplweekupd.php'),(20808676,2243,'./premplweekupd.php'),(20808675,2238,'./premplweekupd.php'),(20808674,2213,'./premplweekupd.php'),(20808673,5709,'./premplweekupd.php'),(20808672,1963,'./premplweekupd.php'),(20808671,1935,'./premplweekupd.php'),(20808670,6418,'./premplweekupd.php'),(20808669,12198,'./premplweekupd.php'),(20808668,1907,'./premplweekupd.php'),(20808667,5708,'./premplweekupd.php'),(20808666,1898,'./premplweekupd.php'),(20808665,5707,'./premplweekupd.php'),(20808664,5706,'./premplweekupd.php'),(20808663,1564,'./premplweekupd.php'),(20808662,1499,'./premplweekupd.php'),(20808661,1471,'./premplweekupd.php'),(20808660,1385,'./premplweekupd.php'),(20808659,4397,'./premplweekupd.php'),(20808658,1007,'./premplweekupd.php'),(20808657,998,'./premplweekupd.php'),(20808656,12193,'./premplweekupd.php'),(20808655,7057,'./premplweekupd.php'),(20808654,6417,'./premplweekupd.php'),(20808653,13738,'./premplweekupd.php'),(20808652,974,'./premplweekupd.php'),(20808651,790,'./premplweekupd.php'),(20808650,781,'./premplweekupd.php'),(20808649,5705,'./premplweekupd.php'),(20808648,607,'./premplweekupd.php'),(20808647,576,'./premplweekupd.php'),(20808646,566,'./premplweekupd.php'),(20808645,315,'./premplweekupd.php'),(20808644,226,'./premplweekupd.php'),(20808643,7823,'./premplsum.php'),(20808642,3090,'./premplsum.php'),(20808641,11839,'./premplsum.php'),(20808640,11838,'./premplsum.php'),(20808639,2773,'./premplsum.php'),(20808638,12034,'./premplsum.php'),(20808637,11837,'./premplsum.php'),(20808636,2315,'./premplsum.php'),(20808635,7773,'./premplsum.php'),(20808634,2225,'./premplsum.php'),(20808633,11836,'./premplsum.php'),(20808632,2055,'./premplsum.php'),(20808631,1963,'./premplsum.php'),(20808630,1945,'./premplsum.php'),(20808629,1935,'./premplsum.php'),(20808628,11835,'./premplsum.php'),(20808627,11834,'./premplsum.php'),(20808626,1598,'./premplsum.php'),(20808625,7043,'./premplsum.php'),(20808624,1536,'./premplsum.php'),(20808623,11833,'./premplsum.php'),(20808622,11832,'./premplsum.php'),(20808621,1007,'./premplsum.php'),(20808620,11840,'./premplsum.php'),(20808619,11831,'./premplsum.php'),(20808618,13742,'./premplsum.php'),(20808617,619,'./premplsum.php'),(20808616,607,'./premplsum.php'),(20808615,11829,'./premplsum.php'),(20808614,491,'./premplsum.php'),(20808613,412,'./premplsum.php'),(20808612,7813,'./premplsum.php'),(20808611,315,'./premplsum.php'),(20808610,197,'./premplsum.php'),(20808609,2738,'./premplreviewupd.php'),(20808608,2710,'./premplreviewupd.php'),(20808607,2702,'./premplreviewupd.php'),(20808606,2578,'./premplreviewupd.php'),(20808605,2459,'./premplreviewupd.php'),(20808604,2046,'./premplreviewupd.php'),(20808603,1963,'./premplreviewupd.php'),(20808602,1345,'./premplreviewupd.php'),(20808601,1344,'./premplreviewupd.php'),(20808600,1343,'./premplreviewupd.php'),(20808599,1268,'./premplreviewupd.php'),(20808598,1164,'./premplreviewupd.php'),(20808597,1023,'./premplreviewupd.php'),(20808596,1006,'./premplreviewupd.php'),(20808595,1005,'./premplreviewupd.php'),(20808594,1004,'./premplreviewupd.php'),(20808593,1003,'./premplreviewupd.php'),(20808592,15425,'./premplreviewupd.php'),(20808591,989,'./premplreviewupd.php'),(20808590,848,'./premplreviewupd.php'),(20808589,799,'./premplreviewupd.php'),(20808588,567,'./premplreviewupd.php'),(20808587,341,'./premplreviewupd.php'),(20808586,315,'./premplreviewupd.php'),(20808585,5203,'./premplreviewupd.php'),(20808584,102,'./premplreviewupd.php'),(20808583,59,'./premplreviewupd.php'),(20808582,2702,'./premplreviewadd.php'),(20808581,2578,'./premplreviewadd.php'),(20808580,1345,'./premplreviewadd.php'),(20808579,1343,'./premplreviewadd.php'),(20808578,1075,'./premplreviewadd.php'),(20808577,1002,'./premplreviewadd.php'),(20808576,1001,'./premplreviewadd.php'),(20808575,989,'./premplreviewadd.php'),(20808574,567,'./premplreviewadd.php'),(20808573,315,'./premplreviewadd.php'),(20811641,15841,'./includes/arfunctions.php'),(20808572,10057,'./premployeeupd.php'),(20808571,3405,'./premployeeupd.php'),(20808570,15424,'./premployeeupd.php'),(20808569,3354,'./premployeeupd.php'),(20808568,3267,'./premployeeupd.php'),(20808567,3248,'./premployeeupd.php'),(20808566,3175,'./premployeeupd.php'),(20808565,8385,'./premployeeupd.php'),(20808564,3056,'./premployeeupd.php'),(20808563,7818,'./premployeeupd.php'),(20808562,3020,'./premployeeupd.php'),(20808561,3014,'./premployeeupd.php'),(20808560,2948,'./premployeeupd.php'),(20808559,11425,'./premployeeupd.php'),(20808558,12017,'./premployeeupd.php'),(20808557,2937,'./premployeeupd.php'),(20808556,2936,'./premployeeupd.php'),(20808555,15393,'./premployeeupd.php'),(20808554,2898,'./premployeeupd.php'),(20808553,8778,'./premployeeupd.php'),(20808552,2882,'./premployeeupd.php'),(20808551,2876,'./premployeeupd.php'),(20808550,12093,'./premployeeupd.php'),(20808549,7467,'./premployeeupd.php'),(20808548,5541,'./premployeeupd.php'),(20808547,2702,'./premployeeupd.php'),(20808546,2663,'./premployeeupd.php'),(20808545,2376,'./premployeeupd.php'),(20808544,19312,'./premployeeupd.php'),(20808543,8384,'./premployeeupd.php'),(20808542,2337,'./premployeeupd.php'),(20808541,2331,'./premployeeupd.php'),(20808540,2330,'./premployeeupd.php'),(20808539,2329,'./premployeeupd.php'),(20808538,2327,'./premployeeupd.php'),(20808537,2312,'./premployeeupd.php'),(20808536,2311,'./premployeeupd.php'),(20808535,2295,'./premployeeupd.php'),(20808534,2242,'./premployeeupd.php'),(20808533,2243,'./premployeeupd.php'),(20808532,2270,'./premployeeupd.php'),(20808531,2266,'./premployeeupd.php'),(20808530,2213,'./premployeeupd.php'),(20808529,9400,'./premployeeupd.php'),(20808528,2044,'./premployeeupd.php'),(20808527,1992,'./premployeeupd.php'),(20808526,5540,'./premployeeupd.php'),(20808525,1963,'./premployeeupd.php'),(20808524,1935,'./premployeeupd.php'),(20808523,1934,'./premployeeupd.php'),(20808522,1874,'./premployeeupd.php'),(20808521,17620,'./premployeeupd.php'),(20808520,7217,'./premployeeupd.php'),(20808519,7216,'./premployeeupd.php'),(20808518,11998,'./premployeeupd.php'),(20808517,1822,'./premployeeupd.php'),(20808516,1810,'./premployeeupd.php'),(20808515,15615,'./premployeeupd.php'),(20808514,11997,'./premployeeupd.php'),(20808513,1783,'./premployeeupd.php'),(20808512,1782,'./premployeeupd.php'),(20808511,1758,'./premployeeupd.php'),(20808510,12088,'./premployeeupd.php'),(20808509,1598,'./premployeeupd.php'),(20808508,11423,'./premployeeupd.php'),(20808507,1575,'./premployeeupd.php'),(20808506,1561,'./premployeeupd.php'),(20808505,1556,'./premployeeupd.php'),(20808504,15991,'./premployeeupd.php'),(20808503,1499,'./premployeeupd.php'),(20808502,1476,'./premployeeupd.php'),(20808501,1442,'./premployeeupd.php'),(20808500,1429,'./premployeeupd.php'),(20808499,11422,'./premployeeupd.php'),(20808498,1387,'./premployeeupd.php'),(20808497,1380,'./premployeeupd.php'),(20808496,1379,'./premployeeupd.php'),(20808495,1368,'./premployeeupd.php'),(20808494,1367,'./premployeeupd.php'),(20808493,1366,'./premployeeupd.php'),(20808492,1365,'./premployeeupd.php'),(20808491,1364,'./premployeeupd.php'),(20808490,1363,'./premployeeupd.php'),(20808489,7466,'./premployeeupd.php'),(20808488,7465,'./premployeeupd.php'),(20808487,1362,'./premployeeupd.php'),(20808486,1361,'./premployeeupd.php'),(20808485,5072,'./premployeeupd.php'),(20808484,1352,'./premployeeupd.php'),(20808483,1267,'./premployeeupd.php'),(20808482,1009,'./premployeeupd.php'),(20808481,11421,'./premployeeupd.php'),(20808480,998,'./premployeeupd.php'),(20808479,992,'./premployeeupd.php'),(20808478,989,'./premployeeupd.php'),(20808477,988,'./premployeeupd.php'),(20808476,984,'./premployeeupd.php'),(20808475,981,'./premployeeupd.php'),(20808474,973,'./premployeeupd.php'),(20808473,966,'./premployeeupd.php'),(20808472,962,'./premployeeupd.php'),(20808471,7871,'./premployeeupd.php'),(20808470,941,'./premployeeupd.php'),(20808469,926,'./premployeeupd.php'),(20808468,5453,'./premployeeupd.php'),(20808467,869,'./premployeeupd.php'),(20808466,7284,'./premployeeupd.php'),(20808465,7841,'./premployeeupd.php'),(20808464,799,'./premployeeupd.php'),(20808463,788,'./premployeeupd.php'),(20808462,3579,'./premployeeupd.php'),(20808461,783,'./premployeeupd.php'),(20808460,741,'./premployeeupd.php'),(20808459,7056,'./premployeeupd.php'),(20808458,683,'./premployeeupd.php'),(20808457,659,'./premployeeupd.php'),(20808456,9492,'./premployeeupd.php'),(20808455,619,'./premployeeupd.php'),(20808454,607,'./premployeeupd.php'),(20808453,605,'./premployeeupd.php'),(20808452,542,'./premployeeupd.php'),(20808451,11985,'./premployeeupd.php'),(20808450,525,'./premployeeupd.php'),(20808449,524,'./premployeeupd.php'),(20808448,6565,'./premployeeupd.php'),(20808447,15724,'./premployeeupd.php'),(20808446,15614,'./premployeeupd.php'),(20808445,15613,'./premployeeupd.php'),(20808444,12085,'./premployeeupd.php'),(20808443,12084,'./premployeeupd.php'),(20808442,337,'./premployeeupd.php'),(20808441,13994,'./premployeeupd.php'),(20808440,328,'./premployeeupd.php'),(20808439,5452,'./premployeeupd.php'),(20808438,315,'./premployeeupd.php'),(20808437,5203,'./premployeeupd.php'),(20808436,9399,'./premployeeupd.php'),(20808435,226,'./premployeeupd.php'),(20808434,14001,'./premployeeupd.php'),(20808427,10057,'./premployeeadd.php'),(20808426,3405,'./premployeeadd.php'),(20808425,15424,'./premployeeadd.php'),(20808424,3354,'./premployeeadd.php'),(20808423,3267,'./premployeeadd.php'),(20808422,8385,'./premployeeadd.php'),(20808421,3056,'./premployeeadd.php'),(20808420,3014,'./premployeeadd.php'),(20808419,11425,'./premployeeadd.php'),(20808418,12017,'./premployeeadd.php'),(20808417,2937,'./premployeeadd.php'),(20808416,2936,'./premployeeadd.php'),(20808415,15393,'./premployeeadd.php'),(20808414,2882,'./premployeeadd.php'),(20808413,2876,'./premployeeadd.php'),(20808412,7467,'./premployeeadd.php'),(20808411,5541,'./premployeeadd.php'),(20808410,2734,'./premployeeadd.php'),(20808409,2733,'./premployeeadd.php'),(20808408,2732,'./premployeeadd.php'),(20808407,2731,'./premployeeadd.php'),(20808406,2729,'./premployeeadd.php'),(20808405,2702,'./premployeeadd.php'),(20808404,2663,'./premployeeadd.php'),(20808403,2376,'./premployeeadd.php'),(20808402,2351,'./premployeeadd.php'),(20808401,19312,'./premployeeadd.php'),(20808400,8384,'./premployeeadd.php'),(20808399,2331,'./premployeeadd.php'),(20808398,2330,'./premployeeadd.php'),(20808397,2329,'./premployeeadd.php'),(20808396,2327,'./premployeeadd.php'),(20808395,2312,'./premployeeadd.php'),(20808394,2311,'./premployeeadd.php'),(20808393,2295,'./premployeeadd.php'),(20808392,2242,'./premployeeadd.php'),(20808391,2243,'./premployeeadd.php'),(20808390,2270,'./premployeeadd.php'),(20808389,2266,'./premployeeadd.php'),(20808388,2213,'./premployeeadd.php'),(20808387,2147,'./premployeeadd.php'),(20808386,9400,'./premployeeadd.php'),(20808385,5540,'./premployeeadd.php'),(20808384,1963,'./premployeeadd.php'),(20808383,7902,'./premployeeadd.php'),(20808382,1935,'./premployeeadd.php'),(20808381,1934,'./premployeeadd.php'),(20808380,1874,'./premployeeadd.php'),(20808379,7217,'./premployeeadd.php'),(20808378,7216,'./premployeeadd.php'),(20808377,11998,'./premployeeadd.php'),(20808376,1822,'./premployeeadd.php'),(20808375,1810,'./premployeeadd.php'),(20808374,11997,'./premployeeadd.php'),(20808373,1783,'./premployeeadd.php'),(20808372,1782,'./premployeeadd.php'),(20808371,1758,'./premployeeadd.php'),(20808370,12088,'./premployeeadd.php'),(20808369,11423,'./premployeeadd.php'),(20808368,1561,'./premployeeadd.php'),(20808367,1556,'./premployeeadd.php'),(20808366,15991,'./premployeeadd.php'),(20808365,1499,'./premployeeadd.php'),(20808364,1476,'./premployeeadd.php'),(20808363,1442,'./premployeeadd.php'),(20808362,1429,'./premployeeadd.php'),(20808361,1423,'./premployeeadd.php'),(20808360,11422,'./premployeeadd.php'),(20808359,1387,'./premployeeadd.php'),(20808358,1380,'./premployeeadd.php'),(20808357,1379,'./premployeeadd.php'),(20808356,1368,'./premployeeadd.php'),(20808355,1367,'./premployeeadd.php'),(20808354,1366,'./premployeeadd.php'),(20808353,1365,'./premployeeadd.php'),(20808352,1364,'./premployeeadd.php'),(20808351,1363,'./premployeeadd.php'),(20808350,7466,'./premployeeadd.php'),(20808349,7465,'./premployeeadd.php'),(20808348,1362,'./premployeeadd.php'),(20808347,1361,'./premployeeadd.php'),(20808346,5072,'./premployeeadd.php'),(20808345,1352,'./premployeeadd.php'),(20808344,8936,'./premployeeadd.php'),(20808343,1074,'./premployeeadd.php'),(20808342,11421,'./premployeeadd.php'),(20808341,991,'./premployeeadd.php'),(20808340,988,'./premployeeadd.php'),(20808339,984,'./premployeeadd.php'),(20808338,973,'./premployeeadd.php'),(20808337,869,'./premployeeadd.php'),(20808336,7284,'./premployeeadd.php'),(20808335,788,'./premployeeadd.php'),(20808334,3579,'./premployeeadd.php'),(20808333,783,'./premployeeadd.php'),(20808332,741,'./premployeeadd.php'),(20808331,659,'./premployeeadd.php'),(20808330,9492,'./premployeeadd.php'),(20808329,619,'./premployeeadd.php'),(20808328,607,'./premployeeadd.php'),(20808327,605,'./premployeeadd.php'),(20808326,11985,'./premployeeadd.php'),(20808325,525,'./premployeeadd.php'),(20808324,524,'./premployeeadd.php'),(20808323,6565,'./premployeeadd.php'),(20808322,15614,'./premployeeadd.php'),(20808321,15613,'./premployeeadd.php'),(20808320,12085,'./premployeeadd.php'),(20808319,12084,'./premployeeadd.php'),(20808318,13994,'./premployeeadd.php'),(20808317,328,'./premployeeadd.php'),(20808316,17210,'./premployeeadd.php'),(20808315,9399,'./premployeeadd.php'),(20808314,226,'./premployeeadd.php'),(20808313,14001,'./premployeeadd.php'),(20808312,173,'./premployeeadd.php'),(20808311,154,'./premployeeadd.php'),(20808307,7817,'./prempllist.php'),(20808306,3358,'./prempllist.php'),(20808305,7816,'./prempllist.php'),(20808304,3118,'./prempllist.php'),(20808303,2936,'./prempllist.php'),(20808302,2914,'./prempllist.php'),(20808301,2867,'./prempllist.php'),(20808300,7055,'./prempllist.php'),(20808299,2614,'./prempllist.php'),(20808298,2612,'./prempllist.php'),(20808297,2536,'./prempllist.php'),(20808296,2535,'./prempllist.php'),(20808295,2335,'./prempllist.php'),(20808294,2328,'./prempllist.php'),(20808293,2325,'./prempllist.php'),(20808292,2324,'./prempllist.php'),(20808291,2244,'./prempllist.php'),(20808290,7054,'./prempllist.php'),(20808289,7053,'./prempllist.php'),(20808288,7052,'./prempllist.php'),(20808287,2238,'./prempllist.php'),(20808286,17013,'./prempllist.php'),(20808285,2038,'./prempllist.php'),(20808284,1996,'./prempllist.php'),(20808283,1963,'./prempllist.php'),(20808282,1915,'./prempllist.php'),(20808281,1913,'./prempllist.php'),(20808280,1822,'./prempllist.php'),(20808279,1782,'./prempllist.php'),(20808278,1584,'./prempllist.php'),(20808277,1578,'./prempllist.php'),(20808276,1564,'./prempllist.php'),(20808275,7051,'./prempllist.php'),(20808274,1553,'./prempllist.php'),(20808273,1480,'./prempllist.php'),(20808272,1453,'./prempllist.php'),(20808271,1376,'./prempllist.php'),(20808270,1352,'./prempllist.php'),(20808269,8936,'./prempllist.php'),(20808268,6195,'./prempllist.php'),(20808267,7050,'./prempllist.php'),(20808266,996,'./prempllist.php'),(20808265,989,'./prempllist.php'),(20808264,7815,'./prempllist.php'),(20808263,524,'./prempllist.php'),(20808262,7814,'./prempllist.php'),(20808261,7813,'./prempllist.php'),(20808260,379,'./prempllist.php'),(20808259,315,'./prempllist.php'),(20808258,256,'./prempllist.php'),(20808255,15410,'./prempldedtype.php'),(20808254,2710,'./prempldedtype.php'),(20808253,2702,'./prempldedtype.php'),(20808252,9807,'./prempldedtype.php'),(20808251,15550,'./prempldedtype.php'),(20808250,13287,'./prempldedtype.php'),(20808249,15742,'./prempldedtype.php'),(20808248,1935,'./prempldedtype.php'),(20808247,7972,'./prempldedtype.php'),(20808246,1499,'./prempldedtype.php'),(20808245,15906,'./prempldedtype.php'),(20808244,1480,'./prempldedtype.php'),(20808243,8936,'./prempldedtype.php'),(20808242,15702,'./prempldedtype.php'),(20808241,15741,'./prempldedtype.php'),(20808240,941,'./prempldedtype.php'),(20808239,799,'./prempldedtype.php'),(20808238,15740,'./prempldedtype.php'),(20808237,13994,'./prempldedtype.php'),(20808236,315,'./prempldedtype.php'),(20808235,5203,'./prempldedtype.php'),(20808234,59,'./prempldedtype.php'),(20808798,8936,'./prloghours.php'),(20808233,3274,'./premplded.php'),(20808232,17768,'./premplded.php'),(20808231,2710,'./premplded.php'),(20808230,2702,'./premplded.php'),(20808229,2606,'./premplded.php'),(20808228,15423,'./premplded.php'),(20808227,2315,'./premplded.php'),(20808226,17767,'./premplded.php'),(20808225,17766,'./premplded.php'),(20808224,7709,'./premplded.php'),(20808223,2160,'./premplded.php'),(20808222,15422,'./premplded.php'),(20808221,6618,'./premplded.php'),(20808220,1935,'./premplded.php'),(20808219,15421,'./premplded.php'),(20808218,17765,'./premplded.php'),(20808217,1499,'./premplded.php'),(20808216,15824,'./premplded.php'),(20808215,8936,'./premplded.php'),(20808214,1013,'./premplded.php'),(20808213,993,'./premplded.php'),(20808212,966,'./premplded.php'),(20808211,941,'./premplded.php'),(20808210,869,'./premplded.php'),(20808209,803,'./premplded.php'),(20808198,5547,'./prdepcheckwrite.php'),(20808197,2919,'./prdepcheckwrite.php'),(20808196,2463,'./prdepcheckwrite.php'),(20808195,1963,'./prdepcheckwrite.php'),(20808194,5546,'./prdepcheckwrite.php'),(20808193,1047,'./prdepcheckwrite.php'),(20808192,5545,'./prdepcheckwrite.php'),(20808191,542,'./prdepcheckwrite.php'),(20808190,5544,'./prdepcheckwrite.php'),(20808189,491,'./prdepcheckwrite.php'),(20808188,488,'./prdepcheckwrite.php'),(20808187,484,'./prdepcheckwrite.php'),(20808186,512,'./prdepcheckwrite.php'),(20808185,315,'./prdepcheckwrite.php'),(20808184,59,'./prdepcheckwrite.php'),(20808183,5561,'./prddvoid.php'),(20808182,5560,'./prddvoid.php'),(20808181,5559,'./prddvoid.php'),(20808180,5558,'./prddvoid.php'),(20808179,5557,'./prddvoid.php'),(20808178,5556,'./prddvoid.php'),(20808177,1963,'./prddvoid.php'),(20808176,5555,'./prddvoid.php'),(20808175,1047,'./prddvoid.php'),(20808174,5554,'./prddvoid.php'),(20808173,5553,'./prddvoid.php'),(20808172,5552,'./prddvoid.php'),(20808171,5551,'./prddvoid.php'),(20808170,5550,'./prddvoid.php'),(20808169,542,'./prddvoid.php'),(20808168,5549,'./prddvoid.php'),(20808167,5548,'./prddvoid.php'),(20808166,4871,'./prddvoid.php'),(20808165,5399,'./prddvoid.php'),(20808164,8964,'./prddemail.php'),(20808163,8956,'./prddemail.php'),(20808162,1880,'./prddemail.php'),(20808161,8955,'./prddemail.php'),(20808160,8954,'./prddemail.php'),(20808159,542,'./prddemail.php'),(20808158,3225,'./prcost_centerupd.php'),(20808157,3186,'./prcost_centerupd.php'),(20808156,2702,'./prcost_centerupd.php'),(20808155,11819,'./prcost_centerupd.php'),(20808154,6481,'./prcost_centerupd.php'),(20808153,1143,'./prcost_centerupd.php'),(20808152,941,'./prcost_centerupd.php'),(20808151,6938,'./prcost_centerupd.php'),(20808150,864,'./prcost_centerupd.php'),(20808149,799,'./prcost_centerupd.php'),(20808148,6947,'./prcost_centerupd.php'),(20808147,619,'./prcost_centerupd.php'),(20808146,315,'./prcost_centerupd.php'),(20808145,5203,'./prcost_centerupd.php'),(20808144,59,'./prcost_centerupd.php'),(20808143,2702,'./prcost_centeradd.php'),(20808142,11818,'./prcost_centeradd.php'),(20808141,6481,'./prcost_centeradd.php'),(20808140,3994,'./prcost_centeradd.php'),(20808139,6938,'./prcost_centeradd.php'),(20808138,6947,'./prcost_centeradd.php'),(20808137,6946,'./prcost_centeradd.php'),(20808136,315,'./prcost_centeradd.php'),(20808135,176,'./prcost_centeradd.php'),(20808134,5465,'./prcheckwrite.php'),(20808133,3411,'./prcheckwrite.php'),(20808132,3886,'./prcheckwrite.php'),(20808131,3402,'./prcheckwrite.php'),(20808130,11817,'./prcheckwrite.php'),(20808129,5070,'./prcheckwrite.php'),(20808128,3002,'./prcheckwrite.php'),(20808127,2998,'./prcheckwrite.php'),(20808126,2980,'./prcheckwrite.php'),(20808125,2919,'./prcheckwrite.php'),(20808124,2773,'./prcheckwrite.php'),(20808123,5464,'./prcheckwrite.php'),(20808122,2463,'./prcheckwrite.php'),(20808121,2380,'./prcheckwrite.php'),(20808120,2270,'./prcheckwrite.php'),(20808119,1983,'./prcheckwrite.php'),(20808118,1963,'./prcheckwrite.php'),(20808117,1470,'./prcheckwrite.php'),(20808116,8936,'./prcheckwrite.php'),(20808115,1011,'./prcheckwrite.php'),(20808114,8953,'./prcheckwrite.php'),(20808113,13734,'./prcheckwrite.php'),(20808112,5463,'./prcheckwrite.php'),(20808111,5462,'./prcheckwrite.php'),(20808110,5461,'./prcheckwrite.php'),(20808109,8007,'./prcheckwrite.php'),(20808108,5460,'./prcheckwrite.php'),(20808107,607,'./prcheckwrite.php'),(20808106,5191,'./prcheckwrite.php'),(20808105,6134,'./prcheckwrite.php'),(20808104,6137,'./prcheckwrite.php'),(20808103,488,'./prcheckwrite.php'),(20808102,484,'./prcheckwrite.php'),(20808101,483,'./prcheckwrite.php'),(20808100,520,'./prcheckwrite.php'),(20808099,514,'./prcheckwrite.php'),(20808098,512,'./prcheckwrite.php'),(20808097,340,'./prcheckwrite.php'),(20808096,315,'./prcheckwrite.php'),(20808095,11816,'./prcheckwrite.php'),(20808094,7464,'./prcheckwrite.php'),(20808093,59,'./prcheckwrite.php'),(20808092,3329,'./prcheckvoid.php'),(20808091,3328,'./prcheckvoid.php'),(20808090,3327,'./prcheckvoid.php'),(20808089,3331,'./prcheckvoid.php'),(20808088,2979,'./prcheckvoid.php'),(20808087,2900,'./prcheckvoid.php'),(20808086,2615,'./prcheckvoid.php'),(20808085,15674,'./prcheckvoid.php'),(20808084,2164,'./prcheckvoid.php'),(20808083,2098,'./prcheckvoid.php'),(20808082,868,'./prcheckvoid.php'),(20808081,542,'./prcheckvoid.php'),(20808080,499,'./prcheckvoid.php'),(20808079,498,'./prcheckvoid.php'),(20808078,5190,'./prcheckvoid.php'),(20808077,491,'./prcheckvoid.php'),(20808076,5189,'./prcheckvoid.php'),(20808075,471,'./prcheckvoid.php'),(20808074,5203,'./prcheckvoid.php'),(20808073,222,'./prcheckvoid.php'),(20808072,3415,'./prchecksumsui.php'),(20808071,3402,'./prchecksumsui.php'),(20808070,14167,'./prchecksumsui.php'),(20808069,7047,'./prchecksumsui.php'),(20808068,7046,'./prchecksumsui.php'),(20808067,3090,'./prchecksumsui.php'),(20808066,3068,'./prchecksumsui.php'),(20808065,3067,'./prchecksumsui.php'),(20808064,3000,'./prchecksumsui.php'),(20808063,14166,'./prchecksumsui.php'),(20808062,2998,'./prchecksumsui.php'),(20808061,14170,'./prchecksumsui.php'),(20808060,14169,'./prchecksumsui.php'),(20808059,14168,'./prchecksumsui.php'),(20808058,2977,'./prchecksumsui.php'),(20808057,2939,'./prchecksumsui.php'),(20808056,12035,'./prchecksumsui.php'),(20808055,2936,'./prchecksumsui.php'),(20808054,11783,'./prchecksumsui.php'),(20808053,15415,'./prchecksumsui.php'),(20808052,2773,'./prchecksumsui.php'),(20808051,7045,'./prchecksumsui.php'),(20808050,2535,'./prchecksumsui.php'),(20808049,2321,'./prchecksumsui.php'),(20808048,2315,'./prchecksumsui.php'),(20808047,2225,'./prchecksumsui.php'),(20808046,5985,'./prchecksumsui.php'),(20808045,2120,'./prchecksumsui.php'),(20808044,2055,'./prchecksumsui.php'),(20808043,1963,'./prchecksumsui.php'),(20808042,1945,'./prchecksumsui.php'),(20808041,1935,'./prchecksumsui.php'),(20808040,1913,'./prchecksumsui.php'),(20808039,1906,'./prchecksumsui.php'),(20808038,1902,'./prchecksumsui.php'),(20808037,1900,'./prchecksumsui.php'),(20808036,1873,'./prchecksumsui.php'),(20808035,1872,'./prchecksumsui.php'),(20808034,1785,'./prchecksumsui.php'),(20808033,1782,'./prchecksumsui.php'),(20808032,7044,'./prchecksumsui.php'),(20808031,1598,'./prchecksumsui.php'),(20808030,7043,'./prchecksumsui.php'),(20808029,7042,'./prchecksumsui.php'),(20808028,7041,'./prchecksumsui.php'),(20808027,7040,'./prchecksumsui.php'),(20808026,7811,'./prchecksumsui.php'),(20808025,7808,'./prchecksumsui.php'),(20808024,7807,'./prchecksumsui.php'),(20808023,7806,'./prchecksumsui.php'),(20808022,1471,'./prchecksumsui.php'),(20808021,1397,'./prchecksumsui.php'),(20808020,1377,'./prchecksumsui.php'),(20808019,14162,'./prchecksumsui.php'),(20808018,1007,'./prchecksumsui.php'),(20808017,989,'./prchecksumsui.php'),(20808016,13738,'./prchecksumsui.php'),(20808015,5715,'./prchecksumsui.php'),(20808014,781,'./prchecksumsui.php'),(20808013,607,'./prchecksumsui.php'),(20808012,527,'./prchecksumsui.php'),(20808011,524,'./prchecksumsui.php'),(20808010,7039,'./prchecksumsui.php'),(20808009,412,'./prchecksumsui.php'),(20808008,315,'./prchecksumsui.php'),(20808007,197,'./prchecksumsui.php'),(20808006,7464,'./prchecksumsui.php'),(20808909,15430,'./prrpt.php'),(20808005,3415,'./prchecksumgroup.php'),(20808004,3402,'./prchecksumgroup.php'),(20808003,7047,'./prchecksumgroup.php'),(20808002,7046,'./prchecksumgroup.php'),(20808001,3106,'./prchecksumgroup.php'),(20808000,3090,'./prchecksumgroup.php'),(20807999,3068,'./prchecksumgroup.php'),(20807998,3067,'./prchecksumgroup.php'),(20807997,2998,'./prchecksumgroup.php'),(20807996,2981,'./prchecksumgroup.php'),(20807995,2980,'./prchecksumgroup.php'),(20807994,2939,'./prchecksumgroup.php'),(20807993,12035,'./prchecksumgroup.php'),(20807992,2936,'./prchecksumgroup.php'),(20807991,15417,'./prchecksumgroup.php'),(20807990,15415,'./prchecksumgroup.php'),(20807989,15418,'./prchecksumgroup.php'),(20807988,17012,'./prchecksumgroup.php'),(20807987,2773,'./prchecksumgroup.php'),(20807986,7045,'./prchecksumgroup.php'),(20807985,12034,'./prchecksumgroup.php'),(20807984,2535,'./prchecksumgroup.php'),(20807983,2321,'./prchecksumgroup.php'),(20807982,2315,'./prchecksumgroup.php'),(20807981,7812,'./prchecksumgroup.php'),(20807980,2238,'./prchecksumgroup.php'),(20807979,2225,'./prchecksumgroup.php'),(20807978,5985,'./prchecksumgroup.php'),(20807977,2120,'./prchecksumgroup.php'),(20807976,2055,'./prchecksumgroup.php'),(20807975,17011,'./prchecksumgroup.php'),(20807974,1963,'./prchecksumgroup.php'),(20807973,1945,'./prchecksumgroup.php'),(20807972,1935,'./prchecksumgroup.php'),(20807971,1913,'./prchecksumgroup.php'),(20807970,1906,'./prchecksumgroup.php'),(20807969,1902,'./prchecksumgroup.php'),(20807968,1900,'./prchecksumgroup.php'),(20807967,5706,'./prchecksumgroup.php'),(20807966,1872,'./prchecksumgroup.php'),(20807965,1785,'./prchecksumgroup.php'),(20807964,1782,'./prchecksumgroup.php'),(20807963,7044,'./prchecksumgroup.php'),(20807962,1598,'./prchecksumgroup.php'),(20807961,1564,'./prchecksumgroup.php'),(20807960,7043,'./prchecksumgroup.php'),(20807959,7042,'./prchecksumgroup.php'),(20807958,7041,'./prchecksumgroup.php'),(20807957,7040,'./prchecksumgroup.php'),(20807956,16497,'./prchecksumgroup.php'),(20807955,16496,'./prchecksumgroup.php'),(20807954,1537,'./prchecksumgroup.php'),(20807953,1536,'./prchecksumgroup.php'),(20807952,1471,'./prchecksumgroup.php'),(20807951,1470,'./prchecksumgroup.php'),(20807950,1377,'./prchecksumgroup.php'),(20807949,1385,'./prchecksumgroup.php'),(20807948,8936,'./prchecksumgroup.php'),(20807947,1007,'./prchecksumgroup.php'),(20807946,989,'./prchecksumgroup.php'),(20807945,13738,'./prchecksumgroup.php'),(20807944,5715,'./prchecksumgroup.php'),(20807943,974,'./prchecksumgroup.php'),(20807942,13734,'./prchecksumgroup.php'),(20807941,790,'./prchecksumgroup.php'),(20807940,781,'./prchecksumgroup.php'),(20807939,607,'./prchecksumgroup.php'),(20807938,576,'./prchecksumgroup.php'),(20807937,527,'./prchecksumgroup.php'),(20807936,524,'./prchecksumgroup.php'),(20807935,7039,'./prchecksumgroup.php'),(20807934,412,'./prchecksumgroup.php'),(20807930,3415,'./prchecksumfuisui.php'),(20807929,3402,'./prchecksumfuisui.php'),(20807928,14167,'./prchecksumfuisui.php'),(20807927,7047,'./prchecksumfuisui.php'),(20807926,7046,'./prchecksumfuisui.php'),(20807925,3090,'./prchecksumfuisui.php'),(20807924,3068,'./prchecksumfuisui.php'),(20807923,3067,'./prchecksumfuisui.php'),(20807922,3000,'./prchecksumfuisui.php'),(20807921,14166,'./prchecksumfuisui.php'),(20807920,2998,'./prchecksumfuisui.php'),(20807919,2981,'./prchecksumfuisui.php'),(20807918,2977,'./prchecksumfuisui.php'),(20807917,2939,'./prchecksumfuisui.php'),(20807916,12035,'./prchecksumfuisui.php'),(20807915,2936,'./prchecksumfuisui.php'),(20807914,11783,'./prchecksumfuisui.php'),(20807913,15415,'./prchecksumfuisui.php'),(20807912,2773,'./prchecksumfuisui.php'),(20807911,7045,'./prchecksumfuisui.php'),(20807910,2535,'./prchecksumfuisui.php'),(20807909,2321,'./prchecksumfuisui.php'),(20807908,2315,'./prchecksumfuisui.php'),(20807907,2225,'./prchecksumfuisui.php'),(20807906,5985,'./prchecksumfuisui.php'),(20807905,2120,'./prchecksumfuisui.php'),(20807904,2055,'./prchecksumfuisui.php'),(20807903,1963,'./prchecksumfuisui.php'),(20807902,1945,'./prchecksumfuisui.php'),(20807901,1935,'./prchecksumfuisui.php'),(20807900,1913,'./prchecksumfuisui.php'),(20807899,1906,'./prchecksumfuisui.php'),(20807898,1902,'./prchecksumfuisui.php'),(20807897,1900,'./prchecksumfuisui.php'),(20807896,1873,'./prchecksumfuisui.php'),(20807895,1872,'./prchecksumfuisui.php'),(20807894,1785,'./prchecksumfuisui.php'),(20807893,1782,'./prchecksumfuisui.php'),(20807892,7044,'./prchecksumfuisui.php'),(20807891,1598,'./prchecksumfuisui.php'),(20807890,7043,'./prchecksumfuisui.php'),(20807889,7042,'./prchecksumfuisui.php'),(20807888,7041,'./prchecksumfuisui.php'),(20807887,7040,'./prchecksumfuisui.php'),(20807886,7811,'./prchecksumfuisui.php'),(20807885,7808,'./prchecksumfuisui.php'),(20807884,7807,'./prchecksumfuisui.php'),(20807883,7806,'./prchecksumfuisui.php'),(20807882,14165,'./prchecksumfuisui.php'),(20807881,14164,'./prchecksumfuisui.php'),(20807880,14163,'./prchecksumfuisui.php'),(20807879,1397,'./prchecksumfuisui.php'),(20807878,1377,'./prchecksumfuisui.php'),(20807877,14162,'./prchecksumfuisui.php'),(20807876,1007,'./prchecksumfuisui.php'),(20807875,989,'./prchecksumfuisui.php'),(20807874,13738,'./prchecksumfuisui.php'),(20807873,5715,'./prchecksumfuisui.php'),(20807872,13734,'./prchecksumfuisui.php'),(20807871,781,'./prchecksumfuisui.php'),(20807870,607,'./prchecksumfuisui.php'),(20807869,527,'./prchecksumfuisui.php'),(20807868,524,'./prchecksumfuisui.php'),(20807867,7039,'./prchecksumfuisui.php'),(20807866,412,'./prchecksumfuisui.php'),(20807865,315,'./prchecksumfuisui.php'),(20807864,197,'./prchecksumfuisui.php'),(20807863,7464,'./prchecksumfuisui.php'),(20808908,15429,'./prrpt.php'),(20807862,8239,'./prchecksum.php'),(20807861,3411,'./prchecksum.php'),(20807860,3402,'./prchecksum.php'),(20807859,5543,'./prchecksum.php'),(20807858,3327,'./prchecksum.php'),(20807857,5542,'./prchecksum.php'),(20807856,3106,'./prchecksum.php'),(20807855,8400,'./prchecksum.php'),(20807854,5458,'./prchecksum.php'),(20807853,3090,'./prchecksum.php'),(20807852,3069,'./prchecksum.php'),(20807851,3067,'./prchecksum.php'),(20807850,2998,'./prchecksum.php'),(20807849,2980,'./prchecksum.php'),(20807848,2977,'./prchecksum.php'),(20807847,2940,'./prchecksum.php'),(20807846,2939,'./prchecksum.php'),(20807845,12035,'./prchecksum.php'),(20807844,15417,'./prchecksum.php'),(20807843,15415,'./prchecksum.php'),(20807842,2773,'./prchecksum.php'),(20807841,12034,'./prchecksum.php'),(20807840,5464,'./prchecksum.php'),(20807839,2463,'./prchecksum.php'),(20807838,2315,'./prchecksum.php'),(20807837,2238,'./prchecksum.php'),(20807836,2120,'./prchecksum.php'),(20807835,2055,'./prchecksum.php'),(20807834,5586,'./prchecksum.php'),(20807833,1963,'./prchecksum.php'),(20807832,1946,'./prchecksum.php'),(20807831,1945,'./prchecksum.php'),(20807830,1908,'./prchecksum.php'),(20807829,1904,'./prchecksum.php'),(20807828,1901,'./prchecksum.php'),(20807827,5706,'./prchecksum.php'),(20807826,1872,'./prchecksum.php'),(20807825,1786,'./prchecksum.php'),(20807824,1785,'./prchecksum.php'),(20807823,5585,'./prchecksum.php'),(20807822,1564,'./prchecksum.php'),(20807821,16497,'./prchecksum.php'),(20807820,16496,'./prchecksum.php'),(20807819,1537,'./prchecksum.php'),(20807818,1536,'./prchecksum.php'),(20807817,1470,'./prchecksum.php'),(20807816,1378,'./prchecksum.php'),(20807815,1385,'./prchecksum.php'),(20807814,989,'./prchecksum.php'),(20807813,8953,'./prchecksum.php'),(20807812,5715,'./prchecksum.php'),(20807811,974,'./prchecksum.php'),(20807810,13734,'./prchecksum.php'),(20807809,5453,'./prchecksum.php'),(20807808,867,'./prchecksum.php'),(20807807,8238,'./prchecksum.php'),(20807806,790,'./prchecksum.php'),(20807805,781,'./prchecksum.php'),(20807804,737,'./prchecksum.php'),(20807803,547,'./prchecksum.php'),(20807802,15416,'./prchecksum.php'),(20807801,546,'./prchecksum.php'),(20807800,545,'./prchecksum.php'),(20807799,13741,'./prchecksum.php'),(20807798,607,'./prchecksum.php'),(20807797,576,'./prchecksum.php'),(20807796,528,'./prchecksum.php'),(20807795,527,'./prchecksum.php'),(20807794,3561,'./prchecksum.php'),(20807793,492,'./prchecksum.php'),(20807792,490,'./prchecksum.php'),(20807791,484,'./prchecksum.php'),(20807790,412,'./prchecksum.php'),(20807789,315,'./prchecksum.php'),(20807788,8672,'./prchecksum.php'),(20807786,5753,'./prchecks.php'),(20807785,3427,'./prchecks.php'),(20807784,16454,'./prchecks.php'),(20807783,8401,'./prchecks.php'),(20807782,8400,'./prchecks.php'),(20807781,3098,'./prchecks.php'),(20807780,4597,'./prchecks.php'),(20807779,3031,'./prchecks.php'),(20807778,2985,'./prchecks.php'),(20807777,2939,'./prchecks.php'),(20807776,11783,'./prchecks.php'),(20807775,15415,'./prchecks.php'),(20807774,11828,'./prchecks.php'),(20807773,12034,'./prchecks.php'),(20807772,2565,'./prchecks.php'),(20807771,11782,'./prchecks.php'),(20807770,11781,'./prchecks.php'),(20807769,2243,'./prchecks.php'),(20807768,7773,'./prchecks.php'),(20807767,2287,'./prchecks.php'),(20807766,2238,'./prchecks.php'),(20807765,11780,'./prchecks.php'),(20807764,1997,'./prchecks.php'),(20807763,1945,'./prchecks.php'),(20807762,1907,'./prchecks.php'),(20807761,1903,'./prchecks.php'),(20807760,1900,'./prchecks.php'),(20807759,1872,'./prchecks.php'),(20807758,1785,'./prchecks.php'),(20807757,1575,'./prchecks.php'),(20807756,1564,'./prchecks.php'),(20807755,1536,'./prchecks.php'),(20807754,1439,'./prchecks.php'),(20807753,1385,'./prchecks.php'),(20807752,1382,'./prchecks.php'),(20807751,1047,'./prchecks.php'),(20807750,11779,'./prchecks.php'),(20807749,5410,'./prchecks.php'),(20807748,989,'./prchecks.php'),(20807747,974,'./prchecks.php'),(20807746,5454,'./prchecks.php'),(20807745,790,'./prchecks.php'),(20807744,683,'./prchecks.php'),(20807743,7038,'./prchecks.php'),(20807742,542,'./prchecks.php'),(20807741,540,'./prchecks.php'),(20807740,527,'./prchecks.php'),(20807739,5963,'./prchecks.php'),(20807738,5962,'./prchecks.php'),(20807737,5961,'./prchecks.php'),(20807736,5960,'./prchecks.php'),(20807735,5959,'./prchecks.php'),(20807734,491,'./prchecks.php'),(20807733,8501,'./prchecks.php'),(20807731,3415,'./prcalchours.php'),(20807730,3886,'./prcalchours.php'),(20807729,12909,'./prcalchours.php'),(20807728,2773,'./prcalchours.php'),(20807727,2535,'./prcalchours.php'),(20807726,2388,'./prcalchours.php'),(20807725,2315,'./prcalchours.php'),(20807724,2120,'./prcalchours.php'),(20807723,2055,'./prcalchours.php'),(20807722,2090,'./prcalchours.php'),(20807721,1913,'./prcalchours.php'),(20807720,7037,'./prcalchours.php'),(20807719,1566,'./prcalchours.php'),(20807718,9187,'./prcalchours.php'),(20807717,9186,'./prcalchours.php'),(20807716,484,'./prcalchours.php'),(20807715,7036,'./prcalchours.php'),(20807714,3553,'./prcalchours.php'),(20807713,408,'./prcalchours.php'),(20807712,315,'./prcalchours.php'),(20807711,13803,'./pr941printdetail.php'),(20807710,3101,'./pr941printdetail.php'),(20807709,13802,'./pr941printdetail.php'),(20807708,13801,'./pr941printdetail.php'),(20807707,2535,'./pr941printdetail.php'),(20807706,1935,'./pr941printdetail.php'),(20807705,13800,'./pr941printdetail.php'),(20807704,13799,'./pr941printdetail.php'),(20807703,8936,'./pr941printaid.php'),(20807702,315,'./pr941printaid.php'),(20687335,3427,'./pr941print_autofill.php'),(20687334,540,'./pr941print_autofill.php'),(20727999,3427,'./pr941print.php'),(20727998,540,'./pr941print.php'),(20807701,12916,'./pr941file.php'),(20807700,13139,'./pr941file.php'),(20807699,8936,'./pr941file.php'),(20807698,12913,'./pr941file.php'),(20807697,3418,'./pr941.php'),(20807696,13138,'./pr941.php'),(20807695,2037,'./pr941.php'),(20807694,12912,'./pr941.php'),(20807693,12911,'./pr941.php'),(20807692,315,'./pr941.php'),(20807691,12910,'./pr941.php'),(20807690,13798,'./pr941.php'),(20807689,7842,'./pr941.php'),(20807688,9060,'./popcalendarlang.php'),(20807687,2798,'./popcalendarlang.php'),(20807686,2129,'./popcalendarlang.php'),(20807685,2106,'./popcalendarlang.php'),(20807684,9046,'./popcalendarlang.php'),(20807683,9045,'./popcalendarlang.php'),(20807682,9044,'./popcalendarlang.php'),(20807681,9043,'./popcalendarlang.php'),(20807680,9042,'./popcalendarlang.php'),(20807679,9041,'./popcalendarlang.php'),(20807678,9040,'./popcalendarlang.php'),(20807677,9039,'./popcalendarlang.php'),(20807676,9038,'./popcalendarlang.php'),(20807675,9037,'./popcalendarlang.php'),(20807674,9036,'./popcalendarlang.php'),(20807673,9035,'./popcalendarlang.php'),(20807672,1871,'./popcalendarlang.php'),(20807671,1821,'./popcalendarlang.php'),(20807670,1749,'./popcalendarlang.php'),(20807669,1747,'./popcalendarlang.php'),(20807668,1741,'./popcalendarlang.php'),(20807667,1375,'./popcalendarlang.php'),(20807666,778,'./popcalendarlang.php'),(20807665,9059,'./popcalendarlang.php'),(20807664,9058,'./popcalendarlang.php'),(20807663,9057,'./popcalendarlang.php'),(20807662,9056,'./popcalendarlang.php'),(20807661,9055,'./popcalendarlang.php'),(20807660,9054,'./popcalendarlang.php'),(20807659,9053,'./popcalendarlang.php'),(20807658,308,'./popcalendarlang.php'),(20807657,275,'./popcalendarlang.php'),(20807656,14345,'./pmworktypeadd.php'),(20807655,3392,'./pmworktypeadd.php'),(20807654,3391,'./pmworktypeadd.php'),(20807653,3384,'./pmworktypeadd.php'),(20807652,14344,'./pmworktypeadd.php'),(20807651,14343,'./pmworktypeadd.php'),(20807650,14342,'./pmworktypeadd.php'),(20807649,3383,'./pmworktypeadd.php'),(20807648,3382,'./pmworktypeadd.php'),(20807647,3381,'./pmworktypeadd.php'),(20807646,3319,'./pmworktypeadd.php'),(20807645,2710,'./pmworktypeadd.php'),(20807644,2702,'./pmworktypeadd.php'),(20807643,9551,'./pmworktypeadd.php'),(20807642,1935,'./pmworktypeadd.php'),(20807641,941,'./pmworktypeadd.php'),(20807640,14341,'./pmworktypeadd.php'),(20807639,799,'./pmworktypeadd.php'),(20807638,542,'./pmworktypeadd.php'),(20807637,315,'./pmworktypeadd.php'),(20807636,5203,'./pmworktypeadd.php'),(20807635,59,'./pmworktypeadd.php'),(20807634,11287,'./pmworkorderstatsreport.php'),(20807633,11286,'./pmworkorderstatsreport.php'),(20807632,7237,'./pmworkorderstatsreport.php'),(20807631,9656,'./pmworkorderstatsreport.php'),(20807630,2738,'./pmworkorderstatsreport.php'),(20807629,11479,'./pmworkorderstatsreport.php'),(20807628,11285,'./pmworkorderstatsreport.php'),(20807627,2151,'./pmworkorderstatsreport.php'),(20807626,9789,'./pmworkorderstatsreport.php'),(20807625,11478,'./pmworkorderstatsreport.php'),(20807624,10875,'./pmworkorderstatsreport.php'),(20807623,4106,'./pmworkorderstatsreport.php'),(20807622,596,'./pmworkorderstatsreport.php'),(20807621,573,'./pmworkorderstatsreport.php'),(20807620,11284,'./pmworkorderstatsreport.php'),(20807619,11283,'./pmworkorderstatsreport.php'),(20807618,10742,'./pmworkordernotify.php'),(20807617,10741,'./pmworkordernotify.php'),(20807616,10740,'./pmworkordernotify.php'),(20807615,2702,'./pmworkordernotify.php'),(20807614,10375,'./pmworkordernotify.php'),(20807613,315,'./pmworkordernotify.php'),(20807612,10372,'./pmworkordernotify.php'),(20807611,11003,'./pmworkorderadd.php'),(20807610,10901,'./pmworkorderadd.php'),(20807609,10900,'./pmworkorderadd.php'),(20807608,3381,'./pmworkorderadd.php'),(20807607,10899,'./pmworkorderadd.php'),(20807606,10898,'./pmworkorderadd.php'),(20807605,10897,'./pmworkorderadd.php'),(20807604,6425,'./pmworkorderadd.php'),(20807603,11411,'./pmworkorderadd.php'),(20807602,10945,'./pmworkorderadd.php'),(20807601,10896,'./pmworkorderadd.php'),(20807600,10895,'./pmworkorderadd.php'),(20807599,10894,'./pmworkorderadd.php'),(20807598,10893,'./pmworkorderadd.php'),(20807597,10892,'./pmworkorderadd.php'),(20807596,10891,'./pmworkorderadd.php'),(20807595,10890,'./pmworkorderadd.php'),(20807594,5588,'./pmworkorderadd.php'),(20807593,3274,'./pmworkorderadd.php'),(20807592,3252,'./pmworkorderadd.php'),(20807591,10888,'./pmworkorderadd.php'),(20807590,3450,'./pmworkorderadd.php'),(20807589,3165,'./pmworkorderadd.php'),(20807588,10739,'./pmworkorderadd.php'),(20807587,3156,'./pmworkorderadd.php'),(20807586,10944,'./pmworkorderadd.php'),(20807585,3111,'./pmworkorderadd.php'),(20807584,3097,'./pmworkorderadd.php'),(20807583,11282,'./pmworkorderadd.php'),(20807582,3090,'./pmworkorderadd.php'),(20807581,11002,'./pmworkorderadd.php'),(20807580,14340,'./pmworkorderadd.php'),(20807579,14339,'./pmworkorderadd.php'),(20807578,10887,'./pmworkorderadd.php'),(20807577,14338,'./pmworkorderadd.php'),(20807576,14337,'./pmworkorderadd.php'),(20807575,10886,'./pmworkorderadd.php'),(20807574,10885,'./pmworkorderadd.php'),(20807573,9750,'./pmworkorderadd.php'),(20807572,10884,'./pmworkorderadd.php'),(20807571,2948,'./pmworkorderadd.php'),(20807570,3434,'./pmworkorderadd.php'),(20807569,10943,'./pmworkorderadd.php'),(20807568,10883,'./pmworkorderadd.php'),(20807567,10814,'./pmworkorderadd.php'),(20807566,5492,'./pmworkorderadd.php'),(20807565,11046,'./pmworkorderadd.php'),(20807564,2710,'./pmworkorderadd.php'),(20807563,2702,'./pmworkorderadd.php'),(20807562,10882,'./pmworkorderadd.php'),(20807561,2565,'./pmworkorderadd.php'),(20807560,2508,'./pmworkorderadd.php'),(20807559,9835,'./pmworkorderadd.php'),(20807558,11479,'./pmworkorderadd.php'),(20807557,10917,'./pmworkorderadd.php'),(20807556,2488,'./pmworkorderadd.php'),(20807555,2464,'./pmworkorderadd.php'),(20807554,2404,'./pmworkorderadd.php'),(20807553,11001,'./pmworkorderadd.php'),(20807552,11000,'./pmworkorderadd.php'),(20807551,2361,'./pmworkorderadd.php'),(20807550,10879,'./pmworkorderadd.php'),(20807549,11481,'./pmworkorderadd.php'),(20807548,10878,'./pmworkorderadd.php'),(20807547,10877,'./pmworkorderadd.php'),(20807546,2324,'./pmworkorderadd.php'),(20807545,2292,'./pmworkorderadd.php'),(20807544,8313,'./pmworkorderadd.php'),(20807543,2109,'./pmworkorderadd.php'),(20807542,10876,'./pmworkorderadd.php'),(20807541,9742,'./pmworkorderadd.php'),(20807540,10875,'./pmworkorderadd.php'),(20807539,2070,'./pmworkorderadd.php'),(20807538,1963,'./pmworkorderadd.php'),(20807537,10874,'./pmworkorderadd.php'),(20807536,10873,'./pmworkorderadd.php'),(20807535,10999,'./pmworkorderadd.php'),(20807534,9908,'./pmworkorderadd.php'),(20807533,10872,'./pmworkorderadd.php'),(20807532,10942,'./pmworkorderadd.php'),(20807531,10941,'./pmworkorderadd.php'),(20807530,10912,'./pmworkorderadd.php'),(20807529,1797,'./pmworkorderadd.php'),(20807528,1788,'./pmworkorderadd.php'),(20807527,1743,'./pmworkorderadd.php'),(20807526,10871,'./pmworkorderadd.php'),(20807525,10870,'./pmworkorderadd.php'),(20807524,1564,'./pmworkorderadd.php'),(20807523,1555,'./pmworkorderadd.php'),(20807522,10940,'./pmworkorderadd.php'),(20807521,1476,'./pmworkorderadd.php'),(20807520,10939,'./pmworkorderadd.php'),(20807519,10295,'./pmworkorderadd.php'),(20807518,8936,'./pmworkorderadd.php'),(20807517,10868,'./pmworkorderadd.php'),(20807516,10541,'./pmworkorderadd.php'),(20807515,1036,'./pmworkorderadd.php'),(20807514,10938,'./pmworkorderadd.php'),(20807513,10867,'./pmworkorderadd.php'),(20807512,1014,'./pmworkorderadd.php'),(20807511,10937,'./pmworkorderadd.php'),(20807510,989,'./pmworkorderadd.php'),(20807509,981,'./pmworkorderadd.php'),(20807508,6923,'./pmworkorderadd.php'),(20807507,941,'./pmworkorderadd.php'),(20807506,4602,'./pmworkorderadd.php'),(20807505,869,'./pmworkorderadd.php'),(20807504,10866,'./pmworkorderadd.php'),(20807503,7105,'./pmworkorderadd.php'),(20807502,11497,'./pmworkorderadd.php'),(20807501,799,'./pmworkorderadd.php'),(20807500,11281,'./pmworkorderadd.php'),(20807499,4716,'./pmworkorderadd.php'),(20807498,4416,'./pmworkorderadd.php'),(20807497,737,'./pmworkorderadd.php'),(20807496,10936,'./pmworkorderadd.php'),(20807495,10865,'./pmworkorderadd.php'),(20807494,10864,'./pmworkorderadd.php'),(20807493,616,'./pmworkorderadd.php'),(20807492,596,'./pmworkorderadd.php'),(20807491,542,'./pmworkorderadd.php'),(20807490,5583,'./pmworkorderadd.php'),(20807489,10863,'./pmworkorderadd.php'),(20807488,10935,'./pmworkorderadd.php'),(20807487,10862,'./pmworkorderadd.php'),(20807486,315,'./pmworkorderadd.php'),(20807485,10909,'./pmworkorderadd.php'),(20807484,10861,'./pmworkorderadd.php'),(20807483,10860,'./pmworkorderadd.php'),(20807482,5203,'./pmworkorderadd.php'),(20807481,5095,'./pmworkorderadd.php'),(20807480,10998,'./pmworkorderadd.php'),(20807479,7025,'./pmworkorderadd.php'),(20807478,10934,'./pmworkorderadd.php'),(20807477,59,'./pmworkorderadd.php'),(20807476,55,'./pmworkorderadd.php'),(20807475,3421,'./pmutilityinvoicingreport.php'),(20807474,14336,'./pmutilityinvoicingreport.php'),(20807473,3165,'./pmutilityinvoicingreport.php'),(20807472,3111,'./pmutilityinvoicingreport.php'),(20807471,3090,'./pmutilityinvoicingreport.php'),(20807470,9750,'./pmutilityinvoicingreport.php'),(20807469,2738,'./pmutilityinvoicingreport.php'),(20807468,11479,'./pmutilityinvoicingreport.php'),(20807467,2292,'./pmutilityinvoicingreport.php'),(20807466,2225,'./pmutilityinvoicingreport.php'),(20807465,9789,'./pmutilityinvoicingreport.php'),(20807464,11478,'./pmutilityinvoicingreport.php'),(20807463,1973,'./pmutilityinvoicingreport.php'),(20807462,1678,'./pmutilityinvoicingreport.php'),(20807461,1014,'./pmutilityinvoicingreport.php'),(20807460,869,'./pmutilityinvoicingreport.php'),(20807459,737,'./pmutilityinvoicingreport.php'),(20807458,573,'./pmutilityinvoicingreport.php'),(20807457,333,'./pmutilityinvoicingreport.php'),(20807456,3421,'./pmunitadd.php'),(20807455,5310,'./pmunitadd.php'),(20807454,5309,'./pmunitadd.php'),(20807453,11397,'./pmunitadd.php'),(20807452,11396,'./pmunitadd.php'),(20807451,3275,'./pmunitadd.php'),(20807450,9596,'./pmunitadd.php'),(20807449,9595,'./pmunitadd.php'),(20807448,9594,'./pmunitadd.php'),(20807447,9593,'./pmunitadd.php'),(20807446,9592,'./pmunitadd.php'),(20807445,9591,'./pmunitadd.php'),(20807444,9590,'./pmunitadd.php'),(20807443,9589,'./pmunitadd.php'),(20807442,9588,'./pmunitadd.php'),(20807441,3165,'./pmunitadd.php'),(20807440,10739,'./pmunitadd.php'),(20807439,9587,'./pmunitadd.php'),(20807438,11395,'./pmunitadd.php'),(20807437,11045,'./pmunitadd.php'),(20807436,9586,'./pmunitadd.php'),(20807435,9585,'./pmunitadd.php'),(20807434,9584,'./pmunitadd.php'),(20807433,2710,'./pmunitadd.php'),(20807432,2702,'./pmunitadd.php'),(20807431,9583,'./pmunitadd.php'),(20807430,9582,'./pmunitadd.php'),(20807429,11394,'./pmunitadd.php'),(20807428,11479,'./pmunitadd.php'),(20807427,9581,'./pmunitadd.php'),(20807426,11481,'./pmunitadd.php'),(20807425,9551,'./pmunitadd.php'),(20807424,1973,'./pmunitadd.php'),(20807423,1935,'./pmunitadd.php'),(20807422,5304,'./pmunitadd.php'),(20807421,1480,'./pmunitadd.php'),(20807420,11393,'./pmunitadd.php'),(20807419,11392,'./pmunitadd.php'),(20807418,941,'./pmunitadd.php'),(20807417,11391,'./pmunitadd.php'),(20807416,11390,'./pmunitadd.php'),(20807415,11389,'./pmunitadd.php'),(20807414,11388,'./pmunitadd.php'),(20807413,869,'./pmunitadd.php'),(20807412,11387,'./pmunitadd.php'),(20807411,11497,'./pmunitadd.php'),(20807410,799,'./pmunitadd.php'),(20807409,542,'./pmunitadd.php'),(20807408,11386,'./pmunitadd.php'),(20807407,11385,'./pmunitadd.php'),(20807406,11384,'./pmunitadd.php'),(20807405,315,'./pmunitadd.php'),(20807404,5203,'./pmunitadd.php'),(20807403,11383,'./pmunitadd.php'),(20807402,59,'./pmunitadd.php'),(20807401,9580,'./pmunitadd.php'),(20807400,3252,'./pmterminatedleasesreport.php'),(20807399,3165,'./pmterminatedleasesreport.php'),(20807398,11279,'./pmterminatedleasesreport.php'),(20807397,10887,'./pmterminatedleasesreport.php'),(20807396,11180,'./pmterminatedleasesreport.php'),(20807395,9750,'./pmterminatedleasesreport.php'),(20807394,2948,'./pmterminatedleasesreport.php'),(20807393,2738,'./pmterminatedleasesreport.php'),(20807392,11131,'./pmterminatedleasesreport.php'),(20807391,11278,'./pmterminatedleasesreport.php'),(20807390,11277,'./pmterminatedleasesreport.php'),(20807389,11479,'./pmterminatedleasesreport.php'),(20807388,9789,'./pmterminatedleasesreport.php'),(20807387,11478,'./pmterminatedleasesreport.php'),(20807386,1014,'./pmterminatedleasesreport.php'),(20807385,737,'./pmterminatedleasesreport.php'),(20807384,573,'./pmterminatedleasesreport.php'),(20807383,333,'./pmterminatedleasesreport.php'),(20807382,197,'./pmterminatedleasesreport.php'),(20807381,6425,'./pmtenantperformancereport.php'),(20807380,10746,'./pmtenantperformancereport.php'),(20807379,3450,'./pmtenantperformancereport.php'),(20807378,3165,'./pmtenantperformancereport.php'),(20807377,11276,'./pmtenantperformancereport.php'),(20807376,10887,'./pmtenantperformancereport.php'),(20807375,11275,'./pmtenantperformancereport.php'),(20807374,9750,'./pmtenantperformancereport.php'),(20807373,10884,'./pmtenantperformancereport.php'),(20807372,2948,'./pmtenantperformancereport.php'),(20807371,3434,'./pmtenantperformancereport.php'),(20807370,4457,'./pmtenantperformancereport.php'),(20807369,2738,'./pmtenantperformancereport.php'),(20807368,10882,'./pmtenantperformancereport.php'),(20807367,11190,'./pmtenantperformancereport.php'),(20807366,11274,'./pmtenantperformancereport.php'),(20807365,11479,'./pmtenantperformancereport.php'),(20807364,2315,'./pmtenantperformancereport.php'),(20807363,2292,'./pmtenantperformancereport.php'),(20807362,2225,'./pmtenantperformancereport.php'),(20807361,11013,'./pmtenantperformancereport.php'),(20807360,6839,'./pmtenantperformancereport.php'),(20807359,10711,'./pmtenantperformancereport.php'),(20807358,10709,'./pmtenantperformancereport.php'),(20807357,9789,'./pmtenantperformancereport.php'),(20807356,1788,'./pmtenantperformancereport.php'),(20807355,9646,'./pmtenantperformancereport.php'),(20807354,1678,'./pmtenantperformancereport.php'),(20807353,4940,'./pmtenantperformancereport.php'),(20807352,10939,'./pmtenantperformancereport.php'),(20807351,1036,'./pmtenantperformancereport.php'),(20807350,1014,'./pmtenantperformancereport.php'),(20807349,11273,'./pmtenantperformancereport.php'),(20807348,1013,'./pmtenantperformancereport.php'),(20807347,932,'./pmtenantperformancereport.php'),(20807346,869,'./pmtenantperformancereport.php'),(20807345,7105,'./pmtenantperformancereport.php'),(20807344,596,'./pmtenantperformancereport.php'),(20807343,14308,'./pmtenantperformancereport.php'),(20807342,325,'./pmtenantperformancereport.php'),(20807341,226,'./pmtenantperformancereport.php'),(20807340,55,'./pmtenantperformancereport.php'),(20807339,10558,'./pmtenantdetailsreport.php'),(20807338,14335,'./pmtenantdetailsreport.php'),(20807337,14334,'./pmtenantdetailsreport.php'),(20807336,14333,'./pmtenantdetailsreport.php'),(20807335,11550,'./pmtenantdetailsreport.php'),(20807334,2788,'./pmtenantdetailsreport.php'),(20807333,11535,'./pmtenantdetailsreport.php'),(20807332,2738,'./pmtenantdetailsreport.php'),(20807331,11479,'./pmtenantdetailsreport.php'),(20807330,9761,'./pmtenantdetailsreport.php'),(20807329,2324,'./pmtenantdetailsreport.php'),(20807328,14332,'./pmtenantdetailsreport.php'),(20807327,14331,'./pmtenantdetailsreport.php'),(20807326,14330,'./pmtenantdetailsreport.php'),(20807325,11768,'./pmtenantdetailsreport.php'),(20807324,9789,'./pmtenantdetailsreport.php'),(20807323,11478,'./pmtenantdetailsreport.php'),(20807322,8544,'./pmtenantdetailsreport.php'),(20807321,1758,'./pmtenantdetailsreport.php'),(20807320,1429,'./pmtenantdetailsreport.php'),(20807319,11243,'./pmtenantdetailsreport.php'),(20807318,8936,'./pmtenantdetailsreport.php'),(20807317,982,'./pmtenantdetailsreport.php'),(20807316,14329,'./pmtenantdetailsreport.php'),(20807315,14328,'./pmtenantdetailsreport.php'),(20807314,14327,'./pmtenantdetailsreport.php'),(20807313,11767,'./pmtenantdetailsreport.php'),(20807312,573,'./pmtenantdetailsreport.php'),(20807311,14326,'./pmtenantdetailsreport.php'),(20807310,3165,'./pmstudentclassreport.php'),(20807309,9750,'./pmstudentclassreport.php'),(20807308,11272,'./pmstudentclassreport.php'),(20807307,2738,'./pmstudentclassreport.php'),(20807306,11479,'./pmstudentclassreport.php'),(20807305,9789,'./pmstudentclassreport.php'),(20807304,11478,'./pmstudentclassreport.php'),(20807303,10960,'./pmstudentclassreport.php'),(20807302,11271,'./pmstudentclassreport.php'),(20807301,573,'./pmstudentclassreport.php'),(20807300,6829,'./pmstudentclassreport.php'),(20807299,11270,'./pmstudentclassreport.php'),(20807298,3165,'./pmsignedleasesreport.php'),(20807297,11269,'./pmsignedleasesreport.php'),(20807296,9750,'./pmsignedleasesreport.php'),(20807295,4457,'./pmsignedleasesreport.php'),(20807294,11268,'./pmsignedleasesreport.php'),(20807293,11267,'./pmsignedleasesreport.php'),(20807292,2738,'./pmsignedleasesreport.php'),(20807291,11266,'./pmsignedleasesreport.php'),(20807290,11265,'./pmsignedleasesreport.php'),(20807289,11479,'./pmsignedleasesreport.php'),(20807288,11264,'./pmsignedleasesreport.php'),(20807287,11263,'./pmsignedleasesreport.php'),(20807286,11262,'./pmsignedleasesreport.php'),(20807285,11261,'./pmsignedleasesreport.php'),(20807284,11260,'./pmsignedleasesreport.php'),(20807283,11259,'./pmsignedleasesreport.php'),(20807282,9789,'./pmsignedleasesreport.php'),(20807281,11478,'./pmsignedleasesreport.php'),(20807280,11258,'./pmsignedleasesreport.php'),(20807279,8936,'./pmsignedleasesreport.php'),(20807278,1013,'./pmsignedleasesreport.php'),(20807277,737,'./pmsignedleasesreport.php'),(20807276,573,'./pmsignedleasesreport.php'),(20807275,542,'./pmsignedleasesreport.php'),(20807274,11257,'./pmsignedleasesreport.php'),(20807273,3421,'./pmsignedleases.php'),(20807272,3165,'./pmsignedleases.php'),(20807271,4974,'./pmsignedleases.php'),(20807270,6016,'./pmsignedleases.php'),(20807269,9750,'./pmsignedleases.php'),(20807268,14325,'./pmsignedleases.php'),(20807267,14324,'./pmsignedleases.php'),(20807266,14323,'./pmsignedleases.php'),(20807265,2738,'./pmsignedleases.php'),(20807264,11248,'./pmsignedleases.php'),(20807263,11479,'./pmsignedleases.php'),(20807262,9877,'./pmsignedleases.php'),(20807261,9789,'./pmsignedleases.php'),(20807260,11478,'./pmsignedleases.php'),(20807259,1973,'./pmsignedleases.php'),(20807258,11235,'./pmsignedleases.php'),(20807257,1467,'./pmsignedleases.php'),(20807256,8936,'./pmsignedleases.php'),(20807255,14322,'./pmsignedleases.php'),(20807254,14321,'./pmsignedleases.php'),(20807253,573,'./pmsignedleases.php'),(20807252,14320,'./pmsignedleases.php'),(20807251,14319,'./pmsignedleases.php'),(20807250,14302,'./pmsignedleases.php'),(20807249,3421,'./pmsecuritydepositreport.php'),(20807248,3165,'./pmsecuritydepositreport.php'),(20807247,3118,'./pmsecuritydepositreport.php'),(20807246,9750,'./pmsecuritydepositreport.php'),(20807245,2738,'./pmsecuritydepositreport.php'),(20807244,8066,'./pmsecuritydepositreport.php'),(20807243,11479,'./pmsecuritydepositreport.php'),(20807242,9789,'./pmsecuritydepositreport.php'),(20807241,11478,'./pmsecuritydepositreport.php'),(20807240,1973,'./pmsecuritydepositreport.php'),(20807239,10960,'./pmsecuritydepositreport.php'),(20807238,14318,'./pmsecuritydepositreport.php'),(20807237,14317,'./pmsecuritydepositreport.php'),(20807236,14316,'./pmsecuritydepositreport.php'),(20807235,14315,'./pmsecuritydepositreport.php'),(20807234,1014,'./pmsecuritydepositreport.php'),(20807233,573,'./pmsecuritydepositreport.php'),(20807232,14314,'./pmsecuritydepositreport.php'),(20807231,14313,'./pmsecuritydepositreport.php'),(20807230,14312,'./pmsecuritydepositreport.php'),(20807229,14311,'./pmsecuritydepositreport.php'),(20807228,14310,'./pmsecuritydepositreport.php'),(20807227,14309,'./pmsecuritydepositreport.php'),(20807226,14308,'./pmsecuritydepositreport.php'),(20807225,333,'./pmsecuritydepositreport.php'),(20807224,10859,'./pmrevenuerec.php'),(20807223,10858,'./pmrevenuerec.php'),(20807222,10857,'./pmrevenuerec.php'),(20807221,2702,'./pmrevenuerec.php'),(20807220,10856,'./pmrevenuerec.php'),(20807219,10855,'./pmrevenuerec.php'),(20807218,10854,'./pmrevenuerec.php'),(20807217,10853,'./pmrevenuerec.php'),(20807216,8936,'./pmrevenuerec.php'),(20807215,10852,'./pmrevenuerec.php'),(20807214,14307,'./pmrentrollreport.php'),(20807213,3165,'./pmrentrollreport.php'),(20807212,3090,'./pmrentrollreport.php'),(20807211,6016,'./pmrentrollreport.php'),(20807210,9750,'./pmrentrollreport.php'),(20807209,14115,'./pmrentrollreport.php'),(20807208,2738,'./pmrentrollreport.php'),(20807207,11248,'./pmrentrollreport.php'),(20807206,11130,'./pmrentrollreport.php'),(20807205,11247,'./pmrentrollreport.php'),(20807204,11246,'./pmrentrollreport.php'),(20807203,11190,'./pmrentrollreport.php'),(20807202,11479,'./pmrentrollreport.php'),(20807201,9877,'./pmrentrollreport.php'),(20807200,11759,'./pmrentrollreport.php'),(20807199,9789,'./pmrentrollreport.php'),(20807198,11478,'./pmrentrollreport.php'),(20807197,1973,'./pmrentrollreport.php'),(20807196,9918,'./pmrentrollreport.php'),(20807195,14306,'./pmrentrollreport.php'),(20807194,4169,'./pmrentrollreport.php'),(20807193,14305,'./pmrentrollreport.php'),(20807192,14304,'./pmrentrollreport.php'),(20807191,14303,'./pmrentrollreport.php'),(20807190,4106,'./pmrentrollreport.php'),(20807189,1467,'./pmrentrollreport.php'),(20807188,10384,'./pmrentrollreport.php'),(20807187,8936,'./pmrentrollreport.php'),(20807186,931,'./pmrentrollreport.php'),(20807185,573,'./pmrentrollreport.php'),(20807184,14302,'./pmrentrollreport.php'),(20807183,185,'./pmrentrollreport.php'),(20807182,2710,'./pmrealestatetaxtypeadd.php'),(20807181,2702,'./pmrealestatetaxtypeadd.php'),(20807180,10851,'./pmrealestatetaxtypeadd.php'),(20807179,10850,'./pmrealestatetaxtypeadd.php'),(20807178,10849,'./pmrealestatetaxtypeadd.php'),(20807177,10848,'./pmrealestatetaxtypeadd.php'),(20807176,10847,'./pmrealestatetaxtypeadd.php'),(20807175,10846,'./pmrealestatetaxtypeadd.php'),(20807174,10845,'./pmrealestatetaxtypeadd.php'),(20807173,10844,'./pmrealestatetaxtypeadd.php'),(20807172,10843,'./pmrealestatetaxtypeadd.php'),(20807171,10842,'./pmrealestatetaxtypeadd.php'),(20807170,10841,'./pmrealestatetaxtypeadd.php'),(20807169,9551,'./pmrealestatetaxtypeadd.php'),(20807168,1935,'./pmrealestatetaxtypeadd.php'),(20807167,941,'./pmrealestatetaxtypeadd.php'),(20807166,799,'./pmrealestatetaxtypeadd.php'),(20807165,542,'./pmrealestatetaxtypeadd.php'),(20807164,315,'./pmrealestatetaxtypeadd.php'),(20807163,5203,'./pmrealestatetaxtypeadd.php'),(20807162,59,'./pmrealestatetaxtypeadd.php'),(20686791,3421,'./pmrealestatetaxrpt.php'),(20686790,10933,'./pmrealestatetaxrpt.php'),(20686789,3024,'./pmrealestatetaxrpt.php'),(20686788,7236,'./pmrealestatetaxrpt.php'),(20686787,2998,'./pmrealestatetaxrpt.php'),(20686786,10932,'./pmrealestatetaxrpt.php'),(20686785,10931,'./pmrealestatetaxrpt.php'),(20686784,2710,'./pmrealestatetaxrpt.php'),(20686783,2702,'./pmrealestatetaxrpt.php'),(20686782,11549,'./pmrealestatetaxrpt.php'),(20686781,11548,'./pmrealestatetaxrpt.php'),(20686780,11538,'./pmrealestatetaxrpt.php'),(20686779,11537,'./pmrealestatetaxrpt.php'),(20686778,11547,'./pmrealestatetaxrpt.php'),(20686777,11479,'./pmrealestatetaxrpt.php'),(20686776,2292,'./pmrealestatetaxrpt.php'),(20686775,1973,'./pmrealestatetaxrpt.php'),(20686774,1963,'./pmrealestatetaxrpt.php'),(20686773,932,'./pmrealestatetaxrpt.php'),(20686772,10997,'./pmrealestatetaxrpt.php'),(20686771,542,'./pmrealestatetaxrpt.php'),(20686770,479,'./pmrealestatetaxrpt.php'),(20686769,10928,'./pmrealestatetaxrpt.php'),(20686768,315,'./pmrealestatetaxrpt.php'),(20686767,226,'./pmrealestatetaxrpt.php'),(20686766,197,'./pmrealestatetaxrpt.php'),(20807161,3024,'./pmrealestatetaxadd.php'),(20807160,10840,'./pmrealestatetaxadd.php'),(20807159,7236,'./pmrealestatetaxadd.php'),(20807158,2948,'./pmrealestatetaxadd.php'),(20807157,2710,'./pmrealestatetaxadd.php'),(20807156,2702,'./pmrealestatetaxadd.php'),(20807155,11245,'./pmrealestatetaxadd.php'),(20807154,11546,'./pmrealestatetaxadd.php'),(20807153,11545,'./pmrealestatetaxadd.php'),(20807152,11544,'./pmrealestatetaxadd.php'),(20807151,11543,'./pmrealestatetaxadd.php'),(20807150,11542,'./pmrealestatetaxadd.php'),(20807149,11541,'./pmrealestatetaxadd.php'),(20807148,11538,'./pmrealestatetaxadd.php'),(20807147,11537,'./pmrealestatetaxadd.php'),(20807146,11540,'./pmrealestatetaxadd.php'),(20807145,11539,'./pmrealestatetaxadd.php'),(20807144,11479,'./pmrealestatetaxadd.php'),(20807143,10393,'./pmrealestatetaxadd.php'),(20807142,10838,'./pmrealestatetaxadd.php'),(20807141,11481,'./pmrealestatetaxadd.php'),(20807140,10837,'./pmrealestatetaxadd.php'),(20807139,10834,'./pmrealestatetaxadd.php'),(20807138,1598,'./pmrealestatetaxadd.php'),(20807137,1578,'./pmrealestatetaxadd.php'),(20807136,10831,'./pmrealestatetaxadd.php'),(20807135,11244,'./pmrealestatetaxadd.php'),(20807134,1506,'./pmrealestatetaxadd.php'),(20807133,941,'./pmrealestatetaxadd.php'),(20807132,799,'./pmrealestatetaxadd.php'),(20807131,7815,'./pmrealestatetaxadd.php'),(20807130,542,'./pmrealestatetaxadd.php'),(20807129,315,'./pmrealestatetaxadd.php'),(20807128,10821,'./pmrealestatetaxadd.php'),(20807127,10820,'./pmrealestatetaxadd.php'),(20807126,5203,'./pmrealestatetaxadd.php'),(20807125,232,'./pmrealestatetaxadd.php'),(20807124,59,'./pmrealestatetaxadd.php'),(20807123,55,'./pmrealestatetaxadd.php'),(20807122,30,'./pmrealestatetaxadd.php'),(20727417,3421,'./pmrealestatetax_create.php'),(20727416,10996,'./pmrealestatetax_create.php'),(20727415,2998,'./pmrealestatetax_create.php'),(20727414,2702,'./pmrealestatetax_create.php'),(20727413,11538,'./pmrealestatetax_create.php'),(20727412,11537,'./pmrealestatetax_create.php'),(20727411,11479,'./pmrealestatetax_create.php'),(20727410,2140,'./pmrealestatetax_create.php'),(20727409,1759,'./pmrealestatetax_create.php'),(20727408,939,'./pmrealestatetax_create.php'),(20727407,932,'./pmrealestatetax_create.php'),(20727406,869,'./pmrealestatetax_create.php'),(20727405,542,'./pmrealestatetax_create.php'),(20727404,10929,'./pmrealestatetax_create.php'),(20727403,226,'./pmrealestatetax_create.php'),(20807121,3432,'./pmpropertydetailsreport.php'),(20807120,11035,'./pmpropertydetailsreport.php'),(20807119,9553,'./pmpropertydetailsreport.php'),(20807118,10925,'./pmpropertydetailsreport.php'),(20807117,2936,'./pmpropertydetailsreport.php'),(20807116,11535,'./pmpropertydetailsreport.php'),(20807115,2738,'./pmpropertydetailsreport.php'),(20807114,11511,'./pmpropertydetailsreport.php'),(20807113,10567,'./pmpropertydetailsreport.php'),(20807112,11479,'./pmpropertydetailsreport.php'),(20807111,9761,'./pmpropertydetailsreport.php'),(20807110,2324,'./pmpropertydetailsreport.php'),(20807109,9789,'./pmpropertydetailsreport.php'),(20807108,14285,'./pmpropertydetailsreport.php'),(20807107,9547,'./pmpropertydetailsreport.php'),(20807106,10923,'./pmpropertydetailsreport.php'),(20807105,11034,'./pmpropertydetailsreport.php'),(20807104,11243,'./pmpropertydetailsreport.php'),(20807103,982,'./pmpropertydetailsreport.php'),(20807102,11033,'./pmpropertydetailsreport.php'),(20807101,869,'./pmpropertydetailsreport.php'),(20807100,573,'./pmpropertydetailsreport.php'),(20807099,524,'./pmpropertydetailsreport.php'),(20807098,185,'./pmpropertydetailsreport.php'),(20807097,10738,'./pmonsitesetup.php'),(20807096,2710,'./pmonsitesetup.php'),(20807095,2702,'./pmonsitesetup.php'),(20807094,10737,'./pmonsitesetup.php'),(20807093,10736,'./pmonsitesetup.php'),(20807092,10735,'./pmonsitesetup.php'),(20807091,10734,'./pmonsitesetup.php'),(20807090,10733,'./pmonsitesetup.php'),(20807089,10732,'./pmonsitesetup.php'),(20807088,10731,'./pmonsitesetup.php'),(20807087,10730,'./pmonsitesetup.php'),(20807086,10729,'./pmonsitesetup.php'),(20807085,10728,'./pmonsitesetup.php'),(20807084,10727,'./pmonsitesetup.php'),(20807083,10726,'./pmonsitesetup.php'),(20807082,10725,'./pmonsitesetup.php'),(20807081,10724,'./pmonsitesetup.php'),(20807080,10723,'./pmonsitesetup.php'),(20807079,10722,'./pmonsitesetup.php'),(20807078,10721,'./pmonsitesetup.php'),(20807077,10720,'./pmonsitesetup.php'),(20807076,10719,'./pmonsitesetup.php'),(20807075,941,'./pmonsitesetup.php'),(20807074,11497,'./pmonsitesetup.php'),(20807073,799,'./pmonsitesetup.php'),(20807072,10718,'./pmonsitesetup.php'),(20807071,542,'./pmonsitesetup.php'),(20807070,315,'./pmonsitesetup.php'),(20807069,5203,'./pmonsitesetup.php'),(20807068,59,'./pmonsitesetup.php'),(20807067,11242,'./pmmoveinsmoveoutsreport.php'),(20807066,3165,'./pmmoveinsmoveoutsreport.php'),(20807065,6016,'./pmmoveinsmoveoutsreport.php'),(20807064,9750,'./pmmoveinsmoveoutsreport.php'),(20807063,2738,'./pmmoveinsmoveoutsreport.php'),(20807062,11479,'./pmmoveinsmoveoutsreport.php'),(20807061,9877,'./pmmoveinsmoveoutsreport.php'),(20807060,9789,'./pmmoveinsmoveoutsreport.php'),(20807059,11478,'./pmmoveinsmoveoutsreport.php'),(20807058,1467,'./pmmoveinsmoveoutsreport.php'),(20807057,4973,'./pmmoveinsmoveoutsreport.php'),(20807056,737,'./pmmoveinsmoveoutsreport.php'),(20807055,573,'./pmmoveinsmoveoutsreport.php'),(20807054,47,'./pmmoveinsmoveoutsreport.php'),(20807053,8216,'./pmleasingrecapreport.php'),(20807052,3090,'./pmleasingrecapreport.php'),(20807051,2738,'./pmleasingrecapreport.php'),(20807050,2508,'./pmleasingrecapreport.php'),(20807049,11479,'./pmleasingrecapreport.php'),(20807048,2404,'./pmleasingrecapreport.php'),(20807047,9853,'./pmleasingrecapreport.php'),(20807046,9852,'./pmleasingrecapreport.php'),(20807045,2225,'./pmleasingrecapreport.php'),(20807044,11478,'./pmleasingrecapreport.php'),(20807043,11361,'./pmleasingrecapreport.php'),(20807042,1668,'./pmleasingrecapreport.php'),(20807041,4106,'./pmleasingrecapreport.php'),(20807040,8936,'./pmleasingrecapreport.php'),(20807039,1014,'./pmleasingrecapreport.php'),(20807038,869,'./pmleasingrecapreport.php'),(20807037,737,'./pmleasingrecapreport.php'),(20807036,697,'./pmleasingrecapreport.php'),(20807035,573,'./pmleasingrecapreport.php'),(20807034,542,'./pmleasingrecapreport.php'),(20807033,333,'./pmleasingrecapreport.php'),(20807032,11534,'./pmleasingrecapreport.php'),(20807031,3165,'./pmleaseexpirationsreport.php'),(20807030,9750,'./pmleaseexpirationsreport.php'),(20807029,2738,'./pmleaseexpirationsreport.php'),(20807028,11479,'./pmleaseexpirationsreport.php'),(20807027,9877,'./pmleaseexpirationsreport.php'),(20807026,9789,'./pmleaseexpirationsreport.php'),(20807025,11478,'./pmleaseexpirationsreport.php'),(20807024,11128,'./pmleaseexpirationsreport.php'),(20807023,10384,'./pmleaseexpirationsreport.php'),(20807022,573,'./pmleaseexpirationsreport.php'),(20807021,11241,'./pminvoicechargesreport.php'),(20807020,3090,'./pminvoicechargesreport.php'),(20807019,9750,'./pminvoicechargesreport.php'),(20807018,2738,'./pminvoicechargesreport.php'),(20807017,2508,'./pminvoicechargesreport.php'),(20807016,11479,'./pminvoicechargesreport.php'),(20807015,2404,'./pminvoicechargesreport.php'),(20807014,9853,'./pminvoicechargesreport.php'),(20807013,9852,'./pminvoicechargesreport.php'),(20807012,11240,'./pminvoicechargesreport.php'),(20807011,11239,'./pminvoicechargesreport.php'),(20807010,9789,'./pminvoicechargesreport.php'),(20807009,11478,'./pminvoicechargesreport.php'),(20807008,11238,'./pminvoicechargesreport.php'),(20807007,1668,'./pminvoicechargesreport.php'),(20807006,4106,'./pminvoicechargesreport.php'),(20807005,8936,'./pminvoicechargesreport.php'),(20807004,1014,'./pminvoicechargesreport.php'),(20807003,869,'./pminvoicechargesreport.php'),(20807002,737,'./pminvoicechargesreport.php'),(20807001,697,'./pminvoicechargesreport.php'),(20807000,573,'./pminvoicechargesreport.php'),(20806999,542,'./pminvoicechargesreport.php'),(20806998,333,'./pminvoicechargesreport.php'),(20806997,3156,'./pmguarantorinforeport.php'),(20806996,9750,'./pmguarantorinforeport.php'),(20806995,2738,'./pmguarantorinforeport.php'),(20806994,11190,'./pmguarantorinforeport.php'),(20806993,2109,'./pmguarantorinforeport.php'),(20806992,9789,'./pmguarantorinforeport.php'),(20806991,11237,'./pmguarantorinforeport.php'),(20806990,11236,'./pmguarantorinforeport.php'),(20806989,11235,'./pmguarantorinforeport.php'),(20806988,10238,'./pmguarantorinforeport.php'),(20806987,5588,'./pmequipmentsignoutreport.php'),(20806986,3252,'./pmequipmentsignoutreport.php'),(20806985,10814,'./pmequipmentsignoutreport.php'),(20806984,2738,'./pmequipmentsignoutreport.php'),(20806983,2103,'./pmequipmentsignoutreport.php'),(20806982,10819,'./pmequipmentsignoutreport.php'),(20806981,10541,'./pmequipmentsignoutreport.php'),(20806980,10818,'./pmequipmentsignoutreport.php'),(20806979,4716,'./pmequipmentsignoutreport.php'),(20806978,4416,'./pmequipmentsignoutreport.php'),(20806977,10817,'./pmequipmentsignoutreport.php'),(20806976,10816,'./pmequipmentsignoutreport.php'),(20806975,197,'./pmequipmentsignoutreport.php'),(20806974,6425,'./pmequipmentsignout.php'),(20806973,5588,'./pmequipmentsignout.php'),(20806972,10815,'./pmequipmentsignout.php'),(20806971,10814,'./pmequipmentsignout.php'),(20806970,2710,'./pmequipmentsignout.php'),(20806969,10813,'./pmequipmentsignout.php'),(20806968,2103,'./pmequipmentsignout.php'),(20806967,10812,'./pmequipmentsignout.php'),(20806966,10811,'./pmequipmentsignout.php'),(20806965,10810,'./pmequipmentsignout.php'),(20806964,10809,'./pmequipmentsignout.php'),(20806963,10808,'./pmequipmentsignout.php'),(20806962,10807,'./pmequipmentsignout.php'),(20806961,10806,'./pmequipmentsignout.php'),(20806960,10541,'./pmequipmentsignout.php'),(20806959,542,'./pmequipmentsignout.php'),(20806958,315,'./pmequipmentsignout.php'),(20806957,3421,'./pmequipmentinventoryreport.php'),(20806956,10801,'./pmequipmentinventoryreport.php'),(20806955,2738,'./pmequipmentinventoryreport.php'),(20806954,8650,'./pmequipmentinventoryreport.php'),(20806953,11479,'./pmequipmentinventoryreport.php'),(20806952,9789,'./pmequipmentinventoryreport.php'),(20806951,11478,'./pmequipmentinventoryreport.php'),(20806950,1973,'./pmequipmentinventoryreport.php'),(20806949,1935,'./pmequipmentinventoryreport.php'),(20806948,11234,'./pmequipmentinventoryreport.php'),(20806947,869,'./pmequipmentinventoryreport.php'),(20806946,573,'./pmequipmentinventoryreport.php'),(20806945,10805,'./pmequipmentadd.php'),(20806944,3275,'./pmequipmentadd.php'),(20806943,3274,'./pmequipmentadd.php'),(20806942,10804,'./pmequipmentadd.php'),(20806941,10803,'./pmequipmentadd.php'),(20806940,10802,'./pmequipmentadd.php'),(20806939,10801,'./pmequipmentadd.php'),(20806938,4267,'./pmequipmentadd.php'),(20806937,2710,'./pmequipmentadd.php'),(20806936,2702,'./pmequipmentadd.php'),(20806935,8650,'./pmequipmentadd.php'),(20806934,11479,'./pmequipmentadd.php'),(20806933,2363,'./pmequipmentadd.php'),(20806932,11481,'./pmequipmentadd.php'),(20806931,9551,'./pmequipmentadd.php'),(20806930,9568,'./pmequipmentadd.php'),(20806929,2136,'./pmequipmentadd.php'),(20806928,1935,'./pmequipmentadd.php'),(20806927,10550,'./pmequipmentadd.php'),(20806926,10549,'./pmequipmentadd.php'),(20806925,10548,'./pmequipmentadd.php'),(20806924,10547,'./pmequipmentadd.php'),(20806923,10546,'./pmequipmentadd.php'),(20806922,10545,'./pmequipmentadd.php'),(20806921,10544,'./pmequipmentadd.php'),(20806920,10543,'./pmequipmentadd.php'),(20806919,10542,'./pmequipmentadd.php'),(20806918,10541,'./pmequipmentadd.php'),(20806917,941,'./pmequipmentadd.php'),(20806916,869,'./pmequipmentadd.php'),(20806915,11497,'./pmequipmentadd.php'),(20806914,799,'./pmequipmentadd.php'),(20806913,616,'./pmequipmentadd.php'),(20806912,573,'./pmequipmentadd.php'),(20806911,542,'./pmequipmentadd.php'),(20806910,315,'./pmequipmentadd.php'),(20806909,5203,'./pmequipmentadd.php'),(20806908,59,'./pmequipmentadd.php'),(20806907,9750,'./pmcourtfilingsreport.php'),(20806906,2948,'./pmcourtfilingsreport.php'),(20806905,2738,'./pmcourtfilingsreport.php'),(20806904,11233,'./pmcourtfilingsreport.php'),(20806903,11232,'./pmcourtfilingsreport.php'),(20806902,2292,'./pmcourtfilingsreport.php'),(20806901,9789,'./pmcourtfilingsreport.php'),(20806900,11231,'./pmcourtfilingsreport.php'),(20806899,11230,'./pmcourtfilingsreport.php'),(20806898,1668,'./pmcourtfilingsreport.php'),(20806897,11229,'./pmcourtfilingsreport.php'),(20806896,7250,'./pmcourtfilingsreport.php'),(20806895,1014,'./pmcourtfilingsreport.php'),(20806894,11228,'./pmcourtfilingsreport.php'),(20806893,11227,'./pmcourtfilingsreport.php'),(20806892,573,'./pmcourtfilingsreport.php'),(20806891,333,'./pmcourtfilingsreport.php'),(20806890,11226,'./pmcourtfilingsreport.php'),(20806889,3252,'./pmcommissions.php'),(20806888,11044,'./pmcommissions.php'),(20806887,9750,'./pmcommissions.php'),(20806886,2948,'./pmcommissions.php'),(20806885,2738,'./pmcommissions.php'),(20806884,2225,'./pmcommissions.php'),(20806883,10876,'./pmcommissions.php'),(20806882,8936,'./pmcommissions.php'),(20806881,1014,'./pmcommissions.php'),(20806880,11042,'./pmcommissions.php'),(20806879,869,'./pmcommissions.php'),(20806878,799,'./pmcommissions.php'),(20806877,737,'./pmcommissions.php'),(20806876,11041,'./pmcommissions.php'),(20806875,11040,'./pmcommissions.php'),(20806874,569,'./pmcommissions.php'),(20806873,6851,'./pmcommissions.php'),(20806872,11039,'./pmcommissions.php'),(20806871,11037,'./pmcommissions.php'),(20806870,11036,'./pmcommissions.php'),(20806869,333,'./pmcommissions.php'),(20806868,8125,'./pmcommissions.php'),(20686456,14301,'./pmcctest.php'),(20686455,14300,'./pmcctest.php'),(20686454,14299,'./pmcctest.php'),(20686453,14298,'./pmcctest.php'),(20686452,14297,'./pmcctest.php'),(20686451,14279,'./pmcctest.php'),(20686450,11220,'./pmcctest.php'),(20686449,8361,'./pmcctest.php'),(20686448,1963,'./pmcctest.php'),(20686447,11148,'./pmcctest.php'),(20686446,14296,'./pmcctest.php'),(20686445,10384,'./pmcctest.php'),(20686444,8936,'./pmcctest.php'),(20686443,14295,'./pmcctest.php'),(20686442,14294,'./pmcctest.php'),(20686441,14293,'./pmcctest.php'),(20686440,14292,'./pmcctest.php'),(20806867,2710,'./pmbuildingtypeadd.php'),(20806866,2702,'./pmbuildingtypeadd.php'),(20806865,11533,'./pmbuildingtypeadd.php'),(20806864,11532,'./pmbuildingtypeadd.php'),(20806863,11531,'./pmbuildingtypeadd.php'),(20806862,11530,'./pmbuildingtypeadd.php'),(20806861,11529,'./pmbuildingtypeadd.php'),(20806860,11528,'./pmbuildingtypeadd.php'),(20806859,10851,'./pmbuildingtypeadd.php'),(20806858,11527,'./pmbuildingtypeadd.php'),(20806857,11526,'./pmbuildingtypeadd.php'),(20806856,11525,'./pmbuildingtypeadd.php'),(20806855,11511,'./pmbuildingtypeadd.php'),(20806854,9551,'./pmbuildingtypeadd.php'),(20806853,1935,'./pmbuildingtypeadd.php'),(20806852,941,'./pmbuildingtypeadd.php'),(20806851,11497,'./pmbuildingtypeadd.php'),(20806850,799,'./pmbuildingtypeadd.php'),(20806849,542,'./pmbuildingtypeadd.php'),(20806848,315,'./pmbuildingtypeadd.php'),(20806847,5203,'./pmbuildingtypeadd.php'),(20806846,59,'./pmbuildingtypeadd.php'),(20686417,3275,'./pmbuildingownershipadd.php'),(20686416,2710,'./pmbuildingownershipadd.php'),(20686415,2702,'./pmbuildingownershipadd.php'),(20686414,11524,'./pmbuildingownershipadd.php'),(20686413,11523,'./pmbuildingownershipadd.php'),(20686412,11522,'./pmbuildingownershipadd.php'),(20686411,11521,'./pmbuildingownershipadd.php'),(20686410,11520,'./pmbuildingownershipadd.php'),(20686409,11519,'./pmbuildingownershipadd.php'),(20686408,11518,'./pmbuildingownershipadd.php'),(20686407,11517,'./pmbuildingownershipadd.php'),(20686406,11516,'./pmbuildingownershipadd.php'),(20686405,11515,'./pmbuildingownershipadd.php'),(20686404,11479,'./pmbuildingownershipadd.php'),(20686403,11481,'./pmbuildingownershipadd.php'),(20686402,9569,'./pmbuildingownershipadd.php'),(20686401,9568,'./pmbuildingownershipadd.php'),(20686400,9566,'./pmbuildingownershipadd.php'),(20686399,9565,'./pmbuildingownershipadd.php'),(20686398,1480,'./pmbuildingownershipadd.php'),(20686397,941,'./pmbuildingownershipadd.php'),(20686396,11497,'./pmbuildingownershipadd.php'),(20686395,799,'./pmbuildingownershipadd.php'),(20686394,9564,'./pmbuildingownershipadd.php'),(20686393,573,'./pmbuildingownershipadd.php'),(20686392,542,'./pmbuildingownershipadd.php'),(20686391,315,'./pmbuildingownershipadd.php'),(20686390,5203,'./pmbuildingownershipadd.php'),(20686389,59,'./pmbuildingownershipadd.php'),(20806845,11035,'./pmbuildingadd.php'),(20806844,3319,'./pmbuildingadd.php'),(20806843,3275,'./pmbuildingadd.php'),(20806842,9553,'./pmbuildingadd.php'),(20806841,9870,'./pmbuildingadd.php'),(20806840,10925,'./pmbuildingadd.php'),(20806839,14291,'./pmbuildingadd.php'),(20806838,14290,'./pmbuildingadd.php'),(20806837,14289,'./pmbuildingadd.php'),(20806836,2936,'./pmbuildingadd.php'),(20806835,2886,'./pmbuildingadd.php'),(20806834,11514,'./pmbuildingadd.php'),(20806833,2710,'./pmbuildingadd.php'),(20806832,2702,'./pmbuildingadd.php'),(20806831,11513,'./pmbuildingadd.php'),(20806830,11512,'./pmbuildingadd.php'),(20806829,11511,'./pmbuildingadd.php'),(20806828,11510,'./pmbuildingadd.php'),(20806827,11509,'./pmbuildingadd.php'),(20806826,11508,'./pmbuildingadd.php'),(20806825,11507,'./pmbuildingadd.php'),(20806824,11479,'./pmbuildingadd.php'),(20806823,11506,'./pmbuildingadd.php'),(20806822,11505,'./pmbuildingadd.php'),(20806821,11504,'./pmbuildingadd.php'),(20806820,2376,'./pmbuildingadd.php'),(20806819,9552,'./pmbuildingadd.php'),(20806818,11503,'./pmbuildingadd.php'),(20806817,9551,'./pmbuildingadd.php'),(20806816,14288,'./pmbuildingadd.php'),(20806815,14287,'./pmbuildingadd.php'),(20806814,9548,'./pmbuildingadd.php'),(20806813,2103,'./pmbuildingadd.php'),(20806812,1935,'./pmbuildingadd.php'),(20806811,14286,'./pmbuildingadd.php'),(20806810,14285,'./pmbuildingadd.php'),(20806809,9547,'./pmbuildingadd.php'),(20806808,14284,'./pmbuildingadd.php'),(20806807,11687,'./pmbuildingadd.php'),(20806806,11686,'./pmbuildingadd.php'),(20806805,11501,'./pmbuildingadd.php'),(20806804,9735,'./pmbuildingadd.php'),(20806803,9869,'./pmbuildingadd.php'),(20806802,10923,'./pmbuildingadd.php'),(20806801,14283,'./pmbuildingadd.php'),(20806800,14282,'./pmbuildingadd.php'),(20806799,1480,'./pmbuildingadd.php'),(20806798,11034,'./pmbuildingadd.php'),(20806797,11500,'./pmbuildingadd.php'),(20806796,11499,'./pmbuildingadd.php'),(20806795,6166,'./pmbuildingadd.php'),(20806794,1333,'./pmbuildingadd.php'),(20806793,10541,'./pmbuildingadd.php'),(20806792,11033,'./pmbuildingadd.php'),(20806791,941,'./pmbuildingadd.php'),(20806790,11758,'./pmbuildingadd.php'),(20806789,11498,'./pmbuildingadd.php'),(20806788,869,'./pmbuildingadd.php'),(20806787,11497,'./pmbuildingadd.php'),(20806786,9868,'./pmbuildingadd.php'),(20806785,799,'./pmbuildingadd.php'),(20806784,737,'./pmbuildingadd.php'),(20806783,9759,'./pmbuildingadd.php'),(20806782,573,'./pmbuildingadd.php'),(20806781,542,'./pmbuildingadd.php'),(20806780,524,'./pmbuildingadd.php'),(20806779,315,'./pmbuildingadd.php'),(20806778,5203,'./pmbuildingadd.php'),(20806777,9782,'./pmbuildingadd.php'),(20806776,9770,'./pmbuildingadd.php'),(20806775,14281,'./pmbuildingadd.php'),(20806774,14280,'./pmbuildingadd.php'),(20806773,197,'./pmbuildingadd.php'),(20806772,185,'./pmbuildingadd.php'),(20806771,59,'./pmbuildingadd.php'),(20686313,7130,'./pmautobillreport.php'),(20686312,2948,'./pmautobillreport.php'),(20686311,14279,'./pmautobillreport.php'),(20686310,11248,'./pmautobillreport.php'),(20686309,14278,'./pmautobillreport.php'),(20686308,4608,'./pmautobillreport.php'),(20686307,1963,'./pmautobillreport.php'),(20686306,1880,'./pmautobillreport.php'),(20686305,1668,'./pmautobillreport.php'),(20686304,7250,'./pmautobillreport.php'),(20686303,8936,'./pmautobillreport.php'),(20686302,932,'./pmautobillreport.php'),(20686301,697,'./pmautobillreport.php'),(20686300,12053,'./pmautobillreport.php'),(20686299,6307,'./pmautobillreport.php'),(20686298,573,'./pmautobillreport.php'),(20686297,14277,'./pmautobillreport.php'),(20686296,14276,'./pmautobillreport.php'),(20686295,14275,'./pmautobillreport.php'),(20686294,226,'./pmautobillreport.php'),(20686293,20,'./pmautobillreport.php'),(20686292,11225,'./pmautobill.php'),(20686291,11224,'./pmautobill.php'),(20686290,11223,'./pmautobill.php'),(20686289,14274,'./pmautobill.php'),(20686288,11496,'./pmautobill.php'),(20686287,11222,'./pmautobill.php'),(20686286,14273,'./pmautobill.php'),(20686285,11221,'./pmautobill.php'),(20686284,11220,'./pmautobill.php'),(20686283,11219,'./pmautobill.php'),(20686282,14272,'./pmautobill.php'),(20686281,8361,'./pmautobill.php'),(20686280,1963,'./pmautobill.php'),(20686279,1880,'./pmautobill.php'),(20686278,11218,'./pmautobill.php'),(20686277,11495,'./pmautobill.php'),(20686276,11217,'./pmautobill.php'),(20686275,11494,'./pmautobill.php'),(20686274,11493,'./pmautobill.php'),(20686273,10923,'./pmautobill.php'),(20686272,11216,'./pmautobill.php'),(20686271,11215,'./pmautobill.php'),(20686270,1668,'./pmautobill.php'),(20686269,11492,'./pmautobill.php'),(20686268,11491,'./pmautobill.php'),(20686267,11490,'./pmautobill.php'),(20686266,11214,'./pmautobill.php'),(20686265,6713,'./pmautobill.php'),(20686264,8936,'./pmautobill.php'),(20686263,1047,'./pmautobill.php'),(20686262,981,'./pmautobill.php'),(20686261,932,'./pmautobill.php'),(20686260,737,'./pmautobill.php'),(20686259,11213,'./pmautobill.php'),(20686258,12053,'./pmautobill.php'),(20686257,11212,'./pmautobill.php'),(20686256,11211,'./pmautobill.php'),(20686255,11210,'./pmautobill.php'),(20686254,5144,'./pmautobill.php'),(20686253,226,'./pmautobill.php'),(20686252,20,'./pmautobill.php'),(20806770,2710,'./pmassuresignsetup.php'),(20806769,2702,'./pmassuresignsetup.php'),(20806768,8936,'./pmassuresignsetup.php'),(20806767,11489,'./pmassuresignsetup.php'),(20806766,542,'./pmassuresignsetup.php'),(20806765,11488,'./pmassuresignsetup.php'),(20806764,11487,'./pmassuresignsetup.php'),(20806763,11486,'./pmassuresignsetup.php'),(20806762,2710,'./pmareaadd.php'),(20806761,2702,'./pmareaadd.php'),(20806760,9551,'./pmareaadd.php'),(20806759,9867,'./pmareaadd.php'),(20806758,1935,'./pmareaadd.php'),(20806757,941,'./pmareaadd.php'),(20806756,9781,'./pmareaadd.php'),(20806755,799,'./pmareaadd.php'),(20806754,14394,'./pmareaadd.php'),(20806753,542,'./pmareaadd.php'),(20806752,315,'./pmareaadd.php'),(20806751,5203,'./pmareaadd.php'),(20806750,9780,'./pmareaadd.php'),(20806749,9779,'./pmareaadd.php'),(20806748,9778,'./pmareaadd.php'),(20806747,9777,'./pmareaadd.php'),(20806746,11485,'./pmareaadd.php'),(20806745,9775,'./pmareaadd.php'),(20806744,9774,'./pmareaadd.php'),(20806743,9773,'./pmareaadd.php'),(20806742,9772,'./pmareaadd.php'),(20806741,9771,'./pmareaadd.php'),(20806740,9770,'./pmareaadd.php'),(20806739,11484,'./pmareaadd.php'),(20806738,9866,'./pmareaadd.php'),(20806737,59,'./pmareaadd.php'),(20806736,11483,'./pmagents.php'),(20806735,2710,'./pmagents.php'),(20806734,2702,'./pmagents.php'),(20806733,14393,'./pmagents.php'),(20806732,14392,'./pmagents.php'),(20806731,10714,'./pmagents.php'),(20806730,11479,'./pmagents.php'),(20806729,11482,'./pmagents.php'),(20806728,11481,'./pmagents.php'),(20806727,9550,'./pmagents.php'),(20806726,8958,'./pmagents.php'),(20806725,14391,'./pmagents.php'),(20806724,6839,'./pmagents.php'),(20806723,14390,'./pmagents.php'),(20806722,10711,'./pmagents.php'),(20806721,14389,'./pmagents.php'),(20806720,10709,'./pmagents.php'),(20806719,14388,'./pmagents.php'),(20806718,14387,'./pmagents.php'),(20806717,10706,'./pmagents.php'),(20806716,9546,'./pmagents.php'),(20806715,10705,'./pmagents.php'),(20806714,10704,'./pmagents.php'),(20806713,941,'./pmagents.php'),(20806712,799,'./pmagents.php'),(20806711,542,'./pmagents.php'),(20806710,315,'./pmagents.php'),(20806709,14386,'./pmagents.php'),(20806708,5203,'./pmagents.php'),(20806707,10702,'./pmagents.php'),(20806706,10701,'./pmagents.php'),(20806705,10700,'./pmagents.php'),(20806704,10699,'./pmagents.php'),(20806703,10698,'./pmagents.php'),(20806702,10697,'./pmagents.php'),(20806701,10696,'./pmagents.php'),(20806700,11480,'./pmagents.php'),(20806699,3421,'./piecework_functionsupd.php'),(20806698,3225,'./piecework_functionsupd.php'),(20806697,8383,'./piecework_functionsupd.php'),(20806696,2902,'./piecework_functionsupd.php'),(20806695,2702,'./piecework_functionsupd.php'),(20806694,8375,'./piecework_functionsupd.php'),(20806693,2094,'./piecework_functionsupd.php'),(20806692,8482,'./piecework_functionsupd.php'),(20806691,8480,'./piecework_functionsupd.php'),(20806690,3995,'./piecework_functionsupd.php'),(20806689,1143,'./piecework_functionsupd.php'),(20806688,941,'./piecework_functionsupd.php'),(20806687,8478,'./piecework_functionsupd.php'),(20806686,864,'./piecework_functionsupd.php'),(20806685,799,'./piecework_functionsupd.php'),(20806684,8477,'./piecework_functionsupd.php'),(20806683,8627,'./piecework_functionsupd.php'),(20806682,8626,'./piecework_functionsupd.php'),(20806681,610,'./piecework_functionsupd.php'),(20806680,542,'./piecework_functionsupd.php'),(20806679,8493,'./piecework_functionsupd.php'),(20806678,8492,'./piecework_functionsupd.php'),(20806677,5203,'./piecework_functionsupd.php'),(20806676,8475,'./piecework_functionsupd.php'),(20806675,8491,'./piecework_functionsupd.php'),(20806674,8488,'./piecework_functionsupd.php'),(20806673,59,'./piecework_functionsupd.php'),(20806672,7843,'./piecework_functionsupd.php'),(20806671,3421,'./piecework_functionsadd.php'),(20806670,8376,'./piecework_functionsadd.php'),(20806669,2902,'./piecework_functionsadd.php'),(20806668,2702,'./piecework_functionsadd.php'),(20806667,8375,'./piecework_functionsadd.php'),(20806666,8482,'./piecework_functionsadd.php'),(20806665,8480,'./piecework_functionsadd.php'),(20806664,8374,'./piecework_functionsadd.php'),(20806663,8478,'./piecework_functionsadd.php'),(20806662,8477,'./piecework_functionsadd.php'),(20806661,542,'./piecework_functionsadd.php'),(20806660,8493,'./piecework_functionsadd.php'),(20806659,8492,'./piecework_functionsadd.php'),(20806658,8475,'./piecework_functionsadd.php'),(20806657,8491,'./piecework_functionsadd.php'),(20806656,176,'./piecework_functionsadd.php'),(20806655,3225,'./piecework_areasupd.php'),(20806654,8382,'./piecework_areasupd.php'),(20806653,2902,'./piecework_areasupd.php'),(20806652,2702,'./piecework_areasupd.php'),(20806651,8379,'./piecework_areasupd.php'),(20806650,2094,'./piecework_areasupd.php'),(20806649,8381,'./piecework_areasupd.php'),(20806648,3995,'./piecework_areasupd.php'),(20806647,1143,'./piecework_areasupd.php'),(20806646,941,'./piecework_areasupd.php'),(20806645,864,'./piecework_areasupd.php'),(20806644,799,'./piecework_areasupd.php'),(20806643,5203,'./piecework_areasupd.php'),(20806642,59,'./piecework_areasupd.php'),(20806641,8380,'./piecework_areasadd.php'),(20806640,2902,'./piecework_areasadd.php'),(20806639,2702,'./piecework_areasadd.php'),(20806638,8379,'./piecework_areasadd.php'),(20806637,8374,'./piecework_areasadd.php'),(20806636,315,'./piecework_areasadd.php'),(20806635,176,'./piecework_areasadd.php'),(20806634,8490,'./piecework_addlrates.php'),(20806633,2702,'./piecework_addlrates.php'),(20806632,2565,'./piecework_addlrates.php'),(20806631,8374,'./piecework_addlrates.php'),(20806630,902,'./piecework_addlrates.php'),(20806629,799,'./piecework_addlrates.php'),(20806628,542,'./piecework_addlrates.php'),(20806627,176,'./piecework_addlrates.php'),(20806626,3422,'./piecework_actionsupd.php'),(20806625,3421,'./piecework_actionsupd.php'),(20806624,8487,'./piecework_actionsupd.php'),(20806623,8378,'./piecework_actionsupd.php'),(20806622,2902,'./piecework_actionsupd.php'),(20806621,8485,'./piecework_actionsupd.php'),(20806620,8489,'./piecework_actionsupd.php'),(20806619,2784,'./piecework_actionsupd.php'),(20806618,2702,'./piecework_actionsupd.php'),(20806617,8484,'./piecework_actionsupd.php'),(20806616,8483,'./piecework_actionsupd.php'),(20806615,2529,'./piecework_actionsupd.php'),(20806614,8377,'./piecework_actionsupd.php'),(20806613,2094,'./piecework_actionsupd.php'),(20806612,8482,'./piecework_actionsupd.php'),(20806611,8481,'./piecework_actionsupd.php'),(20806610,8480,'./piecework_actionsupd.php'),(20806609,8479,'./piecework_actionsupd.php'),(20806608,3995,'./piecework_actionsupd.php'),(20806607,1143,'./piecework_actionsupd.php'),(20806606,941,'./piecework_actionsupd.php'),(20806605,8478,'./piecework_actionsupd.php'),(20806604,864,'./piecework_actionsupd.php'),(20806603,799,'./piecework_actionsupd.php'),(20806602,8477,'./piecework_actionsupd.php'),(20806601,542,'./piecework_actionsupd.php'),(20806600,8476,'./piecework_actionsupd.php'),(20806599,5203,'./piecework_actionsupd.php'),(20806598,8475,'./piecework_actionsupd.php'),(20806597,8488,'./piecework_actionsupd.php'),(20806596,59,'./piecework_actionsupd.php'),(20806595,3422,'./piecework_actionsadd.php'),(20806594,3421,'./piecework_actionsadd.php'),(20806593,8487,'./piecework_actionsadd.php'),(20806592,8486,'./piecework_actionsadd.php'),(20806591,2902,'./piecework_actionsadd.php'),(20806590,8485,'./piecework_actionsadd.php'),(20806589,2784,'./piecework_actionsadd.php'),(20806588,2702,'./piecework_actionsadd.php'),(20806587,8484,'./piecework_actionsadd.php'),(20806586,8483,'./piecework_actionsadd.php'),(20806585,2529,'./piecework_actionsadd.php'),(20806584,8377,'./piecework_actionsadd.php'),(20806583,8482,'./piecework_actionsadd.php'),(20806582,8481,'./piecework_actionsadd.php'),(20806581,8480,'./piecework_actionsadd.php'),(20806580,8479,'./piecework_actionsadd.php'),(20806579,8374,'./piecework_actionsadd.php'),(20806578,8478,'./piecework_actionsadd.php'),(20806577,8477,'./piecework_actionsadd.php'),(20806576,542,'./piecework_actionsadd.php'),(20806575,8476,'./piecework_actionsadd.php'),(20806574,8475,'./piecework_actionsadd.php'),(20806573,176,'./piecework_actionsadd.php'),(20806572,8474,'./piecework_actions_selections.php'),(20806571,2702,'./piecework_actions_selections.php'),(20806570,2565,'./piecework_actions_selections.php'),(20806569,1894,'./piecework_actions_selections.php'),(20806568,8374,'./piecework_actions_selections.php'),(20806567,902,'./piecework_actions_selections.php'),(20806566,869,'./piecework_actions_selections.php'),(20806565,799,'./piecework_actions_selections.php'),(20806564,542,'./piecework_actions_selections.php'),(20806563,176,'./piecework_actions_selections.php'),(20806562,3108,'./pager.php'),(20806561,3046,'./pager.php'),(20806560,2982,'./pager.php'),(20806559,2947,'./pager.php'),(20806558,2935,'./pager.php'),(20806557,2772,'./pager.php'),(20806556,2593,'./pager.php'),(20806555,2348,'./pager.php'),(20806554,2223,'./pager.php'),(20806553,2044,'./pager.php'),(20806552,1920,'./pager.php'),(20806551,1918,'./pager.php'),(20806550,1888,'./pager.php'),(20806549,1846,'./pager.php'),(20806548,690,'./pager.php'),(20806547,466,'./pager.php'),(20806546,424,'./pager.php'),(20806545,423,'./pager.php'),(20806544,313,'./pager.php'),(20806543,5677,'./over_estimate_orders_list.php'),(20806542,2165,'./over_estimate_orders_list.php'),(20806541,5674,'./over_estimate_orders_list.php'),(20806540,4083,'./over_estimate_orders_list.php'),(20806539,697,'./over_estimate_orders_list.php'),(20806538,5673,'./over_estimate_orders_list.php'),(20806537,3090,'./obs_report.php'),(20806536,2827,'./obs_report.php'),(20806535,2589,'./obs_report.php'),(20806534,7515,'./obs_report.php'),(20806533,7512,'./obs_report.php'),(20806532,8362,'./obs_report.php'),(20806531,4391,'./obs_report.php'),(20806530,8361,'./obs_report.php'),(20806529,1963,'./obs_report.php'),(20806528,1014,'./obs_report.php'),(20806527,901,'./obs_report.php'),(20806526,749,'./obs_report.php'),(20806525,387,'./obs_report.php'),(20806524,333,'./obs_report.php'),(20806523,313,'./obs_report.php'),(20810368,14626,'./reset_password.php'),(20810367,14625,'./reset_password.php'),(20810366,14624,'./reset_password.php'),(20810365,14623,'./reset_password.php'),(20810364,7973,'./reset_password.php'),(20806522,3252,'./npordersave.php'),(20806521,16890,'./npordersave.php'),(20806520,3090,'./npordersave.php'),(20806519,3948,'./npordersave.php'),(20806518,19794,'./npordersave.php'),(20806517,2998,'./npordersave.php'),(20806516,20254,'./npordersave.php'),(20806515,9226,'./npordersave.php'),(20806514,9225,'./npordersave.php'),(20806513,16475,'./npordersave.php'),(20806512,19793,'./npordersave.php'),(20806511,19866,'./npordersave.php'),(20806510,16393,'./npordersave.php'),(20806509,19510,'./npordersave.php'),(20806508,2601,'./npordersave.php'),(20806507,4708,'./npordersave.php'),(20806506,2540,'./npordersave.php'),(20806451,3322,'./nporderremote.php'),(20806450,14795,'./nporderremote.php'),(20806449,17425,'./nporderremote.php'),(20806448,3252,'./nporderremote.php'),(20806447,3156,'./nporderremote.php'),(20806446,7129,'./nporderremote.php'),(20806427,2508,'./nporderpricehistory.php'),(20806426,2494,'./nporderpricehistory.php'),(20806425,2404,'./nporderpricehistory.php'),(20806424,2315,'./nporderpricehistory.php'),(20806423,2165,'./nporderpricehistory.php'),(20806422,13937,'./nporderpricehistory.php'),(20806421,9000,'./nporderpricehistory.php'),(20806420,13941,'./nporderpricehistory.php'),(20806419,1668,'./nporderpricehistory.php'),(20806418,8936,'./nporderpricehistory.php'),(20806417,13936,'./nporderpricehistory.php'),(20806416,737,'./nporderpricehistory.php'),(20806413,8916,'./nporderpayment.php'),(20806412,13065,'./nporderpayment.php'),(20806411,8915,'./nporderpayment.php'),(20806410,8914,'./nporderpayment.php'),(20806409,11792,'./nporderpayment.php'),(20806408,3415,'./nporderpayment.php'),(20806407,17112,'./nporderpayment.php'),(20806406,3333,'./nporderpayment.php'),(20806405,14056,'./nporderpayment.php'),(20806404,14157,'./nporderpayment.php'),(20806403,14946,'./nporderpayment.php'),(20806402,3129,'./nporderpayment.php'),(20806401,10622,'./nporderpayment.php'),(20806400,17117,'./nporderpayment.php'),(20806399,2998,'./nporderpayment.php'),(20806398,2977,'./nporderpayment.php'),(20806397,16475,'./nporderpayment.php'),(20806396,8126,'./nporderpayment.php'),(20806395,17111,'./nporderpayment.php'),(20806394,10621,'./nporderpayment.php'),(20806393,8913,'./nporderpayment.php'),(20806392,16825,'./nporderpayment.php'),(20806391,16785,'./nporderpayment.php'),(20806390,2561,'./nporderpayment.php'),(20806389,2540,'./nporderpayment.php'),(20806388,2501,'./nporderpayment.php'),(20806387,9928,'./nporderpayment.php'),(20806386,14688,'./nporderpayment.php'),(20806385,3777,'./nporderpayment.php'),(20806384,2480,'./nporderpayment.php'),(20806383,19220,'./nporderpayment.php'),(20806382,2473,'./nporderpayment.php'),(20806381,11734,'./nporderpayment.php'),(20806380,2459,'./nporderpayment.php'),(20806379,15105,'./nporderpayment.php'),(20806378,9612,'./nporderpayment.php'),(20806377,17124,'./nporderpayment.php'),(20806376,7758,'./nporderpayment.php'),(20806375,2334,'./nporderpayment.php'),(20806374,18222,'./nporderpayment.php'),(20806373,13908,'./nporderpayment.php'),(20806372,19154,'./nporderpayment.php'),(20806371,8912,'./nporderpayment.php'),(20806370,6318,'./nporderpayment.php'),(20806369,2225,'./nporderpayment.php'),(20806368,4023,'./nporderpayment.php'),(20806367,2208,'./nporderpayment.php'),(20806366,2194,'./nporderpayment.php'),(20806365,2192,'./nporderpayment.php'),(20806364,5481,'./nporderpayment.php'),(20806363,2182,'./nporderpayment.php'),(20806362,8680,'./nporderpayment.php'),(20806361,2165,'./nporderpayment.php'),(20806360,16163,'./nporderpayment.php'),(20806359,2109,'./nporderpayment.php'),(20806358,1992,'./nporderpayment.php'),(20806357,11122,'./nporderpayment.php'),(20806356,9459,'./nporderpayment.php'),(20806355,9458,'./nporderpayment.php'),(20806354,16162,'./nporderpayment.php'),(20806353,6783,'./nporderpayment.php'),(20806352,16779,'./nporderpayment.php'),(20806351,16778,'./nporderpayment.php'),(20806350,3706,'./nporderpayment.php'),(20806349,1913,'./nporderpayment.php'),(20806348,17116,'./nporderpayment.php'),(20806347,1788,'./nporderpayment.php'),(20806346,10619,'./nporderpayment.php'),(20806345,6215,'./nporderpayment.php'),(20806344,1692,'./nporderpayment.php'),(20806343,1678,'./nporderpayment.php'),(20806342,1668,'./nporderpayment.php'),(20806341,6745,'./nporderpayment.php'),(20806340,13064,'./nporderpayment.php'),(20806339,6213,'./nporderpayment.php'),(20806338,13063,'./nporderpayment.php'),(20806337,13200,'./nporderpayment.php'),(20806336,13076,'./nporderpayment.php'),(20806335,11146,'./nporderpayment.php'),(20806334,11145,'./nporderpayment.php'),(20806333,10238,'./nporderpayment.php'),(20806332,1047,'./nporderpayment.php'),(20806331,15557,'./nporderpayment.php'),(20806330,985,'./nporderpayment.php'),(20806329,6308,'./nporderpayment.php'),(20806328,981,'./nporderpayment.php'),(20806327,13789,'./nporderpayment.php'),(20806326,8010,'./nporderpayment.php'),(20806325,776,'./nporderpayment.php'),(20806324,15104,'./nporderpayment.php'),(20806323,673,'./nporderpayment.php'),(20806322,6430,'./nporderpayment.php'),(20806321,670,'./nporderpayment.php'),(20806320,7623,'./nporderpayment.php'),(20806319,9492,'./nporderpayment.php'),(20806318,16097,'./nporderpayment.php'),(20806317,6307,'./nporderpayment.php'),(20806316,17109,'./nporderpayment.php'),(20806279,16703,'./npordermiscremote.php'),(20806278,6792,'./npordermiscremote.php'),(20806277,12237,'./npordermiscremote.php'),(20806276,17114,'./npordermiscremote.php'),(20806275,17113,'./npordermiscremote.php'),(20806274,2998,'./npordermiscremote.php'),(20806273,2833,'./npordermiscremote.php'),(20806272,11406,'./npordermiscremote.php'),(20806271,2464,'./npordermiscremote.php'),(20806270,17124,'./npordermiscremote.php'),(20806269,8910,'./npordermiscremote.php'),(20806268,6788,'./npordermiscremote.php'),(20806267,6787,'./npordermiscremote.php'),(20806266,6786,'./npordermiscremote.php'),(20806265,9143,'./npordermiscremote.php'),(20806253,2508,'./nporderitemfamily.php'),(20806252,2404,'./nporderitemfamily.php'),(20806251,5525,'./nporderitemfamily.php'),(20806250,2137,'./nporderitemfamily.php'),(20806249,9000,'./nporderitemfamily.php'),(20806248,13334,'./nporderitemfamily.php'),(20806247,1709,'./nporderitemfamily.php'),(20806246,8936,'./nporderitemfamily.php'),(20806245,869,'./nporderitemfamily.php'),(20806244,6771,'./nporderitemfamily.php'),(20806243,8997,'./nporderitemfamily.php'),(20806242,8999,'./nporderitemfamily.php'),(20808797,1029,'./prloghours.php'),(20808796,995,'./prloghours.php'),(20808795,993,'./prloghours.php'),(20808794,989,'./prloghours.php'),(20808793,15678,'./prloghours.php'),(20808792,7284,'./prloghours.php'),(20808791,17855,'./prloghours.php'),(20808790,781,'./prloghours.php'),(20808789,15677,'./prloghours.php'),(20808788,737,'./prloghours.php'),(20808787,16455,'./prloghours.php'),(20781428,2950,'./!/application/controllers/invcountbatch_livecount.php'),(20781427,18193,'./!/application/controllers/invcountbatch_livecount.php'),(20781426,19546,'./!/application/controllers/invcountbatch_livecount.php'),(20781425,18462,'./!/application/controllers/invcountbatch_livecount.php'),(20781424,2459,'./!/application/controllers/invcountbatch_livecount.php'),(20781423,16487,'./!/application/controllers/invcountbatch_livecount.php'),(20806505,14823,'./npordersave.php'),(20806504,16396,'./npordersave.php'),(20806503,17346,'./npordersave.php'),(20806502,19182,'./npordersave.php'),(20806501,2324,'./npordersave.php'),(20806500,8918,'./npordersave.php'),(20806499,9143,'./npordersave.php'),(20806498,9147,'./npordersave.php'),(20806445,6770,'./nporderremote.php'),(20806315,548,'./nporderpayment.php'),(20806314,491,'./nporderpayment.php'),(20806313,19153,'./nporderpayment.php'),(20806240,9130,'./nporder.php'),(20806239,14793,'./nporder.php'),(20806238,14915,'./nporder.php'),(20806237,8908,'./nporder.php'),(20806236,14914,'./nporder.php'),(20806235,19875,'./nporder.php'),(20806234,13966,'./nporder.php'),(20806233,3421,'./nporder.php'),(20806232,3360,'./nporder.php'),(20806231,16884,'./nporder.php'),(20806230,19257,'./nporder.php'),(20806229,14555,'./nporder.php'),(20806228,5378,'./nporder.php'),(20806227,3324,'./nporder.php'),(20806226,15348,'./nporder.php'),(20806225,3322,'./nporder.php'),(20806224,8220,'./nporder.php'),(20806223,15854,'./nporder.php'),(20806222,14134,'./nporder.php'),(20806221,14932,'./nporder.php'),(20806220,13821,'./nporder.php'),(20806219,13820,'./nporder.php'),(20806218,3177,'./nporder.php'),(20806217,18033,'./nporder.php'),(20806216,3450,'./nporder.php'),(20806215,14768,'./nporder.php'),(20806214,19288,'./nporder.php'),(20806213,9140,'./nporder.php'),(20806212,18692,'./nporder.php'),(20806211,17493,'./nporder.php'),(20806210,3156,'./nporder.php'),(20806209,16883,'./nporder.php'),(20806208,3099,'./nporder.php'),(20806207,3090,'./nporder.php'),(20806206,18827,'./nporder.php'),(20806205,16882,'./nporder.php'),(20806204,16075,'./nporder.php'),(20806203,9129,'./nporder.php'),(20806202,19862,'./nporder.php'),(20806201,16702,'./nporder.php'),(20806200,14931,'./nporder.php'),(20806199,13107,'./nporder.php'),(20806198,15544,'./nporder.php'),(20806197,2998,'./nporder.php'),(20806196,16641,'./nporder.php'),(20806195,2977,'./nporder.php'),(20806194,2948,'./nporder.php'),(20806193,2936,'./nporder.php'),(20806192,14161,'./nporder.php'),(20806191,9825,'./nporder.php'),(20806190,20158,'./nporder.php'),(20806189,18313,'./nporder.php'),(20806188,18032,'./nporder.php'),(20806187,2849,'./nporder.php'),(20806186,16327,'./nporder.php'),(20806185,4455,'./nporder.php'),(20806184,2823,'./nporder.php'),(20806183,2819,'./nporder.php'),(20806182,8126,'./nporder.php'),(20806181,14765,'./nporder.php'),(20806180,5225,'./nporder.php'),(20806179,19152,'./nporder.php'),(20806178,8055,'./nporder.php'),(20806177,14361,'./nporder.php'),(20806176,2833,'./nporder.php'),(20806175,2827,'./nporder.php'),(20806174,15347,'./nporder.php'),(20806173,17366,'./nporder.php'),(20806172,15103,'./nporder.php'),(20806171,2788,'./nporder.php'),(20806170,13879,'./nporder.php'),(20806169,13878,'./nporder.php'),(20806168,16881,'./nporder.php'),(20806167,6217,'./nporder.php'),(20806166,18312,'./nporder.php'),(20806165,8682,'./nporder.php'),(20806164,18311,'./nporder.php'),(20806163,9135,'./nporder.php'),(20806162,15017,'./nporder.php'),(20806161,5847,'./nporder.php'),(20806160,2702,'./nporder.php'),(20806159,2701,'./nporder.php'),(20806158,2676,'./nporder.php'),(20806157,3961,'./nporder.php'),(20806156,8219,'./nporder.php'),(20806155,8218,'./nporder.php'),(20806154,13662,'./nporder.php'),(20806153,2622,'./nporder.php'),(20806152,19687,'./nporder.php'),(20806151,18465,'./nporder.php'),(20806150,4265,'./nporder.php'),(20806149,17051,'./nporder.php'),(20806148,17050,'./nporder.php'),(20806147,17049,'./nporder.php'),(20806146,13616,'./nporder.php'),(20806145,16847,'./nporder.php'),(20806144,16785,'./nporder.php'),(20806143,19477,'./nporder.php'),(20806142,16074,'./nporder.php'),(20806141,13254,'./nporder.php'),(20806140,18031,'./nporder.php'),(20806139,16701,'./nporder.php'),(20806138,2586,'./nporder.php'),(20806137,19215,'./nporder.php'),(20806136,2561,'./nporder.php'),(20806135,13980,'./nporder.php'),(20806134,2540,'./nporder.php'),(20806133,18310,'./nporder.php'),(20806132,2539,'./nporder.php'),(20806131,19455,'./nporder.php'),(20806130,2508,'./nporder.php'),(20806129,2501,'./nporder.php'),(20806128,16879,'./nporder.php'),(20806127,17496,'./nporder.php'),(20806126,17497,'./nporder.php'),(20806125,9267,'./nporder.php'),(20806124,2494,'./nporder.php'),(20806123,11420,'./nporder.php'),(20806122,19454,'./nporder.php'),(20806121,19453,'./nporder.php'),(20806120,19452,'./nporder.php'),(20806119,20157,'./nporder.php'),(20806118,2459,'./nporder.php'),(20806117,20156,'./nporder.php'),(20806116,18276,'./nporder.php'),(20806115,2405,'./nporder.php'),(20806114,18691,'./nporder.php'),(20806113,13933,'./nporder.php'),(20806112,2455,'./nporder.php'),(20806111,2404,'./nporder.php'),(20806110,8996,'./nporder.php'),(20806109,2363,'./nporder.php'),(20806108,2376,'./nporder.php'),(20806107,2371,'./nporder.php'),(20806106,14094,'./nporder.php'),(20806105,14090,'./nporder.php'),(20806104,9322,'./nporder.php'),(20806103,5494,'./nporder.php'),(20806102,2361,'./nporder.php'),(20806101,14105,'./nporder.php'),(20806100,2334,'./nporder.php'),(20806099,14658,'./nporder.php'),(20806098,2324,'./nporder.php'),(20806097,2315,'./nporder.php'),(20806096,17048,'./nporder.php'),(20806095,17619,'./nporder.php'),(20806094,18222,'./nporder.php'),(20806093,2260,'./nporder.php'),(20806092,2225,'./nporder.php'),(20806091,20183,'./nporder.php'),(20806090,20155,'./nporder.php'),(20806089,20154,'./nporder.php'),(20806088,3933,'./nporder.php'),(20806087,16878,'./nporder.php'),(20806086,8681,'./nporder.php'),(20806085,4579,'./nporder.php'),(20806084,16700,'./nporder.php'),(20806083,9134,'./nporder.php'),(20806082,2182,'./nporder.php'),(20806081,4865,'./nporder.php'),(20805849,768,'./np_install.php'),(20805848,8114,'./noteedit.php'),(20805847,2103,'./noteedit.php'),(20805846,8115,'./noteadd.php'),(20805845,8114,'./noteadd.php'),(20805844,2103,'./noteadd.php'),(20805843,3224,'./myuser.php'),(20805842,2710,'./myuser.php'),(20805841,2702,'./myuser.php'),(20805840,14629,'./myuser.php'),(20805839,2237,'./myuser.php'),(20805838,8030,'./myuser.php'),(20805836,3102,'./mgmtfees_paid.php'),(20805835,3101,'./mgmtfees_paid.php'),(20805834,2595,'./mgmtfees_paid.php'),(20805833,6962,'./mgmtfees_paid.php'),(20805832,1998,'./mgmtfees_paid.php'),(20805831,1963,'./mgmtfees_paid.php'),(20805830,11205,'./mgmtfees_paid.php'),(20805829,11204,'./mgmtfees_paid.php'),(20805828,1014,'./mgmtfees_paid.php'),(20805827,869,'./mgmtfees_paid.php'),(20805826,333,'./mgmtfees_paid.php'),(20805825,226,'./mgmtfees_paid.php'),(20805824,6710,'./mgmtfees.php'),(20805823,11032,'./mgmtfees.php'),(20805822,2673,'./mgmtfees.php'),(20805821,2565,'./mgmtfees.php'),(20805820,11479,'./mgmtfees.php'),(20805819,11031,'./mgmtfees.php'),(20805818,11478,'./mgmtfees.php'),(20805817,1963,'./mgmtfees.php'),(20805816,11029,'./mgmtfees.php'),(20805815,11028,'./mgmtfees.php'),(20805814,11027,'./mgmtfees.php'),(20805813,11026,'./mgmtfees.php'),(20805812,11025,'./mgmtfees.php'),(20805811,11024,'./mgmtfees.php'),(20805810,11023,'./mgmtfees.php'),(20805809,8936,'./mgmtfees.php'),(20805808,869,'./mgmtfees.php'),(20805807,11022,'./mgmtfees.php'),(20805806,607,'./mgmtfees.php'),(20805805,11021,'./mgmtfees.php'),(20805804,5145,'./mgmtfees.php'),(20805803,604,'./message.php'),(20805802,12726,'./message.php'),(20805801,2058,'./menunew1_classic.php'),(20805800,2057,'./menunew1.php'),(20805799,4015,'./menu.php'),(20805798,3797,'./menu.php'),(20805797,10492,'./menu.php'),(20805796,4095,'./menu.php'),(20805795,9612,'./menu.php'),(20805794,2270,'./menu.php'),(20805793,2058,'./menu.php'),(20805792,3672,'./menu.php'),(20805791,1639,'./menu.php'),(20805790,16477,'./menu.php'),(20805789,13576,'./menu.php'),(20805788,1353,'./menu.php'),(20685268,11436,'./mc2xreportofcollection.php'),(20685267,2702,'./mc2xreportofcollection.php'),(20685266,11441,'./mc2xreportofcollection.php'),(20685265,2508,'./mc2xreportofcollection.php'),(20685264,11440,'./mc2xreportofcollection.php'),(20685263,11439,'./mc2xreportofcollection.php'),(20685262,11438,'./mc2xreportofcollection.php'),(20685261,1963,'./mc2xreportofcollection.php'),(20685260,8936,'./mc2xreportofcollection.php'),(20685259,9341,'./mc2xreportofcollection.php'),(20685258,11437,'./mc2xreportofcollection.php'),(20685257,11427,'./mc2xreportofcollection.php'),(20685256,315,'./mc2xreportofcollection.php'),(20685255,11434,'./mc2xreportofcollection.php'),(20685254,226,'./mc2xreportofcollection.php'),(20685253,11436,'./mc2xcashcount.php'),(20685252,2702,'./mc2xcashcount.php'),(20685251,2508,'./mc2xcashcount.php'),(20685250,5366,'./mc2xcashcount.php'),(20685249,8912,'./mc2xcashcount.php'),(20685248,8936,'./mc2xcashcount.php'),(20685247,9803,'./mc2xcashcount.php'),(20685246,9341,'./mc2xcashcount.php'),(20685245,11435,'./mc2xcashcount.php'),(20685244,541,'./mc2xcashcount.php'),(20685243,11427,'./mc2xcashcount.php'),(20685242,11434,'./mc2xcashcount.php'),(20685241,226,'./mc2xcashcount.php'),(20805786,12690,'./managesub.php'),(20805785,12685,'./managesub.php'),(20805784,12683,'./managesub.php'),(20805783,6164,'./lookupvendor_alt.php'),(20805782,6364,'./lookupvendor_alt.php'),(20805781,3274,'./lookupvendor_alt.php'),(20805780,2936,'./lookupvendor_alt.php'),(20805779,2751,'./lookupvendor_alt.php'),(20805778,15016,'./lookupvendor_alt.php'),(20805777,2738,'./lookupvendor_alt.php'),(20805776,2324,'./lookupvendor_alt.php'),(20805775,2031,'./lookupvendor_alt.php'),(20805774,6163,'./lookupvendor_alt.php'),(20805773,981,'./lookupvendor_alt.php'),(20805772,581,'./lookupvendor_alt.php'),(20805771,542,'./lookupvendor_alt.php'),(20805770,524,'./lookupvendor_alt.php'),(20805769,315,'./lookupvendor_alt.php'),(20805768,185,'./lookupvendor_alt.php'),(20726048,3278,'./lookupvendor.php'),(20726047,2751,'./lookupvendor.php'),(20726046,2738,'./lookupvendor.php'),(20726045,2031,'./lookupvendor.php'),(20726044,315,'./lookupvendor.php'),(20685216,2751,'./lookupshipto.php'),(20685215,2030,'./lookupshipto.php'),(20685214,315,'./lookupshipto.php'),(20805767,4861,'./lookuporder.php'),(20805766,2948,'./lookuporder.php'),(20805765,2819,'./lookuporder.php'),(20805764,2540,'./lookuporder.php'),(20805763,2501,'./lookuporder.php'),(20805762,2363,'./lookuporder.php'),(20805761,4886,'./lookuporder.php'),(20805760,2231,'./lookuporder.php'),(20805759,2182,'./lookuporder.php'),(20805758,2170,'./lookuporder.php'),(20805757,2156,'./lookuporder.php'),(20805756,2151,'./lookuporder.php'),(20805755,12686,'./lookuporder.php'),(20805754,2103,'./lookuporder.php'),(20805753,2099,'./lookuporder.php'),(20805752,1963,'./lookuporder.php'),(20805751,5339,'./lookuporder.php'),(20805750,6772,'./lookuporder.php'),(20805749,4481,'./lookuporder.php'),(20805748,542,'./lookuporder.php'),(20805747,5850,'./lookuporder.php'),(20805746,355,'./lookuporder.php'),(20805745,211,'./lookuporder.php'),(20805744,12681,'./lookuporder.php'),(20685189,2767,'./lookupitemcomposite.php'),(20685188,2751,'./lookupitemcomposite.php'),(20685187,1987,'./lookupitemcomposite.php'),(20685186,869,'./lookupitemcomposite.php'),(20685185,602,'./lookupitemcomposite.php'),(20685184,451,'./lookupitemcomposite.php'),(20805743,4109,'./lookupitem_alt.php'),(20805742,16694,'./lookupitem_alt.php'),(20805741,3298,'./lookupitem_alt.php'),(20805740,3292,'./lookupitem_alt.php'),(20805739,3274,'./lookupitem_alt.php'),(20805738,5827,'./lookupitem_alt.php'),(20805737,16676,'./lookupitem_alt.php'),(20805736,6369,'./lookupitem_alt.php'),(20805735,2767,'./lookupitem_alt.php'),(20805734,2623,'./lookupitem_alt.php'),(20805733,16671,'./lookupitem_alt.php'),(20805732,3503,'./lookupitem_alt.php'),(20805731,2008,'./lookupitem_alt.php'),(20805730,16674,'./lookupitem_alt.php'),(20805729,1963,'./lookupitem_alt.php'),(20805728,6986,'./lookupitem_alt.php'),(20805727,8184,'./lookupitem_alt.php'),(20805726,1766,'./lookupitem_alt.php'),(20805725,19780,'./lookupitem_alt.php'),(20725988,5829,'./lookupitem2.php'),(20725987,5828,'./lookupitem2.php'),(20725986,2767,'./lookupitem2.php'),(20725985,2751,'./lookupitem2.php'),(20725984,2008,'./lookupitem2.php'),(20725983,1776,'./lookupitem2.php'),(20725982,1731,'./lookupitem2.php'),(20725981,869,'./lookupitem2.php'),(20725980,451,'./lookupitem2.php'),(20725979,315,'./lookupitem2.php'),(20725978,4109,'./lookupitem.php'),(20725977,5829,'./lookupitem.php'),(20725976,5828,'./lookupitem.php'),(20725975,3274,'./lookupitem.php'),(20725974,5827,'./lookupitem.php'),(20725973,6369,'./lookupitem.php'),(20725972,2767,'./lookupitem.php'),(20725971,2751,'./lookupitem.php'),(20725970,3503,'./lookupitem.php'),(20725969,2008,'./lookupitem.php'),(20725968,1963,'./lookupitem.php'),(20725967,1766,'./lookupitem.php'),(20725966,1709,'./lookupitem.php'),(20725965,1696,'./lookupitem.php'),(20725964,869,'./lookupitem.php'),(20725963,600,'./lookupitem.php'),(20725962,451,'./lookupitem.php'),(20725961,5826,'./lookupitem.php'),(20725960,315,'./lookupitem.php'),(20685123,5659,'./lookupgl.php'),(20685122,5658,'./lookupgl.php'),(20685121,2751,'./lookupgl.php'),(20685120,2044,'./lookupgl.php'),(20685119,542,'./lookupgl.php'),(20685118,2751,'./lookupcustomer_search.php'),(20685117,2738,'./lookupcustomer_search.php'),(20685116,581,'./lookupcustomer_search.php'),(20685115,315,'./lookupcustomer_search.php'),(20805712,6164,'./lookupcustomer_alt.php'),(20805711,9169,'./lookupcustomer_alt.php'),(20805710,2936,'./lookupcustomer_alt.php'),(20805709,2751,'./lookupcustomer_alt.php'),(20805708,15016,'./lookupcustomer_alt.php'),(20805707,2738,'./lookupcustomer_alt.php'),(20805706,2676,'./lookupcustomer_alt.php'),(20805705,3961,'./lookupcustomer_alt.php'),(20805704,2324,'./lookupcustomer_alt.php'),(20805703,2018,'./lookupcustomer_alt.php'),(20805702,8548,'./lookupcustomer_alt.php'),(20805701,8544,'./lookupcustomer_alt.php'),(20805700,1758,'./lookupcustomer_alt.php'),(20805699,5081,'./lookupcustomer_alt.php'),(20805698,1678,'./lookupcustomer_alt.php'),(20805697,1429,'./lookupcustomer_alt.php'),(20805696,6163,'./lookupcustomer_alt.php'),(20805695,981,'./lookupcustomer_alt.php'),(20805694,6162,'./lookupcustomer_alt.php'),(20805693,697,'./lookupcustomer_alt.php'),(20805692,659,'./lookupcustomer_alt.php'),(20805691,581,'./lookupcustomer_alt.php'),(20805690,542,'./lookupcustomer_alt.php'),(20725933,2751,'./lookupcustomer.php'),(20725932,2738,'./lookupcustomer.php'),(20725931,2018,'./lookupcustomer.php'),(20725930,704,'./lookupcustomer.php'),(20725929,315,'./lookupcustomer.php'),(20685083,542,'./lookupcalc.php'),(20685082,5521,'./lookupcalc.php'),(20685081,2022,'./lookup.php'),(20805686,6386,'./list_db_explanation.php'),(20805685,6385,'./list_db_explanation.php'),(20805684,2094,'./list_db_explanation.php'),(20805683,1963,'./list_db_explanation.php'),(20805682,6383,'./list_db_explanation.php'),(20805681,6382,'./list_db_explanation.php'),(20805680,6387,'./list_db_explanation.php'),(20805679,6381,'./list_db_explanation.php'),(20805678,6380,'./list_db_explanation.php'),(20805677,6379,'./list_db_explanation.php'),(20805676,4397,'./list_db_explanation.php'),(20805675,6389,'./list_db_explanation.php'),(20805674,607,'./list_db_explanation.php'),(20805673,315,'./list_db_explanation.php'),(20805672,6509,'./link_addupdate.php'),(20805671,2702,'./link_addupdate.php'),(20805670,6512,'./link_addupdate.php'),(20805669,1935,'./link_addupdate.php'),(20805668,6507,'./link_addupdate.php'),(20805667,6510,'./link_addupdate.php'),(20805666,6520,'./link_addupdate.php'),(20805665,6506,'./link_addupdate.php'),(20805664,6511,'./link_addupdate.php'),(20805663,6504,'./link_addupdate.php'),(20805662,6503,'./link_addupdate.php'),(20805661,941,'./link_addupdate.php'),(20805660,869,'./link_addupdate.php'),(20805659,806,'./link_addupdate.php'),(20805658,799,'./link_addupdate.php'),(20805657,315,'./link_addupdate.php'),(20805656,4871,'./link_addupdate.php'),(20805655,6502,'./link_addupdate.php'),(20805654,59,'./link_addupdate.php'),(20805653,55,'./link_addupdate.php'),(20805652,14684,'./langedit.php'),(20805651,3903,'./langedit.php'),(20805650,3521,'./langedit.php'),(20805649,3902,'./langedit.php'),(20805648,3520,'./langedit.php'),(20805647,3427,'./labels2.php'),(20805646,7986,'./labels2.php'),(20805645,7985,'./labels2.php'),(20805644,7984,'./labels2.php'),(20805643,7983,'./labels2.php'),(20805642,7982,'./labels2.php'),(20805641,2250,'./labels2.php'),(20805640,2178,'./labels2.php'),(20805639,4315,'./labels2.php'),(20805638,2063,'./labels2.php'),(20805637,2048,'./labels2.php'),(20805636,2009,'./labels2.php'),(20805635,1991,'./labels2.php'),(20805634,1963,'./labels2.php'),(20805633,7981,'./labels2.php'),(20805632,1750,'./labels2.php'),(20805631,1700,'./labels2.php'),(20805630,1696,'./labels2.php'),(20805629,1540,'./labels2.php'),(20805628,1239,'./labels2.php'),(20805627,1236,'./labels2.php'),(20805626,1230,'./labels2.php'),(20805625,722,'./labels2.php'),(20805624,7980,'./labels2.php'),(20805623,697,'./labels2.php'),(20805622,542,'./labels2.php'),(20805621,540,'./labels2.php'),(20805620,7979,'./labels2.php'),(20805619,315,'./labels2.php'),(20805618,306,'./labels2.php'),(20685011,3070,'./labels.php'),(20685010,1997,'./labels.php'),(20685009,2069,'./labels.php'),(20685008,1750,'./labels.php'),(20685007,1727,'./labels.php'),(20685006,669,'./labels.php'),(20685005,309,'./labels.php'),(20725859,11747,'./jobvariancerptdetail.php'),(20725858,3090,'./jobvariancerptdetail.php'),(20725857,2998,'./jobvariancerptdetail.php'),(20725856,15577,'./jobvariancerptdetail.php'),(20725855,10332,'./jobvariancerptdetail.php'),(20725854,2508,'./jobvariancerptdetail.php'),(20725853,2404,'./jobvariancerptdetail.php'),(20725852,10137,'./jobvariancerptdetail.php'),(20725851,11746,'./jobvariancerptdetail.php'),(20725850,11745,'./jobvariancerptdetail.php'),(20725849,10328,'./jobvariancerptdetail.php'),(20725848,5081,'./jobvariancerptdetail.php'),(20725847,4106,'./jobvariancerptdetail.php'),(20725846,8936,'./jobvariancerptdetail.php'),(20725845,4065,'./jobvariancerptdetail.php'),(20725844,737,'./jobvariancerptdetail.php'),(20725843,10326,'./jobvariancerptdetail.php'),(20725842,13861,'./jobvariancerptdetail.php'),(20725841,315,'./jobvariancerptdetail.php'),(20725840,10325,'./jobvariancerptdetail.php'),(20725839,11744,'./jobvariancerptdetail.php'),(20725838,20,'./jobvariancerptdetail.php'),(20725837,10333,'./jobvariancerpt.php'),(20725836,3090,'./jobvariancerpt.php'),(20725835,11751,'./jobvariancerpt.php'),(20725834,15576,'./jobvariancerpt.php'),(20725833,10332,'./jobvariancerpt.php'),(20725832,10331,'./jobvariancerpt.php'),(20725831,10330,'./jobvariancerpt.php'),(20725830,1963,'./jobvariancerpt.php'),(20725829,10329,'./jobvariancerpt.php'),(20725828,10328,'./jobvariancerpt.php'),(20725827,10327,'./jobvariancerpt.php'),(20725826,9622,'./jobvariancerpt.php'),(20725825,5081,'./jobvariancerpt.php'),(20725824,1578,'./jobvariancerpt.php'),(20725823,11750,'./jobvariancerpt.php'),(20725822,8936,'./jobvariancerpt.php'),(20725821,10326,'./jobvariancerpt.php'),(20725820,11749,'./jobvariancerpt.php'),(20725819,11748,'./jobvariancerpt.php'),(20725818,11682,'./jobvariancerpt.php'),(20725817,3548,'./jobvariancerpt.php'),(20725816,315,'./jobvariancerpt.php'),(20725815,10325,'./jobvariancerpt.php'),(20725814,10324,'./jobvariancerpt.php'),(20725813,185,'./jobvariancerpt.php'),(20805617,3432,'./jobupd.php'),(20805616,3319,'./jobupd.php'),(20805615,15854,'./jobupd.php'),(20805614,19244,'./jobupd.php'),(20805613,9617,'./jobupd.php'),(20805612,3202,'./jobupd.php'),(20805611,3225,'./jobupd.php'),(20805610,19288,'./jobupd.php'),(20805609,15575,'./jobupd.php'),(20805608,3005,'./jobupd.php'),(20805607,2948,'./jobupd.php'),(20805606,2936,'./jobupd.php'),(20805605,4733,'./jobupd.php'),(20805604,9718,'./jobupd.php'),(20805603,9966,'./jobupd.php'),(20805602,15874,'./jobupd.php'),(20805601,2710,'./jobupd.php'),(20805600,2702,'./jobupd.php'),(20805599,19448,'./jobupd.php'),(20805598,9965,'./jobupd.php'),(20805597,9964,'./jobupd.php'),(20805596,9963,'./jobupd.php'),(20805595,17762,'./jobupd.php'),(20805594,15574,'./jobupd.php'),(20805593,9962,'./jobupd.php'),(20805592,10638,'./jobupd.php'),(20805591,9717,'./jobupd.php'),(20805590,17166,'./jobupd.php'),(20805589,17165,'./jobupd.php'),(20805588,16358,'./jobupd.php'),(20805587,15768,'./jobupd.php'),(20805586,15573,'./jobupd.php'),(20805585,2324,'./jobupd.php'),(20805584,15918,'./jobupd.php'),(20805583,9877,'./jobupd.php'),(20805582,16072,'./jobupd.php'),(20805581,15917,'./jobupd.php'),(20805580,15572,'./jobupd.php'),(20805579,15571,'./jobupd.php'),(20805578,15847,'./jobupd.php'),(20805577,9876,'./jobupd.php'),(20805576,16357,'./jobupd.php'),(20805575,16356,'./jobupd.php'),(20805574,18874,'./jobupd.php'),(20805573,19509,'./jobupd.php'),(20805572,5061,'./jobupd.php'),(20805571,15797,'./jobupd.php'),(20805570,1743,'./jobupd.php'),(20805569,15570,'./jobupd.php'),(20805568,1742,'./jobupd.php'),(20805567,9878,'./jobupd.php'),(20805566,9622,'./jobupd.php'),(20805565,16355,'./jobupd.php'),(20805564,15877,'./jobupd.php'),(20805563,15876,'./jobupd.php'),(20805562,1659,'./jobupd.php'),(20805561,1476,'./jobupd.php'),(20805560,19590,'./jobupd.php'),(20805559,15049,'./jobupd.php'),(20805558,17761,'./jobupd.php'),(20805557,8936,'./jobupd.php'),(20805556,981,'./jobupd.php'),(20805555,6923,'./jobupd.php'),(20805554,941,'./jobupd.php'),(20805553,9959,'./jobupd.php'),(20805552,15569,'./jobupd.php'),(20805551,799,'./jobupd.php'),(20805550,17760,'./jobupd.php'),(20805549,17759,'./jobupd.php'),(20805548,17758,'./jobupd.php'),(20805547,798,'./jobupd.php'),(20805546,4973,'./jobupd.php'),(20805545,20151,'./jobupd.php'),(20805544,15916,'./jobupd.php'),(20805543,4481,'./jobupd.php'),(20805542,6228,'./jobupd.php'),(20805541,697,'./jobupd.php'),(20805540,675,'./jobupd.php'),(20805539,17284,'./jobupd.php'),(20805538,5403,'./jobupd.php'),(20805537,15349,'./jobupd.php'),(20805536,659,'./jobupd.php'),(20805535,10056,'./jobupd.php'),(20805534,17757,'./jobupd.php'),(20805533,17756,'./jobupd.php'),(20805532,15915,'./jobupd.php'),(20805531,11356,'./jobupd.php'),(20805530,607,'./jobupd.php'),(20805491,10077,'./jobpocopy.php'),(20805490,10091,'./jobpocopy.php'),(20805489,9998,'./jobpocopy.php'),(20805488,10090,'./jobpocopy.php'),(20805487,1963,'./jobpocopy.php'),(20805486,10089,'./jobpocopy.php'),(20805485,10088,'./jobpocopy.php'),(20805484,10087,'./jobpocopy.php'),(20805483,10086,'./jobpocopy.php'),(20805482,10085,'./jobpocopy.php'),(20805481,542,'./jobpocopy.php'),(20805480,315,'./jobpocopy.php'),(20805396,10077,'./jobbudgetupd.php'),(20805395,10002,'./jobbudgetupd.php'),(20805394,3202,'./jobbudgetupd.php'),(20805393,3225,'./jobbudgetupd.php'),(20805392,2948,'./jobbudgetupd.php'),(20805391,10084,'./jobbudgetupd.php'),(20805390,2710,'./jobbudgetupd.php'),(20805389,2702,'./jobbudgetupd.php'),(20805388,11757,'./jobbudgetupd.php'),(20805387,11756,'./jobbudgetupd.php'),(20805386,10001,'./jobbudgetupd.php'),(20805385,9878,'./jobbudgetupd.php'),(20805384,9622,'./jobbudgetupd.php'),(20805383,10000,'./jobbudgetupd.php'),(20805382,10076,'./jobbudgetupd.php'),(20805381,5081,'./jobbudgetupd.php'),(20805380,1578,'./jobbudgetupd.php'),(20805379,9999,'./jobbudgetupd.php'),(20805378,10083,'./jobbudgetupd.php'),(20805377,10082,'./jobbudgetupd.php'),(20805376,941,'./jobbudgetupd.php'),(20805375,869,'./jobbudgetupd.php'),(20805374,10081,'./jobbudgetupd.php'),(20805373,799,'./jobbudgetupd.php'),(20805372,737,'./jobbudgetupd.php'),(20805371,9492,'./jobbudgetupd.php'),(20805370,9621,'./jobbudgetupd.php'),(20805369,451,'./jobbudgetupd.php'),(20805368,10080,'./jobbudgetupd.php'),(20805367,315,'./jobbudgetupd.php'),(20805366,11755,'./jobbudgetupd.php'),(20805365,5095,'./jobbudgetupd.php'),(20805364,10079,'./jobbudgetupd.php'),(20805363,226,'./jobbudgetupd.php'),(20805362,10078,'./jobbudgetupd.php'),(20805361,59,'./jobbudgetupd.php'),(20684700,3090,'./jobbudgetrpt.php'),(20684699,9718,'./jobbudgetrpt.php'),(20684698,9965,'./jobbudgetrpt.php'),(20684697,9717,'./jobbudgetrpt.php'),(20684696,1963,'./jobbudgetrpt.php'),(20684695,9622,'./jobbudgetrpt.php'),(20684694,10241,'./jobbudgetrpt.php'),(20684693,10076,'./jobbudgetrpt.php'),(20684692,5081,'./jobbudgetrpt.php'),(20684691,1578,'./jobbudgetrpt.php'),(20684690,10238,'./jobbudgetrpt.php'),(20684689,869,'./jobbudgetrpt.php'),(20684688,737,'./jobbudgetrpt.php'),(20684687,9492,'./jobbudgetrpt.php'),(20684686,451,'./jobbudgetrpt.php'),(20684685,5439,'./jobbudgetrpt.php'),(20684684,315,'./jobbudgetrpt.php'),(20684683,226,'./jobbudgetrpt.php'),(20684682,185,'./jobbudgetrpt.php'),(20805360,10077,'./jobbudgetadd.php'),(20805359,2702,'./jobbudgetadd.php'),(20805358,9998,'./jobbudgetadd.php'),(20805357,9875,'./jobbudgetadd.php'),(20805356,9978,'./jobbudgetadd.php'),(20805355,9997,'./jobbudgetadd.php'),(20805354,9996,'./jobbudgetadd.php'),(20805353,9995,'./jobbudgetadd.php'),(20805352,10076,'./jobbudgetadd.php'),(20805351,5081,'./jobbudgetadd.php'),(20805350,869,'./jobbudgetadd.php'),(20805349,9621,'./jobbudgetadd.php'),(20805348,542,'./jobbudgetadd.php'),(20805347,451,'./jobbudgetadd.php'),(20805346,10075,'./jobbudgetadd.php'),(20805345,315,'./jobbudgetadd.php'),(20805344,226,'./jobbudgetadd.php'),(20805343,5503,'./jobbudgetadd.php'),(20805342,59,'./jobbudgetadd.php'),(20805341,1963,'./item_pod_picker.php'),(20805340,5180,'./item_pod_picker.php'),(20805339,315,'./item_pod_picker.php'),(20805338,2886,'./item_picker.php'),(20805337,2861,'./item_picker.php'),(20805336,12778,'./item_picker.php'),(20805335,2509,'./item_picker.php'),(20805334,4285,'./item_picker.php'),(20805333,12777,'./item_picker.php'),(20805332,1963,'./item_picker.php'),(20805331,1776,'./item_picker.php'),(20805330,869,'./item_picker.php'),(20805329,315,'./item_picker.php'),(20805328,3252,'./invtransferrpt.php'),(20805327,3165,'./invtransferrpt.php'),(20805326,6965,'./invtransferrpt.php'),(20805325,3097,'./invtransferrpt.php'),(20805324,3072,'./invtransferrpt.php'),(20805323,2529,'./invtransferrpt.php'),(20805322,13464,'./invtransferrpt.php'),(20805321,13463,'./invtransferrpt.php'),(20805320,1963,'./invtransferrpt.php'),(20805319,1788,'./invtransferrpt.php'),(20805318,13406,'./invtransferrpt.php'),(20805317,6366,'./invtransferrpt.php'),(20805316,1724,'./invtransferrpt.php'),(20805315,1696,'./invtransferrpt.php'),(20805314,1647,'./invtransferrpt.php'),(20805313,13462,'./invtransferrpt.php'),(20805312,1467,'./invtransferrpt.php'),(20805311,8936,'./invtransferrpt.php'),(20805310,1014,'./invtransferrpt.php'),(20805309,869,'./invtransferrpt.php'),(20805308,616,'./invtransferrpt.php'),(20805307,333,'./invtransferrpt.php'),(20806080,16699,'./nporder.php'),(20806079,9133,'./nporder.php'),(20806078,3502,'./nporder.php'),(20815253,3414,'./includes/tamg.php'),(20815252,15261,'./includes/tamg.php'),(20815251,3274,'./includes/tamg.php'),(20815250,3252,'./includes/tamg.php'),(20811640,10615,'./includes/arfunctions.php'),(20811639,15349,'./includes/arfunctions.php'),(20806497,2165,'./npordersave.php'),(20806496,19792,'./npordersave.php'),(20806495,2103,'./npordersave.php'),(20806494,3990,'./npordersave.php'),(20806493,3706,'./npordersave.php'),(20806492,1770,'./npordersave.php'),(20806491,1743,'./npordersave.php'),(20806490,9622,'./npordersave.php'),(20806077,4070,'./nporder.php'),(20806076,2199,'./nporder.php'),(20805306,3292,'./invpricelistpdf.php'),(20805305,3072,'./invpricelistpdf.php'),(20805304,2901,'./invpricelistpdf.php'),(20805303,14020,'./invpricelistpdf.php'),(20805302,14019,'./invpricelistpdf.php'),(20805301,14018,'./invpricelistpdf.php'),(20805300,14017,'./invpricelistpdf.php'),(20805299,14016,'./invpricelistpdf.php'),(20805298,2459,'./invpricelistpdf.php'),(20805297,2415,'./invpricelistpdf.php'),(20805296,2405,'./invpricelistpdf.php'),(20805295,2160,'./invpricelistpdf.php'),(20805294,2099,'./invpricelistpdf.php'),(20805293,14015,'./invpricelistpdf.php'),(20805292,14014,'./invpricelistpdf.php'),(20805291,1709,'./invpricelistpdf.php'),(20805290,1647,'./invpricelistpdf.php'),(20805289,14013,'./invpricelistpdf.php'),(20805288,14012,'./invpricelistpdf.php'),(20805287,8936,'./invpricelistpdf.php'),(20805286,14011,'./invpricelistpdf.php'),(20805285,14010,'./invpricelistpdf.php'),(20805284,869,'./invpricelistpdf.php'),(20805283,4481,'./invpricelistpdf.php'),(20805282,12150,'./invpricelistpdf.php'),(20805281,451,'./invpricelistpdf.php'),(20805280,197,'./invpricelistpdf.php'),(20805279,3427,'./invpoviewfpdf.php'),(20805278,3360,'./invpoviewfpdf.php'),(20805277,3274,'./invpoviewfpdf.php'),(20805276,3172,'./invpoviewfpdf.php'),(20805275,3090,'./invpoviewfpdf.php'),(20805274,3035,'./invpoviewfpdf.php'),(20805273,5581,'./invpoviewfpdf.php'),(20805272,5723,'./invpoviewfpdf.php'),(20805271,2819,'./invpoviewfpdf.php'),(20805270,2816,'./invpoviewfpdf.php'),(20805269,5121,'./invpoviewfpdf.php'),(20805268,15321,'./invpoviewfpdf.php'),(20805267,2508,'./invpoviewfpdf.php'),(20805266,15005,'./invpoviewfpdf.php'),(20805265,2501,'./invpoviewfpdf.php'),(20805264,5722,'./invpoviewfpdf.php'),(20805263,2363,'./invpoviewfpdf.php'),(20805262,4979,'./invpoviewfpdf.php'),(20805261,2361,'./invpoviewfpdf.php'),(20805260,2324,'./invpoviewfpdf.php'),(20805259,2222,'./invpoviewfpdf.php'),(20805258,6234,'./invpoviewfpdf.php'),(20805257,5721,'./invpoviewfpdf.php'),(20805256,7800,'./invpoviewfpdf.php'),(20805255,1446,'./invpoviewfpdf.php'),(20805254,1373,'./invpoviewfpdf.php'),(20805253,5580,'./invpoviewfpdf.php'),(20805252,869,'./invpoviewfpdf.php'),(20805251,737,'./invpoviewfpdf.php'),(20805250,719,'./invpoviewfpdf.php'),(20805249,5720,'./invpoviewfpdf.php'),(20805248,5403,'./invpoviewfpdf.php'),(20805247,5459,'./invpoviewfpdf.php'),(20805246,542,'./invpoviewfpdf.php'),(20805245,5719,'./invpoviewfpdf.php'),(20805244,306,'./invpoviewfpdf.php'),(20684563,3274,'./invpoview.php'),(20684562,3111,'./invpoview.php'),(20684561,2529,'./invpoview.php'),(20684560,2502,'./invpoview.php'),(20684559,2404,'./invpoview.php'),(20684558,2363,'./invpoview.php'),(20684557,2182,'./invpoview.php'),(20684556,2199,'./invpoview.php'),(20684555,1774,'./invpoview.php'),(20684554,1770,'./invpoview.php'),(20684553,1709,'./invpoview.php'),(20684552,1660,'./invpoview.php'),(20684551,1357,'./invpoview.php'),(20684550,931,'./invpoview.php'),(20684549,869,'./invpoview.php'),(20805242,18783,'./invpoupd.php'),(20805241,18967,'./invpoupd.php'),(20805240,3421,'./invpoupd.php'),(20805239,3360,'./invpoupd.php'),(20805238,3297,'./invpoupd.php'),(20805237,3292,'./invpoupd.php'),(20805236,13934,'./invpoupd.php'),(20805235,3274,'./invpoupd.php'),(20805234,3212,'./invpoupd.php'),(20805233,3211,'./invpoupd.php'),(20805232,3090,'./invpoupd.php'),(20805231,2960,'./invpoupd.php'),(20805230,16676,'./invpoupd.php'),(20805229,2948,'./invpoupd.php'),(20805228,2838,'./invpoupd.php'),(20805227,20145,'./invpoupd.php'),(20805226,20144,'./invpoupd.php'),(20805225,20182,'./invpoupd.php'),(20805224,20142,'./invpoupd.php'),(20805223,2751,'./invpoupd.php'),(20805222,8189,'./invpoupd.php'),(20805221,2702,'./invpoupd.php'),(20805220,14962,'./invpoupd.php'),(20805219,2620,'./invpoupd.php'),(20805218,13616,'./invpoupd.php'),(20805217,2601,'./invpoupd.php'),(20805216,14961,'./invpoupd.php'),(20805215,2588,'./invpoupd.php'),(20805214,2589,'./invpoupd.php'),(20805213,14913,'./invpoupd.php'),(20805212,2529,'./invpoupd.php'),(20805211,5120,'./invpoupd.php'),(20805210,14972,'./invpoupd.php'),(20805209,5119,'./invpoupd.php'),(20805208,5167,'./invpoupd.php'),(20805207,2508,'./invpoupd.php'),(20805206,18761,'./invpoupd.php'),(20805205,7028,'./invpoupd.php'),(20805204,2503,'./invpoupd.php'),(20805203,15014,'./invpoupd.php'),(20805202,15013,'./invpoupd.php'),(20805201,2501,'./invpoupd.php'),(20805200,2482,'./invpoupd.php'),(20805199,18784,'./invpoupd.php'),(20805198,11734,'./invpoupd.php'),(20805197,2459,'./invpoupd.php'),(20805196,13933,'./invpoupd.php'),(20805195,2404,'./invpoupd.php'),(20805194,8755,'./invpoupd.php'),(20805193,2366,'./invpoupd.php'),(20805192,19698,'./invpoupd.php'),(20805191,2363,'./invpoupd.php'),(20805190,19694,'./invpoupd.php'),(20805189,12821,'./invpoupd.php'),(20805188,2361,'./invpoupd.php'),(20805187,2292,'./invpoupd.php'),(20805186,16671,'./invpoupd.php'),(20805185,2182,'./invpoupd.php'),(20805184,2025,'./invpoupd.php'),(20805183,1997,'./invpoupd.php'),(20805182,14575,'./invpoupd.php'),(20805181,2103,'./invpoupd.php'),(20805180,16674,'./invpoupd.php'),(20805179,1973,'./invpoupd.php'),(20805178,1963,'./invpoupd.php'),(20805177,12089,'./invpoupd.php'),(20805176,4017,'./invpoupd.php'),(20805175,1788,'./invpoupd.php'),(20805174,1770,'./invpoupd.php'),(20805173,1750,'./invpoupd.php'),(20805172,20141,'./invpoupd.php'),(20805171,5081,'./invpoupd.php'),(20805170,1724,'./invpoupd.php'),(20805169,1696,'./invpoupd.php'),(20805168,1662,'./invpoupd.php'),(20805167,1644,'./invpoupd.php'),(20805166,18758,'./invpoupd.php'),(20805165,8006,'./invpoupd.php'),(20805164,15991,'./invpoupd.php'),(20805163,7026,'./invpoupd.php'),(20805162,1499,'./invpoupd.php'),(20805161,20140,'./invpoupd.php'),(20805160,1276,'./invpoupd.php'),(20805159,8936,'./invpoupd.php'),(20805158,1173,'./invpoupd.php'),(20805157,1047,'./invpoupd.php'),(20805156,981,'./invpoupd.php'),(20805127,3274,'./invpotocc.php'),(20805126,8776,'./invpotocc.php'),(20805125,8775,'./invpotocc.php'),(20805124,18869,'./invpotocc.php'),(20805123,8774,'./invpotocc.php'),(20805122,2504,'./invpotocc.php'),(20805121,8651,'./invpotocc.php'),(20805120,8650,'./invpotocc.php'),(20805119,8649,'./invpotocc.php'),(20805118,8773,'./invpotocc.php'),(20805117,5787,'./invpotocc.php'),(20805116,8772,'./invpotocc.php'),(20805115,8771,'./invpotocc.php'),(20805114,2094,'./invpotocc.php'),(20805113,8641,'./invpotocc.php'),(20805112,1963,'./invpotocc.php'),(20805111,6633,'./invpotocc.php'),(20805110,3994,'./invpotocc.php'),(20805109,673,'./invpotocc.php'),(20805108,8770,'./invpotocc.php'),(20805103,8701,'./invpotoapai.php'),(20805102,3090,'./invpotoapai.php'),(20805101,2948,'./invpotoapai.php'),(20805100,2702,'./invpotoapai.php'),(20805099,15835,'./invpotoapai.php'),(20805098,2589,'./invpotoapai.php'),(20805097,15834,'./invpotoapai.php'),(20805096,2508,'./invpotoapai.php'),(20805095,2451,'./invpotoapai.php'),(20805094,15833,'./invpotoapai.php'),(20805093,2363,'./invpotoapai.php'),(20805092,2361,'./invpotoapai.php'),(20805091,2165,'./invpotoapai.php'),(20805090,15832,'./invpotoapai.php'),(20805089,15831,'./invpotoapai.php'),(20805088,2094,'./invpotoapai.php'),(20805087,1963,'./invpotoapai.php'),(20805086,15830,'./invpotoapai.php'),(20805085,15829,'./invpotoapai.php'),(20805084,15828,'./invpotoapai.php'),(20805083,1696,'./invpotoapai.php'),(20805082,14208,'./invpotoapai.php'),(20805081,1678,'./invpotoapai.php'),(20805080,1672,'./invpotoapai.php'),(20805079,1668,'./invpotoapai.php'),(20805078,1599,'./invpotoapai.php'),(20805077,4106,'./invpotoapai.php'),(20805076,1463,'./invpotoapai.php'),(20805075,13461,'./invpotoapai.php'),(20805074,1308,'./invpotoapai.php'),(20805073,1293,'./invpotoapai.php'),(20805072,1284,'./invpotoapai.php'),(20805071,8936,'./invpotoapai.php'),(20805070,1083,'./invpotoapai.php'),(20805069,1081,'./invpotoapai.php'),(20805068,1054,'./invpotoapai.php'),(20805067,932,'./invpotoapai.php'),(20805066,15827,'./invpotoapai.php'),(20805065,12733,'./invpotoapai.php'),(20805064,315,'./invpotoapai.php'),(20805063,15826,'./invpotoapai.php'),(20805062,15773,'./invpotoapai.php'),(20805061,16877,'./invpotoap.php'),(20805060,12831,'./invpotoap.php'),(20805059,3292,'./invpotoap.php'),(20805058,3279,'./invpotoap.php'),(20805057,20150,'./invpotoap.php'),(20805056,20149,'./invpotoap.php'),(20805055,3274,'./invpotoap.php'),(20805054,9125,'./invpotoap.php'),(20805053,8701,'./invpotoap.php'),(20805052,3110,'./invpotoap.php'),(20805051,3090,'./invpotoap.php'),(20805050,3035,'./invpotoap.php'),(20805049,2998,'./invpotoap.php'),(20805048,20077,'./invpotoap.php'),(20805047,20076,'./invpotoap.php'),(20805046,11445,'./invpotoap.php'),(20805045,18868,'./invpotoap.php'),(20805044,19697,'./invpotoap.php'),(20805043,19696,'./invpotoap.php'),(20805042,19695,'./invpotoap.php'),(20805041,2873,'./invpotoap.php'),(20805040,2719,'./invpotoap.php'),(20805039,2702,'./invpotoap.php'),(20805038,2686,'./invpotoap.php'),(20805037,2589,'./invpotoap.php'),(20805036,16875,'./invpotoap.php'),(20805035,2508,'./invpotoap.php'),(20805034,2459,'./invpotoap.php'),(20805033,2451,'./invpotoap.php'),(20805032,2390,'./invpotoap.php'),(20805031,2363,'./invpotoap.php'),(20805030,5787,'./invpotoap.php'),(20805029,2361,'./invpotoap.php'),(20805028,5366,'./invpotoap.php'),(20805027,2258,'./invpotoap.php'),(20805026,2064,'./invpotoap.php'),(20805025,2043,'./invpotoap.php'),(20805024,6056,'./invpotoap.php'),(20805023,12077,'./invpotoap.php'),(20805022,2012,'./invpotoap.php'),(20805021,1963,'./invpotoap.php'),(20805020,18867,'./invpotoap.php'),(20805019,1788,'./invpotoap.php'),(20805018,18866,'./invpotoap.php'),(20805017,1696,'./invpotoap.php'),(20805016,1678,'./invpotoap.php'),(20805015,1672,'./invpotoap.php'),(20805014,1670,'./invpotoap.php'),(20805013,1668,'./invpotoap.php'),(20805012,17256,'./invpotoap.php'),(20805011,1599,'./invpotoap.php'),(20805010,7448,'./invpotoap.php'),(20805009,17593,'./invpotoap.php'),(20805008,20148,'./invpotoap.php'),(20805007,15991,'./invpotoap.php'),(20805006,1499,'./invpotoap.php'),(20805005,14570,'./invpotoap.php'),(20805004,1463,'./invpotoap.php'),(20805003,18685,'./invpotoap.php'),(20804972,3274,'./invporeturn.php'),(20804971,3090,'./invporeturn.php'),(20804970,2702,'./invporeturn.php'),(20804969,16695,'./invporeturn.php'),(20804968,13405,'./invporeturn.php'),(20804967,13404,'./invporeturn.php'),(20804966,13403,'./invporeturn.php'),(20804965,13402,'./invporeturn.php'),(20804964,2628,'./invporeturn.php'),(20804963,6825,'./invporeturn.php'),(20804962,13401,'./invporeturn.php'),(20804961,2588,'./invporeturn.php'),(20804960,13400,'./invporeturn.php'),(20804959,3522,'./invporeturn.php'),(20804958,13399,'./invporeturn.php'),(20804957,5119,'./invporeturn.php'),(20804956,6227,'./invporeturn.php'),(20804955,2482,'./invporeturn.php'),(20804954,2459,'./invporeturn.php'),(20804953,13398,'./invporeturn.php'),(20804952,2363,'./invporeturn.php'),(20804951,12821,'./invporeturn.php'),(20804950,13397,'./invporeturn.php'),(20804949,19260,'./invporeturn.php'),(20804948,4023,'./invporeturn.php'),(20804947,13396,'./invporeturn.php'),(20804946,13395,'./invporeturn.php'),(20804945,2070,'./invporeturn.php'),(20804944,1963,'./invporeturn.php'),(20804943,1659,'./invporeturn.php'),(20804942,19259,'./invporeturn.php'),(20804941,8936,'./invporeturn.php'),(20804940,981,'./invporeturn.php'),(20804939,961,'./invporeturn.php'),(20804938,941,'./invporeturn.php'),(20684237,7447,'./invporecv_detail.php'),(20684236,2702,'./invporecv_detail.php'),(20684235,7446,'./invporecv_detail.php'),(20684234,7445,'./invporecv_detail.php'),(20684233,6227,'./invporecv_detail.php'),(20684232,7444,'./invporecv_detail.php'),(20684231,1781,'./invporecv_detail.php'),(20684230,799,'./invporecv_detail.php'),(20684229,542,'./invporecv_detail.php'),(20684228,85,'./invporecv_detail.php'),(20804931,3297,'./invporecv.php'),(20804930,3292,'./invporecv.php'),(20804929,3274,'./invporecv.php'),(20804928,3165,'./invporecv.php'),(20804927,9100,'./invporecv.php'),(20804926,5179,'./invporecv.php'),(20804925,3072,'./invporecv.php'),(20804924,2950,'./invporecv.php'),(20804923,2838,'./invporecv.php'),(20804922,2621,'./invporecv.php'),(20804921,2620,'./invporecv.php'),(20804920,2601,'./invporecv.php'),(20804919,18683,'./invporecv.php'),(20804918,2588,'./invporecv.php'),(20804917,3792,'./invporecv.php'),(20804916,2589,'./invporecv.php'),(20804915,14913,'./invporecv.php'),(20804914,2529,'./invporecv.php'),(20804913,18761,'./invporecv.php'),(20804912,2503,'./invporecv.php'),(20804911,18784,'./invporecv.php'),(20804910,11734,'./invporecv.php'),(20804909,2404,'./invporecv.php'),(20804908,2403,'./invporecv.php'),(20804907,18864,'./invporecv.php'),(20804906,2365,'./invporecv.php'),(20804905,8996,'./invporecv.php'),(20804904,2364,'./invporecv.php'),(20804903,2363,'./invporecv.php'),(20804902,18682,'./invporecv.php'),(20804901,5178,'./invporecv.php'),(20804900,2361,'./invporecv.php'),(20804899,14105,'./invporecv.php'),(20804898,7034,'./invporecv.php'),(20804897,2185,'./invporecv.php'),(20804896,2182,'./invporecv.php'),(20804895,2199,'./invporecv.php'),(20804894,4608,'./invporecv.php'),(20804893,2027,'./invporecv.php'),(20804892,2012,'./invporecv.php'),(20804891,7033,'./invporecv.php'),(20804890,1963,'./invporecv.php'),(20804889,18006,'./invporecv.php'),(20804888,6130,'./invporecv.php'),(20804887,1796,'./invporecv.php'),(20804886,18005,'./invporecv.php'),(20804885,1788,'./invporecv.php'),(20804884,12196,'./invporecv.php'),(20804861,13934,'./invpopricehistory.php'),(20804860,2508,'./invpopricehistory.php'),(20804859,2404,'./invpopricehistory.php'),(20804858,2361,'./invpopricehistory.php'),(20804857,13938,'./invpopricehistory.php'),(20804856,13937,'./invpopricehistory.php'),(20804855,9000,'./invpopricehistory.php'),(20804854,8936,'./invpopricehistory.php'),(20804853,13936,'./invpopricehistory.php'),(20804852,737,'./invpopricehistory.php'),(20804851,13935,'./invpopricehistory.php'),(20804850,3414,'./invpolist.php'),(20804849,3292,'./invpolist.php'),(20804848,3274,'./invpolist.php'),(20804847,3118,'./invpolist.php'),(20804846,2870,'./invpolist.php'),(20804845,15009,'./invpolist.php'),(20804844,2866,'./invpolist.php'),(20804843,2838,'./invpolist.php'),(20804842,7032,'./invpolist.php'),(20804841,2620,'./invpolist.php'),(20804840,6139,'./invpolist.php'),(20804839,2601,'./invpolist.php'),(20804838,2596,'./invpolist.php'),(20804837,3522,'./invpolist.php'),(20804836,2508,'./invpolist.php'),(20804835,15008,'./invpolist.php'),(20804834,9824,'./invpolist.php'),(20804833,12825,'./invpolist.php'),(20804832,2459,'./invpolist.php'),(20804831,2363,'./invpolist.php'),(20804830,3745,'./invpolist.php'),(20804829,12821,'./invpolist.php'),(20804828,2361,'./invpolist.php'),(20804827,7031,'./invpolist.php'),(20804826,2182,'./invpolist.php'),(20804825,6138,'./invpolist.php'),(20804824,2026,'./invpolist.php'),(20804823,2027,'./invpolist.php'),(20804822,1963,'./invpolist.php'),(20804821,1933,'./invpolist.php'),(20804820,1788,'./invpolist.php'),(20804819,1780,'./invpolist.php'),(20804818,5081,'./invpolist.php'),(20804817,6366,'./invpolist.php'),(20804816,1724,'./invpolist.php'),(20804815,1713,'./invpolist.php'),(20804814,1709,'./invpolist.php'),(20804813,1696,'./invpolist.php'),(20804812,1658,'./invpolist.php'),(20804811,8936,'./invpolist.php'),(20804810,941,'./invpolist.php'),(20804809,932,'./invpolist.php'),(20804808,591,'./invpolist.php'),(20804807,542,'./invpolist.php'),(20804806,441,'./invpolist.php'),(20804805,325,'./invpolist.php'),(20804804,315,'./invpolist.php'),(20804803,3427,'./invpochecklistfpdf.php'),(20804802,3274,'./invpochecklistfpdf.php'),(20804801,3035,'./invpochecklistfpdf.php'),(20804800,5581,'./invpochecklistfpdf.php'),(20804799,5723,'./invpochecklistfpdf.php'),(20804798,2819,'./invpochecklistfpdf.php'),(20804797,20146,'./invpochecklistfpdf.php'),(20804796,2589,'./invpochecklistfpdf.php'),(20804795,15007,'./invpochecklistfpdf.php'),(20804794,2363,'./invpochecklistfpdf.php'),(20804793,4979,'./invpochecklistfpdf.php'),(20804792,12822,'./invpochecklistfpdf.php'),(20804791,2361,'./invpochecklistfpdf.php'),(20804790,2324,'./invpochecklistfpdf.php'),(20804789,2222,'./invpochecklistfpdf.php'),(20804788,6234,'./invpochecklistfpdf.php'),(20804787,7800,'./invpochecklistfpdf.php'),(20804786,1373,'./invpochecklistfpdf.php'),(20804785,5580,'./invpochecklistfpdf.php'),(20804784,719,'./invpochecklistfpdf.php'),(20804783,5459,'./invpochecklistfpdf.php'),(20804782,542,'./invpochecklistfpdf.php'),(20804781,5719,'./invpochecklistfpdf.php'),(20804780,306,'./invpochecklistfpdf.php'),(20804778,3294,'./invpoauto.php'),(20804777,8996,'./invpoauto.php'),(20804776,15340,'./invpoauto.php'),(20804775,2361,'./invpoauto.php'),(20804774,6887,'./invpoauto.php'),(20804773,15339,'./invpoauto.php'),(20804772,15338,'./invpoauto.php'),(20804771,1285,'./invpoauto.php'),(20804770,1283,'./invpoauto.php'),(20804769,8936,'./invpoauto.php'),(20684064,3297,'./invpoadd_vendoritem.php'),(20684063,2702,'./invpoadd_vendoritem.php'),(20684062,7030,'./invpoadd_vendoritem.php'),(20684061,2502,'./invpoadd_vendoritem.php'),(20684060,2099,'./invpoadd_vendoritem.php'),(20684059,7029,'./invpoadd_vendoritem.php'),(20684058,1047,'./invpoadd_vendoritem.php'),(20684057,542,'./invpoadd_vendoritem.php'),(20805529,15914,'./jobupd.php'),(20805479,3421,'./jobcostrpt.php'),(20805478,16495,'./jobcostrpt.php'),(20805002,13461,'./invpotoap.php'),(20804768,18783,'./invpoadd.php'),(20804767,18967,'./invpoadd.php'),(20804766,3421,'./invpoadd.php'),(20804765,19908,'./invpoadd.php'),(20804764,3360,'./invpoadd.php'),(20804763,3294,'./invpoadd.php'),(20804762,13934,'./invpoadd.php'),(20804761,3274,'./invpoadd.php'),(20804760,3211,'./invpoadd.php'),(20804759,3090,'./invpoadd.php'),(20804758,16906,'./invpoadd.php'),(20804757,2960,'./invpoadd.php'),(20804756,16676,'./invpoadd.php'),(20804755,20145,'./invpoadd.php'),(20804754,20144,'./invpoadd.php'),(20804753,20182,'./invpoadd.php'),(20804752,20142,'./invpoadd.php'),(20804751,2751,'./invpoadd.php'),(20804750,15006,'./invpoadd.php'),(20804749,2702,'./invpoadd.php'),(20804748,8070,'./invpoadd.php'),(20804747,13616,'./invpoadd.php'),(20804746,2588,'./invpoadd.php'),(20804745,2529,'./invpoadd.php'),(20804744,5120,'./invpoadd.php'),(20804743,14972,'./invpoadd.php'),(20804742,5119,'./invpoadd.php'),(20804741,5167,'./invpoadd.php'),(20804740,2508,'./invpoadd.php'),(20804739,7028,'./invpoadd.php'),(20804738,15005,'./invpoadd.php'),(20804737,2500,'./invpoadd.php'),(20804736,2482,'./invpoadd.php'),(20804735,11734,'./invpoadd.php'),(20804734,11732,'./invpoadd.php'),(20804733,2459,'./invpoadd.php'),(20804732,13933,'./invpoadd.php'),(20804731,2404,'./invpoadd.php'),(20804730,8755,'./invpoadd.php'),(20804729,2366,'./invpoadd.php'),(20804728,6055,'./invpoadd.php'),(20804727,2363,'./invpoadd.php'),(20804726,19694,'./invpoadd.php'),(20804725,12821,'./invpoadd.php'),(20804724,2361,'./invpoadd.php'),(20804723,16905,'./invpoadd.php'),(20804722,16671,'./invpoadd.php'),(20804721,2182,'./invpoadd.php'),(20804720,2103,'./invpoadd.php'),(20804719,16674,'./invpoadd.php'),(20804718,1973,'./invpoadd.php'),(20804717,1963,'./invpoadd.php'),(20804716,15004,'./invpoadd.php'),(20804715,3708,'./invpoadd.php'),(20804714,12089,'./invpoadd.php'),(20804713,4017,'./invpoadd.php'),(20804712,1770,'./invpoadd.php'),(20804711,20141,'./invpoadd.php'),(20804710,5081,'./invpoadd.php'),(20804709,1724,'./invpoadd.php'),(20804708,1709,'./invpoadd.php'),(20804707,16904,'./invpoadd.php'),(20804706,1696,'./invpoadd.php'),(20804705,1659,'./invpoadd.php'),(20804704,1644,'./invpoadd.php'),(20804703,18758,'./invpoadd.php'),(20804702,15991,'./invpoadd.php'),(20804701,7026,'./invpoadd.php'),(20804667,12096,'./invordline_addedit.php'),(20804666,3030,'./invordline_addedit.php'),(20804665,2817,'./invordline_addedit.php'),(20804664,2827,'./invordline_addedit.php'),(20804663,2702,'./invordline_addedit.php'),(20804662,2701,'./invordline_addedit.php'),(20804661,2529,'./invordline_addedit.php'),(20804660,6427,'./invordline_addedit.php'),(20804659,2451,'./invordline_addedit.php'),(20804658,2455,'./invordline_addedit.php'),(20804657,2167,'./invordline_addedit.php'),(20804656,6773,'./invordline_addedit.php'),(20804655,5485,'./invordline_addedit.php'),(20804654,1726,'./invordline_addedit.php'),(20804653,5484,'./invordline_addedit.php'),(20804652,1724,'./invordline_addedit.php'),(20804651,1709,'./invordline_addedit.php'),(20804650,18772,'./invordline_addedit.php'),(20804649,1519,'./invordline_addedit.php'),(20804648,941,'./invordline_addedit.php'),(20804647,4602,'./invordline_addedit.php'),(20804646,869,'./invordline_addedit.php'),(20804645,799,'./invordline_addedit.php'),(20804644,641,'./invordline_addedit.php'),(20804643,542,'./invordline_addedit.php'),(20804642,18782,'./invordline_addedit.php'),(20804641,6771,'./invordline_addedit.php'),(20683926,8176,'./invonhand_qtyfix.php'),(20804638,3290,'./invnotifications.php'),(20804637,7024,'./invnotifications.php'),(20804636,2948,'./invnotifications.php'),(20804635,7023,'./invnotifications.php'),(20804634,7022,'./invnotifications.php'),(20804633,7021,'./invnotifications.php'),(20804632,12164,'./invnotifications.php'),(20804631,7020,'./invnotifications.php'),(20804630,2795,'./invnotifications.php'),(20804629,6700,'./invnotifications.php'),(20804628,7019,'./invnotifications.php'),(20804627,7018,'./invnotifications.php'),(20804626,7161,'./invnotifications.php'),(20804625,1963,'./invnotifications.php'),(20804624,6366,'./invnotifications.php'),(20804623,1724,'./invnotifications.php'),(20804622,1713,'./invnotifications.php'),(20804621,1709,'./invnotifications.php'),(20804620,7016,'./invnotifications.php'),(20804619,981,'./invnotifications.php'),(20804618,697,'./invnotifications.php'),(20804617,683,'./invnotifications.php'),(20804616,7015,'./invnotifications.php'),(20804615,7014,'./invnotifications.php'),(20804614,4632,'./invnotifications.php'),(20804613,7013,'./invnotifications.php'),(20804612,315,'./invnotifications.php'),(20804611,197,'./invnotifications.php'),(20804610,8818,'./invmarkupupd.php'),(20804609,13016,'./invmarkupupd.php'),(20804608,13932,'./invmarkupupd.php'),(20804607,2923,'./invmarkupupd.php'),(20804606,2922,'./invmarkupupd.php'),(20804605,2769,'./invmarkupupd.php'),(20804604,2710,'./invmarkupupd.php'),(20804603,2702,'./invmarkupupd.php'),(20804602,13876,'./invmarkupupd.php'),(20804601,13818,'./invmarkupupd.php'),(20804600,2456,'./invmarkupupd.php'),(20804599,2405,'./invmarkupupd.php'),(20804598,2061,'./invmarkupupd.php'),(20804597,13875,'./invmarkupupd.php'),(20804596,13874,'./invmarkupupd.php'),(20804595,13873,'./invmarkupupd.php'),(20804594,13872,'./invmarkupupd.php'),(20804593,13871,'./invmarkupupd.php'),(20804592,13870,'./invmarkupupd.php'),(20804591,13869,'./invmarkupupd.php'),(20804590,13868,'./invmarkupupd.php'),(20804589,1886,'./invmarkupupd.php'),(20804588,1833,'./invmarkupupd.php'),(20804587,1831,'./invmarkupupd.php'),(20804586,1830,'./invmarkupupd.php'),(20804585,1829,'./invmarkupupd.php'),(20804584,1827,'./invmarkupupd.php'),(20804583,1825,'./invmarkupupd.php'),(20804582,1824,'./invmarkupupd.php'),(20804581,1756,'./invmarkupupd.php'),(20804580,1428,'./invmarkupupd.php'),(20804579,1313,'./invmarkupupd.php'),(20804578,1245,'./invmarkupupd.php'),(20804577,1180,'./invmarkupupd.php'),(20804576,1179,'./invmarkupupd.php'),(20804575,941,'./invmarkupupd.php'),(20804574,834,'./invmarkupupd.php'),(20804573,799,'./invmarkupupd.php'),(20804572,647,'./invmarkupupd.php'),(20804571,315,'./invmarkupupd.php'),(20804570,5203,'./invmarkupupd.php'),(20804569,107,'./invmarkupupd.php'),(20804568,59,'./invmarkupupd.php'),(20683854,2922,'./invmarkuplst.php'),(20683853,2456,'./invmarkuplst.php'),(20683852,2061,'./invmarkuplst.php'),(20683851,1831,'./invmarkuplst.php'),(20683850,1827,'./invmarkuplst.php'),(20804567,8818,'./invmarkupadd.php'),(20804566,13016,'./invmarkupadd.php'),(20804565,13932,'./invmarkupadd.php'),(20804564,2921,'./invmarkupadd.php'),(20804563,2920,'./invmarkupadd.php'),(20804562,2702,'./invmarkupadd.php'),(20804561,13876,'./invmarkupadd.php'),(20804560,13818,'./invmarkupadd.php'),(20804559,2405,'./invmarkupadd.php'),(20804558,1963,'./invmarkupadd.php'),(20804557,13875,'./invmarkupadd.php'),(20804556,13874,'./invmarkupadd.php'),(20804555,13873,'./invmarkupadd.php'),(20804554,13872,'./invmarkupadd.php'),(20804553,13871,'./invmarkupadd.php'),(20804552,13870,'./invmarkupadd.php'),(20804551,13869,'./invmarkupadd.php'),(20804550,13868,'./invmarkupadd.php'),(20804549,1886,'./invmarkupadd.php'),(20804548,1832,'./invmarkupadd.php'),(20804547,1831,'./invmarkupadd.php'),(20804546,1825,'./invmarkupadd.php'),(20804545,1824,'./invmarkupadd.php'),(20804544,1756,'./invmarkupadd.php'),(20804543,1428,'./invmarkupadd.php'),(20804542,1120,'./invmarkupadd.php'),(20804541,1098,'./invmarkupadd.php'),(20804540,315,'./invmarkupadd.php'),(20804539,3186,'./invlevelupd.php'),(20804538,2702,'./invlevelupd.php'),(20804537,9381,'./invlevelupd.php'),(20804536,2414,'./invlevelupd.php'),(20804535,2413,'./invlevelupd.php'),(20804534,2412,'./invlevelupd.php'),(20804533,2411,'./invlevelupd.php'),(20804532,2410,'./invlevelupd.php'),(20804531,2409,'./invlevelupd.php'),(20804530,2405,'./invlevelupd.php'),(20804529,2040,'./invlevelupd.php'),(20804528,13272,'./invlevelupd.php'),(20804527,13271,'./invlevelupd.php'),(20804526,13270,'./invlevelupd.php'),(20804525,8936,'./invlevelupd.php'),(20804524,1188,'./invlevelupd.php'),(20804523,941,'./invlevelupd.php'),(20804522,843,'./invlevelupd.php'),(20804521,799,'./invlevelupd.php'),(20804520,315,'./invlevelupd.php'),(20804519,314,'./invlevelupd.php'),(20804518,5203,'./invlevelupd.php'),(20804517,8875,'./invlevelupd.php'),(20804516,108,'./invlevelupd.php'),(20804515,59,'./invlevelupd.php'),(20724709,2412,'./invlevellst.php'),(20724708,2410,'./invlevellst.php'),(20724707,2040,'./invlevellst.php'),(20724706,315,'./invlevellst.php'),(20724705,314,'./invlevellst.php'),(20804514,2702,'./invleveladd.php'),(20804513,2411,'./invleveladd.php'),(20804512,2410,'./invleveladd.php'),(20804511,2408,'./invleveladd.php'),(20804510,2407,'./invleveladd.php'),(20804509,2406,'./invleveladd.php'),(20804508,13272,'./invleveladd.php'),(20804507,13271,'./invleveladd.php'),(20804506,13270,'./invleveladd.php'),(20804505,8936,'./invleveladd.php'),(20804504,1107,'./invleveladd.php'),(20804503,315,'./invleveladd.php'),(20804502,16694,'./invitemvendupd.php'),(20804501,9337,'./invitemvendupd.php'),(20804500,18857,'./invitemvendupd.php'),(20804499,3298,'./invitemvendupd.php'),(20804498,18781,'./invitemvendupd.php'),(20804497,9336,'./invitemvendupd.php'),(20804496,3290,'./invitemvendupd.php'),(20804495,3286,'./invitemvendupd.php'),(20804494,3285,'./invitemvendupd.php'),(20804493,3274,'./invitemvendupd.php'),(20804492,13867,'./invitemvendupd.php'),(20804491,3185,'./invitemvendupd.php'),(20804490,9335,'./invitemvendupd.php'),(20804489,3202,'./invitemvendupd.php'),(20804488,16693,'./invitemvendupd.php'),(20804487,2778,'./invitemvendupd.php'),(20804486,2757,'./invitemvendupd.php'),(20804485,2702,'./invitemvendupd.php'),(20804484,16692,'./invitemvendupd.php'),(20804483,14823,'./invitemvendupd.php'),(20804482,2503,'./invitemvendupd.php'),(20804481,2303,'./invitemvendupd.php'),(20804480,2212,'./invitemvendupd.php'),(20804479,2162,'./invitemvendupd.php'),(20804478,16691,'./invitemvendupd.php'),(20804477,2115,'./invitemvendupd.php'),(20804476,2103,'./invitemvendupd.php'),(20804475,1963,'./invitemvendupd.php'),(20804474,6986,'./invitemvendupd.php'),(20804473,1736,'./invitemvendupd.php'),(20804472,3667,'./invitemvendupd.php'),(20804471,6366,'./invitemvendupd.php'),(20804470,1724,'./invitemvendupd.php'),(20804469,1696,'./invitemvendupd.php'),(20804468,16690,'./invitemvendupd.php'),(20804467,13866,'./invitemvendupd.php'),(20804466,8936,'./invitemvendupd.php'),(20804465,970,'./invitemvendupd.php'),(20804464,966,'./invitemvendupd.php'),(20804463,941,'./invitemvendupd.php'),(20804462,863,'./invitemvendupd.php'),(20804461,799,'./invitemvendupd.php'),(20804460,8010,'./invitemvendupd.php'),(20804459,616,'./invitemvendupd.php'),(20804458,9334,'./invitemvendupd.php'),(20804445,18963,'./invitemupd1.php'),(20804444,8817,'./invitemupd1.php'),(20804443,14912,'./invitemupd1.php'),(20804442,14911,'./invitemupd1.php'),(20804441,3207,'./invitemupd1.php'),(20804440,3202,'./invitemupd1.php'),(20804439,4593,'./invitemupd1.php'),(20804438,2964,'./invitemupd1.php'),(20804437,2948,'./invitemupd1.php'),(20804436,2787,'./invitemupd1.php'),(20804435,2749,'./invitemupd1.php'),(20804434,2726,'./invitemupd1.php'),(20804433,2702,'./invitemupd1.php'),(20804432,2529,'./invitemupd1.php'),(20804431,2515,'./invitemupd1.php'),(20804430,2511,'./invitemupd1.php'),(20804429,2509,'./invitemupd1.php'),(20804428,19427,'./invitemupd1.php'),(20804427,3777,'./invitemupd1.php'),(20804426,11734,'./invitemupd1.php'),(20804425,13306,'./invitemupd1.php'),(20804424,16487,'./invitemupd1.php'),(20804423,4592,'./invitemupd1.php'),(20804422,16872,'./invitemupd1.php'),(20804421,16871,'./invitemupd1.php'),(20804420,16870,'./invitemupd1.php'),(20804419,2405,'./invitemupd1.php'),(20804418,2187,'./invitemupd1.php'),(20804417,2138,'./invitemupd1.php'),(20804416,2006,'./invitemupd1.php'),(20804415,16486,'./invitemupd1.php'),(20804414,1980,'./invitemupd1.php'),(20804413,2101,'./invitemupd1.php'),(20804412,2070,'./invitemupd1.php'),(20804411,1894,'./invitemupd1.php'),(20804410,1885,'./invitemupd1.php'),(20804409,1863,'./invitemupd1.php'),(20804408,1828,'./invitemupd1.php'),(20804407,13269,'./invitemupd1.php'),(20804406,14910,'./invitemupd1.php'),(20804405,8184,'./invitemupd1.php'),(20804404,1789,'./invitemupd1.php'),(20804403,1788,'./invitemupd1.php'),(20804402,19130,'./invitemupd1.php'),(20804401,1753,'./invitemupd1.php'),(20804400,1737,'./invitemupd1.php'),(20804399,1723,'./invitemupd1.php'),(20804398,1721,'./invitemupd1.php'),(20804397,1427,'./invitemupd1.php'),(20804396,8936,'./invitemupd1.php'),(20804395,941,'./invitemupd1.php'),(20804394,898,'./invitemupd1.php'),(20804393,809,'./invitemupd1.php'),(20804392,799,'./invitemupd1.php'),(20804391,646,'./invitemupd1.php'),(20804390,616,'./invitemupd1.php'),(20804389,18464,'./invitemupd1.php'),(20804388,19129,'./invitemupd1.php'),(20804387,542,'./invitemupd1.php'),(20804386,539,'./invitemupd1.php'),(20804369,3421,'./invitemupd.php'),(20804368,3373,'./invitemupd.php'),(20804367,3362,'./invitemupd.php'),(20804366,18014,'./invitemupd.php'),(20804365,3322,'./invitemupd.php'),(20804364,14898,'./invitemupd.php'),(20804363,3274,'./invitemupd.php'),(20804362,14900,'./invitemupd.php'),(20804361,13965,'./invitemupd.php'),(20804360,3239,'./invitemupd.php'),(20804359,3240,'./invitemupd.php'),(20804358,3238,'./invitemupd.php'),(20804357,3235,'./invitemupd.php'),(20804356,3234,'./invitemupd.php'),(20804355,6509,'./invitemupd.php'),(20804354,12764,'./invitemupd.php'),(20804353,7669,'./invitemupd.php'),(20804352,18631,'./invitemupd.php'),(20804351,6371,'./invitemupd.php'),(20804350,18207,'./invitemupd.php'),(20804349,14971,'./invitemupd.php'),(20804348,3056,'./invitemupd.php'),(20804347,15544,'./invitemupd.php'),(20804346,5827,'./invitemupd.php'),(20804345,16676,'./invitemupd.php'),(20804344,13932,'./invitemupd.php'),(20804343,4457,'./invitemupd.php'),(20804342,16475,'./invitemupd.php'),(20804341,7007,'./invitemupd.php'),(20804340,2902,'./invitemupd.php'),(20804339,14970,'./invitemupd.php'),(20804338,2886,'./invitemupd.php'),(20804337,14899,'./invitemupd.php'),(20804336,2849,'./invitemupd.php'),(20804335,7796,'./invitemupd.php'),(20804334,2847,'./invitemupd.php'),(20804333,17390,'./invitemupd.php'),(20804332,15825,'./invitemupd.php'),(20804331,15139,'./invitemupd.php'),(20804330,2749,'./invitemupd.php'),(20804329,2740,'./invitemupd.php'),(20804328,2710,'./invitemupd.php'),(20804327,2702,'./invitemupd.php'),(20804326,2664,'./invitemupd.php'),(20804325,10577,'./invitemupd.php'),(20804324,14009,'./invitemupd.php'),(20804323,18013,'./invitemupd.php'),(20804322,20129,'./invitemupd.php'),(20804321,20128,'./invitemupd.php'),(20804320,16675,'./invitemupd.php'),(20804319,7795,'./invitemupd.php'),(20804318,10989,'./invitemupd.php'),(20804317,5881,'./invitemupd.php'),(20804316,13806,'./invitemupd.php'),(20804315,2520,'./invitemupd.php'),(20804314,2515,'./invitemupd.php'),(20804313,5880,'./invitemupd.php'),(20804312,10100,'./invitemupd.php'),(20804311,17442,'./invitemupd.php'),(20804310,10099,'./invitemupd.php'),(20804309,10098,'./invitemupd.php'),(20804308,11734,'./invitemupd.php'),(20804307,13306,'./invitemupd.php'),(20804306,2453,'./invitemupd.php'),(20804305,15768,'./invitemupd.php'),(20804304,14179,'./invitemupd.php'),(20804303,2367,'./invitemupd.php'),(20804302,19320,'./invitemupd.php'),(20804301,2333,'./invitemupd.php'),(20804300,16869,'./invitemupd.php'),(20804299,13336,'./invitemupd.php'),(20804298,16868,'./invitemupd.php'),(20804297,2320,'./invitemupd.php'),(20804296,16671,'./invitemupd.php'),(20804295,6444,'./invitemupd.php'),(20804294,14781,'./invitemupd.php'),(20804293,18674,'./invitemupd.php'),(20804292,14969,'./invitemupd.php'),(20804291,18096,'./invitemupd.php'),(20804290,15181,'./invitemupd.php'),(20804289,13931,'./invitemupd.php'),(20804288,2103,'./invitemupd.php'),(20804287,16674,'./invitemupd.php'),(20804286,2070,'./invitemupd.php'),(20804285,1973,'./invitemupd.php'),(20804284,1932,'./invitemupd.php'),(20804283,18777,'./invitemupd.php'),(20804282,5909,'./invitemupd.php'),(20804281,5908,'./invitemupd.php'),(20804280,13964,'./invitemupd.php'),(20804279,1888,'./invitemupd.php'),(20804278,1846,'./invitemupd.php'),(20804277,14968,'./invitemupd.php'),(20804276,17010,'./invitemupd.php'),(20804275,15003,'./invitemupd.php'),(20804274,1766,'./invitemupd.php'),(20804273,1765,'./invitemupd.php'),(20804272,15191,'./invitemupd.php'),(20804271,14967,'./invitemupd.php'),(20804270,1737,'./invitemupd.php'),(20804269,1735,'./invitemupd.php'),(20804268,15138,'./invitemupd.php'),(20804267,12975,'./invitemupd.php'),(20804266,6373,'./invitemupd.php'),(20804265,1726,'./invitemupd.php'),(20804264,6366,'./invitemupd.php'),(20804263,1724,'./invitemupd.php'),(20804262,7003,'./invitemupd.php'),(20804261,12974,'./invitemupd.php'),(20804260,5858,'./invitemupd.php'),(20804259,1711,'./invitemupd.php'),(20804258,1709,'./invitemupd.php'),(20804257,1696,'./invitemupd.php'),(20804256,1666,'./invitemupd.php'),(20804255,1664,'./invitemupd.php'),(20804254,18772,'./invitemupd.php'),(20804253,18758,'./invitemupd.php'),(20804252,1607,'./invitemupd.php'),(20804251,15137,'./invitemupd.php'),(20804250,15366,'./invitemupd.php'),(20804249,1598,'./invitemupd.php'),(20804248,1587,'./invitemupd.php'),(20804247,13717,'./invitemupd.php'),(20804246,6079,'./invitemupd.php'),(20804245,18676,'./invitemupd.php'),(20804244,1508,'./invitemupd.php'),(20804243,17752,'./invitemupd.php'),(20804242,14248,'./invitemupd.php'),(20804241,1482,'./invitemupd.php'),(20804240,1476,'./invitemupd.php'),(20804239,15824,'./invitemupd.php'),(20804238,1424,'./invitemupd.php'),(20804237,5072,'./invitemupd.php'),(20804236,14966,'./invitemupd.php'),(20804235,1334,'./invitemupd.php'),(20804234,1333,'./invitemupd.php'),(20804233,1280,'./invitemupd.php'),(20804232,8936,'./invitemupd.php'),(20804231,1047,'./invitemupd.php'),(20804230,1013,'./invitemupd.php'),(20804229,966,'./invitemupd.php'),(20804228,16387,'./invitemupd.php'),(20804227,941,'./invitemupd.php'),(20804226,870,'./invitemupd.php'),(20804225,869,'./invitemupd.php'),(20804224,10103,'./invitemupd.php'),(20804223,10102,'./invitemupd.php'),(20804222,4141,'./invitemupd.php'),(20804221,10101,'./invitemupd.php'),(20804220,4140,'./invitemupd.php'),(20804219,7621,'./invitemupd.php'),(20724365,1,'./invitemtranfieldadd.php'),(20724364,7435,'./invitemtranfieldadd.php'),(20724363,2702,'./invitemtranfieldadd.php'),(20724362,7437,'./invitemtranfieldadd.php'),(20724361,7436,'./invitemtranfieldadd.php'),(20724360,7431,'./invitemtranfieldadd.php'),(20724359,3994,'./invitemtranfieldadd.php'),(20724358,7430,'./invitemtranfieldadd.php'),(20724357,737,'./invitemtranfieldadd.php'),(20724356,7428,'./invitemtranfieldadd.php'),(20724355,315,'./invitemtranfieldadd.php'),(20724354,222,'./invitemtranfieldadd.php'),(20724353,197,'./invitemtranfieldadd.php'),(20724352,176,'./invitemtranfieldadd.php'),(20724351,3225,'./invitemtranfield.php'),(20724350,1,'./invitemtranfield.php'),(20724349,2902,'./invitemtranfield.php'),(20724348,7435,'./invitemtranfield.php'),(20724347,7434,'./invitemtranfield.php'),(20724346,2710,'./invitemtranfield.php'),(20724345,2702,'./invitemtranfield.php'),(20724344,7433,'./invitemtranfield.php'),(20724343,7432,'./invitemtranfield.php'),(20724342,7431,'./invitemtranfield.php'),(20724341,3995,'./invitemtranfield.php'),(20724340,1143,'./invitemtranfield.php'),(20724339,7430,'./invitemtranfield.php'),(20724338,7429,'./invitemtranfield.php'),(20724337,941,'./invitemtranfield.php'),(20724336,864,'./invitemtranfield.php'),(20724335,799,'./invitemtranfield.php'),(20724334,737,'./invitemtranfield.php'),(20724333,7428,'./invitemtranfield.php'),(20724332,315,'./invitemtranfield.php'),(20724331,5203,'./invitemtranfield.php'),(20724330,197,'./invitemtranfield.php'),(20724329,87,'./invitemtranfield.php'),(20724328,59,'./invitemtranfield.php'),(20683414,3437,'./invitemtracker.php'),(20683413,9491,'./invitemtracker.php'),(20683412,9486,'./invitemtracker.php'),(20683411,9477,'./invitemtracker.php'),(20683410,3097,'./invitemtracker.php'),(20683409,9485,'./invitemtracker.php'),(20683408,3439,'./invitemtracker.php'),(20683407,2656,'./invitemtracker.php'),(20683406,9484,'./invitemtracker.php'),(20683405,2529,'./invitemtracker.php'),(20683404,2504,'./invitemtracker.php'),(20683403,3438,'./invitemtracker.php'),(20683402,2459,'./invitemtracker.php'),(20683401,2401,'./invitemtracker.php'),(20683400,2361,'./invitemtracker.php'),(20683399,3436,'./invitemtracker.php'),(20683398,9483,'./invitemtracker.php'),(20683397,9482,'./invitemtracker.php'),(20683396,2165,'./invitemtracker.php'),(20683395,2103,'./invitemtracker.php'),(20683394,2099,'./invitemtracker.php'),(20683393,1963,'./invitemtracker.php'),(20683392,9476,'./invitemtracker.php'),(20683391,1788,'./invitemtracker.php'),(20683390,9475,'./invitemtracker.php'),(20683389,1709,'./invitemtracker.php'),(20683388,1696,'./invitemtracker.php'),(20683387,1668,'./invitemtracker.php'),(20683386,1647,'./invitemtracker.php'),(20683385,1644,'./invitemtracker.php'),(20683384,3433,'./invitemtracker.php'),(20683383,3435,'./invitemtracker.php'),(20683382,9481,'./invitemtracker.php'),(20683381,9480,'./invitemtracker.php'),(20683380,9474,'./invitemtracker.php'),(20683379,3451,'./invitemtracker.php'),(20683378,1019,'./invitemtracker.php'),(20683377,869,'./invitemtracker.php'),(20683376,737,'./invitemtracker.php'),(20683375,6226,'./invitemtracker.php'),(20683374,665,'./invitemtracker.php'),(20683373,9473,'./invitemtracker.php'),(20683372,634,'./invitemtracker.php'),(20683371,616,'./invitemtracker.php'),(20683370,337,'./invitemtracker.php'),(20683369,315,'./invitemtracker.php'),(20683368,209,'./invitemtracker.php'),(20683367,9479,'./invitemtracker.php'),(20683366,187,'./invitemtracker.php'),(20683365,4713,'./invitemtracker.php'),(20683364,47,'./invitemtracker.php'),(20804175,8939,'./invitemstatusvendor.php'),(20804174,7268,'./invitemstatusvendor.php'),(20804173,3292,'./invitemstatusvendor.php'),(20804172,13819,'./invitemstatusvendor.php'),(20804171,3274,'./invitemstatusvendor.php'),(20804170,4415,'./invitemstatusvendor.php'),(20804169,3165,'./invitemstatusvendor.php'),(20804168,12093,'./invitemstatusvendor.php'),(20804167,13818,'./invitemstatusvendor.php'),(20804166,2405,'./invitemstatusvendor.php'),(20804165,2404,'./invitemstatusvendor.php'),(20804164,13817,'./invitemstatusvendor.php'),(20804163,13816,'./invitemstatusvendor.php'),(20804162,13815,'./invitemstatusvendor.php'),(20804161,13814,'./invitemstatusvendor.php'),(20804160,2044,'./invitemstatusvendor.php'),(20804159,1963,'./invitemstatusvendor.php'),(20804158,13813,'./invitemstatusvendor.php'),(20804157,1788,'./invitemstatusvendor.php'),(20804156,13812,'./invitemstatusvendor.php'),(20804155,13811,'./invitemstatusvendor.php'),(20804154,1709,'./invitemstatusvendor.php'),(20804153,1647,'./invitemstatusvendor.php'),(20804152,13810,'./invitemstatusvendor.php'),(20804151,8936,'./invitemstatusvendor.php'),(20804150,869,'./invitemstatusvendor.php'),(20804149,665,'./invitemstatusvendor.php'),(20804148,572,'./invitemstatusvendor.php'),(20804147,315,'./invitemstatusvendor.php'),(20804146,6314,'./invitemstatusvendor.php'),(20804145,197,'./invitemstatusvendor.php'),(20724296,7799,'./invitemsearchupd.php'),(20724295,4743,'./invitemsearchupd.php'),(20724294,2740,'./invitemsearchupd.php'),(20724293,2710,'./invitemsearchupd.php'),(20724292,2702,'./invitemsearchupd.php'),(20724291,1766,'./invitemsearchupd.php'),(20724290,1724,'./invitemsearchupd.php'),(20724289,1708,'./invitemsearchupd.php'),(20724288,1705,'./invitemsearchupd.php'),(20724287,1281,'./invitemsearchupd.php'),(20724286,1176,'./invitemsearchupd.php'),(20724285,941,'./invitemsearchupd.php'),(20724284,831,'./invitemsearchupd.php'),(20724283,799,'./invitemsearchupd.php'),(20724282,4742,'./invitemsearchupd.php'),(20724281,4741,'./invitemsearchupd.php'),(20724280,315,'./invitemsearchupd.php'),(20724279,5203,'./invitemsearchupd.php'),(20724278,111,'./invitemsearchupd.php'),(20724277,59,'./invitemsearchupd.php'),(20683312,3154,'./invitemsearchlst.php'),(20683311,3063,'./invitemsearchlst.php'),(20683310,2749,'./invitemsearchlst.php'),(20683309,2143,'./invitemsearchlst.php'),(20683308,2007,'./invitemsearchlst.php'),(20683307,1935,'./invitemsearchlst.php'),(20683306,1913,'./invitemsearchlst.php'),(20683305,1706,'./invitemsearchlst.php'),(20683304,1461,'./invitemsearchlst.php'),(20683303,1013,'./invitemsearchlst.php'),(20683302,457,'./invitemsearchlst.php'),(20683301,332,'./invitemsearchlst.php'),(20804144,5827,'./invitemsearchcat.php'),(20804143,1766,'./invitemsearchcat.php'),(20804142,1702,'./invitemsearchcat.php'),(20804141,5834,'./invitemsearchcat.php'),(20804140,5833,'./invitemsearchcat.php'),(20804139,953,'./invitemsearchcat.php'),(20804138,941,'./invitemsearchcat.php'),(20804137,799,'./invitemsearchcat.php'),(20804136,5832,'./invitemsearchcat.php'),(20804135,5831,'./invitemsearchcat.php'),(20804134,4871,'./invitemsearchcat.php'),(20804133,59,'./invitemsearchcat.php'),(20724264,4743,'./invitemsearchadd.php'),(20724263,2702,'./invitemsearchadd.php'),(20724262,1766,'./invitemsearchadd.php'),(20724261,1702,'./invitemsearchadd.php'),(20724260,1704,'./invitemsearchadd.php'),(20724259,1092,'./invitemsearchadd.php'),(20724258,4742,'./invitemsearchadd.php'),(20724257,4741,'./invitemsearchadd.php'),(20724256,315,'./invitemsearchadd.php'),(20804132,5774,'./invitemreclist.php'),(20804131,3292,'./invitemreclist.php'),(20804130,3290,'./invitemreclist.php'),(20804129,9491,'./invitemreclist.php'),(20804128,3274,'./invitemreclist.php'),(20804127,3182,'./invitemreclist.php'),(20804126,3181,'./invitemreclist.php'),(20804125,3172,'./invitemreclist.php'),(20804124,3090,'./invitemreclist.php'),(20804123,5773,'./invitemreclist.php'),(20804122,18862,'./invitemreclist.php'),(20804121,18681,'./invitemreclist.php'),(20804120,4267,'./invitemreclist.php'),(20804119,2597,'./invitemreclist.php'),(20804118,2595,'./invitemreclist.php'),(20804117,2589,'./invitemreclist.php'),(20804116,18680,'./invitemreclist.php'),(20804115,16875,'./invitemreclist.php'),(20804114,12824,'./invitemreclist.php'),(20804113,13325,'./invitemreclist.php'),(20804112,2531,'./invitemreclist.php'),(20804111,18861,'./invitemreclist.php'),(20804110,2508,'./invitemreclist.php'),(20804109,5772,'./invitemreclist.php'),(20804108,11734,'./invitemreclist.php'),(20804107,2404,'./invitemreclist.php'),(20804106,9363,'./invitemreclist.php'),(20804105,9657,'./invitemreclist.php'),(20804104,8996,'./invitemreclist.php'),(20804103,5771,'./invitemreclist.php'),(20804102,2363,'./invitemreclist.php'),(20804101,2361,'./invitemreclist.php'),(20804100,9472,'./invitemreclist.php'),(20804099,2136,'./invitemreclist.php'),(20804098,1998,'./invitemreclist.php'),(20804097,2103,'./invitemreclist.php'),(20804096,5770,'./invitemreclist.php'),(20804095,1973,'./invitemreclist.php'),(20804094,1963,'./invitemreclist.php'),(20804093,1788,'./invitemreclist.php'),(20804092,1750,'./invitemreclist.php'),(20804091,18860,'./invitemreclist.php'),(20804090,1730,'./invitemreclist.php'),(20804089,6366,'./invitemreclist.php'),(20804088,1725,'./invitemreclist.php'),(20804087,1724,'./invitemreclist.php'),(20804086,1709,'./invitemreclist.php'),(20804085,12168,'./invitemreclist.php'),(20804084,9471,'./invitemreclist.php'),(20804083,1557,'./invitemreclist.php'),(20804082,15991,'./invitemreclist.php'),(20804081,1499,'./invitemreclist.php'),(20804080,1285,'./invitemreclist.php'),(20804063,3298,'./invitemrecadd.php'),(20804062,4147,'./invitemrecadd.php'),(20804061,3292,'./invitemrecadd.php'),(20804060,3290,'./invitemrecadd.php'),(20804059,3274,'./invitemrecadd.php'),(20804058,11893,'./invitemrecadd.php'),(20804057,4146,'./invitemrecadd.php'),(20804056,4901,'./invitemrecadd.php'),(20804055,2713,'./invitemrecadd.php'),(20804054,2702,'./invitemrecadd.php'),(20804053,3793,'./invitemrecadd.php'),(20804052,4900,'./invitemrecadd.php'),(20804051,16874,'./invitemrecadd.php'),(20804050,2589,'./invitemrecadd.php'),(20804049,16873,'./invitemrecadd.php'),(20804048,2529,'./invitemrecadd.php'),(20804047,5176,'./invitemrecadd.php'),(20804046,2103,'./invitemrecadd.php'),(20804045,1963,'./invitemrecadd.php'),(20804044,1961,'./invitemrecadd.php'),(20804043,1953,'./invitemrecadd.php'),(20804042,1756,'./invitemrecadd.php'),(20804041,6366,'./invitemrecadd.php'),(20804040,1724,'./invitemrecadd.php'),(20804039,5175,'./invitemrecadd.php'),(20804038,4145,'./invitemrecadd.php'),(20804037,1696,'./invitemrecadd.php'),(20804036,1285,'./invitemrecadd.php'),(20804035,1283,'./invitemrecadd.php'),(20804034,8936,'./invitemrecadd.php'),(20804033,5141,'./invitemrecadd.php'),(20804032,744,'./invitemrecadd.php'),(20804031,4899,'./invitemrecadd.php'),(20804030,4144,'./invitemrecadd.php'),(20804029,607,'./invitemrecadd.php'),(20804028,4143,'./invitemrecadd.php'),(20683172,9318,'./invitemprintbarcode.php'),(20683171,9317,'./invitemprintbarcode.php'),(20683170,1963,'./invitemprintbarcode.php'),(20683169,6366,'./invitemprintbarcode.php'),(20683168,1724,'./invitemprintbarcode.php'),(20683167,9316,'./invitemprintbarcode.php'),(20683166,9315,'./invitemprintbarcode.php'),(20804025,3421,'./invitemprices.php'),(20804024,8810,'./invitemprices.php'),(20804023,3358,'./invitemprices.php'),(20804022,20135,'./invitemprices.php'),(20804021,3108,'./invitemprices.php'),(20804020,13932,'./invitemprices.php'),(20804019,2901,'./invitemprices.php'),(20804018,18966,'./invitemprices.php'),(20804017,2702,'./invitemprices.php'),(20804016,16675,'./invitemprices.php'),(20804015,9922,'./invitemprices.php'),(20804014,5135,'./invitemprices.php'),(20804013,18965,'./invitemprices.php'),(20804012,18964,'./invitemprices.php'),(20804011,5525,'./invitemprices.php'),(20804010,2137,'./invitemprices.php'),(20804009,2070,'./invitemprices.php'),(20804008,1973,'./invitemprices.php'),(20804007,1963,'./invitemprices.php'),(20804006,1913,'./invitemprices.php'),(20804005,1885,'./invitemprices.php'),(20804004,1824,'./invitemprices.php'),(20804003,13484,'./invitemprices.php'),(20804002,1788,'./invitemprices.php'),(20804001,1756,'./invitemprices.php'),(20804000,1753,'./invitemprices.php'),(20803999,9921,'./invitemprices.php'),(20803998,6366,'./invitemprices.php'),(20803997,1724,'./invitemprices.php'),(20803996,1709,'./invitemprices.php'),(20803995,9920,'./invitemprices.php'),(20803994,1740,'./invitemprices.php'),(20803993,20134,'./invitemprices.php'),(20803992,20133,'./invitemprices.php'),(20803991,3469,'./invitemprices.php'),(20803990,1598,'./invitemprices.php'),(20803967,3421,'./invitempricelevels.php'),(20803966,3108,'./invitempricelevels.php'),(20803965,2901,'./invitempricelevels.php'),(20803964,5525,'./invitempricelevels.php'),(20803963,2137,'./invitempricelevels.php'),(20803962,2070,'./invitempricelevels.php'),(20803961,1973,'./invitempricelevels.php'),(20803960,1963,'./invitempricelevels.php'),(20803959,1788,'./invitempricelevels.php'),(20803958,12864,'./invitempricelevels.php'),(20803957,6366,'./invitempricelevels.php'),(20803956,1724,'./invitempricelevels.php'),(20803955,1709,'./invitempricelevels.php'),(20803954,9920,'./invitempricelevels.php'),(20803953,3469,'./invitempricelevels.php'),(20803952,9919,'./invitempricelevels.php'),(20803951,8936,'./invitempricelevels.php'),(20803950,869,'./invitempricelevels.php'),(20803949,690,'./invitempricelevels.php'),(20803948,665,'./invitempricelevels.php'),(20803947,451,'./invitempricelevels.php'),(20803946,6031,'./invitempricelevels.php'),(20803945,315,'./invitempricelevels.php'),(20803944,6314,'./invitempricelevels.php'),(20803943,197,'./invitempricelevels.php'),(20803942,3047,'./invitemposted_beginbal.php'),(20803941,2960,'./invitemposted_beginbal.php'),(20803940,2948,'./invitemposted_beginbal.php'),(20803939,2901,'./invitemposted_beginbal.php'),(20803938,2722,'./invitemposted_beginbal.php'),(20803937,2702,'./invitemposted_beginbal.php'),(20803936,5815,'./invitemposted_beginbal.php'),(20803935,5814,'./invitemposted_beginbal.php'),(20803934,5813,'./invitemposted_beginbal.php'),(20803933,2044,'./invitemposted_beginbal.php'),(20803932,5812,'./invitemposted_beginbal.php'),(20803931,1963,'./invitemposted_beginbal.php'),(20803930,1788,'./invitemposted_beginbal.php'),(20803929,1725,'./invitemposted_beginbal.php'),(20803928,1709,'./invitemposted_beginbal.php'),(20803927,1031,'./invitemposted_beginbal.php'),(20803926,745,'./invitemposted_beginbal.php'),(20803925,740,'./invitemposted_beginbal.php'),(20803924,666,'./invitemposted_beginbal.php'),(20803923,451,'./invitemposted_beginbal.php'),(20803922,416,'./invitemposted_beginbal.php'),(20803921,339,'./invitemposted_beginbal.php'),(20803920,8268,'./invitemposted_beginbal.php'),(20803919,315,'./invitemposted_beginbal.php'),(20803918,5811,'./invitemposted_beginbal.php'),(20724040,2960,'./invitemposted.php'),(20724039,2948,'./invitemposted.php'),(20724038,2901,'./invitemposted.php'),(20724037,2722,'./invitemposted.php'),(20724036,2702,'./invitemposted.php'),(20724035,2642,'./invitemposted.php'),(20724034,2594,'./invitemposted.php'),(20724033,2371,'./invitemposted.php'),(20724032,2044,'./invitemposted.php'),(20724031,2039,'./invitemposted.php'),(20724030,1963,'./invitemposted.php'),(20724029,1952,'./invitemposted.php'),(20724028,1788,'./invitemposted.php'),(20724027,1725,'./invitemposted.php'),(20724026,1713,'./invitemposted.php'),(20724025,1709,'./invitemposted.php'),(20724024,3901,'./invitemposted.php'),(20724023,1031,'./invitemposted.php'),(20724022,745,'./invitemposted.php'),(20724021,740,'./invitemposted.php'),(20724020,666,'./invitemposted.php'),(20724019,451,'./invitemposted.php'),(20724018,416,'./invitemposted.php'),(20724017,321,'./invitemposted.php'),(20724016,315,'./invitemposted.php'),(20803917,3202,'./invitempage_define.php'),(20803916,3225,'./invitempage_define.php'),(20803915,2710,'./invitempage_define.php'),(20803914,2702,'./invitempage_define.php'),(20803913,4265,'./invitempage_define.php'),(20803912,8802,'./invitempage_define.php'),(20803911,8792,'./invitempage_define.php'),(20803910,542,'./invitempage_define.php'),(20803909,8791,'./invitempage_define.php'),(20803908,8790,'./invitempage_define.php'),(20803907,2751,'./invitemoptionitemlookup.php'),(20803906,1724,'./invitemoptionitemlookup.php'),(20803905,6411,'./invitemoptionitemlookup.php'),(20803904,2702,'./invitemoptiongroupitem.php'),(20803903,2165,'./invitemoptiongroupitem.php'),(20803902,6410,'./invitemoptiongroupitem.php'),(20803901,6409,'./invitemoptiongroupitem.php'),(20803900,1935,'./invitemoptiongroupitem.php'),(20803899,6408,'./invitemoptiongroupitem.php'),(20803898,869,'./invitemoptiongroupitem.php'),(20803897,542,'./invitemoptiongroupitem.php'),(20803896,59,'./invitemoptiongroupitem.php'),(20803895,6345,'./invitemoptiongroup.php'),(20803893,6343,'./invitemoption.php'),(20803891,3292,'./invitemlstvendorprice.php'),(20803890,3274,'./invitemlstvendorprice.php'),(20803889,3184,'./invitemlstvendorprice.php'),(20803888,3103,'./invitemlstvendorprice.php'),(20803887,2901,'./invitemlstvendorprice.php'),(20803886,12093,'./invitemlstvendorprice.php'),(20803885,2702,'./invitemlstvendorprice.php'),(20803884,2404,'./invitemlstvendorprice.php'),(20803883,5243,'./invitemlstvendorprice.php'),(20803882,2223,'./invitemlstvendorprice.php'),(20803881,2022,'./invitemlstvendorprice.php'),(20803880,1963,'./invitemlstvendorprice.php'),(20803879,7158,'./invitemlstvendorprice.php'),(20803878,1713,'./invitemlstvendorprice.php'),(20803877,1709,'./invitemlstvendorprice.php'),(20803876,4346,'./invitemlstvendorprice.php'),(20803875,665,'./invitemlstvendorprice.php'),(20803874,467,'./invitemlstvendorprice.php'),(20803873,451,'./invitemlstvendorprice.php'),(20803872,315,'./invitemlstvendorprice.php'),(20803871,197,'./invitemlstvendorprice.php'),(20803870,8939,'./invitemlstvendor.php'),(20803869,3292,'./invitemlstvendor.php'),(20803868,12093,'./invitemlstvendor.php'),(20803867,2515,'./invitemlstvendor.php'),(20803866,2405,'./invitemlstvendor.php'),(20803865,2404,'./invitemlstvendor.php'),(20803864,2044,'./invitemlstvendor.php'),(20803863,14575,'./invitemlstvendor.php'),(20803862,1963,'./invitemlstvendor.php'),(20803861,8938,'./invitemlstvendor.php'),(20803860,1756,'./invitemlstvendor.php'),(20803859,8937,'./invitemlstvendor.php'),(20803858,1709,'./invitemlstvendor.php'),(20803857,1647,'./invitemlstvendor.php'),(20803856,1428,'./invitemlstvendor.php'),(20803855,8936,'./invitemlstvendor.php'),(20803854,869,'./invitemlstvendor.php'),(20803853,665,'./invitemlstvendor.php'),(20803852,315,'./invitemlstvendor.php'),(20803851,8935,'./invitemlstvendor.php'),(20803849,8818,'./invitemlstval.php'),(20803848,8810,'./invitemlstval.php'),(20803847,3274,'./invitemlstval.php'),(20803846,3270,'./invitemlstval.php'),(20803845,3269,'./invitemlstval.php'),(20803844,14964,'./invitemlstval.php'),(20803843,3165,'./invitemlstval.php'),(20803842,3103,'./invitemlstval.php'),(20803841,3118,'./invitemlstval.php'),(20803840,2950,'./invitemlstval.php'),(20803839,13932,'./invitemlstval.php'),(20803838,14841,'./invitemlstval.php'),(20803837,2901,'./invitemlstval.php'),(20803836,2849,'./invitemlstval.php'),(20803835,7674,'./invitemlstval.php'),(20803834,18462,'./invitemlstval.php'),(20803833,2529,'./invitemlstval.php'),(20803832,2405,'./invitemlstval.php'),(20803831,2404,'./invitemlstval.php'),(20803830,5243,'./invitemlstval.php'),(20803829,2223,'./invitemlstval.php'),(20803828,16671,'./invitemlstval.php'),(20803827,2022,'./invitemlstval.php'),(20803826,16669,'./invitemlstval.php'),(20803825,18461,'./invitemlstval.php'),(20803824,1963,'./invitemlstval.php'),(20803823,8938,'./invitemlstval.php'),(20803822,1885,'./invitemlstval.php'),(20803821,19145,'./invitemlstval.php'),(20803820,1788,'./invitemlstval.php'),(20803819,19130,'./invitemlstval.php'),(20803818,1756,'./invitemlstval.php'),(20803817,1753,'./invitemlstval.php'),(20803816,12180,'./invitemlstval.php'),(20803815,18460,'./invitemlstval.php'),(20803814,1725,'./invitemlstval.php'),(20803813,1709,'./invitemlstval.php'),(20803789,20130,'./invitemlstusage.php'),(20803788,3421,'./invitemlstusage.php'),(20803787,3415,'./invitemlstusage.php'),(20803786,3414,'./invitemlstusage.php'),(20803785,3292,'./invitemlstusage.php'),(20803784,3290,'./invitemlstusage.php'),(20803783,3241,'./invitemlstusage.php'),(20803782,14667,'./invitemlstusage.php'),(20803781,3090,'./invitemlstusage.php'),(20803780,2978,'./invitemlstusage.php'),(20803779,12014,'./invitemlstusage.php'),(20803778,12092,'./invitemlstusage.php'),(20803777,2782,'./invitemlstusage.php'),(20803776,2751,'./invitemlstusage.php'),(20803775,9270,'./invitemlstusage.php'),(20803774,2522,'./invitemlstusage.php'),(20803773,2315,'./invitemlstusage.php'),(20803772,2202,'./invitemlstusage.php'),(20803771,2201,'./invitemlstusage.php'),(20803770,1998,'./invitemlstusage.php'),(20803769,1973,'./invitemlstusage.php'),(20803768,1963,'./invitemlstusage.php'),(20803767,1933,'./invitemlstusage.php'),(20803766,1913,'./invitemlstusage.php'),(20803765,1788,'./invitemlstusage.php'),(20803764,3668,'./invitemlstusage.php'),(20803763,6366,'./invitemlstusage.php'),(20803762,1725,'./invitemlstusage.php'),(20803761,1724,'./invitemlstusage.php'),(20803750,3421,'./invitemlstsum.php'),(20803749,8817,'./invitemlstsum.php'),(20803748,3165,'./invitemlstsum.php'),(20803747,3103,'./invitemlstsum.php'),(20803746,2985,'./invitemlstsum.php'),(20803745,2950,'./invitemlstsum.php'),(20803744,2901,'./invitemlstsum.php'),(20803743,12092,'./invitemlstsum.php'),(20803742,2849,'./invitemlstsum.php'),(20803741,9270,'./invitemlstsum.php'),(20803740,18462,'./invitemlstsum.php'),(20803739,2515,'./invitemlstsum.php'),(20803738,2508,'./invitemlstsum.php'),(20803737,2453,'./invitemlstsum.php'),(20803736,18679,'./invitemlstsum.php'),(20803735,5243,'./invitemlstsum.php'),(20803734,2223,'./invitemlstsum.php'),(20803733,2222,'./invitemlstsum.php'),(20803732,2022,'./invitemlstsum.php'),(20803731,18461,'./invitemlstsum.php'),(20803730,18678,'./invitemlstsum.php'),(20803729,1963,'./invitemlstsum.php'),(20803728,1885,'./invitemlstsum.php'),(20803727,1788,'./invitemlstsum.php'),(20803726,13334,'./invitemlstsum.php'),(20803725,1753,'./invitemlstsum.php'),(20803724,3666,'./invitemlstsum.php'),(20803723,18460,'./invitemlstsum.php'),(20803722,1725,'./invitemlstsum.php'),(20803721,1716,'./invitemlstsum.php'),(20803720,1709,'./invitemlstsum.php'),(20803719,1598,'./invitemlstsum.php'),(20803718,1450,'./invitemlstsum.php'),(20803717,1447,'./invitemlstsum.php'),(20803707,3421,'./invitemlststatus.php'),(20803706,3103,'./invitemlststatus.php'),(20803705,2948,'./invitemlststatus.php'),(20803704,2901,'./invitemlststatus.php'),(20803703,11121,'./invitemlststatus.php'),(20803702,12092,'./invitemlststatus.php'),(20803701,2849,'./invitemlststatus.php'),(20803700,9270,'./invitemlststatus.php'),(20803699,2516,'./invitemlststatus.php'),(20803698,2515,'./invitemlststatus.php'),(20803697,2511,'./invitemlststatus.php'),(20803696,2509,'./invitemlststatus.php'),(20803695,5243,'./invitemlststatus.php'),(20803694,2223,'./invitemlststatus.php'),(20803693,14252,'./invitemlststatus.php'),(20803692,11120,'./invitemlststatus.php'),(20803691,11119,'./invitemlststatus.php'),(20803690,15182,'./invitemlststatus.php'),(20803689,1963,'./invitemlststatus.php'),(20803688,14251,'./invitemlststatus.php'),(20803687,1788,'./invitemlststatus.php'),(20803686,1732,'./invitemlststatus.php'),(20803685,1725,'./invitemlststatus.php'),(20803684,1716,'./invitemlststatus.php'),(20803683,1713,'./invitemlststatus.php'),(20803682,14250,'./invitemlststatus.php'),(20803681,1709,'./invitemlststatus.php'),(20803680,11118,'./invitemlststatus.php'),(20803679,1450,'./invitemlststatus.php'),(20803678,5407,'./invitemlststatus.php'),(20803677,542,'./invitemlststatus.php'),(20803676,467,'./invitemlststatus.php'),(20803675,451,'./invitemlststatus.php'),(20803674,315,'./invitemlststatus.php'),(20803673,12,'./invitemlststatus.php'),(20803672,14249,'./invitemlststatus.php'),(20803671,209,'./invitemlststatus.php'),(20803670,11117,'./invitemlststatus.php'),(20803669,197,'./invitemlststatus.php'),(20803668,11116,'./invitemlststatus.php'),(20803667,11115,'./invitemlststatus.php'),(20803666,14505,'./invitemlstreorder.php'),(20803665,5577,'./invitemlstreorder.php'),(20803664,3297,'./invitemlstreorder.php'),(20803663,3292,'./invitemlstreorder.php'),(20803662,3274,'./invitemlstreorder.php'),(20803661,19444,'./invitemlstreorder.php'),(20803660,14908,'./invitemlstreorder.php'),(20803659,3165,'./invitemlstreorder.php'),(20803658,4387,'./invitemlstreorder.php'),(20803657,16612,'./invitemlstreorder.php'),(20803656,14907,'./invitemlstreorder.php'),(20803655,14906,'./invitemlstreorder.php'),(20803654,5576,'./invitemlstreorder.php'),(20803653,2529,'./invitemlstreorder.php'),(20803652,2459,'./invitemlstreorder.php'),(20803651,2404,'./invitemlstreorder.php'),(20803650,12821,'./invitemlstreorder.php'),(20803649,2208,'./invitemlstreorder.php'),(20803648,18304,'./invitemlstreorder.php'),(20803647,18303,'./invitemlstreorder.php'),(20803646,19142,'./invitemlstreorder.php'),(20803645,5528,'./invitemlstreorder.php'),(20803644,14506,'./invitemlstreorder.php'),(20803643,5525,'./invitemlstreorder.php'),(20803642,2137,'./invitemlstreorder.php'),(20803641,16689,'./invitemlstreorder.php'),(20803640,16688,'./invitemlstreorder.php'),(20803639,16687,'./invitemlstreorder.php'),(20803638,14905,'./invitemlstreorder.php'),(20803637,18302,'./invitemlstreorder.php'),(20803636,18301,'./invitemlstreorder.php'),(20803635,16370,'./invitemlstreorder.php'),(20803634,1963,'./invitemlstreorder.php'),(20803633,16686,'./invitemlstreorder.php'),(20803632,5574,'./invitemlstreorder.php'),(20803631,10623,'./invitemlstreorder.php'),(20803630,10946,'./invitemlstreorder.php'),(20803629,19852,'./invitemlstreorder.php'),(20803628,16685,'./invitemlstreorder.php'),(20803627,19141,'./invitemlstreorder.php'),(20803626,16684,'./invitemlstreorder.php'),(20803625,19140,'./invitemlstreorder.php'),(20803624,1788,'./invitemlstreorder.php'),(20803623,4381,'./invitemlstreorder.php'),(20803622,1709,'./invitemlstreorder.php'),(20803621,1703,'./invitemlstreorder.php'),(20803620,19139,'./invitemlstreorder.php'),(20803619,5573,'./invitemlstreorder.php'),(20803618,1696,'./invitemlstreorder.php'),(20803617,4532,'./invitemlstreorder.php'),(20803616,16683,'./invitemlstreorder.php'),(20803615,1622,'./invitemlstreorder.php'),(20803614,19138,'./invitemlstreorder.php'),(20803613,19137,'./invitemlstreorder.php'),(20803612,1599,'./invitemlstreorder.php'),(20803575,3103,'./invitemlstprice.php'),(20803574,2901,'./invitemlstprice.php'),(20803573,2849,'./invitemlstprice.php'),(20803572,2453,'./invitemlstprice.php'),(20803571,2405,'./invitemlstprice.php'),(20803570,2404,'./invitemlstprice.php'),(20803569,5243,'./invitemlstprice.php'),(20803568,2223,'./invitemlstprice.php'),(20803567,2022,'./invitemlstprice.php'),(20803566,1963,'./invitemlstprice.php'),(20803565,1788,'./invitemlstprice.php'),(20803564,3665,'./invitemlstprice.php'),(20803563,6366,'./invitemlstprice.php'),(20803562,1724,'./invitemlstprice.php'),(20803561,1716,'./invitemlstprice.php'),(20803560,1713,'./invitemlstprice.php'),(20803559,1709,'./invitemlstprice.php'),(20803558,1598,'./invitemlstprice.php'),(20803557,1572,'./invitemlstprice.php'),(20803556,1451,'./invitemlstprice.php'),(20803555,1450,'./invitemlstprice.php'),(20803554,1447,'./invitemlstprice.php'),(20803553,665,'./invitemlstprice.php'),(20803552,467,'./invitemlstprice.php'),(20803551,451,'./invitemlstprice.php'),(20803550,315,'./invitemlstprice.php'),(20803549,197,'./invitemlstprice.php'),(20723646,14524,'./invitemlstphys.php'),(20723645,3129,'./invitemlstphys.php'),(20723644,3072,'./invitemlstphys.php'),(20723643,3045,'./invitemlstphys.php'),(20723642,2960,'./invitemlstphys.php'),(20723641,2901,'./invitemlstphys.php'),(20723640,2874,'./invitemlstphys.php'),(20723639,2849,'./invitemlstphys.php'),(20723638,2744,'./invitemlstphys.php'),(20723637,2742,'./invitemlstphys.php'),(20723636,14523,'./invitemlstphys.php'),(20723635,2706,'./invitemlstphys.php'),(20723634,2702,'./invitemlstphys.php'),(20723633,2642,'./invitemlstphys.php'),(20723632,2627,'./invitemlstphys.php'),(20723631,2626,'./invitemlstphys.php'),(20723630,4725,'./invitemlstphys.php'),(20723629,2401,'./invitemlstphys.php'),(20723628,6444,'./invitemlstphys.php'),(20723627,2137,'./invitemlstphys.php'),(20723626,1963,'./invitemlstphys.php'),(20723625,1949,'./invitemlstphys.php'),(20723624,1839,'./invitemlstphys.php'),(20723623,1788,'./invitemlstphys.php'),(20723622,1776,'./invitemlstphys.php'),(20723621,1725,'./invitemlstphys.php'),(20723620,1717,'./invitemlstphys.php'),(20723619,1713,'./invitemlstphys.php'),(20723618,1709,'./invitemlstphys.php'),(20723617,1598,'./invitemlstphys.php'),(20723616,8188,'./invitemlstphys.php'),(20723615,8187,'./invitemlstphys.php'),(20723614,6426,'./invitemlstphys.php'),(20723613,764,'./invitemlstphys.php'),(20723612,686,'./invitemlstphys.php'),(20723611,685,'./invitemlstphys.php'),(20723610,666,'./invitemlstphys.php'),(20723609,572,'./invitemlstphys.php'),(20723608,451,'./invitemlstphys.php'),(20723607,8186,'./invitemlstphys.php'),(20723606,8185,'./invitemlstphys.php'),(20723605,315,'./invitemlstphys.php'),(20723604,12,'./invitemlstphys.php'),(20723603,5203,'./invitemlstphys.php'),(20803548,3290,'./invitemlsthistory.php'),(20803547,4696,'./invitemlsthistory.php'),(20803546,12013,'./invitemlsthistory.php'),(20803545,2520,'./invitemlsthistory.php'),(20803544,4695,'./invitemlsthistory.php'),(20803543,12010,'./invitemlsthistory.php'),(20803542,1963,'./invitemlsthistory.php'),(20803541,1788,'./invitemlsthistory.php'),(20803540,6366,'./invitemlsthistory.php'),(20803539,1724,'./invitemlsthistory.php'),(20803538,1716,'./invitemlsthistory.php'),(20803537,3662,'./invitemlsthistory.php'),(20803536,4128,'./invitemlsthistory.php'),(20803535,1557,'./invitemlsthistory.php'),(20803534,1450,'./invitemlsthistory.php'),(20803533,869,'./invitemlsthistory.php'),(20803532,665,'./invitemlsthistory.php'),(20803531,4693,'./invitemlsthistory.php'),(20803530,451,'./invitemlsthistory.php'),(20803529,315,'./invitemlsthistory.php'),(20803528,209,'./invitemlsthistory.php'),(20803527,3103,'./invitemlstdist.php'),(20803526,2960,'./invitemlstdist.php'),(20803525,2901,'./invitemlstdist.php'),(20803524,2849,'./invitemlstdist.php'),(20803523,2515,'./invitemlstdist.php'),(20803522,5243,'./invitemlstdist.php'),(20803521,2223,'./invitemlstdist.php'),(20803520,2186,'./invitemlstdist.php'),(20803519,2022,'./invitemlstdist.php'),(20803518,1963,'./invitemlstdist.php'),(20803517,1893,'./invitemlstdist.php'),(20803516,1859,'./invitemlstdist.php'),(20803515,1788,'./invitemlstdist.php'),(20803514,1725,'./invitemlstdist.php'),(20803513,1716,'./invitemlstdist.php'),(20803512,3663,'./invitemlstdist.php'),(20803511,1709,'./invitemlstdist.php'),(20803510,1598,'./invitemlstdist.php'),(20803509,1450,'./invitemlstdist.php'),(20803508,1447,'./invitemlstdist.php'),(20803507,904,'./invitemlstdist.php'),(20803506,665,'./invitemlstdist.php'),(20803505,467,'./invitemlstdist.php'),(20803504,451,'./invitemlstdist.php'),(20803503,315,'./invitemlstdist.php'),(20803502,197,'./invitemlstdist.php'),(20803501,3103,'./invitemlstcost.php'),(20803500,2901,'./invitemlstcost.php'),(20803499,2453,'./invitemlstcost.php'),(20803498,2404,'./invitemlstcost.php'),(20803497,5243,'./invitemlstcost.php'),(20803496,2223,'./invitemlstcost.php'),(20803495,2022,'./invitemlstcost.php'),(20803494,8237,'./invitemlstcost.php'),(20803493,1963,'./invitemlstcost.php'),(20803492,1788,'./invitemlstcost.php'),(20803491,1713,'./invitemlstcost.php'),(20803490,1709,'./invitemlstcost.php'),(20803489,8236,'./invitemlstcost.php'),(20803488,8235,'./invitemlstcost.php'),(20803487,8250,'./invitemlstcost.php'),(20803486,8234,'./invitemlstcost.php'),(20803485,1450,'./invitemlstcost.php'),(20803484,1447,'./invitemlstcost.php'),(20803483,665,'./invitemlstcost.php'),(20803482,467,'./invitemlstcost.php'),(20803481,451,'./invitemlstcost.php'),(20803480,315,'./invitemlstcost.php'),(20803479,197,'./invitemlstcost.php'),(20803478,3274,'./invitemlstconversions.php'),(20803477,3103,'./invitemlstconversions.php'),(20803476,2901,'./invitemlstconversions.php'),(20803475,2849,'./invitemlstconversions.php'),(20803474,7564,'./invitemlstconversions.php'),(20803473,5243,'./invitemlstconversions.php'),(20803472,2223,'./invitemlstconversions.php'),(20803471,2022,'./invitemlstconversions.php'),(20803470,1963,'./invitemlstconversions.php'),(20803469,1716,'./invitemlstconversions.php'),(20803468,1713,'./invitemlstconversions.php'),(20803467,7569,'./invitemlstconversions.php'),(20803466,1709,'./invitemlstconversions.php'),(20803465,1598,'./invitemlstconversions.php'),(20803464,665,'./invitemlstconversions.php'),(20803463,7562,'./invitemlstconversions.php'),(20803462,467,'./invitemlstconversions.php'),(20803461,451,'./invitemlstconversions.php'),(20803460,315,'./invitemlstconversions.php'),(20803459,197,'./invitemlstconversions.php'),(20682529,3290,'./invitemlstcomp.php'),(20682528,3173,'./invitemlstcomp.php'),(20682527,2971,'./invitemlstcomp.php'),(20682526,2901,'./invitemlstcomp.php'),(20682525,2529,'./invitemlstcomp.php'),(20682524,2515,'./invitemlstcomp.php'),(20682523,2511,'./invitemlstcomp.php'),(20682522,2509,'./invitemlstcomp.php'),(20682521,2022,'./invitemlstcomp.php'),(20682520,1963,'./invitemlstcomp.php'),(20682519,1854,'./invitemlstcomp.php'),(20682518,6366,'./invitemlstcomp.php'),(20682517,1725,'./invitemlstcomp.php'),(20682516,1724,'./invitemlstcomp.php'),(20682515,1716,'./invitemlstcomp.php'),(20682514,1709,'./invitemlstcomp.php'),(20682513,1696,'./invitemlstcomp.php'),(20682512,1233,'./invitemlstcomp.php'),(20682511,665,'./invitemlstcomp.php'),(20682510,599,'./invitemlstcomp.php'),(20682509,451,'./invitemlstcomp.php'),(20682508,7008,'./invitemlstcomp.php'),(20682507,315,'./invitemlstcomp.php'),(20682506,312,'./invitemlstcomp.php'),(20682505,302,'./invitemlstcomp.php'),(20682504,221,'./invitemlstcomp.php'),(20803458,7007,'./invitemgroupupd.php'),(20803457,2702,'./invitemgroupupd.php'),(20803456,7006,'./invitemgroupupd.php'),(20803455,7005,'./invitemgroupupd.php'),(20803454,7004,'./invitemgroupupd.php'),(20803453,6558,'./invitemgroupupd.php'),(20803452,542,'./invitemgroupupd.php'),(20803451,3421,'./invitemcosts.php'),(20803450,8810,'./invitemcosts.php'),(20803449,15314,'./invitemcosts.php'),(20803448,3108,'./invitemcosts.php'),(20803447,2901,'./invitemcosts.php'),(20803446,2702,'./invitemcosts.php'),(20803445,5525,'./invitemcosts.php'),(20803444,2137,'./invitemcosts.php'),(20803443,2070,'./invitemcosts.php'),(20803442,1973,'./invitemcosts.php'),(20803441,1963,'./invitemcosts.php'),(20803440,1885,'./invitemcosts.php'),(20803439,1824,'./invitemcosts.php'),(20803438,1788,'./invitemcosts.php'),(20803437,1753,'./invitemcosts.php'),(20803436,6366,'./invitemcosts.php'),(20803435,1724,'./invitemcosts.php'),(20803434,15308,'./invitemcosts.php'),(20803433,1709,'./invitemcosts.php'),(20803432,9920,'./invitemcosts.php'),(20803431,3469,'./invitemcosts.php'),(20803430,1598,'./invitemcosts.php'),(20803429,9919,'./invitemcosts.php'),(20803428,1427,'./invitemcosts.php'),(20803427,5142,'./invitemcosts.php'),(20803426,8936,'./invitemcosts.php'),(20803425,869,'./invitemcosts.php'),(20803424,690,'./invitemcosts.php'),(20803423,665,'./invitemcosts.php'),(20803422,15313,'./invitemcosts.php'),(20803421,616,'./invitemcosts.php'),(20803420,451,'./invitemcosts.php'),(20803419,6031,'./invitemcosts.php'),(20803418,315,'./invitemcosts.php'),(20803417,6314,'./invitemcosts.php'),(20803416,197,'./invitemcosts.php'),(20803415,57,'./invitemcosts.php'),(20803414,18300,'./invitemcatupd.php'),(20803413,18299,'./invitemcatupd.php'),(20803412,3154,'./invitemcatupd.php'),(20803411,18207,'./invitemcatupd.php'),(20803410,9909,'./invitemcatupd.php'),(20803409,3063,'./invitemcatupd.php'),(20803408,16676,'./invitemcatupd.php'),(20803407,14901,'./invitemcatupd.php'),(20803406,14271,'./invitemcatupd.php'),(20803405,18097,'./invitemcatupd.php'),(20803404,2749,'./invitemcatupd.php'),(20803403,2710,'./invitemcatupd.php'),(20803402,2702,'./invitemcatupd.php'),(20803401,2686,'./invitemcatupd.php'),(20803400,2664,'./invitemcatupd.php'),(20803399,10577,'./invitemcatupd.php'),(20803398,18298,'./invitemcatupd.php'),(20803397,20129,'./invitemcatupd.php'),(20803396,20128,'./invitemcatupd.php'),(20803395,16675,'./invitemcatupd.php'),(20803394,13806,'./invitemcatupd.php'),(20803393,4740,'./invitemcatupd.php'),(20803392,16671,'./invitemcatupd.php'),(20803391,2143,'./invitemcatupd.php'),(20803390,2127,'./invitemcatupd.php'),(20803389,18297,'./invitemcatupd.php'),(20803388,2007,'./invitemcatupd.php'),(20803387,18096,'./invitemcatupd.php'),(20803386,16674,'./invitemcatupd.php'),(20803385,1963,'./invitemcatupd.php'),(20803384,1935,'./invitemcatupd.php'),(20803383,9908,'./invitemcatupd.php'),(20803382,1913,'./invitemcatupd.php'),(20803381,1708,'./invitemcatupd.php'),(20803380,1707,'./invitemcatupd.php'),(20803379,1706,'./invitemcatupd.php'),(20803378,1705,'./invitemcatupd.php'),(20803377,1703,'./invitemcatupd.php'),(20803376,9907,'./invitemcatupd.php'),(20803375,1666,'./invitemcatupd.php'),(20803374,1508,'./invitemcatupd.php'),(20803373,1476,'./invitemcatupd.php'),(20803372,1461,'./invitemcatupd.php'),(20803347,12820,'./invitemcatremove.php'),(20803346,2007,'./invitemcatremove.php'),(20803345,12819,'./invitemcatremove.php'),(20803344,12818,'./invitemcatremove.php'),(20803343,1703,'./invitemcatremove.php'),(20803342,596,'./invitemcatremove.php'),(20803341,12817,'./invitemcatremove.php'),(20803340,416,'./invitemcatremove.php'),(20803339,315,'./invitemcatremove.php'),(20723392,3154,'./invitemcatlst.php'),(20723391,3063,'./invitemcatlst.php'),(20723390,2749,'./invitemcatlst.php'),(20723389,2143,'./invitemcatlst.php'),(20723388,2007,'./invitemcatlst.php'),(20723387,1935,'./invitemcatlst.php'),(20723386,1913,'./invitemcatlst.php'),(20723385,1706,'./invitemcatlst.php'),(20723384,1461,'./invitemcatlst.php'),(20723383,1013,'./invitemcatlst.php'),(20723382,457,'./invitemcatlst.php'),(20723381,332,'./invitemcatlst.php'),(20803812,1666,'./invitemlstval.php'),(20803611,14904,'./invitemlstreorder.php'),(20803610,14903,'./invitemlstreorder.php'),(20803609,14046,'./invitemlstreorder.php'),(20803608,19136,'./invitemlstreorder.php'),(20803607,1450,'./invitemlstreorder.php'),(20803371,1281,'./invitemcatupd.php'),(20803370,8936,'./invitemcatupd.php'),(20803369,1176,'./invitemcatupd.php'),(20803368,1024,'./invitemcatupd.php'),(20803367,1013,'./invitemcatupd.php'),(20803366,15673,'./invitemcatupd.php'),(20803329,3072,'./invitembuildorderlist.php'),(20803328,12206,'./invitembuildorderlist.php'),(20803327,12205,'./invitembuildorderlist.php'),(20803326,2528,'./invitembuildorderlist.php'),(20803325,2511,'./invitembuildorderlist.php'),(20803324,2292,'./invitembuildorderlist.php'),(20803323,2182,'./invitembuildorderlist.php'),(20803322,4539,'./invitembuildorderlist.php'),(20803321,1963,'./invitembuildorderlist.php'),(20803320,1838,'./invitembuildorderlist.php'),(20803319,1820,'./invitembuildorderlist.php'),(20803318,1788,'./invitembuildorderlist.php'),(20803317,4133,'./invitembuildorderlist.php'),(20803316,1608,'./invitembuildorderlist.php'),(20803315,7427,'./invitembuildorderlist.php'),(20803314,1497,'./invitembuildorderlist.php'),(20803313,1446,'./invitembuildorderlist.php'),(20803312,1412,'./invitembuildorderlist.php'),(20803311,7426,'./invitembuildorderlist.php'),(20803310,1019,'./invitembuildorderlist.php'),(20803309,739,'./invitembuildorderlist.php'),(20803308,596,'./invitembuildorderlist.php'),(20803307,400,'./invitembuildorderlist.php'),(20803306,337,'./invitembuildorderlist.php'),(20803305,315,'./invitembuildorderlist.php'),(20803304,14,'./invitembuildorderlist.php'),(20803303,288,'./invitembuildorderlist.php'),(20803302,287,'./invitembuildorderlist.php'),(20803301,7460,'./invitembuildorder_fill.php'),(20803300,3173,'./invitembuildorder_fill.php'),(20803299,3076,'./invitembuildorder_fill.php'),(20803298,3044,'./invitembuildorder_fill.php'),(20803297,2997,'./invitembuildorder_fill.php'),(20803296,2971,'./invitembuildorder_fill.php'),(20803295,2709,'./invitembuildorder_fill.php'),(20803294,2702,'./invitembuildorder_fill.php'),(20803293,2528,'./invitembuildorder_fill.php'),(20803292,2509,'./invitembuildorder_fill.php'),(20803291,2508,'./invitembuildorder_fill.php'),(20803290,2297,'./invitembuildorder_fill.php'),(20803289,7424,'./invitembuildorder_fill.php'),(20803288,7423,'./invitembuildorder_fill.php'),(20803287,1993,'./invitembuildorder_fill.php'),(20803286,1987,'./invitembuildorder_fill.php'),(20803285,7422,'./invitembuildorder_fill.php'),(20803284,7798,'./invitembuildorder_fill.php'),(20803283,1854,'./invitembuildorder_fill.php'),(20803282,1838,'./invitembuildorder_fill.php'),(20803281,1837,'./invitembuildorder_fill.php'),(20803280,1725,'./invitembuildorder_fill.php'),(20803279,1709,'./invitembuildorder_fill.php'),(20803278,1647,'./invitembuildorder_fill.php'),(20803277,7406,'./invitembuildorder_fill.php'),(20803276,7421,'./invitembuildorder_fill.php'),(20803275,1237,'./invitembuildorder_fill.php'),(20803274,1233,'./invitembuildorder_fill.php'),(20803273,1229,'./invitembuildorder_fill.php'),(20803272,1214,'./invitembuildorder_fill.php'),(20803271,5060,'./invitembuildorder_fill.php'),(20803270,7404,'./invitembuildorder_fill.php'),(20803269,404,'./invitembuildorder_fill.php'),(20803268,403,'./invitembuildorder_fill.php'),(20803267,7420,'./invitembuildorder_fill.php'),(20803266,315,'./invitembuildorder_fill.php'),(20803265,288,'./invitembuildorder_fill.php'),(20803264,246,'./invitembuildorder_fill.php'),(20803263,7419,'./invitembuildorder_commit.php'),(20803262,3274,'./invitembuildorder_commit.php'),(20803261,7418,'./invitembuildorder_commit.php'),(20803260,2702,'./invitembuildorder_commit.php'),(20803259,8111,'./invitembuildorder_commit.php'),(20803258,8110,'./invitembuildorder_commit.php'),(20803257,7415,'./invitembuildorder_commit.php'),(20803256,2509,'./invitembuildorder_commit.php'),(20803255,7030,'./invitembuildorder_commit.php'),(20803254,7413,'./invitembuildorder_commit.php'),(20803253,7412,'./invitembuildorder_commit.php'),(20803252,2103,'./invitembuildorder_commit.php'),(20803251,7411,'./invitembuildorder_commit.php'),(20803250,1781,'./invitembuildorder_commit.php'),(20803249,8109,'./invitembuildorder_commit.php'),(20803248,542,'./invitembuildorder_commit.php'),(20803247,7409,'./invitembuildorder_commit.php'),(20803246,3173,'./invitembuildorder.php'),(20803245,3076,'./invitembuildorder.php'),(20803244,3044,'./invitembuildorder.php'),(20803243,2997,'./invitembuildorder.php'),(20803242,12206,'./invitembuildorder.php'),(20803241,12205,'./invitembuildorder.php'),(20803240,2948,'./invitembuildorder.php'),(20803239,2771,'./invitembuildorder.php'),(20803238,15634,'./invitembuildorder.php'),(20803237,2709,'./invitembuildorder.php'),(20803236,2702,'./invitembuildorder.php'),(20803235,2528,'./invitembuildorder.php'),(20803234,12204,'./invitembuildorder.php'),(20803233,2511,'./invitembuildorder.php'),(20803232,2509,'./invitembuildorder.php'),(20803231,8108,'./invitembuildorder.php'),(20803230,8107,'./invitembuildorder.php'),(20803229,2023,'./invitembuildorder.php'),(20803228,1993,'./invitembuildorder.php'),(20803227,1987,'./invitembuildorder.php'),(20803226,1963,'./invitembuildorder.php'),(20803225,1948,'./invitembuildorder.php'),(20803224,1854,'./invitembuildorder.php'),(20803223,1838,'./invitembuildorder.php'),(20803222,1647,'./invitembuildorder.php'),(20803221,7251,'./invitembuildorder.php'),(20803220,7406,'./invitembuildorder.php'),(20803219,4440,'./invitembuildorder.php'),(20803218,1237,'./invitembuildorder.php'),(20803217,1233,'./invitembuildorder.php'),(20803216,1229,'./invitembuildorder.php'),(20803215,952,'./invitembuildorder.php'),(20803214,951,'./invitembuildorder.php'),(20803213,941,'./invitembuildorder.php'),(20803212,801,'./invitembuildorder.php'),(20803211,799,'./invitembuildorder.php'),(20803210,7404,'./invitembuildorder.php'),(20803209,403,'./invitembuildorder.php'),(20803208,401,'./invitembuildorder.php'),(20803207,315,'./invitembuildorder.php'),(20803206,288,'./invitembuildorder.php'),(20803205,287,'./invitembuildorder.php'),(20803204,246,'./invitembuildorder.php'),(20803203,87,'./invitembuildorder.php'),(20803202,59,'./invitembuildorder.php'),(20803201,55,'./invitembuildorder.php'),(20803200,7403,'./invitembompo.php'),(20803199,7401,'./invitembompo.php'),(20803198,7400,'./invitembompo.php'),(20803197,7399,'./invitembompo.php'),(20803196,7797,'./invitembompo.php'),(20803195,1963,'./invitembompo.php'),(20803194,7398,'./invitembompo.php'),(20803193,1047,'./invitembompo.php'),(20803192,7623,'./invitembompo.php'),(20803191,607,'./invitembompo.php'),(20803190,7397,'./invitembompo.php'),(20803189,7396,'./invitembompo.php'),(20682221,9313,'./invitembarcodepdf.php'),(20723230,3290,'./invitemadd2.php'),(20723229,2753,'./invitemadd2.php'),(20723228,2533,'./invitemadd2.php'),(20723227,1733,'./invitemadd2.php'),(20723226,1724,'./invitemadd2.php'),(20723225,1709,'./invitemadd2.php'),(20723224,1571,'./invitemadd2.php'),(20723223,4602,'./invitemadd2.php'),(20723222,869,'./invitemadd2.php'),(20723221,601,'./invitemadd2.php'),(20723220,598,'./invitemadd2.php'),(20723219,542,'./invitemadd2.php'),(20723218,315,'./invitemadd2.php'),(20723217,150,'./invitemadd2.php'),(20723216,149,'./invitemadd2.php'),(20803188,18963,'./invitemadd1.php'),(20803187,19278,'./invitemadd1.php'),(20803186,3056,'./invitemadd1.php'),(20803185,8359,'./invitemadd1.php'),(20803184,4593,'./invitemadd1.php'),(20803183,2964,'./invitemadd1.php'),(20803182,2787,'./invitemadd1.php'),(20803181,2749,'./invitemadd1.php'),(20803180,2720,'./invitemadd1.php'),(20803179,2702,'./invitemadd1.php'),(20803178,4592,'./invitemadd1.php'),(20803177,16872,'./invitemadd1.php'),(20803176,16871,'./invitemadd1.php'),(20803175,16870,'./invitemadd1.php'),(20803174,2405,'./invitemadd1.php'),(20803173,2187,'./invitemadd1.php'),(20803172,2138,'./invitemadd1.php'),(20803171,1980,'./invitemadd1.php'),(20803170,2101,'./invitemadd1.php'),(20803169,2070,'./invitemadd1.php'),(20803168,1894,'./invitemadd1.php'),(20803167,1863,'./invitemadd1.php'),(20803166,1828,'./invitemadd1.php'),(20803165,13269,'./invitemadd1.php'),(20803164,8184,'./invitemadd1.php'),(20803163,1789,'./invitemadd1.php'),(20803162,1726,'./invitemadd1.php'),(20803161,1720,'./invitemadd1.php'),(20803160,1698,'./invitemadd1.php'),(20803159,1333,'./invitemadd1.php'),(20803158,1280,'./invitemadd1.php'),(20803157,1047,'./invitemadd1.php'),(20803156,1027,'./invitemadd1.php'),(20803155,898,'./invitemadd1.php'),(20803154,8819,'./invitemadd1.php'),(20803153,18962,'./invitemadd1.php'),(20803145,19278,'./invitemadd.php'),(20803144,3421,'./invitemadd.php'),(20803143,3373,'./invitemadd.php'),(20803142,3362,'./invitemadd.php'),(20803141,16694,'./invitemadd.php'),(20803140,18857,'./invitemadd.php'),(20803139,3298,'./invitemadd.php'),(20803138,18781,'./invitemadd.php'),(20803137,3292,'./invitemadd.php'),(20803136,3274,'./invitemadd.php'),(20803135,14900,'./invitemadd.php'),(20803134,13867,'./invitemadd.php'),(20803133,13965,'./invitemadd.php'),(20803132,3239,'./invitemadd.php'),(20803131,3240,'./invitemadd.php'),(20803130,3235,'./invitemadd.php'),(20803129,3234,'./invitemadd.php'),(20803128,18875,'./invitemadd.php'),(20803127,7669,'./invitemadd.php'),(20803126,18631,'./invitemadd.php'),(20803125,6371,'./invitemadd.php'),(20803124,15544,'./invitemadd.php'),(20803123,5827,'./invitemadd.php'),(20803122,16676,'./invitemadd.php'),(20803121,13932,'./invitemadd.php'),(20803120,2886,'./invitemadd.php'),(20803119,14899,'./invitemadd.php'),(20803118,2849,'./invitemadd.php'),(20803117,7796,'./invitemadd.php'),(20803116,2847,'./invitemadd.php'),(20803115,15825,'./invitemadd.php'),(20803114,15139,'./invitemadd.php'),(20803113,2740,'./invitemadd.php'),(20803112,2730,'./invitemadd.php'),(20803111,2710,'./invitemadd.php'),(20803110,2702,'./invitemadd.php'),(20803109,14009,'./invitemadd.php'),(20803108,18013,'./invitemadd.php'),(20803107,16675,'./invitemadd.php'),(20803106,7795,'./invitemadd.php'),(20803105,5881,'./invitemadd.php'),(20803104,16692,'./invitemadd.php'),(20803103,2503,'./invitemadd.php'),(20803102,5880,'./invitemadd.php'),(20803101,10100,'./invitemadd.php'),(20803100,17442,'./invitemadd.php'),(20803099,10099,'./invitemadd.php'),(20803098,10098,'./invitemadd.php'),(20803097,2453,'./invitemadd.php'),(20803096,15768,'./invitemadd.php'),(20803095,2367,'./invitemadd.php'),(20803094,18295,'./invitemadd.php'),(20803093,19320,'./invitemadd.php'),(20803092,2333,'./invitemadd.php'),(20803091,2212,'./invitemadd.php'),(20803090,16671,'./invitemadd.php'),(20803089,14781,'./invitemadd.php'),(20803088,18855,'./invitemadd.php'),(20803087,18674,'./invitemadd.php'),(20803086,16691,'./invitemadd.php'),(20803085,15181,'./invitemadd.php'),(20803084,13931,'./invitemadd.php'),(20803083,2103,'./invitemadd.php'),(20803082,16674,'./invitemadd.php'),(20803081,1973,'./invitemadd.php'),(20803080,1932,'./invitemadd.php'),(20803079,18777,'./invitemadd.php'),(20803078,5909,'./invitemadd.php'),(20803077,5908,'./invitemadd.php'),(20803076,13964,'./invitemadd.php'),(20803075,12738,'./invitemadd.php'),(20803074,6986,'./invitemadd.php'),(20803073,17010,'./invitemadd.php'),(20803072,15003,'./invitemadd.php'),(20803071,1766,'./invitemadd.php'),(20803070,1765,'./invitemadd.php'),(20803069,15138,'./invitemadd.php'),(20803068,12975,'./invitemadd.php'),(20803067,1724,'./invitemadd.php'),(20803066,7003,'./invitemadd.php'),(20803065,12974,'./invitemadd.php'),(20803064,5858,'./invitemadd.php'),(20803063,1709,'./invitemadd.php'),(20803062,5174,'./invitemadd.php'),(20803061,7002,'./invitemadd.php'),(20803060,1696,'./invitemadd.php'),(20803059,20127,'./invitemadd.php'),(20803058,1666,'./invitemadd.php'),(20803057,18772,'./invitemadd.php'),(20803056,18758,'./invitemadd.php'),(20803055,1607,'./invitemadd.php'),(20803054,15137,'./invitemadd.php'),(20803053,1598,'./invitemadd.php'),(20803005,3437,'./invitemactivity.php'),(20803004,3333,'./invitemactivity.php'),(20803003,3248,'./invitemactivity.php'),(20803002,3450,'./invitemactivity.php'),(20803001,3156,'./invitemactivity.php'),(20803000,3097,'./invitemactivity.php'),(20802999,11342,'./invitemactivity.php'),(20802998,3439,'./invitemactivity.php'),(20802997,2656,'./invitemactivity.php'),(20802996,18239,'./invitemactivity.php'),(20802995,2589,'./invitemactivity.php'),(20802994,2529,'./invitemactivity.php'),(20802993,2528,'./invitemactivity.php'),(20802992,3522,'./invitemactivity.php'),(20802991,6227,'./invitemactivity.php'),(20802990,2508,'./invitemactivity.php'),(20802989,3438,'./invitemactivity.php'),(20802988,2459,'./invitemactivity.php'),(20802987,2404,'./invitemactivity.php'),(20802986,2401,'./invitemactivity.php'),(20802985,3436,'./invitemactivity.php'),(20802984,2165,'./invitemactivity.php'),(20802983,5525,'./invitemactivity.php'),(20802982,3442,'./invitemactivity.php'),(20802981,3440,'./invitemactivity.php'),(20802980,2103,'./invitemactivity.php'),(20802979,1963,'./invitemactivity.php'),(20802978,1788,'./invitemactivity.php'),(20802977,1709,'./invitemactivity.php'),(20802976,3660,'./invitemactivity.php'),(20802975,1739,'./invitemactivity.php'),(20802974,1647,'./invitemactivity.php'),(20802973,1644,'./invitemactivity.php'),(20802972,3433,'./invitemactivity.php'),(20802971,7000,'./invitemactivity.php'),(20802970,3435,'./invitemactivity.php'),(20802969,3451,'./invitemactivity.php'),(20802968,18675,'./invitemactivity.php'),(20802967,8936,'./invitemactivity.php'),(20802966,9466,'./invitemactivity.php'),(20802965,1019,'./invitemactivity.php'),(20802964,869,'./invitemactivity.php'),(20802963,799,'./invitemactivity.php'),(20802962,737,'./invitemactivity.php'),(20802961,6226,'./invitemactivity.php'),(20802960,665,'./invitemactivity.php'),(20802959,616,'./invitemactivity.php'),(20802958,572,'./invitemactivity.php'),(20802957,9465,'./invitemactivity.php'),(20802956,337,'./invitemactivity.php'),(20802955,315,'./invitemactivity.php'),(20802954,209,'./invitemactivity.php'),(20802953,4127,'./invitemactivity.php'),(20802952,187,'./invitemactivity.php'),(20802948,13021,'./invexportimportcsv.php'),(20802947,13020,'./invexportimportcsv.php'),(20802946,13019,'./invexportimportcsv.php'),(20802945,13018,'./invexportimportcsv.php'),(20802944,9162,'./invexportimportcsv.php'),(20802943,3298,'./invexportimportcsv.php'),(20802942,3292,'./invexportimportcsv.php'),(20802941,13017,'./invexportimportcsv.php'),(20802940,13016,'./invexportimportcsv.php'),(20802939,3184,'./invexportimportcsv.php'),(20802938,13709,'./invexportimportcsv.php'),(20802937,13708,'./invexportimportcsv.php'),(20802936,13707,'./invexportimportcsv.php'),(20802935,13706,'./invexportimportcsv.php'),(20802934,13705,'./invexportimportcsv.php'),(20802933,13704,'./invexportimportcsv.php'),(20802932,13703,'./invexportimportcsv.php'),(20802931,13702,'./invexportimportcsv.php'),(20802930,13701,'./invexportimportcsv.php'),(20802929,13700,'./invexportimportcsv.php'),(20802928,13699,'./invexportimportcsv.php'),(20802927,13698,'./invexportimportcsv.php'),(20802926,13697,'./invexportimportcsv.php'),(20802925,13696,'./invexportimportcsv.php'),(20802924,13695,'./invexportimportcsv.php'),(20802923,13694,'./invexportimportcsv.php'),(20802922,2529,'./invexportimportcsv.php'),(20802921,2515,'./invexportimportcsv.php'),(20802920,2508,'./invexportimportcsv.php'),(20802919,16869,'./invexportimportcsv.php'),(20802918,13336,'./invexportimportcsv.php'),(20802917,16868,'./invexportimportcsv.php'),(20802916,13015,'./invexportimportcsv.php'),(20802915,15566,'./invexportimportcsv.php'),(20802914,15565,'./invexportimportcsv.php'),(20802913,13014,'./invexportimportcsv.php'),(20802912,8938,'./invexportimportcsv.php'),(20802911,1828,'./invexportimportcsv.php'),(20802910,6986,'./invexportimportcsv.php'),(20802909,1789,'./invexportimportcsv.php'),(20802908,13013,'./invexportimportcsv.php'),(20802907,1756,'./invexportimportcsv.php'),(20802906,13012,'./invexportimportcsv.php'),(20802898,13011,'./invexportimport.php'),(20802897,3292,'./invexportimport.php'),(20802896,3238,'./invexportimport.php'),(20802895,15305,'./invexportimport.php'),(20802894,15823,'./invexportimport.php'),(20802893,15238,'./invexportimport.php'),(20802892,15304,'./invexportimport.php'),(20802891,15180,'./invexportimport.php'),(20802890,13009,'./invexportimport.php'),(20802889,16676,'./invexportimport.php'),(20802888,5122,'./invexportimport.php'),(20802887,2765,'./invexportimport.php'),(20802886,11535,'./invexportimport.php'),(20802885,15237,'./invexportimport.php'),(20802884,15236,'./invexportimport.php'),(20802883,17917,'./invexportimport.php'),(20802882,13008,'./invexportimport.php'),(20802881,13007,'./invexportimport.php'),(20802880,13006,'./invexportimport.php'),(20802879,16671,'./invexportimport.php'),(20802878,13005,'./invexportimport.php'),(20802877,15178,'./invexportimport.php'),(20802876,16674,'./invexportimport.php'),(20802875,18058,'./invexportimport.php'),(20802874,15337,'./invexportimport.php'),(20802873,13004,'./invexportimport.php'),(20802872,13042,'./invexportimport.php'),(20802871,1726,'./invexportimport.php'),(20802870,1666,'./invexportimport.php'),(20802869,13003,'./invexportimport.php'),(20802868,13002,'./invexportimport.php'),(20802867,13001,'./invexportimport.php'),(20802866,15336,'./invexportimport.php'),(20802865,8547,'./invexportimport.php'),(20802864,15335,'./invexportimport.php'),(20802863,15334,'./invexportimport.php'),(20802862,1599,'./invexportimport.php'),(20802861,13000,'./invexportimport.php'),(20802860,14666,'./invexportimport.php'),(20802859,5271,'./invexportimport.php'),(20802858,12999,'./invexportimport.php'),(20802857,6378,'./invexportimport.php'),(20802856,12998,'./invexportimport.php'),(20802855,15235,'./invexportimport.php'),(20802854,12997,'./invexportimport.php'),(20802853,12996,'./invexportimport.php'),(20802852,12995,'./invexportimport.php'),(20802851,14683,'./invexportimport.php'),(20802850,13693,'./invexportimport.php'),(20802849,15234,'./invexportimport.php'),(20802848,1354,'./invexportimport.php'),(20802840,12222,'./inventory_transfers.php'),(20802839,13392,'./inventory_transfers.php'),(20802838,13391,'./inventory_transfers.php'),(20802837,3165,'./inventory_transfers.php'),(20802836,5173,'./inventory_transfers.php'),(20802835,13390,'./inventory_transfers.php'),(20802834,6965,'./inventory_transfers.php'),(20802833,8172,'./inventory_transfers.php'),(20802832,8171,'./inventory_transfers.php'),(20802831,13389,'./inventory_transfers.php'),(20802830,3072,'./inventory_transfers.php'),(20802829,12236,'./inventory_transfers.php'),(20802828,2702,'./inventory_transfers.php'),(20802827,8170,'./inventory_transfers.php'),(20802826,8169,'./inventory_transfers.php'),(20802825,2137,'./inventory_transfers.php'),(20802824,13388,'./inventory_transfers.php'),(20802823,2044,'./inventory_transfers.php'),(20802822,13387,'./inventory_transfers.php'),(20802821,1963,'./inventory_transfers.php'),(20802820,1788,'./inventory_transfers.php'),(20802819,8168,'./inventory_transfers.php'),(20802818,8174,'./inventory_transfers.php'),(20802817,8167,'./inventory_transfers.php'),(20802816,1724,'./inventory_transfers.php'),(20802815,8165,'./inventory_transfers.php'),(20802814,8164,'./inventory_transfers.php'),(20802813,8163,'./inventory_transfers.php'),(20802812,13386,'./inventory_transfers.php'),(20802811,1467,'./inventory_transfers.php'),(20802810,8936,'./inventory_transfers.php'),(20802809,869,'./inventory_transfers.php'),(20802808,13385,'./inventory_transfers.php'),(20802807,13384,'./inventory_transfers.php'),(20802806,315,'./inventory_transfers.php'),(20802805,9468,'./inventory_recalcFMLW.php'),(20802804,9464,'./inventory_recalcFMLW.php'),(20802803,9470,'./inventory_recalcFMLW.php'),(20681819,9362,'./inventory_realign.php'),(20802802,10590,'./inventory_pricecopy.php'),(20802801,10589,'./inventory_pricecopy.php'),(20802800,10588,'./inventory_pricecopy.php'),(20802799,1963,'./inventory_pricecopy.php'),(20802798,10593,'./inventory_pricecopy.php'),(20802797,10586,'./inventory_pricecopy.php'),(20802796,10585,'./inventory_pricecopy.php'),(20802795,14517,'./inventory_detail_pop.php'),(20802794,14505,'./inventory_detail_pop.php'),(20802793,3360,'./inventory_detail_pop.php'),(20802792,14898,'./inventory_detail_pop.php'),(20802791,3165,'./inventory_detail_pop.php'),(20802790,16676,'./inventory_detail_pop.php'),(20802789,13932,'./inventory_detail_pop.php'),(20802788,2886,'./inventory_detail_pop.php'),(20802787,6443,'./inventory_detail_pop.php'),(20802786,2508,'./inventory_detail_pop.php'),(20802785,11734,'./inventory_detail_pop.php'),(20802784,2405,'./inventory_detail_pop.php'),(20802783,2404,'./inventory_detail_pop.php'),(20802782,16671,'./inventory_detail_pop.php'),(20802781,2165,'./inventory_detail_pop.php'),(20802780,6448,'./inventory_detail_pop.php'),(20802779,6447,'./inventory_detail_pop.php'),(20802778,16674,'./inventory_detail_pop.php'),(20802777,1963,'./inventory_detail_pop.php'),(20802776,1788,'./inventory_detail_pop.php'),(20802775,19130,'./inventory_detail_pop.php'),(20802774,1756,'./inventory_detail_pop.php'),(20802773,6366,'./inventory_detail_pop.php'),(20802772,20126,'./inventory_detail_pop.php'),(20802771,16739,'./inventory_detail_pop.php'),(20802770,1598,'./inventory_detail_pop.php'),(20802769,14248,'./inventory_detail_pop.php'),(20802768,8936,'./inventory_detail_pop.php'),(20802767,737,'./inventory_detail_pop.php'),(20802766,4481,'./inventory_detail_pop.php'),(20802765,14504,'./inventory_detail_pop.php'),(20802764,15564,'./inventory_detail_pop.php'),(20802754,13304,'./inventory_costadjust.php'),(20802753,9110,'./inventory_costadjust.php'),(20802752,3090,'./inventory_costadjust.php'),(20802751,5172,'./inventory_costadjust.php'),(20802750,2702,'./inventory_costadjust.php'),(20802749,9122,'./inventory_costadjust.php'),(20802748,9121,'./inventory_costadjust.php'),(20802747,9120,'./inventory_costadjust.php'),(20802746,2515,'./inventory_costadjust.php'),(20802745,2361,'./inventory_costadjust.php'),(20802744,13303,'./inventory_costadjust.php'),(20802743,2162,'./inventory_costadjust.php'),(20802742,9119,'./inventory_costadjust.php'),(20802741,13302,'./inventory_costadjust.php'),(20802740,13301,'./inventory_costadjust.php'),(20802739,1963,'./inventory_costadjust.php'),(20802738,1788,'./inventory_costadjust.php'),(20802737,6366,'./inventory_costadjust.php'),(20802736,1724,'./inventory_costadjust.php'),(20802735,9123,'./inventory_costadjust.php'),(20802734,5171,'./inventory_costadjust.php'),(20802733,9118,'./inventory_costadjust.php'),(20802732,4130,'./inventory_costadjust.php'),(20802731,9107,'./inventory_costadjust.php'),(20802730,1499,'./inventory_costadjust.php'),(20802729,8936,'./inventory_costadjust.php'),(20802728,869,'./inventory_costadjust.php'),(20802727,13300,'./inventory_costadjust.php'),(20802726,13299,'./inventory_costadjust.php'),(20802725,13298,'./inventory_costadjust.php'),(20802724,13297,'./inventory_costadjust.php'),(20802723,567,'./inventory_costadjust.php'),(20802722,542,'./inventory_costadjust.php'),(20802721,9463,'./inventory_costadjust.php'),(20802720,315,'./inventory_costadjust.php'),(20802719,13296,'./inventory_costadjust.php'),(20802718,13295,'./inventory_costadjust.php'),(20802717,13294,'./inventory_costadjust.php'),(20802716,9116,'./inventory_costadjust.php'),(20802715,226,'./inventory_costadjust.php'),(20802714,13293,'./inventory_costadjust.php'),(20802713,13292,'./inventory_costadjust.php'),(20802712,8325,'./inventory_costadjust.php'),(20802711,9099,'./inventory_breakdown.php'),(20802710,3165,'./inventory_breakdown.php'),(20802709,5173,'./inventory_breakdown.php'),(20802708,8172,'./inventory_breakdown.php'),(20802707,9279,'./inventory_breakdown.php'),(20802706,2702,'./inventory_breakdown.php'),(20802705,9098,'./inventory_breakdown.php'),(20802704,9097,'./inventory_breakdown.php'),(20802703,9278,'./inventory_breakdown.php'),(20802702,2137,'./inventory_breakdown.php'),(20802701,2044,'./inventory_breakdown.php'),(20802700,1963,'./inventory_breakdown.php'),(20802699,1788,'./inventory_breakdown.php'),(20802698,1724,'./inventory_breakdown.php'),(20802697,9095,'./inventory_breakdown.php'),(20802696,9094,'./inventory_breakdown.php'),(20802695,9106,'./inventory_breakdown.php'),(20802694,9277,'./inventory_breakdown.php'),(20802693,8164,'./inventory_breakdown.php'),(20802692,8163,'./inventory_breakdown.php'),(20802691,4239,'./inventory_breakdown.php'),(20802690,869,'./inventory_breakdown.php'),(20802689,9092,'./inventory_breakdown.php'),(20802688,451,'./inventory_breakdown.php'),(20802687,9253,'./inventory_breakdown.php'),(20802686,315,'./inventory_breakdown.php'),(20802685,18294,'./inventory_adjustments.php'),(20802684,18293,'./inventory_adjustments.php'),(20802683,18292,'./inventory_adjustments.php'),(20802682,2702,'./inventory_adjustments.php'),(20802681,10989,'./inventory_adjustments.php'),(20802680,2367,'./inventory_adjustments.php'),(20802679,18291,'./inventory_adjustments.php'),(20802678,18290,'./inventory_adjustments.php'),(20802677,18289,'./inventory_adjustments.php'),(20802676,16670,'./inventory_adjustments.php'),(20802675,18288,'./inventory_adjustments.php'),(20802674,18287,'./inventory_adjustments.php'),(20802673,9519,'./inventory_adjustments.php'),(20802672,1788,'./inventory_adjustments.php'),(20802671,6366,'./inventory_adjustments.php'),(20802670,1724,'./inventory_adjustments.php'),(20802669,18286,'./inventory_adjustments.php'),(20802668,7156,'./inventory_adjustments.php'),(20802667,18285,'./inventory_adjustments.php'),(20802666,18284,'./inventory_adjustments.php'),(20802665,1696,'./inventory_adjustments.php'),(20802664,1666,'./inventory_adjustments.php'),(20802663,15991,'./inventory_adjustments.php'),(20802662,1499,'./inventory_adjustments.php'),(20802661,737,'./inventory_adjustments.php'),(20802647,19277,'./invcotransfer.php'),(20802646,19276,'./invcotransfer.php'),(20802645,5130,'./invcotransfer.php'),(20802644,19908,'./invcotransfer.php'),(20802643,3252,'./invcotransfer.php'),(20802642,18199,'./invcotransfer.php'),(20802641,9140,'./invcotransfer.php'),(20802640,16867,'./invcotransfer.php'),(20802639,13518,'./invcotransfer.php'),(20802638,13517,'./invcotransfer.php'),(20802637,20125,'./invcotransfer.php'),(20802636,13516,'./invcotransfer.php'),(20802635,16673,'./invcotransfer.php'),(20802634,19128,'./invcotransfer.php'),(20802633,16672,'./invcotransfer.php'),(20802632,11704,'./invcotransfer.php'),(20802631,13389,'./invcotransfer.php'),(20802630,8307,'./invcotransfer.php'),(20802629,3097,'./invcotransfer.php'),(20802628,3072,'./invcotransfer.php'),(20802627,3070,'./invcotransfer.php'),(20802626,3948,'./invcotransfer.php'),(20802625,16676,'./invcotransfer.php'),(20802624,2948,'./invcotransfer.php'),(20802623,19127,'./invcotransfer.php'),(20802622,16866,'./invcotransfer.php'),(20802621,2827,'./invcotransfer.php'),(20802620,5492,'./invcotransfer.php'),(20802619,13515,'./invcotransfer.php'),(20802618,2702,'./invcotransfer.php'),(20802617,17715,'./invcotransfer.php'),(20802616,16785,'./invcotransfer.php'),(20802615,10989,'./invcotransfer.php'),(20802614,2601,'./invcotransfer.php'),(20802613,5876,'./invcotransfer.php'),(20802612,4567,'./invcotransfer.php'),(20802611,2589,'./invcotransfer.php'),(20802610,2540,'./invcotransfer.php'),(20802609,2529,'./invcotransfer.php'),(20802608,13514,'./invcotransfer.php'),(20802607,16865,'./invcotransfer.php'),(20802606,16864,'./invcotransfer.php'),(20802605,11734,'./invcotransfer.php'),(20802604,4725,'./invcotransfer.php'),(20802603,2459,'./invcotransfer.php'),(20802602,8861,'./invcotransfer.php'),(20802601,2377,'./invcotransfer.php'),(20802600,2371,'./invcotransfer.php'),(20802599,13513,'./invcotransfer.php'),(20802598,20124,'./invcotransfer.php'),(20802543,13603,'./invcatpriceadjust.php'),(20802542,13602,'./invcatpriceadjust.php'),(20802541,13601,'./invcatpriceadjust.php'),(20802540,13600,'./invcatpriceadjust.php'),(20802539,13599,'./invcatpriceadjust.php'),(20802538,13598,'./invcatpriceadjust.php'),(20802537,13597,'./invcatpriceadjust.php'),(20802536,13596,'./invcatpriceadjust.php'),(20802535,8936,'./invcatpriceadjust.php'),(20802534,13605,'./invcatpriceadjust.php'),(20802533,13604,'./invcatpriceadjust.php'),(20802532,197,'./invcatpriceadjust.php'),(20802531,3129,'./invbeginbal.php'),(20802530,3072,'./invbeginbal.php'),(20802529,3045,'./invbeginbal.php'),(20802528,2960,'./invbeginbal.php'),(20802527,2901,'./invbeginbal.php'),(20802526,2874,'./invbeginbal.php'),(20802525,2744,'./invbeginbal.php'),(20802524,2742,'./invbeginbal.php'),(20802523,2702,'./invbeginbal.php'),(20802522,5810,'./invbeginbal.php'),(20802521,2627,'./invbeginbal.php'),(20802520,2626,'./invbeginbal.php'),(20802519,2401,'./invbeginbal.php'),(20802518,1963,'./invbeginbal.php'),(20802517,1839,'./invbeginbal.php'),(20802516,1788,'./invbeginbal.php'),(20802515,1725,'./invbeginbal.php'),(20802514,1709,'./invbeginbal.php'),(20802513,5809,'./invbeginbal.php'),(20802512,764,'./invbeginbal.php'),(20802511,5808,'./invbeginbal.php'),(20802510,5819,'./invbeginbal.php'),(20802509,451,'./invbeginbal.php'),(20802508,5807,'./invbeginbal.php'),(20802507,5806,'./invbeginbal.php'),(20802506,339,'./invbeginbal.php'),(20802505,315,'./invbeginbal.php'),(20802504,197,'./invbeginbal.php'),(20802503,15214,'./invai3dcartupd.php'),(20802502,15213,'./invai3dcartupd.php'),(20802501,4023,'./invai3dcartupd.php'),(20802500,15212,'./invai3dcartupd.php'),(20802499,15211,'./invai3dcartupd.php'),(20802498,9923,'./invai3dcartupd.php'),(20802497,15210,'./invai3dcartupd.php'),(20802496,2950,'./inv_report_common.inc'),(20802495,2901,'./inv_report_common.inc'),(20802494,2627,'./inv_report_common.inc'),(20802493,3444,'./inv_report_common.inc'),(20802492,3445,'./inv_report_common.inc'),(20802491,2333,'./inv_report_common.inc'),(20802490,16671,'./inv_report_common.inc'),(20802489,16669,'./inv_report_common.inc'),(20802488,6366,'./inv_report_common.inc'),(20802487,1724,'./inv_report_common.inc'),(20802486,1709,'./inv_report_common.inc'),(20802485,1666,'./inv_report_common.inc'),(20802484,12214,'./inv_report_common.inc'),(20802483,1424,'./inv_report_common.inc'),(20802482,3447,'./inv_report_common.inc'),(20802481,869,'./inv_report_common.inc'),(20803052,18961,'./invitemadd.php'),(20803051,13717,'./invitemadd.php'),(20803050,6079,'./invitemadd.php'),(20802477,6013,'./initial_setup.php'),(20802476,3299,'./initial_setup.php'),(20802475,3291,'./initial_setup.php'),(20802474,3158,'./initial_setup.php'),(20802473,3145,'./initial_setup.php'),(20802472,2915,'./initial_setup.php'),(20802471,2918,'./initial_setup.php'),(20802470,2815,'./initial_setup.php'),(20802469,2814,'./initial_setup.php'),(20802468,2807,'./initial_setup.php'),(20802467,2686,'./initial_setup.php'),(20802466,2682,'./initial_setup.php'),(20802465,2675,'./initial_setup.php'),(20802464,2567,'./initial_setup.php'),(20802463,2563,'./initial_setup.php'),(20802462,2405,'./initial_setup.php'),(20802461,2346,'./initial_setup.php'),(20802460,2291,'./initial_setup.php'),(20802459,2251,'./initial_setup.php'),(20802458,2284,'./initial_setup.php'),(20802457,2161,'./initial_setup.php'),(20802456,2160,'./initial_setup.php'),(20802455,1931,'./initial_setup.php'),(20802454,1930,'./initial_setup.php'),(20802453,1794,'./initial_setup.php'),(20802452,1701,'./initial_setup.php'),(20802451,1596,'./initial_setup.php'),(20802450,1633,'./initial_setup.php'),(20802449,1685,'./initial_setup.php'),(20802448,1647,'./initial_setup.php'),(20802447,1609,'./initial_setup.php'),(20802446,5073,'./initial_setup.php'),(20802445,1604,'./initial_setup.php'),(20802444,1531,'./initial_setup.php'),(20802443,1523,'./initial_setup.php'),(20802442,1432,'./initial_setup.php'),(20802441,1379,'./initial_setup.php'),(20802440,1346,'./initial_setup.php'),(20802439,779,'./initial_setup.php'),(20802438,565,'./initial_setup.php'),(20802437,591,'./initial_setup.php'),(20802436,3900,'./initial_setup.php'),(20802435,523,'./initial_setup.php'),(20802434,481,'./initial_setup.php'),(20802433,3519,'./initial_setup.php'),(20802432,350,'./initial_setup.php'),(20802431,215,'./initial_setup.php'),(20802430,208,'./initial_setup.php'),(20802429,206,'./initial_setup.php'),(20802428,201,'./initial_setup.php'),(20802427,199,'./initial_setup.php'),(20802426,196,'./initial_setup.php'),(20802425,32,'./initial_setup.php'),(20802424,41,'./initial_setup.php'),(20802423,2702,'./indexmain.php'),(20802422,2057,'./indexmain.php'),(20802421,2047,'./indexmain.php'),(20802420,1794,'./indexmain.php'),(20802419,1531,'./indexmain.php'),(20802418,657,'./indexmain.php'),(20802417,574,'./indexmain.php'),(20802416,75,'./indexmain.php'),(20681431,9300,'./importvivo.php'),(20681430,9299,'./importvivo.php'),(20681429,9298,'./importvivo.php'),(20681428,9297,'./importvivo.php'),(20681427,9296,'./importvivo.php'),(20681426,2765,'./importvivo.php'),(20681425,9295,'./importvivo.php'),(20681424,9294,'./importvivo.php'),(20681423,9293,'./importvivo.php'),(20681422,9292,'./importvivo.php'),(20681421,5271,'./importvivo.php'),(20681420,9291,'./importvivo.php'),(20681419,9290,'./importvivo.php'),(17485633,3432,'./importvendor.php'),(17485632,16058,'./importvendor.php'),(17485631,4109,'./importvendor.php'),(17485630,5701,'./importvendor.php'),(17485629,5700,'./importvendor.php'),(17485628,6141,'./importvendor.php'),(17485627,5699,'./importvendor.php'),(17485626,6997,'./importvendor.php'),(17485625,7667,'./importvendor.php'),(17485624,8546,'./importvendor.php'),(17485623,6995,'./importvendor.php'),(17485622,2936,'./importvendor.php'),(17485621,5698,'./importvendor.php'),(17485620,2765,'./importvendor.php'),(17485619,8545,'./importvendor.php'),(17485618,6993,'./importvendor.php'),(17485617,6992,'./importvendor.php'),(17485616,12920,'./importvendor.php'),(17485615,2325,'./importvendor.php'),(17485614,2324,'./importvendor.php'),(17485613,15611,'./importvendor.php'),(17485612,7365,'./importvendor.php'),(17485611,3470,'./importvendor.php'),(17485610,6987,'./importvendor.php'),(17485609,8544,'./importvendor.php'),(17485608,4720,'./importvendor.php'),(17485607,1770,'./importvendor.php'),(17485606,4084,'./importvendor.php'),(17485605,1758,'./importvendor.php'),(17485604,15552,'./importvendor.php'),(17485603,5702,'./importvendor.php'),(17485602,5271,'./importvendor.php'),(17485601,15612,'./importvendor.php'),(17485600,7362,'./importvendor.php'),(17485599,7361,'./importvendor.php'),(17485598,1429,'./importvendor.php'),(17485597,7663,'./importvendor.php'),(17485596,1381,'./importvendor.php'),(17485595,5697,'./importvendor.php'),(17485594,981,'./importvendor.php'),(17485593,14206,'./importvendor.php'),(17485592,698,'./importvendor.php'),(17485591,13383,'./importvendor.php'),(17485590,659,'./importvendor.php'),(17485589,581,'./importvendor.php'),(17485588,524,'./importvendor.php'),(20681418,3432,'./importstatetaxes.php'),(20681417,3405,'./importstatetaxes.php'),(20681416,5309,'./importstatetaxes.php'),(20681415,4109,'./importstatetaxes.php'),(20681414,3267,'./importstatetaxes.php'),(20681413,6997,'./importstatetaxes.php'),(20681412,7667,'./importstatetaxes.php'),(20681411,7792,'./importstatetaxes.php'),(20681410,2937,'./importstatetaxes.php'),(20681409,2936,'./importstatetaxes.php'),(20681408,7791,'./importstatetaxes.php'),(20681407,2882,'./importstatetaxes.php'),(20681406,2876,'./importstatetaxes.php'),(20681405,7790,'./importstatetaxes.php'),(20681404,2765,'./importstatetaxes.php'),(20681403,2663,'./importstatetaxes.php'),(20681402,6993,'./importstatetaxes.php'),(20681401,6992,'./importstatetaxes.php'),(20681400,7788,'./importstatetaxes.php'),(20681399,2325,'./importstatetaxes.php'),(20681398,2324,'./importstatetaxes.php'),(20681397,2251,'./importstatetaxes.php'),(20681396,7787,'./importstatetaxes.php'),(20681395,2243,'./importstatetaxes.php'),(20681394,7365,'./importstatetaxes.php'),(20681393,7786,'./importstatetaxes.php'),(20681392,5304,'./importstatetaxes.php'),(20681391,6987,'./importstatetaxes.php'),(20681390,6191,'./importstatetaxes.php'),(20681389,6190,'./importstatetaxes.php'),(20681388,1822,'./importstatetaxes.php'),(20681387,4720,'./importstatetaxes.php'),(20681386,1770,'./importstatetaxes.php'),(20681385,1758,'./importstatetaxes.php'),(20681384,12033,'./importstatetaxes.php'),(20681383,12032,'./importstatetaxes.php'),(20681382,5271,'./importstatetaxes.php'),(20681381,1561,'./importstatetaxes.php'),(20681380,1556,'./importstatetaxes.php'),(20681379,1545,'./importstatetaxes.php'),(20681378,1506,'./importstatetaxes.php'),(20681377,7362,'./importstatetaxes.php'),(20681376,7784,'./importstatetaxes.php'),(20681375,7663,'./importstatetaxes.php'),(20681374,1380,'./importstatetaxes.php'),(20681373,7783,'./importstatetaxes.php'),(20681372,7782,'./importstatetaxes.php'),(20681371,5697,'./importstatetaxes.php'),(20681370,981,'./importstatetaxes.php'),(20681369,741,'./importstatetaxes.php'),(20681368,7780,'./importstatetaxes.php'),(20681367,659,'./importstatetaxes.php'),(20681366,524,'./importstatetaxes.php'),(20681365,7779,'./importstatetaxes.php'),(20681364,315,'./importstatetaxes.php'),(20681363,185,'./importstatetaxes.php'),(20681362,55,'./importstatetaxes.php'),(20802415,9984,'./importrprrevenue.php'),(20802414,14896,'./importrprrevenue.php'),(20802413,14895,'./importrprrevenue.php'),(20802412,5420,'./importrprrevenue.php'),(20802411,9983,'./importrprrevenue.php'),(20802410,14809,'./importrprrevenue.php'),(20802409,2765,'./importrprrevenue.php'),(20802408,14808,'./importrprrevenue.php'),(20802407,1770,'./importrprrevenue.php'),(20802406,14807,'./importrprrevenue.php'),(20802405,14897,'./importrprrevenue.php'),(20802404,5271,'./importrprrevenue.php'),(20802403,9976,'./importrprrevenue.php'),(20802402,8936,'./importrprrevenue.php'),(20802401,14806,'./importrprrevenue.php'),(20802400,5144,'./importrprrevenue.php'),(20802399,5145,'./importrprrevenue.php'),(20802398,9984,'./importrprexpenses.php'),(20802397,14896,'./importrprexpenses.php'),(20802396,14895,'./importrprexpenses.php'),(20802395,5420,'./importrprexpenses.php'),(20802394,9983,'./importrprexpenses.php'),(20802393,2765,'./importrprexpenses.php'),(20802392,14894,'./importrprexpenses.php'),(20802391,14808,'./importrprexpenses.php'),(20802390,1770,'./importrprexpenses.php'),(20802389,14893,'./importrprexpenses.php'),(20802388,5271,'./importrprexpenses.php'),(20802387,1578,'./importrprexpenses.php'),(20802386,14892,'./importrprexpenses.php'),(20802385,9976,'./importrprexpenses.php'),(20802384,8936,'./importrprexpenses.php'),(20802383,8866,'./importrprexpenses.php'),(20802382,14806,'./importrprexpenses.php'),(20802381,14891,'./importrprexpenses.php'),(20802380,5145,'./importrprexpenses.php'),(20802379,14246,'./importoscom.php'),(20802378,2833,'./importoscom.php'),(20802377,12948,'./importoscom.php'),(20802376,14245,'./importoscom.php'),(20802375,6318,'./importoscom.php'),(20802374,14244,'./importoscom.php'),(20802373,12947,'./importoscom.php'),(20802372,9294,'./importoscom.php'),(20802371,2165,'./importoscom.php'),(20802370,12933,'./importoscom.php'),(20802369,14243,'./importoscom.php'),(20802368,1963,'./importoscom.php'),(20802367,14242,'./importoscom.php'),(20802366,14241,'./importoscom.php'),(20802365,14240,'./importoscom.php'),(20802364,11945,'./importoscom.php'),(20802363,10473,'./importoscom.php'),(20802362,8936,'./importoscom.php'),(20802361,10253,'./importoscom.php'),(20802360,697,'./importoscom.php'),(20802359,12930,'./importoscom.php'),(20802358,18048,'./importoscom.php'),(20802357,315,'./importoscom.php'),(20802356,12929,'./importoscom.php'),(20802355,226,'./importoscom.php'),(20681299,10475,'./importmycare2xinvoice.php'),(20681298,9420,'./importmycare2xinvoice.php'),(20681297,10474,'./importmycare2xinvoice.php'),(20681296,2765,'./importmycare2xinvoice.php'),(20681295,9294,'./importmycare2xinvoice.php'),(20681294,9418,'./importmycare2xinvoice.php'),(20681293,9292,'./importmycare2xinvoice.php'),(20681292,5271,'./importmycare2xinvoice.php'),(20681291,1404,'./importmycare2xinvoice.php'),(20681290,10473,'./importmycare2xinvoice.php'),(20681289,9290,'./importmycare2xinvoice.php'),(20681288,10472,'./importmycare2xinvoice.php'),(20802353,4109,'./importmagentoorders.php'),(20802352,2948,'./importmagentoorders.php'),(20802351,15102,'./importmagentoorders.php'),(20802350,2686,'./importmagentoorders.php'),(20802349,12948,'./importmagentoorders.php'),(20802348,12935,'./importmagentoorders.php'),(20802347,6318,'./importmagentoorders.php'),(20802346,2192,'./importmagentoorders.php'),(20802345,2182,'./importmagentoorders.php'),(20802344,15101,'./importmagentoorders.php'),(20802343,12947,'./importmagentoorders.php'),(20802342,9294,'./importmagentoorders.php'),(20802341,15100,'./importmagentoorders.php'),(20802340,12933,'./importmagentoorders.php'),(20802339,12932,'./importmagentoorders.php'),(20802338,2034,'./importmagentoorders.php'),(20802337,1963,'./importmagentoorders.php'),(20802336,15123,'./importmagentoorders.php'),(20802335,8273,'./importmagentoorders.php'),(20802334,9292,'./importmagentoorders.php'),(20802333,15099,'./importmagentoorders.php'),(20802332,5271,'./importmagentoorders.php'),(20802331,11945,'./importmagentoorders.php'),(20802330,15098,'./importmagentoorders.php'),(20802329,15097,'./importmagentoorders.php'),(20802328,9127,'./importmagentoorders.php'),(20802327,8936,'./importmagentoorders.php'),(20802326,1014,'./importmagentoorders.php'),(20802325,886,'./importmagentoorders.php'),(20802324,10253,'./importmagentoorders.php'),(20802323,737,'./importmagentoorders.php'),(20802322,697,'./importmagentoorders.php'),(20802321,15122,'./importmagentoorders.php'),(20802320,333,'./importmagentoorders.php'),(20802319,15121,'./importmagentoorders.php'),(20802318,12929,'./importmagentoorders.php'),(20802317,15096,'./importmagentoorders.php'),(20681250,9312,'./importitemsupc.php'),(20681249,9311,'./importitemsupc.php'),(20681248,9310,'./importitemsupc.php'),(20681247,2765,'./importitemsupc.php'),(20681246,9309,'./importitemsupc.php'),(20681245,9308,'./importitemsupc.php'),(20681244,5271,'./importitemsupc.php'),(20681243,9307,'./importitemsupc.php'),(20681242,6997,'./importitems_xpedx.php'),(20681241,9941,'./importitems_xpedx.php'),(20681240,7667,'./importitems_xpedx.php'),(20681239,6995,'./importitems_xpedx.php'),(20681238,7640,'./importitems_xpedx.php'),(20681237,2765,'./importitems_xpedx.php'),(20681236,9940,'./importitems_xpedx.php'),(20681235,6993,'./importitems_xpedx.php'),(20681234,6992,'./importitems_xpedx.php'),(20681233,6987,'./importitems_xpedx.php'),(20681232,6984,'./importitems_xpedx.php'),(20681231,6983,'./importitems_xpedx.php'),(20681230,9939,'./importitems_xpedx.php'),(20681229,5271,'./importitems_xpedx.php'),(20681228,7639,'./importitems_xpedx.php'),(20681227,7663,'./importitems_xpedx.php'),(20681226,8878,'./importitems_xpedx.php'),(20681225,8877,'./importitems_xpedx.php'),(20681224,9938,'./importitems_xpedx.php'),(20681223,315,'./importitems_xpedx.php'),(20802597,16767,'./invcotransfer.php'),(20802316,3373,'./importitems.php'),(20802315,3362,'./importitems.php'),(20802314,5309,'./importitems.php'),(20802313,3358,'./importitems.php'),(20802312,9162,'./importitems.php'),(20802311,9942,'./importitems.php'),(20802310,3292,'./importitems.php'),(20802309,13692,'./importitems.php'),(20802308,3256,'./importitems.php'),(20802307,3235,'./importitems.php'),(20802306,6997,'./importitems.php'),(20802305,7668,'./importitems.php'),(20802304,18631,'./importitems.php'),(20802303,7667,'./importitems.php'),(20802302,6996,'./importitems.php'),(20802301,6995,'./importitems.php'),(20802300,6994,'./importitems.php'),(20802299,9161,'./importitems.php'),(20802298,2950,'./importitems.php'),(20802297,13932,'./importitems.php'),(20802296,7640,'./importitems.php'),(20802295,2765,'./importitems.php'),(20802294,2673,'./importitems.php'),(20802293,6993,'./importitems.php'),(20802292,16675,'./importitems.php'),(20802291,6992,'./importitems.php'),(20802290,6991,'./importitems.php'),(20802289,7607,'./importitems.php'),(20802288,5880,'./importitems.php'),(20802287,17443,'./importitems.php'),(20802286,3777,'./importitems.php'),(20802285,6990,'./importitems.php'),(20802284,6989,'./importitems.php'),(20802283,16860,'./importitems.php'),(20802282,16859,'./importitems.php'),(20802281,16858,'./importitems.php'),(20802280,7666,'./importitems.php'),(20802279,2367,'./importitems.php'),(20802278,2333,'./importitems.php'),(20802277,7365,'./importitems.php'),(20802276,9160,'./importitems.php'),(20802275,16670,'./importitems.php'),(20802274,7665,'./importitems.php'),(20802273,18674,'./importitems.php'),(20802272,2103,'./importitems.php'),(20802271,16669,'./importitems.php'),(20802270,1973,'./importitems.php'),(20802269,1932,'./importitems.php'),(20802268,18777,'./importitems.php'),(20802267,5304,'./importitems.php'),(20802266,1913,'./importitems.php'),(20802265,6987,'./importitems.php'),(20802264,12737,'./importitems.php'),(20802263,6986,'./importitems.php'),(20802262,17010,'./importitems.php'),(20802261,8184,'./importitems.php'),(20802260,1789,'./importitems.php'),(20802259,18095,'./importitems.php'),(20802258,1765,'./importitems.php'),(20802257,6985,'./importitems.php'),(20802256,12975,'./importitems.php'),(20802255,12974,'./importitems.php'),(20802254,6984,'./importitems.php'),(20802253,4130,'./importitems.php'),(20802252,1666,'./importitems.php'),(20802251,6705,'./importitems.php'),(20802250,18673,'./importitems.php'),(20802249,18672,'./importitems.php'),(20802248,15552,'./importitems.php'),(20802247,7153,'./importitems.php'),(20802246,5271,'./importitems.php'),(20802245,7639,'./importitems.php'),(20802244,7606,'./importitems.php'),(20802243,7362,'./importitems.php'),(20802242,7361,'./importitems.php'),(20681125,3421,'./importitem_categories.php'),(20681124,7661,'./importitem_categories.php'),(20681123,7667,'./importitem_categories.php'),(20681122,6995,'./importitem_categories.php'),(20681121,2765,'./importitem_categories.php'),(20681120,7660,'./importitem_categories.php'),(20681119,7659,'./importitem_categories.php'),(20681118,7658,'./importitem_categories.php'),(20681117,7657,'./importitem_categories.php'),(20681116,7656,'./importitem_categories.php'),(20681115,7655,'./importitem_categories.php'),(20681114,7654,'./importitem_categories.php'),(20681113,7653,'./importitem_categories.php'),(20681112,7652,'./importitem_categories.php'),(20681111,7651,'./importitem_categories.php'),(20681110,7650,'./importitem_categories.php'),(20681109,7649,'./importitem_categories.php'),(20681108,2664,'./importitem_categories.php'),(20681107,6993,'./importitem_categories.php'),(20681106,16675,'./importitem_categories.php'),(20681105,6992,'./importitem_categories.php'),(20681104,7365,'./importitem_categories.php'),(20681103,6987,'./importitem_categories.php'),(20681102,1770,'./importitem_categories.php'),(20681101,8233,'./importitem_categories.php'),(20681100,7648,'./importitem_categories.php'),(20681099,15552,'./importitem_categories.php'),(20681098,11977,'./importitem_categories.php'),(20681097,5271,'./importitem_categories.php'),(20681096,1499,'./importitem_categories.php'),(20681095,7362,'./importitem_categories.php'),(20681094,7361,'./importitem_categories.php'),(20681093,7663,'./importitem_categories.php'),(20681085,13011,'./importinvoices_qb_alt.php'),(20681084,14218,'./importinvoices_qb_alt.php'),(20681083,14238,'./importinvoices_qb_alt.php'),(20681082,14237,'./importinvoices_qb_alt.php'),(20681081,14236,'./importinvoices_qb_alt.php'),(20681080,13009,'./importinvoices_qb_alt.php'),(20681079,14216,'./importinvoices_qb_alt.php'),(20681078,14235,'./importinvoices_qb_alt.php'),(20681077,2765,'./importinvoices_qb_alt.php'),(20681076,14805,'./importinvoices_qb_alt.php'),(20681075,14804,'./importinvoices_qb_alt.php'),(20681074,14803,'./importinvoices_qb_alt.php'),(20681073,4265,'./importinvoices_qb_alt.php'),(20681072,14232,'./importinvoices_qb_alt.php'),(20681071,14231,'./importinvoices_qb_alt.php'),(20681070,14213,'./importinvoices_qb_alt.php'),(20681069,15563,'./importinvoices_qb_alt.php'),(20681068,5340,'./importinvoices_qb_alt.php'),(20681067,5366,'./importinvoices_qb_alt.php'),(20681066,14230,'./importinvoices_qb_alt.php'),(20681065,15562,'./importinvoices_qb_alt.php'),(20681064,2099,'./importinvoices_qb_alt.php'),(20681063,15561,'./importinvoices_qb_alt.php'),(20681062,14229,'./importinvoices_qb_alt.php'),(20681061,14228,'./importinvoices_qb_alt.php'),(20681060,14227,'./importinvoices_qb_alt.php'),(20681059,14226,'./importinvoices_qb_alt.php'),(20681058,1935,'./importinvoices_qb_alt.php'),(20681057,14802,'./importinvoices_qb_alt.php'),(20681056,1770,'./importinvoices_qb_alt.php'),(20681055,14208,'./importinvoices_qb_alt.php'),(20681054,1678,'./importinvoices_qb_alt.php'),(20681053,14224,'./importinvoices_qb_alt.php'),(20681052,1672,'./importinvoices_qb_alt.php'),(20681051,14223,'./importinvoices_qb_alt.php'),(20681050,14222,'./importinvoices_qb_alt.php'),(20681049,7386,'./importinvoices_qb_alt.php'),(20681048,15560,'./importinvoices_qb_alt.php'),(20681047,15559,'./importinvoices_qb_alt.php'),(20681046,5271,'./importinvoices_qb_alt.php'),(20681045,14207,'./importinvoices_qb_alt.php'),(20681044,6978,'./importinvoices_qb_alt.php'),(20681043,15558,'./importinvoices_qb_alt.php'),(20681042,8936,'./importinvoices_qb_alt.php'),(20681041,15557,'./importinvoices_qb_alt.php'),(20681040,932,'./importinvoices_qb_alt.php'),(20681039,14206,'./importinvoices_qb_alt.php'),(20681038,14204,'./importinvoices_qb_alt.php'),(20681037,15556,'./importinvoices_qb_alt.php'),(20681036,14801,'./importinvoices_qb_alt.php'),(20681035,8730,'./importinvoices_qb_alt.php'),(20681034,697,'./importinvoices_qb_alt.php'),(20681033,14203,'./importinvoices_qb_alt.php'),(20681032,14221,'./importinvoices_qb_alt.php'),(20681031,315,'./importinvoices_qb_alt.php'),(20681030,5145,'./importinvoices_qb_alt.php'),(20681029,226,'./importinvoices_qb_alt.php'),(20681028,14800,'./importinvoices_qb_alt.php'),(20681027,14890,'./importinvoices_qb_alt.php'),(17485587,315,'./importvendor.php'),(20802219,13011,'./importinvoices.php'),(20802218,3358,'./importinvoices.php'),(20802217,14218,'./importinvoices.php'),(20802216,14238,'./importinvoices.php'),(20802215,14237,'./importinvoices.php'),(20802214,14236,'./importinvoices.php'),(20802213,16186,'./importinvoices.php'),(20802212,13009,'./importinvoices.php'),(20802211,14216,'./importinvoices.php'),(20802210,2838,'./importinvoices.php'),(20802209,14235,'./importinvoices.php'),(20802208,2765,'./importinvoices.php'),(20802207,16070,'./importinvoices.php'),(20802206,4265,'./importinvoices.php'),(20802205,18853,'./importinvoices.php'),(20802204,18146,'./importinvoices.php'),(20802203,14232,'./importinvoices.php'),(20802202,17496,'./importinvoices.php'),(20802201,16239,'./importinvoices.php'),(20802200,14231,'./importinvoices.php'),(20802199,16238,'./importinvoices.php'),(20802198,2363,'./importinvoices.php'),(20802197,14213,'./importinvoices.php'),(20802196,14230,'./importinvoices.php'),(20802195,18852,'./importinvoices.php'),(20802194,2099,'./importinvoices.php'),(20802193,14229,'./importinvoices.php'),(20802192,14228,'./importinvoices.php'),(20802191,14227,'./importinvoices.php'),(20802190,14226,'./importinvoices.php'),(20802189,16350,'./importinvoices.php'),(20802188,16349,'./importinvoices.php'),(20802187,1913,'./importinvoices.php'),(20802186,16237,'./importinvoices.php'),(20802185,9981,'./importinvoices.php'),(20802184,9622,'./importinvoices.php'),(20802183,14208,'./importinvoices.php'),(20802182,1678,'./importinvoices.php'),(20802181,17499,'./importinvoices.php'),(20802180,14224,'./importinvoices.php'),(20802179,1672,'./importinvoices.php'),(20802178,14223,'./importinvoices.php'),(20802177,14222,'./importinvoices.php'),(20802176,7386,'./importinvoices.php'),(20802175,1668,'./importinvoices.php'),(20802174,15552,'./importinvoices.php'),(20802173,5271,'./importinvoices.php'),(20802172,14207,'./importinvoices.php'),(20802171,18851,'./importinvoices.php'),(20802170,16041,'./importinvoices.php'),(20802169,15991,'./importinvoices.php'),(20802168,1373,'./importinvoices.php'),(20802167,8936,'./importinvoices.php'),(20802166,981,'./importinvoices.php'),(20802165,932,'./importinvoices.php'),(20802144,6997,'./importgltotals.php'),(20802143,7667,'./importgltotals.php'),(20802142,2765,'./importgltotals.php'),(20802141,6993,'./importgltotals.php'),(20802140,6992,'./importgltotals.php'),(20802139,7365,'./importgltotals.php'),(20802138,11878,'./importgltotals.php'),(20802137,6987,'./importgltotals.php'),(20802136,15552,'./importgltotals.php'),(20802135,6070,'./importgltotals.php'),(20802134,7370,'./importgltotals.php'),(20802133,5271,'./importgltotals.php'),(20802132,6391,'./importgltotals.php'),(20802131,6390,'./importgltotals.php'),(20802130,6978,'./importgltotals.php'),(20802129,1500,'./importgltotals.php'),(20802128,6067,'./importgltotals.php'),(20802127,5840,'./importgltotals.php'),(20802126,16484,'./importgltotals.php'),(20802125,7362,'./importgltotals.php'),(20802124,7361,'./importgltotals.php'),(20802123,7663,'./importgltotals.php'),(20802122,6066,'./importgltotals.php'),(20802121,737,'./importgltotals.php'),(20802120,9341,'./importgltotals.php'),(20802119,6065,'./importgltotals.php'),(20802116,3421,'./importgljournals.php'),(20802115,16665,'./importgljournals.php'),(20802114,5310,'./importgljournals.php'),(20802113,5309,'./importgljournals.php'),(20802112,13268,'./importgljournals.php'),(20802111,16268,'./importgljournals.php'),(20802110,3333,'./importgljournals.php'),(20802109,3269,'./importgljournals.php'),(20802108,6997,'./importgljournals.php'),(20802107,13267,'./importgljournals.php'),(20802106,6176,'./importgljournals.php'),(20802105,16450,'./importgljournals.php'),(20802104,16267,'./importgljournals.php'),(20802103,7667,'./importgljournals.php'),(20802102,13266,'./importgljournals.php'),(20802101,8148,'./importgljournals.php'),(20802100,2765,'./importgljournals.php'),(20802099,16020,'./importgljournals.php'),(20802098,16068,'./importgljournals.php'),(20802097,6993,'./importgljournals.php'),(20802096,6992,'./importgljournals.php'),(20802095,16067,'./importgljournals.php'),(20802094,16015,'./importgljournals.php'),(20802093,16065,'./importgljournals.php'),(20802092,16294,'./importgljournals.php'),(20802091,2070,'./importgljournals.php'),(20802090,1973,'./importgljournals.php'),(20802089,11878,'./importgljournals.php'),(20802088,5304,'./importgljournals.php'),(20802087,6987,'./importgljournals.php'),(20802086,10386,'./importgljournals.php'),(20802085,16266,'./importgljournals.php'),(20802084,1770,'./importgljournals.php'),(20802083,1746,'./importgljournals.php'),(20802082,5081,'./importgljournals.php'),(20802081,15552,'./importgljournals.php'),(20802080,13264,'./importgljournals.php'),(20802079,5271,'./importgljournals.php'),(20802078,13263,'./importgljournals.php'),(20802077,13262,'./importgljournals.php'),(20802076,17614,'./importgljournals.php'),(20802075,17751,'./importgljournals.php'),(20802074,15991,'./importgljournals.php'),(20802073,6978,'./importgljournals.php'),(20802072,1500,'./importgljournals.php'),(20802071,16309,'./importgljournals.php'),(20802070,7663,'./importgljournals.php'),(20802069,13261,'./importgljournals.php'),(20802068,17420,'./importgljournals.php'),(20802055,13011,'./importglbudgets.php'),(20802054,3415,'./importglbudgets.php'),(20802053,14218,'./importglbudgets.php'),(20802052,16186,'./importglbudgets.php'),(20802051,13009,'./importglbudgets.php'),(20802050,14216,'./importglbudgets.php'),(20802049,2765,'./importglbudgets.php'),(20802048,4265,'./importglbudgets.php'),(20802047,14213,'./importglbudgets.php'),(20802046,2099,'./importglbudgets.php'),(20802045,1935,'./importglbudgets.php'),(20802044,16063,'./importglbudgets.php'),(20802043,15552,'./importglbudgets.php'),(20802042,10065,'./importglbudgets.php'),(20802041,5271,'./importglbudgets.php'),(20802040,15991,'./importglbudgets.php'),(20802039,16062,'./importglbudgets.php'),(20802038,16061,'./importglbudgets.php'),(20802037,1500,'./importglbudgets.php'),(20802036,8936,'./importglbudgets.php'),(20802035,14206,'./importglbudgets.php'),(20802034,9492,'./importglbudgets.php'),(20802033,14203,'./importglbudgets.php'),(20802032,548,'./importglbudgets.php'),(20802031,16084,'./importglbudgets.php'),(20802030,16059,'./importglbudgets.php'),(20680833,3421,'./importeporders.php'),(20680832,13041,'./importeporders.php'),(20680831,13040,'./importeporders.php'),(20680830,1973,'./importeporders.php'),(20680829,13039,'./importeporders.php'),(20680828,13038,'./importeporders.php'),(20680827,13037,'./importeporders.php'),(20680826,8936,'./importeporders.php'),(20802026,16058,'./importemployeeexpenses.php'),(20802025,13011,'./importemployeeexpenses.php'),(20802024,16057,'./importemployeeexpenses.php'),(20802023,3274,'./importemployeeexpenses.php'),(20802022,14218,'./importemployeeexpenses.php'),(20802021,16186,'./importemployeeexpenses.php'),(20802020,13009,'./importemployeeexpenses.php'),(20802019,14216,'./importemployeeexpenses.php'),(20802018,15002,'./importemployeeexpenses.php'),(20802017,2765,'./importemployeeexpenses.php'),(20802016,4265,'./importemployeeexpenses.php'),(20802015,11433,'./importemployeeexpenses.php'),(20802014,15001,'./importemployeeexpenses.php'),(20802013,15000,'./importemployeeexpenses.php'),(20802012,14213,'./importemployeeexpenses.php'),(20802011,2099,'./importemployeeexpenses.php'),(20802010,16347,'./importemployeeexpenses.php'),(20802009,16857,'./importemployeeexpenses.php'),(20802008,14208,'./importemployeeexpenses.php'),(20802007,1678,'./importemployeeexpenses.php'),(20802006,1672,'./importemployeeexpenses.php'),(20802005,15552,'./importemployeeexpenses.php'),(20802004,15961,'./importemployeeexpenses.php'),(20802003,5271,'./importemployeeexpenses.php'),(20802002,14999,'./importemployeeexpenses.php'),(20802001,16041,'./importemployeeexpenses.php'),(20802000,15991,'./importemployeeexpenses.php'),(20801999,1500,'./importemployeeexpenses.php'),(20801998,8936,'./importemployeeexpenses.php'),(20801997,16055,'./importemployeeexpenses.php'),(20801996,16054,'./importemployeeexpenses.php'),(20801995,932,'./importemployeeexpenses.php'),(20801994,14206,'./importemployeeexpenses.php'),(20801993,16046,'./importemployeeexpenses.php'),(20801992,16039,'./importemployeeexpenses.php'),(20801984,3432,'./importemployee.php'),(20801983,3405,'./importemployee.php'),(20801982,5309,'./importemployee.php'),(20801981,4109,'./importemployee.php'),(20801980,3267,'./importemployee.php'),(20801979,6997,'./importemployee.php'),(20801978,7667,'./importemployee.php'),(20801977,6582,'./importemployee.php'),(20801976,7792,'./importemployee.php'),(20801975,2937,'./importemployee.php'),(20801974,2936,'./importemployee.php'),(20801973,7791,'./importemployee.php'),(20801972,2882,'./importemployee.php'),(20801971,2876,'./importemployee.php'),(20801970,7790,'./importemployee.php'),(20801969,2765,'./importemployee.php'),(20801968,7789,'./importemployee.php'),(20801967,2663,'./importemployee.php'),(20801966,6993,'./importemployee.php'),(20801965,6992,'./importemployee.php'),(20801964,7788,'./importemployee.php'),(20801963,2325,'./importemployee.php'),(20801962,2324,'./importemployee.php'),(20801961,2251,'./importemployee.php'),(20801960,7787,'./importemployee.php'),(20801959,2243,'./importemployee.php'),(20801958,7365,'./importemployee.php'),(20801957,7786,'./importemployee.php'),(20801956,5304,'./importemployee.php'),(20801955,6987,'./importemployee.php'),(20801954,6191,'./importemployee.php'),(20801953,6190,'./importemployee.php'),(20801952,1822,'./importemployee.php'),(20801951,4720,'./importemployee.php'),(20801950,1770,'./importemployee.php'),(20801949,1758,'./importemployee.php'),(20801948,15552,'./importemployee.php'),(20801947,12195,'./importemployee.php'),(20801946,7785,'./importemployee.php'),(20801945,5271,'./importemployee.php'),(20801944,1561,'./importemployee.php'),(20801943,1556,'./importemployee.php'),(20801942,1545,'./importemployee.php'),(20801941,1506,'./importemployee.php'),(20801940,7362,'./importemployee.php'),(20801939,7361,'./importemployee.php'),(20801938,7784,'./importemployee.php'),(20801937,7663,'./importemployee.php'),(20801936,1380,'./importemployee.php'),(20801935,7783,'./importemployee.php'),(20801934,7782,'./importemployee.php'),(20801933,5697,'./importemployee.php'),(20801932,981,'./importemployee.php'),(20801931,741,'./importemployee.php'),(20801930,7780,'./importemployee.php'),(20801929,659,'./importemployee.php'),(20801928,524,'./importemployee.php'),(20801927,7779,'./importemployee.php'),(20801926,315,'./importemployee.php'),(20801925,185,'./importemployee.php'),(20801924,55,'./importemployee.php'),(20801923,3432,'./importcustomer.php'),(20801922,3421,'./importcustomer.php'),(20801921,4109,'./importcustomer.php'),(20801920,6997,'./importcustomer.php'),(20801919,18671,'./importcustomer.php'),(20801918,16320,'./importcustomer.php'),(20801917,5766,'./importcustomer.php'),(20801916,7667,'./importcustomer.php'),(20801915,3010,'./importcustomer.php'),(20801914,8546,'./importcustomer.php'),(20801913,2936,'./importcustomer.php'),(20801912,18670,'./importcustomer.php'),(20801911,15852,'./importcustomer.php'),(20801910,7778,'./importcustomer.php'),(20801909,7777,'./importcustomer.php'),(20801908,5225,'./importcustomer.php'),(20801907,5763,'./importcustomer.php'),(20801906,17687,'./importcustomer.php'),(20801905,17215,'./importcustomer.php'),(20801904,17749,'./importcustomer.php'),(20801903,17748,'./importcustomer.php'),(20801902,17214,'./importcustomer.php'),(20801901,2765,'./importcustomer.php'),(20801900,2763,'./importcustomer.php'),(20801899,8545,'./importcustomer.php'),(20801898,5762,'./importcustomer.php'),(20801897,2691,'./importcustomer.php'),(20801896,5761,'./importcustomer.php'),(20801895,14789,'./importcustomer.php'),(20801894,6993,'./importcustomer.php'),(20801893,6992,'./importcustomer.php'),(20801892,2543,'./importcustomer.php'),(20801891,2542,'./importcustomer.php'),(20801890,5821,'./importcustomer.php'),(20801889,15851,'./importcustomer.php'),(20801888,15768,'./importcustomer.php'),(20801887,16238,'./importcustomer.php'),(20801886,2325,'./importcustomer.php'),(20801885,2324,'./importcustomer.php'),(20801884,7365,'./importcustomer.php'),(20801883,13768,'./importcustomer.php'),(20801882,15850,'./importcustomer.php'),(20801881,13767,'./importcustomer.php'),(20801880,15848,'./importcustomer.php'),(20801879,11122,'./importcustomer.php'),(20801878,2103,'./importcustomer.php'),(20801877,13766,'./importcustomer.php'),(20801876,11878,'./importcustomer.php'),(20801875,6987,'./importcustomer.php'),(20801874,8544,'./importcustomer.php'),(20801873,12736,'./importcustomer.php'),(20801872,4720,'./importcustomer.php'),(20801871,16237,'./importcustomer.php'),(20801870,1770,'./importcustomer.php'),(20801869,4084,'./importcustomer.php'),(20801868,1758,'./importcustomer.php'),(20801867,8505,'./importcustomer.php'),(20801866,1685,'./importcustomer.php'),(20801865,13765,'./importcustomer.php'),(20801864,15552,'./importcustomer.php'),(20801863,3644,'./importcustomer.php'),(20801862,7370,'./importcustomer.php'),(20801861,5271,'./importcustomer.php'),(20801860,5760,'./importcustomer.php'),(20801859,1519,'./importcustomer.php'),(20801858,7362,'./importcustomer.php'),(20801857,7361,'./importcustomer.php'),(20801856,1429,'./importcustomer.php'),(20801813,13011,'./importccpurchases.php'),(20801812,16856,'./importccpurchases.php'),(20801811,13017,'./importccpurchases.php'),(20801810,6141,'./importccpurchases.php'),(20801809,14218,'./importccpurchases.php'),(20801808,16186,'./importccpurchases.php'),(20801807,13009,'./importccpurchases.php'),(20801806,14216,'./importccpurchases.php'),(20801805,15002,'./importccpurchases.php'),(20801804,2765,'./importccpurchases.php'),(20801803,4265,'./importccpurchases.php'),(20801802,2504,'./importccpurchases.php'),(20801801,16052,'./importccpurchases.php'),(20801800,16051,'./importccpurchases.php'),(20801799,14213,'./importccpurchases.php'),(20801798,2099,'./importccpurchases.php'),(20801797,16347,'./importccpurchases.php'),(20801796,16855,'./importccpurchases.php'),(20801795,16049,'./importccpurchases.php'),(20801794,15552,'./importccpurchases.php'),(20801793,15960,'./importccpurchases.php'),(20801792,5271,'./importccpurchases.php'),(20801791,14999,'./importccpurchases.php'),(20801790,16854,'./importccpurchases.php'),(20801789,16048,'./importccpurchases.php'),(20801788,16041,'./importccpurchases.php'),(20801787,15991,'./importccpurchases.php'),(20801786,16047,'./importccpurchases.php'),(20801785,1500,'./importccpurchases.php'),(20801784,8936,'./importccpurchases.php'),(20801783,989,'./importccpurchases.php'),(20801782,14206,'./importccpurchases.php'),(20801781,16046,'./importccpurchases.php'),(20801780,737,'./importccpurchases.php'),(20801779,16039,'./importccpurchases.php'),(20801778,9492,'./importccpurchases.php'),(20801777,14203,'./importccpurchases.php'),(20801776,16853,'./importccpurchases.php'),(20801775,548,'./importccpurchases.php'),(20680563,9984,'./importbudgetposb.php'),(20680562,5420,'./importbudgetposb.php'),(20680561,9983,'./importbudgetposb.php'),(20680560,9982,'./importbudgetposb.php'),(20680559,2765,'./importbudgetposb.php'),(20680558,5270,'./importbudgetposb.php'),(20680557,11359,'./importbudgetposb.php'),(20680556,9981,'./importbudgetposb.php'),(20680555,9980,'./importbudgetposb.php'),(20680554,9622,'./importbudgetposb.php'),(20680553,9979,'./importbudgetposb.php'),(20680552,9978,'./importbudgetposb.php'),(20680551,9977,'./importbudgetposb.php'),(20680550,5271,'./importbudgetposb.php'),(20680549,9976,'./importbudgetposb.php'),(20680548,8936,'./importbudgetposb.php'),(20680547,8866,'./importbudgetposb.php'),(20680546,9975,'./importbudgetposb.php'),(20680545,9974,'./importbudgetposb.php'),(20680544,9492,'./importbudgetposb.php'),(20680543,9973,'./importbudgetposb.php'),(20680542,11358,'./importbudgetposb.php'),(20680541,451,'./importbudgetposb.php'),(20680540,11357,'./importbudgetposb.php'),(20680539,389,'./importbudgetposb.php'),(20801765,13011,'./importbills.php'),(20801764,3294,'./importbills.php'),(20801763,14219,'./importbills.php'),(20801762,3274,'./importbills.php'),(20801761,14218,'./importbills.php'),(20801760,14217,'./importbills.php'),(20801759,6176,'./importbills.php'),(20801758,12764,'./importbills.php'),(20801757,16186,'./importbills.php'),(20801756,13009,'./importbills.php'),(20801755,3035,'./importbills.php'),(20801754,14216,'./importbills.php'),(20801753,14215,'./importbills.php'),(20801752,15002,'./importbills.php'),(20801751,2765,'./importbills.php'),(20801750,4265,'./importbills.php'),(20801749,14214,'./importbills.php'),(20801748,15001,'./importbills.php'),(20801747,15000,'./importbills.php'),(20801746,14213,'./importbills.php'),(20801745,17418,'./importbills.php'),(20801744,5366,'./importbills.php'),(20801743,14212,'./importbills.php'),(20801742,2099,'./importbills.php'),(20801741,14211,'./importbills.php'),(20801740,16346,'./importbills.php'),(20801739,16345,'./importbills.php'),(20801738,14210,'./importbills.php'),(20801737,14209,'./importbills.php'),(20801736,18132,'./importbills.php'),(20801735,9981,'./importbills.php'),(20801734,9622,'./importbills.php'),(20801733,14208,'./importbills.php'),(20801732,1678,'./importbills.php'),(20801731,17417,'./importbills.php'),(20801730,1672,'./importbills.php'),(20801729,1668,'./importbills.php'),(20801728,15552,'./importbills.php'),(20801727,5271,'./importbills.php'),(20801726,14207,'./importbills.php'),(20801725,14999,'./importbills.php'),(20801724,16041,'./importbills.php'),(20801723,17751,'./importbills.php'),(20801722,15991,'./importbills.php'),(20801721,8936,'./importbills.php'),(20801720,17416,'./importbills.php'),(20801719,932,'./importbills.php'),(20801718,16040,'./importbills.php'),(20801717,14206,'./importbills.php'),(20801697,10465,'./importbankofx.php'),(20801696,10464,'./importbankofx.php'),(20801695,10463,'./importbankofx.php'),(20801694,10462,'./importbankofx.php'),(20801693,3156,'./importbankofx.php'),(20801692,10461,'./importbankofx.php'),(20801691,10460,'./importbankofx.php'),(20801690,14108,'./importbankofx.php'),(20801689,2765,'./importbankofx.php'),(20801688,10459,'./importbankofx.php'),(20801687,2702,'./importbankofx.php'),(20801686,6318,'./importbankofx.php'),(20801685,10458,'./importbankofx.php'),(20801684,10457,'./importbankofx.php'),(20801683,5786,'./importbankofx.php'),(20801682,2103,'./importbankofx.php'),(20801681,17068,'./importbankofx.php'),(20801680,14682,'./importbankofx.php'),(20801679,6505,'./importbankofx.php'),(20801678,10456,'./importbankofx.php'),(20801677,14760,'./importbankofx.php'),(20801676,10452,'./importbankofx.php'),(20801675,5271,'./importbankofx.php'),(20801674,10451,'./importbankofx.php'),(20801673,10450,'./importbankofx.php'),(20801672,8936,'./importbankofx.php'),(20801671,10449,'./importbankofx.php'),(20801670,5891,'./importbankofx.php'),(20801669,6054,'./importbankofx.php'),(20801668,941,'./importbankofx.php'),(20801667,14681,'./importbankofx.php'),(20801666,4065,'./importbankofx.php'),(20801665,10253,'./importbankofx.php'),(20801664,799,'./importbankofx.php'),(20801663,737,'./importbankofx.php'),(20801662,10448,'./importbankofx.php'),(20801661,479,'./importbankofx.php'),(20801660,10447,'./importbankofx.php'),(20801659,10446,'./importbankofx.php'),(20801658,10445,'./importbankofx.php'),(20801657,10444,'./importbankofx.php'),(20801656,5430,'./importbankofx.php'),(20801655,315,'./importbankofx.php'),(20801654,8125,'./importbankofx.php'),(20801653,226,'./importbankofx.php'),(20801652,47,'./importbankofx.php'),(20801651,20,'./importbankofx.php'),(20801650,10407,'./importbankofx.php'),(20801649,13011,'./importauthnettrans.php'),(20801648,6965,'./importauthnettrans.php'),(20801647,11704,'./importauthnettrans.php'),(20801646,14385,'./importauthnettrans.php'),(20801645,6964,'./importauthnettrans.php'),(20801644,3090,'./importauthnettrans.php'),(20801643,3072,'./importauthnettrans.php'),(20801642,13009,'./importauthnettrans.php'),(20801641,14384,'./importauthnettrans.php'),(20801640,14383,'./importauthnettrans.php'),(20801639,2765,'./importauthnettrans.php'),(20801638,2702,'./importauthnettrans.php'),(20801637,14382,'./importauthnettrans.php'),(20801636,2601,'./importauthnettrans.php'),(20801635,14381,'./importauthnettrans.php'),(20801634,14380,'./importauthnettrans.php'),(20801633,14379,'./importauthnettrans.php'),(20801632,14378,'./importauthnettrans.php'),(20801631,14377,'./importauthnettrans.php'),(20801630,14376,'./importauthnettrans.php'),(20801629,2165,'./importauthnettrans.php'),(20801628,14375,'./importauthnettrans.php'),(20801627,14374,'./importauthnettrans.php'),(20801626,1668,'./importauthnettrans.php'),(20801625,14373,'./importauthnettrans.php'),(20801624,5271,'./importauthnettrans.php'),(20801623,4106,'./importauthnettrans.php'),(20801622,1467,'./importauthnettrans.php'),(20801621,8936,'./importauthnettrans.php'),(20801620,737,'./importauthnettrans.php'),(20801619,697,'./importauthnettrans.php'),(20801618,6697,'./importauthnettrans.php'),(20801617,315,'./importauthnettrans.php'),(20801616,14372,'./importauthnettrans.php'),(20801615,226,'./importauthnettrans.php'),(20801614,14371,'./importauthnettrans.php'),(20801613,14370,'./importauthnettrans.php'),(20801612,47,'./importauthnettrans.php'),(20680384,3292,'./importapbills.php'),(20680383,6979,'./importapbills.php'),(20680382,6997,'./importapbills.php'),(20680381,3090,'./importapbills.php'),(20680380,7667,'./importapbills.php'),(20680379,7640,'./importapbills.php'),(20680378,2765,'./importapbills.php'),(20680377,6131,'./importapbills.php'),(20680376,6993,'./importapbills.php'),(20680375,6992,'./importapbills.php'),(20680374,7365,'./importapbills.php'),(20680373,6987,'./importapbills.php'),(20680372,1678,'./importapbills.php'),(20680371,5271,'./importapbills.php'),(20680370,7639,'./importapbills.php'),(20680369,6978,'./importapbills.php'),(20680368,7362,'./importapbills.php'),(20680367,7361,'./importapbills.php'),(20680366,7663,'./importapbills.php'),(20680365,932,'./importapbills.php'),(20680364,892,'./importapbills.php'),(20680363,890,'./importapbills.php'),(20680362,6977,'./importapbills.php'),(20680361,315,'./importapbills.php'),(20680360,6059,'./importapbills.php'),(20680359,7394,'./import_qbvendor.php'),(20680358,5699,'./import_qbvendor.php'),(20680357,6998,'./import_qbvendor.php'),(20680356,6995,'./import_qbvendor.php'),(20680355,5698,'./import_qbvendor.php'),(20680354,2765,'./import_qbvendor.php'),(20680353,7365,'./import_qbvendor.php'),(20680352,5702,'./import_qbvendor.php'),(20680351,7393,'./import_qbvendor.php'),(20680350,5271,'./import_qbvendor.php'),(20680349,7362,'./import_qbvendor.php'),(20680348,7361,'./import_qbvendor.php'),(20680347,1373,'./import_qbvendor.php'),(20680346,7283,'./import_qbvendor.php'),(20680345,315,'./import_qbvendor.php'),(20680344,6997,'./import_qbitems.php'),(20680343,6995,'./import_qbitems.php'),(20680342,7392,'./import_qbitems.php'),(20680341,7391,'./import_qbitems.php'),(20680340,2765,'./import_qbitems.php'),(20680339,6993,'./import_qbitems.php'),(20680338,6992,'./import_qbitems.php'),(20680337,7365,'./import_qbitems.php'),(20680336,6987,'./import_qbitems.php'),(20680335,6984,'./import_qbitems.php'),(20680334,7390,'./import_qbitems.php'),(20680333,6983,'./import_qbitems.php'),(20680332,5271,'./import_qbitems.php'),(20680331,7362,'./import_qbitems.php'),(20680330,7361,'./import_qbitems.php'),(20680329,7283,'./import_qbitems.php'),(20680328,315,'./import_qbitems.php'),(20680327,3233,'./import_qbinvoices.php'),(20680326,7389,'./import_qbinvoices.php'),(20680325,2765,'./import_qbinvoices.php'),(20680324,7388,'./import_qbinvoices.php'),(20680323,7387,'./import_qbinvoices.php'),(20680322,7386,'./import_qbinvoices.php'),(20680321,7383,'./import_qbinvoices.php'),(20680320,5271,'./import_qbinvoices.php'),(20680319,5362,'./import_qbinvoices.php'),(20680318,7283,'./import_qbinvoices.php'),(20680317,716,'./import_qbinvoices.php'),(20680316,315,'./import_qbinvoices.php'),(18632906,3233,'./import_qbinvoicepayment.php'),(18632905,7374,'./import_qbinvoicepayment.php'),(18632904,2765,'./import_qbinvoicepayment.php'),(18632903,7385,'./import_qbinvoicepayment.php'),(18632902,7356,'./import_qbinvoicepayment.php'),(18632901,7384,'./import_qbinvoicepayment.php'),(18632900,7383,'./import_qbinvoicepayment.php'),(18632899,5271,'./import_qbinvoicepayment.php'),(18632898,5362,'./import_qbinvoicepayment.php'),(18632897,7283,'./import_qbinvoicepayment.php'),(18632896,315,'./import_qbinvoicepayment.php'),(20680315,3233,'./import_qbemployee.php'),(20680314,7374,'./import_qbemployee.php'),(20680313,2765,'./import_qbemployee.php'),(20680312,7382,'./import_qbemployee.php'),(20680311,7381,'./import_qbemployee.php'),(20680310,7380,'./import_qbemployee.php'),(20680309,7379,'./import_qbemployee.php'),(20680308,5271,'./import_qbemployee.php'),(20680307,5362,'./import_qbemployee.php'),(20680306,7283,'./import_qbemployee.php'),(20680305,315,'./import_qbemployee.php'),(20680304,3233,'./import_qbcustomer.php'),(20680303,5766,'./import_qbcustomer.php'),(20680302,2765,'./import_qbcustomer.php'),(20680301,2763,'./import_qbcustomer.php'),(20680300,7365,'./import_qbcustomer.php'),(20680299,7378,'./import_qbcustomer.php'),(20680298,3644,'./import_qbcustomer.php'),(20680297,5271,'./import_qbcustomer.php'),(20680296,7362,'./import_qbcustomer.php'),(20680295,7361,'./import_qbcustomer.php'),(20680294,1373,'./import_qbcustomer.php'),(20680293,5362,'./import_qbcustomer.php'),(20680292,7283,'./import_qbcustomer.php'),(20680291,708,'./import_qbcustomer.php'),(20680290,734,'./import_qbcustomer.php'),(20680289,315,'./import_qbcustomer.php'),(18632868,3233,'./import_qbcreditmemopayment.php'),(18632867,7374,'./import_qbcreditmemopayment.php'),(18632866,2765,'./import_qbcreditmemopayment.php'),(18632865,7377,'./import_qbcreditmemopayment.php'),(18632864,7356,'./import_qbcreditmemopayment.php'),(18632863,7376,'./import_qbcreditmemopayment.php'),(18632862,7375,'./import_qbcreditmemopayment.php'),(18632861,5271,'./import_qbcreditmemopayment.php'),(18632860,5362,'./import_qbcreditmemopayment.php'),(18632859,7283,'./import_qbcreditmemopayment.php'),(18632858,315,'./import_qbcreditmemopayment.php'),(20680288,3233,'./import_qbcreditmemo.php'),(20680287,7374,'./import_qbcreditmemo.php'),(20680286,2765,'./import_qbcreditmemo.php'),(20680285,7373,'./import_qbcreditmemo.php'),(20680284,7372,'./import_qbcreditmemo.php'),(20680283,7371,'./import_qbcreditmemo.php'),(20680282,7370,'./import_qbcreditmemo.php'),(20680281,5271,'./import_qbcreditmemo.php'),(20680280,5362,'./import_qbcreditmemo.php'),(20680279,7283,'./import_qbcreditmemo.php'),(20680278,716,'./import_qbcreditmemo.php'),(20680277,315,'./import_qbcreditmemo.php'),(20680276,3294,'./import_qbbills.php'),(20680275,3233,'./import_qbbills.php'),(20680274,7369,'./import_qbbills.php'),(20680273,2765,'./import_qbbills.php'),(20680272,7368,'./import_qbbills.php'),(20680271,7367,'./import_qbbills.php'),(20680270,7366,'./import_qbbills.php'),(20680269,7365,'./import_qbbills.php'),(20680268,7364,'./import_qbbills.php'),(20680267,7363,'./import_qbbills.php'),(20680266,5271,'./import_qbbills.php'),(20680265,7362,'./import_qbbills.php'),(20680264,7361,'./import_qbbills.php'),(20680263,5362,'./import_qbbills.php'),(20680262,7283,'./import_qbbills.php'),(20680261,7360,'./import_qbbills.php'),(20680260,315,'./import_qbbills.php'),(20680259,3233,'./import_qbbillpayments.php'),(20680258,7359,'./import_qbbillpayments.php'),(20680257,2765,'./import_qbbillpayments.php'),(20680256,7358,'./import_qbbillpayments.php'),(20680255,7357,'./import_qbbillpayments.php'),(20680254,7356,'./import_qbbillpayments.php'),(20680253,7355,'./import_qbbillpayments.php'),(20680252,7354,'./import_qbbillpayments.php'),(20680251,5271,'./import_qbbillpayments.php'),(20680250,5362,'./import_qbbillpayments.php'),(20680249,7283,'./import_qbbillpayments.php'),(20680248,315,'./import_qbbillpayments.php'),(20680247,6997,'./import_nssales.php'),(20680246,3172,'./import_nssales.php'),(20680245,7353,'./import_nssales.php'),(20680244,6995,'./import_nssales.php'),(20680243,7336,'./import_nssales.php'),(20680242,7352,'./import_nssales.php'),(20680241,2765,'./import_nssales.php'),(20680240,6993,'./import_nssales.php'),(20680239,6992,'./import_nssales.php'),(20680238,2529,'./import_nssales.php'),(20680237,2363,'./import_nssales.php'),(20680236,1973,'./import_nssales.php'),(20680235,1935,'./import_nssales.php'),(20680234,6987,'./import_nssales.php'),(20680233,7351,'./import_nssales.php'),(20680232,6984,'./import_nssales.php'),(20680231,7350,'./import_nssales.php'),(20680230,7349,'./import_nssales.php'),(20680229,5271,'./import_nssales.php'),(20680228,981,'./import_nssales.php'),(20680227,7283,'./import_nssales.php'),(20680226,5101,'./import_nssales.php'),(20680225,737,'./import_nssales.php'),(20680224,7348,'./import_nssales.php'),(20680223,567,'./import_nssales.php'),(20680222,7280,'./import_nssales.php'),(20680221,7347,'./import_nssales.php'),(20680220,315,'./import_nssales.php'),(20680219,7346,'./import_nsitems.php'),(20680218,3360,'./import_nsitems.php'),(20680217,3297,'./import_nsitems.php'),(20680216,7345,'./import_nsitems.php'),(20680215,6997,'./import_nsitems.php'),(20680214,7344,'./import_nsitems.php'),(20680213,3156,'./import_nsitems.php'),(20680212,7343,'./import_nsitems.php'),(20680211,7342,'./import_nsitems.php'),(20680210,3030,'./import_nsitems.php'),(20680209,6995,'./import_nsitems.php'),(20680208,4289,'./import_nsitems.php'),(20680207,7341,'./import_nsitems.php'),(20680206,7340,'./import_nsitems.php'),(20680205,7339,'./import_nsitems.php'),(20680204,7338,'./import_nsitems.php'),(20680203,7337,'./import_nsitems.php'),(20680202,7336,'./import_nsitems.php'),(20680201,7335,'./import_nsitems.php'),(20680200,7334,'./import_nsitems.php'),(20680199,7333,'./import_nsitems.php'),(20680198,7332,'./import_nsitems.php'),(20680197,7331,'./import_nsitems.php'),(20680196,7330,'./import_nsitems.php'),(20680195,7329,'./import_nsitems.php'),(20680194,7328,'./import_nsitems.php'),(20680193,2765,'./import_nsitems.php'),(20680192,7327,'./import_nsitems.php'),(20680191,7326,'./import_nsitems.php'),(20680190,6993,'./import_nsitems.php'),(20680189,7325,'./import_nsitems.php'),(20680188,6992,'./import_nsitems.php'),(20680187,7324,'./import_nsitems.php'),(20680186,2503,'./import_nsitems.php'),(20680185,7323,'./import_nsitems.php'),(20680184,7322,'./import_nsitems.php'),(20680183,7321,'./import_nsitems.php'),(20680182,7320,'./import_nsitems.php'),(20680181,7319,'./import_nsitems.php'),(20680180,7318,'./import_nsitems.php'),(20680179,6444,'./import_nsitems.php'),(20680178,7317,'./import_nsitems.php'),(20680177,7316,'./import_nsitems.php'),(20680176,7315,'./import_nsitems.php'),(20680175,7314,'./import_nsitems.php'),(20680174,7313,'./import_nsitems.php'),(20680173,4075,'./import_nsitems.php'),(20680172,7312,'./import_nsitems.php'),(20680171,7311,'./import_nsitems.php'),(20680170,1935,'./import_nsitems.php'),(20680169,7310,'./import_nsitems.php'),(20680168,6987,'./import_nsitems.php'),(20680167,7309,'./import_nsitems.php'),(20680166,6986,'./import_nsitems.php'),(20680165,7308,'./import_nsitems.php'),(20680164,7307,'./import_nsitems.php'),(20680163,7306,'./import_nsitems.php'),(20680162,7305,'./import_nsitems.php'),(20680161,6984,'./import_nsitems.php'),(20680160,7304,'./import_nsitems.php'),(20680159,7303,'./import_nsitems.php'),(20680158,7302,'./import_nsitems.php'),(20680157,1598,'./import_nsitems.php'),(20680156,6983,'./import_nsitems.php'),(20680155,5271,'./import_nsitems.php'),(20680154,1588,'./import_nsitems.php'),(20680153,7301,'./import_nsitems.php'),(20680152,7300,'./import_nsitems.php'),(20680151,7299,'./import_nsitems.php'),(20680150,7298,'./import_nsitems.php'),(20680149,7297,'./import_nsitems.php'),(20680148,7296,'./import_nsitems.php'),(20680147,7295,'./import_nsitems.php'),(20680146,7294,'./import_nsitems.php'),(20680145,7293,'./import_nsitems.php'),(20680144,7292,'./import_nsitems.php'),(20680143,7291,'./import_nsitems.php'),(20680142,7290,'./import_nsitems.php'),(20680141,7289,'./import_nsitems.php'),(20680140,7288,'./import_nsitems.php'),(20680139,7287,'./import_nsitems.php'),(20680138,7286,'./import_nsitems.php'),(20680137,869,'./import_nsitems.php'),(20680136,7285,'./import_nsitems.php'),(20680135,7284,'./import_nsitems.php'),(20680134,7283,'./import_nsitems.php'),(20680133,739,'./import_nsitems.php'),(20680132,7282,'./import_nsitems.php'),(20680131,7281,'./import_nsitems.php'),(20680130,572,'./import_nsitems.php'),(20680129,7280,'./import_nsitems.php'),(20680128,7279,'./import_nsitems.php'),(20680127,6829,'./import_nsitems.php'),(20680126,451,'./import_nsitems.php'),(20680125,7278,'./import_nsitems.php'),(20680124,7277,'./import_nsitems.php'),(20680123,315,'./import_nsitems.php'),(20680122,6314,'./import_nsitems.php'),(20680121,7276,'./import_nsitems.php'),(20680120,6997,'./import_itembegbal.php'),(20680119,7667,'./import_itembegbal.php'),(20680118,6995,'./import_itembegbal.php'),(20680117,7640,'./import_itembegbal.php'),(20680116,2765,'./import_itembegbal.php'),(20680115,6993,'./import_itembegbal.php'),(20680114,6992,'./import_itembegbal.php'),(20680113,7365,'./import_itembegbal.php'),(20680112,2137,'./import_itembegbal.php'),(20680111,1929,'./import_itembegbal.php'),(20680110,6987,'./import_itembegbal.php'),(20680109,4130,'./import_itembegbal.php'),(20680108,6983,'./import_itembegbal.php'),(20680107,5271,'./import_itembegbal.php'),(20680106,7639,'./import_itembegbal.php'),(20680105,7362,'./import_itembegbal.php'),(20680104,7361,'./import_itembegbal.php'),(20680103,7663,'./import_itembegbal.php'),(20680102,634,'./import_itembegbal.php'),(20680101,315,'./import_itembegbal.php'),(20801611,13865,'./import_invitembuildorder.php'),(20801610,6997,'./import_invitembuildorder.php'),(20801609,7667,'./import_invitembuildorder.php'),(20801608,12908,'./import_invitembuildorder.php'),(20801607,12205,'./import_invitembuildorder.php'),(20801606,2765,'./import_invitembuildorder.php'),(20801605,6993,'./import_invitembuildorder.php'),(20801604,6992,'./import_invitembuildorder.php'),(20801603,7365,'./import_invitembuildorder.php'),(20801602,6987,'./import_invitembuildorder.php'),(20801601,12907,'./import_invitembuildorder.php'),(20801600,12904,'./import_invitembuildorder.php'),(20801599,15552,'./import_invitembuildorder.php'),(20801598,12033,'./import_invitembuildorder.php'),(20801597,12903,'./import_invitembuildorder.php'),(20801596,12906,'./import_invitembuildorder.php'),(20801595,5271,'./import_invitembuildorder.php'),(20801594,7362,'./import_invitembuildorder.php'),(20801593,7361,'./import_invitembuildorder.php'),(20801592,12901,'./import_invitembuildorder.php'),(20801591,7663,'./import_invitembuildorder.php'),(20801590,315,'./import_invitembuildorder.php'),(20801589,288,'./import_invitembuildorder.php'),(20801588,287,'./import_invitembuildorder.php'),(20680076,5964,'./import_docbooks.php'),(20680075,5904,'./import_docbooks.php'),(20801587,3233,'./import_distributor_sales.php'),(20801586,3097,'./import_distributor_sales.php'),(20801585,2826,'./import_distributor_sales.php'),(20801584,2765,'./import_distributor_sales.php'),(20801583,2182,'./import_distributor_sales.php'),(20801582,6974,'./import_distributor_sales.php'),(20801581,6973,'./import_distributor_sales.php'),(20801580,2099,'./import_distributor_sales.php'),(20801579,1709,'./import_distributor_sales.php'),(20801578,15552,'./import_distributor_sales.php'),(20801577,5271,'./import_distributor_sales.php'),(20801576,6972,'./import_distributor_sales.php'),(20801575,6971,'./import_distributor_sales.php'),(20801574,6970,'./import_distributor_sales.php'),(20801573,6969,'./import_distributor_sales.php'),(20801572,4481,'./import_distributor_sales.php'),(20801571,315,'./import_distributor_sales.php'),(20680057,6997,'./import_custominvoices.php'),(20680056,7389,'./import_custominvoices.php'),(20680055,7667,'./import_custominvoices.php'),(20680054,2765,'./import_custominvoices.php'),(20680053,7365,'./import_custominvoices.php'),(20680052,7386,'./import_custominvoices.php'),(20680051,7383,'./import_custominvoices.php'),(20680050,5271,'./import_custominvoices.php'),(20680049,7362,'./import_custominvoices.php'),(20680048,7361,'./import_custominvoices.php'),(20680047,7663,'./import_custominvoices.php'),(20680046,5362,'./import_custominvoices.php'),(20680045,315,'./import_custominvoices.php'),(20801570,3373,'./import_coastpaper.php'),(20801569,6092,'./import_coastpaper.php'),(20801568,3360,'./import_coastpaper.php'),(20801567,3274,'./import_coastpaper.php'),(20801566,6091,'./import_coastpaper.php'),(20801565,3233,'./import_coastpaper.php'),(20801564,6090,'./import_coastpaper.php'),(20801563,6089,'./import_coastpaper.php'),(20801562,6088,'./import_coastpaper.php'),(20801561,6087,'./import_coastpaper.php'),(20801560,6086,'./import_coastpaper.php'),(20801559,6085,'./import_coastpaper.php'),(20801558,2765,'./import_coastpaper.php'),(20801557,6084,'./import_coastpaper.php'),(20801556,6083,'./import_coastpaper.php'),(20801555,2404,'./import_coastpaper.php'),(20801554,6082,'./import_coastpaper.php'),(20801553,6081,'./import_coastpaper.php'),(20801552,7547,'./import_coastpaper.php'),(20801551,1932,'./import_coastpaper.php'),(20801550,1827,'./import_coastpaper.php'),(20801549,6080,'./import_coastpaper.php'),(20801548,4130,'./import_coastpaper.php'),(20801547,5271,'./import_coastpaper.php'),(20801546,6079,'./import_coastpaper.php'),(20801545,6078,'./import_coastpaper.php'),(20801544,7361,'./import_coastpaper.php'),(20801543,1422,'./import_coastpaper.php'),(20801542,869,'./import_coastpaper.php'),(20801541,618,'./import_coastpaper.php'),(20801540,550,'./import_coastpaper.php'),(20801539,6077,'./import_coastpaper.php'),(20801538,6076,'./import_coastpaper.php'),(20801537,6075,'./import_coastpaper.php'),(20801536,315,'./import_coastpaper.php'),(20801535,6997,'./import_bom.php'),(20801534,7667,'./import_bom.php'),(20801533,12905,'./import_bom.php'),(20801532,12205,'./import_bom.php'),(20801531,2765,'./import_bom.php'),(20801530,6993,'./import_bom.php'),(20801529,6992,'./import_bom.php'),(20801528,7365,'./import_bom.php'),(20801527,6987,'./import_bom.php'),(20801526,12904,'./import_bom.php'),(20801525,15552,'./import_bom.php'),(20801524,12033,'./import_bom.php'),(20801523,12903,'./import_bom.php'),(20801522,12902,'./import_bom.php'),(20801521,5271,'./import_bom.php'),(20801520,13809,'./import_bom.php'),(20801519,7362,'./import_bom.php'),(20801518,7361,'./import_bom.php'),(20801517,12901,'./import_bom.php'),(20801516,7663,'./import_bom.php'),(20801515,315,'./import_bom.php'),(20679988,6968,'./hgchristie_import2.php'),(20679987,6967,'./hgchristie_import1.php'),(20679986,6966,'./hgchristie_import1.php'),(20679985,6965,'./hgchristie_import1.php'),(20679984,6964,'./hgchristie_import1.php'),(20679983,2702,'./hgchristie_import1.php'),(20679982,6963,'./hgchristie_import1.php'),(20679981,6962,'./hgchristie_import1.php'),(20679980,6961,'./hgchristie_import1.php'),(20679979,1499,'./hgchristie_import1.php'),(20679978,869,'./hgchristie_import1.php'),(20679977,6960,'./hgchristie_import1.php'),(20679976,226,'./hgchristie_import1.php'),(20679975,6967,'./hgchristie_import.php'),(20679974,6966,'./hgchristie_import.php'),(20679973,6965,'./hgchristie_import.php'),(20679972,6964,'./hgchristie_import.php'),(20679971,2702,'./hgchristie_import.php'),(20679970,6963,'./hgchristie_import.php'),(20679969,6962,'./hgchristie_import.php'),(20679968,7275,'./hgchristie_import.php'),(20679967,6961,'./hgchristie_import.php'),(20679966,869,'./hgchristie_import.php'),(20679965,7274,'./hgchristie_import.php'),(20679964,7273,'./hgchristie_import.php'),(20679963,6960,'./hgchristie_import.php'),(20679962,226,'./hgchristie_import.php'),(20679961,47,'./hgchristie_import.php'),(20801514,5155,'./help.php'),(20679959,3948,'./header_xp.php'),(20679958,5494,'./header_xp.php'),(20679957,2058,'./header_xp.php'),(20679956,1791,'./header_xp.php'),(20679955,1794,'./header_xp.php'),(20679954,1559,'./header_xp.php'),(20679953,8936,'./header_xp.php'),(20679952,656,'./header_xp.php'),(20679951,7035,'./header_xp.php'),(20801513,14569,'./glverifysetup.php'),(20801512,3333,'./glrepjournal_unbalanced.php'),(20801511,8473,'./glrepjournal_unbalanced.php'),(20801510,8472,'./glrepjournal_unbalanced.php'),(20801509,7938,'./glrepjournal_unbalanced.php'),(20801508,4531,'./glrepjournal_unbalanced.php'),(20801507,3123,'./glrepjournal_unbalanced.php'),(20801506,3120,'./glrepjournal_unbalanced.php'),(20801505,3090,'./glrepjournal_unbalanced.php'),(20801504,2872,'./glrepjournal_unbalanced.php'),(20801503,2869,'./glrepjournal_unbalanced.php'),(20801502,8471,'./glrepjournal_unbalanced.php'),(20801501,2377,'./glrepjournal_unbalanced.php'),(20801500,2000,'./glrepjournal_unbalanced.php'),(20801499,6472,'./glrepjournal_unbalanced.php'),(20801498,6471,'./glrepjournal_unbalanced.php'),(20801497,6470,'./glrepjournal_unbalanced.php'),(20801496,8936,'./glrepjournal_unbalanced.php'),(20801495,869,'./glrepjournal_unbalanced.php'),(20801494,776,'./glrepjournal_unbalanced.php'),(20801493,740,'./glrepjournal_unbalanced.php'),(20801492,670,'./glrepjournal_unbalanced.php'),(20801491,467,'./glrepjournal_unbalanced.php'),(20801490,315,'./glrepjournal_unbalanced.php'),(20801489,20,'./glrepjournal_unbalanced.php'),(20801473,3343,'./glrepjournal.php'),(20801472,3333,'./glrepjournal.php'),(20801471,6011,'./glrepjournal.php'),(20801470,4531,'./glrepjournal.php'),(20801469,3123,'./glrepjournal.php'),(20801468,6474,'./glrepjournal.php'),(20801467,6473,'./glrepjournal.php'),(20801466,3120,'./glrepjournal.php'),(20801465,3119,'./glrepjournal.php'),(20801464,3090,'./glrepjournal.php'),(20801463,16667,'./glrepjournal.php'),(20801462,20121,'./glrepjournal.php'),(20801461,2871,'./glrepjournal.php'),(20801460,2868,'./glrepjournal.php'),(20801459,2851,'./glrepjournal.php'),(20801458,20120,'./glrepjournal.php'),(20801457,2613,'./glrepjournal.php'),(20801456,6010,'./glrepjournal.php'),(20801455,6009,'./glrepjournal.php'),(20801454,6008,'./glrepjournal.php'),(20801453,6007,'./glrepjournal.php'),(20801452,2377,'./glrepjournal.php'),(20801451,2000,'./glrepjournal.php'),(20801450,1963,'./glrepjournal.php'),(20801449,3671,'./glrepjournal.php'),(20801448,6472,'./glrepjournal.php'),(20801447,16511,'./glrepjournal.php'),(20801446,6471,'./glrepjournal.php'),(20801445,6470,'./glrepjournal.php'),(20801444,15991,'./glrepjournal.php'),(20801443,1036,'./glrepjournal.php'),(20801442,6478,'./glrepjournal.php'),(20801441,1019,'./glrepjournal.php'),(20801440,869,'./glrepjournal.php'),(20801439,776,'./glrepjournal.php'),(20801438,740,'./glrepjournal.php'),(20801437,6006,'./glrepjournal.php'),(20801436,670,'./glrepjournal.php'),(20801435,9492,'./glrepjournal.php'),(20801434,607,'./glrepjournal.php'),(20801433,467,'./glrepjournal.php'),(20801432,6477,'./glrepjournal.php'),(20801412,16668,'./glrepincome_12month.php'),(20801411,3115,'./glrepincome_12month.php'),(20801410,3090,'./glrepincome_12month.php'),(20801409,16667,'./glrepincome_12month.php'),(20801408,6954,'./glrepincome_12month.php'),(20801407,14567,'./glrepincome_12month.php'),(20801406,6944,'./glrepincome_12month.php'),(20801405,3961,'./glrepincome_12month.php'),(20801404,2157,'./glrepincome_12month.php'),(20801403,12986,'./glrepincome_12month.php'),(20801402,2070,'./glrepincome_12month.php'),(20801401,1963,'./glrepincome_12month.php'),(20801400,1944,'./glrepincome_12month.php'),(20801399,5081,'./glrepincome_12month.php'),(20801398,1603,'./glrepincome_12month.php'),(20801397,16511,'./glrepincome_12month.php'),(20801396,12985,'./glrepincome_12month.php'),(20801395,12984,'./glrepincome_12month.php'),(20801394,1539,'./glrepincome_12month.php'),(20801393,6957,'./glrepincome_12month.php'),(20801392,15991,'./glrepincome_12month.php'),(20801391,1019,'./glrepincome_12month.php'),(20801390,665,'./glrepincome_12month.php'),(20801389,9492,'./glrepincome_12month.php'),(20801388,619,'./glrepincome_12month.php'),(20801387,315,'./glrepincome_12month.php'),(20801381,16668,'./glrepincome.php'),(20801380,13552,'./glrepincome.php'),(20801379,13551,'./glrepincome.php'),(20801378,3115,'./glrepincome.php'),(20801377,14568,'./glrepincome.php'),(20801376,3090,'./glrepincome.php'),(20801375,16667,'./glrepincome.php'),(20801374,6954,'./glrepincome.php'),(20801373,14567,'./glrepincome.php'),(20801372,6944,'./glrepincome.php'),(20801371,12987,'./glrepincome.php'),(20801370,3961,'./glrepincome.php'),(20801369,3778,'./glrepincome.php'),(20801368,14566,'./glrepincome.php'),(20801367,2320,'./glrepincome.php'),(20801366,2318,'./glrepincome.php'),(20801365,2315,'./glrepincome.php'),(20801364,13544,'./glrepincome.php'),(20801363,13543,'./glrepincome.php'),(20801362,2157,'./glrepincome.php'),(20801361,12986,'./glrepincome.php'),(20801360,14541,'./glrepincome.php'),(20801359,2070,'./glrepincome.php'),(20801358,1963,'./glrepincome.php'),(20801357,13542,'./glrepincome.php'),(20801356,13541,'./glrepincome.php'),(20801355,1944,'./glrepincome.php'),(20801354,14565,'./glrepincome.php'),(20801353,5081,'./glrepincome.php'),(20801352,1603,'./glrepincome.php'),(20801351,16511,'./glrepincome.php'),(20801350,12985,'./glrepincome.php'),(20801349,14564,'./glrepincome.php'),(20801348,12984,'./glrepincome.php'),(20801347,13534,'./glrepincome.php'),(20801346,13533,'./glrepincome.php'),(20801345,1539,'./glrepincome.php'),(20801344,6957,'./glrepincome.php'),(20801343,15991,'./glrepincome.php'),(20801342,1019,'./glrepincome.php'),(20801341,14563,'./glrepincome.php'),(20801340,665,'./glrepincome.php'),(20801339,9492,'./glrepincome.php'),(20801338,619,'./glrepincome.php'),(20801337,589,'./glrepincome.php'),(20801336,588,'./glrepincome.php'),(20801335,590,'./glrepincome.php'),(20801334,14562,'./glrepincome.php'),(20801333,337,'./glrepincome.php'),(20801332,315,'./glrepincome.php'),(20801331,14561,'./glrepincome.php'),(20801325,4387,'./glrepdaily.php'),(20801324,3090,'./glrepdaily.php'),(20801323,8340,'./glrepdaily.php'),(20801322,8339,'./glrepdaily.php'),(20801321,2208,'./glrepdaily.php'),(20801320,7744,'./glrepdaily.php'),(20801319,2200,'./glrepdaily.php'),(20801318,1963,'./glrepdaily.php'),(20801317,1772,'./glrepdaily.php'),(20801316,8338,'./glrepdaily.php'),(20801315,8337,'./glrepdaily.php'),(20801314,8336,'./glrepdaily.php'),(20801313,683,'./glrepdaily.php'),(20801312,673,'./glrepdaily.php'),(20801311,479,'./glrepdaily.php'),(20801310,445,'./glrepdaily.php'),(20801309,42,'./glrepdaily.php'),(20801308,40,'./glrepdaily.php'),(20801307,8335,'./glrepdaily.php'),(20801306,8334,'./glrepdaily.php'),(20801305,8333,'./glrepdaily.php'),(20801304,8332,'./glrepdaily.php'),(20801303,3271,'./glrepbudvariance.php'),(20801302,12074,'./glrepbudvariance.php'),(20801301,3090,'./glrepbudvariance.php'),(20801300,2984,'./glrepbudvariance.php'),(20801299,2761,'./glrepbudvariance.php'),(20801298,2783,'./glrepbudvariance.php'),(20801297,2584,'./glrepbudvariance.php'),(20801296,2315,'./glrepbudvariance.php'),(20801295,2000,'./glrepbudvariance.php'),(20801294,1982,'./glrepbudvariance.php'),(20801293,1963,'./glrepbudvariance.php'),(20801292,1935,'./glrepbudvariance.php'),(20801291,14780,'./glrepbudvariance.php'),(20801290,6957,'./glrepbudvariance.php'),(20801289,15991,'./glrepbudvariance.php'),(20801288,12073,'./glrepbudvariance.php'),(20801287,1436,'./glrepbudvariance.php'),(20801286,1434,'./glrepbudvariance.php'),(20801285,869,'./glrepbudvariance.php'),(20801284,9492,'./glrepbudvariance.php'),(20801283,607,'./glrepbudvariance.php'),(20801282,3548,'./glrepbudvariance.php'),(20801281,389,'./glrepbudvariance.php'),(20801280,315,'./glrepbudvariance.php'),(20801279,15,'./glrepbudvariance.php'),(20801278,11,'./glrepbudvariance.php'),(20801277,10,'./glrepbudvariance.php'),(20801276,197,'./glrepbudvariance.php'),(20801275,57,'./glrepbudvariance.php'),(20801274,20,'./glrepbudvariance.php'),(20801273,3,'./glrepbudvariance.php'),(20801272,3416,'./glrepbalance_summary.php'),(20801271,16668,'./glrepbalance_summary.php'),(20801270,3130,'./glrepbalance_summary.php'),(20801269,16667,'./glrepbalance_summary.php'),(20801268,7645,'./glrepbalance_summary.php'),(20801267,2315,'./glrepbalance_summary.php'),(20801266,2000,'./glrepbalance_summary.php'),(20801265,1963,'./glrepbalance_summary.php'),(20801264,16511,'./glrepbalance_summary.php'),(20801263,6953,'./glrepbalance_summary.php'),(20801262,15991,'./glrepbalance_summary.php'),(20801261,14522,'./glrepbalance_summary.php'),(20801260,5205,'./glrepbalance_summary.php'),(20801259,776,'./glrepbalance_summary.php'),(20801258,9341,'./glrepbalance_summary.php'),(20801257,670,'./glrepbalance_summary.php'),(20801256,9492,'./glrepbalance_summary.php'),(20801255,607,'./glrepbalance_summary.php'),(20801254,7644,'./glrepbalance_summary.php'),(20801253,589,'./glrepbalance_summary.php'),(20801252,327,'./glrepbalance_summary.php'),(20801251,315,'./glrepbalance_summary.php'),(20801246,3416,'./glrepbalance_detail.php'),(20801245,16668,'./glrepbalance_detail.php'),(20801244,3130,'./glrepbalance_detail.php'),(20801243,3105,'./glrepbalance_detail.php'),(20801242,3100,'./glrepbalance_detail.php'),(20801241,3096,'./glrepbalance_detail.php'),(20801240,3090,'./glrepbalance_detail.php'),(20801239,16667,'./glrepbalance_detail.php'),(20801238,6954,'./glrepbalance_detail.php'),(20801237,6944,'./glrepbalance_detail.php'),(20801236,6952,'./glrepbalance_detail.php'),(20801235,2613,'./glrepbalance_detail.php'),(20801234,10107,'./glrepbalance_detail.php'),(20801233,2315,'./glrepbalance_detail.php'),(20801232,2000,'./glrepbalance_detail.php'),(20801231,2070,'./glrepbalance_detail.php'),(20801230,1963,'./glrepbalance_detail.php'),(20801229,6951,'./glrepbalance_detail.php'),(20801228,16511,'./glrepbalance_detail.php'),(20801227,15991,'./glrepbalance_detail.php'),(20801226,14522,'./glrepbalance_detail.php'),(20801225,1040,'./glrepbalance_detail.php'),(20801224,6956,'./glrepbalance_detail.php'),(20801223,7143,'./glrepbalance_detail.php'),(20801222,5205,'./glrepbalance_detail.php'),(20801221,776,'./glrepbalance_detail.php'),(20801220,9341,'./glrepbalance_detail.php'),(20801219,670,'./glrepbalance_detail.php'),(20801218,9492,'./glrepbalance_detail.php'),(20801217,607,'./glrepbalance_detail.php'),(20801216,339,'./glrepbalance_detail.php'),(20801215,327,'./glrepbalance_detail.php'),(20801214,315,'./glrepbalance_detail.php'),(20801213,203,'./glrepbalance_detail.php'),(20801212,202,'./glrepbalance_detail.php'),(20801207,3416,'./glrepbalance.php'),(20801206,16668,'./glrepbalance.php'),(20801205,10108,'./glrepbalance.php'),(20801204,3105,'./glrepbalance.php'),(20801203,3096,'./glrepbalance.php'),(20801202,3090,'./glrepbalance.php'),(20801201,16667,'./glrepbalance.php'),(20801200,6954,'./glrepbalance.php'),(20801199,6944,'./glrepbalance.php'),(20801198,12987,'./glrepbalance.php'),(20801197,10107,'./glrepbalance.php'),(20801196,2494,'./glrepbalance.php'),(20801195,2315,'./glrepbalance.php'),(20801194,12986,'./glrepbalance.php'),(20801193,2000,'./glrepbalance.php'),(20801192,2070,'./glrepbalance.php'),(20801191,1963,'./glrepbalance.php'),(20801190,16511,'./glrepbalance.php'),(20801189,12985,'./glrepbalance.php'),(20801188,12984,'./glrepbalance.php'),(20801187,15991,'./glrepbalance.php'),(20801186,14522,'./glrepbalance.php'),(20801185,1040,'./glrepbalance.php'),(20801184,5205,'./glrepbalance.php'),(20801183,9341,'./glrepbalance.php'),(20801182,9492,'./glrepbalance.php'),(20801181,607,'./glrepbalance.php'),(20801180,7644,'./glrepbalance.php'),(20801179,589,'./glrepbalance.php'),(20801178,327,'./glrepbalance.php'),(20801177,3541,'./glrepbalance.php'),(20801176,315,'./glrepbalance.php'),(20801171,13458,'./glrepactivity_specific.php'),(20801170,13457,'./glrepactivity_specific.php'),(20801169,3090,'./glrepactivity_specific.php'),(20801168,2315,'./glrepactivity_specific.php'),(20801167,2270,'./glrepactivity_specific.php'),(20801166,13456,'./glrepactivity_specific.php'),(20801165,1999,'./glrepactivity_specific.php'),(20801164,1963,'./glrepactivity_specific.php'),(20801163,7351,'./glrepactivity_specific.php'),(20801162,4106,'./glrepactivity_specific.php'),(20801161,13455,'./glrepactivity_specific.php'),(20801160,13454,'./glrepactivity_specific.php'),(20801159,1019,'./glrepactivity_specific.php'),(20801158,869,'./glrepactivity_specific.php'),(20801157,776,'./glrepactivity_specific.php'),(20801156,737,'./glrepactivity_specific.php'),(20801155,665,'./glrepactivity_specific.php'),(20801154,542,'./glrepactivity_specific.php'),(20801153,337,'./glrepactivity_specific.php'),(20801152,315,'./glrepactivity_specific.php'),(20801151,20,'./glrepactivity_specific.php'),(20801150,3336,'./glrepactivity.php'),(20801149,3333,'./glrepactivity.php'),(20801148,6011,'./glrepactivity.php'),(20801147,3090,'./glrepactivity.php'),(20801146,16667,'./glrepactivity.php'),(20801145,6952,'./glrepactivity.php'),(20801144,2911,'./glrepactivity.php'),(20801143,2907,'./glrepactivity.php'),(20801142,17747,'./glrepactivity.php'),(20801141,2872,'./glrepactivity.php'),(20801140,2869,'./glrepactivity.php'),(20801139,15155,'./glrepactivity.php'),(20801138,2850,'./glrepactivity.php'),(20801137,2613,'./glrepactivity.php'),(20801136,6010,'./glrepactivity.php'),(20801135,6008,'./glrepactivity.php'),(20801134,2377,'./glrepactivity.php'),(20801133,2315,'./glrepactivity.php'),(20801132,19443,'./glrepactivity.php'),(20801131,1999,'./glrepactivity.php'),(20801130,19442,'./glrepactivity.php'),(20801129,1963,'./glrepactivity.php'),(20801128,6951,'./glrepactivity.php'),(20801127,5081,'./glrepactivity.php'),(20801126,16511,'./glrepactivity.php'),(20801125,16851,'./glrepactivity.php'),(20801124,15991,'./glrepactivity.php'),(20801123,1036,'./glrepactivity.php'),(20801122,6478,'./glrepactivity.php'),(20801121,1019,'./glrepactivity.php'),(20801120,1022,'./glrepactivity.php'),(20801119,5407,'./glrepactivity.php'),(20801118,17746,'./glrepactivity.php'),(20801117,869,'./glrepactivity.php'),(20801116,5205,'./glrepactivity.php'),(20801115,776,'./glrepactivity.php'),(20801114,743,'./glrepactivity.php'),(20801113,6006,'./glrepactivity.php'),(20801112,670,'./glrepactivity.php'),(20801111,665,'./glrepactivity.php'),(20801110,9492,'./glrepactivity.php'),(20801109,542,'./glrepactivity.php'),(20801108,536,'./glrepactivity.php'),(20801107,16308,'./glrepactivity.php'),(20801106,16307,'./glrepactivity.php'),(20801105,6477,'./glrepactivity.php'),(20801104,337,'./glrepactivity.php'),(20801092,3415,'./glpostupd.php'),(20801091,16344,'./glpostupd.php'),(20801090,14889,'./glpostupd.php'),(20801089,15963,'./glpostupd.php'),(20801088,16038,'./glpostupd.php'),(20801087,3177,'./glpostupd.php'),(20801086,16343,'./glpostupd.php'),(20801085,3080,'./glpostupd.php'),(20801084,4023,'./glpostupd.php'),(20801083,2162,'./glpostupd.php'),(20801082,1913,'./glpostupd.php'),(20801081,14888,'./glpostupd.php'),(20801080,16185,'./glpostupd.php'),(20801079,3333,'./glpostreport.php'),(20801078,13691,'./glpostreport.php'),(20801077,2907,'./glpostreport.php'),(20801076,13690,'./glpostreport.php'),(20801075,13689,'./glpostreport.php'),(20801074,2066,'./glpostreport.php'),(20801073,13688,'./glpostreport.php'),(20801072,869,'./glpostreport.php'),(20801071,5405,'./glpostreport.php'),(20801070,13687,'./glpostreport.php'),(20801069,4465,'./glpostreport.php'),(20801068,3417,'./glpostadd.php'),(20801067,13686,'./glpostadd.php'),(20801066,3344,'./glpostadd.php'),(20801065,3333,'./glpostadd.php'),(20801064,16037,'./glpostadd.php'),(20801063,16036,'./glpostadd.php'),(20801062,3444,'./glpostadd.php'),(20801061,13963,'./glpostadd.php'),(20801060,16184,'./glpostadd.php'),(20801059,2373,'./glpostadd.php'),(20801058,3746,'./glpostadd.php'),(20801057,2372,'./glpostadd.php'),(20801056,2270,'./glpostadd.php'),(20801055,2066,'./glpostadd.php'),(20801054,16183,'./glpostadd.php'),(20801053,16182,'./glpostadd.php'),(20801052,13927,'./glpostadd.php'),(20801051,16035,'./glpostadd.php'),(20801050,1639,'./glpostadd.php'),(20801049,18957,'./glpostadd.php'),(20801048,1482,'./glpostadd.php'),(20801047,1441,'./glpostadd.php'),(20801046,1371,'./glpostadd.php'),(20801045,1226,'./glpostadd.php'),(20801044,1019,'./glpostadd.php'),(20801043,16342,'./glpostadd.php'),(20801042,337,'./glpostadd.php'),(20801041,13453,'./glpostadd.php'),(20801040,315,'./glpostadd.php'),(20801039,11210,'./glpostadd.php'),(20801038,15414,'./glpostadd.php'),(20801037,16034,'./glpostadd.php'),(20801036,197,'./glpostadd.php'),(20801035,42,'./glpostadd.php'),(20801033,2373,'./glpost_mass_fix.php'),(20801032,13927,'./glpost_mass_fix.php'),(20679432,3333,'./gljourupd1.php'),(20679431,3226,'./gljourupd1.php'),(20679430,3204,'./gljourupd1.php'),(20679429,3129,'./gljourupd1.php'),(20679428,2710,'./gljourupd1.php'),(20679427,2702,'./gljourupd1.php'),(20679426,1963,'./gljourupd1.php'),(20679425,1746,'./gljourupd1.php'),(20679424,1332,'./gljourupd1.php'),(20679423,869,'./gljourupd1.php'),(20679422,607,'./gljourupd1.php'),(20679421,489,'./gljourupd1.php'),(20679420,226,'./gljourupd1.php'),(20679419,20,'./gljourupd1.php'),(20800995,16665,'./gljourupd.php'),(20800994,5170,'./gljourupd.php'),(20800993,3342,'./gljourupd.php'),(20800992,16033,'./gljourupd.php'),(20800991,16449,'./gljourupd.php'),(20800990,16448,'./gljourupd.php'),(20800989,3339,'./gljourupd.php'),(20800988,3337,'./gljourupd.php'),(20800987,8671,'./gljourupd.php'),(20800986,3333,'./gljourupd.php'),(20800985,16032,'./gljourupd.php'),(20800984,16031,'./gljourupd.php'),(20800983,3204,'./gljourupd.php'),(20800982,3134,'./gljourupd.php'),(20800981,3129,'./gljourupd.php'),(20800980,16030,'./gljourupd.php'),(20800979,3076,'./gljourupd.php'),(20800978,3090,'./gljourupd.php'),(20800977,16029,'./gljourupd.php'),(20800976,9407,'./gljourupd.php'),(20800975,16664,'./gljourupd.php'),(20800974,2739,'./gljourupd.php'),(20800973,2710,'./gljourupd.php'),(20800972,2702,'./gljourupd.php'),(20800971,2623,'./gljourupd.php'),(20800970,2270,'./gljourupd.php'),(20800969,2065,'./gljourupd.php'),(20800968,5786,'./gljourupd.php'),(20800967,2094,'./gljourupd.php'),(20800966,1963,'./gljourupd.php'),(20800965,1746,'./gljourupd.php'),(20800964,5081,'./gljourupd.php'),(20800963,1639,'./gljourupd.php'),(20800962,15991,'./gljourupd.php'),(20800961,1482,'./gljourupd.php'),(20800960,1469,'./gljourupd.php'),(20800959,1441,'./gljourupd.php'),(20800958,1409,'./gljourupd.php'),(20800957,8936,'./gljourupd.php'),(20800956,1037,'./gljourupd.php'),(20800955,971,'./gljourupd.php'),(20800954,3586,'./gljourupd.php'),(20800953,949,'./gljourupd.php'),(20800952,18669,'./gljourupd.php'),(20800951,941,'./gljourupd.php'),(20800950,901,'./gljourupd.php'),(20800949,20248,'./gljourupd.php'),(20800948,8670,'./gljourupd.php'),(20800947,869,'./gljourupd.php'),(20800946,5878,'./gljourupd.php'),(20800945,861,'./gljourupd.php'),(20800944,16028,'./gljourupd.php'),(20800943,16027,'./gljourupd.php'),(20800942,799,'./gljourupd.php'),(20800941,776,'./gljourupd.php'),(20800940,9341,'./gljourupd.php'),(20800939,670,'./gljourupd.php'),(20800938,16026,'./gljourupd.php'),(20800937,16025,'./gljourupd.php'),(20800936,9492,'./gljourupd.php'),(20800935,607,'./gljourupd.php'),(20800934,542,'./gljourupd.php'),(20800933,541,'./gljourupd.php'),(20800932,18668,'./gljourupd.php'),(20800931,414,'./gljourupd.php'),(20800930,16024,'./gljourupd.php'),(20800929,5877,'./gljourupd.php'),(20800928,16023,'./gljourupd.php'),(20800927,416,'./gljourupd.php'),(20800926,315,'./gljourupd.php'),(20800915,6155,'./gljournalpdf.php'),(20800914,3333,'./gljournalpdf.php'),(20800913,3324,'./gljournalpdf.php'),(20800912,6153,'./gljournalpdf.php'),(20800911,3072,'./gljournalpdf.php'),(20800910,15822,'./gljournalpdf.php'),(20800909,2907,'./gljournalpdf.php'),(20800908,16785,'./gljournalpdf.php'),(20800907,6010,'./gljournalpdf.php'),(20800906,6151,'./gljournalpdf.php'),(20800905,6150,'./gljournalpdf.php'),(20800904,2225,'./gljournalpdf.php'),(20800903,2222,'./gljournalpdf.php'),(20800902,2165,'./gljournalpdf.php'),(20800901,15821,'./gljournalpdf.php'),(20800900,2099,'./gljournalpdf.php'),(20800899,15820,'./gljournalpdf.php'),(20800898,15819,'./gljournalpdf.php'),(20800897,7275,'./gljournalpdf.php'),(20800896,5081,'./gljournalpdf.php'),(20800895,6149,'./gljournalpdf.php'),(20800894,1668,'./gljournalpdf.php'),(20800893,6147,'./gljournalpdf.php'),(20800892,1640,'./gljournalpdf.php'),(20800891,15991,'./gljournalpdf.php'),(20800890,4982,'./gljournalpdf.php'),(20800889,1467,'./gljournalpdf.php'),(20800888,1446,'./gljournalpdf.php'),(20800887,8936,'./gljournalpdf.php'),(20800886,15818,'./gljournalpdf.php'),(20800885,1036,'./gljournalpdf.php'),(20800884,6146,'./gljournalpdf.php'),(20800883,1032,'./gljournalpdf.php'),(20800882,6054,'./gljournalpdf.php'),(20800881,15817,'./gljournalpdf.php'),(20800880,869,'./gljournalpdf.php'),(20800879,776,'./gljournalpdf.php'),(20800878,15816,'./gljournalpdf.php'),(20800877,6145,'./gljournalpdf.php'),(20800876,6053,'./gljournalpdf.php'),(20800875,670,'./gljournalpdf.php'),(20800874,9492,'./gljournalpdf.php'),(20800873,567,'./gljournalpdf.php'),(20800872,479,'./gljournalpdf.php'),(20800871,445,'./gljournalpdf.php'),(20800870,6144,'./gljournalpdf.php'),(20679290,3334,'./gljouradd2.php'),(20679289,2378,'./gljouradd2.php'),(20679288,1138,'./gljouradd2.php'),(20679287,1134,'./gljouradd2.php'),(20679286,1132,'./gljouradd2.php'),(20679285,3340,'./gljouradd1.php'),(20679284,3338,'./gljouradd1.php'),(20679283,3333,'./gljouradd1.php'),(20679282,2718,'./gljouradd1.php'),(20679281,2702,'./gljouradd1.php'),(20679280,1483,'./gljouradd1.php'),(20679279,1446,'./gljouradd1.php'),(20679278,1132,'./gljouradd1.php'),(20679277,869,'./gljouradd1.php'),(20679276,747,'./gljouradd1.php'),(20679275,591,'./gljouradd1.php'),(20679274,226,'./gljouradd1.php'),(20679273,20,'./gljouradd1.php'),(20800867,16665,'./gljouradd.php'),(20800866,3332,'./gljouradd.php'),(20800865,3335,'./gljouradd.php'),(20800864,3333,'./gljouradd.php'),(20800863,13289,'./gljouradd.php'),(20800862,9491,'./gljouradd.php'),(20800861,3274,'./gljouradd.php'),(20800860,7938,'./gljouradd.php'),(20800859,3129,'./gljouradd.php'),(20800858,3090,'./gljouradd.php'),(20800857,16664,'./gljouradd.php'),(20800856,16021,'./gljouradd.php'),(20800855,16020,'./gljouradd.php'),(20800854,2059,'./gljouradd.php'),(20800853,1963,'./gljouradd.php'),(20800852,15962,'./gljouradd.php'),(20800851,3705,'./gljouradd.php'),(20800850,13452,'./gljouradd.php'),(20800849,1746,'./gljouradd.php'),(20800848,5081,'./gljouradd.php'),(20800847,15991,'./gljouradd.php'),(20800846,1046,'./gljouradd.php'),(20800845,8936,'./gljouradd.php'),(20800844,1047,'./gljouradd.php'),(20800843,7430,'./gljouradd.php'),(20800842,869,'./gljouradd.php'),(20800841,776,'./gljouradd.php'),(20800840,13282,'./gljouradd.php'),(20800839,13451,'./gljouradd.php'),(20800838,697,'./gljouradd.php'),(20800837,9341,'./gljouradd.php'),(20800836,670,'./gljouradd.php'),(20800835,16019,'./gljouradd.php'),(20800834,9492,'./gljouradd.php'),(20800833,573,'./gljouradd.php'),(20800832,542,'./gljouradd.php'),(20800831,6198,'./gljouradd.php'),(20800830,315,'./gljouradd.php'),(20800824,5310,'./gljour_std_upd.php'),(20800823,5794,'./gljour_std_upd.php'),(20800822,5309,'./gljour_std_upd.php'),(20800821,5170,'./gljour_std_upd.php'),(20800820,3342,'./gljour_std_upd.php'),(20800819,3339,'./gljour_std_upd.php'),(20800818,3337,'./gljour_std_upd.php'),(20800817,3333,'./gljour_std_upd.php'),(20800816,5793,'./gljour_std_upd.php'),(20800815,3134,'./gljour_std_upd.php'),(20800814,3076,'./gljour_std_upd.php'),(20800813,3090,'./gljour_std_upd.php'),(20800812,2739,'./gljour_std_upd.php'),(20800811,2710,'./gljour_std_upd.php'),(20800810,2702,'./gljour_std_upd.php'),(20800809,2623,'./gljour_std_upd.php'),(20800808,5792,'./gljour_std_upd.php'),(20800807,16017,'./gljour_std_upd.php'),(20800806,16016,'./gljour_std_upd.php'),(20800805,16015,'./gljour_std_upd.php'),(20800804,16014,'./gljour_std_upd.php'),(20800803,16013,'./gljour_std_upd.php'),(20800802,16012,'./gljour_std_upd.php'),(20800801,5791,'./gljour_std_upd.php'),(20800800,5786,'./gljour_std_upd.php'),(20800799,1963,'./gljour_std_upd.php'),(20800798,13766,'./gljour_std_upd.php'),(20800797,5304,'./gljour_std_upd.php'),(20800796,15969,'./gljour_std_upd.php'),(20800795,5790,'./gljour_std_upd.php'),(20800794,15991,'./gljour_std_upd.php'),(20800793,16337,'./gljour_std_upd.php'),(20800792,1469,'./gljour_std_upd.php'),(20800791,1468,'./gljour_std_upd.php'),(20800790,1455,'./gljour_std_upd.php'),(20800789,1409,'./gljour_std_upd.php'),(20800788,16011,'./gljour_std_upd.php'),(20800787,16010,'./gljour_std_upd.php'),(20800786,16009,'./gljour_std_upd.php'),(20800785,16008,'./gljour_std_upd.php'),(20800784,7878,'./gljour_std_upd.php'),(20800783,941,'./gljour_std_upd.php'),(20800782,869,'./gljour_std_upd.php'),(20800781,861,'./gljour_std_upd.php'),(20800780,799,'./gljour_std_upd.php'),(20800779,5299,'./gljour_std_upd.php'),(20800778,9341,'./gljour_std_upd.php'),(20800777,9492,'./gljour_std_upd.php'),(20800776,607,'./gljour_std_upd.php'),(20800775,414,'./gljour_std_upd.php'),(20800774,7835,'./gljour_std_upd.php'),(20800773,16007,'./gljour_std_upd.php'),(20800772,315,'./gljour_std_upd.php'),(20800771,5203,'./gljour_std_upd.php'),(20800770,226,'./gljour_std_upd.php'),(20800769,87,'./gljour_std_upd.php'),(20800768,20,'./gljour_std_upd.php'),(20800767,3333,'./gljour_std_post.php'),(20800766,6176,'./gljour_std_post.php'),(20800765,4596,'./gljour_std_post.php'),(20800764,5786,'./gljour_std_post.php'),(20800763,1963,'./gljour_std_post.php'),(20800762,16341,'./gljour_std_post.php'),(20800761,16340,'./gljour_std_post.php'),(20800760,16339,'./gljour_std_post.php'),(20800759,16309,'./gljour_std_post.php'),(20800758,16337,'./gljour_std_post.php'),(20800757,16338,'./gljour_std_post.php'),(20800756,5784,'./gljour_std_post.php'),(20800755,941,'./gljour_std_post.php'),(20800754,869,'./gljour_std_post.php'),(20800753,737,'./gljour_std_post.php'),(20800752,14887,'./gljour_std_post.php'),(20800751,315,'./gljour_std_post.php'),(20800750,5310,'./gljour_std_add.php'),(20800749,5309,'./gljour_std_add.php'),(20800748,3332,'./gljour_std_add.php'),(20800747,3335,'./gljour_std_add.php'),(20800746,3333,'./gljour_std_add.php'),(20800745,3090,'./gljour_std_add.php'),(20800744,16017,'./gljour_std_add.php'),(20800743,16016,'./gljour_std_add.php'),(20800742,16015,'./gljour_std_add.php'),(20800741,16014,'./gljour_std_add.php'),(20800740,16013,'./gljour_std_add.php'),(20800739,16012,'./gljour_std_add.php'),(20800738,2002,'./gljour_std_add.php'),(20800737,1963,'./gljour_std_add.php'),(20800736,7907,'./gljour_std_add.php'),(20800735,13766,'./gljour_std_add.php'),(20800734,5304,'./gljour_std_add.php'),(20800733,15969,'./gljour_std_add.php'),(20800732,1770,'./gljour_std_add.php'),(20800731,1746,'./gljour_std_add.php'),(20800730,15991,'./gljour_std_add.php'),(20800729,16337,'./gljour_std_add.php'),(20800728,16011,'./gljour_std_add.php'),(20800727,16010,'./gljour_std_add.php'),(20800726,16009,'./gljour_std_add.php'),(20800725,16008,'./gljour_std_add.php'),(20800724,1046,'./gljour_std_add.php'),(20800723,4346,'./gljour_std_add.php'),(20800722,869,'./gljour_std_add.php'),(20800721,5299,'./gljour_std_add.php'),(20800720,9341,'./gljour_std_add.php'),(20800719,9492,'./gljour_std_add.php'),(20800718,607,'./gljour_std_add.php'),(20800717,7835,'./gljour_std_add.php'),(20800716,16007,'./gljour_std_add.php'),(20800715,315,'./gljour_std_add.php'),(20800714,226,'./gljour_std_add.php'),(20800713,85,'./gljour_std_add.php'),(20800712,72,'./gljour_std_add.php'),(20800711,20,'./gljour_std_add.php'),(20800710,15410,'./glincometype.php'),(20800709,2710,'./glincometype.php'),(20800708,2702,'./glincometype.php'),(20800707,9807,'./glincometype.php'),(20800706,15550,'./glincometype.php'),(20800705,13287,'./glincometype.php'),(20800704,15910,'./glincometype.php'),(20800703,1935,'./glincometype.php'),(20800702,7972,'./glincometype.php'),(20800701,1499,'./glincometype.php'),(20800700,15906,'./glincometype.php'),(20800699,1480,'./glincometype.php'),(20800698,8936,'./glincometype.php'),(20800697,941,'./glincometype.php'),(20800696,15873,'./glincometype.php'),(20800695,15908,'./glincometype.php'),(20800694,799,'./glincometype.php'),(20800693,15912,'./glincometype.php'),(20800692,13994,'./glincometype.php'),(20800691,315,'./glincometype.php'),(20800690,5203,'./glincometype.php'),(20800689,59,'./glincometype.php'),(20800925,12140,'./gljourupd.php'),(20800688,3252,'./glincome.php'),(20800687,3156,'./glincome.php'),(20800686,15410,'./glincome.php'),(20800685,2702,'./glincome.php'),(20800684,15911,'./glincome.php'),(20800683,11922,'./glincome.php'),(20800682,15910,'./glincome.php'),(20800681,15812,'./glincome.php'),(20800680,15810,'./glincome.php'),(20800679,15909,'./glincome.php'),(20800678,5081,'./glincome.php'),(20800677,15991,'./glincome.php'),(20800676,8936,'./glincome.php'),(20800675,15809,'./glincome.php'),(20800674,7685,'./glincome.php'),(20800673,15908,'./glincome.php'),(20800672,15872,'./glincome.php'),(20800671,799,'./glincome.php'),(20800670,15807,'./glincome.php'),(20800669,737,'./glincome.php'),(20800668,15806,'./glincome.php'),(20800667,9492,'./glincome.php'),(20800666,566,'./glincome.php'),(20800665,20119,'./glincome.php'),(20800664,20118,'./glincome.php'),(20800663,20117,'./glincome.php'),(20800662,20116,'./glincome.php'),(20800658,3156,'./glexpensetype.php'),(20800657,15410,'./glexpensetype.php'),(20800656,2710,'./glexpensetype.php'),(20800655,2702,'./glexpensetype.php'),(20800654,9807,'./glexpensetype.php'),(20800653,15550,'./glexpensetype.php'),(20800652,13287,'./glexpensetype.php'),(20800651,15813,'./glexpensetype.php'),(20800650,1935,'./glexpensetype.php'),(20800649,7972,'./glexpensetype.php'),(20800648,1499,'./glexpensetype.php'),(20800647,1480,'./glexpensetype.php'),(20800646,17612,'./glexpensetype.php'),(20800645,8936,'./glexpensetype.php'),(20800644,941,'./glexpensetype.php'),(20800643,15775,'./glexpensetype.php'),(20800642,15808,'./glexpensetype.php'),(20800641,799,'./glexpensetype.php'),(20800640,15815,'./glexpensetype.php'),(20800639,445,'./glexpensetype.php'),(20800638,17611,'./glexpensetype.php'),(20800637,13994,'./glexpensetype.php'),(20800924,5203,'./gljourupd.php'),(20800633,3252,'./glexpense.php'),(20800632,3156,'./glexpense.php'),(20800631,16148,'./glexpense.php'),(20800630,16113,'./glexpense.php'),(20800629,15410,'./glexpense.php'),(20800628,2702,'./glexpense.php'),(20800627,7192,'./glexpense.php'),(20800626,15814,'./glexpense.php'),(20800625,17610,'./glexpense.php'),(20800624,11922,'./glexpense.php'),(20800623,2044,'./glexpense.php'),(20800622,15813,'./glexpense.php'),(20800621,18667,'./glexpense.php'),(20800620,15812,'./glexpense.php'),(20800619,15811,'./glexpense.php'),(20800618,15810,'./glexpense.php'),(20800617,5081,'./glexpense.php'),(20800616,15991,'./glexpense.php'),(20800615,17609,'./glexpense.php'),(20800614,8936,'./glexpense.php'),(20800613,15809,'./glexpense.php'),(20800612,7685,'./glexpense.php'),(20800611,15808,'./glexpense.php'),(20800610,15774,'./glexpense.php'),(20800609,17572,'./glexpense.php'),(20800608,15807,'./glexpense.php'),(20800607,737,'./glexpense.php'),(20800606,15806,'./glexpense.php'),(20800595,3225,'./glcost_centerupd.php'),(20800594,3186,'./glcost_centerupd.php'),(20800593,2702,'./glcost_centerupd.php'),(20800592,2044,'./glcost_centerupd.php'),(20800591,6481,'./glcost_centerupd.php'),(20800590,6949,'./glcost_centerupd.php'),(20800589,1143,'./glcost_centerupd.php'),(20800588,941,'./glcost_centerupd.php'),(20800587,6938,'./glcost_centerupd.php'),(20800586,864,'./glcost_centerupd.php'),(20800585,799,'./glcost_centerupd.php'),(20800584,6947,'./glcost_centerupd.php'),(20800583,619,'./glcost_centerupd.php'),(20800582,315,'./glcost_centerupd.php'),(20800581,5203,'./glcost_centerupd.php'),(20800580,59,'./glcost_centerupd.php'),(20800579,2702,'./glcost_centeradd.php'),(20800578,6481,'./glcost_centeradd.php'),(20800577,6948,'./glcost_centeradd.php'),(20800576,3994,'./glcost_centeradd.php'),(20800575,6938,'./glcost_centeradd.php'),(20800574,6947,'./glcost_centeradd.php'),(20800573,6946,'./glcost_centeradd.php'),(20800572,315,'./glcost_centeradd.php'),(20800571,176,'./glcost_centeradd.php'),(20800570,5681,'./glclose_year.php'),(20800569,10155,'./glclose_year.php'),(20800568,6197,'./glclose_year.php'),(20800567,3221,'./glclose_year.php'),(20800566,3202,'./glclose_year.php'),(20800565,5680,'./glclose_year.php'),(20800564,5713,'./glclose_year.php'),(20800563,3156,'./glclose_year.php'),(20800562,17415,'./glclose_year.php'),(20800561,17414,'./glclose_year.php'),(20800560,5712,'./glclose_year.php'),(20800559,6196,'./glclose_year.php'),(20800558,2373,'./glclose_year.php'),(20800557,1963,'./glclose_year.php'),(20800556,5622,'./glclose_year.php'),(20800555,13685,'./glclose_year.php'),(20800554,5711,'./glclose_year.php'),(20800553,1019,'./glclose_year.php'),(20800552,6195,'./glclose_year.php'),(20800551,799,'./glclose_year.php'),(20800550,16662,'./glclose_year.php'),(20800549,5623,'./glclose_year.php'),(20800548,5620,'./glclose_year.php'),(20800547,16661,'./glclose_year.php'),(20800546,16660,'./glclose_year.php'),(20800545,5619,'./glclose_year.php'),(20800537,3415,'./glclose_month.php'),(20800536,16180,'./glclose_month.php'),(20800535,16179,'./glclose_month.php'),(20800534,4531,'./glclose_month.php'),(20800533,2702,'./glclose_month.php'),(20800532,2612,'./glclose_month.php'),(20800531,16178,'./glclose_month.php'),(20800530,16177,'./glclose_month.php'),(20800529,16176,'./glclose_month.php'),(20800528,16336,'./glclose_month.php'),(20800527,16335,'./glclose_month.php'),(20800526,4023,'./glclose_month.php'),(20800525,16175,'./glclose_month.php'),(20800524,16174,'./glclose_month.php'),(20800523,16173,'./glclose_month.php'),(20800522,1913,'./glclose_month.php'),(20800521,16172,'./glclose_month.php'),(20800520,16171,'./glclose_month.php'),(20800519,16334,'./glclose_month.php'),(20800518,16170,'./glclose_month.php'),(20800517,8936,'./glclose_month.php'),(20800516,1013,'./glclose_month.php'),(20800515,16333,'./glclose_month.php'),(20800514,4376,'./glclose_month.php'),(20800513,9803,'./glclose_month.php'),(20800512,15731,'./glclose_month.php'),(20678904,10155,'./glchecklist.php'),(20678903,3415,'./glchecklist.php'),(20678902,3414,'./glchecklist.php'),(20678901,3156,'./glchecklist.php'),(20678900,10154,'./glchecklist.php'),(20678899,10153,'./glchecklist.php'),(20678898,2535,'./glchecklist.php'),(20678897,10152,'./glchecklist.php'),(20678896,4023,'./glchecklist.php'),(20678895,1933,'./glchecklist.php'),(20678894,10151,'./glchecklist.php'),(20678893,1913,'./glchecklist.php'),(20678892,10150,'./glchecklist.php'),(20678891,8936,'./glchecklist.php'),(20678890,941,'./glchecklist.php'),(20678889,740,'./glchecklist.php'),(20678888,4595,'./glchecklist.php'),(20678887,10149,'./glchecklist.php'),(20678886,591,'./glchecklist.php'),(20678885,10148,'./glchecklist.php'),(20800499,13460,'./glcategory.php'),(20800498,3186,'./glcategory.php'),(20800497,8580,'./glcategory.php'),(20800496,2702,'./glcategory.php'),(20800495,2044,'./glcategory.php'),(20800494,15959,'./glcategory.php'),(20800493,8936,'./glcategory.php'),(20800492,1143,'./glcategory.php'),(20800491,941,'./glcategory.php'),(20800490,6938,'./glcategory.php'),(20800489,869,'./glcategory.php'),(20800488,864,'./glcategory.php'),(20800487,799,'./glcategory.php'),(20800486,9492,'./glcategory.php'),(20800485,548,'./glcategory.php'),(20800484,315,'./glcategory.php'),(20800483,5203,'./glcategory.php'),(20800482,59,'./glcategory.php'),(20800481,10215,'./glcashflow.php'),(20800480,3416,'./glcashflow.php'),(20800479,10230,'./glcashflow.php'),(20800478,10229,'./glcashflow.php'),(20800477,3271,'./glcashflow.php'),(20800476,3090,'./glcashflow.php'),(20800475,10743,'./glcashflow.php'),(20800474,10214,'./glcashflow.php'),(20800473,10352,'./glcashflow.php'),(20800472,10228,'./glcashflow.php'),(20800471,12839,'./glcashflow.php'),(20800470,1963,'./glcashflow.php'),(20800469,10209,'./glcashflow.php'),(20800468,10156,'./glcashflow.php'),(20800467,10351,'./glcashflow.php'),(20800466,12801,'./glcashflow.php'),(20800465,1446,'./glcashflow.php'),(20800464,8936,'./glcashflow.php'),(20800463,10213,'./glcashflow.php'),(20800462,5039,'./glcashflow.php'),(20800461,607,'./glcashflow.php'),(20800460,10212,'./glcashflow.php'),(20800459,10350,'./glcashflow.php'),(20800458,10198,'./glcashflow.php'),(20800457,10197,'./glcashflow.php'),(20800456,10196,'./glcashflow.php'),(20800455,10349,'./glcashflow.php'),(20800454,10348,'./glcashflow.php'),(20800453,10194,'./glcashflow.php'),(20800452,10346,'./glcashflow.php'),(20800451,315,'./glcashflow.php'),(20800450,10223,'./glcashflow.php'),(20800449,202,'./glcashflow.php'),(20800448,3090,'./glbudlst.php'),(20800447,2015,'./glbudlst.php'),(20800446,1963,'./glbudlst.php'),(20800445,15991,'./glbudlst.php'),(20800444,1435,'./glbudlst.php'),(20800443,1434,'./glbudlst.php'),(20800442,18627,'./glbudlst.php'),(20800441,5407,'./glbudlst.php'),(20800440,869,'./glbudlst.php'),(20800439,9492,'./glbudlst.php'),(20800438,4005,'./glbudlst.php'),(20800437,396,'./glbudlst.php'),(20800431,16006,'./glbudadd.php'),(20800430,3189,'./glbudadd.php'),(20800429,3090,'./glbudadd.php'),(20800428,16005,'./glbudadd.php'),(20800427,2702,'./glbudadd.php'),(20800426,16004,'./glbudadd.php'),(20800425,16003,'./glbudadd.php'),(20800424,16002,'./glbudadd.php'),(20800423,2160,'./glbudadd.php'),(20800422,16001,'./glbudadd.php'),(20800421,1963,'./glbudadd.php'),(20800420,11854,'./glbudadd.php'),(20800419,16000,'./glbudadd.php'),(20800418,15991,'./glbudadd.php'),(20800417,1499,'./glbudadd.php'),(20800416,1435,'./glbudadd.php'),(20800415,15999,'./glbudadd.php'),(20800414,8936,'./glbudadd.php'),(20800413,941,'./glbudadd.php'),(20800412,869,'./glbudadd.php'),(20800411,799,'./glbudadd.php'),(20800410,9492,'./glbudadd.php'),(20800409,611,'./glbudadd.php'),(20800408,15998,'./glbudadd.php'),(20800407,397,'./glbudadd.php'),(20800406,393,'./glbudadd.php'),(20800405,389,'./glbudadd.php'),(20800404,315,'./glbudadd.php'),(20800403,11,'./glbudadd.php'),(20800402,10,'./glbudadd.php'),(20800401,8125,'./glbudadd.php'),(20800400,249,'./glbudadd.php'),(20800399,73,'./glbudadd.php'),(20800398,59,'./glbudadd.php'),(20800397,20,'./glbudadd.php'),(20800396,15117,'./glbankimporttrans.php'),(20800395,10442,'./glbankimporttrans.php'),(20800394,8916,'./glbankimporttrans.php'),(20800393,10441,'./glbankimporttrans.php'),(20800392,10440,'./glbankimporttrans.php'),(20800391,3417,'./glbankimporttrans.php'),(20800390,3333,'./glbankimporttrans.php'),(20800389,10439,'./glbankimporttrans.php'),(20800388,2702,'./glbankimporttrans.php'),(20800387,2606,'./glbankimporttrans.php'),(20800386,10438,'./glbankimporttrans.php'),(20800385,1499,'./glbankimporttrans.php'),(20800384,8936,'./glbankimporttrans.php'),(20800383,869,'./glbankimporttrans.php'),(20800382,691,'./glbankimporttrans.php'),(20800381,10437,'./glbankimporttrans.php'),(20800380,542,'./glbankimporttrans.php'),(20800379,541,'./glbankimporttrans.php'),(20800378,226,'./glbankimporttrans.php'),(20800377,104,'./glbankimporttrans.php'),(20800376,3186,'./glacctupd.php'),(20800375,14667,'./glacctupd.php'),(20800374,2782,'./glacctupd.php'),(20800373,2751,'./glacctupd.php'),(20800372,2702,'./glacctupd.php'),(20800371,2044,'./glacctupd.php'),(20800370,1590,'./glacctupd.php'),(20800369,1483,'./glacctupd.php'),(20800368,11976,'./glacctupd.php'),(20800367,946,'./glacctupd.php'),(20800366,941,'./glacctupd.php'),(20800365,816,'./glacctupd.php'),(20800364,5205,'./glacctupd.php'),(20800363,799,'./glacctupd.php'),(20800362,6165,'./glacctupd.php'),(20800361,315,'./glacctupd.php'),(20800360,5207,'./glacctupd.php'),(20800359,5203,'./glacctupd.php'),(20800354,3415,'./glacctlst1.php'),(20800353,1913,'./glacctlst1.php'),(20800352,1500,'./glacctlst1.php'),(20800351,1484,'./glacctlst1.php'),(20800350,315,'./glacctlst1.php'),(20800349,226,'./glacctlst1.php'),(20800348,20,'./glacctlst1.php'),(20800347,13036,'./glacctlst.php'),(20800346,6260,'./glacctlst.php'),(20800345,6944,'./glacctlst.php'),(20800344,2019,'./glacctlst.php'),(20800343,869,'./glacctlst.php'),(20800342,5205,'./glacctlst.php'),(20800341,619,'./glacctlst.php'),(20800340,6943,'./glacctlst.php'),(20800339,6942,'./glacctlst.php'),(20800338,3558,'./glacctlst.php'),(20800337,478,'./glacctlst.php'),(20800336,32,'./glacctlst.php'),(20800335,20,'./glacctlst.php'),(20800334,14667,'./glacctadd.php'),(20800333,2782,'./glacctadd.php'),(20800332,2751,'./glacctadd.php'),(20800331,2702,'./glacctadd.php'),(20800330,19274,'./glacctadd.php'),(20800329,5296,'./glacctadd.php'),(20800328,7903,'./glacctadd.php'),(20800327,1748,'./glacctadd.php'),(20800326,1590,'./glacctadd.php'),(20800325,869,'./glacctadd.php'),(20800314,3221,'./glacct_assign.php'),(20800313,6260,'./glacct_assign.php'),(20800312,6944,'./glacct_assign.php'),(20800311,8061,'./glacct_assign.php'),(20800310,2702,'./glacct_assign.php'),(20800309,2019,'./glacct_assign.php'),(20800308,2099,'./glacct_assign.php'),(20800307,4346,'./glacct_assign.php'),(20800306,869,'./glacct_assign.php'),(20800305,5205,'./glacct_assign.php'),(20800304,6943,'./glacct_assign.php'),(20800303,6942,'./glacct_assign.php'),(20800302,478,'./glacct_assign.php'),(20800301,8060,'./glacct_assign.php'),(20800300,5074,'./glacct_assign.php'),(20800299,315,'./glacct_assign.php'),(20800298,8065,'./glacct_assign.php'),(20800297,32,'./glacct_assign.php'),(20800296,20,'./glacct_assign.php'),(20678680,9440,'./glaccount_company_fix.php'),(20800295,3225,'./gl_sumlevelupd.php'),(20800294,3186,'./gl_sumlevelupd.php'),(20800293,6940,'./gl_sumlevelupd.php'),(20800292,2702,'./gl_sumlevelupd.php'),(20800291,2044,'./gl_sumlevelupd.php'),(20800290,6481,'./gl_sumlevelupd.php'),(20800289,6941,'./gl_sumlevelupd.php'),(20800288,1143,'./gl_sumlevelupd.php'),(20800287,941,'./gl_sumlevelupd.php'),(20800286,6938,'./gl_sumlevelupd.php'),(20800285,864,'./gl_sumlevelupd.php'),(20800284,799,'./gl_sumlevelupd.php'),(20800283,315,'./gl_sumlevelupd.php'),(20800282,5203,'./gl_sumlevelupd.php'),(20800281,59,'./gl_sumlevelupd.php'),(20800280,6940,'./gl_sumleveladd.php'),(20800279,2702,'./gl_sumleveladd.php'),(20800278,6481,'./gl_sumleveladd.php'),(20800277,6939,'./gl_sumleveladd.php'),(20800276,3994,'./gl_sumleveladd.php'),(20800275,6938,'./gl_sumleveladd.php'),(20800274,315,'./gl_sumleveladd.php'),(20800273,222,'./gl_sumleveladd.php'),(20800272,176,'./gl_sumleveladd.php'),(20800271,4023,'./gl_export_report.php'),(20800270,930,'./gl_export_report.php'),(20800269,655,'./gl_export_report.php'),(20800268,542,'./gl_export_report.php'),(20800267,531,'./gl_export_report.php'),(20678649,3244,'./gl_export_bs.php'),(20678648,929,'./gl_export_bs.php'),(20678647,655,'./gl_export_bs.php'),(20678646,430,'./gl_export_bs.php'),(20720292,2765,'./gl_admin_import_std.php'),(20720291,2355,'./gl_admin_import_std.php'),(20720290,5781,'./gl_admin_import_std.php'),(20720289,5780,'./gl_admin_import_std.php'),(20720288,5779,'./gl_admin_import_std.php'),(20720287,1590,'./gl_admin_import_std.php'),(20720286,32,'./gl_admin_import_std.php'),(20720285,30,'./gl_admin_import_std.php'),(20720284,3514,'./gl_admin_import_std.php'),(20720283,27,'./gl_admin_import_std.php'),(20720282,3157,'./gl_admin_import3_std.php'),(20720281,3041,'./gl_admin_import3_std.php'),(20720280,3039,'./gl_admin_import3_std.php'),(20720279,3777,'./gl_admin_import3_std.php'),(20720278,2350,'./gl_admin_import3_std.php'),(20720277,1631,'./gl_admin_import3_std.php'),(20720276,5778,'./gl_admin_import3_std.php'),(20720275,1525,'./gl_admin_import3_std.php'),(20720274,869,'./gl_admin_import3_std.php'),(20720273,315,'./gl_admin_import3_std.php'),(20720272,30,'./gl_admin_import3_std.php'),(20800265,3157,'./gl_admin_import3.php'),(20800264,3041,'./gl_admin_import3.php'),(20800263,3039,'./gl_admin_import3.php'),(20800262,3777,'./gl_admin_import3.php'),(20800261,2350,'./gl_admin_import3.php'),(20800260,16212,'./gl_admin_import3.php'),(20800259,1770,'./gl_admin_import3.php'),(20800258,15804,'./gl_admin_import3.php'),(20800257,12903,'./gl_admin_import3.php'),(20800256,1590,'./gl_admin_import3.php'),(20800255,16166,'./gl_admin_import3.php'),(20800254,16165,'./gl_admin_import3.php'),(20800253,1525,'./gl_admin_import3.php'),(20800252,8936,'./gl_admin_import3.php'),(20800251,15944,'./gl_admin_import3.php'),(20800250,1047,'./gl_admin_import3.php'),(20800249,15803,'./gl_admin_import3.php'),(20800248,869,'./gl_admin_import3.php'),(20800247,619,'./gl_admin_import3.php'),(20800246,315,'./gl_admin_import3.php'),(20800245,222,'./gl_admin_import3.php'),(20800244,30,'./gl_admin_import3.php'),(20720249,3157,'./gl_admin_import2_std.php'),(20720248,2356,'./gl_admin_import2_std.php'),(20720247,2347,'./gl_admin_import2_std.php'),(20720246,1963,'./gl_admin_import2_std.php'),(20720245,5778,'./gl_admin_import2_std.php'),(20720244,1402,'./gl_admin_import2_std.php'),(20720243,315,'./gl_admin_import2_std.php'),(20720242,30,'./gl_admin_import2_std.php'),(20720241,27,'./gl_admin_import2_std.php'),(20800243,3421,'./gl_admin_import2.php'),(20800242,3202,'./gl_admin_import2.php'),(20800241,3225,'./gl_admin_import2.php'),(20800240,3157,'./gl_admin_import2.php'),(20800239,2356,'./gl_admin_import2.php'),(20800238,2347,'./gl_admin_import2.php'),(20800237,1993,'./gl_admin_import2.php'),(20800236,1963,'./gl_admin_import2.php'),(20800235,15552,'./gl_admin_import2.php'),(20800234,1590,'./gl_admin_import2.php'),(20800233,5271,'./gl_admin_import2.php'),(20800232,16166,'./gl_admin_import2.php'),(20800231,16165,'./gl_admin_import2.php'),(20800230,15934,'./gl_admin_import2.php'),(20800229,1402,'./gl_admin_import2.php'),(20800228,619,'./gl_admin_import2.php'),(20800227,315,'./gl_admin_import2.php'),(20800226,30,'./gl_admin_import2.php'),(20800225,27,'./gl_admin_import2.php'),(20800224,12211,'./gl_admin_import.php'),(20800223,5837,'./gl_admin_import.php'),(20800222,12207,'./gl_admin_import.php'),(20800221,2765,'./gl_admin_import.php'),(20800220,2355,'./gl_admin_import.php'),(20800219,7365,'./gl_admin_import.php'),(20800218,7272,'./gl_admin_import.php'),(20800217,5823,'./gl_admin_import.php'),(20800216,5777,'./gl_admin_import.php'),(20800215,3518,'./gl_admin_import.php'),(20800214,5782,'./gl_admin_import.php'),(20800213,5776,'./gl_admin_import.php'),(20800212,1590,'./gl_admin_import.php'),(20800211,16166,'./gl_admin_import.php'),(20800210,16165,'./gl_admin_import.php'),(20800209,15934,'./gl_admin_import.php'),(20800208,7361,'./gl_admin_import.php'),(20800207,5820,'./gl_admin_import.php'),(20800206,5822,'./gl_admin_import.php'),(20800205,619,'./gl_admin_import.php'),(20800204,5825,'./gl_admin_import.php'),(20800203,15997,'./gl_admin_import.php'),(20800202,32,'./gl_admin_import.php'),(20800201,30,'./gl_admin_import.php'),(20800200,3517,'./gl_admin_import.php'),(20800199,3514,'./gl_admin_import.php'),(20800198,27,'./gl_admin_import.php'),(20800197,6937,'./gl_admin_export.php'),(20800196,3075,'./gl_admin_export.php'),(20800195,1355,'./gl_admin_export.php'),(20800194,1354,'./gl_admin_export.php'),(20800193,8936,'./gl_admin_export.php'),(20800192,6936,'./gl_admin_export.php'),(20800191,32,'./gl_admin_export.php'),(20800190,30,'./gl_admin_export.php'),(20800189,27,'./gl_admin_export.php'),(20800188,3421,'./gl_admin_cf.php'),(20800187,2702,'./gl_admin_cf.php'),(20800186,10347,'./gl_admin_cf.php'),(20800185,9551,'./gl_admin_cf.php'),(20800184,10211,'./gl_admin_cf.php'),(20800183,10210,'./gl_admin_cf.php'),(20800182,2044,'./gl_admin_cf.php'),(20800181,1973,'./gl_admin_cf.php'),(20800180,10209,'./gl_admin_cf.php'),(20800179,10208,'./gl_admin_cf.php'),(20800178,1935,'./gl_admin_cf.php'),(20800177,10207,'./gl_admin_cf.php'),(20800176,10206,'./gl_admin_cf.php'),(20800175,941,'./gl_admin_cf.php'),(20800174,799,'./gl_admin_cf.php'),(20800173,10205,'./gl_admin_cf.php'),(20800172,451,'./gl_admin_cf.php'),(20800171,10204,'./gl_admin_cf.php'),(20800170,10203,'./gl_admin_cf.php'),(20800169,10202,'./gl_admin_cf.php'),(20800168,10201,'./gl_admin_cf.php'),(20800167,10200,'./gl_admin_cf.php'),(20800166,10199,'./gl_admin_cf.php'),(20800165,10198,'./gl_admin_cf.php'),(20800164,10197,'./gl_admin_cf.php'),(20800163,10196,'./gl_admin_cf.php'),(20800162,10195,'./gl_admin_cf.php'),(20800161,10194,'./gl_admin_cf.php'),(20800160,10346,'./gl_admin_cf.php'),(20800159,315,'./gl_admin_cf.php'),(20800158,5203,'./gl_admin_cf.php'),(20800157,12838,'./gl_admin_cf.php'),(20800156,5297,'./gl_admin_cf.php'),(20800155,59,'./gl_admin_cf.php'),(20720151,3263,'./genuserupd_temp.php'),(20720150,3224,'./genuserupd_temp.php'),(20720149,2710,'./genuserupd_temp.php'),(20720148,965,'./genuserupd_temp.php'),(20720147,858,'./genuserupd_temp.php'),(20720146,315,'./genuserupd_temp.php'),(20720145,5203,'./genuserupd_temp.php'),(20720144,144,'./genuserupd_temp.php'),(20800154,9636,'./genuserupd.php'),(20800153,3410,'./genuserupd.php'),(20800152,14886,'./genuserupd.php'),(20800151,3252,'./genuserupd.php'),(20800150,3224,'./genuserupd.php'),(20800149,2805,'./genuserupd.php'),(20800148,2710,'./genuserupd.php'),(20800147,2702,'./genuserupd.php'),(20800146,2581,'./genuserupd.php'),(20800145,9168,'./genuserupd.php'),(20800144,14629,'./genuserupd.php'),(20800143,2237,'./genuserupd.php'),(20800142,10097,'./genuserupd.php'),(20800141,1540,'./genuserupd.php'),(20800140,8936,'./genuserupd.php'),(20800139,11995,'./genuserupd.php'),(20800138,965,'./genuserupd.php'),(20800137,941,'./genuserupd.php'),(20800136,858,'./genuserupd.php'),(20800135,799,'./genuserupd.php'),(20800134,542,'./genuserupd.php'),(20800133,12190,'./genuserupd.php'),(20800132,9257,'./genuserupd.php'),(20800131,315,'./genuserupd.php'),(20800130,5203,'./genuserupd.php'),(20800129,197,'./genuserupd.php'),(20800128,9611,'./genuserupd.php'),(20800127,144,'./genuserupd.php'),(20800125,9610,'./genuserrightsgroup.php'),(20800124,18665,'./genuserrightsgroup.php'),(20800123,9605,'./genuserrightsgroup.php'),(20800122,5990,'./genuserrightsgroup.php'),(20800121,2710,'./genuserrightsgroup.php'),(20800120,2702,'./genuserrightsgroup.php'),(20800119,11643,'./genuserrightsgroup.php'),(20800118,2270,'./genuserrightsgroup.php'),(20800117,2258,'./genuserrightsgroup.php'),(20800116,2200,'./genuserrightsgroup.php'),(20800115,9608,'./genuserrightsgroup.php'),(20800114,18664,'./genuserrightsgroup.php'),(20800113,18663,'./genuserrightsgroup.php'),(20800112,18662,'./genuserrightsgroup.php'),(20800111,18661,'./genuserrightsgroup.php'),(20800110,18660,'./genuserrightsgroup.php'),(20800109,18659,'./genuserrightsgroup.php'),(20800108,18658,'./genuserrightsgroup.php'),(20800107,18657,'./genuserrightsgroup.php'),(20800106,18656,'./genuserrightsgroup.php'),(20800105,18655,'./genuserrightsgroup.php'),(20800104,18654,'./genuserrightsgroup.php'),(20800068,9606,'./genuserrights.php'),(20800067,18665,'./genuserrights.php'),(20800066,9605,'./genuserrights.php'),(20800065,5990,'./genuserrights.php'),(20800064,2710,'./genuserrights.php'),(20800063,2702,'./genuserrights.php'),(20800062,2270,'./genuserrights.php'),(20800061,2258,'./genuserrights.php'),(20800060,2200,'./genuserrights.php'),(20800059,9604,'./genuserrights.php'),(20800058,9603,'./genuserrights.php'),(20800057,18664,'./genuserrights.php'),(20800056,18663,'./genuserrights.php'),(20800055,18662,'./genuserrights.php'),(20800054,18661,'./genuserrights.php'),(20800053,18660,'./genuserrights.php'),(20800052,18659,'./genuserrights.php'),(20800051,18658,'./genuserrights.php'),(20800050,18657,'./genuserrights.php'),(20720000,3253,'./genuseradd_temp.php'),(20719999,3224,'./genuseradd_temp.php'),(20719998,315,'./genuseradd_temp.php'),(20719997,59,'./genuseradd_temp.php'),(20800011,3224,'./genuseradd.php'),(20800010,14667,'./genuseradd.php'),(20800009,14503,'./genuseradd.php'),(20800008,14629,'./genuseradd.php'),(20800007,2236,'./genuseradd.php'),(20800006,2235,'./genuseradd.php'),(20800005,2237,'./genuseradd.php'),(20800004,12009,'./genuseradd.php'),(20800003,14502,'./genuseradd.php'),(20800002,8936,'./genuseradd.php'),(20800001,1127,'./genuseradd.php'),(20800000,542,'./genuseradd.php'),(20799999,541,'./genuseradd.php'),(20678333,3252,'./genmessage.php'),(20678332,3072,'./genmessage.php'),(20678331,2797,'./genmessage.php'),(20678330,2796,'./genmessage.php'),(20678329,2795,'./genmessage.php'),(20678328,2793,'./genmessage.php'),(20678327,2790,'./genmessage.php'),(20678326,2789,'./genmessage.php'),(20678325,2794,'./genmessage.php'),(20678324,2591,'./genmessage.php'),(20678323,2589,'./genmessage.php'),(20678322,2582,'./genmessage.php'),(20678321,2581,'./genmessage.php'),(20678320,2401,'./genmessage.php'),(20678319,2400,'./genmessage.php'),(20678318,2068,'./genmessage.php'),(20678317,1955,'./genmessage.php'),(20678316,1883,'./genmessage.php'),(20678315,1882,'./genmessage.php'),(20678314,1881,'./genmessage.php'),(20678313,1880,'./genmessage.php'),(20678312,1467,'./genmessage.php'),(20678311,1430,'./genmessage.php'),(20678310,925,'./genmessage.php'),(20678309,320,'./genmessage.php'),(20678308,315,'./genmessage.php'),(20801991,9492,'./importemployeeexpenses.php'),(20799995,3056,'./gencompanyupd.php'),(20799994,8989,'./gencompanyupd.php'),(20799993,2710,'./gencompanyupd.php'),(20799992,2702,'./gencompanyupd.php'),(20799991,5072,'./gencompanyupd.php'),(20799990,1333,'./gencompanyupd.php'),(20799989,14113,'./gencompanyupd.php'),(20799988,964,'./gencompanyupd.php'),(20799987,11989,'./gencompanyupd.php'),(20799986,941,'./gencompanyupd.php'),(20799985,824,'./gencompanyupd.php'),(20799984,799,'./gencompanyupd.php'),(20799983,585,'./gencompanyupd.php'),(20799982,578,'./gencompanyupd.php'),(20799981,13994,'./gencompanyupd.php'),(20799980,315,'./gencompanyupd.php'),(20799979,7775,'./gencompanyupd.php'),(20799978,95,'./gencompanyupd.php'),(20799977,59,'./gencompanyupd.php'),(20799976,14680,'./gencompanyadd.php'),(20799975,12735,'./gencompanyadd.php'),(20799974,3056,'./gencompanyadd.php'),(20799973,2727,'./gencompanyadd.php'),(20799972,2702,'./gencompanyadd.php'),(20799971,14679,'./gencompanyadd.php'),(20799970,1333,'./gencompanyadd.php'),(20799969,1321,'./gencompanyadd.php'),(20799968,14678,'./gencompanyadd.php'),(20799967,8936,'./gencompanyadd.php'),(20799966,1128,'./gencompanyadd.php'),(20799965,1127,'./gencompanyadd.php'),(20799964,11987,'./gencompanyadd.php'),(20799963,315,'./gencompanyadd.php'),(20799962,74,'./gencompanyadd.php'),(20799961,6176,'./fileupload.php'),(20799960,17413,'./fileupload.php'),(20799957,12800,'./features.php'),(20799956,2948,'./features.php'),(20799955,4267,'./features.php'),(20799954,15290,'./features.php'),(20799953,15289,'./features.php'),(20799952,11810,'./features.php'),(20799951,12060,'./features.php'),(20799950,8229,'./features.php'),(20799949,8228,'./features.php'),(20799948,8227,'./features.php'),(20799947,8226,'./features.php'),(20799946,869,'./features.php'),(20799945,8225,'./features.php'),(20799944,12849,'./features.php'),(20799943,8753,'./features.php'),(20799942,8224,'./features.php'),(20799941,15288,'./features.php'),(20799940,15293,'./featurepurchase.subscription.php'),(20799939,15303,'./featurepurchase.subscription.php'),(20799938,15302,'./featurepurchase.subscription.php'),(20799937,5329,'./featurepurchase.subscription.php'),(20799936,15290,'./featurepurchase.subscription.php'),(20799935,10386,'./featurepurchase.subscription.php'),(20799934,15301,'./featurepurchase.subscription.php'),(20799933,15289,'./featurepurchase.subscription.php'),(20799932,15245,'./featurepurchase.subscription.php'),(20799931,13066,'./featurepurchase.subscription.php'),(20799926,15332,'./featurepurchase.setcc.php'),(20799930,8227,'./featurepurchase.subscription.php'),(20799929,15333,'./featurepurchase.subscription.php'),(20799928,12849,'./featurepurchase.subscription.php'),(20799927,15288,'./featurepurchase.subscription.php'),(20799925,11792,'./featurepurchase.php'),(20799924,13559,'./featurepurchase.php'),(20799923,3450,'./featurepurchase.php'),(20799922,2324,'./featurepurchase.php'),(20799921,13291,'./featurepurchase.php'),(20799920,15298,'./featurepurchase.php'),(20799919,11146,'./featurepurchase.php'),(20799918,11145,'./featurepurchase.php'),(20799917,8936,'./featurepurchase.php'),(20799916,1047,'./featurepurchase.php'),(20799915,981,'./featurepurchase.php'),(20799914,13033,'./featurepurchase.php'),(20799913,542,'./featurepurchase.php'),(20799912,12052,'./featurepurchase.php'),(20799911,5912,'./featurepurchase.php'),(20799910,11791,'./featurepurchase.php'),(20799909,9380,'./featurepurchase.php'),(20799908,9379,'./featurepurchase.php'),(20799907,9378,'./featurepurchase.php'),(20799906,9377,'./featurepurchase.php'),(20799905,55,'./featurepurchase.php'),(20799904,13926,'./featurepurchase.list.php'),(20799903,15294,'./featurepurchase.list.php'),(20799902,15293,'./featurepurchase.list.php'),(20799901,13683,'./featurepurchase.list.php'),(20799900,13682,'./featurepurchase.list.php'),(20799899,13681,'./featurepurchase.list.php'),(20799898,13680,'./featurepurchase.list.php'),(20799897,13679,'./featurepurchase.list.php'),(20799896,15296,'./featurepurchase.list.php'),(20799895,2270,'./featurepurchase.list.php'),(20799894,2258,'./featurepurchase.list.php'),(20799893,2208,'./featurepurchase.list.php'),(20799892,13291,'./featurepurchase.list.php'),(20799891,2200,'./featurepurchase.list.php'),(20799890,12842,'./featurepurchase.list.php'),(20799889,2136,'./featurepurchase.list.php'),(20799888,8516,'./featurepurchase.list.php'),(20799887,15290,'./featurepurchase.list.php'),(20799886,13797,'./featurepurchase.list.php'),(20799885,15289,'./featurepurchase.list.php'),(20799884,3672,'./featurepurchase.list.php'),(20799883,1639,'./featurepurchase.list.php'),(20799882,1546,'./featurepurchase.list.php'),(20799881,13796,'./featurepurchase.list.php'),(20799880,12965,'./featurepurchase.list.php'),(20799879,10383,'./featurepurchase.list.php'),(20799878,8936,'./featurepurchase.list.php'),(20799877,6115,'./featurepurchase.list.php'),(20799876,13925,'./featurepurchase.list.php'),(20799875,13924,'./featurepurchase.list.php'),(20799874,13033,'./featurepurchase.list.php'),(20799873,15295,'./featurepurchase.list.php'),(20799872,13795,'./featurepurchase.list.php'),(20799871,13923,'./featurepurchase.list.php'),(20799870,3544,'./featurepurchase.list.php'),(20799869,197,'./featurepurchase.list.php'),(20799868,3533,'./featurepurchase.list.php'),(20799867,12849,'./featurepurchase.list.php'),(20799866,13794,'./featurepurchase.list.php'),(20799865,55,'./featurepurchase.list.php'),(20799864,15288,'./featurepurchase.list.php'),(20799863,3221,'./featurepurchase.getprods.php'),(20799862,3090,'./featurepurchase.getprods.php'),(20799861,12067,'./featurepurchase.getprods.php'),(20799860,2404,'./featurepurchase.getprods.php'),(20799859,12062,'./featurepurchase.getprods.php'),(20799858,2009,'./featurepurchase.getprods.php'),(20799857,8229,'./featurepurchase.getprods.php'),(20799856,12058,'./featurepurchase.getprods.php'),(20799855,12057,'./featurepurchase.getprods.php'),(20799854,8936,'./featurepurchase.getprods.php'),(20799853,8226,'./featurepurchase.getprods.php'),(20799852,12053,'./featurepurchase.getprods.php'),(20799851,315,'./featurepurchase.getprods.php'),(20799850,12050,'./featurepurchase.getprods.php'),(20799849,12049,'./featurepurchase.getprods.php'),(20799848,12048,'./featurepurchase.getprods.php'),(20799847,12240,'./featurepurchase.getcc.php'),(20799846,12072,'./featurepurchase.getcc.php'),(20799845,12239,'./featurepurchase.getcc.php'),(20799844,12071,'./featurepurchase.getcc.php'),(20799843,12070,'./featurepurchase.getcc.php'),(20799842,15294,'./featurepurchase.getcc.php'),(20799841,15293,'./featurepurchase.getcc.php'),(20799840,3090,'./featurepurchase.getcc.php'),(20799839,12715,'./featurepurchase.getcc.php'),(20799838,2975,'./featurepurchase.getcc.php'),(20799837,12069,'./featurepurchase.getcc.php'),(20799836,3777,'./featurepurchase.getcc.php'),(20799835,2404,'./featurepurchase.getcc.php'),(20799834,12231,'./featurepurchase.getcc.php'),(20799833,2324,'./featurepurchase.getcc.php'),(20799832,4023,'./featurepurchase.getcc.php'),(20799831,15292,'./featurepurchase.getcc.php'),(20799830,2009,'./featurepurchase.getcc.php'),(20799829,1992,'./featurepurchase.getcc.php'),(20799828,5329,'./featurepurchase.getcc.php'),(20799827,15291,'./featurepurchase.getcc.php'),(20799826,13538,'./featurepurchase.getcc.php'),(20799825,15331,'./featurepurchase.getcc.php'),(20799824,1583,'./featurepurchase.getcc.php'),(20799823,1582,'./featurepurchase.getcc.php'),(20799822,6744,'./featurepurchase.getcc.php'),(20799821,12060,'./featurepurchase.getcc.php'),(20799820,8227,'./featurepurchase.getcc.php'),(20799819,8936,'./featurepurchase.getcc.php'),(20799818,981,'./featurepurchase.getcc.php'),(20799817,12054,'./featurepurchase.getcc.php'),(20799816,5912,'./featurepurchase.getcc.php'),(20799815,5910,'./featurepurchase.getcc.php'),(20799814,416,'./featurepurchase.getcc.php'),(20799813,9380,'./featurepurchase.getcc.php'),(20799812,9379,'./featurepurchase.getcc.php'),(20799811,12051,'./featurepurchase.getcc.php'),(20799810,9378,'./featurepurchase.getcc.php'),(20799809,9377,'./featurepurchase.getcc.php'),(20799808,15330,'./featurepurchase.editcc.php'),(20799807,12800,'./featurelist.php'),(20799806,2270,'./featurelist.php'),(20799805,2258,'./featurelist.php'),(20799804,2200,'./featurelist.php'),(20799803,15290,'./featurelist.php'),(20799802,15289,'./featurelist.php'),(20799801,3672,'./featurelist.php'),(20799800,1639,'./featurelist.php'),(20799799,13796,'./featurelist.php'),(20799798,8228,'./featurelist.php'),(20799797,8226,'./featurelist.php'),(20799796,13925,'./featurelist.php'),(20799795,3544,'./featurelist.php'),(20799794,197,'./featurelist.php'),(20799793,3533,'./featurelist.php'),(20799792,12849,'./featurelist.php'),(20799791,15288,'./featurelist.php'),(20799790,14067,'./feature_translate.php'),(20799789,14066,'./feature_translate.php'),(20799788,3037,'./feature_translate.php'),(20799787,14065,'./feature_translate.php'),(20799786,14064,'./feature_translate.php'),(20799785,1935,'./feature_translate.php'),(20799784,15290,'./feature_translate.php'),(20799783,15289,'./feature_translate.php'),(20799782,14063,'./feature_translate.php'),(20799781,6505,'./feature_translate.php'),(20799780,14062,'./feature_translate.php'),(20799779,1587,'./feature_translate.php'),(20799778,13995,'./feature_translate.php'),(20799777,14061,'./feature_translate.php'),(20799776,941,'./feature_translate.php'),(20799775,869,'./feature_translate.php'),(20799774,14060,'./feature_translate.php'),(20799773,14059,'./feature_translate.php'),(20799772,14058,'./feature_translate.php'),(20799771,14057,'./feature_translate.php'),(20799770,12849,'./feature_translate.php'),(20799769,15288,'./feature_translate.php'),(20678080,1963,'./family_picker.php'),(20678079,315,'./family_picker.php'),(20799768,3432,'./exportvendors.php'),(20799767,4109,'./exportvendors.php'),(20799766,5701,'./exportvendors.php'),(20799765,6141,'./exportvendors.php'),(20799764,8546,'./exportvendors.php'),(20799763,2936,'./exportvendors.php'),(20799762,8545,'./exportvendors.php'),(20799761,2325,'./exportvendors.php'),(20799760,2324,'./exportvendors.php'),(20799759,15611,'./exportvendors.php'),(20799758,3470,'./exportvendors.php'),(20799757,8544,'./exportvendors.php'),(20799756,4720,'./exportvendors.php'),(20799755,1770,'./exportvendors.php'),(20799754,4084,'./exportvendors.php'),(20799753,1758,'./exportvendors.php'),(20799752,14996,'./exportvendors.php'),(20799751,1429,'./exportvendors.php'),(20799750,1381,'./exportvendors.php'),(20799749,11786,'./exportvendors.php'),(20799748,1354,'./exportvendors.php'),(20799747,8936,'./exportvendors.php'),(20799746,5697,'./exportvendors.php'),(20799745,981,'./exportvendors.php'),(20799744,698,'./exportvendors.php'),(20799743,9341,'./exportvendors.php'),(20799742,659,'./exportvendors.php'),(20799741,581,'./exportvendors.php'),(20799740,524,'./exportvendors.php'),(20799739,306,'./exportvendors.php'),(20799738,185,'./exportvendors.php'),(20799737,1404,'./exportitemsdisplay.php'),(20799736,9935,'./exportitems.php'),(20799735,9933,'./exportitems.php'),(20799734,9932,'./exportitems.php'),(20799733,1354,'./exportitems.php'),(20799732,9931,'./exportitems.php'),(20799731,9929,'./exportitems.php'),(20678040,3421,'./exportepinvoices.php'),(20678039,13032,'./exportepinvoices.php'),(20678038,1973,'./exportepinvoices.php'),(20678037,13031,'./exportepinvoices.php'),(20678036,13030,'./exportepinvoices.php'),(20678035,13074,'./exportepinvoices.php'),(20678034,13028,'./exportepinvoices.php'),(20678033,8936,'./exportepinvoices.php'),(20678032,3421,'./exportepasn.php'),(20678031,13073,'./exportepasn.php'),(20678030,4023,'./exportepasn.php'),(20678029,13032,'./exportepasn.php'),(20678028,1973,'./exportepasn.php'),(20678027,13072,'./exportepasn.php'),(20678026,13071,'./exportepasn.php'),(20678025,13070,'./exportepasn.php'),(20678024,8936,'./exportepasn.php'),(20799730,13851,'./estquoteworkstepsupd.php'),(20799729,2710,'./estquoteworkstepsupd.php'),(20799728,2702,'./estquoteworkstepsupd.php'),(20799727,966,'./estquoteworkstepsupd.php'),(20799726,941,'./estquoteworkstepsupd.php'),(20799725,799,'./estquoteworkstepsupd.php'),(20799724,315,'./estquoteworkstepsupd.php'),(20799723,5203,'./estquoteworkstepsupd.php'),(20799722,222,'./estquoteworkstepsupd.php'),(20799721,87,'./estquoteworkstepsupd.php'),(20799720,59,'./estquoteworkstepsupd.php'),(20799719,13834,'./estquoteworkstepsadd.php'),(20799718,13833,'./estquoteworkstepsadd.php'),(20799717,2902,'./estquoteworkstepsadd.php'),(20799716,2702,'./estquoteworkstepsadd.php'),(20799715,315,'./estquoteworkstepsadd.php'),(20799714,222,'./estquoteworkstepsadd.php'),(20799713,3398,'./estquoteworkareaupd.php'),(20799712,3397,'./estquoteworkareaupd.php'),(20799711,3396,'./estquoteworkareaupd.php'),(20799710,2710,'./estquoteworkareaupd.php'),(20799709,2702,'./estquoteworkareaupd.php'),(20799708,966,'./estquoteworkareaupd.php'),(20799707,941,'./estquoteworkareaupd.php'),(20799706,799,'./estquoteworkareaupd.php'),(20799705,315,'./estquoteworkareaupd.php'),(20799704,300,'./estquoteworkareaupd.php'),(20799703,5203,'./estquoteworkareaupd.php'),(20799702,3998,'./estquoteworkareaupd.php'),(20799701,59,'./estquoteworkareaupd.php'),(20799700,3396,'./estquoteworkareaadd.php'),(20799699,3395,'./estquoteworkareaadd.php'),(20799698,3394,'./estquoteworkareaadd.php'),(20799697,2702,'./estquoteworkareaadd.php'),(20799696,315,'./estquoteworkareaadd.php'),(20799695,3955,'./estquoteworkareaadd.php'),(20799694,3398,'./estquoteworkarea_assign.php'),(20799693,3397,'./estquoteworkarea_assign.php'),(20799692,3394,'./estquoteworkarea_assign.php'),(20799691,3273,'./estquoteworkarea_assign.php'),(20799690,2950,'./estquoteworkarea_assign.php'),(20799689,2906,'./estquoteworkarea_assign.php'),(20799688,2905,'./estquoteworkarea_assign.php'),(20799687,2833,'./estquoteworkarea_assign.php'),(20799686,2702,'./estquoteworkarea_assign.php'),(20799685,2505,'./estquoteworkarea_assign.php'),(20799684,2504,'./estquoteworkarea_assign.php'),(20799683,2459,'./estquoteworkarea_assign.php'),(20799682,3931,'./estquoteworkarea_assign.php'),(20799681,2070,'./estquoteworkarea_assign.php'),(20799680,1534,'./estquoteworkarea_assign.php'),(20799679,966,'./estquoteworkarea_assign.php'),(20799678,941,'./estquoteworkarea_assign.php'),(20799677,937,'./estquoteworkarea_assign.php'),(20799676,3932,'./estquoteworkarea_assign.php'),(20799675,315,'./estquoteworkarea_assign.php'),(20799674,300,'./estquoteworkarea_assign.php'),(20799673,3998,'./estquoteworkarea_assign.php'),(20799672,59,'./estquoteworkarea_assign.php'),(20799671,3381,'./estquotestockupd_percentage.php'),(20799670,3221,'./estquotestockupd_percentage.php'),(20799669,3202,'./estquotestockupd_percentage.php'),(20799668,12793,'./estquotestockupd_percentage.php'),(20799667,12792,'./estquotestockupd_percentage.php'),(20799666,12791,'./estquotestockupd_percentage.php'),(20799665,1963,'./estquotestockupd_percentage.php'),(20799664,12780,'./estquotestockupd_percentage.php'),(20799663,12790,'./estquotestockupd_percentage.php'),(20799662,12789,'./estquotestockupd_percentage.php'),(20799661,12788,'./estquotestockupd_percentage.php'),(20799660,3965,'./estquotestockupd.php'),(20799659,3195,'./estquotestockupd.php'),(20799658,2972,'./estquotestockupd.php'),(20799657,2961,'./estquotestockupd.php'),(20799656,2957,'./estquotestockupd.php'),(20799655,12748,'./estquotestockupd.php'),(20799654,12747,'./estquotestockupd.php'),(20799653,2710,'./estquotestockupd.php'),(20799652,2702,'./estquotestockupd.php'),(20799651,4637,'./estquotestockupd.php'),(20799650,12746,'./estquotestockupd.php'),(20799649,1317,'./estquotestockupd.php'),(20799648,1204,'./estquotestockupd.php'),(20799647,1123,'./estquotestockupd.php'),(20799646,966,'./estquotestockupd.php'),(20799645,941,'./estquotestockupd.php'),(20799644,12745,'./estquotestockupd.php'),(20799643,815,'./estquotestockupd.php'),(20799642,807,'./estquotestockupd.php'),(20799641,864,'./estquotestockupd.php'),(20799640,799,'./estquotestockupd.php'),(20799639,542,'./estquotestockupd.php'),(20799638,428,'./estquotestockupd.php'),(20799637,12744,'./estquotestockupd.php'),(20799636,315,'./estquotestockupd.php'),(20799635,5203,'./estquotestockupd.php'),(20799634,171,'./estquotestockupd.php'),(20799633,141,'./estquotestockupd.php'),(20799632,140,'./estquotestockupd.php'),(20799631,59,'./estquotestockupd.php'),(20799630,2951,'./estquotestockadd.php'),(20799629,2702,'./estquotestockadd.php'),(20799628,2710,'./estquotestd_jobdescriptionupd.php'),(20799627,2702,'./estquotestd_jobdescriptionupd.php'),(20799626,966,'./estquotestd_jobdescriptionupd.php'),(20799625,941,'./estquotestd_jobdescriptionupd.php'),(20799624,799,'./estquotestd_jobdescriptionupd.php'),(20799623,315,'./estquotestd_jobdescriptionupd.php'),(20799622,5203,'./estquotestd_jobdescriptionupd.php'),(20799621,87,'./estquotestd_jobdescriptionupd.php'),(20799620,59,'./estquotestd_jobdescriptionupd.php'),(20799619,14677,'./estquotestd_jobdescription.php'),(20799618,2702,'./estquotestd_jobdescription.php'),(20799617,315,'./estquotestd_jobdescription.php'),(20799616,3429,'./estquoteshipping.php'),(20799615,4591,'./estquoteshipping.php'),(20799614,5070,'./estquoteshipping.php'),(20799613,4590,'./estquoteshipping.php'),(20799612,4589,'./estquoteshipping.php'),(20799611,5069,'./estquoteshipping.php'),(20799610,4587,'./estquoteshipping.php'),(20799609,4586,'./estquoteshipping.php'),(20799608,2959,'./estquoteshipping.php'),(20799607,2950,'./estquoteshipping.php'),(20799606,5068,'./estquoteshipping.php'),(20799605,2886,'./estquoteshipping.php'),(20799604,2819,'./estquoteshipping.php'),(20799603,2816,'./estquoteshipping.php'),(20799602,4584,'./estquoteshipping.php'),(20799601,2795,'./estquoteshipping.php'),(20799600,5067,'./estquoteshipping.php'),(20799599,2702,'./estquoteshipping.php'),(20799598,5066,'./estquoteshipping.php'),(20799597,5084,'./estquoteshipping.php'),(20799596,5065,'./estquoteshipping.php'),(20799595,2529,'./estquoteshipping.php'),(20799594,2508,'./estquoteshipping.php'),(20799593,13382,'./estquoteshipping.php'),(20799592,2459,'./estquoteshipping.php'),(20799591,4582,'./estquoteshipping.php'),(20799590,5064,'./estquoteshipping.php'),(20799589,4565,'./estquoteshipping.php'),(20799588,4580,'./estquoteshipping.php'),(20799587,4579,'./estquoteshipping.php'),(20799586,2199,'./estquoteshipping.php'),(20799585,2165,'./estquoteshipping.php'),(20799584,6935,'./estquoteshipping.php'),(20799583,6934,'./estquoteshipping.php'),(20799582,5083,'./estquoteshipping.php'),(20799581,2094,'./estquoteshipping.php'),(20799580,2103,'./estquoteshipping.php'),(20799579,1963,'./estquoteshipping.php'),(20799578,5063,'./estquoteshipping.php'),(20799577,4720,'./estquoteshipping.php'),(20799576,5081,'./estquoteshipping.php'),(20799575,4576,'./estquoteshipping.php'),(20799574,4575,'./estquoteshipping.php'),(20799573,4574,'./estquoteshipping.php'),(20799572,4169,'./estquoteshipping.php'),(20799571,4573,'./estquoteshipping.php'),(20799570,1047,'./estquoteshipping.php'),(20799569,1036,'./estquoteshipping.php'),(20799568,5080,'./estquoteshipping.php'),(20799567,5079,'./estquoteshipping.php'),(20799566,869,'./estquoteshipping.php'),(20799565,799,'./estquoteshipping.php'),(20799564,4363,'./estquoteshipping.php'),(20799563,4481,'./estquoteshipping.php'),(20799562,697,'./estquoteshipping.php'),(20799561,695,'./estquoteshipping.php'),(20799560,606,'./estquoteshipping.php'),(20799559,542,'./estquoteshipping.php'),(20799558,5718,'./estquoteshipping.php'),(20799557,5062,'./estquoteshipping.php'),(20799556,4571,'./estquoteshipping.php'),(20799555,5076,'./estquoteshipping.php'),(20799554,5075,'./estquoteshipping.php'),(20799553,315,'./estquoteshipping.php'),(20799552,5203,'./estquoteshipping.php'),(20799551,258,'./estquoteshipping.php'),(20799550,2886,'./estquotescheduledetail.php'),(20799549,10778,'./estquotescheduledetail.php'),(20799548,6931,'./estquotescheduledetail.php'),(20799547,6930,'./estquotescheduledetail.php'),(20799546,10993,'./estquotescheduledetail.php'),(20799545,740,'./estquotescheduledetail.php'),(20799544,4363,'./estquotescheduledetail.php'),(20799543,10777,'./estquotescheduledetail.php'),(20799542,6929,'./estquotescheduledetail.php'),(20799541,542,'./estquotescheduledetail.php'),(20799540,6928,'./estquotescheduledetail.php'),(20799539,6933,'./estquoteschedule.php'),(20799538,6932,'./estquoteschedule.php'),(20799537,4070,'./estquoteschedule.php'),(20799536,6931,'./estquoteschedule.php'),(20799535,6930,'./estquoteschedule.php'),(20799534,1031,'./estquoteschedule.php'),(20799533,931,'./estquoteschedule.php'),(20799532,740,'./estquoteschedule.php'),(20799531,4363,'./estquoteschedule.php'),(20799530,737,'./estquoteschedule.php'),(20799529,8369,'./estquoteschedule.php'),(20799528,6929,'./estquoteschedule.php'),(20799527,387,'./estquoteschedule.php'),(20799526,6928,'./estquoteschedule.php'),(20677818,13553,'./estquoteprintexport_ow.php'),(20677817,13497,'./estquoteprintexport_ow.php'),(20677816,13496,'./estquoteprintexport_ow.php'),(20677815,13962,'./estquoteprintexport_ow.php'),(20677814,13495,'./estquoteprintexport_ow.php'),(20677813,532,'./estquoteprintexport_ow.php'),(20799525,3381,'./estquotepricelstupd.php'),(20799524,3243,'./estquotepricelstupd.php'),(20799523,3220,'./estquotepricelstupd.php'),(20799522,3213,'./estquotepricelstupd.php'),(20799521,3131,'./estquotepricelstupd.php'),(20799520,3133,'./estquotepricelstupd.php'),(20799519,2886,'./estquotepricelstupd.php'),(20799518,2710,'./estquotepricelstupd.php'),(20799517,2702,'./estquotepricelstupd.php'),(20799516,2532,'./estquotepricelstupd.php'),(20799515,2446,'./estquotepricelstupd.php'),(20799514,2445,'./estquotepricelstupd.php'),(20799513,2420,'./estquotepricelstupd.php'),(20799512,2418,'./estquotepricelstupd.php'),(20799511,2415,'./estquotepricelstupd.php'),(20799510,13450,'./estquotepricelstupd.php'),(20799509,2105,'./estquotepricelstupd.php'),(20799508,1963,'./estquotepricelstupd.php'),(20799507,1935,'./estquotepricelstupd.php'),(20799506,12780,'./estquotepricelstupd.php'),(20799505,12787,'./estquotepricelstupd.php'),(20799504,1851,'./estquotepricelstupd.php'),(20799503,1850,'./estquotepricelstupd.php'),(20799502,1298,'./estquotepricelstupd.php'),(20799501,1189,'./estquotepricelstupd.php'),(20799500,941,'./estquotepricelstupd.php'),(20799499,924,'./estquotepricelstupd.php'),(20799498,844,'./estquotepricelstupd.php'),(20799497,799,'./estquotepricelstupd.php'),(20799496,315,'./estquotepricelstupd.php'),(20799495,5203,'./estquotepricelstupd.php'),(20799494,123,'./estquotepricelstupd.php'),(20799493,59,'./estquotepricelstupd.php'),(20799492,2973,'./estquotepricelststockupd.php'),(20799491,2950,'./estquotepricelststockupd.php'),(20799490,2777,'./estquotepricelststockupd.php'),(20799489,2710,'./estquotepricelststockupd.php'),(20799488,2702,'./estquotepricelststockupd.php'),(20799487,7638,'./estquotepricelststockupd.php'),(20799486,2431,'./estquotepricelststockupd.php'),(20799485,2430,'./estquotepricelststockupd.php'),(20799484,2429,'./estquotepricelststockupd.php'),(20799483,2428,'./estquotepricelststockupd.php'),(20799482,2125,'./estquotepricelststockupd.php'),(20799481,2119,'./estquotepricelststockupd.php'),(20799480,9247,'./estquotepricelststockupd.php'),(20799479,1889,'./estquotepricelststockupd.php'),(20799478,1299,'./estquotepricelststockupd.php'),(20799477,1191,'./estquotepricelststockupd.php'),(20799476,941,'./estquotepricelststockupd.php'),(20799475,845,'./estquotepricelststockupd.php'),(20799474,799,'./estquotepricelststockupd.php'),(20799473,614,'./estquotepricelststockupd.php'),(20799472,542,'./estquotepricelststockupd.php'),(20799471,5203,'./estquotepricelststockupd.php'),(20799470,216,'./estquotepricelststockupd.php'),(20799469,217,'./estquotepricelststockupd.php'),(20799468,124,'./estquotepricelststockupd.php'),(20799467,180,'./estquotepricelststockupd.php'),(20799466,2973,'./estquotepricelststockadd.php'),(20799465,2950,'./estquotepricelststockadd.php'),(20799464,2702,'./estquotepricelststockadd.php'),(20799463,7638,'./estquotepricelststockadd.php'),(20799462,2426,'./estquotepricelststockadd.php'),(20799461,2425,'./estquotepricelststockadd.php'),(20799460,2125,'./estquotepricelststockadd.php'),(20799459,2119,'./estquotepricelststockadd.php'),(20799458,9247,'./estquotepricelststockadd.php'),(20799457,1889,'./estquotepricelststockadd.php'),(20799456,1644,'./estquotepricelststockadd.php'),(20799455,1109,'./estquotepricelststockadd.php'),(20799454,941,'./estquotepricelststockadd.php'),(20799453,905,'./estquotepricelststockadd.php'),(20799452,613,'./estquotepricelststockadd.php'),(20799451,612,'./estquotepricelststockadd.php'),(20799450,542,'./estquotepricelststockadd.php'),(20799449,216,'./estquotepricelststockadd.php'),(20799448,180,'./estquotepricelststockadd.php'),(20799447,13381,'./estquotepricelstprice.php'),(20799446,2710,'./estquotepricelstprice.php'),(20799445,2702,'./estquotepricelstprice.php'),(20799444,2529,'./estquotepricelstprice.php'),(20799443,2448,'./estquotepricelstprice.php'),(20799442,2446,'./estquotepricelstprice.php'),(20799441,2415,'./estquotepricelstprice.php'),(20799440,1342,'./estquotepricelstprice.php'),(20799439,13192,'./estquotepricelstprice.php'),(20799438,2710,'./estquotepricelstcolor.php'),(20799437,2702,'./estquotepricelstcolor.php'),(20799436,2427,'./estquotepricelstcolor.php'),(20799435,2134,'./estquotepricelstcolor.php'),(20799434,1985,'./estquotepricelstcolor.php'),(20799433,550,'./estquotepricelstcolor.php'),(20799432,427,'./estquotepricelstcolor.php'),(20799431,3381,'./estquotepricelstadd.php'),(20799430,3131,'./estquotepricelstadd.php'),(20799429,3132,'./estquotepricelstadd.php'),(20799428,2886,'./estquotepricelstadd.php'),(20799427,2702,'./estquotepricelstadd.php'),(20799426,2532,'./estquotepricelstadd.php'),(20799425,2417,'./estquotepricelstadd.php'),(20799424,2416,'./estquotepricelstadd.php'),(20799423,13450,'./estquotepricelstadd.php'),(20799422,1935,'./estquotepricelstadd.php'),(20799421,1851,'./estquotepricelstadd.php'),(20799420,1850,'./estquotepricelstadd.php'),(20799419,1108,'./estquotepricelstadd.php'),(20799418,3225,'./estquotepieceworkupd.php'),(20799417,5508,'./estquotepieceworkupd.php'),(20799416,2710,'./estquotepieceworkupd.php'),(20799415,2702,'./estquotepieceworkupd.php'),(20799414,6902,'./estquotepieceworkupd.php'),(20799413,3995,'./estquotepieceworkupd.php'),(20799412,1143,'./estquotepieceworkupd.php'),(20799411,941,'./estquotepieceworkupd.php'),(20799410,831,'./estquotepieceworkupd.php'),(20799409,864,'./estquotepieceworkupd.php'),(20799408,799,'./estquotepieceworkupd.php'),(20799407,315,'./estquotepieceworkupd.php'),(20799406,5203,'./estquotepieceworkupd.php'),(20799405,111,'./estquotepieceworkupd.php'),(20799404,59,'./estquotepieceworkupd.php'),(20799403,2702,'./estquotepieceworkadd.php'),(20799402,6927,'./estquotepieceworkadd.php'),(20799401,6902,'./estquotepieceworkadd.php'),(20799400,3994,'./estquotepieceworkadd.php'),(20799399,315,'./estquotepieceworkadd.php'),(20799398,176,'./estquotepieceworkadd.php'),(20799397,59,'./estquotepieceworkadd.php'),(20799396,3427,'./estquotepackingslip.php'),(20799395,5569,'./estquotepackingslip.php'),(20799394,5582,'./estquotepackingslip.php'),(20799393,4569,'./estquotepackingslip.php'),(20799392,4568,'./estquotepackingslip.php'),(20799391,4567,'./estquotepackingslip.php'),(20799390,2529,'./estquotepackingslip.php'),(20799389,4566,'./estquotepackingslip.php'),(20799388,5584,'./estquotepackingslip.php'),(20799387,4565,'./estquotepackingslip.php'),(20799386,4564,'./estquotepackingslip.php'),(20799385,1963,'./estquotepackingslip.php'),(20799384,4720,'./estquotepackingslip.php'),(20799383,1467,'./estquotepackingslip.php'),(20799382,3914,'./estquotepackingslip.php'),(20799381,5282,'./estquotepackingslip.php'),(20799380,4562,'./estquotepackingslip.php'),(20799379,5093,'./estquotepackingslip.php'),(20799378,869,'./estquotepackingslip.php'),(20799377,737,'./estquotepackingslip.php'),(20799376,542,'./estquotepackingslip.php'),(20799375,4560,'./estquotepackingslip.php'),(20799374,387,'./estquotepackingslip.php'),(20677660,3421,'./estquoteorderwho.php'),(20677659,8733,'./estquoteorderwho.php'),(20677658,3252,'./estquoteorderwho.php'),(20677657,8331,'./estquoteorderwho.php'),(20677656,3101,'./estquoteorderwho.php'),(20677655,2508,'./estquoteorderwho.php'),(20677654,2361,'./estquoteorderwho.php'),(20677653,12940,'./estquoteorderwho.php'),(20677652,12939,'./estquoteorderwho.php'),(20677651,2165,'./estquoteorderwho.php'),(20677650,2024,'./estquoteorderwho.php'),(20677649,1963,'./estquoteorderwho.php'),(20677648,12938,'./estquoteorderwho.php'),(20677647,1456,'./estquoteorderwho.php'),(20677646,1036,'./estquoteorderwho.php'),(20677645,5080,'./estquoteorderwho.php'),(20677644,869,'./estquoteorderwho.php'),(20677643,4363,'./estquoteorderwho.php'),(20677642,697,'./estquoteorderwho.php'),(20677641,11863,'./estquoteorderwho.php'),(20677640,5078,'./estquoteorderwho.php'),(20677639,5076,'./estquoteorderwho.php'),(20799373,8733,'./estquoteordersearch.php'),(20799372,6161,'./estquoteordersearch.php'),(20799371,8331,'./estquoteordersearch.php'),(20799370,2959,'./estquoteordersearch.php'),(20799369,2886,'./estquoteordersearch.php'),(20799368,4455,'./estquoteordersearch.php'),(20799367,2819,'./estquoteordersearch.php'),(20799366,2816,'./estquoteordersearch.php'),(20799365,6926,'./estquoteordersearch.php'),(20799364,6925,'./estquoteordersearch.php'),(20799363,6921,'./estquoteordersearch.php'),(20799362,6924,'./estquoteordersearch.php'),(20799361,2615,'./estquoteordersearch.php'),(20799360,5084,'./estquoteordersearch.php'),(20799359,2540,'./estquoteordersearch.php'),(20799358,2508,'./estquoteordersearch.php'),(20799357,2480,'./estquoteordersearch.php'),(20799356,2363,'./estquoteordersearch.php'),(20799355,2361,'./estquoteordersearch.php'),(20799354,6920,'./estquoteordersearch.php'),(20799353,2165,'./estquoteordersearch.php'),(20799352,8319,'./estquoteordersearch.php'),(20799351,5083,'./estquoteordersearch.php'),(20799350,1963,'./estquoteordersearch.php'),(20799349,5082,'./estquoteordersearch.php'),(20799348,5081,'./estquoteordersearch.php'),(20799347,4414,'./estquoteordersearch.php'),(20799346,1592,'./estquoteordersearch.php'),(20799345,1534,'./estquoteordersearch.php'),(20799344,1456,'./estquoteordersearch.php'),(20799343,3995,'./estquoteordersearch.php'),(20799342,1036,'./estquoteordersearch.php'),(20799341,5080,'./estquoteordersearch.php'),(20799340,5079,'./estquoteordersearch.php'),(20799339,6923,'./estquoteordersearch.php'),(20799338,941,'./estquoteordersearch.php'),(20799337,7685,'./estquoteordersearch.php'),(20799336,869,'./estquoteordersearch.php'),(20799335,6918,'./estquoteordersearch.php'),(20799334,799,'./estquoteordersearch.php'),(20799333,4363,'./estquoteordersearch.php'),(20799332,7690,'./estquoteordersearch.php'),(20799331,4481,'./estquoteordersearch.php'),(20799330,697,'./estquoteordersearch.php'),(20799329,695,'./estquoteordersearch.php'),(20799328,6922,'./estquoteordersearch.php'),(20799327,610,'./estquoteordersearch.php'),(20799326,606,'./estquoteordersearch.php'),(20799325,11863,'./estquoteordersearch.php'),(20799324,540,'./estquoteordersearch.php'),(20799323,5078,'./estquoteordersearch.php'),(20799322,5076,'./estquoteordersearch.php'),(20799321,5075,'./estquoteordersearch.php'),(20799320,5203,'./estquoteordersearch.php'),(20799319,4613,'./estquoteordernotapproved.php'),(20799318,13583,'./estquoteordernotapproved.php'),(20799317,6921,'./estquoteordernotapproved.php'),(20799316,2702,'./estquoteordernotapproved.php'),(20799315,2508,'./estquoteordernotapproved.php'),(20799314,2480,'./estquoteordernotapproved.php'),(20799313,2471,'./estquoteordernotapproved.php'),(20799312,2361,'./estquoteordernotapproved.php'),(20799311,13579,'./estquoteordernotapproved.php'),(20799310,6920,'./estquoteordernotapproved.php'),(20799309,4609,'./estquoteordernotapproved.php'),(20799308,2165,'./estquoteordernotapproved.php'),(20799307,4606,'./estquoteordernotapproved.php'),(20799306,4222,'./estquoteordernotapproved.php'),(20799305,7689,'./estquoteordernotapproved.php'),(20799304,7688,'./estquoteordernotapproved.php'),(20799303,4605,'./estquoteordernotapproved.php'),(20799302,1456,'./estquoteordernotapproved.php'),(20799301,3914,'./estquoteordernotapproved.php'),(20799300,6919,'./estquoteordernotapproved.php'),(20799299,3995,'./estquoteordernotapproved.php'),(20799298,5060,'./estquoteordernotapproved.php'),(20799297,941,'./estquoteordernotapproved.php'),(20799296,869,'./estquoteordernotapproved.php'),(20799295,6918,'./estquoteordernotapproved.php'),(20799294,4416,'./estquoteordernotapproved.php'),(20799293,697,'./estquoteordernotapproved.php'),(20799292,13573,'./estquoteordernotapproved.php'),(20799291,5203,'./estquoteordernotapproved.php'),(20799290,59,'./estquoteordernotapproved.php'),(20799289,13850,'./estquoteorderapproved_detail.php'),(20799288,2702,'./estquoteorderapproved_detail.php'),(20799287,2529,'./estquoteorderapproved_detail.php'),(20799286,3762,'./estquoteorderapproved_detail.php'),(20799285,1696,'./estquoteorderapproved_detail.php'),(20799284,13849,'./estquoteorderapproved_detail.php'),(20799283,799,'./estquoteorderapproved_detail.php'),(20799282,2702,'./estquoteorderapproved.php'),(20799281,13848,'./estquoteorderapproved.php'),(20799280,2508,'./estquoteorderapproved.php'),(20799279,2361,'./estquoteorderapproved.php'),(20799278,2165,'./estquoteorderapproved.php'),(20799277,1934,'./estquoteorderapproved.php'),(20799276,3914,'./estquoteorderapproved.php'),(20799275,6919,'./estquoteorderapproved.php'),(20799274,3995,'./estquoteorderapproved.php'),(20799273,13847,'./estquoteorderapproved.php'),(20799272,869,'./estquoteorderapproved.php'),(20799271,697,'./estquoteorderapproved.php'),(20799270,13678,'./estquoteorderapproved.php'),(20799269,13846,'./estquoteorderapproved.php'),(20799268,4613,'./estquoteopenorder.php'),(20799267,2948,'./estquoteopenorder.php'),(20799266,2813,'./estquoteopenorder.php'),(20799265,6921,'./estquoteopenorder.php'),(20799264,13845,'./estquoteopenorder.php'),(20799263,2540,'./estquoteopenorder.php'),(20799262,2508,'./estquoteopenorder.php'),(20799261,2480,'./estquoteopenorder.php'),(20799260,2471,'./estquoteopenorder.php'),(20799259,2459,'./estquoteopenorder.php'),(20799258,2404,'./estquoteopenorder.php'),(20799257,2361,'./estquoteopenorder.php'),(20799256,4874,'./estquoteopenorder.php'),(20799255,6920,'./estquoteopenorder.php'),(20799254,4609,'./estquoteopenorder.php'),(20799253,2165,'./estquoteopenorder.php'),(20799252,13844,'./estquoteopenorder.php'),(20799251,1963,'./estquoteopenorder.php'),(20799250,4606,'./estquoteopenorder.php'),(20799249,4222,'./estquoteopenorder.php'),(20799248,7689,'./estquoteopenorder.php'),(20799247,7688,'./estquoteopenorder.php'),(20799246,4605,'./estquoteopenorder.php'),(20799245,1456,'./estquoteopenorder.php'),(20799244,3914,'./estquoteopenorder.php'),(20799243,6919,'./estquoteopenorder.php'),(20799242,3995,'./estquoteopenorder.php'),(20799241,5060,'./estquoteopenorder.php'),(20799240,941,'./estquoteopenorder.php'),(20799239,869,'./estquoteopenorder.php'),(20799238,6918,'./estquoteopenorder.php'),(20799237,4416,'./estquoteopenorder.php'),(20799236,697,'./estquoteopenorder.php'),(20799235,13843,'./estquoteopenorder.php'),(20799234,5203,'./estquoteopenorder.php'),(20799233,59,'./estquoteopenorder.php'),(20799232,6917,'./estquotenumperbox.php'),(20799231,1963,'./estquotenumperbox.php'),(20799230,3995,'./estquotenumperbox.php'),(20799229,6916,'./estquotenumperbox.php'),(20799228,5259,'./estquotelists_unconfirmed.php'),(20799227,5111,'./estquotelists_unconfirmed.php'),(20799226,5258,'./estquotelists_unconfirmed.php'),(20799225,7687,'./estquotelists_unconfirmed.php'),(20799224,12047,'./estquotelists_unconfirmed.php'),(20799223,7686,'./estquotelists_unconfirmed.php'),(20799222,4414,'./estquotelists_unconfirmed.php'),(20799221,1534,'./estquotelists_unconfirmed.php'),(20799220,1467,'./estquotelists_unconfirmed.php'),(20799219,932,'./estquotelists_unconfirmed.php'),(20799218,7685,'./estquotelists_unconfirmed.php'),(20799217,740,'./estquotelists_unconfirmed.php'),(20799216,697,'./estquotelists_unconfirmed.php'),(20799215,4690,'./estquotelists_unconfirmed.php'),(20799214,12046,'./estquotelists_unconfirmed.php'),(20799213,416,'./estquotelists_unconfirmed.php'),(20799212,5059,'./estquotelateorder.php'),(20799211,2656,'./estquotelateorder.php'),(20799210,2508,'./estquotelateorder.php'),(20799209,3722,'./estquotelateorder.php'),(20799208,2165,'./estquotelateorder.php'),(20799207,2103,'./estquotelateorder.php'),(20799206,1963,'./estquotelateorder.php'),(20799205,869,'./estquotelateorder.php'),(20799204,4416,'./estquotelateorder.php'),(20799203,4363,'./estquotelateorder.php'),(20799202,737,'./estquotelateorder.php'),(20799201,697,'./estquotelateorder.php'),(20799200,3427,'./estquotejobticket_ow_fpdf.php'),(20799199,5569,'./estquotejobticket_ow_fpdf.php'),(20799198,5588,'./estquotejobticket_ow_fpdf.php'),(20799197,3380,'./estquotejobticket_ow_fpdf.php'),(20799196,3355,'./estquotejobticket_ow_fpdf.php'),(20799195,4126,'./estquotejobticket_ow_fpdf.php'),(20799194,3151,'./estquotejobticket_ow_fpdf.php'),(20799193,6894,'./estquotejobticket_ow_fpdf.php'),(20799192,6893,'./estquotejobticket_ow_fpdf.php'),(20799191,2950,'./estquotejobticket_ow_fpdf.php'),(20799190,2886,'./estquotejobticket_ow_fpdf.php'),(20799189,5164,'./estquotejobticket_ow_fpdf.php'),(20799188,2816,'./estquotejobticket_ow_fpdf.php'),(20799187,6892,'./estquotejobticket_ow_fpdf.php'),(20799186,5687,'./estquotejobticket_ow_fpdf.php'),(20799185,5686,'./estquotejobticket_ow_fpdf.php'),(20799184,12851,'./estquotejobticket_ow_fpdf.php'),(20799183,13922,'./estquotejobticket_ow_fpdf.php'),(20799182,2529,'./estquotejobticket_ow_fpdf.php'),(20799181,2508,'./estquotejobticket_ow_fpdf.php'),(20799180,13581,'./estquotejobticket_ow_fpdf.php'),(20799179,13580,'./estquotejobticket_ow_fpdf.php'),(20799178,13919,'./estquotejobticket_ow_fpdf.php'),(20799177,6889,'./estquotejobticket_ow_fpdf.php'),(20799176,2324,'./estquotejobticket_ow_fpdf.php'),(20799175,13238,'./estquotejobticket_ow_fpdf.php'),(20799174,13237,'./estquotejobticket_ow_fpdf.php'),(20799173,13442,'./estquotejobticket_ow_fpdf.php'),(20799172,13449,'./estquotejobticket_ow_fpdf.php'),(20799171,6887,'./estquotejobticket_ow_fpdf.php'),(20799170,2165,'./estquotejobticket_ow_fpdf.php'),(20799169,13236,'./estquotejobticket_ow_fpdf.php'),(20799168,13235,'./estquotejobticket_ow_fpdf.php'),(20799167,8368,'./estquotejobticket_ow_fpdf.php'),(20799166,2099,'./estquotejobticket_ow_fpdf.php'),(20799165,1963,'./estquotejobticket_ow_fpdf.php'),(20799164,5685,'./estquotejobticket_ow_fpdf.php'),(20799163,5081,'./estquotejobticket_ow_fpdf.php'),(20799162,13234,'./estquotejobticket_ow_fpdf.php'),(20799161,13441,'./estquotejobticket_ow_fpdf.php'),(20799160,1610,'./estquotejobticket_ow_fpdf.php'),(20799159,13440,'./estquotejobticket_ow_fpdf.php'),(20799158,1592,'./estquotejobticket_ow_fpdf.php'),(20799157,11873,'./estquotejobticket_ow_fpdf.php'),(20799156,11872,'./estquotejobticket_ow_fpdf.php'),(20799155,1456,'./estquotejobticket_ow_fpdf.php'),(20799154,1373,'./estquotejobticket_ow_fpdf.php'),(20799153,13413,'./estquotejobticket_ow_fpdf.php'),(20799152,13921,'./estquotejobticket_ow_fpdf.php'),(20799151,13920,'./estquotejobticket_ow_fpdf.php'),(20799150,5684,'./estquotejobticket_ow_fpdf.php'),(20799149,982,'./estquotejobticket_ow_fpdf.php'),(20799148,981,'./estquotejobticket_ow_fpdf.php'),(20799147,938,'./estquotejobticket_ow_fpdf.php'),(20799146,13373,'./estquotejobticket_ow_fpdf.php'),(20799145,4602,'./estquotejobticket_ow_fpdf.php'),(20799144,13448,'./estquotejobticket_ow_fpdf.php'),(20799143,869,'./estquotejobticket_ow_fpdf.php'),(20799142,13437,'./estquotejobticket_ow_fpdf.php'),(20799141,719,'./estquotejobticket_ow_fpdf.php'),(20799140,717,'./estquotejobticket_ow_fpdf.php'),(20799139,716,'./estquotejobticket_ow_fpdf.php'),(20799138,13447,'./estquotejobticket_ow_fpdf.php'),(20799137,13436,'./estquotejobticket_ow_fpdf.php'),(20799136,542,'./estquotejobticket_ow_fpdf.php'),(20799135,5536,'./estquotejobticket_ow_fpdf.php'),(20799134,540,'./estquotejobticket_ow_fpdf.php'),(20799133,13446,'./estquotejobticket_ow_fpdf.php'),(20799132,306,'./estquotejobticket_ow_fpdf.php'),(20799131,8873,'./estquotejobticket_ow_fpdf.php'),(20799130,13571,'./estquotejobticket_ow_fpdf.php'),(20799129,191,'./estquotejobticket_ow_fpdf.php'),(20799128,13372,'./estquotejobticket_ow_fpdf.php'),(20799127,3427,'./estquotejobticket_ow2_fpdf.php'),(20799126,5569,'./estquotejobticket_ow2_fpdf.php'),(20799125,5588,'./estquotejobticket_ow2_fpdf.php'),(20799124,3355,'./estquotejobticket_ow2_fpdf.php'),(20799123,4126,'./estquotejobticket_ow2_fpdf.php'),(20799122,6894,'./estquotejobticket_ow2_fpdf.php'),(20799121,6893,'./estquotejobticket_ow2_fpdf.php'),(20799120,2950,'./estquotejobticket_ow2_fpdf.php'),(20799119,2886,'./estquotejobticket_ow2_fpdf.php'),(20799118,5164,'./estquotejobticket_ow2_fpdf.php'),(20799117,2816,'./estquotejobticket_ow2_fpdf.php'),(20799116,6892,'./estquotejobticket_ow2_fpdf.php'),(20799115,5687,'./estquotejobticket_ow2_fpdf.php'),(20799114,5686,'./estquotejobticket_ow2_fpdf.php'),(20799113,12851,'./estquotejobticket_ow2_fpdf.php'),(20799112,2508,'./estquotejobticket_ow2_fpdf.php'),(20799111,2324,'./estquotejobticket_ow2_fpdf.php'),(20799110,13449,'./estquotejobticket_ow2_fpdf.php'),(20799109,6887,'./estquotejobticket_ow2_fpdf.php'),(20799108,2165,'./estquotejobticket_ow2_fpdf.php'),(20799107,1963,'./estquotejobticket_ow2_fpdf.php'),(20799106,5685,'./estquotejobticket_ow2_fpdf.php'),(20799105,5081,'./estquotejobticket_ow2_fpdf.php'),(20799104,1610,'./estquotejobticket_ow2_fpdf.php'),(20799103,11873,'./estquotejobticket_ow2_fpdf.php'),(20799102,11872,'./estquotejobticket_ow2_fpdf.php'),(20799101,1456,'./estquotejobticket_ow2_fpdf.php'),(20799100,1373,'./estquotejobticket_ow2_fpdf.php'),(20799099,13921,'./estquotejobticket_ow2_fpdf.php'),(20799098,5684,'./estquotejobticket_ow2_fpdf.php'),(20799097,982,'./estquotejobticket_ow2_fpdf.php'),(20799096,981,'./estquotejobticket_ow2_fpdf.php'),(20799095,13448,'./estquotejobticket_ow2_fpdf.php'),(20799094,869,'./estquotejobticket_ow2_fpdf.php'),(20799093,719,'./estquotejobticket_ow2_fpdf.php'),(20799092,717,'./estquotejobticket_ow2_fpdf.php'),(20799091,716,'./estquotejobticket_ow2_fpdf.php'),(20799090,542,'./estquotejobticket_ow2_fpdf.php'),(20799089,5536,'./estquotejobticket_ow2_fpdf.php'),(20799088,540,'./estquotejobticket_ow2_fpdf.php'),(20799087,306,'./estquotejobticket_ow2_fpdf.php'),(20799086,8873,'./estquotejobticket_ow2_fpdf.php'),(20799085,191,'./estquotejobticket_ow2_fpdf.php'),(20677349,6536,'./estquotejobticket_ow.php'),(20677348,3928,'./estquotejobticket_ow.php'),(20677347,3909,'./estquotejobticket_ow.php'),(20677346,3910,'./estquotejobticket_ow.php'),(20677345,4126,'./estquotejobticket_ow.php'),(20677344,3090,'./estquotejobticket_ow.php'),(20677343,4176,'./estquotejobticket_ow.php'),(20677342,3913,'./estquotejobticket_ow.php'),(20677341,12731,'./estquotejobticket_ow.php'),(20677340,2879,'./estquotejobticket_ow.php'),(20677339,2878,'./estquotejobticket_ow.php'),(20677338,2819,'./estquotejobticket_ow.php'),(20677337,2833,'./estquotejobticket_ow.php'),(20677336,2813,'./estquotejobticket_ow.php'),(20677335,3922,'./estquotejobticket_ow.php'),(20677334,6535,'./estquotejobticket_ow.php'),(20677333,2661,'./estquotejobticket_ow.php'),(20677332,3926,'./estquotejobticket_ow.php'),(20677331,2529,'./estquotejobticket_ow.php'),(20677330,2508,'./estquotejobticket_ow.php'),(20677329,7643,'./estquotejobticket_ow.php'),(20677328,2459,'./estquotejobticket_ow.php'),(20677327,4923,'./estquotejobticket_ow.php'),(20677326,3921,'./estquotejobticket_ow.php'),(20677325,2363,'./estquotejobticket_ow.php'),(20677324,6534,'./estquotejobticket_ow.php'),(20677323,3924,'./estquotejobticket_ow.php'),(20677322,7637,'./estquotejobticket_ow.php'),(20677321,3927,'./estquotejobticket_ow.php'),(20677320,3931,'./estquotejobticket_ow.php'),(20677319,6887,'./estquotejobticket_ow.php'),(20677318,5235,'./estquotejobticket_ow.php'),(20677317,7684,'./estquotejobticket_ow.php'),(20677316,6533,'./estquotejobticket_ow.php'),(20677315,3912,'./estquotejobticket_ow.php'),(20677314,3917,'./estquotejobticket_ow.php'),(20677313,1610,'./estquotejobticket_ow.php'),(20677312,1592,'./estquotejobticket_ow.php'),(20677311,6532,'./estquotejobticket_ow.php'),(20677310,1463,'./estquotejobticket_ow.php'),(20677309,1456,'./estquotejobticket_ow.php'),(20677308,3914,'./estquotejobticket_ow.php'),(20677307,1425,'./estquotejobticket_ow.php'),(20677306,6531,'./estquotejobticket_ow.php'),(20677305,6530,'./estquotejobticket_ow.php'),(20677304,3930,'./estquotejobticket_ow.php'),(20677303,715,'./estquotejobticket_ow.php'),(20677302,3929,'./estquotejobticket_ow.php'),(20677301,5583,'./estquotejobticket_ow.php'),(20677300,3916,'./estquotejobticket_ow.php'),(20677299,4199,'./estquotejobticket_ow.php'),(20677298,3932,'./estquotejobticket_ow.php'),(20677297,306,'./estquotejobticket_ow.php'),(20677296,6529,'./estquotejobticket_ow.php'),(20677295,3915,'./estquotejobticket_ow.php'),(20799084,6536,'./estquotejobticket.php'),(20799083,3928,'./estquotejobticket.php'),(20799082,3909,'./estquotejobticket.php'),(20799081,3910,'./estquotejobticket.php'),(20799080,4126,'./estquotejobticket.php'),(20799079,3090,'./estquotejobticket.php'),(20799078,4176,'./estquotejobticket.php'),(20799077,3913,'./estquotejobticket.php'),(20799076,12731,'./estquotejobticket.php'),(20799075,2879,'./estquotejobticket.php'),(20799074,2878,'./estquotejobticket.php'),(20799073,2819,'./estquotejobticket.php'),(20799072,2833,'./estquotejobticket.php'),(20799071,2813,'./estquotejobticket.php'),(20799070,3922,'./estquotejobticket.php'),(20799069,6535,'./estquotejobticket.php'),(20799068,2661,'./estquotejobticket.php'),(20799067,13662,'./estquotejobticket.php'),(20799066,3926,'./estquotejobticket.php'),(20799065,2529,'./estquotejobticket.php'),(20799064,2508,'./estquotejobticket.php'),(20799063,7643,'./estquotejobticket.php'),(20799062,2459,'./estquotejobticket.php'),(20799061,4923,'./estquotejobticket.php'),(20799060,3921,'./estquotejobticket.php'),(20799059,2363,'./estquotejobticket.php'),(20799058,6534,'./estquotejobticket.php'),(20799057,3924,'./estquotejobticket.php'),(20799056,7637,'./estquotejobticket.php'),(20799055,3927,'./estquotejobticket.php'),(20799054,3931,'./estquotejobticket.php'),(20799053,6887,'./estquotejobticket.php'),(20799052,5235,'./estquotejobticket.php'),(20799051,7684,'./estquotejobticket.php'),(20799050,6533,'./estquotejobticket.php'),(20799049,3912,'./estquotejobticket.php'),(20799048,3917,'./estquotejobticket.php'),(20799047,1610,'./estquotejobticket.php'),(20799046,1592,'./estquotejobticket.php'),(20799045,6532,'./estquotejobticket.php'),(20799044,1463,'./estquotejobticket.php'),(20799043,1456,'./estquotejobticket.php'),(20799042,3914,'./estquotejobticket.php'),(20799041,1425,'./estquotejobticket.php'),(20799040,6531,'./estquotejobticket.php'),(20799039,886,'./estquotejobticket.php'),(20799038,6530,'./estquotejobticket.php'),(20799037,3930,'./estquotejobticket.php'),(20799036,715,'./estquotejobticket.php'),(20799035,3929,'./estquotejobticket.php'),(20799034,5536,'./estquotejobticket.php'),(20799033,5583,'./estquotejobticket.php'),(20799032,3916,'./estquotejobticket.php'),(20799031,4199,'./estquotejobticket.php'),(20799030,3932,'./estquotejobticket.php'),(20799029,306,'./estquotejobticket.php'),(20799028,6529,'./estquotejobticket.php'),(20799027,3915,'./estquotejobticket.php'),(20799026,13677,'./estquotejobticket.php'),(20799025,6915,'./estquotefromaddress.php'),(20799024,2702,'./estquotefromaddress.php'),(20799023,6877,'./estquotefromaddress.php'),(20799022,6914,'./estquotefromaddress.php'),(20799021,6913,'./estquotefromaddress.php'),(20799020,6912,'./estquotefromaddress.php'),(20799019,6911,'./estquotefromaddress.php'),(20799018,6910,'./estquotefromaddress.php'),(20799017,6909,'./estquotefromaddress.php'),(20799016,6908,'./estquotefromaddress.php'),(20799015,542,'./estquotefromaddress.php'),(20799014,6907,'./estquotefromaddress.php'),(20799013,4613,'./estquoteenvimp.php'),(20799012,2948,'./estquoteenvimp.php'),(20799011,14672,'./estquoteenvimp.php'),(20799010,6921,'./estquoteenvimp.php'),(20799009,13845,'./estquoteenvimp.php'),(20799008,2540,'./estquoteenvimp.php'),(20799007,2508,'./estquoteenvimp.php'),(20799006,2480,'./estquoteenvimp.php'),(20799005,2471,'./estquoteenvimp.php'),(20799004,2459,'./estquoteenvimp.php'),(20799003,2404,'./estquoteenvimp.php'),(20799002,2361,'./estquoteenvimp.php'),(20799001,4874,'./estquoteenvimp.php'),(20799000,14676,'./estquoteenvimp.php'),(20798999,13449,'./estquoteenvimp.php'),(20798998,6920,'./estquoteenvimp.php'),(20798997,4609,'./estquoteenvimp.php'),(20798996,2165,'./estquoteenvimp.php'),(20798995,14671,'./estquoteenvimp.php'),(20798994,13844,'./estquoteenvimp.php'),(20798993,1963,'./estquoteenvimp.php'),(20798992,4606,'./estquoteenvimp.php'),(20798991,4222,'./estquoteenvimp.php'),(20798990,7689,'./estquoteenvimp.php'),(20798989,7688,'./estquoteenvimp.php'),(20798988,4605,'./estquoteenvimp.php'),(20798987,1456,'./estquoteenvimp.php'),(20798986,3914,'./estquoteenvimp.php'),(20798985,6919,'./estquoteenvimp.php'),(20798984,3995,'./estquoteenvimp.php'),(20798983,5060,'./estquoteenvimp.php'),(20798982,941,'./estquoteenvimp.php'),(20798981,869,'./estquoteenvimp.php'),(20798980,6918,'./estquoteenvimp.php'),(20798979,4416,'./estquoteenvimp.php'),(20798978,697,'./estquoteenvimp.php'),(20798977,13843,'./estquoteenvimp.php'),(20798976,5203,'./estquoteenvimp.php'),(20798975,14668,'./estquoteenvimp.php'),(20798974,59,'./estquoteenvimp.php'),(20798973,2959,'./estquoteeditsearch.php'),(20798972,2950,'./estquoteeditsearch.php'),(20798971,2886,'./estquoteeditsearch.php'),(20798970,2747,'./estquoteeditsearch.php'),(20798969,7219,'./estquoteeditsearch.php'),(20798968,2540,'./estquoteeditsearch.php'),(20798967,2480,'./estquoteeditsearch.php'),(20798966,2459,'./estquoteeditsearch.php'),(20798965,12045,'./estquoteeditsearch.php'),(20798964,1036,'./estquoteeditsearch.php'),(20798963,6461,'./estquoteeditsearch.php'),(20798962,869,'./estquoteeditsearch.php'),(20798961,799,'./estquoteeditsearch.php'),(20798960,4481,'./estquoteeditsearch.php'),(20798959,697,'./estquoteeditsearch.php'),(20798958,695,'./estquoteeditsearch.php'),(20798957,606,'./estquoteeditsearch.php'),(20798956,6460,'./estquoteeditsearch.php'),(20798955,315,'./estquoteeditsearch.php'),(20798954,5203,'./estquoteeditsearch.php'),(20798953,1963,'./estquoteduedate.php'),(20798952,4471,'./estquoteduedate.php'),(20798951,3995,'./estquoteduedate.php'),(20798950,4465,'./estquoteduedate.php'),(20798949,4613,'./estquotecsrpending.php'),(20798948,2948,'./estquotecsrpending.php'),(20798947,14672,'./estquotecsrpending.php'),(20798946,6921,'./estquotecsrpending.php'),(20798945,13845,'./estquotecsrpending.php'),(20798944,2540,'./estquotecsrpending.php'),(20798943,2508,'./estquotecsrpending.php'),(20798942,2480,'./estquotecsrpending.php'),(20798941,2471,'./estquotecsrpending.php'),(20798940,2459,'./estquotecsrpending.php'),(20798939,2404,'./estquotecsrpending.php'),(20798938,2361,'./estquotecsrpending.php'),(20798937,4874,'./estquotecsrpending.php'),(20798936,14675,'./estquotecsrpending.php'),(20798935,13449,'./estquotecsrpending.php'),(20798934,6920,'./estquotecsrpending.php'),(20798933,4609,'./estquotecsrpending.php'),(20798932,2165,'./estquotecsrpending.php'),(20798931,14671,'./estquotecsrpending.php'),(20798930,13844,'./estquotecsrpending.php'),(20798929,1963,'./estquotecsrpending.php'),(20798928,4606,'./estquotecsrpending.php'),(20798927,4222,'./estquotecsrpending.php'),(20798926,7689,'./estquotecsrpending.php'),(20798925,7688,'./estquotecsrpending.php'),(20798924,4605,'./estquotecsrpending.php'),(20798923,1456,'./estquotecsrpending.php'),(20798922,3914,'./estquotecsrpending.php'),(20798921,6919,'./estquotecsrpending.php'),(20798920,3995,'./estquotecsrpending.php'),(20798919,5060,'./estquotecsrpending.php'),(20798918,941,'./estquotecsrpending.php'),(20798917,869,'./estquotecsrpending.php'),(20798916,6918,'./estquotecsrpending.php'),(20798915,4416,'./estquotecsrpending.php'),(20798914,697,'./estquotecsrpending.php'),(20798913,13843,'./estquotecsrpending.php'),(20798912,5203,'./estquotecsrpending.php'),(20798911,14668,'./estquotecsrpending.php'),(20798910,59,'./estquotecsrpending.php'),(20798909,2710,'./estquotecouponupd.php'),(20798908,2702,'./estquotecouponupd.php'),(20798907,13673,'./estquotecouponupd.php'),(20798906,11662,'./estquotecouponupd.php'),(20798905,966,'./estquotecouponupd.php'),(20798904,941,'./estquotecouponupd.php'),(20798903,898,'./estquotecouponupd.php'),(20798902,13676,'./estquotecouponupd.php'),(20798901,890,'./estquotecouponupd.php'),(20798900,13672,'./estquotecouponupd.php'),(20798899,808,'./estquotecouponupd.php'),(20798898,799,'./estquotecouponupd.php'),(20798897,13671,'./estquotecouponupd.php'),(20798896,13675,'./estquotecouponupd.php'),(20798895,315,'./estquotecouponupd.php'),(20798894,5203,'./estquotecouponupd.php'),(20798893,13670,'./estquotecouponupd.php'),(20798892,87,'./estquotecouponupd.php'),(20798891,59,'./estquotecouponupd.php'),(20798890,2710,'./estquotecouponadd.php'),(20798889,2702,'./estquotecouponadd.php'),(20798888,13674,'./estquotecouponadd.php'),(20798887,13673,'./estquotecouponadd.php'),(20798886,11662,'./estquotecouponadd.php'),(20798885,3994,'./estquotecouponadd.php'),(20798884,898,'./estquotecouponadd.php'),(20798883,890,'./estquotecouponadd.php'),(20798882,13672,'./estquotecouponadd.php'),(20798881,13671,'./estquotecouponadd.php'),(20798880,542,'./estquotecouponadd.php'),(20798879,315,'./estquotecouponadd.php'),(20798878,222,'./estquotecouponadd.php'),(20798877,13670,'./estquotecouponadd.php'),(20798876,176,'./estquotecouponadd.php'),(20798875,3247,'./estquotecomplstupd.php'),(20798874,3938,'./estquotecomplstupd.php'),(20798873,3225,'./estquotecomplstupd.php'),(20798872,2710,'./estquotecomplstupd.php'),(20798871,2094,'./estquotecomplstupd.php'),(20798870,3995,'./estquotecomplstupd.php'),(20798869,1143,'./estquotecomplstupd.php'),(20798868,3994,'./estquotecomplstupd.php'),(20798867,941,'./estquotecomplstupd.php'),(20798866,864,'./estquotecomplstupd.php'),(20798865,799,'./estquotecomplstupd.php'),(20798864,3937,'./estquotecomplstupd.php'),(20798863,3934,'./estquotecomplstupd.php'),(20798862,3936,'./estquotecomplstupd.php'),(20798861,5203,'./estquotecomplstupd.php'),(20798860,3935,'./estquotecomplstupd.php'),(20798859,3422,'./estquotecomplstaddlupd.php'),(20798858,3268,'./estquotecomplstaddlupd.php'),(20798857,3225,'./estquotecomplstaddlupd.php'),(20798856,3148,'./estquotecomplstaddlupd.php'),(20798855,3084,'./estquotecomplstaddlupd.php'),(20798854,1,'./estquotecomplstaddlupd.php'),(20798853,2904,'./estquotecomplstaddlupd.php'),(20798852,6906,'./estquotecomplstaddlupd.php'),(20798851,6905,'./estquotecomplstaddlupd.php'),(20798850,6904,'./estquotecomplstaddlupd.php'),(20798849,6903,'./estquotecomplstaddlupd.php'),(20798848,2785,'./estquotecomplstaddlupd.php'),(20798847,2784,'./estquotecomplstaddlupd.php'),(20798846,2710,'./estquotecomplstaddlupd.php'),(20798845,2702,'./estquotecomplstaddlupd.php'),(20798844,2519,'./estquotecomplstaddlupd.php'),(20798843,9635,'./estquotecomplstaddlupd.php'),(20798842,2109,'./estquotecomplstaddlupd.php'),(20798841,2094,'./estquotecomplstaddlupd.php'),(20798840,13375,'./estquotecomplstaddlupd.php'),(20798839,13168,'./estquotecomplstaddlupd.php'),(20798838,3995,'./estquotecomplstaddlupd.php'),(20798837,1143,'./estquotecomplstaddlupd.php'),(20798836,966,'./estquotecomplstaddlupd.php'),(20798835,941,'./estquotecomplstaddlupd.php'),(20798834,903,'./estquotecomplstaddlupd.php'),(20798833,864,'./estquotecomplstaddlupd.php'),(20798832,799,'./estquotecomplstaddlupd.php'),(20798831,737,'./estquotecomplstaddlupd.php'),(20798830,3937,'./estquotecomplstaddlupd.php'),(20798829,3939,'./estquotecomplstaddlupd.php'),(20798828,3940,'./estquotecomplstaddlupd.php'),(20798827,542,'./estquotecomplstaddlupd.php'),(20798826,5203,'./estquotecomplstaddlupd.php'),(20798825,3943,'./estquotecomplstaddlupd.php'),(20798824,3942,'./estquotecomplstaddlupd.php'),(20798823,182,'./estquotecomplstaddlupd.php'),(20798822,59,'./estquotecomplstaddlupd.php'),(20798821,3260,'./estquotecomplstaddlsizeupd.php'),(20798820,3225,'./estquotecomplstaddlsizeupd.php'),(20798819,2806,'./estquotecomplstaddlsizeupd.php'),(20798818,2805,'./estquotecomplstaddlsizeupd.php'),(20798817,2710,'./estquotecomplstaddlsizeupd.php'),(20798816,2702,'./estquotecomplstaddlsizeupd.php'),(20798815,2159,'./estquotecomplstaddlsizeupd.php'),(20798814,1976,'./estquotecomplstaddlsizeupd.php'),(20798813,1896,'./estquotecomplstaddlsizeupd.php'),(20798812,1895,'./estquotecomplstaddlsizeupd.php'),(20798811,1894,'./estquotecomplstaddlsizeupd.php'),(20798810,1870,'./estquotecomplstaddlsizeupd.php'),(20798809,1868,'./estquotecomplstaddlsizeupd.php'),(20798808,3995,'./estquotecomplstaddlsizeupd.php'),(20798807,1143,'./estquotecomplstaddlsizeupd.php'),(20798806,3994,'./estquotecomplstaddlsizeupd.php'),(20798805,966,'./estquotecomplstaddlsizeupd.php'),(20798804,941,'./estquotecomplstaddlsizeupd.php'),(20798803,820,'./estquotecomplstaddlsizeupd.php'),(20798802,864,'./estquotecomplstaddlsizeupd.php'),(20798801,799,'./estquotecomplstaddlsizeupd.php'),(20798800,3937,'./estquotecomplstaddlsizeupd.php'),(20798799,3944,'./estquotecomplstaddlsizeupd.php'),(20798798,542,'./estquotecomplstaddlsizeupd.php'),(20798797,477,'./estquotecomplstaddlsizeupd.php'),(20798796,476,'./estquotecomplstaddlsizeupd.php'),(20798795,409,'./estquotecomplstaddlsizeupd.php'),(20798794,5203,'./estquotecomplstaddlsizeupd.php'),(20798793,13119,'./estquotecomplstaddlsizeupd.php'),(20798792,12799,'./estquotecomplstaddlsizeupd.php'),(20798791,13415,'./estquotecomplstaddlsizeupd.php'),(20798790,243,'./estquotecomplstaddlsizeupd.php'),(20798789,240,'./estquotecomplstaddlsizeupd.php'),(20798788,239,'./estquotecomplstaddlsizeupd.php'),(20798787,238,'./estquotecomplstaddlsizeupd.php'),(20798786,237,'./estquotecomplstaddlsizeupd.php'),(20798785,236,'./estquotecomplstaddlsizeupd.php'),(20798784,228,'./estquotecomplstaddlsizeupd.php'),(20798783,226,'./estquotecomplstaddlsizeupd.php'),(20798782,176,'./estquotecomplstaddlsizeupd.php'),(20798781,3260,'./estquotecomplstaddlopt.php'),(20798780,2904,'./estquotecomplstaddlopt.php'),(20798779,2710,'./estquotecomplstaddlopt.php'),(20798778,2702,'./estquotecomplstaddlopt.php'),(20798777,1499,'./estquotecomplstaddlopt.php'),(20798776,3995,'./estquotecomplstaddlopt.php'),(20798775,1143,'./estquotecomplstaddlopt.php'),(20798774,3994,'./estquotecomplstaddlopt.php'),(20798773,799,'./estquotecomplstaddlopt.php'),(20798772,3937,'./estquotecomplstaddlopt.php'),(20798771,3945,'./estquotecomplstaddlopt.php'),(20798770,542,'./estquotecomplstaddlopt.php'),(20798769,3422,'./estquotecomplstaddladd.php'),(20798768,3268,'./estquotecomplstaddladd.php'),(20798767,3148,'./estquotecomplstaddladd.php'),(20798766,3084,'./estquotecomplstaddladd.php'),(20798765,1,'./estquotecomplstaddladd.php'),(20798764,2904,'./estquotecomplstaddladd.php'),(20798763,2785,'./estquotecomplstaddladd.php'),(20798762,2784,'./estquotecomplstaddladd.php'),(20798761,2702,'./estquotecomplstaddladd.php'),(20798760,2519,'./estquotecomplstaddladd.php'),(20798759,9635,'./estquotecomplstaddladd.php'),(20798758,2109,'./estquotecomplstaddladd.php'),(20798757,13375,'./estquotecomplstaddladd.php'),(20798756,13168,'./estquotecomplstaddladd.php'),(20798755,3994,'./estquotecomplstaddladd.php'),(20798754,903,'./estquotecomplstaddladd.php'),(20798753,737,'./estquotecomplstaddladd.php'),(20798752,3941,'./estquotecomplstaddladd.php'),(20798751,3940,'./estquotecomplstaddladd.php'),(20798750,162,'./estquotecomplstaddladd.php'),(20798749,182,'./estquotecomplstaddladd.php'),(20798748,176,'./estquotecomplstaddladd.php'),(20798747,3247,'./estquotecomplstadd.php'),(20798746,2702,'./estquotecomplstadd.php'),(20798745,3994,'./estquotecomplstadd.php'),(20798744,3936,'./estquotecomplstadd.php'),(20798743,3935,'./estquotecomplstadd.php'),(20798742,176,'./estquotecomplstadd.php'),(20798741,2702,'./estquotecompletionsteps.php'),(20798740,13842,'./estquotecompletionsteps.php'),(20798739,1963,'./estquotecompletionsteps.php'),(20798738,3912,'./estquotecompletionsteps.php'),(20798737,5257,'./estquotecompleteorder.php'),(20798736,2656,'./estquotecompleteorder.php'),(20798735,2615,'./estquotecompleteorder.php'),(20798734,2508,'./estquotecompleteorder.php'),(20798733,2165,'./estquotecompleteorder.php'),(20798732,2103,'./estquotecompleteorder.php'),(20798731,1963,'./estquotecompleteorder.php'),(20798730,5256,'./estquotecompleteorder.php'),(20798729,5255,'./estquotecompleteorder.php'),(20798728,1019,'./estquotecompleteorder.php'),(20798727,869,'./estquotecompleteorder.php'),(20798726,4416,'./estquotecompleteorder.php'),(20798725,697,'./estquotecompleteorder.php'),(20798724,607,'./estquotecompleteorder.php'),(20798723,5254,'./estquotecompleteorder.php'),(20798722,7858,'./estquotecompleteorder.php'),(20798721,5253,'./estquotecompleteorder.php'),(20798720,337,'./estquotecompleteorder.php'),(20798719,5926,'./estquotecc.php'),(20798718,5925,'./estquotecc.php'),(20798717,5924,'./estquotecc.php'),(20798716,5917,'./estquotecc.php'),(20798715,5916,'./estquotecc.php'),(20798714,5915,'./estquotecc.php'),(20798713,5914,'./estquotecc.php'),(20798712,5913,'./estquotecc.php'),(20798711,5923,'./estquotecc.php'),(20798710,2260,'./estquotecc.php'),(20798709,4023,'./estquotecc.php'),(20798708,2182,'./estquotecc.php'),(20798707,1992,'./estquotecc.php'),(20798706,1963,'./estquotecc.php'),(20798705,1583,'./estquotecc.php'),(20798704,1582,'./estquotecc.php'),(20798703,5922,'./estquotecc.php'),(20798702,5921,'./estquotecc.php'),(20798701,1232,'./estquotecc.php'),(20798700,5920,'./estquotecc.php'),(20798699,679,'./estquotecc.php'),(20798698,5919,'./estquotecc.php'),(20798697,5725,'./estquotecc.php'),(20798696,5912,'./estquotecc.php'),(20798695,5910,'./estquotecc.php'),(20798694,3427,'./estquoteboxlabel_lpstd.php'),(20798693,3072,'./estquoteboxlabel_lpstd.php'),(20798692,3070,'./estquoteboxlabel_lpstd.php'),(20798691,13380,'./estquoteboxlabel_lpstd.php'),(20798690,2819,'./estquoteboxlabel_lpstd.php'),(20798689,2817,'./estquoteboxlabel_lpstd.php'),(20798688,2529,'./estquoteboxlabel_lpstd.php'),(20798687,5088,'./estquoteboxlabel_lpstd.php'),(20798686,2363,'./estquoteboxlabel_lpstd.php'),(20798685,2182,'./estquoteboxlabel_lpstd.php'),(20798684,4789,'./estquoteboxlabel_lpstd.php'),(20798683,13379,'./estquoteboxlabel_lpstd.php'),(20798682,1963,'./estquoteboxlabel_lpstd.php'),(20798681,13378,'./estquoteboxlabel_lpstd.php'),(20798680,4720,'./estquoteboxlabel_lpstd.php'),(20798679,13377,'./estquoteboxlabel_lpstd.php'),(20798678,13376,'./estquoteboxlabel_lpstd.php'),(20798677,1456,'./estquoteboxlabel_lpstd.php'),(20798676,737,'./estquoteboxlabel_lpstd.php'),(20798675,5091,'./estquoteboxlabel_lpstd.php'),(20798674,542,'./estquoteboxlabel_lpstd.php'),(20798673,5087,'./estquoteboxlabel_lpstd.php'),(20798672,5086,'./estquoteboxlabel_lpstd.php'),(20798671,306,'./estquoteboxlabel_lpstd.php'),(20798670,185,'./estquoteboxlabel_lpstd.php'),(20676879,3427,'./estquoteboxlabel6x6.php'),(20676878,3072,'./estquoteboxlabel6x6.php'),(20676877,3070,'./estquoteboxlabel6x6.php'),(20676876,5088,'./estquoteboxlabel6x6.php'),(20676875,2182,'./estquoteboxlabel6x6.php'),(20676874,4789,'./estquoteboxlabel6x6.php'),(20676873,5092,'./estquoteboxlabel6x6.php'),(20676872,1963,'./estquoteboxlabel6x6.php'),(20676871,4720,'./estquoteboxlabel6x6.php'),(20676870,5091,'./estquoteboxlabel6x6.php'),(20676869,542,'./estquoteboxlabel6x6.php'),(20676868,5087,'./estquoteboxlabel6x6.php'),(20676867,5086,'./estquoteboxlabel6x6.php'),(20676866,185,'./estquoteboxlabel6x6.php'),(20798669,3427,'./estquoteboxlabel.php'),(20798668,3072,'./estquoteboxlabel.php'),(20798667,3070,'./estquoteboxlabel.php'),(20798666,5088,'./estquoteboxlabel.php'),(20798665,2182,'./estquoteboxlabel.php'),(20798664,4789,'./estquoteboxlabel.php'),(20798663,1963,'./estquoteboxlabel.php'),(20798662,4720,'./estquoteboxlabel.php'),(20798661,737,'./estquoteboxlabel.php'),(20798660,5091,'./estquoteboxlabel.php'),(20798659,542,'./estquoteboxlabel.php'),(20798658,5087,'./estquoteboxlabel.php'),(20798657,5086,'./estquoteboxlabel.php'),(20798656,306,'./estquoteboxlabel.php'),(20798655,185,'./estquoteboxlabel.php'),(20798654,3247,'./estquotebindlstupd.php'),(20798653,3193,'./estquotebindlstupd.php'),(20798652,2710,'./estquotebindlstupd.php'),(20798651,3931,'./estquotebindlstupd.php'),(20798650,1252,'./estquotebindlstupd.php'),(20798649,1152,'./estquotebindlstupd.php'),(20798648,1151,'./estquotebindlstupd.php'),(20798647,1059,'./estquotebindlstupd.php'),(20798646,941,'./estquotebindlstupd.php'),(20798645,821,'./estquotebindlstupd.php'),(20798644,799,'./estquotebindlstupd.php'),(20798643,378,'./estquotebindlstupd.php'),(20798642,377,'./estquotebindlstupd.php'),(20798641,376,'./estquotebindlstupd.php'),(20798640,375,'./estquotebindlstupd.php'),(20798639,372,'./estquotebindlstupd.php'),(20798638,371,'./estquotebindlstupd.php'),(20798637,370,'./estquotebindlstupd.php'),(20798636,5203,'./estquotebindlstupd.php'),(20798635,90,'./estquotebindlstupd.php'),(20798634,3422,'./estquotebindlstaddlupd.php'),(20798633,3268,'./estquotebindlstaddlupd.php'),(20798632,3148,'./estquotebindlstaddlupd.php'),(20798631,3084,'./estquotebindlstaddlupd.php'),(20798630,1,'./estquotebindlstaddlupd.php'),(20798629,2904,'./estquotebindlstaddlupd.php'),(20798628,6906,'./estquotebindlstaddlupd.php'),(20798627,6905,'./estquotebindlstaddlupd.php'),(20798626,6904,'./estquotebindlstaddlupd.php'),(20798625,6903,'./estquotebindlstaddlupd.php'),(20798624,2785,'./estquotebindlstaddlupd.php'),(20798623,2784,'./estquotebindlstaddlupd.php'),(20798622,2710,'./estquotebindlstaddlupd.php'),(20798621,2702,'./estquotebindlstaddlupd.php'),(20798620,2519,'./estquotebindlstaddlupd.php'),(20798619,7636,'./estquotebindlstaddlupd.php'),(20798618,4175,'./estquotebindlstaddlupd.php'),(20798617,4922,'./estquotebindlstaddlupd.php'),(20798616,4174,'./estquotebindlstaddlupd.php'),(20798615,4124,'./estquotebindlstaddlupd.php'),(20798614,6902,'./estquotebindlstaddlupd.php'),(20798613,4123,'./estquotebindlstaddlupd.php'),(20798612,4921,'./estquotebindlstaddlupd.php'),(20798611,4173,'./estquotebindlstaddlupd.php'),(20798610,4316,'./estquotebindlstaddlupd.php'),(20798609,2109,'./estquotebindlstaddlupd.php'),(20798608,13669,'./estquotebindlstaddlupd.php'),(20798607,1934,'./estquotebindlstaddlupd.php'),(20798606,11731,'./estquotebindlstaddlupd.php'),(20798605,4172,'./estquotebindlstaddlupd.php'),(20798604,1592,'./estquotebindlstaddlupd.php'),(20798603,11730,'./estquotebindlstaddlupd.php'),(20798602,13375,'./estquotebindlstaddlupd.php'),(20798601,13168,'./estquotebindlstaddlupd.php'),(20798600,1249,'./estquotebindlstaddlupd.php'),(20798599,1148,'./estquotebindlstaddlupd.php'),(20798598,966,'./estquotebindlstaddlupd.php'),(20798597,941,'./estquotebindlstaddlupd.php'),(20798596,903,'./estquotebindlstaddlupd.php'),(20798595,819,'./estquotebindlstaddlupd.php'),(20798594,799,'./estquotebindlstaddlupd.php'),(20798593,737,'./estquotebindlstaddlupd.php'),(20798592,542,'./estquotebindlstaddlupd.php'),(20798591,372,'./estquotebindlstaddlupd.php'),(20798590,4171,'./estquotebindlstaddlupd.php'),(20798589,4170,'./estquotebindlstaddlupd.php'),(20798588,365,'./estquotebindlstaddlupd.php'),(20798587,361,'./estquotebindlstaddlupd.php'),(20798586,360,'./estquotebindlstaddlupd.php'),(20798585,369,'./estquotebindlstaddlupd.php'),(20798584,358,'./estquotebindlstaddlupd.php'),(20798583,13118,'./estquotebindlstaddlupd.php'),(20798582,5203,'./estquotebindlstaddlupd.php'),(20798581,11729,'./estquotebindlstaddlupd.php'),(20798580,170,'./estquotebindlstaddlupd.php'),(20798579,165,'./estquotebindlstaddlupd.php'),(20798578,89,'./estquotebindlstaddlupd.php'),(20798577,182,'./estquotebindlstaddlupd.php'),(20798576,59,'./estquotebindlstaddlupd.php'),(20798575,3260,'./estquotebindlstaddlsizeupd.php'),(20798574,2806,'./estquotebindlstaddlsizeupd.php'),(20798573,2805,'./estquotebindlstaddlsizeupd.php'),(20798572,2710,'./estquotebindlstaddlsizeupd.php'),(20798571,2702,'./estquotebindlstaddlsizeupd.php'),(20798570,2159,'./estquotebindlstaddlsizeupd.php'),(20798569,1976,'./estquotebindlstaddlsizeupd.php'),(20798568,1896,'./estquotebindlstaddlsizeupd.php'),(20798567,1895,'./estquotebindlstaddlsizeupd.php'),(20798566,1894,'./estquotebindlstaddlsizeupd.php'),(20798565,1870,'./estquotebindlstaddlsizeupd.php'),(20798564,1868,'./estquotebindlstaddlsizeupd.php'),(20798563,1291,'./estquotebindlstaddlsizeupd.php'),(20798562,1250,'./estquotebindlstaddlsizeupd.php'),(20798561,1149,'./estquotebindlstaddlsizeupd.php'),(20798560,1104,'./estquotebindlstaddlsizeupd.php'),(20798559,1056,'./estquotebindlstaddlsizeupd.php'),(20798558,966,'./estquotebindlstaddlsizeupd.php'),(20798557,941,'./estquotebindlstaddlsizeupd.php'),(20798556,820,'./estquotebindlstaddlsizeupd.php'),(20798555,799,'./estquotebindlstaddlsizeupd.php'),(20798554,542,'./estquotebindlstaddlsizeupd.php'),(20798553,477,'./estquotebindlstaddlsizeupd.php'),(20798552,476,'./estquotebindlstaddlsizeupd.php'),(20798551,409,'./estquotebindlstaddlsizeupd.php'),(20798550,372,'./estquotebindlstaddlsizeupd.php'),(20798549,364,'./estquotebindlstaddlsizeupd.php'),(20798548,363,'./estquotebindlstaddlsizeupd.php'),(20798547,362,'./estquotebindlstaddlsizeupd.php'),(20798546,367,'./estquotebindlstaddlsizeupd.php'),(20798545,5203,'./estquotebindlstaddlsizeupd.php'),(20798544,13119,'./estquotebindlstaddlsizeupd.php'),(20798543,12799,'./estquotebindlstaddlsizeupd.php'),(20798542,13415,'./estquotebindlstaddlsizeupd.php'),(20798541,243,'./estquotebindlstaddlsizeupd.php'),(20798540,240,'./estquotebindlstaddlsizeupd.php'),(20798539,239,'./estquotebindlstaddlsizeupd.php'),(20798538,238,'./estquotebindlstaddlsizeupd.php'),(20798537,237,'./estquotebindlstaddlsizeupd.php'),(20798536,236,'./estquotebindlstaddlsizeupd.php'),(20798535,228,'./estquotebindlstaddlsizeupd.php'),(20798534,226,'./estquotebindlstaddlsizeupd.php'),(20798533,3260,'./estquotebindlstaddlopt.php'),(20798532,2904,'./estquotebindlstaddlopt.php'),(20798531,2710,'./estquotebindlstaddlopt.php'),(20798530,2702,'./estquotebindlstaddlopt.php'),(20798529,3995,'./estquotebindlstaddlopt.php'),(20798528,1143,'./estquotebindlstaddlopt.php'),(20798527,3994,'./estquotebindlstaddlopt.php'),(20798526,799,'./estquotebindlstaddlopt.php'),(20798525,542,'./estquotebindlstaddlopt.php'),(20798524,372,'./estquotebindlstaddlopt.php'),(20798523,368,'./estquotebindlstaddlopt.php'),(20798522,3422,'./estquotebindlstaddladd.php'),(20798521,3268,'./estquotebindlstaddladd.php'),(20798520,3148,'./estquotebindlstaddladd.php'),(20798519,3084,'./estquotebindlstaddladd.php'),(20798518,1,'./estquotebindlstaddladd.php'),(20798517,2904,'./estquotebindlstaddladd.php'),(20798516,2785,'./estquotebindlstaddladd.php'),(20798515,2784,'./estquotebindlstaddladd.php'),(20798514,2702,'./estquotebindlstaddladd.php'),(20798513,2519,'./estquotebindlstaddladd.php'),(20798512,7636,'./estquotebindlstaddladd.php'),(20798511,2109,'./estquotebindlstaddladd.php'),(20798510,13375,'./estquotebindlstaddladd.php'),(20798509,13168,'./estquotebindlstaddladd.php'),(20798508,1055,'./estquotebindlstaddladd.php'),(20798507,903,'./estquotebindlstaddladd.php'),(20798506,737,'./estquotebindlstaddladd.php'),(20798505,359,'./estquotebindlstaddladd.php'),(20798504,366,'./estquotebindlstaddladd.php'),(20798503,358,'./estquotebindlstaddladd.php'),(20798502,13118,'./estquotebindlstaddladd.php'),(20798501,162,'./estquotebindlstaddladd.php'),(20798500,182,'./estquotebindlstaddladd.php'),(20798499,3247,'./estquotebindlstadd.php'),(20798498,2702,'./estquotebindlstadd.php'),(20798497,3931,'./estquotebindlstadd.php'),(20798496,1059,'./estquotebindlstadd.php'),(20798495,1058,'./estquotebindlstadd.php'),(20798494,374,'./estquotebindlstadd.php'),(20798493,373,'./estquotebindlstadd.php'),(20798492,370,'./estquotebindlstadd.php'),(20798491,5169,'./estquotebilledorder.php'),(20798490,3319,'./estquotebilledorder.php'),(20798489,5168,'./estquotebilledorder.php'),(20798488,2656,'./estquotebilledorder.php'),(20798487,2615,'./estquotebilledorder.php'),(20798486,5167,'./estquotebilledorder.php'),(20798485,2459,'./estquotebilledorder.php'),(20798484,2165,'./estquotebilledorder.php'),(20798483,1963,'./estquotebilledorder.php'),(20798482,1678,'./estquotebilledorder.php'),(20798481,1672,'./estquotebilledorder.php'),(20798480,4165,'./estquotebilledorder.php'),(20798479,1019,'./estquotebilledorder.php'),(20798478,941,'./estquotebilledorder.php'),(20798477,901,'./estquotebilledorder.php'),(20798476,869,'./estquotebilledorder.php'),(20798475,4416,'./estquotebilledorder.php'),(20798474,697,'./estquotebilledorder.php'),(20798473,607,'./estquotebilledorder.php'),(20798472,5252,'./estquotebilledorder.php'),(20798471,337,'./estquotebilledorder.php'),(20798470,59,'./estquotebilledorder.php'),(20798469,3427,'./estquoteaddshipmail_fpdf.php'),(20798468,5569,'./estquoteaddshipmail_fpdf.php'),(20798467,3355,'./estquoteaddshipmail_fpdf.php'),(20798466,4126,'./estquoteaddshipmail_fpdf.php'),(20798465,6901,'./estquoteaddshipmail_fpdf.php'),(20798464,6893,'./estquoteaddshipmail_fpdf.php'),(20798463,4176,'./estquoteaddshipmail_fpdf.php'),(20798462,6892,'./estquoteaddshipmail_fpdf.php'),(20798461,6900,'./estquoteaddshipmail_fpdf.php'),(20798460,6899,'./estquoteaddshipmail_fpdf.php'),(20798459,6770,'./estquoteaddshipmail_fpdf.php'),(20798458,6898,'./estquoteaddshipmail_fpdf.php'),(20798457,5687,'./estquoteaddshipmail_fpdf.php'),(20798456,5686,'./estquoteaddshipmail_fpdf.php'),(20798455,12851,'./estquoteaddshipmail_fpdf.php'),(20798454,2508,'./estquoteaddshipmail_fpdf.php'),(20798453,2324,'./estquoteaddshipmail_fpdf.php'),(20798452,6888,'./estquoteaddshipmail_fpdf.php'),(20798451,6897,'./estquoteaddshipmail_fpdf.php'),(20798450,4173,'./estquoteaddshipmail_fpdf.php'),(20798449,6887,'./estquoteaddshipmail_fpdf.php'),(20798448,2099,'./estquoteaddshipmail_fpdf.php'),(20798447,5685,'./estquoteaddshipmail_fpdf.php'),(20798446,6896,'./estquoteaddshipmail_fpdf.php'),(20798445,1456,'./estquoteaddshipmail_fpdf.php'),(20798444,1446,'./estquoteaddshipmail_fpdf.php'),(20798443,1373,'./estquoteaddshipmail_fpdf.php'),(20798442,5684,'./estquoteaddshipmail_fpdf.php'),(20798441,982,'./estquoteaddshipmail_fpdf.php'),(20798440,981,'./estquoteaddshipmail_fpdf.php'),(20798439,869,'./estquoteaddshipmail_fpdf.php'),(20798438,719,'./estquoteaddshipmail_fpdf.php'),(20798437,716,'./estquoteaddshipmail_fpdf.php'),(20798436,715,'./estquoteaddshipmail_fpdf.php'),(20798435,542,'./estquoteaddshipmail_fpdf.php'),(20798434,540,'./estquoteaddshipmail_fpdf.php'),(20798433,6895,'./estquoteaddshipmail_fpdf.php'),(20798432,5086,'./estquoteaddshipmail_fpdf.php'),(20798431,191,'./estquoteaddshipmail_fpdf.php'),(20718415,5569,'./estquoteaddshipmail.php'),(20718414,3355,'./estquoteaddshipmail.php'),(20718413,4126,'./estquoteaddshipmail.php'),(20718412,6901,'./estquoteaddshipmail.php'),(20718411,6893,'./estquoteaddshipmail.php'),(20718410,4176,'./estquoteaddshipmail.php'),(20718409,6892,'./estquoteaddshipmail.php'),(20718408,6900,'./estquoteaddshipmail.php'),(20718407,6899,'./estquoteaddshipmail.php'),(20718406,6898,'./estquoteaddshipmail.php'),(20718405,5687,'./estquoteaddshipmail.php'),(20718404,5686,'./estquoteaddshipmail.php'),(20718403,2459,'./estquoteaddshipmail.php'),(20718402,2324,'./estquoteaddshipmail.php'),(20718401,6888,'./estquoteaddshipmail.php'),(20718400,6897,'./estquoteaddshipmail.php'),(20718399,4173,'./estquoteaddshipmail.php'),(20718398,6887,'./estquoteaddshipmail.php'),(20718397,2099,'./estquoteaddshipmail.php'),(20718396,5685,'./estquoteaddshipmail.php'),(20718395,6896,'./estquoteaddshipmail.php'),(20718394,1446,'./estquoteaddshipmail.php'),(20718393,1373,'./estquoteaddshipmail.php'),(20718392,5684,'./estquoteaddshipmail.php'),(20718391,982,'./estquoteaddshipmail.php'),(20718390,981,'./estquoteaddshipmail.php'),(20718389,869,'./estquoteaddshipmail.php'),(20718388,719,'./estquoteaddshipmail.php'),(20718387,717,'./estquoteaddshipmail.php'),(20718386,716,'./estquoteaddshipmail.php'),(20718385,6895,'./estquoteaddshipmail.php'),(20718384,191,'./estquoteaddshipmail.php'),(17485586,306,'./importvendor.php'),(20802067,16143,'./importgljournals.php'),(20676594,2950,'./estquoteaddsearch.php'),(20676593,2886,'./estquoteaddsearch.php'),(20676592,2561,'./estquoteaddsearch.php'),(20676591,2459,'./estquoteaddsearch.php'),(20676590,2028,'./estquoteaddsearch.php'),(20676589,869,'./estquoteaddsearch.php'),(20676588,737,'./estquoteaddsearch.php'),(20676587,4481,'./estquoteaddsearch.php'),(20676586,697,'./estquoteaddsearch.php'),(20798430,3427,'./estquoteaddjobmail_ow_fpdf.php'),(20798429,5569,'./estquoteaddjobmail_ow_fpdf.php'),(20798428,8874,'./estquoteaddjobmail_ow_fpdf.php'),(20798427,3380,'./estquoteaddjobmail_ow_fpdf.php'),(20798426,3355,'./estquoteaddjobmail_ow_fpdf.php'),(20798425,4126,'./estquoteaddjobmail_ow_fpdf.php'),(20798424,3151,'./estquoteaddjobmail_ow_fpdf.php'),(20798423,6894,'./estquoteaddjobmail_ow_fpdf.php'),(20798422,3090,'./estquoteaddjobmail_ow_fpdf.php'),(20798421,12118,'./estquoteaddjobmail_ow_fpdf.php'),(20798420,6893,'./estquoteaddjobmail_ow_fpdf.php'),(20798419,2950,'./estquoteaddjobmail_ow_fpdf.php'),(20798418,2886,'./estquoteaddjobmail_ow_fpdf.php'),(20798417,5164,'./estquoteaddjobmail_ow_fpdf.php'),(20798416,6892,'./estquoteaddjobmail_ow_fpdf.php'),(20798415,5687,'./estquoteaddjobmail_ow_fpdf.php'),(20798414,5686,'./estquoteaddjobmail_ow_fpdf.php'),(20798413,12851,'./estquoteaddjobmail_ow_fpdf.php'),(20798412,13414,'./estquoteaddjobmail_ow_fpdf.php'),(20798411,2529,'./estquoteaddjobmail_ow_fpdf.php'),(20798410,2508,'./estquoteaddjobmail_ow_fpdf.php'),(20798409,13581,'./estquoteaddjobmail_ow_fpdf.php'),(20798408,13580,'./estquoteaddjobmail_ow_fpdf.php'),(20798407,13919,'./estquoteaddjobmail_ow_fpdf.php'),(20798406,13374,'./estquoteaddjobmail_ow_fpdf.php'),(20798405,6889,'./estquoteaddjobmail_ow_fpdf.php'),(20798404,2324,'./estquoteaddjobmail_ow_fpdf.php'),(20798403,13238,'./estquoteaddjobmail_ow_fpdf.php'),(20798402,13237,'./estquoteaddjobmail_ow_fpdf.php'),(20798401,13442,'./estquoteaddjobmail_ow_fpdf.php'),(20798400,6888,'./estquoteaddjobmail_ow_fpdf.php'),(20798399,2208,'./estquoteaddjobmail_ow_fpdf.php'),(20798398,6887,'./estquoteaddjobmail_ow_fpdf.php'),(20798397,6886,'./estquoteaddjobmail_ow_fpdf.php'),(20798396,2165,'./estquoteaddjobmail_ow_fpdf.php'),(20798395,13236,'./estquoteaddjobmail_ow_fpdf.php'),(20798394,13235,'./estquoteaddjobmail_ow_fpdf.php'),(20798393,8368,'./estquoteaddjobmail_ow_fpdf.php'),(20798392,1963,'./estquoteaddjobmail_ow_fpdf.php'),(20798391,5685,'./estquoteaddjobmail_ow_fpdf.php'),(20798390,13234,'./estquoteaddjobmail_ow_fpdf.php'),(20798389,13441,'./estquoteaddjobmail_ow_fpdf.php'),(20798388,1610,'./estquoteaddjobmail_ow_fpdf.php'),(20798387,13440,'./estquoteaddjobmail_ow_fpdf.php'),(20798386,11873,'./estquoteaddjobmail_ow_fpdf.php'),(20798385,11872,'./estquoteaddjobmail_ow_fpdf.php'),(20798384,1456,'./estquoteaddjobmail_ow_fpdf.php'),(20798383,1373,'./estquoteaddjobmail_ow_fpdf.php'),(20798382,13413,'./estquoteaddjobmail_ow_fpdf.php'),(20798381,5684,'./estquoteaddjobmail_ow_fpdf.php'),(20798380,982,'./estquoteaddjobmail_ow_fpdf.php'),(20798379,981,'./estquoteaddjobmail_ow_fpdf.php'),(20798378,938,'./estquoteaddjobmail_ow_fpdf.php'),(20798377,13373,'./estquoteaddjobmail_ow_fpdf.php'),(20798376,4602,'./estquoteaddjobmail_ow_fpdf.php'),(20798375,869,'./estquoteaddjobmail_ow_fpdf.php'),(20798374,13437,'./estquoteaddjobmail_ow_fpdf.php'),(20798373,719,'./estquoteaddjobmail_ow_fpdf.php'),(20798372,717,'./estquoteaddjobmail_ow_fpdf.php'),(20798371,716,'./estquoteaddjobmail_ow_fpdf.php'),(20798370,13436,'./estquoteaddjobmail_ow_fpdf.php'),(20798369,542,'./estquoteaddjobmail_ow_fpdf.php'),(20798368,540,'./estquoteaddjobmail_ow_fpdf.php'),(20798367,13412,'./estquoteaddjobmail_ow_fpdf.php'),(20798366,7347,'./estquoteaddjobmail_ow_fpdf.php'),(20798365,306,'./estquoteaddjobmail_ow_fpdf.php'),(20798364,8873,'./estquoteaddjobmail_ow_fpdf.php'),(20798363,13571,'./estquoteaddjobmail_ow_fpdf.php'),(20798362,191,'./estquoteaddjobmail_ow_fpdf.php'),(20798361,13372,'./estquoteaddjobmail_ow_fpdf.php'),(20798360,3427,'./estquoteaddjobmail_ow2_fpdf.php'),(20798359,5569,'./estquoteaddjobmail_ow2_fpdf.php'),(20798358,8874,'./estquoteaddjobmail_ow2_fpdf.php'),(20798357,3380,'./estquoteaddjobmail_ow2_fpdf.php'),(20798356,3355,'./estquoteaddjobmail_ow2_fpdf.php'),(20798355,4126,'./estquoteaddjobmail_ow2_fpdf.php'),(20798354,3151,'./estquoteaddjobmail_ow2_fpdf.php'),(20798353,6894,'./estquoteaddjobmail_ow2_fpdf.php'),(20798352,3090,'./estquoteaddjobmail_ow2_fpdf.php'),(20798351,12118,'./estquoteaddjobmail_ow2_fpdf.php'),(20798350,6893,'./estquoteaddjobmail_ow2_fpdf.php'),(20798349,2950,'./estquoteaddjobmail_ow2_fpdf.php'),(20798348,2886,'./estquoteaddjobmail_ow2_fpdf.php'),(20798347,5164,'./estquoteaddjobmail_ow2_fpdf.php'),(20798346,6892,'./estquoteaddjobmail_ow2_fpdf.php'),(20798345,5687,'./estquoteaddjobmail_ow2_fpdf.php'),(20798344,5686,'./estquoteaddjobmail_ow2_fpdf.php'),(20798343,12851,'./estquoteaddjobmail_ow2_fpdf.php'),(20798342,2661,'./estquoteaddjobmail_ow2_fpdf.php'),(20798341,13414,'./estquoteaddjobmail_ow2_fpdf.php'),(20798340,2529,'./estquoteaddjobmail_ow2_fpdf.php'),(20798339,2508,'./estquoteaddjobmail_ow2_fpdf.php'),(20798338,13919,'./estquoteaddjobmail_ow2_fpdf.php'),(20798337,13374,'./estquoteaddjobmail_ow2_fpdf.php'),(20798336,6889,'./estquoteaddjobmail_ow2_fpdf.php'),(20798335,2324,'./estquoteaddjobmail_ow2_fpdf.php'),(20798334,6888,'./estquoteaddjobmail_ow2_fpdf.php'),(20798333,2208,'./estquoteaddjobmail_ow2_fpdf.php'),(20798332,6887,'./estquoteaddjobmail_ow2_fpdf.php'),(20798331,6886,'./estquoteaddjobmail_ow2_fpdf.php'),(20798330,2165,'./estquoteaddjobmail_ow2_fpdf.php'),(20798329,1963,'./estquoteaddjobmail_ow2_fpdf.php'),(20798328,5685,'./estquoteaddjobmail_ow2_fpdf.php'),(20798327,1610,'./estquoteaddjobmail_ow2_fpdf.php'),(20798326,11873,'./estquoteaddjobmail_ow2_fpdf.php'),(20798325,11872,'./estquoteaddjobmail_ow2_fpdf.php'),(20798324,1456,'./estquoteaddjobmail_ow2_fpdf.php'),(20798323,1373,'./estquoteaddjobmail_ow2_fpdf.php'),(20798322,13413,'./estquoteaddjobmail_ow2_fpdf.php'),(20798321,5684,'./estquoteaddjobmail_ow2_fpdf.php'),(20798320,982,'./estquoteaddjobmail_ow2_fpdf.php'),(20798319,981,'./estquoteaddjobmail_ow2_fpdf.php'),(20798318,938,'./estquoteaddjobmail_ow2_fpdf.php'),(20798317,13373,'./estquoteaddjobmail_ow2_fpdf.php'),(20798316,4602,'./estquoteaddjobmail_ow2_fpdf.php'),(20798315,869,'./estquoteaddjobmail_ow2_fpdf.php'),(20798314,719,'./estquoteaddjobmail_ow2_fpdf.php'),(20798313,717,'./estquoteaddjobmail_ow2_fpdf.php'),(20798312,716,'./estquoteaddjobmail_ow2_fpdf.php'),(20798311,542,'./estquoteaddjobmail_ow2_fpdf.php'),(20798310,540,'./estquoteaddjobmail_ow2_fpdf.php'),(20798309,13412,'./estquoteaddjobmail_ow2_fpdf.php'),(20798308,7347,'./estquoteaddjobmail_ow2_fpdf.php'),(20798307,306,'./estquoteaddjobmail_ow2_fpdf.php'),(20798306,8873,'./estquoteaddjobmail_ow2_fpdf.php'),(20798305,191,'./estquoteaddjobmail_ow2_fpdf.php'),(20798304,13372,'./estquoteaddjobmail_ow2_fpdf.php'),(20798303,3427,'./estquoteaddjobmail_fpdf.php'),(20798302,5569,'./estquoteaddjobmail_fpdf.php'),(20798301,8874,'./estquoteaddjobmail_fpdf.php'),(20798300,3380,'./estquoteaddjobmail_fpdf.php'),(20798299,3355,'./estquoteaddjobmail_fpdf.php'),(20798298,4126,'./estquoteaddjobmail_fpdf.php'),(20798297,3151,'./estquoteaddjobmail_fpdf.php'),(20798296,6894,'./estquoteaddjobmail_fpdf.php'),(20798295,11892,'./estquoteaddjobmail_fpdf.php'),(20798294,6893,'./estquoteaddjobmail_fpdf.php'),(20798293,2950,'./estquoteaddjobmail_fpdf.php'),(20798292,2886,'./estquoteaddjobmail_fpdf.php'),(20798291,5164,'./estquoteaddjobmail_fpdf.php'),(20798290,6892,'./estquoteaddjobmail_fpdf.php'),(20798289,5687,'./estquoteaddjobmail_fpdf.php'),(20798288,5686,'./estquoteaddjobmail_fpdf.php'),(20798287,12851,'./estquoteaddjobmail_fpdf.php'),(20798286,2661,'./estquoteaddjobmail_fpdf.php'),(20798285,13662,'./estquoteaddjobmail_fpdf.php'),(20798284,2529,'./estquoteaddjobmail_fpdf.php'),(20798283,2508,'./estquoteaddjobmail_fpdf.php'),(20798282,6875,'./estquoteaddjobmail_fpdf.php'),(20798281,6874,'./estquoteaddjobmail_fpdf.php'),(20798280,6889,'./estquoteaddjobmail_fpdf.php'),(20798279,2357,'./estquoteaddjobmail_fpdf.php'),(20798278,2324,'./estquoteaddjobmail_fpdf.php'),(20798277,6888,'./estquoteaddjobmail_fpdf.php'),(20798276,2208,'./estquoteaddjobmail_fpdf.php'),(20798275,6887,'./estquoteaddjobmail_fpdf.php'),(20798274,6886,'./estquoteaddjobmail_fpdf.php'),(20798273,2165,'./estquoteaddjobmail_fpdf.php'),(20798272,8368,'./estquoteaddjobmail_fpdf.php'),(20798271,1963,'./estquoteaddjobmail_fpdf.php'),(20798270,5685,'./estquoteaddjobmail_fpdf.php'),(20798269,1610,'./estquoteaddjobmail_fpdf.php'),(20798268,11873,'./estquoteaddjobmail_fpdf.php'),(20798267,11872,'./estquoteaddjobmail_fpdf.php'),(20798266,1456,'./estquoteaddjobmail_fpdf.php'),(20798265,1446,'./estquoteaddjobmail_fpdf.php'),(20798264,1373,'./estquoteaddjobmail_fpdf.php'),(20798263,6885,'./estquoteaddjobmail_fpdf.php'),(20798262,5684,'./estquoteaddjobmail_fpdf.php'),(20798261,982,'./estquoteaddjobmail_fpdf.php'),(20798260,981,'./estquoteaddjobmail_fpdf.php'),(20798259,13668,'./estquoteaddjobmail_fpdf.php'),(20798258,13667,'./estquoteaddjobmail_fpdf.php'),(20798257,869,'./estquoteaddjobmail_fpdf.php'),(20798256,719,'./estquoteaddjobmail_fpdf.php'),(20798255,717,'./estquoteaddjobmail_fpdf.php'),(20798254,716,'./estquoteaddjobmail_fpdf.php'),(20798253,3929,'./estquoteaddjobmail_fpdf.php'),(20798252,542,'./estquoteaddjobmail_fpdf.php'),(20798251,540,'./estquoteaddjobmail_fpdf.php'),(20798250,306,'./estquoteaddjobmail_fpdf.php'),(20798249,8873,'./estquoteaddjobmail_fpdf.php'),(20798248,191,'./estquoteaddjobmail_fpdf.php'),(20718200,5569,'./estquoteaddjobmail.php'),(20718199,3380,'./estquoteaddjobmail.php'),(20718198,3355,'./estquoteaddjobmail.php'),(20718197,4126,'./estquoteaddjobmail.php'),(20718196,3151,'./estquoteaddjobmail.php'),(20718195,6894,'./estquoteaddjobmail.php'),(20718194,6893,'./estquoteaddjobmail.php'),(20718193,2950,'./estquoteaddjobmail.php'),(20718192,2886,'./estquoteaddjobmail.php'),(20718191,5164,'./estquoteaddjobmail.php'),(20718190,6892,'./estquoteaddjobmail.php'),(20718189,5687,'./estquoteaddjobmail.php'),(20718188,5686,'./estquoteaddjobmail.php'),(20718187,2661,'./estquoteaddjobmail.php'),(20718186,2529,'./estquoteaddjobmail.php'),(20718185,6875,'./estquoteaddjobmail.php'),(20718184,6890,'./estquoteaddjobmail.php'),(20718183,2459,'./estquoteaddjobmail.php'),(20718182,6874,'./estquoteaddjobmail.php'),(20718181,6889,'./estquoteaddjobmail.php'),(20718180,2357,'./estquoteaddjobmail.php'),(20718179,2324,'./estquoteaddjobmail.php'),(20718178,6888,'./estquoteaddjobmail.php'),(20718177,2208,'./estquoteaddjobmail.php'),(20718176,6887,'./estquoteaddjobmail.php'),(20718175,6886,'./estquoteaddjobmail.php'),(20718174,8368,'./estquoteaddjobmail.php'),(20718173,1963,'./estquoteaddjobmail.php'),(20718172,5685,'./estquoteaddjobmail.php'),(20718171,1610,'./estquoteaddjobmail.php'),(20718170,1373,'./estquoteaddjobmail.php'),(20718169,6885,'./estquoteaddjobmail.php'),(20718168,5684,'./estquoteaddjobmail.php'),(20718167,982,'./estquoteaddjobmail.php'),(20718166,981,'./estquoteaddjobmail.php'),(20718165,869,'./estquoteaddjobmail.php'),(20718164,719,'./estquoteaddjobmail.php'),(20718163,716,'./estquoteaddjobmail.php'),(20718162,3929,'./estquoteaddjobmail.php'),(20718161,542,'./estquoteaddjobmail.php'),(20718160,191,'./estquoteaddjobmail.php'),(20798247,6884,'./estquoteaddjobcopy.php'),(20798246,3156,'./estquoteaddjob_wt2.php'),(20798245,13241,'./estquoteaddjob_wt2.php'),(20798244,13255,'./estquoteaddjob_wt2.php'),(20798243,13254,'./estquoteaddjob_wt2.php'),(20798242,2561,'./estquoteaddjob_wt2.php'),(20798241,13252,'./estquoteaddjob_wt2.php'),(20798240,13324,'./estquoteaddjob_wt2.php'),(20798239,3912,'./estquoteaddjob_wt2.php'),(20798238,13250,'./estquoteaddjob_wt2.php'),(20798237,13233,'./estquoteaddjob_wt2.php'),(20798236,13247,'./estquoteaddjob_wt2.php'),(20798235,13246,'./estquoteaddjob_wt2.php'),(20798234,737,'./estquoteaddjob_wt2.php'),(20798233,13245,'./estquoteaddjob_wt2.php'),(20798232,550,'./estquoteaddjob_wt2.php'),(20798231,14674,'./estquoteaddjob_wt2.php'),(20798230,14673,'./estquoteaddjob_wt2.php'),(20798229,315,'./estquoteaddjob_wt2.php'),(20798228,5503,'./estquoteaddjob_wt2.php'),(20798227,13242,'./estquoteaddjob_wt1.php'),(20798226,13241,'./estquoteaddjob_wt1.php'),(20798225,13240,'./estquoteaddjob_wt1.php'),(20798224,2561,'./estquoteaddjob_wt1.php'),(20798223,13582,'./estquoteaddjob_wt1.php'),(20798222,13581,'./estquoteaddjob_wt1.php'),(20798221,13580,'./estquoteaddjob_wt1.php'),(20798220,13238,'./estquoteaddjob_wt1.php'),(20798219,13237,'./estquoteaddjob_wt1.php'),(20798218,13197,'./estquoteaddjob_wt1.php'),(20798217,13236,'./estquoteaddjob_wt1.php'),(20798216,13235,'./estquoteaddjob_wt1.php'),(20798215,2071,'./estquoteaddjob_wt1.php'),(20798214,1963,'./estquoteaddjob_wt1.php'),(20798213,1934,'./estquoteaddjob_wt1.php'),(20798212,3912,'./estquoteaddjob_wt1.php'),(20798211,13234,'./estquoteaddjob_wt1.php'),(20798210,13196,'./estquoteaddjob_wt1.php'),(20798209,13322,'./estquoteaddjob_wt1.php'),(20798208,13233,'./estquoteaddjob_wt1.php'),(20798207,13321,'./estquoteaddjob_wt1.php'),(20798206,13231,'./estquoteaddjob_wt1.php'),(20798205,13230,'./estquoteaddjob_wt1.php'),(20798204,695,'./estquoteaddjob_wt1.php'),(20798203,13229,'./estquoteaddjob_wt1.php'),(20798202,13228,'./estquoteaddjob_wt1.php'),(20798201,550,'./estquoteaddjob_wt1.php'),(20798200,315,'./estquoteaddjob_wt1.php'),(20798199,3269,'./estquoteaddjob2.php'),(20798198,12018,'./estquoteaddjob2.php'),(20798197,3090,'./estquoteaddjob2.php'),(20798196,12016,'./estquoteaddjob2.php'),(20798195,12734,'./estquoteaddjob2.php'),(20798194,12731,'./estquoteaddjob2.php'),(20798193,13663,'./estquoteaddjob2.php'),(20798192,2702,'./estquoteaddjob2.php'),(20798191,11889,'./estquoteaddjob2.php'),(20798190,6883,'./estquoteaddjob2.php'),(20798189,2529,'./estquoteaddjob2.php'),(20798188,6882,'./estquoteaddjob2.php'),(20798187,5918,'./estquoteaddjob2.php'),(20798186,6459,'./estquoteaddjob2.php'),(20798185,3964,'./estquoteaddjob2.php'),(20798184,3762,'./estquoteaddjob2.php'),(20798183,2465,'./estquoteaddjob2.php'),(20798182,13115,'./estquoteaddjob2.php'),(20798181,3963,'./estquoteaddjob2.php'),(20798180,2448,'./estquoteaddjob2.php'),(20798179,6988,'./estquoteaddjob2.php'),(20798178,6458,'./estquoteaddjob2.php'),(20798177,5917,'./estquoteaddjob2.php'),(20798176,5916,'./estquoteaddjob2.php'),(20798175,5915,'./estquoteaddjob2.php'),(20798174,5914,'./estquoteaddjob2.php'),(20798173,5913,'./estquoteaddjob2.php'),(20798172,2260,'./estquoteaddjob2.php'),(20798171,4023,'./estquoteaddjob2.php'),(20798170,1992,'./estquoteaddjob2.php'),(20798169,6881,'./estquoteaddjob2.php'),(20798168,6880,'./estquoteaddjob2.php'),(20798167,3912,'./estquoteaddjob2.php'),(20798166,8367,'./estquoteaddjob2.php'),(20798165,6457,'./estquoteaddjob2.php'),(20798164,13370,'./estquoteaddjob2.php'),(20798163,13369,'./estquoteaddjob2.php'),(20798162,13368,'./estquoteaddjob2.php'),(20798161,1583,'./estquoteaddjob2.php'),(20798160,1582,'./estquoteaddjob2.php'),(20798159,13445,'./estquoteaddjob2.php'),(20798158,1232,'./estquoteaddjob2.php'),(20798157,13113,'./estquoteaddjob2.php'),(20798156,6879,'./estquoteaddjob2.php'),(20798155,5060,'./estquoteaddjob2.php'),(20798154,6878,'./estquoteaddjob2.php'),(20798153,941,'./estquoteaddjob2.php'),(20798152,13108,'./estquoteaddjob2.php'),(20798151,5479,'./estquoteaddjob2.php'),(20798150,4363,'./estquoteaddjob2.php'),(20798149,679,'./estquoteaddjob2.php'),(20798148,11866,'./estquoteaddjob2.php'),(20798147,5725,'./estquoteaddjob2.php'),(20798146,5912,'./estquoteaddjob2.php'),(20798145,5911,'./estquoteaddjob2.php'),(20798144,5910,'./estquoteaddjob2.php'),(20798143,11984,'./estquoteaddjob2.php'),(20798142,12733,'./estquoteaddjob2.php'),(20798141,3962,'./estquoteaddjob2.php'),(20798140,6456,'./estquoteaddjob2.php'),(20805477,7946,'./jobcostrpt.php'),(20805476,3271,'./jobcostrpt.php'),(20805475,14667,'./jobcostrpt.php'),(20805474,16494,'./jobcostrpt.php'),(20805473,16493,'./jobcostrpt.php'),(20805472,17852,'./jobcostrpt.php'),(20805471,11241,'./jobcostrpt.php'),(20805470,15695,'./jobcostrpt.php'),(17485585,185,'./importvendor.php'),(20798139,8301,'./estquoteaddjob.php'),(20798138,8300,'./estquoteaddjob.php'),(20798137,8298,'./estquoteaddjob.php'),(20798136,11902,'./estquoteaddjob.php'),(20798135,8297,'./estquoteaddjob.php'),(20798134,5597,'./estquoteaddjob.php'),(20798133,3909,'./estquoteaddjob.php'),(20798132,3910,'./estquoteaddjob.php'),(20798131,3907,'./estquoteaddjob.php'),(20798130,2959,'./estquoteaddjob.php'),(20798129,2950,'./estquoteaddjob.php'),(20798128,3957,'./estquoteaddjob.php'),(20798127,13320,'./estquoteaddjob.php'),(20798126,13227,'./estquoteaddjob.php'),(20798125,12730,'./estquoteaddjob.php'),(20798124,2821,'./estquoteaddjob.php'),(20798123,2820,'./estquoteaddjob.php'),(20798122,13444,'./estquoteaddjob.php'),(20798121,13226,'./estquoteaddjob.php'),(20798120,8366,'./estquoteaddjob.php'),(20798119,3961,'./estquoteaddjob.php'),(20798118,13319,'./estquoteaddjob.php'),(20798117,13662,'./estquoteaddjob.php'),(20798116,11953,'./estquoteaddjob.php'),(20798115,2529,'./estquoteaddjob.php'),(20798114,13165,'./estquoteaddjob.php'),(20798113,3906,'./estquoteaddjob.php'),(20798112,12698,'./estquoteaddjob.php'),(20798111,3933,'./estquoteaddjob.php'),(20798110,13163,'./estquoteaddjob.php'),(20798109,13162,'./estquoteaddjob.php'),(20798108,13318,'./estquoteaddjob.php'),(20798107,12031,'./estquoteaddjob.php'),(20798106,8050,'./estquoteaddjob.php'),(20798105,2125,'./estquoteaddjob.php'),(20798104,12729,'./estquoteaddjob.php'),(20798103,6869,'./estquoteaddjob.php'),(20798102,2103,'./estquoteaddjob.php'),(20798101,2070,'./estquoteaddjob.php'),(20798100,1963,'./estquoteaddjob.php'),(20798099,1724,'./estquoteaddjob.php'),(20798098,1709,'./estquoteaddjob.php'),(20798097,13161,'./estquoteaddjob.php'),(20798096,1639,'./estquoteaddjob.php'),(20798095,3917,'./estquoteaddjob.php'),(20798094,12113,'./estquoteaddjob.php'),(20798093,12112,'./estquoteaddjob.php'),(20798092,1610,'./estquoteaddjob.php'),(20798091,12030,'./estquoteaddjob.php'),(20798090,1456,'./estquoteaddjob.php'),(20798089,1425,'./estquoteaddjob.php'),(20798088,3905,'./estquoteaddjob.php'),(20798087,1031,'./estquoteaddjob.php'),(20798086,941,'./estquoteaddjob.php'),(20798085,869,'./estquoteaddjob.php'),(20798084,4764,'./estquoteaddjob.php'),(20798083,12029,'./estquoteaddjob.php'),(20798082,13112,'./estquoteaddjob.php'),(20798081,3954,'./estquoteaddjob.php'),(20798080,716,'./estquoteaddjob.php'),(20798079,4481,'./estquoteaddjob.php'),(20798078,697,'./estquoteaddjob.php'),(20798077,684,'./estquoteaddjob.php'),(20798076,13661,'./estquoteaddjob.php'),(20798075,13660,'./estquoteaddjob.php'),(20798074,5536,'./estquoteaddjob.php'),(20798073,8625,'./estquoteaddjob.php'),(20798072,6121,'./estquoteaddjob.php'),(20798071,13111,'./estquoteaddjob.php'),(20798070,13109,'./estquoteaddjob.php'),(20798069,315,'./estquoteaddjob.php'),(20798068,306,'./estquoteaddjob.php'),(20798067,13160,'./estquoteaddjob.php'),(20798066,12743,'./estquoteaddjob.php'),(20798065,8365,'./estquoteaddjob.php'),(20798064,3908,'./estquoteaddjob.php'),(20798063,3427,'./estquoteaddformmail_ow_fpdf.php'),(20798062,5569,'./estquoteaddformmail_ow_fpdf.php'),(20798061,3380,'./estquoteaddformmail_ow_fpdf.php'),(20798060,3355,'./estquoteaddformmail_ow_fpdf.php'),(20798059,3151,'./estquoteaddformmail_ow_fpdf.php'),(20798058,6894,'./estquoteaddformmail_ow_fpdf.php'),(20798057,3090,'./estquoteaddformmail_ow_fpdf.php'),(20798056,13443,'./estquoteaddformmail_ow_fpdf.php'),(20798055,6893,'./estquoteaddformmail_ow_fpdf.php'),(20798054,2950,'./estquoteaddformmail_ow_fpdf.php'),(20798053,2886,'./estquoteaddformmail_ow_fpdf.php'),(20798052,5164,'./estquoteaddformmail_ow_fpdf.php'),(20798051,5687,'./estquoteaddformmail_ow_fpdf.php'),(20798050,5686,'./estquoteaddformmail_ow_fpdf.php'),(20798049,12851,'./estquoteaddformmail_ow_fpdf.php'),(20798048,13414,'./estquoteaddformmail_ow_fpdf.php'),(20798047,2540,'./estquoteaddformmail_ow_fpdf.php'),(20798046,2529,'./estquoteaddformmail_ow_fpdf.php'),(20798045,13581,'./estquoteaddformmail_ow_fpdf.php'),(20798044,13580,'./estquoteaddformmail_ow_fpdf.php'),(20798043,13374,'./estquoteaddformmail_ow_fpdf.php'),(20798042,6889,'./estquoteaddformmail_ow_fpdf.php'),(20798041,2324,'./estquoteaddformmail_ow_fpdf.php'),(20798040,13238,'./estquoteaddformmail_ow_fpdf.php'),(20798039,13237,'./estquoteaddformmail_ow_fpdf.php'),(20798038,13442,'./estquoteaddformmail_ow_fpdf.php'),(20798037,6871,'./estquoteaddformmail_ow_fpdf.php'),(20798036,2208,'./estquoteaddformmail_ow_fpdf.php'),(20798035,6887,'./estquoteaddformmail_ow_fpdf.php'),(20798034,2165,'./estquoteaddformmail_ow_fpdf.php'),(20798033,13236,'./estquoteaddformmail_ow_fpdf.php'),(20798032,13235,'./estquoteaddformmail_ow_fpdf.php'),(20798031,8368,'./estquoteaddformmail_ow_fpdf.php'),(20798030,1963,'./estquoteaddformmail_ow_fpdf.php'),(20798029,5685,'./estquoteaddformmail_ow_fpdf.php'),(20798028,13234,'./estquoteaddformmail_ow_fpdf.php'),(20798027,13441,'./estquoteaddformmail_ow_fpdf.php'),(20798026,1610,'./estquoteaddformmail_ow_fpdf.php'),(20798025,13440,'./estquoteaddformmail_ow_fpdf.php'),(20798024,13439,'./estquoteaddformmail_ow_fpdf.php'),(20798023,11872,'./estquoteaddformmail_ow_fpdf.php'),(20798022,1456,'./estquoteaddformmail_ow_fpdf.php'),(20798021,1373,'./estquoteaddformmail_ow_fpdf.php'),(20798020,13413,'./estquoteaddformmail_ow_fpdf.php'),(20798019,5684,'./estquoteaddformmail_ow_fpdf.php'),(20798018,982,'./estquoteaddformmail_ow_fpdf.php'),(20798017,981,'./estquoteaddformmail_ow_fpdf.php'),(20798016,938,'./estquoteaddformmail_ow_fpdf.php'),(20798015,13438,'./estquoteaddformmail_ow_fpdf.php'),(20798014,4602,'./estquoteaddformmail_ow_fpdf.php'),(20798013,869,'./estquoteaddformmail_ow_fpdf.php'),(20798012,13437,'./estquoteaddformmail_ow_fpdf.php'),(20798011,719,'./estquoteaddformmail_ow_fpdf.php'),(20798010,717,'./estquoteaddformmail_ow_fpdf.php'),(20798009,716,'./estquoteaddformmail_ow_fpdf.php'),(20798008,13436,'./estquoteaddformmail_ow_fpdf.php'),(20798007,542,'./estquoteaddformmail_ow_fpdf.php'),(20798006,540,'./estquoteaddformmail_ow_fpdf.php'),(20798005,13412,'./estquoteaddformmail_ow_fpdf.php'),(20798004,8873,'./estquoteaddformmail_ow_fpdf.php'),(20798003,13571,'./estquoteaddformmail_ow_fpdf.php'),(20798002,191,'./estquoteaddformmail_ow_fpdf.php'),(20798001,13372,'./estquoteaddformmail_ow_fpdf.php'),(20798000,3427,'./estquoteaddformmail_fpdf.php'),(20797999,3380,'./estquoteaddformmail_fpdf.php'),(20797998,3355,'./estquoteaddformmail_fpdf.php'),(20797997,3151,'./estquoteaddformmail_fpdf.php'),(20797996,5165,'./estquoteaddformmail_fpdf.php'),(20797995,2950,'./estquoteaddformmail_fpdf.php'),(20797994,2909,'./estquoteaddformmail_fpdf.php'),(20797993,2886,'./estquoteaddformmail_fpdf.php'),(20797992,5164,'./estquoteaddformmail_fpdf.php'),(20797991,5687,'./estquoteaddformmail_fpdf.php'),(20797990,5686,'./estquoteaddformmail_fpdf.php'),(20797989,13666,'./estquoteaddformmail_fpdf.php'),(20797988,2616,'./estquoteaddformmail_fpdf.php'),(20797987,2553,'./estquoteaddformmail_fpdf.php'),(20797986,2540,'./estquoteaddformmail_fpdf.php'),(20797985,2529,'./estquoteaddformmail_fpdf.php'),(20797984,6875,'./estquoteaddformmail_fpdf.php'),(20797983,2486,'./estquoteaddformmail_fpdf.php'),(20797982,2485,'./estquoteaddformmail_fpdf.php'),(20797981,6874,'./estquoteaddformmail_fpdf.php'),(20797980,11883,'./estquoteaddformmail_fpdf.php'),(20797979,6873,'./estquoteaddformmail_fpdf.php'),(20797978,6872,'./estquoteaddformmail_fpdf.php'),(20797977,2324,'./estquoteaddformmail_fpdf.php'),(20797976,6871,'./estquoteaddformmail_fpdf.php'),(20797975,8364,'./estquoteaddformmail_fpdf.php'),(20797974,13665,'./estquoteaddformmail_fpdf.php'),(20797973,6870,'./estquoteaddformmail_fpdf.php'),(20797972,1963,'./estquoteaddformmail_fpdf.php'),(20797971,5685,'./estquoteaddformmail_fpdf.php'),(20797970,1610,'./estquoteaddformmail_fpdf.php'),(20797969,11869,'./estquoteaddformmail_fpdf.php'),(20797968,1456,'./estquoteaddformmail_fpdf.php'),(20797967,1446,'./estquoteaddformmail_fpdf.php'),(20797966,1373,'./estquoteaddformmail_fpdf.php'),(20797965,5163,'./estquoteaddformmail_fpdf.php'),(20797964,5684,'./estquoteaddformmail_fpdf.php'),(20797963,982,'./estquoteaddformmail_fpdf.php'),(20797962,981,'./estquoteaddformmail_fpdf.php'),(20797961,869,'./estquoteaddformmail_fpdf.php'),(20797960,738,'./estquoteaddformmail_fpdf.php'),(20797959,719,'./estquoteaddformmail_fpdf.php'),(20797958,5162,'./estquoteaddformmail_fpdf.php'),(20797957,12701,'./estquoteaddformmail_fpdf.php'),(20797956,716,'./estquoteaddformmail_fpdf.php'),(20797955,13664,'./estquoteaddformmail_fpdf.php'),(20797954,542,'./estquoteaddformmail_fpdf.php'),(20797953,540,'./estquoteaddformmail_fpdf.php'),(20797952,191,'./estquoteaddformmail_fpdf.php'),(20717863,3380,'./estquoteaddformmail.php'),(20717862,3355,'./estquoteaddformmail.php'),(20717861,3151,'./estquoteaddformmail.php'),(20717860,5165,'./estquoteaddformmail.php'),(20717859,2950,'./estquoteaddformmail.php'),(20717858,2886,'./estquoteaddformmail.php'),(20717857,5164,'./estquoteaddformmail.php'),(20717856,5687,'./estquoteaddformmail.php'),(20717855,5686,'./estquoteaddformmail.php'),(20717854,2616,'./estquoteaddformmail.php'),(20717853,2553,'./estquoteaddformmail.php'),(20717852,2529,'./estquoteaddformmail.php'),(20717851,6875,'./estquoteaddformmail.php'),(20717850,2486,'./estquoteaddformmail.php'),(20717849,2459,'./estquoteaddformmail.php'),(20717848,6874,'./estquoteaddformmail.php'),(20717847,6873,'./estquoteaddformmail.php'),(20717846,6872,'./estquoteaddformmail.php'),(20717845,2324,'./estquoteaddformmail.php'),(20717844,6871,'./estquoteaddformmail.php'),(20717843,8364,'./estquoteaddformmail.php'),(20717842,6870,'./estquoteaddformmail.php'),(20717841,1963,'./estquoteaddformmail.php'),(20717840,5685,'./estquoteaddformmail.php'),(20717839,1610,'./estquoteaddformmail.php'),(20717838,1373,'./estquoteaddformmail.php'),(20717837,5163,'./estquoteaddformmail.php'),(20717836,5684,'./estquoteaddformmail.php'),(20717835,982,'./estquoteaddformmail.php'),(20717834,981,'./estquoteaddformmail.php'),(20717833,869,'./estquoteaddformmail.php'),(20717832,738,'./estquoteaddformmail.php'),(20717831,719,'./estquoteaddformmail.php'),(20717830,5162,'./estquoteaddformmail.php'),(20717829,717,'./estquoteaddformmail.php'),(20717828,716,'./estquoteaddformmail.php'),(20717827,542,'./estquoteaddformmail.php'),(20717826,191,'./estquoteaddformmail.php'),(20805469,16492,'./jobcostrpt.php'),(20805468,2907,'./jobcostrpt.php'),(20676027,8301,'./estquoteaddform_ow.php'),(20676026,8300,'./estquoteaddform_ow.php'),(20676025,8298,'./estquoteaddform_ow.php'),(20676024,11902,'./estquoteaddform_ow.php'),(20676023,12700,'./estquoteaddform_ow.php'),(20676022,3380,'./estquoteaddform_ow.php'),(20676021,4109,'./estquoteaddform_ow.php'),(20676020,3151,'./estquoteaddform_ow.php'),(20676019,12798,'./estquoteaddform_ow.php'),(20676018,3090,'./estquoteaddform_ow.php'),(20676017,2959,'./estquoteaddform_ow.php'),(20676016,2950,'./estquoteaddform_ow.php'),(20676015,2909,'./estquoteaddform_ow.php'),(20676014,13320,'./estquoteaddform_ow.php'),(20676013,2886,'./estquoteaddform_ow.php'),(20676012,2826,'./estquoteaddform_ow.php'),(20676011,2843,'./estquoteaddform_ow.php'),(20676010,2835,'./estquoteaddform_ow.php'),(20676009,2562,'./estquoteaddform_ow.php'),(20676008,12699,'./estquoteaddform_ow.php'),(20676007,2529,'./estquoteaddform_ow.php'),(20676006,2508,'./estquoteaddform_ow.php'),(20676005,11885,'./estquoteaddform_ow.php'),(20676004,2485,'./estquoteaddform_ow.php'),(20676003,11884,'./estquoteaddform_ow.php'),(20676002,6988,'./estquoteaddform_ow.php'),(20676001,12698,'./estquoteaddform_ow.php'),(20676000,2353,'./estquoteaddform_ow.php'),(20675999,2324,'./estquoteaddform_ow.php'),(20675998,2182,'./estquoteaddform_ow.php'),(20675997,12729,'./estquoteaddform_ow.php'),(20675996,12697,'./estquoteaddform_ow.php'),(20675995,6869,'./estquoteaddform_ow.php'),(20675994,6870,'./estquoteaddform_ow.php'),(20675993,2070,'./estquoteaddform_ow.php'),(20675992,11880,'./estquoteaddform_ow.php'),(20675991,11877,'./estquoteaddform_ow.php'),(20675990,11876,'./estquoteaddform_ow.php'),(20675989,1763,'./estquoteaddform_ow.php'),(20675988,12113,'./estquoteaddform_ow.php'),(20675987,12112,'./estquoteaddform_ow.php'),(20675986,1610,'./estquoteaddform_ow.php'),(20675985,11871,'./estquoteaddform_ow.php'),(20675984,1498,'./estquoteaddform_ow.php'),(20675983,11869,'./estquoteaddform_ow.php'),(20675982,1456,'./estquoteaddform_ow.php'),(20675981,1373,'./estquoteaddform_ow.php'),(20675980,985,'./estquoteaddform_ow.php'),(20675979,981,'./estquoteaddform_ow.php'),(20675978,941,'./estquoteaddform_ow.php'),(20675977,13108,'./estquoteaddform_ow.php'),(20675976,869,'./estquoteaddform_ow.php'),(20675975,4481,'./estquoteaddform_ow.php'),(20675974,6015,'./estquoteaddform_ow.php'),(20675973,3929,'./estquoteaddform_ow.php'),(20675972,451,'./estquoteaddform_ow.php'),(20675971,306,'./estquoteaddform_ow.php'),(20675970,12107,'./estquoteaddform_ow.php'),(20805467,17223,'./jobcostrpt.php'),(20805466,18027,'./jobcostrpt.php'),(20797951,8301,'./estquoteaddform.php'),(20797950,8300,'./estquoteaddform.php'),(20797949,8298,'./estquoteaddform.php'),(20797948,11902,'./estquoteaddform.php'),(20797947,12700,'./estquoteaddform.php'),(20797946,3380,'./estquoteaddform.php'),(20797945,4109,'./estquoteaddform.php'),(20797944,3151,'./estquoteaddform.php'),(20797943,12798,'./estquoteaddform.php'),(20797942,3090,'./estquoteaddform.php'),(20797941,2959,'./estquoteaddform.php'),(20797940,2950,'./estquoteaddform.php'),(20797939,2909,'./estquoteaddform.php'),(20797938,2886,'./estquoteaddform.php'),(20797937,2826,'./estquoteaddform.php'),(20797936,2843,'./estquoteaddform.php'),(20797935,2835,'./estquoteaddform.php'),(20797934,13663,'./estquoteaddform.php'),(20797933,13662,'./estquoteaddform.php'),(20797932,2562,'./estquoteaddform.php'),(20797931,12699,'./estquoteaddform.php'),(20797930,2529,'./estquoteaddform.php'),(20797929,2508,'./estquoteaddform.php'),(20797928,11885,'./estquoteaddform.php'),(20797927,2485,'./estquoteaddform.php'),(20797926,11884,'./estquoteaddform.php'),(20797925,2404,'./estquoteaddform.php'),(20797924,12698,'./estquoteaddform.php'),(20797923,2353,'./estquoteaddform.php'),(20797922,2324,'./estquoteaddform.php'),(20797921,2182,'./estquoteaddform.php'),(20797920,12729,'./estquoteaddform.php'),(20797919,12697,'./estquoteaddform.php'),(20797918,6869,'./estquoteaddform.php'),(20797917,6870,'./estquoteaddform.php'),(20797916,2070,'./estquoteaddform.php'),(20797915,11880,'./estquoteaddform.php'),(20797914,11877,'./estquoteaddform.php'),(20797913,11876,'./estquoteaddform.php'),(20797912,1798,'./estquoteaddform.php'),(20797911,1796,'./estquoteaddform.php'),(20797910,1763,'./estquoteaddform.php'),(20797909,12113,'./estquoteaddform.php'),(20797908,12112,'./estquoteaddform.php'),(20797907,1610,'./estquoteaddform.php'),(20797906,11871,'./estquoteaddform.php'),(20797905,1498,'./estquoteaddform.php'),(20797904,11869,'./estquoteaddform.php'),(20797903,1456,'./estquoteaddform.php'),(20797902,1373,'./estquoteaddform.php'),(20797901,985,'./estquoteaddform.php'),(20797900,981,'./estquoteaddform.php'),(20797899,941,'./estquoteaddform.php'),(20797898,13108,'./estquoteaddform.php'),(20797897,869,'./estquoteaddform.php'),(20797896,4481,'./estquoteaddform.php'),(20797895,3929,'./estquoteaddform.php'),(20797894,13661,'./estquoteaddform.php'),(20797893,13660,'./estquoteaddform.php'),(20797892,451,'./estquoteaddform.php'),(20797891,306,'./estquoteaddform.php'),(20797890,12107,'./estquoteaddform.php'),(20797889,2798,'./estquote_volume_detail.php'),(20797888,5057,'./estquote_volume_detail.php'),(20797887,2529,'./estquote_volume_detail.php'),(20797886,4896,'./estquote_volume_detail.php'),(20797885,2165,'./estquote_volume_detail.php'),(20797884,2129,'./estquote_volume_detail.php'),(20797883,2106,'./estquote_volume_detail.php'),(20797882,1871,'./estquote_volume_detail.php'),(20797881,1821,'./estquote_volume_detail.php'),(20797880,1749,'./estquote_volume_detail.php'),(20797879,1747,'./estquote_volume_detail.php'),(20797878,1741,'./estquote_volume_detail.php'),(20797877,1678,'./estquote_volume_detail.php'),(20797876,5056,'./estquote_volume_detail.php'),(20797875,1375,'./estquote_volume_detail.php'),(20797874,869,'./estquote_volume_detail.php'),(20797873,778,'./estquote_volume_detail.php'),(20797872,5055,'./estquote_volume_detail.php'),(20797871,4416,'./estquote_volume_detail.php'),(20797870,5054,'./estquote_volume_detail.php'),(20797869,5053,'./estquote_volume_detail.php'),(20797868,542,'./estquote_volume_detail.php'),(20797867,315,'./estquote_volume_detail.php'),(20797866,308,'./estquote_volume_detail.php'),(20797865,275,'./estquote_volume_detail.php'),(20797864,226,'./estquote_volume_detail.php'),(20797863,3415,'./estquote_volume.php'),(20797862,3090,'./estquote_volume.php'),(20797861,2798,'./estquote_volume.php'),(20797860,4394,'./estquote_volume.php'),(20797859,2590,'./estquote_volume.php'),(20797858,2529,'./estquote_volume.php'),(20797857,4393,'./estquote_volume.php'),(20797856,2129,'./estquote_volume.php'),(20797855,4917,'./estquote_volume.php'),(20797854,4389,'./estquote_volume.php'),(20797853,2106,'./estquote_volume.php'),(20797852,1963,'./estquote_volume.php'),(20797851,1913,'./estquote_volume.php'),(20797850,1871,'./estquote_volume.php'),(20797849,1821,'./estquote_volume.php'),(20797848,1749,'./estquote_volume.php'),(20797847,1747,'./estquote_volume.php'),(20797846,1741,'./estquote_volume.php'),(20797845,4165,'./estquote_volume.php'),(20797844,1375,'./estquote_volume.php'),(20797843,778,'./estquote_volume.php'),(20797842,749,'./estquote_volume.php'),(20797841,5040,'./estquote_volume.php'),(20797840,5039,'./estquote_volume.php'),(20797839,4162,'./estquote_volume.php'),(20797838,308,'./estquote_volume.php'),(20797837,275,'./estquote_volume.php'),(20797836,12028,'./estquote_volume.php'),(20797835,4064,'./estquote_stock_needs.php'),(20797834,5251,'./estquote_stock_needs.php'),(20797833,3849,'./estquote_stock_needs.php'),(20797832,2165,'./estquote_stock_needs.php'),(20797831,4075,'./estquote_stock_needs.php'),(20797830,1939,'./estquote_stock_needs.php'),(20797829,1696,'./estquote_stock_needs.php'),(20797828,869,'./estquote_stock_needs.php'),(20797827,697,'./estquote_stock_needs.php'),(20797826,572,'./estquote_stock_needs.php'),(20675843,2751,'./estquote_reprint_order_ticket.php'),(20675842,2465,'./estquote_reprint_order_ticket.php'),(20675841,2094,'./estquote_reprint_order_ticket.php'),(20797825,3151,'./estquote_ontimestats.php'),(20797824,5250,'./estquote_ontimestats.php'),(20797823,2816,'./estquote_ontimestats.php'),(20797822,2661,'./estquote_ontimestats.php'),(20797821,2589,'./estquote_ontimestats.php'),(20797820,2488,'./estquote_ontimestats.php'),(20797819,5249,'./estquote_ontimestats.php'),(20797818,5248,'./estquote_ontimestats.php'),(20797817,5247,'./estquote_ontimestats.php'),(20797816,5246,'./estquote_ontimestats.php'),(20797815,2165,'./estquote_ontimestats.php'),(20797814,2140,'./estquote_ontimestats.php'),(20797813,4917,'./estquote_ontimestats.php'),(20797812,5245,'./estquote_ontimestats.php'),(20797811,2034,'./estquote_ontimestats.php'),(20797810,2090,'./estquote_ontimestats.php'),(20797809,1963,'./estquote_ontimestats.php'),(20797808,1759,'./estquote_ontimestats.php'),(20797807,1592,'./estquote_ontimestats.php'),(20797806,1014,'./estquote_ontimestats.php'),(20797805,939,'./estquote_ontimestats.php'),(20797804,932,'./estquote_ontimestats.php'),(20797803,901,'./estquote_ontimestats.php'),(20797802,4973,'./estquote_ontimestats.php'),(20797801,4481,'./estquote_ontimestats.php'),(20797800,5244,'./estquote_ontimestats.php'),(20797799,333,'./estquote_ontimestats.php'),(20797798,6868,'./estquote_ontimestats.php'),(20797797,4350,'./estquote_ontimestats.php'),(20797796,226,'./estquote_ontimestats.php'),(20797795,3414,'./estquote_noorderyear.php'),(20797794,2751,'./estquote_noorderyear.php'),(20797793,2738,'./estquote_noorderyear.php'),(20797792,2508,'./estquote_noorderyear.php'),(20797791,3472,'./estquote_noorderyear.php'),(20797790,2165,'./estquote_noorderyear.php'),(20797789,14885,'./estquote_noorderyear.php'),(20797788,14884,'./estquote_noorderyear.php'),(20797787,1963,'./estquote_noorderyear.php'),(20797786,1933,'./estquote_noorderyear.php'),(20797785,3468,'./estquote_noorderyear.php'),(20797784,15287,'./estquote_noorderyear.php'),(20797783,3995,'./estquote_noorderyear.php'),(20797782,869,'./estquote_noorderyear.php'),(20797781,4416,'./estquote_noorderyear.php'),(20797780,8730,'./estquote_noorderyear.php'),(20797779,697,'./estquote_noorderyear.php'),(20797778,14883,'./estquote_noorderyear.php'),(20797777,5570,'./estquote_noorderyear.php'),(20797776,14882,'./estquote_noorderyear.php'),(20797775,14881,'./estquote_noorderyear.php'),(20797774,2791,'./estquote2invoice_quick.php'),(20797773,1963,'./estquote2invoice_quick.php'),(20797772,3912,'./estquote2invoice_quick.php'),(20675786,6161,'./estquote2invoice_ow.php'),(20675785,3126,'./estquote2invoice_ow.php'),(20675784,3090,'./estquote2invoice_ow.php'),(20675783,4598,'./estquote2invoice_ow.php'),(20675782,4597,'./estquote2invoice_ow.php'),(20675781,2977,'./estquote2invoice_ow.php'),(20675780,2833,'./estquote2invoice_ow.php'),(20675779,2791,'./estquote2invoice_ow.php'),(20675778,2661,'./estquote2invoice_ow.php'),(20675777,4596,'./estquote2invoice_ow.php'),(20675776,5052,'./estquote2invoice_ow.php'),(20675775,8890,'./estquote2invoice_ow.php'),(20675774,5466,'./estquote2invoice_ow.php'),(20675773,13901,'./estquote2invoice_ow.php'),(20675772,2459,'./estquote2invoice_ow.php'),(20675771,11473,'./estquote2invoice_ow.php'),(20675770,2374,'./estquote2invoice_ow.php'),(20675769,2301,'./estquote2invoice_ow.php'),(20675768,6866,'./estquote2invoice_ow.php'),(20675767,2182,'./estquote2invoice_ow.php'),(20675766,10192,'./estquote2invoice_ow.php'),(20675765,2165,'./estquote2invoice_ow.php'),(20675764,13899,'./estquote2invoice_ow.php'),(20675763,1963,'./estquote2invoice_ow.php'),(20675762,11472,'./estquote2invoice_ow.php'),(20675761,1668,'./estquote2invoice_ow.php'),(20675760,1463,'./estquote2invoice_ow.php'),(20675759,1232,'./estquote2invoice_ow.php'),(20675758,6865,'./estquote2invoice_ow.php'),(20675757,6864,'./estquote2invoice_ow.php'),(20675756,938,'./estquote2invoice_ow.php'),(20675755,13898,'./estquote2invoice_ow.php'),(20675754,869,'./estquote2invoice_ow.php'),(20675753,697,'./estquote2invoice_ow.php'),(20675752,3929,'./estquote2invoice_ow.php'),(20675751,6863,'./estquote2invoice_ow.php'),(20675750,5583,'./estquote2invoice_ow.php'),(20675749,5144,'./estquote2invoice_ow.php'),(20675748,5145,'./estquote2invoice_ow.php'),(20675747,6160,'./estquote2invoice_ow.php'),(20675746,6159,'./estquote2invoice_ow.php'),(20797771,6161,'./estquote2invoice.php'),(20797770,3126,'./estquote2invoice.php'),(20797769,3090,'./estquote2invoice.php'),(20797768,4598,'./estquote2invoice.php'),(20797767,4597,'./estquote2invoice.php'),(20797766,2977,'./estquote2invoice.php'),(20797765,2833,'./estquote2invoice.php'),(20797764,2791,'./estquote2invoice.php'),(20797763,2784,'./estquote2invoice.php'),(20797762,2661,'./estquote2invoice.php'),(20797761,4596,'./estquote2invoice.php'),(20797760,5052,'./estquote2invoice.php'),(20797759,8890,'./estquote2invoice.php'),(20797758,5466,'./estquote2invoice.php'),(20797757,2459,'./estquote2invoice.php'),(20797756,11473,'./estquote2invoice.php'),(20797755,2374,'./estquote2invoice.php'),(20797754,2301,'./estquote2invoice.php'),(20797753,6866,'./estquote2invoice.php'),(20797752,2182,'./estquote2invoice.php'),(20797751,2165,'./estquote2invoice.php'),(20797750,2044,'./estquote2invoice.php'),(20797749,2103,'./estquote2invoice.php'),(20797748,1963,'./estquote2invoice.php'),(20797747,11472,'./estquote2invoice.php'),(20797746,1672,'./estquote2invoice.php'),(20797745,1668,'./estquote2invoice.php'),(20797744,1463,'./estquote2invoice.php'),(20797743,1232,'./estquote2invoice.php'),(20797742,6865,'./estquote2invoice.php'),(20797741,6864,'./estquote2invoice.php'),(20797740,869,'./estquote2invoice.php'),(20797739,4416,'./estquote2invoice.php'),(20797738,697,'./estquote2invoice.php'),(20797737,3929,'./estquote2invoice.php'),(20797736,6863,'./estquote2invoice.php'),(20797735,5583,'./estquote2invoice.php'),(20797734,5051,'./estquote2invoice.php'),(20797733,5144,'./estquote2invoice.php'),(20797732,5145,'./estquote2invoice.php'),(20797731,6160,'./estquote2invoice.php'),(20797730,6159,'./estquote2invoice.php'),(20675703,3155,'./estprgeneralupd.php'),(20675702,2710,'./estprgeneralupd.php'),(20675701,2702,'./estprgeneralupd.php'),(20675700,2209,'./estprgeneralupd.php'),(20675699,2145,'./estprgeneralupd.php'),(20675698,1478,'./estprgeneralupd.php'),(20675697,1477,'./estprgeneralupd.php'),(20675696,1479,'./estprgeneralupd.php'),(20675695,1446,'./estprgeneralupd.php'),(20675694,1426,'./estprgeneralupd.php'),(20675693,1269,'./estprgeneralupd.php'),(20675692,1076,'./estprgeneralupd.php'),(20675691,3393,'./estnpupd.php'),(20675690,3319,'./estnpupd.php'),(20675689,3209,'./estnpupd.php'),(20675688,2782,'./estnpupd.php'),(20675687,2751,'./estnpupd.php'),(20675686,2710,'./estnpupd.php'),(20675685,2702,'./estnpupd.php'),(20675684,2384,'./estnpupd.php'),(20675683,2067,'./estnpupd.php'),(20675682,2013,'./estnpupd.php'),(20675681,2097,'./estnpupd.php'),(20675680,2087,'./estnpupd.php'),(20675679,2086,'./estnpupd.php'),(20675678,2081,'./estnpupd.php'),(20675677,2080,'./estnpupd.php'),(20675676,2077,'./estnpupd.php'),(20675675,1935,'./estnpupd.php'),(20675674,1289,'./estnpupd.php'),(20675673,1183,'./estnpupd.php'),(20675672,941,'./estnpupd.php'),(20675671,20247,'./estnpupd.php'),(20675670,799,'./estnpupd.php'),(20675669,315,'./estnpupd.php'),(20675668,5203,'./estnpupd.php'),(20675667,20246,'./estnpupd.php'),(20675666,59,'./estnpupd.php'),(20675665,3260,'./estnpoperationsoptions.php'),(20675664,2904,'./estnpoperationsoptions.php'),(20675663,4011,'./estnpoperationsoptions.php'),(20675662,2702,'./estnpoperationsoptions.php'),(20675661,2617,'./estnpoperationsoptions.php'),(20675660,2077,'./estnpoperationsoptions.php'),(20675659,2075,'./estnpoperationsoptions.php'),(20675658,1290,'./estnpoperationsoptions.php'),(20675657,1184,'./estnpoperationsoptions.php'),(20675656,1102,'./estnpoperationsoptions.php'),(20675655,799,'./estnpoperationsoptions.php'),(20675654,315,'./estnpoperationsoptions.php'),(20675653,3248,'./estnpoperationsizematls.php'),(20675652,2712,'./estnpoperationsizematls.php'),(20675651,2702,'./estnpoperationsizematls.php'),(20675650,2633,'./estnpoperationsizematls.php'),(20675649,2611,'./estnpoperationsizematls.php'),(20675648,2528,'./estnpoperationsizematls.php'),(20675647,2304,'./estnpoperationsizematls.php'),(20675646,2089,'./estnpoperationsizematls.php'),(20675645,2074,'./estnpoperationsizematls.php'),(20675644,1845,'./estnpoperationsizematls.php'),(20675643,1843,'./estnpoperationsizematls.php'),(20675642,1842,'./estnpoperationsizematls.php'),(20675641,1724,'./estnpoperationsizematls.php'),(20675640,1709,'./estnpoperationsizematls.php'),(20675639,1697,'./estnpoperationsizematls.php'),(20675638,1412,'./estnpoperationsizematls.php'),(20675637,1287,'./estnpoperationsizematls.php'),(20675636,1182,'./estnpoperationsizematls.php'),(20675635,1100,'./estnpoperationsizematls.php'),(20675634,869,'./estnpoperationsizematls.php'),(20675633,799,'./estnpoperationsizematls.php'),(20675632,634,'./estnpoperationsizematls.php'),(20675631,315,'./estnpoperationsizematls.php'),(20675630,3260,'./estnpoperationsize.php'),(20675629,2805,'./estnpoperationsize.php'),(20675628,2710,'./estnpoperationsize.php'),(20675627,2702,'./estnpoperationsize.php'),(20675626,2660,'./estnpoperationsize.php'),(20675625,2577,'./estnpoperationsize.php'),(20675624,2576,'./estnpoperationsize.php'),(20675623,2575,'./estnpoperationsize.php'),(20675622,2574,'./estnpoperationsize.php'),(20675621,2573,'./estnpoperationsize.php'),(20675620,2572,'./estnpoperationsize.php'),(20675619,2571,'./estnpoperationsize.php'),(20675618,2570,'./estnpoperationsize.php'),(20675617,2569,'./estnpoperationsize.php'),(20675616,2568,'./estnpoperationsize.php'),(20675615,2566,'./estnpoperationsize.php'),(20675614,2305,'./estnpoperationsize.php'),(20675613,2159,'./estnpoperationsize.php'),(20675612,2108,'./estnpoperationsize.php'),(20675611,2107,'./estnpoperationsize.php'),(20675610,1976,'./estnpoperationsize.php'),(20675609,2073,'./estnpoperationsize.php'),(20675608,2072,'./estnpoperationsize.php'),(20675607,2088,'./estnpoperationsize.php'),(20675606,2076,'./estnpoperationsize.php'),(20675605,2074,'./estnpoperationsize.php'),(20675604,1896,'./estnpoperationsize.php'),(20675603,1894,'./estnpoperationsize.php'),(20675602,1858,'./estnpoperationsize.php'),(20675601,1870,'./estnpoperationsize.php'),(20675600,1868,'./estnpoperationsize.php'),(20675599,1576,'./estnpoperationsize.php'),(20675598,1568,'./estnpoperationsize.php'),(20675597,1291,'./estnpoperationsize.php'),(20675596,1288,'./estnpoperationsize.php'),(20675595,1181,'./estnpoperationsize.php'),(20675594,1104,'./estnpoperationsize.php'),(20675593,1099,'./estnpoperationsize.php'),(20675592,966,'./estnpoperationsize.php'),(20675591,941,'./estnpoperationsize.php'),(20675590,20245,'./estnpoperationsize.php'),(20675589,799,'./estnpoperationsize.php'),(20675588,721,'./estnpoperationsize.php'),(20675587,718,'./estnpoperationsize.php'),(20675586,714,'./estnpoperationsize.php'),(20675585,701,'./estnpoperationsize.php'),(20675584,477,'./estnpoperationsize.php'),(20675583,476,'./estnpoperationsize.php'),(20675582,301,'./estnpoperationsize.php'),(20675581,5203,'./estnpoperationsize.php'),(20675580,244,'./estnpoperationsize.php'),(20675579,243,'./estnpoperationsize.php'),(20675578,242,'./estnpoperationsize.php'),(20675577,241,'./estnpoperationsize.php'),(20675576,240,'./estnpoperationsize.php'),(20675575,238,'./estnpoperationsize.php'),(20675574,237,'./estnpoperationsize.php'),(20675573,236,'./estnpoperationsize.php'),(20675572,228,'./estnpoperationsize.php'),(20675571,226,'./estnpoperationsize.php'),(20675570,184,'./estnpoperationsize.php'),(20675569,183,'./estnpoperationsize.php'),(20675568,3422,'./estnpoperations.php'),(20675567,3268,'./estnpoperations.php'),(20675566,3215,'./estnpoperations.php'),(20675565,3208,'./estnpoperations.php'),(20675564,3197,'./estnpoperations.php'),(20675563,3148,'./estnpoperations.php'),(20675562,3084,'./estnpoperations.php'),(20675561,2902,'./estnpoperations.php'),(20675560,2786,'./estnpoperations.php'),(20675559,2784,'./estnpoperations.php'),(20675558,2538,'./estnpoperations.php'),(20675557,2518,'./estnpoperations.php'),(20675556,2109,'./estnpoperations.php'),(20675555,2041,'./estnpoperations.php'),(20675554,2084,'./estnpoperations.php'),(20675553,2083,'./estnpoperations.php'),(20675552,2082,'./estnpoperations.php'),(20675551,2085,'./estnpoperations.php'),(20675550,1778,'./estnpoperations.php'),(20675549,1290,'./estnpoperations.php'),(20675548,1184,'./estnpoperations.php'),(20675547,1102,'./estnpoperations.php'),(20675546,960,'./estnpoperations.php'),(20675545,941,'./estnpoperations.php'),(20675544,837,'./estnpoperations.php'),(20675543,799,'./estnpoperations.php'),(20675542,315,'./estnpoperations.php'),(20675541,117,'./estnpoperations.php'),(20675540,182,'./estnpoperations.php'),(20675539,59,'./estnpoperations.php'),(20675538,3393,'./estnpadd.php'),(20675537,2782,'./estnpadd.php'),(20675536,2384,'./estnpadd.php'),(20675535,2067,'./estnpadd.php'),(20675534,2013,'./estnpadd.php'),(20675533,2097,'./estnpadd.php'),(20675532,2079,'./estnpadd.php'),(20675531,2078,'./estnpadd.php'),(20675530,1935,'./estnpadd.php'),(20675529,1101,'./estnpadd.php'),(20675528,315,'./estnpadd.php'),(20675527,117,'./estnpadd.php'),(20675526,59,'./estnpadd.php'),(20797729,4418,'./est_work_in_process.php'),(20797728,3118,'./est_work_in_process.php'),(20797727,2950,'./est_work_in_process.php'),(20797726,2656,'./est_work_in_process.php'),(20797725,2404,'./est_work_in_process.php'),(20797724,2182,'./est_work_in_process.php'),(20797723,3949,'./est_work_in_process.php'),(20797722,1751,'./est_work_in_process.php'),(20797721,4239,'./est_work_in_process.php'),(20797720,616,'./est_work_in_process.php'),(20797719,3090,'./est_volume_detail.php'),(20797718,3070,'./est_volume_detail.php'),(20797717,2816,'./est_volume_detail.php'),(20797716,4157,'./est_volume_detail.php'),(20797715,2529,'./est_volume_detail.php'),(20797714,2165,'./est_volume_detail.php'),(20797713,4623,'./est_volume_detail.php'),(20797712,1678,'./est_volume_detail.php'),(20797711,1672,'./est_volume_detail.php'),(20797710,315,'./est_volume_detail.php'),(20797709,10004,'./est_volume_detail.php'),(20797708,3415,'./est_volume.php'),(20797707,3090,'./est_volume.php'),(20797706,2827,'./est_volume.php'),(20797705,2798,'./est_volume.php'),(20797704,4394,'./est_volume.php'),(20797703,2589,'./est_volume.php'),(20797702,2529,'./est_volume.php'),(20797701,4896,'./est_volume.php'),(20797700,4392,'./est_volume.php'),(20797699,2129,'./est_volume.php'),(20797698,4391,'./est_volume.php'),(20797697,4390,'./est_volume.php'),(20797696,4389,'./est_volume.php'),(20797695,2106,'./est_volume.php'),(20797694,1963,'./est_volume.php'),(20797693,1913,'./est_volume.php'),(20797692,1871,'./est_volume.php'),(20797691,1821,'./est_volume.php'),(20797690,1749,'./est_volume.php'),(20797689,1747,'./est_volume.php'),(20797688,1741,'./est_volume.php'),(20797687,4169,'./est_volume.php'),(20797686,1375,'./est_volume.php'),(20797685,778,'./est_volume.php'),(20797684,749,'./est_volume.php'),(20797683,308,'./est_volume.php'),(20797682,275,'./est_volume.php'),(20797681,12027,'./est_volume.php'),(20797680,3865,'./est_variance.php'),(20797679,4379,'./est_variance.php'),(20797678,3090,'./est_variance.php'),(20797677,4101,'./est_variance.php'),(20797676,4100,'./est_variance.php'),(20797675,2950,'./est_variance.php'),(20797674,4358,'./est_variance.php'),(20797673,4099,'./est_variance.php'),(20797672,4378,'./est_variance.php'),(20797671,2656,'./est_variance.php'),(20797670,2182,'./est_variance.php'),(20797669,2165,'./est_variance.php'),(20797668,1963,'./est_variance.php'),(20797667,3949,'./est_variance.php'),(20797666,1751,'./est_variance.php'),(20797665,4239,'./est_variance.php'),(20797664,4377,'./est_variance.php'),(20797663,1014,'./est_variance.php'),(20797662,4098,'./est_variance.php'),(20797661,4097,'./est_variance.php'),(20797660,4376,'./est_variance.php'),(20797659,315,'./est_variance.php'),(20797658,4375,'./est_variance.php'),(20797657,4712,'./est_update_existing_orders.php'),(20797656,2702,'./est_update_existing_orders.php'),(20797655,4809,'./est_update_existing_orders.php'),(20797654,4711,'./est_update_existing_orders.php'),(20797653,4032,'./est_update_existing_orders.php'),(20797652,4710,'./est_update_existing_orders.php'),(20797651,4883,'./est_update_existing_orders.php'),(20797650,4709,'./est_update_existing_orders.php'),(20797649,2583,'./est_update_existing_orders.php'),(20797648,7546,'./est_update_existing_orders.php'),(20797647,2561,'./est_update_existing_orders.php'),(20797646,2553,'./est_update_existing_orders.php'),(20797645,4882,'./est_update_existing_orders.php'),(20797644,4881,'./est_update_existing_orders.php'),(20797643,4708,'./est_update_existing_orders.php'),(20797642,4009,'./est_update_existing_orders.php'),(20797641,4707,'./est_update_existing_orders.php'),(20797640,4031,'./est_update_existing_orders.php'),(20797639,4706,'./est_update_existing_orders.php'),(20797638,4705,'./est_update_existing_orders.php'),(20797637,2182,'./est_update_existing_orders.php'),(20797636,6887,'./est_update_existing_orders.php'),(20797635,4704,'./est_update_existing_orders.php'),(20797634,4703,'./est_update_existing_orders.php'),(20797633,4702,'./est_update_existing_orders.php'),(20797632,4701,'./est_update_existing_orders.php'),(20797631,4700,'./est_update_existing_orders.php'),(20797630,4880,'./est_update_existing_orders.php'),(20797629,4699,'./est_update_existing_orders.php'),(20797628,941,'./est_update_existing_orders.php'),(20797627,869,'./est_update_existing_orders.php'),(20797626,6862,'./est_update_existing_orders.php'),(20797625,799,'./est_update_existing_orders.php'),(20797624,697,'./est_update_existing_orders.php'),(20797623,4698,'./est_update_existing_orders.php'),(20797622,4697,'./est_update_existing_orders.php'),(20797621,5154,'./est_update_existing_orders.php'),(20797620,315,'./est_update_existing_orders.php'),(20797619,7545,'./est_stock_needs_status.php'),(20797618,2702,'./est_stock_needs_status.php'),(20797617,2589,'./est_stock_needs_status.php'),(20797616,2508,'./est_stock_needs_status.php'),(20797615,2292,'./est_stock_needs_status.php'),(20797614,7543,'./est_stock_needs_status.php'),(20797613,2199,'./est_stock_needs_status.php'),(20797612,2137,'./est_stock_needs_status.php'),(20797611,7539,'./est_stock_needs_status.php'),(20797610,1709,'./est_stock_needs_status.php'),(20797609,869,'./est_stock_needs_status.php'),(20797608,6042,'./est_stock_needs_status.php'),(20797607,542,'./est_stock_needs_status.php'),(20797606,7544,'./est_stock_needs_status.php'),(20797605,4417,'./est_stock_needs.php'),(20797604,2948,'./est_stock_needs.php'),(20797603,2589,'./est_stock_needs.php'),(20797602,2508,'./est_stock_needs.php'),(20797601,3906,'./est_stock_needs.php'),(20797600,2292,'./est_stock_needs.php'),(20797599,7543,'./est_stock_needs.php'),(20797598,2199,'./est_stock_needs.php'),(20797597,7542,'./est_stock_needs.php'),(20797596,7541,'./est_stock_needs.php'),(20797595,7540,'./est_stock_needs.php'),(20797594,5495,'./est_stock_needs.php'),(20797593,5103,'./est_stock_needs.php'),(20797592,7539,'./est_stock_needs.php'),(20797591,7538,'./est_stock_needs.php'),(20797590,1709,'./est_stock_needs.php'),(20797589,7537,'./est_stock_needs.php'),(20797588,869,'./est_stock_needs.php'),(20797587,697,'./est_stock_needs.php'),(20797586,7536,'./est_stock_needs.php'),(20797585,3358,'./est_shop_loading.php'),(20797584,12689,'./est_shop_loading.php'),(20797583,3838,'./est_shop_loading.php'),(20797582,2200,'./est_shop_loading.php'),(20797581,1913,'./est_shop_loading.php'),(20797580,1799,'./est_shop_loading.php'),(20797579,1564,'./est_shop_loading.php'),(20797578,749,'./est_shop_loading.php'),(20797577,4657,'./est_review_order_costs.php'),(20797576,4656,'./est_review_order_costs.php'),(20797575,4655,'./est_review_order_costs.php'),(20797574,3948,'./est_review_order_costs.php'),(20797573,2950,'./est_review_order_costs.php'),(20797572,4654,'./est_review_order_costs.php'),(20797571,2702,'./est_review_order_costs.php'),(20797570,4653,'./est_review_order_costs.php'),(20797569,4652,'./est_review_order_costs.php'),(20797568,4651,'./est_review_order_costs.php'),(20797567,4650,'./est_review_order_costs.php'),(20797566,2561,'./est_review_order_costs.php'),(20797565,2529,'./est_review_order_costs.php'),(20797564,4649,'./est_review_order_costs.php'),(20797563,2480,'./est_review_order_costs.php'),(20797562,2459,'./est_review_order_costs.php'),(20797561,2451,'./est_review_order_costs.php'),(20797560,3946,'./est_review_order_costs.php'),(20797559,4648,'./est_review_order_costs.php'),(20797558,2182,'./est_review_order_costs.php'),(20797557,2044,'./est_review_order_costs.php'),(20797556,6232,'./est_review_order_costs.php'),(20797555,1963,'./est_review_order_costs.php'),(20797554,3949,'./est_review_order_costs.php'),(20797553,1827,'./est_review_order_costs.php'),(20797552,1824,'./est_review_order_costs.php'),(20797551,1799,'./est_review_order_costs.php'),(20797550,1751,'./est_review_order_costs.php'),(20797549,3951,'./est_review_order_costs.php'),(20797548,1564,'./est_review_order_costs.php'),(20797547,3950,'./est_review_order_costs.php'),(20797546,5153,'./est_review_order_costs.php'),(20797545,1047,'./est_review_order_costs.php'),(20797544,941,'./est_review_order_costs.php'),(20797543,932,'./est_review_order_costs.php'),(20797542,4647,'./est_review_order_costs.php'),(20797541,869,'./est_review_order_costs.php'),(20797540,745,'./est_review_order_costs.php'),(20797539,697,'./est_review_order_costs.php'),(20797538,4646,'./est_review_order_costs.php'),(20797537,641,'./est_review_order_costs.php'),(20797536,3947,'./est_review_order_costs.php'),(20797535,4645,'./est_review_order_costs.php'),(20797534,4644,'./est_review_order_costs.php'),(20797533,420,'./est_review_order_costs.php'),(20797532,4407,'./est_redo_stats.php'),(20797531,4406,'./est_redo_stats.php'),(20797530,4358,'./est_redo_stats.php'),(20797529,2861,'./est_redo_stats.php'),(20797528,4378,'./est_redo_stats.php'),(20797527,4405,'./est_redo_stats.php'),(20797526,4404,'./est_redo_stats.php'),(20797525,4402,'./est_redo_stats.php'),(20797524,2182,'./est_redo_stats.php'),(20797523,12708,'./est_redo_stats.php'),(20797522,1963,'./est_redo_stats.php'),(20797521,4400,'./est_redo_stats.php'),(20797520,4399,'./est_redo_stats.php'),(20797519,4398,'./est_redo_stats.php'),(20797518,4397,'./est_redo_stats.php'),(20797517,1014,'./est_redo_stats.php'),(20797516,740,'./est_redo_stats.php'),(20797515,315,'./est_redo_stats.php'),(20797514,4396,'./est_redo_stats.php'),(20797513,4395,'./est_redo_stats.php'),(20797512,4358,'./est_proof_history.php'),(20797511,4374,'./est_proof_history.php'),(20797510,4373,'./est_proof_history.php'),(20797509,4372,'./est_proof_history.php'),(20797508,4371,'./est_proof_history.php'),(20797507,4370,'./est_proof_history.php'),(20797506,2182,'./est_proof_history.php'),(20797505,2008,'./est_proof_history.php'),(20797504,1963,'./est_proof_history.php'),(20797503,4369,'./est_proof_history.php'),(20797502,4368,'./est_proof_history.php'),(20797501,4367,'./est_proof_history.php'),(20797500,4366,'./est_proof_history.php'),(20797499,4365,'./est_proof_history.php'),(20797498,1047,'./est_proof_history.php'),(20797497,1014,'./est_proof_history.php'),(20797496,869,'./est_proof_history.php'),(20797495,4364,'./est_proof_history.php'),(20797494,4363,'./est_proof_history.php'),(20797493,697,'./est_proof_history.php'),(20797492,4362,'./est_proof_history.php'),(20797491,315,'./est_proof_history.php'),(20797490,4361,'./est_proof_history.php'),(20797489,4360,'./est_proof_history.php'),(20797488,3427,'./est_print_quotepdf.php'),(20797487,4688,'./est_print_quotepdf.php'),(20797486,4686,'./est_print_quotepdf.php'),(20797485,4685,'./est_print_quotepdf.php'),(20797484,4684,'./est_print_quotepdf.php'),(20797483,4683,'./est_print_quotepdf.php'),(20797482,4682,'./est_print_quotepdf.php'),(20797481,4681,'./est_print_quotepdf.php'),(20797480,4680,'./est_print_quotepdf.php'),(20797479,4679,'./est_print_quotepdf.php'),(20797478,2561,'./est_print_quotepdf.php'),(20797477,2540,'./est_print_quotepdf.php'),(20797476,2529,'./est_print_quotepdf.php'),(20797475,4678,'./est_print_quotepdf.php'),(20797474,2404,'./est_print_quotepdf.php'),(20797473,2363,'./est_print_quotepdf.php'),(20797472,4677,'./est_print_quotepdf.php'),(20797471,2324,'./est_print_quotepdf.php'),(20797470,2262,'./est_print_quotepdf.php'),(20797469,4676,'./est_print_quotepdf.php'),(20797468,2103,'./est_print_quotepdf.php'),(20797467,4675,'./est_print_quotepdf.php'),(20797466,7535,'./est_print_quotepdf.php'),(20797465,1373,'./est_print_quotepdf.php'),(20797464,7534,'./est_print_quotepdf.php'),(20797463,981,'./est_print_quotepdf.php'),(20797462,932,'./est_print_quotepdf.php'),(20797461,869,'./est_print_quotepdf.php'),(20797460,4671,'./est_print_quotepdf.php'),(20797459,737,'./est_print_quotepdf.php'),(20797458,573,'./est_print_quotepdf.php'),(20797457,542,'./est_print_quotepdf.php'),(20797456,540,'./est_print_quotepdf.php'),(20797455,4670,'./est_print_quotepdf.php'),(20797454,306,'./est_print_quotepdf.php'),(20797453,4669,'./est_print_quotepdf.php'),(20797452,185,'./est_print_quotepdf.php'),(20797451,4657,'./est_print_quote.php'),(20797450,7533,'./est_print_quote.php'),(20797449,7532,'./est_print_quote.php'),(20797448,4668,'./est_print_quote.php'),(20797447,4667,'./est_print_quote.php'),(20797446,4666,'./est_print_quote.php'),(20797445,2950,'./est_print_quote.php'),(20797444,3922,'./est_print_quote.php'),(20797443,4665,'./est_print_quote.php'),(20797442,4664,'./est_print_quote.php'),(20797441,4663,'./est_print_quote.php'),(20797440,2561,'./est_print_quote.php'),(20797439,4662,'./est_print_quote.php'),(20797438,2529,'./est_print_quote.php'),(20797437,4649,'./est_print_quote.php'),(20797436,5728,'./est_print_quote.php'),(20797435,2459,'./est_print_quote.php'),(20797434,2324,'./est_print_quote.php'),(20797433,2182,'./est_print_quote.php'),(20797432,2044,'./est_print_quote.php'),(20797431,4661,'./est_print_quote.php'),(20797430,1963,'./est_print_quote.php'),(20797429,1810,'./est_print_quote.php'),(20797428,1788,'./est_print_quote.php'),(20797427,1564,'./est_print_quote.php'),(20797426,7534,'./est_print_quote.php'),(20797425,7531,'./est_print_quote.php'),(20797424,941,'./est_print_quote.php'),(20797423,932,'./est_print_quote.php'),(20797422,869,'./est_print_quote.php'),(20797421,745,'./est_print_quote.php'),(20797420,5851,'./est_print_quote.php'),(20797419,4659,'./est_print_quote.php'),(20797418,306,'./est_print_quote.php'),(20797417,4516,'./est_out_to_proof.php'),(20797416,4515,'./est_out_to_proof.php'),(20797415,4514,'./est_out_to_proof.php'),(20797414,3072,'./est_out_to_proof.php'),(20797413,3071,'./est_out_to_proof.php'),(20797412,3070,'./est_out_to_proof.php'),(20797411,3037,'./est_out_to_proof.php'),(20797410,4513,'./est_out_to_proof.php'),(20797409,4512,'./est_out_to_proof.php'),(20797408,4511,'./est_out_to_proof.php'),(20797407,2702,'./est_out_to_proof.php'),(20797406,4510,'./est_out_to_proof.php'),(20797405,4509,'./est_out_to_proof.php'),(20797404,4449,'./est_out_to_proof.php'),(20797403,4508,'./est_out_to_proof.php'),(20797402,4507,'./est_out_to_proof.php'),(20797401,4557,'./est_out_to_proof.php'),(20797400,4506,'./est_out_to_proof.php'),(20797399,4505,'./est_out_to_proof.php'),(20797398,4504,'./est_out_to_proof.php'),(20797397,4503,'./est_out_to_proof.php'),(20797396,4502,'./est_out_to_proof.php'),(20797395,2497,'./est_out_to_proof.php'),(20797394,4501,'./est_out_to_proof.php'),(20797393,4500,'./est_out_to_proof.php'),(20797392,4499,'./est_out_to_proof.php'),(20797391,2459,'./est_out_to_proof.php'),(20797390,4498,'./est_out_to_proof.php'),(20797389,4497,'./est_out_to_proof.php'),(20797388,4496,'./est_out_to_proof.php'),(20797387,2324,'./est_out_to_proof.php'),(20797386,4495,'./est_out_to_proof.php'),(20797385,4494,'./est_out_to_proof.php'),(20797384,4493,'./est_out_to_proof.php'),(20797383,2182,'./est_out_to_proof.php'),(20797382,4492,'./est_out_to_proof.php'),(20797381,2117,'./est_out_to_proof.php'),(20797380,2103,'./est_out_to_proof.php'),(20797379,1963,'./est_out_to_proof.php'),(20797378,4369,'./est_out_to_proof.php'),(20797377,1935,'./est_out_to_proof.php'),(20797376,4491,'./est_out_to_proof.php'),(20797375,4490,'./est_out_to_proof.php'),(20797374,4489,'./est_out_to_proof.php'),(20797373,4488,'./est_out_to_proof.php'),(20797372,4487,'./est_out_to_proof.php'),(20797371,4486,'./est_out_to_proof.php'),(20797370,1373,'./est_out_to_proof.php'),(20797369,3995,'./est_out_to_proof.php'),(20797368,4485,'./est_out_to_proof.php'),(20797367,4484,'./est_out_to_proof.php'),(20797366,941,'./est_out_to_proof.php'),(20797365,932,'./est_out_to_proof.php'),(20797364,799,'./est_out_to_proof.php'),(20797363,4483,'./est_out_to_proof.php'),(20797362,4482,'./est_out_to_proof.php'),(20797361,737,'./est_out_to_proof.php'),(20797360,4481,'./est_out_to_proof.php'),(20797359,315,'./est_out_to_proof.php'),(20797358,5203,'./est_out_to_proof.php'),(20797357,59,'./est_out_to_proof.php'),(20797356,4360,'./est_out_to_proof.php'),(20797355,4359,'./est_ontime_stats.php'),(20797354,4358,'./est_ontime_stats.php'),(20797353,2816,'./est_ontime_stats.php'),(20797352,2827,'./est_ontime_stats.php'),(20797351,4357,'./est_ontime_stats.php'),(20797350,2661,'./est_ontime_stats.php'),(20797349,2488,'./est_ontime_stats.php'),(20797348,12707,'./est_ontime_stats.php'),(20797347,12706,'./est_ontime_stats.php'),(20797346,4354,'./est_ontime_stats.php'),(20797345,4353,'./est_ontime_stats.php'),(20797344,4352,'./est_ontime_stats.php'),(20797343,2200,'./est_ontime_stats.php'),(20797342,2165,'./est_ontime_stats.php'),(20797341,2140,'./est_ontime_stats.php'),(20797340,4351,'./est_ontime_stats.php'),(20797339,2090,'./est_ontime_stats.php'),(20797338,1963,'./est_ontime_stats.php'),(20797337,1759,'./est_ontime_stats.php'),(20797336,1592,'./est_ontime_stats.php'),(20797335,1014,'./est_ontime_stats.php'),(20797334,939,'./est_ontime_stats.php'),(20797333,932,'./est_ontime_stats.php'),(20797332,543,'./est_ontime_stats.php'),(20797331,315,'./est_ontime_stats.php'),(20797330,4350,'./est_ontime_stats.php'),(20797329,226,'./est_ontime_stats.php'),(20797328,4641,'./est_lists_quotes.php'),(20797327,4640,'./est_lists_quotes.php'),(20797326,2948,'./est_lists_quotes.php'),(20797325,2656,'./est_lists_quotes.php'),(20797324,4639,'./est_lists_quotes.php'),(20797323,2645,'./est_lists_quotes.php'),(20797322,4638,'./est_lists_quotes.php'),(20797321,2540,'./est_lists_quotes.php'),(20797320,2508,'./est_lists_quotes.php'),(20797319,2480,'./est_lists_quotes.php'),(20797318,4637,'./est_lists_quotes.php'),(20797317,4636,'./est_lists_quotes.php'),(20797316,1963,'./est_lists_quotes.php'),(20797315,1795,'./est_lists_quotes.php'),(20797314,4634,'./est_lists_quotes.php'),(20797313,901,'./est_lists_quotes.php'),(20797312,4615,'./est_lists_quotes.php'),(20797311,869,'./est_lists_quotes.php'),(20797310,4633,'./est_lists_quotes.php'),(20797309,697,'./est_lists_quotes.php'),(20797308,4632,'./est_lists_quotes.php'),(20797307,4631,'./est_lists_quotes.php'),(20797306,607,'./est_lists_quotes.php'),(20797305,4630,'./est_lists_quotes.php'),(20797304,4629,'./est_lists_quotes.php'),(20797303,4628,'./est_lists_quotes.php'),(20797302,4627,'./est_lists_quotes.php'),(20797301,4512,'./est_back_from_proof.php'),(20797300,2702,'./est_back_from_proof.php'),(20797299,4559,'./est_back_from_proof.php'),(20797298,4558,'./est_back_from_proof.php'),(20797297,4449,'./est_back_from_proof.php'),(20797296,4507,'./est_back_from_proof.php'),(20797295,4557,'./est_back_from_proof.php'),(20797294,4505,'./est_back_from_proof.php'),(20797293,4556,'./est_back_from_proof.php'),(20797292,4503,'./est_back_from_proof.php'),(20797291,4502,'./est_back_from_proof.php'),(20797290,4555,'./est_back_from_proof.php'),(20797289,4493,'./est_back_from_proof.php'),(20797288,2182,'./est_back_from_proof.php'),(20797287,4492,'./est_back_from_proof.php'),(20797286,2117,'./est_back_from_proof.php'),(20797285,2103,'./est_back_from_proof.php'),(20797284,1963,'./est_back_from_proof.php'),(20797283,4369,'./est_back_from_proof.php'),(20675037,3320,'./docmgmtview.php'),(20797282,4486,'./est_back_from_proof.php'),(20797281,3995,'./est_back_from_proof.php'),(20797280,941,'./est_back_from_proof.php'),(20797279,799,'./est_back_from_proof.php'),(20797278,4482,'./est_back_from_proof.php'),(20797277,4481,'./est_back_from_proof.php'),(20797276,315,'./est_back_from_proof.php'),(20797275,5203,'./est_back_from_proof.php'),(20797274,4360,'./est_back_from_proof.php'),(20797273,14655,'./error_cmp_changed.php'),(20797272,1047,'./error_cmp_changed.php'),(20797271,14778,'./error_cmp_changed.php'),(20797270,14777,'./error_cmp_changed.php'),(20797269,2702,'./editinvponote.php'),(20797268,2099,'./editinvponote.php'),(20797267,6120,'./editinvponote.php'),(20797266,542,'./editinvponote.php'),(20797265,2702,'./editarnote.php'),(20797264,2099,'./editarnote.php'),(20797263,6119,'./editarnote.php'),(20797262,542,'./editarnote.php'),(20675057,6386,'./edit_db_explanation.php'),(20675056,6385,'./edit_db_explanation.php'),(20675055,6384,'./edit_db_explanation.php'),(20675054,2702,'./edit_db_explanation.php'),(20675053,2094,'./edit_db_explanation.php'),(20675052,1963,'./edit_db_explanation.php'),(20675051,6383,'./edit_db_explanation.php'),(20675050,6382,'./edit_db_explanation.php'),(20675049,6381,'./edit_db_explanation.php'),(20675048,6380,'./edit_db_explanation.php'),(20675047,6379,'./edit_db_explanation.php'),(20675046,6378,'./edit_db_explanation.php'),(20675045,4397,'./edit_db_explanation.php'),(20675044,6377,'./edit_db_explanation.php'),(20675043,6376,'./edit_db_explanation.php'),(20675042,653,'./edit_db_explanation.php'),(20675041,607,'./edit_db_explanation.php'),(20675040,315,'./edit_db_explanation.php'),(20797261,8123,'./downloaddb.php'),(20797260,8121,'./downloaddb.php'),(20675036,3073,'./docmgmtview.php'),(20675035,2142,'./docmgmtview.php'),(20675030,2748,'./docmgmtsearch.php'),(20675034,1404,'./docmgmtview.php'),(20675033,609,'./docmgmtview.php'),(20675032,532,'./docmgmtview.php'),(20675031,315,'./docmgmtview.php'),(20675029,2738,'./docmgmtsearch.php'),(20675028,1406,'./docmgmtsearch.php'),(20675027,873,'./docmgmtsearch.php'),(20675026,568,'./docmgmtsearch.php'),(20675025,197,'./docmgmtsearch.php'),(20675024,3054,'./docmgmtout.php'),(20675023,3053,'./docmgmtout.php'),(20675022,3052,'./docmgmtout.php'),(20675021,1994,'./docmgmtout.php'),(20675020,1757,'./docmgmtout.php'),(20675019,911,'./docmgmtout.php'),(20675018,909,'./docmgmtout.php'),(20675017,407,'./docmgmtout.php'),(20675016,406,'./docmgmtout.php'),(20675015,3312,'./docmgmtin.php'),(20675014,2004,'./docmgmtin.php'),(20675013,909,'./docmgmtin.php'),(20675012,923,'./docmgmtin.php'),(20675011,922,'./docmgmtin.php'),(20675010,485,'./docmgmtin.php'),(20675009,407,'./docmgmtin.php'),(20675008,406,'./docmgmtin.php'),(20675007,3421,'./docmgmthistory.php'),(20675006,3312,'./docmgmthistory.php'),(20675005,2649,'./docmgmthistory.php'),(20675004,2217,'./docmgmthistory.php'),(20675003,2135,'./docmgmthistory.php'),(20675002,1994,'./docmgmthistory.php'),(20675001,1979,'./docmgmthistory.php'),(20675000,2099,'./docmgmthistory.php'),(20674999,1962,'./docmgmthistory.php'),(20674998,1909,'./docmgmthistory.php'),(20674997,1417,'./docmgmthistory.php'),(20674996,1405,'./docmgmthistory.php'),(20674995,1404,'./docmgmthistory.php'),(20674994,917,'./docmgmthistory.php'),(20674993,871,'./docmgmthistory.php'),(20674992,668,'./docmgmthistory.php'),(20674991,451,'./docmgmthistory.php'),(20674990,407,'./docmgmthistory.php'),(20674989,406,'./docmgmthistory.php'),(20674988,315,'./docmgmthistory.php'),(20674987,310,'./docmgmthistory.php'),(20674986,3319,'./docmgmtedit.php'),(20674985,3312,'./docmgmtedit.php'),(20674984,3201,'./docmgmtedit.php'),(20674983,2650,'./docmgmtedit.php'),(20674982,2604,'./docmgmtedit.php'),(20674981,1935,'./docmgmtedit.php'),(20674980,1910,'./docmgmtedit.php'),(20674979,1724,'./docmgmtedit.php'),(20674978,1411,'./docmgmtedit.php'),(20674977,1404,'./docmgmtedit.php'),(20674976,941,'./docmgmtedit.php'),(20674975,921,'./docmgmtedit.php'),(20674974,869,'./docmgmtedit.php'),(20674973,566,'./docmgmtedit.php'),(20674972,451,'./docmgmtedit.php'),(20674971,315,'./docmgmtedit.php'),(20674970,304,'./docmgmtedit.php'),(20674969,303,'./docmgmtedit.php'),(20674968,3421,'./docmgmtdetails.php'),(20674967,3320,'./docmgmtdetails.php'),(20674966,3312,'./docmgmtdetails.php'),(20674965,2649,'./docmgmtdetails.php'),(20674964,2603,'./docmgmtdetails.php'),(20674963,2218,'./docmgmtdetails.php'),(20674962,1994,'./docmgmtdetails.php'),(20674961,1979,'./docmgmtdetails.php'),(20674960,1417,'./docmgmtdetails.php'),(20674959,1405,'./docmgmtdetails.php'),(20674958,1404,'./docmgmtdetails.php'),(20674957,956,'./docmgmtdetails.php'),(20674956,916,'./docmgmtdetails.php'),(20674955,871,'./docmgmtdetails.php'),(20674954,805,'./docmgmtdetails.php'),(20674953,692,'./docmgmtdetails.php'),(20674952,668,'./docmgmtdetails.php'),(20674951,487,'./docmgmtdetails.php'),(20674950,451,'./docmgmtdetails.php'),(20674949,407,'./docmgmtdetails.php'),(20674948,315,'./docmgmtdetails.php'),(20674947,310,'./docmgmtdetails.php'),(20674946,5203,'./docmgmtdetails.php'),(20674945,1404,'./docmgmtdelete.php'),(20674944,920,'./docmgmtdelete.php'),(20674943,315,'./docmgmtdelete.php'),(20674942,3074,'./docmgmtcheck-out.php'),(20674941,2142,'./docmgmtcheck-out.php'),(20674940,915,'./docmgmtcheck-out.php'),(20674939,910,'./docmgmtcheck-out.php'),(20674938,609,'./docmgmtcheck-out.php'),(20674937,532,'./docmgmtcheck-out.php'),(20674936,487,'./docmgmtcheck-out.php'),(20674935,315,'./docmgmtcheck-out.php'),(20674934,3424,'./docmgmtcheck-in.php'),(20674933,3056,'./docmgmtcheck-in.php'),(20674932,1994,'./docmgmtcheck-in.php'),(20674931,2100,'./docmgmtcheck-in.php'),(20674930,1962,'./docmgmtcheck-in.php'),(20674929,1788,'./docmgmtcheck-in.php'),(20674928,1411,'./docmgmtcheck-in.php'),(20674927,1403,'./docmgmtcheck-in.php'),(20674926,919,'./docmgmtcheck-in.php'),(20674925,908,'./docmgmtcheck-in.php'),(20674924,907,'./docmgmtcheck-in.php'),(20674923,869,'./docmgmtcheck-in.php'),(20674922,486,'./docmgmtcheck-in.php'),(20674921,315,'./docmgmtcheck-in.php'),(20674920,3426,'./docmgmtadd.php'),(20674919,3425,'./docmgmtadd.php'),(20674918,3319,'./docmgmtadd.php'),(20674917,3312,'./docmgmtadd.php'),(20674916,3227,'./docmgmtadd.php'),(20674915,3056,'./docmgmtadd.php'),(20674914,2650,'./docmgmtadd.php'),(20674913,2604,'./docmgmtadd.php'),(20674912,1910,'./docmgmtadd.php'),(20674911,1788,'./docmgmtadd.php'),(20674910,1724,'./docmgmtadd.php'),(20674909,1411,'./docmgmtadd.php'),(20674908,918,'./docmgmtadd.php'),(20674907,869,'./docmgmtadd.php'),(20674906,566,'./docmgmtadd.php'),(20674905,451,'./docmgmtadd.php'),(20674904,315,'./docmgmtadd.php'),(20674903,77,'./docmgmtadd.php'),(20674902,59,'./docmgmtadd.php'),(20797259,3156,'./distributor_commissionreport.php'),(20797258,3118,'./distributor_commissionreport.php'),(20797257,6706,'./distributor_commissionreport.php'),(20797256,6861,'./distributor_commissionreport.php'),(20797255,2698,'./distributor_commissionreport.php'),(20797254,6700,'./distributor_commissionreport.php'),(20797253,2461,'./distributor_commissionreport.php'),(20797252,6859,'./distributor_commissionreport.php'),(20797251,2238,'./distributor_commissionreport.php'),(20797250,2225,'./distributor_commissionreport.php'),(20797249,2182,'./distributor_commissionreport.php'),(20797248,6858,'./distributor_commissionreport.php'),(20797247,6857,'./distributor_commissionreport.php'),(20797246,7271,'./distributor_commissionreport.php'),(20797245,6856,'./distributor_commissionreport.php'),(20797244,1963,'./distributor_commissionreport.php'),(20797243,6855,'./distributor_commissionreport.php'),(20797242,6854,'./distributor_commissionreport.php'),(20797241,1014,'./distributor_commissionreport.php'),(20797240,1025,'./distributor_commissionreport.php'),(20797239,6853,'./distributor_commissionreport.php'),(20797238,7136,'./distributor_commissionreport.php'),(20797237,6851,'./distributor_commissionreport.php'),(20797236,491,'./distributor_commissionreport.php'),(20797235,484,'./distributor_commissionreport.php'),(20797234,482,'./distributor_commissionreport.php'),(20797233,504,'./distributor_commissionreport.php'),(20797232,333,'./distributor_commissionreport.php'),(20797231,315,'./distributor_commissionreport.php'),(20503550,542,'./displayhtml.php'),(20797230,2459,'./directdepform.php'),(20797229,1935,'./directdepform.php'),(20797228,1598,'./directdepform.php'),(20797227,1007,'./directdepform.php'),(20797226,5265,'./directdepform.php'),(20797225,542,'./directdepform.php'),(20797224,8004,'./directdepform.php'),(20797223,15413,'./department.php'),(20797222,15412,'./department.php'),(20797221,15411,'./department.php'),(20797220,15393,'./department.php'),(20797219,15410,'./department.php'),(20797218,2710,'./department.php'),(20797217,2702,'./department.php'),(20797216,9807,'./department.php'),(20797215,15409,'./department.php'),(20797214,15408,'./department.php'),(20797213,1935,'./department.php'),(20797212,1874,'./department.php'),(20797211,7972,'./department.php'),(20797210,15906,'./department.php'),(20797209,1480,'./department.php'),(20797208,15406,'./department.php'),(20797207,8936,'./department.php'),(20797206,941,'./department.php'),(20797205,15405,'./department.php'),(20797204,15404,'./department.php'),(20797203,15389,'./department.php'),(20797202,7284,'./department.php'),(20797201,799,'./department.php'),(20797200,15403,'./department.php'),(20797199,548,'./department.php'),(20797198,13994,'./department.php'),(20797197,315,'./department.php'),(20797196,5203,'./department.php'),(20797195,59,'./department.php'),(20717068,6850,'./deletecounts.php'),(20717067,542,'./deletecounts.php'),(20797194,3134,'./dbupdate_multi.php'),(20797193,8020,'./dbupdate_multi.php'),(20797192,8936,'./dbupdate_multi.php'),(20797191,771,'./dbupdate_multi.php'),(20797190,768,'./dbupdate_multi.php'),(20797189,11347,'./dbupdate_multi.php'),(20797188,11346,'./dbupdate_multi.php'),(20805001,1308,'./invpotoap.php'),(20805000,1293,'./invpotoap.php'),(20797187,15672,'./dbupdate.php'),(20797186,15671,'./dbupdate.php'),(20797185,3134,'./dbupdate.php'),(20797184,8020,'./dbupdate.php'),(20797183,15670,'./dbupdate.php'),(20797182,19126,'./dbupdate.php'),(20797181,15669,'./dbupdate.php'),(20797180,19855,'./dbupdate.php'),(20797179,19125,'./dbupdate.php'),(20797178,15667,'./dbupdate.php'),(20797177,18459,'./dbupdate.php'),(20797176,19124,'./dbupdate.php'),(20797175,771,'./dbupdate.php'),(20797174,768,'./dbupdate.php'),(20797173,767,'./dbupdate.php'),(20797172,766,'./dbupdate.php'),(20797171,765,'./dbupdate.php'),(20797170,763,'./dbupdate.php'),(20797169,762,'./dbupdate.php'),(20797168,11347,'./dbupdate.php'),(20797167,760,'./dbupdate.php'),(20797166,759,'./dbupdate.php'),(20797165,755,'./dbupdate.php'),(20797164,752,'./dbupdate.php'),(20674797,773,'./dbkilltemp.php'),(20797089,3432,'./custexportimportcsv.php'),(20797088,8244,'./custexportimportcsv.php'),(20797087,8243,'./custexportimportcsv.php'),(20797086,2936,'./custexportimportcsv.php'),(20797085,13961,'./custexportimportcsv.php'),(20797084,9631,'./custexportimportcsv.php'),(20797083,2331,'./custexportimportcsv.php'),(20797082,13960,'./custexportimportcsv.php'),(20797081,2330,'./custexportimportcsv.php'),(20797080,9630,'./custexportimportcsv.php'),(20797079,2329,'./custexportimportcsv.php'),(20797078,13959,'./custexportimportcsv.php'),(20797077,2327,'./custexportimportcsv.php'),(20797076,1810,'./custexportimportcsv.php'),(20797075,11446,'./custexportimportcsv.php'),(20797074,8936,'./custexportimportcsv.php'),(20797073,8738,'./custexportimportcsv.php'),(20797072,988,'./custexportimportcsv.php'),(20797071,13958,'./custexportimportcsv.php'),(20797070,984,'./custexportimportcsv.php'),(20797069,659,'./custexportimportcsv.php'),(20797068,581,'./custexportimportcsv.php'),(20797067,524,'./custexportimportcsv.php'),(20797066,306,'./custexportimportcsv.php'),(20797065,8797,'./custexportimportcsv.php'),(20797064,185,'./custexportimportcsv.php'),(20797063,13011,'./custexportimport.php'),(20797062,14667,'./custexportimport.php'),(20797061,13009,'./custexportimport.php'),(20797060,5122,'./custexportimport.php'),(20797059,2819,'./custexportimport.php'),(20797058,2765,'./custexportimport.php'),(20797057,2782,'./custexportimport.php'),(20797056,2751,'./custexportimport.php'),(20797055,3961,'./custexportimport.php'),(20797054,2405,'./custexportimport.php'),(20797053,13006,'./custexportimport.php'),(20797052,13004,'./custexportimport.php'),(20797051,13042,'./custexportimport.php'),(20797050,1685,'./custexportimport.php'),(20797049,14996,'./custexportimport.php'),(20797048,1599,'./custexportimport.php'),(20797047,14666,'./custexportimport.php'),(20797046,14665,'./custexportimport.php'),(20797045,5271,'./custexportimport.php'),(20797044,12999,'./custexportimport.php'),(20797043,6378,'./custexportimport.php'),(20797042,12996,'./custexportimport.php'),(20797041,14664,'./custexportimport.php'),(20797040,19441,'./custexportimport.php'),(20797039,1354,'./custexportimport.php'),(20797038,8936,'./custexportimport.php'),(20797037,14663,'./custexportimport.php'),(20797036,12992,'./custexportimport.php'),(20797035,14662,'./custexportimport.php'),(20797034,13954,'./custexportimport.php'),(20797033,13953,'./custexportimport.php'),(20797032,12991,'./custexportimport.php'),(20797031,6165,'./custexportimport.php'),(20797028,2702,'./costcodeadd.php'),(20797027,6481,'./costcodeadd.php'),(20797026,3994,'./costcodeadd.php'),(20797025,6938,'./costcodeadd.php'),(20797024,869,'./costcodeadd.php'),(20797023,13459,'./costcodeadd.php'),(20797022,548,'./costcodeadd.php'),(20797021,315,'./costcodeadd.php'),(20797020,222,'./costcodeadd.php'),(20797019,176,'./costcodeadd.php'),(20797018,13460,'./costcode.php'),(20797017,3225,'./costcode.php'),(20797016,3186,'./costcode.php'),(20797015,2702,'./costcode.php'),(20797014,2044,'./costcode.php'),(20797013,19778,'./costcode.php'),(20797012,1143,'./costcode.php'),(20797011,941,'./costcode.php'),(20797010,6938,'./costcode.php'),(20797009,869,'./costcode.php'),(20797008,864,'./costcode.php'),(20797007,799,'./costcode.php'),(20797006,13459,'./costcode.php'),(20797005,9492,'./costcode.php'),(20797004,548,'./costcode.php'),(20797003,315,'./costcode.php'),(20797002,5203,'./costcode.php'),(20797000,3421,'./copytax.php'),(20796999,12208,'./copytax.php'),(20796998,13740,'./copytax.php'),(20796997,8100,'./copytax.php'),(20796996,8099,'./copytax.php'),(20796995,8104,'./copytax.php'),(20796994,1963,'./copytax.php'),(20796993,8098,'./copytax.php'),(20796992,6219,'./contactinfoupdate.php'),(20796991,6218,'./contactinfoupdate.php'),(20796990,10679,'./constructionloanupd.php'),(20796989,3292,'./constructionloanupd.php'),(20796988,3274,'./constructionloanupd.php'),(20796987,3202,'./constructionloanupd.php'),(20796986,3225,'./constructionloanupd.php'),(20796985,10669,'./constructionloanupd.php'),(20796984,3090,'./constructionloanupd.php'),(20796983,10668,'./constructionloanupd.php'),(20796982,11199,'./constructionloanupd.php'),(20796981,2948,'./constructionloanupd.php'),(20796980,9966,'./constructionloanupd.php'),(20796979,2710,'./constructionloanupd.php'),(20796978,2702,'./constructionloanupd.php'),(20796977,10678,'./constructionloanupd.php'),(20796976,10677,'./constructionloanupd.php'),(20796975,2664,'./constructionloanupd.php'),(20796974,11479,'./constructionloanupd.php'),(20796973,2457,'./constructionloanupd.php'),(20796972,2292,'./constructionloanupd.php'),(20796971,10667,'./constructionloanupd.php'),(20796970,2225,'./constructionloanupd.php'),(20796969,10666,'./constructionloanupd.php'),(20796968,2094,'./constructionloanupd.php'),(20796967,10665,'./constructionloanupd.php'),(20796966,11198,'./constructionloanupd.php'),(20796965,10664,'./constructionloanupd.php'),(20796964,10663,'./constructionloanupd.php'),(20796963,10676,'./constructionloanupd.php'),(20796962,10662,'./constructionloanupd.php'),(20796961,10675,'./constructionloanupd.php'),(20796960,10661,'./constructionloanupd.php'),(20796959,10660,'./constructionloanupd.php'),(20796958,10658,'./constructionloanupd.php'),(20796957,10674,'./constructionloanupd.php'),(20796956,10673,'./constructionloanupd.php'),(20796955,10654,'./constructionloanupd.php'),(20796954,1678,'./constructionloanupd.php'),(20796953,1672,'./constructionloanupd.php'),(20796952,10653,'./constructionloanupd.php'),(20796951,10652,'./constructionloanupd.php'),(20796950,10651,'./constructionloanupd.php'),(20796949,10650,'./constructionloanupd.php'),(20796948,10649,'./constructionloanupd.php'),(20796947,1625,'./constructionloanupd.php'),(20796946,1578,'./constructionloanupd.php'),(20796945,10648,'./constructionloanupd.php'),(20796944,10647,'./constructionloanupd.php'),(20796943,10646,'./constructionloanupd.php'),(20796942,1476,'./constructionloanupd.php'),(20796941,10645,'./constructionloanupd.php'),(20796940,10644,'./constructionloanupd.php'),(20796939,941,'./constructionloanupd.php'),(20796938,799,'./constructionloanupd.php'),(20796937,10643,'./constructionloanupd.php'),(20796936,7815,'./constructionloanupd.php'),(20796935,5382,'./constructionloanupd.php'),(20796934,10672,'./constructionloanupd.php'),(20796933,315,'./constructionloanupd.php'),(20796932,5203,'./constructionloanupd.php'),(20796931,10642,'./constructionloanupd.php'),(20796930,10671,'./constructionloanupd.php'),(20796929,10670,'./constructionloanupd.php'),(20796928,59,'./constructionloanupd.php'),(20796927,3292,'./constructionloanadd.php'),(20796926,10669,'./constructionloanadd.php'),(20796925,10668,'./constructionloanadd.php'),(20796924,2948,'./constructionloanadd.php'),(20796923,9966,'./constructionloanadd.php'),(20796922,2702,'./constructionloanadd.php'),(20796921,11479,'./constructionloanadd.php'),(20796920,10667,'./constructionloanadd.php'),(20796919,10666,'./constructionloanadd.php'),(20796918,10665,'./constructionloanadd.php'),(20796917,11198,'./constructionloanadd.php'),(20796916,10664,'./constructionloanadd.php'),(20796915,10663,'./constructionloanadd.php'),(20796914,10662,'./constructionloanadd.php'),(20796913,10661,'./constructionloanadd.php'),(20796912,10660,'./constructionloanadd.php'),(20796911,10659,'./constructionloanadd.php'),(20796910,10658,'./constructionloanadd.php'),(20796909,10657,'./constructionloanadd.php'),(20796908,10656,'./constructionloanadd.php'),(20796907,10655,'./constructionloanadd.php'),(20796906,10654,'./constructionloanadd.php'),(20796905,10653,'./constructionloanadd.php'),(20796904,10652,'./constructionloanadd.php'),(20796903,10651,'./constructionloanadd.php'),(20796902,10650,'./constructionloanadd.php'),(20796901,10649,'./constructionloanadd.php'),(20796900,1578,'./constructionloanadd.php'),(20796899,10648,'./constructionloanadd.php'),(20796898,10647,'./constructionloanadd.php'),(20796897,10646,'./constructionloanadd.php'),(20796896,10645,'./constructionloanadd.php'),(20796895,10644,'./constructionloanadd.php'),(20796894,10643,'./constructionloanadd.php'),(20796893,542,'./constructionloanadd.php'),(20796892,315,'./constructionloanadd.php'),(20796891,10642,'./constructionloanadd.php'),(20796890,59,'./constructionloanadd.php'),(20716761,8511,'./community.php'),(20796889,12973,'./commissions.php'),(20796888,3186,'./commissions.php'),(20796887,12972,'./commissions.php'),(20796886,12971,'./commissions.php'),(20796885,12970,'./commissions.php'),(20796884,12969,'./commissions.php'),(20796883,9273,'./commissions.php'),(20796882,2948,'./commissions.php'),(20796881,2702,'./commissions.php'),(20796880,2676,'./commissions.php'),(20796879,12968,'./commissions.php'),(20796878,2292,'./commissions.php'),(20796877,12967,'./commissions.php'),(20796876,2238,'./commissions.php'),(20796875,2225,'./commissions.php'),(20796874,1963,'./commissions.php'),(20796873,12966,'./commissions.php'),(20796872,1678,'./commissions.php'),(20796871,1674,'./commissions.php'),(20796870,1671,'./commissions.php'),(20796869,1668,'./commissions.php'),(20796868,4106,'./commissions.php'),(20796867,12965,'./commissions.php'),(20796866,4397,'./commissions.php'),(20796865,8936,'./commissions.php'),(20796864,11042,'./commissions.php'),(20796863,12964,'./commissions.php'),(20796862,869,'./commissions.php'),(20796861,799,'./commissions.php'),(20796860,697,'./commissions.php'),(20796859,11041,'./commissions.php'),(20796858,11040,'./commissions.php'),(20796857,12963,'./commissions.php'),(20796856,569,'./commissions.php'),(20796855,6851,'./commissions.php'),(20796854,12962,'./commissions.php'),(20796853,11039,'./commissions.php'),(20796852,11037,'./commissions.php'),(20796851,409,'./commissions.php'),(20796850,11036,'./commissions.php'),(20796849,12961,'./commissions.php'),(20796848,8125,'./commissions.php'),(20796847,197,'./commissions.php'),(20796846,47,'./commissions.php'),(20796845,3274,'./checksemail.php'),(20796844,2948,'./checksemail.php'),(20796843,2795,'./checksemail.php'),(20796842,14501,'./checksemail.php'),(20796841,2292,'./checksemail.php'),(20796840,14359,'./checksemail.php'),(20796839,8936,'./checksemail.php'),(20796838,14490,'./checksemail.php'),(20796837,981,'./checksemail.php'),(20796836,596,'./checksemail.php'),(20796835,315,'./checksemail.php'),(20796834,3427,'./checks_one.php'),(20796833,6849,'./checks_one.php'),(20796832,3118,'./checks_one.php'),(20796831,5689,'./checks_one.php'),(20796830,2463,'./checks_one.php'),(20796829,12785,'./checks_one.php'),(20796828,7630,'./checks_one.php'),(20796827,6476,'./checks_one.php'),(20796826,1668,'./checks_one.php'),(20796825,7629,'./checks_one.php'),(20796824,542,'./checks_one.php'),(20796823,12784,'./checks_one.php'),(20796822,491,'./checks_one.php'),(20796821,6499,'./checks_one.php'),(20796820,226,'./checks_one.php'),(20796818,3427,'./checks.php'),(20796817,6849,'./checks.php'),(20796816,3090,'./checks.php'),(20796815,14519,'./checks.php'),(20796814,14500,'./checks.php'),(20796813,14499,'./checks.php'),(20796812,5366,'./checks.php'),(20796811,17067,'./checks.php'),(20796810,6476,'./checks.php'),(20796809,2103,'./checks.php'),(20796808,1668,'./checks.php'),(20796807,1629,'./checks.php'),(20796806,1467,'./checks.php'),(20796805,1242,'./checks.php'),(20796804,1235,'./checks.php'),(20796803,8936,'./checks.php'),(20796802,9224,'./checks.php'),(20796801,14498,'./checks.php'),(20796800,900,'./checks.php'),(20796799,886,'./checks.php'),(20796798,7629,'./checks.php'),(20796797,542,'./checks.php'),(20796796,540,'./checks.php'),(20796795,5963,'./checks.php'),(20796794,5962,'./checks.php'),(20796793,5961,'./checks.php'),(20796792,5960,'./checks.php'),(20796791,5959,'./checks.php'),(20796790,491,'./checks.php'),(20796786,2702,'./checklist.php'),(20796785,10144,'./checklist.php'),(20796784,10143,'./checklist.php'),(20796783,10142,'./checklist.php'),(20796782,8936,'./checklist.php'),(20796781,1047,'./checklist.php'),(20796780,591,'./checklist.php'),(20796779,541,'./checklist.php'),(20796778,10141,'./checklist.php'),(20796777,10140,'./checklist.php'),(20796776,10139,'./checklist.php'),(20674413,6848,'./checkitemcode.php'),(20674412,12199,'./checkitemcode.php'),(20674411,6847,'./checkitemcode.php'),(20674410,6846,'./checkitemcode.php'),(20796775,4334,'./check_calc.php'),(20796774,4333,'./check_calc.php'),(20796773,4332,'./check_calc.php'),(20796772,4331,'./check_calc.php'),(20796771,5610,'./check_calc.php'),(20796770,4330,'./check_calc.php'),(20796769,2702,'./check_calc.php'),(20796768,4329,'./check_calc.php'),(20796767,4320,'./check_calc.php'),(20796766,7080,'./check_calc.php'),(20796765,4319,'./check_calc.php'),(20796764,4318,'./check_calc.php'),(20796763,5606,'./check_calc.php'),(20796762,4316,'./check_calc.php'),(20796761,4315,'./check_calc.php'),(20796760,2123,'./check_calc.php'),(20796759,4314,'./check_calc.php'),(20796758,2117,'./check_calc.php'),(20796757,3977,'./check_calc.php'),(20796756,3980,'./check_calc.php'),(20796755,4312,'./check_calc.php'),(20796754,4328,'./check_calc.php'),(20796753,1592,'./check_calc.php'),(20796752,7555,'./check_calc.php'),(20796751,7554,'./check_calc.php'),(20796750,869,'./check_calc.php'),(20796749,7553,'./check_calc.php'),(20796748,4327,'./check_calc.php'),(20796747,4472,'./changedate_ship.php'),(20796746,4471,'./changedate_ship.php'),(20796745,4465,'./changedate_ship.php'),(20796744,4477,'./changedate_due_tam.php'),(20796743,4476,'./changedate_due_tam.php'),(20796742,4480,'./changedate_due_tam.php'),(20796741,4475,'./changedate_due_tam.php'),(20796740,2702,'./changedate_due_tam.php'),(20796739,2234,'./changedate_due_tam.php'),(20796738,2182,'./changedate_due_tam.php'),(20796737,4473,'./changedate_due_tam.php'),(20796736,4472,'./changedate_due_tam.php'),(20796735,4471,'./changedate_due_tam.php'),(20796734,4470,'./changedate_due_tam.php'),(20796733,4469,'./changedate_due_tam.php'),(20796732,4467,'./changedate_due_tam.php'),(20796731,4346,'./changedate_due_tam.php'),(20796730,4466,'./changedate_due_tam.php'),(20796729,4465,'./changedate_due_tam.php'),(20796728,4464,'./changedate_due_tam.php'),(20796727,4476,'./changedate_due.php'),(20796726,4475,'./changedate_due.php'),(20796725,3256,'./changedate_due.php'),(20796724,5152,'./changedate_due.php'),(20796723,2234,'./changedate_due.php'),(20796722,5151,'./changedate_due.php'),(20796721,4471,'./changedate_due.php'),(20796720,4470,'./changedate_due.php'),(20796719,5150,'./changedate_due.php'),(20796718,5149,'./changedate_due.php'),(20796717,5148,'./changedate_due.php'),(20796716,4465,'./changedate_due.php'),(20796715,5147,'./changedate_due.php'),(20796714,2529,'./calcimp.php'),(20796713,4479,'./calcimp.php'),(20796712,4478,'./calcimp.php'),(20796711,4443,'./calcimp.php'),(20796710,1592,'./calcimp.php'),(20796709,7269,'./bom_list.php'),(20796708,3274,'./bom_list.php'),(20796707,2948,'./bom_list.php'),(20796706,7264,'./bom_list.php'),(20796705,7263,'./bom_list.php'),(20796704,2529,'./bom_list.php'),(20796703,2292,'./bom_list.php'),(20796702,2228,'./bom_list.php'),(20796701,2044,'./bom_list.php'),(20796700,1963,'./bom_list.php'),(20796699,6986,'./bom_list.php'),(20796698,7258,'./bom_list.php'),(20796697,7453,'./bom_list.php'),(20796696,6434,'./bom_list.php'),(20796695,1709,'./bom_list.php'),(20796694,7251,'./bom_list.php'),(20796693,869,'./bom_list.php'),(20796692,542,'./bom_list.php'),(20796691,315,'./bom_list.php'),(20796690,55,'./bom_list.php'),(20796689,2702,'./bom_entry_or_update_details.php'),(20796688,1499,'./bom_entry_or_update_details.php'),(20796687,4346,'./bom_entry_or_update_details.php'),(20796686,13575,'./bom_entry_or_update_details.php'),(20796685,869,'./bom_entry_or_update_details.php'),(20796684,13574,'./bom_entry_or_update_details.php'),(20796683,13572,'./bom_entry_or_update_details.php'),(20796682,7269,'./bom_entry_or_update.php'),(20796681,7268,'./bom_entry_or_update.php'),(20796680,3274,'./bom_entry_or_update.php'),(20796679,7267,'./bom_entry_or_update.php'),(20796678,7266,'./bom_entry_or_update.php'),(20796677,7265,'./bom_entry_or_update.php'),(20796676,2979,'./bom_entry_or_update.php'),(20796675,2948,'./bom_entry_or_update.php'),(20796674,2765,'./bom_entry_or_update.php'),(20796673,7264,'./bom_entry_or_update.php'),(20796672,2702,'./bom_entry_or_update.php'),(20796671,7263,'./bom_entry_or_update.php'),(20796670,2529,'./bom_entry_or_update.php'),(20796669,2508,'./bom_entry_or_update.php'),(20796668,2292,'./bom_entry_or_update.php'),(20796667,7262,'./bom_entry_or_update.php'),(20796666,2228,'./bom_entry_or_update.php'),(20796665,2044,'./bom_entry_or_update.php'),(20796664,1963,'./bom_entry_or_update.php'),(20796663,7261,'./bom_entry_or_update.php'),(20796662,7260,'./bom_entry_or_update.php'),(20796661,7259,'./bom_entry_or_update.php'),(20796660,6986,'./bom_entry_or_update.php'),(20796659,7258,'./bom_entry_or_update.php'),(20796658,1775,'./bom_entry_or_update.php'),(20796657,1770,'./bom_entry_or_update.php'),(20796656,6434,'./bom_entry_or_update.php'),(20796655,7257,'./bom_entry_or_update.php'),(20796654,6366,'./bom_entry_or_update.php'),(20796653,1724,'./bom_entry_or_update.php'),(20796652,1709,'./bom_entry_or_update.php'),(20796651,4130,'./bom_entry_or_update.php'),(20796650,7256,'./bom_entry_or_update.php'),(20796649,7255,'./bom_entry_or_update.php'),(20796648,7254,'./bom_entry_or_update.php'),(20796647,5271,'./bom_entry_or_update.php'),(20796646,7251,'./bom_entry_or_update.php'),(20796645,7250,'./bom_entry_or_update.php'),(20796644,7249,'./bom_entry_or_update.php'),(20796643,7870,'./bom_entry_or_update.php'),(20796642,941,'./bom_entry_or_update.php'),(20796641,869,'./bom_entry_or_update.php'),(20796640,799,'./bom_entry_or_update.php'),(20796639,542,'./bom_entry_or_update.php'),(20796638,7248,'./bom_entry_or_update.php'),(20796637,7246,'./bom_entry_or_update.php'),(20796636,7245,'./bom_entry_or_update.php'),(20796635,315,'./bom_entry_or_update.php'),(20796634,5203,'./bom_entry_or_update.php'),(20796633,5570,'./bom_entry_or_update.php'),(20796632,7244,'./bom_entry_or_update.php'),(20796631,7243,'./bom_entry_or_update.php'),(20796630,13562,'./bom_entry_or_update.php'),(20796629,7242,'./bom_entry_or_update.php'),(20796628,55,'./bom_entry_or_update.php'),(20796627,3427,'./barlabelfpdf.php'),(20796626,2508,'./barlabelfpdf.php'),(20796625,2182,'./barlabelfpdf.php'),(20796624,8936,'./barlabelfpdf.php'),(20796623,542,'./barlabelfpdf.php'),(20796622,11728,'./barlabelfpdf.php'),(20796620,5451,'./bankaccountaddupdate.php'),(20796619,7774,'./bankaccountaddupdate.php'),(20796618,5421,'./bankaccountaddupdate.php'),(20796617,5450,'./bankaccountaddupdate.php'),(20796616,5449,'./bankaccountaddupdate.php'),(20796615,2702,'./bankaccountaddupdate.php'),(20796614,5448,'./bankaccountaddupdate.php'),(20796613,5447,'./bankaccountaddupdate.php'),(20796612,5446,'./bankaccountaddupdate.php'),(20796611,6052,'./bankaccountaddupdate.php'),(20796610,7773,'./bankaccountaddupdate.php'),(20796609,7772,'./bankaccountaddupdate.php'),(20796608,7771,'./bankaccountaddupdate.php'),(20796607,5445,'./bankaccountaddupdate.php'),(20796606,7770,'./bankaccountaddupdate.php'),(20796605,7769,'./bankaccountaddupdate.php'),(20796604,1471,'./bankaccountaddupdate.php'),(20796603,7768,'./bankaccountaddupdate.php'),(20796602,13739,'./bankaccountaddupdate.php'),(20796601,1047,'./bankaccountaddupdate.php'),(20796600,7767,'./bankaccountaddupdate.php'),(20796599,7766,'./bankaccountaddupdate.php'),(20796598,7765,'./bankaccountaddupdate.php'),(20796597,13738,'./bankaccountaddupdate.php'),(20796596,941,'./bankaccountaddupdate.php'),(20796595,7764,'./bankaccountaddupdate.php'),(20796594,5453,'./bankaccountaddupdate.php'),(20796593,799,'./bankaccountaddupdate.php'),(20796592,5444,'./bankaccountaddupdate.php'),(20796591,542,'./bankaccountaddupdate.php'),(20796590,541,'./bankaccountaddupdate.php'),(20796589,503,'./bankaccountaddupdate.php'),(20796588,479,'./bankaccountaddupdate.php'),(20796587,5443,'./bankaccountaddupdate.php'),(20796586,5442,'./bankaccountaddupdate.php'),(20796585,5441,'./bankaccountaddupdate.php'),(20796584,5440,'./bankaccountaddupdate.php'),(20796583,5439,'./bankaccountaddupdate.php'),(20796582,7763,'./bankaccountaddupdate.php'),(20796581,5438,'./bankaccountaddupdate.php'),(20796580,5437,'./bankaccountaddupdate.php'),(20796579,5436,'./bankaccountaddupdate.php'),(20796578,5435,'./bankaccountaddupdate.php'),(20796577,5434,'./bankaccountaddupdate.php'),(20796576,5433,'./bankaccountaddupdate.php'),(20796575,5432,'./bankaccountaddupdate.php'),(20796574,5431,'./bankaccountaddupdate.php'),(20796573,5430,'./bankaccountaddupdate.php'),(20796572,315,'./bankaccountaddupdate.php'),(20796571,4871,'./bankaccountaddupdate.php'),(20796570,59,'./bankaccountaddupdate.php'),(20796569,5429,'./bankaccountaddupdate.php'),(20796568,5428,'./bankaccountaddupdate.php'),(20796567,5427,'./bankaccountaddupdate.php'),(20674200,3292,'./av_airportsadd.php'),(20674199,7627,'./av_airportsadd.php'),(20674198,7626,'./av_airportsadd.php'),(20674197,3016,'./av_airportsadd.php'),(20674196,2710,'./av_airportsadd.php'),(20674195,2702,'./av_airportsadd.php'),(20674194,7584,'./av_airportsadd.php'),(20674193,7583,'./av_airportsadd.php'),(20674192,2665,'./av_airportsadd.php'),(20674191,8041,'./av_airportsadd.php'),(20674190,8040,'./av_airportsadd.php'),(20674189,7582,'./av_airportsadd.php'),(20674188,8039,'./av_airportsadd.php'),(20674187,8038,'./av_airportsadd.php'),(20674186,7581,'./av_airportsadd.php'),(20674185,6292,'./av_airportsadd.php'),(20674184,6308,'./av_airportsadd.php'),(20674183,869,'./av_airportsadd.php'),(20674182,7580,'./av_airportsadd.php'),(20674181,7579,'./av_airportsadd.php'),(20674180,7578,'./av_airportsadd.php'),(20674179,7577,'./av_airportsadd.php'),(20674178,315,'./av_airportsadd.php'),(20674177,7585,'./av_airportsadd.php'),(20674176,6287,'./av_airportsadd.php'),(20674175,7575,'./av_airportsadd.php'),(20674174,7574,'./av_airportsadd.php'),(20674173,6285,'./av_airportsadd.php'),(20674172,6277,'./av_airportsadd.php'),(20674171,176,'./av_airportsadd.php'),(20674170,59,'./av_airportsadd.php'),(20674169,7237,'./av_airports_resrpt.php'),(20674168,2686,'./av_airports_resrpt.php'),(20674167,7604,'./av_airports_resrpt.php'),(20674166,7603,'./av_airports_resrpt.php'),(20674165,7602,'./av_airports_resrpt.php'),(20674164,7601,'./av_airports_resrpt.php'),(20674163,7600,'./av_airports_resrpt.php'),(20674162,7599,'./av_airports_resrpt.php'),(20674161,1963,'./av_airports_resrpt.php'),(20674160,7598,'./av_airports_resrpt.php'),(20674159,4106,'./av_airports_resrpt.php'),(20674158,7581,'./av_airports_resrpt.php'),(20674157,7597,'./av_airports_resrpt.php'),(20674156,8049,'./av_airports_resrpt.php'),(20674155,1036,'./av_airports_resrpt.php'),(20674154,8048,'./av_airports_resrpt.php'),(20674153,7596,'./av_airports_resrpt.php'),(20674152,7595,'./av_airports_resrpt.php'),(20674151,7594,'./av_airports_resrpt.php'),(20674150,697,'./av_airports_resrpt.php'),(20674149,7593,'./av_airports_resrpt.php'),(20674148,7592,'./av_airports_resrpt.php'),(20674147,7591,'./av_airports_resrpt.php'),(20674146,7590,'./av_airports_resrpt.php'),(20674145,197,'./av_airports_resrpt.php'),(20674144,7589,'./av_airports_resrpt.php'),(20674143,7588,'./av_airports_resrpt.php'),(20674142,6265,'./av_airports_resrpt.php'),(20674141,6514,'./av_airports_resrpt.php'),(20674140,3292,'./av_airports.php'),(20674139,3202,'./av_airports.php'),(20674138,7627,'./av_airports.php'),(20674137,7626,'./av_airports.php'),(20674136,3016,'./av_airports.php'),(20674135,2710,'./av_airports.php'),(20674134,2702,'./av_airports.php'),(20674133,7584,'./av_airports.php'),(20674132,7583,'./av_airports.php'),(20674131,2665,'./av_airports.php'),(20674130,8041,'./av_airports.php'),(20674129,8040,'./av_airports.php'),(20674128,7582,'./av_airports.php'),(20674127,8039,'./av_airports.php'),(20674126,8038,'./av_airports.php'),(20674125,7581,'./av_airports.php'),(20674124,5214,'./av_airports.php'),(20674123,6308,'./av_airports.php'),(20674122,966,'./av_airports.php'),(20674121,941,'./av_airports.php'),(20674120,869,'./av_airports.php'),(20674119,808,'./av_airports.php'),(20674118,799,'./av_airports.php'),(20674117,7580,'./av_airports.php'),(20674116,7579,'./av_airports.php'),(20674115,7578,'./av_airports.php'),(20674114,7577,'./av_airports.php'),(20674113,315,'./av_airports.php'),(20674112,5203,'./av_airports.php'),(20674111,7576,'./av_airports.php'),(20674110,6287,'./av_airports.php'),(20674109,7575,'./av_airports.php'),(20674108,7574,'./av_airports.php'),(20674107,6285,'./av_airports.php'),(20674106,6277,'./av_airports.php'),(20674105,87,'./av_airports.php'),(20674104,59,'./av_airports.php'),(20674103,2710,'./av_airport_servicetypeadd.php'),(20674102,2702,'./av_airport_servicetypeadd.php'),(20674101,1935,'./av_airport_servicetypeadd.php'),(20674100,3994,'./av_airport_servicetypeadd.php'),(20674099,451,'./av_airport_servicetypeadd.php'),(20674098,315,'./av_airport_servicetypeadd.php'),(20674097,222,'./av_airport_servicetypeadd.php'),(20674096,6299,'./av_airport_servicetypeadd.php'),(20674095,6298,'./av_airport_servicetypeadd.php'),(20674094,176,'./av_airport_servicetypeadd.php'),(20674093,59,'./av_airport_servicetypeadd.php'),(20674092,3202,'./av_airport_services_category.php'),(20674091,6293,'./av_airport_services_category.php'),(20674090,2710,'./av_airport_services_category.php'),(20674089,2702,'./av_airport_services_category.php'),(20674088,6289,'./av_airport_services_category.php'),(20674087,5214,'./av_airport_services_category.php'),(20674086,966,'./av_airport_services_category.php'),(20674085,941,'./av_airport_services_category.php'),(20674084,808,'./av_airport_services_category.php'),(20674083,799,'./av_airport_services_category.php'),(20674082,457,'./av_airport_services_category.php'),(20674081,315,'./av_airport_services_category.php'),(20674080,5203,'./av_airport_services_category.php'),(20674079,222,'./av_airport_services_category.php'),(20674078,6297,'./av_airport_services_category.php'),(20674077,87,'./av_airport_services_category.php'),(20674076,59,'./av_airport_services_category.php'),(20674075,6306,'./av_airport_services.php'),(20674074,2801,'./av_airport_services.php'),(20674073,2710,'./av_airport_services.php'),(20674072,2702,'./av_airport_services.php'),(20674071,2404,'./av_airport_services.php'),(20674070,6271,'./av_airport_services.php'),(20674069,6270,'./av_airport_services.php'),(20674068,966,'./av_airport_services.php'),(20674067,941,'./av_airport_services.php'),(20674066,808,'./av_airport_services.php'),(20674065,315,'./av_airport_services.php'),(20674064,5203,'./av_airport_services.php'),(20674063,7573,'./av_airport_services.php'),(20674062,7571,'./av_airport_services.php'),(20674061,6295,'./av_airport_services.php'),(20674060,3202,'./av_airport_service_type.php'),(20674059,5509,'./av_airport_service_type.php'),(20674058,2710,'./av_airport_service_type.php'),(20674057,2702,'./av_airport_service_type.php'),(20674056,1935,'./av_airport_service_type.php'),(20674055,6289,'./av_airport_service_type.php'),(20674054,5214,'./av_airport_service_type.php'),(20674053,966,'./av_airport_service_type.php'),(20674052,941,'./av_airport_service_type.php'),(20674051,808,'./av_airport_service_type.php'),(20674050,799,'./av_airport_service_type.php'),(20674049,451,'./av_airport_service_type.php'),(20674048,315,'./av_airport_service_type.php'),(20674047,5203,'./av_airport_service_type.php'),(20674046,222,'./av_airport_service_type.php'),(20674045,6294,'./av_airport_service_type.php'),(20674044,87,'./av_airport_service_type.php'),(20674043,59,'./av_airport_service_type.php'),(20674042,6293,'./av_airport_service_categoryadd.php'),(20674041,2710,'./av_airport_service_categoryadd.php'),(20674040,2702,'./av_airport_service_categoryadd.php'),(20674039,3994,'./av_airport_service_categoryadd.php'),(20674038,457,'./av_airport_service_categoryadd.php'),(20674037,315,'./av_airport_service_categoryadd.php'),(20674036,222,'./av_airport_service_categoryadd.php'),(20674035,6290,'./av_airport_service_categoryadd.php'),(20674034,176,'./av_airport_service_categoryadd.php'),(20674033,59,'./av_airport_service_categoryadd.php'),(20674032,3421,'./av_airport_rptcommission.php'),(20674031,2225,'./av_airport_rptcommission.php'),(20674030,6845,'./av_airport_rptcommission.php'),(20674029,1973,'./av_airport_rptcommission.php'),(20674028,1963,'./av_airport_rptcommission.php'),(20674027,1678,'./av_airport_rptcommission.php'),(20674026,4106,'./av_airport_rptcommission.php'),(20674025,1014,'./av_airport_rptcommission.php'),(20674024,931,'./av_airport_rptcommission.php'),(20674023,869,'./av_airport_rptcommission.php'),(20674022,737,'./av_airport_rptcommission.php'),(20674021,6844,'./av_airport_rptcommission.php'),(20674020,591,'./av_airport_rptcommission.php'),(20674019,504,'./av_airport_rptcommission.php'),(20674018,333,'./av_airport_rptcommission.php'),(20674017,315,'./av_airport_rptcommission.php'),(20674016,226,'./av_airport_rptcommission.php'),(20674015,6363,'./av_airport_rptcommission.php'),(20674014,6843,'./av_airport_rptcommission.php'),(20674013,6513,'./av_airport_rptcommission.php'),(20674012,3520,'./av_airport_rptcommission.php'),(20674011,7762,'./av_airport_parking_fees.php'),(20674010,7761,'./av_airport_parking_fees.php'),(20674009,2710,'./av_airport_parking_fees.php'),(20674008,2702,'./av_airport_parking_fees.php'),(20674007,6271,'./av_airport_parking_fees.php'),(20674006,6305,'./av_airport_parking_fees.php'),(20674005,6270,'./av_airport_parking_fees.php'),(20674004,966,'./av_airport_parking_fees.php'),(20674003,941,'./av_airport_parking_fees.php'),(20674002,4973,'./av_airport_parking_fees.php'),(20674001,315,'./av_airport_parking_fees.php'),(20674000,7572,'./av_airport_parking_fees.php'),(20673999,7571,'./av_airport_parking_fees.php'),(20673998,6304,'./av_airport_parking_fees.php'),(20673997,6303,'./av_airport_parking_fees.php'),(20796566,2165,'./autofunctionsdb.php'),(20796565,9259,'./autofunctionsdb.php'),(20796562,5588,'./autofunctions.php'),(20796561,3333,'./autofunctions.php'),(20796560,3274,'./autofunctions.php'),(20796559,3252,'./autofunctions.php'),(20796558,3165,'./autofunctions.php'),(20796557,11704,'./autofunctions.php'),(20796556,3035,'./autofunctions.php'),(20796555,2936,'./autofunctions.php'),(20796554,14559,'./autofunctions.php'),(20796553,2819,'./autofunctions.php'),(20796552,19448,'./autofunctions.php'),(20796551,2686,'./autofunctions.php'),(20796550,3961,'./autofunctions.php'),(20796549,2700,'./autofunctions.php'),(20796548,17904,'./autofunctions.php'),(20796547,2540,'./autofunctions.php'),(20796546,8959,'./autofunctions.php'),(20796545,2376,'./autofunctions.php'),(20796544,2361,'./autofunctions.php'),(20796543,2165,'./autofunctions.php'),(20796542,16330,'./autofunctions.php'),(20796541,1963,'./autofunctions.php'),(20796540,10658,'./autofunctions.php'),(20796539,10991,'./autofunctions.php'),(20796538,5081,'./autofunctions.php'),(20796519,3311,'./arvendb2buser.php'),(20796518,3310,'./arvendb2buser.php'),(20796517,3292,'./arvendb2buser.php'),(20796516,6404,'./arvendb2buser.php'),(20796515,3274,'./arvendb2buser.php'),(20796514,3264,'./arvendb2buser.php'),(20796513,3256,'./arvendb2buser.php'),(20796512,3254,'./arvendb2buser.php'),(20796511,3202,'./arvendb2buser.php'),(20796510,2756,'./arvendb2buser.php'),(20796509,2710,'./arvendb2buser.php'),(20796508,2702,'./arvendb2buser.php'),(20796507,2234,'./arvendb2buser.php'),(20796506,1963,'./arvendb2buser.php'),(20796505,1937,'./arvendb2buser.php'),(20796504,4469,'./arvendb2buser.php'),(20796503,1758,'./arvendb2buser.php'),(20796502,1634,'./arvendb2buser.php'),(20796501,1622,'./arvendb2buser.php'),(20796500,1429,'./arvendb2buser.php'),(20796499,965,'./arvendb2buser.php'),(20796498,941,'./arvendb2buser.php'),(20796497,6421,'./arvendb2buser.php'),(20796496,807,'./arvendb2buser.php'),(20796495,864,'./arvendb2buser.php'),(20796494,799,'./arvendb2buser.php'),(20796493,315,'./arvendb2buser.php'),(20796492,4871,'./arvendb2buser.php'),(20796491,144,'./arvendb2buser.php'),(20796490,78,'./arvendb2buser.php'),(20796489,59,'./arvendb2buser.php'),(20796488,6453,'./arvendb2buser.php'),(20796487,6494,'./arvendb2buser.php'),(20796486,3427,'./arstateviewfpdf.php'),(20796485,9252,'./arstateviewfpdf.php'),(20796484,6257,'./arstateviewfpdf.php'),(20796483,15941,'./arstateviewfpdf.php'),(20796482,5687,'./arstateviewfpdf.php'),(20796481,5686,'./arstateviewfpdf.php'),(20796480,13951,'./arstateviewfpdf.php'),(20796479,1998,'./arstateviewfpdf.php'),(20796478,1963,'./arstateviewfpdf.php'),(20796477,5685,'./arstateviewfpdf.php'),(20796476,1792,'./arstateviewfpdf.php'),(20796475,1467,'./arstateviewfpdf.php'),(20796474,15939,'./arstateviewfpdf.php'),(20796473,8936,'./arstateviewfpdf.php'),(20796472,5684,'./arstateviewfpdf.php'),(20796471,6253,'./arstateviewfpdf.php'),(20796470,982,'./arstateviewfpdf.php'),(20796469,9224,'./arstateviewfpdf.php'),(20796468,15938,'./arstateviewfpdf.php'),(20796467,542,'./arstateviewfpdf.php'),(20796466,6252,'./arstateviewfpdf.php'),(20796463,3427,'./arstateview_simplefpdf.php'),(20796462,6259,'./arstateview_simplefpdf.php'),(20796461,3090,'./arstateview_simplefpdf.php'),(20796460,9252,'./arstateview_simplefpdf.php'),(20796459,8222,'./arstateview_simplefpdf.php'),(20796458,6257,'./arstateview_simplefpdf.php'),(20796457,5687,'./arstateview_simplefpdf.php'),(20796456,5686,'./arstateview_simplefpdf.php'),(20796455,13951,'./arstateview_simplefpdf.php'),(20796454,2363,'./arstateview_simplefpdf.php'),(20796453,2361,'./arstateview_simplefpdf.php'),(20796452,2324,'./arstateview_simplefpdf.php'),(20796451,2225,'./arstateview_simplefpdf.php'),(20796450,2222,'./arstateview_simplefpdf.php'),(20796449,6839,'./arstateview_simplefpdf.php'),(20796448,1963,'./arstateview_simplefpdf.php'),(20796447,5685,'./arstateview_simplefpdf.php'),(20796446,6234,'./arstateview_simplefpdf.php'),(20796445,1678,'./arstateview_simplefpdf.php'),(20796444,6838,'./arstateview_simplefpdf.php'),(20796443,1625,'./arstateview_simplefpdf.php'),(20796442,1467,'./arstateview_simplefpdf.php'),(20796441,1373,'./arstateview_simplefpdf.php'),(20796440,8936,'./arstateview_simplefpdf.php'),(20796439,6254,'./arstateview_simplefpdf.php'),(20796438,5684,'./arstateview_simplefpdf.php'),(20796437,6253,'./arstateview_simplefpdf.php'),(20796436,982,'./arstateview_simplefpdf.php'),(20796435,9224,'./arstateview_simplefpdf.php'),(20796434,869,'./arstateview_simplefpdf.php'),(20796433,737,'./arstateview_simplefpdf.php'),(20796432,719,'./arstateview_simplefpdf.php'),(20796431,14880,'./arstateview_simplefpdf.php'),(20796430,683,'./arstateview_simplefpdf.php'),(20796429,542,'./arstateview_simplefpdf.php'),(20796428,6252,'./arstateview_simplefpdf.php'),(20796427,6251,'./arstateview_simplefpdf.php'),(20796426,325,'./arstateview_simplefpdf.php'),(20796425,306,'./arstateview_simplefpdf.php'),(20796424,6250,'./arstateview_simplefpdf.php'),(20796423,20,'./arstateview_simplefpdf.php'),(20796422,4039,'./arstateview_simplefpdf.php'),(20796421,9289,'./arstateview_simplefpdf.php'),(20796420,4037,'./arstateview_simplefpdf.php'),(20796419,3072,'./arstateview_detailfpdf.php'),(20796418,8222,'./arstateview_detailfpdf.php'),(20796417,6257,'./arstateview_detailfpdf.php'),(20796416,2508,'./arstateview_detailfpdf.php'),(20796415,3471,'./arstateview_detailfpdf.php'),(20796414,2222,'./arstateview_detailfpdf.php'),(20796413,14558,'./arstateview_detailfpdf.php'),(20796412,1668,'./arstateview_detailfpdf.php'),(20796411,14012,'./arstateview_detailfpdf.php'),(20796410,8936,'./arstateview_detailfpdf.php'),(20796409,869,'./arstateview_detailfpdf.php'),(20796408,776,'./arstateview_detailfpdf.php'),(20796407,737,'./arstateview_detailfpdf.php'),(20796406,670,'./arstateview_detailfpdf.php'),(20796405,4005,'./arstateview_detailfpdf.php'),(20796404,14368,'./arstateview_detailfpdf.php'),(20796403,14367,'./arstateview_detailfpdf.php'),(20796402,14366,'./arstateview_detailfpdf.php'),(20796401,14365,'./arstateview_detailfpdf.php'),(20796400,14364,'./arstateview_detailfpdf.php'),(20796399,339,'./arstateview_detailfpdf.php'),(20796398,325,'./arstateview_detailfpdf.php'),(20796397,227,'./arstateview_detailfpdf.php'),(20796396,6682,'./arstateview_detailfpdf.php'),(20796395,4713,'./arstateview_detailfpdf.php'),(20796394,30,'./arstateview_detailfpdf.php'),(20796393,3427,'./arstateview_altfpdf.php'),(20796392,6259,'./arstateview_altfpdf.php'),(20796391,3090,'./arstateview_altfpdf.php'),(20796390,9252,'./arstateview_altfpdf.php'),(20796389,8222,'./arstateview_altfpdf.php'),(20796388,6257,'./arstateview_altfpdf.php'),(20796387,5687,'./arstateview_altfpdf.php'),(20796386,5686,'./arstateview_altfpdf.php'),(20796385,13951,'./arstateview_altfpdf.php'),(20796384,2324,'./arstateview_altfpdf.php'),(20796383,2225,'./arstateview_altfpdf.php'),(20796382,2222,'./arstateview_altfpdf.php'),(20796381,6839,'./arstateview_altfpdf.php'),(20796380,1963,'./arstateview_altfpdf.php'),(20796379,5685,'./arstateview_altfpdf.php'),(20796378,6234,'./arstateview_altfpdf.php'),(20796377,1678,'./arstateview_altfpdf.php'),(20796376,13069,'./arstateview_altfpdf.php'),(20796375,1467,'./arstateview_altfpdf.php'),(20796374,1373,'./arstateview_altfpdf.php'),(20796373,8936,'./arstateview_altfpdf.php'),(20796372,5684,'./arstateview_altfpdf.php'),(20796371,6253,'./arstateview_altfpdf.php'),(20796370,982,'./arstateview_altfpdf.php'),(20796369,9224,'./arstateview_altfpdf.php'),(20796368,931,'./arstateview_altfpdf.php'),(20796367,869,'./arstateview_altfpdf.php'),(20796366,737,'./arstateview_altfpdf.php'),(20796365,719,'./arstateview_altfpdf.php'),(20796364,683,'./arstateview_altfpdf.php'),(20796363,542,'./arstateview_altfpdf.php'),(20796362,6252,'./arstateview_altfpdf.php'),(20796361,6251,'./arstateview_altfpdf.php'),(20796360,325,'./arstateview_altfpdf.php'),(20796359,306,'./arstateview_altfpdf.php'),(20796358,6250,'./arstateview_altfpdf.php'),(20796357,8373,'./arstateview_altfpdf.php'),(20796356,226,'./arstateview_altfpdf.php'),(20796355,20,'./arstateview_altfpdf.php'),(20796354,4039,'./arstateview_altfpdf.php'),(20796353,4037,'./arstateview_altfpdf.php'),(20796352,3225,'./arservicetypeupd.php'),(20796351,5514,'./arservicetypeupd.php'),(20796350,5509,'./arservicetypeupd.php'),(20796349,2710,'./arservicetypeupd.php'),(20796348,2702,'./arservicetypeupd.php'),(20796347,2673,'./arservicetypeupd.php'),(20796346,6435,'./arservicetypeupd.php'),(20796345,8058,'./arservicetypeupd.php'),(20796344,3995,'./arservicetypeupd.php'),(20796343,1143,'./arservicetypeupd.php'),(20796342,941,'./arservicetypeupd.php'),(20796341,831,'./arservicetypeupd.php'),(20796340,864,'./arservicetypeupd.php'),(20796339,799,'./arservicetypeupd.php'),(20796338,17009,'./arservicetypeupd.php'),(20796337,17008,'./arservicetypeupd.php'),(20796336,315,'./arservicetypeupd.php'),(20796332,5513,'./arservicetypeadd.php'),(20796331,7760,'./arservicetypeadd.php'),(20796330,5509,'./arservicetypeadd.php'),(20796329,2702,'./arservicetypeadd.php'),(20796328,2673,'./arservicetypeadd.php'),(20796327,6435,'./arservicetypeadd.php'),(20796326,8057,'./arservicetypeadd.php'),(20796325,3994,'./arservicetypeadd.php'),(20796324,17009,'./arservicetypeadd.php'),(20796320,9533,'./arservicesubtype.php'),(20796319,4290,'./arservicesubtype.php'),(20796318,9532,'./arservicesubtype.php'),(20796317,9531,'./arservicesubtype.php'),(20796316,9530,'./arservicesubtype.php'),(20796315,9529,'./arservicesubtype.php'),(20796314,9528,'./arservicesubtype.php'),(20796313,2702,'./arservicesubtype.php'),(20796312,2673,'./arservicesubtype.php'),(20796311,9527,'./arservicesubtype.php'),(20796310,8057,'./arservicesubtype.php'),(20796309,9526,'./arservicesubtype.php'),(20796308,8309,'./arservicesubtype.php'),(20796307,799,'./arservicesubtype.php'),(20796306,315,'./arservicesubtype.php'),(20796305,8125,'./arservicesubtype.php'),(20796304,9525,'./arservicesubtype.php'),(20796303,9524,'./arservicesubtype.php'),(20796302,59,'./arservicesubtype.php'),(20796301,3225,'./arservicerates.php'),(20796300,5509,'./arservicerates.php'),(20796299,7924,'./arservicerates.php'),(20796298,5506,'./arservicerates.php'),(20796297,2710,'./arservicerates.php'),(20796296,2702,'./arservicerates.php'),(20796295,5511,'./arservicerates.php'),(20796294,12197,'./arservicerates.php'),(20796293,5510,'./arservicerates.php'),(20796292,3995,'./arservicerates.php'),(20796291,9823,'./arserviceordworkdetails.php'),(20796290,9822,'./arserviceordworkdetails.php'),(20796289,2710,'./arserviceordworkdetails.php'),(20796288,2702,'./arserviceordworkdetails.php'),(20796287,2165,'./arserviceordworkdetails.php'),(20796286,541,'./arserviceordworkdetails.php'),(20796285,14793,'./arserviceordupd.php'),(20796284,19877,'./arserviceordupd.php'),(20796283,3381,'./arserviceordupd.php'),(20796282,8093,'./arserviceordupd.php'),(20796281,5617,'./arserviceordupd.php'),(20796280,8090,'./arserviceordupd.php'),(20796279,7196,'./arserviceordupd.php'),(20796278,19257,'./arserviceordupd.php'),(20796277,14555,'./arserviceordupd.php'),(20796276,5378,'./arserviceordupd.php'),(20796275,3324,'./arserviceordupd.php'),(20796274,15256,'./arserviceordupd.php'),(20796273,3165,'./arserviceordupd.php'),(20796272,3156,'./arserviceordupd.php'),(20796271,7759,'./arserviceordupd.php'),(20796270,6060,'./arserviceordupd.php'),(20796269,7756,'./arserviceordupd.php'),(20796268,3118,'./arserviceordupd.php'),(20796267,3090,'./arserviceordupd.php'),(20796266,8092,'./arserviceordupd.php'),(20796265,6837,'./arserviceordupd.php'),(20796264,5654,'./arserviceordupd.php'),(20796263,11114,'./arserviceordupd.php'),(20796262,13107,'./arserviceordupd.php'),(20796261,3030,'./arserviceordupd.php'),(20796260,2998,'./arserviceordupd.php'),(20796259,2977,'./arserviceordupd.php'),(20796258,2948,'./arserviceordupd.php'),(20796257,16383,'./arserviceordupd.php'),(20796256,2849,'./arserviceordupd.php'),(20796255,2820,'./arserviceordupd.php'),(20796254,2819,'./arserviceordupd.php'),(20796253,2817,'./arserviceordupd.php'),(20796252,2838,'./arserviceordupd.php'),(20796251,2833,'./arserviceordupd.php'),(20796250,6770,'./arserviceordupd.php'),(20796249,5492,'./arserviceordupd.php'),(20796248,17134,'./arserviceordupd.php'),(20796247,2738,'./arserviceordupd.php'),(20796246,2710,'./arserviceordupd.php'),(20796245,6836,'./arserviceordupd.php'),(20796244,2702,'./arserviceordupd.php'),(20796243,3961,'./arserviceordupd.php'),(20796242,2665,'./arserviceordupd.php'),(20796241,2698,'./arserviceordupd.php'),(20796240,6738,'./arserviceordupd.php'),(20796239,2589,'./arserviceordupd.php'),(20796238,2586,'./arserviceordupd.php'),(20796237,19215,'./arserviceordupd.php'),(20796236,5633,'./arserviceordupd.php'),(20796235,2565,'./arserviceordupd.php'),(20796234,2529,'./arserviceordupd.php'),(20796233,2527,'./arserviceordupd.php'),(20796232,2501,'./arserviceordupd.php'),(20796231,2459,'./arserviceordupd.php'),(20796230,18276,'./arserviceordupd.php'),(20796229,2404,'./arserviceordupd.php'),(20796228,2363,'./arserviceordupd.php'),(20796227,7758,'./arserviceordupd.php'),(20796226,7755,'./arserviceordupd.php'),(20796225,5671,'./arserviceordupd.php'),(20796224,17876,'./arserviceordupd.php'),(20796223,2208,'./arserviceordupd.php'),(20796222,4008,'./arserviceordupd.php'),(20796221,2195,'./arserviceordupd.php'),(20796220,2182,'./arserviceordupd.php'),(20796219,4865,'./arserviceordupd.php'),(20796218,4850,'./arserviceordupd.php'),(20796217,4070,'./arserviceordupd.php'),(20796216,2170,'./arserviceordupd.php'),(20796215,6118,'./arserviceordupd.php'),(20796214,8091,'./arserviceordupd.php'),(20796213,2165,'./arserviceordupd.php'),(20796212,6773,'./arserviceordupd.php'),(20796211,2156,'./arserviceordupd.php'),(20796210,2151,'./arserviceordupd.php'),(20796209,18630,'./arserviceordupd.php'),(20796208,4608,'./arserviceordupd.php'),(20796207,2024,'./arserviceordupd.php'),(20796206,8002,'./arserviceordupd.php'),(20796205,14554,'./arserviceordupd.php'),(20796204,6117,'./arserviceordupd.php'),(20796203,2103,'./arserviceordupd.php'),(20796202,1963,'./arserviceordupd.php'),(20796201,5505,'./arserviceordupd.php'),(20796200,1884,'./arserviceordupd.php'),(20796199,18006,'./arserviceordupd.php'),(20796198,18005,'./arserviceordupd.php'),(20796197,18004,'./arserviceordupd.php'),(20796196,1775,'./arserviceordupd.php'),(20796195,1770,'./arserviceordupd.php'),(20796194,9167,'./arserviceordupd.php'),(20796193,5081,'./arserviceordupd.php'),(20796192,1727,'./arserviceordupd.php'),(20796191,9165,'./arserviceordupd.php'),(20796190,5652,'./arserviceordupd.php'),(20796189,17964,'./arserviceordupd.php'),(20796188,1647,'./arserviceordupd.php'),(20796187,18772,'./arserviceordupd.php'),(20796186,7683,'./arserviceordupd.php'),(20796185,1629,'./arserviceordupd.php'),(20796184,5339,'./arserviceordupd.php'),(20796183,1599,'./arserviceordupd.php'),(20796182,8086,'./arserviceordupd.php'),(20796181,8085,'./arserviceordupd.php'),(20796180,1564,'./arserviceordupd.php'),(20796179,15991,'./arserviceordupd.php'),(20796178,3481,'./arserviceordupd.php'),(20796177,19214,'./arserviceordupd.php'),(20796176,4083,'./arserviceordupd.php'),(20796175,8936,'./arserviceordupd.php'),(20796174,5214,'./arserviceordupd.php'),(20796173,1047,'./arserviceordupd.php'),(20796172,6116,'./arserviceordupd.php'),(20796171,9821,'./arserviceordupd.php'),(20796170,6115,'./arserviceordupd.php'),(20796169,967,'./arserviceordupd.php'),(20796168,16386,'./arserviceordupd.php'),(20796167,7877,'./arserviceordupd.php'),(20796166,941,'./arserviceordupd.php'),(20796165,931,'./arserviceordupd.php'),(20796164,11815,'./arserviceordupd.php'),(20796163,6736,'./arserviceordupd.php'),(20796162,869,'./arserviceordupd.php'),(20796161,5478,'./arserviceordupd.php'),(20796160,19267,'./arserviceordupd.php'),(20796159,799,'./arserviceordupd.php'),(20796158,9523,'./arserviceordupd.php'),(20796157,737,'./arserviceordupd.php'),(20796156,5477,'./arserviceordupd.php'),(20796155,3930,'./arserviceordupd.php'),(20796154,4481,'./arserviceordupd.php'),(20796153,6042,'./arserviceordupd.php'),(20796152,673,'./arserviceordupd.php'),(20796151,7623,'./arserviceordupd.php'),(20796150,3947,'./arserviceordupd.php'),(20796149,9492,'./arserviceordupd.php'),(20796148,13610,'./arserviceordupd.php'),(20796147,607,'./arserviceordupd.php'),(20796146,596,'./arserviceordupd.php'),(20796145,18048,'./arserviceordupd.php'),(20796144,542,'./arserviceordupd.php'),(20796143,5850,'./arserviceordupd.php'),(20796142,543,'./arserviceordupd.php'),(20796141,17133,'./arserviceordupd.php'),(20796140,17132,'./arserviceordupd.php'),(20796114,3427,'./arserviceordtickfpdf.php'),(20796113,5588,'./arserviceordtickfpdf.php'),(20796112,8092,'./arserviceordtickfpdf.php'),(20796111,5581,'./arserviceordtickfpdf.php'),(20796110,5225,'./arserviceordtickfpdf.php'),(20796109,5649,'./arserviceordtickfpdf.php'),(20796108,9251,'./arserviceordtickfpdf.php'),(20796107,5687,'./arserviceordtickfpdf.php'),(20796106,5686,'./arserviceordtickfpdf.php'),(20796105,2529,'./arserviceordtickfpdf.php'),(20796104,2361,'./arserviceordtickfpdf.php'),(20796103,2225,'./arserviceordtickfpdf.php'),(20796102,2222,'./arserviceordtickfpdf.php'),(20796101,1963,'./arserviceordtickfpdf.php'),(20796100,5685,'./arserviceordtickfpdf.php'),(20796099,6234,'./arserviceordtickfpdf.php'),(20796098,1781,'./arserviceordtickfpdf.php'),(20796097,1564,'./arserviceordtickfpdf.php'),(20796096,1467,'./arserviceordtickfpdf.php'),(20796095,1373,'./arserviceordtickfpdf.php'),(20796094,1036,'./arserviceordtickfpdf.php'),(20796093,5684,'./arserviceordtickfpdf.php'),(20796092,6058,'./arserviceordtickfpdf.php'),(20796091,982,'./arserviceordtickfpdf.php'),(20796090,9224,'./arserviceordtickfpdf.php'),(20796089,932,'./arserviceordtickfpdf.php'),(20796088,869,'./arserviceordtickfpdf.php'),(20796087,719,'./arserviceordtickfpdf.php'),(20796086,5477,'./arserviceordtickfpdf.php'),(20796085,697,'./arserviceordtickfpdf.php'),(20796084,5459,'./arserviceordtickfpdf.php'),(20796083,542,'./arserviceordtickfpdf.php'),(20796082,540,'./arserviceordtickfpdf.php'),(20796081,406,'./arserviceordtickfpdf.php'),(20796080,6057,'./arserviceordtickfpdf.php'),(20796079,302,'./arserviceordtickfpdf.php'),(20805465,2782,'./jobcostrpt.php'),(20805464,2751,'./jobcostrpt.php'),(20796537,1696,'./autofunctions.php'),(20796078,5588,'./arserviceordtick.php'),(20796077,8093,'./arserviceordtick.php'),(20796076,4298,'./arserviceordtick.php'),(20796075,3173,'./arserviceordtick.php'),(20796074,3118,'./arserviceordtick.php'),(20796073,3090,'./arserviceordtick.php'),(20796072,8092,'./arserviceordtick.php'),(20796071,2824,'./arserviceordtick.php'),(20796070,2819,'./arserviceordtick.php'),(20796069,5482,'./arserviceordtick.php'),(20796068,2565,'./arserviceordtick.php'),(20796067,2517,'./arserviceordtick.php'),(20796066,2501,'./arserviceordtick.php'),(20796065,9928,'./arserviceordtick.php'),(20796064,2459,'./arserviceordtick.php'),(20796063,2363,'./arserviceordtick.php'),(20796062,2290,'./arserviceordtick.php'),(20796061,2182,'./arserviceordtick.php'),(20796060,2173,'./arserviceordtick.php'),(20796059,2170,'./arserviceordtick.php'),(20796058,8091,'./arserviceordtick.php'),(20796057,5648,'./arserviceordtick.php'),(20796056,2094,'./arserviceordtick.php'),(20796055,1963,'./arserviceordtick.php'),(20796054,1776,'./arserviceordtick.php'),(20796053,1775,'./arserviceordtick.php'),(20796052,1773,'./arserviceordtick.php'),(20796051,1709,'./arserviceordtick.php'),(20796050,1647,'./arserviceordtick.php'),(20796049,8086,'./arserviceordtick.php'),(20796048,8085,'./arserviceordtick.php'),(20796047,5480,'./arserviceordtick.php'),(20796046,981,'./arserviceordtick.php'),(20796045,941,'./arserviceordtick.php'),(20796044,931,'./arserviceordtick.php'),(20796043,869,'./arserviceordtick.php'),(20796042,5590,'./arserviceordtick.php'),(20796041,5477,'./arserviceordtick.php'),(20796040,4481,'./arserviceordtick.php'),(20796039,8083,'./arserviceordtick.php'),(20796038,3427,'./arserviceordconfirmfpdf.php'),(20796037,3172,'./arserviceordconfirmfpdf.php'),(20796036,3090,'./arserviceordconfirmfpdf.php'),(20796035,3072,'./arserviceordconfirmfpdf.php'),(20796034,2998,'./arserviceordconfirmfpdf.php'),(20796033,2977,'./arserviceordconfirmfpdf.php'),(20796032,5225,'./arserviceordconfirmfpdf.php'),(20796031,2833,'./arserviceordconfirmfpdf.php'),(20796030,5687,'./arserviceordconfirmfpdf.php'),(20796029,5686,'./arserviceordconfirmfpdf.php'),(20796028,12851,'./arserviceordconfirmfpdf.php'),(20796027,4680,'./arserviceordconfirmfpdf.php'),(20796026,2529,'./arserviceordconfirmfpdf.php'),(20796025,9927,'./arserviceordconfirmfpdf.php'),(20796024,2363,'./arserviceordconfirmfpdf.php'),(20796023,2361,'./arserviceordconfirmfpdf.php'),(20796022,6249,'./arserviceordconfirmfpdf.php'),(20796021,2262,'./arserviceordconfirmfpdf.php'),(20796020,2225,'./arserviceordconfirmfpdf.php'),(20796019,2222,'./arserviceordconfirmfpdf.php'),(20796018,8990,'./arserviceordconfirmfpdf.php'),(20796017,2182,'./arserviceordconfirmfpdf.php'),(20796016,9249,'./arserviceordconfirmfpdf.php'),(20796015,1963,'./arserviceordconfirmfpdf.php'),(20796014,5685,'./arserviceordconfirmfpdf.php'),(20796013,6234,'./arserviceordconfirmfpdf.php'),(20796012,1781,'./arserviceordconfirmfpdf.php'),(20796011,6247,'./arserviceordconfirmfpdf.php'),(20796010,1678,'./arserviceordconfirmfpdf.php'),(20796009,1467,'./arserviceordconfirmfpdf.php'),(20796008,1373,'./arserviceordconfirmfpdf.php'),(20796007,8936,'./arserviceordconfirmfpdf.php'),(20796006,5684,'./arserviceordconfirmfpdf.php'),(20796005,9926,'./arserviceordconfirmfpdf.php'),(20796004,982,'./arserviceordconfirmfpdf.php'),(20796003,9224,'./arserviceordconfirmfpdf.php'),(20796002,981,'./arserviceordconfirmfpdf.php'),(20796001,869,'./arserviceordconfirmfpdf.php'),(20796000,744,'./arserviceordconfirmfpdf.php'),(20795999,719,'./arserviceordconfirmfpdf.php'),(20795998,5477,'./arserviceordconfirmfpdf.php'),(20795997,697,'./arserviceordconfirmfpdf.php'),(20795996,5459,'./arserviceordconfirmfpdf.php'),(20795995,542,'./arserviceordconfirmfpdf.php'),(20795994,9925,'./arserviceordconfirmfpdf.php'),(20795993,325,'./arserviceordconfirmfpdf.php'),(20795992,9924,'./arserviceordconfirmfpdf.php'),(20805463,12097,'./jobcostrpt.php'),(20796139,17131,'./arserviceordupd.php'),(20795991,14793,'./arserviceordadd.php'),(20795990,3371,'./arserviceordadd.php'),(20795989,2998,'./arserviceordadd.php'),(20795988,2820,'./arserviceordadd.php'),(20795987,2819,'./arserviceordadd.php'),(20795986,2838,'./arserviceordadd.php'),(20795985,5482,'./arserviceordadd.php'),(20795984,2702,'./arserviceordadd.php'),(20795983,2676,'./arserviceordadd.php'),(20795982,3961,'./arserviceordadd.php'),(20795981,2586,'./arserviceordadd.php'),(20795980,2501,'./arserviceordadd.php'),(20795979,2405,'./arserviceordadd.php'),(20795978,5917,'./arserviceordadd.php'),(20795977,5916,'./arserviceordadd.php'),(20795976,5915,'./arserviceordadd.php'),(20795975,5914,'./arserviceordadd.php'),(20795974,5913,'./arserviceordadd.php'),(20795973,4070,'./arserviceordadd.php'),(20795972,6118,'./arserviceordadd.php'),(20795971,6117,'./arserviceordadd.php'),(20795970,2103,'./arserviceordadd.php'),(20795969,1963,'./arserviceordadd.php'),(20795968,3706,'./arserviceordadd.php'),(20795967,1788,'./arserviceordadd.php'),(20795966,9276,'./arserviceordadd.php'),(20795965,5081,'./arserviceordadd.php'),(20795964,1647,'./arserviceordadd.php'),(20795963,1599,'./arserviceordadd.php'),(20795962,15991,'./arserviceordadd.php'),(20795961,1422,'./arserviceordadd.php'),(20795960,4083,'./arserviceordadd.php'),(20795959,1232,'./arserviceordadd.php'),(20795958,8936,'./arserviceordadd.php'),(20795957,6116,'./arserviceordadd.php'),(20795956,1012,'./arserviceordadd.php'),(20795955,6115,'./arserviceordadd.php'),(20795954,941,'./arserviceordadd.php'),(20795953,932,'./arserviceordadd.php'),(20795952,11815,'./arserviceordadd.php'),(20795951,9523,'./arserviceordadd.php'),(20795950,716,'./arserviceordadd.php'),(20795949,4481,'./arserviceordadd.php'),(20795948,697,'./arserviceordadd.php'),(20795947,9341,'./arserviceordadd.php'),(20795946,14879,'./arserviceordadd.php'),(20795945,9492,'./arserviceordadd.php'),(20795944,607,'./arserviceordadd.php'),(20795943,315,'./arserviceordadd.php'),(20795942,152,'./arserviceordadd.php'),(20795941,83,'./arserviceordadd.php'),(20795940,59,'./arserviceordadd.php'),(20795939,9828,'./arserviceordadd.php'),(20795938,15897,'./arserviceordadd.php'),(20795936,3225,'./arserviceclassupd.php'),(20795935,5508,'./arserviceclassupd.php'),(20795934,5506,'./arserviceclassupd.php'),(20795933,2710,'./arserviceclassupd.php'),(20795932,2702,'./arserviceclassupd.php'),(20795931,3995,'./arserviceclassupd.php'),(20795930,1143,'./arserviceclassupd.php'),(20795929,941,'./arserviceclassupd.php'),(20795928,831,'./arserviceclassupd.php'),(20795927,864,'./arserviceclassupd.php'),(20795926,799,'./arserviceclassupd.php'),(20795925,315,'./arserviceclassupd.php'),(20795924,5203,'./arserviceclassupd.php'),(20795923,111,'./arserviceclassupd.php'),(20795922,59,'./arserviceclassupd.php'),(20795921,5507,'./arserviceclassadd.php'),(20795920,7757,'./arserviceclassadd.php'),(20795919,5506,'./arserviceclassadd.php'),(20795918,2702,'./arserviceclassadd.php'),(20795917,3994,'./arserviceclassadd.php'),(20795916,315,'./arserviceclassadd.php'),(20795915,176,'./arserviceclassadd.php'),(20795914,14107,'./arserialcheck.php'),(20795913,4267,'./arserialcheck.php'),(20795912,2702,'./arserialcheck.php'),(20795911,2508,'./arserialcheck.php'),(20795910,14089,'./arserialcheck.php'),(20795909,1796,'./arserialcheck.php'),(20795908,1775,'./arserialcheck.php'),(20795907,14104,'./arserialcheck.php'),(20795906,1709,'./arserialcheck.php'),(20795905,11662,'./arserialcheck.php'),(20795901,2948,'./arrmashipview.php'),(20795900,5581,'./arrmashipview.php'),(20795899,2824,'./arrmashipview.php'),(20795898,2819,'./arrmashipview.php'),(20795897,14765,'./arrmashipview.php'),(20795896,2817,'./arrmashipview.php'),(20795895,2816,'./arrmashipview.php'),(20795894,2835,'./arrmashipview.php'),(20795893,2827,'./arrmashipview.php'),(20795892,4007,'./arrmashipview.php'),(20795891,6835,'./arrmashipview.php'),(20795890,6770,'./arrmashipview.php'),(20795889,6768,'./arrmashipview.php'),(20795888,6767,'./arrmashipview.php'),(20795887,6826,'./arrmashipview.php'),(20795886,2638,'./arrmashipview.php'),(20795885,6803,'./arrmashipview.php'),(20795884,6834,'./arrmashipview.php'),(20795883,2583,'./arrmashipview.php'),(20795882,2534,'./arrmashipview.php'),(20795881,6833,'./arrmashipview.php'),(20795880,2531,'./arrmashipview.php'),(20795879,2501,'./arrmashipview.php'),(20795878,7918,'./arrmashipview.php'),(20795877,2363,'./arrmashipview.php'),(20795876,5584,'./arrmashipview.php'),(20795875,2292,'./arrmashipview.php'),(20795874,2231,'./arrmashipview.php'),(20795873,4565,'./arrmashipview.php'),(20795872,2220,'./arrmashipview.php'),(20795871,2182,'./arrmashipview.php'),(20795870,2180,'./arrmashipview.php'),(20795869,2173,'./arrmashipview.php'),(20795868,2154,'./arrmashipview.php'),(20795867,4006,'./arrmashipview.php'),(20795866,2034,'./arrmashipview.php'),(20795865,2103,'./arrmashipview.php'),(20795864,1963,'./arrmashipview.php'),(20795863,1788,'./arrmashipview.php'),(20795862,1775,'./arrmashipview.php'),(20795861,6832,'./arrmashipview.php'),(20795860,1709,'./arrmashipview.php'),(20795859,1696,'./arrmashipview.php'),(20795858,1668,'./arrmashipview.php'),(20795857,1446,'./arrmashipview.php'),(20795856,6831,'./arrmashipview.php'),(20795855,8936,'./arrmashipview.php'),(20795854,6828,'./arrmashipview.php'),(20795853,869,'./arrmashipview.php'),(20795852,4481,'./arrmashipview.php'),(20795851,670,'./arrmashipview.php'),(20795850,6830,'./arrmashipview.php'),(20795849,591,'./arrmashipview.php'),(20795848,6829,'./arrmashipview.php'),(20795847,442,'./arrmashipview.php'),(20795843,6804,'./arrmaorderupd.php'),(20795842,5581,'./arrmaorderupd.php'),(20795841,2819,'./arrmaorderupd.php'),(20795840,2817,'./arrmaorderupd.php'),(20795839,2816,'./arrmaorderupd.php'),(20795838,6770,'./arrmaorderupd.php'),(20795837,2702,'./arrmaorderupd.php'),(20795836,6764,'./arrmaorderupd.php'),(20795835,6826,'./arrmaorderupd.php'),(20795834,6803,'./arrmaorderupd.php'),(20795833,6802,'./arrmaorderupd.php'),(20795832,6801,'./arrmaorderupd.php'),(20795831,2534,'./arrmaorderupd.php'),(20795830,6800,'./arrmaorderupd.php'),(20795829,6799,'./arrmaorderupd.php'),(20795828,6817,'./arrmaorderupd.php'),(20795827,5584,'./arrmaorderupd.php'),(20795826,2182,'./arrmaorderupd.php'),(20795825,6797,'./arrmaorderupd.php'),(20795824,6796,'./arrmaorderupd.php'),(20795823,6795,'./arrmaorderupd.php'),(20795822,2103,'./arrmaorderupd.php'),(20795821,1775,'./arrmaorderupd.php'),(20795820,1709,'./arrmaorderupd.php'),(20795819,1446,'./arrmaorderupd.php'),(20795818,6828,'./arrmaorderupd.php'),(20795817,869,'./arrmaorderupd.php'),(20795816,799,'./arrmaorderupd.php'),(20795815,315,'./arrmaorderupd.php'),(20795814,6793,'./arrmaorderupd.php'),(20795813,6827,'./arrmaorderreceive.php'),(20795812,5581,'./arrmaorderreceive.php'),(20795811,2819,'./arrmaorderreceive.php'),(20795810,2817,'./arrmaorderreceive.php'),(20795809,2816,'./arrmaorderreceive.php'),(20795808,2835,'./arrmaorderreceive.php'),(20795807,8122,'./arrmaorderreceive.php'),(20795806,2833,'./arrmaorderreceive.php'),(20795805,6770,'./arrmaorderreceive.php'),(20795804,19263,'./arrmaorderreceive.php'),(20795803,2702,'./arrmaorderreceive.php'),(20795802,6764,'./arrmaorderreceive.php'),(20795801,6826,'./arrmaorderreceive.php'),(20795800,19262,'./arrmaorderreceive.php'),(20795799,19206,'./arrmaorderreceive.php'),(20795798,6825,'./arrmaorderreceive.php'),(20795797,6824,'./arrmaorderreceive.php'),(20795796,6823,'./arrmaorderreceive.php'),(20795795,6803,'./arrmaorderreceive.php'),(20795794,6822,'./arrmaorderreceive.php'),(20795793,6821,'./arrmaorderreceive.php'),(20795792,6802,'./arrmaorderreceive.php'),(20795791,6820,'./arrmaorderreceive.php'),(20795790,6819,'./arrmaorderreceive.php'),(20795789,6818,'./arrmaorderreceive.php'),(20795788,6817,'./arrmaorderreceive.php'),(20795787,3522,'./arrmaorderreceive.php'),(20795786,6816,'./arrmaorderreceive.php'),(20795785,6815,'./arrmaorderreceive.php'),(20795784,5584,'./arrmaorderreceive.php'),(20795783,19260,'./arrmaorderreceive.php'),(20795782,2182,'./arrmaorderreceive.php'),(20795781,6797,'./arrmaorderreceive.php'),(20795780,6814,'./arrmaorderreceive.php'),(20795779,6795,'./arrmaorderreceive.php'),(20795778,2103,'./arrmaorderreceive.php'),(20795777,1775,'./arrmaorderreceive.php'),(20795776,1709,'./arrmaorderreceive.php'),(20795775,6813,'./arrmaorderreceive.php'),(20795774,6812,'./arrmaorderreceive.php'),(20795773,6811,'./arrmaorderreceive.php'),(20795772,1668,'./arrmaorderreceive.php'),(20795771,18570,'./arrmaorderreceive.php'),(20795770,6810,'./arrmaorderreceive.php'),(20795769,1463,'./arrmaorderreceive.php'),(20795768,1446,'./arrmaorderreceive.php'),(20795767,19259,'./arrmaorderreceive.php'),(20795766,8936,'./arrmaorderreceive.php'),(20795765,6809,'./arrmaorderreceive.php'),(20795764,869,'./arrmaorderreceive.php'),(20795763,695,'./arrmaorderreceive.php'),(20795762,13659,'./arrmaorderreceive.php'),(20795752,6804,'./arrmaorderadd.php'),(20795751,5581,'./arrmaorderadd.php'),(20795750,2819,'./arrmaorderadd.php'),(20795749,2817,'./arrmaorderadd.php'),(20795748,2816,'./arrmaorderadd.php'),(20795747,6770,'./arrmaorderadd.php'),(20795746,2702,'./arrmaorderadd.php'),(20795745,6803,'./arrmaorderadd.php'),(20795744,5689,'./arrmaorderadd.php'),(20795743,6802,'./arrmaorderadd.php'),(20795742,6801,'./arrmaorderadd.php'),(20795741,2534,'./arrmaorderadd.php'),(20795740,6800,'./arrmaorderadd.php'),(20795739,6799,'./arrmaorderadd.php'),(20795738,6798,'./arrmaorderadd.php'),(20795737,5584,'./arrmaorderadd.php'),(20795736,2182,'./arrmaorderadd.php'),(20795735,6797,'./arrmaorderadd.php'),(20795734,6796,'./arrmaorderadd.php'),(20795733,6795,'./arrmaorderadd.php'),(20795732,2103,'./arrmaorderadd.php'),(20795731,1775,'./arrmaorderadd.php'),(20795730,1709,'./arrmaorderadd.php'),(20795729,18570,'./arrmaorderadd.php'),(20795728,869,'./arrmaorderadd.php'),(20795727,6794,'./arrmaorderadd.php'),(20795726,315,'./arrmaorderadd.php'),(20673154,3427,'./arprintorderinvoiceviewpdf.php'),(20673153,3172,'./arprintorderinvoiceviewpdf.php'),(20673152,3090,'./arprintorderinvoiceviewpdf.php'),(20673151,3035,'./arprintorderinvoiceviewpdf.php'),(20673150,2819,'./arprintorderinvoiceviewpdf.php'),(20673149,2529,'./arprintorderinvoiceviewpdf.php'),(20673148,2361,'./arprintorderinvoiceviewpdf.php'),(20673147,2170,'./arprintorderinvoiceviewpdf.php'),(20673146,2094,'./arprintorderinvoiceviewpdf.php'),(20673145,1938,'./arprintorderinvoiceviewpdf.php'),(20673144,5090,'./arprintorderinvoiceviewpdf.php'),(20673143,1679,'./arprintorderinvoiceviewpdf.php'),(20673142,1678,'./arprintorderinvoiceviewpdf.php'),(20673141,1672,'./arprintorderinvoiceviewpdf.php'),(20673140,1668,'./arprintorderinvoiceviewpdf.php'),(20673139,932,'./arprintorderinvoiceviewpdf.php'),(20673138,869,'./arprintorderinvoiceviewpdf.php'),(20673137,697,'./arprintorderinvoiceviewpdf.php'),(20673136,540,'./arprintorderinvoiceviewpdf.php'),(20806075,2165,'./nporder.php'),(20805462,2494,'./jobcostrpt.php'),(18625978,6792,'./arposordadd.php'),(18625977,6791,'./arposordadd.php'),(18625976,3090,'./arposordadd.php'),(18625975,2977,'./arposordadd.php'),(18625974,6790,'./arposordadd.php'),(18625973,2702,'./arposordadd.php'),(18625972,2686,'./arposordadd.php'),(18625971,3961,'./arposordadd.php'),(18625970,6789,'./arposordadd.php'),(18625969,2700,'./arposordadd.php'),(18625968,2529,'./arposordadd.php'),(18625967,2508,'./arposordadd.php'),(18625966,2473,'./arposordadd.php'),(18625965,2459,'./arposordadd.php'),(18625964,2404,'./arposordadd.php'),(18625963,5917,'./arposordadd.php'),(18625962,5916,'./arposordadd.php'),(18625961,5915,'./arposordadd.php'),(18625960,5914,'./arposordadd.php'),(18625959,5913,'./arposordadd.php'),(18625958,6788,'./arposordadd.php'),(18625957,6787,'./arposordadd.php'),(18625956,6786,'./arposordadd.php'),(18625955,4023,'./arposordadd.php'),(18625954,7625,'./arposordadd.php'),(18625953,6785,'./arposordadd.php'),(18625952,6784,'./arposordadd.php'),(18625951,8358,'./arposordadd.php'),(18625950,1992,'./arposordadd.php'),(18625949,6783,'./arposordadd.php'),(18625948,1788,'./arposordadd.php'),(18625947,1724,'./arposordadd.php'),(18625946,1696,'./arposordadd.php'),(18625945,6745,'./arposordadd.php'),(18625944,1583,'./arposordadd.php'),(18625943,1582,'./arposordadd.php'),(18625942,6744,'./arposordadd.php'),(18625941,1357,'./arposordadd.php'),(18625940,3950,'./arposordadd.php'),(18625939,6713,'./arposordadd.php'),(18625938,1232,'./arposordadd.php'),(18625937,6782,'./arposordadd.php'),(18625936,981,'./arposordadd.php'),(18625935,886,'./arposordadd.php'),(18625934,4761,'./arposordadd.php'),(18625933,6781,'./arposordadd.php'),(18625932,6780,'./arposordadd.php'),(18625931,4633,'./arposordadd.php'),(18625930,4481,'./arposordadd.php'),(18625929,6779,'./arposordadd.php'),(18625928,6778,'./arposordadd.php'),(18625927,6053,'./arposordadd.php'),(18625926,6777,'./arposordadd.php'),(18625925,491,'./arposordadd.php'),(18625924,6192,'./arposordadd.php'),(18625923,479,'./arposordadd.php'),(18625922,6776,'./arposordadd.php'),(18625921,6775,'./arposordadd.php'),(18625920,5725,'./arposordadd.php'),(18625919,5912,'./arposordadd.php'),(18625918,5910,'./arposordadd.php'),(18625917,445,'./arposordadd.php'),(18625916,315,'./arposordadd.php'),(18625915,6743,'./arposordadd.php'),(18625914,5144,'./arposordadd.php'),(18625913,5145,'./arposordadd.php'),(18625912,6774,'./arposordadd.php'),(20795724,5310,'./arpayplanupd.php'),(20795723,5309,'./arpayplanupd.php'),(20795722,5345,'./arpayplanupd.php'),(20795721,5323,'./arpayplanupd.php'),(20795720,3090,'./arpayplanupd.php'),(20795719,3035,'./arpayplanupd.php'),(20795718,3030,'./arpayplanupd.php'),(20795717,2998,'./arpayplanupd.php'),(20795716,2977,'./arpayplanupd.php'),(20795715,6021,'./arpayplanupd.php'),(20795714,2819,'./arpayplanupd.php'),(20795713,2710,'./arpayplanupd.php'),(20795712,2702,'./arpayplanupd.php'),(20795711,3961,'./arpayplanupd.php'),(20795710,2665,'./arpayplanupd.php'),(20795709,2698,'./arpayplanupd.php'),(20795708,2622,'./arpayplanupd.php'),(20795707,2618,'./arpayplanupd.php'),(20795706,2586,'./arpayplanupd.php'),(20795705,5308,'./arpayplanupd.php'),(20795704,2501,'./arpayplanupd.php'),(20795703,2404,'./arpayplanupd.php'),(20795702,2363,'./arpayplanupd.php'),(20795701,12203,'./arpayplanupd.php'),(20795700,5332,'./arpayplanupd.php'),(20795699,5322,'./arpayplanupd.php'),(20795698,5321,'./arpayplanupd.php'),(20795697,5319,'./arpayplanupd.php'),(20795696,2170,'./arpayplanupd.php'),(20795695,5318,'./arpayplanupd.php'),(20795694,2021,'./arpayplanupd.php'),(20795693,2094,'./arpayplanupd.php'),(20795692,2103,'./arpayplanupd.php'),(20795691,5317,'./arpayplanupd.php'),(20795690,5316,'./arpayplanupd.php'),(20795689,1963,'./arpayplanupd.php'),(20795688,5714,'./arpayplanupd.php'),(20795687,5304,'./arpayplanupd.php'),(20795686,1692,'./arpayplanupd.php'),(20795685,1678,'./arpayplanupd.php'),(20795684,5315,'./arpayplanupd.php'),(20795683,1647,'./arpayplanupd.php'),(20795682,15991,'./arpayplanupd.php'),(20795681,5303,'./arpayplanupd.php'),(20795680,5314,'./arpayplanupd.php'),(20795679,5302,'./arpayplanupd.php'),(20795678,1221,'./arpayplanupd.php'),(20795677,4346,'./arpayplanupd.php'),(20795676,5313,'./arpayplanupd.php'),(20795675,1028,'./arpayplanupd.php'),(20795674,7876,'./arpayplanupd.php'),(20795673,6019,'./arpayplanupd.php'),(20795672,6018,'./arpayplanupd.php'),(20795671,6017,'./arpayplanupd.php'),(20795670,869,'./arpayplanupd.php'),(20795669,830,'./arpayplanupd.php'),(20795668,799,'./arpayplanupd.php'),(20795667,4973,'./arpayplanupd.php'),(20795666,742,'./arpayplanupd.php'),(20795665,5299,'./arpayplanupd.php'),(20795664,5312,'./arpayplanupd.php'),(20795663,4481,'./arpayplanupd.php'),(20795662,695,'./arpayplanupd.php'),(20795661,653,'./arpayplanupd.php'),(20795660,9492,'./arpayplanupd.php'),(20795659,549,'./arpayplanupd.php'),(20795658,542,'./arpayplanupd.php'),(20795657,5311,'./arpayplanupd.php'),(20795656,468,'./arpayplanupd.php'),(20795655,14116,'./arpayplanupd.php'),(20795654,315,'./arpayplanupd.php'),(20795653,5203,'./arpayplanupd.php'),(20795652,87,'./arpayplanupd.php'),(20795651,5310,'./arpayplanrep.php'),(20795650,5309,'./arpayplanrep.php'),(20795649,3450,'./arpayplanrep.php'),(20795648,5338,'./arpayplanrep.php'),(20795647,5337,'./arpayplanrep.php'),(20795646,5336,'./arpayplanrep.php'),(20795645,3090,'./arpayplanrep.php'),(20795644,5335,'./arpayplanrep.php'),(20795643,5334,'./arpayplanrep.php'),(20795642,5333,'./arpayplanrep.php'),(20795641,2676,'./arpayplanrep.php'),(20795640,2673,'./arpayplanrep.php'),(20795639,2612,'./arpayplanrep.php'),(20795638,5308,'./arpayplanrep.php'),(20795637,2404,'./arpayplanrep.php'),(20795636,5332,'./arpayplanrep.php'),(20795635,2292,'./arpayplanrep.php'),(20795634,2170,'./arpayplanrep.php'),(20795633,5331,'./arpayplanrep.php'),(20795632,5330,'./arpayplanrep.php'),(20795631,5329,'./arpayplanrep.php'),(20795630,1963,'./arpayplanrep.php'),(20795629,5304,'./arpayplanrep.php'),(20795628,7894,'./arpayplanrep.php'),(20795627,1771,'./arpayplanrep.php'),(20795626,5339,'./arpayplanrep.php'),(20795625,4111,'./arpayplanrep.php'),(20795624,1503,'./arpayplanrep.php'),(20795623,1502,'./arpayplanrep.php'),(20795622,5303,'./arpayplanrep.php'),(20795621,5302,'./arpayplanrep.php'),(20795620,1017,'./arpayplanrep.php'),(20795619,869,'./arpayplanrep.php'),(20795618,4973,'./arpayplanrep.php'),(20795617,5299,'./arpayplanrep.php'),(20795616,697,'./arpayplanrep.php'),(20795615,695,'./arpayplanrep.php'),(20795614,665,'./arpayplanrep.php'),(20795613,616,'./arpayplanrep.php'),(20795612,596,'./arpayplanrep.php'),(20795611,336,'./arpayplanrep.php'),(20795610,315,'./arpayplanrep.php'),(20795609,197,'./arpayplanrep.php'),(20806074,5865,'./nporder.php'),(20795608,5310,'./arpayplanadd.php'),(20795607,5309,'./arpayplanadd.php'),(20795606,3112,'./arpayplanadd.php'),(20795605,3111,'./arpayplanadd.php'),(20795604,3021,'./arpayplanadd.php'),(20795603,2998,'./arpayplanadd.php'),(20795602,2820,'./arpayplanadd.php'),(20795601,2819,'./arpayplanadd.php'),(20795600,2676,'./arpayplanadd.php'),(20795599,3961,'./arpayplanadd.php'),(20795598,2618,'./arpayplanadd.php'),(20795597,2586,'./arpayplanadd.php'),(20795596,5308,'./arpayplanadd.php'),(20795595,2501,'./arpayplanadd.php'),(20795594,2404,'./arpayplanadd.php'),(20795593,5307,'./arpayplanadd.php'),(20795592,12202,'./arpayplanadd.php'),(20795591,5305,'./arpayplanadd.php'),(20795590,2103,'./arpayplanadd.php'),(20795589,1963,'./arpayplanadd.php'),(20795588,7906,'./arpayplanadd.php'),(20795587,5304,'./arpayplanadd.php'),(20795586,4108,'./arpayplanadd.php'),(20795585,1696,'./arpayplanadd.php'),(20795584,1685,'./arpayplanadd.php'),(20795583,1647,'./arpayplanadd.php'),(20795582,6020,'./arpayplanadd.php'),(20795581,1519,'./arpayplanadd.php'),(20795580,15991,'./arpayplanadd.php'),(20795579,5303,'./arpayplanadd.php'),(20795578,5302,'./arpayplanadd.php'),(20795577,5301,'./arpayplanadd.php'),(20795576,12194,'./arpayplanadd.php'),(20795575,5327,'./arpayplanadd.php'),(20795574,5300,'./arpayplanadd.php'),(20795573,1222,'./arpayplanadd.php'),(20795572,1028,'./arpayplanadd.php'),(20795571,941,'./arpayplanadd.php'),(20795570,6019,'./arpayplanadd.php'),(20795569,6018,'./arpayplanadd.php'),(20795568,6017,'./arpayplanadd.php'),(20795567,869,'./arpayplanadd.php'),(20795566,4973,'./arpayplanadd.php'),(20795565,5299,'./arpayplanadd.php'),(20795564,5298,'./arpayplanadd.php'),(20795563,716,'./arpayplanadd.php'),(20795562,4481,'./arpayplanadd.php'),(20795561,702,'./arpayplanadd.php'),(20795560,695,'./arpayplanadd.php'),(20795559,9341,'./arpayplanadd.php'),(20795558,9492,'./arpayplanadd.php'),(20795557,607,'./arpayplanadd.php'),(20795556,593,'./arpayplanadd.php'),(20795555,549,'./arpayplanadd.php'),(20795554,14116,'./arpayplanadd.php'),(20795553,315,'./arpayplanadd.php'),(20795552,152,'./arpayplanadd.php'),(20795551,85,'./arpayplanadd.php'),(20795550,59,'./arpayplanadd.php'),(20795549,13841,'./arpayplan_post.php'),(20795548,5310,'./arpayplan_post.php'),(20795547,5309,'./arpayplan_post.php'),(20795546,3090,'./arpayplan_post.php'),(20795545,6016,'./arpayplan_post.php'),(20795544,2671,'./arpayplan_post.php'),(20795543,5308,'./arpayplan_post.php'),(20795542,5466,'./arpayplan_post.php'),(20795541,5344,'./arpayplan_post.php'),(20795540,7916,'./arpayplan_post.php'),(20795539,5343,'./arpayplan_post.php'),(20795538,2371,'./arpayplan_post.php'),(20795537,5332,'./arpayplan_post.php'),(20795536,5342,'./arpayplan_post.php'),(20795535,13918,'./arpayplan_post.php'),(20795534,5341,'./arpayplan_post.php'),(20795533,5340,'./arpayplan_post.php'),(20795532,13917,'./arpayplan_post.php'),(20795531,5330,'./arpayplan_post.php'),(20795530,14093,'./arpayplan_post.php'),(20795529,1963,'./arpayplan_post.php'),(20795528,5304,'./arpayplan_post.php'),(20795527,15126,'./arpayplan_post.php'),(20795526,1678,'./arpayplan_post.php'),(20795525,1672,'./arpayplan_post.php'),(20795524,13840,'./arpayplan_post.php'),(20795523,13839,'./arpayplan_post.php'),(20795522,13838,'./arpayplan_post.php'),(20795521,5339,'./arpayplan_post.php'),(20795520,5303,'./arpayplan_post.php'),(20795519,8936,'./arpayplan_post.php'),(20795518,14092,'./arpayplan_post.php'),(20795517,13837,'./arpayplan_post.php'),(20795516,932,'./arpayplan_post.php'),(20795515,17075,'./arpayplan_post.php'),(20795514,4973,'./arpayplan_post.php'),(20795513,5299,'./arpayplan_post.php'),(20795512,697,'./arpayplan_post.php'),(20795511,695,'./arpayplan_post.php'),(20795510,6015,'./arpayplan_post.php'),(20795509,3566,'./arpayplan_post.php'),(19916512,8212,'./arordupd.php'),(19916511,7196,'./arordupd.php'),(19916510,3324,'./arordupd.php'),(19916509,8220,'./arordupd.php'),(19916508,3165,'./arordupd.php'),(19916507,4861,'./arordupd.php'),(19916506,3156,'./arordupd.php'),(19916505,7756,'./arordupd.php'),(19916504,3099,'./arordupd.php'),(19916503,3090,'./arordupd.php'),(19916502,3058,'./arordupd.php'),(19916501,3030,'./arordupd.php'),(19916500,2998,'./arordupd.php'),(19916499,2977,'./arordupd.php'),(19916498,2948,'./arordupd.php'),(19916497,2820,'./arordupd.php'),(19916496,2819,'./arordupd.php'),(19916495,8126,'./arordupd.php'),(19916494,2817,'./arordupd.php'),(19916493,8055,'./arordupd.php'),(19916492,2833,'./arordupd.php'),(19916491,2827,'./arordupd.php'),(19916490,2702,'./arordupd.php'),(19916489,3961,'./arordupd.php'),(19916488,2665,'./arordupd.php'),(19916487,2698,'./arordupd.php'),(19916486,8219,'./arordupd.php'),(19916485,8218,'./arordupd.php'),(19916484,6738,'./arordupd.php'),(19916483,2586,'./arordupd.php'),(19916482,2561,'./arordupd.php'),(19916481,2540,'./arordupd.php'),(19916480,2529,'./arordupd.php'),(19916479,2527,'./arordupd.php'),(19916478,2501,'./arordupd.php'),(19916477,2480,'./arordupd.php'),(19916476,11734,'./arordupd.php'),(19916475,2459,'./arordupd.php'),(19916474,2404,'./arordupd.php'),(19916473,2363,'./arordupd.php'),(19916472,2334,'./arordupd.php'),(19916471,4886,'./arordupd.php'),(19916470,7755,'./arordupd.php'),(19916469,2231,'./arordupd.php'),(19916468,5671,'./arordupd.php'),(19916467,2208,'./arordupd.php'),(19916466,4008,'./arordupd.php'),(19916465,2195,'./arordupd.php'),(19916464,2182,'./arordupd.php'),(19916463,8069,'./arordupd.php'),(19916462,4850,'./arordupd.php'),(19916461,2170,'./arordupd.php'),(19916460,6118,'./arordupd.php'),(19916459,6773,'./arordupd.php'),(19916458,2156,'./arordupd.php'),(19916457,2151,'./arordupd.php'),(19916456,2024,'./arordupd.php'),(19916455,6117,'./arordupd.php'),(19916454,2103,'./arordupd.php'),(19916453,2099,'./arordupd.php'),(19916452,2071,'./arordupd.php'),(19916451,1963,'./arordupd.php'),(19916450,5505,'./arordupd.php'),(19916449,1884,'./arordupd.php'),(19916448,1775,'./arordupd.php'),(19916447,1727,'./arordupd.php'),(19916446,1629,'./arordupd.php'),(19916445,5339,'./arordupd.php'),(19916444,1599,'./arordupd.php'),(19916443,6772,'./arordupd.php'),(19916442,3481,'./arordupd.php'),(19916441,5504,'./arordupd.php'),(19916440,5214,'./arordupd.php'),(19916439,6116,'./arordupd.php'),(19916438,985,'./arordupd.php'),(19916437,6115,'./arordupd.php'),(19916436,967,'./arordupd.php'),(19916435,7877,'./arordupd.php'),(19916434,941,'./arordupd.php'),(19916433,931,'./arordupd.php'),(19916432,11815,'./arordupd.php'),(19916431,6736,'./arordupd.php'),(19916430,869,'./arordupd.php'),(19916429,5478,'./arordupd.php'),(19916428,799,'./arordupd.php'),(19916427,737,'./arordupd.php'),(19916426,5477,'./arordupd.php'),(19916425,4481,'./arordupd.php'),(19916424,673,'./arordupd.php'),(19916423,7623,'./arordupd.php'),(19916422,8768,'./arordupd.php'),(19916421,5851,'./arordupd.php'),(19916420,18048,'./arordupd.php'),(19916419,5850,'./arordupd.php'),(19916418,7642,'./arordupd.php'),(19916417,479,'./arordupd.php'),(19916416,445,'./arordupd.php'),(19916415,355,'./arordupd.php'),(19916414,325,'./arordupd.php'),(19916413,315,'./arordupd.php'),(19916412,6771,'./arordupd.php'),(19916411,5203,'./arordupd.php'),(19916410,5570,'./arordupd.php'),(19916409,226,'./arordupd.php'),(19916408,211,'./arordupd.php'),(19916407,8217,'./arordupd.php'),(19916406,87,'./arordupd.php'),(19916405,5503,'./arordupd.php'),(19916404,5670,'./arordupd.php'),(20796564,1598,'./autofunctionsdb.php'),(20795500,3427,'./arordshipviewfpdf.php'),(20795499,5179,'./arordshipviewfpdf.php'),(20795498,18275,'./arordshipviewfpdf.php'),(20795497,3090,'./arordshipviewfpdf.php'),(20795496,3948,'./arordshipviewfpdf.php'),(20795495,2998,'./arordshipviewfpdf.php'),(20795494,5863,'./arordshipviewfpdf.php'),(20795493,14115,'./arordshipviewfpdf.php'),(20795492,2818,'./arordshipviewfpdf.php'),(20795491,2816,'./arordshipviewfpdf.php'),(20795490,2833,'./arordshipviewfpdf.php'),(20795489,6770,'./arordshipviewfpdf.php'),(20795488,18771,'./arordshipviewfpdf.php'),(20795487,5876,'./arordshipviewfpdf.php'),(20795486,14114,'./arordshipviewfpdf.php'),(20795485,17443,'./arordshipviewfpdf.php'),(20795484,4678,'./arordshipviewfpdf.php'),(20795483,2404,'./arordshipviewfpdf.php'),(20795482,2361,'./arordshipviewfpdf.php'),(20795481,2315,'./arordshipviewfpdf.php'),(20795480,2225,'./arordshipviewfpdf.php'),(20795479,2222,'./arordshipviewfpdf.php'),(20795478,4565,'./arordshipviewfpdf.php'),(20795477,2186,'./arordshipviewfpdf.php'),(20795476,4070,'./arordshipviewfpdf.php'),(20795475,6234,'./arordshipviewfpdf.php'),(20795474,1781,'./arordshipviewfpdf.php'),(20795444,3421,'./arordshipview.php'),(20795443,3360,'./arordshipview.php'),(20795442,7754,'./arordshipview.php'),(20795441,5378,'./arordshipview.php'),(20795440,3324,'./arordshipview.php'),(20795439,3879,'./arordshipview.php'),(20795438,14766,'./arordshipview.php'),(20795437,12722,'./arordshipview.php'),(20795436,3126,'./arordshipview.php'),(20795435,18244,'./arordshipview.php'),(20795434,3060,'./arordshipview.php'),(20795433,2948,'./arordshipview.php'),(20795432,2824,'./arordshipview.php'),(20795431,2819,'./arordshipview.php'),(20795430,14765,'./arordshipview.php'),(20795429,2817,'./arordshipview.php'),(20795428,2816,'./arordshipview.php'),(20795427,15546,'./arordshipview.php'),(20795426,2827,'./arordshipview.php'),(20795425,8000,'./arordshipview.php'),(20795424,7753,'./arordshipview.php'),(20795423,4007,'./arordshipview.php'),(20795422,19122,'./arordshipview.php'),(20795421,18157,'./arordshipview.php'),(20795420,18633,'./arordshipview.php'),(20795419,6770,'./arordshipview.php'),(20795418,7752,'./arordshipview.php'),(20795417,2534,'./arordshipview.php'),(20795416,2531,'./arordshipview.php'),(20795415,2530,'./arordshipview.php'),(20795414,2501,'./arordshipview.php'),(20795413,2402,'./arordshipview.php'),(20795412,2363,'./arordshipview.php'),(20795411,2231,'./arordshipview.php'),(20795410,4565,'./arordshipview.php'),(20795409,2219,'./arordshipview.php'),(20795408,2220,'./arordshipview.php'),(20795407,2182,'./arordshipview.php'),(20795406,2180,'./arordshipview.php'),(20795405,2173,'./arordshipview.php'),(20795404,2170,'./arordshipview.php'),(20795403,2154,'./arordshipview.php'),(20795402,2151,'./arordshipview.php'),(20795401,4006,'./arordshipview.php'),(20795400,2034,'./arordshipview.php'),(20795399,2103,'./arordshipview.php'),(20795398,1973,'./arordshipview.php'),(20795397,1963,'./arordshipview.php'),(20795396,5234,'./arordshipview.php'),(20795395,1788,'./arordshipview.php'),(20795394,1775,'./arordshipview.php'),(20795393,1773,'./arordshipview.php'),(20795392,17412,'./arordshipview.php'),(20795391,1709,'./arordshipview.php'),(20795390,5652,'./arordshipview.php'),(20795389,1464,'./arordshipview.php'),(20795388,5214,'./arordshipview.php'),(20795387,15970,'./arordshipview.php'),(20795386,1036,'./arordshipview.php'),(20795385,4625,'./arordshipview.php'),(20795384,931,'./arordshipview.php'),(20795383,16656,'./arordshipview.php'),(20795382,869,'./arordshipview.php'),(20795381,7750,'./arordshipview.php'),(20795367,3510,'./arordshipquote.php'),(20795366,3360,'./arordshipquote.php'),(20795365,15136,'./arordshipquote.php'),(20795364,15135,'./arordshipquote.php'),(20795363,3490,'./arordshipquote.php'),(20795362,3492,'./arordshipquote.php'),(20795361,3491,'./arordshipquote.php'),(20795360,17411,'./arordshipquote.php'),(20795359,17410,'./arordshipquote.php'),(20795358,3489,'./arordshipquote.php'),(20795357,3499,'./arordshipquote.php'),(20795356,3493,'./arordshipquote.php'),(20795355,3495,'./arordshipquote.php'),(20795354,3494,'./arordshipquote.php'),(20795353,3482,'./arordshipquote.php'),(20795352,3496,'./arordshipquote.php'),(20795351,3483,'./arordshipquote.php'),(20795350,3498,'./arordshipquote.php'),(20795349,3497,'./arordshipquote.php'),(20795348,3488,'./arordshipquote.php'),(20795347,3487,'./arordshipquote.php'),(20795346,15154,'./arordshipquote.php'),(20795345,3486,'./arordshipquote.php'),(20795344,3484,'./arordshipquote.php'),(20795343,3485,'./arordshipquote.php'),(20795342,3450,'./arordshipquote.php'),(20795341,3506,'./arordshipquote.php'),(20795340,15802,'./arordshipquote.php'),(20795339,3090,'./arordshipquote.php'),(20795338,3072,'./arordshipquote.php'),(20795337,3511,'./arordshipquote.php'),(20795336,3507,'./arordshipquote.php'),(20795335,3508,'./arordshipquote.php'),(20795334,2540,'./arordshipquote.php'),(20795333,3504,'./arordshipquote.php'),(20795332,2109,'./arordshipquote.php'),(20795331,1884,'./arordshipquote.php'),(20795330,15134,'./arordshipquote.php'),(20795329,15801,'./arordshipquote.php'),(20795328,13864,'./arordshipquote.php'),(20795327,3512,'./arordshipquote.php'),(20795326,3505,'./arordshipquote.php'),(20795325,1467,'./arordshipquote.php'),(20795324,10704,'./arordshipquote.php'),(20795323,16447,'./arordshipquote.php'),(20795322,8936,'./arordshipquote.php'),(20795321,886,'./arordshipquote.php'),(20795320,15133,'./arordshipquote.php'),(20795319,799,'./arordshipquote.php'),(20795318,4973,'./arordshipquote.php'),(20795310,3427,'./arordshipboxlabelpdf.php'),(20795309,3072,'./arordshipboxlabelpdf.php'),(20795308,5088,'./arordshipboxlabelpdf.php'),(20795307,2361,'./arordshipboxlabelpdf.php'),(20795306,2182,'./arordshipboxlabelpdf.php'),(20795305,4789,'./arordshipboxlabelpdf.php'),(20795304,2094,'./arordshipboxlabelpdf.php'),(20795303,737,'./arordshipboxlabelpdf.php'),(20795302,542,'./arordshipboxlabelpdf.php'),(20795301,5087,'./arordshipboxlabelpdf.php'),(20795299,13159,'./arordshipadd_group.php'),(20795298,6770,'./arordshipadd_group.php'),(20795297,14105,'./arordshipadd_group.php'),(20795296,2188,'./arordshipadd_group.php'),(20795295,2033,'./arordshipadd_group.php'),(20795294,14104,'./arordshipadd_group.php'),(20795293,8936,'./arordshipadd_group.php'),(20795292,13106,'./arordshipadd_group.php'),(20795291,4109,'./arordshipadd3dcart.php'),(20795290,4861,'./arordshipadd3dcart.php'),(20795289,15209,'./arordshipadd3dcart.php'),(20795288,3126,'./arordshipadd3dcart.php'),(20795287,2948,'./arordshipadd3dcart.php'),(20795286,14497,'./arordshipadd3dcart.php'),(20795285,14878,'./arordshipadd3dcart.php'),(20795284,2813,'./arordshipadd3dcart.php'),(20795283,2540,'./arordshipadd3dcart.php'),(20795282,14496,'./arordshipadd3dcart.php'),(20795281,14495,'./arordshipadd3dcart.php'),(20795280,2231,'./arordshipadd3dcart.php'),(20795279,2165,'./arordshipadd3dcart.php'),(20795278,2151,'./arordshipadd3dcart.php'),(20795277,14877,'./arordshipadd3dcart.php'),(20795276,14876,'./arordshipadd3dcart.php'),(20795275,14875,'./arordshipadd3dcart.php'),(20795274,1935,'./arordshipadd3dcart.php'),(20795273,11945,'./arordshipadd3dcart.php'),(20795272,15208,'./arordshipadd3dcart.php'),(20795271,8936,'./arordshipadd3dcart.php'),(20795270,14854,'./arordshipadd3dcart.php'),(20795269,355,'./arordshipadd3dcart.php'),(20795268,15207,'./arordshipadd3dcart.php'),(20795267,14874,'./arordshipadd3dcart.php'),(20795266,14494,'./arordshipadd3dcart.php'),(20795265,18458,'./arordshipadd.php'),(20795264,3429,'./arordshipadd.php'),(20795263,3421,'./arordshipadd.php'),(20795262,3360,'./arordshipadd.php'),(20795261,3274,'./arordshipadd.php'),(20795260,20114,'./arordshipadd.php'),(20795259,18089,'./arordshipadd.php'),(20795258,18088,'./arordshipadd.php'),(20795257,18087,'./arordshipadd.php'),(20795256,13494,'./arordshipadd.php'),(20795255,3237,'./arordshipadd.php'),(20795254,15545,'./arordshipadd.php'),(20795253,3126,'./arordshipadd.php'),(20795252,7759,'./arordshipadd.php'),(20795251,19777,'./arordshipadd.php'),(20795250,19776,'./arordshipadd.php'),(20795249,18086,'./arordshipadd.php'),(20795248,11113,'./arordshipadd.php'),(20795247,3060,'./arordshipadd.php'),(20795246,3059,'./arordshipadd.php'),(20795245,19589,'./arordshipadd.php'),(20795244,2948,'./arordshipadd.php'),(20795243,14963,'./arordshipadd.php'),(20795242,2824,'./arordshipadd.php'),(20795241,2820,'./arordshipadd.php'),(20795240,2819,'./arordshipadd.php'),(20795239,7935,'./arordshipadd.php'),(20795238,14765,'./arordshipadd.php'),(20795237,2817,'./arordshipadd.php'),(20795236,2816,'./arordshipadd.php'),(20795235,19121,'./arordshipadd.php'),(20795234,2838,'./arordshipadd.php'),(20795233,2836,'./arordshipadd.php'),(20795232,13159,'./arordshipadd.php'),(20795231,2830,'./arordshipadd.php'),(20795230,2827,'./arordshipadd.php'),(20795229,16446,'./arordshipadd.php'),(20795228,19659,'./arordshipadd.php'),(20795227,9435,'./arordshipadd.php'),(20795226,6770,'./arordshipadd.php'),(20795225,2801,'./arordshipadd.php'),(20795224,2725,'./arordshipadd.php'),(20795223,2702,'./arordshipadd.php'),(20795222,5188,'./arordshipadd.php'),(20795221,14962,'./arordshipadd.php'),(20795220,20113,'./arordshipadd.php'),(20795219,2602,'./arordshipadd.php'),(20795218,14961,'./arordshipadd.php'),(20795217,2534,'./arordshipadd.php'),(20795216,13147,'./arordshipadd.php'),(20795215,2531,'./arordshipadd.php'),(20795214,5903,'./arordshipadd.php'),(20795213,2508,'./arordshipadd.php'),(20795212,2501,'./arordshipadd.php'),(20795211,2402,'./arordshipadd.php'),(20795210,2363,'./arordshipadd.php'),(20795209,4979,'./arordshipadd.php'),(20795208,16445,'./arordshipadd.php'),(20795207,2361,'./arordshipadd.php'),(20795206,14105,'./arordshipadd.php'),(20795205,18151,'./arordshipadd.php'),(20795204,2293,'./arordshipadd.php'),(20795203,2231,'./arordshipadd.php'),(20795202,2219,'./arordshipadd.php'),(20795201,5187,'./arordshipadd.php'),(20795200,2189,'./arordshipadd.php'),(20795199,2188,'./arordshipadd.php'),(20795198,2182,'./arordshipadd.php'),(20795197,2181,'./arordshipadd.php'),(20795196,8068,'./arordshipadd.php'),(20795195,2173,'./arordshipadd.php'),(20795194,2170,'./arordshipadd.php'),(20795193,19120,'./arordshipadd.php'),(20795192,19119,'./arordshipadd.php'),(20795191,2151,'./arordshipadd.php'),(20795190,2137,'./arordshipadd.php'),(20795189,4608,'./arordshipadd.php'),(20795188,16655,'./arordshipadd.php'),(20795187,2033,'./arordshipadd.php'),(20795186,20064,'./arordshipadd.php'),(20795185,20112,'./arordshipadd.php'),(20795184,15241,'./arordshipadd.php'),(20795183,2103,'./arordshipadd.php'),(20795182,2099,'./arordshipadd.php'),(20795181,1973,'./arordshipadd.php'),(20795180,1963,'./arordshipadd.php'),(20795179,18012,'./arordshipadd.php'),(20795178,1796,'./arordshipadd.php'),(20795129,3427,'./arordquotefpdf.php'),(20795128,3172,'./arordquotefpdf.php'),(20795127,3090,'./arordquotefpdf.php'),(20795126,2998,'./arordquotefpdf.php'),(20795125,2977,'./arordquotefpdf.php'),(20795124,4513,'./arordquotefpdf.php'),(20795123,5225,'./arordquotefpdf.php'),(20795122,2833,'./arordquotefpdf.php'),(20795121,5687,'./arordquotefpdf.php'),(20795120,5686,'./arordquotefpdf.php'),(20795119,13951,'./arordquotefpdf.php'),(20795118,4680,'./arordquotefpdf.php'),(20795117,16825,'./arordquotefpdf.php'),(20795116,13980,'./arordquotefpdf.php'),(20795115,2540,'./arordquotefpdf.php'),(20795114,2529,'./arordquotefpdf.php'),(20795113,17409,'./arordquotefpdf.php'),(20795112,2324,'./arordquotefpdf.php'),(20795111,2315,'./arordquotefpdf.php'),(20795110,2222,'./arordquotefpdf.php'),(20795109,1963,'./arordquotefpdf.php'),(20795108,5685,'./arordquotefpdf.php'),(20795107,6234,'./arordquotefpdf.php'),(20795106,1781,'./arordquotefpdf.php'),(20795105,1743,'./arordquotefpdf.php'),(20795104,9622,'./arordquotefpdf.php'),(20795103,5081,'./arordquotefpdf.php'),(20795102,8942,'./arordquotefpdf.php'),(20795101,13434,'./arordquotefpdf.php'),(20795100,1373,'./arordquotefpdf.php'),(20795099,8936,'./arordquotefpdf.php'),(20795098,5684,'./arordquotefpdf.php'),(20795097,985,'./arordquotefpdf.php'),(20795096,982,'./arordquotefpdf.php'),(20795084,13158,'./arordpurge.php'),(20795083,13157,'./arordpurge.php'),(20795082,13156,'./arordpurge.php'),(20795081,13150,'./arordpurge.php'),(20795080,13149,'./arordpurge.php'),(20795079,13155,'./arordpurge.php'),(20795078,2182,'./arordpurge.php'),(20795077,4070,'./arordpurge.php'),(20795076,13154,'./arordpurge.php'),(20795075,1963,'./arordpurge.php'),(20795074,13148,'./arordpurge.php'),(20795073,13153,'./arordpurge.php'),(20795072,8936,'./arordpurge.php'),(20795071,799,'./arordpurge.php'),(20795070,13152,'./arordpurge.php'),(20795069,697,'./arordpurge.php'),(20795068,315,'./arordpurge.php'),(20795067,13151,'./arordpurge.php'),(20795066,3427,'./arordpicktickfpdf.php'),(20795065,3295,'./arordpicktickfpdf.php'),(20795064,18631,'./arordpicktickfpdf.php'),(20795063,3173,'./arordpicktickfpdf.php'),(20795062,3090,'./arordpicktickfpdf.php'),(20795061,3072,'./arordpicktickfpdf.php'),(20795060,15206,'./arordpicktickfpdf.php'),(20795059,15205,'./arordpicktickfpdf.php'),(20795058,4513,'./arordpicktickfpdf.php'),(20795057,5581,'./arordpicktickfpdf.php'),(20795056,2819,'./arordpicktickfpdf.php'),(20795055,2818,'./arordpicktickfpdf.php'),(20795054,2816,'./arordpicktickfpdf.php'),(20795053,4680,'./arordpicktickfpdf.php'),(20795052,16847,'./arordpicktickfpdf.php'),(20795051,2523,'./arordpicktickfpdf.php'),(20795050,5119,'./arordpicktickfpdf.php'),(20795049,2510,'./arordpicktickfpdf.php'),(20795048,15204,'./arordpicktickfpdf.php'),(20795047,2404,'./arordpicktickfpdf.php'),(20795046,17500,'./arordpicktickfpdf.php'),(20795045,2361,'./arordpicktickfpdf.php'),(20795044,18084,'./arordpicktickfpdf.php'),(20795043,6249,'./arordpicktickfpdf.php'),(20795042,19320,'./arordpicktickfpdf.php'),(20795041,2222,'./arordpicktickfpdf.php'),(20795040,8990,'./arordpicktickfpdf.php'),(20795039,2182,'./arordpicktickfpdf.php'),(20795038,4070,'./arordpicktickfpdf.php'),(20795037,15726,'./arordpicktickfpdf.php'),(20795036,6234,'./arordpicktickfpdf.php'),(20795035,18083,'./arordpicktickfpdf.php'),(20795034,15203,'./arordpicktickfpdf.php'),(20795033,1743,'./arordpicktickfpdf.php'),(20795032,9622,'./arordpicktickfpdf.php'),(20795031,5081,'./arordpicktickfpdf.php'),(20795030,6248,'./arordpicktickfpdf.php'),(20795029,6247,'./arordpicktickfpdf.php'),(20795028,15633,'./arordpicktickfpdf.php'),(20795027,1647,'./arordpicktickfpdf.php'),(20795026,13434,'./arordpicktickfpdf.php'),(20795177,18005,'./arordshipadd.php'),(20795176,1788,'./arordshipadd.php'),(20795008,3173,'./arordpicktick.php'),(20795007,2824,'./arordpicktick.php'),(20795006,2819,'./arordpicktick.php'),(20795005,2818,'./arordpicktick.php'),(20795004,2523,'./arordpicktick.php'),(20795003,2517,'./arordpicktick.php'),(20795002,2510,'./arordpicktick.php'),(20795001,2501,'./arordpicktick.php'),(20795000,9928,'./arordpicktick.php'),(20794999,2459,'./arordpicktick.php'),(20794998,2363,'./arordpicktick.php'),(20794997,2290,'./arordpicktick.php'),(20794996,2182,'./arordpicktick.php'),(20794995,2173,'./arordpicktick.php'),(20794994,2170,'./arordpicktick.php'),(20794993,2094,'./arordpicktick.php'),(20794992,2103,'./arordpicktick.php'),(20794991,1963,'./arordpicktick.php'),(20794990,1775,'./arordpicktick.php'),(20794989,1773,'./arordpicktick.php'),(20794988,1709,'./arordpicktick.php'),(20794987,15631,'./arordpicktick.php'),(20794986,1647,'./arordpicktick.php'),(20794985,6308,'./arordpicktick.php'),(20794984,941,'./arordpicktick.php'),(20794983,931,'./arordpicktick.php'),(20794982,869,'./arordpicktick.php'),(20794981,4481,'./arordpicktick.php'),(20794980,6307,'./arordpicktick.php'),(20794979,542,'./arordpicktick.php'),(20794978,8185,'./arordpicktick.php'),(20794976,19877,'./arorderunpaid.php'),(20794975,3179,'./arorderunpaid.php'),(20794974,4974,'./arorderunpaid.php'),(20794973,3090,'./arorderunpaid.php'),(20794972,2998,'./arorderunpaid.php'),(20794971,2986,'./arorderunpaid.php'),(20794970,2977,'./arorderunpaid.php'),(20794969,6732,'./arorderunpaid.php'),(20794968,6731,'./arorderunpaid.php'),(20794967,6229,'./arorderunpaid.php'),(20794966,2860,'./arorderunpaid.php'),(20794965,2833,'./arorderunpaid.php'),(20794964,5492,'./arorderunpaid.php'),(20794963,2676,'./arorderunpaid.php'),(20794962,2612,'./arorderunpaid.php'),(20794961,5388,'./arorderunpaid.php'),(20794960,6730,'./arorderunpaid.php'),(20794959,7730,'./arorderunpaid.php'),(20794958,2225,'./arorderunpaid.php'),(20794957,2182,'./arorderunpaid.php'),(20794956,2170,'./arorderunpaid.php'),(20794955,7748,'./arorderunpaid.php'),(20794954,6370,'./arorderunpaid.php'),(20794953,7678,'./arorderunpaid.php'),(20794952,2151,'./arorderunpaid.php'),(20794951,2021,'./arorderunpaid.php'),(20794950,1963,'./arorderunpaid.php'),(20794949,1771,'./arorderunpaid.php'),(20794948,1740,'./arorderunpaid.php'),(20794947,1678,'./arorderunpaid.php'),(20794946,5652,'./arorderunpaid.php'),(20794945,1672,'./arorderunpaid.php'),(20794944,1502,'./arorderunpaid.php'),(20794943,5491,'./arorderunpaid.php'),(20794942,6729,'./arorderunpaid.php'),(20794941,6728,'./arorderunpaid.php'),(20794940,5470,'./arorderunpaid.php'),(20794939,932,'./arorderunpaid.php'),(20794938,886,'./arorderunpaid.php'),(20794937,4481,'./arorderunpaid.php'),(20794936,697,'./arorderunpaid.php'),(20794935,665,'./arorderunpaid.php'),(20794934,616,'./arorderunpaid.php'),(20794933,7854,'./arorderunpaid.php'),(20794932,5469,'./arorderunpaid.php'),(20794931,325,'./arorderunpaid.php'),(20794930,315,'./arorderunpaid.php'),(20794929,197,'./arorderunpaid.php'),(20794928,2948,'./arorderunbilled.php'),(20794927,7747,'./arorderunbilled.php'),(20794926,2363,'./arorderunbilled.php'),(20794925,7746,'./arorderunbilled.php'),(20794924,2182,'./arorderunbilled.php'),(20794923,2165,'./arorderunbilled.php'),(20794922,5646,'./arorderunbilled.php'),(20794921,7745,'./arorderunbilled.php'),(20794920,355,'./arorderunbilled.php'),(20672330,3174,'./arorderstatuslst.php'),(20672329,2966,'./arorderstatuslst.php'),(20672328,2931,'./arorderstatuslst.php'),(20672327,2801,'./arorderstatuslst.php'),(20672326,2630,'./arorderstatuslst.php'),(20672325,16675,'./arorderstatuslst.php'),(20672324,2364,'./arorderstatuslst.php'),(20672323,2323,'./arorderstatuslst.php'),(20672322,2232,'./arorderstatuslst.php'),(20672321,4793,'./arorderstatuslst.php'),(20672320,2190,'./arorderstatuslst.php'),(20672319,2184,'./arorderstatuslst.php'),(20672318,2171,'./arorderstatuslst.php'),(20672317,2156,'./arorderstatuslst.php'),(20672316,2024,'./arorderstatuslst.php'),(20672315,1788,'./arorderstatuslst.php'),(20672314,5493,'./arorderstatuslst.php'),(20672313,1418,'./arorderstatuslst.php'),(20672312,934,'./arorderstatuslst.php'),(20672311,746,'./arorderstatuslst.php'),(20672310,494,'./arorderstatuslst.php'),(20672309,197,'./arorderstatuslst.php'),(20672308,47,'./arorderstatuslst.php'),(20794919,3740,'./arorderstatlst.php'),(20794918,1963,'./arorderstatlst.php'),(20794917,1014,'./arorderstatlst.php'),(20794916,4481,'./arorderstatlst.php'),(20794915,697,'./arorderstatlst.php'),(20794914,333,'./arorderstatlst.php'),(20794913,315,'./arorderstatlst.php'),(20794912,197,'./arorderstatlst.php'),(20794911,3173,'./arordershiplst.php'),(20794910,3090,'./arordershiplst.php'),(20794909,13563,'./arordershiplst.php'),(20794908,5731,'./arordershiplst.php'),(20794907,2818,'./arordershiplst.php'),(20794906,2816,'./arordershiplst.php'),(20794905,5492,'./arordershiplst.php'),(20794904,3961,'./arordershiplst.php'),(20794903,13564,'./arordershiplst.php'),(20794902,16785,'./arordershiplst.php'),(20794901,2529,'./arordershiplst.php'),(20794900,2501,'./arordershiplst.php'),(20794899,2459,'./arordershiplst.php'),(20794898,2451,'./arordershiplst.php'),(20794897,2363,'./arordershiplst.php'),(20794896,2361,'./arordershiplst.php'),(20794895,4793,'./arordershiplst.php'),(20794894,2192,'./arordershiplst.php'),(20794893,2182,'./arordershiplst.php'),(20794892,2170,'./arordershiplst.php'),(20794891,7744,'./arordershiplst.php'),(20794890,2029,'./arordershiplst.php'),(20794889,4081,'./arordershiplst.php'),(20794888,2103,'./arordershiplst.php'),(20794887,1963,'./arordershiplst.php'),(20794886,1788,'./arordershiplst.php'),(20794885,5389,'./arordershiplst.php'),(20794884,6757,'./arordershiplst.php'),(20794883,13566,'./arordershiplst.php'),(20794882,1678,'./arordershiplst.php'),(20794881,5491,'./arordershiplst.php'),(20794880,1357,'./arordershiplst.php'),(20794879,8936,'./arordershiplst.php'),(20794878,1019,'./arordershiplst.php'),(20794877,901,'./arordershiplst.php'),(20794876,744,'./arordershiplst.php'),(20794875,4481,'./arordershiplst.php'),(20794874,607,'./arordershiplst.php'),(20794873,7743,'./arordershiplst.php'),(20794872,13225,'./arordershiplst.php'),(20794871,13565,'./arordershiplst.php'),(20794870,337,'./arordershiplst.php'),(20794869,315,'./arordershiplst.php'),(20794868,13224,'./arordershiplst.php'),(20794867,9600,'./arordershiplst.php'),(20794865,3124,'./arordershipitemlst.php'),(20794864,7742,'./arordershipitemlst.php'),(20794863,2818,'./arordershipitemlst.php'),(20794862,2816,'./arordershipitemlst.php'),(20794861,2451,'./arordershipitemlst.php'),(20794860,2184,'./arordershipitemlst.php'),(20794859,2170,'./arordershipitemlst.php'),(20794858,2029,'./arordershipitemlst.php'),(20794857,4107,'./arordershipitemlst.php'),(20794856,1963,'./arordershipitemlst.php'),(20794855,1788,'./arordershipitemlst.php'),(20794854,12217,'./arordershipitemlst.php'),(20794853,11853,'./arordershipitemlst.php'),(20794852,1710,'./arordershipitemlst.php'),(20794851,1739,'./arordershipitemlst.php'),(20794850,6439,'./arordershipitemlst.php'),(20794849,1532,'./arordershipitemlst.php'),(20794848,1357,'./arordershipitemlst.php'),(20794847,1019,'./arordershipitemlst.php'),(20794846,901,'./arordershipitemlst.php'),(20794845,872,'./arordershipitemlst.php'),(20794844,4481,'./arordershipitemlst.php'),(20794843,607,'./arordershipitemlst.php'),(20794842,7741,'./arordershipitemlst.php'),(20794841,5074,'./arordershipitemlst.php'),(20794840,337,'./arordershipitemlst.php'),(20794839,315,'./arordershipitemlst.php'),(20794838,197,'./arordershipitemlst.php'),(20672225,15116,'./arordershipactuals.php'),(20672224,3118,'./arordershipactuals.php'),(20672223,15115,'./arordershipactuals.php'),(20672222,2816,'./arordershipactuals.php'),(20672221,15114,'./arordershipactuals.php'),(20672220,15113,'./arordershipactuals.php'),(20672219,9135,'./arordershipactuals.php'),(20672218,2182,'./arordershipactuals.php'),(20672217,4070,'./arordershipactuals.php'),(20672216,1963,'./arordershipactuals.php'),(20672215,15112,'./arordershipactuals.php'),(20672214,15111,'./arordershipactuals.php'),(20672213,8936,'./arordershipactuals.php'),(20672212,15110,'./arordershipactuals.php'),(20672211,434,'./arordershipactuals.php'),(20672210,15109,'./arordershipactuals.php'),(20672209,315,'./arordershipactuals.php'),(20672208,12681,'./arordershipactuals.php'),(20672207,15108,'./arordershipactuals.php'),(20672206,15107,'./arordershipactuals.php'),(20794837,3124,'./arorderrmalst.php'),(20794836,2948,'./arorderrmalst.php'),(20794835,6768,'./arorderrmalst.php'),(20794834,6767,'./arorderrmalst.php'),(20794833,6766,'./arorderrmalst.php'),(20794832,6765,'./arorderrmalst.php'),(20794831,6764,'./arorderrmalst.php'),(20794830,6763,'./arorderrmalst.php'),(20794829,6762,'./arorderrmalst.php'),(20794828,2501,'./arorderrmalst.php'),(20794827,2451,'./arorderrmalst.php'),(20794826,2364,'./arorderrmalst.php'),(20794825,2293,'./arorderrmalst.php'),(20794824,2184,'./arorderrmalst.php'),(20794823,6761,'./arorderrmalst.php'),(20794822,1963,'./arorderrmalst.php'),(20794821,1934,'./arorderrmalst.php'),(20794820,1788,'./arorderrmalst.php'),(20794819,1710,'./arorderrmalst.php'),(20794818,5339,'./arorderrmalst.php'),(20794817,1357,'./arorderrmalst.php'),(20794816,1019,'./arorderrmalst.php'),(20794815,901,'./arorderrmalst.php'),(20794814,869,'./arorderrmalst.php'),(20794813,4481,'./arorderrmalst.php'),(20794812,732,'./arorderrmalst.php'),(20794811,607,'./arorderrmalst.php'),(20794810,6760,'./arorderrmalst.php'),(20794809,337,'./arorderrmalst.php'),(20794808,315,'./arorderrmalst.php'),(20794807,197,'./arorderrmalst.php'),(20794806,3173,'./arorderquotelist.php'),(20794805,13432,'./arorderquotelist.php'),(20794804,16850,'./arorderquotelist.php'),(20794803,5849,'./arorderquotelist.php'),(20794802,4877,'./arorderquotelist.php'),(20794801,2529,'./arorderquotelist.php'),(20794800,20110,'./arorderquotelist.php'),(20794799,2404,'./arorderquotelist.php'),(20794798,2363,'./arorderquotelist.php'),(20794797,2182,'./arorderquotelist.php'),(20794796,2170,'./arorderquotelist.php'),(20794795,4069,'./arorderquotelist.php'),(20794794,2103,'./arorderquotelist.php'),(20794793,1963,'./arorderquotelist.php'),(20794792,1788,'./arorderquotelist.php'),(20794791,1709,'./arorderquotelist.php'),(20794790,4106,'./arorderquotelist.php'),(20794789,5848,'./arorderquotelist.php'),(20794788,1357,'./arorderquotelist.php'),(20794787,1019,'./arorderquotelist.php'),(20794786,985,'./arorderquotelist.php'),(20794785,941,'./arorderquotelist.php'),(20794784,901,'./arorderquotelist.php'),(20794783,869,'./arorderquotelist.php'),(20794782,13431,'./arorderquotelist.php'),(20794781,799,'./arorderquotelist.php'),(20794780,4481,'./arorderquotelist.php'),(20794779,607,'./arorderquotelist.php'),(20794778,13225,'./arorderquotelist.php'),(20794777,337,'./arorderquotelist.php'),(20794776,315,'./arorderquotelist.php'),(20794773,13430,'./arorderquotedel.php'),(20794772,13429,'./arorderquotedel.php'),(20794771,8936,'./arorderquotedel.php'),(20794770,13428,'./arorderquotedel.php'),(20794769,9146,'./arorderquotedel.php'),(20794768,13427,'./arorderquotedel.php'),(20794767,3225,'./arordernumber.php'),(20794766,9521,'./arordernumber.php'),(20794765,2710,'./arordernumber.php'),(20794764,2702,'./arordernumber.php'),(20794763,2182,'./arordernumber.php'),(20794762,13123,'./arordernumber.php'),(20794761,19854,'./arordernumber.php'),(20794759,3269,'./arordermargins.php'),(20794758,2702,'./arordermargins.php'),(20794757,13493,'./arordermargins.php'),(20794756,13492,'./arordermargins.php'),(20794755,13491,'./arordermargins.php'),(20794754,2165,'./arordermargins.php'),(20794753,13490,'./arordermargins.php'),(20794752,13275,'./arordermargins.php'),(20794751,13274,'./arordermargins.php'),(20794750,13489,'./arordermargins.php'),(20794749,13484,'./arordermargins.php'),(20794748,8936,'./arordermargins.php'),(20794747,697,'./arordermargins.php'),(20794746,616,'./arordermargins.php'),(20794745,13488,'./arordermargins.php'),(20794744,13487,'./arordermargins.php'),(20794743,8995,'./arorderlistweight.php'),(20794742,8994,'./arorderlistweight.php'),(20794741,8993,'./arorderlistweight.php'),(20794740,8992,'./arorderlistweight.php'),(20794739,7019,'./arorderlistweight.php'),(20794738,8990,'./arorderlistweight.php'),(20794737,2165,'./arorderlistweight.php'),(20794736,8991,'./arorderlistweight.php'),(20794735,932,'./arorderlistweight.php'),(20794734,697,'./arorderlistweight.php'),(20794733,19877,'./arorderlistvoid.php'),(20794732,8318,'./arorderlistvoid.php'),(20794731,3173,'./arorderlistvoid.php'),(20794730,3101,'./arorderlistvoid.php'),(20794729,3090,'./arorderlistvoid.php'),(20794728,2827,'./arorderlistvoid.php'),(20794727,5492,'./arorderlistvoid.php'),(20794726,16785,'./arorderlistvoid.php'),(20794725,5388,'./arorderlistvoid.php'),(20794724,2529,'./arorderlistvoid.php'),(20794723,2404,'./arorderlistvoid.php'),(20794722,2363,'./arorderlistvoid.php'),(20794721,2231,'./arorderlistvoid.php'),(20794720,2192,'./arorderlistvoid.php'),(20794719,2182,'./arorderlistvoid.php'),(20794718,2170,'./arorderlistvoid.php'),(20794717,2151,'./arorderlistvoid.php'),(20794716,2034,'./arorderlistvoid.php'),(20794715,2103,'./arorderlistvoid.php'),(20794714,1963,'./arorderlistvoid.php'),(20794713,1788,'./arorderlistvoid.php'),(20794712,6757,'./arorderlistvoid.php'),(20794711,1709,'./arorderlistvoid.php'),(20794710,5491,'./arorderlistvoid.php'),(20794709,1357,'./arorderlistvoid.php'),(20794708,1019,'./arorderlistvoid.php'),(20794707,5965,'./arorderlistvoid.php'),(20794706,869,'./arorderlistvoid.php'),(20794705,5205,'./arorderlistvoid.php'),(20794704,744,'./arorderlistvoid.php'),(20794703,739,'./arorderlistvoid.php'),(20794702,4481,'./arorderlistvoid.php'),(20794701,607,'./arorderlistvoid.php'),(20794700,543,'./arorderlistvoid.php'),(20794699,8316,'./arorderlistvoid.php'),(20794698,355,'./arorderlistvoid.php'),(20794697,337,'./arorderlistvoid.php'),(20794696,315,'./arorderlistvoid.php'),(20794694,7817,'./arorderlistreceive.php'),(20794693,3173,'./arorderlistreceive.php'),(20794692,3101,'./arorderlistreceive.php'),(20794691,3090,'./arorderlistreceive.php'),(20794690,2948,'./arorderlistreceive.php'),(20794689,5731,'./arorderlistreceive.php'),(20794688,2818,'./arorderlistreceive.php'),(20794687,2827,'./arorderlistreceive.php'),(20794686,2813,'./arorderlistreceive.php'),(20794685,5492,'./arorderlistreceive.php'),(20794684,2676,'./arorderlistreceive.php'),(20794683,3961,'./arorderlistreceive.php'),(20794682,2657,'./arorderlistreceive.php'),(20794681,16785,'./arorderlistreceive.php'),(20794680,2590,'./arorderlistreceive.php'),(20794679,8197,'./arorderlistreceive.php'),(20794678,2529,'./arorderlistreceive.php'),(20794677,9824,'./arorderlistreceive.php'),(20794676,2459,'./arorderlistreceive.php'),(20794675,2451,'./arorderlistreceive.php'),(20794674,2363,'./arorderlistreceive.php'),(20794673,2361,'./arorderlistreceive.php'),(20794672,2315,'./arorderlistreceive.php'),(20794671,2232,'./arorderlistreceive.php'),(20794670,2231,'./arorderlistreceive.php'),(20794669,2225,'./arorderlistreceive.php'),(20794668,4793,'./arorderlistreceive.php'),(20794667,2192,'./arorderlistreceive.php'),(20794666,2182,'./arorderlistreceive.php'),(20794665,15177,'./arorderlistreceive.php'),(20794664,15176,'./arorderlistreceive.php'),(20794663,15175,'./arorderlistreceive.php'),(20794662,2170,'./arorderlistreceive.php'),(20794661,2154,'./arorderlistreceive.php'),(20794660,2151,'./arorderlistreceive.php'),(20794659,2034,'./arorderlistreceive.php'),(20794658,2103,'./arorderlistreceive.php'),(20794657,6759,'./arorderlistreceive.php'),(20794656,1963,'./arorderlistreceive.php'),(20794655,13764,'./arorderlistreceive.php'),(20794654,15174,'./arorderlistreceive.php'),(20794653,1788,'./arorderlistreceive.php'),(20794652,5389,'./arorderlistreceive.php'),(20794651,6757,'./arorderlistreceive.php'),(20794650,15173,'./arorderlistreceive.php'),(20794649,4940,'./arorderlistreceive.php'),(20794648,1668,'./arorderlistreceive.php'),(20794647,5491,'./arorderlistreceive.php'),(20794646,1357,'./arorderlistreceive.php'),(20794645,8936,'./arorderlistreceive.php'),(20794644,1036,'./arorderlistreceive.php'),(20794643,1019,'./arorderlistreceive.php'),(20794642,941,'./arorderlistreceive.php'),(20794641,932,'./arorderlistreceive.php'),(20794640,901,'./arorderlistreceive.php'),(20794639,5965,'./arorderlistreceive.php'),(20794638,5205,'./arorderlistreceive.php'),(20794637,744,'./arorderlistreceive.php'),(20794636,739,'./arorderlistreceive.php'),(20794635,4481,'./arorderlistreceive.php'),(20794634,607,'./arorderlistreceive.php'),(20794633,15172,'./arorderlistreceive.php'),(20794632,559,'./arorderlistreceive.php'),(20794631,555,'./arorderlistreceive.php'),(20794630,554,'./arorderlistreceive.php'),(20794629,551,'./arorderlistreceive.php'),(20794628,6758,'./arorderlistreceive.php'),(20794627,543,'./arorderlistreceive.php'),(20794626,6617,'./arorderlistreceive.php'),(20794625,15171,'./arorderlistreceive.php'),(20794624,7740,'./arorderlistreceive.php'),(20794623,13763,'./arorderlistreceive.php'),(20794622,14591,'./arorderlistreceive.php'),(20794621,355,'./arorderlistreceive.php'),(20794620,337,'./arorderlistreceive.php'),(20794619,325,'./arorderlistreceive.php'),(20794618,315,'./arorderlistreceive.php'),(20794617,5207,'./arorderlistreceive.php'),(20794616,250,'./arorderlistreceive.php'),(20794615,9600,'./arorderlistreceive.php'),(20794613,12162,'./arorderlist_sum.php'),(20794612,14768,'./arorderlist_sum.php'),(20794611,12161,'./arorderlist_sum.php'),(20794610,12160,'./arorderlist_sum.php'),(20794609,12163,'./arorderlist_sum.php'),(20794608,2902,'./arorderlist_sum.php'),(20794607,12159,'./arorderlist_sum.php'),(20794606,5492,'./arorderlist_sum.php'),(20794605,2700,'./arorderlist_sum.php'),(20794604,16785,'./arorderlist_sum.php'),(20794603,2508,'./arorderlist_sum.php'),(20794602,7730,'./arorderlist_sum.php'),(20794601,4793,'./arorderlist_sum.php'),(20794600,2182,'./arorderlist_sum.php'),(20794599,7676,'./arorderlist_sum.php'),(20794598,4070,'./arorderlist_sum.php'),(20794597,6138,'./arorderlist_sum.php'),(20794596,2155,'./arorderlist_sum.php'),(20794595,2033,'./arorderlist_sum.php'),(20794594,19439,'./arorderlist_sum.php'),(20794593,1963,'./arorderlist_sum.php'),(20794592,13566,'./arorderlist_sum.php'),(20794591,1647,'./arorderlist_sum.php'),(20794590,15402,'./arorderlist_sum.php'),(20794589,4106,'./arorderlist_sum.php'),(20794588,19438,'./arorderlist_sum.php'),(20794587,5491,'./arorderlist_sum.php'),(20794586,8936,'./arorderlist_sum.php'),(20794585,10867,'./arorderlist_sum.php'),(20794584,932,'./arorderlist_sum.php'),(20794583,12157,'./arorderlist_sum.php'),(20794582,9726,'./arorderlist_sum.php'),(20794581,697,'./arorderlist_sum.php'),(20794580,9492,'./arorderlist_sum.php'),(20794579,607,'./arorderlist_sum.php'),(20794578,591,'./arorderlist_sum.php'),(20794577,451,'./arorderlist_sum.php'),(20671936,5070,'./arorderlist_group.php'),(20671935,3173,'./arorderlist_group.php'),(20671934,5731,'./arorderlist_group.php'),(20671933,2818,'./arorderlist_group.php'),(20671932,14178,'./arorderlist_group.php'),(20671931,2813,'./arorderlist_group.php'),(20671930,5492,'./arorderlist_group.php'),(20671929,3961,'./arorderlist_group.php'),(20671928,2529,'./arorderlist_group.php'),(20671927,2459,'./arorderlist_group.php'),(20671926,2451,'./arorderlist_group.php'),(20671925,2363,'./arorderlist_group.php'),(20671924,2361,'./arorderlist_group.php'),(20671923,2192,'./arorderlist_group.php'),(20671922,2182,'./arorderlist_group.php'),(20671921,2170,'./arorderlist_group.php'),(20671920,7163,'./arorderlist_group.php'),(20671919,2155,'./arorderlist_group.php'),(20671918,14122,'./arorderlist_group.php'),(20671917,2033,'./arorderlist_group.php'),(20671916,2103,'./arorderlist_group.php'),(20671915,1788,'./arorderlist_group.php'),(20671914,5389,'./arorderlist_group.php'),(20671913,6757,'./arorderlist_group.php'),(20671912,13566,'./arorderlist_group.php'),(20671911,6040,'./arorderlist_group.php'),(20671910,1558,'./arorderlist_group.php'),(20671909,4106,'./arorderlist_group.php'),(20671908,5491,'./arorderlist_group.php'),(20671907,1357,'./arorderlist_group.php'),(20671906,6756,'./arorderlist_group.php'),(20671905,8936,'./arorderlist_group.php'),(20671904,941,'./arorderlist_group.php'),(20671903,932,'./arorderlist_group.php'),(20671902,744,'./arorderlist_group.php'),(20671901,737,'./arorderlist_group.php'),(20671900,4481,'./arorderlist_group.php'),(20671899,13225,'./arorderlist_group.php'),(20671898,14121,'./arorderlist_group.php'),(20671897,13224,'./arorderlist_group.php'),(20671896,9600,'./arorderlist_group.php'),(20794568,3480,'./arorderlist_backorder.php'),(20794567,3274,'./arorderlist_backorder.php'),(20794566,3173,'./arorderlist_backorder.php'),(20794565,11704,'./arorderlist_backorder.php'),(20794564,19436,'./arorderlist_backorder.php'),(20794563,19435,'./arorderlist_backorder.php'),(20794562,16318,'./arorderlist_backorder.php'),(20794561,8126,'./arorderlist_backorder.php'),(20794560,8055,'./arorderlist_backorder.php'),(20794559,5492,'./arorderlist_backorder.php'),(20794558,20244,'./arorderlist_backorder.php'),(20794557,20243,'./arorderlist_backorder.php'),(20794556,20242,'./arorderlist_backorder.php'),(20794555,20241,'./arorderlist_backorder.php'),(20794554,16785,'./arorderlist_backorder.php'),(20794553,5903,'./arorderlist_backorder.php'),(20794552,2517,'./arorderlist_backorder.php'),(20794551,8110,'./arorderlist_backorder.php'),(20794550,2509,'./arorderlist_backorder.php'),(20794549,20109,'./arorderlist_backorder.php'),(20794548,2508,'./arorderlist_backorder.php'),(20794547,14124,'./arorderlist_backorder.php'),(20794546,14123,'./arorderlist_backorder.php'),(20794545,2404,'./arorderlist_backorder.php'),(20794544,2363,'./arorderlist_backorder.php'),(20794543,2361,'./arorderlist_backorder.php'),(20794542,7758,'./arorderlist_backorder.php'),(20794541,2290,'./arorderlist_backorder.php'),(20794540,2192,'./arorderlist_backorder.php'),(20794539,2182,'./arorderlist_backorder.php'),(20794538,2170,'./arorderlist_backorder.php'),(20794537,2165,'./arorderlist_backorder.php'),(20794536,19044,'./arorderlist_backorder.php'),(20794535,5525,'./arorderlist_backorder.php'),(20794505,5070,'./arorderlist.php'),(20794504,3173,'./arorderlist.php'),(20794503,15363,'./arorderlist.php'),(20794502,3090,'./arorderlist.php'),(20794501,14661,'./arorderlist.php'),(20794500,5731,'./arorderlist.php'),(20794499,2818,'./arorderlist.php'),(20794498,8055,'./arorderlist.php'),(20794497,14776,'./arorderlist.php'),(20794496,14775,'./arorderlist.php'),(20794495,5492,'./arorderlist.php'),(20794494,2738,'./arorderlist.php'),(20794493,3961,'./arorderlist.php'),(20794492,16785,'./arorderlist.php'),(20794491,2508,'./arorderlist.php'),(20794490,15630,'./arorderlist.php'),(20794489,15629,'./arorderlist.php'),(20794488,14124,'./arorderlist.php'),(20794487,20108,'./arorderlist.php'),(20794486,15628,'./arorderlist.php'),(20794485,2459,'./arorderlist.php'),(20794484,2451,'./arorderlist.php'),(20794483,2363,'./arorderlist.php'),(20794482,2361,'./arorderlist.php'),(20794481,2290,'./arorderlist.php'),(20794480,4793,'./arorderlist.php'),(20794479,2182,'./arorderlist.php'),(20794478,7163,'./arorderlist.php'),(20794477,2155,'./arorderlist.php'),(20794476,14557,'./arorderlist.php'),(20794475,14122,'./arorderlist.php'),(20794474,2033,'./arorderlist.php'),(20794473,2103,'./arorderlist.php'),(20794472,5505,'./arorderlist.php'),(20794471,1788,'./arorderlist.php'),(20794470,5389,'./arorderlist.php'),(20794469,1751,'./arorderlist.php'),(20794468,13566,'./arorderlist.php'),(20794467,19431,'./arorderlist.php'),(20794466,6040,'./arorderlist.php'),(20794465,15402,'./arorderlist.php'),(20794464,10388,'./arorderlist.php'),(20794463,1558,'./arorderlist.php'),(20794462,4106,'./arorderlist.php'),(20794461,5491,'./arorderlist.php'),(20794460,1357,'./arorderlist.php'),(20794459,14660,'./arorderlist.php'),(20794458,11646,'./arorderlist.php'),(20794457,8936,'./arorderlist.php'),(20794456,16760,'./arorderlist.php'),(20794455,19118,'./arorderlist.php'),(20794454,941,'./arorderlist.php'),(20794453,932,'./arorderlist.php'),(20794452,869,'./arorderlist.php'),(20794451,744,'./arorderlist.php'),(20794450,737,'./arorderlist.php'),(20794449,4481,'./arorderlist.php'),(20794448,697,'./arorderlist.php'),(20794447,6307,'./arorderlist.php'),(20794446,591,'./arorderlist.php'),(20794445,13225,'./arorderlist.php'),(20794437,3118,'./arorderitemlst_backorder.php'),(20794436,8126,'./arorderitemlst_backorder.php'),(20794435,5492,'./arorderitemlst_backorder.php'),(20794434,2529,'./arorderitemlst_backorder.php'),(20794433,2524,'./arorderitemlst_backorder.php'),(20794432,2453,'./arorderitemlst_backorder.php'),(20794431,2404,'./arorderitemlst_backorder.php'),(20794430,2182,'./arorderitemlst_backorder.php'),(20794429,2170,'./arorderitemlst_backorder.php'),(20794428,8132,'./arorderitemlst_backorder.php'),(20794427,1788,'./arorderitemlst_backorder.php'),(20794426,1709,'./arorderitemlst_backorder.php'),(20794425,12215,'./arorderitemlst_backorder.php'),(20794424,8155,'./arorderitemlst_backorder.php'),(20794423,1696,'./arorderitemlst_backorder.php'),(20794422,5491,'./arorderitemlst_backorder.php'),(20794421,1357,'./arorderitemlst_backorder.php'),(20794420,941,'./arorderitemlst_backorder.php'),(20794419,932,'./arorderitemlst_backorder.php'),(20794418,869,'./arorderitemlst_backorder.php'),(20794417,197,'./arorderitemlst_backorder.php'),(20794416,3118,'./arorderitemlst.php'),(20794415,5492,'./arorderitemlst.php'),(20794414,2529,'./arorderitemlst.php'),(20794413,2524,'./arorderitemlst.php'),(20794412,2453,'./arorderitemlst.php'),(20794411,2404,'./arorderitemlst.php'),(20794410,2182,'./arorderitemlst.php'),(20794409,2170,'./arorderitemlst.php'),(20794408,2152,'./arorderitemlst.php'),(20794407,3713,'./arorderitemlst.php'),(20794406,2032,'./arorderitemlst.php'),(20794405,8067,'./arorderitemlst.php'),(20794404,1788,'./arorderitemlst.php'),(20794403,1709,'./arorderitemlst.php'),(20794402,1696,'./arorderitemlst.php'),(20794401,5491,'./arorderitemlst.php'),(20794400,1357,'./arorderitemlst.php'),(20794399,941,'./arorderitemlst.php'),(20794398,932,'./arorderitemlst.php'),(20794397,869,'./arorderitemlst.php'),(20794396,197,'./arorderitemlst.php'),(20794395,3290,'./arorderitemcustlst.php'),(20794394,3124,'./arorderitemcustlst.php'),(20794393,3090,'./arorderitemcustlst.php'),(20794392,19430,'./arorderitemcustlst.php'),(20794391,9135,'./arorderitemcustlst.php'),(20794390,2508,'./arorderitemcustlst.php'),(20794389,2451,'./arorderitemcustlst.php'),(20794388,2184,'./arorderitemcustlst.php'),(20794387,2029,'./arorderitemcustlst.php'),(20794386,4107,'./arorderitemcustlst.php'),(20794385,1963,'./arorderitemcustlst.php'),(20794384,1788,'./arorderitemcustlst.php'),(20794383,12216,'./arorderitemcustlst.php'),(20794382,6402,'./arorderitemcustlst.php'),(20794381,6366,'./arorderitemcustlst.php'),(20794380,1724,'./arorderitemcustlst.php'),(20794379,1710,'./arorderitemcustlst.php'),(20794378,1739,'./arorderitemcustlst.php'),(20794377,1532,'./arorderitemcustlst.php'),(20794376,1357,'./arorderitemcustlst.php'),(20794375,1019,'./arorderitemcustlst.php'),(20794374,872,'./arorderitemcustlst.php'),(20794373,737,'./arorderitemcustlst.php'),(20794372,4481,'./arorderitemcustlst.php'),(20794371,697,'./arorderitemcustlst.php'),(20794370,607,'./arorderitemcustlst.php'),(20794369,19429,'./arorderitemcustlst.php'),(20794368,337,'./arorderitemcustlst.php'),(20794367,315,'./arorderitemcustlst.php'),(20671688,5161,'./arorderfill.php'),(20671687,2967,'./arorderfill.php'),(20671686,2932,'./arorderfill.php'),(20671685,2933,'./arorderfill.php'),(20671684,2824,'./arorderfill.php'),(20671683,2501,'./arorderfill.php'),(20671682,2363,'./arorderfill.php'),(20671681,2193,'./arorderfill.php'),(20671680,2182,'./arorderfill.php'),(20671679,2173,'./arorderfill.php'),(20671678,2158,'./arorderfill.php'),(20671677,2024,'./arorderfill.php'),(20671676,1963,'./arorderfill.php'),(20671675,1754,'./arorderfill.php'),(20671674,1446,'./arorderfill.php'),(20671673,1410,'./arorderfill.php'),(20671672,1408,'./arorderfill.php'),(20671671,1125,'./arorderfill.php'),(20671670,4481,'./arorderfill.php'),(20671669,315,'./arorderfill.php'),(20794354,3124,'./arordercustitemlst.php'),(20794353,3118,'./arordercustitemlst.php'),(20794352,5492,'./arordercustitemlst.php'),(20794351,15255,'./arordercustitemlst.php'),(20794350,2508,'./arordercustitemlst.php'),(20794349,2451,'./arordercustitemlst.php'),(20794348,2184,'./arordercustitemlst.php'),(20794347,2170,'./arordercustitemlst.php'),(20794346,2029,'./arordercustitemlst.php'),(20794345,4107,'./arordercustitemlst.php'),(20794344,1963,'./arordercustitemlst.php'),(20794343,1788,'./arordercustitemlst.php'),(20794342,6366,'./arordercustitemlst.php'),(20794341,1724,'./arordercustitemlst.php'),(20794340,1710,'./arordercustitemlst.php'),(20794339,1739,'./arordercustitemlst.php'),(20794338,15169,'./arordercustitemlst.php'),(20794337,1532,'./arordercustitemlst.php'),(20794336,5491,'./arordercustitemlst.php'),(20794335,1357,'./arordercustitemlst.php'),(20794334,1019,'./arordercustitemlst.php'),(20794333,901,'./arordercustitemlst.php'),(20794332,872,'./arordercustitemlst.php'),(20794331,737,'./arordercustitemlst.php'),(20794330,4481,'./arordercustitemlst.php'),(20794329,6394,'./arordercustitemlst.php'),(20794328,6755,'./arordercustitemlst.php'),(20794327,697,'./arordercustitemlst.php'),(20794326,607,'./arordercustitemlst.php'),(20794325,337,'./arordercustitemlst.php'),(20794324,315,'./arordercustitemlst.php'),(20794323,6393,'./arordercustitemlst.php'),(20794322,197,'./arordercustitemlst.php'),(20671626,3173,'./arorderconfirm.php'),(20671625,4884,'./arorderconfirm.php'),(20671624,5492,'./arorderconfirm.php'),(20671623,16785,'./arorderconfirm.php'),(20671622,2517,'./arorderconfirm.php'),(20671621,2404,'./arorderconfirm.php'),(20671620,2363,'./arorderconfirm.php'),(20671619,2192,'./arorderconfirm.php'),(20671618,2182,'./arorderconfirm.php'),(20671617,2170,'./arorderconfirm.php'),(20671616,6455,'./arorderconfirm.php'),(20671615,2103,'./arorderconfirm.php'),(20671614,1788,'./arorderconfirm.php'),(20671613,1709,'./arorderconfirm.php'),(20671612,4106,'./arorderconfirm.php'),(20671611,5491,'./arorderconfirm.php'),(20671610,1357,'./arorderconfirm.php'),(20671609,941,'./arorderconfirm.php'),(20671608,932,'./arorderconfirm.php'),(20671607,869,'./arorderconfirm.php'),(20671605,5160,'./arorderckout.php'),(20671604,2824,'./arorderckout.php'),(20671603,2702,'./arorderckout.php'),(20671602,2629,'./arorderckout.php'),(20671601,2638,'./arorderckout.php'),(20671600,2501,'./arorderckout.php'),(20671599,2363,'./arorderckout.php'),(20671598,2191,'./arorderckout.php'),(20671597,2182,'./arorderckout.php'),(20671596,2173,'./arorderckout.php'),(20671595,2172,'./arorderckout.php'),(20671594,2158,'./arorderckout.php'),(20671593,2024,'./arorderckout.php'),(20671592,1963,'./arorderckout.php'),(20671591,1754,'./arorderckout.php'),(20671590,1446,'./arorderckout.php'),(20671589,1063,'./arorderckout.php'),(20671588,4481,'./arorderckout.php'),(20671587,494,'./arorderckout.php'),(20671586,502,'./arorderckout.php'),(20671585,315,'./arorderckout.php'),(20794321,3090,'./arorder_volume_detail.php'),(20794320,5490,'./arorder_volume_detail.php'),(20794319,2798,'./arorder_volume_detail.php'),(20794318,2589,'./arorder_volume_detail.php'),(20794317,2165,'./arorder_volume_detail.php'),(20794316,2129,'./arorder_volume_detail.php'),(20794315,2106,'./arorder_volume_detail.php'),(20794314,1871,'./arorder_volume_detail.php'),(20794313,1821,'./arorder_volume_detail.php'),(20794312,1749,'./arorder_volume_detail.php'),(20794311,1747,'./arorder_volume_detail.php'),(20794310,1741,'./arorder_volume_detail.php'),(20794309,1678,'./arorder_volume_detail.php'),(20794308,4169,'./arorder_volume_detail.php'),(20794307,4168,'./arorder_volume_detail.php'),(20794306,1375,'./arorder_volume_detail.php'),(20794305,778,'./arorder_volume_detail.php'),(20794304,697,'./arorder_volume_detail.php'),(20794303,596,'./arorder_volume_detail.php'),(20794302,542,'./arorder_volume_detail.php'),(20794301,315,'./arorder_volume_detail.php'),(20794300,308,'./arorder_volume_detail.php'),(20794299,275,'./arorder_volume_detail.php'),(20794298,3415,'./arorder_volume.php'),(20794297,3882,'./arorder_volume.php'),(20794296,3090,'./arorder_volume.php'),(20794295,5159,'./arorder_volume.php'),(20794294,5158,'./arorder_volume.php'),(20794293,2985,'./arorder_volume.php'),(20794292,2935,'./arorder_volume.php'),(20794291,12220,'./arorder_volume.php'),(20794290,5488,'./arorder_volume.php'),(20794289,2798,'./arorder_volume.php'),(20794288,2590,'./arorder_volume.php'),(20794287,2529,'./arorder_volume.php'),(20794286,9013,'./arorder_volume.php'),(20794285,4793,'./arorder_volume.php'),(20794284,2129,'./arorder_volume.php'),(20794283,4166,'./arorder_volume.php'),(20794282,2106,'./arorder_volume.php'),(20794281,2070,'./arorder_volume.php'),(20794280,1963,'./arorder_volume.php'),(20794279,1913,'./arorder_volume.php'),(20794278,1871,'./arorder_volume.php'),(20794277,1821,'./arorder_volume.php'),(20794276,1749,'./arorder_volume.php'),(20794275,1747,'./arorder_volume.php'),(20794274,1741,'./arorder_volume.php'),(20794273,4165,'./arorder_volume.php'),(20794272,4164,'./arorder_volume.php'),(20794271,5486,'./arorder_volume.php'),(20794270,1375,'./arorder_volume.php'),(20794269,778,'./arorder_volume.php'),(20794268,749,'./arorder_volume.php'),(20794267,4162,'./arorder_volume.php'),(20794266,9158,'./arorder_volume.php'),(20794265,9157,'./arorder_volume.php'),(20794264,9156,'./arorder_volume.php'),(20794263,308,'./arorder_volume.php'),(20794262,275,'./arorder_volume.php'),(20794261,197,'./arorder_volume.php'),(20794260,3173,'./arorder_unconfirmed.php'),(20794259,5492,'./arorder_unconfirmed.php'),(20794258,16785,'./arorder_unconfirmed.php'),(20794257,2517,'./arorder_unconfirmed.php'),(20794256,2404,'./arorder_unconfirmed.php'),(20794255,2363,'./arorder_unconfirmed.php'),(20794254,2192,'./arorder_unconfirmed.php'),(20794253,2182,'./arorder_unconfirmed.php'),(20794252,2170,'./arorder_unconfirmed.php'),(20794251,6754,'./arorder_unconfirmed.php'),(20794250,6455,'./arorder_unconfirmed.php'),(20794249,2103,'./arorder_unconfirmed.php'),(20794248,1788,'./arorder_unconfirmed.php'),(20794247,1709,'./arorder_unconfirmed.php'),(20794246,4106,'./arorder_unconfirmed.php'),(20794245,5491,'./arorder_unconfirmed.php'),(20794244,1357,'./arorder_unconfirmed.php'),(20794243,941,'./arorder_unconfirmed.php'),(20794242,932,'./arorder_unconfirmed.php'),(20794241,869,'./arorder_unconfirmed.php'),(20794240,6488,'./arorder_unconfirmed.php'),(20794238,4298,'./arorder_over_hours.php'),(20794237,8090,'./arorder_over_hours.php'),(20794236,8089,'./arorder_over_hours.php'),(20794235,5633,'./arorder_over_hours.php'),(20794234,8088,'./arorder_over_hours.php'),(20794233,2165,'./arorder_over_hours.php'),(20794232,8087,'./arorder_over_hours.php'),(20794231,8086,'./arorder_over_hours.php'),(20794230,8085,'./arorder_over_hours.php'),(20794229,8084,'./arorder_over_hours.php'),(20794228,697,'./arorder_over_hours.php'),(20794227,8083,'./arorder_over_hours.php'),(20794226,8082,'./arorder_over_hours.php'),(20794225,8081,'./arorder_over_hours.php'),(20794224,11443,'./arorder_hold.php'),(20794223,6493,'./arorder_confirm.php'),(20794222,2334,'./arorder_confirm.php'),(20794221,6308,'./arorder_confirm.php'),(20794220,6492,'./arorder_confirm.php'),(20794219,6307,'./arorder_confirm.php'),(20794218,542,'./arorder_confirm.php'),(20794217,13065,'./arorder_add_deposit.php'),(20794216,17112,'./arorder_add_deposit.php'),(20794215,14555,'./arorder_add_deposit.php'),(20794214,3324,'./arorder_add_deposit.php'),(20794213,3202,'./arorder_add_deposit.php'),(20794212,17114,'./arorder_add_deposit.php'),(20794211,17113,'./arorder_add_deposit.php'),(20794210,7739,'./arorder_add_deposit.php'),(20794209,5663,'./arorder_add_deposit.php'),(20794208,17111,'./arorder_add_deposit.php'),(20794207,2702,'./arorder_add_deposit.php'),(20794206,5918,'./arorder_add_deposit.php'),(20794205,5917,'./arorder_add_deposit.php'),(20794204,5916,'./arorder_add_deposit.php'),(20794203,5915,'./arorder_add_deposit.php'),(20794202,5914,'./arorder_add_deposit.php'),(20794201,5913,'./arorder_add_deposit.php'),(20794200,17124,'./arorder_add_deposit.php'),(20794199,2260,'./arorder_add_deposit.php'),(20794198,6786,'./arorder_add_deposit.php'),(20794197,2165,'./arorder_add_deposit.php'),(20794196,15812,'./arorder_add_deposit.php'),(20794195,8183,'./arorder_add_deposit.php'),(20794194,13064,'./arorder_add_deposit.php'),(20794193,13063,'./arorder_add_deposit.php'),(20794192,13200,'./arorder_add_deposit.php'),(20794191,1232,'./arorder_add_deposit.php'),(20794190,5479,'./arorder_add_deposit.php'),(20794189,5839,'./arorder_add_deposit.php'),(20794239,197,'./arorder_unconfirmed.php'),(20794174,4547,'./arorder_activity.php'),(20794173,5993,'./arorder_activity.php'),(20794172,3090,'./arorder_activity.php'),(20794171,5992,'./arorder_activity.php'),(20794170,5991,'./arorder_activity.php'),(20794169,5990,'./arorder_activity.php'),(20794168,12169,'./arorder_activity.php'),(20794167,16848,'./arorder_activity.php'),(20794166,5988,'./arorder_activity.php'),(20794165,5987,'./arorder_activity.php'),(20794164,5986,'./arorder_activity.php'),(20794163,2182,'./arorder_activity.php'),(20794162,4391,'./arorder_activity.php'),(20794161,1963,'./arorder_activity.php'),(20794160,5984,'./arorder_activity.php'),(20794159,5983,'./arorder_activity.php'),(20794158,5982,'./arorder_activity.php'),(20794157,1678,'./arorder_activity.php'),(20794156,1672,'./arorder_activity.php'),(20794155,13902,'./arorder_activity.php'),(20794154,13916,'./arorder_activity.php'),(20794153,15991,'./arorder_activity.php'),(20794152,5981,'./arorder_activity.php'),(20794151,1019,'./arorder_activity.php'),(20794150,901,'./arorder_activity.php'),(20794149,5980,'./arorder_activity.php'),(20794148,697,'./arorder_activity.php'),(20794147,6429,'./arorder_activity.php'),(20794146,9492,'./arorder_activity.php'),(20794145,607,'./arorder_activity.php'),(20794144,9179,'./arorder_activity.php'),(20794143,451,'./arorder_activity.php'),(20794142,337,'./arorder_activity.php'),(20794141,315,'./arorder_activity.php'),(20794140,197,'./arorder_activity.php'),(20794139,5979,'./arorder_activity.php'),(20794138,5978,'./arorder_activity.php'),(20795095,981,'./arordquotefpdf.php'),(20795094,869,'./arordquotefpdf.php'),(20794137,3319,'./arorder2invoice.php'),(20794136,6176,'./arorder2invoice.php'),(20794135,3450,'./arorder2invoice.php'),(20794134,4861,'./arorder2invoice.php'),(20794133,17844,'./arorder2invoice.php'),(20794132,4121,'./arorder2invoice.php'),(20794131,4120,'./arorder2invoice.php'),(20794130,3072,'./arorder2invoice.php'),(20794129,6753,'./arorder2invoice.php'),(20794128,2998,'./arorder2invoice.php'),(20794127,2948,'./arorder2invoice.php'),(20794126,8037,'./arorder2invoice.php'),(20794125,19269,'./arorder2invoice.php'),(20794124,17366,'./arorder2invoice.php'),(20794123,14132,'./arorder2invoice.php'),(20794122,2766,'./arorder2invoice.php'),(20794121,3961,'./arorder2invoice.php'),(20794120,18010,'./arorder2invoice.php'),(20794119,18009,'./arorder2invoice.php'),(20794118,6752,'./arorder2invoice.php'),(20794117,2540,'./arorder2invoice.php'),(20794116,5647,'./arorder2invoice.php'),(20794115,6751,'./arorder2invoice.php'),(20794114,2363,'./arorder2invoice.php'),(20794113,2315,'./arorder2invoice.php'),(20794112,8056,'./arorder2invoice.php'),(20794111,6750,'./arorder2invoice.php'),(20794110,6749,'./arorder2invoice.php'),(20794109,16164,'./arorder2invoice.php'),(20794108,2182,'./arorder2invoice.php'),(20794107,13485,'./arorder2invoice.php'),(20794106,7728,'./arorder2invoice.php'),(20794105,3718,'./arorder2invoice.php'),(20794104,2165,'./arorder2invoice.php'),(20794103,2151,'./arorder2invoice.php'),(20794102,2150,'./arorder2invoice.php'),(20794101,2054,'./arorder2invoice.php'),(20794100,5646,'./arorder2invoice.php'),(20794099,18008,'./arorder2invoice.php'),(20794098,18007,'./arorder2invoice.php'),(20794097,1963,'./arorder2invoice.php'),(20794096,18274,'./arorder2invoice.php'),(20794095,1788,'./arorder2invoice.php'),(20794094,7737,'./arorder2invoice.php'),(20794093,7736,'./arorder2invoice.php'),(20794092,1770,'./arorder2invoice.php'),(20794091,9167,'./arorder2invoice.php'),(20794090,1696,'./arorder2invoice.php'),(20794089,1595,'./arorder2invoice.php'),(20794088,9166,'./arorder2invoice.php'),(20794087,9165,'./arorder2invoice.php'),(20794086,5652,'./arorder2invoice.php'),(20794085,13611,'./arorder2invoice.php'),(20794084,14556,'./arorder2invoice.php'),(20794083,1672,'./arorder2invoice.php'),(20794082,1668,'./arorder2invoice.php'),(20794081,1540,'./arorder2invoice.php'),(20794080,1232,'./arorder2invoice.php'),(20794079,8936,'./arorder2invoice.php'),(20794078,1139,'./arorder2invoice.php'),(20794077,6748,'./arorder2invoice.php'),(20794076,981,'./arorder2invoice.php'),(20794075,925,'./arorder2invoice.php'),(20794074,697,'./arorder2invoice.php'),(20795473,1743,'./arordshipviewfpdf.php'),(20795472,9622,'./arordshipviewfpdf.php'),(20795471,5081,'./arordshipviewfpdf.php'),(20795470,1668,'./arordshipviewfpdf.php'),(20795469,1647,'./arordshipviewfpdf.php'),(20795468,13434,'./arordshipviewfpdf.php'),(20795467,7581,'./arordshipviewfpdf.php'),(20795466,1373,'./arordshipviewfpdf.php'),(20795380,4481,'./arordshipview.php'),(20795379,7999,'./arordshipview.php'),(20795175,18004,'./arordshipadd.php'),(20795174,1775,'./arordshipadd.php'),(20795173,1773,'./arordshipadd.php'),(20795172,1770,'./arordshipadd.php'),(20795171,14104,'./arordshipadd.php'),(20795025,1373,'./arordpicktickfpdf.php'),(20795024,1338,'./arordpicktickfpdf.php'),(20795023,8936,'./arordpicktickfpdf.php'),(20794444,14121,'./arorderlist.php'),(20794443,13224,'./arorderlist.php'),(20794056,3427,'./arordconfirmfpdf.php'),(20794055,3172,'./arordconfirmfpdf.php'),(20794054,14768,'./arordconfirmfpdf.php'),(20794053,3090,'./arordconfirmfpdf.php'),(20794052,2998,'./arordconfirmfpdf.php'),(20794051,2977,'./arordconfirmfpdf.php'),(20794050,4513,'./arordconfirmfpdf.php'),(20794049,5225,'./arordconfirmfpdf.php'),(20794048,2833,'./arordconfirmfpdf.php'),(20794047,2827,'./arordconfirmfpdf.php'),(20794046,5687,'./arordconfirmfpdf.php'),(20794045,5686,'./arordconfirmfpdf.php'),(20794044,13951,'./arordconfirmfpdf.php'),(20794043,2529,'./arordconfirmfpdf.php'),(20794042,4678,'./arordconfirmfpdf.php'),(20794041,2315,'./arordconfirmfpdf.php'),(20794040,2262,'./arordconfirmfpdf.php'),(20794039,2225,'./arordconfirmfpdf.php'),(20794038,2222,'./arordconfirmfpdf.php'),(20794037,8990,'./arordconfirmfpdf.php'),(20794036,2182,'./arordconfirmfpdf.php'),(20794035,15329,'./arordconfirmfpdf.php'),(20794034,2165,'./arordconfirmfpdf.php'),(20794033,1963,'./arordconfirmfpdf.php'),(20794015,13223,'./arordclone.php'),(20794014,13222,'./arordclone.php'),(20794013,8936,'./arordclone.php'),(20794012,18048,'./arordclone.php'),(20794010,14056,'./arordcc.php'),(20794009,14157,'./arordcc.php'),(20794008,5926,'./arordcc.php'),(20794007,5925,'./arordcc.php'),(20794006,10622,'./arordcc.php'),(20794005,10621,'./arordcc.php'),(20794004,5924,'./arordcc.php'),(20794003,11406,'./arordcc.php'),(20794002,2464,'./arordcc.php'),(20794001,5917,'./arordcc.php'),(20794000,5916,'./arordcc.php'),(20793999,5915,'./arordcc.php'),(20793998,5914,'./arordcc.php'),(20793997,5913,'./arordcc.php'),(20793996,5923,'./arordcc.php'),(20793995,2260,'./arordcc.php'),(20793994,4023,'./arordcc.php'),(20793993,2215,'./arordcc.php'),(20793992,2182,'./arordcc.php'),(20793991,16163,'./arordcc.php'),(20793990,1992,'./arordcc.php'),(20793989,16162,'./arordcc.php'),(20793988,1963,'./arordcc.php'),(20793987,15253,'./arordcc.php'),(20793986,10619,'./arordcc.php'),(20793985,6745,'./arordcc.php'),(20793984,1583,'./arordcc.php'),(20793983,1582,'./arordcc.php'),(20793982,6744,'./arordcc.php'),(20793981,5922,'./arordcc.php'),(20793980,1232,'./arordcc.php'),(20793979,5920,'./arordcc.php'),(20793978,5725,'./arordcc.php'),(20793977,5912,'./arordcc.php'),(20793976,5910,'./arordcc.php'),(20793975,6697,'./arordcc.php'),(20793974,9380,'./arordcc.php'),(20793973,9379,'./arordcc.php'),(20793972,9378,'./arordcc.php'),(20793971,10776,'./arordcc.php'),(19914799,3371,'./arordadd.php'),(19914798,7196,'./arordadd.php'),(19914797,3210,'./arordadd.php'),(19914796,3165,'./arordadd.php'),(19914795,3090,'./arordadd.php'),(19914794,3030,'./arordadd.php'),(19914793,2998,'./arordadd.php'),(19914792,2977,'./arordadd.php'),(19914791,2820,'./arordadd.php'),(19914790,2819,'./arordadd.php'),(19914789,8126,'./arordadd.php'),(19914788,2817,'./arordadd.php'),(19914787,8055,'./arordadd.php'),(19914786,6454,'./arordadd.php'),(19914785,5847,'./arordadd.php'),(19914784,2702,'./arordadd.php'),(19914783,2676,'./arordadd.php'),(19914782,3961,'./arordadd.php'),(19914781,2665,'./arordadd.php'),(19914780,2586,'./arordadd.php'),(19914779,5846,'./arordadd.php'),(19914778,2541,'./arordadd.php'),(19914777,2529,'./arordadd.php'),(19914776,2527,'./arordadd.php'),(19914775,2501,'./arordadd.php'),(19914774,5918,'./arordadd.php'),(19914773,11734,'./arordadd.php'),(19914772,2405,'./arordadd.php'),(19914771,2404,'./arordadd.php'),(19914770,5917,'./arordadd.php'),(19914769,5916,'./arordadd.php'),(19914768,5915,'./arordadd.php'),(19914767,5914,'./arordadd.php'),(19914766,5913,'./arordadd.php'),(19914765,2334,'./arordadd.php'),(19914764,2260,'./arordadd.php'),(19914763,6118,'./arordadd.php'),(19914762,2168,'./arordadd.php'),(19914761,6742,'./arordadd.php'),(19914760,6117,'./arordadd.php'),(19914759,2103,'./arordadd.php'),(19914758,2071,'./arordadd.php'),(19914757,1963,'./arordadd.php'),(19914756,1788,'./arordadd.php'),(19914755,1775,'./arordadd.php'),(19914754,1727,'./arordadd.php'),(19914753,1599,'./arordadd.php'),(19914752,3481,'./arordadd.php'),(19914751,5502,'./arordadd.php'),(19914750,1422,'./arordadd.php'),(19914749,1232,'./arordadd.php'),(19914748,6116,'./arordadd.php'),(19914747,1012,'./arordadd.php'),(19914746,985,'./arordadd.php'),(19914745,6308,'./arordadd.php'),(19914744,6115,'./arordadd.php'),(19914743,941,'./arordadd.php'),(19914742,932,'./arordadd.php'),(19914741,11815,'./arordadd.php'),(19914740,869,'./arordadd.php'),(19914739,716,'./arordadd.php'),(19914738,4481,'./arordadd.php'),(19914737,697,'./arordadd.php'),(19914736,9341,'./arordadd.php'),(19914735,7623,'./arordadd.php'),(19914734,607,'./arordadd.php'),(19914733,6307,'./arordadd.php'),(19914732,18048,'./arordadd.php'),(19914731,5911,'./arordadd.php'),(19914730,315,'./arordadd.php'),(19914729,5570,'./arordadd.php'),(19914728,152,'./arordadd.php'),(19914727,85,'./arordadd.php'),(19914726,71,'./arordadd.php'),(20793966,13793,'./armessage.php'),(20793965,13792,'./armessage.php'),(20793964,8936,'./armessage.php'),(20793963,604,'./armessage.php'),(20793962,13791,'./armessage.php'),(20793961,12726,'./armessage.php'),(20793960,13790,'./armessage.php'),(20671222,3415,'./aritemsaleslst_alt.php'),(20671221,3360,'./aritemsaleslst_alt.php'),(20671220,3269,'./aritemsaleslst_alt.php'),(20671219,9275,'./aritemsaleslst_alt.php'),(20671218,3101,'./aritemsaleslst_alt.php'),(20671217,9274,'./aritemsaleslst_alt.php'),(20671216,9273,'./aritemsaleslst_alt.php'),(20671215,6731,'./aritemsaleslst_alt.php'),(20671214,9272,'./aritemsaleslst_alt.php'),(20671213,9271,'./aritemsaleslst_alt.php'),(20671212,2698,'./aritemsaleslst_alt.php'),(20671211,9270,'./aritemsaleslst_alt.php'),(20671210,9269,'./aritemsaleslst_alt.php'),(20671209,2508,'./aritemsaleslst_alt.php'),(20671208,9268,'./aritemsaleslst_alt.php'),(20671207,9267,'./aritemsaleslst_alt.php'),(20671206,9266,'./aritemsaleslst_alt.php'),(20671205,9265,'./aritemsaleslst_alt.php'),(20671204,2070,'./aritemsaleslst_alt.php'),(20671203,1963,'./aritemsaleslst_alt.php'),(20671202,1913,'./aritemsaleslst_alt.php'),(20671201,1788,'./aritemsaleslst_alt.php'),(20671200,1709,'./aritemsaleslst_alt.php'),(20671199,1703,'./aritemsaleslst_alt.php'),(20671198,1696,'./aritemsaleslst_alt.php'),(20671197,9264,'./aritemsaleslst_alt.php'),(20671196,9263,'./aritemsaleslst_alt.php'),(20671195,9262,'./aritemsaleslst_alt.php'),(20671194,1019,'./aritemsaleslst_alt.php'),(20671193,9261,'./aritemsaleslst_alt.php'),(20671192,749,'./aritemsaleslst_alt.php'),(20671191,737,'./aritemsaleslst_alt.php'),(20671190,4481,'./aritemsaleslst_alt.php'),(20671189,697,'./aritemsaleslst_alt.php'),(20671188,616,'./aritemsaleslst_alt.php'),(20671187,607,'./aritemsaleslst_alt.php'),(20671186,542,'./aritemsaleslst_alt.php'),(20671185,9260,'./aritemsaleslst_alt.php'),(20671184,451,'./aritemsaleslst_alt.php'),(20671183,337,'./aritemsaleslst_alt.php'),(20671182,315,'./aritemsaleslst_alt.php'),(20671181,197,'./aritemsaleslst_alt.php'),(20793959,3421,'./aritemsaleslst.php'),(20793958,3415,'./aritemsaleslst.php'),(20793957,3360,'./aritemsaleslst.php'),(20793956,12722,'./aritemsaleslst.php'),(20793955,3292,'./aritemsaleslst.php'),(20793954,3274,'./aritemsaleslst.php'),(20793953,3269,'./aritemsaleslst.php'),(20793952,6011,'./aritemsaleslst.php'),(20793951,9275,'./aritemsaleslst.php'),(20793950,3101,'./aritemsaleslst.php'),(20793949,9274,'./aritemsaleslst.php'),(20793948,9273,'./aritemsaleslst.php'),(20793947,2948,'./aritemsaleslst.php'),(20793946,6731,'./aritemsaleslst.php'),(20793945,9272,'./aritemsaleslst.php'),(20793944,14131,'./aritemsaleslst.php'),(20793943,12721,'./aritemsaleslst.php'),(20793942,12692,'./aritemsaleslst.php'),(20793941,12092,'./aritemsaleslst.php'),(20793940,9271,'./aritemsaleslst.php'),(20793939,19448,'./aritemsaleslst.php'),(20793938,19468,'./aritemsaleslst.php'),(20793937,2698,'./aritemsaleslst.php'),(20793936,9270,'./aritemsaleslst.php'),(20793935,9269,'./aritemsaleslst.php'),(20793934,2508,'./aritemsaleslst.php'),(20793933,9268,'./aritemsaleslst.php'),(20793932,9267,'./aritemsaleslst.php'),(20793931,9266,'./aritemsaleslst.php'),(20793930,11882,'./aritemsaleslst.php'),(20793929,2225,'./aritemsaleslst.php'),(20793928,2151,'./aritemsaleslst.php'),(20793927,9265,'./aritemsaleslst.php'),(20793926,2070,'./aritemsaleslst.php'),(20793925,1963,'./aritemsaleslst.php'),(20793924,19852,'./aritemsaleslst.php'),(20793923,1913,'./aritemsaleslst.php'),(20793922,1788,'./aritemsaleslst.php'),(20793921,1709,'./aritemsaleslst.php'),(20793920,1703,'./aritemsaleslst.php'),(20793919,1696,'./aritemsaleslst.php'),(20793918,1678,'./aritemsaleslst.php'),(20793917,1672,'./aritemsaleslst.php'),(20793916,1668,'./aritemsaleslst.php'),(20793915,9264,'./aritemsaleslst.php'),(20793914,9263,'./aritemsaleslst.php'),(20793913,9262,'./aritemsaleslst.php'),(20793912,1019,'./aritemsaleslst.php'),(20793911,9261,'./aritemsaleslst.php'),(20793910,869,'./aritemsaleslst.php'),(20793909,749,'./aritemsaleslst.php'),(20793908,737,'./aritemsaleslst.php'),(20793907,4481,'./aritemsaleslst.php'),(20793906,13836,'./aritemsaleslst.php'),(20793905,697,'./aritemsaleslst.php'),(20793904,616,'./aritemsaleslst.php'),(20793903,607,'./aritemsaleslst.php'),(20793897,3090,'./aritemsaleshistory.php'),(20793896,9484,'./aritemsaleshistory.php'),(20793895,20236,'./aritemsaleshistory.php'),(20793894,2137,'./aritemsaleshistory.php'),(20793893,9265,'./aritemsaleshistory.php'),(20793892,1963,'./aritemsaleshistory.php'),(20793891,1788,'./aritemsaleshistory.php'),(20793890,20102,'./aritemsaleshistory.php'),(20793889,20101,'./aritemsaleshistory.php'),(20793888,20100,'./aritemsaleshistory.php'),(20793887,20099,'./aritemsaleshistory.php'),(20793886,6366,'./aritemsaleshistory.php'),(20793885,1724,'./aritemsaleshistory.php'),(20793884,1696,'./aritemsaleshistory.php'),(20793883,12815,'./aritemsaleshistory.php'),(20793882,12814,'./aritemsaleshistory.php'),(20793881,12813,'./aritemsaleshistory.php'),(20793880,1019,'./aritemsaleshistory.php'),(20793879,869,'./aritemsaleshistory.php'),(20793878,12812,'./aritemsaleshistory.php'),(20793877,697,'./aritemsaleshistory.php'),(20793876,9492,'./aritemsaleshistory.php'),(20793871,19428,'./aritemcalcreorderpoint.php'),(20793870,13592,'./aritemcalcreorderpoint.php'),(20793869,16612,'./aritemcalcreorderpoint.php'),(20793868,8508,'./aritemcalcreorderpoint.php'),(20793867,2702,'./aritemcalcreorderpoint.php'),(20793866,11953,'./aritemcalcreorderpoint.php'),(20793865,2516,'./aritemcalcreorderpoint.php'),(20793864,2509,'./aritemcalcreorderpoint.php'),(20793863,19427,'./aritemcalcreorderpoint.php'),(20793862,20098,'./aritemcalcreorderpoint.php'),(20793861,12810,'./aritemcalcreorderpoint.php'),(20793860,12809,'./aritemcalcreorderpoint.php'),(20793859,12808,'./aritemcalcreorderpoint.php'),(20793858,18494,'./aritemcalcreorderpoint.php'),(20793857,1963,'./aritemcalcreorderpoint.php'),(20793856,19426,'./aritemcalcreorderpoint.php'),(20793855,1894,'./aritemcalcreorderpoint.php'),(20793854,1863,'./aritemcalcreorderpoint.php'),(20793853,1788,'./aritemcalcreorderpoint.php'),(20793837,3427,'./arinvoiceviewfpdf_small3.php'),(20793836,19877,'./arinvoiceviewfpdf_small3.php'),(20793835,3172,'./arinvoiceviewfpdf_small3.php'),(20793834,3090,'./arinvoiceviewfpdf_small3.php'),(20793833,2998,'./arinvoiceviewfpdf_small3.php'),(20793832,2977,'./arinvoiceviewfpdf_small3.php'),(20793831,3913,'./arinvoiceviewfpdf_small3.php'),(20793830,2819,'./arinvoiceviewfpdf_small3.php'),(20793829,2833,'./arinvoiceviewfpdf_small3.php'),(20793828,5687,'./arinvoiceviewfpdf_small3.php'),(20793827,5686,'./arinvoiceviewfpdf_small3.php'),(20793826,12851,'./arinvoiceviewfpdf_small3.php'),(20793825,6741,'./arinvoiceviewfpdf_small3.php'),(20793824,5689,'./arinvoiceviewfpdf_small3.php'),(20793823,2591,'./arinvoiceviewfpdf_small3.php'),(20793822,2222,'./arinvoiceviewfpdf_small3.php'),(20793821,6739,'./arinvoiceviewfpdf_small3.php'),(20793820,2208,'./arinvoiceviewfpdf_small3.php'),(20793819,1963,'./arinvoiceviewfpdf_small3.php'),(20793818,5685,'./arinvoiceviewfpdf_small3.php'),(20793817,1781,'./arinvoiceviewfpdf_small3.php'),(20793816,1678,'./arinvoiceviewfpdf_small3.php'),(20793815,9248,'./arinvoiceviewfpdf_small3.php'),(20793814,1668,'./arinvoiceviewfpdf_small3.php'),(20793813,1467,'./arinvoiceviewfpdf_small3.php'),(20793812,5684,'./arinvoiceviewfpdf_small3.php'),(20793811,5682,'./arinvoiceviewfpdf_small3.php'),(20793810,982,'./arinvoiceviewfpdf_small3.php'),(20793809,9224,'./arinvoiceviewfpdf_small3.php'),(20793808,869,'./arinvoiceviewfpdf_small3.php'),(20793807,737,'./arinvoiceviewfpdf_small3.php'),(20793806,697,'./arinvoiceviewfpdf_small3.php'),(20793805,673,'./arinvoiceviewfpdf_small3.php'),(20793804,670,'./arinvoiceviewfpdf_small3.php'),(20793803,542,'./arinvoiceviewfpdf_small3.php'),(20793802,5456,'./arinvoiceviewfpdf_small3.php'),(20793801,479,'./arinvoiceviewfpdf_small3.php'),(20793800,445,'./arinvoiceviewfpdf_small3.php'),(20793799,306,'./arinvoiceviewfpdf_small3.php'),(20793798,5683,'./arinvoiceviewfpdf_small3.php'),(20793797,3427,'./arinvoiceviewfpdf_small2.php'),(20793796,8216,'./arinvoiceviewfpdf_small2.php'),(20793795,19877,'./arinvoiceviewfpdf_small2.php'),(20793794,2998,'./arinvoiceviewfpdf_small2.php'),(20793793,2977,'./arinvoiceviewfpdf_small2.php'),(20793792,2833,'./arinvoiceviewfpdf_small2.php'),(20793791,5687,'./arinvoiceviewfpdf_small2.php'),(20793790,5686,'./arinvoiceviewfpdf_small2.php'),(20793789,6741,'./arinvoiceviewfpdf_small2.php'),(20793788,5689,'./arinvoiceviewfpdf_small2.php'),(20793787,2508,'./arinvoiceviewfpdf_small2.php'),(20793786,2225,'./arinvoiceviewfpdf_small2.php'),(20793785,2208,'./arinvoiceviewfpdf_small2.php'),(20793784,1963,'./arinvoiceviewfpdf_small2.php'),(20793783,5685,'./arinvoiceviewfpdf_small2.php'),(20793782,9248,'./arinvoiceviewfpdf_small2.php'),(20793781,1668,'./arinvoiceviewfpdf_small2.php'),(20793780,1625,'./arinvoiceviewfpdf_small2.php'),(20793779,1467,'./arinvoiceviewfpdf_small2.php'),(20793778,5684,'./arinvoiceviewfpdf_small2.php'),(20793777,5682,'./arinvoiceviewfpdf_small2.php'),(20793776,982,'./arinvoiceviewfpdf_small2.php'),(20793775,9224,'./arinvoiceviewfpdf_small2.php'),(20793774,6736,'./arinvoiceviewfpdf_small2.php'),(20793773,10775,'./arinvoiceviewfpdf_small2.php'),(20793772,673,'./arinvoiceviewfpdf_small2.php'),(20793771,670,'./arinvoiceviewfpdf_small2.php'),(20793770,542,'./arinvoiceviewfpdf_small2.php'),(20793769,5456,'./arinvoiceviewfpdf_small2.php'),(20793768,479,'./arinvoiceviewfpdf_small2.php'),(20793767,445,'./arinvoiceviewfpdf_small2.php'),(20793766,306,'./arinvoiceviewfpdf_small2.php'),(20793765,5683,'./arinvoiceviewfpdf_small2.php'),(20793764,3427,'./arinvoiceviewfpdf_small.php'),(20793763,8216,'./arinvoiceviewfpdf_small.php'),(20793762,19877,'./arinvoiceviewfpdf_small.php'),(20793761,3172,'./arinvoiceviewfpdf_small.php'),(20793760,5458,'./arinvoiceviewfpdf_small.php'),(20793759,3090,'./arinvoiceviewfpdf_small.php'),(20793758,3035,'./arinvoiceviewfpdf_small.php'),(20793757,2998,'./arinvoiceviewfpdf_small.php'),(20793756,2977,'./arinvoiceviewfpdf_small.php'),(20793755,3913,'./arinvoiceviewfpdf_small.php'),(20793754,2819,'./arinvoiceviewfpdf_small.php'),(20793753,2833,'./arinvoiceviewfpdf_small.php'),(20793752,5687,'./arinvoiceviewfpdf_small.php'),(20793751,5686,'./arinvoiceviewfpdf_small.php'),(20793750,12851,'./arinvoiceviewfpdf_small.php'),(20793749,4680,'./arinvoiceviewfpdf_small.php'),(20793748,6741,'./arinvoiceviewfpdf_small.php'),(20793747,5689,'./arinvoiceviewfpdf_small.php'),(20793746,2529,'./arinvoiceviewfpdf_small.php'),(20793745,2260,'./arinvoiceviewfpdf_small.php'),(20793744,2225,'./arinvoiceviewfpdf_small.php'),(20793743,2222,'./arinvoiceviewfpdf_small.php'),(20793742,6739,'./arinvoiceviewfpdf_small.php'),(20793741,2208,'./arinvoiceviewfpdf_small.php'),(20793740,1963,'./arinvoiceviewfpdf_small.php'),(20793739,5685,'./arinvoiceviewfpdf_small.php'),(20793738,1781,'./arinvoiceviewfpdf_small.php'),(20793737,9248,'./arinvoiceviewfpdf_small.php'),(20793736,1668,'./arinvoiceviewfpdf_small.php'),(20793735,1625,'./arinvoiceviewfpdf_small.php'),(20793734,1467,'./arinvoiceviewfpdf_small.php'),(20793733,5684,'./arinvoiceviewfpdf_small.php'),(20793732,5682,'./arinvoiceviewfpdf_small.php'),(20793731,982,'./arinvoiceviewfpdf_small.php'),(20793730,9224,'./arinvoiceviewfpdf_small.php'),(20793729,932,'./arinvoiceviewfpdf_small.php'),(20793728,6736,'./arinvoiceviewfpdf_small.php'),(20793727,869,'./arinvoiceviewfpdf_small.php'),(20793726,10775,'./arinvoiceviewfpdf_small.php'),(20793725,737,'./arinvoiceviewfpdf_small.php'),(20793724,673,'./arinvoiceviewfpdf_small.php'),(20793723,670,'./arinvoiceviewfpdf_small.php'),(20793722,5459,'./arinvoiceviewfpdf_small.php'),(20793721,542,'./arinvoiceviewfpdf_small.php'),(20793720,5456,'./arinvoiceviewfpdf_small.php'),(20793719,479,'./arinvoiceviewfpdf_small.php'),(20793718,445,'./arinvoiceviewfpdf_small.php'),(20793717,306,'./arinvoiceviewfpdf_small.php'),(20793716,5683,'./arinvoiceviewfpdf_small.php'),(20793715,3427,'./arinvoiceviewfpdf.php'),(20793714,5225,'./arinvoiceviewfpdf.php'),(20793713,5687,'./arinvoiceviewfpdf.php'),(20793712,5686,'./arinvoiceviewfpdf.php'),(20793711,13951,'./arinvoiceviewfpdf.php'),(20793710,1963,'./arinvoiceviewfpdf.php'),(20793709,5685,'./arinvoiceviewfpdf.php'),(20793708,1678,'./arinvoiceviewfpdf.php'),(20793707,9248,'./arinvoiceviewfpdf.php'),(20793706,1668,'./arinvoiceviewfpdf.php'),(20793705,1467,'./arinvoiceviewfpdf.php'),(20793704,8936,'./arinvoiceviewfpdf.php'),(20793703,5684,'./arinvoiceviewfpdf.php'),(20793702,3465,'./arinvoiceviewfpdf.php'),(20793701,5682,'./arinvoiceviewfpdf.php'),(20793700,982,'./arinvoiceviewfpdf.php'),(20793699,9224,'./arinvoiceviewfpdf.php'),(20793698,542,'./arinvoiceviewfpdf.php'),(20793697,5456,'./arinvoiceviewfpdf.php'),(20793696,5683,'./arinvoiceviewfpdf.php'),(20793695,1679,'./arinvoiceview_beginbal.php'),(20793694,1678,'./arinvoiceview_beginbal.php'),(20793693,1232,'./arinvoiceview_beginbal.php'),(20793692,1134,'./arinvoiceview_beginbal.php'),(20793691,1133,'./arinvoiceview_beginbal.php'),(20793690,1132,'./arinvoiceview_beginbal.php'),(20793689,5803,'./arinvoiceview_beginbal.php'),(20793688,315,'./arinvoiceview_beginbal.php'),(20793687,5145,'./arinvoiceview_beginbal.php'),(20793686,176,'./arinvoiceview_beginbal.php'),(20793685,19877,'./arinvoiceview.php'),(20793684,16703,'./arinvoiceview.php'),(20793683,19257,'./arinvoiceview.php'),(20793682,14555,'./arinvoiceview.php'),(20793681,20181,'./arinvoiceview.php'),(20793680,5378,'./arinvoiceview.php'),(20793679,3324,'./arinvoiceview.php'),(20793678,3172,'./arinvoiceview.php'),(20793677,17494,'./arinvoiceview.php'),(20793676,3156,'./arinvoiceview.php'),(20793675,3104,'./arinvoiceview.php'),(20793674,3097,'./arinvoiceview.php'),(20793673,3090,'./arinvoiceview.php'),(20793672,14143,'./arinvoiceview.php'),(20793671,3035,'./arinvoiceview.php'),(20793670,2998,'./arinvoiceview.php'),(20793669,2977,'./arinvoiceview.php'),(20793668,16383,'./arinvoiceview.php'),(20793667,2819,'./arinvoiceview.php'),(20793666,2833,'./arinvoiceview.php'),(20793665,6770,'./arinvoiceview.php'),(20793664,2803,'./arinvoiceview.php'),(20793663,2802,'./arinvoiceview.php'),(20793662,8913,'./arinvoiceview.php'),(20793661,19448,'./arinvoiceview.php'),(20793660,2676,'./arinvoiceview.php'),(20793659,6737,'./arinvoiceview.php'),(20793658,5689,'./arinvoiceview.php'),(20793657,19215,'./arinvoiceview.php'),(20793656,2565,'./arinvoiceview.php'),(20793655,2529,'./arinvoiceview.php'),(20793654,2494,'./arinvoiceview.php'),(20793653,19220,'./arinvoiceview.php'),(20793652,2473,'./arinvoiceview.php'),(20793651,2459,'./arinvoiceview.php'),(20793650,5787,'./arinvoiceview.php'),(20793649,2361,'./arinvoiceview.php'),(20793648,7758,'./arinvoiceview.php'),(20793647,2315,'./arinvoiceview.php'),(20793646,5935,'./arinvoiceview.php'),(20793645,2231,'./arinvoiceview.php'),(20793644,5934,'./arinvoiceview.php'),(20793643,13353,'./arinvoiceview.php'),(20793642,6739,'./arinvoiceview.php'),(20793641,2208,'./arinvoiceview.php'),(20793640,2170,'./arinvoiceview.php'),(20793639,18630,'./arinvoiceview.php'),(20793638,17889,'./arinvoiceview.php'),(20793637,2094,'./arinvoiceview.php'),(20793636,13265,'./arinvoiceview.php'),(20793635,14554,'./arinvoiceview.php'),(20793634,17103,'./arinvoiceview.php'),(20793633,2103,'./arinvoiceview.php'),(20793632,18629,'./arinvoiceview.php'),(20793631,10946,'./arinvoiceview.php'),(20793630,1884,'./arinvoiceview.php'),(20793629,7199,'./arinvoiceview.php'),(20793628,1788,'./arinvoiceview.php'),(20795317,749,'./arordshipquote.php'),(20793627,1781,'./arinvoiceview.php'),(20793588,9361,'./arinvoiceupd.php'),(20793587,19268,'./arinvoiceupd.php'),(20793586,10584,'./arinvoiceupd.php'),(20793585,19877,'./arinvoiceupd.php'),(20793584,3358,'./arinvoiceupd.php'),(20793583,7196,'./arinvoiceupd.php'),(20793582,3319,'./arinvoiceupd.php'),(20793581,3178,'./arinvoiceupd.php'),(20793580,15793,'./arinvoiceupd.php'),(20793579,3179,'./arinvoiceupd.php'),(20793578,3177,'./arinvoiceupd.php'),(20793577,7733,'./arinvoiceupd.php'),(20793576,7732,'./arinvoiceupd.php'),(20793575,17494,'./arinvoiceupd.php'),(20793574,3156,'./arinvoiceupd.php'),(20793573,3112,'./arinvoiceupd.php'),(20793572,3090,'./arinvoiceupd.php'),(20793571,19116,'./arinvoiceupd.php'),(20793570,10583,'./arinvoiceupd.php'),(20793569,9359,'./arinvoiceupd.php'),(20793568,3035,'./arinvoiceupd.php'),(20793567,4597,'./arinvoiceupd.php'),(20793566,3030,'./arinvoiceupd.php'),(20793565,2998,'./arinvoiceupd.php'),(20793564,2977,'./arinvoiceupd.php'),(20793563,2948,'./arinvoiceupd.php'),(20793562,7682,'./arinvoiceupd.php'),(20793561,7681,'./arinvoiceupd.php'),(20793560,2858,'./arinvoiceupd.php'),(20793559,2820,'./arinvoiceupd.php'),(20793558,2819,'./arinvoiceupd.php'),(20793557,6735,'./arinvoiceupd.php'),(20793556,2838,'./arinvoiceupd.php'),(20793555,2833,'./arinvoiceupd.php'),(20793554,6770,'./arinvoiceupd.php'),(20793553,9358,'./arinvoiceupd.php'),(20793552,2710,'./arinvoiceupd.php'),(20793551,2702,'./arinvoiceupd.php'),(20793550,3961,'./arinvoiceupd.php'),(20793549,2698,'./arinvoiceupd.php'),(20793548,2622,'./arinvoiceupd.php'),(20793547,2618,'./arinvoiceupd.php'),(20793546,15401,'./arinvoiceupd.php'),(20793545,15400,'./arinvoiceupd.php'),(20793544,5388,'./arinvoiceupd.php'),(20793543,5689,'./arinvoiceupd.php'),(20793542,2586,'./arinvoiceupd.php'),(20793541,2529,'./arinvoiceupd.php'),(20793540,2526,'./arinvoiceupd.php'),(20793539,2501,'./arinvoiceupd.php'),(20793538,16239,'./arinvoiceupd.php'),(20793537,19220,'./arinvoiceupd.php'),(20793536,2473,'./arinvoiceupd.php'),(20793535,2459,'./arinvoiceupd.php'),(20793534,2453,'./arinvoiceupd.php'),(20793533,2404,'./arinvoiceupd.php'),(20793532,16240,'./arinvoiceupd.php'),(20793531,2363,'./arinvoiceupd.php'),(20793530,2374,'./arinvoiceupd.php'),(20793529,2377,'./arinvoiceupd.php'),(20793528,2371,'./arinvoiceupd.php'),(20793527,2315,'./arinvoiceupd.php'),(20793526,5935,'./arinvoiceupd.php'),(20793525,2225,'./arinvoiceupd.php'),(20793524,2208,'./arinvoiceupd.php'),(20793523,6734,'./arinvoiceupd.php'),(20793522,2170,'./arinvoiceupd.php'),(20793521,6118,'./arinvoiceupd.php'),(20793520,17889,'./arinvoiceupd.php'),(20793519,3992,'./arinvoiceupd.php'),(20793518,15800,'./arinvoiceupd.php'),(20793517,2021,'./arinvoiceupd.php'),(20793516,2094,'./arinvoiceupd.php'),(20793515,6117,'./arinvoiceupd.php'),(20793514,2103,'./arinvoiceupd.php'),(20793513,1963,'./arinvoiceupd.php'),(20793512,1913,'./arinvoiceupd.php'),(20793511,1884,'./arinvoiceupd.php'),(20793510,16237,'./arinvoiceupd.php'),(20793509,5389,'./arinvoiceupd.php'),(20793508,10991,'./arinvoiceupd.php'),(20793507,5081,'./arinvoiceupd.php'),(20793506,1696,'./arinvoiceupd.php'),(20793505,18571,'./arinvoiceupd.php'),(20793504,15799,'./arinvoiceupd.php'),(20793503,1694,'./arinvoiceupd.php'),(20793502,1678,'./arinvoiceupd.php'),(20793501,1673,'./arinvoiceupd.php'),(20793500,1672,'./arinvoiceupd.php'),(20793499,1668,'./arinvoiceupd.php'),(20793498,1647,'./arinvoiceupd.php'),(20793497,1629,'./arinvoiceupd.php'),(20793496,7680,'./arinvoiceupd.php'),(20793495,1599,'./arinvoiceupd.php'),(20793494,1578,'./arinvoiceupd.php'),(20793493,1554,'./arinvoiceupd.php'),(20793492,15798,'./arinvoiceupd.php'),(20793491,15991,'./arinvoiceupd.php'),(20793490,11868,'./arinvoiceupd.php'),(20793489,1373,'./arinvoiceupd.php'),(20793488,3950,'./arinvoiceupd.php'),(20793487,1221,'./arinvoiceupd.php'),(20793486,8936,'./arinvoiceupd.php'),(20793485,4346,'./arinvoiceupd.php'),(20793484,6116,'./arinvoiceupd.php'),(20793483,1028,'./arinvoiceupd.php'),(20793482,981,'./arinvoiceupd.php'),(20793481,6115,'./arinvoiceupd.php'),(20793480,7874,'./arinvoiceupd.php'),(20793479,941,'./arinvoiceupd.php'),(20793478,932,'./arinvoiceupd.php'),(20793477,16122,'./arinvoiceupd.php'),(20793476,6736,'./arinvoiceupd.php'),(20793475,10582,'./arinvoiceupd.php'),(20793474,10572,'./arinvoiceupd.php'),(20793473,869,'./arinvoiceupd.php'),(20793472,5478,'./arinvoiceupd.php'),(20793471,13787,'./arinvoiceupd.php'),(20793470,13789,'./arinvoiceupd.php'),(20793469,13785,'./arinvoiceupd.php'),(20793468,13784,'./arinvoiceupd.php'),(20793467,830,'./arinvoiceupd.php'),(20793466,19267,'./arinvoiceupd.php'),(20793465,15399,'./arinvoiceupd.php'),(20793464,5205,'./arinvoiceupd.php'),(20793463,799,'./arinvoiceupd.php'),(20793462,749,'./arinvoiceupd.php'),(20793461,737,'./arinvoiceupd.php'),(20793460,10613,'./arinvoiceupd.php'),(20793459,4481,'./arinvoiceupd.php'),(20793458,697,'./arinvoiceupd.php'),(20793457,688,'./arinvoiceupd.php'),(20793456,673,'./arinvoiceupd.php'),(20793455,10614,'./arinvoiceupd.php'),(20793454,10581,'./arinvoiceupd.php'),(20793453,653,'./arinvoiceupd.php'),(20793452,644,'./arinvoiceupd.php'),(20793451,9492,'./arinvoiceupd.php'),(20793450,549,'./arinvoiceupd.php'),(20793449,4119,'./arinvoiceupd.php'),(20670654,10371,'./arinvoicetotalupdate.php'),(20670653,8936,'./arinvoicetotalupdate.php'),(20793433,19877,'./arinvoicesum.php'),(20793432,8317,'./arinvoicesum.php'),(20793431,18501,'./arinvoicesum.php'),(20793430,5378,'./arinvoicesum.php'),(20793429,19115,'./arinvoicesum.php'),(20793428,12082,'./arinvoicesum.php'),(20793427,3179,'./arinvoicesum.php'),(20793426,3450,'./arinvoicesum.php'),(20793425,4974,'./arinvoicesum.php'),(20793424,3097,'./arinvoicesum.php'),(20793423,3090,'./arinvoicesum.php'),(20793422,11709,'./arinvoicesum.php'),(20793421,2998,'./arinvoicesum.php'),(20793420,8267,'./arinvoicesum.php'),(20793419,7997,'./arinvoicesum.php'),(20793418,2986,'./arinvoicesum.php'),(20793417,3853,'./arinvoicesum.php'),(20793416,8304,'./arinvoicesum.php'),(20793415,8266,'./arinvoicesum.php'),(20793414,2977,'./arinvoicesum.php'),(20793413,2950,'./arinvoicesum.php'),(20793412,2948,'./arinvoicesum.php'),(20793411,6732,'./arinvoicesum.php'),(20793410,6731,'./arinvoicesum.php'),(20793409,19775,'./arinvoicesum.php'),(20793408,11708,'./arinvoicesum.php'),(20793407,6229,'./arinvoicesum.php'),(20793406,19851,'./arinvoicesum.php'),(20793405,19850,'./arinvoicesum.php'),(20793404,2860,'./arinvoicesum.php'),(20793403,19774,'./arinvoicesum.php'),(20793402,2819,'./arinvoicesum.php'),(20793401,2838,'./arinvoicesum.php'),(20793400,2833,'./arinvoicesum.php'),(20793399,2803,'./arinvoicesum.php'),(20793398,5991,'./arinvoicesum.php'),(20793397,19448,'./arinvoicesum.php'),(20793396,19468,'./arinvoicesum.php'),(20793395,2676,'./arinvoicesum.php'),(20793394,2673,'./arinvoicesum.php'),(20793393,19773,'./arinvoicesum.php'),(20793392,2698,'./arinvoicesum.php'),(20793391,10577,'./arinvoicesum.php'),(20793390,2612,'./arinvoicesum.php'),(20793389,18462,'./arinvoicesum.php'),(20793388,17917,'./arinvoicesum.php'),(20793387,16675,'./arinvoicesum.php'),(20793386,5388,'./arinvoicesum.php'),(20793385,2529,'./arinvoicesum.php'),(20793384,2494,'./arinvoicesum.php'),(20793383,2404,'./arinvoicesum.php'),(20793382,19849,'./arinvoicesum.php'),(20793381,6730,'./arinvoicesum.php'),(20793380,7730,'./arinvoicesum.php'),(20793379,2225,'./arinvoicesum.php'),(20793378,19114,'./arinvoicesum.php'),(20793377,16671,'./arinvoicesum.php'),(20793376,2170,'./arinvoicesum.php'),(20793375,6370,'./arinvoicesum.php'),(20793374,7678,'./arinvoicesum.php'),(20793373,2151,'./arinvoicesum.php'),(20793372,19113,'./arinvoicesum.php'),(20793371,19310,'./arinvoicesum.php'),(20793370,19112,'./arinvoicesum.php'),(20793369,19111,'./arinvoicesum.php'),(20793368,2021,'./arinvoicesum.php'),(20793367,19110,'./arinvoicesum.php'),(20793366,19109,'./arinvoicesum.php'),(20793365,19442,'./arinvoicesum.php'),(20793364,12081,'./arinvoicesum.php'),(20793363,13788,'./arinvoicesum.php'),(20793362,16669,'./arinvoicesum.php'),(20793361,18461,'./arinvoicesum.php'),(20793360,19656,'./arinvoicesum.php'),(20793359,2070,'./arinvoicesum.php'),(20793358,1963,'./arinvoicesum.php'),(20793357,19108,'./arinvoicesum.php'),(20793356,1788,'./arinvoicesum.php'),(20793355,1771,'./arinvoicesum.php'),(20793354,5081,'./arinvoicesum.php'),(20793353,1724,'./arinvoicesum.php'),(20793352,1709,'./arinvoicesum.php'),(20793351,1703,'./arinvoicesum.php'),(20793350,1740,'./arinvoicesum.php'),(20793349,1684,'./arinvoicesum.php'),(20793348,1678,'./arinvoicesum.php'),(20793347,1672,'./arinvoicesum.php'),(17336035,3427,'./arinvoicestateview.php'),(17336034,3037,'./arinvoicestateview.php'),(17336033,2946,'./arinvoicestateview.php'),(17336032,2352,'./arinvoicestateview.php'),(17336031,2259,'./arinvoicestateview.php'),(17336030,2021,'./arinvoicestateview.php'),(17336029,1678,'./arinvoicestateview.php'),(17336028,1625,'./arinvoicestateview.php'),(17336027,737,'./arinvoicestateview.php'),(17336026,684,'./arinvoicestateview.php'),(17336025,683,'./arinvoicestateview.php'),(17336024,672,'./arinvoicestateview.php'),(17336023,670,'./arinvoicestateview.php'),(17336022,662,'./arinvoicestateview.php'),(17336021,542,'./arinvoicestateview.php'),(17336020,540,'./arinvoicestateview.php'),(17336019,475,'./arinvoicestateview.php'),(17336018,326,'./arinvoicestateview.php'),(17336017,315,'./arinvoicestateview.php'),(17336016,227,'./arinvoicestateview.php'),(17336015,226,'./arinvoicestateview.php'),(17336014,59,'./arinvoicestateview.php'),(17336013,20,'./arinvoicestateview.php'),(17336012,4040,'./arinvoicestateview.php'),(17336011,4039,'./arinvoicestateview.php'),(17336010,4037,'./arinvoicestateview.php'),(17336009,4036,'./arinvoicestateview.php'),(20793304,3134,'./arinvoicestateemail.php'),(20793303,2948,'./arinvoicestateemail.php'),(20793302,2795,'./arinvoicestateemail.php'),(20793301,19266,'./arinvoicestateemail.php'),(20793300,2292,'./arinvoicestateemail.php'),(20793299,4789,'./arinvoicestateemail.php'),(20793298,19265,'./arinvoicestateemail.php'),(20793297,14359,'./arinvoicestateemail.php'),(20793296,16127,'./arinvoicestateemail.php'),(20793288,7240,'./arinvoicestate.php'),(20793287,7239,'./arinvoicestate.php'),(20793286,6245,'./arinvoicestate.php'),(20793285,6244,'./arinvoicestate.php'),(20793284,6243,'./arinvoicestate.php'),(20793283,3847,'./arinvoicestate.php'),(20793282,14045,'./arinvoicestate.php'),(20793281,14927,'./arinvoicestate.php'),(20793280,15996,'./arinvoicestate.php'),(20793279,2788,'./arinvoicestate.php'),(20793278,14044,'./arinvoicestate.php'),(20793277,19309,'./arinvoicestate.php'),(20793276,3773,'./arinvoicestate.php'),(20793275,1963,'./arinvoicestate.php'),(20793274,19298,'./arinvoicestate.php'),(20793273,19847,'./arinvoicestate.php'),(20793272,1580,'./arinvoicestate.php'),(20793271,19175,'./arinvoicestate.php'),(20793270,14043,'./arinvoicestate.php'),(20793269,19587,'./arinvoicestate.php'),(20793268,14357,'./arinvoicestate.php'),(20793267,906,'./arinvoicestate.php'),(20793266,4973,'./arinvoicestate.php'),(20793259,3172,'./arinvoicereturnsdetail.php'),(20793258,3156,'./arinvoicereturnsdetail.php'),(20793257,3090,'./arinvoicereturnsdetail.php'),(20793256,3035,'./arinvoicereturnsdetail.php'),(20793255,2998,'./arinvoicereturnsdetail.php'),(20793254,2977,'./arinvoicereturnsdetail.php'),(20793253,19424,'./arinvoicereturnsdetail.php'),(20793252,2895,'./arinvoicereturnsdetail.php'),(20793251,2819,'./arinvoicereturnsdetail.php'),(20793250,19263,'./arinvoicereturnsdetail.php'),(20793249,19423,'./arinvoicereturnsdetail.php'),(20793248,19262,'./arinvoicereturnsdetail.php'),(20793247,19206,'./arinvoicereturnsdetail.php'),(20793246,6825,'./arinvoicereturnsdetail.php'),(20793245,6737,'./arinvoicereturnsdetail.php'),(20793244,10580,'./arinvoicereturnsdetail.php'),(20793243,2529,'./arinvoicereturnsdetail.php'),(20793242,2361,'./arinvoicereturnsdetail.php'),(20793241,19260,'./arinvoicereturnsdetail.php'),(20793240,5935,'./arinvoicereturnsdetail.php'),(20793239,6739,'./arinvoicereturnsdetail.php'),(20793238,2170,'./arinvoicereturnsdetail.php'),(20793237,4608,'./arinvoicereturnsdetail.php'),(20793236,2094,'./arinvoicereturnsdetail.php'),(20793235,2103,'./arinvoicereturnsdetail.php'),(20793234,1884,'./arinvoicereturnsdetail.php'),(20793233,18006,'./arinvoicereturnsdetail.php'),(20793232,18005,'./arinvoicereturnsdetail.php'),(20793231,1781,'./arinvoicereturnsdetail.php'),(20793230,18004,'./arinvoicereturnsdetail.php'),(20793229,1679,'./arinvoicereturnsdetail.php'),(20793228,1678,'./arinvoicereturnsdetail.php'),(20793227,17964,'./arinvoicereturnsdetail.php'),(20793226,1629,'./arinvoicereturnsdetail.php'),(20793225,18570,'./arinvoicereturnsdetail.php'),(20793224,19259,'./arinvoicereturnsdetail.php'),(20793223,1232,'./arinvoicereturnsdetail.php'),(20793222,8936,'./arinvoicereturnsdetail.php'),(20793221,10579,'./arinvoicereturnsdetail.php'),(20793220,6736,'./arinvoicereturnsdetail.php'),(20793207,3319,'./arinvoicereturns.php'),(20793206,3176,'./arinvoicereturns.php'),(20793205,13426,'./arinvoicereturns.php'),(20793204,2948,'./arinvoicereturns.php'),(20793203,2819,'./arinvoicereturns.php'),(20793202,10577,'./arinvoicereturns.php'),(20793201,2501,'./arinvoicereturns.php'),(20793200,2363,'./arinvoicereturns.php'),(20793199,2225,'./arinvoicereturns.php'),(20793198,6734,'./arinvoicereturns.php'),(20793197,13425,'./arinvoicereturns.php'),(20793196,10576,'./arinvoicereturns.php'),(20793195,1963,'./arinvoicereturns.php'),(20793194,5389,'./arinvoicereturns.php'),(20793193,6366,'./arinvoicereturns.php'),(20793192,1724,'./arinvoicereturns.php'),(20793191,1678,'./arinvoicereturns.php'),(20793190,1672,'./arinvoicereturns.php'),(20793189,10575,'./arinvoicereturns.php'),(20793188,941,'./arinvoicereturns.php'),(20793187,4481,'./arinvoicereturns.php'),(20793186,697,'./arinvoicereturns.php'),(20793185,10574,'./arinvoicereturns.php'),(20793184,10573,'./arinvoicereturns.php'),(20793183,481,'./arinvoicereturns.php'),(20793182,315,'./arinvoicereturns.php'),(20793181,47,'./arinvoicereturns.php'),(20793180,6014,'./arinvoicerepvat.php'),(20793179,3324,'./arinvoicerepvat.php'),(20793178,3274,'./arinvoicerepvat.php'),(20793177,12238,'./arinvoicerepvat.php'),(20793176,6710,'./arinvoicerepvat.php'),(20793175,6726,'./arinvoicerepvat.php'),(20793174,7237,'./arinvoicerepvat.php'),(20793173,7236,'./arinvoicerepvat.php'),(20793172,7231,'./arinvoicerepvat.php'),(20793171,7235,'./arinvoicerepvat.php'),(20793170,11891,'./arinvoicerepvat.php'),(20793169,3030,'./arinvoicerepvat.php'),(20793168,1963,'./arinvoicerepvat.php'),(20793167,7234,'./arinvoicerepvat.php'),(20793166,5385,'./arinvoicerepvat.php'),(20793165,1678,'./arinvoicerepvat.php'),(20793164,1540,'./arinvoicerepvat.php'),(20793163,1446,'./arinvoicerepvat.php'),(20793162,1019,'./arinvoicerepvat.php'),(20793161,7233,'./arinvoicerepvat.php'),(20793160,737,'./arinvoicerepvat.php'),(20793159,697,'./arinvoicerepvat.php'),(20793158,607,'./arinvoicerepvat.php'),(20793157,548,'./arinvoicerepvat.php'),(20793156,337,'./arinvoicerepvat.php'),(20793155,315,'./arinvoicerepvat.php'),(20793154,284,'./arinvoicerepvat.php'),(20793153,197,'./arinvoicerepvat.php'),(20793152,3414,'./arinvoicereptax.php'),(20793151,6014,'./arinvoicereptax.php'),(20793150,18826,'./arinvoicereptax.php'),(20793149,5378,'./arinvoicereptax.php'),(20793148,3324,'./arinvoicereptax.php'),(20793147,18456,'./arinvoicereptax.php'),(20793146,19288,'./arinvoicereptax.php'),(20793145,19586,'./arinvoicereptax.php'),(20793144,19585,'./arinvoicereptax.php'),(20793143,6726,'./arinvoicereptax.php'),(20793142,3101,'./arinvoicereptax.php'),(20793141,18455,'./arinvoicereptax.php'),(20793140,3022,'./arinvoicereptax.php'),(20793139,18454,'./arinvoicereptax.php'),(20793138,18453,'./arinvoicereptax.php'),(20793137,18452,'./arinvoicereptax.php'),(20793136,15544,'./arinvoicereptax.php'),(20793135,3000,'./arinvoicereptax.php'),(20793134,19584,'./arinvoicereptax.php'),(20793133,18261,'./arinvoicereptax.php'),(20793132,11891,'./arinvoicereptax.php'),(20793131,3030,'./arinvoicereptax.php'),(20793130,2998,'./arinvoicereptax.php'),(20793129,18451,'./arinvoicereptax.php'),(20793128,5581,'./arinvoicereptax.php'),(20793127,8994,'./arinvoicereptax.php'),(20793126,18450,'./arinvoicereptax.php'),(20793125,18449,'./arinvoicereptax.php'),(20793124,8992,'./arinvoicereptax.php'),(20793123,12013,'./arinvoicereptax.php'),(20793122,3811,'./arinvoicereptax.php'),(20793121,2664,'./arinvoicereptax.php'),(20793120,2583,'./arinvoicereptax.php'),(20793119,2565,'./arinvoicereptax.php'),(20793118,18448,'./arinvoicereptax.php'),(20793117,5366,'./arinvoicereptax.php'),(20793067,3432,'./arinvoicereprint.php'),(20793066,19877,'./arinvoicereprint.php'),(20793065,3179,'./arinvoicereprint.php'),(20793064,4974,'./arinvoicereprint.php'),(20793063,3090,'./arinvoicereprint.php'),(20793062,2948,'./arinvoicereprint.php'),(20793061,16329,'./arinvoicereprint.php'),(20793060,16244,'./arinvoicereprint.php'),(20793059,16241,'./arinvoicereprint.php'),(20793058,19507,'./arinvoicereprint.php'),(20793057,5467,'./arinvoicereprint.php'),(20793056,5388,'./arinvoicereprint.php'),(20793055,16239,'./arinvoicereprint.php'),(20793054,18819,'./arinvoicereprint.php'),(20793053,5474,'./arinvoicereprint.php'),(20793052,2459,'./arinvoicereprint.php'),(20793051,17021,'./arinvoicereprint.php'),(20793050,2225,'./arinvoicereprint.php'),(20793049,2151,'./arinvoicereprint.php'),(20793048,2021,'./arinvoicereprint.php'),(20793047,16255,'./arinvoicereprint.php'),(20793046,1963,'./arinvoicereprint.php'),(20793045,16237,'./arinvoicereprint.php'),(20793044,1788,'./arinvoicereprint.php'),(20793043,1740,'./arinvoicereprint.php'),(20793042,5471,'./arinvoicereprint.php'),(20793041,1678,'./arinvoicereprint.php'),(20793040,16243,'./arinvoicereprint.php'),(20793039,16242,'./arinvoicereprint.php'),(20793038,1668,'./arinvoicereprint.php'),(20793037,1373,'./arinvoicereprint.php'),(20793036,16276,'./arinvoicereprint.php'),(20793035,5470,'./arinvoicereprint.php'),(20793034,5682,'./arinvoicereprint.php'),(20793033,19422,'./arinvoicereprint.php'),(20793032,19421,'./arinvoicereprint.php'),(20793031,981,'./arinvoicereprint.php'),(20793030,932,'./arinvoicereprint.php'),(20793029,16122,'./arinvoicereprint.php'),(20793028,13785,'./arinvoicereprint.php'),(20793027,13784,'./arinvoicereprint.php'),(20793017,19877,'./arinvoicereppay.php'),(20793016,3343,'./arinvoicereppay.php'),(20793015,3333,'./arinvoicereppay.php'),(20793014,5378,'./arinvoicereppay.php'),(20793013,3252,'./arinvoicereppay.php'),(20793012,3156,'./arinvoicereppay.php'),(20793011,3102,'./arinvoicereppay.php'),(20793010,7677,'./arinvoicereppay.php'),(20793009,3118,'./arinvoicereppay.php'),(20793008,3090,'./arinvoicereppay.php'),(20793007,3072,'./arinvoicereppay.php'),(20793006,2998,'./arinvoicereppay.php'),(20793005,4113,'./arinvoicereppay.php'),(20793004,16362,'./arinvoicereppay.php'),(20793003,20093,'./arinvoicereppay.php'),(20793002,20092,'./arinvoicereppay.php'),(20793001,16327,'./arinvoicereppay.php'),(20793000,6725,'./arinvoicereppay.php'),(20792999,5991,'./arinvoicereppay.php'),(20792998,6724,'./arinvoicereppay.php'),(20792997,2657,'./arinvoicereppay.php'),(20792996,2638,'./arinvoicereppay.php'),(20792995,5689,'./arinvoicereppay.php'),(20792994,14041,'./arinvoicereppay.php'),(20792993,6516,'./arinvoicereppay.php'),(20792992,2260,'./arinvoicereppay.php'),(20792991,5366,'./arinvoicereppay.php'),(20792990,11742,'./arinvoicereppay.php'),(20792989,5365,'./arinvoicereppay.php'),(20792988,2225,'./arinvoicereppay.php'),(20792987,6431,'./arinvoicereppay.php'),(20792986,2208,'./arinvoicereppay.php'),(20792985,2182,'./arinvoicereppay.php'),(20792984,7676,'./arinvoicereppay.php'),(20792983,2170,'./arinvoicereppay.php'),(20792982,2044,'./arinvoicereppay.php'),(20792981,14575,'./arinvoicereppay.php'),(20792980,5381,'./arinvoicereppay.php'),(20792979,1963,'./arinvoicereppay.php'),(20792978,1884,'./arinvoicereppay.php'),(20792977,1788,'./arinvoicereppay.php'),(20792976,5081,'./arinvoicereppay.php'),(20792975,1678,'./arinvoicereppay.php'),(20792974,1668,'./arinvoicereppay.php'),(20792973,1647,'./arinvoicereppay.php'),(20792972,1625,'./arinvoicereppay.php'),(20792971,6022,'./arinvoicereppay.php'),(20792970,1578,'./arinvoicereppay.php'),(20792969,1467,'./arinvoicereppay.php'),(20792968,13066,'./arinvoicereppay.php'),(20792967,20091,'./arinvoicereppay.php'),(20792966,7675,'./arinvoicereppay.php'),(20792965,8936,'./arinvoicereppay.php'),(20792964,6723,'./arinvoicereppay.php'),(20792963,886,'./arinvoicereppay.php'),(20792962,17572,'./arinvoicereppay.php'),(20792961,869,'./arinvoicereppay.php'),(20792960,9726,'./arinvoicereppay.php'),(20792959,737,'./arinvoicereppay.php'),(20792958,4481,'./arinvoicereppay.php'),(20792957,697,'./arinvoicereppay.php'),(20792956,673,'./arinvoicereppay.php'),(20792955,6430,'./arinvoicereppay.php'),(20792954,9492,'./arinvoicereppay.php'),(20792953,607,'./arinvoicereppay.php'),(20792952,566,'./arinvoicereppay.php'),(20792951,542,'./arinvoicereppay.php'),(20792950,5382,'./arinvoicereppay.php'),(20792949,479,'./arinvoicereppay.php'),(20792935,7196,'./arinvoicerepcust.php'),(20792934,3322,'./arinvoicerepcust.php'),(20792933,3875,'./arinvoicerepcust.php'),(20792932,3035,'./arinvoicerepcust.php'),(20792931,5492,'./arinvoicerepcust.php'),(20792930,16785,'./arinvoicerepcust.php'),(20792929,9288,'./arinvoicerepcust.php'),(20792928,18590,'./arinvoicerepcust.php'),(20792927,4874,'./arinvoicerepcust.php'),(20792926,6721,'./arinvoicerepcust.php'),(20792925,2226,'./arinvoicerepcust.php'),(20792924,2192,'./arinvoicerepcust.php'),(20792923,2182,'./arinvoicerepcust.php'),(20792922,4070,'./arinvoicerepcust.php'),(20792921,8214,'./arinvoicerepcust.php'),(20792920,18626,'./arinvoicerepcust.php'),(20792919,18625,'./arinvoicerepcust.php'),(20792918,2017,'./arinvoicerepcust.php'),(20792917,18587,'./arinvoicerepcust.php'),(20792916,1963,'./arinvoicerepcust.php'),(20792915,6720,'./arinvoicerepcust.php'),(20792914,6719,'./arinvoicerepcust.php'),(20792913,5081,'./arinvoicerepcust.php'),(20792912,1692,'./arinvoicerepcust.php'),(20792911,1678,'./arinvoicerepcust.php'),(20792910,1672,'./arinvoicerepcust.php'),(20792909,1668,'./arinvoicerepcust.php'),(20792908,5491,'./arinvoicerepcust.php'),(20792907,6718,'./arinvoicerepcust.php'),(20792906,8936,'./arinvoicerepcust.php'),(20792905,9287,'./arinvoicerepcust.php'),(20792904,932,'./arinvoicerepcust.php'),(20792903,8213,'./arinvoicerepcust.php'),(20792902,4481,'./arinvoicerepcust.php'),(20792901,6228,'./arinvoicerepcust.php'),(20792900,11846,'./arinvoicerepcust.php'),(20792899,675,'./arinvoicerepcust.php'),(20792892,7196,'./arinvoicerepbalcust_detail.php'),(20792891,6319,'./arinvoicerepbalcust_detail.php'),(20792890,7192,'./arinvoicerepbalcust_detail.php'),(20792889,6318,'./arinvoicerepbalcust_detail.php'),(20792888,2225,'./arinvoicerepbalcust_detail.php'),(20792887,2017,'./arinvoicerepbalcust_detail.php'),(20792886,1963,'./arinvoicerepbalcust_detail.php'),(20792885,5081,'./arinvoicerepbalcust_detail.php'),(20792884,1668,'./arinvoicerepbalcust_detail.php'),(20792883,1019,'./arinvoicerepbalcust_detail.php'),(20792882,1022,'./arinvoicerepbalcust_detail.php'),(20792881,737,'./arinvoicerepbalcust_detail.php'),(20792880,4481,'./arinvoicerepbalcust_detail.php'),(20792879,6317,'./arinvoicerepbalcust_detail.php'),(20792878,607,'./arinvoicerepbalcust_detail.php'),(20792877,355,'./arinvoicerepbalcust_detail.php'),(20792876,337,'./arinvoicerepbalcust_detail.php'),(20792875,339,'./arinvoicerepbalcust_detail.php'),(20792874,325,'./arinvoicerepbalcust_detail.php'),(20792872,7196,'./arinvoicerepbalcust.php'),(20792871,2225,'./arinvoicerepbalcust.php'),(20792870,2017,'./arinvoicerepbalcust.php'),(20792869,1963,'./arinvoicerepbalcust.php'),(20792868,1019,'./arinvoicerepbalcust.php'),(20792867,1022,'./arinvoicerepbalcust.php'),(20792866,737,'./arinvoicerepbalcust.php'),(20792865,4481,'./arinvoicerepbalcust.php'),(20792864,6316,'./arinvoicerepbalcust.php'),(20792863,607,'./arinvoicerepbalcust.php'),(20792862,355,'./arinvoicerepbalcust.php'),(20792861,337,'./arinvoicerepbalcust.php'),(20792860,339,'./arinvoicerepbalcust.php'),(20792859,7853,'./arinvoicerepbalcust.php'),(20792858,325,'./arinvoicerepbalcust.php'),(20792857,315,'./arinvoicerepbalcust.php'),(20792856,6716,'./arinvoicerepbalcust.php'),(20792855,3421,'./arinvoicerepaging.php'),(20792854,14158,'./arinvoicerepaging.php'),(20792853,12095,'./arinvoicerepaging.php'),(20792852,11707,'./arinvoicerepaging.php'),(20792851,3090,'./arinvoicerepaging.php'),(20792850,2978,'./arinvoicerepaging.php'),(20792849,15769,'./arinvoicerepaging.php'),(20792848,2859,'./arinvoicerepaging.php'),(20792847,2850,'./arinvoicerepaging.php'),(20792846,2676,'./arinvoicerepaging.php'),(20792845,3961,'./arinvoicerepaging.php'),(20792844,2700,'./arinvoicerepaging.php'),(20792843,7674,'./arinvoicerepaging.php'),(20792842,12235,'./arinvoicerepaging.php'),(20792841,12234,'./arinvoicerepaging.php'),(20792840,16087,'./arinvoicerepaging.php'),(20792839,15768,'./arinvoicerepaging.php'),(20792838,2361,'./arinvoicerepaging.php'),(20792837,2225,'./arinvoicerepaging.php'),(20792836,8681,'./arinvoicerepaging.php'),(20792835,6715,'./arinvoicerepaging.php'),(20792834,1978,'./arinvoicerepaging.php'),(20792833,2091,'./arinvoicerepaging.php'),(20792832,2070,'./arinvoicerepaging.php'),(20792831,1973,'./arinvoicerepaging.php'),(20792830,1963,'./arinvoicerepaging.php'),(20792829,1934,'./arinvoicerepaging.php'),(20792828,1788,'./arinvoicerepaging.php'),(20792827,15763,'./arinvoicerepaging.php'),(20792826,15797,'./arinvoicerepaging.php'),(20792825,9622,'./arinvoicerepaging.php'),(20792824,1692,'./arinvoicerepaging.php'),(20792823,1678,'./arinvoicerepaging.php'),(20792822,1672,'./arinvoicerepaging.php'),(20792821,1647,'./arinvoicerepaging.php'),(20792820,6315,'./arinvoicerepaging.php'),(20792819,14773,'./arinvoicerepaging.php'),(20792818,15796,'./arinvoicerepaging.php'),(20792817,932,'./arinvoicerepaging.php'),(20792816,886,'./arinvoicerepaging.php'),(20792815,15795,'./arinvoicerepaging.php'),(20792814,4973,'./arinvoicerepaging.php'),(20792813,737,'./arinvoicerepaging.php'),(20792812,728,'./arinvoicerepaging.php'),(20792811,6228,'./arinvoicerepaging.php'),(20792810,697,'./arinvoicerepaging.php'),(20792809,683,'./arinvoicerepaging.php'),(20792804,3333,'./arinvoicepayvoid.php'),(20792803,5353,'./arinvoicepayvoid.php'),(20792802,19258,'./arinvoicepayvoid.php'),(20792801,19257,'./arinvoicepayvoid.php'),(20792800,5356,'./arinvoicepayvoid.php'),(20792799,20181,'./arinvoicepayvoid.php'),(20792798,3324,'./arinvoicepayvoid.php'),(20792797,5352,'./arinvoicepayvoid.php'),(20792796,6074,'./arinvoicepayvoid.php'),(20792795,7130,'./arinvoicepayvoid.php'),(20792794,3072,'./arinvoicepayvoid.php'),(20792793,5663,'./arinvoicepayvoid.php'),(20792792,2657,'./arinvoicepayvoid.php'),(20792791,6073,'./arinvoicepayvoid.php'),(20792790,2638,'./arinvoicepayvoid.php'),(20792789,16846,'./arinvoicepayvoid.php'),(20792788,8066,'./arinvoicepayvoid.php'),(20792787,9406,'./arinvoicepayvoid.php'),(20792786,2225,'./arinvoicepayvoid.php'),(20792785,2182,'./arinvoicepayvoid.php'),(20792784,7728,'./arinvoicepayvoid.php'),(20792783,2165,'./arinvoicepayvoid.php'),(20792782,17103,'./arinvoicepayvoid.php'),(20792781,1963,'./arinvoicepayvoid.php'),(20792780,1884,'./arinvoicepayvoid.php'),(20792779,1678,'./arinvoicepayvoid.php'),(20792778,1668,'./arinvoicepayvoid.php'),(20792777,5922,'./arinvoicepayvoid.php'),(20792776,1467,'./arinvoicepayvoid.php'),(20792775,1019,'./arinvoicepayvoid.php'),(20792774,5878,'./arinvoicepayvoid.php'),(20792773,737,'./arinvoicepayvoid.php'),(20792772,4481,'./arinvoicepayvoid.php'),(20792771,697,'./arinvoicepayvoid.php'),(20792770,9405,'./arinvoicepayvoid.php'),(20792769,9404,'./arinvoicepayvoid.php'),(20792768,9403,'./arinvoicepayvoid.php'),(20792761,3421,'./arinvoicepayuser.php'),(20792760,13220,'./arinvoicepayuser.php'),(20792759,11196,'./arinvoicepayuser.php'),(20792758,3319,'./arinvoicepayuser.php'),(20792757,13219,'./arinvoicepayuser.php'),(20792756,3252,'./arinvoicepayuser.php'),(20792755,2702,'./arinvoicepayuser.php'),(20792754,13218,'./arinvoicepayuser.php'),(20792753,13217,'./arinvoicepayuser.php'),(20792752,5366,'./arinvoicepayuser.php'),(20792751,11742,'./arinvoicepayuser.php'),(20792750,13216,'./arinvoicepayuser.php'),(20792749,13215,'./arinvoicepayuser.php'),(20792748,13214,'./arinvoicepayuser.php'),(20792747,2208,'./arinvoicepayuser.php'),(20792746,1973,'./arinvoicepayuser.php'),(20792745,7972,'./arinvoicepayuser.php'),(20792744,8936,'./arinvoicepayuser.php'),(20792743,941,'./arinvoicepayuser.php'),(20792742,13213,'./arinvoicepayuser.php'),(20792741,13212,'./arinvoicepayuser.php'),(20792740,13211,'./arinvoicepayuser.php'),(20792739,13210,'./arinvoicepayuser.php'),(20792738,13209,'./arinvoicepayuser.php'),(20792737,479,'./arinvoicepayuser.php'),(20792736,13208,'./arinvoicepayuser.php'),(20792735,13207,'./arinvoicepayuser.php'),(20792734,13206,'./arinvoicepayuser.php'),(20792733,3457,'./arinvoicepayuser.php'),(20792732,13205,'./arinvoicepayuser.php'),(20792731,13204,'./arinvoicepayuser.php'),(20792730,13203,'./arinvoicepayuser.php'),(20792729,445,'./arinvoicepayuser.php'),(20792728,315,'./arinvoicepayuser.php'),(20792727,13202,'./arinvoicepayuser.php'),(20792726,13201,'./arinvoicepayuser.php'),(20792725,5095,'./arinvoicepayuser.php'),(20792724,59,'./arinvoicepayuser.php'),(20792723,13289,'./arinvoicepaysp.php'),(20792722,3274,'./arinvoicepaysp.php'),(20792721,11406,'./arinvoicepaysp.php'),(20792720,13288,'./arinvoicepaysp.php'),(20792719,13287,'./arinvoicepaysp.php'),(20792718,11923,'./arinvoicepaysp.php'),(20792717,13286,'./arinvoicepaysp.php'),(20792716,11922,'./arinvoicepaysp.php'),(20792715,2266,'./arinvoicepaysp.php'),(20792714,2260,'./arinvoicepaysp.php'),(20792713,5366,'./arinvoicepaysp.php'),(20792712,2208,'./arinvoicepaysp.php'),(20792711,1963,'./arinvoicepaysp.php'),(20792710,1935,'./arinvoicepaysp.php'),(20792709,1678,'./arinvoicepaysp.php'),(20792708,13424,'./arinvoicepaysp.php'),(20792707,13285,'./arinvoicepaysp.php'),(20792706,1499,'./arinvoicepaysp.php'),(20792705,8936,'./arinvoicepaysp.php'),(20792704,3600,'./arinvoicepaysp.php'),(20792703,13284,'./arinvoicepaysp.php'),(20792702,13283,'./arinvoicepaysp.php'),(20792701,13282,'./arinvoicepaysp.php'),(20792700,697,'./arinvoicepaysp.php'),(20792699,673,'./arinvoicepaysp.php'),(20792698,504,'./arinvoicepaysp.php'),(20792697,479,'./arinvoicepaysp.php'),(20792696,445,'./arinvoicepaysp.php'),(20792695,226,'./arinvoicepaysp.php'),(20792694,7721,'./arinvoicepaysp.php'),(20792693,3156,'./arinvoicepayreceipt.php'),(20792692,3090,'./arinvoicepayreceipt.php'),(20792691,13862,'./arinvoicepayreceipt.php'),(20792690,2977,'./arinvoicepayreceipt.php'),(20792689,2833,'./arinvoicepayreceipt.php'),(20792688,11433,'./arinvoicepayreceipt.php'),(20792687,11432,'./arinvoicepayreceipt.php'),(20792686,11431,'./arinvoicepayreceipt.php'),(20792685,2225,'./arinvoicepayreceipt.php'),(20792684,2215,'./arinvoicepayreceipt.php'),(20792683,2165,'./arinvoicepayreceipt.php'),(20792682,18323,'./arinvoicepayreceipt.php'),(20792681,11430,'./arinvoicepayreceipt.php'),(20792680,1935,'./arinvoicepayreceipt.php'),(20792679,5707,'./arinvoicepayreceipt.php'),(20792678,1668,'./arinvoicepayreceipt.php'),(20792677,8936,'./arinvoicepayreceipt.php'),(20792676,907,'./arinvoicepayreceipt.php'),(20792675,13808,'./arinvoicepayreceipt.php'),(20792674,10253,'./arinvoicepayreceipt.php'),(20792673,737,'./arinvoicepayreceipt.php'),(20792672,673,'./arinvoicepayreceipt.php'),(20792671,6307,'./arinvoicepayreceipt.php'),(20792670,479,'./arinvoicepayreceipt.php'),(20792669,13861,'./arinvoicepayreceipt.php'),(20792668,11429,'./arinvoicepayreceipt.php'),(20792767,607,'./arinvoicepayvoid.php'),(20792661,13065,'./arinvoicepay.php'),(20792660,3423,'./arinvoicepay.php'),(20792659,15778,'./arinvoicepay.php'),(20792658,15794,'./arinvoicepay.php'),(20792657,15903,'./arinvoicepay.php'),(20792656,17112,'./arinvoicepay.php'),(20792655,17843,'./arinvoicepay.php'),(20792654,3341,'./arinvoicepay.php'),(20792653,17842,'./arinvoicepay.php'),(20792652,3090,'./arinvoicepay.php'),(20792651,11326,'./arinvoicepay.php'),(20792650,11776,'./arinvoicepay.php'),(20792649,17111,'./arinvoicepay.php'),(20792648,17875,'./arinvoicepay.php'),(20792647,2702,'./arinvoicepay.php'),(20792646,13806,'./arinvoicepay.php'),(20792645,5918,'./arinvoicepay.php'),(20792644,11406,'./arinvoicepay.php'),(20792643,5647,'./arinvoicepay.php'),(20792642,2363,'./arinvoicepay.php'),(20792641,2349,'./arinvoicepay.php'),(20792640,17840,'./arinvoicepay.php'),(20792639,17124,'./arinvoicepay.php'),(20792638,2266,'./arinvoicepay.php'),(20792637,2261,'./arinvoicepay.php'),(20792636,13908,'./arinvoicepay.php'),(20792635,17839,'./arinvoicepay.php'),(20792634,2260,'./arinvoicepay.php'),(20792633,7673,'./arinvoicepay.php'),(20792632,14270,'./arinvoicepay.php'),(20792631,2225,'./arinvoicepay.php'),(20792630,18624,'./arinvoicepay.php'),(20792629,2215,'./arinvoicepay.php'),(20792628,2208,'./arinvoicepay.php'),(20792627,2207,'./arinvoicepay.php'),(20792626,15902,'./arinvoicepay.php'),(20792625,2094,'./arinvoicepay.php'),(20792624,1963,'./arinvoicepay.php'),(20792623,15253,'./arinvoicepay.php'),(20792622,18003,'./arinvoicepay.php'),(20792621,18002,'./arinvoicepay.php'),(20792620,6841,'./arinvoicepay.php'),(20792619,1846,'./arinvoicepay.php'),(20792618,1819,'./arinvoicepay.php'),(20792617,1788,'./arinvoicepay.php'),(20792616,6171,'./arinvoicepay.php'),(20792615,5081,'./arinvoicepay.php'),(20792614,15901,'./arinvoicepay.php'),(20792613,1597,'./arinvoicepay.php'),(20792612,1681,'./arinvoicepay.php'),(20792611,1678,'./arinvoicepay.php'),(20792610,1672,'./arinvoicepay.php'),(20792609,20089,'./arinvoicepay.php'),(20792608,1668,'./arinvoicepay.php'),(20792607,6714,'./arinvoicepay.php'),(20792606,1625,'./arinvoicepay.php'),(20792605,1600,'./arinvoicepay.php'),(20792604,13064,'./arinvoicepay.php'),(20792603,13063,'./arinvoicepay.php'),(20792602,13200,'./arinvoicepay.php'),(20792601,13068,'./arinvoicepay.php'),(20792600,1278,'./arinvoicepay.php'),(20792599,6713,'./arinvoicepay.php'),(20792598,1232,'./arinvoicepay.php'),(20792597,1220,'./arinvoicepay.php'),(20792596,1219,'./arinvoicepay.php'),(20792595,8936,'./arinvoicepay.php'),(20792594,1134,'./arinvoicepay.php'),(20792593,1132,'./arinvoicepay.php'),(20792592,1106,'./arinvoicepay.php'),(20792591,13914,'./arinvoicepay.php'),(20792590,6712,'./arinvoicepay.php'),(20792589,1047,'./arinvoicepay.php'),(20792588,3600,'./arinvoicepay.php'),(20792587,932,'./arinvoicepay.php'),(20792586,886,'./arinvoicepay.php'),(20792585,8010,'./arinvoicepay.php'),(20792584,776,'./arinvoicepay.php'),(20792583,17838,'./arinvoicepay.php'),(20792541,14553,'./arinvoiceintrpt.php'),(20792540,2702,'./arinvoiceintrpt.php'),(20792539,10989,'./arinvoiceintrpt.php'),(20792538,2044,'./arinvoiceintrpt.php'),(20792537,1963,'./arinvoiceintrpt.php'),(20792536,1692,'./arinvoiceintrpt.php'),(20792535,14552,'./arinvoiceintrpt.php'),(20792534,1678,'./arinvoiceintrpt.php'),(20792533,1668,'./arinvoiceintrpt.php'),(20792532,14551,'./arinvoiceintrpt.php'),(20792531,14550,'./arinvoiceintrpt.php'),(20792530,8936,'./arinvoiceintrpt.php'),(20792529,932,'./arinvoiceintrpt.php'),(20792528,4481,'./arinvoiceintrpt.php'),(20792527,697,'./arinvoiceintrpt.php'),(20792526,14549,'./arinvoiceintrpt.php'),(20792525,14548,'./arinvoiceintrpt.php'),(20792524,14547,'./arinvoiceintrpt.php'),(20792523,14546,'./arinvoiceintrpt.php'),(20792522,6711,'./arinvoiceintrpt.php'),(20792521,3415,'./arinvoicehist.php'),(20792520,3179,'./arinvoicehist.php'),(20792519,3450,'./arinvoicehist.php'),(20792518,6710,'./arinvoicehist.php'),(20792517,4974,'./arinvoicehist.php'),(20792516,3090,'./arinvoicehist.php'),(20792515,2998,'./arinvoicehist.php'),(20792514,2977,'./arinvoicehist.php'),(20792513,2948,'./arinvoicehist.php'),(20792512,2860,'./arinvoicehist.php'),(20792511,2833,'./arinvoicehist.php'),(20792510,2676,'./arinvoicehist.php'),(20792509,2673,'./arinvoicehist.php'),(20792508,2612,'./arinvoicehist.php'),(20792507,2529,'./arinvoicehist.php'),(20792506,2494,'./arinvoicehist.php'),(20792505,2404,'./arinvoicehist.php'),(20792504,2225,'./arinvoicehist.php'),(20792503,2151,'./arinvoicehist.php'),(20792502,2114,'./arinvoicehist.php'),(20792501,2021,'./arinvoicehist.php'),(20792500,1963,'./arinvoicehist.php'),(20792499,1913,'./arinvoicehist.php'),(20792498,5081,'./arinvoicehist.php'),(20792497,1692,'./arinvoicehist.php'),(20792496,1678,'./arinvoicehist.php'),(20792495,1629,'./arinvoicehist.php'),(20792494,1503,'./arinvoicehist.php'),(20792493,1019,'./arinvoicehist.php'),(20792492,932,'./arinvoicehist.php'),(20792491,886,'./arinvoicehist.php'),(20792490,874,'./arinvoicehist.php'),(20792489,869,'./arinvoicehist.php'),(20792488,749,'./arinvoicehist.php'),(20792487,737,'./arinvoicehist.php'),(20792486,4481,'./arinvoicehist.php'),(20792485,709,'./arinvoicehist.php'),(20792484,697,'./arinvoicehist.php'),(20792483,665,'./arinvoicehist.php'),(20792482,616,'./arinvoicehist.php'),(20792481,542,'./arinvoicehist.php'),(20792480,337,'./arinvoicehist.php'),(20792479,325,'./arinvoicehist.php'),(20792478,315,'./arinvoicehist.php'),(20792477,5015,'./arinvoicehist.php'),(20792476,197,'./arinvoicehist.php'),(20669694,7635,'./arinvoicefix_historical_jakprt.php'),(20669693,7996,'./arinvoicefix_closepaid_jakprt.php'),(20792475,13783,'./arinvoicedelivery.php'),(20792474,2948,'./arinvoicedelivery.php'),(20792473,13782,'./arinvoicedelivery.php'),(20792472,2702,'./arinvoicedelivery.php'),(20792471,13781,'./arinvoicedelivery.php'),(20792470,5119,'./arinvoicedelivery.php'),(20792469,13780,'./arinvoicedelivery.php'),(20792468,13779,'./arinvoicedelivery.php'),(20792467,2459,'./arinvoicedelivery.php'),(20792466,13778,'./arinvoicedelivery.php'),(20792465,11430,'./arinvoicedelivery.php'),(20792464,2103,'./arinvoicedelivery.php'),(20792463,13777,'./arinvoicedelivery.php'),(20792462,1775,'./arinvoicedelivery.php'),(20792461,1672,'./arinvoicedelivery.php'),(20792460,1668,'./arinvoicedelivery.php'),(20792459,8936,'./arinvoicedelivery.php'),(20792458,13776,'./arinvoicedelivery.php'),(20792457,1032,'./arinvoicedelivery.php'),(20792456,869,'./arinvoicedelivery.php'),(20792455,13775,'./arinvoicedelivery.php'),(20792454,13774,'./arinvoicedelivery.php'),(20792453,13773,'./arinvoicedelivery.php'),(20792452,13772,'./arinvoicedelivery.php'),(20792451,13771,'./arinvoicedelivery.php'),(20792450,13770,'./arinvoicedelivery.php'),(20792449,799,'./arinvoicedelivery.php'),(20792448,591,'./arinvoicedelivery.php'),(20792447,542,'./arinvoicedelivery.php'),(20792446,13769,'./arinvoicedelivery.php'),(20792444,6322,'./arinvoicecalcint.php'),(20792443,3118,'./arinvoicecalcint.php'),(20792442,3090,'./arinvoicecalcint.php'),(20792441,19256,'./arinvoicecalcint.php'),(20792440,6321,'./arinvoicecalcint.php'),(20792439,2802,'./arinvoicecalcint.php'),(20792438,2702,'./arinvoicecalcint.php'),(20792437,2565,'./arinvoicecalcint.php'),(20792436,4118,'./arinvoicecalcint.php'),(20792435,18679,'./arinvoicecalcint.php'),(20792434,2267,'./arinvoicecalcint.php'),(20792433,19283,'./arinvoicecalcint.php'),(20792432,2021,'./arinvoicecalcint.php'),(20792431,18494,'./arinvoicecalcint.php'),(20792430,18678,'./arinvoicecalcint.php'),(20792429,1963,'./arinvoicecalcint.php'),(20792428,19581,'./arinvoicecalcint.php'),(20792427,6323,'./arinvoicecalcint.php'),(20792426,19254,'./arinvoicecalcint.php'),(20792425,10946,'./arinvoicecalcint.php'),(20792424,19307,'./arinvoicecalcint.php'),(20792423,18623,'./arinvoicecalcint.php'),(20792422,6320,'./arinvoicecalcint.php'),(20792421,15900,'./arinvoicecalcint.php'),(20792420,1672,'./arinvoicecalcint.php'),(20792395,19877,'./arinvoicebystate.php'),(20792394,5378,'./arinvoicebystate.php'),(20792393,3179,'./arinvoicebystate.php'),(20792392,4974,'./arinvoicebystate.php'),(20792391,3090,'./arinvoicebystate.php'),(20792390,2998,'./arinvoicebystate.php'),(20792389,9490,'./arinvoicebystate.php'),(20792388,2977,'./arinvoicebystate.php'),(20792387,2936,'./arinvoicebystate.php'),(20792386,2860,'./arinvoicebystate.php'),(20792385,2833,'./arinvoicebystate.php'),(20792384,5991,'./arinvoicebystate.php'),(20792383,5388,'./arinvoicebystate.php'),(20792382,6730,'./arinvoicebystate.php'),(20792381,2225,'./arinvoicebystate.php'),(20792380,6370,'./arinvoicebystate.php'),(20792379,2151,'./arinvoicebystate.php'),(20792378,2021,'./arinvoicebystate.php'),(20792377,1963,'./arinvoicebystate.php'),(20792376,9489,'./arinvoicebystate.php'),(20792375,1740,'./arinvoicebystate.php'),(20792374,1678,'./arinvoicebystate.php'),(20792373,9467,'./arinvoicebystate.php'),(20792372,5470,'./arinvoicebystate.php'),(20792371,886,'./arinvoicebystate.php'),(20792370,4481,'./arinvoicebystate.php'),(20792369,697,'./arinvoicebystate.php'),(20792368,665,'./arinvoicebystate.php'),(20792367,616,'./arinvoicebystate.php'),(20792366,6565,'./arinvoicebystate.php'),(20792365,5469,'./arinvoicebystate.php'),(20792364,315,'./arinvoicebystate.php'),(20792363,197,'./arinvoicebystate.php'),(20792362,11102,'./arinvoicearchive.php'),(20792361,11101,'./arinvoicearchive.php'),(20792360,3415,'./arinvoicearchive.php'),(20792359,3252,'./arinvoicearchive.php'),(20792358,11804,'./arinvoicearchive.php'),(20792357,1963,'./arinvoicearchive.php'),(20792356,1913,'./arinvoicearchive.php'),(20792355,11803,'./arinvoicearchive.php'),(20792354,11802,'./arinvoicearchive.php'),(20792353,8936,'./arinvoicearchive.php'),(20792352,1014,'./arinvoicearchive.php'),(20792351,749,'./arinvoicearchive.php'),(20792350,737,'./arinvoicearchive.php'),(20792349,333,'./arinvoicearchive.php'),(20792348,11801,'./arinvoicearchive.php'),(20792347,5146,'./arinvoicearchive.php'),(20792346,5145,'./arinvoicearchive.php'),(20792345,11800,'./arinvoicearchive.php'),(20792344,11799,'./arinvoicearchive.php'),(20792343,11798,'./arinvoicearchive.php'),(20792342,11797,'./arinvoicearchive.php'),(20792341,6708,'./arinvoiceaddcogs.php'),(20792340,3097,'./arinvoiceaddcogs.php'),(20792339,6707,'./arinvoiceaddcogs.php'),(20792338,6706,'./arinvoiceaddcogs.php'),(20792337,2702,'./arinvoiceaddcogs.php'),(20792336,2508,'./arinvoiceaddcogs.php'),(20792335,1696,'./arinvoiceaddcogs.php'),(20792334,1678,'./arinvoiceaddcogs.php'),(20792333,1675,'./arinvoiceaddcogs.php'),(20792332,6705,'./arinvoiceaddcogs.php'),(20792331,6704,'./arinvoiceaddcogs.php'),(20792330,8936,'./arinvoiceaddcogs.php'),(20792329,4346,'./arinvoiceaddcogs.php'),(20792328,733,'./arinvoiceaddcogs.php'),(20792327,635,'./arinvoiceaddcogs.php'),(20792326,634,'./arinvoiceaddcogs.php'),(20792325,15313,'./arinvoiceaddcogs.php'),(20792324,11867,'./arinvoiceaddcogs.php'),(20792323,616,'./arinvoiceaddcogs.php'),(20795316,15365,'./arordshipquote.php'),(20792319,5802,'./arinvoiceadd_beginbal.php'),(20792318,3112,'./arinvoiceadd_beginbal.php'),(20792317,3111,'./arinvoiceadd_beginbal.php'),(20792316,3021,'./arinvoiceadd_beginbal.php'),(20792315,2998,'./arinvoiceadd_beginbal.php'),(20792314,2820,'./arinvoiceadd_beginbal.php'),(20792313,2819,'./arinvoiceadd_beginbal.php'),(20792312,2838,'./arinvoiceadd_beginbal.php'),(20792311,2835,'./arinvoiceadd_beginbal.php'),(20792310,2676,'./arinvoiceadd_beginbal.php'),(20792309,3961,'./arinvoiceadd_beginbal.php'),(20792308,2618,'./arinvoiceadd_beginbal.php'),(20792307,2586,'./arinvoiceadd_beginbal.php'),(20792306,2529,'./arinvoiceadd_beginbal.php'),(20792305,2526,'./arinvoiceadd_beginbal.php'),(20792304,2501,'./arinvoiceadd_beginbal.php'),(20792303,2453,'./arinvoiceadd_beginbal.php'),(20792302,2404,'./arinvoiceadd_beginbal.php'),(20792301,5801,'./arinvoiceadd_beginbal.php'),(20792300,2103,'./arinvoiceadd_beginbal.php'),(20792299,1963,'./arinvoiceadd_beginbal.php'),(20792298,4108,'./arinvoiceadd_beginbal.php'),(20792297,1597,'./arinvoiceadd_beginbal.php'),(20792296,1685,'./arinvoiceadd_beginbal.php'),(20792295,1678,'./arinvoiceadd_beginbal.php'),(20792294,1670,'./arinvoiceadd_beginbal.php'),(20792293,1519,'./arinvoiceadd_beginbal.php'),(20792292,1278,'./arinvoiceadd_beginbal.php'),(20792291,1222,'./arinvoiceadd_beginbal.php'),(20792290,1220,'./arinvoiceadd_beginbal.php'),(20792289,1219,'./arinvoiceadd_beginbal.php'),(20792288,8936,'./arinvoiceadd_beginbal.php'),(20792287,1028,'./arinvoiceadd_beginbal.php'),(20792286,941,'./arinvoiceadd_beginbal.php'),(20792285,932,'./arinvoiceadd_beginbal.php'),(20792284,901,'./arinvoiceadd_beginbal.php'),(20792283,892,'./arinvoiceadd_beginbal.php'),(20792282,10572,'./arinvoiceadd_beginbal.php'),(20792281,869,'./arinvoiceadd_beginbal.php'),(20792280,10613,'./arinvoiceadd_beginbal.php'),(20792279,716,'./arinvoiceadd_beginbal.php'),(20792278,4481,'./arinvoiceadd_beginbal.php'),(20792277,702,'./arinvoiceadd_beginbal.php'),(20792276,9341,'./arinvoiceadd_beginbal.php'),(20792275,607,'./arinvoiceadd_beginbal.php'),(20792274,593,'./arinvoiceadd_beginbal.php'),(20792273,549,'./arinvoiceadd_beginbal.php'),(20792272,5800,'./arinvoiceadd_beginbal.php'),(20792271,152,'./arinvoiceadd_beginbal.php'),(20792270,85,'./arinvoiceadd_beginbal.php'),(20792269,59,'./arinvoiceadd_beginbal.php'),(20795315,20115,'./arordshipquote.php'),(20792667,445,'./arinvoicepayreceipt.php'),(20792582,744,'./arinvoicepay.php'),(20792581,737,'./arinvoicepay.php'),(20792268,7196,'./arinvoiceadd.php'),(20792267,15793,'./arinvoiceadd.php'),(20792266,3112,'./arinvoiceadd.php'),(20792265,3111,'./arinvoiceadd.php'),(20792264,3021,'./arinvoiceadd.php'),(20792263,2998,'./arinvoiceadd.php'),(20792262,2820,'./arinvoiceadd.php'),(20792261,2819,'./arinvoiceadd.php'),(20792260,2838,'./arinvoiceadd.php'),(20792259,2835,'./arinvoiceadd.php'),(20792258,2676,'./arinvoiceadd.php'),(20792257,3961,'./arinvoiceadd.php'),(20792256,2618,'./arinvoiceadd.php'),(20792255,2586,'./arinvoiceadd.php'),(20792254,2529,'./arinvoiceadd.php'),(20792253,2526,'./arinvoiceadd.php'),(20792252,2501,'./arinvoiceadd.php'),(20792251,16239,'./arinvoiceadd.php'),(20792250,2453,'./arinvoiceadd.php'),(20792249,2404,'./arinvoiceadd.php'),(20792248,16238,'./arinvoiceadd.php'),(20792247,9612,'./arinvoiceadd.php'),(20792246,5494,'./arinvoiceadd.php'),(20792245,6118,'./arinvoiceadd.php'),(20792244,2165,'./arinvoiceadd.php'),(20792243,2094,'./arinvoiceadd.php'),(20792242,6117,'./arinvoiceadd.php'),(20792241,2103,'./arinvoiceadd.php'),(20792240,1963,'./arinvoiceadd.php'),(20792239,7904,'./arinvoiceadd.php'),(20792238,4721,'./arinvoiceadd.php'),(20792237,4108,'./arinvoiceadd.php'),(20792236,16237,'./arinvoiceadd.php'),(20792235,10991,'./arinvoiceadd.php'),(20792234,5081,'./arinvoiceadd.php'),(20792233,1685,'./arinvoiceadd.php'),(20792232,6660,'./arinvoiceadd.php'),(20792231,1678,'./arinvoiceadd.php'),(20792230,1672,'./arinvoiceadd.php'),(20792229,1670,'./arinvoiceadd.php'),(20792228,1647,'./arinvoiceadd.php'),(20792227,1599,'./arinvoiceadd.php'),(20792226,17745,'./arinvoiceadd.php'),(20792225,1519,'./arinvoiceadd.php'),(20792224,15991,'./arinvoiceadd.php'),(20792223,1373,'./arinvoiceadd.php'),(20792222,1278,'./arinvoiceadd.php'),(20792221,1222,'./arinvoiceadd.php'),(20792220,1220,'./arinvoiceadd.php'),(20792219,1219,'./arinvoiceadd.php'),(20792218,8936,'./arinvoiceadd.php'),(20792217,6782,'./arinvoiceadd.php'),(20792216,6116,'./arinvoiceadd.php'),(20792215,1028,'./arinvoiceadd.php'),(20792214,981,'./arinvoiceadd.php'),(20792213,6115,'./arinvoiceadd.php'),(20792212,7868,'./arinvoiceadd.php'),(20792211,932,'./arinvoiceadd.php'),(20792210,16122,'./arinvoiceadd.php'),(20792209,892,'./arinvoiceadd.php'),(20792208,10572,'./arinvoiceadd.php'),(20792207,869,'./arinvoiceadd.php'),(20792206,15539,'./arinvoiceadd.php'),(20792205,737,'./arinvoiceadd.php'),(20792204,10613,'./arinvoiceadd.php'),(20792203,716,'./arinvoiceadd.php'),(20792202,4481,'./arinvoiceadd.php'),(20792201,702,'./arinvoiceadd.php'),(20792200,9341,'./arinvoiceadd.php'),(20792199,9492,'./arinvoiceadd.php'),(20792198,607,'./arinvoiceadd.php'),(20792197,593,'./arinvoiceadd.php'),(20792196,549,'./arinvoiceadd.php'),(20792188,8211,'./arinvoice_writeoff.php'),(20792187,8210,'./arinvoice_writeoff.php'),(20792186,8209,'./arinvoice_writeoff.php'),(20792185,20086,'./arinvoice_writeoff.php'),(20792184,19877,'./arinvoice_writeoff.php'),(20792183,3341,'./arinvoice_writeoff.php'),(20792182,3333,'./arinvoice_writeoff.php'),(20792181,3090,'./arinvoice_writeoff.php'),(20792180,8208,'./arinvoice_writeoff.php'),(20792179,2702,'./arinvoice_writeoff.php'),(20792178,2349,'./arinvoice_writeoff.php'),(20792177,2225,'./arinvoice_writeoff.php'),(20792176,2207,'./arinvoice_writeoff.php'),(20792175,8207,'./arinvoice_writeoff.php'),(20792174,1963,'./arinvoice_writeoff.php'),(20792173,1929,'./arinvoice_writeoff.php'),(20792172,8206,'./arinvoice_writeoff.php'),(20792171,1788,'./arinvoice_writeoff.php'),(20792170,5081,'./arinvoice_writeoff.php'),(20792169,20085,'./arinvoice_writeoff.php'),(20792168,1678,'./arinvoice_writeoff.php'),(20792167,15991,'./arinvoice_writeoff.php'),(20792166,11112,'./arinvoice_writeoff.php'),(20792165,932,'./arinvoice_writeoff.php'),(20792164,8203,'./arinvoice_writeoff.php'),(20792163,4481,'./arinvoice_writeoff.php'),(20792162,697,'./arinvoice_writeoff.php'),(20792161,9341,'./arinvoice_writeoff.php'),(20792160,9492,'./arinvoice_writeoff.php'),(20792159,8202,'./arinvoice_writeoff.php'),(20792152,14544,'./arhotelusage.php'),(20792151,2702,'./arhotelusage.php'),(20792150,14543,'./arhotelusage.php'),(20792149,14542,'./arhotelusage.php'),(20792148,14541,'./arhotelusage.php'),(20792147,1963,'./arhotelusage.php'),(20792146,14540,'./arhotelusage.php'),(20792145,14539,'./arhotelusage.php'),(20792144,14538,'./arhotelusage.php'),(20792143,8936,'./arhotelusage.php'),(20792142,1014,'./arhotelusage.php'),(20792141,737,'./arhotelusage.php'),(20792140,333,'./arhotelusage.php'),(20792139,14537,'./arhotelusage.php'),(20792138,3090,'./areft.php'),(20792137,14269,'./areft.php'),(20792136,11406,'./areft.php'),(20792135,14199,'./areft.php'),(20792134,19771,'./areft.php'),(20792133,5366,'./areft.php'),(20792132,2225,'./areft.php'),(20792131,18624,'./areft.php'),(20792130,2215,'./areft.php'),(20792129,14198,'./areft.php'),(20792128,14193,'./areft.php'),(20792127,1963,'./areft.php'),(20792126,1743,'./areft.php'),(20792125,9622,'./areft.php'),(20792124,5081,'./areft.php'),(20792123,1668,'./areft.php'),(20792122,1599,'./areft.php'),(20792121,1278,'./areft.php'),(20792120,8936,'./areft.php'),(20792119,1134,'./areft.php'),(20792118,1132,'./areft.php'),(20792117,1106,'./areft.php'),(20792116,14197,'./areft.php'),(20792115,14196,'./areft.php'),(20792114,14195,'./areft.php'),(20792113,932,'./areft.php'),(20792112,14192,'./areft.php'),(20792111,886,'./areft.php'),(20792110,697,'./areft.php'),(20792097,6361,'./ardiscountedit.php'),(20792096,10057,'./ardiscountedit.php'),(20792095,2702,'./ardiscountedit.php'),(20792094,2044,'./ardiscountedit.php'),(20792093,1935,'./ardiscountedit.php'),(20792092,1499,'./ardiscountedit.php'),(20792091,8936,'./ardiscountedit.php'),(20792090,941,'./ardiscountedit.php'),(20792089,9814,'./ardiscountedit.php'),(20792088,898,'./ardiscountedit.php'),(20792087,9813,'./ardiscountedit.php'),(20792086,10571,'./ardiscountedit.php'),(20792085,886,'./ardiscountedit.php'),(20792084,799,'./ardiscountedit.php'),(20792083,315,'./ardiscountedit.php'),(20792082,8125,'./ardiscountedit.php'),(20792081,59,'./ardiscountedit.php'),(20781531,9491,'./!/application/controllers/invreceive.php'),(20781878,8810,'./!/application/controllers/itemlocation.php'),(20781877,5070,'./!/application/controllers/itemlocation.php'),(20781876,3274,'./!/application/controllers/itemlocation.php'),(20781875,3252,'./!/application/controllers/itemlocation.php'),(20792079,7196,'./arcustupd.php'),(20792078,3322,'./arcustupd.php'),(20792077,15202,'./arcustupd.php'),(20792076,3319,'./arcustupd.php'),(20792075,14157,'./arcustupd.php'),(20792074,3216,'./arcustupd.php'),(20792073,4861,'./arcustupd.php'),(20792072,3072,'./arcustupd.php'),(20792071,9244,'./arcustupd.php'),(20792070,2948,'./arcustupd.php'),(20792069,15899,'./arcustupd.php'),(20792068,2801,'./arcustupd.php'),(20792067,2759,'./arcustupd.php'),(20792066,2751,'./arcustupd.php'),(20792065,2738,'./arcustupd.php'),(20792064,2710,'./arcustupd.php'),(20792063,2702,'./arcustupd.php'),(20792062,2676,'./arcustupd.php'),(20792061,2664,'./arcustupd.php'),(20792060,14233,'./arcustupd.php'),(20792059,7192,'./arcustupd.php'),(20792058,16675,'./arcustupd.php'),(20792057,4071,'./arcustupd.php'),(20792056,8197,'./arcustupd.php'),(20792055,2540,'./arcustupd.php'),(20792054,9835,'./arcustupd.php'),(20792053,20082,'./arcustupd.php'),(20792052,18590,'./arcustupd.php'),(20792051,18588,'./arcustupd.php'),(20792050,2324,'./arcustupd.php'),(20792049,2267,'./arcustupd.php'),(20792048,2237,'./arcustupd.php'),(20792047,2200,'./arcustupd.php'),(20792046,2044,'./arcustupd.php'),(20792045,6701,'./arcustupd.php'),(20792044,2103,'./arcustupd.php'),(20792043,18587,'./arcustupd.php'),(20792042,18585,'./arcustupd.php'),(20792041,3706,'./arcustupd.php'),(20792040,17405,'./arcustupd.php'),(20792039,15059,'./arcustupd.php'),(20792038,15898,'./arcustupd.php'),(20792037,13586,'./arcustupd.php'),(20792036,9390,'./arcustupd.php'),(20792035,1685,'./arcustupd.php'),(20792034,4940,'./arcustupd.php'),(20792033,1467,'./arcustupd.php'),(20792032,8867,'./arcustupd.php'),(20792031,11868,'./arcustupd.php'),(20792030,5072,'./arcustupd.php'),(20792029,5142,'./arcustupd.php'),(20792028,8936,'./arcustupd.php'),(20792027,5141,'./arcustupd.php'),(20792026,981,'./arcustupd.php'),(20792025,12020,'./arcustupd.php'),(20792024,967,'./arcustupd.php'),(20792023,941,'./arcustupd.php'),(20792022,4602,'./arcustupd.php'),(20792021,852,'./arcustupd.php'),(20792020,827,'./arcustupd.php'),(20792019,8196,'./arcustupd.php'),(20792018,799,'./arcustupd.php'),(20792017,18316,'./arcustupd.php'),(20792016,4363,'./arcustupd.php'),(20792015,731,'./arcustupd.php'),(20792014,726,'./arcustupd.php'),(20792013,727,'./arcustupd.php'),(20792012,725,'./arcustupd.php'),(20792011,724,'./arcustupd.php'),(20792010,723,'./arcustupd.php'),(20792009,15233,'./arcustupd.php'),(20792008,716,'./arcustupd.php'),(20792007,3930,'./arcustupd.php'),(20792006,4481,'./arcustupd.php'),(20792005,705,'./arcustupd.php'),(20792004,699,'./arcustupd.php'),(20792003,697,'./arcustupd.php'),(20792002,683,'./arcustupd.php'),(20792001,675,'./arcustupd.php'),(20792000,11135,'./arcustupd.php'),(20791999,15598,'./arcustupd.php'),(20791998,6224,'./arcustupd.php'),(20791997,11843,'./arcustupd.php'),(20791996,605,'./arcustupd.php'),(20791995,542,'./arcustupd.php'),(20791994,13994,'./arcustupd.php'),(20791993,325,'./arcustupd.php'),(20791975,15328,'./arcustomerpage_define.php'),(20791974,2710,'./arcustomerpage_define.php'),(20791973,8508,'./arcustomerpage_define.php'),(20791972,2702,'./arcustomerpage_define.php'),(20791971,4265,'./arcustomerpage_define.php'),(20791970,14823,'./arcustomerpage_define.php'),(20791969,18106,'./arcustomerpage_define.php'),(20791968,8800,'./arcustomerpage_define.php'),(20791967,8792,'./arcustomerpage_define.php'),(20791966,542,'./arcustomerpage_define.php'),(20791965,8791,'./arcustomerpage_define.php'),(20796536,1668,'./autofunctions.php'),(20796535,1647,'./autofunctions.php'),(20791962,8732,'./arcustmerge_customfields.php'),(20791961,1963,'./arcustmerge_customfields.php'),(20791960,8662,'./arcustmerge_customfields.php'),(20791959,12098,'./arcustmerge_customfields.php'),(20791958,9154,'./arcustmerge_customfields.php'),(20791957,9153,'./arcustmerge_customfields.php'),(20791956,8660,'./arcustmerge_customfields.php'),(20791955,8656,'./arcustmerge_customfields.php'),(20791954,315,'./arcustmerge_customfields.php'),(20791953,8666,'./arcustmerge_customfields.php'),(20791952,9152,'./arcustmerge.php'),(20791951,8731,'./arcustmerge.php'),(20791950,1963,'./arcustmerge.php'),(20791949,9151,'./arcustmerge.php'),(20791948,9150,'./arcustmerge.php'),(20791947,8687,'./arcustmerge.php'),(20791946,9149,'./arcustmerge.php'),(20791945,18130,'./arcustmerge.php'),(20791944,6378,'./arcustmerge.php'),(20791943,9148,'./arcustmerge.php'),(20791942,4481,'./arcustmerge.php'),(20791941,8730,'./arcustmerge.php'),(20791940,8729,'./arcustmerge.php'),(20791937,4109,'./arcustlistview.php'),(20791936,2819,'./arcustlistview.php'),(20791935,2803,'./arcustlistview.php'),(20791934,2676,'./arcustlistview.php'),(20791933,2324,'./arcustlistview.php'),(20791932,1991,'./arcustlistview.php'),(20791931,1810,'./arcustlistview.php'),(20791930,1632,'./arcustlistview.php'),(20791929,1446,'./arcustlistview.php'),(20791928,1381,'./arcustlistview.php'),(20791927,981,'./arcustlistview.php'),(20791926,710,'./arcustlistview.php'),(20791925,6602,'./arcustlistview.php'),(20791924,573,'./arcustlistview.php'),(20791923,315,'./arcustlistview.php'),(20791922,185,'./arcustlistview.php'),(20791921,7492,'./arcustlistremove.php'),(20791920,1963,'./arcustlistremove.php'),(20791919,7491,'./arcustlistremove.php'),(20791918,7490,'./arcustlistremove.php'),(20791917,7489,'./arcustlistremove.php'),(20791916,7488,'./arcustlistremove.php'),(20791915,8936,'./arcustlistremove.php'),(20791914,7487,'./arcustlistremove.php'),(20791913,799,'./arcustlistremove.php'),(20791912,7486,'./arcustlistremove.php'),(20791911,7485,'./arcustlistremove.php'),(20791910,697,'./arcustlistremove.php'),(20791909,6165,'./arcustlistremove.php'),(20791908,326,'./arcustlistremove.php'),(20791907,7484,'./arcustlistremove.php'),(20791906,11111,'./arcustlistedit.php'),(20791905,11979,'./arcustlistedit.php'),(20791904,11110,'./arcustlistedit.php'),(20791903,8908,'./arcustlistedit.php'),(20791902,2702,'./arcustlistedit.php'),(20791901,3961,'./arcustlistedit.php'),(20791900,11109,'./arcustlistedit.php'),(20791899,2405,'./arcustlistedit.php'),(20791898,11108,'./arcustlistedit.php'),(20791897,1758,'./arcustlistedit.php'),(20791896,1685,'./arcustlistedit.php'),(20791895,1578,'./arcustlistedit.php'),(20791894,11107,'./arcustlistedit.php'),(20791893,1429,'./arcustlistedit.php'),(20791892,8936,'./arcustlistedit.php'),(20791891,11105,'./arcustlistedit.php'),(20791890,11106,'./arcustlistedit.php'),(20791889,675,'./arcustlistedit.php'),(20791888,581,'./arcustlistedit.php'),(20791887,541,'./arcustlistedit.php'),(20791886,3377,'./arcustlist.php'),(20791885,3143,'./arcustlist.php'),(20791884,3142,'./arcustlist.php'),(20791883,3138,'./arcustlist.php'),(20791882,3137,'./arcustlist.php'),(20791881,3135,'./arcustlist.php'),(20791880,3961,'./arcustlist.php'),(20791879,11978,'./arcustlist.php'),(20791878,8816,'./arcustlist.php'),(20791877,3472,'./arcustlist.php'),(20791876,8805,'./arcustlist.php'),(20791875,2405,'./arcustlist.php'),(20791874,8815,'./arcustlist.php'),(20791873,8814,'./arcustlist.php'),(20791872,8813,'./arcustlist.php'),(20791871,1991,'./arcustlist.php'),(20791870,1963,'./arcustlist.php'),(20791869,7978,'./arcustlist.php'),(20791868,1814,'./arcustlist.php'),(20791867,1811,'./arcustlist.php'),(20791866,8804,'./arcustlist.php'),(20791865,14997,'./arcustlist.php'),(20791864,8803,'./arcustlist.php'),(20791863,1685,'./arcustlist.php'),(20791862,14996,'./arcustlist.php'),(20791861,11105,'./arcustlist.php'),(20791860,712,'./arcustlist.php'),(20791859,711,'./arcustlist.php'),(20791858,4110,'./arcustlist.php'),(20791857,17744,'./arcustlist.php'),(20791856,6602,'./arcustlist.php'),(20791855,8812,'./arcustlist.php'),(20791854,681,'./arcustlist.php'),(20791851,9820,'./arcustitemdiscount.php'),(20791850,9819,'./arcustitemdiscount.php'),(20791849,9818,'./arcustitemdiscount.php'),(20791848,9817,'./arcustitemdiscount.php'),(20791847,2710,'./arcustitemdiscount.php'),(20791846,2702,'./arcustitemdiscount.php'),(20791845,9816,'./arcustitemdiscount.php'),(20791844,1963,'./arcustitemdiscount.php'),(20791843,6366,'./arcustitemdiscount.php'),(20791842,1724,'./arcustitemdiscount.php'),(20791841,1696,'./arcustitemdiscount.php'),(20791840,9815,'./arcustitemdiscount.php'),(20791839,8936,'./arcustitemdiscount.php'),(20791838,941,'./arcustitemdiscount.php'),(20791837,9814,'./arcustitemdiscount.php'),(20791836,9813,'./arcustitemdiscount.php'),(20791835,799,'./arcustitemdiscount.php'),(20791834,4481,'./arcustitemdiscount.php'),(20791833,9812,'./arcustitemdiscount.php'),(20791832,697,'./arcustitemdiscount.php'),(20791831,315,'./arcustitemdiscount.php'),(20791830,9811,'./arcustitemdiscount.php'),(20791829,5203,'./arcustitemdiscount.php'),(20791828,9810,'./arcustitemdiscount.php'),(20791827,59,'./arcustitemdiscount.php'),(20808786,9492,'./prloghours.php'),(20807732,11827,'./prchecks.php'),(20806073,2151,'./nporder.php'),(20795314,387,'./arordshipquote.php'),(20669044,3311,'./arcustextuser.php'),(20669043,3310,'./arcustextuser.php'),(20669042,3264,'./arcustextuser.php'),(20669041,3256,'./arcustextuser.php'),(20669040,3255,'./arcustextuser.php'),(20669039,3254,'./arcustextuser.php'),(20669038,3202,'./arcustextuser.php'),(20669037,2756,'./arcustextuser.php'),(20669036,2710,'./arcustextuser.php'),(20669035,2702,'./arcustextuser.php'),(20669034,2234,'./arcustextuser.php'),(20669033,1963,'./arcustextuser.php'),(20669032,1937,'./arcustextuser.php'),(20669031,1634,'./arcustextuser.php'),(20669030,1622,'./arcustextuser.php'),(20669029,965,'./arcustextuser.php'),(20669028,941,'./arcustextuser.php'),(20669027,859,'./arcustextuser.php'),(20669026,807,'./arcustextuser.php'),(20669025,799,'./arcustextuser.php'),(20669024,4481,'./arcustextuser.php'),(20669023,707,'./arcustextuser.php'),(20669022,697,'./arcustextuser.php'),(20669021,315,'./arcustextuser.php'),(20669020,4871,'./arcustextuser.php'),(20669019,144,'./arcustextuser.php'),(20669018,78,'./arcustextuser.php'),(20669017,59,'./arcustextuser.php'),(20791826,3319,'./arcustdupmatch.php'),(20791825,2751,'./arcustdupmatch.php'),(20791824,14090,'./arcustdupmatch.php'),(20791823,2324,'./arcustdupmatch.php'),(20791822,14089,'./arcustdupmatch.php'),(20791821,1935,'./arcustdupmatch.php'),(20791820,14088,'./arcustdupmatch.php'),(20791819,981,'./arcustdupmatch.php'),(20791818,14087,'./arcustdupmatch.php'),(20791817,581,'./arcustdupmatch.php'),(20791816,14086,'./arcustdupmatch.php'),(20791815,185,'./arcustdupmatch.php'),(20791814,3428,'./arcustcsvlist.php'),(20791813,3075,'./arcustcsvlist.php'),(20791812,1991,'./arcustcsvlist.php'),(20791811,532,'./arcustcsvlist.php'),(20791810,315,'./arcustcsvlist.php'),(20791809,17493,'./arcustchange.php'),(20791808,2819,'./arcustchange.php'),(20791807,2702,'./arcustchange.php'),(20791806,2165,'./arcustchange.php'),(20791805,7901,'./arcustchange.php'),(20791804,1668,'./arcustchange.php'),(20791803,8936,'./arcustchange.php'),(20791802,6923,'./arcustchange.php'),(20791801,15792,'./arcustchange.php'),(20791800,4481,'./arcustchange.php'),(20791799,13913,'./arcustchange.php'),(20791798,13912,'./arcustchange.php'),(20791797,605,'./arcustchange.php'),(20792109,20083,'./areft.php'),(20792108,14194,'./areft.php'),(20792107,19420,'./areft.php'),(20792106,19419,'./areft.php'),(20791992,315,'./arcustupd.php'),(20791991,6717,'./arcustupd.php'),(20791990,14050,'./arcustupd.php'),(20791989,306,'./arcustupd.php'),(20791988,5203,'./arcustupd.php'),(20791793,3311,'./arcustb2buser.php'),(20791792,3310,'./arcustb2buser.php'),(20791791,3264,'./arcustb2buser.php'),(20791790,3256,'./arcustb2buser.php'),(20791789,3254,'./arcustb2buser.php'),(20791788,3202,'./arcustb2buser.php'),(20791787,19484,'./arcustb2buser.php'),(20791786,2975,'./arcustb2buser.php'),(20791785,2795,'./arcustb2buser.php'),(20791784,13471,'./arcustb2buser.php'),(20791783,2756,'./arcustb2buser.php'),(20791782,2710,'./arcustb2buser.php'),(20791781,2702,'./arcustb2buser.php'),(20791780,14655,'./arcustb2buser.php'),(20791779,19482,'./arcustb2buser.php'),(20791778,2324,'./arcustb2buser.php'),(20791777,2237,'./arcustb2buser.php'),(20791776,2234,'./arcustb2buser.php'),(20791775,19481,'./arcustb2buser.php'),(20791774,1963,'./arcustb2buser.php'),(20791773,1937,'./arcustb2buser.php'),(20791772,19479,'./arcustb2buser.php'),(20791771,16738,'./arcustb2buser.php'),(20791770,4469,'./arcustb2buser.php'),(20791769,1758,'./arcustb2buser.php'),(20791768,1634,'./arcustb2buser.php'),(20791767,1622,'./arcustb2buser.php'),(20791766,1429,'./arcustb2buser.php'),(20791765,7250,'./arcustb2buser.php'),(20791764,1047,'./arcustb2buser.php'),(20791741,8908,'./arcustadd.php'),(20791740,2728,'./arcustadd.php'),(20791739,2702,'./arcustadd.php'),(20791738,4265,'./arcustadd.php'),(20791737,12097,'./arcustadd.php'),(20791736,2599,'./arcustadd.php'),(20791735,2598,'./arcustadd.php'),(20791734,2260,'./arcustadd.php'),(20791733,2237,'./arcustadd.php'),(20791732,6701,'./arcustadd.php'),(20791731,7901,'./arcustadd.php'),(20791730,12732,'./arcustadd.php'),(20791729,5072,'./arcustadd.php'),(20791728,8936,'./arcustadd.php'),(20791727,19770,'./arcustadd.php'),(20791720,3090,'./arcredit_writecheck.php'),(20791719,5693,'./arcredit_writecheck.php'),(20791718,7726,'./arcredit_writecheck.php'),(20791717,5692,'./arcredit_writecheck.php'),(20791716,6052,'./arcredit_writecheck.php'),(20791715,6654,'./arcredit_writecheck.php'),(20791714,1963,'./arcredit_writecheck.php'),(20791713,1788,'./arcredit_writecheck.php'),(20791712,1678,'./arcredit_writecheck.php'),(20791711,7725,'./arcredit_writecheck.php'),(20791710,7724,'./arcredit_writecheck.php'),(20791709,1025,'./arcredit_writecheck.php'),(20791708,888,'./arcredit_writecheck.php'),(20791707,737,'./arcredit_writecheck.php'),(20791706,4481,'./arcredit_writecheck.php'),(20791705,697,'./arcredit_writecheck.php'),(20791704,6647,'./arcredit_writecheck.php'),(20791703,673,'./arcredit_writecheck.php'),(20791702,7723,'./arcredit_writecheck.php'),(20791701,607,'./arcredit_writecheck.php'),(20791700,3999,'./arcredit_writecheck.php'),(20791699,491,'./arcredit_writecheck.php'),(20791698,484,'./arcredit_writecheck.php'),(20791697,481,'./arcredit_writecheck.php'),(20791696,479,'./arcredit_writecheck.php'),(20791695,445,'./arcredit_writecheck.php'),(20791694,325,'./arcredit_writecheck.php'),(20791693,315,'./arcredit_writecheck.php'),(20791692,11775,'./arcredit_writecheck.php'),(20791691,11774,'./arcredit_writecheck.php'),(20791690,7722,'./arcredit_writecheck.php'),(20791688,10612,'./arcoinvoice.php'),(20791687,10611,'./arcoinvoice.php'),(20791686,10610,'./arcoinvoice.php'),(20791685,3090,'./arcoinvoice.php'),(20791684,10609,'./arcoinvoice.php'),(20791683,10608,'./arcoinvoice.php'),(20791682,2702,'./arcoinvoice.php'),(20791681,4023,'./arcoinvoice.php'),(20791680,6749,'./arcoinvoice.php'),(20791679,10607,'./arcoinvoice.php'),(20791678,10606,'./arcoinvoice.php'),(20791677,1963,'./arcoinvoice.php'),(20791676,10605,'./arcoinvoice.php'),(20791675,1678,'./arcoinvoice.php'),(20791674,10604,'./arcoinvoice.php'),(20791673,8936,'./arcoinvoice.php'),(20791672,869,'./arcoinvoice.php'),(20791671,10603,'./arcoinvoice.php'),(20791670,10602,'./arcoinvoice.php'),(20791669,10601,'./arcoinvoice.php'),(20791668,10600,'./arcoinvoice.php'),(20791667,10599,'./arcoinvoice.php'),(20791666,315,'./arcoinvoice.php'),(20791665,10598,'./arcoinvoice.php'),(20791664,57,'./arcoinvoice.php'),(20791663,14157,'./arcimue.php'),(20791662,2702,'./arcimue.php'),(20791661,14054,'./arcimue.php'),(20791660,14156,'./arcimue.php'),(20791659,14155,'./arcimue.php'),(20791658,4023,'./arcimue.php'),(20791657,1992,'./arcimue.php'),(20791656,14053,'./arcimue.php'),(20791655,1583,'./arcimue.php'),(20791654,1582,'./arcimue.php'),(20791653,6744,'./arcimue.php'),(20791652,14154,'./arcimue.php'),(20791651,14153,'./arcimue.php'),(20791650,5912,'./arcimue.php'),(20791649,5910,'./arcimue.php'),(20791648,14152,'./arcimue.php'),(20791647,14151,'./arcimue.php'),(20791646,9380,'./arcimue.php'),(20791645,9379,'./arcimue.php'),(20791644,9378,'./arcimue.php'),(20791643,9377,'./arcimue.php'),(20791642,14150,'./arcimue.php'),(20791641,14054,'./arcim.php'),(20791640,14053,'./arcim.php'),(20791639,14052,'./arcim.php'),(20791638,19577,'./arcim.php'),(20791637,19576,'./arcim.php'),(20808785,607,'./prloghours.php'),(20791634,5422,'./arcctransactions.php'),(20791633,4329,'./arcctransactions.php'),(20791632,1963,'./arcctransactions.php'),(20791631,1014,'./arcctransactions.php'),(20791630,4481,'./arcctransactions.php'),(20791629,7121,'./arcctransactions.php'),(20791628,6698,'./arcctransactions.php'),(20791627,5725,'./arcctransactions.php'),(20791626,6697,'./arcctransactions.php'),(20791625,333,'./arcctransactions.php'),(20791624,315,'./arcctransactions.php'),(20808784,524,'./prloghours.php'),(20788829,3036,'./admininvoicenotesadd.php'),(20791623,5371,'./arcashpaymentupd.php'),(20791622,5378,'./arcashpaymentupd.php'),(20791621,3225,'./arcashpaymentupd.php'),(20791620,7231,'./arcashpaymentupd.php'),(20791619,5370,'./arcashpaymentupd.php'),(20791618,3000,'./arcashpaymentupd.php'),(20791617,5369,'./arcashpaymentupd.php'),(20791616,2998,'./arcashpaymentupd.php'),(20791615,2702,'./arcashpaymentupd.php'),(20791614,5367,'./arcashpaymentupd.php'),(20791613,2686,'./arcashpaymentupd.php'),(20791612,3961,'./arcashpaymentupd.php'),(20791611,7108,'./arcashpaymentupd.php'),(20791610,11406,'./arcashpaymentupd.php'),(20791609,5366,'./arcashpaymentupd.php'),(20791608,5365,'./arcashpaymentupd.php'),(20791607,2208,'./arcashpaymentupd.php'),(20791606,5379,'./arcashpaymentupd.php'),(20791605,12200,'./arcashpaymentupd.php'),(20791604,2094,'./arcashpaymentupd.php'),(20791603,2093,'./arcashpaymentupd.php'),(20791602,2103,'./arcashpaymentupd.php'),(20791601,1963,'./arcashpaymentupd.php'),(20791600,3672,'./arcashpaymentupd.php'),(20791599,5081,'./arcashpaymentupd.php'),(20791598,1647,'./arcashpaymentupd.php'),(20791597,1578,'./arcashpaymentupd.php'),(20791596,1519,'./arcashpaymentupd.php'),(20791595,13064,'./arcashpaymentupd.php'),(20791594,5364,'./arcashpaymentupd.php'),(20791593,15991,'./arcashpaymentupd.php'),(20791592,13067,'./arcashpaymentupd.php'),(20791591,5363,'./arcashpaymentupd.php'),(20791590,1232,'./arcashpaymentupd.php'),(20791589,8936,'./arcashpaymentupd.php'),(20791588,4346,'./arcashpaymentupd.php'),(20791587,1143,'./arcashpaymentupd.php'),(20791586,5376,'./arcashpaymentupd.php'),(20791585,11905,'./arcashpaymentupd.php'),(20791584,941,'./arcashpaymentupd.php'),(20791583,869,'./arcashpaymentupd.php'),(20791582,5878,'./arcashpaymentupd.php'),(20791581,864,'./arcashpaymentupd.php'),(20791580,799,'./arcashpaymentupd.php'),(20791579,716,'./arcashpaymentupd.php'),(20791578,4481,'./arcashpaymentupd.php'),(20791577,697,'./arcashpaymentupd.php'),(20791576,673,'./arcashpaymentupd.php'),(20791575,653,'./arcashpaymentupd.php'),(20791574,5360,'./arcashpaymentupd.php'),(20791573,9492,'./arcashpaymentupd.php'),(20791572,5375,'./arcashpaymentupd.php'),(20791571,479,'./arcashpaymentupd.php'),(20791570,445,'./arcashpaymentupd.php'),(20791569,5877,'./arcashpaymentupd.php'),(20791568,5374,'./arcashpaymentupd.php'),(20791567,13994,'./arcashpaymentupd.php'),(20791566,315,'./arcashpaymentupd.php'),(20791565,5203,'./arcashpaymentupd.php'),(20791564,226,'./arcashpaymentupd.php'),(20791563,87,'./arcashpaymentupd.php'),(20791561,3118,'./arcashpaymentrep.php'),(20791560,3090,'./arcashpaymentrep.php'),(20791559,2998,'./arcashpaymentrep.php'),(20791558,5991,'./arcashpaymentrep.php'),(20791557,5366,'./arcashpaymentrep.php'),(20791556,5365,'./arcashpaymentrep.php'),(20791555,2208,'./arcashpaymentrep.php'),(20791554,5985,'./arcashpaymentrep.php'),(20791553,4087,'./arcashpaymentrep.php'),(20791552,5381,'./arcashpaymentrep.php'),(20791551,5377,'./arcashpaymentrep.php'),(20791550,1963,'./arcashpaymentrep.php'),(20791549,1578,'./arcashpaymentrep.php'),(20791548,13066,'./arcashpaymentrep.php'),(20791547,5376,'./arcashpaymentrep.php'),(20791546,869,'./arcashpaymentrep.php'),(20791545,9726,'./arcashpaymentrep.php'),(20791544,4481,'./arcashpaymentrep.php'),(20791543,697,'./arcashpaymentrep.php'),(20791542,673,'./arcashpaymentrep.php'),(20791541,5382,'./arcashpaymentrep.php'),(20791540,479,'./arcashpaymentrep.php'),(20791539,451,'./arcashpaymentrep.php'),(20791538,445,'./arcashpaymentrep.php'),(20791537,5374,'./arcashpaymentrep.php'),(20791536,315,'./arcashpaymentrep.php'),(20791535,226,'./arcashpaymentrep.php'),(20791534,197,'./arcashpaymentrep.php'),(20791533,13065,'./arcashpaymentadd.php'),(20791532,5371,'./arcashpaymentadd.php'),(20791531,5373,'./arcashpaymentadd.php'),(20791530,7231,'./arcashpaymentadd.php'),(20791529,5370,'./arcashpaymentadd.php'),(20791528,3000,'./arcashpaymentadd.php'),(20791527,5369,'./arcashpaymentadd.php'),(20791526,2998,'./arcashpaymentadd.php'),(20791525,2702,'./arcashpaymentadd.php'),(20791524,5367,'./arcashpaymentadd.php'),(20791523,2686,'./arcashpaymentadd.php'),(20791522,3961,'./arcashpaymentadd.php'),(20791521,7108,'./arcashpaymentadd.php'),(20791520,11406,'./arcashpaymentadd.php'),(20791519,5366,'./arcashpaymentadd.php'),(20791518,5365,'./arcashpaymentadd.php'),(20791517,2208,'./arcashpaymentadd.php'),(20791516,7565,'./arcashpaymentadd.php'),(20791515,6696,'./arcashpaymentadd.php'),(20791514,2093,'./arcashpaymentadd.php'),(20791513,2103,'./arcashpaymentadd.php'),(20791512,11906,'./arcashpaymentadd.php'),(20791511,3672,'./arcashpaymentadd.php'),(20791510,5081,'./arcashpaymentadd.php'),(20791509,1647,'./arcashpaymentadd.php'),(20791508,1519,'./arcashpaymentadd.php'),(20791507,13064,'./arcashpaymentadd.php'),(20791506,5364,'./arcashpaymentadd.php'),(20791505,15991,'./arcashpaymentadd.php'),(20791504,13063,'./arcashpaymentadd.php'),(20791503,13200,'./arcashpaymentadd.php'),(20791502,5363,'./arcashpaymentadd.php'),(20791501,1232,'./arcashpaymentadd.php'),(20791500,5362,'./arcashpaymentadd.php'),(20791499,8936,'./arcashpaymentadd.php'),(20791498,941,'./arcashpaymentadd.php'),(20791497,869,'./arcashpaymentadd.php'),(20791496,716,'./arcashpaymentadd.php'),(20791495,4481,'./arcashpaymentadd.php'),(20791494,9341,'./arcashpaymentadd.php'),(20791493,673,'./arcashpaymentadd.php'),(20791492,5360,'./arcashpaymentadd.php'),(20791491,9492,'./arcashpaymentadd.php'),(20791490,479,'./arcashpaymentadd.php'),(20791489,445,'./arcashpaymentadd.php'),(20791488,13994,'./arcashpaymentadd.php'),(20791487,315,'./arcashpaymentadd.php'),(20791486,14001,'./arcashpaymentadd.php'),(20791485,176,'./arcashpaymentadd.php'),(20791483,14417,'./arbankreconciledetail.php'),(20791482,3358,'./arbankreconciledetail.php'),(20791481,10526,'./arbankreconciledetail.php'),(20791480,10525,'./arbankreconciledetail.php'),(20791479,8701,'./arbankreconciledetail.php'),(20791478,16407,'./arbankreconciledetail.php'),(20791477,10524,'./arbankreconciledetail.php'),(20791476,8421,'./arbankreconciledetail.php'),(20791475,2782,'./arbankreconciledetail.php'),(20791474,2702,'./arbankreconciledetail.php'),(20791473,10523,'./arbankreconciledetail.php'),(20791472,4023,'./arbankreconciledetail.php'),(20791471,16406,'./arbankreconciledetail.php'),(20791470,2097,'./arbankreconciledetail.php'),(20791469,7899,'./arbankreconciledetail.php'),(20791468,8416,'./arbankreconciledetail.php'),(20791467,10520,'./arbankreconciledetail.php'),(20788847,3036,'./admininvoicenotesupd.php'),(20808783,491,'./prloghours.php'),(20808782,6165,'./prloghours.php'),(20808781,15676,'./prloghours.php'),(20791459,3421,'./arbankreconcile.php'),(20791458,3319,'./arbankreconcile.php'),(20791457,5896,'./arbankreconcile.php'),(20791456,13860,'./arbankreconcile.php'),(20791455,6944,'./arbankreconcile.php'),(20791454,17208,'./arbankreconcile.php'),(20791453,17207,'./arbankreconcile.php'),(20791452,17162,'./arbankreconcile.php'),(20791451,11927,'./arbankreconcile.php'),(20791450,2702,'./arbankreconcile.php'),(20791449,5895,'./arbankreconcile.php'),(20791448,5894,'./arbankreconcile.php'),(20791447,11926,'./arbankreconcile.php'),(20791446,11925,'./arbankreconcile.php'),(20791445,11924,'./arbankreconcile.php'),(20791444,11923,'./arbankreconcile.php'),(20791443,11922,'./arbankreconcile.php'),(20791442,11921,'./arbankreconcile.php'),(20791441,2208,'./arbankreconcile.php'),(20791440,1973,'./arbankreconcile.php'),(20791439,1963,'./arbankreconcile.php'),(20791438,11920,'./arbankreconcile.php'),(20791437,11919,'./arbankreconcile.php'),(20791436,17607,'./arbankreconcile.php'),(20791435,17606,'./arbankreconcile.php'),(20791434,16404,'./arbankreconcile.php'),(20791433,13859,'./arbankreconcile.php'),(20791432,8936,'./arbankreconcile.php'),(20791431,4346,'./arbankreconcile.php'),(20791430,9804,'./arbankreconcile.php'),(20791429,11918,'./arbankreconcile.php'),(20791428,5891,'./arbankreconcile.php'),(20791427,11916,'./arbankreconcile.php'),(20791426,11915,'./arbankreconcile.php'),(20791425,11914,'./arbankreconcile.php'),(20791424,10773,'./arbankreconcile.php'),(20791423,869,'./arbankreconcile.php'),(20791422,11913,'./arbankreconcile.php'),(20791421,5205,'./arbankreconcile.php'),(20791420,799,'./arbankreconcile.php'),(20791419,737,'./arbankreconcile.php'),(20791418,673,'./arbankreconcile.php'),(20791417,607,'./arbankreconcile.php'),(20791416,5889,'./arbankreconcile.php'),(20791415,11912,'./arbankreconcile.php'),(20791414,479,'./arbankreconcile.php'),(20791413,445,'./arbankreconcile.php'),(20791412,5888,'./arbankreconcile.php'),(20791411,12850,'./arbankreconcile.php'),(20791410,5886,'./arbankreconcile.php'),(20791409,11907,'./arbankreconcile.php'),(20791397,3427,'./arbankdepositviewfpdf.php'),(20791396,5378,'./arbankdepositviewfpdf.php'),(20791395,4387,'./arbankdepositviewfpdf.php'),(20791394,5845,'./arbankdepositviewfpdf.php'),(20791393,2208,'./arbankdepositviewfpdf.php'),(20791392,869,'./arbankdepositviewfpdf.php'),(20791391,10255,'./arbankdepositviewfpdf.php'),(20791390,10254,'./arbankdepositviewfpdf.php'),(20791389,10253,'./arbankdepositviewfpdf.php'),(20791388,737,'./arbankdepositviewfpdf.php'),(20791387,542,'./arbankdepositviewfpdf.php'),(20791386,10252,'./arbankdepositviewfpdf.php'),(20791385,491,'./arbankdepositviewfpdf.php'),(20791384,513,'./arbankdepositviewfpdf.php'),(20791383,445,'./arbankdepositviewfpdf.php'),(20791382,226,'./arbankdepositviewfpdf.php'),(20791381,16462,'./arbankdepositupd.php'),(20791380,3421,'./arbankdepositupd.php'),(20791379,16703,'./arbankdepositupd.php'),(20791378,3333,'./arbankdepositupd.php'),(20791377,5378,'./arbankdepositupd.php'),(20791376,3156,'./arbankdepositupd.php'),(20791375,3090,'./arbankdepositupd.php'),(20791374,3072,'./arbankdepositupd.php'),(20791373,16461,'./arbankdepositupd.php'),(20791372,5863,'./arbankdepositupd.php'),(20791371,2977,'./arbankdepositupd.php'),(20791370,2657,'./arbankdepositupd.php'),(20791369,6695,'./arbankdepositupd.php'),(20791368,4009,'./arbankdepositupd.php'),(20791367,5875,'./arbankdepositupd.php'),(20791366,5874,'./arbankdepositupd.php'),(20791365,10406,'./arbankdepositupd.php'),(20791364,1973,'./arbankdepositupd.php'),(20791363,1963,'./arbankdepositupd.php'),(20791362,5861,'./arbankdepositupd.php'),(20791361,17825,'./arbankdepositupd.php'),(20791360,15901,'./arbankdepositupd.php'),(20791359,10450,'./arbankdepositupd.php'),(20791358,1467,'./arbankdepositupd.php'),(20791357,5873,'./arbankdepositupd.php'),(20791356,7866,'./arbankdepositupd.php'),(20791355,941,'./arbankdepositupd.php'),(20791354,869,'./arbankdepositupd.php'),(20791353,5901,'./arbankdepositupd.php'),(20791352,5872,'./arbankdepositupd.php'),(20791351,5871,'./arbankdepositupd.php'),(20791350,5839,'./arbankdepositupd.php'),(20791349,5870,'./arbankdepositupd.php'),(20791348,799,'./arbankdepositupd.php'),(20791347,16161,'./arbankdepositupd.php'),(20791346,607,'./arbankdepositupd.php'),(20791345,445,'./arbankdepositupd.php'),(20791344,5869,'./arbankdepositupd.php'),(20791343,5859,'./arbankdepositupd.php'),(20791342,5868,'./arbankdepositupd.php'),(20791341,5430,'./arbankdepositupd.php'),(20791340,5402,'./arbankdepositupd.php'),(20791332,17833,'./arbankdepositadd.php'),(20791331,17874,'./arbankdepositadd.php'),(20791330,17873,'./arbankdepositadd.php'),(20791329,17832,'./arbankdepositadd.php'),(20791328,17829,'./arbankdepositadd.php'),(20791327,17828,'./arbankdepositadd.php'),(20791326,17827,'./arbankdepositadd.php'),(20791325,3333,'./arbankdepositadd.php'),(20791324,3221,'./arbankdepositadd.php'),(20791323,3156,'./arbankdepositadd.php'),(20791322,18272,'./arbankdepositadd.php'),(20791321,5845,'./arbankdepositadd.php'),(20791320,3090,'./arbankdepositadd.php'),(20791319,17743,'./arbankdepositadd.php'),(20791318,5863,'./arbankdepositadd.php'),(20791317,2977,'./arbankdepositadd.php'),(20791316,18001,'./arbankdepositadd.php'),(20791315,2738,'./arbankdepositadd.php'),(20791314,6695,'./arbankdepositadd.php'),(20791313,4009,'./arbankdepositadd.php'),(20791312,5862,'./arbankdepositadd.php'),(20791311,2266,'./arbankdepositadd.php'),(20791310,17826,'./arbankdepositadd.php'),(20791309,16159,'./arbankdepositadd.php'),(20791308,19253,'./arbankdepositadd.php'),(20791307,2208,'./arbankdepositadd.php'),(20791306,16158,'./arbankdepositadd.php'),(20791305,5841,'./arbankdepositadd.php'),(20791304,10406,'./arbankdepositadd.php'),(20791303,1963,'./arbankdepositadd.php'),(20791302,7899,'./arbankdepositadd.php'),(20791301,16157,'./arbankdepositadd.php'),(20791300,19252,'./arbankdepositadd.php'),(20791299,5861,'./arbankdepositadd.php'),(20791298,17825,'./arbankdepositadd.php'),(20791297,15901,'./arbankdepositadd.php'),(20791296,1682,'./arbankdepositadd.php'),(20791295,17824,'./arbankdepositadd.php'),(20791294,16156,'./arbankdepositadd.php'),(20791293,16155,'./arbankdepositadd.php'),(20791292,1599,'./arbankdepositadd.php'),(20791291,19251,'./arbankdepositadd.php'),(20791290,17823,'./arbankdepositadd.php'),(20791289,10450,'./arbankdepositadd.php'),(20791288,5840,'./arbankdepositadd.php'),(20791287,18271,'./arbankdepositadd.php'),(20791286,15025,'./arbankdepositadd.php'),(20791285,4836,'./arbankdepositadd.php'),(20791242,14149,'./araiproducts.php'),(20791241,14148,'./araiproducts.php'),(20791240,14147,'./araiproducts.php'),(20791239,14146,'./araiproducts.php'),(20791238,14657,'./ar3dcartstatus.php'),(20791237,4023,'./ar3dcartstatus.php'),(20791236,2182,'./ar3dcartstatus.php'),(20791235,8936,'./ar3dcartstatus.php'),(20791234,14656,'./ar3dcartstatus.php'),(20791233,12916,'./ar3dcartship.php'),(20791232,3126,'./ar3dcartship.php'),(20791231,14493,'./ar3dcartship.php'),(20791230,12935,'./ar3dcartship.php'),(20791229,2165,'./ar3dcartship.php'),(20791228,1880,'./ar3dcartship.php'),(20791227,1668,'./ar3dcartship.php'),(20791226,14492,'./ar3dcartship.php'),(20791225,8936,'./ar3dcartship.php'),(20791224,14491,'./ar3dcartship.php'),(20791223,4109,'./ar3dcartpricing.php'),(20791222,13821,'./ar3dcartpricing.php'),(20791221,14792,'./ar3dcartpricing.php'),(20791220,14791,'./ar3dcartpricing.php'),(20791219,2405,'./ar3dcartpricing.php'),(20791218,1788,'./ar3dcartpricing.php'),(20791217,1703,'./ar3dcartpricing.php'),(20791216,8936,'./ar3dcartpricing.php'),(20791215,197,'./ar3dcartpricing.php'),(20791214,12916,'./ar3dcart.php'),(20791213,4109,'./ar3dcart.php'),(20791212,6964,'./ar3dcart.php'),(20791211,12937,'./ar3dcart.php'),(20791210,12948,'./ar3dcart.php'),(20791209,12935,'./ar3dcart.php'),(20791208,6318,'./ar3dcart.php'),(20791207,2192,'./ar3dcart.php'),(20791206,5111,'./ar3dcart.php'),(20791205,12947,'./ar3dcart.php'),(20791204,9294,'./ar3dcart.php'),(20791203,12934,'./ar3dcart.php'),(20791202,12933,'./ar3dcart.php'),(20791201,12932,'./ar3dcart.php'),(20791200,2034,'./ar3dcart.php'),(20791199,1963,'./ar3dcart.php'),(20791198,8273,'./ar3dcart.php'),(20791197,1678,'./ar3dcart.php'),(20791196,9292,'./ar3dcart.php'),(20791195,5271,'./ar3dcart.php'),(20791194,11945,'./ar3dcart.php'),(20791193,12931,'./ar3dcart.php'),(20791192,8936,'./ar3dcart.php'),(20791191,1014,'./ar3dcart.php'),(20791190,886,'./ar3dcart.php'),(20791189,10253,'./ar3dcart.php'),(20791188,737,'./ar3dcart.php'),(20791187,697,'./ar3dcart.php'),(20791186,12930,'./ar3dcart.php'),(20791185,18048,'./ar3dcart.php'),(20791184,333,'./ar3dcart.php'),(20791183,12929,'./ar3dcart.php'),(20791182,8875,'./ar3dcart.php'),(20791181,12928,'./ar3dcart.php'),(20791180,12927,'./ar3dcart.php'),(20791178,3221,'./ar2inv_close.php'),(20791177,3202,'./ar2inv_close.php'),(20791176,1963,'./ar2inv_close.php'),(20791175,8034,'./ar2inv_close.php'),(20791174,1232,'./ar2inv_close.php'),(20791173,8033,'./ar2inv_close.php'),(20791172,5145,'./ar2inv_close.php'),(20791171,3322,'./apvendupd.php'),(20791170,15200,'./apvendupd.php'),(20791169,6451,'./apvendupd.php'),(20791168,3319,'./apvendupd.php'),(20791167,3308,'./apvendupd.php'),(20791166,14764,'./apvendupd.php'),(20791165,3294,'./apvendupd.php'),(20791164,3292,'./apvendupd.php'),(20791163,15621,'./apvendupd.php'),(20791162,3281,'./apvendupd.php'),(20791161,15725,'./apvendupd.php'),(20791160,3274,'./apvendupd.php'),(20791159,3202,'./apvendupd.php'),(20791158,8472,'./apvendupd.php'),(20791157,3156,'./apvendupd.php'),(20791156,3056,'./apvendupd.php'),(20791155,3035,'./apvendupd.php'),(20791154,9244,'./apvendupd.php'),(20791153,2948,'./apvendupd.php'),(20791152,3847,'./apvendupd.php'),(20791151,2710,'./apvendupd.php'),(20791150,2702,'./apvendupd.php'),(20791149,14007,'./apvendupd.php'),(20791148,4088,'./apvendupd.php'),(20791147,12153,'./apvendupd.php'),(20791146,8197,'./apvendupd.php'),(20791145,20082,'./apvendupd.php'),(20791144,2324,'./apvendupd.php'),(20791143,6452,'./apvendupd.php'),(20791142,2226,'./apvendupd.php'),(20791141,2225,'./apvendupd.php'),(20791140,11013,'./apvendupd.php'),(20791139,6839,'./apvendupd.php'),(20791138,10711,'./apvendupd.php'),(20791137,10709,'./apvendupd.php'),(20791136,11298,'./apvendupd.php'),(20791135,2103,'./apvendupd.php'),(20791134,15059,'./apvendupd.php'),(20791133,13766,'./apvendupd.php'),(20791132,1935,'./apvendupd.php'),(20791131,10386,'./apvendupd.php'),(20791130,1678,'./apvendupd.php'),(20791129,1672,'./apvendupd.php'),(20791128,12088,'./apvendupd.php'),(20791127,11868,'./apvendupd.php'),(20791126,5072,'./apvendupd.php'),(20791125,10384,'./apvendupd.php'),(20791124,8936,'./apvendupd.php'),(20791123,981,'./apvendupd.php'),(20791122,7880,'./apvendupd.php'),(20791121,941,'./apvendupd.php'),(20791120,932,'./apvendupd.php'),(20791119,860,'./apvendupd.php'),(20791118,799,'./apvendupd.php'),(20791117,737,'./apvendupd.php'),(20791116,6224,'./apvendupd.php'),(20791115,11843,'./apvendupd.php'),(20791114,605,'./apvendupd.php'),(20791113,491,'./apvendupd.php'),(20791112,15724,'./apvendupd.php'),(20791111,15723,'./apvendupd.php'),(20791110,8862,'./apvendupd.php'),(20791109,13994,'./apvendupd.php'),(20791108,325,'./apvendupd.php'),(20791107,315,'./apvendupd.php'),(20791106,5203,'./apvendupd.php'),(20791098,8872,'./apvendorpage_define.php'),(20791097,3202,'./apvendorpage_define.php'),(20791096,3225,'./apvendorpage_define.php'),(20791095,2710,'./apvendorpage_define.php'),(20791094,2702,'./apvendorpage_define.php'),(20791093,4265,'./apvendorpage_define.php'),(20791092,8792,'./apvendorpage_define.php'),(20791091,542,'./apvendorpage_define.php'),(20791090,8791,'./apvendorpage_define.php'),(20791089,8790,'./apvendorpage_define.php'),(20791088,3292,'./apvendoractivity.php'),(20791087,13423,'./apvendoractivity.php'),(20791086,3252,'./apvendoractivity.php'),(20791085,6318,'./apvendoractivity.php'),(20791084,2225,'./apvendoractivity.php'),(20791083,1963,'./apvendoractivity.php'),(20791082,5081,'./apvendoractivity.php'),(20791081,1668,'./apvendoractivity.php'),(20791080,8936,'./apvendoractivity.php'),(20791079,1014,'./apvendoractivity.php'),(20791078,1022,'./apvendoractivity.php'),(20791077,737,'./apvendoractivity.php'),(20791076,355,'./apvendoractivity.php'),(20791075,333,'./apvendoractivity.php'),(20791074,339,'./apvendoractivity.php'),(20791073,325,'./apvendoractivity.php'),(20791071,3355,'./apvendlistview.php'),(20791070,3287,'./apvendlistview.php'),(20791069,6141,'./apvendlistview.php'),(20791068,2249,'./apvendlistview.php'),(20791067,2248,'./apvendlistview.php'),(20791066,2246,'./apvendlistview.php'),(20791065,2177,'./apvendlistview.php'),(20791064,2176,'./apvendlistview.php'),(20791063,2174,'./apvendlistview.php'),(20791062,1935,'./apvendlistview.php'),(20791061,1578,'./apvendlistview.php'),(20791060,698,'./apvendlistview.php'),(20791059,581,'./apvendlistview.php'),(20791058,315,'./apvendlistview.php'),(20791057,3421,'./apvendlist.php'),(20791056,3292,'./apvendlist.php'),(20791055,3867,'./apvendlist.php'),(20791054,3480,'./apvendlist.php'),(20791053,3147,'./apvendlist.php'),(20791052,6527,'./apvendlist.php'),(20791051,3141,'./apvendlist.php'),(20791050,3140,'./apvendlist.php'),(20791049,3136,'./apvendlist.php'),(20791048,2849,'./apvendlist.php'),(20791047,7988,'./apvendlist.php'),(20791046,7987,'./apvendlist.php'),(20791045,2139,'./apvendlist.php'),(20791044,6526,'./apvendlist.php'),(20791043,2063,'./apvendlist.php'),(20791042,1973,'./apvendlist.php'),(20791041,1813,'./apvendlist.php'),(20791040,1812,'./apvendlist.php'),(20791039,14997,'./apvendlist.php'),(20668226,3310,'./apvendextuser.php'),(20668225,3292,'./apvendextuser.php'),(20668224,3289,'./apvendextuser.php'),(20668223,3274,'./apvendextuser.php'),(20668222,3264,'./apvendextuser.php'),(20668221,3256,'./apvendextuser.php'),(20668220,3255,'./apvendextuser.php'),(20668219,3254,'./apvendextuser.php'),(20668218,3202,'./apvendextuser.php'),(20668217,2760,'./apvendextuser.php'),(20668216,2756,'./apvendextuser.php'),(20668215,2710,'./apvendextuser.php'),(20668214,2702,'./apvendextuser.php'),(20668213,2506,'./apvendextuser.php'),(20668212,2237,'./apvendextuser.php'),(20668211,2234,'./apvendextuser.php'),(20668210,1963,'./apvendextuser.php'),(20668209,1937,'./apvendextuser.php'),(20668208,1752,'./apvendextuser.php'),(20668207,1635,'./apvendextuser.php'),(20668206,1622,'./apvendextuser.php'),(20668205,1604,'./apvendextuser.php'),(20668204,941,'./apvendextuser.php'),(20668203,807,'./apvendextuser.php'),(20668202,799,'./apvendextuser.php'),(20668201,607,'./apvendextuser.php'),(20668200,315,'./apvendextuser.php'),(20668199,4871,'./apvendextuser.php'),(20668198,59,'./apvendextuser.php'),(20791036,2063,'./apvendcsvlist.php'),(20791035,1954,'./apvendcsvlist.php'),(20791034,1238,'./apvendcsvlist.php'),(20791033,537,'./apvendcsvlist.php'),(20791032,315,'./apvendcsvlist.php'),(20791031,6694,'./apvendagentlistview.php'),(20791030,2249,'./apvendagentlistview.php'),(20791029,2248,'./apvendagentlistview.php'),(20791028,2246,'./apvendagentlistview.php'),(20791027,6525,'./apvendagentlistview.php'),(20791026,1578,'./apvendagentlistview.php'),(20791025,581,'./apvendagentlistview.php'),(20791024,315,'./apvendagentlistview.php'),(20791023,6265,'./apvendagentlistview.php'),(20791022,3293,'./apvendadd.php'),(20791021,3276,'./apvendadd.php'),(20791020,12094,'./apvendadd.php'),(20791019,2735,'./apvendadd.php'),(20791018,2734,'./apvendadd.php'),(20791017,2733,'./apvendadd.php'),(20791016,2732,'./apvendadd.php'),(20791015,2731,'./apvendadd.php'),(20791014,2702,'./apvendadd.php'),(20791013,14007,'./apvendadd.php'),(20791012,1961,'./apvendadd.php'),(20791011,12088,'./apvendadd.php'),(20791010,5072,'./apvendadd.php'),(20791009,1333,'./apvendadd.php'),(20791008,542,'./apvendadd.php'),(20791007,13994,'./apvendadd.php'),(20791006,315,'./apvendadd.php'),(20791005,59,'./apvendadd.php'),(20791004,12900,'./apvend1099print.php'),(20791003,12899,'./apvend1099print.php'),(20791002,8936,'./apvend1099print.php'),(20791001,12898,'./apvend1099print.php'),(20791000,12916,'./apvend1099file.php'),(20790999,13585,'./apvend1099file.php'),(20790998,12900,'./apvend1099file.php'),(20790997,12899,'./apvend1099file.php'),(20790996,14130,'./apvend1099file.php'),(20790995,8936,'./apvend1099file.php'),(20790994,12914,'./apvend1099file.php'),(20790993,12898,'./apvend1099file.php'),(20790992,12913,'./apvend1099file.php'),(20790991,3421,'./apvend1099edit.php'),(20790990,12897,'./apvend1099edit.php'),(20790989,3292,'./apvend1099edit.php'),(20790988,12896,'./apvend1099edit.php'),(20790987,3274,'./apvend1099edit.php'),(20790986,3090,'./apvend1099edit.php'),(20790985,8079,'./apvend1099edit.php'),(20790984,2702,'./apvend1099edit.php'),(20790983,2612,'./apvend1099edit.php'),(20790982,12895,'./apvend1099edit.php'),(20790981,2459,'./apvend1099edit.php'),(20790980,12960,'./apvend1099edit.php'),(20790979,2225,'./apvend1099edit.php'),(20790978,2044,'./apvend1099edit.php'),(20790977,12894,'./apvend1099edit.php'),(20790976,1973,'./apvend1099edit.php'),(20790975,13835,'./apvend1099edit.php'),(20790974,12893,'./apvend1099edit.php'),(20790973,12912,'./apvend1099edit.php'),(20790972,8936,'./apvend1099edit.php'),(20790971,941,'./apvend1099edit.php'),(20790970,12911,'./apvend1099edit.php'),(20790969,315,'./apvend1099edit.php'),(20790968,12910,'./apvend1099edit.php'),(20790906,13909,'./appayvoucher.php'),(20790905,13289,'./apmanualchecksp.php'),(20790904,3274,'./apmanualchecksp.php'),(20790903,13367,'./apmanualchecksp.php'),(20790902,13366,'./apmanualchecksp.php'),(20790901,13365,'./apmanualchecksp.php'),(20790900,13288,'./apmanualchecksp.php'),(20790899,13364,'./apmanualchecksp.php'),(20790898,13287,'./apmanualchecksp.php'),(20790897,11923,'./apmanualchecksp.php'),(20790896,13286,'./apmanualchecksp.php'),(20790895,11922,'./apmanualchecksp.php'),(20790894,3471,'./apmanualchecksp.php'),(20790893,6052,'./apmanualchecksp.php'),(20790892,2266,'./apmanualchecksp.php'),(20790891,2260,'./apmanualchecksp.php'),(20790890,5366,'./apmanualchecksp.php'),(20790889,2258,'./apmanualchecksp.php'),(20790888,2208,'./apmanualchecksp.php'),(20790887,2160,'./apmanualchecksp.php'),(20790886,6654,'./apmanualchecksp.php'),(20790885,1963,'./apmanualchecksp.php'),(20790884,5396,'./apmanualchecksp.php'),(20790883,1678,'./apmanualchecksp.php'),(20790882,13285,'./apmanualchecksp.php'),(20790881,1499,'./apmanualchecksp.php'),(20790880,8936,'./apmanualchecksp.php'),(20790879,890,'./apmanualchecksp.php'),(20790878,13283,'./apmanualchecksp.php'),(20790877,13282,'./apmanualchecksp.php'),(20790876,697,'./apmanualchecksp.php'),(20790875,6647,'./apmanualchecksp.php'),(20790874,673,'./apmanualchecksp.php'),(20790873,670,'./apmanualchecksp.php'),(20790872,13363,'./apmanualchecksp.php'),(20790871,504,'./apmanualchecksp.php'),(20790870,479,'./apmanualchecksp.php'),(20790869,445,'./apmanualchecksp.php'),(20790868,5391,'./apmanualchecksp.php'),(20790867,226,'./apmanualchecksp.php'),(20790866,6050,'./apmanualchecksp.php'),(20791284,15944,'./arbankdepositadd.php'),(20790865,3292,'./apmanualcheck.php'),(20790864,3090,'./apmanualcheck.php'),(20790863,3072,'./apmanualcheck.php'),(20790862,15721,'./apmanualcheck.php'),(20790861,2998,'./apmanualcheck.php'),(20790860,16113,'./apmanualcheck.php'),(20790859,6052,'./apmanualcheck.php'),(20790858,13909,'./apmanualcheck.php'),(20790857,6497,'./apmanualcheck.php'),(20790856,13908,'./apmanualcheck.php'),(20790855,2260,'./apmanualcheck.php'),(20790854,5366,'./apmanualcheck.php'),(20790853,16843,'./apmanualcheck.php'),(20790852,2258,'./apmanualcheck.php'),(20790851,2238,'./apmanualcheck.php'),(20790850,6374,'./apmanualcheck.php'),(20790849,6654,'./apmanualcheck.php'),(20790848,12783,'./apmanualcheck.php'),(20790847,1963,'./apmanualcheck.php'),(20790846,1940,'./apmanualcheck.php'),(20790845,10386,'./apmanualcheck.php'),(20790844,14040,'./apmanualcheck.php'),(20790843,14039,'./apmanualcheck.php'),(20790842,12782,'./apmanualcheck.php'),(20790841,5081,'./apmanualcheck.php'),(20790840,6660,'./apmanualcheck.php'),(20790839,1678,'./apmanualcheck.php'),(20790838,15991,'./apmanualcheck.php'),(20790837,1499,'./apmanualcheck.php'),(20790836,5393,'./apmanualcheck.php'),(20790835,1025,'./apmanualcheck.php'),(20790834,6496,'./apmanualcheck.php'),(20790833,890,'./apmanualcheck.php'),(20790832,888,'./apmanualcheck.php'),(20790831,886,'./apmanualcheck.php'),(20790830,882,'./apmanualcheck.php'),(20790829,869,'./apmanualcheck.php'),(20790828,737,'./apmanualcheck.php'),(20790827,691,'./apmanualcheck.php'),(20790826,6647,'./apmanualcheck.php'),(20790825,673,'./apmanualcheck.php'),(20790824,6053,'./apmanualcheck.php'),(20790823,9492,'./apmanualcheck.php'),(20790822,607,'./apmanualcheck.php'),(20790821,594,'./apmanualcheck.php'),(20790820,592,'./apmanualcheck.php'),(20790819,491,'./apmanualcheck.php'),(20790818,482,'./apmanualcheck.php'),(20790817,504,'./apmanualcheck.php'),(20790816,479,'./apmanualcheck.php'),(20790815,6240,'./apmanualcheck.php'),(20790814,6239,'./apmanualcheck.php'),(20790813,445,'./apmanualcheck.php'),(20790812,5391,'./apmanualcheck.php'),(20790811,315,'./apmanualcheck.php'),(20790810,12140,'./apmanualcheck.php'),(20790809,226,'./apmanualcheck.php'),(20790808,12781,'./apmanualcheck.php'),(20667966,7641,'./apchkfix_historical_jakprt.php'),(20790805,3414,'./apchecklist.php'),(20790804,3324,'./apchecklist.php'),(20790803,3292,'./apchecklist.php'),(20790802,3280,'./apchecklist.php'),(20790801,3274,'./apchecklist.php'),(20790800,3095,'./apchecklist.php'),(20790799,3094,'./apchecklist.php'),(20790798,3093,'./apchecklist.php'),(20790797,3092,'./apchecklist.php'),(20790796,3091,'./apchecklist.php'),(20790795,17605,'./apchecklist.php'),(20790794,17604,'./apchecklist.php'),(20790793,2863,'./apchecklist.php'),(20790792,12232,'./apchecklist.php'),(20790791,17105,'./apchecklist.php'),(20790790,7619,'./apchecklist.php'),(20790789,2260,'./apchecklist.php'),(20790788,2165,'./apchecklist.php'),(20790787,2016,'./apchecklist.php'),(20790786,1963,'./apchecklist.php'),(20790785,1934,'./apchecklist.php'),(20790784,1933,'./apchecklist.php'),(20790783,8008,'./apchecklist.php'),(20790782,1678,'./apchecklist.php'),(20790781,1601,'./apchecklist.php'),(20790780,1015,'./apchecklist.php'),(20790779,6053,'./apchecklist.php'),(20790778,607,'./apchecklist.php'),(20790777,491,'./apchecklist.php'),(20790776,484,'./apchecklist.php'),(20790775,6192,'./apchecklist.php'),(20790774,508,'./apchecklist.php'),(20790773,504,'./apchecklist.php'),(20790772,447,'./apchecklist.php'),(20790771,446,'./apchecklist.php'),(20790770,445,'./apchecklist.php'),(20790769,5074,'./apchecklist.php'),(20790768,334,'./apchecklist.php'),(20790767,315,'./apchecklist.php'),(20667923,3414,'./apchecking_new.php'),(20667922,3324,'./apchecking_new.php'),(20667921,3280,'./apchecking_new.php'),(20667920,3274,'./apchecking_new.php'),(20667919,3090,'./apchecking_new.php'),(20667918,2975,'./apchecking_new.php'),(20667917,2864,'./apchecking_new.php'),(20667916,2863,'./apchecking_new.php'),(20667915,2165,'./apchecking_new.php'),(20667914,2016,'./apchecking_new.php'),(20667913,1934,'./apchecking_new.php'),(20667912,1933,'./apchecking_new.php'),(20667911,1678,'./apchecking_new.php'),(20667910,1331,'./apchecking_new.php'),(20667909,607,'./apchecking_new.php'),(20667908,491,'./apchecking_new.php'),(20667907,484,'./apchecking_new.php'),(20667906,519,'./apchecking_new.php'),(20667905,515,'./apchecking_new.php'),(20667904,508,'./apchecking_new.php'),(20667903,504,'./apchecking_new.php'),(20667902,446,'./apchecking_new.php'),(20667901,5074,'./apchecking_new.php'),(20667900,315,'./apchecking_new.php'),(20667899,290,'./apchecking_new.php'),(20667898,266,'./apchecking_new.php'),(20667897,226,'./apchecking_new.php'),(20667896,197,'./apchecking_new.php'),(20790763,3414,'./apchecking.php'),(20790762,6014,'./apchecking.php'),(20790761,3330,'./apchecking.php'),(20790760,5378,'./apchecking.php'),(20790759,3324,'./apchecking.php'),(20790758,3870,'./apchecking.php'),(20790757,3292,'./apchecking.php'),(20790756,3280,'./apchecking.php'),(20790755,3274,'./apchecking.php'),(20790754,5704,'./apchecking.php'),(20790753,3090,'./apchecking.php'),(20790752,2975,'./apchecking.php'),(20790751,2702,'./apchecking.php'),(20790750,4139,'./apchecking.php'),(20790749,2165,'./apchecking.php'),(20790748,2016,'./apchecking.php'),(20790747,1963,'./apchecking.php'),(20790746,1934,'./apchecking.php'),(20790745,1933,'./apchecking.php'),(20790744,1678,'./apchecking.php'),(20790743,1331,'./apchecking.php'),(20790742,1015,'./apchecking.php'),(20790741,6054,'./apchecking.php'),(20790740,941,'./apchecking.php'),(20790739,6053,'./apchecking.php'),(20790738,607,'./apchecking.php'),(20790737,491,'./apchecking.php'),(20790736,484,'./apchecking.php'),(20790735,508,'./apchecking.php'),(20790734,504,'./apchecking.php'),(20790733,447,'./apchecking.php'),(20790732,446,'./apchecking.php'),(20790731,445,'./apchecking.php'),(20790730,5074,'./apchecking.php'),(20790729,334,'./apchecking.php'),(20790728,12140,'./apchecking.php'),(20790727,290,'./apchecking.php'),(20790726,266,'./apchecking.php'),(20790725,226,'./apchecking.php'),(20790723,8654,'./apccpurchaseupd.php'),(20790722,3274,'./apccpurchaseupd.php'),(20790721,3225,'./apccpurchaseupd.php'),(20790720,8652,'./apccpurchaseupd.php'),(20790719,7237,'./apccpurchaseupd.php'),(20790718,3090,'./apccpurchaseupd.php'),(20790717,2710,'./apccpurchaseupd.php'),(20790716,2702,'./apccpurchaseupd.php'),(20790715,2504,'./apccpurchaseupd.php'),(20790714,8651,'./apccpurchaseupd.php'),(20790713,8650,'./apccpurchaseupd.php'),(20790712,8649,'./apccpurchaseupd.php'),(20790711,8708,'./apccpurchaseupd.php'),(20790710,8641,'./apccpurchaseupd.php'),(20790709,15994,'./apccpurchaseupd.php'),(20790708,15993,'./apccpurchaseupd.php'),(20790707,15991,'./apccpurchaseupd.php'),(20790706,1499,'./apccpurchaseupd.php'),(20790705,3995,'./apccpurchaseupd.php'),(20790704,11991,'./apccpurchaseupd.php'),(20790703,15678,'./apccpurchaseupd.php'),(20790702,941,'./apccpurchaseupd.php'),(20790701,799,'./apccpurchaseupd.php'),(20790700,737,'./apccpurchaseupd.php'),(20790699,673,'./apccpurchaseupd.php'),(20790698,9492,'./apccpurchaseupd.php'),(20790697,5382,'./apccpurchaseupd.php'),(20790696,15992,'./apccpurchaseupd.php'),(20790695,8647,'./apccpurchaseupd.php'),(20790694,7209,'./apccpurchaseupd.php'),(20790693,4871,'./apccpurchaseupd.php'),(20667822,8654,'./apccpurchases.php'),(20667821,3274,'./apccpurchases.php'),(20667820,3225,'./apccpurchases.php'),(20667819,3090,'./apccpurchases.php'),(20667818,2710,'./apccpurchases.php'),(20667817,2702,'./apccpurchases.php'),(20667816,2504,'./apccpurchases.php'),(20667815,8651,'./apccpurchases.php'),(20667814,1963,'./apccpurchases.php'),(20667813,1499,'./apccpurchases.php'),(20667812,3995,'./apccpurchases.php'),(20667811,799,'./apccpurchases.php'),(20667810,737,'./apccpurchases.php'),(20667809,8653,'./apccpurchases.php'),(20667808,673,'./apccpurchases.php'),(20667807,8647,'./apccpurchases.php'),(20667806,7209,'./apccpurchases.php'),(20667805,315,'./apccpurchases.php'),(20667804,226,'./apccpurchases.php'),(20790690,8712,'./apccpurchaselist.php'),(20790689,8654,'./apccpurchaselist.php'),(20790688,5378,'./apccpurchaselist.php'),(20790687,3090,'./apccpurchaselist.php'),(20790686,2948,'./apccpurchaselist.php'),(20790685,8711,'./apccpurchaselist.php'),(20790684,8728,'./apccpurchaselist.php'),(20790683,8651,'./apccpurchaselist.php'),(20790682,8710,'./apccpurchaselist.php'),(20790681,8709,'./apccpurchaselist.php'),(20790680,8708,'./apccpurchaselist.php'),(20790679,8707,'./apccpurchaselist.php'),(20790678,1963,'./apccpurchaselist.php'),(20790677,1014,'./apccpurchaselist.php'),(20790676,737,'./apccpurchaselist.php'),(20790675,8653,'./apccpurchaselist.php'),(20790674,673,'./apccpurchaselist.php'),(20790673,7209,'./apccpurchaselist.php'),(20790672,333,'./apccpurchaselist.php'),(20790671,315,'./apccpurchaselist.php'),(20790670,226,'./apccpurchaselist.php'),(20790669,197,'./apccpurchaselist.php'),(20790668,3274,'./apccpurchaseadd.php'),(20790667,3225,'./apccpurchaseadd.php'),(20790666,8652,'./apccpurchaseadd.php'),(20790665,7237,'./apccpurchaseadd.php'),(20790664,2710,'./apccpurchaseadd.php'),(20790663,2702,'./apccpurchaseadd.php'),(20790662,2504,'./apccpurchaseadd.php'),(20790661,8651,'./apccpurchaseadd.php'),(20790660,8650,'./apccpurchaseadd.php'),(20790659,8649,'./apccpurchaseadd.php'),(20790658,15995,'./apccpurchaseadd.php'),(20790657,1963,'./apccpurchaseadd.php'),(20790656,12002,'./apccpurchaseadd.php'),(20790655,15994,'./apccpurchaseadd.php'),(20790654,15993,'./apccpurchaseadd.php'),(20790653,15991,'./apccpurchaseadd.php'),(20790652,3995,'./apccpurchaseadd.php'),(20790651,673,'./apccpurchaseadd.php'),(20790650,9492,'./apccpurchaseadd.php'),(20790649,15992,'./apccpurchaseadd.php'),(20790648,8647,'./apccpurchaseadd.php'),(20790647,7209,'./apccpurchaseadd.php'),(20790646,315,'./apccpurchaseadd.php'),(20790645,226,'./apccpurchaseadd.php'),(20790644,8654,'./apccpurchase2billupd.php'),(20790643,3274,'./apccpurchase2billupd.php'),(20790642,8701,'./apccpurchase2billupd.php'),(20790641,8700,'./apccpurchase2billupd.php'),(20790640,7823,'./apccpurchase2billupd.php'),(20790639,3090,'./apccpurchase2billupd.php'),(20790638,2710,'./apccpurchase2billupd.php'),(20790637,2702,'./apccpurchase2billupd.php'),(20790636,8705,'./apccpurchase2billupd.php'),(20790635,2504,'./apccpurchase2billupd.php'),(20790634,8651,'./apccpurchase2billupd.php'),(20790633,8699,'./apccpurchase2billupd.php'),(20790632,1678,'./apccpurchase2billupd.php'),(20790631,4940,'./apccpurchase2billupd.php'),(20790630,15991,'./apccpurchase2billupd.php'),(20790629,1499,'./apccpurchase2billupd.php'),(20790628,8936,'./apccpurchase2billupd.php'),(20790627,8717,'./apccpurchase2billupd.php'),(20790626,941,'./apccpurchase2billupd.php'),(20790625,932,'./apccpurchase2billupd.php'),(20790624,892,'./apccpurchase2billupd.php'),(20790623,890,'./apccpurchase2billupd.php'),(20790622,888,'./apccpurchase2billupd.php'),(20790621,869,'./apccpurchase2billupd.php'),(20790620,799,'./apccpurchase2billupd.php'),(20790619,742,'./apccpurchase2billupd.php'),(20790618,737,'./apccpurchase2billupd.php'),(20790617,645,'./apccpurchase2billupd.php'),(20790616,9492,'./apccpurchase2billupd.php'),(20790615,8694,'./apccpurchase2billupd.php'),(20790614,7209,'./apccpurchase2billupd.php'),(20790613,4000,'./apccpurchase2billupd.php'),(20790612,353,'./apccpurchase2billupd.php'),(20790611,8703,'./apccpurchase2billupd.php'),(20790610,8702,'./apccpurchase2billupd.php'),(20790609,315,'./apccpurchase2billupd.php'),(20790608,8125,'./apccpurchase2billupd.php'),(20790607,15895,'./apccpurchase2billupd.php'),(20790606,226,'./apccpurchase2billupd.php'),(20790605,59,'./apccpurchase2billupd.php'),(20790604,8654,'./apccpurchase2bill.php'),(20790603,15896,'./apccpurchase2bill.php'),(20790602,3274,'./apccpurchase2bill.php'),(20790601,8701,'./apccpurchase2bill.php'),(20790600,8700,'./apccpurchase2bill.php'),(20790599,7823,'./apccpurchase2bill.php'),(20790598,3090,'./apccpurchase2bill.php'),(20790597,2710,'./apccpurchase2bill.php'),(20790596,2702,'./apccpurchase2bill.php'),(20790595,2504,'./apccpurchase2bill.php'),(20790594,8651,'./apccpurchase2bill.php'),(20790593,8699,'./apccpurchase2bill.php'),(20790592,1963,'./apccpurchase2bill.php'),(20790591,8727,'./apccpurchase2bill.php'),(20790590,6660,'./apccpurchase2bill.php'),(20790589,1678,'./apccpurchase2bill.php'),(20790588,1672,'./apccpurchase2bill.php'),(20790587,4940,'./apccpurchase2bill.php'),(20790586,15991,'./apccpurchase2bill.php'),(20790585,1499,'./apccpurchase2bill.php'),(20790584,1329,'./apccpurchase2bill.php'),(20790583,8936,'./apccpurchase2bill.php'),(20790582,1052,'./apccpurchase2bill.php'),(20790581,932,'./apccpurchase2bill.php'),(20790580,892,'./apccpurchase2bill.php'),(20790579,890,'./apccpurchase2bill.php'),(20790578,888,'./apccpurchase2bill.php'),(20790577,869,'./apccpurchase2bill.php'),(20790576,737,'./apccpurchase2bill.php'),(20790575,673,'./apccpurchase2bill.php'),(20790574,9492,'./apccpurchase2bill.php'),(20790573,607,'./apccpurchase2bill.php'),(20790572,8694,'./apccpurchase2bill.php'),(20790571,7209,'./apccpurchase2bill.php'),(20790570,346,'./apccpurchase2bill.php'),(20790569,315,'./apccpurchase2bill.php'),(20790568,15895,'./apccpurchase2bill.php'),(20790567,226,'./apccpurchase2bill.php'),(20790566,6693,'./apcashrequirements.php'),(20790565,6692,'./apcashrequirements.php'),(20790564,3274,'./apcashrequirements.php'),(20790563,6691,'./apcashrequirements.php'),(20790562,6690,'./apcashrequirements.php'),(20790561,6689,'./apcashrequirements.php'),(20790560,3118,'./apcashrequirements.php'),(20790559,3090,'./apcashrequirements.php'),(20790558,2901,'./apcashrequirements.php'),(20790557,2656,'./apcashrequirements.php'),(20790556,6688,'./apcashrequirements.php'),(20790555,5366,'./apcashrequirements.php'),(20790554,6677,'./apcashrequirements.php'),(20790553,1963,'./apcashrequirements.php'),(20790552,1672,'./apcashrequirements.php'),(20790551,1668,'./apcashrequirements.php'),(20790550,6687,'./apcashrequirements.php'),(20790549,932,'./apcashrequirements.php'),(20790548,737,'./apcashrequirements.php'),(20790547,607,'./apcashrequirements.php'),(20790546,542,'./apcashrequirements.php'),(20790545,6686,'./apcashrequirements.php'),(20790544,12225,'./apcashrequirements.php'),(20790543,7135,'./apcashrequirements.php'),(20790542,6683,'./apcashrequirements.php'),(20790541,315,'./apcashrequirements.php'),(20790540,6682,'./apcashrequirements.php'),(20790539,197,'./apcashrequirements.php'),(20790538,13422,'./apbillviewfpdf.php'),(20790537,18850,'./apbillupd.php'),(20790536,18849,'./apbillupd.php'),(20790535,12831,'./apbillupd.php'),(20790534,8654,'./apbillupd.php'),(20790533,3333,'./apbillupd.php'),(20790532,3292,'./apbillupd.php'),(20790531,9491,'./apbillupd.php'),(20790530,3274,'./apbillupd.php'),(20790529,3252,'./apbillupd.php'),(20790528,3090,'./apbillupd.php'),(20790527,9904,'./apbillupd.php'),(20790526,3035,'./apbillupd.php'),(20790525,20077,'./apbillupd.php'),(20790524,20076,'./apbillupd.php'),(20790523,16134,'./apbillupd.php'),(20790522,2707,'./apbillupd.php'),(20790521,2702,'./apbillupd.php'),(20790520,2686,'./apbillupd.php'),(20790519,18622,'./apbillupd.php'),(20790518,2508,'./apbillupd.php'),(20790517,2504,'./apbillupd.php'),(20790516,8651,'./apbillupd.php'),(20790515,2459,'./apbillupd.php'),(20790514,2404,'./apbillupd.php'),(20790513,16325,'./apbillupd.php'),(20790512,2363,'./apbillupd.php'),(20790511,8861,'./apbillupd.php'),(20790510,5366,'./apbillupd.php'),(20790509,2258,'./apbillupd.php'),(20790508,2225,'./apbillupd.php'),(20790507,2044,'./apbillupd.php'),(20790506,6681,'./apbillupd.php'),(20790505,17603,'./apbillupd.php'),(20790504,2094,'./apbillupd.php'),(20790503,12783,'./apbillupd.php'),(20790502,1963,'./apbillupd.php'),(20790501,1940,'./apbillupd.php'),(20790500,12782,'./apbillupd.php'),(20790499,5081,'./apbillupd.php'),(20790498,1678,'./apbillupd.php'),(20790497,1672,'./apbillupd.php'),(20790496,4940,'./apbillupd.php'),(20790495,4106,'./apbillupd.php'),(20790494,1529,'./apbillupd.php'),(20790493,17593,'./apbillupd.php'),(20790492,15991,'./apbillupd.php'),(20790491,1499,'./apbillupd.php'),(20790490,8936,'./apbillupd.php'),(20790489,1017,'./apbillupd.php'),(20790488,1016,'./apbillupd.php'),(20790487,11849,'./apbillupd.php'),(20790486,932,'./apbillupd.php'),(20790485,892,'./apbillupd.php'),(20790484,890,'./apbillupd.php'),(20790483,882,'./apbillupd.php'),(20790482,869,'./apbillupd.php'),(20790481,818,'./apbillupd.php'),(20790480,5205,'./apbillupd.php'),(20790479,799,'./apbillupd.php'),(20790478,776,'./apbillupd.php'),(20790477,744,'./apbillupd.php'),(20790476,742,'./apbillupd.php'),(20790475,737,'./apbillupd.php'),(20790474,691,'./apbillupd.php'),(20790473,8698,'./apbillupd.php'),(20790472,670,'./apbillupd.php'),(20790471,645,'./apbillupd.php'),(20790470,9492,'./apbillupd.php'),(20790446,3274,'./apbillpayrpr.php'),(20790445,3101,'./apbillpayrpr.php'),(20790444,14995,'./apbillpayrpr.php'),(20790443,2702,'./apbillpayrpr.php'),(20790442,14994,'./apbillpayrpr.php'),(20790441,14993,'./apbillpayrpr.php'),(20790440,5366,'./apbillpayrpr.php'),(20790439,14992,'./apbillpayrpr.php'),(20790438,2238,'./apbillpayrpr.php'),(20790437,8936,'./apbillpayrpr.php'),(20790436,932,'./apbillpayrpr.php'),(20790435,869,'./apbillpayrpr.php'),(20790434,5583,'./apbillpayrpr.php'),(20790433,14991,'./apbillpayrpr.php'),(20790432,14990,'./apbillpayrpr.php'),(20790431,325,'./apbillpayrpr.php'),(20790430,5144,'./apbillpayrpr.php'),(20790429,226,'./apbillpayrpr.php'),(20790428,14989,'./apbillpayrpr.php'),(20790427,7721,'./apbillpayrpr.php'),(20790426,6680,'./apbillpay_preapproved.php'),(20790425,6679,'./apbillpay_preapproved.php'),(20790424,3292,'./apbillpay_preapproved.php'),(20790423,3274,'./apbillpay_preapproved.php'),(20790422,6678,'./apbillpay_preapproved.php'),(20790421,3090,'./apbillpay_preapproved.php'),(20790420,17602,'./apbillpay_preapproved.php'),(20790419,6135,'./apbillpay_preapproved.php'),(20790418,17601,'./apbillpay_preapproved.php'),(20790417,17007,'./apbillpay_preapproved.php'),(20790416,17006,'./apbillpay_preapproved.php'),(20790415,17005,'./apbillpay_preapproved.php'),(20790414,17600,'./apbillpay_preapproved.php'),(20790413,17104,'./apbillpay_preapproved.php'),(20790412,6498,'./apbillpay_preapproved.php'),(20790411,2240,'./apbillpay_preapproved.php'),(20790410,7773,'./apbillpay_preapproved.php'),(20790409,6497,'./apbillpay_preapproved.php'),(20790408,5366,'./apbillpay_preapproved.php'),(20790407,6677,'./apbillpay_preapproved.php'),(20790406,2238,'./apbillpay_preapproved.php'),(20790405,2021,'./apbillpay_preapproved.php'),(20790404,17004,'./apbillpay_preapproved.php'),(20790403,11881,'./apbillpay_preapproved.php'),(20790402,7018,'./apbillpay_preapproved.php'),(20790401,2099,'./apbillpay_preapproved.php'),(20790400,1963,'./apbillpay_preapproved.php'),(20790399,1884,'./apbillpay_preapproved.php'),(20790398,17599,'./apbillpay_preapproved.php'),(20790397,1678,'./apbillpay_preapproved.php'),(20790396,1668,'./apbillpay_preapproved.php'),(20790395,6676,'./apbillpay_preapproved.php'),(20790394,4106,'./apbillpay_preapproved.php'),(20790393,8936,'./apbillpay_preapproved.php'),(20790392,1025,'./apbillpay_preapproved.php'),(20790391,14092,'./apbillpay_preapproved.php'),(20790390,17598,'./apbillpay_preapproved.php'),(20790389,17491,'./apbillpay_preapproved.php'),(20790388,6496,'./apbillpay_preapproved.php'),(20790387,932,'./apbillpay_preapproved.php'),(20790386,17002,'./apbillpay_preapproved.php'),(20790364,6671,'./apbillpay.php'),(20790363,3886,'./apbillpay.php'),(20790362,3292,'./apbillpay.php'),(20790361,12210,'./apbillpay.php'),(20790360,3274,'./apbillpay.php'),(20790359,17490,'./apbillpay.php'),(20790358,17597,'./apbillpay.php'),(20790357,3090,'./apbillpay.php'),(20790356,3072,'./apbillpay.php'),(20790355,6135,'./apbillpay.php'),(20790354,17596,'./apbillpay.php'),(20790353,17595,'./apbillpay.php'),(20790352,2462,'./apbillpay.php'),(20790351,17104,'./apbillpay.php'),(20790350,6498,'./apbillpay.php'),(20790349,2459,'./apbillpay.php'),(20790348,6670,'./apbillpay.php'),(20790347,2240,'./apbillpay.php'),(20790346,6052,'./apbillpay.php'),(20790345,13909,'./apbillpay.php'),(20790344,6497,'./apbillpay.php'),(20790343,13908,'./apbillpay.php'),(20790342,5366,'./apbillpay.php'),(20790341,2238,'./apbillpay.php'),(20790340,2225,'./apbillpay.php'),(20790339,2060,'./apbillpay.php'),(20790338,2021,'./apbillpay.php'),(20790337,14193,'./apbillpay.php'),(20790336,6654,'./apbillpay.php'),(20790335,2099,'./apbillpay.php'),(20790334,1963,'./apbillpay.php'),(20790333,1846,'./apbillpay.php'),(20790332,1678,'./apbillpay.php'),(20790331,1668,'./apbillpay.php'),(20790330,1625,'./apbillpay.php'),(20790329,4106,'./apbillpay.php'),(20790328,8811,'./apbillpay.php'),(20790327,1246,'./apbillpay.php'),(20790326,1242,'./apbillpay.php'),(20790325,10106,'./apbillpay.php'),(20790324,8936,'./apbillpay.php'),(20790323,1025,'./apbillpay.php'),(20790322,14092,'./apbillpay.php'),(20790321,6496,'./apbillpay.php'),(20790320,932,'./apbillpay.php'),(20790319,14192,'./apbillpay.php'),(20790318,892,'./apbillpay.php'),(20790317,886,'./apbillpay.php'),(20790316,6647,'./apbillpay.php'),(20790315,673,'./apbillpay.php'),(20790314,6051,'./apbillpay.php'),(20790313,6053,'./apbillpay.php'),(20790312,607,'./apbillpay.php'),(20790311,14268,'./apbillpay.php'),(20790310,18848,'./apbillpay.php'),(20790309,6134,'./apbillpay.php'),(20790308,491,'./apbillpay.php'),(20790307,484,'./apbillpay.php'),(20790306,5390,'./apbillpay.php'),(20790305,7622,'./apbillpay.php'),(20790304,6165,'./apbillpay.php'),(20790303,482,'./apbillpay.php'),(20790302,12191,'./apbillpay.php'),(20790301,504,'./apbillpay.php'),(20790300,501,'./apbillpay.php'),(20790299,479,'./apbillpay.php'),(20790298,6239,'./apbillpay.php'),(20790297,6048,'./apbillpay.php'),(20790288,3379,'./apbilllistdiscaging.php'),(20790287,3274,'./apbilllistdiscaging.php'),(20790286,3101,'./apbilllistdiscaging.php'),(20790285,3090,'./apbilllistdiscaging.php'),(20790284,2858,'./apbilllistdiscaging.php'),(20790283,12230,'./apbilllistdiscaging.php'),(20790282,1977,'./apbilllistdiscaging.php'),(20790281,1963,'./apbilllistdiscaging.php'),(20790280,1678,'./apbilllistdiscaging.php'),(20790279,892,'./apbilllistdiscaging.php'),(20790278,891,'./apbilllistdiscaging.php'),(20790277,886,'./apbilllistdiscaging.php'),(20790276,874,'./apbilllistdiscaging.php'),(20790275,869,'./apbilllistdiscaging.php'),(20790274,737,'./apbilllistdiscaging.php'),(20790273,607,'./apbilllistdiscaging.php'),(20790272,344,'./apbilllistdiscaging.php'),(20790271,315,'./apbilllistdiscaging.php'),(20790270,193,'./apbilllistdiscaging.php'),(20790269,3421,'./apbilllistaging.php'),(20790268,3274,'./apbilllistaging.php'),(20790267,17594,'./apbilllistaging.php'),(20790266,3090,'./apbilllistaging.php'),(20790265,2656,'./apbilllistaging.php'),(20790264,12229,'./apbilllistaging.php'),(20790263,12228,'./apbilllistaging.php'),(20790262,1977,'./apbilllistaging.php'),(20790261,1973,'./apbilllistaging.php'),(20790260,1963,'./apbilllistaging.php'),(20790259,1678,'./apbilllistaging.php'),(20790258,1672,'./apbilllistaging.php'),(20790257,17593,'./apbilllistaging.php'),(20790256,15991,'./apbilllistaging.php'),(20790255,1499,'./apbilllistaging.php'),(20790254,932,'./apbilllistaging.php'),(20790253,886,'./apbilllistaging.php'),(20790252,869,'./apbilllistaging.php'),(20790244,3292,'./apbilllist.php'),(20790243,3274,'./apbilllist.php'),(20790242,6668,'./apbilllist.php'),(20790241,3118,'./apbilllist.php'),(20790240,2985,'./apbilllist.php'),(20790239,6667,'./apbilllist.php'),(20790238,6666,'./apbilllist.php'),(20790237,2849,'./apbilllist.php'),(20790236,8018,'./apbilllist.php'),(20790235,2656,'./apbilllist.php'),(20790234,4157,'./apbilllist.php'),(20790233,6665,'./apbilllist.php'),(20790232,2589,'./apbilllist.php'),(20790231,2363,'./apbilllist.php'),(20790230,4979,'./apbilllist.php'),(20790229,6664,'./apbilllist.php'),(20790228,6663,'./apbilllist.php'),(20790227,6662,'./apbilllist.php'),(20790226,2292,'./apbilllist.php'),(20790225,5366,'./apbilllist.php'),(20790224,6661,'./apbilllist.php'),(20790223,2225,'./apbilllist.php'),(20790222,2170,'./apbilllist.php'),(20790221,2151,'./apbilllist.php'),(20790220,2109,'./apbilllist.php'),(20790219,2014,'./apbilllist.php'),(20790218,2099,'./apbilllist.php'),(20790217,1963,'./apbilllist.php'),(20790216,1941,'./apbilllist.php'),(20790215,5081,'./apbilllist.php'),(20790214,1678,'./apbilllist.php'),(20790213,1674,'./apbilllist.php'),(20790212,4138,'./apbilllist.php'),(20790211,1672,'./apbilllist.php'),(20790210,1671,'./apbilllist.php'),(20790209,1668,'./apbilllist.php'),(20790208,1625,'./apbilllist.php'),(20790207,1449,'./apbilllist.php'),(20790206,9658,'./apbilllist.php'),(20790205,1235,'./apbilllist.php'),(20790204,1017,'./apbilllist.php'),(20790203,15130,'./apbilllist.php'),(20790202,1013,'./apbilllist.php'),(20790201,932,'./apbilllist.php'),(20790200,15129,'./apbilllist.php'),(20790199,892,'./apbilllist.php'),(20790198,886,'./apbilllist.php'),(20790197,874,'./apbilllist.php'),(20790196,737,'./apbilllist.php'),(20790195,4632,'./apbilllist.php'),(20790194,607,'./apbilllist.php'),(20790193,543,'./apbilllist.php'),(20790192,336,'./apbilllist.php'),(20790191,15128,'./apbilllist.php'),(20790190,332,'./apbilllist.php'),(20790189,315,'./apbilllist.php'),(20790188,262,'./apbilllist.php'),(20790187,226,'./apbilllist.php'),(20790186,197,'./apbilllist.php'),(20790185,20,'./apbilllist.php'),(20667297,7483,'./apbillfix_posting.php'),(20667296,7633,'./apbillfix_historical_jakprt.php'),(20790184,5802,'./apbilladd_beginbal.php'),(20790183,3292,'./apbilladd_beginbal.php'),(20790182,3274,'./apbilladd_beginbal.php'),(20790181,3090,'./apbilladd_beginbal.php'),(20790180,1963,'./apbilladd_beginbal.php'),(20790179,1940,'./apbilladd_beginbal.php'),(20790178,6660,'./apbilladd_beginbal.php'),(20790177,1678,'./apbilladd_beginbal.php'),(20790176,1672,'./apbilladd_beginbal.php'),(20790175,1499,'./apbilladd_beginbal.php'),(20790174,1330,'./apbilladd_beginbal.php'),(20790173,1052,'./apbilladd_beginbal.php'),(20790172,932,'./apbilladd_beginbal.php'),(20790171,892,'./apbilladd_beginbal.php'),(20790170,890,'./apbilladd_beginbal.php'),(20790169,888,'./apbilladd_beginbal.php'),(20790168,882,'./apbilladd_beginbal.php'),(20790167,869,'./apbilladd_beginbal.php'),(20790166,737,'./apbilladd_beginbal.php'),(20790165,691,'./apbilladd_beginbal.php'),(20790164,607,'./apbilladd_beginbal.php'),(20790163,592,'./apbilladd_beginbal.php'),(20790162,6528,'./apbilladd_beginbal.php'),(20790161,346,'./apbilladd_beginbal.php'),(20790160,315,'./apbilladd_beginbal.php'),(20790159,226,'./apbilladd_beginbal.php'),(20790158,85,'./apbilladd_beginbal.php'),(20790157,59,'./apbilladd_beginbal.php'),(20791283,15970,'./arbankdepositadd.php'),(20790156,3292,'./apbilladd.php'),(20790155,16902,'./apbilladd.php'),(20790154,3274,'./apbilladd.php'),(20790153,3090,'./apbilladd.php'),(20790152,15721,'./apbilladd.php'),(20790151,3035,'./apbilladd.php'),(20790150,20078,'./apbilladd.php'),(20790149,20077,'./apbilladd.php'),(20790148,20076,'./apbilladd.php'),(20790147,2686,'./apbilladd.php'),(20790146,2459,'./apbilladd.php'),(20790145,5366,'./apbilladd.php'),(20790144,2258,'./apbilladd.php'),(20790143,12783,'./apbilladd.php'),(20790142,1963,'./apbilladd.php'),(20790141,3709,'./apbilladd.php'),(20790140,1940,'./apbilladd.php'),(20790139,10386,'./apbilladd.php'),(20790138,12782,'./apbilladd.php'),(20790137,5081,'./apbilladd.php'),(20790136,6660,'./apbilladd.php'),(20790135,1678,'./apbilladd.php'),(20790134,1672,'./apbilladd.php'),(20790133,1668,'./apbilladd.php'),(20790132,15991,'./apbilladd.php'),(20790131,1499,'./apbilladd.php'),(20790130,1329,'./apbilladd.php'),(20790129,8936,'./apbilladd.php'),(20790128,1052,'./apbilladd.php'),(20790127,932,'./apbilladd.php'),(20790126,892,'./apbilladd.php'),(20790125,890,'./apbilladd.php'),(20790124,888,'./apbilladd.php'),(20790123,882,'./apbilladd.php'),(20790122,869,'./apbilladd.php'),(20790121,737,'./apbilladd.php'),(20790120,691,'./apbilladd.php'),(20790119,9492,'./apbilladd.php'),(20790118,607,'./apbilladd.php'),(20790117,592,'./apbilladd.php'),(20790116,566,'./apbilladd.php'),(20790115,9599,'./apbilladd.php'),(20790083,3274,'./apbill_preapprove_edit.php'),(20790082,3090,'./apbill_preapprove_edit.php'),(20790081,2702,'./apbill_preapprove_edit.php'),(20790080,2240,'./apbill_preapprove_edit.php'),(20790079,6657,'./apbill_preapprove_edit.php'),(20790078,6656,'./apbill_preapprove_edit.php'),(20790077,2225,'./apbill_preapprove_edit.php'),(20790076,1668,'./apbill_preapprove_edit.php'),(20790075,6652,'./apbill_preapprove_edit.php'),(20790074,1558,'./apbill_preapprove_edit.php'),(20790073,6651,'./apbill_preapprove_edit.php'),(20790072,932,'./apbill_preapprove_edit.php'),(20790071,931,'./apbill_preapprove_edit.php'),(20790070,6648,'./apbill_preapprove_edit.php'),(20790069,6134,'./apbill_preapprove_edit.php'),(20790068,6165,'./apbill_preapprove_edit.php'),(20790067,501,'./apbill_preapprove_edit.php'),(20790066,315,'./apbill_preapprove_edit.php'),(20790065,3455,'./apbill_preapprove_edit.php'),(20790064,15698,'./apbill_preapprove_edit.php'),(20790061,6671,'./apbill_preapprove.php'),(20790060,3292,'./apbill_preapprove.php'),(20790059,16324,'./apbill_preapprove.php'),(20790058,3274,'./apbill_preapprove.php'),(20790057,3252,'./apbill_preapprove.php'),(20790056,3221,'./apbill_preapprove.php'),(20790055,3202,'./apbill_preapprove.php'),(20790054,3090,'./apbill_preapprove.php'),(20790053,16148,'./apbill_preapprove.php'),(20790052,3948,'./apbill_preapprove.php'),(20790051,2948,'./apbill_preapprove.php'),(20790050,20076,'./apbill_preapprove.php'),(20790049,6658,'./apbill_preapprove.php'),(20790048,17018,'./apbill_preapprove.php'),(20790047,17017,'./apbill_preapprove.php'),(20790046,17005,'./apbill_preapprove.php'),(20790045,2702,'./apbill_preapprove.php'),(20790044,2292,'./apbill_preapprove.php'),(20790043,2240,'./apbill_preapprove.php'),(20790042,6657,'./apbill_preapprove.php'),(20790041,6656,'./apbill_preapprove.php'),(20790040,5366,'./apbill_preapprove.php'),(20790039,16323,'./apbill_preapprove.php'),(20790038,2225,'./apbill_preapprove.php'),(20790037,2021,'./apbill_preapprove.php'),(20790036,1963,'./apbill_preapprove.php'),(20790035,15711,'./apbill_preapprove.php'),(20790034,10386,'./apbill_preapprove.php'),(20790033,6653,'./apbill_preapprove.php'),(20790032,1692,'./apbill_preapprove.php'),(20790031,1678,'./apbill_preapprove.php'),(20790030,1668,'./apbill_preapprove.php'),(20790029,17064,'./apbill_preapprove.php'),(20790028,6652,'./apbill_preapprove.php'),(20790027,1558,'./apbill_preapprove.php'),(20790026,6651,'./apbill_preapprove.php'),(20790025,8936,'./apbill_preapprove.php'),(20790024,6650,'./apbill_preapprove.php'),(20790023,932,'./apbill_preapprove.php'),(20790022,931,'./apbill_preapprove.php'),(20790003,14790,'./adminzencompanyupd.php'),(20790002,8354,'./adminzencompanyupd.php'),(20790001,2710,'./adminzencompanyupd.php'),(20790000,2702,'./adminzencompanyupd.php'),(20789999,2664,'./adminzencompanyupd.php'),(20789998,7708,'./adminzencompanyupd.php'),(20789997,2070,'./adminzencompanyupd.php'),(20789996,1935,'./adminzencompanyupd.php'),(20789995,7973,'./adminzencompanyupd.php'),(20789994,6599,'./adminzencompanyupd.php'),(20789993,9432,'./adminzencompanyupd.php'),(20789992,8936,'./adminzencompanyupd.php'),(20789991,941,'./adminzencompanyupd.php'),(20789990,9431,'./adminzencompanyupd.php'),(20789989,9439,'./adminzencompanyupd.php'),(20789988,9438,'./adminzencompanyupd.php'),(20789987,9437,'./adminzencompanyupd.php'),(20789986,797,'./adminzencompanyupd.php'),(20789985,796,'./adminzencompanyupd.php'),(20789984,7479,'./adminzencompanyupd.php'),(20789983,5661,'./adminzencompanyupd.php'),(20789982,637,'./adminzencompanyupd.php'),(20789981,8353,'./adminzencompanyupd.php'),(20789980,503,'./adminzencompanyupd.php'),(20789979,9443,'./adminzencompanyupd.php'),(20789978,9442,'./adminzencompanyupd.php'),(20789977,8629,'./adminzencompanyupd.php'),(20789976,3421,'./adminsystemsettings.php'),(20789975,20075,'./adminsystemsettings.php'),(20789974,7459,'./adminsystemsettings.php'),(20789973,7965,'./adminsystemsettings.php'),(20789972,9306,'./adminsystemsettings.php'),(20789971,14006,'./adminsystemsettings.php'),(20789970,18268,'./adminsystemsettings.php'),(20789969,6039,'./adminsystemsettings.php'),(20789968,14786,'./adminsystemsettings.php'),(20789967,14787,'./adminsystemsettings.php'),(20789966,14785,'./adminsystemsettings.php'),(20789965,18956,'./adminsystemsettings.php'),(20789964,7964,'./adminsystemsettings.php'),(20789963,8989,'./adminsystemsettings.php'),(20789962,9426,'./adminsystemsettings.php'),(20789961,8988,'./adminsystemsettings.php'),(20789960,8987,'./adminsystemsettings.php'),(20789959,8986,'./adminsystemsettings.php'),(20789958,18816,'./adminsystemsettings.php'),(20789957,6540,'./adminsystemsettings.php'),(20789956,2702,'./adminsystemsettings.php'),(20789955,16194,'./adminsystemsettings.php'),(20789954,9962,'./adminsystemsettings.php'),(20789953,14823,'./adminsystemsettings.php'),(20789952,18955,'./adminsystemsettings.php'),(20789951,13155,'./adminsystemsettings.php'),(20789950,15199,'./adminsystemsettings.php'),(20789949,16211,'./adminsystemsettings.php'),(20789948,17346,'./adminsystemsettings.php'),(20789947,13281,'./adminsystemsettings.php'),(20789946,8985,'./adminsystemsettings.php'),(20789945,18954,'./adminsystemsettings.php'),(20789944,1973,'./adminsystemsettings.php'),(20789943,8984,'./adminsystemsettings.php'),(20789942,8983,'./adminsystemsettings.php'),(20789941,18847,'./adminsystemsettings.php'),(20789940,8982,'./adminsystemsettings.php'),(20789939,15362,'./adminsystemsettings.php'),(20789938,12684,'./adminsystemsettings.php'),(20789937,8981,'./adminsystemsettings.php'),(20789936,13857,'./adminsystemsettings.php'),(20789935,14005,'./adminsystemsettings.php'),(20789934,8980,'./adminsystemsettings.php'),(20789933,18953,'./adminsystemsettings.php'),(20789932,7954,'./adminsystemsettings.php'),(20789931,8511,'./adminsystemsettings.php'),(20789930,8936,'./adminsystemsettings.php'),(20789929,14113,'./adminsystemsettings.php'),(20789928,8979,'./adminsystemsettings.php'),(20789927,15397,'./adminsystemsettings.php'),(20789926,8978,'./adminsystemsettings.php'),(20789925,8010,'./adminsystemsettings.php'),(20789924,754,'./adminsystemsettings.php'),(20789923,753,'./adminsystemsettings.php'),(20789922,18952,'./adminsystemsettings.php'),(20789921,18951,'./adminsystemsettings.php'),(20789920,18941,'./adminsystemsettings.php'),(20789919,9305,'./adminsystemsettings.php'),(20789918,542,'./adminsystemsettings.php'),(20791282,19250,'./arbankdepositadd.php'),(20789897,3421,'./adminsurveyurl.php'),(20789896,3292,'./adminsurveyurl.php'),(20789895,3274,'./adminsurveyurl.php'),(20789894,9214,'./adminsurveyurl.php'),(20789893,9213,'./adminsurveyurl.php'),(20789892,9212,'./adminsurveyurl.php'),(20789891,9211,'./adminsurveyurl.php'),(20789890,9210,'./adminsurveyurl.php'),(20789889,2182,'./adminsurveyurl.php'),(20789888,4842,'./adminsurveyurl.php'),(20789887,2165,'./adminsurveyurl.php'),(20789886,9209,'./adminsurveyurl.php'),(20789885,1973,'./adminsurveyurl.php'),(20789884,1963,'./adminsurveyurl.php'),(20789883,9208,'./adminsurveyurl.php'),(20789882,1724,'./adminsurveyurl.php'),(20789881,9207,'./adminsurveyurl.php'),(20789880,9206,'./adminsurveyurl.php'),(20789879,1668,'./adminsurveyurl.php'),(20789878,9205,'./adminsurveyurl.php'),(20789877,8936,'./adminsurveyurl.php'),(20789876,9204,'./adminsurveyurl.php'),(20789875,4481,'./adminsurveyurl.php'),(20789874,697,'./adminsurveyurl.php'),(20789873,9203,'./adminsurveyurl.php'),(20789872,315,'./adminsurveyurl.php'),(20789871,3414,'./adminsurveyreport.php'),(20789870,9239,'./adminsurveyreport.php'),(20789869,3274,'./adminsurveyreport.php'),(20789868,9238,'./adminsurveyreport.php'),(20789867,3156,'./adminsurveyreport.php'),(20789866,9237,'./adminsurveyreport.php'),(20789865,9236,'./adminsurveyreport.php'),(20789864,9235,'./adminsurveyreport.php'),(20789863,9225,'./adminsurveyreport.php'),(20789862,2858,'./adminsurveyreport.php'),(20789861,2165,'./adminsurveyreport.php'),(20789860,1963,'./adminsurveyreport.php'),(20789859,1935,'./adminsurveyreport.php'),(20789858,1933,'./adminsurveyreport.php'),(20789857,8273,'./adminsurveyreport.php'),(20789856,1668,'./adminsurveyreport.php'),(20789855,1598,'./adminsurveyreport.php'),(20789854,8936,'./adminsurveyreport.php'),(20789853,1014,'./adminsurveyreport.php'),(20789852,9234,'./adminsurveyreport.php'),(20789851,697,'./adminsurveyreport.php'),(20789850,9233,'./adminsurveyreport.php'),(20789849,542,'./adminsurveyreport.php'),(20789848,333,'./adminsurveyreport.php'),(20789847,3432,'./adminsurvey.php'),(20789846,9202,'./adminsurvey.php'),(20789845,3421,'./adminsurvey.php'),(20789844,9634,'./adminsurvey.php'),(20789843,9232,'./adminsurvey.php'),(20789842,3274,'./adminsurvey.php'),(20789841,3269,'./adminsurvey.php'),(20789840,3156,'./adminsurvey.php'),(20789839,9633,'./adminsurvey.php'),(20789838,9632,'./adminsurvey.php'),(20789837,3070,'./adminsurvey.php'),(20789836,9201,'./adminsurvey.php'),(20789835,1,'./adminsurvey.php'),(20789834,9200,'./adminsurvey.php'),(20789833,9231,'./adminsurvey.php'),(20789832,9199,'./adminsurvey.php'),(20789831,9198,'./adminsurvey.php'),(20789830,9230,'./adminsurvey.php'),(20789829,9197,'./adminsurvey.php'),(20789828,2936,'./adminsurvey.php'),(20789827,2902,'./adminsurvey.php'),(20789826,2886,'./adminsurvey.php'),(20789825,2751,'./adminsurvey.php'),(20789824,2702,'./adminsurvey.php'),(20789823,4265,'./adminsurvey.php'),(20789822,8784,'./adminsurvey.php'),(20789821,6351,'./adminsurvey.php'),(20789820,2400,'./adminsurvey.php'),(20789819,17489,'./adminsurvey.php'),(20789818,9631,'./adminsurvey.php'),(20789817,2331,'./adminsurvey.php'),(20789816,9630,'./adminsurvey.php'),(20789815,2329,'./adminsurvey.php'),(20789814,2165,'./adminsurvey.php'),(20789813,8290,'./adminsurvey.php'),(20789812,1973,'./adminsurvey.php'),(20789811,1963,'./adminsurvey.php'),(20789810,8289,'./adminsurvey.php'),(20789809,8544,'./adminsurvey.php'),(20789808,9629,'./adminsurvey.php'),(20789807,9628,'./adminsurvey.php'),(20789806,9627,'./adminsurvey.php'),(20789805,1758,'./adminsurvey.php'),(20789804,1668,'./adminsurvey.php'),(20789803,8786,'./adminsurvey.php'),(20789802,3917,'./adminsurvey.php'),(20789801,1598,'./adminsurvey.php'),(20789800,8782,'./adminsurvey.php'),(20789799,9196,'./adminsurvey.php'),(20789798,9195,'./adminsurvey.php'),(20789797,1429,'./adminsurvey.php'),(20789796,9626,'./adminsurvey.php'),(20789795,1381,'./adminsurvey.php'),(20789794,5142,'./adminsurvey.php'),(20789793,8311,'./adminsurvey.php'),(20789792,8936,'./adminsurvey.php'),(20789791,8310,'./adminsurvey.php'),(20789790,8286,'./adminsurvey.php'),(20789789,8309,'./adminsurvey.php'),(20789788,8285,'./adminsurvey.php'),(20789787,9194,'./adminsurvey.php'),(20789786,981,'./adminsurvey.php'),(20789785,8283,'./adminsurvey.php'),(20789784,941,'./adminsurvey.php'),(20789783,8781,'./adminsurvey.php'),(20789782,9625,'./adminsurvey.php'),(20789781,5406,'./adminsurvey.php'),(20789780,799,'./adminsurvey.php'),(20789779,9229,'./adminsurvey.php'),(20789778,8010,'./adminsurvey.php'),(20789777,737,'./adminsurvey.php'),(20789776,697,'./adminsurvey.php'),(20789775,9193,'./adminsurvey.php'),(20789774,9192,'./adminsurvey.php'),(20789773,659,'./adminsurvey.php'),(20789772,524,'./adminsurvey.php'),(20789771,6326,'./adminsurvey.php'),(20789770,9246,'./adminsurvey.php'),(20789769,315,'./adminsurvey.php'),(20789768,9228,'./adminsurvey.php'),(20789767,8125,'./adminsurvey.php'),(20789766,202,'./adminsurvey.php'),(20789765,9191,'./adminsurvey.php'),(20789764,9190,'./adminsurvey.php'),(20789763,9189,'./adminsurvey.php'),(20789762,8280,'./adminsurvey.php'),(20789761,9188,'./adminsurvey.php'),(20789760,8278,'./adminsurvey.php'),(20789759,9624,'./adminsurvey.php'),(20789758,9623,'./adminsurvey.php'),(20789757,59,'./adminsurvey.php'),(20789755,6361,'./adminstagesetup.php'),(20789754,9355,'./adminstagesetup.php'),(20789753,9809,'./adminstagesetup.php'),(20789752,2902,'./adminstagesetup.php'),(20789751,9808,'./adminstagesetup.php'),(20789750,2702,'./adminstagesetup.php'),(20789749,9807,'./adminstagesetup.php'),(20789748,9806,'./adminstagesetup.php'),(20789747,2070,'./adminstagesetup.php'),(20789746,1963,'./adminstagesetup.php'),(20789745,1935,'./adminstagesetup.php'),(20789744,9805,'./adminstagesetup.php'),(20789743,8936,'./adminstagesetup.php'),(20789742,9804,'./adminstagesetup.php'),(20789741,5141,'./adminstagesetup.php'),(20789740,941,'./adminstagesetup.php'),(20789739,869,'./adminstagesetup.php'),(20789738,7105,'./adminstagesetup.php'),(20789737,799,'./adminstagesetup.php'),(20789736,9803,'./adminstagesetup.php'),(20789735,548,'./adminstagesetup.php'),(20789734,315,'./adminstagesetup.php'),(20789733,9802,'./adminstagesetup.php'),(20789732,9801,'./adminstagesetup.php'),(20789731,9800,'./adminstagesetup.php'),(20789730,8125,'./adminstagesetup.php'),(20789729,202,'./adminstagesetup.php'),(20789728,9799,'./adminstagesetup.php'),(20789727,9798,'./adminstagesetup.php'),(20789726,197,'./adminstagesetup.php'),(20789725,9797,'./adminstagesetup.php'),(20789724,59,'./adminstagesetup.php'),(20789723,47,'./adminstagesetup.php'),(20789722,3312,'./adminserversetup.php'),(20789721,2886,'./adminserversetup.php'),(20789720,2800,'./adminserversetup.php'),(20789719,2592,'./adminserversetup.php'),(20789718,1935,'./adminserversetup.php'),(20789717,10386,'./adminserversetup.php'),(20789716,13334,'./adminserversetup.php'),(20789715,8121,'./adminserversetup.php'),(20789714,5407,'./adminserversetup.php'),(20789713,5034,'./adminserversetup.php'),(20789712,5286,'./adminserversetup.php'),(20789711,11986,'./adminserversetup.php'),(20789710,5181,'./adminserversetup.php'),(20666820,3421,'./adminscartfreeship.php'),(20666819,9389,'./adminscartfreeship.php'),(20666818,3070,'./adminscartfreeship.php'),(20666817,9388,'./adminscartfreeship.php'),(20666816,2702,'./adminscartfreeship.php'),(20666815,8824,'./adminscartfreeship.php'),(20666814,1973,'./adminscartfreeship.php'),(20666813,9387,'./adminscartfreeship.php'),(20666812,9386,'./adminscartfreeship.php'),(20666811,9385,'./adminscartfreeship.php'),(20666810,9384,'./adminscartfreeship.php'),(20666809,9383,'./adminscartfreeship.php'),(20666808,8936,'./adminscartfreeship.php'),(20666807,941,'./adminscartfreeship.php'),(20666806,799,'./adminscartfreeship.php'),(20666805,315,'./adminscartfreeship.php'),(20666804,4871,'./adminscartfreeship.php'),(20666803,87,'./adminscartfreeship.php'),(20666802,9382,'./adminscartfreeship.php'),(20666801,55,'./adminscartfreeship.php'),(20789709,2702,'./adminreportcache.php'),(20789708,6638,'./adminreportcache.php'),(20789707,2612,'./adminreportcache.php'),(20789706,12012,'./adminreportcache.php'),(20789705,12011,'./adminreportcache.php'),(20789704,6435,'./adminreportcache.php'),(20789703,1564,'./adminreportcache.php'),(20789702,11982,'./adminreportcache.php'),(20789701,4973,'./adminreportcache.php'),(20666791,13834,'./adminprtworkstepsadd.php'),(20666790,13833,'./adminprtworkstepsadd.php'),(20666789,2902,'./adminprtworkstepsadd.php'),(20666788,2702,'./adminprtworkstepsadd.php'),(20666787,315,'./adminprtworkstepsadd.php'),(20666786,222,'./adminprtworkstepsadd.php'),(20789700,3398,'./adminprtworkareaupd.php'),(20789699,3397,'./adminprtworkareaupd.php'),(20789698,3396,'./adminprtworkareaupd.php'),(20789697,2710,'./adminprtworkareaupd.php'),(20789696,2702,'./adminprtworkareaupd.php'),(20789695,4346,'./adminprtworkareaupd.php'),(20789694,966,'./adminprtworkareaupd.php'),(20789693,941,'./adminprtworkareaupd.php'),(20789692,799,'./adminprtworkareaupd.php'),(20789691,315,'./adminprtworkareaupd.php'),(20789690,300,'./adminprtworkareaupd.php'),(20789689,5203,'./adminprtworkareaupd.php'),(20789688,3998,'./adminprtworkareaupd.php'),(20789687,59,'./adminprtworkareaupd.php'),(20789686,3396,'./adminprtworkareaadd.php'),(20789685,3395,'./adminprtworkareaadd.php'),(20789684,3394,'./adminprtworkareaadd.php'),(20789683,2702,'./adminprtworkareaadd.php'),(20789682,315,'./adminprtworkareaadd.php'),(20789681,3955,'./adminprtworkareaadd.php'),(20789680,4345,'./adminprtworkarea_assign.php'),(20789679,3398,'./adminprtworkarea_assign.php'),(20789678,3397,'./adminprtworkarea_assign.php'),(20789677,3394,'./adminprtworkarea_assign.php'),(20789676,3273,'./adminprtworkarea_assign.php'),(20789675,2950,'./adminprtworkarea_assign.php'),(20789674,2906,'./adminprtworkarea_assign.php'),(20789673,2905,'./adminprtworkarea_assign.php'),(20789672,2833,'./adminprtworkarea_assign.php'),(20789671,2702,'./adminprtworkarea_assign.php'),(20789670,2505,'./adminprtworkarea_assign.php'),(20789669,2504,'./adminprtworkarea_assign.php'),(20789668,2459,'./adminprtworkarea_assign.php'),(20789667,6235,'./adminprtworkarea_assign.php'),(20789666,2070,'./adminprtworkarea_assign.php'),(20789665,1534,'./adminprtworkarea_assign.php'),(20789664,966,'./adminprtworkarea_assign.php'),(20789663,941,'./adminprtworkarea_assign.php'),(20789662,937,'./adminprtworkarea_assign.php'),(20789661,315,'./adminprtworkarea_assign.php'),(20789660,300,'./adminprtworkarea_assign.php'),(20789659,3998,'./adminprtworkarea_assign.php'),(20789658,59,'./adminprtworkarea_assign.php'),(20789657,2710,'./adminprtlocationupd.php'),(20789656,2702,'./adminprtlocationupd.php'),(20789655,1657,'./adminprtlocationupd.php'),(20789654,1654,'./adminprtlocationupd.php'),(20789653,941,'./adminprtlocationupd.php'),(20789652,832,'./adminprtlocationupd.php'),(20789651,799,'./adminprtlocationupd.php'),(20789650,315,'./adminprtlocationupd.php'),(20789649,5203,'./adminprtlocationupd.php'),(20789648,113,'./adminprtlocationupd.php'),(20789647,59,'./adminprtlocationupd.php'),(20789646,3207,'./adminprtlocationadd.php'),(20789645,2702,'./adminprtlocationadd.php'),(20789644,1648,'./adminprtlocationadd.php'),(20789643,315,'./adminprtlocationadd.php'),(20789642,70,'./adminprtlocationadd.php'),(20789641,59,'./adminprtlocationadd.php'),(20791339,315,'./arbankdepositupd.php'),(20789640,13362,'./adminprtgeneral.php'),(20789639,7559,'./adminprtgeneral.php'),(20789638,13104,'./adminprtgeneral.php'),(20789637,13103,'./adminprtgeneral.php'),(20789636,6944,'./adminprtgeneral.php'),(20789635,11777,'./adminprtgeneral.php'),(20789634,4030,'./adminprtgeneral.php'),(20789633,2702,'./adminprtgeneral.php'),(20789632,7528,'./adminprtgeneral.php'),(20789631,2525,'./adminprtgeneral.php'),(20789630,2527,'./adminprtgeneral.php'),(20789629,2454,'./adminprtgeneral.php'),(20789628,13907,'./adminprtgeneral.php'),(20789627,13361,'./adminprtgeneral.php'),(20789626,1834,'./adminprtgeneral.php'),(20789625,11367,'./adminprtgeneral.php'),(20789624,1826,'./adminprtgeneral.php'),(20789623,13658,'./adminprtgeneral.php'),(20789622,6114,'./adminprtgeneral.php'),(20789621,6113,'./adminprtgeneral.php'),(20789620,4344,'./adminprtgeneral.php'),(20789619,4029,'./adminprtgeneral.php'),(20789618,7527,'./adminprtgeneral.php'),(20789617,4346,'./adminprtgeneral.php'),(20789616,1209,'./adminprtgeneral.php'),(20789615,1135,'./adminprtgeneral.php'),(20789614,13905,'./adminprtgeneral.php'),(20789613,13102,'./adminprtgeneral.php'),(20789612,13904,'./adminprtgeneral.php'),(20789611,13360,'./adminprtgeneral.php'),(20789610,13359,'./adminprtgeneral.php'),(20789609,378,'./adminprtgeneral.php'),(20789608,3477,'./adminprtemail.php'),(20789607,4343,'./adminprtemail.php'),(20789606,2702,'./adminprtemail.php'),(20789605,4342,'./adminprtemail.php'),(20789604,4341,'./adminprtemail.php'),(20789603,4340,'./adminprtemail.php'),(20789602,4339,'./adminprtemail.php'),(20789601,4338,'./adminprtemail.php'),(20789600,4337,'./adminprtemail.php'),(20789599,1880,'./adminprtemail.php'),(20789598,4336,'./adminprtemail.php'),(20789597,1467,'./adminprtemail.php'),(20789596,4335,'./adminprtemail.php'),(20791281,16443,'./arbankdepositadd.php'),(20791338,5203,'./arbankdepositupd.php'),(20789595,3223,'./adminprtaxtypeupd.php'),(20789594,3028,'./adminprtaxtypeupd.php'),(20789593,3026,'./adminprtaxtypeupd.php'),(20789592,3024,'./adminprtaxtypeupd.php'),(20789591,3018,'./adminprtaxtypeupd.php'),(20789590,3017,'./adminprtaxtypeupd.php'),(20789589,3015,'./adminprtaxtypeupd.php'),(20789588,12026,'./adminprtaxtypeupd.php'),(20789587,3013,'./adminprtaxtypeupd.php'),(20789586,3004,'./adminprtaxtypeupd.php'),(20789585,3003,'./adminprtaxtypeupd.php'),(20789584,7717,'./adminprtaxtypeupd.php'),(20789583,2980,'./adminprtaxtypeupd.php'),(20789582,2936,'./adminprtaxtypeupd.php'),(20789581,2898,'./adminprtaxtypeupd.php'),(20789580,2882,'./adminprtaxtypeupd.php'),(20789579,12025,'./adminprtaxtypeupd.php'),(20789578,12024,'./adminprtaxtypeupd.php'),(20789577,12023,'./adminprtaxtypeupd.php'),(20789576,2710,'./adminprtaxtypeupd.php'),(20789575,2702,'./adminprtaxtypeupd.php'),(20789574,6636,'./adminprtaxtypeupd.php'),(20789573,2289,'./adminprtaxtypeupd.php'),(20789572,2141,'./adminprtaxtypeupd.php'),(20789571,12022,'./adminprtaxtypeupd.php'),(20789570,2131,'./adminprtaxtypeupd.php'),(20789569,2052,'./adminprtaxtypeupd.php'),(20789568,9398,'./adminprtaxtypeupd.php'),(20789567,1963,'./adminprtaxtypeupd.php'),(20789566,1935,'./adminprtaxtypeupd.php'),(20789565,14145,'./adminprtaxtypeupd.php'),(20789564,1872,'./adminprtaxtypeupd.php'),(20789563,1862,'./adminprtaxtypeupd.php'),(20789562,1860,'./adminprtaxtypeupd.php'),(20789561,1849,'./adminprtaxtypeupd.php'),(20789560,1848,'./adminprtaxtypeupd.php'),(20789559,1864,'./adminprtaxtypeupd.php'),(20789558,11999,'./adminprtaxtypeupd.php'),(20789557,1782,'./adminprtaxtypeupd.php'),(20789556,7716,'./adminprtaxtypeupd.php'),(20789555,12021,'./adminprtaxtypeupd.php'),(20789554,1499,'./adminprtaxtypeupd.php'),(20789553,7714,'./adminprtaxtypeupd.php'),(20789552,1470,'./adminprtaxtypeupd.php'),(20789551,1394,'./adminprtaxtypeupd.php'),(20789550,1388,'./adminprtaxtypeupd.php'),(20789549,1379,'./adminprtaxtypeupd.php'),(20789548,1351,'./adminprtaxtypeupd.php'),(20789547,989,'./adminprtaxtypeupd.php'),(20789546,13735,'./adminprtaxtypeupd.php'),(20789545,976,'./adminprtaxtypeupd.php'),(20789544,7215,'./adminprtaxtypeupd.php'),(20789543,7214,'./adminprtaxtypeupd.php'),(20789542,13734,'./adminprtaxtypeupd.php'),(20789541,941,'./adminprtaxtypeupd.php'),(20789540,940,'./adminprtaxtypeupd.php'),(20789539,856,'./adminprtaxtypeupd.php'),(20789538,799,'./adminprtaxtypeupd.php'),(20789537,780,'./adminprtaxtypeupd.php'),(20789536,6189,'./adminprtaxtypeupd.php'),(20789535,6188,'./adminprtaxtypeupd.php'),(20789534,6187,'./adminprtaxtypeupd.php'),(20789533,674,'./adminprtaxtypeupd.php'),(20789532,573,'./adminprtaxtypeupd.php'),(20789531,542,'./adminprtaxtypeupd.php'),(20789530,524,'./adminprtaxtypeupd.php'),(20789529,480,'./adminprtaxtypeupd.php'),(20789528,13733,'./adminprtaxtypeupd.php'),(20789527,13732,'./adminprtaxtypeupd.php'),(20789526,315,'./adminprtaxtypeupd.php'),(20789525,5203,'./adminprtaxtypeupd.php'),(20789524,9409,'./adminprtaxtypeupd.php'),(20789523,257,'./adminprtaxtypeupd.php'),(20789522,6186,'./adminprtaxtypeupd.php'),(20789521,6635,'./adminprtaxtypeupd.php'),(20789520,6185,'./adminprtaxtypeupd.php'),(20789519,6184,'./adminprtaxtypeupd.php'),(20789518,229,'./adminprtaxtypeupd.php'),(20789517,9397,'./adminprtaxtypeupd.php'),(20789516,7230,'./adminprtaxtypeupd.php'),(20789515,3520,'./adminprtaxtypeupd.php'),(20789514,3421,'./adminprtaxtypedtl.php'),(20789513,3026,'./adminprtaxtypedtl.php'),(20789512,3024,'./adminprtaxtypedtl.php'),(20789511,3023,'./adminprtaxtypedtl.php'),(20789510,3000,'./adminprtaxtypedtl.php'),(20789509,2936,'./adminprtaxtypedtl.php'),(20789508,2710,'./adminprtaxtypedtl.php'),(20789507,2702,'./adminprtaxtypedtl.php'),(20789506,13737,'./adminprtaxtypedtl.php'),(20789505,2358,'./adminprtaxtypedtl.php'),(20789504,2141,'./adminprtaxtypedtl.php'),(20789503,2052,'./adminprtaxtypedtl.php'),(20789502,1973,'./adminprtaxtypedtl.php'),(20789501,1935,'./adminprtaxtypedtl.php'),(20789500,1822,'./adminprtaxtypedtl.php'),(20789499,1782,'./adminprtaxtypedtl.php'),(20789498,1379,'./adminprtaxtypedtl.php'),(20789497,11974,'./adminprtaxtypedtl.php'),(20789496,941,'./adminprtaxtypedtl.php'),(20789495,782,'./adminprtaxtypedtl.php'),(20789494,524,'./adminprtaxtypedtl.php'),(20789493,324,'./adminprtaxtypedtl.php'),(20789492,315,'./adminprtaxtypedtl.php'),(20789491,7230,'./adminprtaxtypedtl.php'),(20789490,3520,'./adminprtaxtypedtl.php'),(20789489,8080,'./adminprtaxtypeadd.php'),(20789488,3223,'./adminprtaxtypeadd.php'),(20789487,5269,'./adminprtaxtypeadd.php'),(20789486,8079,'./adminprtaxtypeadd.php'),(20789485,8078,'./adminprtaxtypeadd.php'),(20789484,3024,'./adminprtaxtypeadd.php'),(20789483,3018,'./adminprtaxtypeadd.php'),(20789482,3015,'./adminprtaxtypeadd.php'),(20789481,12026,'./adminprtaxtypeadd.php'),(20789480,3013,'./adminprtaxtypeadd.php'),(20789479,3003,'./adminprtaxtypeadd.php'),(20789478,2999,'./adminprtaxtypeadd.php'),(20789477,7717,'./adminprtaxtypeadd.php'),(20789476,2980,'./adminprtaxtypeadd.php'),(20789475,2936,'./adminprtaxtypeadd.php'),(20789474,2898,'./adminprtaxtypeadd.php'),(20789473,2882,'./adminprtaxtypeadd.php'),(20789472,12025,'./adminprtaxtypeadd.php'),(20789471,12024,'./adminprtaxtypeadd.php'),(20789470,12023,'./adminprtaxtypeadd.php'),(20789469,2710,'./adminprtaxtypeadd.php'),(20789468,2702,'./adminprtaxtypeadd.php'),(20789467,6636,'./adminprtaxtypeadd.php'),(20789466,2141,'./adminprtaxtypeadd.php'),(20789465,12022,'./adminprtaxtypeadd.php'),(20789464,2131,'./adminprtaxtypeadd.php'),(20789463,9398,'./adminprtaxtypeadd.php'),(20789462,1963,'./adminprtaxtypeadd.php'),(20789461,11975,'./adminprtaxtypeadd.php'),(20789460,1935,'./adminprtaxtypeadd.php'),(20789459,14145,'./adminprtaxtypeadd.php'),(20789458,1872,'./adminprtaxtypeadd.php'),(20789457,1862,'./adminprtaxtypeadd.php'),(20789456,1860,'./adminprtaxtypeadd.php'),(20789455,1849,'./adminprtaxtypeadd.php'),(20789454,1848,'./adminprtaxtypeadd.php'),(20789453,1864,'./adminprtaxtypeadd.php'),(20789452,11999,'./adminprtaxtypeadd.php'),(20789451,1782,'./adminprtaxtypeadd.php'),(20789450,7716,'./adminprtaxtypeadd.php'),(20789449,12021,'./adminprtaxtypeadd.php'),(20789448,1499,'./adminprtaxtypeadd.php'),(20789447,7714,'./adminprtaxtypeadd.php'),(20789446,1470,'./adminprtaxtypeadd.php'),(20789445,8077,'./adminprtaxtypeadd.php'),(20789444,1394,'./adminprtaxtypeadd.php'),(20789443,1388,'./adminprtaxtypeadd.php'),(20789442,1379,'./adminprtaxtypeadd.php'),(20789441,1351,'./adminprtaxtypeadd.php'),(20789440,989,'./adminprtaxtypeadd.php'),(20789439,13735,'./adminprtaxtypeadd.php'),(20789438,976,'./adminprtaxtypeadd.php'),(20789437,7215,'./adminprtaxtypeadd.php'),(20789436,7214,'./adminprtaxtypeadd.php'),(20789435,13734,'./adminprtaxtypeadd.php'),(20789434,940,'./adminprtaxtypeadd.php'),(20789433,780,'./adminprtaxtypeadd.php'),(20789432,6189,'./adminprtaxtypeadd.php'),(20789431,6188,'./adminprtaxtypeadd.php'),(20789430,6187,'./adminprtaxtypeadd.php'),(20789429,674,'./adminprtaxtypeadd.php'),(20789428,8076,'./adminprtaxtypeadd.php'),(20789427,573,'./adminprtaxtypeadd.php'),(20789426,542,'./adminprtaxtypeadd.php'),(20789425,524,'./adminprtaxtypeadd.php'),(20789424,480,'./adminprtaxtypeadd.php'),(20789423,13733,'./adminprtaxtypeadd.php'),(20789422,13732,'./adminprtaxtypeadd.php'),(20789421,323,'./adminprtaxtypeadd.php'),(20789420,315,'./adminprtaxtypeadd.php'),(20789419,9409,'./adminprtaxtypeadd.php'),(20789418,257,'./adminprtaxtypeadd.php');
INSERT INTO `langmatch` VALUES (20789417,6186,'./adminprtaxtypeadd.php'),(20789416,6635,'./adminprtaxtypeadd.php'),(20789415,6185,'./adminprtaxtypeadd.php'),(20789414,6184,'./adminprtaxtypeadd.php'),(20789413,229,'./adminprtaxtypeadd.php'),(20789412,9397,'./adminprtaxtypeadd.php'),(20789411,7230,'./adminprtaxtypeadd.php'),(20789410,59,'./adminprtaxtypeadd.php'),(20789409,3520,'./adminprtaxtypeadd.php'),(20789408,3225,'./adminprt_categoryadd.php'),(20789407,12728,'./adminprt_categoryadd.php'),(20789406,2710,'./adminprt_categoryadd.php'),(20789405,2702,'./adminprt_categoryadd.php'),(20789404,3961,'./adminprt_categoryadd.php'),(20789403,3960,'./adminprt_categoryadd.php'),(20789402,1519,'./adminprt_categoryadd.php'),(20789401,3995,'./adminprt_categoryadd.php'),(20789400,6565,'./adminprt_categoryadd.php'),(20789399,315,'./adminprt_categoryadd.php'),(20789398,3225,'./adminprt_category.php'),(20789397,12728,'./adminprt_category.php'),(20789396,2710,'./adminprt_category.php'),(20789395,2702,'./adminprt_category.php'),(20789394,3961,'./adminprt_category.php'),(20789393,3959,'./adminprt_category.php'),(20789392,1519,'./adminprt_category.php'),(20789391,3995,'./adminprt_category.php'),(20789390,1143,'./adminprt_category.php'),(20789389,941,'./adminprt_category.php'),(20789388,864,'./adminprt_category.php'),(20789387,799,'./adminprt_category.php'),(20789386,6565,'./adminprt_category.php'),(20789385,315,'./adminprt_category.php'),(20789384,5203,'./adminprt_category.php'),(20789383,111,'./adminprt_category.php'),(20789382,59,'./adminprt_category.php'),(20789381,6634,'./adminprpens.php'),(20789380,15747,'./adminprpens.php'),(20789379,3351,'./adminprpens.php'),(20789378,3274,'./adminprpens.php'),(20789377,6183,'./adminprpens.php'),(20789376,4597,'./adminprpens.php'),(20789375,2917,'./adminprpens.php'),(20789374,2942,'./adminprpens.php'),(20789373,2938,'./adminprpens.php'),(20789372,2775,'./adminprpens.php'),(20789371,2710,'./adminprpens.php'),(20789370,2702,'./adminprpens.php'),(20789369,2342,'./adminprpens.php'),(20789368,6182,'./adminprpens.php'),(20789367,2296,'./adminprpens.php'),(20789366,3739,'./adminprpens.php'),(20789365,2294,'./adminprpens.php'),(20789364,7709,'./adminprpens.php'),(20789363,2149,'./adminprpens.php'),(20789362,2146,'./adminprpens.php'),(20789361,2044,'./adminprpens.php'),(20789360,1988,'./adminprpens.php'),(20789359,6633,'./adminprpens.php'),(20789358,1840,'./adminprpens.php'),(20789357,7482,'./adminprpens.php'),(20789356,6632,'./adminprpens.php'),(20789355,1579,'./adminprpens.php'),(20789354,1563,'./adminprpens.php'),(20789353,1512,'./adminprpens.php'),(20789352,1507,'./adminprpens.php'),(20789351,1476,'./adminprpens.php'),(20789350,6181,'./adminprpens.php'),(20789349,1443,'./adminprpens.php'),(20789348,1389,'./adminprpens.php'),(20789347,1383,'./adminprpens.php'),(20789346,6180,'./adminprpens.php'),(20789345,6179,'./adminprpens.php'),(20789344,1011,'./adminprpens.php'),(20789343,1010,'./adminprpens.php'),(20789342,15396,'./adminprpens.php'),(20789341,997,'./adminprpens.php'),(20789340,966,'./adminprpens.php'),(20789339,941,'./adminprpens.php'),(20789338,12087,'./adminprpens.php'),(20789337,840,'./adminprpens.php'),(20789336,5205,'./adminprpens.php'),(20789335,799,'./adminprpens.php'),(20789334,784,'./adminprpens.php'),(20789333,661,'./adminprpens.php'),(20789332,15395,'./adminprpens.php'),(20789331,6617,'./adminprpens.php'),(20789330,6616,'./adminprpens.php'),(20789329,526,'./adminprpens.php'),(20789328,6631,'./adminprpens.php'),(20789327,413,'./adminprpens.php'),(20789326,18267,'./adminprpens.php'),(20789325,6630,'./adminprpens.php'),(20789324,383,'./adminprpens.php'),(20789323,16842,'./adminprpens.php'),(20789322,329,'./adminprpens.php'),(20789321,13994,'./adminprpens.php'),(20789320,315,'./adminprpens.php'),(20789319,5203,'./adminprpens.php'),(20789318,213,'./adminprpens.php'),(20789317,204,'./adminprpens.php'),(20789316,121,'./adminprpens.php'),(20789313,2710,'./adminprpaytypeupd.php'),(20789312,2702,'./adminprpaytypeupd.php'),(20789311,6629,'./adminprpaytypeupd.php'),(20789310,2044,'./adminprpaytypeupd.php'),(20789309,966,'./adminprpaytypeupd.php'),(20789308,941,'./adminprpaytypeupd.php'),(20789307,839,'./adminprpaytypeupd.php'),(20789306,799,'./adminprpaytypeupd.php'),(20789305,315,'./adminprpaytypeupd.php'),(20789304,5203,'./adminprpaytypeupd.php'),(20789303,119,'./adminprpaytypeupd.php'),(20789302,59,'./adminprpaytypeupd.php'),(20789301,2702,'./adminprpaytypeadd.php'),(20789300,6628,'./adminprpaytypeadd.php'),(20789299,315,'./adminprpaytypeadd.php'),(20666383,3432,'./adminprnelco.php'),(20666382,12892,'./adminprnelco.php'),(20666381,2936,'./adminprnelco.php'),(20666380,2929,'./adminprnelco.php'),(20666379,2710,'./adminprnelco.php'),(20666378,2702,'./adminprnelco.php'),(20666377,12891,'./adminprnelco.php'),(20666376,2324,'./adminprnelco.php'),(20666375,2234,'./adminprnelco.php'),(20666374,12890,'./adminprnelco.php'),(20666373,1758,'./adminprnelco.php'),(20666372,1429,'./adminprnelco.php'),(20666371,1373,'./adminprnelco.php'),(20666370,981,'./adminprnelco.php'),(20666369,581,'./adminprnelco.php'),(20666368,524,'./adminprnelco.php'),(20666367,315,'./adminprnelco.php'),(20666366,8797,'./adminprnelco.php'),(20666365,12889,'./adminprnelco.php'),(20789298,7711,'./adminprglacct.php'),(20789297,3404,'./adminprglacct.php'),(20789296,3403,'./adminprglacct.php'),(20789295,3350,'./adminprglacct.php'),(20789294,3349,'./adminprglacct.php'),(20789293,6627,'./adminprglacct.php'),(20789292,6626,'./adminprglacct.php'),(20789291,3348,'./adminprglacct.php'),(20789290,3347,'./adminprglacct.php'),(20789289,3283,'./adminprglacct.php'),(20789288,12888,'./adminprglacct.php'),(20789287,15663,'./adminprglacct.php'),(20789286,2944,'./adminprglacct.php'),(20789285,2943,'./adminprglacct.php'),(20789284,2941,'./adminprglacct.php'),(20789283,12887,'./adminprglacct.php'),(20789282,12886,'./adminprglacct.php'),(20789281,2929,'./adminprglacct.php'),(20789280,15394,'./adminprglacct.php'),(20789279,15393,'./adminprglacct.php'),(20789278,15662,'./adminprglacct.php'),(20789277,15661,'./adminprglacct.php'),(20789276,2710,'./adminprglacct.php'),(20789275,2702,'./adminprglacct.php'),(20789274,15720,'./adminprglacct.php'),(20789273,6201,'./adminprglacct.php'),(20789272,15660,'./adminprglacct.php'),(20789271,15659,'./adminprglacct.php'),(20789270,6200,'./adminprglacct.php'),(20789269,15658,'./adminprglacct.php'),(20789268,15657,'./adminprglacct.php'),(20789267,12885,'./adminprglacct.php'),(20789266,1905,'./adminprglacct.php'),(20789265,1899,'./adminprglacct.php'),(20789264,9176,'./adminprglacct.php'),(20789263,1875,'./adminprglacct.php'),(20789262,1874,'./adminprglacct.php'),(20789261,8767,'./adminprglacct.php'),(20789260,12884,'./adminprglacct.php'),(20789259,15392,'./adminprglacct.php'),(20789258,15656,'./adminprglacct.php'),(20789257,15697,'./adminprglacct.php'),(20789256,12213,'./adminprglacct.php'),(20789255,1486,'./adminprglacct.php'),(20789254,1482,'./adminprglacct.php'),(20789253,1476,'./adminprglacct.php'),(20789252,5501,'./adminprglacct.php'),(20789251,1391,'./adminprglacct.php'),(20789250,1390,'./adminprglacct.php'),(20789249,19103,'./adminprglacct.php'),(20789248,1386,'./adminprglacct.php'),(20789247,1384,'./adminprglacct.php'),(20789246,12883,'./adminprglacct.php'),(20789245,8195,'./adminprglacct.php'),(20789244,8936,'./adminprglacct.php'),(20789243,5272,'./adminprglacct.php'),(20789242,792,'./adminprglacct.php'),(20789241,503,'./adminprglacct.php'),(20789240,13994,'./adminprglacct.php'),(20789239,311,'./adminprglacct.php'),(20789237,3421,'./adminprgendat.php'),(20789236,3420,'./adminprgendat.php'),(20789235,15610,'./adminprgendat.php'),(20789234,3266,'./adminprgendat.php'),(20789233,3221,'./adminprgendat.php'),(20789232,3061,'./adminprgendat.php'),(20789231,2902,'./adminprgendat.php'),(20789230,2877,'./adminprgendat.php'),(20789229,15609,'./adminprgendat.php'),(20789228,2710,'./adminprgendat.php'),(20789227,2702,'./adminprgendat.php'),(20789226,15608,'./adminprgendat.php'),(20789225,11826,'./adminprgendat.php'),(20789224,11825,'./adminprgendat.php'),(20789223,7463,'./adminprgendat.php'),(20789222,1973,'./adminprgendat.php'),(20789221,1926,'./adminprgendat.php'),(20789220,1925,'./adminprgendat.php'),(20789219,7710,'./adminprgendat.php'),(20789218,1897,'./adminprgendat.php'),(20789217,1861,'./adminprgendat.php'),(20789216,1869,'./adminprgendat.php'),(20789215,1866,'./adminprgendat.php'),(20789214,14002,'./adminprgendat.php'),(20789213,1865,'./adminprgendat.php'),(20789212,1556,'./adminprgendat.php'),(20789211,15791,'./adminprgendat.php'),(20789210,1499,'./adminprgendat.php'),(20789209,1482,'./adminprgendat.php'),(20789208,3634,'./adminprgendat.php'),(20789207,1476,'./adminprgendat.php'),(20789206,7462,'./adminprgendat.php'),(20789205,7461,'./adminprgendat.php'),(20789204,799,'./adminprgendat.php'),(20789203,751,'./adminprgendat.php'),(20789202,15607,'./adminprgendat.php'),(20789201,15606,'./adminprgendat.php'),(20789200,13799,'./adminprgendat.php'),(20789199,13994,'./adminprgendat.php'),(20789198,220,'./adminprgendat.php'),(20789196,2710,'./adminpremplreviewratingupd.php'),(20789195,2702,'./adminpremplreviewratingupd.php'),(20789194,2648,'./adminpremplreviewratingupd.php'),(20789193,2647,'./adminpremplreviewratingupd.php'),(20789192,3789,'./adminpremplreviewratingupd.php'),(20789191,2044,'./adminpremplreviewratingupd.php'),(20789190,1309,'./adminpremplreviewratingupd.php'),(20789189,1199,'./adminpremplreviewratingupd.php'),(20789188,966,'./adminpremplreviewratingupd.php'),(20789187,941,'./adminpremplreviewratingupd.php'),(20789186,869,'./adminpremplreviewratingupd.php'),(20789185,849,'./adminpremplreviewratingupd.php'),(20789184,799,'./adminpremplreviewratingupd.php'),(20789183,315,'./adminpremplreviewratingupd.php'),(20789182,5203,'./adminpremplreviewratingupd.php'),(20789181,132,'./adminpremplreviewratingupd.php'),(20789180,59,'./adminpremplreviewratingupd.php'),(20789179,2702,'./adminpremplreviewratingadd.php'),(20789178,2646,'./adminpremplreviewratingadd.php'),(20789177,3789,'./adminpremplreviewratingadd.php'),(20789176,2579,'./adminpremplreviewratingadd.php'),(20789175,1116,'./adminpremplreviewratingadd.php'),(20789174,869,'./adminpremplreviewratingadd.php'),(20789173,315,'./adminpremplreviewratingadd.php'),(20789172,2710,'./adminprdedgroupupd.php'),(20789171,2702,'./adminprdedgroupupd.php'),(20789170,2044,'./adminprdedgroupupd.php'),(20789169,966,'./adminprdedgroupupd.php'),(20789168,941,'./adminprdedgroupupd.php'),(20789167,828,'./adminprdedgroupupd.php'),(20789166,799,'./adminprdedgroupupd.php'),(20789165,6621,'./adminprdedgroupupd.php'),(20789164,315,'./adminprdedgroupupd.php'),(20789163,5203,'./adminprdedgroupupd.php'),(20789162,98,'./adminprdedgroupupd.php'),(20789161,59,'./adminprdedgroupupd.php'),(20789160,2702,'./adminprdedgroupadd.php'),(20789159,6620,'./adminprdedgroupadd.php'),(20789158,315,'./adminprdedgroupadd.php'),(20789197,14001,'./adminprgendat.php'),(20789157,3419,'./adminprded.php'),(20789156,3359,'./adminprded.php'),(20789155,3274,'./adminprded.php'),(20789154,9395,'./adminprded.php'),(20789153,9394,'./adminprded.php'),(20789152,3031,'./adminprded.php'),(20789151,2917,'./adminprded.php'),(20789150,2916,'./adminprded.php'),(20789149,2710,'./adminprded.php'),(20789148,2702,'./adminprded.php'),(20789147,2663,'./adminprded.php'),(20789146,2565,'./adminprded.php'),(20789145,2379,'./adminprded.php'),(20789144,7709,'./adminprded.php'),(20789143,6618,'./adminprded.php'),(20789142,1573,'./adminprded.php'),(20789141,1570,'./adminprded.php'),(20789140,1567,'./adminprded.php'),(20789139,1562,'./adminprded.php'),(20789138,1561,'./adminprded.php'),(20789137,1542,'./adminprded.php'),(20789136,1512,'./adminprded.php'),(20789135,3633,'./adminprded.php'),(20789134,6619,'./adminprded.php'),(20789133,9396,'./adminprded.php'),(20789132,869,'./adminprded.php'),(20789131,799,'./adminprded.php'),(20789130,789,'./adminprded.php'),(20789129,6617,'./adminprded.php'),(20789128,6616,'./adminprded.php'),(20789127,245,'./adminprded.php'),(20789126,3419,'./adminprcon.php'),(20789125,3359,'./adminprcon.php'),(20789124,3274,'./adminprcon.php'),(20789123,9395,'./adminprcon.php'),(20789122,9394,'./adminprcon.php'),(20789121,3031,'./adminprcon.php'),(20789120,2917,'./adminprcon.php'),(20789119,2916,'./adminprcon.php'),(20789118,2710,'./adminprcon.php'),(20789117,2702,'./adminprcon.php'),(20789116,2663,'./adminprcon.php'),(20789115,2565,'./adminprcon.php'),(20789114,2379,'./adminprcon.php'),(20789113,7709,'./adminprcon.php'),(20789112,6618,'./adminprcon.php'),(20789111,2071,'./adminprcon.php'),(20789110,1573,'./adminprcon.php'),(20789109,1570,'./adminprcon.php'),(20789108,1567,'./adminprcon.php'),(20789107,1562,'./adminprcon.php'),(20789106,1561,'./adminprcon.php'),(20789105,1542,'./adminprcon.php'),(20789104,1512,'./adminprcon.php'),(20789103,1506,'./adminprcon.php'),(20789102,6619,'./adminprcon.php'),(20789101,9393,'./adminprcon.php'),(20789100,869,'./adminprcon.php'),(20789099,799,'./adminprcon.php'),(20789098,577,'./adminprcon.php'),(20789097,576,'./adminprcon.php'),(20789096,6617,'./adminprcon.php'),(20789095,6616,'./adminprcon.php'),(20789094,245,'./adminprcon.php'),(20789093,3359,'./adminprben.php'),(20789092,3032,'./adminprben.php'),(20789091,3031,'./adminprben.php'),(20789090,2917,'./adminprben.php'),(20789089,2916,'./adminprben.php'),(20789088,2710,'./adminprben.php'),(20789087,2702,'./adminprben.php'),(20789086,2662,'./adminprben.php'),(20789085,2565,'./adminprben.php'),(20789084,2379,'./adminprben.php'),(20789083,6618,'./adminprben.php'),(20789082,1574,'./adminprben.php'),(20789081,1573,'./adminprben.php'),(20789080,1570,'./adminprben.php'),(20789079,1567,'./adminprben.php'),(20789078,1562,'./adminprben.php'),(20789077,1542,'./adminprben.php'),(20789076,1506,'./adminprben.php'),(20789075,3632,'./adminprben.php'),(20789074,869,'./adminprben.php'),(20789073,799,'./adminprben.php'),(20789072,6617,'./adminprben.php'),(20789071,6616,'./adminprben.php'),(20789070,343,'./adminprben.php'),(20789069,6178,'./adminprben.php'),(20789068,245,'./adminprben.php'),(20789067,8354,'./adminosccompanyupd.php'),(20789066,2710,'./adminosccompanyupd.php'),(20789065,2702,'./adminosccompanyupd.php'),(20789064,2664,'./adminosccompanyupd.php'),(20789063,7708,'./adminosccompanyupd.php'),(20789062,14191,'./adminosccompanyupd.php'),(20789061,9450,'./adminosccompanyupd.php'),(20789060,9449,'./adminosccompanyupd.php'),(20789059,9448,'./adminosccompanyupd.php'),(20789058,9447,'./adminosccompanyupd.php'),(20789057,9446,'./adminosccompanyupd.php'),(20789056,9445,'./adminosccompanyupd.php'),(20789055,9444,'./adminosccompanyupd.php'),(20789054,12175,'./adminosccompanyupd.php'),(20789053,2070,'./adminosccompanyupd.php'),(20789052,1935,'./adminosccompanyupd.php'),(20789051,14190,'./adminosccompanyupd.php'),(20789050,14189,'./adminosccompanyupd.php'),(20789049,7973,'./adminosccompanyupd.php'),(20789048,14188,'./adminosccompanyupd.php'),(20789047,6599,'./adminosccompanyupd.php'),(20789046,14187,'./adminosccompanyupd.php'),(20789045,9432,'./adminosccompanyupd.php'),(20789044,8936,'./adminosccompanyupd.php'),(20789043,941,'./adminosccompanyupd.php'),(20789042,9431,'./adminosccompanyupd.php'),(20789041,9439,'./adminosccompanyupd.php'),(20789040,9438,'./adminosccompanyupd.php'),(20789039,9437,'./adminosccompanyupd.php'),(20789038,797,'./adminosccompanyupd.php'),(20789037,796,'./adminosccompanyupd.php'),(20789036,7479,'./adminosccompanyupd.php'),(20789035,5661,'./adminosccompanyupd.php'),(20789034,637,'./adminosccompanyupd.php'),(20789033,8353,'./adminosccompanyupd.php'),(20789032,503,'./adminosccompanyupd.php'),(20789031,9443,'./adminosccompanyupd.php'),(20789030,14186,'./adminosccompanyupd.php'),(20789029,9442,'./adminosccompanyupd.php'),(20789028,8629,'./adminosccompanyupd.php'),(20789027,3070,'./adminorderlinenotes.php'),(20789026,14536,'./adminorderlinenotes.php'),(20789025,2702,'./adminorderlinenotes.php'),(20789024,14535,'./adminorderlinenotes.php'),(20789023,14534,'./adminorderlinenotes.php'),(20789022,14533,'./adminorderlinenotes.php'),(20789021,14532,'./adminorderlinenotes.php'),(20789020,8118,'./adminorderlinenotes.php'),(20789019,2099,'./adminorderlinenotes.php'),(20789018,8936,'./adminorderlinenotes.php'),(20789017,941,'./adminorderlinenotes.php'),(20789016,799,'./adminorderlinenotes.php'),(20789015,315,'./adminorderlinenotes.php'),(20789014,8125,'./adminorderlinenotes.php'),(20789013,59,'./adminorderlinenotes.php'),(20789012,3252,'./adminnotesreport.php'),(20789011,13832,'./adminnotesreport.php'),(20789010,2601,'./adminnotesreport.php'),(20789009,2361,'./adminnotesreport.php'),(20789008,2165,'./adminnotesreport.php'),(20789007,13831,'./adminnotesreport.php'),(20789006,13830,'./adminnotesreport.php'),(20789005,10093,'./adminnotesreport.php'),(20789004,13829,'./adminnotesreport.php'),(20789003,2099,'./adminnotesreport.php'),(20789002,1963,'./adminnotesreport.php'),(20789001,1668,'./adminnotesreport.php'),(20789000,4414,'./adminnotesreport.php'),(20788999,8936,'./adminnotesreport.php'),(20788998,1014,'./adminnotesreport.php'),(20788997,737,'./adminnotesreport.php'),(20788996,451,'./adminnotesreport.php'),(20788995,8702,'./adminnotesreport.php'),(20788994,333,'./adminnotesreport.php'),(20788993,10050,'./adminnotecategory.php'),(20788992,2702,'./adminnotecategory.php'),(20788991,10049,'./adminnotecategory.php'),(20788990,10048,'./adminnotecategory.php'),(20788989,10047,'./adminnotecategory.php'),(20788988,12007,'./adminnotecategory.php'),(20788987,8936,'./adminnotecategory.php'),(20788986,11994,'./adminnotecategory.php'),(20788985,941,'./adminnotecategory.php'),(20788984,799,'./adminnotecategory.php'),(20788983,10045,'./adminnotecategory.php'),(20788982,457,'./adminnotecategory.php'),(20788981,451,'./adminnotecategory.php'),(20788980,315,'./adminnotecategory.php'),(20788979,8125,'./adminnotecategory.php'),(20788978,202,'./adminnotecategory.php'),(20788977,59,'./adminnotecategory.php'),(20788976,8595,'./adminmessages_seen.php'),(20788975,12044,'./adminmessages_seen.php'),(20788974,8583,'./adminmessages_seen.php'),(20788973,8594,'./adminmessages_seen.php'),(20788972,8593,'./adminmessages_seen.php'),(20788971,8572,'./adminmessages_seen.php'),(20788970,1935,'./adminmessages_seen.php'),(20788969,8592,'./adminmessages_seen.php'),(20788968,8591,'./adminmessages_seen.php'),(20788967,542,'./adminmessages_seen.php'),(20788966,8590,'./adminmessages_graphic.php'),(20788965,8589,'./adminmessages_graphic.php'),(20788964,2070,'./adminmessages_graphic.php'),(20788963,8588,'./adminmessages_graphic.php'),(20788962,542,'./adminmessages_graphic.php'),(20788961,8587,'./adminmessages_graphic.php'),(20788960,8595,'./adminmessages.php'),(20788959,8586,'./adminmessages.php'),(20788958,3202,'./adminmessages.php'),(20788957,8585,'./adminmessages.php'),(20788956,8584,'./adminmessages.php'),(20788955,8583,'./adminmessages.php'),(20788954,8582,'./adminmessages.php'),(20788953,3156,'./adminmessages.php'),(20788952,3072,'./adminmessages.php'),(20788951,3070,'./adminmessages.php'),(20788950,12725,'./adminmessages.php'),(20788949,8581,'./adminmessages.php'),(20788948,2710,'./adminmessages.php'),(20788947,8580,'./adminmessages.php'),(20788946,2702,'./adminmessages.php'),(20788945,8579,'./adminmessages.php'),(20788944,8578,'./adminmessages.php'),(20788943,8577,'./adminmessages.php'),(20788942,8576,'./adminmessages.php'),(20788941,12724,'./adminmessages.php'),(20788940,2371,'./adminmessages.php'),(20788939,8575,'./adminmessages.php'),(20788938,8574,'./adminmessages.php'),(20788937,8573,'./adminmessages.php'),(20788936,8572,'./adminmessages.php'),(20788935,6481,'./adminmessages.php'),(20788934,2070,'./adminmessages.php'),(20788933,1963,'./adminmessages.php'),(20788932,8571,'./adminmessages.php'),(20788931,8570,'./adminmessages.php'),(20788930,8569,'./adminmessages.php'),(20788929,4603,'./adminmessages.php'),(20788928,1533,'./adminmessages.php'),(20788927,8624,'./adminmessages.php'),(20788926,8568,'./adminmessages.php'),(20788925,1476,'./adminmessages.php'),(20788924,8567,'./adminmessages.php'),(20788923,8566,'./adminmessages.php'),(20788922,8565,'./adminmessages.php'),(20788921,8564,'./adminmessages.php'),(20788920,1143,'./adminmessages.php'),(20788919,8563,'./adminmessages.php'),(20788918,1014,'./adminmessages.php'),(20788917,8562,'./adminmessages.php'),(20788916,8559,'./adminmessages.php'),(20788915,4600,'./adminmessages.php'),(20788914,380,'./adminmessages.php'),(20788913,333,'./adminmessages.php'),(20788912,315,'./adminmessages.php'),(20788911,309,'./adminmessages.php'),(20788910,8598,'./adminmessages.php'),(20788909,8623,'./adminmessages.php'),(20788908,47,'./adminmessages.php'),(20788907,5130,'./adminlogin.php'),(20788906,3252,'./adminlogin.php'),(20788905,10096,'./adminlogin.php'),(20788904,10095,'./adminlogin.php'),(20788903,8936,'./adminlogin.php'),(20665968,3353,'./adminlevelstat.php'),(20665967,3316,'./adminlevelstat.php'),(20665966,3315,'./adminlevelstat.php'),(20665965,3314,'./adminlevelstat.php'),(20665964,3313,'./adminlevelstat.php'),(20665963,3175,'./adminlevelstat.php'),(20665962,2847,'./adminlevelstat.php'),(20665961,2196,'./adminlevelstat.php'),(20665960,1923,'./adminlevelstat.php'),(20665959,1853,'./adminlevelstat.php'),(20665958,1847,'./adminlevelstat.php'),(20665957,1639,'./adminlevelstat.php'),(20665956,1520,'./adminlevelstat.php'),(20665955,1482,'./adminlevelstat.php'),(20665954,1374,'./adminlevelstat.php'),(20665953,750,'./adminlevelstat.php'),(20665952,682,'./adminlevelstat.php'),(20665951,450,'./adminlevelstat.php'),(20665950,292,'./adminlevelstat.php'),(20665949,269,'./adminlevelstat.php'),(20665948,219,'./adminlevelstat.php'),(20665947,46,'./adminlevelstat.php'),(20665946,45,'./adminlevelstat.php'),(20665945,44,'./adminlevelstat.php'),(20665944,43,'./adminlevelstat.php'),(20788902,3256,'./adminipaccessmanager.php'),(20788901,2702,'./adminipaccessmanager.php'),(20788900,8517,'./adminipaccessmanager.php'),(20788899,2136,'./adminipaccessmanager.php'),(20788898,8516,'./adminipaccessmanager.php'),(20788897,1935,'./adminipaccessmanager.php'),(20788896,8515,'./adminipaccessmanager.php'),(20788895,8514,'./adminipaccessmanager.php'),(20788894,8513,'./adminipaccessmanager.php'),(20788893,8512,'./adminipaccessmanager.php'),(20788892,8511,'./adminipaccessmanager.php'),(20788891,8510,'./adminipaccessmanager.php'),(20788890,8509,'./adminipaccessmanager.php'),(20788889,2710,'./admininvunitnameupd.php'),(20788888,2702,'./admininvunitnameupd.php'),(20788887,12688,'./admininvunitnameupd.php'),(20788886,966,'./admininvunitnameupd.php'),(20788885,941,'./admininvunitnameupd.php'),(20788884,857,'./admininvunitnameupd.php'),(20788883,799,'./admininvunitnameupd.php'),(20788882,542,'./admininvunitnameupd.php'),(20788881,315,'./admininvunitnameupd.php'),(20788880,5203,'./admininvunitnameupd.php'),(20788879,143,'./admininvunitnameupd.php'),(20788878,59,'./admininvunitnameupd.php'),(20788877,2702,'./admininvunitnameadd.php'),(20788876,12687,'./admininvunitnameadd.php'),(20788875,2696,'./admininvunitnameadd.php'),(20788874,542,'./admininvunitnameadd.php'),(20788873,315,'./admininvunitnameadd.php'),(20788872,3036,'./admininvponotesupd.php'),(20788871,6099,'./admininvponotesupd.php'),(20788870,2702,'./admininvponotesupd.php'),(20788869,8017,'./admininvponotesupd.php'),(20788868,12847,'./admininvponotesupd.php'),(20788867,2044,'./admininvponotesupd.php'),(20788866,2094,'./admininvponotesupd.php'),(20788865,6111,'./admininvponotesupd.php'),(20788864,6106,'./admininvponotesupd.php'),(20788863,6110,'./admininvponotesupd.php'),(20788862,6101,'./admininvponotesupd.php'),(20788861,941,'./admininvponotesupd.php'),(20788860,902,'./admininvponotesupd.php'),(20788859,799,'./admininvponotesupd.php'),(20788858,315,'./admininvponotesupd.php'),(20788857,6100,'./admininvponotesupd.php'),(20788856,59,'./admininvponotesupd.php'),(20788855,3036,'./admininvponotesadd.php'),(20788854,6099,'./admininvponotesadd.php'),(20788853,2702,'./admininvponotesadd.php'),(20788852,12847,'./admininvponotesadd.php'),(20788851,6108,'./admininvponotesadd.php'),(20788850,6107,'./admininvponotesadd.php'),(20788849,902,'./admininvponotesadd.php'),(20788848,315,'./admininvponotesadd.php'),(20788846,6099,'./admininvoicenotesupd.php'),(20788845,2702,'./admininvoicenotesupd.php'),(20788844,2044,'./admininvoicenotesupd.php'),(20788843,2094,'./admininvoicenotesupd.php'),(20788842,6106,'./admininvoicenotesupd.php'),(20788841,6105,'./admininvoicenotesupd.php'),(20788840,6103,'./admininvoicenotesupd.php'),(20788839,12846,'./admininvoicenotesupd.php'),(20788838,6102,'./admininvoicenotesupd.php'),(20788837,6101,'./admininvoicenotesupd.php'),(20788836,941,'./admininvoicenotesupd.php'),(20788835,902,'./admininvoicenotesupd.php'),(20788834,799,'./admininvoicenotesupd.php'),(20788833,315,'./admininvoicenotesupd.php'),(20788832,16460,'./admininvoicenotesupd.php'),(20788831,6100,'./admininvoicenotesupd.php'),(20788830,59,'./admininvoicenotesupd.php'),(20788828,6099,'./admininvoicenotesadd.php'),(20788827,2702,'./admininvoicenotesadd.php'),(20788826,6098,'./admininvoicenotesadd.php'),(20788825,12846,'./admininvoicenotesadd.php'),(20788824,6096,'./admininvoicenotesadd.php'),(20788823,902,'./admininvoicenotesadd.php'),(20788822,315,'./admininvoicenotesadd.php'),(20788821,16460,'./admininvoicenotesadd.php'),(20788820,3056,'./admininvlocationupd.php'),(20788819,2710,'./admininvlocationupd.php'),(20788818,2702,'./admininvlocationupd.php'),(20788817,1654,'./admininvlocationupd.php'),(20788816,16683,'./admininvlocationupd.php'),(20788815,1333,'./admininvlocationupd.php'),(20788814,8936,'./admininvlocationupd.php'),(20788813,966,'./admininvlocationupd.php'),(20788812,941,'./admininvlocationupd.php'),(20788811,832,'./admininvlocationupd.php'),(20788810,799,'./admininvlocationupd.php'),(20788809,315,'./admininvlocationupd.php'),(20804700,1499,'./invpoadd.php'),(20789917,7457,'./adminsystemsettings.php'),(20788805,3207,'./admininvlocationadd.php'),(20788804,3188,'./admininvlocationadd.php'),(20788803,3056,'./admininvlocationadd.php'),(20788802,2702,'./admininvlocationadd.php'),(20788801,16683,'./admininvlocationadd.php'),(20788800,1333,'./admininvlocationadd.php'),(20788799,315,'./admininvlocationadd.php'),(20665837,3274,'./admininvintercompany.php'),(20665836,8315,'./admininvintercompany.php'),(20665835,8314,'./admininvintercompany.php'),(20665834,2710,'./admininvintercompany.php'),(20665833,2702,'./admininvintercompany.php'),(20665832,2405,'./admininvintercompany.php'),(20665831,8313,'./admininvintercompany.php'),(20665830,8312,'./admininvintercompany.php'),(20665829,8330,'./admininvintercompany.php'),(20665828,697,'./admininvintercompany.php'),(20800605,9492,'./glexpense.php'),(20795313,15364,'./arordshipquote.php'),(20795170,1709,'./arordshipadd.php'),(20795169,17964,'./arordshipadd.php'),(20795168,1541,'./arordshipadd.php'),(20795167,1524,'./arordshipadd.php'),(20795166,17608,'./arordshipadd.php'),(20795165,11662,'./arordshipadd.php'),(20795164,8936,'./arordshipadd.php'),(20795163,1047,'./arordshipadd.php'),(20795162,931,'./arordshipadd.php'),(20794775,13224,'./arorderquotelist.php'),(20794534,14122,'./arorderlist_backorder.php'),(20794533,8128,'./arorderlist_backorder.php'),(20794532,2103,'./arorderlist_backorder.php'),(20794531,19434,'./arorderlist_backorder.php'),(20794530,1963,'./arorderlist_backorder.php'),(20794529,1788,'./arorderlist_backorder.php'),(20794442,9600,'./arorderlist.php'),(20794363,20107,'./arordercustomerinvstatusfpdf.php'),(20794362,20106,'./arordercustomerinvstatusfpdf.php'),(20794361,5120,'./arordercustomerinvstatusfpdf.php'),(20794360,5119,'./arordercustomerinvstatusfpdf.php'),(20794359,13941,'./arordercustomerinvstatusfpdf.php'),(20794358,1696,'./arordercustomerinvstatusfpdf.php'),(20794357,20105,'./arordercustomerinvstatusfpdf.php'),(20794356,20104,'./arordercustomerinvstatusfpdf.php'),(20794355,716,'./arordercustomerinvstatusfpdf.php'),(20794032,5685,'./arordconfirmfpdf.php'),(20793902,542,'./aritemsaleslst.php'),(20793901,451,'./aritemsaleslst.php'),(20793875,607,'./aritemsaleshistory.php'),(20665827,2768,'./admininvattachupd.php'),(20665826,2608,'./admininvattachupd.php'),(20665825,1724,'./admininvattachupd.php'),(20665824,1709,'./admininvattachupd.php'),(20665823,1642,'./admininvattachupd.php'),(20665822,1533,'./admininvattachupd.php'),(20665821,1407,'./admininvattachupd.php'),(20665820,1014,'./admininvattachupd.php'),(20665819,901,'./admininvattachupd.php'),(20665818,799,'./admininvattachupd.php'),(20665817,449,'./admininvattachupd.php'),(20665816,333,'./admininvattachupd.php'),(20788796,12209,'./adminhpgroups.php'),(20788795,5049,'./adminhpgroups.php'),(20788794,5048,'./adminhpgroups.php'),(20788793,4196,'./adminhpgroups.php'),(20788792,4195,'./adminhpgroups.php'),(20788791,2702,'./adminhpgroups.php'),(20788790,3797,'./adminhpgroups.php'),(20788789,10492,'./adminhpgroups.php'),(20788788,10491,'./adminhpgroups.php'),(20788787,2270,'./adminhpgroups.php'),(20788786,2200,'./adminhpgroups.php'),(20788785,1639,'./adminhpgroups.php'),(20788784,1482,'./adminhpgroups.php'),(20788783,941,'./adminhpgroups.php'),(20788782,10627,'./adminhpgroups.php'),(20788781,10626,'./adminhpgroups.php'),(20788780,10625,'./adminhpgroups.php'),(20788779,10487,'./adminhpgroups.php'),(20788778,315,'./adminhpgroups.php'),(20788777,12189,'./adminhpgroups.php'),(20788776,12188,'./adminhpgroups.php'),(20788775,42,'./adminhpgroups.php'),(20788774,40,'./adminhpgroups.php'),(20788773,8599,'./adminhostingmanagerlogin.php'),(20788772,8543,'./adminhostingmanager.php'),(20788771,8542,'./adminhostingmanager.php'),(20788770,2948,'./adminhostingmanager.php'),(20788769,8541,'./adminhostingmanager.php'),(20788768,4267,'./adminhostingmanager.php'),(20788767,2702,'./adminhostingmanager.php'),(20788766,8539,'./adminhostingmanager.php'),(20788765,1935,'./adminhostingmanager.php'),(20788764,12836,'./adminhostingmanager.php'),(20788763,1598,'./adminhostingmanager.php'),(20788762,8599,'./adminhostingmanager.php'),(20788761,8538,'./adminhostingmanager.php'),(20788760,8511,'./adminhostingmanager.php'),(20788759,8537,'./adminhostingmanager.php'),(20788758,8536,'./adminhostingmanager.php'),(20788757,8535,'./adminhostingmanager.php'),(20788756,8534,'./adminhostingmanager.php'),(20788755,941,'./adminhostingmanager.php'),(20788754,8533,'./adminhostingmanager.php'),(20788753,799,'./adminhostingmanager.php'),(20788752,8532,'./adminhostingmanager.php'),(20788751,768,'./adminhostingmanager.php'),(20788750,8531,'./adminhostingmanager.php'),(20788749,8530,'./adminhostingmanager.php'),(20788748,10434,'./adminhostingmanager.php'),(20788747,8529,'./adminhostingmanager.php'),(20788746,10433,'./adminhostingmanager.php'),(20788745,10432,'./adminhostingmanager.php'),(20788744,315,'./adminhostingmanager.php'),(20788743,10431,'./adminhostingmanager.php'),(20788742,8125,'./adminhostingmanager.php'),(20788741,8528,'./adminhostingmanager.php'),(20788740,59,'./adminhostingmanager.php'),(20788739,55,'./adminhostingmanager.php'),(20788738,3225,'./admingraphicadd.php'),(20788737,2710,'./admingraphicadd.php'),(20788736,2702,'./admingraphicadd.php'),(20788735,12006,'./admingraphicadd.php'),(20788734,1935,'./admingraphicadd.php'),(20788733,3995,'./admingraphicadd.php'),(20788732,869,'./admingraphicadd.php'),(20788731,451,'./admingraphicadd.php'),(20788730,315,'./admingraphicadd.php'),(20788729,222,'./admingraphicadd.php'),(20788728,3225,'./admingraphic_categoryadd.php'),(20788727,2710,'./admingraphic_categoryadd.php'),(20788726,2702,'./admingraphic_categoryadd.php'),(20788725,6481,'./admingraphic_categoryadd.php'),(20788724,12005,'./admingraphic_categoryadd.php'),(20788723,8556,'./admingraphic_categoryadd.php'),(20788722,8555,'./admingraphic_categoryadd.php'),(20788721,3995,'./admingraphic_categoryadd.php'),(20788720,315,'./admingraphic_categoryadd.php'),(20788719,222,'./admingraphic_categoryadd.php'),(20788718,3225,'./admingraphic_category.php'),(20788717,2710,'./admingraphic_category.php'),(20788716,2702,'./admingraphic_category.php'),(20788715,6481,'./admingraphic_category.php'),(20788714,1935,'./admingraphic_category.php'),(20788713,8553,'./admingraphic_category.php'),(20788712,3995,'./admingraphic_category.php'),(20788711,1143,'./admingraphic_category.php'),(20788710,11992,'./admingraphic_category.php'),(20788709,941,'./admingraphic_category.php'),(20788708,869,'./admingraphic_category.php'),(20788707,864,'./admingraphic_category.php'),(20788706,799,'./admingraphic_category.php'),(20788705,315,'./admingraphic_category.php'),(20788704,5203,'./admingraphic_category.php'),(20788703,93,'./admingraphic_category.php'),(20788702,59,'./admingraphic_category.php'),(20788701,8622,'./admingraphic.php'),(20788700,3225,'./admingraphic.php'),(20788699,2710,'./admingraphic.php'),(20788698,2702,'./admingraphic.php'),(20788697,6481,'./admingraphic.php'),(20788696,1935,'./admingraphic.php'),(20788695,8551,'./admingraphic.php'),(20788694,3995,'./admingraphic.php'),(20788693,1143,'./admingraphic.php'),(20788692,11993,'./admingraphic.php'),(20788691,941,'./admingraphic.php'),(20788690,869,'./admingraphic.php'),(20788689,864,'./admingraphic.php'),(20788688,799,'./admingraphic.php'),(20788687,451,'./admingraphic.php'),(20788686,315,'./admingraphic.php'),(20788685,5203,'./admingraphic.php'),(20788684,8550,'./admingraphic.php'),(20788683,8621,'./admingraphic.php'),(20788682,59,'./admingraphic.php'),(20788681,3186,'./admingooglebase.php'),(20788680,9902,'./admingooglebase.php'),(20788679,9901,'./admingooglebase.php'),(20788678,9900,'./admingooglebase.php'),(20788677,2702,'./admingooglebase.php'),(20788676,9899,'./admingooglebase.php'),(20788675,9898,'./admingooglebase.php'),(20788674,1735,'./admingooglebase.php'),(20788673,1712,'./admingooglebase.php'),(20788672,1698,'./admingooglebase.php'),(20788671,9897,'./admingooglebase.php'),(20788670,9896,'./admingooglebase.php'),(20788669,8936,'./admingooglebase.php'),(20788668,9895,'./admingooglebase.php'),(20788667,9894,'./admingooglebase.php'),(20788666,797,'./admingooglebase.php'),(20788665,796,'./admingooglebase.php'),(20788664,9923,'./admingooglebase.php'),(20788663,315,'./admingooglebase.php'),(20788662,197,'./admingooglebase.php'),(20788661,6609,'./adminglcompanyupd.php'),(20788660,2710,'./adminglcompanyupd.php'),(20788659,2702,'./adminglcompanyupd.php'),(20788658,6608,'./adminglcompanyupd.php'),(20788657,1433,'./adminglcompanyupd.php'),(20788656,2710,'./adminglaccttypeupd.php'),(20788655,2702,'./adminglaccttypeupd.php'),(20788654,2044,'./adminglaccttypeupd.php'),(20788653,1501,'./adminglaccttypeupd.php'),(20788652,966,'./adminglaccttypeupd.php'),(20788651,941,'./adminglaccttypeupd.php'),(20788650,315,'./adminglaccttypeupd.php'),(20788649,3524,'./adminglaccttypeupd.php'),(20788648,3421,'./adminflexfields.php'),(20788647,3414,'./adminflexfields.php'),(20788646,3269,'./adminflexfields.php'),(20788645,9201,'./adminflexfields.php'),(20788644,1,'./adminflexfields.php'),(20788643,2902,'./adminflexfields.php'),(20788642,2751,'./adminflexfields.php'),(20788641,2702,'./adminflexfields.php'),(20788640,4265,'./adminflexfields.php'),(20788639,8784,'./adminflexfields.php'),(20788638,6351,'./adminflexfields.php'),(20788637,8290,'./adminflexfields.php'),(20788636,1973,'./adminflexfields.php'),(20788635,1963,'./adminflexfields.php'),(20788634,1933,'./adminflexfields.php'),(20788633,8289,'./adminflexfields.php'),(20788632,8786,'./adminflexfields.php'),(20788631,8782,'./adminflexfields.php'),(20788630,9196,'./adminflexfields.php'),(20788629,6381,'./adminflexfields.php'),(20788628,8288,'./adminflexfields.php'),(20788627,8287,'./adminflexfields.php'),(20788626,5142,'./adminflexfields.php'),(20788625,8311,'./adminflexfields.php'),(20788624,8310,'./adminflexfields.php'),(20788623,8286,'./adminflexfields.php'),(20788622,8309,'./adminflexfields.php'),(20788621,8285,'./adminflexfields.php'),(20788620,8283,'./adminflexfields.php'),(20788619,941,'./adminflexfields.php'),(20788618,8781,'./adminflexfields.php'),(20788617,5406,'./adminflexfields.php'),(20788616,799,'./adminflexfields.php'),(20788615,737,'./adminflexfields.php'),(20788614,8308,'./adminflexfields.php'),(20788613,8282,'./adminflexfields.php'),(20788612,6326,'./adminflexfields.php'),(20788611,315,'./adminflexfields.php'),(20788610,8125,'./adminflexfields.php'),(20788609,202,'./adminflexfields.php'),(20788608,8281,'./adminflexfields.php'),(20788607,8280,'./adminflexfields.php'),(20788606,8279,'./adminflexfields.php'),(20788605,8278,'./adminflexfields.php'),(20788604,3413,'./adminestquoteworktypeupd.php'),(20788603,3392,'./adminestquoteworktypeupd.php'),(20788602,3391,'./adminestquoteworktypeupd.php'),(20788601,3385,'./adminestquoteworktypeupd.php'),(20788600,3384,'./adminestquoteworktypeupd.php'),(20788599,3381,'./adminestquoteworktypeupd.php'),(20788598,3368,'./adminestquoteworktypeupd.php'),(20788597,3367,'./adminestquoteworktypeupd.php'),(20788596,3366,'./adminestquoteworktypeupd.php'),(20788595,3150,'./adminestquoteworktypeupd.php'),(20788594,3149,'./adminestquoteworktypeupd.php'),(20788593,3078,'./adminestquoteworktypeupd.php'),(20788592,7229,'./adminestquoteworktypeupd.php'),(20788591,2710,'./adminestquoteworktypeupd.php'),(20788590,2702,'./adminestquoteworktypeupd.php'),(20788589,3515,'./adminestquoteworktypeupd.php'),(20788588,2302,'./adminestquoteworktypeupd.php'),(20788587,2104,'./adminestquoteworktypeupd.php'),(20788586,1935,'./adminestquoteworktypeupd.php'),(20788585,1325,'./adminestquoteworktypeupd.php'),(20788584,1209,'./adminestquoteworktypeupd.php'),(20788583,941,'./adminestquoteworktypeupd.php'),(20788582,862,'./adminestquoteworktypeupd.php'),(20788581,3996,'./adminestquoteworktypeupd.php'),(20788580,799,'./adminestquoteworktypeupd.php'),(20788579,667,'./adminestquoteworktypeupd.php'),(20788578,315,'./adminestquoteworktypeupd.php'),(20788577,5203,'./adminestquoteworktypeupd.php'),(20788576,255,'./adminestquoteworktypeupd.php'),(20788575,8363,'./adminestquoteworktypeupd.php'),(20788574,253,'./adminestquoteworktypeupd.php'),(20788573,252,'./adminestquoteworktypeupd.php'),(20788572,251,'./adminestquoteworktypeupd.php'),(20788571,250,'./adminestquoteworktypeupd.php'),(20788570,147,'./adminestquoteworktypeupd.php'),(20788569,128,'./adminestquoteworktypeupd.php'),(20788568,86,'./adminestquoteworktypeupd.php'),(20788567,59,'./adminestquoteworktypeupd.php'),(20788566,3381,'./adminestquoteworktypestdqty.php'),(20788565,2710,'./adminestquoteworktypestdqty.php'),(20788564,2702,'./adminestquoteworktypestdqty.php'),(20788563,2529,'./adminestquoteworktypestdqty.php'),(20788562,1314,'./adminestquoteworktypestdqty.php'),(20788561,1203,'./adminestquoteworktypestdqty.php'),(20788560,542,'./adminestquoteworktypestdqty.php'),(20788559,429,'./adminestquoteworktypestdqty.php'),(20788558,315,'./adminestquoteworktypestdqty.php'),(20788557,3422,'./adminestquoteworktypeaddl.php'),(20788556,3412,'./adminestquoteworktypeaddl.php'),(20788555,3389,'./adminestquoteworktypeaddl.php'),(20788554,3388,'./adminestquoteworktypeaddl.php'),(20788553,3387,'./adminestquoteworktypeaddl.php'),(20788552,3386,'./adminestquoteworktypeaddl.php'),(20788551,3268,'./adminestquoteworktypeaddl.php'),(20788550,1,'./adminestquoteworktypeaddl.php'),(20788549,2710,'./adminestquoteworktypeaddl.php'),(20788548,2702,'./adminestquoteworktypeaddl.php'),(20788547,2539,'./adminestquoteworktypeaddl.php'),(20788546,2148,'./adminestquoteworktypeaddl.php'),(20788545,2112,'./adminestquoteworktypeaddl.php'),(20788544,1976,'./adminestquoteworktypeaddl.php'),(20788543,1452,'./adminestquoteworktypeaddl.php'),(20788542,1326,'./adminestquoteworktypeaddl.php'),(20788541,1210,'./adminestquoteworktypeaddl.php'),(20788540,846,'./adminestquoteworktypeaddl.php'),(20788539,799,'./adminestquoteworktypeaddl.php'),(20788538,542,'./adminestquoteworktypeaddl.php'),(20788537,409,'./adminestquoteworktypeaddl.php'),(20788536,298,'./adminestquoteworktypeaddl.php'),(20788535,297,'./adminestquoteworktypeaddl.php'),(20788534,296,'./adminestquoteworktypeaddl.php'),(20788533,295,'./adminestquoteworktypeaddl.php'),(20788532,294,'./adminestquoteworktypeaddl.php'),(20788531,293,'./adminestquoteworktypeaddl.php'),(20788530,5203,'./adminestquoteworktypeaddl.php'),(20788529,250,'./adminestquoteworktypeaddl.php'),(20788528,240,'./adminestquoteworktypeaddl.php'),(20788527,6607,'./adminestquoteworktypeaddl.php'),(20788526,238,'./adminestquoteworktypeaddl.php'),(20788525,236,'./adminestquoteworktypeaddl.php'),(20788524,228,'./adminestquoteworktypeaddl.php'),(20788523,226,'./adminestquoteworktypeaddl.php'),(20788522,3383,'./adminestquoteworktypeadd.php'),(20788521,3382,'./adminestquoteworktypeadd.php'),(20788520,3150,'./adminestquoteworktypeadd.php'),(20788519,3149,'./adminestquoteworktypeadd.php'),(20788518,12705,'./adminestquoteworktypeadd.php'),(20788517,2702,'./adminestquoteworktypeadd.php'),(20788516,12704,'./adminestquoteworktypeadd.php'),(20788515,2104,'./adminestquoteworktypeadd.php'),(20788514,1935,'./adminestquoteworktypeadd.php'),(20788513,1135,'./adminestquoteworktypeadd.php'),(20788512,13101,'./adminestquotetypeofspecialsupd.php'),(20788511,3221,'./adminestquotetypeofspecialsupd.php'),(20788510,13199,'./adminestquotetypeofspecialsupd.php'),(20788509,2710,'./adminestquotetypeofspecialsupd.php'),(20788508,2702,'./adminestquotetypeofspecialsupd.php'),(20788507,7440,'./adminestquotetypeofspecialsupd.php'),(20788506,869,'./adminestquotetypeofspecialsupd.php'),(20788505,6566,'./adminestquotetypeofspecialsupd.php'),(20788504,13198,'./adminestquotetypeofspecialsupd.php'),(20788503,3966,'./adminestquotestocksizes.php'),(20788502,2950,'./adminestquotestocksizes.php'),(20788501,2886,'./adminestquotestocksizes.php'),(20788500,2710,'./adminestquotestocksizes.php'),(20788499,2702,'./adminestquotestocksizes.php'),(20788498,2070,'./adminestquotestocksizes.php'),(20788497,1709,'./adminestquotestocksizes.php'),(20788496,3995,'./adminestquotestocksizes.php'),(20788495,1143,'./adminestquotestocksizes.php'),(20788494,3994,'./adminestquotestocksizes.php'),(20788493,799,'./adminestquotestocksizes.php'),(20788492,542,'./adminestquotestocksizes.php'),(20788491,3993,'./adminestquotestocksizes.php'),(20665509,3375,'./adminestquotestockcost.php'),(20665508,3290,'./adminestquotestockcost.php'),(20665507,2955,'./adminestquotestockcost.php'),(20665506,2811,'./adminestquotestockcost.php'),(20665505,2710,'./adminestquotestockcost.php'),(20665504,2653,'./adminestquotestockcost.php'),(20665503,2652,'./adminestquotestockcost.php'),(20665502,2636,'./adminestquotestockcost.php'),(20665501,2301,'./adminestquotestockcost.php'),(20665500,2300,'./adminestquotestockcost.php'),(20665499,1922,'./adminestquotestockcost.php'),(20665498,6366,'./adminestquotestockcost.php'),(20665497,1724,'./adminestquotestockcost.php'),(20665496,1644,'./adminestquotestockcost.php'),(20665495,938,'./adminestquotestockcost.php'),(20665494,616,'./adminestquotestockcost.php'),(20788490,3966,'./adminestquotestockcolorsize.php'),(20788489,2950,'./adminestquotestockcolorsize.php'),(20788488,2886,'./adminestquotestockcolorsize.php'),(20788487,2710,'./adminestquotestockcolorsize.php'),(20788486,2702,'./adminestquotestockcolorsize.php'),(20788485,2070,'./adminestquotestockcolorsize.php'),(20788484,1709,'./adminestquotestockcolorsize.php'),(20788483,3995,'./adminestquotestockcolorsize.php'),(20788482,1143,'./adminestquotestockcolorsize.php'),(20788481,3994,'./adminestquotestockcolorsize.php'),(20788480,799,'./adminestquotestockcolorsize.php'),(20788479,542,'./adminestquotestockcolorsize.php'),(20788478,3993,'./adminestquotestockcolorsize.php'),(20788477,3965,'./adminestquotestockcolor.php'),(20788476,2953,'./adminestquotestockcolor.php'),(20788475,2950,'./adminestquotestockcolor.php'),(20788474,2710,'./adminestquotestockcolor.php'),(20788473,2702,'./adminestquotestockcolor.php'),(20788472,1257,'./adminestquotestockcolor.php'),(20788471,1156,'./adminestquotestockcolor.php'),(20788470,1065,'./adminestquotestockcolor.php'),(20788469,550,'./adminestquotestockcolor.php'),(20788468,542,'./adminestquotestockcolor.php'),(20788467,3993,'./adminestquotestockcolor.php'),(20788466,3412,'./adminestquotestdsizeupd.php'),(20788465,3374,'./adminestquotestdsizeupd.php'),(20788464,2928,'./adminestquotestdsizeupd.php'),(20788463,2927,'./adminestquotestdsizeupd.php'),(20788462,2926,'./adminestquotestdsizeupd.php'),(20788461,2904,'./adminestquotestdsizeupd.php'),(20788460,2887,'./adminestquotestdsizeupd.php'),(20788459,2886,'./adminestquotestdsizeupd.php'),(20788458,2710,'./adminestquotestdsizeupd.php'),(20788457,2702,'./adminestquotestdsizeupd.php'),(20788456,1315,'./adminestquotestdsizeupd.php'),(20788455,941,'./adminestquotestdsizeupd.php'),(20788454,854,'./adminestquotestdsizeupd.php'),(20788453,799,'./adminestquotestdsizeupd.php'),(20788452,315,'./adminestquotestdsizeupd.php'),(20788451,5203,'./adminestquotestdsizeupd.php'),(20788450,139,'./adminestquotestdsizeupd.php'),(20788449,3374,'./adminestquotestdsizeadd.php'),(20788448,2925,'./adminestquotestdsizeadd.php'),(20788447,2924,'./adminestquotestdsizeadd.php'),(20788446,2904,'./adminestquotestdsizeadd.php'),(20788445,2702,'./adminestquotestdsizeadd.php'),(20788444,1121,'./adminestquotestdsizeadd.php'),(20788443,315,'./adminestquotestdsizeadd.php'),(20788442,59,'./adminestquotestdsizeadd.php'),(20788441,3225,'./adminestquotespecials.php'),(20788440,13411,'./adminestquotespecials.php'),(20788439,13381,'./adminestquotespecials.php'),(20788438,2710,'./adminestquotespecials.php'),(20788437,2702,'./adminestquotespecials.php'),(20788436,3995,'./adminestquotespecials.php'),(20788435,13189,'./adminestquotespecials.php'),(20788434,13101,'./adminestquotespecialdatesupd.php'),(20788433,3221,'./adminestquotespecialdatesupd.php'),(20788432,13100,'./adminestquotespecialdatesupd.php'),(20788431,2710,'./adminestquotespecialdatesupd.php'),(20788430,2702,'./adminestquotespecialdatesupd.php'),(20788429,13099,'./adminestquotespecialdatesupd.php'),(20788428,5406,'./adminestquotespecialdatesupd.php'),(20788427,869,'./adminestquotespecialdatesupd.php'),(20788426,6566,'./adminestquotespecialdatesupd.php'),(20788425,13098,'./adminestquotespecialdatesupd.php'),(20788424,13097,'./adminestquotespecialdatesupd.php'),(20788423,13101,'./adminestquotesalescampaigns.php'),(20788422,3221,'./adminestquotesalescampaigns.php'),(20788421,2710,'./adminestquotesalescampaigns.php'),(20788420,2702,'./adminestquotesalescampaigns.php'),(20788419,13317,'./adminestquotesalescampaigns.php'),(20788418,13316,'./adminestquotesalescampaigns.php'),(20788417,869,'./adminestquotesalescampaigns.php'),(20788416,6566,'./adminestquotesalescampaigns.php'),(20788415,3036,'./adminestquotequotenotesupd.php'),(20788414,2862,'./adminestquotequotenotesupd.php'),(20788413,2702,'./adminestquotequotenotesupd.php'),(20788412,2555,'./adminestquotequotenotesupd.php'),(20788411,2560,'./adminestquotequotenotesupd.php'),(20788410,2559,'./adminestquotequotenotesupd.php'),(20788409,2558,'./adminestquotequotenotesupd.php'),(20788408,2554,'./adminestquotequotenotesupd.php'),(20788407,2144,'./adminestquotequotenotesupd.php'),(20788406,1917,'./adminestquotequotenotesupd.php'),(20788405,1306,'./adminestquotequotenotesupd.php'),(20788404,1198,'./adminestquotequotenotesupd.php'),(20788403,941,'./adminestquotequotenotesupd.php'),(20788402,902,'./adminestquotequotenotesupd.php'),(20788401,799,'./adminestquotequotenotesupd.php'),(20788400,381,'./adminestquotequotenotesupd.php'),(20788399,225,'./adminestquotequotenotesupd.php'),(20788398,130,'./adminestquotequotenotesupd.php'),(20788397,59,'./adminestquotequotenotesupd.php'),(20788396,3036,'./adminestquotequotenotesadd.php'),(20788395,2862,'./adminestquotequotenotesadd.php'),(20788394,2702,'./adminestquotequotenotesadd.php'),(20788393,2557,'./adminestquotequotenotesadd.php'),(20788392,2556,'./adminestquotequotenotesadd.php'),(20788391,2144,'./adminestquotequotenotesadd.php'),(20788390,1917,'./adminestquotequotenotesadd.php'),(20788389,1103,'./adminestquotequotenotesadd.php'),(20788388,902,'./adminestquotequotenotesadd.php'),(20788387,381,'./adminestquotequotenotesadd.php'),(20788386,315,'./adminestquotequotenotesadd.php'),(20788385,225,'./adminestquotequotenotesadd.php'),(20788384,3156,'./adminestquoteinkupd.php'),(20788383,2949,'./adminestquoteinkupd.php'),(20788382,2913,'./adminestquoteinkupd.php'),(20788381,2806,'./adminestquoteinkupd.php'),(20788380,2710,'./adminestquoteinkupd.php'),(20788379,2702,'./adminestquoteinkupd.php'),(20788378,2448,'./adminestquoteinkupd.php'),(20788377,2447,'./adminestquoteinkupd.php'),(20788376,13355,'./adminestquoteinkupd.php'),(20788375,1935,'./adminestquoteinkupd.php'),(20788374,1762,'./adminestquoteinkupd.php'),(20788373,1620,'./adminestquoteinkupd.php'),(20788372,1619,'./adminestquoteinkupd.php'),(20788371,1617,'./adminestquoteinkupd.php'),(20788370,1614,'./adminestquoteinkupd.php'),(20788369,1610,'./adminestquoteinkupd.php'),(20788368,13354,'./adminestquoteinkupd.php'),(20788367,1473,'./adminestquoteinkupd.php'),(20788366,1274,'./adminestquoteinkupd.php'),(20788365,1171,'./adminestquoteinkupd.php'),(20788364,941,'./adminestquoteinkupd.php'),(20788363,829,'./adminestquoteinkupd.php'),(20788362,799,'./adminestquoteinkupd.php'),(20788361,696,'./adminestquoteinkupd.php'),(20788360,641,'./adminestquoteinkupd.php'),(20788359,618,'./adminestquoteinkupd.php'),(20788358,12742,'./adminestquoteinkupd.php'),(20788357,380,'./adminestquoteinkupd.php'),(20788356,5203,'./adminestquoteinkupd.php'),(20788355,106,'./adminestquoteinkupd.php'),(20788354,59,'./adminestquoteinkupd.php'),(20788353,3156,'./adminestquoteinkadd.php'),(20788352,2949,'./adminestquoteinkadd.php'),(20788351,2913,'./adminestquoteinkadd.php'),(20788350,2806,'./adminestquoteinkadd.php'),(20788349,2702,'./adminestquoteinkadd.php'),(20788348,2448,'./adminestquoteinkadd.php'),(20788347,2447,'./adminestquoteinkadd.php'),(20788346,13355,'./adminestquoteinkadd.php'),(20788345,1935,'./adminestquoteinkadd.php'),(20788344,1612,'./adminestquoteinkadd.php'),(20788343,1611,'./adminestquoteinkadd.php'),(20788342,13354,'./adminestquoteinkadd.php'),(20788341,1473,'./adminestquoteinkadd.php'),(20788340,1087,'./adminestquoteinkadd.php'),(20788339,696,'./adminestquoteinkadd.php'),(20788338,641,'./adminestquoteinkadd.php'),(20788337,618,'./adminestquoteinkadd.php'),(20788336,12742,'./adminestquoteinkadd.php'),(20788335,425,'./adminestquoteinkadd.php'),(20788334,380,'./adminestquoteinkadd.php'),(20788333,2710,'./adminestquotegenink.php'),(20788332,2702,'./adminestquotegenink.php'),(20788331,2310,'./adminestquotegenink.php'),(20788330,1855,'./adminestquotegenink.php'),(20788329,1616,'./adminestquotegenink.php'),(20788328,1615,'./adminestquotegenink.php'),(20788327,1613,'./adminestquotegenink.php'),(20788326,1481,'./adminestquotegenink.php'),(20788325,1275,'./adminestquotegenink.php'),(20788324,1088,'./adminestquotegenink.php'),(20788323,473,'./adminestquotegenink.php'),(20788322,3225,'./adminestquotecovercolors.php'),(20788321,2710,'./adminestquotecovercolors.php'),(20788320,2702,'./adminestquotecovercolors.php'),(20788319,13197,'./adminestquotecovercolors.php'),(20788318,13420,'./adminestquotecovercolors.php'),(20788317,13196,'./adminestquotecovercolors.php'),(20788316,3995,'./adminestquotecovercolors.php'),(20788315,902,'./adminestquotecovercolors.php'),(20788314,13195,'./adminestquotecovercolors.php'),(20788313,13194,'./adminestquotecovercolors.php'),(20788312,13193,'./adminestquotecovercolors.php'),(20788311,13419,'./adminestquotecovercolors.php'),(20788310,13192,'./adminestquotecovercolors.php'),(20788309,13314,'./adminestquotecovercolors.php'),(20788308,13313,'./adminestquotecovercolors.php'),(20788307,13312,'./adminestquotecovercolors.php'),(20788306,13311,'./adminestquotecovercolors.php'),(20788305,13310,'./adminestquotecovercolors.php'),(20788304,13191,'./adminestquotecovercolors.php'),(20788303,13190,'./adminestquotecovercolors.php'),(20788302,13189,'./adminestquotecovercolors.php'),(20788301,13101,'./adminestquote_ordersource.php'),(20788300,3221,'./adminestquote_ordersource.php'),(20788299,2710,'./adminestquote_ordersource.php'),(20788298,2702,'./adminestquote_ordersource.php'),(20788297,13315,'./adminestquote_ordersource.php'),(20788296,869,'./adminestquote_ordersource.php'),(20788295,6566,'./adminestquote_ordersource.php'),(20665297,2902,'./adminestmachineupd.php'),(20665296,2770,'./adminestmachineupd.php'),(20665295,2751,'./adminestmachineupd.php'),(20665294,2710,'./adminestmachineupd.php'),(20665293,1989,'./adminestmachineupd.php'),(20665292,1935,'./adminestmachineupd.php'),(20665291,1827,'./adminestmachineupd.php'),(20665290,1808,'./adminestmachineupd.php'),(20665289,1807,'./adminestmachineupd.php'),(20665288,1806,'./adminestmachineupd.php'),(20665287,1804,'./adminestmachineupd.php'),(20665286,1802,'./adminestmachineupd.php'),(20665285,1799,'./adminestmachineupd.php'),(20665284,1490,'./adminestmachineupd.php'),(20665283,1369,'./adminestmachineupd.php'),(20665282,1286,'./adminestmachineupd.php'),(20665281,1178,'./adminestmachineupd.php'),(20665280,833,'./adminestmachineupd.php'),(20665279,639,'./adminestmachineupd.php'),(20665278,636,'./adminestmachineupd.php'),(20665277,617,'./adminestmachineupd.php'),(20665276,315,'./adminestmachineupd.php'),(20665275,5203,'./adminestmachineupd.php'),(20665274,114,'./adminestmachineupd.php'),(20665273,2902,'./adminestmachineadd.php'),(20665272,2770,'./adminestmachineadd.php'),(20665271,1989,'./adminestmachineadd.php'),(20665270,1935,'./adminestmachineadd.php'),(20665269,1827,'./adminestmachineadd.php'),(20665268,1805,'./adminestmachineadd.php'),(20665267,1804,'./adminestmachineadd.php'),(20665266,1801,'./adminestmachineadd.php'),(20665265,1800,'./adminestmachineadd.php'),(20665264,1490,'./adminestmachineadd.php'),(20665263,1369,'./adminestmachineadd.php'),(20665262,1097,'./adminestmachineadd.php'),(20665261,639,'./adminestmachineadd.php'),(20665260,636,'./adminestmachineadd.php'),(20665259,617,'./adminestmachineadd.php'),(20665258,59,'./adminestmachineadd.php'),(20665257,3190,'./adminestcostcenterupd.php'),(20665256,2902,'./adminestcostcenterupd.php'),(20665255,2813,'./adminestcostcenterupd.php'),(20665254,2710,'./adminestcostcenterupd.php'),(20665253,2507,'./adminestcostcenterupd.php'),(20665252,2497,'./adminestcostcenterupd.php'),(20665251,2459,'./adminestcostcenterupd.php'),(20665250,2391,'./adminestcostcenterupd.php'),(20665249,2386,'./adminestcostcenterupd.php'),(20665248,2227,'./adminestcostcenterupd.php'),(20665247,1935,'./adminestcostcenterupd.php'),(20665246,1610,'./adminestcostcenterupd.php'),(20665245,1422,'./adminestcostcenterupd.php'),(20665244,1261,'./adminestcostcenterupd.php'),(20665243,1158,'./adminestcostcenterupd.php'),(20665242,966,'./adminestcostcenterupd.php'),(20665241,825,'./adminestcostcenterupd.php'),(20665240,633,'./adminestcostcenterupd.php'),(20665239,632,'./adminestcostcenterupd.php'),(20665238,631,'./adminestcostcenterupd.php'),(20665237,630,'./adminestcostcenterupd.php'),(20665236,622,'./adminestcostcenterupd.php'),(20665235,619,'./adminestcostcenterupd.php'),(20665234,315,'./adminestcostcenterupd.php'),(20665233,96,'./adminestcostcenterupd.php'),(20665232,2902,'./adminestcostcentersubtypeupd.php'),(20665231,2770,'./adminestcostcentersubtypeupd.php'),(20665230,2751,'./adminestcostcentersubtypeupd.php'),(20665229,2710,'./adminestcostcentersubtypeupd.php'),(20665228,1990,'./adminestcostcentersubtypeupd.php'),(20665227,1936,'./adminestcostcentersubtypeupd.php'),(20665226,1262,'./adminestcostcentersubtypeupd.php'),(20665225,1159,'./adminestcostcentersubtypeupd.php'),(20665224,826,'./adminestcostcentersubtypeupd.php'),(20665223,629,'./adminestcostcentersubtypeupd.php'),(20665222,628,'./adminestcostcentersubtypeupd.php'),(20665221,627,'./adminestcostcentersubtypeupd.php'),(20665220,625,'./adminestcostcentersubtypeupd.php'),(20665219,624,'./adminestcostcentersubtypeupd.php'),(20665218,169,'./adminestcostcentersubtypeupd.php'),(20665217,115,'./adminestcostcentersubtypeupd.php'),(20665216,2902,'./adminestcostcentersubtypeadd.php'),(20665215,2770,'./adminestcostcentersubtypeadd.php'),(20665214,1990,'./adminestcostcentersubtypeadd.php'),(20665213,1935,'./adminestcostcentersubtypeadd.php'),(20665212,1804,'./adminestcostcentersubtypeadd.php'),(20665211,1069,'./adminestcostcentersubtypeadd.php'),(20665210,626,'./adminestcostcentersubtypeadd.php'),(20665209,623,'./adminestcostcentersubtypeadd.php'),(20665208,315,'./adminestcostcentersubtypeadd.php'),(20665207,59,'./adminestcostcentersubtypeadd.php'),(20665206,2902,'./adminestcostcenteradd.php'),(20665205,2813,'./adminestcostcenteradd.php'),(20665204,2507,'./adminestcostcenteradd.php'),(20665203,2497,'./adminestcostcenteradd.php'),(20665202,2459,'./adminestcostcenteradd.php'),(20665201,2391,'./adminestcostcenteradd.php'),(20665200,2386,'./adminestcostcenteradd.php'),(20665199,2227,'./adminestcostcenteradd.php'),(20665198,1935,'./adminestcostcenteradd.php'),(20665197,1610,'./adminestcostcenteradd.php'),(20665196,1422,'./adminestcostcenteradd.php'),(20665195,1068,'./adminestcostcenteradd.php'),(20665194,631,'./adminestcostcenteradd.php'),(20665193,621,'./adminestcostcenteradd.php'),(20665192,620,'./adminestcostcenteradd.php'),(20665191,59,'./adminestcostcenteradd.php'),(20788294,13950,'./adminemailtemplates.php'),(20788293,13949,'./adminemailtemplates.php'),(20788292,11382,'./adminemailtemplates.php'),(20788291,13948,'./adminemailtemplates.php'),(20788290,3477,'./adminemailtemplates.php'),(20788289,13947,'./adminemailtemplates.php'),(20788288,2710,'./adminemailtemplates.php'),(20788287,2702,'./adminemailtemplates.php'),(20788286,11381,'./adminemailtemplates.php'),(20788285,11380,'./adminemailtemplates.php'),(20788284,11379,'./adminemailtemplates.php'),(20788283,11378,'./adminemailtemplates.php'),(20788282,2044,'./adminemailtemplates.php'),(20788281,15894,'./adminemailtemplates.php'),(20788280,15893,'./adminemailtemplates.php'),(20788279,15866,'./adminemailtemplates.php'),(20788278,7972,'./adminemailtemplates.php'),(20788277,6911,'./adminemailtemplates.php'),(20788276,11377,'./adminemailtemplates.php'),(20788275,8936,'./adminemailtemplates.php'),(20788274,941,'./adminemailtemplates.php'),(20788273,11477,'./adminemailtemplates.php'),(20788272,9545,'./adminemailtemplates.php'),(20788271,799,'./adminemailtemplates.php'),(20788270,542,'./adminemailtemplates.php'),(20788269,11370,'./adminemailtemplates.php'),(20788268,315,'./adminemailtemplates.php'),(20788267,11476,'./adminemailtemplates.php'),(20788266,5203,'./adminemailtemplates.php'),(20788265,11475,'./adminemailtemplates.php'),(20788264,13946,'./adminemailtemplates.php'),(20788263,59,'./adminemailtemplates.php'),(20788262,3480,'./adminemailpicker.php'),(20788261,3479,'./adminemailpicker.php'),(20788260,3478,'./adminemailpicker.php'),(20788259,3090,'./adminemailpicker.php'),(20788258,3072,'./adminemailpicker.php'),(20788257,3476,'./adminemailpicker.php'),(20788256,3475,'./adminemailpicker.php'),(20788255,3474,'./adminemailpicker.php'),(20788254,3473,'./adminemailpicker.php'),(20788253,3471,'./adminemailpicker.php'),(20788252,2223,'./adminemailpicker.php'),(20788251,3470,'./adminemailpicker.php'),(20788250,2008,'./adminemailpicker.php'),(20788249,1963,'./adminemailpicker.php'),(20788248,1935,'./adminemailpicker.php'),(20788247,3469,'./adminemailpicker.php'),(20788246,1598,'./adminemailpicker.php'),(20788245,3468,'./adminemailpicker.php'),(20788244,3467,'./adminemailpicker.php'),(20788243,3464,'./adminemailpicker.php'),(20788242,981,'./adminemailpicker.php'),(20788241,3460,'./adminemailpicker.php'),(20788240,3458,'./adminemailpicker.php'),(20788239,3459,'./adminemailpicker.php'),(20788238,3457,'./adminemailpicker.php'),(20788237,3456,'./adminemailpicker.php'),(20788236,315,'./adminemailpicker.php'),(20788235,3454,'./adminemailpicker.php'),(20788234,197,'./adminemailpicker.php'),(20788233,14581,'./adminemailpicker.php'),(20788232,3072,'./adminemail.php'),(20788231,9227,'./adminemail.php'),(20788230,9226,'./adminemail.php'),(20788229,9225,'./adminemail.php'),(20788228,3477,'./adminemail.php'),(20788227,9252,'./adminemail.php'),(20788226,2788,'./adminemail.php'),(20788225,11761,'./adminemail.php'),(20788224,13903,'./adminemail.php'),(20788223,4137,'./adminemail.php'),(20788222,4136,'./adminemail.php'),(20788221,13828,'./adminemail.php'),(20788220,15361,'./adminemail.php'),(20788219,9249,'./adminemail.php'),(20788218,1935,'./adminemail.php'),(20788217,11772,'./adminemail.php'),(20788216,1880,'./adminemail.php'),(20788215,9248,'./adminemail.php'),(20788214,1467,'./adminemail.php'),(20788213,13807,'./adminemail.php'),(20788212,9930,'./adminemail.php'),(20788211,3465,'./adminemail.php'),(20788210,3463,'./adminemail.php'),(20788209,3461,'./adminemail.php'),(20788208,9224,'./adminemail.php'),(20788207,981,'./adminemail.php'),(20788206,15225,'./adminemail.php'),(20788205,18941,'./adminemail.php'),(20788204,13880,'./adminemail.php'),(20788203,3457,'./adminemail.php'),(20788197,3252,'./admineftrpt.php'),(20788196,3156,'./admineftrpt.php'),(20788195,14185,'./admineftrpt.php'),(20788194,2795,'./admineftrpt.php'),(20788193,5366,'./admineftrpt.php'),(20788192,14184,'./admineftrpt.php'),(20788191,17103,'./admineftrpt.php'),(20788190,1963,'./admineftrpt.php'),(20788189,14183,'./admineftrpt.php'),(20788188,8936,'./admineftrpt.php'),(20788187,1036,'./admineftrpt.php'),(20788186,1014,'./admineftrpt.php'),(20788185,14490,'./admineftrpt.php'),(20788184,981,'./admineftrpt.php'),(20788183,14182,'./admineftrpt.php'),(20788182,5407,'./admineftrpt.php'),(20788181,776,'./admineftrpt.php'),(20788180,670,'./admineftrpt.php'),(20788179,333,'./admineftrpt.php'),(20788178,315,'./admineftrpt.php'),(20708044,2710,'./admindocmgmtcatupd.php'),(20708043,2702,'./admindocmgmtcatupd.php'),(20708042,2163,'./admindocmgmtcatupd.php'),(20708041,966,'./admindocmgmtcatupd.php'),(20708040,941,'./admindocmgmtcatupd.php'),(20708039,914,'./admindocmgmtcatupd.php'),(20708038,913,'./admindocmgmtcatupd.php'),(20708037,823,'./admindocmgmtcatupd.php'),(20708036,799,'./admindocmgmtcatupd.php'),(20708035,460,'./admindocmgmtcatupd.php'),(20708034,458,'./admindocmgmtcatupd.php'),(20708033,457,'./admindocmgmtcatupd.php'),(20708032,455,'./admindocmgmtcatupd.php'),(20708031,453,'./admindocmgmtcatupd.php'),(20708030,452,'./admindocmgmtcatupd.php'),(20708029,319,'./admindocmgmtcatupd.php'),(20708028,315,'./admindocmgmtcatupd.php'),(20708027,5203,'./admindocmgmtcatupd.php'),(20708026,93,'./admindocmgmtcatupd.php'),(20708025,59,'./admindocmgmtcatupd.php'),(20708024,1067,'./admindocmgmtcatadd.php'),(20708023,913,'./admindocmgmtcatadd.php'),(20708022,457,'./admindocmgmtcatadd.php'),(20708021,452,'./admindocmgmtcatadd.php'),(20708020,315,'./admindocmgmtcatadd.php'),(20708019,93,'./admindocmgmtcatadd.php'),(20708018,59,'./admindocmgmtcatadd.php'),(20788173,17404,'./admindoccenter.php'),(20788172,17403,'./admindoccenter.php'),(20788171,17402,'./admindoccenter.php'),(20788170,17401,'./admindoccenter.php'),(20788169,14356,'./admindoccenter.php'),(20788168,3706,'./admindoccenter.php'),(20788167,14355,'./admindoccenter.php'),(20788166,13827,'./admindoccenter.php'),(20788161,9491,'./admindeletionrpt.php'),(20788160,3274,'./admindeletionrpt.php'),(20788159,2540,'./admindeletionrpt.php'),(20788158,2501,'./admindeletionrpt.php'),(20788157,2165,'./admindeletionrpt.php'),(20788156,1963,'./admindeletionrpt.php'),(20788155,7275,'./admindeletionrpt.php'),(20788154,1668,'./admindeletionrpt.php'),(20788153,14763,'./admindeletionrpt.php'),(20788152,8936,'./admindeletionrpt.php'),(20788151,1036,'./admindeletionrpt.php'),(20788150,14762,'./admindeletionrpt.php'),(20788149,14761,'./admindeletionrpt.php'),(20788148,10455,'./admindeletionrpt.php'),(20788147,10454,'./admindeletionrpt.php'),(20788146,697,'./admindeletionrpt.php'),(20788145,451,'./admindeletionrpt.php'),(20788144,15168,'./admindeletionrpt.php'),(20788143,10453,'./admindeletionrpt.php'),(20788142,7529,'./admindeletionrpt.php'),(20788141,315,'./admindeletionrpt.php'),(20788140,9417,'./admincurrencyrates.php'),(20788139,12181,'./admincurrencyrates.php'),(20788138,9416,'./admincurrencyrates.php'),(20788137,2702,'./admincurrencyrates.php'),(20788136,2565,'./admincurrencyrates.php'),(20788135,1963,'./admincurrencyrates.php'),(20788134,9415,'./admincurrencyrates.php'),(20788133,1467,'./admincurrencyrates.php'),(20788132,8936,'./admincurrencyrates.php'),(20788131,1014,'./admincurrencyrates.php'),(20788130,737,'./admincurrencyrates.php'),(20788129,9414,'./admincurrencyrates.php'),(20788128,9413,'./admincurrencyrates.php'),(20788127,333,'./admincurrencyrates.php'),(20788126,9412,'./admincurrencyedit.php'),(20788125,6361,'./admincurrencyedit.php'),(20788124,9355,'./admincurrencyedit.php'),(20788123,11899,'./admincurrencyedit.php'),(20788122,12774,'./admincurrencyedit.php'),(20788121,9354,'./admincurrencyedit.php'),(20788120,9402,'./admincurrencyedit.php'),(20788119,12773,'./admincurrencyedit.php'),(20788118,9353,'./admincurrencyedit.php'),(20788117,9352,'./admincurrencyedit.php'),(20788116,2710,'./admincurrencyedit.php'),(20788115,2702,'./admincurrencyedit.php'),(20788114,1935,'./admincurrencyedit.php'),(20788113,12772,'./admincurrencyedit.php'),(20788112,9351,'./admincurrencyedit.php'),(20788111,9350,'./admincurrencyedit.php'),(20788110,8936,'./admincurrencyedit.php'),(20788109,9349,'./admincurrencyedit.php'),(20788108,9348,'./admincurrencyedit.php'),(20788107,966,'./admincurrencyedit.php'),(20788106,941,'./admincurrencyedit.php'),(20788105,799,'./admincurrencyedit.php'),(20788104,9401,'./admincurrencyedit.php'),(20788103,9347,'./admincurrencyedit.php'),(20788102,9346,'./admincurrencyedit.php'),(20788101,9411,'./admincurrencyedit.php'),(20788100,9345,'./admincurrencyedit.php'),(20788099,9344,'./admincurrencyedit.php'),(20788098,9343,'./admincurrencyedit.php'),(20788097,9342,'./admincurrencyedit.php'),(20788096,9341,'./admincurrencyedit.php'),(20788095,548,'./admincurrencyedit.php'),(20788094,541,'./admincurrencyedit.php'),(20788093,9340,'./admincurrencyedit.php'),(20788092,315,'./admincurrencyedit.php'),(20788091,9339,'./admincurrencyedit.php'),(20788090,9338,'./admincurrencyedit.php'),(20788089,59,'./admincurrencyedit.php'),(20788088,55,'./admincurrencyedit.php'),(20788087,8936,'./adminccsetup.php'),(20788086,13052,'./adminccsetup.php'),(20788085,7863,'./adminccsetup.php'),(20788084,542,'./adminccsetup.php'),(20788083,7112,'./adminccsetup.php'),(20788082,8047,'./adminbing.php'),(20788081,3252,'./adminbatchrpt.php'),(20788080,3450,'./adminbatchrpt.php'),(20788079,14873,'./adminbatchrpt.php'),(20788078,14279,'./adminbatchrpt.php'),(20788077,14872,'./adminbatchrpt.php'),(20788076,14871,'./adminbatchrpt.php'),(20788075,2044,'./adminbatchrpt.php'),(20788074,14870,'./adminbatchrpt.php'),(20788073,2103,'./adminbatchrpt.php'),(20788072,1963,'./adminbatchrpt.php'),(20788071,14869,'./adminbatchrpt.php'),(20788070,14868,'./adminbatchrpt.php'),(20788069,1668,'./adminbatchrpt.php'),(20788068,14867,'./adminbatchrpt.php'),(20788067,14763,'./adminbatchrpt.php'),(20788066,14866,'./adminbatchrpt.php'),(20788065,14865,'./adminbatchrpt.php'),(20788064,14864,'./adminbatchrpt.php'),(20788063,6166,'./adminbatchrpt.php'),(20788062,1353,'./adminbatchrpt.php'),(20788061,8936,'./adminbatchrpt.php'),(20788060,14863,'./adminbatchrpt.php'),(20788059,573,'./adminbatchrpt.php'),(20788058,14987,'./adminbatchrpt.php'),(20788057,14862,'./adminbatchrpt.php'),(20788056,14861,'./adminbatchrpt.php'),(20788055,11801,'./adminbatchrpt.php'),(20788054,14860,'./adminbatchrpt.php'),(20788053,14859,'./adminbatchrpt.php'),(20788052,13295,'./adminbatchrpt.php'),(20788051,226,'./adminbatchrpt.php'),(20788050,197,'./adminbatchrpt.php'),(20788049,3373,'./adminbarcode.php'),(20788048,14354,'./adminbarcode.php'),(20788047,14353,'./adminbarcode.php'),(20788046,11726,'./adminbarcode.php'),(20788045,11794,'./adminbarcode.php'),(20788044,11725,'./adminbarcode.php'),(20788043,11724,'./adminbarcode.php'),(20788042,11809,'./adminbarcode.php'),(20788041,11723,'./adminbarcode.php'),(20788040,2710,'./adminbarcode.php'),(20788039,2702,'./adminbarcode.php'),(20788038,14352,'./adminbarcode.php'),(20788037,2405,'./adminbarcode.php'),(20788036,14351,'./adminbarcode.php'),(20788035,11808,'./adminbarcode.php'),(20788034,1963,'./adminbarcode.php'),(20788033,11722,'./adminbarcode.php'),(20788032,11721,'./adminbarcode.php'),(20788031,11795,'./adminbarcode.php'),(20788030,11719,'./adminbarcode.php'),(20788029,6079,'./adminbarcode.php'),(20788028,1476,'./adminbarcode.php'),(20788027,11718,'./adminbarcode.php'),(20788026,11717,'./adminbarcode.php'),(20788025,11716,'./adminbarcode.php'),(20788024,11715,'./adminbarcode.php'),(20788023,11714,'./adminbarcode.php'),(20788022,11713,'./adminbarcode.php'),(20788021,11712,'./adminbarcode.php'),(20788020,6565,'./adminbarcode.php'),(20788019,11807,'./adminbarcode.php'),(20788018,13994,'./adminbarcode.php'),(20788017,11796,'./adminbarcode.php'),(20788016,11711,'./adminbarcode.php'),(20788015,11727,'./adminbarcode.php'),(20788014,315,'./adminbarcode.php'),(20788013,14001,'./adminbarcode.php'),(20788012,11710,'./adminbarcode.php'),(20788011,6419,'./adminb2bsite.php'),(20788010,3225,'./adminartaxgroupsupd.php'),(20788009,2710,'./adminartaxgroupsupd.php'),(20788008,2702,'./adminartaxgroupsupd.php'),(20788007,6558,'./adminartaxgroupsupd.php'),(20788006,3995,'./adminartaxgroupsupd.php'),(20788005,1143,'./adminartaxgroupsupd.php'),(20788004,966,'./adminartaxgroupsupd.php'),(20788003,941,'./adminartaxgroupsupd.php'),(20788002,869,'./adminartaxgroupsupd.php'),(20788001,6561,'./adminartaxgroupsupd.php'),(20788000,864,'./adminartaxgroupsupd.php'),(20787999,799,'./adminartaxgroupsupd.php'),(20787998,7228,'./adminartaxgroupsupd.php'),(20787997,7227,'./adminartaxgroupsupd.php'),(20787996,315,'./adminartaxgroupsupd.php'),(20787995,5203,'./adminartaxgroupsupd.php'),(20787994,6560,'./adminartaxgroupsupd.php'),(20787993,59,'./adminartaxgroupsupd.php'),(20787992,2710,'./adminartaxgroupsadd.php'),(20787991,2702,'./adminartaxgroupsadd.php'),(20787990,6558,'./adminartaxgroupsadd.php'),(20787989,3994,'./adminartaxgroupsadd.php'),(20787988,7226,'./adminartaxgroupsadd.php'),(20787987,542,'./adminartaxgroupsadd.php'),(20787986,315,'./adminartaxgroupsadd.php'),(20787985,222,'./adminartaxgroupsadd.php'),(20787984,176,'./adminartaxgroupsadd.php'),(20787983,16643,'./adminartaxexupd.php'),(20787982,3011,'./adminartaxexupd.php'),(20787981,3010,'./adminartaxexupd.php'),(20787980,2936,'./adminartaxexupd.php'),(20787979,2710,'./adminartaxexupd.php'),(20787978,2702,'./adminartaxexupd.php'),(20787977,18616,'./adminartaxexupd.php'),(20787976,16642,'./adminartaxexupd.php'),(20787975,2044,'./adminartaxexupd.php'),(20787974,18767,'./adminartaxexupd.php'),(20787973,18206,'./adminartaxexupd.php'),(20793874,20235,'./aritemsaleshistory.php'),(20787972,966,'./adminartaxexupd.php'),(20787962,16643,'./adminartaxexadd.php'),(20787961,3010,'./adminartaxexadd.php'),(20787960,3006,'./adminartaxexadd.php'),(20787959,2936,'./adminartaxexadd.php'),(20787952,2710,'./adminarsalestaxupd.php'),(20787951,2702,'./adminarsalestaxupd.php'),(20787950,2693,'./adminarsalestaxupd.php'),(20787949,7706,'./adminarsalestaxupd.php'),(20787948,850,'./adminarsalestaxupd.php'),(20787947,799,'./adminarsalestaxupd.php'),(20787946,7225,'./adminarsalestaxupd.php'),(20787945,315,'./adminarsalestaxupd.php'),(20787944,5203,'./adminarsalestaxupd.php'),(20787943,137,'./adminarsalestaxupd.php'),(20787942,59,'./adminarsalestaxupd.php'),(20787941,2710,'./adminarsalestaxadd.php'),(20787940,2702,'./adminarsalestaxadd.php'),(20787939,2688,'./adminarsalestaxadd.php'),(20787938,2687,'./adminarsalestaxadd.php'),(20787937,13287,'./adminarsalestaxadd.php'),(20787936,6605,'./adminarsalestaxadd.php'),(20787935,542,'./adminarsalestaxadd.php'),(20787933,2710,'./adminarsalesmanupd.php'),(20787932,2702,'./adminarsalesmanupd.php'),(20787931,966,'./adminarsalesmanupd.php'),(20787930,11847,'./adminarsalesmanupd.php'),(20787929,941,'./adminarsalesmanupd.php'),(20787928,851,'./adminarsalesmanupd.php'),(20787927,799,'./adminarsalesmanupd.php'),(20787926,542,'./adminarsalesmanupd.php'),(20787925,315,'./adminarsalesmanupd.php'),(20787924,5203,'./adminarsalesmanupd.php'),(20787923,135,'./adminarsalesmanupd.php'),(20787922,59,'./adminarsalesmanupd.php'),(20787921,2702,'./adminarsalesmanadd.php'),(20787920,542,'./adminarsalesmanadd.php'),(20787919,315,'./adminarsalesmanadd.php'),(20787918,12043,'./adminarsalesmanadd.php'),(20787917,11983,'./adminarsalesmanadd.php'),(20787916,18264,'./adminarsales_categoryadd.php'),(20787915,3225,'./adminarsales_categoryadd.php'),(20787914,2710,'./adminarsales_categoryadd.php'),(20787913,2702,'./adminarsales_categoryadd.php'),(20787912,5977,'./adminarsales_categoryadd.php'),(20787911,3961,'./adminarsales_categoryadd.php'),(20787910,3995,'./adminarsales_categoryadd.php'),(20787909,19648,'./adminarsales_categoryadd.php'),(20787904,18264,'./adminarsales_category.php'),(20787903,3225,'./adminarsales_category.php'),(20787902,2710,'./adminarsales_category.php'),(20787901,2702,'./adminarsales_category.php'),(20787900,5976,'./adminarsales_category.php'),(20787899,3961,'./adminarsales_category.php'),(20787898,2044,'./adminarsales_category.php'),(20787897,3995,'./adminarsales_category.php'),(20787896,1143,'./adminarsales_category.php'),(20787895,941,'./adminarsales_category.php'),(20787894,864,'./adminarsales_category.php'),(20787893,799,'./adminarsales_category.php'),(20787892,19648,'./adminarsales_category.php'),(20787891,19647,'./adminarsales_category.php'),(20787890,19646,'./adminarsales_category.php'),(20787889,14858,'./adminarsales_category.php'),(20787884,2710,'./adminarquotecomupd.php'),(20787883,2702,'./adminarquotecomupd.php'),(20787882,2548,'./adminarquotecomupd.php'),(20787881,966,'./adminarquotecomupd.php'),(20787880,941,'./adminarquotecomupd.php'),(20787879,847,'./adminarquotecomupd.php'),(20787878,808,'./adminarquotecomupd.php'),(20787877,799,'./adminarquotecomupd.php'),(20787876,315,'./adminarquotecomupd.php'),(20787875,5203,'./adminarquotecomupd.php'),(20787874,129,'./adminarquotecomupd.php'),(20787873,59,'./adminarquotecomupd.php'),(20787872,2710,'./adminarquotecomadd.php'),(20787871,2702,'./adminarquotecomadd.php'),(20787870,2545,'./adminarquotecomadd.php'),(20787869,2544,'./adminarquotecomadd.php'),(20787868,2543,'./adminarquotecomadd.php'),(20787867,542,'./adminarquotecomadd.php'),(20787866,315,'./adminarquotecomadd.php'),(20787865,3221,'./adminarpostaxupd.php'),(20787864,10470,'./adminarpostaxupd.php'),(20787863,5990,'./adminarpostaxupd.php'),(20787862,2710,'./adminarpostaxupd.php'),(20787861,2702,'./adminarpostaxupd.php'),(20787860,2686,'./adminarpostaxupd.php'),(20787859,10471,'./adminarpostaxupd.php'),(20787858,2094,'./adminarpostaxupd.php'),(20787857,1788,'./adminarpostaxupd.php'),(20787856,3995,'./adminarpostaxupd.php'),(20787855,1143,'./adminarpostaxupd.php'),(20787854,966,'./adminarpostaxupd.php'),(20787853,941,'./adminarpostaxupd.php'),(20787852,850,'./adminarpostaxupd.php'),(20787851,799,'./adminarpostaxupd.php'),(20787850,315,'./adminarpostaxupd.php'),(20787849,5203,'./adminarpostaxupd.php'),(20787848,6466,'./adminarpostaxupd.php'),(20787847,59,'./adminarpostaxupd.php'),(20787846,3221,'./adminarpostaxadd.php'),(20787845,10470,'./adminarpostaxadd.php'),(20787844,2710,'./adminarpostaxadd.php'),(20787843,2702,'./adminarpostaxadd.php'),(20787842,2686,'./adminarpostaxadd.php'),(20787841,10469,'./adminarpostaxadd.php'),(20787840,1788,'./adminarpostaxadd.php'),(20787839,542,'./adminarpostaxadd.php'),(20787838,315,'./adminarpostaxadd.php'),(20787837,7926,'./adminarordstatusupd.php'),(20787836,2710,'./adminarordstatusupd.php'),(20787835,2702,'./adminarordstatusupd.php'),(20787834,966,'./adminarordstatusupd.php'),(20787833,941,'./adminarordstatusupd.php'),(20787832,6037,'./adminarordstatusupd.php'),(20787831,799,'./adminarordstatusupd.php'),(20787830,315,'./adminarordstatusupd.php'),(20787829,5203,'./adminarordstatusupd.php'),(20787828,6036,'./adminarordstatusupd.php'),(20787827,59,'./adminarordstatusupd.php'),(20787826,7926,'./adminarordstatusadd.php'),(20787825,2710,'./adminarordstatusadd.php'),(20787824,2702,'./adminarordstatusadd.php'),(20787823,315,'./adminarordstatusadd.php'),(20787822,2710,'./adminarinvtermsupd.php'),(20787821,2702,'./adminarinvtermsupd.php'),(20787820,11926,'./adminarinvtermsupd.php'),(20787819,1690,'./adminarinvtermsupd.php'),(20787818,966,'./adminarinvtermsupd.php'),(20787817,941,'./adminarinvtermsupd.php'),(20787816,808,'./adminarinvtermsupd.php'),(20787815,799,'./adminarinvtermsupd.php'),(20787814,315,'./adminarinvtermsupd.php'),(20787813,5203,'./adminarinvtermsupd.php'),(20787812,109,'./adminarinvtermsupd.php'),(20787810,2710,'./adminarinvtermsadd.php'),(20787809,2702,'./adminarinvtermsadd.php'),(20787808,11926,'./adminarinvtermsadd.php'),(20787807,1686,'./adminarinvtermsadd.php'),(20787806,542,'./adminarinvtermsadd.php'),(20787804,12882,'./adminarinvoicetext.php'),(20787803,3202,'./adminarinvoicetext.php'),(20787802,3225,'./adminarinvoicetext.php'),(20787801,13062,'./adminarinvoicetext.php'),(20787800,12881,'./adminarinvoicetext.php'),(20787799,12880,'./adminarinvoicetext.php'),(20787798,12879,'./adminarinvoicetext.php'),(20787797,12878,'./adminarinvoicetext.php'),(20787796,12925,'./adminarinvoicetext.php'),(20787795,2710,'./adminarinvoicetext.php'),(20787794,2702,'./adminarinvoicetext.php'),(20787793,12877,'./adminarinvoicetext.php'),(20787792,3225,'./adminargroupsupd.php'),(20787791,2710,'./adminargroupsupd.php'),(20787790,2702,'./adminargroupsupd.php'),(20787789,12797,'./adminargroupsupd.php'),(20787788,6558,'./adminargroupsupd.php'),(20787787,3995,'./adminargroupsupd.php'),(20787786,1143,'./adminargroupsupd.php'),(20787785,966,'./adminargroupsupd.php'),(20787784,941,'./adminargroupsupd.php'),(20787783,869,'./adminargroupsupd.php'),(20787782,6561,'./adminargroupsupd.php'),(20787781,864,'./adminargroupsupd.php'),(20787780,799,'./adminargroupsupd.php'),(20787779,6603,'./adminargroupsupd.php'),(20787778,6602,'./adminargroupsupd.php'),(20787777,315,'./adminargroupsupd.php'),(20787776,5203,'./adminargroupsupd.php'),(20787775,6560,'./adminargroupsupd.php'),(20787774,59,'./adminargroupsupd.php'),(20787773,2710,'./adminargroupsadd.php'),(20787772,2702,'./adminargroupsadd.php'),(20787771,12797,'./adminargroupsadd.php'),(20787770,6558,'./adminargroupsadd.php'),(20787769,3994,'./adminargroupsadd.php'),(20787768,869,'./adminargroupsadd.php'),(20787767,6601,'./adminargroupsadd.php'),(20787766,542,'./adminargroupsadd.php'),(20787765,315,'./adminargroupsadd.php'),(20787764,222,'./adminargroupsadd.php'),(20787763,176,'./adminargroupsadd.php'),(20787762,19877,'./adminarglacct.php'),(20787761,2950,'./adminarglacct.php'),(20787760,2837,'./adminarglacct.php'),(20787759,5627,'./adminarglacct.php'),(20787758,2710,'./adminarglacct.php'),(20787757,8508,'./adminarglacct.php'),(20787756,2702,'./adminarglacct.php'),(20787755,5688,'./adminarglacct.php'),(20787754,6600,'./adminarglacct.php'),(20787753,2586,'./adminarglacct.php'),(20787752,13806,'./adminarglacct.php'),(20787751,18263,'./adminarglacct.php'),(20787750,16669,'./adminarglacct.php'),(20787749,6599,'./adminarglacct.php'),(20787748,1639,'./adminarglacct.php'),(20787747,1628,'./adminarglacct.php'),(20787746,12177,'./adminarglacct.php'),(20787745,896,'./adminarglacct.php'),(20787744,10921,'./adminarglacct.php'),(20787743,17738,'./adminarglacct.php'),(20787742,18614,'./adminarglacct.php'),(20787741,5661,'./adminarglacct.php'),(20664603,5958,'./adminarcompanyupd_docbook.php'),(20664602,5956,'./adminarcompanyupd_docbook.php'),(20791763,16261,'./arcustb2buser.php'),(20791762,981,'./arcustb2buser.php'),(20791761,965,'./arcustb2buser.php'),(20791760,941,'./arcustb2buser.php'),(20791759,6421,'./arcustb2buser.php'),(20791758,807,'./arcustb2buser.php'),(20791757,864,'./arcustb2buser.php'),(20791756,799,'./arcustb2buser.php'),(20791755,716,'./arcustb2buser.php'),(20791754,4481,'./arcustb2buser.php'),(20791753,697,'./arcustb2buser.php'),(20787731,3421,'./adminarcompanyupd.php'),(20787730,15891,'./adminarcompanyupd.php'),(20787729,13567,'./adminarcompanyupd.php'),(20787728,3376,'./adminarcompanyupd.php'),(20787727,20074,'./adminarcompanyupd.php'),(20787726,12718,'./adminarcompanyupd.php'),(20787725,17742,'./adminarcompanyupd.php'),(20787724,14771,'./adminarcompanyupd.php'),(20787723,8470,'./adminarcompanyupd.php'),(20787722,15604,'./adminarcompanyupd.php'),(20787721,19764,'./adminarcompanyupd.php'),(20787720,15327,'./adminarcompanyupd.php'),(20787719,19418,'./adminarcompanyupd.php'),(20787718,19244,'./adminarcompanyupd.php'),(20787717,19243,'./adminarcompanyupd.php'),(20787716,13945,'./adminarcompanyupd.php'),(20787715,16260,'./adminarcompanyupd.php'),(20787714,18939,'./adminarcompanyupd.php'),(20787713,19845,'./adminarcompanyupd.php'),(20787712,6598,'./adminarcompanyupd.php'),(20787711,5662,'./adminarcompanyupd.php'),(20787710,14667,'./adminarcompanyupd.php'),(20787709,3056,'./adminarcompanyupd.php'),(20787708,18261,'./adminarcompanyupd.php'),(20787707,5568,'./adminarcompanyupd.php'),(20787706,5625,'./adminarcompanyupd.php'),(20787705,16641,'./adminarcompanyupd.php'),(20787704,2950,'./adminarcompanyupd.php'),(20787703,15360,'./adminarcompanyupd.php'),(20787702,15359,'./adminarcompanyupd.php'),(20787701,19242,'./adminarcompanyupd.php'),(20787700,6243,'./adminarcompanyupd.php'),(20787699,5567,'./adminarcompanyupd.php'),(20787698,6596,'./adminarcompanyupd.php'),(20787697,6944,'./adminarcompanyupd.php'),(20787696,15167,'./adminarcompanyupd.php'),(20787695,19763,'./adminarcompanyupd.php'),(20787694,8162,'./adminarcompanyupd.php'),(20787693,17592,'./adminarcompanyupd.php'),(20787692,14770,'./adminarcompanyupd.php'),(20787691,14128,'./adminarcompanyupd.php'),(20787690,6595,'./adminarcompanyupd.php'),(20787689,13657,'./adminarcompanyupd.php'),(20787688,19417,'./adminarcompanyupd.php'),(20787687,19762,'./adminarcompanyupd.php'),(20787686,19761,'./adminarcompanyupd.php'),(20787685,15195,'./adminarcompanyupd.php'),(20787684,18613,'./adminarcompanyupd.php'),(20787683,15387,'./adminarcompanyupd.php'),(20787682,14129,'./adminarcompanyupd.php'),(20787681,6594,'./adminarcompanyupd.php'),(20787680,8182,'./adminarcompanyupd.php'),(20787679,19760,'./adminarcompanyupd.php'),(20787678,14142,'./adminarcompanyupd.php'),(20787677,14112,'./adminarcompanyupd.php'),(20787676,19102,'./adminarcompanyupd.php'),(20787675,19416,'./adminarcompanyupd.php'),(20787674,13944,'./adminarcompanyupd.php'),(20787673,9518,'./adminarcompanyupd.php'),(20787672,15166,'./adminarcompanyupd.php'),(20787671,19415,'./adminarcompanyupd.php'),(20787670,14110,'./adminarcompanyupd.php'),(20787669,20233,'./adminarcompanyupd.php'),(20787668,15326,'./adminarcompanyupd.php'),(20787667,13656,'./adminarcompanyupd.php'),(20787666,8766,'./adminarcompanyupd.php'),(20787665,14799,'./adminarcompanyupd.php'),(20787664,19306,'./adminarcompanyupd.php'),(20787663,18766,'./adminarcompanyupd.php'),(20787662,20232,'./adminarcompanyupd.php'),(20787661,18612,'./adminarcompanyupd.php'),(20787660,15890,'./adminarcompanyupd.php'),(20787659,14037,'./adminarcompanyupd.php'),(20787658,19241,'./adminarcompanyupd.php'),(20787657,13061,'./adminarcompanyupd.php'),(20787656,13060,'./adminarcompanyupd.php'),(20787655,14100,'./adminarcompanyupd.php'),(20787654,15627,'./adminarcompanyupd.php'),(20787653,20231,'./adminarcompanyupd.php'),(20787652,15626,'./adminarcompanyupd.php'),(20787651,15537,'./adminarcompanyupd.php'),(20787650,13059,'./adminarcompanyupd.php'),(20787649,14084,'./adminarcompanyupd.php'),(20787648,15889,'./adminarcompanyupd.php'),(20787647,18611,'./adminarcompanyupd.php'),(20787646,18610,'./adminarcompanyupd.php'),(20787645,15194,'./adminarcompanyupd.php'),(20787644,17999,'./adminarcompanyupd.php'),(20787643,15095,'./adminarcompanyupd.php'),(20787642,20230,'./adminarcompanyupd.php'),(20787641,13655,'./adminarcompanyupd.php'),(20787640,2850,'./adminarcompanyupd.php'),(20787639,20229,'./adminarcompanyupd.php'),(20787638,2849,'./adminarcompanyupd.php'),(20787637,17591,'./adminarcompanyupd.php'),(20787636,14769,'./adminarcompanyupd.php'),(20787635,20180,'./adminarcompanyupd.php'),(20787634,2833,'./adminarcompanyupd.php'),(20787633,20071,'./adminarcompanyupd.php'),(20787632,18825,'./adminarcompanyupd.php'),(20787631,6064,'./adminarcompanyupd.php'),(20787630,13025,'./adminarcompanyupd.php'),(20787629,5488,'./adminarcompanyupd.php'),(20787628,15719,'./adminarcompanyupd.php'),(20787627,20070,'./adminarcompanyupd.php'),(20787626,11806,'./adminarcompanyupd.php'),(20787625,11805,'./adminarcompanyupd.php'),(20787624,20069,'./adminarcompanyupd.php'),(20787623,20068,'./adminarcompanyupd.php'),(20787622,20067,'./adminarcompanyupd.php'),(20787621,17140,'./adminarcompanyupd.php'),(20787620,19505,'./adminarcompanyupd.php'),(20787619,19414,'./adminarcompanyupd.php'),(20787618,17139,'./adminarcompanyupd.php'),(20787617,17463,'./adminarcompanyupd.php'),(20787616,2782,'./adminarcompanyupd.php'),(20787615,2751,'./adminarcompanyupd.php'),(20787614,20066,'./adminarcompanyupd.php'),(20787613,2710,'./adminarcompanyupd.php'),(20787612,2702,'./adminarcompanyupd.php'),(20787611,15285,'./adminarcompanyupd.php'),(20787610,14000,'./adminarcompanyupd.php'),(20787609,9517,'./adminarcompanyupd.php'),(20787608,19240,'./adminarcompanyupd.php'),(20787607,14789,'./adminarcompanyupd.php'),(20787606,19474,'./adminarcompanyupd.php'),(20787605,19239,'./adminarcompanyupd.php'),(20787604,11790,'./adminarcompanyupd.php'),(20787603,11789,'./adminarcompanyupd.php'),(20787602,14265,'./adminarcompanyupd.php'),(20787601,19844,'./adminarcompanyupd.php'),(20787600,18765,'./adminarcompanyupd.php'),(20787599,17998,'./adminarcompanyupd.php'),(20787598,17917,'./adminarcompanyupd.php'),(20787597,19238,'./adminarcompanyupd.php'),(20787596,5693,'./adminarcompanyupd.php'),(20787595,15325,'./adminarcompanyupd.php'),(20787594,18764,'./adminarcompanyupd.php'),(20787593,13980,'./adminarcompanyupd.php'),(20787592,4857,'./adminarcompanyupd.php'),(20787591,13150,'./adminarcompanyupd.php'),(20787590,13149,'./adminarcompanyupd.php'),(20787589,20228,'./adminarcompanyupd.php'),(20787588,20227,'./adminarcompanyupd.php'),(20787587,16083,'./adminarcompanyupd.php'),(20787586,18846,'./adminarcompanyupd.php'),(20787585,6428,'./adminarcompanyupd.php'),(20787584,11705,'./adminarcompanyupd.php'),(20787583,16147,'./adminarcompanyupd.php'),(20787582,17997,'./adminarcompanyupd.php'),(20787581,9612,'./adminarcompanyupd.php'),(20787580,17741,'./adminarcompanyupd.php'),(20787579,5494,'./adminarcompanyupd.php'),(20787578,18260,'./adminarcompanyupd.php'),(20787577,7758,'./adminarcompanyupd.php'),(20787576,7911,'./adminarcompanyupd.php'),(20787575,18222,'./adminarcompanyupd.php'),(20787574,7708,'./adminarcompanyupd.php'),(20787573,2267,'./adminarcompanyupd.php'),(20787572,6318,'./adminarcompanyupd.php'),(20787571,17462,'./adminarcompanyupd.php'),(20787570,17590,'./adminarcompanyupd.php'),(20787569,17461,'./adminarcompanyupd.php'),(20787568,16671,'./adminarcompanyupd.php'),(20787567,2208,'./adminarcompanyupd.php'),(20787566,19759,'./adminarcompanyupd.php'),(20787565,15284,'./adminarcompanyupd.php'),(20787564,14350,'./adminarcompanyupd.php'),(20787563,18938,'./adminarcompanyupd.php'),(20787562,2200,'./adminarcompanyupd.php'),(20787561,2160,'./adminarcompanyupd.php'),(20787560,2137,'./adminarcompanyupd.php'),(20787559,10570,'./adminarcompanyupd.php'),(20787558,19237,'./adminarcompanyupd.php'),(20787557,17589,'./adminarcompanyupd.php'),(20787556,20065,'./adminarcompanyupd.php'),(20787555,8265,'./adminarcompanyupd.php'),(20787554,8264,'./adminarcompanyupd.php'),(20787553,13058,'./adminarcompanyupd.php'),(20787552,8181,'./adminarcompanyupd.php'),(20787551,8129,'./adminarcompanyupd.php'),(20787550,20064,'./adminarcompanyupd.php'),(20787549,14575,'./adminarcompanyupd.php'),(20787548,19413,'./adminarcompanyupd.php'),(20787547,19412,'./adminarcompanyupd.php'),(20787546,20063,'./adminarcompanyupd.php'),(20787545,2090,'./adminarcompanyupd.php'),(20787544,16669,'./adminarcompanyupd.php'),(20787543,18259,'./adminarcompanyupd.php'),(20787542,2070,'./adminarcompanyupd.php'),(20787541,1973,'./adminarcompanyupd.php'),(20787540,18763,'./adminarcompanyupd.php'),(20787539,1965,'./adminarcompanyupd.php'),(20787538,17996,'./adminarcompanyupd.php'),(20787537,13277,'./adminarcompanyupd.php'),(20787536,13766,'./adminarcompanyupd.php'),(20787535,6233,'./adminarcompanyupd.php'),(20787534,6029,'./adminarcompanyupd.php'),(20787533,13992,'./adminarcompanyupd.php'),(20787532,13275,'./adminarcompanyupd.php'),(20787531,18609,'./adminarcompanyupd.php'),(20787530,15989,'./adminarcompanyupd.php'),(20787529,15888,'./adminarcompanyupd.php'),(20787528,14127,'./adminarcompanyupd.php'),(20787527,15887,'./adminarcompanyupd.php'),(20787526,18824,'./adminarcompanyupd.php'),(20787525,1847,'./adminarcompanyupd.php'),(20787524,6063,'./adminarcompanyupd.php'),(20787523,13274,'./adminarcompanyupd.php'),(20787522,13148,'./adminarcompanyupd.php'),(20787521,18937,'./adminarcompanyupd.php'),(20787520,18936,'./adminarcompanyupd.php'),(20787519,18845,'./adminarcompanyupd.php'),(20787518,1788,'./adminarcompanyupd.php'),(20787517,17821,'./adminarcompanyupd.php'),(20787516,19573,'./adminarcompanyupd.php'),(20787515,13096,'./adminarcompanyupd.php'),(20787514,15232,'./adminarcompanyupd.php'),(20787513,15625,'./adminarcompanyupd.php'),(20787512,6062,'./adminarcompanyupd.php'),(20787511,6061,'./adminarcompanyupd.php'),(20787510,17198,'./adminarcompanyupd.php'),(20787509,19236,'./adminarcompanyupd.php'),(20787508,15886,'./adminarcompanyupd.php'),(20787507,19843,'./adminarcompanyupd.php'),(20787506,8161,'./adminarcompanyupd.php'),(20787505,17968,'./adminarcompanyupd.php'),(20787504,17967,'./adminarcompanyupd.php'),(20787503,13999,'./adminarcompanyupd.php'),(20787502,10562,'./adminarcompanyupd.php'),(20787501,9329,'./adminarcompanyupd.php'),(20787500,15126,'./adminarcompanyupd.php'),(20787499,19101,'./adminarcompanyupd.php'),(20787498,1680,'./adminarcompanyupd.php'),(20787497,1676,'./adminarcompanyupd.php'),(20787496,17588,'./adminarcompanyupd.php'),(20787495,17587,'./adminarcompanyupd.php'),(20787494,5624,'./adminarcompanyupd.php'),(20787493,5566,'./adminarcompanyupd.php'),(20787492,5535,'./adminarcompanyupd.php'),(20787491,5534,'./adminarcompanyupd.php'),(20787490,5533,'./adminarcompanyupd.php'),(20787489,5532,'./adminarcompanyupd.php'),(20787488,1672,'./adminarcompanyupd.php'),(20787487,7707,'./adminarcompanyupd.php'),(20787486,13095,'./adminarcompanyupd.php'),(20787485,8372,'./adminarcompanyupd.php'),(20787484,20226,'./adminarcompanyupd.php'),(20787483,13902,'./adminarcompanyupd.php'),(20787482,13576,'./adminarcompanyupd.php'),(20787481,18844,'./adminarcompanyupd.php'),(20787480,14926,'./adminarcompanyupd.php'),(20787479,15624,'./adminarcompanyupd.php'),(20787224,14667,'./adminarcompanytaxupd.php'),(20787223,6597,'./adminarcompanytaxupd.php'),(20787222,17394,'./adminarcompanytaxupd.php'),(20787221,18437,'./adminarcompanytaxupd.php'),(20787220,2821,'./adminarcompanytaxupd.php'),(20787219,6593,'./adminarcompanytaxupd.php'),(20787218,19644,'./adminarcompanytaxupd.php'),(20787217,2782,'./adminarcompanytaxupd.php'),(20787216,2751,'./adminarcompanytaxupd.php'),(20787215,2710,'./adminarcompanytaxupd.php'),(20787214,2702,'./adminarcompanytaxupd.php'),(20787213,6592,'./adminarcompanytaxupd.php'),(20787212,2686,'./adminarcompanytaxupd.php'),(20787211,17393,'./adminarcompanytaxupd.php'),(20787210,10468,'./adminarcompanytaxupd.php'),(20787209,6591,'./adminarcompanytaxupd.php'),(20787208,16637,'./adminarcompanytaxupd.php'),(20787207,6157,'./adminarcompanytaxupd.php'),(20787206,6590,'./adminarcompanytaxupd.php'),(20787205,13766,'./adminarcompanytaxupd.php'),(20787204,6416,'./adminarcompanytaxupd.php'),(20787203,5626,'./adminarcompanytaxupd.php'),(20787202,6589,'./adminarcompanytaxupd.php'),(20787201,19840,'./adminarcompanytaxupd.php'),(20787200,18436,'./adminarcompanytaxupd.php'),(20787181,3308,'./adminarcarrierupd.php'),(20787180,3281,'./adminarcarrierupd.php'),(20787179,3194,'./adminarcarrierupd.php'),(20787178,2710,'./adminarcarrierupd.php'),(20787177,2702,'./adminarcarrierupd.php'),(20787176,4112,'./adminarcarrierupd.php'),(20787175,2062,'./adminarcarrierupd.php'),(20787174,1963,'./adminarcarrierupd.php'),(20787173,13943,'./adminarcarrierupd.php'),(20787172,1322,'./adminarcarrierupd.php'),(20787171,1254,'./adminarcarrierupd.php'),(20787170,1241,'./adminarcarrierupd.php'),(20787169,13942,'./adminarcarrierupd.php'),(20787168,822,'./adminarcarrierupd.php'),(20787167,5294,'./adminarcarrierupd.php'),(20787166,5293,'./adminarcarrierupd.php'),(20787165,444,'./adminarcarrierupd.php'),(20787164,443,'./adminarcarrierupd.php'),(20787163,437,'./adminarcarrierupd.php'),(20787162,434,'./adminarcarrierupd.php'),(20787161,315,'./adminarcarrierupd.php'),(20787160,5531,'./adminarcarrierupd.php'),(20787159,5292,'./adminarcarrierupd.php'),(20787158,5291,'./adminarcarrierupd.php'),(20787157,5295,'./adminarcarrierupd.php'),(20787156,92,'./adminarcarrierupd.php'),(20787155,6582,'./adminarcarrierorder.php'),(20787154,2902,'./adminarcarrierorder.php'),(20787153,2702,'./adminarcarrierorder.php'),(20787152,1884,'./adminarcarrierorder.php'),(20787151,5530,'./adminarcarrierorder.php'),(20787150,434,'./adminarcarrierorder.php'),(20787149,315,'./adminarcarrierorder.php'),(20787148,5529,'./adminarcarrierorder.php'),(20787147,5295,'./adminarcarrierorder.php'),(20787146,14267,'./adminarcarriermethupd.php'),(20787145,2842,'./adminarcarriermethupd.php'),(20787144,2841,'./adminarcarriermethupd.php'),(20787143,2840,'./adminarcarriermethupd.php'),(20787142,2839,'./adminarcarriermethupd.php'),(20787141,2710,'./adminarcarriermethupd.php'),(20787140,2702,'./adminarcarriermethupd.php'),(20787139,12173,'./adminarcarriermethupd.php'),(20787138,12741,'./adminarcarriermethupd.php'),(20787137,12740,'./adminarcarriermethupd.php'),(20787136,941,'./adminarcarriermethupd.php'),(20787135,8756,'./adminarcarriermethupd.php'),(20787134,869,'./adminarcarriermethupd.php'),(20787133,835,'./adminarcarriermethupd.php'),(20787132,799,'./adminarcarriermethupd.php'),(20787131,582,'./adminarcarriermethupd.php'),(20787130,542,'./adminarcarriermethupd.php'),(20787129,315,'./adminarcarriermethupd.php'),(20787128,5203,'./adminarcarriermethupd.php'),(20787127,18762,'./adminarcarriermethupd.php'),(20787126,116,'./adminarcarriermethupd.php'),(20787125,12739,'./adminarcarriermethupd.php'),(20787124,59,'./adminarcarriermethupd.php'),(20787122,3277,'./adminarcarrieradd.php'),(20787121,3276,'./adminarcarrieradd.php'),(20787120,2834,'./adminarcarrieradd.php'),(20787119,2710,'./adminarcarrieradd.php'),(20787118,2702,'./adminarcarrieradd.php'),(20787117,1327,'./adminarcarrieradd.php'),(20787116,435,'./adminarcarrieradd.php'),(20787115,315,'./adminarcarrieradd.php'),(20787114,6581,'./adminar_rmasetup.php'),(20787113,3225,'./adminar_rmasetup.php'),(20787112,19228,'./adminar_rmasetup.php'),(20787111,2710,'./adminar_rmasetup.php'),(20787110,8508,'./adminar_rmasetup.php'),(20787109,2702,'./adminar_rmasetup.php'),(20787108,6580,'./adminar_rmasetup.php'),(20787107,17194,'./adminar_rmasetup.php'),(20787106,17193,'./adminar_rmasetup.php'),(20787105,6579,'./adminar_rmasetup.php'),(20787104,6578,'./adminar_rmasetup.php'),(20787103,6577,'./adminar_rmasetup.php'),(20787102,6576,'./adminar_rmasetup.php'),(20787101,6575,'./adminar_rmasetup.php'),(20787100,6574,'./adminar_rmasetup.php'),(20787099,6573,'./adminar_rmasetup.php'),(20787098,6572,'./adminar_rmasetup.php'),(20787097,6571,'./adminar_rmasetup.php'),(20787096,19227,'./adminar_rmasetup.php'),(20787095,6570,'./adminar_rmasetup.php'),(20787094,6569,'./adminar_rmasetup.php'),(20787093,6568,'./adminar_rmasetup.php'),(20787092,17192,'./adminar_rmasetup.php'),(20787091,19226,'./adminar_rmasetup.php'),(20787090,6567,'./adminar_rmasetup.php'),(20787089,3995,'./adminar_rmasetup.php'),(20787088,1143,'./adminar_rmasetup.php'),(20787087,941,'./adminar_rmasetup.php'),(20787086,6566,'./adminar_rmasetup.php'),(20787085,864,'./adminar_rmasetup.php'),(20787076,8894,'./adminapvendortypeadd.php'),(20787075,2702,'./adminapvendortypeadd.php'),(20787074,542,'./adminapvendortypeadd.php'),(20787073,315,'./adminapvendortypeadd.php'),(20787072,8893,'./adminapvendortype.php'),(20787071,8892,'./adminapvendortype.php'),(20787070,2710,'./adminapvendortype.php'),(20787069,2702,'./adminapvendortype.php'),(20787068,2044,'./adminapvendortype.php'),(20787067,941,'./adminapvendortype.php'),(20787066,799,'./adminapvendortype.php'),(20787065,315,'./adminapvendortype.php'),(20787064,5203,'./adminapvendortype.php'),(20787063,146,'./adminapvendortype.php'),(20787062,59,'./adminapvendortype.php'),(20787061,3305,'./adminappaytermsupd.php'),(20787060,3303,'./adminappaytermsupd.php'),(20787059,2710,'./adminappaytermsupd.php'),(20787058,2702,'./adminappaytermsupd.php'),(20787057,11926,'./adminappaytermsupd.php'),(20787056,2044,'./adminappaytermsupd.php'),(20787055,1211,'./adminappaytermsupd.php'),(20787054,941,'./adminappaytermsupd.php'),(20787053,810,'./adminappaytermsupd.php'),(20787052,799,'./adminappaytermsupd.php'),(20787051,315,'./adminappaytermsupd.php'),(20787050,5203,'./adminappaytermsupd.php'),(20787049,146,'./adminappaytermsupd.php'),(20787047,3300,'./adminappaytermsadd.php'),(20787046,2702,'./adminappaytermsadd.php'),(20787045,11926,'./adminappaytermsadd.php'),(20787044,1211,'./adminappaytermsadd.php'),(20787043,542,'./adminappaytermsadd.php'),(20787041,5876,'./adminapilogdata.php'),(20787040,8357,'./adminapilogdata.php'),(20787039,8273,'./adminapilogdata.php'),(20787038,1578,'./adminapilogdata.php'),(20787037,737,'./adminapilogdata.php'),(20787036,8356,'./adminapilogdata.php'),(20787035,8355,'./adminapilogdata.php'),(20787034,315,'./adminapilogdata.php'),(20787033,47,'./adminapilogdata.php'),(20787032,3319,'./adminapilog.php'),(20787031,8354,'./adminapilog.php'),(20787030,7130,'./adminapilog.php'),(20787029,6700,'./adminapilog.php'),(20787028,4023,'./adminapilog.php'),(20787027,1963,'./adminapilog.php'),(20787026,8273,'./adminapilog.php'),(20787025,6478,'./adminapilog.php'),(20787024,1014,'./adminapilog.php'),(20787023,737,'./adminapilog.php'),(20787022,8270,'./adminapilog.php'),(20787021,8353,'./adminapilog.php'),(20787020,6477,'./adminapilog.php'),(20787019,333,'./adminapilog.php'),(20787018,8352,'./adminapilog.php'),(20787017,47,'./adminapilog.php'),(20663883,6563,'./adminapgroupsupd.php'),(20663882,6562,'./adminapgroupsupd.php'),(20663881,3225,'./adminapgroupsupd.php'),(20663880,2710,'./adminapgroupsupd.php'),(20663879,2702,'./adminapgroupsupd.php'),(20663878,6558,'./adminapgroupsupd.php'),(20663877,3995,'./adminapgroupsupd.php'),(20663876,1143,'./adminapgroupsupd.php'),(20663875,966,'./adminapgroupsupd.php'),(20663874,941,'./adminapgroupsupd.php'),(20663873,869,'./adminapgroupsupd.php'),(20663872,6561,'./adminapgroupsupd.php'),(20663871,864,'./adminapgroupsupd.php'),(20663870,799,'./adminapgroupsupd.php'),(20663869,315,'./adminapgroupsupd.php'),(20663868,5203,'./adminapgroupsupd.php'),(20663867,6560,'./adminapgroupsupd.php'),(20663866,59,'./adminapgroupsupd.php'),(20663865,6559,'./adminapgroupsadd.php'),(20663864,2710,'./adminapgroupsadd.php'),(20663863,2702,'./adminapgroupsadd.php'),(20663862,6558,'./adminapgroupsadd.php'),(20663861,3994,'./adminapgroupsadd.php'),(20663860,869,'./adminapgroupsadd.php'),(20663859,542,'./adminapgroupsadd.php'),(20663858,315,'./adminapgroupsadd.php'),(20663857,222,'./adminapgroupsadd.php'),(20663856,176,'./adminapgroupsadd.php'),(20804699,20140,'./invpoadd.php'),(20804457,9333,'./invitemvendupd.php'),(20804218,799,'./invitemupd.php'),(20804217,16876,'./invitemupd.php'),(20804216,16932,'./invitemupd.php'),(20804215,6602,'./invitemupd.php'),(20804214,5832,'./invitemupd.php'),(20804213,637,'./invitemupd.php'),(20803989,9919,'./invitemprices.php'),(20803988,1427,'./invitemprices.php'),(20803987,5142,'./invitemprices.php'),(20803986,8936,'./invitemprices.php'),(20803985,869,'./invitemprices.php'),(20803984,8109,'./invitemprices.php'),(20803983,749,'./invitemprices.php'),(20803982,690,'./invitemprices.php'),(20803760,1709,'./invitemlstusage.php'),(20803759,1014,'./invitemlstusage.php'),(20803758,665,'./invitemlstusage.php'),(20803757,616,'./invitemlstusage.php'),(20803365,941,'./invitemcatupd.php'),(20803364,831,'./invitemcatupd.php'),(20803049,18676,'./invitemadd.php'),(20802763,19129,'./inventory_detail_pop.php'),(20802762,6446,'./inventory_detail_pop.php'),(20802761,542,'./inventory_detail_pop.php'),(20802759,14247,'./inventory_detail_pop.php'),(20802596,16671,'./invcotransfer.php'),(20802595,2151,'./invcotransfer.php'),(20802594,2044,'./invcotransfer.php'),(20802593,20123,'./invcotransfer.php'),(20802592,16674,'./invcotransfer.php'),(20802591,17421,'./invcotransfer.php'),(20802590,1788,'./invcotransfer.php'),(20802589,13511,'./invcotransfer.php'),(20801431,337,'./glrepjournal.php'),(20801430,315,'./glrepjournal.php'),(20801429,5145,'./glrepjournal.php'),(20801103,339,'./glrepactivity.php'),(20800661,5430,'./glincome.php'),(20800660,226,'./glincome.php'),(20800659,15907,'./glincome.php'),(20800604,566,'./glexpense.php'),(20787478,18258,'./adminarcompanyupd.php'),(20787477,15623,'./adminarcompanyupd.php'),(20787476,14141,'./adminarcompanyupd.php'),(20787475,18608,'./adminarcompanyupd.php'),(20787474,15165,'./adminarcompanyupd.php'),(20787473,19235,'./adminarcompanyupd.php'),(20787472,19234,'./adminarcompanyupd.php'),(20787471,9328,'./adminarcompanyupd.php'),(20787470,19305,'./adminarcompanyupd.php'),(20787469,16395,'./adminarcompanyupd.php'),(20787468,13057,'./adminarcompanyupd.php'),(20787467,14099,'./adminarcompanyupd.php'),(20787466,15164,'./adminarcompanyupd.php'),(20787465,19411,'./adminarcompanyupd.php'),(20787464,15622,'./adminarcompanyupd.php'),(20787463,13418,'./adminarcompanyupd.php'),(20787462,15655,'./adminarcompanyupd.php'),(20787461,20062,'./adminarcompanyupd.php'),(20787460,17197,'./adminarcompanyupd.php'),(20787459,13024,'./adminarcompanyupd.php'),(20787458,17196,'./adminarcompanyupd.php'),(20787457,17586,'./adminarcompanyupd.php'),(20787013,3056,'./adminapchkacctupd.php'),(20787012,2710,'./adminapchkacctupd.php'),(20787011,2702,'./adminapchkacctupd.php'),(20787010,2044,'./adminapchkacctupd.php'),(20787009,1333,'./adminapchkacctupd.php'),(20787008,966,'./adminapchkacctupd.php'),(20787007,941,'./adminapchkacctupd.php'),(20787006,816,'./adminapchkacctupd.php'),(20787005,864,'./adminapchkacctupd.php'),(20787004,799,'./adminapchkacctupd.php'),(20787003,510,'./adminapchkacctupd.php'),(20787002,315,'./adminapchkacctupd.php'),(20787001,5203,'./adminapchkacctupd.php'),(20787000,94,'./adminapchkacctupd.php'),(20786999,59,'./adminapchkacctupd.php'),(20786998,3056,'./adminapchkacctadd.php'),(20786997,2702,'./adminapchkacctadd.php'),(20786996,1333,'./adminapchkacctadd.php'),(20786995,505,'./adminapchkacctadd.php'),(20786994,315,'./adminapchkacctadd.php'),(20786993,3292,'./adminapccvendorupd.php'),(20786992,3225,'./adminapccvendorupd.php'),(20786991,13612,'./adminapccvendorupd.php'),(20786990,2710,'./adminapccvendorupd.php'),(20786989,2702,'./adminapccvendorupd.php'),(20786988,13288,'./adminapccvendorupd.php'),(20786987,13287,'./adminapccvendorupd.php'),(20786986,1499,'./adminapccvendorupd.php'),(20786985,3995,'./adminapccvendorupd.php'),(20786984,1143,'./adminapccvendorupd.php'),(20786983,11990,'./adminapccvendorupd.php'),(20786982,941,'./adminapccvendorupd.php'),(20786981,864,'./adminapccvendorupd.php'),(20786980,799,'./adminapccvendorupd.php'),(20786979,8644,'./adminapccvendorupd.php'),(20786978,673,'./adminapccvendorupd.php'),(20786977,315,'./adminapccvendorupd.php'),(20786976,5203,'./adminapccvendorupd.php'),(20786975,59,'./adminapccvendorupd.php'),(20786974,3292,'./adminapccvendoradd.php'),(20786973,2710,'./adminapccvendoradd.php'),(20786972,2702,'./adminapccvendoradd.php'),(20786971,13288,'./adminapccvendoradd.php'),(20786970,13287,'./adminapccvendoradd.php'),(20786969,12001,'./adminapccvendoradd.php'),(20786968,12727,'./adminapccvendoradd.php'),(20786967,1499,'./adminapccvendoradd.php'),(20786966,3994,'./adminapccvendoradd.php'),(20786965,8644,'./adminapccvendoradd.php'),(20786964,542,'./adminapccvendoradd.php'),(20786963,315,'./adminapccvendoradd.php'),(20786962,222,'./adminapccvendoradd.php'),(20786961,176,'./adminapccvendoradd.php'),(20786960,3225,'./adminapcctypeupd.php'),(20786959,2710,'./adminapcctypeupd.php'),(20786958,2702,'./adminapcctypeupd.php'),(20786957,8640,'./adminapcctypeupd.php'),(20786956,15985,'./adminapcctypeupd.php'),(20786955,8639,'./adminapcctypeupd.php'),(20786954,8638,'./adminapcctypeupd.php'),(20786953,8637,'./adminapcctypeupd.php'),(20786952,3995,'./adminapcctypeupd.php'),(20786951,1143,'./adminapcctypeupd.php'),(20786950,11988,'./adminapcctypeupd.php'),(20786949,941,'./adminapcctypeupd.php'),(20786948,869,'./adminapcctypeupd.php'),(20786947,864,'./adminapcctypeupd.php'),(20786946,799,'./adminapcctypeupd.php'),(20786945,8642,'./adminapcctypeupd.php'),(20786944,8634,'./adminapcctypeupd.php'),(20786943,315,'./adminapcctypeupd.php'),(20786942,5203,'./adminapcctypeupd.php'),(20786941,59,'./adminapcctypeupd.php'),(20786940,2710,'./adminapcctypeadd.php'),(20786939,2702,'./adminapcctypeadd.php'),(20786938,12000,'./adminapcctypeadd.php'),(20786937,8640,'./adminapcctypeadd.php'),(20786936,15985,'./adminapcctypeadd.php'),(20786935,8639,'./adminapcctypeadd.php'),(20786934,8638,'./adminapcctypeadd.php'),(20786933,8637,'./adminapcctypeadd.php'),(20786932,3994,'./adminapcctypeadd.php'),(20786931,869,'./adminapcctypeadd.php'),(20786930,542,'./adminapcctypeadd.php'),(20786929,8634,'./adminapcctypeadd.php'),(20786928,315,'./adminapcctypeadd.php'),(20786927,222,'./adminapcctypeadd.php'),(20786926,176,'./adminapcctypeadd.php'),(20786925,8765,'./adminapccgen.php'),(20786924,3225,'./adminapccgen.php'),(20786923,2710,'./adminapccgen.php'),(20786922,2702,'./adminapccgen.php'),(20786921,8764,'./adminapccgen.php'),(20786920,8763,'./adminapccgen.php'),(20786919,8762,'./adminapccgen.php'),(20786918,3995,'./adminapccgen.php'),(20786917,8761,'./adminapccgen.php'),(20786916,8760,'./adminapccgen.php'),(20786915,8759,'./adminapccgen.php'),(20786914,6565,'./adminapccgen.php'),(20786913,11470,'./adminactivitymonitor.php'),(20786912,3252,'./adminactivitymonitor.php'),(20786911,6384,'./adminactivitymonitor.php'),(20786910,7024,'./adminactivitymonitor.php'),(20786909,8276,'./adminactivitymonitor.php'),(20786908,8275,'./adminactivitymonitor.php'),(20786907,6700,'./adminactivitymonitor.php'),(20786906,5876,'./adminactivitymonitor.php'),(20786905,7019,'./adminactivitymonitor.php'),(20786904,1963,'./adminactivitymonitor.php'),(20786903,1911,'./adminactivitymonitor.php'),(20786902,8273,'./adminactivitymonitor.php'),(20786901,1578,'./adminactivitymonitor.php'),(20786900,8272,'./adminactivitymonitor.php'),(20786899,1014,'./adminactivitymonitor.php'),(20786898,4602,'./adminactivitymonitor.php'),(20786897,8271,'./adminactivitymonitor.php'),(20786896,737,'./adminactivitymonitor.php'),(20786895,8270,'./adminactivitymonitor.php'),(20786894,683,'./adminactivitymonitor.php'),(20786893,542,'./adminactivitymonitor.php'),(20786892,333,'./adminactivitymonitor.php'),(20786891,47,'./adminactivitymonitor.php'),(20787455,15790,'./adminarcompanyupd.php'),(20787454,10569,'./adminarcompanyupd.php'),(20786890,5423,'./adminachreport.php'),(20786889,5422,'./adminachreport.php'),(20786888,5421,'./adminachreport.php'),(20786887,5420,'./adminachreport.php'),(20786886,5419,'./adminachreport.php'),(20786885,5418,'./adminachreport.php'),(20786884,5455,'./adminachreport.php'),(20786883,5417,'./adminachreport.php'),(20786882,5416,'./adminachreport.php'),(20786881,5415,'./adminachreport.php'),(20786880,2044,'./adminachreport.php'),(20786879,1963,'./adminachreport.php'),(20786878,1935,'./adminachreport.php'),(20786877,1578,'./adminachreport.php'),(20786876,5564,'./adminachreport.php'),(20786875,5414,'./adminachreport.php'),(20786874,5413,'./adminachreport.php'),(20786873,5412,'./adminachreport.php'),(20786872,5411,'./adminachreport.php'),(20786871,1047,'./adminachreport.php'),(20786870,1014,'./adminachreport.php'),(20786869,5410,'./adminachreport.php'),(20786868,5409,'./adminachreport.php'),(20786867,5408,'./adminachreport.php'),(20786866,5407,'./adminachreport.php'),(20786865,5425,'./adminachreport.php'),(20786864,7865,'./adminachreport.php'),(20786863,5453,'./adminachreport.php'),(20786862,869,'./adminachreport.php'),(20786861,5405,'./adminachreport.php'),(20786860,5404,'./adminachreport.php'),(20786859,5403,'./adminachreport.php'),(20786858,542,'./adminachreport.php'),(20786857,5424,'./adminachreport.php'),(20786856,333,'./adminachreport.php'),(20786855,5402,'./adminachreport.php'),(20786854,5401,'./adminachreport.php'),(20786849,14823,'./adminachdownload.php'),(20786848,5565,'./adminachdownload.php'),(20786847,4109,'./admin3dcart.php'),(20786846,15190,'./admin3dcart.php'),(20786845,15189,'./admin3dcart.php'),(20786844,15282,'./admin3dcart.php'),(20786843,17453,'./admin3dcart.php'),(20786842,15188,'./admin3dcart.php'),(20786841,15231,'./admin3dcart.php'),(20786840,15787,'./admin3dcart.php'),(20786839,14489,'./admin3dcart.php'),(20786838,15984,'./admin3dcart.php'),(20786837,15786,'./admin3dcart.php'),(20786836,15983,'./admin3dcart.php'),(20786835,15281,'./admin3dcart.php'),(20786834,14788,'./admin3dcart.php'),(20786833,19834,'./admin3dcart.php'),(20786832,15163,'./admin3dcart.php'),(20786831,16381,'./admin3dcart.php'),(20786830,15162,'./admin3dcart.php'),(20786829,15230,'./admin3dcart.php'),(20786828,15982,'./admin3dcart.php'),(20786827,19571,'./admin3dcart.php'),(20786826,12924,'./admin3dcart.php'),(20786825,15187,'./admin3dcart.php'),(20786824,15602,'./admin3dcart.php'),(20786823,2710,'./admin3dcart.php'),(20786822,2702,'./admin3dcart.php'),(20786821,2664,'./admin3dcart.php'),(20786820,7708,'./admin3dcart.php'),(20786819,18074,'./admin3dcart.php'),(20786818,14857,'./admin3dcart.php'),(20786817,2070,'./admin3dcart.php'),(20786816,18073,'./admin3dcart.php'),(20786815,18072,'./admin3dcart.php'),(20786814,19570,'./admin3dcart.php'),(20786813,6599,'./admin3dcart.php'),(20786812,15186,'./admin3dcart.php'),(20786811,18071,'./admin3dcart.php'),(20786810,1696,'./admin3dcart.php'),(20786809,15280,'./admin3dcart.php'),(20786808,15279,'./admin3dcart.php'),(20786807,15229,'./admin3dcart.php'),(20786806,15228,'./admin3dcart.php'),(20786805,15785,'./admin3dcart.php'),(20786804,15784,'./admin3dcart.php'),(20786803,18070,'./admin3dcart.php'),(20786802,15161,'./admin3dcart.php'),(20786801,15783,'./admin3dcart.php'),(20786800,15160,'./admin3dcart.php'),(20786799,15159,'./admin3dcart.php'),(20786798,17818,'./admin3dcart.php'),(20786797,17817,'./admin3dcart.php'),(20786796,19569,'./admin3dcart.php'),(20786795,14856,'./admin3dcart.php'),(20786794,14855,'./admin3dcart.php'),(20786793,18069,'./admin3dcart.php'),(20786792,18068,'./admin3dcart.php'),(20786791,18067,'./admin3dcart.php'),(20786790,18066,'./admin3dcart.php'),(20786789,9432,'./admin3dcart.php'),(20786788,18065,'./admin3dcart.php'),(20786787,8936,'./admin3dcart.php'),(20786786,18064,'./admin3dcart.php'),(20786785,1047,'./admin3dcart.php'),(20786784,14854,'./admin3dcart.php'),(20786783,941,'./admin3dcart.php'),(20786782,17584,'./admin3dcart.php'),(20786781,799,'./admin3dcart.php'),(20786780,9431,'./admin3dcart.php'),(20786779,9439,'./admin3dcart.php'),(20786778,9438,'./admin3dcart.php'),(20786777,9437,'./admin3dcart.php'),(20786776,797,'./admin3dcart.php'),(20663588,2715,'./action_addupdate.php'),(20663587,2702,'./action_addupdate.php'),(20663586,7698,'./action_addupdate.php'),(20663585,1047,'./action_addupdate.php'),(20663584,942,'./action_addupdate.php'),(20663583,941,'./action_addupdate.php'),(20663582,800,'./action_addupdate.php'),(20663581,799,'./action_addupdate.php'),(20663580,315,'./action_addupdate.php'),(20663579,4871,'./action_addupdate.php'),(20663578,88,'./action_addupdate.php'),(20663577,59,'./action_addupdate.php'),(20663576,51,'./action_addupdate.php'),(20663575,50,'./action_addupdate.php'),(20663574,48,'./action_addupdate.php'),(20663573,47,'./action_addupdate.php'),(20786725,14986,'./!/application/views/vendor/summary.php'),(20787453,13640,'./adminarcompanyupd.php'),(20792195,315,'./arinvoiceadd.php'),(20786711,15716,'./!/application/views/vendor/certificate_upload.php'),(20786710,15715,'./!/application/views/vendor/certificate_upload.php'),(20786702,8468,'./!/application/views/timecard/sidemenu.php'),(20786701,8467,'./!/application/views/timecard/sidemenu.php'),(20786700,8466,'./!/application/views/timecard/sidemenu.php'),(20786699,8464,'./!/application/views/timecard/sidemenu.php'),(20786698,8463,'./!/application/views/timecard/sidemenu.php'),(20786697,10990,'./!/application/views/timecard/sidemenu.php'),(20786696,8462,'./!/application/views/timecard/sidemenu.php'),(20786695,8461,'./!/application/views/timecard/sidemenu.php'),(20786694,8460,'./!/application/views/timecard/sidemenu.php'),(20786693,15227,'./!/application/views/timecard/sidemenu.php'),(20786692,1794,'./!/application/views/timecard/sidemenu.php'),(20786691,8458,'./!/application/views/timecard/sidemenu.php'),(20786690,8457,'./!/application/views/timecard/sidemenu.php'),(20786689,15226,'./!/application/views/timecard/sidemenu.php'),(20786688,8466,'./!/application/views/timecard/over_maxhours.php'),(20786687,8458,'./!/application/views/timecard/over_maxhours.php'),(20786686,1575,'./!/application/views/timecard/over_maxhours.php'),(20786685,8525,'./!/application/views/timecard/over_maxhours.php'),(20786684,15225,'./!/application/views/timecard/over_maxhours.php'),(20786683,8524,'./!/application/views/timecard/over_maxhours.php'),(20786680,9642,'./!/application/views/timecard/login.php'),(20786679,8527,'./!/application/views/timecard/login.php'),(20786678,2234,'./!/application/views/timecard/login.php'),(20792445,8125,'./arinvoicedelivery.php'),(20786675,5733,'./!/application/views/timecard/history_form.php'),(20786674,3434,'./!/application/views/timecard/history_form.php'),(20786673,8433,'./!/application/views/timecard/history_form.php'),(20786672,1014,'./!/application/views/timecard/history_form.php'),(20786671,8402,'./!/application/views/timecard/employee_list.php'),(20786670,4457,'./!/application/views/timecard/employee_list.php'),(20786669,8428,'./!/application/views/timecard/employee_list.php'),(20786668,8393,'./!/application/views/timecard/employee_list.php'),(20786667,989,'./!/application/views/timecard/employee_list.php'),(20786666,6042,'./!/application/views/timecard/employee_list.php'),(20786663,3434,'./!/application/views/timecard/edit_times_form.php'),(20786662,1963,'./!/application/views/timecard/edit_times_form.php'),(20786661,1014,'./!/application/views/timecard/edit_times_form.php'),(20786660,5640,'./!/application/views/timecard/edit_times_form.php'),(20786659,2985,'./!/application/views/template_parts/main_index.php'),(20786658,20042,'./!/application/views/template_parts/main_index.php'),(20786657,14851,'./!/application/views/template_parts/main_index.php'),(20786656,2058,'./!/application/views/template_parts/main_index.php'),(20786655,14850,'./!/application/views/template_parts/main_index.php'),(20786654,13334,'./!/application/views/template_parts/main_index.php'),(20786343,1963,'./!/application/views/query_builder/user_input_form.php'),(20786342,3090,'./!/application/views/query_builder/run.php'),(20793900,337,'./aritemsaleslst.php'),(20793899,315,'./aritemsaleslst.php'),(20796563,19508,'./autofunctionsdb.php'),(20786341,14824,'./!/application/views/query_builder/list.php'),(20786340,14849,'./!/application/views/query_builder/list.php'),(20786339,14848,'./!/application/views/query_builder/list.php'),(20786338,941,'./!/application/views/query_builder/list.php'),(20786334,15277,'./!/application/views/query_builder/edit.start.php'),(20786333,15276,'./!/application/views/query_builder/edit.start.php'),(20786332,14847,'./!/application/views/query_builder/edit.start.php'),(20786331,15275,'./!/application/views/query_builder/edit.start.php'),(20786330,15274,'./!/application/views/query_builder/edit.start.php'),(20786329,15273,'./!/application/views/query_builder/edit.start.php'),(20786328,14846,'./!/application/views/query_builder/edit.start.php'),(20786327,941,'./!/application/views/query_builder/edit.start.php'),(20786326,14845,'./!/application/views/query_builder/edit.start.php'),(20786325,2805,'./!/application/views/query_builder/edit.select.php'),(20786324,14844,'./!/application/views/query_builder/edit.select.php'),(20786323,14843,'./!/application/views/query_builder/edit.select.php'),(20786322,15243,'./!/application/views/query_builder/edit.select.php'),(20786321,10492,'./!/application/views/query_builder/edit.select.php'),(20786320,2270,'./!/application/views/query_builder/edit.select.php'),(20786319,2258,'./!/application/views/query_builder/edit.select.php'),(20786318,2200,'./!/application/views/query_builder/edit.select.php'),(20786317,2070,'./!/application/views/query_builder/edit.select.php'),(20786316,1935,'./!/application/views/query_builder/edit.select.php'),(20786315,3672,'./!/application/views/query_builder/edit.select.php'),(20786314,1639,'./!/application/views/query_builder/edit.select.php'),(20786313,15242,'./!/application/views/query_builder/edit.select.php'),(20786312,11843,'./!/application/views/query_builder/edit.select.php'),(20786311,3544,'./!/application/views/query_builder/edit.select.php'),(20786310,14842,'./!/application/views/query_builder/edit.js.php'),(20786309,3156,'./!/application/views/query_builder/edit.js.php'),(20786308,1,'./!/application/views/query_builder/edit.js.php'),(20786307,14841,'./!/application/views/query_builder/edit.js.php'),(20786306,15272,'./!/application/views/query_builder/edit.js.php'),(20786305,14839,'./!/application/views/query_builder/edit.js.php'),(20786304,14838,'./!/application/views/query_builder/edit.js.php'),(20786303,2751,'./!/application/views/query_builder/edit.js.php'),(20786302,2738,'./!/application/views/query_builder/edit.js.php'),(20786301,2109,'./!/application/views/query_builder/edit.js.php'),(20786300,1935,'./!/application/views/query_builder/edit.js.php'),(20786299,13334,'./!/application/views/query_builder/edit.js.php'),(20786298,14967,'./!/application/views/query_builder/edit.js.php'),(20786297,14837,'./!/application/views/query_builder/edit.js.php'),(20786296,14836,'./!/application/views/query_builder/edit.js.php'),(20786295,6378,'./!/application/views/query_builder/edit.js.php'),(20786294,14835,'./!/application/views/query_builder/edit.js.php'),(20786293,737,'./!/application/views/query_builder/edit.js.php'),(20786292,15271,'./!/application/views/query_builder/edit.js.php'),(20786291,15270,'./!/application/views/query_builder/edit.js.php'),(20786290,14834,'./!/application/views/query_builder/edit.js.php'),(20786289,14833,'./!/application/views/query_builder/edit.js.php'),(20786192,3090,'./!/application/views/mobilepos/mobilepos.php'),(20786191,2998,'./!/application/views/mobilepos/mobilepos.php'),(20786190,2762,'./!/application/views/mobilepos/mobilepos.php'),(20786189,2622,'./!/application/views/mobilepos/mobilepos.php'),(20786188,2508,'./!/application/views/mobilepos/mobilepos.php'),(20786187,1794,'./!/application/views/mobilepos/mobilepos.php'),(20786186,8863,'./!/application/views/mobilepos/mobilepos.php'),(20805528,606,'./jobupd.php'),(20805527,605,'./jobupd.php'),(20805526,11355,'./jobupd.php'),(20786179,1668,'./!/application/views/mobilepos/mobilepos.payment.php'),(20786178,315,'./!/application/views/mobilepos/mobilepos.payment.php'),(20806489,1709,'./npordersave.php'),(20806488,19791,'./npordersave.php'),(20786177,3319,'./!/application/views/meta_menu/vendor.php'),(20786176,3274,'./!/application/views/meta_menu/vendor.php'),(20786175,15075,'./!/application/views/meta_menu/vendor.php'),(20786174,4088,'./!/application/views/meta_menu/vendor.php'),(20786173,12153,'./!/application/views/meta_menu/vendor.php'),(20786172,11013,'./!/application/views/meta_menu/vendor.php'),(20786171,6839,'./!/application/views/meta_menu/vendor.php'),(20786170,10711,'./!/application/views/meta_menu/vendor.php'),(20786169,10709,'./!/application/views/meta_menu/vendor.php'),(20786168,11298,'./!/application/views/meta_menu/vendor.php'),(20786167,2044,'./!/application/views/meta_menu/vendor.php'),(20786166,1935,'./!/application/views/meta_menu/vendor.php'),(20786165,1934,'./!/application/views/meta_menu/vendor.php'),(20786164,1678,'./!/application/views/meta_menu/vendor.php'),(20786163,1575,'./!/application/views/meta_menu/vendor.php'),(20786162,941,'./!/application/views/meta_menu/vendor.php'),(20786161,4363,'./!/application/views/meta_menu/vendor.php'),(20786160,737,'./!/application/views/meta_menu/vendor.php'),(20786159,605,'./!/application/views/meta_menu/vendor.php'),(20786158,491,'./!/application/views/meta_menu/vendor.php'),(20786157,325,'./!/application/views/meta_menu/vendor.php'),(20786156,226,'./!/application/views/meta_menu/vendor.php'),(20810601,204,'./serviceorder_time_reporter.php'),(20806487,9173,'./npordersave.php'),(20806486,13045,'./npordersave.php'),(20806485,1467,'./npordersave.php'),(20806484,10384,'./npordersave.php'),(20806483,19790,'./npordersave.php'),(20806482,8917,'./npordersave.php'),(20806481,16089,'./npordersave.php'),(20806480,8936,'./npordersave.php'),(20806479,19789,'./npordersave.php'),(20806478,9224,'./npordersave.php'),(20786403,2676,'./!/application/views/salesregion/region_territory_list.php'),(20786253,5681,'./!/application/views/physicalinv/search.php'),(20786151,3319,'./!/application/views/meta_menu/job.php'),(20786150,7946,'./!/application/views/meta_menu/job.php'),(20786149,3274,'./!/application/views/meta_menu/job.php'),(20786148,11241,'./!/application/views/meta_menu/job.php'),(20786147,15695,'./!/application/views/meta_menu/job.php'),(20786146,3090,'./!/application/views/meta_menu/job.php'),(20786145,2948,'./!/application/views/meta_menu/job.php'),(20786144,2044,'./!/application/views/meta_menu/job.php'),(20786143,1935,'./!/application/views/meta_menu/job.php'),(20786142,15641,'./!/application/views/meta_menu/job.php'),(20786141,5081,'./!/application/views/meta_menu/job.php'),(20786140,1678,'./!/application/views/meta_menu/job.php'),(20786139,1672,'./!/application/views/meta_menu/job.php'),(20786138,4940,'./!/application/views/meta_menu/job.php'),(20786137,989,'./!/application/views/meta_menu/job.php'),(20786136,941,'./!/application/views/meta_menu/job.php'),(20786135,932,'./!/application/views/meta_menu/job.php'),(20786134,737,'./!/application/views/meta_menu/job.php'),(20786133,697,'./!/application/views/meta_menu/job.php'),(20786132,9492,'./!/application/views/meta_menu/job.php'),(20786131,226,'./!/application/views/meta_menu/job.php'),(20786130,3319,'./!/application/views/meta_menu/item.php'),(20786129,3238,'./!/application/views/meta_menu/item.php'),(20786128,18247,'./!/application/views/meta_menu/item.php'),(20786127,2664,'./!/application/views/meta_menu/item.php'),(20786126,2520,'./!/application/views/meta_menu/item.php'),(20786125,2515,'./!/application/views/meta_menu/item.php'),(20786124,2320,'./!/application/views/meta_menu/item.php'),(20786114,3333,'./!/application/views/meta_menu/gltransvoucher.php'),(20786113,15980,'./!/application/views/meta_menu/gltransvoucher.php'),(20786112,3319,'./!/application/views/meta_menu/gltransvoucher.php'),(20786111,2907,'./!/application/views/meta_menu/gltransvoucher.php'),(20786110,2459,'./!/application/views/meta_menu/gltransvoucher.php'),(20786109,2377,'./!/application/views/meta_menu/gltransvoucher.php'),(20786108,2044,'./!/application/views/meta_menu/gltransvoucher.php'),(20786107,1499,'./!/application/views/meta_menu/gltransvoucher.php'),(20786106,15779,'./!/application/views/meta_menu/gltransvoucher.php'),(20786105,11868,'./!/application/views/meta_menu/gltransvoucher.php'),(20786104,1036,'./!/application/views/meta_menu/gltransvoucher.php'),(20786103,941,'./!/application/views/meta_menu/gltransvoucher.php'),(20786102,869,'./!/application/views/meta_menu/gltransvoucher.php'),(20786101,15979,'./!/application/views/meta_menu/gltransvoucher.php'),(20786100,226,'./!/application/views/meta_menu/gltransvoucher.php'),(20813863,2208,'./includes/functions.php'),(20786087,11888,'./!/application/views/meta_menu/customer.php'),(20786097,3421,'./!/application/views/meta_menu/customer.php'),(20786096,3319,'./!/application/views/meta_menu/customer.php'),(20786095,4861,'./!/application/views/meta_menu/customer.php'),(20786094,15075,'./!/application/views/meta_menu/customer.php'),(20786093,2948,'./!/application/views/meta_menu/customer.php'),(20786092,2816,'./!/application/views/meta_menu/customer.php'),(20786091,2827,'./!/application/views/meta_menu/customer.php'),(20786090,6770,'./!/application/views/meta_menu/customer.php'),(20786089,2638,'./!/application/views/meta_menu/customer.php'),(20786079,11013,'./!/application/views/meta_menu/customer.php'),(20786080,18928,'./!/application/views/meta_menu/customer.php'),(20786081,18929,'./!/application/views/meta_menu/customer.php'),(20786082,15768,'./!/application/views/meta_menu/customer.php'),(20786083,18589,'./!/application/views/meta_menu/customer.php'),(20786084,11014,'./!/application/views/meta_menu/customer.php'),(20786085,11887,'./!/application/views/meta_menu/customer.php'),(20786051,6014,'./!/application/views/meta_menu/check.php'),(20786050,3324,'./!/application/views/meta_menu/check.php'),(20786049,3319,'./!/application/views/meta_menu/check.php'),(20786048,2459,'./!/application/views/meta_menu/check.php'),(20786047,1973,'./!/application/views/meta_menu/check.php'),(20786046,1935,'./!/application/views/meta_menu/check.php'),(20786045,941,'./!/application/views/meta_menu/check.php'),(20786037,3090,'./!/application/views/meta_menu/arorder.php'),(20786036,2948,'./!/application/views/meta_menu/arorder.php'),(20786035,2827,'./!/application/views/meta_menu/arorder.php'),(20786034,5492,'./!/application/views/meta_menu/arorder.php'),(20786033,16825,'./!/application/views/meta_menu/arorder.php'),(20786032,16785,'./!/application/views/meta_menu/arorder.php'),(20786031,2540,'./!/application/views/meta_menu/arorder.php'),(20786030,2508,'./!/application/views/meta_menu/arorder.php'),(20786029,2459,'./!/application/views/meta_menu/arorder.php'),(20786028,6988,'./!/application/views/meta_menu/arorder.php'),(20786027,2205,'./!/application/views/meta_menu/arorder.php'),(20786026,2165,'./!/application/views/meta_menu/arorder.php'),(20786025,2044,'./!/application/views/meta_menu/arorder.php'),(20786024,10386,'./!/application/views/meta_menu/arorder.php'),(20786023,1740,'./!/application/views/meta_menu/arorder.php'),(20786022,1696,'./!/application/views/meta_menu/arorder.php'),(20786021,4940,'./!/application/views/meta_menu/arorder.php'),(20786020,1668,'./!/application/views/meta_menu/arorder.php'),(20786019,1564,'./!/application/views/meta_menu/arorder.php'),(20786018,5491,'./!/application/views/meta_menu/arorder.php'),(20786017,981,'./!/application/views/meta_menu/arorder.php'),(20786016,941,'./!/application/views/meta_menu/arorder.php'),(20786013,3333,'./!/application/views/meta_menu/arinvoice.php'),(20786012,3319,'./!/application/views/meta_menu/arinvoice.php'),(20786011,3090,'./!/application/views/meta_menu/arinvoice.php'),(20786010,2948,'./!/application/views/meta_menu/arinvoice.php'),(20786009,2508,'./!/application/views/meta_menu/arinvoice.php'),(20786008,19220,'./!/application/views/meta_menu/arinvoice.php'),(20786007,2459,'./!/application/views/meta_menu/arinvoice.php'),(20786006,6988,'./!/application/views/meta_menu/arinvoice.php'),(20786005,2267,'./!/application/views/meta_menu/arinvoice.php'),(20786004,2165,'./!/application/views/meta_menu/arinvoice.php'),(20786003,2044,'./!/application/views/meta_menu/arinvoice.php'),(20785982,14959,'./!/application/views/mage/sync.php'),(20785981,1740,'./!/application/views/mage/sync.php'),(20785980,14938,'./!/application/views/mage/sync.php'),(20785979,5271,'./!/application/views/mage/sync.php'),(20785978,14958,'./!/application/views/mage/sync.php'),(20785977,1354,'./!/application/views/mage/sync.php'),(20785976,8863,'./!/application/views/mage/sync.php'),(20785975,14957,'./!/application/views/mage/sync.php'),(20785974,315,'./!/application/views/mage/sync.php'),(20785936,3432,'./!/application/views/job/tab_view.php'),(20785935,3271,'./!/application/views/job/tab_view.php'),(20785934,11241,'./!/application/views/job/tab_view.php'),(20785933,15695,'./!/application/views/job/tab_view.php'),(20785932,2948,'./!/application/views/job/tab_view.php'),(20785931,2936,'./!/application/views/job/tab_view.php'),(20785930,9718,'./!/application/views/job/tab_view.php'),(20785929,2664,'./!/application/views/job/tab_view.php'),(20785928,9962,'./!/application/views/job/tab_view.php'),(20785927,4088,'./!/application/views/job/tab_view.php'),(20785926,11014,'./!/application/views/job/tab_view.php'),(20785925,12153,'./!/application/views/job/tab_view.php'),(20785924,2494,'./!/application/views/job/tab_view.php'),(20785923,9717,'./!/application/views/job/tab_view.php'),(20785922,18590,'./!/application/views/job/tab_view.php'),(20785921,16087,'./!/application/views/job/tab_view.php'),(20785920,15978,'./!/application/views/job/tab_view.php'),(20785919,18589,'./!/application/views/job/tab_view.php'),(20785918,18588,'./!/application/views/job/tab_view.php'),(20785917,15768,'./!/application/views/job/tab_view.php'),(20785916,2324,'./!/application/views/job/tab_view.php'),(20785915,15881,'./!/application/views/job/tab_view.php'),(20785914,17739,'./!/application/views/job/tab_view.php'),(20785913,18587,'./!/application/views/job/tab_view.php'),(20785912,18586,'./!/application/views/job/tab_view.php'),(20785885,12764,'./!/application/views/job/tab_prelim_request.php'),(20785884,13471,'./!/application/views/job/tab_prelim_request.php'),(20785882,15059,'./!/application/views/job/tab_activity.php'),(20786749,6164,'./!/application/views/zipcodealt/datatable.extra.php'),(20785881,16114,'./!/application/views/job/send_prelim_request_form.php'),(20785880,15942,'./!/application/views/job/send_prelim_request_form.php'),(20785879,5686,'./!/application/views/job/send_prelim_request_form.php'),(20785878,2459,'./!/application/views/job/send_prelim_request_form.php'),(20785877,16146,'./!/application/views/job/send_prelim_request_form.php'),(20785876,15975,'./!/application/views/job/send_prelim_request_form.php'),(20785875,1884,'./!/application/views/job/send_prelim_request_form.php'),(20785874,15940,'./!/application/views/job/send_prelim_request_form.php'),(20785873,1373,'./!/application/views/job/send_prelim_request_form.php'),(20785872,14092,'./!/application/views/job/send_prelim_request_form.php'),(20785870,19088,'./!/application/views/job/batch_send_prelim_request_select.php'),(20785869,19087,'./!/application/views/job/batch_send_prelim_request_select.php'),(20785842,4018,'./!/application/views/itemcategory/customer_group_discounts.php'),(20785841,6602,'./!/application/views/itemcategory/customer_group_discounts.php'),(20786747,2936,'./!/application/views/zipcodealt/datatable.extra.php'),(20785830,15318,'./!/application/views/item/mobile_manage_location.php'),(20785829,15317,'./!/application/views/item/mobile_manage_location.php'),(20785828,2702,'./!/application/views/item/mobile_manage_location.php'),(20785827,15316,'./!/application/views/item/mobile_manage_location.php'),(20785824,3295,'./!/application/views/item/compare_vendor_prices.php'),(20785823,3274,'./!/application/views/item/compare_vendor_prices.php'),(20785822,4295,'./!/application/views/item/compare_vendor_prices.php'),(20785821,2044,'./!/application/views/item/compare_vendor_prices.php'),(20785819,2404,'./!/application/views/item/ckeditor_info.php'),(20785818,14924,'./!/application/views/item/ckeditor_info.php'),(20785817,4532,'./!/application/views/item/ckeditor_info.php'),(20785732,19566,'./!/application/views/invcountbatch/enterCounts.php'),(20785587,2103,'./!/application/views/import_task/upload_form.php'),(20785579,16142,'./!/application/views/import_task/import_task_result.php'),(20785578,12903,'./!/application/views/import_task/import_task_result.php'),(20785577,16141,'./!/application/views/import_task/import_task_result.php'),(20785576,16140,'./!/application/views/import_task/import_task_result.php'),(20785731,19499,'./!/application/views/invcountbatch/enterCounts.php'),(20785573,3333,'./!/application/views/gltransvoucher/multi_attach_form.php'),(20785572,12764,'./!/application/views/gltransvoucher/multi_attach_form.php'),(20785571,2044,'./!/application/views/gltransvoucher/multi_attach_form.php'),(20785570,869,'./!/application/views/gltransvoucher/multi_attach_form.php'),(20785569,12140,'./!/application/views/gltransvoucher/multi_attach_form.php'),(20785565,4721,'./!/application/views/generic/split_view_table_edit.php'),(20785564,799,'./!/application/views/generic/split_view_table_edit.php'),(20785563,59,'./!/application/views/generic/split_view_table_edit.php'),(20785562,16439,'./!/application/views/generic/simple_table.php'),(20785561,2222,'./!/application/views/generic/simple_table.php'),(20785556,2751,'./!/application/views/generic/select.php'),(20785521,14652,'./!/application/views/generic/datatable.php'),(20785520,14638,'./!/application/views/generic/datatable.php'),(20785519,2849,'./!/application/views/generic/datatable.php'),(20785518,2738,'./!/application/views/generic/datatable.php'),(20785517,14636,'./!/application/views/generic/datatable.php'),(20785516,2702,'./!/application/views/generic/datatable.php'),(20785515,3444,'./!/application/views/generic/datatable.php'),(20785514,3777,'./!/application/views/generic/datatable.php'),(20785513,2401,'./!/application/views/generic/datatable.php'),(20785512,4789,'./!/application/views/generic/datatable.php'),(20785511,2044,'./!/application/views/generic/datatable.php'),(20785510,1963,'./!/application/views/generic/datatable.php'),(20785509,8677,'./!/application/views/generic/datatable.php'),(20785508,13334,'./!/application/views/generic/datatable.php'),(20785507,17980,'./!/application/views/generic/datatable.php'),(20785506,1753,'./!/application/views/generic/datatable.php'),(20785505,1427,'./!/application/views/generic/datatable.php'),(20785504,14603,'./!/application/views/generic/datatable.php'),(20785503,1354,'./!/application/views/generic/datatable.php'),(20785502,8311,'./!/application/views/generic/datatable.php'),(20785501,14600,'./!/application/views/generic/datatable.php'),(20785500,907,'./!/application/views/generic/datatable.php'),(20785499,14596,'./!/application/views/generic/datatable.php'),(20785498,573,'./!/application/views/generic/datatable.php'),(20785497,416,'./!/application/views/generic/datatable.php'),(20785496,14583,'./!/application/views/generic/datatable.php'),(20785490,541,'./!/application/views/generic/close_message.php'),(20785488,315,'./!/application/views/generic/back_message.php'),(20785487,13334,'./!/application/views/generic/ajax.php'),(20785486,2795,'./!/application/views/faxservices/log_tr_ringcentral.php'),(20785485,16139,'./!/application/views/faxservices/log_tr_ringcentral.php'),(20785676,18199,'./!/application/views/invcountbatch/assignCounting.form.binsAjax.php'),(20785201,2948,'./!/application/views/customer/fax_statments.php'),(20785200,2795,'./!/application/views/customer/fax_statments.php'),(20785199,2292,'./!/application/views/customer/fax_statments.php'),(20785198,7018,'./!/application/views/customer/fax_statments.php'),(20785197,4486,'./!/application/views/customer/fax_statments.php'),(17998919,14985,'!/application/views/contact/import.php'),(17998918,2324,'!/application/views/contact/import.php'),(17998917,1758,'!/application/views/contact/import.php'),(17998916,16900,'!/application/views/contact/import.php'),(17998915,14984,'!/application/views/contact/import.php'),(17998914,16899,'!/application/views/contact/import.php'),(17998913,5271,'!/application/views/contact/import.php'),(17998912,1429,'!/application/views/contact/import.php'),(17998911,981,'!/application/views/contact/import.php'),(17998910,869,'!/application/views/contact/import.php'),(17998909,697,'!/application/views/contact/import.php'),(17998908,14983,'!/application/views/contact/import.php'),(17998907,524,'!/application/views/contact/import.php'),(17998906,9624,'!/application/views/contact/import.php'),(17998905,9623,'!/application/views/contact/import.php'),(20781422,19810,'./!/application/controllers/invcountbatch_livecount.php'),(20786088,2601,'./!/application/views/meta_menu/customer.php'),(20787456,9327,'./adminarcompanyupd.php'),(20785749,2702,'./!/application/views/invcountbatch/liveCounts.php'),(20785741,1666,'./!/application/views/invcountbatch/liveCounts.php'),(20786648,2103,'./!/application/views/task/historyrpt.php'),(20786374,18435,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20785763,19502,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20785130,14650,'./!/application/views/chunks/ui_style_properties.php'),(20785547,17111,'./!/application/views/generic/paxTerminalCollect.php'),(20785129,14649,'./!/application/views/chunks/ui_style_properties.php'),(20785127,14647,'./!/application/views/chunks/ui_style_properties.php'),(20785126,3070,'./!/application/views/chunks/ui_style_properties.php'),(20785125,1,'./!/application/views/chunks/ui_style_properties.php'),(20785124,14643,'./!/application/views/chunks/ui_style_properties.php'),(20785122,14641,'./!/application/views/chunks/ui_style_properties.php'),(20785123,14642,'./!/application/views/chunks/ui_style_properties.php'),(20785121,14640,'./!/application/views/chunks/ui_style_properties.php'),(20785120,14639,'./!/application/views/chunks/ui_style_properties.php'),(20785119,2970,'./!/application/views/chunks/ui_style_properties.php'),(20785118,14637,'./!/application/views/chunks/ui_style_properties.php'),(20785117,14634,'./!/application/views/chunks/ui_style_properties.php'),(20785116,8579,'./!/application/views/chunks/ui_style_properties.php'),(20785115,8577,'./!/application/views/chunks/ui_style_properties.php'),(20785114,8573,'./!/application/views/chunks/ui_style_properties.php'),(20785113,14831,'./!/application/views/chunks/ui_style_properties.php'),(20785112,6505,'./!/application/views/chunks/ui_style_properties.php'),(20785111,14615,'./!/application/views/chunks/ui_style_properties.php'),(20785110,14614,'./!/application/views/chunks/ui_style_properties.php'),(20785109,14613,'./!/application/views/chunks/ui_style_properties.php'),(20785064,16371,'./!/application/views/batchimport/settings.php'),(20785063,15975,'./!/application/views/batchimport/settings.php'),(20785062,15974,'./!/application/views/batchimport/settings.php'),(20785047,1225,'./!/application/views/batchimport/batchimporterror_table.php'),(20785050,6384,'./!/application/views/batchimport/batchimporterror_table.php'),(20785049,9381,'./!/application/views/batchimport/batchimporterror_table.php'),(20785048,1775,'./!/application/views/batchimport/batchimporterror_table.php'),(20785045,3333,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785044,3274,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785043,3090,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785042,6384,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785041,9381,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785040,1770,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785039,7890,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785038,5081,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785037,1678,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785036,4940,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785031,3156,'./!/application/views/batchimport/batchimport_entry.php'),(20785030,15971,'./!/application/views/batchimport/batchimport_entry.php'),(20785029,1578,'./!/application/views/batchimport/batchimport_entry.php'),(20785028,10795,'./!/application/views/batchimport/batchimport_entry.php'),(20785027,15970,'./!/application/views/batchimport/batchimport_entry.php'),(20785026,1036,'./!/application/views/batchimport/batchimport_entry.php'),(20785025,5205,'./!/application/views/batchimport/batchimport_entry.php'),(20785024,573,'./!/application/views/batchimport/batchimport_entry.php'),(20785023,16253,'./!/application/views/b2buser/multiadd_select_form_footer.php'),(20785021,16257,'./!/application/views/b2buser/multiadd_create.php'),(20785764,19490,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20784945,16138,'./!/application/views/arinvoicepaymentdetail/import_sub_form.php'),(20784784,15874,'./!/application/views/archive_reports/review.php'),(20784783,2702,'./!/application/views/archive_reports/review.php'),(20784782,15751,'./!/application/views/archive_reports/review.php'),(20784781,2612,'./!/application/views/archive_reports/review.php'),(20784780,2044,'./!/application/views/archive_reports/review.php'),(20784779,737,'./!/application/views/archive_reports/review.php'),(20784559,16138,'./!/application/views/apbillpayment/import_sub_form.php'),(20784490,3886,'./!/application/views/process_payroll.php'),(20784489,1790,'./!/application/views/process_payroll.php'),(20784488,408,'./!/application/views/process_payroll.php'),(20784486,9643,'./!/application/views/login.php'),(20784485,14654,'./!/application/views/login.php'),(20784484,14653,'./!/application/views/login.php'),(20784483,9642,'./!/application/views/login.php'),(20784482,2622,'./!/application/views/login.php'),(20784481,12702,'./!/application/views/login.php'),(20784480,2234,'./!/application/views/login.php'),(20784479,7973,'./!/application/views/login.php'),(20784478,14610,'./!/application/views/login.php'),(20784477,14605,'./!/application/views/login.php'),(20784476,13643,'./!/application/views/login.php'),(20784475,9424,'./!/application/views/login.php'),(20784474,15269,'./!/application/views/login.php'),(20784473,7196,'./!/application/views/customer.php'),(20784472,2664,'./!/application/views/customer.php'),(20784471,675,'./!/application/views/customer.php'),(20784470,6224,'./!/application/views/customer.php'),(20784469,325,'./!/application/views/customer.php'),(20784468,13083,'./!/application/views/customer.php'),(20784467,4023,'./!/application/third_party/ringcentral-composer/ringcentral/psr7/tests/CachingStreamTest.php'),(20784466,4023,'./!/application/third_party/phpseclib_ssh2/Net/SSH2.php'),(20784465,4023,'./!/application/third_party/phpseclib_ssh2/Net/SSH1.php'),(20784464,4023,'./!/application/third_party/phpseclib_ssh2/Math/BigInteger.php'),(20784463,4023,'./!/application/third_party/phpseclib_ssh2/File/ASN1.php'),(20784462,4023,'./!/application/third_party/phpseclib_ssh2/Crypt/RSA.php'),(20784461,4023,'./!/application/third_party/phpseclib_ssh2/Crypt/Base.php'),(20784453,2070,'./!/application/models/smtp_users_model.php'),(20785105,4604,'./!/application/views/chunks/ui_style_properties.php'),(20785272,19555,'./!/application/views/customer/report_authnet_cards.php'),(20785633,3948,'./!/application/views/invcotransfer/email.php'),(20785275,19635,'./!/application/views/customer/report_authnet_cards.php'),(20784431,1598,'./!/application/models/job_model.php'),(20784430,5205,'./!/application/models/job_model.php'),(20785274,3090,'./!/application/views/customer/report_authnet_cards.php'),(20784427,3450,'./!/application/models/itemtransaction_model.php'),(20784426,3439,'./!/application/models/itemtransaction_model.php'),(20784425,3438,'./!/application/models/itemtransaction_model.php'),(20784424,6226,'./!/application/models/itemtransaction_model.php'),(20784418,3248,'./!/application/models/item_model.php'),(20784417,14841,'./!/application/models/item_model.php'),(20784276,19877,'./!/application/models/arinvoice_model.php'),(20784275,13556,'./!/application/models/arinvoice_model.php'),(20784274,18104,'./!/application/models/arinvoice_model.php'),(20784273,3179,'./!/application/models/arinvoice_model.php'),(20784272,15941,'./!/application/models/arinvoice_model.php'),(20784247,8402,'./!/application/model_collections/timeclock_collection.php'),(20784246,8428,'./!/application/model_collections/timeclock_collection.php'),(20784245,8393,'./!/application/model_collections/timeclock_collection.php'),(20784244,695,'./!/application/model_collections/timeclock_collection.php'),(20784243,6075,'./!/application/model_collections/timeclock_collection.php'),(20784242,3414,'./!/application/model_collections/premplweekpaydetail_collection.php'),(20784240,1598,'./!/application/model_collections/job_collection.php'),(20784239,5205,'./!/application/model_collections/job_collection.php'),(20805155,15012,'./invpoupd.php'),(20784237,2151,'./!/application/model_collections/invpo_collection.php'),(20784236,591,'./!/application/model_collections/invpo_collection.php'),(20784220,5310,'./!/application/model_collections/gltransvoucher_collection.php'),(20784219,5309,'./!/application/model_collections/gltransvoucher_collection.php'),(20784218,2270,'./!/application/model_collections/gltransvoucher_collection.php'),(20784217,5304,'./!/application/model_collections/gltransvoucher_collection.php'),(20784216,15969,'./!/application/model_collections/gltransvoucher_collection.php'),(20784215,1639,'./!/application/model_collections/gltransvoucher_collection.php'),(20784214,1482,'./!/application/model_collections/gltransvoucher_collection.php'),(20784213,1441,'./!/application/model_collections/gltransvoucher_collection.php'),(20784212,5299,'./!/application/model_collections/gltransvoucher_collection.php'),(20784211,42,'./!/application/model_collections/gltransvoucher_collection.php'),(20784210,40,'./!/application/model_collections/gltransvoucher_collection.php'),(20784206,3324,'./!/application/model_collections/check_collection.php'),(20784205,6054,'./!/application/model_collections/check_collection.php'),(20784200,5378,'./!/application/model_collections/ccpurchase_collection.php'),(20785596,13334,'./!/application/views/invbin/getForm.php'),(20784198,3421,'./!/application/model_collections/bank_deposit_collection.php'),(20784197,1973,'./!/application/model_collections/bank_deposit_collection.php'),(20785598,18756,'./!/application/views/invbin/getForm.php'),(20785597,19074,'./!/application/views/invbin/getForm.php'),(20784194,19877,'./!/application/model_collections/arorder_deposit_collection.php'),(20784193,5689,'./!/application/model_collections/arorder_deposit_collection.php'),(20784192,2208,'./!/application/model_collections/arorder_deposit_collection.php'),(20784191,673,'./!/application/model_collections/arorder_deposit_collection.php'),(20784188,4861,'./!/application/model_collections/arorder_collection.php'),(20784187,5492,'./!/application/model_collections/arorder_collection.php'),(20784186,16785,'./!/application/model_collections/arorder_collection.php'),(20784185,2540,'./!/application/model_collections/arorder_collection.php'),(20784182,17968,'./!/application/model_collections/arorder_collection.php'),(20784178,19877,'./!/application/model_collections/arinvoicepaymentdetail_collection.php'),(20784177,5689,'./!/application/model_collections/arinvoicepaymentdetail_collection.php'),(20784176,2208,'./!/application/model_collections/arinvoicepaymentdetail_collection.php'),(20784175,673,'./!/application/model_collections/arinvoicepaymentdetail_collection.php'),(20784174,479,'./!/application/model_collections/arinvoicepaymentdetail_collection.php'),(20784173,445,'./!/application/model_collections/arinvoicepaymentdetail_collection.php'),(20784172,5310,'./!/application/model_collections/arinvoice_collection.php'),(20784171,19877,'./!/application/model_collections/arinvoice_collection.php'),(20784170,5309,'./!/application/model_collections/arinvoice_collection.php'),(20784169,5378,'./!/application/model_collections/arinvoice_collection.php'),(20784168,3179,'./!/application/model_collections/arinvoice_collection.php'),(20784167,5388,'./!/application/model_collections/arinvoice_collection.php'),(20784166,5308,'./!/application/model_collections/arinvoice_collection.php'),(20784165,2225,'./!/application/model_collections/arinvoice_collection.php'),(20784164,2151,'./!/application/model_collections/arinvoice_collection.php'),(20784163,5304,'./!/application/model_collections/arinvoice_collection.php'),(20784162,5299,'./!/application/model_collections/arinvoice_collection.php'),(20784161,7679,'./!/application/model_collections/arinvoice_collection.php'),(20784159,543,'./!/application/model_collections/ap_bill_collection.php'),(20785600,1709,'./!/application/views/invbinitem/reassignByBarCode.php'),(20784160,2151,'./!/application/model_collections/ap_bill_collection.php'),(20784158,16227,'./!/application/libraries/zlien.php'),(20784157,16225,'./!/application/libraries/zlien.php'),(20784155,2702,'./!/application/libraries/taskbar.php'),(20784614,1,'./!/application/views/appointments/admin.php'),(20784148,8810,'./!/application/libraries/settings_form.php'),(20784147,3295,'./!/application/libraries/settings_form.php'),(20784100,799,'./!/application/libraries/select_form.php'),(20785605,19557,'./!/application/views/invbinitem/reassignByBarCode.php'),(20785604,19556,'./!/application/views/invbinitem/reassignByBarCode.php'),(20785603,16487,'./!/application/views/invbinitem/reassignByBarCode.php'),(20785602,1788,'./!/application/views/invbinitem/reassignByBarCode.php'),(20784098,13105,'./!/application/libraries/pdf.php'),(20784097,3913,'./!/application/libraries/pdf.php'),(20785601,13334,'./!/application/views/invbinitem/reassignByBarCode.php'),(20785677,17260,'./!/application/views/invcountbatch/assignCounting.form.getVarRecountItemsAjax.php'),(20784041,15968,'./!/application/libraries/faxservice.php'),(20784040,2234,'./!/application/libraries/faxservice.php'),(20784039,15967,'./!/application/libraries/faxservice.php'),(20784035,2751,'./!/application/libraries/datatable.php'),(20783998,16137,'./!/application/libraries/FixedInputFile.php'),(20783992,3520,'./!/application/core/MY_Loader.php'),(20785683,2751,'./!/application/views/invcountbatch/assignCounting.form.getVarRecountItemsAjax.php'),(20785682,2401,'./!/application/views/invcountbatch/assignCounting.form.getVarRecountItemsAjax.php'),(20785691,19639,'./!/application/views/invcountbatch/assignCounting.form.js.php'),(20784146,6141,'./!/application/libraries/settings_form.php'),(20783991,8232,'./!/application/core/MY_Controller.php'),(20783990,8508,'./!/application/core/MY_Controller.php'),(20783989,2702,'./!/application/core/MY_Controller.php'),(20784145,19243,'./!/application/libraries/settings_form.php'),(20784144,3252,'./!/application/libraries/settings_form.php'),(20783975,6164,'./!/application/controllers/zipcodealt.php'),(20784250,18124,'./!/application/models/appointment_model.php'),(20784249,18113,'./!/application/models/appointment_model.php'),(20785911,18585,'./!/application/views/job/tab_view.php'),(20785108,14608,'./!/application/views/chunks/ui_style_properties.php'),(20785178,16745,'./!/application/views/customer/appointment_report.php'),(20804999,1285,'./invpotoap.php'),(20804998,1284,'./invpotoap.php'),(20784140,19743,'./!/application/libraries/settings_form.php'),(20783968,15776,'./!/application/controllers/writeoffreason.php'),(20783967,15778,'./!/application/controllers/writeoffreason.php'),(20783966,2751,'./!/application/controllers/writeoffreason.php'),(20783965,8508,'./!/application/controllers/writeoffreason.php'),(20783964,2094,'./!/application/controllers/writeoffreason.php'),(20783963,1935,'./!/application/controllers/writeoffreason.php'),(20783962,20012,'./!/application/controllers/writeoffreason.php'),(20783961,15991,'./!/application/controllers/writeoffreason.php'),(20783960,1499,'./!/application/controllers/writeoffreason.php'),(20783959,941,'./!/application/controllers/writeoffreason.php'),(20783958,5205,'./!/application/controllers/writeoffreason.php'),(20781421,16671,'./!/application/controllers/invcountbatch_livecount.php'),(20783974,3432,'./!/application/controllers/zipcodealt.php'),(20783970,15349,'./!/application/controllers/zipcodealt.php'),(20783925,3414,'./!/application/controllers/vendor.php'),(20783924,4109,'./!/application/controllers/vendor.php'),(20783923,5701,'./!/application/controllers/vendor.php'),(20783922,8899,'./!/application/controllers/vendor.php'),(20783921,14982,'./!/application/controllers/vendor.php'),(20783920,20217,'./!/application/controllers/vendor.php'),(20783919,16216,'./!/application/controllers/vendor.php'),(20783918,3294,'./!/application/controllers/vendor.php'),(20783917,3292,'./!/application/controllers/vendor.php'),(20783916,15621,'./!/application/controllers/vendor.php'),(20783915,17703,'./!/application/controllers/vendor.php'),(20783914,17702,'./!/application/controllers/vendor.php'),(20783913,16561,'./!/application/controllers/vendor.php'),(20783912,16564,'./!/application/controllers/vendor.php'),(20783911,6141,'./!/application/controllers/vendor.php'),(20783910,15701,'./!/application/controllers/vendor.php'),(20783909,15714,'./!/application/controllers/vendor.php'),(20783908,15703,'./!/application/controllers/vendor.php'),(20783907,16433,'./!/application/controllers/vendor.php'),(20783906,15713,'./!/application/controllers/vendor.php'),(20783905,17449,'./!/application/controllers/vendor.php'),(20783904,3480,'./!/application/controllers/vendor.php'),(20783903,3274,'./!/application/controllers/vendor.php'),(20783902,14771,'./!/application/controllers/vendor.php'),(20783901,6176,'./!/application/controllers/vendor.php'),(20783900,15712,'./!/application/controllers/vendor.php'),(20783899,3156,'./!/application/controllers/vendor.php'),(20783898,3115,'./!/application/controllers/vendor.php'),(20783897,3097,'./!/application/controllers/vendor.php'),(20783896,3090,'./!/application/controllers/vendor.php'),(20783895,8546,'./!/application/controllers/vendor.php'),(20783894,3477,'./!/application/controllers/vendor.php'),(20783893,2936,'./!/application/controllers/vendor.php'),(20783892,2886,'./!/application/controllers/vendor.php'),(20783891,16436,'./!/application/controllers/vendor.php'),(20783890,2838,'./!/application/controllers/vendor.php'),(20783889,2795,'./!/application/controllers/vendor.php'),(20783888,17090,'./!/application/controllers/vendor.php'),(20783887,20011,'./!/application/controllers/vendor.php'),(20783886,15996,'./!/application/controllers/vendor.php'),(20783885,17089,'./!/application/controllers/vendor.php'),(20783884,11550,'./!/application/controllers/vendor.php'),(20783883,2738,'./!/application/controllers/vendor.php'),(20783882,8545,'./!/application/controllers/vendor.php'),(20783881,17306,'./!/application/controllers/vendor.php'),(20783880,4265,'./!/application/controllers/vendor.php'),(20783879,7674,'./!/application/controllers/vendor.php'),(20783878,12920,'./!/application/controllers/vendor.php'),(20783877,5239,'./!/application/controllers/vendor.php'),(20783876,2515,'./!/application/controllers/vendor.php'),(20783875,13818,'./!/application/controllers/vendor.php'),(20783874,2376,'./!/application/controllers/vendor.php'),(20783873,8741,'./!/application/controllers/vendor.php'),(20783872,2329,'./!/application/controllers/vendor.php'),(20783871,2325,'./!/application/controllers/vendor.php'),(20783870,2324,'./!/application/controllers/vendor.php'),(20783869,15611,'./!/application/controllers/vendor.php'),(20783868,2262,'./!/application/controllers/vendor.php'),(20783867,15746,'./!/application/controllers/vendor.php'),(20783866,15745,'./!/application/controllers/vendor.php'),(20783865,15744,'./!/application/controllers/vendor.php'),(20783746,15267,'./!/application/controllers/timeclock.php'),(20783745,10526,'./!/application/controllers/timeclock.php'),(20783744,3156,'./!/application/controllers/timeclock.php'),(20783743,10525,'./!/application/controllers/timeclock.php'),(20783742,11442,'./!/application/controllers/timeclock.php'),(20783741,10524,'./!/application/controllers/timeclock.php'),(20783740,8500,'./!/application/controllers/timeclock.php'),(20783739,8421,'./!/application/controllers/timeclock.php'),(20783738,4457,'./!/application/controllers/timeclock.php'),(20783737,10523,'./!/application/controllers/timeclock.php'),(20783736,8499,'./!/application/controllers/timeclock.php'),(20783735,8498,'./!/application/controllers/timeclock.php'),(20783734,8684,'./!/application/controllers/timeclock.php'),(20783733,8420,'./!/application/controllers/timeclock.php'),(20783732,8418,'./!/application/controllers/timeclock.php'),(20783731,8396,'./!/application/controllers/timeclock.php'),(20783730,1935,'./!/application/controllers/timeclock.php'),(20783729,8417,'./!/application/controllers/timeclock.php'),(20783710,8402,'./!/application/controllers/timecard.php'),(20783709,10105,'./!/application/controllers/timecard.php'),(20783708,3221,'./!/application/controllers/timecard.php'),(20783707,8437,'./!/application/controllers/timecard.php'),(20783706,8750,'./!/application/controllers/timecard.php'),(20783705,8780,'./!/application/controllers/timecard.php'),(20783704,8400,'./!/application/controllers/timecard.php'),(20783703,8748,'./!/application/controllers/timecard.php'),(20783702,7823,'./!/application/controllers/timecard.php'),(20783701,3118,'./!/application/controllers/timecard.php'),(20783700,3090,'./!/application/controllers/timecard.php'),(20783699,7739,'./!/application/controllers/timecard.php'),(20783698,3072,'./!/application/controllers/timecard.php'),(20783697,8436,'./!/application/controllers/timecard.php'),(20783696,4457,'./!/application/controllers/timecard.php'),(20783695,8434,'./!/application/controllers/timecard.php'),(20783694,10104,'./!/application/controllers/timecard.php'),(20783693,2812,'./!/application/controllers/timecard.php'),(20783692,2710,'./!/application/controllers/timecard.php'),(20783691,2702,'./!/application/controllers/timecard.php'),(20783690,2565,'./!/application/controllers/timecard.php'),(20783689,2529,'./!/application/controllers/timecard.php'),(20783688,8736,'./!/application/controllers/timecard.php'),(20783687,8861,'./!/application/controllers/timecard.php'),(20783686,8503,'./!/application/controllers/timecard.php'),(20783681,8502,'./!/application/controllers/timecard.php'),(20783682,2238,'./!/application/controllers/timecard.php'),(20783683,2292,'./!/application/controllers/timecard.php'),(20783684,8459,'./!/application/controllers/timecard.php'),(20783685,8693,'./!/application/controllers/timecard.php'),(20783679,8432,'./!/application/controllers/timecard.php'),(20783680,2208,'./!/application/controllers/timecard.php'),(20783647,14956,'./!/application/controllers/taskstatus.php'),(20783646,14955,'./!/application/controllers/taskstatus.php'),(20783645,1935,'./!/application/controllers/taskstatus.php'),(20783644,941,'./!/application/controllers/taskstatus.php'),(20783643,799,'./!/application/controllers/taskstatus.php'),(20783642,315,'./!/application/controllers/taskstatus.php'),(20783641,8125,'./!/application/controllers/taskstatus.php'),(20783640,59,'./!/application/controllers/taskstatus.php'),(20783613,14954,'./!/application/controllers/taskaction.php'),(20783612,14953,'./!/application/controllers/taskaction.php'),(20783611,1935,'./!/application/controllers/taskaction.php'),(20783610,941,'./!/application/controllers/taskaction.php'),(20783609,799,'./!/application/controllers/taskaction.php'),(20783608,315,'./!/application/controllers/taskaction.php'),(20783607,8125,'./!/application/controllers/taskaction.php'),(20783606,59,'./!/application/controllers/taskaction.php'),(20783605,10799,'./!/application/controllers/task.php'),(20783604,3252,'./!/application/controllers/task.php'),(20783603,17439,'./!/application/controllers/task.php'),(20783350,2936,'./!/application/controllers/salesman.php'),(20783349,3473,'./!/application/controllers/salesman.php'),(20783347,2324,'./!/application/controllers/salesman.php'),(20783348,19954,'./!/application/controllers/salesman.php'),(20783341,3661,'./!/application/controllers/rtmed.php'),(20783340,1354,'./!/application/controllers/rtmed.php'),(20784142,18899,'./!/application/libraries/settings_form.php'),(20783193,3434,'./!/application/controllers/premplweekpaydetail.php'),(20783192,15642,'./!/application/controllers/premplweekpaydetail.php'),(20783191,2565,'./!/application/controllers/premplweekpaydetail.php'),(20783190,2243,'./!/application/controllers/premplweekpaydetail.php'),(20783189,15641,'./!/application/controllers/premplweekpaydetail.php'),(20783188,9622,'./!/application/controllers/premplweekpaydetail.php'),(20783187,1564,'./!/application/controllers/premplweekpaydetail.php'),(20783186,1014,'./!/application/controllers/premplweekpaydetail.php'),(20783185,989,'./!/application/controllers/premplweekpaydetail.php'),(20783182,226,'./!/application/controllers/premplweekpaydetail.php'),(20783184,737,'./!/application/controllers/premplweekpaydetail.php'),(20783183,9492,'./!/application/controllers/premplweekpaydetail.php'),(20783181,3324,'./!/application/controllers/positivepay.php'),(20783180,16136,'./!/application/controllers/positivepay.php'),(20783179,16135,'./!/application/controllers/positivepay.php'),(20783178,3090,'./!/application/controllers/positivepay.php'),(20783177,6582,'./!/application/controllers/positivepay.php'),(20783176,16134,'./!/application/controllers/positivepay.php'),(20783175,16287,'./!/application/controllers/positivepay.php'),(20783174,2795,'./!/application/controllers/positivepay.php'),(20783173,16133,'./!/application/controllers/positivepay.php'),(20783172,16290,'./!/application/controllers/positivepay.php'),(20783171,16132,'./!/application/controllers/positivepay.php'),(20783170,16289,'./!/application/controllers/positivepay.php'),(20783169,16131,'./!/application/controllers/positivepay.php'),(20783168,16288,'./!/application/controllers/positivepay.php'),(20783167,4596,'./!/application/controllers/positivepay.php'),(20783166,16130,'./!/application/controllers/positivepay.php'),(20783165,16129,'./!/application/controllers/positivepay.php'),(20783164,16117,'./!/application/controllers/positivepay.php'),(20783163,2292,'./!/application/controllers/positivepay.php'),(20783162,16128,'./!/application/controllers/positivepay.php'),(20783161,16127,'./!/application/controllers/positivepay.php'),(20783160,1792,'./!/application/controllers/positivepay.php'),(20783159,17294,'./!/application/controllers/positivepay.php'),(20783158,16192,'./!/application/controllers/positivepay.php'),(20783157,1678,'./!/application/controllers/positivepay.php'),(20783156,16126,'./!/application/controllers/positivepay.php'),(20783155,1446,'./!/application/controllers/positivepay.php'),(20783154,11868,'./!/application/controllers/positivepay.php'),(20783153,10795,'./!/application/controllers/positivepay.php'),(20783152,16125,'./!/application/controllers/positivepay.php'),(20783151,1047,'./!/application/controllers/positivepay.php'),(20783150,16124,'./!/application/controllers/positivepay.php'),(20783149,16123,'./!/application/controllers/positivepay.php'),(20783148,16122,'./!/application/controllers/positivepay.php'),(20783147,17293,'./!/application/controllers/positivepay.php'),(20783146,16121,'./!/application/controllers/positivepay.php'),(20783138,16120,'./!/application/controllers/positivepay.php'),(20783139,484,'./!/application/controllers/positivepay.php'),(20783140,491,'./!/application/controllers/positivepay.php'),(20783141,16291,'./!/application/controllers/positivepay.php'),(20783142,16280,'./!/application/controllers/positivepay.php'),(20783143,737,'./!/application/controllers/positivepay.php'),(20783144,4602,'./!/application/controllers/positivepay.php'),(20783145,13033,'./!/application/controllers/positivepay.php'),(20783111,5338,'./!/application/controllers/payment_plan.php'),(20783110,5337,'./!/application/controllers/payment_plan.php'),(20783109,5335,'./!/application/controllers/payment_plan.php'),(20783108,5333,'./!/application/controllers/payment_plan.php'),(20783107,2671,'./!/application/controllers/payment_plan.php'),(20783106,5332,'./!/application/controllers/payment_plan.php'),(20783105,2292,'./!/application/controllers/payment_plan.php'),(20783103,5331,'./!/application/controllers/payment_plan.php'),(20783104,7911,'./!/application/controllers/payment_plan.php'),(20783426,3016,'./!/application/controllers/salestax.php'),(20783425,2936,'./!/application/controllers/salestax.php'),(20783973,2936,'./!/application/controllers/zipcodealt.php'),(20783972,4721,'./!/application/controllers/zipcodealt.php'),(20783971,19549,'./!/application/controllers/zipcodealt.php'),(20783969,524,'./!/application/controllers/zipcodealt.php'),(20785706,19560,'./!/application/views/invcountbatch/enterCounts.Header.php'),(20785705,541,'./!/application/views/invcountbatch/enterCounts.Header.php'),(20785704,19559,'./!/application/views/invcountbatch/enterCounts.Header.php'),(20785730,16393,'./!/application/views/invcountbatch/enterCounts.php'),(20785729,8508,'./!/application/views/invcountbatch/enterCounts.php'),(20785727,12097,'./!/application/views/invcountbatch/enterCounts.php'),(20785728,2702,'./!/application/views/invcountbatch/enterCounts.php'),(20785748,17917,'./!/application/views/invcountbatch/liveCounts.php'),(20785747,12097,'./!/application/views/invcountbatch/liveCounts.php'),(20785746,19567,'./!/application/views/invcountbatch/liveCounts.php'),(20785745,1963,'./!/application/views/invcountbatch/liveCounts.php'),(20785744,19641,'./!/application/views/invcountbatch/liveCounts.php'),(20786748,3432,'./!/application/views/zipcodealt/datatable.extra.php'),(20786746,2702,'./!/application/views/zipcodealt/datatable.extra.php'),(20786745,19568,'./!/application/views/zipcodealt/datatable.extra.php'),(20786744,941,'./!/application/views/zipcodealt/datatable.extra.php'),(20786743,15349,'./!/application/views/zipcodealt/datatable.extra.php'),(20786742,541,'./!/application/views/zipcodealt/datatable.extra.php'),(20786741,524,'./!/application/views/zipcodealt/datatable.extra.php'),(20786775,796,'./admin3dcart.php'),(20786774,7479,'./admin3dcart.php'),(20786773,5661,'./admin3dcart.php'),(20787452,20225,'./adminarcompanyupd.php'),(20793852,1703,'./aritemcalcreorderpoint.php'),(20793851,9920,'./aritemcalcreorderpoint.php'),(20791636,14051,'./arcim.php'),(20791635,14050,'./arcim.php'),(20792419,11026,'./arinvoicecalcint.php'),(20792418,14767,'./arinvoicecalcint.php'),(20792417,1668,'./arinvoicecalcint.php'),(20792416,5143,'./arinvoicecalcint.php'),(20792415,19580,'./arinvoicecalcint.php'),(20792414,19579,'./arinvoicecalcint.php'),(20792413,1626,'./arinvoicecalcint.php'),(20793116,18447,'./arinvoicereptax.php'),(20793115,18446,'./arinvoicereptax.php'),(20793114,6256,'./arinvoicereptax.php'),(20793113,18445,'./arinvoicereptax.php'),(20793112,11771,'./arinvoicereptax.php'),(20793111,15543,'./arinvoicereptax.php'),(20793110,2021,'./arinvoicereptax.php'),(20793109,18444,'./arinvoicereptax.php'),(20793265,4481,'./arinvoicestate.php'),(20794073,6238,'./arorder2invoice.php'),(20795161,20111,'./arordshipadd.php'),(20795160,14960,'./arordshipadd.php'),(20795378,442,'./arordshipview.php'),(20795465,8936,'./arordshipviewfpdf.php'),(20796534,1540,'./autofunctions.php'),(20796533,1499,'./autofunctions.php'),(20802951,3441,'./invitemactivity.php'),(20804997,8936,'./invpotoap.php'),(20805525,540,'./jobupd.php'),(20806072,5525,'./nporder.php'),(20806071,2137,'./nporder.php'),(20806070,18630,'./nporder.php'),(20806069,4608,'./nporder.php'),(20806068,17889,'./nporder.php'),(20806067,18690,'./nporder.php'),(20806066,20259,'./nporder.php'),(20806065,12090,'./nporder.php'),(20806064,19451,'./nporder.php'),(20806063,15847,'./nporder.php'),(20806062,14554,'./nporder.php'),(20806061,18689,'./nporder.php'),(20806060,13075,'./nporder.php'),(20806059,2103,'./nporder.php'),(20806058,19151,'./nporder.php'),(20806057,18030,'./nporder.php'),(20806056,1973,'./nporder.php'),(20806055,1963,'./nporder.php'),(20806054,8679,'./nporder.php'),(20806053,3706,'./nporder.php'),(20806052,14622,'./nporder.php'),(20806051,11855,'./nporder.php'),(20806050,7901,'./nporder.php'),(20806049,4721,'./nporder.php'),(20806048,18629,'./nporder.php'),(20806047,13540,'./nporder.php'),(20806046,13539,'./nporder.php'),(20806045,19279,'./nporder.php'),(20806044,19784,'./nporder.php'),(20806043,8677,'./nporder.php'),(20806042,1884,'./nporder.php'),(20806041,18099,'./nporder.php'),(20806040,17618,'./nporder.php'),(20806039,14160,'./nporder.php'),(20806038,18006,'./nporder.php'),(20806037,16237,'./nporder.php'),(20806036,1796,'./nporder.php'),(20806035,18005,'./nporder.php'),(20806034,1788,'./nporder.php'),(20806033,18004,'./nporder.php'),(20806032,1770,'./nporder.php'),(20806031,6171,'./nporder.php'),(20806030,9172,'./nporder.php'),(20806029,1758,'./nporder.php'),(20806028,8505,'./nporder.php'),(20806027,18688,'./nporder.php'),(20806026,1742,'./nporder.php'),(20806025,18687,'./nporder.php'),(20806024,5081,'./nporder.php'),(20806023,14104,'./nporder.php'),(20806022,18309,'./nporder.php'),(20806021,1709,'./nporder.php'),(20806020,1696,'./nporder.php'),(20806019,17968,'./nporder.php'),(20806018,17967,'./nporder.php'),(20806017,13999,'./nporder.php'),(20806016,1685,'./nporder.php'),(20779334,3333,'./!/application/controllers/arinvoicepaymentdetail.php'),(20814755,20174,'./includes/invfunctions.php'),(20814754,20173,'./includes/invfunctions.php'),(20814753,20172,'./includes/invfunctions.php'),(20814752,18104,'./includes/invfunctions.php'),(20814831,8859,'./includes/invoicesoldshipformat.php'),(20815287,19796,'./includes/classes/glvoucher.php'),(20815286,776,'./includes/classes/glvoucher.php'),(20815285,670,'./includes/classes/glvoucher.php'),(20781420,19489,'./!/application/controllers/invcountbatch_livecount.php'),(20781393,18200,'./!/application/controllers/invcountbatch.php'),(20781392,16614,'./!/application/controllers/invcountbatch.php'),(20781419,19295,'./!/application/controllers/invcountbatch_livecount.php'),(20812121,6259,'./includes/arstateviewfpdf.functions.php'),(20812120,3090,'./includes/arstateviewfpdf.functions.php'),(20812119,3072,'./includes/arstateviewfpdf.functions.php'),(20812118,6258,'./includes/arstateviewfpdf.functions.php'),(20812117,6257,'./includes/arstateviewfpdf.functions.php'),(20812116,6842,'./includes/arstateviewfpdf.functions.php'),(20812115,2363,'./includes/arstateviewfpdf.functions.php'),(20812114,2324,'./includes/arstateviewfpdf.functions.php'),(20812113,16417,'./includes/arstateviewfpdf.functions.php'),(20812107,1678,'./includes/arstateviewfpdf.functions.php'),(20812112,2222,'./includes/arstateviewfpdf.functions.php'),(20812111,6841,'./includes/arstateviewfpdf.functions.php'),(20812110,15299,'./includes/arstateviewfpdf.functions.php'),(20812109,6234,'./includes/arstateviewfpdf.functions.php'),(20786643,8862,'./!/application/views/task/historyrpt.php'),(20786644,15218,'./!/application/views/task/historyrpt.php'),(20786645,1682,'./!/application/views/task/historyrpt.php'),(20786646,10562,'./!/application/views/task/historyrpt.php'),(20787451,14049,'./adminarcompanyupd.php'),(20787450,9326,'./adminarcompanyupd.php'),(20787449,17222,'./adminarcompanyupd.php'),(20787448,18607,'./adminarcompanyupd.php'),(20787447,20061,'./adminarcompanyupd.php'),(20787446,15603,'./adminarcompanyupd.php'),(20787445,15789,'./adminarcompanyupd.php'),(20787444,13717,'./adminarcompanyupd.php'),(20787443,11788,'./adminarcompanyupd.php'),(20787442,10772,'./adminarcompanyupd.php'),(20787441,15718,'./adminarcompanyupd.php'),(20787440,20224,'./adminarcompanyupd.php'),(20787439,17820,'./adminarcompanyupd.php'),(20793850,1696,'./aritemcalcreorderpoint.php'),(20793626,5081,'./arinvoiceview.php'),(20793625,1709,'./arinvoiceview.php'),(20793624,18571,'./arinvoiceview.php'),(20793623,17807,'./arinvoiceview.php'),(20793346,19848,'./arinvoicesum.php'),(20789916,13421,'./adminsystemsettings.php'),(20791726,19769,'./arcustadd.php'),(20791725,17834,'./arcustadd.php'),(20792105,325,'./areft.php'),(20792104,315,'./areft.php'),(20792103,5144,'./areft.php'),(20792766,6072,'./arinvoicepayvoid.php'),(20793108,1963,'./arinvoicereptax.php'),(20793345,15120,'./arinvoicesum.php'),(20793344,1666,'./arinvoicesum.php'),(20793343,19107,'./arinvoicesum.php'),(20793342,4111,'./arinvoicesum.php'),(20795159,869,'./arordshipadd.php'),(20796532,10541,'./autofunctions.php'),(20796531,989,'./autofunctions.php'),(20797001,59,'./costcode.php'),(20802588,16212,'./invcotransfer.php'),(20802587,1770,'./invcotransfer.php'),(20802586,1750,'./invcotransfer.php'),(20802660,13823,'./inventory_adjustments.php'),(20802659,9492,'./inventory_adjustments.php'),(20802847,8936,'./invexportimport.php'),(20802846,1047,'./invexportimport.php'),(20802845,14663,'./invexportimport.php'),(20802844,12992,'./invexportimport.php'),(20802843,12991,'./invexportimport.php'),(20802842,12990,'./invexportimport.php'),(20802841,315,'./invexportimport.php'),(20805724,1731,'./lookupitem_alt.php'),(20805723,1709,'./lookupitem_alt.php'),(20805722,3661,'./lookupitem_alt.php'),(20805721,1696,'./lookupitem_alt.php'),(20805720,1666,'./lookupitem_alt.php'),(20805719,6368,'./lookupitem_alt.php'),(20805718,6367,'./lookupitem_alt.php'),(20805717,869,'./lookupitem_alt.php'),(20806477,981,'./npordersave.php'),(20806476,19267,'./npordersave.php'),(20806475,6228,'./npordersave.php'),(20811638,659,'./includes/arfunctions.php'),(20811637,9492,'./includes/arfunctions.php'),(20781418,2137,'./!/application/controllers/invcountbatch_livecount.php'),(20781417,19612,'./!/application/controllers/invcountbatch_livecount.php'),(20781416,19809,'./!/application/controllers/invcountbatch_livecount.php'),(20781415,16669,'./!/application/controllers/invcountbatch_livecount.php'),(20781414,19720,'./!/application/controllers/invcountbatch_livecount.php'),(20781413,19544,'./!/application/controllers/invcountbatch_livecount.php'),(20781412,1788,'./!/application/controllers/invcountbatch_livecount.php'),(20781411,13334,'./!/application/controllers/invcountbatch_livecount.php'),(20781410,1696,'./!/application/controllers/invcountbatch_livecount.php'),(20781409,1666,'./!/application/controllers/invcountbatch_livecount.php'),(20781408,19808,'./!/application/controllers/invcountbatch_livecount.php'),(20781399,658,'./!/application/controllers/invcountbatch_livecount.php'),(20781400,16528,'./!/application/controllers/invcountbatch_livecount.php'),(20781401,19292,'./!/application/controllers/invcountbatch_livecount.php'),(20781402,19536,'./!/application/controllers/invcountbatch_livecount.php'),(20781403,869,'./!/application/controllers/invcountbatch_livecount.php'),(20781404,5407,'./!/application/controllers/invcountbatch_livecount.php'),(20781405,19293,'./!/application/controllers/invcountbatch_livecount.php'),(20781406,19294,'./!/application/controllers/invcountbatch_livecount.php'),(20781407,19360,'./!/application/controllers/invcountbatch_livecount.php'),(20784762,10525,'./!/application/views/appointments/summary.php'),(20785910,13484,'./!/application/views/job/tab_view.php'),(20784613,17485,'./!/application/views/appointments/admin.php'),(20784612,3477,'./!/application/views/appointments/admin.php'),(20784549,3090,'./!/application/views/amazon/import_order_selection_table.php'),(20784611,17484,'./!/application/views/appointments/admin.php'),(20784610,8508,'./!/application/views/appointments/admin.php'),(20784608,19631,'./!/application/views/appointments/admin.php'),(20784609,17063,'./!/application/views/appointments/admin.php'),(20783224,3156,'./!/application/controllers/priceoverriderequest.php'),(20783222,17031,'./!/application/controllers/priceoverriderequest.php'),(20784143,18199,'./!/application/libraries/settings_form.php'),(20784312,4861,'./!/application/models/arorder_model.php'),(20784396,18104,'./!/application/models/inventorylocation_model.php'),(20783088,5130,'./!/application/controllers/mobilepos.php'),(20783087,1935,'./!/application/controllers/mobilepos.php'),(20783082,869,'./!/application/controllers/mobilepos.php'),(20783083,1709,'./!/application/controllers/mobilepos.php'),(20783084,1794,'./!/application/controllers/mobilepos.php'),(20783085,14830,'./!/application/controllers/mobilepos.php'),(20783086,19741,'./!/application/controllers/mobilepos.php'),(20783076,19877,'./!/application/controllers/main.php'),(20783075,3890,'./!/application/controllers/main.php'),(20783074,3886,'./!/application/controllers/main.php'),(20783073,14348,'./!/application/controllers/main.php'),(20783072,3381,'./!/application/controllers/main.php'),(20783071,11286,'./!/application/controllers/main.php'),(20783070,10740,'./!/application/controllers/main.php'),(20783069,10905,'./!/application/controllers/main.php'),(20783068,10746,'./!/application/controllers/main.php'),(20783067,3402,'./!/application/controllers/main.php'),(20783066,15390,'./!/application/controllers/main.php'),(20783065,3883,'./!/application/controllers/main.php'),(20783064,19198,'./!/application/controllers/main.php'),(20783063,16483,'./!/application/controllers/main.php'),(20783062,19192,'./!/application/controllers/main.php'),(20783061,16482,'./!/application/controllers/main.php'),(20783060,17960,'./!/application/controllers/main.php'),(20783059,7949,'./!/application/controllers/main.php'),(20783058,3882,'./!/application/controllers/main.php'),(20783057,3881,'./!/application/controllers/main.php'),(20783056,5356,'./!/application/controllers/main.php'),(20783055,8318,'./!/application/controllers/main.php'),(20783054,6727,'./!/application/controllers/main.php'),(20783053,3870,'./!/application/controllers/main.php'),(20783052,4990,'./!/application/controllers/main.php'),(20783051,19492,'./!/application/controllers/main.php'),(20783050,19297,'./!/application/controllers/main.php'),(20783049,9468,'./!/application/controllers/main.php'),(20783048,14569,'./!/application/controllers/main.php'),(20783047,8901,'./!/application/controllers/main.php'),(20783046,3299,'./!/application/controllers/main.php'),(20783045,8872,'./!/application/controllers/main.php'),(20783044,3867,'./!/application/controllers/main.php'),(20783043,15704,'./!/application/controllers/main.php'),(20783042,15703,'./!/application/controllers/main.php'),(20783041,16433,'./!/application/controllers/main.php'),(20783040,7946,'./!/application/controllers/main.php'),(20783039,13423,'./!/application/controllers/main.php'),(20783038,3480,'./!/application/controllers/main.php'),(20783037,3274,'./!/application/controllers/main.php'),(20783036,3271,'./!/application/controllers/main.php'),(20783035,16210,'./!/application/controllers/main.php'),(20783034,14336,'./!/application/controllers/main.php'),(20783033,13180,'./!/application/controllers/main.php'),(20783032,13219,'./!/application/controllers/main.php'),(20783031,11470,'./!/application/controllers/main.php'),(20783030,3479,'./!/application/controllers/main.php'),(20783029,14792,'./!/application/controllers/main.php'),(20783028,15963,'./!/application/controllers/main.php'),(20783027,11290,'./!/application/controllers/main.php'),(20783026,10505,'./!/application/controllers/main.php'),(20783025,19080,'./!/application/controllers/main.php'),(20783024,7938,'./!/application/controllers/main.php'),(20783023,13100,'./!/application/controllers/main.php'),(20783022,13199,'./!/application/controllers/main.php'),(20783021,3130,'./!/application/controllers/main.php'),(20783020,20208,'./!/application/controllers/main.php'),(20783019,19471,'./!/application/controllers/main.php'),(20783018,16673,'./!/application/controllers/main.php'),(20783017,16783,'./!/application/controllers/main.php'),(20783016,4015,'./!/application/controllers/main.php'),(20783015,3072,'./!/application/controllers/main.php'),(20783014,8449,'./!/application/controllers/main.php'),(20783013,5733,'./!/application/controllers/main.php'),(20783012,3855,'./!/application/controllers/main.php'),(20783011,8452,'./!/application/controllers/main.php'),(20783010,8446,'./!/application/controllers/main.php'),(20783009,8425,'./!/application/controllers/main.php'),(20783008,11442,'./!/application/controllers/main.php'),(20783007,19950,'./!/application/controllers/main.php'),(20783006,19949,'./!/application/controllers/main.php'),(20783005,19948,'./!/application/controllers/main.php'),(20783004,11275,'./!/application/controllers/main.php'),(20783003,10558,'./!/application/controllers/main.php'),(20783002,13081,'./!/application/controllers/main.php'),(20783001,7936,'./!/application/controllers/main.php'),(20783000,15538,'./!/application/controllers/main.php'),(20782999,14956,'./!/application/controllers/main.php'),(20782998,14954,'./!/application/controllers/main.php'),(20782997,14952,'./!/application/controllers/main.php'),(20782996,8989,'./!/application/controllers/main.php'),(20782995,14644,'./!/application/controllers/main.php'),(20782994,14169,'./!/application/controllers/main.php'),(20782993,9236,'./!/application/controllers/main.php'),(20782992,9198,'./!/application/controllers/main.php'),(20782991,9244,'./!/application/controllers/main.php'),(20782990,3853,'./!/application/controllers/main.php'),(20782989,11272,'./!/application/controllers/main.php'),(20782988,3849,'./!/application/controllers/main.php'),(20782987,2950,'./!/application/controllers/main.php'),(20782986,12171,'./!/application/controllers/main.php'),(20782985,8104,'./!/application/controllers/main.php'),(20782984,3984,'./!/application/controllers/main.php'),(20782983,3845,'./!/application/controllers/main.php'),(20782982,14699,'./!/application/controllers/main.php'),(20782981,7645,'./!/application/controllers/main.php'),(20782980,16550,'./!/application/controllers/main.php'),(20782979,19941,'./!/application/controllers/main.php'),(20782978,16475,'./!/application/controllers/main.php'),(20782977,14323,'./!/application/controllers/main.php'),(20782976,11267,'./!/application/controllers/main.php'),(20782975,18901,'./!/application/controllers/main.php'),(20782974,3838,'./!/application/controllers/main.php'),(20782973,16949,'./!/application/controllers/main.php'),(20782972,17292,'./!/application/controllers/main.php'),(20782971,7935,'./!/application/controllers/main.php'),(20782970,17228,'./!/application/controllers/main.php'),(20782969,18159,'./!/application/controllers/main.php'),(20782968,14497,'./!/application/controllers/main.php'),(20782967,18215,'./!/application/controllers/main.php'),(20782966,12172,'./!/application/controllers/main.php'),(20782965,4153,'./!/application/controllers/main.php'),(20782964,7933,'./!/application/controllers/main.php'),(20782963,18147,'./!/application/controllers/main.php'),(20782962,7932,'./!/application/controllers/main.php'),(20782961,17366,'./!/application/controllers/main.php'),(20782960,9521,'./!/application/controllers/main.php'),(20782959,6609,'./!/application/controllers/main.php'),(20782958,13968,'./!/application/controllers/main.php'),(20782957,2805,'./!/application/controllers/main.php'),(20782956,5520,'./!/application/controllers/main.php'),(20782955,9528,'./!/application/controllers/main.php'),(20782954,7926,'./!/application/controllers/main.php'),(20782953,5492,'./!/application/controllers/main.php'),(20782952,7924,'./!/application/controllers/main.php'),(20782951,5518,'./!/application/controllers/main.php'),(20782950,16275,'./!/application/controllers/main.php'),(20782949,2747,'./!/application/controllers/main.php'),(20782948,7175,'./!/application/controllers/main.php'),(20782947,3813,'./!/application/controllers/main.php'),(20782946,3811,'./!/application/controllers/main.php'),(20782945,3812,'./!/application/controllers/main.php'),(20782944,20203,'./!/application/controllers/main.php'),(20782943,16481,'./!/application/controllers/main.php'),(20782942,12169,'./!/application/controllers/main.php'),(20782941,2682,'./!/application/controllers/main.php'),(20782940,3807,'./!/application/controllers/main.php'),(20782939,16480,'./!/application/controllers/main.php'),(20782938,19333,'./!/application/controllers/main.php'),(20782937,2671,'./!/application/controllers/main.php'),(20782936,13317,'./!/application/controllers/main.php'),(20782935,7174,'./!/application/controllers/main.php'),(20782934,6765,'./!/application/controllers/main.php'),(20782933,4653,'./!/application/controllers/main.php'),(20782932,18347,'./!/application/controllers/main.php'),(20782931,10855,'./!/application/controllers/main.php'),(20782930,13405,'./!/application/controllers/main.php'),(20782929,11131,'./!/application/controllers/main.php'),(20782928,3800,'./!/application/controllers/main.php'),(20782927,6127,'./!/application/controllers/main.php'),(20782926,5467,'./!/application/controllers/main.php'),(20782925,15224,'./!/application/controllers/main.php'),(20782924,3797,'./!/application/controllers/main.php'),(20782923,16522,'./!/application/controllers/main.php'),(20782922,11130,'./!/application/controllers/main.php'),(20782921,17959,'./!/application/controllers/main.php'),(20782920,16781,'./!/application/controllers/main.php'),(20782919,16785,'./!/application/controllers/main.php'),(20782918,13884,'./!/application/controllers/main.php'),(20782917,19947,'./!/application/controllers/main.php'),(20782916,19946,'./!/application/controllers/main.php'),(20782915,5693,'./!/application/controllers/main.php'),(20782914,17291,'./!/application/controllers/main.php'),(20782913,3794,'./!/application/controllers/main.php'),(20782912,14632,'./!/application/controllers/main.php'),(20782911,7063,'./!/application/controllers/main.php'),(20782910,3793,'./!/application/controllers/main.php'),(20782909,18214,'./!/application/controllers/main.php'),(20782908,3792,'./!/application/controllers/main.php'),(20782907,10904,'./!/application/controllers/main.php'),(20782906,11557,'./!/application/controllers/main.php'),(20782905,3789,'./!/application/controllers/main.php'),(20782904,4034,'./!/application/controllers/main.php'),(20782903,3788,'./!/application/controllers/main.php'),(20782902,7921,'./!/application/controllers/main.php'),(20782901,4857,'./!/application/controllers/main.php'),(20782900,19531,'./!/application/controllers/main.php'),(20782899,17174,'./!/application/controllers/main.php'),(20782898,13182,'./!/application/controllers/main.php'),(20782897,11972,'./!/application/controllers/main.php'),(20782896,9835,'./!/application/controllers/main.php'),(20782895,2501,'./!/application/controllers/main.php'),(20782894,11129,'./!/application/controllers/main.php'),(20782893,11556,'./!/application/controllers/main.php'),(20782892,10492,'./!/application/controllers/main.php'),(20782891,11555,'./!/application/controllers/main.php'),(20782890,3781,'./!/application/controllers/main.php'),(20782888,3778,'./!/application/controllers/main.php'),(20782889,3779,'./!/application/controllers/main.php'),(20782887,17442,'./!/application/controllers/main.php'),(20782886,9826,'./!/application/controllers/main.php'),(20782885,7918,'./!/application/controllers/main.php'),(20782884,19945,'./!/application/controllers/main.php'),(20782883,15356,'./!/application/controllers/main.php'),(20782882,3777,'./!/application/controllers/main.php'),(20782881,3774,'./!/application/controllers/main.php'),(20782880,3773,'./!/application/controllers/main.php'),(20782879,5750,'./!/application/controllers/main.php'),(20782878,4033,'./!/application/controllers/main.php'),(20782877,2480,'./!/application/controllers/main.php'),(20782341,14981,'./!/application/controllers/mage.php'),(20782340,14947,'./!/application/controllers/mage.php'),(20782339,14946,'./!/application/controllers/mage.php'),(20782338,14945,'./!/application/controllers/mage.php'),(20782337,14944,'./!/application/controllers/mage.php'),(20782336,14980,'./!/application/controllers/mage.php'),(20782335,14943,'./!/application/controllers/mage.php'),(20782334,14942,'./!/application/controllers/mage.php'),(20782333,8508,'./!/application/controllers/mage.php'),(20782332,2664,'./!/application/controllers/mage.php'),(20782331,2537,'./!/application/controllers/mage.php'),(20782330,7708,'./!/application/controllers/mage.php'),(20782329,1935,'./!/application/controllers/mage.php'),(20782328,14941,'./!/application/controllers/mage.php'),(20782327,14940,'./!/application/controllers/mage.php'),(20782326,14939,'./!/application/controllers/mage.php'),(20782325,1726,'./!/application/controllers/mage.php'),(20782324,1639,'./!/application/controllers/mage.php'),(20782323,9292,'./!/application/controllers/mage.php'),(20782322,14938,'./!/application/controllers/mage.php'),(20782321,1476,'./!/application/controllers/mage.php'),(20782300,12841,'./!/application/controllers/login.php'),(20782876,16780,'./!/application/controllers/main.php'),(20782875,5749,'./!/application/controllers/main.php'),(20782874,3767,'./!/application/controllers/main.php'),(20782873,3988,'./!/application/controllers/main.php'),(20782872,3762,'./!/application/controllers/main.php'),(20782871,3760,'./!/application/controllers/main.php'),(20782870,3761,'./!/application/controllers/main.php'),(20782869,3759,'./!/application/controllers/main.php'),(20782868,3756,'./!/application/controllers/main.php'),(20782867,3753,'./!/application/controllers/main.php'),(20782866,3752,'./!/application/controllers/main.php'),(20782865,3751,'./!/application/controllers/main.php'),(20782864,12232,'./!/application/controllers/main.php'),(20782863,7619,'./!/application/controllers/main.php'),(20782862,2487,'./!/application/controllers/main.php'),(20782861,4095,'./!/application/controllers/main.php'),(20782857,2415,'./!/application/controllers/main.php'),(20782858,17022,'./!/application/controllers/main.php'),(20782859,17023,'./!/application/controllers/main.php'),(20782860,3747,'./!/application/controllers/main.php'),(20782855,6670,'./!/application/controllers/main.php'),(20782856,5085,'./!/application/controllers/main.php'),(20782298,2751,'./!/application/controllers/jobtype.php'),(20782297,8508,'./!/application/controllers/jobtype.php'),(20782296,2094,'./!/application/controllers/jobtype.php'),(20782295,15871,'./!/application/controllers/jobtype.php'),(20782294,5061,'./!/application/controllers/jobtype.php'),(20782293,941,'./!/application/controllers/jobtype.php'),(20782292,5205,'./!/application/controllers/jobtype.php'),(20782291,541,'./!/application/controllers/jobtype.php'),(20782290,315,'./!/application/controllers/jobtype.php'),(20782289,59,'./!/application/controllers/jobtype.php'),(20781747,8260,'./!/application/controllers/item.php'),(20781746,18918,'./!/application/controllers/item.php'),(20781745,3274,'./!/application/controllers/item.php'),(20781744,3269,'./!/application/controllers/item.php'),(20781743,3238,'./!/application/controllers/item.php'),(20781742,18899,'./!/application/controllers/item.php'),(20781741,3165,'./!/application/controllers/item.php'),(20781740,19149,'./!/application/controllers/item.php'),(20781739,19148,'./!/application/controllers/item.php'),(20781738,19799,'./!/application/controllers/item.php'),(20781737,19798,'./!/application/controllers/item.php'),(20781736,11276,'./!/application/controllers/item.php'),(20781735,11704,'./!/application/controllers/item.php'),(20781734,19626,'./!/application/controllers/item.php'),(20781733,6964,'./!/application/controllers/item.php'),(20781398,19807,'./!/application/controllers/invcountbatch_livecount.php'),(20781397,315,'./!/application/controllers/invcountbatch_livecount.php'),(20781396,6669,'./!/application/controllers/invcountbatch_livecount.php'),(20781395,14832,'./!/application/controllers/invcountbatch_livecount.php'),(20781394,19806,'./!/application/controllers/invcountbatch_livecount.php'),(20782227,3421,'./!/application/controllers/job.php'),(20782226,13556,'./!/application/controllers/job.php'),(20782225,17688,'./!/application/controllers/job.php'),(20782224,3319,'./!/application/controllers/job.php'),(20782223,15640,'./!/application/controllers/job.php'),(20782222,3252,'./!/application/controllers/job.php'),(20782221,6176,'./!/application/controllers/job.php'),(20782220,18899,'./!/application/controllers/job.php'),(20782219,19288,'./!/application/controllers/job.php'),(20782218,3156,'./!/application/controllers/job.php'),(20782217,16115,'./!/application/controllers/job.php'),(20782216,17791,'./!/application/controllers/job.php'),(20782215,11241,'./!/application/controllers/job.php'),(20782214,15695,'./!/application/controllers/job.php'),(20782213,16148,'./!/application/controllers/job.php'),(20782212,7069,'./!/application/controllers/job.php'),(20782211,2948,'./!/application/controllers/job.php'),(20782210,2936,'./!/application/controllers/job.php'),(20782209,3434,'./!/application/controllers/job.php'),(20782208,4733,'./!/application/controllers/job.php'),(20782207,9718,'./!/application/controllers/job.php'),(20782206,9966,'./!/application/controllers/job.php'),(20782205,2795,'./!/application/controllers/job.php'),(20782204,17946,'./!/application/controllers/job.php'),(20782203,16114,'./!/application/controllers/job.php'),(20782202,16274,'./!/application/controllers/job.php'),(20782201,17945,'./!/application/controllers/job.php'),(20782200,11761,'./!/application/controllers/job.php'),(20782199,2751,'./!/application/controllers/job.php'),(20782198,2738,'./!/application/controllers/job.php'),(20782197,16113,'./!/application/controllers/job.php'),(20782196,10678,'./!/application/controllers/job.php'),(20782195,17168,'./!/application/controllers/job.php'),(20782194,17167,'./!/application/controllers/job.php'),(20782193,2676,'./!/application/controllers/job.php'),(20782192,19738,'./!/application/controllers/job.php'),(20782191,9965,'./!/application/controllers/job.php'),(20782190,15957,'./!/application/controllers/job.php'),(20782189,15956,'./!/application/controllers/job.php'),(20782188,9964,'./!/application/controllers/job.php'),(20782187,9963,'./!/application/controllers/job.php'),(20782186,16231,'./!/application/controllers/job.php'),(20782185,16312,'./!/application/controllers/job.php'),(20782184,11441,'./!/application/controllers/job.php'),(20782183,9962,'./!/application/controllers/job.php'),(20782182,2601,'./!/application/controllers/job.php'),(20782181,16112,'./!/application/controllers/job.php'),(20782180,11433,'./!/application/controllers/job.php'),(20782179,15601,'./!/application/controllers/job.php'),(20782178,9835,'./!/application/controllers/job.php'),(20782177,10638,'./!/application/controllers/job.php'),(20782176,8959,'./!/application/controllers/job.php'),(20782175,9717,'./!/application/controllers/job.php'),(20782174,16111,'./!/application/controllers/job.php'),(20782173,2459,'./!/application/controllers/job.php'),(20782172,16110,'./!/application/controllers/job.php'),(20782171,16109,'./!/application/controllers/job.php'),(20782170,16108,'./!/application/controllers/job.php'),(20782169,16107,'./!/application/controllers/job.php'),(20782168,17166,'./!/application/controllers/job.php'),(20782167,16087,'./!/application/controllers/job.php'),(20782166,16106,'./!/application/controllers/job.php'),(20782165,16105,'./!/application/controllers/job.php'),(20782164,17165,'./!/application/controllers/job.php'),(20782163,15768,'./!/application/controllers/job.php'),(20782162,17500,'./!/application/controllers/job.php'),(20782161,15361,'./!/application/controllers/job.php'),(20782160,16104,'./!/application/controllers/job.php'),(20782159,15918,'./!/application/controllers/job.php'),(20782158,18057,'./!/application/controllers/job.php'),(20782157,2225,'./!/application/controllers/job.php'),(20782156,8214,'./!/application/controllers/job.php'),(20782155,2200,'./!/application/controllers/job.php'),(20782154,18384,'./!/application/controllers/job.php'),(20782153,18383,'./!/application/controllers/job.php'),(20782152,18063,'./!/application/controllers/job.php'),(20782151,19203,'./!/application/controllers/job.php'),(20782150,19202,'./!/application/controllers/job.php'),(20782149,18920,'./!/application/controllers/job.php'),(20782148,19201,'./!/application/controllers/job.php'),(20782147,19200,'./!/application/controllers/job.php'),(20782146,5495,'./!/application/controllers/job.php'),(20782145,15917,'./!/application/controllers/job.php'),(20782144,2094,'./!/application/controllers/job.php'),(20782143,16370,'./!/application/controllers/job.php'),(20782142,2103,'./!/application/controllers/job.php'),(20782141,1973,'./!/application/controllers/job.php'),(20782140,1963,'./!/application/controllers/job.php'),(20782139,1935,'./!/application/controllers/job.php'),(20782138,16311,'./!/application/controllers/job.php'),(20782137,1884,'./!/application/controllers/job.php'),(20782136,16369,'./!/application/controllers/job.php'),(20782135,16103,'./!/application/controllers/job.php'),(20782134,15880,'./!/application/controllers/job.php'),(20782133,15639,'./!/application/controllers/job.php'),(20782132,5061,'./!/application/controllers/job.php'),(20782131,16230,'./!/application/controllers/job.php'),(20782130,19199,'./!/application/controllers/job.php'),(20782129,16102,'./!/application/controllers/job.php'),(20782128,15797,'./!/application/controllers/job.php'),(20782127,18062,'./!/application/controllers/job.php'),(20782126,9981,'./!/application/controllers/job.php'),(20782125,16391,'./!/application/controllers/job.php'),(20782124,1743,'./!/application/controllers/job.php'),(20782123,17944,'./!/application/controllers/job.php'),(20782122,15955,'./!/application/controllers/job.php'),(20782121,15954,'./!/application/controllers/job.php'),(20782120,15638,'./!/application/controllers/job.php'),(20782119,9622,'./!/application/controllers/job.php'),(20782118,15953,'./!/application/controllers/job.php'),(20782117,15952,'./!/application/controllers/job.php'),(20782116,15877,'./!/application/controllers/job.php'),(20782115,17943,'./!/application/controllers/job.php'),(20782114,18061,'./!/application/controllers/job.php'),(20782113,18060,'./!/application/controllers/job.php'),(20782112,9390,'./!/application/controllers/job.php'),(20782111,5081,'./!/application/controllers/job.php'),(20782110,17790,'./!/application/controllers/job.php'),(20782109,15600,'./!/application/controllers/job.php'),(20782108,4940,'./!/application/controllers/job.php'),(20782107,1668,'./!/application/controllers/job.php'),(20782106,1659,'./!/application/controllers/job.php'),(20782105,17942,'./!/application/controllers/job.php'),(20782104,1598,'./!/application/controllers/job.php'),(20782103,16101,'./!/application/controllers/job.php'),(20782102,7370,'./!/application/controllers/job.php'),(20782101,1557,'./!/application/controllers/job.php'),(20780875,2751,'./!/application/controllers/interestchargeoption.php'),(20780874,8508,'./!/application/controllers/interestchargeoption.php'),(20780873,2094,'./!/application/controllers/interestchargeoption.php'),(20780872,15870,'./!/application/controllers/interestchargeoption.php'),(20780871,15869,'./!/application/controllers/interestchargeoption.php'),(20780870,15868,'./!/application/controllers/interestchargeoption.php'),(20780869,941,'./!/application/controllers/interestchargeoption.php'),(20780865,3432,'./!/application/controllers/hubconstruction.php'),(20781133,16614,'./!/application/controllers/invcotransfer.php'),(20780967,3252,'./!/application/controllers/invbinitem.php'),(20780966,2702,'./!/application/controllers/invbinitem.php'),(20780965,19533,'./!/application/controllers/invbinitem.php'),(20780964,19532,'./!/application/controllers/invbinitem.php'),(20780963,19531,'./!/application/controllers/invbinitem.php'),(20780533,3343,'./!/application/controllers/gltransvoucher.php'),(20780532,3333,'./!/application/controllers/gltransvoucher.php'),(20780531,12764,'./!/application/controllers/gltransvoucher.php'),(20780530,3129,'./!/application/controllers/gltransvoucher.php'),(20780529,2907,'./!/application/controllers/gltransvoucher.php'),(20780528,15947,'./!/application/controllers/gltransvoucher.php'),(20780518,6168,'./!/application/controllers/gltransvoucher.php'),(20780519,1467,'./!/application/controllers/gltransvoucher.php'),(20780520,16309,'./!/application/controllers/gltransvoucher.php'),(20780521,15991,'./!/application/controllers/gltransvoucher.php'),(20780522,17571,'./!/application/controllers/gltransvoucher.php'),(20780523,14611,'./!/application/controllers/gltransvoucher.php'),(20780524,15946,'./!/application/controllers/gltransvoucher.php'),(20780525,1963,'./!/application/controllers/gltransvoucher.php'),(20780527,6010,'./!/application/controllers/gltransvoucher.php'),(20780526,2377,'./!/application/controllers/gltransvoucher.php'),(20780504,3415,'./!/application/controllers/glbudgets.php'),(20780503,3090,'./!/application/controllers/glbudgets.php'),(20780502,1935,'./!/application/controllers/glbudgets.php'),(20780501,9046,'./!/application/controllers/glbudgets.php'),(20780500,9045,'./!/application/controllers/glbudgets.php'),(20780499,9044,'./!/application/controllers/glbudgets.php'),(20780498,9043,'./!/application/controllers/glbudgets.php'),(20780497,9042,'./!/application/controllers/glbudgets.php'),(20780496,9041,'./!/application/controllers/glbudgets.php'),(20780495,9040,'./!/application/controllers/glbudgets.php'),(20780452,13910,'./!/application/controllers/gencompany.php'),(20780451,2936,'./!/application/controllers/gencompany.php'),(20780450,14120,'./!/application/controllers/gencompany.php'),(20780449,14119,'./!/application/controllers/gencompany.php'),(20780448,11890,'./!/application/controllers/gencompany.php'),(20780447,8329,'./!/application/controllers/gencompany.php'),(20780446,14118,'./!/application/controllers/gencompany.php'),(20780445,2376,'./!/application/controllers/gencompany.php'),(20780444,14117,'./!/application/controllers/gencompany.php'),(20780443,2234,'./!/application/controllers/gencompany.php'),(20780442,1815,'./!/application/controllers/gencompany.php'),(20780441,7973,'./!/application/controllers/gencompany.php'),(20780440,1560,'./!/application/controllers/gencompany.php'),(20780439,1476,'./!/application/controllers/gencompany.php'),(20780438,1373,'./!/application/controllers/gencompany.php'),(20780437,14113,'./!/application/controllers/gencompany.php'),(20780436,981,'./!/application/controllers/gencompany.php'),(20780435,941,'./!/application/controllers/gencompany.php'),(20780434,720,'./!/application/controllers/gencompany.php'),(20780433,659,'./!/application/controllers/gencompany.php'),(20780432,605,'./!/application/controllers/gencompany.php'),(20780431,581,'./!/application/controllers/gencompany.php'),(20780430,8353,'./!/application/controllers/gencompany.php'),(20780429,573,'./!/application/controllers/gencompany.php'),(20780428,524,'./!/application/controllers/gencompany.php'),(20780427,185,'./!/application/controllers/gencompany.php'),(20780426,59,'./!/application/controllers/gencompany.php'),(20780389,2948,'./!/application/controllers/faxservices.php'),(20780388,2795,'./!/application/controllers/faxservices.php'),(20780387,16095,'./!/application/controllers/faxservices.php'),(20780386,2738,'./!/application/controllers/faxservices.php'),(20780385,2292,'./!/application/controllers/faxservices.php'),(20780384,5081,'./!/application/controllers/faxservices.php'),(20780383,1668,'./!/application/controllers/faxservices.php'),(20780382,1578,'./!/application/controllers/faxservices.php'),(20780381,1446,'./!/application/controllers/faxservices.php'),(20780380,4486,'./!/application/controllers/faxservices.php'),(20780379,16094,'./!/application/controllers/faxservices.php'),(20780378,7250,'./!/application/controllers/faxservices.php'),(20780377,1036,'./!/application/controllers/faxservices.php'),(20780376,1014,'./!/application/controllers/faxservices.php'),(20780375,697,'./!/application/controllers/faxservices.php'),(20780374,333,'./!/application/controllers/faxservices.php'),(20780373,197,'./!/application/controllers/faxservices.php'),(20780962,19530,'./!/application/controllers/invbinitem.php'),(20780961,19529,'./!/application/controllers/invbinitem.php'),(20781132,3414,'./!/application/controllers/invcotransfer.php'),(20781131,19908,'./!/application/controllers/invcotransfer.php'),(20781130,3298,'./!/application/controllers/invcotransfer.php'),(20781129,3271,'./!/application/controllers/invcotransfer.php'),(20781128,18631,'./!/application/controllers/invcotransfer.php'),(20781175,2165,'./!/application/controllers/invcotransfershiprecv.php'),(20781390,3298,'./!/application/controllers/invcountbatch.php'),(20781389,19620,'./!/application/controllers/invcountbatch.php'),(20781388,3271,'./!/application/controllers/invcountbatch.php'),(20781387,3252,'./!/application/controllers/invcountbatch.php'),(20781386,14981,'./!/application/controllers/invcountbatch.php'),(20781385,18199,'./!/application/controllers/invcountbatch.php'),(20781384,18198,'./!/application/controllers/invcountbatch.php'),(20781383,19068,'./!/application/controllers/invcountbatch.php'),(20781382,19723,'./!/application/controllers/invcountbatch.php'),(20781381,16431,'./!/application/controllers/invcountbatch.php'),(20781380,19067,'./!/application/controllers/invcountbatch.php'),(20781379,3156,'./!/application/controllers/invcountbatch.php'),(20780330,3421,'./!/application/controllers/datatable_ajax.php'),(20780329,14621,'./!/application/controllers/datatable_ajax.php'),(20780328,1354,'./!/application/controllers/datatable_ajax.php'),(20780327,1047,'./!/application/controllers/datatable_ajax.php'),(20780326,11815,'./!/application/controllers/datatable_ajax.php'),(20781375,3948,'./!/application/controllers/invcountbatch.php'),(20781376,19491,'./!/application/controllers/invcountbatch.php'),(20781378,19296,'./!/application/controllers/invcountbatch.php'),(20781377,3090,'./!/application/controllers/invcountbatch.php'),(20784761,3118,'./!/application/views/appointments/summary.php'),(20779623,3126,'./!/application/controllers/arordership.php'),(20785681,1963,'./!/application/views/invcountbatch/assignCounting.form.getVarRecountItemsAjax.php'),(20785680,19543,'./!/application/views/invcountbatch/assignCounting.form.getVarRecountItemsAjax.php'),(20785679,1696,'./!/application/views/invcountbatch/assignCounting.form.getVarRecountItemsAjax.php'),(20785678,869,'./!/application/views/invcountbatch/assignCounting.form.getVarRecountItemsAjax.php'),(20785690,19391,'./!/application/views/invcountbatch/assignCounting.form.js.php'),(20785689,13334,'./!/application/views/invcountbatch/assignCounting.form.js.php'),(20785688,1726,'./!/application/views/invcountbatch/assignCounting.form.js.php'),(20785687,19638,'./!/application/views/invcountbatch/assignCounting.form.js.php'),(20785686,19558,'./!/application/views/invcountbatch/assignCounting.form.js.php'),(20785725,15241,'./!/application/views/invcountbatch/enterCounts.php'),(20785743,19640,'./!/application/views/invcountbatch/liveCounts.php'),(20785742,1696,'./!/application/views/invcountbatch/liveCounts.php'),(20785762,19350,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20785761,19501,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20787199,7701,'./adminarcompanytaxupd.php'),(20787438,7706,'./adminarcompanyupd.php'),(20787888,315,'./adminarsales_category.php'),(20787887,5203,'./adminarsales_category.php'),(20787886,111,'./adminarsales_category.php'),(20787908,19647,'./adminarsales_categoryadd.php'),(20787907,19646,'./adminarsales_categoryadd.php'),(20787906,14858,'./adminarsales_categoryadd.php'),(20787971,941,'./adminartaxexupd.php'),(20793341,1503,'./arinvoicesum.php'),(20793340,1502,'./arinvoicesum.php'),(20791964,8790,'./arcustomerpage_define.php'),(20791963,59,'./arcustomerpage_define.php'),(20793107,1933,'./arinvoicereptax.php'),(20793339,1446,'./arinvoicesum.php'),(20793338,19106,'./arinvoicesum.php'),(20793337,1036,'./arinvoicesum.php'),(20793336,6478,'./arinvoicesum.php'),(20793335,5470,'./arinvoicesum.php'),(20793334,15119,'./arinvoicesum.php'),(20793333,981,'./arinvoicesum.php'),(20793332,932,'./arinvoicesum.php'),(20793331,886,'./arinvoicesum.php'),(20795158,19658,'./arordshipadd.php'),(20795157,8213,'./arordshipadd.php'),(20795156,19657,'./arordshipadd.php'),(20795155,737,'./arordshipadd.php'),(20795154,4481,'./arordshipadd.php'),(20795153,675,'./arordshipadd.php'),(20795152,607,'./arordshipadd.php'),(20797157,5395,'./customcommissions.php'),(20780052,14829,'./!/application/controllers/custom_queries.php'),(20780051,3269,'./!/application/controllers/custom_queries.php'),(20780050,3239,'./!/application/controllers/custom_queries.php'),(20780049,1,'./!/application/controllers/custom_queries.php'),(20780048,2982,'./!/application/controllers/custom_queries.php'),(20780047,14828,'./!/application/controllers/custom_queries.php'),(20780046,14827,'./!/application/controllers/custom_queries.php'),(20780045,14826,'./!/application/controllers/custom_queries.php'),(20780044,14825,'./!/application/controllers/custom_queries.php'),(20780043,15265,'./!/application/controllers/custom_queries.php'),(20780042,2751,'./!/application/controllers/custom_queries.php'),(20780041,2702,'./!/application/controllers/custom_queries.php'),(20780040,14824,'./!/application/controllers/custom_queries.php'),(20780039,14823,'./!/application/controllers/custom_queries.php'),(20780038,14848,'./!/application/controllers/custom_queries.php'),(20780037,6349,'./!/application/controllers/custom_queries.php'),(20780036,2400,'./!/application/controllers/custom_queries.php'),(20780035,2109,'./!/application/controllers/custom_queries.php'),(20780034,1993,'./!/application/controllers/custom_queries.php'),(20780033,4915,'./!/application/controllers/custom_queries.php'),(20780032,14822,'./!/application/controllers/custom_queries.php'),(20780031,14821,'./!/application/controllers/custom_queries.php'),(20780030,1894,'./!/application/controllers/custom_queries.php'),(20780029,1863,'./!/application/controllers/custom_queries.php'),(20780028,14820,'./!/application/controllers/custom_queries.php'),(20780027,14819,'./!/application/controllers/custom_queries.php'),(20780026,14818,'./!/application/controllers/custom_queries.php'),(20780025,941,'./!/application/controllers/custom_queries.php'),(20780024,5205,'./!/application/controllers/custom_queries.php'),(20780023,14817,'./!/application/controllers/custom_queries.php'),(20780022,14816,'./!/application/controllers/custom_queries.php'),(20780021,14815,'./!/application/controllers/custom_queries.php'),(20780020,15264,'./!/application/controllers/custom_queries.php'),(20780019,15263,'./!/application/controllers/custom_queries.php'),(20780018,15262,'./!/application/controllers/custom_queries.php'),(20780017,9341,'./!/application/controllers/custom_queries.php'),(20780016,658,'./!/application/controllers/custom_queries.php'),(20780015,14814,'./!/application/controllers/custom_queries.php'),(20780014,315,'./!/application/controllers/custom_queries.php'),(20780013,313,'./!/application/controllers/custom_queries.php'),(20780012,16214,'./!/application/controllers/cron.php'),(20781374,19619,'./!/application/controllers/invcountbatch.php'),(20781373,19618,'./!/application/controllers/invcountbatch.php'),(20780321,3432,'./!/application/controllers/customer.php'),(20780320,3421,'./!/application/controllers/customer.php'),(20780319,3414,'./!/application/controllers/customer.php'),(20780318,13556,'./!/application/controllers/customer.php'),(20781372,16536,'./!/application/controllers/invcountbatch.php'),(20781371,16676,'./!/application/controllers/invcountbatch.php'),(20781370,2950,'./!/application/controllers/invcountbatch.php'),(20781369,2948,'./!/application/controllers/invcountbatch.php'),(20781368,18196,'./!/application/controllers/invcountbatch.php'),(20781367,18195,'./!/application/controllers/invcountbatch.php'),(20781366,19617,'./!/application/controllers/invcountbatch.php'),(20781365,18194,'./!/application/controllers/invcountbatch.php'),(20781364,2738,'./!/application/controllers/invcountbatch.php'),(20779995,3432,'./!/application/controllers/contact.php'),(20779994,3292,'./!/application/controllers/contact.php'),(20779993,16200,'./!/application/controllers/contact.php'),(20779992,13017,'./!/application/controllers/contact.php'),(20779991,16916,'./!/application/controllers/contact.php'),(20779990,6141,'./!/application/controllers/contact.php'),(20779989,3274,'./!/application/controllers/contact.php'),(20779988,2936,'./!/application/controllers/contact.php'),(20779987,17687,'./!/application/controllers/contact.php'),(20779986,4265,'./!/application/controllers/contact.php'),(20780057,15837,'./!/application/controllers/customer.php'),(20779967,3324,'./!/application/controllers/check.php'),(20779966,3274,'./!/application/controllers/check.php'),(20779965,16426,'./!/application/controllers/check.php'),(20779964,6710,'./!/application/controllers/check.php'),(20779963,3095,'./!/application/controllers/check.php'),(20779915,2751,'./!/application/controllers/chargebackcode.php'),(20779914,8508,'./!/application/controllers/chargebackcode.php'),(20779913,2094,'./!/application/controllers/chargebackcode.php'),(20779906,15864,'./!/application/controllers/chargebackcode.php'),(20779907,541,'./!/application/controllers/chargebackcode.php'),(20779908,548,'./!/application/controllers/chargebackcode.php'),(20779909,5205,'./!/application/controllers/chargebackcode.php'),(20779910,869,'./!/application/controllers/chargebackcode.php'),(20779911,941,'./!/application/controllers/chargebackcode.php'),(20779912,1499,'./!/application/controllers/chargebackcode.php'),(20779904,315,'./!/application/controllers/chargebackcode.php'),(20779905,15863,'./!/application/controllers/chargebackcode.php'),(20779833,3421,'./!/application/controllers/ccpurchase.php'),(20779832,8654,'./!/application/controllers/ccpurchase.php'),(20779831,8728,'./!/application/controllers/ccpurchase.php'),(20779830,8651,'./!/application/controllers/ccpurchase.php'),(20779829,8708,'./!/application/controllers/ccpurchase.php'),(20779828,1973,'./!/application/controllers/ccpurchase.php'),(20779827,1578,'./!/application/controllers/ccpurchase.php'),(20779826,14601,'./!/application/controllers/ccpurchase.php'),(20779825,1019,'./!/application/controllers/ccpurchase.php'),(20779824,737,'./!/application/controllers/ccpurchase.php'),(20779823,8653,'./!/application/controllers/ccpurchase.php'),(20779822,7209,'./!/application/controllers/ccpurchase.php'),(20779821,337,'./!/application/controllers/ccpurchase.php'),(20779820,226,'./!/application/controllers/ccpurchase.php'),(20779819,197,'./!/application/controllers/ccpurchase.php'),(20779752,16483,'./!/application/controllers/batchimport.php'),(20779751,17237,'./!/application/controllers/batchimport.php'),(20779750,16482,'./!/application/controllers/batchimport.php'),(20779749,16216,'./!/application/controllers/batchimport.php'),(20779748,17236,'./!/application/controllers/batchimport.php'),(20779747,3480,'./!/application/controllers/batchimport.php'),(20779746,3252,'./!/application/controllers/batchimport.php'),(20779745,14644,'./!/application/controllers/batchimport.php'),(20781363,19352,'./!/application/controllers/invcountbatch.php'),(20780362,17788,'./!/application/controllers/employee.php'),(20780886,16734,'./!/application/controllers/invadjustmenttype.php'),(20781127,18199,'./!/application/controllers/invcotransfer.php'),(20781126,3156,'./!/application/controllers/invcotransfer.php'),(20781125,18181,'./!/application/controllers/invcotransfer.php'),(20780316,17570,'./!/application/controllers/customer.php'),(20779674,3333,'./!/application/controllers/b2buser.php'),(20779673,3480,'./!/application/controllers/b2buser.php'),(20779672,3274,'./!/application/controllers/b2buser.php'),(20779671,9642,'./!/application/controllers/b2buser.php'),(20779670,3252,'./!/application/controllers/b2buser.php'),(20779669,16148,'./!/application/controllers/b2buser.php'),(20779668,2948,'./!/application/controllers/b2buser.php'),(20779667,4457,'./!/application/controllers/b2buser.php'),(20779666,16251,'./!/application/controllers/b2buser.php'),(20779665,2738,'./!/application/controllers/b2buser.php'),(20779664,15410,'./!/application/controllers/b2buser.php'),(20779663,2234,'./!/application/controllers/b2buser.php'),(20779662,15101,'./!/application/controllers/b2buser.php'),(20779661,16252,'./!/application/controllers/b2buser.php'),(20779660,16255,'./!/application/controllers/b2buser.php'),(20779659,1963,'./!/application/controllers/b2buser.php'),(20779658,16248,'./!/application/controllers/b2buser.php'),(20779657,16247,'./!/application/controllers/b2buser.php'),(20779656,16254,'./!/application/controllers/b2buser.php'),(20779655,1935,'./!/application/controllers/b2buser.php'),(20779654,7973,'./!/application/controllers/b2buser.php'),(20779653,1781,'./!/application/controllers/b2buser.php'),(20779652,6505,'./!/application/controllers/b2buser.php'),(20779651,1758,'./!/application/controllers/b2buser.php'),(20779650,19892,'./!/application/controllers/b2buser.php'),(20779649,1668,'./!/application/controllers/b2buser.php'),(20779648,1446,'./!/application/controllers/b2buser.php'),(20779646,19891,'./!/application/controllers/b2buser.php'),(20779470,3333,'./!/application/controllers/arorder_deposit.php'),(20779469,2225,'./!/application/controllers/arorder_deposit.php'),(20779468,7676,'./!/application/controllers/arorder_deposit.php'),(20779467,2165,'./!/application/controllers/arorder_deposit.php'),(20779466,1884,'./!/application/controllers/arorder_deposit.php'),(20779465,14611,'./!/application/controllers/arorder_deposit.php'),(20779464,737,'./!/application/controllers/arorder_deposit.php'),(20779463,697,'./!/application/controllers/arorder_deposit.php'),(20779461,13556,'./!/application/controllers/arorder.php'),(20779460,10948,'./!/application/controllers/arorder.php'),(20779459,5309,'./!/application/controllers/arorder.php'),(20779458,3358,'./!/application/controllers/arorder.php'),(20779457,3252,'./!/application/controllers/arorder.php'),(20779456,20206,'./!/application/controllers/arorder.php'),(20779455,18508,'./!/application/controllers/arorder.php'),(20779454,4415,'./!/application/controllers/arorder.php'),(20779453,4667,'./!/application/controllers/arorder.php'),(20779452,9140,'./!/application/controllers/arorder.php'),(20779451,3156,'./!/application/controllers/arorder.php'),(20779450,3090,'./!/application/controllers/arorder.php'),(20779449,3072,'./!/application/controllers/arorder.php'),(20779448,16676,'./!/application/controllers/arorder.php'),(20779447,2950,'./!/application/controllers/arorder.php'),(20779446,2948,'./!/application/controllers/arorder.php'),(20779445,3434,'./!/application/controllers/arorder.php'),(20779444,5731,'./!/application/controllers/arorder.php'),(20779443,2819,'./!/application/controllers/arorder.php'),(20779442,17228,'./!/application/controllers/arorder.php'),(20779441,17227,'./!/application/controllers/arorder.php'),(20779440,17226,'./!/application/controllers/arorder.php'),(20779439,5225,'./!/application/controllers/arorder.php'),(20779333,3252,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779332,16209,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779331,3434,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779330,4265,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779329,2266,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779328,6318,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779327,2225,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779326,2160,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779325,16208,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779324,1973,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779323,16207,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779322,16092,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779321,1884,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779320,1770,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779319,5081,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779318,15901,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779317,1682,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779316,1677,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779315,16206,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779314,16205,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779313,16204,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779312,1672,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779311,1668,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779310,14611,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779309,16093,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779308,15991,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779307,17163,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779306,1499,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779305,16089,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779304,1134,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779303,1014,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779302,8010,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779301,737,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779299,8730,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779300,4481,'./!/application/controllers/arinvoicepaymentdetail.php'),(20778927,3319,'./!/application/controllers/archive_reports.php'),(20778926,3252,'./!/application/controllers/archive_reports.php'),(20778925,3130,'./!/application/controllers/archive_reports.php'),(20778924,3070,'./!/application/controllers/archive_reports.php'),(20778923,3853,'./!/application/controllers/archive_reports.php'),(20778922,8222,'./!/application/controllers/archive_reports.php'),(20778921,6257,'./!/application/controllers/archive_reports.php'),(20778920,3434,'./!/application/controllers/archive_reports.php'),(20778919,18147,'./!/application/controllers/archive_reports.php'),(20778918,8508,'./!/application/controllers/archive_reports.php'),(20778917,3778,'./!/application/controllers/archive_reports.php'),(20778916,18979,'./!/application/controllers/archive_reports.php'),(20778915,4725,'./!/application/controllers/archive_reports.php'),(20778914,6516,'./!/application/controllers/archive_reports.php'),(20778913,2258,'./!/application/controllers/archive_reports.php'),(20778912,18140,'./!/application/controllers/archive_reports.php'),(20778911,2200,'./!/application/controllers/archive_reports.php'),(20778867,3294,'./!/application/controllers/apbillpayment.php'),(20778866,3292,'./!/application/controllers/apbillpayment.php'),(20778865,16203,'./!/application/controllers/apbillpayment.php'),(20778864,16200,'./!/application/controllers/apbillpayment.php'),(20778863,13017,'./!/application/controllers/apbillpayment.php'),(20778862,6141,'./!/application/controllers/apbillpayment.php'),(20778861,4265,'./!/application/controllers/apbillpayment.php'),(20778860,2266,'./!/application/controllers/apbillpayment.php'),(20778859,6318,'./!/application/controllers/apbillpayment.php'),(20778858,2238,'./!/application/controllers/apbillpayment.php'),(20778857,2160,'./!/application/controllers/apbillpayment.php'),(20778856,16092,'./!/application/controllers/apbillpayment.php'),(20778855,16091,'./!/application/controllers/apbillpayment.php'),(20778854,16202,'./!/application/controllers/apbillpayment.php'),(20778853,1770,'./!/application/controllers/apbillpayment.php'),(20778852,1677,'./!/application/controllers/apbillpayment.php'),(20778834,7946,'./!/application/controllers/apbill.php'),(20778833,3274,'./!/application/controllers/apbill.php'),(20778832,3252,'./!/application/controllers/apbill.php'),(20778831,3035,'./!/application/controllers/apbill.php'),(20778830,2948,'./!/application/controllers/apbill.php'),(20778829,3434,'./!/application/controllers/apbill.php'),(20778828,5366,'./!/application/controllers/apbill.php'),(20778827,2225,'./!/application/controllers/apbill.php'),(20778826,2151,'./!/application/controllers/apbill.php'),(20778825,1941,'./!/application/controllers/apbill.php'),(20778824,9622,'./!/application/controllers/apbill.php'),(20778823,1672,'./!/application/controllers/apbill.php'),(20778822,1668,'./!/application/controllers/apbill.php'),(20778821,1625,'./!/application/controllers/apbill.php'),(20778820,1014,'./!/application/controllers/apbill.php'),(20778819,941,'./!/application/controllers/apbill.php'),(20778818,932,'./!/application/controllers/apbill.php'),(20778817,892,'./!/application/controllers/apbill.php'),(20778816,886,'./!/application/controllers/apbill.php'),(20778815,5205,'./!/application/controllers/apbill.php'),(20778814,14595,'./!/application/controllers/apbill.php'),(20814485,1931,'./includes/initial_setup.php'),(20814484,1930,'./includes/initial_setup.php'),(20814483,1794,'./includes/initial_setup.php'),(20814482,1701,'./includes/initial_setup.php'),(20814481,1596,'./includes/initial_setup.php'),(20814751,7460,'./includes/invfunctions.php'),(20814750,3239,'./includes/invfunctions.php'),(20814749,3240,'./includes/invfunctions.php'),(20814748,3238,'./includes/invfunctions.php'),(20814747,3235,'./includes/invfunctions.php'),(20814746,3234,'./includes/invfunctions.php'),(20814745,13910,'./includes/invfunctions.php'),(20814744,15015,'./includes/invfunctions.php'),(20814743,3203,'./includes/invfunctions.php'),(20814742,7669,'./includes/invfunctions.php'),(20814741,18631,'./includes/invfunctions.php'),(20814740,3171,'./includes/invfunctions.php'),(20814739,3169,'./includes/invfunctions.php'),(20814738,3168,'./includes/invfunctions.php'),(20814737,3167,'./includes/invfunctions.php'),(20814736,15551,'./includes/invfunctions.php'),(20814735,3126,'./includes/invfunctions.php'),(20814734,3097,'./includes/invfunctions.php'),(20814733,13825,'./includes/invfunctions.php'),(20814732,11409,'./includes/invfunctions.php'),(20814731,11408,'./includes/invfunctions.php'),(20814730,15544,'./includes/invfunctions.php'),(20814729,16676,'./includes/invfunctions.php'),(20814728,13932,'./includes/invfunctions.php'),(20814727,2936,'./includes/invfunctions.php'),(20814726,9825,'./includes/invfunctions.php'),(20814725,2905,'./includes/invfunctions.php'),(20814724,7796,'./includes/invfunctions.php'),(20814723,2847,'./includes/invfunctions.php'),(20814722,13486,'./includes/invfunctions.php'),(20814721,15153,'./includes/invfunctions.php'),(20814720,2838,'./includes/invfunctions.php'),(20814719,15825,'./includes/invfunctions.php'),(20814718,15152,'./includes/invfunctions.php'),(20814717,15151,'./includes/invfunctions.php'),(20814716,2833,'./includes/invfunctions.php'),(20814715,6770,'./includes/invfunctions.php'),(20814714,2740,'./includes/invfunctions.php'),(20814713,2696,'./includes/invfunctions.php'),(20814712,19468,'./includes/invfunctions.php'),(20814711,14009,'./includes/invfunctions.php'),(20814710,2620,'./includes/invfunctions.php'),(20814709,18361,'./includes/invfunctions.php'),(20814708,16675,'./includes/invfunctions.php'),(20814707,5876,'./includes/invfunctions.php'),(20814706,18103,'./includes/invfunctions.php'),(20814705,2589,'./includes/invfunctions.php'),(20814704,2508,'./includes/invfunctions.php'),(20814703,5880,'./includes/invfunctions.php'),(20814702,10100,'./includes/invfunctions.php'),(20814701,10099,'./includes/invfunctions.php'),(20814700,10098,'./includes/invfunctions.php'),(20814699,2466,'./includes/invfunctions.php'),(20814698,2453,'./includes/invfunctions.php'),(20814697,2404,'./includes/invfunctions.php'),(20814696,8769,'./includes/invfunctions.php'),(20814695,2363,'./includes/invfunctions.php'),(20814694,2376,'./includes/invfunctions.php'),(20814693,9612,'./includes/invfunctions.php'),(20814692,19320,'./includes/invfunctions.php'),(20814691,2331,'./includes/invfunctions.php'),(20814690,2330,'./includes/invfunctions.php'),(20814689,2327,'./includes/invfunctions.php'),(20814688,2324,'./includes/invfunctions.php'),(20814687,16671,'./includes/invfunctions.php'),(20814686,2208,'./includes/invfunctions.php'),(20814685,2182,'./includes/invfunctions.php'),(20814684,13485,'./includes/invfunctions.php'),(20814683,3470,'./includes/invfunctions.php'),(20814682,6123,'./includes/invfunctions.php'),(20814681,2165,'./includes/invfunctions.php'),(20814680,2160,'./includes/invfunctions.php'),(20814679,8708,'./includes/invfunctions.php'),(20814678,11407,'./includes/invfunctions.php'),(20814677,2034,'./includes/invfunctions.php'),(20814676,2011,'./includes/invfunctions.php'),(20814675,11449,'./includes/invfunctions.php'),(20814674,15181,'./includes/invfunctions.php'),(20814673,6122,'./includes/invfunctions.php'),(20814672,2103,'./includes/invfunctions.php'),(20814671,16674,'./includes/invfunctions.php'),(20814670,1973,'./includes/invfunctions.php'),(20814669,4551,'./includes/invfunctions.php'),(20814668,14622,'./includes/invfunctions.php'),(20814667,1932,'./includes/invfunctions.php'),(20814666,5908,'./includes/invfunctions.php'),(20814665,19520,'./includes/invfunctions.php'),(20814664,13964,'./includes/invfunctions.php'),(20814663,19519,'./includes/invfunctions.php'),(20814662,18719,'./includes/invfunctions.php'),(20814661,13484,'./includes/invfunctions.php'),(20814660,6130,'./includes/invfunctions.php'),(20814659,1810,'./includes/invfunctions.php'),(20814658,17010,'./includes/invfunctions.php'),(20814657,13824,'./includes/invfunctions.php'),(20814656,14266,'./includes/invfunctions.php'),(20814655,1765,'./includes/invfunctions.php'),(20814654,11448,'./includes/invfunctions.php'),(20814653,18874,'./includes/invfunctions.php'),(20814652,5081,'./includes/invfunctions.php'),(20814651,15138,'./includes/invfunctions.php'),(20814650,1729,'./includes/invfunctions.php'),(20814649,1728,'./includes/invfunctions.php'),(20814648,12975,'./includes/invfunctions.php'),(20814647,1726,'./includes/invfunctions.php'),(20814646,1723,'./includes/invfunctions.php'),(20814645,1722,'./includes/invfunctions.php'),(20814644,7003,'./includes/invfunctions.php'),(20814643,12974,'./includes/invfunctions.php'),(20814642,5858,'./includes/invfunctions.php'),(20814641,1712,'./includes/invfunctions.php'),(20814640,1709,'./includes/invfunctions.php'),(20814639,1703,'./includes/invfunctions.php'),(20814638,1699,'./includes/invfunctions.php'),(20814637,1696,'./includes/invfunctions.php'),(20814636,18360,'./includes/invfunctions.php'),(20814635,16710,'./includes/invfunctions.php'),(20814634,8942,'./includes/invfunctions.php'),(20814633,1666,'./includes/invfunctions.php'),(20814632,4022,'./includes/invfunctions.php'),(20814631,1651,'./includes/invfunctions.php'),(20814630,1650,'./includes/invfunctions.php'),(20814629,1649,'./includes/invfunctions.php'),(20814628,1647,'./includes/invfunctions.php'),(20814627,1640,'./includes/invfunctions.php'),(20814626,18772,'./includes/invfunctions.php'),(20814625,18758,'./includes/invfunctions.php'),(20814624,1606,'./includes/invfunctions.php'),(20814623,1599,'./includes/invfunctions.php'),(20814622,1598,'./includes/invfunctions.php'),(20814621,5271,'./includes/invfunctions.php'),(20814620,16705,'./includes/invfunctions.php'),(20814619,1578,'./includes/invfunctions.php'),(20814618,20171,'./includes/invfunctions.php'),(20814617,1519,'./includes/invfunctions.php'),(20814616,11447,'./includes/invfunctions.php'),(20814615,1508,'./includes/invfunctions.php'),(20814614,1503,'./includes/invfunctions.php'),(20814613,15991,'./includes/invfunctions.php'),(20814612,1476,'./includes/invfunctions.php'),(20814611,8072,'./includes/invfunctions.php'),(20814610,15824,'./includes/invfunctions.php'),(20814609,1381,'./includes/invfunctions.php'),(20814608,5072,'./includes/invfunctions.php'),(20814607,18794,'./includes/invfunctions.php'),(20814606,19467,'./includes/invfunctions.php'),(20814605,1328,'./includes/invfunctions.php'),(20814604,1323,'./includes/invfunctions.php'),(20814603,1319,'./includes/invfunctions.php'),(20814602,1284,'./includes/invfunctions.php'),(20814601,1283,'./includes/invfunctions.php'),(20814600,1280,'./includes/invfunctions.php'),(20814599,1258,'./includes/invfunctions.php'),(20814598,1224,'./includes/invfunctions.php'),(20814597,8936,'./includes/invfunctions.php'),(20814596,1206,'./includes/invfunctions.php'),(20814595,1177,'./includes/invfunctions.php'),(20814594,1172,'./includes/invfunctions.php'),(20814593,1157,'./includes/invfunctions.php'),(20814592,1130,'./includes/invfunctions.php'),(20814591,1126,'./includes/invfunctions.php'),(20814590,1096,'./includes/invfunctions.php'),(20814589,1095,'./includes/invfunctions.php'),(20814588,1094,'./includes/invfunctions.php'),(20814587,1091,'./includes/invfunctions.php'),(20814586,1089,'./includes/invfunctions.php'),(20814585,1066,'./includes/invfunctions.php'),(20814584,15970,'./includes/invfunctions.php'),(20814583,6116,'./includes/invfunctions.php'),(20814582,988,'./includes/invfunctions.php'),(20814581,18328,'./includes/invfunctions.php'),(20814580,18466,'./includes/invfunctions.php'),(20814579,19593,'./includes/invfunctions.php'),(20814578,19592,'./includes/invfunctions.php'),(20814577,981,'./includes/invfunctions.php'),(20814576,6115,'./includes/invfunctions.php'),(20814830,8546,'./includes/invoicesoldshipformat.php'),(20814829,2936,'./includes/invoicesoldshipformat.php'),(20814828,3913,'./includes/invoicesoldshipformat.php'),(20814827,4455,'./includes/invoicesoldshipformat.php'),(20814826,2819,'./includes/invoicesoldshipformat.php'),(20814825,17496,'./includes/invoicesoldshipformat.php'),(20814824,17497,'./includes/invoicesoldshipformat.php'),(20814823,9631,'./includes/invoicesoldshipformat.php'),(20814822,2331,'./includes/invoicesoldshipformat.php'),(20814821,13960,'./includes/invoicesoldshipformat.php'),(20814820,2330,'./includes/invoicesoldshipformat.php'),(20814819,9630,'./includes/invoicesoldshipformat.php'),(20814898,6361,'./includes/itemoptiongroup.php'),(20814897,3421,'./includes/itemoptiongroup.php'),(20814896,3362,'./includes/itemoptiongroup.php'),(20814895,6360,'./includes/itemoptiongroup.php'),(20814894,6359,'./includes/itemoptiongroup.php'),(20814893,6358,'./includes/itemoptiongroup.php'),(20814892,3239,'./includes/itemoptiongroup.php'),(20814891,3240,'./includes/itemoptiongroup.php'),(20814890,3156,'./includes/itemoptiongroup.php'),(20814889,1,'./includes/itemoptiongroup.php'),(20814888,3030,'./includes/itemoptiongroup.php'),(20814887,6357,'./includes/itemoptiongroup.php'),(20814886,6356,'./includes/itemoptiongroup.php'),(20814885,2702,'./includes/itemoptiongroup.php'),(20814884,6354,'./includes/itemoptiongroup.php'),(20814883,6353,'./includes/itemoptiongroup.php'),(20814882,4265,'./includes/itemoptiongroup.php'),(20814881,17219,'./includes/itemoptiongroup.php'),(20814880,6352,'./includes/itemoptiongroup.php'),(20814879,6351,'./includes/itemoptiongroup.php'),(20814878,6350,'./includes/itemoptiongroup.php'),(20814877,2508,'./includes/itemoptiongroup.php'),(20814876,6349,'./includes/itemoptiongroup.php'),(20814875,2451,'./includes/itemoptiongroup.php'),(20814874,6348,'./includes/itemoptiongroup.php'),(20814873,6413,'./includes/itemoptiongroup.php'),(20814872,2160,'./includes/itemoptiongroup.php'),(20814871,5525,'./includes/itemoptiongroup.php'),(20814870,5495,'./includes/itemoptiongroup.php'),(20814869,6347,'./includes/itemoptiongroup.php'),(20814868,6346,'./includes/itemoptiongroup.php'),(20814867,1973,'./includes/itemoptiongroup.php'),(20814866,6345,'./includes/itemoptiongroup.php'),(20814865,6344,'./includes/itemoptiongroup.php'),(20814864,6343,'./includes/itemoptiongroup.php'),(20814863,1935,'./includes/itemoptiongroup.php'),(20814862,6342,'./includes/itemoptiongroup.php'),(20814861,6341,'./includes/itemoptiongroup.php'),(20814860,6340,'./includes/itemoptiongroup.php'),(20814859,6339,'./includes/itemoptiongroup.php'),(20814858,6338,'./includes/itemoptiongroup.php'),(20814857,6337,'./includes/itemoptiongroup.php'),(20814856,1519,'./includes/itemoptiongroup.php'),(20814855,6336,'./includes/itemoptiongroup.php'),(20814854,6335,'./includes/itemoptiongroup.php'),(20814853,6334,'./includes/itemoptiongroup.php'),(20814852,7185,'./includes/itemoptiongroup.php'),(20814851,902,'./includes/itemoptiongroup.php'),(20814850,869,'./includes/itemoptiongroup.php'),(20814849,4065,'./includes/itemoptiongroup.php'),(20814848,6333,'./includes/itemoptiongroup.php'),(20814847,799,'./includes/itemoptiongroup.php'),(20814846,6332,'./includes/itemoptiongroup.php'),(20814845,6331,'./includes/itemoptiongroup.php'),(20814844,17218,'./includes/itemoptiongroup.php'),(20814843,6330,'./includes/itemoptiongroup.php'),(20814842,6329,'./includes/itemoptiongroup.php'),(20814841,7184,'./includes/itemoptiongroup.php'),(20814840,6326,'./includes/itemoptiongroup.php'),(20814839,6771,'./includes/itemoptiongroup.php'),(20814838,4871,'./includes/itemoptiongroup.php'),(20814900,15596,'./includes/jobcost.php'),(20814899,8936,'./includes/jobcost.php'),(20814902,8511,'./includes/lang.php'),(20814901,8936,'./includes/lang.php'),(20814906,15084,'./includes/mage.php'),(20814905,1735,'./includes/mage.php'),(20814904,3995,'./includes/mage.php'),(20814927,9641,'./includes/mailclass.php'),(20814926,14120,'./includes/mailclass.php'),(20814925,14119,'./includes/mailclass.php'),(20814924,18045,'./includes/mailclass.php'),(20814923,14118,'./includes/mailclass.php'),(20814922,18044,'./includes/mailclass.php'),(20814921,14117,'./includes/mailclass.php'),(20814920,2234,'./includes/mailclass.php'),(20814919,2070,'./includes/mailclass.php'),(20814917,7973,'./includes/mailclass.php'),(20814936,5070,'./includes/main.php'),(20814935,8022,'./includes/main.php'),(20814934,13334,'./includes/main.php'),(20814933,8936,'./includes/main.php'),(20814932,16270,'./includes/main.php'),(20814931,5201,'./includes/main.php'),(20814930,542,'./includes/main.php'),(20814937,2057,'./includes/menu.php'),(20783223,19951,'./!/application/controllers/priceoverriderequest.php'),(20814964,8115,'./includes/npnote.php'),(20814963,8120,'./includes/npnote.php'),(20814962,8260,'./includes/npnote.php'),(20814961,3252,'./includes/npnote.php'),(20814952,10093,'./includes/npnote.php'),(20814953,8118,'./includes/npnote.php'),(20814954,4865,'./includes/npnote.php'),(20814955,8259,'./includes/npnote.php'),(20814956,7169,'./includes/npnote.php'),(20814957,2702,'./includes/npnote.php'),(20814958,11793,'./includes/npnote.php'),(20814959,8119,'./includes/npnote.php'),(20814960,16431,'./includes/npnote.php'),(20814988,9827,'./includes/npstage.php'),(20814987,9840,'./includes/npstage.php'),(20814986,3252,'./includes/npstage.php'),(20814985,9839,'./includes/npstage.php'),(20814984,9838,'./includes/npstage.php'),(20814983,9837,'./includes/npstage.php'),(20814982,9836,'./includes/npstage.php'),(20814981,9825,'./includes/npstage.php'),(20814980,2702,'./includes/npstage.php'),(20814979,9835,'./includes/npstage.php'),(20814978,9826,'./includes/npstage.php'),(20814977,9834,'./includes/npstage.php'),(20814976,2099,'./includes/npstage.php'),(20814975,9833,'./includes/npstage.php'),(20814974,1910,'./includes/npstage.php'),(20814973,5486,'./includes/npstage.php'),(20814972,8936,'./includes/npstage.php'),(20814971,9832,'./includes/npstage.php'),(20814970,9831,'./includes/npstage.php'),(20814969,799,'./includes/npstage.php'),(20814968,737,'./includes/npstage.php'),(20814967,542,'./includes/npstage.php'),(20814966,315,'./includes/npstage.php'),(20814965,8125,'./includes/npstage.php'),(20815318,2985,'./includes/home/np5_tabs.php'),(20815046,3402,'./includes/prfunctions.php'),(20815045,3319,'./includes/prfunctions.php'),(20815044,3266,'./includes/prfunctions.php'),(20815043,3156,'./includes/prfunctions.php'),(20815042,2998,'./includes/prfunctions.php'),(20815041,2980,'./includes/prfunctions.php'),(20815040,2919,'./includes/prfunctions.php'),(20815039,2898,'./includes/prfunctions.php'),(20815038,8778,'./includes/prfunctions.php'),(20815037,2882,'./includes/prfunctions.php'),(20815036,2875,'./includes/prfunctions.php'),(20815035,5415,'./includes/prfunctions.php'),(20815034,7192,'./includes/prfunctions.php'),(20815033,5446,'./includes/prfunctions.php'),(20815032,2337,'./includes/prfunctions.php'),(20815031,2257,'./includes/prfunctions.php'),(20815030,2254,'./includes/prfunctions.php'),(20815029,2253,'./includes/prfunctions.php'),(20815028,2252,'./includes/prfunctions.php'),(20815027,2251,'./includes/prfunctions.php'),(20815026,2225,'./includes/prfunctions.php'),(20815025,2208,'./includes/prfunctions.php'),(20815024,15532,'./includes/prfunctions.php'),(20815023,1992,'./includes/prfunctions.php'),(20815022,7048,'./includes/prfunctions.php'),(20815021,1935,'./includes/prfunctions.php'),(20815020,1924,'./includes/prfunctions.php'),(20815019,10386,'./includes/prfunctions.php'),(20815018,11999,'./includes/prfunctions.php'),(20815017,1470,'./includes/prfunctions.php'),(20815016,8970,'./includes/prfunctions.php'),(20815015,14173,'./includes/prfunctions.php'),(20815014,1303,'./includes/prfunctions.php'),(20815013,1302,'./includes/prfunctions.php'),(20815012,1295,'./includes/prfunctions.php'),(20815011,1294,'./includes/prfunctions.php'),(20815010,1292,'./includes/prfunctions.php'),(20815009,1265,'./includes/prfunctions.php'),(20815008,1258,'./includes/prfunctions.php'),(20815007,8936,'./includes/prfunctions.php'),(20815006,1186,'./includes/prfunctions.php'),(20815005,1162,'./includes/prfunctions.php'),(20815004,1105,'./includes/prfunctions.php'),(20815003,1072,'./includes/prfunctions.php'),(20815002,1066,'./includes/prfunctions.php'),(20815001,1011,'./includes/prfunctions.php'),(20815000,989,'./includes/prfunctions.php'),(20814999,13734,'./includes/prfunctions.php'),(20814998,869,'./includes/prfunctions.php'),(20814997,787,'./includes/prfunctions.php'),(20814996,786,'./includes/prfunctions.php'),(20814995,785,'./includes/prfunctions.php'),(20814994,784,'./includes/prfunctions.php'),(20814993,412,'./includes/prfunctions.php'),(20814992,5398,'./includes/prfunctions.php'),(20814991,315,'./includes/prfunctions.php'),(20814990,7464,'./includes/prfunctions.php'),(20735857,3354,'./includes/prtfunctions.php'),(20735856,3188,'./includes/prtfunctions.php'),(20735855,2936,'./includes/prtfunctions.php'),(20735854,2468,'./includes/prtfunctions.php'),(20735853,2466,'./includes/prtfunctions.php'),(20735852,2376,'./includes/prtfunctions.php'),(20735851,2331,'./includes/prtfunctions.php'),(20735850,2330,'./includes/prtfunctions.php'),(20735849,2329,'./includes/prtfunctions.php'),(20735848,2327,'./includes/prtfunctions.php'),(20735847,2326,'./includes/prtfunctions.php'),(20735846,2324,'./includes/prtfunctions.php'),(20735845,2011,'./includes/prtfunctions.php'),(20735844,1810,'./includes/prtfunctions.php'),(20735843,1789,'./includes/prtfunctions.php'),(20735842,1381,'./includes/prtfunctions.php'),(20735841,1224,'./includes/prtfunctions.php'),(20735840,1195,'./includes/prtfunctions.php'),(20735839,1112,'./includes/prtfunctions.php'),(20735838,988,'./includes/prtfunctions.php'),(20735837,984,'./includes/prtfunctions.php'),(20735836,983,'./includes/prtfunctions.php'),(20735835,981,'./includes/prtfunctions.php'),(20735834,966,'./includes/prtfunctions.php'),(20735833,659,'./includes/prtfunctions.php'),(20735832,524,'./includes/prtfunctions.php'),(20735831,185,'./includes/prtfunctions.php'),(20735830,176,'./includes/prtfunctions.php'),(20815278,13968,'./includes/wizard.php'),(20815277,20258,'./includes/wizard.php'),(20815102,13897,'./includes/quick_setup.php'),(20815101,9642,'./includes/quick_setup.php'),(20815100,14786,'./includes/quick_setup.php'),(20815099,14787,'./includes/quick_setup.php'),(20815098,14785,'./includes/quick_setup.php'),(20815097,12800,'./includes/quick_setup.php'),(20815096,2969,'./includes/quick_setup.php'),(20815095,2936,'./includes/quick_setup.php'),(20815094,13896,'./includes/quick_setup.php'),(20815093,7194,'./includes/quick_setup.php'),(20815092,13895,'./includes/quick_setup.php'),(20815091,14048,'./includes/quick_setup.php'),(20815090,11535,'./includes/quick_setup.php'),(20815089,2702,'./includes/quick_setup.php'),(20815088,7192,'./includes/quick_setup.php'),(20815087,4265,'./includes/quick_setup.php'),(20815086,7190,'./includes/quick_setup.php'),(20815085,8454,'./includes/quick_setup.php'),(20815084,14509,'./includes/quick_setup.php'),(20815083,2376,'./includes/quick_setup.php'),(20815082,2324,'./includes/quick_setup.php'),(20815081,14080,'./includes/quick_setup.php'),(20815080,2237,'./includes/quick_setup.php'),(20815079,2234,'./includes/quick_setup.php'),(20815078,2208,'./includes/quick_setup.php'),(20815077,13894,'./includes/quick_setup.php'),(20815076,13893,'./includes/quick_setup.php'),(20815075,1935,'./includes/quick_setup.php'),(20815074,1894,'./includes/quick_setup.php'),(20815073,1888,'./includes/quick_setup.php'),(20815072,6234,'./includes/quick_setup.php'),(20815071,1752,'./includes/quick_setup.php'),(20815070,1476,'./includes/quick_setup.php'),(20815069,8228,'./includes/quick_setup.php'),(20815068,13892,'./includes/quick_setup.php'),(20815067,7187,'./includes/quick_setup.php'),(20815066,8936,'./includes/quick_setup.php'),(20815065,7186,'./includes/quick_setup.php'),(20815064,8226,'./includes/quick_setup.php'),(20815063,981,'./includes/quick_setup.php'),(20815062,7499,'./includes/quick_setup.php'),(20815061,591,'./includes/quick_setup.php'),(20815060,581,'./includes/quick_setup.php'),(20815059,573,'./includes/quick_setup.php'),(20815058,524,'./includes/quick_setup.php'),(20815057,13989,'./includes/quick_setup.php'),(20815056,14079,'./includes/quick_setup.php'),(20815055,9801,'./includes/quick_setup.php'),(20815054,13891,'./includes/quick_setup.php'),(20815053,13890,'./includes/quick_setup.php'),(20815052,13889,'./includes/quick_setup.php'),(20815051,189,'./includes/quick_setup.php'),(20815050,3533,'./includes/quick_setup.php'),(20815049,185,'./includes/quick_setup.php'),(20815048,11929,'./includes/quick_setup.php'),(20815047,52,'./includes/quick_setup.php'),(20815106,2850,'./includes/reportcachenav.php'),(20815105,16284,'./includes/reportcachenav.php'),(20815108,2625,'./includes/responsetype.inc'),(20815107,2624,'./includes/responsetype.inc'),(20815249,18899,'./includes/tamg.php'),(20815248,3450,'./includes/tamg.php'),(20815247,19288,'./includes/tamg.php'),(20815246,4861,'./includes/tamg.php'),(20815245,3005,'./includes/tamg.php'),(20815244,14955,'./includes/tamg.php'),(20815243,14951,'./includes/tamg.php'),(20815242,2948,'./includes/tamg.php'),(20815241,2936,'./includes/tamg.php'),(20815240,4733,'./includes/tamg.php'),(20815239,9718,'./includes/tamg.php'),(20815238,9966,'./includes/tamg.php'),(20815237,16318,'./includes/tamg.php'),(20815236,2850,'./includes/tamg.php'),(20815235,9965,'./includes/tamg.php'),(20815234,9964,'./includes/tamg.php'),(20815233,9963,'./includes/tamg.php'),(20815232,9962,'./includes/tamg.php'),(20815231,2540,'./includes/tamg.php'),(20815230,3784,'./includes/tamg.php'),(20815229,10638,'./includes/tamg.php'),(20815228,9717,'./includes/tamg.php'),(20815227,16109,'./includes/tamg.php'),(20815226,17166,'./includes/tamg.php'),(20815225,17165,'./includes/tamg.php'),(20815224,16358,'./includes/tamg.php'),(20815223,2363,'./includes/tamg.php'),(20815222,2361,'./includes/tamg.php'),(20815221,15093,'./includes/tamg.php'),(20815220,15092,'./includes/tamg.php'),(20815219,2324,'./includes/tamg.php'),(20815218,15918,'./includes/tamg.php'),(20815217,5866,'./includes/tamg.php'),(20815216,6318,'./includes/tamg.php'),(20815215,15222,'./includes/tamg.php'),(20815214,2225,'./includes/tamg.php'),(20815213,9877,'./includes/tamg.php'),(20815212,2208,'./includes/tamg.php'),(20815211,7676,'./includes/tamg.php'),(20815210,9143,'./includes/tamg.php'),(20815209,15221,'./includes/tamg.php'),(20815208,2165,'./includes/tamg.php'),(20815207,5865,'./includes/tamg.php'),(20815206,2151,'./includes/tamg.php'),(20815205,16072,'./includes/tamg.php'),(20815204,15917,'./includes/tamg.php'),(20815203,15066,'./includes/tamg.php'),(20815202,15091,'./includes/tamg.php'),(20815201,2103,'./includes/tamg.php'),(20815200,2099,'./includes/tamg.php'),(20815199,15062,'./includes/tamg.php'),(20815198,15060,'./includes/tamg.php'),(20815197,3709,'./includes/tamg.php'),(20815196,15254,'./includes/tamg.php'),(20815195,3708,'./includes/tamg.php'),(20815194,15253,'./includes/tamg.php'),(20815193,7904,'./includes/tamg.php'),(20815192,15252,'./includes/tamg.php'),(20815191,1935,'./includes/tamg.php'),(20815190,1933,'./includes/tamg.php'),(20815189,6234,'./includes/tamg.php'),(20815188,16357,'./includes/tamg.php'),(20815187,16356,'./includes/tamg.php'),(20815186,19874,'./includes/tamg.php'),(20815185,18874,'./includes/tamg.php'),(20815184,15090,'./includes/tamg.php'),(20815183,15089,'./includes/tamg.php'),(20815182,15088,'./includes/tamg.php'),(20815181,15260,'./includes/tamg.php'),(20815180,5061,'./includes/tamg.php'),(20815179,15797,'./includes/tamg.php'),(20815178,1743,'./includes/tamg.php'),(20815177,15570,'./includes/tamg.php'),(20815176,9622,'./includes/tamg.php'),(20815256,8936,'./includes/usaepaybridge.php'),(20781956,19942,'./!/application/controllers/itempricespecial.php'),(20815265,3156,'./includes/usaepaycd.php'),(20815264,14175,'./includes/usaepaycd.php'),(20815263,14070,'./includes/usaepaycd.php'),(20815262,14174,'./includes/usaepaycd.php'),(20815261,10238,'./includes/usaepaycd.php'),(20815269,6318,'./includes/usaepayeft.php'),(20815268,14349,'./includes/usaepayeft.php'),(20815276,20257,'./includes/wizard.php'),(20815275,4608,'./includes/wizard.php'),(20815274,13992,'./includes/wizard.php'),(20815273,1912,'./includes/wizard.php'),(20815284,20,'./includes/classes/glvoucher.php'),(20815281,3400,'./includes/workarea.inc'),(20815280,3399,'./includes/workarea.inc'),(20815283,7196,'./includes/classes/customer.php'),(20815282,7853,'./includes/classes/customer.php'),(20815293,19877,'./includes/classes/invoice.php'),(20815292,5378,'./includes/classes/invoice.php'),(20815291,3179,'./includes/classes/invoice.php'),(20815290,5388,'./includes/classes/invoice.php'),(20815289,2225,'./includes/classes/invoice.php'),(20815288,2151,'./includes/classes/invoice.php'),(20815301,5070,'./includes/home/index.php'),(20815300,16191,'./includes/home/index.php'),(20815304,14511,'./includes/home/index_common.php'),(20786853,226,'./adminachreport.php'),(20786852,5399,'./adminachreport.php'),(20786851,30,'./adminachreport.php'),(20786850,20,'./adminachreport.php'),(20781360,2702,'./!/application/controllers/invcountbatch.php'),(20815644,16676,'./includes/home/inventory/welcome.php'),(20815317,2846,'./includes/home/np5_tabs.php'),(20815316,4095,'./includes/home/np5_tabs.php'),(20815315,5085,'./includes/home/np5_tabs.php'),(20815313,2258,'./includes/home/np5_tabs.php'),(20815314,2270,'./includes/home/np5_tabs.php'),(20815322,16400,'./includes/home/welcome.php'),(20815321,4045,'./includes/home/welcome.php'),(20815320,4044,'./includes/home/welcome.php'),(20815319,4043,'./includes/home/welcome.php'),(20815328,4939,'./includes/home/billing/aging_summary.php'),(20815327,683,'./includes/home/billing/aging_summary.php'),(20815326,4938,'./includes/home/billing/aging_summary.php'),(20815337,3415,'./includes/home/billing/arinvoice_volume_12month.php'),(20815336,4943,'./includes/home/billing/arinvoice_volume_12month.php'),(20815335,3118,'./includes/home/billing/arinvoice_volume_12month.php'),(20815334,14708,'./includes/home/billing/arinvoice_volume_12month.php'),(20815333,4081,'./includes/home/billing/arinvoice_volume_12month.php'),(20815332,1913,'./includes/home/billing/arinvoice_volume_12month.php'),(20815345,4943,'./includes/home/billing/arinvoice_volume_8week.php'),(20815344,3118,'./includes/home/billing/arinvoice_volume_8week.php'),(20815343,14708,'./includes/home/billing/arinvoice_volume_8week.php'),(20815342,4081,'./includes/home/billing/arinvoice_volume_8week.php'),(20815341,1913,'./includes/home/billing/arinvoice_volume_8week.php'),(20815340,4948,'./includes/home/billing/arinvoice_volume_8week.php'),(20815339,14706,'./includes/home/billing/arinvoice_volume_8week.php'),(20815338,226,'./includes/home/billing/arinvoice_volume_8week.php'),(20815364,14711,'./includes/home/billing/defines.php'),(20815363,14710,'./includes/home/billing/defines.php'),(20815362,4931,'./includes/home/billing/defines.php'),(20815361,4078,'./includes/home/billing/defines.php'),(20815360,4929,'./includes/home/billing/defines.php'),(20815359,4928,'./includes/home/billing/defines.php'),(20815358,4077,'./includes/home/billing/defines.php'),(20815357,4949,'./includes/home/billing/defines.php'),(20815356,4944,'./includes/home/billing/defines.php'),(20815355,4948,'./includes/home/billing/defines.php'),(20815354,14707,'./includes/home/billing/defines.php'),(20815353,14709,'./includes/home/billing/defines.php'),(20815352,4947,'./includes/home/billing/defines.php'),(20815351,4092,'./includes/home/billing/defines.php'),(20815350,14514,'./includes/home/billing/defines.php'),(20815349,14513,'./includes/home/billing/defines.php'),(20815348,4935,'./includes/home/billing/defines.php'),(20815347,4938,'./includes/home/billing/defines.php'),(20815346,7508,'./includes/home/billing/defines.php'),(20815371,4185,'./includes/home/billing/half_menu.php'),(20781732,19625,'./!/application/controllers/item.php'),(20815370,4184,'./includes/home/billing/half_menu.php'),(20815369,7222,'./includes/home/billing/half_menu.php'),(20815368,4949,'./includes/home/billing/half_menu.php'),(20815379,4943,'./includes/home/billing/invoice_volume_7day.php'),(20815378,3118,'./includes/home/billing/invoice_volume_7day.php'),(20815377,14708,'./includes/home/billing/invoice_volume_7day.php'),(20815376,4081,'./includes/home/billing/invoice_volume_7day.php'),(20815375,1913,'./includes/home/billing/invoice_volume_7day.php'),(20815374,14709,'./includes/home/billing/invoice_volume_7day.php'),(20815373,14706,'./includes/home/billing/invoice_volume_7day.php'),(20815372,226,'./includes/home/billing/invoice_volume_7day.php'),(20815388,3118,'./includes/home/billing/invoices_due_dates.php'),(20815387,12235,'./includes/home/billing/invoices_due_dates.php'),(20815386,4081,'./includes/home/billing/invoices_due_dates.php'),(20815385,4080,'./includes/home/billing/invoices_due_dates.php'),(20815384,4079,'./includes/home/billing/invoices_due_dates.php'),(20815383,1668,'./includes/home/billing/invoices_due_dates.php'),(20815382,932,'./includes/home/billing/invoices_due_dates.php'),(20815381,697,'./includes/home/billing/invoices_due_dates.php'),(20815380,325,'./includes/home/billing/invoices_due_dates.php'),(20815393,4939,'./includes/home/billing/most_overdue.php'),(20815392,2008,'./includes/home/billing/most_overdue.php'),(20815391,4949,'./includes/home/billing/most_overdue.php'),(20815400,4183,'./includes/home/billing/overcredit_customers.php'),(20815399,3118,'./includes/home/billing/overcredit_customers.php'),(20815398,2008,'./includes/home/billing/overcredit_customers.php'),(20815396,4935,'./includes/home/billing/overcredit_customers.php'),(20815397,4937,'./includes/home/billing/overcredit_customers.php'),(20815413,4086,'./includes/home/billing/pending_sales_overview.php'),(20815412,3164,'./includes/home/billing/pending_sales_overview.php'),(20815411,3118,'./includes/home/billing/pending_sales_overview.php'),(20815410,2368,'./includes/home/billing/pending_sales_overview.php'),(20815409,4077,'./includes/home/billing/pending_sales_overview.php'),(20815408,4085,'./includes/home/billing/pending_sales_overview.php'),(20815407,4084,'./includes/home/billing/pending_sales_overview.php'),(20815406,1530,'./includes/home/billing/pending_sales_overview.php'),(20815405,1372,'./includes/home/billing/pending_sales_overview.php'),(20815404,1347,'./includes/home/billing/pending_sales_overview.php'),(20815403,4083,'./includes/home/billing/pending_sales_overview.php'),(20815402,697,'./includes/home/billing/pending_sales_overview.php'),(20815401,451,'./includes/home/billing/pending_sales_overview.php'),(20815418,7511,'./includes/home/billing/recent_customers.php'),(20815417,1991,'./includes/home/billing/recent_customers.php'),(20815416,7510,'./includes/home/billing/recent_customers.php'),(20815431,3415,'./includes/home/billing/recent_payments_common.php'),(20815430,3358,'./includes/home/billing/recent_payments_common.php'),(20815429,3333,'./includes/home/billing/recent_payments_common.php'),(20815428,4089,'./includes/home/billing/recent_payments_common.php'),(20815427,3118,'./includes/home/billing/recent_payments_common.php'),(20815426,4088,'./includes/home/billing/recent_payments_common.php'),(20815425,2589,'./includes/home/billing/recent_payments_common.php'),(20815424,2225,'./includes/home/billing/recent_payments_common.php'),(20815423,4087,'./includes/home/billing/recent_payments_common.php'),(20815422,1913,'./includes/home/billing/recent_payments_common.php'),(20815421,1884,'./includes/home/billing/recent_payments_common.php'),(20815420,4973,'./includes/home/billing/recent_payments_common.php'),(20815419,697,'./includes/home/billing/recent_payments_common.php'),(20815438,4091,'./includes/home/billing/recent_sales_actions.php'),(20815437,2698,'./includes/home/billing/recent_sales_actions.php'),(20815436,4078,'./includes/home/billing/recent_sales_actions.php'),(20815435,4090,'./includes/home/billing/recent_sales_actions.php'),(20815434,697,'./includes/home/billing/recent_sales_actions.php'),(20779287,3421,'./!/application/controllers/arinvoice.php'),(20815445,4091,'./includes/home/billing/sales_actions_needed_today.php'),(20815444,4931,'./includes/home/billing/sales_actions_needed_today.php'),(20815443,2698,'./includes/home/billing/sales_actions_needed_today.php'),(20815442,4090,'./includes/home/billing/sales_actions_needed_today.php'),(20815441,697,'./includes/home/billing/sales_actions_needed_today.php'),(20815440,4932,'./includes/home/billing/sales_actions_needed_today.php'),(20815439,47,'./includes/home/billing/sales_actions_needed_today.php'),(20815450,7222,'./includes/home/billing/twothirds_menu.php'),(20815449,4948,'./includes/home/billing/twothirds_menu.php'),(20815448,14707,'./includes/home/billing/twothirds_menu.php'),(20815447,14709,'./includes/home/billing/twothirds_menu.php'),(20815446,14712,'./includes/home/billing/twothirds_menu.php'),(20815457,2267,'./includes/home/billing/welcome.php'),(20815456,2208,'./includes/home/billing/welcome.php'),(20815455,4924,'./includes/home/billing/welcome.php'),(20815454,4940,'./includes/home/billing/welcome.php'),(20815453,670,'./includes/home/billing/welcome.php'),(20815452,479,'./includes/home/billing/welcome.php'),(20815451,445,'./includes/home/billing/welcome.php'),(20815460,4928,'./includes/home/billing/whole_menu.php'),(20815459,14713,'./includes/home/billing/whole_menu.php'),(20815458,7222,'./includes/home/billing/whole_menu.php'),(20815495,6034,'./includes/home/help/index.php'),(20815494,6033,'./includes/home/help/index.php'),(20815493,8191,'./includes/home/help/index.php'),(20815492,8157,'./includes/home/help/index.php'),(20815491,8027,'./includes/home/help/index.php'),(20815490,8156,'./includes/home/help/index.php'),(20815489,8025,'./includes/home/help/index.php'),(20815488,8620,'./includes/home/help/index.php'),(20815487,8619,'./includes/home/help/index.php'),(20815486,8618,'./includes/home/help/index.php'),(20815485,8616,'./includes/home/help/index.php'),(20815484,8615,'./includes/home/help/index.php'),(20815483,8614,'./includes/home/help/index.php'),(20815482,8613,'./includes/home/help/index.php'),(20815481,8612,'./includes/home/help/index.php'),(20815480,8611,'./includes/home/help/index.php'),(20815479,8610,'./includes/home/help/index.php'),(20815478,8609,'./includes/home/help/index.php'),(20815477,8608,'./includes/home/help/index.php'),(20815476,8607,'./includes/home/help/index.php'),(20815475,8606,'./includes/home/help/index.php'),(20815474,8605,'./includes/home/help/index.php'),(20815473,8604,'./includes/home/help/index.php'),(20815472,8603,'./includes/home/help/index.php'),(20815471,8602,'./includes/home/help/index.php'),(20815470,13092,'./includes/home/help/index.php'),(20815469,13091,'./includes/home/help/index.php'),(20815468,13090,'./includes/home/help/index.php'),(20815467,13089,'./includes/home/help/index.php'),(20815466,8601,'./includes/home/help/index.php'),(20815465,8600,'./includes/home/help/index.php'),(20815464,8024,'./includes/home/help/index.php'),(20815463,8261,'./includes/home/help/index.php'),(20815462,8177,'./includes/home/help/index.php'),(20815461,8023,'./includes/home/help/index.php'),(20815515,4198,'./includes/home/inventory/defines.php'),(20815514,4197,'./includes/home/inventory/defines.php'),(20815513,14720,'./includes/home/inventory/defines.php'),(20815512,4191,'./includes/home/inventory/defines.php'),(20815511,4190,'./includes/home/inventory/defines.php'),(20815510,14719,'./includes/home/inventory/defines.php'),(20815509,14718,'./includes/home/inventory/defines.php'),(20815508,4527,'./includes/home/inventory/defines.php'),(20815507,4526,'./includes/home/inventory/defines.php'),(20815506,4525,'./includes/home/inventory/defines.php'),(20815519,4524,'./includes/home/inventory/half_menu.php'),(20815518,4523,'./includes/home/inventory/half_menu.php'),(20815517,7222,'./includes/home/inventory/half_menu.php'),(20815516,4381,'./includes/home/inventory/half_menu.php'),(20815528,4189,'./includes/home/inventory/inventory_adjustments.php'),(20815527,3118,'./includes/home/inventory/inventory_adjustments.php'),(20815526,14721,'./includes/home/inventory/inventory_adjustments.php'),(20815525,2508,'./includes/home/inventory/inventory_adjustments.php'),(20815524,2008,'./includes/home/inventory/inventory_adjustments.php'),(20815523,1788,'./includes/home/inventory/inventory_adjustments.php'),(20815522,1713,'./includes/home/inventory/inventory_adjustments.php'),(20815521,1709,'./includes/home/inventory/inventory_adjustments.php'),(20815520,1031,'./includes/home/inventory/inventory_adjustments.php'),(20815847,1991,'./includes/home/orders/profitability_customers_month.php'),(20815533,1740,'./includes/home/inventory/inventory_category_usage_common.php'),(20815534,4530,'./includes/home/inventory/inventory_category_usage_common.php'),(20815535,1913,'./includes/home/inventory/inventory_category_usage_common.php'),(20815536,2008,'./includes/home/inventory/inventory_category_usage_common.php'),(20815537,2528,'./includes/home/inventory/inventory_category_usage_common.php'),(20815538,4531,'./includes/home/inventory/inventory_category_usage_common.php'),(20815539,4189,'./includes/home/inventory/inventory_category_usage_common.php'),(20815541,3415,'./includes/home/inventory/inventory_category_usage_common.php'),(20778910,16669,'./!/application/controllers/archive_reports.php'),(20778909,3672,'./!/application/controllers/archive_reports.php'),(20778908,1557,'./!/application/controllers/archive_reports.php'),(20778907,19178,'./!/application/controllers/archive_reports.php'),(20778906,10795,'./!/application/controllers/archive_reports.php'),(20778905,19177,'./!/application/controllers/archive_reports.php'),(20778904,19176,'./!/application/controllers/archive_reports.php'),(20815549,4534,'./includes/home/inventory/items_below_reorder.php'),(20815548,3118,'./includes/home/inventory/items_below_reorder.php'),(20815547,4386,'./includes/home/inventory/items_below_reorder.php'),(20815546,2008,'./includes/home/inventory/items_below_reorder.php'),(20781729,12221,'./!/application/controllers/item.php'),(20815557,4537,'./includes/home/inventory/new_items.php'),(20815556,3118,'./includes/home/inventory/new_items.php'),(20815555,2008,'./includes/home/inventory/new_items.php'),(20815554,14722,'./includes/home/inventory/new_items.php'),(20815553,1713,'./includes/home/inventory/new_items.php'),(20815552,1709,'./includes/home/inventory/new_items.php'),(20815551,1031,'./includes/home/inventory/new_items.php'),(20815550,451,'./includes/home/inventory/new_items.php'),(20815565,4541,'./includes/home/inventory/pending_build_order.php'),(20815564,3118,'./includes/home/inventory/pending_build_order.php'),(20815563,2508,'./includes/home/inventory/pending_build_order.php'),(20815562,4523,'./includes/home/inventory/pending_build_order.php'),(20781391,19492,'./!/application/controllers/invcountbatch.php'),(20815573,4544,'./includes/home/inventory/pending_po.php'),(20815572,3274,'./includes/home/inventory/pending_po.php'),(20815571,3118,'./includes/home/inventory/pending_po.php'),(20815570,2363,'./includes/home/inventory/pending_po.php'),(20778813,567,'./!/application/controllers/apbill.php'),(20695804,4086,'./includes/home/inventory/pending_sales_overview.php'),(20695803,3164,'./includes/home/inventory/pending_sales_overview.php'),(20695802,2368,'./includes/home/inventory/pending_sales_overview.php'),(20695801,4077,'./includes/home/inventory/pending_sales_overview.php'),(20695800,4085,'./includes/home/inventory/pending_sales_overview.php'),(20695799,4084,'./includes/home/inventory/pending_sales_overview.php'),(20695797,1372,'./includes/home/inventory/pending_sales_overview.php'),(20695798,1530,'./includes/home/inventory/pending_sales_overview.php'),(20815585,3415,'./includes/home/inventory/profitability_items_common.php'),(20815584,3358,'./includes/home/inventory/profitability_items_common.php'),(20815583,4189,'./includes/home/inventory/profitability_items_common.php'),(20815582,14723,'./includes/home/inventory/profitability_items_common.php'),(20815581,4194,'./includes/home/inventory/profitability_items_common.php'),(20815580,4193,'./includes/home/inventory/profitability_items_common.php'),(20815579,2008,'./includes/home/inventory/profitability_items_common.php'),(20815578,1913,'./includes/home/inventory/profitability_items_common.php'),(20815593,4544,'./includes/home/inventory/receipts_with_po.php'),(20815592,3274,'./includes/home/inventory/receipts_with_po.php'),(20815591,3118,'./includes/home/inventory/receipts_with_po.php'),(20815590,4546,'./includes/home/inventory/receipts_with_po.php'),(20815589,2363,'./includes/home/inventory/receipts_with_po.php'),(20815588,4542,'./includes/home/inventory/receipts_with_po.php'),(20815587,14724,'./includes/home/inventory/receipts_with_po.php'),(20815586,226,'./includes/home/inventory/receipts_with_po.php'),(20781731,4626,'./!/application/controllers/item.php'),(20815601,4548,'./includes/home/inventory/receipts_without_po.php'),(20815600,3274,'./includes/home/inventory/receipts_without_po.php'),(20815599,3118,'./includes/home/inventory/receipts_without_po.php'),(20815598,4546,'./includes/home/inventory/receipts_without_po.php'),(20815608,4091,'./includes/home/inventory/recent_sales_actions.php'),(20815607,2698,'./includes/home/inventory/recent_sales_actions.php'),(20815606,4078,'./includes/home/inventory/recent_sales_actions.php'),(20815605,4090,'./includes/home/inventory/recent_sales_actions.php'),(20815604,697,'./includes/home/inventory/recent_sales_actions.php'),(20815603,4129,'./includes/home/inventory/recent_sales_actions.php'),(20815602,47,'./includes/home/inventory/recent_sales_actions.php'),(20815617,5241,'./includes/home/inventory/top_selling_items.php'),(20815616,4667,'./includes/home/inventory/top_selling_items.php'),(20815615,5240,'./includes/home/inventory/top_selling_items.php'),(20815614,5239,'./includes/home/inventory/top_selling_items.php'),(20815613,2522,'./includes/home/inventory/top_selling_items.php'),(20815612,2034,'./includes/home/inventory/top_selling_items.php'),(20815611,869,'./includes/home/inventory/top_selling_items.php'),(20815610,548,'./includes/home/inventory/top_selling_items.php'),(20815609,226,'./includes/home/inventory/top_selling_items.php'),(20815629,3415,'./includes/home/inventory/topsales_items_common.php'),(20815628,3358,'./includes/home/inventory/topsales_items_common.php'),(20815627,4189,'./includes/home/inventory/topsales_items_common.php'),(20815626,14726,'./includes/home/inventory/topsales_items_common.php'),(20815625,4187,'./includes/home/inventory/topsales_items_common.php'),(20815624,4166,'./includes/home/inventory/topsales_items_common.php'),(20815623,2008,'./includes/home/inventory/topsales_items_common.php'),(20815622,1913,'./includes/home/inventory/topsales_items_common.php'),(20815621,1713,'./includes/home/inventory/topsales_items_common.php'),(20815620,4130,'./includes/home/inventory/topsales_items_common.php'),(20815619,4973,'./includes/home/inventory/topsales_items_common.php'),(20815618,11908,'./includes/home/inventory/topsales_items_common.php'),(20815635,4198,'./includes/home/inventory/twothirds_menu.php'),(20815634,4197,'./includes/home/inventory/twothirds_menu.php'),(20815633,4191,'./includes/home/inventory/twothirds_menu.php'),(20815643,6443,'./includes/home/inventory/welcome.php'),(20815642,4553,'./includes/home/inventory/welcome.php'),(20815641,16671,'./includes/home/inventory/welcome.php'),(20815647,7222,'./includes/home/inventory/whole_menu.php'),(20781730,3097,'./!/application/controllers/item.php'),(20815648,14721,'./includes/home/inventory/whole_menu.php'),(20815656,5033,'./includes/home/ledger/bar_profit_12month.php'),(20781728,3118,'./!/application/controllers/item.php'),(20815655,8276,'./includes/home/ledger/bar_profit_12month.php'),(20815654,2664,'./includes/home/ledger/bar_profit_12month.php'),(20815653,5027,'./includes/home/ledger/bar_profit_12month.php'),(20815664,5033,'./includes/home/ledger/bar_profit_5year.php'),(20815663,8276,'./includes/home/ledger/bar_profit_5year.php'),(20815662,2664,'./includes/home/ledger/bar_profit_5year.php'),(20815661,5027,'./includes/home/ledger/bar_profit_5year.php'),(20815660,7616,'./includes/home/ledger/bar_profit_5year.php'),(20815659,13054,'./includes/home/ledger/bar_profit_5year.php'),(20815658,1353,'./includes/home/ledger/bar_profit_5year.php'),(20815657,7615,'./includes/home/ledger/bar_profit_5year.php'),(20815676,14731,'./includes/home/ledger/defines.php'),(20815675,5030,'./includes/home/ledger/defines.php'),(20815674,5020,'./includes/home/ledger/defines.php'),(20815673,14730,'./includes/home/ledger/defines.php'),(20815672,14729,'./includes/home/ledger/defines.php'),(20815671,5029,'./includes/home/ledger/defines.php'),(20815670,7616,'./includes/home/ledger/defines.php'),(20815669,14727,'./includes/home/ledger/defines.php'),(20815668,5031,'./includes/home/ledger/defines.php'),(20815667,5025,'./includes/home/ledger/defines.php'),(20815666,14728,'./includes/home/ledger/defines.php'),(20815665,5971,'./includes/home/ledger/defines.php'),(20815681,5970,'./includes/home/ledger/glrepincome.php'),(20815680,2320,'./includes/home/ledger/glrepincome.php'),(20815679,2318,'./includes/home/ledger/glrepincome.php'),(20815678,1944,'./includes/home/ledger/glrepincome.php'),(20815677,5969,'./includes/home/ledger/glrepincome.php'),(20815685,3115,'./includes/home/ledger/glrepincomefunction.php'),(20815684,3090,'./includes/home/ledger/glrepincomefunction.php'),(20815683,2157,'./includes/home/ledger/glrepincomefunction.php'),(20815682,1539,'./includes/home/ledger/glrepincomefunction.php'),(20781727,3090,'./!/application/controllers/item.php'),(20781726,2985,'./!/application/controllers/item.php'),(20815690,14731,'./includes/home/ledger/half_menu.php'),(20815689,14730,'./includes/home/ledger/half_menu.php'),(20815688,14729,'./includes/home/ledger/half_menu.php'),(20815699,3333,'./includes/home/ledger/recent_journal.php'),(20815698,5022,'./includes/home/ledger/recent_journal.php'),(20815697,3118,'./includes/home/ledger/recent_journal.php'),(20815696,2907,'./includes/home/ledger/recent_journal.php'),(20815695,1997,'./includes/home/ledger/recent_journal.php'),(20815707,5024,'./includes/home/ledger/sales_12month.php'),(20815706,3118,'./includes/home/ledger/sales_12month.php'),(20815705,14730,'./includes/home/ledger/sales_12month.php'),(20815704,2664,'./includes/home/ledger/sales_12month.php'),(20779818,13556,'./!/application/controllers/billtrust.php'),(20815715,5024,'./includes/home/ledger/sales_7day.php'),(20815714,3118,'./includes/home/ledger/sales_7day.php'),(20815713,14729,'./includes/home/ledger/sales_7day.php'),(20815712,2664,'./includes/home/ledger/sales_7day.php'),(20815723,5024,'./includes/home/ledger/sales_8week.php'),(20815722,3118,'./includes/home/ledger/sales_8week.php'),(20815721,14731,'./includes/home/ledger/sales_8week.php'),(20815720,2664,'./includes/home/ledger/sales_8week.php'),(20815719,2315,'./includes/home/ledger/sales_8week.php'),(20815718,1993,'./includes/home/ledger/sales_8week.php'),(20815717,869,'./includes/home/ledger/sales_8week.php'),(20815716,20,'./includes/home/ledger/sales_8week.php'),(20815725,7222,'./includes/home/ledger/twothirds_menu.php'),(20781362,15410,'./!/application/controllers/invcountbatch.php'),(20781359,18810,'./!/application/controllers/invcountbatch.php'),(20815727,5026,'./includes/home/ledger/welcome.php'),(20815726,3705,'./includes/home/ledger/welcome.php'),(20815730,7616,'./includes/home/ledger/whole_menu.php'),(20815729,5031,'./includes/home/ledger/whole_menu.php'),(20815741,4178,'./includes/home/orders/arorder_volume_12month.php'),(20815740,3118,'./includes/home/orders/arorder_volume_12month.php'),(20815739,2590,'./includes/home/orders/arorder_volume_12month.php'),(20815738,2529,'./includes/home/orders/arorder_volume_12month.php'),(20815737,14732,'./includes/home/orders/arorder_volume_12month.php'),(20815736,4166,'./includes/home/orders/arorder_volume_12month.php'),(20815752,4178,'./includes/home/orders/arorder_volume_7day.php'),(20815751,3118,'./includes/home/orders/arorder_volume_7day.php'),(20815750,2590,'./includes/home/orders/arorder_volume_7day.php'),(20815749,2529,'./includes/home/orders/arorder_volume_7day.php'),(20815748,14733,'./includes/home/orders/arorder_volume_7day.php'),(20815747,4166,'./includes/home/orders/arorder_volume_7day.php'),(20815746,2034,'./includes/home/orders/arorder_volume_7day.php'),(20815745,4165,'./includes/home/orders/arorder_volume_7day.php'),(20815744,749,'./includes/home/orders/arorder_volume_7day.php'),(20815743,4162,'./includes/home/orders/arorder_volume_7day.php'),(20815742,226,'./includes/home/orders/arorder_volume_7day.php'),(20815763,3358,'./includes/home/orders/arorder_volume_8week.php'),(20815762,4178,'./includes/home/orders/arorder_volume_8week.php'),(20815761,3118,'./includes/home/orders/arorder_volume_8week.php'),(20815760,2590,'./includes/home/orders/arorder_volume_8week.php'),(20815759,2529,'./includes/home/orders/arorder_volume_8week.php'),(20815758,4181,'./includes/home/orders/arorder_volume_8week.php'),(20815757,4166,'./includes/home/orders/arorder_volume_8week.php'),(20815756,2034,'./includes/home/orders/arorder_volume_8week.php'),(20815755,4165,'./includes/home/orders/arorder_volume_8week.php'),(20815754,4162,'./includes/home/orders/arorder_volume_8week.php'),(20815753,226,'./includes/home/orders/arorder_volume_8week.php'),(20815789,4198,'./includes/home/orders/defines.php'),(20815788,4197,'./includes/home/orders/defines.php'),(20815787,4201,'./includes/home/orders/defines.php'),(20815786,4200,'./includes/home/orders/defines.php'),(20815785,4191,'./includes/home/orders/defines.php'),(20815784,4190,'./includes/home/orders/defines.php'),(20815783,4185,'./includes/home/orders/defines.php'),(20815782,4184,'./includes/home/orders/defines.php'),(20815781,4054,'./includes/home/orders/defines.php'),(20815780,4042,'./includes/home/orders/defines.php'),(20815779,4154,'./includes/home/orders/defines.php'),(20815778,4159,'./includes/home/orders/defines.php'),(20815777,4060,'./includes/home/orders/defines.php'),(20815776,4059,'./includes/home/orders/defines.php'),(20815775,4058,'./includes/home/orders/defines.php'),(20815774,4057,'./includes/home/orders/defines.php'),(20815773,4181,'./includes/home/orders/defines.php'),(20815772,4180,'./includes/home/orders/defines.php'),(20815771,14732,'./includes/home/orders/defines.php'),(20815770,14733,'./includes/home/orders/defines.php'),(20815769,4179,'./includes/home/orders/defines.php'),(20815768,5672,'./includes/home/orders/defines.php'),(20815767,4056,'./includes/home/orders/defines.php'),(20815766,4155,'./includes/home/orders/defines.php'),(20815765,9284,'./includes/home/orders/defines.php'),(20815764,5668,'./includes/home/orders/defines.php'),(20815795,14737,'./includes/home/orders/half_menu.php'),(20815794,14736,'./includes/home/orders/half_menu.php'),(20815793,14735,'./includes/home/orders/half_menu.php'),(20815804,4050,'./includes/home/orders/open_orders_all.php'),(20815803,3118,'./includes/home/orders/open_orders_all.php'),(20815802,2292,'./includes/home/orders/open_orders_all.php'),(20815801,2165,'./includes/home/orders/open_orders_all.php'),(20815800,4155,'./includes/home/orders/open_orders_all.php'),(20815799,2034,'./includes/home/orders/open_orders_all.php'),(20815798,932,'./includes/home/orders/open_orders_all.php'),(20815797,697,'./includes/home/orders/open_orders_all.php'),(20815796,596,'./includes/home/orders/open_orders_all.php'),(20815814,4050,'./includes/home/orders/open_orders_due_dates.php'),(20815813,3118,'./includes/home/orders/open_orders_due_dates.php'),(20815812,2292,'./includes/home/orders/open_orders_due_dates.php'),(20815811,2165,'./includes/home/orders/open_orders_due_dates.php'),(20815810,4053,'./includes/home/orders/open_orders_due_dates.php'),(20815808,2034,'./includes/home/orders/open_orders_due_dates.php'),(20815824,9302,'./includes/home/orders/open_orders_mine.php'),(20815823,3118,'./includes/home/orders/open_orders_mine.php'),(20815822,2292,'./includes/home/orders/open_orders_mine.php'),(20815821,2165,'./includes/home/orders/open_orders_mine.php'),(20815820,2034,'./includes/home/orders/open_orders_mine.php'),(20815819,9284,'./includes/home/orders/open_orders_mine.php'),(20815818,932,'./includes/home/orders/open_orders_mine.php'),(20815817,697,'./includes/home/orders/open_orders_mine.php'),(20815816,596,'./includes/home/orders/open_orders_mine.php'),(20815815,197,'./includes/home/orders/open_orders_mine.php'),(20815832,3118,'./includes/home/orders/over_estimate_orders.php'),(20815831,5679,'./includes/home/orders/over_estimate_orders.php'),(20815830,5672,'./includes/home/orders/over_estimate_orders.php'),(20815829,2165,'./includes/home/orders/over_estimate_orders.php'),(20815828,5674,'./includes/home/orders/over_estimate_orders.php'),(20815827,4083,'./includes/home/orders/over_estimate_orders.php'),(20815826,697,'./includes/home/orders/over_estimate_orders.php'),(20815825,5673,'./includes/home/orders/over_estimate_orders.php'),(20815833,4061,'./includes/home/orders/performance_statistics_15.php'),(20815834,4055,'./includes/home/orders/performance_statistics_30.php'),(20815835,4062,'./includes/home/orders/performance_statistics_60.php'),(20815836,4063,'./includes/home/orders/performance_statistics_90.php'),(20780317,4109,'./!/application/controllers/customer.php'),(20815844,4051,'./includes/home/orders/performance_statistics_common.php'),(20815843,2200,'./includes/home/orders/performance_statistics_common.php'),(20815842,2140,'./includes/home/orders/performance_statistics_common.php'),(20815841,2034,'./includes/home/orders/performance_statistics_common.php'),(20815839,1740,'./includes/home/orders/performance_statistics_common.php'),(20815840,1759,'./includes/home/orders/performance_statistics_common.php'),(20779286,3415,'./!/application/controllers/arinvoice.php'),(20815851,4049,'./includes/home/orders/profitability_customers_month.php'),(20815850,4200,'./includes/home/orders/profitability_customers_month.php'),(20815848,4193,'./includes/home/orders/profitability_customers_month.php'),(20815849,4194,'./includes/home/orders/profitability_customers_month.php'),(20815858,4049,'./includes/home/orders/profitability_customers_year.php'),(20815857,4201,'./includes/home/orders/profitability_customers_year.php'),(20815856,4194,'./includes/home/orders/profitability_customers_year.php'),(20815855,4193,'./includes/home/orders/profitability_customers_year.php'),(20815854,1991,'./includes/home/orders/profitability_customers_year.php'),(20815853,697,'./includes/home/orders/profitability_customers_year.php'),(20815852,4192,'./includes/home/orders/profitability_customers_year.php'),(20815865,4161,'./includes/home/orders/recently_added_customers.php'),(20815864,3118,'./includes/home/orders/recently_added_customers.php'),(20815863,14734,'./includes/home/orders/recently_added_customers.php'),(20815862,1991,'./includes/home/orders/recently_added_customers.php'),(20815861,697,'./includes/home/orders/recently_added_customers.php'),(20815860,605,'./includes/home/orders/recently_added_customers.php'),(20815859,4160,'./includes/home/orders/recently_added_customers.php'),(20815873,4050,'./includes/home/orders/recently_received_orders.php'),(20815872,3118,'./includes/home/orders/recently_received_orders.php'),(20815871,14735,'./includes/home/orders/recently_received_orders.php'),(20815870,4157,'./includes/home/orders/recently_received_orders.php'),(20815869,2404,'./includes/home/orders/recently_received_orders.php'),(20815868,2165,'./includes/home/orders/recently_received_orders.php'),(20815867,2034,'./includes/home/orders/recently_received_orders.php'),(20815866,697,'./includes/home/orders/recently_received_orders.php'),(20815882,4047,'./includes/home/orders/recently_shipped_items.php'),(20815881,3118,'./includes/home/orders/recently_shipped_items.php'),(20815880,2816,'./includes/home/orders/recently_shipped_items.php'),(20815879,14736,'./includes/home/orders/recently_shipped_items.php'),(20815878,2508,'./includes/home/orders/recently_shipped_items.php'),(20815890,4049,'./includes/home/orders/recently_shipped_orders.php'),(20815889,3118,'./includes/home/orders/recently_shipped_orders.php'),(20815888,2816,'./includes/home/orders/recently_shipped_orders.php'),(20815887,14737,'./includes/home/orders/recently_shipped_orders.php'),(20815886,2165,'./includes/home/orders/recently_shipped_orders.php'),(20815885,2034,'./includes/home/orders/recently_shipped_orders.php'),(20815884,697,'./includes/home/orders/recently_shipped_orders.php'),(20815883,434,'./includes/home/orders/recently_shipped_orders.php'),(20797156,12973,'./customcommissions.php'),(20815900,4298,'./includes/home/orders/service_order_workers_on_jobs.php'),(20815899,5667,'./includes/home/orders/service_order_workers_on_jobs.php'),(20815898,5617,'./includes/home/orders/service_order_workers_on_jobs.php'),(20815897,3090,'./includes/home/orders/service_order_workers_on_jobs.php'),(20815896,5666,'./includes/home/orders/service_order_workers_on_jobs.php'),(20815895,5665,'./includes/home/orders/service_order_workers_on_jobs.php'),(20815894,2165,'./includes/home/orders/service_order_workers_on_jobs.php'),(20797154,3090,'./customcommissions.php'),(20815909,3415,'./includes/home/orders/topdollar_customers_common.php'),(20797153,19685,'./customcommissions.php'),(20797152,19684,'./customcommissions.php'),(20797151,19683,'./customcommissions.php'),(20815904,2008,'./includes/home/orders/topdollar_customers_common.php'),(20815905,4166,'./includes/home/orders/topdollar_customers_common.php'),(20815906,14738,'./includes/home/orders/topdollar_customers_common.php'),(20815908,4183,'./includes/home/orders/topdollar_customers_common.php'),(20815907,3090,'./includes/home/orders/topdollar_customers_common.php'),(20797150,2702,'./customcommissions.php'),(20815922,4198,'./includes/home/orders/twothirds_menu.php'),(20815921,4197,'./includes/home/orders/twothirds_menu.php'),(20815920,4201,'./includes/home/orders/twothirds_menu.php'),(20815919,4200,'./includes/home/orders/twothirds_menu.php'),(20815918,4191,'./includes/home/orders/twothirds_menu.php'),(20815917,14719,'./includes/home/orders/twothirds_menu.php'),(20815916,4185,'./includes/home/orders/twothirds_menu.php'),(20815933,4884,'./includes/home/orders/welcome.php'),(20815932,4153,'./includes/home/orders/welcome.php'),(20815931,2801,'./includes/home/orders/welcome.php'),(20815930,16675,'./includes/home/orders/welcome.php'),(20815929,2200,'./includes/home/orders/welcome.php'),(20815928,14740,'./includes/home/orders/welcome.php'),(20815927,4151,'./includes/home/orders/welcome.php'),(20815926,9286,'./includes/home/orders/welcome.php'),(20815925,6415,'./includes/home/orders/welcome.php'),(20815924,5493,'./includes/home/orders/welcome.php'),(20815923,6414,'./includes/home/orders/welcome.php'),(20815941,4060,'./includes/home/orders/whole_menu.php'),(20815940,4059,'./includes/home/orders/whole_menu.php'),(20815939,4058,'./includes/home/orders/whole_menu.php'),(20815938,4057,'./includes/home/orders/whole_menu.php'),(20797149,5876,'./customcommissions.php'),(20797148,2292,'./customcommissions.php'),(20797147,2238,'./customcommissions.php'),(20797146,2225,'./customcommissions.php'),(20797145,2044,'./customcommissions.php'),(20696179,4939,'./includes/home/payables/ap_aging_summary.php'),(20696178,2008,'./includes/home/payables/ap_aging_summary.php'),(20696177,683,'./includes/home/payables/ap_aging_summary.php'),(20696176,4938,'./includes/home/payables/ap_aging_summary.php'),(20797144,19682,'./customcommissions.php'),(20797143,1963,'./customcommissions.php'),(20815951,4958,'./includes/home/payables/bills_due_dates.php'),(20815950,3274,'./includes/home/payables/bills_due_dates.php'),(20815949,3118,'./includes/home/payables/bills_due_dates.php'),(20815948,4957,'./includes/home/payables/bills_due_dates.php'),(20815947,4081,'./includes/home/payables/bills_due_dates.php'),(20815956,4081,'./includes/home/payables/bills_volume_12month.php'),(20779279,3295,'./!/application/controllers/arinvoice.php'),(20815960,4958,'./includes/home/payables/bills_volume_12month.php'),(20815959,3118,'./includes/home/payables/bills_volume_12month.php'),(20815958,2267,'./includes/home/payables/bills_volume_12month.php'),(20815957,2109,'./includes/home/payables/bills_volume_12month.php'),(20815969,4958,'./includes/home/payables/bills_volume_7day.php'),(20815968,3118,'./includes/home/payables/bills_volume_7day.php'),(20815967,2267,'./includes/home/payables/bills_volume_7day.php'),(20815966,2109,'./includes/home/payables/bills_volume_7day.php'),(20815965,4081,'./includes/home/payables/bills_volume_7day.php'),(20815964,4940,'./includes/home/payables/bills_volume_7day.php'),(20815963,749,'./includes/home/payables/bills_volume_7day.php'),(20815962,14742,'./includes/home/payables/bills_volume_7day.php'),(20815961,226,'./includes/home/payables/bills_volume_7day.php'),(20797142,19681,'./customcommissions.php'),(20815979,4958,'./includes/home/payables/bills_volume_8week.php'),(20815978,3118,'./includes/home/payables/bills_volume_8week.php'),(20815977,2315,'./includes/home/payables/bills_volume_8week.php'),(20815976,2267,'./includes/home/payables/bills_volume_8week.php'),(20815975,2109,'./includes/home/payables/bills_volume_8week.php'),(20815974,4081,'./includes/home/payables/bills_volume_8week.php'),(20815973,4940,'./includes/home/payables/bills_volume_8week.php'),(20815972,4959,'./includes/home/payables/bills_volume_8week.php'),(20815971,226,'./includes/home/payables/bills_volume_8week.php'),(20815970,4946,'./includes/home/payables/bills_volume_8week.php'),(20815997,15700,'./includes/home/payables/defines.php'),(20815996,4961,'./includes/home/payables/defines.php'),(20815995,4960,'./includes/home/payables/defines.php'),(20815994,14746,'./includes/home/payables/defines.php'),(20815993,14745,'./includes/home/payables/defines.php'),(20815992,14744,'./includes/home/payables/defines.php'),(20815991,14743,'./includes/home/payables/defines.php'),(20815990,4967,'./includes/home/payables/defines.php'),(20815989,4987,'./includes/home/payables/defines.php'),(20779285,3414,'./!/application/controllers/arinvoice.php'),(20816003,14746,'./includes/home/payables/half_menu.php'),(20816002,14745,'./includes/home/payables/half_menu.php'),(20816001,14744,'./includes/home/payables/half_menu.php'),(20816000,14743,'./includes/home/payables/half_menu.php'),(20815999,4967,'./includes/home/payables/half_menu.php'),(20815998,7222,'./includes/home/payables/half_menu.php'),(20797141,1775,'./customcommissions.php'),(20816014,4981,'./includes/home/payables/pending_po.php'),(20816013,3274,'./includes/home/payables/pending_po.php'),(20816012,3118,'./includes/home/payables/pending_po.php'),(20816011,2838,'./includes/home/payables/pending_po.php'),(20816010,4980,'./includes/home/payables/pending_po.php'),(20816009,2363,'./includes/home/payables/pending_po.php'),(20816008,4979,'./includes/home/payables/pending_po.php'),(20816007,4987,'./includes/home/payables/pending_po.php'),(20816006,2165,'./includes/home/payables/pending_po.php'),(20816005,4977,'./includes/home/payables/pending_po.php'),(20816004,932,'./includes/home/payables/pending_po.php'),(20797140,1735,'./customcommissions.php'),(20816026,4981,'./includes/home/payables/pending_po_item.php'),(20816025,3274,'./includes/home/payables/pending_po_item.php'),(20816024,3269,'./includes/home/payables/pending_po_item.php'),(20816023,3118,'./includes/home/payables/pending_po_item.php'),(20816021,2508,'./includes/home/payables/pending_po_item.php'),(20778812,543,'./!/application/controllers/apbill.php'),(20816022,4980,'./includes/home/payables/pending_po_item.php'),(20696276,3421,'./includes/home/payables/receive_inventory.php'),(20696275,4981,'./includes/home/payables/receive_inventory.php'),(20696274,3274,'./includes/home/payables/receive_inventory.php'),(20696273,3269,'./includes/home/payables/receive_inventory.php'),(20696272,3118,'./includes/home/payables/receive_inventory.php'),(20696271,4983,'./includes/home/payables/receive_inventory.php'),(20696270,2589,'./includes/home/payables/receive_inventory.php'),(20696269,2508,'./includes/home/payables/receive_inventory.php'),(20696268,2043,'./includes/home/payables/receive_inventory.php'),(20696267,1973,'./includes/home/payables/receive_inventory.php'),(20696266,4982,'./includes/home/payables/receive_inventory.php'),(20696265,869,'./includes/home/payables/receive_inventory.php'),(20816033,4958,'./includes/home/payables/recent_bills.php'),(20816032,3274,'./includes/home/payables/recent_bills.php'),(20816031,4967,'./includes/home/payables/recent_bills.php'),(20816030,4081,'./includes/home/payables/recent_bills.php'),(20797139,19680,'./customcommissions.php'),(20816045,3415,'./includes/home/payables/recent_checks_common.php'),(20816044,3358,'./includes/home/payables/recent_checks_common.php'),(20816043,4958,'./includes/home/payables/recent_checks_common.php'),(20816042,3274,'./includes/home/payables/recent_checks_common.php'),(20816041,3118,'./includes/home/payables/recent_checks_common.php'),(20816040,4971,'./includes/home/payables/recent_checks_common.php'),(20816055,3415,'./includes/home/payables/topdollar_vendors_common.php'),(20816054,3358,'./includes/home/payables/topdollar_vendors_common.php'),(20816053,4958,'./includes/home/payables/topdollar_vendors_common.php'),(20816052,3274,'./includes/home/payables/topdollar_vendors_common.php'),(20816051,3090,'./includes/home/payables/topdollar_vendors_common.php'),(20816050,14747,'./includes/home/payables/topdollar_vendors_common.php'),(20816049,4933,'./includes/home/payables/topdollar_vendors_common.php'),(20816057,7222,'./includes/home/payables/twothirds_menu.php'),(20816056,5242,'./includes/home/payables/twothirds_menu.php'),(20816065,3274,'./includes/home/payables/unapproved_apbills.php'),(20816064,15700,'./includes/home/payables/unapproved_apbills.php'),(20816063,3118,'./includes/home/payables/unapproved_apbills.php'),(20816062,4081,'./includes/home/payables/unapproved_apbills.php'),(20816061,1668,'./includes/home/payables/unapproved_apbills.php'),(20816060,932,'./includes/home/payables/unapproved_apbills.php'),(20816059,6646,'./includes/home/payables/unapproved_apbills.php'),(20816058,226,'./includes/home/payables/unapproved_apbills.php'),(20816069,4954,'./includes/home/payables/welcome.php'),(20816068,4953,'./includes/home/payables/welcome.php'),(20816075,4987,'./includes/home/payables/whole_menu.php'),(20816074,4978,'./includes/home/payables/whole_menu.php'),(20816073,7222,'./includes/home/payables/whole_menu.php'),(20816072,4966,'./includes/home/payables/whole_menu.php'),(20816071,14741,'./includes/home/payables/whole_menu.php'),(20816070,14742,'./includes/home/payables/whole_menu.php'),(20816080,4990,'./includes/home/payroll/birthdays.php'),(20816079,4989,'./includes/home/payroll/birthdays.php'),(20816078,989,'./includes/home/payroll/birthdays.php'),(20816092,14512,'./includes/home/payroll/defines.php'),(20816091,5014,'./includes/home/payroll/defines.php'),(20816090,14749,'./includes/home/payroll/defines.php'),(20816089,14748,'./includes/home/payroll/defines.php'),(20816088,4992,'./includes/home/payroll/defines.php'),(20816087,4991,'./includes/home/payroll/defines.php'),(20816086,5006,'./includes/home/payroll/defines.php'),(20816085,5005,'./includes/home/payroll/defines.php'),(20816084,5004,'./includes/home/payroll/defines.php'),(20816083,5009,'./includes/home/payroll/defines.php'),(20816082,5007,'./includes/home/payroll/defines.php'),(20816081,4988,'./includes/home/payroll/defines.php'),(20816098,4997,'./includes/home/payroll/employee_counts.php'),(20816097,5008,'./includes/home/payroll/employee_counts.php'),(20816096,2315,'./includes/home/payroll/employee_counts.php'),(20816095,1993,'./includes/home/payroll/employee_counts.php'),(20816094,1561,'./includes/home/payroll/employee_counts.php'),(20816093,5007,'./includes/home/payroll/employee_counts.php'),(20816102,14748,'./includes/home/payroll/half_menu.php'),(20816101,4991,'./includes/home/payroll/half_menu.php'),(20816109,4997,'./includes/home/payroll/paychanges.php'),(20816108,14748,'./includes/home/payroll/paychanges.php'),(20816107,5010,'./includes/home/payroll/paychanges.php'),(20816106,4995,'./includes/home/payroll/paychanges.php'),(20816105,4994,'./includes/home/payroll/paychanges.php'),(20816104,989,'./includes/home/payroll/paychanges.php'),(20816103,4993,'./includes/home/payroll/paychanges.php'),(20816116,4997,'./includes/home/payroll/payroll_by_month.php'),(20797138,19679,'./customcommissions.php'),(20816115,3118,'./includes/home/payroll/payroll_by_month.php'),(20816114,5004,'./includes/home/payroll/payroll_by_month.php'),(20816113,2238,'./includes/home/payroll/payroll_by_month.php'),(20816124,4997,'./includes/home/payroll/payroll_by_quarter.php'),(20816123,3118,'./includes/home/payroll/payroll_by_quarter.php'),(20816122,2535,'./includes/home/payroll/payroll_by_quarter.php'),(20816121,5005,'./includes/home/payroll/payroll_by_quarter.php'),(20816120,2238,'./includes/home/payroll/payroll_by_quarter.php'),(20816119,4998,'./includes/home/payroll/payroll_by_quarter.php'),(20816118,1564,'./includes/home/payroll/payroll_by_quarter.php'),(20816117,989,'./includes/home/payroll/payroll_by_quarter.php'),(20816132,3358,'./includes/home/payroll/payroll_by_week.php'),(20816131,4997,'./includes/home/payroll/payroll_by_week.php'),(20816130,3118,'./includes/home/payroll/payroll_by_week.php'),(20816129,5006,'./includes/home/payroll/payroll_by_week.php'),(20816128,2238,'./includes/home/payroll/payroll_by_week.php'),(20816127,4998,'./includes/home/payroll/payroll_by_week.php'),(20816126,1564,'./includes/home/payroll/payroll_by_week.php'),(20816125,989,'./includes/home/payroll/payroll_by_week.php'),(20816143,4997,'./includes/home/payroll/recent_layoffs.php'),(20816142,4991,'./includes/home/payroll/recent_layoffs.php'),(20816141,5000,'./includes/home/payroll/recent_layoffs.php'),(20816140,989,'./includes/home/payroll/recent_layoffs.php'),(20816139,4999,'./includes/home/payroll/recent_layoffs.php'),(20816150,4997,'./includes/home/payroll/recent_reviews.php'),(20816149,5013,'./includes/home/payroll/recent_reviews.php'),(20816148,14749,'./includes/home/payroll/recent_reviews.php'),(20816147,2578,'./includes/home/payroll/recent_reviews.php'),(20816146,5012,'./includes/home/payroll/recent_reviews.php'),(20816145,989,'./includes/home/payroll/recent_reviews.php'),(20816144,5011,'./includes/home/payroll/recent_reviews.php'),(20797137,19678,'./customcommissions.php'),(20816153,14749,'./includes/home/payroll/twothirds_menu.php'),(20816152,7222,'./includes/home/payroll/twothirds_menu.php'),(20816151,4988,'./includes/home/payroll/twothirds_menu.php'),(20816156,5003,'./includes/home/payroll/welcome.php'),(20816155,5002,'./includes/home/payroll/welcome.php'),(20816154,5001,'./includes/home/payroll/welcome.php'),(20816160,5006,'./includes/home/payroll/whole_menu.php'),(20816159,5005,'./includes/home/payroll/whole_menu.php'),(20816158,5004,'./includes/home/payroll/whole_menu.php'),(20816157,7222,'./includes/home/payroll/whole_menu.php'),(20816185,4064,'./includes/home/pricelist/defines.php'),(20797136,19677,'./customcommissions.php'),(20797135,1709,'./customcommissions.php'),(20816184,4692,'./includes/home/pricelist/defines.php'),(20816183,14750,'./includes/home/pricelist/defines.php'),(20816182,7520,'./includes/home/pricelist/defines.php'),(20816181,4914,'./includes/home/pricelist/defines.php'),(20816180,4201,'./includes/home/pricelist/defines.php'),(20816179,4200,'./includes/home/pricelist/defines.php'),(20816178,4913,'./includes/home/pricelist/defines.php'),(20816177,4071,'./includes/home/pricelist/defines.php'),(20816176,4907,'./includes/home/pricelist/defines.php'),(20816175,4904,'./includes/home/pricelist/defines.php'),(20816174,4896,'./includes/home/pricelist/defines.php'),(20816173,4063,'./includes/home/pricelist/defines.php'),(20797134,1696,'./customcommissions.php'),(20816192,4064,'./includes/home/pricelist/half_menu.php'),(20816191,4884,'./includes/home/pricelist/half_menu.php'),(20816190,4185,'./includes/home/pricelist/half_menu.php'),(20816189,4184,'./includes/home/pricelist/half_menu.php'),(20816188,14737,'./includes/home/pricelist/half_menu.php'),(20816187,7222,'./includes/home/pricelist/half_menu.php'),(20816186,7508,'./includes/home/pricelist/half_menu.php'),(20816202,4905,'./includes/home/pricelist/obs_month.php'),(20816201,3090,'./includes/home/pricelist/obs_month.php'),(20816200,2827,'./includes/home/pricelist/obs_month.php'),(20816199,2589,'./includes/home/pricelist/obs_month.php'),(20816198,4897,'./includes/home/pricelist/obs_month.php'),(20816197,7513,'./includes/home/pricelist/obs_month.php'),(20816196,7512,'./includes/home/pricelist/obs_month.php'),(20816195,4391,'./includes/home/pricelist/obs_month.php'),(20816194,4903,'./includes/home/pricelist/obs_month.php'),(20816193,387,'./includes/home/pricelist/obs_month.php'),(20816212,3090,'./includes/home/pricelist/obs_quarter.php'),(20816211,2827,'./includes/home/pricelist/obs_quarter.php'),(20816210,2589,'./includes/home/pricelist/obs_quarter.php'),(20816209,7517,'./includes/home/pricelist/obs_quarter.php'),(20816208,7516,'./includes/home/pricelist/obs_quarter.php'),(20816223,3090,'./includes/home/pricelist/obs_week.php'),(20816222,2827,'./includes/home/pricelist/obs_week.php'),(20816221,2589,'./includes/home/pricelist/obs_week.php'),(20816220,8360,'./includes/home/pricelist/obs_week.php'),(20816219,7518,'./includes/home/pricelist/obs_week.php'),(20816218,7515,'./includes/home/pricelist/obs_week.php'),(20816217,7512,'./includes/home/pricelist/obs_week.php'),(20816216,4391,'./includes/home/pricelist/obs_week.php'),(20816215,4895,'./includes/home/pricelist/obs_week.php'),(20816214,749,'./includes/home/pricelist/obs_week.php'),(20816213,387,'./includes/home/pricelist/obs_week.php'),(20816233,3090,'./includes/home/pricelist/obs_year.php'),(20816232,2827,'./includes/home/pricelist/obs_year.php'),(20816231,2589,'./includes/home/pricelist/obs_year.php'),(20816230,7519,'./includes/home/pricelist/obs_year.php'),(20816229,7515,'./includes/home/pricelist/obs_year.php'),(20816228,7512,'./includes/home/pricelist/obs_year.php'),(20816227,4391,'./includes/home/pricelist/obs_year.php'),(20816226,4906,'./includes/home/pricelist/obs_year.php'),(20816225,1913,'./includes/home/pricelist/obs_year.php'),(20816224,387,'./includes/home/pricelist/obs_year.php'),(20816243,4905,'./includes/home/pricelist/order_volume_month.php'),(20816242,3090,'./includes/home/pricelist/order_volume_month.php'),(20816241,2827,'./includes/home/pricelist/order_volume_month.php'),(20816240,2589,'./includes/home/pricelist/order_volume_month.php'),(20816239,2529,'./includes/home/pricelist/order_volume_month.php'),(20816237,4904,'./includes/home/pricelist/order_volume_month.php'),(20816253,3090,'./includes/home/pricelist/order_volume_week.php'),(20816252,2827,'./includes/home/pricelist/order_volume_week.php'),(20816251,2589,'./includes/home/pricelist/order_volume_week.php'),(20816250,2529,'./includes/home/pricelist/order_volume_week.php'),(20816249,4897,'./includes/home/pricelist/order_volume_week.php'),(20816248,4896,'./includes/home/pricelist/order_volume_week.php'),(20816247,4391,'./includes/home/pricelist/order_volume_week.php'),(20816246,4895,'./includes/home/pricelist/order_volume_week.php'),(20816245,4169,'./includes/home/pricelist/order_volume_week.php'),(20816244,749,'./includes/home/pricelist/order_volume_week.php'),(20816263,3090,'./includes/home/pricelist/order_volume_year.php'),(20816262,2827,'./includes/home/pricelist/order_volume_year.php'),(20816261,2589,'./includes/home/pricelist/order_volume_year.php'),(20816260,2529,'./includes/home/pricelist/order_volume_year.php'),(20816259,4897,'./includes/home/pricelist/order_volume_year.php'),(20816258,4907,'./includes/home/pricelist/order_volume_year.php'),(20816257,4391,'./includes/home/pricelist/order_volume_year.php'),(20816256,4906,'./includes/home/pricelist/order_volume_year.php'),(20816255,1913,'./includes/home/pricelist/order_volume_year.php'),(20816254,4169,'./includes/home/pricelist/order_volume_year.php'),(20816274,4905,'./includes/home/pricelist/pl_order_volume_month.php'),(20816273,3090,'./includes/home/pricelist/pl_order_volume_month.php'),(20816272,2827,'./includes/home/pricelist/pl_order_volume_month.php'),(20816271,2589,'./includes/home/pricelist/pl_order_volume_month.php'),(20816270,2529,'./includes/home/pricelist/pl_order_volume_month.php'),(20816269,4897,'./includes/home/pricelist/pl_order_volume_month.php'),(20816268,4904,'./includes/home/pricelist/pl_order_volume_month.php'),(20816267,4391,'./includes/home/pricelist/pl_order_volume_month.php'),(20816266,4903,'./includes/home/pricelist/pl_order_volume_month.php'),(20816265,4169,'./includes/home/pricelist/pl_order_volume_month.php'),(20816264,387,'./includes/home/pricelist/pl_order_volume_month.php'),(20816285,3090,'./includes/home/pricelist/pl_order_volume_week.php'),(20816284,2827,'./includes/home/pricelist/pl_order_volume_week.php'),(20816283,2589,'./includes/home/pricelist/pl_order_volume_week.php'),(20816282,2529,'./includes/home/pricelist/pl_order_volume_week.php'),(20816281,4897,'./includes/home/pricelist/pl_order_volume_week.php'),(20816280,4896,'./includes/home/pricelist/pl_order_volume_week.php'),(20816279,4391,'./includes/home/pricelist/pl_order_volume_week.php'),(20816278,4895,'./includes/home/pricelist/pl_order_volume_week.php'),(20816277,4169,'./includes/home/pricelist/pl_order_volume_week.php'),(20816276,749,'./includes/home/pricelist/pl_order_volume_week.php'),(20816275,387,'./includes/home/pricelist/pl_order_volume_week.php'),(20816296,3090,'./includes/home/pricelist/pl_order_volume_year.php'),(20816295,2827,'./includes/home/pricelist/pl_order_volume_year.php'),(20816294,2589,'./includes/home/pricelist/pl_order_volume_year.php'),(20816293,2529,'./includes/home/pricelist/pl_order_volume_year.php'),(20816292,4897,'./includes/home/pricelist/pl_order_volume_year.php'),(20816291,4907,'./includes/home/pricelist/pl_order_volume_year.php'),(20816290,4391,'./includes/home/pricelist/pl_order_volume_year.php'),(20816289,4906,'./includes/home/pricelist/pl_order_volume_year.php'),(20816288,1913,'./includes/home/pricelist/pl_order_volume_year.php'),(20816287,4169,'./includes/home/pricelist/pl_order_volume_year.php'),(20816286,387,'./includes/home/pricelist/pl_order_volume_year.php'),(20816297,4061,'./includes/home/pricelist/pl_performance_statistics_15.php'),(20816298,4055,'./includes/home/pricelist/pl_performance_statistics_30.php'),(20816299,4062,'./includes/home/pricelist/pl_performance_statistics_60.php'),(20816300,4063,'./includes/home/pricelist/pl_performance_statistics_90.php'),(20816308,4051,'./includes/home/pricelist/pl_performance_statistics_common.php'),(20816307,2200,'./includes/home/pricelist/pl_performance_statistics_common.php'),(20816306,2140,'./includes/home/pricelist/pl_performance_statistics_common.php'),(20816305,1759,'./includes/home/pricelist/pl_performance_statistics_common.php'),(20816304,1592,'./includes/home/pricelist/pl_performance_statistics_common.php'),(20816303,939,'./includes/home/pricelist/pl_performance_statistics_common.php'),(20816302,4350,'./includes/home/pricelist/pl_performance_statistics_common.php'),(20816301,226,'./includes/home/pricelist/pl_performance_statistics_common.php'),(20816320,4068,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816319,3090,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816318,4872,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816317,2165,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816316,4067,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816315,4066,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816314,4052,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816313,2034,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816312,932,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816311,869,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816310,4065,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816309,697,'./includes/home/pricelist/pl_print_orders_due_dates.php'),(20816330,3269,'./includes/home/pricelist/pl_print_orders_pending.php'),(20816329,3090,'./includes/home/pricelist/pl_print_orders_pending.php'),(20816328,4872,'./includes/home/pricelist/pl_print_orders_pending.php'),(20816327,2165,'./includes/home/pricelist/pl_print_orders_pending.php'),(20816326,4873,'./includes/home/pricelist/pl_print_orders_pending.php'),(20816325,2155,'./includes/home/pricelist/pl_print_orders_pending.php'),(20816324,2034,'./includes/home/pricelist/pl_print_orders_pending.php'),(20797133,19676,'./customcommissions.php'),(20797132,1678,'./customcommissions.php'),(20797131,1674,'./customcommissions.php'),(20816342,4692,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816341,4885,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816340,4884,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816339,3090,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816338,2907,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816337,2165,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816336,2034,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816335,4414,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816353,4641,'./includes/home/pricelist/pl_recent_quotes.php'),(20816352,4072,'./includes/home/pricelist/pl_recent_quotes.php'),(20816351,4878,'./includes/home/pricelist/pl_recent_quotes.php'),(20816350,4071,'./includes/home/pricelist/pl_recent_quotes.php'),(20816349,4877,'./includes/home/pricelist/pl_recent_quotes.php'),(20816348,2540,'./includes/home/pricelist/pl_recent_quotes.php'),(20816347,2508,'./includes/home/pricelist/pl_recent_quotes.php'),(20816346,4876,'./includes/home/pricelist/pl_recent_quotes.php'),(20816345,4069,'./includes/home/pricelist/pl_recent_quotes.php'),(20816344,869,'./includes/home/pricelist/pl_recent_quotes.php'),(20816343,697,'./includes/home/pricelist/pl_recent_quotes.php'),(20816363,4072,'./includes/home/pricelist/pl_recent_quotes_pending.php'),(20816362,4887,'./includes/home/pricelist/pl_recent_quotes_pending.php'),(20816361,4877,'./includes/home/pricelist/pl_recent_quotes_pending.php'),(20816360,2540,'./includes/home/pricelist/pl_recent_quotes_pending.php'),(20816359,2508,'./includes/home/pricelist/pl_recent_quotes_pending.php'),(20816358,4886,'./includes/home/pricelist/pl_recent_quotes_pending.php'),(20816357,4069,'./includes/home/pricelist/pl_recent_quotes_pending.php'),(20816356,869,'./includes/home/pricelist/pl_recent_quotes_pending.php'),(20816355,697,'./includes/home/pricelist/pl_recent_quotes_pending.php'),(20816354,226,'./includes/home/pricelist/pl_recent_quotes_pending.php'),(20816371,4911,'./includes/home/pricelist/pl_recently_shipped_orders.php'),(20816370,3090,'./includes/home/pricelist/pl_recently_shipped_orders.php'),(20816369,2816,'./includes/home/pricelist/pl_recently_shipped_orders.php'),(20816368,5225,'./includes/home/pricelist/pl_recently_shipped_orders.php'),(20816367,2508,'./includes/home/pricelist/pl_recently_shipped_orders.php'),(20816366,4879,'./includes/home/pricelist/pl_recently_shipped_orders.php'),(20797130,1671,'./customcommissions.php'),(20816380,4076,'./includes/home/pricelist/pl_upcoming_stock_needs.php'),(20816379,4064,'./includes/home/pricelist/pl_upcoming_stock_needs.php'),(20816378,3090,'./includes/home/pricelist/pl_upcoming_stock_needs.php'),(20816377,4875,'./includes/home/pricelist/pl_upcoming_stock_needs.php'),(20816376,4075,'./includes/home/pricelist/pl_upcoming_stock_needs.php'),(20816375,4074,'./includes/home/pricelist/pl_upcoming_stock_needs.php'),(20816392,4068,'./includes/home/pricelist/print_orders_due_dates.php'),(20797129,1467,'./customcommissions.php'),(20797128,1422,'./customcommissions.php'),(20816391,3090,'./includes/home/pricelist/print_orders_due_dates.php'),(20816390,4872,'./includes/home/pricelist/print_orders_due_dates.php'),(20816389,2165,'./includes/home/pricelist/print_orders_due_dates.php'),(20816388,4067,'./includes/home/pricelist/print_orders_due_dates.php'),(20816387,4066,'./includes/home/pricelist/print_orders_due_dates.php'),(20816386,4052,'./includes/home/pricelist/print_orders_due_dates.php'),(20816385,2034,'./includes/home/pricelist/print_orders_due_dates.php'),(20816400,4911,'./includes/home/pricelist/profitability_customers_month.php'),(20816399,4200,'./includes/home/pricelist/profitability_customers_month.php'),(20816398,4194,'./includes/home/pricelist/profitability_customers_month.php'),(20816397,4193,'./includes/home/pricelist/profitability_customers_month.php'),(20816396,4081,'./includes/home/pricelist/profitability_customers_month.php'),(20816395,1713,'./includes/home/pricelist/profitability_customers_month.php'),(20816394,697,'./includes/home/pricelist/profitability_customers_month.php'),(20816393,4192,'./includes/home/pricelist/profitability_customers_month.php'),(20816408,4911,'./includes/home/pricelist/profitability_customers_year.php'),(20816407,4201,'./includes/home/pricelist/profitability_customers_year.php'),(20816406,4194,'./includes/home/pricelist/profitability_customers_year.php'),(20816405,4193,'./includes/home/pricelist/profitability_customers_year.php'),(20816404,4081,'./includes/home/pricelist/profitability_customers_year.php'),(20816403,1713,'./includes/home/pricelist/profitability_customers_year.php'),(20816402,697,'./includes/home/pricelist/profitability_customers_year.php'),(20816401,4192,'./includes/home/pricelist/profitability_customers_year.php'),(20816416,4911,'./includes/home/pricelist/profitability_orders_month.php'),(20816415,4914,'./includes/home/pricelist/profitability_orders_month.php'),(20816414,4194,'./includes/home/pricelist/profitability_orders_month.php'),(20816413,4193,'./includes/home/pricelist/profitability_orders_month.php'),(20816412,2182,'./includes/home/pricelist/profitability_orders_month.php'),(20816411,4081,'./includes/home/pricelist/profitability_orders_month.php'),(20816421,7511,'./includes/home/pricelist/recent_customers.php'),(20816420,1991,'./includes/home/pricelist/recent_customers.php'),(20816419,7510,'./includes/home/pricelist/recent_customers.php'),(20816418,697,'./includes/home/pricelist/recent_customers.php'),(20816417,7508,'./includes/home/pricelist/recent_customers.php'),(20816432,4641,'./includes/home/pricelist/recent_quotes.php'),(20816431,4072,'./includes/home/pricelist/recent_quotes.php'),(20816430,4878,'./includes/home/pricelist/recent_quotes.php'),(20816429,4071,'./includes/home/pricelist/recent_quotes.php'),(20816428,4877,'./includes/home/pricelist/recent_quotes.php'),(20816427,2540,'./includes/home/pricelist/recent_quotes.php'),(20816426,2508,'./includes/home/pricelist/recent_quotes.php'),(20816425,4876,'./includes/home/pricelist/recent_quotes.php'),(20816424,4069,'./includes/home/pricelist/recent_quotes.php'),(20816423,869,'./includes/home/pricelist/recent_quotes.php'),(20816422,697,'./includes/home/pricelist/recent_quotes.php'),(20816443,4641,'./includes/home/pricelist/recent_quotes_pending.php'),(20816442,4072,'./includes/home/pricelist/recent_quotes_pending.php'),(20816441,4887,'./includes/home/pricelist/recent_quotes_pending.php'),(20816440,4877,'./includes/home/pricelist/recent_quotes_pending.php'),(20816439,2540,'./includes/home/pricelist/recent_quotes_pending.php'),(20816438,2508,'./includes/home/pricelist/recent_quotes_pending.php'),(20816437,4886,'./includes/home/pricelist/recent_quotes_pending.php'),(20816436,4069,'./includes/home/pricelist/recent_quotes_pending.php'),(20816435,869,'./includes/home/pricelist/recent_quotes_pending.php'),(20816434,697,'./includes/home/pricelist/recent_quotes_pending.php'),(20816433,226,'./includes/home/pricelist/recent_quotes_pending.php'),(20816450,4183,'./includes/home/pricelist/topdollar_customers_month.php'),(20816449,3090,'./includes/home/pricelist/topdollar_customers_month.php'),(20816448,4912,'./includes/home/pricelist/topdollar_customers_month.php'),(20816447,4166,'./includes/home/pricelist/topdollar_customers_month.php'),(20816446,2008,'./includes/home/pricelist/topdollar_customers_month.php'),(20816445,697,'./includes/home/pricelist/topdollar_customers_month.php'),(20816444,4037,'./includes/home/pricelist/topdollar_customers_month.php'),(20816456,6464,'./includes/home/pricelist/topdollar_customers_year.php'),(20816455,3090,'./includes/home/pricelist/topdollar_customers_year.php'),(20816454,4913,'./includes/home/pricelist/topdollar_customers_year.php'),(20816453,4166,'./includes/home/pricelist/topdollar_customers_year.php'),(20816452,2008,'./includes/home/pricelist/topdollar_customers_year.php'),(20816451,697,'./includes/home/pricelist/topdollar_customers_year.php'),(20797127,12965,'./customcommissions.php'),(20797126,19675,'./customcommissions.php'),(20816462,6464,'./includes/home/pricelist/topdollar_customers_year_wide.php'),(20816461,3090,'./includes/home/pricelist/topdollar_customers_year_wide.php'),(20816460,7520,'./includes/home/pricelist/topdollar_customers_year_wide.php'),(20816459,4166,'./includes/home/pricelist/topdollar_customers_year_wide.php'),(20816458,1991,'./includes/home/pricelist/topdollar_customers_year_wide.php'),(20816457,697,'./includes/home/pricelist/topdollar_customers_year_wide.php'),(20816472,4914,'./includes/home/pricelist/twothirds_menu.php'),(20797125,8936,'./customcommissions.php'),(20797124,1047,'./customcommissions.php'),(20816471,4201,'./includes/home/pricelist/twothirds_menu.php'),(20816468,4874,'./includes/home/pricelist/twothirds_menu.php'),(20816469,4073,'./includes/home/pricelist/twothirds_menu.php'),(20816470,4200,'./includes/home/pricelist/twothirds_menu.php'),(20797123,7765,'./customcommissions.php'),(20797122,941,'./customcommissions.php'),(20816477,4870,'./includes/home/pricelist/welcome.php'),(20816476,4869,'./includes/home/pricelist/welcome.php'),(20816475,4152,'./includes/home/pricelist/welcome.php'),(20797121,19674,'./customcommissions.php'),(20797120,19673,'./customcommissions.php'),(20778988,3343,'./!/application/controllers/ardailyclose.php'),(20816488,7525,'./includes/home/pricelist/whole_menu.php'),(20816487,4888,'./includes/home/pricelist/whole_menu.php'),(20816486,5264,'./includes/home/pricelist/whole_menu.php'),(20816485,5263,'./includes/home/pricelist/whole_menu.php'),(20816484,5262,'./includes/home/pricelist/whole_menu.php'),(20816483,5261,'./includes/home/pricelist/whole_menu.php'),(20816506,4919,'./includes/home/printing/defines.php'),(20816505,4064,'./includes/home/printing/defines.php'),(20816504,4692,'./includes/home/printing/defines.php'),(20816503,4912,'./includes/home/printing/defines.php'),(20816502,4914,'./includes/home/printing/defines.php'),(20816501,4201,'./includes/home/printing/defines.php'),(20816500,4200,'./includes/home/printing/defines.php'),(20816499,4913,'./includes/home/printing/defines.php'),(20816512,4920,'./includes/home/printing/est_shop_loading.php'),(20816511,3838,'./includes/home/printing/est_shop_loading.php'),(20816510,2200,'./includes/home/printing/est_shop_loading.php'),(20816520,4918,'./includes/home/printing/half_menu.php'),(20816519,4064,'./includes/home/printing/half_menu.php'),(20816518,4884,'./includes/home/printing/half_menu.php'),(20816517,4185,'./includes/home/printing/half_menu.php'),(20816516,4184,'./includes/home/printing/half_menu.php'),(20816515,14737,'./includes/home/printing/half_menu.php'),(20816514,4890,'./includes/home/printing/half_menu.php'),(20816513,7222,'./includes/home/printing/half_menu.php'),(20816531,4905,'./includes/home/printing/order_volume_month.php'),(20816530,3090,'./includes/home/printing/order_volume_month.php'),(20816529,2827,'./includes/home/printing/order_volume_month.php'),(20816528,2589,'./includes/home/printing/order_volume_month.php'),(20816527,2529,'./includes/home/printing/order_volume_month.php'),(20816526,4897,'./includes/home/printing/order_volume_month.php'),(20816525,4904,'./includes/home/printing/order_volume_month.php'),(20816524,4392,'./includes/home/printing/order_volume_month.php'),(20816523,4391,'./includes/home/printing/order_volume_month.php'),(20816522,4903,'./includes/home/printing/order_volume_month.php'),(20816521,4169,'./includes/home/printing/order_volume_month.php'),(20816542,3090,'./includes/home/printing/order_volume_week.php'),(20816541,2827,'./includes/home/printing/order_volume_week.php'),(20816540,2589,'./includes/home/printing/order_volume_week.php'),(20816539,2529,'./includes/home/printing/order_volume_week.php'),(20816538,4897,'./includes/home/printing/order_volume_week.php'),(20816537,4896,'./includes/home/printing/order_volume_week.php'),(20816536,4392,'./includes/home/printing/order_volume_week.php'),(20816535,4391,'./includes/home/printing/order_volume_week.php'),(20816534,4895,'./includes/home/printing/order_volume_week.php'),(20816533,4169,'./includes/home/printing/order_volume_week.php'),(20816532,749,'./includes/home/printing/order_volume_week.php'),(20797119,19672,'./customcommissions.php'),(20816553,3090,'./includes/home/printing/order_volume_year.php'),(20816552,2827,'./includes/home/printing/order_volume_year.php'),(20816551,2589,'./includes/home/printing/order_volume_year.php'),(20816550,2529,'./includes/home/printing/order_volume_year.php'),(20816549,4897,'./includes/home/printing/order_volume_year.php'),(20816548,4907,'./includes/home/printing/order_volume_year.php'),(20816547,4392,'./includes/home/printing/order_volume_year.php'),(20816546,4391,'./includes/home/printing/order_volume_year.php'),(20816545,4906,'./includes/home/printing/order_volume_year.php'),(20816544,1913,'./includes/home/printing/order_volume_year.php'),(20816543,4169,'./includes/home/printing/order_volume_year.php'),(20816565,4068,'./includes/home/printing/print_orders_due_dates.php'),(20816564,3090,'./includes/home/printing/print_orders_due_dates.php'),(20816563,4872,'./includes/home/printing/print_orders_due_dates.php'),(20816562,2165,'./includes/home/printing/print_orders_due_dates.php'),(20816561,4067,'./includes/home/printing/print_orders_due_dates.php'),(20816560,4066,'./includes/home/printing/print_orders_due_dates.php'),(20816559,4052,'./includes/home/printing/print_orders_due_dates.php'),(20816558,2034,'./includes/home/printing/print_orders_due_dates.php'),(20816557,932,'./includes/home/printing/print_orders_due_dates.php'),(20816556,869,'./includes/home/printing/print_orders_due_dates.php'),(20816555,4065,'./includes/home/printing/print_orders_due_dates.php'),(20816554,697,'./includes/home/printing/print_orders_due_dates.php'),(20816575,3269,'./includes/home/printing/print_orders_pending.php'),(20816574,3090,'./includes/home/printing/print_orders_pending.php'),(20816573,4872,'./includes/home/printing/print_orders_pending.php'),(20816572,2165,'./includes/home/printing/print_orders_pending.php'),(20816571,4873,'./includes/home/printing/print_orders_pending.php'),(20816587,4692,'./includes/home/printing/print_orders_unconfirmed.php'),(20797118,19671,'./customcommissions.php'),(20797117,4562,'./customcommissions.php'),(20816586,4885,'./includes/home/printing/print_orders_unconfirmed.php'),(20816585,4884,'./includes/home/printing/print_orders_unconfirmed.php'),(20816584,3090,'./includes/home/printing/print_orders_unconfirmed.php'),(20816583,2907,'./includes/home/printing/print_orders_unconfirmed.php'),(20816582,2165,'./includes/home/printing/print_orders_unconfirmed.php'),(20816581,2034,'./includes/home/printing/print_orders_unconfirmed.php'),(20816580,4414,'./includes/home/printing/print_orders_unconfirmed.php'),(20816595,4911,'./includes/home/printing/profitability_customers_month.php'),(20816594,4200,'./includes/home/printing/profitability_customers_month.php'),(20816593,4194,'./includes/home/printing/profitability_customers_month.php'),(20816592,4193,'./includes/home/printing/profitability_customers_month.php'),(20816591,4081,'./includes/home/printing/profitability_customers_month.php'),(20816590,1713,'./includes/home/printing/profitability_customers_month.php'),(20816589,697,'./includes/home/printing/profitability_customers_month.php'),(20816588,4192,'./includes/home/printing/profitability_customers_month.php'),(20816603,4911,'./includes/home/printing/profitability_customers_year.php'),(20816602,4201,'./includes/home/printing/profitability_customers_year.php'),(20816601,4194,'./includes/home/printing/profitability_customers_year.php'),(20816600,4193,'./includes/home/printing/profitability_customers_year.php'),(20816599,4081,'./includes/home/printing/profitability_customers_year.php'),(20816598,1713,'./includes/home/printing/profitability_customers_year.php'),(20779284,13556,'./!/application/controllers/arinvoice.php'),(20696861,4911,'./includes/home/printing/profitability_orders_month.php'),(20696860,4914,'./includes/home/printing/profitability_orders_month.php'),(20696859,4194,'./includes/home/printing/profitability_orders_month.php'),(20696858,4193,'./includes/home/printing/profitability_orders_month.php'),(20696857,2182,'./includes/home/printing/profitability_orders_month.php'),(20696856,4081,'./includes/home/printing/profitability_orders_month.php'),(20696855,697,'./includes/home/printing/profitability_orders_month.php'),(20696854,4192,'./includes/home/printing/profitability_orders_month.php'),(20816621,3090,'./includes/home/printing/proofs_pending.php'),(20816620,4894,'./includes/home/printing/proofs_pending.php'),(20816619,4893,'./includes/home/printing/proofs_pending.php'),(20816618,4890,'./includes/home/printing/proofs_pending.php'),(20816617,2165,'./includes/home/printing/proofs_pending.php'),(20816616,4892,'./includes/home/printing/proofs_pending.php'),(20816615,4891,'./includes/home/printing/proofs_pending.php'),(20816614,4889,'./includes/home/printing/proofs_pending.php'),(20816613,4364,'./includes/home/printing/proofs_pending.php'),(20816612,697,'./includes/home/printing/proofs_pending.php'),(20816634,4641,'./includes/home/printing/recent_quotes.php'),(20816633,4072,'./includes/home/printing/recent_quotes.php'),(20816632,4878,'./includes/home/printing/recent_quotes.php'),(20816631,4071,'./includes/home/printing/recent_quotes.php'),(20816630,4877,'./includes/home/printing/recent_quotes.php'),(20816629,2540,'./includes/home/printing/recent_quotes.php'),(20816628,2508,'./includes/home/printing/recent_quotes.php'),(20816627,4876,'./includes/home/printing/recent_quotes.php'),(20816626,4069,'./includes/home/printing/recent_quotes.php'),(20816625,1795,'./includes/home/printing/recent_quotes.php'),(20816624,869,'./includes/home/printing/recent_quotes.php'),(20816623,697,'./includes/home/printing/recent_quotes.php'),(20816622,226,'./includes/home/printing/recent_quotes.php'),(20816645,4641,'./includes/home/printing/recent_quotes_pending.php'),(20816644,4072,'./includes/home/printing/recent_quotes_pending.php'),(20816643,4887,'./includes/home/printing/recent_quotes_pending.php'),(20816642,4877,'./includes/home/printing/recent_quotes_pending.php'),(20816641,2540,'./includes/home/printing/recent_quotes_pending.php'),(20816640,2508,'./includes/home/printing/recent_quotes_pending.php'),(20816639,4886,'./includes/home/printing/recent_quotes_pending.php'),(20816638,4069,'./includes/home/printing/recent_quotes_pending.php'),(20816637,869,'./includes/home/printing/recent_quotes_pending.php'),(20816636,697,'./includes/home/printing/recent_quotes_pending.php'),(20816635,226,'./includes/home/printing/recent_quotes_pending.php'),(20816653,4049,'./includes/home/printing/recently_shipped_orders.php'),(20797116,869,'./customcommissions.php'),(20816652,3090,'./includes/home/printing/recently_shipped_orders.php'),(20816651,2816,'./includes/home/printing/recently_shipped_orders.php'),(20816650,2508,'./includes/home/printing/recently_shipped_orders.php'),(20816649,4879,'./includes/home/printing/recently_shipped_orders.php'),(20816660,4183,'./includes/home/printing/topdollar_customers_month.php'),(20816659,3090,'./includes/home/printing/topdollar_customers_month.php'),(20816658,4912,'./includes/home/printing/topdollar_customers_month.php'),(20816657,4166,'./includes/home/printing/topdollar_customers_month.php'),(20816656,2008,'./includes/home/printing/topdollar_customers_month.php'),(20816655,697,'./includes/home/printing/topdollar_customers_month.php'),(20816654,4037,'./includes/home/printing/topdollar_customers_month.php'),(20816666,4183,'./includes/home/printing/topdollar_customers_year.php'),(20816665,3090,'./includes/home/printing/topdollar_customers_year.php'),(20816663,4166,'./includes/home/printing/topdollar_customers_year.php'),(20816664,4913,'./includes/home/printing/topdollar_customers_year.php'),(20797115,799,'./customcommissions.php'),(20797114,19670,'./customcommissions.php'),(20816672,4914,'./includes/home/printing/twothirds_menu.php'),(20816671,4201,'./includes/home/printing/twothirds_menu.php'),(20816670,4200,'./includes/home/printing/twothirds_menu.php'),(20816669,4073,'./includes/home/printing/twothirds_menu.php'),(20816668,4874,'./includes/home/printing/twothirds_menu.php'),(20816667,7222,'./includes/home/printing/twothirds_menu.php'),(20816681,4076,'./includes/home/printing/upcoming_stock_needs.php'),(20816680,4064,'./includes/home/printing/upcoming_stock_needs.php'),(20816679,3090,'./includes/home/printing/upcoming_stock_needs.php'),(20816678,4875,'./includes/home/printing/upcoming_stock_needs.php'),(20816677,4075,'./includes/home/printing/upcoming_stock_needs.php'),(20797113,737,'./customcommissions.php'),(20816686,4870,'./includes/home/printing/welcome.php'),(20816685,4869,'./includes/home/printing/welcome.php'),(20816684,4152,'./includes/home/printing/welcome.php'),(20797112,19627,'./customcommissions.php'),(20797111,19669,'./customcommissions.php'),(20797110,573,'./customcommissions.php'),(20797109,19668,'./customcommissions.php'),(20797108,12963,'./customcommissions.php'),(20816693,3838,'./includes/home/printing/whole_menu.php'),(20816692,4888,'./includes/home/printing/whole_menu.php'),(20816691,4886,'./includes/home/printing/whole_menu.php'),(20816690,4908,'./includes/home/printing/whole_menu.php'),(20816689,4898,'./includes/home/printing/whole_menu.php'),(20816688,4902,'./includes/home/printing/whole_menu.php'),(20816687,7222,'./includes/home/printing/whole_menu.php'),(20797107,19689,'./customcommissions.php'),(20816702,3415,'./includes/home/printing/won_lost_quotes.php'),(20816701,4919,'./includes/home/printing/won_lost_quotes.php'),(20816700,4641,'./includes/home/printing/won_lost_quotes.php'),(20816699,3358,'./includes/home/printing/won_lost_quotes.php'),(20816698,4072,'./includes/home/printing/won_lost_quotes.php'),(20816729,4182,'./includes/home/scart/defines.php'),(20816728,14757,'./includes/home/scart/defines.php'),(20816727,14756,'./includes/home/scart/defines.php'),(20816726,14755,'./includes/home/scart/defines.php'),(20816725,14720,'./includes/home/scart/defines.php'),(20816724,14754,'./includes/home/scart/defines.php'),(20816723,14753,'./includes/home/scart/defines.php'),(20816722,14752,'./includes/home/scart/defines.php'),(20816721,14719,'./includes/home/scart/defines.php'),(20816720,14711,'./includes/home/scart/defines.php'),(20816719,4054,'./includes/home/scart/defines.php'),(20816718,4042,'./includes/home/scart/defines.php'),(20816717,4154,'./includes/home/scart/defines.php'),(20816716,4159,'./includes/home/scart/defines.php'),(20816736,14737,'./includes/home/scart/half_menu.php'),(20816735,14736,'./includes/home/scart/half_menu.php'),(20816734,14735,'./includes/home/scart/half_menu.php'),(20816733,14734,'./includes/home/scart/half_menu.php'),(20816732,5045,'./includes/home/scart/half_menu.php'),(20816731,5136,'./includes/home/scart/half_menu.php'),(20816730,7222,'./includes/home/scart/half_menu.php'),(20797106,19666,'./customcommissions.php'),(20816744,4051,'./includes/home/scart/performance_statistics_common.php'),(20816743,2200,'./includes/home/scart/performance_statistics_common.php'),(20816742,2140,'./includes/home/scart/performance_statistics_common.php'),(20816741,2034,'./includes/home/scart/performance_statistics_common.php'),(20816740,1759,'./includes/home/scart/performance_statistics_common.php'),(20816739,1740,'./includes/home/scart/performance_statistics_common.php'),(20816738,939,'./includes/home/scart/performance_statistics_common.php'),(20816737,226,'./includes/home/scart/performance_statistics_common.php'),(20816753,5138,'./includes/home/scart/products_on_sale.php'),(20816752,5137,'./includes/home/scart/products_on_sale.php'),(20816751,5136,'./includes/home/scart/products_on_sale.php'),(20816750,2405,'./includes/home/scart/products_on_sale.php'),(20816749,5135,'./includes/home/scart/products_on_sale.php'),(20816748,2008,'./includes/home/scart/products_on_sale.php'),(20816747,1934,'./includes/home/scart/products_on_sale.php'),(20816746,1709,'./includes/home/scart/products_on_sale.php'),(20816745,869,'./includes/home/scart/products_on_sale.php'),(20797105,9179,'./customcommissions.php'),(20816759,5047,'./includes/home/scart/products_viewed.php'),(20816758,5046,'./includes/home/scart/products_viewed.php'),(20816757,5045,'./includes/home/scart/products_viewed.php'),(20816765,5050,'./includes/home/scart/top_states_month.php'),(20816764,5048,'./includes/home/scart/top_states_month.php'),(20816763,2936,'./includes/home/scart/top_states_month.php'),(20816762,2200,'./includes/home/scart/top_states_month.php'),(20816761,2008,'./includes/home/scart/top_states_month.php'),(20816760,226,'./includes/home/scart/top_states_month.php'),(20797104,11036,'./customcommissions.php'),(20797103,19665,'./customcommissions.php'),(20816771,5050,'./includes/home/scart/top_states_year.php'),(20816770,5049,'./includes/home/scart/top_states_year.php'),(20816769,2936,'./includes/home/scart/top_states_year.php'),(20797102,408,'./customcommissions.php'),(20816784,5049,'./includes/home/scart/twothirds_menu.php'),(20816783,5048,'./includes/home/scart/twothirds_menu.php'),(20816782,4198,'./includes/home/scart/twothirds_menu.php'),(20816781,4197,'./includes/home/scart/twothirds_menu.php'),(20816780,4201,'./includes/home/scart/twothirds_menu.php'),(20816779,4200,'./includes/home/scart/twothirds_menu.php'),(20816778,4191,'./includes/home/scart/twothirds_menu.php'),(20797101,315,'./customcommissions.php'),(20816787,4153,'./includes/home/scart/welcome.php'),(20816786,4152,'./includes/home/scart/welcome.php'),(20816797,4060,'./includes/home/scart/whole_menu.php'),(20816796,4059,'./includes/home/scart/whole_menu.php'),(20816795,4058,'./includes/home/scart/whole_menu.php'),(20816794,4057,'./includes/home/scart/whole_menu.php'),(20816793,4181,'./includes/home/scart/whole_menu.php'),(17046851,1974,'includes/home/summary/common.php'),(17046850,13334,'includes/home/summary/common.php'),(17046853,12233,'includes/home/summary/defines.php'),(17046852,14515,'includes/home/summary/defines.php'),(17046858,13334,'includes/home/summary/sum_bank_accounts.php'),(17046857,10983,'includes/home/summary/sum_bank_accounts.php'),(17046856,5898,'includes/home/summary/sum_bank_accounts.php'),(17046855,325,'includes/home/summary/sum_bank_accounts.php'),(17046854,15094,'includes/home/summary/sum_bank_accounts.php'),(17046863,4596,'includes/home/summary/sum_credit_accounts.php'),(17046862,1934,'includes/home/summary/sum_credit_accounts.php'),(17046861,13334,'includes/home/summary/sum_credit_accounts.php'),(17046860,10983,'includes/home/summary/sum_credit_accounts.php'),(17046859,325,'includes/home/summary/sum_credit_accounts.php'),(17046879,2292,'includes/home/summary/sum_income_expenses.php'),(17046878,2267,'includes/home/summary/sum_income_expenses.php'),(17046877,6318,'includes/home/summary/sum_income_expenses.php'),(17046876,8681,'includes/home/summary/sum_income_expenses.php'),(17046875,2208,'includes/home/summary/sum_income_expenses.php'),(17046874,13334,'includes/home/summary/sum_income_expenses.php'),(17046873,4940,'includes/home/summary/sum_income_expenses.php'),(17046872,1668,'includes/home/summary/sum_income_expenses.php'),(17046871,13577,'includes/home/summary/sum_income_expenses.php'),(17046870,13576,'includes/home/summary/sum_income_expenses.php'),(17046869,13584,'includes/home/summary/sum_income_expenses.php'),(17046868,1353,'includes/home/summary/sum_income_expenses.php'),(17046867,14759,'includes/home/summary/sum_income_expenses.php'),(17046866,4956,'includes/home/summary/sum_income_expenses.php'),(17046865,80,'includes/home/summary/sum_income_expenses.php'),(17046864,14758,'includes/home/summary/sum_income_expenses.php'),(17046895,3090,'includes/home/summary/sum_profit_loss.php'),(17046894,12013,'includes/home/summary/sum_profit_loss.php'),(17046893,13588,'includes/home/summary/sum_profit_loss.php'),(17046892,12233,'includes/home/summary/sum_profit_loss.php'),(17046891,2494,'includes/home/summary/sum_profit_loss.php'),(17046890,2320,'includes/home/summary/sum_profit_loss.php'),(17046889,2208,'includes/home/summary/sum_profit_loss.php'),(17046888,13578,'includes/home/summary/sum_profit_loss.php'),(17046887,13334,'includes/home/summary/sum_profit_loss.php'),(17046886,13569,'includes/home/summary/sum_profit_loss.php'),(17046885,13570,'includes/home/summary/sum_profit_loss.php'),(17046884,13586,'includes/home/summary/sum_profit_loss.php'),(17046883,13576,'includes/home/summary/sum_profit_loss.php'),(17046882,1353,'includes/home/summary/sum_profit_loss.php'),(17046881,638,'includes/home/summary/sum_profit_loss.php'),(17046880,13523,'includes/home/summary/sum_profit_loss.php'),(20816802,13482,'./includes/htmltopdf/wrapper.php'),(20816801,13481,'./includes/htmltopdf/wrapper.php'),(20816800,1354,'./includes/htmltopdf/wrapper.php'),(20797100,19664,'./customcommissions.php'),(20816836,13644,'./includes/metro/metro.php'),(20816835,13637,'./includes/metro/metro.php'),(20816834,13642,'./includes/metro/metro.php'),(20816833,13636,'./includes/metro/metro.php'),(20816832,13595,'./includes/metro/metro.php'),(20816831,13635,'./includes/metro/metro.php'),(20816830,13589,'./includes/metro/metro.php'),(20816829,13634,'./includes/metro/metro.php'),(20816828,13633,'./includes/metro/metro.php'),(20816827,13632,'./includes/metro/metro.php'),(20816826,13631,'./includes/metro/metro.php'),(20816825,13630,'./includes/metro/metro.php'),(20816824,13647,'./includes/metro/metro.php'),(20816823,13646,'./includes/metro/metro.php'),(20816822,13645,'./includes/metro/metro.php'),(20816821,13629,'./includes/metro/metro.php'),(20816820,13628,'./includes/metro/metro.php'),(20816819,13594,'./includes/metro/metro.php'),(20816818,13639,'./includes/metro/metro.php'),(20816817,13627,'./includes/metro/metro.php'),(20816816,13626,'./includes/metro/metro.php'),(20816815,8227,'./includes/metro/metro.php'),(20816814,1047,'./includes/metro/metro.php'),(20816813,13625,'./includes/metro/metro.php'),(20816812,13638,'./includes/metro/metro.php'),(20816811,13624,'./includes/metro/metro.php'),(20816810,13623,'./includes/metro/metro.php'),(20816809,13622,'./includes/metro/metro.php'),(20816808,13621,'./includes/metro/metro.php'),(20816807,13731,'./includes/metro/metro.php'),(20816806,13620,'./includes/metro/metro.php'),(20816805,11841,'./includes/metro/metro.php'),(20816804,13619,'./includes/metro/metro.php'),(20816803,13618,'./includes/metro/metro.php'),(20816838,13334,'./includes/metro/metro_header.php'),(20797099,19663,'./customcommissions.php'),(20797098,19662,'./customcommissions.php'),(20797097,19661,'./customcommissions.php'),(20816845,3274,'./includes/metro/metro_search.php'),(20816844,2165,'./includes/metro/metro_search.php'),(20816843,1668,'./includes/metro/metro_search.php'),(20816842,1639,'./includes/metro/metro_search.php'),(20816850,5130,'./pm/asdocshell.php'),(20816849,10607,'./pm/asdocshell.php'),(20816848,8936,'./pm/asdocshell.php'),(20816847,11651,'./pm/asdocshell.php'),(20816846,11650,'./pm/asdocshell.php'),(20797096,5811,'./customcommissions.php'),(20797095,5570,'./customcommissions.php'),(20816855,5130,'./pm/aslanding.php'),(20816854,8936,'./pm/aslanding.php'),(20816853,11654,'./pm/aslanding.php'),(20816852,11653,'./pm/aslanding.php'),(20816851,11652,'./pm/aslanding.php'),(20816898,14420,'./pm/bankaccounts.php'),(20816897,14419,'./pm/bankaccounts.php'),(20816896,14418,'./pm/bankaccounts.php'),(20816895,14417,'./pm/bankaccounts.php'),(20816894,3421,'./pm/bankaccounts.php'),(20816893,3414,'./pm/bankaccounts.php'),(20816892,3156,'./pm/bankaccounts.php'),(20816891,14416,'./pm/bankaccounts.php'),(20816890,11573,'./pm/bankaccounts.php'),(20816889,2702,'./pm/bankaccounts.php'),(20816888,5415,'./pm/bankaccounts.php'),(20816887,11572,'./pm/bankaccounts.php'),(20816886,11571,'./pm/bankaccounts.php'),(20816885,14415,'./pm/bankaccounts.php'),(20816884,14414,'./pm/bankaccounts.php'),(20816883,1973,'./pm/bankaccounts.php'),(20816882,14413,'./pm/bankaccounts.php'),(20816881,1935,'./pm/bankaccounts.php'),(20816880,1933,'./pm/bankaccounts.php'),(20816879,14487,'./pm/bankaccounts.php'),(20816878,8936,'./pm/bankaccounts.php'),(20816877,941,'./pm/bankaccounts.php'),(20781799,17923,'./!/application/controllers/itemlocation.php'),(20816909,3414,'./pm/camdetail.php'),(20816908,3090,'./pm/camdetail.php'),(20816907,9750,'./pm/camdetail.php'),(20816906,11056,'./pm/camdetail.php'),(20816905,11055,'./pm/camdetail.php'),(20816904,1933,'./pm/camdetail.php'),(20816903,4169,'./pm/camdetail.php'),(20816902,8936,'./pm/camdetail.php'),(20816901,11054,'./pm/camdetail.php'),(20816900,11053,'./pm/camdetail.php'),(20816899,226,'./pm/camdetail.php'),(20797094,207,'./customcommissions.php'),(20797093,197,'./customcommissions.php'),(20797092,19660,'./customcommissions.php'),(20797091,59,'./customcommissions.php'),(20797090,47,'./customcommissions.php'),(20781722,13932,'./!/application/controllers/item.php'),(20781723,2948,'./!/application/controllers/item.php'),(20781724,2950,'./!/application/controllers/item.php'),(20781725,16676,'./!/application/controllers/item.php'),(20781720,18917,'./!/application/controllers/item.php'),(20816971,11405,'./pm/creditcards.php'),(20816970,3421,'./pm/creditcards.php'),(20816969,3156,'./pm/creditcards.php'),(20816968,9750,'./pm/creditcards.php'),(20816967,2798,'./pm/creditcards.php'),(20816966,11573,'./pm/creditcards.php'),(20816965,11155,'./pm/creditcards.php'),(20816964,2702,'./pm/creditcards.php'),(20816963,11572,'./pm/creditcards.php'),(20816962,11330,'./pm/creditcards.php'),(20816961,11154,'./pm/creditcards.php'),(20816960,11329,'./pm/creditcards.php'),(20816959,11152,'./pm/creditcards.php'),(20816958,11328,'./pm/creditcards.php'),(20816957,11151,'./pm/creditcards.php'),(20816956,11150,'./pm/creditcards.php'),(20816955,11327,'./pm/creditcards.php'),(20816954,11571,'./pm/creditcards.php'),(20816953,2165,'./pm/creditcards.php'),(20816952,2129,'./pm/creditcards.php'),(20816951,2109,'./pm/creditcards.php'),(20816950,11149,'./pm/creditcards.php'),(20816949,2106,'./pm/creditcards.php'),(20816948,1973,'./pm/creditcards.php'),(20816947,11148,'./pm/creditcards.php'),(20816946,1935,'./pm/creditcards.php'),(20816945,1871,'./pm/creditcards.php'),(20816944,1821,'./pm/creditcards.php'),(20816943,1749,'./pm/creditcards.php'),(20816942,1747,'./pm/creditcards.php'),(20816941,1741,'./pm/creditcards.php'),(20817021,11083,'./pm/invoiceextracharges.php'),(20817020,11574,'./pm/invoiceextracharges.php'),(20817019,10057,'./pm/invoiceextracharges.php'),(20817018,10440,'./pm/invoiceextracharges.php'),(20817017,8914,'./pm/invoiceextracharges.php'),(20817016,11081,'./pm/invoiceextracharges.php'),(20817015,11080,'./pm/invoiceextracharges.php'),(20817014,11079,'./pm/invoiceextracharges.php'),(20817013,3165,'./pm/invoiceextracharges.php'),(20817012,3111,'./pm/invoiceextracharges.php'),(20817011,3090,'./pm/invoiceextracharges.php'),(20817010,9750,'./pm/invoiceextracharges.php'),(20817009,11056,'./pm/invoiceextracharges.php'),(20817008,11078,'./pm/invoiceextracharges.php'),(20817007,2529,'./pm/invoiceextracharges.php'),(20817006,11479,'./pm/invoiceextracharges.php'),(20817005,6988,'./pm/invoiceextracharges.php'),(20817004,2404,'./pm/invoiceextracharges.php'),(20817003,11077,'./pm/invoiceextracharges.php'),(20817002,11076,'./pm/invoiceextracharges.php'),(20817001,9548,'./pm/invoiceextracharges.php'),(20817000,11075,'./pm/invoiceextracharges.php'),(20816999,11074,'./pm/invoiceextracharges.php'),(20816998,11073,'./pm/invoiceextracharges.php'),(20816997,1519,'./pm/invoiceextracharges.php'),(20817044,3111,'./pm/invoiceextrachargespost.php'),(20817043,9750,'./pm/invoiceextrachargespost.php'),(20817042,2529,'./pm/invoiceextrachargespost.php'),(20817041,2404,'./pm/invoiceextrachargespost.php'),(20817040,11090,'./pm/invoiceextrachargespost.php'),(20817039,2292,'./pm/invoiceextrachargespost.php'),(20817038,11088,'./pm/invoiceextrachargespost.php'),(20817037,1668,'./pm/invoiceextrachargespost.php'),(20817036,11087,'./pm/invoiceextrachargespost.php'),(20817035,1499,'./pm/invoiceextrachargespost.php'),(20817034,11086,'./pm/invoiceextrachargespost.php'),(20817033,11085,'./pm/invoiceextrachargespost.php'),(20779283,18046,'./!/application/controllers/arinvoice.php'),(20817086,11102,'./pm/invoicenotifications.php'),(20817085,11101,'./pm/invoicenotifications.php'),(20817084,3421,'./pm/invoicenotifications.php'),(20817083,3414,'./pm/invoicenotifications.php'),(20817082,3118,'./pm/invoicenotifications.php'),(20817081,3072,'./pm/invoicenotifications.php'),(20817080,9750,'./pm/invoicenotifications.php'),(20817079,2860,'./pm/invoicenotifications.php'),(20817078,11100,'./pm/invoicenotifications.php'),(20817077,11099,'./pm/invoicenotifications.php'),(20817076,11761,'./pm/invoicenotifications.php'),(20817075,14403,'./pm/invoicenotifications.php'),(20817074,11097,'./pm/invoicenotifications.php'),(20817073,2225,'./pm/invoicenotifications.php'),(20817072,11096,'./pm/invoicenotifications.php'),(20817071,1933,'./pm/invoicenotifications.php'),(20817070,14429,'./pm/invoicenotifications.php'),(20817069,14428,'./pm/invoicenotifications.php'),(20817068,14427,'./pm/invoicenotifications.php'),(20817067,11493,'./pm/invoicenotifications.php'),(20817066,10923,'./pm/invoicenotifications.php'),(20779280,18501,'./!/application/controllers/arinvoice.php'),(20779281,3333,'./!/application/controllers/arinvoice.php'),(20817124,11309,'./pm/leaseapplications.php'),(20817123,11308,'./pm/leaseapplications.php'),(20817122,11307,'./pm/leaseapplications.php'),(20817121,11306,'./pm/leaseapplications.php'),(20817120,11305,'./pm/leaseapplications.php'),(20817119,11304,'./pm/leaseapplications.php'),(20817118,11303,'./pm/leaseapplications.php'),(20817117,11302,'./pm/leaseapplications.php'),(20817116,11301,'./pm/leaseapplications.php'),(20817115,11300,'./pm/leaseapplications.php'),(20817114,11223,'./pm/leaseapplications.php'),(20817113,9750,'./pm/leaseapplications.php'),(20817112,9724,'./pm/leaseapplications.php'),(20817111,8913,'./pm/leaseapplications.php'),(20817110,9855,'./pm/leaseapplications.php'),(20817109,8912,'./pm/leaseapplications.php'),(20817108,11299,'./pm/leaseapplications.php'),(20817107,4023,'./pm/leaseapplications.php'),(20817106,11575,'./pm/leaseapplications.php'),(20817105,9723,'./pm/leaseapplications.php'),(20817104,14922,'./pm/leaseapplications.php'),(20817103,6713,'./pm/leaseapplications.php'),(20817102,8936,'./pm/leaseapplications.php'),(20817101,8136,'./pm/leaseapplications.php'),(20817100,7120,'./pm/leaseapplications.php'),(20817099,11294,'./pm/leaseapplications.php'),(20817098,11293,'./pm/leaseapplications.php'),(20817097,11292,'./pm/leaseapplications.php'),(20817096,7116,'./pm/leaseapplications.php'),(20817095,9380,'./pm/leaseapplications.php'),(20817094,9379,'./pm/leaseapplications.php'),(20817093,9378,'./pm/leaseapplications.php'),(20817092,9377,'./pm/leaseapplications.php'),(20817091,5144,'./pm/leaseapplications.php'),(20817090,5145,'./pm/leaseapplications.php'),(20817089,9770,'./pm/leaseapplications.php'),(20817088,11484,'./pm/leaseapplications.php'),(20817087,14430,'./pm/leaseapplications.php'),(20781721,3434,'./!/application/controllers/item.php'),(20781719,19356,'./!/application/controllers/item.php'),(20817136,9643,'./pm/login.php'),(20817135,9641,'./pm/login.php'),(20817134,11365,'./pm/login.php'),(20817133,9661,'./pm/login.php'),(20817132,9640,'./pm/login.php'),(20817131,9639,'./pm/login.php'),(20817130,2234,'./pm/login.php'),(20817129,11576,'./pm/login.php'),(20817128,7973,'./pm/login.php'),(20817127,8936,'./pm/login.php'),(20817126,981,'./pm/login.php'),(20817125,9659,'./pm/login.php'),(20817211,14420,'./pm/makepayment.php'),(20817210,8916,'./pm/makepayment.php'),(20817209,11310,'./pm/makepayment.php'),(20817208,11309,'./pm/makepayment.php'),(20817207,11308,'./pm/makepayment.php'),(20817206,11307,'./pm/makepayment.php'),(20817205,8915,'./pm/makepayment.php'),(20817204,11306,'./pm/makepayment.php'),(20817203,11305,'./pm/makepayment.php'),(20817202,11304,'./pm/makepayment.php'),(20817201,11303,'./pm/makepayment.php'),(20817200,11302,'./pm/makepayment.php'),(20817199,14419,'./pm/makepayment.php'),(20817198,11301,'./pm/makepayment.php'),(20817197,11300,'./pm/makepayment.php'),(20817196,8914,'./pm/makepayment.php'),(20817195,14418,'./pm/makepayment.php'),(20817194,3090,'./pm/makepayment.php'),(20817193,14434,'./pm/makepayment.php'),(20817192,11223,'./pm/makepayment.php'),(20817191,14416,'./pm/makepayment.php'),(20817190,9750,'./pm/makepayment.php'),(20817189,11578,'./pm/makepayment.php'),(20817188,14433,'./pm/makepayment.php'),(20817187,11577,'./pm/makepayment.php'),(20817186,14432,'./pm/makepayment.php'),(20817185,5415,'./pm/makepayment.php'),(20817184,2606,'./pm/makepayment.php'),(20817183,11420,'./pm/makepayment.php'),(20817182,3777,'./pm/makepayment.php'),(20817181,8912,'./pm/makepayment.php'),(20817180,11299,'./pm/makepayment.php'),(20817179,6318,'./pm/makepayment.php'),(20817178,2238,'./pm/makepayment.php'),(20817177,4023,'./pm/makepayment.php'),(20817176,8681,'./pm/makepayment.php'),(20817175,11298,'./pm/makepayment.php'),(20817174,11297,'./pm/makepayment.php'),(20817241,3070,'./pm/manageappointments.php'),(20817240,11580,'./pm/manageappointments.php'),(20817239,2738,'./pm/manageappointments.php'),(20817238,2702,'./pm/manageappointments.php'),(20817237,9855,'./pm/manageappointments.php'),(20817236,9854,'./pm/manageappointments.php'),(20817235,9853,'./pm/manageappointments.php'),(20817234,9852,'./pm/manageappointments.php'),(20817233,9851,'./pm/manageappointments.php'),(20817232,2103,'./pm/manageappointments.php'),(20817231,9753,'./pm/manageappointments.php'),(20817230,1354,'./pm/manageappointments.php'),(20817229,6478,'./pm/manageappointments.php'),(20817228,1014,'./pm/manageappointments.php'),(20817227,799,'./pm/manageappointments.php'),(20817226,11579,'./pm/manageappointments.php'),(20817225,9850,'./pm/manageappointments.php'),(20817224,416,'./pm/manageappointments.php'),(20817223,6477,'./pm/manageappointments.php'),(20817222,333,'./pm/manageappointments.php'),(20817221,315,'./pm/manageappointments.php'),(20817220,5203,'./pm/manageappointments.php'),(20817219,9849,'./pm/manageappointments.php'),(20817218,9847,'./pm/manageappointments.php'),(20817217,9846,'./pm/manageappointments.php'),(20817216,9845,'./pm/manageappointments.php'),(20817215,9844,'./pm/manageappointments.php'),(20817214,9843,'./pm/manageappointments.php'),(20817213,9842,'./pm/manageappointments.php'),(20817212,9841,'./pm/manageappointments.php'),(20817282,14420,'./pm/managebankaccounts.php'),(20817281,14419,'./pm/managebankaccounts.php'),(20817280,14418,'./pm/managebankaccounts.php'),(20817279,3421,'./pm/managebankaccounts.php'),(20817278,3414,'./pm/managebankaccounts.php'),(20817277,3156,'./pm/managebankaccounts.php'),(20817276,14416,'./pm/managebankaccounts.php'),(20817275,9750,'./pm/managebankaccounts.php'),(20817274,9787,'./pm/managebankaccounts.php'),(20817273,2738,'./pm/managebankaccounts.php'),(20817272,2702,'./pm/managebankaccounts.php'),(20817271,5415,'./pm/managebankaccounts.php'),(20817270,11153,'./pm/managebankaccounts.php'),(20817269,14415,'./pm/managebankaccounts.php'),(20817268,14414,'./pm/managebankaccounts.php'),(20817267,1973,'./pm/managebankaccounts.php'),(20817266,14413,'./pm/managebankaccounts.php'),(20817265,1935,'./pm/managebankaccounts.php'),(20817264,1933,'./pm/managebankaccounts.php'),(20817263,8936,'./pm/managebankaccounts.php'),(20817262,941,'./pm/managebankaccounts.php'),(20817261,799,'./pm/managebankaccounts.php'),(20817260,8010,'./pm/managebankaccounts.php'),(20817259,14412,'./pm/managebankaccounts.php'),(20817258,5439,'./pm/managebankaccounts.php'),(20817257,5452,'./pm/managebankaccounts.php'),(20817256,14411,'./pm/managebankaccounts.php'),(20817255,14410,'./pm/managebankaccounts.php'),(20817254,14409,'./pm/managebankaccounts.php'),(20817253,5432,'./pm/managebankaccounts.php'),(20817252,14408,'./pm/managebankaccounts.php'),(20817251,14407,'./pm/managebankaccounts.php'),(20817250,14406,'./pm/managebankaccounts.php'),(20817249,5402,'./pm/managebankaccounts.php'),(20817248,315,'./pm/managebankaccounts.php'),(20817247,5203,'./pm/managebankaccounts.php'),(20817246,14405,'./pm/managebankaccounts.php'),(20817245,32,'./pm/managebankaccounts.php'),(20817244,14404,'./pm/managebankaccounts.php'),(20817243,30,'./pm/managebankaccounts.php'),(20817242,20,'./pm/managebankaccounts.php'),(20817296,3252,'./pm/managecommunications.php'),(20817295,9750,'./pm/managecommunications.php'),(20817294,11583,'./pm/managecommunications.php'),(20817293,2099,'./pm/managecommunications.php'),(20817292,9753,'./pm/managecommunications.php'),(20817291,4414,'./pm/managecommunications.php'),(20817290,8936,'./pm/managecommunications.php'),(20817330,11326,'./pm/managecourtfilings.php'),(20817329,9750,'./pm/managecourtfilings.php'),(20817328,2948,'./pm/managecourtfilings.php'),(20817327,2738,'./pm/managecourtfilings.php'),(20817326,2702,'./pm/managecourtfilings.php'),(20817325,11233,'./pm/managecourtfilings.php'),(20817324,11232,'./pm/managecourtfilings.php'),(20817323,11153,'./pm/managecourtfilings.php'),(20817322,11325,'./pm/managecourtfilings.php'),(20817321,11324,'./pm/managecourtfilings.php'),(20817320,11323,'./pm/managecourtfilings.php'),(20817319,2292,'./pm/managecourtfilings.php'),(20817318,11322,'./pm/managecourtfilings.php'),(20817317,11321,'./pm/managecourtfilings.php'),(20817316,9753,'./pm/managecourtfilings.php'),(20817315,11320,'./pm/managecourtfilings.php'),(20817314,11231,'./pm/managecourtfilings.php'),(20817313,1678,'./pm/managecourtfilings.php'),(20817312,11229,'./pm/managecourtfilings.php'),(20817311,7250,'./pm/managecourtfilings.php'),(20817310,941,'./pm/managecourtfilings.php'),(20817309,799,'./pm/managecourtfilings.php'),(20817308,11228,'./pm/managecourtfilings.php'),(20817307,11319,'./pm/managecourtfilings.php'),(20817306,11316,'./pm/managecourtfilings.php'),(20817305,11315,'./pm/managecourtfilings.php'),(20817304,11314,'./pm/managecourtfilings.php'),(20817303,11313,'./pm/managecourtfilings.php'),(20817302,11227,'./pm/managecourtfilings.php'),(20817301,416,'./pm/managecourtfilings.php'),(20817300,315,'./pm/managecourtfilings.php'),(20817299,5203,'./pm/managecourtfilings.php'),(20817298,11312,'./pm/managecourtfilings.php'),(20817297,11311,'./pm/managecourtfilings.php'),(20817391,3432,'./pm/managecreditcards.php'),(20817390,3421,'./pm/managecreditcards.php'),(20817389,3156,'./pm/managecreditcards.php'),(20817388,9750,'./pm/managecreditcards.php'),(20817387,2936,'./pm/managecreditcards.php'),(20817386,2798,'./pm/managecreditcards.php'),(20817385,9787,'./pm/managecreditcards.php'),(20817384,2738,'./pm/managecreditcards.php'),(20817383,11155,'./pm/managecreditcards.php'),(20817382,2702,'./pm/managecreditcards.php'),(20817381,11330,'./pm/managecreditcards.php'),(20817380,11154,'./pm/managecreditcards.php'),(20817379,11153,'./pm/managecreditcards.php'),(20817378,11329,'./pm/managecreditcards.php'),(20817377,11152,'./pm/managecreditcards.php'),(20817376,11328,'./pm/managecreditcards.php'),(20817375,11151,'./pm/managecreditcards.php'),(20817374,11150,'./pm/managecreditcards.php'),(20817373,11327,'./pm/managecreditcards.php'),(20817372,2165,'./pm/managecreditcards.php'),(20817371,2129,'./pm/managecreditcards.php'),(20817370,2109,'./pm/managecreditcards.php'),(20817369,11149,'./pm/managecreditcards.php'),(20817368,2106,'./pm/managecreditcards.php'),(20817367,1973,'./pm/managecreditcards.php'),(20817366,11148,'./pm/managecreditcards.php'),(20817365,1935,'./pm/managecreditcards.php'),(20817364,1871,'./pm/managecreditcards.php'),(20817363,1821,'./pm/managecreditcards.php'),(20817362,1749,'./pm/managecreditcards.php'),(20817361,1747,'./pm/managecreditcards.php'),(20817360,1741,'./pm/managecreditcards.php'),(20817359,11147,'./pm/managecreditcards.php'),(20817358,1375,'./pm/managecreditcards.php'),(20817357,11146,'./pm/managecreditcards.php'),(20817356,11145,'./pm/managecreditcards.php'),(20817355,10238,'./pm/managecreditcards.php'),(20817354,941,'./pm/managecreditcards.php'),(20817353,799,'./pm/managecreditcards.php'),(20817352,778,'./pm/managecreditcards.php'),(20817351,11404,'./pm/managecreditcards.php'),(20817350,11144,'./pm/managecreditcards.php'),(20817349,11143,'./pm/managecreditcards.php'),(20817348,11142,'./pm/managecreditcards.php'),(20817347,8136,'./pm/managecreditcards.php'),(20817346,11141,'./pm/managecreditcards.php'),(20817345,11140,'./pm/managecreditcards.php'),(20817344,11139,'./pm/managecreditcards.php'),(20817343,11138,'./pm/managecreditcards.php'),(20817342,11137,'./pm/managecreditcards.php'),(20817341,11136,'./pm/managecreditcards.php'),(20817340,11135,'./pm/managecreditcards.php'),(20817339,524,'./pm/managecreditcards.php'),(20817338,416,'./pm/managecreditcards.php'),(20817337,9377,'./pm/managecreditcards.php'),(20817336,315,'./pm/managecreditcards.php'),(20817335,308,'./pm/managecreditcards.php'),(20817334,5203,'./pm/managecreditcards.php'),(20817333,275,'./pm/managecreditcards.php'),(20817332,11134,'./pm/managecreditcards.php'),(20817331,185,'./pm/managecreditcards.php'),(20781718,14765,'./!/application/controllers/item.php'),(20781717,2816,'./!/application/controllers/item.php'),(20817396,11104,'./pm/manageinvoicing.php'),(20817395,11090,'./pm/manageinvoicing.php'),(20817394,10562,'./pm/manageinvoicing.php'),(20781358,2664,'./!/application/controllers/invcountbatch.php'),(20781357,18193,'./!/application/controllers/invcountbatch.php'),(20781356,19546,'./!/application/controllers/invcountbatch.php'),(20781355,19616,'./!/application/controllers/invcountbatch.php'),(20781354,7192,'./!/application/controllers/invcountbatch.php'),(20781353,2616,'./!/application/controllers/invcountbatch.php'),(20781352,18010,'./!/application/controllers/invcountbatch.php'),(20781351,18462,'./!/application/controllers/invcountbatch.php'),(20781350,10989,'./!/application/controllers/invcountbatch.php'),(20781716,6770,'./!/application/controllers/item.php'),(20781715,2749,'./!/application/controllers/item.php'),(20781714,18916,'./!/application/controllers/item.php'),(20781713,2664,'./!/application/controllers/item.php'),(20781712,19624,'./!/application/controllers/item.php'),(20781711,19623,'./!/application/controllers/item.php'),(20817489,10977,'./pm/manageleaseinvoices.php'),(20817488,10976,'./pm/manageleaseinvoices.php'),(20817487,10974,'./pm/manageleaseinvoices.php'),(20817486,14446,'./pm/manageleaseinvoices.php'),(20817485,3421,'./pm/manageleaseinvoices.php'),(20817484,3319,'./pm/manageleaseinvoices.php'),(20817483,11668,'./pm/manageleaseinvoices.php'),(20817482,3186,'./pm/manageleaseinvoices.php'),(20817481,11588,'./pm/manageleaseinvoices.php'),(20817480,3165,'./pm/manageleaseinvoices.php'),(20817479,10925,'./pm/manageleaseinvoices.php'),(20817478,10973,'./pm/manageleaseinvoices.php'),(20817477,10972,'./pm/manageleaseinvoices.php'),(20817476,9750,'./pm/manageleaseinvoices.php'),(20817475,2948,'./pm/manageleaseinvoices.php'),(20817474,11587,'./pm/manageleaseinvoices.php'),(20817473,11667,'./pm/manageleaseinvoices.php'),(20817472,14445,'./pm/manageleaseinvoices.php'),(20817471,11666,'./pm/manageleaseinvoices.php'),(20817470,11665,'./pm/manageleaseinvoices.php'),(20817469,11586,'./pm/manageleaseinvoices.php'),(20817468,10969,'./pm/manageleaseinvoices.php'),(20817467,10855,'./pm/manageleaseinvoices.php'),(20817466,10967,'./pm/manageleaseinvoices.php'),(20817465,11414,'./pm/manageleaseinvoices.php'),(20817464,10966,'./pm/manageleaseinvoices.php'),(20817463,9749,'./pm/manageleaseinvoices.php'),(20817462,10965,'./pm/manageleaseinvoices.php'),(20817461,11190,'./pm/manageleaseinvoices.php'),(20817460,10964,'./pm/manageleaseinvoices.php'),(20817459,10963,'./pm/manageleaseinvoices.php'),(20817458,11420,'./pm/manageleaseinvoices.php'),(20817457,9871,'./pm/manageleaseinvoices.php'),(20817456,14444,'./pm/manageleaseinvoices.php'),(20817455,4023,'./pm/manageleaseinvoices.php'),(20817454,9548,'./pm/manageleaseinvoices.php'),(20817453,9858,'./pm/manageleaseinvoices.php'),(20817452,10962,'./pm/manageleaseinvoices.php'),(20817451,1973,'./pm/manageleaseinvoices.php'),(20817450,1963,'./pm/manageleaseinvoices.php'),(20817449,9918,'./pm/manageleaseinvoices.php'),(20817448,14286,'./pm/manageleaseinvoices.php'),(20817447,14443,'./pm/manageleaseinvoices.php'),(20817446,14285,'./pm/manageleaseinvoices.php'),(20817445,10960,'./pm/manageleaseinvoices.php'),(20817444,11664,'./pm/manageleaseinvoices.php'),(20817443,11585,'./pm/manageleaseinvoices.php'),(20781349,19490,'./!/application/controllers/invcountbatch.php'),(20781348,19350,'./!/application/controllers/invcountbatch.php'),(20781347,16464,'./!/application/controllers/invcountbatch.php'),(20817500,11589,'./pm/manageleasepayments.php'),(20817499,11420,'./pm/manageleasepayments.php'),(20817498,10962,'./pm/manageleasepayments.php'),(20817497,11009,'./pm/manageleasepayments.php'),(20817496,10979,'./pm/manageleasepayments.php'),(20817495,10978,'./pm/manageleasepayments.php'),(20781346,14823,'./!/application/controllers/invcountbatch.php'),(20781345,19349,'./!/application/controllers/invcountbatch.php'),(20781344,2459,'./!/application/controllers/invcountbatch.php'),(20781343,16487,'./!/application/controllers/invcountbatch.php'),(20781342,19348,'./!/application/controllers/invcountbatch.php'),(20781341,19615,'./!/application/controllers/invcountbatch.php'),(20781340,19545,'./!/application/controllers/invcountbatch.php'),(20817592,3421,'./pm/manageleases.php'),(20817591,11010,'./pm/manageleases.php'),(20817590,11588,'./pm/manageleases.php'),(20817589,3165,'./pm/manageleases.php'),(20817588,10739,'./pm/manageleases.php'),(20817587,10925,'./pm/manageleases.php'),(20817586,9750,'./pm/manageleases.php'),(20817585,11587,'./pm/manageleases.php'),(20817584,11586,'./pm/manageleases.php'),(20817583,11594,'./pm/manageleases.php'),(20817582,9785,'./pm/manageleases.php'),(20817581,2702,'./pm/manageleases.php'),(20817580,9749,'./pm/manageleases.php'),(20817579,11159,'./pm/manageleases.php'),(20817578,11158,'./pm/manageleases.php'),(20817577,11419,'./pm/manageleases.php'),(20817576,9583,'./pm/manageleases.php'),(20817575,11418,'./pm/manageleases.php'),(20817574,9582,'./pm/manageleases.php'),(20817573,11479,'./pm/manageleases.php'),(20817572,9871,'./pm/manageleases.php'),(20817571,14452,'./pm/manageleases.php'),(20817570,14451,'./pm/manageleases.php'),(20817569,11593,'./pm/manageleases.php'),(20817568,9784,'./pm/manageleases.php'),(20817567,9748,'./pm/manageleases.php'),(20817566,9747,'./pm/manageleases.php'),(20817565,11592,'./pm/manageleases.php'),(20817564,14450,'./pm/manageleases.php'),(20817563,9745,'./pm/manageleases.php'),(20817562,9744,'./pm/manageleases.php'),(20817561,10981,'./pm/manageleases.php'),(20817560,11417,'./pm/manageleases.php'),(20817559,9858,'./pm/manageleases.php'),(20817558,9742,'./pm/manageleases.php'),(20817557,9741,'./pm/manageleases.php'),(20817556,2103,'./pm/manageleases.php'),(20817555,1973,'./pm/manageleases.php'),(20817554,11332,'./pm/manageleases.php'),(20817553,9753,'./pm/manageleases.php'),(20817552,10961,'./pm/manageleases.php'),(20817551,11185,'./pm/manageleases.php'),(20817550,9918,'./pm/manageleases.php'),(20817549,14286,'./pm/manageleases.php'),(20817548,14285,'./pm/manageleases.php'),(20817547,9740,'./pm/manageleases.php'),(20817621,14307,'./pm/manageprospects.php'),(20817620,2948,'./pm/manageprospects.php'),(20817619,3434,'./pm/manageprospects.php'),(20817618,2738,'./pm/manageprospects.php'),(20817617,14459,'./pm/manageprospects.php'),(20817616,10555,'./pm/manageprospects.php'),(20817615,9754,'./pm/manageprospects.php'),(20817614,9761,'./pm/manageprospects.php'),(20817613,14346,'./pm/manageprospects.php'),(20817612,2324,'./pm/manageprospects.php'),(20817611,2044,'./pm/manageprospects.php'),(20817610,14458,'./pm/manageprospects.php'),(20817609,14457,'./pm/manageprospects.php'),(20817608,9753,'./pm/manageprospects.php'),(20817607,1935,'./pm/manageprospects.php'),(20817656,10770,'./pm/managescreenings.php'),(20817655,10769,'./pm/managescreenings.php'),(20817654,10768,'./pm/managescreenings.php'),(20817653,10767,'./pm/managescreenings.php'),(20817652,11595,'./pm/managescreenings.php'),(20817651,2948,'./pm/managescreenings.php'),(20817650,7791,'./pm/managescreenings.php'),(20817649,2738,'./pm/managescreenings.php'),(20817648,10765,'./pm/managescreenings.php'),(20817647,10557,'./pm/managescreenings.php'),(20817646,10764,'./pm/managescreenings.php'),(20817645,10763,'./pm/managescreenings.php'),(20817644,2737,'./pm/managescreenings.php'),(20817643,10762,'./pm/managescreenings.php'),(20817642,10761,'./pm/managescreenings.php'),(20817641,10760,'./pm/managescreenings.php'),(20817640,10759,'./pm/managescreenings.php'),(20817639,10758,'./pm/managescreenings.php'),(20817752,3432,'./pm/managetenants.php'),(20817751,5588,'./pm/managetenants.php'),(20817750,3225,'./pm/managetenants.php'),(20817749,3165,'./pm/managetenants.php'),(20817748,10739,'./pm/managetenants.php'),(20817747,3156,'./pm/managetenants.php'),(20817746,3070,'./pm/managetenants.php'),(20817745,10558,'./pm/managetenants.php'),(20817744,9656,'./pm/managetenants.php'),(20817743,2948,'./pm/managetenants.php'),(20817742,2936,'./pm/managetenants.php'),(20817741,11598,'./pm/managetenants.php'),(20817740,9916,'./pm/managetenants.php'),(20817739,11580,'./pm/managetenants.php'),(20817738,2738,'./pm/managetenants.php'),(20817737,2737,'./pm/managetenants.php'),(20817736,2702,'./pm/managetenants.php'),(20817735,14463,'./pm/managetenants.php'),(20817734,14462,'./pm/managetenants.php'),(20817733,14461,'./pm/managetenants.php'),(20817732,2638,'./pm/managetenants.php'),(20817731,14460,'./pm/managetenants.php'),(20817730,11015,'./pm/managetenants.php'),(20817729,4088,'./pm/managetenants.php'),(20817728,11014,'./pm/managetenants.php'),(20817727,10555,'./pm/managetenants.php'),(20817726,11479,'./pm/managetenants.php'),(20817725,9761,'./pm/managetenants.php'),(20817724,9681,'./pm/managetenants.php'),(20817723,9680,'./pm/managetenants.php'),(20817722,9679,'./pm/managetenants.php'),(20817721,9677,'./pm/managetenants.php'),(20817720,9676,'./pm/managetenants.php'),(20817719,9675,'./pm/managetenants.php'),(20817718,9674,'./pm/managetenants.php'),(20817717,9673,'./pm/managetenants.php'),(20817716,2324,'./pm/managetenants.php'),(20817715,11768,'./pm/managetenants.php'),(20817714,11013,'./pm/managetenants.php'),(20817713,6839,'./pm/managetenants.php'),(20817712,10711,'./pm/managetenants.php'),(20817711,10709,'./pm/managetenants.php'),(20817710,8516,'./pm/managetenants.php'),(20817709,9742,'./pm/managetenants.php'),(20817708,9786,'./pm/managetenants.php'),(20817707,11597,'./pm/managetenants.php'),(20817706,1963,'./pm/managetenants.php'),(20817705,9913,'./pm/managetenants.php'),(20817704,9753,'./pm/managetenants.php'),(20817703,1935,'./pm/managetenants.php'),(20817702,10961,'./pm/managetenants.php'),(20817701,8544,'./pm/managetenants.php'),(20817700,1884,'./pm/managetenants.php'),(20817699,9760,'./pm/managetenants.php'),(20817698,9647,'./pm/managetenants.php'),(20817697,9752,'./pm/managetenants.php'),(20817696,9546,'./pm/managetenants.php'),(20817695,9723,'./pm/managetenants.php'),(20817694,1758,'./pm/managetenants.php'),(20817693,1668,'./pm/managetenants.php'),(20817692,1429,'./pm/managetenants.php'),(20817691,8936,'./pm/managetenants.php'),(20817690,1014,'./pm/managetenants.php'),(20817689,11012,'./pm/managetenants.php'),(20817688,982,'./pm/managetenants.php'),(20817687,11596,'./pm/managetenants.php'),(20817686,10753,'./pm/managetenants.php'),(20817685,745,'./pm/managetenants.php'),(20817684,737,'./pm/managetenants.php'),(20817683,9759,'./pm/managetenants.php'),(20817682,9861,'./pm/managetenants.php'),(20817681,9758,'./pm/managetenants.php'),(20817680,11767,'./pm/managetenants.php'),(20817679,9757,'./pm/managetenants.php'),(20817678,11135,'./pm/managetenants.php'),(20817677,673,'./pm/managetenants.php'),(20817676,9668,'./pm/managetenants.php'),(20817675,9860,'./pm/managetenants.php'),(20817674,9667,'./pm/managetenants.php'),(20817673,9666,'./pm/managetenants.php'),(20817672,573,'./pm/managetenants.php'),(20817671,524,'./pm/managetenants.php'),(20817670,416,'./pm/managetenants.php'),(20817669,333,'./pm/managetenants.php'),(20817668,14406,'./pm/managetenants.php'),(20817667,5430,'./pm/managetenants.php'),(20817666,325,'./pm/managetenants.php'),(20817665,11011,'./pm/managetenants.php'),(20817664,315,'./pm/managetenants.php'),(20817663,14319,'./pm/managetenants.php'),(20817662,11331,'./pm/managetenants.php'),(20817661,9756,'./pm/managetenants.php'),(20817660,226,'./pm/managetenants.php'),(20817659,9725,'./pm/managetenants.php'),(20817658,9841,'./pm/managetenants.php'),(20817657,185,'./pm/managetenants.php'),(20817775,3165,'./pm/movein.php'),(20817774,3156,'./pm/movein.php'),(20817773,9750,'./pm/movein.php'),(20817772,10990,'./pm/movein.php'),(20817771,14465,'./pm/movein.php'),(20817770,14115,'./pm/movein.php'),(20817769,9914,'./pm/movein.php'),(20817768,10989,'./pm/movein.php'),(20817767,10988,'./pm/movein.php'),(20817766,2292,'./pm/movein.php'),(20817765,10706,'./pm/movein.php'),(20817764,11601,'./pm/movein.php'),(20817763,11600,'./pm/movein.php'),(20817762,11599,'./pm/movein.php'),(20817761,10983,'./pm/movein.php'),(20817760,11235,'./pm/movein.php'),(20817759,14464,'./pm/movein.php'),(20817758,8936,'./pm/movein.php'),(20817757,10139,'./pm/movein.php'),(20817756,8125,'./pm/movein.php'),(20817755,8911,'./pm/movein.php'),(20817754,9725,'./pm/movein.php'),(20817753,10982,'./pm/movein.php'),(20817794,11016,'./pm/moveout.php'),(20817793,3165,'./pm/moveout.php'),(20817792,9750,'./pm/moveout.php'),(20817791,10990,'./pm/moveout.php'),(20817790,11164,'./pm/moveout.php'),(20817789,10989,'./pm/moveout.php'),(20817788,10988,'./pm/moveout.php'),(20817787,11163,'./pm/moveout.php'),(20817786,2292,'./pm/moveout.php'),(20817785,11605,'./pm/moveout.php'),(20817844,11338,'./pm/moveoutprocess.php'),(20817843,11337,'./pm/moveoutprocess.php'),(20817842,3165,'./pm/moveoutprocess.php'),(20817841,11182,'./pm/moveoutprocess.php'),(20817840,11336,'./pm/moveoutprocess.php'),(20817839,11335,'./pm/moveoutprocess.php'),(20817838,6965,'./pm/moveoutprocess.php'),(20817837,11704,'./pm/moveoutprocess.php'),(20817836,3072,'./pm/moveoutprocess.php'),(20817835,11703,'./pm/moveoutprocess.php'),(20817834,11702,'./pm/moveoutprocess.php'),(20817833,11334,'./pm/moveoutprocess.php'),(20817832,11181,'./pm/moveoutprocess.php'),(20817831,3034,'./pm/moveoutprocess.php'),(20817830,11180,'./pm/moveoutprocess.php'),(20817829,9750,'./pm/moveoutprocess.php'),(20817828,11179,'./pm/moveoutprocess.php'),(20817827,11606,'./pm/moveoutprocess.php'),(20817826,10714,'./pm/moveoutprocess.php'),(20817825,11701,'./pm/moveoutprocess.php'),(20817824,11479,'./pm/moveoutprocess.php'),(20817823,11163,'./pm/moveoutprocess.php'),(20817822,11177,'./pm/moveoutprocess.php'),(20817821,9742,'./pm/moveoutprocess.php'),(20817820,1963,'./pm/moveoutprocess.php'),(20817819,11332,'./pm/moveoutprocess.php'),(20817818,10961,'./pm/moveoutprocess.php'),(20817817,11333,'./pm/moveoutprocess.php'),(20817816,11173,'./pm/moveoutprocess.php'),(20817815,11172,'./pm/moveoutprocess.php'),(20817814,11171,'./pm/moveoutprocess.php'),(20817813,11700,'./pm/moveoutprocess.php'),(20817812,1668,'./pm/moveoutprocess.php'),(20817811,14471,'./pm/moveoutprocess.php'),(20817810,14470,'./pm/moveoutprocess.php'),(20817809,14315,'./pm/moveoutprocess.php'),(20817808,8936,'./pm/moveoutprocess.php'),(20817807,1134,'./pm/moveoutprocess.php'),(20817806,1132,'./pm/moveoutprocess.php'),(20817805,14469,'./pm/moveoutprocess.php'),(20817804,14468,'./pm/moveoutprocess.php'),(20817803,14311,'./pm/moveoutprocess.php'),(20817802,14467,'./pm/moveoutprocess.php'),(20817801,14466,'./pm/moveoutprocess.php'),(20817800,14308,'./pm/moveoutprocess.php'),(20817799,5146,'./pm/moveoutprocess.php'),(20817798,5145,'./pm/moveoutprocess.php'),(20817797,11699,'./pm/moveoutprocess.php'),(20817796,11698,'./pm/moveoutprocess.php'),(20817795,11697,'./pm/moveoutprocess.php'),(20817863,3165,'./pm/moveoutselectlease.php'),(20817862,10739,'./pm/moveoutselectlease.php'),(20817861,10925,'./pm/moveoutselectlease.php'),(20817860,9750,'./pm/moveoutselectlease.php'),(20817859,11183,'./pm/moveoutselectlease.php'),(20817858,9785,'./pm/moveoutselectlease.php'),(20817857,9583,'./pm/moveoutselectlease.php'),(20817856,9582,'./pm/moveoutselectlease.php'),(20817855,11479,'./pm/moveoutselectlease.php'),(20817854,9858,'./pm/moveoutselectlease.php'),(20817853,9742,'./pm/moveoutselectlease.php'),(20817852,9741,'./pm/moveoutselectlease.php'),(20817851,9753,'./pm/moveoutselectlease.php'),(20817850,9736,'./pm/moveoutselectlease.php'),(20817849,9734,'./pm/moveoutselectlease.php'),(20817848,9646,'./pm/moveoutselectlease.php'),(20817847,10923,'./pm/moveoutselectlease.php'),(20817846,1014,'./pm/moveoutselectlease.php'),(20817845,333,'./pm/moveoutselectlease.php'),(20817913,3432,'./pm/newaccount.php'),(20817912,2936,'./pm/newaccount.php'),(20817911,9916,'./pm/newaccount.php'),(20817910,11608,'./pm/newaccount.php'),(20817909,11594,'./pm/newaccount.php'),(20817908,11769,'./pm/newaccount.php'),(20817907,9864,'./pm/newaccount.php'),(20817906,9855,'./pm/newaccount.php'),(20817905,14474,'./pm/newaccount.php'),(20817904,9761,'./pm/newaccount.php'),(20817903,9767,'./pm/newaccount.php'),(20817902,9681,'./pm/newaccount.php'),(20817901,9680,'./pm/newaccount.php'),(20817900,9679,'./pm/newaccount.php'),(20817899,9678,'./pm/newaccount.php'),(20817898,9677,'./pm/newaccount.php'),(20817897,9676,'./pm/newaccount.php'),(20817896,9675,'./pm/newaccount.php'),(20817895,9674,'./pm/newaccount.php'),(20817894,9673,'./pm/newaccount.php'),(20817893,9672,'./pm/newaccount.php'),(20817892,2324,'./pm/newaccount.php'),(20817891,11768,'./pm/newaccount.php'),(20817890,2237,'./pm/newaccount.php'),(20817889,2234,'./pm/newaccount.php'),(20817888,1963,'./pm/newaccount.php'),(20817887,9913,'./pm/newaccount.php'),(20817886,8544,'./pm/newaccount.php'),(20817885,9671,'./pm/newaccount.php'),(20817884,1758,'./pm/newaccount.php'),(20817883,1429,'./pm/newaccount.php'),(20817882,8936,'./pm/newaccount.php'),(20817881,982,'./pm/newaccount.php'),(20817880,11590,'./pm/newaccount.php'),(20817879,11607,'./pm/newaccount.php'),(20817878,11767,'./pm/newaccount.php'),(20817877,9863,'./pm/newaccount.php'),(20817876,14472,'./pm/newaccount.php'),(20817875,9668,'./pm/newaccount.php'),(20817874,9667,'./pm/newaccount.php'),(20817873,9666,'./pm/newaccount.php'),(20817872,7499,'./pm/newaccount.php'),(20817871,524,'./pm/newaccount.php'),(20817870,416,'./pm/newaccount.php'),(20817869,315,'./pm/newaccount.php'),(20817868,9665,'./pm/newaccount.php'),(20817867,185,'./pm/newaccount.php'),(20817866,9664,'./pm/newaccount.php'),(20817865,9663,'./pm/newaccount.php'),(20817864,9662,'./pm/newaccount.php'),(20817916,8115,'./pm/noteadd.php'),(20817915,8114,'./pm/noteadd.php'),(20817918,10992,'./pm/printlease.php'),(20817917,10991,'./pm/printlease.php'),(20817942,3165,'./pm/propertyavailability.php'),(20817941,10739,'./pm/propertyavailability.php'),(20817940,5237,'./pm/propertyavailability.php'),(20817939,9750,'./pm/propertyavailability.php'),(20817938,11598,'./pm/propertyavailability.php'),(20817937,9917,'./pm/propertyavailability.php'),(20817936,9916,'./pm/propertyavailability.php'),(20817935,11594,'./pm/propertyavailability.php'),(20817934,11580,'./pm/propertyavailability.php'),(20817933,2738,'./pm/propertyavailability.php'),(20817932,11190,'./pm/propertyavailability.php'),(20817931,10555,'./pm/propertyavailability.php'),(20817964,9796,'./pm/propertyoccupation.php'),(20817963,2798,'./pm/propertyoccupation.php'),(20817962,2738,'./pm/propertyoccupation.php'),(20817961,9795,'./pm/propertyoccupation.php'),(20817960,9652,'./pm/propertyoccupation.php'),(20817959,11479,'./pm/propertyoccupation.php'),(20817958,9794,'./pm/propertyoccupation.php'),(20817957,2129,'./pm/propertyoccupation.php'),(20817956,2106,'./pm/propertyoccupation.php'),(20817955,1871,'./pm/propertyoccupation.php'),(20817954,1821,'./pm/propertyoccupation.php'),(20817953,1749,'./pm/propertyoccupation.php'),(20817952,1747,'./pm/propertyoccupation.php'),(20817951,1741,'./pm/propertyoccupation.php'),(20817950,1375,'./pm/propertyoccupation.php'),(20817949,1014,'./pm/propertyoccupation.php'),(20817948,778,'./pm/propertyoccupation.php'),(20817947,9793,'./pm/propertyoccupation.php'),(20817946,8271,'./pm/propertyoccupation.php'),(20817945,333,'./pm/propertyoccupation.php'),(20817944,308,'./pm/propertyoccupation.php'),(20817943,275,'./pm/propertyoccupation.php'),(20817996,3450,'./pm/requestmaintenance.php'),(20817995,3165,'./pm/requestmaintenance.php'),(20817994,10887,'./pm/requestmaintenance.php'),(20817993,9750,'./pm/requestmaintenance.php'),(20817992,10884,'./pm/requestmaintenance.php'),(20817991,2975,'./pm/requestmaintenance.php'),(20817990,2948,'./pm/requestmaintenance.php'),(20817989,10920,'./pm/requestmaintenance.php'),(20817988,10919,'./pm/requestmaintenance.php'),(20817987,10918,'./pm/requestmaintenance.php'),(20817986,11479,'./pm/requestmaintenance.php'),(20817985,10917,'./pm/requestmaintenance.php'),(20817984,10916,'./pm/requestmaintenance.php'),(20817983,2324,'./pm/requestmaintenance.php'),(20817982,2292,'./pm/requestmaintenance.php'),(20817981,10915,'./pm/requestmaintenance.php'),(20817980,10914,'./pm/requestmaintenance.php'),(20817979,10913,'./pm/requestmaintenance.php'),(20817978,10912,'./pm/requestmaintenance.php'),(20817977,10911,'./pm/requestmaintenance.php'),(20817976,8936,'./pm/requestmaintenance.php'),(20817975,981,'./pm/requestmaintenance.php'),(20817974,869,'./pm/requestmaintenance.php'),(20817973,7105,'./pm/requestmaintenance.php'),(20817972,10910,'./pm/requestmaintenance.php'),(20817971,596,'./pm/requestmaintenance.php'),(20817970,416,'./pm/requestmaintenance.php'),(20817969,315,'./pm/requestmaintenance.php'),(20817968,10909,'./pm/requestmaintenance.php'),(20817967,10860,'./pm/requestmaintenance.php'),(20817966,10908,'./pm/requestmaintenance.php'),(20817965,55,'./pm/requestmaintenance.php'),(20818014,9690,'./pm/reset.php'),(20818013,2702,'./pm/reset.php'),(20818012,9689,'./pm/reset.php'),(20818011,9678,'./pm/reset.php'),(20818010,9688,'./pm/reset.php'),(20818009,9672,'./pm/reset.php'),(20818008,2237,'./pm/reset.php'),(20818007,2234,'./pm/reset.php'),(20818006,1963,'./pm/reset.php'),(20818005,9687,'./pm/reset.php'),(20818004,9686,'./pm/reset.php'),(20818003,9685,'./pm/reset.php'),(20818002,9684,'./pm/reset.php'),(20818001,9683,'./pm/reset.php'),(20818000,9682,'./pm/reset.php'),(20817999,982,'./pm/reset.php'),(20817998,7499,'./pm/reset.php'),(20817997,315,'./pm/reset.php'),(20818022,14479,'./pm/setpw.php'),(20818021,14478,'./pm/setpw.php'),(20818020,14477,'./pm/setpw.php'),(20818019,2237,'./pm/setpw.php'),(20818018,2234,'./pm/setpw.php'),(20818017,8936,'./pm/setpw.php'),(20818016,981,'./pm/setpw.php'),(20818015,7499,'./pm/setpw.php'),(20818029,3156,'./pm/tenantsurveys.php'),(20818028,9993,'./pm/tenantsurveys.php'),(20818027,14482,'./pm/tenantsurveys.php'),(20818026,8936,'./pm/tenantsurveys.php'),(20818025,14481,'./pm/tenantsurveys.php'),(20818024,9234,'./pm/tenantsurveys.php'),(20818023,14480,'./pm/tenantsurveys.php'),(20818031,9768,'./pm/viewapplication.php'),(20818051,3165,'./pm/viewinvoices.php'),(20818050,11184,'./pm/viewinvoices.php'),(20818049,2948,'./pm/viewinvoices.php'),(20818048,3434,'./pm/viewinvoices.php'),(20818047,2738,'./pm/viewinvoices.php'),(20818046,11014,'./pm/viewinvoices.php'),(20818045,11479,'./pm/viewinvoices.php'),(20818044,2225,'./pm/viewinvoices.php'),(20818043,11013,'./pm/viewinvoices.php'),(20818042,6839,'./pm/viewinvoices.php'),(20818101,3319,'./pm/viewleases.php'),(20818100,11588,'./pm/viewleases.php'),(20818099,3165,'./pm/viewleases.php'),(20818098,3156,'./pm/viewleases.php'),(20818097,10925,'./pm/viewleases.php'),(20818096,11191,'./pm/viewleases.php'),(20818095,14483,'./pm/viewleases.php'),(20818094,11673,'./pm/viewleases.php'),(20818093,11672,'./pm/viewleases.php'),(20818092,11586,'./pm/viewleases.php'),(20818091,11671,'./pm/viewleases.php'),(20818090,9583,'./pm/viewleases.php'),(20818089,9582,'./pm/viewleases.php'),(20818088,11190,'./pm/viewleases.php'),(20818087,11189,'./pm/viewleases.php'),(20818086,11615,'./pm/viewleases.php'),(20818085,11188,'./pm/viewleases.php'),(20818084,10963,'./pm/viewleases.php'),(20818083,11479,'./pm/viewleases.php'),(20818082,11670,'./pm/viewleases.php'),(20818081,2225,'./pm/viewleases.php'),(20818080,9858,'./pm/viewleases.php'),(20818079,11187,'./pm/viewleases.php'),(20818078,9741,'./pm/viewleases.php'),(20818077,11186,'./pm/viewleases.php'),(20818076,10961,'./pm/viewleases.php'),(20818075,11185,'./pm/viewleases.php'),(20818074,9918,'./pm/viewleases.php'),(20818073,14285,'./pm/viewleases.php'),(20818072,11614,'./pm/viewleases.php'),(20818071,11613,'./pm/viewleases.php'),(20818070,11637,'./pm/viewleases.php'),(20818069,10906,'./pm/viewleases.php'),(20818068,11674,'./pm/viewleases.php'),(20818067,10923,'./pm/viewleases.php'),(20818066,10956,'./pm/viewleases.php'),(20818065,1668,'./pm/viewleases.php'),(20818064,14315,'./pm/viewleases.php'),(20818063,8936,'./pm/viewleases.php'),(20818062,932,'./pm/viewleases.php'),(20818061,907,'./pm/viewleases.php'),(20818060,737,'./pm/viewleases.php'),(20818059,11669,'./pm/viewleases.php'),(20818058,14447,'./pm/viewleases.php'),(20818057,14441,'./pm/viewleases.php'),(20818056,10952,'./pm/viewleases.php'),(20818055,573,'./pm/viewleases.php'),(20818054,14308,'./pm/viewleases.php'),(20818053,315,'./pm/viewleases.php'),(20818052,226,'./pm/viewleases.php'),(20818103,11616,'./pm/viewnotes.php'),(20818102,10561,'./pm/viewnotes.php'),(20818119,11193,'./pm/viewpayments.php'),(20818118,2948,'./pm/viewpayments.php'),(20818117,3434,'./pm/viewpayments.php'),(20818116,2738,'./pm/viewpayments.php'),(20818115,2638,'./pm/viewpayments.php'),(20818114,4088,'./pm/viewpayments.php'),(20818113,7203,'./pm/viewpayments.php'),(20818112,2225,'./pm/viewpayments.php'),(20818155,3432,'./pm/viewprofile.php'),(20818154,3225,'./pm/viewprofile.php'),(20818153,14486,'./pm/viewprofile.php'),(20818152,14485,'./pm/viewprofile.php'),(20818151,2936,'./pm/viewprofile.php'),(20818150,2702,'./pm/viewprofile.php'),(20818149,9761,'./pm/viewprofile.php'),(20818148,9681,'./pm/viewprofile.php'),(20818147,9680,'./pm/viewprofile.php'),(20818146,9679,'./pm/viewprofile.php'),(20818145,9677,'./pm/viewprofile.php'),(20818144,9676,'./pm/viewprofile.php'),(20818143,9675,'./pm/viewprofile.php'),(20818142,9674,'./pm/viewprofile.php'),(20818141,9673,'./pm/viewprofile.php'),(20818140,2324,'./pm/viewprofile.php'),(20818139,11768,'./pm/viewprofile.php'),(20818138,8516,'./pm/viewprofile.php'),(20818158,9768,'./pm/viewtenantsurvey.php'),(20818157,9755,'./pm/viewtenantsurvey.php'),(20818222,11631,'./pm/includes/dashboard_l.php'),(20818221,11630,'./pm/includes/dashboard_l.php'),(20818220,11010,'./pm/includes/dashboard_l.php'),(20818219,11629,'./pm/includes/dashboard_l.php'),(20818218,11628,'./pm/includes/dashboard_l.php'),(20818217,11627,'./pm/includes/dashboard_l.php'),(20818216,11626,'./pm/includes/dashboard_l.php'),(20818215,9755,'./pm/includes/dashboard_l.php'),(20818214,11625,'./pm/includes/dashboard_l.php'),(20818213,10888,'./pm/includes/dashboard_l.php'),(20818212,11624,'./pm/includes/dashboard_l.php'),(20818211,11623,'./pm/includes/dashboard_l.php'),(20818210,11622,'./pm/includes/dashboard_l.php'),(20818209,3450,'./pm/includes/dashboard_l.php'),(20818208,11290,'./pm/includes/dashboard_l.php'),(20818207,3165,'./pm/includes/dashboard_l.php'),(20818206,3070,'./pm/includes/dashboard_l.php'),(20818205,10887,'./pm/includes/dashboard_l.php'),(20818204,9750,'./pm/includes/dashboard_l.php'),(20818203,10884,'./pm/includes/dashboard_l.php'),(20818202,2948,'./pm/includes/dashboard_l.php'),(20818201,11621,'./pm/includes/dashboard_l.php'),(20818200,9855,'./pm/includes/dashboard_l.php'),(20818199,11479,'./pm/includes/dashboard_l.php'),(20818198,2488,'./pm/includes/dashboard_l.php'),(20818197,2292,'./pm/includes/dashboard_l.php'),(20818196,11013,'./pm/includes/dashboard_l.php'),(20818195,11620,'./pm/includes/dashboard_l.php'),(20818194,2151,'./pm/includes/dashboard_l.php'),(20818193,2109,'./pm/includes/dashboard_l.php'),(20818192,9789,'./pm/includes/dashboard_l.php'),(20818191,2044,'./pm/includes/dashboard_l.php'),(20818224,11366,'./pm/includes/dashboard_p.php'),(20781338,2371,'./!/application/controllers/invcountbatch.php'),(20781337,19917,'./!/application/controllers/invcountbatch.php'),(20781336,19320,'./!/application/controllers/invcountbatch.php'),(20781335,19614,'./!/application/controllers/invcountbatch.php'),(20781334,19613,'./!/application/controllers/invcountbatch.php'),(20781333,19810,'./!/application/controllers/invcountbatch.php'),(20781332,2333,'./!/application/controllers/invcountbatch.php'),(20818269,11196,'./pm/includes/dashboard_t.php'),(20818268,11195,'./pm/includes/dashboard_t.php'),(20818267,11010,'./pm/includes/dashboard_t.php'),(20818266,3450,'./pm/includes/dashboard_t.php'),(20818265,10887,'./pm/includes/dashboard_t.php'),(20818264,10884,'./pm/includes/dashboard_t.php'),(20818263,2948,'./pm/includes/dashboard_t.php'),(20818262,3434,'./pm/includes/dashboard_t.php'),(20818261,2638,'./pm/includes/dashboard_t.php'),(20818260,9655,'./pm/includes/dashboard_t.php'),(20818259,4088,'./pm/includes/dashboard_t.php'),(20818258,11635,'./pm/includes/dashboard_t.php'),(20818257,11014,'./pm/includes/dashboard_t.php'),(20818256,11479,'./pm/includes/dashboard_t.php'),(20818255,10917,'./pm/includes/dashboard_t.php'),(20818254,2292,'./pm/includes/dashboard_t.php'),(20818253,2267,'./pm/includes/dashboard_t.php'),(20818252,2225,'./pm/includes/dashboard_t.php'),(20818251,11013,'./pm/includes/dashboard_t.php'),(20818250,4087,'./pm/includes/dashboard_t.php'),(20818249,10915,'./pm/includes/dashboard_t.php'),(20818248,9741,'./pm/includes/dashboard_t.php'),(20818247,4081,'./pm/includes/dashboard_t.php'),(20818329,11286,'./pm/includes/header.php'),(20818328,10746,'./pm/includes/header.php'),(20818327,14336,'./pm/includes/header.php'),(20818326,11275,'./pm/includes/header.php'),(20818325,10558,'./pm/includes/header.php'),(20818324,9236,'./pm/includes/header.php'),(20818323,11272,'./pm/includes/header.php'),(20818322,14323,'./pm/includes/header.php'),(20818321,11267,'./pm/includes/header.php'),(20818320,11580,'./pm/includes/header.php'),(20818319,2737,'./pm/includes/header.php'),(20818318,9661,'./pm/includes/header.php'),(20818317,11131,'./pm/includes/header.php'),(20818316,3797,'./pm/includes/header.php'),(20818315,11130,'./pm/includes/header.php'),(20818314,10555,'./pm/includes/header.php'),(20818313,9855,'./pm/includes/header.php'),(20818312,11129,'./pm/includes/header.php'),(20818311,9652,'./pm/includes/header.php'),(20818310,9651,'./pm/includes/header.php'),(20818309,10567,'./pm/includes/header.php'),(20818308,3443,'./pm/includes/header.php'),(20818307,14346,'./pm/includes/header.php'),(20818306,9648,'./pm/includes/header.php'),(20818305,15192,'./pm/includes/header.php'),(20818304,7203,'./pm/includes/header.php'),(20818303,10564,'./pm/includes/header.php'),(20818302,9647,'./pm/includes/header.php'),(20818301,14487,'./pm/includes/header.php'),(20818300,7199,'./pm/includes/header.php'),(20818330,9769,'./pm/includes/main.php'),(20781339,2377,'./!/application/controllers/invcountbatch.php'),(20781331,18809,'./!/application/controllers/invcountbatch.php'),(20781330,16533,'./!/application/controllers/invcountbatch.php'),(20781329,18735,'./!/application/controllers/invcountbatch.php'),(20781328,2292,'./!/application/controllers/invcountbatch.php'),(20818338,11641,'./pm/includes/moveinwizard.php'),(20818337,9916,'./pm/includes/moveinwizard.php'),(20818336,11594,'./pm/includes/moveinwizard.php'),(20818335,11420,'./pm/includes/moveinwizard.php'),(20818334,11018,'./pm/includes/moveinwizard.php'),(20818333,11638,'./pm/includes/moveinwizard.php'),(20818332,8936,'./pm/includes/moveinwizard.php'),(20818331,11590,'./pm/includes/moveinwizard.php'),(20818344,11179,'./pm/includes/moveoutwizard.php'),(20818343,11183,'./pm/includes/moveoutwizard.php'),(20818342,7917,'./pm/includes/moveoutwizard.php'),(20818341,11197,'./pm/includes/moveoutwizard.php'),(20818340,11602,'./pm/includes/moveoutwizard.php'),(20818339,8936,'./pm/includes/moveoutwizard.php'),(20787437,19758,'./adminarcompanyupd.php'),(20787436,1476,'./adminarcompanyupd.php'),(20787435,19282,'./adminarcompanyupd.php'),(20787434,8180,'./adminarcompanyupd.php'),(20787433,13023,'./adminarcompanyupd.php'),(20787432,5486,'./adminarcompanyupd.php'),(20787431,5491,'./adminarcompanyupd.php'),(20787430,17460,'./adminarcompanyupd.php'),(20787429,17459,'./adminarcompanyupd.php'),(20787428,17399,'./adminarcompanyupd.php'),(20787427,17398,'./adminarcompanyupd.php'),(20787426,17397,'./adminarcompanyupd.php'),(20787425,13995,'./adminarcompanyupd.php'),(20787424,17458,'./adminarcompanyupd.php'),(20818365,8115,'./pm/includes/npnote.php'),(20818364,8120,'./pm/includes/npnote.php'),(20818363,8260,'./pm/includes/npnote.php'),(20818362,3252,'./pm/includes/npnote.php'),(20818361,8119,'./pm/includes/npnote.php'),(20818360,2702,'./pm/includes/npnote.php'),(20818359,7169,'./pm/includes/npnote.php'),(20818358,8259,'./pm/includes/npnote.php'),(20818357,4865,'./pm/includes/npnote.php'),(20818356,8118,'./pm/includes/npnote.php'),(20818355,8117,'./pm/includes/npnote.php'),(20779282,5309,'./!/application/controllers/arinvoice.php'),(20780959,2094,'./!/application/controllers/invbinitem.php'),(20782100,1476,'./!/application/controllers/job.php'),(20782099,18910,'./!/application/controllers/job.php'),(20782854,18379,'./!/application/controllers/main.php'),(20782853,16936,'./!/application/controllers/main.php'),(20782852,3745,'./!/application/controllers/main.php'),(20782851,12847,'./!/application/controllers/main.php'),(20782850,16479,'./!/application/controllers/main.php'),(20782849,9170,'./!/application/controllers/main.php'),(20782848,15082,'./!/application/controllers/main.php'),(20784088,3421,'./!/application/libraries/import_task.php'),(20784087,3415,'./!/application/libraries/import_task.php'),(20784086,3299,'./!/application/libraries/import_task.php'),(20784085,6141,'./!/application/libraries/import_task.php'),(20784084,3274,'./!/application/libraries/import_task.php'),(20784083,19082,'./!/application/libraries/import_task.php'),(20784082,16320,'./!/application/libraries/import_task.php'),(20784080,16676,'./!/application/libraries/import_task.php'),(20784881,1963,'./!/application/views/arinvoice/import_customer_and_job_changes_footer.php'),(20784880,416,'./!/application/views/arinvoice/import_customer_and_job_changes_footer.php'),(20784879,315,'./!/application/views/arinvoice/import_customer_and_job_changes_footer.php'),(20785568,16321,'./!/application/views/glaccount/report_balance_sheet_trial_form.php'),(20790021,892,'./apbill_preapprove.php'),(20790020,10572,'./apbill_preapprove.php'),(20790019,886,'./apbill_preapprove.php'),(20790018,6649,'./apbill_preapprove.php'),(20790017,6648,'./apbill_preapprove.php'),(20790016,607,'./apbill_preapprove.php'),(20790469,607,'./apbillupd.php'),(20790468,592,'./apbillupd.php'),(20790467,567,'./apbillupd.php'),(20790466,566,'./apbillupd.php'),(20790465,542,'./apbillupd.php'),(20790464,491,'./apbillupd.php'),(20792412,1625,'./arinvoicecalcint.php'),(20792808,542,'./arinvoicerepaging.php'),(20792807,325,'./arinvoicerepaging.php'),(20792806,197,'./arinvoicerepaging.php'),(20792805,194,'./arinvoicerepaging.php'),(20792948,17073,'./arinvoicereppay.php'),(20792947,451,'./arinvoicereppay.php'),(20792946,445,'./arinvoicereppay.php'),(20793026,18818,'./arinvoicereprint.php'),(20793025,4481,'./arinvoicereprint.php'),(20796530,5205,'./autofunctions.php'),(20800436,3547,'./glbudlst.php'),(20800435,389,'./glbudlst.php'),(20800434,11,'./glbudlst.php'),(20800511,16116,'./glclose_month.php'),(20800510,543,'./glclose_month.php'),(20800509,541,'./glclose_month.php'),(20800508,13861,'./glclose_month.php'),(20800507,416,'./glclose_month.php'),(20800506,16169,'./glclose_month.php'),(20801102,7246,'./glrepactivity.php'),(20801716,892,'./importbills.php'),(20801715,890,'./importbills.php'),(20801714,14205,'./importbills.php'),(20801774,16045,'./importccpurchases.php'),(20801773,16044,'./importccpurchases.php'),(20801772,16043,'./importccpurchases.php'),(20801771,16852,'./importccpurchases.php'),(20801770,7209,'./importccpurchases.php'),(20801855,7663,'./importcustomer.php'),(20801854,1381,'./importcustomer.php'),(20801990,14203,'./importemployeeexpenses.php'),(20801989,548,'./importemployeeexpenses.php'),(20801988,7360,'./importemployeeexpenses.php'),(20801987,9357,'./importemployeeexpenses.php'),(20801986,315,'./importemployeeexpenses.php'),(20802066,20248,'./importgljournals.php'),(20805524,17755,'./jobupd.php'),(20805523,19859,'./jobupd.php'),(20805522,524,'./jobupd.php'),(20805521,9958,'./jobupd.php'),(20805520,9957,'./jobupd.php'),(20805519,503,'./jobupd.php'),(20805518,15568,'./jobupd.php'),(20805517,416,'./jobupd.php'),(20805516,9956,'./jobupd.php'),(20805515,13994,'./jobupd.php'),(20805514,5439,'./jobupd.php'),(20805513,15567,'./jobupd.php'),(20805512,9955,'./jobupd.php'),(20805511,9954,'./jobupd.php'),(20811998,6228,'./includes/arinvoiceviewfpdf.functions.php'),(20812108,1743,'./includes/arstateviewfpdf.functions.php'),(20812345,7849,'./includes/createmenu2.inc'),(20815175,16355,'./includes/tamg.php'),(20779744,16475,'./!/application/controllers/batchimport.php'),(20779743,6085,'./!/application/controllers/batchimport.php'),(20779742,8508,'./!/application/controllers/batchimport.php'),(20779741,2702,'./!/application/controllers/batchimport.php'),(20780325,16367,'./!/application/controllers/dashboard.php'),(20781327,2230,'./!/application/controllers/invcountbatch.php'),(20782098,16955,'./!/application/controllers/job.php'),(20782097,6168,'./!/application/controllers/job.php'),(20782096,11868,'./!/application/controllers/job.php'),(20782095,6166,'./!/application/controllers/job.php'),(20782094,15939,'./!/application/controllers/job.php'),(20785061,15973,'./!/application/views/batchimport/settings.php'),(20785338,4045,'./!/application/views/dashboard/welcome.php'),(20785337,4044,'./!/application/views/dashboard/welcome.php'),(20785336,4043,'./!/application/views/dashboard/welcome.php'),(20785343,13766,'./!/application/views/dashboard/summary/checking_account.php'),(20785726,16487,'./!/application/views/invcountbatch/enterCounts.php'),(20785342,10983,'./!/application/views/dashboard/summary/checking_account.php'),(20785341,5898,'./!/application/views/dashboard/summary/checking_account.php'),(20785340,325,'./!/application/views/dashboard/summary/checking_account.php'),(20785348,4596,'./!/application/views/dashboard/summary/creditcard_account.php'),(20785347,13766,'./!/application/views/dashboard/summary/creditcard_account.php'),(20785346,10983,'./!/application/views/dashboard/summary/creditcard_account.php'),(20785345,325,'./!/application/views/dashboard/summary/creditcard_account.php'),(20785344,15094,'./!/application/views/dashboard/summary/creditcard_account.php'),(20785355,16373,'./!/application/views/dashboard/summary/expenses.php'),(20785354,16372,'./!/application/views/dashboard/summary/expenses.php'),(20785353,13584,'./!/application/views/dashboard/summary/expenses.php'),(20785351,14759,'./!/application/views/dashboard/summary/expenses.php'),(20785352,1353,'./!/application/views/dashboard/summary/expenses.php'),(20785489,19495,'./!/application/views/generic/barcode_reader_detector.php'),(20804996,1140,'./invpotoap.php'),(20785362,16377,'./!/application/views/dashboard/summary/income.php'),(20785361,16376,'./!/application/views/dashboard/summary/income.php'),(20785360,16375,'./!/application/views/dashboard/summary/income.php'),(20785359,16374,'./!/application/views/dashboard/summary/income.php'),(20785358,13577,'./!/application/views/dashboard/summary/income.php'),(20785357,13576,'./!/application/views/dashboard/summary/income.php'),(20785356,80,'./!/application/views/dashboard/summary/income.php'),(20785376,3090,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785375,12013,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785374,13588,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785373,12233,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785372,2494,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785371,2320,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785370,16403,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785369,2208,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785368,13578,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785471,3156,'./!/application/views/employee/certificates.php'),(20785494,9789,'./!/application/views/generic/control_panel.php'),(20785493,16378,'./!/application/views/generic/control_panel.php'),(20785567,16380,'./!/application/views/generic/tabs.php'),(20785566,16379,'./!/application/views/generic/tabs.php'),(20787422,16640,'./adminarcompanyupd.php'),(20792158,594,'./arinvoice_writeoff.php'),(20792945,5355,'./arinvoicereppay.php'),(20793622,1679,'./arinvoiceview.php'),(20796138,13221,'./arserviceordupd.php'),(20805510,5437,'./jobupd.php'),(20814450,14646,'./includes/header.php'),(20792873,315,'./arinvoicerepbalcust_detail.php'),(20791105,226,'./apvendupd.php'),(20791987,20081,'./arcustupd.php'),(20793621,1678,'./arinvoiceview.php'),(20796137,479,'./arserviceordupd.php'),(20805154,11973,'./invpoupd.php'),(20805153,8005,'./invpoupd.php'),(20782093,16100,'./!/application/controllers/job.php'),(20782092,1373,'./!/application/controllers/job.php'),(20785534,3252,'./!/application/views/generic/notes.php'),(20785533,16393,'./!/application/views/generic/notes.php'),(20785532,2702,'./!/application/views/generic/notes.php'),(20785531,2103,'./!/application/views/generic/notes.php'),(20785530,2099,'./!/application/views/generic/notes.php'),(20785529,16089,'./!/application/views/generic/notes.php'),(20785528,1143,'./!/application/views/generic/notes.php'),(20785527,941,'./!/application/views/generic/notes.php'),(20785526,799,'./!/application/views/generic/notes.php'),(20785525,737,'./!/application/views/generic/notes.php'),(20785524,16392,'./!/application/views/generic/notes.php'),(20787423,19100,'./adminarcompanyupd.php'),(20787421,8801,'./adminarcompanyupd.php'),(20791986,4938,'./arcustupd.php'),(20800829,12140,'./gljouradd.php'),(20800828,226,'./gljouradd.php'),(20800923,259,'./gljourupd.php'),(20800922,226,'./gljourupd.php'),(20806015,9165,'./nporder.php'),(20806312,6192,'./nporderpayment.php'),(20806311,16088,'./nporderpayment.php'),(20806310,479,'./nporderpayment.php'),(20806474,697,'./npordersave.php'),(20806473,14593,'./npordersave.php'),(20811997,697,'./includes/arinvoiceviewfpdf.functions.php'),(20814104,9012,'./includes/genfunctions.php'),(20814103,14919,'./includes/genfunctions.php'),(20782846,3746,'./!/application/controllers/main.php'),(20782847,7916,'./!/application/controllers/main.php'),(20791466,8936,'./arbankreconciledetail.php'),(20791465,4346,'./arbankreconciledetail.php'),(20791464,16405,'./arbankreconciledetail.php'),(20791463,9803,'./arbankreconciledetail.php'),(20791462,5888,'./arbankreconciledetail.php'),(20791461,5430,'./arbankreconciledetail.php'),(20791460,315,'./arbankreconciledetail.php'),(20791724,700,'./arcustadd.php'),(20791985,4001,'./arcustupd.php'),(20792194,152,'./arinvoiceadd.php'),(20792193,85,'./arinvoiceadd.php'),(20792192,59,'./arinvoiceadd.php'),(20799998,6165,'./genuseradd.php'),(20799997,315,'./genuseradd.php'),(20801425,16410,'./glrepincome_fund_summary.php'),(20801424,2003,'./glrepincome_fund_summary.php'),(20801423,1963,'./glrepincome_fund_summary.php'),(20801422,16402,'./glrepincome_fund_summary.php'),(20801421,16409,'./glrepincome_fund_summary.php'),(20801420,1019,'./glrepincome_fund_summary.php'),(20801419,1022,'./glrepincome_fund_summary.php'),(20801418,16408,'./glrepincome_fund_summary.php'),(20801417,607,'./glrepincome_fund_summary.php'),(20801416,467,'./glrepincome_fund_summary.php'),(20801415,337,'./glrepincome_fund_summary.php'),(20801414,339,'./glrepincome_fund_summary.php'),(20801413,315,'./glrepincome_fund_summary.php'),(20801488,3274,'./glrepjournal_funds.php'),(20801487,3118,'./glrepjournal_funds.php'),(20801486,2977,'./glrepjournal_funds.php'),(20801485,2504,'./glrepjournal_funds.php'),(20801484,2003,'./glrepjournal_funds.php'),(20801483,1963,'./glrepjournal_funds.php'),(20801482,16401,'./glrepjournal_funds.php'),(20801481,16411,'./glrepjournal_funds.php'),(20801480,1019,'./glrepjournal_funds.php'),(20801479,607,'./glrepjournal_funds.php'),(20801478,467,'./glrepjournal_funds.php'),(20801477,337,'./glrepjournal_funds.php'),(20801476,315,'./glrepjournal_funds.php'),(20801475,226,'./glrepjournal_funds.php'),(20801474,197,'./glrepjournal_funds.php'),(20806014,1678,'./nporder.php'),(20806013,5652,'./nporder.php'),(20806012,11095,'./nporder.php'),(20806011,6125,'./nporder.php'),(20806010,16414,'./nporder.php'),(20806009,1672,'./nporder.php'),(20806008,14767,'./nporder.php'),(20806007,1668,'./nporder.php'),(20806006,17964,'./nporder.php'),(20806005,1647,'./nporder.php'),(20806004,18772,'./nporder.php'),(20806003,1599,'./nporder.php'),(20806002,1558,'./nporder.php'),(20806001,13717,'./nporder.php'),(20806000,14606,'./nporder.php'),(20805999,8905,'./nporder.php'),(20805998,15991,'./nporder.php'),(20805997,3481,'./nporder.php'),(20805996,9128,'./nporder.php'),(20805995,9321,'./nporder.php'),(20805994,5486,'./nporder.php'),(20805993,1429,'./nporder.php'),(20811558,3333,'./includes/arbankreconcile.functions.php'),(20811557,16416,'./includes/arbankreconcile.functions.php'),(20811556,5897,'./includes/arbankreconcile.functions.php'),(20811555,3156,'./includes/arbankreconcile.functions.php'),(20811554,6964,'./includes/arbankreconcile.functions.php'),(20811553,3090,'./includes/arbankreconcile.functions.php'),(20811552,3072,'./includes/arbankreconcile.functions.php'),(20811551,6071,'./includes/arbankreconcile.functions.php'),(20811550,3762,'./includes/arbankreconcile.functions.php'),(20811549,2270,'./includes/arbankreconcile.functions.php'),(20811548,11778,'./includes/arbankreconcile.functions.php'),(20811547,9143,'./includes/arbankreconcile.functions.php'),(20811546,2165,'./includes/arbankreconcile.functions.php'),(20811545,5892,'./includes/arbankreconcile.functions.php'),(20811544,6149,'./includes/arbankreconcile.functions.php'),(20811543,1668,'./includes/arbankreconcile.functions.php'),(20811542,17627,'./includes/arbankreconcile.functions.php'),(20811541,5930,'./includes/arbankreconcile.functions.php'),(20811540,15991,'./includes/arbankreconcile.functions.php'),(20812344,3526,'./includes/createmenu2.inc'),(20812343,6398,'./includes/createmenu2.inc'),(20813540,18881,'./includes/filesystemdb.php'),(20814102,15739,'./includes/genfunctions.php'),(20814101,13477,'./includes/genfunctions.php'),(20814100,8010,'./includes/genfunctions.php'),(20779438,8055,'./!/application/controllers/arorder.php'),(20779437,2835,'./!/application/controllers/arorder.php'),(20779436,18507,'./!/application/controllers/arorder.php'),(20779435,18147,'./!/application/controllers/arorder.php'),(20779434,17130,'./!/application/controllers/arorder.php'),(20779962,3094,'./!/application/controllers/check.php'),(20779961,3093,'./!/application/controllers/check.php'),(20779960,3092,'./!/application/controllers/check.php'),(20780960,19040,'./!/application/controllers/invbinitem.php'),(20780958,14396,'./!/application/controllers/invbinitem.php'),(20780955,1698,'./!/application/controllers/invbinitem.php'),(20780485,3415,'./!/application/controllers/glaccount.php'),(20782091,11049,'./!/application/controllers/job.php'),(20782090,17941,'./!/application/controllers/job.php'),(20782845,16117,'./!/application/controllers/main.php'),(20782844,9612,'./!/application/controllers/main.php'),(20783864,18233,'./!/application/controllers/vendor.php'),(20783863,2223,'./!/application/controllers/vendor.php'),(20783862,3470,'./!/application/controllers/vendor.php'),(20783861,13938,'./!/application/controllers/vendor.php'),(20783860,2044,'./!/application/controllers/vendor.php'),(20783859,16255,'./!/application/controllers/vendor.php'),(20784141,3172,'./!/application/libraries/settings_form.php'),(20785091,1625,'./!/application/views/check/edit_associated_bills.php'),(20785090,8702,'./!/application/views/check/edit_associated_bills.php'),(20785089,16437,'./!/application/views/check/edit_associated_bills.php'),(20785560,2044,'./!/application/views/generic/simple_table.php'),(20785559,4940,'./!/application/views/generic/simple_table.php'),(20787419,20223,'./adminarcompanyupd.php'),(20780957,1726,'./!/application/controllers/invbinitem.php'),(20780938,16614,'./!/application/controllers/invbin.php'),(20780937,16468,'./!/application/controllers/invbin.php'),(20780936,19192,'./!/application/controllers/invbin.php'),(20780935,16467,'./!/application/controllers/invbin.php'),(20780934,16466,'./!/application/controllers/invbin.php'),(20780933,16465,'./!/application/controllers/invbin.php'),(20780932,19526,'./!/application/controllers/invbin.php'),(20780931,2702,'./!/application/controllers/invbin.php'),(20780930,4265,'./!/application/controllers/invbin.php'),(20780929,5876,'./!/application/controllers/invbin.php'),(20780928,16464,'./!/application/controllers/invbin.php'),(20780927,19344,'./!/application/controllers/invbin.php'),(20780926,19343,'./!/application/controllers/invbin.php'),(20780925,2459,'./!/application/controllers/invbin.php'),(20780924,19191,'./!/application/controllers/invbin.php'),(20780923,19190,'./!/application/controllers/invbin.php'),(20780922,17263,'./!/application/controllers/invbin.php'),(20780921,2094,'./!/application/controllers/invbin.php'),(20781581,17273,'./!/application/controllers/invzone.php'),(20781580,17272,'./!/application/controllers/invzone.php'),(20781579,18524,'./!/application/controllers/invzone.php'),(20781578,16614,'./!/application/controllers/invzone.php'),(20781954,16676,'./!/application/controllers/itempricespecial.php'),(20781953,13932,'./!/application/controllers/itempricespecial.php'),(20781952,16476,'./!/application/controllers/itempricespecial.php'),(20781951,19941,'./!/application/controllers/itempricespecial.php'),(20781950,16475,'./!/application/controllers/itempricespecial.php'),(20781949,19940,'./!/application/controllers/itempricespecial.php'),(20781948,19939,'./!/application/controllers/itempricespecial.php'),(20781947,7007,'./!/application/controllers/itempricespecial.php'),(20781946,3913,'./!/application/controllers/itempricespecial.php'),(20781945,2819,'./!/application/controllers/itempricespecial.php'),(20781944,2738,'./!/application/controllers/itempricespecial.php'),(20781943,8508,'./!/application/controllers/itempricespecial.php'),(20781939,5876,'./!/application/controllers/itempricespecial.php'),(20781940,9962,'./!/application/controllers/itempricespecial.php'),(20781941,2676,'./!/application/controllers/itempricespecial.php'),(20781942,2702,'./!/application/controllers/itempricespecial.php'),(20782089,15049,'./!/application/controllers/job.php'),(20782843,8747,'./!/application/controllers/main.php'),(20782842,18213,'./!/application/controllers/main.php'),(20782841,3741,'./!/application/controllers/main.php'),(20782840,3740,'./!/application/controllers/main.php'),(20782839,3739,'./!/application/controllers/main.php'),(20782838,7165,'./!/application/controllers/main.php'),(20782837,3738,'./!/application/controllers/main.php'),(20782836,4874,'./!/application/controllers/main.php'),(20782834,13755,'./!/application/controllers/main.php'),(20784139,3163,'./!/application/libraries/settings_form.php'),(20785523,607,'./!/application/views/generic/interrupt_save_check.php'),(20796529,697,'./autofunctions.php'),(20802118,457,'./importgltotals.php'),(20802117,315,'./importgltotals.php'),(20804385,14909,'./invitemupd1.php'),(20804384,16485,'./invitemupd1.php'),(20804383,13994,'./invitemupd1.php'),(20804382,315,'./invitemupd1.php'),(20805461,16453,'./jobcostrpt.php'),(20805460,2103,'./jobcostrpt.php'),(20805459,2099,'./jobcostrpt.php'),(20805458,1973,'./jobcostrpt.php'),(20805457,18026,'./jobcostrpt.php'),(20805456,13484,'./jobcostrpt.php'),(20805455,16491,'./jobcostrpt.php'),(20805454,16490,'./jobcostrpt.php'),(20805453,1751,'./jobcostrpt.php'),(20805452,16489,'./jobcostrpt.php'),(20805451,16488,'./jobcostrpt.php'),(20805450,5081,'./jobcostrpt.php'),(20805449,1740,'./jobcostrpt.php'),(20805448,1696,'./jobcostrpt.php'),(20805447,14868,'./jobcostrpt.php'),(20805446,1682,'./jobcostrpt.php'),(20805445,4940,'./jobcostrpt.php'),(20805444,1668,'./jobcostrpt.php'),(20805443,17209,'./jobcostrpt.php'),(20805442,1575,'./jobcostrpt.php'),(20805441,15991,'./jobcostrpt.php'),(20805440,8936,'./jobcostrpt.php'),(20805439,16451,'./jobcostrpt.php'),(20805787,3533,'./menu.php'),(20808907,15428,'./prrpt.php'),(20808906,8797,'./prrpt.php'),(20808905,185,'./prrpt.php'),(20778851,1668,'./!/application/controllers/apbillpayment.php'),(20784760,3948,'./!/application/views/appointments/summary.php'),(20778903,19175,'./!/application/controllers/archive_reports.php'),(20778902,1014,'./!/application/controllers/archive_reports.php'),(20778901,15862,'./!/application/controllers/archive_reports.php'),(20778900,19174,'./!/application/controllers/archive_reports.php'),(20778899,5205,'./!/application/controllers/archive_reports.php'),(20779298,6228,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779903,59,'./!/application/controllers/chargebackcode.php'),(20780010,3225,'./!/application/controllers/county.php'),(20780009,14823,'./!/application/controllers/county.php'),(20780008,16506,'./!/application/controllers/county.php'),(20780007,1047,'./!/application/controllers/county.php'),(20780006,16590,'./!/application/controllers/county.php'),(20780005,807,'./!/application/controllers/county.php'),(20780004,864,'./!/application/controllers/county.php'),(20780003,16505,'./!/application/controllers/county.php'),(20780002,16504,'./!/application/controllers/county.php'),(20780001,541,'./!/application/controllers/county.php'),(20780000,16503,'./!/application/controllers/county.php'),(20779999,222,'./!/application/controllers/county.php'),(20780315,3319,'./!/application/controllers/customer.php'),(20780314,18899,'./!/application/controllers/customer.php'),(20780313,19288,'./!/application/controllers/customer.php'),(20780312,3156,'./!/application/controllers/customer.php'),(20780425,2751,'./!/application/controllers/freightburden.php'),(20780956,19195,'./!/application/controllers/invbinitem.php'),(20780484,16431,'./!/application/controllers/glaccount.php'),(20780483,3130,'./!/application/controllers/glaccount.php'),(20780482,9273,'./!/application/controllers/glaccount.php'),(20780481,18906,'./!/application/controllers/glaccount.php'),(20780480,16095,'./!/application/controllers/glaccount.php'),(20780479,2738,'./!/application/controllers/glaccount.php'),(20780470,20207,'./!/application/controllers/glaccount.php'),(20780471,14611,'./!/application/controllers/glaccount.php'),(20780472,16511,'./!/application/controllers/glaccount.php'),(20780473,1913,'./!/application/controllers/glaccount.php'),(20780474,1935,'./!/application/controllers/glaccount.php'),(20780475,6951,'./!/application/controllers/glaccount.php'),(20780476,16429,'./!/application/controllers/glaccount.php'),(20780478,2223,'./!/application/controllers/glaccount.php'),(20780892,2702,'./!/application/controllers/invadjustmenttype.php'),(20780891,5876,'./!/application/controllers/invadjustmenttype.php'),(20780890,16464,'./!/application/controllers/invadjustmenttype.php'),(20780889,4721,'./!/application/controllers/invadjustmenttype.php'),(20780888,16736,'./!/application/controllers/invadjustmenttype.php'),(20780887,16735,'./!/application/controllers/invadjustmenttype.php'),(20780884,15991,'./!/application/controllers/invadjustmenttype.php'),(20780885,16512,'./!/application/controllers/invadjustmenttype.php'),(20781124,19907,'./!/application/controllers/invcotransfer.php'),(20781123,16523,'./!/application/controllers/invcotransfer.php'),(20781122,19906,'./!/application/controllers/invcotransfer.php'),(20781121,19053,'./!/application/controllers/invcotransfer.php'),(20781120,16883,'./!/application/controllers/invcotransfer.php'),(20781326,18344,'./!/application/controllers/invcountbatch.php'),(20781325,2231,'./!/application/controllers/invcountbatch.php'),(20781324,2223,'./!/application/controllers/invcountbatch.php'),(20781323,4023,'./!/application/controllers/invcountbatch.php'),(20781322,19066,'./!/application/controllers/invcountbatch.php'),(20781321,16671,'./!/application/controllers/invcountbatch.php'),(20781320,19489,'./!/application/controllers/invcountbatch.php'),(20781319,2160,'./!/application/controllers/invcountbatch.php'),(20781311,19302,'./!/application/controllers/invcountbatch.php'),(20781874,17937,'./!/application/controllers/itemlocation.php'),(20781937,2508,'./!/application/controllers/itempricespecial.php'),(20781938,16464,'./!/application/controllers/itempricespecial.php'),(20782088,16125,'./!/application/controllers/job.php'),(20782087,16089,'./!/application/controllers/job.php'),(20782086,1047,'./!/application/controllers/job.php'),(20782085,1014,'./!/application/controllers/job.php'),(20782084,16273,'./!/application/controllers/job.php'),(20782083,3463,'./!/application/controllers/job.php'),(20782082,16099,'./!/application/controllers/job.php'),(20782081,16098,'./!/application/controllers/job.php'),(20782080,981,'./!/application/controllers/job.php'),(20782079,941,'./!/application/controllers/job.php'),(20782078,932,'./!/application/controllers/job.php'),(20782077,5407,'./!/application/controllers/job.php'),(20782076,18919,'./!/application/controllers/job.php'),(20782075,16270,'./!/application/controllers/job.php'),(20782074,869,'./!/application/controllers/job.php'),(20782073,5205,'./!/application/controllers/job.php'),(20781318,19295,'./!/application/controllers/invcountbatch.php'),(20781317,2137,'./!/application/controllers/invcountbatch.php'),(20781316,19065,'./!/application/controllers/invcountbatch.php'),(20781315,19612,'./!/application/controllers/invcountbatch.php'),(20781314,3503,'./!/application/controllers/invcountbatch.php'),(20781313,2044,'./!/application/controllers/invcountbatch.php'),(20781312,19809,'./!/application/controllers/invcountbatch.php'),(20782835,15192,'./!/application/controllers/main.php'),(20782833,3726,'./!/application/controllers/main.php'),(20782832,7812,'./!/application/controllers/main.php'),(20782831,7054,'./!/application/controllers/main.php'),(20782830,7053,'./!/application/controllers/main.php'),(20782829,7052,'./!/application/controllers/main.php'),(20782828,14993,'./!/application/controllers/main.php'),(20782827,15481,'./!/application/controllers/main.php'),(20782826,14631,'./!/application/controllers/main.php'),(20782825,2270,'./!/application/controllers/main.php'),(20782824,6516,'./!/application/controllers/main.php'),(20782823,7911,'./!/application/controllers/main.php'),(20782822,18222,'./!/application/controllers/main.php'),(20782820,6661,'./!/application/controllers/main.php'),(20783575,16550,'./!/application/controllers/stagingarea.php'),(20783574,16551,'./!/application/controllers/stagingarea.php'),(20783573,2751,'./!/application/controllers/stagingarea.php'),(20783572,869,'./!/application/controllers/stagingarea.php'),(20783571,548,'./!/application/controllers/stagingarea.php'),(20489199,6164,'./!/application/controllers/territory.php'),(20489198,14946,'./!/application/controllers/territory.php'),(20489197,8472,'./!/application/controllers/territory.php'),(20489196,18553,'./!/application/controllers/territory.php'),(20489195,18552,'./!/application/controllers/territory.php'),(20489194,19383,'./!/application/controllers/territory.php'),(20489193,18551,'./!/application/controllers/territory.php'),(20783858,8361,'./!/application/controllers/vendor.php'),(20783857,14575,'./!/application/controllers/vendor.php'),(20783856,2094,'./!/application/controllers/vendor.php'),(20783855,2103,'./!/application/controllers/vendor.php'),(20783854,1963,'./!/application/controllers/vendor.php'),(20783853,1935,'./!/application/controllers/vendor.php'),(20783852,1933,'./!/application/controllers/vendor.php'),(20783851,15620,'./!/application/controllers/vendor.php'),(20783850,10386,'./!/application/controllers/vendor.php'),(20783849,8544,'./!/application/controllers/vendor.php'),(20783848,8596,'./!/application/controllers/vendor.php'),(20783847,1880,'./!/application/controllers/vendor.php'),(20783846,16556,'./!/application/controllers/vendor.php'),(20783845,17694,'./!/application/controllers/vendor.php'),(20783844,17573,'./!/application/controllers/vendor.php'),(20783843,17693,'./!/application/controllers/vendor.php'),(20783842,4720,'./!/application/controllers/vendor.php'),(20783841,1792,'./!/application/controllers/vendor.php'),(20783840,1770,'./!/application/controllers/vendor.php'),(20783839,18232,'./!/application/controllers/vendor.php'),(20783838,4084,'./!/application/controllers/vendor.php'),(20783837,1758,'./!/application/controllers/vendor.php'),(20783836,7490,'./!/application/controllers/vendor.php'),(20783835,1709,'./!/application/controllers/vendor.php'),(20783834,17701,'./!/application/controllers/vendor.php'),(20783833,17448,'./!/application/controllers/vendor.php'),(20783832,1678,'./!/application/controllers/vendor.php'),(20783831,1672,'./!/application/controllers/vendor.php'),(20783830,17806,'./!/application/controllers/vendor.php'),(20783829,17805,'./!/application/controllers/vendor.php'),(20783828,9314,'./!/application/controllers/vendor.php'),(20783827,14611,'./!/application/controllers/vendor.php'),(20783826,18231,'./!/application/controllers/vendor.php'),(20783825,17441,'./!/application/controllers/vendor.php'),(20783824,17447,'./!/application/controllers/vendor.php'),(20783823,16546,'./!/application/controllers/vendor.php'),(20783822,17691,'./!/application/controllers/vendor.php'),(20783821,5702,'./!/application/controllers/vendor.php'),(20783820,17181,'./!/application/controllers/vendor.php'),(20783957,541,'./!/application/controllers/writeoffreason.php'),(20783988,17715,'./!/application/core/MY_Controller.php'),(20783987,17714,'./!/application/core/MY_Controller.php'),(20783986,5876,'./!/application/core/MY_Controller.php'),(20783985,16464,'./!/application/core/MY_Controller.php'),(20783984,3992,'./!/application/core/MY_Controller.php'),(20783983,4721,'./!/application/core/MY_Controller.php'),(20783982,1559,'./!/application/core/MY_Controller.php'),(20783981,16089,'./!/application/core/MY_Controller.php'),(20783980,17713,'./!/application/core/MY_Controller.php'),(20783979,1143,'./!/application/core/MY_Controller.php'),(20784081,19081,'./!/application/libraries/import_task.php'),(20784232,16431,'./!/application/model_collections/invcountbatch_collection.php'),(20784231,2377,'./!/application/model_collections/invcountbatch_collection.php'),(20784230,16566,'./!/application/model_collections/invcountbatch_collection.php'),(20784229,15803,'./!/application/model_collections/invcountbatch_collection.php'),(20784228,591,'./!/application/model_collections/invcountbatch_collection.php'),(20784227,16526,'./!/application/model_collections/invcountbatch_collection.php'),(20784395,16431,'./!/application/models/invcountbatch_model.php'),(20784394,2377,'./!/application/models/invcountbatch_model.php'),(20784393,2333,'./!/application/models/invcountbatch_model.php'),(20784392,18186,'./!/application/models/invcountbatch_model.php'),(20784391,591,'./!/application/models/invcountbatch_model.php'),(20784759,10524,'./!/application/views/appointments/summary.php'),(20784758,16958,'./!/application/views/appointments/summary.php'),(20784757,8421,'./!/application/views/appointments/summary.php'),(20784756,2975,'./!/application/views/appointments/summary.php'),(20784755,16581,'./!/application/views/appointments/summary.php'),(20784754,20032,'./!/application/views/appointments/summary.php'),(20784753,2801,'./!/application/views/appointments/summary.php'),(20784752,18816,'./!/application/views/appointments/summary.php'),(20784751,2798,'./!/application/views/appointments/summary.php'),(20784750,16733,'./!/application/views/appointments/summary.php'),(20784749,16715,'./!/application/views/appointments/summary.php'),(20784748,2702,'./!/application/views/appointments/summary.php'),(20784747,10523,'./!/application/views/appointments/summary.php'),(20784746,10882,'./!/application/views/appointments/summary.php'),(20784745,17063,'./!/application/views/appointments/summary.php'),(20784744,16813,'./!/application/views/appointments/summary.php'),(20784743,16806,'./!/application/views/appointments/summary.php'),(20784742,20031,'./!/application/views/appointments/summary.php'),(20784741,16812,'./!/application/views/appointments/summary.php'),(20784740,16580,'./!/application/views/appointments/summary.php'),(20784739,4608,'./!/application/views/appointments/summary.php'),(20784738,2129,'./!/application/views/appointments/summary.php'),(20784737,19755,'./!/application/views/appointments/summary.php'),(20784736,2106,'./!/application/views/appointments/summary.php'),(20784735,18815,'./!/application/views/appointments/summary.php'),(20785137,16587,'./!/application/views/county/add.php'),(20785136,16586,'./!/application/views/county/add.php'),(20785135,2702,'./!/application/views/county/add.php'),(20785134,16585,'./!/application/views/county/add.php'),(20785247,11014,'./!/application/views/customer/recent_invoices.php'),(20785724,19498,'./!/application/views/invcountbatch/enterCounts.php'),(20785147,16587,'./!/application/views/county/edit.php'),(20785146,16586,'./!/application/views/county/edit.php'),(20785145,2702,'./!/application/views/county/edit.php'),(20785144,16585,'./!/application/views/county/edit.php'),(20785143,1047,'./!/application/views/county/edit.php'),(20785158,16594,'./!/application/views/county/select.php'),(20785157,16593,'./!/application/views/county/select.php'),(20785156,2936,'./!/application/views/county/select.php'),(20785155,1047,'./!/application/views/county/select.php'),(20785154,5996,'./!/application/views/county/select.php'),(20785153,16592,'./!/application/views/county/select.php'),(20785152,941,'./!/application/views/county/select.php'),(20785151,15349,'./!/application/views/county/select.php'),(20785150,16591,'./!/application/views/county/select.php'),(20785149,5994,'./!/application/views/county/select.php'),(20785148,59,'./!/application/views/county/select.php'),(17644823,2985,'!/application/views/customer/hipaa_import_results.php'),(17644822,16598,'!/application/views/customer/hipaa_import_results.php'),(17644821,14976,'!/application/views/customer/hipaa_import_results.php'),(17644820,16597,'!/application/views/customer/hipaa_import_results.php'),(17644819,16596,'!/application/views/customer/hipaa_import_results.php'),(17644818,16595,'!/application/views/customer/hipaa_import_results.php'),(17644844,16605,'!/application/views/customer/hipaa_import_upload.php'),(17644843,16604,'!/application/views/customer/hipaa_import_upload.php'),(17644842,16603,'!/application/views/customer/hipaa_import_upload.php'),(17644841,2376,'!/application/views/customer/hipaa_import_upload.php'),(17644840,2103,'!/application/views/customer/hipaa_import_upload.php'),(17644839,16602,'!/application/views/customer/hipaa_import_upload.php'),(17644838,16601,'!/application/views/customer/hipaa_import_upload.php'),(17644837,1758,'!/application/views/customer/hipaa_import_upload.php'),(17644836,1685,'!/application/views/customer/hipaa_import_upload.php'),(17644835,15552,'!/application/views/customer/hipaa_import_upload.php'),(17644834,1429,'!/application/views/customer/hipaa_import_upload.php'),(17644833,16144,'!/application/views/customer/hipaa_import_upload.php'),(17644832,1047,'!/application/views/customer/hipaa_import_upload.php'),(17644831,982,'!/application/views/customer/hipaa_import_upload.php'),(17644830,741,'!/application/views/customer/hipaa_import_upload.php'),(17644829,16543,'!/application/views/customer/hipaa_import_upload.php'),(17644828,16600,'!/application/views/customer/hipaa_import_upload.php'),(17644827,14203,'!/application/views/customer/hipaa_import_upload.php'),(17644826,524,'!/application/views/customer/hipaa_import_upload.php'),(17644825,16599,'!/application/views/customer/hipaa_import_upload.php'),(17644824,59,'!/application/views/customer/hipaa_import_upload.php'),(20779647,1429,'./!/application/controllers/b2buser.php'),(20785555,13049,'./!/application/views/generic/select.php'),(20785696,3777,'./!/application/views/invcountbatch/create.php'),(20785673,16614,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785672,16613,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785671,16612,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785670,16611,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785669,16610,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785668,2516,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785667,2515,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785666,2044,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785665,10946,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785664,1893,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785663,1709,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785662,869,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785661,4973,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785660,16608,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785659,16515,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20785658,16607,'./!/application/views/invcotransfer/replenish_transfers_items_form.php'),(20793024,697,'./arinvoicereprint.php'),(20786431,2985,'./!/application/views/salestax/import_results.php'),(20786430,16620,'./!/application/views/salestax/import_results.php'),(20786429,16619,'./!/application/views/salestax/import_results.php'),(20786428,16598,'./!/application/views/salestax/import_results.php'),(20786427,14976,'./!/application/views/salestax/import_results.php'),(20787733,18411,'./adminarcompanyupd.php'),(20786459,8054,'./!/application/views/salestax/import_upload.php'),(20786458,3114,'./!/application/views/salestax/import_upload.php'),(20786457,16630,'./!/application/views/salestax/import_upload.php'),(20786456,3001,'./!/application/views/salestax/import_upload.php'),(20786455,16629,'./!/application/views/salestax/import_upload.php'),(20786454,16628,'./!/application/views/salestax/import_upload.php'),(20786453,16604,'./!/application/views/salestax/import_upload.php'),(20786452,2765,'./!/application/views/salestax/import_upload.php'),(20786451,14432,'./!/application/views/salestax/import_upload.php'),(20786450,16627,'./!/application/views/salestax/import_upload.php'),(20786449,2160,'./!/application/views/salestax/import_upload.php'),(20786448,2103,'./!/application/views/salestax/import_upload.php'),(20786447,1844,'./!/application/views/salestax/import_upload.php'),(20786446,15552,'./!/application/views/salestax/import_upload.php'),(20786445,19550,'./!/application/views/salestax/import_upload.php'),(20786444,7096,'./!/application/views/salestax/import_upload.php'),(20786443,7095,'./!/application/views/salestax/import_upload.php'),(20786715,16634,'./!/application/views/vendor/import_orderfrom_subform.php'),(20786714,16633,'./!/application/views/vendor/import_orderfrom_subform.php'),(20786713,16632,'./!/application/views/vendor/import_orderfrom_subform.php'),(20787420,19410,'./adminarcompanyupd.php'),(20787198,583,'./adminarcompanytaxupd.php'),(20787197,17392,'./adminarcompanytaxupd.php'),(20787418,1333,'./adminarcompanyupd.php'),(20787417,8936,'./adminarcompanyupd.php'),(20787416,8160,'./adminarcompanyupd.php'),(20787415,3600,'./adminarcompanyupd.php'),(20787958,2710,'./adminartaxexadd.php'),(20787957,2702,'./adminartaxexadd.php'),(20787956,18616,'./adminartaxexadd.php'),(20787970,855,'./adminartaxexupd.php'),(20787969,799,'./adminartaxexupd.php'),(20787968,18615,'./adminartaxexupd.php'),(20787967,315,'./adminartaxexupd.php'),(20793264,607,'./arinvoicestate.php'),(20792943,16326,'./arinvoicereppay.php'),(20792765,337,'./arinvoicepayvoid.php'),(20792764,315,'./arinvoicepayvoid.php'),(20792580,4481,'./arinvoicepay.php'),(20792579,6602,'./arinvoicepay.php'),(20792578,697,'./arinvoicepay.php'),(20792577,673,'./arinvoicepay.php'),(20791752,315,'./arcustb2buser.php'),(20791751,16652,'./arcustb2buser.php'),(20791750,7852,'./arcustb2buser.php'),(20791749,7115,'./arcustb2buser.php'),(20792102,5145,'./areft.php'),(20795151,542,'./arordshipadd.php'),(20795150,434,'./arordshipadd.php'),(20795377,441,'./arordshipview.php'),(20795376,18241,'./arordshipview.php'),(20795375,7749,'./arordshipview.php'),(20795374,5089,'./arordshipview.php'),(20796528,15349,'./autofunctions.php'),(20796527,9492,'./autofunctions.php'),(20796819,3523,'./checks_one.php'),(20800505,16167,'./glclose_month.php'),(20800544,16659,'./glclose_year.php'),(20800543,16658,'./glclose_year.php'),(20800542,6565,'./glclose_year.php'),(20800541,4697,'./glclose_year.php'),(20800827,85,'./gljouradd.php'),(20800826,20,'./gljouradd.php'),(20800825,16663,'./gljouradd.php'),(20800921,16022,'./gljourupd.php'),(20800920,87,'./gljourupd.php'),(20800919,42,'./gljourupd.php'),(20801101,325,'./glrepactivity.php'),(20801100,315,'./glrepactivity.php'),(20801099,198,'./glrepactivity.php'),(20801175,30,'./glrepbalance.php'),(20801174,27,'./glrepbalance.php'),(20801173,25,'./glrepbalance.php'),(20801172,16666,'./glrepbalance.php'),(20801211,197,'./glrepbalance_detail.php'),(20801210,30,'./glrepbalance_detail.php'),(20801209,27,'./glrepbalance_detail.php'),(20801208,16666,'./glrepbalance_detail.php'),(20801250,202,'./glrepbalance_summary.php'),(20801249,30,'./glrepbalance_summary.php'),(20801248,27,'./glrepbalance_summary.php'),(20801247,16666,'./glrepbalance_summary.php'),(20801330,197,'./glrepincome.php'),(20801329,27,'./glrepincome.php'),(20801328,20,'./glrepincome.php'),(20801327,16666,'./glrepincome.php'),(20801386,197,'./glrepincome_12month.php'),(20801385,27,'./glrepincome_12month.php'),(20801384,20,'./glrepincome_12month.php'),(20801383,16666,'./glrepincome_12month.php'),(20801428,197,'./glrepjournal.php'),(20801427,20,'./glrepjournal.php'),(20801426,16666,'./glrepjournal.php'),(20801713,14204,'./importbills.php'),(20801712,16039,'./importbills.php'),(20802065,737,'./importgljournals.php'),(20802241,7664,'./importitems.php'),(20802240,1424,'./importitems.php'),(20802239,7663,'./importitems.php'),(20802480,451,'./inv_report_common.inc'),(20802479,8185,'./inv_report_common.inc'),(20802478,197,'./inv_report_common.inc'),(20802585,13509,'./invcotransfer.php'),(20802584,1709,'./invcotransfer.php'),(20802583,16862,'./invcotransfer.php'),(20802582,13507,'./invcotransfer.php'),(20802581,5491,'./invcotransfer.php'),(20802580,13506,'./invcotransfer.php'),(20802579,13386,'./invcotransfer.php'),(20802578,13505,'./invcotransfer.php'),(20802577,13504,'./invcotransfer.php'),(20802658,567,'./inventory_adjustments.php'),(20803048,1519,'./invitemadd.php'),(20803047,1508,'./invitemadd.php'),(20803046,17752,'./invitemadd.php'),(20803045,1503,'./invitemadd.php'),(20803363,799,'./invitemcatupd.php'),(20803362,637,'./invitemcatupd.php'),(20803361,17816,'./invitemcatupd.php'),(20803360,596,'./invitemcatupd.php'),(20803606,16089,'./invitemlstreorder.php'),(20803605,8936,'./invitemlstreorder.php'),(20803604,941,'./invitemlstreorder.php'),(20803603,932,'./invitemlstreorder.php'),(20803602,16682,'./invitemlstreorder.php'),(20803601,869,'./invitemlstreorder.php'),(20803600,4764,'./invitemlstreorder.php'),(20803599,4973,'./invitemlstreorder.php'),(20803598,20240,'./invitemlstreorder.php'),(20803597,16681,'./invitemlstreorder.php'),(20803596,20238,'./invitemlstreorder.php'),(20803595,16680,'./invitemlstreorder.php'),(20803594,607,'./invitemlstreorder.php'),(20803593,572,'./invitemlstreorder.php'),(20804212,610,'./invitemupd.php'),(20804211,603,'./invitemupd.php'),(20804210,15564,'./invitemupd.php'),(20804209,17466,'./invitemupd.php'),(20804456,607,'./invitemvendupd.php'),(20804455,542,'./invitemvendupd.php'),(20804454,20136,'./invitemvendupd.php'),(20804453,315,'./invitemvendupd.php'),(20804452,5203,'./invitemvendupd.php'),(20804451,164,'./invitemvendupd.php'),(20804937,932,'./invporeturn.php'),(20805992,1427,'./nporder.php'),(20805991,14930,'./nporder.php'),(20805990,14929,'./nporder.php'),(20805989,11868,'./nporder.php'),(20805988,1373,'./nporder.php'),(20805987,18308,'./nporder.php'),(20805986,8998,'./nporder.php'),(20805985,18307,'./nporder.php'),(20805984,19214,'./nporder.php'),(20805983,11662,'./nporder.php'),(20805982,12750,'./nporder.php'),(20805981,9127,'./nporder.php'),(20806264,15812,'./npordermiscremote.php'),(20811239,5949,'./includes/apfunctions.php'),(20811635,605,'./includes/arfunctions.php'),(20812140,4265,'./includes/auto_complete_field_check.php'),(20781959,1606,'./!/application/controllers/itempricespecialchange.php'),(20812342,17792,'./includes/createmenu2.inc'),(20812341,81,'./includes/createmenu2.inc'),(20812340,7847,'./includes/createmenu2.inc'),(20814099,720,'./includes/genfunctions.php'),(20814098,14702,'./includes/genfunctions.php'),(20814327,11907,'./includes/glverifysetup_functions.php'),(20814326,10861,'./includes/glverifysetup_functions.php'),(20814325,14573,'./includes/glverifysetup_functions.php'),(20814575,941,'./includes/invfunctions.php'),(20814574,932,'./includes/invfunctions.php'),(17556268,768,'./install.php'),(20784734,16957,'./!/application/views/appointments/summary.php'),(20784733,16956,'./!/application/views/appointments/summary.php'),(20784732,2103,'./!/application/views/appointments/summary.php'),(20784731,16579,'./!/application/views/appointments/summary.php'),(20784730,17068,'./!/application/views/appointments/summary.php'),(20784729,8416,'./!/application/views/appointments/summary.php'),(20784728,6435,'./!/application/views/appointments/summary.php'),(20784727,16805,'./!/application/views/appointments/summary.php'),(20784726,1871,'./!/application/views/appointments/summary.php'),(20785210,2985,'./!/application/views/customer/patient_import_results.php'),(20785209,16598,'./!/application/views/customer/patient_import_results.php'),(20785208,14976,'./!/application/views/customer/patient_import_results.php'),(20785207,16597,'./!/application/views/customer/patient_import_results.php'),(20785739,18909,'./!/application/views/invcountbatch/liveCounts.php'),(20785586,16145,'./!/application/views/import_task/upload_form.php'),(20785585,5271,'./!/application/views/import_task/upload_form.php'),(20785584,16144,'./!/application/views/import_task/upload_form.php'),(20785230,16816,'./!/application/views/customer/patient_import_upload.php'),(20785227,16815,'./!/application/views/customer/patient_import_upload.php'),(20785229,16605,'./!/application/views/customer/patient_import_upload.php'),(20785228,16604,'./!/application/views/customer/patient_import_upload.php'),(20785226,2376,'./!/application/views/customer/patient_import_upload.php'),(20785225,16718,'./!/application/views/customer/patient_import_upload.php'),(20785224,2103,'./!/application/views/customer/patient_import_upload.php'),(20785223,16602,'./!/application/views/customer/patient_import_upload.php'),(20785222,16601,'./!/application/views/customer/patient_import_upload.php'),(20785221,1758,'./!/application/views/customer/patient_import_upload.php'),(20785220,15552,'./!/application/views/customer/patient_import_upload.php'),(20785219,1429,'./!/application/views/customer/patient_import_upload.php'),(20785218,16144,'./!/application/views/customer/patient_import_upload.php'),(20785217,1047,'./!/application/views/customer/patient_import_upload.php'),(20812155,13537,'./includes/autoupdate.php'),(20812339,7133,'./includes/createmenu2.inc'),(20812338,7132,'./includes/createmenu2.inc'),(20802760,8185,'./inventory_detail_pop.php'),(20778898,737,'./!/application/controllers/archive_reports.php'),(20779433,15941,'./!/application/controllers/arorder.php'),(20779959,3091,'./!/application/controllers/check.php'),(20779958,16754,'./!/application/controllers/check.php'),(20779957,6516,'./!/application/controllers/check.php'),(20779956,2260,'./!/application/controllers/check.php'),(20779955,5366,'./!/application/controllers/check.php'),(20779954,8912,'./!/application/controllers/check.php'),(20779953,2238,'./!/application/controllers/check.php'),(20779952,16753,'./!/application/controllers/check.php'),(20779951,2223,'./!/application/controllers/check.php'),(20779950,2208,'./!/application/controllers/check.php'),(20779949,16425,'./!/application/controllers/check.php'),(20779948,16459,'./!/application/controllers/check.php'),(20779947,2044,'./!/application/controllers/check.php'),(20779946,1963,'./!/application/controllers/check.php'),(20779945,1884,'./!/application/controllers/check.php'),(20779944,1692,'./!/application/controllers/check.php'),(20779943,1678,'./!/application/controllers/check.php'),(20779942,1672,'./!/application/controllers/check.php'),(20780311,18514,'./!/application/controllers/customer.php'),(20780310,15772,'./!/application/controllers/customer.php'),(20780309,5458,'./!/application/controllers/customer.php'),(20780308,15771,'./!/application/controllers/customer.php'),(20780307,3090,'./!/application/controllers/customer.php'),(20780306,17569,'./!/application/controllers/customer.php'),(20780305,15075,'./!/application/controllers/customer.php'),(20780304,17568,'./!/application/controllers/customer.php'),(20780303,17567,'./!/application/controllers/customer.php'),(20780302,17566,'./!/application/controllers/customer.php'),(20780301,17565,'./!/application/controllers/customer.php'),(20780300,3005,'./!/application/controllers/customer.php'),(20780299,17564,'./!/application/controllers/customer.php'),(20780298,2948,'./!/application/controllers/customer.php'),(20780297,9252,'./!/application/controllers/customer.php'),(20780296,8222,'./!/application/controllers/customer.php'),(20780295,6257,'./!/application/controllers/customer.php'),(20780294,2936,'./!/application/controllers/customer.php'),(20780293,3434,'./!/application/controllers/customer.php'),(20780292,19338,'./!/application/controllers/customer.php'),(20780291,15770,'./!/application/controllers/customer.php'),(20780290,15769,'./!/application/controllers/customer.php'),(20780289,2850,'./!/application/controllers/customer.php'),(20780288,19337,'./!/application/controllers/customer.php'),(20780287,2819,'./!/application/controllers/customer.php'),(20780286,2816,'./!/application/controllers/customer.php'),(20780285,6770,'./!/application/controllers/customer.php'),(20780284,17563,'./!/application/controllers/customer.php'),(20780283,17562,'./!/application/controllers/customer.php'),(20780281,15942,'./!/application/controllers/customer.php'),(20781119,19471,'./!/application/controllers/invcotransfer.php'),(20781118,19171,'./!/application/controllers/invcotransfer.php'),(20781117,19905,'./!/application/controllers/invcotransfer.php'),(20781116,19291,'./!/application/controllers/invcotransfer.php'),(20781114,16783,'./!/application/controllers/invcotransfer.php'),(20781310,2094,'./!/application/controllers/invcountbatch.php'),(20781179,11704,'./!/application/controllers/invcotransfershiprecv.php'),(20781178,3072,'./!/application/controllers/invcotransfershiprecv.php'),(20781177,16772,'./!/application/controllers/invcotransfershiprecv.php'),(20781176,2508,'./!/application/controllers/invcotransfershiprecv.php'),(20781174,1709,'./!/application/controllers/invcotransfershiprecv.php'),(20781173,16771,'./!/application/controllers/invcotransfershiprecv.php'),(20781172,1467,'./!/application/controllers/invcotransfershiprecv.php'),(20782821,2267,'./!/application/controllers/main.php'),(20782819,2258,'./!/application/controllers/main.php'),(20782818,19371,'./!/application/controllers/main.php'),(20782817,3722,'./!/application/controllers/main.php'),(20784079,16319,'./!/application/libraries/import_task.php'),(20784078,16318,'./!/application/libraries/import_task.php'),(20784077,2849,'./!/application/libraries/import_task.php'),(20784376,19037,'./!/application/models/invcotransfer_model.php'),(20784375,19171,'./!/application/models/invcotransfer_model.php'),(20784374,2827,'./!/application/models/invcotransfer_model.php'),(20784373,16787,'./!/application/models/invcotransfer_model.php'),(20784372,16767,'./!/application/models/invcotransfer_model.php'),(20784371,16786,'./!/application/models/invcotransfer_model.php'),(20784388,3072,'./!/application/models/invcotransfershiprecv_model.php'),(20784387,2044,'./!/application/models/invcotransfershiprecv_model.php'),(20784386,16898,'./!/application/models/invcotransfershiprecv_model.php'),(20784385,16793,'./!/application/models/invcotransfershiprecv_model.php'),(20784384,16792,'./!/application/models/invcotransfershiprecv_model.php'),(20784383,16791,'./!/application/models/invcotransfershiprecv_model.php'),(20784382,1467,'./!/application/models/invcotransfershiprecv_model.php'),(20784381,8936,'./!/application/models/invcotransfershiprecv_model.php'),(20784380,16790,'./!/application/models/invcotransfershiprecv_model.php'),(20784379,16516,'./!/application/models/invcotransfershiprecv_model.php'),(20784378,16897,'./!/application/models/invcotransfershiprecv_model.php'),(20784377,16788,'./!/application/models/invcotransfershiprecv_model.php'),(20784653,3948,'./!/application/views/appointments/printSummary.php'),(20784652,2801,'./!/application/views/appointments/printSummary.php'),(20784651,1788,'./!/application/views/appointments/printSummary.php'),(20784650,1560,'./!/application/views/appointments/printSummary.php'),(20784649,6478,'./!/application/views/appointments/printSummary.php'),(20784648,5583,'./!/application/views/appointments/printSummary.php'),(20784647,9842,'./!/application/views/appointments/printSummary.php'),(18467430,17033,'!/application/views/appointments/reportMembership.php'),(18467429,2948,'!/application/views/appointments/reportMembership.php'),(18467428,16802,'!/application/views/appointments/reportMembership.php'),(18467427,16801,'!/application/views/appointments/reportMembership.php'),(18467426,16800,'!/application/views/appointments/reportMembership.php'),(18467425,16799,'!/application/views/appointments/reportMembership.php'),(18467424,16798,'!/application/views/appointments/reportMembership.php'),(18467423,16797,'!/application/views/appointments/reportMembership.php'),(18467422,17032,'!/application/views/appointments/reportMembership.php'),(18467421,16796,'!/application/views/appointments/reportMembership.php'),(18467420,1446,'!/application/views/appointments/reportMembership.php'),(18467419,981,'!/application/views/appointments/reportMembership.php'),(18467418,16795,'!/application/views/appointments/reportMembership.php'),(18467434,3090,'!/application/views/appointments/reportReferrals.php'),(18467433,2626,'!/application/views/appointments/reportReferrals.php'),(18467432,16804,'!/application/views/appointments/reportReferrals.php'),(18467431,1446,'!/application/views/appointments/reportReferrals.php'),(18467443,16808,'!/application/views/appointments/reportSelections.php'),(18467442,16807,'!/application/views/appointments/reportSelections.php'),(18467441,8433,'!/application/views/appointments/reportSelections.php'),(18467440,16806,'!/application/views/appointments/reportSelections.php'),(18467439,16805,'!/application/views/appointments/reportSelections.php'),(18467438,1014,'!/application/views/appointments/reportSelections.php'),(18467437,573,'!/application/views/appointments/reportSelections.php'),(18467436,333,'!/application/views/appointments/reportSelections.php'),(18467435,202,'!/application/views/appointments/reportSelections.php'),(20784725,1821,'./!/application/views/appointments/summary.php'),(20784724,1788,'./!/application/views/appointments/summary.php'),(20784723,13334,'./!/application/views/appointments/summary.php'),(20784722,16720,'./!/application/views/appointments/summary.php'),(20784721,17062,'./!/application/views/appointments/summary.php'),(20784720,1749,'./!/application/views/appointments/summary.php'),(20784719,1747,'./!/application/views/appointments/summary.php'),(20784718,1741,'./!/application/views/appointments/summary.php'),(20784717,17061,'./!/application/views/appointments/summary.php'),(20784716,20030,'./!/application/views/appointments/summary.php'),(20784715,1560,'./!/application/views/appointments/summary.php'),(20784714,10520,'./!/application/views/appointments/summary.php'),(20784713,16955,'./!/application/views/appointments/summary.php'),(20784712,16719,'./!/application/views/appointments/summary.php'),(20784711,4440,'./!/application/views/appointments/summary.php'),(20784710,1375,'./!/application/views/appointments/summary.php'),(20784709,17041,'./!/application/views/appointments/summary.php'),(20784708,17040,'./!/application/views/appointments/summary.php'),(20784707,17039,'./!/application/views/appointments/summary.php'),(20784706,17038,'./!/application/views/appointments/summary.php'),(20784705,19754,'./!/application/views/appointments/summary.php'),(20784704,15970,'./!/application/views/appointments/summary.php'),(20784703,6478,'./!/application/views/appointments/summary.php'),(20784702,17037,'./!/application/views/appointments/summary.php'),(20784701,17036,'./!/application/views/appointments/summary.php'),(20784700,869,'./!/application/views/appointments/summary.php'),(20784699,16578,'./!/application/views/appointments/summary.php'),(20784698,18415,'./!/application/views/appointments/summary.php'),(20785204,16814,'./!/application/views/customer/import_shipto_subform.php'),(20785203,16632,'./!/application/views/customer/import_shipto_subform.php'),(20785721,13334,'./!/application/views/invcountbatch/enterCounts.php'),(20785723,15337,'./!/application/views/invcountbatch/enterCounts.php'),(20785722,1788,'./!/application/views/invcountbatch/enterCounts.php'),(20785626,16673,'./!/application/views/invcotransfer/dataTable_extra.php'),(20785625,11704,'./!/application/views/invcotransfer/dataTable_extra.php'),(20785624,2702,'./!/application/views/invcotransfer/dataTable_extra.php'),(20785623,16764,'./!/application/views/invcotransfer/dataTable_extra.php'),(20785622,1047,'./!/application/views/invcotransfer/dataTable_extra.php'),(20785621,416,'./!/application/views/invcotransfer/dataTable_extra.php'),(20785620,10861,'./!/application/views/invcotransfer/dataTable_extra.php'),(20785868,11761,'./!/application/views/job/batch_send_prelim_request_select.php'),(20785856,3319,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785855,16824,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785854,16823,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785853,4608,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785852,2099,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785851,16822,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785850,14682,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785849,16821,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785848,16777,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20786015,697,'./!/application/views/meta_menu/arorder.php'),(20786014,355,'./!/application/views/meta_menu/arorder.php'),(20786099,16827,'./!/application/views/meta_menu/gltransvoucher.php'),(20786098,16826,'./!/application/views/meta_menu/gltransvoucher.php'),(20786422,16841,'./!/application/views/salestax/conflict.php'),(20786421,16840,'./!/application/views/salestax/conflict.php'),(20786420,16839,'./!/application/views/salestax/conflict.php'),(20786419,16838,'./!/application/views/salestax/conflict.php'),(20786418,16837,'./!/application/views/salestax/conflict.php'),(20786417,16836,'./!/application/views/salestax/conflict.php'),(20786416,16835,'./!/application/views/salestax/conflict.php'),(20786415,2821,'./!/application/views/salestax/conflict.php'),(20786414,16834,'./!/application/views/salestax/conflict.php'),(20786413,16833,'./!/application/views/salestax/conflict.php'),(20786412,16832,'./!/application/views/salestax/conflict.php'),(20786411,6591,'./!/application/views/salestax/conflict.php'),(20786410,2099,'./!/application/views/salestax/conflict.php'),(20786409,16831,'./!/application/views/salestax/conflict.php'),(20786408,16830,'./!/application/views/salestax/conflict.php'),(20786407,697,'./!/application/views/salestax/conflict.php'),(20786406,16829,'./!/application/views/salestax/conflict.php'),(20786405,607,'./!/application/views/salestax/conflict.php'),(20786404,16828,'./!/application/views/salestax/conflict.php'),(20787955,16642,'./adminartaxexadd.php'),(20787966,5203,'./adminartaxexupd.php'),(20789315,59,'./adminprpens.php'),(20790015,6134,'./apbill_preapprove.php'),(20790807,85,'./apmanualcheck.php'),(20790806,6050,'./apmanualcheck.php'),(20791984,167,'./arcustupd.php'),(20792191,9828,'./arinvoiceadd.php'),(20792190,15897,'./arinvoiceadd.php'),(20792763,5351,'./arinvoicepayvoid.php'),(20792898,607,'./arinvoicerepcust.php'),(20794031,1781,'./arordconfirmfpdf.php'),(20671606,197,'./arorderconfirm.php'),(20794441,16849,'./arorderlist.php'),(20794440,197,'./arorderlist.php'),(20794439,14774,'./arorderlist.php'),(20794528,6757,'./arorderlist_backorder.php'),(20671895,16849,'./arorderlist_group.php'),(20671894,197,'./arorderlist_group.php'),(20794576,12156,'./arorderlist_sum.php'),(20794614,197,'./arorderlistreceive.php'),(20794695,197,'./arorderlistvoid.php'),(20794774,197,'./arorderquotelist.php'),(20795022,981,'./arordpicktickfpdf.php'),(20800266,430,'./gl_export_report.php'),(20800869,7529,'./gljournalpdf.php'),(20801098,197,'./glrepactivity.php'),(20801769,9357,'./importccpurchases.php'),(20801768,315,'./importccpurchases.php'),(20801767,226,'./importccpurchases.php'),(20801766,20,'./importccpurchases.php'),(20801985,226,'./importemployeeexpenses.php'),(20802164,16122,'./importinvoices.php'),(20802576,19275,'./invcotransfer.php'),(20802575,1467,'./invcotransfer.php'),(20802574,8936,'./invcotransfer.php'),(20802573,1014,'./invcotransfer.php'),(20802572,981,'./invcotransfer.php'),(20802571,941,'./invcotransfer.php'),(20802570,932,'./invcotransfer.php'),(20802569,869,'./invcotransfer.php'),(20802568,5205,'./invcotransfer.php'),(20802567,799,'./invcotransfer.php'),(20802566,13483,'./invcotransfer.php'),(20802565,5101,'./invcotransfer.php'),(20802564,744,'./invcotransfer.php'),(20802563,739,'./invcotransfer.php'),(20802562,697,'./invcotransfer.php'),(20802561,5403,'./invcotransfer.php'),(20802758,7794,'./inventory_detail_pop.php'),(20802905,1428,'./invexportimportcsv.php'),(20802904,8936,'./invexportimportcsv.php'),(20802903,886,'./invexportimportcsv.php'),(20803152,458,'./invitemadd1.php'),(20803151,315,'./invitemadd1.php'),(20803150,197,'./invitemadd1.php'),(20803359,9906,'./invitemcatupd.php'),(20803358,9905,'./invitemcatupd.php'),(20803981,665,'./invitemprices.php'),(20803980,616,'./invitemprices.php'),(20803979,573,'./invitemprices.php'),(20803978,451,'./invitemprices.php'),(20804027,4142,'./invitemrecadd.php'),(20804079,1280,'./invitemreclist.php'),(20804208,572,'./invitemupd.php'),(20804207,541,'./invitemupd.php'),(20804206,6156,'./invitemupd.php'),(20804205,451,'./invitemupd.php'),(20804381,19143,'./invitemupd1.php'),(20804380,5203,'./invitemupd1.php'),(20804883,18004,'./invporecv.php'),(20805980,16413,'./nporder.php'),(20805979,14928,'./nporder.php'),(20805978,8936,'./nporder.php'),(20805977,15346,'./nporder.php'),(20805976,15345,'./nporder.php'),(20805975,1047,'./nporder.php'),(20805974,6116,'./nporder.php'),(20805973,1036,'./nporder.php'),(20805972,14526,'./nporder.php'),(20805971,981,'./nporder.php'),(20805970,6115,'./nporder.php'),(20805969,7877,'./nporder.php'),(20805968,7874,'./nporder.php'),(20805967,941,'./nporder.php'),(20805966,932,'./nporder.php'),(20805965,931,'./nporder.php'),(20805964,16656,'./nporder.php'),(20806309,6776,'./nporderpayment.php'),(20806308,6775,'./nporderpayment.php'),(20806307,5912,'./nporderpayment.php'),(20806472,6430,'./npordersave.php'),(20806471,19788,'./npordersave.php'),(20806470,16886,'./npordersave.php'),(20806469,19787,'./npordersave.php'),(20806468,19786,'./npordersave.php'),(20806467,19785,'./npordersave.php'),(20806466,19865,'./npordersave.php'),(20806465,19864,'./npordersave.php'),(20806464,18048,'./npordersave.php'),(20806463,13880,'./npordersave.php'),(20811140,6144,'./voucherdetail.php'),(20812315,6523,'./includes/content_top.php'),(20812337,7846,'./includes/createmenu2.inc'),(20812336,7845,'./includes/createmenu2.inc'),(20813862,13163,'./includes/functions.php'),(20813861,2192,'./includes/functions.php'),(20813860,2182,'./includes/functions.php'),(20814097,7458,'./includes/genfunctions.php'),(20815296,18333,'./includes/classes/nptax.php'),(20782072,798,'./!/application/controllers/job.php'),(20782813,18382,'./!/application/controllers/main.php'),(20782816,18140,'./!/application/controllers/main.php'),(20782815,4616,'./!/application/controllers/main.php'),(20782814,3720,'./!/application/controllers/main.php'),(20784404,18841,'./!/application/models/invpo_model.php'),(17998920,4265,'!/application/views/contact/import.php'),(17998921,2936,'!/application/views/contact/import.php'),(17998922,3274,'!/application/views/contact/import.php'),(17998923,3432,'!/application/views/contact/import.php'),(20790114,346,'./apbilladd.php'),(20790113,315,'./apbilladd.php'),(20796789,6499,'./checks.php'),(20804698,1276,'./invpoadd.php'),(20804697,1218,'./invpoadd.php'),(20804696,8936,'./invpoadd.php'),(20804695,5578,'./invpoadd.php'),(20804694,981,'./invpoadd.php'),(20805107,16907,'./invpotocc.php'),(20805106,8647,'./invpotocc.php'),(20805105,315,'./invpotocc.php'),(20805963,20252,'./nporder.php'),(20805962,8904,'./nporder.php'),(20811238,5948,'./includes/apfunctions.php'),(20811237,354,'./includes/apfunctions.php'),(20811236,13994,'./includes/apfunctions.php'),(20811235,7084,'./includes/apfunctions.php'),(20813859,13978,'./includes/functions.php'),(20813858,13977,'./includes/functions.php'),(20813857,13976,'./includes/functions.php'),(20779710,5068,'./!/application/controllers/bankrec.php'),(20779709,2802,'./!/application/controllers/bankrec.php'),(20779708,11919,'./!/application/controllers/bankrec.php'),(20779707,1014,'./!/application/controllers/bankrec.php'),(20779706,1022,'./!/application/controllers/bankrec.php'),(20779705,16913,'./!/application/controllers/bankrec.php'),(20779704,17164,'./!/application/controllers/bankrec.php'),(20779703,197,'./!/application/controllers/bankrec.php'),(20779702,20,'./!/application/controllers/bankrec.php'),(20779985,2324,'./!/application/controllers/contact.php'),(20779984,2094,'./!/application/controllers/contact.php'),(20779983,1770,'./!/application/controllers/contact.php'),(20779982,1758,'./!/application/controllers/contact.php'),(20779981,1429,'./!/application/controllers/contact.php'),(20779980,981,'./!/application/controllers/contact.php'),(20779979,869,'./!/application/controllers/contact.php'),(20779978,4481,'./!/application/controllers/contact.php'),(20779977,16915,'./!/application/controllers/contact.php'),(20779976,8730,'./!/application/controllers/contact.php'),(20779975,16914,'./!/application/controllers/contact.php'),(20779974,6228,'./!/application/controllers/contact.php'),(20779973,697,'./!/application/controllers/contact.php'),(20779972,541,'./!/application/controllers/contact.php'),(20779971,524,'./!/application/controllers/contact.php'),(20779970,15922,'./!/application/controllers/contact.php'),(20779969,9624,'./!/application/controllers/contact.php'),(20782812,12175,'./!/application/controllers/main.php'),(20782811,13318,'./!/application/controllers/main.php'),(20782810,14533,'./!/application/controllers/main.php'),(20782808,4609,'./!/application/controllers/main.php'),(20785177,16731,'./!/application/views/customer/appointment_report.php'),(20785740,1647,'./!/application/views/invcountbatch/liveCounts.php'),(20785176,16925,'./!/application/views/customer/appointment_report.php'),(20785175,3948,'./!/application/views/customer/appointment_report.php'),(20785174,2948,'./!/application/views/customer/appointment_report.php'),(20785173,5068,'./!/application/views/customer/appointment_report.php'),(20785172,2801,'./!/application/views/customer/appointment_report.php'),(20785171,2292,'./!/application/views/customer/appointment_report.php'),(20785170,4608,'./!/application/views/customer/appointment_report.php'),(20785169,16924,'./!/application/views/customer/appointment_report.php'),(20785168,16923,'./!/application/views/customer/appointment_report.php'),(20785738,19360,'./!/application/views/invcountbatch/liveCounts.php'),(20785188,16928,'./!/application/views/customer/appointment_report_select.php'),(20785187,3434,'./!/application/views/customer/appointment_report_select.php'),(20785186,2801,'./!/application/views/customer/appointment_report_select.php'),(20785182,1014,'./!/application/views/customer/appointment_report_select.php'),(20785183,16927,'./!/application/views/customer/appointment_report_select.php'),(20785184,1560,'./!/application/views/customer/appointment_report_select.php'),(20790014,6165,'./apbill_preapprove.php'),(20790107,3274,'./apbill_preapprove_report.php'),(20790106,2985,'./apbill_preapprove_report.php'),(20790105,6657,'./apbill_preapprove_report.php'),(20790104,6656,'./apbill_preapprove_report.php'),(20790103,16931,'./apbill_preapprove_report.php'),(20790102,2225,'./apbill_preapprove_report.php'),(20790101,1963,'./apbill_preapprove_report.php'),(20790100,1884,'./apbill_preapprove_report.php'),(20790099,1668,'./apbill_preapprove_report.php'),(20790098,1558,'./apbill_preapprove_report.php'),(20790097,8936,'./apbill_preapprove_report.php'),(20790096,932,'./apbill_preapprove_report.php'),(20790095,931,'./apbill_preapprove_report.php'),(20790094,13668,'./apbill_preapprove_report.php'),(20790093,886,'./apbill_preapprove_report.php'),(20790092,4602,'./apbill_preapprove_report.php'),(20790091,6648,'./apbill_preapprove_report.php'),(20790090,504,'./apbill_preapprove_report.php'),(20790089,17199,'./apbill_preapprove_report.php'),(20790088,13077,'./apbill_preapprove_report.php'),(20790296,445,'./apbillpay.php'),(20791408,5898,'./arbankreconcile.php'),(20791407,5430,'./arbankreconcile.php'),(20791406,315,'./arbankreconcile.php'),(20791405,4871,'./arbankreconcile.php'),(20803044,6375,'./invitemadd.php'),(20804204,13930,'./invitemupd.php'),(20812335,7844,'./includes/createmenu2.inc'),(20812334,3524,'./includes/createmenu2.inc'),(20812333,3523,'./includes/createmenu2.inc'),(20812332,15367,'./includes/createmenu2.inc'),(20812331,15752,'./includes/createmenu2.inc'),(20812330,7842,'./includes/createmenu2.inc'),(20812329,12923,'./includes/createmenu2.inc'),(20812328,12826,'./includes/createmenu2.inc'),(20813475,15241,'./includes/feature_exp_notice.php'),(20813474,12685,'./includes/feature_exp_notice.php'),(20813473,15240,'./includes/feature_exp_notice.php'),(20781521,3421,'./!/application/controllers/invpo.php'),(20781520,18358,'./!/application/controllers/invpo.php'),(20781709,18915,'./!/application/controllers/item.php'),(20782809,6754,'./!/application/controllers/main.php'),(20785800,16940,'./!/application/views/invpo/proposal_management.php'),(20785799,2622,'./!/application/views/invpo/proposal_management.php'),(20796788,226,'./checks.php'),(20802902,17422,'./invexportimportcsv.php'),(20802901,8185,'./invexportimportcsv.php'),(20811234,5947,'./includes/apfunctions.php'),(20811233,5939,'./includes/apfunctions.php'),(20811232,7083,'./includes/apfunctions.php'),(20811231,5433,'./includes/apfunctions.php'),(20811230,315,'./includes/apfunctions.php'),(20782807,5677,'./!/application/controllers/main.php'),(20782806,7163,'./!/application/controllers/main.php'),(20782805,7162,'./!/application/controllers/main.php'),(20782803,7744,'./!/application/controllers/main.php'),(20783570,16952,'./!/application/controllers/shopify.php'),(20784697,778,'./!/application/views/appointments/summary.php'),(20784696,19830,'./!/application/views/appointments/summary.php'),(20784695,19829,'./!/application/views/appointments/summary.php'),(20784694,19828,'./!/application/views/appointments/summary.php'),(20784693,16577,'./!/application/views/appointments/summary.php'),(20784692,541,'./!/application/views/appointments/summary.php'),(20784691,5583,'./!/application/views/appointments/summary.php'),(20784690,16714,'./!/application/views/appointments/summary.php'),(20784689,16713,'./!/application/views/appointments/summary.php'),(20784688,16712,'./!/application/views/appointments/summary.php'),(20785165,5074,'./!/application/views/customer/appointment_report.php'),(20785166,605,'./!/application/views/customer/appointment_report.php'),(20785167,16913,'./!/application/views/customer/appointment_report.php'),(20792944,5354,'./arinvoicereppay.php'),(20786559,17375,'./!/application/views/shopify/admin_select_store.php'),(20792942,6722,'./arinvoicereppay.php'),(20786540,17735,'./!/application/views/shopify/admin.php'),(20786539,17373,'./!/application/views/shopify/admin.php'),(20786538,17372,'./!/application/views/shopify/admin.php'),(20786537,16998,'./!/application/views/shopify/admin.php'),(20786536,17371,'./!/application/views/shopify/admin.php'),(20786535,3310,'./!/application/views/shopify/admin.php'),(20786534,16997,'./!/application/views/shopify/admin.php'),(20786533,17993,'./!/application/views/shopify/admin.php'),(20786532,3186,'./!/application/views/shopify/admin.php'),(20786531,3134,'./!/application/views/shopify/admin.php'),(20786530,16994,'./!/application/views/shopify/admin.php'),(20786529,17370,'./!/application/views/shopify/admin.php'),(20786528,16993,'./!/application/views/shopify/admin.php'),(20786527,16992,'./!/application/views/shopify/admin.php'),(20786526,16991,'./!/application/views/shopify/admin.php'),(20786525,17992,'./!/application/views/shopify/admin.php'),(20786524,17991,'./!/application/views/shopify/admin.php'),(20786523,16990,'./!/application/views/shopify/admin.php'),(20786522,16986,'./!/application/views/shopify/admin.php'),(20786521,17486,'./!/application/views/shopify/admin.php'),(20786520,2234,'./!/application/views/shopify/admin.php'),(20786519,4608,'./!/application/views/shopify/admin.php'),(20786518,11879,'./!/application/views/shopify/admin.php'),(20786517,16980,'./!/application/views/shopify/admin.php'),(20786516,16979,'./!/application/views/shopify/admin.php'),(20786515,7188,'./!/application/views/shopify/admin.php'),(20786514,17369,'./!/application/views/shopify/admin.php'),(20786513,1047,'./!/application/views/shopify/admin.php'),(20786512,16976,'./!/application/views/shopify/admin.php'),(20786511,17368,'./!/application/views/shopify/admin.php'),(20786510,799,'./!/application/views/shopify/admin.php'),(20786509,17341,'./!/application/views/shopify/admin.php'),(20786508,5759,'./!/application/views/shopify/admin.php'),(20786507,17340,'./!/application/views/shopify/admin.php'),(20786506,9438,'./!/application/views/shopify/admin.php'),(20786505,17339,'./!/application/views/shopify/admin.php'),(20786504,17367,'./!/application/views/shopify/admin.php'),(20786503,5727,'./!/application/views/shopify/admin.php'),(20786502,8194,'./!/application/views/shopify/admin.php'),(20786501,17336,'./!/application/views/shopify/admin.php'),(20786500,13998,'./!/application/views/shopify/admin.php'),(20786499,15354,'./!/application/views/shopify/admin.php'),(20786498,16971,'./!/application/views/shopify/admin.php'),(20786497,541,'./!/application/views/shopify/admin.php'),(20786496,16970,'./!/application/views/shopify/admin.php'),(20786495,16968,'./!/application/views/shopify/admin.php'),(20786494,16967,'./!/application/views/shopify/admin.php'),(20786493,16966,'./!/application/views/shopify/admin.php'),(20786492,16965,'./!/application/views/shopify/admin.php'),(20786491,16964,'./!/application/views/shopify/admin.php'),(20786490,16963,'./!/application/views/shopify/admin.php'),(20786558,4608,'./!/application/views/shopify/admin_select_store.php'),(20792666,7120,'./arinvoicepayreceipt.php'),(20786556,16998,'./!/application/views/shopify/admin_add_store.php'),(20786555,3310,'./!/application/views/shopify/admin_add_store.php'),(20786554,2975,'./!/application/views/shopify/admin_add_store.php'),(20786553,17370,'./!/application/views/shopify/admin_add_store.php'),(20786552,16991,'./!/application/views/shopify/admin_add_store.php'),(20786551,2234,'./!/application/views/shopify/admin_add_store.php'),(20786550,4608,'./!/application/views/shopify/admin_add_store.php'),(20786549,11879,'./!/application/views/shopify/admin_add_store.php'),(20790013,504,'./apbill_preapprove.php'),(20790385,892,'./apbillpay_preapproved.php'),(20790384,886,'./apbillpay_preapproved.php'),(20790383,6053,'./apbillpay_preapproved.php'),(20790382,607,'./apbillpay_preapproved.php'),(20790381,9371,'./apbillpay_preapproved.php'),(20790380,17465,'./apbillpay_preapproved.php'),(20790379,17065,'./apbillpay_preapproved.php'),(20790378,6134,'./apbillpay_preapproved.php'),(20791072,315,'./apvendoractivity.php'),(20791104,15722,'./apvendupd.php'),(20796323,17008,'./arservicetypeadd.php'),(20796322,315,'./arservicetypeadd.php'),(20796321,176,'./arservicetypeadd.php'),(20796335,5203,'./arservicetypeupd.php'),(20796334,111,'./arservicetypeupd.php'),(20796333,59,'./arservicetypeupd.php'),(20803043,1482,'./invitemadd.php'),(20804203,6076,'./invitemupd.php'),(20807933,315,'./prchecksumgroup.php'),(20807932,197,'./prchecksumgroup.php'),(20807931,7464,'./prchecksumgroup.php'),(20808257,7049,'./prempllist.php'),(20808256,185,'./prempllist.php'),(20808780,15675,'./prloghours.php'),(20808779,412,'./prloghours.php'),(20808778,408,'./prloghours.php'),(20808777,17014,'./prloghours.php'),(20808776,315,'./prloghours.php'),(20808775,207,'./prloghours.php'),(20808774,205,'./prloghours.php'),(20808773,15426,'./prloghours.php'),(20808772,15427,'./prloghours.php'),(20810791,59,'./taskuser.php'),(20814573,8071,'./includes/invfunctions.php'),(20815174,19873,'./includes/tamg.php'),(20787414,20222,'./adminarcompanyupd.php'),(20790012,501,'./apbill_preapprove.php'),(20790011,315,'./apbill_preapprove.php'),(20790010,3455,'./apbill_preapprove.php'),(20790009,15698,'./apbill_preapprove.php'),(20790008,6646,'./apbill_preapprove.php'),(20790007,16929,'./apbill_preapprove.php'),(20782804,3718,'./!/application/controllers/main.php'),(20782802,2200,'./!/application/controllers/main.php'),(20782800,12158,'./!/application/controllers/main.php'),(20784419,8010,'./!/application/models/itempricespecial_model.php'),(20784420,19745,'./!/application/models/itempricespecial_model.php'),(20783221,17030,'./!/application/controllers/priceoverriderequest.php'),(20783220,17029,'./!/application/controllers/priceoverriderequest.php'),(20783219,17028,'./!/application/controllers/priceoverriderequest.php'),(20783218,17027,'./!/application/controllers/priceoverriderequest.php'),(20783217,2948,'./!/application/controllers/priceoverriderequest.php'),(20783216,17026,'./!/application/controllers/priceoverriderequest.php'),(20783215,2702,'./!/application/controllers/priceoverriderequest.php'),(20783214,18535,'./!/application/controllers/priceoverriderequest.php'),(20783213,18534,'./!/application/controllers/priceoverriderequest.php'),(20783212,17025,'./!/application/controllers/priceoverriderequest.php'),(20783211,17023,'./!/application/controllers/priceoverriderequest.php'),(20783210,17022,'./!/application/controllers/priceoverriderequest.php'),(18467417,5583,'!/application/views/appointments/reportMembership.php'),(20784687,19753,'./!/application/views/appointments/summary.php'),(20784686,19752,'./!/application/views/appointments/summary.php'),(20784685,16711,'./!/application/views/appointments/summary.php'),(20784684,16811,'./!/application/views/appointments/summary.php'),(20784683,17091,'./!/application/views/appointments/summary.php'),(20784682,17060,'./!/application/views/appointments/summary.php'),(20784681,416,'./!/application/views/appointments/summary.php'),(20784680,16723,'./!/application/views/appointments/summary.php'),(20784679,19633,'./!/application/views/appointments/summary.php'),(20786275,2948,'./!/application/views/priceoverriderequest/edit.php'),(20786274,13932,'./!/application/views/priceoverriderequest/edit.php'),(20786273,17026,'./!/application/views/priceoverriderequest/edit.php'),(20786272,17046,'./!/application/views/priceoverriderequest/edit.php'),(20786271,17045,'./!/application/views/priceoverriderequest/edit.php'),(20786270,17044,'./!/application/views/priceoverriderequest/edit.php'),(20786269,2494,'./!/application/views/priceoverriderequest/edit.php'),(20786268,17022,'./!/application/views/priceoverriderequest/edit.php'),(20786267,2404,'./!/application/views/priceoverriderequest/edit.php'),(20786266,19223,'./!/application/views/priceoverriderequest/edit.php'),(20786265,14575,'./!/application/views/priceoverriderequest/edit.php'),(20786288,17026,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786287,17046,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786286,17045,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786285,17044,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786284,20041,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786283,17022,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786282,14575,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786281,2103,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786280,17043,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786279,17042,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786278,10081,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786277,4646,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20790766,265,'./apchecklist.php'),(20805961,14069,'./nporder.php'),(20805960,869,'./nporder.php'),(20805959,10253,'./nporder.php'),(20805958,9139,'./nporder.php'),(20805957,4761,'./nporder.php'),(20805956,5205,'./nporder.php'),(20805955,799,'./nporder.php'),(20812314,1546,'./includes/content_top.php'),(20814096,659,'./includes/genfunctions.php'),(20814095,14701,'./includes/genfunctions.php'),(20814094,605,'./includes/genfunctions.php'),(20784678,16576,'./!/application/views/appointments/summary.php'),(20784677,17059,'./!/application/views/appointments/summary.php'),(20784676,17035,'./!/application/views/appointments/summary.php'),(20784675,17034,'./!/application/views/appointments/summary.php'),(20784674,19751,'./!/application/views/appointments/summary.php'),(20784673,19632,'./!/application/views/appointments/summary.php'),(20784672,308,'./!/application/views/appointments/summary.php'),(20784671,302,'./!/application/views/appointments/summary.php'),(20784670,20029,'./!/application/views/appointments/summary.php'),(20784669,17058,'./!/application/views/appointments/summary.php'),(20784668,16954,'./!/application/views/appointments/summary.php'),(20784667,275,'./!/application/views/appointments/summary.php'),(20790006,5095,'./apbill_preapprove.php'),(20790087,10004,'./apbill_preapprove_report.php'),(20790086,16929,'./apbill_preapprove_report.php'),(20790112,12140,'./apbilladd.php'),(20790111,226,'./apbilladd.php'),(20790377,491,'./apbillpay_preapproved.php'),(20790376,5390,'./apbillpay_preapproved.php'),(20790375,6165,'./apbillpay_preapproved.php'),(20790374,12191,'./apbillpay_preapproved.php'),(20790463,484,'./apbillupd.php'),(20790462,4000,'./apbillupd.php'),(20791103,15041,'./apvendupd.php'),(20796787,29,'./checks.php'),(20801711,17750,'./importbills.php'),(20801710,9492,'./importbills.php'),(20801709,18131,'./importbills.php'),(20801708,14203,'./importbills.php'),(20811229,17856,'./includes/apfunctions.php'),(20813539,18880,'./includes/filesystemdb.php'),(20813538,11940,'./includes/filesystemdb.php'),(20778811,491,'./!/application/controllers/apbill.php'),(20778810,226,'./!/application/controllers/apbill.php'),(20779893,3421,'./!/application/controllers/ccterminal.php'),(20779892,17521,'./!/application/controllers/ccterminal.php'),(20779891,17520,'./!/application/controllers/ccterminal.php'),(20779890,17519,'./!/application/controllers/ccterminal.php'),(20779889,18168,'./!/application/controllers/ccterminal.php'),(20779888,17078,'./!/application/controllers/ccterminal.php'),(20779887,17518,'./!/application/controllers/ccterminal.php'),(20779886,2948,'./!/application/controllers/ccterminal.php'),(20779885,18804,'./!/application/controllers/ccterminal.php'),(20779884,17517,'./!/application/controllers/ccterminal.php'),(20779883,6085,'./!/application/controllers/ccterminal.php'),(20779882,17516,'./!/application/controllers/ccterminal.php'),(20779881,17515,'./!/application/controllers/ccterminal.php'),(20779902,3252,'./!/application/controllers/ccterminallog.php'),(20779901,17078,'./!/application/controllers/ccterminallog.php'),(20779900,4329,'./!/application/controllers/ccterminallog.php'),(20779899,4915,'./!/application/controllers/ccterminallog.php'),(20779898,1578,'./!/application/controllers/ccterminallog.php'),(20782352,3072,'./!/application/controllers/maillog.php'),(20782351,2948,'./!/application/controllers/maillog.php'),(20782350,4457,'./!/application/controllers/maillog.php'),(20782349,17082,'./!/application/controllers/maillog.php'),(20782348,17081,'./!/application/controllers/maillog.php'),(20782347,17080,'./!/application/controllers/maillog.php'),(20782346,17079,'./!/application/controllers/maillog.php'),(20782345,1467,'./!/application/controllers/maillog.php'),(20782344,1013,'./!/application/controllers/maillog.php'),(20782343,4602,'./!/application/controllers/maillog.php'),(20782342,737,'./!/application/controllers/maillog.php'),(20782801,8991,'./!/application/controllers/main.php'),(20783819,15612,'./!/application/controllers/vendor.php'),(20783818,1539,'./!/application/controllers/vendor.php'),(20783817,1429,'./!/application/controllers/vendor.php'),(20783816,1381,'./!/application/controllers/vendor.php'),(20783815,15976,'./!/application/controllers/vendor.php'),(20783814,20010,'./!/application/controllers/vendor.php'),(20783813,1373,'./!/application/controllers/vendor.php'),(20783812,10384,'./!/application/controllers/vendor.php'),(20784014,4023,'./!/application/libraries/PaxTerminal.php'),(20784204,479,'./!/application/model_collections/check_collection.php'),(20784203,3457,'./!/application/model_collections/check_collection.php'),(20784202,446,'./!/application/model_collections/check_collection.php'),(20784201,445,'./!/application/model_collections/check_collection.php'),(20784460,6964,'./!/application/models/threedcart_model.php'),(20784459,6318,'./!/application/models/threedcart_model.php'),(20784458,4865,'./!/application/models/threedcart_model.php'),(20784457,8273,'./!/application/models/threedcart_model.php'),(20784456,886,'./!/application/models/threedcart_model.php'),(20784455,10253,'./!/application/models/threedcart_model.php'),(20785107,14607,'./!/application/views/chunks/ui_style_properties.php'),(20784635,16731,'./!/application/views/appointments/appointment_report.php'),(20784634,16925,'./!/application/views/appointments/appointment_report.php'),(20784633,3948,'./!/application/views/appointments/appointment_report.php'),(20784632,2948,'./!/application/views/appointments/appointment_report.php'),(20784631,5068,'./!/application/views/appointments/appointment_report.php'),(20784630,2801,'./!/application/views/appointments/appointment_report.php'),(20784629,2292,'./!/application/views/appointments/appointment_report.php'),(20784628,4608,'./!/application/views/appointments/appointment_report.php'),(20784627,16924,'./!/application/views/appointments/appointment_report.php'),(20784626,16923,'./!/application/views/appointments/appointment_report.php'),(20784625,15970,'./!/application/views/appointments/appointment_report.php'),(20784624,16913,'./!/application/views/appointments/appointment_report.php'),(20784623,605,'./!/application/views/appointments/appointment_report.php'),(20784622,5074,'./!/application/views/appointments/appointment_report.php'),(20785760,1696,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20784646,16928,'./!/application/views/appointments/appointment_report_select.php'),(20784645,3434,'./!/application/views/appointments/appointment_report_select.php'),(20784644,2801,'./!/application/views/appointments/appointment_report_select.php'),(20784640,1014,'./!/application/views/appointments/appointment_report_select.php'),(20784641,16927,'./!/application/views/appointments/appointment_report_select.php'),(20784642,1560,'./!/application/views/appointments/appointment_report_select.php'),(20784666,17057,'./!/application/views/appointments/summary.php'),(20785084,17078,'./!/application/views/ccterminal/selectTerminal.php'),(20785083,2948,'./!/application/views/ccterminal/selectTerminal.php'),(20785082,17093,'./!/application/views/ccterminal/selectTerminal.php'),(20785081,2751,'./!/application/views/ccterminal/selectTerminal.php'),(20785080,17092,'./!/application/views/ccterminal/selectTerminal.php'),(20785079,1597,'./!/application/views/ccterminal/selectTerminal.php'),(20785078,17575,'./!/application/views/ccterminal/selectTerminal.php'),(20785758,882,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20785087,2751,'./!/application/views/ccterminal/selectedTerminalDetails.php'),(20785086,17095,'./!/application/views/ccterminal/selectedTerminalDetails.php'),(20785989,3072,'./!/application/views/maillog/review.php'),(20786441,1047,'./!/application/views/salestax/import_upload.php'),(20785988,3477,'./!/application/views/maillog/review.php'),(20785987,17096,'./!/application/views/maillog/review.php'),(20785986,1880,'./!/application/views/maillog/review.php'),(20787413,20060,'./adminarcompanyupd.php'),(20787412,20059,'./adminarcompanyupd.php'),(20787411,19522,'./adminarcompanyupd.php'),(20788176,17102,'./admineftdownload.php'),(20788175,17101,'./admineftdownload.php'),(20788174,17100,'./admineftdownload.php'),(20788177,20,'./admineftrpt.php'),(20790295,349,'./apbillpay.php'),(20790373,501,'./apbillpay_preapproved.php'),(20790765,226,'./apchecklist.php'),(20791102,185,'./apvendupd.php'),(20792576,670,'./arinvoicepay.php'),(20792575,664,'./arinvoicepay.php'),(20792574,17837,'./arinvoicepay.php'),(20792573,17836,'./arinvoicepay.php'),(20792572,17835,'./arinvoicepay.php'),(20792571,9492,'./arinvoicepay.php'),(20792570,15935,'./arinvoicepay.php'),(20792569,594,'./arinvoicepay.php'),(20792568,17123,'./arinvoicepay.php'),(20792567,17109,'./arinvoicepay.php'),(20794188,5932,'./arorder_add_deposit.php'),(20794187,776,'./arorder_add_deposit.php'),(20794186,6053,'./arorder_add_deposit.php'),(20794185,670,'./arorder_add_deposit.php'),(20794184,17123,'./arorder_add_deposit.php'),(20794183,17109,'./arorder_add_deposit.php'),(20794182,542,'./arorder_add_deposit.php'),(20794181,7738,'./arorder_add_deposit.php'),(20794180,17107,'./arorder_add_deposit.php'),(20794179,445,'./arorder_add_deposit.php'),(20794178,416,'./arorder_add_deposit.php'),(20794177,17122,'./arorder_add_deposit.php'),(20794176,5670,'./arorder_add_deposit.php'),(20794175,7721,'./arorder_add_deposit.php'),(20794575,12155,'./arorderlist_sum.php'),(20795508,12834,'./arpayplan_post.php'),(20795507,17115,'./arpayplan_post.php'),(20795506,3544,'./arpayplan_post.php'),(20795505,315,'./arpayplan_post.php'),(20795504,5145,'./arpayplan_post.php'),(20795503,197,'./arpayplan_post.php'),(20801853,1373,'./importcustomer.php'),(20801852,15846,'./importcustomer.php'),(20801851,15845,'./importcustomer.php'),(20801850,5362,'./importcustomer.php'),(20801849,8936,'./importcustomer.php'),(20801848,14526,'./importcustomer.php'),(20801847,5697,'./importcustomer.php'),(20801846,981,'./importcustomer.php'),(20801845,14206,'./importcustomer.php'),(20801844,15844,'./importcustomer.php'),(20801843,18278,'./importcustomer.php'),(20801842,5759,'./importcustomer.php'),(20801841,9438,'./importcustomer.php'),(20801840,5758,'./importcustomer.php'),(20801839,9451,'./importcustomer.php'),(20801838,15843,'./importcustomer.php'),(20801837,15842,'./importcustomer.php'),(20801836,717,'./importcustomer.php'),(20801835,6602,'./importcustomer.php'),(20801834,708,'./importcustomer.php'),(20801833,6228,'./importcustomer.php'),(20801832,734,'./importcustomer.php'),(20801831,3458,'./importcustomer.php'),(20801830,675,'./importcustomer.php'),(20801829,15841,'./importcustomer.php'),(20801828,659,'./importcustomer.php'),(20801827,581,'./importcustomer.php'),(20801826,524,'./importcustomer.php'),(20801825,5757,'./importcustomer.php'),(20806263,15919,'./npordermiscremote.php'),(20806262,6713,'./npordermiscremote.php'),(20806261,8909,'./npordermiscremote.php'),(20806260,9142,'./npordermiscremote.php'),(20806259,6748,'./npordermiscremote.php'),(20806306,11791,'./nporderpayment.php'),(20806305,445,'./nporderpayment.php'),(20806304,6697,'./nporderpayment.php'),(20806303,14687,'./nporderpayment.php'),(20806302,9457,'./nporderpayment.php'),(20806301,9456,'./nporderpayment.php'),(20806300,9380,'./nporderpayment.php'),(20806299,9379,'./nporderpayment.php'),(20806298,9378,'./nporderpayment.php'),(20811228,17624,'./includes/apfunctions.php'),(20811634,7085,'./includes/arfunctions.php'),(20812313,941,'./includes/content_top.php'),(20813856,13975,'./includes/functions.php'),(20814093,604,'./includes/genfunctions.php'),(20779432,19886,'./!/application/controllers/arorder.php'),(20784994,17131,'./!/application/views/arorder/cloneServiceOrderResponse.php'),(20796136,13911,'./arserviceordupd.php'),(20796135,445,'./arserviceordupd.php'),(20796134,416,'./arserviceordupd.php'),(20796133,355,'./arserviceordupd.php'),(20796132,325,'./arserviceordupd.php'),(20796131,6031,'./arserviceordupd.php'),(20782799,3713,'./!/application/controllers/main.php'),(20782798,3711,'./!/application/controllers/main.php'),(20782797,10744,'./!/application/controllers/main.php'),(20785271,19554,'./!/application/views/customer/report_authnet_cards.php'),(20784311,5492,'./!/application/models/arorder_model.php'),(20784310,2638,'./!/application/models/arorder_model.php'),(20785270,799,'./!/application/views/customer/report_authnet_cards.php'),(20785269,4481,'./!/application/views/customer/report_authnet_cards.php'),(20785759,18341,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20784979,3432,'./!/application/views/arorder/arorder.php'),(20784978,4109,'./!/application/views/arorder/arorder.php'),(20784977,3172,'./!/application/views/arorder/arorder.php'),(20784976,3090,'./!/application/views/arorder/arorder.php'),(20784975,2998,'./!/application/views/arorder/arorder.php'),(20784974,5863,'./!/application/views/arorder/arorder.php'),(20784973,2936,'./!/application/views/arorder/arorder.php'),(20784972,3913,'./!/application/views/arorder/arorder.php'),(20784971,4455,'./!/application/views/arorder/arorder.php'),(20784970,2819,'./!/application/views/arorder/arorder.php'),(20784969,2700,'./!/application/views/arorder/arorder.php'),(20784968,2529,'./!/application/views/arorder/arorder.php'),(20784967,2361,'./!/application/views/arorder/arorder.php'),(20784966,2324,'./!/application/views/arorder/arorder.php'),(20784965,2262,'./!/application/views/arorder/arorder.php'),(20784964,2182,'./!/application/views/arorder/arorder.php'),(20784963,4865,'./!/application/views/arorder/arorder.php'),(20784998,17137,'./!/application/views/arorder/email_changed_notice.php'),(20784999,17138,'./!/application/views/arorder/email_deleted_notice.php'),(20787410,19504,'./adminarcompanyupd.php'),(20787409,20058,'./adminarcompanyupd.php'),(20790724,197,'./apchecking.php'),(20790967,3421,'./apvariance.php'),(20790966,3333,'./apvariance.php'),(20790965,3274,'./apvariance.php'),(20790964,17161,'./apvariance.php'),(20790963,17206,'./apvariance.php'),(20790962,17205,'./apvariance.php'),(20790961,17204,'./apvariance.php'),(20790960,7759,'./apvariance.php'),(20790959,17158,'./apvariance.php'),(20790958,18081,'./apvariance.php'),(20790957,18080,'./apvariance.php'),(20790956,17157,'./apvariance.php'),(20790955,17156,'./apvariance.php'),(20790954,17203,'./apvariance.php'),(20790953,17202,'./apvariance.php'),(20790952,17201,'./apvariance.php'),(20790951,17155,'./apvariance.php'),(20790950,2948,'./apvariance.php'),(20790949,17154,'./apvariance.php'),(20790948,17200,'./apvariance.php'),(20790947,6010,'./apvariance.php'),(20790946,17153,'./apvariance.php'),(20790945,17152,'./apvariance.php'),(20790944,5366,'./apvariance.php'),(20790943,8912,'./apvariance.php'),(20790942,2267,'./apvariance.php'),(20790941,2225,'./apvariance.php'),(20790940,2151,'./apvariance.php'),(20790939,1973,'./apvariance.php'),(20790938,1963,'./apvariance.php'),(20790937,1911,'./apvariance.php'),(20790936,1672,'./apvariance.php'),(20790935,9137,'./apvariance.php'),(20790934,1668,'./apvariance.php'),(20790933,17151,'./apvariance.php'),(20790932,17150,'./apvariance.php'),(20790931,17148,'./apvariance.php'),(20790930,17147,'./apvariance.php'),(20790929,20079,'./apvariance.php'),(20790928,18079,'./apvariance.php'),(20790927,9474,'./apvariance.php'),(20790926,11678,'./apvariance.php'),(20790925,8936,'./apvariance.php'),(20790924,1036,'./apvariance.php'),(20790923,17146,'./apvariance.php'),(20790922,1014,'./apvariance.php'),(20791404,5885,'./arbankreconcile.php'),(20791403,226,'./arbankreconcile.php'),(20791402,5884,'./arbankreconcile.php'),(20779297,697,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779296,18896,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779295,9492,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779294,541,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779293,491,'./!/application/controllers/arinvoicepaymentdetail.php'),(20782071,15795,'./!/application/controllers/job.php'),(20782070,7815,'./!/application/controllers/job.php'),(20782069,737,'./!/application/controllers/job.php'),(20782068,716,'./!/application/controllers/job.php'),(20782796,7908,'./!/application/controllers/main.php'),(20782795,13883,'./!/application/controllers/main.php'),(20782794,8362,'./!/application/controllers/main.php'),(20782793,14698,'./!/application/controllers/main.php'),(20783337,3173,'./!/application/controllers/rma_arorder.php'),(20783336,8508,'./!/application/controllers/rma_arorder.php'),(20783335,2702,'./!/application/controllers/rma_arorder.php'),(20783334,17177,'./!/application/controllers/rma_arorder.php'),(20783333,6826,'./!/application/controllers/rma_arorder.php'),(20783332,17176,'./!/application/controllers/rma_arorder.php'),(20783331,2222,'./!/application/controllers/rma_arorder.php'),(20783330,16370,'./!/application/controllers/rma_arorder.php'),(20783329,1963,'./!/application/controllers/rma_arorder.php'),(20783328,1709,'./!/application/controllers/rma_arorder.php'),(20783327,17175,'./!/application/controllers/rma_arorder.php'),(20783326,1668,'./!/application/controllers/rma_arorder.php'),(20783325,869,'./!/application/controllers/rma_arorder.php'),(20783324,697,'./!/application/controllers/rma_arorder.php'),(20783323,6808,'./!/application/controllers/rma_arorder.php'),(20783322,6830,'./!/application/controllers/rma_arorder.php'),(20783321,17171,'./!/application/controllers/rma_arorder.php'),(20783546,3274,'./!/application/controllers/scanner.php'),(20783545,6176,'./!/application/controllers/scanner.php'),(20783544,9633,'./!/application/controllers/scanner.php'),(20783543,18544,'./!/application/controllers/scanner.php'),(20783542,6770,'./!/application/controllers/scanner.php'),(20783541,18746,'./!/application/controllers/scanner.php'),(20783540,16113,'./!/application/controllers/scanner.php'),(20783539,8508,'./!/application/controllers/scanner.php'),(20783538,2702,'./!/application/controllers/scanner.php'),(20783537,2698,'./!/application/controllers/scanner.php'),(20783536,18745,'./!/application/controllers/scanner.php'),(20783535,17904,'./!/application/controllers/scanner.php'),(20783534,18744,'./!/application/controllers/scanner.php'),(20783533,17174,'./!/application/controllers/scanner.php'),(20783532,18743,'./!/application/controllers/scanner.php'),(20783531,18742,'./!/application/controllers/scanner.php'),(20783530,2361,'./!/application/controllers/scanner.php'),(20783811,17088,'./!/application/controllers/vendor.php'),(20783810,1036,'./!/application/controllers/vendor.php'),(20783809,1014,'./!/application/controllers/vendor.php'),(20784096,2819,'./!/application/libraries/pdf.php'),(20785470,2324,'./!/application/views/employee/certificates.php'),(20785469,13766,'./!/application/views/employee/certificates.php'),(20785468,1935,'./!/application/views/employee/certificates.php'),(20785467,10384,'./!/application/views/employee/certificates.php'),(20785466,17182,'./!/application/views/employee/certificates.php'),(20785465,981,'./!/application/views/employee/certificates.php'),(20785464,941,'./!/application/views/employee/certificates.php'),(20785463,799,'./!/application/views/employee/certificates.php'),(20785462,15723,'./!/application/views/employee/certificates.php'),(20785461,185,'./!/application/views/employee/certificates.php'),(20786379,1846,'./!/application/views/rma_arorder/batch_create_select_order_line.php'),(20793023,665,'./arinvoicereprint.php'),(20793022,5475,'./arinvoicereprint.php'),(20793021,18817,'./arinvoicereprint.php'),(20786390,17187,'./!/application/views/rma_arorder/batch_create_select_orders.php'),(20786389,17186,'./!/application/views/rma_arorder/batch_create_select_orders.php'),(20786388,17185,'./!/application/views/rma_arorder/batch_create_select_orders.php'),(20786386,15101,'./!/application/views/rma_arorder/batch_create_select_orders.php'),(20786387,2529,'./!/application/views/rma_arorder/batch_create_select_orders.php'),(20786384,2165,'./!/application/views/rma_arorder/batch_create_select_orders.php'),(20786385,4070,'./!/application/views/rma_arorder/batch_create_select_orders.php'),(20786397,6767,'./!/application/views/rma_arorder/batch_created_details.php'),(20786396,14913,'./!/application/views/rma_arorder/batch_created_details.php'),(20786395,2459,'./!/application/views/rma_arorder/batch_created_details.php'),(20786394,15101,'./!/application/views/rma_arorder/batch_created_details.php'),(20786393,1740,'./!/application/views/rma_arorder/batch_created_details.php'),(20786392,981,'./!/application/views/rma_arorder/batch_created_details.php'),(20786391,17188,'./!/application/views/rma_arorder/batch_created_details.php'),(20786474,6176,'./!/application/views/scanner/index.php'),(20786473,3156,'./!/application/views/scanner/index.php'),(20786472,6085,'./!/application/views/scanner/index.php'),(20786471,16113,'./!/application/views/scanner/index.php'),(20786470,17189,'./!/application/views/scanner/index.php'),(20786469,18761,'./!/application/views/scanner/index.php'),(20786468,3777,'./!/application/views/scanner/index.php'),(20793020,5469,'./arinvoicereprint.php'),(20786478,3156,'./!/application/views/scanner/review.php'),(20786477,17191,'./!/application/views/scanner/review.php'),(20787084,799,'./adminar_rmasetup.php'),(20787083,6565,'./adminar_rmasetup.php'),(20787082,315,'./adminar_rmasetup.php'),(20787081,5203,'./adminar_rmasetup.php'),(20787408,20057,'./adminarcompanyupd.php'),(20787407,20056,'./adminarcompanyupd.php'),(20787406,20055,'./adminarcompanyupd.php'),(20787405,7480,'./adminarcompanyupd.php'),(20790085,16930,'./apbill_preapprove_report.php'),(20790084,5570,'./apbill_preapprove_report.php'),(20790921,932,'./apvariance.php'),(20790920,10572,'./apvariance.php'),(20790919,886,'./apvariance.php'),(20790918,17145,'./apvariance.php'),(20790917,869,'./apvariance.php'),(20790916,5205,'./apvariance.php'),(20790915,491,'./apvariance.php'),(20791401,11911,'./arbankreconcile.php'),(20791400,13858,'./arbankreconcile.php'),(20796526,605,'./autofunctions.php'),(20796525,524,'./autofunctions.php'),(20803892,6412,'./invitemoption.php'),(20803894,6407,'./invitemoptiongroup.php'),(20805438,1014,'./jobcostrpt.php'),(20805437,869,'./jobcostrpt.php'),(20805436,737,'./jobcostrpt.php'),(20805435,697,'./jobcostrpt.php'),(20805509,9953,'./jobupd.php'),(20805508,315,'./jobupd.php'),(20808310,19311,'./premployeeadd.php'),(20808309,185,'./premployeeadd.php'),(20808433,154,'./premployeeupd.php'),(20811227,17623,'./includes/apfunctions.php'),(20811226,5273,'./includes/apfunctions.php'),(20811225,11618,'./includes/apfunctions.php'),(20811539,6193,'./includes/arbankreconcile.functions.php'),(20812327,8231,'./includes/createmenu2.inc'),(20814092,586,'./includes/genfunctions.php'),(20814837,17217,'./includes/itemoptiongroup.php'),(20814836,6325,'./includes/itemoptiongroup.php'),(20814835,6324,'./includes/itemoptiongroup.php'),(20816138,3156,'./includes/home/payroll/prcerts.php'),(20816137,2044,'./includes/home/payroll/prcerts.php'),(20816136,17220,'./includes/home/payroll/prcerts.php'),(20816135,10383,'./includes/home/payroll/prcerts.php'),(20816134,989,'./includes/home/payroll/prcerts.php'),(20816133,17221,'./includes/home/payroll/prcerts.php'),(20785246,2363,'./!/application/views/customer/recent_invoices.php'),(20785245,5081,'./!/application/views/customer/recent_invoices.php'),(20785244,1672,'./!/application/views/customer/recent_invoices.php'),(20785243,1668,'./!/application/views/customer/recent_invoices.php'),(20785242,4363,'./!/application/views/customer/recent_invoices.php'),(20785241,325,'./!/application/views/customer/recent_invoices.php'),(20785240,226,'./!/application/views/customer/recent_invoices.php'),(20785253,2948,'./!/application/views/customer/recent_orders.php'),(20785252,16844,'./!/application/views/customer/recent_orders.php'),(20785251,2363,'./!/application/views/customer/recent_orders.php'),(20785250,2165,'./!/application/views/customer/recent_orders.php'),(20785260,2601,'./!/application/views/customer/recent_payments.php'),(20785259,4088,'./!/application/views/customer/recent_payments.php'),(20785258,2109,'./!/application/views/customer/recent_payments.php'),(20785257,1884,'./!/application/views/customer/recent_payments.php'),(20785256,5081,'./!/application/views/customer/recent_payments.php'),(20785255,737,'./!/application/views/customer/recent_payments.php'),(20785254,226,'./!/application/views/customer/recent_payments.php'),(20785266,2816,'./!/application/views/customer/recent_shipments.php'),(20785265,6770,'./!/application/views/customer/recent_shipments.php'),(20785264,11888,'./!/application/views/customer/recent_shipments.php'),(20785263,2363,'./!/application/views/customer/recent_shipments.php'),(20785262,2165,'./!/application/views/customer/recent_shipments.php'),(20785261,1884,'./!/application/views/customer/recent_shipments.php'),(20787404,20054,'./adminarcompanyupd.php'),(20791484,7721,'./arcashpaymentadd.php'),(20791562,7721,'./arcashpaymentupd.php'),(20779431,2738,'./!/application/controllers/arorder.php'),(20779430,2676,'./!/application/controllers/arorder.php'),(20779429,3961,'./!/application/controllers/arorder.php'),(20779428,2665,'./!/application/controllers/arorder.php'),(20779427,4265,'./!/application/controllers/arorder.php'),(20779426,18506,'./!/application/controllers/arorder.php'),(20779425,16825,'./!/application/controllers/arorder.php'),(20779424,18505,'./!/application/controllers/arorder.php'),(20779423,18146,'./!/application/controllers/arorder.php'),(20779422,16785,'./!/application/controllers/arorder.php'),(20779421,18504,'./!/application/controllers/arorder.php'),(20779420,2561,'./!/application/controllers/arorder.php'),(20779419,2540,'./!/application/controllers/arorder.php'),(20779418,2529,'./!/application/controllers/arorder.php'),(20779417,5120,'./!/application/controllers/arorder.php'),(20779416,2508,'./!/application/controllers/arorder.php'),(20779415,2453,'./!/application/controllers/arorder.php'),(20779414,6988,'./!/application/controllers/arorder.php'),(20779413,2363,'./!/application/controllers/arorder.php'),(20779412,2361,'./!/application/controllers/arorder.php'),(20779411,18145,'./!/application/controllers/arorder.php'),(20779410,2260,'./!/application/controllers/arorder.php'),(20779409,18140,'./!/application/controllers/arorder.php'),(20779408,16671,'./!/application/controllers/arorder.php'),(20779407,2208,'./!/application/controllers/arorder.php'),(20779406,4793,'./!/application/controllers/arorder.php'),(20779405,4579,'./!/application/controllers/arorder.php'),(20779404,9134,'./!/application/controllers/arorder.php'),(20779403,17780,'./!/application/controllers/arorder.php'),(20779402,2182,'./!/application/controllers/arorder.php'),(20779740,19893,'./!/application/controllers/batchimport.php'),(20779739,9835,'./!/application/controllers/batchimport.php'),(20779738,2200,'./!/application/controllers/batchimport.php'),(20779737,17686,'./!/application/controllers/batchimport.php'),(20779736,7890,'./!/application/controllers/batchimport.php'),(20779735,9390,'./!/application/controllers/batchimport.php'),(20779734,17234,'./!/application/controllers/batchimport.php'),(20779733,17233,'./!/application/controllers/batchimport.php'),(20779732,3660,'./!/application/controllers/batchimport.php'),(20779731,4940,'./!/application/controllers/batchimport.php'),(20779730,8166,'./!/application/controllers/batchimport.php'),(20779729,15945,'./!/application/controllers/batchimport.php'),(20779728,1578,'./!/application/controllers/batchimport.php'),(20779727,11868,'./!/application/controllers/batchimport.php'),(20779726,10795,'./!/application/controllers/batchimport.php'),(20779725,6782,'./!/application/controllers/batchimport.php'),(20779724,15944,'./!/application/controllers/batchimport.php'),(20779723,15943,'./!/application/controllers/batchimport.php'),(20779722,17232,'./!/application/controllers/batchimport.php'),(20779721,807,'./!/application/controllers/batchimport.php'),(20779720,864,'./!/application/controllers/batchimport.php'),(20779719,799,'./!/application/controllers/batchimport.php'),(20779718,17231,'./!/application/controllers/batchimport.php'),(20779717,16215,'./!/application/controllers/batchimport.php'),(20779716,17230,'./!/application/controllers/batchimport.php'),(20779715,17229,'./!/application/controllers/batchimport.php'),(20779714,8653,'./!/application/controllers/batchimport.php'),(20779713,11843,'./!/application/controllers/batchimport.php'),(20779712,8862,'./!/application/controllers/batchimport.php'),(20780282,2795,'./!/application/controllers/customer.php'),(20780323,2702,'./!/application/controllers/customfields.php'),(20781308,19721,'./!/application/controllers/invcountbatch.php'),(20780338,17248,'./!/application/controllers/ebay.php'),(20781309,19722,'./!/application/controllers/invcountbatch.php'),(20780337,17247,'./!/application/controllers/ebay.php'),(20780336,17246,'./!/application/controllers/ebay.php'),(20780335,17245,'./!/application/controllers/ebay.php'),(20780391,1935,'./!/application/controllers/filecategory.php'),(20780954,1696,'./!/application/controllers/invbinitem.php'),(20780423,6141,'./!/application/controllers/fileitem.php'),(20780422,3252,'./!/application/controllers/fileitem.php'),(20780421,17258,'./!/application/controllers/fileitem.php'),(20780420,3156,'./!/application/controllers/fileitem.php'),(20780419,2886,'./!/application/controllers/fileitem.php'),(20780418,17257,'./!/application/controllers/fileitem.php'),(20780737,7163,'./!/application/controllers/hubconstruction.php'),(20780417,4265,'./!/application/controllers/fileitem.php'),(20780416,8290,'./!/application/controllers/fileitem.php'),(20780415,18904,'./!/application/controllers/fileitem.php'),(20780414,2094,'./!/application/controllers/fileitem.php'),(20780413,2103,'./!/application/controllers/fileitem.php'),(20780412,9622,'./!/application/controllers/fileitem.php'),(20780411,1709,'./!/application/controllers/fileitem.php'),(20780410,17256,'./!/application/controllers/fileitem.php'),(20780409,17255,'./!/application/controllers/fileitem.php'),(20780920,1963,'./!/application/controllers/invbin.php'),(20780919,4551,'./!/application/controllers/invbin.php'),(20780918,4721,'./!/application/controllers/invbin.php'),(20780917,19189,'./!/application/controllers/invbin.php'),(20780916,19342,'./!/application/controllers/invbin.php'),(20780915,19188,'./!/application/controllers/invbin.php'),(20780914,1709,'./!/application/controllers/invbin.php'),(20780913,18516,'./!/application/controllers/invbin.php'),(20780912,1647,'./!/application/controllers/invbin.php'),(20780953,17265,'./!/application/controllers/invbinitem.php'),(20780952,1647,'./!/application/controllers/invbinitem.php'),(20780951,17264,'./!/application/controllers/invbinitem.php'),(20780950,1091,'./!/application/controllers/invbinitem.php'),(20780949,869,'./!/application/controllers/invbinitem.php'),(20780948,19528,'./!/application/controllers/invbinitem.php'),(20780947,19194,'./!/application/controllers/invbinitem.php'),(20780946,19193,'./!/application/controllers/invbinitem.php'),(20781115,16770,'./!/application/controllers/invcotransfer.php'),(20781113,11704,'./!/application/controllers/invcotransfer.php'),(20781112,16769,'./!/application/controllers/invcotransfer.php'),(20781111,18521,'./!/application/controllers/invcotransfer.php'),(20781110,8171,'./!/application/controllers/invcotransfer.php'),(20781109,18378,'./!/application/controllers/invcotransfer.php'),(20781108,3090,'./!/application/controllers/invcotransfer.php'),(20781107,3072,'./!/application/controllers/invcotransfer.php'),(20781106,18180,'./!/application/controllers/invcotransfer.php'),(20781105,18179,'./!/application/controllers/invcotransfer.php'),(20781873,16148,'./!/application/controllers/itemlocation.php'),(20781519,18357,'./!/application/controllers/invpo.php'),(20781518,18356,'./!/application/controllers/invpo.php'),(20781517,18355,'./!/application/controllers/invpo.php'),(20781516,3360,'./!/application/controllers/invpo.php'),(20781515,3299,'./!/application/controllers/invpo.php'),(20781514,3292,'./!/application/controllers/invpo.php'),(20781513,3274,'./!/application/controllers/invpo.php'),(20781512,3252,'./!/application/controllers/invpo.php'),(20781511,18203,'./!/application/controllers/invpo.php'),(20781510,3126,'./!/application/controllers/invpo.php'),(20781509,3090,'./!/application/controllers/invpo.php'),(20781508,16676,'./!/application/controllers/invpo.php'),(20781507,3434,'./!/application/controllers/invpo.php'),(20781506,18354,'./!/application/controllers/invpo.php'),(20781577,19198,'./!/application/controllers/invzone.php'),(20781576,16471,'./!/application/controllers/invzone.php'),(20781575,16470,'./!/application/controllers/invzone.php'),(20781574,16468,'./!/application/controllers/invzone.php'),(20781573,2702,'./!/application/controllers/invzone.php'),(20781572,4265,'./!/application/controllers/invzone.php'),(20781571,5876,'./!/application/controllers/invzone.php'),(20781570,16464,'./!/application/controllers/invzone.php'),(20781569,2459,'./!/application/controllers/invzone.php'),(20781568,19197,'./!/application/controllers/invzone.php'),(20781567,2094,'./!/application/controllers/invzone.php'),(20781566,4721,'./!/application/controllers/invzone.php'),(20781565,1788,'./!/application/controllers/invzone.php'),(20781564,18516,'./!/application/controllers/invzone.php'),(20781563,1647,'./!/application/controllers/invzone.php'),(20781562,17271,'./!/application/controllers/invzone.php'),(20781561,1143,'./!/application/controllers/invzone.php'),(20781560,941,'./!/application/controllers/invzone.php'),(20781559,869,'./!/application/controllers/invzone.php'),(20781558,799,'./!/application/controllers/invzone.php'),(20781935,13818,'./!/application/controllers/itempricespecial.php'),(20781929,19368,'./!/application/controllers/itempricespecial.php'),(20781930,2459,'./!/application/controllers/itempricespecial.php'),(20781931,4725,'./!/application/controllers/itempricespecial.php'),(20781932,19937,'./!/application/controllers/itempricespecial.php'),(20781933,19938,'./!/application/controllers/itempricespecial.php'),(20781994,17283,'./!/application/controllers/itemtransaction.php'),(20781993,17258,'./!/application/controllers/itemtransaction.php'),(20781992,3156,'./!/application/controllers/itemtransaction.php'),(20781991,11704,'./!/application/controllers/itemtransaction.php'),(20781990,3439,'./!/application/controllers/itemtransaction.php'),(20781989,2664,'./!/application/controllers/itemtransaction.php'),(20781988,7108,'./!/application/controllers/itemtransaction.php'),(20781987,2601,'./!/application/controllers/itemtransaction.php'),(20781986,2529,'./!/application/controllers/itemtransaction.php'),(20781985,3438,'./!/application/controllers/itemtransaction.php'),(20781984,6988,'./!/application/controllers/itemtransaction.php'),(20781983,2363,'./!/application/controllers/itemtransaction.php'),(20781982,2182,'./!/application/controllers/itemtransaction.php'),(20781981,8290,'./!/application/controllers/itemtransaction.php'),(20781980,2094,'./!/application/controllers/itemtransaction.php'),(20781979,1770,'./!/application/controllers/itemtransaction.php'),(20781978,1709,'./!/application/controllers/itemtransaction.php'),(20781977,1678,'./!/application/controllers/itemtransaction.php'),(20781976,1647,'./!/application/controllers/itemtransaction.php'),(20781975,17282,'./!/application/controllers/itemtransaction.php'),(20781974,5746,'./!/application/controllers/itemtransaction.php'),(20781973,869,'./!/application/controllers/itemtransaction.php'),(20781972,737,'./!/application/controllers/itemtransaction.php'),(20781971,634,'./!/application/controllers/itemtransaction.php'),(20781970,572,'./!/application/controllers/itemtransaction.php'),(20781969,541,'./!/application/controllers/itemtransaction.php'),(20781968,187,'./!/application/controllers/itemtransaction.php'),(20782067,697,'./!/application/controllers/job.php'),(20782792,7161,'./!/application/controllers/main.php'),(20782791,10046,'./!/application/controllers/main.php'),(20782790,13829,'./!/application/controllers/main.php'),(20782789,16669,'./!/application/controllers/main.php'),(20782788,5377,'./!/application/controllers/main.php'),(20782787,3709,'./!/application/controllers/main.php'),(20782786,11857,'./!/application/controllers/main.php'),(20782785,16549,'./!/application/controllers/main.php'),(20782784,5234,'./!/application/controllers/main.php'),(20782783,15962,'./!/application/controllers/main.php'),(20782782,16778,'./!/application/controllers/main.php'),(20782781,7907,'./!/application/controllers/main.php'),(20782780,3990,'./!/application/controllers/main.php'),(20782779,3708,'./!/application/controllers/main.php'),(20782778,3707,'./!/application/controllers/main.php'),(20782777,7906,'./!/application/controllers/main.php'),(20782776,11906,'./!/application/controllers/main.php'),(20782775,3705,'./!/application/controllers/main.php'),(20782774,14622,'./!/application/controllers/main.php'),(20783137,16088,'./!/application/controllers/positivepay.php'),(20783136,504,'./!/application/controllers/positivepay.php'),(20783135,315,'./!/application/controllers/positivepay.php'),(20783134,16119,'./!/application/controllers/positivepay.php'),(20783133,16118,'./!/application/controllers/positivepay.php'),(20783551,2094,'./!/application/controllers/search_tree.php'),(20783550,1696,'./!/application/controllers/search_tree.php'),(20783549,17288,'./!/application/controllers/search_tree.php'),(20783548,541,'./!/application/controllers/search_tree.php'),(20783547,451,'./!/application/controllers/search_tree.php'),(20783566,1963,'./!/application/controllers/shopify.php'),(20783567,17246,'./!/application/controllers/shopify.php'),(20783569,16951,'./!/application/controllers/shopify.php'),(20783568,16950,'./!/application/controllers/shopify.php'),(20783602,17298,'./!/application/controllers/task.php'),(20783601,14952,'./!/application/controllers/task.php'),(20783600,14951,'./!/application/controllers/task.php'),(20783599,15836,'./!/application/controllers/task.php'),(20783598,4265,'./!/application/controllers/task.php'),(20783597,2162,'./!/application/controllers/task.php'),(20783596,2094,'./!/application/controllers/task.php'),(20783595,1935,'./!/application/controllers/task.php'),(20783594,17297,'./!/application/controllers/task.php'),(20783593,1911,'./!/application/controllers/task.php'),(20783592,17296,'./!/application/controllers/task.php'),(20783591,17295,'./!/application/controllers/task.php'),(20783639,17305,'./!/application/controllers/tasklog.php'),(20783638,6141,'./!/application/controllers/tasklog.php'),(20783637,3274,'./!/application/controllers/tasklog.php'),(20783636,9642,'./!/application/controllers/tasklog.php'),(20783635,3252,'./!/application/controllers/tasklog.php'),(20783634,14955,'./!/application/controllers/tasklog.php'),(20783633,17298,'./!/application/controllers/tasklog.php'),(20783632,14953,'./!/application/controllers/tasklog.php'),(20783631,14951,'./!/application/controllers/tasklog.php'),(20783630,17440,'./!/application/controllers/tasklog.php'),(20783629,4265,'./!/application/controllers/tasklog.php'),(20783628,2160,'./!/application/controllers/tasklog.php'),(20783627,2094,'./!/application/controllers/tasklog.php'),(20783626,2103,'./!/application/controllers/tasklog.php'),(20783625,17303,'./!/application/controllers/tasklog.php'),(20783624,17302,'./!/application/controllers/tasklog.php'),(20783623,9622,'./!/application/controllers/tasklog.php'),(20783622,17287,'./!/application/controllers/tasklog.php'),(20783621,15050,'./!/application/controllers/tasklog.php'),(20783620,737,'./!/application/controllers/tasklog.php'),(20783619,17301,'./!/application/controllers/tasklog.php'),(20783618,6228,'./!/application/controllers/tasklog.php'),(20783617,697,'./!/application/controllers/tasklog.php'),(20783616,605,'./!/application/controllers/tasklog.php'),(20783615,541,'./!/application/controllers/tasklog.php'),(20783614,17300,'./!/application/controllers/tasklog.php'),(20783808,17180,'./!/application/controllers/vendor.php'),(20783996,16135,'./!/application/helpers/sftp_helper.php'),(20783995,17307,'./!/application/helpers/sftp_helper.php'),(20783994,1792,'./!/application/helpers/sftp_helper.php'),(20783993,1047,'./!/application/helpers/sftp_helper.php'),(20784076,4455,'./!/application/libraries/import_task.php'),(20784075,2821,'./!/application/libraries/import_task.php'),(20784074,18816,'./!/application/libraries/import_task.php'),(20784271,19205,'./!/application/models/arinvoice_model.php'),(20784268,2225,'./!/application/models/arinvoice_model.php'),(20784269,7628,'./!/application/models/arinvoice_model.php'),(20784270,5388,'./!/application/models/arinvoice_model.php'),(20784368,17312,'./!/application/models/ebay_model.php'),(20784367,17311,'./!/application/models/ebay_model.php'),(20784366,17310,'./!/application/models/ebay_model.php'),(20784365,17309,'./!/application/models/ebay_model.php'),(20784452,17320,'./!/application/models/shopify_model.php'),(20784451,17319,'./!/application/models/shopify_model.php'),(20784450,17292,'./!/application/models/shopify_model.php'),(20784449,17318,'./!/application/models/shopify_model.php'),(20784448,17317,'./!/application/models/shopify_model.php'),(20784447,17316,'./!/application/models/shopify_model.php'),(20784992,3090,'./!/application/views/arorder/batchShipAndInvoice.php'),(20784991,17228,'./!/application/views/arorder/batchShipAndInvoice.php'),(20784990,2165,'./!/application/views/arorder/batchShipAndInvoice.php'),(20785055,17324,'./!/application/views/batchimport/email_error.php'),(20785054,17323,'./!/application/views/batchimport/email_error.php'),(20785053,15972,'./!/application/views/batchimport/email_error.php'),(20785060,17324,'./!/application/views/batchimport/email_notice.php'),(20785059,16081,'./!/application/views/batchimport/email_notice.php'),(20785058,15972,'./!/application/views/batchimport/email_notice.php'),(20785057,17322,'./!/application/views/batchimport/email_notice.php'),(20785056,15944,'./!/application/views/batchimport/email_notice.php'),(20785720,19565,'./!/application/views/invcountbatch/enterCounts.php'),(20785719,1696,'./!/application/views/invcountbatch/enterCounts.php'),(20785718,19497,'./!/application/views/invcountbatch/enterCounts.php'),(20785323,3090,'./!/application/views/customfields/report_membershiptracker.php'),(20785322,16808,'./!/application/views/customfields/report_membershiptracker.php'),(20785321,8433,'./!/application/views/customfields/report_membershiptracker.php'),(20785320,17328,'./!/application/views/customfields/report_membershiptracker.php'),(20785319,16798,'./!/application/views/customfields/report_membershiptracker.php'),(20785318,17327,'./!/application/views/customfields/report_membershiptracker.php'),(20785317,1446,'./!/application/views/customfields/report_membershiptracker.php'),(20785316,1014,'./!/application/views/customfields/report_membershiptracker.php'),(20785315,17326,'./!/application/views/customfields/report_membershiptracker.php'),(20785314,697,'./!/application/views/customfields/report_membershiptracker.php'),(20785313,6042,'./!/application/views/customfields/report_membershiptracker.php'),(20785312,573,'./!/application/views/customfields/report_membershiptracker.php'),(20785311,333,'./!/application/views/customfields/report_membershiptracker.php'),(20785310,17325,'./!/application/views/customfields/report_membershiptracker.php'),(20785309,202,'./!/application/views/customfields/report_membershiptracker.php'),(20785335,3090,'./!/application/views/customfields/report_referrals.php'),(20785334,16808,'./!/application/views/customfields/report_referrals.php'),(20785333,17979,'./!/application/views/customfields/report_referrals.php'),(20785332,8433,'./!/application/views/customfields/report_referrals.php'),(20785331,2626,'./!/application/views/customfields/report_referrals.php'),(20785330,16804,'./!/application/views/customfields/report_referrals.php'),(20785329,1446,'./!/application/views/customfields/report_referrals.php'),(20785328,1014,'./!/application/views/customfields/report_referrals.php'),(20785327,573,'./!/application/views/customfields/report_referrals.php'),(20785326,16565,'./!/application/views/customfields/report_referrals.php'),(20785409,17352,'./!/application/views/ebay/admin.php'),(20785408,17351,'./!/application/views/ebay/admin.php'),(20785407,17350,'./!/application/views/ebay/admin.php'),(20785406,17349,'./!/application/views/ebay/admin.php'),(20785405,17348,'./!/application/views/ebay/admin.php'),(20785404,12715,'./!/application/views/ebay/admin.php'),(20785403,16995,'./!/application/views/ebay/admin.php'),(20785402,2702,'./!/application/views/ebay/admin.php'),(20785401,17347,'./!/application/views/ebay/admin.php'),(20785400,17346,'./!/application/views/ebay/admin.php'),(20785399,17345,'./!/application/views/ebay/admin.php'),(20785398,17344,'./!/application/views/ebay/admin.php'),(20785397,16979,'./!/application/views/ebay/admin.php'),(20785396,17343,'./!/application/views/ebay/admin.php'),(20785395,17342,'./!/application/views/ebay/admin.php'),(20785394,799,'./!/application/views/ebay/admin.php'),(20785393,17341,'./!/application/views/ebay/admin.php'),(20785420,17350,'./!/application/views/ebay/admin_add_store.php'),(20785419,17349,'./!/application/views/ebay/admin_add_store.php'),(20785418,17348,'./!/application/views/ebay/admin_add_store.php'),(20785417,2975,'./!/application/views/ebay/admin_add_store.php'),(20785416,17346,'./!/application/views/ebay/admin_add_store.php'),(20785415,17344,'./!/application/views/ebay/admin_add_store.php'),(20785414,17354,'./!/application/views/ebay/admin_add_store.php'),(20785413,17343,'./!/application/views/ebay/admin_add_store.php'),(20785412,17334,'./!/application/views/ebay/admin_add_store.php'),(20785411,17331,'./!/application/views/ebay/admin_add_store.php'),(20785410,17353,'./!/application/views/ebay/admin_add_store.php'),(20785423,17355,'./!/application/views/ebay/admin_select_store.php'),(20785422,4608,'./!/application/views/ebay/admin_select_store.php'),(20785434,2975,'./!/application/views/ebay/import_orders_search.php'),(20785433,17362,'./!/application/views/ebay/import_orders_search.php'),(20785432,17361,'./!/application/views/ebay/import_orders_search.php'),(20785431,17360,'./!/application/views/ebay/import_orders_search.php'),(20785430,17359,'./!/application/views/ebay/import_orders_search.php'),(20785429,2162,'./!/application/views/ebay/import_orders_search.php'),(20785428,17358,'./!/application/views/ebay/import_orders_search.php'),(20785427,17357,'./!/application/views/ebay/import_orders_search.php'),(20785426,17356,'./!/application/views/ebay/import_orders_search.php'),(20785425,4973,'./!/application/views/ebay/import_orders_search.php'),(20785424,749,'./!/application/views/ebay/import_orders_search.php'),(20785460,3090,'./!/application/views/ebay/import_orders_select.php'),(20785459,2975,'./!/application/views/ebay/import_orders_select.php'),(20785458,2948,'./!/application/views/ebay/import_orders_select.php'),(20785457,17361,'./!/application/views/ebay/import_orders_select.php'),(20785456,17360,'./!/application/views/ebay/import_orders_select.php'),(20785455,17366,'./!/application/views/ebay/import_orders_select.php'),(20785454,2751,'./!/application/views/ebay/import_orders_select.php'),(20785453,17365,'./!/application/views/ebay/import_orders_select.php'),(20785452,2529,'./!/application/views/ebay/import_orders_select.php'),(20785451,8912,'./!/application/views/ebay/import_orders_select.php'),(20785450,17364,'./!/application/views/ebay/import_orders_select.php'),(20785449,17359,'./!/application/views/ebay/import_orders_select.php'),(20785448,2162,'./!/application/views/ebay/import_orders_select.php'),(20785447,16370,'./!/application/views/ebay/import_orders_select.php'),(20785446,10386,'./!/application/views/ebay/import_orders_select.php'),(20785445,15402,'./!/application/views/ebay/import_orders_select.php'),(20785444,17363,'./!/application/views/ebay/import_orders_select.php'),(20785443,17358,'./!/application/views/ebay/import_orders_select.php'),(20785442,7370,'./!/application/views/ebay/import_orders_select.php'),(20785441,1578,'./!/application/views/ebay/import_orders_select.php'),(20785440,17356,'./!/application/views/ebay/import_orders_select.php'),(20785439,4973,'./!/application/views/ebay/import_orders_select.php'),(20785438,749,'./!/application/views/ebay/import_orders_select.php'),(20785437,737,'./!/application/views/ebay/import_orders_select.php'),(20785436,697,'./!/application/views/ebay/import_orders_select.php'),(20785435,591,'./!/application/views/ebay/import_orders_select.php'),(20786705,416,'./!/application/views/usps_api/customerAddressChanged.js.php'),(20791748,4871,'./arcustb2buser.php'),(20791747,19478,'./arcustb2buser.php'),(20791746,144,'./arcustb2buser.php'),(20792665,11428,'./arinvoicepayreceipt.php'),(20792101,8875,'./areft.php'),(20786577,17381,'./!/application/views/shopify/import_customer_selection_table.php'),(20786576,2948,'./!/application/views/shopify/import_customer_selection_table.php'),(20787196,10467,'./adminarcompanytaxupd.php'),(20786575,3434,'./!/application/views/shopify/import_customer_selection_table.php'),(20786574,2751,'./!/application/views/shopify/import_customer_selection_table.php'),(20786573,5417,'./!/application/views/shopify/import_customer_selection_table.php'),(20786572,2738,'./!/application/views/shopify/import_customer_selection_table.php'),(20786571,17380,'./!/application/views/shopify/import_customer_selection_table.php'),(20786570,17379,'./!/application/views/shopify/import_customer_selection_table.php'),(20786569,17378,'./!/application/views/shopify/import_customer_selection_table.php'),(20786568,16370,'./!/application/views/shopify/import_customer_selection_table.php'),(20786567,1935,'./!/application/views/shopify/import_customer_selection_table.php'),(20786566,10386,'./!/application/views/shopify/import_customer_selection_table.php'),(20791745,78,'./arcustb2buser.php'),(20791744,59,'./arcustb2buser.php'),(20791743,6453,'./arcustb2buser.php'),(20791742,6494,'./arcustb2buser.php'),(20787402,6467,'./adminarcompanyupd.php'),(20786595,3070,'./!/application/views/shopify/import_item_selection_table.php'),(20786594,14971,'./!/application/views/shopify/import_item_selection_table.php'),(20787195,6165,'./adminarcompanytaxupd.php'),(20786593,2948,'./!/application/views/shopify/import_item_selection_table.php'),(20786592,3434,'./!/application/views/shopify/import_item_selection_table.php'),(20786591,2751,'./!/application/views/shopify/import_item_selection_table.php'),(20786590,5417,'./!/application/views/shopify/import_item_selection_table.php'),(20786589,2738,'./!/application/views/shopify/import_item_selection_table.php'),(20786588,2404,'./!/application/views/shopify/import_item_selection_table.php'),(20786587,17380,'./!/application/views/shopify/import_item_selection_table.php'),(20786586,17379,'./!/application/views/shopify/import_item_selection_table.php'),(20786585,17378,'./!/application/views/shopify/import_item_selection_table.php'),(20786584,16370,'./!/application/views/shopify/import_item_selection_table.php'),(20786615,3090,'./!/application/views/shopify/import_order_selection_table.php'),(20786614,2948,'./!/application/views/shopify/import_order_selection_table.php'),(20786613,3434,'./!/application/views/shopify/import_order_selection_table.php'),(20786612,2751,'./!/application/views/shopify/import_order_selection_table.php'),(20786611,5417,'./!/application/views/shopify/import_order_selection_table.php'),(20786610,2738,'./!/application/views/shopify/import_order_selection_table.php'),(20786609,17380,'./!/application/views/shopify/import_order_selection_table.php'),(20786608,17379,'./!/application/views/shopify/import_order_selection_table.php'),(20786607,8912,'./!/application/views/shopify/import_order_selection_table.php'),(20786606,17378,'./!/application/views/shopify/import_order_selection_table.php'),(20786605,16370,'./!/application/views/shopify/import_order_selection_table.php'),(20786604,1935,'./!/application/views/shopify/import_order_selection_table.php'),(20786603,10386,'./!/application/views/shopify/import_order_selection_table.php'),(20786602,1772,'./!/application/views/shopify/import_order_selection_table.php'),(20786601,17385,'./!/application/views/shopify/import_order_selection_table.php'),(20786600,17363,'./!/application/views/shopify/import_order_selection_table.php'),(20786599,7370,'./!/application/views/shopify/import_order_selection_table.php'),(20786598,1014,'./!/application/views/shopify/import_order_selection_table.php'),(20786597,737,'./!/application/views/shopify/import_order_selection_table.php'),(20786596,697,'./!/application/views/shopify/import_order_selection_table.php'),(20786634,3090,'./!/application/views/shopify/import_quote_selection_table.php'),(20786633,2948,'./!/application/views/shopify/import_quote_selection_table.php'),(20786632,3434,'./!/application/views/shopify/import_quote_selection_table.php'),(20786631,2751,'./!/application/views/shopify/import_quote_selection_table.php'),(20786630,5417,'./!/application/views/shopify/import_quote_selection_table.php'),(20786629,2738,'./!/application/views/shopify/import_quote_selection_table.php'),(20786628,3777,'./!/application/views/shopify/import_quote_selection_table.php'),(20786627,17380,'./!/application/views/shopify/import_quote_selection_table.php'),(20786626,17379,'./!/application/views/shopify/import_quote_selection_table.php'),(20786625,17378,'./!/application/views/shopify/import_quote_selection_table.php'),(20786624,16370,'./!/application/views/shopify/import_quote_selection_table.php'),(20786623,1935,'./!/application/views/shopify/import_quote_selection_table.php'),(20786622,10386,'./!/application/views/shopify/import_quote_selection_table.php'),(20786621,1772,'./!/application/views/shopify/import_quote_selection_table.php'),(20786620,17387,'./!/application/views/shopify/import_quote_selection_table.php'),(20786619,17386,'./!/application/views/shopify/import_quote_selection_table.php'),(20786618,7370,'./!/application/views/shopify/import_quote_selection_table.php'),(20786617,1014,'./!/application/views/shopify/import_quote_selection_table.php'),(20786616,697,'./!/application/views/shopify/import_quote_selection_table.php'),(20786642,17390,'./!/application/views/shopify/import_select_store.php'),(20786641,17389,'./!/application/views/shopify/import_select_store.php'),(20786640,4857,'./!/application/views/shopify/import_select_store.php'),(20786639,2200,'./!/application/views/shopify/import_select_store.php'),(20786638,1740,'./!/application/views/shopify/import_select_store.php'),(20787403,932,'./adminarcompanyupd.php'),(20787194,12716,'./adminarcompanytaxupd.php'),(20787193,19839,'./adminarcompanytaxupd.php'),(20787192,19838,'./adminarcompanytaxupd.php'),(20787401,12717,'./adminarcompanyupd.php'),(20787400,20221,'./adminarcompanyupd.php'),(20787399,19757,'./adminarcompanyupd.php'),(20787398,19842,'./adminarcompanyupd.php'),(20787397,6588,'./adminarcompanyupd.php'),(20787396,19473,'./adminarcompanyupd.php'),(20788165,7900,'./admindoccenter.php'),(20788164,17400,'./admindoccenter.php'),(20788163,13614,'./admindoccenter.php'),(20788162,13613,'./admindoccenter.php'),(20790461,353,'./apbillupd.php'),(20791983,11134,'./arcustupd.php'),(20793448,6733,'./arinvoiceupd.php'),(20795093,17408,'./arordquotefpdf.php'),(20795092,13433,'./arordquotefpdf.php'),(20795091,719,'./arordquotefpdf.php'),(20795090,5477,'./arordquotefpdf.php'),(20795312,15132,'./arordshipquote.php'),(20795311,3509,'./arordshipquote.php'),(20795373,355,'./arordshipview.php'),(20795372,4624,'./arordshipview.php'),(20795371,315,'./arordshipview.php'),(20799959,6175,'./fileupload.php'),(20799958,8936,'./fileupload.php'),(20800540,5424,'./glclose_year.php'),(20800539,315,'./glclose_year.php'),(20800538,5618,'./glclose_year.php'),(20801707,14202,'./importbills.php'),(20801706,14201,'./importbills.php'),(20801705,7360,'./importbills.php'),(20801824,351,'./importcustomer.php'),(20801823,315,'./importcustomer.php'),(20802064,5299,'./importgljournals.php'),(20802163,16040,'./importinvoices.php'),(20802162,18279,'./importinvoices.php'),(20802161,14206,'./importinvoices.php'),(20802160,14204,'./importinvoices.php'),(20802159,749,'./importinvoices.php'),(20802158,14801,'./importinvoices.php'),(20802157,8730,'./importinvoices.php'),(20802156,697,'./importinvoices.php'),(20802560,634,'./invcotransfer.php'),(20802559,573,'./invcotransfer.php'),(20802900,14121,'./invexportimportcsv.php'),(20802899,11744,'./invexportimportcsv.php'),(20803357,457,'./invitemcatupd.php'),(20803356,416,'./invitemcatupd.php'),(20804202,18776,'./invitemupd.php'),(20804201,9373,'./invitemupd.php'),(20805507,16353,'./jobupd.php'),(20805954,8109,'./nporder.php'),(20805953,15539,'./nporder.php'),(20806297,10776,'./nporderpayment.php'),(20806296,9377,'./nporderpayment.php'),(20806295,9376,'./nporderpayment.php'),(20806444,4267,'./nporderremote.php'),(20806443,17854,'./nporderremote.php'),(20811224,262,'./includes/apfunctions.php'),(20811223,17212,'./includes/apfunctions.php'),(20811222,222,'./includes/apfunctions.php'),(20811221,8879,'./includes/apfunctions.php'),(20811220,14001,'./includes/apfunctions.php'),(20811219,7082,'./includes/apfunctions.php'),(20811218,155,'./includes/apfunctions.php'),(20812170,8936,'./includes/batchhelper.php'),(20812169,14810,'./includes/batchhelper.php'),(20813537,18879,'./includes/filesystemdb.php'),(20813536,8936,'./includes/filesystemdb.php'),(20813535,9069,'./includes/filesystemdb.php'),(20813534,799,'./includes/filesystemdb.php'),(20813533,17433,'./includes/filesystemdb.php'),(20813532,737,'./includes/filesystemdb.php'),(20813531,9068,'./includes/filesystemdb.php'),(20813530,9067,'./includes/filesystemdb.php'),(20813529,15923,'./includes/filesystemdb.php'),(20813528,18035,'./includes/filesystemdb.php'),(20813527,18034,'./includes/filesystemdb.php'),(20813526,9066,'./includes/filesystemdb.php'),(20813525,13886,'./includes/filesystemdb.php'),(20813855,13974,'./includes/functions.php'),(20813854,13973,'./includes/functions.php'),(20813853,4070,'./includes/functions.php'),(20814572,19146,'./includes/invfunctions.php'),(20814571,16709,'./includes/invfunctions.php'),(20814570,18710,'./includes/invfunctions.php'),(20814569,870,'./includes/invfunctions.php'),(20782773,7904,'./!/application/controllers/main.php'),(20782762,1935,'./!/application/controllers/main.php'),(20783236,3022,'./!/application/controllers/producttypetax.php'),(20783235,14398,'./!/application/controllers/producttypetax.php'),(20783234,17442,'./!/application/controllers/producttypetax.php'),(20783233,17443,'./!/application/controllers/producttypetax.php'),(20783232,1935,'./!/application/controllers/producttypetax.php'),(20783807,17179,'./!/application/controllers/vendor.php'),(20783806,17087,'./!/application/controllers/vendor.php'),(20783805,15710,'./!/application/controllers/vendor.php'),(20783804,5697,'./!/application/controllers/vendor.php'),(20783803,981,'./!/application/controllers/vendor.php'),(20783802,941,'./!/application/controllers/vendor.php'),(20783801,869,'./!/application/controllers/vendor.php'),(20783800,17446,'./!/application/controllers/vendor.php'),(20783799,17445,'./!/application/controllers/vendor.php'),(20783798,5205,'./!/application/controllers/vendor.php'),(20783797,799,'./!/application/controllers/vendor.php'),(20784281,6944,'./!/application/models/arinvoicedetail_model.php'),(20784280,19206,'./!/application/models/arinvoicedetail_model.php'),(20784279,17443,'./!/application/models/arinvoicedetail_model.php'),(20784318,6944,'./!/application/models/arorderdetail_model.php'),(20784317,19206,'./!/application/models/arorderdetail_model.php'),(20784316,17443,'./!/application/models/arorderdetail_model.php'),(20784315,7581,'./!/application/models/arorderdetail_model.php'),(20786709,17452,'./!/application/views/usps_api/customerAddressChanged.js.php'),(20787395,18077,'./adminarcompanyupd.php'),(20786706,524,'./!/application/views/usps_api/customerAddressChanged.js.php'),(20786707,15349,'./!/application/views/usps_api/customerAddressChanged.js.php'),(20786708,2936,'./!/application/views/usps_api/customerAddressChanged.js.php'),(20786772,637,'./admin3dcart.php'),(20787394,18076,'./adminarcompanyupd.php'),(20787393,13761,'./adminarcompanyupd.php'),(20787392,9325,'./adminarcompanyupd.php'),(20787391,19409,'./adminarcompanyupd.php'),(20787390,19099,'./adminarcompanyupd.php'),(20787389,17396,'./adminarcompanyupd.php'),(20787388,18075,'./adminarcompanyupd.php'),(20787387,17395,'./adminarcompanyupd.php'),(20787386,13929,'./adminarcompanyupd.php'),(20787385,9324,'./adminarcompanyupd.php'),(20787384,15536,'./adminarcompanyupd.php'),(20793620,1677,'./arinvoiceview.php'),(20793619,15391,'./arinvoiceview.php'),(20795149,13106,'./arordshipadd.php'),(20795148,16654,'./arordshipadd.php'),(20795147,416,'./arordshipadd.php'),(20795904,869,'./arserialcheck.php'),(20795903,14277,'./arserialcheck.php'),(20795902,14106,'./arserialcheck.php'),(20802238,16315,'./importitems.php'),(20803042,1476,'./invitemadd.php'),(20803041,13866,'./invitemadd.php'),(20804200,9372,'./invitemupd.php'),(20804199,13994,'./invitemupd.php'),(20805952,4973,'./nporder.php'),(20805951,737,'./nporder.php'),(20805950,17665,'./nporder.php'),(20805949,18336,'./nporder.php'),(20805948,20153,'./nporder.php'),(20805947,19450,'./nporder.php'),(20806258,9141,'./npordermiscremote.php'),(20806257,20160,'./npordermiscremote.php'),(20806462,20253,'./npordersave.php'),(20813852,2200,'./includes/functions.php'),(20813847,15592,'./includes/functions.php'),(20813848,18323,'./includes/functions.php'),(20813849,5865,'./includes/functions.php'),(20813850,8290,'./includes/functions.php'),(20813851,2165,'./includes/functions.php'),(20782772,16948,'./!/application/controllers/main.php'),(20782771,7903,'./!/application/controllers/main.php'),(20782770,12003,'./!/application/controllers/main.php'),(20782769,11854,'./!/application/controllers/main.php'),(20782768,13827,'./!/application/controllers/main.php'),(20782767,8727,'./!/application/controllers/main.php'),(20782766,1948,'./!/application/controllers/main.php'),(20782765,16918,'./!/application/controllers/main.php'),(20782764,7899,'./!/application/controllers/main.php'),(20782763,3704,'./!/application/controllers/main.php'),(20782760,8628,'./!/application/controllers/main.php'),(20785106,14606,'./!/application/views/chunks/ui_style_properties.php'),(20784607,18128,'./!/application/views/appointments/admin.php'),(20784606,10281,'./!/application/views/appointments/admin.php'),(20784605,17483,'./!/application/views/appointments/admin.php'),(20784604,18127,'./!/application/views/appointments/admin.php'),(20784603,17975,'./!/application/views/appointments/admin.php'),(20784602,17482,'./!/application/views/appointments/admin.php'),(20784601,17481,'./!/application/views/appointments/admin.php'),(20784600,2099,'./!/application/views/appointments/admin.php'),(20784599,1935,'./!/application/views/appointments/admin.php'),(20784598,19630,'./!/application/views/appointments/admin.php'),(20784597,20027,'./!/application/views/appointments/admin.php'),(20784596,20026,'./!/application/views/appointments/admin.php'),(20784595,18814,'./!/application/views/appointments/admin.php'),(20784594,18813,'./!/application/views/appointments/admin.php'),(20786489,16962,'./!/application/views/shopify/admin.php'),(20786488,16961,'./!/application/views/shopify/admin.php'),(20787383,14098,'./adminarcompanyupd.php'),(20788202,416,'./adminemail.php'),(20789756,55,'./adminsurvey.php'),(20790294,315,'./apbillpay.php'),(20790372,479,'./apbillpay_preapproved.php'),(20790371,445,'./apbillpay_preapproved.php'),(20791796,13911,'./arcustchange.php'),(20791795,315,'./arcustchange.php'),(20791794,17492,'./arcustchange.php'),(20793447,479,'./arinvoiceupd.php'),(20793618,1668,'./arinvoiceview.php'),(20802155,16069,'./importinvoices.php'),(20802154,16039,'./importinvoices.php'),(20802153,9492,'./importinvoices.php'),(20805946,17047,'./nporder.php'),(20805945,3930,'./nporder.php'),(20805944,13939,'./nporder.php'),(20805943,18098,'./nporder.php'),(20805942,8730,'./nporder.php'),(20805941,8903,'./nporder.php'),(20811633,7498,'./includes/arfunctions.php'),(20812277,6205,'./includes/contactinfo.php'),(20812326,8230,'./includes/createmenu2.inc'),(20814815,8544,'./includes/invoicesoldshipformat.php'),(20814818,2329,'./includes/invoicesoldshipformat.php'),(20814817,13959,'./includes/invoicesoldshipformat.php'),(20814816,2327,'./includes/invoicesoldshipformat.php'),(20779401,6887,'./!/application/controllers/arorder.php'),(20779880,8508,'./!/application/controllers/ccterminal.php'),(20779879,2702,'./!/application/controllers/ccterminal.php'),(20779878,5876,'./!/application/controllers/ccterminal.php'),(20779877,16464,'./!/application/controllers/ccterminal.php'),(20779876,14117,'./!/application/controllers/ccterminal.php'),(20779875,17514,'./!/application/controllers/ccterminal.php'),(20779874,1973,'./!/application/controllers/ccterminal.php'),(20779873,1963,'./!/application/controllers/ccterminal.php'),(20779872,17513,'./!/application/controllers/ccterminal.php'),(20779871,17512,'./!/application/controllers/ccterminal.php'),(20779870,17511,'./!/application/controllers/ccterminal.php'),(20779869,17510,'./!/application/controllers/ccterminal.php'),(20779868,17509,'./!/application/controllers/ccterminal.php'),(20779867,1788,'./!/application/controllers/ccterminal.php'),(20779866,17076,'./!/application/controllers/ccterminal.php'),(20779865,1557,'./!/application/controllers/ccterminal.php'),(20779864,17508,'./!/application/controllers/ccterminal.php'),(20779863,10384,'./!/application/controllers/ccterminal.php'),(20779862,16089,'./!/application/controllers/ccterminal.php'),(20779861,1143,'./!/application/controllers/ccterminal.php'),(20779860,1047,'./!/application/controllers/ccterminal.php'),(20779859,17507,'./!/application/controllers/ccterminal.php'),(20779858,941,'./!/application/controllers/ccterminal.php'),(20779857,17506,'./!/application/controllers/ccterminal.php'),(20779856,4602,'./!/application/controllers/ccterminal.php'),(20779855,869,'./!/application/controllers/ccterminal.php'),(20779854,799,'./!/application/controllers/ccterminal.php'),(20779853,17075,'./!/application/controllers/ccterminal.php'),(20779852,17505,'./!/application/controllers/ccterminal.php'),(20779851,776,'./!/application/controllers/ccterminal.php'),(20779850,17083,'./!/application/controllers/ccterminal.php'),(20779849,17504,'./!/application/controllers/ccterminal.php'),(20779848,548,'./!/application/controllers/ccterminal.php'),(20779847,18167,'./!/application/controllers/ccterminal.php'),(20779846,16712,'./!/application/controllers/ccterminal.php'),(20779845,13421,'./!/application/controllers/ccterminal.php'),(20779844,18510,'./!/application/controllers/ccterminal.php'),(20779843,18803,'./!/application/controllers/ccterminal.php'),(20779842,17074,'./!/application/controllers/ccterminal.php'),(20779841,17503,'./!/application/controllers/ccterminal.php'),(20779840,504,'./!/application/controllers/ccterminal.php'),(20780280,15996,'./!/application/controllers/customer.php'),(20780279,15941,'./!/application/controllers/customer.php'),(20780278,2788,'./!/application/controllers/customer.php'),(20780277,11761,'./!/application/controllers/customer.php'),(20780276,2751,'./!/application/controllers/customer.php'),(20780275,2738,'./!/application/controllers/customer.php'),(20780274,8545,'./!/application/controllers/customer.php'),(20780273,2691,'./!/application/controllers/customer.php'),(20780272,19336,'./!/application/controllers/customer.php'),(20780271,2676,'./!/application/controllers/customer.php'),(20780270,17561,'./!/application/controllers/customer.php'),(20780269,19335,'./!/application/controllers/customer.php'),(20780268,19334,'./!/application/controllers/customer.php'),(20780267,19333,'./!/application/controllers/customer.php'),(20780266,17560,'./!/application/controllers/customer.php'),(20780265,16558,'./!/application/controllers/customer.php'),(20780264,2698,'./!/application/controllers/customer.php'),(20780263,13662,'./!/application/controllers/customer.php'),(20780262,19332,'./!/application/controllers/customer.php'),(20780261,7674,'./!/application/controllers/customer.php'),(20780260,18513,'./!/application/controllers/customer.php'),(20780259,13365,'./!/application/controllers/customer.php'),(20780258,19524,'./!/application/controllers/customer.php'),(20780257,19331,'./!/application/controllers/customer.php'),(20780256,14823,'./!/application/controllers/customer.php'),(20780255,2508,'./!/application/controllers/customer.php'),(20780254,17559,'./!/application/controllers/customer.php'),(20780253,13818,'./!/application/controllers/customer.php'),(20780252,19897,'./!/application/controllers/customer.php'),(20780251,19330,'./!/application/controllers/customer.php'),(20780250,15867,'./!/application/controllers/customer.php'),(20780249,2459,'./!/application/controllers/customer.php'),(20780248,2405,'./!/application/controllers/customer.php'),(20780247,18589,'./!/application/controllers/customer.php'),(20780246,15768,'./!/application/controllers/customer.php'),(20780245,2363,'./!/application/controllers/customer.php'),(20780244,17781,'./!/application/controllers/customer.php'),(20780243,17558,'./!/application/controllers/customer.php'),(20780242,17557,'./!/application/controllers/customer.php'),(20780241,17556,'./!/application/controllers/customer.php'),(20780240,17555,'./!/application/controllers/customer.php'),(20780239,17554,'./!/application/controllers/customer.php'),(20780238,17553,'./!/application/controllers/customer.php'),(20780237,17552,'./!/application/controllers/customer.php'),(20780236,17551,'./!/application/controllers/customer.php'),(20780235,17550,'./!/application/controllers/customer.php'),(20780234,14658,'./!/application/controllers/customer.php'),(20780233,17549,'./!/application/controllers/customer.php'),(20780232,17548,'./!/application/controllers/customer.php'),(20780231,17547,'./!/application/controllers/customer.php'),(20780230,2324,'./!/application/controllers/customer.php'),(20780229,15767,'./!/application/controllers/customer.php'),(20780228,18057,'./!/application/controllers/customer.php'),(20780227,6721,'./!/application/controllers/customer.php'),(20780226,2222,'./!/application/controllers/customer.php'),(20780225,18898,'./!/application/controllers/customer.php'),(20780224,2208,'./!/application/controllers/customer.php'),(20780223,2165,'./!/application/controllers/customer.php'),(20780517,1019,'./!/application/controllers/gltransvoucher.php'),(20780516,1014,'./!/application/controllers/gltransvoucher.php'),(20780515,869,'./!/application/controllers/gltransvoucher.php'),(20780514,776,'./!/application/controllers/gltransvoucher.php'),(20780513,737,'./!/application/controllers/gltransvoucher.php'),(20780512,670,'./!/application/controllers/gltransvoucher.php'),(20780511,15354,'./!/application/controllers/gltransvoucher.php'),(20780510,9492,'./!/application/controllers/gltransvoucher.php'),(20780509,567,'./!/application/controllers/gltransvoucher.php'),(20780508,337,'./!/application/controllers/gltransvoucher.php'),(20780507,333,'./!/application/controllers/gltransvoucher.php'),(20780506,315,'./!/application/controllers/gltransvoucher.php'),(20780505,20,'./!/application/controllers/gltransvoucher.php'),(20782761,8588,'./!/application/controllers/main.php'),(20783796,16563,'./!/application/controllers/vendor.php'),(20783795,9323,'./!/application/controllers/vendor.php'),(20783794,8194,'./!/application/controllers/vendor.php'),(20783793,795,'./!/application/controllers/vendor.php'),(20783792,8271,'./!/application/controllers/vendor.php'),(20783791,698,'./!/application/controllers/vendor.php'),(20783790,13383,'./!/application/controllers/vendor.php'),(20783789,673,'./!/application/controllers/vendor.php'),(20783788,16555,'./!/application/controllers/vendor.php'),(20783787,16554,'./!/application/controllers/vendor.php'),(20783786,659,'./!/application/controllers/vendor.php'),(20783785,16717,'./!/application/controllers/vendor.php'),(20784138,14667,'./!/application/libraries/settings_form.php'),(20785076,17072,'./!/application/views/ccterminal/edit_select_footer.php'),(20785077,6314,'./!/application/views/ccterminal/selectTerminal.php'),(20785522,315,'./!/application/views/generic/interrupt_save_check.php'),(20785308,20039,'./!/application/views/customfields/report_assignmembershipcoaches.php'),(20785297,3072,'./!/application/views/customer/report_custom_search.php'),(20785296,17583,'./!/application/views/customer/report_custom_search.php'),(20785295,17564,'./!/application/views/customer/report_custom_search.php'),(20785294,17582,'./!/application/views/customer/report_custom_search.php'),(20785293,2901,'./!/application/views/customer/report_custom_search.php'),(20785292,14048,'./!/application/views/customer/report_custom_search.php'),(20785291,11535,'./!/application/views/customer/report_custom_search.php'),(20785290,17581,'./!/application/views/customer/report_custom_search.php'),(20785289,2671,'./!/application/views/customer/report_custom_search.php'),(20785288,17580,'./!/application/views/customer/report_custom_search.php'),(20785287,17579,'./!/application/views/customer/report_custom_search.php'),(20785286,17543,'./!/application/views/customer/report_custom_search.php'),(20785285,14611,'./!/application/views/customer/report_custom_search.php'),(20785284,1578,'./!/application/views/customer/report_custom_search.php'),(20785283,1467,'./!/application/views/customer/report_custom_search.php'),(20785282,17578,'./!/application/views/customer/report_custom_search.php'),(20785281,17577,'./!/application/views/customer/report_custom_search.php'),(20785280,739,'./!/application/views/customer/report_custom_search.php'),(20785279,12992,'./!/application/views/customer/report_custom_search.php'),(20785278,17532,'./!/application/views/customer/report_custom_search.php'),(20785277,17527,'./!/application/views/customer/report_custom_search.php'),(20785276,17522,'./!/application/views/customer/report_custom_search.php'),(20785539,2222,'./!/application/views/generic/paginated_query_table.php'),(20785538,4789,'./!/application/views/generic/paginated_query_table.php'),(20785537,1963,'./!/application/views/generic/paginated_query_table.php'),(20785536,5407,'./!/application/views/generic/paginated_query_table.php'),(20785909,15880,'./!/application/views/job/tab_view.php'),(20785908,15879,'./!/application/views/job/tab_view.php'),(20786716,16393,'./!/application/views/vendor/mass_update.php'),(20786771,17816,'./admin3dcart.php'),(20787382,17457,'./adminarcompanyupd.php'),(20787381,17456,'./adminarcompanyupd.php'),(20787380,7841,'./adminarcompanyupd.php'),(20787379,799,'./adminarcompanyupd.php'),(20787378,8109,'./adminarcompanyupd.php'),(20787377,13654,'./adminarcompanyupd.php'),(20787376,13653,'./adminarcompanyupd.php'),(20790251,683,'./apbilllistaging.php'),(20790250,9492,'./apbilllistaging.php'),(20790249,315,'./apbilllistaging.php'),(20790248,6669,'./apbilllistaging.php'),(20790247,12223,'./apbilllistaging.php'),(20790246,226,'./apbilllistaging.php'),(20790245,194,'./apbilllistaging.php'),(20790293,16929,'./apbillpay.php'),(20790292,272,'./apbillpay.php'),(20790291,226,'./apbillpay.php'),(20790290,6050,'./apbillpay.php'),(20790370,315,'./apbillpay_preapproved.php'),(20790369,6674,'./apbillpay_preapproved.php'),(20790368,6673,'./apbillpay_preapproved.php'),(20790367,272,'./apbillpay_preapproved.php'),(20790366,226,'./apbillpay_preapproved.php'),(20790365,6672,'./apbillpay_preapproved.php'),(20790460,348,'./apbillupd.php'),(20790459,18621,'./apbillupd.php'),(20790764,197,'./apchecklist.php'),(20791101,59,'./apvendupd.php'),(20791100,4713,'./apvendupd.php'),(20791399,11910,'./arbankreconcile.php'),(20791398,20,'./arbankreconcile.php'),(20791982,15041,'./arcustupd.php'),(20795502,3533,'./arpayplan_post.php'),(20800603,20119,'./glexpense.php'),(20800602,20118,'./glexpense.php'),(20800601,20117,'./glexpense.php'),(20800600,20116,'./glexpense.php'),(20800599,5430,'./glexpense.php'),(20800598,226,'./glexpense.php'),(20800636,315,'./glexpensetype.php'),(20800635,5203,'./glexpensetype.php'),(20800634,59,'./glexpensetype.php'),(20802063,9341,'./importgljournals.php'),(20802062,17613,'./importgljournals.php'),(20804693,961,'./invpoadd.php'),(20804692,941,'./invpoadd.php'),(20804691,19146,'./invpoadd.php'),(20805152,941,'./invpoupd.php'),(20805151,932,'./invpoupd.php'),(20805150,19146,'./invpoupd.php'),(20805940,6228,'./nporder.php'),(20805939,697,'./nporder.php'),(20805938,16698,'./nporder.php'),(20805937,684,'./nporder.php'),(20805936,9341,'./nporder.php'),(20805935,673,'./nporder.php'),(20808432,19311,'./premployeeupd.php'),(20808431,101,'./premployeeupd.php'),(20808430,185,'./premployeeupd.php'),(20808429,59,'./premployeeupd.php'),(20809978,607,'./prworkmanscomp.php'),(20809977,527,'./prworkmanscomp.php'),(20809976,524,'./prworkmanscomp.php'),(20809975,7039,'./prworkmanscomp.php'),(20809974,412,'./prworkmanscomp.php'),(20809973,315,'./prworkmanscomp.php'),(20809972,197,'./prworkmanscomp.php'),(20809971,7464,'./prworkmanscomp.php'),(20811217,154,'./includes/apfunctions.php'),(20811216,14918,'./includes/apfunctions.php'),(20811215,15728,'./includes/apfunctions.php'),(20811214,15727,'./includes/apfunctions.php'),(20811213,8797,'./includes/apfunctions.php'),(20811212,185,'./includes/apfunctions.php'),(20811538,1446,'./includes/arbankreconcile.functions.php'),(20811632,15307,'./includes/arfunctions.php'),(20811631,581,'./includes/arfunctions.php'),(20811630,15921,'./includes/arfunctions.php'),(20811996,673,'./includes/arinvoiceviewfpdf.functions.php'),(20814091,9305,'./includes/genfunctions.php'),(20814090,16419,'./includes/genfunctions.php'),(20814089,581,'./includes/genfunctions.php'),(20814088,8353,'./includes/genfunctions.php'),(20814449,17777,'./includes/header.php'),(20814448,16380,'./includes/header.php'),(20814447,18975,'./includes/header.php'),(20814446,13968,'./includes/header.php'),(20814445,17776,'./includes/header.php'),(20814444,12097,'./includes/header.php'),(20814443,2222,'./includes/header.php'),(20778877,6085,'./!/application/controllers/appointments.php'),(20778876,2702,'./!/application/controllers/appointments.php'),(20778875,2328,'./!/application/controllers/appointments.php'),(20778874,17636,'./!/application/controllers/appointments.php'),(20778873,17635,'./!/application/controllers/appointments.php'),(20778897,15938,'./!/application/controllers/archive_reports.php'),(20778880,17638,'./!/application/controllers/aradmin.php'),(20778879,17637,'./!/application/controllers/aradmin.php'),(20778878,2702,'./!/application/controllers/aradmin.php'),(20779278,3252,'./!/application/controllers/arinvoice.php'),(20779400,9133,'./!/application/controllers/arorder.php'),(20779399,9249,'./!/application/controllers/arorder.php'),(20779398,4070,'./!/application/controllers/arorder.php'),(20779397,18998,'./!/application/controllers/arorder.php'),(20779396,6311,'./!/application/controllers/arorder.php'),(20779395,2200,'./!/application/controllers/arorder.php'),(20779394,2165,'./!/application/controllers/arorder.php'),(20779393,8290,'./!/application/controllers/arorder.php'),(20779277,3202,'./!/application/controllers/arinvoice.php'),(20778987,3333,'./!/application/controllers/ardailyclose.php'),(20778986,7343,'./!/application/controllers/ardailyclose.php'),(20778985,18887,'./!/application/controllers/ardailyclose.php'),(20778984,17663,'./!/application/controllers/ardailyclose.php'),(20778983,17662,'./!/application/controllers/ardailyclose.php'),(20778982,17661,'./!/application/controllers/ardailyclose.php'),(20778981,17660,'./!/application/controllers/ardailyclose.php'),(20778980,17659,'./!/application/controllers/ardailyclose.php'),(20778979,17658,'./!/application/controllers/ardailyclose.php'),(20778978,17657,'./!/application/controllers/ardailyclose.php'),(20778977,8508,'./!/application/controllers/ardailyclose.php'),(20782759,17290,'./!/application/controllers/main.php'),(20782757,19290,'./!/application/controllers/main.php'),(20784776,5492,'./!/application/views/aradmin/ordernumbering.php'),(20784775,2540,'./!/application/views/aradmin/ordernumbering.php'),(20784774,17668,'./!/application/views/aradmin/ordernumbering.php'),(20784773,17667,'./!/application/views/aradmin/ordernumbering.php'),(20784772,2109,'./!/application/views/aradmin/ordernumbering.php'),(20784771,2099,'./!/application/views/aradmin/ordernumbering.php'),(20784791,5070,'./!/application/views/ardailyclose/create.js.php'),(20784790,17678,'./!/application/views/ardailyclose/create.js.php'),(20784789,1047,'./!/application/views/ardailyclose/create.js.php'),(20784788,17670,'./!/application/views/ardailyclose/create.js.php'),(20785616,16614,'./!/application/views/invcotransfer/assignByZone_form.php'),(20785752,19642,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20784793,1668,'./!/application/views/ardailyclose/create_get_system_totals.cash.php'),(20784794,7676,'./!/application/views/ardailyclose/create_get_system_totals.cash.php'),(20784795,2267,'./!/application/views/ardailyclose/create_get_system_totals.cash.php'),(20784796,9612,'./!/application/views/ardailyclose/create_get_system_totals.cash.php'),(20784807,3090,'./!/application/views/ardailyclose/create_get_system_totals.checks.php'),(20784806,17675,'./!/application/views/ardailyclose/create_get_system_totals.checks.php'),(20784805,9612,'./!/application/views/ardailyclose/create_get_system_totals.checks.php'),(20784804,2267,'./!/application/views/ardailyclose/create_get_system_totals.checks.php'),(20784803,7676,'./!/application/views/ardailyclose/create_get_system_totals.checks.php'),(20784802,1668,'./!/application/views/ardailyclose/create_get_system_totals.checks.php'),(20784820,3090,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.php'),(20784819,17078,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.php'),(20784818,17674,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.php'),(20784817,9612,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.php'),(20784816,2267,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.php'),(20784815,7676,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.php'),(20784814,1668,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.php'),(20784813,737,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.php'),(20784812,17676,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.php'),(20784811,226,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.php'),(20792941,332,'./arinvoicereppay.php'),(20808904,15427,'./prrpt.php'),(20814989,30,'./includes/prfunctions.php'),(20802061,17750,'./importgljournals.php'),(20802060,9492,'./importgljournals.php'),(20778808,3221,'./!/application/controllers/amazon.php'),(20778807,17679,'./!/application/controllers/amazon.php'),(20778806,16950,'./!/application/controllers/amazon.php'),(20778805,14823,'./!/application/controllers/amazon.php'),(20779701,3227,'./!/application/controllers/bank_deposit.php'),(20779700,6964,'./!/application/controllers/bank_deposit.php'),(20779699,3090,'./!/application/controllers/bank_deposit.php'),(20779698,17685,'./!/application/controllers/bank_deposit.php'),(20779697,4023,'./!/application/controllers/bank_deposit.php'),(20779696,5875,'./!/application/controllers/bank_deposit.php'),(20779695,1668,'./!/application/controllers/bank_deposit.php'),(20779694,14611,'./!/application/controllers/bank_deposit.php'),(20779693,17690,'./!/application/controllers/bank_deposit.php'),(20779692,1578,'./!/application/controllers/bank_deposit.php'),(20779691,15970,'./!/application/controllers/bank_deposit.php'),(20779690,17684,'./!/application/controllers/bank_deposit.php'),(20779711,4871,'./!/application/controllers/batchimport.php'),(20779968,9623,'./!/application/controllers/contact.php'),(20782758,17694,'./!/application/controllers/main.php'),(20782756,17693,'./!/application/controllers/main.php'),(20782755,19902,'./!/application/controllers/main.php'),(20782754,14620,'./!/application/controllers/main.php'),(20783784,606,'./!/application/controllers/vendor.php'),(20783783,17961,'./!/application/controllers/vendor.php'),(20783782,581,'./!/application/controllers/vendor.php'),(20783781,14203,'./!/application/controllers/vendor.php'),(20783780,541,'./!/application/controllers/vendor.php'),(20783779,524,'./!/application/controllers/vendor.php'),(20783778,479,'./!/application/controllers/vendor.php'),(20783777,17700,'./!/application/controllers/vendor.php'),(20783776,15709,'./!/application/controllers/vendor.php'),(20783775,16435,'./!/application/controllers/vendor.php'),(20783774,17444,'./!/application/controllers/vendor.php'),(20783773,16434,'./!/application/controllers/vendor.php'),(20783772,17086,'./!/application/controllers/vendor.php'),(20783771,15707,'./!/application/controllers/vendor.php'),(20783770,17085,'./!/application/controllers/vendor.php'),(20783769,17699,'./!/application/controllers/vendor.php'),(20783768,17084,'./!/application/controllers/vendor.php'),(20783949,17711,'./!/application/controllers/waiver.php'),(20783948,17960,'./!/application/controllers/waiver.php'),(20783947,17688,'./!/application/controllers/waiver.php'),(20783946,3319,'./!/application/controllers/waiver.php'),(20783945,3156,'./!/application/controllers/waiver.php'),(20783944,2738,'./!/application/controllers/waiver.php'),(20783943,17710,'./!/application/controllers/waiver.php'),(20783942,4721,'./!/application/controllers/waiver.php'),(20783954,17582,'./!/application/controllers/waivertype.php'),(20783953,2488,'./!/application/controllers/waivertype.php'),(20783952,4721,'./!/application/controllers/waivertype.php'),(20783951,1935,'./!/application/controllers/waivertype.php'),(20783950,17712,'./!/application/controllers/waivertype.php'),(20783978,941,'./!/application/core/MY_Controller.php'),(20783977,799,'./!/application/core/MY_Controller.php'),(20783976,315,'./!/application/core/MY_Controller.php'),(18878397,17729,'!/application/models/amazon_model.php'),(18878396,17728,'!/application/models/amazon_model.php'),(18878395,17727,'!/application/models/amazon_model.php'),(18878394,14823,'!/application/models/amazon_model.php'),(18878393,17726,'!/application/models/amazon_model.php'),(18878392,17725,'!/application/models/amazon_model.php'),(18878391,17724,'!/application/models/amazon_model.php'),(18878390,17723,'!/application/models/amazon_model.php'),(18878389,17722,'!/application/models/amazon_model.php'),(18878388,17721,'!/application/models/amazon_model.php'),(18878387,17720,'!/application/models/amazon_model.php'),(18878386,17719,'!/application/models/amazon_model.php'),(18878385,17718,'!/application/models/amazon_model.php'),(18878384,17717,'!/application/models/amazon_model.php'),(18878383,17716,'!/application/models/amazon_model.php'),(20781710,7192,'./!/application/controllers/item.php'),(20784548,2948,'./!/application/views/amazon/import_order_selection_table.php'),(20784517,17735,'./!/application/views/amazon/admin.php'),(20784516,3186,'./!/application/views/amazon/admin.php'),(20784515,17734,'./!/application/views/amazon/admin.php'),(20784514,17733,'./!/application/views/amazon/admin.php'),(20784513,17732,'./!/application/views/amazon/admin.php'),(20784512,16990,'./!/application/views/amazon/admin.php'),(20784511,4608,'./!/application/views/amazon/admin.php'),(20784510,16979,'./!/application/views/amazon/admin.php'),(20784509,16976,'./!/application/views/amazon/admin.php'),(20784508,17731,'./!/application/views/amazon/admin.php'),(20784507,799,'./!/application/views/amazon/admin.php'),(20784506,17341,'./!/application/views/amazon/admin.php'),(20784505,5759,'./!/application/views/amazon/admin.php'),(20784504,17340,'./!/application/views/amazon/admin.php'),(20784503,9438,'./!/application/views/amazon/admin.php'),(20784502,17339,'./!/application/views/amazon/admin.php'),(20784501,17367,'./!/application/views/amazon/admin.php'),(20784500,5727,'./!/application/views/amazon/admin.php'),(20784499,8194,'./!/application/views/amazon/admin.php'),(20784498,17336,'./!/application/views/amazon/admin.php'),(20784497,13998,'./!/application/views/amazon/admin.php'),(20784496,17730,'./!/application/views/amazon/admin.php'),(20784495,8125,'./!/application/views/amazon/admin.php'),(20784494,17970,'./!/application/views/amazon/admin.php'),(20784493,6466,'./!/application/views/amazon/admin.php'),(20784492,17616,'./!/application/views/amazon/admin.php'),(20784491,17331,'./!/application/views/amazon/admin.php'),(20784526,2975,'./!/application/views/amazon/admin_add_store.php'),(20784525,17734,'./!/application/views/amazon/admin_add_store.php'),(20784524,17733,'./!/application/views/amazon/admin_add_store.php'),(20784523,17732,'./!/application/views/amazon/admin_add_store.php'),(20784522,17736,'./!/application/views/amazon/admin_add_store.php'),(20784521,17731,'./!/application/views/amazon/admin_add_store.php'),(20784529,17737,'./!/application/views/amazon/admin_select_store.php'),(20784528,4608,'./!/application/views/amazon/admin_select_store.php'),(20784527,17374,'./!/application/views/amazon/admin_select_store.php'),(20785871,981,'./!/application/views/job/send_prelim_request_form.php'),(20785907,15878,'./!/application/views/job/tab_view.php'),(20785906,15977,'./!/application/views/job/tab_view.php'),(20785905,1743,'./!/application/views/job/tab_view.php'),(20785904,19831,'./!/application/views/job/tab_view.php'),(20786487,8125,'./!/application/views/shopify/admin.php'),(20786486,9442,'./!/application/views/shopify/admin.php'),(20787374,19408,'./adminarcompanyupd.php'),(20787740,638,'./adminarglacct.php'),(20787739,18262,'./adminarglacct.php'),(20791853,315,'./arcustlist.php'),(20791852,197,'./arcustlist.php'),(20792189,15755,'./arinvoiceadd.php'),(20795937,15755,'./arserviceordadd.php'),(20796130,6030,'./arserviceordupd.php'),(20800324,19273,'./glacctadd.php'),(20800323,19272,'./glacctadd.php'),(20800322,542,'./glacctadd.php'),(20800321,6165,'./glacctadd.php'),(20800358,104,'./glacctupd.php'),(20800357,59,'./glacctupd.php'),(20800356,5206,'./glacctupd.php'),(20800355,52,'./glacctupd.php'),(20801097,6469,'./glrepactivity.php'),(20801096,6468,'./glrepactivity.php'),(20801822,15840,'./importcustomer.php'),(20801821,15839,'./importcustomer.php'),(20801820,15838,'./importcustomer.php'),(20801819,185,'./importcustomer.php'),(20801818,13083,'./importcustomer.php'),(20802059,315,'./importgljournals.php'),(20802058,226,'./importgljournals.php'),(20802057,16064,'./importgljournals.php'),(20803040,18780,'./invitemadd.php'),(20804198,14965,'./invitemupd.php'),(20805506,16366,'./jobupd.php'),(20805505,16365,'./jobupd.php'),(20805504,17754,'./jobupd.php'),(20805503,17753,'./jobupd.php'),(20805502,16363,'./jobupd.php'),(20805501,5203,'./jobupd.php'),(20805500,11354,'./jobupd.php'),(20805499,15913,'./jobupd.php'),(20805498,9967,'./jobupd.php'),(20808208,789,'./premplded.php'),(20808207,15420,'./premplded.php'),(20808206,15419,'./premplded.php'),(20808205,6617,'./premplded.php'),(20808204,6616,'./premplded.php'),(20808203,17764,'./premplded.php'),(20808202,332,'./premplded.php'),(20808201,315,'./premplded.php'),(20808200,226,'./premplded.php'),(20808199,17763,'./premplded.php'),(20811211,176,'./includes/apfunctions.php'),(20811515,16160,'./includes/arbankdepositadd.functions.php'),(20811636,14691,'./includes/arfunctions.php'),(20811629,7093,'./includes/arfunctions.php'),(20811628,7092,'./includes/arfunctions.php'),(20812139,17103,'./includes/auto_complete_field_check.php'),(20812276,6204,'./includes/contactinfo.php'),(20813846,2143,'./includes/functions.php'),(20813845,2129,'./includes/functions.php'),(20813844,2044,'./includes/functions.php'),(20814277,5228,'./includes/glfunctions.php'),(20814276,23,'./includes/glfunctions.php'),(20814275,5227,'./includes/glfunctions.php'),(20814442,15251,'./includes/header.php'),(20814441,15150,'./includes/header.php'),(20778804,864,'./!/application/controllers/amazon.php'),(20779392,2160,'./!/application/controllers/arorder.php'),(20779391,2155,'./!/application/controllers/arorder.php'),(20779998,16583,'./!/application/controllers/county.php'),(20779997,16540,'./!/application/controllers/county.php'),(20779996,176,'./!/application/controllers/county.php'),(20780222,2151,'./!/application/controllers/customer.php'),(20780361,17872,'./!/application/controllers/employee.php'),(20780360,17787,'./!/application/controllers/employee.php'),(20780359,2948,'./!/application/controllers/employee.php'),(20780358,2936,'./!/application/controllers/employee.php'),(20780357,17785,'./!/application/controllers/employee.php'),(20780356,17784,'./!/application/controllers/employee.php'),(20780354,18901,'./!/application/controllers/employee.php'),(20782066,675,'./!/application/controllers/job.php'),(20782065,17284,'./!/application/controllers/job.php'),(20782064,668,'./!/application/controllers/job.php'),(20782288,11792,'./!/application/controllers/jobitem.php'),(20782287,17803,'./!/application/controllers/jobitem.php'),(20782286,3097,'./!/application/controllers/jobitem.php'),(20782285,3434,'./!/application/controllers/jobitem.php'),(20782284,2813,'./!/application/controllers/jobitem.php'),(20782283,17802,'./!/application/controllers/jobitem.php'),(20782282,2529,'./!/application/controllers/jobitem.php'),(20782281,2165,'./!/application/controllers/jobitem.php'),(20782280,1884,'./!/application/controllers/jobitem.php'),(20782279,16035,'./!/application/controllers/jobitem.php'),(20782278,17801,'./!/application/controllers/jobitem.php'),(20782277,17800,'./!/application/controllers/jobitem.php'),(20782276,17799,'./!/application/controllers/jobitem.php'),(20782275,9622,'./!/application/controllers/jobitem.php'),(20782274,5081,'./!/application/controllers/jobitem.php'),(20782273,17956,'./!/application/controllers/jobitem.php'),(20782272,1696,'./!/application/controllers/jobitem.php'),(20782271,1647,'./!/application/controllers/jobitem.php'),(20782270,17798,'./!/application/controllers/jobitem.php'),(20782269,17797,'./!/application/controllers/jobitem.php'),(20782268,17796,'./!/application/controllers/jobitem.php'),(20782267,17795,'./!/application/controllers/jobitem.php'),(20782266,17794,'./!/application/controllers/jobitem.php'),(20782265,17793,'./!/application/controllers/jobitem.php'),(20782264,1134,'./!/application/controllers/jobitem.php'),(20782263,5141,'./!/application/controllers/jobitem.php'),(20782262,1014,'./!/application/controllers/jobitem.php'),(20782261,869,'./!/application/controllers/jobitem.php'),(20782260,737,'./!/application/controllers/jobitem.php'),(20782259,634,'./!/application/controllers/jobitem.php'),(20782258,9492,'./!/application/controllers/jobitem.php'),(20782257,17792,'./!/application/controllers/jobitem.php'),(20782752,14039,'./!/application/controllers/main.php'),(20783767,15706,'./!/application/controllers/vendor.php'),(20783941,17709,'./!/application/controllers/waiver.php'),(20783940,9622,'./!/application/controllers/waiver.php'),(20783939,9390,'./!/application/controllers/waiver.php'),(20784309,16785,'./!/application/models/arorder_model.php'),(20784308,2540,'./!/application/models/arorder_model.php'),(20784307,2231,'./!/application/models/arorder_model.php'),(20784989,15943,'./!/application/views/arorder/batchShipAndInvoice.php'),(20784993,17808,'./!/application/views/arorder/batchShipAndInvoice_PrintAllForm.php'),(20785973,17813,'./!/application/views/jobitem/edit.php'),(20785972,17812,'./!/application/views/jobitem/edit.php'),(20785971,17811,'./!/application/views/jobitem/edit.php'),(20785970,17810,'./!/application/views/jobitem/edit.php'),(20785969,17809,'./!/application/views/jobitem/edit.php'),(20785968,3252,'./!/application/views/jobitem/edit.php'),(20785967,3129,'./!/application/views/jobitem/edit.php'),(20785966,2702,'./!/application/views/jobitem/edit.php'),(20785965,2529,'./!/application/views/jobitem/edit.php'),(20785964,2165,'./!/application/views/jobitem/edit.php'),(20785963,5525,'./!/application/views/jobitem/edit.php'),(20785962,2137,'./!/application/views/jobitem/edit.php'),(20785961,1788,'./!/application/views/jobitem/edit.php'),(20785960,5081,'./!/application/views/jobitem/edit.php'),(20785959,1696,'./!/application/views/jobitem/edit.php'),(20785958,15991,'./!/application/views/jobitem/edit.php'),(20785957,697,'./!/application/views/jobitem/edit.php'),(20785956,9492,'./!/application/views/jobitem/edit.php'),(20785955,6314,'./!/application/views/jobitem/edit.php'),(20786770,17815,'./admin3dcart.php'),(20786769,503,'./admin3dcart.php'),(20786768,416,'./admin3dcart.php'),(20786767,19833,'./admin3dcart.php'),(20786766,315,'./admin3dcart.php'),(20786765,8125,'./admin3dcart.php'),(20787375,6587,'./adminarcompanyupd.php'),(20787373,19407,'./adminarcompanyupd.php'),(20787372,6140,'./adminarcompanyupd.php'),(20791280,7866,'./arbankdepositadd.php'),(20791279,882,'./arbankdepositadd.php'),(20791278,869,'./arbankdepositadd.php'),(20791277,18270,'./arbankdepositadd.php'),(20791276,5901,'./arbankdepositadd.php'),(20791275,19249,'./arbankdepositadd.php'),(20791274,5844,'./arbankdepositadd.php'),(20791273,11909,'./arbankdepositadd.php'),(20791272,5839,'./arbankdepositadd.php'),(20791271,5860,'./arbankdepositadd.php'),(20791270,807,'./arbankdepositadd.php'),(20791269,737,'./arbankdepositadd.php'),(20791268,5661,'./arbankdepositadd.php'),(20791267,683,'./arbankdepositadd.php'),(20791266,673,'./arbankdepositadd.php'),(20791265,9492,'./arbankdepositadd.php'),(20791264,607,'./arbankdepositadd.php'),(20791263,19248,'./arbankdepositadd.php'),(20791262,479,'./arbankdepositadd.php'),(20791261,5843,'./arbankdepositadd.php'),(20791260,17822,'./arbankdepositadd.php'),(20791259,19247,'./arbankdepositadd.php'),(20791337,226,'./arbankdepositupd.php'),(20791336,197,'./arbankdepositupd.php'),(20791335,59,'./arbankdepositupd.php'),(20791334,5900,'./arbankdepositupd.php'),(20791723,542,'./arcustadd.php'),(20792566,18385,'./arinvoicepay.php'),(20792565,16088,'./arinvoicepay.php'),(20792564,479,'./arinvoicepay.php'),(20792563,15863,'./arinvoicepay.php'),(20792562,15892,'./arinvoicepay.php'),(20792561,17107,'./arinvoicepay.php'),(20792560,445,'./arinvoicepay.php'),(20794072,607,'./arorder2invoice.php'),(20796129,315,'./arserviceordupd.php'),(20796128,6771,'./arserviceordupd.php'),(20796127,5203,'./arserviceordupd.php'),(20796524,479,'./autofunctions.php'),(20799996,59,'./genuseradd.php'),(20800126,59,'./genuserupd.php'),(20801031,5170,'./gljourupdhv.php'),(20801030,3342,'./gljourupdhv.php'),(20801029,16449,'./gljourupdhv.php'),(20801028,16448,'./gljourupdhv.php'),(20801027,3333,'./gljourupdhv.php'),(20801026,16030,'./gljourupdhv.php'),(20801025,3090,'./gljourupdhv.php'),(20801024,16029,'./gljourupdhv.php'),(20801023,9407,'./gljourupdhv.php'),(20801022,2739,'./gljourupdhv.php'),(20801021,2710,'./gljourupdhv.php'),(20801020,2702,'./gljourupdhv.php'),(20801019,11430,'./gljourupdhv.php'),(20801018,5081,'./gljourupdhv.php'),(20801017,15991,'./gljourupdhv.php'),(20801016,17850,'./gljourupdhv.php'),(20801015,8936,'./gljourupdhv.php'),(20801014,3586,'./gljourupdhv.php'),(20801013,17849,'./gljourupdhv.php'),(20801012,941,'./gljourupdhv.php'),(20801011,869,'./gljourupdhv.php'),(20801010,5878,'./gljourupdhv.php'),(20801009,16027,'./gljourupdhv.php'),(20801008,776,'./gljourupdhv.php'),(20801007,9341,'./gljourupdhv.php'),(20801006,670,'./gljourupdhv.php'),(20801005,20249,'./gljourupdhv.php'),(20801004,9492,'./gljourupdhv.php'),(20801003,604,'./gljourupdhv.php'),(20801002,541,'./gljourupdhv.php'),(20801001,5877,'./gljourupdhv.php'),(20801000,315,'./gljourupdhv.php'),(20800999,12140,'./gljourupdhv.php'),(20800998,226,'./gljourupdhv.php'),(20800997,17848,'./gljourupdhv.php'),(20681092,17851,'./importitem_categories.php'),(20681091,637,'./importitem_categories.php'),(20681090,457,'./importitem_categories.php'),(20681089,7646,'./importitem_categories.php'),(20681088,7793,'./importitem_categories.php'),(20681087,315,'./importitem_categories.php'),(20681086,197,'./importitem_categories.php'),(20805434,9492,'./jobcostrpt.php'),(20805433,6165,'./jobcostrpt.php'),(20805432,479,'./jobcostrpt.php'),(20805689,524,'./lookupcustomer_alt.php'),(20805934,10617,'./nporder.php'),(20805933,15344,'./nporder.php'),(20805932,16681,'./nporder.php'),(20806442,2529,'./nporderremote.php'),(20806441,2044,'./nporderremote.php'),(20806440,16035,'./nporderremote.php'),(20806439,1742,'./nporderremote.php'),(20806438,17853,'./nporderremote.php'),(20806437,1709,'./nporderremote.php'),(20806436,14248,'./nporderremote.php'),(20806435,8936,'./nporderremote.php'),(20806434,1047,'./nporderremote.php'),(20806433,1036,'./nporderremote.php'),(20806432,869,'./nporderremote.php'),(20806431,799,'./nporderremote.php'),(20806430,14254,'./nporderremote.php'),(20806429,8125,'./nporderremote.php'),(20807787,7464,'./prchecksum.php'),(20808771,6132,'./prloghours.php'),(20811210,59,'./includes/apfunctions.php'),(20811209,6050,'./includes/apfunctions.php'),(20811208,5946,'./includes/apfunctions.php'),(20811627,571,'./includes/arfunctions.php'),(20811626,569,'./includes/arfunctions.php'),(20811625,13660,'./includes/arfunctions.php'),(20811624,19867,'./includes/arfunctions.php'),(20812312,11903,'./includes/content_top.php'),(20812325,14136,'./includes/createmenu2.inc'),(20813524,13617,'./includes/filesystemdb.php'),(20813523,11291,'./includes/filesystemdb.php'),(20813522,542,'./includes/filesystemdb.php'),(20813521,17070,'./includes/filesystemdb.php'),(20813631,12676,'./includes/footer.php'),(20813843,9423,'./includes/functions.php'),(20814087,6406,'./includes/genfunctions.php'),(20814086,578,'./includes/genfunctions.php'),(20814085,575,'./includes/genfunctions.php'),(20814084,573,'./includes/genfunctions.php'),(20814083,7992,'./includes/genfunctions.php'),(20814082,524,'./includes/genfunctions.php'),(20814081,6165,'./includes/genfunctions.php'),(20814080,7952,'./includes/genfunctions.php'),(20814079,17121,'./includes/genfunctions.php'),(20814078,19514,'./includes/genfunctions.php'),(20814077,17120,'./includes/genfunctions.php'),(20814076,18702,'./includes/genfunctions.php'),(20814075,18701,'./includes/genfunctions.php'),(20814074,18700,'./includes/genfunctions.php'),(20814073,13088,'./includes/genfunctions.php'),(20814072,15083,'./includes/genfunctions.php'),(20814071,20169,'./includes/genfunctions.php'),(20814070,17870,'./includes/genfunctions.php'),(20814069,15694,'./includes/genfunctions.php'),(20814068,19159,'./includes/genfunctions.php'),(20814067,19513,'./includes/genfunctions.php'),(20814066,17869,'./includes/genfunctions.php'),(20814065,14521,'./includes/genfunctions.php'),(20814064,14140,'./includes/genfunctions.php'),(20814063,14096,'./includes/genfunctions.php'),(20814062,15856,'./includes/genfunctions.php'),(20814061,18699,'./includes/genfunctions.php'),(20814060,18698,'./includes/genfunctions.php'),(20814059,13143,'./includes/genfunctions.php'),(20814058,13519,'./includes/genfunctions.php'),(20814057,19795,'./includes/genfunctions.php'),(20814056,15595,'./includes/genfunctions.php'),(20814055,18829,'./includes/genfunctions.php'),(20814054,18972,'./includes/genfunctions.php'),(20779276,14946,'./!/application/controllers/arinvoice.php'),(20779275,18899,'./!/application/controllers/arinvoice.php'),(20779274,3450,'./!/application/controllers/arinvoice.php'),(20779273,3173,'./!/application/controllers/arinvoice.php'),(20779272,16431,'./!/application/controllers/arinvoice.php'),(20779271,3156,'./!/application/controllers/arinvoice.php'),(20779270,3118,'./!/application/controllers/arinvoice.php'),(20779269,3090,'./!/application/controllers/arinvoice.php'),(20779268,16148,'./!/application/controllers/arinvoice.php'),(20779267,3072,'./!/application/controllers/arinvoice.php'),(20779266,17895,'./!/application/controllers/arinvoice.php'),(20779265,18996,'./!/application/controllers/arinvoice.php'),(20779264,17894,'./!/application/controllers/arinvoice.php'),(20779263,18995,'./!/application/controllers/arinvoice.php'),(20779261,7069,'./!/application/controllers/arinvoice.php'),(20779537,3948,'./!/application/controllers/arorderrentalpickup.php'),(20779536,2948,'./!/application/controllers/arorderrentalpickup.php'),(20779535,3913,'./!/application/controllers/arorderrentalpickup.php'),(20779534,17657,'./!/application/controllers/arorderrentalpickup.php'),(20779533,2819,'./!/application/controllers/arorderrentalpickup.php'),(20779532,6706,'./!/application/controllers/arorderrentalpickup.php'),(20779531,17912,'./!/application/controllers/arorderrentalpickup.php'),(20779530,17911,'./!/application/controllers/arorderrentalpickup.php'),(20779529,2738,'./!/application/controllers/arorderrentalpickup.php'),(20779528,8508,'./!/application/controllers/arorderrentalpickup.php'),(20779527,2702,'./!/application/controllers/arorderrentalpickup.php'),(20779526,19004,'./!/application/controllers/arorderrentalpickup.php'),(20779525,17910,'./!/application/controllers/arorderrentalpickup.php'),(20779524,2638,'./!/application/controllers/arorderrentalpickup.php'),(20779523,17715,'./!/application/controllers/arorderrentalpickup.php'),(20779522,17909,'./!/application/controllers/arorderrentalpickup.php'),(20779521,17908,'./!/application/controllers/arorderrentalpickup.php'),(20779520,17907,'./!/application/controllers/arorderrentalpickup.php'),(20779519,17906,'./!/application/controllers/arorderrentalpickup.php'),(20779518,17905,'./!/application/controllers/arorderrentalpickup.php'),(20779517,17904,'./!/application/controllers/arorderrentalpickup.php'),(20779516,16785,'./!/application/controllers/arorderrentalpickup.php'),(20779515,17903,'./!/application/controllers/arorderrentalpickup.php'),(20779514,17714,'./!/application/controllers/arorderrentalpickup.php'),(20779513,18732,'./!/application/controllers/arorderrentalpickup.php'),(20779512,19160,'./!/application/controllers/arorderrentalpickup.php'),(20779511,5120,'./!/application/controllers/arorderrentalpickup.php'),(20779510,18731,'./!/application/controllers/arorderrentalpickup.php'),(20779509,2508,'./!/application/controllers/arorderrentalpickup.php'),(20779508,2459,'./!/application/controllers/arorderrentalpickup.php'),(20779507,17902,'./!/application/controllers/arorderrentalpickup.php'),(20779506,17901,'./!/application/controllers/arorderrentalpickup.php'),(20779505,17900,'./!/application/controllers/arorderrentalpickup.php'),(20779504,17969,'./!/application/controllers/arorderrentalpickup.php'),(20779503,2315,'./!/application/controllers/arorderrentalpickup.php'),(20779502,18730,'./!/application/controllers/arorderrentalpickup.php'),(20779501,2182,'./!/application/controllers/arorderrentalpickup.php'),(20779500,15101,'./!/application/controllers/arorderrentalpickup.php'),(20779499,2165,'./!/application/controllers/arorderrentalpickup.php'),(20779498,18729,'./!/application/controllers/arorderrentalpickup.php'),(20779497,18376,'./!/application/controllers/arorderrentalpickup.php'),(20779496,19002,'./!/application/controllers/arorderrentalpickup.php'),(20779495,4721,'./!/application/controllers/arorderrentalpickup.php'),(20779621,2998,'./!/application/controllers/arordership.php'),(20779620,5863,'./!/application/controllers/arordership.php'),(20779619,16676,'./!/application/controllers/arordership.php'),(20779618,2948,'./!/application/controllers/arordership.php'),(20779617,3434,'./!/application/controllers/arordership.php'),(20779616,5426,'./!/application/controllers/arordership.php'),(20779615,19009,'./!/application/controllers/arordership.php'),(20779614,2819,'./!/application/controllers/arordership.php'),(20779613,19008,'./!/application/controllers/arordership.php'),(20779612,14765,'./!/application/controllers/arordership.php'),(20779611,2816,'./!/application/controllers/arordership.php'),(20779610,18159,'./!/application/controllers/arordership.php'),(20781708,2612,'./!/application/controllers/item.php'),(20781707,19079,'./!/application/controllers/item.php'),(20781706,19078,'./!/application/controllers/item.php'),(20781705,17908,'./!/application/controllers/item.php'),(20781704,18239,'./!/application/controllers/item.php'),(20781872,17936,'./!/application/controllers/itemlocation.php'),(20781871,17935,'./!/application/controllers/itemlocation.php'),(20781870,19366,'./!/application/controllers/itemlocation.php'),(20781869,18529,'./!/application/controllers/itemlocation.php'),(20781868,20209,'./!/application/controllers/itemlocation.php'),(20781867,19365,'./!/application/controllers/itemlocation.php'),(20781866,17279,'./!/application/controllers/itemlocation.php'),(20781865,18528,'./!/application/controllers/itemlocation.php'),(20781864,17934,'./!/application/controllers/itemlocation.php'),(20781863,8508,'./!/application/controllers/itemlocation.php'),(20781862,2664,'./!/application/controllers/itemlocation.php'),(20781861,17933,'./!/application/controllers/itemlocation.php'),(20781860,17917,'./!/application/controllers/itemlocation.php'),(20781859,2594,'./!/application/controllers/itemlocation.php'),(20781858,19823,'./!/application/controllers/itemlocation.php'),(20781857,18716,'./!/application/controllers/itemlocation.php'),(20781856,19822,'./!/application/controllers/itemlocation.php'),(20782063,15354,'./!/application/controllers/job.php'),(20782062,15349,'./!/application/controllers/job.php'),(20782061,659,'./!/application/controllers/job.php'),(20782060,15598,'./!/application/controllers/job.php'),(20782059,15915,'./!/application/controllers/job.php'),(20782058,15951,'./!/application/controllers/job.php'),(20782057,15950,'./!/application/controllers/job.php'),(20782056,11356,'./!/application/controllers/job.php'),(20782055,15914,'./!/application/controllers/job.php'),(20782054,606,'./!/application/controllers/job.php'),(20782053,16097,'./!/application/controllers/job.php'),(20782052,548,'./!/application/controllers/job.php'),(20782051,15949,'./!/application/controllers/job.php'),(20782050,543,'./!/application/controllers/job.php'),(20782049,541,'./!/application/controllers/job.php'),(20782048,11355,'./!/application/controllers/job.php'),(20782047,17789,'./!/application/controllers/job.php'),(20782046,524,'./!/application/controllers/job.php'),(20782045,17940,'./!/application/controllers/job.php'),(20782044,18059,'./!/application/controllers/job.php'),(20782043,17938,'./!/application/controllers/job.php'),(20782042,389,'./!/application/controllers/job.php'),(20782041,333,'./!/application/controllers/job.php'),(20782040,17019,'./!/application/controllers/job.php'),(20782256,11792,'./!/application/controllers/jobbudget.php'),(20782255,3156,'./!/application/controllers/jobbudget.php'),(20782254,3434,'./!/application/controllers/jobbudget.php'),(20782253,17802,'./!/application/controllers/jobbudget.php'),(20782252,2160,'./!/application/controllers/jobbudget.php'),(20782251,2094,'./!/application/controllers/jobbudget.php'),(20782250,2103,'./!/application/controllers/jobbudget.php'),(20782249,9622,'./!/application/controllers/jobbudget.php'),(20782248,17955,'./!/application/controllers/jobbudget.php'),(20782247,17954,'./!/application/controllers/jobbudget.php'),(20782246,17953,'./!/application/controllers/jobbudget.php'),(20782245,17952,'./!/application/controllers/jobbudget.php'),(20782244,10092,'./!/application/controllers/jobbudget.php'),(20782243,5081,'./!/application/controllers/jobbudget.php'),(20782753,18211,'./!/application/controllers/main.php'),(20782751,5396,'./!/application/controllers/main.php'),(20782750,19370,'./!/application/controllers/main.php'),(20782749,18210,'./!/application/controllers/main.php'),(20783766,17698,'./!/application/controllers/vendor.php'),(20783765,15705,'./!/application/controllers/vendor.php'),(20783764,17221,'./!/application/controllers/vendor.php'),(20783938,5081,'./!/application/controllers/waiver.php'),(20783937,17807,'./!/application/controllers/waiver.php'),(20783936,17708,'./!/application/controllers/waiver.php'),(20783935,941,'./!/application/controllers/waiver.php'),(20783934,5205,'./!/application/controllers/waiver.php'),(20783933,17707,'./!/application/controllers/waiver.php'),(20783932,17706,'./!/application/controllers/waiver.php'),(20783931,697,'./!/application/controllers/waiver.php'),(20783930,315,'./!/application/controllers/waiver.php'),(20783929,226,'./!/application/controllers/waiver.php'),(20783928,17705,'./!/application/controllers/waiver.php'),(20783927,17704,'./!/application/controllers/waiver.php'),(20784033,17729,'./!/application/libraries/amazon_library.php'),(20784032,17728,'./!/application/libraries/amazon_library.php'),(20784031,17727,'./!/application/libraries/amazon_library.php'),(20784030,14823,'./!/application/libraries/amazon_library.php'),(20784029,17726,'./!/application/libraries/amazon_library.php'),(20784028,17725,'./!/application/libraries/amazon_library.php'),(20784027,17724,'./!/application/libraries/amazon_library.php'),(20784026,17723,'./!/application/libraries/amazon_library.php'),(20784025,17963,'./!/application/libraries/amazon_library.php'),(20784092,17966,'./!/application/libraries/invlockdown.php'),(20784091,17965,'./!/application/libraries/invlockdown.php'),(20784183,2151,'./!/application/model_collections/arorder_collection.php'),(20784195,2151,'./!/application/model_collections/arordershipdetail_collection.php'),(20784209,17968,'./!/application/model_collections/customer_collection.php'),(20784208,17967,'./!/application/model_collections/customer_collection.php'),(20784226,2827,'./!/application/model_collections/invcotransferdetail_collection.php'),(20784252,17968,'./!/application/models/arcompany_model.php'),(20784251,17967,'./!/application/models/arcompany_model.php'),(20784267,2151,'./!/application/models/arinvoice_model.php'),(20784266,18238,'./!/application/models/arinvoice_model.php'),(20784265,18237,'./!/application/models/arinvoice_model.php'),(20784264,2094,'./!/application/models/arinvoice_model.php'),(20784263,1792,'./!/application/models/arinvoice_model.php'),(20784262,1678,'./!/application/models/arinvoice_model.php'),(20784287,19385,'./!/application/models/arinvoicepaymentdetail_model.php'),(20784306,18503,'./!/application/models/arorder_model.php'),(20784322,2638,'./!/application/models/arorderrentalpickup_model.php'),(20784321,17969,'./!/application/models/arorderrentalpickup_model.php'),(20784320,2151,'./!/application/models/arorderrentalpickup_model.php'),(20784331,2638,'./!/application/models/arorderrentalpickupdetail_model.php'),(20784330,18240,'./!/application/models/arorderrentalpickupdetail_model.php'),(20784329,18239,'./!/application/models/arorderrentalpickupdetail_model.php'),(20784328,17969,'./!/application/models/arorderrentalpickupdetail_model.php'),(20785267,19553,'./!/application/views/customer/report_authnet_cards.php'),(20784357,11122,'./!/application/models/customer_model.php'),(20784356,20016,'./!/application/models/customer_model.php'),(20784434,7946,'./!/application/models/jobbudget_model.php'),(20784433,1751,'./!/application/models/jobbudget_model.php'),(20784432,1740,'./!/application/models/jobbudget_model.php'),(20784547,3434,'./!/application/views/amazon/import_order_selection_table.php'),(20784546,2751,'./!/application/views/amazon/import_order_selection_table.php'),(20784545,5417,'./!/application/views/amazon/import_order_selection_table.php'),(20784538,13334,'./!/application/views/amazon/import_order_selection_table.php'),(20784539,17972,'./!/application/views/amazon/import_order_selection_table.php'),(20784540,10386,'./!/application/views/amazon/import_order_selection_table.php'),(20784541,16370,'./!/application/views/amazon/import_order_selection_table.php'),(20784542,17378,'./!/application/views/amazon/import_order_selection_table.php'),(20784543,17346,'./!/application/views/amazon/import_order_selection_table.php'),(20784544,2738,'./!/application/views/amazon/import_order_selection_table.php'),(20784536,17363,'./!/application/views/amazon/import_order_selection_table.php'),(20784593,17974,'./!/application/views/appointments/admin.php'),(20784592,19750,'./!/application/views/appointments/admin.php'),(20784591,1476,'./!/application/views/appointments/admin.php'),(20784590,20025,'./!/application/views/appointments/admin.php'),(20784585,981,'./!/application/views/appointments/admin.php'),(20785018,17893,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785017,17908,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785016,17978,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785015,17903,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785014,17977,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785013,5120,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785012,2521,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785011,2315,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785009,1696,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785325,333,'./!/application/views/customfields/report_referrals.php'),(20785324,202,'./!/application/views/customfields/report_referrals.php'),(20785492,1963,'./!/application/views/generic/confirm_message.php'),(20785495,14582,'./!/application/views/generic/datatable.php'),(20785903,9622,'./!/application/views/job/tab_view.php'),(20785902,15877,'./!/application/views/job/tab_view.php'),(20785901,15876,'./!/application/views/job/tab_view.php'),(20785900,981,'./!/application/views/job/tab_view.php'),(20785899,869,'./!/application/views/job/tab_view.php'),(20785898,5205,'./!/application/views/job/tab_view.php'),(20785897,10921,'./!/application/views/job/tab_view.php'),(20785896,17738,'./!/application/views/job/tab_view.php'),(20785895,15875,'./!/application/views/job/tab_view.php'),(20785894,15598,'./!/application/views/job/tab_view.php'),(20785893,543,'./!/application/views/job/tab_view.php'),(20785954,17812,'./!/application/views/jobbudget/edit.php'),(20785953,3252,'./!/application/views/jobbudget/edit.php'),(20785952,2948,'./!/application/views/jobbudget/edit.php'),(20785951,2702,'./!/application/views/jobbudget/edit.php'),(20785950,17981,'./!/application/views/jobbudget/edit.php'),(20785949,2103,'./!/application/views/jobbudget/edit.php'),(20785948,5081,'./!/application/views/jobbudget/edit.php'),(20785947,1557,'./!/application/views/jobbudget/edit.php'),(20785946,15991,'./!/application/views/jobbudget/edit.php'),(20786224,3072,'./!/application/views/physicalinv/entry.php'),(20786223,2960,'./!/application/views/physicalinv/entry.php'),(20786222,2874,'./!/application/views/physicalinv/entry.php'),(20786221,2626,'./!/application/views/physicalinv/entry.php'),(20786220,17246,'./!/application/views/physicalinv/entry.php'),(20786219,8861,'./!/application/views/physicalinv/entry.php'),(20786218,6444,'./!/application/views/physicalinv/entry.php'),(20786217,2137,'./!/application/views/physicalinv/entry.php'),(20786216,1963,'./!/application/views/physicalinv/entry.php'),(20786215,17982,'./!/application/views/physicalinv/entry.php'),(20786214,1839,'./!/application/views/physicalinv/entry.php'),(20786213,1788,'./!/application/views/physicalinv/entry.php'),(20786212,1713,'./!/application/views/physicalinv/entry.php'),(20786211,1709,'./!/application/views/physicalinv/entry.php'),(20786210,572,'./!/application/views/physicalinv/entry.php'),(20786209,451,'./!/application/views/physicalinv/entry.php'),(20786208,8185,'./!/application/views/physicalinv/entry.php'),(20786207,6314,'./!/application/views/physicalinv/entry.php'),(20803592,19135,'./invitemlstreorder.php'),(20786252,14524,'./!/application/views/physicalinv/search.php'),(20786251,3129,'./!/application/views/physicalinv/search.php'),(20786250,17990,'./!/application/views/physicalinv/search.php'),(20786249,2901,'./!/application/views/physicalinv/search.php'),(20786248,12093,'./!/application/views/physicalinv/search.php'),(20786247,17989,'./!/application/views/physicalinv/search.php'),(20786246,2744,'./!/application/views/physicalinv/search.php'),(20786245,2742,'./!/application/views/physicalinv/search.php'),(20786244,14523,'./!/application/views/physicalinv/search.php'),(20786243,2627,'./!/application/views/physicalinv/search.php'),(20786242,3741,'./!/application/views/physicalinv/search.php'),(20786241,17988,'./!/application/views/physicalinv/search.php'),(20786240,1788,'./!/application/views/physicalinv/search.php'),(20786239,1713,'./!/application/views/physicalinv/search.php'),(20786485,8629,'./!/application/views/shopify/admin.php'),(20786484,6466,'./!/application/views/shopify/admin.php'),(20786483,17616,'./!/application/views/shopify/admin.php'),(20787042,315,'./adminappaytermsadd.php'),(20787048,59,'./adminappaytermsupd.php'),(20787370,19098,'./adminarcompanyupd.php'),(20787369,18823,'./adminarcompanyupd.php'),(20787368,9323,'./adminarcompanyupd.php'),(20787367,13145,'./adminarcompanyupd.php'),(20787366,19097,'./adminarcompanyupd.php'),(20787365,14144,'./adminarcompanyupd.php'),(20787805,315,'./adminarinvtermsadd.php'),(20787811,59,'./adminarinvtermsupd.php'),(20792559,416,'./arinvoicepay.php'),(20791258,6048,'./arbankdepositadd.php'),(20792558,15131,'./arinvoicepay.php'),(20792557,325,'./arinvoicepay.php'),(20792556,315,'./arinvoicepay.php'),(20792555,18441,'./arinvoicepay.php'),(20792554,12140,'./arinvoicepay.php'),(20793219,869,'./arinvoicereturnsdetail.php'),(20793218,5205,'./arinvoicereturnsdetail.php'),(20793217,737,'./arinvoicereturnsdetail.php'),(20793216,695,'./arinvoicereturnsdetail.php'),(20793215,10578,'./arinvoicereturnsdetail.php'),(20793446,13911,'./arinvoiceupd.php'),(20793445,445,'./arinvoiceupd.php'),(20793444,325,'./arinvoiceupd.php'),(20793617,1629,'./arinvoiceview.php'),(20793616,18628,'./arinvoiceview.php'),(20794030,1685,'./arordconfirmfpdf.php'),(20794071,8036,'./arorder2invoice.php'),(20794070,8035,'./arorder2invoice.php'),(20794069,543,'./arorder2invoice.php'),(20794068,13609,'./arorder2invoice.php'),(20794067,13608,'./arorder2invoice.php'),(20794066,19210,'./arorder2invoice.php'),(20794065,6747,'./arorder2invoice.php'),(20794866,197,'./arordershiplst.php'),(20794977,315,'./arordpicktick.php'),(20795089,5459,'./arordquotefpdf.php'),(20795088,542,'./arordquotefpdf.php'),(20795146,13863,'./arordshipadd.php'),(20795145,20049,'./arordshipadd.php'),(20795144,14277,'./arordshipadd.php'),(20795143,13435,'./arordshipadd.php'),(20795142,6030,'./arordshipadd.php'),(20795141,315,'./arordshipadd.php'),(20795464,938,'./arordshipviewfpdf.php'),(20796126,17845,'./arserviceordupd.php'),(20796125,8083,'./arserviceordupd.php'),(20796124,226,'./arserviceordupd.php'),(20796123,211,'./arserviceordupd.php'),(20796122,8095,'./arserviceordupd.php'),(20803039,15824,'./invitemadd.php'),(20803038,1424,'./invitemadd.php'),(20804197,315,'./invitemupd.php'),(20804196,7035,'./invitemupd.php'),(20804195,14247,'./invitemupd.php'),(20804194,309,'./invitemupd.php'),(20804882,1750,'./invporecv.php'),(20804881,14104,'./invporecv.php'),(20804880,1713,'./invporecv.php'),(20804879,1709,'./invporecv.php'),(20804878,17964,'./invporecv.php'),(20805425,18024,'./jobbudgetvariancerpt.php'),(20805424,18023,'./jobbudgetvariancerpt.php'),(20805423,18022,'./jobbudgetvariancerpt.php'),(20805422,14667,'./jobbudgetvariancerpt.php'),(20805421,18021,'./jobbudgetvariancerpt.php'),(20805420,15695,'./jobbudgetvariancerpt.php'),(20805419,18020,'./jobbudgetvariancerpt.php'),(20805418,2782,'./jobbudgetvariancerpt.php'),(20805417,2751,'./jobbudgetvariancerpt.php'),(20805416,12097,'./jobbudgetvariancerpt.php'),(20805415,16453,'./jobbudgetvariancerpt.php'),(20805414,18019,'./jobbudgetvariancerpt.php'),(20805413,15641,'./jobbudgetvariancerpt.php'),(20805412,18018,'./jobbudgetvariancerpt.php'),(20805411,17955,'./jobbudgetvariancerpt.php'),(20805410,5081,'./jobbudgetvariancerpt.php'),(20805409,18017,'./jobbudgetvariancerpt.php'),(20805408,17956,'./jobbudgetvariancerpt.php'),(20805407,18016,'./jobbudgetvariancerpt.php'),(20805406,4106,'./jobbudgetvariancerpt.php'),(20805405,15991,'./jobbudgetvariancerpt.php'),(20805404,18015,'./jobbudgetvariancerpt.php'),(20805403,8936,'./jobbudgetvariancerpt.php'),(20805402,1014,'./jobbudgetvariancerpt.php'),(20805401,697,'./jobbudgetvariancerpt.php'),(20805400,9492,'./jobbudgetvariancerpt.php'),(20805399,6165,'./jobbudgetvariancerpt.php'),(20805398,17948,'./jobbudgetvariancerpt.php'),(20805397,333,'./jobbudgetvariancerpt.php'),(20805431,18025,'./jobcostrpt.php'),(20805430,389,'./jobcostrpt.php'),(20805429,15219,'./jobcostrpt.php'),(20805428,8702,'./jobcostrpt.php'),(20805427,333,'./jobcostrpt.php'),(20805426,226,'./jobcostrpt.php'),(20805931,7623,'./nporder.php'),(20805930,15349,'./nporder.php'),(20805929,659,'./nporder.php'),(20805928,9126,'./nporder.php'),(20805927,19783,'./nporder.php'),(20805926,9492,'./nporder.php'),(20805925,14686,'./nporder.php'),(20805924,14685,'./nporder.php'),(20805923,19782,'./nporder.php'),(20805922,8768,'./nporder.php'),(20805921,13308,'./nporder.php'),(20805920,5851,'./nporder.php'),(20805919,19591,'./nporder.php'),(20805918,605,'./nporder.php'),(20806294,326,'./nporderpayment.php'),(20806293,9144,'./nporderpayment.php'),(20808308,59,'./premployeeadd.php'),(20808428,55,'./premployeeupd.php'),(20808770,59,'./prloghours.php'),(20811623,542,'./includes/arfunctions.php'),(20813520,479,'./includes/filesystemdb.php'),(20813519,451,'./includes/filesystemdb.php'),(20813842,8257,'./includes/functions.php'),(20814053,18790,'./includes/genfunctions.php'),(20814052,18971,'./includes/genfunctions.php'),(20814051,18789,'./includes/genfunctions.php'),(20814050,13986,'./includes/genfunctions.php'),(20814049,13082,'./includes/genfunctions.php'),(20814048,14095,'./includes/genfunctions.php'),(20814047,13476,'./includes/genfunctions.php'),(20814046,13475,'./includes/genfunctions.php'),(20805917,8902,'./nporder.php'),(20779262,19717,'./!/application/controllers/arinvoice.php'),(20779260,3035,'./!/application/controllers/arinvoice.php'),(20779259,3005,'./!/application/controllers/arinvoice.php'),(20779258,18994,'./!/application/controllers/arinvoice.php'),(20779257,2998,'./!/application/controllers/arinvoice.php'),(20779256,5863,'./!/application/controllers/arinvoice.php'),(20779255,2978,'./!/application/controllers/arinvoice.php'),(20779254,2977,'./!/application/controllers/arinvoice.php'),(20779253,2948,'./!/application/controllers/arinvoice.php'),(20779252,3434,'./!/application/controllers/arinvoice.php'),(20779251,2907,'./!/application/controllers/arinvoice.php'),(20779250,18894,'./!/application/controllers/arinvoice.php'),(20779249,15769,'./!/application/controllers/arinvoice.php'),(20779248,19321,'./!/application/controllers/arinvoice.php'),(20779247,20205,'./!/application/controllers/arinvoice.php'),(20779246,20204,'./!/application/controllers/arinvoice.php'),(20779245,18056,'./!/application/controllers/arinvoice.php'),(20779244,19691,'./!/application/controllers/arinvoice.php'),(20779243,2851,'./!/application/controllers/arinvoice.php'),(20779242,5225,'./!/application/controllers/arinvoice.php'),(20779241,2833,'./!/application/controllers/arinvoice.php'),(20779240,2827,'./!/application/controllers/arinvoice.php'),(20779239,15942,'./!/application/controllers/arinvoice.php'),(20779238,15941,'./!/application/controllers/arinvoice.php'),(20779237,11761,'./!/application/controllers/arinvoice.php'),(20779236,2738,'./!/application/controllers/arinvoice.php'),(20779235,18500,'./!/application/controllers/arinvoice.php'),(20779234,18499,'./!/application/controllers/arinvoice.php'),(20779233,8508,'./!/application/controllers/arinvoice.php'),(20779232,2702,'./!/application/controllers/arinvoice.php'),(20779230,4680,'./!/application/controllers/arinvoice.php'),(20779390,2151,'./!/application/controllers/arorder.php'),(20781104,18178,'./!/application/controllers/invcotransfer.php'),(20781854,17932,'./!/application/controllers/itemlocation.php'),(20781703,17917,'./!/application/controllers/item.php'),(20781702,2601,'./!/application/controllers/item.php'),(20781701,7805,'./!/application/controllers/item.php'),(20781700,2520,'./!/application/controllers/item.php'),(20782039,5439,'./!/application/controllers/job.php'),(20782038,15567,'./!/application/controllers/job.php'),(20782037,9955,'./!/application/controllers/job.php'),(20782036,9954,'./!/application/controllers/job.php'),(20782035,5437,'./!/application/controllers/job.php'),(20782034,9953,'./!/application/controllers/job.php'),(20782748,12685,'./!/application/controllers/main.php'),(20782746,18209,'./!/application/controllers/main.php'),(20784024,17722,'./!/application/libraries/amazon_library.php'),(20784314,17450,'./!/application/models/arorderdetail_model.php'),(20784446,17315,'./!/application/models/shopify_model.php'),(20784454,18048,'./!/application/models/threedcart_model.php'),(20785535,315,'./!/application/views/generic/paginated_query_table.php'),(20786764,19832,'./admin3dcart.php'),(20786763,17814,'./admin3dcart.php'),(20786762,9442,'./admin3dcart.php'),(20786761,8629,'./admin3dcart.php'),(20786760,13804,'./admin3dcart.php'),(20786759,15278,'./admin3dcart.php'),(20786758,15125,'./admin3dcart.php'),(20786757,15782,'./admin3dcart.php'),(20786756,15781,'./admin3dcart.php'),(20786755,12923,'./admin3dcart.php'),(20786754,15158,'./admin3dcart.php'),(20787364,19406,'./adminarcompanyupd.php'),(20787363,13276,'./adminarcompanyupd.php'),(20790458,347,'./apbillupd.php'),(20790457,336,'./apbillupd.php'),(20790456,335,'./apbillupd.php'),(20790455,315,'./apbillupd.php'),(20790454,5203,'./apbillupd.php'),(20790914,484,'./apvariance.php'),(20790913,17144,'./apvariance.php'),(20790912,8862,'./apvariance.php'),(20790911,333,'./apvariance.php'),(20790910,17142,'./apvariance.php'),(20790909,17135,'./apvariance.php'),(20790908,226,'./apvariance.php'),(20791179,12926,'./ar3dcart.php'),(19914725,59,'./arordadd.php'),(20794011,13221,'./arordclone.php'),(20794029,14767,'./arordconfirmfpdf.php'),(20794028,8936,'./arordconfirmfpdf.php'),(20794027,5684,'./arordconfirmfpdf.php'),(20794026,6308,'./arordconfirmfpdf.php'),(20794025,982,'./arordconfirmfpdf.php'),(20794024,931,'./arordconfirmfpdf.php'),(20794023,869,'./arordconfirmfpdf.php'),(20795021,744,'./arordpicktickfpdf.php'),(20795020,4363,'./arordpicktickfpdf.php'),(20795019,737,'./arordpicktickfpdf.php'),(20795018,719,'./arordpicktickfpdf.php'),(20795017,8730,'./arordpicktickfpdf.php'),(20795016,6228,'./arordpicktickfpdf.php'),(20795140,18457,'./arordshipadd.php'),(20795139,16444,'./arordshipadd.php'),(20795138,12140,'./arordshipadd.php'),(20795137,16954,'./arordshipadd.php'),(20795136,18085,'./arordshipadd.php'),(19916403,59,'./arordupd.php'),(20795761,6808,'./arrmaorderreceive.php'),(20796121,87,'./arserviceordupd.php'),(20797163,15666,'./dbupdate.php'),(20800504,332,'./glclose_month.php'),(20800503,16332,'./glclose_month.php'),(20800502,18091,'./glclose_month.php'),(20800501,16657,'./glclose_month.php'),(20800500,16331,'./glclose_month.php'),(20801704,9357,'./importbills.php'),(20801703,315,'./importbills.php'),(20801702,18094,'./importbills.php'),(20801701,226,'./importbills.php'),(20801700,14200,'./importbills.php'),(20801817,17419,'./importcustomer.php'),(20680825,18048,'./importeporders.php'),(20802237,8878,'./importitems.php'),(20802236,8877,'./importitems.php'),(20802235,13529,'./importitems.php'),(20802234,13528,'./importitems.php'),(20802233,869,'./importitems.php'),(20802232,749,'./importitems.php'),(20802231,5299,'./importitems.php'),(20802230,9159,'./importitems.php'),(20802229,457,'./importitems.php'),(20802354,14239,'./importoscom.php'),(20803338,2702,'./invitemcatadd.php'),(20803337,1704,'./invitemcatadd.php'),(20803336,1703,'./invitemcatadd.php'),(20803335,1092,'./invitemcatadd.php'),(20803334,18296,'./invitemcatadd.php'),(20803333,454,'./invitemcatadd.php'),(20803332,13994,'./invitemcatadd.php'),(20803331,315,'./invitemcatadd.php'),(20803330,59,'./invitemcatadd.php'),(20803355,342,'./invitemcatupd.php'),(20803354,332,'./invitemcatupd.php'),(20803353,13994,'./invitemcatupd.php'),(20803352,315,'./invitemcatupd.php'),(20803351,5203,'./invitemcatupd.php'),(20803350,111,'./invitemcatupd.php'),(20803349,59,'./invitemcatupd.php'),(20803348,18205,'./invitemcatupd.php'),(20805916,3566,'./nporder.php'),(20805915,581,'./nporder.php'),(20805914,13660,'./nporder.php'),(20805913,567,'./nporder.php'),(20806461,9146,'./npordersave.php'),(20811622,5536,'./includes/arfunctions.php'),(20811621,5929,'./includes/arfunctions.php'),(20811620,524,'./includes/arfunctions.php'),(20811619,18696,'./includes/arfunctions.php'),(20811618,503,'./includes/arfunctions.php'),(20811617,479,'./includes/arfunctions.php'),(20811616,474,'./includes/arfunctions.php'),(20811615,18100,'./includes/arfunctions.php'),(20811614,8240,'./includes/arfunctions.php'),(20811613,15250,'./includes/arfunctions.php'),(20811612,19155,'./includes/arfunctions.php'),(20811611,445,'./includes/arfunctions.php'),(20811610,444,'./includes/arfunctions.php'),(20811609,15143,'./includes/arfunctions.php'),(20811608,15142,'./includes/arfunctions.php'),(20811607,11861,'./includes/arfunctions.php'),(20811606,439,'./includes/arfunctions.php'),(20811605,438,'./includes/arfunctions.php'),(20811604,435,'./includes/arfunctions.php'),(20811603,434,'./includes/arfunctions.php'),(20811602,18695,'./includes/arfunctions.php'),(20811601,16457,'./includes/arfunctions.php'),(20811600,351,'./includes/arfunctions.php'),(20811599,14690,'./includes/arfunctions.php'),(20811598,13994,'./includes/arfunctions.php'),(20811597,7084,'./includes/arfunctions.php'),(20814568,869,'./includes/invfunctions.php'),(20814567,7841,'./includes/invfunctions.php'),(20814789,5070,'./includes/invitemaddupd.functions.php'),(20814788,18207,'./includes/invitemaddupd.functions.php'),(20814787,18832,'./includes/invitemaddupd.functions.php'),(20814786,18137,'./includes/invitemaddupd.functions.php'),(20814785,18332,'./includes/invitemaddupd.functions.php'),(20814784,18331,'./includes/invitemaddupd.functions.php'),(20814783,2664,'./includes/invitemaddupd.functions.php'),(20814782,10577,'./includes/invitemaddupd.functions.php'),(20814903,3520,'./includes/langcache.php'),(20784248,18126,'./!/application/models/appointment_model.php'),(20784588,1047,'./!/application/views/appointments/admin.php'),(20784589,20024,'./!/application/views/appointments/admin.php'),(20791939,18129,'./arcustmerge.php'),(20791938,8655,'./arcustmerge.php'),(20801699,18093,'./importbills.php'),(20801698,18092,'./importbills.php'),(20811596,7530,'./includes/arfunctions.php'),(20811595,318,'./includes/arfunctions.php'),(20778809,197,'./!/application/controllers/apbill.php'),(20778896,683,'./!/application/controllers/archive_reports.php'),(20778895,19173,'./!/application/controllers/archive_reports.php'),(20779231,12013,'./!/application/controllers/arinvoice.php'),(20779229,20203,'./!/application/controllers/arinvoice.php'),(20779226,18802,'./!/application/controllers/arinvoice.php'),(20779227,19716,'./!/application/controllers/arinvoice.php'),(20779389,18144,'./!/application/controllers/arorder.php'),(20779388,17225,'./!/application/controllers/arorder.php'),(20779387,2094,'./!/application/controllers/arorder.php'),(20779386,2103,'./!/application/controllers/arorder.php'),(20779385,16674,'./!/application/controllers/arorder.php'),(20779384,16669,'./!/application/controllers/arorder.php'),(20779383,10946,'./!/application/controllers/arorder.php'),(20779382,5304,'./!/application/controllers/arorder.php'),(20779381,1913,'./!/application/controllers/arorder.php'),(20779380,1788,'./!/application/controllers/arorder.php'),(20779379,1781,'./!/application/controllers/arorder.php'),(20779378,1770,'./!/application/controllers/arorder.php'),(20779377,17888,'./!/application/controllers/arorder.php'),(20779376,1743,'./!/application/controllers/arorder.php'),(20779375,9622,'./!/application/controllers/arorder.php'),(20779374,5081,'./!/application/controllers/arorder.php'),(20779373,1709,'./!/application/controllers/arorder.php'),(20779372,1703,'./!/application/controllers/arorder.php'),(20779371,1696,'./!/application/controllers/arorder.php'),(20779370,1668,'./!/application/controllers/arorder.php'),(20779369,1666,'./!/application/controllers/arorder.php'),(20779368,1647,'./!/application/controllers/arorder.php'),(20779367,17129,'./!/application/controllers/arorder.php'),(20779366,9292,'./!/application/controllers/arorder.php'),(20779365,1539,'./!/application/controllers/arorder.php'),(20779364,1467,'./!/application/controllers/arorder.php'),(20779363,18502,'./!/application/controllers/arorder.php'),(20779362,4413,'./!/application/controllers/arorder.php'),(20779361,4083,'./!/application/controllers/arorder.php'),(20779360,8936,'./!/application/controllers/arorder.php'),(20779609,18158,'./!/application/controllers/arordership.php'),(20779608,2833,'./!/application/controllers/arordership.php'),(20779607,18338,'./!/application/controllers/arordership.php'),(20779606,18337,'./!/application/controllers/arordership.php'),(20779605,4007,'./!/application/controllers/arordership.php'),(20779604,6835,'./!/application/controllers/arordership.php'),(20779603,17918,'./!/application/controllers/arordership.php'),(20779602,17912,'./!/application/controllers/arordership.php'),(20779601,18157,'./!/application/controllers/arordership.php'),(20779600,18897,'./!/application/controllers/arordership.php'),(20779599,17366,'./!/application/controllers/arordership.php'),(20779598,6770,'./!/application/controllers/arordership.php'),(20779597,2738,'./!/application/controllers/arordership.php'),(20779596,8508,'./!/application/controllers/arordership.php'),(20779595,18156,'./!/application/controllers/arordership.php'),(20779594,18155,'./!/application/controllers/arordership.php'),(20779593,19007,'./!/application/controllers/arordership.php'),(20779592,17959,'./!/application/controllers/arordership.php'),(20779591,18154,'./!/application/controllers/arordership.php'),(20779590,2534,'./!/application/controllers/arordership.php'),(20779589,13147,'./!/application/controllers/arordership.php'),(20779588,2531,'./!/application/controllers/arordership.php'),(20779587,5120,'./!/application/controllers/arordership.php'),(20779586,5903,'./!/application/controllers/arordership.php'),(20779585,18153,'./!/application/controllers/arordership.php'),(20779584,2402,'./!/application/controllers/arordership.php'),(20779583,18152,'./!/application/controllers/arordership.php'),(20779582,2363,'./!/application/controllers/arordership.php'),(20779581,17500,'./!/application/controllers/arordership.php'),(20779580,16445,'./!/application/controllers/arordership.php'),(20779579,2361,'./!/application/controllers/arordership.php'),(20779578,19887,'./!/application/controllers/arordership.php'),(20779577,4193,'./!/application/controllers/arordership.php'),(20779576,18151,'./!/application/controllers/arordership.php'),(20779575,16671,'./!/application/controllers/arordership.php'),(20779574,5111,'./!/application/controllers/arordership.php'),(20779573,2182,'./!/application/controllers/arordership.php'),(20779572,15101,'./!/application/controllers/arordership.php'),(20779571,18150,'./!/application/controllers/arordership.php'),(20779570,2165,'./!/application/controllers/arordership.php'),(20779569,2151,'./!/application/controllers/arordership.php'),(20779568,19006,'./!/application/controllers/arordership.php'),(20779567,16674,'./!/application/controllers/arordership.php'),(20779566,16764,'./!/application/controllers/arordership.php'),(20779565,1963,'./!/application/controllers/arordership.php'),(20779564,17916,'./!/application/controllers/arordership.php'),(20779817,19019,'./!/application/controllers/billtrust.php'),(20779816,3090,'./!/application/controllers/billtrust.php'),(20779815,4015,'./!/application/controllers/billtrust.php'),(20779814,2998,'./!/application/controllers/billtrust.php'),(20779813,5863,'./!/application/controllers/billtrust.php'),(20779812,2833,'./!/application/controllers/billtrust.php'),(20779839,17073,'./!/application/controllers/ccterminal.php'),(20779838,17502,'./!/application/controllers/ccterminal.php'),(20781103,18177,'./!/application/controllers/invcotransfer.php'),(20781102,18833,'./!/application/controllers/invcotransfer.php'),(20781101,2948,'./!/application/controllers/invcotransfer.php'),(20781100,3434,'./!/application/controllers/invcotransfer.php'),(20781099,19904,'./!/application/controllers/invcotransfer.php'),(20781098,19346,'./!/application/controllers/invcotransfer.php'),(20781097,8126,'./!/application/controllers/invcotransfer.php'),(20781096,18176,'./!/application/controllers/invcotransfer.php'),(20781095,19051,'./!/application/controllers/invcotransfer.php'),(20781094,18507,'./!/application/controllers/invcotransfer.php'),(20781093,18353,'./!/application/controllers/invcotransfer.php'),(20781092,2827,'./!/application/controllers/invcotransfer.php'),(20781091,16772,'./!/application/controllers/invcotransfer.php'),(20781090,2813,'./!/application/controllers/invcotransfer.php'),(20781089,19345,'./!/application/controllers/invcotransfer.php'),(20781088,2738,'./!/application/controllers/invcotransfer.php'),(20781087,8508,'./!/application/controllers/invcotransfer.php'),(20781085,19903,'./!/application/controllers/invcotransfer.php'),(20781361,8508,'./!/application/controllers/invcountbatch.php'),(20781306,16674,'./!/application/controllers/invcountbatch.php'),(20781307,16370,'./!/application/controllers/invcountbatch.php'),(20781305,16669,'./!/application/controllers/invcountbatch.php'),(20781304,18461,'./!/application/controllers/invcountbatch.php'),(20781303,1963,'./!/application/controllers/invcountbatch.php'),(20781302,19720,'./!/application/controllers/invcountbatch.php'),(20781301,19544,'./!/application/controllers/invcountbatch.php'),(20781300,19916,'./!/application/controllers/invcountbatch.php'),(20781299,18192,'./!/application/controllers/invcountbatch.php'),(20781298,17982,'./!/application/controllers/invcountbatch.php'),(20781297,18191,'./!/application/controllers/invcountbatch.php'),(20781296,4721,'./!/application/controllers/invcountbatch.php'),(20781295,1934,'./!/application/controllers/invcountbatch.php'),(20781294,10946,'./!/application/controllers/invcountbatch.php'),(20781293,19611,'./!/application/controllers/invcountbatch.php'),(20781292,19610,'./!/application/controllers/invcountbatch.php'),(20781291,10386,'./!/application/controllers/invcountbatch.php'),(20781290,18808,'./!/application/controllers/invcountbatch.php'),(20781289,18190,'./!/application/controllers/invcountbatch.php'),(20781288,19915,'./!/application/controllers/invcountbatch.php'),(20781287,1788,'./!/application/controllers/invcountbatch.php'),(20781505,2838,'./!/application/controllers/invpo.php'),(20781503,7032,'./!/application/controllers/invpo.php'),(20781504,2738,'./!/application/controllers/invpo.php'),(20781502,2620,'./!/application/controllers/invpo.php'),(20781501,4265,'./!/application/controllers/invpo.php'),(20781500,4980,'./!/application/controllers/invpo.php'),(20781499,6139,'./!/application/controllers/invpo.php'),(20781498,2588,'./!/application/controllers/invpo.php'),(20781497,2529,'./!/application/controllers/invpo.php'),(20781496,2508,'./!/application/controllers/invpo.php'),(20781495,9835,'./!/application/controllers/invpo.php'),(20781494,2501,'./!/application/controllers/invpo.php'),(20781493,16939,'./!/application/controllers/invpo.php'),(20781492,16938,'./!/application/controllers/invpo.php'),(20781491,16937,'./!/application/controllers/invpo.php'),(20781490,12825,'./!/application/controllers/invpo.php'),(20781489,2459,'./!/application/controllers/invpo.php'),(20781488,6988,'./!/application/controllers/invpo.php'),(20781487,16936,'./!/application/controllers/invpo.php'),(20781781,18207,'./!/application/controllers/itemcategory.php'),(20781780,16676,'./!/application/controllers/itemcategory.php'),(20781779,7660,'./!/application/controllers/itemcategory.php'),(20781778,7659,'./!/application/controllers/itemcategory.php'),(20781777,7658,'./!/application/controllers/itemcategory.php'),(20781776,7657,'./!/application/controllers/itemcategory.php'),(20781775,7656,'./!/application/controllers/itemcategory.php'),(20781774,7655,'./!/application/controllers/itemcategory.php'),(20781773,7654,'./!/application/controllers/itemcategory.php'),(20781772,7653,'./!/application/controllers/itemcategory.php'),(20781771,7652,'./!/application/controllers/itemcategory.php'),(20781770,7651,'./!/application/controllers/itemcategory.php'),(20781769,7650,'./!/application/controllers/itemcategory.php'),(20781768,7649,'./!/application/controllers/itemcategory.php'),(20781767,2702,'./!/application/controllers/itemcategory.php'),(20781766,2664,'./!/application/controllers/itemcategory.php'),(20781936,9267,'./!/application/controllers/itempricespecial.php'),(20782747,19944,'./!/application/controllers/main.php'),(20782745,1820,'./!/application/controllers/main.php'),(20782744,19549,'./!/application/controllers/main.php'),(20782743,11204,'./!/application/controllers/main.php'),(20782742,10563,'./!/application/controllers/main.php'),(20782741,15866,'./!/application/controllers/main.php'),(20782740,17079,'./!/application/controllers/main.php'),(20782739,14974,'./!/application/controllers/main.php'),(20782738,5643,'./!/application/controllers/main.php'),(20782737,11822,'./!/application/controllers/main.php'),(20783094,18220,'./!/application/controllers/myuser.php'),(20783093,14823,'./!/application/controllers/myuser.php'),(20783092,18219,'./!/application/controllers/myuser.php'),(20783091,18218,'./!/application/controllers/myuser.php'),(20783090,18217,'./!/application/controllers/myuser.php'),(20783089,18216,'./!/application/controllers/myuser.php'),(20783423,2565,'./!/application/controllers/salestax.php'),(20783132,18812,'./!/application/controllers/paymentonaccount.php'),(20783131,2975,'./!/application/controllers/paymentonaccount.php'),(20783130,16113,'./!/application/controllers/paymentonaccount.php'),(20783129,18222,'./!/application/controllers/paymentonaccount.php'),(20783128,2260,'./!/application/controllers/paymentonaccount.php'),(20783126,1788,'./!/application/controllers/paymentonaccount.php'),(20783127,2103,'./!/application/controllers/paymentonaccount.php'),(20783124,869,'./!/application/controllers/paymentonaccount.php'),(20783231,1499,'./!/application/controllers/producttypetax.php'),(20783320,18411,'./!/application/controllers/recurringbilling.php'),(20783319,18229,'./!/application/controllers/recurringbilling.php'),(20783318,18839,'./!/application/controllers/recurringbilling.php'),(20783317,18228,'./!/application/controllers/recurringbilling.php'),(20783316,5378,'./!/application/controllers/recurringbilling.php'),(20783315,3175,'./!/application/controllers/recurringbilling.php'),(20783314,18410,'./!/application/controllers/recurringbilling.php'),(20783313,18409,'./!/application/controllers/recurringbilling.php'),(20783312,18408,'./!/application/controllers/recurringbilling.php'),(20783311,3090,'./!/application/controllers/recurringbilling.php'),(20783310,5335,'./!/application/controllers/recurringbilling.php'),(20783309,18537,'./!/application/controllers/recurringbilling.php'),(20783308,18407,'./!/application/controllers/recurringbilling.php'),(20783307,12715,'./!/application/controllers/recurringbilling.php'),(20783306,2948,'./!/application/controllers/recurringbilling.php'),(20783305,3434,'./!/application/controllers/recurringbilling.php'),(20783304,12657,'./!/application/controllers/recurringbilling.php'),(20783303,2775,'./!/application/controllers/recurringbilling.php'),(20783302,2702,'./!/application/controllers/recurringbilling.php'),(20783301,18406,'./!/application/controllers/recurringbilling.php'),(20783300,16950,'./!/application/controllers/recurringbilling.php'),(20783299,18405,'./!/application/controllers/recurringbilling.php'),(20783424,3812,'./!/application/controllers/salestax.php'),(20783422,14823,'./!/application/controllers/salestax.php'),(20783421,10386,'./!/application/controllers/salestax.php'),(20783420,7255,'./!/application/controllers/salestax.php'),(20783419,19550,'./!/application/controllers/salestax.php'),(20783418,15972,'./!/application/controllers/salestax.php'),(20783417,1499,'./!/application/controllers/salestax.php'),(20783529,18543,'./!/application/controllers/scanner.php'),(20783528,18542,'./!/application/controllers/scanner.php'),(20783565,18230,'./!/application/controllers/shippingroute.php'),(20783564,16535,'./!/application/controllers/shippingroute.php'),(20783563,18215,'./!/application/controllers/shippingroute.php'),(20783562,18158,'./!/application/controllers/shippingroute.php'),(20783763,445,'./!/application/controllers/vendor.php'),(20783762,17697,'./!/application/controllers/vendor.php'),(20783761,17696,'./!/application/controllers/vendor.php'),(20783760,17695,'./!/application/controllers/vendor.php'),(20783759,333,'./!/application/controllers/vendor.php'),(20783758,5441,'./!/application/controllers/vendor.php'),(20784013,3298,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784012,3274,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784011,20013,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784010,11704,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784009,18413,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784008,18235,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784007,18554,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784137,16676,'./!/application/libraries/settings_form.php'),(20784136,2782,'./!/application/libraries/settings_form.php'),(20784135,2751,'./!/application/libraries/settings_form.php'),(20784134,2738,'./!/application/libraries/settings_form.php'),(20784133,2702,'./!/application/libraries/settings_form.php'),(20784156,2738,'./!/application/libraries/taskbar.php'),(20784261,9248,'./!/application/models/arinvoice_model.php'),(20784260,19204,'./!/application/models/arinvoice_model.php'),(20784259,1668,'./!/application/models/arinvoice_model.php'),(20784258,8936,'./!/application/models/arinvoice_model.php'),(20784257,17308,'./!/application/models/arinvoice_model.php'),(20784256,5205,'./!/application/models/arinvoice_model.php'),(20784327,2151,'./!/application/models/arorderrentalpickupdetail_model.php'),(20784326,18376,'./!/application/models/arorderrentalpickupdetail_model.php'),(20784325,8936,'./!/application/models/arorderrentalpickupdetail_model.php'),(20784351,3421,'./!/application/models/arordershipdetail_model.php'),(20784350,18104,'./!/application/models/arordershipdetail_model.php'),(20784349,18244,'./!/application/models/arordershipdetail_model.php'),(20784348,18157,'./!/application/models/arordershipdetail_model.php'),(20784347,18155,'./!/application/models/arordershipdetail_model.php'),(20784346,18239,'./!/application/models/arordershipdetail_model.php'),(20784345,18243,'./!/application/models/arordershipdetail_model.php'),(20784344,2508,'./!/application/models/arordershipdetail_model.php'),(20784343,1973,'./!/application/models/arordershipdetail_model.php'),(20784342,1696,'./!/application/models/arordershipdetail_model.php'),(20784341,18242,'./!/application/models/arordershipdetail_model.php'),(20784340,18048,'./!/application/models/arordershipdetail_model.php'),(20785751,18424,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20785546,17124,'./!/application/views/generic/paxTerminalCollect.php'),(20785545,776,'./!/application/views/generic/paxTerminalCollect.php'),(20785543,17109,'./!/application/views/generic/paxTerminalCollect.php'),(20785544,670,'./!/application/views/generic/paxTerminalCollect.php'),(20785557,18245,'./!/application/views/generic/settings_form_js.php'),(20785695,16097,'./!/application/views/invcountbatch/create.php'),(20785694,541,'./!/application/views/invcountbatch/create.php'),(20785693,18184,'./!/application/views/invcountbatch/create.php'),(20785692,197,'./!/application/views/invcountbatch/create.php'),(20785716,19564,'./!/application/views/invcountbatch/enterCounts.php'),(20785715,658,'./!/application/views/invcountbatch/enterCounts.php'),(20785714,16097,'./!/application/views/invcountbatch/enterCounts.php'),(20785713,19496,'./!/application/views/invcountbatch/enterCounts.php'),(20786155,19090,'./!/application/views/meta_menu/shipment.php'),(20806460,9145,'./npordersave.php'),(20806459,6030,'./npordersave.php'),(20806458,5144,'./npordersave.php'),(20806457,5145,'./npordersave.php'),(20786205,2975,'./!/application/views/myuser/newpassword.php'),(20804379,18463,'./invitemupd1.php'),(20786204,14478,'./!/application/views/myuser/newpassword.php'),(20786203,14629,'./!/application/views/myuser/newpassword.php'),(20786202,14628,'./!/application/views/myuser/newpassword.php'),(20786201,2237,'./!/application/views/myuser/newpassword.php'),(20786200,14626,'./!/application/views/myuser/newpassword.php'),(20786199,14625,'./!/application/views/myuser/newpassword.php'),(20787371,13417,'./adminarcompanyupd.php'),(20787362,19232,'./adminarcompanyupd.php'),(20787361,13094,'./adminarcompanyupd.php'),(20787360,13928,'./adminarcompanyupd.php'),(20787359,18935,'./adminarcompanyupd.php'),(20787358,18359,'./adminarcompanyupd.php'),(20787357,20053,'./adminarcompanyupd.php'),(20787356,14264,'./adminarcompanyupd.php'),(20787355,18934,'./adminarcompanyupd.php'),(20787354,18822,'./adminarcompanyupd.php'),(20787353,7479,'./adminarcompanyupd.php'),(20787738,503,'./adminarglacct.php'),(20787737,15892,'./adminarglacct.php'),(20787885,59,'./adminarsales_category.php'),(20787905,315,'./adminarsales_categoryadd.php'),(20787934,315,'./adminarsalestaxadd.php'),(20792553,5144,'./arinvoicepay.php'),(20789314,52,'./adminprpens.php'),(20789915,6640,'./adminsystemsettings.php'),(20791257,445,'./arbankdepositadd.php'),(20791256,20080,'./arbankdepositadd.php'),(20791255,19246,'./arbankdepositadd.php'),(20791254,5859,'./arbankdepositadd.php'),(20793443,315,'./arinvoiceupd.php'),(20793442,17406,'./arinvoiceupd.php'),(20793615,1625,'./arinvoiceview.php'),(20793614,11868,'./arinvoiceview.php'),(20793613,1373,'./arinvoiceview.php'),(20793612,19214,'./arinvoiceview.php'),(20793849,12807,'./aritemcalcreorderpoint.php'),(20794064,355,'./arorder2invoice.php'),(20794063,315,'./arorder2invoice.php'),(20794062,5144,'./arorder2invoice.php'),(20794061,5145,'./arorder2invoice.php'),(20794060,6746,'./arorder2invoice.php'),(20794059,226,'./arorder2invoice.php'),(20795135,19588,'./arordshipadd.php'),(20795134,211,'./arordshipadd.php'),(20795133,197,'./arordshipadd.php'),(20795370,5203,'./arordshipview.php'),(20795369,5570,'./arordshipview.php'),(20795368,18248,'./arordshipview.php'),(20795463,886,'./arordshipviewfpdf.php'),(20795462,869,'./arordshipviewfpdf.php'),(20795461,10253,'./arordshipviewfpdf.php'),(20796523,451,'./autofunctions.php'),(20796522,8702,'./autofunctions.php'),(20800049,18656,'./genuserrights.php'),(20800103,18653,'./genuserrightsgroup.php'),(20801816,15755,'./importcustomer.php'),(20802152,605,'./importinvoices.php'),(20802228,7605,'./importitems.php'),(20802657,542,'./inventory_adjustments.php'),(20802656,315,'./inventory_adjustments.php'),(20802655,16525,'./inventory_adjustments.php'),(20802654,18283,'./inventory_adjustments.php'),(20802653,18282,'./inventory_adjustments.php'),(20802652,8325,'./inventory_adjustments.php'),(20802651,18281,'./inventory_adjustments.php'),(20802650,18958,'./inventory_adjustments.php'),(20803037,5072,'./invitemadd.php'),(20804193,7012,'./invitemupd.php'),(20804192,5203,'./invitemupd.php'),(20804191,202,'./invitemupd.php'),(20804190,20250,'./invitemupd.php'),(20804690,16903,'./invpoadd.php'),(20804689,869,'./invpoadd.php'),(20804688,799,'./invpoadd.php'),(20804877,11662,'./invporecv.php'),(20804995,1083,'./invpotoap.php'),(20805497,15553,'./jobupd.php'),(20805912,541,'./nporder.php'),(20805911,13273,'./nporder.php'),(20805910,13221,'./nporder.php'),(20805909,14571,'./nporder.php'),(20805908,8891,'./nporder.php'),(20805907,18785,'./nporder.php'),(20805906,524,'./nporder.php'),(20805905,503,'./nporder.php'),(20805904,479,'./nporder.php'),(20805903,16908,'./nporder.php'),(20806256,20159,'./npordermiscremote.php'),(20806292,6030,'./nporderpayment.php'),(20810363,3463,'./reset_password.php'),(20810362,604,'./reset_password.php'),(20810361,13184,'./reset_password.php'),(20810360,315,'./reset_password.php'),(20810359,14584,'./reset_password.php'),(20811207,28,'./includes/apfunctions.php'),(20811206,16195,'./includes/apfunctions.php'),(20811594,315,'./includes/arfunctions.php'),(20811593,16079,'./includes/arfunctions.php'),(20811592,16224,'./includes/arfunctions.php'),(20811591,17859,'./includes/arfunctions.php'),(20811590,9,'./includes/arfunctions.php'),(20811589,15840,'./includes/arfunctions.php'),(20811588,306,'./includes/arfunctions.php'),(20813518,12224,'./includes/filesystemdb.php'),(20813841,2106,'./includes/functions.php'),(20813840,2091,'./includes/functions.php'),(20813839,16674,'./includes/functions.php'),(20814045,18970,'./includes/genfunctions.php'),(20814044,8009,'./includes/genfunctions.php'),(20814043,11824,'./includes/genfunctions.php'),(20814042,18325,'./includes/genfunctions.php'),(20814041,18788,'./includes/genfunctions.php'),(20814040,18324,'./includes/genfunctions.php'),(20814039,9487,'./includes/genfunctions.php'),(20813517,17779,'./includes/filesystemdb.php'),(20813516,9124,'./includes/filesystemdb.php'),(20814566,18977,'./includes/invfunctions.php'),(20814517,19345,'./includes/invcotransfer.functions.php'),(20814516,10989,'./includes/invcotransfer.functions.php'),(20814515,19320,'./includes/invcotransfer.functions.php'),(20814514,15101,'./includes/invcotransfer.functions.php'),(20814513,2165,'./includes/invcotransfer.functions.php'),(20814512,1770,'./includes/invcotransfer.functions.php'),(20814565,19095,'./includes/invfunctions.php'),(20814564,13479,'./includes/invfunctions.php'),(20814563,13309,'./includes/invfunctions.php'),(20814562,737,'./includes/invfunctions.php'),(20814781,20129,'./includes/invitemaddupd.functions.php'),(20814780,20128,'./includes/invitemaddupd.functions.php'),(20814779,13806,'./includes/invitemaddupd.functions.php'),(20814778,18096,'./includes/invitemaddupd.functions.php'),(20814777,13991,'./includes/invitemaddupd.functions.php'),(20814776,1508,'./includes/invitemaddupd.functions.php'),(20814775,1047,'./includes/invitemaddupd.functions.php'),(20814774,18106,'./includes/invitemaddupd.functions.php'),(20814773,18105,'./includes/invitemaddupd.functions.php'),(20815298,18335,'./includes/classes/nptax.php'),(20815297,18334,'./includes/classes/nptax.php'),(20779563,1884,'./!/application/controllers/arordership.php'),(20779562,1788,'./!/application/controllers/arordership.php'),(20779561,15319,'./!/application/controllers/arordership.php'),(20779560,9622,'./!/application/controllers/arordership.php'),(20779559,5081,'./!/application/controllers/arordership.php'),(20781286,13334,'./!/application/controllers/invcountbatch.php'),(20781284,1713,'./!/application/controllers/invcountbatch.php'),(20781285,18189,'./!/application/controllers/invcountbatch.php'),(20781283,18734,'./!/application/controllers/invcountbatch.php'),(20781282,1709,'./!/application/controllers/invcountbatch.php'),(20781281,19488,'./!/application/controllers/invcountbatch.php'),(20781280,19543,'./!/application/controllers/invcountbatch.php'),(20782736,1790,'./!/application/controllers/main.php'),(20784199,2070,'./!/application/model_collections/carrierservice_collection.php'),(20784234,2377,'./!/application/model_collections/invcountbatchdetail_collection.php'),(20785268,604,'./!/application/views/customer/report_authnet_cards.php'),(20784235,18198,'./!/application/model_collections/invcountbatchdetail_collection.php'),(20785019,11444,'./!/application/views/arordership/adjustment_search_result_row_html.php'),(20785756,18348,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20785755,416,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20785754,19500,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20785753,17260,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20814038,18795,'./includes/genfunctions.php'),(20781086,2702,'./!/application/controllers/invcotransfer.php'),(20781084,19170,'./!/application/controllers/invcotransfer.php'),(20781083,19169,'./!/application/controllers/invcotransfer.php'),(20781082,19168,'./!/application/controllers/invcotransfer.php'),(20781486,2363,'./!/application/controllers/invpo.php'),(20781485,12821,'./!/application/controllers/invpo.php'),(20781484,2361,'./!/application/controllers/invpo.php'),(20781483,2262,'./!/application/controllers/invpo.php'),(20781482,2231,'./!/application/controllers/invpo.php'),(20781481,16671,'./!/application/controllers/invpo.php'),(20781479,15101,'./!/application/controllers/invpo.php'),(20784034,1788,'./!/application/libraries/datatable.php'),(20784073,4265,'./!/application/libraries/import_task.php'),(20784072,16671,'./!/application/libraries/import_task.php'),(20784071,2182,'./!/application/libraries/import_task.php'),(20784069,2165,'./!/application/libraries/import_task.php'),(20785798,3172,'./!/application/views/invpo/invpodetail_table.php'),(20786740,8125,'./!/application/views/zipcodealt/datatable.extra.php'),(20785797,3090,'./!/application/views/invpo/invpodetail_table.php'),(20785796,15321,'./!/application/views/invpo/invpodetail_table.php'),(20785794,2508,'./!/application/views/invpo/invpodetail_table.php'),(20787352,7478,'./adminarcompanyupd.php'),(20814561,18976,'./includes/invfunctions.php'),(20814560,18709,'./includes/invfunctions.php'),(20814559,18708,'./includes/invfunctions.php'),(20814558,5403,'./includes/invfunctions.php'),(20814557,15349,'./includes/invfunctions.php'),(20778894,18139,'./!/application/controllers/archive_reports.php'),(20778893,541,'./!/application/controllers/archive_reports.php'),(20778892,14546,'./!/application/controllers/archive_reports.php'),(20779228,2676,'./!/application/controllers/arinvoice.php'),(20779222,2700,'./!/application/controllers/arinvoice.php'),(20779223,18992,'./!/application/controllers/arinvoice.php'),(20779359,1036,'./!/application/controllers/arorder.php'),(20779358,15943,'./!/application/controllers/arorder.php'),(20779494,19001,'./!/application/controllers/arorderrentalpickup.php'),(20779558,1709,'./!/application/controllers/arordership.php'),(20781530,3274,'./!/application/controllers/invreceive.php'),(20781529,18381,'./!/application/controllers/invreceive.php'),(20781528,18380,'./!/application/controllers/invreceive.php'),(20781527,18379,'./!/application/controllers/invreceive.php'),(20781526,2363,'./!/application/controllers/invreceive.php'),(20781525,2182,'./!/application/controllers/invreceive.php'),(20781524,1788,'./!/application/controllers/invreceive.php'),(20781523,5081,'./!/application/controllers/invreceive.php'),(20781522,5570,'./!/application/controllers/invreceive.php'),(20781699,2515,'./!/application/controllers/item.php'),(20782033,325,'./!/application/controllers/job.php'),(20782032,315,'./!/application/controllers/job.php'),(20782031,16310,'./!/application/controllers/job.php'),(20782030,11354,'./!/application/controllers/job.php'),(20782735,8047,'./!/application/controllers/main.php'),(20783125,1696,'./!/application/controllers/paymentonaccount.php'),(20783122,697,'./!/application/controllers/paymentonaccount.php'),(20783298,18404,'./!/application/controllers/recurringbilling.php'),(20783297,18403,'./!/application/controllers/recurringbilling.php'),(20783296,18227,'./!/application/controllers/recurringbilling.php'),(20783295,16743,'./!/application/controllers/recurringbilling.php'),(20783294,2537,'./!/application/controllers/recurringbilling.php'),(20783293,14823,'./!/application/controllers/recurringbilling.php'),(20783292,18402,'./!/application/controllers/recurringbilling.php'),(20783291,18401,'./!/application/controllers/recurringbilling.php'),(20783290,18400,'./!/application/controllers/recurringbilling.php'),(20783289,7917,'./!/application/controllers/recurringbilling.php'),(20783288,18536,'./!/application/controllers/recurringbilling.php'),(20783287,2342,'./!/application/controllers/recurringbilling.php'),(20783286,16986,'./!/application/controllers/recurringbilling.php'),(20783285,18399,'./!/application/controllers/recurringbilling.php'),(20783284,18226,'./!/application/controllers/recurringbilling.php'),(20783283,2315,'./!/application/controllers/recurringbilling.php'),(20783282,18398,'./!/application/controllers/recurringbilling.php'),(20783281,18838,'./!/application/controllers/recurringbilling.php'),(20783280,7911,'./!/application/controllers/recurringbilling.php'),(20783279,8290,'./!/application/controllers/recurringbilling.php'),(20783278,5331,'./!/application/controllers/recurringbilling.php'),(20783277,18375,'./!/application/controllers/recurringbilling.php'),(20783276,2103,'./!/application/controllers/recurringbilling.php'),(20783275,5329,'./!/application/controllers/recurringbilling.php'),(20783273,7906,'./!/application/controllers/recurringbilling.php'),(20784006,17184,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784005,18234,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784004,19139,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784324,18725,'./!/application/models/arorderrentalpickupdetail_model.php'),(20784439,18414,'./!/application/models/recurringbillingplan_model.php'),(20784438,2377,'./!/application/models/recurringbillingplan_model.php'),(20784437,2225,'./!/application/models/recurringbillingplan_model.php'),(20784664,17056,'./!/application/views/appointments/summary.php'),(20784665,16810,'./!/application/views/appointments/summary.php'),(20785703,18421,'./!/application/views/invcountbatch/edit.php'),(20785702,18420,'./!/application/views/invcountbatch/edit.php'),(20785701,18419,'./!/application/views/invcountbatch/edit.php'),(20785840,16676,'./!/application/views/item/statsPerLocation.php'),(20785892,524,'./!/application/views/job/tab_view.php'),(20787351,19096,'./adminarcompanyupd.php'),(20787350,19095,'./adminarcompanyupd.php'),(20787349,12959,'./adminarcompanyupd.php'),(20787348,5975,'./adminarcompanyupd.php'),(20787347,5974,'./adminarcompanyupd.php'),(20787346,5973,'./adminarcompanyupd.php'),(20779225,3961,'./!/application/controllers/arinvoice.php'),(20786373,18434,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20793330,869,'./arinvoicesum.php'),(20786372,18433,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786371,18432,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786370,18431,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786369,18430,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786366,3030,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786367,3165,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786368,18429,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786364,2673,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786365,2676,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786363,3961,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786362,18428,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786361,2404,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786360,2070,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786359,1772,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786358,1770,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786357,18427,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786356,18426,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786355,18425,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786378,2751,'./!/application/views/recurringbilling/subscribe_js.php'),(20786377,17346,'./!/application/views/recurringbilling/subscribe_js.php'),(20786376,16506,'./!/application/views/recurringbilling/subscribe_js.php'),(20786375,1047,'./!/application/views/recurringbilling/subscribe_js.php'),(20787191,19837,'./adminarcompanytaxupd.php'),(20787190,6586,'./adminarcompanytaxupd.php'),(20787189,315,'./adminarcompanytaxupd.php'),(20787188,16636,'./adminarcompanytaxupd.php'),(20787187,6585,'./adminarcompanytaxupd.php'),(20787186,279,'./adminarcompanytaxupd.php'),(20787345,5972,'./adminarcompanyupd.php'),(20787344,18606,'./adminarcompanyupd.php'),(20787343,18605,'./adminarcompanyupd.php'),(20787342,14598,'./adminarcompanyupd.php'),(20792552,5145,'./arinvoicepay.php'),(20792664,226,'./arinvoicepayreceipt.php'),(20793106,5385,'./arinvoicereptax.php'),(20793105,1743,'./arinvoicereptax.php'),(20793104,9622,'./arinvoicereptax.php'),(20793103,1703,'./arinvoicereptax.php'),(20793102,1692,'./arinvoicereptax.php'),(20793101,1678,'./arinvoicereptax.php'),(20793100,1672,'./arinvoicereptax.php'),(20793099,1668,'./arinvoicereptax.php'),(20793098,19655,'./arinvoicereptax.php'),(20793097,10940,'./arinvoicereptax.php'),(20793096,17593,'./arinvoicereptax.php'),(20793095,1446,'./arinvoicereptax.php'),(20793094,1350,'./arinvoicereptax.php'),(20793093,19583,'./arinvoicereptax.php'),(20793092,19582,'./arinvoicereptax.php'),(20793091,1349,'./arinvoicereptax.php'),(20793090,12720,'./arinvoicereptax.php'),(20793089,18443,'./arinvoicereptax.php'),(20793088,18565,'./arinvoicereptax.php'),(20793087,1348,'./arinvoicereptax.php'),(20793086,8936,'./arinvoicereptax.php'),(20793085,1019,'./arinvoicereptax.php'),(20793084,18627,'./arinvoicereptax.php'),(20793083,5407,'./arinvoicereptax.php'),(20793082,737,'./arinvoicereptax.php'),(20793081,4481,'./arinvoicereptax.php'),(20793080,6228,'./arinvoicereptax.php'),(20793079,9492,'./arinvoicereptax.php'),(20793078,607,'./arinvoicereptax.php'),(20793077,18442,'./arinvoicereptax.php'),(20793076,15542,'./arinvoicereptax.php'),(20793075,15541,'./arinvoicereptax.php'),(20793074,12719,'./arinvoicereptax.php'),(20793073,15540,'./arinvoicereptax.php'),(20793072,337,'./arinvoicereptax.php'),(20793970,9377,'./arordcc.php'),(20794022,10253,'./arordconfirmfpdf.php'),(20794574,10862,'./arorderlist_sum.php'),(20794573,326,'./arorderlist_sum.php'),(20795015,9492,'./arordpicktickfpdf.php'),(20795132,14133,'./arordshipadd.php'),(20795131,59,'./arordshipadd.php'),(20797162,15665,'./dbupdate.php'),(20803716,1427,'./invitemlstsum.php'),(20803715,5407,'./invitemlstsum.php'),(20803714,665,'./invitemlstsum.php'),(20803713,616,'./invitemlstsum.php'),(20803811,12950,'./invitemlstval.php'),(20803810,14109,'./invitemlstval.php'),(20803809,16071,'./invitemlstval.php'),(20803808,1598,'./invitemlstval.php'),(20803807,1450,'./invitemlstval.php'),(20803806,1447,'./invitemlstval.php'),(20803805,1428,'./invitemlstval.php'),(20803804,1427,'./invitemlstval.php'),(20803803,5407,'./invitemlstval.php'),(20804378,197,'./invitemupd1.php'),(20804377,17616,'./invitemupd1.php'),(20804376,168,'./invitemupd1.php'),(20805902,445,'./nporder.php'),(20805901,19150,'./nporder.php'),(20806291,14050,'./nporderpayment.php'),(20814556,659,'./includes/invfunctions.php'),(20814929,8021,'./includes/main.php'),(20814928,315,'./includes/main.php'),(20778976,2702,'./!/application/controllers/ardailyclose.php'),(20778975,17656,'./!/application/controllers/ardailyclose.php'),(20778974,4211,'./!/application/controllers/ardailyclose.php'),(20778973,2208,'./!/application/controllers/ardailyclose.php'),(20778972,19883,'./!/application/controllers/ardailyclose.php'),(20778971,4721,'./!/application/controllers/ardailyclose.php'),(20778970,17294,'./!/application/controllers/ardailyclose.php'),(20778969,1788,'./!/application/controllers/ardailyclose.php'),(20778968,18478,'./!/application/controllers/ardailyclose.php'),(20778967,18477,'./!/application/controllers/ardailyclose.php'),(20778966,18476,'./!/application/controllers/ardailyclose.php'),(20778965,17652,'./!/application/controllers/ardailyclose.php'),(20778964,18475,'./!/application/controllers/ardailyclose.php'),(20779224,18993,'./!/application/controllers/arinvoice.php'),(20779221,2664,'./!/application/controllers/arinvoice.php'),(20779220,18497,'./!/application/controllers/arinvoice.php'),(20779219,2638,'./!/application/controllers/arinvoice.php'),(20779218,4265,'./!/application/controllers/arinvoice.php'),(20779217,18991,'./!/application/controllers/arinvoice.php'),(20779216,7674,'./!/application/controllers/arinvoice.php'),(20779215,17892,'./!/application/controllers/arinvoice.php'),(20779214,18143,'./!/application/controllers/arinvoice.php'),(20779213,18893,'./!/application/controllers/arinvoice.php'),(20779212,20202,'./!/application/controllers/arinvoice.php'),(20779211,12234,'./!/application/controllers/arinvoice.php'),(20779210,18990,'./!/application/controllers/arinvoice.php'),(20779209,18989,'./!/application/controllers/arinvoice.php'),(20779208,2529,'./!/application/controllers/arinvoice.php'),(20779207,2523,'./!/application/controllers/arinvoice.php'),(20779206,2508,'./!/application/controllers/arinvoice.php'),(20779205,18055,'./!/application/controllers/arinvoice.php'),(20779204,2459,'./!/application/controllers/arinvoice.php'),(20779203,18496,'./!/application/controllers/arinvoice.php'),(20779202,2404,'./!/application/controllers/arinvoice.php'),(20779201,18679,'./!/application/controllers/arinvoice.php'),(20779200,15768,'./!/application/controllers/arinvoice.php'),(20779198,17500,'./!/application/controllers/arinvoice.php'),(20779357,1014,'./!/application/controllers/arorder.php'),(20779356,3465,'./!/application/controllers/arorder.php'),(20779355,9224,'./!/application/controllers/arorder.php'),(20779354,932,'./!/application/controllers/arorder.php'),(20779353,16656,'./!/application/controllers/arorder.php'),(20779352,869,'./!/application/controllers/arorder.php'),(20779351,5205,'./!/application/controllers/arorder.php'),(20779350,4973,'./!/application/controllers/arorder.php'),(20779349,749,'./!/application/controllers/arorder.php'),(20779348,5299,'./!/application/controllers/arorder.php'),(20779347,18306,'./!/application/controllers/arorder.php'),(20779346,697,'./!/application/controllers/arorder.php'),(20779557,1696,'./!/application/controllers/arordership.php'),(20779837,5725,'./!/application/controllers/ccterminal.php'),(20779836,17501,'./!/application/controllers/ccterminal.php'),(20780221,15766,'./!/application/controllers/customer.php'),(20780220,17546,'./!/application/controllers/customer.php'),(20780219,15765,'./!/application/controllers/customer.php'),(20780218,15850,'./!/application/controllers/customer.php'),(20780217,6715,'./!/application/controllers/customer.php'),(20780216,5985,'./!/application/controllers/customer.php'),(20780215,14693,'./!/application/controllers/customer.php'),(20780214,2044,'./!/application/controllers/customer.php'),(20780213,18512,'./!/application/controllers/customer.php'),(20780212,17545,'./!/application/controllers/customer.php'),(20780211,17544,'./!/application/controllers/customer.php'),(20780210,14575,'./!/application/controllers/customer.php'),(20780209,2093,'./!/application/controllers/customer.php'),(20780208,15764,'./!/application/controllers/customer.php'),(20780207,2103,'./!/application/controllers/customer.php'),(20780206,2099,'./!/application/controllers/customer.php'),(20780205,18586,'./!/application/controllers/customer.php'),(20780203,1963,'./!/application/controllers/customer.php'),(20780911,17262,'./!/application/controllers/invbin.php'),(20780910,19289,'./!/application/controllers/invbin.php'),(20781081,17025,'./!/application/controllers/invcotransfer.php'),(20781080,18175,'./!/application/controllers/invcotransfer.php'),(20781079,16522,'./!/application/controllers/invcotransfer.php'),(20781167,3271,'./!/application/controllers/invcotransferdetail.php'),(20781166,16673,'./!/application/controllers/invcotransferdetail.php'),(20781165,11704,'./!/application/controllers/invcotransferdetail.php'),(20781164,18521,'./!/application/controllers/invcotransferdetail.php'),(20781163,18520,'./!/application/controllers/invcotransferdetail.php'),(20781162,18507,'./!/application/controllers/invcotransferdetail.php'),(20781161,2702,'./!/application/controllers/invcotransferdetail.php'),(20781160,17025,'./!/application/controllers/invcotransferdetail.php'),(20781159,19911,'./!/application/controllers/invcotransferdetail.php'),(20781158,19910,'./!/application/controllers/invcotransferdetail.php'),(20781157,19064,'./!/application/controllers/invcotransferdetail.php'),(20781156,19063,'./!/application/controllers/invcotransferdetail.php'),(20781155,6762,'./!/application/controllers/invcotransferdetail.php'),(20781278,1740,'./!/application/controllers/invcountbatch.php'),(20781279,16531,'./!/application/controllers/invcountbatch.php'),(20781277,1696,'./!/application/controllers/invcountbatch.php'),(20781541,9491,'./!/application/controllers/invreceivemain.php'),(20781540,3274,'./!/application/controllers/invreceivemain.php'),(20781539,18380,'./!/application/controllers/invreceivemain.php'),(20781538,16875,'./!/application/controllers/invreceivemain.php'),(20781537,18379,'./!/application/controllers/invreceivemain.php'),(20781536,2363,'./!/application/controllers/invreceivemain.php'),(20781535,2182,'./!/application/controllers/invreceivemain.php'),(20781534,1788,'./!/application/controllers/invreceivemain.php'),(20781533,5081,'./!/application/controllers/invreceivemain.php'),(20781532,5570,'./!/application/controllers/invreceivemain.php'),(20781557,18523,'./!/application/controllers/invzone.php'),(20781556,16469,'./!/application/controllers/invzone.php'),(20781555,548,'./!/application/controllers/invzone.php'),(20781554,541,'./!/application/controllers/invzone.php'),(20781697,2509,'./!/application/controllers/item.php'),(20781698,19818,'./!/application/controllers/item.php'),(20781696,2508,'./!/application/controllers/item.php'),(20781855,2508,'./!/application/controllers/itemlocation.php'),(20781853,17931,'./!/application/controllers/itemlocation.php'),(20781852,2371,'./!/application/controllers/itemlocation.php'),(20781851,17930,'./!/application/controllers/itemlocation.php'),(20781850,3741,'./!/application/controllers/itemlocation.php'),(20781849,2222,'./!/application/controllers/itemlocation.php'),(20781848,19364,'./!/application/controllers/itemlocation.php'),(20782014,16694,'./!/application/controllers/itemvendor.php'),(20782013,19825,'./!/application/controllers/itemvendor.php'),(20782012,3298,'./!/application/controllers/itemvendor.php'),(20782011,3294,'./!/application/controllers/itemvendor.php'),(20782010,3274,'./!/application/controllers/itemvendor.php'),(20782009,18532,'./!/application/controllers/itemvendor.php'),(20782008,13932,'./!/application/controllers/itemvendor.php'),(20782007,18354,'./!/application/controllers/itemvendor.php'),(20782006,16692,'./!/application/controllers/itemvendor.php'),(20782005,18531,'./!/application/controllers/itemvendor.php'),(20782004,2103,'./!/application/controllers/itemvendor.php'),(20782003,6986,'./!/application/controllers/itemvendor.php'),(20782002,19130,'./!/application/controllers/itemvendor.php'),(20782001,1726,'./!/application/controllers/itemvendor.php'),(20782000,1709,'./!/application/controllers/itemvendor.php'),(20781999,16690,'./!/application/controllers/itemvendor.php'),(20782734,7973,'./!/application/controllers/main.php'),(20782733,11004,'./!/application/controllers/main.php'),(20782732,10655,'./!/application/controllers/main.php'),(20782731,3688,'./!/application/controllers/main.php'),(20783123,744,'./!/application/controllers/paymentonaccount.php'),(20783209,2292,'./!/application/controllers/priceoverriderequest.php'),(20783208,4563,'./!/application/controllers/priceoverriderequest.php'),(20783207,2103,'./!/application/controllers/priceoverriderequest.php'),(20783206,1894,'./!/application/controllers/priceoverriderequest.php'),(20783274,18397,'./!/application/controllers/recurringbilling.php'),(20783527,18840,'./!/application/controllers/scanner.php'),(20783526,18741,'./!/application/controllers/scanner.php'),(20783525,18740,'./!/application/controllers/scanner.php'),(20783524,18739,'./!/application/controllers/scanner.php'),(20783523,2165,'./!/application/controllers/scanner.php'),(20783522,18541,'./!/application/controllers/scanner.php'),(20783521,9627,'./!/application/controllers/scanner.php'),(20783520,11005,'./!/application/controllers/scanner.php'),(20489192,18550,'./!/application/controllers/territory.php'),(20489191,18549,'./!/application/controllers/territory.php'),(20489190,19382,'./!/application/controllers/territory.php'),(20784339,18241,'./!/application/models/arordershipdetail_model.php'),(20784338,16525,'./!/application/models/arordershipdetail_model.php'),(20784587,17480,'./!/application/views/appointments/admin.php'),(20784787,607,'./!/application/views/ardailyclose/create.js.php'),(20785712,416,'./!/application/views/invcountbatch/enterCounts.php'),(20784800,18556,'./!/application/views/ardailyclose/create_get_system_totals.checks.gl.php'),(20784801,5024,'./!/application/views/ardailyclose/create_get_system_totals.checks.gl.php'),(20785614,19301,'./!/application/views/invcotransfer/assignByZone_form.php'),(20785757,16528,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20784810,5024,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.gl.php'),(20784809,2044,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.gl.php'),(20784808,18923,'./!/application/views/ardailyclose/create_get_system_totals.creditcards.gl.php'),(20784823,799,'./!/application/views/ardailyclose/dataTable.datePopup.php'),(20784822,541,'./!/application/views/ardailyclose/dataTable.datePopup.php'),(20784821,8125,'./!/application/views/ardailyclose/dataTable.datePopup.php'),(20784841,17662,'./!/application/views/ardailyclose/view.php'),(20784840,17660,'./!/application/views/ardailyclose/view.php'),(20784839,17658,'./!/application/views/ardailyclose/view.php'),(20784838,17657,'./!/application/views/ardailyclose/view.php'),(20784837,4211,'./!/application/views/ardailyclose/view.php'),(20784836,1788,'./!/application/views/ardailyclose/view.php'),(20784835,18475,'./!/application/views/ardailyclose/view.php'),(20784834,18474,'./!/application/views/ardailyclose/view.php'),(20784833,18473,'./!/application/views/ardailyclose/view.php'),(20784832,15970,'./!/application/views/ardailyclose/view.php'),(20784831,1036,'./!/application/views/ardailyclose/view.php'),(20784830,18562,'./!/application/views/ardailyclose/view.php'),(20784829,18561,'./!/application/views/ardailyclose/view.php'),(20784828,18560,'./!/application/views/ardailyclose/view.php'),(20784827,18559,'./!/application/views/ardailyclose/view.php'),(20784826,18558,'./!/application/views/ardailyclose/view.php'),(20784825,11842,'./!/application/views/ardailyclose/view.php'),(20784824,17642,'./!/application/views/ardailyclose/view.php'),(20784869,18718,'./!/application/views/arinvoice/header.php'),(20784868,1678,'./!/application/views/arinvoice/header.php'),(20784878,3035,'./!/application/views/arinvoice/header_extra.php'),(20784877,2803,'./!/application/views/arinvoice/header_extra.php'),(20784876,2676,'./!/application/views/arinvoice/header_extra.php'),(20784875,2361,'./!/application/views/arinvoice/header_extra.php'),(20784873,6739,'./!/application/views/arinvoice/header_extra.php'),(20784874,2231,'./!/application/views/arinvoice/header_extra.php'),(20784902,18574,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784901,18573,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784900,2628,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784899,18496,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784898,18572,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784897,2052,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784896,18571,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784895,18570,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784894,1047,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784893,18569,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784892,18568,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784891,18567,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784890,869,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784889,18566,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784888,6065,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784909,17494,'./!/application/views/arinvoice/orderby_shipto.php'),(20784908,2819,'./!/application/views/arinvoice/orderby_shipto.php'),(20784907,2833,'./!/application/views/arinvoice/orderby_shipto.php'),(20784906,6770,'./!/application/views/arinvoice/orderby_shipto.php'),(20784905,2170,'./!/application/views/arinvoice/orderby_shipto.php'),(20784904,1788,'./!/application/views/arinvoice/orderby_shipto.php'),(20784903,11868,'./!/application/views/arinvoice/orderby_shipto.php'),(20805149,14960,'./invpoupd.php'),(20784937,3172,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784921,3090,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20784919,5863,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20784916,11756,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20784920,18752,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20784918,2508,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20784936,3017,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784935,3005,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784934,5863,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784933,2508,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784932,18580,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784931,18579,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784930,13334,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784929,1781,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784928,1709,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784927,18570,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784926,1047,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784925,869,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784924,18578,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20785553,2044,'./!/application/views/generic/select.php'),(20785595,18757,'./!/application/views/invbin/bin_item_assignment.php'),(20785717,13991,'./!/application/views/invcountbatch/enterCounts.php'),(20785594,18756,'./!/application/views/invbin/bin_item_assignment.php'),(20785593,18755,'./!/application/views/invbin/bin_item_assignment.php'),(20785592,1713,'./!/application/views/invbin/bin_item_assignment.php'),(20785591,1709,'./!/application/views/invbin/bin_item_assignment.php'),(20785891,389,'./!/application/views/job/tab_view.php'),(20785890,325,'./!/application/views/job/tab_view.php'),(20785889,6717,'./!/application/views/job/tab_view.php'),(20785888,185,'./!/application/views/job/tab_view.php'),(20785887,15201,'./!/application/views/job/tab_view.php'),(20786264,2103,'./!/application/views/priceoverriderequest/edit.php'),(20786263,18609,'./!/application/views/priceoverriderequest/edit.php'),(20786262,18592,'./!/application/views/priceoverriderequest/edit.php'),(20786753,14853,'./admin3dcart.php'),(20787341,19405,'./adminarcompanyupd.php'),(20787340,13652,'./adminarcompanyupd.php'),(20787339,13998,'./adminarcompanyupd.php'),(20787338,8010,'./adminarcompanyupd.php'),(20787337,19572,'./adminarcompanyupd.php'),(20787336,3958,'./adminarcompanyupd.php'),(20787335,18257,'./adminarcompanyupd.php'),(20787334,4973,'./adminarcompanyupd.php'),(20787333,749,'./adminarcompanyupd.php'),(20787332,20052,'./adminarcompanyupd.php'),(20787331,18604,'./adminarcompanyupd.php'),(20787330,18306,'./adminarcompanyupd.php'),(20787329,8800,'./adminarcompanyupd.php'),(20787328,3458,'./adminarcompanyupd.php'),(20787327,11787,'./adminarcompanyupd.php'),(20787326,673,'./adminarcompanyupd.php'),(20787325,16681,'./adminarcompanyupd.php'),(20787954,18615,'./adminartaxexadd.php'),(20787953,315,'./adminartaxexadd.php'),(20787965,19649,'./adminartaxexupd.php'),(20787964,142,'./adminartaxexupd.php'),(20792157,325,'./arinvoice_writeoff.php'),(20792156,315,'./arinvoice_writeoff.php'),(20790453,15895,'./apbillupd.php'),(20790452,10004,'./apbillupd.php'),(20791722,13994,'./arcustadd.php'),(20791721,315,'./arcustadd.php'),(20791981,59,'./arcustupd.php'),(20791980,4713,'./arcustupd.php'),(20791979,52,'./arcustupd.php'),(20791978,15201,'./arcustupd.php'),(20791977,15897,'./arcustupd.php'),(20792411,1557,'./arinvoicecalcint.php'),(20792410,13068,'./arinvoicecalcint.php'),(20792551,20088,'./arinvoicepay.php'),(20792550,274,'./arinvoicepay.php'),(20792549,17122,'./arinvoicepay.php'),(20792548,232,'./arinvoicepay.php'),(20792663,15924,'./arinvoicepayreceipt.php'),(20792897,542,'./arinvoicerepcust.php'),(20792896,356,'./arinvoicerepcust.php'),(20792895,326,'./arinvoicerepcust.php'),(20792894,315,'./arinvoicerepcust.php'),(20792893,6717,'./arinvoicerepcust.php'),(20793071,315,'./arinvoicereptax.php'),(20793070,284,'./arinvoicereptax.php'),(20793214,6806,'./arinvoicereturnsdetail.php'),(20793441,5204,'./arinvoiceupd.php'),(20793611,18565,'./arinvoiceview.php'),(20793610,8936,'./arinvoiceview.php'),(20793609,981,'./arinvoiceview.php'),(20793608,941,'./arinvoiceview.php'),(20793607,892,'./arinvoiceview.php'),(20793606,6736,'./arinvoiceview.php'),(20793605,869,'./arinvoiceview.php'),(20793604,13787,'./arinvoiceview.php'),(20793603,13789,'./arinvoiceview.php'),(20793602,13785,'./arinvoiceview.php'),(20793601,13784,'./arinvoiceview.php'),(20793600,5205,'./arinvoiceview.php'),(20793599,737,'./arinvoiceview.php'),(20793598,673,'./arinvoiceview.php'),(20793597,634,'./arinvoiceview.php'),(20795014,5459,'./arordpicktickfpdf.php'),(20795013,15632,'./arordpicktickfpdf.php'),(20795012,542,'./arordpicktickfpdf.php'),(20795130,15755,'./arordshipadd.php'),(20795300,5086,'./arordshipboxlabelpdf.php'),(20795460,17450,'./arordshipviewfpdf.php'),(20795459,737,'./arordshipviewfpdf.php'),(20795458,719,'./arordshipviewfpdf.php'),(20795457,8730,'./arordshipviewfpdf.php'),(20795456,6228,'./arordshipviewfpdf.php'),(20795725,6793,'./arrmaorderadd.php'),(20795760,6807,'./arrmaorderreceive.php'),(20796120,5503,'./arserviceordupd.php'),(20796621,11727,'./barlabelfpdf.php'),(20800048,18655,'./genuserrights.php'),(20800047,18654,'./genuserrights.php'),(20800046,18653,'./genuserrights.php'),(20800045,18652,'./genuserrights.php'),(20800044,18651,'./genuserrights.php'),(20800043,18650,'./genuserrights.php'),(20800042,18649,'./genuserrights.php'),(20800041,18648,'./genuserrights.php'),(20800040,18647,'./genuserrights.php'),(20800039,18646,'./genuserrights.php'),(20800038,18645,'./genuserrights.php'),(20800037,18644,'./genuserrights.php'),(20800036,18643,'./genuserrights.php'),(20800035,18642,'./genuserrights.php'),(20800034,18641,'./genuserrights.php'),(20800033,18640,'./genuserrights.php'),(20800032,18639,'./genuserrights.php'),(20800031,6523,'./genuserrights.php'),(20800030,3672,'./genuserrights.php'),(20800029,18775,'./genuserrights.php'),(20800028,1639,'./genuserrights.php'),(20800027,1559,'./genuserrights.php'),(20800026,18774,'./genuserrights.php'),(20800025,18773,'./genuserrights.php'),(20800024,9602,'./genuserrights.php'),(20800023,18638,'./genuserrights.php'),(20800022,8936,'./genuserrights.php'),(20800021,19858,'./genuserrights.php'),(20800020,18277,'./genuserrights.php'),(20800019,18637,'./genuserrights.php'),(20800018,542,'./genuserrights.php'),(20800102,18652,'./genuserrightsgroup.php'),(20800101,18651,'./genuserrightsgroup.php'),(20800100,18650,'./genuserrightsgroup.php'),(20800099,18649,'./genuserrightsgroup.php'),(20800098,18648,'./genuserrightsgroup.php'),(20800097,18647,'./genuserrightsgroup.php'),(20800096,18646,'./genuserrightsgroup.php'),(20800095,18645,'./genuserrightsgroup.php'),(20800094,18644,'./genuserrightsgroup.php'),(20800093,18643,'./genuserrightsgroup.php'),(20800092,18642,'./genuserrightsgroup.php'),(20800091,18641,'./genuserrightsgroup.php'),(20800090,18640,'./genuserrightsgroup.php'),(20800089,18639,'./genuserrightsgroup.php'),(20800088,6523,'./genuserrightsgroup.php'),(20800087,3672,'./genuserrightsgroup.php'),(20800086,18775,'./genuserrightsgroup.php'),(20800085,1639,'./genuserrightsgroup.php'),(20800084,1559,'./genuserrightsgroup.php'),(20800083,18774,'./genuserrightsgroup.php'),(20800082,18773,'./genuserrightsgroup.php'),(20800081,9607,'./genuserrightsgroup.php'),(20800080,7004,'./genuserrightsgroup.php'),(20800079,18638,'./genuserrightsgroup.php'),(20800078,8936,'./genuserrightsgroup.php'),(20800077,799,'./genuserrightsgroup.php'),(20800076,18277,'./genuserrightsgroup.php'),(20800075,18637,'./genuserrightsgroup.php'),(20800074,18636,'./genuserrightsgroup.php'),(20800073,3544,'./genuserrightsgroup.php'),(20800072,8125,'./genuserrightsgroup.php'),(20800433,10,'./glbudlst.php'),(20800432,20,'./glbudlst.php'),(20800597,15805,'./glexpense.php'),(20800596,18666,'./glexpense.php'),(20800918,40,'./gljourupd.php'),(20800917,20,'./gljourupd.php'),(20801815,15837,'./importcustomer.php'),(20801814,17,'./importcustomer.php'),(20802029,315,'./importglbudgets.php'),(20802028,11,'./importglbudgets.php'),(20802027,10,'./importglbudgets.php'),(20802227,6076,'./importitems.php'),(20802226,18776,'./importitems.php'),(20802225,9373,'./importitems.php'),(20802224,9372,'./importitems.php'),(20802558,572,'./invcotransfer.php'),(20802557,566,'./invcotransfer.php'),(20802950,56,'./invitemactivity.php'),(20802949,47,'./invitemactivity.php'),(20803036,8936,'./invitemadd.php'),(20803035,18854,'./invitemadd.php'),(20803034,18779,'./invitemadd.php'),(20803033,1047,'./invitemadd.php'),(20803712,467,'./invitemlstsum.php'),(20803711,451,'./invitemlstsum.php'),(20803710,17611,'./invitemlstsum.php'),(20803709,315,'./invitemlstsum.php'),(20803708,197,'./invitemlstsum.php'),(20804078,8936,'./invitemreclist.php'),(20804077,1132,'./invitemreclist.php'),(20804076,1047,'./invitemreclist.php'),(20804075,1032,'./invitemreclist.php'),(20804074,1014,'./invitemreclist.php'),(20804073,6226,'./invitemreclist.php'),(20804072,18859,'./invitemreclist.php'),(20804071,9492,'./invitemreclist.php'),(20804070,451,'./invitemreclist.php'),(20804069,416,'./invitemreclist.php'),(20804189,197,'./invitemupd.php'),(20804188,14001,'./invitemupd.php'),(20804187,188,'./invitemupd.php'),(20804186,168,'./invitemupd.php'),(20804185,166,'./invitemupd.php'),(20804184,7011,'./invitemupd.php'),(20804183,110,'./invitemupd.php'),(20804876,1293,'./invporecv.php'),(20804875,1285,'./invporecv.php'),(20804874,1283,'./invporecv.php'),(20804873,8936,'./invporecv.php'),(20804872,932,'./invporecv.php'),(20804871,744,'./invporecv.php'),(20804994,1081,'./invpotoap.php'),(20804993,1054,'./invpotoap.php'),(20804992,1047,'./invpotoap.php'),(20804991,1020,'./invpotoap.php'),(20804990,932,'./invpotoap.php'),(20804989,892,'./invpotoap.php'),(20804988,890,'./invpotoap.php'),(20804987,20147,'./invpotoap.php'),(20804986,9492,'./invpotoap.php'),(20804985,616,'./invpotoap.php'),(20805148,869,'./invpoupd.php'),(20805900,20152,'./nporder.php'),(20805899,9132,'./nporder.php'),(20805898,18686,'./nporder.php'),(20805897,19861,'./nporder.php'),(20805896,19860,'./nporder.php'),(20805895,16697,'./nporder.php'),(20805894,416,'./nporder.php'),(20805893,14068,'./nporder.php'),(20805892,18028,'./nporder.php'),(20805891,3544,'./nporder.php'),(20805890,14277,'./nporder.php'),(20805889,325,'./nporder.php'),(20805888,16696,'./nporder.php'),(20811139,315,'./voucherdetail.php'),(20811205,20,'./includes/apfunctions.php'),(20811587,20161,'./includes/arfunctions.php'),(20811586,5146,'./includes/arfunctions.php'),(20811585,5145,'./includes/arfunctions.php'),(20811584,8051,'./includes/arfunctions.php'),(20811583,226,'./includes/arfunctions.php'),(20811582,9452,'./includes/arfunctions.php'),(20813630,12675,'./includes/footer.php'),(20813838,1973,'./includes/functions.php'),(20814037,13994,'./includes/genfunctions.php'),(20814036,9357,'./includes/genfunctions.php'),(20814035,13410,'./includes/genfunctions.php'),(20814034,14584,'./includes/genfunctions.php'),(20814033,7951,'./includes/genfunctions.php'),(20814032,7950,'./includes/genfunctions.php'),(20814031,8631,'./includes/genfunctions.php'),(20814030,8630,'./includes/genfunctions.php'),(20814029,9442,'./includes/genfunctions.php'),(20814028,8629,'./includes/genfunctions.php'),(20814555,13823,'./includes/invfunctions.php'),(20814554,9492,'./includes/invfunctions.php'),(20814553,605,'./includes/invfunctions.php'),(20814552,600,'./includes/invfunctions.php'),(20814551,591,'./includes/invfunctions.php'),(20814550,13822,'./includes/invfunctions.php'),(20814549,572,'./includes/invfunctions.php'),(20814548,548,'./includes/invfunctions.php'),(20814547,524,'./includes/invfunctions.php'),(20814918,13992,'./includes/mailclass.php'),(20779199,2363,'./!/application/controllers/arinvoice.php'),(20779197,18988,'./!/application/controllers/arinvoice.php'),(20779196,8861,'./!/application/controllers/arinvoice.php'),(20779195,2361,'./!/application/controllers/arinvoice.php'),(20779493,1781,'./!/application/controllers/arorderrentalpickup.php'),(20779492,7306,'./!/application/controllers/arorderrentalpickup.php'),(20779491,5081,'./!/application/controllers/arorderrentalpickup.php'),(20779490,1696,'./!/application/controllers/arorderrentalpickup.php'),(20779489,5652,'./!/application/controllers/arorderrentalpickup.php'),(20779488,6125,'./!/application/controllers/arorderrentalpickup.php'),(20779487,18728,'./!/application/controllers/arorderrentalpickup.php'),(20779486,1047,'./!/application/controllers/arorderrentalpickup.php'),(20779485,17898,'./!/application/controllers/arorderrentalpickup.php'),(20779484,5205,'./!/application/controllers/arorderrentalpickup.php'),(20779483,799,'./!/application/controllers/arorderrentalpickup.php'),(20779482,737,'./!/application/controllers/arorderrentalpickup.php'),(20779481,6226,'./!/application/controllers/arorderrentalpickup.php'),(20779480,13084,'./!/application/controllers/arorderrentalpickup.php'),(20779479,4481,'./!/application/controllers/arorderrentalpickup.php'),(20781276,18350,'./!/application/controllers/invcountbatch.php'),(20781274,1666,'./!/application/controllers/invcountbatch.php'),(20781275,19542,'./!/application/controllers/invcountbatch.php'),(20781273,19541,'./!/application/controllers/invcountbatch.php'),(20783121,9492,'./!/application/controllers/paymentonaccount.php'),(20783519,1696,'./!/application/controllers/scanner.php'),(20783518,1668,'./!/application/controllers/scanner.php'),(20783517,18717,'./!/application/controllers/scanner.php'),(20783516,18539,'./!/application/controllers/scanner.php'),(20783515,10451,'./!/application/controllers/scanner.php'),(20783514,17178,'./!/application/controllers/scanner.php'),(20783513,14061,'./!/application/controllers/scanner.php'),(20783512,1047,'./!/application/controllers/scanner.php'),(20783511,989,'./!/application/controllers/scanner.php'),(20783510,697,'./!/application/controllers/scanner.php'),(20783509,479,'./!/application/controllers/scanner.php'),(20783508,18738,'./!/application/controllers/scanner.php'),(20783507,8702,'./!/application/controllers/scanner.php'),(20783506,315,'./!/application/controllers/scanner.php'),(20784225,18751,'./!/application/model_collections/invadjustmenttype_collection.php'),(20784224,18750,'./!/application/model_collections/invadjustmenttype_collection.php'),(20784223,18749,'./!/application/model_collections/invadjustmenttype_collection.php'),(20784222,18748,'./!/application/model_collections/invadjustmenttype_collection.php'),(20784221,18747,'./!/application/model_collections/invadjustmenttype_collection.php'),(20784323,16526,'./!/application/models/arorderrentalpickupdetail_model.php'),(20784917,18576,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20786002,7199,'./!/application/views/meta_menu/arinvoice.php'),(20786206,18760,'./!/application/views/paymentonaccount/entry_js.php'),(20786467,2459,'./!/application/views/scanner/index.php'),(20786466,17178,'./!/application/views/scanner/index.php'),(20787123,17,'./adminarcarriermethupd.php'),(20787324,15554,'./adminarcompanyupd.php'),(20787323,19231,'./adminarcompanyupd.php'),(20787322,19230,'./adminarcompanyupd.php'),(20787321,17740,'./adminarcompanyupd.php'),(20787963,59,'./adminartaxexupd.php'),(20791689,6050,'./arcredit_writecheck.php'),(20791038,681,'./apvendlist.php'),(20791037,197,'./apvendlist.php'),(20790907,17141,'./apvariance.php'),(20793440,7731,'./arinvoiceupd.php'),(20793596,18564,'./arinvoiceview.php'),(20793595,542,'./arinvoiceview.php'),(20795455,5403,'./arordshipviewfpdf.php'),(20796119,5650,'./arserviceordupd.php'),(20800017,19857,'./genuserrights.php'),(20800016,18636,'./genuserrights.php'),(20800015,3544,'./genuserrights.php'),(20800071,18635,'./genuserrightsgroup.php'),(20800070,202,'./genuserrightsgroup.php'),(20800069,9601,'./genuserrightsgroup.php'),(20802223,315,'./importitems.php'),(20802222,6981,'./importitems.php'),(20802221,309,'./importitems.php'),(20803032,18778,'./invitemadd.php'),(20803031,870,'./invitemadd.php'),(20803030,869,'./invitemadd.php'),(20803029,18960,'./invitemadd.php'),(20803028,18959,'./invitemadd.php'),(20803027,8109,'./invitemadd.php'),(20804182,15140,'./invitemupd.php'),(20804181,14008,'./invitemupd.php'),(20804180,178,'./invitemupd.php'),(20804179,177,'./invitemupd.php'),(20804640,7608,'./invordline_addedit.php'),(20804639,59,'./invordline_addedit.php'),(20804687,737,'./invpoadd.php'),(20804686,697,'./invpoadd.php'),(20804685,20139,'./invpoadd.php'),(20804870,6226,'./invporecv.php'),(20805147,841,'./invpoupd.php'),(20805146,799,'./invpoupd.php'),(20805145,697,'./invpoupd.php'),(20805144,20139,'./invpoupd.php'),(20805887,6314,'./nporder.php'),(20805886,6771,'./nporder.php'),(20806290,17424,'./nporderpayment.php'),(20811581,15839,'./includes/arfunctions.php'),(20811580,15838,'./includes/arfunctions.php'),(20811995,670,'./includes/arinvoiceviewfpdf.functions.php'),(20811994,11355,'./includes/arinvoiceviewfpdf.functions.php'),(20811993,479,'./includes/arinvoiceviewfpdf.functions.php'),(20811992,445,'./includes/arinvoiceviewfpdf.functions.php'),(20811991,406,'./includes/arinvoiceviewfpdf.functions.php'),(20813837,1972,'./includes/functions.php'),(20814027,18037,'./includes/genfunctions.php'),(20814026,14530,'./includes/genfunctions.php'),(20814025,209,'./includes/genfunctions.php'),(20814024,13409,'./includes/genfunctions.php'),(20814023,18036,'./includes/genfunctions.php'),(20814022,17053,'./includes/genfunctions.php'),(20814021,8598,'./includes/genfunctions.php'),(20814546,18327,'./includes/invfunctions.php'),(20814545,451,'./includes/invfunctions.php'),(20814544,7209,'./includes/invfunctions.php'),(20814543,5260,'./includes/invfunctions.php'),(20779194,19182,'./!/application/controllers/arinvoice.php'),(20779193,18084,'./!/application/controllers/arinvoice.php'),(20779192,19320,'./!/application/controllers/arinvoice.php'),(20779191,18801,'./!/application/controllers/arinvoice.php'),(20779190,18495,'./!/application/controllers/arinvoice.php'),(20779189,18987,'./!/application/controllers/arinvoice.php'),(20779188,18222,'./!/application/controllers/arinvoice.php'),(20779187,2260,'./!/application/controllers/arinvoice.php'),(20779185,11240,'./!/application/controllers/arinvoice.php'),(20779835,315,'./!/application/controllers/ccterminal.php'),(20779834,14085,'./!/application/controllers/ccterminal.php'),(20781078,16521,'./!/application/controllers/invcotransfer.php'),(20781077,18174,'./!/application/controllers/invcotransfer.php'),(20781075,14913,'./!/application/controllers/invcotransfer.php'),(20781272,19540,'./!/application/controllers/invcountbatch.php'),(20781694,2459,'./!/application/controllers/item.php'),(20781695,2501,'./!/application/controllers/item.php'),(20781847,5525,'./!/application/controllers/itemlocation.php'),(20782730,8008,'./!/application/controllers/main.php'),(20783120,15935,'./!/application/controllers/paymentonaccount.php'),(20784586,17479,'./!/application/views/appointments/admin.php'),(20784663,16573,'./!/application/views/appointments/summary.php'),(20784662,16571,'./!/application/views/appointments/summary.php'),(20785814,19395,'./!/application/views/item/barcodemassprint_queue.php'),(20785813,18820,'./!/application/views/item/barcodemassprint_queue.php'),(20785812,18819,'./!/application/views/item/barcodemassprint_queue.php'),(20785811,19394,'./!/application/views/item/barcodemassprint_queue.php'),(20787320,20051,'./adminarcompanyupd.php'),(20787319,18256,'./adminarcompanyupd.php'),(20787318,15988,'./adminarcompanyupd.php'),(20787317,15935,'./adminarcompanyupd.php'),(20787316,10487,'./adminarcompanyupd.php'),(20793069,14998,'./arinvoicereptax.php'),(20793068,5384,'./arinvoicereptax.php'),(20805885,15343,'./nporder.php'),(20805884,15342,'./nporder.php'),(20811990,306,'./includes/arinvoiceviewfpdf.functions.php'),(20814020,192,'./includes/genfunctions.php'),(20814019,9601,'./includes/genfunctions.php'),(20814018,14001,'./includes/genfunctions.php'),(20814772,637,'./includes/invitemaddupd.functions.php'),(20779186,11882,'./!/application/controllers/arinvoice.php'),(20779345,9341,'./!/application/controllers/arorder.php'),(20781076,2589,'./!/application/controllers/invcotransfer.php'),(20782729,18837,'./!/application/controllers/main.php'),(20782728,4133,'./!/application/controllers/main.php'),(20783272,13766,'./!/application/controllers/recurringbilling.php'),(20783271,18225,'./!/application/controllers/recurringbilling.php'),(20783270,18396,'./!/application/controllers/recurringbilling.php'),(20783269,18395,'./!/application/controllers/recurringbilling.php'),(20783268,1694,'./!/application/controllers/recurringbilling.php'),(20783267,18394,'./!/application/controllers/recurringbilling.php'),(20783266,1678,'./!/application/controllers/recurringbilling.php'),(20783265,1672,'./!/application/controllers/recurringbilling.php'),(20783505,18737,'./!/application/controllers/scanner.php'),(20784403,8769,'./!/application/models/invpo_model.php'),(20784402,8996,'./!/application/models/invpo_model.php'),(20785778,18842,'./!/application/views/invpo/barcodelabelselection.php'),(20785777,18819,'./!/application/views/invpo/barcodelabelselection.php'),(20785776,18818,'./!/application/views/invpo/barcodelabelselection.php'),(20785795,3522,'./!/application/views/invpo/invpodetail_table.php'),(20787315,15717,'./adminarcompanyupd.php'),(20787314,8179,'./adminarcompanyupd.php'),(20787310,14363,'./adminarcompanyupd.php'),(20787313,583,'./adminarcompanyupd.php'),(20787312,3566,'./adminarcompanyupd.php'),(20789914,7952,'./adminsystemsettings.php'),(20790289,20,'./apbillpay.php'),(20790451,15699,'./apbillupd.php'),(20790450,226,'./apbillupd.php'),(20790449,12781,'./apbillupd.php'),(20790692,226,'./apccpurchaseupd.php'),(20790691,59,'./apccpurchaseupd.php'),(20792547,226,'./arinvoicepay.php'),(20802151,14203,'./importinvoices.php'),(20802150,14221,'./importinvoices.php'),(20802149,315,'./importinvoices.php'),(20802148,5145,'./importinvoices.php'),(20802147,226,'./importinvoices.php'),(20802146,16348,'./importinvoices.php'),(20802145,14890,'./importinvoices.php'),(20803026,16932,'./invitemadd.php'),(20803025,5832,'./invitemadd.php'),(20803024,616,'./invitemadd.php'),(20803023,603,'./invitemadd.php'),(20803022,17466,'./invitemadd.php'),(20803021,6156,'./invitemadd.php'),(20803020,9968,'./invitemadd.php'),(20803019,451,'./invitemadd.php'),(20803018,13930,'./invitemadd.php'),(20803017,6076,'./invitemadd.php'),(20803016,18776,'./invitemadd.php'),(20803015,9373,'./invitemadd.php'),(20803014,9372,'./invitemadd.php'),(20803013,13994,'./invitemadd.php'),(20803012,7035,'./invitemadd.php'),(20803977,416,'./invitemprices.php'),(20804068,333,'./invitemreclist.php'),(20804067,325,'./invitemreclist.php'),(20804066,315,'./invitemreclist.php'),(20804065,226,'./invitemreclist.php'),(20804450,158,'./invitemvendupd.php'),(20804449,156,'./invitemvendupd.php'),(20804448,59,'./invitemvendupd.php'),(20804447,54,'./invitemvendupd.php'),(20804869,18859,'./invporecv.php'),(20804868,572,'./invporecv.php'),(20804867,18863,'./invporecv.php'),(20804936,13394,'./invporeturn.php'),(20804984,3567,'./invpotoap.php'),(20804983,566,'./invpotoap.php'),(20804982,12076,'./invpotoap.php'),(20804981,12075,'./invpotoap.php'),(20805104,226,'./invpotocc.php'),(20805243,20,'./invpoviewfpdf.php'),(20811204,17211,'./includes/apfunctions.php'),(20811989,6682,'./includes/arinvoiceviewfpdf.functions.php'),(20812106,6838,'./includes/arstateviewfpdf.functions.php'),(20813836,1971,'./includes/functions.php'),(20814017,9356,'./includes/genfunctions.php'),(20814511,13509,'./includes/invcotransfer.functions.php'),(20814510,8165,'./includes/invcotransfer.functions.php'),(20814542,6076,'./includes/invfunctions.php'),(20814541,18776,'./includes/invfunctions.php'),(20814540,7420,'./includes/invfunctions.php'),(20814539,402,'./includes/invfunctions.php'),(20814538,9375,'./includes/invfunctions.php'),(20814537,9374,'./includes/invfunctions.php'),(20814536,19466,'./includes/invfunctions.php'),(20778963,17651,'./!/application/controllers/ardailyclose.php'),(20778962,18474,'./!/application/controllers/ardailyclose.php'),(20778961,15991,'./!/application/controllers/ardailyclose.php'),(20778960,17650,'./!/application/controllers/ardailyclose.php'),(20778959,18473,'./!/application/controllers/ardailyclose.php'),(20778958,1499,'./!/application/controllers/ardailyclose.php'),(20779184,2225,'./!/application/controllers/arinvoice.php'),(20779183,8681,'./!/application/controllers/arinvoice.php'),(20779182,2208,'./!/application/controllers/arinvoice.php'),(20779181,18800,'./!/application/controllers/arinvoice.php'),(20779180,2182,'./!/application/controllers/arinvoice.php'),(20779179,15101,'./!/application/controllers/arinvoice.php'),(20779178,17890,'./!/application/controllers/arinvoice.php'),(20779177,2165,'./!/application/controllers/arinvoice.php'),(20779176,18323,'./!/application/controllers/arinvoice.php'),(20779292,7035,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779291,5144,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779290,18895,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779556,4169,'./!/application/controllers/arordership.php'),(20779642,4602,'./!/application/controllers/b2buser.php'),(20779643,981,'./!/application/controllers/b2buser.php'),(20779644,1013,'./!/application/controllers/b2buser.php'),(20779811,6085,'./!/application/controllers/billtrust.php'),(20780204,1973,'./!/application/controllers/customer.php'),(20780355,17783,'./!/application/controllers/employee.php'),(20780353,13680,'./!/application/controllers/employee.php'),(20780352,2324,'./!/application/controllers/employee.php'),(20780351,1935,'./!/application/controllers/employee.php'),(20780408,18903,'./!/application/controllers/fileitem.php'),(20780407,17254,'./!/application/controllers/fileitem.php'),(20780406,17253,'./!/application/controllers/fileitem.php'),(20780405,11868,'./!/application/controllers/fileitem.php'),(20780477,4023,'./!/application/controllers/glaccount.php'),(20781074,19470,'./!/application/controllers/invcotransfer.php'),(20781073,5120,'./!/application/controllers/invcotransfer.php'),(20781071,5119,'./!/application/controllers/invcotransfer.php'),(20781271,1647,'./!/application/controllers/invcountbatch.php'),(20781269,19538,'./!/application/controllers/invcountbatch.php'),(20781270,19539,'./!/application/controllers/invcountbatch.php'),(20781268,18909,'./!/application/controllers/invcountbatch.php'),(20781693,4592,'./!/application/controllers/item.php'),(20781692,2405,'./!/application/controllers/item.php'),(20781691,2404,'./!/application/controllers/item.php'),(20781690,18379,'./!/application/controllers/item.php'),(20781689,19320,'./!/application/controllers/item.php'),(20781688,19077,'./!/application/controllers/item.php'),(20781687,18382,'./!/application/controllers/item.php'),(20781686,18503,'./!/application/controllers/item.php'),(20781685,3436,'./!/application/controllers/item.php'),(20781684,16671,'./!/application/controllers/item.php'),(20781683,2165,'./!/application/controllers/item.php'),(20781682,19925,'./!/application/controllers/item.php'),(20781681,19924,'./!/application/controllers/item.php'),(20781680,19044,'./!/application/controllers/item.php'),(20781679,19076,'./!/application/controllers/item.php'),(20781678,19355,'./!/application/controllers/item.php'),(20781677,5525,'./!/application/controllers/item.php'),(20781676,6444,'./!/application/controllers/item.php'),(20781934,2494,'./!/application/controllers/itempricespecial.php'),(20781928,19936,'./!/application/controllers/itempricespecial.php'),(20781927,2404,'./!/application/controllers/itempricespecial.php'),(20781925,16474,'./!/application/controllers/itempricespecial.php'),(20782029,15913,'./!/application/controllers/job.php'),(20782028,16225,'./!/application/controllers/job.php'),(20782027,226,'./!/application/controllers/job.php'),(20782026,197,'./!/application/controllers/job.php'),(20782025,15156,'./!/application/controllers/job.php'),(20782024,15948,'./!/application/controllers/job.php'),(20782727,7453,'./!/application/controllers/main.php'),(20784132,2589,'./!/application/libraries/settings_form.php'),(20784131,15321,'./!/application/libraries/settings_form.php'),(20784130,2531,'./!/application/libraries/settings_form.php'),(20784129,2529,'./!/application/libraries/settings_form.php'),(20784128,3522,'./!/application/libraries/settings_form.php'),(20785700,18925,'./!/application/views/invcountbatch/edit.php'),(20785711,19563,'./!/application/views/invcountbatch/enterCounts.php'),(20785710,18246,'./!/application/views/invcountbatch/enterCounts.php'),(20785709,19562,'./!/application/views/invcountbatch/enterCounts.php'),(20785708,19561,'./!/application/views/invcountbatch/enterCounts.php'),(20785707,14832,'./!/application/views/invcountbatch/enterCounts.php'),(20785787,18918,'./!/application/views/invpo/email_receival_notice.php'),(20785786,18841,'./!/application/views/invpo/email_receival_notice.php'),(20785785,2589,'./!/application/views/invpo/email_receival_notice.php'),(20785784,2529,'./!/application/views/invpo/email_receival_notice.php'),(20785783,1713,'./!/application/views/invpo/email_receival_notice.php'),(20785782,1709,'./!/application/views/invpo/email_receival_notice.php'),(20786647,5081,'./!/application/views/task/historyrpt.php'),(20786086,4088,'./!/application/views/meta_menu/customer.php'),(20787311,19094,'./adminarcompanyupd.php'),(20787309,6165,'./adminarcompanyupd.php'),(20787308,15884,'./adminarcompanyupd.php'),(20787307,20050,'./adminarcompanyupd.php'),(20787306,14362,'./adminarcompanyupd.php'),(20787305,7704,'./adminarcompanyupd.php'),(20787304,7703,'./adminarcompanyupd.php'),(20787303,18603,'./adminarcompanyupd.php'),(20787302,18602,'./adminarcompanyupd.php'),(20787301,8028,'./adminarcompanyupd.php'),(20788201,3456,'./adminemail.php'),(20788200,3455,'./adminemail.php'),(20788199,18940,'./adminemail.php'),(20788198,3991,'./adminemail.php'),(20790448,59,'./apbillupd.php'),(20790447,18078,'./apbillupd.php'),(20790110,12781,'./apbilladd.php'),(20790109,85,'./apbilladd.php'),(20790108,59,'./apbilladd.php'),(20790063,6646,'./apbill_preapprove_edit.php'),(20790062,226,'./apbill_preapprove_edit.php'),(20788808,5203,'./admininvlocationupd.php'),(20789913,416,'./adminsystemsettings.php'),(20789912,12978,'./adminsystemsettings.php'),(20789911,14004,'./adminsystemsettings.php'),(20789910,18950,'./adminsystemsettings.php'),(20789909,18949,'./adminsystemsettings.php'),(20789908,13762,'./adminsystemsettings.php'),(20789907,13994,'./adminsystemsettings.php'),(20789906,9357,'./adminsystemsettings.php'),(20789905,18948,'./adminsystemsettings.php'),(20789904,14003,'./adminsystemsettings.php'),(20789903,16193,'./adminsystemsettings.php'),(20789902,18947,'./adminsystemsettings.php'),(20789901,12837,'./adminsystemsettings.php'),(20789900,19768,'./adminsystemsettings.php'),(20789899,9356,'./adminsystemsettings.php'),(20789898,59,'./adminsystemsettings.php'),(20792662,20,'./arinvoicepayreceipt.php'),(20801034,40,'./glpostadd.php'),(20802220,7662,'./importitems.php'),(20802649,3441,'./inventory_adjustments.php'),(20803011,309,'./invitemadd.php'),(20803010,20250,'./invitemadd.php'),(20803009,14001,'./invitemadd.php'),(20803149,17616,'./invitemadd1.php'),(20803148,143,'./invitemadd1.php'),(20803147,174,'./invitemadd1.php'),(20803850,197,'./invitemlstvendor.php'),(20803976,6031,'./invitemprices.php'),(20803975,315,'./invitemprices.php'),(20803974,8935,'./invitemprices.php'),(20803973,6314,'./invitemprices.php'),(20803972,18858,'./invitemprices.php'),(20803971,20132,'./invitemprices.php'),(20804026,59,'./invitemrecadd.php'),(20804178,59,'./invitemupd.php'),(20804375,163,'./invitemupd1.php'),(20804374,69,'./invitemupd1.php'),(20804684,9492,'./invpoadd.php'),(20804980,17199,'./invpotoap.php'),(20805143,9492,'./invpoupd.php'),(20805883,15341,'./nporder.php'),(20805882,17492,'./nporder.php'),(20811138,6143,'./voucherdetail.php'),(20813515,9065,'./includes/filesystemdb.php'),(20813514,9064,'./includes/filesystemdb.php'),(20813513,9063,'./includes/filesystemdb.php'),(20813512,9062,'./includes/filesystemdb.php'),(20813511,9061,'./includes/filesystemdb.php'),(20813510,17432,'./includes/filesystemdb.php'),(20814016,185,'./includes/genfunctions.php'),(20814015,14700,'./includes/genfunctions.php'),(20814014,55,'./includes/genfunctions.php'),(20814013,42,'./includes/genfunctions.php'),(20814274,4035,'./includes/glfunctions.php'),(20814440,4608,'./includes/header.php'),(20814439,15241,'./includes/header.php'),(20814535,19465,'./includes/invfunctions.php'),(20814534,13994,'./includes/invfunctions.php'),(20814533,4021,'./includes/invfunctions.php'),(20814814,1810,'./includes/invoicesoldshipformat.php'),(20778891,17238,'./!/application/controllers/archive_reports.php'),(20779175,6715,'./!/application/controllers/arinvoice.php'),(20779174,18729,'./!/application/controllers/arinvoice.php'),(20779173,14693,'./!/application/controllers/arinvoice.php'),(20779172,17889,'./!/application/controllers/arinvoice.php'),(20779171,5646,'./!/application/controllers/arinvoice.php'),(20779170,2044,'./!/application/controllers/arinvoice.php'),(20779169,18375,'./!/application/controllers/arinvoice.php'),(20779168,18986,'./!/application/controllers/arinvoice.php'),(20779167,17225,'./!/application/controllers/arinvoice.php'),(20779166,15682,'./!/application/controllers/arinvoice.php'),(20779165,14575,'./!/application/controllers/arinvoice.php'),(20779164,18494,'./!/application/controllers/arinvoice.php'),(20779163,20201,'./!/application/controllers/arinvoice.php'),(20779162,2070,'./!/application/controllers/arinvoice.php'),(20779161,1973,'./!/application/controllers/arinvoice.php'),(20779160,18678,'./!/application/controllers/arinvoice.php'),(20779158,7899,'./!/application/controllers/arinvoice.php'),(20779344,17224,'./!/application/controllers/arorder.php'),(20779343,634,'./!/application/controllers/arorder.php'),(20779342,9492,'./!/application/controllers/arorder.php'),(20779341,591,'./!/application/controllers/arorder.php'),(20779340,581,'./!/application/controllers/arorder.php'),(20779339,18048,'./!/application/controllers/arorder.php'),(20779338,6702,'./!/application/controllers/arorder.php'),(20779337,19885,'./!/application/controllers/arorder.php'),(20779478,697,'./!/application/controllers/arorderrentalpickup.php'),(20779477,15354,'./!/application/controllers/arorderrentalpickup.php'),(20779476,18982,'./!/application/controllers/arorderrentalpickup.php'),(20779475,19000,'./!/application/controllers/arorderrentalpickup.php'),(20779474,325,'./!/application/controllers/arorderrentalpickup.php'),(20779473,10861,'./!/application/controllers/arorderrentalpickup.php'),(20779472,16527,'./!/application/controllers/arorderrentalpickup.php'),(20779471,18727,'./!/application/controllers/arorderrentalpickup.php'),(20779555,1668,'./!/application/controllers/arordership.php'),(20779554,1578,'./!/application/controllers/arordership.php'),(20779553,17882,'./!/application/controllers/arordership.php'),(20779552,1014,'./!/application/controllers/arordership.php'),(20779551,18149,'./!/application/controllers/arordership.php'),(20779550,869,'./!/application/controllers/arordership.php'),(20779549,697,'./!/application/controllers/arordership.php'),(20779548,663,'./!/application/controllers/arordership.php'),(20779547,18047,'./!/application/controllers/arordership.php'),(20779546,434,'./!/application/controllers/arordership.php'),(20779545,18148,'./!/application/controllers/arordership.php'),(20779541,17914,'./!/application/controllers/arordership.php'),(20779542,10860,'./!/application/controllers/arordership.php'),(20779544,333,'./!/application/controllers/arordership.php'),(20779543,19005,'./!/application/controllers/arordership.php'),(20779810,19184,'./!/application/controllers/billtrust.php'),(20779809,2795,'./!/application/controllers/billtrust.php'),(20779808,19161,'./!/application/controllers/billtrust.php'),(20779807,15968,'./!/application/controllers/billtrust.php'),(20779806,12097,'./!/application/controllers/billtrust.php'),(20779805,19896,'./!/application/controllers/billtrust.php'),(20779804,2361,'./!/application/controllers/billtrust.php'),(20779803,16377,'./!/application/controllers/billtrust.php'),(20779802,2225,'./!/application/controllers/billtrust.php'),(20779801,6839,'./!/application/controllers/billtrust.php'),(20779800,18237,'./!/application/controllers/billtrust.php'),(20779799,1963,'./!/application/controllers/billtrust.php'),(20779798,1884,'./!/application/controllers/billtrust.php'),(20779797,19895,'./!/application/controllers/billtrust.php'),(20779796,16237,'./!/application/controllers/billtrust.php'),(20779794,5081,'./!/application/controllers/billtrust.php'),(20780864,15743,'./!/application/controllers/hubconstruction.php'),(20780863,3414,'./!/application/controllers/hubconstruction.php'),(20780862,3402,'./!/application/controllers/hubconstruction.php'),(20780861,19039,'./!/application/controllers/hubconstruction.php'),(20780860,5309,'./!/application/controllers/hubconstruction.php'),(20780859,7949,'./!/application/controllers/hubconstruction.php'),(20780858,3882,'./!/application/controllers/hubconstruction.php'),(20780857,8318,'./!/application/controllers/hubconstruction.php'),(20780856,3879,'./!/application/controllers/hubconstruction.php'),(20780855,14569,'./!/application/controllers/hubconstruction.php'),(20780854,3867,'./!/application/controllers/hubconstruction.php'),(20780853,15703,'./!/application/controllers/hubconstruction.php'),(20780852,7946,'./!/application/controllers/hubconstruction.php'),(20780851,13423,'./!/application/controllers/hubconstruction.php'),(20780850,3274,'./!/application/controllers/hubconstruction.php'),(20780849,3271,'./!/application/controllers/hubconstruction.php'),(20780848,3252,'./!/application/controllers/hubconstruction.php'),(20780847,19038,'./!/application/controllers/hubconstruction.php'),(20780846,7938,'./!/application/controllers/hubconstruction.php'),(20780845,3156,'./!/application/controllers/hubconstruction.php'),(20780844,3130,'./!/application/controllers/hubconstruction.php'),(20780843,19037,'./!/application/controllers/hubconstruction.php'),(20780842,18207,'./!/application/controllers/hubconstruction.php'),(20780841,16673,'./!/application/controllers/hubconstruction.php'),(20780840,16783,'./!/application/controllers/hubconstruction.php'),(20780839,11704,'./!/application/controllers/hubconstruction.php'),(20780838,19036,'./!/application/controllers/hubconstruction.php'),(20780837,19035,'./!/application/controllers/hubconstruction.php'),(20780836,16148,'./!/application/controllers/hubconstruction.php'),(20780835,4015,'./!/application/controllers/hubconstruction.php'),(20780834,5733,'./!/application/controllers/hubconstruction.php'),(20780833,14644,'./!/application/controllers/hubconstruction.php'),(20780832,9198,'./!/application/controllers/hubconstruction.php'),(20780831,9244,'./!/application/controllers/hubconstruction.php'),(20780830,12163,'./!/application/controllers/hubconstruction.php'),(20780829,3853,'./!/application/controllers/hubconstruction.php'),(20780828,3851,'./!/application/controllers/hubconstruction.php'),(20780827,16676,'./!/application/controllers/hubconstruction.php'),(20780826,12171,'./!/application/controllers/hubconstruction.php'),(20780825,3847,'./!/application/controllers/hubconstruction.php'),(20780824,2936,'./!/application/controllers/hubconstruction.php'),(20780823,7645,'./!/application/controllers/hubconstruction.php'),(20780822,16550,'./!/application/controllers/hubconstruction.php'),(20780821,2899,'./!/application/controllers/hubconstruction.php'),(20780820,19034,'./!/application/controllers/hubconstruction.php'),(20780819,4455,'./!/application/controllers/hubconstruction.php'),(20780818,2821,'./!/application/controllers/hubconstruction.php'),(20780817,2819,'./!/application/controllers/hubconstruction.php'),(20780816,8055,'./!/application/controllers/hubconstruction.php'),(20780815,19033,'./!/application/controllers/hubconstruction.php'),(20780814,2835,'./!/application/controllers/hubconstruction.php'),(20780813,12172,'./!/application/controllers/hubconstruction.php'),(20780812,19032,'./!/application/controllers/hubconstruction.php'),(20780811,7933,'./!/application/controllers/hubconstruction.php'),(20780810,18507,'./!/application/controllers/hubconstruction.php'),(20780809,19031,'./!/application/controllers/hubconstruction.php'),(20780808,7930,'./!/application/controllers/hubconstruction.php'),(20780807,3823,'./!/application/controllers/hubconstruction.php'),(20780806,3822,'./!/application/controllers/hubconstruction.php'),(20780805,3821,'./!/application/controllers/hubconstruction.php'),(20780804,3820,'./!/application/controllers/hubconstruction.php'),(20780803,12848,'./!/application/controllers/hubconstruction.php'),(20780802,5488,'./!/application/controllers/hubconstruction.php'),(20780801,2738,'./!/application/controllers/hubconstruction.php'),(20780800,8508,'./!/application/controllers/hubconstruction.php'),(20780799,2702,'./!/application/controllers/hubconstruction.php'),(20780798,2696,'./!/application/controllers/hubconstruction.php'),(20780797,3811,'./!/application/controllers/hubconstruction.php'),(20780796,12169,'./!/application/controllers/hubconstruction.php'),(20780795,2676,'./!/application/controllers/hubconstruction.php'),(20780794,2665,'./!/application/controllers/hubconstruction.php'),(20780793,2664,'./!/application/controllers/hubconstruction.php'),(20780792,7173,'./!/application/controllers/hubconstruction.php'),(20780791,10577,'./!/application/controllers/hubconstruction.php'),(20780790,4265,'./!/application/controllers/hubconstruction.php'),(20780789,5467,'./!/application/controllers/hubconstruction.php'),(20780788,3797,'./!/application/controllers/hubconstruction.php'),(20780787,16522,'./!/application/controllers/hubconstruction.php'),(20780786,18506,'./!/application/controllers/hubconstruction.php'),(20780785,16825,'./!/application/controllers/hubconstruction.php'),(20780784,18505,'./!/application/controllers/hubconstruction.php'),(20780783,18146,'./!/application/controllers/hubconstruction.php'),(20780782,16785,'./!/application/controllers/hubconstruction.php'),(20780781,18504,'./!/application/controllers/hubconstruction.php'),(20780780,7063,'./!/application/controllers/hubconstruction.php'),(20780779,2589,'./!/application/controllers/hubconstruction.php'),(20780778,13806,'./!/application/controllers/hubconstruction.php'),(20780777,2540,'./!/application/controllers/hubconstruction.php'),(20780776,2529,'./!/application/controllers/hubconstruction.php'),(20780775,5120,'./!/application/controllers/hubconstruction.php'),(20780774,2508,'./!/application/controllers/hubconstruction.php'),(20780773,9835,'./!/application/controllers/hubconstruction.php'),(20780772,12233,'./!/application/controllers/hubconstruction.php'),(20780771,2453,'./!/application/controllers/hubconstruction.php'),(20780770,6988,'./!/application/controllers/hubconstruction.php'),(20780769,15768,'./!/application/controllers/hubconstruction.php'),(20780768,2363,'./!/application/controllers/hubconstruction.php'),(20780767,3745,'./!/application/controllers/hubconstruction.php'),(20780766,15082,'./!/application/controllers/hubconstruction.php'),(20780765,9612,'./!/application/controllers/hubconstruction.php'),(20780764,5494,'./!/application/controllers/hubconstruction.php'),(20780763,3743,'./!/application/controllers/hubconstruction.php'),(20780762,18145,'./!/application/controllers/hubconstruction.php'),(20780761,3740,'./!/application/controllers/hubconstruction.php'),(20780760,7812,'./!/application/controllers/hubconstruction.php'),(20780759,7054,'./!/application/controllers/hubconstruction.php'),(20780758,7053,'./!/application/controllers/hubconstruction.php'),(20780757,7052,'./!/application/controllers/hubconstruction.php'),(20780756,15481,'./!/application/controllers/hubconstruction.php'),(20780755,2270,'./!/application/controllers/hubconstruction.php'),(20780754,3732,'./!/application/controllers/hubconstruction.php'),(20780753,7911,'./!/application/controllers/hubconstruction.php'),(20780752,2260,'./!/application/controllers/hubconstruction.php'),(20780751,15378,'./!/application/controllers/hubconstruction.php'),(20780750,3730,'./!/application/controllers/hubconstruction.php'),(20780749,2258,'./!/application/controllers/hubconstruction.php'),(20780748,4023,'./!/application/controllers/hubconstruction.php'),(20780747,16671,'./!/application/controllers/hubconstruction.php'),(20780746,4793,'./!/application/controllers/hubconstruction.php'),(20780745,2182,'./!/application/controllers/hubconstruction.php'),(20780744,6887,'./!/application/controllers/hubconstruction.php'),(20780743,3502,'./!/application/controllers/hubconstruction.php'),(20780742,4070,'./!/application/controllers/hubconstruction.php'),(20780741,6754,'./!/application/controllers/hubconstruction.php'),(20780740,15377,'./!/application/controllers/hubconstruction.php'),(20780739,4609,'./!/application/controllers/hubconstruction.php'),(20780945,541,'./!/application/controllers/invbinitem.php'),(20780944,416,'./!/application/controllers/invbinitem.php'),(20781072,18352,'./!/application/controllers/invcotransfer.php'),(20781070,19167,'./!/application/controllers/invcotransfer.php'),(20781069,19166,'./!/application/controllers/invcotransfer.php'),(20781068,2508,'./!/application/controllers/invcotransfer.php'),(20781067,3777,'./!/application/controllers/invcotransfer.php'),(20781066,16768,'./!/application/controllers/invcotransfer.php'),(20781065,17808,'./!/application/controllers/invcotransfer.php'),(20781064,2459,'./!/application/controllers/invcotransfer.php'),(20781063,18173,'./!/application/controllers/invcotransfer.php'),(20781062,19045,'./!/application/controllers/invcotransfer.php'),(20781061,19320,'./!/application/controllers/invcotransfer.php'),(20781060,16767,'./!/application/controllers/invcotransfer.php'),(20781059,18172,'./!/application/controllers/invcotransfer.php'),(20781058,2290,'./!/application/controllers/invcotransfer.php'),(20781057,4023,'./!/application/controllers/invcotransfer.php'),(20781154,4546,'./!/application/controllers/invcotransferdetail.php'),(20781153,19062,'./!/application/controllers/invcotransferdetail.php'),(20781152,19061,'./!/application/controllers/invcotransferdetail.php'),(20781151,1963,'./!/application/controllers/invcotransferdetail.php'),(20781150,1770,'./!/application/controllers/invcotransferdetail.php'),(20781149,1696,'./!/application/controllers/invcotransferdetail.php'),(20781148,19060,'./!/application/controllers/invcotransferdetail.php'),(20781147,18519,'./!/application/controllers/invcotransferdetail.php'),(20781146,16955,'./!/application/controllers/invcotransferdetail.php'),(20781145,19059,'./!/application/controllers/invcotransferdetail.php'),(20781144,19058,'./!/application/controllers/invcotransferdetail.php'),(20781143,15970,'./!/application/controllers/invcotransferdetail.php'),(20781142,869,'./!/application/controllers/invcotransferdetail.php'),(20781141,19057,'./!/application/controllers/invcotransferdetail.php'),(20781140,19056,'./!/application/controllers/invcotransferdetail.php'),(20781139,19909,'./!/application/controllers/invcotransferdetail.php'),(20781138,19055,'./!/application/controllers/invcotransferdetail.php'),(20781137,19054,'./!/application/controllers/invcotransferdetail.php'),(20781267,18342,'./!/application/controllers/invcountbatch.php'),(20781265,1640,'./!/application/controllers/invcountbatch.php'),(20781266,18188,'./!/application/controllers/invcountbatch.php'),(20781264,19609,'./!/application/controllers/invcountbatch.php'),(20781263,19608,'./!/application/controllers/invcountbatch.php'),(20781262,14611,'./!/application/controllers/invcountbatch.php'),(20781480,2182,'./!/application/controllers/invpo.php'),(20781675,7804,'./!/application/controllers/item.php'),(20781674,2137,'./!/application/controllers/item.php'),(20781673,2044,'./!/application/controllers/item.php'),(20781672,19354,'./!/application/controllers/item.php'),(20781671,19074,'./!/application/controllers/item.php'),(20781670,19073,'./!/application/controllers/item.php'),(20781669,4637,'./!/application/controllers/item.php'),(20781668,14575,'./!/application/controllers/item.php'),(20781667,2103,'./!/application/controllers/item.php'),(20781666,16674,'./!/application/controllers/item.php'),(20781665,16669,'./!/application/controllers/item.php'),(20781664,18058,'./!/application/controllers/item.php'),(20781663,1963,'./!/application/controllers/item.php'),(20781662,10946,'./!/application/controllers/item.php'),(20781661,5304,'./!/application/controllers/item.php'),(20781660,1913,'./!/application/controllers/item.php'),(20781659,15355,'./!/application/controllers/item.php'),(20781658,1888,'./!/application/controllers/item.php'),(20782726,6520,'./!/application/controllers/main.php'),(20784070,3470,'./!/application/libraries/import_task.php'),(20784068,2162,'./!/application/libraries/import_task.php'),(20784067,8290,'./!/application/libraries/import_task.php'),(20784066,2160,'./!/application/libraries/import_task.php'),(20784153,799,'./!/application/libraries/taskbar.php'),(20784154,2459,'./!/application/libraries/taskbar.php'),(20784337,2638,'./!/application/models/arordership_model.php'),(20784336,18376,'./!/application/models/arordership_model.php'),(20784335,19001,'./!/application/models/arordership_model.php'),(20784416,2827,'./!/application/models/item_model.php'),(20784415,2589,'./!/application/models/item_model.php'),(20784414,2508,'./!/application/models/item_model.php'),(20784867,3090,'./!/application/views/arinvoice/generateOverdueRentalInvoices_Select.php'),(20784866,2998,'./!/application/views/arinvoice/generateOverdueRentalInvoices_Select.php'),(20784865,5863,'./!/application/views/arinvoice/generateOverdueRentalInvoices_Select.php'),(20784864,2977,'./!/application/views/arinvoice/generateOverdueRentalInvoices_Select.php'),(20784863,19212,'./!/application/views/arinvoice/generateOverdueRentalInvoices_Select.php'),(20784887,10578,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784886,19083,'./!/application/views/arinvoice/issueCreditDiag.php'),(20784923,18577,'./!/application/views/arinvoice/taxAdjustment.form.php'),(20784997,19084,'./!/application/views/arorder/dataTable.rentals.js.php'),(20784996,2702,'./!/application/views/arorder/dataTable.rentals.js.php'),(20784995,416,'./!/application/views/arorder/dataTable.rentals.js.php'),(20785010,2165,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785007,10861,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785008,869,'./!/application/views/arorderrentalpickup/create_select_details.php'),(20785774,3090,'./!/application/views/invpo/apbill_table.php'),(20785773,2948,'./!/application/views/invpo/apbill_table.php'),(20785772,19085,'./!/application/views/invpo/apbill_table.php'),(20785771,2151,'./!/application/views/invpo/apbill_table.php'),(20785770,1678,'./!/application/views/invpo/apbill_table.php'),(20785859,19086,'./!/application/views/itemlocation/editable_lastpocost.php'),(20785858,2702,'./!/application/views/itemlocation/editable_lastpocost.php'),(20785857,416,'./!/application/views/itemlocation/editable_lastpocost.php'),(20785862,19643,'./!/application/views/itemlocation/editable_wacost.php'),(20785861,2702,'./!/application/views/itemlocation/editable_wacost.php'),(20785860,416,'./!/application/views/itemlocation/editable_wacost.php'),(20785867,2459,'./!/application/views/job/batch_send_prelim_request_select.php'),(20785866,15241,'./!/application/views/job/batch_send_prelim_request_select.php'),(20785865,14092,'./!/application/views/job/batch_send_prelim_request_select.php'),(20785864,416,'./!/application/views/job/batch_send_prelim_request_select.php'),(20785863,315,'./!/application/views/job/batch_send_prelim_request_select.php'),(20787300,18440,'./adminarcompanyupd.php'),(20787299,19093,'./adminarcompanyupd.php'),(20787298,15788,'./adminarcompanyupd.php'),(20787297,20049,'./adminarcompanyupd.php'),(20787296,20048,'./adminarcompanyupd.php'),(20787295,18439,'./adminarcompanyupd.php'),(20787294,18255,'./adminarcompanyupd.php'),(20787293,9516,'./adminarcompanyupd.php'),(20787292,18821,'./adminarcompanyupd.php'),(20787291,19472,'./adminarcompanyupd.php'),(20787290,20047,'./adminarcompanyupd.php'),(20787289,18933,'./adminarcompanyupd.php'),(20787288,19092,'./adminarcompanyupd.php'),(20787287,18601,'./adminarcompanyupd.php'),(20787283,13996,'./adminarcompanyupd.php'),(20787284,18254,'./adminarcompanyupd.php'),(20787285,13997,'./adminarcompanyupd.php'),(20789238,14001,'./adminprglacct.php'),(20792322,6703,'./arinvoiceaddcogs.php'),(20792321,6702,'./arinvoiceaddcogs.php'),(20792320,315,'./arinvoiceaddcogs.php'),(20792546,20234,'./arinvoicepay.php'),(20792545,20087,'./arinvoicepay.php'),(20792940,325,'./arinvoicereppay.php'),(20793329,13787,'./arinvoicesum.php'),(20793328,13785,'./arinvoicesum.php'),(20793327,13784,'./arinvoicesum.php'),(20793326,13786,'./arinvoicesum.php'),(20793325,20094,'./arinvoicesum.php'),(20793324,18322,'./arinvoicesum.php'),(20793323,5477,'./arinvoicesum.php'),(20793322,4481,'./arinvoicesum.php'),(20793321,697,'./arinvoicesum.php'),(20793320,19105,'./arinvoicesum.php'),(20793319,665,'./arinvoicesum.php'),(20793318,9492,'./arinvoicesum.php'),(20793317,19772,'./arinvoicesum.php'),(20793316,616,'./arinvoicesum.php'),(20793315,541,'./arinvoicesum.php'),(20793314,11368,'./arinvoicesum.php'),(20793313,8316,'./arinvoicesum.php'),(20793312,8303,'./arinvoicesum.php'),(20793311,6477,'./arinvoicesum.php'),(20793310,5469,'./arinvoicesum.php'),(20793439,5203,'./arinvoiceupd.php'),(20793438,15398,'./arinvoiceupd.php'),(20793437,226,'./arinvoiceupd.php'),(20793436,87,'./arinvoiceupd.php'),(20793435,59,'./arinvoiceupd.php'),(20795454,9492,'./arordshipviewfpdf.php'),(20796521,315,'./autofunctions.php'),(20797161,19123,'./dbupdate.php'),(20797160,15664,'./dbupdate.php'),(20797159,18090,'./dbupdate.php'),(20797158,3520,'./dbupdate.php'),(20801326,8230,'./glrepincome.php'),(20801382,8231,'./glrepincome_12month.php'),(20802556,542,'./invcotransfer.php'),(20802555,333,'./invcotransfer.php'),(20802554,315,'./invcotransfer.php'),(20802553,6314,'./invcotransfer.php'),(20802552,10860,'./invcotransfer.php'),(20802551,16527,'./invcotransfer.php'),(20802550,5203,'./invcotransfer.php'),(20802549,20122,'./invcotransfer.php'),(20802548,8125,'./invcotransfer.php'),(20802757,8935,'./inventory_detail_pop.php'),(20802756,6445,'./inventory_detail_pop.php'),(20802755,11444,'./inventory_detail_pop.php'),(20803591,19134,'./invitemlstreorder.php'),(20803590,14902,'./invitemlstreorder.php'),(20803589,315,'./invitemlstreorder.php'),(20803588,16679,'./invitemlstreorder.php'),(20803587,6314,'./invitemlstreorder.php'),(20803586,5571,'./invitemlstreorder.php'),(20803585,20237,'./invitemlstreorder.php'),(20803584,5570,'./invitemlstreorder.php'),(20803583,13305,'./invitemlstreorder.php'),(20803582,19133,'./invitemlstreorder.php'),(20803802,14253,'./invitemlstval.php'),(20803801,665,'./invitemlstval.php'),(20803800,616,'./invitemlstval.php'),(20803799,19129,'./invitemlstval.php'),(20803798,19144,'./invitemlstval.php'),(20803797,467,'./invitemlstval.php'),(20803796,451,'./invitemlstval.php'),(20803795,17611,'./invitemlstval.php'),(20803794,315,'./invitemlstval.php'),(20803793,19143,'./invitemlstval.php'),(20803792,197,'./invitemlstval.php'),(20803791,4658,'./invitemlstval.php'),(20803970,20131,'./invitemprices.php'),(20803969,197,'./invitemprices.php'),(20803968,57,'./invitemprices.php'),(20804373,178,'./invitemupd1.php'),(20804372,4658,'./invitemupd1.php'),(20804371,53,'./invitemupd1.php'),(20804446,52,'./invitemvendupd.php'),(20805142,616,'./invpoupd.php'),(20805881,8676,'./nporder.php'),(20805880,17424,'./nporder.php'),(20805879,17423,'./nporder.php'),(20805878,12083,'./nporder.php'),(20805688,315,'./lookupcustomer_alt.php'),(20805687,185,'./lookupcustomer_alt.php'),(20805877,19781,'./nporder.php'),(20805876,8125,'./nporder.php'),(20805875,13307,'./nporder.php'),(20806289,17423,'./nporderpayment.php'),(20806288,17406,'./nporderpayment.php'),(20806287,9455,'./nporderpayment.php'),(20806286,17122,'./nporderpayment.php'),(20806285,14525,'./nporderpayment.php'),(20810790,7844,'./taskuser.php'),(20811579,18762,'./includes/arfunctions.php'),(20811578,197,'./includes/arfunctions.php'),(20811577,14001,'./includes/arfunctions.php'),(20811576,157,'./includes/arfunctions.php'),(20811575,152,'./includes/arfunctions.php'),(20811574,155,'./includes/arfunctions.php'),(20811573,129,'./includes/arfunctions.php'),(20811572,92,'./includes/arfunctions.php'),(20812086,3090,'./includes/arordconfirmfpdf.functions.php'),(20812085,3072,'./includes/arordconfirmfpdf.functions.php'),(20812084,4680,'./includes/arordconfirmfpdf.functions.php'),(20812083,16847,'./includes/arordconfirmfpdf.functions.php'),(20812082,2361,'./includes/arordconfirmfpdf.functions.php'),(20812081,6249,'./includes/arordconfirmfpdf.functions.php'),(20812080,2222,'./includes/arordconfirmfpdf.functions.php'),(20812079,2182,'./includes/arordconfirmfpdf.functions.php'),(20812078,4070,'./includes/arordconfirmfpdf.functions.php'),(20812077,6311,'./includes/arordconfirmfpdf.functions.php'),(20812076,20164,'./includes/arordconfirmfpdf.functions.php'),(20812075,19461,'./includes/arordconfirmfpdf.functions.php'),(20812074,19460,'./includes/arordconfirmfpdf.functions.php'),(20812073,6234,'./includes/arordconfirmfpdf.functions.php'),(20813835,1970,'./includes/functions.php'),(20813834,1963,'./includes/functions.php'),(20814012,40,'./includes/genfunctions.php'),(20778890,3544,'./!/application/controllers/archive_reports.php'),(20778889,3541,'./!/application/controllers/archive_reports.php'),(20778888,325,'./!/application/controllers/archive_reports.php'),(20778887,15750,'./!/application/controllers/archive_reports.php'),(20778886,19172,'./!/application/controllers/archive_reports.php'),(20778885,4938,'./!/application/controllers/archive_reports.php'),(20778884,3537,'./!/application/controllers/archive_reports.php'),(20778883,15156,'./!/application/controllers/archive_reports.php'),(20778882,47,'./!/application/controllers/archive_reports.php'),(20779159,1963,'./!/application/controllers/arinvoice.php'),(20779157,18892,'./!/application/controllers/arinvoice.php'),(20779156,13766,'./!/application/controllers/arinvoice.php'),(20779155,1933,'./!/application/controllers/arinvoice.php'),(20779336,222,'./!/application/controllers/arorder.php'),(20779795,1792,'./!/application/controllers/billtrust.php'),(20779793,19017,'./!/application/controllers/billtrust.php'),(20779792,18166,'./!/application/controllers/billtrust.php'),(20779791,1672,'./!/application/controllers/billtrust.php'),(20780202,8548,'./!/application/controllers/customer.php'),(20780738,5677,'./!/application/controllers/hubconstruction.php'),(20780909,1143,'./!/application/controllers/invbin.php'),(20780908,941,'./!/application/controllers/invbin.php'),(20780907,869,'./!/application/controllers/invbin.php'),(20780906,799,'./!/application/controllers/invbin.php'),(20780905,19187,'./!/application/controllers/invbin.php'),(20780904,16463,'./!/application/controllers/invbin.php'),(20780903,548,'./!/application/controllers/invbin.php'),(20780902,541,'./!/application/controllers/invbin.php'),(20780901,18515,'./!/application/controllers/invbin.php'),(20780900,19525,'./!/application/controllers/invbin.php'),(20780899,17261,'./!/application/controllers/invbin.php'),(20780898,17260,'./!/application/controllers/invbin.php'),(20780943,18795,'./!/application/controllers/invbinitem.php'),(20780942,17261,'./!/application/controllers/invbinitem.php'),(20780941,19527,'./!/application/controllers/invbinitem.php'),(20780940,14395,'./!/application/controllers/invbinitem.php'),(20780939,16278,'./!/application/controllers/invbinitem.php'),(20781055,2165,'./!/application/controllers/invcotransfer.php'),(20781553,315,'./!/application/controllers/invzone.php'),(20781552,18522,'./!/application/controllers/invzone.php'),(20781551,17259,'./!/application/controllers/invzone.php'),(20782023,8797,'./!/application/controllers/job.php'),(20782022,12889,'./!/application/controllers/job.php'),(20782021,185,'./!/application/controllers/job.php'),(20782020,14008,'./!/application/controllers/job.php'),(20782019,4713,'./!/application/controllers/job.php'),(20782724,3672,'./!/application/controllers/main.php'),(20784255,644,'./!/application/models/arinvoice_model.php'),(20784254,5145,'./!/application/models/arinvoice_model.php'),(20784278,7581,'./!/application/models/arinvoicedetail_model.php'),(20784282,19207,'./!/application/models/arinvoicedetailref_model.php'),(20784286,19208,'./!/application/models/arinvoicepaymentdetail_model.php'),(20784288,19209,'./!/application/models/arorder_deposit_model.php'),(20784305,4850,'./!/application/models/arorder_model.php'),(20784313,18048,'./!/application/models/arorderdetail_model.php'),(20784401,2361,'./!/application/models/invpo_model.php'),(20784400,8072,'./!/application/models/invpo_model.php'),(20784399,1285,'./!/application/models/invpo_model.php'),(20784398,1283,'./!/application/models/invpo_model.php'),(20784397,8936,'./!/application/models/invpo_model.php'),(20784859,3172,'./!/application/views/arinvoice/arinvoice.php'),(20784858,3090,'./!/application/views/arinvoice/arinvoice.php'),(20784857,2998,'./!/application/views/arinvoice/arinvoice.php'),(20784856,5863,'./!/application/views/arinvoice/arinvoice.php'),(20784855,3913,'./!/application/views/arinvoice/arinvoice.php'),(20784854,2819,'./!/application/views/arinvoice/arinvoice.php'),(20784853,2833,'./!/application/views/arinvoice/arinvoice.php'),(20784852,2700,'./!/application/views/arinvoice/arinvoice.php'),(20784851,2529,'./!/application/views/arinvoice/arinvoice.php'),(20784860,19211,'./!/application/views/arinvoice/email_delete_notice.php'),(20784915,1781,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20784885,19215,'./!/application/views/arinvoice/invoiceDeleteDiag.php'),(20784884,19214,'./!/application/views/arinvoice/invoiceDeleteDiag.php'),(20784883,19213,'./!/application/views/arinvoice/invoiceDeleteDiag.php'),(20784944,19216,'./!/application/views/arinvoicepaymentdetail/email_void_notice.php'),(20784943,13908,'./!/application/views/arinvoicepaymentdetail/email_void_notice.php'),(20784942,2260,'./!/application/views/arinvoicepaymentdetail/email_void_notice.php'),(20784941,6318,'./!/application/views/arinvoicepaymentdetail/email_void_notice.php'),(20784940,737,'./!/application/views/arinvoicepaymentdetail/email_void_notice.php'),(20784939,479,'./!/application/views/arinvoicepaymentdetail/email_void_notice.php'),(20784938,226,'./!/application/views/arinvoicepaymentdetail/email_void_notice.php'),(20784983,19215,'./!/application/views/arorder/arorderDeleteDiag.php'),(20784982,19214,'./!/application/views/arorder/arorderDeleteDiag.php'),(20784981,4761,'./!/application/views/arorder/arorderDeleteDiag.php'),(20784980,416,'./!/application/views/arorder/arorderDeleteDiag.php'),(20784987,19215,'./!/application/views/arorder/arserviceorderDeleteDiag.php'),(20784986,19214,'./!/application/views/arorder/arserviceorderDeleteDiag.php'),(20784985,4761,'./!/application/views/arorder/arserviceorderDeleteDiag.php'),(20784984,416,'./!/application/views/arorder/arserviceorderDeleteDiag.php'),(20785006,13908,'./!/application/views/arorder_deposit/email_void_notice.php'),(20785005,2260,'./!/application/views/arorder_deposit/email_void_notice.php'),(20785004,6318,'./!/application/views/arorder_deposit/email_void_notice.php'),(20785003,19217,'./!/application/views/arorder_deposit/email_void_notice.php'),(20785002,737,'./!/application/views/arorder_deposit/email_void_notice.php'),(20785001,479,'./!/application/views/arorder_deposit/email_void_notice.php'),(20785000,226,'./!/application/views/arorder_deposit/email_void_notice.php'),(20785075,19161,'./!/application/views/billtrust/export.php'),(20785074,11761,'./!/application/views/billtrust/export.php'),(20785073,19896,'./!/application/views/billtrust/export.php'),(20785072,20034,'./!/application/views/billtrust/export.php'),(20785071,9789,'./!/application/views/billtrust/export.php'),(20785070,19298,'./!/application/views/billtrust/export.php'),(20785558,16438,'./!/application/views/generic/simple_table.php'),(20785599,19218,'./!/application/views/invbin/pdflabel.php'),(20785804,19219,'./!/application/views/invzone/pdflabel.php'),(20786078,6839,'./!/application/views/meta_menu/customer.php'),(20786077,10711,'./!/application/views/meta_menu/customer.php'),(20786075,2165,'./!/application/views/meta_menu/customer.php'),(20786261,13484,'./!/application/views/priceoverriderequest/edit.php'),(20786260,1788,'./!/application/views/priceoverriderequest/edit.php'),(20786259,17043,'./!/application/views/priceoverriderequest/edit.php'),(20786258,17042,'./!/application/views/priceoverriderequest/edit.php'),(20786257,19222,'./!/application/views/priceoverriderequest/edit.php'),(20786256,4646,'./!/application/views/priceoverriderequest/edit.php'),(20786255,19221,'./!/application/views/priceoverriderequest/edit.php'),(20787286,18438,'./adminarcompanyupd.php'),(20787080,6564,'./adminar_rmasetup.php'),(20787079,19225,'./adminar_rmasetup.php'),(20787078,87,'./adminar_rmasetup.php'),(20787077,59,'./adminar_rmasetup.php'),(20787282,11773,'./adminarcompanyupd.php'),(20787281,15283,'./adminarcompanyupd.php'),(20787280,12691,'./adminarcompanyupd.php'),(20787279,17238,'./adminarcompanyupd.php'),(20787278,3544,'./adminarcompanyupd.php'),(20787277,6586,'./adminarcompanyupd.php'),(20787276,13994,'./adminarcompanyupd.php'),(20787275,19841,'./adminarcompanyupd.php'),(20787274,17195,'./adminarcompanyupd.php'),(20787273,20046,'./adminarcompanyupd.php'),(20787272,20045,'./adminarcompanyupd.php'),(20787271,325,'./adminarcompanyupd.php'),(20787270,19229,'./adminarcompanyupd.php'),(20787269,7035,'./adminarcompanyupd.php'),(20787268,9469,'./adminarcompanyupd.php'),(20787267,17455,'./adminarcompanyupd.php'),(20787265,17454,'./adminarcompanyupd.php'),(20790005,5570,'./apbill_preapprove.php'),(20791253,7529,'./arbankdepositadd.php'),(20791252,315,'./arbankdepositadd.php'),(20791251,7115,'./arbankdepositadd.php'),(20791250,226,'./arbankdepositadd.php'),(20791249,16153,'./arbankdepositadd.php'),(20791248,16152,'./arbankdepositadd.php'),(20791247,16151,'./arbankdepositadd.php'),(20791246,16150,'./arbankdepositadd.php'),(20791245,16149,'./arbankdepositadd.php'),(20791244,5900,'./arbankdepositadd.php'),(20792409,6709,'./arinvoicecalcint.php'),(20792408,14545,'./arinvoicecalcint.php'),(20792407,932,'./arinvoicecalcint.php'),(20792406,697,'./arinvoicecalcint.php'),(20792405,17224,'./arinvoicecalcint.php'),(20792404,474,'./arinvoicecalcint.php'),(20792403,19578,'./arinvoicecalcint.php'),(20792402,3550,'./arinvoicecalcint.php'),(20792401,14546,'./arinvoicecalcint.php'),(20792400,325,'./arinvoicecalcint.php'),(20792399,315,'./arinvoicecalcint.php'),(20792398,6669,'./arinvoicecalcint.php'),(20792762,11865,'./arinvoicepayvoid.php'),(20793213,479,'./arinvoicereturnsdetail.php'),(20793212,19308,'./arinvoicereturnsdetail.php'),(20793211,325,'./arinvoicereturnsdetail.php'),(20793263,14042,'./arinvoicestate.php'),(20793295,1373,'./arinvoicestateemail.php'),(20793294,14036,'./arinvoicestateemail.php'),(20793293,1047,'./arinvoicestateemail.php'),(20793292,981,'./arinvoicestateemail.php'),(20793291,15938,'./arinvoicestateemail.php'),(20793290,697,'./arinvoicestateemail.php'),(20793289,19264,'./arinvoicestateemail.php'),(20793434,7679,'./arinvoiceupd.php'),(20793594,479,'./arinvoiceview.php'),(20793593,445,'./arinvoiceview.php'),(20793592,416,'./arinvoiceview.php'),(20793591,325,'./arinvoiceview.php'),(20794021,737,'./arordconfirmfpdf.php'),(20794020,542,'./arordconfirmfpdf.php'),(20794019,6310,'./arordconfirmfpdf.php'),(20794018,20103,'./arordconfirmfpdf.php'),(20794058,218,'./arorder2invoice.php'),(20794057,13607,'./arorder2invoice.php'),(20795453,5459,'./arordshipviewfpdf.php'),(20795452,542,'./arordshipviewfpdf.php'),(20795451,540,'./arordshipviewfpdf.php'),(20795450,18634,'./arordshipviewfpdf.php'),(20795449,5074,'./arordshipviewfpdf.php'),(20795448,406,'./arordshipviewfpdf.php'),(20795447,5591,'./arordshipviewfpdf.php'),(20795501,14091,'./arpayplan_post.php'),(20795759,6065,'./arrmaorderreceive.php'),(20795758,6806,'./arrmaorderreceive.php'),(20795757,18048,'./arrmaorderreceive.php'),(20795756,6565,'./arrmaorderreceive.php'),(20795755,315,'./arrmaorderreceive.php'),(20795754,5145,'./arrmaorderreceive.php'),(20795753,6805,'./arrmaorderreceive.php'),(20795846,5089,'./arrmashipview.php'),(20795845,315,'./arrmashipview.php'),(20795844,6793,'./arrmashipview.php'),(20796118,17792,'./arserviceordupd.php'),(20796117,5670,'./arserviceordupd.php'),(20796116,59,'./arserviceordupd.php'),(20796115,8094,'./arserviceordupd.php'),(20796465,3544,'./arstateviewfpdf.php'),(20796464,6250,'./arstateviewfpdf.php'),(20800320,19271,'./glacctadd.php'),(20800319,416,'./glacctadd.php'),(20800318,19270,'./glacctadd.php'),(20800317,59,'./glacctadd.php'),(20800316,32,'./glacctadd.php'),(20800315,20,'./glacctadd.php'),(20802547,287,'./invcotransfer.php'),(20802546,13499,'./invcotransfer.php'),(20802545,59,'./invcotransfer.php'),(20803008,81,'./invitemadd.php'),(20803146,59,'./invitemadd1.php'),(20804064,197,'./invitemreclist.php'),(20804866,18305,'./invporecv.php'),(20804865,8185,'./invporecv.php'),(20804864,14277,'./invporecv.php'),(20804863,315,'./invporecv.php'),(20804862,12140,'./invporecv.php'),(20805141,15011,'./invpoupd.php'),(20805496,185,'./jobupd.php'),(20805837,4346,'./myuser.php'),(20805874,16954,'./nporder.php'),(20805873,13224,'./nporder.php'),(20805872,19449,'./nporder.php'),(20805871,19686,'./nporder.php'),(20805870,10616,'./nporder.php'),(20805869,226,'./nporder.php'),(20806456,19447,'./npordersave.php'),(20811571,8797,'./includes/arfunctions.php'),(20811570,185,'./includes/arfunctions.php'),(20814813,1758,'./includes/invoicesoldshipformat.php'),(20778881,15752,'./!/application/controllers/archive_reports.php'),(20779154,5304,'./!/application/controllers/arinvoice.php'),(20779153,1913,'./!/application/controllers/arinvoice.php'),(20779152,15620,'./!/application/controllers/arinvoice.php'),(20779151,5707,'./!/application/controllers/arinvoice.php'),(20779150,18985,'./!/application/controllers/arinvoice.php'),(20779149,15940,'./!/application/controllers/arinvoice.php'),(20779148,1792,'./!/application/controllers/arinvoice.php'),(20779147,1788,'./!/application/controllers/arinvoice.php'),(20779146,1781,'./!/application/controllers/arinvoice.php'),(20779790,19016,'./!/application/controllers/billtrust.php'),(20780201,17543,'./!/application/controllers/customer.php'),(20780897,315,'./!/application/controllers/invbin.php'),(20781056,2182,'./!/application/controllers/invcotransfer.php'),(20781054,19044,'./!/application/controllers/invcotransfer.php'),(20781053,16520,'./!/application/controllers/invcotransfer.php'),(20781052,16519,'./!/application/controllers/invcotransfer.php'),(20781261,1578,'./!/application/controllers/invcountbatch.php'),(20781260,14606,'./!/application/controllers/invcountbatch.php'),(20781259,19808,'./!/application/controllers/invcountbatch.php'),(20781258,18341,'./!/application/controllers/invcountbatch.php'),(20781257,19360,'./!/application/controllers/invcountbatch.php'),(20781256,18733,'./!/application/controllers/invcountbatch.php'),(20782018,55,'./!/application/controllers/job.php'),(20782725,14619,'./!/application/controllers/main.php'),(20784370,16526,'./!/application/models/invcotransfer_model.php'),(20784369,14085,'./!/application/models/invcotransfer_model.php'),(20785069,18509,'./!/application/views/billtrust/export.php'),(20785554,2162,'./!/application/views/generic/select.php'),(20785613,19300,'./!/application/views/invcotransfer/assignByZone_form.php'),(20785612,18924,'./!/application/views/invcotransfer/assignByZone_form.php'),(20785611,2044,'./!/application/views/invcotransfer/assignByZone_form.php'),(20785610,16311,'./!/application/views/invcotransfer/assignByZone_form.php'),(20785609,1647,'./!/application/views/invcotransfer/assignByZone_form.php'),(20785619,18199,'./!/application/views/invcotransfer/assignByZone_form_binsAjax.php'),(20785618,19302,'./!/application/views/invcotransfer/assignByZone_form_binsAjax.php'),(20785617,14262,'./!/application/views/invcotransfer/assignByZone_form_binsAjax.php'),(20785650,16673,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785649,19304,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785648,16393,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785647,2702,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20786076,10709,'./!/application/views/meta_menu/customer.php'),(20792155,20084,'./arinvoice_writeoff.php'),(20792154,8198,'./arinvoice_writeoff.php'),(20792153,226,'./arinvoice_writeoff.php'),(20792397,276,'./arinvoicecalcint.php'),(20792396,273,'./arinvoicecalcint.php'),(20793210,315,'./arinvoicereturnsdetail.php'),(20793262,15286,'./arinvoicestate.php'),(20793261,6242,'./arinvoicestate.php'),(20793309,325,'./arinvoicesum.php'),(20794017,18082,'./arordconfirmfpdf.php'),(20805495,14008,'./jobupd.php'),(20805868,17617,'./nporder.php'),(20805867,19475,'./nporder.php'),(20778803,3432,'./!/application/controllers/addedit_control.php'),(20778802,3274,'./!/application/controllers/addedit_control.php'),(20778801,2936,'./!/application/controllers/addedit_control.php'),(20778800,2819,'./!/application/controllers/addedit_control.php'),(20778799,8508,'./!/application/controllers/addedit_control.php'),(20778798,4265,'./!/application/controllers/addedit_control.php'),(20778797,2325,'./!/application/controllers/addedit_control.php'),(20778796,2324,'./!/application/controllers/addedit_control.php'),(20778795,19318,'./!/application/controllers/addedit_control.php'),(20778794,2224,'./!/application/controllers/addedit_control.php'),(20778793,1758,'./!/application/controllers/addedit_control.php'),(20778792,1696,'./!/application/controllers/addedit_control.php'),(20778791,1429,'./!/application/controllers/addedit_control.php'),(20778790,6378,'./!/application/controllers/addedit_control.php'),(20778789,5697,'./!/application/controllers/addedit_control.php'),(20778788,981,'./!/application/controllers/addedit_control.php'),(20778787,697,'./!/application/controllers/addedit_control.php'),(20778786,15349,'./!/application/controllers/addedit_control.php'),(20778785,659,'./!/application/controllers/addedit_control.php'),(20778784,581,'./!/application/controllers/addedit_control.php'),(20778783,524,'./!/application/controllers/addedit_control.php'),(20778782,19317,'./!/application/controllers/addedit_control.php'),(20778781,306,'./!/application/controllers/addedit_control.php'),(20778780,185,'./!/application/controllers/addedit_control.php'),(20778850,16090,'./!/application/controllers/apbillpayment.php'),(20778849,16089,'./!/application/controllers/apbillpayment.php'),(20778848,16201,'./!/application/controllers/apbillpayment.php'),(20778847,8010,'./!/application/controllers/apbillpayment.php'),(20778846,737,'./!/application/controllers/apbillpayment.php'),(20778845,673,'./!/application/controllers/apbillpayment.php'),(20778844,14203,'./!/application/controllers/apbillpayment.php'),(20778843,541,'./!/application/controllers/apbillpayment.php'),(20778842,491,'./!/application/controllers/apbillpayment.php'),(20778841,16088,'./!/application/controllers/apbillpayment.php'),(20778840,504,'./!/application/controllers/apbillpayment.php'),(20778839,479,'./!/application/controllers/apbillpayment.php'),(20778838,447,'./!/application/controllers/apbillpayment.php'),(20778837,445,'./!/application/controllers/apbillpayment.php'),(20778836,226,'./!/application/controllers/apbillpayment.php'),(20778835,6050,'./!/application/controllers/apbillpayment.php'),(20778872,982,'./!/application/controllers/appointments.php'),(20778871,4481,'./!/application/controllers/appointments.php'),(20778870,315,'./!/application/controllers/appointments.php'),(20778869,17634,'./!/application/controllers/appointments.php'),(20778868,17633,'./!/application/controllers/appointments.php'),(20778957,17647,'./!/application/controllers/ardailyclose.php'),(20778956,18472,'./!/application/controllers/ardailyclose.php'),(20778955,18471,'./!/application/controllers/ardailyclose.php'),(20778954,1047,'./!/application/controllers/ardailyclose.php'),(20778953,18270,'./!/application/controllers/ardailyclose.php'),(20778952,9726,'./!/application/controllers/ardailyclose.php'),(20778951,10253,'./!/application/controllers/ardailyclose.php'),(20778950,776,'./!/application/controllers/ardailyclose.php'),(20778949,737,'./!/application/controllers/ardailyclose.php'),(20778948,17646,'./!/application/controllers/ardailyclose.php'),(20778947,17645,'./!/application/controllers/ardailyclose.php'),(20778946,18470,'./!/application/controllers/ardailyclose.php'),(20778945,18469,'./!/application/controllers/ardailyclose.php'),(20778944,17665,'./!/application/controllers/ardailyclose.php'),(20778943,670,'./!/application/controllers/ardailyclose.php'),(20778942,7861,'./!/application/controllers/ardailyclose.php'),(20778941,18468,'./!/application/controllers/ardailyclose.php'),(20778940,17644,'./!/application/controllers/ardailyclose.php'),(20778939,9492,'./!/application/controllers/ardailyclose.php'),(20778938,504,'./!/application/controllers/ardailyclose.php'),(20778937,18885,'./!/application/controllers/ardailyclose.php'),(20778936,3457,'./!/application/controllers/ardailyclose.php'),(20778935,18467,'./!/application/controllers/ardailyclose.php'),(20778934,17642,'./!/application/controllers/ardailyclose.php'),(20778933,325,'./!/application/controllers/ardailyclose.php'),(20778932,17641,'./!/application/controllers/ardailyclose.php'),(20778931,17640,'./!/application/controllers/ardailyclose.php'),(20778930,17639,'./!/application/controllers/ardailyclose.php'),(20778929,20,'./!/application/controllers/ardailyclose.php'),(20778928,16278,'./!/application/controllers/ardailyclose.php'),(20779145,1770,'./!/application/controllers/arinvoice.php'),(20779144,18984,'./!/application/controllers/arinvoice.php'),(20779143,20200,'./!/application/controllers/arinvoice.php'),(20779142,19884,'./!/application/controllers/arinvoice.php'),(20779141,15056,'./!/application/controllers/arinvoice.php'),(20779140,7491,'./!/application/controllers/arinvoice.php'),(20779139,15763,'./!/application/controllers/arinvoice.php'),(20779138,17888,'./!/application/controllers/arinvoice.php'),(20779137,15797,'./!/application/controllers/arinvoice.php'),(20779136,19181,'./!/application/controllers/arinvoice.php'),(20779135,9981,'./!/application/controllers/arinvoice.php'),(20779134,1743,'./!/application/controllers/arinvoice.php'),(20779133,17887,'./!/application/controllers/arinvoice.php'),(20779132,9622,'./!/application/controllers/arinvoice.php'),(20779131,5081,'./!/application/controllers/arinvoice.php'),(20779130,1709,'./!/application/controllers/arinvoice.php'),(20779129,18493,'./!/application/controllers/arinvoice.php'),(20779128,18492,'./!/application/controllers/arinvoice.php'),(20779127,18491,'./!/application/controllers/arinvoice.php'),(20779126,1692,'./!/application/controllers/arinvoice.php'),(20779125,1685,'./!/application/controllers/arinvoice.php'),(20779124,20199,'./!/application/controllers/arinvoice.php'),(20779123,20198,'./!/application/controllers/arinvoice.php'),(20779122,17886,'./!/application/controllers/arinvoice.php'),(20779121,17885,'./!/application/controllers/arinvoice.php'),(20779120,20197,'./!/application/controllers/arinvoice.php'),(20779119,18142,'./!/application/controllers/arinvoice.php'),(20779118,1678,'./!/application/controllers/arinvoice.php'),(20779117,5652,'./!/application/controllers/arinvoice.php'),(20779116,1677,'./!/application/controllers/arinvoice.php'),(20779115,20196,'./!/application/controllers/arinvoice.php'),(20779114,20195,'./!/application/controllers/arinvoice.php'),(20779113,18799,'./!/application/controllers/arinvoice.php'),(20779112,9248,'./!/application/controllers/arinvoice.php'),(20779111,1672,'./!/application/controllers/arinvoice.php'),(20779110,17884,'./!/application/controllers/arinvoice.php'),(20779109,18489,'./!/application/controllers/arinvoice.php'),(20779108,19287,'./!/application/controllers/arinvoice.php'),(20779107,20194,'./!/application/controllers/arinvoice.php'),(20779106,5315,'./!/application/controllers/arinvoice.php'),(20779105,4940,'./!/application/controllers/arinvoice.php'),(20779104,1668,'./!/application/controllers/arinvoice.php'),(20779103,1647,'./!/application/controllers/arinvoice.php'),(20779102,6315,'./!/application/controllers/arinvoice.php'),(20779101,17883,'./!/application/controllers/arinvoice.php'),(20779100,18891,'./!/application/controllers/arinvoice.php'),(20779099,14773,'./!/application/controllers/arinvoice.php'),(20779098,16306,'./!/application/controllers/arinvoice.php'),(20779097,16305,'./!/application/controllers/arinvoice.php'),(20779096,1578,'./!/application/controllers/arinvoice.php'),(20779095,19180,'./!/application/controllers/arinvoice.php'),(20779094,1559,'./!/application/controllers/arinvoice.php'),(20779093,18890,'./!/application/controllers/arinvoice.php'),(20779092,15796,'./!/application/controllers/arinvoice.php'),(20779091,1539,'./!/application/controllers/arinvoice.php'),(20779090,18488,'./!/application/controllers/arinvoice.php'),(20779089,20193,'./!/application/controllers/arinvoice.php'),(20779088,20192,'./!/application/controllers/arinvoice.php'),(20779087,20191,'./!/application/controllers/arinvoice.php'),(20779086,20190,'./!/application/controllers/arinvoice.php'),(20779085,20189,'./!/application/controllers/arinvoice.php'),(20779084,20188,'./!/application/controllers/arinvoice.php'),(20779083,20187,'./!/application/controllers/arinvoice.php'),(20779082,17593,'./!/application/controllers/arinvoice.php'),(20779081,18054,'./!/application/controllers/arinvoice.php'),(20779080,1517,'./!/application/controllers/arinvoice.php'),(20779079,17882,'./!/application/controllers/arinvoice.php'),(20779078,1467,'./!/application/controllers/arinvoice.php'),(20779077,18487,'./!/application/controllers/arinvoice.php'),(20779076,19286,'./!/application/controllers/arinvoice.php'),(20779075,18983,'./!/application/controllers/arinvoice.php'),(20779074,18834,'./!/application/controllers/arinvoice.php'),(20779073,18798,'./!/application/controllers/arinvoice.php'),(20779072,15939,'./!/application/controllers/arinvoice.php'),(20779071,1373,'./!/application/controllers/arinvoice.php'),(20779070,19285,'./!/application/controllers/arinvoice.php'),(20779069,18341,'./!/application/controllers/arinvoice.php'),(20779068,19179,'./!/application/controllers/arinvoice.php'),(20779067,1047,'./!/application/controllers/arinvoice.php'),(20779066,17881,'./!/application/controllers/arinvoice.php'),(20779065,1036,'./!/application/controllers/arinvoice.php'),(20779064,1014,'./!/application/controllers/arinvoice.php'),(20779063,3465,'./!/application/controllers/arinvoice.php'),(20779062,9224,'./!/application/controllers/arinvoice.php'),(20779061,981,'./!/application/controllers/arinvoice.php'),(20779060,941,'./!/application/controllers/arinvoice.php'),(20779059,932,'./!/application/controllers/arinvoice.php'),(20779058,16304,'./!/application/controllers/arinvoice.php'),(20779057,19690,'./!/application/controllers/arinvoice.php'),(20779056,886,'./!/application/controllers/arinvoice.php'),(20779055,869,'./!/application/controllers/arinvoice.php'),(20779054,10253,'./!/application/controllers/arinvoice.php'),(20779053,5205,'./!/application/controllers/arinvoice.php'),(20779052,15795,'./!/application/controllers/arinvoice.php'),(20779051,4973,'./!/application/controllers/arinvoice.php'),(20779050,4363,'./!/application/controllers/arinvoice.php'),(20779049,737,'./!/application/controllers/arinvoice.php'),(20779048,18797,'./!/application/controllers/arinvoice.php'),(20779047,18486,'./!/application/controllers/arinvoice.php'),(20779046,17665,'./!/application/controllers/arinvoice.php'),(20779045,5299,'./!/application/controllers/arinvoice.php'),(20779044,18053,'./!/application/controllers/arinvoice.php'),(20779043,18322,'./!/application/controllers/arinvoice.php'),(20779042,16303,'./!/application/controllers/arinvoice.php'),(20779041,716,'./!/application/controllers/arinvoice.php'),(20779040,4481,'./!/application/controllers/arinvoice.php'),(20779039,18052,'./!/application/controllers/arinvoice.php'),(20779038,6228,'./!/application/controllers/arinvoice.php'),(20779037,19485,'./!/application/controllers/arinvoice.php'),(20779036,697,'./!/application/controllers/arinvoice.php'),(20779035,683,'./!/application/controllers/arinvoice.php'),(20779034,18485,'./!/application/controllers/arinvoice.php'),(20779033,18484,'./!/application/controllers/arinvoice.php'),(20779032,18141,'./!/application/controllers/arinvoice.php'),(20779031,670,'./!/application/controllers/arinvoice.php'),(20779030,18714,'./!/application/controllers/arinvoice.php'),(20779029,668,'./!/application/controllers/arinvoice.php'),(20779028,18482,'./!/application/controllers/arinvoice.php'),(20779027,18481,'./!/application/controllers/arinvoice.php'),(20779026,18051,'./!/application/controllers/arinvoice.php'),(20779025,17880,'./!/application/controllers/arinvoice.php'),(20779021,18982,'./!/application/controllers/arinvoice.php'),(20779022,18725,'./!/application/controllers/arinvoice.php'),(20779023,9492,'./!/application/controllers/arinvoice.php'),(20779289,226,'./!/application/controllers/arinvoicepaymentdetail.php'),(20779689,5839,'./!/application/controllers/bank_deposit.php'),(20779688,737,'./!/application/controllers/bank_deposit.php'),(20779687,9492,'./!/application/controllers/bank_deposit.php'),(20779686,541,'./!/application/controllers/bank_deposit.php'),(20779685,7120,'./!/application/controllers/bank_deposit.php'),(20779684,17683,'./!/application/controllers/bank_deposit.php'),(20779683,17682,'./!/application/controllers/bank_deposit.php'),(20779682,17681,'./!/application/controllers/bank_deposit.php'),(20779681,11842,'./!/application/controllers/bank_deposit.php'),(20779680,7529,'./!/application/controllers/bank_deposit.php'),(20779679,5402,'./!/application/controllers/bank_deposit.php'),(20779678,226,'./!/application/controllers/bank_deposit.php'),(20779789,4940,'./!/application/controllers/billtrust.php'),(20779788,1668,'./!/application/controllers/billtrust.php'),(20779787,18165,'./!/application/controllers/billtrust.php'),(20779786,18164,'./!/application/controllers/billtrust.php'),(20779785,1373,'./!/application/controllers/billtrust.php'),(20779784,19015,'./!/application/controllers/billtrust.php'),(20779783,18509,'./!/application/controllers/billtrust.php'),(20779782,18163,'./!/application/controllers/billtrust.php'),(20779781,18162,'./!/application/controllers/billtrust.php'),(20779780,9943,'./!/application/controllers/billtrust.php'),(20779779,1014,'./!/application/controllers/billtrust.php'),(20779778,19014,'./!/application/controllers/billtrust.php'),(20779777,16123,'./!/application/controllers/billtrust.php'),(20779776,13837,'./!/application/controllers/billtrust.php'),(20779775,18160,'./!/application/controllers/billtrust.php'),(20779774,981,'./!/application/controllers/billtrust.php'),(20779773,8863,'./!/application/controllers/billtrust.php'),(20779772,19013,'./!/application/controllers/billtrust.php'),(20779771,13033,'./!/application/controllers/billtrust.php'),(20779770,869,'./!/application/controllers/billtrust.php'),(20779769,737,'./!/application/controllers/billtrust.php'),(20779768,19183,'./!/application/controllers/billtrust.php'),(20779767,697,'./!/application/controllers/billtrust.php'),(20779766,683,'./!/application/controllers/billtrust.php'),(20779765,20177,'./!/application/controllers/billtrust.php'),(20779764,19012,'./!/application/controllers/billtrust.php'),(20779763,19011,'./!/application/controllers/billtrust.php'),(20779762,17238,'./!/application/controllers/billtrust.php'),(20779897,1036,'./!/application/controllers/ccterminallog.php'),(20779896,4602,'./!/application/controllers/ccterminallog.php'),(20779895,17077,'./!/application/controllers/ccterminallog.php'),(20779894,573,'./!/application/controllers/ccterminallog.php'),(20779941,1668,'./!/application/controllers/check.php'),(20779940,16424,'./!/application/controllers/check.php'),(20779939,1019,'./!/application/controllers/check.php'),(20779938,5376,'./!/application/controllers/check.php'),(20779937,16423,'./!/application/controllers/check.php'),(20779936,932,'./!/application/controllers/check.php'),(20779935,673,'./!/application/controllers/check.php'),(20779934,16422,'./!/application/controllers/check.php'),(20779933,491,'./!/application/controllers/check.php'),(20779932,16421,'./!/application/controllers/check.php'),(20779931,16420,'./!/application/controllers/check.php'),(20779930,484,'./!/application/controllers/check.php'),(20779929,6192,'./!/application/controllers/check.php'),(20779928,513,'./!/application/controllers/check.php'),(20779927,16088,'./!/application/controllers/check.php'),(20779926,504,'./!/application/controllers/check.php'),(20779925,479,'./!/application/controllers/check.php'),(20779924,446,'./!/application/controllers/check.php'),(20779923,445,'./!/application/controllers/check.php'),(20779922,337,'./!/application/controllers/check.php'),(20779921,5374,'./!/application/controllers/check.php'),(20779920,16752,'./!/application/controllers/check.php'),(20779919,315,'./!/application/controllers/check.php'),(20779918,226,'./!/application/controllers/check.php'),(20779917,6050,'./!/application/controllers/check.php'),(20779916,20,'./!/application/controllers/check.php'),(20780011,16213,'./!/application/controllers/cron.php'),(20780200,1935,'./!/application/controllers/customer.php'),(20780199,1933,'./!/application/controllers/customer.php'),(20780198,10946,'./!/application/controllers/customer.php'),(20780197,8544,'./!/application/controllers/customer.php'),(20780196,1884,'./!/application/controllers/customer.php'),(20780195,15940,'./!/application/controllers/customer.php'),(20780194,15866,'./!/application/controllers/customer.php'),(20780193,1810,'./!/application/controllers/customer.php'),(20780192,1792,'./!/application/controllers/customer.php'),(20780191,1788,'./!/application/controllers/customer.php'),(20780190,1770,'./!/application/controllers/customer.php'),(20780189,1758,'./!/application/controllers/customer.php'),(20780188,15763,'./!/application/controllers/customer.php'),(20780187,17542,'./!/application/controllers/customer.php'),(20780186,8739,'./!/application/controllers/customer.php'),(20780185,1713,'./!/application/controllers/customer.php'),(20780184,1709,'./!/application/controllers/customer.php'),(20780183,1703,'./!/application/controllers/customer.php'),(20780182,11446,'./!/application/controllers/customer.php'),(20780181,17541,'./!/application/controllers/customer.php'),(20780180,1685,'./!/application/controllers/customer.php'),(20780179,1678,'./!/application/controllers/customer.php'),(20780178,14706,'./!/application/controllers/customer.php'),(20780177,1672,'./!/application/controllers/customer.php'),(20780176,1668,'./!/application/controllers/customer.php'),(20780175,1625,'./!/application/controllers/customer.php'),(20780174,19329,'./!/application/controllers/customer.php'),(20780173,14611,'./!/application/controllers/customer.php'),(20780172,7255,'./!/application/controllers/customer.php'),(20780171,16756,'./!/application/controllers/customer.php'),(20780170,1578,'./!/application/controllers/customer.php'),(20780169,1559,'./!/application/controllers/customer.php'),(20780168,17540,'./!/application/controllers/customer.php'),(20780167,1539,'./!/application/controllers/customer.php'),(20780166,16927,'./!/application/controllers/customer.php'),(20780165,18715,'./!/application/controllers/customer.php'),(20780164,1467,'./!/application/controllers/customer.php'),(20780163,14604,'./!/application/controllers/customer.php'),(20780162,1429,'./!/application/controllers/customer.php'),(20780161,1381,'./!/application/controllers/customer.php'),(20780160,15939,'./!/application/controllers/customer.php'),(20780159,1373,'./!/application/controllers/customer.php'),(20780158,17241,'./!/application/controllers/customer.php'),(20780157,15845,'./!/application/controllers/customer.php'),(20780156,14043,'./!/application/controllers/customer.php'),(20780155,14966,'./!/application/controllers/customer.php'),(20780154,19523,'./!/application/controllers/customer.php'),(20780153,1047,'./!/application/controllers/customer.php'),(20780152,17539,'./!/application/controllers/customer.php'),(20780151,1036,'./!/application/controllers/customer.php'),(20780150,1014,'./!/application/controllers/customer.php'),(20780149,17538,'./!/application/controllers/customer.php'),(20780148,17537,'./!/application/controllers/customer.php'),(20780147,17536,'./!/application/controllers/customer.php'),(20780146,17535,'./!/application/controllers/customer.php'),(20780145,9224,'./!/application/controllers/customer.php'),(20780144,15865,'./!/application/controllers/customer.php'),(20780143,981,'./!/application/controllers/customer.php'),(20780142,932,'./!/application/controllers/customer.php'),(20780141,927,'./!/application/controllers/customer.php'),(20780140,869,'./!/application/controllers/customer.php'),(20780139,19328,'./!/application/controllers/customer.php'),(20780138,6140,'./!/application/controllers/customer.php'),(20780137,5816,'./!/application/controllers/customer.php'),(20780136,19327,'./!/application/controllers/customer.php'),(20780135,776,'./!/application/controllers/customer.php'),(20780134,4973,'./!/application/controllers/customer.php'),(20780133,15761,'./!/application/controllers/customer.php'),(20780132,15760,'./!/application/controllers/customer.php'),(20780131,737,'./!/application/controllers/customer.php'),(20780130,16508,'./!/application/controllers/customer.php'),(20780129,17576,'./!/application/controllers/customer.php'),(20780128,17534,'./!/application/controllers/customer.php'),(20780127,19326,'./!/application/controllers/customer.php'),(20780126,15938,'./!/application/controllers/customer.php'),(20780125,15759,'./!/application/controllers/customer.php'),(20780124,716,'./!/application/controllers/customer.php'),(20780123,16755,'./!/application/controllers/customer.php'),(20780122,7141,'./!/application/controllers/customer.php'),(20780121,15758,'./!/application/controllers/customer.php'),(20780120,6228,'./!/application/controllers/customer.php'),(20780119,3458,'./!/application/controllers/customer.php'),(20780118,697,'./!/application/controllers/customer.php'),(20780117,17533,'./!/application/controllers/customer.php'),(20780116,683,'./!/application/controllers/customer.php'),(20780115,9341,'./!/application/controllers/customer.php'),(20780114,19718,'./!/application/controllers/customer.php'),(20780113,675,'./!/application/controllers/customer.php'),(20780112,15757,'./!/application/controllers/customer.php'),(20780111,15756,'./!/application/controllers/customer.php'),(20780110,19325,'./!/application/controllers/customer.php'),(20780109,670,'./!/application/controllers/customer.php'),(20780108,659,'./!/application/controllers/customer.php'),(20780107,616,'./!/application/controllers/customer.php'),(20780106,17532,'./!/application/controllers/customer.php'),(20780105,17531,'./!/application/controllers/customer.php'),(20780104,581,'./!/application/controllers/customer.php'),(20780103,17530,'./!/application/controllers/customer.php'),(20780102,17529,'./!/application/controllers/customer.php'),(20780101,543,'./!/application/controllers/customer.php'),(20780100,541,'./!/application/controllers/customer.php'),(20780099,524,'./!/application/controllers/customer.php'),(20780098,472,'./!/application/controllers/customer.php'),(20780097,19324,'./!/application/controllers/customer.php'),(20780096,15250,'./!/application/controllers/customer.php'),(20780095,19594,'./!/application/controllers/customer.php'),(20780094,451,'./!/application/controllers/customer.php'),(20780093,16507,'./!/application/controllers/customer.php'),(20780092,17528,'./!/application/controllers/customer.php'),(20780091,8316,'./!/application/controllers/customer.php'),(20780090,416,'./!/application/controllers/customer.php'),(20780089,19323,'./!/application/controllers/customer.php'),(20780088,16457,'./!/application/controllers/customer.php'),(20780087,7979,'./!/application/controllers/customer.php'),(20780086,17527,'./!/application/controllers/customer.php'),(20780085,3544,'./!/application/controllers/customer.php'),(20780084,15597,'./!/application/controllers/customer.php'),(20780083,7246,'./!/application/controllers/customer.php'),(20780082,19322,'./!/application/controllers/customer.php'),(20780081,325,'./!/application/controllers/customer.php'),(20780080,315,'./!/application/controllers/customer.php'),(20780079,17526,'./!/application/controllers/customer.php'),(20780078,17525,'./!/application/controllers/customer.php'),(20780077,6717,'./!/application/controllers/customer.php'),(20780076,11331,'./!/application/controllers/customer.php'),(20780075,15922,'./!/application/controllers/customer.php'),(20780074,306,'./!/application/controllers/customer.php'),(20780073,6250,'./!/application/controllers/customer.php'),(20780072,287,'./!/application/controllers/customer.php'),(20780071,17524,'./!/application/controllers/customer.php'),(20780070,226,'./!/application/controllers/customer.php'),(20780069,5015,'./!/application/controllers/customer.php'),(20780068,197,'./!/application/controllers/customer.php'),(20780067,7243,'./!/application/controllers/customer.php'),(20780066,17523,'./!/application/controllers/customer.php'),(20780065,17522,'./!/application/controllers/customer.php'),(20780064,8797,'./!/application/controllers/customer.php'),(20780063,12889,'./!/application/controllers/customer.php'),(20780062,185,'./!/application/controllers/customer.php'),(20780061,15897,'./!/application/controllers/customer.php'),(20780060,30,'./!/application/controllers/customer.php'),(20780059,15755,'./!/application/controllers/customer.php'),(20780058,15752,'./!/application/controllers/customer.php'),(20780324,2208,'./!/application/controllers/dashboard.php'),(20780334,1963,'./!/application/controllers/ebay.php'),(20780333,17243,'./!/application/controllers/ebay.php'),(20780332,17242,'./!/application/controllers/ebay.php'),(20780331,17437,'./!/application/controllers/ebay.php'),(20780350,14611,'./!/application/controllers/employee.php'),(20780349,1598,'./!/application/controllers/employee.php'),(20780348,5510,'./!/application/controllers/employee.php'),(20780347,18900,'./!/application/controllers/employee.php'),(20780346,3467,'./!/application/controllers/employee.php'),(20780345,989,'./!/application/controllers/employee.php'),(20780344,981,'./!/application/controllers/employee.php'),(20780343,524,'./!/application/controllers/employee.php'),(20780342,315,'./!/application/controllers/employee.php'),(20780341,197,'./!/application/controllers/employee.php'),(20780340,15722,'./!/application/controllers/employee.php'),(20780339,55,'./!/application/controllers/employee.php'),(20780372,3252,'./!/application/controllers/eventlog.php'),(20780371,3434,'./!/application/controllers/eventlog.php'),(20780370,8275,'./!/application/controllers/eventlog.php'),(20780369,1911,'./!/application/controllers/eventlog.php'),(20780368,19341,'./!/application/controllers/eventlog.php'),(20780367,19340,'./!/application/controllers/eventlog.php'),(20780366,19339,'./!/application/controllers/eventlog.php'),(20780365,1014,'./!/application/controllers/eventlog.php'),(20780364,737,'./!/application/controllers/eventlog.php'),(20780363,47,'./!/application/controllers/eventlog.php'),(20780390,17249,'./!/application/controllers/filecategory.php'),(20780404,6166,'./!/application/controllers/fileitem.php'),(20780403,18902,'./!/application/controllers/fileitem.php'),(20780402,8936,'./!/application/controllers/fileitem.php'),(20780401,799,'./!/application/controllers/fileitem.php'),(20780400,737,'./!/application/controllers/fileitem.php'),(20780399,17438,'./!/application/controllers/fileitem.php'),(20780398,6228,'./!/application/controllers/fileitem.php'),(20780397,591,'./!/application/controllers/fileitem.php'),(20780396,451,'./!/application/controllers/fileitem.php'),(20780395,17251,'./!/application/controllers/fileitem.php'),(20780394,17190,'./!/application/controllers/fileitem.php'),(20780393,17250,'./!/application/controllers/fileitem.php'),(20780392,16278,'./!/application/controllers/fileitem.php'),(20780424,16509,'./!/application/controllers/freightburden.php'),(20780469,15991,'./!/application/controllers/glaccount.php'),(20780468,15959,'./!/application/controllers/glaccount.php'),(20780467,1499,'./!/application/controllers/glaccount.php'),(20780466,5407,'./!/application/controllers/glaccount.php'),(20780465,869,'./!/application/controllers/glaccount.php'),(20780464,9492,'./!/application/controllers/glaccount.php'),(20780463,619,'./!/application/controllers/glaccount.php'),(20780462,16308,'./!/application/controllers/glaccount.php'),(20780461,16307,'./!/application/controllers/glaccount.php'),(20780460,18905,'./!/application/controllers/glaccount.php'),(20780459,16428,'./!/application/controllers/glaccount.php'),(20780458,325,'./!/application/controllers/glaccount.php'),(20780457,315,'./!/application/controllers/glaccount.php'),(20780456,32,'./!/application/controllers/glaccount.php'),(20780455,16427,'./!/application/controllers/glaccount.php'),(20780454,27,'./!/application/controllers/glaccount.php'),(20780494,9039,'./!/application/controllers/glbudgets.php'),(20780493,9038,'./!/application/controllers/glbudgets.php'),(20780492,9037,'./!/application/controllers/glbudgets.php'),(20780491,9036,'./!/application/controllers/glbudgets.php'),(20780490,9035,'./!/application/controllers/glbudgets.php'),(20780489,15991,'./!/application/controllers/glbudgets.php'),(20780488,9492,'./!/application/controllers/glbudgets.php'),(20780487,4105,'./!/application/controllers/glbudgets.php'),(20780486,20,'./!/application/controllers/glbudgets.php'),(20780868,5205,'./!/application/controllers/interestchargeoption.php'),(20780867,315,'./!/application/controllers/interestchargeoption.php'),(20780866,59,'./!/application/controllers/interestchargeoption.php'),(20780883,1143,'./!/application/controllers/invadjustmenttype.php'),(20780882,941,'./!/application/controllers/invadjustmenttype.php'),(20780881,869,'./!/application/controllers/invadjustmenttype.php'),(20780880,799,'./!/application/controllers/invadjustmenttype.php'),(20780879,16469,'./!/application/controllers/invadjustmenttype.php'),(20780878,548,'./!/application/controllers/invadjustmenttype.php'),(20780877,315,'./!/application/controllers/invadjustmenttype.php'),(20780876,20,'./!/application/controllers/invadjustmenttype.php'),(20780896,5203,'./!/application/controllers/invbin.php'),(20780895,17259,'./!/application/controllers/invbin.php'),(20780894,19186,'./!/application/controllers/invbin.php'),(20780893,19185,'./!/application/controllers/invbin.php'),(20781051,16766,'./!/application/controllers/invcotransfer.php'),(20781050,3503,'./!/application/controllers/invcotransfer.php'),(20781049,18171,'./!/application/controllers/invcotransfer.php'),(20781048,2044,'./!/application/controllers/invcotransfer.php'),(20781047,1997,'./!/application/controllers/invcotransfer.php'),(20781046,16765,'./!/application/controllers/invcotransfer.php'),(20781045,2094,'./!/application/controllers/invcotransfer.php'),(20781044,18582,'./!/application/controllers/invcotransfer.php'),(20781043,18494,'./!/application/controllers/invcotransfer.php'),(20781042,2103,'./!/application/controllers/invcotransfer.php'),(20781041,16764,'./!/application/controllers/invcotransfer.php'),(20781040,1963,'./!/application/controllers/invcotransfer.php'),(20781039,1935,'./!/application/controllers/invcotransfer.php'),(20781038,1933,'./!/application/controllers/invcotransfer.php'),(20781037,18351,'./!/application/controllers/invcotransfer.php'),(20781036,19165,'./!/application/controllers/invcotransfer.php'),(20781035,19290,'./!/application/controllers/invcotransfer.php'),(20781034,19902,'./!/application/controllers/invcotransfer.php'),(20781033,1788,'./!/application/controllers/invcotransfer.php'),(20781032,16212,'./!/application/controllers/invcotransfer.php'),(20781031,1770,'./!/application/controllers/invcotransfer.php'),(20781030,1750,'./!/application/controllers/invcotransfer.php'),(20781029,16763,'./!/application/controllers/invcotransfer.php'),(20781028,1726,'./!/application/controllers/invcotransfer.php'),(20781027,1709,'./!/application/controllers/invcotransfer.php'),(20781026,1696,'./!/application/controllers/invcotransfer.php'),(20781025,18350,'./!/application/controllers/invcotransfer.php'),(20781024,1666,'./!/application/controllers/invcotransfer.php'),(20781023,17268,'./!/application/controllers/invcotransfer.php'),(20781022,17267,'./!/application/controllers/invcotransfer.php'),(20781021,16518,'./!/application/controllers/invcotransfer.php'),(20781020,16517,'./!/application/controllers/invcotransfer.php'),(20781019,13507,'./!/application/controllers/invcotransfer.php'),(20781018,19901,'./!/application/controllers/invcotransfer.php'),(20781017,17266,'./!/application/controllers/invcotransfer.php'),(20781016,1578,'./!/application/controllers/invcotransfer.php'),(20781015,16762,'./!/application/controllers/invcotransfer.php'),(20781014,19900,'./!/application/controllers/invcotransfer.php'),(20781013,18519,'./!/application/controllers/invcotransfer.php'),(20781012,8163,'./!/application/controllers/invcotransfer.php'),(20781011,1467,'./!/application/controllers/invcotransfer.php'),(20781010,18170,'./!/application/controllers/invcotransfer.php'),(20781009,16089,'./!/application/controllers/invcotransfer.php'),(20781008,17713,'./!/application/controllers/invcotransfer.php'),(20781007,1143,'./!/application/controllers/invcotransfer.php'),(20781006,16761,'./!/application/controllers/invcotransfer.php'),(20781005,16760,'./!/application/controllers/invcotransfer.php'),(20781004,1036,'./!/application/controllers/invcotransfer.php'),(20781003,16759,'./!/application/controllers/invcotransfer.php'),(20781002,16758,'./!/application/controllers/invcotransfer.php'),(20781001,932,'./!/application/controllers/invcotransfer.php'),(20781000,8863,'./!/application/controllers/invcotransfer.php'),(20780999,869,'./!/application/controllers/invcotransfer.php'),(20780998,19534,'./!/application/controllers/invcotransfer.php'),(20780997,19164,'./!/application/controllers/invcotransfer.php'),(20780996,17446,'./!/application/controllers/invcotransfer.php'),(20780995,19163,'./!/application/controllers/invcotransfer.php'),(20780994,799,'./!/application/controllers/invcotransfer.php'),(20780993,16516,'./!/application/controllers/invcotransfer.php'),(20780992,5101,'./!/application/controllers/invcotransfer.php'),(20780991,16515,'./!/application/controllers/invcotransfer.php'),(20780990,5403,'./!/application/controllers/invcotransfer.php'),(20780989,18051,'./!/application/controllers/invcotransfer.php'),(20780988,18169,'./!/application/controllers/invcotransfer.php'),(20780987,572,'./!/application/controllers/invcotransfer.php'),(20780986,567,'./!/application/controllers/invcotransfer.php'),(20780985,566,'./!/application/controllers/invcotransfer.php'),(20780984,541,'./!/application/controllers/invcotransfer.php'),(20780983,18049,'./!/application/controllers/invcotransfer.php'),(20780982,8185,'./!/application/controllers/invcotransfer.php'),(20780981,17260,'./!/application/controllers/invcotransfer.php'),(20781171,932,'./!/application/controllers/invcotransfershiprecv.php'),(20781170,869,'./!/application/controllers/invcotransfershiprecv.php'),(20781169,697,'./!/application/controllers/invcotransfershiprecv.php'),(20781168,16526,'./!/application/controllers/invcotransfershiprecv.php'),(20781255,1047,'./!/application/controllers/invcountbatch.php'),(20781254,19688,'./!/application/controllers/invcountbatch.php'),(20781253,1036,'./!/application/controllers/invcountbatch.php'),(20781252,19294,'./!/application/controllers/invcountbatch.php'),(20781251,19606,'./!/application/controllers/invcountbatch.php'),(20781250,19293,'./!/application/controllers/invcountbatch.php'),(20781249,18187,'./!/application/controllers/invcountbatch.php'),(20781248,1014,'./!/application/controllers/invcountbatch.php'),(20781247,19605,'./!/application/controllers/invcountbatch.php'),(20781246,19604,'./!/application/controllers/invcountbatch.php'),(20781245,19537,'./!/application/controllers/invcountbatch.php'),(20781244,5407,'./!/application/controllers/invcountbatch.php'),(20781243,8863,'./!/application/controllers/invcountbatch.php'),(20781242,4602,'./!/application/controllers/invcountbatch.php'),(20781241,869,'./!/application/controllers/invcountbatch.php'),(20781240,17075,'./!/application/controllers/invcountbatch.php'),(20781239,17024,'./!/application/controllers/invcountbatch.php'),(20781238,737,'./!/application/controllers/invcountbatch.php'),(20781237,18186,'./!/application/controllers/invcountbatch.php'),(20781236,19536,'./!/application/controllers/invcountbatch.php'),(20781235,19347,'./!/application/controllers/invcountbatch.php'),(20781234,683,'./!/application/controllers/invcountbatch.php'),(20781233,16529,'./!/application/controllers/invcountbatch.php'),(20781232,16542,'./!/application/controllers/invcountbatch.php'),(20781231,19487,'./!/application/controllers/invcountbatch.php'),(20781230,19603,'./!/application/controllers/invcountbatch.php'),(20781229,19292,'./!/application/controllers/invcountbatch.php'),(20781228,19535,'./!/application/controllers/invcountbatch.php'),(20781227,16528,'./!/application/controllers/invcountbatch.php'),(20781226,658,'./!/application/controllers/invcountbatch.php'),(20781225,18807,'./!/application/controllers/invcountbatch.php'),(20781224,18340,'./!/application/controllers/invcountbatch.php'),(20781223,616,'./!/application/controllers/invcountbatch.php'),(20781222,607,'./!/application/controllers/invcountbatch.php'),(20781221,19602,'./!/application/controllers/invcountbatch.php'),(20781220,596,'./!/application/controllers/invcountbatch.php'),(20781219,591,'./!/application/controllers/invcountbatch.php'),(20781218,19601,'./!/application/controllers/invcountbatch.php'),(20781217,18184,'./!/application/controllers/invcountbatch.php'),(20781216,15315,'./!/application/controllers/invcountbatch.php'),(20781215,19797,'./!/application/controllers/invcountbatch.php'),(20781214,19600,'./!/application/controllers/invcountbatch.php'),(20781213,18908,'./!/application/controllers/invcountbatch.php'),(20781212,19914,'./!/application/controllers/invcountbatch.php'),(20781211,19807,'./!/application/controllers/invcountbatch.php'),(20781210,19913,'./!/application/controllers/invcountbatch.php'),(20781209,19599,'./!/application/controllers/invcountbatch.php'),(20781208,8185,'./!/application/controllers/invcountbatch.php'),(20781207,19598,'./!/application/controllers/invcountbatch.php'),(20781206,17260,'./!/application/controllers/invcountbatch.php'),(20781205,333,'./!/application/controllers/invcountbatch.php'),(20781204,315,'./!/application/controllers/invcountbatch.php'),(20781203,19912,'./!/application/controllers/invcountbatch.php'),(20781202,6669,'./!/application/controllers/invcountbatch.php'),(20781201,18183,'./!/application/controllers/invcountbatch.php'),(20781200,10861,'./!/application/controllers/invcountbatch.php'),(20781199,18182,'./!/application/controllers/invcountbatch.php'),(20781198,10860,'./!/application/controllers/invcountbatch.php'),(20781197,19597,'./!/application/controllers/invcountbatch.php'),(20781196,19486,'./!/application/controllers/invcountbatch.php'),(20781195,16526,'./!/application/controllers/invcountbatch.php'),(20781194,18339,'./!/application/controllers/invcountbatch.php'),(20781193,5095,'./!/application/controllers/invcountbatch.php'),(20781192,10079,'./!/application/controllers/invcountbatch.php'),(20781191,5570,'./!/application/controllers/invcountbatch.php'),(20781190,19596,'./!/application/controllers/invcountbatch.php'),(20781478,4865,'./!/application/controllers/invpo.php'),(20781477,16935,'./!/application/controllers/invpo.php'),(20781476,13974,'./!/application/controllers/invpo.php'),(20781475,6858,'./!/application/controllers/invpo.php'),(20781474,2165,'./!/application/controllers/invpo.php'),(20781473,2160,'./!/application/controllers/invpo.php'),(20781472,2151,'./!/application/controllers/invpo.php'),(20781471,6444,'./!/application/controllers/invpo.php'),(20781470,2094,'./!/application/controllers/invpo.php'),(20781469,2103,'./!/application/controllers/invpo.php'),(20781468,16674,'./!/application/controllers/invpo.php'),(20781467,1973,'./!/application/controllers/invpo.php'),(20781466,1963,'./!/application/controllers/invpo.php'),(20781465,1788,'./!/application/controllers/invpo.php'),(20781464,1770,'./!/application/controllers/invpo.php'),(20781463,9622,'./!/application/controllers/invpo.php'),(20781462,1726,'./!/application/controllers/invpo.php'),(20781461,1709,'./!/application/controllers/invpo.php'),(20781460,1696,'./!/application/controllers/invpo.php'),(20781459,17270,'./!/application/controllers/invpo.php'),(20781458,1666,'./!/application/controllers/invpo.php'),(20781457,1647,'./!/application/controllers/invpo.php'),(20781456,6705,'./!/application/controllers/invpo.php'),(20781455,14611,'./!/application/controllers/invpo.php'),(20781454,17269,'./!/application/controllers/invpo.php'),(20781453,15991,'./!/application/controllers/invpo.php'),(20781452,15970,'./!/application/controllers/invpo.php'),(20781451,1036,'./!/application/controllers/invpo.php'),(20781450,1014,'./!/application/controllers/invpo.php'),(20781449,7877,'./!/application/controllers/invpo.php'),(20781448,932,'./!/application/controllers/invpo.php'),(20781447,4660,'./!/application/controllers/invpo.php'),(20781446,869,'./!/application/controllers/invpo.php'),(20781445,9341,'./!/application/controllers/invpo.php'),(20781444,19918,'./!/application/controllers/invpo.php'),(20781443,18201,'./!/application/controllers/invpo.php'),(20781442,9492,'./!/application/controllers/invpo.php'),(20781441,616,'./!/application/controllers/invpo.php'),(20781440,16934,'./!/application/controllers/invpo.php'),(20781439,16933,'./!/application/controllers/invpo.php'),(20781438,605,'./!/application/controllers/invpo.php'),(20781437,18139,'./!/application/controllers/invpo.php'),(20781436,591,'./!/application/controllers/invpo.php'),(20781657,1846,'./!/application/controllers/item.php'),(20781656,1788,'./!/application/controllers/item.php'),(20781655,18914,'./!/application/controllers/item.php'),(20781654,19923,'./!/application/controllers/item.php'),(20781653,19817,'./!/application/controllers/item.php'),(20781652,19072,'./!/application/controllers/item.php'),(20781651,19147,'./!/application/controllers/item.php'),(20781650,19726,'./!/application/controllers/item.php'),(20781649,17919,'./!/application/controllers/item.php'),(20781648,1713,'./!/application/controllers/item.php'),(20781647,1709,'./!/application/controllers/item.php'),(20781646,15619,'./!/application/controllers/item.php'),(20781645,19816,'./!/application/controllers/item.php'),(20781644,19725,'./!/application/controllers/item.php'),(20781643,19724,'./!/application/controllers/item.php'),(20781642,18912,'./!/application/controllers/item.php'),(20781641,1740,'./!/application/controllers/item.php'),(20781640,1696,'./!/application/controllers/item.php'),(20781639,14706,'./!/application/controllers/item.php'),(20781638,1672,'./!/application/controllers/item.php'),(20781637,1666,'./!/application/controllers/item.php'),(20781636,1664,'./!/application/controllers/item.php'),(20781635,1647,'./!/application/controllers/item.php'),(20781634,18772,'./!/application/controllers/item.php'),(20781633,19815,'./!/application/controllers/item.php'),(20781632,19814,'./!/application/controllers/item.php'),(20781631,19813,'./!/application/controllers/item.php'),(20781630,14611,'./!/application/controllers/item.php'),(20781629,19812,'./!/application/controllers/item.php'),(20781628,1598,'./!/application/controllers/item.php'),(20781627,3435,'./!/application/controllers/item.php'),(20781626,17274,'./!/application/controllers/item.php'),(20781625,14837,'./!/application/controllers/item.php'),(20781624,1450,'./!/application/controllers/item.php'),(20781623,1447,'./!/application/controllers/item.php'),(20781622,19811,'./!/application/controllers/item.php'),(20781621,4413,'./!/application/controllers/item.php'),(20781620,1014,'./!/application/controllers/item.php'),(20781619,869,'./!/application/controllers/item.php'),(20781618,5205,'./!/application/controllers/item.php'),(20781617,16932,'./!/application/controllers/item.php'),(20781616,4973,'./!/application/controllers/item.php'),(20781615,737,'./!/application/controllers/item.php'),(20781614,5299,'./!/application/controllers/item.php'),(20781613,6228,'./!/application/controllers/item.php'),(20781612,697,'./!/application/controllers/item.php'),(20781611,19071,'./!/application/controllers/item.php'),(20781610,683,'./!/application/controllers/item.php'),(20781609,19173,'./!/application/controllers/item.php'),(20781608,19070,'./!/application/controllers/item.php'),(20781607,9492,'./!/application/controllers/item.php'),(20781606,19069,'./!/application/controllers/item.php'),(20781605,616,'./!/application/controllers/item.php'),(20781604,7803,'./!/application/controllers/item.php'),(20781603,572,'./!/application/controllers/item.php'),(20781602,15315,'./!/application/controllers/item.php'),(20781601,451,'./!/application/controllers/item.php'),(20781600,5424,'./!/application/controllers/item.php'),(20781599,18776,'./!/application/controllers/item.php'),(20781598,7246,'./!/application/controllers/item.php'),(20781597,18811,'./!/application/controllers/item.php'),(20781596,315,'./!/application/controllers/item.php'),(20781595,8935,'./!/application/controllers/item.php'),(20781594,19622,'./!/application/controllers/item.php'),(20781593,19621,'./!/application/controllers/item.php'),(20781592,313,'./!/application/controllers/item.php'),(20781591,7802,'./!/application/controllers/item.php'),(20781590,6314,'./!/application/controllers/item.php'),(20781765,10577,'./!/application/controllers/itemcategory.php'),(20781764,16675,'./!/application/controllers/itemcategory.php'),(20781763,13806,'./!/application/controllers/itemcategory.php'),(20781762,16671,'./!/application/controllers/itemcategory.php'),(20781761,18096,'./!/application/controllers/itemcategory.php'),(20781760,16674,'./!/application/controllers/itemcategory.php'),(20781759,1770,'./!/application/controllers/itemcategory.php'),(20781758,1639,'./!/application/controllers/itemcategory.php'),(20781757,11977,'./!/application/controllers/itemcategory.php'),(20781756,1499,'./!/application/controllers/itemcategory.php'),(20781755,18206,'./!/application/controllers/itemcategory.php'),(20781754,637,'./!/application/controllers/itemcategory.php'),(20781753,457,'./!/application/controllers/itemcategory.php'),(20781752,18205,'./!/application/controllers/itemcategory.php'),(20781751,18204,'./!/application/controllers/itemcategory.php'),(20781846,2137,'./!/application/controllers/itemlocation.php'),(20781845,19469,'./!/application/controllers/itemlocation.php'),(20781844,5985,'./!/application/controllers/itemlocation.php'),(20781843,17867,'./!/application/controllers/itemlocation.php'),(20781842,18526,'./!/application/controllers/itemlocation.php'),(20781841,17929,'./!/application/controllers/itemlocation.php'),(20781840,2094,'./!/application/controllers/itemlocation.php'),(20781839,18494,'./!/application/controllers/itemlocation.php'),(20781838,1963,'./!/application/controllers/itemlocation.php'),(20781837,19494,'./!/application/controllers/itemlocation.php'),(20781836,10946,'./!/application/controllers/itemlocation.php'),(20781835,1913,'./!/application/controllers/itemlocation.php'),(20781834,17277,'./!/application/controllers/itemlocation.php'),(20781833,1888,'./!/application/controllers/itemlocation.php'),(20781832,17276,'./!/application/controllers/itemlocation.php'),(20781831,1846,'./!/application/controllers/itemlocation.php'),(20781830,1788,'./!/application/controllers/itemlocation.php'),(20781829,20261,'./!/application/controllers/itemlocation.php'),(20781828,19362,'./!/application/controllers/itemlocation.php'),(20781827,18913,'./!/application/controllers/itemlocation.php'),(20781826,20260,'./!/application/controllers/itemlocation.php'),(20781825,19493,'./!/application/controllers/itemlocation.php'),(20781824,17919,'./!/application/controllers/itemlocation.php'),(20781823,1709,'./!/application/controllers/itemlocation.php'),(20781822,1703,'./!/application/controllers/itemlocation.php'),(20781821,1696,'./!/application/controllers/itemlocation.php'),(20781820,17928,'./!/application/controllers/itemlocation.php'),(20781819,1666,'./!/application/controllers/itemlocation.php'),(20781818,1647,'./!/application/controllers/itemlocation.php'),(20781817,19361,'./!/application/controllers/itemlocation.php'),(20781816,17275,'./!/application/controllers/itemlocation.php'),(20781815,17927,'./!/application/controllers/itemlocation.php'),(20781814,17926,'./!/application/controllers/itemlocation.php'),(20781813,16955,'./!/application/controllers/itemlocation.php'),(20781812,19360,'./!/application/controllers/itemlocation.php'),(20781811,19359,'./!/application/controllers/itemlocation.php'),(20781810,19358,'./!/application/controllers/itemlocation.php'),(20781809,19357,'./!/application/controllers/itemlocation.php'),(20781808,16089,'./!/application/controllers/itemlocation.php'),(20781807,17925,'./!/application/controllers/itemlocation.php'),(20781806,1047,'./!/application/controllers/itemlocation.php'),(20781805,16040,'./!/application/controllers/itemlocation.php'),(20781804,19821,'./!/application/controllers/itemlocation.php'),(20781803,19930,'./!/application/controllers/itemlocation.php'),(20781802,869,'./!/application/controllers/itemlocation.php'),(20781801,17924,'./!/application/controllers/itemlocation.php'),(20781926,16671,'./!/application/controllers/itempricespecial.php'),(20781924,16473,'./!/application/controllers/itempricespecial.php'),(20781923,13941,'./!/application/controllers/itempricespecial.php'),(20781922,19367,'./!/application/controllers/itempricespecial.php'),(20781921,17281,'./!/application/controllers/itempricespecial.php'),(20781920,2094,'./!/application/controllers/itempricespecial.php'),(20781919,2103,'./!/application/controllers/itempricespecial.php'),(20781918,16674,'./!/application/controllers/itempricespecial.php'),(20781917,1963,'./!/application/controllers/itempricespecial.php'),(20781916,4721,'./!/application/controllers/itempricespecial.php'),(20781915,19730,'./!/application/controllers/itempricespecial.php'),(20781914,1884,'./!/application/controllers/itempricespecial.php'),(20781913,13484,'./!/application/controllers/itempricespecial.php'),(20781912,1788,'./!/application/controllers/itempricespecial.php'),(20781911,1781,'./!/application/controllers/itempricespecial.php'),(20781910,9622,'./!/application/controllers/itempricespecial.php'),(20781909,5081,'./!/application/controllers/itempricespecial.php'),(20781908,1709,'./!/application/controllers/itempricespecial.php'),(20782242,17798,'./!/application/controllers/jobbudget.php'),(20782241,17797,'./!/application/controllers/jobbudget.php'),(20782240,17951,'./!/application/controllers/jobbudget.php'),(20782239,15991,'./!/application/controllers/jobbudget.php'),(20782238,17950,'./!/application/controllers/jobbudget.php'),(20782237,17949,'./!/application/controllers/jobbudget.php'),(20782236,1036,'./!/application/controllers/jobbudget.php'),(20782235,1014,'./!/application/controllers/jobbudget.php'),(20782234,9492,'./!/application/controllers/jobbudget.php'),(20782233,541,'./!/application/controllers/jobbudget.php'),(20782232,17948,'./!/application/controllers/jobbudget.php'),(20782231,226,'./!/application/controllers/jobbudget.php'),(20782230,17947,'./!/application/controllers/jobbudget.php'),(20782299,12840,'./!/application/controllers/login.php'),(20782320,14979,'./!/application/controllers/mage.php'),(20782319,11049,'./!/application/controllers/mage.php'),(20782318,1047,'./!/application/controllers/mage.php'),(20782317,941,'./!/application/controllers/mage.php'),(20782316,799,'./!/application/controllers/mage.php'),(20782315,9439,'./!/application/controllers/mage.php'),(20782314,9438,'./!/application/controllers/mage.php'),(20782313,9437,'./!/application/controllers/mage.php'),(20782312,797,'./!/application/controllers/mage.php'),(20782311,796,'./!/application/controllers/mage.php'),(20782310,7479,'./!/application/controllers/mage.php'),(20782309,5661,'./!/application/controllers/mage.php'),(20782308,637,'./!/application/controllers/mage.php'),(20782307,503,'./!/application/controllers/mage.php'),(20782306,315,'./!/application/controllers/mage.php'),(20782305,8125,'./!/application/controllers/mage.php'),(20782304,14937,'./!/application/controllers/mage.php'),(20782303,14936,'./!/application/controllers/mage.php'),(20782302,14978,'./!/application/controllers/mage.php'),(20782301,59,'./!/application/controllers/mage.php'),(20782723,11361,'./!/application/controllers/main.php'),(20782722,11128,'./!/application/controllers/main.php'),(20782721,3521,'./!/application/controllers/main.php'),(20782720,3671,'./!/application/controllers/main.php'),(20782719,7890,'./!/application/controllers/main.php'),(20782718,17692,'./!/application/controllers/main.php'),(20782717,17955,'./!/application/controllers/main.php'),(20782716,18061,'./!/application/controllers/main.php'),(20782715,18060,'./!/application/controllers/main.php'),(20782714,9390,'./!/application/controllers/main.php'),(20782713,5081,'./!/application/controllers/main.php'),(20782712,13811,'./!/application/controllers/main.php'),(20782711,7158,'./!/application/controllers/main.php'),(20782710,8937,'./!/application/controllers/main.php'),(20782709,12180,'./!/application/controllers/main.php'),(20782708,3668,'./!/application/controllers/main.php'),(20782707,13406,'./!/application/controllers/main.php'),(20782706,8174,'./!/application/controllers/main.php'),(20782705,17289,'./!/application/controllers/main.php'),(20782704,3667,'./!/application/controllers/main.php'),(20782703,3666,'./!/application/controllers/main.php'),(20782702,1732,'./!/application/controllers/main.php'),(20782701,11853,'./!/application/controllers/main.php'),(20782700,10595,'./!/application/controllers/main.php'),(20782699,4381,'./!/application/controllers/main.php'),(20782698,14015,'./!/application/controllers/main.php'),(20782697,12864,'./!/application/controllers/main.php'),(20782696,9921,'./!/application/controllers/main.php'),(20782695,13597,'./!/application/controllers/main.php'),(20782694,3665,'./!/application/controllers/main.php'),(20782693,8802,'./!/application/controllers/main.php'),(20782692,6402,'./!/application/controllers/main.php'),(20782691,6373,'./!/application/controllers/main.php'),(20782690,17919,'./!/application/controllers/main.php'),(20782689,3663,'./!/application/controllers/main.php'),(20782688,3662,'./!/application/controllers/main.php'),(20782687,9123,'./!/application/controllers/main.php'),(20782686,15308,'./!/application/controllers/main.php'),(20782685,7569,'./!/application/controllers/main.php'),(20782684,1702,'./!/application/controllers/main.php'),(20782683,16777,'./!/application/controllers/main.php'),(20782682,3661,'./!/application/controllers/main.php'),(20782681,9106,'./!/application/controllers/main.php'),(20782680,15619,'./!/application/controllers/main.php'),(20782679,5809,'./!/application/controllers/main.php'),(20782678,19628,'./!/application/controllers/main.php'),(20782677,7156,'./!/application/controllers/main.php'),(20782676,3660,'./!/application/controllers/main.php'),(20782675,12168,'./!/application/controllers/main.php'),(20782674,18912,'./!/application/controllers/main.php'),(20782673,8155,'./!/application/controllers/main.php'),(20782672,1740,'./!/application/controllers/main.php'),(20782671,1696,'./!/application/controllers/main.php'),(20782670,12893,'./!/application/controllers/main.php'),(20782669,8513,'./!/application/controllers/main.php'),(20782668,12877,'./!/application/controllers/main.php'),(20782667,1685,'./!/application/controllers/main.php'),(20782666,12846,'./!/application/controllers/main.php'),(20782665,10594,'./!/application/controllers/main.php'),(20782664,18166,'./!/application/controllers/main.php'),(20782663,11238,'./!/application/controllers/main.php'),(20782662,19287,'./!/application/controllers/main.php'),(20782661,19016,'./!/application/controllers/main.php'),(20782660,9467,'./!/application/controllers/main.php'),(20782659,4940,'./!/application/controllers/main.php'),(20782658,9263,'./!/application/controllers/main.php'),(20782657,12815,'./!/application/controllers/main.php'),(20782656,12807,'./!/application/controllers/main.php'),(20782655,16683,'./!/application/controllers/main.php'),(20782654,14616,'./!/application/controllers/main.php'),(20782653,13002,'./!/application/controllers/main.php'),(20782652,16548,'./!/application/controllers/main.php'),(20782651,1639,'./!/application/controllers/main.php'),(20782650,12723,'./!/application/controllers/main.php'),(20782649,14550,'./!/application/controllers/main.php'),(20782648,16547,'./!/application/controllers/main.php'),(20782647,13507,'./!/application/controllers/main.php'),(20782646,16478,'./!/application/controllers/main.php'),(20782645,16477,'./!/application/controllers/main.php'),(20782644,3986,'./!/application/controllers/main.php'),(20782643,3985,'./!/application/controllers/main.php'),(20782642,8250,'./!/application/controllers/main.php'),(20782641,14612,'./!/application/controllers/main.php'),(20782640,13576,'./!/application/controllers/main.php'),(20782639,17441,'./!/application/controllers/main.php'),(20782638,7489,'./!/application/controllers/main.php'),(20782637,17271,'./!/application/controllers/main.php'),(20782636,17264,'./!/application/controllers/main.php'),(20782635,17262,'./!/application/controllers/main.php'),(20782634,16090,'./!/application/controllers/main.php'),(20782633,16546,'./!/application/controllers/main.php'),(20782632,16900,'./!/application/controllers/main.php'),(20782631,17691,'./!/application/controllers/main.php'),(20782630,14260,'./!/application/controllers/main.php'),(20782629,5702,'./!/application/controllers/main.php'),(20782628,17690,'./!/application/controllers/main.php'),(20782627,17280,'./!/application/controllers/main.php'),(20782626,16545,'./!/application/controllers/main.php'),(20782625,16544,'./!/application/controllers/main.php'),(20782624,14807,'./!/application/controllers/main.php'),(20782623,11851,'./!/application/controllers/main.php'),(20782622,16776,'./!/application/controllers/main.php'),(20782621,14241,'./!/application/controllers/main.php'),(20782620,9292,'./!/application/controllers/main.php'),(20782619,17274,'./!/application/controllers/main.php'),(20782618,15099,'./!/application/controllers/main.php'),(20782617,15945,'./!/application/controllers/main.php'),(20782616,17958,'./!/application/controllers/main.php'),(20782615,16101,'./!/application/controllers/main.php'),(20782614,18530,'./!/application/controllers/main.php'),(20782613,17288,'./!/application/controllers/main.php'),(20782612,17275,'./!/application/controllers/main.php'),(20782611,17282,'./!/application/controllers/main.php'),(20782610,17266,'./!/application/controllers/main.php'),(20782609,17269,'./!/application/controllers/main.php'),(20782608,7153,'./!/application/controllers/main.php'),(20782607,7670,'./!/application/controllers/main.php'),(20782606,13264,'./!/application/controllers/main.php'),(20782605,6070,'./!/application/controllers/main.php'),(20782604,10065,'./!/application/controllers/main.php'),(20782603,17255,'./!/application/controllers/main.php'),(20782602,14893,'./!/application/controllers/main.php'),(20782601,15961,'./!/application/controllers/main.php'),(20782600,7785,'./!/application/controllers/main.php'),(20782599,16775,'./!/application/controllers/main.php'),(20782598,16756,'./!/application/controllers/main.php'),(20782597,16093,'./!/application/controllers/main.php'),(20782596,16774,'./!/application/controllers/main.php'),(20782595,16773,'./!/application/controllers/main.php'),(20782594,16899,'./!/application/controllers/main.php'),(20782593,3644,'./!/application/controllers/main.php'),(20782592,17287,'./!/application/controllers/main.php'),(20782591,17286,'./!/application/controllers/main.php'),(20782590,6093,'./!/application/controllers/main.php'),(20782589,15960,'./!/application/controllers/main.php'),(20782588,12921,'./!/application/controllers/main.php'),(20782587,12902,'./!/application/controllers/main.php'),(20782586,14760,'./!/application/controllers/main.php'),(20782585,14373,'./!/application/controllers/main.php'),(20782584,1590,'./!/application/controllers/main.php'),(20782583,12949,'./!/application/controllers/main.php'),(20782582,7889,'./!/application/controllers/main.php'),(20782581,17571,'./!/application/controllers/main.php'),(20782580,8084,'./!/application/controllers/main.php'),(20782579,14538,'./!/application/controllers/main.php'),(20782578,8599,'./!/application/controllers/main.php'),(20782577,11982,'./!/application/controllers/main.php'),(20782576,14609,'./!/application/controllers/main.php'),(20782575,1559,'./!/application/controllers/main.php'),(20782574,1546,'./!/application/controllers/main.php'),(20782573,11237,'./!/application/controllers/main.php'),(20782572,14181,'./!/application/controllers/main.php'),(20782571,9910,'./!/application/controllers/main.php'),(20782570,7150,'./!/application/controllers/main.php'),(20782569,7149,'./!/application/controllers/main.php'),(20782568,15959,'./!/application/controllers/main.php'),(20782567,16309,'./!/application/controllers/main.php'),(20782566,18921,'./!/application/controllers/main.php'),(20782565,11471,'./!/application/controllers/main.php'),(20782564,3635,'./!/application/controllers/main.php'),(20782563,1480,'./!/application/controllers/main.php'),(20782562,3634,'./!/application/controllers/main.php'),(20782561,3633,'./!/application/controllers/main.php'),(20782560,3632,'./!/application/controllers/main.php'),(20782559,1476,'./!/application/controllers/main.php'),(20782558,14164,'./!/application/controllers/main.php'),(20782557,16402,'./!/application/controllers/main.php'),(20782556,16401,'./!/application/controllers/main.php'),(20782555,7887,'./!/application/controllers/main.php'),(20782554,5491,'./!/application/controllers/main.php'),(20782553,1446,'./!/application/controllers/main.php'),(20782552,12912,'./!/application/controllers/main.php'),(20782551,17285,'./!/application/controllers/main.php'),(20782550,16094,'./!/application/controllers/main.php'),(20782549,11786,'./!/application/controllers/main.php'),(20782548,17941,'./!/application/controllers/main.php'),(20782547,9933,'./!/application/controllers/main.php'),(20782546,13022,'./!/application/controllers/main.php'),(20782545,12843,'./!/application/controllers/main.php'),(20782544,17241,'./!/application/controllers/main.php'),(20782543,1355,'./!/application/controllers/main.php'),(20782542,9943,'./!/application/controllers/main.php'),(20782541,13454,'./!/application/controllers/main.php'),(20782540,14602,'./!/application/controllers/main.php'),(20782539,1353,'./!/application/controllers/main.php'),(20782538,10819,'./!/application/controllers/main.php'),(20782537,11234,'./!/application/controllers/main.php'),(20782536,10551,'./!/application/controllers/main.php'),(20782535,14697,'./!/application/controllers/main.php'),(20782534,1036,'./!/application/controllers/main.php'),(20782533,13882,'./!/application/controllers/main.php'),(20782532,3629,'./!/application/controllers/main.php'),(20782531,18208,'./!/application/controllers/main.php'),(20782530,7147,'./!/application/controllers/main.php'),(20782529,3600,'./!/application/controllers/main.php'),(20782528,3596,'./!/application/controllers/main.php'),(20782527,3595,'./!/application/controllers/main.php'),(20782526,14197,'./!/application/controllers/main.php'),(20782525,7146,'./!/application/controllers/main.php'),(20782524,3593,'./!/application/controllers/main.php'),(20782523,11840,'./!/application/controllers/main.php'),(20782522,15702,'./!/application/controllers/main.php'),(20782521,993,'./!/application/controllers/main.php'),(20782520,7057,'./!/application/controllers/main.php'),(20782519,17173,'./!/application/controllers/main.php'),(20782518,3467,'./!/application/controllers/main.php'),(20782517,3461,'./!/application/controllers/main.php'),(20782516,14182,'./!/application/controllers/main.php'),(20782515,11848,'./!/application/controllers/main.php'),(20782514,11974,'./!/application/controllers/main.php'),(20782513,3588,'./!/application/controllers/main.php'),(20782512,11905,'./!/application/controllers/main.php'),(20782511,7971,'./!/application/controllers/main.php'),(20782510,7873,'./!/application/controllers/main.php'),(20782509,11976,'./!/application/controllers/main.php'),(20782508,7870,'./!/application/controllers/main.php'),(20782507,8717,'./!/application/controllers/main.php'),(20782506,952,'./!/application/controllers/main.php'),(20782505,17172,'./!/application/controllers/main.php'),(20782504,13613,'./!/application/controllers/main.php'),(20782503,11812,'./!/application/controllers/main.php'),(20782502,13730,'./!/application/controllers/main.php'),(20782501,3581,'./!/application/controllers/main.php'),(20782500,15775,'./!/application/controllers/main.php'),(20782499,15774,'./!/application/controllers/main.php'),(20782498,5267,'./!/application/controllers/main.php'),(20782497,7865,'./!/application/controllers/main.php'),(20782496,17572,'./!/application/controllers/main.php'),(20782495,15873,'./!/application/controllers/main.php'),(20782494,15872,'./!/application/controllers/main.php'),(20782493,6955,'./!/application/controllers/main.php'),(20782492,15389,'./!/application/controllers/main.php'),(20782491,10455,'./!/application/controllers/main.php'),(20782490,19534,'./!/application/controllers/main.php'),(20782489,12828,'./!/application/controllers/main.php'),(20782488,3579,'./!/application/controllers/main.php'),(20782487,12174,'./!/application/controllers/main.php'),(20782486,18486,'./!/application/controllers/main.php'),(20782485,8336,'./!/application/controllers/main.php'),(20782484,17645,'./!/application/controllers/main.php'),(20782483,17665,'./!/application/controllers/main.php'),(20782482,17664,'./!/application/controllers/main.php'),(20782481,8308,'./!/application/controllers/main.php'),(20782480,19627,'./!/application/controllers/main.php'),(20782479,17467,'./!/application/controllers/main.php'),(20782478,19369,'./!/application/controllers/main.php'),(20782477,8800,'./!/application/controllers/main.php'),(20782476,710,'./!/application/controllers/main.php'),(20782475,6755,'./!/application/controllers/main.php'),(20782474,9812,'./!/application/controllers/main.php'),(20782473,7141,'./!/application/controllers/main.php'),(20782472,15758,'./!/application/controllers/main.php'),(20782471,6316,'./!/application/controllers/main.php'),(20782470,16917,'./!/application/controllers/main.php'),(20782469,6317,'./!/application/controllers/main.php'),(20782468,11846,'./!/application/controllers/main.php'),(20782467,6465,'./!/application/controllers/main.php'),(20782466,3458,'./!/application/controllers/main.php'),(20782465,697,'./!/application/controllers/main.php'),(20782464,12776,'./!/application/controllers/main.php'),(20782463,12775,'./!/application/controllers/main.php'),(20782462,14696,'./!/application/controllers/main.php'),(20782461,15757,'./!/application/controllers/main.php'),(20782460,7121,'./!/application/controllers/main.php'),(20782459,17083,'./!/application/controllers/main.php'),(20782458,8653,'./!/application/controllers/main.php'),(20782457,7863,'./!/application/controllers/main.php'),(20782456,11845,'./!/application/controllers/main.php'),(20782455,7623,'./!/application/controllers/main.php'),(20782454,17171,'./!/application/controllers/main.php'),(20782453,11227,'./!/application/controllers/main.php'),(20782452,16542,'./!/application/controllers/main.php'),(20782451,17804,'./!/application/controllers/main.php'),(20782450,13459,'./!/application/controllers/main.php'),(20782449,11820,'./!/application/controllers/main.php'),(20782448,13729,'./!/application/controllers/main.php'),(20782447,10593,'./!/application/controllers/main.php'),(20782446,3569,'./!/application/controllers/main.php'),(20782445,3989,'./!/application/controllers/main.php'),(20782444,4601,'./!/application/controllers/main.php'),(20782443,7560,'./!/application/controllers/main.php'),(20782442,18139,'./!/application/controllers/main.php'),(20782441,3567,'./!/application/controllers/main.php'),(20782440,3566,'./!/application/controllers/main.php'),(20782439,576,'./!/application/controllers/main.php'),(20782438,7137,'./!/application/controllers/main.php'),(20782437,7136,'./!/application/controllers/main.php'),(20782436,11037,'./!/application/controllers/main.php'),(20782435,16291,'./!/application/controllers/main.php'),(20782434,5623,'./!/application/controllers/main.php'),(20782433,16116,'./!/application/controllers/main.php'),(20782432,3563,'./!/application/controllers/main.php'),(20782431,7858,'./!/application/controllers/main.php'),(20782430,14310,'./!/application/controllers/main.php'),(20782429,495,'./!/application/controllers/main.php'),(20782428,513,'./!/application/controllers/main.php'),(20782427,3562,'./!/application/controllers/main.php'),(20782426,3558,'./!/application/controllers/main.php'),(20782425,15864,'./!/application/controllers/main.php'),(20782424,19943,'./!/application/controllers/main.php'),(20782423,8723,'./!/application/controllers/main.php'),(20782422,7135,'./!/application/controllers/main.php'),(20782421,12803,'./!/application/controllers/main.php'),(20782420,12802,'./!/application/controllers/main.php'),(20782419,3550,'./!/application/controllers/main.php'),(20782418,408,'./!/application/controllers/main.php'),(20782417,3548,'./!/application/controllers/main.php'),(20782416,3547,'./!/application/controllers/main.php'),(20782415,4105,'./!/application/controllers/main.php'),(20782414,3987,'./!/application/controllers/main.php'),(20782413,11047,'./!/application/controllers/main.php'),(20782412,3544,'./!/application/controllers/main.php'),(20782411,3904,'./!/application/controllers/main.php'),(20782410,7854,'./!/application/controllers/main.php'),(20782409,15597,'./!/application/controllers/main.php'),(20782408,6537,'./!/application/controllers/main.php'),(20782407,5817,'./!/application/controllers/main.php'),(20782406,14861,'./!/application/controllers/main.php'),(20782405,18811,'./!/application/controllers/main.php'),(20782404,11727,'./!/application/controllers/main.php'),(20782403,5898,'./!/application/controllers/main.php'),(20782402,11842,'./!/application/controllers/main.php'),(20782401,16428,'./!/application/controllers/main.php'),(20782400,3541,'./!/application/controllers/main.php'),(20782399,7853,'./!/application/controllers/main.php'),(20782398,8127,'./!/application/controllers/main.php'),(20782397,18525,'./!/application/controllers/main.php'),(20782396,11841,'./!/application/controllers/main.php'),(20782395,7852,'./!/application/controllers/main.php'),(20782394,6419,'./!/application/controllers/main.php'),(20782393,15216,'./!/application/controllers/main.php'),(20782392,15773,'./!/application/controllers/main.php'),(20782391,19548,'./!/application/controllers/main.php'),(20782390,11487,'./!/application/controllers/main.php'),(20782389,8065,'./!/application/controllers/main.php'),(20782388,18182,'./!/application/controllers/main.php'),(20782387,18836,'./!/application/controllers/main.php'),(20782386,17170,'./!/application/controllers/main.php'),(20782385,10499,'./!/application/controllers/main.php'),(20782384,11798,'./!/application/controllers/main.php'),(20782383,15748,'./!/application/controllers/main.php'),(20782382,15958,'./!/application/controllers/main.php'),(20782381,17135,'./!/application/controllers/main.php'),(20782380,17169,'./!/application/controllers/main.php'),(20782379,8440,'./!/application/controllers/main.php'),(20782378,16541,'./!/application/controllers/main.php'),(20782377,9842,'./!/application/controllers/main.php'),(20782376,8352,'./!/application/controllers/main.php'),(20782375,17689,'./!/application/controllers/main.php'),(20782374,17957,'./!/application/controllers/main.php'),(20782373,4938,'./!/application/controllers/main.php'),(20782372,3537,'./!/application/controllers/main.php'),(20782371,10696,'./!/application/controllers/main.php'),(20782370,9601,'./!/application/controllers/main.php'),(20782369,3533,'./!/application/controllers/main.php'),(20782368,18346,'./!/application/controllers/main.php'),(20782367,7409,'./!/application/controllers/main.php'),(20783081,19740,'./!/application/controllers/mobilepos.php'),(20783080,19739,'./!/application/controllers/mobilepos.php'),(20783102,5329,'./!/application/controllers/payment_plan.php'),(20783101,5303,'./!/application/controllers/payment_plan.php'),(20783100,5302,'./!/application/controllers/payment_plan.php'),(20783099,1019,'./!/application/controllers/payment_plan.php'),(20783098,697,'./!/application/controllers/payment_plan.php'),(20783097,596,'./!/application/controllers/payment_plan.php'),(20783096,337,'./!/application/controllers/payment_plan.php'),(20783095,197,'./!/application/controllers/payment_plan.php'),(20783119,17123,'./!/application/controllers/paymentonaccount.php'),(20783118,17109,'./!/application/controllers/paymentonaccount.php'),(20783117,18385,'./!/application/controllers/paymentonaccount.php'),(20783116,479,'./!/application/controllers/paymentonaccount.php'),(20783115,5430,'./!/application/controllers/paymentonaccount.php'),(20783114,18736,'./!/application/controllers/paymentonaccount.php'),(20783113,226,'./!/application/controllers/paymentonaccount.php'),(20783205,1696,'./!/application/controllers/priceoverriderequest.php'),(20783204,14611,'./!/application/controllers/priceoverriderequest.php'),(20783203,1036,'./!/application/controllers/priceoverriderequest.php'),(20783202,7105,'./!/application/controllers/priceoverriderequest.php'),(20783201,17024,'./!/application/controllers/priceoverriderequest.php'),(20783200,697,'./!/application/controllers/priceoverriderequest.php'),(20783199,683,'./!/application/controllers/priceoverriderequest.php'),(20783198,13201,'./!/application/controllers/priceoverriderequest.php'),(20783264,1668,'./!/application/controllers/recurringbilling.php'),(20783263,1578,'./!/application/controllers/recurringbilling.php'),(20783262,18393,'./!/application/controllers/recurringbilling.php'),(20783261,5303,'./!/application/controllers/recurringbilling.php'),(20783260,16506,'./!/application/controllers/recurringbilling.php'),(20783259,18392,'./!/application/controllers/recurringbilling.php'),(20783258,18391,'./!/application/controllers/recurringbilling.php'),(20783257,18390,'./!/application/controllers/recurringbilling.php'),(20783256,1019,'./!/application/controllers/recurringbilling.php'),(20783255,1014,'./!/application/controllers/recurringbilling.php'),(20783254,18389,'./!/application/controllers/recurringbilling.php'),(20783253,7876,'./!/application/controllers/recurringbilling.php'),(20783252,932,'./!/application/controllers/recurringbilling.php'),(20783251,18388,'./!/application/controllers/recurringbilling.php'),(20783250,869,'./!/application/controllers/recurringbilling.php'),(20783249,5205,'./!/application/controllers/recurringbilling.php'),(20783248,799,'./!/application/controllers/recurringbilling.php'),(20783247,18224,'./!/application/controllers/recurringbilling.php'),(20783246,697,'./!/application/controllers/recurringbilling.php'),(20783245,18387,'./!/application/controllers/recurringbilling.php'),(20783244,668,'./!/application/controllers/recurringbilling.php'),(20783243,18223,'./!/application/controllers/recurringbilling.php'),(20783242,337,'./!/application/controllers/recurringbilling.php'),(20783241,325,'./!/application/controllers/recurringbilling.php'),(20783240,315,'./!/application/controllers/recurringbilling.php'),(20783239,8125,'./!/application/controllers/recurringbilling.php'),(20783238,18386,'./!/application/controllers/recurringbilling.php'),(20783237,197,'./!/application/controllers/recurringbilling.php'),(20783339,15106,'./!/application/controllers/rtmed.php'),(20783338,197,'./!/application/controllers/rtmed.php'),(20783346,1935,'./!/application/controllers/salesman.php'),(20783345,14611,'./!/application/controllers/salesman.php'),(20783344,981,'./!/application/controllers/salesman.php'),(20783416,1036,'./!/application/controllers/salestax.php'),(20783415,5409,'./!/application/controllers/salestax.php'),(20783414,16784,'./!/application/controllers/salestax.php'),(20783413,15349,'./!/application/controllers/salestax.php'),(20783412,524,'./!/application/controllers/salestax.php'),(20783411,16507,'./!/application/controllers/salestax.php'),(20783561,8508,'./!/application/controllers/shippingroute.php'),(20783560,4721,'./!/application/controllers/shippingroute.php'),(20783559,1935,'./!/application/controllers/shippingroute.php'),(20783558,315,'./!/application/controllers/shippingroute.php'),(20783590,14950,'./!/application/controllers/task.php'),(20783589,14949,'./!/application/controllers/task.php'),(20783588,17286,'./!/application/controllers/task.php'),(20783587,941,'./!/application/controllers/task.php'),(20783586,14948,'./!/application/controllers/task.php'),(20783585,869,'./!/application/controllers/task.php'),(20783584,799,'./!/application/controllers/task.php'),(20783583,15022,'./!/application/controllers/task.php'),(20783582,541,'./!/application/controllers/task.php'),(20783581,315,'./!/application/controllers/task.php'),(20783580,15020,'./!/application/controllers/task.php'),(20783579,15019,'./!/application/controllers/task.php'),(20783578,15018,'./!/application/controllers/task.php'),(20783577,8125,'./!/application/controllers/task.php'),(20783576,59,'./!/application/controllers/task.php'),(20489189,19381,'./!/application/controllers/territory.php'),(20489188,18548,'./!/application/controllers/territory.php'),(20489187,2738,'./!/application/controllers/territory.php'),(20489186,5761,'./!/application/controllers/territory.php'),(20489185,2698,'./!/application/controllers/territory.php'),(20489184,19380,'./!/application/controllers/territory.php'),(20489183,18547,'./!/application/controllers/territory.php'),(20489182,18546,'./!/application/controllers/territory.php'),(20489181,9962,'./!/application/controllers/territory.php'),(20489180,19379,'./!/application/controllers/territory.php'),(20489179,2044,'./!/application/controllers/territory.php'),(20489178,19378,'./!/application/controllers/territory.php'),(20489177,19377,'./!/application/controllers/territory.php'),(20489176,1935,'./!/application/controllers/territory.php'),(20489175,19827,'./!/application/controllers/territory.php'),(20489174,19370,'./!/application/controllers/territory.php'),(20489173,1788,'./!/application/controllers/territory.php'),(20489172,16544,'./!/application/controllers/territory.php'),(20489171,1578,'./!/application/controllers/territory.php'),(20489170,19376,'./!/application/controllers/territory.php'),(20489169,19826,'./!/application/controllers/territory.php'),(20489168,18545,'./!/application/controllers/territory.php'),(20489167,19375,'./!/application/controllers/territory.php'),(20489166,19194,'./!/application/controllers/territory.php'),(20489165,19374,'./!/application/controllers/territory.php'),(20489164,19373,'./!/application/controllers/territory.php'),(20489163,548,'./!/application/controllers/territory.php'),(20489162,315,'./!/application/controllers/territory.php'),(20783678,2099,'./!/application/controllers/timecard.php'),(20783677,8521,'./!/application/controllers/timecard.php'),(20783676,8393,'./!/application/controllers/timecard.php'),(20783675,5081,'./!/application/controllers/timecard.php'),(20783674,1575,'./!/application/controllers/timecard.php'),(20783673,1570,'./!/application/controllers/timecard.php'),(20783672,1567,'./!/application/controllers/timecard.php'),(20783671,1564,'./!/application/controllers/timecard.php'),(20783670,8749,'./!/application/controllers/timecard.php'),(20783669,1557,'./!/application/controllers/timecard.php'),(20783668,1337,'./!/application/controllers/timecard.php'),(20783667,3995,'./!/application/controllers/timecard.php'),(20783666,1013,'./!/application/controllers/timecard.php'),(20783665,998,'./!/application/controllers/timecard.php'),(20783664,996,'./!/application/controllers/timecard.php'),(20783663,8526,'./!/application/controllers/timecard.php'),(20783662,5640,'./!/application/controllers/timecard.php'),(20783661,799,'./!/application/controllers/timecard.php'),(20783660,4973,'./!/application/controllers/timecard.php'),(20783659,737,'./!/application/controllers/timecard.php'),(20783658,6075,'./!/application/controllers/timecard.php'),(20783657,337,'./!/application/controllers/timecard.php'),(20783656,8431,'./!/application/controllers/timecard.php'),(20783655,8520,'./!/application/controllers/timecard.php'),(20783654,315,'./!/application/controllers/timecard.php'),(20783653,8501,'./!/application/controllers/timecard.php'),(20783652,8692,'./!/application/controllers/timecard.php'),(20783651,11737,'./!/application/controllers/timecard.php'),(20783650,8691,'./!/application/controllers/timecard.php'),(20783649,57,'./!/application/controllers/timecard.php'),(20783648,47,'./!/application/controllers/timecard.php'),(20783728,8416,'./!/application/controllers/timeclock.php'),(20783727,8415,'./!/application/controllers/timeclock.php'),(20783726,8414,'./!/application/controllers/timeclock.php'),(20783725,8413,'./!/application/controllers/timeclock.php'),(20783724,8393,'./!/application/controllers/timeclock.php'),(20783723,8409,'./!/application/controllers/timeclock.php'),(20783722,8408,'./!/application/controllers/timeclock.php'),(20783721,8406,'./!/application/controllers/timeclock.php'),(20783720,8405,'./!/application/controllers/timeclock.php'),(20783719,1564,'./!/application/controllers/timeclock.php'),(20783718,1476,'./!/application/controllers/timeclock.php'),(20783717,10520,'./!/application/controllers/timeclock.php'),(20783716,8806,'./!/application/controllers/timeclock.php'),(20783715,1013,'./!/application/controllers/timeclock.php'),(20783714,8497,'./!/application/controllers/timeclock.php'),(20783713,8496,'./!/application/controllers/timeclock.php'),(20783712,6075,'./!/application/controllers/timeclock.php'),(20783711,8403,'./!/application/controllers/timeclock.php'),(20783997,4023,'./!/application/libraries/FixedInputFile.php'),(20784023,17721,'./!/application/libraries/amazon_library.php'),(20784022,886,'./!/application/libraries/amazon_library.php'),(20784021,18048,'./!/application/libraries/amazon_library.php'),(20784020,17720,'./!/application/libraries/amazon_library.php'),(20784019,17719,'./!/application/libraries/amazon_library.php'),(20784018,17718,'./!/application/libraries/amazon_library.php'),(20784017,17717,'./!/application/libraries/amazon_library.php'),(20784016,17962,'./!/application/libraries/amazon_library.php'),(20784015,17716,'./!/application/libraries/amazon_library.php'),(20784038,15966,'./!/application/libraries/faxservice.php'),(20784037,15965,'./!/application/libraries/faxservice.php'),(20784036,15964,'./!/application/libraries/faxservice.php'),(20784065,16317,'./!/application/libraries/import_task.php'),(20784064,16674,'./!/application/libraries/import_task.php'),(20784063,1935,'./!/application/libraries/import_task.php'),(20784062,1913,'./!/application/libraries/import_task.php'),(20784061,11005,'./!/application/libraries/import_task.php'),(20784060,1696,'./!/application/libraries/import_task.php'),(20784059,13717,'./!/application/libraries/import_task.php'),(20784058,14606,'./!/application/libraries/import_task.php'),(20784057,1476,'./!/application/libraries/import_task.php'),(20784056,14836,'./!/application/libraries/import_task.php'),(20784055,16316,'./!/application/libraries/import_task.php'),(20784054,16315,'./!/application/libraries/import_task.php'),(20784053,16089,'./!/application/libraries/import_task.php'),(20784052,749,'./!/application/libraries/import_task.php'),(20784051,6228,'./!/application/libraries/import_task.php'),(20784050,697,'./!/application/libraries/import_task.php'),(20784049,673,'./!/application/libraries/import_task.php'),(20784048,581,'./!/application/libraries/import_task.php'),(20784047,479,'./!/application/libraries/import_task.php'),(20784046,445,'./!/application/libraries/import_task.php'),(20784045,16565,'./!/application/libraries/import_task.php'),(20784044,16314,'./!/application/libraries/import_task.php'),(20784043,6050,'./!/application/libraries/import_task.php'),(20784090,17964,'./!/application/libraries/invlockdown.php'),(20784089,315,'./!/application/libraries/invlockdown.php'),(20784095,6234,'./!/application/libraries/pdf.php'),(20784094,1373,'./!/application/libraries/pdf.php'),(20784093,719,'./!/application/libraries/pdf.php'),(20784099,8125,'./!/application/libraries/select_form.php'),(20784127,12823,'./!/application/libraries/settings_form.php'),(20784126,2404,'./!/application/libraries/settings_form.php'),(20784125,19742,'./!/application/libraries/settings_form.php'),(20784152,541,'./!/application/libraries/taskbar.php'),(20784151,315,'./!/application/libraries/taskbar.php'),(20784150,18236,'./!/application/libraries/taskbar.php'),(20784149,3520,'./!/application/libraries/taskbar.php'),(20784184,2231,'./!/application/model_collections/arorder_collection.php'),(20784181,17967,'./!/application/model_collections/arorder_collection.php'),(20784180,5491,'./!/application/model_collections/arorder_collection.php'),(20784179,355,'./!/application/model_collections/arorder_collection.php'),(20784190,479,'./!/application/model_collections/arorder_deposit_collection.php'),(20784189,445,'./!/application/model_collections/arorder_deposit_collection.php'),(20784196,5205,'./!/application/model_collections/bank_deposit_collection.php'),(20784207,15921,'./!/application/model_collections/customer_collection.php'),(20784233,16528,'./!/application/model_collections/invcountbatchdetail_collection.php'),(20784238,55,'./!/application/model_collections/job_collection.php'),(20784241,1933,'./!/application/model_collections/premplweekpaydetail_collection.php'),(20784277,17450,'./!/application/models/arinvoicedetail_model.php'),(20784285,19384,'./!/application/models/arinvoicepaymentdetail_model.php'),(20784284,13808,'./!/application/models/arinvoicepaymentdetail_model.php'),(20784283,5145,'./!/application/models/arinvoicepaymentdetail_model.php'),(20784304,17136,'./!/application/models/arorder_model.php'),(20784303,2151,'./!/application/models/arorder_model.php'),(20784302,18376,'./!/application/models/arorder_model.php'),(20784301,20015,'./!/application/models/arorder_model.php'),(20784300,9138,'./!/application/models/arorder_model.php'),(20784299,17968,'./!/application/models/arorder_model.php'),(20784319,16526,'./!/application/models/arorderrentalpickup_model.php'),(20784334,19386,'./!/application/models/arordership_model.php'),(20784333,18982,'./!/application/models/arordership_model.php'),(20784332,18888,'./!/application/models/arordership_model.php'),(20784355,17968,'./!/application/models/customer_model.php'),(20784364,886,'./!/application/models/ebay_model.php'),(20784363,10253,'./!/application/models/ebay_model.php'),(20784362,187,'./!/application/models/ebay_model.php'),(20784390,16526,'./!/application/models/invcountbatch_model.php'),(20784389,14085,'./!/application/models/invcountbatch_model.php'),(20784413,2182,'./!/application/models/item_model.php'),(20784412,1753,'./!/application/models/item_model.php'),(20784411,1696,'./!/application/models/item_model.php'),(20784410,1640,'./!/application/models/item_model.php'),(20784409,1427,'./!/application/models/item_model.php'),(20784408,313,'./!/application/models/item_model.php'),(20784407,187,'./!/application/models/item_model.php'),(20784423,572,'./!/application/models/itemtransaction_model.php'),(20784422,187,'./!/application/models/itemtransaction_model.php'),(20784429,55,'./!/application/models/job_model.php'),(20784428,7679,'./!/application/models/job_model.php'),(20784436,4169,'./!/application/models/recurringbillingplan_model.php'),(20784445,17314,'./!/application/models/shopify_model.php'),(20784444,17313,'./!/application/models/shopify_model.php'),(20784443,5689,'./!/application/models/shopify_model.php'),(20784442,886,'./!/application/models/shopify_model.php'),(20784441,10253,'./!/application/models/shopify_model.php'),(20784440,18048,'./!/application/models/shopify_model.php'),(20784487,8440,'./!/application/views/process_payroll.php'),(20784520,17730,'./!/application/views/amazon/admin_add_store.php'),(20784519,6466,'./!/application/views/amazon/admin_add_store.php'),(20784518,17331,'./!/application/views/amazon/admin_add_store.php'),(20784537,1740,'./!/application/views/amazon/import_order_selection_table.php'),(20784535,17971,'./!/application/views/amazon/import_order_selection_table.php'),(20784534,7370,'./!/application/views/amazon/import_order_selection_table.php'),(20784533,1014,'./!/application/views/amazon/import_order_selection_table.php'),(20784532,737,'./!/application/views/amazon/import_order_selection_table.php'),(20784531,697,'./!/application/views/amazon/import_order_selection_table.php'),(20784530,17962,'./!/application/views/amazon/import_order_selection_table.php'),(20784584,17478,'./!/application/views/appointments/admin.php'),(20784583,17477,'./!/application/views/appointments/admin.php'),(20784582,17476,'./!/application/views/appointments/admin.php'),(20784581,17475,'./!/application/views/appointments/admin.php'),(20784580,869,'./!/application/views/appointments/admin.php'),(20784579,17474,'./!/application/views/appointments/admin.php'),(20784578,6307,'./!/application/views/appointments/admin.php'),(20784577,548,'./!/application/views/appointments/admin.php'),(20784576,416,'./!/application/views/appointments/admin.php'),(20784575,13994,'./!/application/views/appointments/admin.php'),(20784574,17973,'./!/application/views/appointments/admin.php'),(20784573,19629,'./!/application/views/appointments/admin.php'),(20784572,18555,'./!/application/views/appointments/admin.php'),(20784571,17473,'./!/application/views/appointments/admin.php'),(20784570,16541,'./!/application/views/appointments/admin.php'),(20784569,17472,'./!/application/views/appointments/admin.php'),(20784568,17471,'./!/application/views/appointments/admin.php'),(20784567,17470,'./!/application/views/appointments/admin.php'),(20784566,14001,'./!/application/views/appointments/admin.php'),(20784565,17469,'./!/application/views/appointments/admin.php'),(20784564,19749,'./!/application/views/appointments/admin.php'),(20784621,16922,'./!/application/views/appointments/appointment_report.php'),(20784620,315,'./!/application/views/appointments/appointment_report.php'),(20784619,16921,'./!/application/views/appointments/appointment_report.php'),(20784618,16920,'./!/application/views/appointments/appointment_report.php'),(20784617,185,'./!/application/views/appointments/appointment_report.php'),(20784616,16919,'./!/application/views/appointments/appointment_report.php'),(20784643,1788,'./!/application/views/appointments/appointment_report_select.php'),(20784639,16926,'./!/application/views/appointments/appointment_report_select.php'),(20784638,697,'./!/application/views/appointments/appointment_report_select.php'),(20784637,197,'./!/application/views/appointments/appointment_report_select.php'),(20784770,5491,'./!/application/views/aradmin/ordernumbering.php'),(20784769,17666,'./!/application/views/aradmin/ordernumbering.php'),(20784778,15750,'./!/application/views/archive_reports/review.php'),(20784777,15749,'./!/application/views/archive_reports/review.php'),(20784786,416,'./!/application/views/ardailyclose/create.js.php'),(20784785,17669,'./!/application/views/ardailyclose/create.js.php'),(20784797,17674,'./!/application/views/ardailyclose/create_get_system_totals.cash.php'),(20784798,3090,'./!/application/views/ardailyclose/create_get_system_totals.cash.php'),(20784799,2044,'./!/application/views/ardailyclose/create_get_system_totals.checks.gl.php'),(20784850,2361,'./!/application/views/arinvoice/arinvoice.php'),(20784849,2262,'./!/application/views/arinvoice/arinvoice.php'),(20784848,1781,'./!/application/views/arinvoice/arinvoice.php'),(20784847,1678,'./!/application/views/arinvoice/arinvoice.php'),(20784846,6125,'./!/application/views/arinvoice/arinvoice.php'),(20784845,1672,'./!/application/views/arinvoice/arinvoice.php'),(20784844,932,'./!/application/views/arinvoice/arinvoice.php'),(20784843,869,'./!/application/views/arinvoice/arinvoice.php'),(20784842,697,'./!/application/views/arinvoice/arinvoice.php'),(20784862,10940,'./!/application/views/arinvoice/generateOverdueRentalInvoices_Select.php'),(20784861,16097,'./!/application/views/arinvoice/generateOverdueRentalInvoices_Select.php'),(20784872,18565,'./!/application/views/arinvoice/header_extra.php'),(20784871,737,'./!/application/views/arinvoice/header_extra.php'),(20784870,18564,'./!/application/views/arinvoice/header_extra.php'),(20784882,416,'./!/application/views/arinvoice/invoiceDeleteDiag.php'),(20784914,20033,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20784913,1709,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20784912,18570,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20784911,869,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20784962,8544,'./!/application/views/arorder/arorder.php'),(20784961,1781,'./!/application/views/arorder/arorder.php'),(20784960,1758,'./!/application/views/arorder/arorder.php'),(20784959,1429,'./!/application/views/arorder/arorder.php'),(20784958,8941,'./!/application/views/arorder/arorder.php'),(20784957,981,'./!/application/views/arorder/arorder.php'),(20784956,16656,'./!/application/views/arorder/arorder.php'),(20784955,869,'./!/application/views/arorder/arorder.php'),(20784954,744,'./!/application/views/arorder/arorder.php'),(20784953,697,'./!/application/views/arorder/arorder.php'),(20784952,659,'./!/application/views/arorder/arorder.php'),(20784951,581,'./!/application/views/arorder/arorder.php'),(20784950,13661,'./!/application/views/arorder/arorder.php'),(20784949,524,'./!/application/views/arorder/arorder.php'),(20784948,306,'./!/application/views/arorder/arorder.php'),(20784947,8797,'./!/application/views/arorder/arorder.php'),(20784946,12889,'./!/application/views/arorder/arorder.php'),(20784988,697,'./!/application/views/arorder/batchShipAndInvoice.php'),(20785020,315,'./!/application/views/b2buser/multiadd_create.php'),(20785022,315,'./!/application/views/b2buser/multiadd_select_form_footer.php'),(20785273,19634,'./!/application/views/customer/report_authnet_cards.php'),(20785035,15972,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785034,869,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785033,697,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785032,8862,'./!/application/views/batchimport/batchimportdetail_table.php'),(20785046,15944,'./!/application/views/batchimport/batchimporterror_table.php'),(20785052,17322,'./!/application/views/batchimport/email_error.php'),(20785051,15944,'./!/application/views/batchimport/email_error.php'),(20785085,17094,'./!/application/views/ccterminal/selectedTerminalDetails.php'),(20785088,226,'./!/application/views/check/edit_associated_bills.php'),(20785104,4603,'./!/application/views/chunks/ui_style_properties.php'),(20785103,1476,'./!/application/views/chunks/ui_style_properties.php'),(20785102,799,'./!/application/views/chunks/ui_style_properties.php'),(20785101,8010,'./!/application/views/chunks/ui_style_properties.php'),(20785100,14597,'./!/application/views/chunks/ui_style_properties.php'),(20785099,695,'./!/application/views/chunks/ui_style_properties.php'),(20785098,14588,'./!/application/views/chunks/ui_style_properties.php'),(20785097,14587,'./!/application/views/chunks/ui_style_properties.php'),(20785096,4600,'./!/application/views/chunks/ui_style_properties.php'),(20785095,13994,'./!/application/views/chunks/ui_style_properties.php'),(20785094,14585,'./!/application/views/chunks/ui_style_properties.php'),(20785093,14001,'./!/application/views/chunks/ui_style_properties.php'),(20785092,3520,'./!/application/views/chunks/ui_style_properties.php'),(20785133,1047,'./!/application/views/county/add.php'),(20785132,16584,'./!/application/views/county/add.php'),(20785131,416,'./!/application/views/county/add.php'),(20785142,16589,'./!/application/views/county/edit.php'),(20785141,799,'./!/application/views/county/edit.php'),(20785140,16584,'./!/application/views/county/edit.php'),(20785139,416,'./!/application/views/county/edit.php'),(20785138,16588,'./!/application/views/county/edit.php'),(20785737,1047,'./!/application/views/invcountbatch/liveCounts.php'),(20785164,16922,'./!/application/views/customer/appointment_report.php'),(20785163,315,'./!/application/views/customer/appointment_report.php'),(20785162,16921,'./!/application/views/customer/appointment_report.php'),(20785161,16920,'./!/application/views/customer/appointment_report.php'),(20785160,185,'./!/application/views/customer/appointment_report.php'),(20785159,16919,'./!/application/views/customer/appointment_report.php'),(20785185,1788,'./!/application/views/customer/appointment_report_select.php'),(20785181,16926,'./!/application/views/customer/appointment_report_select.php'),(20785180,697,'./!/application/views/customer/appointment_report_select.php'),(20785179,197,'./!/application/views/customer/appointment_report_select.php'),(20785196,15976,'./!/application/views/customer/fax_statments.php'),(20785195,697,'./!/application/views/customer/fax_statments.php'),(20785202,16631,'./!/application/views/customer/import_shipto_subform.php'),(20785206,16596,'./!/application/views/customer/patient_import_results.php'),(20785205,16595,'./!/application/views/customer/patient_import_results.php'),(20785216,982,'./!/application/views/customer/patient_import_upload.php'),(20785215,741,'./!/application/views/customer/patient_import_upload.php'),(20785214,16600,'./!/application/views/customer/patient_import_upload.php'),(20785213,14203,'./!/application/views/customer/patient_import_upload.php'),(20785212,524,'./!/application/views/customer/patient_import_upload.php'),(20785211,16599,'./!/application/views/customer/patient_import_upload.php'),(20785249,8867,'./!/application/views/customer/recent_orders.php'),(20785248,4363,'./!/application/views/customer/recent_orders.php'),(20785339,15094,'./!/application/views/dashboard/summary/checking_account.php'),(20785350,4956,'./!/application/views/dashboard/summary/expenses.php'),(20785349,14758,'./!/application/views/dashboard/summary/expenses.php'),(20785367,13569,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785366,13576,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785365,1353,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785364,5039,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785363,638,'./!/application/views/dashboard/summary/profit_and_loss_statement.php'),(20785392,5759,'./!/application/views/ebay/admin.php'),(20785391,17340,'./!/application/views/ebay/admin.php'),(20785390,9438,'./!/application/views/ebay/admin.php'),(20785389,17339,'./!/application/views/ebay/admin.php'),(20785388,5727,'./!/application/views/ebay/admin.php'),(20785387,17338,'./!/application/views/ebay/admin.php'),(20785386,17337,'./!/application/views/ebay/admin.php'),(20785385,17336,'./!/application/views/ebay/admin.php'),(20785384,17335,'./!/application/views/ebay/admin.php'),(20785383,17334,'./!/application/views/ebay/admin.php'),(20785382,8125,'./!/application/views/ebay/admin.php'),(20785381,17333,'./!/application/views/ebay/admin.php'),(20785380,17332,'./!/application/views/ebay/admin.php'),(20785379,17331,'./!/application/views/ebay/admin.php'),(20785378,17330,'./!/application/views/ebay/admin.php'),(20785377,17329,'./!/application/views/ebay/admin.php'),(20785421,7112,'./!/application/views/ebay/admin_select_store.php'),(20785483,3269,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785482,17278,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785481,18175,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785480,2508,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785479,1788,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785478,19387,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785477,1696,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785476,1647,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785475,616,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785474,19129,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785473,7246,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785472,7243,'./!/application/views/eventlog/reviewEntry.wacost.edit.php'),(20785484,7250,'./!/application/views/faxservices/log_tr_ringcentral.php'),(20785491,315,'./!/application/views/generic/confirm_message.php'),(20785542,17107,'./!/application/views/generic/paxTerminalCollect.php'),(20785541,416,'./!/application/views/generic/paxTerminalCollect.php'),(20785540,17122,'./!/application/views/generic/paxTerminalCollect.php'),(20785552,1578,'./!/application/views/generic/select.php'),(20785551,197,'./!/application/views/generic/select.php'),(20785550,87,'./!/application/views/generic/select.php'),(20785549,16606,'./!/application/views/generic/select.php'),(20785575,7370,'./!/application/views/import_task/import_task_result.php'),(20785574,15944,'./!/application/views/import_task/import_task_result.php'),(20785583,6166,'./!/application/views/import_task/upload_form.php'),(20785582,16143,'./!/application/views/import_task/upload_form.php'),(20785581,16817,'./!/application/views/import_task/upload_form.php'),(20785580,14203,'./!/application/views/import_task/upload_form.php'),(20785590,18754,'./!/application/views/invbin/bin_item_assignment.php'),(20785589,18753,'./!/application/views/invbin/bin_item_assignment.php'),(20785588,17260,'./!/application/views/invbin/bin_item_assignment.php'),(20785615,18199,'./!/application/views/invcotransfer/assignByZone_form.php'),(20785608,19299,'./!/application/views/invcotransfer/assignByZone_form.php'),(20785607,17260,'./!/application/views/invcotransfer/assignByZone_form.php'),(20785606,10861,'./!/application/views/invcotransfer/assignByZone_form.php'),(20785646,19389,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785645,2401,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785644,19062,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785643,1709,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785642,1696,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785641,19388,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785640,19303,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785639,869,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785638,541,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785637,416,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785636,14832,'./!/application/views/invcotransfer/massShip_ReviewTransfers.php'),(20785657,19345,'./!/application/views/invcotransfer/pick.php'),(20785656,4267,'./!/application/views/invcotransfer/pick.php'),(20785655,2702,'./!/application/views/invcotransfer/pick.php'),(20785654,14105,'./!/application/views/invcotransfer/pick.php'),(20785653,19390,'./!/application/views/invcotransfer/pick.php'),(20785652,416,'./!/application/views/invcotransfer/pick.php'),(20785675,2044,'./!/application/views/invcountbatch/assignCounting.form.binsAjax.php'),(20785674,19302,'./!/application/views/invcountbatch/assignCounting.form.binsAjax.php'),(20785685,19637,'./!/application/views/invcountbatch/assignCounting.form.js.php'),(20785684,19636,'./!/application/views/invcountbatch/assignCounting.form.js.php'),(20785699,18418,'./!/application/views/invcountbatch/edit.php'),(20785698,18417,'./!/application/views/invcountbatch/edit.php'),(20785697,18416,'./!/application/views/invcountbatch/edit.php'),(20785736,541,'./!/application/views/invcountbatch/liveCounts.php'),(20785750,16525,'./!/application/views/invcountbatch/reviewCounts.details.php'),(20785769,1672,'./!/application/views/invpo/apbill_table.php'),(20785768,932,'./!/application/views/invpo/apbill_table.php'),(20785767,869,'./!/application/views/invpo/apbill_table.php'),(20785766,543,'./!/application/views/invpo/apbill_table.php'),(20785765,226,'./!/application/views/invpo/apbill_table.php'),(20785775,18817,'./!/application/views/invpo/barcodelabelselection.php'),(20785781,8072,'./!/application/views/invpo/email_receival_notice.php'),(20785780,6226,'./!/application/views/invpo/email_receival_notice.php'),(20785779,8185,'./!/application/views/invpo/email_receival_notice.php'),(20785793,2165,'./!/application/views/invpo/invpodetail_table.php'),(20785792,1770,'./!/application/views/invpo/invpodetail_table.php'),(20785791,1696,'./!/application/views/invpo/invpodetail_table.php'),(20785790,18758,'./!/application/views/invpo/invpodetail_table.php'),(20785789,4602,'./!/application/views/invpo/invpodetail_table.php'),(20785788,869,'./!/application/views/invpo/invpodetail_table.php'),(20785810,1696,'./!/application/views/item/barcodemassprint_queue.php'),(20785809,1647,'./!/application/views/item/barcodemassprint_queue.php'),(20785808,18818,'./!/application/views/item/barcodemassprint_queue.php'),(20785807,18817,'./!/application/views/item/barcodemassprint_queue.php'),(20785806,19393,'./!/application/views/item/barcodemassprint_queue.php'),(20785805,19392,'./!/application/views/item/barcodemassprint_queue.php'),(20785816,869,'./!/application/views/item/ckeditor_info.php'),(20785815,10909,'./!/application/views/item/ckeditor_info.php'),(20785820,616,'./!/application/views/item/compare_vendor_prices.php'),(20785826,1696,'./!/application/views/item/mobile_manage_location.php'),(20785825,683,'./!/application/views/item/mobile_manage_location.php'),(20785839,19397,'./!/application/views/item/statsPerLocation.php'),(20785838,19396,'./!/application/views/item/statsPerLocation.php'),(20785837,2702,'./!/application/views/item/statsPerLocation.php'),(20785836,16671,'./!/application/views/item/statsPerLocation.php'),(20785835,16674,'./!/application/views/item/statsPerLocation.php'),(20785834,18584,'./!/application/views/item/statsPerLocation.php'),(20785847,16820,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785846,16819,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785845,886,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785844,16818,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785843,607,'./!/application/views/itemcategory/item_category_discounts_by_price_level.php'),(20785883,16125,'./!/application/views/job/tab_prelim_request.php'),(20785945,799,'./!/application/views/jobbudget/edit.php'),(20785944,737,'./!/application/views/jobbudget/edit.php'),(20785943,697,'./!/application/views/jobbudget/edit.php'),(20785942,683,'./!/application/views/jobbudget/edit.php'),(20785941,9492,'./!/application/views/jobbudget/edit.php'),(20785940,13861,'./!/application/views/jobbudget/edit.php'),(20785939,17948,'./!/application/views/jobbudget/edit.php'),(20785938,8125,'./!/application/views/jobbudget/edit.php'),(20785937,226,'./!/application/views/jobbudget/edit.php'),(20785985,1467,'./!/application/views/maillog/review.php'),(20785984,15803,'./!/application/views/maillog/review.php'),(20785983,3455,'./!/application/views/maillog/review.php'),(20786001,5081,'./!/application/views/meta_menu/arinvoice.php'),(20786000,1740,'./!/application/views/meta_menu/arinvoice.php'),(20785999,1696,'./!/application/views/meta_menu/arinvoice.php'),(20785998,15391,'./!/application/views/meta_menu/arinvoice.php'),(20785997,1668,'./!/application/views/meta_menu/arinvoice.php'),(20785996,1373,'./!/application/views/meta_menu/arinvoice.php'),(20785995,981,'./!/application/views/meta_menu/arinvoice.php'),(20785994,941,'./!/application/views/meta_menu/arinvoice.php'),(20785993,737,'./!/application/views/meta_menu/arinvoice.php'),(20785992,697,'./!/application/views/meta_menu/arinvoice.php'),(20785991,491,'./!/application/views/meta_menu/arinvoice.php'),(20785990,226,'./!/application/views/meta_menu/arinvoice.php'),(20786044,484,'./!/application/views/meta_menu/check.php'),(20786043,504,'./!/application/views/meta_menu/check.php'),(20786042,479,'./!/application/views/meta_menu/check.php'),(20786041,447,'./!/application/views/meta_menu/check.php'),(20786040,446,'./!/application/views/meta_menu/check.php'),(20786039,13295,'./!/application/views/meta_menu/check.php'),(20786038,226,'./!/application/views/meta_menu/check.php'),(20786074,2044,'./!/application/views/meta_menu/customer.php'),(20786073,18586,'./!/application/views/meta_menu/customer.php'),(20786072,1973,'./!/application/views/meta_menu/customer.php'),(20786071,1935,'./!/application/views/meta_menu/customer.php'),(20786070,1884,'./!/application/views/meta_menu/customer.php'),(20786069,7199,'./!/application/views/meta_menu/customer.php'),(20786068,1678,'./!/application/views/meta_menu/customer.php'),(20786067,1575,'./!/application/views/meta_menu/customer.php'),(20786066,8867,'./!/application/views/meta_menu/customer.php'),(20786065,981,'./!/application/views/meta_menu/customer.php'),(20786064,941,'./!/application/views/meta_menu/customer.php'),(20786063,4363,'./!/application/views/meta_menu/customer.php'),(20786062,737,'./!/application/views/meta_menu/customer.php'),(20786061,697,'./!/application/views/meta_menu/customer.php'),(20786060,683,'./!/application/views/meta_menu/customer.php'),(20786059,605,'./!/application/views/meta_menu/customer.php'),(20786058,18927,'./!/application/views/meta_menu/customer.php'),(20786057,18926,'./!/application/views/meta_menu/customer.php'),(20786056,355,'./!/application/views/meta_menu/customer.php'),(20786055,325,'./!/application/views/meta_menu/customer.php'),(20786054,226,'./!/application/views/meta_menu/customer.php'),(20786053,15156,'./!/application/views/meta_menu/customer.php'),(20786052,55,'./!/application/views/meta_menu/customer.php'),(20786123,6444,'./!/application/views/meta_menu/item.php'),(20786122,2070,'./!/application/views/meta_menu/item.php'),(20786121,1696,'./!/application/views/meta_menu/item.php'),(20786120,18772,'./!/application/views/meta_menu/item.php'),(20786119,1557,'./!/application/views/meta_menu/item.php'),(20786118,941,'./!/application/views/meta_menu/item.php'),(20786117,869,'./!/application/views/meta_menu/item.php'),(20786116,572,'./!/application/views/meta_menu/item.php'),(20786115,188,'./!/application/views/meta_menu/item.php'),(20786154,19089,'./!/application/views/meta_menu/shipment.php'),(20786152,18248,'./!/application/views/meta_menu/shipment.php'),(20786153,6770,'./!/application/views/meta_menu/shipment.php'),(20786185,799,'./!/application/views/mobilepos/mobilepos.php'),(20786184,737,'./!/application/views/mobilepos/mobilepos.php'),(20786183,416,'./!/application/views/mobilepos/mobilepos.php'),(20786182,5811,'./!/application/views/mobilepos/mobilepos.php'),(20786181,14581,'./!/application/views/mobilepos/mobilepos.php'),(20786180,14832,'./!/application/views/mobilepos/mobilepos.php'),(20786198,14624,'./!/application/views/myuser/newpassword.php'),(20786197,14623,'./!/application/views/myuser/newpassword.php'),(20786196,18251,'./!/application/views/myuser/newpassword.php'),(20786195,18250,'./!/application/views/myuser/newpassword.php'),(20786194,18249,'./!/application/views/myuser/newpassword.php'),(20786193,14584,'./!/application/views/myuser/newpassword.php'),(20786238,17987,'./!/application/views/physicalinv/search.php'),(20786237,1709,'./!/application/views/physicalinv/search.php'),(20786236,17964,'./!/application/views/physicalinv/search.php'),(20786235,14836,'./!/application/views/physicalinv/search.php'),(20786234,19537,'./!/application/views/physicalinv/search.php'),(20786233,17986,'./!/application/views/physicalinv/search.php'),(20786232,17985,'./!/application/views/physicalinv/search.php'),(20786231,8188,'./!/application/views/physicalinv/search.php'),(20786230,8187,'./!/application/views/physicalinv/search.php'),(20786229,17984,'./!/application/views/physicalinv/search.php'),(20786228,17816,'./!/application/views/physicalinv/search.php'),(20786227,451,'./!/application/views/physicalinv/search.php'),(20786226,17983,'./!/application/views/physicalinv/search.php'),(20786225,197,'./!/application/views/physicalinv/search.php'),(20786337,799,'./!/application/views/query_builder/list.php'),(20786336,5203,'./!/application/views/query_builder/list.php'),(20786335,59,'./!/application/views/query_builder/list.php'),(20786354,1685,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786353,13121,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786352,1647,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786351,15991,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786350,869,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786349,5727,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786348,635,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786347,9492,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786346,616,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786345,18424,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786344,18280,'./!/application/views/recurringbilling/plan_invoice_edit.php'),(20786442,16144,'./!/application/views/salestax/import_upload.php'),(20786383,13334,'./!/application/views/rma_arorder/batch_create_select_orders.php'),(20786382,1696,'./!/application/views/rma_arorder/batch_create_select_orders.php'),(20786381,17183,'./!/application/views/rma_arorder/batch_create_select_orders.php'),(20786426,16618,'./!/application/views/salestax/import_results.php'),(20786425,16617,'./!/application/views/salestax/import_results.php'),(20786424,16616,'./!/application/views/salestax/import_results.php'),(20786423,16615,'./!/application/views/salestax/import_results.php'),(20786440,16626,'./!/application/views/salestax/import_upload.php'),(20786439,16625,'./!/application/views/salestax/import_upload.php'),(20786438,16584,'./!/application/views/salestax/import_upload.php'),(20786437,14203,'./!/application/views/salestax/import_upload.php'),(20786436,16624,'./!/application/views/salestax/import_upload.php'),(20786435,16623,'./!/application/views/salestax/import_upload.php'),(20786434,16622,'./!/application/views/salestax/import_upload.php'),(20786433,16621,'./!/application/views/salestax/import_upload.php'),(20786432,8051,'./!/application/views/salestax/import_upload.php'),(20786476,2222,'./!/application/views/scanner/review.php'),(20786475,17190,'./!/application/views/scanner/review.php'),(20786548,16980,'./!/application/views/shopify/admin_add_store.php'),(20786547,17000,'./!/application/views/shopify/admin_add_store.php'),(20786546,7188,'./!/application/views/shopify/admin_add_store.php'),(20786545,541,'./!/application/views/shopify/admin_add_store.php'),(20786544,16970,'./!/application/views/shopify/admin_add_store.php'),(20786543,9442,'./!/application/views/shopify/admin_add_store.php'),(20786542,8629,'./!/application/views/shopify/admin_add_store.php'),(20786541,6466,'./!/application/views/shopify/admin_add_store.php'),(20786557,17374,'./!/application/views/shopify/admin_select_store.php'),(20786565,1788,'./!/application/views/shopify/import_customer_selection_table.php'),(20786564,17377,'./!/application/views/shopify/import_customer_selection_table.php'),(20786563,17376,'./!/application/views/shopify/import_customer_selection_table.php'),(20786562,7370,'./!/application/views/shopify/import_customer_selection_table.php'),(20786561,1014,'./!/application/views/shopify/import_customer_selection_table.php'),(20786560,981,'./!/application/views/shopify/import_customer_selection_table.php'),(20786583,10386,'./!/application/views/shopify/import_item_selection_table.php'),(20786582,17384,'./!/application/views/shopify/import_item_selection_table.php'),(20786581,17383,'./!/application/views/shopify/import_item_selection_table.php'),(20786580,17382,'./!/application/views/shopify/import_item_selection_table.php'),(20786579,7370,'./!/application/views/shopify/import_item_selection_table.php'),(20786578,1014,'./!/application/views/shopify/import_item_selection_table.php'),(20786637,17388,'./!/application/views/shopify/import_select_store.php'),(20786636,3458,'./!/application/views/shopify/import_select_store.php'),(20786635,607,'./!/application/views/shopify/import_select_store.php'),(20492078,6164,'./!/application/views/territory/edit.php'),(20492077,18550,'./!/application/views/territory/edit.php'),(20492076,18549,'./!/application/views/territory/edit.php'),(20492075,2698,'./!/application/views/territory/edit.php'),(20492074,18547,'./!/application/views/territory/edit.php'),(20492073,19370,'./!/application/views/territory/edit.php'),(20492072,13334,'./!/application/views/territory/edit.php'),(20492071,1647,'./!/application/views/territory/edit.php'),(20492083,19400,'./!/application/views/territory/region_territory_list.php'),(20492082,1935,'./!/application/views/territory/region_territory_list.php'),(20492081,19399,'./!/application/views/territory/region_territory_list.php'),(20492080,19398,'./!/application/views/territory/region_territory_list.php'),(20492079,548,'./!/application/views/territory/region_territory_list.php'),(20786665,6075,'./!/application/views/timecard/employee_list.php'),(20786664,47,'./!/application/views/timecard/employee_list.php'),(20786677,12836,'./!/application/views/timecard/login.php'),(20786676,15269,'./!/application/views/timecard/login.php'),(20786682,8523,'./!/application/views/timecard/over_maxhours.php'),(20786681,8522,'./!/application/views/timecard/over_maxhours.php'),(20786704,17451,'./!/application/views/usps_api/customerAddressChanged.js.php'),(20786703,185,'./!/application/views/usps_api/customerAddressChanged.js.php'),(20787266,18253,'./adminarcompanyupd.php'),(20786712,16631,'./!/application/views/vendor/import_orderfrom_subform.php'),(20786724,11298,'./!/application/views/vendor/summary.php'),(20786739,19400,'./!/application/views/zipcode/verifyZipCityStateMatch.php'),(20786738,3432,'./!/application/views/zipcode/verifyZipCityStateMatch.php'),(20786737,19404,'./!/application/views/zipcode/verifyZipCityStateMatch.php'),(20786736,19403,'./!/application/views/zipcode/verifyZipCityStateMatch.php'),(20786735,2936,'./!/application/views/zipcode/verifyZipCityStateMatch.php'),(20786734,19402,'./!/application/views/zipcode/verifyZipCityStateMatch.php'),(20786733,19401,'./!/application/views/zipcode/verifyZipCityStateMatch.php'),(20786732,2702,'./!/application/views/zipcode/verifyZipCityStateMatch.php'),(20786731,2044,'./!/application/views/zipcode/verifyZipCityStateMatch.php'),(20786730,524,'./!/application/views/zipcode/verifyZipCityStateMatch.php'),(20786729,416,'./!/application/views/zipcode/verifyZipCityStateMatch.php'),(20787016,2258,'./adminapglacct.php'),(20787264,19756,'./adminarcompanyupd.php'),(20787263,13826,'./adminarcompanyupd.php'),(20787262,14126,'./adminarcompanyupd.php'),(20787261,14125,'./adminarcompanyupd.php'),(20787260,19091,'./adminarcompanyupd.php'),(20787259,279,'./adminarcompanyupd.php'),(20787258,15883,'./adminarcompanyupd.php'),(20787257,16229,'./adminarcompanyupd.php'),(20787256,16228,'./adminarcompanyupd.php'),(20787255,9442,'./adminarcompanyupd.php'),(20787254,8629,'./adminarcompanyupd.php'),(20787253,13568,'./adminarcompanyupd.php'),(20787252,17995,'./adminarcompanyupd.php'),(20787251,18600,'./adminarcompanyupd.php'),(20788798,70,'./admininvlocationadd.php'),(20788797,59,'./admininvlocationadd.php'),(20788807,113,'./admininvlocationupd.php'),(20788806,59,'./admininvlocationupd.php'),(20791243,20,'./arbankdepositadd.php'),(20792100,226,'./areft.php'),(20792099,30,'./areft.php'),(20792098,7721,'./areft.php'),(20793019,315,'./arinvoicereprint.php'),(20793018,5570,'./arinvoicereprint.php'),(20793209,5145,'./arinvoicereturnsdetail.php'),(20793208,226,'./arinvoicereturnsdetail.php'),(20793590,315,'./arinvoiceview.php'),(20793848,18273,'./aritemcalcreorderpoint.php'),(20793847,20097,'./aritemcalcreorderpoint.php'),(20793846,869,'./aritemcalcreorderpoint.php'),(20793845,683,'./aritemcalcreorderpoint.php'),(20793844,607,'./aritemcalcreorderpoint.php'),(20793843,542,'./aritemcalcreorderpoint.php'),(20793842,12806,'./aritemcalcreorderpoint.php'),(20793841,315,'./aritemcalcreorderpoint.php'),(20793840,20096,'./aritemcalcreorderpoint.php'),(20793839,20095,'./aritemcalcreorderpoint.php'),(20793838,16607,'./aritemcalcreorderpoint.php'),(20793969,9376,'./arordcc.php'),(20793968,14050,'./arordcc.php'),(20793967,14055,'./arordcc.php'),(20794016,325,'./arordconfirmfpdf.php'),(20794366,6393,'./arorderitemcustlst.php'),(20794365,197,'./arorderitemcustlst.php'),(20794364,12681,'./arorderitemcustlst.php'),(20794438,14659,'./arorderlist.php'),(20794527,1709,'./arorderlist_backorder.php'),(20794526,6040,'./arorderlist_backorder.php'),(20794525,19433,'./arorderlist_backorder.php'),(20794524,19432,'./arorderlist_backorder.php'),(20794523,4106,'./arorderlist_backorder.php'),(20794522,5491,'./arorderlist_backorder.php'),(20794572,315,'./arorderlist_sum.php'),(20794571,19437,'./arorderlist_sum.php'),(20794570,12154,'./arorderlist_sum.php'),(20794569,197,'./arorderlist_sum.php'),(20795011,6246,'./arordpicktickfpdf.php'),(20795010,8185,'./arordpicktickfpdf.php'),(20795087,540,'./arordquotefpdf.php'),(20795086,17407,'./arordquotefpdf.php'),(20795085,306,'./arordquotefpdf.php'),(20795446,325,'./arordshipviewfpdf.php'),(20795445,306,'./arordshipviewfpdf.php'),(20796520,6514,'./autofunctions.php'),(20797030,19440,'./custexportimport.php'),(20797029,315,'./custexportimport.php'),(20801095,21,'./glrepactivity.php'),(20801094,3523,'./glrepactivity.php'),(20802544,14085,'./invcotransfer.php'),(20802648,18280,'./inventory_adjustments.php'),(20803007,14008,'./invitemadd.php'),(20803581,19132,'./invitemlstreorder.php'),(20803756,6165,'./invitemlstusage.php'),(20803755,451,'./invitemlstusage.php'),(20803754,19429,'./invitemlstusage.php'),(20803753,333,'./invitemlstusage.php'),(20803752,315,'./invitemlstusage.php'),(20803751,197,'./invitemlstusage.php'),(20803790,57,'./invitemlstval.php'),(20804177,52,'./invitemupd.php'),(20804370,52,'./invitemupd1.php'),(20804979,315,'./invpotoap.php'),(20805866,17616,'./nporder.php'),(20805494,19447,'./jobupd.php'),(20805493,19446,'./jobupd.php'),(20805865,12681,'./nporder.php'),(20805864,3533,'./nporder.php'),(20805863,8217,'./nporder.php'),(20805862,6202,'./nporder.php'),(20805861,16073,'./nporder.php'),(20805860,17792,'./nporder.php'),(20806455,19446,'./npordersave.php'),(20811514,16154,'./includes/arbankdepositadd.functions.php'),(20811537,8936,'./includes/arbankreconcile.functions.php'),(20811536,6054,'./includes/arbankreconcile.functions.php'),(20811535,11917,'./includes/arbankreconcile.functions.php'),(20811534,10435,'./includes/arbankreconcile.functions.php'),(20811533,5453,'./includes/arbankreconcile.functions.php'),(20811532,869,'./includes/arbankreconcile.functions.php'),(20811531,5839,'./includes/arbankreconcile.functions.php'),(20811530,5890,'./includes/arbankreconcile.functions.php'),(20811529,10253,'./includes/arbankreconcile.functions.php'),(20811528,737,'./includes/arbankreconcile.functions.php'),(20811527,14103,'./includes/arbankreconcile.functions.php'),(20811526,697,'./includes/arbankreconcile.functions.php'),(20811525,6053,'./includes/arbankreconcile.functions.php'),(20811524,9492,'./includes/arbankreconcile.functions.php'),(20811523,14102,'./includes/arbankreconcile.functions.php'),(20811522,5902,'./includes/arbankreconcile.functions.php'),(20811521,479,'./includes/arbankreconcile.functions.php'),(20811520,3457,'./includes/arbankreconcile.functions.php'),(20811519,6048,'./includes/arbankreconcile.functions.php'),(20811518,226,'./includes/arbankreconcile.functions.php'),(20811517,5883,'./includes/arbankreconcile.functions.php'),(20811569,12739,'./includes/arfunctions.php'),(20811568,176,'./includes/arfunctions.php'),(20811567,19447,'./includes/arfunctions.php'),(20811566,19446,'./includes/arfunctions.php'),(20811565,59,'./includes/arfunctions.php'),(20811564,3908,'./includes/arfunctions.php'),(20811563,14689,'./includes/arfunctions.php'),(20812072,1743,'./includes/arordconfirmfpdf.functions.php'),(20812071,9622,'./includes/arordconfirmfpdf.functions.php'),(20812070,5081,'./includes/arordconfirmfpdf.functions.php'),(20812069,6247,'./includes/arordconfirmfpdf.functions.php'),(20812068,1668,'./includes/arordconfirmfpdf.functions.php'),(20812067,1647,'./includes/arordconfirmfpdf.functions.php'),(20812066,1373,'./includes/arordconfirmfpdf.functions.php'),(20812065,8941,'./includes/arordconfirmfpdf.functions.php'),(20812064,981,'./includes/arordconfirmfpdf.functions.php'),(20812063,744,'./includes/arordconfirmfpdf.functions.php'),(20812062,719,'./includes/arordconfirmfpdf.functions.php'),(20812061,8730,'./includes/arordconfirmfpdf.functions.php'),(20812060,6228,'./includes/arordconfirmfpdf.functions.php'),(20812059,9492,'./includes/arordconfirmfpdf.functions.php'),(20812105,15905,'./includes/arstateviewfpdf.functions.php'),(20812104,15904,'./includes/arstateviewfpdf.functions.php'),(20812103,6840,'./includes/arstateviewfpdf.functions.php'),(20812102,1625,'./includes/arstateviewfpdf.functions.php'),(20812101,13290,'./includes/arstateviewfpdf.functions.php'),(20812100,1373,'./includes/arstateviewfpdf.functions.php'),(20812099,8936,'./includes/arstateviewfpdf.functions.php'),(20812098,931,'./includes/arstateviewfpdf.functions.php'),(20812097,886,'./includes/arstateviewfpdf.functions.php'),(20812096,4973,'./includes/arstateviewfpdf.functions.php'),(20812095,737,'./includes/arstateviewfpdf.functions.php'),(20812094,719,'./includes/arstateviewfpdf.functions.php'),(20812093,683,'./includes/arstateviewfpdf.functions.php'),(20812092,17789,'./includes/arstateviewfpdf.functions.php'),(20812091,445,'./includes/arstateviewfpdf.functions.php'),(20812090,6251,'./includes/arstateviewfpdf.functions.php'),(20812089,306,'./includes/arstateviewfpdf.functions.php'),(20812128,4025,'./includes/auth.functions.php'),(20812127,8511,'./includes/auth.functions.php'),(20812126,8936,'./includes/auth.functions.php'),(20812125,657,'./includes/auth.functions.php'),(20812124,16278,'./includes/auth.functions.php'),(20812138,15991,'./includes/auto_complete_field_check.php'),(20812137,9492,'./includes/auto_complete_field_check.php'),(20812154,13536,'./includes/autoupdate.php'),(20812153,13535,'./includes/autoupdate.php'),(20812152,13532,'./includes/autoupdate.php'),(20812151,13531,'./includes/autoupdate.php'),(20812150,13530,'./includes/autoupdate.php'),(20812149,13527,'./includes/autoupdate.php'),(20812148,13526,'./includes/autoupdate.php'),(20812147,13525,'./includes/autoupdate.php'),(20812146,13524,'./includes/autoupdate.php'),(20812145,13523,'./includes/autoupdate.php'),(20812144,13522,'./includes/autoupdate.php'),(20812143,15350,'./includes/autoupdate.php'),(20812142,13521,'./includes/autoupdate.php'),(20812141,13520,'./includes/autoupdate.php'),(20812185,7103,'./includes/ccpayment.php'),(20812184,7102,'./includes/ccpayment.php'),(20812183,5430,'./includes/ccpayment.php'),(20812182,315,'./includes/ccpayment.php'),(20812181,7101,'./includes/ccpayment.php'),(20812180,8125,'./includes/ccpayment.php'),(20812179,5095,'./includes/ccpayment.php'),(20812178,39,'./includes/ccpayment.php'),(20812177,7100,'./includes/ccpayment.php'),(20812176,28,'./includes/ccpayment.php'),(20812175,26,'./includes/ccpayment.php'),(20812226,6307,'./includes/ccpayment_factory.php'),(20812225,581,'./includes/ccpayment_factory.php'),(20812224,14076,'./includes/ccpayment_factory.php'),(20812223,14075,'./includes/ccpayment_factory.php'),(20812222,14074,'./includes/ccpayment_factory.php'),(20812221,14073,'./includes/ccpayment_factory.php'),(20812220,14072,'./includes/ccpayment_factory.php'),(20812219,5725,'./includes/ccpayment_factory.php'),(20812218,6697,'./includes/ccpayment_factory.php'),(20812217,7120,'./includes/ccpayment_factory.php'),(20812216,7119,'./includes/ccpayment_factory.php'),(20812215,7118,'./includes/ccpayment_factory.php'),(20812214,7117,'./includes/ccpayment_factory.php'),(20812213,7116,'./includes/ccpayment_factory.php'),(20812212,9380,'./includes/ccpayment_factory.php'),(20812211,9379,'./includes/ccpayment_factory.php'),(20812210,9378,'./includes/ccpayment_factory.php'),(20812209,9377,'./includes/ccpayment_factory.php'),(20812208,5430,'./includes/ccpayment_factory.php'),(20812207,7115,'./includes/ccpayment_factory.php'),(20812206,7114,'./includes/ccpayment_factory.php'),(20812205,7113,'./includes/ccpayment_factory.php'),(20812204,6743,'./includes/ccpayment_factory.php'),(20812203,14071,'./includes/ccpayment_factory.php'),(20812202,226,'./includes/ccpayment_factory.php'),(20812201,7112,'./includes/ccpayment_factory.php'),(20812200,28,'./includes/ccpayment_factory.php'),(20812199,20,'./includes/ccpayment_factory.php'),(20812275,6203,'./includes/contactinfo.php'),(20812274,11843,'./includes/contactinfo.php'),(20812273,542,'./includes/contactinfo.php'),(20812272,524,'./includes/contactinfo.php'),(20812271,15922,'./includes/contactinfo.php'),(20813455,15743,'./includes/dbupdateextra.php'),(20813452,3882,'./includes/dbupdateextra.php'),(20813453,7949,'./includes/dbupdateextra.php'),(20813454,3402,'./includes/dbupdateextra.php'),(20813470,3361,'./includes/estquotefunctions.php'),(20813469,3148,'./includes/estquotefunctions.php'),(20813468,2974,'./includes/estquotefunctions.php'),(20813467,2962,'./includes/estquotefunctions.php'),(20813466,2957,'./includes/estquotefunctions.php'),(20813465,2952,'./includes/estquotefunctions.php'),(20813464,2904,'./includes/estquotefunctions.php'),(20813463,2119,'./includes/estquotefunctions.php'),(20813462,4041,'./includes/estquotefunctions.php'),(20813461,1316,'./includes/estquotefunctions.php'),(20813460,1122,'./includes/estquotefunctions.php'),(20813459,649,'./includes/estquotefunctions.php'),(20813458,5570,'./includes/estquotefunctions.php'),(20813457,12805,'./includes/estquotefunctions.php'),(20813472,15239,'./includes/feature_exp_notice.php'),(20813471,541,'./includes/feature_exp_notice.php'),(20813491,5329,'./includes/featurepurchase.functions.php'),(20813490,15291,'./includes/featurepurchase.functions.php'),(20813489,15299,'./includes/featurepurchase.functions.php'),(20813488,15245,'./includes/featurepurchase.functions.php'),(20813487,11981,'./includes/featurepurchase.functions.php'),(20813486,12056,'./includes/featurepurchase.functions.php'),(20813485,15297,'./includes/featurepurchase.functions.php'),(20813484,3467,'./includes/featurepurchase.functions.php'),(20813483,4973,'./includes/featurepurchase.functions.php'),(20813482,749,'./includes/featurepurchase.functions.php'),(20813481,3458,'./includes/featurepurchase.functions.php'),(20813480,13523,'./includes/featurepurchase.functions.php'),(20813479,15244,'./includes/featurepurchase.functions.php'),(20813478,450,'./includes/featurepurchase.functions.php'),(20813477,416,'./includes/featurepurchase.functions.php'),(20813476,12050,'./includes/featurepurchase.functions.php'),(20813509,4871,'./includes/filesystemdb.php'),(20813617,15533,'./includes/footer.php'),(20813616,17866,'./includes/footer.php'),(20813615,1354,'./includes/footer.php'),(20813614,17865,'./includes/footer.php'),(20813613,981,'./includes/footer.php'),(20813612,15529,'./includes/footer.php'),(20813611,15528,'./includes/footer.php'),(20813610,13480,'./includes/footer.php'),(20813609,15527,'./includes/footer.php'),(20813608,15526,'./includes/footer.php'),(20813607,12642,'./includes/footer.php'),(20813606,541,'./includes/footer.php'),(20813605,533,'./includes/footer.php'),(20813604,17864,'./includes/footer.php'),(20813603,17863,'./includes/footer.php'),(20813602,17862,'./includes/footer.php'),(20813601,17861,'./includes/footer.php'),(20813600,13790,'./includes/footer.php'),(20813638,14624,'./includes/form_validator_js.php'),(20813637,14623,'./includes/form_validator_js.php'),(20813636,14584,'./includes/form_validator_js.php'),(20813833,1935,'./includes/functions.php'),(20813832,1933,'./includes/functions.php'),(20813831,9908,'./includes/functions.php'),(20813830,13992,'./includes/functions.php'),(20813829,9046,'./includes/functions.php'),(20813828,9045,'./includes/functions.php'),(20813827,9044,'./includes/functions.php'),(20813826,9043,'./includes/functions.php'),(20813825,9042,'./includes/functions.php'),(20813824,9041,'./includes/functions.php'),(20813823,9040,'./includes/functions.php'),(20813822,9039,'./includes/functions.php'),(20813821,9038,'./includes/functions.php'),(20813820,9037,'./includes/functions.php'),(20813819,9036,'./includes/functions.php'),(20813818,9035,'./includes/functions.php'),(20813817,10946,'./includes/functions.php'),(20813816,9088,'./includes/functions.php'),(20813815,5304,'./includes/functions.php'),(20813814,1913,'./includes/functions.php'),(20813813,10386,'./includes/functions.php'),(20813812,6479,'./includes/functions.php'),(20813811,1887,'./includes/functions.php'),(20813810,1879,'./includes/functions.php'),(20813809,1871,'./includes/functions.php'),(20813808,1821,'./includes/functions.php'),(20813807,6130,'./includes/functions.php'),(20813806,4017,'./includes/functions.php'),(20813805,1781,'./includes/functions.php'),(20813804,16264,'./includes/functions.php'),(20813803,6523,'./includes/functions.php'),(20813802,15319,'./includes/functions.php'),(20813801,8690,'./includes/functions.php'),(20813800,1770,'./includes/functions.php'),(20813799,3672,'./includes/functions.php'),(20813798,10923,'./includes/functions.php'),(20813797,9011,'./includes/functions.php'),(20813796,1749,'./includes/functions.php'),(20813795,1747,'./includes/functions.php'),(20813794,1743,'./includes/functions.php'),(20813793,9622,'./includes/functions.php'),(20813792,1741,'./includes/functions.php'),(20813791,1709,'./includes/functions.php'),(20813790,1594,'./includes/functions.php'),(20813789,1593,'./includes/functions.php'),(20813788,9408,'./includes/functions.php'),(20813787,1692,'./includes/functions.php'),(20813786,9369,'./includes/functions.php'),(20813785,1678,'./includes/functions.php'),(20813784,9248,'./includes/functions.php'),(20813783,11564,'./includes/functions.php'),(20813782,11563,'./includes/functions.php'),(20813781,13972,'./includes/functions.php'),(20813780,11562,'./includes/functions.php'),(20813779,15927,'./includes/functions.php'),(20813778,1668,'./includes/functions.php'),(20813777,1647,'./includes/functions.php'),(20813776,1639,'./includes/functions.php'),(20813775,1622,'./includes/functions.php'),(20813774,1591,'./includes/functions.php'),(20813773,15937,'./includes/functions.php'),(20813772,1577,'./includes/functions.php'),(20813771,1575,'./includes/functions.php'),(20813770,8256,'./includes/functions.php'),(20813769,8255,'./includes/functions.php'),(20813768,1559,'./includes/functions.php'),(20813767,1546,'./includes/functions.php'),(20813766,1544,'./includes/functions.php'),(20813765,1543,'./includes/functions.php'),(20813764,17745,'./includes/functions.php'),(20813763,1519,'./includes/functions.php'),(20813762,15926,'./includes/functions.php'),(20813761,1482,'./includes/functions.php'),(20813760,1467,'./includes/functions.php'),(20813759,1462,'./includes/functions.php'),(20813758,1461,'./includes/functions.php'),(20813757,16894,'./includes/functions.php'),(20813756,1458,'./includes/functions.php'),(20813755,1446,'./includes/functions.php'),(20813754,1441,'./includes/functions.php'),(20813753,1440,'./includes/functions.php'),(20813752,14402,'./includes/functions.php'),(20813751,14401,'./includes/functions.php'),(20813750,1401,'./includes/functions.php'),(20813749,1400,'./includes/functions.php'),(20813748,1375,'./includes/functions.php'),(20813747,8227,'./includes/functions.php'),(20813746,11049,'./includes/functions.php'),(20813745,11048,'./includes/functions.php'),(20813744,8970,'./includes/functions.php'),(20813743,8969,'./includes/functions.php'),(20813742,1370,'./includes/functions.php'),(20813741,1339,'./includes/functions.php'),(20813740,8296,'./includes/functions.php'),(20813739,8968,'./includes/functions.php'),(20813738,8936,'./includes/functions.php'),(20813737,8295,'./includes/functions.php'),(20813736,8226,'./includes/functions.php'),(20813735,16263,'./includes/functions.php'),(20813734,9240,'./includes/functions.php'),(20813733,8967,'./includes/functions.php'),(20813732,3465,'./includes/functions.php'),(20813731,9224,'./includes/functions.php'),(20813730,980,'./includes/functions.php'),(20813729,979,'./includes/functions.php'),(20813728,978,'./includes/functions.php'),(20813727,977,'./includes/functions.php'),(20813726,7877,'./includes/functions.php'),(20813725,7971,'./includes/functions.php'),(20813724,928,'./includes/functions.php'),(20813723,927,'./includes/functions.php'),(20813722,5454,'./includes/functions.php'),(20813721,8966,'./includes/functions.php'),(20813720,869,'./includes/functions.php'),(20813719,7105,'./includes/functions.php'),(20813718,9830,'./includes/functions.php'),(20813717,8062,'./includes/functions.php'),(20813716,778,'./includes/functions.php'),(20813715,4973,'./includes/functions.php'),(20813714,749,'./includes/functions.php'),(20813713,15936,'./includes/functions.php'),(20813712,5299,'./includes/functions.php'),(20813711,5477,'./includes/functions.php'),(20813710,4481,'./includes/functions.php'),(20813709,13971,'./includes/functions.php'),(20813708,13939,'./includes/functions.php'),(20813707,13970,'./includes/functions.php'),(20813706,704,'./includes/functions.php'),(20813705,6228,'./includes/functions.php'),(20813704,5231,'./includes/functions.php'),(20813703,697,'./includes/functions.php'),(20813702,17868,'./includes/functions.php'),(20813701,673,'./includes/functions.php'),(20813700,9368,'./includes/functions.php'),(20813699,16681,'./includes/functions.php'),(20813698,8965,'./includes/functions.php'),(20813697,641,'./includes/functions.php'),(20813696,616,'./includes/functions.php'),(20813695,15935,'./includes/functions.php'),(20813694,15915,'./includes/functions.php'),(20813693,607,'./includes/functions.php'),(20813692,605,'./includes/functions.php'),(20813691,14137,'./includes/functions.php'),(20813690,595,'./includes/functions.php'),(20813689,596,'./includes/functions.php'),(20813688,13969,'./includes/functions.php'),(20813687,573,'./includes/functions.php'),(20813686,20167,'./includes/functions.php'),(20813685,5864,'./includes/functions.php'),(20813684,11355,'./includes/functions.php'),(20813683,5382,'./includes/functions.php'),(20813682,6165,'./includes/functions.php'),(20813681,503,'./includes/functions.php'),(20813680,479,'./includes/functions.php'),(20813679,470,'./includes/functions.php'),(20813678,13861,'./includes/functions.php'),(20813677,465,'./includes/functions.php'),(20813676,445,'./includes/functions.php'),(20813675,15694,'./includes/functions.php'),(20813674,13561,'./includes/functions.php'),(20813673,12961,'./includes/functions.php'),(20813672,14400,'./includes/functions.php'),(20813671,9087,'./includes/functions.php'),(20813670,12691,'./includes/functions.php'),(20813669,357,'./includes/functions.php'),(20813668,3544,'./includes/functions.php'),(20813667,315,'./includes/functions.php'),(20813666,16262,'./includes/functions.php'),(20813665,9829,'./includes/functions.php'),(20813664,308,'./includes/functions.php'),(20813663,15925,'./includes/functions.php'),(20813662,275,'./includes/functions.php'),(20813661,9842,'./includes/functions.php'),(20813660,5570,'./includes/functions.php'),(20813659,250,'./includes/functions.php'),(20813658,232,'./includes/functions.php'),(20813657,6682,'./includes/functions.php'),(20813656,15351,'./includes/functions.php'),(20813655,9601,'./includes/functions.php'),(20813654,7409,'./includes/functions.php'),(20813653,8254,'./includes/functions.php'),(20813652,110,'./includes/functions.php'),(20813651,16245,'./includes/functions.php'),(20813650,8674,'./includes/functions.php'),(20813649,55,'./includes/functions.php'),(20813648,9828,'./includes/functions.php'),(20813647,15924,'./includes/functions.php'),(20813646,42,'./includes/functions.php'),(20813645,40,'./includes/functions.php'),(20814422,9903,'./includes/googlebase.php'),(20814438,1963,'./includes/header.php'),(20814437,18974,'./includes/header.php'),(20814436,17775,'./includes/header.php'),(20814435,17774,'./includes/header.php'),(20814434,13334,'./includes/header.php'),(20814433,1776,'./includes/header.php'),(20814432,15310,'./includes/header.php'),(20814431,16379,'./includes/header.php'),(20814430,16385,'./includes/header.php'),(20814429,541,'./includes/header.php'),(20814428,17773,'./includes/header.php'),(20814427,13478,'./includes/header.php'),(20814426,315,'./includes/header.php'),(20814425,14262,'./includes/header.php'),(20814424,197,'./includes/header.php'),(20814423,3520,'./includes/header.php'),(20814480,1633,'./includes/initial_setup.php'),(20814479,1685,'./includes/initial_setup.php'),(20814478,1647,'./includes/initial_setup.php'),(20814477,1609,'./includes/initial_setup.php'),(20814476,5073,'./includes/initial_setup.php'),(20814475,1604,'./includes/initial_setup.php'),(20814474,1531,'./includes/initial_setup.php'),(20814473,1523,'./includes/initial_setup.php'),(20814472,1432,'./includes/initial_setup.php'),(20814471,1346,'./includes/initial_setup.php'),(20814470,779,'./includes/initial_setup.php'),(20814469,565,'./includes/initial_setup.php'),(20814468,591,'./includes/initial_setup.php'),(20814467,3900,'./includes/initial_setup.php'),(20814466,523,'./includes/initial_setup.php'),(20814465,481,'./includes/initial_setup.php'),(20814464,3519,'./includes/initial_setup.php'),(20814463,350,'./includes/initial_setup.php'),(20814462,215,'./includes/initial_setup.php'),(20814461,208,'./includes/initial_setup.php'),(20814460,206,'./includes/initial_setup.php'),(20814459,201,'./includes/initial_setup.php'),(20814458,199,'./includes/initial_setup.php'),(20814457,196,'./includes/initial_setup.php'),(20814456,32,'./includes/initial_setup.php'),(20814455,41,'./includes/initial_setup.php'),(20814509,8936,'./includes/invcotransfer.functions.php'),(20814508,566,'./includes/invcotransfer.functions.php'),(20814532,315,'./includes/invfunctions.php'),(20814531,13988,'./includes/invfunctions.php'),(20814530,13987,'./includes/invfunctions.php'),(20814529,309,'./includes/invfunctions.php'),(20814528,306,'./includes/invfunctions.php'),(20814527,3955,'./includes/invfunctions.php'),(20814526,226,'./includes/invfunctions.php'),(20814525,18707,'./includes/invfunctions.php'),(20814524,20250,'./includes/invfunctions.php'),(20814812,20176,'./includes/invoicesoldshipformat.php'),(20814811,1743,'./includes/invoicesoldshipformat.php'),(20814810,20175,'./includes/invoicesoldshipformat.php'),(20814809,9622,'./includes/invoicesoldshipformat.php'),(20814808,5081,'./includes/invoicesoldshipformat.php'),(20814807,14784,'./includes/invoicesoldshipformat.php'),(20814806,1429,'./includes/invoicesoldshipformat.php'),(20814805,1381,'./includes/invoicesoldshipformat.php'),(20814804,14783,'./includes/invoicesoldshipformat.php'),(20814803,988,'./includes/invoicesoldshipformat.php'),(20814802,14782,'./includes/invoicesoldshipformat.php'),(20814801,984,'./includes/invoicesoldshipformat.php'),(20814800,18306,'./includes/invoicesoldshipformat.php'),(20814799,6228,'./includes/invoicesoldshipformat.php'),(20814798,659,'./includes/invoicesoldshipformat.php'),(20814797,605,'./includes/invoicesoldshipformat.php'),(20814796,573,'./includes/invoicesoldshipformat.php'),(20814795,5536,'./includes/invoicesoldshipformat.php'),(20814794,524,'./includes/invoicesoldshipformat.php'),(20814793,306,'./includes/invoicesoldshipformat.php'),(20814792,8676,'./includes/invoicesoldshipformat.php'),(20814916,15353,'./includes/mailclass.php'),(20814915,1560,'./includes/mailclass.php'),(20814914,18043,'./includes/mailclass.php'),(20814913,982,'./includes/mailclass.php'),(20814912,18042,'./includes/mailclass.php'),(20814911,15860,'./includes/mailclass.php'),(20814910,15859,'./includes/mailclass.php'),(20814909,11210,'./includes/mailclass.php'),(20814908,18713,'./includes/mailclass.php'),(20814907,18041,'./includes/mailclass.php'),(20814951,8117,'./includes/npnote.php'),(20814950,2099,'./includes/npnote.php'),(20814949,6125,'./includes/npnote.php'),(20814948,8116,'./includes/npnote.php'),(20814947,8258,'./includes/npnote.php'),(20814946,941,'./includes/npnote.php'),(20814945,799,'./includes/npnote.php'),(20814944,737,'./includes/npnote.php'),(20814943,3930,'./includes/npnote.php'),(20814942,15933,'./includes/npnote.php'),(20814941,542,'./includes/npnote.php'),(20814940,451,'./includes/npnote.php'),(20815104,16283,'./includes/reportcachenav.php'),(20815103,2223,'./includes/reportcachenav.php'),(20815260,8936,'./includes/usaepaycd.php'),(20815259,1047,'./includes/usaepaycd.php'),(20815258,799,'./includes/usaepaycd.php'),(20815257,8125,'./includes/usaepaycd.php'),(20815267,8936,'./includes/usaepayeft.php'),(20815266,1047,'./includes/usaepayeft.php'),(20815272,20256,'./includes/wizard.php'),(20815271,13991,'./includes/wizard.php'),(20815270,8511,'./includes/wizard.php'),(20815295,2052,'./includes/classes/nptax.php'),(20815294,1348,'./includes/classes/nptax.php'),(20815299,4046,'./includes/home/index.php'),(20815303,14510,'./includes/home/index_common.php'),(20815302,17220,'./includes/home/index_common.php'),(20815312,2200,'./includes/home/np5_tabs.php'),(20815311,3672,'./includes/home/np5_tabs.php'),(20815310,1639,'./includes/home/np5_tabs.php'),(20815309,1559,'./includes/home/np5_tabs.php'),(20815308,1546,'./includes/home/np5_tabs.php'),(20815307,11903,'./includes/home/np5_tabs.php'),(20815306,10508,'./includes/home/np5_tabs.php'),(20815325,4040,'./includes/home/billing/aging_summary.php'),(20815324,4039,'./includes/home/billing/aging_summary.php'),(20815323,4037,'./includes/home/billing/aging_summary.php'),(20815331,14707,'./includes/home/billing/arinvoice_volume_12month.php'),(20815330,14706,'./includes/home/billing/arinvoice_volume_12month.php'),(20815329,226,'./includes/home/billing/arinvoice_volume_12month.php'),(20815367,4935,'./includes/home/billing/half_menu.php'),(20815366,4938,'./includes/home/billing/half_menu.php'),(20815365,7508,'./includes/home/billing/half_menu.php'),(20815390,4950,'./includes/home/billing/most_overdue.php'),(20815389,697,'./includes/home/billing/most_overdue.php'),(20781800,19929,'./!/application/controllers/itemlocation.php'),(20815395,697,'./includes/home/billing/overcredit_customers.php'),(20815394,675,'./includes/home/billing/overcredit_customers.php'),(20815415,697,'./includes/home/billing/recent_customers.php'),(20815414,7508,'./includes/home/billing/recent_customers.php'),(20779024,4192,'./!/application/controllers/arinvoice.php'),(20815433,4129,'./includes/home/billing/recent_sales_actions.php'),(20815432,47,'./includes/home/billing/recent_sales_actions.php'),(20815505,4524,'./includes/home/inventory/defines.php'),(20815504,4523,'./includes/home/inventory/defines.php'),(20815503,14717,'./includes/home/inventory/defines.php'),(20815502,4535,'./includes/home/inventory/defines.php'),(20815501,4381,'./includes/home/inventory/defines.php'),(20815500,10528,'./includes/home/inventory/defines.php'),(20815499,10527,'./includes/home/inventory/defines.php'),(20815498,14716,'./includes/home/inventory/defines.php'),(20815497,14715,'./includes/home/inventory/defines.php'),(20815496,14714,'./includes/home/inventory/defines.php'),(20815540,3358,'./includes/home/inventory/inventory_category_usage_common.php'),(20815532,4529,'./includes/home/inventory/inventory_category_usage_common.php'),(20815531,4973,'./includes/home/inventory/inventory_category_usage_common.php'),(20815530,12038,'./includes/home/inventory/inventory_category_usage_common.php'),(20815529,451,'./includes/home/inventory/inventory_category_usage_common.php'),(20815545,1788,'./includes/home/inventory/items_below_reorder.php'),(20815544,4381,'./includes/home/inventory/items_below_reorder.php'),(20815543,1709,'./includes/home/inventory/items_below_reorder.php'),(20815542,6314,'./includes/home/inventory/items_below_reorder.php'),(20815561,4539,'./includes/home/inventory/pending_build_order.php'),(20815560,1709,'./includes/home/inventory/pending_build_order.php'),(20815559,1647,'./includes/home/inventory/pending_build_order.php'),(20815558,4538,'./includes/home/inventory/pending_build_order.php'),(20815569,4524,'./includes/home/inventory/pending_po.php'),(20815568,4542,'./includes/home/inventory/pending_po.php'),(20815567,932,'./includes/home/inventory/pending_po.php'),(20815566,226,'./includes/home/inventory/pending_po.php'),(20695796,1347,'./includes/home/inventory/pending_sales_overview.php'),(20695795,4083,'./includes/home/inventory/pending_sales_overview.php'),(20695794,697,'./includes/home/inventory/pending_sales_overview.php'),(20695793,451,'./includes/home/inventory/pending_sales_overview.php'),(20815577,1713,'./includes/home/inventory/profitability_items_common.php'),(20815576,4130,'./includes/home/inventory/profitability_items_common.php'),(20815575,4973,'./includes/home/inventory/profitability_items_common.php'),(20815574,4192,'./includes/home/inventory/profitability_items_common.php'),(20815597,2508,'./includes/home/inventory/receipts_without_po.php'),(20815596,2043,'./includes/home/inventory/receipts_without_po.php'),(20815595,1709,'./includes/home/inventory/receipts_without_po.php'),(20815594,14725,'./includes/home/inventory/receipts_without_po.php'),(20815632,14719,'./includes/home/inventory/twothirds_menu.php'),(20815631,7222,'./includes/home/inventory/twothirds_menu.php'),(20815630,14722,'./includes/home/inventory/twothirds_menu.php'),(20815640,16674,'./includes/home/inventory/welcome.php'),(20815639,4552,'./includes/home/inventory/welcome.php'),(20815638,4551,'./includes/home/inventory/welcome.php'),(20815646,10527,'./includes/home/inventory/whole_menu.php'),(20815645,14716,'./includes/home/inventory/whole_menu.php'),(20815652,14727,'./includes/home/ledger/bar_profit_12month.php'),(20815651,13054,'./includes/home/ledger/bar_profit_12month.php'),(20815650,1353,'./includes/home/ledger/bar_profit_12month.php'),(20815649,4963,'./includes/home/ledger/bar_profit_12month.php'),(20815687,7222,'./includes/home/ledger/half_menu.php'),(20815686,5971,'./includes/home/ledger/half_menu.php'),(20815694,14728,'./includes/home/ledger/recent_journal.php'),(20815693,869,'./includes/home/ledger/recent_journal.php'),(20815692,737,'./includes/home/ledger/recent_journal.php'),(20815691,226,'./includes/home/ledger/recent_journal.php'),(20815703,2315,'./includes/home/ledger/sales_12month.php'),(20815702,1993,'./includes/home/ledger/sales_12month.php'),(20815701,869,'./includes/home/ledger/sales_12month.php'),(20815700,20,'./includes/home/ledger/sales_12month.php'),(20815711,1993,'./includes/home/ledger/sales_7day.php'),(20815710,869,'./includes/home/ledger/sales_7day.php'),(20815709,749,'./includes/home/ledger/sales_7day.php'),(20815708,20,'./includes/home/ledger/sales_7day.php'),(20815724,5025,'./includes/home/ledger/twothirds_menu.php'),(20815728,7222,'./includes/home/ledger/whole_menu.php'),(20815735,2034,'./includes/home/orders/arorder_volume_12month.php'),(20815734,1913,'./includes/home/orders/arorder_volume_12month.php'),(20815733,4165,'./includes/home/orders/arorder_volume_12month.php'),(20815732,4162,'./includes/home/orders/arorder_volume_12month.php'),(20815731,226,'./includes/home/orders/arorder_volume_12month.php'),(20815792,14734,'./includes/home/orders/half_menu.php'),(20815791,5672,'./includes/home/orders/half_menu.php'),(20815790,7222,'./includes/home/orders/half_menu.php'),(20815809,4052,'./includes/home/orders/open_orders_due_dates.php'),(20815807,932,'./includes/home/orders/open_orders_due_dates.php'),(20815806,697,'./includes/home/orders/open_orders_due_dates.php'),(20815805,596,'./includes/home/orders/open_orders_due_dates.php'),(20815838,939,'./includes/home/orders/performance_statistics_common.php'),(20815837,226,'./includes/home/orders/performance_statistics_common.php'),(20815846,697,'./includes/home/orders/profitability_customers_month.php'),(20815845,4192,'./includes/home/orders/profitability_customers_month.php'),(20815877,2404,'./includes/home/orders/recently_shipped_items.php'),(20815876,2165,'./includes/home/orders/recently_shipped_items.php'),(20815875,2008,'./includes/home/orders/recently_shipped_items.php'),(20815874,1696,'./includes/home/orders/recently_shipped_items.php'),(20797155,3176,'./customcommissions.php'),(20815893,5664,'./includes/home/orders/service_order_workers_on_jobs.php'),(20815892,2103,'./includes/home/orders/service_order_workers_on_jobs.php'),(20815891,5612,'./includes/home/orders/service_order_workers_on_jobs.php'),(20815903,1913,'./includes/home/orders/topdollar_customers_common.php'),(20815902,4973,'./includes/home/orders/topdollar_customers_common.php'),(20815901,697,'./includes/home/orders/topdollar_customers_common.php'),(20815915,4184,'./includes/home/orders/twothirds_menu.php'),(20815914,9301,'./includes/home/orders/twothirds_menu.php'),(20815913,14739,'./includes/home/orders/twothirds_menu.php'),(20815912,4155,'./includes/home/orders/twothirds_menu.php'),(20815911,7222,'./includes/home/orders/twothirds_menu.php'),(20815910,5668,'./includes/home/orders/twothirds_menu.php'),(20815937,4181,'./includes/home/orders/whole_menu.php'),(20815936,14732,'./includes/home/orders/whole_menu.php'),(20815935,14733,'./includes/home/orders/whole_menu.php'),(20815934,7222,'./includes/home/orders/whole_menu.php'),(20696175,4040,'./includes/home/payables/ap_aging_summary.php'),(20696174,4039,'./includes/home/payables/ap_aging_summary.php'),(20696173,4037,'./includes/home/payables/ap_aging_summary.php'),(20815946,1668,'./includes/home/payables/bills_due_dates.php'),(20815945,932,'./includes/home/payables/bills_due_dates.php'),(20815944,4956,'./includes/home/payables/bills_due_dates.php'),(20815943,4955,'./includes/home/payables/bills_due_dates.php'),(20815942,325,'./includes/home/payables/bills_due_dates.php'),(20815955,1913,'./includes/home/payables/bills_volume_12month.php'),(20815954,4940,'./includes/home/payables/bills_volume_12month.php'),(20815953,14741,'./includes/home/payables/bills_volume_12month.php'),(20815952,226,'./includes/home/payables/bills_volume_12month.php'),(20815988,4978,'./includes/home/payables/defines.php'),(20815987,4969,'./includes/home/payables/defines.php'),(20815986,4968,'./includes/home/payables/defines.php'),(20815985,4966,'./includes/home/payables/defines.php'),(20815984,4965,'./includes/home/payables/defines.php'),(20815983,14741,'./includes/home/payables/defines.php'),(20815982,14742,'./includes/home/payables/defines.php'),(20815981,4964,'./includes/home/payables/defines.php'),(20815980,5242,'./includes/home/payables/defines.php'),(20816020,2363,'./includes/home/payables/pending_po_item.php'),(20816019,4978,'./includes/home/payables/pending_po_item.php'),(20816018,2165,'./includes/home/payables/pending_po_item.php'),(20816017,4977,'./includes/home/payables/pending_po_item.php'),(20816016,1696,'./includes/home/payables/pending_po_item.php'),(20816015,932,'./includes/home/payables/pending_po_item.php'),(20816029,1668,'./includes/home/payables/recent_bills.php'),(20816028,932,'./includes/home/payables/recent_bills.php'),(20816027,226,'./includes/home/payables/recent_bills.php'),(20816039,4081,'./includes/home/payables/recent_checks_common.php'),(20816038,1913,'./includes/home/payables/recent_checks_common.php'),(20816037,4973,'./includes/home/payables/recent_checks_common.php'),(20816036,491,'./includes/home/payables/recent_checks_common.php'),(20816035,484,'./includes/home/payables/recent_checks_common.php'),(20816034,226,'./includes/home/payables/recent_checks_common.php'),(20816048,2008,'./includes/home/payables/topdollar_vendors_common.php'),(20816047,1913,'./includes/home/payables/topdollar_vendors_common.php'),(20816046,4973,'./includes/home/payables/topdollar_vendors_common.php'),(20816067,4952,'./includes/home/payables/welcome.php'),(20816066,4951,'./includes/home/payables/welcome.php'),(20816077,4988,'./includes/home/payroll/birthdays.php'),(20816076,379,'./includes/home/payroll/birthdays.php'),(20816100,7222,'./includes/home/payroll/half_menu.php'),(20816099,5007,'./includes/home/payroll/half_menu.php'),(20816112,4998,'./includes/home/payroll/payroll_by_month.php'),(20816111,1564,'./includes/home/payroll/payroll_by_month.php'),(20816110,989,'./includes/home/payroll/payroll_by_month.php'),(20816172,4062,'./includes/home/pricelist/defines.php'),(20816171,4055,'./includes/home/pricelist/defines.php'),(20816170,4061,'./includes/home/pricelist/defines.php'),(20816169,4886,'./includes/home/pricelist/defines.php'),(20816168,4879,'./includes/home/pricelist/defines.php'),(20816167,4066,'./includes/home/pricelist/defines.php'),(20816166,4873,'./includes/home/pricelist/defines.php'),(20816165,7519,'./includes/home/pricelist/defines.php'),(20816164,7518,'./includes/home/pricelist/defines.php'),(20816163,7516,'./includes/home/pricelist/defines.php'),(20816162,7513,'./includes/home/pricelist/defines.php'),(20816161,7509,'./includes/home/pricelist/defines.php'),(20816207,7515,'./includes/home/pricelist/obs_quarter.php'),(20816206,7512,'./includes/home/pricelist/obs_quarter.php'),(20816205,4391,'./includes/home/pricelist/obs_quarter.php'),(20816204,7514,'./includes/home/pricelist/obs_quarter.php'),(20816203,387,'./includes/home/pricelist/obs_quarter.php'),(20816238,4897,'./includes/home/pricelist/order_volume_month.php'),(20816236,4391,'./includes/home/pricelist/order_volume_month.php'),(20816235,4903,'./includes/home/pricelist/order_volume_month.php'),(20816234,4169,'./includes/home/pricelist/order_volume_month.php'),(20816323,932,'./includes/home/pricelist/pl_print_orders_pending.php'),(20816322,869,'./includes/home/pricelist/pl_print_orders_pending.php'),(20816321,697,'./includes/home/pricelist/pl_print_orders_pending.php'),(20816334,1358,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816333,932,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816332,4889,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816331,697,'./includes/home/pricelist/pl_print_orders_unconfirmed.php'),(20816365,2165,'./includes/home/pricelist/pl_recently_shipped_orders.php'),(20816364,2034,'./includes/home/pricelist/pl_recently_shipped_orders.php'),(20816374,1939,'./includes/home/pricelist/pl_upcoming_stock_needs.php'),(20816373,1696,'./includes/home/pricelist/pl_upcoming_stock_needs.php'),(20816372,869,'./includes/home/pricelist/pl_upcoming_stock_needs.php'),(20816384,932,'./includes/home/pricelist/print_orders_due_dates.php'),(20816383,869,'./includes/home/pricelist/print_orders_due_dates.php'),(20816382,4065,'./includes/home/pricelist/print_orders_due_dates.php'),(20816381,697,'./includes/home/pricelist/print_orders_due_dates.php'),(20816410,697,'./includes/home/pricelist/profitability_orders_month.php'),(20816409,4192,'./includes/home/pricelist/profitability_orders_month.php'),(20816467,7524,'./includes/home/pricelist/twothirds_menu.php'),(20816466,7523,'./includes/home/pricelist/twothirds_menu.php'),(20816465,7522,'./includes/home/pricelist/twothirds_menu.php'),(20816464,7521,'./includes/home/pricelist/twothirds_menu.php'),(20816463,7222,'./includes/home/pricelist/twothirds_menu.php'),(20816474,4151,'./includes/home/pricelist/welcome.php'),(20816473,4162,'./includes/home/pricelist/welcome.php'),(20816482,4886,'./includes/home/pricelist/whole_menu.php'),(20816481,4908,'./includes/home/pricelist/whole_menu.php'),(20816480,4898,'./includes/home/pricelist/whole_menu.php'),(20816479,4902,'./includes/home/pricelist/whole_menu.php'),(20816478,7222,'./includes/home/pricelist/whole_menu.php'),(20816498,3838,'./includes/home/printing/defines.php'),(20816497,4071,'./includes/home/printing/defines.php'),(20816496,4907,'./includes/home/printing/defines.php'),(20816495,4904,'./includes/home/printing/defines.php'),(20816494,4896,'./includes/home/printing/defines.php'),(20816493,4886,'./includes/home/printing/defines.php'),(20816492,4890,'./includes/home/printing/defines.php'),(20816491,4879,'./includes/home/printing/defines.php'),(20816490,4066,'./includes/home/printing/defines.php'),(20816509,4915,'./includes/home/printing/est_shop_loading.php'),(20816508,1799,'./includes/home/printing/est_shop_loading.php'),(20816507,1564,'./includes/home/printing/est_shop_loading.php'),(20816570,2155,'./includes/home/printing/print_orders_pending.php'),(20816569,2034,'./includes/home/printing/print_orders_pending.php'),(20816568,932,'./includes/home/printing/print_orders_pending.php'),(20816567,869,'./includes/home/printing/print_orders_pending.php'),(20816566,697,'./includes/home/printing/print_orders_pending.php'),(20816579,1358,'./includes/home/printing/print_orders_unconfirmed.php'),(20816578,932,'./includes/home/printing/print_orders_unconfirmed.php'),(20816577,4889,'./includes/home/printing/print_orders_unconfirmed.php'),(20816576,697,'./includes/home/printing/print_orders_unconfirmed.php'),(20816597,697,'./includes/home/printing/profitability_customers_year.php'),(20816596,4192,'./includes/home/printing/profitability_customers_year.php'),(20816648,2165,'./includes/home/printing/recently_shipped_orders.php'),(20816647,2034,'./includes/home/printing/recently_shipped_orders.php'),(20816646,697,'./includes/home/printing/recently_shipped_orders.php'),(20816662,2008,'./includes/home/printing/topdollar_customers_year.php'),(20816661,697,'./includes/home/printing/topdollar_customers_year.php'),(20816676,4074,'./includes/home/printing/upcoming_stock_needs.php'),(20816675,1939,'./includes/home/printing/upcoming_stock_needs.php'),(20816674,1696,'./includes/home/printing/upcoming_stock_needs.php'),(20816673,869,'./includes/home/printing/upcoming_stock_needs.php'),(20816683,4151,'./includes/home/printing/welcome.php'),(20816682,4162,'./includes/home/printing/welcome.php'),(20816697,2315,'./includes/home/printing/won_lost_quotes.php'),(20816696,2292,'./includes/home/printing/won_lost_quotes.php'),(20816695,1913,'./includes/home/printing/won_lost_quotes.php'),(20816694,1795,'./includes/home/printing/won_lost_quotes.php'),(20816715,5045,'./includes/home/scart/defines.php'),(20816714,5136,'./includes/home/scart/defines.php'),(20816713,4063,'./includes/home/scart/defines.php'),(20816712,4062,'./includes/home/scart/defines.php'),(20816711,4055,'./includes/home/scart/defines.php'),(20816710,4061,'./includes/home/scart/defines.php'),(20816709,14751,'./includes/home/scart/defines.php'),(20816708,14732,'./includes/home/scart/defines.php'),(20816707,14733,'./includes/home/scart/defines.php'),(20816706,4052,'./includes/home/scart/defines.php'),(20816705,4155,'./includes/home/scart/defines.php'),(20816704,10527,'./includes/home/scart/defines.php'),(20816703,14716,'./includes/home/scart/defines.php'),(20816756,2008,'./includes/home/scart/products_viewed.php'),(20816755,1709,'./includes/home/scart/products_viewed.php'),(20816754,869,'./includes/home/scart/products_viewed.php'),(20816768,2200,'./includes/home/scart/top_states_year.php'),(20816767,2008,'./includes/home/scart/top_states_year.php'),(20816766,226,'./includes/home/scart/top_states_year.php'),(20816777,14719,'./includes/home/scart/twothirds_menu.php'),(20816776,4185,'./includes/home/scart/twothirds_menu.php'),(20816775,4184,'./includes/home/scart/twothirds_menu.php'),(20816774,14739,'./includes/home/scart/twothirds_menu.php'),(20816773,4155,'./includes/home/scart/twothirds_menu.php'),(20816772,7222,'./includes/home/scart/twothirds_menu.php'),(20816785,4151,'./includes/home/scart/welcome.php'),(20816792,14732,'./includes/home/scart/whole_menu.php'),(20816791,14733,'./includes/home/scart/whole_menu.php'),(20816790,7222,'./includes/home/scart/whole_menu.php'),(20816789,10527,'./includes/home/scart/whole_menu.php'),(20816788,14716,'./includes/home/scart/whole_menu.php'),(20816799,13480,'./includes/htmltopdf/wrapper.php'),(20816798,315,'./includes/htmltopdf/wrapper.php'),(20816837,1559,'./includes/metro/metro_header.php'),(20816841,989,'./includes/metro/metro_search.php'),(20816840,697,'./includes/metro/metro_search.php'),(20816839,8702,'./includes/metro/metro_search.php'),(20816876,799,'./pm/bankaccounts.php'),(20816875,8010,'./pm/bankaccounts.php'),(20816874,14412,'./pm/bankaccounts.php'),(20816873,5439,'./pm/bankaccounts.php'),(20816872,5452,'./pm/bankaccounts.php'),(20816871,14411,'./pm/bankaccounts.php'),(20816870,14410,'./pm/bankaccounts.php'),(20816869,14409,'./pm/bankaccounts.php'),(20816868,5432,'./pm/bankaccounts.php'),(20816867,14408,'./pm/bankaccounts.php'),(20816866,14407,'./pm/bankaccounts.php'),(20816865,14406,'./pm/bankaccounts.php'),(20816864,5402,'./pm/bankaccounts.php'),(20816863,315,'./pm/bankaccounts.php'),(20816862,14921,'./pm/bankaccounts.php'),(20816861,5203,'./pm/bankaccounts.php'),(20816860,14405,'./pm/bankaccounts.php'),(20816859,32,'./pm/bankaccounts.php'),(20816858,14404,'./pm/bankaccounts.php'),(20816857,30,'./pm/bankaccounts.php'),(20816856,20,'./pm/bankaccounts.php'),(20816940,11147,'./pm/creditcards.php'),(20816939,1375,'./pm/creditcards.php'),(20816938,11146,'./pm/creditcards.php'),(20816937,11145,'./pm/creditcards.php'),(20816936,10238,'./pm/creditcards.php'),(20816935,941,'./pm/creditcards.php'),(20816934,799,'./pm/creditcards.php'),(20816933,778,'./pm/creditcards.php'),(20816932,11404,'./pm/creditcards.php'),(20816931,11144,'./pm/creditcards.php'),(20816930,11143,'./pm/creditcards.php'),(20816929,11142,'./pm/creditcards.php'),(20816928,8136,'./pm/creditcards.php'),(20816927,11141,'./pm/creditcards.php'),(20816926,11140,'./pm/creditcards.php'),(20816925,11139,'./pm/creditcards.php'),(20816924,11138,'./pm/creditcards.php'),(20816923,11137,'./pm/creditcards.php'),(20816922,11136,'./pm/creditcards.php'),(20816921,11135,'./pm/creditcards.php'),(20816920,416,'./pm/creditcards.php'),(20816919,9380,'./pm/creditcards.php'),(20816918,9379,'./pm/creditcards.php'),(20816917,9378,'./pm/creditcards.php'),(20816916,9377,'./pm/creditcards.php'),(20816915,315,'./pm/creditcards.php'),(20816914,11570,'./pm/creditcards.php'),(20816913,308,'./pm/creditcards.php'),(20816912,5203,'./pm/creditcards.php'),(20816911,275,'./pm/creditcards.php'),(20816910,11134,'./pm/creditcards.php'),(20816996,1499,'./pm/invoiceextracharges.php'),(20816995,11071,'./pm/invoiceextracharges.php'),(20816994,8936,'./pm/invoiceextracharges.php'),(20816993,11070,'./pm/invoiceextracharges.php'),(20816992,869,'./pm/invoiceextracharges.php'),(20816991,799,'./pm/invoiceextracharges.php'),(20816990,737,'./pm/invoiceextracharges.php'),(20816989,11069,'./pm/invoiceextracharges.php'),(20816988,11068,'./pm/invoiceextracharges.php'),(20816987,11067,'./pm/invoiceextracharges.php'),(20816986,11066,'./pm/invoiceextracharges.php'),(20816985,11054,'./pm/invoiceextracharges.php'),(20816984,11065,'./pm/invoiceextracharges.php'),(20816983,11064,'./pm/invoiceextracharges.php'),(20816982,315,'./pm/invoiceextracharges.php'),(20816981,8125,'./pm/invoiceextracharges.php'),(20816980,11063,'./pm/invoiceextracharges.php'),(20816979,11062,'./pm/invoiceextracharges.php'),(20816978,226,'./pm/invoiceextracharges.php'),(20816977,11061,'./pm/invoiceextracharges.php'),(20816976,11060,'./pm/invoiceextracharges.php'),(20816975,11103,'./pm/invoiceextracharges.php'),(20816974,11059,'./pm/invoiceextracharges.php'),(20816973,11058,'./pm/invoiceextracharges.php'),(20816972,11057,'./pm/invoiceextracharges.php'),(20817032,8936,'./pm/invoiceextrachargespost.php'),(20817031,1014,'./pm/invoiceextrachargespost.php'),(20817030,869,'./pm/invoiceextrachargespost.php'),(20817029,14423,'./pm/invoiceextrachargespost.php'),(20817028,14422,'./pm/invoiceextrachargespost.php'),(20817027,799,'./pm/invoiceextrachargespost.php'),(20817026,737,'./pm/invoiceextrachargespost.php'),(20817025,11084,'./pm/invoiceextrachargespost.php'),(20817024,14421,'./pm/invoiceextrachargespost.php'),(20817023,333,'./pm/invoiceextrachargespost.php'),(20817022,5145,'./pm/invoiceextrachargespost.php'),(20817065,14426,'./pm/invoicenotifications.php'),(20817064,11094,'./pm/invoicenotifications.php'),(20817063,1668,'./pm/invoicenotifications.php'),(20817062,11235,'./pm/invoicenotifications.php'),(20817061,14402,'./pm/invoicenotifications.php'),(20817060,14401,'./pm/invoicenotifications.php'),(20817059,14425,'./pm/invoicenotifications.php'),(20817058,8936,'./pm/invoicenotifications.php'),(20817057,11093,'./pm/invoicenotifications.php'),(20817056,1014,'./pm/invoicenotifications.php'),(20817055,981,'./pm/invoicenotifications.php'),(20817054,932,'./pm/invoicenotifications.php'),(20817053,11192,'./pm/invoicenotifications.php'),(20817052,4364,'./pm/invoicenotifications.php'),(20817051,5583,'./pm/invoicenotifications.php'),(20817050,11092,'./pm/invoicenotifications.php'),(20817049,333,'./pm/invoicenotifications.php'),(20817048,325,'./pm/invoicenotifications.php'),(20817047,315,'./pm/invoicenotifications.php'),(20817046,14424,'./pm/invoicenotifications.php'),(20817045,226,'./pm/invoicenotifications.php'),(20817173,11296,'./pm/makepayment.php'),(20817172,14414,'./pm/makepayment.php'),(20817171,14413,'./pm/makepayment.php'),(20817170,11295,'./pm/makepayment.php'),(20817169,7199,'./pm/makepayment.php'),(20817168,1668,'./pm/makepayment.php'),(20817167,6713,'./pm/makepayment.php'),(20817166,8936,'./pm/makepayment.php'),(20817165,1134,'./pm/makepayment.php'),(20817164,1132,'./pm/makepayment.php'),(20817163,932,'./pm/makepayment.php'),(20817162,4973,'./pm/makepayment.php'),(20817161,8136,'./pm/makepayment.php'),(20817160,673,'./pm/makepayment.php'),(20817159,14412,'./pm/makepayment.php'),(20817158,7120,'./pm/makepayment.php'),(20817157,11294,'./pm/makepayment.php'),(20817156,11293,'./pm/makepayment.php'),(20817155,11292,'./pm/makepayment.php'),(20817154,7116,'./pm/makepayment.php'),(20817153,9457,'./pm/makepayment.php'),(20817152,9456,'./pm/makepayment.php'),(20817151,9380,'./pm/makepayment.php'),(20817150,9379,'./pm/makepayment.php'),(20817149,9378,'./pm/makepayment.php'),(20817148,9377,'./pm/makepayment.php'),(20817147,5439,'./pm/makepayment.php'),(20817146,5452,'./pm/makepayment.php'),(20817145,315,'./pm/makepayment.php'),(20817144,14431,'./pm/makepayment.php'),(20817143,5144,'./pm/makepayment.php'),(20817142,232,'./pm/makepayment.php'),(20817141,226,'./pm/makepayment.php'),(20817140,5882,'./pm/makepayment.php'),(20817139,32,'./pm/makepayment.php'),(20817138,14404,'./pm/makepayment.php'),(20817137,30,'./pm/makepayment.php'),(20817289,1014,'./pm/managecommunications.php'),(20817288,737,'./pm/managecommunications.php'),(20817287,11582,'./pm/managecommunications.php'),(20817286,11581,'./pm/managecommunications.php'),(20817285,5583,'./pm/managecommunications.php'),(20817284,451,'./pm/managecommunications.php'),(20817283,333,'./pm/managecommunications.php'),(20817393,14426,'./pm/manageinvoicing.php'),(20817392,11103,'./pm/manageinvoicing.php'),(20817442,11007,'./pm/manageleaseinvoices.php'),(20817441,10959,'./pm/manageleaseinvoices.php'),(20817440,11413,'./pm/manageleaseinvoices.php'),(20817439,11694,'./pm/manageleaseinvoices.php'),(20817438,11674,'./pm/manageleaseinvoices.php'),(20817437,10923,'./pm/manageleaseinvoices.php'),(20817436,11663,'./pm/manageleaseinvoices.php'),(20817435,10956,'./pm/manageleaseinvoices.php'),(20817434,11156,'./pm/manageleaseinvoices.php'),(20817433,1668,'./pm/manageleaseinvoices.php'),(20817432,14442,'./pm/manageleaseinvoices.php'),(20817431,14315,'./pm/manageleaseinvoices.php'),(20817430,10955,'./pm/manageleaseinvoices.php'),(20817429,11662,'./pm/manageleaseinvoices.php'),(20817428,11661,'./pm/manageleaseinvoices.php'),(20817427,11660,'./pm/manageleaseinvoices.php'),(20817426,8936,'./pm/manageleaseinvoices.php'),(20817425,11659,'./pm/manageleaseinvoices.php'),(20817424,1013,'./pm/manageleaseinvoices.php'),(20817423,9727,'./pm/manageleaseinvoices.php'),(20817422,932,'./pm/manageleaseinvoices.php'),(20817421,11658,'./pm/manageleaseinvoices.php'),(20817420,11657,'./pm/manageleaseinvoices.php'),(20817419,907,'./pm/manageleaseinvoices.php'),(20817418,11656,'./pm/manageleaseinvoices.php'),(20817417,799,'./pm/manageleaseinvoices.php'),(20817416,10954,'./pm/manageleaseinvoices.php'),(20817415,4973,'./pm/manageleaseinvoices.php'),(20817414,670,'./pm/manageleaseinvoices.php'),(20817413,10953,'./pm/manageleaseinvoices.php'),(20817412,14441,'./pm/manageleaseinvoices.php'),(20817411,10952,'./pm/manageleaseinvoices.php'),(20817410,14440,'./pm/manageleaseinvoices.php'),(20817409,14439,'./pm/manageleaseinvoices.php'),(20817408,14308,'./pm/manageleaseinvoices.php'),(20817407,332,'./pm/manageleaseinvoices.php'),(20817406,5145,'./pm/manageleaseinvoices.php'),(20817405,226,'./pm/manageleaseinvoices.php'),(20817404,6514,'./pm/manageleaseinvoices.php'),(20817403,14438,'./pm/manageleaseinvoices.php'),(20817402,14437,'./pm/manageleaseinvoices.php'),(20817401,11655,'./pm/manageleaseinvoices.php'),(20817400,10951,'./pm/manageleaseinvoices.php'),(20817399,14436,'./pm/manageleaseinvoices.php'),(20817398,14435,'./pm/manageleaseinvoices.php'),(20817397,10949,'./pm/manageleaseinvoices.php'),(20817494,11413,'./pm/manageleasepayments.php'),(20817493,8936,'./pm/manageleasepayments.php'),(20817492,11415,'./pm/manageleasepayments.php'),(20817491,11008,'./pm/manageleasepayments.php'),(20817490,10982,'./pm/manageleasepayments.php'),(20817546,11585,'./pm/manageleases.php'),(20817545,9739,'./pm/manageleases.php'),(20817544,9738,'./pm/manageleases.php'),(20817543,9737,'./pm/manageleases.php'),(20817542,11766,'./pm/manageleases.php'),(20817541,11765,'./pm/manageleases.php'),(20817540,11764,'./pm/manageleases.php'),(20817539,11763,'./pm/manageleases.php'),(20817538,9736,'./pm/manageleases.php'),(20817537,9735,'./pm/manageleases.php'),(20817536,9734,'./pm/manageleases.php'),(20817535,9733,'./pm/manageleases.php'),(20817534,9732,'./pm/manageleases.php'),(20817533,9646,'./pm/manageleases.php'),(20817532,11674,'./pm/manageleases.php'),(20817531,10923,'./pm/manageleases.php'),(20817530,14315,'./pm/manageleases.php'),(20817529,9731,'./pm/manageleases.php'),(20817528,9857,'./pm/manageleases.php'),(20817527,9730,'./pm/manageleases.php'),(20817526,14449,'./pm/manageleases.php'),(20817525,14448,'./pm/manageleases.php'),(20817524,11660,'./pm/manageleases.php'),(20817523,8936,'./pm/manageleases.php'),(20817522,11157,'./pm/manageleases.php'),(20817521,1134,'./pm/manageleases.php'),(20817520,1132,'./pm/manageleases.php'),(20817519,1014,'./pm/manageleases.php'),(20817518,11591,'./pm/manageleases.php'),(20817517,11590,'./pm/manageleases.php'),(20817516,11658,'./pm/manageleases.php'),(20817515,799,'./pm/manageleases.php'),(20817514,11416,'./pm/manageleases.php'),(20817513,11669,'./pm/manageleases.php'),(20817512,14447,'./pm/manageleases.php'),(20817511,14441,'./pm/manageleases.php'),(20817510,10952,'./pm/manageleases.php'),(20817509,14308,'./pm/manageleases.php'),(20817508,416,'./pm/manageleases.php'),(20817507,333,'./pm/manageleases.php'),(20817506,315,'./pm/manageleases.php'),(20817505,11331,'./pm/manageleases.php'),(20817504,5146,'./pm/manageleases.php'),(20817503,5145,'./pm/manageleases.php'),(20817502,5203,'./pm/manageleases.php'),(20817501,8911,'./pm/manageleases.php'),(20817606,9752,'./pm/manageprospects.php'),(20817605,9546,'./pm/manageprospects.php'),(20817604,14456,'./pm/manageprospects.php'),(20817603,14455,'./pm/manageprospects.php'),(20817602,14454,'./pm/manageprospects.php'),(20817601,8936,'./pm/manageprospects.php'),(20817600,1014,'./pm/manageprospects.php'),(20817599,981,'./pm/manageprospects.php'),(20817598,8271,'./pm/manageprospects.php'),(20817597,11579,'./pm/manageprospects.php'),(20817596,14453,'./pm/manageprospects.php'),(20817595,6514,'./pm/manageprospects.php'),(20817594,9859,'./pm/manageprospects.php'),(20817593,185,'./pm/manageprospects.php'),(20817638,2044,'./pm/managescreenings.php'),(20817637,9753,'./pm/managescreenings.php'),(20817636,1935,'./pm/managescreenings.php'),(20817635,10757,'./pm/managescreenings.php'),(20817634,10756,'./pm/managescreenings.php'),(20817633,10755,'./pm/managescreenings.php'),(20817632,6748,'./pm/managescreenings.php'),(20817631,10754,'./pm/managescreenings.php'),(20817630,10753,'./pm/managescreenings.php'),(20817629,10752,'./pm/managescreenings.php'),(20817628,11579,'./pm/managescreenings.php'),(20817627,10751,'./pm/managescreenings.php'),(20817626,315,'./pm/managescreenings.php'),(20817625,10750,'./pm/managescreenings.php'),(20817624,10749,'./pm/managescreenings.php'),(20817623,10748,'./pm/managescreenings.php'),(20817622,47,'./pm/managescreenings.php'),(20817784,11604,'./pm/moveout.php'),(20817783,11603,'./pm/moveout.php'),(20817782,11602,'./pm/moveout.php'),(20817781,10983,'./pm/moveout.php'),(20817780,8936,'./pm/moveout.php'),(20817779,10139,'./pm/moveout.php'),(20817778,8125,'./pm/moveout.php'),(20817777,8911,'./pm/moveout.php'),(20817776,10982,'./pm/moveout.php'),(20817914,2103,'./pm/noteadd.php'),(20817930,9790,'./pm/propertyavailability.php'),(20817929,11479,'./pm/propertyavailability.php'),(20817928,3443,'./pm/propertyavailability.php'),(20817927,9742,'./pm/propertyavailability.php'),(20817926,9789,'./pm/propertyavailability.php'),(20817925,11185,'./pm/propertyavailability.php'),(20817924,1014,'./pm/propertyavailability.php'),(20817923,869,'./pm/propertyavailability.php'),(20817922,10771,'./pm/propertyavailability.php'),(20817921,6314,'./pm/propertyavailability.php'),(20817920,14476,'./pm/propertyavailability.php'),(20817919,14475,'./pm/propertyavailability.php'),(20818030,9755,'./pm/viewapplication.php'),(20818041,10711,'./pm/viewinvoices.php'),(20818040,10709,'./pm/viewinvoices.php'),(20818039,2151,'./pm/viewinvoices.php'),(20818038,4081,'./pm/viewinvoices.php'),(20818037,4940,'./pm/viewinvoices.php'),(20818036,1668,'./pm/viewinvoices.php'),(20818035,1014,'./pm/viewinvoices.php'),(20818034,932,'./pm/viewinvoices.php'),(20818033,8271,'./pm/viewinvoices.php'),(20818032,226,'./pm/viewinvoices.php'),(20818111,4087,'./pm/viewpayments.php'),(20818110,1884,'./pm/viewpayments.php'),(20818109,1668,'./pm/viewpayments.php'),(20818108,1014,'./pm/viewpayments.php'),(20818107,11192,'./pm/viewpayments.php'),(20818106,8271,'./pm/viewpayments.php'),(20818105,7815,'./pm/viewpayments.php'),(20818104,226,'./pm/viewpayments.php'),(20818137,2103,'./pm/viewprofile.php'),(20818136,14484,'./pm/viewprofile.php'),(20818135,8544,'./pm/viewprofile.php'),(20818134,1758,'./pm/viewprofile.php'),(20818133,1429,'./pm/viewprofile.php'),(20818132,8936,'./pm/viewprofile.php'),(20818131,982,'./pm/viewprofile.php'),(20818130,907,'./pm/viewprofile.php'),(20818129,737,'./pm/viewprofile.php'),(20818128,11767,'./pm/viewprofile.php'),(20818127,673,'./pm/viewprofile.php'),(20818126,9666,'./pm/viewprofile.php'),(20818125,524,'./pm/viewprofile.php'),(20818124,5430,'./pm/viewprofile.php'),(20818123,315,'./pm/viewprofile.php'),(20818122,11331,'./pm/viewprofile.php'),(20818121,9665,'./pm/viewprofile.php'),(20818120,185,'./pm/viewprofile.php'),(20818156,541,'./pm/viewtenantsurvey.php'),(20818190,11619,'./pm/includes/dashboard_l.php'),(20818189,4081,'./pm/includes/dashboard_l.php'),(20818188,2103,'./pm/includes/dashboard_l.php'),(20818187,2099,'./pm/includes/dashboard_l.php'),(20818186,2070,'./pm/includes/dashboard_l.php'),(20818185,1935,'./pm/includes/dashboard_l.php'),(20818184,10872,'./pm/includes/dashboard_l.php'),(20818183,1797,'./pm/includes/dashboard_l.php'),(20818182,1788,'./pm/includes/dashboard_l.php'),(20818181,1668,'./pm/includes/dashboard_l.php'),(20818180,4414,'./pm/includes/dashboard_l.php'),(20818179,1555,'./pm/includes/dashboard_l.php'),(20818178,14812,'./pm/includes/dashboard_l.php'),(20818177,14813,'./pm/includes/dashboard_l.php'),(20818176,14798,'./pm/includes/dashboard_l.php'),(20818175,1354,'./pm/includes/dashboard_l.php'),(20818174,10384,'./pm/includes/dashboard_l.php'),(20818173,8936,'./pm/includes/dashboard_l.php'),(20818172,1014,'./pm/includes/dashboard_l.php'),(20818171,932,'./pm/includes/dashboard_l.php'),(20818170,7105,'./pm/includes/dashboard_l.php'),(20818169,4973,'./pm/includes/dashboard_l.php'),(20818168,745,'./pm/includes/dashboard_l.php'),(20818167,737,'./pm/includes/dashboard_l.php'),(20818166,596,'./pm/includes/dashboard_l.php'),(20818165,451,'./pm/includes/dashboard_l.php'),(20818164,333,'./pm/includes/dashboard_l.php'),(20818163,325,'./pm/includes/dashboard_l.php'),(20818162,11618,'./pm/includes/dashboard_l.php'),(20818161,226,'./pm/includes/dashboard_l.php'),(20818160,11617,'./pm/includes/dashboard_l.php'),(20818159,55,'./pm/includes/dashboard_l.php'),(20818223,3363,'./pm/includes/dashboard_p.php'),(20818246,10961,'./pm/includes/dashboard_t.php'),(20818245,9918,'./pm/includes/dashboard_t.php'),(20818244,1884,'./pm/includes/dashboard_t.php'),(20818243,11194,'./pm/includes/dashboard_t.php'),(20818242,11634,'./pm/includes/dashboard_t.php'),(20818241,1668,'./pm/includes/dashboard_t.php'),(20818240,14812,'./pm/includes/dashboard_t.php'),(20818239,14813,'./pm/includes/dashboard_t.php'),(20818238,14798,'./pm/includes/dashboard_t.php'),(20818237,11633,'./pm/includes/dashboard_t.php'),(20818236,8936,'./pm/includes/dashboard_t.php'),(20818235,1014,'./pm/includes/dashboard_t.php'),(20818234,932,'./pm/includes/dashboard_t.php'),(20818233,5407,'./pm/includes/dashboard_t.php'),(20818232,907,'./pm/includes/dashboard_t.php'),(20818231,7105,'./pm/includes/dashboard_t.php'),(20818230,11192,'./pm/includes/dashboard_t.php'),(20818229,7815,'./pm/includes/dashboard_t.php'),(20818228,596,'./pm/includes/dashboard_t.php'),(20818227,325,'./pm/includes/dashboard_t.php'),(20818226,226,'./pm/includes/dashboard_t.php'),(20818225,55,'./pm/includes/dashboard_t.php'),(20818299,10912,'./pm/includes/header.php'),(20818298,11289,'./pm/includes/header.php'),(20818297,10563,'./pm/includes/header.php'),(20818296,11361,'./pm/includes/header.php'),(20818295,11600,'./pm/includes/header.php'),(20818294,11602,'./pm/includes/header.php'),(20818293,11637,'./pm/includes/header.php'),(20818292,11128,'./pm/includes/header.php'),(20818291,14922,'./pm/includes/header.php'),(20818290,10562,'./pm/includes/header.php'),(20818289,11238,'./pm/includes/header.php'),(20818288,1559,'./pm/includes/header.php'),(20818287,11237,'./pm/includes/header.php'),(20818286,10819,'./pm/includes/header.php'),(20818285,11234,'./pm/includes/header.php'),(20818284,14481,'./pm/includes/header.php'),(20818283,673,'./pm/includes/header.php'),(20818282,9670,'./pm/includes/header.php'),(20818281,10771,'./pm/includes/header.php'),(20818280,11227,'./pm/includes/header.php'),(20818279,11579,'./pm/includes/header.php'),(20818278,11581,'./pm/includes/header.php'),(20818277,10561,'./pm/includes/header.php'),(20818276,11037,'./pm/includes/header.php'),(20818275,14310,'./pm/includes/header.php'),(20818274,11363,'./pm/includes/header.php'),(20818273,9842,'./pm/includes/header.php'),(20818272,14923,'./pm/includes/header.php'),(20818271,5882,'./pm/includes/header.php'),(20818270,14516,'./pm/includes/header.php'),(20818354,2103,'./pm/includes/npnote.php'),(20818353,2099,'./pm/includes/npnote.php'),(20818352,6125,'./pm/includes/npnote.php'),(20818351,8116,'./pm/includes/npnote.php'),(20818350,8258,'./pm/includes/npnote.php'),(20818349,799,'./pm/includes/npnote.php'),(20818348,737,'./pm/includes/npnote.php'),(20818347,3930,'./pm/includes/npnote.php'),(20818346,541,'./pm/includes/npnote.php'),(20818345,8125,'./pm/includes/npnote.php'),(20781589,5570,'./!/application/controllers/item.php'),(20781588,7801,'./!/application/controllers/item.php'),(20781587,197,'./!/application/controllers/item.php'),(20781586,7243,'./!/application/controllers/item.php'),(20781798,17922,'./!/application/controllers/itemlocation.php'),(20781797,19820,'./!/application/controllers/itemlocation.php'),(20781796,616,'./!/application/controllers/itemlocation.php'),(20781795,541,'./!/application/controllers/itemlocation.php'),(20781794,17921,'./!/application/controllers/itemlocation.php'),(20781793,5826,'./!/application/controllers/itemlocation.php'),(20781792,19928,'./!/application/controllers/itemlocation.php'),(20781791,19927,'./!/application/controllers/itemlocation.php'),(20781790,19926,'./!/application/controllers/itemlocation.php'),(20781998,1666,'./!/application/controllers/itemvendor.php'),(20781997,18530,'./!/application/controllers/itemvendor.php'),(20781996,616,'./!/application/controllers/itemvendor.php'),(20781995,19824,'./!/application/controllers/itemvendor.php'),(20782017,47,'./!/application/controllers/job.php'),(20783557,6085,'./!/application/controllers/settings.php'),(20783556,8508,'./!/application/controllers/settings.php'),(20783555,2702,'./!/application/controllers/settings.php'),(20783554,1639,'./!/application/controllers/settings.php'),(20783553,3566,'./!/application/controllers/settings.php'),(20489161,16954,'./!/application/controllers/territory.php'),(20489160,19372,'./!/application/controllers/territory.php'),(20784042,30,'./!/application/libraries/import_task.php'),(20784124,4211,'./!/application/libraries/settings_form.php'),(20784123,14180,'./!/application/libraries/settings_form.php'),(20784122,16671,'./!/application/libraries/settings_form.php'),(20784121,16674,'./!/application/libraries/settings_form.php'),(20784120,1963,'./!/application/libraries/settings_form.php'),(20784661,16809,'./!/application/views/appointments/summary.php'),(20784660,16570,'./!/application/views/appointments/summary.php'),(20785886,20,'./!/application/views/job/tab_view.php'),(20786482,4023,'./!/application/views/settingsmap/fromPath.php'),(20786481,1476,'./!/application/views/settingsmap/fromPath.php'),(20786480,13994,'./!/application/views/settingsmap/fromPath.php'),(20786479,3520,'./!/application/views/settingsmap/fromPath.php'),(20786752,14852,'./admin3dcart.php'),(20786751,15780,'./admin3dcart.php'),(20786750,15157,'./admin3dcart.php'),(20787015,11471,'./adminapglacct.php'),(20787014,3533,'./adminapglacct.php'),(20787185,18635,'./adminarcompanytaxupd.php'),(20787184,155,'./adminarcompanytaxupd.php'),(20787183,10466,'./adminarcompanytaxupd.php'),(20787182,59,'./adminarcompanytaxupd.php'),(20787250,8178,'./adminarcompanyupd.php'),(20787249,17099,'./adminarcompanyupd.php'),(20787248,19645,'./adminarcompanyupd.php'),(20787247,6491,'./adminarcompanyupd.php'),(20787246,8788,'./adminarcompanyupd.php'),(20787245,7224,'./adminarcompanyupd.php'),(20787244,7223,'./adminarcompanyupd.php'),(20787736,445,'./adminarglacct.php'),(20787735,279,'./adminarglacct.php'),(20790004,226,'./apbill_preapprove.php'),(20791333,20,'./arbankdepositupd.php'),(20792939,315,'./arinvoicereppay.php'),(20792938,282,'./arinvoicereppay.php'),(20792937,226,'./arinvoicereppay.php'),(20792936,197,'./arinvoicereppay.php'),(20793260,6241,'./arinvoicestate.php'),(20793308,315,'./arinvoicesum.php'),(20793307,5570,'./arinvoicesum.php'),(20793306,19104,'./arinvoicesum.php'),(20793305,197,'./arinvoicesum.php'),(20793898,197,'./aritemsaleslst.php'),(20794760,19853,'./arordernumber.php'),(20795009,306,'./arordpicktickfpdf.php'),(20800014,18635,'./genuserrights.php'),(20800013,9601,'./genuserrights.php'),(20800012,19856,'./genuserrights.php'),(20800868,20,'./gljournalpdf.php'),(20801093,16666,'./glrepactivity.php'),(20803580,209,'./invitemlstreorder.php'),(20815173,15877,'./includes/tamg.php'),(20815172,5081,'./includes/tamg.php'),(20815171,10562,'./includes/tamg.php'),(20815170,14868,'./includes/tamg.php'),(20815169,1682,'./includes/tamg.php'),(20815168,1668,'./includes/tamg.php'),(20815167,1659,'./includes/tamg.php'),(20815166,1578,'./includes/tamg.php'),(20815165,15049,'./includes/tamg.php'),(20815164,8936,'./includes/tamg.php'),(20815163,15970,'./includes/tamg.php'),(20815162,1036,'./includes/tamg.php'),(20815161,981,'./includes/tamg.php'),(20815160,941,'./includes/tamg.php'),(20815159,869,'./includes/tamg.php'),(20815158,19872,'./includes/tamg.php'),(20815157,19871,'./includes/tamg.php'),(20815156,5205,'./includes/tamg.php'),(20815155,17760,'./includes/tamg.php'),(20815154,798,'./includes/tamg.php'),(20815153,11349,'./includes/tamg.php'),(20815152,737,'./includes/tamg.php'),(20815151,697,'./includes/tamg.php'),(20815150,675,'./includes/tamg.php'),(20815149,673,'./includes/tamg.php'),(20815148,15349,'./includes/tamg.php'),(20815147,659,'./includes/tamg.php'),(20815146,15915,'./includes/tamg.php'),(20815145,11356,'./includes/tamg.php'),(20815144,15914,'./includes/tamg.php'),(20815143,606,'./includes/tamg.php'),(20815142,6224,'./includes/tamg.php'),(20815141,605,'./includes/tamg.php'),(20815140,591,'./includes/tamg.php'),(20815139,5864,'./includes/tamg.php'),(20815138,543,'./includes/tamg.php'),(20815137,11355,'./includes/tamg.php'),(20815136,15220,'./includes/tamg.php'),(20815135,524,'./includes/tamg.php'),(20815134,479,'./includes/tamg.php'),(20815133,445,'./includes/tamg.php'),(20815132,9956,'./includes/tamg.php'),(20815131,15219,'./includes/tamg.php'),(20815130,15218,'./includes/tamg.php'),(20815129,8862,'./includes/tamg.php'),(20815128,8702,'./includes/tamg.php'),(20815127,5439,'./includes/tamg.php'),(20815126,9955,'./includes/tamg.php'),(20815125,9954,'./includes/tamg.php'),(20815124,5437,'./includes/tamg.php'),(20815123,9953,'./includes/tamg.php'),(20815122,11354,'./includes/tamg.php'),(20815121,15913,'./includes/tamg.php'),(20815120,15046,'./includes/tamg.php'),(20815119,226,'./includes/tamg.php'),(20815118,15087,'./includes/tamg.php'),(20815117,16082,'./includes/tamg.php'),(20815116,15086,'./includes/tamg.php'),(20815115,15085,'./includes/tamg.php'),(20815114,17523,'./includes/tamg.php'),(20815113,19870,'./includes/tamg.php'),(20815112,19869,'./includes/tamg.php'),(20815111,7844,'./includes/tamg.php'),(20815110,47,'./includes/tamg.php'),(20815109,15217,'./includes/tamg.php'),(20815305,3544,'./includes/home/np5_tabs.php'),(20816489,4873,'./includes/home/printing/defines.php'),(20779645,19890,'./!/application/controllers/b2buser.php'),(20779641,5205,'./!/application/controllers/b2buser.php'),(20779640,6602,'./!/application/controllers/b2buser.php'),(20779639,3458,'./!/application/controllers/b2buser.php'),(20779638,697,'./!/application/controllers/b2buser.php'),(20779637,16256,'./!/application/controllers/b2buser.php'),(20779636,16250,'./!/application/controllers/b2buser.php'),(20779635,16249,'./!/application/controllers/b2buser.php'),(20779634,19889,'./!/application/controllers/b2buser.php'),(20779633,19888,'./!/application/controllers/b2buser.php'),(20779632,7852,'./!/application/controllers/b2buser.php'),(20779631,5570,'./!/application/controllers/b2buser.php'),(20779630,226,'./!/application/controllers/b2buser.php'),(20779629,197,'./!/application/controllers/b2buser.php'),(20779628,16246,'./!/application/controllers/b2buser.php'),(20779627,55,'./!/application/controllers/b2buser.php'),(20779626,4932,'./!/application/controllers/b2buser.php'),(20779677,17680,'./!/application/controllers/bank_deposit.php'),(20779761,3544,'./!/application/controllers/billtrust.php'),(20779760,333,'./!/application/controllers/billtrust.php'),(20779759,325,'./!/application/controllers/billtrust.php'),(20779758,315,'./!/application/controllers/billtrust.php'),(20779757,226,'./!/application/controllers/billtrust.php'),(20779756,16119,'./!/application/controllers/billtrust.php'),(20779755,16118,'./!/application/controllers/billtrust.php'),(20779754,4039,'./!/application/controllers/billtrust.php'),(20779753,4037,'./!/application/controllers/billtrust.php'),(20780056,4040,'./!/application/controllers/customer.php'),(20780055,4039,'./!/application/controllers/customer.php'),(20780054,9289,'./!/application/controllers/customer.php'),(20780322,202,'./!/application/controllers/customfields.php'),(20780736,7744,'./!/application/controllers/hubconstruction.php'),(20780735,2200,'./!/application/controllers/hubconstruction.php'),(20780734,2165,'./!/application/controllers/hubconstruction.php'),(20780733,8290,'./!/application/controllers/hubconstruction.php'),(20780732,2160,'./!/application/controllers/hubconstruction.php'),(20780731,8991,'./!/application/controllers/hubconstruction.php'),(20780730,3713,'./!/application/controllers/hubconstruction.php'),(20780729,19030,'./!/application/controllers/hubconstruction.php'),(20780728,6444,'./!/application/controllers/hubconstruction.php'),(20780727,2137,'./!/application/controllers/hubconstruction.php'),(20780726,18144,'./!/application/controllers/hubconstruction.php'),(20780725,19029,'./!/application/controllers/hubconstruction.php'),(20780724,15800,'./!/application/controllers/hubconstruction.php'),(20780723,2044,'./!/application/controllers/hubconstruction.php'),(20780722,18096,'./!/application/controllers/hubconstruction.php'),(20780721,2094,'./!/application/controllers/hubconstruction.php'),(20780720,7161,'./!/application/controllers/hubconstruction.php'),(20780719,16674,'./!/application/controllers/hubconstruction.php'),(20780718,19028,'./!/application/controllers/hubconstruction.php'),(20780717,5377,'./!/application/controllers/hubconstruction.php'),(20780716,1963,'./!/application/controllers/hubconstruction.php'),(20780715,19027,'./!/application/controllers/hubconstruction.php'),(20780714,15962,'./!/application/controllers/hubconstruction.php'),(20780713,3705,'./!/application/controllers/hubconstruction.php'),(20780712,9392,'./!/application/controllers/hubconstruction.php'),(20780711,7903,'./!/application/controllers/hubconstruction.php'),(20780710,11855,'./!/application/controllers/hubconstruction.php'),(20780709,1948,'./!/application/controllers/hubconstruction.php'),(20780708,19026,'./!/application/controllers/hubconstruction.php'),(20780707,3704,'./!/application/controllers/hubconstruction.php'),(20780706,1933,'./!/application/controllers/hubconstruction.php'),(20780705,5304,'./!/application/controllers/hubconstruction.php'),(20780704,8588,'./!/application/controllers/hubconstruction.php'),(20780703,8628,'./!/application/controllers/hubconstruction.php'),(20780702,14039,'./!/application/controllers/hubconstruction.php'),(20780701,1820,'./!/application/controllers/hubconstruction.php'),(20780700,15866,'./!/application/controllers/hubconstruction.php'),(20780699,1788,'./!/application/controllers/hubconstruction.php'),(20780698,1781,'./!/application/controllers/hubconstruction.php'),(20780697,7894,'./!/application/controllers/hubconstruction.php'),(20780696,8008,'./!/application/controllers/hubconstruction.php'),(20780695,3674,'./!/application/controllers/hubconstruction.php'),(20780694,4133,'./!/application/controllers/hubconstruction.php'),(20780693,7453,'./!/application/controllers/hubconstruction.php'),(20780692,1770,'./!/application/controllers/hubconstruction.php'),(20780691,3672,'./!/application/controllers/hubconstruction.php'),(20780690,19025,'./!/application/controllers/hubconstruction.php'),(20780689,3671,'./!/application/controllers/hubconstruction.php'),(20780688,7890,'./!/application/controllers/hubconstruction.php'),(20780687,1743,'./!/application/controllers/hubconstruction.php'),(20780686,19024,'./!/application/controllers/hubconstruction.php'),(20780685,9622,'./!/application/controllers/hubconstruction.php'),(20780684,15590,'./!/application/controllers/hubconstruction.php'),(20780683,9390,'./!/application/controllers/hubconstruction.php'),(20780682,5081,'./!/application/controllers/hubconstruction.php'),(20780681,7158,'./!/application/controllers/hubconstruction.php'),(20780680,8937,'./!/application/controllers/hubconstruction.php'),(20780679,3668,'./!/application/controllers/hubconstruction.php'),(20780678,13406,'./!/application/controllers/hubconstruction.php'),(20780677,3666,'./!/application/controllers/hubconstruction.php'),(20780676,1732,'./!/application/controllers/hubconstruction.php'),(20780675,11853,'./!/application/controllers/hubconstruction.php'),(20780674,4381,'./!/application/controllers/hubconstruction.php'),(20780673,14015,'./!/application/controllers/hubconstruction.php'),(20780672,12864,'./!/application/controllers/hubconstruction.php'),(20780671,3665,'./!/application/controllers/hubconstruction.php'),(20780670,6402,'./!/application/controllers/hubconstruction.php'),(20780669,11852,'./!/application/controllers/hubconstruction.php'),(20780668,3663,'./!/application/controllers/hubconstruction.php'),(20780667,3662,'./!/application/controllers/hubconstruction.php'),(20780666,15308,'./!/application/controllers/hubconstruction.php'),(20780665,7569,'./!/application/controllers/hubconstruction.php'),(20780664,1709,'./!/application/controllers/hubconstruction.php'),(20780663,16777,'./!/application/controllers/hubconstruction.php'),(20780662,1703,'./!/application/controllers/hubconstruction.php'),(20780661,15619,'./!/application/controllers/hubconstruction.php'),(20780660,3660,'./!/application/controllers/hubconstruction.php'),(20780659,12168,'./!/application/controllers/hubconstruction.php'),(20780658,8155,'./!/application/controllers/hubconstruction.php'),(20780657,1740,'./!/application/controllers/hubconstruction.php'),(20780656,1696,'./!/application/controllers/hubconstruction.php'),(20780655,12893,'./!/application/controllers/hubconstruction.php'),(20780654,15799,'./!/application/controllers/hubconstruction.php'),(20780653,15374,'./!/application/controllers/hubconstruction.php'),(20780652,9467,'./!/application/controllers/hubconstruction.php'),(20780651,4940,'./!/application/controllers/hubconstruction.php'),(20780650,3657,'./!/application/controllers/hubconstruction.php'),(20780649,1666,'./!/application/controllers/hubconstruction.php'),(20780648,16683,'./!/application/controllers/hubconstruction.php'),(20780647,1647,'./!/application/controllers/hubconstruction.php'),(20780646,11981,'./!/application/controllers/hubconstruction.php'),(20780645,9281,'./!/application/controllers/hubconstruction.php'),(20780644,1639,'./!/application/controllers/hubconstruction.php'),(20780643,12723,'./!/application/controllers/hubconstruction.php'),(20780642,16547,'./!/application/controllers/hubconstruction.php'),(20780641,14520,'./!/application/controllers/hubconstruction.php'),(20780640,8250,'./!/application/controllers/hubconstruction.php'),(20780639,13576,'./!/application/controllers/hubconstruction.php'),(20780638,7489,'./!/application/controllers/hubconstruction.php'),(20780637,17275,'./!/application/controllers/hubconstruction.php'),(20780636,7889,'./!/application/controllers/hubconstruction.php'),(20780635,8084,'./!/application/controllers/hubconstruction.php'),(20780634,1508,'./!/application/controllers/hubconstruction.php'),(20780633,7887,'./!/application/controllers/hubconstruction.php'),(20780632,16509,'./!/application/controllers/hubconstruction.php'),(20780631,1446,'./!/application/controllers/hubconstruction.php'),(20780630,12912,'./!/application/controllers/hubconstruction.php'),(20780629,16094,'./!/application/controllers/hubconstruction.php'),(20780628,19898,'./!/application/controllers/hubconstruction.php'),(20780627,13454,'./!/application/controllers/hubconstruction.php'),(20780626,4083,'./!/application/controllers/hubconstruction.php'),(20780625,7146,'./!/application/controllers/hubconstruction.php'),(20780624,3593,'./!/application/controllers/hubconstruction.php'),(20780623,12167,'./!/application/controllers/hubconstruction.php'),(20780622,12166,'./!/application/controllers/hubconstruction.php'),(20780621,3467,'./!/application/controllers/hubconstruction.php'),(20780620,11372,'./!/application/controllers/hubconstruction.php'),(20780619,14182,'./!/application/controllers/hubconstruction.php'),(20780618,12020,'./!/application/controllers/hubconstruction.php'),(20780617,7876,'./!/application/controllers/hubconstruction.php'),(20780616,5060,'./!/application/controllers/hubconstruction.php'),(20780615,3586,'./!/application/controllers/hubconstruction.php'),(20780614,6923,'./!/application/controllers/hubconstruction.php'),(20780613,11976,'./!/application/controllers/hubconstruction.php'),(20780612,7871,'./!/application/controllers/hubconstruction.php'),(20780611,951,'./!/application/controllers/hubconstruction.php'),(20780610,16656,'./!/application/controllers/hubconstruction.php'),(20780609,6969,'./!/application/controllers/hubconstruction.php'),(20780608,3581,'./!/application/controllers/hubconstruction.php'),(20780607,7865,'./!/application/controllers/hubconstruction.php'),(20780606,3580,'./!/application/controllers/hubconstruction.php'),(20780605,7143,'./!/application/controllers/hubconstruction.php'),(20780604,869,'./!/application/controllers/hubconstruction.php'),(20780603,12174,'./!/application/controllers/hubconstruction.php'),(20780602,10625,'./!/application/controllers/hubconstruction.php'),(20780601,8336,'./!/application/controllers/hubconstruction.php'),(20780600,5299,'./!/application/controllers/hubconstruction.php'),(20780599,17467,'./!/application/controllers/hubconstruction.php'),(20780598,18306,'./!/application/controllers/hubconstruction.php'),(20780597,5477,'./!/application/controllers/hubconstruction.php'),(20780596,6755,'./!/application/controllers/hubconstruction.php'),(20780595,15758,'./!/application/controllers/hubconstruction.php'),(20780594,6316,'./!/application/controllers/hubconstruction.php'),(20780593,16917,'./!/application/controllers/hubconstruction.php'),(20780592,6317,'./!/application/controllers/hubconstruction.php'),(20780591,11846,'./!/application/controllers/hubconstruction.php'),(20780590,6465,'./!/application/controllers/hubconstruction.php'),(20780589,3458,'./!/application/controllers/hubconstruction.php'),(20780588,697,'./!/application/controllers/hubconstruction.php'),(20780587,19023,'./!/application/controllers/hubconstruction.php'),(20780586,19162,'./!/application/controllers/hubconstruction.php'),(20780585,11767,'./!/application/controllers/hubconstruction.php'),(20780584,9341,'./!/application/controllers/hubconstruction.php'),(20780583,15757,'./!/application/controllers/hubconstruction.php'),(20780582,7121,'./!/application/controllers/hubconstruction.php'),(20780581,8653,'./!/application/controllers/hubconstruction.php'),(20780580,19021,'./!/application/controllers/hubconstruction.php'),(20780579,17171,'./!/application/controllers/hubconstruction.php'),(20780578,637,'./!/application/controllers/hubconstruction.php'),(20780577,634,'./!/application/controllers/hubconstruction.php'),(20780576,9492,'./!/application/controllers/hubconstruction.php'),(20780575,11843,'./!/application/controllers/hubconstruction.php'),(20780574,581,'./!/application/controllers/hubconstruction.php'),(20780573,572,'./!/application/controllers/hubconstruction.php'),(20780572,7136,'./!/application/controllers/hubconstruction.php'),(20780571,11037,'./!/application/controllers/hubconstruction.php'),(20780570,6702,'./!/application/controllers/hubconstruction.php'),(20780569,541,'./!/application/controllers/hubconstruction.php'),(20780568,524,'./!/application/controllers/hubconstruction.php'),(20780567,495,'./!/application/controllers/hubconstruction.php'),(20780566,513,'./!/application/controllers/hubconstruction.php'),(20780565,3562,'./!/application/controllers/hubconstruction.php'),(20780564,3558,'./!/application/controllers/hubconstruction.php'),(20780563,3519,'./!/application/controllers/hubconstruction.php'),(20780562,7135,'./!/application/controllers/hubconstruction.php'),(20780561,12803,'./!/application/controllers/hubconstruction.php'),(20780560,7856,'./!/application/controllers/hubconstruction.php'),(20780559,408,'./!/application/controllers/hubconstruction.php'),(20780558,3547,'./!/application/controllers/hubconstruction.php'),(20780557,3544,'./!/application/controllers/hubconstruction.php'),(20780556,7854,'./!/application/controllers/hubconstruction.php'),(20780555,15597,'./!/application/controllers/hubconstruction.php'),(20780554,16096,'./!/application/controllers/hubconstruction.php'),(20780553,3541,'./!/application/controllers/hubconstruction.php'),(20780552,7853,'./!/application/controllers/hubconstruction.php'),(20780551,8127,'./!/application/controllers/hubconstruction.php'),(20780550,315,'./!/application/controllers/hubconstruction.php'),(20780549,8065,'./!/application/controllers/hubconstruction.php'),(20780548,19020,'./!/application/controllers/hubconstruction.php'),(20780547,195,'./!/application/controllers/hubconstruction.php'),(20780546,3537,'./!/application/controllers/hubconstruction.php'),(20780545,3533,'./!/application/controllers/hubconstruction.php'),(20780544,188,'./!/application/controllers/hubconstruction.php'),(20780543,185,'./!/application/controllers/hubconstruction.php'),(20780542,7844,'./!/application/controllers/hubconstruction.php'),(20780541,18205,'./!/application/controllers/hubconstruction.php'),(20780540,3523,'./!/application/controllers/hubconstruction.php'),(20780539,15752,'./!/application/controllers/hubconstruction.php'),(20780538,7842,'./!/application/controllers/hubconstruction.php'),(20780537,12826,'./!/application/controllers/hubconstruction.php'),(20780536,8230,'./!/application/controllers/hubconstruction.php'),(20780535,14136,'./!/application/controllers/hubconstruction.php'),(20780980,14277,'./!/application/controllers/invcotransfer.php'),(20780979,315,'./!/application/controllers/invcotransfer.php'),(20780978,10861,'./!/application/controllers/invcotransfer.php'),(20780977,16757,'./!/application/controllers/invcotransfer.php'),(20780976,10860,'./!/application/controllers/invcotransfer.php'),(20780975,16527,'./!/application/controllers/invcotransfer.php'),(20780974,16526,'./!/application/controllers/invcotransfer.php'),(20780973,300,'./!/application/controllers/invcotransfer.php'),(20780972,18805,'./!/application/controllers/invcotransfer.php'),(20780971,287,'./!/application/controllers/invcotransfer.php'),(20780970,5570,'./!/application/controllers/invcotransfer.php'),(20780969,14832,'./!/application/controllers/invcotransfer.php'),(20780968,18907,'./!/application/controllers/invcotransfer.php'),(20781136,6314,'./!/application/controllers/invcotransferdetail.php'),(20781135,187,'./!/application/controllers/invcotransferdetail.php'),(20781134,47,'./!/application/controllers/invcotransferdetail.php'),(20781189,197,'./!/application/controllers/invcountbatch.php'),(20781188,187,'./!/application/controllers/invcountbatch.php'),(20781187,14832,'./!/application/controllers/invcountbatch.php'),(20781186,19806,'./!/application/controllers/invcountbatch.php'),(20781185,14935,'./!/application/controllers/invcountbatch.php'),(20781184,59,'./!/application/controllers/invcountbatch.php'),(20781183,19595,'./!/application/controllers/invcountbatch.php'),(20781434,5570,'./!/application/controllers/invpo.php'),(20781433,222,'./!/application/controllers/invpo.php'),(20781550,19345,'./!/application/controllers/invserialnumber.php'),(20781549,4267,'./!/application/controllers/invserialnumber.php'),(20781548,1781,'./!/application/controllers/invserialnumber.php'),(20781547,19922,'./!/application/controllers/invserialnumber.php'),(20781546,1696,'./!/application/controllers/invserialnumber.php'),(20781545,19921,'./!/application/controllers/invserialnumber.php'),(20781544,869,'./!/application/controllers/invserialnumber.php'),(20781543,19920,'./!/application/controllers/invserialnumber.php'),(20781542,14277,'./!/application/controllers/invserialnumber.php'),(20781585,188,'./!/application/controllers/item.php'),(20781584,3441,'./!/application/controllers/item.php'),(20781583,55,'./!/application/controllers/item.php'),(20781582,47,'./!/application/controllers/item.php'),(20781789,19819,'./!/application/controllers/itemlocation.php'),(20781788,18776,'./!/application/controllers/itemlocation.php'),(20781787,18525,'./!/application/controllers/itemlocation.php'),(20781786,315,'./!/application/controllers/itemlocation.php'),(20781785,16607,'./!/application/controllers/itemlocation.php'),(20781784,6314,'./!/application/controllers/itemlocation.php'),(20787243,9164,'./adminarcompanyupd.php'),(20781907,1740,'./!/application/controllers/itempricespecial.php'),(20781906,1696,'./!/application/controllers/itempricespecial.php'),(20781905,1672,'./!/application/controllers/itempricespecial.php'),(20781904,1668,'./!/application/controllers/itempricespecial.php'),(20781903,1647,'./!/application/controllers/itempricespecial.php'),(20781902,19935,'./!/application/controllers/itempricespecial.php'),(20781901,17280,'./!/application/controllers/itempricespecial.php'),(20781900,19934,'./!/application/controllers/itempricespecial.php'),(20781899,10384,'./!/application/controllers/itempricespecial.php'),(20781898,10383,'./!/application/controllers/itempricespecial.php'),(20781897,1143,'./!/application/controllers/itempricespecial.php'),(20781896,1014,'./!/application/controllers/itempricespecial.php'),(20781895,869,'./!/application/controllers/itempricespecial.php'),(20781894,5205,'./!/application/controllers/itempricespecial.php'),(20781893,799,'./!/application/controllers/itempricespecial.php'),(20781892,19933,'./!/application/controllers/itempricespecial.php'),(20781891,19729,'./!/application/controllers/itempricespecial.php'),(20781890,6228,'./!/application/controllers/itempricespecial.php'),(20781889,697,'./!/application/controllers/itempricespecial.php'),(20781888,13308,'./!/application/controllers/itempricespecial.php'),(20781887,607,'./!/application/controllers/itempricespecial.php'),(20781886,541,'./!/application/controllers/itempricespecial.php'),(20781885,333,'./!/application/controllers/itempricespecial.php'),(20781884,16472,'./!/application/controllers/itempricespecial.php'),(20781883,315,'./!/application/controllers/itempricespecial.php'),(20781882,19932,'./!/application/controllers/itempricespecial.php'),(20781881,5570,'./!/application/controllers/itempricespecial.php'),(20781958,869,'./!/application/controllers/itempricespecialchange.php'),(20781957,697,'./!/application/controllers/itempricespecialchange.php'),(20782016,15897,'./!/application/controllers/job.php'),(20782015,20,'./!/application/controllers/job.php'),(20782366,153,'./!/application/controllers/main.php'),(20782365,12080,'./!/application/controllers/main.php'),(20782364,17792,'./!/application/controllers/main.php'),(20782363,15553,'./!/application/controllers/main.php'),(20782362,14580,'./!/application/controllers/main.php'),(20782361,4016,'./!/application/controllers/main.php'),(20782360,3524,'./!/application/controllers/main.php'),(20782359,3523,'./!/application/controllers/main.php'),(20782358,15752,'./!/application/controllers/main.php'),(20782357,7111,'./!/application/controllers/main.php'),(20782356,7842,'./!/application/controllers/main.php'),(20782355,12923,'./!/application/controllers/main.php'),(20783197,10004,'./!/application/controllers/priceoverriderequest.php'),(20783196,5095,'./!/application/controllers/priceoverriderequest.php'),(20783195,10079,'./!/application/controllers/priceoverriderequest.php'),(20783194,197,'./!/application/controllers/priceoverriderequest.php'),(20783230,19953,'./!/application/controllers/processqueue.php'),(20783229,19952,'./!/application/controllers/processqueue.php'),(20783228,19945,'./!/application/controllers/processqueue.php'),(20783227,8272,'./!/application/controllers/processqueue.php'),(20783226,1036,'./!/application/controllers/processqueue.php'),(20783343,9492,'./!/application/controllers/salesman.php'),(20783342,524,'./!/application/controllers/salesman.php'),(20783410,3432,'./!/application/controllers/salesregion.php'),(20783409,3415,'./!/application/controllers/salesregion.php'),(20783408,14946,'./!/application/controllers/salesregion.php'),(20783407,19963,'./!/application/controllers/salesregion.php'),(20783406,3118,'./!/application/controllers/salesregion.php'),(20783405,3072,'./!/application/controllers/salesregion.php'),(20783404,19383,'./!/application/controllers/salesregion.php'),(20783403,19382,'./!/application/controllers/salesregion.php'),(20783402,19381,'./!/application/controllers/salesregion.php'),(20783401,7069,'./!/application/controllers/salesregion.php'),(20783400,17235,'./!/application/controllers/salesregion.php'),(20783399,2936,'./!/application/controllers/salesregion.php'),(20783398,18548,'./!/application/controllers/salesregion.php'),(20783397,2738,'./!/application/controllers/salesregion.php'),(20783396,19962,'./!/application/controllers/salesregion.php'),(20783395,19961,'./!/application/controllers/salesregion.php'),(20783394,19468,'./!/application/controllers/salesregion.php'),(20783393,2676,'./!/application/controllers/salesregion.php'),(20783392,2664,'./!/application/controllers/salesregion.php'),(20783391,19960,'./!/application/controllers/salesregion.php'),(20783390,19959,'./!/application/controllers/salesregion.php'),(20783389,19947,'./!/application/controllers/salesregion.php'),(20783388,19958,'./!/application/controllers/salesregion.php'),(20783387,19946,'./!/application/controllers/salesregion.php'),(20783386,18546,'./!/application/controllers/salesregion.php'),(20783385,9962,'./!/application/controllers/salesregion.php'),(20783384,5876,'./!/application/controllers/salesregion.php'),(20783383,16464,'./!/application/controllers/salesregion.php'),(20783382,2535,'./!/application/controllers/salesregion.php'),(20783381,19379,'./!/application/controllers/salesregion.php'),(20783380,19957,'./!/application/controllers/salesregion.php'),(20783379,19378,'./!/application/controllers/salesregion.php'),(20783378,19377,'./!/application/controllers/salesregion.php'),(20783377,19956,'./!/application/controllers/salesregion.php'),(20783376,1935,'./!/application/controllers/salesregion.php'),(20783375,19827,'./!/application/controllers/salesregion.php'),(20783374,19955,'./!/application/controllers/salesregion.php'),(20783373,1788,'./!/application/controllers/salesregion.php'),(20783372,1578,'./!/application/controllers/salesregion.php'),(20783371,1143,'./!/application/controllers/salesregion.php'),(20783370,19376,'./!/application/controllers/salesregion.php'),(20783369,1014,'./!/application/controllers/salesregion.php'),(20783368,19826,'./!/application/controllers/salesregion.php'),(20783367,18545,'./!/application/controllers/salesregion.php'),(20783366,799,'./!/application/controllers/salesregion.php'),(20783365,19194,'./!/application/controllers/salesregion.php'),(20783364,6228,'./!/application/controllers/salesregion.php'),(20783363,697,'./!/application/controllers/salesregion.php'),(20783362,19374,'./!/application/controllers/salesregion.php'),(20783361,9341,'./!/application/controllers/salesregion.php'),(20783360,548,'./!/application/controllers/salesregion.php'),(20783359,524,'./!/application/controllers/salesregion.php'),(20783358,13861,'./!/application/controllers/salesregion.php'),(20783357,333,'./!/application/controllers/salesregion.php'),(20783356,315,'./!/application/controllers/salesregion.php'),(20783355,19692,'./!/application/controllers/salesregion.php'),(20783354,5203,'./!/application/controllers/salesregion.php'),(20783353,19372,'./!/application/controllers/salesregion.php'),(20783352,185,'./!/application/controllers/salesregion.php'),(20783351,19446,'./!/application/controllers/salesregion.php'),(20783503,19989,'./!/application/controllers/salesterritory.php'),(20783502,6164,'./!/application/controllers/salesterritory.php'),(20783501,19988,'./!/application/controllers/salesterritory.php'),(20783500,19987,'./!/application/controllers/salesterritory.php'),(20783499,19986,'./!/application/controllers/salesterritory.php'),(20783498,19985,'./!/application/controllers/salesterritory.php'),(20783497,19984,'./!/application/controllers/salesterritory.php'),(20783496,3415,'./!/application/controllers/salesterritory.php'),(20783495,14946,'./!/application/controllers/salesterritory.php'),(20783494,3115,'./!/application/controllers/salesterritory.php'),(20783493,6894,'./!/application/controllers/salesterritory.php'),(20783492,3097,'./!/application/controllers/salesterritory.php'),(20783491,3118,'./!/application/controllers/salesterritory.php'),(20783490,3072,'./!/application/controllers/salesterritory.php'),(20783489,19983,'./!/application/controllers/salesterritory.php'),(20783488,18552,'./!/application/controllers/salesterritory.php'),(20783487,19982,'./!/application/controllers/salesterritory.php'),(20783486,19981,'./!/application/controllers/salesterritory.php'),(20783485,18550,'./!/application/controllers/salesterritory.php'),(20783484,19980,'./!/application/controllers/salesterritory.php'),(20783483,19950,'./!/application/controllers/salesterritory.php'),(20783482,19949,'./!/application/controllers/salesterritory.php'),(20783481,18549,'./!/application/controllers/salesterritory.php'),(20783480,19948,'./!/application/controllers/salesterritory.php'),(20783479,7069,'./!/application/controllers/salesterritory.php'),(20783478,19979,'./!/application/controllers/salesterritory.php'),(20783477,2738,'./!/application/controllers/salesterritory.php'),(20783476,19978,'./!/application/controllers/salesterritory.php'),(20783475,19977,'./!/application/controllers/salesterritory.php'),(20783474,19448,'./!/application/controllers/salesterritory.php'),(20783473,2676,'./!/application/controllers/salesterritory.php'),(20783472,2700,'./!/application/controllers/salesterritory.php'),(20783471,5761,'./!/application/controllers/salesterritory.php'),(20783470,2664,'./!/application/controllers/salesterritory.php'),(20783469,18547,'./!/application/controllers/salesterritory.php'),(20783468,19976,'./!/application/controllers/salesterritory.php'),(20783467,9962,'./!/application/controllers/salesterritory.php'),(20783466,5876,'./!/application/controllers/salesterritory.php'),(20783465,16464,'./!/application/controllers/salesterritory.php'),(20783464,19975,'./!/application/controllers/salesterritory.php'),(20783463,19974,'./!/application/controllers/salesterritory.php'),(20783462,19973,'./!/application/controllers/salesterritory.php'),(20783461,19972,'./!/application/controllers/salesterritory.php'),(20783460,19971,'./!/application/controllers/salesterritory.php'),(20783459,19970,'./!/application/controllers/salesterritory.php'),(20783458,1935,'./!/application/controllers/salesterritory.php'),(20783457,13484,'./!/application/controllers/salesterritory.php'),(20783456,19969,'./!/application/controllers/salesterritory.php'),(20783455,1788,'./!/application/controllers/salesterritory.php'),(20783454,1713,'./!/application/controllers/salesterritory.php'),(20783453,1709,'./!/application/controllers/salesterritory.php'),(20783452,16544,'./!/application/controllers/salesterritory.php'),(20783451,1578,'./!/application/controllers/salesterritory.php'),(20783450,1143,'./!/application/controllers/salesterritory.php'),(20783449,19376,'./!/application/controllers/salesterritory.php'),(20783448,1014,'./!/application/controllers/salesterritory.php'),(20783447,19968,'./!/application/controllers/salesterritory.php'),(20783446,19375,'./!/application/controllers/salesterritory.php'),(20783445,799,'./!/application/controllers/salesterritory.php'),(20783444,19194,'./!/application/controllers/salesterritory.php'),(20783443,697,'./!/application/controllers/salesterritory.php'),(20783442,19967,'./!/application/controllers/salesterritory.php'),(20783441,9341,'./!/application/controllers/salesterritory.php'),(20783440,15598,'./!/application/controllers/salesterritory.php'),(20783439,548,'./!/application/controllers/salesterritory.php'),(20783438,6829,'./!/application/controllers/salesterritory.php'),(20783437,333,'./!/application/controllers/salesterritory.php'),(20783436,315,'./!/application/controllers/salesterritory.php'),(20783435,19966,'./!/application/controllers/salesterritory.php'),(20783434,7794,'./!/application/controllers/salesterritory.php'),(20783433,19965,'./!/application/controllers/salesterritory.php'),(20783432,8935,'./!/application/controllers/salesterritory.php'),(20783431,19692,'./!/application/controllers/salesterritory.php'),(20783430,5203,'./!/application/controllers/salesterritory.php'),(20783429,16954,'./!/application/controllers/salesterritory.php'),(20783428,19964,'./!/application/controllers/salesterritory.php'),(20783427,19446,'./!/application/controllers/salesterritory.php'),(20783504,18538,'./!/application/controllers/scanner.php'),(20783552,3533,'./!/application/controllers/settings.php'),(20783757,5433,'./!/application/controllers/vendor.php'),(20783756,315,'./!/application/controllers/vendor.php'),(20783755,306,'./!/application/controllers/vendor.php'),(20783754,15698,'./!/application/controllers/vendor.php'),(20783753,5203,'./!/application/controllers/vendor.php'),(20783752,197,'./!/application/controllers/vendor.php'),(20783956,315,'./!/application/controllers/writeoffreason.php'),(20784003,1696,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784002,1467,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784001,1446,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784000,6441,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20783999,869,'./!/application/libraries/InvcotransferEmailBuilder.php'),(20784119,1885,'./!/application/libraries/settings_form.php'),(20784118,15319,'./!/application/libraries/settings_form.php'),(20784117,1775,'./!/application/libraries/settings_form.php'),(20784116,1753,'./!/application/libraries/settings_form.php'),(20784115,1578,'./!/application/libraries/settings_form.php'),(20784114,1427,'./!/application/libraries/settings_form.php'),(20784113,14818,'./!/application/libraries/settings_form.php'),(20784112,5407,'./!/application/libraries/settings_form.php'),(20784111,869,'./!/application/libraries/settings_form.php'),(20784110,799,'./!/application/libraries/settings_form.php'),(20784109,616,'./!/application/libraries/settings_form.php'),(20784108,6165,'./!/application/libraries/settings_form.php'),(20784107,12691,'./!/application/libraries/settings_form.php'),(20784106,9442,'./!/application/libraries/settings_form.php'),(20784105,8629,'./!/application/libraries/settings_form.php'),(20784104,197,'./!/application/libraries/settings_form.php'),(20784253,7679,'./!/application/models/arinvoice_model.php'),(20784298,17967,'./!/application/models/arorder_model.php'),(20784297,5491,'./!/application/models/arorder_model.php'),(20784296,5205,'./!/application/models/arorder_model.php'),(20784295,19744,'./!/application/models/arorder_model.php'),(20784294,591,'./!/application/models/arorder_model.php'),(20784293,19210,'./!/application/models/arorder_model.php'),(20784292,355,'./!/application/models/arorder_model.php'),(20784291,18835,'./!/application/models/arorder_model.php'),(20784290,20014,'./!/application/models/arorder_model.php'),(20784289,197,'./!/application/models/arorder_model.php'),(20784354,17967,'./!/application/models/customer_model.php'),(20784353,19456,'./!/application/models/customer_model.php'),(20784352,15921,'./!/application/models/customer_model.php'),(20784361,18816,'./!/application/models/dnsmxcache_model.php'),(20784360,20019,'./!/application/models/dnsmxcache_model.php'),(20784359,20018,'./!/application/models/dnsmxcache_model.php'),(20784358,20017,'./!/application/models/dnsmxcache_model.php'),(20784406,6944,'./!/application/models/invpodetail_model.php'),(20784405,19206,'./!/application/models/invpodetail_model.php'),(20784435,3450,'./!/application/models/membershiptracker_model.php'),(20784558,6318,'./!/application/views/apbill/apbillsplitpayment.control.php'),(20784557,2225,'./!/application/views/apbill/apbillsplitpayment.control.php'),(20784556,20023,'./!/application/views/apbill/apbillsplitpayment.control.php'),(20784555,20022,'./!/application/views/apbill/apbillsplitpayment.control.php'),(20784554,20021,'./!/application/views/apbill/apbillsplitpayment.control.php'),(20784553,20020,'./!/application/views/apbill/apbillsplitpayment.control.php'),(20784552,886,'./!/application/views/apbill/apbillsplitpayment.control.php'),(20784551,737,'./!/application/views/apbill/apbillsplitpayment.control.php'),(20784550,226,'./!/application/views/apbill/apbillsplitpayment.control.php'),(20784563,19748,'./!/application/views/appointments/admin.php'),(20784562,19747,'./!/application/views/appointments/admin.php'),(20784561,17468,'./!/application/views/appointments/admin.php'),(20784560,3533,'./!/application/views/appointments/admin.php'),(20784659,16569,'./!/application/views/appointments/summary.php'),(20784658,16568,'./!/application/views/appointments/summary.php'),(20784657,16567,'./!/application/views/appointments/summary.php'),(20784656,20028,'./!/application/views/appointments/summary.php'),(20784655,16953,'./!/application/views/appointments/summary.php'),(20785548,17112,'./!/application/views/generic/paxTerminalCollect.php'),(20784910,18575,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20785068,1014,'./!/application/views/billtrust/export.php'),(20785067,5407,'./!/application/views/billtrust/export.php'),(20785066,541,'./!/application/views/billtrust/export.php'),(20785065,416,'./!/application/views/billtrust/export.php'),(20785193,3035,'./!/application/views/customer/emailSalesmanNotice.php'),(20785192,1935,'./!/application/views/customer/emailSalesmanNotice.php'),(20785191,670,'./!/application/views/customer/emailSalesmanNotice.php'),(20785190,20035,'./!/application/views/customer/emailSalesmanNotice.php'),(20785189,185,'./!/application/views/customer/emailSalesmanNotice.php'),(20785239,3115,'./!/application/views/customer/profitabilityReportDialog.php'),(20785238,3097,'./!/application/views/customer/profitabilityReportDialog.php'),(20785237,3434,'./!/application/views/customer/profitabilityReportDialog.php'),(20785236,2860,'./!/application/views/customer/profitabilityReportDialog.php'),(20785235,13818,'./!/application/views/customer/profitabilityReportDialog.php'),(20785234,2044,'./!/application/views/customer/profitabilityReportDialog.php'),(20785233,1703,'./!/application/views/customer/profitabilityReportDialog.php'),(20785232,1539,'./!/application/views/customer/profitabilityReportDialog.php'),(20785231,5570,'./!/application/views/customer/profitabilityReportDialog.php'),(20785307,16393,'./!/application/views/customfields/report_assignmembershipcoaches.php'),(20785306,8580,'./!/application/views/customfields/report_assignmembershipcoaches.php'),(20785305,2324,'./!/application/views/customfields/report_assignmembershipcoaches.php'),(20785304,20038,'./!/application/views/customfields/report_assignmembershipcoaches.php'),(20785303,1788,'./!/application/views/customfields/report_assignmembershipcoaches.php'),(20785302,20037,'./!/application/views/customfields/report_assignmembershipcoaches.php'),(20785301,981,'./!/application/views/customfields/report_assignmembershipcoaches.php'),(20785300,19867,'./!/application/views/customfields/report_assignmembershipcoaches.php'),(20785299,541,'./!/application/views/customfields/report_assignmembershipcoaches.php'),(20785298,20036,'./!/application/views/customfields/report_assignmembershipcoaches.php'),(20785632,2827,'./!/application/views/invcotransfer/email.php'),(20785631,2589,'./!/application/views/invcotransfer/email.php'),(20785630,2508,'./!/application/views/invcotransfer/email.php'),(20785629,4130,'./!/application/views/invcotransfer/email.php'),(20785628,869,'./!/application/views/invcotransfer/email.php'),(20785627,406,'./!/application/views/invcotransfer/email.php'),(20785651,14277,'./!/application/views/invcotransfer/pick.php'),(20785735,416,'./!/application/views/invcountbatch/liveCounts.php'),(20785734,10861,'./!/application/views/invcountbatch/liveCounts.php'),(20785803,11704,'./!/application/views/invserialnumber/editNumbersUsed.form.php'),(20785802,20040,'./!/application/views/invserialnumber/editNumbersUsed.form.php'),(20785801,2165,'./!/application/views/invserialnumber/editNumbersUsed.form.php'),(20785833,18772,'./!/application/views/item/statsPerLocation.php'),(20785832,541,'./!/application/views/item/statsPerLocation.php'),(20785831,416,'./!/application/views/item/statsPerLocation.php'),(20786254,567,'./!/application/views/priceoverriderequest/edit.php'),(20786276,10079,'./!/application/views/priceoverriderequest/request_notice_email.php'),(20786402,9962,'./!/application/views/salesregion/region_territory_list.php'),(20786401,1935,'./!/application/views/salesregion/region_territory_list.php'),(20786400,19399,'./!/application/views/salesregion/region_territory_list.php'),(20786399,19398,'./!/application/views/salesregion/region_territory_list.php'),(20786398,548,'./!/application/views/salesregion/region_territory_list.php'),(20786465,3432,'./!/application/views/salesterritory/territory_zip_list.php'),(20786464,2936,'./!/application/views/salesterritory/territory_zip_list.php'),(20786463,11535,'./!/application/views/salesterritory/territory_zip_list.php'),(20786462,799,'./!/application/views/salesterritory/territory_zip_list.php'),(20786461,15349,'./!/application/views/salesterritory/territory_zip_list.php'),(20786460,524,'./!/application/views/salesterritory/territory_zip_list.php'),(20786653,1559,'./!/application/views/template_parts/main_index.php'),(20786728,1847,'./!/application/views/writeoffreason/nprightsgroup_assignment.php'),(20786727,1540,'./!/application/views/writeoffreason/nprightsgroup_assignment.php'),(20786726,9798,'./!/application/views/writeoffreason/nprightsgroup_assignment.php'),(20804683,616,'./invpoadd.php'),(20804682,607,'./invpoadd.php'),(20804681,595,'./invpoadd.php'),(20804680,542,'./invpoadd.php'),(20804679,7587,'./invpoadd.php'),(20804678,540,'./invpoadd.php'),(20804677,20251,'./invpoadd.php'),(20804676,416,'./invpoadd.php'),(20804675,315,'./invpoadd.php'),(20804674,20138,'./invpoadd.php'),(20804673,20137,'./invpoadd.php'),(20804672,84,'./invpoadd.php'),(20804671,17615,'./invpoadd.php'),(20804670,176,'./invpoadd.php'),(20804779,20,'./invpochecklistfpdf.php'),(20804935,869,'./invporeturn.php'),(20804934,13393,'./invporeturn.php'),(20804933,315,'./invporeturn.php'),(20804932,226,'./invporeturn.php'),(20804978,12140,'./invpotoap.php'),(20804977,18865,'./invpotoap.php'),(20804976,6177,'./invpotoap.php'),(20804975,226,'./invpotoap.php'),(20804974,19445,'./invpotoap.php'),(20804973,18684,'./invpotoap.php'),(20805140,15010,'./invpoupd.php'),(20805139,591,'./invpoupd.php'),(20805138,7587,'./invpoupd.php'),(20805137,20251,'./invpoupd.php'),(20805136,441,'./invpoupd.php'),(20805135,434,'./invpoupd.php'),(20805134,416,'./invpoupd.php'),(20805133,315,'./invpoupd.php'),(20805132,5203,'./invpoupd.php'),(20805131,127,'./invpoupd.php'),(20805130,17615,'./invpoupd.php'),(20805129,59,'./invpoupd.php'),(20805492,59,'./jobupd.php'),(20805716,600,'./lookupitem_alt.php'),(20805715,542,'./lookupitem_alt.php'),(20805714,315,'./lookupitem_alt.php'),(20805713,19779,'./lookupitem_alt.php'),(20805859,8997,'./nporder.php'),(20805858,5670,'./nporder.php'),(20805857,8797,'./nporder.php'),(20805856,185,'./nporder.php'),(20805855,8674,'./nporder.php'),(20805854,13877,'./nporder.php'),(20805853,16412,'./nporder.php'),(20805852,9828,'./nporder.php'),(20805851,8673,'./nporder.php'),(20806255,5144,'./npordermiscremote.php'),(20806254,17122,'./npordermiscremote.php'),(20806284,6774,'./nporderpayment.php'),(20806283,8911,'./nporderpayment.php'),(20806282,14055,'./nporderpayment.php'),(20806415,13939,'./nporderpricehistory.php'),(20806414,13940,'./nporderpricehistory.php'),(20806428,15306,'./nporderremote.php'),(20810789,15040,'./taskuser.php'),(20811516,5882,'./includes/arbankreconcile.functions.php'),(20811562,15755,'./includes/arfunctions.php'),(20811561,15141,'./includes/arfunctions.php'),(20811560,15837,'./includes/arfunctions.php'),(20811559,17,'./includes/arfunctions.php'),(20812058,306,'./includes/arordconfirmfpdf.functions.php'),(20812088,8373,'./includes/arstateviewfpdf.functions.php'),(20812270,4871,'./includes/contactinfo.php'),(20812269,6202,'./includes/contactinfo.php'),(20812268,185,'./includes/contactinfo.php'),(20812267,6225,'./includes/contactinfo.php'),(20812266,55,'./includes/contactinfo.php'),(20812265,52,'./includes/contactinfo.php'),(20813451,8318,'./includes/dbupdateextra.php'),(20813450,3879,'./includes/dbupdateextra.php'),(20813449,14569,'./includes/dbupdateextra.php'),(20813448,3867,'./includes/dbupdateextra.php'),(20813447,15703,'./includes/dbupdateextra.php'),(20813446,7946,'./includes/dbupdateextra.php'),(20813445,13423,'./includes/dbupdateextra.php'),(20813444,16706,'./includes/dbupdateextra.php'),(20813443,7938,'./includes/dbupdateextra.php'),(20813442,3130,'./includes/dbupdateextra.php'),(20813441,4015,'./includes/dbupdateextra.php'),(20813440,5733,'./includes/dbupdateextra.php'),(20813439,9198,'./includes/dbupdateextra.php'),(20813438,9244,'./includes/dbupdateextra.php'),(20813437,12163,'./includes/dbupdateextra.php'),(20813436,3853,'./includes/dbupdateextra.php'),(20813435,3851,'./includes/dbupdateextra.php'),(20813434,12171,'./includes/dbupdateextra.php'),(20813433,3847,'./includes/dbupdateextra.php'),(20813432,7645,'./includes/dbupdateextra.php'),(20813431,16550,'./includes/dbupdateextra.php'),(20813430,12172,'./includes/dbupdateextra.php'),(20813429,7933,'./includes/dbupdateextra.php'),(20813428,7930,'./includes/dbupdateextra.php'),(20813427,3823,'./includes/dbupdateextra.php'),(20813426,3822,'./includes/dbupdateextra.php'),(20813425,3821,'./includes/dbupdateextra.php'),(20813424,3820,'./includes/dbupdateextra.php'),(20813423,12848,'./includes/dbupdateextra.php'),(20813422,5488,'./includes/dbupdateextra.php'),(20813421,2696,'./includes/dbupdateextra.php'),(20813420,3811,'./includes/dbupdateextra.php'),(20813419,12169,'./includes/dbupdateextra.php'),(20813418,7173,'./includes/dbupdateextra.php'),(20813417,15637,'./includes/dbupdateextra.php'),(20813416,5467,'./includes/dbupdateextra.php'),(20813415,3797,'./includes/dbupdateextra.php'),(20813414,16522,'./includes/dbupdateextra.php'),(20813413,7063,'./includes/dbupdateextra.php'),(20813412,12233,'./includes/dbupdateextra.php'),(20813411,3745,'./includes/dbupdateextra.php'),(20813410,15082,'./includes/dbupdateextra.php'),(20813409,5494,'./includes/dbupdateextra.php'),(20813408,3743,'./includes/dbupdateextra.php'),(20813407,3740,'./includes/dbupdateextra.php'),(20813406,7812,'./includes/dbupdateextra.php'),(20813405,7054,'./includes/dbupdateextra.php'),(20813404,7053,'./includes/dbupdateextra.php'),(20813403,7052,'./includes/dbupdateextra.php'),(20813402,15481,'./includes/dbupdateextra.php'),(20813401,2270,'./includes/dbupdateextra.php'),(20813400,3732,'./includes/dbupdateextra.php'),(20813399,7911,'./includes/dbupdateextra.php'),(20813398,15378,'./includes/dbupdateextra.php'),(20813397,3730,'./includes/dbupdateextra.php'),(20813396,2258,'./includes/dbupdateextra.php'),(20813395,6754,'./includes/dbupdateextra.php'),(20813394,15377,'./includes/dbupdateextra.php'),(20813393,4609,'./includes/dbupdateextra.php'),(20813392,5677,'./includes/dbupdateextra.php'),(20813391,7163,'./includes/dbupdateextra.php'),(20813390,7744,'./includes/dbupdateextra.php'),(20813389,2200,'./includes/dbupdateextra.php'),(20813388,8991,'./includes/dbupdateextra.php'),(20813387,3713,'./includes/dbupdateextra.php'),(20813386,7161,'./includes/dbupdateextra.php'),(20813385,5377,'./includes/dbupdateextra.php'),(20813384,15962,'./includes/dbupdateextra.php'),(20813383,3705,'./includes/dbupdateextra.php'),(20813382,9392,'./includes/dbupdateextra.php'),(20813381,7903,'./includes/dbupdateextra.php'),(20813380,11855,'./includes/dbupdateextra.php'),(20813379,1948,'./includes/dbupdateextra.php'),(20813378,3704,'./includes/dbupdateextra.php'),(20813377,8588,'./includes/dbupdateextra.php'),(20813376,8628,'./includes/dbupdateextra.php'),(20813375,14039,'./includes/dbupdateextra.php'),(20813374,1820,'./includes/dbupdateextra.php'),(20813373,15866,'./includes/dbupdateextra.php'),(20813372,7894,'./includes/dbupdateextra.php'),(20813371,8008,'./includes/dbupdateextra.php'),(20813370,3674,'./includes/dbupdateextra.php'),(20813369,4133,'./includes/dbupdateextra.php'),(20813368,7453,'./includes/dbupdateextra.php'),(20813367,3672,'./includes/dbupdateextra.php'),(20813366,3671,'./includes/dbupdateextra.php'),(20813365,7890,'./includes/dbupdateextra.php'),(20813364,15590,'./includes/dbupdateextra.php'),(20813363,9390,'./includes/dbupdateextra.php'),(20813362,7158,'./includes/dbupdateextra.php'),(20813361,8937,'./includes/dbupdateextra.php'),(20813360,3668,'./includes/dbupdateextra.php'),(20813359,13406,'./includes/dbupdateextra.php'),(20813358,3666,'./includes/dbupdateextra.php'),(20813357,1732,'./includes/dbupdateextra.php'),(20813356,11853,'./includes/dbupdateextra.php'),(20813355,4381,'./includes/dbupdateextra.php'),(20813354,14015,'./includes/dbupdateextra.php'),(20813353,12864,'./includes/dbupdateextra.php'),(20813352,3665,'./includes/dbupdateextra.php'),(20813351,6402,'./includes/dbupdateextra.php'),(20813350,11852,'./includes/dbupdateextra.php'),(20813349,3663,'./includes/dbupdateextra.php'),(20813348,3662,'./includes/dbupdateextra.php'),(20813347,15308,'./includes/dbupdateextra.php'),(20813346,7569,'./includes/dbupdateextra.php'),(20813345,16777,'./includes/dbupdateextra.php'),(20813344,15619,'./includes/dbupdateextra.php'),(20813343,3660,'./includes/dbupdateextra.php'),(20813342,12168,'./includes/dbupdateextra.php'),(20813341,8155,'./includes/dbupdateextra.php'),(20813340,1740,'./includes/dbupdateextra.php'),(20813339,12893,'./includes/dbupdateextra.php'),(20813338,15374,'./includes/dbupdateextra.php'),(20813337,9467,'./includes/dbupdateextra.php'),(20813336,4940,'./includes/dbupdateextra.php'),(20813335,3657,'./includes/dbupdateextra.php'),(20813334,16683,'./includes/dbupdateextra.php'),(20813333,11981,'./includes/dbupdateextra.php'),(20813332,9281,'./includes/dbupdateextra.php'),(20813331,1639,'./includes/dbupdateextra.php'),(20813330,12723,'./includes/dbupdateextra.php'),(20813329,16547,'./includes/dbupdateextra.php'),(20813328,14520,'./includes/dbupdateextra.php'),(20813327,8250,'./includes/dbupdateextra.php'),(20813326,13576,'./includes/dbupdateextra.php'),(20813325,7489,'./includes/dbupdateextra.php'),(20813324,7889,'./includes/dbupdateextra.php'),(20813323,8084,'./includes/dbupdateextra.php'),(20813322,7887,'./includes/dbupdateextra.php'),(20813321,16509,'./includes/dbupdateextra.php'),(20813320,12912,'./includes/dbupdateextra.php'),(20813319,16094,'./includes/dbupdateextra.php'),(20813318,19898,'./includes/dbupdateextra.php'),(20813317,13454,'./includes/dbupdateextra.php'),(20813316,8936,'./includes/dbupdateextra.php'),(20813315,7146,'./includes/dbupdateextra.php'),(20813314,3593,'./includes/dbupdateextra.php'),(20813313,12167,'./includes/dbupdateextra.php'),(20813312,12166,'./includes/dbupdateextra.php'),(20813311,3467,'./includes/dbupdateextra.php'),(20813310,11372,'./includes/dbupdateextra.php'),(20813309,14182,'./includes/dbupdateextra.php'),(20813308,12020,'./includes/dbupdateextra.php'),(20813307,7876,'./includes/dbupdateextra.php'),(20813306,5060,'./includes/dbupdateextra.php'),(20813305,3586,'./includes/dbupdateextra.php'),(20813304,6923,'./includes/dbupdateextra.php'),(20813303,11976,'./includes/dbupdateextra.php'),(20813302,7871,'./includes/dbupdateextra.php'),(20813301,951,'./includes/dbupdateextra.php'),(20813300,6969,'./includes/dbupdateextra.php'),(20813299,3581,'./includes/dbupdateextra.php'),(20813298,7865,'./includes/dbupdateextra.php'),(20813297,3580,'./includes/dbupdateextra.php'),(20813296,7143,'./includes/dbupdateextra.php'),(20813295,12174,'./includes/dbupdateextra.php'),(20813294,10625,'./includes/dbupdateextra.php'),(20813293,8336,'./includes/dbupdateextra.php'),(20813292,17467,'./includes/dbupdateextra.php'),(20813291,6755,'./includes/dbupdateextra.php'),(20813290,15758,'./includes/dbupdateextra.php'),(20813289,6316,'./includes/dbupdateextra.php'),(20813288,16917,'./includes/dbupdateextra.php'),(20813287,6317,'./includes/dbupdateextra.php'),(20813286,11846,'./includes/dbupdateextra.php'),(20813285,6465,'./includes/dbupdateextra.php'),(20813284,3458,'./includes/dbupdateextra.php'),(20813283,15757,'./includes/dbupdateextra.php'),(20813282,7121,'./includes/dbupdateextra.php'),(20813281,8653,'./includes/dbupdateextra.php'),(20813280,17171,'./includes/dbupdateextra.php'),(20813279,11843,'./includes/dbupdateextra.php'),(20813278,7136,'./includes/dbupdateextra.php'),(20813277,11037,'./includes/dbupdateextra.php'),(20813276,495,'./includes/dbupdateextra.php'),(20813275,513,'./includes/dbupdateextra.php'),(20813274,3562,'./includes/dbupdateextra.php'),(20813273,3558,'./includes/dbupdateextra.php'),(20813272,3519,'./includes/dbupdateextra.php'),(20813271,7135,'./includes/dbupdateextra.php'),(20813270,12803,'./includes/dbupdateextra.php'),(20813269,7856,'./includes/dbupdateextra.php'),(20813268,408,'./includes/dbupdateextra.php'),(20813267,3547,'./includes/dbupdateextra.php'),(20813266,3544,'./includes/dbupdateextra.php'),(20813265,7854,'./includes/dbupdateextra.php'),(20813264,15597,'./includes/dbupdateextra.php'),(20813263,16096,'./includes/dbupdateextra.php'),(20813262,3541,'./includes/dbupdateextra.php'),(20813261,7853,'./includes/dbupdateextra.php'),(20813260,8127,'./includes/dbupdateextra.php'),(20813259,8065,'./includes/dbupdateextra.php'),(20813258,5145,'./includes/dbupdateextra.php'),(20813257,195,'./includes/dbupdateextra.php'),(20813256,3537,'./includes/dbupdateextra.php'),(20813255,3533,'./includes/dbupdateextra.php'),(20813254,7844,'./includes/dbupdateextra.php'),(20813253,3523,'./includes/dbupdateextra.php'),(20813252,15752,'./includes/dbupdateextra.php'),(20813251,7842,'./includes/dbupdateextra.php'),(20813250,12826,'./includes/dbupdateextra.php'),(20813249,8230,'./includes/dbupdateextra.php'),(20813248,14136,'./includes/dbupdateextra.php'),(20813644,9580,'./includes/functions.php'),(20813643,3520,'./includes/functions.php'),(20814523,14001,'./includes/invfunctions.php'),(20814522,12928,'./includes/invfunctions.php'),(20814521,187,'./includes/invfunctions.php'),(20814520,8797,'./includes/invfunctions.php'),(20814519,185,'./includes/invfunctions.php'),(20814771,18330,'./includes/invitemaddupd.functions.php'),(20814770,18205,'./includes/invitemaddupd.functions.php'),(20814791,8797,'./includes/invoicesoldshipformat.php'),(20814790,12889,'./includes/invoicesoldshipformat.php'),(20814939,8125,'./includes/npnote.php'),(20814938,197,'./includes/npnote.php'),(20815637,4550,'./includes/home/inventory/welcome.php'),(20815636,6366,'./includes/home/inventory/welcome.php'),(20779020,18889,'./!/application/controllers/arinvoice.php'),(20779540,17913,'./!/application/controllers/arordership.php'),(20779539,197,'./!/application/controllers/arordership.php'),(20782353,8230,'./!/application/controllers/main.php'),(20781880,197,'./!/application/controllers/itempricespecial.php'),(20781879,19931,'./!/application/controllers/itempricespecial.php'),(20782354,8231,'./!/application/controllers/main.php'),(20778779,3333,'./!/application/controllers/GltransactionController.php'),(20778778,9622,'./!/application/controllers/GltransactionController.php'),(20778777,20186,'./!/application/controllers/GltransactionController.php'),(20778776,20185,'./!/application/controllers/GltransactionController.php'),(20778775,8822,'./!/application/controllers/GltransactionController.php'),(20778774,15991,'./!/application/controllers/GltransactionController.php'),(20778773,869,'./!/application/controllers/GltransactionController.php'),(20778772,9492,'./!/application/controllers/GltransactionController.php'),(20778771,226,'./!/application/controllers/GltransactionController.php'),(20778770,20,'./!/application/controllers/GltransactionController.php'),(20779019,18888,'./!/application/controllers/arinvoice.php'),(20779018,18050,'./!/application/controllers/arinvoice.php'),(20779017,581,'./!/application/controllers/arinvoice.php'),(20779016,17789,'./!/application/controllers/arinvoice.php'),(20779015,491,'./!/application/controllers/arinvoice.php'),(20779014,6165,'./!/application/controllers/arinvoice.php'),(20779013,479,'./!/application/controllers/arinvoice.php'),(20779012,15250,'./!/application/controllers/arinvoice.php'),(20779011,445,'./!/application/controllers/arinvoice.php'),(20779010,18049,'./!/application/controllers/arinvoice.php'),(20779009,17611,'./!/application/controllers/arinvoice.php'),(20779008,8185,'./!/application/controllers/arinvoice.php'),(20779007,333,'./!/application/controllers/arinvoice.php'),(20779006,9357,'./!/application/controllers/arinvoice.php'),(20779005,325,'./!/application/controllers/arinvoice.php'),(20779004,315,'./!/application/controllers/arinvoice.php'),(20779003,18480,'./!/application/controllers/arinvoice.php'),(20779002,18479,'./!/application/controllers/arinvoice.php'),(20779001,17879,'./!/application/controllers/arinvoice.php'),(20779000,5683,'./!/application/controllers/arinvoice.php'),(20778999,19692,'./!/application/controllers/arinvoice.php'),(20778998,19284,'./!/application/controllers/arinvoice.php'),(20778997,17878,'./!/application/controllers/arinvoice.php'),(20778996,5885,'./!/application/controllers/arinvoice.php'),(20778995,226,'./!/application/controllers/arinvoice.php'),(20778994,197,'./!/application/controllers/arinvoice.php'),(20778993,3537,'./!/application/controllers/arinvoice.php'),(20778992,15156,'./!/application/controllers/arinvoice.php'),(20778991,187,'./!/application/controllers/arinvoice.php'),(20778990,55,'./!/application/controllers/arinvoice.php'),(20779462,18999,'./!/application/controllers/arorder.php'),(20779335,197,'./!/application/controllers/arorder.php'),(20779622,3090,'./!/application/controllers/arordership.php'),(20779538,16525,'./!/application/controllers/arordership.php'),(20780053,4037,'./!/application/controllers/customer.php'),(20780453,7111,'./!/application/controllers/glaccount.php'),(20780534,3520,'./!/application/controllers/hubconstruction.php'),(20781182,20208,'./!/application/controllers/invcotransfertitle.php'),(20781181,3070,'./!/application/controllers/invcotransfertitle.php'),(20781180,2702,'./!/application/controllers/invcotransfertitle.php'),(20781783,17920,'./!/application/controllers/itemlocation.php'),(20783077,15776,'./!/application/controllers/main.php'),(20783112,18221,'./!/application/controllers/paymentonaccount.php'),(20783751,185,'./!/application/controllers/vendor.php'),(20783750,59,'./!/application/controllers/vendor.php'),(20783749,14778,'./!/application/controllers/vendor.php'),(20783748,6050,'./!/application/controllers/vendor.php'),(20783747,16552,'./!/application/controllers/vendor.php'),(20783955,59,'./!/application/controllers/writeoffreason.php'),(20784102,1047,'./!/application/libraries/sendformonce.php'),(20784101,20218,'./!/application/libraries/sendformonce.php'),(20784103,57,'./!/application/libraries/settings_form.php'),(20784654,59,'./!/application/views/appointments/summary.php'),(20785635,20220,'./!/application/views/invcotransfer/invcotransfertitle.php'),(20785634,20219,'./!/application/views/invcotransfer/invcotransfertitle.php'),(20785733,14832,'./!/application/views/invcountbatch/liveCounts.php'),(20786380,6830,'./!/application/views/rma_arorder/batch_create_select_orders.php'),(20786723,3115,'./!/application/views/vendor/profitabilityReportDialog.php'),(20786722,3097,'./!/application/views/vendor/profitabilityReportDialog.php'),(20786721,3434,'./!/application/views/vendor/profitabilityReportDialog.php'),(20786720,2860,'./!/application/views/vendor/profitabilityReportDialog.php'),(20786719,13818,'./!/application/views/vendor/profitabilityReportDialog.php'),(20786718,2044,'./!/application/views/vendor/profitabilityReportDialog.php'),(20786717,1539,'./!/application/views/vendor/profitabilityReportDialog.php'),(20787242,15987,'./adminarcompanyupd.php'),(20787241,20044,'./adminarcompanyupd.php'),(20787240,6490,'./adminarcompanyupd.php'),(20787239,8787,'./adminarcompanyupd.php'),(20787238,14925,'./adminarcompanyupd.php'),(20787237,14097,'./adminarcompanyupd.php'),(20787236,7477,'./adminarcompanyupd.php'),(20787235,10597,'./adminarcompanyupd.php'),(20787234,6583,'./adminarcompanyupd.php'),(20787233,16638,'./adminarcompanyupd.php'),(20787232,18932,'./adminarcompanyupd.php'),(20787231,219,'./adminarcompanyupd.php'),(20787230,197,'./adminarcompanyupd.php'),(20787229,20043,'./adminarcompanyupd.php'),(20787228,15358,'./adminarcompanyupd.php'),(20787227,15357,'./adminarcompanyupd.php'),(20787226,59,'./adminarcompanyupd.php'),(20787225,13093,'./adminarcompanyupd.php'),(20791099,52,'./apvendupd.php'),(20791976,15755,'./arcustupd.php'),(20792544,59,'./arinvoicepay.php'),(20792543,6711,'./arinvoicepay.php'),(20792542,7721,'./arinvoicepay.php'),(20793589,226,'./arinvoiceview.php'),(20793873,451,'./aritemsaleshistory.php'),(20793872,197,'./aritemsaleshistory.php'),(20794521,1357,'./arorderlist_backorder.php'),(20794520,6756,'./arorderlist_backorder.php'),(20794519,16089,'./arorderlist_backorder.php'),(20794518,941,'./arorderlist_backorder.php'),(20794517,932,'./arorderlist_backorder.php'),(20794516,869,'./arorderlist_backorder.php'),(20794515,737,'./arorderlist_backorder.php'),(20794514,20240,'./arorderlist_backorder.php'),(20794513,20239,'./arorderlist_backorder.php'),(20794512,20238,'./arorderlist_backorder.php'),(20794511,16680,'./arorderlist_backorder.php'),(20794510,16886,'./arorderlist_backorder.php'),(20794509,6307,'./arorderlist_backorder.php'),(20794508,8127,'./arorderlist_backorder.php'),(20794507,20237,'./arorderlist_backorder.php'),(20794506,197,'./arorderlist_backorder.php'),(20800916,16663,'./gljourupd.php'),(20800996,20,'./gljourupdhv.php'),(20802056,20,'./importgljournals.php'),(20803006,59,'./invitemadd.php'),(20803579,19131,'./invitemlstreorder.php'),(20803578,197,'./invitemlstreorder.php'),(20803577,16678,'./invitemlstreorder.php'),(20803576,16677,'./invitemlstreorder.php'),(20804176,18205,'./invitemupd.php'),(20804669,59,'./invpoadd.php'),(20804668,14085,'./invpoadd.php'),(20805128,14085,'./invpoupd.php'),(20806281,5670,'./nporderpayment.php'),(20806280,7721,'./nporderpayment.php'),(20806454,9828,'./npordersave.php'),(20806453,15897,'./npordersave.php'),(20806452,15755,'./npordersave.php'),(20811137,20,'./voucherdetail.php'),(20814518,14008,'./includes/invfunctions.php'),(20778989,20,'./!/application/controllers/arinvoice.php'),(20779625,47,'./!/application/controllers/b2buser.php'),(20779676,20,'./!/application/controllers/bank_deposit.php'),(20784922,3172,'./!/application/views/arinvoice/priceAdjustment.form.php'),(20805850,15755,'./nporder.php'),(20812087,20,'./includes/arstateviewfpdf.functions.php'),(20816610,4914,'./includes/home/printing/profitability_order_month.php'),(20816609,4194,'./includes/home/printing/profitability_order_month.php'),(20816608,4193,'./includes/home/printing/profitability_order_month.php'),(20816607,2182,'./includes/home/printing/profitability_order_month.php'),(20816606,4081,'./includes/home/printing/profitability_order_month.php'),(20816605,697,'./includes/home/printing/profitability_order_month.php'),(20816604,4192,'./includes/home/printing/profitability_order_month.php'),(20781782,47,'./!/application/controllers/itemlocation.php'),(20784615,17976,'./!/application/views/appointments/admin.php'),(20784792,17672,'./!/application/views/ardailyclose/create_get_system_totals.cash.php');
/*!40000 ALTER TABLE `langmatch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `langmatch_b2b`
--

DROP TABLE IF EXISTS `langmatch_b2b`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `langmatch_b2b` (
  `id` int(11) NOT NULL auto_increment,
  `langid` int(11) NOT NULL default '0',
  `page` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `langid` (`langid`),
  KEY `page` (`page`)
) ENGINE=MyISAM AUTO_INCREMENT=429266 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `langmatch_b2b`
--

LOCK TABLES `langmatch_b2b` WRITE;
/*!40000 ALTER TABLE `langmatch_b2b` DISABLE KEYS */;
INSERT INTO `langmatch_b2b` VALUES (428803,3421,'includes/arfunctions.php'),(428802,3354,'includes/arfunctions.php'),(428801,3309,'includes/arfunctions.php'),(428800,3180,'includes/arfunctions.php'),(428799,3128,'includes/arfunctions.php'),(428798,3127,'includes/arfunctions.php'),(428797,3114,'includes/arfunctions.php'),(428796,3022,'includes/arfunctions.php'),(428795,3016,'includes/arfunctions.php'),(428794,3012,'includes/arfunctions.php'),(428793,3010,'includes/arfunctions.php'),(428792,3008,'includes/arfunctions.php'),(428791,3007,'includes/arfunctions.php'),(428790,3005,'includes/arfunctions.php'),(428789,3001,'includes/arfunctions.php'),(428788,2998,'includes/arfunctions.php'),(428787,8546,'includes/arfunctions.php'),(428786,2936,'includes/arfunctions.php'),(428785,2898,'includes/arfunctions.php'),(428784,2819,'includes/arfunctions.php'),(428783,2844,'includes/arfunctions.php'),(428782,2803,'includes/arfunctions.php'),(428781,8545,'includes/arfunctions.php'),(428780,2694,'includes/arfunctions.php'),(428779,2691,'includes/arfunctions.php'),(428778,2690,'includes/arfunctions.php'),(428777,2689,'includes/arfunctions.php'),(428776,2688,'includes/arfunctions.php'),(428775,2686,'includes/arfunctions.php'),(428774,2681,'includes/arfunctions.php'),(428773,2679,'includes/arfunctions.php'),(428772,2678,'includes/arfunctions.php'),(428771,2676,'includes/arfunctions.php'),(428770,2673,'includes/arfunctions.php'),(428769,2699,'includes/arfunctions.php'),(428768,2635,'includes/arfunctions.php'),(428767,2600,'includes/arfunctions.php'),(428766,2599,'includes/arfunctions.php'),(428765,2598,'includes/arfunctions.php'),(428764,2549,'includes/arfunctions.php'),(428763,2547,'includes/arfunctions.php'),(428762,2545,'includes/arfunctions.php'),(428761,2543,'includes/arfunctions.php'),(428760,2542,'includes/arfunctions.php'),(428759,3472,'includes/arfunctions.php'),(428758,2496,'includes/arfunctions.php'),(428757,8302,'includes/arfunctions.php'),(428756,2376,'includes/arfunctions.php'),(428755,2331,'includes/arfunctions.php'),(428754,2330,'includes/arfunctions.php'),(428753,2329,'includes/arfunctions.php'),(428752,2327,'includes/arfunctions.php'),(428751,2326,'includes/arfunctions.php'),(428750,2324,'includes/arfunctions.php'),(428749,2270,'includes/arfunctions.php'),(428748,2051,'includes/arfunctions.php'),(428747,1992,'includes/arfunctions.php'),(428746,2094,'includes/arfunctions.php'),(428745,2093,'includes/arfunctions.php'),(428744,2103,'includes/arfunctions.php'),(428743,5726,'includes/arfunctions.php'),(428742,2070,'includes/arfunctions.php'),(428741,1973,'includes/arfunctions.php'),(428740,1942,'includes/arfunctions.php'),(428739,1935,'includes/arfunctions.php'),(428738,8544,'includes/arfunctions.php'),(428737,1844,'includes/arfunctions.php'),(428736,1810,'includes/arfunctions.php'),(428735,1758,'includes/arfunctions.php'),(428647,3432,'./signup_revshare.php'),(428646,7506,'./signup_revshare.php'),(428645,7505,'./signup_revshare.php'),(428644,2936,'./signup_revshare.php'),(428643,7504,'./signup_revshare.php'),(428642,7976,'./signup_revshare.php'),(428641,2326,'./signup_revshare.php'),(428640,2324,'./signup_revshare.php'),(428639,2237,'./signup_revshare.php'),(428638,2234,'./signup_revshare.php'),(428637,1963,'./signup_revshare.php'),(428636,7502,'./signup_revshare.php'),(428635,1758,'./signup_revshare.php'),(428634,7501,'./signup_revshare.php'),(428633,1429,'./signup_revshare.php'),(428632,7500,'./signup_revshare.php'),(428631,981,'./signup_revshare.php'),(428630,7499,'./signup_revshare.php'),(428629,7498,'./signup_revshare.php'),(428628,581,'./signup_revshare.php'),(428627,524,'./signup_revshare.php'),(428626,7495,'./signup_revshare.php'),(428625,7975,'./signup_revshare.php'),(428624,7974,'./signup_revshare.php'),(428623,185,'./signup_revshare.php'),(428622,3432,'./signup.php'),(428621,7506,'./signup.php'),(428620,7505,'./signup.php'),(428619,2936,'./signup.php'),(428618,7504,'./signup.php'),(428617,2326,'./signup.php'),(428616,2324,'./signup.php'),(428615,2237,'./signup.php'),(428614,2234,'./signup.php'),(428613,1963,'./signup.php'),(428612,7502,'./signup.php'),(428611,1758,'./signup.php'),(428610,7501,'./signup.php'),(428609,1429,'./signup.php'),(428608,8936,'./signup.php'),(428607,7500,'./signup.php'),(428606,981,'./signup.php'),(428605,7499,'./signup.php'),(428604,7498,'./signup.php'),(428603,581,'./signup.php'),(428602,524,'./signup.php'),(428601,7507,'./signup.php'),(428600,7496,'./signup.php'),(428599,7495,'./signup.php'),(428598,185,'./signup.php'),(428597,6442,'./shipped_detail.php'),(428596,2816,'./shipped_detail.php'),(428595,2165,'./shipped_detail.php'),(428594,1446,'./shipped_detail.php'),(428593,6441,'./shipped_detail.php'),(428592,542,'./shipped_detail.php'),(428591,442,'./shipped_detail.php'),(428590,6399,'./shipped_detail.php'),(428589,16302,'./setpw.php'),(428588,2702,'./setpw.php'),(428587,13187,'./setpw.php'),(428586,2237,'./setpw.php'),(428585,2234,'./setpw.php'),(428584,4222,'./setpw.php'),(428583,16301,'./setpw.php'),(428582,604,'./setpw.php'),(428581,4836,'./saveorder.inc'),(428580,12149,'./saveorder.inc'),(428579,12079,'./saveorder.inc'),(428578,4861,'./rep_orders.php'),(428577,2948,'./rep_orders.php'),(428576,2827,'./rep_orders.php'),(428575,6487,'./rep_orders.php'),(428574,2363,'./rep_orders.php'),(428573,2292,'./rep_orders.php'),(428572,12122,'./rep_orders.php'),(428571,5111,'./rep_orders.php'),(428570,2182,'./rep_orders.php'),(428569,2165,'./rep_orders.php'),(428568,6481,'./rep_orders.php'),(428567,1935,'./rep_orders.php'),(428566,6247,'./rep_orders.php'),(428565,1668,'./rep_orders.php'),(428564,11945,'./rep_orders.php'),(428563,11461,'./rep_orders.php'),(428562,12148,'./rep_orders.php'),(428561,1036,'./rep_orders.php'),(428560,932,'./rep_orders.php'),(428559,12147,'./rep_orders.php'),(428558,12121,'./rep_orders.php'),(428557,12146,'./rep_orders.php'),(428556,11944,'./rep_orders.php'),(428547,3421,'./prtorder_ticket.php'),(428546,3273,'./prtorder_ticket.php'),(428545,3450,'./prtorder_ticket.php'),(428544,3156,'./prtorder_ticket.php'),(428543,4738,'./prtorder_ticket.php'),(428542,4735,'./prtorder_ticket.php'),(428541,4569,'./prtorder_ticket.php'),(428540,2886,'./prtorder_ticket.php'),(428539,3923,'./prtorder_ticket.php'),(428538,2661,'./prtorder_ticket.php'),(428537,12145,'./prtorder_ticket.php'),(428536,4729,'./prtorder_ticket.php'),(428535,4807,'./prtorder_ticket.php'),(428534,4806,'./prtorder_ticket.php'),(428533,4728,'./prtorder_ticket.php'),(428532,2529,'./prtorder_ticket.php'),(428531,2471,'./prtorder_ticket.php'),(428530,4448,'./prtorder_ticket.php'),(428529,4725,'./prtorder_ticket.php'),(428528,2324,'./prtorder_ticket.php'),(428527,4723,'./prtorder_ticket.php'),(428526,4478,'./prtorder_ticket.php'),(428525,12144,'./prtorder_ticket.php'),(428524,2125,'./prtorder_ticket.php'),(428523,4102,'./prtorder_ticket.php'),(428522,12143,'./prtorder_ticket.php'),(428521,6236,'./prtorder_ticket.php'),(428520,1973,'./prtorder_ticket.php'),(428519,4721,'./prtorder_ticket.php'),(428518,4720,'./prtorder_ticket.php'),(428517,4719,'./prtorder_ticket.php'),(428516,1592,'./prtorder_ticket.php'),(428515,1589,'./prtorder_ticket.php'),(428514,4777,'./prtorder_ticket.php'),(428513,1446,'./prtorder_ticket.php'),(428512,1425,'./prtorder_ticket.php'),(428511,1373,'./prtorder_ticket.php'),(428510,12142,'./prtorder_ticket.php'),(428509,981,'./prtorder_ticket.php'),(428508,11469,'./prtorder_ticket.php'),(428507,869,'./prtorder_ticket.php'),(428506,865,'./prtorder_ticket.php'),(428505,4416,'./prtorder_ticket.php'),(428504,4363,'./prtorder_ticket.php'),(428503,665,'./prtorder_ticket.php'),(428502,3981,'./prtorder_ticket.php'),(428501,12141,'./prtorder_ticket.php'),(428500,12140,'./prtorder_ticket.php'),(428499,6161,'./prtorder_search.php'),(428498,4455,'./prtorder_search.php'),(428497,2819,'./prtorder_search.php'),(428496,2816,'./prtorder_search.php'),(428495,6924,'./prtorder_search.php'),(428494,2615,'./prtorder_search.php'),(428493,2540,'./prtorder_search.php'),(428492,2508,'./prtorder_search.php'),(428491,2363,'./prtorder_search.php'),(428490,2361,'./prtorder_search.php'),(428489,7470,'./prtorder_search.php'),(428488,2165,'./prtorder_search.php'),(428487,5083,'./prtorder_search.php'),(428486,1963,'./prtorder_search.php'),(428485,5081,'./prtorder_search.php'),(428484,1534,'./prtorder_search.php'),(428483,1456,'./prtorder_search.php'),(428482,3914,'./prtorder_search.php'),(428481,3995,'./prtorder_search.php'),(428480,1036,'./prtorder_search.php'),(428479,5080,'./prtorder_search.php'),(428478,5079,'./prtorder_search.php'),(428477,869,'./prtorder_search.php'),(428476,4363,'./prtorder_search.php'),(428475,697,'./prtorder_search.php'),(428474,610,'./prtorder_search.php'),(428473,606,'./prtorder_search.php'),(428472,5078,'./prtorder_search.php'),(428471,5076,'./prtorder_search.php'),(428470,5075,'./prtorder_search.php'),(428469,11468,'./prtorder_entry.php'),(428468,11467,'./prtorder_entry.php'),(428467,2948,'./prtorder_entry.php'),(428466,4569,'./prtorder_entry.php'),(428465,12139,'./prtorder_entry.php'),(428464,12138,'./prtorder_entry.php'),(428463,2821,'./prtorder_entry.php'),(428462,12137,'./prtorder_entry.php'),(428461,2702,'./prtorder_entry.php'),(428460,4729,'./prtorder_entry.php'),(428459,12136,'./prtorder_entry.php'),(428458,4807,'./prtorder_entry.php'),(428457,4806,'./prtorder_entry.php'),(428456,4728,'./prtorder_entry.php'),(428455,2540,'./prtorder_entry.php'),(428454,2529,'./prtorder_entry.php'),(428453,11466,'./prtorder_entry.php'),(428452,11465,'./prtorder_entry.php'),(428451,12135,'./prtorder_entry.php'),(428450,4023,'./prtorder_entry.php'),(428449,5235,'./prtorder_entry.php'),(428448,12134,'./prtorder_entry.php'),(428447,3977,'./prtorder_entry.php'),(428446,4721,'./prtorder_entry.php'),(428445,4785,'./prtorder_entry.php'),(428444,11464,'./prtorder_entry.php'),(428443,11463,'./prtorder_entry.php'),(428442,4783,'./prtorder_entry.php'),(428441,11462,'./prtorder_entry.php'),(428440,12133,'./prtorder_entry.php'),(428439,12132,'./prtorder_entry.php'),(428438,12131,'./prtorder_entry.php'),(428437,1534,'./prtorder_entry.php'),(428436,4777,'./prtorder_entry.php'),(428435,12130,'./prtorder_entry.php'),(428434,11461,'./prtorder_entry.php'),(428433,12129,'./prtorder_entry.php'),(428432,4718,'./prtorder_entry.php'),(428431,11460,'./prtorder_entry.php'),(428430,869,'./prtorder_entry.php'),(428429,4764,'./prtorder_entry.php'),(428428,11459,'./prtorder_entry.php'),(428427,4762,'./prtorder_entry.php'),(428426,11458,'./prtorder_entry.php'),(428425,4834,'./prtorder_entry.php'),(428424,4363,'./prtorder_entry.php'),(428423,695,'./prtorder_entry.php'),(428422,11457,'./prtorder_entry.php'),(428421,12128,'./prtorder_entry.php'),(428420,12127,'./prtorder_entry.php'),(428419,12126,'./prtorder_entry.php'),(428418,315,'./prtorder_entry.php'),(428417,11456,'./prtorder_entry.php'),(428416,11455,'./prtorder_entry.php'),(428415,11454,'./prtorder_entry.php'),(428414,12125,'./prtorder_entry.php'),(428413,12124,'./prtorder_entry.php'),(428412,12123,'./prtorder_entry.php'),(428411,6884,'./prtjobcopy.php'),(428410,4745,'./prtjobcopy.php'),(428409,9060,'./popcalendarlang.php'),(428408,2798,'./popcalendarlang.php'),(428407,2129,'./popcalendarlang.php'),(428406,2106,'./popcalendarlang.php'),(428405,9046,'./popcalendarlang.php'),(428404,9045,'./popcalendarlang.php'),(428403,9044,'./popcalendarlang.php'),(428402,9043,'./popcalendarlang.php'),(428401,9042,'./popcalendarlang.php'),(428400,9041,'./popcalendarlang.php'),(428399,9040,'./popcalendarlang.php'),(428398,9039,'./popcalendarlang.php'),(428397,9038,'./popcalendarlang.php'),(428396,9037,'./popcalendarlang.php'),(428395,9036,'./popcalendarlang.php'),(428394,9035,'./popcalendarlang.php'),(428393,1871,'./popcalendarlang.php'),(428392,1821,'./popcalendarlang.php'),(428391,1749,'./popcalendarlang.php'),(428390,1747,'./popcalendarlang.php'),(428389,1741,'./popcalendarlang.php'),(428388,1375,'./popcalendarlang.php'),(428387,778,'./popcalendarlang.php'),(428386,9059,'./popcalendarlang.php'),(428385,9058,'./popcalendarlang.php'),(428384,9057,'./popcalendarlang.php'),(428383,9056,'./popcalendarlang.php'),(428382,9055,'./popcalendarlang.php'),(428381,9054,'./popcalendarlang.php'),(428380,9053,'./popcalendarlang.php'),(428379,308,'./popcalendarlang.php'),(428378,275,'./popcalendarlang.php'),(428368,4738,'./originals_coversheet.php'),(428367,3071,'./originals_coversheet.php'),(428366,11453,'./originals_coversheet.php'),(428365,9881,'./originals_coversheet.php'),(428364,11452,'./originals_coversheet.php'),(428363,932,'./originals_coversheet.php'),(428362,745,'./originals_coversheet.php'),(428361,4481,'./originals_coversheet.php'),(428360,11451,'./originals_coversheet.php'),(428359,4109,'./lookupitem_alt.php'),(428358,5828,'./lookupitem_alt.php'),(428357,3292,'./lookupitem_alt.php'),(428356,3290,'./lookupitem_alt.php'),(428355,3274,'./lookupitem_alt.php'),(428354,5827,'./lookupitem_alt.php'),(428353,6369,'./lookupitem_alt.php'),(428352,2767,'./lookupitem_alt.php'),(428351,3503,'./lookupitem_alt.php'),(428350,2008,'./lookupitem_alt.php'),(428349,1963,'./lookupitem_alt.php'),(428348,1766,'./lookupitem_alt.php'),(428347,1709,'./lookupitem_alt.php'),(428346,1696,'./lookupitem_alt.php'),(428345,6368,'./lookupitem_alt.php'),(428344,6367,'./lookupitem_alt.php'),(428343,869,'./lookupitem_alt.php'),(428342,600,'./lookupitem_alt.php'),(428341,315,'./lookupitem_alt.php'),(428340,14684,'./langedit_b2b.php'),(428339,3903,'./langedit_b2b.php'),(428338,3521,'./langedit_b2b.php'),(428337,3902,'./langedit_b2b.php'),(428336,3520,'./langedit_b2b.php'),(428335,14034,'./itemsearch.php'),(428334,14033,'./itemsearch.php'),(428333,14032,'./itemsearch.php'),(428332,16300,'./itemsearch.php'),(428331,16299,'./itemsearch.php'),(428330,2453,'./itemsearch.php'),(428329,2404,'./itemsearch.php'),(428328,14031,'./itemsearch.php'),(428327,1963,'./itemsearch.php'),(428326,14030,'./itemsearch.php'),(428325,1731,'./itemsearch.php'),(428324,14029,'./itemsearch.php'),(428323,14028,'./itemsearch.php'),(428322,1709,'./itemsearch.php'),(428321,6368,'./itemsearch.php'),(428320,8936,'./itemsearch.php'),(428319,869,'./itemsearch.php'),(428318,14027,'./itemsearch.php'),(428317,315,'./itemsearch.php'),(428316,6314,'./itemsearch.php'),(428315,10909,'./itemsearch.php'),(428314,14026,'./itemsearch.php'),(428313,14025,'./itemsearch.php'),(428312,3290,'./invordline_addedit.php'),(428311,3030,'./invordline_addedit.php'),(428310,2817,'./invordline_addedit.php'),(428309,2827,'./invordline_addedit.php'),(428308,2702,'./invordline_addedit.php'),(428307,2529,'./invordline_addedit.php'),(428306,16300,'./invordline_addedit.php'),(428305,16299,'./invordline_addedit.php'),(428304,2167,'./invordline_addedit.php'),(428303,6773,'./invordline_addedit.php'),(428302,6481,'./invordline_addedit.php'),(428301,1726,'./invordline_addedit.php'),(428300,5484,'./invordline_addedit.php'),(428299,1724,'./invordline_addedit.php'),(428298,1709,'./invordline_addedit.php'),(428297,941,'./invordline_addedit.php'),(428296,799,'./invordline_addedit.php'),(428295,542,'./invordline_addedit.php'),(428294,6771,'./invordline_addedit.php'),(428293,59,'./invordline_addedit.php'),(428292,6481,'./indexvend.php'),(428291,7475,'./indexcust.php'),(428290,4861,'./indexcust.php'),(428289,6161,'./indexcust.php'),(428288,3126,'./indexcust.php'),(428287,2948,'./indexcust.php'),(428286,2819,'./indexcust.php'),(428285,2816,'./indexcust.php'),(428284,2827,'./indexcust.php'),(428283,6770,'./indexcust.php'),(428282,6487,'./indexcust.php'),(428281,4611,'./indexcust.php'),(428280,2508,'./indexcust.php'),(428279,2497,'./indexcust.php'),(428278,3964,'./indexcust.php'),(428277,2471,'./indexcust.php'),(428276,2464,'./indexcust.php'),(428275,2459,'./indexcust.php'),(428274,2363,'./indexcust.php'),(428273,2361,'./indexcust.php'),(428272,3738,'./indexcust.php'),(428271,2292,'./indexcust.php'),(428270,3436,'./indexcust.php'),(428269,12122,'./indexcust.php'),(428268,5111,'./indexcust.php'),(428267,2182,'./indexcust.php'),(428266,2165,'./indexcust.php'),(428265,4608,'./indexcust.php'),(428264,2034,'./indexcust.php'),(428263,6481,'./indexcust.php'),(428262,2103,'./indexcust.php'),(428261,1884,'./indexcust.php'),(428260,6247,'./indexcust.php'),(428259,11935,'./indexcust.php'),(428258,1668,'./indexcust.php'),(428257,1534,'./indexcust.php'),(428256,11945,'./indexcust.php'),(428255,11461,'./indexcust.php'),(428254,1456,'./indexcust.php'),(428253,6919,'./indexcust.php'),(428252,8936,'./indexcust.php'),(428251,1036,'./indexcust.php'),(428250,13855,'./indexcust.php'),(428249,932,'./indexcust.php'),(428248,7685,'./indexcust.php'),(428247,4602,'./indexcust.php'),(428246,6441,'./indexcust.php'),(428245,869,'./indexcust.php'),(428244,6918,'./indexcust.php'),(428243,4416,'./indexcust.php'),(428242,697,'./indexcust.php'),(428241,11450,'./indexcust.php'),(428240,7474,'./indexcust.php'),(428239,4601,'./indexcust.php'),(428238,5475,'./indexcust.php'),(428237,7612,'./indexcust.php'),(428236,14082,'./indexcust.php'),(428235,12121,'./indexcust.php'),(428234,12120,'./indexcust.php'),(428233,12119,'./indexcust.php'),(428232,8046,'./indexcust.php'),(428231,11944,'./indexcust.php'),(428230,6481,'./indexagent.php'),(428229,6481,'./indexagency.php'),(428228,930,'./gl_export_report.php'),(428227,655,'./gl_export_report.php'),(428226,542,'./gl_export_report.php'),(428225,531,'./gl_export_report.php'),(428224,430,'./gl_export_report.php'),(428223,315,'./gl_export_report.php'),(428222,6176,'./fileupload.php'),(428221,6175,'./fileupload.php'),(428220,3427,'./estquotepackingslip.php'),(428219,5569,'./estquotepackingslip.php'),(428218,5582,'./estquotepackingslip.php'),(428217,4569,'./estquotepackingslip.php'),(428216,4568,'./estquotepackingslip.php'),(428215,4567,'./estquotepackingslip.php'),(428214,2529,'./estquotepackingslip.php'),(428213,4566,'./estquotepackingslip.php'),(428212,5584,'./estquotepackingslip.php'),(428211,4565,'./estquotepackingslip.php'),(428210,4564,'./estquotepackingslip.php'),(428209,4915,'./estquotepackingslip.php'),(428208,1963,'./estquotepackingslip.php'),(428207,4720,'./estquotepackingslip.php'),(428206,1467,'./estquotepackingslip.php'),(428205,3914,'./estquotepackingslip.php'),(428204,5282,'./estquotepackingslip.php'),(428203,4562,'./estquotepackingslip.php'),(428202,5093,'./estquotepackingslip.php'),(428201,869,'./estquotepackingslip.php'),(428200,737,'./estquotepackingslip.php'),(428199,542,'./estquotepackingslip.php'),(428198,4560,'./estquotepackingslip.php'),(428197,387,'./estquotepackingslip.php'),(428196,7473,'./estquoteordersearch.php'),(428195,5569,'./estquoteordersearch.php'),(428194,7614,'./estquoteordersearch.php'),(428193,6161,'./estquoteordersearch.php'),(428192,2959,'./estquoteordersearch.php'),(428191,2886,'./estquoteordersearch.php'),(428190,2821,'./estquoteordersearch.php'),(428189,2819,'./estquoteordersearch.php'),(428188,2816,'./estquoteordersearch.php'),(428187,7220,'./estquoteordersearch.php'),(428186,7472,'./estquoteordersearch.php'),(428185,7613,'./estquoteordersearch.php'),(428184,5084,'./estquoteordersearch.php'),(428183,2508,'./estquoteordersearch.php'),(428182,2480,'./estquoteordersearch.php'),(428181,3964,'./estquoteordersearch.php'),(428180,2464,'./estquoteordersearch.php'),(428179,7470,'./estquoteordersearch.php'),(428178,2165,'./estquoteordersearch.php'),(428177,5083,'./estquoteordersearch.php'),(428176,7696,'./estquoteordersearch.php'),(428175,1963,'./estquoteordersearch.php'),(428174,1456,'./estquoteordersearch.php'),(428173,6919,'./estquoteordersearch.php'),(428172,1036,'./estquoteordersearch.php'),(428171,5080,'./estquoteordersearch.php'),(428170,5079,'./estquoteordersearch.php'),(428169,941,'./estquoteordersearch.php'),(428168,7685,'./estquoteordersearch.php'),(428167,869,'./estquoteordersearch.php'),(428166,7690,'./estquoteordersearch.php'),(428165,7695,'./estquoteordersearch.php'),(428164,5475,'./estquoteordersearch.php'),(428163,7612,'./estquoteordersearch.php'),(428162,5076,'./estquoteordersearch.php'),(428161,5075,'./estquoteordersearch.php'),(428160,13144,'./estquoteordersearch.php'),(428159,3427,'./estquotejobticket_ow_fpdf.php'),(428158,5569,'./estquotejobticket_ow_fpdf.php'),(428157,5588,'./estquotejobticket_ow_fpdf.php'),(428156,3380,'./estquotejobticket_ow_fpdf.php'),(428155,3355,'./estquotejobticket_ow_fpdf.php'),(428154,4126,'./estquotejobticket_ow_fpdf.php'),(428153,3151,'./estquotejobticket_ow_fpdf.php'),(428152,6894,'./estquotejobticket_ow_fpdf.php'),(428151,6893,'./estquotejobticket_ow_fpdf.php'),(428150,2950,'./estquotejobticket_ow_fpdf.php'),(428149,2886,'./estquotejobticket_ow_fpdf.php'),(428148,5164,'./estquotejobticket_ow_fpdf.php'),(428147,6892,'./estquotejobticket_ow_fpdf.php'),(428146,5687,'./estquotejobticket_ow_fpdf.php'),(428145,5686,'./estquotejobticket_ow_fpdf.php'),(428144,12851,'./estquotejobticket_ow_fpdf.php'),(428143,13414,'./estquotejobticket_ow_fpdf.php'),(428142,2529,'./estquotejobticket_ow_fpdf.php'),(428141,2508,'./estquotejobticket_ow_fpdf.php'),(428140,13581,'./estquotejobticket_ow_fpdf.php'),(428139,13580,'./estquotejobticket_ow_fpdf.php'),(428138,6889,'./estquotejobticket_ow_fpdf.php'),(428137,2324,'./estquotejobticket_ow_fpdf.php'),(428136,13238,'./estquotejobticket_ow_fpdf.php'),(428135,13237,'./estquotejobticket_ow_fpdf.php'),(428134,13442,'./estquotejobticket_ow_fpdf.php'),(428133,13449,'./estquotejobticket_ow_fpdf.php'),(428132,6887,'./estquotejobticket_ow_fpdf.php'),(428131,2165,'./estquotejobticket_ow_fpdf.php'),(428130,13236,'./estquotejobticket_ow_fpdf.php'),(428129,13235,'./estquotejobticket_ow_fpdf.php'),(428128,8368,'./estquotejobticket_ow_fpdf.php'),(428127,1963,'./estquotejobticket_ow_fpdf.php'),(428126,5685,'./estquotejobticket_ow_fpdf.php'),(428125,5081,'./estquotejobticket_ow_fpdf.php'),(428124,13234,'./estquotejobticket_ow_fpdf.php'),(428123,13441,'./estquotejobticket_ow_fpdf.php'),(428122,1610,'./estquotejobticket_ow_fpdf.php'),(428121,13440,'./estquotejobticket_ow_fpdf.php'),(428120,1592,'./estquotejobticket_ow_fpdf.php'),(428119,11873,'./estquotejobticket_ow_fpdf.php'),(428118,11872,'./estquotejobticket_ow_fpdf.php'),(428117,1456,'./estquotejobticket_ow_fpdf.php'),(428116,1373,'./estquotejobticket_ow_fpdf.php'),(428115,13413,'./estquotejobticket_ow_fpdf.php'),(428114,5684,'./estquotejobticket_ow_fpdf.php'),(428113,982,'./estquotejobticket_ow_fpdf.php'),(428112,981,'./estquotejobticket_ow_fpdf.php'),(428111,938,'./estquotejobticket_ow_fpdf.php'),(428110,13373,'./estquotejobticket_ow_fpdf.php'),(428109,4602,'./estquotejobticket_ow_fpdf.php'),(428108,13448,'./estquotejobticket_ow_fpdf.php'),(428107,869,'./estquotejobticket_ow_fpdf.php'),(428106,13437,'./estquotejobticket_ow_fpdf.php'),(428105,719,'./estquotejobticket_ow_fpdf.php'),(428104,717,'./estquotejobticket_ow_fpdf.php'),(428103,716,'./estquotejobticket_ow_fpdf.php'),(428102,13447,'./estquotejobticket_ow_fpdf.php'),(428101,13436,'./estquotejobticket_ow_fpdf.php'),(428100,542,'./estquotejobticket_ow_fpdf.php'),(428099,5536,'./estquotejobticket_ow_fpdf.php'),(428098,540,'./estquotejobticket_ow_fpdf.php'),(428097,13446,'./estquotejobticket_ow_fpdf.php'),(428096,7347,'./estquotejobticket_ow_fpdf.php'),(428095,306,'./estquotejobticket_ow_fpdf.php'),(428094,8873,'./estquotejobticket_ow_fpdf.php'),(428093,13571,'./estquotejobticket_ow_fpdf.php'),(428092,191,'./estquotejobticket_ow_fpdf.php'),(428091,13372,'./estquotejobticket_ow_fpdf.php'),(428090,2959,'./estquoteeditsearch.php'),(428089,2950,'./estquoteeditsearch.php'),(428088,2886,'./estquoteeditsearch.php'),(428087,2747,'./estquoteeditsearch.php'),(428086,7219,'./estquoteeditsearch.php'),(428085,2540,'./estquoteeditsearch.php'),(428084,2459,'./estquoteeditsearch.php'),(428083,1036,'./estquoteeditsearch.php'),(428082,6461,'./estquoteeditsearch.php'),(428081,869,'./estquoteeditsearch.php'),(428080,799,'./estquoteeditsearch.php'),(428079,606,'./estquoteeditsearch.php'),(428078,6460,'./estquoteeditsearch.php'),(428077,5203,'./estquoteeditsearch.php'),(428076,3427,'./estquoteaddshipmail.php'),(428075,5569,'./estquoteaddshipmail.php'),(428074,3355,'./estquoteaddshipmail.php'),(428073,4126,'./estquoteaddshipmail.php'),(428072,6901,'./estquoteaddshipmail.php'),(428071,6893,'./estquoteaddshipmail.php'),(428070,4176,'./estquoteaddshipmail.php'),(428069,6892,'./estquoteaddshipmail.php'),(428068,6900,'./estquoteaddshipmail.php'),(428067,6899,'./estquoteaddshipmail.php'),(428066,6898,'./estquoteaddshipmail.php'),(428065,2508,'./estquoteaddshipmail.php'),(428064,2324,'./estquoteaddshipmail.php'),(428063,6888,'./estquoteaddshipmail.php'),(428062,6897,'./estquoteaddshipmail.php'),(428061,4173,'./estquoteaddshipmail.php'),(428060,6887,'./estquoteaddshipmail.php'),(428059,2099,'./estquoteaddshipmail.php'),(428058,6896,'./estquoteaddshipmail.php'),(428057,1456,'./estquoteaddshipmail.php'),(428056,1446,'./estquoteaddshipmail.php'),(428055,1373,'./estquoteaddshipmail.php'),(428054,986,'./estquoteaddshipmail.php'),(428053,982,'./estquoteaddshipmail.php'),(428052,981,'./estquoteaddshipmail.php'),(428051,869,'./estquoteaddshipmail.php'),(428050,719,'./estquoteaddshipmail.php'),(428049,716,'./estquoteaddshipmail.php'),(428048,542,'./estquoteaddshipmail.php'),(428047,540,'./estquoteaddshipmail.php'),(428046,6895,'./estquoteaddshipmail.php'),(428045,191,'./estquoteaddshipmail.php'),(428044,3427,'./estquoteaddjobmail_ow_fpdf.php'),(428043,5569,'./estquoteaddjobmail_ow_fpdf.php'),(428042,8874,'./estquoteaddjobmail_ow_fpdf.php'),(428041,3380,'./estquoteaddjobmail_ow_fpdf.php'),(428040,3355,'./estquoteaddjobmail_ow_fpdf.php'),(428039,4126,'./estquoteaddjobmail_ow_fpdf.php'),(428038,3151,'./estquoteaddjobmail_ow_fpdf.php'),(428037,6894,'./estquoteaddjobmail_ow_fpdf.php'),(428036,3090,'./estquoteaddjobmail_ow_fpdf.php'),(428035,12118,'./estquoteaddjobmail_ow_fpdf.php'),(428034,6893,'./estquoteaddjobmail_ow_fpdf.php'),(428033,2950,'./estquoteaddjobmail_ow_fpdf.php'),(428032,2886,'./estquoteaddjobmail_ow_fpdf.php'),(428031,5164,'./estquoteaddjobmail_ow_fpdf.php'),(428030,6892,'./estquoteaddjobmail_ow_fpdf.php'),(428029,12851,'./estquoteaddjobmail_ow_fpdf.php'),(428028,13414,'./estquoteaddjobmail_ow_fpdf.php'),(428027,2529,'./estquoteaddjobmail_ow_fpdf.php'),(428026,2508,'./estquoteaddjobmail_ow_fpdf.php'),(428025,13581,'./estquoteaddjobmail_ow_fpdf.php'),(428024,13580,'./estquoteaddjobmail_ow_fpdf.php'),(428023,13374,'./estquoteaddjobmail_ow_fpdf.php'),(428022,6889,'./estquoteaddjobmail_ow_fpdf.php'),(428021,2324,'./estquoteaddjobmail_ow_fpdf.php'),(428020,13238,'./estquoteaddjobmail_ow_fpdf.php'),(428019,13237,'./estquoteaddjobmail_ow_fpdf.php'),(428018,13442,'./estquoteaddjobmail_ow_fpdf.php'),(428017,6888,'./estquoteaddjobmail_ow_fpdf.php'),(428016,2208,'./estquoteaddjobmail_ow_fpdf.php'),(428015,6887,'./estquoteaddjobmail_ow_fpdf.php'),(428014,3502,'./estquoteaddjobmail_ow_fpdf.php'),(428013,2165,'./estquoteaddjobmail_ow_fpdf.php'),(428012,13236,'./estquoteaddjobmail_ow_fpdf.php'),(428011,13235,'./estquoteaddjobmail_ow_fpdf.php'),(428010,8368,'./estquoteaddjobmail_ow_fpdf.php'),(428009,13234,'./estquoteaddjobmail_ow_fpdf.php'),(428008,13441,'./estquoteaddjobmail_ow_fpdf.php'),(428007,1610,'./estquoteaddjobmail_ow_fpdf.php'),(428006,13440,'./estquoteaddjobmail_ow_fpdf.php'),(428005,11873,'./estquoteaddjobmail_ow_fpdf.php'),(428004,11872,'./estquoteaddjobmail_ow_fpdf.php'),(428003,1456,'./estquoteaddjobmail_ow_fpdf.php'),(428002,1373,'./estquoteaddjobmail_ow_fpdf.php'),(428001,13413,'./estquoteaddjobmail_ow_fpdf.php'),(428000,981,'./estquoteaddjobmail_ow_fpdf.php'),(427999,938,'./estquoteaddjobmail_ow_fpdf.php'),(427998,13373,'./estquoteaddjobmail_ow_fpdf.php'),(427997,4602,'./estquoteaddjobmail_ow_fpdf.php'),(427996,869,'./estquoteaddjobmail_ow_fpdf.php'),(427995,13437,'./estquoteaddjobmail_ow_fpdf.php'),(427994,719,'./estquoteaddjobmail_ow_fpdf.php'),(427993,717,'./estquoteaddjobmail_ow_fpdf.php'),(427992,716,'./estquoteaddjobmail_ow_fpdf.php'),(427991,13436,'./estquoteaddjobmail_ow_fpdf.php'),(427990,542,'./estquoteaddjobmail_ow_fpdf.php'),(427989,540,'./estquoteaddjobmail_ow_fpdf.php'),(427988,13412,'./estquoteaddjobmail_ow_fpdf.php'),(427987,7347,'./estquoteaddjobmail_ow_fpdf.php'),(427986,306,'./estquoteaddjobmail_ow_fpdf.php'),(427985,8873,'./estquoteaddjobmail_ow_fpdf.php'),(427984,13571,'./estquoteaddjobmail_ow_fpdf.php'),(427983,191,'./estquoteaddjobmail_ow_fpdf.php'),(427982,13372,'./estquoteaddjobmail_ow_fpdf.php'),(420347,5569,'./estquoteaddjobmail_insert.php'),(420346,3380,'./estquoteaddjobmail_insert.php'),(420345,3355,'./estquoteaddjobmail_insert.php'),(420344,4126,'./estquoteaddjobmail_insert.php'),(420343,4861,'./estquoteaddjobmail_insert.php'),(420342,6876,'./estquoteaddjobmail_insert.php'),(420341,3151,'./estquoteaddjobmail_insert.php'),(420340,6894,'./estquoteaddjobmail_insert.php'),(420339,3065,'./estquoteaddjobmail_insert.php'),(420338,6893,'./estquoteaddjobmail_insert.php'),(420337,2950,'./estquoteaddjobmail_insert.php'),(420336,2886,'./estquoteaddjobmail_insert.php'),(420335,5164,'./estquoteaddjobmail_insert.php'),(420334,6892,'./estquoteaddjobmail_insert.php'),(420333,2833,'./estquoteaddjobmail_insert.php'),(420332,2661,'./estquoteaddjobmail_insert.php'),(420331,2616,'./estquoteaddjobmail_insert.php'),(420330,2529,'./estquoteaddjobmail_insert.php'),(420329,6875,'./estquoteaddjobmail_insert.php'),(420328,6874,'./estquoteaddjobmail_insert.php'),(420327,6889,'./estquoteaddjobmail_insert.php'),(420326,2357,'./estquoteaddjobmail_insert.php'),(420325,2324,'./estquoteaddjobmail_insert.php'),(420324,6888,'./estquoteaddjobmail_insert.php'),(420323,2208,'./estquoteaddjobmail_insert.php'),(420322,6887,'./estquoteaddjobmail_insert.php'),(420321,6886,'./estquoteaddjobmail_insert.php'),(420320,8368,'./estquoteaddjobmail_insert.php'),(420319,1610,'./estquoteaddjobmail_insert.php'),(420318,1373,'./estquoteaddjobmail_insert.php'),(420317,6885,'./estquoteaddjobmail_insert.php'),(420316,5163,'./estquoteaddjobmail_insert.php'),(420315,981,'./estquoteaddjobmail_insert.php'),(420314,869,'./estquoteaddjobmail_insert.php'),(420313,719,'./estquoteaddjobmail_insert.php'),(420312,716,'./estquoteaddjobmail_insert.php'),(420311,8369,'./estquoteaddjobmail_insert.php'),(420310,3929,'./estquoteaddjobmail_insert.php'),(420309,7694,'./estquoteaddjobmail_insert.php'),(420308,191,'./estquoteaddjobmail_insert.php'),(427981,3427,'./estquoteaddjobmail.php'),(427980,5569,'./estquoteaddjobmail.php'),(427979,8874,'./estquoteaddjobmail.php'),(427978,3380,'./estquoteaddjobmail.php'),(427977,3355,'./estquoteaddjobmail.php'),(427976,4126,'./estquoteaddjobmail.php'),(427975,4861,'./estquoteaddjobmail.php'),(427974,3151,'./estquoteaddjobmail.php'),(427973,6894,'./estquoteaddjobmail.php'),(427972,12118,'./estquoteaddjobmail.php'),(427971,6893,'./estquoteaddjobmail.php'),(427970,2950,'./estquoteaddjobmail.php'),(427969,2909,'./estquoteaddjobmail.php'),(427968,2886,'./estquoteaddjobmail.php'),(427967,5164,'./estquoteaddjobmail.php'),(427966,6892,'./estquoteaddjobmail.php'),(427965,6891,'./estquoteaddjobmail.php'),(427964,12851,'./estquoteaddjobmail.php'),(427963,2661,'./estquoteaddjobmail.php'),(427962,13662,'./estquoteaddjobmail.php'),(427961,2529,'./estquoteaddjobmail.php'),(427960,2508,'./estquoteaddjobmail.php'),(427959,6875,'./estquoteaddjobmail.php'),(427958,6874,'./estquoteaddjobmail.php'),(427957,6889,'./estquoteaddjobmail.php'),(427956,2357,'./estquoteaddjobmail.php'),(427955,2324,'./estquoteaddjobmail.php'),(427954,6888,'./estquoteaddjobmail.php'),(427953,2208,'./estquoteaddjobmail.php'),(427952,6887,'./estquoteaddjobmail.php'),(427951,6886,'./estquoteaddjobmail.php'),(427950,2165,'./estquoteaddjobmail.php'),(427949,8368,'./estquoteaddjobmail.php'),(427948,2103,'./estquoteaddjobmail.php'),(427947,1610,'./estquoteaddjobmail.php'),(427946,11873,'./estquoteaddjobmail.php'),(427945,11872,'./estquoteaddjobmail.php'),(427944,12117,'./estquoteaddjobmail.php'),(427943,1446,'./estquoteaddjobmail.php'),(427942,1373,'./estquoteaddjobmail.php'),(427941,6885,'./estquoteaddjobmail.php'),(427940,986,'./estquoteaddjobmail.php'),(427939,982,'./estquoteaddjobmail.php'),(427938,981,'./estquoteaddjobmail.php'),(427937,13668,'./estquoteaddjobmail.php'),(427936,13667,'./estquoteaddjobmail.php'),(427935,869,'./estquoteaddjobmail.php'),(427934,719,'./estquoteaddjobmail.php'),(427933,716,'./estquoteaddjobmail.php'),(427932,8369,'./estquoteaddjobmail.php'),(427931,3929,'./estquoteaddjobmail.php'),(427930,542,'./estquoteaddjobmail.php'),(427929,540,'./estquoteaddjobmail.php'),(427928,306,'./estquoteaddjobmail.php'),(427927,8873,'./estquoteaddjobmail.php'),(427926,191,'./estquoteaddjobmail.php'),(427925,6884,'./estquoteaddjobcopy.php'),(427924,3156,'./estquoteaddjob_wt2.php'),(427923,13259,'./estquoteaddjob_wt2.php'),(427922,13258,'./estquoteaddjob_wt2.php'),(427921,13257,'./estquoteaddjob_wt2.php'),(427920,13256,'./estquoteaddjob_wt2.php'),(427919,13241,'./estquoteaddjob_wt2.php'),(427918,13255,'./estquoteaddjob_wt2.php'),(427917,13371,'./estquoteaddjob_wt2.php'),(427916,13254,'./estquoteaddjob_wt2.php'),(427915,2561,'./estquoteaddjob_wt2.php'),(427914,13253,'./estquoteaddjob_wt2.php'),(427913,13252,'./estquoteaddjob_wt2.php'),(427912,13324,'./estquoteaddjob_wt2.php'),(427911,13251,'./estquoteaddjob_wt2.php'),(427910,3912,'./estquoteaddjob_wt2.php'),(427909,13250,'./estquoteaddjob_wt2.php'),(427908,13249,'./estquoteaddjob_wt2.php'),(427907,13248,'./estquoteaddjob_wt2.php'),(427906,13323,'./estquoteaddjob_wt2.php'),(427905,13233,'./estquoteaddjob_wt2.php'),(427904,13247,'./estquoteaddjob_wt2.php'),(427903,13246,'./estquoteaddjob_wt2.php'),(427902,737,'./estquoteaddjob_wt2.php'),(427901,13245,'./estquoteaddjob_wt2.php'),(427900,550,'./estquoteaddjob_wt2.php'),(427899,13244,'./estquoteaddjob_wt2.php'),(427898,315,'./estquoteaddjob_wt2.php'),(427897,13243,'./estquoteaddjob_wt2.php'),(427896,5503,'./estquoteaddjob_wt2.php'),(427895,13242,'./estquoteaddjob_wt1.php'),(427894,13241,'./estquoteaddjob_wt1.php'),(427893,13240,'./estquoteaddjob_wt1.php'),(427892,2561,'./estquoteaddjob_wt1.php'),(427891,13582,'./estquoteaddjob_wt1.php'),(427890,13581,'./estquoteaddjob_wt1.php'),(427889,13580,'./estquoteaddjob_wt1.php'),(427888,13238,'./estquoteaddjob_wt1.php'),(427887,13237,'./estquoteaddjob_wt1.php'),(427886,13197,'./estquoteaddjob_wt1.php'),(427885,13236,'./estquoteaddjob_wt1.php'),(427884,13235,'./estquoteaddjob_wt1.php'),(427883,2071,'./estquoteaddjob_wt1.php'),(427882,1963,'./estquoteaddjob_wt1.php'),(427881,1934,'./estquoteaddjob_wt1.php'),(427880,3912,'./estquoteaddjob_wt1.php'),(427879,13234,'./estquoteaddjob_wt1.php'),(427878,13196,'./estquoteaddjob_wt1.php'),(427877,13322,'./estquoteaddjob_wt1.php'),(427876,13233,'./estquoteaddjob_wt1.php'),(427875,13321,'./estquoteaddjob_wt1.php'),(427874,13231,'./estquoteaddjob_wt1.php'),(427873,13230,'./estquoteaddjob_wt1.php'),(427872,695,'./estquoteaddjob_wt1.php'),(427871,13229,'./estquoteaddjob_wt1.php'),(427870,13228,'./estquoteaddjob_wt1.php'),(427869,550,'./estquoteaddjob_wt1.php'),(427868,7995,'./estquoteaddjob2.php'),(427867,13854,'./estquoteaddjob2.php'),(427866,5917,'./estquoteaddjob2.php'),(427865,5916,'./estquoteaddjob2.php'),(427864,5915,'./estquoteaddjob2.php'),(427863,5914,'./estquoteaddjob2.php'),(427862,5913,'./estquoteaddjob2.php'),(427861,3912,'./estquoteaddjob2.php'),(427860,12116,'./estquoteaddjob2.php'),(427859,3995,'./estquoteaddjob2.php'),(427858,941,'./estquoteaddjob2.php'),(427857,6918,'./estquoteaddjob2.php'),(427856,13853,'./estquoteaddjob2.php'),(427855,12083,'./estquoteaddjob2.php'),(427854,8301,'./estquoteaddjob.php'),(427853,8300,'./estquoteaddjob.php'),(427852,8298,'./estquoteaddjob.php'),(427851,11902,'./estquoteaddjob.php'),(427850,8297,'./estquoteaddjob.php'),(427849,5597,'./estquoteaddjob.php'),(427848,3909,'./estquoteaddjob.php'),(427847,3910,'./estquoteaddjob.php'),(427846,3907,'./estquoteaddjob.php'),(427845,3269,'./estquoteaddjob.php'),(427844,2959,'./estquoteaddjob.php'),(427843,2950,'./estquoteaddjob.php'),(427842,3957,'./estquoteaddjob.php'),(427841,13320,'./estquoteaddjob.php'),(427840,12730,'./estquoteaddjob.php'),(427839,7693,'./estquoteaddjob.php'),(427838,2821,'./estquoteaddjob.php'),(427837,2820,'./estquoteaddjob.php'),(427836,13444,'./estquoteaddjob.php'),(427835,8366,'./estquoteaddjob.php'),(427834,13663,'./estquoteaddjob.php'),(427833,13319,'./estquoteaddjob.php'),(427832,13662,'./estquoteaddjob.php'),(427831,11953,'./estquoteaddjob.php'),(427830,2529,'./estquoteaddjob.php'),(427829,13165,'./estquoteaddjob.php'),(427828,3906,'./estquoteaddjob.php'),(427827,2361,'./estquoteaddjob.php'),(427826,12698,'./estquoteaddjob.php'),(427825,3933,'./estquoteaddjob.php'),(427824,13163,'./estquoteaddjob.php'),(427823,13162,'./estquoteaddjob.php'),(427822,13318,'./estquoteaddjob.php'),(427821,12031,'./estquoteaddjob.php'),(427820,2125,'./estquoteaddjob.php'),(427819,12729,'./estquoteaddjob.php'),(427818,6869,'./estquoteaddjob.php'),(427817,2103,'./estquoteaddjob.php'),(427816,2070,'./estquoteaddjob.php'),(427815,1963,'./estquoteaddjob.php'),(427814,1724,'./estquoteaddjob.php'),(427813,1709,'./estquoteaddjob.php'),(427812,13161,'./estquoteaddjob.php'),(427811,1639,'./estquoteaddjob.php'),(427810,12113,'./estquoteaddjob.php'),(427809,12112,'./estquoteaddjob.php'),(427808,1610,'./estquoteaddjob.php'),(427807,13852,'./estquoteaddjob.php'),(427806,1456,'./estquoteaddjob.php'),(427805,1425,'./estquoteaddjob.php'),(427804,3905,'./estquoteaddjob.php'),(427803,941,'./estquoteaddjob.php'),(427802,869,'./estquoteaddjob.php'),(427801,4764,'./estquoteaddjob.php'),(427800,12029,'./estquoteaddjob.php'),(427799,716,'./estquoteaddjob.php'),(427798,699,'./estquoteaddjob.php'),(427797,684,'./estquoteaddjob.php'),(427796,13661,'./estquoteaddjob.php'),(427795,13660,'./estquoteaddjob.php'),(427794,5536,'./estquoteaddjob.php'),(427793,8625,'./estquoteaddjob.php'),(427792,6121,'./estquoteaddjob.php'),(427791,451,'./estquoteaddjob.php'),(427790,13111,'./estquoteaddjob.php'),(427789,13110,'./estquoteaddjob.php'),(427788,13109,'./estquoteaddjob.php'),(427787,315,'./estquoteaddjob.php'),(427786,306,'./estquoteaddjob.php'),(427785,12743,'./estquoteaddjob.php'),(427784,8365,'./estquoteaddjob.php'),(427783,8549,'./estquoteaddjob.php'),(427782,59,'./estquoteaddjob.php'),(427781,3908,'./estquoteaddjob.php'),(427780,3427,'./estquoteaddformmail_ow_fpdf.php'),(427779,5569,'./estquoteaddformmail_ow_fpdf.php'),(427778,8874,'./estquoteaddformmail_ow_fpdf.php'),(427777,3380,'./estquoteaddformmail_ow_fpdf.php'),(427776,3355,'./estquoteaddformmail_ow_fpdf.php'),(427775,4126,'./estquoteaddformmail_ow_fpdf.php'),(427774,3151,'./estquoteaddformmail_ow_fpdf.php'),(427773,6894,'./estquoteaddformmail_ow_fpdf.php'),(427772,3090,'./estquoteaddformmail_ow_fpdf.php'),(427771,13443,'./estquoteaddformmail_ow_fpdf.php'),(427770,6893,'./estquoteaddformmail_ow_fpdf.php'),(427769,2950,'./estquoteaddformmail_ow_fpdf.php'),(427768,2886,'./estquoteaddformmail_ow_fpdf.php'),(427767,5164,'./estquoteaddformmail_ow_fpdf.php'),(427766,6892,'./estquoteaddformmail_ow_fpdf.php'),(427765,5687,'./estquoteaddformmail_ow_fpdf.php'),(427764,5686,'./estquoteaddformmail_ow_fpdf.php'),(427763,13414,'./estquoteaddformmail_ow_fpdf.php'),(427762,2540,'./estquoteaddformmail_ow_fpdf.php'),(427761,2529,'./estquoteaddformmail_ow_fpdf.php'),(427760,2508,'./estquoteaddformmail_ow_fpdf.php'),(427759,13581,'./estquoteaddformmail_ow_fpdf.php'),(427758,13580,'./estquoteaddformmail_ow_fpdf.php'),(427757,13374,'./estquoteaddformmail_ow_fpdf.php'),(427756,6889,'./estquoteaddformmail_ow_fpdf.php'),(427755,2324,'./estquoteaddformmail_ow_fpdf.php'),(427754,13238,'./estquoteaddformmail_ow_fpdf.php'),(427753,13237,'./estquoteaddformmail_ow_fpdf.php'),(427752,13442,'./estquoteaddformmail_ow_fpdf.php'),(427751,6871,'./estquoteaddformmail_ow_fpdf.php'),(427750,2208,'./estquoteaddformmail_ow_fpdf.php'),(427749,6887,'./estquoteaddformmail_ow_fpdf.php'),(427748,2165,'./estquoteaddformmail_ow_fpdf.php'),(427747,13236,'./estquoteaddformmail_ow_fpdf.php'),(427746,13235,'./estquoteaddformmail_ow_fpdf.php'),(427745,8368,'./estquoteaddformmail_ow_fpdf.php'),(427744,1963,'./estquoteaddformmail_ow_fpdf.php'),(427743,5685,'./estquoteaddformmail_ow_fpdf.php'),(427742,13234,'./estquoteaddformmail_ow_fpdf.php'),(427741,13441,'./estquoteaddformmail_ow_fpdf.php'),(427740,1610,'./estquoteaddformmail_ow_fpdf.php'),(427739,13440,'./estquoteaddformmail_ow_fpdf.php'),(427738,13439,'./estquoteaddformmail_ow_fpdf.php'),(427737,11872,'./estquoteaddformmail_ow_fpdf.php'),(427736,1456,'./estquoteaddformmail_ow_fpdf.php'),(427735,1373,'./estquoteaddformmail_ow_fpdf.php'),(427734,13413,'./estquoteaddformmail_ow_fpdf.php'),(427733,5684,'./estquoteaddformmail_ow_fpdf.php'),(427732,982,'./estquoteaddformmail_ow_fpdf.php'),(427731,981,'./estquoteaddformmail_ow_fpdf.php'),(427730,938,'./estquoteaddformmail_ow_fpdf.php'),(427729,13438,'./estquoteaddformmail_ow_fpdf.php'),(427728,4602,'./estquoteaddformmail_ow_fpdf.php'),(427727,869,'./estquoteaddformmail_ow_fpdf.php'),(427726,13437,'./estquoteaddformmail_ow_fpdf.php'),(427725,719,'./estquoteaddformmail_ow_fpdf.php'),(427724,717,'./estquoteaddformmail_ow_fpdf.php'),(427723,716,'./estquoteaddformmail_ow_fpdf.php'),(427722,13436,'./estquoteaddformmail_ow_fpdf.php'),(427721,542,'./estquoteaddformmail_ow_fpdf.php'),(427720,540,'./estquoteaddformmail_ow_fpdf.php'),(427719,13412,'./estquoteaddformmail_ow_fpdf.php'),(427718,7347,'./estquoteaddformmail_ow_fpdf.php'),(427717,306,'./estquoteaddformmail_ow_fpdf.php'),(427716,8873,'./estquoteaddformmail_ow_fpdf.php'),(427715,13571,'./estquoteaddformmail_ow_fpdf.php'),(427714,191,'./estquoteaddformmail_ow_fpdf.php'),(427713,13372,'./estquoteaddformmail_ow_fpdf.php'),(427712,3427,'./estquoteaddformmail.php'),(427711,3380,'./estquoteaddformmail.php'),(427710,3355,'./estquoteaddformmail.php'),(427709,4126,'./estquoteaddformmail.php'),(427708,12111,'./estquoteaddformmail.php'),(427707,12110,'./estquoteaddformmail.php'),(427706,3228,'./estquoteaddformmail.php'),(427705,12109,'./estquoteaddformmail.php'),(427704,3151,'./estquoteaddformmail.php'),(427703,3065,'./estquoteaddformmail.php'),(427702,5165,'./estquoteaddformmail.php'),(427701,2950,'./estquoteaddformmail.php'),(427700,2909,'./estquoteaddformmail.php'),(427699,2886,'./estquoteaddformmail.php'),(427698,5164,'./estquoteaddformmail.php'),(427697,2792,'./estquoteaddformmail.php'),(427696,12851,'./estquoteaddformmail.php'),(427695,13666,'./estquoteaddformmail.php'),(427694,2616,'./estquoteaddformmail.php'),(427693,2553,'./estquoteaddformmail.php'),(427692,2540,'./estquoteaddformmail.php'),(427691,2529,'./estquoteaddformmail.php'),(427690,6875,'./estquoteaddformmail.php'),(427689,2486,'./estquoteaddformmail.php'),(427688,2485,'./estquoteaddformmail.php'),(427687,6874,'./estquoteaddformmail.php'),(427686,11883,'./estquoteaddformmail.php'),(427685,6873,'./estquoteaddformmail.php'),(427684,6872,'./estquoteaddformmail.php'),(427683,2324,'./estquoteaddformmail.php'),(427682,6871,'./estquoteaddformmail.php'),(427681,8364,'./estquoteaddformmail.php'),(427680,13665,'./estquoteaddformmail.php'),(427679,6870,'./estquoteaddformmail.php'),(427678,1610,'./estquoteaddformmail.php'),(427677,11869,'./estquoteaddformmail.php'),(427676,1456,'./estquoteaddformmail.php'),(427675,1446,'./estquoteaddformmail.php'),(427674,1373,'./estquoteaddformmail.php'),(427673,5163,'./estquoteaddformmail.php'),(427672,982,'./estquoteaddformmail.php'),(427671,981,'./estquoteaddformmail.php'),(427670,869,'./estquoteaddformmail.php'),(427669,738,'./estquoteaddformmail.php'),(427668,719,'./estquoteaddformmail.php'),(427667,5162,'./estquoteaddformmail.php'),(427666,717,'./estquoteaddformmail.php'),(427665,716,'./estquoteaddformmail.php'),(427664,13664,'./estquoteaddformmail.php'),(427663,542,'./estquoteaddformmail.php'),(427662,540,'./estquoteaddformmail.php'),(427661,191,'./estquoteaddformmail.php'),(419986,8301,'./estquoteaddform_ow.php'),(419985,8300,'./estquoteaddform_ow.php'),(419984,8298,'./estquoteaddform_ow.php'),(419983,11902,'./estquoteaddform_ow.php'),(419982,12700,'./estquoteaddform_ow.php'),(419981,3380,'./estquoteaddform_ow.php'),(419980,4109,'./estquoteaddform_ow.php'),(419979,3151,'./estquoteaddform_ow.php'),(419978,12798,'./estquoteaddform_ow.php'),(419977,3090,'./estquoteaddform_ow.php'),(419976,2959,'./estquoteaddform_ow.php'),(419975,2950,'./estquoteaddform_ow.php'),(419974,2909,'./estquoteaddform_ow.php'),(419973,13320,'./estquoteaddform_ow.php'),(419972,2886,'./estquoteaddform_ow.php'),(419971,2826,'./estquoteaddform_ow.php'),(419970,2843,'./estquoteaddform_ow.php'),(419969,2835,'./estquoteaddform_ow.php'),(419968,2562,'./estquoteaddform_ow.php'),(419967,12699,'./estquoteaddform_ow.php'),(419966,2529,'./estquoteaddform_ow.php'),(419965,2508,'./estquoteaddform_ow.php'),(419964,11885,'./estquoteaddform_ow.php'),(419963,2485,'./estquoteaddform_ow.php'),(419962,11884,'./estquoteaddform_ow.php'),(419961,6988,'./estquoteaddform_ow.php'),(419960,12698,'./estquoteaddform_ow.php'),(419959,2353,'./estquoteaddform_ow.php'),(419958,2324,'./estquoteaddform_ow.php'),(419957,2182,'./estquoteaddform_ow.php'),(419956,12729,'./estquoteaddform_ow.php'),(419955,12697,'./estquoteaddform_ow.php'),(419954,6870,'./estquoteaddform_ow.php'),(419953,2070,'./estquoteaddform_ow.php'),(419952,11880,'./estquoteaddform_ow.php'),(419951,11877,'./estquoteaddform_ow.php'),(419950,11876,'./estquoteaddform_ow.php'),(419949,1763,'./estquoteaddform_ow.php'),(419948,12113,'./estquoteaddform_ow.php'),(419947,12112,'./estquoteaddform_ow.php'),(419946,1610,'./estquoteaddform_ow.php'),(419945,11871,'./estquoteaddform_ow.php'),(419944,1498,'./estquoteaddform_ow.php'),(419943,11869,'./estquoteaddform_ow.php'),(419942,1456,'./estquoteaddform_ow.php'),(419941,1373,'./estquoteaddform_ow.php'),(419940,985,'./estquoteaddform_ow.php'),(419939,981,'./estquoteaddform_ow.php'),(419938,13108,'./estquoteaddform_ow.php'),(419937,869,'./estquoteaddform_ow.php'),(419936,6015,'./estquoteaddform_ow.php'),(419935,3929,'./estquoteaddform_ow.php'),(419934,451,'./estquoteaddform_ow.php'),(419933,306,'./estquoteaddform_ow.php'),(419932,12107,'./estquoteaddform_ow.php'),(427660,3427,'./estquoteaddform_mail_fpdf.php'),(427659,3380,'./estquoteaddform_mail_fpdf.php'),(427658,3355,'./estquoteaddform_mail_fpdf.php'),(427657,3151,'./estquoteaddform_mail_fpdf.php'),(427656,5165,'./estquoteaddform_mail_fpdf.php'),(427655,2950,'./estquoteaddform_mail_fpdf.php'),(427654,2909,'./estquoteaddform_mail_fpdf.php'),(427653,2886,'./estquoteaddform_mail_fpdf.php'),(427652,5164,'./estquoteaddform_mail_fpdf.php'),(427651,5687,'./estquoteaddform_mail_fpdf.php'),(427650,5686,'./estquoteaddform_mail_fpdf.php'),(427649,13666,'./estquoteaddform_mail_fpdf.php'),(427648,2616,'./estquoteaddform_mail_fpdf.php'),(427647,2553,'./estquoteaddform_mail_fpdf.php'),(427646,2540,'./estquoteaddform_mail_fpdf.php'),(427645,2529,'./estquoteaddform_mail_fpdf.php'),(427644,6875,'./estquoteaddform_mail_fpdf.php'),(427643,2486,'./estquoteaddform_mail_fpdf.php'),(427642,6874,'./estquoteaddform_mail_fpdf.php'),(427641,11883,'./estquoteaddform_mail_fpdf.php'),(427640,6873,'./estquoteaddform_mail_fpdf.php'),(427639,6872,'./estquoteaddform_mail_fpdf.php'),(427638,2324,'./estquoteaddform_mail_fpdf.php'),(427637,6871,'./estquoteaddform_mail_fpdf.php'),(427636,8364,'./estquoteaddform_mail_fpdf.php'),(427635,13665,'./estquoteaddform_mail_fpdf.php'),(427634,6870,'./estquoteaddform_mail_fpdf.php'),(427633,1963,'./estquoteaddform_mail_fpdf.php'),(427632,5685,'./estquoteaddform_mail_fpdf.php'),(427631,1610,'./estquoteaddform_mail_fpdf.php'),(427630,11869,'./estquoteaddform_mail_fpdf.php'),(427629,1456,'./estquoteaddform_mail_fpdf.php'),(427628,1446,'./estquoteaddform_mail_fpdf.php'),(427627,1373,'./estquoteaddform_mail_fpdf.php'),(427626,5163,'./estquoteaddform_mail_fpdf.php'),(427625,5684,'./estquoteaddform_mail_fpdf.php'),(427624,982,'./estquoteaddform_mail_fpdf.php'),(427623,981,'./estquoteaddform_mail_fpdf.php'),(427622,869,'./estquoteaddform_mail_fpdf.php'),(427621,738,'./estquoteaddform_mail_fpdf.php'),(427620,719,'./estquoteaddform_mail_fpdf.php'),(427619,5162,'./estquoteaddform_mail_fpdf.php'),(427618,12701,'./estquoteaddform_mail_fpdf.php'),(427617,716,'./estquoteaddform_mail_fpdf.php'),(427616,13664,'./estquoteaddform_mail_fpdf.php'),(427615,542,'./estquoteaddform_mail_fpdf.php'),(427614,540,'./estquoteaddform_mail_fpdf.php'),(427613,191,'./estquoteaddform_mail_fpdf.php'),(427612,12700,'./estquoteaddform.php'),(427611,3380,'./estquoteaddform.php'),(427610,4109,'./estquoteaddform.php'),(427609,3151,'./estquoteaddform.php'),(427608,3090,'./estquoteaddform.php'),(427607,2886,'./estquoteaddform.php'),(427606,5610,'./estquoteaddform.php'),(427605,2826,'./estquoteaddform.php'),(427604,2843,'./estquoteaddform.php'),(427603,2835,'./estquoteaddform.php'),(427602,13662,'./estquoteaddform.php'),(427601,2562,'./estquoteaddform.php'),(427600,2561,'./estquoteaddform.php'),(427599,2541,'./estquoteaddform.php'),(427598,2529,'./estquoteaddform.php'),(427597,2508,'./estquoteaddform.php'),(427596,2485,'./estquoteaddform.php'),(427595,11884,'./estquoteaddform.php'),(427594,2404,'./estquoteaddform.php'),(427593,7692,'./estquoteaddform.php'),(427592,2324,'./estquoteaddform.php'),(427591,2119,'./estquoteaddform.php'),(427590,12697,'./estquoteaddform.php'),(427589,6869,'./estquoteaddform.php'),(427588,6870,'./estquoteaddform.php'),(427587,2070,'./estquoteaddform.php'),(427586,11880,'./estquoteaddform.php'),(427585,11877,'./estquoteaddform.php'),(427584,11876,'./estquoteaddform.php'),(427583,11871,'./estquoteaddform.php'),(427582,1498,'./estquoteaddform.php'),(427581,1456,'./estquoteaddform.php'),(427580,1373,'./estquoteaddform.php'),(427579,1113,'./estquoteaddform.php'),(427578,981,'./estquoteaddform.php'),(427577,869,'./estquoteaddform.php'),(427576,3929,'./estquoteaddform.php'),(427575,13661,'./estquoteaddform.php'),(427574,13660,'./estquoteaddform.php'),(427573,306,'./estquoteaddform.php'),(427572,12107,'./estquoteaddform.php'),(427571,3432,'./editvendor.php'),(427570,2936,'./editvendor.php'),(427569,2326,'./editvendor.php'),(427568,2324,'./editvendor.php'),(427567,2237,'./editvendor.php'),(427566,2234,'./editvendor.php'),(427565,6481,'./editvendor.php'),(427564,1963,'./editvendor.php'),(427563,7502,'./editvendor.php'),(427562,7973,'./editvendor.php'),(427561,1758,'./editvendor.php'),(427560,7972,'./editvendor.php'),(427559,7501,'./editvendor.php'),(427558,1429,'./editvendor.php'),(427557,981,'./editvendor.php'),(427556,7971,'./editvendor.php'),(427555,7499,'./editvendor.php'),(427554,581,'./editvendor.php'),(427553,548,'./editvendor.php'),(427552,524,'./editvendor.php'),(427551,185,'./editvendor.php'),(427550,3432,'./customer.php'),(427549,19484,'./customer.php'),(427548,8546,'./customer.php'),(427547,2975,'./customer.php'),(427546,2936,'./customer.php'),(427545,8545,'./customer.php'),(427544,19483,'./customer.php'),(427543,19482,'./customer.php'),(427542,2331,'./customer.php'),(427541,2330,'./customer.php'),(427540,2329,'./customer.php'),(427539,2327,'./customer.php'),(427538,2326,'./customer.php'),(427537,2324,'./customer.php'),(427536,2234,'./customer.php'),(427535,19481,'./customer.php'),(427534,19480,'./customer.php'),(427533,12106,'./customer.php'),(427532,12105,'./customer.php'),(427531,12104,'./customer.php'),(427530,12103,'./customer.php'),(427529,12102,'./customer.php'),(427528,12101,'./customer.php'),(427527,19479,'./customer.php'),(427526,8544,'./customer.php'),(427525,1810,'./customer.php'),(427524,1758,'./customer.php'),(427523,1429,'./customer.php'),(427522,1047,'./customer.php'),(427521,988,'./customer.php'),(427505,6481,'./client_customer.php'),(427504,18373,'./client_customer.php'),(427466,9643,'./b2b_logout.php'),(427465,19707,'./b2b_login.php'),(427454,3156,'./b2b_commissionreport.php'),(427453,3118,'./b2b_commissionreport.php'),(427452,6706,'./b2b_commissionreport.php'),(427451,6861,'./b2b_commissionreport.php'),(427450,2698,'./b2b_commissionreport.php'),(427449,6700,'./b2b_commissionreport.php'),(427448,6860,'./b2b_commissionreport.php'),(427447,6859,'./b2b_commissionreport.php'),(427446,2225,'./b2b_commissionreport.php'),(427445,2182,'./b2b_commissionreport.php'),(427444,6858,'./b2b_commissionreport.php'),(427443,6856,'./b2b_commissionreport.php'),(427442,6481,'./b2b_commissionreport.php'),(427441,1963,'./b2b_commissionreport.php'),(427440,6855,'./b2b_commissionreport.php'),(427439,6854,'./b2b_commissionreport.php'),(427438,1014,'./b2b_commissionreport.php'),(427437,6853,'./b2b_commissionreport.php'),(427436,6852,'./b2b_commissionreport.php'),(427435,6851,'./b2b_commissionreport.php'),(427434,491,'./b2b_commissionreport.php'),(427433,333,'./b2b_commissionreport.php'),(427432,315,'./b2b_commissionreport.php'),(427431,3156,'./b2b_commissioncust.php'),(427430,3118,'./b2b_commissioncust.php'),(427429,6706,'./b2b_commissioncust.php'),(427428,6861,'./b2b_commissioncust.php'),(427427,2698,'./b2b_commissioncust.php'),(427426,6700,'./b2b_commissioncust.php'),(427425,6860,'./b2b_commissioncust.php'),(427424,6859,'./b2b_commissioncust.php'),(427423,2238,'./b2b_commissioncust.php'),(427422,2225,'./b2b_commissioncust.php'),(427421,2182,'./b2b_commissioncust.php'),(427420,6858,'./b2b_commissioncust.php'),(427419,6856,'./b2b_commissioncust.php'),(427418,6481,'./b2b_commissioncust.php'),(427417,1963,'./b2b_commissioncust.php'),(427416,6855,'./b2b_commissioncust.php'),(427415,6854,'./b2b_commissioncust.php'),(427414,1014,'./b2b_commissioncust.php'),(427413,6853,'./b2b_commissioncust.php'),(427412,6852,'./b2b_commissioncust.php'),(427411,6851,'./b2b_commissioncust.php'),(427410,491,'./b2b_commissioncust.php'),(427409,333,'./b2b_commissioncust.php'),(427408,315,'./b2b_commissioncust.php'),(427407,6481,'./av_edit_reservation.php'),(427406,7237,'./av_airports_resrpt.php'),(427405,2686,'./av_airports_resrpt.php'),(427404,7604,'./av_airports_resrpt.php'),(427403,7603,'./av_airports_resrpt.php'),(427402,7602,'./av_airports_resrpt.php'),(427401,7601,'./av_airports_resrpt.php'),(427400,7600,'./av_airports_resrpt.php'),(427399,7599,'./av_airports_resrpt.php'),(427398,6481,'./av_airports_resrpt.php'),(427397,1963,'./av_airports_resrpt.php'),(427396,7598,'./av_airports_resrpt.php'),(427395,4106,'./av_airports_resrpt.php'),(427394,7581,'./av_airports_resrpt.php'),(427393,7597,'./av_airports_resrpt.php'),(427392,7596,'./av_airports_resrpt.php'),(427391,7595,'./av_airports_resrpt.php'),(427390,7594,'./av_airports_resrpt.php'),(427389,697,'./av_airports_resrpt.php'),(427388,7593,'./av_airports_resrpt.php'),(427387,7592,'./av_airports_resrpt.php'),(427386,7591,'./av_airports_resrpt.php'),(427385,7590,'./av_airports_resrpt.php'),(427384,197,'./av_airports_resrpt.php'),(427383,7589,'./av_airports_resrpt.php'),(427382,7588,'./av_airports_resrpt.php'),(427381,6265,'./av_airports_resrpt.php'),(427380,9259,'./autofunctionsdb.php'),(427379,1598,'./autofunctionsdb.php'),(427378,11943,'./attachfiles.php'),(427377,11942,'./attachfiles.php'),(427376,3056,'./attachfiles.php'),(427375,11941,'./attachfiles.php'),(427374,11940,'./attachfiles.php'),(427373,11939,'./attachfiles.php'),(427372,11938,'./attachfiles.php'),(427371,12099,'./attachfiles.php'),(427370,11937,'./attachfiles.php'),(427369,644,'./attachfiles.php'),(427368,11936,'./attachfiles.php'),(427367,5588,'./arserviceordtickfpdf.php'),(427366,3913,'./arserviceordtickfpdf.php'),(427365,5581,'./arserviceordtickfpdf.php'),(427364,2819,'./arserviceordtickfpdf.php'),(427363,5649,'./arserviceordtickfpdf.php'),(427362,2529,'./arserviceordtickfpdf.php'),(427361,2361,'./arserviceordtickfpdf.php'),(427360,2222,'./arserviceordtickfpdf.php'),(427359,6234,'./arserviceordtickfpdf.php'),(427358,1781,'./arserviceordtickfpdf.php'),(427357,1373,'./arserviceordtickfpdf.php'),(427356,1036,'./arserviceordtickfpdf.php'),(427355,932,'./arserviceordtickfpdf.php'),(427354,869,'./arserviceordtickfpdf.php'),(427353,719,'./arserviceordtickfpdf.php'),(427352,5477,'./arserviceordtickfpdf.php'),(427351,5459,'./arserviceordtickfpdf.php'),(427350,3371,'./arserviceordadd.php'),(427349,2820,'./arserviceordadd.php'),(427348,2838,'./arserviceordadd.php'),(427347,5663,'./arserviceordadd.php'),(427346,5482,'./arserviceordadd.php'),(427345,2702,'./arserviceordadd.php'),(427344,7213,'./arserviceordadd.php'),(427343,7207,'./arserviceordadd.php'),(427342,2501,'./arserviceordadd.php'),(427341,5918,'./arserviceordadd.php'),(427340,5917,'./arserviceordadd.php'),(427339,5916,'./arserviceordadd.php'),(427338,5915,'./arserviceordadd.php'),(427337,5914,'./arserviceordadd.php'),(427336,5913,'./arserviceordadd.php'),(427335,14263,'./arserviceordadd.php'),(427334,2260,'./arserviceordadd.php'),(427333,4023,'./arserviceordadd.php'),(427332,6485,'./arserviceordadd.php'),(427331,5481,'./arserviceordadd.php'),(427330,2182,'./arserviceordadd.php'),(427329,2168,'./arserviceordadd.php'),(427328,1992,'./arserviceordadd.php'),(427327,6481,'./arserviceordadd.php'),(427326,1963,'./arserviceordadd.php'),(427325,1788,'./arserviceordadd.php'),(427324,1583,'./arserviceordadd.php'),(427323,1582,'./arserviceordadd.php'),(427322,1422,'./arserviceordadd.php'),(427321,1232,'./arserviceordadd.php'),(427320,8936,'./arserviceordadd.php'),(427319,1012,'./arserviceordadd.php'),(427318,932,'./arserviceordadd.php'),(427317,5479,'./arserviceordadd.php'),(427316,5478,'./arserviceordadd.php'),(427315,5477,'./arserviceordadd.php'),(427314,717,'./arserviceordadd.php'),(427313,4481,'./arserviceordadd.php'),(427312,713,'./arserviceordadd.php'),(427311,699,'./arserviceordadd.php'),(427310,697,'./arserviceordadd.php'),(427309,679,'./arserviceordadd.php'),(427308,607,'./arserviceordadd.php'),(427307,5725,'./arserviceordadd.php'),(427306,5912,'./arserviceordadd.php'),(427305,5911,'./arserviceordadd.php'),(427304,5910,'./arserviceordadd.php'),(427303,315,'./arserviceordadd.php'),(427302,83,'./arserviceordadd.php'),(427301,71,'./arserviceordadd.php'),(427299,3173,'./arorderdetails.php'),(427298,3172,'./arorderdetails.php'),(427297,3090,'./arorderdetails.php'),(427296,7192,'./arorderdetails.php'),(427295,5119,'./arorderdetails.php'),(427294,2361,'./arorderdetails.php'),(427293,3502,'./arorderdetails.php'),(427292,2165,'./arorderdetails.php'),(427291,6481,'./arorderdetails.php'),(427290,1934,'./arorderdetails.php'),(427289,5090,'./arorderdetails.php'),(427288,1709,'./arorderdetails.php'),(427287,14036,'./arorderdetails.php'),(427286,8936,'./arorderdetails.php'),(427285,938,'./arorderdetails.php'),(427284,869,'./arorderdetails.php'),(427283,744,'./arorderdetails.php'),(427282,4363,'./arorderdetails.php'),(427281,697,'./arorderdetails.php'),(427280,3118,'./arordercustitemlst.php'),(427279,2508,'./arordercustitemlst.php'),(427278,6484,'./arordercustitemlst.php'),(427277,2451,'./arordercustitemlst.php'),(427276,2182,'./arordercustitemlst.php'),(427275,2170,'./arordercustitemlst.php'),(427274,6483,'./arordercustitemlst.php'),(427273,6481,'./arordercustitemlst.php'),(427272,4107,'./arordercustitemlst.php'),(427271,1709,'./arordercustitemlst.php'),(427270,11935,'./arordercustitemlst.php'),(427269,1357,'./arordercustitemlst.php'),(427268,869,'./arordercustitemlst.php'),(427267,737,'./arordercustitemlst.php'),(427266,542,'./arordercustitemlst.php'),(427265,6393,'./arordercustitemlst.php'),(427264,3172,'./arordconfirmfpdf.php'),(427263,3090,'./arordconfirmfpdf.php'),(427262,3072,'./arordconfirmfpdf.php'),(427261,2998,'./arordconfirmfpdf.php'),(427260,2977,'./arordconfirmfpdf.php'),(427259,3913,'./arordconfirmfpdf.php'),(427258,5581,'./arordconfirmfpdf.php'),(427257,2819,'./arordconfirmfpdf.php'),(427256,2833,'./arordconfirmfpdf.php'),(427255,5119,'./arordconfirmfpdf.php'),(427254,6313,'./arordconfirmfpdf.php'),(427253,2361,'./arordconfirmfpdf.php'),(427252,6249,'./arordconfirmfpdf.php'),(427251,2222,'./arordconfirmfpdf.php'),(427250,6312,'./arordconfirmfpdf.php'),(427249,2182,'./arordconfirmfpdf.php'),(427248,6311,'./arordconfirmfpdf.php'),(427247,6234,'./arordconfirmfpdf.php'),(427246,1781,'./arordconfirmfpdf.php'),(427245,6248,'./arordconfirmfpdf.php'),(427244,6247,'./arordconfirmfpdf.php'),(427243,1373,'./arordconfirmfpdf.php'),(427242,938,'./arordconfirmfpdf.php'),(427241,744,'./arordconfirmfpdf.php'),(427240,4363,'./arordconfirmfpdf.php'),(427239,719,'./arordconfirmfpdf.php'),(427238,697,'./arordconfirmfpdf.php'),(427237,5459,'./arordconfirmfpdf.php'),(427236,306,'./arordconfirmfpdf.php'),(427235,14056,'./arordcc.php'),(427234,5926,'./arordcc.php'),(427233,5925,'./arordcc.php'),(427232,3129,'./arordcc.php'),(427231,12018,'./arordcc.php'),(427230,16748,'./arordcc.php'),(427229,5924,'./arordcc.php'),(427228,2459,'./arordcc.php'),(427227,7212,'./arordcc.php'),(427226,5917,'./arordcc.php'),(427225,5916,'./arordcc.php'),(427224,5915,'./arordcc.php'),(427223,5914,'./arordcc.php'),(427222,5913,'./arordcc.php'),(427221,16232,'./arordcc.php'),(427220,5923,'./arordcc.php'),(427219,7211,'./arordcc.php'),(427218,6318,'./arordcc.php'),(427217,4023,'./arordcc.php'),(427216,2182,'./arordcc.php'),(427215,2165,'./arordcc.php'),(427214,1992,'./arordcc.php'),(427213,6481,'./arordcc.php'),(427212,1963,'./arordcc.php'),(427211,6745,'./arordcc.php'),(427210,1583,'./arordcc.php'),(427209,1582,'./arordcc.php'),(427208,6744,'./arordcc.php'),(427207,5922,'./arordcc.php'),(427206,1232,'./arordcc.php'),(427205,5920,'./arordcc.php'),(427204,697,'./arordcc.php'),(427203,679,'./arordcc.php'),(427202,15935,'./arordcc.php'),(427201,7210,'./arordcc.php'),(427200,5725,'./arordcc.php'),(427199,5912,'./arordcc.php'),(427198,5910,'./arordcc.php'),(427197,7209,'./arordcc.php'),(427196,9380,'./arordcc.php'),(427195,9379,'./arordcc.php'),(427194,9378,'./arordcc.php'),(427193,9377,'./arordcc.php'),(427192,315,'./arordcc.php'),(427191,7115,'./arordcc.php'),(427190,7494,'./arordcc.php'),(427186,3371,'./arordadd.php'),(427185,8263,'./arordadd.php'),(427184,3165,'./arordadd.php'),(427183,3090,'./arordadd.php'),(427182,3030,'./arordadd.php'),(427181,2998,'./arordadd.php'),(427180,2977,'./arordadd.php'),(427179,15618,'./arordadd.php'),(427178,2820,'./arordadd.php'),(427177,2819,'./arordadd.php'),(427176,7208,'./arordadd.php'),(427175,2541,'./arordadd.php'),(427174,14823,'./arordadd.php'),(427173,2529,'./arordadd.php'),(427172,2501,'./arordadd.php'),(427171,5918,'./arordadd.php'),(427170,2404,'./arordadd.php'),(427169,14263,'./arordadd.php'),(427168,2260,'./arordadd.php'),(427167,4865,'./arordadd.php'),(427166,5235,'./arordadd.php'),(427165,2168,'./arordadd.php'),(427164,2165,'./arordadd.php'),(427163,7206,'./arordadd.php'),(427162,6481,'./arordadd.php'),(427161,2103,'./arordadd.php'),(427160,1963,'./arordadd.php'),(427159,7493,'./arordadd.php'),(427158,1775,'./arordadd.php'),(427157,1727,'./arordadd.php'),(427156,1422,'./arordadd.php'),(427155,1232,'./arordadd.php'),(427154,8936,'./arordadd.php'),(427153,1012,'./arordadd.php'),(427152,941,'./arordadd.php'),(427151,932,'./arordadd.php'),(427150,869,'./arordadd.php'),(427149,697,'./arordadd.php'),(427148,607,'./arordadd.php'),(427147,6307,'./arordadd.php'),(427146,18048,'./arordadd.php'),(427145,5911,'./arordadd.php'),(427144,315,'./arordadd.php'),(427143,7115,'./arordadd.php'),(427142,226,'./arordadd.php'),(427141,85,'./arordadd.php'),(427140,8262,'./arordadd.php'),(427139,71,'./arordadd.php'),(427137,3427,'./arord_preconfirmfpdf.php'),(427136,3172,'./arord_preconfirmfpdf.php'),(427135,3090,'./arord_preconfirmfpdf.php'),(427134,3072,'./arord_preconfirmfpdf.php'),(427133,13183,'./arord_preconfirmfpdf.php'),(427132,2998,'./arord_preconfirmfpdf.php'),(427131,2977,'./arord_preconfirmfpdf.php'),(427130,3913,'./arord_preconfirmfpdf.php'),(427129,5581,'./arord_preconfirmfpdf.php'),(427128,2819,'./arord_preconfirmfpdf.php'),(427127,2833,'./arord_preconfirmfpdf.php'),(427126,5119,'./arord_preconfirmfpdf.php'),(427125,6313,'./arord_preconfirmfpdf.php'),(427124,6482,'./arord_preconfirmfpdf.php'),(427123,2361,'./arord_preconfirmfpdf.php'),(427122,6249,'./arord_preconfirmfpdf.php'),(427121,2222,'./arord_preconfirmfpdf.php'),(427120,6312,'./arord_preconfirmfpdf.php'),(427119,2182,'./arord_preconfirmfpdf.php'),(427118,2165,'./arord_preconfirmfpdf.php'),(427117,6234,'./arord_preconfirmfpdf.php'),(427116,1781,'./arord_preconfirmfpdf.php'),(427115,6248,'./arord_preconfirmfpdf.php'),(427114,6247,'./arord_preconfirmfpdf.php'),(427113,1373,'./arord_preconfirmfpdf.php'),(427112,938,'./arord_preconfirmfpdf.php'),(427111,744,'./arord_preconfirmfpdf.php'),(427110,4363,'./arord_preconfirmfpdf.php'),(427109,719,'./arord_preconfirmfpdf.php'),(427108,697,'./arord_preconfirmfpdf.php'),(427107,5459,'./arord_preconfirmfpdf.php'),(427106,542,'./arord_preconfirmfpdf.php'),(427105,8043,'./arord_preconfirmfpdf.php'),(427104,306,'./arord_preconfirmfpdf.php'),(427103,3427,'./arinvoiceviewfpdf.php'),(427102,13334,'./arinvoiceviewfpdf.php'),(427101,1668,'./arinvoiceviewfpdf.php'),(427100,542,'./arinvoiceviewfpdf.php'),(427099,5456,'./arinvoiceviewfpdf.php'),(427098,19877,'./arinvoicesum.php'),(427097,3179,'./arinvoicesum.php'),(427096,3090,'./arinvoicesum.php'),(427095,17877,'./arinvoicesum.php'),(427094,2948,'./arinvoicesum.php'),(427093,2819,'./arinvoicesum.php'),(427092,2751,'./arinvoicesum.php'),(427091,19879,'./arinvoicesum.php'),(427090,5388,'./arinvoicesum.php'),(427089,19703,'./arinvoicesum.php'),(427088,19702,'./arinvoicesum.php'),(427087,2363,'./arinvoicesum.php'),(427086,17500,'./arinvoicesum.php'),(427085,2225,'./arinvoicesum.php'),(427084,11934,'./arinvoicesum.php'),(427083,2151,'./arinvoicesum.php'),(427082,2021,'./arinvoicesum.php'),(427081,6481,'./arinvoicesum.php'),(427080,19701,'./arinvoicesum.php'),(427079,1788,'./arinvoicesum.php'),(427078,1743,'./arinvoicesum.php'),(427077,9622,'./arinvoicesum.php'),(427076,16086,'./arinvoicesum.php'),(427075,16085,'./arinvoicesum.php'),(427074,1678,'./arinvoicesum.php'),(427060,3427,'./arinvoicestate.php'),(427059,16298,'./arinvoicestate.php'),(427058,6252,'./arinvoicestate.php'),(427057,6250,'./arinvoicestate.php'),(427056,19877,'./arinvoicereppay.php'),(427055,3343,'./arinvoicereppay.php'),(427054,5378,'./arinvoicereppay.php'),(427053,3102,'./arinvoicereppay.php'),(427052,3118,'./arinvoicereppay.php'),(427051,3090,'./arinvoicereppay.php'),(427050,2998,'./arinvoicereppay.php'),(427049,4113,'./arinvoicereppay.php'),(427048,2638,'./arinvoicereppay.php'),(427047,7203,'./arinvoicereppay.php'),(427046,5366,'./arinvoicereppay.php'),(427045,5365,'./arinvoicereppay.php'),(427044,2225,'./arinvoicereppay.php'),(427043,6431,'./arinvoicereppay.php'),(427042,2208,'./arinvoicereppay.php'),(427041,2020,'./arinvoicereppay.php'),(427040,6481,'./arinvoicereppay.php'),(427039,6440,'./arinvoicereppay.php'),(427038,1884,'./arinvoicereppay.php'),(427037,1678,'./arinvoicereppay.php'),(427036,1625,'./arinvoicereppay.php'),(427035,1578,'./arinvoicereppay.php'),(427034,886,'./arinvoicereppay.php'),(427033,869,'./arinvoicereppay.php'),(427032,737,'./arinvoicereppay.php'),(427031,697,'./arinvoicereppay.php'),(427030,673,'./arinvoicereppay.php'),(427029,6430,'./arinvoicereppay.php'),(427028,479,'./arinvoicereppay.php'),(427027,445,'./arinvoicereppay.php'),(427026,5355,'./arinvoicereppay.php'),(427025,332,'./arinvoicereppay.php'),(427024,325,'./arinvoicereppay.php'),(427023,7202,'./arinvoicereppay.php'),(427022,226,'./arinvoicereppay.php'),(427021,11932,'./arinvoicereppay.php'),(427020,16751,'./arinvoicepay.php'),(427019,3333,'./arinvoicepay.php'),(427018,3090,'./arinvoicepay.php'),(427017,3948,'./arinvoicepay.php'),(427016,2948,'./arinvoicepay.php'),(427015,19316,'./arinvoicepay.php'),(427014,14823,'./arinvoicepay.php'),(427013,5918,'./arinvoicepay.php'),(427012,2459,'./arinvoicepay.php'),(427011,2363,'./arinvoicepay.php'),(427010,2349,'./arinvoicepay.php'),(427009,16223,'./arinvoicepay.php'),(427008,16222,'./arinvoicepay.php'),(427007,11931,'./arinvoicepay.php'),(427006,7201,'./arinvoicepay.php'),(427005,6656,'./arinvoicepay.php'),(427004,18878,'./arinvoicepay.php'),(427003,18877,'./arinvoicepay.php'),(427002,2260,'./arinvoicepay.php'),(427001,19314,'./arinvoicepay.php'),(427000,7200,'./arinvoicepay.php'),(426999,6318,'./arinvoicepay.php'),(426998,2225,'./arinvoicepay.php'),(426997,16221,'./arinvoicepay.php'),(426996,6481,'./arinvoicepay.php'),(426995,1963,'./arinvoicepay.php'),(426994,1929,'./arinvoicepay.php'),(426993,7199,'./arinvoicepay.php'),(426992,9622,'./arinvoicepay.php'),(426991,16750,'./arinvoicepay.php'),(426990,1681,'./arinvoicepay.php'),(426989,1678,'./arinvoicepay.php'),(426988,1672,'./arinvoicepay.php'),(426987,4940,'./arinvoicepay.php'),(426986,1625,'./arinvoicepay.php'),(426985,11930,'./arinvoicepay.php'),(426984,1278,'./arinvoicepay.php'),(426983,6713,'./arinvoicepay.php'),(426982,16220,'./arinvoicepay.php'),(426981,1240,'./arinvoicepay.php'),(426980,1232,'./arinvoicepay.php'),(426979,8936,'./arinvoicepay.php'),(426978,1134,'./arinvoicepay.php'),(426977,1132,'./arinvoicepay.php'),(426976,1106,'./arinvoicepay.php'),(427497,3432,'./client_contacts.php'),(427496,18368,'./client_contacts.php'),(427495,2975,'./client_contacts.php'),(427494,2936,'./client_contacts.php'),(427493,17687,'./client_contacts.php'),(427492,18367,'./client_contacts.php'),(427491,18366,'./client_contacts.php'),(427490,16743,'./client_contacts.php'),(427489,14823,'./client_contacts.php'),(427488,2324,'./client_contacts.php'),(427487,1810,'./client_contacts.php'),(427486,1758,'./client_contacts.php'),(427485,1429,'./client_contacts.php'),(427484,1047,'./client_contacts.php'),(427483,981,'./client_contacts.php'),(427482,869,'./client_contacts.php'),(426955,18363,'./arcustupd.php'),(426954,18362,'./arcustupd.php'),(426953,3311,'./arcustb2buser.php'),(426952,3310,'./arcustb2buser.php'),(426951,3264,'./arcustb2buser.php'),(426950,3263,'./arcustb2buser.php'),(426949,7691,'./arcustb2buser.php'),(426948,3256,'./arcustb2buser.php'),(426947,3254,'./arcustb2buser.php'),(426946,3202,'./arcustb2buser.php'),(426945,2710,'./arcustb2buser.php'),(426944,2702,'./arcustb2buser.php'),(426943,2234,'./arcustb2buser.php'),(426942,6481,'./arcustb2buser.php'),(426941,1937,'./arcustb2buser.php'),(426940,4469,'./arcustb2buser.php'),(426939,1758,'./arcustb2buser.php'),(426938,1634,'./arcustb2buser.php'),(426937,1622,'./arcustb2buser.php'),(426936,1429,'./arcustb2buser.php'),(426935,981,'./arcustb2buser.php'),(426934,965,'./arcustb2buser.php'),(426933,941,'./arcustb2buser.php'),(426932,6421,'./arcustb2buser.php'),(426931,807,'./arcustb2buser.php'),(426930,864,'./arcustb2buser.php'),(426929,799,'./arcustb2buser.php'),(426928,697,'./arcustb2buser.php'),(426927,315,'./arcustb2buser.php'),(426926,4871,'./arcustb2buser.php'),(426925,144,'./arcustb2buser.php'),(426924,78,'./arcustb2buser.php'),(426923,6480,'./arcustb2buser.php'),(426922,59,'./arcustb2buser.php'),(426921,6453,'./arcustb2buser.php'),(426920,6494,'./arcustb2buser.php'),(426894,3414,'./apvendorpostatus.php'),(426893,3118,'./apvendorpostatus.php'),(426892,6519,'./apvendorpostatus.php'),(426891,6518,'./apvendorpostatus.php'),(426890,2838,'./apvendorpostatus.php'),(426889,6517,'./apvendorpostatus.php'),(426888,2459,'./apvendorpostatus.php'),(426887,2363,'./apvendorpostatus.php'),(426886,6138,'./apvendorpostatus.php'),(426885,2027,'./apvendorpostatus.php'),(426884,6481,'./apvendorpostatus.php'),(426883,1933,'./apvendorpostatus.php'),(426882,932,'./apvendorpostatus.php'),(426881,591,'./apvendorpostatus.php'),(426880,3421,'./apvendorbillsrpt.php'),(426879,3101,'./apvendorbillsrpt.php'),(426878,6516,'./apvendorbillsrpt.php'),(426877,2225,'./apvendorbillsrpt.php'),(426876,6481,'./apvendorbillsrpt.php'),(426875,1973,'./apvendorbillsrpt.php'),(426874,1963,'./apvendorbillsrpt.php'),(426873,1678,'./apvendorbillsrpt.php'),(426872,4106,'./apvendorbillsrpt.php'),(426871,1014,'./apvendorbillsrpt.php'),(426870,931,'./apvendorbillsrpt.php'),(426869,869,'./apvendorbillsrpt.php'),(426868,737,'./apvendorbillsrpt.php'),(426867,673,'./apvendorbillsrpt.php'),(426866,591,'./apvendorbillsrpt.php'),(426865,491,'./apvendorbillsrpt.php'),(426864,445,'./apvendorbillsrpt.php'),(426863,6515,'./apvendorbillsrpt.php'),(426862,333,'./apvendorbillsrpt.php'),(426861,315,'./apvendorbillsrpt.php'),(426860,226,'./apvendorbillsrpt.php'),(426859,6514,'./apvendorbillsrpt.php'),(428734,1691,'includes/arfunctions.php'),(428733,1689,'includes/arfunctions.php'),(428732,1687,'includes/arfunctions.php'),(428731,1685,'includes/arfunctions.php'),(428730,1678,'includes/arfunctions.php'),(428729,1668,'includes/arfunctions.php'),(428728,1499,'includes/arfunctions.php'),(428727,1429,'includes/arfunctions.php'),(428726,1381,'includes/arfunctions.php'),(428725,1318,'includes/arfunctions.php'),(428724,1312,'includes/arfunctions.php'),(428723,1311,'includes/arfunctions.php'),(428722,1310,'includes/arfunctions.php'),(428721,1305,'includes/arfunctions.php'),(428720,1279,'includes/arfunctions.php'),(428719,1278,'includes/arfunctions.php'),(428718,1264,'includes/arfunctions.php'),(428717,1263,'includes/arfunctions.php'),(428716,1254,'includes/arfunctions.php'),(428715,1240,'includes/arfunctions.php'),(428714,1232,'includes/arfunctions.php'),(428713,8936,'includes/arfunctions.php'),(428712,1205,'includes/arfunctions.php'),(428711,1202,'includes/arfunctions.php'),(428710,1201,'includes/arfunctions.php'),(428709,1200,'includes/arfunctions.php'),(428708,1197,'includes/arfunctions.php'),(428707,1175,'includes/arfunctions.php'),(428706,1174,'includes/arfunctions.php'),(428705,1161,'includes/arfunctions.php'),(428704,1160,'includes/arfunctions.php'),(428703,1153,'includes/arfunctions.php'),(428702,1134,'includes/arfunctions.php'),(428701,1132,'includes/arfunctions.php'),(428700,1124,'includes/arfunctions.php'),(428699,1119,'includes/arfunctions.php'),(428698,1118,'includes/arfunctions.php'),(428697,1117,'includes/arfunctions.php'),(428696,1114,'includes/arfunctions.php'),(428695,1090,'includes/arfunctions.php'),(428694,1071,'includes/arfunctions.php'),(428693,1070,'includes/arfunctions.php'),(428692,1067,'includes/arfunctions.php'),(428691,1060,'includes/arfunctions.php'),(428690,1047,'includes/arfunctions.php'),(428689,989,'includes/arfunctions.php'),(428688,988,'includes/arfunctions.php'),(428687,984,'includes/arfunctions.php'),(428686,983,'includes/arfunctions.php'),(428685,981,'includes/arfunctions.php'),(428684,948,'includes/arfunctions.php'),(428683,898,'includes/arfunctions.php'),(428682,894,'includes/arfunctions.php'),(428681,869,'includes/arfunctions.php'),(428680,798,'includes/arfunctions.php'),(428679,717,'includes/arfunctions.php'),(428678,6228,'includes/arfunctions.php'),(428677,675,'includes/arfunctions.php'),(428676,663,'includes/arfunctions.php'),(428675,659,'includes/arfunctions.php'),(428674,581,'includes/arfunctions.php'),(428673,571,'includes/arfunctions.php'),(428672,570,'includes/arfunctions.php'),(428671,569,'includes/arfunctions.php'),(428670,524,'includes/arfunctions.php'),(428669,474,'includes/arfunctions.php'),(428668,444,'includes/arfunctions.php'),(428667,439,'includes/arfunctions.php'),(428666,438,'includes/arfunctions.php'),(428665,435,'includes/arfunctions.php'),(428664,434,'includes/arfunctions.php'),(428663,351,'includes/arfunctions.php'),(428662,318,'includes/arfunctions.php'),(428661,315,'includes/arfunctions.php'),(428660,9,'includes/arfunctions.php'),(428659,5146,'includes/arfunctions.php'),(428658,5145,'includes/arfunctions.php'),(428657,157,'includes/arfunctions.php'),(428656,152,'includes/arfunctions.php'),(428655,155,'includes/arfunctions.php'),(428654,129,'includes/arfunctions.php'),(428653,109,'includes/arfunctions.php'),(428652,92,'includes/arfunctions.php'),(428651,185,'includes/arfunctions.php'),(428650,59,'includes/arfunctions.php'),(428649,17,'includes/arfunctions.php'),(428805,2070,'includes/category.inc'),(428804,197,'includes/category.inc'),(428822,7109,'includes/ccpayment.php'),(428821,2702,'includes/ccpayment.php'),(428820,7108,'includes/ccpayment.php'),(428819,7107,'includes/ccpayment.php'),(428818,7106,'includes/ccpayment.php'),(428817,1047,'includes/ccpayment.php'),(428816,7105,'includes/ccpayment.php'),(428815,670,'includes/ccpayment.php'),(428814,7104,'includes/ccpayment.php'),(428813,7103,'includes/ccpayment.php'),(428812,7102,'includes/ccpayment.php'),(428811,5430,'includes/ccpayment.php'),(428810,7101,'includes/ccpayment.php'),(428809,5095,'includes/ccpayment.php'),(428808,39,'includes/ccpayment.php'),(428807,7100,'includes/ccpayment.php'),(428806,28,'includes/ccpayment.php'),(428823,7110,'includes/ccpayment_authorizenet.php'),(427138,59,'./arordadd.php'),(428824,13967,'includes/ccpayment_epay.php'),(428853,7131,'includes/ccpayment_factory.php'),(428852,7130,'includes/ccpayment_factory.php'),(428851,7129,'includes/ccpayment_factory.php'),(428850,2998,'includes/ccpayment_factory.php'),(428849,2833,'includes/ccpayment_factory.php'),(428848,7128,'includes/ccpayment_factory.php'),(428847,4329,'includes/ccpayment_factory.php'),(428846,7126,'includes/ccpayment_factory.php'),(428845,6346,'includes/ccpayment_factory.php'),(428844,7125,'includes/ccpayment_factory.php'),(428843,7123,'includes/ccpayment_factory.php'),(428842,7122,'includes/ccpayment_factory.php'),(428841,7121,'includes/ccpayment_factory.php'),(428840,6307,'includes/ccpayment_factory.php'),(428839,581,'includes/ccpayment_factory.php'),(428838,6697,'includes/ccpayment_factory.php'),(428837,7120,'includes/ccpayment_factory.php'),(428836,7119,'includes/ccpayment_factory.php'),(428835,7118,'includes/ccpayment_factory.php'),(428834,7117,'includes/ccpayment_factory.php'),(428833,7116,'includes/ccpayment_factory.php'),(428832,7115,'includes/ccpayment_factory.php'),(428831,7114,'includes/ccpayment_factory.php'),(428830,7113,'includes/ccpayment_factory.php'),(428829,6743,'includes/ccpayment_factory.php'),(428828,226,'includes/ccpayment_factory.php'),(428827,7112,'includes/ccpayment_factory.php'),(428826,28,'includes/ccpayment_factory.php'),(428825,7111,'includes/ccpayment_factory.php'),(285400,7100,'includes/ccpayment_manual.php'),(285401,7103,'includes/ccpayment_manual.php'),(285402,7104,'includes/ccpayment_manual.php'),(428943,6174,'includes/filesystemdb.php'),(428942,5130,'includes/filesystemdb.php'),(428941,6173,'includes/filesystemdb.php'),(428940,17071,'includes/filesystemdb.php'),(428939,9083,'includes/filesystemdb.php'),(428938,9082,'includes/filesystemdb.php'),(428937,3252,'includes/filesystemdb.php'),(428936,6176,'includes/filesystemdb.php'),(428935,17436,'includes/filesystemdb.php'),(428934,17435,'includes/filesystemdb.php'),(428933,17434,'includes/filesystemdb.php'),(428932,10553,'includes/filesystemdb.php'),(428931,18884,'includes/filesystemdb.php'),(428930,19158,'includes/filesystemdb.php'),(428929,9245,'includes/filesystemdb.php'),(428928,16418,'includes/filesystemdb.php'),(428927,2886,'includes/filesystemdb.php'),(428926,18321,'includes/filesystemdb.php'),(428925,16113,'includes/filesystemdb.php'),(428924,18883,'includes/filesystemdb.php'),(428923,2702,'includes/filesystemdb.php'),(428922,9081,'includes/filesystemdb.php'),(428921,18882,'includes/filesystemdb.php'),(428920,17403,'includes/filesystemdb.php'),(428919,9080,'includes/filesystemdb.php'),(428918,11559,'includes/filesystemdb.php'),(428917,15591,'includes/filesystemdb.php'),(428916,9079,'includes/filesystemdb.php'),(428915,17401,'includes/filesystemdb.php'),(428914,2165,'includes/filesystemdb.php'),(428913,13142,'includes/filesystemdb.php'),(428912,6172,'includes/filesystemdb.php'),(428911,2103,'includes/filesystemdb.php'),(428910,2070,'includes/filesystemdb.php'),(428909,8551,'includes/filesystemdb.php'),(428908,11006,'includes/filesystemdb.php'),(428907,6171,'includes/filesystemdb.php'),(428906,9783,'includes/filesystemdb.php'),(428905,10906,'includes/filesystemdb.php'),(428904,15855,'includes/filesystemdb.php'),(428903,11005,'includes/filesystemdb.php'),(428902,9078,'includes/filesystemdb.php'),(428901,17400,'includes/filesystemdb.php'),(428900,9077,'includes/filesystemdb.php'),(428899,9076,'includes/filesystemdb.php'),(428898,9075,'includes/filesystemdb.php'),(428897,7972,'includes/filesystemdb.php'),(428953,2896,'includes/footer.php'),(428952,11886,'includes/footer.php'),(428951,2459,'includes/footer.php'),(428950,11879,'includes/footer.php'),(428949,11875,'includes/footer.php'),(428948,1546,'includes/footer.php'),(428947,1354,'includes/footer.php'),(428946,1033,'includes/footer.php'),(428945,12150,'includes/footer.php'),(428944,533,'includes/footer.php'),(429008,5130,'includes/functions.php'),(429007,13053,'includes/functions.php'),(429006,6384,'includes/functions.php'),(429005,2798,'includes/functions.php'),(429004,14655,'includes/functions.php'),(429003,14823,'includes/functions.php'),(429002,2270,'includes/functions.php'),(429001,5866,'includes/functions.php'),(429000,2208,'includes/functions.php'),(428999,5865,'includes/functions.php'),(428998,2129,'includes/functions.php'),(428997,9423,'includes/functions.php'),(428996,2106,'includes/functions.php'),(428995,13992,'includes/functions.php'),(428994,9046,'includes/functions.php'),(428993,9045,'includes/functions.php'),(428992,9044,'includes/functions.php'),(428991,9043,'includes/functions.php'),(428990,9042,'includes/functions.php'),(428989,9041,'includes/functions.php'),(428988,9040,'includes/functions.php'),(428987,9039,'includes/functions.php'),(428986,9038,'includes/functions.php'),(428985,9037,'includes/functions.php'),(428984,9036,'includes/functions.php'),(428983,9035,'includes/functions.php'),(428982,1871,'includes/functions.php'),(428981,1821,'includes/functions.php'),(428980,1749,'includes/functions.php'),(428979,1747,'includes/functions.php'),(428978,1741,'includes/functions.php'),(428977,1639,'includes/functions.php'),(428976,1622,'includes/functions.php'),(428975,1591,'includes/functions.php'),(428974,15937,'includes/functions.php'),(428973,1482,'includes/functions.php'),(428972,1441,'includes/functions.php'),(428971,1375,'includes/functions.php'),(428970,1339,'includes/functions.php'),(428969,8936,'includes/functions.php'),(428968,1047,'includes/functions.php'),(428967,927,'includes/functions.php'),(428966,778,'includes/functions.php'),(428965,15936,'includes/functions.php'),(428964,673,'includes/functions.php'),(428963,5832,'includes/functions.php'),(428962,5864,'includes/functions.php'),(428961,479,'includes/functions.php'),(428960,3457,'includes/functions.php'),(428959,445,'includes/functions.php'),(428958,308,'includes/functions.php'),(428954,40,'includes/functions.php'),(428955,42,'includes/functions.php'),(428956,8254,'includes/functions.php'),(428957,275,'includes/functions.php'),(429044,2983,'includes/glfunctions.php'),(429043,2910,'includes/glfunctions.php'),(429042,6374,'includes/glfunctions.php'),(429041,1963,'includes/glfunctions.php'),(429040,1485,'includes/glfunctions.php'),(429039,1483,'includes/glfunctions.php'),(429038,4028,'includes/glfunctions.php'),(429037,1244,'includes/glfunctions.php'),(429036,1243,'includes/glfunctions.php'),(429035,1170,'includes/glfunctions.php'),(429034,1169,'includes/glfunctions.php'),(429033,1145,'includes/glfunctions.php'),(429032,1144,'includes/glfunctions.php'),(429031,1079,'includes/glfunctions.php'),(429030,1050,'includes/glfunctions.php'),(429029,1049,'includes/glfunctions.php'),(429028,1048,'includes/glfunctions.php'),(429027,5229,'includes/glfunctions.php'),(429026,1035,'includes/glfunctions.php'),(429025,944,'includes/glfunctions.php'),(429024,936,'includes/glfunctions.php'),(429023,5205,'includes/glfunctions.php'),(429022,573,'includes/glfunctions.php'),(429021,315,'includes/glfunctions.php'),(429020,202,'includes/glfunctions.php'),(429019,104,'includes/glfunctions.php'),(429018,39,'includes/glfunctions.php'),(429017,37,'includes/glfunctions.php'),(429016,35,'includes/glfunctions.php'),(429015,32,'includes/glfunctions.php'),(429014,27,'includes/glfunctions.php'),(429013,26,'includes/glfunctions.php'),(429012,5228,'includes/glfunctions.php'),(429011,23,'includes/glfunctions.php'),(429010,5227,'includes/glfunctions.php'),(429009,4035,'includes/glfunctions.php'),(426975,6496,'./arinvoicepay.php'),(429128,3363,'includes/header.php'),(429127,11971,'includes/header.php'),(429126,11970,'includes/header.php'),(429125,11959,'includes/header.php'),(429124,11958,'includes/header.php'),(429123,11957,'includes/header.php'),(429122,16748,'includes/header.php'),(429121,2798,'includes/header.php'),(429120,2747,'includes/header.php'),(429119,7175,'includes/header.php'),(429118,11956,'includes/header.php'),(429117,14035,'includes/header.php'),(429116,16732,'includes/header.php'),(429115,11969,'includes/header.php'),(429114,11968,'includes/header.php'),(429113,16236,'includes/header.php'),(429112,11955,'includes/header.php'),(429111,7213,'includes/header.php'),(429110,11954,'includes/header.php'),(429109,11953,'includes/header.php'),(429108,4857,'includes/header.php'),(429107,9835,'includes/header.php'),(429106,6484,'includes/header.php'),(429105,11691,'includes/header.php'),(429104,11967,'includes/header.php'),(429103,7203,'includes/header.php'),(429102,11966,'includes/header.php'),(429101,5111,'includes/header.php'),(429100,5235,'includes/header.php'),(429099,2200,'includes/header.php'),(429098,2129,'includes/header.php'),(429097,2106,'includes/header.php'),(429096,3990,'includes/header.php'),(429095,3706,'includes/header.php'),(429094,8030,'includes/header.php'),(429093,9046,'includes/header.php'),(429092,9045,'includes/header.php'),(429091,9044,'includes/header.php'),(429090,9043,'includes/header.php'),(429089,9042,'includes/header.php'),(429088,9041,'includes/header.php'),(429087,9040,'includes/header.php'),(429086,9039,'includes/header.php'),(429085,9038,'includes/header.php'),(429084,9037,'includes/header.php'),(429083,9036,'includes/header.php'),(429082,9035,'includes/header.php'),(429081,1871,'includes/header.php'),(429080,1821,'includes/header.php'),(429079,11965,'includes/header.php'),(429078,7199,'includes/header.php'),(429077,11875,'includes/header.php'),(429076,1749,'includes/header.php'),(429075,1747,'includes/header.php'),(429074,1741,'includes/header.php'),(429073,1731,'includes/header.php'),(429072,7204,'includes/header.php'),(429071,4940,'includes/header.php'),(429070,1559,'includes/header.php'),(429069,1375,'includes/header.php'),(429068,11952,'includes/header.php'),(429067,11950,'includes/header.php'),(429066,11964,'includes/header.php'),(429065,11949,'includes/header.php'),(429064,11963,'includes/header.php'),(429063,11962,'includes/header.php'),(429062,7971,'includes/header.php'),(429061,18374,'includes/header.php'),(429060,778,'includes/header.php'),(429059,16235,'includes/header.php'),(429058,11961,'includes/header.php'),(429057,11948,'includes/header.php'),(429056,11947,'includes/header.php'),(429055,11946,'includes/header.php'),(429054,6852,'includes/header.php'),(429053,11037,'includes/header.php'),(429052,11960,'includes/header.php'),(429051,12152,'includes/header.php'),(429050,12151,'includes/header.php'),(427481,18365,'./client_contacts.php'),(427480,6212,'./client_contacts.php'),(427479,6211,'./client_contacts.php'),(427478,6210,'./client_contacts.php'),(427477,716,'./client_contacts.php'),(427476,659,'./client_contacts.php'),(429177,3354,'includes/invfunctions.php'),(429176,3171,'includes/invfunctions.php'),(429175,3169,'includes/invfunctions.php'),(429174,3167,'includes/invfunctions.php'),(429173,2936,'includes/invfunctions.php'),(429172,2376,'includes/invfunctions.php'),(429171,2331,'includes/invfunctions.php'),(429170,2330,'includes/invfunctions.php'),(429169,2329,'includes/invfunctions.php'),(429168,2327,'includes/invfunctions.php'),(429167,2326,'includes/invfunctions.php'),(429166,2324,'includes/invfunctions.php'),(429165,1810,'includes/invfunctions.php'),(429164,1726,'includes/invfunctions.php'),(429163,1723,'includes/invfunctions.php'),(429162,1722,'includes/invfunctions.php'),(429161,1699,'includes/invfunctions.php'),(429160,1651,'includes/invfunctions.php'),(429159,1650,'includes/invfunctions.php'),(429158,1649,'includes/invfunctions.php'),(429157,1647,'includes/invfunctions.php'),(429156,1646,'includes/invfunctions.php'),(429155,1381,'includes/invfunctions.php'),(429154,1323,'includes/invfunctions.php'),(429153,1319,'includes/invfunctions.php'),(429152,1284,'includes/invfunctions.php'),(429151,1283,'includes/invfunctions.php'),(429150,1280,'includes/invfunctions.php'),(429149,1258,'includes/invfunctions.php'),(429148,8936,'includes/invfunctions.php'),(429147,1206,'includes/invfunctions.php'),(429146,1177,'includes/invfunctions.php'),(429145,1172,'includes/invfunctions.php'),(429144,1157,'includes/invfunctions.php'),(429143,1130,'includes/invfunctions.php'),(429142,1126,'includes/invfunctions.php'),(429141,1096,'includes/invfunctions.php'),(429140,1095,'includes/invfunctions.php'),(429139,1094,'includes/invfunctions.php'),(429138,1091,'includes/invfunctions.php'),(429137,1089,'includes/invfunctions.php'),(429136,1066,'includes/invfunctions.php'),(429135,988,'includes/invfunctions.php'),(429134,984,'includes/invfunctions.php'),(429133,983,'includes/invfunctions.php'),(429132,981,'includes/invfunctions.php'),(429131,659,'includes/invfunctions.php'),(429130,524,'includes/invfunctions.php'),(429129,185,'includes/invfunctions.php'),(429236,6361,'includes/itemoptiongroup.php'),(429235,3421,'includes/itemoptiongroup.php'),(429234,3362,'includes/itemoptiongroup.php'),(429233,6360,'includes/itemoptiongroup.php'),(429232,6359,'includes/itemoptiongroup.php'),(429231,6358,'includes/itemoptiongroup.php'),(429230,3239,'includes/itemoptiongroup.php'),(429229,3240,'includes/itemoptiongroup.php'),(429228,3156,'includes/itemoptiongroup.php'),(429227,1,'includes/itemoptiongroup.php'),(429226,3030,'includes/itemoptiongroup.php'),(429225,6357,'includes/itemoptiongroup.php'),(429224,6356,'includes/itemoptiongroup.php'),(429223,2702,'includes/itemoptiongroup.php'),(429222,6354,'includes/itemoptiongroup.php'),(429221,6353,'includes/itemoptiongroup.php'),(429220,4265,'includes/itemoptiongroup.php'),(429219,6352,'includes/itemoptiongroup.php'),(429218,6351,'includes/itemoptiongroup.php'),(429217,6350,'includes/itemoptiongroup.php'),(429216,2508,'includes/itemoptiongroup.php'),(429215,6349,'includes/itemoptiongroup.php'),(429214,2451,'includes/itemoptiongroup.php'),(429213,6348,'includes/itemoptiongroup.php'),(429212,6413,'includes/itemoptiongroup.php'),(429211,2160,'includes/itemoptiongroup.php'),(429210,6347,'includes/itemoptiongroup.php'),(429209,6346,'includes/itemoptiongroup.php'),(429208,1973,'includes/itemoptiongroup.php'),(429207,6345,'includes/itemoptiongroup.php'),(429206,6344,'includes/itemoptiongroup.php'),(429205,6343,'includes/itemoptiongroup.php'),(429204,1935,'includes/itemoptiongroup.php'),(429203,6342,'includes/itemoptiongroup.php'),(429202,6341,'includes/itemoptiongroup.php'),(429201,6340,'includes/itemoptiongroup.php'),(429200,6339,'includes/itemoptiongroup.php'),(429199,6338,'includes/itemoptiongroup.php'),(429198,6337,'includes/itemoptiongroup.php'),(429197,1519,'includes/itemoptiongroup.php'),(429196,6336,'includes/itemoptiongroup.php'),(429195,6335,'includes/itemoptiongroup.php'),(429194,6334,'includes/itemoptiongroup.php'),(429193,7185,'includes/itemoptiongroup.php'),(429192,902,'includes/itemoptiongroup.php'),(429191,869,'includes/itemoptiongroup.php'),(429190,4065,'includes/itemoptiongroup.php'),(429189,6333,'includes/itemoptiongroup.php'),(429188,799,'includes/itemoptiongroup.php'),(429187,6332,'includes/itemoptiongroup.php'),(429186,6331,'includes/itemoptiongroup.php'),(429185,6330,'includes/itemoptiongroup.php'),(429184,6329,'includes/itemoptiongroup.php'),(429183,6328,'includes/itemoptiongroup.php'),(429182,7184,'includes/itemoptiongroup.php'),(429181,6326,'includes/itemoptiongroup.php'),(429180,4871,'includes/itemoptiongroup.php'),(429179,6325,'includes/itemoptiongroup.php'),(429178,6324,'includes/itemoptiongroup.php'),(429257,9641,'includes/mailclass.php'),(429256,14120,'includes/mailclass.php'),(429255,14119,'includes/mailclass.php'),(429254,18045,'includes/mailclass.php'),(429253,14118,'includes/mailclass.php'),(429252,18044,'includes/mailclass.php'),(429251,14117,'includes/mailclass.php'),(429250,2234,'includes/mailclass.php'),(429249,2070,'includes/mailclass.php'),(429248,13992,'includes/mailclass.php'),(429259,6399,'includes/main.php'),(429263,4088,'includes/sidebar.php'),(429262,11014,'includes/sidebar.php'),(429261,12153,'includes/sidebar.php'),(429260,8936,'includes/sidebar.php'),(426858,6050,'./apvendorbillsrpt.php'),(428896,9074,'includes/filesystemdb.php'),(428895,9073,'includes/filesystemdb.php'),(428894,9072,'includes/filesystemdb.php'),(428893,9071,'includes/filesystemdb.php'),(428892,11558,'includes/filesystemdb.php'),(428891,6170,'includes/filesystemdb.php'),(428890,6169,'includes/filesystemdb.php'),(428889,6168,'includes/filesystemdb.php'),(428888,9070,'includes/filesystemdb.php'),(428887,6167,'includes/filesystemdb.php'),(428886,6166,'includes/filesystemdb.php'),(428885,18881,'includes/filesystemdb.php'),(428884,18880,'includes/filesystemdb.php'),(428883,11940,'includes/filesystemdb.php'),(428882,18879,'includes/filesystemdb.php'),(429247,7973,'includes/mailclass.php'),(429246,15353,'includes/mailclass.php'),(429245,1560,'includes/mailclass.php'),(429244,18043,'includes/mailclass.php'),(426807,16747,'./appointments.php'),(426806,16746,'./appointments.php'),(426805,16745,'./appointments.php'),(426804,16731,'./appointments.php'),(426803,3953,'./appointments.php'),(426802,10526,'./appointments.php'),(426801,18110,'./appointments.php'),(426800,10525,'./appointments.php'),(426799,3948,'./appointments.php'),(426798,10524,'./appointments.php'),(426797,8421,'./appointments.php'),(426796,2975,'./appointments.php'),(426795,2801,'./appointments.php'),(426794,2798,'./appointments.php'),(426793,16744,'./appointments.php'),(426792,16733,'./appointments.php'),(429049,315,'includes/header.php'),(429048,308,'includes/header.php'),(429047,275,'includes/header.php'),(429265,12909,'includes/sidecalendar.php'),(429264,16733,'includes/sidecalendar.php'),(426791,16730,'./appointments.php'),(426790,10523,'./appointments.php'),(426789,17063,'./appointments.php'),(426788,16743,'./appointments.php'),(426787,18109,'./appointments.php'),(426786,18724,'./appointments.php'),(426785,18723,'./appointments.php'),(426784,16729,'./appointments.php'),(426783,2129,'./appointments.php'),(426782,16728,'./appointments.php'),(426919,16749,'./arcimue.php'),(426918,16748,'./arcimue.php'),(426917,2702,'./arcimue.php'),(426916,14054,'./arcimue.php'),(426915,14156,'./arcimue.php'),(426914,14155,'./arcimue.php'),(426913,4023,'./arcimue.php'),(426912,1992,'./arcimue.php'),(426911,14053,'./arcimue.php'),(426910,6481,'./arcimue.php'),(426909,15241,'./arcimue.php'),(426908,1583,'./arcimue.php'),(426907,1582,'./arcimue.php'),(426906,6744,'./arcimue.php'),(426905,14154,'./arcimue.php'),(426904,14153,'./arcimue.php'),(426903,5912,'./arcimue.php'),(426902,5910,'./arcimue.php'),(426901,14152,'./arcimue.php'),(426900,14151,'./arcimue.php'),(426899,9380,'./arcimue.php'),(426898,9379,'./arcimue.php'),(426897,9378,'./arcimue.php'),(426896,9377,'./arcimue.php'),(426895,14150,'./arcimue.php'),(426974,932,'./arinvoicepay.php'),(426973,886,'./arinvoicepay.php'),(426972,673,'./arinvoicepay.php'),(427189,6743,'./arordcc.php'),(427188,226,'./arordcc.php'),(427187,14055,'./arordcc.php'),(429046,16575,'includes/header.php'),(426781,18722,'./appointments.php'),(426780,2106,'./appointments.php'),(426779,15241,'./appointments.php'),(426778,16727,'./appointments.php'),(426777,17128,'./appointments.php'),(426776,8416,'./appointments.php'),(426775,1871,'./appointments.php'),(426774,1821,'./appointments.php'),(426773,1788,'./appointments.php'),(426772,13334,'./appointments.php'),(426771,17062,'./appointments.php'),(426770,1749,'./appointments.php'),(426769,1747,'./appointments.php'),(426768,1741,'./appointments.php'),(426767,17061,'./appointments.php'),(426766,18721,'./appointments.php'),(426765,10520,'./appointments.php'),(426764,1375,'./appointments.php'),(426763,16726,'./appointments.php'),(426762,869,'./appointments.php'),(426761,778,'./appointments.php'),(426760,18720,'./appointments.php'),(426759,16725,'./appointments.php'),(426758,16724,'./appointments.php'),(426757,17127,'./appointments.php'),(426756,17126,'./appointments.php'),(426755,16741,'./appointments.php'),(426754,416,'./appointments.php'),(426753,16723,'./appointments.php'),(426752,17059,'./appointments.php'),(426751,308,'./appointments.php'),(426750,302,'./appointments.php'),(429243,982,'includes/mailclass.php'),(427073,7204,'./arinvoicesum.php'),(427072,1672,'./arinvoicesum.php'),(427071,1625,'./arinvoicesum.php'),(427070,11930,'./arinvoicesum.php'),(427069,3914,'./arinvoicesum.php'),(427068,932,'./arinvoicesum.php'),(428881,8936,'includes/filesystemdb.php'),(426971,15935,'./arinvoicepay.php'),(426970,16219,'./arinvoicepay.php'),(426969,594,'./arinvoicepay.php'),(427067,8271,'./arinvoicesum.php'),(427066,11355,'./arinvoicesum.php'),(427065,325,'./arinvoicesum.php'),(426749,17125,'./appointments.php'),(426748,16740,'./appointments.php'),(426747,275,'./appointments.php'),(426857,16747,'./appointments_ccauth.php'),(426856,18138,'./appointments_ccauth.php'),(426855,16745,'./appointments_ccauth.php'),(426854,10526,'./appointments_ccauth.php'),(426853,10525,'./appointments_ccauth.php'),(426852,10524,'./appointments_ccauth.php'),(426851,8421,'./appointments_ccauth.php'),(426850,2801,'./appointments_ccauth.php'),(426849,2798,'./appointments_ccauth.php'),(426848,16733,'./appointments_ccauth.php'),(426847,10523,'./appointments_ccauth.php'),(426846,16743,'./appointments_ccauth.php'),(426845,18124,'./appointments_ccauth.php'),(426844,18109,'./appointments_ccauth.php'),(426843,18123,'./appointments_ccauth.php'),(426842,18122,'./appointments_ccauth.php'),(426841,2129,'./appointments_ccauth.php'),(426840,18121,'./appointments_ccauth.php'),(426839,2106,'./appointments_ccauth.php'),(426838,8416,'./appointments_ccauth.php'),(426837,1871,'./appointments_ccauth.php'),(426836,1821,'./appointments_ccauth.php'),(426835,1788,'./appointments_ccauth.php'),(426834,13334,'./appointments_ccauth.php'),(426833,1749,'./appointments_ccauth.php'),(426832,1747,'./appointments_ccauth.php'),(426831,1741,'./appointments_ccauth.php'),(426830,18120,'./appointments_ccauth.php'),(426829,10520,'./appointments_ccauth.php'),(426828,1375,'./appointments_ccauth.php'),(426827,16726,'./appointments_ccauth.php'),(426826,1047,'./appointments_ccauth.php'),(426825,778,'./appointments_ccauth.php'),(426824,738,'./appointments_ccauth.php'),(426823,18119,'./appointments_ccauth.php'),(426822,18118,'./appointments_ccauth.php'),(426821,17127,'./appointments_ccauth.php'),(426820,18117,'./appointments_ccauth.php'),(426819,416,'./appointments_ccauth.php'),(426818,16723,'./appointments_ccauth.php'),(426817,18116,'./appointments_ccauth.php'),(426816,18115,'./appointments_ccauth.php'),(426815,18114,'./appointments_ccauth.php'),(426814,18113,'./appointments_ccauth.php'),(426813,308,'./appointments_ccauth.php'),(426812,8676,'./appointments_ccauth.php'),(426811,17125,'./appointments_ccauth.php'),(426810,275,'./appointments_ccauth.php'),(426809,18112,'./appointments_ccauth.php'),(426808,18111,'./appointments_ccauth.php'),(427475,14081,'./client_contacts.php'),(427474,606,'./client_contacts.php'),(427473,11843,'./client_contacts.php'),(427472,524,'./client_contacts.php'),(427471,315,'./client_contacts.php'),(427470,15922,'./client_contacts.php'),(427469,18364,'./client_contacts.php'),(427503,18372,'./client_customer.php'),(427502,18371,'./client_customer.php'),(427501,315,'./client_customer.php'),(427500,18370,'./client_customer.php'),(427499,18369,'./client_customer.php'),(427498,6486,'./client_customer.php'),(429045,9842,'includes/header.php'),(427468,6202,'./client_contacts.php'),(426746,17057,'./appointments.php'),(426745,16575,'./appointments.php'),(426744,16541,'./appointments.php'),(426743,18108,'./appointments.php'),(426742,16722,'./appointments.php'),(426741,197,'./appointments.php'),(426968,17789,'./arinvoicepay.php'),(426967,5441,'./arinvoicepay.php'),(426966,5433,'./arinvoicepay.php'),(427467,185,'./client_contacts.php'),(428880,9069,'includes/filesystemdb.php'),(428879,799,'includes/filesystemdb.php'),(428878,17433,'includes/filesystemdb.php'),(428877,737,'includes/filesystemdb.php'),(428876,9068,'includes/filesystemdb.php'),(428875,9067,'includes/filesystemdb.php'),(428874,15923,'includes/filesystemdb.php'),(428873,18035,'includes/filesystemdb.php'),(428872,18034,'includes/filesystemdb.php'),(428871,9066,'includes/filesystemdb.php'),(428870,13886,'includes/filesystemdb.php'),(428869,13617,'includes/filesystemdb.php'),(428868,11291,'includes/filesystemdb.php'),(428867,542,'includes/filesystemdb.php'),(428866,17070,'includes/filesystemdb.php'),(428865,479,'includes/filesystemdb.php'),(428864,451,'includes/filesystemdb.php'),(428863,12224,'includes/filesystemdb.php'),(428862,17779,'includes/filesystemdb.php'),(428861,9124,'includes/filesystemdb.php'),(428860,9065,'includes/filesystemdb.php'),(428859,9064,'includes/filesystemdb.php'),(428858,9063,'includes/filesystemdb.php'),(428857,9062,'includes/filesystemdb.php'),(428856,9061,'includes/filesystemdb.php'),(428855,17432,'includes/filesystemdb.php'),(429242,18042,'includes/mailclass.php'),(429241,15860,'includes/mailclass.php'),(429240,15859,'includes/mailclass.php'),(429239,11210,'includes/mailclass.php'),(429238,18713,'includes/mailclass.php'),(429237,18041,'includes/mailclass.php'),(426965,16218,'./arinvoicepay.php'),(426964,325,'./arinvoicepay.php'),(426963,315,'./arinvoicepay.php'),(426962,7101,'./arinvoicepay.php'),(426961,5144,'./arinvoicepay.php'),(426960,7198,'./arinvoicepay.php'),(426959,232,'./arinvoicepay.php'),(426958,226,'./arinvoicepay.php'),(426957,7197,'./arinvoicepay.php'),(426956,16217,'./arinvoicepay.php'),(429258,16245,'includes/main.php'),(427520,984,'./customer.php'),(427519,983,'./customer.php'),(427518,982,'./customer.php'),(427517,981,'./customer.php'),(427516,7499,'./customer.php'),(427515,12100,'./customer.php'),(427514,581,'./customer.php'),(427513,524,'./customer.php'),(427512,19478,'./customer.php'),(427511,185,'./customer.php'),(427064,19878,'./arinvoicesum.php'),(427063,5570,'./arinvoicesum.php'),(427464,19706,'./b2b_login.php'),(427463,9661,'./b2b_login.php'),(427462,2622,'./b2b_login.php'),(427461,19876,'./b2b_login.php'),(427460,19705,'./b2b_login.php'),(427459,19704,'./b2b_login.php'),(427458,4469,'./b2b_login.php'),(427457,1047,'./b2b_login.php'),(427456,982,'./b2b_login.php'),(428377,19715,'./passwordreset.php'),(428376,9690,'./passwordreset.php'),(428375,19714,'./passwordreset.php'),(428374,19713,'./passwordreset.php'),(428373,19712,'./passwordreset.php'),(428372,19711,'./passwordreset.php'),(428371,19710,'./passwordreset.php'),(428370,19709,'./passwordreset.php'),(428369,19708,'./passwordreset.php'),(428854,4871,'includes/filesystemdb.php'),(427300,59,'./arserviceordadd.php'),(427455,6399,'./b2b_login.php'),(427510,19804,'./confirm_user.php'),(427509,19803,'./confirm_user.php'),(427508,19802,'./confirm_user.php'),(427507,19711,'./confirm_user.php'),(427506,19801,'./confirm_user.php'),(428648,19805,'./wpverify.php'),(427062,11933,'./arinvoicesum.php'),(427061,7197,'./arinvoicesum.php'),(428555,17904,'./rentalhistory.php'),(428554,19882,'./rentalhistory.php'),(428553,19881,'./rentalhistory.php'),(428552,2021,'./rentalhistory.php'),(428551,19880,'./rentalhistory.php'),(428550,1668,'./rentalhistory.php'),(428549,737,'./rentalhistory.php'),(428548,47,'./rentalhistory.php');
/*!40000 ALTER TABLE `langmatch_b2b` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `languages`
--

DROP TABLE IF EXISTS `languages`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `languages` (
  `languages_id` int(5) NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `code` char(2) NOT NULL default '',
  `image` varchar(64) default NULL,
  `directory` varchar(32) default NULL,
  `sort_order` int(3) default NULL,
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`languages_id`),
  KEY `IDX_LANGUAGES_NAME` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=102 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `languages`
--

LOCK TABLES `languages` WRITE;
/*!40000 ALTER TABLE `languages` DISABLE KEYS */;
INSERT INTO `languages` VALUES (1,'English','en','flag_en.gif','english',1,0),(2,'German','de','flag_de.gif','german',13,0),(3,'Spanish','es','flag_es.gif','espanol',31,0),(4,'Russian','ru','','',28,0),(5,'Portuguese','pt','','',26,0),(6,'Japanese','jp','','',20,0),(7,'French','fr','','',12,0),(9,'Arabic','ar','','',3,0),(10,'Malay','ms','','',22,0),(11,'Hindi','hi','','',16,0),(12,'Thai','th','','',33,0),(13,'Filipino','tl','','',10,0),(14,'Italian','it','','',19,0),(15,'Swedish','sv','','',32,0),(8,'Chinese','zh','','',5,0),(17,'Greek','el','','',14,0),(18,'Hebrew','he','','',15,0),(19,'Korean','ko','','',21,0),(20,'Danish','da','','',6,0),(21,'Norwegian','no','','',23,0),(22,'Finnish','fi','','',11,0),(23,'Dutch','nl','','',8,0),(24,'Indonesian','ba','','',18,0),(25,'Slovenian','si','','',30,0),(26,'Estonian','et','','',9,0),(27,'Romanian','ro','','',27,0),(28,'Afrikaans','af','','',2,0),(29,'Vietnamese','vi','','',36,0),(30,'Serbian','sr','','',29,0),(31,'Polish','pl','','',25,0),(32,'Urdu','ur','','',35,0),(33,'Bulgarian','bg','','',4,0),(35,'Persian','pr','','',24,0),(34,'Turkish','tr','','',34,0),(36,'Dari','dr',NULL,NULL,7,0),(101,'Icelandic','is',NULL,NULL,17,0);
/*!40000 ALTER TABLE `languages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `latereason`
--

DROP TABLE IF EXISTS `latereason`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `latereason` (
  `id_latereason` int(11) NOT NULL default '0',
  `reason` varchar(100) NOT NULL default '',
  `createdate` date NOT NULL default '0000-00-00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` date default NULL,
  `cancel` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_latereason`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `latereason`
--

LOCK TABLES `latereason` WRITE;
/*!40000 ALTER TABLE `latereason` DISABLE KEYS */;
/*!40000 ALTER TABLE `latereason` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `latereasonseq`
--

DROP TABLE IF EXISTS `latereasonseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `latereasonseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `latereasonseq`
--

LOCK TABLES `latereasonseq` WRITE;
/*!40000 ALTER TABLE `latereasonseq` DISABLE KEYS */;
INSERT INTO `latereasonseq` VALUES (0);
/*!40000 ALTER TABLE `latereasonseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `lease`
--

DROP TABLE IF EXISTS `lease`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `lease` (
  `id` int(11) NOT NULL auto_increment,
  `unitid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `rentperiod` varchar(5) NOT NULL default '',
  `cotenant` varchar(150) NOT NULL default '',
  `cotenantemail` varchar(200) NOT NULL default '',
  `cotenant2` varchar(150) NOT NULL default '',
  `cotenant2email` varchar(200) NOT NULL default '',
  `begindate` date NOT NULL default '0000-00-00',
  `enddate` date NOT NULL default '0000-00-00',
  `moveindate` date default NULL,
  `firstinvoicemonths` int(11) NOT NULL default '0',
  `origenddate` date default NULL,
  `rentamount` decimal(19,6) NOT NULL default '0.000000',
  `petrent` decimal(19,6) NOT NULL default '0.000000',
  `lawncare` decimal(19,6) NOT NULL default '0.000000',
  `revenueglaccountid` int(11) NOT NULL default '0',
  `petrentglaccountid` int(11) NOT NULL default '0',
  `lawncareglaccountid` int(11) NOT NULL default '0',
  `deferredrevenueglaccountid` int(11) NOT NULL default '0',
  `numpayments` int(11) NOT NULL default '0',
  `depositamount` decimal(19,6) NOT NULL default '0.000000',
  `depositcredit` decimal(19,6) NOT NULL default '0.000000',
  `depositreturned` decimal(19,6) NOT NULL default '0.000000',
  `depositreturnedinvoiceid` int(11) NOT NULL default '0',
  `depositkeptvoucherid` int(11) NOT NULL default '0',
  `depositglaccountid` int(11) NOT NULL default '0',
  `overagecap` decimal(19,6) NOT NULL default '0.000000',
  `latefee` decimal(19,6) NOT NULL default '0.000000',
  `transferfee` decimal(19,6) NOT NULL default '0.000000',
  `notes` text NOT NULL,
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `reservationfee` decimal(19,6) NOT NULL default '0.000000',
  `reservationfeeglaccountid` int(11) NOT NULL default '0',
  `petdeposit` decimal(19,6) NOT NULL default '0.000000',
  `petdepositcredit` decimal(19,6) NOT NULL default '0.000000',
  `petdepositglaccountid` int(11) NOT NULL default '0',
  `petdepositreturned` decimal(19,6) NOT NULL default '0.000000',
  `proratedamount` decimal(19,6) NOT NULL default '0.000000',
  `prorateddays` int(11) NOT NULL default '0',
  `proratedtotaldays` int(11) NOT NULL default '0',
  `paymentplan` text,
  `leaseended` int(11) NOT NULL default '0',
  `leaseendeddate` datetime default NULL,
  `leaseendeduserid` int(11) NOT NULL default '0',
  `origleaseid` int(11) NOT NULL default '0',
  `renewed` int(11) NOT NULL default '0',
  `transferred` int(11) NOT NULL default '0',
  `transferredunitid` int(11) NOT NULL default '0',
  `autobill` int(11) NOT NULL default '0',
  `leasecode` varchar(30) NOT NULL default '',
  `signed` int(11) NOT NULL default '0',
  `prepaymentamount` decimal(19,6) NOT NULL default '0.000000',
  `prepaymentdate` date default NULL,
  PRIMARY KEY  (`id`),
  KEY `leaseended` (`leaseended`),
  KEY `leasecode` (`leasecode`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `lease`
--

LOCK TABLES `lease` WRITE;
/*!40000 ALTER TABLE `lease` DISABLE KEYS */;
/*!40000 ALTER TABLE `lease` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `leaseapplicationfee`
--

DROP TABLE IF EXISTS `leaseapplicationfee`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `leaseapplicationfee` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `areaid` int(11) NOT NULL default '0',
  `cctransactionid` int(11) NOT NULL default '0',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `cctransactionid` (`cctransactionid`),
  KEY `areaid` (`areaid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `leaseapplicationfee`
--

LOCK TABLES `leaseapplicationfee` WRITE;
/*!40000 ALTER TABLE `leaseapplicationfee` DISABLE KEYS */;
/*!40000 ALTER TABLE `leaseapplicationfee` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `leasedoc`
--

DROP TABLE IF EXISTS `leasedoc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `leasedoc` (
  `id` int(11) NOT NULL auto_increment,
  `buildingid` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `filename` varchar(255) NOT NULL default '',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `leasedoc`
--

LOCK TABLES `leasedoc` WRITE;
/*!40000 ALTER TABLE `leasedoc` DISABLE KEYS */;
/*!40000 ALTER TABLE `leasedoc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `link`
--

DROP TABLE IF EXISTS `link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `link` (
  `id` int(11) NOT NULL default '0',
  `name` varchar(25) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `description` varchar(100) NOT NULL default '',
  `gencompanyid` varchar(11) default NULL,
  `active` varchar(11) default NULL,
  `linktype` varchar(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `link`
--

LOCK TABLES `link` WRITE;
/*!40000 ALTER TABLE `link` DISABLE KEYS */;
/*!40000 ALTER TABLE `link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `loans`
--

DROP TABLE IF EXISTS `loans`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `loans` (
  `id` int(11) NOT NULL auto_increment,
  `loanoriginationdate` date default NULL,
  `loannumber` varchar(255) NOT NULL default '',
  `loandetails` text,
  `status` int(5) NOT NULL default '0',
  `gl_underconstruction_interest` int(11) NOT NULL default '0',
  `gl_inservice_interest` int(11) NOT NULL default '0',
  `gl_principle` int(11) NOT NULL default '0',
  `loantovalue` decimal(19,5) NOT NULL default '0.00000',
  `debtservicecoverage` decimal(19,5) NOT NULL default '0.00000',
  `original_loanbalance` decimal(19,5) NOT NULL default '0.00000',
  `paymentdayofmonth` int(5) NOT NULL default '15',
  `monthlyinterest` decimal(19,5) NOT NULL default '0.00000',
  `monthlyprinciple` decimal(19,5) NOT NULL default '0.00000',
  `interest_type` int(5) NOT NULL default '0',
  `interestpercentpermonth` decimal(8,3) NOT NULL default '0.000',
  `daysperyear` int(5) NOT NULL default '365',
  `amortizationperiods` decimal(14,2) NOT NULL default '0.00',
  `netcarryingbalance` decimal(19,2) NOT NULL default '0.00',
  `termsdetail` text,
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` date default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `buildingid` int(11) NOT NULL default '0',
  `monthlytax` decimal(19,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`),
  KEY `loannumber` (`loannumber`),
  KEY `status` (`status`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `vendorid` (`vendorid`),
  KEY `buildingid` (`buildingid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `loans`
--

LOCK TABLES `loans` WRITE;
/*!40000 ALTER TABLE `loans` DISABLE KEYS */;
/*!40000 ALTER TABLE `loans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `loans_payments`
--

DROP TABLE IF EXISTS `loans_payments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `loans_payments` (
  `id` int(11) NOT NULL auto_increment,
  `loansid` int(11) NOT NULL default '0',
  `apbillid` int(11) NOT NULL default '0',
  `apbillpaymentid` int(11) NOT NULL default '0',
  `paymentamount` decimal(19,5) NOT NULL default '0.00000',
  `interestpaid` decimal(19,5) NOT NULL default '0.00000',
  `principlepaid` decimal(19,5) NOT NULL default '0.00000',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` date default NULL,
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `taxescrow` decimal(19,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`),
  KEY `loansid` (`loansid`),
  KEY `apbillid` (`apbillid`),
  KEY `apbillpaymentid` (`apbillpaymentid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `loans_payments`
--

LOCK TABLES `loans_payments` WRITE;
/*!40000 ALTER TABLE `loans_payments` DISABLE KEYS */;
/*!40000 ALTER TABLE `loans_payments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `loans_sales`
--

DROP TABLE IF EXISTS `loans_sales`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `loans_sales` (
  `id` int(11) NOT NULL auto_increment,
  `loansid` int(11) NOT NULL default '0',
  `sales_writeoff_amount` decimal(19,5) NOT NULL default '0.00000',
  `loan_curtailment_amount` decimal(19,5) NOT NULL default '0.00000',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` date default NULL,
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `sales_detail` text,
  `salesdate` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`id`),
  KEY `loansid` (`loansid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `loans_sales`
--

LOCK TABLES `loans_sales` WRITE;
/*!40000 ALTER TABLE `loans_sales` DISABLE KEYS */;
/*!40000 ALTER TABLE `loans_sales` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `locationseq`
--

DROP TABLE IF EXISTS `locationseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `locationseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `locationseq`
--

LOCK TABLES `locationseq` WRITE;
/*!40000 ALTER TABLE `locationseq` DISABLE KEYS */;
INSERT INTO `locationseq` VALUES (0);
/*!40000 ALTER TABLE `locationseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `loginfailure`
--

DROP TABLE IF EXISTS `loginfailure`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `loginfailure` (
  `id` int(11) NOT NULL auto_increment,
  `username` varchar(50) default NULL,
  `ip` varchar(15) default NULL,
  `entrydate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ipusernamecancel` (`ip`,`username`,`cancel`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `loginfailure`
--

LOCK TABLES `loginfailure` WRITE;
/*!40000 ALTER TABLE `loginfailure` DISABLE KEYS */;
INSERT INTO `loginfailure` VALUES (1,'admin','192.168.1.230','2012-08-02 13:40:30',1),(2,'admin','192.168.1.230','2013-05-30 16:26:56',1),(3,'admin','192.168.1.231','2013-11-19 20:59:55',1);
/*!40000 ALTER TABLE `loginfailure` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `machine`
--

DROP TABLE IF EXISTS `machine`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `machine` (
  `id_machine` int(11) NOT NULL default '0',
  `id_family` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `serialnumber` varchar(50) NOT NULL default '0',
  `machinecostperhour` decimal(10,2) NOT NULL default '0.00',
  `laborcostperhour` decimal(10,2) NOT NULL default '0.00',
  `id_company` int(11) NOT NULL default '0',
  `id_location` int(11) NOT NULL default '0',
  `operatortime` decimal(5,2) NOT NULL default '0.00',
  `overhead` decimal(5,2) NOT NULL default '0.00',
  `markup` decimal(5,2) NOT NULL default '0.00',
  `is_default` int(1) NOT NULL default '0',
  `rolloverpoint` int(15) NOT NULL default '0',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_machine`),
  UNIQUE KEY `id_machine` (`id_machine`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `machine`
--

LOCK TABLES `machine` WRITE;
/*!40000 ALTER TABLE `machine` DISABLE KEYS */;
/*!40000 ALTER TABLE `machine` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `machineseq`
--

DROP TABLE IF EXISTS `machineseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `machineseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `machineseq`
--

LOCK TABLES `machineseq` WRITE;
/*!40000 ALTER TABLE `machineseq` DISABLE KEYS */;
INSERT INTO `machineseq` VALUES (0);
/*!40000 ALTER TABLE `machineseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `magestore`
--

DROP TABLE IF EXISTS `magestore`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `magestore` (
  `id` int(11) NOT NULL auto_increment,
  `name` text,
  `gencompanyid` int(11) NOT NULL default '0',
  `url` text,
  `default_pricelevelid` int(11) NOT NULL default '0',
  `locationid` int(11) NOT NULL default '0',
  `cost` int(11) NOT NULL default '0',
  `sales` int(11) NOT NULL default '0',
  `default_sellunitid` int(11) NOT NULL default '0',
  `default_priceunitid` int(11) NOT NULL default '0',
  `checking` int(11) NOT NULL default '0',
  `depositglacctid` int(11) NOT NULL default '0',
  `default_checkacctid` int(11) NOT NULL default '0',
  `default_salescategory_fulfillment` int(11) NOT NULL default '0',
  `default_invoicetermsid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `api_key` varchar(50) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `magestore`
--

LOCK TABLES `magestore` WRITE;
/*!40000 ALTER TABLE `magestore` DISABLE KEYS */;
/*!40000 ALTER TABLE `magestore` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `maillog`
--

DROP TABLE IF EXISTS `maillog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `maillog` (
  `id` int(11) NOT NULL auto_increment,
  `to` varchar(255) default NULL,
  `from` varchar(255) default NULL,
  `uuid` varchar(32) default NULL,
  `entrydate` datetime default NULL,
  `status` varchar(255) default NULL,
  `mailer` varchar(8) default NULL,
  `genuserid` int(11) default NULL,
  `subject` varchar(255) default NULL,
  `body` mediumtext,
  PRIMARY KEY  (`id`),
  KEY `uuid` (`uuid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `maillog`
--

LOCK TABLES `maillog` WRITE;
/*!40000 ALTER TABLE `maillog` DISABLE KEYS */;
/*!40000 ALTER TABLE `maillog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `maillog_attachments`
--

DROP TABLE IF EXISTS `maillog_attachments`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `maillog_attachments` (
  `id` int(11) NOT NULL auto_increment,
  `maillog_id` int(11) default NULL,
  `filename` varchar(255) default NULL,
  `data` mediumblob,
  PRIMARY KEY  (`id`),
  KEY `maillog_id` (`maillog_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `maillog_attachments`
--

LOCK TABLES `maillog_attachments` WRITE;
/*!40000 ALTER TABLE `maillog_attachments` DISABLE KEYS */;
/*!40000 ALTER TABLE `maillog_attachments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `markupset`
--

DROP TABLE IF EXISTS `markupset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `markupset` (
  `id` int(11) NOT NULL auto_increment,
  `description` char(35) default NULL,
  `costbased` int(11) NOT NULL default '1',
  `companyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `roundto` decimal(12,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`),
  KEY `companyid` (`companyid`),
  KEY `costbased` (`costbased`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `markupset`
--

LOCK TABLES `markupset` WRITE;
/*!40000 ALTER TABLE `markupset` DISABLE KEYS */;
INSERT INTO `markupset` VALUES (1,'Standard',1,1,0,NULL,NULL,NULL,NULL,'2005-03-08 15:08:39',NULL,'0.00');
/*!40000 ALTER TABLE `markupset` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `markupsetlevel`
--

DROP TABLE IF EXISTS `markupsetlevel`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `markupsetlevel` (
  `id` int(11) NOT NULL auto_increment,
  `pricelevelid` int(11) NOT NULL default '0',
  `markupsetid` int(11) NOT NULL default '0',
  `markuppercent` decimal(6,3) NOT NULL default '0.000',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `pricelevelid` (`pricelevelid`),
  KEY `markupsetid` (`markupsetid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `markupsetlevel`
--

LOCK TABLES `markupsetlevel` WRITE;
/*!40000 ALTER TABLE `markupsetlevel` DISABLE KEYS */;
/*!40000 ALTER TABLE `markupsetlevel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mcxcollectionreport`
--

DROP TABLE IF EXISTS `mcxcollectionreport`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mcxcollectionreport` (
  `id` int(11) NOT NULL auto_increment,
  `reportdate` date default NULL,
  `orfrom` varchar(45) default NULL,
  `orto` varchar(45) default NULL,
  `companyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` varchar(45) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `reportdate` (`reportdate`),
  KEY `companyid` (`companyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mcxcollectionreport`
--

LOCK TABLES `mcxcollectionreport` WRITE;
/*!40000 ALTER TABLE `mcxcollectionreport` DISABLE KEYS */;
/*!40000 ALTER TABLE `mcxcollectionreport` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menucategory`
--

DROP TABLE IF EXISTS `menucategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menucategory` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `orderflag` int(11) NOT NULL default '0',
  `menu` int(11) NOT NULL default '0',
  `description` blob,
  `accessap` int(11) NOT NULL default '0',
  `accessar` int(11) NOT NULL default '0',
  `accessgl` int(11) NOT NULL default '0',
  `accesspay` int(11) NOT NULL default '0',
  `accessinv` int(11) NOT NULL default '0',
  `accessest` int(11) NOT NULL default '0',
  `accessfix` int(11) NOT NULL default '0',
  `accessimp` int(11) NOT NULL default '0',
  `setupap` int(11) NOT NULL default '0',
  `setupar` int(11) NOT NULL default '0',
  `setupgl` int(11) NOT NULL default '0',
  `setuppay` int(11) NOT NULL default '0',
  `setupinv` int(11) NOT NULL default '0',
  `setupest` int(11) NOT NULL default '0',
  `setupfix` int(11) NOT NULL default '0',
  `setupimp` int(11) NOT NULL default '0',
  `supervisor` int(11) NOT NULL default '0',
  `nonsupervisor` int(11) NOT NULL default '0',
  `extvend` int(11) NOT NULL default '0',
  `extcust` int(11) NOT NULL default '0',
  `nonext` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `orderflag` (`orderflag`),
  KEY `accessap` (`accessap`),
  KEY `accessar` (`accessar`),
  KEY `accessgl` (`accessgl`),
  KEY `accesspay` (`accesspay`),
  KEY `accessinv` (`accessinv`),
  KEY `accessest` (`accessest`),
  KEY `accessfix` (`accessfix`),
  KEY `accessimp` (`accessimp`),
  KEY `supervisor` (`supervisor`),
  KEY `nonsupervisor` (`nonsupervisor`),
  KEY `extvend` (`extvend`),
  KEY `extcust` (`extcust`),
  KEY `nonext` (`nonext`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menucategory`
--

LOCK TABLES `menucategory` WRITE;
/*!40000 ALTER TABLE `menucategory` DISABLE KEYS */;
INSERT INTO `menucategory` VALUES (1,'Orders',1,1,'Provides an easy means for you to enter orders for: Standard Items; Custom one-time Print Jobs; or New Standard Items to be printed. All of these order types can also be edited and updated. Also, you can enter/update customer information or print lists of customers. Simply click on the appropriate section.',0,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0),(2,'Lists',2,1,'Check on open orders or item, or look to see when an order or item was shipped. By drilling down from the order shipped list, you can see the tracking number, or bring up a copy of the packing slip. Performance statistics track on-time performance for orders.',0,1,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0),(3,'Processing',3,1,'Track progress of order through plant from initial receipt to QC and ship',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(4,'Billing',4,1,'Write Invoices, check customer accounts, view summaries of billing info, aging data.',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(5,'Inventory',5,1,'Enter/Change Item information and run item reports.',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6,'Vendors',6,1,'Enter/Change Vendor information, run lists or labels, and update vendor login users.',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0),(7,'Purchasing',7,1,'Receive items into inventory either directly, or by first issuing a PO and tracking status. After PO is received, vendor billing information can be transferred to payables.',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(8,'Payables',8,1,'Manage your accounts payables by tracking open bills and aging of payables. Write checks for specific invoices, or for all invoices grouped by date range.',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9,'Payroll',9,1,'Calculate payrolls, write checks, track vacation, sick leave, etc. Write 941, W2 and other payroll reports.',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(10,'Ledger',10,1,'',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(11,'Admin',11,1,'Add Internal Users, adjust their rights, import data from external database, and set up Document Categories to allow easier searches for Documents.',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(12,'Prefs',12,1,'',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0),(13,'AR Setup',15,0,'Enter/Update all the necessary standards on which quoting and scheduling are based, carriers used, etc.',0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(14,'AP Setup',16,0,'Enter/Update Vendor Terms, checking account info, and GL accounts for tie-ins.',0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),(15,'Print Management Setup',17,0,'Enter/Update all the necessary standards on which quoting and scheduling are based, carriers used, etc.',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(16,'Payroll Setup',18,0,'Enter/Update Taxes, deductions, pension plans, etc. on which payroll is based.',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(17,'General Ledger Setup',19,0,'Set the fiscal year for your company. Account types you should NOT change unless you are VERY sure you understand the implications of changing them.',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0),(18,'Inventory Setup',20,0,'Enter Unit, Location, Category, etc. information about how the inventory is to be organized.',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0);
/*!40000 ALTER TABLE `menucategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menudata`
--

DROP TABLE IF EXISTS `menudata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menudata` (
  `id` int(11) NOT NULL default '0',
  `menu_name` varchar(100) default '',
  `id_menudata` int(11) NOT NULL default '0',
  `orderflag` int(5) NOT NULL default '0',
  `menu_action` int(2) NOT NULL default '1',
  `description` varchar(250) default NULL,
  `accessap` int(2) NOT NULL default '0',
  `accessar` int(2) NOT NULL default '0',
  `accessgl` int(2) NOT NULL default '0',
  `accesspay` int(2) NOT NULL default '0',
  `accessinv` int(2) NOT NULL default '0',
  `estaccess` int(2) NOT NULL default '0',
  `accessfix` int(2) NOT NULL default '0',
  `accessimp` int(2) NOT NULL default '0',
  `accesssc` int(2) NOT NULL default '0',
  `setupap` int(2) NOT NULL default '0',
  `setupar` int(2) NOT NULL default '0',
  `setupgl` int(2) NOT NULL default '0',
  `setuppay` int(2) NOT NULL default '0',
  `setupinv` int(2) NOT NULL default '0',
  `estsetup` int(2) NOT NULL default '0',
  `setupfix` int(2) NOT NULL default '0',
  `setupimp` int(2) NOT NULL default '0',
  `setupsc` int(2) NOT NULL default '0',
  `supervisor` int(2) NOT NULL default '0',
  `extvend` int(2) NOT NULL default '0',
  `extcust` int(2) NOT NULL default '0',
  `nonext` int(2) NOT NULL default '0',
  `menu_link` varchar(255) default NULL,
  `linktype` varchar(11) NOT NULL default '',
  `plaintext` varchar(11) NOT NULL default '',
  `languageid` int(2) NOT NULL default '0',
  `icon` varchar(255) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `groupname` varchar(15) NOT NULL default '',
  `menu_path` varchar(255) NOT NULL default '',
  `featureid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menudata`
--

LOCK TABLES `menudata` WRITE;
/*!40000 ALTER TABLE `menudata` DISABLE KEYS */;
INSERT INTO `menudata` VALUES (1,'STR_CONTACTS',0,1,0,'STR_CONTACTS_MENU_DESC',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'orders_main.png',0,'','STR_CONTACTS',0),(100,'STR_CUSTOMERS',1,100,0,'STR_CUSTOMER_INFORMATION',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustupd.php','','',1,'customer.png',0,'','STR_CONTACTS|STR_CUSTOMERS',0),(1001,'STR_NEW_CUSTOMER',100,1,1,'STR_ADD_CUSTOMER_INFORMATION',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustadd.php','','',1,'add.png',0,'','STR_CONTACTS|STR_CUSTOMERS|STR_NEW_CUSTOMER',0),(1002,'STR_EDIT_VIEW_CUSTOMER',100,2,1,'STR_VIEW_CUSTOMER_INFORMATION',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustupd.php','','',1,'edit.png',0,'','STR_CONTACTS|STR_CUSTOMERS|STR_EDIT_VIEW_CUSTOMER',0),(1003,'STR_B2B_USERS',100,3,1,'STR_ADD_LISTS_OF_EXTERNAL_B2B_CUSTOMER_USERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustb2buser.php?ar=1','','',1,'contacts.png',0,'','STR_CONTACTS|STR_CUSTOMERS|STR_B2B_USERS',123),(101,'STR_EMAIL_CENTER',1,101,1,'STR_EMAIL_CENTER_DESC',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminemail.php','','',1,'mail.png',0,'','STR_CONTACTS|STR_EMAIL_CENTER',0),(102,'STR_EMPLOYEES',1,102,0,'STR_ADD_UPDATE_EMPLOYEE_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'premployeeupd.php','','',1,'customer.png',0,'','STR_CONTACTS|STR_EMPLOYEES',121),(1021,'STR_NEW_EMPLOYEE',102,1,1,'STR_ADD_EMPLOYEE_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'premployeeadd.php','','',1,'add.png',0,'','STR_CONTACTS|STR_EMPLOYEES|STR_NEW_EMPLOYEE',121),(1022,'STR_EDIT_EMPLOYEE',102,2,1,'STR_UPDATE_EMPLOYEE_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'premployeeupd.php','','',1,'edit.png',0,'','STR_CONTACTS|STR_EMPLOYEES|STR_EDIT_EMPLOYEE',121),(103,'STR_SALES_PERSONNEL',1,103,0,'STR_ENTER_UPDATE_SALES_PERSONNEL',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'premployeeupd.php','','',1,'customer.png',0,'','STR_CONTACTS|STR_SALES_PERSONNEL',0),(1031,'STR_NEW_SALES_PERSONNEL',103,1,1,'STR_NEW_SALES_PERSONNEL',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminarsalesmanadd.php','','',1,'customer.png',0,'','STR_CONTACTS|STR_SALES_PERSONNEL|STR_NEW_SALES_PERSONNEL',0),(1032,'STR_EDIT_SALES_PERSONNEL',103,2,1,'STR_EDIT_SALES_PERSONNEL',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminarsalesmanupd.php','','',1,'customer.png',0,'','STR_CONTACTS|STR_SALES_PERSONNEL|STR_EDIT_SALES_PERSONNEL',0),(104,'STR_VENDORS',1,104,0,'STR_VENDOR_ENTRY_UPDATE_REPORTS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'vendors.png',0,'','STR_CONTACTS|STR_VENDORS',0),(1041,'STR_NEW_VENDOR',104,1,1,'STR_ENTER_NEW_VENDOR_DATA',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apvendadd.php','','',1,'add.png',0,'','STR_CONTACTS|STR_VENDORS|STR_NEW_VENDOR',0),(1042,'STR_EDIT_VENDOR',104,2,1,'STR_UPDATE_VENDOR_DATA',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apvendupd.php','','',1,'edit.png',0,'','STR_CONTACTS|STR_VENDORS|STR_EDIT_VENDOR',0),(1043,'STR_VENDOR_B2B_LOGIN_USERS',104,3,1,'STR_VENDOR_B2B_LOGIN_USERS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arvendb2buser.php?ap=1','','',1,'b2buser.png',0,'','STR_CONTACTS|STR_VENDORS|STR_VENDOR_B2B_LOGIN_USERS',123),(2,'STR_ORDERS',0,2,0,'STR_ORDER_TRACKING_LISTS_FILLING_STATISTICS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'orders_main.png',0,'','STR_ORDERS',122),(201,'STR_B2B_WEB_PORTAL',2,201,1,'STR_BUSINESS_TO_BUSINESS_SITE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'b2b/index.php','','',1,'mail.png',0,'','STR_ORDERS|STR_B2B_WEB_PORTAL',123),(202,'STR_ITEM_ORDERS',2,202,0,'STR_ITEM_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordupd.php','','',1,'orders.png',0,'fulfillment','STR_ORDERS|STR_ITEM_ORDERS',122),(2021,'STR_NEW_EDIT_ORDER',202,1,1,'STR_NEW_EDIT_ORDER',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'nporder.php?pos_mode=0','','',1,'edit.png',0,'fulfillment','STR_ORDERS|STR_ITEM_ORDERS|STR_NEW_EDIT_ORDER',122),(2022,'STR_ORDERS_INVOICES',202,2,1,'STR_CREATE_INVOICES_FROM_SHIPPED_OR_COMPLETED_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorder2invoice.php','','',1,'process.png',0,'fulfillment','STR_ORDERS|STR_ITEM_ORDERS|STR_ORDERS_INVOICES',122),(2023,'STR_PROCESS_RMAS',202,3,1,'STR_RMAS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arrmashipview.php','','',1,'rma.png',0,'fulfillment','STR_ORDERS|STR_ITEM_ORDERS|STR_PROCESS_RMAS',122),(2024,'STR_SHIP_ORDER',202,4,1,'STR_ENTER_SHIPMENTS_OF_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordshipadd.php','','',1,'ship.png',0,'fulfillment','STR_ORDERS|STR_ITEM_ORDERS|STR_SHIP_ORDER',122),(203,'STR_POINT_OF_SALE',2,203,1,'STR_POINT_OF_SALE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'nporder.php','','',1,'pos2.png',0,'','STR_ORDERS|STR_POINT_OF_SALE',122),(204,'STR_SERVICE_ORDERS',2,204,0,'STR_ENTER_AND_UPDATE_SERVICE_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arserviceordupd.php','','',1,'service.png',0,'service','STR_ORDERS|STR_SERVICE_ORDERS',122),(2044,'STR_NEW_ORDER',204,4,1,'STR_ADD_NEW_SERVICE_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arserviceordadd.php','','',1,'add.png',0,'service','STR_ORDERS|STR_SERVICE_ORDERS|STR_NEW_ORDER',122),(2045,'STR_EDIT_ORDER',204,5,1,'STR_EDIT_SERVICE_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arserviceordupd.php','','',1,'edit.png',0,'service','STR_ORDERS|STR_SERVICE_ORDERS|STR_EDIT_ORDER',122),(2046,'STR_EDIT_INTERNAL_WORK',204,6,1,'STR_EDIT_INTERNAL_WORK_TIME',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'serviceorder_time_editor.php','','',1,'edit.png',0,'service','STR_ORDERS|STR_SERVICE_ORDERS|STR_EDIT_INTERNAL_WORK',122),(2047,'STR_LOG_TIME',204,7,1,'STR_LOG_HOURS_ON_SERVICE_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'serviceorder_time.php','','',1,'time.png',0,'service','STR_ORDERS|STR_SERVICE_ORDERS|STR_LOG_TIME',122),(3,'STR_INVENTORY',0,3,0,'STR_INVENTORY_ENTRY_UPDATE_REPORTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'inventory_main.png',0,'','STR_INVENTORY',122),(300,'STR_INVENTORY_ITEMS',3,300,0,'STR_INVENTORY_ITEM_ENTRY_UPDATE',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'inventory.png',0,'','STR_INVENTORY|STR_INVENTORY_ITEMS',122),(3001,'STR_ADD_ITEMS',300,1,1,'STR_ADD_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemadd.php','','',1,'add.png',0,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ADD_ITEMS',122),(3002,'STR_EDIT_ITEMS',300,2,1,'STR_EDIT_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemupd.php','','',1,'edit.png',0,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_EDIT_ITEMS',122),(3003,'STR_COPY_PRICING',300,3,1,'STR_COPY_ITEM_PRICES_TO_OTHER_LOCATION',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'inventory_pricecopy.php','','',1,'finance.png',0,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_COPY_PRICING',122),(3004,'STR_ITEM_ADJUSTMENTS',300,4,1,'STR_ADJUST_ITEM_QUANTITIES',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'inventory_adjustments.php','','',1,'refresh.png',0,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_ADJUSTMENTS',122),(3005,'STR_ITEM_BREAKDOWN',300,5,1,'STR_ITEM_BREAKDOWN',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'inventory_breakdown.php','','',1,'kits.png',0,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_BREAKDOWN',122),(3006,'STR_ITEM_COST_ADJUSTMENTS',300,6,1,'STR_ITEM_COST_ADJUSTMENTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'inventory_costadjust.php','','',1,'refresh.png',0,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_COST_ADJUSTMENTS',122),(3007,'STR_ITEM_PRICES_MASS_EDIT',300,7,1,'STR_ITEM_PRICES_MASS_EDIT',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemprices.php','','',1,'finance.png',0,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_PRICES_MASS_EDIT',90),(3008,'STR_ITEM_REORDER_LIST',300,8,1,'STR_ITEM_REORDER_LIST',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstreorder.php','','',1,'report.png',0,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_REORDER_LIST',122),(3009,'STR_ITEM_TRANSFERS',300,9,1,'STR_INVENTORY_ITEM_TRANSFERS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'inventory_transfers.php','','',1,'refresh.png',0,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_TRANSFERS',122),(30010,'STR_ITEM_SUPPLIERS',300,10,1,'STR_ENTRY_UPDATE_OF_SUPPLIER_INFORMATION_FOR_SPECIFIC_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemvendupd.php','','',1,'ship.png',0,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_SUPPLIERS',122),(301,'STR_MANAGE_BUILD_ORDERS',3,301,0,'STR_ENTER_UPDATE_COMPONENT_LIST_FOR_BILL_OF_MATERIALS_INVENTORY_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'kits.png',0,'','STR_INVENTORY|STR_MANAGE_BUILD_ORDERS',122),(3011,'STR_NEW_BUILD_ORDER',301,1,1,'STR_ADD_BILL_OF_MATERIALS_INVENTORY_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitembuildorder.php?cmd=main2','','',1,'add.png',0,'','STR_INVENTORY|STR_MANAGE_BUILD_ORDERS|STR_NEW_BUILD_ORDER',122),(3012,'STR_EDIT_BUILD_ORDER',301,2,1,'STR_ENTER_UPDATE_BILL_OF_MATERIALS_INVENTORY_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitembuildorder.php','','',1,'edit.png',0,'','STR_INVENTORY|STR_MANAGE_BUILD_ORDERS|STR_EDIT_BUILD_ORDER',122),(3013,'STR_CREATE_PO',301,3,1,'STR_CREATE_PO_FOR_BUILD_ORDERS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitembompo.php','','',1,'purchase.png',0,'','STR_INVENTORY|STR_MANAGE_BUILD_ORDERS|STR_CREATE_PO',122),(3014,'STR_EDIT_DEFINITIONS',301,4,1,'STR_BUILD_ORDER_DEFINITIONS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'bom_entry_or_update.php','','',1,'edit.png',0,'','STR_INVENTORY|STR_MANAGE_BUILD_ORDERS|STR_EDIT_DEFINITIONS',122),(4,'STR_BILLING',0,4,0,'STR_INVOICING_PAYMENTS_RECEIVED_SALES_TAX_REPORTS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'billing_main.png',0,'','STR_BILLING',0),(400,'STR_BANK_DEPOSITS',4,400,0,'STR_BANK_DEPOSITS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'process.png',0,'','STR_BILLING|STR_BANK_DEPOSITS',0),(4001,'STR_NEW_BANK_DEPOSIT',400,1,1,'STR_CREATE_BANK_DEPOSITS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arbankdepositadd.php','','',1,'add.png',0,'','STR_BILLING|STR_BANK_DEPOSITS|STR_NEW_BANK_DEPOSIT',0),(4002,'STR_EDIT_BANK_DEPOSIT',400,2,1,'STR_UPDATE_BANK_DEPOSITS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arbankdepositupd.php','','',1,'edit.png',0,'','STR_BILLING|STR_BANK_DEPOSITS|STR_EDIT_BANK_DEPOSIT',0),(401,'STR_INVOICES',4,401,0,'STR_CREATE_EDIT_INVOICE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'finance.png',0,'','STR_BILLING|STR_INVOICES',0),(4011,'STR_NEW_INVOICE',401,1,1,'STR_CREATE_A_NEW_INVOICE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoiceadd.php','','',1,'add.png',0,'','STR_BILLING|STR_INVOICES|STR_NEW_INVOICE',0),(4012,'STR_EDIT_INVOICE',401,2,0,'STR_UPDATE_INVOICES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoiceupd.php','','',1,'edit.png',0,'','STR_BILLING|STR_INVOICES|STR_EDIT_INVOICE',0),(4013,'STR_NEW_NON_INVOICED_SALES',401,3,0,'STR_NEW_NON_INVOICED_SALES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcashpaymentadd.php','','',1,'add.png',0,'','STR_BILLING|STR_INVOICES|STR_NEW_NON_INVOICED_SALES',0),(4014,'STR_EDIT_NON_INVOICED_SALES',401,4,0,'STR_EDIT_NON_INVOICED_SALES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcashpaymentupd.php','','',1,'edit.png',0,'','STR_BILLING|STR_INVOICES|STR_EDIT_NON_INVOICED_SALES',0),(4015,'STR_CALCULATE_INTEREST',401,5,1,'STR_CALCULATE_INTEREST_ON_OVERDUE_INVOICES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicecalcint.php','','',1,'calculator.png',0,'','STR_BILLING|STR_INVOICES|STR_CALCULATE_INTEREST',0),(4016,'STR_ENTER_PAYMENTS',401,6,1,'STR_ENTER_PAYMENTS_RECEIVED',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicepay.php','','',1,'finance.png',0,'','STR_BILLING|STR_INVOICES|STR_ENTER_PAYMENTS',0),(4017,'STR_POINT_OF_SALE',401,7,0,'STR_POINT_OF_SALE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'nporder.php','','',1,'pos2.png',0,'','STR_BILLING|STR_INVOICES|STR_POINT_OF_SALE',122),(4018,'STR_REFUND_CREDIT',401,8,1,'STR_WRITE_CHECK_TO_CANCEL_CREDIT_BALANCE_ON_CUSTOMER_ACCOUNT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcredit_writecheck.php','','',1,'payment.png',0,'','STR_BILLING|STR_INVOICES|STR_REFUND_CREDIT',0),(4019,'STR_VOID_PAYMENTS',401,9,1,'STR_VOID_PAYMENTS_ENTERED',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arinvoicepayvoid.php','','',1,'void.png',0,'','STR_BILLING|STR_INVOICES|STR_VOID_PAYMENTS',0),(402,'STR_PAYMENT_PLANS',4,402,0,'STR_CREATE_UPDATE_A_NEW_PAYMENT_PLAN',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arpayplanupd.php','','',1,'picklist.png',0,'','STR_BILLING|STR_PAYMENT_PLANS',0),(4021,'STR_NEW_PLAN',402,1,1,'STR_NEW_PAYMENT_PLAN',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arpayplanadd.php','','',1,'add.png',0,'','STR_BILLING|STR_PAYMENT_PLANS|STR_NEW_PLAN',0),(4022,'STR_EDIT_PLAN',402,2,1,'STR_UPDATE_EXISTING_PAYMENT_PLAN',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arpayplanupd.php','','',1,'edit.png',0,'','STR_BILLING|STR_PAYMENT_PLANS|STR_EDIT_PLAN',0),(4023,'STR_POST_PLANS',402,3,1,'STR_POST_PAYMENT_PLANS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arpayplan_post.php','','',1,'process.png',0,'','STR_BILLING|STR_PAYMENT_PLANS|STR_POST_PLANS',0),(5,'STR_PAYABLES',0,5,0,'STR_PAYABLES_ENTRY_UPDATE_WRITE_CHECK_REQUESTS_REPORTS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'payables_main.png',0,'','STR_PAYABLES',0),(500,'STR_CHECKS',5,500,0,'STR_WRITE_CHECKS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apmanualcheck.php','','',1,'checkingacct.png',0,'','STR_PAYABLES|STR_CHECKS',0),(5001,'STR_MANUAL_CHECKS',500,1,1,'STR_WRITE_CHECKS_MANUALLY_WITHOUT_FIRST_ENTERING_BILL',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apmanualcheck.php','','',1,'check.png',0,'','STR_PAYABLES|STR_CHECKS|STR_MANUAL_CHECKS',0),(5002,'STR_VIEW_CANCEL_CHECKS',500,2,1,'STR_VIEW_CANCEL_PAYABLES_CHECKS_WRITTEN',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apchecking.php','','',1,'void.png',0,'','STR_PAYABLES|STR_CHECKS|STR_VIEW_CANCEL_CHECKS',0),(5003,'STR_WRITE_CHECKS',500,3,1,'STR_WRITE_CHECKS_FOR_SPECIFIC_BILLS_OR_MAKE_PARTIAL_PAYMENTS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbillpay.php','','',1,'checkingacct.png',0,'','STR_PAYABLES|STR_CHECKS|STR_WRITE_CHECKS',0),(501,'STR_PURCHASING',5,501,0,'STR_PURCHASE_ORDER_ENTRY_UPDATE_PRINT_POS_RECEIVE_GOODS_REPORTS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'purchase.png',0,'','STR_PAYABLES|STR_PURCHASING',122),(5011,'STR_NEW_PURCHASE_ORDER',501,1,1,'STR_CREATE_A_NEW_PURCHASE_ORDER',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invpoadd.php','','',1,'add.png',0,'','STR_PAYABLES|STR_PURCHASING|STR_NEW_PURCHASE_ORDER',122),(5012,'STR_EDIT_PURCHASE_ORDER',501,2,1,'STR_UPDATE_AN_EXISTING_PURCHASE_ORDER',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invpoupd.php','','',1,'edit.png',0,'','STR_PAYABLES|STR_PURCHASING|STR_EDIT_PURCHASE_ORDER',122),(5013,'STR_COMPLETED_PO_TO_AP',501,3,1,'STR_PASS_COMPLETED_PURCHASE_ORDER_INFORMATION_INTO_PAYABLES_MATCH_TO_BILLS_RECEIVED',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invpotoap.php','','',1,'process.png',0,'','STR_PAYABLES|STR_PURCHASING|STR_COMPLETED_PO_TO_AP',122),(5014,'STR_RECEIVE_ITEMS_ON_PO',501,4,1,'STR_RECEIVE_ITEMS_INTO_INVENTORY_FOR_WHICH_PURCHASE_ORDER_WAS_CREATED',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invporecv.php','','',1,'receive.png',0,'','STR_PAYABLES|STR_PURCHASING|STR_RECEIVE_ITEMS_ON_PO',122),(5015,'STR_RECEIVE_WITHOUT_PO',501,5,1,'STR_RECEIVE_ITEMS_INTO_INVENTORY_THAT_DID_NOT_HAVE_A_PURCHASE_ORDER_CREATED',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemrecadd.php','','',1,'receive.png',0,'','STR_PAYABLES|STR_PURCHASING|STR_RECEIVE_WITHOUT_PO',122),(502,'STR_VENDOR_BILLS',5,502,0,'STR_VENDOR_BILLS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'payables.png',0,'','STR_PAYABLES|STR_VENDOR_BILLS',0),(5021,'STR_NEW_VENDOR_BILL',502,1,1,'STR_CREATE_A_NEW_VENDOR_BILL',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbilladd.php','','',1,'add.png',0,'','STR_PAYABLES|STR_VENDOR_BILLS|STR_NEW_VENDOR_BILL',0),(5022,'STR_EDIT_VENDOR_BILL',502,2,1,'STR_UPDATE_AN_EXISTING_PAYABLES_BILL',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbillupd.php','','',1,'edit.png',0,'','STR_PAYABLES|STR_VENDOR_BILLS|STR_EDIT_VENDOR_BILL',0),(6,'STR_PAYROLL',0,6,0,'STR_EMPLOYEE_ENTRY_UPDATE_WRITE_CHECKS_REPORTS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'payroll_main.png',0,'','STR_PAYROLL',121),(600,'STR_CALCULATE_AND_CHECKS',6,600,0,'STR_LOG_HOURS_CALCULATE_ALL_PAY_AND_TAXES_FOR_PERIOD',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prcalchours.php','','',1,'process.png',0,'','STR_PAYROLL|STR_CALCULATE_AND_CHECKS',121),(6001,'STR_CALCULATE',600,1,1,'STR_CALCULATE_ALL_PAY_AND_TAXES_FOR_PERIOD',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prcalchours.php','','',1,'calculator.png',0,'','STR_PAYROLL|STR_CALCULATE_AND_CHECKS|STR_CALCULATE',121),(6002,'STR_CHECK_SUMMARY',600,2,1,'STR_PAYROLL_CHECK_SUMMARY_FOR_ONE_PAY_PERIOD',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prchecksum.php','','',1,'report.png',0,'','STR_PAYROLL|STR_CALCULATE_AND_CHECKS|STR_CHECK_SUMMARY',121),(6003,'STR_EMPLOYEE_CHECK_EDIT',600,3,1,'STR_ADD_UPDATE_EMPLOYEE_PAY_AND_DEDUCTION_INFORMATION',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'premplweekupd.php','','',1,'payment.png',0,'','STR_PAYROLL|STR_CALCULATE_AND_CHECKS|STR_EMPLOYEE_CHECK_EDIT',121),(6004,'STR_LOG_HOURS',600,4,1,'STR_ENTER_HOURS_WORKED_AND_MISC_PAY_DEDUCTIONS_FOR_EMPLOYEES',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prloghours.php','','',1,'time.png',0,'','STR_PAYROLL|STR_CALCULATE_AND_CHECKS|STR_LOG_HOURS',121),(6005,'STR_WRITE_CHECKS',600,5,1,'STR_WRITE_PAYROLL_CHECKS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prcheckwrite.php','','',1,'checkingacct.png',0,'','STR_PAYROLL|STR_CALCULATE_AND_CHECKS|STR_WRITE_CHECKS',121),(601,'STR_EMPLOYEE_DEDUCTIONS',6,601,1,'STR_REGULAR_DEDUCTIONS_TO_BE_TAKEN_FROM_EMPLOYEE_PAY',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'premplded.php','','',1,'void.png',0,'','STR_PAYROLL|STR_EMPLOYEE_DEDUCTIONS',121),(602,'STR_TAX_TABLES',6,602,0,'STR_ENTER_UPDATE_TAXES_TABLES',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'picklist.png',0,'','STR_PAYROLL|STR_TAX_TABLES',121),(6026,'STR_EDIT_TAX_TABLE',602,6,1,'STR_EDIT_TAX_TABLE',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminprtaxtypedtl.php','','',1,'picklist.png',0,'','STR_PAYROLL|STR_TAX_TABLES|STR_EDIT_TAX_TABLE',121),(6027,'STR_NEW_TAX_TYPE',602,7,1,'STR_ADD_NEW_PAYROLL_TAX_DISTRICT',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminprtaxtypeadd.php','','',1,'add.png',0,'','STR_PAYROLL|STR_TAX_TABLES|STR_NEW_TAX_TYPE',121),(6028,'STR_EDIT_TAX_TYPE',602,8,1,'STR_VIEW_OR_CHANGE_PAYROLL_TAX_DISTRICTS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminprtaxtypeupd.php','','',1,'edit.png',0,'','STR_PAYROLL|STR_TAX_TABLES|STR_EDIT_TAX_TYPE',121),(6029,'STR_START_NEW_YEAR',602,9,1,'STR_START_NEW_YEAR_FOR_TAXES',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'copytax.php','','',1,'edit.png',0,'','STR_PAYROLL|STR_TAX_TABLES|STR_START_NEW_YEAR',121),(603,'STR_WRITE_EMPLOYEE_REVIEW',6,603,1,'STR_WRITE_AN_EMPLOYEE_PERFORMANCE_REVIEW',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'premplreviewupd.php','','',1,'mail.png',0,'','STR_PAYROLL|STR_WRITE_EMPLOYEE_REVIEW',121),(7,'STR_LEDGER',0,7,0,'STR_JOURNAL_ENTRY_BALANCE_SHEET',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'ledger_main.png',0,'','STR_LEDGER',0),(700,'STR_BANK_RECONCILIATION',7,700,1,'STR_BANK_RECONCILIATION_WORKSHEET',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arbankreconcile.php','','',1,'report.png',0,'','STR_LEDGER|STR_BANK_RECONCILIATION',0),(701,'STR_BUDGETS',7,701,0,'STR_BUDGETS',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'budget.png',0,'','STR_LEDGER|STR_BUDGETS',0),(7011,'STR_NEW_EDIT_BUDGET',701,1,1,'STR_NEW_EDIT_BUDGET',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glbudadd.php','','',1,'edit.png',0,'','STR_LEDGER|STR_BUDGETS|STR_NEW_EDIT_BUDGET',0),(7012,'STR_BUDGET_VARIANCE',701,2,1,'STR_GENERAL_LEDGER_BUDGET_VARIANCE_REPORT',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepbudvariance.php','','',1,'statistics.png',0,'','STR_LEDGER|STR_BUDGETS|STR_BUDGET_VARIANCE',0),(702,'STR_CHART_OF_ACCOUNTS',7,702,0,'STR_CHART_OF_ACCOUNTS',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glacctupd.php','','',1,'list.png',0,'','STR_LEDGER|STR_CHART_OF_ACCOUNTS',0),(7021,'STR_NEW_GL_ACCOUNTS',702,1,1,'STR_NEW_GL_ACCOUNTS',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glacctadd.php','','',1,'add.png',0,'','STR_LEDGER|STR_CHART_OF_ACCOUNTS|STR_NEW_GL_ACCOUNTS',0),(7022,'STR_EDIT_GL_ACCOUNTS',702,2,1,'STR_EDIT_GL_ACCOUNTS',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glacctupd.php','','',1,'edit.png',0,'','STR_LEDGER|STR_CHART_OF_ACCOUNTS|STR_EDIT_GL_ACCOUNTS',0),(7023,'STR_ASSIGN_SUMMARIZATION',702,3,1,'STR_ASSIGN_SUMMARIZATION',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glacct_assign.php','','',1,'list3.png',0,'','STR_LEDGER|STR_CHART_OF_ACCOUNTS|STR_ASSIGN_SUMMARIZATION',0),(703,'STR_JOURNAL_ENTRIES',7,703,0,'STR_CREATE_AND_EDIT_GENERAL_LEDGER_JOURNAL_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljourupd.php','','',1,'notes.png',0,'','STR_LEDGER|STR_JOURNAL_ENTRIES',0),(7031,'STR_NEW_JOURNAL_ENTRIES',703,1,0,'STR_CREATE_AND_EDIT_GENERAL_LEDGER_JOURNAL_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljouradd.php','','',1,'add.png',0,'','STR_LEDGER|STR_JOURNAL_ENTRIES|STR_NEW_JOURNAL_ENTRIES',0),(7032,'STR_EDIT_JOURNAL_ENTRIES',703,2,0,'STR_EDIT_GENERAL_LEDGER_JOURNAL_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljourupd.php','','',1,'edit.png',0,'','STR_LEDGER|STR_JOURNAL_ENTRIES|STR_EDIT_JOURNAL_ENTRIES',0),(7033,'STR_CLOSE_YEAR',703,3,1,'STR_CLOSE_YEAR',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glclose_year.php','','',1,'complete.png',0,'','STR_LEDGER|STR_JOURNAL_ENTRIES|STR_CLOSE_YEAR',0),(7034,'STR_POST_JOURNALS_NOW',703,4,1,'STR_GENERAL_LEDGER_POST_JOURNALS_FROM_ANY_SOURCE',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glpostadd.php','','',1,'process.png',0,'','STR_LEDGER|STR_JOURNAL_ENTRIES|STR_POST_JOURNALS_NOW',0),(7035,'STR_REVERSE_JOURNAL_POSTINGS',703,5,1,'STR_REVERSE_GENERAL_LEDGER_POST_ACTION',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glpostupd.php','','',1,'receive.png',0,'','STR_LEDGER|STR_JOURNAL_ENTRIES|STR_REVERSE_JOURNAL_POSTINGS',0),(704,'STR_RECURRING_LEDGER_ENTRIES',7,704,0,'STR_RECURRING_LEDGER_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'refresh.png',0,'','STR_LEDGER|STR_RECURRING_LEDGER_ENTRIES',0),(7041,'STR_NEW_RECURRING_ENTRIES',704,1,1,'STR_ENTER_RECURRING_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljour_std_add.php','','',1,'add.png',0,'','STR_LEDGER|STR_RECURRING_LEDGER_ENTRIES|STR_NEW_RECURRING_ENTRIES',0),(7042,'STR_EDIT_RECURRING_ENTRIES',704,2,1,'STR_UPDATE_RECURRING_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljour_std_upd.php','','',1,'edit.png',0,'','STR_LEDGER|STR_RECURRING_LEDGER_ENTRIES|STR_EDIT_RECURRING_ENTRIES',0),(7043,'STR_POST_RECURRING_ENTRIES',704,3,1,'STR_POST_RECURRING_LEDGER_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljour_std_post.php','','',1,'process.png',0,'','STR_LEDGER|STR_RECURRING_LEDGER_ENTRIES|STR_POST_RECURRING_ENTRIES',0),(8,'STR_TOOLS',0,8,0,'STR_TOOLS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'','','',1,'admin_main.png',0,'','STR_TOOLS',0),(800,'STR_ADD_ONS',8,800,1,'STR_PURCHASE_AND_MANAGE_ADD_ONS_AND_PLUG_INS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'featurepurchase.php','','',1,'edit.png',0,'','STR_TOOLS|STR_ADD_ONS',0),(801,'STR_API_LOG_VIEWER',8,801,1,'STR_API_LOG_VIEWER',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'adminapilog.php','','',1,'list.png',0,'','STR_TOOLS|STR_API_LOG_VIEWER',22),(802,'STR_CUSTOM_FIELDS_EDITOR',8,802,1,'STR_CUSTOM_FIELDS_EDITOR',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'adminflexfields.php','','',1,'data_web.png',0,'','STR_TOOLS|STR_CUSTOM_FIELDS_EDITOR',20),(803,'STR_DATABASE_INFO',8,803,1,'STR_DATABASE_INFORMATION',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'adminserversetup.php','','',1,'purchase.png',0,'','STR_TOOLS|STR_DATABASE_INFO',0),(804,'STR_EXPORTS',8,804,0,'STR_EXPORTS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'','','',1,'refresh.png',0,'','STR_TOOLS|STR_EXPORTS',0),(8041,'STR_EXPORT_ACCOUNTS',804,1,1,'STR_EXPORT_GENERAL_LEDGER_ACCOUNTS_LIST',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'gl_admin_export.php','','',1,'process.png',0,'','STR_TOOLS|STR_EXPORTS|STR_EXPORT_ACCOUNTS',0),(8042,'STR_EXPORT_ITEMS',804,2,1,'STR_EXPORT_ITEMS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'exportitems.php','','',1,'inventory.png',0,'','STR_TOOLS|STR_EXPORTS|STR_EXPORT_ITEMS',122),(8043,'STR_EXPORT_VENDORS',804,3,1,'STR_EXPORT_VENDORS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'exportvendors.php','','',1,'vendors.png',0,'','STR_TOOLS|STR_EXPORTS|STR_EXPORT_VENDORS',0),(805,'STR_IMPORTS',8,805,0,'STR_IMPORTS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'','','',1,'refresh.png',0,'','STR_TOOLS|STR_IMPORTS',0),(8051,'STR_IMPORT_ACCOUNTS',805,1,1,'STR_IMPORT_GENERAL_LEDGER_ACCOUNTS_LIST',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'gl_admin_import.php','','',1,'import.png',0,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_ACCOUNTS',0),(8052,'STR_IMPORT_BANK_STATEMENTS',805,2,1,'STR_IMPORT_BANK_STATEMENTS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'importbankofx.php','','',1,'cash.png',0,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_BANK_STATEMENTS',97),(8053,'STR_IMPORT_CUSTOMERS',805,3,1,'STR_IMPORT_CUSTOMER_LIST_INTO_NOLAPRO',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'importcustomer.php','','',1,'customer.png',0,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_CUSTOMERS',0),(8054,'STR_DISTRIBUTOR_FILE_IMPORT',805,4,1,'STR_IMPORT_DISTRIBUTOR_CSV_FILES_FOR_COMMISSIONS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'import_distributor_sales.php','','',1,'import.png',0,'','STR_TOOLS|STR_IMPORTS|STR_DISTRIBUTOR_FILE_IMPORT',0),(8055,'STR_IMPORT_EMPLOYEES',805,5,1,'STR_IMPORT_EMPLOYEES_INTO_NOLAPRO',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'importemployee.php','','',1,'customer.png',0,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_EMPLOYEES',121),(8056,'STR_IMPORT_GL_TOTALS',805,6,1,'STR_IMPORT_GL_TOTALS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'importgltotals.php','','',1,'list.png',0,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_GL_TOTALS',0),(8057,'STR_IMPORT_INVENTORY_CATEGORIES',805,7,1,'STR_IMPORT_INVENTORY_CATEGORIES_FROM_CSV_FILE',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'importitem_categories.php','','',1,'inventory.png',0,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_INVENTORY_CATEGORIES',122),(8058,'STR_IMPORT_INVENTORY_ITEMS',805,8,1,'STR_IMPORT_INVENTORY_ITEMS_FROM_CSV_FILE',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'importitems.php','','',1,'inventory.png',0,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_INVENTORY_ITEMS',122),(8059,'STR_IMPORT_QUICKBOOKS_FILES',805,9,1,'STR_IMPORT_QUICKBOOKS_FILES',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'qbimport.php','','',1,'list.png',0,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_QUICKBOOKS_FILES',41),(80510,'STR_IMPORT_VENDORS',805,10,1,'STR_IMPORT_VENDOR_LIST_INTO_NOLAPRO',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'importvendor.php','','',1,'vendors.png',0,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_VENDORS',0),(806,'STR_IP_ACCESS_MANAGER',8,806,1,'STR_IP_ACCESS_MANAGER',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'adminipaccessmanager.php','','',1,'location.png',0,'','STR_TOOLS|STR_IP_ACCESS_MANAGER',28),(807,'STR_LANGUAGE_EDITOR',8,807,1,'STR_MODIFY_DISPLAY_TEXT',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'translation.php','','',1,'mail.png',0,'','STR_TOOLS|STR_LANGUAGE_EDITOR',0),(808,'STR_OSCOMMERCE',8,808,1,'STR_OSCOMMERCE_INTEGRATION_DEFAULTS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'adminosccompanyupd.php','','',1,'edit.png',0,'','STR_TOOLS|STR_OSCOMMERCE',27),(809,'STR_SURVEYS',8,809,0,'STR_SURVEYS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'','','',1,'refresh.png',0,'','STR_TOOLS|STR_SURVEYS',45),(8091,'STR_SURVEY_MANAGER',809,1,1,'STR_SURVEY_MANAGER',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'adminsurvey.php','','',1,'list3.png',0,'','STR_TOOLS|STR_SURVEYS|STR_SURVEY_MANAGER',45),(8092,'STR_SURVEY_REPORTS',809,2,1,'STR_SURVEY_REPORTS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'adminsurveyreport.php','','',1,'list3.png',0,'','STR_TOOLS|STR_SURVEYS|STR_SURVEY_REPORTS',45),(810,'STR_USER_ACTIVITY_MONITOR',8,810,1,'STR_USER_ACTIVITY_MONITOR',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'adminactivitymonitor.php','','',1,'list2.png',0,'','STR_TOOLS|STR_USER_ACTIVITY_MONITOR',16),(9,'STR_ADMIN',0,9,0,'STR_ADMINISTRATION_TOOLS_USER_RIGHTS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'','','',1,'admin_main.png',0,'','STR_ADMIN',0),(901,'STR_MY_INFO',9,901,1,'STR_MY_INFO',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'myuser.php','','',1,'purchase.png',0,'','STR_ADMIN|STR_MY_INFO',0),(902,'STR_ADMIN_SETUP',9,902,0,'STR_ADMIN_SETUP_TOOLS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,'','STR_ADMIN|STR_ADMIN_SETUP',0),(9021,'STR_ADD_ONS',902,1,1,'STR_PURCHASE_AND_MANAGE_ADD_ONS_AND_PLUG_INS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'featurepurchase.php','','',1,'edit.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_ADD_ONS',123),(9022,'STR_B2B_SITE_GRAPHICS',902,2,1,'STR_B2B_SITE_GRAPHICS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminb2bsite.php','','',1,'graphics.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_B2B_SITE_GRAPHICS',123),(9023,'STR_COMPANY_ADD_UPDATE',902,3,1,'STR_ENTER_UPDATE_COMPANIES_COVERED_BY_SYSTEM',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gencompanyupd.php','','',1,'location.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_COMPANY_ADD_UPDATE',0),(9024,'STR_DASHBOARD_REPORTS',902,4,1,'STR_DASHBOARD_REPORTS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminhpgroups.php','','',1,'location.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_DASHBOARD_REPORTS',0),(9025,'STR_HOMEPAGE_REFRESH_TIMES',902,5,1,'STR_HOMEPAGE_REFRESH',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminreportcache.php','','',1,'list.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_HOMEPAGE_REFRESH_TIMES',0),(9026,'STR_LINK_ADD_UPDATE',902,6,1,'STR_LINK_ADD_UPDATE_TEXT',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'link_addupdate.php','','',1,'link.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_LINK_ADD_UPDATE',0),(9027,'STR_LOGO_BRANDING',902,7,1,'STR_ASSIGN_LOGO_FOR_LOGON_PAGE_AND_FOOTERS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminbing.php','','',1,'edit.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_LOGO_BRANDING',11),(9028,'STR_MANAGE_SUBSCRIPTION',902,8,1,'STR_MANAGE_SUBSCRIPTION',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'managesub.php','','',1,'edit.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_MANAGE_SUBSCRIPTION',0),(9029,'STR_NOTE_CATEGORIES',902,9,1,'STR_NOTE_CATEGORIES',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminnotecategory.php','','',1,'list.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_NOTE_CATEGORIES',0),(90210,'STR_NEW_EDIT_STATE',902,10,1,'STR_NEW_EDIT_STATE_TEXT',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'state_addupdate.php','','',1,'data_web.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_NEW_EDIT_STATE',0),(90211,'STR_SYSTEM_SETTINGS',902,11,1,'STR_SYSTEM_SETTINGS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminsystemsettings.php','','',1,'edit.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_SYSTEM_SETTINGS',0),(90212,'STR_NEW_EDIT_USER',902,12,1,'STR_ENTER_UPDATE_USER_LIST',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'genuserupd.php','','',1,'customer.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_NEW_EDIT_USER',0),(90213,'STR_USER_RIGHTS_GROUPS',902,13,1,'STR_USER_RIGHTS_GROUPS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'genuserrightsgroup.php','','',1,'customer.png',0,'','STR_ADMIN|STR_ADMIN_SETUP|STR_USER_RIGHTS_GROUPS',83),(903,'STR_SETUP_SERVICE',9,903,0,'STR_SETUP_FUNCTIONS_FOR_SERVICE_ORDERS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,'service','STR_ADMIN|STR_SETUP_SERVICE',122),(9031,'STR_RMA_SETUP',903,1,1,'STR_RMA_CONDITIONS_REASONS_ACTIONS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminar_rmasetup.php','','',1,'tools.png',0,'fulfillment','STR_ADMIN|STR_SETUP_SERVICE|STR_RMA_SETUP',122),(9032,'STR_SERVICE_CLASSES',903,2,1,'STR_ENTER_SERVICE_ORDER_CLASSES_OF_LABOR',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arserviceclassupd.php','','',1,'service.png',0,'service','STR_ADMIN|STR_SETUP_SERVICE|STR_SERVICE_CLASSES',122),(9033,'STR_SERVICE_LABOR_RATES',903,3,1,'STR_LABOR_RATES_FOR_SERVICE_ORDER_TYPES_AND_CLASSES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arservicerates.php','','',1,'payment.png',0,'service','STR_ADMIN|STR_SETUP_SERVICE|STR_SERVICE_LABOR_RATES',122),(9034,'STR_SERVICE_STATUS_OPTIONS',903,4,1,'STR_STATUS_OPTIONS_FOR_SERVICE_ORDERS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarordstatusupd.php','','',1,'edit.png',0,'service','STR_ADMIN|STR_SETUP_SERVICE|STR_SERVICE_STATUS_OPTIONS',122),(9035,'STR_SERVICE_SUBTYPES',903,5,1,'STR_SERVICE_SUBTYPES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arservicesubtype.php','','',1,'category.png',0,'service','STR_ADMIN|STR_SETUP_SERVICE|STR_SERVICE_SUBTYPES',122),(9036,'STR_SERVICE_TYPES',903,6,1,'STR_ENTER_SERVICE_ORDER_TYPES_OF_WORK',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arservicetypeupd.php','','',1,'category.png',0,'service','STR_ADMIN|STR_SETUP_SERVICE|STR_SERVICE_TYPES',122),(9037,'STR_SET_NEXT_ORDER_NUMBER',903,7,1,'STR_SET_NEXT_ORDER_NUMBER',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arordernumber.php','','',1,'category.png',0,'service','STR_ADMIN|STR_SETUP_SERVICE|STR_SET_NEXT_ORDER_NUMBER',122),(904,'STR_SETUP_FUNCTIONS_FOR_INVENTORY',9,904,0,'STR_ENTER_UNITS_LOCATIONS_CATEGORIES_ETC',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY',122),(9041,'STR_CUSTOMER_ITEM_DISCOUNTS',904,1,1,'STR_CUSTOMER_ITEM_DISCOUNTS',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'arcustitemdiscount.php','','',1,'customer.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_CUSTOMER_ITEM_DISCOUNTS',87),(9042,'STR_GENERAL_SETUP',904,2,1,'STR_GENERAL_SETUP',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'admininvglacct.php','','',1,'list.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_GENERAL_SETUP',122),(9043,'STR_ITEM_BEGINNING_BALANCES',904,3,1,'STR_ENTER_BEGINNING_ONHAND_FOR_INVENTORY',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'invbeginbal.php','','',1,'beginbal.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_ITEM_BEGINNING_BALANCES',122),(9044,'STR_ITEM_CATEGORIES',904,4,1,'STR_ENTER_UPDATE_CATEGORIES_OF_ITEMS',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'invitemcatupd.php','','',1,'category.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_ITEM_CATEGORIES',122),(9045,'STR_ITEM_OPTION_GROUPS',904,5,1,'STR_ITEM_OPTION_GROUPS_DESC',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'invitemoptiongroup.php','','',1,'category.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_ITEM_OPTION_GROUPS',122),(9046,'STR_ITEM_PAGE_CUSTOMIZER',904,6,1,'STR_ITEM_PAGE_CUSTOMIZER',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'invitempage_define.php','','',1,'category.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_ITEM_PAGE_CUSTOMIZER',37),(9047,'STR_PLANT_LOCATIONS',904,7,1,'STR_PLANT_LOCATIONS_WHERE_INVENTORY_IS_KEPT',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'admininvlocationupd.php','','',1,'location.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_PLANT_LOCATIONS',122),(9048,'STR_PRICING_LEVELS',904,8,1,'STR_ENTER_UPDATE_PRICING_LEVELS_FOR_INVENTORY_SALES',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'invlevelupd.php','','',1,'finance.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_PRICING_LEVELS',122),(9049,'STR_SALES_UNIT',904,9,1,'STR_UNITS_OF_MEASURE_FOR_STOCKING_AND_PURCHASING_INVENTORY',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'admininvunitnameupd.php','','',1,'report.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_SALES_UNIT',122),(90410,'STR_ITEM_CAT_SEARCH',904,10,1,'STR_ITEM_CAT_SEARCH',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'invitemsearchcat.php','','',1,'search.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_ITEM_CAT_SEARCH',122),(90411,'STR_STANDARD_MARKUP',904,11,1,'STR_STANDARD_MARKUP_SETS_FOR_AUTO_MARKING_UP_INVENTORY',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'invmarkupupd.php','','',1,'payment.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_STANDARD_MARKUP',122),(90412,'STR_VERIFY_INVENTORY',904,12,1,'STR_VERIFY_AND_CORRECT_ITEM_BALANCES',0,0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,'inventory_recalcFMLW.php','','',1,'tools.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_VERIFY_INVENTORY',122),(905,'STR_SETUP_RECEIVABLES',9,905,0,'STR_BASIC_SETUP_FUNCTIONS_FOR_RECEIVABLES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES',0),(9051,'STR_BEGINNING_BALANCES',905,1,1,'STR_ENTER_BEGINNING_BALANCE_INVOICES_FOR_STATUP_ONLY',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arinvoiceadd_beginbal.php','','',1,'rma.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_BEGINNING_BALANCES',0),(9052,'STR_COMPANY_OPTIONS',905,2,1,'STR_COMPANY_LOGO_NAME_ETC',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarcompanyupd.php','','',1,'edit.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_COMPANY_OPTIONS',0),(9053,'STR_CREDIT_CARD_OPTIONS',905,3,1,'STR_SET_UP_CREDIT_CARD_PROCESSING',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminccsetup.php','','',1,'creditcard.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_CREDIT_CARD_OPTIONS',0),(9054,'STR_CUSTOMER_GROUPS',905,4,1,'STR_CUSTOMER_GROUPS_FOR_INVENTORY_ITEMS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminargroupsupd.php','','',1,'customer.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_CUSTOMER_GROUPS',0),(9055,'STR_CUSTOMER_PAGE_CUSTOMIZER',905,5,1,'STR_CUSTOMER_PAGE_CUSTOMIZER',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arcustomerpage_define.php','','',1,'customer.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_CUSTOMER_PAGE_CUSTOMIZER',35),(9056,'STR_GENERAL_SETUP',905,6,1,'STR_ENTER_UPDATE_GL_ACCOUNTS_USED_FOR_RECEIVABLES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarglacct.php','','',1,'list.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_GENERAL_SETUP',0),(9057,'STR_INVOICE_NOTES',905,7,1,'STR_SELECTABLE_NOTES_FOR_PAGES_FOLLOWING_INVOICE',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'admininvoicenotesupd.php','','',1,'list4.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_INVOICE_NOTES',0),(9058,'STR_INVOICE_TERMS',905,8,1,'STR_ENTER_UPDATE_STANDARD_PAYMENT_TERMS_FOR_INVOICES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarinvtermsupd.php','','',1,'list3.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_INVOICE_TERMS',0),(9059,'STR_QUOTE_COMMENTS',905,9,1,'STR_STANDARD_COMMENTS_TO_USE_ON_QUOTES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarquotecomupd.php','','',1,'notes.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_QUOTE_COMMENTS',0),(90510,'STR_SALES_CATEGORIES',905,10,1,'STR_SALES_CATEGORIES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarsales_category.php','','',1,'category.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_SALES_CATEGORIES',0),(90511,'STR_SALES_UNIT',905,11,1,'STR_UNIT_NAMES_FOR_ITEMS_SOLD',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'admininvunitnameupd.php','','',1,'payment.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_SALES_UNIT',0),(90512,'STR_SALES_TAXES',905,12,1,'STR_SALES_TAX_RATES_AND_NAMES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarsalestaxupd.php','','',1,'finance.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_SALES_TAXES',0),(90513,'STR_SHIPPING_CARRIERS',905,13,1,'STR_ENTER_UPDATE_CARRIERS_AND_SHIPMENT_METHODS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarcarrierupd.php','','',1,'ship.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_SHIPPING_CARRIERS',0),(90514,'STR_TAX_EXEMPTIONS',905,14,1,'STR_SALES_TAX_EXEMPTION_REASONS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminartaxexupd.php','','',1,'finance.png',0,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_TAX_EXEMPTIONS',0),(906,'STR_SETUP_FUNCTIONS_FOR_PAYABLES',9,906,0,'STR_ENTER_UPDATE_VENDOR_TERMS_CHECKING_ACCOUNT_INFO_GL_ACCOUNTS_FOR_TIE_INS',0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES',0),(9061,'STR_BEGIN_BILLS',906,1,1,'STR_ENTER_BEGINNING_BALANCE_VENDOR_BILLS',0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,0,0,0,'apbilladd_beginbal.php','','',1,'beginbal.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_BEGIN_BILLS',0),(9062,'STR_CHECKING_ACCOUNTS',906,2,1,'STR_ENTER_UPDATE_PAYMENT_OR_CHECKING_ACCOUNTS_USED_FOR_PAYABLES',0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,0,0,0,'adminapchkacctupd.php','','',1,'checkingacct.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_CHECKING_ACCOUNTS',0),(9063,'STR_GENERAL_SETUP',906,3,1,'STR_ENTER_UPDATE_STANDARD_GL_ACCOUNTS_USED_BY_PAYABLES',0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,0,0,0,'adminapglacct.php','','',1,'list.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_GENERAL_SETUP',0),(9064,'STR_PO_NOTES',906,4,1,'STR_ENTER_STANDARD_NOTES_TO_BE_SELECTED_FOR_PRINT_ON_PAGES_FOLLOWING_MAIN_PO',0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,0,0,0,'admininvponotesupd.php','','',1,'notes.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_PO_NOTES',122),(9065,'STR_SHIPPING_CARRIERS',906,5,1,'STR_ENTER_UPDATE_CARRIERS_AND_SHIPMENT_METHODS',0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,0,0,0,'adminarcarrierupd.php','','',1,'ship.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_SHIPPING_CARRIERS',0),(9066,'STR_VENDOR_PAGE_CUSTOMIZER',906,6,1,'STR_VENDOR_PAGE_CUSTOMIZER',0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,0,0,0,'apvendorpage_define.php','','',1,'category.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_VENDOR_PAGE_CUSTOMIZER',38),(9067,'STR_VENDOR_TERMS',906,7,1,'STR_ENTER_UPDATE_STANDARD_TERMS_EXTENDED_BY_VENDORS_FOR_PAYMENT_OF_INVOICES',0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,0,0,0,'adminappaytermsupd.php','','',1,'report.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_VENDOR_TERMS',0),(9068,'STR_VENDOR_TYPES',906,8,1,'STR_ENTER_UPDATE_TYPES_OF_VENDORS',0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,1,0,0,0,'adminapvendortype.php','','',1,'report.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_VENDOR_TYPES',0),(907,'STR_SETUP_FUNCTIONS_FOR_PAYROLL',9,907,0,'STR_ENTER_UPDATE_TAXES_DEDUCTIONS_PENSION_PLANS_ETC',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL',121),(9071,'STR_CHECKING_ACCOUNTS',907,1,1,'STR_ENTER_UPDATE_CHECKING_ACCOUNTS_USED_FOR_PAYROLL',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'adminapchkacctupd.php','','',1,'checkingacct.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_CHECKING_ACCOUNTS',0),(9072,'STR_COMPANY_CONTRIBUTIONS',907,2,1,'STR_AMOUNTS_PAID_BY_EMPLOYER',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'adminprcon.php','','',1,'refresh.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_COMPANY_CONTRIBUTIONS',121),(9073,'STR_DEDUCTION_GROUPS',907,3,1,'STR_PAYROLL_DEDUCTION_GROUPS',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'adminprdedgroupupd.php','','',1,'category.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_DEDUCTION_GROUPS',121),(9074,'STR_DIRECT_DEPOSIT_AUTH',907,4,1,'STR_DIRECTION_DEPOSIT_AUTHORIZATION_FORM',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'directdepform.php','','',1,'process.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_DIRECT_DEPOSIT_AUTH',121),(9075,'STR_GENERAL_BENEFITS_PAY',907,5,1,'STR_BENEFITS_PAY_FOR_GROUP',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'adminprben.php','','',1,'finance.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_GENERAL_BENEFITS_PAY',121),(9076,'STR_GENERAL_DEDUCTIONS',907,6,1,'STR_DEDUCTION_FOR_GROUP',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'adminprded.php','','',1,'payment.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_GENERAL_DEDUCTIONS',121),(9077,'STR_GENERAL_FACTORS',907,7,1,'STR_GENERAL_PAYROLL_INFORMATION',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'adminprgendat.php','','',1,'report.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_GENERAL_FACTORS',121),(9078,'STR_GENERAL_SETUP',907,8,1,'STR_ENTER_UPDATE_STANDARD_GL_ACCOUNTS_USED_BY_PAYROLL',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'adminprglacct.php','','',1,'list.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_GENERAL_SETUP',121),(9079,'STR_PAY_TYPES',907,9,1,'STR_PAYROLL_PAY_TYPES',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'adminprpaytypeupd.php','','',1,'finance.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_PAY_TYPES',121),(90710,'STR_PENSION_PLANS',907,10,1,'STR_ENTER_UPDATE_PENSION_HEALTH_OTHER_PLAN',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'adminprpens.php','','',1,'pension.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_PENSION_PLANS',121),(90711,'STR_RATING_SCALE_FOR_REVIEWS',907,11,1,'STR_SET_UP_RATING_SCALE',0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,1,0,0,0,'adminpremplreviewratingupd.php','','',1,'notes.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_RATING_SCALE_FOR_REVIEWS',121),(908,'STR_SETUP_FUNCTIONS_FOR_GL',9,908,0,'STR_SET_THE_FISCAL_YEAR',0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL',0),(9081,'STR_ACCOUNT_TYPES',908,1,1,'STR_CHANGE_THE_NAMES_USED_FOR_ACCOUNT_TYPES',0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,0,0,0,'adminglaccttypeupd.php','','',1,'list2.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL|STR_ACCOUNT_TYPES',0),(9082,'STR_GL_COST_CENTERS',908,2,1,'STR_ADD_EDIT_GENERAL_LEDGER_COST_CENTERS',0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,0,0,0,'glcost_centerupd.php','','',1,'category.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL|STR_GL_COST_CENTERS',0),(9083,'STR_GL_SUMMARY_LEVELS',908,3,1,'STR_ADD_EDIT_SUMMARY_LEVEL_DESCRIPTIONS',0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,0,0,0,'gl_sumlevelupd.php','','',1,'beginbal.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL|STR_GL_SUMMARY_LEVELS',0),(9084,'STR_SET_FISCAL_START_MONTH',908,4,1,'STR_CHANGE_YOUR_COMPANY_FISCAL_YEAR_BEGIN',0,0,0,0,0,0,0,0,0,1,1,1,1,0,0,0,0,0,1,0,0,0,'adminglcompanyupd.php','','',1,'calendar.png',0,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL|STR_SET_FISCAL_START_MONTH',0),(10,'STR_REPORTS',0,10,0,'STR_REPORTS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,1,0,0,0,'','','',1,'admin_main.png',0,'','STR_REPORTS',0),(1100,'STR_CONTACTS',10,1100,0,'STR_CUSTOMER_INFORMATION',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,1,0,0,0,'arcustupd.php','','',1,'customer.png',0,'','STR_REPORTS|STR_CONTACTS',0),(11001,'STR_CUSTOMER_ACCOUNTS',1100,1,1,'STR_VIEW_ACCOUNT_DATA',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,1,0,0,0,'arinvoicerepcust.php','','',1,'report.png',0,'','STR_REPORTS|STR_CONTACTS|STR_CUSTOMER_ACCOUNTS',0),(11002,'STR_CUSTOMER_ACTIVITY_HISTORY',1100,2,1,'STR_CUSTOMER_ACTIVITY_HISTORY',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,1,0,0,0,'arinvoicerepbalcust_detail.php','','',1,'history.png',0,'','STR_REPORTS|STR_CONTACTS|STR_CUSTOMER_ACTIVITY_HISTORY',0),(11003,'STR_CUSTOMER_BALANCE_HISTORY',1100,3,1,'STR_CUSTOMER_BALANCE_HISTORY',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,1,0,0,0,'arinvoicerepbalcust.php','','',1,'history.png',0,'','STR_REPORTS|STR_CONTACTS|STR_CUSTOMER_BALANCE_HISTORY',0),(11004,'STR_LIST_CUSTOMERS',1100,4,1,'STR_LISTS_AND_EXPORTS_OF_CUSTOMER_DATA',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,1,0,0,0,'arcustlist.php','','',1,'list.png',0,'','STR_REPORTS|STR_CONTACTS|STR_LIST_CUSTOMERS',0),(11005,'STR_INACTIVE_CUSTOMERS',1100,5,1,'STR_INACTIVE_CUSTOMERS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,1,0,0,0,'arcustlistremove.php','','',1,'list2.png',0,'','STR_REPORTS|STR_CONTACTS|STR_INACTIVE_CUSTOMERS',0),(11006,'STR_EMPLOYEE_BIRTHDAYS',1100,6,1,'STR_LIST_OF_EMPLOYEE_BIRTHDAYS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=bday','','',1,'list1.png',0,'','STR_REPORTS|STR_CONTACTS|STR_EMPLOYEE_BIRTHDAYS',121),(11007,'STR_NAME_ADDRESS_PHONE_LIST',1100,7,1,'STR_NAME_ADDRESS_PHONE_LIST',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=nap','','',1,'list.png',0,'','STR_REPORTS|STR_CONTACTS|STR_NAME_ADDRESS_PHONE_LIST',121),(11008,'STR_EMPLOYEE_GENERAL_INFORMATION',1100,8,1,'STR_LIST_OF_EMPLOYEE_GENERAL_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=gen','','',1,'list3.png',0,'','STR_REPORTS|STR_CONTACTS|STR_EMPLOYEE_GENERAL_INFORMATION',121),(11009,'STR_EMPLOYEE_PHONE_LIST',1100,9,1,'STR_EMPLOYEE_PHONE_LIST',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=phone','','',1,'list2.png',0,'','STR_REPORTS|STR_CONTACTS|STR_EMPLOYEE_PHONE_LIST',121),(110010,'STR_EMPLOYEE_SENIORITY',1100,10,1,'STR_EMPLOYEE_SENIORITY',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=sen','','',1,'list4.png',0,'','STR_REPORTS|STR_CONTACTS|STR_EMPLOYEE_SENIORITY',121),(110011,'STR_RECENT_CUSTOMERS',1100,11,1,'STR_LIST_RECENT_CUSTOMERS',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'recent_customers.php','','',1,'list.png',0,'','STR_REPORTS|STR_CONTACTS|STR_RECENT_CUSTOMERS',0),(110012,'STR_VENDOR_LISTS_LABELS',1100,12,1,'STR_PRINT_LISTS_OR_LABELS_OF_VENDORS',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apvendlist.php','','',1,'list.png',0,'','STR_REPORTS|STR_CONTACTS|STR_VENDOR_LISTS_LABELS',0),(1101,'STR_ORDERS',10,1101,0,'STR_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustupd.php','','',1,'customer.png',0,'','STR_REPORTS|STR_ORDERS',122),(11011,'STR_BACK_ORDERS',1101,1,1,'STR_LISTS_OF_BACK_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderlist_backorder.php','','',1,'list1.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_BACK_ORDERS',122),(11012,'STR_BILLED_NOT_PAID',1101,2,1,'STR_ORDER_BILLED_BUT_NOT_PAID',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderunpaid.php','','',1,'finance.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_BILLED_NOT_PAID',122),(11013,'STR_CUSTOMER_ITEM_HISTORY',1101,3,1,'STR_CUSTOMER_ITEM_HISTORY',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordercustitemlst.php','','',1,'history.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_CUSTOMER_ITEM_HISTORY',122),(11014,'STR_FULFILLMENT_QUOTES',1101,4,1,'STR_PENDING_FULFILLMENT_ORDER_QUOTES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderquotelist.php','','',1,'list.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_FULFILLMENT_QUOTES',122),(11015,'STR_HOURS_ORDERED',1101,5,1,'STR_HOURS_ORDERED',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorder_over_hours.php','','',1,'list3.png',0,'service','STR_REPORTS|STR_ORDERS|STR_HOURS_ORDERED',122),(11016,'STR_ORDERS_COMPLETED',1101,6,1,'STR_LISTS_OF_COMPLETED_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordershiplst.php','','',1,'list3.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_ORDERS_COMPLETED',122),(11017,'STR_ORDERS_OPEN',1101,7,1,'STR_LISTS_OF_OPEN_PENDING_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderlist.php','','',1,'list2.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_ORDERS_OPEN',122),(11018,'STR_SUMMARY_OPEN_ORDERS',1101,8,1,'STR_LISTS_OF_OPEN_PENDING_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderlist_sum.php','','',1,'list1.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_SUMMARY_OPEN_ORDERS',122),(11019,'STR_OPEN_ORDER_WEIGHT_VIEW',1101,9,1,'STR_OPEN_ORDER_WEIGHT_VIEW',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderlistweight.php','','',1,'list3.png',0,'fulfillment','STR_REPORTS|STR_ORDERS|STR_OPEN_ORDER_WEIGHT_VIEW',122),(110110,'STR_ORDERS_OVER_ESTIMATE',1101,10,1,'STR_ORDERS_NEAR_OR_OVER_ESTIMATE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'over_estimate_orders_list.php','','',1,'list2.png',0,'service','STR_REPORTS|STR_ORDERS|STR_ORDERS_OVER_ESTIMATE',122),(110111,'STR_ORDERS_RECEIVED',1101,11,1,'STR_LISTS_OF_ORDERS_RECEIVED',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderlistreceive.php','','',1,'list4.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_ORDERS_RECEIVED',122),(110112,'STR_ORDERS_UNCONFIRMED',1101,12,1,'STR_LISTS_AND_CONFIRM_ORDERS_ENTERED_BY_B2B_USERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorder_unconfirmed.php','','',1,'list.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_ORDERS_UNCONFIRMED',122),(110113,'STR_PERFORMANCE_STATISTICS',1101,13,1,'STR_ON_TIME_STATISTICS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderstatlst.php','','',1,'newslice.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_PERFORMANCE_STATISTICS',122),(110114,'STR_RMA_LISTS',1101,14,1,'STR_LIST_PENDING_AND_COMPLETED_RMAS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderrmalst.php','','',1,'list4.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_RMA_LISTS',122),(110115,'STR_SHIPPED_NOT_BILLED',1101,15,1,'STR_FULFILLMENT_ORDERS_SHIPPED_BUT_NOT_BILLED',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderunbilled.php','','',1,'list2.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_SHIPPED_NOT_BILLED',122),(110116,'STR_VIEW_SHIPPED_ORDERS',1101,16,1,'STR_VIEW_ORDERS_SHIPPED',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordshipview.php','','',1,'list1.png',0,'fulfillment','STR_REPORTS|STR_ORDERS|STR_VIEW_SHIPPED_ORDERS',122),(110117,'STR_TIME_REPORT',1101,17,1,'STR_TIME_REPORT_FOR_SERVICE_ORDER_WORK',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'serviceorder_time_reporter.php','','',1,'report.png',0,'service','STR_REPORTS|STR_ORDERS|STR_TIME_REPORT',122),(110118,'STR_VOIDED_ORDERS',1101,18,1,'STR_LISTS_OF_VOIDED_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderlistvoid.php','','',1,'delete.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_VOIDED_ORDERS',122),(110119,'STR_VOLUME_RPT',1101,19,1,'STR_VOLUME_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorder_volume.php','','',1,'newslice.png',0,'serviceful','STR_REPORTS|STR_ORDERS|STR_VOLUME_RPT',122),(1102,'STR_INVENTORY',10,1102,0,'STR_INVENTORY',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustupd.php','','',1,'customer.png',0,'','STR_REPORTS|STR_INVENTORY',122),(11021,'STR_INCOMPLETE_ITEMS',1102,1,1,'STR_ITEMS_WITH_EITHER_NO_COST_OR_NO_SUPPLIER',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstcost.php','','',1,'list.png',0,'','STR_REPORTS|STR_INVENTORY|STR_INCOMPLETE_ITEMS',122),(11022,'STR_INVENTORY_HISTORY',1102,2,1,'STR_INVENTORY_HISTORY',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'aritemsaleslst.php','','',1,'history.png',0,'serviceful','STR_REPORTS|STR_INVENTORY|STR_INVENTORY_HISTORY',122),(11023,'STR_ITEM_ACTIVITY',1102,3,1,'STR_INVENTORY_ITEM_ACTIVITY_LISTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemactivity.php','','',1,'report.png',0,'','STR_REPORTS|STR_INVENTORY|STR_ITEM_ACTIVITY',122),(11024,'STR_ITEMS_BACKORDERED',1102,4,1,'STR_LISTS_OF_BACK_ORDERED_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderitemlst_backorder.php','','',1,'list3.png',0,'serviceful','STR_REPORTS|STR_INVENTORY|STR_ITEMS_BACKORDERED',122),(11025,'STR_ITEM_CONVERSIONS',1102,5,1,'STR_INVENTORY_ITEM_CONVERSIONS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstconversions.php','','',1,'refresh.png',0,'','STR_REPORTS|STR_INVENTORY|STR_ITEM_CONVERSIONS',122),(11026,'STR_ITEM_DETAIL_HISTORY',1102,6,1,'STR_INVENTORY_ITEM_DETAIL_HISTORY_REPORTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlsthistory.php','','',1,'history.png',0,'','STR_REPORTS|STR_INVENTORY|STR_ITEM_DETAIL_HISTORY',122),(11027,'STR_ITEM_DISTRIBUTION',1102,7,1,'STR_INVENTORY_ITEM_DISTRIBUTION_LIST',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstdist.php','','',1,'ship.png',0,'','STR_REPORTS|STR_INVENTORY|STR_ITEM_DISTRIBUTION',122),(11028,'STR_ITEM_ORDER_HISTORY',1102,8,1,'STR_ITEM_ORDER_HISTORY',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderitemcustlst.php','','',1,'history.png',0,'serviceful','STR_REPORTS|STR_INVENTORY|STR_ITEM_ORDER_HISTORY',122),(11029,'STR_ITEM_PRICES',1102,9,1,'STR_INVENTORY_ITEM_PRICE_ENTRY',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstprice.php','','',1,'finance.png',0,'','STR_REPORTS|STR_INVENTORY|STR_ITEM_PRICES',122),(110210,'STR_ITEM_SHIPMENTS',1102,10,1,'STR_LISTS_OF_ITEMS_SHIPPED',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordershipitemlst.php','','',1,'list3.png',0,'serviceful','STR_REPORTS|STR_INVENTORY|STR_ITEM_SHIPMENTS',122),(110211,'STR_ITEM_STATUS',1102,11,1,'STR_INVENTORY_ITEM_STATUS_REPORT',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlststatus.php','','',1,'report1.png',0,'','STR_REPORTS|STR_INVENTORY|STR_ITEM_STATUS',122),(110212,'STR_ITEM_SUMMARIES',1102,12,1,'STR_INVENTORY_ITEM_SUMMARY_LISTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstsum.php','','',1,'report2.png',0,'','STR_REPORTS|STR_INVENTORY|STR_ITEM_SUMMARIES',122),(110213,'STR_ITEM_USAGE_HISTORY',1102,13,1,'STR_INVENTORY_ITEM_USAGE_REPORTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstusage.php','','',1,'report3.png',0,'','STR_REPORTS|STR_INVENTORY|STR_ITEM_USAGE_HISTORY',122),(110214,'STR_INVENTORY_VALUATION',1102,14,1,'STR_INVENTORY_VALUATION_REPORT',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstval.php','','',1,'payment.png',0,'','STR_REPORTS|STR_INVENTORY|STR_INVENTORY_VALUATION',122),(110215,'STR_ITEM_VENDOR_LIST',1102,15,1,'STR_INVENTORY_ITEM_VENDORS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstvendor.php','','',1,'payables.png',0,'','STR_REPORTS|STR_INVENTORY|STR_ITEM_VENDOR_LIST',122),(110216,'STR_ITEM_VENDOR_PRICES',1102,16,1,'STR_INVENTORY_ITEM_VENDOR_PRICES',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstvendorprice.php','','',1,'finance.png',0,'','STR_REPORTS|STR_INVENTORY|STR_ITEM_VENDOR_PRICES',122),(110217,'STR_LIST_BOM_DEFINITIONS',1102,17,1,'STR_LIST_BOM_DEFINITIONS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'bom_list.php','','',1,'list4.png',0,'','STR_REPORTS|STR_INVENTORY|STR_LIST_BOM_DEFINITIONS',122),(110218,'STR_LIST_BUILD_ORDERS',1102,18,1,'STR_LIST_FOR_BILL_OF_MATERIALS_INVENTORY_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitembuildorderlist.php','','',1,'list.png',0,'','STR_REPORTS|STR_INVENTORY|STR_LIST_BUILD_ORDERS',122),(110219,'STR_NOTIFICATION_REQUESTS',1102,19,1,'STR_NOTIFICATION_REQUESTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invnotifications.php','','',1,'list.png',0,'','STR_REPORTS|STR_INVENTORY|STR_NOTIFICATION_REQUESTS',122),(110220,'STR_OPEN_ITEMS_ON_ORDERS',1102,20,1,'STR_LISTS_OF_OPEN_ITEMS_ON_ORDERS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderitemlst.php','','',1,'list2.png',0,'serviceful','STR_REPORTS|STR_INVENTORY|STR_OPEN_ITEMS_ON_ORDERS',122),(1103,'STR_BILLING',10,1103,0,'STR_BILLING',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustupd.php','','',1,'customer.png',0,'','STR_REPORTS|STR_BILLING',0),(11031,'STR_ACTIVITY_HISTORY',1103,1,1,'STR_CUSTOMER_ACTIVITY_HISTORY',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepbalcust_detail.php','','',1,'history.png',0,'','STR_REPORTS|STR_BILLING|STR_ACTIVITY_HISTORY',0),(11032,'STR_AGING_DETAILS',1103,2,1,'STR_AGING_DETAIL_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepaging.php?detail=1','','',1,'list.png',0,'','STR_REPORTS|STR_BILLING|STR_AGING_DETAILS',0),(11033,'STR_AGING_REPORT',1103,3,1,'STR_AGING_SUMMARY_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepaging.php','','',1,'list1.png',0,'','STR_REPORTS|STR_BILLING|STR_AGING_REPORT',0),(11034,'STR_BALANCE_HISTORY',1103,4,1,'STR_CUSTOMER_BALANCE_HISTORY',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepbalcust.php','','',1,'history.png',0,'','STR_REPORTS|STR_BILLING|STR_BALANCE_HISTORY',0),(11035,'STR_CREDIT_CARD_TRANSACTIONS',1103,5,1,'STR_CREDIT_CARD_TRANSACTIONS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcctransactions.php','','',1,'creditcard.png',0,'','STR_REPORTS|STR_BILLING|STR_CREDIT_CARD_TRANSACTIONS',0),(11036,'STR_CUSTOMER_ACCOUNTS',1103,6,1,'STR_VIEW_CUSTOMER_ACCOUNT_STATUS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepcust.php','','',1,'customer.png',0,'','STR_REPORTS|STR_BILLING|STR_CUSTOMER_ACCOUNTS',0),(11037,'STR_CUSTOMERS_BY_SALES',1103,7,1,'STR_CUSTOMERS_BY_SALES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'topdollar_customers.php','','',1,'list3.png',0,'','STR_REPORTS|STR_BILLING|STR_CUSTOMERS_BY_SALES',0),(11038,'STR_INVOICES_BY_STATE',1103,8,1,'STR_SUMMARY_OF_INVOICES_BY_STATE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicebystate.php','','',1,'statistics.png',0,'','STR_REPORTS|STR_BILLING|STR_INVOICES_BY_STATE',0),(11039,'STR_LIST_PAYMENT_PLANS',1103,9,1,'STR_LIST_PAYMENT_PLANS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arpayplanrep.php','','',1,'list.png',0,'','STR_REPORTS|STR_BILLING|STR_LIST_PAYMENT_PLANS',0),(110310,'STR_NON_INVOICED_SALES',1103,10,1,'STR_REPORT_OF_SALES_RECEIPTS_WITHOUT_INVOICES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcashpaymentrep.php','','',1,'list4.png',0,'','STR_REPORTS|STR_BILLING|STR_NON_INVOICED_SALES',0),(110311,'STR_PAYMENT_REPORTS',1103,11,1,'STR_PAYMENTS_RECEIVED_REPORTS_BANK_DEPOSIT_RECONCILIATION',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicereppay.php','','',1,'list.png',0,'','STR_REPORTS|STR_BILLING|STR_PAYMENT_REPORTS',0),(110312,'STR_REPRINT_INVOICES',1103,12,1,'STR_REPRINT_SPECIFIC_OR_GROUPS_OF_INVOICES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicereprint.php','','',1,'print.png',0,'','STR_REPORTS|STR_BILLING|STR_REPRINT_INVOICES',0),(110313,'STR_SALES_PROFITABILITY',1103,13,1,'STR_SALES_PROFITABILITY_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorder_activity.php','','',1,'statistics.png',0,'','STR_REPORTS|STR_BILLING|STR_SALES_PROFITABILITY',0),(110314,'STR_SALES_TAX_REPORT',1103,14,1,'STR_SALES_TAX_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicereptax.php','','',1,'finance.png',0,'','STR_REPORTS|STR_BILLING|STR_SALES_TAX_REPORT',0),(110315,'STR_SUMMARY_OF_INVOICES',1103,15,1,'STR_SUMMARY_LISTS_OF_INVOICES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicesum.php','','',1,'statistics.png',0,'','STR_REPORTS|STR_BILLING|STR_SUMMARY_OF_INVOICES',0),(110316,'STR_STATEMENTS',1103,16,1,'STR_PRINT_STATEMENTS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicestate.php','','',1,'print.png',0,'','STR_REPORTS|STR_BILLING|STR_STATEMENTS',0),(1104,'STR_PAYABLES',10,1104,0,'STR_PAYABLES',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustupd.php','','',1,'customer.png',0,'','STR_REPORTS|STR_PAYABLES',0),(110417,'STR_DETAIL_AGING',1104,17,1,'STR_PAYABLES_DETAIL_AGING_REPORT',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbilllistaging.php?detail=1','','',1,'report1.png',0,'','STR_REPORTS|STR_PAYABLES|STR_DETAIL_AGING',0),(110418,'STR_DISCOUNT_AGING',1104,18,1,'STR_PAYABLES_DISCOUNT_AGING_REPORT',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbilllistdiscaging.php','','',1,'report2.png',0,'','STR_REPORTS|STR_PAYABLES|STR_DISCOUNT_AGING',0),(110419,'STR_SUMMARY_AGING',1104,19,1,'STR_PAYABLES_SUMMARY_AGING_REPORT',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbilllistaging.php','','',1,'report.png',0,'','STR_REPORTS|STR_PAYABLES|STR_SUMMARY_AGING',0),(110420,'STR_CASH_REQUIREMENTS',1104,20,1,'STR_CASH_REQUIREMENTS_REPORT',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apcashrequirements.php','','',1,'payment.png',0,'','STR_REPORTS|STR_PAYABLES|STR_CASH_REQUIREMENTS',0),(110421,'STR_LIST_OF_CHECKS',1104,21,1,'STR_LISTS_OF_CHECKS_WRITTEN',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apchecklist.php','','',1,'list.png',0,'','STR_REPORTS|STR_PAYABLES|STR_LIST_OF_CHECKS',0),(110422,'STR_COMMISSION_CHECKS',1104,22,1,'STR_WRITE_COMMISSION_CHECKS_FROM_DISTRIBUTOR_SALES_OR_VIEW_REPORT',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'distributor_commissionreport.php','','',1,'commission.png',0,'','STR_REPORTS|STR_PAYABLES|STR_COMMISSION_CHECKS',0),(110423,'STR_ITEMS_RECEIVED',1104,23,1,'STR_LIST_ITEMS_RECEIVED_INTO_INVENTORY',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemreclist.php','','',1,'list4.png',0,'','STR_REPORTS|STR_PAYABLES|STR_ITEMS_RECEIVED',122),(110424,'STR_PAYABLES_LISTS',1104,24,1,'STR_LISTS_OF_PAYABLES',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbilllist.php','','',1,'list.png',0,'','STR_REPORTS|STR_PAYABLES|STR_PAYABLES_LISTS',0),(110425,'STR_PO_LISTS',1104,25,1,'STR_PRINT_LISTS_OF_PURCHASE_ORDERS',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invpolist.php','','',1,'list.png',0,'','STR_REPORTS|STR_PAYABLES|STR_PO_LISTS',122),(1105,'STR_PAYROLL',10,1105,0,'STR_PAYROLL',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustupd.php','','',1,'customer.png',0,'','STR_REPORTS|STR_PAYROLL',121),(11051,'STR_CHECK_SUMMARY',1105,1,1,'STR_PAYROLL_CHECK_SUMMARY_FOR_ONE_PAY_PERIOD',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prchecksum.php','','',1,'check.png',0,'','STR_REPORTS|STR_PAYROLL|STR_CHECK_SUMMARY',121),(11052,'STR_DIRECT_DEPOSITS',1105,2,1,'STR_VIEW_AND_DOWNLOAD_DIRECT_DEPOSIT_FILES',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminachreport.php','','',1,'process.png',0,'','STR_REPORTS|STR_PAYROLL|STR_DIRECT_DEPOSITS',121),(11053,'STR_STATUS_OF_EMPLOYEES',1105,3,1,'STR_CURRENT_STATUS_OF_EMPLOYEES',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'timeclock_viewstatus.php','','',1,'list.png',0,'','STR_REPORTS|STR_PAYROLL|STR_STATUS_OF_EMPLOYEES',25),(11054,'STR_PAY_BY_WEEK',1105,4,1,'STR_LIST_OF_EMPLOYEE_PAY_BY_WEEK',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=hpw','','',1,'report1.png',0,'','STR_REPORTS|STR_PAYROLL|STR_PAY_BY_WEEK',121),(11055,'STR_PAY_BY_MONTH',1105,5,1,'STR_LIST_OF_EMPLOYEE_PAY_BY_MONTH',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=hpm','','',1,'report2.png',0,'','STR_REPORTS|STR_PAYROLL|STR_PAY_BY_MONTH',121),(11056,'STR_PAY_BY_QUARTER',1105,6,1,'STR_LIST_OF_EMPLOYEE_PAY_BY_QUARTER',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=hpq','','',1,'report4.png',0,'','STR_REPORTS|STR_PAYROLL|STR_PAY_BY_QUARTER',121),(11057,'STR_PAY_HISTORY',1105,7,1,'STR_PAY_HISTORY',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prchecksumgroup.php','','',1,'payment.png',0,'','STR_REPORTS|STR_PAYROLL|STR_PAY_HISTORY',121),(11058,'STR_WORKMANS_COMP',1105,8,1,'STR_WORKMANS_COMP_REPORT',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prworkmanscomp.php','','',1,'workcomp.png',0,'','STR_REPORTS|STR_PAYROLL|STR_WORKMANS_COMP',121),(11059,'STR_W2S',1105,9,1,'STR_PRINT_W2_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prw2.php','','',1,'report2.png',0,'','STR_REPORTS|STR_PAYROLL|STR_W2S',121),(110510,'STR_941S',1105,10,1,'STR_PRINT_941_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'pr941.php','','',1,'report.png',0,'','STR_REPORTS|STR_PAYROLL|STR_941S',121),(1106,'STR_LEDGER',10,1106,0,'STR_LEDGER',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustupd.php','','',1,'customer.png',0,'','STR_REPORTS|STR_LEDGER',0),(11061,'STR_ACCOUNT_ACTIVITY',1106,1,1,'STR_GENERAL_LEDGER_ACCOUNT_ACTIVITY_REPORT',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepactivity.php','','',1,'report.png',0,'','STR_REPORTS|STR_LEDGER|STR_ACCOUNT_ACTIVITY',0),(11062,'STR_BALANCE_SHEET',1106,2,1,'STR_CREATE_A_BALANCE_SHEET',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepbalance.php','','',1,'report4.png',0,'','STR_REPORTS|STR_LEDGER|STR_BALANCE_SHEET',0),(11063,'STR_STANDARD_BALANCE_SHEET',1106,3,1,'STR_CREATE_A_BALANCE_SHEET_IN_DEBIT_CREDIT_FORMAT',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepbalance_summary.php','','',1,'report2.png',0,'','STR_REPORTS|STR_LEDGER|STR_STANDARD_BALANCE_SHEET',0),(11064,'STR_DETAILED_TRIAL_BALANCE',1106,4,1,'STR_CREATE_A_DETAILED_TRIAL_BALANCE_SHEET',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepbalance_detail.php','','',1,'report1.png',0,'','STR_REPORTS|STR_LEDGER|STR_DETAILED_TRIAL_BALANCE',0),(11065,'STR_BUDGET_LIST',1106,5,1,'STR_PRINT_GENERAL_LEDGER_BUDGET_LIST',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glbudlst.php','','',1,'list.png',0,'','STR_REPORTS|STR_LEDGER|STR_BUDGET_LIST',0),(11066,'STR_CHART_OF_ACCOUNTS_LIST',1106,6,1,'STR_PRINT_GENERAL_LEDGER_CHART_OF_ACCOUNTS_LIST',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glacctlst.php','','',1,'list.png',0,'','STR_REPORTS|STR_LEDGER|STR_CHART_OF_ACCOUNTS_LIST',0),(11067,'STR_DAILY_REPORT',1106,7,1,'STR_DAILY_REPORT_OF_BALANCES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepdaily.php','','',1,'time.png',0,'','STR_REPORTS|STR_LEDGER|STR_DAILY_REPORT',21),(11068,'STR_JOURNAL_REPORTS',1106,8,1,'STR_GENERAL_LEDGER_JOURNAL_REPORTS',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepjournal.php','','',1,'report3.png',0,'','STR_REPORTS|STR_LEDGER|STR_JOURNAL_REPORTS',0),(11069,'STR_PROFIT_AND_LOSS',1106,9,1,'STR_PROFIT_AND_LOSS_STATEMENT',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepincome.php','','',1,'refresh.png',0,'','STR_REPORTS|STR_LEDGER|STR_PROFIT_AND_LOSS',0),(110610,'STR_UNBALANCED',1106,10,1,'STR_UNBALANCED_JOURNAL_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepjournal_unbalanced.php','','',1,'report2.png',0,'','STR_REPORTS|STR_LEDGER|STR_UNBALANCED',0);
/*!40000 ALTER TABLE `menudata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menudataorder`
--

DROP TABLE IF EXISTS `menudataorder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menudataorder` (
  `id` int(11) NOT NULL default '0',
  `menu_name` varchar(30) default '',
  `id_menudata` int(11) NOT NULL default '0',
  `orderflag` int(5) NOT NULL default '0',
  `menu_action` int(2) NOT NULL default '1',
  `description` varchar(250) default NULL,
  `accessap` int(2) NOT NULL default '0',
  `accessar` int(2) NOT NULL default '0',
  `accessgl` int(2) NOT NULL default '0',
  `accesspay` int(2) NOT NULL default '0',
  `accessinv` int(2) NOT NULL default '0',
  `accessest` int(2) NOT NULL default '0',
  `accessfix` int(2) NOT NULL default '0',
  `accessimp` int(2) NOT NULL default '0',
  `setupap` int(2) NOT NULL default '0',
  `setupar` int(2) NOT NULL default '0',
  `setupgl` int(2) NOT NULL default '0',
  `setuppay` int(2) NOT NULL default '0',
  `setupinv` int(2) NOT NULL default '0',
  `setupest` int(2) NOT NULL default '0',
  `setupfix` int(2) NOT NULL default '0',
  `setupimp` int(2) NOT NULL default '0',
  `supervisor` int(2) NOT NULL default '0',
  `extvend` int(2) NOT NULL default '0',
  `extcust` int(2) NOT NULL default '0',
  `nonext` int(2) NOT NULL default '0',
  `menu_link` varchar(255) default NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menudataorder`
--

LOCK TABLES `menudataorder` WRITE;
/*!40000 ALTER TABLE `menudataorder` DISABLE KEYS */;
INSERT INTO `menudataorder` VALUES (1,'Add Order',0,1,1,'Add Orders',0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'araddeditorder.php'),(2,'Update / View Orders',0,2,1,'View Orders',0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'arvieworder.php'),(3,'Order Status',0,3,1,'Main Order Screen',0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'orderscreen.php'),(4,'Edit My Information',0,4,1,'Edit your personal information',0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'arcustupd.php?name=start');
/*!40000 ALTER TABLE `menudataorder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menudatashortcut`
--

DROP TABLE IF EXISTS `menudatashortcut`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menudatashortcut` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `menu_link` varchar(255) default NULL,
  `sub_link` varchar(255) default NULL,
  `sub_link_name` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=695 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menudatashortcut`
--

LOCK TABLES `menudatashortcut` WRITE;
/*!40000 ALTER TABLE `menudatashortcut` DISABLE KEYS */;
INSERT INTO `menudatashortcut` VALUES (1,'invitemadd.php','invitemcatupd.php','STR_ITEM_CATEGORIES'),(2,'invitemadd.php','admininvunitnameupd.php','STR_SALES_UNIT'),(3,'invitemadd.php','invitemprices.php','STR_ITEM_PRICES_MASS_EDIT'),(8,'adminemail.php','arcustlist.php','STR_LIST_CUSTOMERS'),(10,'premplded.php','prloghours.php','STR_LOG_HOURS'),(12,'arcustadd.php','nporder.php','STR_POINT_OF_SALE'),(16,'adminarsalesmanadd.php','nporder.php','STR_POINT_OF_SALE'),(17,'adminarsalesmanupd.php','nporder.php','STR_POINT_OF_SALE'),(18,'apvendadd.php','apbilladd.php','STR_NEW_VENDOR_BILL'),(21,'apvendupd.php','arvendb2buser.php?ap=1','STR_VENDOR_B2B_LOGIN_USERS'),(22,'apvendupd.php','admininvponotesupd.php','STR_PO_END_NOTES'),(23,'apvendupd.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(24,'apvendadd.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(25,'apvendupd.php','apbilladd.php','STR_NEW_VENDOR_BILL'),(26,'arcustadd.php','arcustb2buser.php?ar=1','STR_B2B_USERS'),(27,'arcustadd.php','b2b/index.php','STR_B2B_WEB_PORTAL'),(28,'arcustupd.php','nporder.php','STR_POINT_OF_SALE'),(29,'arcustupd.php','arcustb2buser.php?ar=1','STR_B2B_USERS'),(30,'arcustupd.php','b2b/index.php','STR_B2B_WEB_PORTAL'),(31,'arcustupd.php','arcustmerge.php?ar=1','STR_MERGE_CUSTOMERS'),(32,'arcustb2buser.php?ar=1','b2b/index.php','STR_B2B_WEB_PORTAL'),(33,'arcustmerge.php?ar=1','arcustupd.php','STR_CUSTOMERS'),(35,'premployeeadd.php','adminprdedgroupupd.php','STR_DEDUCTION_GROUPS'),(36,'premployeeupd.php','adminprdedgroupupd.php','STR_DEDUCTION_GROUPS'),(37,'premployeeupd.php','adminprded.php','STR_GENERAL_DEDUCTIONS'),(38,'premployeeupd.php','premplded.php','STR_EMPLOYEE_DEDUCTIONS'),(39,'premployeeupd.php','adminprpens.php','STR_PENSION_PLANS'),(40,'premployeeupd.php','directdepform.php','STR_DIRECT_DEPOSIT_AUTH'),(41,'nporder.php','arcustadd.php','STR_NEW_CUSTOMER'),(42,'nporder.php','arcustupd.php','STR_CUSTOMERS'),(43,'nporder.php','invitemlststatus.php','STR_ITEM_STATUS'),(44,'arrmashipview.php','adminar_rmasetup.php','STR_RMA_SETUP'),(45,'arrmashipview.php','arinvoicepayvoid.php','STR_VOID_PAYMENTS'),(46,'arordshipadd.php','invitemlstreorder.php','STR_ITEM_REORDER_LIST'),(47,'arserviceordadd.php','arservicetypeupd.php','STR_SERVICE_TYPES'),(48,'arserviceordadd.php','arserviceclassupd.php','STR_SERVICE_CLASSES'),(49,'arserviceordadd.php','arservicerates.php','STR_SERVICE_LABOR_RATES'),(50,'arserviceordadd.php','adminarordstatusupd.php','STR_SERVICE_STATUS_OPTIONS'),(51,'arserviceordupd.php','arservicetypeupd.php','STR_SERVICE_TYPES'),(52,'arserviceordupd.php','arserviceclassupd.php','STR_SERVICE_CLASSES'),(53,'arserviceordupd.php','arservicerates.php','STR_SERVICE_LABOR_RATES'),(54,'arserviceordupd.php','adminarordstatusupd.php','STR_SERVICE_STATUS_OPTIONS'),(55,'serviceorder_time.php','arservicetypeupd.php','STR_SERVICE_TYPES'),(56,'serviceorder_time.php','adminarsalesmanadd.php','STR_NEW_SALES_PERSONNEL'),(57,'serviceorder_time.php','adminarordstatusupd.php','STR_SERVICE_STATUS_OPTIONS'),(58,'invitemadd.php','invitemlststatus.php','STR_ITEM_STATUS'),(59,'invitemupd.php','invbeginbal.php','STR_ITEM_BEGINNING_BALANCES'),(60,'invitemupd.php','inventory_adjustments.php','STR_ITEM_ADJUSTMENTS'),(61,'invitemupd.php','inventory_costadjust.php','STR_ITEM_COST_ADJUSTMENTS'),(62,'invitemupd.php','invlevelupd.php','STR_PRICING_LEVELS'),(63,'invitemupd.php','invmarkupupd.php','STR_STANDARD_MARKUP'),(64,'inventory_adjustments.php','invitemlstphys.php','STR_PHYSICAL_INVENTORY'),(65,'inventory_adjustments.php','invitemactivity.php','STR_ITEM_ACTIVITY'),(66,'inventory_adjustments.php','invitemlststatus.php','STR_ITEM_STATUS'),(67,'inventory_adjustments.php','inventory_costadjust.php','STR_ITEM_COST_ADJUSTMENTS'),(68,'inventory_costadjust.php','inventory_adjustments.php','STR_ITEM_ADJUSTMENTS'),(69,'inventory_costadjust.php','invitemprices.php','STR_ITEM_PRICES_MASS_EDIT'),(70,'invitemprices.php','invmarkupupd.php','STR_STANDARD_MARKUP'),(71,'invitemprices.php','invlevelupd.php','STR_PRICING_LEVELS'),(72,'invitemlstreorder.php','invitemupd.php','STR_EDIT_ITEMS'),(73,'invitemlstreorder.php','arorderitemlst_backorder.php','STR_ITEMS_BACKORDERED'),(74,'invitemlstreorder.php','invitemlststatus.php','STR_ITEM_STATUS'),(75,'invitemlstreorder.php','invitemcatupd.php','STR_ITEM_CATEGORIES'),(76,'invitembuildorder.php','invitemupd.php','STR_EDIT_ITEMS'),(77,'invitemlstphys.php','invitemlststatus.php','STR_ITEM_STATUS'),(78,'invitemlstphys.php','invitemactivity.php','STR_ITEM_ACTIVITY'),(79,'invitemlstphys.php','arorderitemlst_backorder.php','STR_ITEMS_BACKORDERED'),(80,'invitemlstphys.php','invitemlstval.php','STR_INVENTORY_VALUATION'),(81,'arbankdepositadd.php','arinvoicepay.php','STR_ENTER_PAYMENTS'),(82,'arbankdepositadd.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(84,'arbankdepositadd.php','glrepbalance_summary.php','STR_STANDARD_BALANCE_SHEET'),(85,'arbankdepositadd.php','gljouradd.php','STR_NEW_JOURNAL_ENTRIES'),(86,'arbankdepositupd.php','arinvoicepay.php','STR_ENTER_PAYMENTS'),(87,'arbankdepositupd.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(88,'arbankdepositupd.php','glrepbalance_summary.php','STR_STANDARD_BALANCE_SHEET'),(89,'arbankdepositupd.php','gljouradd.php','STR_NEW_JOURNAL_ENTRIES'),(90,'nporder.php','adminarquotecomupd.php','STR_QUOTE_COMMENTS'),(91,'arcustadd.php','adminartaxexupd.php','STR_TAX_EXEMPTIONS'),(92,'arinvoiceadd.php','adminarcompanyupd.php','STR_COMPANY_OPTIONS'),(93,'arinvoiceadd.php','adminarinvtermsupd.php','STR_INVOICE_TERMS'),(94,'arinvoiceadd.php','admininvoicenotesupd.php','STR_INVOICE_END_NOTES'),(95,'arinvoiceupd.php','arinvoicepay.php','STR_ENTER_PAYMENTS'),(96,'arinvoiceupd.php','arinvoice_writeoff.php','STR_BAD_DEBT'),(97,'arinvoiceupd.php','adminarcompanyupd.php','STR_COMPANY_OPTIONS'),(98,'arinvoiceupd.php','adminarinvtermsupd.php','STR_INVOICE_TERMS'),(99,'arinvoiceupd.php','admininvoicenotesupd.php','STR_INVOICE_END_NOTES'),(100,'arinvoice_writeoff.php','apbilllistaging.php','STR_SUMMARY_AGING'),(101,'arinvoicecalcint.php','adminarcompanyupd.php','STR_COMPANY_OPTIONS'),(102,'arinvoicecalcint.php','arcustupd.php','STR_CUSTOMERS'),(104,'arinvoicecalcint.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(105,'arinvoicepay.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(106,'arcredit_writecheck.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(107,'arinvoicepayvoid.php','arinvoicereppay.php','STR_PAYMENT_REPORTS'),(108,'arinvoicepayvoid.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(109,'arinvoicepayvoid.php','nporder.php','STR_POINT_OF_SALE'),(110,'arpayplanadd.php','arcustadd.php','STR_NEW_CUSTOMER'),(111,'arpayplanadd.php','adminarsalesmanadd.php','STR_NEW_SALES_PERSONNEL'),(112,'arpayplanadd.php','adminarinvtermsupd.php','STR_INVOICE_TERMS'),(113,'arpayplanadd.php','admininvunitnameupd.php','STR_SALES_UNIT'),(114,'arpayplanupd.php','adminarsalesmanadd.php','STR_NEW_SALES_PERSONNEL'),(115,'arpayplanupd.php','adminarinvtermsupd.php','STR_INVOICE_TERMS'),(116,'arpayplanupd.php','admininvunitnameupd.php','STR_SALES_UNIT'),(117,'arpayplan_post.php','arpayplanupd.php','STR_PAYMENT_PLANS'),(118,'apmanualcheck.php','apbilllist.php','STR_PAYABLES_LISTS'),(119,'apmanualcheck.php','apvendupd.php','STR_EDIT_VENDOR'),(120,'apchecking.php','arbankreconcile.php','STR_BANK_RECONCILIATION'),(121,'apchecking.php','apchecklist.php','STR_LIST_OF_CHECKS'),(122,'apchecking.php','prchecksum.php','STR_CHECK_SUMMARY'),(123,'apbillpay.php','adminapglacct.php','STR_GENERAL_SETUP'),(124,'apbillpay.php','apbillupd.php','STR_EDIT_VENDOR_BILL'),(125,'apbillpay.php','apvendupd.php','STR_EDIT_VENDOR'),(126,'apccpurchase2bill.php','apccpurchaselist.php','STR_LIST_CC_PURCHASES'),(127,'apccpurchase2bill.php','apcashrequirements.php','STR_CASH_REQUIREMENTS'),(128,'apccpurchase2bill.php','adminapccvendorupd.php','STR_CC_CARDS'),(129,'apccpurchase2bill.php','apccpurchaseupd.php','STR_CC_PURCHASES'),(130,'apccpurchase2billupd.php','apccpurchaselist.php','STR_LIST_CC_PURCHASES'),(131,'apccpurchase2billupd.php','apcashrequirements.php','STR_CASH_REQUIREMENTS'),(132,'apccpurchase2billupd.php','apccpurchaseupd.php','STR_CC_PURCHASES'),(133,'adminapcctypeupd.php','apccpurchase2bill.php','STR_NEW_CC_BILLS'),(134,'adminapcctypeupd.php','apccpurchase2billupd.php','STR_EDIT_CC_BILLS'),(135,'adminapcctypeupd.php','glacctadd.php','STR_NEW_GL_ACCOUNTS'),(136,'adminapcctypeupd.php','adminarsalestaxupd.php','STR_SALES_TAXES'),(137,'apccpurchaseupd.php','adminapccvendorupd.php','STR_CC_CARDS'),(138,'apccpurchaseupd.php','apccpurchaselist.php','STR_LIST_CC_PURCHASES'),(139,'apccpurchaseupd.php','apcashrequirements.php','STR_CASH_REQUIREMENTS'),(140,'adminapccvendorupd.php','apvendadd.php','STR_NEW_VENDOR'),(141,'invpoadd.php','adminappaytermsupd.php','STR_VENDOR_TERMS'),(142,'invpoadd.php','adminarcarrierupd.php','STR_CARRIER_METHODS'),(143,'invpoadd.php','admininvlocationupd.php','STR_PLANT_LOCATIONS'),(144,'invpoadd.php','admininvponotesupd.php','STR_PO_END_NOTES'),(145,'invpoupd.php','adminappaytermsupd.php','STR_VENDOR_TERMS'),(146,'invpoupd.php','adminarcarrierupd.php','STR_CARRIER_METHODS'),(147,'invpoupd.php','admininvlocationupd.php','STR_PLANT_LOCATIONS'),(148,'invpoupd.php','admininvponotesupd.php','STR_PO_END_NOTES'),(149,'invpotoap.php','invitemprices.php','STR_ITEM_PRICES_MASS_EDIT'),(150,'invporecv.php','invpolist.php','STR_PO_LISTS'),(151,'invporecv.php','invitemlststatus.php','STR_ITEM_STATUS'),(152,'invitemrecadd.php','apvendadd.php','STR_NEW_VENDOR'),(153,'invitemrecadd.php','invitemadd.php','STR_ADD_ITEMS'),(154,'apbilladd.php','apbilllist.php','STR_PAYABLES_LISTS'),(155,'apbilladd.php','apcashrequirements.php','STR_CASH_REQUIREMENTS'),(156,'apbilladd.php','adminappaytermsupd.php','STR_VENDOR_TERMS'),(157,'apbilladd.php','adminarsalestaxupd.php','STR_SALES_TAXES'),(158,'apbillupd.php','apbilllist.php','STR_PAYABLES_LISTS'),(159,'apbillupd.php','apcashrequirements.php','STR_CASH_REQUIREMENTS'),(160,'apbillupd.php','adminappaytermsupd.php','STR_VENDOR_TERMS'),(161,'apbillupd.php','adminarsalestaxupd.php','STR_SALES_TAXES'),(162,'prchecksum.php','prchecksumgroup.php','STR_PAY_HISTORY'),(163,'prchecksum.php','adminprded.php','STR_GENERAL_DEDUCTIONS'),(164,'prchecksum.php','adminprcon.php','STR_COMPANY_CONTRIBUTIONS'),(165,'prloghours.php','premployeeadd.php','STR_NEW_EMPLOYEE'),(166,'prloghours.php','premployeeupd.php','STR_EMPLOYEES'),(167,'prloghours.php','timeclock_editwork.php','STR_APPROVE_TIMES'),(168,'prloghours.php','adminprpaytypeupd.php','STR_PAY_TYPES'),(169,'prcheckwrite.php','prloghours.php','STR_LOG_HOURS'),(170,'prcheckwrite.php','adminapchkacctupd.php','STR_CHECKING_ACCOUNTS'),(171,'premployeeadd.php','adminprded.php','STR_GENERAL_DEDUCTIONS'),(172,'premployeeadd.php','premplded.php','STR_EMPLOYEE_DEDUCTIONS'),(173,'premployeeadd.php','adminprpens.php','STR_PENSION_PLANS'),(174,'premployeeadd.php','directdepform.php','STR_DIRECT_DEPOSIT_AUTH'),(175,'apvendadd.php','admininvponotesupd.php','STR_PO_END_NOTES'),(176,'apvendadd.php','apvendorpage_define.php','STR_VENDOR_PAGE_CUSTOMIZER'),(177,'arrmashipview.php','arcredit_writecheck.php','STR_REFUND_CREDIT'),(178,'timeclock_editwork.php','serviceorder_time_reporter.php','STR_TIME_REPORT'),(179,'timeclock_editwork.php','premployeeupd.php','STR_EMPLOYEES'),(180,'premplreviewupd.php','adminpremplreviewratingupd.php','STR_RATING_SCALE_FOR_REVIEWS'),(181,'arbankreconcile.php','adminapchkacctupd.php','STR_CHECKING_ACCOUNTS'),(182,'arbankreconcile.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(183,'arbankreconcile.php','apchecking.php','STR_VIEW_CANCEL_CHECKS'),(184,'arbankreconcile.php','gljouradd.php','STR_NEW_JOURNAL_ENTRIES'),(185,'glacctadd.php','glacctlst.php','STR_CHART_OF_ACCOUNTS_LIST'),(186,'glacctadd.php','adminglaccttypeupd.php','STR_ACCOUNT_TYPES'),(187,'glacctadd.php','glcost_centerupd.php','STR_GL_COST_CENTERS'),(188,'glacctadd.php','gl_sumlevelupd.php','STR_GL_SUMMARY_LEVELS'),(189,'glacctupd.php','glacctlst.php','STR_CHART_OF_ACCOUNTS_LIST'),(190,'glacctupd.php','adminglaccttypeupd.php','STR_ACCOUNT_TYPES'),(191,'glacctupd.php','glcost_centerupd.php','STR_GL_COST_CENTERS'),(192,'glacctupd.php','gl_sumlevelupd.php','STR_GL_SUMMARY_LEVELS'),(193,'glacct_assign.php','gl_sumlevelupd.php','STR_GL_SUMMARY_LEVELS'),(194,'gljouradd.php','glacctlst.php','STR_CHART_OF_ACCOUNTS_LIST'),(195,'gljouradd.php','glacctadd.php','STR_NEW_GL_ACCOUNTS'),(196,'gljourupd.php','glacctlst.php','STR_CHART_OF_ACCOUNTS_LIST'),(197,'gljourupd.php','glacctadd.php','STR_NEW_GL_ACCOUNTS'),(198,'gljourupd.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(199,'glclose_year.php','glpostadd.php','STR_POST_JOURNALS_NOW'),(200,'gljour_std_post.php','gljour_std_add.php','STR_NEW_RECURRING_ENTRIES'),(201,'gljour_std_post.php','gljour_std_upd.php','STR_EDIT_RECURRING_ENTRIES'),(202,'adminactivitymonitor.php','genuserrightsgroup.php','STR_USER_RIGHTS_GROUPS'),(203,'adminactivitymonitor.php','genuserupd.php','STR_NEW_EDIT_USER'),(204,'adminb2bsite.php','b2b/index.php','STR_B2B_WEB_PORTAL'),(205,'gencompanyupd.php','state_addupdate.php','STR_NEW_EDIT_STATE'),(206,'gencompanyupd.php','adminarsalestaxupd.php','STR_SALES_TAXES'),(207,'gencompanyupd.php','adminosccompanyupd.php','STR_OSCOMMERCE_INTEGRATION'),(208,'state_addupdate.php','arcustupd.php','STR_CUSTOMERS'),(209,'state_addupdate.php','premployeeupd.php','STR_EMPLOYEES'),(210,'state_addupdate.php','apvendupd.php','STR_EDIT_VENDOR'),(211,'adminsystemsettings.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(212,'adminsystemsettings.php','genuserupd.php','STR_NEW_EDIT_USER'),(213,'adminsystemsettings.php','adminapilog.php','STR_API_LOG_VIEWER'),(214,'genuserupd.php','premployeeadd.php','STR_NEW_EMPLOYEE'),(215,'genuserupd.php','adminarsalesmanadd.php','STR_NEW_SALES_PERSONNEL'),(216,'genuserupd.php','genuserrightsgroup.php','STR_USER_RIGHTS_GROUPS'),(217,'genuserrightsgroup.php','genuserupd.php','STR_NEW_EDIT_USER'),(218,'adminar_rmasetup.php','arrmashipview.php','STR_PROCESS_RMAS'),(219,'adminar_rmasetup.php','adminarglacct.php','STR_GENERAL_SETUP'),(220,'arserviceclassupd.php','arservicetypeupd.php','STR_SERVICE_TYPES'),(221,'arserviceclassupd.php','arservicesubtype.php','STR_SERVICE_SUBTYPES'),(222,'arserviceclassupd.php','arservicerates.php','STR_SERVICE_LABOR_RATES'),(223,'arserviceclassupd.php','adminarordstatusupd.php','STR_SERVICE_STATUS_OPTIONS'),(224,'arservicerates.php','arservicetypeupd.php','STR_SERVICE_TYPES'),(225,'arservicerates.php','arservicesubtype.php','STR_SERVICE_SUBTYPES'),(226,'arservicerates.php','arserviceclassupd.php','STR_SERVICE_CLASSES'),(227,'arservicerates.php','adminarordstatusupd.php','STR_SERVICE_STATUS_OPTIONS'),(228,'adminarordstatusupd.php','arservicetypeupd.php','STR_SERVICE_TYPES'),(229,'adminarordstatusupd.php','arservicesubtype.php','STR_SERVICE_SUBTYPES'),(230,'adminarordstatusupd.php','arserviceclassupd.php','STR_SERVICE_CLASSES'),(231,'adminarordstatusupd.php','arservicerates.php','STR_SERVICE_LABOR_RATES'),(232,'arservicesubtype.php','arservicetypeupd.php','STR_SERVICE_TYPES'),(233,'arservicesubtype.php','arserviceclassupd.php','STR_SERVICE_CLASSES'),(234,'arservicesubtype.php','arservicerates.php','STR_SERVICE_LABOR_RATES'),(235,'arservicesubtype.php','adminarordstatusupd.php','STR_SERVICE_STATUS_OPTIONS'),(236,'arservicetypeupd.php','arservicesubtype.php','STR_SERVICE_SUBTYPES'),(237,'arservicetypeupd.php','arserviceclassupd.php','STR_SERVICE_CLASSES'),(238,'arservicetypeupd.php','arservicerates.php','STR_SERVICE_LABOR_RATES'),(239,'arservicetypeupd.php','adminarordstatusupd.php','STR_SERVICE_STATUS_OPTIONS'),(240,'arordernumber.php','nporder.php','STR_POINT_OF_SALE'),(241,'arcustitemdiscount.php','invitemadd.php','STR_ADD_ITEMS'),(242,'arcustitemdiscount.php','invitemupd.php','STR_EDIT_ITEMS'),(243,'arcustitemdiscount.php','arcustadd.php','STR_NEW_CUSTOMER'),(244,'admininvglacct.php','glacctadd.php','STR_NEW_GL_ACCOUNTS'),(245,'admininvglacct.php','admininvlocationupd.php','STR_PLANT_LOCATIONS'),(246,'admininvglacct.php','invlevelupd.php','STR_PRICING_LEVELS'),(247,'invbeginbal.php','admininvlocationupd.php','STR_PLANT_LOCATIONS'),(248,'invbeginbal.php','invitemprices.php','STR_ITEM_PRICES_MASS_EDIT'),(249,'invbeginbal.php','invitemlststatus.php','STR_ITEM_STATUS'),(250,'invitemcatupd.php','invitemadd.php','STR_ADD_ITEMS'),(251,'invitemcatupd.php','invitemupd.php','STR_EDIT_ITEMS'),(252,'invitempage_define.php','invitemadd.php','STR_ADD_ITEMS'),(253,'invitempage_define.php','invitemupd.php','STR_EDIT_ITEMS'),(254,'admininvlocationupd.php','state_addupdate.php','STR_NEW_EDIT_STATE'),(255,'admininvlocationupd.php','glacctadd.php','STR_NEW_GL_ACCOUNTS'),(256,'invlevelupd.php','invitemprices.php','STR_ITEM_PRICES_MASS_EDIT'),(257,'invlevelupd.php','invmarkupupd.php','STR_STANDARD_MARKUP'),(258,'admininvunitnameupd.php','invitemadd.php','STR_ADD_ITEMS'),(259,'admininvunitnameupd.php','invitemupd.php','STR_EDIT_ITEMS'),(260,'admininvunitnameupd.php','nporder.php','STR_POINT_OF_SALE'),(261,'invitemsearchcat.php','invitemadd.php','STR_ADD_ITEMS'),(262,'invitemsearchcat.php','invitemupd.php','STR_EDIT_ITEMS'),(263,'invmarkupupd.php','invlevelupd.php','STR_PRICING_LEVELS'),(264,'arinvoiceadd_beginbal.php','arcustadd.php','STR_NEW_CUSTOMER'),(265,'arinvoiceadd_beginbal.php','adminarsales_category.php','STR_SALES_CATEGORIES'),(266,'arinvoiceadd_beginbal.php','adminarsalesmanadd.php','STR_NEW_SALES_PERSONNEL'),(267,'arinvoiceadd_beginbal.php','adminarinvtermsupd.php','STR_INVOICE_TERMS'),(268,'adminarcarrierupd.php','state_addupdate.php','STR_NEW_EDIT_STATE'),(269,'adminarcarrierupd.php','adminapvendortype.php','STR_VENDOR_TYPES'),(270,'adminarcarrierupd.php','adminappaytermsupd.php','STR_VENDOR_TERMS'),(271,'adminarcompanyupd.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(272,'adminarcompanyupd.php','nporder.php','STR_POINT_OF_SALE'),(273,'adminarcompanyupd.php','admininvunitnameupd.php','STR_SALES_UNIT'),(274,'adminccsetup.php','adminapchkacctupd.php','STR_CHECKING_ACCOUNTS'),(275,'adminccsetup.php','arinvoicepay.php','STR_ENTER_PAYMENTS'),(276,'adminargroupsupd.php','arcustadd.php','STR_NEW_CUSTOMER'),(277,'adminargroupsupd.php','arcustupd.php','STR_CUSTOMERS'),(278,'arcustomerpage_define.php','arcustadd.php','STR_NEW_CUSTOMER'),(279,'arcustomerpage_define.php','arcustupd.php','STR_CUSTOMERS'),(280,'arcustomerpage_define.php','translation.php','STR_LANGUAGE_EDITOR'),(281,'adminarglacct.php','glacctupd.php','STR_CHART_OF_ACCOUNTS'),(282,'adminarglacct.php','adminapchkacctupd.php','STR_CHECKING_ACCOUNTS'),(283,'admininvoicenotesupd.php','arinvoiceadd.php','STR_NEW_INVOICE'),(284,'admininvoicenotesupd.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(285,'admininvoicenotesupd.php','arinvoicereprint.php','STR_REPRINT_INVOICES'),(286,'adminarinvtermsupd.php','arinvoiceadd.php','STR_NEW_INVOICE'),(287,'adminarinvtermsupd.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(288,'adminarinvtermsupd.php','arinvoicereprint.php','STR_REPRINT_INVOICES'),(289,'adminarquotecomupd.php','nporder.php','STR_POINT_OF_SALE'),(290,'adminarsales_category.php','nporder.php','STR_POINT_OF_SALE'),(291,'adminarsales_category.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(292,'adminarsalestaxupd.php','arinvoicerepvat.php',''),(293,'adminarsalestaxupd.php','nporder.php','STR_POINT_OF_SALE'),(294,'adminartaxexupd.php','arcustupd.php','STR_CUSTOMERS'),(295,'adminartaxexupd.php','nporder.php','STR_POINT_OF_SALE'),(296,'adminartaxexupd.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(297,'apbilladd_beginbal.php','apvendadd.php','STR_NEW_VENDOR'),(299,'adminapglacct.php','glacctupd.php','STR_CHART_OF_ACCOUNTS'),(300,'adminapglacct.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(302,'adminapglacct.php','adminappaytermsupd.php','STR_VENDOR_TERMS'),(303,'admininvponotesupd.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(304,'admininvponotesupd.php','invpoupd.php','STR_EDIT_PURCHASE_ORDER'),(305,'adminarcarrierupd.php','arordshipadd.php','STR_SHIP_ORDER'),(306,'apvendorpage_define.php','apvendadd.php','STR_NEW_VENDOR'),(307,'apvendorpage_define.php','apvendupd.php','STR_EDIT_VENDOR'),(308,'adminappaytermsupd.php','apvendadd.php','STR_NEW_VENDOR'),(309,'adminappaytermsupd.php','apvendupd.php','STR_EDIT_VENDOR'),(310,'adminappaytermsupd.php','apbilladd.php','STR_NEW_VENDOR_BILL'),(311,'adminapvendortype.php','apvendadd.php','STR_NEW_VENDOR'),(312,'adminapvendortype.php','apvendupd.php','STR_EDIT_VENDOR'),(313,'adminapchkacctupd.php','prloghours.php','STR_LOG_HOURS'),(314,'adminapchkacctupd.php','prcalchours.php','STR_CALCULATE_AND_CHECKS'),(315,'adminapchkacctupd.php','prcheckwrite.php','STR_WRITE_CHECKS'),(316,'adminprcon.php','prloghours.php','STR_LOG_HOURS'),(317,'adminprcon.php','adminprdedgroupupd.php','STR_DEDUCTION_GROUPS'),(318,'adminprcon.php','adminprpens.php','STR_PENSION_PLANS'),(319,'adminprdedgroupupd.php','prloghours.php','STR_LOG_HOURS'),(320,'adminprdedgroupupd.php','adminprded.php','STR_GENERAL_DEDUCTIONS'),(321,'adminprdedgroupupd.php','adminprcon.php','STR_COMPANY_CONTRIBUTIONS'),(322,'adminprdedgroupupd.php','adminprben.php','STR_GENERAL_BENEFITS_PAY'),(323,'directdepform.php','prloghours.php','STR_LOG_HOURS'),(324,'directdepform.php','premployeeupd.php','STR_EMPLOYEES'),(325,'directdepform.php','adminapchkacctupd.php','STR_CHECKING_ACCOUNTS'),(326,'adminprben.php','prloghours.php','STR_LOG_HOURS'),(327,'adminprben.php','adminprdedgroupupd.php','STR_DEDUCTION_GROUPS'),(328,'adminprben.php','glacctadd.php','STR_NEW_GL_ACCOUNTS'),(329,'adminprded.php','prloghours.php','STR_LOG_HOURS'),(330,'adminprded.php','adminprdedgroupupd.php','STR_DEDUCTION_GROUPS'),(331,'adminprgendat.php','prloghours.php','STR_LOG_HOURS'),(332,'adminprgendat.php','premployeeupd.php','STR_EMPLOYEES'),(333,'adminprgendat.php','glacctadd.php','STR_NEW_GL_ACCOUNTS'),(334,'adminprglacct.php','prloghours.php','STR_LOG_HOURS'),(335,'adminprglacct.php','prw2.php','STR_W2S'),(336,'adminprglacct.php','pr941.php','STR_941S'),(337,'adminprglacct.php','adminapchkacctupd.php','STR_CHECKING_ACCOUNTS'),(338,'adminprpaytypeupd.php','prloghours.php','STR_LOG_HOURS'),(339,'adminprpaytypeupd.php','prchecksum.php','STR_CHECK_SUMMARY'),(340,'adminprpens.php','prloghours.php','STR_LOG_HOURS'),(341,'adminprpens.php','glacctadd.php','STR_NEW_GL_ACCOUNTS'),(342,'adminprpens.php','prw2.php','STR_W2S'),(343,'adminprpens.php','adminprdedgroupupd.php','STR_DEDUCTION_GROUPS'),(344,'adminpremplreviewratingupd.php','premplreviewupd.php','STR_WRITE_EMPLOYEE_REVIEW'),(345,'adminpremplreviewratingupd.php','timeclock_general.php','STR_TIMECLOCK_SETUP'),(346,'timeclock_general.php','prloghours.php','STR_LOG_HOURS'),(347,'timeclock_general.php','timeclock_viewwork.php','STR_TIME_SUMMARY'),(348,'adminglaccttypeupd.php','glacctadd.php','STR_NEW_GL_ACCOUNTS'),(349,'adminglaccttypeupd.php','glacctlst.php','STR_CHART_OF_ACCOUNTS_LIST'),(350,'adminglaccttypeupd.php','glrepbalance_summary.php','STR_STANDARD_BALANCE_SHEET'),(351,'glcost_centerupd.php','glrepactivity.php','STR_ACCOUNT_ACTIVITY'),(352,'glcost_centerupd.php','glrepincome_12month.php','STR_PRINT_A_12_MONTH_PROFIT_AND_LOSS_STATEMENT'),(353,'glcost_centerupd.php','glrepincome.php','STR_PRINT_A_PROFIT_AND_LOSS_STATEMENT'),(354,'gl_sumlevelupd.php','glrepbalance_summary.php','STR_STANDARD_BALANCE_SHEET'),(355,'gl_sumlevelupd.php','glacctlst.php','STR_CHART_OF_ACCOUNTS_LIST'),(356,'gl_sumlevelupd.php','glrepincome.php','STR_PRINT_A_PROFIT_AND_LOSS_STATEMENT'),(357,'arinvoicerepcust.php','arcustupd.php','STR_CUSTOMERS'),(358,'arinvoicerepcust.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(359,'arinvoicerepcust.php','nporder.php?pos_mode=0','STR_NEW_EDIT_ORDER'),(360,'arinvoicerepbalcust_detail.php','arinvoicepay.php','STR_ENTER_PAYMENTS'),(361,'arinvoicerepbalcust_detail.php','arcredit_writecheck.php','STR_REFUND_CREDIT'),(362,'arinvoicerepbalcust_detail.php','arinvoicestate.php','STR_STATEMENTS'),(363,'arinvoicerepbalcust.php','arinvoicepay.php','STR_ENTER_PAYMENTS'),(364,'arinvoicerepbalcust.php','arcredit_writecheck.php','STR_REFUND_CREDIT'),(365,'arinvoicerepbalcust.php','arinvoicestate.php','STR_STATEMENTS'),(366,'arcustlist.php','adminemail.php','STR_EMAIL_CENTER'),(367,'arcustlistremove.php','adminemail.php','STR_EMAIL_CENTER'),(368,'arcustlistremove.php','arcustupd.php','STR_CUSTOMERS'),(369,'recent_customers.php','adminemail.php','STR_EMAIL_CENTER'),(370,'prempllist.php?types=bday','premployeeupd.php','STR_EMPLOYEES'),(371,'prempllist.php?types=bday','adminemail.php','STR_EMAIL_CENTER'),(372,'prempllist.php?types=nap','arcustupd.php?npmid=1002',''),(373,'prempllist.php?types=gen','premployeeupd.php','STR_EMPLOYEES'),(374,'apvendlist.php','apvendupd.php','STR_EDIT_VENDOR'),(375,'apvendlist.php','adminemail.php','STR_EMAIL_CENTER'),(376,'arordercustitemlst.php','invitemupd.php','STR_EDIT_ITEMS'),(377,'arordercustitemlst.php','nporder.php','STR_POINT_OF_SALE'),(378,'arordercustitemlst.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(379,'arorderquotelist.php','nporder.php?pos_mode=0','STR_NEW_EDIT_ORDER'),(380,'arorder_over_hours.php','nporder.php?pos_mode=0','STR_NEW_EDIT_ORDER'),(381,'arorder_over_hours.php','arservicetypeupd.php','STR_SERVICE_TYPES'),(382,'arorder_over_hours.php','arserviceclassupd.php','STR_SERVICE_CLASSES'),(383,'arorderlist_backorder.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(384,'arorderlist_backorder.php','invpolist.php','STR_PO_LISTS'),(385,'arorderunpaid.php','arinvoicereprint.php','STR_REPRINT_INVOICES'),(386,'arorderunpaid.php','arinvoicestate.php','STR_STATEMENTS'),(387,'arordershiplst.php','arinvoicereprint.php','STR_REPRINT_INVOICES'),(388,'arordershiplst.php','arinvoicestate.php','STR_STATEMENTS'),(389,'arordershiplst.php','invitemlststatus.php','STR_ITEM_STATUS'),(390,'arorderlist.php','arordshipadd.php','STR_SHIP_ORDER'),(391,'arorderlistweight.php','arordshipadd.php','STR_SHIP_ORDER'),(392,'arorderlistreceive.php','arordshipadd.php','STR_SHIP_ORDER'),(393,'arorderlistreceive.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(394,'arorderlistreceive.php','invpolist.php','STR_PO_LISTS'),(395,'arorderlistreceive.php','invitemlststatus.php','STR_ITEM_STATUS'),(396,'arordshipview.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(397,'arordshipview.php','invpolist.php','STR_PO_LISTS'),(398,'arordshipview.php','invitemlststatus.php','STR_ITEM_STATUS'),(399,'arorderunbilled.php','arinvoicestate.php','STR_STATEMENTS'),(400,'arorderlistvoid.php','nporder.php','STR_POINT_OF_SALE'),(401,'arorderstatlst.php','adminemail.php','STR_EMAIL_CENTER'),(402,'arorderstatlst.php','arinvoicereprint.php','STR_REPRINT_INVOICES'),(403,'arorderstatlst.php','arinvoicestate.php','STR_STATEMENTS'),(404,'arorderrmalst.php','adminar_rmasetup.php','STR_RMA_SETUP'),(405,'arorderrmalst.php','arrmashipview.php','STR_PROCESS_RMAS'),(406,'arorderrmalst.php','invitemlststatus.php','STR_ITEM_STATUS'),(407,'arorderstatuslst.php','arorderlist.php','STR_ORDERS_OPEN'),(408,'arorderstatuslst.php','nporder.php','STR_POINT_OF_SALE'),(409,'arorderstatuslst.php','arordshipadd.php','STR_SHIP_ORDER'),(410,'serviceorder_time_reporter.php','nporder.php?pos_mode=0','STR_NEW_EDIT_ORDER'),(411,'invitembuildorderlist.php','nporder.php','STR_POINT_OF_SALE'),(412,'invitembuildorderlist.php','invitemupd.php','STR_EDIT_ITEMS'),(413,'invitemlstcost.php','invitemupd.php','STR_EDIT_ITEMS'),(414,'invitemlstcost.php','invitemlststatus.php','STR_ITEM_STATUS'),(415,'invitemlstcost.php','inventory_costadjust.php','STR_ITEM_COST_ADJUSTMENTS'),(416,'aritemsaleslst.php','invitemupd.php','STR_EDIT_ITEMS'),(417,'aritemsaleslst.php','inventory_costadjust.php','STR_ITEM_COST_ADJUSTMENTS'),(418,'aritemsaleslst.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(419,'invitemactivity.php','invitemupd.php','STR_EDIT_ITEMS'),(420,'invitemactivity.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(421,'invitemactivity.php','inventory_adjustments.php','STR_ITEM_ADJUSTMENTS'),(422,'arorderitemlst_backorder.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(423,'arorderitemlst_backorder.php','invpolist.php','STR_PO_LISTS'),(424,'invitemlstconversions.php','invitemupd.php','STR_EDIT_ITEMS'),(425,'invitemlsthistory.php','inventory_costadjust.php','STR_ITEM_COST_ADJUSTMENTS'),(426,'invitemlsthistory.php','inventory_adjustments.php','STR_ITEM_ADJUSTMENTS'),(427,'invitemlstdist.php','invitemupd.php','STR_EDIT_ITEMS'),(428,'invitemlstdist.php','inventory_adjustments.php','STR_ITEM_ADJUSTMENTS'),(429,'arorderitemcustlst.php','invitemupd.php','STR_EDIT_ITEMS'),(430,'invitemlstprice.php','invitemupd.php','STR_EDIT_ITEMS'),(431,'invitemlstprice.php','invitemprices.php','STR_ITEM_PRICES_MASS_EDIT'),(432,'arordershipitemlst.php','nporder.php?pos_mode=0','STR_NEW_EDIT_ORDER'),(433,'arordershipitemlst.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(434,'invitemlststatus.php','invitemupd.php','STR_EDIT_ITEMS'),(435,'invitemlststatus.php','inventory_adjustments.php','STR_ITEM_ADJUSTMENTS'),(436,'invitemlststatus.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(437,'invitemlstsum.php','invitemupd.php','STR_EDIT_ITEMS'),(438,'invitemlstsum.php','inventory_adjustments.php','STR_ITEM_ADJUSTMENTS'),(439,'invitemlstsum.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(440,'invitemlstusage.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(441,'invitemlstval.php','invitemupd.php','STR_EDIT_ITEMS'),(442,'invitemlstval.php','inventory_costadjust.php','STR_ITEM_COST_ADJUSTMENTS'),(443,'invitemlstval.php','glrepbalance_summary.php','STR_STANDARD_BALANCE_SHEET'),(444,'invitemlstvendor.php','invpolist.php','STR_PO_LISTS'),(445,'invitemlstvendor.php','apbillpay.php','STR_WRITE_CHECKS'),(446,'invitemlstvendor.php','inventory_adjustments.php','STR_ITEM_ADJUSTMENTS'),(447,'invitemlstvendorprice.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(448,'invnotifications.php','adminemail.php','STR_EMAIL_CENTER'),(449,'arorderitemlst.php','invitemupd.php','STR_EDIT_ITEMS'),(450,'arorderitemlst.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(451,'arinvoicerepaging.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(452,'arinvoicerepaging.php','arinvoicepay.php','STR_ENTER_PAYMENTS'),(453,'arinvoicerepaging.php','arcredit_writecheck.php','STR_REFUND_CREDIT'),(454,'arinvoicerepaging.php','arinvoicestate.php','STR_STATEMENTS'),(455,'arcctransactions.php','arinvoicepay.php','STR_ENTER_PAYMENTS'),(456,'arcctransactions.php','arinvoicepayvoid.php','STR_VOID_PAYMENTS'),(457,'arcctransactions.php','arcredit_writecheck.php','STR_REFUND_CREDIT'),(458,'topdollar_customers.php','nporder.php?pos_mode=0','STR_NEW_EDIT_ORDER'),(459,'topdollar_customers.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(460,'topdollar_customers.php','arinvoicestate.php','STR_STATEMENTS'),(461,'arinvoicebystate.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(462,'arinvoicebystate.php','inventory_costadjust.php','STR_ITEM_COST_ADJUSTMENTS'),(463,'arpayplanrep.php','arpayplanadd.php','STR_NEW_PLAN'),(464,'arpayplanrep.php','arpayplanupd.php','STR_PAYMENT_PLANS'),(465,'arpayplanrep.php','arpayplan_post.php','STR_POST_PLANS'),(466,'arinvoicereppay.php','arinvoicepay.php','STR_ENTER_PAYMENTS'),(467,'arinvoicereppay.php','arcredit_writecheck.php','STR_REFUND_CREDIT'),(468,'arinvoicereppay.php','arinvoicepayvoid.php','STR_VOID_PAYMENTS'),(469,'arinvoicereppay.php','arinvoicestate.php','STR_STATEMENTS'),(470,'arorder_activity.php','timeclock_viewwork.php','STR_TIME_SUMMARY'),(471,'arorder_activity.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(472,'arinvoicereprint.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(473,'arinvoicereprint.php','arcustupd.php','STR_CUSTOMERS'),(474,'arinvoicereprint.php','adminarinvtermsupd.php','STR_INVOICE_TERMS'),(475,'arinvoicereprint.php','admininvoicenotesupd.php','STR_INVOICE_END_NOTES'),(476,'arinvoicerepvat.php','adminartaxgroupsupd.php',''),(477,'arinvoicerepvat.php','adminartaxgroupsupd.php',''),(478,'arinvoicerepvat.php','adminartaxgroupsupd.',''),(479,'arinvoicesum.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(480,'arinvoicesum.php','inventory_costadjust.php','STR_ITEM_COST_ADJUSTMENTS'),(481,'arinvoicesum.php','arinvoicepay.php','STR_ENTER_PAYMENTS'),(482,'arinvoicerepvat.php','adminartaxgroupsupd.php',''),(483,'arinvoicestate.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(484,'arinvoicestate.php','arcustupd.php','STR_CUSTOMERS'),(485,'arinvoicestate.php','arinvoicereprint.php','STR_REPRINT_INVOICES'),(486,'apbilllistaging.php','apvendupd.php','STR_EDIT_VENDOR'),(487,'apbilllistaging.php','apbillupd.php','STR_EDIT_VENDOR_BILL'),(488,'apbilllistaging.php','apbillpay.php','STR_WRITE_CHECKS'),(489,'apbilllistdiscaging.php','apvendupd.php','STR_EDIT_VENDOR'),(490,'apbilllistdiscaging.php','apbillupd.php','STR_EDIT_VENDOR_BILL'),(491,'apbilllistdiscaging.php','apbillpay.php','STR_WRITE_CHECKS'),(492,'apcashrequirements.php','apvendupd.php','STR_EDIT_VENDOR'),(493,'apcashrequirements.php','apbillupd.php','STR_EDIT_VENDOR_BILL'),(494,'apcashrequirements.php','apbillpay.php','STR_WRITE_CHECKS'),(495,'apchecklist.php','apchecking.php','STR_VIEW_CANCEL_CHECKS'),(496,'apchecklist.php','apbillpay.php','STR_WRITE_CHECKS'),(497,'apccpurchaselist.php','apccpurchaseupd.php','STR_CC_PURCHASES'),(498,'apccpurchaselist.php','apccpurchase2bill.php','STR_NEW_CC_BILLS'),(499,'apccpurchaselist.php','apccpurchase2billupd.php','STR_EDIT_CC_BILLS'),(500,'invitemreclist.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(501,'invitemreclist.php','invitemlststatus.php','STR_ITEM_STATUS'),(502,'invitemreclist.php','arordshipadd.php','STR_SHIP_ORDER'),(503,'apbilllist.php','apbilladd.php','STR_NEW_VENDOR_BILL'),(504,'apbilllist.php','apbillupd.php','STR_EDIT_VENDOR_BILL'),(505,'apbilllist.php','apbillpay.php','STR_WRITE_CHECKS'),(506,'invpolist.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(507,'invpolist.php','invpoupd.php','STR_EDIT_PURCHASE_ORDER'),(508,'invpolist.php','arorderlist_backorder.php','STR_BACKORDERS'),(509,'adminachreport.php','directdepform.php','STR_DIRECT_DEPOSIT_AUTH'),(510,'adminachreport.php','prloghours.php','STR_LOG_HOURS'),(511,'prempllist.php','prw2.php','STR_W2S'),(512,'prempllist.php','pr941.php','STR_941S'),(513,'prempllist.php','prloghours.php','STR_LOG_HOURS'),(514,'prchecksumgroup.php','prw2.php','STR_W2S'),(515,'prchecksumgroup.php','pr941.php','STR_941S'),(516,'prchecksumgroup.php','timeclock_viewwork.php','STR_TIME_SUMMARY'),(517,'timeclock_viewstatus.php','timeclock_viewwork.php','STR_TIME_SUMMARY'),(518,'timeclock_viewstatus.php','premployeeupd.php','STR_EMPLOYEES'),(519,'timeclock_viewwork.php','prloghours.php','STR_LOG_HOURS'),(520,'timeclock_viewwork.php','premployeeupd.php','STR_EMPLOYEES'),(521,'prworkmanscomp.php','premployeeupd.php','STR_EMPLOYEES'),(522,'prw2.php','prchecksumgroup.php','STR_PAY_HISTORY'),(523,'prw2.php','premployeeupd.php','STR_EMPLOYEES'),(524,'pr941.php','prchecksumgroup.php','STR_PAY_HISTORY'),(525,'pr941.php','prempllist.php?types=bday','STR_LIST_OF_EMPLOYEE_BIRTHDAYS'),(526,'pr941.php','premployeeupd.php','STR_EMPLOYEES'),(527,'glrepactivity.php','glpostadd.php','STR_POST_JOURNALS_NOW'),(528,'glrepactivity.php','gljourupd.php','STR_JOURNAL_ENTRIES'),(529,'glrepactivity.php','glrepbalance_summary.php','STR_STANDARD_BALANCE_SHEET'),(530,'glrepbalance.php','gl_sumlevelupd.php','STR_GL_SUMMARY_LEVELS'),(531,'glrepbalance.php','glacct_assign.php','STR_ASSIGN_SUMMARIZATION'),(532,'glrepbalance.php','gljouradd.php','STR_NEW_JOURNAL_ENTRIES'),(533,'glrepbalance_summary.php?npmid=11063','gl_sumlevelupd.php?npmid=9073',''),(534,'glrepbalance_summary.php?npmid=11063','glacct_assign.php?npmid=7023',''),(535,'glrepbalance_summary.php?npmid=11063','gljouradd.php','STR_NEW_JOURNAL_ENTRIES'),(536,'glrepbalance_summary.php','gl_sumlevelupd.php','STR_GL_SUMMARY_LEVELS'),(537,'glrepbalance_summary.php','glacct_assign.php','STR_ASSIGN_SUMMARIZATION'),(538,'glrepbalance_summary.php','gljouradd.php','STR_NEW_JOURNAL_ENTRIES'),(539,'glrepbalance_detail.php','gl_sumlevelupd.php','STR_GL_SUMMARY_LEVELS'),(540,'glrepbalance_detail.php','glcost_centerupd.php','STR_GL_COST_CENTERS'),(541,'glrepbalance_detail.php','gljouradd.php','STR_NEW_JOURNAL_ENTRIES'),(542,'glbudlst.php','glbudadd.php','STR_NEW_EDIT_BUDGET'),(543,'glbudlst.php','glrepbudvariance.php','STR_BUDGET_VARIANCE'),(544,'glacctlst.php','gljouradd.php','STR_NEW_JOURNAL_ENTRIES'),(545,'glacctlst.php','gljourupd.php','STR_JOURNAL_ENTRIES'),(546,'glacctlst.php','gl_sumlevelupd.php','STR_GL_SUMMARY_LEVELS'),(547,'glrepdaily.php','glrepjournal.php','STR_JOURNAL_REPORTS'),(548,'glrepdaily.php','arinvoicerepaging.php','STR_AGING_REPORT'),(549,'glrepdaily.php','apbilllistaging.php','STR_SUMMARY_AGING'),(550,'glrepjournal.php','glpostadd.php','STR_POST_JOURNALS_NOW'),(551,'glrepjournal.php','gljourupd.php','STR_JOURNAL_ENTRIES'),(552,'glrepjournal.php','glrepactivity.php','STR_ACCOUNT_ACTIVITY'),(553,'glrepincome_12month.php','gl_sumlevelupd.php','STR_GL_SUMMARY_LEVELS'),(554,'glrepincome_12month.php','glcost_centerupd.php','STR_GL_COST_CENTERS'),(555,'glrepincome_12month.php','glrepincome.php','STR_PRINT_A_PROFIT_AND_LOSS_STATEMENT'),(556,'glrepincome.php','gl_sumlevelupd.php','STR_GL_SUMMARY_LEVELS'),(557,'glrepincome.php','glcost_centerupd.php','STR_GL_COST_CENTERS'),(558,'glrepincome.php','glrepincome_12month.php','STR_PRINT_A_12_MONTH_PROFIT_AND_LOSS_STATEMENT'),(559,'glrepjournal_unbalanced.php','glpostadd.php','STR_POST_JOURNALS_NOW'),(560,'glrepjournal_unbalanced.php','gljourupd.php','STR_JOURNAL_ENTRIES'),(561,'arcustb2buser.php','nolapro/b2b/index.php',''),(562,'arcustmerge.php','arcustupd.php','STR_CUSTOMERS'),(563,'arcustmerge.php','nporder.php','STR_POINT_OF_SALE'),(564,'arcustmerge.php','arinvoiceadd.php','STR_NEW_INVOICE'),(565,'adminemail.php','premployeeupd.php','STR_EMPLOYEES'),(566,'adminemail.php','apvendupd.php','STR_EDIT_VENDOR'),(567,'adminarsalesmanadd.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(568,'adminarsalesmanupd.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(569,'arorder2invoice.php','arinvoicereprint.php','STR_REPRINT_INVOICES'),(570,'arorder2invoice.php','arinvoicestate.php','STR_STATEMENTS'),(571,'arordshipadd.php','invitemlststatus.php','STR_ITEM_STATUS'),(572,'arordshipadd.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(573,'arorder2invoice.php','nporder.php?pos_mode=0','STR_NEW_EDIT_ORDER'),(574,'serviceorder_time_editor.php','serviceorder_time.php','STR_LOG_TIME'),(575,'serviceorder_time_editor.php','nporder.php?pos_mode=0','STR_NEW_EDIT_ORDER'),(576,'inventory_pricecopy.php','invitemprices.php','STR_ITEM_PRICES_MASS_EDIT'),(577,'inventory_pricecopy.php','invitemlststatus.php','STR_ITEM_STATUS'),(578,'inventory_pricecopy.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(579,'inventory_breakdown.php','inventory_adjustments.php','STR_ITEM_ADJUSTMENTS'),(580,'inventory_breakdown.php','invitemupd.php','STR_EDIT_ITEMS'),(581,'inventory_breakdown.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(582,'inventory_costadjust.php','invitemupd.php','STR_EDIT_ITEMS'),(583,'invitemprices.php','inventory_adjustments.php','STR_ITEM_ADJUSTMENTS'),(584,'inventory_transfers.php','invitemlststatus.php','STR_ITEM_STATUS'),(585,'inventory_transfers.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(586,'invitemvendupd.php','invitemlststatus.php','STR_ITEM_STATUS'),(587,'invitemvendupd.php','invpoadd.php','STR_NEW_PURCHASE_ORDER'),(588,'invitembuildorder.php','nporder.php?pos_mode=0','STR_NEW_EDIT_ORDER'),(589,'invitembompo.php','invitemadd.php','STR_ADD_ITEMS'),(590,'invitembompo.php','invitemupd.php','STR_EDIT_ITEMS'),(591,'arcashpaymentadd.php','adminarsales_category.php','STR_SALES_CATEGORIES'),(592,'arcashpaymentadd.php','adminarsalestaxupd.php','STR_SALES_TAXES'),(593,'arcashpaymentadd.php','gljouradd.php','STR_NEW_JOURNAL_ENTRIES'),(594,'arcashpaymentupd.php','adminarsales_category.php','STR_SALES_CATEGORIES'),(595,'arcashpaymentupd.php','adminarsalestaxupd.php','STR_SALES_TAXES'),(596,'arcashpaymentupd.php','gljouradd.php','STR_NEW_JOURNAL_ENTRIES'),(597,'arinvoice_writeoff.php','arinvoiceupd.php','STR_EDIT_INVOICE'),(598,'arinvoice_writeoff.php','arcustupd.php','STR_CUSTOMERS'),(599,'arinvoicepay.php','arcredit_writecheck.php','STR_REFUND_CREDIT'),(600,'arinvoicepay.php','arinvoicestate.php','STR_STATEMENTS'),(601,'arcredit_writecheck.php','arinvoicepayvoid.php','STR_VOID_PAYMENTS'),(602,'arcredit_writecheck.php','arinvoicestate.ph',''),(603,'arpayplan_post.php','arinvoicereprint.php','STR_REPRINT_INVOICES'),(604,'arpayplan_post.php','arinvoicestate.php','STR_STATEMENTS'),(605,'bom_entry_or_update.php','invitembuildorder.php','STR_EDIT_BUILD_ORDER'),(606,'bom_entry_or_update.php','invitembuildorder.phpnpmid=3012',''),(607,'prcalchours.php','prloghours.php','STR_LOG_HOURS'),(608,'prcalchours.php','prcheckwrite.php','STR_WRITE_CHECKS'),(609,'premplweekupd.php','prloghours.php','STR_LOG_HOURS'),(610,'premplweekupd.php','prcheckwrite.php','STR_WRITE_CHECKS'),(611,'prloghours_table.php','prloghours.php','STR_LOG_HOURS'),(612,'adminprtaxtypedtl.php','adminprtaxtypeadd.php','STR_NEW_TAX_TYPE'),(613,'adminprtaxtypedtl.php','adminprtaxtypeupd.php','STR_EDIT_TAX_TYPE'),(614,'adminprtaxtypeadd.php','adminprtaxtypeupd.php','STR_EDIT_TAX_TYPE'),(615,'adminprtaxtypeadd.php','adminprtaxtypedtl.php','STR_EDIT_TAX_TABLE'),(616,'adminprtaxtypeupd.php','adminprtaxtypeadd.php','STR_NEW_TAX_TYPE'),(617,'adminprtaxtypeupd.php','adminprtaxtypedtl.php','STR_EDIT_TAX_TABLE'),(618,'copytax.php','adminprtaxtypeadd.php','STR_NEW_TAX_TYPE'),(619,'copytax.php','adminprtaxtypedtl.php','STR_EDIT_TAX_TABLE'),(620,'glbudadd.php','glrepbudvariance.php','STR_BUDGET_VARIANCE'),(621,'glbudadd.php','glbudlst.php','STR_BUDGET_LIST'),(622,'glrepbudvariance.php','glbudadd.php','STR_NEW_EDIT_BUDGET'),(623,'glrepbudvariance.php','glbudlst.php','STR_BUDGET_LIST'),(624,'glpostadd.php','glrepjournal_unbalanced.php','STR_UNBALANCED'),(625,'glpostadd.php','glrepjournal.php','STR_JOURNAL_REPORTS'),(626,'glpostadd.php','gljouradd.php','STR_NEW_JOURNAL_ENTRIES'),(627,'glpostadd.php','gljourupd.php','STR_JOURNAL_ENTRIES'),(628,'glpostupd.php','gljourupd.php','STR_JOURNAL_ENTRIES'),(629,'gljour_std_add.php','gljour_std_upd.php','STR_EDIT_RECURRING_ENTRIES'),(630,'gljour_std_add.php','gljour_std_post.php','STR_POST_RECURRING_ENTRIES'),(631,'gljour_std_add.php','arinvoiceadd.php','STR_NEW_INVOICE'),(632,'gljour_std_add.php','apbilladd.php','STR_NEW_VENDOR_BILL'),(633,'gljour_std_upd.php','gljour_std_add.php','STR_NEW_RECURRING_ENTRIES'),(634,'gljour_std_upd.php','gljour_std_post.php','STR_POST_RECURRING_ENTRIES'),(635,'gljour_std_upd.php','arinvoiceadd.php','STR_NEW_INVOICE'),(636,'gljour_std_upd.php','apbilladd.php','STR_NEW_VENDOR_BILL'),(637,'adminapilog.php','featurepurchase.php','STR_ADD_ONS'),(638,'adminflexfields.php','featurepurchase.php','STR_ADD_ONS'),(639,'adminserversetup.php','admininvlocationupd.php','STR_PLANT_LOCATIONS'),(640,'adminserversetup.php','gencompanyupd.php','STR_COMPANY_ADD_UPDATE'),(641,'adminserversetup.php','arcustadd.php','STR_NEW_CUSTOMER'),(642,'adminserversetup.php','premployeeadd.php','STR_NEW_EMPLOYEE'),(643,'adminserversetup.php','adminarsalesmanadd.php','STR_NEW_SALES_PERSONNEL'),(644,'adminserversetup.php','apvendadd.php','STR_NEW_VENDOR'),(645,'gl_admin_export.php','glacctlst.php','STR_CHART_OF_ACCOUNTS_LIST'),(646,'exportitems.php','invitemlststatus.php','STR_ITEM_STATUS'),(647,'exportvendors.php','apvendlist.php','STR_VENDOR_LISTS_LABELS'),(648,'gl_admin_import.php','glacctlst.php','STR_CHART_OF_ACCOUNTS_LIST'),(649,'importbankofx.php','featurepurchase.php','STR_ADD_ONS'),(650,'importcustomer.php','arcustlist.php','STR_LIST_CUSTOMERS'),(651,'importcustomer.php','arcustadd.php','STR_NEW_CUSTOMER'),(652,'import_distributor_sales.php','apbilladd_beginbal.php','STR_BEGIN_BILLS'),(653,'importemployee.php','prempllist.php',''),(654,'importemployee.php','premployeeadd.php','STR_NEW_EMPLOYEE'),(655,'importgltotals.php','glrepbalance.php','STR_BALANCE_SHEET'),(656,'importgltotals.php','apbilllist.php','STR_PAYABLES_LISTS'),(657,'importgltotals.php','arinvoiceadd_beginbal.php','STR_BEGINNING_BALANCES'),(658,'importgltotals.php','apbilladd_beginbal.php','STR_BEGIN_BILLS'),(659,'importitem_categories.php','invitemcatupd.php','STR_ITEM_CATEGORIES'),(660,'importitems.php','invitemlststatus.php','STR_ITEM_STATUS'),(661,'qbimport.php','featurepurchase.php','STR_ADD_ONS'),(662,'importvendor.php','apvendlist.php','STR_VENDOR_LISTS_LABELS'),(663,'importvendor.php','apvendadd.php','STR_NEW_VENDOR'),(664,'adminipaccessmanager.php','featurepurchase.php','STR_ADD_ONS'),(665,'translation.php','nporder.php','STR_POINT_OF_SALE'),(666,'translation.php','arinvoiceadd.php','STR_NEW_INVOICE'),(667,'adminosccompanyupd.php','featurepurchase.php','STR_ADD_ONS'),(668,'adminsurvey.php','adminsurveyreport',''),(669,'adminsurvey.php','arcustupd.php','STR_CUSTOMERS'),(670,'adminsurveyreport.php','adminsurvey.php','STR_SURVEY_MANAGER'),(671,'adminsurveyreport.php','arcustupd.php','STR_CUSTOMERS'),(672,'adminhpgroups.php','adminreportcache.php','STR_HOMEPAGE_REFRESH_TIMES'),(673,'adminreportcache.php','adminhpgroups.php','STR_DASHBOARD_REPORTS'),(674,'adminbing.php','gencompanyupd.php','STR_COMPANY_ADD_UPDATE'),(675,'adminnotecategory.php','arcustupd.php','STR_CUSTOMERS'),(676,'invitemoptiongroup.php','invitemupd.php','STR_EDIT_ITEMS'),(677,'inventory_recalcFMLW.php','invitemlststatus.php','STR_ITEM_STATUS'),(678,'adminglcompanyupd.php','glrepbalance.php','STR_BALANCE_SHEET'),(679,'adminglcompanyupd.php','glrepincome.php','STR_PROFIT_AND_LOSS'),(680,'premplsum.php','prchecksum.php','STR_CHECK_SUMMARY'),(681,'arorderlist.php','nporder.php','STR_POINT_OF_SALE'),(682,'over_estimate_orders_list.php','invitemlststatus.php','STR_ITEM_STATUS'),(683,'arorder_unconfirmed.php','invitemlststatus.php','STR_ITEM_STATUS'),(684,'arorder_volume.php','glrepbalance.php','STR_BALANCE_SHEET'),(685,'bom_list.php','invitembuildorder.php','STR_EDIT_BUILD_ORDER'),(686,'arcashpaymentrep.php','arcashpaymentadd.php','STR_NEW_NON_INVOICED_SALES'),(687,'arcashpaymentrep.php','arcashpaymentupd.php','STR_EDIT_NON_INVOICED_SALES'),(688,'arinvoicereptax.php','adminarsalestaxupd.php','STR_SALES_TAXES'),(689,'distributor_commissionreport.php','arinvoicesum.php','STR_SUMMARY_OF_INVOICES'),(690,'arcustb2buser.php','index.php',''),(691,'arcustb2buser.php','arcustadd.php','STR_NEW_CUSTOMER'),(692,'arvendb2buser.php','apvendadd.php','STR_NEW_VENDOR'),(693,'arcustupd.php','nporder.php?pos_mode=0','STR_NEW_EDIT_ORDER'),(694,'arcustadd.php','nporder.php?pos_mode=0','STR_NEW_EDIT_ORDER');
/*!40000 ALTER TABLE `menudatashortcut` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menudatavendor`
--

DROP TABLE IF EXISTS `menudatavendor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menudatavendor` (
  `id` int(11) NOT NULL default '0',
  `menu_name` varchar(30) default '',
  `id_menudata` int(11) NOT NULL default '0',
  `orderflag` int(5) NOT NULL default '0',
  `menu_action` int(2) NOT NULL default '1',
  `description` varchar(250) default NULL,
  `accessap` int(2) NOT NULL default '0',
  `accessar` int(2) NOT NULL default '0',
  `accessgl` int(2) NOT NULL default '0',
  `accesspay` int(2) NOT NULL default '0',
  `accessinv` int(2) NOT NULL default '0',
  `accessest` int(2) NOT NULL default '0',
  `accessfix` int(2) NOT NULL default '0',
  `accessimp` int(2) NOT NULL default '0',
  `setupap` int(2) NOT NULL default '0',
  `setupar` int(2) NOT NULL default '0',
  `setupgl` int(2) NOT NULL default '0',
  `setuppay` int(2) NOT NULL default '0',
  `setupinv` int(2) NOT NULL default '0',
  `setupest` int(2) NOT NULL default '0',
  `setupfix` int(2) NOT NULL default '0',
  `setupimp` int(2) NOT NULL default '0',
  `supervisor` int(2) NOT NULL default '0',
  `extvend` int(2) NOT NULL default '0',
  `extcust` int(2) NOT NULL default '0',
  `nonext` int(2) NOT NULL default '0',
  `menu_link` varchar(255) default NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menudatavendor`
--

LOCK TABLES `menudatavendor` WRITE;
/*!40000 ALTER TABLE `menudatavendor` DISABLE KEYS */;
/*!40000 ALTER TABLE `menudatavendor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menudataxp`
--

DROP TABLE IF EXISTS `menudataxp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menudataxp` (
  `id` int(11) NOT NULL default '0',
  `menu_name` varchar(100) default '',
  `id_menudata` int(11) NOT NULL default '0',
  `orderflag` int(5) NOT NULL default '0',
  `menu_action` int(2) NOT NULL default '1',
  `description` varchar(250) default NULL,
  `accessap` int(2) NOT NULL default '0',
  `accessar` int(2) NOT NULL default '0',
  `accessgl` int(2) NOT NULL default '0',
  `accesspay` int(2) NOT NULL default '0',
  `accessinv` int(2) NOT NULL default '0',
  `accessest` int(2) NOT NULL default '0',
  `accessfix` int(2) NOT NULL default '0',
  `accessimp` int(2) NOT NULL default '0',
  `accesssc` int(2) NOT NULL default '0',
  `setupap` int(2) NOT NULL default '0',
  `setupar` int(2) NOT NULL default '0',
  `setupgl` int(2) NOT NULL default '0',
  `setuppay` int(2) NOT NULL default '0',
  `setupinv` int(2) NOT NULL default '0',
  `setupest` int(2) NOT NULL default '0',
  `setupfix` int(2) NOT NULL default '0',
  `setupimp` int(2) NOT NULL default '0',
  `setupsc` int(2) NOT NULL default '0',
  `supervisor` int(2) NOT NULL default '0',
  `extvend` int(2) NOT NULL default '0',
  `extcust` int(2) NOT NULL default '0',
  `nonext` int(2) NOT NULL default '0',
  `menu_link` varchar(255) default NULL,
  `linktype` varchar(11) NOT NULL default '',
  `plaintext` varchar(11) NOT NULL default '',
  `languageid` int(2) NOT NULL default '0',
  `icon` varchar(255) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `groupname` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menudataxp`
--

LOCK TABLES `menudataxp` WRITE;
/*!40000 ALTER TABLE `menudataxp` DISABLE KEYS */;
INSERT INTO `menudataxp` VALUES (1,'STR_ORDERS',0,1,0,'STR_ORDER_TRACKING_LISTS_FILLING_STATISTICS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'orders_main.png',0,''),(100,'STR_CUSTOMERS',1,100,0,'STR_CUSTOMER_INFORMATION',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustupd.php','','',1,'customer.png',0,''),(1001,'STR_NEW_CUSTOMER',100,1,1,'STR_ADD_CUSTOMER_INFORMATION',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustadd.php','','',1,'add.png',0,''),(1002,'STR_EDIT_CUSTOMER',100,2,1,'STR_EDIT_CUSTOMER_INFORMATION',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustupd.php','','',1,'edit.png',0,''),(1003,'STR_LIST_CUSTOMERS',100,3,1,'STR_LISTS_AND_EXPORTS_OF_CUSTOMER_DATA',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustlist.php','','',1,'list.png',0,''),(1004,'STR_VIEW_ACCOUNT',100,4,1,'STR_VIEW_ACCOUNT_DATA',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepcust.php','','',1,'report.png',0,''),(1005,'STR_ACTIVITY_HISTORY',100,5,1,'STR_CUSTOMER_ACTIVITY_HISTORY',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepbalcust_detail.php','','',1,'history.png',0,''),(1006,'STR_BALANCE_HISTORY',100,6,1,'STR_BALANCE_HISTORY',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepbalcust.php','','',1,'history.png',0,''),(1007,'STR_B2B_USERS',100,7,1,'STR_ADD_LISTS_OF_EXTERNAL_B2B_CUSTOMER_USERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustb2buser.php?ar=1','','',1,'contacts.png',0,''),(1008,'STR_MERGE_CUSTOMERS',100,8,1,'STR_MERGE_CUSTOMERS_WITH_MULTIPLE_RECORDS',0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arcustmerge.php?ar=1','','',1,'process.png',0,''),(101,'STR_FULFILLMENT_ORDERS',1,101,0,'STR_FULFILLMENT_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordupd.php','','',1,'orders.png',0,'fulfillment'),(1011,'STR_NEW_ORDER',101,1,1,'STR_ADD_NEW_FULFILLMENT_ORDER',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordadd.php','','',1,'add.png',0,'fulfillment'),(1012,'STR_EDIT_ORDER',101,2,1,'STR_EDIT_FULFILLMENT_ORDER',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordupd.php','','',1,'edit.png',0,'fulfillment'),(1013,'STR_DYNAMIC_ORDER_PAGE',101,3,1,'STR_DYNAMIC_ORDER_PAGE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'nporder.php?pos_mode=0','','',1,'edit.png',0,'fulfillment'),(1014,'STR_CHECK_IN_OUT',101,4,1,'STR_CONFIRM_ORDERS_AS_OK',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderckout.php','','',1,'confirm.png',0,'fulfillment'),(1015,'STR_SHIP_ORDER',101,5,1,'STR_ENTER_SHIPMENTS_OF_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordshipadd.php','','',1,'ship.png',0,'fulfillment'),(1016,'STR_FILL_START_STOP',101,6,1,'STR_TRACK_FULFILLMENT_PROCESSES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderfill.php','','',1,'fill.png',0,'fulfillment'),(1017,'STR_PROCESS_STATUS',101,7,1,'STR_STATUS_OF_PENDING_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderstatuslst.php','','',1,'list.png',0,'fulfillment'),(1018,'STR_ORDERS_INVOICES',101,8,1,'STR_CREATE_INVOICES_FROM_SHIPPED_OR_COMPLETED_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorder2invoice.php','','',1,'process.png',0,'fulfillment'),(1019,'STR_VIEW_SHIPPED_ORDERS',101,9,1,'STR_VIEW_ORDERS_SHIPPED',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordshipview.php','','',1,'list1.png',0,'fulfillment'),(10110,'STR_PROCESS_RMAS',101,10,1,'STR_RMAS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arrmashipview.php','','',1,'rma.png',0,'fulfillment'),(10111,'STR_RMA_SETUP',101,11,1,'STR_RMA_CONDITIONS_REASONS_ACTIONS',0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminar_rmasetup.php','','',1,'tools.png',0,'fulfillment'),(102,'STR_SERVICE_ORDERS',1,102,0,'STR_ENTER_AND_UPDATE_SERVICE_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arserviceordupd.php','','',1,'service.png',0,'service'),(10211,'STR_NEW_ORDER',102,11,1,'STR_ADD_NEW_SERVICE_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arserviceordadd.php','','',1,'add.png',0,'service'),(10212,'STR_EDIT_ORDER',102,12,1,'STR_EDIT_SERVICE_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arserviceordupd.php','','',1,'edit.png',0,'service'),(10213,'STR_LOG_TIME',102,13,1,'STR_LOG_HOURS_ON_SERVICE_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'serviceorder_time.php','','',1,'time.png',0,'service'),(10214,'STR_EDIT_INTERNAL_WORK',102,14,1,'STR_EDIT_INTERNAL_WORK_TIME',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'serviceorder_time_editor.php','','',1,'edit.png',0,'service'),(10215,'STR_OVER_ESTIMATE',102,15,1,'STR_ORDERS_NEAR_OR_OVER_ESTIMATE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'over_estimate_orders_list.php','','',1,'list2.png',0,'service'),(10216,'STR_HOURS_ORDERED',102,16,1,'STR_HOURS_ORDERED',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorder_over_hours.php','','',1,'list3.png',0,'service'),(10217,'STR_TIME_REPORT',102,17,1,'STR_TIME_REPORT_FOR_SERVICE_ORDER_WORK',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'serviceorder_time_reporter.php','','',1,'report.png',0,'service'),(103,'STR_REPORTS',1,103,0,'STR_ORDER_LISTS_OPEN_ORDERS_SHIPPED_ORDERS_BACKORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'statistics.png',0,'serviceful'),(1031,'STR_ORDERS_OPEN',103,1,1,'STR_LISTS_OF_OPEN_PENDING_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderlist.php','','',1,'list2.png',0,'serviceful'),(1032,'STR_BACKORDERS',103,2,1,'STR_LISTS_OF_BACK_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderlist_backorder.php','','',1,'list1.png',0,'serviceful'),(1033,'STR_ITEMS_BACKORDERED',103,3,1,'STR_LISTS_OF_BACK_ORDERED_ITEMS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderitemlst_backorder.php','','',1,'list3.png',0,'serviceful'),(1034,'STR_ORDERS_RECEIVED',103,4,1,'STR_LISTS_OF_ORDERS_RECEIVED',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderlistreceive.php','','',1,'list4.png',0,'serviceful'),(1035,'STR_ORDERS_COMPLETED',103,5,1,'STR_LISTS_OF_COMPLETED_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordershiplst.php','','',1,'list3.png',0,'serviceful'),(1036,'STR_VOIDED_ORDERS',103,6,1,'STR_LISTS_OF_VOIDED_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderlistvoid.php','','',1,'delete.png',0,'serviceful'),(1037,'STR_ORDERS_UNCONFIRMED',103,7,1,'STR_LISTS_AND_CONFIRM_ORDERS_ENTERED_BY_B2B_USERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorder_unconfirmed.php','','',1,'list.png',0,'serviceful'),(1038,'STR_RMA_LISTS',103,8,1,'STR_LIST_PENDING_AND_COMPLETED_RMAS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderrmalst.php','','',1,'list4.png',0,'serviceful'),(1039,'STR_CUSTOMER_ITEM_HISTORY',103,9,1,'STR_CUSTOMER_ITEM_HISTORY',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordercustitemlst.php','','',1,'history.png',0,'serviceful'),(10310,'STR_ITEM_ORDER_HISTORY',103,10,1,'STR_ITEM_ORDER_HISTORY',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderitemcustlst.php','','',1,'history.png',0,'serviceful'),(10311,'STR_INVENTORY_HISTORY',103,11,1,'STR_INVENTORY_HISTORY',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'aritemsaleslst.php','','',1,'history.png',0,'serviceful'),(10312,'STR_ITEMS_SHIPPED',103,12,1,'STR_LISTS_OF_ITEMS_SHIPPED',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arordershipitemlst.php','','',1,'list3.png',0,'serviceful'),(10313,'STR_OPEN_ITEMS_ON_ORDERS',103,13,1,'STR_LISTS_OF_OPEN_ITEMS_ON_ORDERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderitemlst.php','','',1,'list2.png',0,'serviceful'),(10314,'STR_OPEN_ORDER_WEIGHT_VIEW',103,14,1,'STR_OPEN_ORDER_WEIGHT_VIEW',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderlistweight.php','','',1,'list3.png',0,'fulfillment'),(10315,'STR_FULFILLMENT_QUOTES',103,15,1,'STR_PENDING_FULFILLMENT_ORDER_QUOTES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderquotelist.php','','',1,'list.png',0,'serviceful'),(10316,'STR_SHIPPED_NOT_BILLED',103,16,1,'STR_FULFILLMENT_ORDERS_SHIPPED_BUT_NOT_BILLED',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderunbilled.php','','',1,'list2.png',0,'serviceful'),(10317,'STR_BILLED_NOT_PAID',103,17,1,'STR_ORDER_BILLED_BUT_NOT_PAID',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderunpaid.php','','',1,'finance.png',0,'serviceful'),(10318,'STR_PERFORMANCE_STATISTICS',103,18,1,'STR_ON_TIME_STATISTICS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorderstatlst.php','','',1,'newslice.png',0,'serviceful'),(10319,'STR_VOLUME_RPT',103,19,1,'STR_VOLUME_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorder_volume.php','','',1,'newslice.png',0,'serviceful'),(104,'STR_LEAD_TRACKING',1,104,0,'STR_LEAD_TRACKING',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'customer.png',0,''),(1041,'STR_SALES_ACTION_REPORT',104,1,1,'STR_SALES_ACTION_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'salesactionlst.php','','',1,'list.png',0,''),(1042,'STR_SALES_OVERVIEW_REPORT',104,2,1,'STR_SALES_OVERVIEW_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'salesstatlst.php','','',1,'list1.png',0,''),(1043,'STR_SALES_PROCESS_ADD_UPDATE',104,3,1,'STR_SALES_PROCESS_ADD_UPDATE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'salesprocess_addupdate.php','','',1,'add.png',0,''),(105,'STR_SETUP_SERVICE',1,105,0,'STR_SETUP_FUNCTIONS_FOR_SERVICE_ORDERS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,'service'),(1054,'STR_SERVICE_CLASSES',105,4,1,'STR_ENTER_SERVICE_ORDER_CLASSES_OF_LABOR',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arserviceclassupd.php','','',1,'service.png',0,'service'),(1055,'STR_SERVICE_LABOR_RATES',105,5,1,'STR_LABOR_RATES_FOR_SERVICE_ORDER_TYPES_AND_CLASSES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arservicerates.php','','',1,'payment.png',0,'service'),(1056,'STR_SERVICE_STATUS_OPTIONS',105,6,1,'STR_STATUS_OPTIONS_FOR_SERVICE_ORDERS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarordstatusupd.php','','',1,'edit.png',0,'service'),(1057,'STR_SERVICE_TYPES',105,7,1,'STR_ENTER_SERVICE_ORDER_TYPES_OF_WORK',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arservicetypeupd.php','','',1,'category.png',0,'service'),(106,'STR_SETUP_LEAD_TRACKING',1,106,0,'STR_SETUP_FUNCTIONS_FOR_LEAD_TRACKING',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,''),(1061,'STR_ACTIONS',106,1,1,'STR_ENTER_UPDATE_SALES_ACTIONS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'action_addupdate.php','','',1,'process.png',0,''),(1062,'STR_CATEGORIES',106,2,1,'STR_ENTER_UPDATE_SALES_CATEGORIES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'salescat_addupdate.php','','',1,'category.png',0,''),(2,'STR_BILLING',0,2,0,'STR_INVOICING_PAYMENTS_RECEIVED_SALES_TAX_REPORTS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'billing_main.png',0,''),(200,'STR_INVOICES',2,200,0,'STR_CREATE_EDIT_INVOICE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'finance.png',0,''),(2001,'STR_NEW_INVOICE',200,1,1,'STR_CREATE_A_NEW_INVOICE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoiceadd.php','','',1,'add.png',0,''),(2002,'STR_EDIT_INVOICE',200,2,0,'STR_UPDATE_INVOICES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoiceupd.php','','',1,'edit.png',0,''),(2003,'STR_CALCULATE_INTEREST',200,3,1,'STR_CALCULATE_INTEREST_ON_OVERDUE_INVOICES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicecalcint.php','','',1,'calculator.png',0,''),(2004,'STR_ENTER_PAYMENTS',200,4,1,'STR_ENTER_PAYMENTS_RECEIVED',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicepay.php','','',1,'finance.png',0,''),(2005,'STR_VOID_PAYMENTS',200,5,1,'STR_VOID_PAYMENTS_ENTERED',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arinvoicepayvoid.php','','',1,'void.png',0,''),(2006,'STR_BAD_DEBT',200,6,1,'STR_BAD_DEBT_WRITE_OFF',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arinvoice_writeoff.php','','',1,'void.png',0,''),(2007,'STR_REFUND_CREDIT',200,7,1,'STR_WRITE_CHECK_TO_CANCEL_CREDIT_BALANCE_ON_CUSTOMER_ACCOUNT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcredit_writecheck.php','','',1,'payment.png',0,''),(2008,'STR_REPRINT_INVOICES',200,8,1,'STR_REPRINT_SPECIFIC_OR_GROUPS_OF_INVOICES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicereprint.php','','',1,'print.png',0,''),(2009,'STR_STATEMENTS',200,9,1,'STR_PRINT_STATEMENTS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicestate.php','','',1,'print.png',0,''),(201,'STR_PAYMENT_PLANS',2,201,0,'STR_CREATE_UPDATE_A_NEW_PAYMENT_PLAN',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arpayplanupd.php','','',1,'picklist.png',0,''),(2011,'STR_NEW_PLAN',201,1,1,'STR_NEW_PAYMENT_PLAN',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arpayplanadd.php','','',1,'add.png',0,''),(2012,'STR_EDIT_PLAN',201,2,1,'STR_UPDATE_EXISTING_PAYMENT_PLAN',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arpayplanupd.php','','',1,'edit.png',0,''),(2013,'STR_POST_PLANS',201,3,1,'STR_POST_PAYMENT_PLANS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arpayplan_post.php','','',1,'process.png',0,''),(2014,'STR_LIST_PLANS',201,4,1,'STR_LIST_PAYMENT_PLANS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arpayplanrep.php','','',1,'list.png',0,''),(202,'STR_PROCESSING',2,202,0,'STR_PROCESSING',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'process.png',0,''),(2021,'STR_MISC_SALES',202,1,1,'STR_ENTER_SALES_RECEIPTS_WHEN_NO_INVOICE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcashpaymentupd.php','','',1,'finance.png',0,''),(2022,'STR_CALCULATE_INTEREST',202,2,1,'STR_CALCULATE_INTEREST_ON_OVERDUE_INVOICES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicecalcint.php','','',1,'calculator.png',0,''),(2023,'STR_IMPORT_DISTRIBUTION',202,3,1,'STR_IMPORT_DISTRIBUTOR_CSV_FILES_FOR_COMMISSIONS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'import_distributor_sales.php','','',1,'import.png',0,''),(2024,'STR_NEW_BANK_DEPOSIT',202,4,1,'STR_CREATE_BANK_DEPOSITS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arbankdepositadd.php','','',1,'add.png',0,''),(2025,'STR_EDIT_BANK_DEPOSIT',202,5,1,'STR_UPDATE_BANK_DEPOSITS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arbankdepositupd.php','','',1,'edit.png',0,''),(203,'STR_REPORTS',2,203,0,'STR_SUMMARY_LISTS_OF_INVOICES_AGING_DETAIL_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'statistics.png',0,''),(2031,'STR_AGING_DETAILS',203,1,1,'STR_AGING_DETAIL_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepaging.php?detail=1','','',1,'list.png',0,''),(2032,'STR_AGING_REPORT',203,2,1,'STR_AGING_SUMMARY_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepaging.php','','',1,'list1.png',0,''),(2033,'STR_CREDIT_CARD_TRANSACTIONS',203,3,1,'STR_CREDIT_CARD_TRANSACTIONS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcctransactions.php','','',1,'creditcard.png',0,''),(2034,'STR_VIEW_CUSTOMER_ACCOUNT',203,4,1,'STR_VIEW_CUSTOMER_ACCOUNT_STATUS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepcust.php','','',1,'customer.png',0,''),(2035,'STR_ACTIVITY_HISTORY',203,5,1,'STR_CUSTOMER_ACTIVITY_HISTORY',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepbalcust_detail.php','','',1,'history.png',0,''),(2036,'STR_BALANCE_HISTORY',203,6,1,'STR_CUSTOMER_BALANCE_HISTORY',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicerepbalcust.php','','',1,'history.png',0,''),(2037,'STR_CUSTOMERS_BY_SALES',203,7,1,'STR_CUSTOMERS_BY_SALES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'topdollar_customers.php','','',1,'list3.png',0,''),(2038,'STR_INACTIVE_CUSTOMERS',203,8,1,'STR_INACTIVE_CUSTOMERS',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcustlistremove.php','','',1,'list2.png',0,''),(2039,'STR_MISC_SALES',203,9,1,'STR_REPORT_OF_SALES_RECEIPTS_WITHOUT_INVOICES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arcashpaymentrep.php','','',1,'list4.png',0,''),(20310,'STR_PAYMENT_REPORTS',203,10,1,'STR_PAYMENTS_RECEIVED_REPORTS_BANK_DEPOSIT_RECONCILIATION',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicereppay.php','','',1,'list.png',0,''),(20311,'STR_RECENT_CUSTOMERS',203,11,1,'STR_RECENTLY_ENTERED_CUSTOMERS_LIST',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'recent_customers.php','','',1,'customer.png',0,''),(20312,'STR_SALES_PROFITABILITY_REPORT',203,12,1,'STR_SALES_PROFITABILITY_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arorder_activity.php','','',1,'statistics.png',0,''),(20313,'STR_SALES_TAX_REPORT',203,13,1,'STR_SALES_TAX_REPORT',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicereptax.php','','',1,'finance.png',0,''),(20314,'STR_SUMMARY_OF_INVOICES',203,14,1,'STR_SUMMARY_LISTS_OF_INVOICES',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicesum.php','','',1,'statistics.png',0,''),(20315,'STR_INVOICES_BY_STATE',203,15,1,'STR_SUMMARY_OF_INVOICES_BY_STATE',0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arinvoicebystate.php','','',1,'statistics.png',0,''),(204,'STR_SETUP_RECEIVABLES',2,204,0,'STR_BASIC_SETUP_FUNCTIONS_FOR_RECEIVABLES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,''),(2041,'STR_BEGINNING_BALANCES',204,1,1,'STR_ENTER_BEGINNING_BALANCE_INVOICES_FOR_STATUP_ONLY',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arinvoiceadd_beginbal.php','','',1,'rma.png',0,''),(2042,'STR_COMPANY_OPTIONS',204,2,1,'STR_COMPANY_LOGO_NAME_ETC',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarcompanyupd.php','','',1,'edit.png',0,''),(2043,'STR_CREDIT_CARD_OPTIONS',204,3,1,'STR_SET_UP_CREDIT_CARD_PROCESSING',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminccsetup.php','','',1,'creditcard.png',0,''),(2044,'STR_CUSTOMER_GROUPS',204,4,1,'STR_CUSTOMER_GROUPS_FOR_INVENTORY_ITEMS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminargroupsupd.php','','',1,'customer.png',0,''),(2045,'STR_CUSTOMER_PAGE_CUSTOMIZER',204,5,1,'STR_CUSTOMER_PAGE_CUSTOMIZER',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'arcustomerpage_define.php','','',1,'customer.png',0,''),(2046,'STR_INVOICE_NOTES',204,6,1,'STR_SELECTABLE_NOTES_FOR_PAGES_FOLLOWING_INVOICE',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'admininvoicenotesupd.php','','',1,'list4.png',0,''),(2047,'STR_INVOICE_TERMS',204,7,1,'STR_ENTER_UPDATE_STANDARD_PAYMENT_TERMS_FOR_INVOICES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarinvtermsupd.php','','',1,'list3.png',0,''),(2048,'STR_QUOTE_COMMENTS',204,8,1,'STR_STANDARD_COMMENTS_TO_USE_ON_QUOTES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarquotecomupd.php','','',1,'notes.png',0,''),(2049,'STR_SALES_CATEGORIES',204,9,1,'STR_SALES_CATEGORIES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarsales_category.php','','',1,'category.png',0,''),(20410,'STR_SALES_PERSONNEL',204,10,1,'STR_ENTER_UPDATE_SALES_PERSONNEL',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarsalesmanupd.php','','',1,'customer.png',0,''),(20411,'STR_SALES_UNIT',204,11,1,'STR_UNIT_NAMES_FOR_ITEMS_SOLD',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'admininvunitnameupd.php','','',1,'payment.png',0,''),(20412,'STR_TAX_EXEMPTIONS',204,12,1,'STR_SALES_TAX_EXEMPTION_REASONS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminartaxexupd.php','','',1,'finance.png',0,''),(20413,'STR_SALES_TAXES',204,13,1,'STR_SALES_TAX_RATES_AND_NAMES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarsalestaxupd.php','','',1,'finance.png',0,''),(20414,'STR_CARRIER_METHODS',204,14,1,'STR_ENTER_UPDATE_CARRIERS_AND_SHIPMENT_METHODS',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarcarrierupd.php','','',1,'ship.png',0,''),(20415,'STR_STANDARD_GL_ACCOUNTS',204,15,1,'STR_ENTER_UPDATE_GL_ACCOUNTS_USED_FOR_RECEIVABLES',0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,'adminarglacct.php','','',1,'list.png',0,''),(3,'STR_INVENTORY',0,3,0,'STR_INVENTORY_ENTRY_UPDATE_REPORTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'inventory_main.png',0,''),(300,'STR_ITEMS',3,300,0,'STR_INVENTORY_ITEM_ENTRY_UPDATE',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'inventory.png',0,''),(3001,'STR_ADD_ITEMS',300,1,1,'STR_ADD_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemadd.php','','',1,'add.png',0,''),(3002,'STR_EDIT_ITEMS',300,2,1,'STR_EDIT_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemupd.php','','',1,'edit.png',0,''),(3003,'STR_ITEM_TRANSFERS',300,3,1,'STR_INVENTORY_ITEM_TRANSFERS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'inventory_transfers.php','','',1,'refresh.png',0,''),(3004,'STR_ITEM_BREAKDOWN',300,4,1,'STR_INVENTORY_ITEM_BREAKDOWN_INTO_SUBCOMPONENTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'inventory_breakdown.php','','',1,'kits.png',0,''),(3005,'STR_ITEM_ADJUSTMENTS',300,5,1,'STR_ADJUST_ITEM_QUANTITIES',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'inventory_adjustments.php','','',1,'refresh.png',0,''),(3006,'STR_ITEM_COST_ADJUSTMENTS',300,6,1,'STR_ITEM_COST_ADJUSTMENTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'inventory_costadjust.php','','',1,'refresh.png',0,''),(3007,'STR_ITEM_SUPPLIERS',300,7,1,'STR_ENTRY_UPDATE_OF_SUPPLIER_INFORMATION_FOR_SPECIFIC_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemvendupd.php','','',1,'ship.png',0,''),(302,'STR_MANAGE_BUILD_ORDERS',3,302,0,'STR_ENTER_UPDATE_COMPONENT_LIST_FOR_BILL_OF_MATERIALS_INVENTORY_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'kits.png',0,''),(3021,'STR_ADD',302,1,1,'STR_ADD_BILL_OF_MATERIALS_INVENTORY_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitembuildorder.php?cmd=main2','','',1,'add.png',0,''),(3022,'STR_EDIT',302,2,1,'STR_ENTER_UPDATE_BILL_OF_MATERIALS_INVENTORY_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitembuildorder.php','','',1,'edit.png',0,''),(3023,'STR_LIST',302,3,1,'STR_LIST_FOR_BILL_OF_MATERIALS_INVENTORY_ITEMS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitembuildorderlist.php','','',1,'list.png',0,''),(3024,'STR_CREATE_PO',302,4,1,'STR_CREATE_PO_FOR_BUILD_ORDERS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitembompo.php','','',1,'purchase.png',0,''),(3025,'STR_EDIT_DEFINITIONS',302,5,1,'STR_ADD_UPDATE_BOM_DEFINITIONS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'bom_entry_or_update.php','','',1,'edit.png',0,''),(3026,'STR_LIST_DEFINITIONS',302,6,1,'STR_LIST_BOM_DEFINITIONS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'bom_list.php','','',1,'list4.png',0,''),(303,'STR_PROCESS',3,303,0,'STR_PHYSICAL_INVENTORY_CREATE_PO',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstphys.php','','',1,'process.png',0,''),(3031,'STR_PHYSICAL_INVENTORY',303,1,1,'STR_PHYSICAL_INVENTORY_ENTRY',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstphys.php','','',1,'confirm.png',0,''),(3032,'STR_ITEM_REORDER_LIST',303,2,1,'STR_ITEM_REORDER_LIST',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstreorder.php','','',1,'report.png',0,''),(304,'STR_REPORTS',3,304,0,'STR_REPORT',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'statistics.png',0,''),(3041,'STR_BOM_LIST',304,1,1,'STR_INVENTORY_ITEM_BILL_OF_MATERIALS_DEFINITION_LIST',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'bom_list.php','','',1,'purchase.png',0,''),(3042,'STR_ITEM_ACTIVITY',304,2,1,'STR_INVENTORY_ITEM_ACTIVITY_LISTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemactivity.php','','',1,'report.png',0,''),(3043,'STR_ITEM_DETAIL_HISTORY',304,3,1,'STR_INVENTORY_ITEM_DETAIL_HISTORY_REPORTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlsthistory.php','','',1,'history.png',0,''),(3044,'STR_ITEM_DISTRIBUTION',304,4,1,'STR_INVENTORY_ITEM_DISTRIBUTION_LIST',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstdist.php','','',1,'ship.png',0,''),(3045,'STR_ITEM_PRICES',304,5,1,'STR_INVENTORY_ITEM_PRICE_ENTRY',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstprice.php','','',1,'finance.png',0,''),(3046,'STR_ITEM_CONVERSIONS',304,6,1,'STR_INVENTORY_ITEM_CONVERSIONS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstconversions.php','','',1,'refresh.png',0,''),(3047,'STR_ITEM_STATUS',304,7,1,'STR_INVENTORY_ITEM_STATUS_REPORT',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlststatus.php','','',1,'report1.png',0,''),(3048,'STR_ITEM_SUMMARIES',304,8,1,'STR_INVENTORY_ITEM_SUMMARY_LISTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstsum.php','','',1,'report2.png',0,''),(3049,'STR_ITEM_USAGE_HISTORY',304,9,1,'STR_INVENTORY_ITEM_USAGE_REPORTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstusage.php','','',1,'report3.png',0,''),(30410,'STR_INVENTORY_VALUATION',304,10,1,'STR_INVENTORY_VALUATION_REPORT',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstval.php','','',1,'payment.png',0,''),(30411,'STR_ITEM_VENDOR_LIST',304,11,1,'STR_INVENTORY_ITEM_VENDORS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstvendor.php','','',1,'payables.png',0,''),(30412,'STR_ITEM_VENDOR_PRICES',304,12,1,'STR_INVENTORY_ITEM_VENDOR_PRICES',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstvendorprice.php','','',1,'finance.png',0,''),(30413,'STR_NOTIFICATION_REQUESTS',304,13,1,'STR_NOTIFICATION_REQUESTS',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invnotifications.php','','',1,'list.png',0,''),(30414,'STR_INCOMPLETE_ITEMS',304,14,1,'STR_ITEMS_WITH_EITHER_NO_COST_OR_NO_SUPPLIER',0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemlstcost.php','','',1,'list.png',0,''),(305,'STR_SETUP_FUNCTIONS_FOR_INVENTORY',3,305,0,'STR_ENTER_UNITS_LOCATIONS_CATEGORIES_ETC',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,''),(30515,'STR_PLANT_LOCATIONS',305,15,1,'STR_PLANT_LOCATIONS_WHERE_INVENTORY_IS_KEPT',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'admininvlocationupd.php','','',1,'location.png',0,''),(30516,'STR_ITEM_BEGINNING_BALANCES',305,16,1,'STR_ENTER_BEGINNING_ONHAND_FOR_INVENTORY',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'invbeginbal.php','','',1,'beginbal.png',0,''),(30517,'STR_ITEM_CATEGORIES',305,17,1,'STR_ENTER_UPDATE_CATEGORIES_OF_ITEMS',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'invitemcatupd.php','','',1,'category.png',0,''),(30518,'STR_ITEM_OPTION_GROUPS',305,18,1,'STR_ITEM_OPTION_GROUPS_DESC',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'invitemoptiongroup.php','','',1,'category.png',0,''),(30519,'STR_ITEM_PAGE_CUSTOMIZER',305,19,1,'STR_ITEM_PAGE_CUSTOMIZER',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'invitempage_define.php','','',1,'category.png',0,''),(30520,'STR_PRICING_LEVELS',305,20,1,'STR_ENTER_UPDATE_PRICING_LEVELS_FOR_INVENTORY_SALES',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'invlevelupd.php','','',1,'finance.png',0,''),(30521,'STR_SALES_UNIT',305,21,1,'STR_UNITS_OF_MEASURE_FOR_STOCKING_AND_PURCHASING_INVENTORY',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'admininvunitnameupd.php','','',1,'report.png',0,''),(30522,'STR_ITEM_CAT_SEARCH',305,22,1,'STR_ITEM_CAT_SEARCH',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'invitemsearchcat.php','','',1,'search.png',0,''),(30523,'STR_STANDARD_GL_ACCOUNTS',305,23,1,'STR_ENTER_UPDATE_GL_ACCOUNTS_USED_FOR_RECEIVABLES',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'admininvglacct.php','','',1,'list.png',0,''),(30524,'STR_STANDARD_MARKUP',305,24,1,'STR_STANDARD_MARKUP_SETS_FOR_AUTO_MARKING_UP_INVENTORY',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'invmarkupupd.php','','',1,'payment.png',0,''),(30525,'STR_VERIFY_INVENTORY',305,25,1,'STR_VERIFY_AND_CORRECT_ITEM_BALANCES',0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,'inventory_recalcFMLW.php','','',1,'tools.png',0,''),(4,'STR_PAYABLES',0,4,0,'STR_PAYABLES_ENTRY_UPDATE_WRITE_CHECK_REQUESTS_REPORTS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'payables_main.png',0,''),(400,'STR_VENDOR_BILLS',4,400,0,'STR_VENDOR_BILLS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'payables.png',0,''),(4001,'STR_NEW_BILL',400,1,1,'STR_CREATE_A_NEW_VENDOR_BILL',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbilladd.php','','',1,'add.png',0,''),(4002,'STR_EDIT_BILLS',400,2,1,'STR_UPDATE_AN_EXISTING_PAYABLES_BILL',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbillupd.php','','',1,'edit.png',0,''),(4003,'STR_PAYABLES_LISTS',400,3,1,'STR_LISTS_OF_PAYABLES',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbilllist.php','','',1,'list.png',0,''),(401,'STR_CREDITCARD_PURCHASES',4,401,0,'STR_CREDITCARD_PURCHASE_TRACKING',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'creditcard.png',0,''),(4011,'STR_CC_PURCHASES',401,1,1,'STR_ENTER_UPDATE_PURCHASES',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apccpurchaseupd.php','','',1,'process.png',0,''),(4012,'STR_NEW_CC_BILLS',401,2,1,'STR_ASSIGN_WHICH_CC_PURCHASES_ARE_ON_BILL',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apccpurchase2bill.php','','',1,'add.png',0,''),(4013,'STR_EDIT_CC_BILLS',401,3,1,'STR_EDIT_CC_BILLS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apccpurchase2billupd.php','','',1,'edit.png',0,''),(4014,'STR_LIST_CC_PURCHASES',401,4,1,'STR_LIST_CC_PURCHASES',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apccpurchaselist.php','','',1,'list.png',0,''),(4015,'STR_CC_CARDS',401,5,1,'STR_ENTER_UPDATE_CC_CARDS',0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'adminapccvendorupd.php','','',1,'creditcard.png',0,''),(4016,'STR_CHARGE_TYPES',401,6,1,'STR_CC_CHARGE_TYPES',0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'adminapcctypeupd.php','','',1,'tools.png',0,''),(4017,'STR_GENERAL',401,7,1,'STR_CC_GENERAL',0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'adminapccgen.php','','',1,'tools.png',0,''),(402,'STR_CHECKS',4,402,0,'STR_WRITE_CHECKS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apmanualcheck.php','','',1,'checkingacct.png',0,''),(4021,'STR_MANUAL_CHECKS',402,1,1,'STR_WRITE_CHECKS_MANUALLY_WITHOUT_FIRST_ENTERING_BILL',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apmanualcheck.php','','',1,'check.png',0,''),(4022,'STR_WRITE_CHECKS',402,2,1,'STR_WRITE_CHECKS_FOR_SPECIFIC_BILLS_OR_MAKE_PARTIAL_PAYMENTS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbillpay.php','','',1,'checkingacct.png',0,''),(4023,'STR_LIST_OF_CHECKS',402,3,1,'STR_LISTS_OF_CHECKS_WRITTEN',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apchecklist.php','','',1,'list.png',0,''),(4024,'STR_VIEW_CANCEL_CHECKS',402,4,1,'STR_VIEW_CANCEL_PAYABLES_CHECKS_WRITTEN',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apchecking.php','','',1,'void.png',0,''),(4025,'STR_COMMISSION_CHECKS',402,5,1,'STR_WRITE_COMMISSION_CHECKS_FROM_DISTRIBUTOR_SALES_OR_VIEW_REPORT',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'distributor_commissionreport.php','','',1,'commission.png',0,''),(403,'STR_PURCHASING',4,403,0,'STR_PURCHASE_ORDER_ENTRY_UPDATE_PRINT_POS_RECEIVE_GOODS_REPORTS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'purchase.png',0,''),(4031,'STR_NEW_PURCHASE_ORDER',403,1,1,'STR_CREATE_A_NEW_PURCHASE_ORDER',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invpoadd.php','','',1,'add.png',0,''),(4032,'STR_EDIT_PO',403,2,1,'STR_UPDATE_AN_EXISTING_PURCHASE_ORDER',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invpoupd.php','','',1,'edit.png',0,''),(4033,'STR_COMPLETED_PO_TO_AP',403,3,1,'STR_PASS_COMPLETED_PURCHASE_ORDER_INFORMATION_INTO_PAYABLES_MATCH_TO_BILLS_RECEIVED',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invpotoap.php','','',1,'process.png',0,''),(4034,'STR_RECEIVE_ITEMS_ON_PO',403,4,1,'STR_RECEIVE_ITEMS_INTO_INVENTORY_FOR_WHICH_PURCHASE_ORDER_WAS_CREATED',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invporecv.php','','',1,'receive.png',0,''),(4035,'STR_RECEIVE_WITHOUT_PO',403,5,1,'STR_RECEIVE_ITEMS_INTO_INVENTORY_THAT_DID_NOT_HAVE_A_PURCHASE_ORDER_CREATED',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemrecadd.php','','',1,'receive.png',0,''),(4036,'STR_LIST_ITEMS_RECEIVED',403,6,1,'STR_LIST_ITEMS_RECEIVED_INTO_INVENTORY',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemreclist.php','','',1,'list4.png',0,''),(4037,'STR_PO_LISTS',403,7,1,'STR_PRINT_LISTS_OF_PURCHASE_ORDERS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invpolist.php','','',1,'list.png',0,''),(4038,'STR_ITEM_SUPPLIERS',403,8,1,'STR_ENTRY_UPDATE_OF_SUPPLIER_INFORMATION_FOR_SPECIFIC_ITEMS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'invitemvendupd.php','','',1,'ship.png',0,''),(405,'STR_VENDORS',4,405,0,'STR_VENDOR_ENTRY_UPDATE_REPORTS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'vendors.png',0,''),(4051,'STR_NEW_VENDOR',405,1,1,'STR_ENTER_NEW_VENDOR_DATA',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apvendadd.php','','',1,'add.png',0,''),(4052,'STR_EDIT_VENDOR',405,2,1,'STR_UPDATE_VENDOR_DATA',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apvendupd.php','','',1,'edit.png',0,''),(4053,'STR_VENDOR_LISTS_LABELS',405,3,1,'STR_PRINT_LISTS_OR_LABELS_OF_VENDORS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apvendlist.php','','',1,'list.png',0,''),(4054,'STR_VENDOR_B2B_LOGIN_USERS',405,4,1,'STR_ADD_LISTS_OF_B2B_VENDOR_USERS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arvendb2buser.php?ap=1','','',1,'b2buser.png',0,''),(406,'STR_REPORTS',4,406,0,'STR_REPORTS',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'statistics.png',0,''),(4061,'STR_DETAIL_AGING',406,1,1,'STR_PAYABLES_DETAIL_AGING_REPORT',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbilllistaging.php?detail=1','','',1,'report1.png',0,''),(4062,'STR_DISCOUNT_AGING',406,2,1,'STR_PAYABLES_DISCOUNT_AGING_REPORT',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbilllistdiscaging.php','','',1,'report2.png',0,''),(4063,'STR_SUMMARY_AGING',406,3,1,'STR_PAYABLES_SUMMARY_AGING_REPORT',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apbilllistaging.php','','',1,'report.png',0,''),(4064,'STR_CASH_REQUIREMENTS',406,4,1,'STR_CASH_REQUIREMENTS_REPORT',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apcashrequirements.php','','',1,'payment.png',0,''),(4065,'STR_LISTS_OF_CHECKS',406,5,1,'STR_LISTS_OF_CHECKS_WRITTEN',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'apchecklist.php','','',1,'checkingacct.png',0,''),(407,'STR_SETUP_FUNCTIONS_FOR_PAYABLES',4,407,0,'STR_ENTER_UPDATE_VENDOR_TERMS_CHECKING_ACCOUNT_INFO_GL_ACCOUNTS_FOR_TIE_INS',0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,''),(4071,'STR_BEGIN_BILLS',407,1,1,'STR_ENTER_BEGINNING_BALANCE_VENDOR_BILLS',0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'apbilladd_beginbal.php','','',1,'beginbal.png',0,''),(4072,'STR_CHECKING_ACCOUNTS',407,2,1,'STR_ENTER_UPDATE_PAYMENT_OR_CHECKING_ACCOUNTS_USED_FOR_PAYABLES',0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'adminapchkacctupd.php','','',1,'checkingacct.png',0,''),(4073,'STR_PO_NOTES',407,3,1,'STR_ENTER_STANDARD_NOTES_TO_BE_SELECTED_FOR_PRINT_ON_PAGES_FOLLOWING_MAIN_PO',0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'admininvponotesupd.php','','',1,'notes.png',0,''),(4074,'STR_VENDOR_PAGE_CUSTOMIZER',407,4,1,'STR_VENDOR_PAGE_CUSTOMIZER',0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'apvendorpage_define.php','','',1,'category.png',0,''),(4075,'STR_STANDARD_GL_ACCOUNTS',407,5,1,'STR_ENTER_UPDATE_STANDARD_GL_ACCOUNTS_USED_BY_PAYABLES',0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'adminapglacct.php','','',1,'list.png',0,''),(4076,'STR_SHIPPING_SETUP',407,6,1,'STR_ENTER_UPDATE_CARRIERS_AND_SHIPMENT_METHODS',0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'adminarcarrierupd.php','','',1,'ship.png',0,''),(4077,'STR_VENDOR_TERMS',407,7,1,'STR_ENTER_UPDATE_STANDARD_TERMS_EXTENDED_BY_VENDORS_FOR_PAYMENT_OF_INVOICES',0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'adminappaytermsupd.php','','',1,'report.png',0,''),(4078,'STR_VENDOR_TYPES',407,8,1,'STR_ENTER_UPDATE_TYPES_OF_VENDORS',0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,'adminapvendortype.php','','',1,'report.png',0,''),(5,'STR_PAYROLL',0,5,0,'STR_EMPLOYEE_ENTRY_UPDATE_WRITE_CHECKS_REPORTS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'payroll_main.png',0,''),(500,'STR_EMPLOYEES',5,500,0,'STR_ADD_UPDATE_EMPLOYEE_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'premployeeupd.php','','',1,'customer.png',0,''),(5001,'STR_NEW_EMPLOYEE',500,1,1,'STR_ADD_EMPLOYEE_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'premployeeadd.php','','',1,'add.png',0,''),(5002,'STR_EDIT_EMPLOYEE',500,2,1,'STR_UPDATE_EMPLOYEE_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'premployeeupd.php','','',1,'edit.png',0,''),(5003,'STR_EMPLOYEE_DEDUCTIONS',500,3,1,'STR_REGULAR_DEDUCTIONS_TO_BE_TAKEN_FROM_EMPLOYEE_PAY',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'premplded.php','','',1,'void.png',0,''),(5004,'STR_WRITE_EMPLOYEE_REVIEW',500,4,1,'STR_WRITE_AN_EMPLOYEE_PERFORMANCE_REVIEW',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'premplreviewupd.php','','',1,'confirm.png',0,''),(5005,'STR_NAME_ADDRESS_PHONE',500,5,1,'STR_LIST_OF_EMPLOYEES_WITH_NAME_AND_ADDRESS_AND_PHONE',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=nap','','',1,'list.png',0,''),(5006,'STR_BIRTHDAYS',500,6,1,'STR_LIST_OF_EMPLOYEE_BIRTHDAYS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=bday','','',1,'list1.png',0,''),(5007,'STR_GENERAL_INFO',500,7,1,'STR_LIST_OF_EMPLOYEE_GENERAL_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=gen','','',1,'list3.png',0,''),(5008,'STR_PHONE_LIST',500,8,1,'STR_LIST_OF_EMPLOYEE_PHONE_NUMBERS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=phone','','',1,'list2.png',0,''),(5009,'STR_SENIORITY',500,9,1,'STR_LIST_OF_EMPLOYEE_SENIORITY',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=sen','','',1,'list4.png',0,''),(501,'STR_CALCULATE_AND_CHECKS',5,501,0,'STR_LOG_HOURS_CALCULATE_ALL_PAY_AND_TAXES_FOR_PERIOD',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prcalchours.php','','',1,'process.png',0,''),(5011,'STR_LOG_HOURS',501,1,1,'STR_ENTER_HOURS_WORKED_AND_MISC_PAY_DEDUCTIONS_FOR_EMPLOYEES',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prloghours.php','','',1,'time.png',0,''),(5012,'STR_CALCULATE',501,2,1,'STR_CALCULATE_ALL_PAY_AND_TAXES_FOR_PERIOD',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prcalchours.php','','',1,'calculator.png',0,''),(5013,'STR_EMPLOYEE_PAY_DED',501,3,1,'STR_ADD_UPDATE_EMPLOYEE_PAY_AND_DEDUCTION_INFORMATION',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'premplweekupd.php','','',1,'payment.png',0,''),(5014,'STR_WRITE_CHECKS',501,4,1,'STR_WRITE_PAYROLL_CHECKS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prcheckwrite.php','','',1,'checkingacct.png',0,''),(5015,'STR_CHECK_SUMMARY',501,5,1,'STR_PAYROLL_CHECK_SUMMARY_FOR_ONE_PAY_PERIOD',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prchecksum.php','','',1,'report.png',0,''),(502,'STR_PERIODIC_REPORTS',5,502,0,'STR_QUARTERLY_AND_ANNUAL_REPORTS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'pr941.php','','',1,'file_chart.png',0,''),(5021,'STR_941S',502,1,1,'STR_PRINT_941_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'pr941.php','','',1,'report.png',0,''),(5022,'STR_W2S',502,2,1,'STR_PRINT_W2_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prw2.php','','',1,'report2.png',0,''),(503,'STR_REPORTS',5,503,0,'STR_REPORTS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'statistics.png',0,''),(5031,'STR_CHECK_SUMMARY',503,1,1,'STR_PAYROLL_CHECK_SUMMARY_FOR_ONE_PAY_PERIOD',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prchecksum.php','','',1,'check.png',0,''),(5032,'STR_PAY_HISTORY',503,2,1,'STR_PAY_HISTORY',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prchecksumgroup.php','','',1,'payment.png',0,''),(5033,'STR_WORKMANS_COMP',503,3,1,'STR_WORKMANS_COMP_REPORT',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prworkmanscomp.php','','',1,'workcomp.png',0,''),(5034,'STR_DIRECT_DEPOSITS',503,4,1,'STR_VIEW_AND_DOWNLOAD_DIRECT_DEPOSIT_FILES',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminachreport.php','','',1,'process.png',0,''),(5035,'STR_NAME_ADDRESS_PHONE',503,5,1,'STR_LIST_OF_EMPLOYEES_WITH_NAME_AND_ADDRESS_AND_PHONE',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=nap','','',1,'list.png',0,''),(5036,'STR_BIRTHDAYS',503,6,1,'STR_LIST_OF_EMPLOYEE_BIRTHDAYS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=bday','','',1,'list1.png',0,''),(5037,'STR_GENERAL_INFO',503,7,1,'STR_LIST_OF_EMPLOYEE_GENERAL_INFORMATION',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=gen','','',1,'list3.png',0,''),(5038,'STR_PHONE_LIST',503,8,1,'STR_LIST_OF_EMPLOYEE_PHONE_NUMBERS',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=phone','','',1,'list2.png',0,''),(5039,'STR_PAY_BY_WEEK',503,9,1,'STR_LIST_OF_EMPLOYEE_PAY_BY_WEEK',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=hpw','','',1,'report1.png',0,''),(50310,'STR_PAY_BY_MONTH',503,10,1,'STR_LIST_OF_EMPLOYEE_PAY_BY_MONTH',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=hpm','','',1,'report2.png',0,''),(50311,'STR_PAY_BY_QUARTER',503,11,1,'STR_LIST_OF_EMPLOYEE_PAY_BY_QUARTER',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=hpq','','',1,'report4.png',0,''),(50312,'STR_SENIORITY',503,12,1,'STR_LIST_OF_EMPLOYEE_SENIORITY',0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'prempllist.php?types=sen','','',1,'list4.png',0,''),(504,'STR_SETUP_FUNCTIONS_FOR_PAYROLL',5,504,0,'STR_ENTER_UPDATE_TAXES_DEDUCTIONS_PENSION_PLANS_ETC',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,''),(5041,'STR_CHECKING_ACCOUNTS',504,1,1,'STR_ENTER_UPDATE_CHECKING_ACCOUNTS_USED_FOR_PAYROLL',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminapchkacctupd.php','','',1,'checkingacct.png',0,''),(5042,'STR_COMPANY_CONTRIBUTIONS',504,2,1,'STR_AMOUNTS_PAID_BY_EMPLOYER',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminprcon.php','','',1,'refresh.png',0,''),(5043,'STR_DEDUCTION_GROUPS',504,3,1,'STR_PAYROLL_DEDUCTION_GROUPS',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminprdedgroupupd.php','','',1,'category.png',0,''),(5044,'STR_DIRECT_DEPOSIT_AUTH',504,4,1,'STR_DIRECTION_DEPOSIT_AUTHORIZATION_FORM',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'directdepform.php','','',1,'process.png',0,''),(5045,'STR_GENERAL_BENEFITS_PAY',504,5,1,'STR_BENEFITS_PAY_FOR_GROUP',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminprben.php','','',1,'finance.png',0,''),(5046,'STR_GENERAL_DEDUCTIONS',504,6,1,'STR_DEDUCTION_FOR_GROUP',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminprded.php','','',1,'payment.png',0,''),(5047,'STR_GENERAL_FACTORS',504,7,1,'STR_GENERAL_PAYROLL_INFORMATION',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminprgendat.php','','',1,'report.png',0,''),(5048,'STR_PAY_TYPES',504,8,1,'STR_PAYROLL_PAY_TYPES',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminprpaytypeupd.php','','',1,'finance.png',0,''),(5049,'STR_PENSION_PLANS',504,9,1,'STR_ENTER_UPDATE_PENSION_HEALTH_OTHER_PLAN',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminprpens.php','','',1,'pension.png',0,''),(50410,'STR_RATING_SCALE_FOR_REVIEWS',504,10,1,'STR_SET_UP_RATING_SCALE',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminpremplreviewratingupd.php','','',1,'notes.png',0,''),(50411,'STR_STANDARD_GL_ACCOUNTS',504,11,1,'STR_ENTER_UPDATE_STANDARD_GL_ACCOUNTS_USED_BY_PAYROLL',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminprglacct.php','','',1,'list.png',0,''),(505,'STR_TAX_TABLES',5,505,0,'STR_ENTER_UPDATE_TAXES_TABLES',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'','','',1,'picklist.png',0,''),(5051,'STR_ENTER_UPDATE_TAX_TABLES',505,1,1,'STR_ENTER_UPDATE_TAX_TABLE_INFORMATION',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminprtaxtypedtl.php','','',1,'picklist.png',0,''),(5052,'STR_ADD_NEW_TAXES',505,2,1,'STR_ADD_NEW_PAYROLL_TAX_DISTRICT',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminprtaxtypeadd.php','','',1,'add.png',0,''),(5053,'STR_VIEW_UPDATE_TAX',505,3,1,'STR_VIEW_OR_CHANGE_PAYROLL_TAX_DISTRICTS',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'adminprtaxtypeupd.php','','',1,'edit.png',0,''),(5054,'STR_START_NEW_YEAR',505,4,1,'STR_START_NEW_YEAR_FOR_TAXES',0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,'copytax.php','','',1,'edit.png',0,''),(6,'STR_LEDGER',0,6,0,'STR_JOURNAL_ENTRY_BALANCE_SHEET',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'ledger_main.png',0,''),(600,'STR_CHART_OF_ACCOUNTS',6,600,0,'STR_EDIT_GENERAL_LEDGER_CHART_OF_ACCOUNTS_LIST',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glacctupd.php','','',1,'list.png',0,''),(6001,'STR_NEW_GL_ACCOUNTS',600,1,1,'STR_EDIT_GENERAL_LEDGER_CHART_OF_ACCOUNTS_LIST',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glacctadd.php','','',1,'add.png',0,''),(6002,'STR_EDIT_CHART_OF_ACCOUNTS',600,2,1,'STR_EDIT_GENERAL_LEDGER_CHART_OF_ACCOUNTS_LIST',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glacctupd.php','','',1,'edit.png',0,''),(6003,'STR_CHART_OF_ACCOUNTS_LIST',600,3,1,'STR_PRINT_GENERAL_LEDGER_CHART_OF_ACCOUNTS_LIST',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glacctlst.php','','',1,'list2.png',0,''),(6004,'STR_ASSIGN_SUMMARIZATION',600,4,1,'STR_ASSIGN_SUMMARIZATION',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glacct_assign.php','','',1,'list3.png',0,''),(601,'STR_BUDGETS',6,601,0,'STR_BUDGETS',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'budget.png',0,''),(6011,'STR_ADD_UPDATE_BUDGETS',601,1,1,'STR_ENTER_UPDATE_GENERAL_LEDGER_BUDGETS',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glbudadd.php','','',1,'edit.png',0,''),(6012,'STR_BUDGET_LIST',601,2,1,'STR_PRINT_GENERAL_LEDGER_BUDGET_LIST',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glbudlst.php','','',1,'list.png',0,''),(6013,'STR_BUDGET_VARIANCE',601,3,1,'STR_GENERAL_LEDGER_BUDGET_VARIANCE_REPORT',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepbudvariance.php','','',1,'statistics.png',0,''),(602,'STR_JOURNAL_ENTRIES',6,602,0,'STR_CREATE_AND_EDIT_GENERAL_LEDGER_JOURNAL_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljourupd.php','','',1,'notes.png',0,''),(6021,'STR_NEW_JOURNAL_ENTRIES',602,1,0,'STR_CREATE_AND_EDIT_GENERAL_LEDGER_JOURNAL_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljouradd.php','','',1,'add.png',0,''),(6022,'STR_EDIT_JOURNAL_ENTRIES',602,2,0,'STR_EDIT_GENERAL_LEDGER_JOURNAL_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljourupd.php','','',1,'edit.png',0,''),(6023,'STR_POST_JOURNALS_NOW',602,3,1,'STR_GENERAL_LEDGER_POST_JOURNALS_FROM_ANY_SOURCE',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glpostadd.php','','',1,'process.png',0,''),(6024,'STR_REVERSE_JOURNAL_POSTINGS',602,4,1,'STR_REVERSE_GENERAL_LEDGER_POST_ACTION',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glpostupd.php','','',1,'receive.png',0,''),(6025,'STR_JOURNAL_REPORTS',602,5,1,'STR_GENERAL_LEDGER_JOURNAL_REPORTS',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepjournal.php','','',1,'report.png',0,''),(6026,'STR_UNBALANCED',602,6,1,'STR_UNBALANCED_JOURNAL_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepjournal_unbalanced.php','','',1,'report2.png',0,''),(603,'STR_RECURRING_LEDGER_ENTRIES',6,603,0,'STR_RECURRING_LEDGER_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'refresh.png',0,''),(6031,'STR_NEW_RECURRING_ENTRIES',603,1,1,'STR_ENTER_RECURRING_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljour_std_add.php','','',1,'add.png',0,''),(6032,'STR_EDIT_RECURRING_ENTRIES',603,2,1,'STR_UPDATE_RECURRING_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljour_std_upd.php','','',1,'edit.png',0,''),(6033,'STR_POST_RECURRING_ENTRIES',603,3,1,'STR_POST_RECURRING_LEDGER_ENTRIES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gljour_std_post.php','','',1,'process.png',0,''),(604,'STR_BANK_RECONCILIATION',6,604,1,'STR_BANK_RECONCILIATION_WORKSHEET',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arbankreconcile.php','','',1,'report.png',0,''),(6044,'STR_BANK_RECONCILIATION',604,4,1,'STR_BANK_RECONCILIATION_WORKSHEET',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'arbankreconcile.php','','',1,'report.png',0,''),(605,'STR_REPORTS',6,605,0,'STR_REPORTS',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'statistics.png',0,''),(6051,'STR_ACCOUNT_ACTIVITY',605,1,1,'STR_GENERAL_LEDGER_ACCOUNT_ACTIVITY_REPORT',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepactivity.php','','',1,'report.png',0,''),(6052,'STR_BALANCE_SHEET',605,2,1,'STR_CREATE_A_BALANCE_SHEET',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepbalance.php','','',1,'report4.png',0,''),(6053,'STR_STANDARD_BALANCE_SHEET',605,3,1,'STR_CREATE_A_BALANCE_SHEET_IN_DEBIT_CREDIT_FORMAT',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepbalance_summary.php','','',1,'report2.png',0,''),(6054,'STR_DAILY_REPORT',605,4,1,'STR_DAILY_REPORT_OF_BALANCES',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepdaily.php','','',1,'time.png',0,''),(6055,'STR_DETAILED_TRIAL_BALANCE',605,5,1,'STR_CREATE_A_DETAILED_TRIAL_BALANCE_SHEET',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepbalance_detail.php','','',1,'report1.png',0,''),(6056,'STR_CHART_OF_ACCOUNTS_LIST',605,6,1,'STR_PRINT_GENERAL_LEDGER_CHART_OF_ACCOUNTS_LIST',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glacctlst.php','','',1,'list.png',0,''),(6057,'STR_JOURNAL_REPORTS',605,7,1,'STR_GENERAL_LEDGER_JOURNAL_REPORTS',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepjournal.php','','',1,'report3.png',0,''),(6058,'STR_MY_PIE_CHARTS',605,8,1,'STR_MY_PIE_CHARTS_DESC',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glpieadd.php','','',1,'file_chart.png',0,''),(6059,'STR_PROFIT_AND_LOSS_STATEMENT',605,9,1,'STR_PRINT_A_PROFIT_AND_LOSS_STATEMENT',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepincome.php','','',1,'refresh.png',0,''),(60510,'STR_12_MONTH_P_AND_L',605,10,1,'STR_PRINT_A_12_MONTH_PROFIT_AND_LOSS_STATEMENT',0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'glrepincome_12month.php','','',1,'refresh.png',0,''),(606,'STR_SETUP_FUNCTIONS_FOR_GL',6,606,0,'STR_SET_THE_FISCAL_YEAR',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,''),(6061,'STR_ACCOUNT_TYPES',606,1,1,'STR_CHANGE_THE_NAMES_USED_FOR_ACCOUNT_TYPES',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,'adminglaccttypeupd.php','','',1,'list2.png',0,''),(6062,'STR_CLOSE_YEAR',606,2,1,'STR_CLOSE_YEAR',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,'glclose_year.php','','',1,'complete.png',0,''),(6063,'STR_IMPORT_ACCOUNTS',606,3,1,'STR_IMPORT_GENERAL_LEDGER_ACCOUNTS_LIST',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,'gl_admin_import.php','','',1,'import.png',0,''),(6064,'STR_GL_COST_CENTERS',606,4,1,'STR_ADD_EDIT_GENERAL_LEDGER_COST_CENTERS',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,'glcost_centerupd.php','','',1,'category.png',0,''),(6065,'STR_GL_SUMMARY_LEVELS',606,5,1,'STR_ADD_EDIT_SUMMARY_LEVEL_DESCRIPTIONS',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,'gl_sumlevelupd.php','','',1,'beginbal.png',0,''),(6066,'STR_EXPORT_ACCOUNTS',606,6,1,'STR_EXPORT_GENERAL_LEDGER_ACCOUNTS_LIST',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,'gl_admin_export.php','','',1,'process.png',0,''),(6067,'STR_SET_FISCAL_START_MONTH',606,7,1,'STR_CHANGE_YOUR_COMPANY_FISCAL_YEAR_BEGIN',0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,'adminglcompanyupd.php','','',1,'calendar.png',0,''),(7,'STR_ADMIN',0,7,0,'STR_ADMINISTRATION_TOOLS_USER_RIGHTS',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'','','',1,'admin_main.png',0,''),(700,'STR_MY_INFO',7,700,0,'STR_MY_INFO',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'','','',1,'customer.png',0,''),(7001,'STR_MY_INFO',700,1,1,'STR_MY_INFO',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'myuser.php','','',1,'edit.png',0,''),(7002,'STR_MESSAGES',700,2,1,'STR_MESSAGES',1,1,1,1,1,0,1,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,'adminmessages.php','','',1,'notes.png',0,''),(701,'STR_REPORTS',7,701,0,'STR_REPORTS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'list.png',0,''),(7011,'STR_NOLAPRO_ACTIVITY',701,1,1,'STR_NOLAPRO_ACTIVITY',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminactivitymonitor.php','','',1,'list2.png',0,''),(7012,'STR_DATABASE_EXPLANATION',701,2,1,'STR_DATABASE_EXPLANATION',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'list_db_explanation.php','','',1,'history.png',0,''),(7013,'STR_SURVEYS',701,3,1,'STR_SURVEYS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminsurveyreport.php','','',1,'list3.png',0,''),(702,'STR_IMPORTS',7,702,0,'STR_IMPORTS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'importcustomer.php','','',1,'import.png',0,''),(7021,'STR_NOLAPRO_UPDATE',702,1,1,'STR_NOLAPRO_UPDATE',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'http://www.nolapro.com/index-6.html','','',1,'refresh.png',0,''),(7022,'STR_IMPORT_CUSTOMERS',702,2,1,'STR_IMPORT_CUSTOMER_LIST_INTO_NOLAPRO',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'importcustomer.php','','',1,'customer.png',0,''),(7023,'STR_IMPORT_EMPLOYEES',702,3,1,'STR_IMPORT_EMPLOYEES_INTO_NOLAPRO',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'importemployee.php','','',1,'customer.png',0,''),(7024,'STR_IMPORT_GL_TOTALS',702,4,1,'STR_IMPORT_GL_TOTALS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'importgltotals.php','','',1,'list.png',0,''),(7025,'STR_IMPORT_INVENTORY_CATEGORIES',702,5,1,'STR_IMPORT_INVENTORY_CATEGORIES_FROM_CSV_FILE',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'importitem_categories.php','','',1,'inventory.png',0,''),(7026,'STR_IMPORT_INVENTORY_ITEMS',702,6,1,'STR_IMPORT_INVENTORY_ITEMS_FROM_CSV_FILE',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'importitems.php','','',1,'inventory.png',0,''),(7027,'STR_IMPORT_VENDORS',702,7,1,'STR_IMPORT_VENDOR_LIST_INTO_NOLAPRO',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'importvendor.php','','',1,'vendors.png',0,''),(7028,'STR_QUICKBOOKS',702,8,1,'STR_QUICKBOOKS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'qbimport.php','','',1,'list.png',0,''),(703,'STR_ADMIN_SETUP',7,703,0,'STR_ADMIN_SETUP_TOOLS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'','','',1,'tools.png',0,''),(7031,'STR_ADD_ON_AND_PLUG_IN',703,1,1,'STR_PURCHASE_AND_MANAGE_ADD_ONS_AND_PLUG_INS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'features.php','','',1,'edit.png',0,''),(7032,'STR_API_LOG_VIEWER',703,2,1,'STR_API_LOG_VIEWER',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminapilog.php','','',1,'list.png',0,''),(7033,'STR_B2B_SITE_GRAPHICS',703,3,1,'STR_B2B_SITE_GRAPHICS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminb2bsite.php','','',1,'graphics.png',0,''),(7034,'STR_BRANDING',703,4,1,'STR_ASSIGN_LOGO_FOR_LOGON_PAGE_AND_FOOTERS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminbing.php','','',1,'edit.png',0,''),(7035,'STR_COMPANY_ADD_UPDATE',703,5,1,'STR_ENTER_UPDATE_COMPANIES_COVERED_BY_SYSTEM',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'gencompanyupd.php','','',1,'location.png',0,''),(7036,'STR_CUSTOM_FIELDS_EDITOR',703,6,1,'STR_CUSTOM_FIELDS_EDITOR',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminflexfields.php','','',1,'data_web.png',0,''),(7037,'STR_DATABASE_INFORMATION',703,7,1,'STR_DATABASE_INFORMATION',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminserversetup.php','','',1,'purchase.png',0,''),(7038,'STR_EMAIL_CENTER',703,8,1,'STR_EMAIL_CENTER_DESC',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminemail.php','','',1,'mail.png',0,''),(7039,'STR_HOMEPAGE_CACHING',703,9,1,'STR_HOMEPAGE_REPORT_CACHING',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminreportcache.php','','',1,'list.png',0,''),(70310,'STR_IP_ACCESS_MANAGER',703,10,1,'STR_IP_ACCESS_MANAGER',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminipaccessmanager.php','','',1,'location.png',0,''),(70311,'STR_LANGUAGE_EDITOR',703,11,1,'STR_MODIFY_DISPLAY_TEXT',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'translation.php','','',1,'font.png',0,''),(70312,'STR_LINK_ADD_UPDATE',703,12,1,'STR_LINK_ADD_UPDATE_TEXT',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'link_addupdate.php','','',1,'link.png',0,''),(70313,'STR_MESSAGE_CATEGORIES',703,13,1,'STR_MESSAGE_CATEGORIES',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'admingraphic_category.php','','',1,'color.png',0,''),(70314,'STR_MESSAGE_GRAPHICS',703,14,1,'STR_MESSAGE_GRAPHICS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'admingraphic.php','','',1,'color.png',0,''),(70315,'STR_OSCOMMERCE_INTEGRATION',703,15,1,'STR_OSCOMMERCE_INTEGRATION',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminosccompanyupd.php','','',1,'edit.png',0,''),(70316,'STR_STATE_ADD_UPDATE',703,16,1,'STR_STATE_ADD_UPDATE_TEXT',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'state_addupdate.php','','',1,'data_web.png',0,''),(70317,'STR_SURVEY_MANAGER',703,17,1,'STR_SURVEY_MANAGER',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminsurvey.php','','',1,'list3.png',0,''),(70318,'STR_SYSTEM_SETTINGS',703,18,1,'STR_SYSTEM_SETTINGS',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminsystemsettings.php','','',1,'edit.png',0,''),(70319,'STR_USER_ADD_UPDATE',703,19,1,'STR_ENTER_UPDATE_USER_LIST',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,'genuserupd.php','','',1,'customer.png',0,''),(8,'STR_SHOPPING',0,8,0,'STR_SHOPPING_CART_AND_ADMINISTRATION_OF_CART_PREFERENCES',0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,1,0,'','','',1,'shopping_main.png',0,''),(800,'STR_SHOPPING_CART',8,800,0,'STR_SHOPPING_CART',0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,1,0,'oscatalog/default.php','','',1,'shopcart.png',0,''),(8001,'STR_GO_SHOPPING',800,1,1,'STR_GO_TO_SHOPPING_CART',0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,1,0,'oscatalog/default.php','','',1,'next.png',0,''),(8002,'STR_ADMINISTRATION',800,2,1,'STR_SET_PREFERENCES',0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,'osadmin/default.php','','',1,'tools.png',0,''),(8003,'STR_FREE_SHIPPING_OPTIONS',800,3,1,'STR_FREE_SHIPPING_OPTIONS',0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,'adminscartfreeship.php','','',1,'tools.png',0,'');
/*!40000 ALTER TABLE `menudataxp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menufunction`
--

DROP TABLE IF EXISTS `menufunction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menufunction` (
  `id` int(11) NOT NULL auto_increment,
  `menucategoryid` int(11) NOT NULL default '0',
  `name` char(50) NOT NULL default '',
  `leftimageurl` char(50) default NULL,
  `rightimageurl` char(50) default NULL,
  `link` char(50) NOT NULL default '',
  `orderflag` int(11) NOT NULL default '0',
  `accessap` int(11) NOT NULL default '0',
  `accessar` int(11) NOT NULL default '0',
  `accessgl` int(11) NOT NULL default '0',
  `accesspay` int(11) NOT NULL default '0',
  `accessinv` int(11) NOT NULL default '0',
  `accessest` int(11) NOT NULL default '0',
  `accessfix` int(11) NOT NULL default '0',
  `accessimp` int(11) NOT NULL default '0',
  `setupap` int(11) NOT NULL default '0',
  `setupar` int(11) NOT NULL default '0',
  `setupgl` int(11) NOT NULL default '0',
  `setuppay` int(11) NOT NULL default '0',
  `setupinv` int(11) NOT NULL default '0',
  `setupest` int(11) NOT NULL default '0',
  `setupfix` int(11) NOT NULL default '0',
  `setupimp` int(11) NOT NULL default '0',
  `supervisor` int(11) NOT NULL default '0',
  `nonsupervisor` int(11) NOT NULL default '0',
  `extvend` int(11) NOT NULL default '0',
  `extcust` int(11) NOT NULL default '0',
  `nonext` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `menucategoryid` (`menucategoryid`),
  KEY `orderflag` (`orderflag`),
  KEY `accessap` (`accessap`),
  KEY `accessar` (`accessar`),
  KEY `accessgl` (`accessgl`),
  KEY `accesspay` (`accesspay`),
  KEY `accessinv` (`accessinv`),
  KEY `accessest` (`accessest`),
  KEY `accessfix` (`accessfix`),
  KEY `accessimp` (`accessimp`),
  KEY `supervisor` (`supervisor`),
  KEY `nonsupervisor` (`nonsupervisor`),
  KEY `extvend` (`extvend`),
  KEY `extcust` (`extcust`),
  KEY `nonext` (`nonext`)
) ENGINE=InnoDB AUTO_INCREMENT=157 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menufunction`
--

LOCK TABLES `menufunction` WRITE;
/*!40000 ALTER TABLE `menufunction` DISABLE KEYS */;
INSERT INTO `menufunction` VALUES (1,1,'New Order Standard Items','images/menu/orderentry.gif','','arordadd.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(2,1,'View/Change Standard Order','images/menu/orderentry.gif','','arordupd.php',2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(3,1,'New PAR','images/menu/customprint2.gif','','estquoteaddform.php',3,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(4,1,'View/Change PAR','images/menu/customprint2.gif','','estquoteaddsearch.php',4,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(5,1,'New Ad-hoc Print Order','images/menu/customprint.gif','','estquoteadd.php',5,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(6,1,'View/Change Ad-hoc Print Order','images/menu/customprint.gif','','estquoteupd.php',6,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(7,1,'Add/Update Customer','images/menu/personnel.gif','','arcustupd.php',7,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0),(8,1,'List Customers','images/menu/page.gif','','arcustlist.php',8,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(9,1,'Add/Update External Users','images/menu/employees.gif','','arcustextuser.php',9,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0),(10,1,'Setup Functions for Print Management','images/menu/setup.gif','','explain.php?menucategoryid=15',10,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(11,2,'Open Orders','images/menu/page.gif','','arorderlist.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0),(12,2,'Orders Shipped','images/menu/page.gif','','arordershiplst.php',2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0),(13,2,'Open Items on Orders','images/menu/page.gif','','arorderitemlst.php',3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0),(14,2,'Items Shipped','images/menu/page.gif','','arordershipitemlst.php',4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0),(15,2,'Performance Statistics','images/menu/graph2.gif','','arorderstatlst.php',5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0),(16,3,'Check In/Out Orders','images/menu/checkmark.gif','','arorderckout.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(17,3,'Fill Order Start/Stop','images/menu/trafficlight.gif','','arorderfill.php',2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(18,3,'Enter New Shipment','images/menu/qc-ship.gif','','arordshipadd.php',3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(19,3,'View Shipped Orders','images/menu/openorders.gif','','arordshipview.php',4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(20,3,'Order Processing Status','images/menu/graph2.gif','','arorderstatuslst.php',5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(21,4,'Add Invoice','images/menu/invoice.gif','','arinvoiceadd.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(22,4,'Summary of Invoices','images/menu/page.gif','','arinvoicesum.php',3,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(23,4,'View Customer Account','images/menu/rollodex.gif','','arinvoicerepcust.php',4,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(24,4,'Aging Report','images/menu/page.gif','','arinvoicerepaging.php',5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(25,4,'Statements','images/menu/Clipboard__Note.jpg','','arinvoicestate.php',6,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(26,4,'Enter Payments','images/menu/dollar.gif','','arinvoicepay.php',7,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(27,4,'Payment Reports','images/menu/page.gif','','arinvoicereppay.php',8,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(28,4,'Sales Tax Reports','images/menu/page.gif','','arinvoicereptax.php',9,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(29,4,'Setup Functions for Receivables','images/menu/setup.gif','','explain.php?menucategoryid=13',10,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1),(30,5,'Item Maintenance','images/menu/Write0a.gif','','invitemupd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(31,5,'Item Suppliers','images/menu/personnel3.gif','','invitemvendupd.php',2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(32,5,'Item Summaries','images/menu/page.gif','','invitemlstsum.php',3,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(33,5,'Item Prices','images/menu/page.gif','','invitemlstprice.php',4,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(34,5,'Item Status','images/menu/page.gif','','invitemlststatus.php',5,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(35,5,'Item Usage History','images/menu/page.gif','','invitemlstusage.php',6,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(36,5,'BOM List','images/menu/page.gif','','invitemlstcomp.php',7,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(37,5,'Item Distribution','images/menu/page.gif','','invitemlstdist.php',8,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(38,5,'Physical Inventory','images/menu/page.gif','','invitemlstphys.php',9,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(39,5,'Inventory Valuation','images/menu/page.gif','','invitemlstval.php',10,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(40,5,'Setup Functions for Inventory','images/menu/setup.gif','','explain.php?menucategoryid=18',11,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(41,6,'Vendor Maintenance','images/menu/personnel.gif','','apvendupd.php',1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0),(42,6,'Vendor Lists/Labels','images/menu/labels.gif','','apvendlist.php',2,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(43,6,'Add/Update Enternal Vendor Users','images/menu/employees.gif','','apvendextuser.php',3,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0),(44,7,'New Purchase Order','images/menu/statemt.gif','','invpoadd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(45,7,'Update PO','images/menu/statemt.gif','','invpoupd.php',2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(46,7,'Receive Items on PO','images/menu/graphicdesign.gif','','invporecv.php',3,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(47,7,'Completed PO to AP','images/menu/createform.gif','','invpotoap.php',4,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(48,7,'PO Lists','images/menu/page.gif','','invpolist.php',5,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(49,7,'Receive without PO','images/menu/boxin.gif','','invitemrecadd.php',6,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(50,7,'List Items Received','images/menu/page.gif','','invitemreclist.php',7,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(51,8,'New Vendor Bill','images/menu/log.gif','','apbilladd.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(52,8,'View/Change Bills','images/menu/log.gif','','apbillupd.php',2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(53,8,'Write Checks Specific','images/menu/Block3.gif','','apbillpay.php?specific=1',3,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(54,8,'Write Checks by Date','images/menu/Block3.gif','','apbillpay.php',4,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(55,8,'View/Cancel Checks','images/menu/qc.gif','','apchecking.php',5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(56,8,'Lists of Checks','images/menu/page.gif','','apchecklist.php',6,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(57,8,'Payables Lists','images/menu/page.gif','','apbilllist.php',7,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(58,8,'Summary Aging','images/menu/page.gif','','apbilllistaging.php',8,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(59,8,'Detail Aging','images/menu/page.gif','','apbilllistaging.php?detail=1',9,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(60,8,'Discount Aging','images/menu/page.gif','','apbilllistdiscaging.php',10,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(61,8,'Setup Functions for Payables','images/menu/setup.gif','','explain.php?menucategoryid=14',11,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(62,9,'Log Hours','images/menu/clockout.gif','','prloghours.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(63,9,'Calculate/Pay Taxes','images/menu/calculator2.gif','','prcalchours.php',2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(64,9,'Write Checks','images/menu/Block3.gif','','prcheckwrite.php',3,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(65,9,'Check Summary One Period','images/menu/page.gif','','prchecksum.php',4,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(66,9,'Check Summary Multiple Periods','images/menu/page.gif','','prchecksumgroup.php',5,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(67,9,'Add/Update Employees','images/menu/interview.gif','','premployeeupd.php',6,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(68,9,'Employee Deductions','images/menu/interview.gif','','premplded.php',7,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(69,9,'Employee Phone List','images/menu/page.gif','','prempllist.php?type=phone',8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(70,9,'Name/Address/Phone List','images/menu/page.gif','','prempllist.php?type=nap',9,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(71,9,'Birthday List','images/menu/page.gif','','prempllist.php?type=bday',10,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(72,9,'General Info List','images/menu/page.gif','','prempllist.php?type=gen',11,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(73,9,'Employee Pay by Week','images/menu/page.gif','','prempllist.php?type=hpw',12,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(74,9,'Employee Pay by Month','images/menu/page.gif','','prempllist.php?type=hpm',13,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(75,9,'Employee Pay by Quarter','images/menu/page.gif','','prempllist.php?type=hpq',14,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(76,9,'Write Employee Review','images/menu/awards.gif','','premplreviewupd.php',15,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(77,9,'Print 941','images/menu/page.gif','','pr941.php',16,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(78,9,'Print W2s','images/menu/page.gif','','prw2.php',17,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(79,9,'Setup Functions for Payroll','images/menu/setup.gif','','explain.php?menucategoryid=16',16,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(80,10,'New Journal Entries','images/menu/reports.gif','','gljouradd.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(81,10,'Edit Journal Entries','images/menu/reports.gif','','gljourupd.php',2,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(82,10,'Post Journals Now','images/menu/boxin.gif','','glpostadd.php',3,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(83,10,'Reverse Journal Postings','images/menu/boxout.gif','','glpostupd.php',4,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(84,10,'Profit and Loss Statement','images/menu/page.gif','','glrepincome.php',5,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(85,10,'Balance Sheet','images/menu/page.gif','','glrepbalance.php',6,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(86,10,'Account Activity','images/menu/page.gif','','glrepactivity.php',7,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(87,10,'Budget Variance','images/menu/page.gif','','glrepbudvariance.php',8,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(88,10,'Journal Reports','images/menu/page.gif','','glrepjournal.php',9,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(89,10,'My Pie Charts','images/menu/piechart.gif','','glpieadd.php',10,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(90,10,'Edit Chart of Accounts','images/menu/org_chart.gif','','glacctupd.php',11,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(91,10,'Chart of Accounts List','images/menu/page.gif','','glacctlst.php',12,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(92,10,'Add Update Budgets','images/menu/file_cab.gif','','glbudadd.php',13,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(93,10,'Budget List','images/menu/page.gif','','glbudlst.php',14,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(94,10,'Setup Functions for General Ledger','images/menu/setup.gif','','explain.php?menucategoryid=17',15,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0),(95,11,'Users and Rights','images/menu/personnel3.gif','','genuserupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(96,11,'Client Companies','images/menu/Shake0a.gif','','gencompanyupd.php',2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(97,11,'Document Categories','images/menu/signpost.gif','','admindocmgmtcatupd.php',3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(98,11,'Import Customers','images/menu/chainlink.gif','','importcustomer.php',4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(99,12,'User Info and Rights','','','genuserupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0),(100,13,'Company Options','images/menu/Build1.gif','','adminarcompanyupd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(101,13,'Sales Taxes','images/menu/balance.gif','','adminarsalestaxupd.php',2,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(102,13,'Tax Exemption Categories','images/menu/balance.gif','','adminartaxexupd.php',3,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(103,13,'Quote Comment Table','images/menu/Note.jpg','','adminarquotecomupd.php',4,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(104,13,'Sales Personnel','images/menu/employees.gif','','adminarsalesmanupd.php',5,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(105,13,'Invoice Terms','images/menu/terms.gif','','adminarinvtermsupd.php',6,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(106,13,'Standard GL Accounts','images/menu/stdglaccts.gif','','adminarglacct.php',7,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(107,13,'Shipping Carriers/Methods','images/menu/delivery.gif','','adminarcarrierupd.php',8,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(108,13,'Sales Units','images/menu/cone.gif','','admininvunitnameupd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(109,14,'Vendor Terms','images/menu/terms.gif','','adminappaytermsupd.php',1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),(110,14,'Standard GL Accounts','images/menu/stdglaccts.gif','','adminapglacct.php',2,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),(111,14,'Checking Accounts','images/menu/Block3.gif','','adminapchkacctupd.php',3,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),(112,15,'Cost Centers/Machines','images/menu/puzzle.gif','','adminestcostcenterupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(115,15,'Inks Database','images/menu/inks.gif','','adminestquoteinkupd.php',4,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(116,15,'General Ink Info','images/menu/inks.gif','','adminestquotegenink.php',5,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(117,15,'Standard Sizes','images/menu/stdsizes.gif','','adminestquotestdsizeupd.php',6,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(118,15,'Print Stocks','images/menu/writepads.gif','','estquotestockupd.php',7,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(119,15,'Work Types','images/menu/decision.gif','','adminestquoteworktypeupd.php',8,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(120,15,'Add/Update Notes for Quote','images/menu/Note.jpg','','adminestquotequotenotesupd.php',9,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(121,15,'Print Tools Add/Update','images/menu/tolls.gif','','estprpricetoolsupd.php',14,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(122,15,'Print Pricing','images/menu/cashregister.gif','','estprpricelstupd.php',12,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(123,15,'Nonprint Pricing','images/menu/cashregister.gif','','estnpupd.php',13,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(124,15,'Shipping Carriers/Methods','images/menu/delivery.gif','','adminarcarrierupd.php',11,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(125,16,'Checking Accounts','images/menu/Block3.gif','','adminapchkacctupd.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(126,16,'Pay Types','images/menu/drama.gif','','adminprpaytypeupd.php',2,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(127,16,'Deduction Groups','images/menu/colordots.gif','','adminprdedgroupupd.php',3,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(128,16,'Add New Tax','images/menu/unhappyface.gif','','adminprtaxtypeadd.php',4,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(129,16,'View/Update Tax','images/menu/unhappyface.gif','','adminprtaxtypeupd.php',5,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(130,16,'Enter/Update Tax Tables','images/menu/unhappyface.gif','','adminprtaxtypedtl.php',6,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(131,16,'General Factors','images/menu/sloppyfiles.gif','','adminprgendat.php',7,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(132,16,'General Benefits (Pay)','images/menu/happyface.gif','','adminprben.php',8,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(133,16,'General Deductions','images/menu/unhappyface.gif','','adminprded.php',9,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(134,16,'Company Contributions','images/menu/nc2.gif','','adminprcon.php',10,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(135,16,'Pension Plans','images/menu/gift.gif','','adminprpens.php',11,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(136,16,'Rating Scale For Reviews','images/menu/awards.gif','','adminpremplreviewratingupd.php',12,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(137,16,'Standard GL Accounts','images/menu/stdglaccts.gif','','adminprglacct.php',13,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(138,17,'Set Fiscal Year','images/menu/calendar.gif','','adminglcompanyupd.php',1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0),(139,17,'Account Types','images/menu/stdglaccts.gif','','adminglaccttypeupd.php',2,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0),(140,18,'Inventory Units','images/menu/cone.gif','','admininvunitnameupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(141,18,'Plant Locations','images/menu/Build1.gif','','admininvlocationupd.php',2,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(142,18,'Standard GL Accounts','images/menu/stdglaccts.gif','','admininvglacct.php',3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(143,18,'Purge Out-Date Files','images/menu/103-BTN.GIF','','admininvattachupd.php',4,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(144,18,'Item Categories','images/menu/wheel.gif','','invitemcatupd.php',5,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(145,18,'Category Lists','images/menu/page.gif','','invitemcatlst.php',6,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(146,18,'Pricing Levels','images/menu/lookup2.gif','','invlevelupd.php',7,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(147,18,'Price Level List','images/menu/page.gif','','invlevellst.php',8,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(148,18,'Standard Markup','images/menu/money1.gif','','invmarkupupd.php',9,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(149,18,'Markups List','images/menu/page.gif','','invmarkuplst.php',10,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(150,15,'Cut/Trim Operations','images/menu/tolls.gif','','estprgeneralupd.php',14,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(151,4,'Update Invoice','images/menu/invoice.gif','','arinvoiceupd.php',2,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(152,4,'Aging Details','images/menu/page.gif','','arinvoicerepaging.php?detail=1',5,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(153,4,'Calculate Interest','images/menu/dollar.gif','','arinvoicecalcint.php',7,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1),(154,17,'Import Accounts','images/menu/boxin.gif','','gl_admin_import.php',3,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0),(155,17,'Export Accounts','images/menu/boxout.gif','','gl_admin_export.php',4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0),(156,5,'Manage Build Orders','images/menu/Write0a.gif','','invitembuildorder.php',12,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
/*!40000 ALTER TABLE `menufunction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menupage`
--

DROP TABLE IF EXISTS `menupage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menupage` (
  `id` int(11) NOT NULL auto_increment,
  `menufunctionid` int(11) NOT NULL default '0',
  `name` char(50) NOT NULL default '',
  `orderflag` int(11) NOT NULL default '0',
  `accessap` int(11) NOT NULL default '0',
  `accessar` int(11) NOT NULL default '0',
  `accessgl` int(11) NOT NULL default '0',
  `accesspay` int(11) NOT NULL default '0',
  `accessinv` int(11) NOT NULL default '0',
  `accessest` int(11) NOT NULL default '0',
  `accessfix` int(11) NOT NULL default '0',
  `accessimp` int(11) NOT NULL default '0',
  `setupap` int(11) NOT NULL default '0',
  `setupar` int(11) NOT NULL default '0',
  `setupgl` int(11) NOT NULL default '0',
  `setuppay` int(11) NOT NULL default '0',
  `setupinv` int(11) NOT NULL default '0',
  `setupest` int(11) NOT NULL default '0',
  `setupfix` int(11) NOT NULL default '0',
  `setupimp` int(11) NOT NULL default '0',
  `supervisor` int(11) NOT NULL default '0',
  `nonsupervisor` int(11) NOT NULL default '0',
  `extvend` int(11) NOT NULL default '0',
  `extcust` int(11) NOT NULL default '0',
  `nonext` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `menufunctionid` (`menufunctionid`),
  KEY `orderflag` (`orderflag`),
  KEY `accessap` (`accessap`),
  KEY `accessar` (`accessar`),
  KEY `accessgl` (`accessgl`),
  KEY `accesspay` (`accesspay`),
  KEY `accessinv` (`accessinv`),
  KEY `accessest` (`accessest`),
  KEY `accessfix` (`accessfix`),
  KEY `accessimp` (`accessimp`),
  KEY `supervisor` (`supervisor`),
  KEY `nonsupervisor` (`nonsupervisor`),
  KEY `extvend` (`extvend`),
  KEY `extcust` (`extcust`),
  KEY `nonext` (`nonext`)
) ENGINE=InnoDB AUTO_INCREMENT=212 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menupage`
--

LOCK TABLES `menupage` WRITE;
/*!40000 ALTER TABLE `menupage` DISABLE KEYS */;
INSERT INTO `menupage` VALUES (1,111,'adminapchkacctadd.php',1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),(2,111,'adminapchkacctupd.php',1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),(3,110,'adminapglacct.php',1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),(4,109,'adminappaytermsadd.php',1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),(5,109,'adminappaytermsupd.php',1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0),(6,107,'adminarcarrieradd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(7,107,'adminarcarriermethupd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(8,107,'adminarcarrierupd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(9,100,'adminarcompanyupd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(10,106,'adminarglacct.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(11,105,'adminarinvtermsadd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(12,105,'adminarinvtermsupd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(13,103,'adminarquotecomadd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(14,103,'adminarquotecomupd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(15,104,'adminarsalesmanadd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(16,104,'adminarsalesmanupd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(17,101,'adminarsalestaxadd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(18,101,'adminarsalestaxupd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(19,102,'adminartaxexadd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(20,102,'adminartaxexupd.php',1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0),(21,97,'admindocmgmtcatadd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(22,97,'admindocmgmtcatupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(23,112,'adminestcostcenteradd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(24,112,'adminestcostcentersubtypeadd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(25,112,'adminestcostcentersubtypeupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(26,112,'adminestcostcenterupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(27,112,'adminestmachineadd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(28,112,'adminestmachineupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(29,116,'adminestquotegenink.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(30,115,'adminestquoteinkadd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(31,115,'adminestquoteinkupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(32,120,'adminestquotequotenotesadd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(33,121,'adminestquotequotenotesupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(34,117,'adminestquotestdsizeadd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(35,117,'adminestquotestdsizeupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(36,118,'adminestquotestockcolor.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(37,118,'adminestquotestockcost.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(38,119,'adminestquoteworktypeadd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(39,119,'adminestquoteworktypeaddl.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(40,119,'adminestquoteworktypestdqty.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(41,119,'adminestquoteworktypeupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0),(42,139,'adminglaccttypeadd.php',1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0),(43,139,'adminglaccttypeupd.php',1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0),(44,138,'adminglcompanyupd.php',1,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0),(45,143,'admininvattachupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(46,142,'admininvglacct.php',1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(47,141,'admininvlocationadd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(48,141,'admininvlocationupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(49,140,'admininvunitnamenadd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(50,140,'admininvunitnameupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0),(51,132,'adminprben.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(52,134,'adminprcon.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(53,133,'adminprded.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(54,127,'adminprdedgroupadd.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(55,127,'adminprdedgroupupd.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(56,136,'adminpremplreviewratingadd.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(57,136,'adminpremplreviewratingupd.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(58,131,'adminprgendat.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(59,137,'adminprglacct.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(60,126,'adminprpaytypeadd.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(61,126,'adminprpaytypeupd.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(62,135,'adminprpens.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(63,128,'adminprtaxtypeadd.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(64,130,'adminprtaxtypedtl.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(65,129,'adminprtaxtypeupd.php',1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0),(66,51,'apbilladd.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(67,57,'apbilllist.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(68,58,'apbilllistaging.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(69,60,'apbilllistdiscaging.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(70,54,'apbillpay.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(71,52,'apbillupd.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(72,55,'apchecking.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(73,56,'apchecklist.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(74,41,'apvendadd.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(75,42,'apvendcsvlist.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(76,43,'apvendextuser.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(77,42,'apvendlist.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(78,42,'apvendlistview.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(79,41,'apvendupd.php',1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(80,7,'arcustadd.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(81,8,'arcustcsvlist.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(82,9,'arcustextuser.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(83,8,'arcustlist.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(84,8,'arcustlistview.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(85,7,'arcustupd.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(86,21,'arinvoiceadd.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(87,21,'arinvoiceaddcogs.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(88,153,'arinvoicecalcint.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(89,26,'arinvoicepay.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(90,24,'arinvoicerepaging.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(91,23,'arinvoicerepcust.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(92,27,'arinvoicereppay.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(93,28,'arinvoicereptax.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(94,25,'arinvoicestate.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(95,22,'arinvoicesum.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(96,151,'arinvoiceupd.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(97,1,'arordadd.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(98,16,'arorderckout.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(99,17,'arorderfill.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(100,13,'arorderitemlst.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(101,11,'arorderlst.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(102,14,'arordershipitemlst.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(103,12,'arordershiplst.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(104,15,'arorderstatlst.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(105,20,'arorderstatuslst.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(106,18,'arordpicktick.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(107,18,'arordshipadd.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(108,19,'arordshipview.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(109,2,'arordupd.php',1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(110,123,'estnpadd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(111,123,'estnpoperations.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(112,123,'estnpoperationsize.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(113,123,'estnpoperationsoptions.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(114,123,'estnpoperationssizeaddl.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(115,123,'estnpupd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(116,122,'estprpricelstadd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(117,122,'estprpricelststockusageadd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(118,122,'estprpricelststockusagecolor.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(119,122,'estprpricelststockusageconsumables.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(120,122,'estprpricelststockusageprice.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(121,122,'estprpricelststockusagestockadd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(122,122,'estprpricelststockusagestockupd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(123,122,'estprpricelststockusageupd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(124,122,'estprpricelstupd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(125,122,'estprpricetoolsadd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(126,122,'estprpricetoolsupd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(127,5,'estquoteadd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(128,6,'estquoteupd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(129,122,'estquotepricelstadd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(130,122,'estquotepricelstcolor.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(131,122,'estquotepricelstprice.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(132,122,'estquotepricelststockadd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(133,122,'estquotepricelststockupd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(134,122,'estquotepricelstupd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(135,118,'estquotestockadd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(136,118,'estquotestockupd.php',1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(137,96,'gencompanyadd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(138,96,'gencompanyupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(139,95,'genuseradd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(140,95,'genuserupd.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(141,90,'glacctadd.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(142,90,'glacctadd1.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(143,90,'glacctadd2.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(144,90,'glacctadd3.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(145,90,'glacctadd4.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(146,91,'glacctlst.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(147,91,'glacctlst1.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(148,90,'glacctupd.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(149,92,'glbudadd.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(150,93,'glbudlst.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(151,80,'gljouradd.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(152,80,'gljouradd1.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(153,80,'gljouradd2.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(154,81,'gljourupd.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(155,81,'gljourupd1.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(156,89,'glpie.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(157,89,'glpieadd.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(158,82,'glpostadd.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(159,83,'glpostupd.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(160,86,'glrepactivity.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(161,85,'glrepbalance.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(162,87,'glrepbudvariance.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(163,84,'glrepincome.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(164,88,'glrepjournal.php',1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(165,98,'importcustomer.php',1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0),(166,30,'invitemadd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(167,30,'invitemadd1.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(168,30,'invitemadd2.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(169,144,'invitemcatadd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(170,145,'invitemcatlst.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(171,144,'invitemcatupd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(172,36,'invitemlstcomp.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(173,37,'invitemlstdist.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(174,38,'invitemlstphys.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(175,33,'invitemlstprice.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(176,34,'invitemlststatus.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(177,32,'invitemlstsum.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(178,35,'invitemlstusage.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(179,49,'invitemrecadd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(180,50,'invitemreclist.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(181,30,'invitemupd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(182,30,'invitemupd1.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(183,31,'invitemvendupd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(184,146,'invleveladd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(185,147,'invlevellst.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(186,146,'invlevelupd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(187,148,'invmarkupadd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(188,149,'invlmarkuplst.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(189,148,'invmarkupupd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(190,44,'invpoadd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(191,48,'invpolist.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(192,46,'invporecv.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(193,47,'invpotoap.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(194,45,'invpoupd.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(195,48,'invpoview.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(196,77,'pr941.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(197,63,'prcalchours.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(198,65,'prchecksum.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(199,66,'prchecksumgroup.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(200,65,'prcheckvoid.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(201,64,'prcheckwrite.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(202,68,'premplded.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(203,72,'prempllist.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(204,67,'premployeeadd.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(205,67,'premployeeupd.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(206,76,'premplreviewadd.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(207,76,'premplreviewupd.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(208,62,'prloghours.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(209,78,'prw2.php',1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(210,39,'invitemlstval.php',1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0),(211,156,'invitembuildorder.php',1,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0);
/*!40000 ALTER TABLE `menupage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menusetuptask`
--

DROP TABLE IF EXISTS `menusetuptask`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menusetuptask` (
  `id` int(11) NOT NULL auto_increment,
  `task` varchar(255) NOT NULL,
  `link` varchar(255) NOT NULL,
  `cancel` int(11) NOT NULL default '0',
  `prosper` int(11) NOT NULL default '0',
  `categories` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=45 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menusetuptask`
--

LOCK TABLES `menusetuptask` WRITE;
/*!40000 ALTER TABLE `menusetuptask` DISABLE KEYS */;
INSERT INTO `menusetuptask` VALUES (1,'STR_SETUP_BILLING_GL_ACCOUNTS','adminarglacct.php',1,0,3),(2,'STR_SETUP_PAYABLES_GL_ACCOUNTS','adminapglacct.php',1,0,4),(3,'STR_ADD_A_BANK_ACCOUNT','adminapchkacctadd.php',0,0,4),(4,'STR_CONFIGURE_PAYROLL_TAX_TYPES','adminprtaxtypeadd.php',0,1,6),(5,'STR_SET_UP_PAYROLL_GL_ACCOUNTS','adminprglacct.php',1,1,6),(6,'STR_SET_UP_INVENTORY_GL_ACCOUNTS','admininvglacct.php',1,1,5),(7,'STR_CREATE_INVENTORY_CATEGORIES','invitemcatadd.php',0,1,5),(8,'STR_SET_FISCAL_START_MONTH','adminglcompanyupd.php',0,0,7),(9,'STR_CHANGE_YOUR_PASSWORD','myuser.php',0,0,9),(10,'STR_CHECK_SYSTEM_SETTINGS','adminsystemsettings.php',0,0,9),(11,'STR_REVIEW_INVOICE_OPTIONS','adminarcompanyupd.php',0,0,3),(12,'STR_ADD_COMPANY_LOGOS','gencompanyupd.php',0,0,9),(13,'STR_SET_COMPANY_ADDRESS','gencompanyupd.php',0,0,9),(14,'STR_CUSTOMERS','importcustomer.php',0,0,10),(15,'STR_VENDORS','importvendor.php',0,0,10),(16,'STR_INVENTORY_ITEMS','importitems.php',0,1,10),(17,'STR_ITEM_CATEGORIES','importitem_categories.php',0,1,10),(18,'STR_EMPLOYEES','importemployee.php',0,1,10),(19,'STR_GL_ACCOUNTS','gl_admin_import.php',0,0,10),(20,'STR_GL_BEGINNING_BALANCES','importgltotals.php',0,0,10),(21,'STR_ADD_TYPES_OF_SERVICES','arservicetypeupd.php',0,1,2),(22,'STR_ADD_SERVICE_CLASSES','arserviceclassupd.php',0,1,2),(23,'STR_ADD_LABOR_RATES','arservicerates.php',0,1,2),(24,'STR_ADD_STATUS_LEVELS','adminarordstatusupd.php',0,1,2),(25,'STR_SET_RETURN_POLICY','adminar_rmasetup.php',0,1,2),(26,'STR_GENERAL_SETUP','admininvglacct.php',0,1,5),(27,'STR_ADD_LOCATIONS','admininvlocationupd.php',0,1,5),(28,'STR_SET_UNIT_NAMES','admininvunitnameupd.php',0,1,5),(29,'STR_ITEM_PRICE_LEVELS','invlevelupd.php',0,1,5),(30,'STR_PRICE_MARKUP_SETS','invmarkupupd.php',0,1,5),(31,'STR_ADD_CLIENT_BALANCES','arinvoiceadd_beginbal.php',0,0,3),(32,'STR_CREDIT_CARD_SETUP','adminccsetup.php',0,0,3),(33,'STR_SET_ADVANCED_OPTIONS','adminarcompanyupd.php',0,0,3),(34,'STR_SALES_CATEGORIES','adminarsales_category.php',0,0,3),(35,'STR_SHIPPING_CARRIERS','adminarcarrierupd.php',0,0,3),(36,'STR_SET_SALES_TAXES_1','adminarsalestaxupd.php',0,0,3),(37,'STR_SET_SALES_TAXES_2','adminarcompanytaxupd.php',0,0,3),(38,'STR_CHECKING_ACCOUNTS','adminapchkacctupd.php',0,0,4),(39,'STR_BILL_START_BALANCES','apbilladd_beginbal.php',0,0,4),(40,'STR_TAX_TABLES','adminprtaxtypedtl.php',0,1,6),(41,'STR_START_NEW_TAX_YEAR','copytax.php',0,1,6),(42,'STR_PAY_FACTORS','adminprgendat.php',0,1,6),(43,'STR_PAY_BENEFITS','adminprben.php',0,1,6),(44,'STR_PAY_TYPES','adminprpaytypeupd.php',0,1,6);
/*!40000 ALTER TABLE `menusetuptask` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menusetuptodo`
--

DROP TABLE IF EXISTS `menusetuptodo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menusetuptodo` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `taskid` int(11) NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menusetuptodo`
--

LOCK TABLES `menusetuptodo` WRITE;
/*!40000 ALTER TABLE `menusetuptodo` DISABLE KEYS */;
INSERT INTO `menusetuptodo` VALUES (1,1,31,1),(2,1,32,1),(3,1,33,1),(4,1,34,1),(5,1,35,1),(6,1,11,1),(7,1,36,1),(8,1,37,1),(9,1,38,1),(10,1,3,1),(11,1,39,1),(12,1,8,1),(13,1,13,1),(14,1,12,1),(15,1,10,1),(16,1,9,1),(17,1,19,1),(18,1,15,1),(19,1,14,1),(20,1,20,1);
/*!40000 ALTER TABLE `menusetuptodo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `message`
--

DROP TABLE IF EXISTS `message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `message` (
  `messageid` int(11) NOT NULL auto_increment,
  `createuserid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `createdate` datetime default NULL,
  `title` varchar(100) default NULL,
  `message` blob,
  `homepage` int(5) NOT NULL default '0',
  `fontcolor` varchar(25) default NULL,
  `graphicid` int(11) NOT NULL default '0',
  `startdate` datetime default NULL,
  `enddate` datetime default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `banner_interval` varchar(25) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`messageid`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `message`
--

LOCK TABLES `message` WRITE;
/*!40000 ALTER TABLE `message` DISABLE KEYS */;
/*!40000 ALTER TABLE `message` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `message_graphic`
--

DROP TABLE IF EXISTS `message_graphic`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `message_graphic` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) default NULL,
  `graphiccategoryid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `description` varchar(100) default NULL,
  `cancel` int(5) NOT NULL default '0',
  `createdate` datetime default NULL,
  `userid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `message_graphic`
--

LOCK TABLES `message_graphic` WRITE;
/*!40000 ALTER TABLE `message_graphic` DISABLE KEYS */;
/*!40000 ALTER TABLE `message_graphic` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `message_graphiccategory`
--

DROP TABLE IF EXISTS `message_graphiccategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `message_graphiccategory` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) default NULL,
  `description` varchar(100) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `message_graphiccategory`
--

LOCK TABLES `message_graphiccategory` WRITE;
/*!40000 ALTER TABLE `message_graphiccategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `message_graphiccategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `meterread`
--

DROP TABLE IF EXISTS `meterread`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `meterread` (
  `id` int(11) NOT NULL auto_increment,
  `unitid` int(11) NOT NULL default '0',
  `metertype` char(2) NOT NULL default '',
  `metervalue` int(10) unsigned NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  PRIMARY KEY  (`id`),
  KEY `unitid` (`unitid`),
  KEY `entrydate` (`entrydate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `meterread`
--

LOCK TABLES `meterread` WRITE;
/*!40000 ALTER TABLE `meterread` DISABLE KEYS */;
/*!40000 ALTER TABLE `meterread` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mobilecarriers`
--

DROP TABLE IF EXISTS `mobilecarriers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mobilecarriers` (
  `id` int(11) NOT NULL auto_increment,
  `carriername` varchar(50) NOT NULL default '',
  `smsgatewaydomain` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mobilecarriers`
--

LOCK TABLES `mobilecarriers` WRITE;
/*!40000 ALTER TABLE `mobilecarriers` DISABLE KEYS */;
INSERT INTO `mobilecarriers` VALUES (1,'Alltel','sms.alltelwireless.com '),(2,'AT&T','txt.att.net'),(3,'Boost Mobile','sms.myboostmobile.com'),(4,'Cricket Wireless','sms.mycricket.com'),(5,'MetroPCS','mymetropcs.com'),(6,'Project Fi','msg.fi.google.com'),(7,'Republic Wireless','text.republicwireless.com'),(8,'Straight Talk','vtext.com'),(9,'Sprint','messaging.sprintpcs.com'),(10,'T-Mobile','tmomail.net'),(11,'U.S. Cellular','email.uscc.net'),(12,'Verizon Wireless','vtext.com'),(13,'Virgin Mobile','vmobl.com');
/*!40000 ALTER TABLE `mobilecarriers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mod_help_categories`
--

DROP TABLE IF EXISTS `mod_help_categories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_help_categories` (
  `id` int(11) NOT NULL auto_increment,
  `parent_id` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `ordering` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=52 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mod_help_categories`
--

LOCK TABLES `mod_help_categories` WRITE;
/*!40000 ALTER TABLE `mod_help_categories` DISABLE KEYS */;
INSERT INTO `mod_help_categories` VALUES (2,31,'General Ledger',1),(8,31,'Order Entry - Fulfillment',2),(9,31,'Order Reports',6),(10,31,'Order Processing - Fulfillment',4),(11,31,'Billing',8),(12,31,'Inventory',9),(13,31,'Vendors',10),(14,15,'Purchasing',2),(15,31,'Payables',11),(16,31,'Payroll',12),(17,31,'Admin',13),(18,31,'Message Center',14),(20,31,'Document Manager',15),(21,0,'LogOut',4),(22,11,'Setup - Receivables',2),(23,12,'Setup Functions for Inventory',1),(24,15,'Setup Functions for Payables',1),(25,16,'Setup Functions for Payroll',1),(26,2,'Setup Functions for GL',1),(31,0,'Using NolaPro',1),(33,0,'FAQ',3),(34,21,'',1),(40,0,'Accounting Terminology',2),(41,31,'Print Shop Management',16),(43,41,'Print Shop Setup',1),(44,31,'Customers',7),(45,11,'Lead Tracking',1),(46,11,'Setup - Lead Tracking',3),(47,31,'Order Entry - Service Orders',3),(49,31,'Order Processing - Service Orders',5),(51,31,'Misc. Topics',17);
/*!40000 ALTER TABLE `mod_help_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mod_help_related_topics`
--

DROP TABLE IF EXISTS `mod_help_related_topics`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_help_related_topics` (
  `id` int(11) NOT NULL auto_increment,
  `topic_id` int(11) NOT NULL default '0',
  `related_topic_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=187 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mod_help_related_topics`
--

LOCK TABLES `mod_help_related_topics` WRITE;
/*!40000 ALTER TABLE `mod_help_related_topics` DISABLE KEYS */;
INSERT INTO `mod_help_related_topics` VALUES (1,85,86),(2,85,87),(3,85,88),(4,85,89),(5,85,90),(6,85,91),(7,94,44),(8,94,104),(9,74,75),(10,1,143),(11,147,103),(12,148,9),(15,8,9),(16,8,322),(17,15,16),(18,15,10),(19,16,15),(20,16,10),(22,10,16),(23,10,15),(25,14,9),(26,13,143),(27,336,335),(28,337,335),(29,339,338),(30,144,13),(31,23,351),(32,23,19),(35,25,351),(36,25,19),(37,24,31),(38,19,18),(43,18,20),(44,29,32),(45,31,30),(46,32,28),(47,32,29),(48,33,34),(49,33,20),(50,34,33),(51,34,35),(52,41,42),(53,35,34),(54,37,38),(55,42,41),(56,56,353),(57,56,307),(58,353,56),(59,61,60),(60,60,61),(61,64,62),(62,64,61),(63,65,298),(64,298,65),(66,68,67),(67,67,68),(68,311,71),(70,73,68),(71,83,96),(72,83,110),(73,92,140),(74,89,90),(75,89,91),(76,90,91),(77,90,89),(78,91,89),(79,91,90),(80,140,92),(81,4,3),(82,6,5),(83,13,144),(84,7,9),(85,7,323),(86,359,358),(87,358,359),(88,335,337),(89,335,336),(90,336,340),(91,338,339),(92,340,336),(93,362,360),(97,364,359),(98,366,20),(99,369,368),(100,19,351),(101,18,351),(102,126,391),(103,394,391),(104,391,394),(105,80,391),(106,19,396),(107,18,397),(108,367,396),(109,367,366),(111,399,366),(112,399,367),(114,368,367),(116,404,20),(117,404,92),(118,34,396),(119,39,361),(120,405,307),(121,405,396),(123,307,356),(124,307,405),(125,307,396),(126,375,304),(127,359,360),(128,18,105),(129,18,405),(130,19,397),(131,19,405),(132,19,20),(133,19,105),(134,351,397),(135,18,357),(136,351,357),(137,366,367),(138,366,357),(140,407,366),(141,407,18),(142,18,407),(143,19,407),(144,367,407),(145,407,367),(146,407,19),(147,367,368),(148,369,383),(149,23,367),(151,392,19),(152,392,345),(153,393,351),(154,393,19),(155,393,367),(156,400,19),(157,400,367),(158,400,351),(159,20,396),(160,46,57),(161,46,396),(163,47,341),(164,48,341),(166,49,341),(168,47,118),(169,48,118),(170,49,118),(171,50,118),(172,51,118),(174,52,341),(175,52,118),(176,53,341),(179,122,120),(180,356,116),(181,57,299),(182,57,396),(183,67,57),(184,299,125),(185,60,357),(186,61,357);
/*!40000 ALTER TABLE `mod_help_related_topics` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mod_help_topics`
--

DROP TABLE IF EXISTS `mod_help_topics`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mod_help_topics` (
  `id` int(11) NOT NULL auto_increment,
  `parent_id` int(11) default NULL,
  `topic` varchar(255) default NULL,
  `helptext` text,
  `ordering` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=408 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mod_help_topics`
--

LOCK TABLES `mod_help_topics` WRITE;
/*!40000 ALTER TABLE `mod_help_topics` DISABLE KEYS */;
INSERT INTO `mod_help_topics` VALUES (1,2,'Chart of Accounts Maintenance','<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Adding and Maintaining Chart of Accounts</font></b></center><br>\r\n <i>This page allows you to enter or update your Chart of Accounts for your General Ledger. All financial activity will be associated with one or more of these accounts.</i><br><br><b>ACCOUNT TYPE:</b> Every Account MUST have a type. Select the appropriate type from the drop-down list.<br><br>Press the CONTINUE button to enter the rest of the information.<br><br><b>GENERAL LEDGER ACCOUNT:</b> Enter a unique account number. Actually, if you are using multiple companies, then one account might be associated with one or more specific companies, or ALL companies.<br><br><b>ACCOUNT DESCRIPTION:</b> The description of the account. (Example: Account 100 might be described as Checking Account)<br><br><b>SUMMARIZE TO ACCOUNT:</b> If you want your income statement to be able to take three or four different accounts and show the totals all under one entry on the report, then enter the account to which this account should be added and displayed. (The report can be printed summarized or not as an option at run time).<br><br><b>SPECIFIC COMPANY:</b> If you have multiple companies and this account only applies to some of them, select which companies. Otherwise, entering a 0 (zero) will make this account available to all companies. This does not mean that transactions to a shared account will be joint. Transactions are kept separate by company ALWAYS.<br><br></font>',1),(3,2,'New Journal Entries','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  New Journal Entries</strong></font><a href=\"http://www.nolapro.com/training/gl/gl_journal_entry/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<p><em> \r\n<p>Use Journal entries only if the entries needed are not those \r\n  generated automatically by Inventory, Payroll, Billing and Payables, etc. Each Journal \r\n  entry requires a Debit and a Credit entry. </p>\r\n</em> \r\n<p>1) From Main Menu select Ledger then Journal Entries Add/Update. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_UpdateNew.jpg\" ></p>\r\n<p>2) Click on the <img src=\"images/add.gif\"> to add a new journal entry.</p><br>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_New.jpg\" ></p>\r\n<p> 3) Journal Voucher: A voucher is a transaction-processing \r\n  record that documents approvals, payment amounts and physical shipment or receipt. \r\n  (Hint: Use Check Number, Invoice Number, etc. as Voucher) </p>\r\n<p>4) Voucher Description: A full description to help you remember what the entry is for and to explain \r\n  it to others.</p>\r\n<p>5) Transaction Date. You can either enter the date manually or click \r\n  the <img src=\"images/calendar.gif\"> button to bring up \r\n  a calendar. (Hint: If the date is for current day, there is no need to change \r\n  it.)</p>\r\n<p>6) Click the <img src=\"images/next.gif\"> button. Your \r\n  screen should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/newledgeraccount.jpg\" ><br>\r\n</p>\r\n<p align=\"left\">7) Account: From the account column, use the pull-down list to select the GL Account.</p>\r\n<p>8) Amount: In the amount column, enter the amount. <strong>NOTE:</strong> Remember to enter all credit \r\n  amounts as negative and all debit amounts as positive.</p>\r\n<p>9) When your debits and credits balance, you will see a button <img src=\"images/completebill.gif\"> to allow you to Complete Voucher. If you need more entry lines than you see, click on the <img src=\"images/add.gif\"> Add button at the bottom of the screen.</p>\r\n<br><hr><br>\r\n<p>When clicking on the <img src=\"images/completebill.gif\"> to Complete the Voucher, you will see a screen like this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/newledgeraccount1.jpg\" ><br>\r\n</p>\r\n<p>Click on the <img src=\"images/add.gif\"> Add button to create another journal entry.</p><br>',2),(4,2,'Edit Journal Entries','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Edit Journal Entries</strong></font><a href=\"http://www.nolapro.com/training/gl/gl_journal_edit/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<em>Edit entries you made via New Journal \r\nEntries as well as those automatic entries created by Receivables, Payables, Payroll, \r\nInventory, etc. You may want to do this to correct for a wrong account being debited or credited.</em> \r\n<p>1) Click Ledger.</p>\r\n<p>2) Click Journal Entries Add/Update. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_UpdateNew.jpg\" ></p>\r\n<p align=\"left\">3) Enter the voucher number in the Voucher box if you know the \r\n  exact voucher you would like to edit. You can leave the box empty if you are \r\n  not searching for a particular voucher.</p>\r\n<p>4) Choose the specific source module from the Entry From pull-down list if \r\n  you want to only search in one source. This is the module which the original \r\n  entry was made.</p>\r\n<p>5) Use the From Date and To Date boxes to enter the year, month and date range \r\n  you would like to search. You can either enter the date manually or click the \r\n  <img src=\"images/calendar.gif\" > button to bring up a \r\n  calendar. </p>\r\n<p>6) Click the <img src=\"images/next.gif\"> button. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Edit2.jpg\" ></p>\r\n<p align=\"left\">7) Select the Voucher you would like to edit, then click on the <img src=\"images/edit.gif\"> Edit button.</p>\r\n<p>8) If you made a mistake, click the <img src=\"images/back.gif\" > \r\n  button to take you back to the original screen without saving the changes.</p>\r\n<br><hr><br>\r\n<p align=\"center\"><img src=\"images/screenshots/GLJournalUpdate1.jpg\" ></p>\r\n<p align=\"left\">9) You can change the information in any of these boxes:</p>\r\n<blockquote>\r\n  <p align=\"left\"> a) <b>Journal Voucher.</b> A voucher is a transaction-processing record \r\n    that documents approvals, payment amounts and physical shipment or receipt. \r\n    (Hint: Use Check Number, Invoice Number, etc. as Voucher)<br>\r\n    b) <b>Voucher Description.</b> This information is to help you remember what it is for and to explain it to others.<br>\r\n    c) <b>Transaction Date.</b> (Hint: If the date is for current day, there is no need \r\n    to change it).</p>\r\n</blockquote>\r\n<p> 10) Click the <img src=\"images/delete.gif\" > button \r\n  if you want to eliminate the voucher.</p>\r\n<p>11) Click the <img src=\"images/back.gif\" > button to \r\n  return to the main screen if you want to restart your search without saving \r\n  the changes.</p>\r\n<p>12) Click the <img src=\"images/next.gif\" > button to \r\n  proceed to the next screen. Your screen should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/GLJournalUpdate.jpg\"></p>\r\n<p align=\"left\">13) Update the Account and Amount boxes. Here is where you can change which account(s) and the amount(s) that need to be changed.</p>\r\n<p>14) Click the <img src=\"images/reset.gif\" > button to \r\n  restore the original values if an error was made entering data. </p>\r\n<p>15) Click the <img src=\"images/save.gif\" > button to \r\n  save the edited journal entry.</p>\r\n<p>16) Click the <img src=\"images/back.gif\" > button to \r\n  return to the main screen without saving the changes.<br>\r\n</p><br>',3),(5,2,'Post Journals Now','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong> \r\n  Post Journals Now</strong></font><a href=\"http://www.nolapro.com/training/gl/gl_journal_post/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<p><em> \r\n<p>Use this chapter to post journal entries made in the General Ledger or created \r\n  by Receivables, Payables, Inventory, etc. Posting is the process of transferring \r\n  or recording amounts to a ledger. </em> \r\n<p>1) Click Ledger.</p>\r\n<p>2) Click Post Journals Now. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Post.jpg\" >\r\n</p>\r\n<p align=\"left\">3) In the Year/Month Post Into boxes, enter the year and the month \r\n  that you wish to post the journal entries INTO.</p>\r\n<p>4) Use the Begin Period and End Period boxes to enter the year, month and date range of the voucher entries you would like to post. You can either enter the date manually or click \r\n  the <img src=\"images/calendar.gif\"> button to bring up \r\n  a calendar.</p>\r\n<p>5) Select the journals you would like to Post From using the check box list \r\n  at the bottom.</p>\r\n<p>6) Click the <img src=\"images/postinvoice.gif\" > Post Now button to complete the process.<br><br>\r\n</p>',4),(6,2,'Reverse Journal Postings','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Reverse Journal Postings</strong></font></strong><a href=\"http://www.nolapro.com/training/gl/gl_journal_reverse/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<em>Use this chapter to reverse the posting of journal entries \r\nthat were posted previously to the specific month or for just \r\none day. </em>\r\n<p>1) Click Ledger.</p>\r\n<p>2) Click Reverse Journal Postings. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Reverse.jpg\"></p>\r\n<p align=\"center\"></p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Reverse Postings by a Specific Date</strong></font></center></div></div>\r\n<hr></hr> \r\n1) Enter the year, month and day the journal entries were posted ON in the Date To Unpost box. \r\nYou can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> \r\nbutton to bring up a calendar. \r\n<p>2) Click the <img src=\"images/reversepost.gif\" width=\"30\" height=\"30\"> button.</p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <br>\r\n  <strong> Reverse Postings for an Entire Month</strong></font></center></div></div>\r\n<hr></hr> \r\n1) You also have the option to reverse entries POSTED TO a SPECIFIC month. Enter the \r\nyear and month you want to reverse the posting for in the Year & Month to \r\nUnpost box. \r\n<p>2) Click the <img src=\"images/reversepost.gif\" width=\"30\" height=\"30\"> button.<br>\r\n</p>',5),(7,2,'Profit and Loss Statement','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Profit and Loss Statement</strong></font></strong><a href=\"http://www.nolapro.com/training/gl/gl_income_statement/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>The profit and loss statement will list revenues (from \r\nsales or services provided), your cost for goods or services \r\nprovided, operating expenses (such as wages, rent, advertising), \r\nand net income or loss.  The basic formula is revenues minus \r\nexpenses equals income/profit.  The categories of a profit \r\nand loss statement are arranged in a specific order regardless \r\nof the legal form of the business (i.e., sole proprietor, C \r\ncorporation, etc.).  Also known as an Income Statement. </em> \r\n<p>1) Click Ledger.</p>\r\n<p>2) Click Profit and Loss Statement. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Profit.jpg\"></p>\r\n<p align=\"left\">3) Use the Begin Period and End Period boxes to enter the year \r\n  and month range you would like covered in the report. </p>\r\n<p>4) Click Summarized if you would like to see the accounts summarized.</p>\r\n<p>5) Click Compare to Other Period if you would like to compare multiple periods. \r\n  If you are comparing multiple periods, continue. If you are only looking at \r\n  one period, go to step 9.</p>\r\n<p>6) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button. \r\n</p>\r\n<p>7) If you are comparing multiple periods, your screen should look similar to \r\n  this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Profit2.jpg\"></p>\r\n<p align=\"left\">8) Use the Begin Period and End Period boxes to enter the year \r\n  and month range for the second period. </p>\r\n<p>9) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button. \r\n  Your screen should look similar to this: (if you are comparing to another period you will see more column to the right for the comparison period). </p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Profit3.jpg\"></p>\r\n<p align=\"left\">10) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> \r\n  button it return to the previous screen without saving the changes.</p>\r\n<p align=\"left\"> 11) Click on any of the dollar amounts to bring up an Activity Report for this account for the period the column covers. (See Account Activity for details).</p><br>',6),(8,2,'Balance Sheet','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Balance Sheet</strong></font></strong><a href=\"http://www.nolapro.com/training/gl/gl_balance_sheet/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<em>A balance sheet is a snapshot of a business\' financial \r\ncondition at a specific moment in time, usually at the \r\nclose of an accounting period. A balance sheet comprises \r\nassets, liabilities, and owners\' or stockholders\' equity. </em>\r\n<p>From the Main Menu select Ledger, then Reports, then Balance Sheet.  Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Balance.jpg\"></p>\r\n<p align=\"left\">1) Enter the financial period (year and month) for the balance sheet in the Period \r\n  box. </p>\r\n<p>2) Check Summarized if you would like to see the balance sheet summarized (accounts grouped together as specified under the account entry -- available only on Enterprise version). \r\n</p>\r\n<p>3) Check All Companies Together if you would like to see all your companies \r\n  or divisions together. If you use multiple companies, then leaving this unchecked produces a balance sheet for ONLY the current company.</p>\r\n<p>4) Check Trial Balance if you need a Trial Balance. A trial balance is a balance sheet as it would appear if all journals had been posted. -- A kind of pre-check that can be made before actually posting. </p>\r\n<p>5) Click the <img src=\"images/next.gif\"> next button. Your screen should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Balance2.jpg\"></p>\r\n<p align=\"left\">6) Clicking on the highlighted amounts in the Account Balance column brings up an Account Activity report for the selected month. </p>\r\n<p>7) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return to the previous screen. </p>\r\n<br>',7),(9,2,'Account Activity','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Account Activity</strong></font></strong><a href=\"http://www.nolapro.com/training/gl/gl_account_activity/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<em>Use the Activity Report when trying to find errors, or to see why \r\na specific account has a certain balance. A good idea is to print a full Activity Report at month-end to keep with your records in case questions come up later.</em>\r\n<p>1) Click Ledger.</p>\r\n<p>2) Click Reports, then Account Activity. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Account.jpg\"></p>\r\n<p align=\"left\">3) Use the Begin Period and End Period boxes to select the year \r\n  and month ranges to be included. </p>\r\n<p>4) To select the entries you would like to see, click either the Show Unposted, \r\n  Show Posted or Show All circles. </p>\r\n<p>5) Choose a Specific General Ledger Account from the pull-down list. Enter \r\n  0 if you would like to see ALL accounts.</p>\r\n<p>6) Click the <img src=\"images/next.gif\" > button \r\n  to continue. Your screen should look similar to this if you choose to Show All \r\n  Entries:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/GL_AcctType.jpg\"></p>\r\n<p align=\"left\">7) Click the <img src=\"images/back.gif\" > \r\n  button to return to your previous screen without saving the changes.</p>\r\n<p align=\"left\">8) Click the <img src=\"images/Excel.gif\" width=\"30\" height=\"30\"> \r\n  button if you would like to export the report into Microsoft ExcelÂ® format. \r\n  <br>\r\n</p>',8),(10,2,'Budget Variance','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Budget Variance</strong></font></strong><a href=\"http://www.nolapro.com/training/gl/gl_budget_variance/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<em>The budget variance report indicates the dollar variance \r\nbetween the Budget and Actual revenue or expense for a \r\nparticular account. </em>\r\n<p>From Main Menu select Ledger then Budget Variance. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/BudgetVariance.jpg\"></p>\r\n<p align=\"left\">1) Enter the year for the report in the Fiscal Year box.</p>\r\n<p>2) Enter the beginning through ending months for the report in the appropriate \r\n  boxes.</p>\r\n<p>3) Click Summarized if you would like to see the report summarized (as specified under account maintenance when you set up the accounts).</p>\r\n<p>4) Click on the <img src=\"images/next.gif\"> Next button. Your screen should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/BudgetVariance1.jpg\"></p>\r\n<p align=\"left\">5) If you wish to view a budget variance using a budget other than the most recent one, choose which budget you would like to use from the Select Budget To Use pull-down list. then click the <img src=\"images/calculations.gif\" width=\"30\" height=\"30\"> Recalculate button to bring up the new variance report using the new budget.</p>\r\n<p>6) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button if you \r\n  need to return to your previous screen without saving the changes. </p>\r\n<p>7) Click the <img src=\"images/Excel.gif\" width=\"30\" height=\"30\"> button if \r\n  you would like to export the report into Microsoft ExcelÂ® format. <br><br>',9),(11,2,'Journal Reports','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Journal Reports</strong></font></strong><a href=\"http://www.nolapro.com/training/gl/gl_journal_report/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<em>A Journal Report is a list of all debits and credits \r\nentered in GL Journal Entry.  </em> \r\n<p>1) Click Ledger.</p>\r\n<p>2) Click Reports, then Journal Reports. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Journal.jpg\"></p>\r\n<p align=\"left\">3) Use the Begin Period and End Period boxes to enter the year, \r\n  month and date range you would like to search. You can either enter the date \r\n  manually or click the Calendar button to bring up a calendar.</p>\r\n<p>4) To select the entries you would like to see, click either the Show Unposted \r\n  Entries Only, Show Posted Entries Only or Show All Entries box.</p>\r\n<p>5) Enter the account you would like to see the report generated from in the \r\n  Report on Module pull-down list.</p>\r\n<p>6) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Journal2.jpg\"></p>\r\n<em>NOTE: Date under date entered has the original entry date, and in parentheses following that, is the date to which this entry was posted.</em><br>\r\n<p align=\"left\">7) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> \r\n  button (found at the top and bottom of the screen) if you would like to use \r\n  different criteria to generate your report.</p>\r\n<p align=\"left\"> 8) Click the <img src=\"images/Excel.gif\" width=\"30\" height=\"30\"> \r\n  button if you would like to export the report into Microsoft ExcelÂ® format. \r\n\r\n  </p><br>',10),(12,2,'My Pie Charts','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> My Pie Charts</strong></font></strong><a href=\"http://www.nolapro.com/training/gl/gl_my_pie_charts/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Pie charts are used to show classes or groups of data in \r\nproportion to the whole data set. The entire pie represents \r\nall the data, while each slice represents a different class \r\nor group within the whole.  Examples: sales from different \r\nsources, sales from different time frames, etc. There is a maximum of\r\n12 slices per pie.</em> \r\n<p>1) Click Ledger.</p>\r\n  <p>2) Click Reports, then My Pie Charts. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Pie.jpg\"></p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n  an Existing Pie Chart or Add a New Pie Chart</strong></font></div>\r\n<hr>\r\n<p align=\"left\">1) Select the Pie Chart you would like to edit from the pull-down \r\n  list.</p>\r\n<p>2) Click the Edit button. (Or Click on the Add button to create a new chart). Your screen should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Pie2.jpg\"></p>\r\n<p align=\"left\">3) Make any necessary changes to the following:</p>\r\n<blockquote>\r\n  <p align=\"left\"> a) <b>Pie Name.</b><br>\r\n    b) <b>Pie Description.</b><br>\r\n    c) <b>Use the Begin Date and End Date</b> boxes to select the year, month and \r\n    day from which you want to search. You can either enter the date manually \r\n    or click the Calendar button to bring up a calendar.<br>\r\n    d) <b>Slice Name.</b> This will represent the different class or group within the whole chart.<br>\r\n    e) <b>Use the Slice Begin Date and Slice End Date boxes</b> to select the year, month \r\n    and day from which you want to search. You can either enter the date manually \r\n    or click the Calendar button to bring up a calendar. NOTE: Leave this blank \r\n    to use pie dates. However, if each slice covers a different time period (such \r\n    as one slice for each quarter) then the slice dates are required.<br>\r\n    f) <b>Delete Slice</b> by selecting the check box.</p>\r\n</blockquote>\r\n<p>4) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous screen without saving the changes. </p>\r\n<p>5) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the changes to your pie chart. </p>\r\n<p>6) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button to \r\n  delete the entire Pie Chart.</p>\r\n<p>7) If you saved your changes, your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Pie3.jpg\"></p>\r\n<p align=\"left\">8) Click the <img src=\"images/back.gif\"> button if you would like \r\n  to return to the previous screen without saving the changes. <br>\r\n  <br>\r\n  9) To edit one slice of a pie chart, select the slice from pull-down list.</p>\r\n<p>10) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> button to \r\n  edit the selected slice. Your screen should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Pie4.jpg\"></p>\r\n<p align=\"left\">11) Select the GL Account from the pull-down list.</p>\r\n<p>12) Select the Company from the pull-down list.</p>\r\n<p>13) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to \r\n  save the changes to the slice. </p>\r\n<p>14) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to \r\n  return to the main screen without saving the changes. </p>\r\n<p align=\"left\">15) Click on the <img src=\"images/Back2.gif\" width=\"30\" height=\"30\"> \r\n  button to return to the previous screen to add new details.</p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>View \r\n  a Pie Chart</strong></font></div>\r\n<hr>\r\n<p align=\"left\"></hr></p> 1) Select the Pie Chart you wish to view from the pull-down \r\n  list. \r\n<p>2) Click the Print button. Your screen should look similar to this: </p>\r\n\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Pie5.jpg\"></p>\r\n<br>',11),(13,2,'Edit Chart of Accounts','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Edit Chart of Accounts</strong></font></strong><a href=\"http://www.nolapro.com/training/gl/gl_account_entry/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<em>This page allows you to add, update (or delete) a General Ledger Account.</em> \r\n<p>From the Main Menu select Ledger, then Chart of Accounts. Your screen should look similar to this: </p>\r\n<div align=\"center\"> \r\n  <p align=\"center\"><img src=\"images/screenshots/EditChartofAcct.jpg\"> </p>\r\n<p>To import a list of accounts from the standard set provided, or to import your own list, click on <img src=\"images/importaccts.gif\"> Import Accounts button, and follow the steps outlined under Import Accounts.</p><br>\r\n  <div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n    an Existing Accounts</strong></font></div>\r\n  <hr>\r\n  <p align=\"left\">1) Choose the account you would like to edit from the General \r\n    Ledger Account pull-down list. </p>\r\n  <p align=\"left\">2) Click the <img src=\"images/edit.gif\" width=\"29\" height=\"29\"> Edit \r\n    button. Your screen should look similar to this:</p>\r\n  <p><img src=\"images/screenshots/EditChartofAcct1.jpg\"></p>\r\n  <p align=\"left\">3) Update any necessary data for the following categories: </p>\r\n</div>\r\n<blockquote> \r\n  <div align=\"left\"> a) <b>Account Description.</b> Will change in all past transactions.<br>\r\n    b) <b>Account Type.</b> WARNING: If there are transactions in this account, you should only \r\n    change an Asset account to another Asset account, a Liability account to another \r\n    Liability account, etc. Do not change from an Asset to a Liability account, \r\n    etc. <br>\r\n    c) <b>Company. If you have multiple companies, then you will need to indicate if this account can be used by all companies, or only by a specific company.</b><br>\r\n    d) <b>Summarize to Account.</b> By specifying another GL Account that this account can be summarized to, then when running financial statements, you can select \"Summarized\" for the report which will cause all accounts to sum into the summary account.</div>\r\n</blockquote>\r\n<div align=\"center\"> \r\n <p align=\"left\">4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> \r\n    Save button. Your screen should look similar to this:</p>\r\n   <p align=\"left\">5) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> Delete \r\n    button if you want to eliminate the account. <br>\r\n  </p>\r\n  <p align=\"center\"><img src=\"images/screenshots/EditChartofAcct2.jpg\"></p>\r\n  <p align=\"left\">6) You have to option to edit another account by clicking the \r\n    select button or add a new general ledger account by clicking the Add New \r\n    GL Account link. </p>\r\n  <div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add \r\n    a New Account</strong></font></div>\r\n  <hr>\r\n  <p align=\"left\">1) Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> Add  \r\n    button. Your screen should look similar to this:</p>\r\n  <p align=\"center\"><img src=\"images/screenshots/EditChartofAcct3.jpg\"></p>\r\n  <p align=\"left\">2) Choose the General Ledger Account Type from the pull-down \r\n    list. If you made a mistake, click the Back button to return to the main screen.</p>\r\n  <p align=\"left\">3) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next  \r\n    button. Your screen should look similar to this:</p>\r\n  <p align=\"center\"><img src=\"images/screenshots/EditChartofAcct4.jpg\"></p>\r\n  <p align=\"left\">4) Enter in the data for the following categories:</p>\r\n</div>\r\n<blockquote>\r\n  <div align=\"left\"> a) <b>General Ledger Account.</b><br>\r\n    b) <b>Account Description.</b><br>\r\n    c) <b>Summarize to Account</b> from the pull-down list. This is the General \r\n    Ledger account it will be summed into when selecting Summarize for reports.<br>\r\n    d) <b>Company. <i>If you have multiple companies, then you will need to indicate if this account can be used by all companies, or only by a specific company.</i></b><br>\r\n    e) <b>Summarize to Account.</b> By specifying another GL Account that this account can be summarized to, then when running financial statements, you can select \"Summarized\" for the report which will cause all accounts to sum into the summary account.</div>\r\n</blockquote>\r\n<div align=\"center\"> \r\n  <p align=\"left\">5) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save  \r\n    button to save your new account. <br>\r\n  </p>\r\n  <p align=\"left\">6) Click the <img src=\"images/Back2.gif\" width=\"30\" height=\"30\"> Back  \r\n    button if you need to return to the previous screen to choose a different \r\n    account. <br>\r\n  </p>\r\n  <p align=\"left\">7) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Jump to GL Account Edit  \r\n    button to return to the main Chart of Accounts screen without saving the changes. \r\n    </p><br>',12),(14,2,'Chart of Accounts List','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Chart of Accounts List</strong></font></strong><a href=\"http://www.nolapro.com/training/gl/gl_account_list/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<em>Chart of Accounts typically is used by an organization as \r\na basis to record its financial transactions.  Each account \r\nis given a number as well as a name based on the type of the \r\naccount.  Similar accounts are grouped within a certain block \r\nof numbers.  These numbers help identify the type of account, \r\nno matter where it is in an organization\'s financial records.</em>\r\n<p>From Main menu select Ledger then Reports then Chart of Accounts List. Your screen should look similar to this:</p>\r\n<div align=\"center\">\r\n  <p><img src=\"images/screenshots/Ledger_AccountList.jpg\"> \r\n  </p>\r\n<p>Click on any of the column headers to re-sort the report on that field.</p><br>\r\n  <p align=\"left\">Click the account number to view more detailed \r\n    information about the account. This will bring up a screen that looks similar to this: </p>\r\n<div align=\"center\">\r\n  <p><img src=\"images/screenshots/Ledger_AccountList2.jpg\"> \r\n  </p>\r\n  <p align=\"left\">At the bottom of this screen is a bar chart to give you a visual display of the data that is shown in detail below. This is included because charts help show trends more quickly than numbers.</p>\r\n  <p align=\"left\">If you want to see the details behind any of the numbers shown, clicking on the number will bring up the Account Activity for this account for this period.</p>\r\n\r\n',13),(15,2,'Add Update Budgets','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Budget Add/Update</strong></font></strong><a href=\"http://www.nolapro.com/training/gl/gl_budget_entry/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<em>A budget is an itemized summary of probable expenses and \r\nincome for a given period.  Budgeting is an essential business \r\nfunction as it allows owners/managers to plan and prepare for \r\nany impending changes.  It is a useful tool for monitoring \r\nexpected performance with actual performance.  This gives \r\nthe owners/managers the opportunity to control the business \r\nperformance and implement strategies that will solve problems. </em>\r\n<p>From Main Menu select Ledger, then Budget Add/Update. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_UpdateBudgets.jpg\"></p>\r\n<p align=\"left\">\r\n<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n PART A: Update an Account Budget</strong></font></strong></div><hr></hr>\r\n<p>1) If you would like to Update an existing budget (if you have created multiple budgets for this period you will be able to edit them all), enter the Fiscal Year to \r\n  update in the Fiscal Year Begin box.</p>\r\n<p>2) Select the General Ledger Account to Budget from the pull-down list.</p>\r\n<p><strong>NOTE: </strong>Must have entered a Budget Name before you can budget a specific account.</p>\r\n<p>3) Click the <img src=\"images/edit.gif\" > Edit button. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_UpdateBudgets2.jpg\"></p>\r\n<p align=\"left\">Each budget will show, giving you the change to change the amounts in each of the months for the year. </p>\r\n<p align=\"left\">4) Update any budget amounts you would like to change in the appropriate boxes. (Do NOT enter sales as negative for budgeting!)</p>\r\n<p>5) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> save button to save \r\n  your updates.</p>\r\n<p>6) If you need to update or add more budgets, click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> back link at the bottom. <br>\r\n</p>\r\n<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>PART B: \r\nAdd a Budget</strong></font></strong></div><hr></hr>\r\n1) Enter the fiscal Year to add in the Fiscal Year Begin box.\r\n<p>2) Enter the name of the new budget in the Budget Name box.</p>\r\n<p>3) Choose where you would like to copy budget data from in the Copy Budget \r\n  Data from pull-down list.</p>\r\n<p>4) Click the <img src=\"images/add.gif\"> Add button. After your new budget is added, a message will display, similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_UpdateBudgets3.jpg\"></p>\r\n<p align=\"left\">5) If you need to update or add more budgets, click the <img src=\"images/back.gif\"> Back button. </p>\r\n  <div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>PART C: \r\nEdit/Delete a Budget</strong></font></strong></div><hr></hr>\r\n1) Select the budget you wish to edit or delete from pull-down list. \r\n<p>2) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> Delete button if \r\n  you would like to delete a budget.</p>\r\n<p>3) Or click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> Edit button to \r\n  change the name of the budget. Your screen should look similar to this: </p>\r\n<p align=\"center\">\r\n<img src=\"images/screenshots/Ledger_UpdateBudgets4.jpg\"></p>\r\n<p align=\"left\">4) Make any changes to the Budget Name. </p>\r\n<p>5) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button. <br>\r\n</p>',14),(16,2,'Budget List','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Budget List</strong></font></strong><a href=\"http://www.nolapro.com/training/gl/gl_budget_list/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<em>For each month of a fiscal year, a budget list will \r\ndisplay each account number, account description, \r\nbudget names, and what the budgeted amounts are. </em>\r\n<p>From the Main Menu select Ledger then Budget List. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_BudgetList.jpg\"></p>\r\n<p align=\"left\">To display a different year, enter the new year in the Fiscal Year Begin box , then click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button to display the new year selection. </p>\r\n\r\n  <br>',15),(18,8,'New Fulfillment Order','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> New Order</strong></font>    <a href=\"http://www.nolapro.com/training/ar/ar_order_entry/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Enter new Fulfillment type Orders.</em> \r\n<p align=\"left\"><ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Fulfillment Order Add/Update</b>,</i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderUpdate.jpg\" ></p>\r\n\r\n<li> Do not enter any data, just click on the <img src=\"images/add.gif\"> <b>Add</b> button. Your screen will change to look like the following:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderAdd.jpg\" ></p>\r\n\r\n<p align=\"left\">\r\n<li> <b>Enter Data in the following categories:</b></li></p>\r\n    <ol TYPE=\"a\">\r\n       <li> <b>Location: </b>Select ship FROM default location from the pull-down \r\n    list. You can over-ride this for specific items on an order. <i>NOTE: if you only have ONE location, this selection will not appear.</i> </li></p>\r\n       <li> Enter <b>Customer Name</b> in the first box (or any portion of the name) to bring up a drop-down of possible matches. Or, you can enter the customer number directly into the box on the right. Or, if you want to search by phone, zip code, etc.,  use the <img src=\"images/seek2.gif\" height=\"30\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n <i>NOTE: To Add a New Customer, Click on the <img src=\"images/add.gif\"> <b>Add</b> Button next to the customer number entry. For help about adding customers, see that section, or click on the link at the bottom of this help page.<br><br> NOTE: When entering a customer, when you tab out of the entry box, or click into another box, the computer will look up information about that customer and display their info and status, allow you to <b>EDIT</b> the customer information, or look more closely at their current status. This brings up a changed display (part just below customer number on display appears only AFTER the customer is entered. If a RED section appears, it means that the customer is over their credit limit or past due.)</i><br><br>\r\n      <li> <b>Price Level: </b>Select from the pull-down list which price level to use for the order being entered. The customer default price level will be pre-selected, but can be changed. </li></p>\r\n      <li> <b>Sales Category: </b>Select the category (used on various sales reports. If you need to add more, look under <b><i>Billing-> Setup-Receivables -> Sales Categories</b></i>).</li></p>\r\n      <li> <b>Purchase Order: </b>Enter any customer supplied PO.</li></p>\r\n      <li> <b>Due Date: </b>You can either enter the date manually or click the <img src=\"images/calendar.gif\"> <b>Calendar</b> button to bring up a calendar.</li></p>\r\n      <li> <b>Notes: </b>Enter any comments about this order.</li></p>\r\n      <li> <b>Payment Method: </b>Select from the pull-down list. Examples: \r\n    Credit Card, Open Account, Check, etc.</li></p>\r\n<b><i>IF YOU SELECT A CREDIT CARD TYPE, </b></i>the credit card processing information will be requested when the Order is finalized. Be sure to click on <b>Process Credit Card</b> on the confirmation screen to process the payment.  Until the credit card is processed, the Order\'s Payment Method will remain as an Open Account.</p>\r\n      <li> <b>Notes to Print on pages following Main Invoice: </b>If you have entered standardized notes, you can select any or all of those notes to appear on the Invoice. After you have selected one of these notes, you will be able to click on an <b>EDIT</b> button to change any of the text for just THIS transaction. The standard text will remain the same. The ORDER AFTER Invoice is to indicate which text appears first, which next, etc.</li></p>\r\n      </ol>\r\n</p><br>\r\n<li> Click the <img src=\"images/next.gif\" > <b>Next</b> button to proceed with order entry. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderAdd2.jpg\" ></p>\r\n<br>\r\n     <ol TYPE=\"a\">\r\n        <li> <b>Ship-To: </b>Select the address it will be shipped to from the pull-down list, or click on the <b>ADD</b> button to create a brand-new ship-to address for this customer.</li></p>\r\n        <li> <b>Sales Person: </b>Select the salesperson responsible for the order from the drop-down list.</li></p>\r\n      </ol>\r\n</p>\r\n<li> Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> <b>Next</b>  button to continue to Item Entry for this order.  Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderAdd3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li> For instructions on entering Line Items, see the <b>Adding Line Items(Parts) to an Order</b> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To get a shipping quote, click on the <img src=\"images/ship.gif\"> <b>Get Shipping Quote</b> button. This calls the shipper web interface to find current shipping data, or you can simply enter your own shipping figures.</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/shipquote.jpg\"></p>\r\n      <p align=\"left\">\r\n      <ol TYPE=\"a\">\r\n               <li><b>Quote $:</b> If you want to enter your own shipping costs, simply enter in this box, then click on the <img src=\"images/checkin.gif\"> <b>Send Back</b> button.</li></p>\r\n               <li><b>From and To Zip Codes:</b> These should already be filled in with your company zip code as the \"From\" and the ship-to location of the customer as the \"To\" zip code. You can change these if you want.</li></p>\r\n               <li><b>Number of Boxes:</b> Enter the number of IDENTICAL weight boxes here.</li></p>\r\n               <li><b>Split:</b> By using the SPLIT button and/or the ADD BOXES button, you can create multiple boxes to be shipped and can indicate different weights per box and different ship-to and from zip codes for each box.</li></p>\r\n               <li><b>Ship Method:</b> Pick the method of shipment for this group of boxes.</li></p>\r\n               <li><b>Get Quote:</b> When all data about the boxes is entered, click on the <img src=\"images/next.gif\"> <b>Get Quote</b> button. This will query the shipper web-site and return the cost of the shipping.</li></p>\r\n\r\n               <li>When you have the shipping costs you want, click on the <img src=\"images/checkin.gif\"> <b>Send Back Shipping Quote</b> button at the top to pass these shipping costs back to the order.</li></p>\r\n               </ol>\r\n\r\n<li> Click on the <img src=\"images/add.gif\"> <b>Add More Lines</b> button to  increase the number of line items on the order.</li></p>\r\n<li>If this is a QUOTE rather than an actual order, click on the <img src=\"images/invoice.gif\"> <b>Save as Quote</b> button.</li></p>\r\n<li>To Finalize the ORDER, click on the <img src=\"images/save.gif\"> <b>Save</b>  button.  If this is <b>NOT</b> a Credit Card Transaction, the final screen for order entry will be displayed.</li></p><hr>\r\n\r\nIf this is a <b>Credit Card Transaction</b>, you will see the following screen:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CreditCardTran.jpg\"></p>\r\n\r\n<p align=\"left\">\r\n       <ul TYPE=â€?CIRCLEâ€?>\r\n            <li><b>Enter the information in the following categories:</b></li></p>\r\n         <ol TYPE=\"a\">     \r\n             <li> <b>Credit Card Processor: </b>Select from drop-down box.</li></p>\r\n             <li> <b>Credit Card Number: </b>Do NOT enter the dashes or spaces! </li></p>\r\n             <li> <b>Card Code: </b>Enter the security code from the back of the card (if required by your Credit Card Processor).</li></p>\r\n             <li> <b>Card expiration:</b> Select the Credit Card Expiration Month/Year from the pull-down list. </li></p>\r\n             <li> <b>Credit Card First Name: </b>First Name of credit card holder. </li></p>\r\n             <li> <b>Credit Card Last Name: </b>Last Name of credit card holder. </li></p>\r\n            <li> <b>Authorization Code: </b>Enter an Authorization Code, if required. Voice Authorization Codes are codes obtained from the Credit Card Processor when the transaction amount exceeds a dollar limit imposed by the Credit Card Processor. </li></p>\r\n         </ol>\r\n\r\n        <li> To process the transaction, click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p>\r\n\r\n        </ul>\r\n<hr>\r\n\r\n<b><i>FINAL SCREEN FOR ORDER ENTRY</b></i>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/OrderAdd5.jpg\"></p>\r\n<p align=\"left\">\r\n<li>Click on the <img src=\"images/edit.gif\"> <b>Edit</b> button to edit the order.</li></p>\r\n<li>Click on the <img src=\"images/picklist.gif\"> <b>Pick List</b> button to view/print an order pick list. Click on link below to see a sample.</li></p>\r\n<li>Click on the <img src=\"images/pdf.gif\"> <b>Confirmation</b> button to print an order Confirmation. Click on link below to see a sample.</li></p>\r\n<li>Click on the <img src=\"images/email.gif\"> <b>Email Confirmation</b> button to email a copy of the order Confirmation. When emailing, the customer email addresses will be shown to allow you to select which ones should receive this confirmation. OR, you can enter addresses of your own to send this to. Click on link below to see a sample.</li></p>\r\n\r\n<li>Click on the <img src=\"images/back.gif\"> <b>Back</b> button to enter another new order.</li></p>\r\n</ol>\r\n',17),(19,8,'Update Fulfillment Order','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Update Fulfillment Order</strong></font>    <a href=\"http://www.nolapro.com/training/ar/ar_order_update/\" target=\"_blank\"><img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this to add new orders or to view/change an existing open orders.</em> \r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Fulfillment Order Add/Update </b></i>.</li></p>\r\n<li> Your screen should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderUpdate.jpg\" ></p>\r\n\r\n<p align=\"left\">\r\n<li> To <b>Add</b> a new order, click on the <img src=\"images/add.gif\"> <b>Add</b> button, then view <b>Help</b> for New Fulfillment Orders.</li></p>\r\n<li> To select an <b>existing</b> order to update, enter any known data into the following categories (NOTE: The more information you fill in, the shorter the list of possible matches will be):</li></p>\r\n     <ol TYPE=\"a\">\r\n         <li><b> Order Number: </b></li></p>\r\n         <li><b> Purchase Order: </b></li></p>\r\n         <li><b> Customer Name ID: </b> Enter the customer name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Or, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc.,  use the <img src=\"images/seek2.gif\" height=\"30\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n         <li><b> Notes: </b>Enter any notes or key words for your search.</li></p>\r\n         <li><b> Include Which: </b> Select STATUS of orders to be included in list (All Orders, Open Orders Only, Closed Orders Only, or Pending Quotes).</li></p>\r\n        </ol>\r\n<li>Click the <img src=\"images/next.gif\" > <b>Next</b> button. If there is more than one possible match, you must select the right one from the list, which should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderUpdate4.jpg\" > </p>\r\n<p align=\"left\">\r\n     <ol TYPE=\"a\">\r\n        <li> Click on the <img src=\"images/back.gif\" height=\"30\"> <b>Back</b> button to return to the previous screen.</li></p>\r\n        <li> Click on the <b>Order Number</b> you would like to view or change. In the status column you can see if the order is Open, Partial (some items shipped), Complete (fully shipped) or Billed (had an invoice created in Receivables). </li></p>\r\n        <li> Your screen should look similar to this:</li></p>\r\n      </ol>\r\n<p align=\"center\"><img src=\"images/screenshots/OrderUpdate3.jpg\" ></p>\r\n\r\n<p align=\"left\">\r\n<p><b>NOTE: </b>If you selected a Completed or Billed order, you can only PRINT the order, not edit it.  To edit a Completed order that has not been Billed, you must cancel a shipment first.</li></p>\r\n\r\n<li><b>Edit any information desired</b>. For instructions on entering Line Items, see the <b>Adding Line Items (Parts) to an Order</b> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To get a shipping quote, click on the <img src=\"images/ship.gif\"> <b>Get Shipping Quote</b> button. This calls the shipper web interface to find current shipping data, or you can simply enter your own shipping figures.</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/shipquote.jpg\"></p>\r\n      <p align=\"left\">\r\n      <ol TYPE=\"a\">\r\n               <li><b>Quote $:</b> If you want to enter your own shipping costs, simply enter in this box, then click on the <img src=\"images/checkin.gif\"> <b>Send Back Shipping Quote</b> button.</li></p>\r\n               <li><b>From and To Zip Codes:</b> These should already be filled in with your company zip code as the \"From\" and the ship-to location of the customer as the \"To\" zip code. You can change these if you want.</li></p>\r\n               <li><b>Number of Boxes:</b> Enter the number of IDENTICAL weight boxes here.</li></p>\r\n               <li><b>Split:</b> By using the SPLIT button and/or the ADD BOXES button, you can create multiple boxes to be shipped and can indicate different weights per box and different ship-to and from zip codes for each box.</li></p>\r\n               <li><b>Ship Method:</b> Pick the method of shipment for this group of boxes.</li></p>\r\n               <li><b>Get Quote:</b> When all data about the boxes is entered, click on the <img src=\"images/next.gif\"> <b>Get Quote</b> button. This will query the shipper web-site and return the cost of the shipping.</li></p>\r\n\r\n               <li>When you have the shipping costs you want, click on the <img src=\"images/checkin.gif\"> <b>Send Back Shipping Quote</b> button at the top to pass these shipping costs back to the order.</li></p>\r\n               </ol>\r\n<hr>\r\n<li> At the very bottom is an area where you can attach documentation about this order (an agreement, a picture of the piece you are to produce, etc.). </li></p>\r\n    <ol TYPE=\"a\">\r\n        <li> To add a new attachment, click on <b>UPLOAD</b>. To see how this entire process works, click on the link below for <b>ATTACHING FILES</b>.</li></p>\r\n        </ol>\r\n<hr>\r\n\r\n<li> Click the <img src=\"images/save.gif\" > <b>Save</b> button to save the changes.</li></p>\r\n<li> Click on the <img src=\"images/add.gif\"> <b>Add </b> button to increase the number of line items on the order.</li></p>\r\n<li> Click the <img src=\"images/print.gif\" > <b>Print</b> button to print a copy of the order, a Order PickList, Order Confirmation, or email an Order Confirmation. Use this same link to print a confirmation of the order, or to email a confirmation. (For sample tickets, scroll to the bottom of the HELP section and use link for NEW FULFILLMENT ORDER, ORDER CONFIRMATION, or PICK TICKET. </li></p>\r\n\r\n',18),(20,44,'Add/Update Customer','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Customer Add/Update</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_order_customer_add_update/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Add or Update your Customers for use in Receivables, Orders, Shopping Cart or Printshop Orders.</em> \r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Customer Add/Update</b></i>. </li></p>\r\n\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerUpdate4.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> <b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n\r\n<li> To Add a New Customer, click on the <img src=\"images/add.gif\"> <b>Add</b> button.</p>\r\n\r\nTo Edit the Customer, click on the <img src=\"images/edit.gif\"> <b>Edit</b> button. </li></p>\r\n\r\n<br><hr><br>\r\n<li>Whether editing an existing customer or adding a new one, your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerUpdate3.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> <b> Enter data into the following categories: </b></li></p>\r\n         <ol TYPE=\"a\">\r\n\r\n            <li><b>Company Name:</b> The company name is used on many reports, so even if this is an entry for an individual and you plan to enter their first and last name in the appropriate field, it might be helpful to put their full name here as well.</li></p>\r\n           <li><b>First Name: </b>If this customer is a company and NOT an individual, you do not need to fill this in.</li></p>\r\n           <li><b>Last Name: </b>If this customer is a company and NOT an individual, you do not need to fill this in.</li></p>\r\n           <li><b>Address: </b>You have two lines for input of the full address. </li></p>\r\n           <li><b>City: </b>Customer city.</li></p>\r\n           <li><b>State: </b>Select state/province from the pull-down list.  If you do not see the state you need, this will need to be entered into the database by your database administrator.</li></p>\r\n          <li><b>Postal Code: </b>Customer zip or postal code.</li></p>\r\n          <li><b>Country: </b>Only needed if you operate in more than one country.</li></p>\r\n          <li><b>Mail stop: </b>If the person to whom mail should be directed is part of a company with an internal mail service, you will probably need a mail stop code in order for the mail to get through their system quickly.</li></p>\r\n          <li><b>Bill To Attn: </b>The name of the person (or department) to whom you should send invoices and statements.</li></p>\r\n          <li><b>Quote Attn: </b>The name of the person (or department) to whom quotes should be sent.</li></p>\r\n          <li><b>Charge Code: </b>This is a customer provided number for their use when making payments.</li></p>\r\n          <li><b>Phone/Phone Description: </b>You can enter up to four different phone numbers for this customer. The description part is so you can tell what this phone number is (office, cell, fax, etc.).</li></p>\r\n          <li><b>Email/Email Description: </b>You can enter up to two different email addresses for this customer. The description part is so you can tell what this email address is (purchasing, billing).</li></p>\r\n          <li><b>Web Address: </b>If your customer has a web-site, put the address here (ex: www.companyname.com).</li></p>\r\n          <li><b>Federal ID: </b>Federal Tax ID Number. Enter WITHOUT dashes between numbers.</li></p>\r\n          <li><b>Default PO: </b>Purchase Order to be automatically entered when an order is created for this customer.  The Purchase Order can be overridden during Order Entry.</li></p>\r\n          <li><b>Tax Exemption: </b>The customer will be either NOT tax exempt, or you will select from a pull-down list of reasons as to why this customer is exempt. Even if you mark a customer as exempt, if you enter tax districts, then you can make some invoices taxable.</li></p>\r\n          <li><b>Sales Tax ID: </b>Tax ID issued which allows customer to collect sales taxes (needed as part of the tax exemption process).</li></p>\r\n          <li><b>SALES TAX DISTRICT: </b><i>NOTE: You will not see this section if you have indicated that you charge tax depending on the Ship-to Location. </i>You can assign up to three different taxes to be applied to a customer. If you do not see the tax districts you want under the pull-down lists, then use the <img src=\"images/add.gif\"> <b>Add</b> button to the right of the header for this section to add a new one.</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerUpdateSalestax.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n          <li><b>Credit Limit: </b>If you leave this field blank or zero, it will assume there is NO limit. Otherwise, when entering orders, if the customer credit limit has been exceeded by previously unpaid bills, you will see a warning.</li></p>\r\n          <li><b>Default Price Level: </b>When the inventory pricing is set up, you can have various pricing levels based on the type of sale. Select the pricing level to normally use for sales to this customer.</li></p>\r\n          <li><b>Sales GL Account: </b>This should be the default General Ledger Sales Account to be used when making sales to this customer. In the Billing area under Setup-Receivables, you can select if you would rather use the inventory item default sales account rather than that of the customer.</li></p>\r\n          <li><b>Sales Person: </b>Select who is the usual salesperson for this customer from the pull-down list. This can be overridden at order entry. To add a new salesperson, click on the <img src=\"images/add.gif\"> <b>Add</b> button to the right of this field.</li></p>\r\n          <li><b>Service Rep: </b>Select who is the usual service rep for this customer from the pull-down list. This can be overridden at order entry. To add a new service rep, click on the <img src=\"images/add.gif\"> <b>Add</b> button to the right of this field.</li></p>\r\n          <li><b>Invoice Terms: </b>Select the default invoice payment terms from the pull-down list. This can be overridden at order entry. To add a new set of terms, click on the <img src=\"images/add.gif\"> <b>Add</b> button to the right of this field.</li></p>\r\n          <li><b>Quote Comment: </b>Select a standard message to appear on quotes from the pull-down list. To add a new comment, click on the <img src=\"images/add.gif\"> <b>Add</b> button to the right of this field.</li></p>\r\n          <li><b>Charge Interest?: </b>Select Yes or No to allowing interest to be calculated for this customer on any overdue invoices.</li></p>\r\n          <li><b>Promotions OK?: </b>Select whether on not this customer should be included in the possible list of customers to receive automatic emails (generated under the ADMIN section of the program).</li></p>\r\n          <li><b>Notes: </b>These notes will appear on Order Entry, so they should contain special notes about customer likes and dislikes in terms of shipments, etc.</li></p>\r\n<br>\r\n     </ol>\r\n\r\n<li> To exit WITHOUT save the changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n\r\n<li> To Save the changes, click on the <img src=\"images/save.gif\"> <b>Save</b>  button.<br>\r\n\r\n<li> (Only if UPDATING) To enter or update Ship-to Addresses, click on the <img src=\"images/edit.gif\"> <b>Edit Shipto</b> button.</li></p>\r\n</p>\r\n\r\n<li> (Only if UPDATING) To view the purchasing history of this customer, click on the <img src=\"images/costofgoods.gif\"> <b>View History</b> button.</li></p>\r\n\r\n<li> (Only if UPDATING) To remove this customer, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button. <i>NOTE: the customer history will still be viewable, even if the customer no longer shows on lists for new orders, etc</i>.</li></p>\r\n\r\n<li><b>Attachments:</b> You can attach pictures, documents, etc. to each customer (sales contracts, agreements, notices, etc.). See the <b>Attaching Files</b> topic in the Related Topics section to see how this is done.</li></p>\r\n</ol>\r\n<br><hr><br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Add/Update Customer Ship-To Addresses</strong></font></div>\r\n<hr>\r\n<em>A customer may have as many Ship-to Addresses as needed.</em> \r\n\r\n<ol>\r\n<li>After selecting to EDIT Ship-to Addresses, this screen will appear (one Ship-to Address is automatically created as the same as the general customer address information):</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerShipToUpdate3.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>To exit the Ship-to Address entry section, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n\r\n<li>To create a new Ship-to Address for this customer, click on the <img src=\"images/add.gif\"> <b>Add</b> button.</li></p>\r\n\r\n<li>Select a Ship-to Address to edit from the pull-down list, then click on the <img src=\"images/edit.gif\"> <b>Edit</b> button to edit the entry.</li></p>\r\n<br>\r\n<li>Whether Adding a new address, or editing an existing one, you screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerShipToUpdate5.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data into the following categories: </b>\r\n     <ol TYPE=\"a\">\r\n          <li><b>Company Name: </b>Enter the Name to be shipped to.</li></p>\r\n          <li><b>Attn: </b>Enter the name to whose attention the shipment should be sent.</li></p>\r\n          <li><b>Address:</b> You have two lines to enter a complete address.</li></p>\r\n          <li><b>City: </b>Customer city.</li></p>\r\n          <li><b>State: </b>Select state/province from the pull-down list.  If you do not see the state you need, this will need to be entered into the database by your database administrator.</li></p>\r\n          <li><b>Postal Code: </b>Customer zip or postal code.</li></p>\r\n          <li><b>Country: </b>Only needed if you operate in more than one country.</li></p>\r\n          <li><b>Mail stop: </b>If the person to whom mail should be directed is part of a company with an internal mail service, you will probably need a mail stop code in order for the mail to get through their system quickly.</li></p>\r\n          <li><b>Phone/Phone Description: </b>You can enter up to four different phone numbers for this Ship-to Customer. The description part is so you can tell what this phone number is (office, cell, fax, etc.).</li></p>\r\n          <li><b>Email/Email Description: </b>You can enter up to two different email addresses for this Ship-to Customer. The description part is so you can tell what this email address is (purchasing, billing).</li></p>\r\n          <li><b>Default Ship Method: </b>Select from the drop-down list of possible shipping methods. This can be overridden at order entry.</li></p>\r\n          <li><b>Tax Exemption: </b>The Ship-to Customer will be either NOT tax exempt, or you will select from a pull-down list of reasons as to why this Ship-to Customer is exempt. Even if you mark a Ship-to Customer as exempt, if you enter tax districts, then you can make some invoices taxable.</li></p>\r\n          <li><b>Sales Tax ID: </b>Tax ID issued which allows Ship-to Customer to collect sales taxes (needed as part of the tax exemption process).</li></p>\r\n          <li><b>SALES TAX DISTRICT: </b><i>NOTE: You will ONLY  see this section if you have indicated that you charge tax depending on the Ship-to Location. </i>You can assign up to three different taxes to be applied to a customer. If you do not see the tax districts you want under the pull-down lists, then use the <img src=\"images/add.gif\"> <b>Add</b> button to the right of the header for this section to add a new one.</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerUpdateSalestax.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n       </ol>\r\n<br>\r\n<li>To return to the Ship-to selection screen WITHOUT saving changes, click on the <img src=\"images/Back2.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To save your entries, click on the <img src=\"images/save.gif\"> <b>Save</b>  button.</li></p>\r\n\r\n<li>To remove this Ship-to Address for the customer, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button.  This button does NOT delete the Customer.</li></p>\r\n</ol>\r\n\r\n<br><hr><br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> View Customer History</strong></font></div>\r\n<hr><br>\r\n<ol>\r\n<li> If you selected to View Customer History, you screen will look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerHist1.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li><b> Enter data into the following categories to narrow your report: </b></li></p>\r\n     <ol TYPE=\"a\">\r\n           <li><b>Begin and End Period: </b> The time period over which to view the history.  Enter the dates manually or use the <img src=\"images/calendar.gif\"> <b>Calendar</b> button to select dates from the calendar.</li></p>\r\n           <li><b>Customer Name - ID:</b> This field will already be filled in with the customer number of the customer you were editing.</li></p>\r\n           <li><b>Show Invoices:</b> Select whether to show only OPEN invoices or ALL invoices for report.</li></p>\r\n           <li><b>Report: </b> You can select the report to print by day, month, year, or in detail.</li></p>\r\n       </ol>\r\n\r\n<li> To view the History Report, click on the <img src=\"images/next.gif\"> <b>Next</b> button.  You have the following options:</li></p>\r\n\r\n        <ol TYPE=\"a\">\r\n           <li><b>Close Window </b> - click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button  to return to the Customer Add/Update screen.</li>\r\n           <li><b>Back </b> - click on the <img src=\"images/back.gif\"> <b>Back</b> button to return to the Customer History screen to view more history.</li>\r\n           <li><b>Export </b> - click on the <img src=\"images/Excel.gif\"> <b>Export</b> button to export this report to a file in Microsoft ExcelÂ® format.</li>\r\n           </ol>\r\n</p>\r\n<li> To exit the History section, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n</ol>\r\n<br><hr><br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sample History broken down by MONTH <strong><small><small><br>(same style as for Week and Year)<small></small></font></div>\r\n<br>\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerHist2.jpg\" ></p><br>\r\n<br><hr><br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sample History - Detail</strong></font></div>\r\n<br>\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerHist3.jpg\" ></p><br>\r\n<br>\r\n\r\n</ol>',19),(21,44,'List Customers','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Customer List</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_order_customer_lists/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter to create lists, mailing labels, and spreadsheet-compatible \r\nfiles of customers.</em> \r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Customers -> List Customers</b></i>.</li></p>\r\n\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ListCustomers.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> Choose which type of list you want to create:</li></p>\r\n    <ol TYPE=\"a\">\r\n\r\n       <li><b>CSV List</b> â€“ Generates a comma delimited (CSV) list of customers. May be displayed in your browser if Microsoft ExcelÂ® or another handler is installed, otherwise you will be prompted to save the file.</li></p>\r\n       <li><b>CSV List WITH HEADERS</b> - Generates a comma delimited (CSV) list of customers with the first row in the list containing the names of the columns (i.e. Name, Address, City, State). May be displayed in your browser if Microsoft ExcelÂ®  or another handler is installed, otherwise you will be prompted to save the file.</li></p>\r\n       <li><b>Customer List (Main Location)</b> - On-screen list of the Main Location information for your customers.</li></p>\r\n       <li><b>Customer List (Ship To Location)</b> - On-screen list of the Shipping Location information for your customers. </li></p>\r\n       <li><b>Mailing Labels (Customer Locations)</b> - Generates mailing labels using the customer\'s Main Location address. May be displayed as a PDF document  in a new window. Requires Adobe Acrobat ReaderÂ® or other PDF viewer to display correctly. </li></p>\r\n       <li><b>Mailing Labels (Ship To Locations)</b> - Generates mailing labels using the customer\'s Ship-To Location address. May be displayed as a PDF document in a new window. Requires Adobe Acrobat ReaderÂ® or other PDF viewer to display correctly. </li></p>\r\n    </ol>\r\n</ol>\r\n<br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\">\r\n   <b> Example of Customer List - Main Location</b></font></div>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/ListCustomers1.jpg\"></p>\r\n<br>\r\n',20),(22,43,'Add/Update External Users','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Customer Login Access</strong></font></div>\r\n<hr></hr>\r\n<em>Use this chapter to enter/update user names and passwords for external companies \r\nto use as logins for their employees.</em> \r\n<p>1) Click Orders.</P>\r\n<p>2) Click Customer Login Access. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerExternalUserUpdate.jpg\" width=\"360\" height=\"119\"> \r\n</p>\r\n<p><br>\r\n  3) Enter the Customer Number in the Customer Number box or use <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> \r\n  the to search for the Customer Number. NOTE: To Add a New Customer, see Appendix \r\n  B in the back of this manual.</p>\r\n<p>4) Click the Show List button to continue. Your screen should look similar \r\n  to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerExternalUserUpdate2.jpg\" width=\"360\" height=\"138\"> \r\n</p>\r\n<p>5) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous screen without saving the changes.</p>\r\n<p> 6) Select the User Name from the pull-down list.</p>\r\n<p> 7) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> button to \r\n  edit this customer&#8217;s information. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/UserNameUpdate.jpg\" width=\"216\" height=\"190\"> \r\n</p>\r\n<p>8) Enter and verify the password.</p>\r\n<p>9) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the changes.</p>\r\n<p>10) Or click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button \r\n  to delete the user from external access.</p>\r\n<p> 11) Click the <img src=\"images/Back2.gif\" width=\"30\" height=\"30\"> button to \r\n  edit another user from the same company.</p>\r\n<p>12) Click on the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button \r\n  to select another company.<br>',21),(23,9,'Open Orders','<div align=\"center\" > <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Open Orders Report</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_order_list_open/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This report shows all open (unfilled) orders currently \r\nin-house. The Due Dates will appear as <font COLOR=\"006400\"><b>green</b></font>=due in the future, <b>black</b>=due today or <font COLOR=\"FF0000\"><b>red</b></font>=past due. You can also edit the order from the list.</em>\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Reports -> Orders Open</b></i>. </li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OpenOrders.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To edit an order, click on the <img src=\"images/edit.gif\" width=\"20\" height=\"20\"> <b>Edit</b> button on the line with the order.</li></p>\r\n\r\n<li>Click on the <b>Order Number</b> to print a Pick Ticket for that order.  For more information on Pick Tickets, click on the <b>Pick Ticket</b> topic in the Related Topics section at the end of this Help screen.</li></p>\r\n\r\n<li>You can click on the column headers (Order #, Order By, PO # or Due Date) to sort the list by that field.</li></p>\r\n<li><b>Notes: </b>Notes on the orders and Shopping cart credit card info shows up in notes area. The total $$ showing for the order may appear different from the total on the report. This is because the credit card amount includes taxes and shipping, which the open orders report does not.</li></p>\r\n\r\n<li>To create a report for a specific location (it comes up initially for ALL locations), select a location from the drop-down box at the top of the report. </li></p>\r\n\r\n<li>To export the report in a Microsoft ExcelÂ® format, click the <img src=\"images/Excel.gif\"> <b>Export</b> button at the bottom of the screen. </li></p>\r\n</ol>',22),(24,9,'Orders Shipped','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Orders Shipped Report</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_order_list_shipped/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This report shows all orders with shipments made between the two dates entered. You may narrow your report for by Customer, Purchase Order and/or Location.  There are grand totals after each order. You can also view the packing list from an order from the list.</em> \r\n<ol>\r\n<li> From Main Menu, select <b><i>Orders -> Reports -> Orders Shipped</b></i>. </li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/ShippedOrderList.jpg\">\r\n</p>\r\n<p align=\"left\">\r\n<ol>\r\n<li> <b> Enter the following categories to narrow your report:</b></li></p>\r\n       <ol TYPE=\"a\">\r\n             <li> <b>Begin Period</b> and <b>End Period</b> - Select the date range from which you want to search. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to bring up a calendar.</li></p>\r\n            <li> <b>Purchase Order: </b> - Enter a specific Purchase Order, or leave it blank to see all purchase orders.</li></p>\r\n            <li><b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n            <li><b>Location: </b> - Select a specific Location from the pull-down list, or leave the ALL option to see shipments from all locations.</li></p>\r\n        </ol>\r\n\r\n<li>When all selections are made, click the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ShippedOrder.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li>You can click on column headers (Order #, Customer or PO Number) to sort the lists by that field. </li></p>\r\n\r\n<li>To view the packing list for that order, click on the <font COLOR=\"0000FF\"><b>Blue </b></font> Order#.  For more information, click on the <b>View Shipped Orders</b> link in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> button at the bottom of the screen. </li></p>\r\n\r\n<li>To return to the previous page, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n</ol>',23),(25,9,'Open Items on Orders','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Open Items on Orders Report</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_order_list_items_open/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This report shows all open (unfilled) items on orders currently in-house. \r\nThere are grand totals after each item of total amounts pending on order. You \r\ncan also edit the order from the list.</em> \r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Reports -> Open Items on Orders</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OpenItemList.jpg\"></p>\r\n<p align = \"left\">\r\n\r\n<li>To specify a specific location, select the <b>Location</b> from the pull-down list at the top of the report.</li></p>\r\n\r\n<li>To View a Picklist for the order, click on the <b>Order Number</b>.</li></p> \r\n\r\n<li>To Edit an Order Number, click on the <img src=\"images/edit.gif\" width=\"20\" height=\"20\"> <b>Edit Fulfillment Order</b> button on the same line as the order.</li></p>\r\n\r\n<li>To sort the items differently, click in the column header over <b>Item Code</b> or <b>Description</b>.</li></p> \r\n\r\n<li>To export the report into Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button.</li></p>\r\n\r\n<li>To return to the Main Menu, click on your browser\'s <b>Back</b> button.</li></p>\r\n</ol>',24),(26,9,'Items Shipped','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Items Shipped Report</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_order_list_items_shipped/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This report shows all items shipped between the two dates entered. You can limit the report to one Customer and/or one Location.  There are grand totals after each item.</em> \r\n<ol>\r\n\r\n<li> From the Main Menu, select <b><i>Orders -> Reports -> Items Shipped</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ShippedItemList.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data into the following categories to narrow your report: </b> </li></p>\r\n      <ol TYPE=\"a\">\r\n          <li><b>Begin Period and End Period:</b> - Select the date range from  which you want to search. You can either enter the date manually or click the   <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to bring up a calendar.</li></p>\r\n         <li><b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n        <li><b>Location: </b> - Select a location from the pull-down list or select ALL to include all locations in your report.</li></p>\r\n        <li><b>Include Non-Inventory Items: </b> - Check this box if you want to include items shipped that are not included in your inventory.</li></p> \r\n      </ol>\r\n\r\n<li> To produce the report, click on the <img src=\"images/next.gif\"> <b>Next</b>\r\nbutton. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"> <img src=\"images/screenshots/ShippedItemList2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To sort the report, click on the column headers (Item Code or Description).</li></p>\r\n\r\n<li>To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"\"> <b>Export</b> button at the bottom of the screen.</li></p>\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n</ol>',25),(27,9,'Performance Statistics','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Order Reports> Performance Statistics</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_order_list_performance_statistics/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This report will show you how well you are meeting the expected due dates for orders. </em> \r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Reports -> Performance Statistics</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Perform.jpg\" > </p>\r\n<p align=\"left\">\r\n\r\n<li> <b>Enter information into the following categories to narrow your report: </b> </li></p>\r\n      <ol TYPE=\"a\">\r\n           <li><b>Customer Name â€“ ID: </b>Leave blank to include ALL Customers, or enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n\r\n           <li><b>Begin and End Dates: </b>Manually enter a range of dates or use the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to select dates from a calendar.</li></p>\r\n       </ol>\r\n\r\n<li> To produce the report, click on the <img src=\"images/next.gif\"> <b>Next</b> button.  Your screen will appear similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Perform1.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> The pie charts (and the data they are drawn from which is shown immediately under the charts) show performance based on the total number of orders that were on-time, late or early, the total number of items on orders which were shipped on-time, late or early, and the total dollar value of orders that were shipped on-time, late or early. By looking at performance from these three points of view, you get a much better idea as to real performance.</li></p>\r\n\r\n<li> Following this is a day-by-day breakdown of orders received, shipped and orders received on that day that are currently open. To see an actual listing of any of these, you can click on the various numbers shown in <font COLOR=\"0000FF\"><b>Blue</b></font> to drill-down to the data underneath.  The  reports produced can be exported to a file in Microsoft ExcelÂ® format by clicking on the <img src=\"images/Excel.gif\"> <b>Export</b> button.</li></p>\r\n<li> To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n</ol>\r\n\r\n<hr>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Drill-down to Received</strong></font></div>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/Perform2.jpg\" ></p>\r\n<br>\r\n<hr>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Drill-down to Orders Shipped or Dollars Shipped</strong></font></div>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/Perform4.jpg\" > \r\n</p>\r\n<br>\r\n<hr>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Drill-down to Items Shipped</strong></font></div>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/Perform5.jpg\" > \r\n</p>\r\n<br>',26),(28,10,'Check In/Out Orders','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Fulfillment Processing > Check In/Out Orders</strong></font>\r\n\r\n<a href=\"http://www.nolapro.com/training/ar/ar_order_process_check_in_out/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n\r\n<hr></hr>\r\n<em>If you have a process of verifying an order for accuracy BEFORE filling it, then use the check out/in to mark the job as to whom and when the job was taken and when it was returned approved.</em> \r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Fulfillment Processing -> Check In/Out Orders</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderCheckout.jpg\" > </p>\r\n<p align=\"left\">\r\n\r\n<li><b> Enter Data in the following categories:</b></li></p>\r\n        <ol TYPE=\"a\">\r\n             <li> <b>Operator: </b>Select the Operator from the pull-down list. (If you do not have supervisor rights, you can only enter checkin-out information for yourself, and this list will not appear.)</li></p>\r\n             <li> <b>Order#: </b>Enter the Order Number.  If you know the Order Number, you will not need to enter any information under Purchase Order or Customer.</li></p>\r\n             <li> <b>Purchase Order: </b>Enter the Purchase Order to find orders with this Purchase Order Number.</li></p>\r\n             <li><b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n            </ol>\r\n\r\n<li>Click the <img src=\"images/next.gif\"> <b>Next</b> button to continue. If you specified a specific order, then you will be taken directly to the Check Out screen.  Otherwise, your screen should be simliar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderCheckout2.jpg\"></p>\r\n<p align=\"left\">\r\n       <ol TYPE=\"a\">\r\n            <li> Click the <b>Order Number</b> you would like to Check In or Check Out. You  will be taken to the Check Out screen:</li></p>\r\n       </ol>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderCheckout1.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> Once an order is selected, your screen will display the OPPOSITE status to whatever the status was before(i.e. if the order was checked OUT the status will be check IN), and usually you only need press the SAVE button:</li></p>\r\n\r\n<li><b>Note:</b> <i>The SAME person must check the job back in as checked it out!</i></p>\r\n\r\n<li> Click the <img src=\"images/save.gif\"> <b>Save</b> button to save your selection.</li></p>\r\n<li> Click the <img src=\"images/back.gif\"> <b>Back</b> button to return to the previous screen.</li></p>\r\n\r\n</ol>',27),(29,10,'Fill Order Start/Stop','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Processing > Fill Order Start/Stop</strong></font>\r\n<a href=\"http://www.nolapro.com/training/ar/ar_order_process_fill_start_stop/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n\r\n<hr></hr>\r\n<em>Use the start or stop filling an order to track who has the order and when they began working on it.</em> \r\n\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Fulfillment Processing -> Fill Order Start/Stop</b></i>.</li></p>\r\n\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/FillOrderStartStop.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li><b> Enter Data in the following categories</b>, or if you are not sure of all the information, leave it blank and you will be given the opportunity to select from a list:</li></p>\r\n     <ol>\r\n         <li> <b>Operator: </b>Select the Operator from the pull-down list. NOTE: This option is only available if you have sufficient security clearance. If you do NOT have this access level, you can only enter information about yourself.</li></p>\r\n         <li> <b>Order #:</b>Enter an order number.  If you enter an order number, here, you do not need to enter a Purchase Order or Customer Name.</li></p>\r\n         <li> <b>Purchase Order: </b> Enter the Purchase Order to find orders with this Purchase Order Number.</li></p>\r\n         <li><b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n        </ol>\r\n\r\n<li> Click the <img src=\"images/next.gif\"> <b>Next</b> button to continue to the next screen. </li></p>\r\n\r\n<li> If the selections you made above applied to more than one order, you will be shown a list from which to choose the order you want. If only one order matched the entries, the screen below will be by-passed. Click the order number you would like to Start or Stop.</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/FillOrderStartStop2.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> <b> Click the Red or Green Light button to start or stop filling</b>.  If the current status of the order is NOT BEING FILLED, you will see a GREEN light.  A RED light means the order is in the process of being filled. </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/FillOrderStartStop4.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> <b>Note:</b><i> The same person must be selected when STOPPING as when STARTING to fill this order!</i></p>\r\n</ol>\r\n',28),(30,10,'Enter New Shipment','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Processing > Enter New Shipment</strong></font>\r\n<a href=\"http://www.nolapro.com/training/ar/ar_order_process_new_shipment/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n\r\n</div>\r\n<hr></hr>\r\n<em>Ship order, create packing slips, and create box labels.</em> \r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Fulfillment Processing -> Enter New Shipment</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/SearchOrderShipped.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li> <b> Enter Data in any of the following categories that you know</b>. If only one order matches, you will go directly to package information.  If more than one could match, you will see a list from which to select the order you want:</li></p>\r\n     <ol TYPE=\"a\">\r\n            <li> <b>Location: </b> If you are using more than one location, you will see a drop-down box from which to choose.</li></p>\r\n            <li> <b>Order #: </b>. Enter Order Number, if known. If you enter an Order Number here, you do not need to enter any further information.</li></p>\r\n            <li> <b>Purchase Order: </b> Enter the Purchase Order Number.  This will produce a list of orders with this purchase order number.</li></p>\r\n            <li> <b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n            <li> <b>Group to Include:</b> Select whether you want to search the Pending Only, Shipped Only or All orders.</li></p>\r\n            </ol>\r\n\r\n<li> Click the <img src=\"images/next.gif\" > <b>Next</b> button to continue. </li></p>\r\n\r\n<li> If more than one order matches the entries you made, the following screen will \r\n  appear. Click the order number you would like to view.</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderList.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Whether you selected an order from the list or if only one order matched your original entries, the following screen will appear.</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderNumberOfBoxes.jpg\" > </p>\r\n<p align=\"left\">\r\n\r\n<li> <b>Enter data into the following categories: </b></li></p>\r\n      <ol TYPE=\"a\">\r\n        <li> Select the <b>Ship To Location </b> from the pull-down box.  If you want to add a Ship To Location for this Customer, click on the <img src=\"images/add.gif\"> <b>Add</b> button to the right.</li></p>\r\n        <li> Specify the <b>number of boxes</b> to ship in the appropriate box. This will determine how many box labels to print (among other things).</li></p>\r\n        <li> <b>Select whether you want to specify the cost/weight per package</b>. If you DO want to enter these, then if you said 3 boxes then you will enter three sets of tracking number, freight charges, etc.</li></p>\r\n        </ol>\r\n\r\n<li> Click the <img src=\"images/next.gif\" > <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/PackingList.jpg\" > \r\n</p>\r\n\r\n<li><b> Enter data into the following categories (highlighted in red):</b></p>\r\n       <ol TYPE=\"a\">\r\n            <li> <b>Quantity Shipped</b> - Enter units to be shipped. Total quantities ordered, backordered, and previously shipped are shown.</li></p>\r\n            <li> <b>Shipping Date</b> - Enter the shipping date or select a date from the calendar using the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button.</li></p>\r\n            <li> <b>Shipping Method</b> - Select the Shipping Method from the pull-down list.</li></p>\r\n            <li> <b>Tracking Number</b> - Enter the Shipper\'s Tracking Number assigned to this shipment.</li></p>\r\n            <li> <b>Weight</b> - Enter the total weight of this shipment in pounds.</li></p>\r\n            <li> <b>Freight Charges</b> - Enter the total freight charges for this shipment.  This amount will be added to the order when invoiced.</li></p>\r\n          </ol>\r\n<li>Note that you may already have a quantity to ship entered. This is because there is sufficient inventory on-hand to fill this order.  If you only have 10 on-hand and you need to ship 50, it will pre-enter a 10 into the ship quantity field. You can, of course, override the quantity. You can also see how many were shipped previously (if any) and how many still need to be shipped (the backorder quantity).\r\n\r\n<li> To save your entries, click the <img src=\"images/save.gif\"> <b>Save</b>  button.</li></p>\r\n\r\n<li> To return to the previous screen without saving the changes, click the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n<li>Your screen should look similar to this after you save:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrdersShipped.jpg\"></p>\r\n<p align=\"left\">\r\n \r\n<li> To print a packing list in PDF form, click the <img src=\"images/pdf.gif\" > <b>Packing Slip</b> button.</li></p>\r\n\r\n<li> To print shipping labels in PDF form for the boxes, click the <img src=\"images/pdf.gif\" > <b>Box Label</b> button.</li></p>\r\n\r\n<li> To enter another shipment, click the <img src=\"images/back.gif\" > Back button.</li></p>\r\n</ol>\r\n<br><hr><br>\r\n\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Packing List</strong></font></div>\r\n<em>The Packing List consists of one or more pages of items, with barcodes of the order number in the header. </em> \r\n<p align=\"center\"><img src=\"images/screenshots/pkglist1.jpg\"></p>\r\n\r\n<br><hr><br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Box Labels</strong></font></div>\r\n<em>The box labels are designed to print multiple-up on the page. The number of labels printing depends on how many boxes you entered when beginning the shipment.</em> \r\n<p align=\"center\"><img src=\"images/screenshots/boxlabel.jpg\"></p>\r\n<br>\r\n  <br>',29),(31,10,'View Shipped Orders','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <b> Order Processing-Fulfillment > View Shipped Orders</b></font>\r\n<a href=\"http://www.nolapro.com/training/ar/ar_order_process_view_shipped/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter to View or reprint packing slips and/or box labels.</em> \r\n\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Fulfillment Processing -> View Shipped Orders</b></i>. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/SearchOrderShippedList.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li> Enter as much data in the following categories as is known. You must enter data in one or more of the fields to see any results. If more than one order fits the entries, then you will see a list from which you can make a selection of the order wanted:</li></p>\r\n       <ol TYPE=\"a\">\r\n          <li> <b>Order #: </b></li>\r\n          <li> <b>Purchase Order: </b></li>\r\n          <li><b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n          <li> <b>Location: </b> Select a location from the pull-down list. NOTE: If you have only one location, you will not see this option on your screen.</li>\r\n       </ol>\r\n\r\n<li>To continue, click the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderListForShipments1.jpg\"></p>\r\n<p align=\"left\"></p>\r\n\r\n<li> To view a Shipped Order, click on an <b>Order Number</b>. Your screen should look like this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrdersShipped.jpg\"></li></p>\r\n<p align=\"left\">\r\n\r\n<li> Shipments in summary are shown in the middle of the screen with the details of a selected shipment shown below the summary.  To view the details of a different shipment, click on the <b>Ship Date</b> of that shipment. The Shipment Details section will redisplay with the information for the shipment you selected.</li></p>\r\n\r\n<li> To print a Packing List in PDF form, click the <img src=\"images/pdf.gif\" > <b>Packing Slip</b> button.</li></p>\r\n\r\n<li> To print a box labels in PDF form, click the <img src=\"images/pdf.gif\" > <b>Box Label</b> button.</p>\r\n\r\n<li> To enter another shipment, click the <img src=\"images/back.gif\" > <b>Back</b> button to enter another shipment.</li></p>\r\n</ol>\r\n\r\n<br><hr><br>\r\n\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Packing List</strong></font></div>\r\n<em>The Packing List consists of one or more pages of items, with barcodes of the order number in the header. </em> \r\n<p align=\"center\"><img src=\"images/screenshots/pkglist1.jpg\"></p>\r\n\r\n<br><hr><br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\">  <b> Box Labels</b></font></div>\r\n<em>The box labels are designed to print multiple-up on the page. The number of labels printing depends on how many boxes you entered when beginning the shipment.</em> \r\n<p align=\"center\"><img src=\"images/screenshots/boxlabel.jpg\"></p>\r\n\r\n<br>\r\n  <br>\r\n',30),(32,10,'Order Processing Status','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <b> Fulfilllment Processing > Order Processing Status</b></font>\r\n<a href=\"http://www.nolapro.com/training/ar/ar_order_process_status/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This report shows the current status (checked out, filled, etc.) of all OPEN orders.</em> \r\n\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Fulfillment Processing -> Orders Processing Status</b></i>. </li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderStatusList.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<p> You can click in the column headers on <b>Order #, Order By, PO Number, or Due Date</b> to sort the list by that field.</p>\r\n\r\n<p> The right-hand column indicates whether the order is a Fulfillment type of order (same as Shopping Cart) or a Service type of Order.</p><br>\r\n\r\n<li> To return to the menu, click the <b>Back button on your Browser</b>. </li></p>\r\n</ol>\r\n',31),(33,11,'Add Invoice','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Add New Invoice</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_new_invoice/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Create new Invoices and print.</em>\r\n<p>From Main Menu, select Billing then Invoice Add/Update. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceUpdate.jpg\" ></p>\r\n<p align=\"left\">To create a NEW Invoice, Click on the <img src=\"images/add.gif\"> Add New button. Your screen will change to look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceAdd.jpg\" ></p>\r\n\r\n<p><b>Customer Code Number:</b> Enter the code number here, or click on the <img src=\"images/seek2.gif\"> Lookup button to select from a list of customers. Or, if this is a new customer, click on the <img src=\"images/add.gif\"> Add button to the right of this field, enter the new customer, then use the Lookup button to select.</p>\r\n<p>When you have entered the customer number, the screen will redraw in order to show you current credit information about this customer:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceAdd1.jpg\" ></p>\r\n<br>\r\n<p>You can EDIT the customer information by clicking on the <img src=\"images/edit.gif\"> Edit button next to the customer name. You can view greater details about the customer account by clicking on the \"View Account\" words. </p>\r\n\r\n<p><b>Invoice Date:</b> You can either enter the date manually or click \r\n  on <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> button to bring up \r\n  a calendar.</p><br>\r\n<p>Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button to proceed. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceAdd2.jpg\" ></p>\r\n<p align=\"left\">\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Select Ship To address</strong> from pull-down list \r\n    or add a new one using the Add button.<br>\r\n    b) <strong>Enter Invoice Number.</strong><br>\r\n    c) <strong>Select Sales Category</strong> from pull-down list<br>\r\n    d) <strong>Enter Purchase Order, </strong>if one is given.<br>\r\n    e) <strong>Select Shipping Method</strong> from pull-down list<br>\r\n    f) <strong>Enter Customer Bill Code. </strong>(For customer\'s internal accounting)<br>\r\n    g) <strong>Select Sales Person</strong> from the pull-down list (this originally shows the default entry for this customer).<br>\r\n    h) <strong>Select Invoice Terms</strong> from the pull-down list (this originally show the default entry for this customer).<br>\r\n    i) <strong>Select any Invoice Notes</strong> to print on the invoice by placing a checkmark in the Include? column<br>\r\n    j) <strong>Order after Invoice</strong> indicates the order the notes will appear.  Enter the number to indicate desired order.<br>\r\n    i) <strong>EDIT the Invoice Notes</strong> text by clicking on the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> Edit button in the Edit Text column.</p> \r\n</blockquote><br>\r\n<p>Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceAdd4.jpg\"></p><br>\r\n\r\n<em>You can enter as many lines of details as needed for each invoice. Additional lines are opened up by clicking on the \"Add More Input Lines\" button at the bottom of the screen. Also at the bottom of the screen you will see the invoice total change with each new line entered.</em><br>\r\n<blockquote> \r\n  <p align=\"left\"> a) <strong>Description: </strong>Full description.<br>\r\n    b) <strong>Quantity:</strong> The quantity column has both quantity and units. The quantity entered in this column should be the quantity of the units listed directly below.\r\n<br>\r\n    c) <strong>Sales Quantity Unit Name:</strong> Select the sales unit name from the drop-down list.<br>\r\n    d) <strong>Price:</strong> The Price column has both a price and units entry. The price entered should be the price of each of the units selected directly below.<br>\r\n    e) <strong>Price Unit Name:</strong> Select the price unit name from the drop-down list.<br>\r\n    f) <strong>Qty Unit/Price Unit:</strong> This field MUST have a value. It is the number of sales units (in the Quantity column) contained in a Sales Unit (in the Price column). The extended price will not work out correctly if this is incorrect.<br>\r\n    g) <strong>Tax:</strong> This box will come up checked (for charge tax on this item) or unchecked (non-taxable item) depending on the default setting for this customer.  If you want to CHANGE the normal tax status for any line on the invoice, simply change the checked status showing.<br>\r\n    h) <strong>GL Sales Account:</strong> This account will first appear with the default Sales Account from the customer.  You may change it for any line item on the invoice by simply picking a different one from the drop-down list.</p>\r\n</blockquote>\r\n<br>\r\n<p align=\"left\">To Add more input lines on this invoice, click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> Add More Input Lines button.</p>\r\n<p align=\"left\">To proceed to the final screen, click on the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button. Your screen should look similar to this:</p><br>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceAdd5.jpg\" ></p><br>\r\n<blockquote>\r\n<p>\r\n<strong>Due Date:</strong> The invoice due date.  This will auto-calculate the due date based on the customer terms, however you can change this date if desired.<br>\r\n<strong>Discount Date:</strong> The date after which no discounts will apply. This will auto-calculate based on the customer terms, however you can change this date if desired.<br>\r\n<strong>Shipping Cost:</strong> Shipping charges (non-taxed) to add to invoice.\r\n</p>\r\n</blockquote>\r\n<br>\r\n<p> Proceed to printing the invoice by clicking on the <img src=\"images/next.gif\"> Next button.</p>\r\n<p>If you want to enter the COST OF GOODS for this invoice, click on the <img src=\"images/costofgoods.gif\"> Enter COGS button, which brings up this screen.</p>\r\n\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceEnterCOGS.jpg\" ></p>\r\n<p align=\"left\">a) Enter Cost of Goods in appropriate box.</p>\r\n<p>b) Select GL account from the pull down list.</p>\r\n<p>c) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save the entry and open up another line for entering more costs. </p>\r\n<p>When you have entered all the costs you want (and SAVED them), exit by clicking on the <img src=\"images/closewindow.gif\"> Close Window button.</p><br><br>\r\n<p>The final invoice screen looks similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceAdd6.jpg\" ></p>\r\n\r\n\r\n\r\n\r\n<p>Click on the <img src=\"images/pdf.gif\" width=\"33\" height=\"29\"> Print button \r\n  to Print a .pdf version of this invoice. </p>\r\n<p>Click on the <img src=\"images/email.gif\" width=\"33\" height=\"29\"> Email button to send a copy of this invoice via your default email account.</p>\r\n<p>When finished, click on the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> \r\n   Back button to create another new invoice.<br><br><hr><br><br>\r\n<div align=\"center\"> <font size=\"+1\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sample of .pdf Invoice</strong></font></div>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceAdd7.jpg\" ></p><br><br>\r\n\r\n\r\n',32),(34,11,'Update Invoice','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Update Invoice</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_edit_invoice/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Edit Invoices</em>\r\n<p>From Main Menu select Billing, then Invoice Add/Update. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceUpdate.jpg\"></p>\r\n<p align=\"left\">Enter any limited data in the following categories (you need enter at least CUSTOMER, but entering as much as you know will limit the search to a reasonable list. If you know the invoice number, that is the ONLY data you need to enter to edit that invoice):</p>\r\n<blockquote> \r\n  <p align=\"left\"> a) <strong>Enter the Invoice Number.</strong><br>\r\n    b) <strong>Enter the Purchase Order.</strong><br>\r\n    c) <strong>Enter the Customer Number</strong> in the Customer Number box or \r\n    use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> button to search \r\n    for the Customer Number.<br>\r\n    d) <strong>Enter Notes</strong>, if necessary.<br>\r\n    e) <strong>Enter Line Item Description keywords.</strong></p>\r\n</blockquote><br>\r\n<p>Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button to proceed. If more than one invoice matches the entries you made, your\r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceUpdate2.jpg\"></p>\r\n<p align=\"left\">Click on the <img src=\"images/view.gif\" width=\"30\" height=\"30\">   to view that Invoice.</p>\r\n<p align=\"left\">Click on the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> to edit that Invoice.</p><br><hr><br>\r\n<p align=\"left\">If only one invoice matched your selections on the first screen, or you have selected an invoice number to be edited on the second screen, your screen should now look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceUpdate3.jpg\"></p>\r\n<p align=\"left\">If this invoice has been POSTED, then the FIRST thing you need to do before being allowed to make changes, is to UNPOST.  Click on the <img src=\"images/unpostinvoice.gif\"> Unpost button.</p>\r\n<br><p>An UNPOSTED display will now appear and you can now make modifications to the invoice in any or all of the following \r\n  categories:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceUpdate3a.jpg\"></p>\r\n\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Ship to Address. </strong> Select a new ship-to address from the pull-down list.<br>\r\n    b) <strong>PO#. </strong> Change or enter your Purchase Order#.<br>\r\n    c) <strong>Invoice Date. </strong> Change the Invoice date, or use the calendar button to pull up a calendar to choose date from.<br>\r\n    d) <strong>Due Date.</strong>  Change the Due Date, or use the calendar button to pull up a calendar to choose date from.<br>\r\n    e) <strong>Invoice Terms </strong> Select terms from the pull-down list. <br>\r\n    f) <strong>Salesman.</strong> Select Salesman from the pull-down list.<br>\r\n    g)<strong> Sales Category.</strong> Select Sales Category from pull-down list.<br>\r\n    h) <strong>Shipping Method.</strong> Select Shipping Method from pull-down list.<br>\r\n    i) <strong>Notes.</strong> Enter Notes, if necessary.<br>\r\n    j) <strong>Hide Notes.</strong> Select to Hide Notes when printing by checking the box.<br>\r\n    k) <strong>Select any Invoice Notes</strong> to print on the invoice by placing a checkmark in the Include? column.<br>\r\n    l) <strong>Order after Invoice</strong> indicates the order the notes will appear.  Enter the number to indicate desired order.<br>\r\n   m) <strong>EDIT the Invoice Notes</strong> text by clicking on the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> Edit button in the Edit Text column.<br><br>\r\n   n)  <big>For each item on the invoice (one blank line is provided to add new, but if more than one is needed, SAVE after entering the first one, and another blank line will appear.):</big><br>\r\n<blockquote>\r\n    1) <strong>Item Description.</strong> Enter Item Description<br>\r\n    2) <strong>Item Price.</strong> Enter Item Price<br>\r\n    3) <strong>Unit Name for Price.</strong> Select from pull-down list.<br>\r\n    4) <strong>GL Sales Account.</strong>  Select from pull-down list.<br>\r\n    5) <strong>Taxable.</strong> Checking the box means that this line is taxable.<br>\r\n    6) <strong>Quantity.</strong> Number of items of the Sales Unit Name units.<br>\r\n    7) <strong>Sales Unit Name</strong> Select from the pull-down list.<br>\r\n    8) <strong>Qty. Unit/Price Unit.</strong>This is how many of the sales quantity units  are contained in each pricing unit.</p>\r\n</blockquote>\r\n   o) <strong>Shipping Charges.</strong> Enter the amount of the shipping charges.</blockquote></p>\r\n<p align=\"left\">At the very bottom is an area where you can attach documentation about this invoice (an agreement, a picture of the piece you are to produce, etc.).\r\nTo add a new attachment, click on <strong>UPLOAD</strong>. To see how this entire process works, click on the link below for <strong>ATTACHING FILES.</strong></p>\r\n<p align=\"left\">Click on the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button to return to the previous screen.</p>\r\n<p>Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save changes.</p>\r\n<p>Click on the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button to finish making changes.</p>\r\n<p>Clicking the <img src=\"images/reset.gif\" width=\"30\" height=\"30\"> Reset button will only back out UNSAVED data.</p>\r\n<p>Clicking on the <img src=\"images/delete.gif\" width=\"30\" height=\"30\">Delete button will remove the invoice.</p>\r\n<p>If you want to edit COST OF GOODS for this invoice, click on the <img src=\"images/costofgoods.gif\"> Enter COGS button, which brings up this screen.</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceEnterCOGS.jpg\" ></p>\r\n<p align=\"left\">a) Enter Cost of Goods in appropriate box.</p>\r\n<p>b) Select GL account from the pull down list.</p>\r\n<p>c) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save the entry and open up another line for entering more costs. </p>\r\n<p>When you have entered all the costs you want (and SAVED them), exit by clicking on the <img src=\"images/closewindow.gif\" width=\"30\" height=\"30\"> Close Window button.</p><br><br>\r\n<p>The final invoice screen looks similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceAdd6.jpg\" ></p>\r\n\r\n\r\n\r\n\r\n<p>Click on the <img src=\"images/pdf.gif\" width=\"33\" height=\"29\"> Print button \r\n  to Print a .pdf version of this invoice. </p>\r\n<p>Click on the <img src=\"images/email.gif\" width=\"33\" height=\"29\"> Email button to send a copy of this invoice via your default email account.</p>\r\n<p>When finished, click on the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> \r\n   Back button to pull up the invoice summary.<br><br><hr><br><br>\r\n<div align=\"center\"> <font size=\"+1\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sample of .pdf Invoice</strong></font></div>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceAdd7.jpg\" ></p><br><br>',33),(35,11,'Summary of Invoices','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Summary of Invoices</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_summary_of_invoices/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>View summaries of open invoices, unposted invoices, all invoices, in detail, grouped by customer, etc.</em>\r\n<p>From Main Menu select Billing, then Reports, then Summary of Invoices. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceSummary.jpg\"> </P>\r\n<p align=\"left\">Specify the type of report you want:</P>\r\n<blockquote> \r\n  <p align=\"left\"> a) <strong>Begin Period and End Period</strong> For reports of OPEN invoices, these dates will have no affect. But for other groups, select the start and end date for invoices to be included. You can either enter the date \r\n    manually or click the <img src=\"images/calendar.gif\"> button to bring up a calendar.<br>\r\n    b) <strong>Customer Name-ID: </strong> Select a Customer or leave blank to report all customers.<br> \r\n    c) <strong>Show Invoices: </strong> Select whether you want to see OPEN ONLY,  ALL or only UNPOSTED invoices from the pull-down list.<br>\r\n    d) <strong>Show Profit: </strong> Select whether or not to show profit on your report.<br>\r\n    e) <strong>Specific Salesperson: </strong> Select a Salesperson from the pull-down list.<br>\r\n    f) <strong>Specific Service Rep: </strong> Select a Service Rep from the pull-down list.<br>\r\n    g) <strong>Report:</strong> Select the level of detail you want to show on the report.  Summary Totals will show one line per invoice, Details will show each line item listed on each invoice, and GL Accounts Detail will show the detail of each line item PLUS each COST distribution included on the invoice.<br>\r\n    h) <strong>Order By: </strong>Select to view by invoice, grouped by customer or grouped by salesperson from the pull-down list.</p>\r\n</blockquote><br>\r\n<p align=\"left\">Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> \r\n  Next button. Your screen should look similar one of the following:</p>\r\n<br><hr><br><p align=\"center\"><big><b>Summary Report - Ordered by Customer</b></big></p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceSummary2.jpg\"></p>\r\n<p align=\"left\">Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back \r\n  button to return to the report selection screen.</p>\r\n\r\n<p align=\"left\">To view an invoice, click on the Invoice number. Check the UPDATE INVOICE section to see how this area works.</p>\r\n<p>To view a customer account status, click on the Customer.</p>\r\n<br><hr><br><p align=\"center\"><big><b>Line Item Detail Report - Ordered by Customer</b></big></p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceSummary3.jpg\"></p>\r\n<p align=\"left\">Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> \r\n  button to return to the report selection screen.</p>\r\n\r\n<p align=\"left\">To view an invoice, click on the Invoice number. Check the UPDATE INVOICE section to see how this area works.</p>\r\n<p>To view a customer account status, click on the Customer.</p>\r\n<br><hr><br><p align=\"center\"><big><b>GL Account Detail Report - Ordered by Customer</b></big></p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceSummary4.jpg\"></p>\r\n<p align=\"left\">Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> \r\n  button to return to the report selection screen.</p>\r\n\r\n<p align=\"left\">To view an invoice, click on the Invoice number. Check the UPDATE INVOICE section to see how this area works.</p>\r\n<p>To view a customer account status, click on the Customer.</p>\r\n<br><br>',35),(36,11,'View Customer Account','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> View Customer Account</strong></font></div>\r\n<hr></hr>\r\n<em>Check on current customer status, showing all open invoices.</em>\r\n<p>From the Main Menu select Billing, then Reports, then View Customer Account. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerAccount.jpg\"></P>\r\n<p align=\"left\">Enter the first letters of the Customer name or Customer Number in the Customer Number box to select a Customer or use \r\n  the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\">button to search for \r\n  the Customer Number. </p>\r\n<p align=\"left\">Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> \r\n  button. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerAccount2.jpg\"></p>\r\n<p>Click on the Invoice Number to view the invoice or edit it.</p>\r\n<p align=\"left\">Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back \r\n  button to return to the previous screen.</p><br>\r\n<p align=\"left\">Click the <img src=\"images/costofgoods.gif\" width=\"30\" height=\"30\"> View History button to see a history of invoices for this customer:</p><br>\r\n<hr>\r\n  <br>\r\n\r\n<p>If you selected to view customer history, you screen will look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerHist1.jpg\" ></p>\r\n<br>\r\n<p><b>Begin and End Period: </b> The time period over which to view the history.</p>\r\n<p><b>Customer #:</b> This field will already be filled in with the customer number of the customer you were editing.</p>\r\n<p><b>Show Invoices:</b> Select whether to show only OPEN invoices or ALL invoices for report.</p>\r\n<p><b>Report: </b> You can select the report to be by day, month, year, or in detail.</p><br>\r\n\r\n<p>Click on the <img src=\"images/next.gif\"> Next button to view the history report.</p>\r\n<p>Click on the <img src=\"images/closewindow.gif\"> Close Window button to exit the history section.</p>\r\n<br><hr><br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sample History broken down by MONTH <strong><small><small><br>(same style as for Week and Year)<small></small></font></div>\r\n<br>\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerHist2.jpg\" ></p><br>\r\n<br><hr><br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sample History - Detail</strong></font></div>\r\n<br>\r\n<p align=\"center\"><img src=\"images/screenshots/CustomerHist3.jpg\" ></p><br>\r\n<br>\r\n\r\n',36),(37,11,'Aging Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Aging Report</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_aging_reports/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Provides a summarized look at customers with overdue \r\namounts - and by how much they are overdue. Each customer \r\nappears on a single line on the report.</em>\r\n<p>From the Main Menu select Billing, then Reports, then Aging Report. Your screen should look similar to this:</P>\r\n<p align=\"left\"><b>Only Show if Over XX Days</b> - Select All Entries, 30 Days, 60 days, or 90 Days from the pull-down list.</p>\r\n<p>Click on the <img src=\"images/next.gif\"> Next button to display report.</p>\r\n<p align=\"center\"><img src=\"images/screenshots/ARInvoiceAgingReport.jpg\"></P>\r\n\r\n<p align=\"left\">Click on a Customerâ€™s name to see a Detailed Aging \r\n  Report for the specific customer showing the aging for their open invoices: </P>\r\n<p align=\"center\"><img src=\"images/screenshots/ARInvoiceDetailAging1.jpg\"></P>\r\n<br><br>',37),(38,11,'Aging Details','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Aging Details</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_aging_reports/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Provides a quick look at customers with overdue amounts - \r\nand by how much they are overdue. Each customer appears with \r\nall their unpaid invoices listed separately with a grand \r\ntotal line.  The Report Run Date is the date used for aging purposes on the report. </em>\r\n<p>From the Main Menu select Billing, then Reports, then Aging Details. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/ARInvoiceDetailAging.jpg\"> </P>\r\n<p>Click on the Invoice Number to bring up the UPDATE INVOICE function.</p>\r\n<p align=\"left\">Click the No Show/Show First Line (in the header under Customer) to either Show the First \r\n  Line (shown below) or No Show First Line (example above). </P>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ARInvoiceDetailAging2.jpg\"></p>\r\n<br>\r\n  <br>\r\n',38),(39,11,'View/Print Statements','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> View/Print Statements</strong></font></div>\r\n<hr></hr>\r\n<em>View or print statements for a specific sales category, specific customer. all sales categories, or all customers. \r\nThis statement will display what the customer still owes you \r\nand what they have already paid.</em>\r\n<p>From Main Menu select Billing, then Processing, then View/Print Statements. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceStatements.jpg\"></P>\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Select what Statement Format</strong> you want to use from the pull-down list. The Sales Categories you defined in Billing Setup are listed here.  Statements print in Customer Number order. The All - Group by Sales Category option will group and subtotal the invoices on the statement by Sales Category. <br>\r\n    b) <strong>Enter the Customer Number</strong> in the Customer Number box or use the Lookup button to search for the Customer Number.<br>\r\n    c) <strong>Enter the Statement Period Begin Date</strong> or use the <img src=\"images/calendar.gif\"> Calendar button to select a date.<br>\r\n    d) <strong>Enter the Statement Period End Date</strong> or use the <img src=\"images/calendar.gif\"> Calendar button to select a date.<br>\r\n    e) <strong>Enter the number of days</strong> less than which you do not want an invoice sent (for example, you sent the only invoice that customer has 2 days ago, you do not want to send them a statement at this time). Note: if the customer has ANY invoice is OLDER than this number of days old, their statement will include ALL pending invoices.</p>\r\n</blockquote>\r\n<p>Click the Next <img src=\"images/next.gif\" width=\"30\" height=\"30\"> button to print \r\n  the statements in PDF Format.</p><br><hr><br>\r\n<p><strong><big>SAMPLE STATEMENT (All Categories - No Separation Format)  in .pdf form:</strong></p>\r\n<p align=\"center\"><img src=\"images/screenshots/StatementPDF.jpg\"><br><br>\r\n</p>\r\n<p align=\"left\"><big>SAMPLE STATEMENT (All - Group by Sales Category format)  in .pdf form:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/StatementPDF2.jpg\"><br>\r\n</p>',39),(40,11,'Calculate Interest','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Calculate Interest</strong></font></div>\r\n<hr></hr>\r\n<em>You must run this if your overdue invoices are going to \r\nhave to have interest charged. You cannot accidently run this again and have the interest double up because the system keeps track of when the last time you calculated interest was, and will not again apply interest until 30 days has passed.</em>\r\n<p>From the Main Menu select Billing, then Processing, then Calculate Interest. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/ARCalculateInterest.jpg\"></P>\r\n<p align=\"left\">Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> \r\n  button to apply the interest to those accounts.</P>\r\n<p align=\"left\">Click the <img src=\"images/Excel.gif\" width=\"30\" height=\"30\"> \r\n  button if you would like to export the report in a Microsoft ExcelÂ® format. \r\n<br>',40),(41,11,'Enter Payments','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Enter Payments</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_enter_payment/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Enter payments received from a customer.</em>\r\n<p>1) From Main Menu select Billing, then Processing, then Enter Payments. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoicePayments.jpg\"></P>\r\n<p align=\"left\">2) Enter Data in the following categories:</P>\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Enter Customer Name</strong> in the first box (or any portion of the name) to bring up a drop-down of possible matches. Or, you can enter the customer number directly into the box on the right. Or, if you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> Lookup button for detailed searches.<br>\r\n    b) <strong>Enter Amount of Payment.</strong> The amount they are paying not \r\n    the amount of the invoice(s).<br>\r\n    c) <strong>Select Payment Method</strong> from the pull-down list.<br>\r\n    d) <strong>Enter the Date Received. </strong>You can either enter the date \r\n    manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> Calendar button to bring up a calendar.<br>\r\n    e) <strong>Enter the Voucher Number.</strong> (Usually a check number) <big><i>NOTE: THIS IS A REQUIRED ENTRY!</i></big><br>\r\n    f) <strong>Check the Include Prior Interest select box,</strong> to include accrued interest in the invoice balances. NOTE: You can always add interest to specific invoices on the next screen.</p>\r\n</blockquote><br>\r\n<p>3) Click on the <img src=\"images/next.gif\"> Next button to continue. Your screen should look \r\n  similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoicePayments2.jpg\"></p>\r\n<p>The system is designed to automatically figure out what amounts should apply to what invoices.  If you have any credits for this customer, it will add them into the payment amount and apply them to invoices as well. If the amount you received EXCEEDS the invoice amounts, then you will need to enter data in the overpayment description area, and also check what you want done with the overpayment (change the payment received amount to equal the amount applied, or to create a credit memo for the customer).</p><br>\r\n\r\n\r\n \r\n<p align=\"left\">If you do not like the selection the system made for you, you can change the amount paid on any invoice, and also enter interest paid by invoice. As you change payments and interest amounts paid, the totals at the bottom of the screen will change so you can see if you have applied the entire amount received (or over-applied). </p>\r\n\r\n<p>NOTE: When the Yet to Apply amount becomes 0.00 you have correctly balanced the payment to the invoices.</p>\r\n<br>\r\n</blockquote>\r\n<p>4) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button to cancel payment and return to the previous screen.<br>\r\n<p>5) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to Finalize the payment (and create the overpayment credit if that is called for).<br>',41),(42,11,'Payment Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Payment Report</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_payment_report/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This report shows all payments received between the two \r\ndates entered. The report can be run for a single customer and/or a specific Sales Category also.  Non-Invoice Payments can be included on the report.</em>\r\n<p>From the Main Menu select Billing, then Reports, then Payment Report. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/ARInvoicePaymentHistoryReport.jpg\"></P>\r\n<p align=\"left\"><b>Use Begin Payment and End Payment</b> to select the date range from which you want to search. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> button to bring up a \r\ncalendar.</P>\r\n<p><b>Enter Customer Name</b> in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> Lookup button for detailed searches.</p>\r\n<p><b>Select Sales Category:</b>, if needed from the pull-down list.</p>\r\n<p><b>Include Non-Invoice Payments:</b> - check this box if you wish to include Non-Invoice Payments in your report.</p>\r\n<p><b>Select Order</b> By using the pull-down list (Customer, Date or Invoice Number order).</p><br>\r\n<p>Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button. Your \r\n  screen should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/ARInvoicePaymentHistoryReport2.jpg\">\r\n</p>\r\n<p>The BEGIN $ shows the balance of the invoice BEFORE the payment was applied. The BALANCE column shows the balance AFTER the payment was applied. The VOUCHER column contains the number you entered (perhaps the check number).</p>\r\n<p>Clicking on the column headers DATE, CUSTOMER, or INVOICE# will resort the report by that column.</p><br><br>',42),(43,11,'Sales Tax Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales Tax Report</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_sales_tax_report/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This report shows sales tax received between the two dates \r\nentered.  This report can be used to help you complete your \r\nmonth-end, quarter-end and even your year-end sales tax reports. </em>\r\n<p>From the Main Menu select Billing, then Reports, then Sales Tax Report. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/ARInvoiceSalesTaxReport.jpg\"></P>\r\n<p align=\"left\">Use Begin Period and End Period to select the date range of invoices to be included in the report. You can either enter the date manually or click the \r\n  <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> button to bring up a \r\n  calendar.</P>\r\n<p>Check Totals Only if you want a summarized report.</p>\r\n<p>Select the Tax District Name from the pull-down list.</p>\r\n<p>Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/ARInvoiceSalesTaxReport1.jpg\"><br>\r\n</p><br>\r\n<p>In addition to showing each individual invoice and whether it is taxable or exempt and if exempt, why...   It also totals at the bottom:  Total Tax, Taxable $$, Exempt $$, and then the totals for exemption reasons by reason.</p>\r\n<p>You may notice that some invoices will have entries in BOTH exempt and taxable columns.  This is because invoices can be taxed for some line items and not others.  Also, non-taxable shipping will appear in the exempt column as well.</p>\r\n<br><br>',43),(46,12,'Item Suppliers','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Inventory > Item Suppliers</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_itemSupplier/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This creates a list of vendors supplying an item, what their\r\n charges are, part numbers, price breakpoints, etc. (To facilitate purchasing)</em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Item Suppliers</b></i>. </li></p> \r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemS.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Item Name or Code â€“ ID: </b> Enter Item Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Item number directly into the box on the right. If you want to search by description, type of item, vendor, category, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n\r\n<li>After selecting an item, click on the <img src=\"images/next.gif\"> <b>Next</b> button to select a vendor to be a supplier for that item.  You will see the <b>Existing Supplier</b> screen if a Supplier already exists or the <b>New Supplier</b> screen, if no Suppliers are set up for this Inventory Item.</li></p>\r\n\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Existing Supplier</strong></font></div>\r\n<hr>\r\n     <ol TYPE=\"a\">\r\n            <li>Since the supplier already exists for this Inventory Item, their name will be automatically displayed. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemSupplierAddUpdate.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n            <li>Select a Vendor from the pull-down list. You can have several Suppliers for an Inventory Item. </li></p> \r\n        <li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n        <li>To edit the Supplier information, click on the <img src=\"images/edit.gif\"> <b>Edit</b> button and proceed to the <b>Editing Supplier Information</b> section of this Help text below to continue:</li></p>\r\n        <li>To add a new Supplier, click on the <img src=\"images/add.gif\"> <b>Add</b> button and proceed to the <b>New Supplier</b> section of this Help text below to continue:</li></p>\r\n        </ol>\r\n\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>New Supplier</strong></font></div>\r\n<hr>\r\n     <ol TYPE=\"a\">\r\n            <li>If you are assigning a new Supplier or no Suppliers exist for this Inventory Item, your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemVendorUpdateAdd1.jpg\"> </p>\r\n<p align=\"left\">\r\n         <li><b>Vendor Name â€“ ID: </b> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Item number directly into the box on the right. If you want to search by name, address, or contact information, use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.  You can <b>Add</b> a new vendor using the <img src=\"images/add.gif\"> <b>Add</b> button to the right of the screen.  See <b><i>Vendor Maintenance</i></b> in the Related Topics section at the bottom of this Help section.</li></p>\r\n\r\n        <li> When you have selected a vendor, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n        </ol>\r\n<br>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><b>Editing Supplier Information</b></font></div>\r\n<hr>\r\n<li>Whether adding a new Supplier or editing an existing one, your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/ItemSupplierAddUpdate1.jpg\"> </p>\r\n<p align=\"left\">\r\n<li><b>Enter the following information:</b></li></p>\r\n      <ol TYPE=\"a\">        \r\n          <li><b>Vendor Product Code:</b> The part number the vendor uses (used when writing purchase orders to this vendor).</li></p>\r\n          <li><b>Purchase Unit:</b> Select a unit name from the drop-down list (ex: stock in each, price by the dozen, purchase by the gross).</li></p>\r\n          <li><b>Number of usage units in each Purchase unit:</b> Needed to do the conversions when purchasing.</li></p>\r\n          <li><b>Cost - Up to this Quantity:</b> Usual prices charged by this vendor at different quantities purchased.</li></p>\r\n          <li><b>Inventory Item Supplier Files:</b> Graphic files can be attached to this Supplier.  See the <b><i>Attaching Files</b></i> topic in the Related Topics section at the bottom of this Help section.</li></p>\r\n       </ol>\r\n\r\n<li>Click the <img src=\"images/save.gif\"> <b>Save</b> button to save the new item.</li></p>\r\n<li>If updating, you can click on the <img src=\"images/delete.gif\"> <b>Delete</b> button to delete this vendor as a supplier of this item.</li></p>\r\n<li>If you selected to Save the changes, your screen should look similar to \r\n  this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemVendorUpdateAdd2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To select a different Inventory Item, click on the <img src=\"images/back.gif\"> <b>Select Another Item</b> button.</li></p>\r\n<li>To select return to the Vendor selection screen for this same Inventory Item, click on the <img src=\"images/Back2.gif\"> <b>Add/Update Another Vendor Same Item</b> button. </li></p>\r\n\r\n</ol>',45),(47,12,'Item Summaries','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Item Summaries Report</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_itemSummaries/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this report to do a quick check on COST figures.</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Reports -> Item Summaries</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"> <img src=\"images/screenshots/Inventory_ItemSum.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the following information to narrow your report:</b></li></p>\r\n         <ol TYPE=\"a\">\r\n             <li><b> Location: </b> Select the Location from the pull-down list. Select ALL in the list for all locations. For information on setting up Locations, see <b>Locations</b> in the Related Topics section at the bottom of this Help topic.</li></p>\r\n             <li><b>Sort by: </b> Select how you would like the report sorted from the choices shown in the pull-down list.</li></p>\r\n             <li><b>Category: </b>Select ALL to include all Item Categories or select a Category from the pull-down list. For information on setting up Item Categories, see <b>Item Categories</b> in the Related Topics section at the bottom of this Help topic.</li></p>\r\n             <li><b>Page Size: </b>Enter the number of records you want to see on one page.</li></p>\r\n         </ol>\r\n\r\n<li>To display your report, click on the <img src=\"images/next.gif\"> <b>Next</b> button.  Your screen should look similar to this: </li></p>\r\n\r\n<b><i>Note: The number of items and the current page number are displayed at the top of the report.  A \"Back\" button is provided at the top as well to make navigation of a lengthy report easier.</b></i></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemSum1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To view On-Hand Details about the Item, click on the <b>number in the Qty On-Hand column</b>. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemSup4.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the report, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li> </p>\r\n\r\n<li>To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button.</li></p>\r\n\r\n</ol>',46),(48,12,'Item Prices','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Item Prices</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_itemPrices/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this report to view price lists and to see which items may not have prices entered.</em>\r\n<ol>\r\n\r\n<li>From the Main Menu, select <b><i>Inventory -> Reports -> Item Prices</b></i>.</li></P> \r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemP.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the following information to narrow your report:</b></li></p>\r\n         <ol TYPE=\"a\">\r\n             <li><b> Location: </b> Select the Location from the pull-down list. Select ALL in the list for all locations. For information on setting up Locations, see <b>Locations</b> in the Related Topics section at the bottom of this Help topic.</li></p>\r\n             <li><b>Sort by: </b> Select how you would like the report sorted from the choices shown in the pull-down list.</li></p>\r\n             <li><b>Price Level: </b>Select which Price Level you want on the report from the pull-down list.</li></p>\r\n             <li><b>Category: </b>Select ALL to include all Item Categories or select a Category from the pull-down list. For information on setting up Item Categories, see <b>Item Categories</b> in the Related Topics section at the bottom of this Help topic.</li></p>\r\n             <li><b>Page Size: </b>Enter the number of records you want to see on one page.</li></p>\r\n         </ol>\r\n</p>\r\n<li>To view your report, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should similar to this: </li></p>\r\n\r\n<b><i>Note: The number of items and the current page number are displayed at the top of the report.  A \"Back\" button is provided at the top as well to make navigation of a lengthy report easier.</b></i></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemPrice2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To see the Inventory Record of an item on the report, click on the Item Code of that Item on the report.</li></p>\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> button. </li></p>\r\n\r\n<li>To export the report into a file in Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button.</li></p>\r\n\r\n</ol>',47),(49,12,'Item Status','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Item Status Report</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_itemStatus/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this section to see how much of each item is on-hand, what is allocated for pending orders, how much inventory is available for new orders and what items have been ordered for delivery from our vendor.</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory ->  Reports -> Item Status</b></i>.</li></p>\r\n<li>Your screen should look similar to this: </li></P>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemListStatus.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the following information to narrow your report:</b></li></p>\r\n         <ol TYPE=\"a\">\r\n             <li><b> Location: </b> Select the Location from the pull-down list. Select ALL in the list for all locations. For information on setting up Locations, see <b>Locations</b> in the Related Topics section at the bottom of this Help topic.</li></p>\r\n            <li><b>Category: </b>Select ALL to include all Item Categories or select a Category from the pull-down list. For information on setting up Item Categories, see <b>Item Categories</b> in the Related Topics section at the bottom of this Help topic.</li></p>\r\n            <li><b>Sort by: </b> Select how you would like the report sorted from the choices shown in the pull-down list.</li></p>\r\n             <li><b>Page Size: </b>Enter the number of records you want to see on one page.</li></p>\r\n         </ol>\r\n</p>\r\n\r\n<li>To view your report, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should similar to this: </li></p>\r\n\r\n<b><i>Note: The number of items and the current page number are displayed at the top of the report.  A \"Back\" button is provided at the top as well to make navigation of a lengthy report easier.</b></i></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemListStatus2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button. </li></p>\r\n\r\n<li>To view the detail behind the numbers by clicking on any of the numbers in the Quantity columns.</li></p>\r\n\r\n</ol>',48),(50,12,'Item Usage History','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Item Usage History Report</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_itemUsageHistory/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>For any given period of time, you can view quantities of an item sold or used. </em>\r\n<ol>\r\n\r\n<li>From the Main Menu, select <b><i>Inventory-> Reports -> Item Usage History</b></i>. </li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemUsage1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the following information to narrow your report:</b></li></p>\r\n      <ol TYPE=\"a\">\r\n              <li><b>Item Name or Code â€“ ID: </b>Leave blank or if you want your report for a specific Inventory Item, enter Item Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Item number directly into the box on the right. If you want to search by description, type of item, vendor, category, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n              <li><b>Category: </b>Select ALL to include all Item Categories or select a Category from the pull-down list. For information on setting up Item Categories, see <b>Item Categories</b> in the Related Topics section at the bottom of this Help topic.</li></p>\r\n              <li><b>Vendor Name â€“ ID: </b> Leave BLANK for all Vendors or enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n              <li><b>Period: </b>Choose to summarize on <b>Month</b> or <b>Year</b> using the pull-down list.</li></p>\r\n              <li><b>Begin and End Dates: </b>Select beginning and ending dates for sales/usage to be included in this report. You can either enter the dates manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> buttons to bring up a calendar. </li></p>\r\n              <li><b>Category Subtotals: </b>Check the box if you want to see subtotals at the end of each category.</li></p>\r\n              <li><b>Use Order Receive Date: </b> Check the box if your date range should use the Order Receive Date(rather than the ship date).</li></p>\r\n        </ol>\r\n</p>\r\n<li>To view your report, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemUsage2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen, click the <img src=\"images/back.gif\"> <b>Back</b> button.</li> </p>\r\n\r\n<li>To view Shipment details for an Item, click on the number in the <b>Qty Sold column</b>. Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemUsage3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To export your report to a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button.</li></p>\r\n\r\n<li>To return to the report, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n\r\n</ol>',49),(51,12,'BOM list','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Bill of Materials (BOM) List</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_BOMList/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This report shows which items make up a composite item, and how many completed items can be made out of the available sub-components.  BOM = Bill of Materials (for composite items).</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Reports -> BOM List</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_BOM.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the following information to narrow your report:</b></li></p>\r\n      <ol TYPE=\"a\">\r\n           <li><b>Item Name or Code â€“ ID: </b> Enter Item Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Item number directly into the box on the right. If you want to search by description, type of item, vendor, category, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b>  button for detailed searches.</li></p>\r\n           <li><b>Sort by: </b> Select how you would like the report sorted from the choices shown in the pull-down list.</li></p>\r\n        </ol>\r\n</p>\r\n<li>To view your report, click on the <img src=\"images/next.gif\"> <b>Next</b>button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_BOM2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen, click the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n<li>To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button at the bottom of the screen.</li></p>\r\n\r\n<li>To see more details for an Item on the report, click on any selectable quantity number (Qty On-Hand, Qty Committed, Qty Available).  Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_BOM3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n    <ol TYPE=\"a\">\r\n         <li>To return to the main report, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n         <li>To export this report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button.</li></p>\r\n     </ol>\r\n</ol>',50),(52,12,'Item Distribution',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Item Distribution Report</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_itemDistribution/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this report to see how much of each item is on-hand, minimum and maximum stock levels, and reorder levels in each location.</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Reports -> Item Distribution</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemDist.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the following information to narrow your report:</b></li></p>\r\n         <ol TYPE=\"a\">\r\n             <li><b> Location: </b> Select the Location from the pull-down list. Select ALL in the list for all locations. For information on setting up Locations, see <b>Locations</b> in the Related Topics section at the bottom of this Help topic.</li></p>\r\n            <li><b>Sort by: </b> Select how you would like the report sorted from the choices shown in the pull-down list.</li></p>\r\n            <li><b>Category: </b>Select ALL to include all Item Categories or select a Category from the pull-down list. For information on setting up Item Categories, see <b>Item Categories</b> in the Related Topics section at the bottom of this Help topic.</li></p>\r\n            <li><b>Page Size: </b>Enter the number of records you want to see on one page.</li></p>\r\n         </ol>\r\n</p>\r\n<li>To view your report, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<b><i>Note: The number of items and the current page number are displayed at the top of the report.  A \"Back\" button is provided at the top as well to make navigation of a lengthy report easier.</b></i></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemDist2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To display details of an Item on the report, click on the <b>Qty On-Hand</b> number for that item. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemDist3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n       <ol TYPE=\"a\">\r\n             <li>To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button at the bottom of the screen.</li></p>\r\n             <li>To return to the main report, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button. </li></p>\r\n        </ol>\r\n</ol>\r\n\r\n',51),(53,12,'Physical Inventory',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Physical Inventory</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_PhysicalInventory/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this screen to gather actual counts when taking a physical inventory in order to correct on-hand quantities to reflect actuals.</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Physical Inventory</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_PhysInv.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the information in the following categories to narrow your selections: </b></li></p>\r\n       <ol TYPE=\"a\">\r\n             <li><b> Location: </b> (if you only have one location, you will not see this pull-down). Select the Location from the pull-down list. Select ALL in the list for all locations. For information on setting up Locations, see <b>Locations</b> in the Related Topics section at the bottom of this Help topic.</li></p>\r\n             <li><b>Sort by: </b> Select how you would like the report sorted from the choices shown in the pull-down list.</li></p>\r\n             <li><b>Search for Item Codes/Search for Item Name: </b>Enter an Item Number (or part of a number) in the Search for Item Code box or enter an Item Name (or part of a name) in the Search for Item Name box.</li></p>\r\n             <li><b>Results per Page: </b>Select the number of results you would like to see per page from the pull-down list.</li></p>\r\n       </ol>\r\n</p>\r\n<p>NOTE: To verify and post the amounts entered(see details further down), click on the <img src=\"images/reviewinventory.gif\"> <b>Review and Post Physical Inventory</b> button.</li></p>\r\n\r\n<li>To enter your physical inventory count, click the <img src=\"images/next.gif\"> <b>Create Report/Enter Counts</b> button. Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/PhysicalInventoryItemList.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the following information on this screen: </b></li></p>\r\n      <ol TYPE=\"a\">\r\n          <li><b>On-Hand column</b> - To keep the inventory count the same, click on the number (shown in blue) in the On-Hand column.</li></p>\r\n          <li><b>New Inventory Count</b> - To increase or decrease the quantity in inventory, enter the <b>quantity counted</b> in the New Inventory Count box. (Hint: enter \"-100\" to decrease the inventory count by 100)</li></p>\r\n          <li><b>Next (##) or Page Numbers</b> - To move to another page, click on the <b>Next (##)</b> link to see the next page(s) of results OR click on any of the numbers (pages) shown at the bottom of the screen to jump to a specific results page.</li></p>\r\n      </ol>\r\n</p>\r\n<li>To search again WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Physical3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To search again, click on the <img src=\"images/back.gif\"> <b>Back</b>   button.</li></p>\r\n\r\n<li>To verify and post the physical counts entered, click on the <img src=\"images/next.gif\"> <b>Review and Post Physical Inventory</b> button. Your screen should look similar to this:</li></p> \r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Physical4.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>Select how you would like to sort the data from the pull-down list.</li></p>\r\n\r\n<li>To continue, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Physical5.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>If you do not want to post the new count for this specific item, click on the <img src=\"images/cancel.gif\"> <b>Cancel</b> button.</li> </p>\r\n\r\n<li>Check the <b>Post</b> box for each item ready to be updated to Inventory. Checking this box selects this item\'s physical count to be updated in Inventory  and the value of the change in inventory posted to the General Ledger.</li> </p>\r\n\r\n<li>To CANCEL all updates and return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To update Inventory counts and post adjustments for any differences <b><i>(for the items with the Post box checked)</b></i>, click the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n\r\n<li>You will receive a confirmation screen stating your changes have been updated (as shown below).  To return to the Physical Inventory screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n</ol>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Physical6.jpg\"></p>\r\n<hr>',52),(56,12,'Enter/Update Build Orders','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Enter/Update Build Orders</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_BuildOrder/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Create Production orders to assemble composite items (such as kits).</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Manage Build Orders ->  Add/Update Build Orders</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Manage.jpg\"></p>\r\n<p align=\"left\">\r\n</ol>\r\n<hr>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add New Build Orders</strong></font></div>\r\n<hr>\r\n<ol>\r\n<li>To add a new Build Order, click on the <img src=\"images/add.gif\"> <b>Add</b> button on the first screen to bring up this screen:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Manage1a.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the following information to begin your Build Order: </b></li></p>\r\n    <ol TYPE=\"a\">\r\n        <li><b>Build Item (Kit or Catalog or Assembly): </b> Select the Build Item from the pull-down list (this list consists on any items that were checked as a COMPOSITE ITEM in the Item Add/Update area).  For more information on adding Inventory Items, see <b><i>Item Add/Update</b></i> in the Related Topics section at the bottom of this Help screen.</li></p>\r\n        <li><b>Inventory Location: </b>Select the Inventory Location from the pull-down list. NOTE: The Build Item needs to have this location attached to it before you can do an order for this location. (from Item Update screen, select Add/Update Locations).</li></p>\r\n     </ol>\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To continue with the Build Order, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Manage2.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the following information in the \"boxed\" fields: </b>\r\n      <ol TYPE=\"a\">\r\n           <li><b>Target Qty of Master Items to Produce:</b> Enter the number of completed Master Items you want to construct at the top of the screen.  When you TAB off of this number, the Quantity Committed boxes will be automatically filled.</li></p>\r\n           <li>The numbers in Qty Committed, Qty Used To Date, and Qty Returned  can be over-ridden, but default to the number of units you entered as required for each of the component pieces in Component Item Add/Update (from the Item Add/Update menu selection).</li></p>\r\n      </ol>\r\n\r\n<li>To return to the previous screen WITHOUT saving any changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n<li>To save the new Build Order, click on the <img src=\"images/save.gif\"> <b>Save</b> button. </li></p>\r\n</ol>\r\n<hr>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit Build Orders</strong></font></div>\r\n<hr>\r\n<p align=\"left\">\r\n<ol>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Manage.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Select the Build Order you would like to edit from the <b>Select Open Build Order to Edit/Finalize</b> pull-down list. </li></p>\r\n \r\n<li>Click the <img src=\"images/edit.gif\"> <b>Edit</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Manage3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the following information in the \"boxed\" fields: </b>\r\n     <ol TYPE=\"a\">\r\n           <li><b>Target Qty of Master Items to Produce: </b> Enter the number of completed Master Items you will construct at the top of the screen.  When you TAB off of this number, the Quantity Committed boxes will be automatically filled.</li></p>\r\n           <li><b>Qty Committed, Qty Used to Date, Qty Returned </b> - You can edit the Qty Committed (amount expected to be used when making this kit), Qty Used (the actual quantity used -- it defaults to the quantity committed) and Qty Returned (if you had previously indicated you had used 5000, but then found you had used only 4500, then you would enter a return quantity of 500 so your inventory counts remain correct).</li></p>\r\n          <li><b>Actual Master Items Produced to Date: </b> - Enter the ACTUAL number of Master Items Produced in the bottom box (the number of units entered here will increase the ON-HAND quantity of this item).</li></p>\r\n    </ol>\r\n\r\n<li>To save the changes and mark this as a PARTIALLY complete order, click on the <img src=\"images/save.gif\"> <b>Partially Complete</b> button.</li></p>\r\n\r\n<li>To return to the previous screen WITHOUT saving any changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To erase the Build Order (only any remaining UNCOMPLETED orders), click on the <img src=\"images/delete.gif\"> <b>Delete</b> button. </li></p>\r\n\r\n<li>To FINALIZE a completed order, click on the <img src=\"images/next.gif\"> <b>Finalize Build Order</b> button. You will see the following question: </b> </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Manage3a.jpg\"></p>\r\n<p align=\"left\">\r\n       <ol TYPE=\"a\">\r\n           <li>To complete the finalization of your Build Order, select <b>OK</b></li>\r\n           <li>To return to previous screen WITHOUT completing the Order, select <b>Cancel</b>.</li></p>\r\n       </ol>\r\n\r\n</ol>\r\n',55),(57,13,'Vendor Add/Update',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Vendor Add/Update</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_vendor_maintenance/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This page allows editing of Vendors for use in Payables, Purchasing and Inventory.</em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Vendors -> Vendor Add/Update</b></i>.</li></p>\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/VendorUpdate.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Vendor Name â€“ ID: </b> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n    <ol TYPE=\"a\">\r\n          <li>To ADD a new vendor, click on the <img src=\"images/add.gif\"> <b>Add</b> button.</li></p>\r\n          <li>To EDIT, select a vendor and click on the <img src=\"images/edit.gif\"> <b>Edit</b> button. </li></P>\r\n    </ol>\r\n<li>Whether ADDING or EDITING, your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/VendorUpdate1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter or modify data in the following categories: </b></li></p>\r\n\r\n     <ol TYPE=\"a\">\r\n         <li><b>Company Name: </b>Enter the corporate name of this vendor. This is the name you will see on your reports and use to identify this vendor in the NolaPro system.</li></p>\r\n         <li><b>Name: </b>Enter a Contact Name for this company.</li></p>\r\n         <li><b>Vendor Code: </b>Enter a code to identify this vendor.  You can use this code to quickly lookup a vendor\'s record.</li></p>\r\n         <li><b>Address:</b> Two lines are provided for the complete address.</li></p>\r\n         <li><b>City: </b>Enter the city where this vendor is located.</li></p>\r\n         <li><b>State:</b> Select a state from the drop-down menu.</li></p>\r\n         <li><b>Postal Code:</b> Zip code or Postal Code.</li></p>\r\n         <li><b>Country: </b>Enter the country where this vendor is located.</li></p>\r\n         <li><b>Mail Stop:</b> If the vendor is a large concern that uses internal mailing, you may need to include a mail stop in order for mailings to reach the right person.</li></p>\r\n         <li><b>Phone and Description:</b> Three(3) phone numbers can be entered for this vendor. Because of that, a description field is provided for each phone so you can tell what its use is (warehouse, office, fax, etc.)</li></p>\r\n         <li><b>E-mail and Description:</b> Vendor email address and a description about WHO the email address belongs to.</li></p>\r\n         <li><b>Web Address:</b> If the vendor has a web-site, enter that here.</li></p>\r\n         <li><b>Federal ID:</b> For tax information you will need the vendor federal tax ID number.  Do NOT enter any dashes.</li></p>\r\n         <li><b>Order From Company Information:</b> If this is to be the SAME as already entered in the upper portion, check the \"Order From same as above\" box. If the name and address you order from is DIFFERENT from the PAY TO information, then enter that information here.  Only ONE phone number entry is provided in this section.</li></p>\r\n         <li><b>Image:</b> For the purposes of the SHOPPING CART you can attach a vendor BRAND image that can show on the Shopping Cart display.  If you have entered one for this vendor, it will display towards the top of this screen. Use the BROWSE to find a copy of the image locally and upload it to your server.</li></p>\r\n         <li><b>Payment Terms:</b> Select the USUAL terms extended to you by this vendor. These terms can be over-ridden during individual bills entry. If you need to a new Terms Code, click on the <img src=\"images/add.gif\" width=\"20\" height=\"20\"> <b>Add</b> button.</li></p>\r\n         <li><b>Pay None:</b> This is a payables function.  You can check this box if you want to place all of this vendors bills on HOLD - - not to be paid.</li></p>\r\n         <li><b>No Returns Accepted: </b>Enter a checkmark if returns are not accepted.</li></p>\r\n         <li><b>Lead Time(Days): </b>Enter the number of days it takes between ordering from the vendor and arrival of the ordered items.</li></p>\r\n         <li><b>Default Shipping Method: </b>Select this vendor\'s usual Shipping Method from the pull-down list.</li></p>\r\n         <li><b>Default GL Account:</b> The USUAL GL Account used for indicating what expense type this purchase is.</li></p>\r\n         <li><b>Default Bill Description:</B> The USUAL Description for this bill.  Some people like to use the vendor name for this because then it shows on the journal entries.</li></p>\r\n         <li><b>Customer Account:</b> The account number assigned by this vendor to your company.</li></p>\r\n         <li><b>Shopping Cart Display:</b> Should this vendor BRAND information show up on the Shopping Cart.  Check the box for YES.</li></p>\r\n         <li><b>View/Upload/Delete - Vendor Files:</b> You can attach pictures, documents, etc. to each Vendor(order agreements, notices, product images, etc.). See the <b>Attaching Files</b> topic in the Related Topics section to see how this is done.</li></p>\r\n      </ol>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li> </p>\r\n\r\n<li>To delete the vendor, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button (only available if EDITING).</li></p>\r\n\r\n<li>To return to the previous screen WITHOUT saving the changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n<li>To pay this vendor, click on the <img src=\"images/costofgoods.gif\"> <b>Pay Vendor</b> button.  This will take you directly to the check writing screen. For instructions on writing Accounts Payable Checks, see the <b><i>Write Checks</b></i> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To enter additional contact information, click on the <img src=\"images/add.gif\"  width=\"16\" height=\"16\"> <b>Add</b> button beside the words <b><font color=\"0000FF\">Additional Contact Information</b></font>.  For detailed instructions about this feature, see the section below titled <b>Entering Additional Contact Information</b>.</li></p>\r\n\r\n\r\n<li>To view unpaid bills for this vendor, click on the <img src=\"images/view.gif\"> <b>View Bills</b> button.  Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/VendorUpdate3.jpg\"></p>\r\n<p align=\"left\">\r\n     <b><p>A list open invoices for this vendor will be displayed.</b>  </p>\r\n   <ol TYPE=\"a\">\r\n\r\n          <li>To sort the report in another way, click on the Vendor, Invoice Date, Due Date, Invoice# or Amount column titles.</li></p>\r\n          <li>To view more details on an invoice, click on the <b>Invoice Number</b> on the report.</li></p>\r\n          <li>To return to the Vendor Add/Update screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n    </ol>\r\n  \r\n</ol>\r\n<br>\r\n<hr>\r\n <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Entering Additional Contact Information</strong></font></div>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/VendorUpdate2.jpg\"></p>\r\n<p align=\"left\">\r\n<br>\r\n<ol>\r\n<li><b>Select Contact: </b>Select the Contact record you wish to view from the pull-down list. The General Contact Information record is automatically displayed. To add additional contacts, click on the <img src=\"images/add.gif\" width=\"18\" height=\"18\"> <b>Add</b> button to the right of the pull-down list.</li></p>\r\n\r\n<li> Enter the name, address and other contact information for up to two contacts per record.</li></p>\r\n\r\n<li>To save your contact information, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n\r\n<li>To return to the Vendor Add/Update screen WITHOUT SAVING your changes, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n</ol>\r\n<br>',56),(58,13,'Vendor List/Labels',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Vendor Lists/Labels</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_vendor_lists_and_labels/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this process to produce a Vendor List either on-screen or in a CSV(comma-separated values) format for exporting and Mailing Labels for Vendors in  Payables, Purchasing and Inventory.</em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Vendors -> Vendor Lists/Labels</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/VendorListsandLabels.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Choose which type of list you want by clicking on the list name:</li></p>\r\n      <ol TYPE=\"a\">\r\n           <li><b>CSV List</b> - Generates a comma delimited (CSV) list of vendors. May be displayed in your browser if Microsoft ExcelÂ® or another handler is installed, otherwise you will be prompted to save the file. </li></p>\r\n           <li><b>On-screen Vendor List</b> - This link generates an on screen list of your vendors.</li></p>\r\n           <li><b>Mailing Labels: Pay to Locations</b> - Generates a page of mailing labels for your vendors (1 x 2.63 in., 30 page, Avery 5160). May be displayed as a PDF document in a new window. It requires Adobe Acrobat Reader or another PDF viewer to display correctly.</li></p>\r\n           <li><b>Mailing Labels: Order From Locations</b> - Generates a page of mailing labels for your vendors (1 x 2.63 in., 30 page, Avery 5160). May be  displayed as a PDF document in a new window. It requires Adobe Acrobat Reader or another PDF viewer to display correctly.</li></p>\r\n      </ol>\r\n</ol>\r\n<br>',57),(60,14,'New Purchase Order',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> New Purchase Order</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_purchasing_po_add/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>A purchase order is the written authorization for a vendor to ship merchandise and bill the customer for it. </em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Purchasing ->  PO Add/Update</b></i>. </li></p>\r\n\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/UpdateInventoryPO1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Enter NO data on this screen, just click on the <img src=\"images/add.gif\"> <b>Add</b> button to start a new Purchase Order. Your screen should then look like this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/AddInventoryPO.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Ente data into the following categories: </b></li></p>\r\n    <ol TYPE=\"a\">\r\n           <li><b>Vendor Name â€“ ID: </b> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.  NOTE: To add a new vendor, click on the <img src=\"images/add.gif\" width=\"20\" height=\"20\"> <b>Add</b> button.  For instructions on adding new vendors, see the <b><i>Vendor Add/Update </b></i>topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n           <li><b>Contact: </b>Name of contact person at the vendor\'s place of business.</li></p>\r\n           <li><b>Vendor Order #: </b>Enter the Vendor-assigned order number.</li></p>\r\n           <li><b>Due Date: </b>Select the date when the items should be delivered. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n           <li><b>Requisition #:</b>Enter the Requistion Number(if any) your company has assigned to this Purchase as authorization to place the order.</li></p>\r\n           <li><b>Inventory Location: </b>Where the items being purchased should be delivered. Select a location from the pull-down list.</li></p>\r\n           <li><b>Shipping Method: </b>How the items should be shipped - select from the pull-down list.</li></p>\r\n           <li><b>Tracking Number: </b>If the vendor provides the shipment tracking number you can enter it here.</li></p>\r\n           <li><b>Main Page Note: </b>Enter any notes you wish to appear on the main page of the purchase order.  These notes appear above the line items.</li></p>\r\n          <li><b>Notes to Print on pages following Main Purchase Order: </b>If you have entered standardized notes, you can select any or all of those notes to appear on the Purchase Order. After you have selected one of these notes, you will be able to click on an <b>EDIT</b> button to change any of the text for just THIS transaction. The standard text will remain the same. The <b>ORDER AFTER PO</b> box is to indicate which text appears first, which next, etc.</li></p>\r\n    </ol>\r\n\r\n<li>To continue, click on the <img src=\"images/next.gif\"> <b>Next</b> button. </li></p>\r\n\r\n<p>The first time you see this screen, it will have a single line for entry, and no COMPLETE button. When you enter the first item, and press the ADD button, you will be shown another blank line in addition to the one you entered, and NOW you will see the COMPLETE button. Two screens are shown below; the first showing the screen BEFORE the ADD button is pressed, and the second showing the screen AFTER the ADD button is pressed.</p>\r\n\r\nYour screen should look similar to this: \r\n<p align=\"center\"><img src=\"images/screenshots/AddInventoryPO1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<p>For INVENTORY items being ordered, you ONLY need to enter the item code and quantity and press the ADD button. The other information will fill in. If the price is not the current price, you can then over-ride it with the current price. For NON-INVENTORY items, you will need to enter ALL information EXCEPT item code before pressing the ADD button.</p>\r\n\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n       <ol TYPE=\"a\">\r\n             <li><b>Item Code: </b> NOTE: NO item code entered means that this is an order for a non-inventory item. However, you must fill in the description field in this instance.  For Inventory Items, enter the Item Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Item number directly into the box below the description. If you want to search by description, type of item, vendor, category, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n            <li><b>Description: </b>Only fill this in for NON-inventory items. For inventory items, once you ADD the entry, it will pull the description from the item file.</li></p>\r\n            <li><b>Quantity: </b>How many of the item you would like to order. NOTE: This quantity should be of the same units shown next to PRICE (i.e. if the price unit is BOXES, be sure to enter the number of boxes, not the number of pieces or cases).</li></p>\r\n            <li><b>Price/Unit: </b>Price at the unit size shown. NOTE: Price and unit name will pull from the inventory when you SAVE the information, but can then be over-ridden manually.</li></p>\r\n            <li><b>GL Account: </b>The Inventory account that should be adjusted in General Ledger. NOTE: This account will fill in automatically for any Inventory item (once you click ADD).</li></p>\r\n       </ol>\r\n\r\n<li>AFTER you make changes to a previously entered item or to enter a new line item on the Purchase Order, click the <img src=\"images/add.gif\"> <b>Add</b> button. This will allow you to stay on this screen and continue to make changes or add items.</li></p>\r\n\r\n<li>To return to the previous screen WITHOUT SAVING your entries, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n<li>When all items have been added to the Purchase Order, click the <img src=\"images/completepo.gif\"> <b>Complete PO</b> button.</li></p>\r\n\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/AddInventoryPO3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the Purchase Order Add/Update screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To make changes to the current Purchase Order, click on the <img src=\"images/edit.gif\"> <b>Edit</b> button. For details on editing a Purchase Order, see the <b><i>Update PO</b></i> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To email a copy of this Purchase Order, click on the <img src=\"images/email.gif\"> <b>Email</b> button.  For details on using the Email Center, see the <b><i>Email Center</b></i> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To print this Purchase Order in Adobe Acrobat ReaderÂ®(.PDF) format, click on the <img src=\"images/pdf.gif\" > <b>Print</b> button to print this Purchase Order.  See <b>SAMPLE PURCHASE ORDER</b> below to view an example of the printed output.</li></p>\r\n\r\n</ol>\r\n<br><hr>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\">  <b>SAMPLE PURCHASE ORDER</b></font></div>  \r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/AddInventoryPO4.jpg\"></p>\r\n<p align=\"left\">\r\n',59),(61,14,'Update Purchase Order','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Update PO</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_purchasing_po_update/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This chapter allows editing of Purchase Orders.  A Purchase Order is the written authorization for a vendor to ship merchandise and bill the customer for it. </em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Purchasing -> PO Add/Update</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/UpdateInventoryPO1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<p>(To ADD a new Purchase Order, click on the <img src=\"images/add.gif\"> <b>Add</b> button. Please see the <b><i>New Purchase Order</b></i> topic in the Related Topics section at the bottom of this Help screen.)</p>\r\n\r\n<li><b>Enter data in one or more of the following categories:</b> (Note: the more fields you fill in, the shorter will be the list of matching PO\'s.) </li></p>\r\n   <ol TYPE=\"a\">\r\n      <li><b>Vendor Name â€“ ID: </b>Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n      <li><b>PO #: </b>This is the Purchase Order number that you originally entered. NOTE: If you know the PO Number, you do not need to enter any other information, just click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p>\r\n      <li><b>Carrier Service: </b>Select the Carrier Service you would prefer to use from the pull-down list.</li></p>\r\n      <li><b>Location: </b>Where the items being purchased should be delivered. Select a location from the pull-down list.</li></p>\r\n      <li><b>Due Date: </b>Enter the date you expect to receive this purchase.  You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n      <li><b>Requisition #: </b>Enter the Requistion Number your company has assigned to this Purchase as authorization to place the order (if known).  NOTE: If you know the Requistion#, you do not need to enter any other information, just click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p></li></p>\r\n      <li><b>Vendor Order #: </b>Enter the Vendor Order# provided to you by your vendor (if known). NOTE: If you know the Vendor Order#, you do not need to enter any other information, just click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p>  </p>\r\n   </ol>\r\n\r\n<li>To get a list of the Purchase Orders meeting your criteria, click on the <img src=\"images/next.gif\"> <b>Next</b> button. If more than one Purchase Order  matches your entries, the next screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"> <img src=\"images/screenshots/UpdateInventoryPO2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To EDIT the Purchase Order, click on the <font color=\"0000FF\">PO#</font> of the order you want to update.  Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/UpdateInventoryPO3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Ente data into the following categories: </b></li></p>\r\n    <ol TYPE=\"a\">\r\n           <li><b>Vendor Name â€“ ID: </b> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches. </li></p>\r\n           <li><b>Contact: </b>Name of contact person at the vendor\'s place of business.</li></p>\r\n           <li><b>Order #: </b>Enter the Vendor-assigned order number.</li></p>\r\n           <li><b>PO#: </b>If you need to change the Purchase Order#, enter the new Purchase Order#.</li></p>\r\n           <li><b>Due Date: </b>Select the date when the items should be delivered. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n           <li><b>Requisition #:</b>Enter the Requistion Number(if any) your company has assigned to this Purchase as authorization to place the order.</li></p>\r\n           <li><b>Inventory Location: </b>Where the items being purchased should be delivered. Select a location from the pull-down list.</li></p>\r\n           <li><b>Shipping Method: </b>How the items should be shipped - select from the pull-down list.</li></p>\r\n           <li><b>Tracking Number: </b>If the vendor provides the shipment tracking number you can enter it here.</li></p>\r\n           <li><b>Main Page Note: </b>Enter any notes you wish to appear on the main page of the purchase order.  These notes appear above the line items.</li></p>\r\n          <li><b>Notes to Print on pages following Main Purchase Order: </b>If you have entered standardized notes, you can select any or all of those notes to appear on the Purchase Order. After you have selected one of these notes, you will be able to click on an <b>EDIT</b> button to change any of the text for just THIS transaction. The standard text will remain the same. The <b>ORDER AFTER PO</b> box indicates which text appears first, which next, etc.</li></p>\r\n    </ol>\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To delete this Purchase Order, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button. </li></p>\r\n\r\n<li>To continue editing the line items on this Purchase Order, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n\r\n<li>Your screen should look similar to this: \r\n<p align=\"center\"><img src=\"images/screenshots/UpdateInventoryPO4.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<p>For INVENTORY items being ordered, you ONLY need to enter the item code and quantity and press the SAVE button. The other information will fill in. If the price is not the current price, you can then over-ride it with the current price. For NON-INVENTORY items, you will need to enter ALL information EXCEPT item code before pressing the SAVE button.</p>\r\n\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n       <ol TYPE=\"a\">\r\n             <li><b>Item Code: </b> NOTE: NO item code entered means that this is an order for a non-inventory item. However, you must fill in the description field in this instance.  For Inventory Items, enter the Item Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Item number directly into the box below the description. If you want to search by description, type of item, vendor, category, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n            <li><b>Description: </b>Only fill this in for NON-inventory items. For inventory items, once you ADD the entry, it will pull the description from the item file.</li></p>\r\n            <li><b>Quantity(in Sell Units): </b>How many of the item you would like to order. NOTE: This quantity should be of the same units as the PRICE UNITS(i.e. if the price unit is BOXES, be sure to enter the number of boxes, not the number of pieces or cases).</li></p>\r\n            <li><b>Price per Unit: </b>Price at the unit size shown. NOTE: Price and unit name will pull from the inventory when you SAVE the information, but can then be over-ridden manually.</li></p>\r\n            <li><b>GL Account: </b>The Inventory account that should be adjusted in General Ledger. NOTE: This account will fill in automatically for any Inventory item (once you click SAVE).</li></p>\r\n            <li><b>Delete: </b>Checking the <b>Delete</b> box for a line item will remove any PENDING quantity for that item from the Purchase Order.</li></p>\r\n       </ol>\r\n\r\n<p>If you add an another line item, click on the <img src=\"images/save.gif\"> <b>Save</b> button and another blank line item will appear.</p>\r\n\r\n<li>To return to the Purchase Order List WITHOUT SAVING your entries, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n\r\n<li>To email a copy of this Purchase Order, click on the <img src=\"images/email.gif\"> <b>Email</b> button.  For details on using the Email Center, see the <b><i>Email Center</b></i> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To print this Purchase Order in Adobe Acrobat ReaderÂ®(.PDF) format, click on the <img src=\"images/pdf.gif\" > <b>Print</b> button to print this Purchase Order.  See <b>SAMPLE PURCHASE ORDER</b> below to view an example of the printed output.</li></p>\r\n\r\n</ol>\r\n<br><hr>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\">  <b>SAMPLE PURCHASE ORDER</b></font></div>  \r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/UpdateInventorySamplePO.jpg\"> </p>\r\n\r\n',60),(62,14,'Receive Items on PO','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Receive Items on PO</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_purchasing_po_receive/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter when you receive a shipment from your vendor when you used a Purchase Order number for the order. </em>\r\n\r\n<ol>\r\n\r\n<li>From the Main Menu, select <b><i>Payables -> Purchasing -> Receive Items on PO</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryPOReceive.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Enter search data in one or more of the following categories:<b>NOTE: If you know the PO number, that is the only information you need enter.</b></li></p>\r\n   <ol TYPE=\"a\">\r\n       <li><b>Vendor Name â€“ ID: </b>Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n       <li><b>PO #: </b>This is the Purchase Order number that you originally entered. NOTE: If you know the PO Number, you do not need to enter any other information, just click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p>\r\n            <li><b>Carrier Service: </b>Select the Carrier Service you would prefer to use from the pull-down list.</li></p>\r\n      <li><b>Location: </b>Where the items being purchased should be delivered. Select a location from the pull-down list.</li></p>\r\n      <li><b>Due Date: </b>Enter the date you expect to receive this purchase.  You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n      <li><b>Requisition #: </b>Enter the Requistion Number your company has assigned to this Purchase as authorization to place the order (if known).  NOTE: If you know the Requistion#, you do not need to enter any other information, just click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p></li></p>\r\n      <li><b>Vendor Order #: </b>Enter the Vendor Order# provided to you by your vendor (if known). NOTE: If you know the Vendor Order#, you do not need to enter any other information, just click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p>  </p>\r\n   </ol>\r\n\r\n<li>To view a list of Purchase Orders the meet your criteria, click on the <img src=\"images/next.gif\"> <b>Next</b> button. If more than one PO matches the entries made, your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryPOReceive1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen WITHOUT making any changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To receive items on a Purchase Order, click on the desired PO#. Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryPOReceive2.jpg\"></p>\r\n<p align=\"left\">\r\n<br>\r\n<p>What you see will be a header section showing the general information about this PO, followed by a listing of all the items ON the PO showing how many were ordered, how many have already been received, and giving you a place to enter newly received quantities and to change the price.</p><br>\r\n\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n       <ol TYPE=\"a\">\r\n          <li><b>Quantity Received: </b> Enter the actual quantity you received from the vendor, not the quantity you ordered.</li></p>\r\n          <li><b>Quantity Received Damaged: </b>Enter the quantity of received  items that were damaged.  NOTE: Include this count in the Quantity Received quantity entered.</li></p>\r\n          <li><b>Price/Unit: </b>Enter the price you were charged on the invoice, NOT the price you put down in the original Purchase Order. Make note you are putting the price for the units shown (i.e. For this example, enter the price of a Carton not the price per item).  </li></p>\r\n          <li><b>Notes: </b>Enter any notes regarding this receipt of items.</li></p>\r\n          <li><b>Tracking #: </b>You will find this number on the packing slip or on the outside of the box.</li></p>\r\n          <li><b>PO Complete: </b>Check this box ONLY if you received everything ordered on the Purchase Order. </li></p>\r\n     </ol>\r\n\r\n<li>To go back to the list of Purchase Orders WITHOUT receiving any items, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To receive the shipment, click on the <img src=\"images/completebill.gif\"> <b>Receive PO</b> button. You will see a confirmation screen similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryPOReceive3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To go back to the list of Purchase Orders, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n',61),(63,14,'Completed PO to AP','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Completed PO to AP</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_purchasing_po_to_ap/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>When you receive a bill from a vendor, you can transfer items received on Purchase Orders to the Accounts Payable system for bill payment. This process provides a double-check because you cannot include on a bill a greater quantity of an item than was received.</em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Purchasing -> Completed PO to AP</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"> <img src=\"images/screenshots/InventoryPOPassToPayables.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data in ALL of the following categories: </b></li></p>\r\n    <ol TYPE=\"a\">\r\n        <li><b>Vendor Name â€“ ID: </b> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n        <li><b>Location: </b>Select the location from the pull-down list.</li></p>\r\n        <li><b>Invoice #: </b>Enter the invoice number appearing on the vendor bill.</li></p>\r\n        <li><b>Invoice Date: </b> Enter the date on the vendor bill. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n    </ol>\r\n\r\n<li>To continue, click on the <img src=\"images/next.gif\"> <b>Next</b> button.  Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"> <img src=\"images/screenshots/InventoryPOPassToPayables1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Verify the data in the following categories: </b></li></p>\r\n     <ol TYPE=\"a\">\r\n           <li><b>Include? box: </b>To include this line item on the bill, click on the <b>Include?</b box to put a checkmark in the box.</li></p>\r\n           <li><b>Qty Received: </b>Change the Quantity of items received, if necessary.</li></p>\r\n           <li><b>Price Per Unit: </b>Change the Price Per Unit, if necssary.</li></p>\r\n      </ol>\r\n\r\n<li>When all items appearing on your bill have been selected, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryPOPass.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n     <ol TYPE=\"a\">\r\n        <li><b>Freight: </b>This is how much you were charged for shipping the items.</li></p>\r\n        <li><b>Tax: </b>This is the amount of tax you were charged.</li></p>\r\n        <li><b>Discount Date: </b>This date will auto-calculate based on the vendor terms. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n        <li><b>Due Date: </b>This date will auto-calculate based on the vendor terms. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n        <li><b>Discount Amount: </b>This amount will automatically be calculated based on the vendor terms, but you can change it to match the bill.</li></p>\r\n        <li><b>Pre-Paid: </b>A pre-paid bill, will post as completed and will not show up as needing to be paid. Check the box if pre-paid.</li></p>\r\n     </ol>\r\n\r\n<li>To return to the list, WITHOUT GENERATING AN INVOICE, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To complete the bill, click on the <img src=\"images/save.gif\"> <b>Save</b> button. This bill will now show up in Payables.</li></p>\r\n\r\n<li>You will see a confirmation screen similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryPOPass1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the Completed PO to AP screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>',62),(64,14,'Purchase Order List','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Purchase Order Lists</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_purchasing_po_lists/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This chapter will provide you with a list of all your Purchase Order numbers.  In this chapter you also have the option to Receive a PO, Edit a PO or Print a PO. </em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Purchasing -> Purchase Order Lists</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryPOList.jpg\"> \r\n<p align=\"left\">\r\n\r\n<li><b>Enter search data in one or more of the following categories:</b></li></p>\r\n    <ol TYPE=\"a\">\r\n        <li><b>PO #: </b>Enter the PO # if you just want to see that PO. Leave BLANK to see all POs.</li></p>\r\n        <li><b>Vendor Name â€“ ID: </b> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches. Leave BLANK to see all vendors. </li></p>\r\n        <li><b>Carrier Service: </b>If list is for a specific carrier, select one from the pull-down list.</li></p>\r\n        <li><b>Location: </b>To limit the list to a specific location, select from the pull-down list.</li></p>\r\n        <li><b>Due Date: </b>To limit the list to POs with a specific due date, you can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n        <li><b>Requisition #: </b>Enter a specific Requisition# to limit the report to that number.</li></p>\r\n        <li><b>Order #: </b>To limit the report to a specific vendor order number, enter it here.</li></p>\r\n        <li><b>Show Pending: </b>Check this box if you want to see PENDING POs.</li></p>\r\n        <li><b>Show Received: </b>Check this box if you want to see RECEIVED POs.</li></p>\r\n        <li><b>Partial Text in PO Detail Notes: </b>Enter words(or parts of words) to search for in the Detail Notes.</li></p>\r\n        <li><b>List Sort By: </b>Select how you want to sort the report from the pull-down list.</li></p>\r\n    </ol>\r\n\r\n<li>To view the Purchase Orders meeting your criteria, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryPOList1.jpg\">\r\n<p align=\"left\">\r\n\r\n<li>Using the Order pull-down list at the top, you can change the sort order of the list.</li></p>\r\n\r\n<li>To UPDATE the PO, click on the <img src=\"images/edit.gif\" width=\"18\" height=\"18\"> <b>Edit</b> button. See the <b><i>Update Purchase Order</b></i> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To RECEIVE items on a PO, click on the <img src=\"images/ReceivePO.gif\" width=\"18\" height=\"18\"> <b>Receive PO</b> button. See the <b><i>Receive Item on PO</b></i> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To return to the Purchase Order List screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button at the bottom of the screen.</li></p>\r\n\r\n<li>To PRINT a copy of the PO, click on the <font color=\"0000FF\">Purchase Order Number</font>.</li> </p>\r\n\r\n</ol>\r\n<br><br><hr><br>\r\n<center><big><b>SAMPLE PO PRINT</b></big></center>\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryPOPrint1.jpg\"> \r\n<p align=\"left\">',63),(65,14,'Receive without PO','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Receive Without PO</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_purchasing_recieve_no_po/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Receive items into inventory that did not first have a PO written.</em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Purchasing -> Receive Without PO</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ReceiveItemsIntoInventory.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Vendor Name â€“ ID: </b> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n\r\n<li>To continue, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ReceiveItemsIntoInventory1.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n    <ol TYPE=\"a\">\r\n         <li><b>Item Name or Code â€“ ID: </b> Enter Item Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Item number directly into the box on the right. If you want to search by description, type of item, vendor, category, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n        <li><b>Date Received: </b>This will default to today\'s date, but you can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n        <li><b>Tracking Number (BOL or Other): </b>Enter Tracking Number from the Bill of Lading (BOL) or other shipping documents.</li></p>\r\n        <li><b>Receive Location: </b>Select which location these items were received at from the pull-down list.</li></p>\r\n    </ol>\r\n\r\n<li>To enter the quantity received and base costs, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ReceiveItemsIntoInventory2.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>Enter the necessary information in the following categories (<b>Note: if this vendor has been used before for this item, some of this information will be automatically filled in)</b>: </li></p>\r\n    <ol TYPE=\"a\">\r\n          <li><b>Vendor Product Code: </b>This is the product code the vendor uses to identify the item, NOT your item code.</li></p>\r\n          <li><b>Quantity units received: </b>Enter the quantity of the item you received. </li></p>\r\n          <li><b>Base Cost per unit: </b>Enter the base cost per unit.</li></p>\r\n          <p>At the bottom of the screen, you will see a detailed list of the Cost per each and the Qty. of each per cost. This is so you can update this vendor\'s pricing schedule for this item.</p>\r\n      </ol>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ReceiveItemsIntoInventory4.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>To return to receive more items for this vendor, click on the <img src=\"images/Back2.gif\"> <b>New Item Same Vendor</b> button.</li></p>\r\n\r\n<li>To return to select a new vendor, click on the <img src=\"images/back.gif\"> <b>New Vendor</b> button.</li></p>\r\n\r\n</ol>\r\n\r\n',64),(67,15,'New Vendor Bill','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> New Vendor Bill</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_vendor_bill_add/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use to enter vendor invoices and distribution amounts if not brought into payables automatically by one of the other modules.</em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Bill Add/Update</b></i>. </li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/BillUpdate4.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Enter NO data on this screen, just click on the <img src=\"images/add.gif\"> <b>Add</b> button. Your screen should now look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/AddBill.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n        <ol TYPE=\"a\">\r\n             <li><b>Invoice #: </b>Number provided by the vendor (printed on the vendor invoice).</li></p>\r\n             <li><b>Vendor Name â€“ ID: </b> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.  To add a new Vendor, click on the <img src=\"images/add.gif\" width=\"18\" height=\"18\"> <b>Add</b> button. For instructions on adding a new vendor, see the <b><i>Vendor Add/Update</b></i> section in the Related Topics section at the bottom of this Help screen.</li></p>\r\n            <li><b>Total (invoice total).</b> Including shipping and tax.</li></p>\r\n            <li><b>Invoice Date.</b> You can either enter the date manually or click on the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n       </ol>\r\n\r\n<li>To continue adding the new bill, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/BillAdd1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data in the following categories (Note: if the vendor information for defaults and terms are set correctly, you may need to change nothing here):</b></li></p>\r\n      <ol TYPE=\"a\">\r\n            <li><b>Description.</b> What the invoice is for (or some uses like to use the vendor name here).</li></p>\r\n            <li><b>Discount Amount</b>, if any.</li></p>\r\n            <li><b>Discount Date.</b> The date you must pay the invoice by to receive a discount. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n            <li><b>Due Date.</b> The date the invoice is actually due. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n     </ol>\r\n\r\n<li>To continue, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/BillAdd2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<em>When you first enter a new bill, you will see 9 lines for possible distribution entries.  The GL account will be the default one. You can fill in amounts in as many of these as you like. You will NOT see the COMPLETE BILL button until you have entered amounts equal to the original invoice total entered.</em><br>\r\n<br>\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n     <ol TYPE=\"a\">\r\n         <li><b>Amount: </b>Either enter the full amount of this invoice or the amount for this GL account.</li></p>\r\n         <li><b>GL Account: </b>Select the GL Account from the pull-down list. </li></p>\r\n     </ol>\r\n\r\n<li>To add more lines for distributions, click on the <img src=\"images/add.gif\"> <b>Add More Input Lines</b> button.</li></p>\r\n\r\n<li>To return to the previous screen WITHOUT SAVING your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To finalize the bill, the entries must be balanced(Difference = 0.00). Click on the <img src=\"images/completebill.gif\"> <b>Complete Bill</b> button.  You will receive a Confirmation screen similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/BillAdd3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the Bill Add/Update screen to add more bills, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n</ol>',66),(68,15,'View/Change Bills','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> View/Change Bills</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_vendor_bill_update/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Edit vendor invoices and distribution amounts whether the invoice was entered in payables or brought into payables automatically by one of the other modules.</em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Bills Add/Update</b></i>.</li></p>\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/BillUpdate4.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Enter search data in one or more of the following categories:</li></p>\r\n      <ol TYPE=\"a\">\r\n             <li><b>Invoice #: </b>The invoice number from the vendor\'s invoice. If you do not know this, leave it blank. If you DO know this, you can leave all the other information blank.</li></p>\r\n             <li><b>Vendor Name â€“ ID: </b>(Leave blank to search all Vendors) Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n             <li><b>Begin  and End Date of Invoice.</b> You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to bring up a calendar.</li></p>\r\n             <li><b>Begin And End Due Date.</b> You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to bring up a calendar.</li></p>\r\n       </ol>\r\n\r\n<li>To view invoices matching your selections, click the <img src=\"images/next.gif\"> <b>Next</b> button. If only one invoice matches your selections, you will skip this screen. If there are more than one, your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/UpdateBill.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>To EDIT an Invoice, click on the <font color=\"000FF\">Invoice #</font>. Your screen should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/UpdateBill1.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>You can modify any or all of the following:</b></p>\r\n      <ol TYPE=\"a\">\r\n          <li><b>Invoice #: </b></li></p>\r\n          <li><b>Vendor Name â€“ ID: </b> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n          <li><b>Total (amount due): </b> Include the shipping or tax.</li></p>\r\n          <li><b>Date of Invoice: </b> You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b>  \r\nbutton to bring up a calendar.</li></p>\r\n          <li><b>Due Date: </b> You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b>  \r\nbutton to bring up a calendar.</li></p>\r\n          <li><b>Description: </b> Purpose of the bill.</li></p>\r\n          <li><b>Discount Amount: </b></li></p>\r\n          <li><b>Discount Date.</b> You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to bring up a calendar.</li></p>\r\n      </ol>\r\n\r\n<li>To delete this Bill, click the <img src=\"images/delete.gif\"> <b>Delete</b> button.</li></p>\r\n\r\n<li>To continue with the update on this bill, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/BillUpdate2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>If needed, modify the General Ledger Accounts and amounts listed. To add another distribution, enter it in the blank line provided, then click on the <img src=\"images/save.gif\"> <b>Save</b> button. This will open up another blank line.</li></p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b>  button.</li></p>\r\n\r\n<li>To finish the update, click the <img src=\"images/completebill.gif\"> <b>Complete Bill</b> button.  You will receive a confirmation screen similar to this:</li></P>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/BillUpdate3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the Bill Add/Update screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n</ol>\r\n',67),(71,15,'View/Cancel Accounts Payable Checks','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> View/Cancel Accounts Payable Checks</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_check_list_cancel/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n\r\n<em>Mark checks as either voided or cashed so you can run reports of outstanding checks, etc.</em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> View/Cancel Checks</b></i>.</li></p>\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/APChecking.jpg\"> \r\n<p align=\"left\">\r\n\r\n<li><b>Enter data in the following categories to narrow your search:</b></li></p>\r\n     <ol TYPE=\"a\">\r\n            <li><b>Check #: </b> If you want all checks, leave blank.</li></p>\r\n            <li><b>Invoice #: </b>Enter the invoice number or leave blank if you want to see ALL.</li></p>\r\n            <li><b>Vendor Name â€“ ID: </b>(Leave BLANK to search all Vendors) Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n            <li><b>Begin and End Check Date: </b>Enter a range of check dates to search. You can either enter the dates manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n            <li><b>Checking Account: </b>Select which checking account from the pull-down list that you want to appear on the report.</li></p>\r\n            <li><b>Order (for sorting): </b>Select order from the pull-down list.</li></p>\r\n       </ol>\r\n\r\n<li>To view checks that meet these criteria, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/APChecking2.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<em>If the vendor name is followed by (PR) then this is a payroll check. Payroll checks must be voided through the payroll system. Payables checks have an (AP) after the vendor name.</em></p>\r\n\r\n<li>To VOID a check, check the <b>Void</b> box or to mark the check as CASHED, check the <b>Cashed</b> box. Leave both boxes unchecked if neither case applies.</li></p>\r\n\r\n<li>To view the actual check, click on the check number shown in the <b>Check# </b> column.  The check will be displayed in a PDF format.</li></p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button. You should see a pop-up box asking if you are sure you want to mark those checks.  Select <b>OK</b> to process the selected checks. </li></p>\r\n\r\n<li>To return to the previous screen WITHOUT SAVING your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n</ol>',70),(73,15,'Payables List','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Payables List</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_bill_summary/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Produces a report of all or open payables, in summary \r\n(one line per invoice) or detail (shows all posting accounts \r\nand amounts).</em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Reports -> Payables List</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/APBillList.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Enter data in the following categories to narrow your search:</li></p>\r\n       <ol TYPE=\"a\">\r\n           <li><b>Invoice #: </b>Leave blank to display all invoices.</li></p>\r\n           <li><b>Vendor Name â€“ ID: </b>(Leave BLANK to search all Vendors) Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n           <li><b>Invoice Begin and Invoice End Date: </b>If you want to limit the list by invoice date range, you can either enter the dates manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> buttons to bring up a calendar.</li></p>\r\n           <li><b>Begin and End Due Date: </b>If you want to limit the list by an Invoice Due Date range, you can either enter the dates manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> buttons to bring up a calendar.</li></p>\r\n           <li><b>Show: </b>Select Open, Closed or All from the pull-down list.</li></p>\r\n           <li><b>Show: </b>Select Summary or Detail from the pull-down list.</li></p>\r\n           <li><b>Select Order By: </b>Select Due Date, Vendor or Invoice # from \r\nthe pull-down list. </li></p>\r\n     </ol>\r\n\r\n<li>To view your report, click on the <img src=\"images/next.gif\"> <b>Next</b>  \r\nbutton.</li></p>\r\n</ol>\r\n<br><hr><br>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><b> Summary Payables List</b></font></div>\r\n<hr>\r\n<ol>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/APBillList1.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li>To re-sort the list, click on the column headers of your choice. You can sort by Vendor, Due Date, Invoice or Amount.</li></p>\r\n\r\n<li>To view/change an invoice, click on the <font color=\"0000FF\">Invoice number</font>. For more information see the <b><i>View/Change Bills</b></i> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To return to the Payables List screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n</ol>\r\n<br><hr><br>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><b> Detail Payables List</b></font></div>\r\n<hr>\r\n<ol>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/APBillList2.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li>To re-sort the list, click on the column headers of your choice. You can sort by Vendor, Due Date, Invoice or Amount.</li></p>\r\n\r\n<li>To view/change an invoice, click on the <font color=\"0000FF\">Invoice number</font>. For more information see the <b><i>View/Change Bills</b></i> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To return to the Payables List screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n</ol>',72),(74,15,'Summary Aging Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Aging Report - Summary</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_aging_summary/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this report to see how many days your Payables are past their due dates. </em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Reports -> Aging - Summary</b></i>.</li></p>\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/SummaryAging.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n',73),(75,15,'Detail Aging Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Aging Report - Detail</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_aging_detail/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this report to see a detailed report of your Payables to see how much is past due and for how many days.</em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Reports -> Aging - Detail</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/DetailAging.jpg\"></p>\r\n<p align=\"left\"></p>',74),(76,15,'Discount Aging Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Aging Report - Discount</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_aging_discount/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this report to determine how much you stand to gain (or lose) by paying bills on time (or late).</em>\r\n\r\n<ol> \r\n<li>From the Main Menu, select <b><i>Payables -> Reports -> Aging - Discount</b></i>.</li></p>\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/APDiscountAgingReport.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n     <ol TYPE=\"a\">\r\n\r\n         <li><b>Discount Cutoff Date: </b> Enter the date to use as the last day you can receive a discount. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to bring up a calendar.</li></p>\r\n         <li><b>Show Details: </b> Select the check box to show the details of the invoices.</li></p>\r\n     </ol>\r\n\r\n<li>To view your report, click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p>\r\n</ol>\r\n\r\n<br><hr><br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\">\r\n     <b>Discount Aging Report - Details Turned Off</b></font></div>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/DiscountAging.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return and run another report, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<br><hr><br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\">\r\n     <b>Discount Aging Report - Show Details</b></font></div>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/DiscountAging2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return and run another report, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>',75),(78,16,'Log Hours','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Log Hours</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_log_hours/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>You can enter hours daily for each day\'s work, or you can \r\nenter them once for each pay period. Remember that if you \r\nlog hours more than once for the same pay period, the hours \r\nwill ADD TOGETHER. So, to remove hours if you entered too many, \r\nyou can enter negative hours in a separate pass through Log Hours.</em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payroll ->  Log Hours</b></i>.</li></p> \r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/LogHoursMain.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Make selections in the following categories:</b></li></p>\r\n    <ol TYPE=\"a\">\r\n         <li><b>Name: </b>Select an Employee Name from the pull-down list or select ALL IN GROUP to do all employees in the pay period selected.</li></p>\r\n         <li><b>Period: </b>Select the Period from the pull-down list (bi-weekly, monthly, semi-monthly, or weekly).</li></p>\r\n     </ol>\r\n\r\n<li>To continue, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/LogHours.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Period Begin Date and Period End Date: </b> These are the pay period begin and end dates -- not the date on which the check is written. You can either enter the date manually or click on the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button select the date from a calendar. </li></p>\r\n\r\n<li>To continue, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/LogHours1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Enter DEFAULT Number of hours in each of the displayed pay types (the pay types are the ones you entered in Payroll -> Setup). If most people worked a 40-hour week, for example, you could enter 40 next to Straight Time Hours and that number of hours would default in each employee entry page.You can override that number, but it can save time if several of your people have the same hours.</li></p>\r\n\r\n<li>To continue, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/LogHours2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Verify that the entries in the following categories are correct, you may edit if necessary:</li></p>\r\n   <ol TYPE=\"a\">\r\n      <li><b>Hours: </b>Number of Hours for this pay period. NOTE: The hours entered as the default on the previous screen will be displayed here.</li></p>\r\n      <li><b>Pay Rate: </b> Employee\'s Pay Rate for this Pay Type. You can override this pay rate, if needed.</li></p>\r\n      <li><b>Shift: </b>The shift number for this Pay Type.</li></p>\r\n      <li><b>Total Default:</b>Wages (Hours x Pay Rate).<//li></p>\r\n      <li><b>GL Account: </b>Enter the GL Account. If you have some pay at one account and some in another for the same person, after entering hours for one account, click on the clock to enter more hours with another account for the same person.</li></p>\r\n      <li><b>Shift: </b>Select shift from pull-down list. This will affect all pay on the current screen. If you have some pay at one shift and some in another for the same person, after entering hours for one shift, click on the clock to enter more hours with another shift for the same person.</li></p>\r\n      <li><b>Tips: </b>If your employees report tips, place that entry here.</li></p>\r\n      <li><b>Misc. Taxable Pay: </b>Enter any additional wages that will be taxable. (Example: Bonuses, Commissions, etc.).</li><p>\r\n      <li><b>Comment: </b>Enter an explanation for Misc. Taxable Pay entry.</li></p>\r\n      <li><b>Misc. Nontaxable Pay: </b>Enter any amounts to appear on the paycheck that are not wages and therefore non-taxables. (Example: Expense Reimbursements).</li> </p>\r\n      <li><b>Comment: </b>Enter an explanation for the Misc. Non-Taxable Pay entry.</li></p>\r\n      <li><b>Misc. Deduction: </b>Enter any miscellaneous deduction amounts (Example: repayment of an advance). </li></p>\r\n      <li><b>Comment: </b>Enter an explanation for the Misc. Deduction entry.</li></p>\r\n   </ol>\r\n\r\n<li>To enter more hours for this employee, click on the <img src=\"images/morehours.gif\"> <b>Enter More Hours</b> button.</li></p>\r\n\r\n<li>To save your changes and continue to the next employee, click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p>\r\n\r\n<li>Repeat these steps for this screen until all selected employees are complete. Your final screen after all employees hours are entered should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/LogHourDone.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the main screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n</ol></p>',77),(79,16,'Calculate/Pay Taxes','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Calculate/Pay Taxes</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_calculate/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>After all employee hours and misc. pay and deductions have been entered, you will next need to calculate the taxes, benefits, etc. If you wish to double-check your work of entering hours before calculating (a good idea when you are just getting started) you can run a check summary even though you have not \r\ncalculated.</em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payroll -> Calculate/Pay Taxes</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CalculateMain.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li>Select <b>Payroll Period</b> from the pull-down list (only uncalculated periods for which hours have been entered will appear on this list).</li></p>\r\n\r\n<li>To calculate, click on the <img src=\"images/calculations.gif\"> <b>Calculate</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CalculateDone.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen to calculate payroll for another group, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n</ol>',78),(80,16,'Write Checks (Payroll)','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Write Checks (Payroll)</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_check_write/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Once you have entered hours and calculated the payroll, you are ready \r\nto write the checks.  It is a good idea to run a check summary BEFORE printing the checks to make sure everything is OK.</em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payroll -> Write Checks</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/WriteChecksMain.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n    <ol TYPE=\"a\">\r\n       <li><b>Period: </b>Select the payroll Period from the pull-down list.</li></p>\r\n       <li><b>Checking Account: </b>Select the Checking Account from the pull-down list. (the default checking account will be auto-selected).</li></p>\r\n       <li><b>Beginning Check #: </b>This is the starting check# for this run (the program will keep track of what it thinks the next number should be, but you can override it if necessary).</li></p>\r\n       <li><b>Check Endorser: </b>Enter the name to print below the signature   line on the check.</li></p>\r\n       <li><b>Check Date: </b>The date you want to put on the checks. The program will always display today\'s date here, but you can override it by entering it manually or you can select a date using the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button. </li></p>\r\n       <li><b>Write Deposit Check: </b>If this box is checked a tax deposit check will be generated after the checks and will cover all federal taxes for the group of checks written. </li></p>\r\n       <li><b>Create Direct Deposit File: </b>(only if using Direct Deposit). If this box is checked, the Direct Deposit file will be created BUT NOT transmitted.</li></p>\r\n        <li><b>Direct Deposit Transaction Description: </b>Enter the text you want to be entered in the Transaction Description field of the Direct Deposit File.  This description helps you identify this file.  It is suggested you enter something like  \"Payroll mmddyyyy\".</li></p>\r\n     </ol>\r\n\r\n<li>To create the checks, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this: </p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/WriteChecks.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n<li>To view/print checks, click the <img src=\"images/print.gif\"> <b>Print Checks</b> button. The check format is Check on top followed by two identical stubs. Checks are created using Adobe Acrobat ReaderÂ®. You must have this software installed to view/print checks.</li></p>\r\n\r\n<li>To view/print Direct Deposit stubs, click the <img src=\"images/print.gif\"> <b>Print Direct Deposit Stubs</b> button. Direct Deposit stubs are created using Adobe Acrobat ReaderÂ®. You must have this software installed to view/print the Direct Deposit Stubs.</li></p>\r\n\r\n<li>To download the Direct Deposit File, click on the <img src=\"images/downloadaccts.gif\"> <b>Download Direct Deposit File</b> button.  For further instructions on processing a Direct Deposit file, see the <b><i>Direct Deposit</i></b> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n</ol>\r\n<hr><br>\r\n<center><big><b>SAMPLE EMPLOYEE CHECK</b></big></center><br><br>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeCheckPdf.jpg\"></p><br><br>\r\n<hr><br>\r\n<center><big><b>SAMPLE TAX DEPOSIT CHECK</b> </big></center><br><br>\r\n<p align=\"center\"><img src=\"images/screenshots/DepositCheckPdf.jpg\"></p><br><br>\r\n',79),(81,16,'Check Summary One Period','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Check Summary One Period</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_check_rpt_one/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>You can run this report to view a single payroll or for not-yet-calculated payrolls to check calculations before committing them to checks/direct deposits.  It also allows you how to void or reprint a check/direct deposit transaction, if necessary.</em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payroll -> Reports -> Check Summary One Period</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/CheckSummaryOneMain.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li>Select <b>Pay Period</b> from the pull-down list.</li></p>\r\n\r\n<li>To produce the report, click on the <img src=\"images/next.gif\"> <b>Next</b>  button. This report shows all pay, deduction, etc. information about each employee with a grand total at the bottom. It will also display tax deposit check information. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CheckSummaryOne.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen to select a different period, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To reprint the exact same check, click on the <font color=\"0000FF\"><b>Check Number</font></b>.</li></p>\r\n\r\n<li>To print all the checks, click on the <img src=\"images/print.gif\"> <b>Print Checks</b> button.</li></p>\r\n\r\n<li>To print all of the direct deposit stubs, click on the <img src=\"images/print.gif\"> <b>Print Direct Deposit Stubs</b> button.</li></p>\r\n\r\n</ol>\r\n\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>To Void a Check</strong></font></div>\r\n<hr>\r\n<p align=\"left\">\r\n\r\n<ol>\r\n<li>To void a Check or Direct Deposit transaction, click on the <img src=\"images/voidcheck.gif\"> <b>Void Check</b> button found on the Check Summary screen (you will not see this button if the checks have not yet been written). Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/VoidCheck.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li><b>You have three(3) different choices on this screen:</b></li></p>\r\n   <ol TYPE=\"a\">\r\n\r\n        <li>To void the Employee\'s check and the check calculations leaving just the hours and pay information intact, click on the <img src=\"images/voidcheck.gif\"> <b>Void Check and Calculations</b> button.  This will allow you to make changes to pay, recalculate, and re-write checks.</li></p>\r\n        <li>To void the Employee\'s check, calculations and ALL Pay Data for that pay period, click on the <img src=\"images/voidcheckcalc.gif\"> <b>Void Check, calculations, AND All Pay Data</b> button. This removes everything, so you can start fresh with entering hours, etc. </li></p>\r\n        <li><b>Reprint as Check#: </b>Enter the new Check # if you wish to assign a new check number and reprint the check (without  changing the data), then  and click the <img src=\"images/print.gif\"> <b>Reprint</b> button to print the new check.</li></p>\r\n    </ol>\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n\r\n</ol>\r\n',80),(82,16,'Check Summary Multiple Periods','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Check Summary Multiple Periods</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_check_rpt_multiple/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this report to summarize payroll data by month, quarter, half-year, or year.</em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payroll -> Reports -> Check Summary Multiple Periods</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CheckSummaryMultipleMain.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Prepare your report by completing the following:</b></li></p>\r\n   <ol TYPE=\"a\">\r\n        <li><b>Grouping: </b>Select whether you want the report for a range of Pay Periods, Months, Quarters, or Years.  NOTE: <b>Individual Pay Periods</b> selection uses the Pay Period Ending Date NOT the Check Date.  The Month, Quarter and Year selections use the Check Date.</li></p>\r\n       <li>To display dates available for the report, click on the <img src=\"images/showlist.gif\"> <b>Change Grouping</b> button.</li></p>\r\n   </ol></p>\r\n<p>NOTE: The \"Select Pay Period\" section of the screen changes depending on the Grouping selected above. If you selected <b>Group by Quarter</b>, your screen should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CheckSummaryMultipleMain1.jpg\" > </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Select Pay Period(s)</b> from list. Hold down the CTRL key and click to select multiple periods.</li></p>\r\n\r\n<li>To produce the report, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CheckSummaryMultiple.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n',81),(83,16,'Add/Update Employees','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Employee Add/Update</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_employee_addUpdate/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Enter/Update all employee information such as name, address, \r\nexemption information, special deductions, etc. From here you \r\ncan also view pay information for this specific employee.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Employee Add/Update. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeAddUpdateMain.jpg\" > \r\n </p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n  an Existing Employee</strong></font></div>\r\n<hr>\r\n<p align=\"left\">1) Select Employee Name from the pull-down list.</p>\r\n<p>2) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeUpdateMain.jpg\" ></p>\r\n<p>3) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button to \r\n  delete the employee. </p>\r\n<p>4) Edit any or all the information in the following categories:</p>\r\n<blockquote>\r\n  <p> a) <strong>Name:</strong> be sure to enter First Name (and middle initial)  in the first \r\n    box, Last Name in the next<br>\r\n    b) <strong>Address, City, State, Postal Code, Country, and Mail Stop:</strong> no explanation needed<br>\r\n    c) <strong>Phone / Phone Description:</strong> Each employee can have up the 4 phone numbers, so there is also a description area to indicate what that phone is (ie: Cell, home, office, parents, etc.).<br>\r\n    d) <strong>E-mail / E-mail Description:</strong> Each employee can have up to 2 email addresses, so there is also a description area to indicate what that e-mail address is.<br>\r\n    e) <strong>Web Address:</strong> If the employee has a web page, enter the web address here.<br>\r\n    f) <strong>Social Security:</strong> Enter the social security number WITHOUT any dashes between number groups.<br>\r\n    g) <strong>Date of Birth:</strong> <br>\r\n    h) <strong>Hire Date:</strong> Date on which employee begins working. This is used in determining vacation rate, etc.<br>\r\n    i) <strong>Payment Type </strong> Hourly or Salary<br>\r\n    j) <strong>Pay Period</strong> if employee paid Weekly, bi-weekly, \r\n    etc.<br>\r\n    k) <strong>Pay per hour/period: </strong>If an hourly worker, then enter the \r\n    hourly pay. If a salaried worker, enter the salary for each period.<br>\r\n    l) <strong>GL Account </strong> the expense account in General Ledger \r\n    that this employees wages should post into. Note: this can be changed at log hours.<br>\r\n    m) <strong>Vacation Hours Accrued</strong> this field will update \r\n    automatically each pay period based on the formula you entered. It will reduce \r\n    every time vacation is used. However, you can manually override this figure \r\n    (useful during startup).<br>\r\n    n) <strong>Sick Leave Hours Accrued </strong>(see notes about vacation accrued).<br>\r\n    o)<strong> Status - Active or Inactive.</strong> An active employee \r\n    will show up on the list when logging hours, an inactive one will not. BOTH \r\n    active and inactive will show up on reports, W-2s etc</p>\r\n    p)<strong> Photo: </strong> Attach a photo to appear on various payroll lists and on welcome home page when this employee logs in. Use the browse to find the file.  When a picture has been attached, you will see this photo at the top of the page when editing the employee file.<br>\r\n    q)<strong> Add Commission Data: </strong> This ties the employee into a salesman record so commission data can be passed back to payroll.<br>\r\n    r)<strong> Edit Login Rights:</strong> This ties the employee into a login record, so changing name, etc. information in one place automatically changes it in another. Also, in order to have a picture that has been attached to the employee record show up on the home page for this employee, the two records need to be attached.<br>\r\n</blockquote>\r\n<p>5) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> button to continue \r\n  editing the employee. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeUpdate1.jpg\" ></p>\r\n<p align=\"left\"> 6) Edit any or all the information in the following categories:</p>\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Marital Status</strong> Select correct status from the pull-down \r\n    list.<br>\r\n    b) <strong>Federal Exemptions </strong> number of federal exemptions \r\n    claimed on W-9 form.<br>\r\n    c) <strong>Extra FIT per pay period</strong>  amount of additional federal income tax to be withheld per pay period.<br>\r\n    d) <strong>Extra FIT based on</strong> If an additional amount of federal tax is to be taken, select method of calculation \r\n    from pull-down (either percentage or fixed amount).<br>\r\n    e) <strong>EIC</strong> Check this box if employee is eligible for Earned Income Credits (they must be low income).<br>\r\n    f) <strong>State</strong> select state for tax purposes (if any) from pull-down list \r\n    (states for tax purposes are entered in setup) or you could a New State tax at this time by clicking on the Add button.<br>\r\n    g) <strong>State Exemptions</strong> number of exemptions claimed \r\n    for state taxes.<br>\r\n    h) <strong>Extra SIT per pay period </strong> additional state income \r\n    tax to be withheld per pay period.<br>\r\n    i) <strong>Extra SIT based on</strong> if additional state income tax is to be withheld, select method of calculation \r\n    from pull-down (either percentage or fixed amount).<br>\r\n    j) <strong>Local Tax </strong> select local tax district (if any) from \r\n    pull-down (local tax districts for tax purposes are entered in setup) or you could a New Local tax district at this time by clicking on the Add button.<br>\r\n    k) <strong>Local Exemptions</strong> number of exemptions claimed \r\n    for local taxes.<br>\r\n    l) <strong>Extra LIT per pay period </strong> additional local income \r\n    tax to be withheld per pay period.<br>\r\n    m) <strong>Extra LIT based on</strong> if withholding additional local income taxes, select method of calculation \r\n    from pull-down list (either percentage or fixed amount).<br>\r\n    n) <strong>City </strong> select city (if any) from pull-down (cities \r\n    for tax purposes are entered in setup) or you could a New City tax district at this time by clicking on the Add button.<br>\r\n    o) <strong>City Exemptions</strong>  number of exemptions claimed for \r\n    city taxes.<br>\r\n    p) <strong>Extra CIT per pay period </strong> additional city income \r\n    tax to be withheld per pay period.<br>\r\n    q) <strong>Extra CIT based on</strong> If additional city income tax is to be withheld, select method of calculation \r\n    from pull-down (either percentage or fixed amount).</p>\r\n</blockquote>\r\n<p>7) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> \r\n  button to continue editing the employee. Your screen should look similar to \r\n  this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeUpdate2.jpg\" ></p>\r\n<p align=\"left\">8) Edit any or all the information in the following categories:</p>\r\n<blockquote> \r\n  <p align=\"left\"> a) <strong>Workers Compensation Rate</strong>  \r\n    Percentage rate for workmans compensation to be contributed by company \r\n    for this type of employee.<br>\r\n    b) <strong>Deduction Group </strong> select from the pull-down list. \r\n    Deduction groups are used to select specific groups of employees who will \r\n    have a special deduction or benefit because they are in a specific group.<br>\r\n    c) <strong>PENSION/SAVINGS PLANS</strong>  if you have entered any \r\n    of these plans in Setup, they will be displayed here.<br>\r\n    d) <strong>Plan One (or Two) </strong> select a plan from the pull-down.</p>\r\n  <blockquote> \r\n    <p align=\"left\"> i) <strong>Deduction Amount</strong>.<br>\r\n      ii) <strong>Base</strong>  select if the amount is a fixed dollar \r\n      amount or a percentage of wages.</p>\r\n  </blockquote>\r\n</blockquote>\r\n<p>9) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> button to continue \r\n  editing the employee. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeUpdate3.jpg\" ></p>\r\n<p align=\"left\">10) At this point:</p>\r\n<blockquote> \r\n  <p align=\"left\"> a) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> \r\n    button to select a different employee for editing.<br>\r\n    b) Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> button to enter a brand-new employee.<br>\r\n  </p>\r\n</blockquote>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add \r\n  a New Employee</strong></font></div>\r\n  <hr></hr>\r\n1) Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> button. Your screen \r\nshould look similar to this: </p> \r\n<p align=\"center\"><img src=\"images/screenshots/NewEmployeeAddMain.jpg\" ></p>\r\n<p align=\"left\">2) Enter all the necessary data for the New Employee.</p>\r\n<blockquote>\r\n<blockquote>\r\n  <p> a) <strong>Name:</strong> be sure to enter First Name (and middle initial)  in the first \r\n    box, Last Name in the next<br>\r\n    b) <strong>Address, City, State, Postal Code, Country, and Mail Stop:</strong> no explanation needed<br>\r\n    c) <strong>Phone / Phone Description:</strong> Each employee can have up the 4 phone numbers, so there is also a description area to indicate what that phone is (ie: Cell, home, office, parents, etc.).<br>\r\n    d) <strong>E-mail / E-mail Description:</strong> Each employee can have up to 2 email addresses, so there is also a description area to indicate what that e-mail address is.<br>\r\n    e) <strong>Web Address:</strong> If the employee has a web page, enter the web address here.<br>\r\n    f) <strong>Social Security:</strong> Enter the social security number WITHOUT any dashes between number groups.<br>\r\n    g) <strong>Date of Birth:</strong> <br>\r\n    h) <strong>Hire Date:</strong> Date on which employee begins working. This is used in determining vacation rate, etc.<br>\r\n    i) <strong>Payment Type </strong> Hourly or Salary<br>\r\n    j) <strong>Pay Period</strong> if employee paid Weekly, bi-weekly, \r\n    etc.<br>\r\n    k) <strong>Pay per hour/period: </strong>If an hourly worker, then enter the \r\n    hourly pay. If a salaried worker, enter the salary for each period.<br>\r\n    l) <strong>GL Account </strong> the expense account in General Ledger \r\n    that this employees wages should post into. Note: this can be changed at log hours.<br>\r\n    m) <strong>Vacation Hours Accrued</strong> this field will update \r\n    automatically each pay period based on the formula you entered. It will reduce \r\n    every time vacation is used. However, you can manually override this figure \r\n    (useful during startup).<br>\r\n    n) <strong>Sick Leave Hours Accrued </strong>(see notes about vacation accrued).<br>\r\n    o)<strong> Status - Active or Inactive.</strong> An active employee \r\n    will show up on the list when logging hours, an inactive one will not. BOTH \r\n    active and inactive will show up on reports, W-2s etc</p>\r\n    p)<strong> Photo: </strong> Attach a photo to appear on various payroll lists and on welcome home page when this employee logs in. Use the browse to find the file.  When a picture has been attached, you will see this photo at the top of the page when editing the employee file.<br>\r\n\r\n</blockquote>\r\n<p>3) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\">button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/NewEmployeeAdd.jpg\" ></p>\r\n<p>4) Enter all the necessary data for the New Employee.</p>\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Marital Status</strong> Select correct status from the pull-down \r\n    list.<br>\r\n    b) <strong>Federal Exemptions </strong> number of federal exemptions \r\n    claimed on W-9 form.<br>\r\n    c) <strong>Extra FIT per pay period</strong>  amount of additional federal income tax to be withheld per pay period.<br>\r\n    d) <strong>Extra FIT based on</strong> If an additional amount of federal tax is to be taken, select method of calculation \r\n    from pull-down (either percentage or fixed amount).<br>\r\n    e) <strong>EIC</strong> Check this box if employee is eligible for Earned Income Credits (they must be low income).<br>\r\n    f) <strong>State</strong> select state for tax purposes (if any) from pull-down list \r\n    (states for tax purposes are entered in setup) or you could a New State tax at this time by clicking on the Add button.<br>\r\n    g) <strong>State Exemptions</strong> number of exemptions claimed \r\n    for state taxes.<br>\r\n    h) <strong>Extra SIT per pay period </strong> additional state income \r\n    tax to be withheld per pay period.<br>\r\n    i) <strong>Extra SIT based on</strong> if additional state income tax is to be withheld, select method of calculation \r\n    from pull-down (either percentage or fixed amount).<br>\r\n    j) <strong>Local Tax </strong> select local tax district (if any) from \r\n    pull-down (local tax districts for tax purposes are entered in setup) or you could a New Local tax district at this time by clicking on the Add button.<br>\r\n    k) <strong>Local Exemptions</strong> number of exemptions claimed \r\n    for local taxes.<br>\r\n    l) <strong>Extra LIT per pay period </strong> additional local income \r\n    tax to be withheld per pay period.<br>\r\n    m) <strong>Extra LIT based on</strong> if withholding additional local income taxes, select method of calculation \r\n    from pull-down list (either percentage or fixed amount).<br>\r\n    n) <strong>City </strong> select city (if any) from pull-down (cities \r\n    for tax purposes are entered in setup) or you could a New City tax district at this time by clicking on the Add button.<br>\r\n    o) <strong>City Exemptions</strong>  number of exemptions claimed for \r\n    city taxes.<br>\r\n    p) <strong>Extra CIT per pay period </strong> additional city income \r\n    tax to be withheld per pay period.<br>\r\n    q) <strong>Extra CIT based on</strong> If additional city income tax is to be withheld, select method of calculation \r\n    from pull-down (either percentage or fixed amount).</p>\r\n</blockquote>\r\n<p>5) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/NewEmployeeAdd1.jpg\" ></p>\r\n<p>6) Enter all the necessary data for the New Employee.</p>\r\n<blockquote> \r\n  <p> a) <strong>Worker Compensation Rate</strong>Percentage \r\n    rate for workmans compensation to be contributed by company for this \r\n    type of employee.<br>\r\n    b) <strong>Deduction Group</strong> select from the pull-down list. \r\n    Deduction groups are used to select specific groups of employees who will \r\n    have a special deduction or benefit because they are in a specific group.<br>\r\n    c) <strong>PENSION/SAVINGS PLANS </strong> if you have entered any \r\n    of these plans in Setup, they will be displayed here.</p>\r\n  <blockquote>\r\n    <p> i) <strong>Plan One (or Two) </strong> select a plan from the pull-down. \r\n      <br>\r\n      ii) <strong>Deduction Amount</strong>.<br>\r\n      iii) <strong>Base </strong> select if the amount is a fixed dollar \r\n      amount or a percentage of wages.</p>\r\n  </blockquote>\r\n\r\n    d)<strong> Add Commission Data: </strong> This ties the employee into a salesman record so commission data can be passed back to payroll.<br>\r\n    e)<strong> Edit Login Rights:</strong> This ties the employee into a login record, so changing name, etc. information in one place automatically changes it in another. Also, in order to have a picture that has been attached to the employee record show up on the home page for this employee, the two records need to be attached.<br>\r\n</blockquote>\r\n<p>7) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the New Employee. </p><br><br>\r\n',82),(84,16,'Employee Deductions','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Employee Deductions</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_employee_deductions/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This is part of the employee setup.  If an employee has any \r\nspecial deductions that apply only to himself, these need to be \r\nentered here. Typical of such deductions are garnishments, \r\ndonations to United Way, Christmas club, etc.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Employee Deductions. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeDeductionsMain.jpg\" ></p>\r\n<p align=\"left\">3) Select the Employee Name from the pull-down list. </p>\r\n<p>4) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeDeductions.jpg\" ></p>\r\n<p align=\"left\">5) Edit data in the following categories:</p>\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Description.</strong><br>\r\n    b) <strong>Amount. </strong><br>\r\n    c) <strong>Periods Remaining.</strong> If you want the deductions to end after \r\n    a given number of times, enter a number here. Enter -1 to keep the deduction \r\n    going until manually removed.<br>\r\n    d) <strong>Select the GL Account</strong> from the pull-down list.<br>\r\n    e) <strong>Delete Deduction</strong> by selecting the check box.</p>\r\n</blockquote>\r\n<p>6) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the Employee Deductions. </p>\r\n<p>7) Repeat steps 4 and 5 if the employee has more deductions.<br>\r\n</p><br>',83),(85,16,'Employee Phone List','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Employee Phone List</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_phone_list/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>View a list of your employees, their \r\nphone numbers and phone comments.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Reports, then Employee Phone List. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeePhoneList.jpg\" ></p>\r\n<p align=\"left\"> </p><br>\r\n<p>3) Click on <img src=\"images/reset.gif\"> button to view same report including employee pictures:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeePhoneList2.jpg\" ></p>\r\n<p align=\"left\"> </p><br>\r\n<p>3) Click on <img src=\"images/reset.gif\"> button to return to report WITHOUT employee pictures:</p><br><br>\r\n',84),(86,16,'Name/Address/Phone List','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Employee Address/Phone List</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_employee_phone_list/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>View a list of your employees, their \r\naddresses and phone numbers.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Reports, then Employee Address/Phone List. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeNameAddressPhone.jpg\"> \r\n</p>\r\n<p>3) Click on the <img src=\"images/reset.gif\"> button to change this display to include pictures of employees:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeNameAddressPhone2.jpg\"> \r\n</p>\r\n<p>4) Click on the <img src=\"images/reset.gif\"> button to return to the display WITHOUT pictures included.</p><br><br>\r\n',85),(87,16,'Birthday List','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Employee Birthday List</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_birthday_list/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>View a list of your employees and \r\ntheir birthdays.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Reports then Employee Birthday List. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeBirthday.jpg\" > \r\n</p>\r\n<br>\r\n<p>3) Click on the <img src=\"images/reset.gif\"> button to include employee pictures in the list:</p><br>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeBirthday2.jpg\" > \r\n</p>\r\n<br>\r\n<p>3) Click on the <img src=\"images/reset.gif\"> button to return to the report WITHOUT pictures.</p><br>\r\n',86),(88,16,'General Info List','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Employee General Info.</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_employee_geninfo_list/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>View a list of your employees, their \r\nmarital status, exemptions and pay rate.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Reports, then Employee General Info. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeGeneralInfo.jpg\" ></p>\r\n<p align=\"left\"> </p>\r\n<p>3) Click on <img src=\"images/reset.gif\"> button to include pictures in report:</p><br>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeGeneralInfo2.jpg\" ></p>\r\n<p align=\"left\"> </p>\r\n<p>3) Click on <img src=\"images/reset.gif\"> button to return to report WITHOUT pictures.</p><br>\r\n',87),(89,16,'Employee Pay By Week','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Employee Pay by Week</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_pay_by_week/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>View a list \r\nof your employees broken down by week for the selected month.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Reports, then Employee Pay by Week. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeByWeek.jpg\" ></p>\r\n<p align=\"left\">3) To change the type of report:</p>\r\n<blockquote>a) Select the Report type from the pull-down list.<br>\r\n b) Select the Year for Report from the pull-down list.<br>\r\nc) Select the Month (if needed) from the pull-down list.<br>\r\nd) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> button to \r\n  see the new report. </p>\r\n <br>\r\n  <br>',88),(90,16,'Employee Pay by Month','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Employee Pay by Month</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_pay_by_month/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter to view a list \r\nof your employees that are paid by month.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Reports, then Employee Pay by Month. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeByMonth.jpg\" ></p>\r\n<p align=\"left\">3) To change the type of report:</p>\r\n<blockquote>a) Select the Report type from the pull-down list.<br>\r\n b) Select the Year for Report from the pull-down list.<br>\r\nc) Select the Month (if needed) from the pull-down list.<br>\r\nd) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> button to \r\n  see the new report. </p>\r\n <br>\r\n  <br>',89),(91,16,'Employee Pay by Quarter','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Employee Pay by Quarter</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_pay_by_quarter/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter to view a list of your employees that are paid by quarter.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Employee Pay by Quarter. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeByQuarter.jpg\" ></p>\r\n<p align=\"left\">3) To change the type of report:</p>\r\n<blockquote>a) Select the Report type from the pull-down list.<br>\r\n b) Select the Year for Report from the pull-down list.<br>\r\nc) Select the Month (if needed) from the pull-down list.<br>\r\nd) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> button to \r\n  see the new report. </p>\r\n <br>\r\n  <br>',90),(92,16,'Write Employee Review','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Write Employee Review</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_write_review/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Create, review and/or edit employee performance reviews.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Write Employee Review. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeReviewUpdate.jpg\" ></p>\r\n</p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n  an Existing Review</strong></font></div>\r\n<hr>\r\n<p align=\"left\">1) Select Employee from the pull-down list. </p>\r\n<p>2) Use the Beginning Evaluation Date and Ending Evaluation Date boxes to select \r\n  the date range for your search. You can either enter \r\n  the date manually or click the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> \r\n  button to bring up a calendar.</p>\r\n<p>3) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> button to \r\n  look up an existing employee review. If more than one review is found, your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeReviewUpdate2.jpg\" ></p>\r\n<p> 4) Select the Employee Evaluation you wish to edit by clicking on the employee name. Your screen should look \r\n  similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeReviewUpdate1.jpg\" ></p>\r\n<p>5) Edit Data in the following categories:</p>\r\n<blockquote>\r\n  <p> a) <strong>Enter Evaluator Name.</strong> Who wrote the evaluation<br>\r\n    b) <strong>Evaluation Date.</strong> You can either enter the date manually \r\n    or click the button to bring up a calendar.<br>\r\n    c) <strong>Rating</strong> Select the rating scale (entered in Payroll Setup)  from the pull-down list.<br>\r\n    d) <strong>Comments</strong> This is the actual evaluation text.</p>\r\n</blockquote>\r\n<p>6) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the changes. </p>\r\n<p>7) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button to \r\n  delete this Review. </p>\r\n<p>8) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous screen without saving the changes.</p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add \r\n  a New Review</strong></font></div>\r\n  <hr></hr><br>\r\n1) Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> button. Your screen \r\nshould look similar to this: </p> </p> \r\n<p align=\"center\"><img src=\"images/screenshots/ReviewAdd.jpg\"></p>\r\n<p>2) Enter Data in the following categories:</p>\r\n<blockquote>\r\n  <p> a) <strong>Select Employee</strong> from the pull-down list.<br>\r\n\r\n    b) <strong>Enter Evaluator Name.</strong> Who wrote the evaluation<br>\r\n    c) <strong>Evaluation Date.</strong> You can either enter the date manually \r\n    or click the button to bring up a calendar.<br>\r\n    d) <strong>Rating</strong> Select the rating scale (entered in Payroll Setup)  from the pull-down list.<br>\r\n    e) <strong>Comments</strong> This is the actual evaluation text.</p>\r\n</blockquote>\r\n<p>3) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to add \r\n  the New Review. </p>\r\n<p>4) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous screen without saving the changes.</p><br><br>',92),(93,16,'Print 941','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Print 941</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_941_print/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Print a completed 941 form in PDF format.  </em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Print 941. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Print941Main.jpg\" ></p>\r\n<p align=\"left\">3) Select the Year/Quarter Date from the pull-down list.</p>\r\n<p>4) Click the <img src=\"images/print.gif\" > button to \r\n  bring up a completed 941 form in PDF format. Requires Adobe Acrobat Reader or \r\n  other PDF viewer to display correctly. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Form941.jpg\" ><br>\r\n</p>\r\n<br>\r\n<p>5) A payment voucher will also be produced:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Form941b.jpg\" ><br>\r\n</p>\r\n',93),(95,16,'Print W2s','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Print W-2\'s</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_w2_print/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Prints W-2 information (assumes a pre-printed form) in PDF format. </em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Print W-2\'s. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/PrintW2Main.jpg\" ></p>\r\n<p align=\"left\">3) Select the Year from the pull-down list.</p>\r\n<p>4) Select the Employee Name from the pull-down list.</p>\r\n<p>5) Click the <img src=\"images/print.gif\" width=\"33\" height=\"29\"> button to \r\n  bring up a completed 941 form in PDF format. Requires Adobe Acrobat Reader or \r\n  other PDF viewer to display correctly. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/W2PDF.jpg\" ><br>\r\n</p>',94),(96,17,'Users and Rights','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Users and Rights</strong></font><a href=\"http://www.nolapro.com/training/admin/admin_users_and_rights/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em></em> \r\n<p>1) Click Admin.</P>\r\n<p>2) Click Users and Rights. Your screen should look similar to this: </p>\r\n<p align=\"center\"> <img src=\"images/screenshots/Admin_Users.jpg\" ><br>\r\n</p>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Update a Selected Users</strong></font></div>\r\n  <hr></hr>\r\n<p>1) Select your User from the pull-down list.</p>\r\n<p>2) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> \r\n  button. Your screen should look similar to this: <br>\r\n</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Admin_Users2.jpg\" > \r\n</p>\r\n<em>NOTE: If a user is NOT tied to an employee record, you will see the additional questions shown on the side.</em><br>\r\n<p>3) Make any necessary changes to the information. </p>\r\n<blockquote>\r\n<b>Active:</b> If an employee is checkmarked as ACTIVE, they can log onto the system. If this box is UNCHECKED, their account has been disabled.<br>\r\n<b>Supervisor:</b> Supervisor access gives access to EVERYTHING so grant it sparingly!<br>\r\n<b>Module Access:</b> Access to each module is granted on three levels. READ is the lowest level - mostly involving only being able to run reports, but they can also enter orders. WRITE allows users to update data, but they cannot get into the setup sections, and they cannot do activities like void checks. SETUP is the maximum access for a module.<br>\r\n</blockquote>\r\n\r\n<p>4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> \r\n  button to save changes.</p>\r\n<p> 5) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> \r\n  button to delete the user. </p>\r\n<p>6) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> \r\n  button to return to the previous screen without saving the changes.<br>\r\n</p>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Add a New User</strong></font></div>\r\n  <hr></hr>\r\n<p>1) From the main screen, you also have the option to add a New User. Click \r\n  the Add button. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Admin_Users3.jpg\" > \r\n</p>\r\n<p>2) Enter the following user information: User Name, First Name, Last Name, \r\n  Password, etc. </p>\r\n<blockquote>\r\n<b>Active:</b> If an employee is checkmarked as ACTIVE, they can log onto the system. If this box is UNCHECKED, their account has been disabled.<br>\r\n<b>Supervisor:</b> Supervisor access gives access to EVERYTHING so grant it sparingly!<br>\r\n<b>Module Access:</b> Access to each module is granted on three levels. READ is the lowest level - mostly involving only being able to run reports, but they can also enter orders. WRITE allows users to update data, but they cannot get into the setup sections, and they cannot do activities like void checks. SETUP is the maximum access for a module.<br>\r\n</blockquote>\r\n<p>3) Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> button to add \r\n  the New User.<br>\r\n</p>',95),(97,17,'Client Companies','<center><H2><b>Company Update - Part One</b></H2></center><br>\r\n<i>Enter more than one company ONLY if you intend to keep two entirely separate sets of accounting books, inventories, etc. If you simply have multiple locations, you will enter that information elsewhere.</i><br><br>\r\n<font=\"-1\"><b>COMPANY: </b>Choose a Company from the pull down list.<br><br>\r\n<b>Edit Selected Company: </b>This allows you to select the Company that you have chosen.<br><br>\r\n<center><b>Company Update - Part Two</b></center><br>\r\n<font=\"-1\"><b>COMPANY NAME: </b>Company Name as it will appear on reports.<br><br>\r\n<b>ADDRESS: </b>Street Address.<br><br>\r\n<b>CITY: </b>City where the Company is located.<br><br>\r\n<b>STATE: </b>State where the Company is located.<br><br>\r\n<b>POSTAL CODE: </b>Postal Code.<br><br>\r\n<b>COUNTRY: </b>Enter the country only if desired.<br><br>\r\n<b>MAIN OFFICE PHONE: </b>Principal phone number.<br><br>\r\n<b>FAX: </b>Fax phone number.<br><br>\r\n<b>CUSTOMER SERVICE PHONE: </b>Special phone number for customer service (if different from main number).<br><br>\r\n<b>AFTER HOURS PHONE: </b>If you have a different number to be called after hours, enter that number here.<br><br>\r\n<b>E-MAIL: </b>E-Mail Address.<br><br>\r\n<b>WEB: </b>Company Web Address.<br><br>\r\n<b>Save Changes: </b>To save entries made, you MUST press SAVE CHANGES button.<br><br>\r\n',96),(99,17,'Import Customers',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Import Customers</strong></font><a href=\"http://www.nolapro.com/training/admin/admin_import_customers/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em></em> \r\n<p>1) Click Admin.</P>\r\n<p>2) Click Import Customers to import customer information from an outside source. \r\n  Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Admin_Import.jpg\" > \r\n</p>\r\n<p>3) Enter the path to the file you would like to import. You can either manually \r\n  type the file path or browse to find an outside source.</p>\r\n<p>4) Click the <img src=\"images/importaccts.gif\" width=\"30\" height=\"30\"> \r\n  button. <br>\r\n  <br>',98),(100,18,'Send New Message','Write me',99),(101,20,'Check in','<center><H2><b>Document Manager - Check in</b></H2></center><br>\r\n<i>This screen shows a list of documents that you currently have checked out.  To check a document back in, click on it\\\'s title, then select the file from your computer.</i><br><br>\r\n<font size=\"-1\"><b>Check In: </b>This button allows you to check-in a document you currently have checked out and are editing.<br><br>\r\n<font size=\"-1\"><b>Search: </b>This button allows you to search for a document by it\\\'s description, filename, or comments.<br><br>\r\n<font size=\"-1\"><b>Add: </b>This button allows you to add a new document to the NOLA Document Manager.<br><br>\r\n',100),(102,20,'Search','<center><H2><b>Document Manager - Search</b></H2></center><br>\r\n<i>You can search document manager for files by their description, filename, or comments.  Enter a short search string next to \"Search Term\", and click the \"Search\" button.  A list of matching files will then appear.</i><br><br>\r\n<font size=\"-1\"><b>Check In: </b>This button allows you to check-in a document you currently have checked out and are editing.<br><br>\r\n<font size=\"-1\"><b>Search: </b>This button allows you to search for a document by it\\\'s description, filename, or comments.<br><br>\r\n<font size=\"-1\"><b>Add: </b>This button allows you to add a new document to the NOLA Document Manager.<br><br>\r\n',101),(103,20,'Add','<center><H2><b>Document Manager - Add</b></H2></center><br>\r\n<i>This screen allows you to add a new file to the system.  Click the location button and select the file you want to add from your computer.  You can enter information about it, including it\\\'s category, size, desciption, etc.  You can also set the user rights on who has permission to view or modify the document.</i><br><br>\r\n<font size=\"-1\"><b>Check In: </b>This button allows you to check-in a document you currently have checked out and are editing.<br><br>\r\n<font size=\"-1\"><b>Search: </b>This button allows you to search for a document by it\\\'s description, filename, or comments.<br><br>\r\n<font size=\"-1\"><b>Add: </b>This button allows you to add a new document to the NOLA Document Manager.<br><br>\r\n',102),(105,22,'Company Options','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Company Options</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_company/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr><br>\r\n<p>From the Main Menu select <b><i>Billing -> Setup-Receivables -> Company Options</b></i>.</p>\r\n<p>Your screen should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/ARCompanyOptions.jpg\"></p>\r\n<br>\r\n<ol>\r\n    <li><b>Invoice Past Due Service Charge.</b>The standard \r\n    charge to apply to an open invoice when payment is not received by the due \r\n    date. </li>\r\n    <li><b>Invoice Interest Rate per Month. </b>This is an \r\n    additional charge applied to an open invoice every 30 days once overdue (until it is paid).</li>\r\n    <li><b>Credit Card Processor. </b>If you accept credit cards in payment, you will need to select which processor to use. If you select MANUAL, then that assumes you will be running the credit card through an unattached device. If you select one of the services showing, then credit cards will automatically process through that account.</li>\r\n    <li><b>Default Invoice Sell Unit. </b>In order to speed up order and invoice entry, you can set a default sell unit name. If you DO select one, then when you begin an invoice, that is the unit name that will be pre-selected.</li>\r\n    <li><b>Default Invoice Price Unit. </b>In order to speed up order and invoice entry, you can set a default price unit name. If you DO select one, then when you begin an invoice, that is the unit name that will be pre-selected.</li>\r\n    <li><b>Default Sell Units per Price Unit. </b>In order to speed up order and invoice entry, you can set a default number of sell units per price unit. If you DO select one, then when you begin an invoice, that is the conversion that will be pre-selected.</li>\r\n    <li><b>Default Invoice Note. </b>You can select a note that will auto-fill in the notes area for an invoice. It might be a seasonal greeting, or any other message (perhaps your company vacation schedule).</li>\r\n    <li><b>Invoice Format </b>You have two options here. To print the entire invoice via the computer output, or to skip the header with your company name and logo -- as you would if you are using pre-printed stock.</li>\r\n    <li><b>Allow Fufillment Orders on B2B Site: </b>Check this box if you want Fulfillment Orders to be entered on your B2B Site.</li>\r\n    <li><b>Allow Service Orders on B2B Site: </b>Check this box if you want Service Orders to be entered on your B2B Site.</li>\r\n    <li><b>Invoice Format for Unit Price. </b>Select from the drop-down whether you want to see the unit price column on the invoice or not.</li>\r\n    <li><b>Service Order Summary Level: </b> Select from Maximum Summary (groups by Rate), Keep Detail - Show Names, Keep Detail - No Names.</li>\r\n    <li><b>Default Category for Service Orders: </b>In order to speed up order entry, you can set a default Sales Category for Service Orders. If you DO select one, then when you begin an order, that is the Category that will be pre-selected.</li>\r\n    <li><b>Default Category for Fulfillment Orders: </b>In order to speed up order entry, you can set a default Sales Category for Fulfillment Orders. If you DO select one, then when you begin an order, that is the Category that will be pre-selected.</li>\r\n    <li><b>Default Category for Invoices: </b>In order to speed up Invoice entry, you can set a default Sales Category for Invoices. If you DO select one, then when you begin an invoice, that is the Category that will be pre-selected.</li>\r\n    <li><b>Default Category for Sales Receipts without Invoice: </b>In order to speed up Sales Receipt entry, you can set a default Sales Category for Sales Receipts w/o Invoices. If you DO select one, then when you begin a Sales Receipt, that is the Category that will be pre-selected.</li>\r\n    <li><b>Enter the Next Invoice number.</b> Will only be used if higher \r\n    than any existing invoice number. </li>\r\n    <li><b>Do Not Use Order Number as Basis for Invoice Number: </b>Check this box to TURN OFF using the Order Number as a basis for assigning an Invoice Number. If boxed is not checked, Next Invoice Number will be used to assign Invoice Numbers.</li>\r\n    <li><b>Do Not Auto-Apply Payments to Oldest Invoices: </b>If checked, payments entered will NOT be automatically applied against the oldest invoices.</li>\r\n    <li><b>Unpaid Days Past Invoice to Show Overdue Order Entry Warning: </b>Enter the number of days past the INVOICE date to start displaying and printing Overdue warning messages, if the invoice has not been paid.</li>\r\n    <li><b>How to Apply Sales Tax to Invoice and Order Items: </b> You have the choice to tax all items on an invoice according to the taxes attached to the Company or to individually tax each line item on the invoice or order. </li>\r\n    <li><b>Tax Who: </b>Select to tax on the basis of the Order-by Address, the Ship-To Address, or to never apply sales taxes.</li>\r\n    <li><b>Sales Tax Districts for WALK-INS: </b>NOTE: These tax districts are only used if the \"Tax Who:\" field is set to Ship-To Address.  You may select up to three(3) tax districts from the pull-down boxes. If you need to add a district, click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> Add button. </li>\r\n</ol>\r\n<p>Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save changes.</p><br>',104),(107,22,'Sales Tax','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales Taxes</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_sales_tax/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter to edit or add a sales tax for Federal, State, City or Local.</em>\r\n<p align=\"left\"> <ol>\r\n<li> From the Main Menu, select <b><i>Billing -> Setup-Receivables -> Sales Taxes</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/SalesTaxUpdate.jpg\"></p>\r\n</ol>\r\n\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\">\r\n<strong>Edit an Existing Sales Tax</strong></font></div>\r\n<hr>\r\n<p align=\"left\"><ol>\r\n<li> Select the Tax District Name from the pull-down list.</li></p>\r\n<li> Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> <b>Edit</b>  button. Your screen should look similar to this:</li> </p>\r\n<p align=\"center\"><img src=\"images/screenshots/SalesTaxUpdate3.jpg\"></p>\r\n<li><b> Enter information in the following categories:</b></li></p>\r\n<ol TYPE=\"a\">\r\n  <p>\r\n       <li><b>Tax State: </b>Select the state (or province) from the drop-down box. This is essential for the SHOPPING CART to function correctly.</li>\r\n       <li><b>Tax District Name: </b>This is where you put Federal, your State, your City, your Local or your County.</li>\r\n       <li><b>Tax Rate:</b>This is the tax rate for the Tax District. (ex: tax is 7.5%, then enter 7.5 here).</li>\r\n       <li><b>Basis for Tax: </b>Select from the pull-down list. Examples: \r\n    Total Sales or Materials only. Total Sales is the most common basis.</li>\r\n       <li><b>GL Account: </b>Select from the pull-down list. This is the \r\n    payables account the sales tax will accrue to for GL financial reports.</li></p>\r\n     </ol>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b>  button to save changes. </li></p>\r\n<li> Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> <b>Delete</b>  button to delete the Tax. </li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b>  button to return to previous screen without saving the changes.</li></p>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\">\r\n<strong>Add a New Sales Tax</strong></font></div>\r\n  <hr></hr>\r\n<p align=\"left\"><ol>\r\n<li> Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> <b>Add</b> button from the first screen. Your screen should look similar to this:</li> </p> \r\n<p align=\"center\"><img src=\"images/screenshots/SalesTaxAdd.jpg\" ></p>\r\n<p align=\"left\">\r\n<li><b> Enter information in the following categories:</b></li></p>\r\n<ol TYPE=\"a\">\r\n  <p>\r\n       <li><b>Tax State: </b>Select the state (or province) from the drop-down box. This is essential for the SHOPPING CART to function correctly.</li>\r\n       <li><b>Tax District Name: </b>This is where you put Federal, your State, your City, your Local or your County.</li>\r\n       <li><b>Tax Rate: </b>This is the tax rate for the Tax District. (ex: tax is 7.5%, then enter 7.5 here).</li>\r\n       <li><b>Basis for Tax: </b>Select from the pull-down list. Examples: Total Sales or Materials only. Total Sales is the most common basis.</li>\r\n       <li><b>GL Account: </b>Select from the pull-down list. This is the payables account the sales tax will accrue to for GL financial reports.</li></p>\r\n      </ol>\r\n\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to add the Sales Tax. </li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b>  button to return to the previous screen without saving the changes.</li></p>\r\n',106),(109,22,'Quote Comment Table','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Quote Comment Table</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_quote_comment/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>These comments will appear on all quotes given to any customer who has been assigned this quote comment. These should be very general comments, like: 50% DOWN WITH ORDER.</em>\r\n<p align=\"left\"></p>\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Billing -> Setup-Receivables -> Quote Comments</b></i>. Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/QuoteCommentUpdate.jpg\" ></p>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit an Existing Quote Comment</strong></font></div>\r\n<hr><ol>\r\n<p align=\"left\">\r\n<li> Select the Quote Comment to be edited from the pull-down list.</li></p>\r\n<li> Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> <b>Edit</b> button. Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/QuoteCommentUpdate2.jpg\" ></p>\r\n<li> Update the description of the Quote Comment.</li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save changes. </li></p>\r\n<li> Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> <b>Delete</b> button to delete the Quote Comment.</li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to the previous screen without saving the changes.</li></p>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add a New Quote Comment</strong></font></div>\r\n  <hr></hr>\r\n<p align=\"left\"><ol>\r\n<li> Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> <b>Add</b> button. Your screen should look similar to this: </li> </p> \r\n<p align=\"center\"><img src=\"images/screenshots/QuoteCommentAdd.jpg\" ></p>\r\n<p align=\"left\">\r\n<li> Enter the New Quote Comment.</li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b>  button to add the Quote Comment. </li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b>  button to return to the previous screen without saving the changes.</li></p>\r\n  </p>',108),(110,22,'Sales Personnel','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales Personnel</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_sales_personnel/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter to edit or add a salesperson, you can enter in their name or their employee number.  This information will include personal information and commission data.</em>\r\n<p>From Main Menu select <b><i>Billing -> Setup-Receivables -> Sales Personnel</b></i>. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/SalesPersonnelUpdate.jpg\" ></p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit an Existing Sales Person</strong></font></div>\r\n<hr>\r\n<p align=\"left\">Select the Sales Person from the pull-down list.</p>\r\n<p>2) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> Edit button. Your  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/SalesPersonnelUpdate2.jpg\" ></p>\r\n<p>\r\n<ol>\r\n<li><b>Sales Person:</b> Name of salesperson.</li>\r\n<li><b>Address:</b> Two rows are provided for entering the complete address.</li>\r\n<li><b>Mail Stop:</b> If this person works for a company which uses internal mail, then a Mail Stop code may be necessary to ensure delivery.</li>\r\n<li><b>City:</b> </li>\r\n<li><b>State:</b> Select from the drop-down list.</li>\r\n<li><b>Postal Code:</b> Zip or Postal Code.</li>\r\n<li><b>Country:</b></li>\r\n<li><b>Phone and Phone Description:</b> There are four possible phone numbers that can be entered for this person, so a description field is provided to indicate what that phone is (cell, pager, fax, home, etc.).</li>\r\n<li><b>E-mail and E-mail description:</b> There are two possible entries for E-mail address, so a description is provided to know how each is to be used.</li>\r\n<li><b>Social Security: </b> Enter the social security number WITHOUT any dashes between the number groups.</li>\r\n<li><b>Employee: </b> If this salesperson is ALSO on your regular payroll, then you can tie this salesperson record into the employee record by selecting the employee from the pull-down box.</li>\r\n<li><b>Commission Rate:</b> Percent commission (10% enter as 10).</li>\r\n<li><b>Commission Base:</b> What number should the percentage commission be applied to.</li>\r\n<li><b>Sales Person:</b> Check this box if this persons job is sales person.<br>\r\n<li><b>Sales Rep:</b> Check this box if this persons job is sales representative.</li>\r\n</ol>\r\n</p><br>\r\n<p>Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save changes. </p>\r\n<p>Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> Delete button to delete the Sales Person. </p>\r\n<p>Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button to return to previous screen without saving the changes.</p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add a New Sales Person</strong></font></div>\r\n  <hr></hr>\r\n<p>Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\">Add button on the first screen. Your screen should look similar to this: </p> </p> \r\n<p align=\"center\"><img src=\"images/screenshots/SalesPersonnelAdd.jpg\" ></p>\r\n<p>\r\n<ol>\r\n<li><b>Sales Person:</b> Name of salesperson.</li>\r\n<li><b>Address:</b> Two rows are provided for entering the complete address.</li>\r\n<li><b>Mail Stop:</b> If this person works for a company which uses internal mail, then a Mail Stop code may be necessary to ensure delivery.</li>\r\n<li><b>City:</b> </li>\r\n<li><b>State:</b> Select from the drop-down list.</li>\r\n<li><b>Postal Code:</b> Zip or Postal Code.</li>\r\n<li><b>Country:</b></li>\r\n<li><b>Phone and Phone Description:</b> There are four possible phone numbers that can be entered for this person, so a description field is provided to indicate what that phone is (cell, pager, fax, home, etc.).</li>\r\n<li><b>E-mail and E-mail description:</b> There are two possible entries for E-mail address, so a description is provided to know how each is to be used.</li>\r\n<li><b>Social Security: </b> Enter the social security number WITHOUT any dashes between the number groups.</li>\r\n<li><b>Commission Rate:</b> Percent commission (10% enter as 10).</li>\r\n<li><b>Commission Base:</b> What number should the percentage commission be applied to.</li>\r\n<li><b>Sales Person:</b> Check this box if this persons job is sales person.</li>\r\n<li><b>Sales Rep:</b> Check this box if this persons job is sales representative.</li>\r\n</ol>\r\n</p>\r\n<p>Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save changes.</p>\r\n<p>Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to previous screen without saving the changes.<br>\r\n  <br>',109),(111,22,'Invoice Terms','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Invoice Terms</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_invoice_terms/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter to setup customer\'s terms for their invoice. An Invoice \r\n  Term is the amount of time or an actual due date that you and your customer \r\n  have agreed upon for them to pay their invoice(s). </em>\r\n<p align=\"left\">\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Billing -> Setup Receivables -> Invoice Terms</b></i>.</li></p>\r\n<li>Your screen should look similar to this: </li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceTermsUpdate.jpg\" ></p>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit an Existing Invoice Term</strong></font></div>\r\n<hr>\r\n<p align=\"left\"><ol>\r\n<li>Select Invoice Terms to be edited from the pull-down list.</li></p>\r\n<li>Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> Edit button. Your \r\n  screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceTermsUpdate2.jpg\" ></p>\r\n<li>Edit Data in the following categories:</li></p>\r\n<ol TYPE=\"a\">\r\n  <li> <b> Verbal.</b> (What prints on the invoice) You can enter in \r\n    how many days (example: Net 30 days) or you can enter in an actual date that \r\n    the invoice is due (Example: 15th of every month).</li>\r\n  <li> <b>Discount Percent.</b> This is the percentage they receive off the total invoice amount if they pay the invoice before the discount date.</li>\r\n   <li><b>Discount Days.</b> This is the amount of days the customer has to pay the invoice, in advance of the actual due date, to receive the discount percentage.</li>\r\n   <li><b>Net Due Days.</b> The number of days the customer has to pay from the invoice date. </li><p>\r\n</ol>\r\n<li>Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save changes. </li></p>\r\n<li>Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"><b>Delete</b>  button to delete the Invoice Terms. </li></p>\r\n<li>Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b>  button to return to the previous screen without saving the changes.</li></p>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add a New Invoice Term</strong></font></div>\r\n  <hr></hr>\r\n<p align=\"left\">\r\n<ol>\r\n<li>Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> <b>Add</b> button. Your screen should look similar to this: </li> </p>\r\n     <p align=\"center\"><img src=\"images/screenshots/InvoiceTermsAdd.jpg\" ></p>\r\n<li><b>Enter Data in the following categories:</b></li>\r\n\r\n<ol TYPE=\"a\">\r\n    <li><b>Verbal.</b> (What prints on the invoice) You can enter in how many days (example: Net 30 days) or you can enter in an actual date that the invoice is due (Example: 15th of every month).</li>\r\n    <li><b>Discount Percent.</b> This is the percentage they receive off the total invoice amount if they pay the invoice before the discount date.</li>\r\n    <li><b>Discount Days.</b> This is the amount of days the customer has to pay the invoice, in advance of the actual due date, to receive the discount percentage.</li>\r\n    <li><b>Net Due Days.</b> The number of days the customer has to pay from the invoice date. </li></p>\r\n</ol>\r\n<li>Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to add the Invoice Term. </li></p>\r\n<li>Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to the previous screen without saving the changes.</li></p>',110),(112,22,'Standard GL Account (Billing)','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Standard GL Accounts (Billing)</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_standard_gl_accounts/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter to enter/update standard posting accounts \r\nto be used by Accounts Receivable when posting data to the \r\nGeneral Ledger.</em><p>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Billing -> Setup-Receivables -> Standard GL Account</b></i>.</li> </p>\r\n<li>Your screen should look similar to this:</li>\r\n<p align=\"center\"><img src=\"images/screenshots/ARStandardGLAccounts.jpg\" >\r\n<p align=\"left\">\r\n<li>Complete the information in the following categories:</li>\r\n<ol TYPE=\"a\">\r\n  <li><b>Cash: </b> When entering CASH receipts, this is the GL account to be posted to.</li>\r\n  <li><b>Checking: </b> When receiving CHECKS, etc., this is the GL account to be posted to.</li>\r\n  <li><b>Interest Income: </b> This account is only used if the customer PAYS interest. You may accrue interest on their account that they do not pay.</li>\r\n  <li><b>Discount Given: </b> If you extend discount terms to your customers, this is the GL account that should post to.</li>\r\n  <li><b>Cost of Goods Sold: </b> The default cost of sales account. (you can enter another number at the time of invoicing if desired).</li>\r\n  <li><b>Inventory: </b> When you enter cost of sales, the opposite entry to that in the GL is inventory (inventory reduced, cost of sales increased).</li>\r\n  <li><b>Shipping Liability: </b> Shipping charges are pass-through amounts. The customer pays them, but you then pay UPS or whomever. This is the Payables account for shipping.</li>\r\n  <li><b>Receivables: </b> Open Account invoices post originally to this GL account, and when the invoice is paid, it reduces this account (which is an asset account).</li>\r\n  <li><b>Bad Debt: </b> The default account used for Bad Debt entries. </li>\r\n  <li><b>Customer Deposits: </b> The default account when a customer puts a deposit down on an order.</li>\r\n  <li><b>Sales Refunds: </b> Checks written to refund credit balances will be posted to this account.</li>\r\n  <li><b>Service Sales Labor GL Account: </b> The default account for Labor entries on Service Orders.</li>\r\n  <li><b>Is Freight Taxable?: </b> Check this box to apply sales tax to your shipping charges. </li>\r\n  <li><b>Is Service Labor Taxable?: </b> Check this box to apply sales tax to labor on Service Orders. </li>\r\n  <li><b>Unit Name for Labor Hours: </b>Select your the unit of measure used to charge service labor from the pull-down list.</li>\r\n  </ol><p>\r\n\r\n<li>Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save changes.</li>\r\n<ol>',111),(113,22,'Shipping Carrier/Methods','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Shipping Carrier/Methods</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_carrier/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter to enter in the different types of shipping \r\ncarrier/methods you use.  Examples: UPS or Federal Express.</em>\r\n<p>From Main Menu, select <b><i>Billing -> Setup-Receivables -> Shipping Carrier/Methods</b></i>.</p>\r\n<p>Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/CarrierUpdate.jpg\" ></p>\r\n<hr>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><b>Assign Display Order</b></font></div>\r\n<hr>\r\n<ol>\r\n<li> To assign the order the carriers will display, click the <img src=\"images/list.gif\" width=\"30\" height=\"30\"> Assign Display Order button. </li>\r\n<li> You should see a screen similar to this: </li>\r\n<p align=\"center\"><img src=\"images/screenshots/CarrierDisplayOrder.jpg\">\r\n</p>\r\n<li>Enter the position in the list you want the carrier to display in the Sort Order column.</li><br>\r\n<li>Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button to return to the Edit Shipping Carrier/Methods screen without saving any changes.</li> <br>\r\n<li>Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save your changes.</li>\r\n</ol> <hr>\r\n\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><b>Adding or Editing an Existing Shipping Carrier/Methods </b></font></div>\r\n<hr>\r\n<p align=\"left\"><ul>\r\n<li>To <b>Edit</b>, Select the Carrier from the top pull-down list then click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> Edit button.</li>\r\n<li>To <b>ADD</b> a carrier who is NOT entered as a vendor in this system, simply click on the <img src=\"images/add.gif\">Add button.</li></p>\r\n<li>To ADD a carrier who IS already entered as a vendor, select that vendor from the drop-down list on the bottom portion of the screen, and then click the <img src=\"images/next.gif\"> Next button.</li>\r\n</ul>\r\n<p>Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/CarrierUpdate2.jpg\" ></p>\r\n<p></p>\r\n<b>Enter the information in the following categories: </b>\r\n<ol>\r\n<li><b>Company Name:</b> The name of the Carrier Company</li>\r\n<li><b>Name:</b> Contact Name</li>\r\n<li><b>Vendor Code: </b>Enter the code for this Vendor in your Accounts Payable system.</li>\r\n<li><b>Address:</b> Two lines are provided for the complete address.</li>\r\n<li><b>City:</b> Carrier\'s City</li>\r\n<li><b>State:</b> Select a state from the drop-down menu.</li>\r\n<li><b>Postal Code:</b> Zip code or Postal Code</li>\r\n<li><b>Country:</b></li>\r\n<li><b>Mail Stop:</b> If the vendor is a large concern that uses internal mailing, you may need to include a mail stop in order for mailings to reach the right person.</li>\r\n<li><b>Phone and Description:</b> Three phone numbers can be entered for this vendor. Because of that, a description field is provided for each phone so you can tell what its use is (warehouse, office, fax, etc.)</li>\r\n<li><b>E-mail and Description:</b> Vendor email and perhaps under the description a note about WHO the email belongs to.</li>\r\n<li><b>Web Address:</b> If the vendor has a web-site, enter that here.</li>\r\n<li><b>Federal ID:</b> For tax information you will need the vendor federal tax ID number.</li>\r\n<li><b>Order From Company Information:</b> If this is to be the SAME as already entered in the upper portion, check the \"Order From same as above\" box. If the name and address you order from is DIFFERENT from the PAY TO information, then enter that information here.  Only ONE phone number entry is provided in this section.</li>\r\n<li><b>Image:</b> For the purposes of the SHOPPING CART you can attach a vendor BRAND image that can show on the Shopping Cart display.  If you have entered one for this vendor, it will display towards the top of this screen. Use the BROWSE to find a copy of the image locally and upload it to your server.</li>\r\n<li><b>Payment Terms:</b> Select the USUAL terms extended to you by this vendor. These terms can be over-ridden during individual bills entry.</li>\r\n<li><b>Pay None:</b> This is a payables function.  You can check this box if you want to place all of this vendors bills on HOLD - - not to be paid.</li>\r\n<li><b>No Returns Accepted: </b> Check this box if you will not accept returns from this Carrier.</li>\r\n<li><b>Lead Time (Days): </b> Enter the number of days ahead of shipment you must notify the carrier.</li>\r\n<li><b>Default Shipping Method: </b> Select the default shipping method for this carrier from the pull-down list.</li>\r\n<li><b>Default GL Account:</b> The USUAL GL Account used for indicating what expense type this purchase is.</li>\r\n<li><b>Default Bill Description:</B> The USUAL Description for this bill.  Some people like to use the vendor name for this because then it shows on the journal entries.</li>\r\n<li><b>Customer Account:</b> The account number assigned by this vendor to your company.</li>\r\n<li><b>Shopping Cart Search Display:</b> Should this vendor BRAND information show up on the Shopping Cart.  Check the box for YES.</li>\r\n<li><b>Carrier Information:</b></li>\r\n<ol TYPE=\"a\">\r\n     <li><b>Customer Code Number: </b> Customer code used when accessing the vendor web-site for tracking and freight information.</li>\r\n     <li><b>Tracking URL:</b> The IP address of the Vendors direct access web site for freight information.</li>\r\n     <li><b>Tracking Number Variable:</b>  The field name to pass along with the URL to query a specific shipment.</li>\r\n</ol><p></p>\r\n</ol>\r\n<p>Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save changes. </p>\r\n<p>If you are EDITING, click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> <b>Delete Carrier Info Only</b> button to delete the Carrier Information Only. The Vendor information will remain in the Accounts Payable system.</p>\r\n<p>If you are EDITING, click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> <b>Delete Carrier and Vendor Info</b> button to delete both the Carrier Information AND the Vendor information stored in the Accounts Payable system.</p>\r\n<p>Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to previous screen without saving the changes.</p>\r\n<br><hr><br>\r\n<p align=\"left\">If you are EDITING, click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> <b>Update/Add Carrier Methods button</b>. Your screen should look similar to this: (see below for explanation)</p>\r\n<p align=\"center\"><img src=\"images/screenshots/ShippingMethodUpdate.jpg\" ></p>\r\n<p>To return to the previous screen WITHOUT saving changes, click the <img src=\"images/closewindow.gif\" width=\"30\" height=\"30\"> <b>Close Window</b> button.</p>\r\n<p>Select a shipping method from the drop-down list then click on the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> <b>EDIT</b> button, or click on the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> <b>ADD</b> button to create a new method.</p>\r\n<p>Your screen should now look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/ShippingMethodUpdate2.jpg\" ></p>\r\n<p align=\"left\"><blockquote>\r\n<b>Description:</b> The name of the method (2nd Day Air, etc.)<br>\r\n<b>Abbreviation:</b> The brief name of the method used when accessing the carrier web-site.<br>\r\n</blockquote></p><br>\r\n<p>Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save your changes.</p>\r\n<p>Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> <b>Delete</b> button to delete this Shipping Method from this Carrier.</p>\r\nClick the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to the Carrier Edit screen. Be sure to click Save to keep your changes.</p>\r\n\r\n',112),(114,23,'Sales/Pricing Unit Names','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales/Pricing Unit Names</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_inventoryUnits/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this program to create a list of pricing, stocking and \r\npurchasing unit names for selection when entering inventory \r\nitems, creating purchase orders, creating sales orders or in \r\nthe shopping cart.  </em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Setup - Inventory -> Sales/Pricing Unit Names</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/UnitNameUpdate.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To Edit an existing Unit Name, select a Unit Name from the pull-down list and click on the <img src=\"images/edit.gif\"> <b>Edit</b> button.</li></p>\r\n\r\n<li>To Add a new Unit Name, click on the <img src=\"images/add.gif\"> <b>Add</b> button.</li></p> \r\n</ol>\r\n<hr>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit an Existing Sales/Pricing Unit Name</strong></font></div>\r\n<hr>\r\n<p align=\"left\">\r\n\r\n<ol>\r\n<li>Clicking on the <img src=\"images/edit.gif\"> <b>Edit</b> button produces a screen similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/UnitNameUpdate2.jpg\"> \r\n<p align=\"left\">\r\n\r\n      <ol TYPE=\"a\">\r\n           <li>Make any changes to the Sales/Pricing Unit Name.</li> </p>\r\n      </ol>\r\n           \r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button. </li></p>\r\n\r\n<li>To delete this Unit Name, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button.</li></p>\r\n\r\n<li>To return to the previous screen WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n</ol>\r\n<hr>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong> Add a New Sales/Pricing Unit Name</strong></font></div>\r\n<hr>\r\n<ol>\r\n<li>Clicking on the <img src=\"images/add.gif\"> button should produce a screen similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/UnitNameAdd1.jpg\"></p>\r\n<p align=\"left\">\r\n    <ol TYPE=\"a\">\r\n          <li>Enter the new Sales/Pricing Unit Name.</li></p>\r\n     </ol>\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button. </li></p>\r\n<li>To return to the previous screen, WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n    \r\n</ol>',113),(115,23,'Inventory Locations','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Setup - Inventory Locations</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_PlantLocations/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Add or edit information on the locations where inventory is stored - different buildings, different warehouses or different plants.  You must have at least one \r\nlocation.</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Setup - Inventory -> Inventory Locations</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Plant1.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Choose one of the following Options:</b></li></p>\r\n         <ol TYPE=\"a\">\r\n              <li><b>Edit</b> - Select an existing location from the pull-down list and click on the <img src=\"images/edit.gif\"> <b>Edit</b> button.</li></p>\r\n              <li><b>Add</b> - To add an new location, click on the <img src=\"images/add.gif\"> <b>Add</b> button.</li></p>\r\n         </ol>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Setup_Plant2.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter/Edit the information in the following categories: </b></li></p>\r\n     <ol TYPE=\"a\">\r\n          <li><b>Inventory Location Name: </b>Enter the name of the location as you want it to show in the pull-down lists in NolaPro.</li></p>\r\n          <li><b>City/State/Zip/Country/Mail Stop: </b>Enter the street address information for this Location.</li></p>\r\n          <li><b>Phone: </b>Enter up to four(4) telephone numbers(with dashes) and descriptions for this Location.</li></p>\r\n          <li><b>Email: </b>Enter up to two(2) email addresses for this Location.</li></p>\r\n          <li><b>Web Address: </b>Enter the Website address for this Location.</li></p>\r\n          <li><b>Federal ID: </b>(for US customers) Enter the US Employer\'s Identification Number (EIN).</li></p>\r\n          <li><b>Print Location: </b>(for NolaPrint customers) Check this box if this Location is a Print Location.  You must have AT LEAST ONE of the locations check-marked as a print location in order for the updates of inventory to work correctly from the Printshop Module. </li></p>\r\n       </ol>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b>  button.</li></p>\r\n\r\n<li>To delete an existing Location, click the <img src=\"images/delete.gif\"> <b>Delete</b> button.</li></p>\r\n\r\n<li>To return to the previous screen WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li> </p>\r\n</ol>',114),(116,23,'Standard GL accounts (Inventory)','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Inventory Setup - Standard GL Accounts</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_StandardGLAccounts/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Inventory transactions (sales, purchases and adjustments) \r\nthat are posted to the General Ledger changes the value of \r\nthe inventory.  Some of the account numbers used for posting are specified \r\nat the item level during input, but some apply generally for the entire Inventory module and these are entered here. </em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Setup - Inventory -> Standard GL Accounts</b></i>.</li> </p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_StandardGLAccount.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<b><i>All Account Number fields have a \"Lookup\" feature. To find an account, type the name(or portion of the name) or the account number.  This will cause a list of matching accounts to show in a pop-up list.  Highlight the account of your choice.</b></i></p>\r\n\r\n<li><b>Enter data into the following categories: </b></li></p>\r\n    <ol TYPE=\"a\">\r\n         <li><b>Cash:</b> Enter the GL Account where you want income posted.</li></p>\r\n         <li><b>Sales:</b> GL Account to use for sales if no other account is available.</li></p>\r\n         <li><b>Inventory Loss:</b> When physical inventory or adjustments to inventory cause losses, the dollar amounts for these losses will be charged to this GL account.</li></p>\r\n         <li><b>Cost of Goods:</b> Enter the GL account used to track COST of Good Sold.</li></p>\r\n         <li><b>Freight Expense:</b> Enter the account used for Incoming freight expense charges.</li></p>\r\n         <li><b>Tax Paid Expense:</b> Enter the account to record taxes paid on purchases of inventory items.</li></p>\r\n         <li><b>Default Location:</b>If you have more than one location, the one selected here will be used as a default location by the Shopping Cart module and for Fulfillment Orders.</li></p>\r\n         <li><b>Default Price Level:</b> Which selling price level is used most often (and is used for the Shopping Cart).</li></p>\r\n         <li><b>Default Inventory Account:</b> Enter the GL account number that is used most often for changes in your Inventory On-Hand.</li></p>\r\n         <li><b>Use Item Sales Account (not customer):</b> Select whether the sales account from the Customer account or the Sales account from the Item record should be used to post sales to General Ledger. </li></p>\r\n         <li><b>Item Weight Units:</b> Are weight units for inventory in lbs. or kgs. - Select from pull-down list.</li></p>\r\n         <li><b>Category Usage:</b>This choice tells the system how you want the Item Search Categories to work in the Shopping Cart and the Orders modules. Select Hierarchy or Parallel Labels are defined below:</li>\r\n           <blockquote>\r\n              <dl>\r\n                    <dt><b>Hierarchy: </b>The Search Categories can have sub-categories set up.  For Example, the Item may be in the Computer Category and within \"Computers\" it falls into a \"Flat Panel Monitor\" Search Category. Think of it visually like this:</p>\r\n             <blockquote> Computers<br>\r\n                     ----->      Flat Panel Monitor<br>\r\n              </blockquote>              \r\n                   <dt><b>Parallel Labels: </b>This choice allows you to check multiple Search Categories this Item can found under.  For example, the Item could have \"Computer Accessories\", \"Monitors\", and \"Office Equipment\" checked.</dt>\r\n          </df>\r\n      </blockquote>\r\n    \r\n      </ol>\r\n\r\n<li>To add a new General Ledger Account to the Chart of Accounts, click on the <img src=\"images/add.gif\"> <b>Add New GL Account</b> button.</li></p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n',115),(118,23,'Item Categories','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Setup - Item Categories</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_itemCategories/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Item categories allow you to group your inventory items into like groups to ease searches and reports.  You can also specify different seasons for each category, so that stocking levels for items can vary with the demand of the different seasons.</em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Setup - Inventory -> Item Categories.</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemCategoryUpdate.jpg\"></p>\r\n<p align=\"left\">\r\n</ol>\r\n\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit an Existing Item Category</strong></font></div><hr></hr>\r\n\r\n<ol>\r\n<li> Select the Item Category you want to edit from the pull-down list.</li></p> \r\n<li>To continue the edit, click the <img src=\"images/edit.gif\"> <b>Edit</b> button. Your screen should now look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemCat2.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Edit the following information:</b></li></p>\r\n    <ol TYPE=\"a\">\r\n          <li><b>Category Name: </b> - Edit the name of the category, if necessary.</li></p>\r\n          <li><b>Print Items Category: </b>(for Nolapro Print modules customers) Check this box if this Item Category is a Print Items Category.  You must have AT LEAST ONE of the categories check-marked as a print item category in order for the updates of inventory to work correctly from the Printshop Module. </li></p>\r\n          <li><b>Season: </b> - Enter up to four(4) seasons for this product group. Seasons allow you to specify different stocking levels for an item depending on the season. If the product category is not seasonal, enter a 1 for the beginning month and a 12 for the ending month.</li></p>\r\n      </ol>\r\n\r\n<li>To return to the previous screen WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n\r\n<li>To remove the Item Category, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button.</li></p>\r\n</ol>\r\n<br><hr>\r\n\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Add a New Item Category</strong></font></div>\r\n<hr>\r\n<ol>\r\n<li>To add a new Item Cateogory, click on the <img src=\"images/screenshots/Add.gif\"> <b>Add</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemCat3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data into the following fields:</b></li></p>\r\n       <ol TYPE=\"a\">\r\n            <li><b>Category Name: </b>Enter the Item Category Name in the top box.</li></p>\r\n            <li><b>Print Items Category: </b>(for NolaPrint customers) Check this box if this Item Category is a Print Items Category. </li></p>\r\n            <li><b>Season Name: </b>Enter the name of the season pertaining to this Category. For example, Holiday Labels may have seasons of Easter, 4th of July, Halloween, and Christmas. </li></p>\r\n           <li><b>Beginning Month and Ending Month (NUMBERS not NAMES): </b>Enter 1 - 12 in the appropriate boxes. Seasons allow you to specify different stocking levels for an item depending on the season. If the product category is not seasonal, enter a 1 for the beginning month and a 12 for the ending month.</li></p>\r\n     </ol>\r\n\r\n<li>To save the new Item Category, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n\r\n<li>To return to the previous screen WITHOUT saving the changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n</ol>',117),(120,23,'Pricing Levels',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong> Setup - Price Levels</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_PriceLevels/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Price levels provide a way to offer different prices to groups of customers.  For example, retail, wholesale, or education prices.  This will also display a list of your Price Level descriptions and their average markup percentage.  Average Markup Percentages are entered through Standard Markup.</em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Setup - Inventory -> Price Levels</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/pricelevelupdate.jpg\"></p>\r\n<p align=\"left\">\r\n<br>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Update a Pricing Level</strong></font></div>\r\n<hr></hr>\r\n<ol>\r\n<li>Select the Price Level you want to edit from the pull-down list. </li></p>\r\n\r\n<li>To continue with the edit, click on the <img src=\"images/edit.gif\"> <b>Edit</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_PriceLevel1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Make any updates or changes to the Price Level Description.</li></p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button. </li></p>\r\n\r\n<li>To delete the price level, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button.</li> </p>\r\n\r\n<li>To return to the previous screen WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li> </p>\r\n</ol>\r\n<br>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Add a New Pricing Level</strong></font></div>\r\n<hr></hr>\r\n<ol>\r\n<li>To add a new Price Level, click on the <img src=\"images/screenshots/Add.gif\"> <b>Add</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_PriceLevel3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li> Enter a Price Level Description.</li></p>\r\n\r\n<li>To save the Price Level Description, click on the <img src=\"images/save.gif\"> <b>Save</b> button. </li></p>\r\n\r\n<li>To return to the previous screen WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n</ol>\r\n',119),(122,23,'Standard Markup Sets','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong> Setup - Standard Markup</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_StandardMarkups/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Define markups for each price level.  Items can use these standard \r\nmarkup sets or can be \"fixed price\".  This will also display a list \r\nof your markup set descriptions, pricing levels and markup percentages.</em>\r\n<ol>\r\n\r\n<li>From the Main Menu, select <b><i>Inventory -> Setup - Inventory -> Standard Markup Sets</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/StandardMarkupSetUpdate.jpg\"> \r\n</p>\r\n<p align=\"left\">\r\n</ol>\r\n<br>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit an Existing Markup Set</strong></font></div>\r\n<hr>\r\n<ol>\r\n<li>Select the markup set you want to edit from the pull-down list. </li></p>\r\n\r\n<li>To continue with the edit, click on the <img src=\"images/edit.gif\"> <b>Edit</b> button. Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Setup_StndMrkup2.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Edit the data in the following categories:</b></li></p>\r\n    <ol TYPE=\"a\">\r\n          <li><b>Markup Set Description: </b> Name used for referring to this markup set.</li></p>\r\n          <li><b>Markup Based On: </b>Apply markup to which cost... First, Mid or Last. (First is the oldest price paid for current stock, mid is the average of all purchases in stock, last is the most recent price paid for stock).</li></p>\r\n         <li><b>Price Level/Markup: </b>Next to each price level you can enter a percentage (enter 15% as 15) that the items will be marked up for selling.</li></p>\r\n    </ol>\r\n<br>\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button. </li></p>\r\n\r\n<li>To delete this Markup Set, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button.</li></p>\r\n\r\n<li>To return to the previous screen WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n</ol>\r\n<br>\r\n\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Add a New Markup Set</strong></font></div>\r\n<hr>\r\n\r\n<ol>\r\n<li>To add a new Standard Markup Set, click on the <img src=\"images/add.gif\"> <b>Add</b> button.  Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Setup_StndMrkup3.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data into the following categories: </b>\r\n     <ol TYPE=\"a\">\r\n           <li><b>Markup Set Description: </b>Name used for referring to this markup set.</li></p>\r\n           <li><b>Markup Based On:</b> Apply markup to which cost... First, Mid or Last. (First is the oldest price paid for current stock, mid is the average of all purchases in stock, last is the most recent price paid for stock).</li></p>\r\n     </ol>\r\n</p>\r\n\r\n<li>To return to the previous screen WITHOUT adding the new Markup Set, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To save the new Markup Set Description and Base and enter the Markup Percentages, click on the <img src=\"images/next.gif\"> <b>Next</b> button.  Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Setup_StndMrkup4.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>Enter the Markup for each price level needed.</li></p>\r\n\r\n<li>To return to the previous screen WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To save the new Markup Set, click on the <img src=\"images/save.gif\"> <b>Save</b> button. </li></p>\r\n',121),(124,24,'Vendor Terms','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Vendor Terms</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_setup_vendor_terms/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<br>\r\n<em>Use this program to define your various Payment Term agreements with your vendors, such as a 2% discount if paid within 15 days, no penalty if paid within 30 days, etc.</em>\r\n<ol>\r\n\r\n<li>From the Main Menu, select <b><i>Payables -> Setup - Payables -> Vendor Terms</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this: </p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/VendorTermsUpdate.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To EDIT the an existing Terms record, do the following: </b></li></p>\r\n    <ol TYPE=\"a\">\r\n        <li>Select the <b>Vendor Terms: </b> your want to edit from the pull-down list.</li>\r\n        <li>Click the <img src=\"images/edit.gif\"> <b>Edit</b> button. </li></p>\r\n    </ol></p>\r\n\r\n<li>To ADD a new Terms record, click on the <img src=\"images/add.gif\"> <b>Add</b> button.</li></p>\r\n    \r\n<li>Whether EDITING or ADDING, your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/VendorTermsUpdate1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter/Modify data in the following categories:</b></li></p>\r\n    <ol TYPE=\"a\">\r\n          <li><b>Verbal: </b>This is the text that will appear on the pull-down boxes when selecting Terms under vendors. Examples: Net 15 Days, Net 30 Days, etc.</li></p>\r\n          <li><b>Discount Percent: </b>If you pay the invoice before the due date, some companies will give you a certain percentage off the total invoice. This is where you would enter that percentage. <i>(Enter as a percentage, for example, 2% would be entered as 2.0 NOT .02)</i>.  If no discount percent is taken put in 0.000. </li></p>\r\n         <li><b>Discount Days: </b>This is where you would enter the number of days you would have to pay the invoice to receive the discount. For example: If your terms are 2% 15 Net 30 days, your discount days could be 15 days.</li></p>\r\n         <li><b>Discount Day of Month (Prox): </b>Use when a discount occurs on the same day every month. Here is where you would enter the date that the payment must be made to receive the discount percentage. (typical terms like this are 2% 10th Prox Net 30 -- meaning that if you pay by the the upcoming 10th of the month, you can take the discount.)</li></p>\r\n         <li><b>Net Due Days.</b> This is the length of time you have to pay an invoice after the service was provided or after the product was delivered. Examples: 15 Days, 30 Days, etc.</li></p>\r\n    </ol>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n\r\n<li>To DELETE the Vendor Terms <i>(only available if EDITING)</i></b>, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button. </li></p>\r\n\r\n<li>To return to the previous screen WITHOUT SAVING your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n</ol>',123),(125,24,'Standard GL Account (Payables)','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Standard GL Accounts</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_setup_gl_accounts/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Enter/Update standard posting accounts and other information to be used by Accounts Payable when passing data to the General Ledger. </em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Setup - Payables -> Standard GL Accounts</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/APStandardGLAccounts.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<b><i>USING THE AUTO-LOOKUP FEATURE on GL Account Numbers</b> - Enter the GL Account, Name or any portion of the number, name or description to see a drop-down list of matching account numbers.  Highlight the account to enter it into the field.  A space bar will bring up ALL accounts valid for this field, HOWEVER this is not recommended due to limitations on the length of the list that can be viewed.</i></p>\r\n\r\n<li><b>Edit data in following categories:</b></li></p>\r\n     <ol TYPE=\"a\">\r\n          <li><b>Payables: </b>Enter the GL payables account (bills post into this holding account until they are paid).</li></p>\r\n          <li><b>Interest Expense: </b>Enter the GL Interest expense account (used when you add interest to an ovedue bill when paying.)</li></p>\r\n          <li><b>Discount Earned or Discount Lost: </b>Check the appropriate box. When using Discounts Earned, you are making the assumption that your will NOT pay by the discount date, so the discount amount is posted in full when the bill is received and is only reduced from discounts earned if you do NOT pay within the discount period. When using Discounts Lost, you are making the assumption that you WILL pay by the discount date, and discounts are only accrued when you lose the discount due to late payment.</li></p>\r\n          <li><b>Discount Account: </b>Enter either a discounts earned or lost GL Account (depending on prior question).</li></p>\r\n          <li><b>Cash Payment: </b>Enter the GL CASH account that will be charged when a cash payment is made.</li></p>\r\n          <li><b>Credit Card Payment: </b>Enter the GL account that will be charged when a credit card payment is made.</li></p>\r\n          <li><b>Commission Expense: </b>Select your GL account expense account that will be used to track Commissions Expense.</li></p>\r\n          <li><b>Use Transaction Date: </b>If you check this box, General Ledger transactions will have the current date on them. If it is NOT checked, then the transaction date will be the invoice date, or the check date, etc.</li></p>\r\n          <li><b>Purchase Order Format: </b>Select the format from the pull-down list that you want to use for your Purchase Order printing. The choices are Standard Print, Suppress Header for Preprints (choose this if you are using pre-printed forms), Company Name and Address on Left Side, Company Name and Address on Right Side with Logo, Standard Print with LONG Item Codes.</li></p>\r\n          <li><b>Purchase Order Default Message: </b>Message to print at the bottom of every Purchase Order. NOTE: Only Purchase Orders created after this message is entered will display the message.</li></p>  \r\n          <li><b>Default Payment Terms: </b>New Vendors will automatically be setup with these Terms, which can be overidden.  To ADD a new Terms record, click on the <img src=\"images/add.gif\" width=\"18\" height=\"18\"> <b>Add</b> button to the right of the input box.</li></p>\r\n     </ol>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n\r\n<li>To add a New GL Account from this screen, click on the <img src=\"images/add.gif\"> <b>Add New GL Account</b> button.</li></p>\r\n\r\n<li>To return to the menu WITHOUT SAVING your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n\r\n</ol>',124),(126,24,'Checking Accounts','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Checking Accounts</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_setup_checking_account/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This is where you set up your checking account information. You can set up  multiple checking accounts, define different ones for Payables and Payroll, or designate one account for both Payables and Payroll.  If using Direct Deposit, it is helpful to have your ACH contract with your bank available when completing this screen.</em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Setup - Payables -> Checking Accounts</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CheckingAccountUpdate.jpg\"> </p>\r\n\r\n<li>Select the Checking Account from the pull-down list and then click the <img src=\"images/edit.gif\"> <b>Edit</b> button.</p>\r\n<p>OR --- click on the <img src=\"images/add.gif\"> <b>Add</b> button to create a new checking account entry.</li></p>\r\n\r\n<li>Whether you ADD or EDIT, the next screen should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CheckingAccountUpdate1.jpg\"> </p><p align=\"left\">\r\n\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n     <ol TYPE=\"a\">\r\n         <li><b>Account Name: </b>We suggest entering the Bank name.</li></p>\r\n         <li><b>Last Check # Used: </b>This entry is so your new checks will start at the right numbers for this checking account. </li></p>\r\n         <li><b>Default Endorser: </b>Enter the name of the person responsible for signing the checks (this WILL print on the check under the signature line.  Some banks do not like this so you may need to leave this blank).</li></p>\r\n         <li><b>AP: </b>Check this box if this checking account can be used for Payables checks.</li></p>\r\n         <li><b>Payroll: </b>Check this box if this checking account can be used for Payroll checks.</li></p>\r\n         <li><b>GL Account: </b>The General ledger ASSET account that checks will be drawn from.</li></p></p>\r\n         <li><b>Check Printing: </b>Select the style of check you are using from the pull-down list.</li></p>\r\n         <li><b>Blank Stock Adjustment: </b>When using blank check stock and \"imaging\" the check onto the paper, some horizontal and vertical adjustments may need to be made to accomodate slight variances in where the printer begins printing. Use these two values to properly align the routing number symbol with the area indicated on the blank stock. Units are 1/72 of an inch.  For example, to move printout to the right  and down by a quarter inch enter 18  for horizontal and -18 for vertical.</li></p>\r\n         <li><b>Check Logo: </b>Enter the name of the graphic file containing your company logo that you want to appear on the checks. NolaPro can support JPG and PNG file types. To locate your file, click on the <b>Browse</b> button.</li></p>\r\n         <li><b>Immediate Origin Routing Number*: </b><i>(required for Direct Deposit)</i> Enter your Bank Routing Number of the Checking Account being used to pay these checks. Check with your bank or refer to your ACH contract to complete the fields for Direct Deposit.</li></p>\r\n         <li><b>Immediate Origin Name*: </b><i>(required for Direct Deposit)</i> This is the name of the bank where the Checking Account resides.</li></p>\r\n         <li><b>Bank Account Number*: </b><i>(required for Direct Deposit)</i> Enter the account number your bank has assigned to this Checking Account. Be sure to reference your ACH contract to get the correct account number.</li></p>\r\n         <li><b>Fractional Routing Number: </b>Enter the fractional rounting number your bank has provided to you.</li></p>\r\n         <li><b>Bank City, State, Zip: </b>Enter your Bank\'s City, State and Zip Code. </li></p>\r\n         <li><b>Immediate Destination Routing Number*: </b><i>(required for Direct Deposit)</i> Enter Routing Number of the Federal Reserve Bank where this Direct Deposit clears. This Destination Information should available on your ACH contact.  If not, contact your bank for the proper Destination Routing number.</li></p>\r\n         <li><b>Immediate Destination Name*: </b><i>(required for Direct Deposit)</i> This is the name of the Federal Reserve Center where payments will be sent by your bank.</li></p>\r\n         <li><b>Company Name*: </b><i>(required for Direct Deposit)</i> Enter the name of the company EXACTLY as it appears on your ACH contract.</li></p>\r\n         <li><b>Company Identification*: </b><i>(required for Direct Deposit)</i>  Enter the Company Identification number given to you by your bank.</li></p>\r\n         <li><b>Send Prenotes: </b>Check this box if your bank requires a prenote to be sent before the first \"live\" payment.  A prenote is a \"test run\" to verify all the information is being transferred correctly.</li></p>\r\n     </ol>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b>  button.</li> </p>\r\n\r\n<li>To DELETE this checking account <i>(only available if EDITING)</i>, click the <img src=\"images/delete.gif\"> <b>Delete</b> button. </li></p>\r\n\r\n<li>To return to the previous screen WITHOUT SAVING your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li> </p>\r\n\r\n</ol>',125),(127,25,'Checking Accounts','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Checking Accounts</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_check_accounts/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>You can have multiple checking accounts in your business. \r\nIf you use a separate account for payroll from the rest of your \r\nbusiness transactions, you will need to set up two separate \r\nchecking account entries, indicating which one is for payroll.  \r\nIf you use one account for everything, you need to enter one \r\nonly.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click Checking Accounts. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_Checking1.jpg\" width=\"288\" height=\"66\"></p>\r\n  <div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n    an Existing Checking Account</strong></font></div>\r\n  <hr>\r\n<p>1) Select the Checking Account you want to edit from the pull-down list.</p>\r\n<p>2) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> button. Your \r\n  screen should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/CheckingAccountUpdate1.jpg\" width=\"288\" height=\"136\"> \r\n</p>\r\n<p>3) Edit information in any or all of the following categories:</p>\r\n<blockquote>\r\n  <p> a) <strong>Edit the Account Name.</strong> The name you use to identify \r\n    what it is for. Examples: First National Bank, Payroll, etc.<br>\r\n    b) <strong>Edit the Last Check # Used.</strong><br>\r\n    c) <strong>Edit the Default Endorser.</strong> Name that should print \r\n    under signature line on check.<br>\r\n    d) <strong>Select AP check box </strong>only if this checking account is used \r\n    by Payables as well as Payroll.<br>\r\n    e) <strong>Select Payroll check box </strong>only if this checking account \r\n    is used by Payroll.<br>\r\n    f) <strong>Select the GL Account</strong> from the pull-down list.  \r\n    General ledger account number for checking account (asset-type account).</p>\r\n</blockquote>\r\n<p>4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the changes. </p>\r\n<p>5) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button to \r\n  delete the account. </p>\r\n<p>6) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous page without saving your changes. </p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add \r\n    a New Checking Account</strong></font></div>\r\n  <hr></hr><br>\r\n1) From the main Checking Accounts screen, click the Add button. Your screen should \r\nlook similar to this: \r\n<p align=\"center\"><img src=\"images/screenshots/CheckingAccountAdd.jpg\" width=\"288\" height=\"123\"></p>\r\n<p align=\"left\">2) Add information to any or all of the following categories:</p>\r\n<blockquote> \r\n  <div align=\"left\">  a) <strong>Enter the Account Name. </strong>The name you use to identify what it is for. Examples: First National Bank, Payroll, etc.<br>\r\n  b) <strong>Enter the Last Check # Used.</strong><br>\r\n  c) <strong>Enter the Default Endorser </strong> name that should print \r\n  under signature line on check.<br>\r\n  d) <strong>Select AP check box </strong>only if this checking account is used \r\n  by Payables as well as Payroll.<br>\r\n  e) <strong>Select Payroll check box </strong>only if this checking account is \r\n  used by Payroll.<br>\r\n  f) <strong>Select the GL Account </strong>from the pull-down list.  General \r\n  ledger account number for checking account (asset-type account).</p></blockquote>\r\n<p>3) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the new account.</p>\r\n<p>4) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous screen without saving the changes.<br>\r\n  <br>',126),(128,25,'Pay Types','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Pay Types</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_pay_types/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Type of pay allowed by your company. Typical pay types are: \r\nStraight Time, Overtime, Double Time, Vacation, Sick Leave, \r\nPersonal Leave, etc. But it does not HAVE to be hours. It could \r\nbe mileage or something else.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click Pay Types. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_Pay.jpg\" ></p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n  an Existing Pay Type</strong></font></div>\r\n<hr>\r\n<p align=\"left\">1) Select the Pay Type you want to edit from the pull-down list.</p>\r\n<p align=\"left\">2) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> \r\n  button. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_Pay2.jpg\" ></p>\r\n<p>3) Edit the following information:</p>\r\n<blockquote>\r\n  <p> a) <strong>Name (abbreviation).</strong> Examples: ST (Straight Time), DT (Double \r\n    Time), etc.<br>\r\n    b)<strong> Description.</strong> Examples: Straight Time, Double \r\n    Time, etc.<br>\r\n    c) <strong>Multiplier</strong> Amount to multiply times regular \r\n    pay rate when hours entered for this pay time (Example: double \r\n    time would have a multiplier of 2).<br>\r\n    d) <strong>Type </strong> Select Vacation, Sick or Other from the pull-down list (the system needs to know if this is vacation or sick leave so it can handle limits for these types correctly).</p>\r\n</blockquote>\r\n<p> 4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to \r\n  save the changes. </p>\r\n<p>5) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button to \r\n  delete the Pay Type. </p>\r\n<p>6) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous screen without saving the changes. </p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add \r\n  a New Pay Type</strong></font></div>\r\n  <hr></hr><br>\r\n  1) Click the Add button. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/PayrollPayTypeAdd.jpg\" ></p>\r\n<p>2) Enter information in the following fields:</p>\r\n<blockquote>\r\n  <p> a) <strong>Name (abbreviation).</strong> Examples: ST (Straight Time), DT (Double \r\n    Time), etc.<br>\r\n    b)<strong> Description.</strong> Examples: Straight Time, Double \r\n    Time, etc.<br>\r\n    c) <strong>Multiplier</strong> Amount to multiply times regular \r\n    pay rate when hours entered for this pay time (Example: double \r\n    time would have a multiplier of 2).<br>\r\n    d) <strong>Type </strong> Select Vacation, Sick or Other from the pull-down list (the system needs to know if this is vacation or sick leave so it can handle limits for these types correctly).</p>\r\n</blockquote>\r\n<p>3) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the New Pay type.</p>\r\n<p>4) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous screen without saving the changes.</p><br><br>',127),(129,25,'Deduction Groups','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Deduction Groups</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_deduction_groups/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Deduction groups are used to separate benefits and deductions\r\n and company contributions that apply only to a specific group \r\n of employees. To work, this deduction group must be created \r\n here, entered into the employee data file, and also entered \r\n in the area (deduction, benefit, company contribution, pension \r\n plan, etc.) that is to apply only to these specific employees.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click Deduction Groups. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_Deduction.jpg\" width=\"288\" height=\"61\"></p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n  an Existing Deduction Group</strong></font></div>\r\n<hr>\r\n<p align=\"left\">1) Select the Deduction Group you would like to edit from the \r\n  pull-down list. </p>\r\n<p>2) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_Deduction2.jpg\" width=\"288\" height=\"78\"> \r\n</p>\r\n<p>3) Make any changes you would like to make to the name. </p>\r\n<p>4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the changes.<br>\r\n  <br>\r\n  5) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button to \r\n  delete the Deduction Group. </p>\r\n<p>6) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous page without saving the changes. </p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add \r\n  a New Deduction Group</strong></font></div>\r\n  <hr></hr><br>\r\n1) Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> button. Your screen \r\nshould look similar to this: \r\n<p align=\"center\"><img src=\"images/screenshots/PayrollDeductionGroupAdd.jpg\" width=\"288\" height=\"66\"></p>\r\n<p align=\"center\"> </p>\r\n<p>2) Enter a new Deduction Group in the Name box.</p>\r\n<p>3) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the new Deduction Group. </p>\r\n<p>4) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous page without saving the changes. <br>',128),(132,25,'Enter/Update Tax Tables',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Enter/Update Tax Tables</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_tax_table_update/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This is where you enter the Withholding and Tax Deduction \r\nAllowance tables. All table information should be entered for \r\nANNUAL wages. </em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click Enter/Update Tax Tables. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_TaxTable.jpg\" ></p>\r\n<p align=\"left\">4) Select the Tax Type from the pull-down list.</p>\r\n<p>5) Click the <img src=\"images/edit.gif\" width=\"29\" height=\"29\"> button. Your \r\n  screen should look similar to this (varying slightly by tax type):</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_TaxTable2.jpg\" ></p>\r\n<p>6) Select the Tax Type from the pull-down list.</p>\r\n<p>7) Marital Status from the pull-down list.  - Tax table for which marital status group.</p>\r\n<p>8) Check if you would like to see a Deduction Allowance Table (only some tax \r\n  districts use these â€“ they are credits for AFTER the regular tax is calculated.)</p>\r\n<p>9) Click the <img src=\"images/edit.gif\" width=\"29\" height=\"29\"> button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_TaxTable3.jpg\" ></p>\r\n<p> </p>\r\n<p>10) Enter or update any or all the information in the table. Remember: these \r\n  amounts and percentages are for AFTER exemption allowance has been taken. Most \r\n  tax booklets have a section entitled â€œusing the percentage methodâ€?. \r\n  You will need to use that section. Also remember to always enter ANNUAL tables. \r\n  The software will break down actual taxes based on whether employee is weekly, \r\n  bi-weekly, monthly, etc.</p>\r\n<p>11) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to \r\n  save the Tax Tables. </p>\r\n<p>12) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to \r\n  return to the previous screen without saving the changes. <br>\r\n  <br>',131),(136,25,'General Benefits (Pay)','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> General Benefits (Pay)</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_general_benefits/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>General benefits are for designating specific extras \r\nthat get paid to a group or to all employees.  This could \r\nbe a bonus amount or any other \"extra\" that will be paid \r\nwith each payroll.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click General Benefits (Pay). Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/GeneralBenefits.jpg\" ></p>\r\n<p align=\"left\">4) Enter Data in the following categories: </p>\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Hrly/Slry</strong> Select from the pull-down list. \r\n    This is the employee group that is affected by the contribution amount. If \r\n    the contribution affects BOTH hourly and salaried workers, you will need to \r\n    create two entries.<br>\r\n    b) <strong>Description</strong> Description of pay \r\n    shows on check summaries, etc.<br>\r\n    c) <strong>How Figured</strong> Select method of calculation from the pull-down list.<br>\r\n    d) <strong>Grp. </strong> Select employee Group from the pull-down list.  Each employee \r\n    can be designated as being part of one group. If you want a pay amount \r\n    only to affect a specific group, then enter the group name here, and make \r\n    sure the same group name is in each employee record.<br>\r\n    e) <strong>Rate.</strong> Enter the rate (percentage or flat amount - depending on choice in HOW FIGURED).<br>\r\n    f) <strong>GL Expense Account </strong> Select from the pull-down list.<br>\r\n    g) <strong>Delete the line </strong>by selecting the check box. </p>\r\n</blockquote>\r\n<p>5) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  changes to the General Benefits (Pay). <br>',133),(137,25,'General Deductions','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> General Deductions</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_general_deductions/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Deductions that apply to all or groups of employees all \r\nhaving the same deduction calculation rather than specific \r\nemployees.  This same deduction group label would also need \r\nto be attached to the employee files of those belonging to \r\nthis group.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click General Deductions. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/PayrollGeneralDeductions.jpg\"></p>\r\n<p align=\"left\">4) Enter Data in the following categories:</p>\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Hrly/Slry</strong> Select from the pull-down list. \r\n    This is the employee group that is affected by the contribution amount. If \r\n    the contribution affects BOTH hourly and salaried workers, you will need to \r\n    create two entries.<br>\r\n    b) <strong>Description </strong> Description of contribution \r\n    shows on check summaries, etc.<br>\r\n    c) <strong>How Figured </strong> Select calculation method from the pull-down list.<br>\r\n    d) <strong>Grp. </strong> Select employee group from the pull-down list.  Each employee \r\n    can be designated as being part of one group. If you want a contribution amount \r\n    only to affect a specific group, then enter the group name here, and make \r\n    sure the same group name is in each employee record.<br>\r\n    e) <strong>Rate.</strong> Enter the percentage rate or flat rate amount (depending on choice in HOW FIGURED).<br>\r\n    f) <strong>Yearly Ceiling.</strong> If this deduction is only taken up to a certain maximum amount of wages, and then no more for the year, enter the maximum amount allowed<br>\r\n    g) <strong>GL Payable Account</strong> Select from the pull-down list.<br>\r\n    h) <strong>Vendor Number</strong> Enter Vendor Number box or use \r\n    the Lookup button to search for the Vendor Number. NOTE: To Add A New Vendor, click on the ADD button and follow the steps under Add Vendor section.\r\n    <br>\r\n    i) <strong>Delete the line</strong> by selecting the check box. </p>\r\n</blockquote>\r\n<p>5) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  changes to the General Deductions.</p><br>\r\n  <br>',134),(138,25,'Company Contributions',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Company Contributions</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_company_contributions/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Company Contributions are misc. amounts that a company \r\npays on behalf of an employee, but which does not affect \r\nthe employee pay or deductions in any way.  Typical examples \r\nof these types of contributions are union specified amounts \r\nthat are paid to the union itself rather than the employee.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click Company Contributions. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/CompanyContributions.jpg\" ></p>\r\n<p align=\"left\">4) Enter Data in the following categories: </p>\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Hrly/Slry </strong>Select from the pull-down list. \r\n    This is the employee group that is affected by the contribution amount. If \r\n    the contribution affects BOTH hourly and salaried workers, you will need to \r\n    create two entries.<br>\r\n    b) <strong>Description</strong> â€“ Description of contribution \r\n    will show on check summaries, etc. <br>\r\n    c) <strong>How Figured</strong> Select the calculation method from the pull-down list.<br>\r\n    d) <strong>Select Grp.</strong> from the pull-down list â€“ Each employee \r\n    can be designated as being part of one group. If you want a contribution amount \r\n    only to affect a specific group, then enter the group name here, and make \r\n    sure the same group name is in each employee record. This can be left blank to apply to all groups.<br>\r\n    e) <strong>Rate.</strong> Together with the HOW FIGURED field this may be either a flat amount or a percentage.<br>\r\n    f) <strong>Yearly Ceiling</strong> â€“ If the contribution has \r\n    a wage ceiling over which it no longer applies, enter that here. A zero ceiling \r\n    means there is NO ceiling.<br>\r\n    g) <strong>GL Payable Account</strong> from the pull-down list.<br>\r\n    h) <strong>GL Expense Account</strong> from the pull-down list.<br>\r\n    i) <strong>Vendor Number </strong>in the Vendor Number box or use the \r\n    Lookup button to search for the Vendor Number. NOTE: To Add A New Vendor, \r\n    click on the ADD button and follow information under Add Vendor section.<br>\r\n    j) <strong>Delete all information on a specific line </strong>by checking \r\n    the check box. </p>\r\n</blockquote>\r\n<p>5) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the changes to the Company Contributions.</p><br><br>',135),(139,25,'Pension plans','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Pension Plans</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_pension/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this area to define pension plans, cafeteria plans, \r\n401K type plans, etc. and how the amounts are to be calculated.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click Pension Plans. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/PensionPlans.jpg\" ></p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n  an Existing Pension Plans</strong></font></div>\r\n<hr>\r\n<p align=\"left\">1) Select Pension Plan from the pull-down list.</p>\r\n<p>2) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Payroll_UpdatePensionPlan.jpg\" ></p>\r\n<p align=\"left\"> 3) Edit any or all the information in the following categories: \r\n  (NOTE: To Add a New Vendor, click on the ADD button and follow steps in Add Vendor section.)</p>\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Plan Name.</strong> Example: 401k, etc.<br>\r\n    b) <strong>GL Payable Account</strong> Select from the pull-down list. \r\n    The account the employee contribution part of the pension plan will be listed under \r\n    in the financial reports.<br>\r\n    c) <strong>GL Expense Account for company portion.</strong> The \r\n    account the company contribution part will be listed under in the financial reports.<br>\r\n    d)<strong> Vendor Number</strong>  Enter the Vendor Number or use \r\n    the Lookup button to search for the Vendor Number. NOTE: To Add A New Vendor, click on ADD button and follow steps under Vendor Add section. This is the provider that \r\n    the deductions AND contributions will be sent to.<br>\r\n    e) <strong>W-2 use what box for plan?</strong> Select W2 box from the pull-down \r\n    list. Examples: Box 13 qualified plan, box 14 qualified plan, etc. <br>\r\n    f) <strong>If box 13 qualified plan /letter for W-2 print.</strong> This box requires a letter indicating type of plan to be printed on W-2. Enter the letter here.<br>\r\n    g) <strong>Employer contributes how? </strong> Select from the pull-down \r\n    list. Examples: No contribution, flat percentage, matching percentage, etc. \r\n    <br>\r\n    h) <strong>Maximum % matched by employer.</strong> <br>\r\n    i) <strong>Employee must participate box</strong> If it is required \r\n    that the employees must contribute to the pension plan in order to have the company contribute, check this box.<br>\r\n    j) <strong>Basis for calculation</strong> Select basis from the pull-down list. \r\n    Examples: All Pay, Straight Time, Hourly wages, etc.<br>\r\n    k) <strong>Deduction Group</strong> Select from the pull-down list if the plan is limited to just a specific group of employees. <br>\r\n    l) <strong>Covers which workers</strong> Select from the pull-down list. Example: \r\n    All employees, Only Hourly, Only Salary, etc.<br>\r\n    m) <strong>Select which taxes are calculated on wages reduced by \r\n    pension amounts</strong> Check any appropriate boxes.</p>\r\n</blockquote>\r\n<p>4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the changes. <br>\r\n  <br>\r\n  5) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button to \r\n  delete Pension Plan. </p>\r\n<p>6) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous screen without saving the changes.</p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add \r\n  a New Pension Plan</strong></font></div>\r\n  <hr></hr><br>\r\n1) Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> button. Your screen \r\nshould look similar to this: \r\n<p align=\"center\"><img src=\"images/screenshots/AddPensionPlan.jpg\" ></p>\r\n<p>2) Enter any or all of the information: </p>\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Plan Name.</strong> Example: 401k, etc.<br>\r\n    b) <strong>GL Payable Account</strong> Select from the pull-down list. \r\n    The account the employee contribution part of the pension plan will be listed under \r\n    in the financial reports.<br>\r\n    c) <strong>GL Expense Account for company portion.</strong> The \r\n    account the company contribution part will be listed under in the financial reports.<br>\r\n    d)<strong> Vendor Number</strong>  Enter the Vendor Number or use \r\n    the Lookup button to search for the Vendor Number. NOTE: To Add A New Vendor, click on ADD button and follow steps under Vendor Add section. This is the provider that \r\n    the deductions AND contributions will be sent to.<br>\r\n    e) <strong>W-2 use what box for plan?</strong> Select W2 box from the pull-down \r\n    list. Examples: Box 13 qualified plan, box 14 qualified plan, etc. <br>\r\n    f) <strong>If box 13 qualified plan /letter for W-2 print.</strong> This box requires a letter indicating type of plan to be printed on W-2. Enter the letter here.<br>\r\n    g) <strong>Employer contributes how? </strong> Select from the pull-down \r\n    list. Examples: No contribution, flat percentage, matching percentage, etc. \r\n    <br>\r\n    h) <strong>Maximum % matched by employer.</strong> <br>\r\n    i) <strong>Employee must participate box</strong> If it is required \r\n    that the employees must contribute to the pension plan in order to have the company contribute, check this box.<br>\r\n    j) <strong>Basis for calculation</strong> Select basis from the pull-down list. \r\n    Examples: All Pay, Straight Time, Hourly wages, etc.<br>\r\n    k) <strong>Deduction Group</strong> Select from the pull-down list if the plan is limited to just a specific group of employees. <br>\r\n    l) <strong>Covers which workers</strong> Select from the pull-down list. Example: \r\n    All employees, Only Hourly, Only Salary, etc.<br>\r\n    m) <strong>Select which taxes are calculated on wages reduced by \r\n    pension amounts</strong> Check any appropriate boxes.</p>\r\n</blockquote>\r\n<p>3) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the new Pension Plan. </p>\r\n<p>4) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button to \r\n  delete entries.<br>\r\n  <br>\r\n  5) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous screen without saving the changes.</p><br><br>',136),(140,25,'Rating scale for reviews',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Rating Scale for Reviews</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_rating_scale/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>When writing employee reviews you can use your own \r\nperformance rating scale, which is defined here.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click Rating Scale for Reviews. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeRatingEdit.jpg\" ></p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n  an Existing Rating</strong></font></div>\r\n<hr>\r\n<p align=\"left\">1) Select Rating you want to edit from the pull-down list.</p>\r\n<p>2) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeRatingEdit1.jpg\" ></p>\r\n<p align=\"left\">3) Edit the Description.</p>\r\n<p>4) Click the Save button to save the change. </p>\r\n<p>5) Click the Delete button to delete the Rating.</p>\r\n<p>6) Click the Back button to return to the previous screen without saving the \r\n  changes.</p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add \r\n  a New Rating </strong></font></div>\r\n  <hr></hr><br>\r\n1) Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> button. Your screen \r\nshould look similar to this: \r\n<p align=\"center\"><img src=\"images/screenshots/AddRatingScale.jpg\" ></p>\r\n<p>2) Enter Description. </p>\r\n<p>3) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the New Rating. </p>\r\n<p>4) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous screen without saving the changes.</p><br><br>',137),(141,25,'Standard GL accounts (Payroll)',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Standard GL Accounts - Payroll</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_gl_accounts/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>In addition to some general information about W2s, etc. \r\nthis area is most important for entering of the General Ledger \r\naccounts to be posted to when writing checks. Although throughout\r\n tax entries, deduction entries, etc. you have been asked to \r\n enter General Ledger accounts, some things that are posted \r\n from payroll are not covered anywhere else.  Those accounts\r\n  must be set up here.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click Standard GL Accounts. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/StandardGLAccounts.jpg\" ></p>\r\n<p align=\"left\">4) Edit Data in the Following Categories:</p>\r\n<blockquote>\r\n  <p align=\"left\"> a) <strong>Federal Tax ID </strong>â€“ The Federal \r\n    ID number that will appear on W2s, 941 etc. NOTE: This is a required entry -- the data will not be saved if it is left blank.<br>\r\n    b) <strong>State Unemployment ID </strong>â€“ The State unemployment \r\n    ID for state unemployment reporting.<br>\r\n    c) <strong>W-2 Company Name.</strong><br>\r\n    d)<strong> W-2 Address 1.</strong><br>\r\n    e) <strong>W-2 Address 2.</strong><br>\r\n    f) <strong>W-2 City, State & Zip.</strong><br>\r\n    g) <strong>Post to Payables? </strong>â€“ Checking this box \r\n    determines whether the deductions, pensions, etc. should create payables entries \r\n    when running the payroll.<br>\r\n    h) <strong>Default Checking Account </strong>â€“ the checking \r\n    account normally used for payroll checksâ€“ from the pull-down list. NOTE: \r\n    These checking accounts are set up under Payroll Setup - Checking account.<br>\r\n    i) <strong>Auto print deposit check? </strong>â€“ Checking \r\n    this box will cause a tax deposit check to be generated automatically after \r\n    all the payroll checks are printed.<br>\r\n    j)<strong> Vendor Number for the Payroll Deposit Check</strong> Enter number in the \r\n    Vendor Number box or use the Lookup button to search for the Vendor Number. NOTE: This vendor should be a bank or other financial institution.<br>\r\n    k) <strong>General Ledger Accounts</strong>\r\n<blockquote>\r\n<strong>Checking Account </strong> Select from \r\n    the pull-down list.<br>\r\n    <strong>Federal \r\n    Income Tax </strong>Select the Payable Account from the pull-down list.<br>\r\n\r\n    <strong>FICA Payable Account</strong> \r\n    Select from the pull-down list.<br>\r\n\r\n    <strong>FICA Company Expense </strong> Select the Account \r\n    from the pull-down list.<br>\r\n\r\n    <strong>Medicare Payable Account</strong> \r\n     Select from the pull-down list.<br>\r\n\r\n    <strong>Medicare Expense Account </strong>\r\n    Select from the pull-down list.<br>\r\n\r\n    <strong>Federal Unemployment Tax \r\n    Payable Account</strong> Select from the pull-down list.<br>\r\n\r\n    <strong>Federal Unemployment Tax \r\n    Expense Account </strong> Select from the pull-down list.<br>\r\n\r\n    <strong>State Unemployment Tax Payable \r\n    Account </strong> Select from the pull-down list.<br>\r\n\r\n   <strong>State Unemployment Tax Expense \r\n    Account </strong> Select from the pull-down list.<br>\r\n\r\n    <strong>Workmanâ€™s Comp Payable \r\n    Account </strong> Select from the pull-down list.<br>\r\n\r\n    <strong>Workmanâ€™s Comp Expense \r\n    Account </strong>Select from the pull-down list.<br>\r\n\r\n    <strong>Misc. Deduction Payable Account \r\n    </strong>Select from the pull-down list.<br>\r\n\r\n    <strong>Misc. Tax Exempt Pay Expense \r\n    Account </strong>Select from the pull-down list.\r\n</blockquote>\r\n</blockquote>\r\n<p>5) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the changes.</p><br><br>',138),(142,26,'Set fiscal year','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>Set Fiscal Year</strong></font><a href=\"http://www.nolapro.com/training/gl/gl_fiscal_year/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<p><em> \r\n<p>This chapter allows you to select the date your company begins its fiscal year. \r\n  If your accounting year does not run from January to December, you must set \r\n  the fiscal year for reports to be correct. </p>\r\n</em> \r\n<p>From the Main Menu select Ledger then Setup Functions - Ledger, then Set Fiscal Year. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Setup_FiscalYr.jpg\"></p>\r\n<p>Select the month you would like to begin your fiscal year by using the \r\n  Fiscal Begin Month pull-down list.</p>\r\n<p>Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save \r\n  changes.</p>\r\n',139),(143,26,'Account types','     <div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>Account Types</strong> </font><a href=\"http://www.nolapro.com/training/gl/gl_account_type_edit/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<p><em><b><big><font color=\"red\">WARNING:</font> Do not change the SENSE of what these items are used for!!!  It is very easy to get confused and change a name that means expense into one that means sales.  If you do this, your entire General Ledger will not work right.  So you can change SALES to INCOME for instance, if you prefer to see it named that way, but be VERY carefull when changing these names.</big></b></em></p>\r\n<p><em>This area allows you to update the main General Ledger account type names. There are 14 default Account Types. </em></p>\r\n<p>1) Click Ledger.</p>\r\n<p>2) Click Setup Functions - Ledger.</p>\r\n<p>3) Click Account Types. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Setup_Account.jpg\"></p>\r\n<p>4) Select the type of account from the General Ledger Account Type pull-down \r\n  list.</p>\r\n<p>5) Click the Edit button. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Setup_Account2.jpg\"></p>\r\n<p>6) Update the Name General Ledger Account Type in the box.</p>\r\n<p align=\"left\">7) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> \r\n  button to save your changes. <br>\r\n</p>\r\n<p>8) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to return \r\n  to the previous screen without saving the changes. <br>\r\n  <br>\r\n</p>\r\n</body>',140),(144,26,'Import Accounts','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>Import Accounts</strong> </font></div><hr></hr>\r\n<p><em>This chapter allows you to import accounts from external files. The files must be in CSV format (exported from Microsoft ExcelÂ®) or plain text format.  The files must be formatted as Account Number, Account Name or Description, then Account Type. The Account Type must match one of the 14 account types you setup in the Account Types chapter. It also provides sets of standard accounts organized by industry to make setup easy.</em></p>\r\n<p>From the Main Menu select Ledger, then Setup Functions - Ledger, then Import Accounts. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Setup_Import.jpg\"></p>\r\n<br><br>\r\n<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>Import Accounts - From Your File</strong> </font></div><hr></hr>\r\n\r\n<p> Enter the path and name of the file you would like to import or \r\n  use the Browse button to find it on your computer.</p>\r\n<p>If using the Browse option, a pop-up screen will appear that looks like this:</p>\r\n<p><center><img src=\"images/screenshots/Ledger_Setup_Import1.jpg\"></center></p><p> Select your file then click on the OPEN button. The Browse popup will disappear.</p>\r\n<p>Click the <img src=\"images/importaccts.gif\"> Import Accounts button.</p>\r\n<p>Continue with verification shown below.</p>\r\n<br><br>\r\n<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>Import Industry Standard Chart of Accounts</strong> </font></div><hr></hr>\r\n<p>Select the industry you want from the drop-down list, then click the <img src=\"images/importaccts.gif\"> Import Standard Set of Accounts button.</p>\r\n<p>When importing industry standard set, there will be no more steps.</p>\r\n<br><br>\r\n<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>Verification Step of Import</strong> </font></div><hr></hr>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Setup_Import2.jpg\"></p>\r\n<p>Confirm the data is correct. Any missing or wrong account types will need to be corrected before proceding with the import.</p>\r\n<p align=\"left\">Click the Submit \r\n  button when you are ready to save.</p>\r\n<p align=\"left\"><strong>NOTE:</strong> If you are not importing your chart of \r\n  accounts, you will need to enter them all using Edit Chart of Accounts.\r\n</p>',141),(145,26,'Export Accounts','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>Export Accounts</strong> </font><a href=\"http://www.nolapro.com/training/gl/gl_account_export\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<p><em>\r\n<p><em>This chapter allows you to export accounts in a plain text format. You \r\n  may want to export your accounts to Import into another software, such as Excel.</em></p>\r\n This is not an initial setup function. </em> </p>\r\n<p>From Main Menu select Ledger then Setup Functions - Ledger, then Export Accounts. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Setup_Export.jpg\"></p>\r\n<p>Right click the Download button (if you left-click the button it will bring up the exported data into a screen that you can copy and paste into a document). Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Setup_Export2.jpg\"></p>\r\n\r\n<p>From the first pop-up window, click Save Target As. </p>\r\n<p>From the second pop-up window, enter a file name and browse to where you would like to save the file.</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Ledger_Setup_Export3.jpg\"></p>\r\n<p align=\"left\">Click the Save button.</p>\r\n<p align=\"left\"><br>\r\n</p>',142),(159,33,'What records should be kept and for how long?','<p align=\"center\"><font face=\"Arial, Helvetica, sans-serif\"><font size=\"+1\">Keeping \r\n            Information </font></font></p>\r\n          <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Many financial \r\n            professionals often wonder what documents they need to keep and for \r\n            how long. Certainly you do not want to keep everything; that just \r\n            makes it more difficult to find something when you do need it. Use \r\n            the chart below as a quick reference when determining how long to \r\n            keep your documents. </font></p>\r\n          <table width=\"80%\" border=\"1\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" bordercolor=\"#000066\">\r\n            <tr align=\"left\" valign=\"middle\" bgcolor=\"#000066\"> \r\n              <td width=\"75%\"><div align=\"center\"><strong><font color=\"#FFFFFF\" face=\"Arial, Helvetica, sans-serif\">Category</font></strong></div></td>\r\n              <td width=\"25%\"><div align=\"center\"><strong><font color=\"#FFFFFF\" face=\"Arial, Helvetica, sans-serif\">Time</font></strong></div></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Accident \r\n                    Reports/Claims (settled) </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Accounts \r\n                    Payable &amp; Receivable Ledgers</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Audit \r\n                    Reports </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Bank \r\n                    Reconciliations</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">2 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Bank \r\n                    Statements </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">3 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Capital \r\n                    Stock &amp; Bond Records: Ledgers, Transfer Registers, Stubs \r\n                    Showing Issues, Record of Interest Coupons, Options, etc.</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Cash \r\n                    Books </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Chart \r\n                    of Accounts</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Checks \r\n                    (canceled) </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Checks \r\n                    (canceled - for important payments - i.e. taxes, purchases \r\n                    of property, special contracts, etc - check should be filed \r\n                    with the papers pertaining to the underlying transaction.)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Contracts, \r\n                    Mortgages, Notes and leases (expired)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Contracts, \r\n                    Mortgages, Notes and Leases (still in effect)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Correspondence \r\n                    (general) </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">2 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Correspondence \r\n                    (legal &amp; important matters only)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Correspondence \r\n                    (routine) with customers and/or vendors</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">2 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Deeds, \r\n                    Mortgages and Bill of Sale</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Depreciation \r\n                    Schedules </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Duplicate \r\n                    deposit slips</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">2 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Employment \r\n                    Applications </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">3 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Employment \r\n                    Tax Returns</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">4 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Expense \r\n                    Analyses/Expense Distribution Schedules</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Financial \r\n                    statements (year-end other options)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Garnishments</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">General/Private \r\n                    Ledgers, Year-end Trial Balance</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Insurance \r\n                    Policies (expired)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">3 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Insurance \r\n                    Records, Current Accident Reports, Claims, Policies, etc.</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Internal \r\n                    Reports (misc)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">3 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Inventories \r\n                    of Products, Materials and Supplies</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Invoices \r\n                    (to customers, from vendors) </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Journals</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Magnetic \r\n                    Tape and Tab Cards</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">1 \r\n                    yr </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Minute \r\n                    Books of directors, Stockholders, Bylaws and Charter</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Notes \r\n                    Receivable Ledgers and Schedules</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Option \r\n                    Records (expired)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Patents \r\n                    &amp; Related Papers </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Payroll \r\n                    Records &amp; Summaries</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Personnel \r\n                    Files (terminated)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Petty \r\n                    Cash Vouchers</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">3 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Physical \r\n                    Inventory Tags</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">3 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Plant \r\n                    Cost Ledgers</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Property \r\n                    Appraisals by Outside Appraisers</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Property \r\n                    records, Including Costs, Depreciation Schedules, blueprints \r\n                    and plans </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Purchase \r\n                    Orders (except purchasing dept copy)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">1 \r\n                    yr </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Purchase \r\n                    Orders (purchasing dept. copy)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Receiving \r\n                    Sheets </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">1 \r\n                    yr </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Retirement \r\n                    &amp; Pension Records </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">1 \r\n                    yr </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Requisitions</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">1 \r\n                    yr </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Sales \r\n                    Commission Reports </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">3 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Sales \r\n                    Records </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Scrap \r\n                    &amp; Salvage Records</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Stock \r\n                    and Bond Certificates (canceled)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Stockroom \r\n                    Withdrawal Forms</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">1 \r\n                    yr </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Subsidiary \r\n                    Ledgers </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Tax \r\n                    returns and worksheets, revenue agents\' reports and other \r\n                    documents relating to determination of income tax liability</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Time \r\n                    books/cards</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Trademark \r\n                    Registrations and Copyrights</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Training \r\n                    manuals </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Union \r\n                    Agreements </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Permanently</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Voucher \r\n                    register and schedules </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Vouchers \r\n                    for Payments to vendors, employees, etc. (includes allowances \r\n                    and reimbursement of employees, officers, etc for travel and \r\n                    entertainment)</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Withholding \r\n                    Tax State</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">10 \r\n                    yrs</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n          </table>\r\n          <p align=\"left\">&nbsp;</p>\r\n          </blockquote></td>',152),(255,33,'What should be listed on my invoices?','- A beginning balance (the previous month\'s ending balance).\r\n- All invoices charged during the month.\r\n- Payments received during the month.\r\n- Any debit memos or credit memos.\r\n- An ending balance.\r\n- A due date.',247),(266,40,'Glossary: A','<p><strong>Above The Line:</strong> This term can be applied to many aspects of \r\n  accounting. It means transactions, assets, etc., that are associated with the \r\n  everyday running of a business. </p>\r\n<p><strong>Account:</strong> An accounting record, grouped according to customer \r\n  or purpose, in which the results of transactions are accumulated; shows increases, \r\n  decreases, and a balance. </p>\r\n<p><strong>Accounting: </strong>Refers to the overall process of tracking your \r\n  business\'s income and expenses. By using these numbers in various calculations \r\n  and formulas to answer specific questions about the tax and financial status \r\n  of your business.</p>\r\n<p><strong>Accounting Cycle:</strong> The procedures for analyzing, recording, \r\n  classifying, summarizing, and reporting the transactions of a business from \r\n  the start of the year to closing them at the end.</p>\r\n<p><strong>Accounting Equation:</strong> The formula used to prepare a balance \r\n  sheet: Assets = Liability + Equity.</p>\r\n<p><strong>Accounting Model:</strong> The basic accounting assumptions, concepts, \r\n  principles, and procedures that determine the manner of recording, measuring, \r\n  and reporting an entity\'s transactions. </p>\r\n<p><strong>Accounting Period:</strong> A period of time for which records are maintained and at the end of which financial statements are prepared covering the period. </p>\r\n<p><strong>Accounting System:</strong> The set of manual and computerized procedures \r\n  and controls that provide for identifying relevant transactions or events; preparing \r\n  accurate source documents, entering data into the accounting records accurately, \r\n  processing transactions accurately, updating master files properly, and generating \r\n  accurate documents and reports. </p>\r\n<p><strong>Accounts Payable:</strong> An amount owed to a supplier or vendor for \r\n  good or services purchased on credit; payment is due within a short time period, \r\n  usually 30 days or less. Also called A/P.</p>\r\n<p><strong>Accounts Receivable:</strong> A current asset representing money due \r\n  for services performed or merchandise sold on credit. Also called A/R.</p>\r\n<p><strong>Accounts Receivable Turnover:</strong> A measure used to determine \r\n  a company\'s average collection period for receivables; computed by dividing \r\n  net sales (or net credit sales) by average accounts receivable. </p>\r\n<p><strong>Accrual-Basis Accounting:</strong> A system of accounting in which \r\n  revenues and expenses are recorded as they are earned and incurred, not necessarily \r\n  when cash is received or paid. </p>\r\n<p><strong>Accrued Expenses:</strong> Expenses that arise through adjusting entries \r\n  when accounting for unrecorded expenses. </p>\r\n<p><strong>Accrued Liabilities:</strong> Liabilities that arise through adjusting \r\n  entries when accounting for unrecorded liabilities. </p>\r\n<p><strong>Accrued Revenue:</strong> A revenue which has been earned during an \r\n  accounting period but which has not been paid or recorded because payment is \r\n  not due. </p>\r\n<p><strong>Accumulated Depreciation:</strong> The total depreciation recorded \r\n  on an asset since its acquisition; a contra account deducted from the original \r\n  cost of an asset on the balance sheet. </p>\r\n<p><strong>Acid-test Ratio (or quick ratio): </strong>A measure of a firm\'s ability \r\n  to meet current liabilities; more restrictive than the current ratio, it is \r\n  computed by dividing net quick assets (all current assets, except inventories \r\n  and prepaid expenses) by current liabilities. </p>\r\n<p><strong>Active Periods:</strong> Allow for posting of financial entries to \r\n  the sub-ledgers or General Ledger within the period specified. </p>\r\n<p><strong>Adjusted Gross Income:</strong> An individual taxpayer\'s total income \r\n  minus deductions (adjustments) for individual retirement plan contributions \r\n  and alimony paid. </p>\r\n<p><strong>Adjusting Entries:</strong> Entries required at the end of each accounting \r\n  period to recognize, on an accrual basis, revenues and expenses for the period \r\n  and to report proper amounts for asset, liability, and owners\' equity accounts. \r\n</p>\r\n<p><strong>Adjustments to Gross Income:</strong> Amounts deducted from the gross \r\n  income of an individual taxpayer in arriving at adjusted gross income; includes \r\n  contributions to individual retirement plans and alimony paid. </p>\r\n<p><strong>Adverse Opinion:</strong> Audit report indicating the auditor believes \r\n  the overall financial statements are so materially misstated or misleading that \r\n  the statements do not fairly represent the financial position or results of \r\n  the operations and cash flows.</p>\r\n<p><strong>Aged Payables: </strong>An analysis of Accounts Payable which have \r\n  been classified according to the length of time that they have been outstanding \r\n  or that they have been due and payable. The time may be measured (aged) by invoice \r\n  date or by due date for each invoice (detailed) or by Supplier totals. </p>\r\n<p><strong>Aging Reports: </strong>In accounts receivable, it is a list of customers \r\n  open balances and their due dates. In accounts payable, it will help you manage \r\n  you outstanding bills.</p>\r\n<p><strong>Allowance for Bad Debits:</strong> It is an estimate of uncollectable \r\n  customer accounts. </p>\r\n<p><strong>Allowance Method:</strong> The recording of estimated losses due to \r\n  uncollectable accounts as expenses during the period in which the sales occurred. \r\n</p>\r\n<p><strong>Amortization:</strong> The process of cost allocation that assigns \r\n  the original cost of an intangible asset to the periods benefited. </p>\r\n<p><strong>Annual Report: </strong>A document that summarizes the results of operations \r\n  and financial status of a company for the past year and outlines plans for the \r\n  future. </p>\r\n<p><strong>Annuity:</strong> A series of equal amounts to be received or paid \r\n  at the end of equal time intervals. </p>\r\n<p><strong>Appropriation Account:</strong> An account in the nominal ledger which \r\n  shows how the net profits of a business (usually a partnership, limited company \r\n  or corporation) have been used. </p>\r\n<p><strong>Arm\'s-length Transactions:</strong> Business dealings between independent \r\n  and rational parties who are looking out for their own interests. </p>\r\n<p><strong>Arrears:</strong> Bills which should have been paid. For example, if \r\n  you have forgotten to pay your last 3 months rent, then you are said to be 3 \r\n  months in arrears on your rent. </p>\r\n<p><strong>Articulation: </strong>The interrelationships among the financial statements. \r\n</p>\r\n<p><strong>Asset Turnover Ratio:</strong> An overall measure of how effectively \r\n  assets are used during a period; computed by dividing net sales by average total \r\n  assets. </p>\r\n<p><strong>Assets:</strong> Items of value held by the business. Examples: cash, \r\n  accounts receivable, fixtures, furniture, equipment, vehicles, buildings, and \r\n  money on hand or in the bank.</p>\r\n<p><strong>At Cost:</strong> The \'at cost\' price usually refers to the price originally \r\n  paid for something, as opposed to, say, the retail price.</p>\r\n<p><strong>Audit: </strong>The result of an independent accountant\'s review of \r\n  the statements and footnotes to ensure compliance with generally accepted accounting \r\n  principles and to render an opinion on the fairness of the financial statements. \r\n</p>\r\n<p><strong>Audit Committee: </strong>Members of a client\'s board of directors \r\n  who are responsible for dealing with the external and internal auditors. </p>\r\n<p><strong>Audit Report:</strong> A report issued by an independent CPA that expresses \r\n  an opinion about whether the financial statements present fairly a company\'s \r\n  financial position, operating results, and cash flows in accordance with generally \r\n  accepted accounting principles. </p>\r\n<p><strong>Audit Trail:</strong> Information in the accounting system that allows \r\n  you to reconstruct how a transaction affected each account balance, who performed \r\n  the processing, etc.. </p>\r\n<p><strong>Authorized Stock:</strong> The amount and type of stock that may be \r\n  issued by a company, as specified in its articles of incorporation. </p>\r\n<p><strong>Automatic Allocation: </strong>Pre-defined distributions ratios which \r\n  apportion and assign debits and credits to the appropriate accounts. When an \r\n  automatic allocation code is entered at the time a Supplier invoice is recorded, \r\n  the automatic allocation program will distribute the invoice total to the pre-determined \r\n  accounts and for the proper amounts. </p>\r\n<p><strong>Available-for-sale securities</strong>: Debt and equity securities \r\n  not classified as trading, held-to-maturity, or equity method securities.<br>\r\n</p>',248),(272,40,'Glossary: B','<strong>Bad Debt: </strong>An uncollectable Account Receivable. \r\n<p><strong>Balance Sheet (statement of financial position):</strong> The financial \r\n  statement that shows the assets, liabilities, and owners\' equity of an entity \r\n  at a particular date. </p>\r\n<p><strong>Bank Reconciliation:</strong> The process of systematically comparing \r\n  the cash balance as reported by the bank with the cash balance on the company\'s \r\n  books and explaining any differences. </p>\r\n<p><strong>Basis of Accounting: </strong>A term used to refer to when revenues, \r\n  expenditures, expenses and transfers - and the related assets and liabilities \r\n  - are recognized in the accounts and reported in the financial statements.</p>\r\n<p><strong>Basket Purchase:</strong> The purchase of two or more assets acquired \r\n  together at a single price.</p>\r\n<p><strong>Benefits:</strong> Payments to which participants may be entitled under \r\n  a pension plan, including pension benefits, death benefits and benefits due \r\n  on termination of employment. </p>\r\n<p><strong>Bill:</strong> A term typically used to describe a purchase invoice.</p>\r\n<p><strong>Bill of Materials (BOM): </strong>A list including the name and price \r\n  of each material or part required to manufacture a finished product. It sometimes \r\n  shows the processing cost (labor and overhead) at each stage of production.</p>\r\n<p><strong>Board of Directors: </strong>Individuals elected by the stockholders \r\n  to govern a corporation. </p>\r\n<p><strong>Bond:</strong> A contract between a borrower and a lender in which \r\n  the borrower promises to pay a specified rate of interest for each period the \r\n  bond is outstanding and repay the principal at the maturity date. </p>\r\n<p><strong>Bond Carrying Value:</strong> The face value of bonds minus the unamortized \r\n  discount or plus the unamortized premium. </p>\r\n<p><strong>Bond Discount:</strong> The difference between the face value and the \r\n  sales price when bonds are sold below their face value. </p>\r\n<p><strong>Bond Indenture:</strong> A contract between a bond issuer and a bond \r\n  purchaser that specifies the terms of a bond. </p>\r\n<p><strong>Bond Maturity Date:</strong> The date at which a bond principal or \r\n  face amount becomes payable. </p>\r\n<p><strong>Bond Premium: </strong>The difference between the face value and the \r\n  sales price when bonds are sold above their face value. </p>\r\n<p><strong>Bookkeeping:</strong> Refers to the task of recording the date, amount \r\n  and source of all business revenues and expenses. </p>\r\n<p><strong>Book Value:</strong> The net amount shown in the accounts for an asset, \r\n  liability, or owners\' equity item. </p>\r\n<p><strong>Book Value per Share:</strong> A measure of net worth; computed by \r\n  dividing stockholders\' equity for each class of stock by the number of shares \r\n  outstanding for that class. </p>\r\n<p><strong>Budget:</strong> A plan of financial operation embodying an estimate \r\n  of propose expenditures for a given period and the proposed means of financing \r\n  them. The term usually indicates a financial plan for a single fiscal year.</p>\r\n<p><strong>Business: </strong>An organization operated with the objective of making \r\n  a profit from the sale of goods or services. </p>\r\n<p><strong>Business Documents:</strong> Records of transactions used as the basis \r\n  for recording accounting entries; includes invoices, check stubs, receipts, \r\n  and similar business papers. </p>\r\n<p><strong>Business Expenses:</strong> Expenses that have been paid or incurred \r\n  in the course of business and that are ordinary, necessary, and reasonable in \r\n  amount. <br>\r\n</p>',249),(273,40,'Glossary: C','<p><strong>Calendar Year: </strong>An entity\'s reporting year, covering 12 months \r\n  and ending on December 31. </p>\r\n<p><strong>Callable Bonds: </strong>Bonds for which the issuer reserves the right \r\n  to pay the obligation before its maturity date. </p>\r\n<p><strong>Capital:</strong> The total amount of money or other resources owned \r\n  or used to acquire future income of benefits. </p>\r\n<p><strong>Capital Account:</strong> An account in which a proprietor\'s or partner\'s \r\n  interest in a firm is recorded; it is increased by owner investments and net \r\n  income and decreased by withdrawals and net losses. </p>\r\n<p><strong>Capital Expenditure: </strong>An expenditure that is recorded as an \r\n  asset because it is expected to benefit more than the current period. </p>\r\n<p><strong>Capital Gain:</strong> The excess of the selling price over the cost \r\n  basis when assets, such as securities and other personal and investment assets, \r\n  are sold. </p>\r\n<p><strong>Capital Lease: </strong>A leasing transaction that is recorded as a \r\n  purchase by the lessee. </p>\r\n<p><strong>Capital Stock:</strong> The portion of a corporation\'s owners\' equity \r\n  contributed by investors (owners) in exchange for shares of stock. </p>\r\n<p><strong>Cash:</strong> Coins, currency, money orders, checks, and funds on \r\n  deposit with financial institutions; the most liquid of assets. </p>\r\n<p><strong>Cash-Basis Accounting: </strong>A system of accounting in which transactions \r\n  are recorded and revenues and expenses are recognized only when cash is received \r\n  or paid. </p>\r\n<p><strong>Cash Budget:</strong> The amount of cash set aside each month to meet \r\n  expected financial obligations of that month. </p>\r\n<p><strong>Cash Disbursements Journal: </strong>A special journal in which all \r\n  cash paid out for supplies, merchandise, salaries, and other items is recorded. \r\n</p>\r\n<p><strong>Cash Dividend:</strong> A cash distribution of earnings to shareholders. \r\n</p>\r\n<p><strong>Cash Equivalents: </strong>Short-term, highly liquid investments that \r\n  can be converted easily into cash. </p>\r\n<p><strong>Cash Flow: </strong>A report which shows the flow of money in and out \r\n  of the business over a period of time.</p>\r\n<p><strong>Cash Inflows: </strong>Any current or expected revenues or savings \r\n  directly associated with an investment. </p>\r\n<p><strong>Cash Management:</strong> The monthly assessment of expenses and revenues \r\n  in the organization. </p>\r\n<p><strong>Cash Outflows:</strong> The initial cost and other expected outlays \r\n  associated with an investment. </p>\r\n<p><strong>Cash (Over and Short): </strong>An account used to record overages \r\n  and shortages in petty cash. </p>\r\n<p><strong>Cash Receipts Journal: </strong>A special journal in which all cash \r\n  received, from sales, interest, rent, or other sources, is recorded. </p>\r\n<p><strong>Ceiling: </strong>The maximum market amount at which inventory can \r\n  be carried on the books; equal to net realizable value. </p>\r\n<p><strong>Certified Public Accountant (CPA):</strong> A special designation given \r\n  to an accountant who has met all the statutory and licensing requirements of \r\n  a given state for use of that designation. All U.S. states require accountants, \r\n  at a minimum, to complete successfully a uniform national examination before \r\n  being allowed to designate themselves as CPAs. CPA certificates are issued and \r\n  monitored by state boards of accountancy or similar agencies. </p>\r\n<p><strong>Chart of Accounts:</strong> A systematic listing of all accounts used \r\n  by a company. </p>\r\n<p><strong>Charter (articles of incorporation):</strong> A document issued by \r\n  a state that gives legal status to a corporation and details its specific rights, \r\n  including the authority to issue a certain maximum number of shares of stock.</p>\r\n<p><strong>Check Reconciliation:</strong> The procedure that an outstanding check \r\n  on the company\'s books has been paid and cleared by the bank. </p>\r\n<p><strong>Classified Balance Sheet: </strong>A balance sheet in which assets \r\n  and liabilities are subdivided into current and noncurrent categories. </p>\r\n<p><strong>Closed Transaction:</strong> A transaction that is completed within \r\n  the accounting period; both the purchase and payment or sale and receipt of \r\n  payment occur within the same accounting period. </p>\r\n<p><strong>Closing Entries:</strong> Entries that reduce all nominal, or temporary, \r\n  accounts to a zero balance at the end of each accounting period, transferring \r\n  their preclosing balances to a permanent balance sheet account. </p>\r\n<p><strong>Closing the Books: </strong>A term used to describe the journal entries \r\n  necessary to close the sales and expense accounts of a business at year end \r\n  by posting their balances to the profit and loss account, and ultimately to \r\n  close the profit and loss account also by posting its balance to a capital or \r\n  other account. The net profit that results from the closing of the income and \r\n  expense accounts is transferred to an equity account such as retained earnings.</p>\r\n<p><strong>Code of Professional Ethics:</strong> Rules set by the AICPA\'s Committee \r\n  on Professional Ethics, which govern the conduct of CPAs. </p>\r\n<p><strong>Common Stock: </strong>The most frequently issued class of stock; usually \r\n  it provides a voting right but is secondary to preferred stock in dividend and \r\n  liquidation rights.</p>\r\n<p><strong>Company: </strong>A business separate and distinct from its owner or \r\n  owners and every other business. </p>\r\n<p><strong>Comparative Financial Statements: </strong>Financial statements in \r\n  which data for two or more years are shown together.</p>\r\n<p><strong>Compound Interest: </strong>Applied interest on the capital plus all \r\n  interest accrued to date.</p>\r\n<p><strong>Compound Journal Entry: </strong>A journal entry that involves more \r\n  than one debit or more than one credit or both. </p>\r\n<p><strong>Compounding Period:</strong> The period of time for which interest \r\n  is computed. </p>\r\n<p><strong>Conduit Principle:</strong> The idea that all income earned by an entity \r\n  must be passed through to the owners and reported on their individual tax returns; \r\n  applicable to proprietorships, partnerships, and S corporations. </p>\r\n<p><strong>Consignee: </strong>A vendor who sells merchandise owned by another \r\n  party, known as the consignor, usually on a commission basis. </p>\r\n<p><strong>Consignment:</strong> An arrangement whereby merchandise owned by one \r\n  party (the consignor) is sold by another party (the consignee), usually on a \r\n  commission basis. </p>\r\n<p><strong>Consignor: </strong>The owner of merchandise to be sold by someone \r\n  else, known as the consignee. </p>\r\n<p><strong>Consolidated Financial Statements:</strong> Statements that report \r\n  the combined operating results, financial position, and cash flows of two or \r\n  more legally separate but affiliated companies as if they were one economic \r\n  entity. </p>\r\n<p><strong>Consumption Liability:</strong> The method under which inventories \r\n  are recorded as expenditures/expenses when used.</p>\r\n<p><strong>Contingent Liability: </strong>A potential obligation, dependent upon \r\n  the occurrence of future events. </p>\r\n<p><strong>Contra Account</strong>: An account that is offset or deducted from \r\n  another account. </p>\r\n<p><strong>Contributed Capital:</strong> The portion of owners\' equity contributed \r\n  by investors (the owners) in exchange for shares of stock. </p>\r\n<p><strong>Control Account:</strong> A summary account in the General Ledger that \r\n  is supported by detailed individual accounts in a subsidiary ledger. </p>\r\n<p><strong>Control Activities: </strong>Policies and procedures used by management \r\n  to meet its objectives; generally divided into adequate segregation of duties, \r\n  proper authorization of transactions and activities, adequate documents and \r\n  records, physical control over assets and records, and independent checks on \r\n  performance. </p>\r\n<p><strong>Control Environment:</strong> The actions, policies, and procedures \r\n  that reflect the overall attitudes of top management, the directors, and the \r\n  owners about control and its importance to the entity. </p>\r\n<p><strong>Convertible Bonds:</strong> Bonds that can be traded for, or converted \r\n  to, other securities after a specified period of time. </p>\r\n<p><strong>Convertible Preferred Stock:</strong> Preferred stock that can be converted \r\n  to common stock at a specified conversion rate. </p>\r\n<p><strong>Corporation: </strong>A legal entity chartered by a state; ownership \r\n  is represented by transferable shares of stock. A corporation is owned by one \r\n  or more stockholders.</p>\r\n<p><strong>Cost:</strong> The amount of money or other consideration exchanged \r\n  for goods or services. </p>\r\n<p><strong>Cost Method of Accounting for Investments in Stocks: </strong>Method \r\n  used to account for an investment in the stock of another company when less \r\n  than 20 percent of the outstanding voting stock is owned. </p>\r\n<p><strong>Cost of Finished Goods:</strong> The value (at cost) of newly manufactured \r\n  goods shown in a business\'s manufacturing account. The valuation is based on \r\n  the opening raw materials balance, less direct costs involved in manufacturing, \r\n  less the closing raw materials balance, and less any other overheads. </p>\r\n<p><strong>Cost of Goods Sold (COGS):</strong> The expense incurred to purchase \r\n  or manufacture the merchandise sold during a period. The result represents the \r\n  gross profit. The formula is: Opening stock + purchases - closing stock.</p>\r\n<p><strong>Cost of Sales:</strong> A formula for working out the direct costs \r\n  for your sales (including stock) over a particular period. The result represents \r\n  the gross profit. The formula is: Opening stock + purchases + direct expenses \r\n  - closing stock.</p>\r\n<p><strong>Cost Principle: </strong>The idea that transactions are recorded at \r\n  their historical costs or exchange prices at the transaction date. </p>\r\n<p><strong>Cost-based Pricing: </strong>Where a company bases its pricing policy \r\n  solely on the costs of manufacturing rather than current market conditions. \r\n</p>\r\n<p><strong>Coupon Bonds: </strong>Unregistered bonds for which owners receive \r\n  periodic interest payments by clipping a coupon from the bond and sending it \r\n  to the issuer as evidence of ownership. </p>\r\n<p><strong>Credit:</strong> An entry on the right side of the account to record \r\n  the \"From\" side of a transaction. (Example: if you purchased groceries \r\n  using a check then the money is paid from the bank to the grocery store, you \r\n  would therefore credit the bank when making the journal entry). Credit increase \r\n  liabilities and equity and decreases assets. </p>\r\n<p><strong>Credit Card Draft:</strong> The part of the multiple-page credit form \r\n  that is sent by the retailer to the credit card company for reimbursement of \r\n  the stated amount.</p>\r\n<p><strong>Credit Memo:</strong> Writing off all or part of a customer\'s account \r\n  balance. Example: If a customer returns merchandise, the vendor issues a credit \r\n  memo.</p>\r\n<p><strong>Creditors:</strong> A list of vendors or suppliers to whom the business \r\n  owes money.</p>\r\n<p><strong>Cumulative-Dividend Preference: </strong>The rights of preferred stockholders \r\n  to receive current dividends plus all dividends in arrears before common stockholders \r\n  receive any dividends. current assets: Cash and other assets that may reasonably \r\n  be expected to be converted to cash within a year or during the normal operating \r\n  cycle. </p>\r\n<p><strong>Current-Dividend Preference:</strong> The right of preferred shareholders \r\n  to receive current dividends before common shareholders receive dividends. </p>\r\n<p><strong>Current: </strong>As applied to budgeting and accounting, designates \r\n  the operations of the present fiscal period as opposed to past or future periods. \r\n</p>\r\n<p><strong>Current Assets: </strong>These include money in the bank, petty cash, \r\n  money received but not yet banked, money owed to the business by its customers, \r\n  raw materials for manufacturing, and stock bought for re-sale. They are termed \r\n  \'current\' because they are active accounts. </p>\r\n<p><strong>Current Liabilities:</strong> These include bank overdrafts, short \r\n  term loans (less than a year), and what the business owes its vendors or suppliers. \r\n  They are termed \'current\' because they are active accounts.</p>\r\n<p><strong>Current (or working capital) Ratio: </strong>A measure of the liquidity \r\n  of a business; equal to current assets divided by current liabilities. <br>',250),(275,40,'Glossary: D','<strong>Date of Record:</strong> The date selected by a corporation\'s board of \r\ndirectors on which the shareholders of record are identified as those who will \r\nreceive dividends. \r\n<p><strong>Debentures (unsecured bonds):</strong> Bonds for which no collateral \r\n  has been pledged. </p>\r\n<p><strong>Debit: </strong>An entry on the left side of an account. Debits increase \r\n  assets and decrease liabilities and equity.</p>\r\n<p><strong>Debit Memo:</strong> Billing a customer again. Example: A customer \r\n  purchases an item using a check but the check is returned.</p>\r\n<p><strong>Debt-Equity Management Ratio:</strong> A measurement of the relative \r\n  utilization of debt and equity; computed by dividing average total assets by \r\n  average stockholders\' equity. </p>\r\n<p><strong>Debt Financing: </strong>Acquiring funds by borrowing money from creditors \r\n  in the form of long-term notes, mortgages, leases, or bonds. </p>\r\n<p><strong>Debt Securities: </strong>Financial instruments issued by a company \r\n  that carry with them a promise of interest payments and the repayment of principal. \r\n</p>\r\n<p><strong>Declaration Date:</strong> The date on which a corporation\'s board \r\n  of directors formally decides to pay a dividend to shareholders. </p>\r\n<p><strong>Declining-Balance Depreciation Method:</strong> An accelerated depreciation \r\n  method in which an asset\'s book value is multiplied by a constant depreciation \r\n  rate (such as double the straight-line percentage, in the case of double-declining-balance.) \r\n</p>\r\n<p><strong>Deduction: </strong>Business expenses or losses that are subtracted \r\n  from gross income in computing taxable income. </p>\r\n<p><strong>Deferred Income Taxes:</strong> An account used to record the difference \r\n  between income tax expense on the income statement and income taxes payable \r\n  for the year to federal and state governments. </p>\r\n<p><strong>Depletion:</strong> The process of cost allocation that assigns the \r\n  original cost of a natural resource to the periods benefited. </p>\r\n<p><strong>Depreciation:</strong> The process of cost allocation that assigns \r\n  the original cost of plant and equipment to the periods benefited. </p>\r\n<p><strong>Direct Method</strong>: A method of reporting net cash flow from operations \r\n  that shows the major classes of cash receipts and payments for a period of time. \r\n</p>\r\n<p><strong>Direct Write-Off Method:</strong> The recording of actual losses from \r\n  uncollectable accounts as expenses during the period in which accounts receivable \r\n  are determined to be uncollectable.</p>\r\n<p><strong>Disbursements: </strong>Represents the amount of checks issued and \r\n  electronic fund transfers, cash or other payments </p>\r\n<p><strong>Disclaimer of Opinion: </strong>A disclaimer indicating the auditor \r\n  was unable to satisfy himself or herself that the overall financial statements \r\n  were fairly present in accordance with GAAP. </p>\r\n<p><strong>Discount: </strong>The amount charged by a financial institution when \r\n  a note receivable is discounted; calculated as maturity value times discount \r\n  rate times discount period.</p>\r\n<p><strong>Discounting a Note Receivable:</strong> The process of the payee\'s \r\n  selling notes to financial institution for less than the maturity value. </p>\r\n<p><strong>Discount Period: </strong>The time between the date a note is sold \r\n  to a financial institution and its maturity date. </p>\r\n<p><strong>Discount Rate:</strong> The interest rate charged by a financial institution \r\n  for buying a note receivable. </p>\r\n<p><strong>Diversified Companies:</strong> Companies operating in more than one \r\n  line of business. </p>\r\n<p><strong>Dividend Payment Date:</strong> The date on which a corporation pays \r\n  dividends to its shareholders. </p>\r\n<p><strong>Dividend Payout Ratio:</strong> A measure of the percentage of earnings \r\n  paid out in dividends; computed by dividing cash dividends by the net income \r\n  available to each class of stock. </p>\r\n<p><strong>Dividends:</strong> Distributions to owners (stockholders) of a corporation. \r\n</p>\r\n<p><strong>Dividends Account:</strong> The account used to reflect periodic distributions \r\n  of earnings to the owners (stockholders) of a corporation. </p>\r\n<p><strong>Dividends in Arrears: </strong>Missed dividends for past years that \r\n  preferred stockholders have a right to receive under the cumulative-dividend \r\n  preference if and when dividends are declared. </p>\r\n<p><strong>Double-Entry Accounting: </strong>A system of recording transactions \r\n  in a way that maintains the equality of the accounting equation. Debits must \r\n  always equal credits.</p>\r\n<p><strong>Drawings: </strong>Distribution to the owner(s) of a proprietorship \r\n  or partnership; similar to dividends for a corporation. </p>\r\n<p><strong>Drawing Account:</strong> The account used to reflect periodic withdrawals \r\n  of earnings by the owner (proprietor) or owners (partners) of a proprietorship \r\n  or partnership. </p>\r\n<p><strong>Due Date:</strong> The date on which a debt or obligation is payable. \r\n  The date on which the check to the creditor must be prepared</p>',252),(276,40,'Glossary: E','<strong>Earnings Per Share (EPS):</strong> The amount of net income (earnings) \r\nrelated to each share of stock; computed by dividing net income by the number \r\nof shares of common stock outstanding during the period. \r\n<p><strong>EDP (electronic data processing):</strong> A term referring to the \r\n  use of computers in recording, classifying, manipulating, and summarizing data. \r\n</p>\r\n<p><strong>Effective-Interest Amortization:</strong> A method of systematically \r\n  writing off a bond premium or discount that takes into consideration the time \r\n  value of money and results in an equal rate of amortization for each period. \r\n</p>\r\n<p><strong>Effective Tax Rate: </strong>A tax rate that reflects the percentage \r\n  of the actual tax liability to the accounting income generated by the company, \r\n  that is, net tax liability/financial (book) income before taxes. </p>\r\n<p><strong>Effective (yield or market) Rate of Interest: </strong>The actual interest \r\n  rate earned or paid on a bond investment. </p>\r\n<p><strong>Electronic Data Processing (EDP):</strong> A term referring to the \r\n  use of computers in recording, classifying, manipulating, and summarizing data.</p>\r\n<p><strong>Emergency Funds: </strong>Cash amounts set aside to cover unforeseen \r\n  expenditures in a fiscal year.</p>\r\n<p><strong>Encumbrance:</strong> A liability (example: a mortgage is an encumbrance \r\n  on a property). Also, it is any amount of money set aside for any purpose.</p>\r\n<p><strong>Entity:</strong> An organizational unit (a person, partnership, or \r\n  corporation) for which accounting records are kept and about which accounting \r\n  reports are prepared. </p>\r\n<p><strong>Entry:</strong> Part of a transaction posted in a journal or recorded \r\n  in a journal.</p>\r\n<p><strong>Equity:</strong> The value of the business to the owner of the business. \r\n  (The difference between the business\'s assets and liabilities).</p>\r\n<p><strong>Equity Financing:</strong> Acquiring funds in the form of investments \r\n  by owners (proprietor, partner, or stockholder). </p>\r\n<p><strong>Equity Method or Accounting for Investments in Stocks: </strong>Method \r\n  used to account for an investments in the stock of another company when significant \r\n  influence can be imposed (presumed to exist when 20 to 50 percent of the outstanding \r\n  voting stock is owned). </p>\r\n<p><strong>Equity Securities:</strong> Shares of ownership in a corporation that \r\n  can change significantly in value and that provide for a return to investors \r\n  in the form of dividends. </p>\r\n<p><strong>Error of Commission:</strong> A double-entry term which means that \r\n  one or both sides of the entry has been posted to the incorrect account (but \r\n  is within the same class of account). Example: Gasoline expense posted to the \r\n  vehicle maintenance expense. </p>\r\n<p><strong>Error of Omission: </strong>A double-entry term which means that a \r\n  transaction has been omitted from the books entirely.</p>\r\n<p><strong>Error of Original Entry: </strong>A double-entry term which means that \r\n  a transaction has been entered with the wrong amount.</p>\r\n<p><strong>Error of Principle:</strong> A double-entry term which means that one \r\n  or both sides of the entry has been posted to the incorrect account (which is \r\n  also a different class of account). Example: Gasoline expense posted to the \r\n  electrical expense.</p>\r\n<p><strong>Estimated Life:</strong> The expected economic useful life of an asset \r\n  from the date placed in service to the projected retirement date. </p>\r\n<p><strong>Exchange Gain or Loss:</strong> The gain or loss incurred when the \r\n  exchange rates are different on the purchase and payment dates or on the sale \r\n  and receipt of payment dates. </p>\r\n<p><strong>Exchange Rate: </strong>The value of one currency in terms of another. \r\n</p>\r\n<p><strong>Exclusions: </strong>Gross receipts that are not subject to tax and \r\n  are not included in gross income, such as interest on state and local government \r\n  bonds. </p>\r\n<p><strong>Expenditure Report:</strong> A report that is created at the end of \r\n  every quarter that shows the total year-to-date expenditures by department.</p>\r\n<p><strong>Expenses:</strong> Costs incurred in the normal course of business \r\n  to generate revenues. This does not include goods bought for re-sale or any \r\n  items of a capital nature.</p>\r\n<p><strong>External Auditors:</strong> Independent CPAs who are retained by organizations \r\n  to perform audits of financial statements. </p>\r\n<p><strong>External Audits:</strong> Audits conducted by CPAs who are independent \r\n  of the client company. </p>\r\n<p><strong>Extraordinary Items: </strong>Nonoperating gains and losses that are \r\n  unusual in nature, infrequent in occurrence, and material in amount. <br>\r\n</p>',253),(277,40,'Glossary: F','<p><strong>Face Value: </strong>The amount of the issuer\'s liability stated in \r\n  the security document.</p>\r\n<p><strong>Factor: </strong>To sell accounts receivable at a discount before they \r\n  are due. </p>\r\n<p><strong>Fair Market Value:</strong> The current value of an asset, e.g., the \r\n  amount at which an asset could be sold or purchased in an arm\'s-length transaction. \r\n</p>\r\n<p><strong>FASB (Financial Accounting Standards Board): </strong>The private organization \r\n  responsible for establishing the standards for financial accounting and reporting \r\n  in the United States. </p>\r\n<p><strong>FCPA (Foreign Corrupt Practices Act):</strong> Legislation requiring \r\n  any company that has publicly-traded stock to maintain records that accurately \r\n  and fairly represent the company\'s transactions; additionally, requires any \r\n  publicly-traded company to have an adequate system of internal accounting controls. \r\n</p>\r\n<p><strong>FICA (social security) taxes: </strong>Federal Insurance Contributions \r\n  Act taxes imposed on employee and employer; used mainly to provide retirement \r\n  benefits. </p>\r\n<p><strong>FIFO (first-in, first-out):</strong> An inventory cost flow whereby \r\n  the first goods purchased are assumed to be the first goods sold so that the \r\n  ending inventory consists of the most recently purchased goods. </p>\r\n<p><strong>Financial Accounting: </strong>The area of accounting concerned with \r\n  reporting financial information to interested external parties. </p>\r\n<p><strong>Financial Accounting Standards Board (FASB):</strong> The private organization \r\n  responsible for establishing the standards for financial accounting and reporting \r\n  in the United States. </p>\r\n<p><strong>Financial Statements:</strong> Reports such as the balance sheet, income \r\n  statement, and statement of cash flows, which summarize the financial status \r\n  and results of operations of a business entity. </p>\r\n<p><strong>Financing Activities:</strong> Transactions and events whereby resources \r\n  are obtained from, or repaid to, owners (equity financing) and creditors (debt \r\n  financing). </p>\r\n<p><strong>Fiscal Period:</strong> Any period at the end of which a business determines \r\n  it\'s financial position and the results of it\'s operations.</p>\r\n<p><strong>Fiscal Year: </strong>An entity\'s reporting year, covering a 12 month \r\n  accounting period.</p>\r\n<p><strong>Fixed Budget: </strong>A budget setting forth dollar amounts that are \r\n  not subject to changed based on the volume of goods or services to be provided.</p>\r\n<p><strong>Floor:</strong> The minimum market amount at which inventory can be \r\n  carried on the books; equal to net realizable value minus a normal profit. </p>\r\n<p><strong>FOB (free-on-board) destination: </strong>A business term meaning that \r\n  the seller of merchandise bears the shipping costs and maintains ownership until \r\n  the merchandise is delivered to the buyer. </p>\r\n<p><strong>FOB (free-on-board) shipping point:</strong> A business term meaning \r\n  that the buyer of merchandise bears the shipping costs and acquires ownership \r\n  at the point of shipment. </p>\r\n<p><strong>Foreign Corrupt Practices Act (FCPA):</strong> Legislation requiring \r\n  any company that has publicly-traded stock to maintain records that accurately \r\n  and fairly represent the company\'s transactions; additionally, requires any \r\n  publicly-traded company to have an adequate system of internal accounting controls. \r\n</p>\r\n<p><strong>Form 941:</strong> The IRS form filed quarterly to report income tax, \r\n  FICA, and Medicare withholdings. </p>\r\n<p><strong>Form 1099:</strong> An IRS form sent to certain vendors whom you have \r\n  paid more than $600 during the year. </p>\r\n<p><strong>Franchise:</strong> An entity that has been licensed to sell the product \r\n  of a manufacturer or to offer a particular service in a given area. </p>\r\n<p><strong>Freight-in:</strong> An account used with the periodic inventory method \r\n  for recording the costs of transporting into a firm all purchased merchandise \r\n  intended for sale; added to purchases in calculating cost of goods sold. </p>\r\n<p><strong>Freight Collect:</strong> The buyer pays the shipping costs. </p>\r\n<p><strong>Functional Currency:</strong> The currency in which a subsidiary conducts \r\n  most of its business; generally, but not always, the currency of the country \r\n  where it does most of its spending and earning. <br>\r\n</p>',254),(278,40,'Glossary: G','<strong>GAAP (generally accepted accounting principles):</strong> Authoritative \r\nguidelines that define accounting practice at a particular time. \r\n<p><strong>GAAS (generally accepted auditing standards): </strong>Auditing standards \r\n  developed by the AICPA. </p>\r\n<p><strong>Generally Accepted Accounting Principles (GAAP):</strong> Authoritative \r\n  guidelines that define accounting practice at a particular time. </p>\r\n<p><strong>Generally Accepted Auditing Standards (GAAS): </strong>Auditing standards \r\n  developed by the AICPA. </p>\r\n<p><strong>General-Purpose Financial Statements: </strong>The financial reports \r\n  intended for use by a variety of external groups; they include the balance sheet, \r\n  the income statement, and the statement of cash flows. </p>\r\n<p><strong>General Ledger:</strong> A record containing the accounts needed to \r\n  reflect the financial position and the results of operations of a business. \r\n  In double-entry bookkeeping, the debits and credits in the general ledger are \r\n  equal.</p>\r\n<p><strong>Going Concern: </strong>The idea that an accounting entity will have \r\n  a continuing existence for the foreseeable future. </p>\r\n<p><strong>Goodwill:</strong> An intangible asset that exists when a business \r\n  is valued at more than the fair market value of its net assets, usually due \r\n  to strategic location, reputation, good customer relations, or similar factors; \r\n  equal to the excess of the purchase price over the fair market value of the \r\n  net assets purchased. </p>\r\n<p><strong>Gross Income:</strong> The taxable portion of a taxpayer\'s gross receipts. \r\n</p>\r\n<p><strong>Gross Loss:</strong> The balance of the trading account assuming it \r\n  has a debit balance. </p>\r\n<p><strong>Gross Margin:</strong> The excess of net sales revenue over the cost \r\n  of goods sold. </p>\r\n<p><strong>Gross Margin Method: </strong>A procedure for estimating the amount \r\n  of ending inventory; the historical relationship of cost of goods sold to sales \r\n  revenue is used in computing ending inventory. </p>\r\n<p><strong>Gross Profit: </strong>The balance of the trading account assuming \r\n  it has a credit balance. </p>\r\n<p><strong>Gross Sales:</strong> Total recorded sales before deducting any sales \r\n  discounts or sales returns and allowances. </p>\r\n<p><strong>Gross Tax Liability:</strong> The amount of tax computed by multiplying \r\n  the tax base (taxable income) by the appropriate tax rates. <br>\r\n</p>',255),(279,40,'Glossary: H','<strong>Held-to-Maturity Securities:</strong> Debt securities purchased by an \r\ninvestor with the intent of holding the securities until they mature. \r\n<p><strong>Historical Cost: </strong>The dollar amount originally exchanged in \r\n  an arm\'s-length transaction; an amount assumed to reflect the fair market value \r\n  of an item at the transaction date. </p>\r\n<p><strong>Historical Exchange Rate:</strong> The exchange rate that existed on \r\n  the date of a transaction. </p>\r\n<p><strong>Horizontal Analysis of Financial Statements: </strong>A technique for \r\n  analyzing the percentage change in individual income statement or balance sheet \r\n  items from one year to the next. <br>\r\n</p>',256),(280,40,'Glossary: I','<p><strong>Icons: </strong>As used in computer terminology, icons are images or \r\n  graphics used to represent actions or computer processes. A trash can might \r\n  be an icon for deleting a file, a picture of a house might indicate moving back \r\n  or to the main or home page, and a pen might indicate a word processing package.</p>\r\n<p><strong>Impersonal Accounts:</strong> These are accounts not held in the name \r\n  of persons (i.e. they do not relate directly to a business\'s customers and suppliers). \r\n  There are two types, see Real and Nominal. </p>\r\n<p><strong>Imprest Account: </strong>An account into which a fixed amount of money \r\n  is placed for minor disbursements or disbursements for a specific purpose (e.g., \r\n  payroll). </p>\r\n<p><strong>Imprest System:</strong> A method of topping up petty cash. A fixed \r\n  sum of petty cash is placed in the petty cash box. When the petty cash balance \r\n  is nearing zero, it is topped up back to its original level again (known as \r\n  \'restoring the Imprest\').</p>\r\n<p><strong>Income: </strong>Money received by a business from its commercial activities. \r\n  See \'Revenue\'.</p>\r\n<p><strong>Income Accounts:</strong> These are the accounts you use to keep track \r\n  of your sources of income. Examples are merchandise sales, consulting revenue, \r\n  and interest income. </p>\r\n<p><strong>Income Statement:</strong> (Also called Statement of Earnings) The \r\n  financial statement that summarizes the revenues generated and the expenses \r\n  incurred by an entity during a period of time. It shows whether the business \r\n  earned a profit or incurred a loss for a given period. </p>\r\n<p><strong>Inland Revenue:</strong> The government department usually responsible \r\n  for collecting your tax.</p>\r\n<p><strong>Insolvent:</strong> A company is insolvent if it has insufficient funds \r\n  (all of its assets) to pay its debts (all of its liabilities). If a company\'s \r\n  liabilities are greater than its assets and it continues to trade, it is not \r\n  only insolvent, but in the UK, is operating illegally (Insolvency act 1986).</p>\r\n<p><strong>Intangible assets:</strong> Assets of a non-physical or financial nature. \r\n  An asset such as a loan or an endowment policy are good examples. See tangible \r\n  assets.</p>\r\n<p><strong>Integration Account: </strong>See Control Account.</p>\r\n<p><strong>Interest:</strong> The payment (cost) for the use of money.</p>\r\n<p><strong>Interest Rate: </strong>the cost of using money, expressed as an annual \r\n  percentage. </p>\r\n<p><strong>Interest Revenue:</strong> Money earned from an investment can be interest \r\n  revenue.</p>\r\n<p><strong>Inventory:</strong> (1) A detailed a detailed list showing quantities, \r\n  descriptions and values of property and, frequently, units of measure and unit \r\n  prices. (2) An asset account reflecting the cost of goods held for resale or \r\n  for use in operations. </p>\r\n<p><strong>Invoice:</strong> A term describing an original document either issued \r\n  by a business for the sale of goods on credit (a sales invoice) or received \r\n  by the business for goods bought (a purchase invoice).</p>',257),(281,40,'Glossary: J','<p><strong>JIT (Just-In-Time) Inventory: </strong>An inventory system that allows \r\n  for the elimination of inventory stockpiles and inefficiency and waste; raw \r\n  materials arrive \"just in time\" for production and finished goods \r\n  \"just in time\" for sale. </p>\r\n<p><strong>Journal(s): </strong>The chronological, day-to-day transactions of \r\n  a business are recorded in sales, cash receipts, and cash disbursements journals. \r\n  A general journal is used to enter period end adjusting and closing entries \r\n  and other special transactions not entered in the other journal. </p>\r\n<p><strong>Journal Entry:</strong> A recording of a transaction where debits equal \r\n  credits; usually includes a date and an explanation of the transaction. </p>\r\n<p><strong>Journal Proper:</strong> A term used to describe the main or general \r\n  journal where other journals specific to subsidiary ledgers are also used.</p>',258),(282,40,'Glossary: K','<em><strong>No Entries.</p> </strong></em> ',259),(283,40,'Glossary: L','<p><strong>Landed Costs:</strong> The total costs involved when importing goods. \r\n  They include buying, shipping, insuring and associated taxes. </p>\r\n<p><strong>Lapping:</strong> A procedure used to conceal the theft of cash by \r\n  crediting the payment from one customer to another customer\'s account on a delayed \r\n  basis. </p>\r\n<p><strong>Lapse:</strong> As applied to appropriations, the automatic termination \r\n  of an appropriation. At the end of this period, any unexpended or unencumbered \r\n  balance thereof lapses, unless otherwise provided by law. </p>\r\n<p><strong>Ledger: </strong>A book of accounts in which data from transactions \r\n  recorded in journals are posted and thereby classified and summarized.</p>\r\n<p><strong>Lease:</strong> A contract that specifies the terms under which the \r\n  owner of an asset (the lessor) agrees to transfer the right to use the asset \r\n  to another party (the lessee). </p>\r\n<p><strong>Lessee:</strong> The party that is granted the right to use property \r\n  under the terms of a lease.</p>\r\n<p><strong>Lessor: </strong>The owner of property that is rented (leased) to another \r\n  party. </p>\r\n<p><strong>Leasehold: </strong>The right to the use of real estate by virtue of \r\n  a lease; usually for a specified term of years, for which consideration is paid.</p>\r\n<p><strong>Legal Capital:</strong> The amount of contributed capital not available \r\n  for dividends; usually equal to the par or stated value of outstanding capital \r\n  stock. </p>\r\n<p><strong>Liabilities:</strong> Obligations measurable in monetary terms that \r\n  represent amounts owed to creditors, governments, employees, and other parties. \r\n  Liabilities are included on the right hand side of the balance sheet and normally \r\n  consist of accounts which have a credit balance.</p>\r\n<p><strong>License: </strong>The right to perform certain activities, generally \r\n  granted by a governmental agency. </p>\r\n<p><strong>LIFO (last-in, first-out): </strong> An inventory cost flow whereby \r\n  the last goods purchased are assumed to be the first goods sold so that the \r\n  ending inventory consists of the first goods purchased. </p>\r\n<p><strong>Limited Liability:</strong> The legal protection given stockholders \r\n  whereby they are responsible for the debts and obligations of a corporation \r\n  only to the extent of their capital contributions. </p>\r\n<p><strong>Line Item:</strong> In budget terminology, a line item is a detail \r\n  in the budget. It refers to the things to be acquired not the results to be \r\n  achieved. </p>\r\n<p><strong>Liquidation: </strong>The process of dissolving a business by selling \r\n  the assets, paying the debts, and distributing the remaining equity to the owners. \r\n</p>\r\n<p><strong>Liquidity:</strong> A company\'s ability to meet current obligations \r\n  with cash or other assets that can be quickly converted to cash. </p>\r\n<p><strong>Local Area Network (LAN):</strong> LANs allow many computers and computer \r\n  associated devices (e.g., printers) to be shared and access by a group of people. \r\n  Often the LAN will have one main computer (sometimes called the server) with \r\n  many smaller computers accessing applications and data from the main computer. \r\n</p>\r\n<p><strong>Long-Term Budget:</strong> A budget prepared for a period longer than \r\n  a fiscal year. Long-term budgets concerned with capital outlay plans and capital \r\n  improvement programs are referred to as capital budgets. </p>\r\n<p><strong>Long-Term Investment: </strong>An expenditure to acquire a non-operating \r\n  asset that is expected to increase in value or generate income for longer than \r\n  1 year. </p>\r\n<p><strong>Long-Term Liabilities (debt):</strong> These usually refer to long \r\n  term loans (e.g. a loan which lasts for more than one year such as a mortgage). \r\n</p>\r\n<p><strong>Loss per Share:</strong> The amount of net loss related to each share \r\n  of stock; computed by dividing net loss by a number of shares of common stock \r\n  outstanding during the period. </p>\r\n<p><strong>Losses:</strong> Costs that provide no benefit to an organization. \r\n</p>\r\n<p><strong>LCM (lower cost or market):</strong> A basis for valuing certain assets \r\n  at the lower of original cost or current market value. </p>',260),(284,40,'Glossary: M','<p><strong>Manufacturing Account:</strong> An account used to show what it cost \r\n  to produce the finished goods made by a manufacturing business.</p>\r\n<p><strong>Maker:</strong> A person (entity) who signs a note to borrow money \r\n  and who assumes responsibility to pay the note at maturity. </p>\r\n<p><strong>Markup:</strong> The amount added to the cost of a product by a retailer. \r\n</p>\r\n<p><strong>Market Adjustment-Trading Securities account:</strong> An account used \r\n  to track the difference between the historical cost and the market value of \r\n  a company\'s portfolio of trading securities. </p>\r\n<p><strong>Master Files: </strong>Files used in the computer system that contain \r\n  permanent information necessary for the ongoing operation of the system. These \r\n  files are never eliminated from the system. An example would be the file containing \r\n  the General Ledger control account numbers. </p>\r\n<p><strong>Matching Principle:</strong> The concept that all costs and expenses \r\n  incurred in generating revenues must be recognized in the same reporting period \r\n  as the related revenues.</p>\r\n<p><strong>Maturity Date:</strong> The date on which a note or other obligation \r\n  becomes due. </p>\r\n<p><strong>Maturity Value: </strong>The amount of an obligation to be collected \r\n  or paid at maturity; equal to principal plus any interest. </p>\r\n<p><strong>Memo Billing (aka memo invoicing):</strong> Goods ordered and invoiced \r\n  on approval. There is no obligation to buy.</p>\r\n<p><strong>Memorandum Accounts: </strong>A name for the accounts held in a subsidiary \r\n  ledger. E.g. the accounts in a sales ledger.</p>\r\n<p><strong>Merchandise Inventory: </strong>Goods held for sale to customers. </p>\r\n<p><strong>Merger: </strong>The acquisition of one company by another company \r\n  whereby the companies combine as one legal entity, with the acquired company \r\n  going out of existence. </p>\r\n<p><strong>Minority Interest: </strong>The interest owned in a subsidiary by stockholders \r\n  other than those of the parent company; occurs when the acquiring company has \r\n  less than a 100 percent ownership interest. </p>\r\n<p><strong>Moving Average: </strong>A perpetual inventory cost flow alternative \r\n  whereby the cost of goods sold and the cost of ending inventory are determined \r\n  by using a weighted-average cost of all merchandise on hand after each purchase. \r\n</p>\r\n<p><strong>Multiple-Step Income Statement (aka Multi-step):</strong> An income \r\n  statement (aka Profit and Loss) which has had its revenue section split up into \r\n  sub-sections in order to give a more detailed view of its sales operations. \r\n  Example: a company sells services and goods. The statement could show revenue \r\n  from services and associated costs of those revenues at the start of the revenue \r\n  section, then show goods sold and cost of goods sold underneath. The two sections \r\n  totals can then be amalgamated at the end to show overall sales (or gross profit). \r\n</p>\r\n<p><strong>Mutual Agency:</strong> The right of all partners in a partnership \r\n  to act as agents for the normal business operations of the partnership, with \r\n  the authority to bind it to a business agreements.</p>',261),(285,40,'Glossary: N','<p><strong>Narrative:</strong> A comment appended to an entry in a journal. It \r\n  can be used to describe the nature of the transaction, and often in particular, \r\n  where the other side of the entry went to (or came from). </p>\r\n<p><strong>Net Assets (Owners\' Equity): </strong>The ownership interest in the \r\n  assets of an entity; equal total assets minus total liabilities. </p>\r\n<p><strong>Net Income:</strong> The proprietary fund excess of operating revenues, \r\n  non-operating revenues and operating transfers in over operating expenses, non-operating \r\n  expenses and operating transfers out. </p>\r\n<p><strong>Net Loss:</strong> The value of expenses less sales assuming that the \r\n  expenses are greater (e.g., if the profit and loss account shows a debit balance).</p>\r\n<p><strong>Net of Tax:</strong> The price less any tax. E.g., if you sold some \r\n  goods for $12 inclusive of $2 sales tax, then the \'net of tax\' price would be \r\n  $10. </p>\r\n<p><strong>Net Proceeds: </strong>The difference between maturity value and discount \r\n  when a note receivable is discounted. </p>\r\n<p><strong>Net Profit:</strong> The value of sales less expenses assuming that \r\n  the sales are greater (e.g,. if the profit and loss account shows a credit balance).</p>\r\n<p><strong>Net Realizable Value:</strong> The selling price of an item less reasonable \r\n  selling costs. </p>\r\n<p><strong>Net Realizable Value of Accounts Receivable:</strong> The net amount \r\n  that would be received if all receivables considered collectible were collected; \r\n  equal to total accounts receivable less the allowance for uncollectable accounts; \r\n  also called the book value of accounts receivable. </p>\r\n<p><strong>Net Sales: </strong>Gross sales less sales discounts and sales returns \r\n  and allowances. </p>\r\n<p><strong>Net Tax Liability: </strong>The amount of tax computed by subtracting \r\n  tax credits from the gross tax liability. </p>\r\n<p><strong>Nominal Accounts: </strong>Accounts that are closed to a zero balance \r\n  at the end of each accounting period; temporary accounts generally appearing \r\n  on the income statement. </p>\r\n<p><strong>Nominal Interest Rate:</strong> The contractual interest rate shown \r\n  on the face and in the body of a bond and used to compute the amount of interest \r\n  to be paid, in contrast to the effective interest rate. </p>\r\n<p><strong>Nominal Ledger:</strong> A ledger which holds all the nominal accounts \r\n  of a business. Where the business uses a subsidiary ledger like the sales ledger \r\n  to hold customer details, the nominal ledger will usually include a control \r\n  account to show the total balance of the subsidiary ledger (a control account \r\n  can be termed \'nominal\' because it doesn\'t relate to a specific person).</p>\r\n<p><strong>Non-Cash Items:</strong> Items included in the determination of net \r\n  income on an accrual basis that do not affect cash; examples are depreciation \r\n  and amortization. </p>\r\n<p><strong>Non-Cash Transactions:</strong> Investing and financing activities that \r\n  do not affect cash; if significant, they are disclosed below the statement of \r\n  cash flows or in the notes to the financial statements. </p>\r\n<p><strong>Non-Operating Assets:</strong> Investment and other assets not used \r\n  in a business but held to earn a return separate from operations. </p>\r\n<p><strong>Non-Operating Expenses:</strong> Proprietary fund expenses not directly \r\n  related to the fund\'s primary activities (e.g., interest).</p>\r\n<p><strong>Non-Operating Revenues: </strong>Proprietary fund revenues incidental \r\n  to, or by-products of, the fund\'s primary activities. </p>\r\n<p><strong>Non-Profit Organization:</strong> An entity without a profit objective, \r\n  oriented toward providing services efficiently and effectively. </p>\r\n<p><strong>No-Par Stock: </strong>Stock that does not have a par value printed \r\n  on the face of the stock certificate. </p>\r\n<p><strong>Normalize: </strong>This term can be applied to many aspects of accounting. \r\n  It means to average or smooth out a set of figures so they are more consistent \r\n  with the general trend of the business.</p>\r\n<p><strong>Note Payable:</strong> A debt owned to a creditor evidenced by an unconditional \r\n  written promise to pay a certain sum of money on or before a specified future \r\n  date. </p>\r\n<p><strong>Note Receivable:</strong> A claim against a debtor, evidenced by an \r\n  unconditional written promise to pay a certain sum of money on or before a specified \r\n  future date.</p>\r\n<p><strong>Note to Financial Statements: </strong>Explanatory information considered \r\n  an integral part of the financial statements. </p>\r\n<p><strong>NSF (Non Sufficient Funds) Check:</strong> A check that is not honored \r\n  by a bank because of insufficient cash in the customer\'s account. </p>\r\n<p><strong>Number of Days\' of Inventory on Hand:</strong> An alternative measure \r\n  of how well inventory is being managed; computed by dividing 365 days by the \r\n  inventory turnover ratio. </p>\r\n<p><strong>Number of Days\' Sales in Receivables:</strong> A measure of the average \r\n  number of days it takes to collect a credit sale; computed by dividing 365 days \r\n  by the accounts receivable turnover. </p>\r\n<p><strong>Number of Days\' Sales Invested in Working Capital: </strong>An alternative \r\n  measure of the amount of working capital used in generating the sales of a period; \r\n  computed by dividing 365 days by the working capital turnover. <br>\r\n</p>',262),(286,40,'Glossary: O','<p><strong>Obsolescence:</strong> The decrease in the value of fixed assets, resulting \r\n  from economic, social, technological or legal changes. </p>\r\n<p><strong>Open Transaction:</strong> A transaction that is not completed at the \r\n  end of the accounting period; a purchase that has not yet been paid for or a \r\n  sale where payment is yet to be collected when the accounting period ends. </p>\r\n<p><strong>Opening the Books:</strong> Every time a business closes the books \r\n  for a year, it opens a new set. The new set of books will be empty, therefore \r\n  the balances from the last balance sheet must be copied into them (via journal \r\n  entries) so that the business is ready to start the new year. </p>\r\n<p><strong>Operating Activities:</strong> Transactions and events that enter into \r\n  the determination of net income. </p>\r\n<p><strong>Operating Assets:</strong> Long-term, or non-current, assets acquired \r\n  for use in the business rather than for resale; includes property, plant, and \r\n  equipment; intangible assets; and natural resources. </p>\r\n<p><strong>Operating Budget:</strong> The plan for the allocation of resources \r\n  to each department for the budget period (usually one year).</p>\r\n<p><strong>Operating Expenses: </strong>Proprietary fund expenses related directly \r\n  to the fund\'s primary activities. </p>\r\n<p><strong>Operating Income:</strong> The excess of proprietary fund operating \r\n  revenues over operating expenses. </p>\r\n<p><strong>Operating Lease:</strong> A simple rental agreement. </p>\r\n<p><strong>Operating Leverage:</strong> The extent to which fixed costs are part \r\n  of a company\'s cost structure; the higher the proportion of fixed costs, the \r\n  faster income increases or decreases with sales volumes. </p>\r\n<p><strong>Operating Performance Ratio:</strong> An overall measure of the efficiency \r\n  of operations during a period; computed by dividing net income by net sales.</p>\r\n<p><strong>Operating Revenues:</strong> Proprietary fund revenues directly related \r\n  to the fund\'s primary activities. They consist primarily of user charges for \r\n  goods and services. </p>\r\n<p><strong>Operating System:</strong> The operating system of a computer is the \r\n  software that coordinates the various applications and allows communication \r\n  among the different subsystems of the computer. </p>\r\n<p><strong>Operations Fund: </strong>A master fund established for the purpose \r\n  of accounting for all resources not accounted for in another fund. </p>\r\n<p><strong>Organizational Structure:</strong> Lines of authority and responsibility. \r\n</p>\r\n<p><strong>Ordinary Share:</strong> This is a type of share issued by a limited \r\n  company. It carries the highest risk but usually attracts the highest rewards.</p>\r\n<p><strong>Original Book of Entry: </strong>A book which contains the details \r\n  of the day to day transactions of a business.</p>\r\n<p><strong>Other Revenues and Expenses:</strong> Items incurred or earned from \r\n  activities that are outside, or peripheral to, the normal operations of a firm.</p>\r\n<p><strong>Outstanding Checks:</strong> Checks that have been written, recorded \r\n  and given to the payee but has not been received by the bank, paid and returned \r\n  (usually with the bank statement).</p>\r\n<p><strong>Outstanding Stock:</strong> Issued stock that is still being held by \r\n  investors. </p>\r\n<p><strong>Overdraft:</strong> The amount by which checks, drafts or other demands \r\n  for payments on a bank exceed the amount of the credit against which they are \r\n  drawn.</p>\r\n<p><strong>Overheads:</strong> These are the costs involved in running a business. \r\n  They consist entirely of expense accounts (e.g. rent, insurance, petrol, staff \r\n  wages etc.).</p>\r\n<p><strong>Owners\' Equity (Net Assets):</strong> The ownership interest in the \r\n  assets of an entity; equal total assets minus total liabilities. <br>\r\n',263),(287,40,'Glossary: P','<p><strong>Parent Company:</strong> A company that owns or maintains control over \r\n  other companies, known as subsidiaries, which are themselves separate legal \r\n  entities; control generally refers to more than 50 percent ownership of the \r\n  stock of another company. </p>\r\n<p><strong>Partnership: </strong>An association of two or more individuals or \r\n  organizations to carry on economic activity. </p>\r\n<p><strong>Partnership Agreement:</strong> A legal agreement between partners; \r\n  it usually specifies, among other things, the capital contributions to be made \r\n  by each partner, the ratios in which partnership earnings and losses will be \r\n  distributed, the management responsibilities of the partners, and the partners\' \r\n  rights to transfer or sell their individual interests. </p>\r\n<p><strong>Par-Value Stock:</strong> Stock that has a nominal value assigned to \r\n  it in the corporation\'s charter and printed on the face of each share of stock. \r\n</p>\r\n<p><strong>Patent:</strong> An exclusive right granted for 17 years by the federal \r\n  government to manufacture and sell an invention. </p>\r\n<p><strong>Pay on Delivery:</strong> The buyer pays the cost of the goods (to \r\n  the carrier) on receipt of them.</p>\r\n<p><strong>Payee: </strong>The person (entity) to whom payment on a note is to \r\n  be made. </p>\r\n<p><strong>P/E (price earnings) Ratio: </strong>A measure of growth potential, \r\n  earnings stability, and management capabilities; computed by dividing market \r\n  price per share by earnings per share. </p>\r\n<p><strong>Pension Plan: </strong>A contract between a company and it employees \r\n  whereby the company agrees to pay benefits to employees after their retirement. \r\n</p>\r\n<p><strong>Performance Reports:</strong> Regular evaluations of departments, programs, \r\n  or people against their stated goals and objectives.</p>\r\n<p><strong>Period (or Accounting Period</strong>): The interval (weekly, monthly, \r\n  or quarterly) at which a business regularly closes it\'s books and generates \r\n  new account balances.</p>\r\n<p><strong>Periodic Inventory Method: </strong>A system of accounting for inventory \r\n  in which cost of goods sold is determined and inventory is adjusted at the end \r\n  of the accounting period, not when merchandise is purchased or sold. </p>\r\n<p><strong>Perpetual Inventory Method:</strong> A system of accounting for inventory \r\n  in which detailed records of the number of units and the cost of each purchase \r\n  and sales transactions are prepared throughout the accounting period. </p>\r\n<p><strong>Personal Accounts: </strong>These are the accounts of a business\'s \r\n  customers and suppliers. They are usually held in the Sales and Purchase Ledgers.</p>\r\n<p><strong>Petty Cash:</strong> A small amount of money held in reserve (normally \r\n  used to purchase items of small value where a check or other form of payment \r\n  is not suitable).</p>\r\n<p><strong>Petty Cash Slip: </strong>A document used to record petty cash payments \r\n  where an original receipt was not obtained (sometimes called a petty cash voucher).</p>\r\n<p><strong>Physical Safeguards: </strong>Physical precautions used to protect \r\n  assets and records, such as locks on doors, fireproof vaults, password verification, \r\n  security gauds. </p>\r\n<p><strong>Point of Sale (POS):</strong> The place where a sale of goods takes \r\n  place, e.g. a shop counter. </p>\r\n<p><strong>Post-Closing Trial Balance: </strong>A listing of all real account \r\n  balances after the closing process has been completed; provides a means of testing \r\n  whether total debits equal total credits for all real accounts prior to beginning \r\n  a new accounting cycle. </p>\r\n<p><strong>Posting: </strong>The process of transferring or recording amounts \r\n  to a ledger. (A/P, A/R, PR or GL).</p>\r\n<p><strong>Preemptive Right: </strong>The right of current stockholders to purchase \r\n  additional shares of stock in order to maintain their same percentage of ownership \r\n  if new shares are issued. </p>\r\n<p><strong>Preferred Stock: </strong>A class of stock that usually provides dividend \r\n  and liquidation preferences over common stock. </p>\r\n<p><strong>Premium on Stock: </strong>The excess of the issuance (market) price \r\n  of stock over its par or stated value. </p>\r\n<p><strong>Prepaid Expenses:</strong> Payments made in advance for items normally \r\n  charged to expense. </p>\r\n<p>Prepaid Income: (Also called unearned revenue) It represents money the business \r\n  received in advance of providing a service to your customer. Prepaid income \r\n  is actually a liability of your business because you still owe the service to \r\n  the customer.</p>\r\n<p><strong>Pre-payments: </strong>One or more accounts set up to account for money \r\n  paid in advance (e.g. insurance, where part of the premium applies to the current \r\n  financial year, and the remainder to the following year).</p>\r\n<p><strong>Present Value</strong>: The discounted value of a future amounts or \r\n  amounts of cash, assuming a given rate of interest. </p>\r\n<p><strong>Present Value of $1:</strong> The value today of $1 to be received \r\n  or paid at some future date given a specified interest rate. </p>\r\n<p><strong>Present Value of an Annuity:</strong> The value today of a series of \r\n  equally spaced, equal-amount payments to be made or received in the future given \r\n  a specified interest rate. </p>\r\n<p><strong>Price-Earnings (P/E) Ratio: </strong>A measure of growth potential, \r\n  earnings stability, and management capabilities; computed by dividing market \r\n  price per share by earnings per share. </p>\r\n<p><strong>Primary Financial Statements:</strong> The balance sheet, income statement, \r\n  and statement of cash flows, used by external groups to assess a company\'s economic \r\n  standing. </p>\r\n<p><strong>Principal (Face Value or Maturity Value): </strong>The amount that \r\n  will be paid on a bond at a maturity date. </p>\r\n<p><strong>Principal on a Note:</strong> The face amount of a note; the amount \r\n  (excluding interest) that the maker agrees to pay the payee. </p>\r\n<p><strong>Prior-Period Adjustments: </strong>Adjustments made directly to Retained \r\n  Earnings in order to correct errors in the financial statements of prior periods. \r\n</p>\r\n<p><strong>Profit and Loss Account: </strong>This statement is sometimes called \r\n  an Income Statement. It shows all the revenue earned during a period (year/month) \r\n  and all the expenses incurred during that period. At the end of the year, all \r\n  the accounts are cleared to zero balances, and the profit or loss is transferred \r\n  to the equity part of the balance sheet. </p>\r\n<p><strong>Profit Margin: </strong>The percentage difference between the costs \r\n  of a product and the price you sell it for. E.g. if a product costs you $10 \r\n  to buy and you sell it for $20, then you have a 100% profit margin. This is \r\n  also known as your \'mark-up\'.</p>\r\n<p><strong>Profitability:</strong> A company\'s ability to generate revenues in \r\n  excess of the costs incurred in producing those revenues.</p>\r\n<p><strong>Proper Authorization: </strong>Policy regarding either a general class \r\n  of transactions such as inventory or a specific transaction to achieve control \r\n  objectives. </p>\r\n<p><strong>Property Dividend: </strong>The distribution to shareholders of assets \r\n  other than cash. </p>\r\n<p><strong>Property, Plant, and Equipment: </strong>Tangible, long-lived assets \r\n  acquired for use in business operations; includes land, buildings, machinery, \r\n  equipment, and furniture. </p>\r\n<p><strong>Property, Plant, and Equipment Turnover:</strong> A measure of how \r\n  well property, plant, and equipment are being utilized in generating a period\'s \r\n  sales; computed by dividing net sales by average property, plant and equipment. \r\n</p>\r\n<p><strong>Proprietorship:</strong> A business owned by one person. </p>\r\n<p><strong>Pro-Forma Invoice: </strong>An invoice sent that requires payment before \r\n  any goods or services have been dispatched.</p>\r\n<p><strong>Pro Rata: </strong>A term describing an allocation that is based on \r\n  a proportionate distribution of the total. </p>\r\n<p><strong>Public Companies: </strong>Entities whose stock is publicly traded. \r\n</p>\r\n<p><strong>Purchase Discount:</strong> A reduction in the purchase price, allowed \r\n  if payment is made within a specified period. </p>\r\n<p><strong>Purchase Method:</strong> A method used to prepare consolidated financial \r\n  statements when one company has acquired a controlling interest in another company \r\n  with similar activities by exchanging cash or other assets for more than 50 \r\n  percent of the acquired company\'s outstanding voting stock. </p>\r\n<p><strong>Purchase Order: </strong>The written authorization for a vendor to \r\n  ship merchandise and bill the customer for it. </p>\r\n<p><strong>Purchase Returns and Allowances: </strong>A contra-purchase account \r\n  used for recording the return of, or allowances for, previously purchased merchandise. \r\n</p>\r\n<p><strong>Purchases Account:</strong> An account in which all inventory purchases \r\n  are recorded; used with the periodic inventory method. </p>\r\n<p><strong>Purchases Journal: </strong>A special journal in which credit purchases \r\n  are recorded. <br>',264),(288,40,'Glossary: Q','<em><strong>No Entries.</p> </strong></em> ',265),(289,40,'Glossary: R','<p><strong>Raw Materials:</strong> Refers to the materials bought by a manufacturing \r\n  business in order to manufacture its products.</p>\r\n<p><strong>Real Accounts:</strong> These are accounts which deal with money such \r\n  as bank and cash accounts. They also include those dealing with property and \r\n  investments. In the case of bank and cash accounts they can be held in the nominal \r\n  ledger, or balanced in a journal (e.g. the cash book) where they can then be \r\n  looked upon as a part of the nominal ledger when compiling a balance sheet. \r\n  Property and investments can be held in subsidiary ledgers (with associated \r\n  control accounts if necessary) or directly in the nominal ledger itself.</p>\r\n<p><strong>Realization Principle: </strong>The principle whereby the value of \r\n  an asset can only be determined when it is sold or otherwise disposed of, i.e. \r\n  its \'real\' (or realized) value.</p>\r\n<p><strong>Realized Gains and Losses:</strong> Gains and losses resulting from \r\n  the sale of securities in an arm\'s length transaction. </p>\r\n<p><strong>Receipt:</strong> A term typically used to describe confirmation of \r\n  a payment. </p>\r\n<p><strong>Receivables: </strong>Claims for money, goods, or services. </p>\r\n<p><strong>Recourse:</strong> The right to seek payment on a discounted note from \r\n  the payee if the maker defaults. </p>\r\n<p><strong>Reconciling: </strong>The procedure of checking entries made in a business\'s \r\n  books with those on a statement sent by a third person (e.g. checking a bank \r\n  statement against your own records).</p>\r\n<p><strong>Recovery Period:</strong> The time period designated by Congress for \r\n  depreciating business assets. </p>\r\n<p><strong>Recurring Payments:</strong> Payments which must be made on a regular \r\n  basis in the same amount. An example would be a monthly loan payment to the \r\n  bank.</p>\r\n<p><strong>Redemption Value:</strong> The price, stated in the contract, to be \r\n  paid by a company to repurchase preferred stock.</p>\r\n<p><strong>Refund:</strong> An amount paid back or credit allowed because of an \r\n  over-collection or because of the return of an object sold. </p>\r\n<p><strong>Registered Bonds:</strong> Bonds for which the names and addresses \r\n  of the bondholders are kept on file by the issuing company.</p>\r\n<p><strong>Reimbursements: </strong>Repayments of amounts remitted on behalf of \r\n  another party. </p>\r\n<p><strong>Reinstate:</strong> If a check has incorrectly had its status changed \r\n  from \"outstanding\" to \"reconciled\", the status may be changed \r\n  back to \"outstanding\". </p>\r\n<p><strong>Relative Fair Market Value Method:</strong> A way of allocating a lump-sum \r\n  or \"basket\" purchase price to the individual assets acquired based \r\n  on their respective market values.</p>\r\n<p><strong>Relieve:</strong> To decrement an inventory account. When goods are \r\n  sold, the inventory accounting records are relieved. </p>\r\n<p><strong>Replacement Cost: </strong>The amount of cash or other consideration \r\n  that would be required today to obtain the same asset or its equivalent. </p>\r\n<p><strong>Reserve for Bad Debts:</strong> Also called allowance for bad debts, \r\n  it is an estimate of uncollectable customer accounts. It is known as a \"contra\" \r\n  account because it is listed with the assets, but it will have a credit balance \r\n  instead of a debit balance.</p>\r\n<p><strong>Residual Income:</strong> The amount of net income an investment center \r\n  is able to earn above a specified minimum rate of return on assets.</p>\r\n<p><strong>Retail Inventory Method:</strong> A procedure for estimating the dollar \r\n  amount of ending inventory; the ending inventory at retail prices is converted \r\n  to a cost basis by using a ratio of the cost and the retail prices of goods \r\n  available for sale. </p>\r\n<p><strong>Retained Earnings:</strong> The portion of a corporation\'s owners\' \r\n  equity that has been earned from profitable operations and not distributed to \r\n  stockholders.</p>\r\n<p><strong>Retainer:</strong> A sum of money paid in order to ensure a person \r\n  or company is available when required. </p>\r\n<p><strong>Retention Ratio: </strong>The proportion of the profits retained in \r\n  a business after all the expenses (usually including tax and interest) are taken \r\n  into account. </p>\r\n<p><strong>Return on Investment (ROI):</strong> A measure of operating performance \r\n  and efficiency in utilizing assets computed in its simplest form by dividing \r\n  net income by average total assets. </p>\r\n<p><strong>Return on Sales Revenue: </strong>A measure of operating performance; \r\n  computed by dividing net income by total sales revenue. </p>\r\n<p><strong>Return on Stockholders\' Equity: </strong>A measure of overall performance \r\n  from a stockholder\'s viewpoint; includes management of operations, uses of assets, \r\n  and management of debt and equity, and is computed by dividing net income by \r\n  average stockholder\'s equity. </p>\r\n<p><strong>Return on Total Assets:</strong> An overall measure of the return to \r\n  both stockholders and creditors; includes operating performance and asset turnover. \r\n</p>\r\n<p><strong>Revenue Recognition Principle: </strong>The idea that revenues should \r\n  be recorded when (1) the earnings process has been substantially completed and \r\n  (2) an exchange has taken place. </p>\r\n<p><strong>Revenues:</strong> The sales and any other taxable income of a business.</p>\r\n<p><strong>Reversing Transactions:</strong> Recurring period-end transactions \r\n  that are recorded in the books and regenerated from scratch each period. This \r\n  requires that the adjustment booked at the end of the preceding period be removed \r\n  from the books so that only the current period\'s adjustment appears. </p>\r\n<p><strong>ROI (Return on Investment):</strong> A measure of operating performance \r\n  and efficiency in utilizing assets computed in its simplest form by dividing \r\n  net income by average total assets. </p>',266),(290,40,'Glossary: S','<strong>S Corporation: </strong>A domestic corporation that is recognized as \r\n  a regular corporation under state law but is granted special status for federal \r\n  income tax purposes. </p>\r\n<p><strong>Sales:</strong> Income received from selling goods or a service.</p>\r\n<p><strong>Sales Discount: </strong>A reduction in the selling price that is allowed \r\n  if payment is received within a specified period. </p>\r\n<p><strong>Sales Journal:</strong> A special journal in which credit sales are \r\n  recorded. </p>\r\n<p><strong>Sales Ledger:</strong> A subsidiary ledger which holds the accounts \r\n  of a business\'s customers. A control account is held in the nominal ledger (usually \r\n  called a debtors\' control account) which shows the total balance of all the \r\n  accounts in the sales ledger.</p>\r\n<p><strong>Sales Returns and Allowances: </strong>A contra-revenue account in \r\n  which the return of, or allowance for, reduction in the price of merchandise \r\n  previously sold is recorded. </p>\r\n<p><strong>Sales Tax Payable:</strong> Money collected from customers for sales \r\n  taxes, that must be remitted to local governments and other taxing authorities. \r\n</p>\r\n<p><strong>Salvage, or Residual, Value:</strong> Estimated value or actual price \r\n  of an asset at the conclusion of its useful life, net of disposal costs. </p>\r\n<p><strong>SEC (Securities and Exchange Commission): </strong>The government body \r\n  responsible for regulating the financial reporting practices of most publicly \r\n  owned corporations in connection with the buying and selling of stocks and bonds. \r\n</p>\r\n<p><strong>Secured Bonds:</strong> Bonds for which assets have been pledged in \r\n  order to guarantee repayment. </p>\r\n<p><strong>Segregation of Duties:</strong> Strategy to provide an internal check \r\n  on performance through separation of custody of assets from accounting personnel, \r\n  separation of authorization of transactions from custody of related assets, \r\n  separation of operational responsibilities from record keeping responsibilities. \r\n</p>\r\n<p><strong>Self-Balancing Ledgers: </strong>A system which makes use of control \r\n  accounts so that each ledger will balance on its own. A control account in a \r\n  subsidiary ledger will be mirrored with a control account in the nominal ledger.</p>\r\n<p><strong>Self-Employed:</strong> The owner (or partner) of a business who is \r\n  legally liable for all the debts of the business (i.e. the owner(s) of a non-limited \r\n  company).</p>\r\n<p><strong>Self-Insurance: </strong>A term often used to describe the retention \r\n  by an entity of a risk of loss arising out of the ownership of property or from \r\n  some other cause, instead of transferring that risk to an independent third \r\n  party through the purchase of an insurance policy. It is sometimes accompanied \r\n  by the setting aside of assets to fund any related losses. Because no insurance \r\n  is involved, the term self-insurance is a misnomer.</p>\r\n<p><strong>Selling, General & Administrative expense (SG&A): </strong>The \r\n  expenses involved in running a business.</p>\r\n<p><strong>Service: </strong>A term usually applied to a business which sells \r\n  a service rather than manufactures or sells goods (e.g. an architect or a window \r\n  cleaner).</p>\r\n<p><strong>Shareholders (stockholders): </strong>Individuals or organizations \r\n  that own a portion (shares of stock) of a corporation.</p>\r\n<p><strong>Short-Term Debt:</strong> Debt with a maturity of one your or less \r\n  after the date of issuance. Short-term debt usually includes variable-rate debt, \r\n  bond anticipation notes, tax anticipation notes and revenue anticipation notes. \r\n</p>\r\n<p><strong>Significant Influences:</strong> Influence presumed if a company owns \r\n  between 20% and 50% of another company. </p>\r\n<p><strong>Single-Step Income Statement:</strong> An income statement where all \r\n  the revenues are shown as a single total rather than being split up into different \r\n  types of revenue (this is the most common format for very small businesses). \r\n</p>\r\n<p><strong>Sinking Fund:</strong> An account set up to reduce another account \r\n  to zero over time (using the principles of amortization or straight line depreciation). \r\n  Once the sinking fund reaches the same value as the other account, both can \r\n  be removed from the balance sheet. </p>\r\n<p><strong>SME: Small and Medium Enterprises (i.e. small and medium size businesses):</strong> \r\n  The distinction between what is \'small\' and what is \'medium\' varies depending \r\n  on where you are and who you talk to. </p>\r\n<p><strong>Social Security (FICA) Taxes:</strong> Federal Insurance Contributions \r\n  Act taxes imposed on employee and employer; used mainly to provide retirement \r\n  benefits. </p>\r\n<p><strong>Sole-Proprietor: </strong>The self-employed owner of a business (see \r\n  Self-employed).</p>\r\n<p><strong>Solvency:</strong> A company\'s long-run ability to meet all financial \r\n  obligations. </p>\r\n<p><strong>Source Document: </strong>An original invoice, bill or receipt to which \r\n  journal entries refer.</p>\r\n<p><strong>Special Journal:</strong> A book of original entry for recording similar \r\n  transactions that occur frequently. </p>\r\n<p><strong>Special Order: </strong>An order that may be priced below the normal \r\n  price in order to utilize excess capacity and thereby contribute to company \r\n  profits. </p>\r\n<p><strong>Specific Identification:</strong> A method of valuing inventory and \r\n  determining cost of goods sold whereby the actual costs of specific inventory \r\n  items are assigned to them. </p>\r\n<p><strong>Spool: </strong>If a report or listing is to be printed, but the printer \r\n  if busy or not ready, you may product the report or listing and save it on the \r\n  computer to be printed later is called spooling. When the printer becomes available, \r\n  the report may be printed (de-spooling).</p>\r\n<p><strong>Standard Unqualified Audit Report:</strong> Audit report indicating \r\n  that all auditing conditions have been met, no significant misstatements have \r\n  been discovered and remain uncorrected, and the auditors feel the financial \r\n  statements are fairly stated in accordance with generally accepted accounting \r\n  principles. </p>\r\n<p><strong>Stated Rate of Interest: </strong>The rate of interest printed on the \r\n  bond.</p>\r\n<p><strong>Stated Value: </strong>A nominal value assigned to no-par stock by \r\n  the board of directors of a corporation. </p>\r\n<p><strong>Statement of Cash Flows: </strong>The financial statement that shows \r\n  an entity\'s cash inflows (receipts) and outflows (payments) during a period \r\n  of time. </p>\r\n<p><strong>Statement of Earnings (Income Statement):</strong> The financial statement \r\n  that summarizes the revenues generated and the expenses incurred by an entity \r\n  during a period of time. </p>\r\n<p><strong>Statement of Partners\' Capital:</strong> A partnership report showing \r\n  the changes in the capital balances; similar to a statement of retained earnings \r\n  for a corporation. </p>\r\n<p><strong>Statement of Retained Earnings:</strong> A report that shows the changes \r\n  in the Retained Earnings account during a period of time. </p>\r\n<p><strong>Statement of Stockholders\' Equity: </strong>A financial statement that \r\n  reports all changes in stockholders\' equity.</p>\r\n<p><strong>Stock:</strong> Refers to the shares of a limited company or goods \r\n  manufactured or bought for re-sale by a business.</p>\r\n<p><strong>Stock Certificate:</strong> A document issued by a corporation to stockholders \r\n  evidencing ownership in the corporation. </p>\r\n<p><strong>Stock Dividend:</strong> A pro rata distribution of additional shares \r\n  of stock to shareholders. </p>\r\n<p><strong>Stock Split: </strong>The replacement of outstanding shares of stock \r\n  with a greater number of new shares that have a proportionately lower par or \r\n  stated value. </p>\r\n<p><strong>Straight-Line Amortization: </strong>A method of systematically writing \r\n  off a bond discount or premium in equal amounts each period until maturity. \r\n</p>\r\n<p><strong>Straight-Line Depreciation Method:</strong> The depreciation method \r\n  in which the cost of an asset is allocated equally over the periods of an asset\'s \r\n  estimated useful life. </p>\r\n<p><strong>Sub-Account: </strong>An account attached to an individual GL account \r\n  code in the company chart of accounts. </p>\r\n<p><strong>Subsidiary Account:</strong> One of a group of related accounts supporting \r\n  in detail the debit and credit summaries recorded in a control account. </p>\r\n<p><strong>Subsidiary Company:</strong> A company owned or controlled by another \r\n  company, known as the parent company. </p>\r\n<p><strong>Subsidiary Ledger:</strong> A grouping of individual accounts that \r\n  in total equal the balance of a control account in the General Ledger. </p>\r\n<p><strong>Sum-of-the-Years\'-Digits (SYD) Depreciation Method:</strong> The accelerated \r\n  depreciation method in which a constant balance (cost minus salvage value) is \r\n  multiplied by a declining depreciation rate. </p>\r\n<p><strong>Supplies:</strong> Materials used in a business that do not generally \r\n  become part of the sales product and were not purchased to be resold to customers.</p>\r\n<p><strong>Suspense Account: </strong>An account carrying charges or credits temporarily \r\n  pending the determination of the proper account or accounts to which they are \r\n  to be posted. </p>\r\n<p><strong>Stock:</strong> This can refer to the shares of a limited company (see \r\n  Shares) or goods manufactured or bought for re-sale by a business.</p>\r\n<p><strong>Stock Control Account: </strong>An account held in the nominal ledger \r\n  which holds the value of all the stock held in the inventory subsidiary ledger.</p>\r\n<p><strong>Stock Valuation:</strong> Valuing a stock of goods bought for manufacturing \r\n  or re-sale.</p>\r\n<p><strong>Straight-Line Depreciation: </strong>Depreciating something by the \r\n  same (i.e. fixed) amount every year rather than as a percentage of its previous \r\n  value. Example: a vehicle initially costs $10,000. If you depreciate it at a \r\n  rate of $2000 a year, it will depreciate to zero in exactly 5 years. See Depreciation.</p>\r\n<p><strong>Subordinated Debt:</strong> If a company is liquidated (i.e. becomes \r\n  insolvent), the secured creditors are paid first. If any money is left, the \r\n  unsecured creditors are then paid. The amount of money owed to the unsecured \r\n  creditors is termed the \'subordinated debt\' of the company. </p>\r\n<p><strong>Subsidiary Ledgers:</strong> Ledgers opened in addition to a business\'s \r\n  nominal ledger. They are used to keep sections of a business separate from each \r\n  other (e.g. a Sales ledger for the customers, and a Purchase ledger for the \r\n  suppliers). (See Control Accounts)</p>\r\n<p><strong>Suspense Account:</strong> A temporary account used to force a trial \r\n  balance to balance if there is only a small discrepancy (or if an account\'s \r\n  balance is simply wrong, and you don\'t know why). A typical example would be \r\n  a small error in petty cash. In this case a transfer would be made to a suspense \r\n  account to balance the cash account. Once the person knows what happened to \r\n  the money, a transfer entry will be made in the journal to credit or debit the \r\n  suspense account back to zero and debit or credit the correct account.</p>',267),(291,40,'Glossary: T','<strong>T Account:</strong> A particular method of displaying an account where \r\nthe debits and associated information are shown on the left, and credits and associated \r\ninformation on the right. \r\n<p><strong>Tangible Assets:</strong> Assets of a physical nature. Examples include \r\n  buildings, motor vehicles, plant and equipment, fixtures and fittings. See Intangible \r\n  assets. </p>\r\n<p><strong>Tangible Personal Business Property: </strong>Depreciable operating \r\n  assets of a business, other than real property, including machinery, furniture \r\n  and fixtures, automobiles and trucks, and equipment. </p>\r\n<p><strong>Tax Rate: </strong>The amount of tax stated in terms of a unit of the \r\n  tax base. </p>\r\n<p><strong>Taxes: </strong>Compulsory charges levied by a government to finance \r\n  services for the common benefit. </p>\r\n<p><strong>Term Bonds:</strong> Bonds that mature in one lump sum at a specified \r\n  future date. </p>\r\n<p><strong>Three Column Cash Book:</strong> A journal which deals with the day \r\n  to day cash and bank transactions of a business. The side of a transaction which \r\n  relates directly to the cash or bank account is usually balanced within the \r\n  journal and used as a part of the nominal ledger when compiling a balance sheet \r\n  (i.e. only the side which details the sale or purchase needs to be posted to \r\n  the nominal ledger).</p>\r\n<p><strong>Time Period (or Periodicity) Concept:</strong> The idea that the life \r\n  of a business is divided into distinct and relatively short time periods so \r\n  that accounting information can be timely. </p>\r\n<p><strong>Times Interest Earned Ratio: </strong>Ratio that indicates the company\'s \r\n  margin above the fixed interest charged to be paid to creditors; calculated \r\n  by dividing income before interest and income taxes by interest expense. </p>\r\n<p><strong>Total Cost of Ownership (TCO):</strong> The real amount an asset will \r\n  cost. Example: An accounting application retails at $1000. Support - which is \r\n  mandatory, costs a further $200 per annum. Assuming the software will be in \r\n  use for 5 years, TCO will be $2000 (1000+5x200=2000).</p>\r\n<p><strong>Trademark: </strong>A word, phrase, symbol, design, or combination \r\n  thereof, that identifies and distinguishes the source of goods or services of \r\n  one party from those of another. </p>\r\n<p><strong>Trading Account: </strong>An account which shows the gross profit of \r\n  a manufacturing or retail business.</p>\r\n<p><strong>Trading Securities: </strong>Debt and equity securities purchased with \r\n  the intent of selling them should the need for cash arise or to realize short-term \r\n  gains. </p>\r\n<p><strong>Transaction:</strong> Two or more entries made in a journal which when \r\n  looked at together reflect an original document such as a sales invoice or purchase \r\n  receipt.</p>\r\n<p><strong>Transaction Group:</strong> Recurring transaction due together periodically, \r\n  such as monthly rent and phone bills. </p>\r\n<p><strong>Transportation Costs: </strong>Costs of transferring merchandise into \r\n  or out of a firm. </p>\r\n<p><strong>Trial Balance: </strong>A list of the balances of the accounts in a \r\n  ledger kept by double entry, with the debt and credit balances shown in separate \r\n  columns. If the totals of the debt and credit columns are equal or if their \r\n  net balance agrees with a control account, the ledger from which the figures \r\n  are taken is said to be in balance. </p>\r\n<p><strong>Treasury Stock:</strong> Issued stock that has subsequently been reacquired \r\n  by the corporation. </p>\r\n<p><strong>Turnover: </strong>The income of a business over a period of time (usually \r\n  a year).</p>',268),(292,40,'Glossary: U','<p><strong>Uncollectable Accounts Expense:</strong> An account that represents \r\n  the portion of the current period\'s receivables that are estimated to become \r\n  uncollectable.\r\n<p><strong>Undelivered Orders: </strong>The value of goods and services ordered \r\n  and obligated, but which have not been received. \r\n<p><strong>Undeposited Funds Account: </strong>An account used to show the current \r\n  total of money received (i.e. not yet banked or spent). The \'funds\' can include \r\n  money, checks, credit card payments, bankers drafts etc. This type of account \r\n  is also commonly referred to as a \'cash in hand\' account.\r\n<p><strong>Unearned Revenues: </strong>Amounts received before they have been \r\n  earned. </p>\r\n<p><strong>Unexpended Balance: </strong>The amount of budget authority unspent \r\n  and still available; the sum of the obligated and unobligated balances. </p>\r\n<p><strong>Units-or-Production Depreciation Method:</strong> The depreciation \r\n  method in which the cost of an asset is allocated to each period on the basis \r\n  of the productive output or use of the asset during the period. </p>\r\n<p><strong>Unlimited Liability: </strong>The lack of a ceiling on the amount of \r\n  liability a proprietor or partner must assume; meaning that if business assets \r\n  are not sufficient to settle creditor claims, the personal assets of the proprietor \r\n  or partners may be used to settle the claims. </p>\r\n<p><strong>Unliquidated Obligations:</strong> Amounts committed for a specific \r\n  purpose for which there has been no disbursement of funds. </p>\r\n<p><strong>Unrealized Gains and Losses:</strong> Gains and losses resulting from \r\n  changes in the value of securities that are still being held. </p>\r\n<p><strong>Unrecorded Expenses:</strong> Expenses incurred during a period that \r\n  have not been recorded by the end of that period. </p>\r\n<p><strong>Unrecorded Revenues:</strong> Revenues earned during a period that \r\n  have not been recorded by the end of that period. </p>\r\n<p><strong>Useful Life:</strong> The term used to describe the life over which \r\n  an asset is expected to be useful to the company; cost is assigned to the periods \r\n  benefited from using the asset. <br>',269),(293,40,'Glossary: V','<p><strong>Variance Report: </strong>Compares an original budget to the actual \r\n  expenditures, highlighting the difference or variance between the two. A variance \r\n  report is produced along with quarterly expenditure reports on a year-to-date \r\n  basis. The results of the variance report may necessitate amending the budget \r\n  disbursements in the second appropriation in order to reflect the changed situation. \r\n</p>\r\n<p><strong>Vested Benefit: </strong>A benefit for which the employer has an obligation \r\n  to make payment even if an employee terminates; thus, the benefit is not contingent \r\n  on an employee\'s future service. </p>\r\n<p><strong>Voided Checks: </strong>Refers to checks which have not released or \r\n  have been lost and therefore have not and will not clear the bank. Voiding checks \r\n  are done in Accounts Payable. \r\n<p><strong>Voucher: </strong>A transaction-processing record that documents approvals, \r\n  payment amounts and physical shipment or receipt.\r\n<p><strong>Voucher Payable: </strong>A voucher connotes that a bill has been checked \r\n  carefully to determine that at least the authorization, amount, and quantity \r\n  are correct and should be paid. Thus, a voucher payable is a liability.',270),(294,40,'Glossary: W','<strong>Wages:</strong> Payments made to the employees of a business for their \r\nwork on behalf of the business. These are classed as expense items and must not \r\nbe confused with \'drawings\' taken by sole-proprietors and partnerships.\r\n<p><strong>Work in Progress:</strong> The value of partly finished (i.e. partly \r\n  manufactured) goods. </p>\r\n<p><strong>Work Sheet:</strong> A columnar schedule used to summarize accounting \r\n  data. </p>\r\n<p><strong>Working Capital:</strong> Current assets minus current liabilities. \r\n</p>\r\n<p><strong>Working Capital Turnover: </strong>A measure of the amount of working \r\n  capital used in generating the sales of a period; computed by dividing net sales \r\n  by average working capital. </p>\r\n<p> <strong>Write-off:</strong> Depreciating an asset to zero in one go. </p>\r\n<p><strong>Weighted-Average:</strong> A periodic inventory cost flow alternative \r\n  whereby the cost of goods sold and the cost of ending inventory are determined \r\n  by using a weighted-average cost of all merchandise available for sale during \r\n  the period. </p>',271),(295,40,'Glossary: X','<em><strong>No Entries.</p> </strong></em> ',272),(296,40,'Glossary: Y','<em><strong>No Entries.</p> </strong></em> ',273),(297,40,'Glossary: Z','<strong>Zero Based Account (ZBA): </strong>Usually applied to a personal account \r\n(checking) where the balance is kept as close to zero as possible by transferring \r\nmoney between that account and, say, a deposit account. \r\n<p><strong>Zero Based Budget (ZBB):</strong> Starting a budget at zero and justifying \r\n  every cost that increases that budget. </p>',274),(298,14,'Items Received List','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Items Received List</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_purchasing_receive_no_po_list/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This report shows Items Received (with or without a Purchase Order) for a range of dates.  The receipt of the item can be cancelled by drilling down from thsi report.</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Purchasing -> Items Received List</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryReceiveNoPOList.jpg\"> \r\n</p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter search data in the following categories:</b></li></p>\r\n     <ol TYPE=\"a\">\r\n         <li><b>Item Name or Code â€“ ID: </b> Enter Item Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Item number directly into the box on the right. If you want to search by description, type of item, vendor, category, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n         <li><b>Begin Date: </b>You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n         <li><b>End Date: </b> You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n         <li><b>Location: </b>Select a location from the pull-down list.</li></p>\r\n         <li><b>Category: </b>Select a Item Category from the pull-down list.</li></p>\r\n         <li><b>Text in Notes: </b>Enter words (or portions of words) to search in the Notes field.</li></p>\r\n         <li><b>Vendor Name â€“ ID: </b> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n         <li><b>Show Which Receipts: </b>Select which items to select for the report, all received items, those with a PO, or those without a PO.</li></p>\r\n       </ol>\r\n\r\n<li>To view your report, click on the <img src=\"images/next.gif\"> <b>Next</b> button.  Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryReceiveNoPoList1.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To see a detailed report or cancel a receipt in case of error, click on the <font color=\"0000FF\">Received Date</font>. Your screen should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryReceiveNoPoList2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To cancel the receipt, click on the <img src=\"images/delete.gif\"> <b>Unreceive This Item</b> button to cancel the receipt. </li></p>\r\n\r\n<li>To return to the previous page WITHOUT SAVING the changes, click on the <img src=\"images/Back2.gif\"> <b>Back</b> button.</li></p>\r\n</ol>',275),(299,15,'Write Checks (Payables)','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Write Payables Checks</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_check_write/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Enter payment information and print checks for bills to be paid.</em> \r\n<ol>\r\n\r\n<li>From the Main Menu, select <b><i>Payables -> Write Checks</b></i>.</li></p>\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/PayBills.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n    <ol TYPE=\"a\">\r\n         <li><b>Invoice #: </b>If you do not knowthis, leave it blank. </li></p>\r\n         <li><b>Vendor Name â€“ ID: </b> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n         <li><b>Due Date: </b>If you want to include only those invoices due by a certain date (say, within the next 7 days), you can either enter the date manually \r\nor click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to bring up a calendar.</li></p>\r\n         <li><b>Pay How: </b>Select method of payment from the pull-down list. NOTE: Credit card, ACH, EFT selections for reference only. No automatic processing will take place. You will need to process the credit card transaction file separately.</li></p> \r\n         <li><b>Checking Account: </b> If you have  MORE THAN ONE checking account defined for payables, select the one you want from the pull-down list. (you will not see this prompt if you have only one checking account.)</li></p>\r\n         <li><b>Check Date: </b>Select the date to be put on your checks. This date will be the date used to post the check run to the General Ledger if \"Use Transaction Date\" field in Payables Setup is UNCHECKED. For more explanation on this feature, see the <b><i>Standard GL Account (Payables)</b></i> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n         <li><b>Apply Discount: </b>Check this box if you want to take any available discounts.</li></p>\r\n     </ol>\r\n\r\n<li>To write the checks, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/PayBills1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data in the following categories:</b></li></p>\r\n      <ol TYPE=\"a\">\r\n          <li><b>Vendor (Hold): </b>If you check this box (next to the vendor name) it will place all bills for this vendor in a HOLD status. Vendor (hold) box or boxes must be UNSELECTED to pay the invoice.</li></p>\r\n          <li><b>Bill on Hold: </b>If you check this box, this BILL will be placed on HOLD status.</li></p>\r\n          <li><b>Pay Invoice: </b>Check this box if you WANT this invoice to be paid at this time (all invoices are checked to be paid by default). To check or uncheck ALL invoices shown, check or uncheck the <b>Check All</b> box at the top of the Pay Invoice column.  NOTE: The total amount being paid will show up at the bottom of the screen in the Total box. </li></p>\r\n     </ol>\r\n\r\n<li>To cancel the check run and return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>Once you have selected the invoices to pay, click the <img src=\"images/next.gif\"> <b>Next</b> button to process the checks. Your screen should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/PayBills3.jpg\" </p>\r\n<p align=\"left\">\r\n\r\n<li>Verify the information shown and edit the following categories, if necessary: </li></p>\r\n       <ol TYPE=\"a\">\r\n             <li><b>Interest: </b>Enter the amount of interest to also be paid on each invoice. </li></p>\r\n             <li><b>Beginning Check Number: </b>Verify the beginning check number is correct.  If using preprinted check stock, verify the beginning check number matches the check number on your first check.</li></p>\r\n             <li><b>Endorser name: </b>Enter/Verify this is the name of the person signing the checks.</li></p>\r\n       </ol>\r\n\r\n<li>To print the checks, click on the <img src=\"images/print.gif\"> <b>Print</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/PayBills4.jpg\" </p>\r\n<p align=\"left\">\r\n\r\n<li>To print the checks in Adobe Acrobat ReaderÂ® (.pdf) format, click on the <font color=\"0000FF\">Check Numbers</font> or on the words <font color=\"0000FF\">Print All in List</font>. An example of the Check Print is shown in the <b>Sample Check Print</b> section below.</li></p>\r\n\r\n<li>If the .PDF file does not open automatically or give the option to open the file, you may see this screen:</li></p>\r\n\r\n   <ol TYPE=\"a\">\r\n        <li>If so, click on the words <font color=\"0000FF\">Click to View</font> to view the checks and print them.</li></p>\r\n\r\n              <p align=\"center\"><img src=\"images/screenshots/PayBills5.jpg\"></p>\r\n              <p align=\"left\">\r\n\r\n        <li>To return to the previous screen and print more checks, if necessary, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n   </ol>   \r\n\r\n<li>To finish, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n \r\n<br><hr>\r\n<div align=\"center\"><font size=\"+1\" face=\"Georgia, Times New Roman, Times, serif\"> <b>Sample Check Print</b></font></div>\r\n<hr>\r\n<em>This check assumes a pre-printed check paper, with the check at the top, followed by two stub copies.</em><br><br>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/PayBills6.jpg\" </p>\r\n\r\n',276),(300,25,'New Tax Type','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> New Tax Type</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_add_tax_type/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this section to create new tax districts \r\n(whether local, city, federal, school district, etc.) and enter some \r\ngeneral information about the tax and deductions.  The actual \r\ntax table information is entered under Enter/Update Tax Tables.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click New Tax Type. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_EnterTax1.jpg\" ></p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Local \r\n  or City Taxes</strong></font></div>\r\n<hr>\r\n<div align=\"left\">\r\n  <p>1) Select the Local or City Tax Type from the pull-down list. </p>\r\n  <p>2) Click the <img src=\"images/add.gif\" width=\"29\" height=\"29\"> button. \r\n    Your screen should look similar to this: </p>\r\n  <p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_NewTax2.jpg\" ></p>\r\n  <p align=\"left\">3) Enter Data in the following categories: </p>\r\n  <blockquote> \r\n  <div align=\"left\"> <p> a) <strong>Name</strong> Name of tax district. This name \r\n    will appear on tax forms<br>\r\n    b) <strong>Check Abbr.</strong> Since there may not be room for the full name on checks, etc. this abbreviation is what will show on pay stubs.<br>\r\n    c) <strong>Deduct Federal Tax First</strong> Check the box if you should deduct federal tax from the total pay before \r\n    calculating this tax.<br>\r\n    d) <strong>Maximum Federal Tax to Deduct.</strong> If you checked \r\n    the above box (Deduct Federal Tax First), then enter the maximum federal tax to be deducted from \r\n    wages. Leave this a zero if there is no maximum.<br>\r\n    e) <strong>GL Account</strong> Select from the pull-down list. This is \r\n    the payables account into which this tax will accrue until paid to the tax \r\n    district.<br>\r\n    f) <strong>Vendor number</strong> Enter the number of the vendor (who you pay the tax to) you need or use \r\n    the Lookup button to search for the vendor number. By selecting the vendor, \r\n    the payroll taxes for this district will generate an entry into Payables automatically \r\n    for the amount accrued. This occurs when writing checks. <br>\r\n    NOTE: To Add A New Vendor, click on the <img src=\"images/add.gif\"> button and follow direction under Add/Update Vendor.<br>\r\n    g) <strong>Tax #.</strong> Tax id number to show on W2, \r\n    etc.<br>\r\n    h) <strong>Amount for 1 exemption.</strong> Amount per exemption. \r\n    Amount to be deducted from wages prior to calculating tax.<br>\r\n    i) <strong>Amount for 2 exemptions.</strong> Amount per exemption. Amount \r\n    to be deducted from wages prior to calculating tax.<br>\r\n    j) <strong>Amount for 3 exemptions.</strong> Amount per exemption. Amount \r\n    to be deducted from wages prior to calculating tax.<br>\r\n    k) <strong>Amount per exemption for 4 & up.</strong> Amount per exemption. \r\n    Amount to be deducted from wages prior to calculating tax.<br>\r\n    l)<strong>Max. exemption %. </strong> If your tax district \r\n    only has a ceiling on allowable exemption amounts up to a certain percentage of total wages, enter \r\n    that percentage here.<br>\r\n    m) <strong>Maximum exemption amount per year.</strong> If your tax \r\n    district has a ceiling on allowable exemption amounts up to a certain maximum amount per \r\n    year, enter that maximum here.<br>\r\n    n) <strong>Credit for 1 exemption.</strong> For tax districts \r\n    allowing a credit (reduction of tax calculated) per exemption. <br>\r\n    o) <strong>Credit per exemption for 2.</strong> For tax \r\n    districts allowing a credit (reduction of tax calculated) per exemption.<br>\r\n    p) <strong>Credit per exemption for 3.</strong> For tax \r\n    districts allowing a credit (reduction of tax calculated) per exemption.<br>\r\n    q)<strong> Enter the Credit per exemption for 4 & up.</strong>  \r\n    For tax districts allowing a credit (reduction of tax tax calculated) per exemption.</p></blockquote>\r\n  <p align=\"left\"> 4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> \r\n    button to save the Local or City tax. This will then take you to the tax table edit section. </p>\r\n  <p>5) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to \r\n    return to the previous screen without saving the changes.</p>\r\n  <div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>State \r\n    Taxes</strong></font></div>\r\n  <hr>\r\n  <p>1) Select the State Tax Type from the pull-down list. </p>\r\n  <p>2) Click the <img src=\"images/add.gif\" width=\"29\" height=\"29\"> button. \r\n    Your screen should look similar to this:</p>\r\n  <p align=\"center\"><img src=\"images/screenshots/StateTaxes.jpg\" ></p>\r\n  <p align=\"left\">3) Enter Data in the following categories:</p>\r\n  <blockquote> \r\n  <div align=\"left\"> <p> a) <strong>Select the State</strong> from the pull-down list.<br>\r\n    b) <strong>Enter the SUI%.</strong>  State Unemployment Insurance  \r\n    percentage to be multiplied times wages to calculate tax.<br>\r\nc) <strong>Max SUI per Year.</strong> Maximum wages on which SUI is to be calculated<br>\r\n\r\n    d) <strong>Deduct Federal Tax First</strong> Check the box if you should deduct federal tax from the total pay before \r\n    calculating this tax.<br>\r\n    e) <strong>Maximum Federal Tax to Deduct.</strong> If you checked \r\n    the above box (Deduct Federal Tax First), then enter the maximum federal tax to be deducted from \r\n    wages. Leave this a zero if there is no maximum.<br>\r\n    f) <strong>GL Account</strong> Select from the pull-down list. This is \r\n    the payables account into which this tax will accrue until paid to the tax \r\n    district.<br>\r\n    g) <strong>Vendor number</strong> Enter the number of the vendor (who you pay the tax to) you need or use \r\n    the Lookup button to search for the vendor number. By selecting the vendor, \r\n    the payroll taxes for this district will generate an entry into Payables automatically \r\n    for the amount accrued. This occurs when writing checks. <br>\r\n    NOTE: To Add A New Vendor, click on the <img src=\"images/add.gif\"> button and follow direction under Add/Update Vendor.<br>\r\n    h) <strong>Tax #.</strong> Tax id number to show on W2, \r\n    etc.<br>\r\n    i) <strong>Amount for 1 exemption.</strong> Amount per exemption. \r\n    Amount to be deducted from wages prior to calculating tax.<br>\r\n    j) <strong>Amount for 2 exemptions.</strong> Amount per exemption. Amount \r\n    to be deducted from wages prior to calculating tax.<br>\r\n    k) <strong>Amount for 3 exemptions.</strong> Amount per exemption. Amount \r\n    to be deducted from wages prior to calculating tax.<br>\r\n    l) <strong>Amount per exemption for 4 & up.</strong> Amount per exemption. \r\n    Amount to be deducted from wages prior to calculating tax.<br>\r\n    m)<strong>Max. exemption %. </strong> If your tax district \r\n    only has a ceiling on allowable exemption amounts up to a certain percentage of total wages, enter \r\n    that percentage here.<br>\r\n    n) <strong>Maximum exemption amount per year.</strong> If your tax \r\n    district has a ceiling on allowable exemption amounts up to a certain maximum amount per \r\n    year, enter that maximum here.<br>\r\n    o) <strong>Credit for 1 exemption.</strong> For tax districts \r\n    allowing a credit (reduction of tax calculated) per exemption. <br>\r\n    p) <strong>Credit per exemption for 2.</strong> For tax \r\n    districts allowing a credit (reduction of tax calculated) per exemption.<br>\r\n    q) <strong>Credit per exemption for 3.</strong> For tax \r\n    districts allowing a credit (reduction of tax calculated) per exemption.<br>\r\n    r)<strong> Enter the Credit per exemption for 4 & up.</strong>  \r\n    For tax districts allowing a credit (reduction of tax tax calculated) per exemption.</p></blockquote>\r\n  <p align=\"left\">4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> \r\n    button to save the state tax. This will take you to the tax table edit section.</p>\r\n  <p>5) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to \r\n    return to the previous screen without saving the changes.</p>\r\n  <div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Federal \r\n    Taxes</strong></font></div>\r\n  <hr>\r\n  <p>1) Select the Federal Tax Type from the pull-down list. NOTE: You will not see a Federal Tax option if you have already entered it -- go to the UPDATE section to make changes.</p>\r\n  <p> 2) Click the <img src=\"images/add.gif\" width=\"29\" height=\"29\"> button. \r\n    Your screen should look similar to this: </p>\r\n  <p align=\"center\"><img src=\"images/screenshots/FederalTaxes.jpg\" ></p>\r\n  <p align=\"left\">3) Enter Data in the following categories: </p>\r\n  <blockquote> \r\n  <div align=\"left\"> a) <strong>Annual Exemption Allowance.</strong> Amount \r\n    to be deducted from YEARLY wages PER EXEMPTION claimed.<br>\r\n    b) <strong>FICA > Max Wages.</strong> Maximum wages on \r\n    which Social Security tax is calculated.<br>\r\n    c) <strong>FICA > Employee %. </strong> Percentage of \r\n    wages deducted from employee pay for social security.<br>\r\n    d) <strong>FICA > Company %.</strong> Percentage of wages \r\n    employer contributes to social security on each employee.<br>\r\n    e) <strong>Medicare > Max Wages.</strong> Maximum wages \r\n    on which Medicare tax is calculated<br>\r\n    f) <strong>Medicare > Employee %. </strong> Percentage \r\n    of wages deducted from employee pay for Medicare.<br>\r\n    g) <strong>Medicare > Company %.</strong> Percentage \r\n    of wages employer contributes to Medicare on each employee<br>\r\n    h) <strong>Federal Unemployment Insurance (FUI or FUTA) Max Wages.</strong> \r\n     Maximum wages on which Federal Unemployment tax is calculated.<br>\r\n    i) <strong>Federal Unemployment Insurance Company %.</strong> \r\n    Percentage of Company contribution for Federal Unemployment Insurance. \r\n    <br>\r\n    j) <strong>Earned Income Credit. </strong> This is for low-income families to receive a tax credit on federal income tax. It is a credit that is applied \r\n    AFTER the regular income tax is calculated. Earned Income Credit (Single) <br>\r\n       __% of wages on annual earnings over $__. <br>\r\n    k) <strong>Earned Income Credit (Single) </strong>>\r\n $__ Tax for annual earnings over $__.<br>\r\n    l) <strong>Earned Income Credit (Single) </strong>> $__ Tax, \r\n    less __% of wages on annual earnings over $__.<br>\r\n    m) <strong>Earned Income Credit (Married)</strong> > __% of wages \r\n    on annual earnings over $__.<br>\r\n    n) <strong>Earned Income Credit (Married) </strong>> $__ Tax \r\n    for annual earnings over $__.<br>\r\n    o) <strong>Earned Income Credit (Married) ></strong> $__ Tax, \r\n    less __ % of wages on annual earnings over $__.</p></blockquote>\r\n  <p align=\"left\">4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> \r\n    button to save the Federal tax.</p><br><br>',277),(301,25,'Update Tax Type','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Update Tax Type</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_update_tax_type/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Update Exemption Allowances and other \r\ngeneral information about tax.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click Update Tax Type. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_ViewTax.jpg\" ></p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n  an Existing Local or City Tax</strong></font></div>\r\n<hr>\r\n<div align=\"left\"> \r\n  <p>1) Select Local or City as the Tax Type from the pull-down list. </p>\r\n  <p>2) Click the <img src=\"images/edit.gif\" width=\"29\" height=\"29\"> button. \r\n    Your screen should look similar to this: </p>\r\n  <p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_ViewTax.jpg\" ></p>\r\n  <p>3) Select the Local or City Tax Type you want to edit from the pull-down \r\n    list.</p>\r\n  <p>4) Click the <img src=\"images/edit.gif\" width=\"29\" height=\"29\"> button. \r\n    Your screen should look similar to this:</p>\r\n  <p align=\"center\"><img src=\"images/screenshots/UpdateLocalTaxes.jpg\" ></p>\r\n  <p align=\"left\">5) Edit any or all of the necessary data in each category. </p>\r\n  <blockquote> \r\n  <div align=\"left\"> <p> a) <strong>Name</strong> Name of tax district. This name \r\n    will appear on tax forms<br>\r\n    b) <strong>Check Abbr.</strong> Since there may not be room for the full name on checks, etc. this abbreviation is what will show on pay stubs.<br>\r\n    c) <strong>Deduct Federal Tax First</strong> Check the box if you should deduct federal tax from the total pay before \r\n    calculating this tax.<br>\r\n    d) <strong>Maximum Federal Tax to Deduct.</strong> If you checked \r\n    the above box (Deduct Federal Tax First), then enter the maximum federal tax to be deducted from \r\n    wages. Leave this a zero if there is no maximum.<br>\r\n    e) <strong>GL Account</strong> Select from the pull-down list. This is \r\n    the payables account into which this tax will accrue until paid to the tax \r\n    district.<br>\r\n    f) <strong>Vendor number</strong> Enter the number of the vendor (who you pay the tax to) you need or use \r\n    the Lookup button to search for the vendor number. By selecting the vendor, \r\n    the payroll taxes for this district will generate an entry into Payables automatically \r\n    for the amount accrued. This occurs when writing checks. <br>\r\n    NOTE: To Add A New Vendor, click on the <img src=\"images/add.gif\"> button and follow direction under Add/Update Vendor.<br>\r\n    g) <strong>Tax #.</strong> Tax id number to show on W2, \r\n    etc.<br>\r\n    h) <strong>Amount for 1 exemption.</strong> Amount per exemption. \r\n    Amount to be deducted from wages prior to calculating tax.<br>\r\n    i) <strong>Amount for 2 exemptions.</strong> Amount per exemption. Amount \r\n    to be deducted from wages prior to calculating tax.<br>\r\n    j) <strong>Amount for 3 exemptions.</strong> Amount per exemption. Amount \r\n    to be deducted from wages prior to calculating tax.<br>\r\n    k) <strong>Amount per exemption for 4 & up.</strong> Amount per exemption. \r\n    Amount to be deducted from wages prior to calculating tax.<br>\r\n    l)<strong>Max. exemption %. </strong> If your tax district \r\n    only has a ceiling on allowable exemption amounts up to a certain percentage of total wages, enter \r\n    that percentage here.<br>\r\n    m) <strong>Maximum exemption amount per year.</strong> If your tax \r\n    district has a ceiling on allowable exemption amounts up to a certain maximum amount per \r\n    year, enter that maximum here.<br>\r\n    n) <strong>Credit for 1 exemption.</strong> For tax districts \r\n    allowing a credit (reduction of tax calculated) per exemption. <br>\r\n    o) <strong>Credit per exemption for 2.</strong> For tax \r\n    districts allowing a credit (reduction of tax calculated) per exemption.<br>\r\n    p) <strong>Credit per exemption for 3.</strong> For tax \r\n    districts allowing a credit (reduction of tax calculated) per exemption.<br>\r\n    q)<strong> Enter the Credit per exemption for 4 & up.</strong>  \r\n    For tax districts allowing a credit (reduction of tax tax calculated) per exemption.</p></blockquote>\r\n  <p>6) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to \r\n    save the changes. </p>\r\n  <p>7) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button \r\n    to delete the Tax. </p>\r\n  <p>8) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to \r\n    return to the previous screen without saving the changes.</p>\r\n  \r\n  \r\n  <div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n    an Existing State Tax</strong></font></div>\r\n  <hr>\r\n  <p>1) Select State as the Tax Type from the pull-down list. </p>\r\n  <p>2) Click the Select button. Your screen should look similar to this: </p>\r\n  <p align=\"center\"><img src=\"images/screenshots/Payroll_Setup_ViewTax.jpg\" ></p>\r\n  <p>3) Select the State Tax Type you want to edit from the pull-down list.</p>\r\n  <p>4) Click the <img src=\"images/edit.gif\" width=\"29\" height=\"29\"> button. \r\n    Your screen should look similar to this:</p>\r\n  <p align=\"center\"><img src=\"images/screenshots/UpdateStateTaxesMain.jpg\" ></p>\r\n  <p>5) Edit any or all of the necessary data in each category. </p>\r\n  <blockquote> \r\n  <div align=\"left\"> <p> a) <strong>Select the State</strong> from the pull-down list.<br>\r\n    b) <strong>Enter the SUI%.</strong>  State Unemployment Insurance  \r\n    percentage to be multiplied times wages to calculate tax.<br>\r\nc) <strong>Max SUI per Year.</strong> Maximum wages on which SUI is to be calculated<br>\r\n\r\n    d) <strong>Deduct Federal Tax First</strong> Check the box if you should deduct federal tax from the total pay before \r\n    calculating this tax.<br>\r\n    e) <strong>Maximum Federal Tax to Deduct.</strong> If you checked \r\n    the above box (Deduct Federal Tax First), then enter the maximum federal tax to be deducted from \r\n    wages. Leave this a zero if there is no maximum.<br>\r\n    f) <strong>GL Account</strong> Select from the pull-down list. This is \r\n    the payables account into which this tax will accrue until paid to the tax \r\n    district.<br>\r\n    g) <strong>Vendor number</strong> Enter the number of the vendor (who you pay the tax to) you need or use \r\n    the Lookup button to search for the vendor number. By selecting the vendor, \r\n    the payroll taxes for this district will generate an entry into Payables automatically \r\n    for the amount accrued. This occurs when writing checks. <br>\r\n    NOTE: To Add A New Vendor, click on the <img src=\"images/add.gif\"> button and follow direction under Add/Update Vendor.<br>\r\n    h) <strong>Tax #.</strong> Tax id number to show on W2, \r\n    etc.<br>\r\n    i) <strong>Amount for 1 exemption.</strong> Amount per exemption. \r\n    Amount to be deducted from wages prior to calculating tax.<br>\r\n    j) <strong>Amount for 2 exemptions.</strong> Amount per exemption. Amount \r\n    to be deducted from wages prior to calculating tax.<br>\r\n    k) <strong>Amount for 3 exemptions.</strong> Amount per exemption. Amount \r\n    to be deducted from wages prior to calculating tax.<br>\r\n    l) <strong>Amount per exemption for 4 & up.</strong> Amount per exemption. \r\n    Amount to be deducted from wages prior to calculating tax.<br>\r\n    m)<strong>Max. exemption %. </strong> If your tax district \r\n    only has a ceiling on allowable exemption amounts up to a certain percentage of total wages, enter \r\n    that percentage here.<br>\r\n    n) <strong>Maximum exemption amount per year.</strong> If your tax \r\n    district has a ceiling on allowable exemption amounts up to a certain maximum amount per \r\n    year, enter that maximum here.<br>\r\n    o) <strong>Credit for 1 exemption.</strong> For tax districts \r\n    allowing a credit (reduction of tax calculated) per exemption. <br>\r\n    p) <strong>Credit per exemption for 2.</strong> For tax \r\n    districts allowing a credit (reduction of tax calculated) per exemption.<br>\r\n    q) <strong>Credit per exemption for 3.</strong> For tax \r\n    districts allowing a credit (reduction of tax calculated) per exemption.<br>\r\n    r)<strong> Enter the Credit per exemption for 4 & up.</strong>  \r\n    For tax districts allowing a credit (reduction of tax tax calculated) per exemption.</p></blockquote>\r\n  <p>6) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to \r\n    save the changes.<br>\r\n    <br>\r\n    7) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button to \r\n    delete the Tax. </p>\r\n  <p>8) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> button to \r\n    return to the previous screen without saving the changes.</P>\r\n    \r\n  <div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n    an Existing Federal Tax</strong></font></div>\r\n  <hr></hr>\r\n  <br>1) Select the Federal Tax Type from the pull-down list. \r\n  <p> 2) Click the <img src=\"images/edit.gif\" width=\"29\" height=\"29\"> button. \r\n    Your screen should look similar to this: </p>\r\n  <p align=\"center\"><img src=\"images/screenshots/UpdateFederalTaxes.jpg\" ></p>\r\n  <p align=\"left\">3) Edit any or all of the necessary data in each category. </p>\r\n  <blockquote> \r\n  <div align=\"left\"> a) <strong>Enter the Annual Exemption Allowance.</strong> Amount \r\n    to be deducted from YEARLY wages PER EXEMPTION claimed.<br>\r\n    b) <strong>FICA > Max Wages.</strong> Maximum wages on \r\n    which Social Security tax is calculated.<br>\r\n    c) <strong>FICA > Employee %. </strong> Percentage of \r\n    wages deducted from employee pay for social security.<br>\r\n    d) <strong>FICA > Company %.</strong> Percentage of wages \r\n    employer contributes to social security on each employee.<br>\r\n    e) <strong>Medicare > Max Wages.</strong> Maximum wages \r\n    on which Medicare tax is calculated<br>\r\n    f) <strong>Medicare > Employee %. </strong> Percentage \r\n    of wages deducted from employee pay for Medicare.<br>\r\n    g) <strong>Medicare > Company %.</strong> Percentage \r\n    of wages employer contributes to Medicare on each employee<br>\r\n    h) <strong>Federal Unemployment Insurance (FUI or FUTA) Max Wages.</strong> \r\n     Maximum wages on which Federal Unemployment tax is calculated.<br>\r\n    i) <strong>Federal Unemployment Insurance Company %.</strong> \r\n    Percentage of Company contribution for Federal Unemployment Insurance. \r\n    <br>\r\n    j) <strong>Earned Income Credit. </strong> This is for low-income families to receive a tax credit on federal income tax. It is a credit that is applied \r\n    AFTER the regular income tax is calculated. Earned Income Credit (Single) <br>\r\n       __% of wages on annual earnings over $__. <br>\r\n    k) <strong>Earned Income Credit (Single) </strong>>\r\n $__ Tax for annual earnings over $__.<br>\r\n    l) <strong>Earned Income Credit (Single) </strong>> $__ Tax, \r\n    less __% of wages on annual earnings over $__.<br>\r\n    m) <strong>Earned Income Credit (Married)</strong> > __% of wages \r\n    on annual earnings over $__.<br>\r\n    n) <strong>Earned Income Credit (Married) </strong>> $__ Tax \r\n    for annual earnings over $__.<br>\r\n    o) <strong>Earned Income Credit (Married) ></strong> $__ Tax, \r\n    less __ % of wages on annual earnings over $__.</p></blockquote>\r\n  <p>4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to \r\n    save the changes.</p><br><br>',278),(302,25,'General Factors','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> General Factors</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_general_factors/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This chapter is where you set up your maximum pay, shift multipliers, vacation and sick leave benefits.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Setup Functions - Payroll.</p>\r\n<p>3) Click General Factors. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/GeneralBenefitsandDeductionsGeneralData.jpg\" ></p>\r\n<blockquote>\r\n<b>Minimum Wage:</b> Enter the current minimum wage rate.  This is needed to make sure pay rates are above the minimum and that tips as wages are calculated correctly.<br>\r\n<b>Multiplier for second shift:</b> If you have a wage differential for second shift work, enter the multiplier here.<br>\r\n<b>Multiplier for third shift:</b> If you have a wage differential for third shift work, enter the multiplier here (multiplied times regular pay).<br>\r\n<b>Maximum Pay/Hour Weekly:</b> This prevents users from being able to enter a higher than allowed wage into the employee records.<br>\r\n<b>Maximum Gross Pay for Weekly:</b> This prevents a single pay-check from exceeding the maximum allowed.<br>\r\n<b>Maximum Pay/Hour Bi-Weekly:</b> This prevents users from being able to enter a higher than allowed wage into the employee records.<br>\r\n<b>Maximum Gross Pay for Bi-Weekly:</b> This prevents a single pay-check from exceeding the maximum allowed.<br>\r\n\r\n<b>Maximum Pay/Hour Semi-Monthly:</b> This prevents users from being able to enter a higher than allowed wage into the employee records.<br>\r\n<b>Maximum Gross Pay for Semi-Monthly:</b> This prevents a single pay-check from exceeding the maximum allowed.<br>\r\n\r\n<b>Maximum Pay/Hour Monthly:</b> This prevents users from being able to enter a higher than allowed wage into the employee records.<br>\r\n<b>Maximum Gross Pay for Monthly:</b> This prevents a single pay-check from exceeding the maximum allowed.<br>\r\n<b>Sick Leave Hours Allowed per Year:</b> When paying employees, the system will check to see how much sick leave has accrued, and if not enough, it will not allow for paid sick leave.<br>\r\n<b>Maximum Sick Leave allowed to accrue:</b> This will prevent sick leave from being SAVED UP for multiple years, then used all at once.<br>\r\n<b>VACATION</b>\r\n<blockquote>\r\n<b>Years Before This Period</b> How long does an employee have to have worked with the company before they accrue vacation at the rate given on this line.<br>\r\n<b>Vacation Days/Year</b> How many vacation days are allowed per year in this time period.<br>\r\n<b>Max Vacation Days Allowed to Accrue</b> After accruing this many vacation days the employee cannot accrue any more until some of the days are used.<br>\r\n<b>Delete</b> Check this box to delete this line of vacation accrual information.<br>\r\n</blockquote>\r\n</blockquote>\r\n\r\n\r\n<p align=\"left\">4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> \r\n  button to save the changes.</p>',279),(303,22,'Sales/Pricing Unit Name','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales/Pricing Unit Name</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_unit_name/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Edit or Add to a list of pricing, stocking and purchasing unit names for selection when entering inventory items, creating purchase orders, creating sales orders or in the Shopping Cart.  </em>\r\n<p align=\"left\"><ol>\r\n<li> From the Main Menu, select <b><i>Inventory -> Setup-Inventory -> Sales/Pricing Unit Name</b></i>.</li></p>\r\n<p align=\"center\"> <b> OR </b></p> \r\n<li> From the Main Menu, select <b><i>Billing -> Setup-Receivables -> Sales/Pricing Unit Name</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/UnitNameUpdate.jpg\"> \r\n</ol>\r\n</p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit an Existing Sales/Pricing Unit Name</strong></font></div>\r\n<hr>\r\n<ol><p align=\"left\">\r\n<li> If you would like to edit existing Sales/Pricing Unit Names, click the \r\n  <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> <b>Edit</b> button. Your screen should look similar to this: </li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/UnitNameUpdate2.jpg\"> \r\n</p><p align=\"left\">\r\n<li> Make any changes to the Sales/Pricing Unit Name. </li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save your changes. </li></p>\r\n<li> Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> <b>Delete</b> button if you would like to delete that unit name.</li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to the previous screen without saving the changes. </li></p>\r\n<br></ol>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Add a New Sales/Pricing Unit Name</strong></font></div>\r\n<p align=\"left\"><hr>\r\n<ol>\r\n<li> Click the <img src=\"images/add.gif\"> <b>Add</b> button. Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/UnitNameAdd1.jpg\"></p>\r\n<p align=\"left\">\r\n<li> Enter the new Sales/Pricing Unit Name.</li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save the new entry. </li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to the previous screen without saving the changes.</li>\r\n</ol> <br> <br>\r\n',280),(304,22,'Sales Tax Exemption Reasons','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales Tax Exemption Reasons</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_sales_tax_exemption/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter to enter in the reasons why some of your \r\ncustomers do not get charged sales tax.  Examples: Non-profit Organization, Out of State or Church.</em>\r\n<p align=\"left\"><ol>\r\n<li> From the Main Menu, select <b><i>Billing -> Setup-Receivables -> Sales Tax Exemption Reasons</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/TaxExemptionUpdate.jpg\" ></p>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit an Existing Sales Tax Exemption Reason</strong></font></div>\r\n<p align=\"left\"><hr>\r\n<ol>\r\n<li> Select the Sales Tax Exemption Reason to be edited from the pull-down \r\n  list.</li></p>\r\n<li> Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> <b>Edit</b>  button. Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/TaxExemptionUpdate2.jpg\" ></p>\r\n<li> Update the description of the Sales Tax Exemption Reason.</li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save changes. </li></p>\r\n<li> Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> <b>Delete</b> button to delete the Sales Tax Exemption Reason. </li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to previous screen without saving the changes.</li></p>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add a New Sales Tax Exemption Reason</strong></font></div>\r\n<hr>\r\n<ol>\r\n<p align=\"left\">\r\n<li> Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> <b>Add</b> button. Your screen should look similar to this: </li></p> </p> \r\n<p align=\"center\"><img src=\"images/screenshots/TaxExemptionAdd.jpg\" ></p>\r\n<p align=\"left\">\r\n<li> Enter the SalesTax Exemption Reason.</li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save the Sales Tax Exemption Reason. </li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to the previous screen without saving.</li></p>\r\n</ol>',281),(305,11,'Orders -> Invoices','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Orders --> Invoices</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_orders_to_invoices/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Create Invoices from orders entered via Shopping Cart, or from Fulfillment/Service (Inventory) Order Entry section.</em>\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Fulfillment Processing -> Orders --> Invoices</b></i>. Your screen should look similar to this:</li></P>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/SelectGroup.jpg\"> </P>\r\n<p align=\"left\">\r\n<li> Select one of the invoice creation entries or one of the list entries using the Group pull-down list.</li></p>\r\n    <ol TYPE=\"a\">\r\n        <li> <b>Send All Unbilled Orders to Invoicing.</b> NOTE: This sends \r\n    all of the unbilled orders (both complete and partial shipments) to invoicing. </li></p>\r\n        <li> <b>Send Completed Unbilled Orders to Invoicing. </b>NOTE: This     sends only the completed unbilled orders to invoicing.</li></p>\r\n        <li> <b>List All Unbilled Orders.</b> Creates a list of all your unbilled     orders. (Handy for checking what invoices may be created)</li></p>\r\n        <li> <b>List Unbilled Completed Orders.</b> Creates a list of all your completed unbilled orders.  You can click on the Order Number to view the order. For this selection, your screen will look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrdersToInvoice2.jpg\"></p>\r\n<p align=\"left\">\r\n        <li> To return to the Orders --> Invoices screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n        </ol>\r\n\r\n<li> Select one of the <b>SEND ORDERS..</b> options, and click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> <b>Next</b> button.  Your screen should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrdersToInvoice.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li> Click on the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to the Orders ==> Invoices screen.\r\n<p align=\"center\"><b><big> OR</b></big>\r\n<p align=\"left\">\r\n\r\n<li> Click on the <img src=\"images/pdf.gif\"> <b>Print Invoices</b> button to display a PDF file containing all the invoices created. NOTE: The number in the paranthesis indicates how many invoices were created. </li></p>\r\n     <ol TYPE=\"a\">\r\n       <li> Click on the <img src=\"images/closewindow.gif\" width=\"30\" height=\"30\"> <b>Close Window</b> button to return to the Orders ==> Invoices screen.</li></p>\r\n     </ol>\r\n</ol>\r\n</div>',44),(307,12,'Item Add/Update','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Item Add/Update</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_item_AddUpdate/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Item Add/Update</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemM.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add New or Edit an Existing Item</strong></font></div>\r\n<hr>\r\n<li><b>Choose one of the following options:</b></li></p>\r\n      <ol TYPE=\"a\">\r\n             <li><b>ADD a new Inventory Item</b> - click on the <img src=\"images/add.gif\"> <b>Add</b> button. </li></p>             \r\n\r\n             <p><b>OR</b></p>\r\n\r\n             <li><b>EDIT an existing Inventory Item</b></li></p>\r\n                   <ol>\r\n                       <li><b>Item Name or Code â€“ ID: </b> Enter Item Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Item number directly into the box on the right. If you want to search by description, type of item, vendor, category, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n                      <li>Click on the <img src=\"images/edit.gif\"> <b>Edit</b> button to edit this item.</li></p>\r\n                  </ol>\r\n        </ol>\r\n\r\n<li>Whether EDITING or ADDING, your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemM6.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the information shown below.</b></p>\r\n       <ul>\r\n             <li><b>Item Code:</b> Identifying code (part number).</li></p>\r\n             <li><b>Description:</b> Full description of the Inventory Item.</li></p>\r\n             <li><b>Category:</b> Select the appropriate Item Category of product from the pull-down list. NOTE: Item Categories are created under Inventory Setup.  Item Categories allow you to group your Inventory Items in logical groups such as Paper Products, Hardware, Printer Supplies, etc.</li></p>\r\n            <li><b>Vendor:</b> You do NOT enter this at this time, but it is displayed for informational purposes.  It is the most RECENT vendor you used to purchase this item.</li></p>\r\n            <li><b>Item Family ID:</b> Enter an Item Code or use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button to search for the Item Code. Entering an Item Code associates the entered Item Code with the current Item Code in the Shopping Cart.  It does not tie the Item Codes together for stocking or pricing purposes.</li></p>\r\n            <li><b>Item Option Groups:</b> (This field does not appear on the Add screen. You must save the Added Item Code before attaching an Item Option Group). Click on the <img src=\"images/edit.gif\"> <b>Add/Update Options</b>  button.  See the <b>Selecting Item Option Groups</b> section below for instructions on using this feature.</li></p>\r\n           <li><b>Usage Unit:</b> Select a unit name from the pull down list. This is usually the smallest usage unit. Pricing unit can be different, but all your inventory counts will be in usage units. NOTE: Usage units are entered in Inventory Setup - Sales/Pricing Unit Names.</li></p>\r\n           <li><b>Price Unit:</b> Select a unit name from the pull down list. This is the unit for pricing. (An example might be usage unit of EACH, with a pricing unit of DOZEN). NOTE: Price units are entered in Inventory Setup - Sales/Pricing Unit Names.</li></p>\r\n          <li><b>Weight per Price Unit:</b> Used for freight calculations, this is the weight of one of the pricing units.</li></p>\r\n          <li><b>Usage Units per Price Unit:</b> How many usage units are contained in each price unit.  This is used for converting pricing quantities to usage quantities. If usage and pricing units are the same, this should be a 1 (one).</li></p>\r\n          <li><b>GL Inventory Account:</b> Enter the General ledger asset account number(or part of the number) or type the name (or part of the name) to lookup the account.  The Inventory system will increase this account when purchasing, decrease it when selling.</li></p>\r\n          <li><b>GL Sales Account:</b> Enter the General ledger sales account number(or part of the number) or type the name (or part of the name) to lookup the account.  This account is the Default GL Sales account for posting to General Ledger.</li></p>\r\n          <li><b>Item is Tax Exempt:</b> Place a checkmark in this box if your Item is Tax Exempt.</li></p>\r\n          <li><b>Composite Item:</b> Click on YES if this item is composed of other inventory items (an assembled piece, or a kit).  See the <b>Add/Update Component List for an Item</b> section below for instructions on using this feature.</li></p>\r\n          <li><b>Inactive:</b> When an item should no longer be sold, mark it as INACTIVE.</li></p>\r\n          <li><b>When Inactive Replace With:</b> If the item is no longer active and you want the system to automatically substitute with a different item on any future orders, enter the replacement item code (select from the drop-down list).</li></p>\r\n          <li><b>Description for Product Catalog:</b> For use when creating a product information sheet. If this description will be viewed with a Web browser, remember to enter the HTML formatting necessary for proper display.</li></p>\r\n          <li><b>Product Web Site:</b> Enter the WebSite associated with this product. Be sure to precede the URL address with \"http://\" or \"https://\".</li></p>\r\n          <li><b>URL/File for Product Sheet:</b> If you want to point to a file providing the information for the product bulletin. Click the <b>Browse</b> button to locate the desired file.</li></p>\r\n          <li><b>URL/File for Product Graphic:</b> For the Shopping Cart, you can select a picture that will be displayed on the Shopping Cart for this item.  Click the <b>Browse</b> button to locate the desired file.</li></p>\r\n          <li><b>Shopping Cart Item:</b> Check this box if this Item will be available on the Shopping Cart.</li></p>\r\n          <li><b>Shopping Cart Minimum Display Quantity:</b> Inventory counts below this level will not be displayed in the Shopping Cart.  This allows you to keep Items low in inventory from displaying in the Shopping Cart.</li></p>\r\n          <li><b>Search Category:</b> Select all Item Search Categories that apply to this Item.  See <b><i>Item Search Categories</i></b> in the Related Topics Help section for use of this feature. Click on the name of the category to see Level 2 categories.</li></p>\r\n          <li><b>Inventory Type:</b> Select one of the three types:  POD (Print on Demand), Physical (Raw materials), Finished goods (ready-to-sell item).</li></p>\r\n          <li><b>Inventory Stats:</b> Displayed at the bottom (when UPDATING) is current information about this item. You can click on any of the quantities to see the details about how those numbers were arrived at.  \"Committed\" represents items for which orders have been placed, but have not yet shipped. You can also click on <b>VIEW HISTORY</b> to see a month-by-month breakdown of purchases and sales.</li></p>\r\n           <li><b>View/Upload/Delete - Inventory Item Supplier Files: </b>Click on <b>Attaching Files</b> in the Related Topics section of this Help screen for instructions on using this feature.</li></p>\r\n     </ul></p>\r\n\r\n<li>To return to the previous screen WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li> </p>\r\n\r\n<li>To delete an Item, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button(only available when UPDATING an item).</li> </p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b>  button. </li></p>\r\n\r\n<li>To add new or edit locations (and stocking information), click on the <img src=\"images/addlocation.gif\"> <b>Add/Edit Location</b> button.  See the <b>Add/Update a Location</b> section below for instructions on using this feature.</li> </p>\r\n\r\n<li>To add/edit Components on a Composite Item, click on the <img src=\"images/addcomponent.gif\"> <b>Add/Edit Component</b> button (this button only appears when Composite Item is set to YES). This is where you attach the components making up the Composite Item. See the <b>Add/Update Component List for an Item</b> section below for instructions on using this feature.</li></p>\r\n\r\n<li>To specify supplier(s) for this item and the prices these suppliers charge for this item, click on the <img src=\"images/View2.gif\"> <b>Item Supplier Update/Add</b> button.</li></p>\r\n</ol>\r\n\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><hr>\r\n<strong>Selecting Item Option Groups for an Item</strong></font></div>\r\n<hr><br>\r\n<em>Item Option Groups can be attached to an Inventory Item to give the customer choices when ordering the item.  Examples are Color Choices, Motor Sizes, Gift Wrapping options, or other related Inventory Items that may be used with this item.</em>\r\n<ol>\r\n<li>Click on the <img src=\"images/edit.gif\"> <b>Item Option Groups</b> button from the Item Add/Update screen. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemOptionGroup1.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>All Item Option Groups defined in Inventory Setup will be displayed. See <b>Item Option Groups</b> in the Related Topics Help Section for further information on defining Item Option Groups.</li></p>\r\n    <ol TYPE=\"a\">\r\n          <li><b>Order- </b> Enter the position number in the list where you want this group to display.</li>\r\n          <li><b>Add - </b>Check this box to select this Item Options Group.</li>\r\n          <li><b>Name - </b>Name of the Item Options Group.  Click on the Name to view Items Options Group details.</li>\r\n      </ol></p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b>  button.</li></p>\r\n\r\n<li>To return to the Item Add/Update screen, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n</ol>\r\n<hr><br>\r\n\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add/Update a Location for an Item</strong></font></div>\r\n<hr>\r\n<em>Locations are attached to an Item to identify its physical location and ship-point.  Stocking levels, reorder points, pricing levels and current quantities on-hand are available on this screen.</em>\r\n<ol>\r\n<li>Click on the <img src=\"images/addlocation.gif\"> <b>Add/Update Location</b> button on the Item Add/Update screen. Your screen should look similar to this: \r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemLocationAddUpdate.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Select the <b>Location</b> from the pull-down list. </li></p>\r\n\r\n<li>Click the <img src=\"images/edit.gif\"> <b>Edit</b> button. Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemM9.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Make any necessary changes to the data.</b></li></p>\r\n      <ol TYPE=\"a\">\r\n             <li><b>Markup Set:</b> If you want the selling price to be calculated automatically based on the purchase cost, you will want to use a markup set. These are set up under Inventory Setup. If you leave this entry as 0=No Automatic Pricing, then prices MUST be entered under the Price Level/Sell Price section further down on the screen.</li></p>\r\n             <li><b>Stocking Levels:</b> For each season (you can specify up to four selling seasons during which stocking levels can vary), you can indicate the Maximum stocking level, the Minimum stocking level, and the Reorder Quantity.</li></p>\r\n             <li><b>Sell Price/unit:</b> For each of up to five different pricing levels (defined under inventory setup) you can have a selling price. However, if you use a markup set to automatically calculate these prices, you will NOT enter anything here.</li></p>\r\n             <li><b>Discount Percent / On Quantities Over:</b> In order to allow for discounts on larger sales, enter the percentage of discount, and the break-point for when this new discount kicks in.</li></p>\r\n             <li><b>Status:</b> This is information about THIS LOCATION ONLY (on the main item screen it covers ALL locations. Click on the <b>On-Hand quantity</b> to see the transactions representing this number. First/Mid/Last are PURCHASE costs and quantities.</li></p>\r\n       </ol></p>\r\n\r\n<li>To return to the Item Add/Update screen WITHOUT saving your changes, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b>  button. </li></p>\r\n\r\n<li>To delete the location informtion(only available if editing), click on the <img src=\"images/delete.gif\"> <b>Delete</b> button. </li></p>\r\n</ol>\r\n<br><hr><br>\r\n</p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add/Update Component List for an Item</strong></font></div>\r\n<hr>\r\n<em>Create a list of parts that make up this kit, catalog or assembly.</em><br>\r\n<br>\r\n<ol>\r\n<li>Click on the <img src=\"images/addcomponent.gif\"> <b>Add/Edit Component</b> button on the Item Add/Update screen. Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_CompositeItemComponentList.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Add Items to or Remove Items from this list:</b> </li></p>\r\n     <ol TYPE=\"a\">\r\n            <li><b>Item to Add or Remove: </b>Enter the Item Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Item number directly into the box on the right. If you want to search by description, type of item, vendor, category, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n            <li><b>Quantity Required:(if adding to the list) </b>Enter the number of units of this item it requires to complete the Composite Item.</li></p>\r\n           <li>Click the <img src=\"images/addremove.gif\"> <b>Add/Remove</b> button. Your item will be added to/deleted from the Component Items Already Selected list.</li> </p>\r\n       </ol>\r\n\r\n    <li>To return to the Item Add/Update screen, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n\r\n<br><hr><br>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add/Update Suppliers for this Item</strong></font></div>\r\n<hr>\r\n<ol>\r\n<li>Click the Item Supplier Update/Add Button. Your screen will look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemSupplierAddUpdate.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Select an existing supplier from the drop-down list and click the <img src=\"images/edit.gif\"> <b>Edit</b> button, OR to add a new supplier for this item, click on the <img src=\"images/add.gif\"> <b>Add</b> button. The screen will change to something similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemSupplierAddUpdate1.jpg\"> </p>\r\n<p align=\"left\">\r\n<li><b>Enter the following information:</b></li></p>\r\n       <ol TYPE=\"a\">\r\n          <li><b>Vendor Product Code:</b> The part number the vendor uses (used when writing purchase orders to this vendor).</li>\r\n          <li><b>Purchase Unit:</b> Select a unit name from the drop-down list (ex: stock in each, price by the dozen, purchase by the gross).</li>\r\n          <li><b>Number of usage units in each Purchase unit:</b> Needed to do the conversions when purchasing.</li>\r\n          <li><b>Cost - Up to this Quantity:</b> Usual prices charged by this vendor at different quantities purchased.</li>\r\n      </ol>\r\n<p></p>\r\n<li>Click the <img src=\"images/back.gif\"> <b>Back</b> button to return to the previous screen.</li></p>\r\n<li> Click the <img src=\"images/save.gif\"> Save button to save the new item.</li></p>\r\n<li>If updating, you can click on the <img src=\"images/delete.gif\"> Delete button to delete this vendor as a supplier of this item.</li></p>\r\n\r\n</ol>\r\n',284),(308,12,'Item Activity','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Item Activity</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_itemActivity/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>The Item Activity Report provides you with the Item Code, Description, beginning quantity on-hand, quantity received, quantity used/sold, quantity adjusted and ending on-hand quantity so you can follow the flow of your inventory for a specific time period. </em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Item Activity</b></i>. </li></p>\r\n<li>Your screen should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemAct1.jpg\"></p>\r\n<p align=\"left\"\r\n\r\n<li><b>Enter information in the following categories to narrow your report:</b> </li></p>\r\n      <ol TYPE=\"a\">\r\n            <li><b>Category: </b>Select the item category from the pull-down list.</li> </p>\r\n            <li><b>Item Code Range: </b>Enter a part number or a range of numbers you would like to view.</li> </p>\r\n            <li><b>Inventory Type: </b>Select ALL or the specific Inventory Type you would like to view.</li></p>\r\n            <li><b>Sort By: </b>You have an option how you would like to view the information. You may choose to sort the report by the Item Code or by the Description.</li></p>\r\n            <li><b>Results Per Page: </b>You can also select the number of items you would like to view per page from the pull-down list.</li></p>\r\n            <li><b>Begin and End Period: </b>Select the start date and end date for activity to be included in the report, or click on the <img src=\"images/calendar.gif\"> <b>Calendar</b> button select a date from the calendar. </li></p>\r\n            <li><b>Location: </b>Select ALL Locations or select a specific location from the pull-down list.</li></p>\r\n       </ol>\r\n\r\n<li>To view the report, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemAct2.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>To view more information, click on the <b>Item Code</b> (for ALL activity)or any of the <b>quantity numbers</b>. For example, click the Quantity Used/Sold to view a break-down list of individual sales.</li> </p>\r\n\r\n<li>If this report spans more than one page, use the <img src=\"images/Back2.gif\" width=\"20\" height=\"20\"> <b>Back</b> and <img src=\"images/next.gif\" width=\"20\" height=\"20\"> <b>Next</b> buttons to go forward or back through the pages.</li></p>\r\n\r\n<li>To return to the report definition screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n</ol>',285),(309,12,'Item Valuation','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Item Valuation Report</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_itemValuation/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this report to calculate the total investment in inventory.</em>\r\n<ol>\r\n\r\n<li>From the Main Menu, select <b><i>Inventory -> Reports -> Item Valuation</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Valuation.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data into the following categories to narrow your report: </b> </li>\r\n     <ol TYPE=\"a\">\r\n          <li><b>Location: </b>Select the Location from the pull down menu or ALL for to include all locations. </li></p>\r\n          <li><b>Sort by: </b>Select how you would like the report sorted from the Sort By pull-down list.</li></p>\r\n          <li><b>Cost: </b>Select the cost basis for calculating values from the Cost pull-down list (First Cost, Mid Cost or Last Cost).</li></p>\r\n          <li><b>Price Level: </b>Select the Price Level for calculating the total sales value from the pull-down list.</li></p>\r\n          <li><b>Category: </b>Select ALL to include all categories or select a specific Category for the pull-down list.</li></p>\r\n         <li><b>Page Size:</b>Enter the number of Items you would want to see on one page.</li></p>\r\n    </ol>\r\n<li>To view your results, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<b><i>Note: The number of items and the current page number are displayed at the top of the report.  A \"Back\" button is provided at the top as well to make navigation of a lengthy report easier.</b></i></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Valuation2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen to create a different report, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To export the report into Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> button at the bottom of the screen. </li></p>\r\n\r\n<li>To view the details of the on-hand quantity, click on the number shown in the <b>Quantity</b> column.  The details screen looks similar to this:</li></p>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Valuation3.jpg\"></p>\r\n<p align=\"left\">\r\n    <ol TYPE=\"a\">\r\n         <li>To export the report into Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> button. </li></p>\r\n         <li>To return to the Item Valuation Report, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n    </ol>\r\n</ol>',286),(310,12,'Adjustments','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Item Adjustments</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_Adjustments/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this screen to make adjustments to Inventory levels.</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Item Adjustments</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryAdjustmentsMain.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data into the following categories to narrow your selections:</b></li></p>\r\n    <ol TYPE=\"a\">\r\n         <li> <b>Category: </b>Select the Category from the pull-down list(or leave selection at NONE for all categories).</li></p>\r\n         <li><b>Item Code Range: </b>Enter beginning and ending Item Codes to narrow your selections, if needed.</li></p>\r\n         <li><b>Inventory Type: </b>Select ALL or choose an Inventory Type from the pull-down list.</li></p>\r\n         <li><b>Sort By: </b>Select to sort by either Item Code or Description.</li></p>\r\n         <li><b>Results Per Page: </b>Select how many Items Per Page you would like to see using the pull-down list.</li></p>\r\n         <li><b>Location: </b>Select a Location using the pull-down list. </li></p>\r\n      </ol>\r\n\r\n<li>To produce the requested list of items, click the <img src=\"images/next.gif\"> <b>Next</b> button.Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryAdjustments.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To enter an Adjustment Quantity for an item, click on the <b>Item Description</b>. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryAdjustments1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>Enter the quantity increase or decrease in the <b>Adjustment Amount</b> column and enter <b>Comments</b> if desired.</li></p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button. </li></p>\r\n\r\n<li>To return to the previous screen WITHOUT saving your changes, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button. </li></p>\r\n',287),(311,15,'Check List','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Check List</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_check_lists/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this chapter to see a list of checks you wrote between certain dates to see if they have been cashed or voided.</em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Reports -> Check List</b></i>.</li></p>\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/APCheckList.jpg\"</p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data in the following categories:</b></p>\r\n      <ol TYPE=\"a\"> \r\n          <li><b>Check#: </b>Enter a check# to see a single check or leave BLANK  to see all checks.</li></p>\r\n          <li><b>Invoice#: </b>Enter an Invoice# to see all checks for that invoice or leave BLANK to see all invoices.</li></p>\r\n          <li><b>Vendor Name â€“ ID: </b>Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n          <li><b>Checking Account: </b>Select a checking account from the pull-down list. NOTE: Only shows if you have more than one checking account.</li></p>\r\n          <li><b>Cashed? </b>Choose either <b>All, Show only Cashed</b> (as a verification of cashed totals equaling bank statement totals of cashed for the period), or <b>Show Only Uncashed</b> (to use a a report of remaining uncashed to use when verifying your bank balance).</li></p> \r\n          <li><b>Include Voids? </b>Check this box to have the report include any voided checks in the group.</li></p>\r\n          <li><b>Order: </b>Select the sort order desired from the pull-down list. </li></p>\r\n          <li><b>Begin Date of Checks: </b>This is the check date unless you select SHOW CASHED ONLY as the group in which case it uses the CASHED DATE. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select a date from the calendar.</li></p>\r\n          <li><b>End Date of Checks: </b>This is the check date unless you select SHOW CASHED ONLY as the group in which case it uses the CASHED DATE.  You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select a date from the calendar.</li></p>\r\n     </ol>\r\n\r\n<li>To view the checks meeting the criteria you entered above, click the <img src=\"images/next.gif\">  <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/APCheckList2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<em><b>If the vendor name is followed by \"(pr)\" then this is a payroll check. Payroll checks must be voided through the payroll system. Payables checks have an \"(ap)\" after the vendor name.</b></em><br>\r\n<br>\r\n<li>To sort the displayed report, click on any of the column headers to sort by that field.</li></p>\r\n\r\n<li>To reprint a check, click on the <font color=\"0000FF\">Check #</font>.  For more information on viewing checks, see the <b><i>View/Cancel Accounts Payable Checks</b></i> in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button.</li></p>\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n</ol>',288),(312,33,'I cant get my pdf documents to print out or the Excel downloads to work?','Its a permissions issue. Go to the Nola Pro directory in Windows Explorer, right click on the Uploads folder, then click on Properties. Next, click in the Security tab. Under Permissions, allow the user full permission. Then click OK. \r\n\r\n',289),(313,33,'How do I first login?','After you have installed Nola-Pro, open your browser and type http://localhost in the directory. Use admin for your login and password for your password. Once you\'re in the program, you can set up user rights for yourself and all your employees. \r\n\r\n',290),(314,33,'Do I have to have a dedicated server to run NOLA-Pro?','No, NOLA-Pro will install and run just fine on a shared server',291),(315,33,'Why is it when I go to the URL for my trial website the screen appears blank?','You must enable pop-ups for your browser to view Nola-Pro.\r\n\r\n',292),(317,33,'I am having problems logging in after installing, what can I do?','1) Make sure you have cookies enabled on your browser. \r\n2) Make sure SESSION.AUTO_START=1 in the PHP.INI file. \r\n3) If you have \'LOGIN_CASE_INSENSITIVE\' set 1 in your defines.php file (in includes directory) , you need to enter your password using the correct CASE. \r\n4) If you have an older version of NOLA, \'LOGIN_CASE_INSENSITIVE\' does not work when set to 1. Update, or change to 0. \r\n',293),(318,33,'My navigation bar is all squashed up against the side and unevenly spaced, how do I fix it?','You may be working with an outdated version of your browser. Try going updating your Internet Explorer (works best with IE 6 or later) or Netscape Navigator to the latest version of the product. \r\n\r\n',294),(319,33,'Can Nola-Pro handle multi-company consolidations?','Yes, you can specify as many companies as you like with Nola-Pro Enterprise version.\r\n\r\nThe consolidation point comes in General Ledger Balance Sheet, where you can specify a joint or separate balance sheet for the companies in the system.\r\n\r\n\r\n',295),(320,33,'What is an Accounting System?','<p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Accounting \r\n            is the method in which financial information is gathered, processed, \r\n            and summarized into financial statements and reports. An accounting \r\n            system can be represented by the following graphic, which is explained \r\n            below. </font></p>\r\n          <p align=\"center\"><font face=\"Arial, Helvetica, sans-serif\"><img src=\"images/screenshots/acctsystem.gif\" width=\"600\" height=\"371\"></font></p>\r\n          <ol>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Every accounting entry \r\n              is based on a <font color=\"#000066\"><strong>business transaction</strong>,</font> \r\n              which is usually evidenced by a business document, such as a check \r\n              or a sales invoice.<br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">A <font color=\"#000066\"><strong>journal</strong></font> \r\n              is a place to record the transactions of a business. The typical \r\n              journals used to record the chronological, day-to-day transactions \r\n              are sales and cash receipts journals and a cash disbursements journal. \r\n              A general journal is used to record special entries at the end of \r\n              an accounting period.<br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">While a journal records \r\n              transactions as they happen, a <strong><font color=\"#000066\">general \r\n              ledger</font></strong> groups transactions according to their type, \r\n              based on the accounts they affect. The general ledger is a collection \r\n              of all balance sheet, income, and expense accounts used to keep \r\n              a business\'s accounting records. At the end of an accounting period, \r\n              all journal entries are summarized and transferred to the general \r\n              ledger accounts. This procedure is called \"posting.\"</font> \r\n              <font face=\"Arial, Helvetica, sans-serif\"><br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">A <font color=\"#000066\"><strong>trial \r\n              balance</strong></font> is prepared at the end of an accounting \r\n              period by adding up all the account balances in your general ledger. \r\n              The sum of the debit balances should equal the sum of the credit \r\n              balances. If total debits don\'t equal total credits, you must track \r\n              down the errors. <br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"> Finally, <strong><font color=\"#000066\">financial \r\n              statements</font></strong> are prepared from the information in \r\n              your trial balance. </font> \r\n              <p><font face=\"Arial, Helvetica, sans-serif\">Your accounting records \r\n                are important because the resulting financial statements and reports \r\n                help you plan and make decisions. They may be used by some third \r\n                parties (bankers, investors, or creditors) and are needed to provide \r\n                information to government agencies, such as the Internal Revenue \r\n                Service.<br>\r\n                </font></p>\r\n\r\n',296),(321,33,'What are Debits & Credits?','\r\n          <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">These are \r\n            the backbone of any accounting system. Understand how debits and credits \r\n            work and you\'ll understand the whole system. Every accounting entry \r\n            in the general ledger contains both a debit and a credit. Further, \r\n            all debits must equal all credits. If they don\'t, the entry is out \r\n            of balance. That\'s not good. Out-of-balance entries throw your balance \r\n            sheet out of balance. </font></p>\r\n          <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Therefore, \r\n            the accounting system must have a mechanism to ensure that all entries \r\n            balance. Indeed, most automated accounting systems won\'t let you enter \r\n            an out-of-balance entry-they\'ll just beep at you until you fix your \r\n            error. </font></p>\r\n          <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Depending \r\n            on what type of account you are dealing with, a debit or credit will \r\n            either increase or decrease the account balance. The table below illustrates \r\n            the entries that increase or decrease each type of account. </font></p>\r\n          <p align=\"left\">&nbsp;</p>\r\n          <table width=\"600\" border=\"1\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" bordercolor=\"#000066\">\r\n            <tr align=\"center\" valign=\"middle\" bgcolor=\"#000066\"> \r\n              <td><strong><font color=\"#FFFFFF\" face=\"Arial, Helvetica, sans-serif\">Account</font></strong></td>\r\n              <td><strong><font color=\"#FFFFFF\" face=\"Arial, Helvetica, sans-serif\">Increase</font></strong></td>\r\n              <td><strong><font color=\"#FFFFFF\" face=\"Arial, Helvetica, sans-serif\">Decrease</font></strong></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Assets</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Debit \r\n                    +</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Credit \r\n                    -</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Cost \r\n                    of Goods Sold</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Debit \r\n                    +</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Credit \r\n                    -</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Expenses</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Debit \r\n                    +</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Credit \r\n                    - </font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Liabilities</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Credit \r\n                    - </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Debit \r\n                    +</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Capital</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Credit \r\n                    -</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Debit \r\n                    +</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Retained \r\n                    Earnings</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Credit \r\n                    -</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Debit \r\n                    +</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Sales \r\n                    &amp; Adjustments</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Credit \r\n                    -</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Debit \r\n                    +</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Other \r\n                    Income &amp; Expenses </font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Credit \r\n                    -</font></p>\r\n                </blockquote></td>\r\n              <td><blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Debit \r\n                    +</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n          </table>\r\n          <p align=\"left\">&nbsp;</p>\r\n          <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Notice that \r\n            for every increase in one account, there is an opposite (and equal) \r\n            decrease in another. That\'s what keeps the entry in balance. </font></p>\r\n          <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Let\'s take \r\n            a look at two sample entries and try these debits and credits: </font></p>\r\n          <blockquote> \r\n            <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\"><em>Example:</em></font></p>\r\n            <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\"> In the \r\n              first stage of the example we\'ll record a credit sale: </font></p>\r\n            <blockquote> \r\n              <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Accounts \r\n                Receivable $1,000 <br>\r\n                Sales Income $1,000</font></p>\r\n            </blockquote>\r\n            <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">If you looked \r\n              at the general ledger right now, you would see that receivables \r\n              had a balance of $1,000 and income also had a balance of $1,000. \r\n              </font></p>\r\n            <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Now we\'ll \r\n              record the collection of the receivable: </font></p>\r\n            <blockquote> \r\n              <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Cash $1,000 \r\n                <br>\r\n                Accounts Receivable $1,000 </font></p>\r\n            </blockquote>\r\n            <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Notice how \r\n              both parts of each entry balance? See how in the end, the receivables \r\n              balance is back to zero? That\'s as it should be once the balance \r\n              is paid. The net result is the same as if we conducted the whole \r\n              transaction in cash:</font></p>\r\n            <blockquote> \r\n              <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\"> Cash \r\n                $1,000 <br>\r\n                Sales Income $1,000 </font></p>\r\n            </blockquote>\r\n            <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Of course, \r\n              there would probably be a period of time between the recording of \r\n              the receivable and its collection. </font></p>\r\n          </blockquote>\r\n          <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">That\'s it. \r\n            Accounting doesn\'t really get much harder. Everything else is just \r\n            a variation on the same theme. Make sure you understand debits and \r\n            credits and how they increase and decrease each type of account. <br>\r\n            </font></p>\r\n          ',297),(322,33,'What is a Balance Sheet?','<p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">A balance \r\n            sheet is a snapshot of a business financial condition at a \r\n            specific moment in time, usually at the close of an accounting period. \r\n            A balance sheet comprises assets, liabilities, and owners&#8217; or \r\n            stockholders&#8217; equity. Assets and liabilities are divided into \r\n            short- and long-term obligations including cash accounts such as checking, \r\n            money market, or government securities. At any given time, assets \r\n            must equal liabilities plus owners&#8217; equity. An asset is anything \r\n            the business owns that has monetary value. Liabilities are the claims \r\n            of creditors against the assets of the business. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong><em>Hint:</em></strong> \r\n            Increase assets with a debit and decrease them with a credit. Increase \r\n            liabilities with a credit and decrease them with a debit.</font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">The balance sheet <u>must</u> \r\n            balance&#8212;that\'s why it\'s called a balance sheet. In other words, \r\n            the assets must equal the claims on assets. The concept of balancing \r\n            relies on the accounting equation:</font></p>\r\n          <p align=\"center\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\"><strong>Assets \r\n            = Liabilities + Owner&#8217;s Equity (Capital)</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">The accounting equation \r\n            is an essential notion in accounting. The equation derives from assets \r\n            and claims on assets: </font></p>\r\n          <table width=\"600\" border=\"1\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" bordercolor=\"#000066\">\r\n            <tr align=\"left\" valign=\"middle\" bgcolor=\"#000066\"> \r\n              <td><div align=\"center\"><strong><font color=\"#FFFFFF\">Assets</font></strong></div></td>\r\n              <td><div align=\"center\"><strong><font color=\"#FFFFFF\">Claims on \r\n                  Assets</font></strong></div></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td rowspan=\"2\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">What \r\n                a company owns</font></td>\r\n              <td><p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Liabilites:</font></p>\r\n                <blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">What \r\n                    a company owes</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Owner\'s \r\n                  Equity:</font></p>\r\n                <blockquote> \r\n                  <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Claims \r\n                    of owners against the business</font></p>\r\n                </blockquote></td>\r\n            </tr>\r\n          </table>\r\n          <p>&nbsp;</p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong>What a Balance \r\n            Sheet is Used For</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">A balance sheet helps a \r\n            small business owner quickly get a handle on the financial strength \r\n            and capabilities of the business. Is the business in a position to \r\n            expand? Can the business easily handle the normal financial ebbs and \r\n            flows of revenues and expenses? Or should the business take immediate \r\n            steps to bolster cash reserves? </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Balance sheets can identify \r\n            and analyze trends, particularly in the area of receivables and payables. \r\n            Is the receivables cycle lengthening? Can receivables be collected \r\n            more aggressively? Are some debts uncollectable? Has the business \r\n            been slowing down payables to forestall an inevitable cash shortage? \r\n            </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Balance sheets, along with \r\n            income statements, are the most basic elements in providing financial \r\n            reporting to potential lenders such as banks, investors, and vendors \r\n            who are considering how much credit to grant the firm.</font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><br>\r\n            </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong>Identifying Assets</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Simply stated, assets are \r\n            those things of value that your company owns. The cash in your bank \r\n            account is an asset. So is the company car you drive. Assets are the \r\n            objects, rights and claims owned by and having value for the firm. \r\n            </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Assets are subdivided into \r\n            current and long-term assets to reflect the ease of liquidating each \r\n            asset. Cash, for obvious reasons, is considered the most liquid of \r\n            all assets. Long-term assets, such as real estate or machinery, are \r\n            less likely to sell overnight or have the capability of being quickly \r\n            converted into a current asset such as cash.</font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Since your company has \r\n            a right to the future collection of money, accounts receivable are \r\n            an asset-probably a major asset, at that. The machinery on your production \r\n            floor is also an asset. If your firm owns real estate or other tangible \r\n            property, those are considered assets as well. If you were a bank, \r\n            the loans you make would be considered assets since they represent \r\n            a right of future collection. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">There may also be intangible \r\n            assets owned by your company. Patents, the exclusive right to use \r\n            a trademark, and goodwill from the acquisition of another company \r\n            are such intangible assets. Their value can be somewhat hazy. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Generally, the value of \r\n            intangible assets is whatever both parties agree to when the assets \r\n            are created. In the case of a patent, the value is often linked to \r\n            its development costs. Goodwill is often the difference between the \r\n            purchase price of a company and the value of the assets acquired (net \r\n            of accumulated depreciation). </font></p>\r\n          <p> <font face=\"Arial, Helvetica, sans-serif\"><br>\r\n            Some basic assets and claims on assets:</font></p>\r\n          <table width=\"600\" border=\"1\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" bordercolor=\"#000066\">\r\n            <tr align=\"center\" valign=\"middle\" bgcolor=\"#000066\"> \r\n              <td width=\"217\"><strong><font color=\"#FFFFFF\">Assets</font></strong></td>\r\n              <td colspan=\"2\"><strong><font color=\"#FFFFFF\">Claims on Assets</font></strong></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td colspan=\"3\"><div align=\"center\"><strong><font color=\"#000066\">Assets \r\n                  &nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; =&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; \r\n                  &nbsp;&nbsp;Liabilities &nbsp;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp; \r\n                  + &nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Owner\'s Equity</font></strong></div></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Cash</font></td>\r\n              <td width=\"184\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Accounts \r\n                Payable</font></td>\r\n              <td width=\"191\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Preferred \r\n                Stock</font></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Inventories</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Wages \r\n                Payable</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Common \r\n                Stock</font></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Building</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Taxes \r\n                Payable</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Capital \r\n                Surplus</font></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Land</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Notes \r\n                Payable</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Retained \r\n                Earnings</font></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Equipment</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Bonds \r\n                Payable</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Accounts \r\n                Recievable</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Intermediate \r\n                Term Debt</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"middle\"> \r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Marketable \r\n                Securities</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n              <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n            </tr>\r\n          </table>\r\n          <p>&nbsp;</p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong>Identifying Liabilities</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"> Think of liabilities as \r\n            the opposite of assets. These are the obligations of one company to \r\n            another. Accounts payable are liabilities, since they represent your \r\n            company\'s future duty to pay a vendor. So is the loan you took from \r\n            your bank. If you were a bank, your customer\'s deposits would be a \r\n            liability, since they represent future claims against the bank. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">We segregate liabilities \r\n            into short-term and long-term categories on the balance sheet. This \r\n            division is nothing more than separating those liabilities scheduled \r\n            for payment within the next accounting period (usually the next twelve \r\n            months) from those not to be paid until later. We often separate debt \r\n            like this. It gives readers a clearer picture of how much the company \r\n            owes and when.</font><font face=\"Arial, Helvetica, sans-serif\"><br>\r\n            </font></p>\r\n          <p>&nbsp;</p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong>Owners\' Equity</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">After the liability section \r\n            in both the chart of accounts and the balance sheet comes owners\' \r\n            equity. This is the difference between assets and liabilities. Hopefully, \r\n            its positive-assets exceed liabilities and we have a positive owners\' \r\n            equity. In this section we\'ll put in things like Partners\' capital \r\n            accounts, Stock, and Retained earnings. <br>\r\n            Hint: Owners\' equity is increased and decreased just like a liability: \r\n            Debits decrease. Credits increase <br>\r\n            By the way, retained earnings are the accumulated profits from prior \r\n            years. At the end of one accounting year, all the income and expense \r\n            accounts are netted against one another, and a single number (profit \r\n            or loss for the year) is moved into the retained earnings account. \r\n            This is what belongs to the company\'s owners-that\'s why it\'s in the \r\n            owners\' equity section. The income and expense accounts go to zero. \r\n            That\'s how we\'re able to begin the new year with a clean slate against \r\n            which to track income and expense. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">The balance sheet, on the \r\n            other hand, does not get zeroed out at year-end. The balance in each \r\n            asset, liability, and owners\' equity account rolls into the next year. \r\n            So the ending balance of one year becomes the beginning balance of \r\n            the next. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Think of the balance sheet \r\n            as today\'s snapshot of the assets and liabilities the company has \r\n            acquired since the first day of business. The income statement, in \r\n            contrast, is a summation of the income and expenses from the first \r\n            day of this accounting period (probably from the beginning of this \r\n            fiscal year). </font></p>\r\n          <p>&nbsp;</p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"> <strong>Income and Expenses</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Further down in the chart \r\n            of accounts (usually after the owners\' equity section) come the income \r\n            and expense accounts. Most companies want to keep track of just where \r\n            they get income and where it goes, and these accounts tell you.</font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong><em>Hint:</em></strong> \r\n            For income accounts, use credits to increase them and debits to decrease \r\n            them. For expense accounts, use debits to increase them and credits \r\n            to decrease them.</font></p>\r\n          <p>&nbsp;</p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong>Income Accounts</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">If you have several lines \r\n            of business, you\'ll probably want to establish an income account for \r\n            each. In that way, you can identify exactly where your income is coming \r\n            from. Adding them together yields total revenue. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Typical income accounts \r\n            would be:</font></p>\r\n          <ul>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"> Sales revenue from \r\n              product A </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Sales revenue from product \r\n              B (and so on for each product you want to track) </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Interest income </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Income from sale of \r\n              assets </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Consulting income </font></li>\r\n          </ul>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Most companies have only \r\n            a few income accounts. That\'s really the way you want it. Too many \r\n            accounts are a burden for the accounting department and probably don\'t \r\n            tell management what it wants to know. Nevertheless, if there\'s a \r\n            source of income you want to track, create an account for it in the \r\n            chart of accounts and use it.</font></p>\r\n          <p>&nbsp;</p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong>Expense Accounts</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Most companies have a separate \r\n            account for each type of expense they incur. Your company probably \r\n            incurs pretty much the same expenses month after month, so once they \r\n            are established, the expense accounts won\'t vary much from month to \r\n            month. Typical expense accounts include </font></p>\r\n          <ul>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Salaries and wages </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Telephone</font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"> Electric utilities \r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Repairs </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Maintenance </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Depreciation </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Amortization </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Interest </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Rent </font></li>\r\n          </ul>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><br>\r\n            </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong>Balance Sheet Quick \r\n            Reference</strong> </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong>Assets</strong> \r\n            are subdivided into current and long-term assets to reflect the ease \r\n            of liquidating each asset. Cash, for obvious reasons, is considered \r\n            the most liquid of all assets. Long-term assets, such as real estate \r\n            or machinery, are less likely to sell overnight or have the capability \r\n            of being quickly converted into a current asset such as cash.</font></p>\r\n          <ol>\r\n            <li><strong><font face=\"Arial, Helvetica, sans-serif\">Current Assets</font></strong><font face=\"Arial, Helvetica, sans-serif\"> \r\n              are any assets that can be easily converted into cash within one \r\n              calendar year. There are five main kinds of current assets: Cash \r\n              &amp; Equivalents, Short and Long-Term Investments, Accounts Receivable, \r\n              Inventories and Prepaid Expenses that are due within one year&#8217;s \r\n              time. (<em><strong>Note:</strong></em> These are the main assets, \r\n              your accounting system may contain other assets.)</font> <br>\r\n              <ul>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\"> Cash is money available \r\n                  immediately, such as in checking accounts, is the most liquid \r\n                  of all short-term assets.</font></li>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\"> Accounts Receivables \r\n                  is money owed to the business for purchases made by customers, \r\n                  suppliers, and other vendors. </font></li>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\">Notes Receivables \r\n                  that are due within one year are current assets. Notes that \r\n                  cannot be collected on within one year should be considered \r\n                  long-term assets. <br>\r\n                  </font></li>\r\n              </ul>\r\n            </li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Fixed (Long-term) \r\n              Assets</strong> include land, buildings, machinery, and vehicles \r\n              that are used in connection with the business. <br>\r\n              &middot; Land is considered a fixed asset but, unlike other fixed \r\n              assets, is not depreciated, because land is considered an asset \r\n              that never wears out. <br>\r\n              </font> </li>\r\n            <ul>\r\n              <li><font face=\"Arial, Helvetica, sans-serif\">Buildings are categorized \r\n                as fixed assets and are depreciated over time. </font></li>\r\n              <li><font face=\"Arial, Helvetica, sans-serif\">Office equipment includes \r\n                equipment such as copiers, fax machines, printers and computers \r\n                used in your business are fixed assets and are depreciated over \r\n                time. </font></li>\r\n              <li><font face=\"Arial, Helvetica, sans-serif\">Machinery used in \r\n                your plant to produce your product are fixed assets and are depreciated \r\n                over time. Examples of machinery might include lathes, conveyor \r\n                belts, or a printing press. </font></li>\r\n              <li><font face=\"Arial, Helvetica, sans-serif\">Vehicles include any \r\n                vehicles used in your business are fixed assets and are depreciated \r\n                over time. </font></li>\r\n              <li><font face=\"Arial, Helvetica, sans-serif\">Total fixed assets \r\n                are the total dollar value of all fixed assets in your business, \r\n                less any accumulated depreciation. <br>\r\n                </font></li>\r\n            </ul>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Total Assets</strong> \r\n              represents the total dollar value of both the short-term and long-term \r\n              assets of your business.</font></li>\r\n          </ol>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong>Liabilities and \r\n            Owners&#8217; Equity</strong> includes all debts and obligations owed \r\n            by the business to outside creditors, vendors, or banks that are payable \r\n            within one year, plus the owners&#8217; equity. Often, this side of \r\n            the balance sheet is simply referred to as &#8220;Liabilities.&#8221; \r\n            </font></p>\r\n          <ol>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Current Liabilities</strong> \r\n              is the sum total of all current liabilities owed to creditors that \r\n              must be paid within a one-year time frame. There are five main categories \r\n              of current liabilities: Accounts Payable, Accrued Expenses, Income \r\n              Tax Payable, Short-Term Notes Payable and Portion of Long-Term Debt \r\n              Payable. (Note: These are the main liabilities, your accounting \r\n              system may contain other liabilities.)</font> <br>\r\n            </li>\r\n            <ul>\r\n              <li><font face=\"Arial, Helvetica, sans-serif\"> Accounts Payable \r\n                is comprised of all short-term obligations owed by your business \r\n                to creditors, suppliers, and other vendors. Accounts payable can \r\n                include supplies and materials acquired on credit.</font></li>\r\n              <li><font face=\"Arial, Helvetica, sans-serif\"> Notes Payable represents \r\n                money owed on a short-term collection cycle of one year or less. \r\n                It may include bank notes, mortgage obligations, or vehicle payments. \r\n                </font></li>\r\n              <li><font face=\"Arial, Helvetica, sans-serif\">Accrued Payroll and \r\n                Withholding includes any earned wages or withholdings that are \r\n                owed to or for employees but have not yet been paid. <br>\r\n                </font></li>\r\n            </ul>\r\n            <li><strong><font face=\"Arial, Helvetica, sans-serif\">Fixed (Long-term) \r\n              Liabilities</font></strong><font face=\"Arial, Helvetica, sans-serif\"> \r\n              are any debts or obligations owed by the business that are due more \r\n              than one year out from the current date. <br>\r\n              </font> </li>\r\n            <ul>\r\n              <li><font face=\"Arial, Helvetica, sans-serif\">Mortgage note payable \r\n                is the balance of a mortgage that extends out beyond the current \r\n                year. For example, you may have paid off three years of a fifteen-year \r\n                mortgage note, of which the remaining eleven years, not counting \r\n                the current year, are considered long-term.<br>\r\n                </font></li>\r\n            </ul>\r\n            <li><strong><font face=\"Arial, Helvetica, sans-serif\"> Owners&#8217; \r\n              equity</font></strong><font face=\"Arial, Helvetica, sans-serif\"> \r\n              is referred to as stockholders&#8217; equity. Owners&#8217; equity \r\n              is made up of the initial investment in the business as well as \r\n              any retained earnings that are reinvested in the business.<br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Common stock</strong> \r\n              is stock issued as part of the initial or later-stage investment \r\n              in the business. <br>\r\n              </font></li>\r\n            <li><strong><font face=\"Arial, Helvetica, sans-serif\">Retained earnings</font></strong><font face=\"Arial, Helvetica, sans-serif\"> \r\n              are earnings reinvested in the business after the deduction of any \r\n              distributions to shareholders, such as dividend payments. <br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Total Liabilities \r\n              and Owners&#8217; Equity</strong> comprises all debts and monies \r\n              that are owed to outside creditors, vendors, or banks and the remaining \r\n              monies that are owed to shareholders, including retained earnings \r\n              reinvested in the business.</font> \r\n              <p><em><font face=\"Arial, Helvetica, sans-serif\">Example:</font></em><font face=\"Arial, Helvetica, sans-serif\"> \r\n                </font></p>\r\n            </li>\r\n          </ol>\r\n          <font face=\"Arial, Helvetica, sans-serif\"> </font>\r\n          <table width=\"80%\" border=\"1\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" bordercolor=\"#000066\">\r\n            <tr align=\"left\" valign=\"middle\" bgcolor=\"#000066\"> \r\n              <td width=\"376\"><div align=\"center\"><strong><font color=\"#FFFFFF\" face=\"Arial, Helvetica, sans-serif\">Assets</font></strong></div></td>\r\n              <td width=\"372\"><div align=\"center\"><strong><font color=\"#FFFFFF\" face=\"Arial, Helvetica, sans-serif\">Claims \r\n                  on Assets</font></strong></div></td>\r\n            </tr>\r\n            <tr align=\"left\" valign=\"top\"> \r\n              <td height=\"418\"> \r\n                <table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td colspan=\"3\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Current \r\n                      Assets:</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td width=\"54%\" align=\"left\"> \r\n                      <blockquote> \r\n                        <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Cash</font></p>\r\n                      </blockquote></td>\r\n                    <td width=\"24%\" align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$123,000</font></td>\r\n                    <td width=\"22%\">&nbsp;</td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"> \r\n                      <blockquote> \r\n                        <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Marketable \r\n                          Securities </font></p>\r\n                      </blockquote></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$200,000</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"> \r\n                      <blockquote> \r\n                        <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Accounts \r\n                          Recievable </font></p>\r\n                      </blockquote></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$345,000</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"> \r\n                      <blockquote> \r\n                        <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Inventories</font></p>\r\n                      </blockquote></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$100,000</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Total \r\n                      Current Assets</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td> \r\n                      <hr> <font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$768,000</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td colspan=\"3\" align=\"left\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Long-Term \r\n                      Assets </font><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"> \r\n                      <blockquote> \r\n                        <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Building \r\n                          (Gross) </font></p>\r\n                      </blockquote></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$350,000</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"> \r\n                      <blockquote> \r\n                        <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">-Accumulated \r\n                          Depreciation</font></p>\r\n                      </blockquote></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$ \r\n                      -50,000<br>\r\n                      </font> <font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp; \r\n                      </font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"> \r\n                      <blockquote> \r\n                        <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Net \r\n                          Building</font></p>\r\n                      </blockquote></td>\r\n                    <td align=\"right\"> \r\n                      <hr> <font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$300,000</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"> \r\n                      <blockquote> \r\n                        <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Land</font></p>\r\n                      </blockquote></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$325,000</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td height=\"19\" colspan=\"2\" align=\"left\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Total \r\n                      Long-Term Assets</font><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td> \r\n                      <hr> <font face=\"Arial, Helvetica, sans-serif\"> <font color=\"#000066\">$625,000</font></font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\"><strong>Total \r\n                      Assets </strong></font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td> \r\n                      <hr> <font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$1,393,000 \r\n                      </font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td align=\"left\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                </table>\r\n              </td>\r\n              <td> <table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr valign=\"bottom\"> \r\n                    <td colspan=\"3\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Current \r\n                      Liabilities </font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td width=\"52%\"> \r\n                      <blockquote> \r\n                        <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Accounts \r\n                          Payable </font></p>\r\n                      </blockquote></td>\r\n                    <td width=\"24%\" align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$100,000</font></td>\r\n                    <td width=\"24%\" align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td> \r\n                      <blockquote> \r\n                        <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Notes \r\n                          Payable </font></p>\r\n                      </blockquote></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$150,000</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Total \r\n                      Current Liabilites</font></td>\r\n                    <td align=\"right\"> \r\n                      <hr> <font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$250,000</font> \r\n                    </td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td> \r\n                      <blockquote> \r\n                        <p><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Long-Term \r\n                          Note </font></p>\r\n                      </blockquote></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$300,000</font></td>\r\n                    <td align=\"right\">&nbsp;</td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Total \r\n                      Liabilites </font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"> \r\n                      <hr> <font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$550,000 \r\n                      </font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">Owner\'s \r\n                      Equity </font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">$843,000</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\"><strong>Total \r\n                      Claims </strong></font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"> \r\n                      <hr> <font color=\"#000033\" face=\"Arial, Helvetica, sans-serif\">$1,393,000</font> \r\n                    </td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                  <tr valign=\"bottom\"> \r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td align=\"right\"><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                    <td><font color=\"#000066\" face=\"Arial, Helvetica, sans-serif\">&nbsp;</font></td>\r\n                  </tr>\r\n                </table></td>\r\n            </tr>\r\n          </table>\r\n          <font face=\"Arial, Helvetica, sans-serif\">\r\n          <p><br>\r\n          </p>\r\n          </font> \r\n          <p align=\"left\">&nbsp;</p>\r\n          <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">',298),(323,33,'What is an Income Statement?','An income \r\n            statement, otherwise known as a profit and loss statement, is a summary \r\n            of a company&#8217;s profit or loss during any one given period of \r\n            time, such as a month, a quarter, or one year. The income statement \r\n            records all revenues for a business during this given period, as well \r\n            as the operating expenses for the business. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong><br>\r\n            What an Income Statement is Used For </strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">You use an income statement \r\n            to track revenues and expenses so that you can determine the operating \r\n            performance of your business over a period of time. Small business \r\n            owners use these statements to find out what areas of their business \r\n            are over budget or under budget. Specific items that are causing unexpected \r\n            expenditures can be pinpointed, such as phone, fax, mail, or supply \r\n            expenses. Income statements can also track dramatic increases in product \r\n            returns or cost of goods sold as a percentage of sales. They also \r\n            can be used to determine income tax liability. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">It is very important to \r\n            format an income statement so that it is appropriate to the business \r\n            being conducted. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Income statements, along \r\n            with balance sheets, are the most basic elements required by potential \r\n            lenders, such as banks, investors, and vendors. They will use the \r\n            financial reporting contained therein to determine credit limits. \r\n            </font></p>\r\n          <ol>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Sales</strong> \r\n              figures represent the amount of revenue generated by the business. \r\n              The amount recorded here is the total sales, less any product returns \r\n              or sales discounts. <br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Cost of Goods \r\n              Sold</strong> represents the costs directly associated with making \r\n              or acquiring your products. Costs include materials purchased from \r\n              outside suppliers used in the manufacture of your product, as well \r\n              as any internal expenses directly expended in the manufacturing \r\n              process. <br>\r\n              </font> \r\n              <ul>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\">Gross profit is \r\n                  derived by subtracting the cost of goods sold from net sales. \r\n                  It does not include any operating expenses or income taxes. \r\n                  <br>\r\n                  </font></li>\r\n              </ul>\r\n            </li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Operating Expenses</strong> \r\n              are the daily expenses incurred in the operation of your business. \r\n              In this sample, they are divided into two categories: selling, and \r\n              general and administrative expenses. <br>\r\n              </font> \r\n              <ul>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\">Sales salaries are \r\n                  the salaries plus bonuses and commissions paid to your sales \r\n                  staff. </font></li>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\">Collateral and promotions \r\n                  fees are expenses incurred in the creation or purchase of printed \r\n                  sales materials used by your sales staff in marketing and selling \r\n                  your product. Promotion fees include any product samples and \r\n                  giveaways used to promote or sell your product. </font></li>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\">Advertising represents \r\n                  all costs involved in creating and placing print or multi-media \r\n                  advertising. </font></li>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\">Other sales costs \r\n                  include any other costs associated with selling your product. \r\n                  They may include travel, client meals, sales meetings, or equipment \r\n                  rental for presentations, copying, or miscellaneous printing \r\n                  costs. </font></li>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\">Office salaries \r\n                  are the salaries of full- and part-time office personnel. </font></li>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\">Rent is the fee \r\n                  incurred to rent or lease office or industrial space. </font></li>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\">Utilities include \r\n                  costs for heating, air conditioning, electricity, phone equipment \r\n                  rental, and phone usage used in connection with your business.</font></li>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\"> Depreciation is \r\n                  an annual expense that takes into account the loss in value \r\n                  of equipment used in your business. Examples of equipment that \r\n                  may be subject to depreciation includes copiers, computers, \r\n                  printers, and fax machines. </font></li>\r\n                <li><font face=\"Arial, Helvetica, sans-serif\">Other overhead costs \r\n                  are expense items that do not fall into other categories or \r\n                  cannot be clearly associated with a particular product or function. \r\n                  These types of expenses may include insurance, office supplies, \r\n                  or cleaning services. <br>\r\n                  </font></li>\r\n              </ul>\r\n            </li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Total Expenses</strong> \r\n              is a tabulation of all expenses incurred in running your business, \r\n              exclusive of taxes or interest expense on interest income, if any. \r\n              <br>\r\n              </font></li>\r\n            <li><strong><font face=\"Arial, Helvetica, sans-serif\">Net Income Before \r\n              Taxes</font></strong><font face=\"Arial, Helvetica, sans-serif\"> \r\n              represents the amount of income earned by a business prior to paying \r\n              income taxes. This figure is arrived at by subtracting total operating \r\n              expenses from gross profit. <br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Taxes</strong> \r\n              are the amount of income taxes you owe to the federal government \r\n              and, if applicable, state and local government taxes. <br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Net income</strong> \r\n              is the amount of money the business has earned after paying income \r\n              taxes. <br>',299),(324,33,'General Ledger Basics','The general \r\n            ledger is the core of your companys financial records. These \r\n            constitute the central core of your system, and every transaction \r\n            flows through the general ledger. These records remain as a permanent \r\n            track of the history of all financial transactions since day one of \r\n            the life of your company. </font></p>\r\n          <p align=\"left\">Â </p>\r\n          <p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\"><strong>Subledgers \r\n            and the General Ledger</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Your accounting system \r\n            will have a number of subsidiary ledgers (called subledgers) for items \r\n            such as cash, accounts receivable, and accounts payable. All the entries \r\n            that are posted to these subledgers will transact through the general \r\n            ledger account.</font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><em>Example:</em></font></p>\r\n          <blockquote>\r\n            <p><font face=\"Arial, Helvetica, sans-serif\">When a credit sale posted \r\n              in the account receivable subledger turns into cash due to a payment, \r\n              the transaction will be posted to the general ledger and the two \r\n              (cash and accounts receivable) subledgers as well. </font></p>\r\n          </blockquote>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">There are times when items \r\n            will go directly to the general ledger without any subledger posting. \r\n            These are primarily capital financial transactions that have no operational \r\n            subledgers. These may include items such as capital contributions, \r\n            loan proceeds, loan repayments (principal), and proceeds from sale \r\n            of assets. These items will be linked to your balance sheet but not \r\n            to your profit and loss statement. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong><br>\r\n            What a General Ledger is Used For</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">There are two main issues \r\n            to understand when setting up the general ledger. One is their linkage \r\n            to your financial reports, and the other is the establishment of opening \r\n            balances. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">The two primary financial \r\n            documents of any company are their balance sheet and the profit and \r\n            loss statement, and both of these are drawn directly from the companys \r\n            general ledger. The chart of accounts determines the order of how \r\n            the numerical balances appear, but all entries that are entered will \r\n            appear. The general ledger accrues the balances that make up the line \r\n            items on these reports, and the changes are reflected in the profit \r\n            and loss statement as well.</font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"> The opening balances that \r\n            are established on your general ledgers may not always be zero as \r\n            you might assume. On the asset side, you will have all tangible assets \r\n            (the value of all machinery, equipment, and inventory) that is available \r\n            as well as any cash that has been invested as working capital. On \r\n            the liability side, you will have any bank (or stockholder) loans \r\n            that were used, as well as trade credit or lease payments that you \r\n            may have secured in order to start the company. You will also increase \r\n            your stockholder equity in the amount you have invested, but not loaned \r\n            to, the business. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><br>\r\n            <strong>The General Ledger Creates an Audit Trail</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Dont let the word \r\n            audit scare you; we are not talking about a tax audit. Although, if \r\n            you are called to respond to an outside audit for any reason, a well-maintained \r\n            general ledger is essential. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">But you will also want \r\n            an internal trail of transaction so that you can trace any discrepancy \r\n            (such as double billing or an unrecorded payment) through your own \r\n            system. You must be able to find the origin of any transaction in \r\n            order to verify its accuracy, and the general ledger is where you \r\n            will do this. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"> Use the chart below to \r\n            follow the transaction flow of the General Ledger: </font></p>\r\n          <p align=\"center\"><font face=\"Arial, Helvetica, sans-serif\"><img src=\"images/screenshots/genledger.gif\" width=\"600\" height=\"800\">',300),(325,33,'What is Inventory Accounting?','Inventory \r\n            accounting may sound like a huge undertaking but in reality, it is \r\n            quite straightforward and easy to understand. You start with the inventory \r\n            you have on hand. No matter when you sell product, the value of your \r\n            inventory will remain constant based on accepted and rational methods \r\n            of inventory accounting. Those methods include weighted average, first \r\n            in/first out, and last in/first out. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><br>\r\n            <strong>Weighted Average </strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Weighted average measures \r\n            the total cost of items in inventory that are available for sale divided \r\n            by the total number of units available for sale. Typically this average \r\n            is computed at the end of an accounting period. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">The weighted average method \r\n            is calculated as follows: </font></p>\r\n          <p align=\"center\"><font face=\"Arial, Helvetica, sans-serif\"><strong>Total \r\n            Cost of Goods for Sale at Cost &divide; <br>\r\n            Total Number of Units Available for Sale = <br>\r\n            Weighted Average Cost per Widget</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><br>\r\n            <em>Example:</em></font></p>\r\n          <blockquote> \r\n            <p><font face=\"Arial, Helvetica, sans-serif\">Suppose you purchase \r\n              five widgets at $10 a piece and five widgets at $20 a piece. You \r\n              sell five units of product. </font></p>\r\n            <p><font face=\"Arial, Helvetica, sans-serif\">Five widgets at $10 each \r\n              = $50<br>\r\n              Five widgets at $20 each = $100<br>\r\n              Total cost of goods = $150<br>\r\n              Total number of widgets = 10<br>\r\n              Weighted Average = $150 &divide; 10 = $15<br>\r\n              $15 is the average cost of the 10 widgets</font></p>\r\n            <p>&nbsp;</p>\r\n          </blockquote>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"> <strong>First In/First \r\n            Out </strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">First in, first out means \r\n            exactly what it says. The first widgets you bring into inventory will \r\n            be the first ones sold as product. First in, first out, or FIFO as \r\n            it is commonly referred to, is based on the principle that most businesses \r\n            tend to sell the first goods that come into inventory. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><em>Example:</em></font></p>\r\n          <blockquote> \r\n            <p><font face=\"Arial, Helvetica, sans-serif\">Suppose you buy five \r\n              widgets at $10 a piece on January 3 and purchase another five widgets \r\n              at $20 a piece on January 7. You then sell five widgets on January \r\n              30. </font></p>\r\n            <p><font face=\"Arial, Helvetica, sans-serif\">Using first in, first \r\n              out, the five widgets you purchased at $10 would be sold first. \r\n              This would leave you with the five widgets that you purchased at \r\n              $20, which would leave the value of your inventory at $100.</font></p>\r\n            <p>&nbsp;</p>\r\n          </blockquote>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong>Last In/First Out \r\n            </strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">This method, commonly referred \r\n            to as LIFO, is based on the assumption that the most recent units \r\n            purchased will be the first units sold. The advantage of last in, \r\n            first out accounting, or LIFO, is that typically the last widgets \r\n            purchased were purchased at the highest price and that by considering \r\n            the highest priced items to be sold first, a business is able to reduce \r\n            its short-term profit, and hence, taxes. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><em>Example:</em></font></p>\r\n          <blockquote> \r\n            <p><font face=\"Arial, Helvetica, sans-serif\">Suppose you purchase \r\n              five widgets at $10 a piece on January 4 and five more widgets at \r\n              $20 a piece on February 2. You then sell five widgets on February \r\n              20. </font></p>\r\n            <p><font face=\"Arial, Helvetica, sans-serif\">The value of your inventory, \r\n              using LIFO, would be $50, since the most recent widgets purchased, \r\n              at a total value of $100 on February 2, were sold. You were left \r\n              with the five widgets valued at $10 each.',301),(326,33,'Cash vs. Accrual Accounting','<p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">There are \r\n            two forms of accounting used by businesses - cash and accrual. The \r\n            basic difference between the two methods is the timing of income and \r\n            expense recording. The best method for your company depends on a variety \r\n            of factors that include the nature of your business, its legal business \r\n            structure, and whether or not you extend credit. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">You must choose between \r\n            cash and accrual accounting and notify the IRS on your tax return \r\n            which method you use. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><br>\r\n            <strong>The Cash Method</strong> </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Most small (one or two-person) \r\n            businesses use the cash basis method of accounting, which is based \r\n            on real-time cash flow. In cash method, you report an expense when \r\n            it is paid, and record income when it is received. So, the day you \r\n            receive a check, it becomes a cash receipt. And you record your expenses \r\n            when you pay your bills, not when the bill is received. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">By the way, the word &quot;cash&quot; \r\n            is not meant literally - it also covers payments by check, credit \r\n            card, barter, etc. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><br>\r\n            <strong>The Accrual Method</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">With accrual accounting, \r\n            you record income when it is earned, not when it is paid. Similarly, \r\n            you record your expenses when the obligation arises, not when you \r\n            pay it. The tax code refers to this as recording income and expenses \r\n            when they are &quot;fixed&quot; - when all the necessary events have \r\n            occurred to receive the income or expense the liability. It is not \r\n            necessary for cash to change hands. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><em>Example:</em></font></p>\r\n          <blockquote> \r\n            <p><font face=\"Arial, Helvetica, sans-serif\">You\'re a consultant and \r\n              you complete a job on December 15, but you haven\'t been paid for \r\n              it. You recognize all expenses in relation to that contract when \r\n              they were incurred, regardless of whether you\'ve been paid yet or \r\n              not. Both the income and expenses are recorded for the current tax \r\n              year, even if payment is received and bills are paid the following \r\n              February. </font></p>\r\n          </blockquote>\r\n          <p> <font face=\"Arial, Helvetica, sans-serif\"><strong><br>\r\n            Who should use the Accrual Method</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">Businesses are required \r\n            to use the accrual method in several instances, including: </font></p>\r\n          <ul>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">if the business has \r\n              inventory. </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">if the business is a \r\n              C corporation. </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">if gross annual sales \r\n              exceed $5 million (with certain exceptions for personal service \r\n              companies, sole proprietorships, farming businesses, and a few others). \r\n              </font></li>\r\n          </ul>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong><br>\r\n            Differences between cash and accrual accounting</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">In a number of instances, \r\n            your bookkeeping method will have an impact on your taxes. </font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><em>Examples:</em></font></p>\r\n          <ul>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\">Accelerated expenses: \r\n              To accelerate expenses, accrual basis companies only need to record \r\n              (not necessarily pay) every purchase and expense invoice by year-end. \r\n              Cash basis companies must pay them off before the end of December.</font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"> Employee bonuses: Cash \r\n              method businesses can only deduct employee bonuses in the year they\'re \r\n              paid. Accrual method businesses, on the other hand, can record the \r\n              bonus in December, and pay the bonus over the next 2 1/2 months. \r\n              </font></li>\r\n          </ul>\r\n          <blockquote> \r\n            <p>&nbsp;</p>\r\n          </blockquote>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\"><strong>Changing between \r\n            cash and accrual methods in different tax years</strong></font></p>\r\n          <p><font face=\"Arial, Helvetica, sans-serif\">If you want to change your \r\n            business\' accounting methods, you may need to get permission from \r\n            the IRS, which is concerned you might be seeking an unfair tax advantage. \r\n            To make the change, you would file IRS Form 3115, Application for \r\n            Change in Accounting Method. This form needs to be filed within 180 \r\n            days before the end of the year for which you want to make the change. \r\n            You do not need permission if there is a &quot;fundamental change&quot; \r\n            in your business - i.e. you move from a service business to one that \r\n            carries inventory. You should seek the advice of your tax advisor \r\n            to determine whether you need permission. </font></p>',302),(327,33,'Owner\'s Review Checklist','<p align=\"left\"><font face=\"Arial, Helvetica, sans-serif\">Even if you \r\n            hire someone to do your accounting and bookkeeping, there are a number \r\n            of items that that you as the business owner should do periodically. \r\n            Many small businesses have suffered serious losses when the owner \r\n            lost track of the numbers and the trusted bookkeeper &quot;borrowed \r\n            money&quot; and left for an extended cruise. The following checklist \r\n            will keep you in touch with your business, and perhaps even prevent \r\n            you from serious losses.</font></p>\r\n          <ol>\r\n            <li><strong><font face=\"Arial, Helvetica, sans-serif\" align=\"left\">Compare \r\n              actual results to budget.</font></strong><font face=\"Arial, Helvetica, sans-serif\" align=\"left\"> \r\n              Each and every month you need to compare your income and expenses \r\n              to your budget. This review is perhaps one of the most important \r\n              tools for a small business owner. It\'s a great way to learn what\'s \r\n              working and what\'s not working with your business. The goal is not \r\n              to have an accurate budget... but for you to have a thorough knowledge \r\n              of what is happening and to know if anything unexpected is happening \r\n              so that you can adjust your actions in a timely manner. <br>\r\n              </font></li>\r\n            <li><strong><font face=\"Arial, Helvetica, sans-serif\"> Scan the check \r\n              register.</font></strong><font face=\"Arial, Helvetica, sans-serif\"> \r\n              Periodically (say every 3-4 months) you should take a look at the \r\n              check register just to make sure all the payees are familiar to \r\n              you. Multiple checks written around the same time to the same vendor \r\n              could be an indication that funds are being diverted. (You also \r\n              might want to reduce the time spent writing and posting multiple \r\n              checks.) <br>\r\n              </font></li>\r\n            <li><strong><font face=\"Arial, Helvetica, sans-serif\"> Review the \r\n              bank reconciliation.</font></strong><font face=\"Arial, Helvetica, sans-serif\"> \r\n              This should be done on a monthly basis (or if you skip a month take \r\n              a look at all the reconciliations since your last review.) This \r\n              step is important, particularly if you have one person doing all \r\n              the bookkeeping: writing checks, posting entries, preparing financials, \r\n              etc. Look at any adjustments to the bank accounts, stale items, \r\n              etc. <br>\r\n              </font></li>\r\n            <li><strong><font face=\"Arial, Helvetica, sans-serif\"> Look at canceled \r\n              checks.</font></strong><font face=\"Arial, Helvetica, sans-serif\"> \r\n              Occasionally (say 1-2 times a year) pull out a bank statement and \r\n              flip through the canceled checks making sure that all those signatures \r\n              are yours, that you recognize the vendors and scan the endorsements \r\n              on the back. Obviously, this can\'t be done if you don\'t get your \r\n              canceled checks back from the bank. In this case you might want \r\n              to spend a little extra time with the check register.<br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"> <strong>Review statements \r\n              from vendors.</strong> Every now and then (say 3-4 times per year) \r\n              take the time to open the mail and look at statements from vendors \r\n              (many vendors have stopped sending statements, but they will send \r\n              late notices). Here you want to make sure that your business is \r\n              in good standing with vendors -- long overdue invoices might be \r\n              an indication that a check you thought was going to a vendor actually \r\n              went in someone else\'s pocket, or that an invoice has been overlooked. \r\n              <br>\r\n              </font></li>\r\n            <li><strong><font face=\"Arial, Helvetica, sans-serif\"> Review Payroll \r\n              register and handout the paychecks.</font></strong><font face=\"Arial, Helvetica, sans-serif\"> \r\n              Now of course this isn\'t an issue for a business with only 1-2 employees. \r\n              But &quot;padding the payroll&quot; is a common problem in some \r\n              industries -- such as construction or cleaning services where it \r\n              is common for the crew to go straight to the jobsite and perhaps \r\n              not come into regular contact with the owner. <br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"> <strong>Review your \r\n              Accounts Receivable and Aging.</strong> This needs to be done on \r\n              a regular basis. Of course you need to know if you have any slow \r\n              paying customers and a periodic review would also disclose any scheme \r\n              of &quot;misapplying&quot; customer payments.<br>\r\n              </font></li>\r\n            <li><font face=\"Arial, Helvetica, sans-serif\"><strong>Take a physical \r\n              inventory.</strong> Many small businesses have very poor inventory \r\n              records, so if you have a large amount of inventory or a high volume \r\n              business, you probably will want to work with your accountant and \r\n              get some type of perpetual inventory system set up. Again, Nola-Pro \r\n              is an excellent software packages available for all sized businesses \r\n              that will make this process relatively painless. Once you have a \r\n              system in place, you should take a physical inventory at least once \r\n              a year and compare the actual goods on hand to the inventory records. \r\n              </font></li>',303),(328,17,'Company Divisions','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Company Divisions</strong></font><a href=\"http://www.nolapro.com/training/admin/admin_company_divisions/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em></em> \r\n<p>1) Click Admin. </P>\r\n<p>2) Click Company Divisions. Your screen should look similar to this: </p>\r\n \r\n<p align=\"center\"><img src=\"images/screenshots/Admin_Company.jpg\" ></p>\r\n<p align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Update an Existing Company Division</strong></font></p>\r\n<hr></hr>\r\n<em></em> \r\n\r\n<p>1) Select the Company Division you would like to update from the Company Division \r\n  pull-down list.</p>\r\n<p>2) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/compedit.jpg\" ></p>\r\n<p align=\"left\"><br>\r\n  3) Make any changes to the company information. </p>\r\n<blockquote>\r\n<b>Name, Address, Phones, etc.</b> These need no explanation.<br>\r\n<b>Menu Bar Color.</b> You can select different color schemes for your program, and each company (if you have more than one) can be different.  Select one from the pull-down list -- save -- then refresh the screen to see the effect).<br>\r\n<b>Small Graphic Logo Filename.</b> You can upload a small graphic that will be displayed in all the headers. Use the browse to find the file.<br>\r\n<b>Delete small graphic</b> If you have entered a graphic, check the delete box to remove it.<br>\r\n\r\n<b>Large Graphic Logo Filename.</b> You can upload a large graphic that will be displayed on forms. Use the browse to find the file.<br>\r\n<b>Delete large graphic</b> If you have entered a graphic, check the delete box to remove it.<br>\r\n\r\n\r\n</blockquote>\r\n<p>4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  your changes.<br>\r\n</p>\r\n<p>5) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> button to \r\n  delete a division.<br>\r\n</p>\r\n<p align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Add a New Company Division</strong></font>\r\n<hr></hr>\r\n<em></em> \r\n<p>1) From the main screen, you also have the option to add a new Company Division. \r\n  Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> button. Your screen \r\n  should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/compadd.jpg\" > \r\n</p>\r\n<p> <br>\r\n  2) Add all the necessary information for the company. </p>\r\n<blockquote>\r\n<b>Name, Address, Phones, etc.</b> These need no explanation.<br>\r\n<b>Menu Bar Color.</b> You can select different color schemes for your program, and each company (if you have more than one) can be different.  Select one from the pull-down list -- save -- then refresh the screen to see the effect).<br>\r\n<b>Small Graphic Logo Filename.</b> You can upload a small graphic that will be displayed in all the headers. Use the browse to find the file.<br>\r\n<b>Delete small graphic</b> If you have entered a graphic, check the delete box to remove it.<br>\r\n\r\n<b>Large Graphic Logo Filename.</b> You can upload a large graphic that will be displayed on forms. Use the browse to find the file.<br>\r\n<b>Delete large graphic</b> If you have entered a graphic, check the delete box to remove it.<br>\r\n\r\n\r\n</blockquote>\r\n<p>3) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to add \r\n  the new division. <B>NOTE:</b> When you add a new company, the first time you select it you will need to run through the preliminary setup functions. Check out how this works under Initial Setup.<br>',304),(329,17,'Version Information','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Version Information</strong></font><a href=\"http://www.nolapro.com/training/admin/admin_version_information/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em></em> \r\n<p>1) Click Admin. </P>\r\n<p>2) Click Version Information. This chart displays the features available with \r\n  each Nola-Pro version. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Admin_version.jpg\" > \r\n</p>\r\n<p>The purpose of this display is to let you know what version you have, and what maximums you have in terms of customers, vendors, etc. in your system.</p><br>\r\n',305),(330,17,'Database Information','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Database Information</strong></font><a href=\"http://www.nolapro.com/training/admin/admin_db_information/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<em>At the top of this section are notes on changing database information. And below that is the amount of disk space used by the database.</em>\r\n<hr></hr>\r\n<em></em> \r\n<p>1) Click Admin. </P>\r\n<p>2) Click Database Information. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/DatabaseInformationMain.jpg\" > \r\n</p>\r\n<p align=\"left\">3) Edit any or all of the following information:</p>\r\n<blockquote>\r\n  <p>\r\n    a) Currency Decimal Places. How many decimal places you would like \r\n    shown on financial details.<br>\r\n    b) Currency Symbol. Current currency you wish to use.</p>\r\n</blockquote>\r\n<p>4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> button to save \r\n  the changes.</p><br>\r\n  <br>',306),(335,43,'Machine Families - Add/Update','<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Adding and Updating Machine Families</font></b></center><br>\r\n <i>Use this section to enter all machine groups to be used for pricing schemes in your estimating.  Actual machines can be specified when RUNNING the job.</i><br><br>\r\n<p>From the Main Menu select Printing then Print Shop Setup then Machine Families.  Your screen will look similar to this:</p><center><img src=\"images/screenshots/machine_family.jpg\" border=\"0\"></center>\r\n<p>To update an existing family, select from the pull down list. Then click on the <img src=\"images/edit.gif\"> Edit button to continue with editing.</p>\r\n<p> To add a new family, Click on the <img src=\"images/add.gif\"> Add button.</p>\r\n<p> Whether adding or updating, your next screen will look similar to this:</p>\r\n<center><img src=\"images/screenshots/machine_family1.jpg\"></center>\r\n\r\n<p><b>Family Name:</b> The name of the family as it will appear during other inputs (such as order entry).<br><br>\r\n<b>Work Area:</b> Select the appropriate work area from the pull-down list. (Work areas are entered elsewhere in Setup area).<br><br>\r\n<b>Normal IPH:</b> You can enter numbers for one sided (for non-print) or one AND two-sided (for print). This figure is used when calculating time when based on running rates. <br><br>\r\n<b>Selling Price per Sheet:</b> An alternate way of calculating charges is to enter a per-unit price to be charged for work in this family. This charge can be different for one-sided vs. two-sided. This is frequently used for copiers.<br><br>\r\n<b>Maximum and Minimum values for PRINT operations: </b>If you want to limit allowed operations based on the press selected during order entry, you will need to enter that information here.<br><br>\r\n<b>Price Breaks: </b>If you have entered PER UNIT PRICING under Selling Price per Sheet, then you can enter as many price breaks as needed in this section. Click on the New Price Break button to add another price-break level.<br><br>\r\n<b>Max Impressions per day:</b> This number is used when calculating some of the scheduling and loading reports.<br><br>\r\n\r\n<b>IPH changes:</b> For run-time based calculations, you can enter values that will change the running rates or prices -- depending on size or weight of the stock to be run.  To change the TIME, enter a factor under \"Multiply Normal IPH by\" (for example to slow a rate by 70%, enter a .7 here).  To change the PRICE by a factor when affected by these parameters, enter the factor under \"Multiply Normal Price By\" (to increase the price by 25%, enter a 1.25 here).<br><br>\r\n</p>\r\n<p>Click on the <img src=\"images/next.gif\"> Next button to continue entering /editing information for this family. The next screen will look similar to this:</p>\r\n<center><img src=\"images/screenshots/machine_family2.jpg\"></center>\r\n<p><b>Internal Only:</b> Checking this box makes sure that this question does not appear on the CUSTOMER order-entry screens, only on INTERNAL use order-entry screens. Checkmark any questions that the customer would not understand how to answer correctly or that are for internal refererence only.<br><br>\r\n<b>Question:</b> This is the prompt that will appear on the order entry screen for this function.<br><br>\r\n<b>Response Type:</b> Select the type of prompt/fill-in you want for this question.  Choices are:<br>\r\n  1. Numeric answer - Your question might be Number of Cuts, so the answer you expect is a number.<br>\r\n  2. Yes/No - This will display a check-box on the order entry next to this question. Typical use would be with a question like \"Proof Required?\"<br>\r\n  3. Text - this expects a typed answer (which will not be used in any calculation). This might be used next to Ink Color question.<br>\r\n  4. Selection list - Will display a pull-down list next to the question (which limits answers to only those acceptable).<br>\r\n  5. Selection list plus text - Will display the pull-down list choice, but also give the order-entry person a place to type additional information.<br><br>\r\n<b>Unit of Measure:</b> This is displayed to make order entry easier to understand.<br><br>\r\n<b>Display Order:</b> The order in which the questions will appear during order entry.<br><br>\r\n<b><img src=\"images/edit.gif\">Edit Button:</b> clicking here will change the screen to allow you to enter the items to be displayed for Selection List pull-downs.<br><br>\r\n<b>Delete:</b> checkmark the Delete box to remove a question no longer needed.<br><br><br>\r\n<p>To add a new question, click on the <img src=\"images/add.gif\"> Add button.<br><br>To save the changes, click on the <img src=\"images/save.gif\"> Save Button.</p><br>\r\n<br>\r\n<b>EDITING A SELECTION LIST: </b>If you clicked on the Edit button above after selecting a response type of Selection List or Selection List plus Text, the screen will change as follows:</p>\r\n<center><img src=\"images/screenshots/machine_family3.jpg\"></center>\r\n<p>You can update the text to appear in the selection list, or to add a new one, click on the small <img src=\"images/add.gif\" height=\"20\"> Add button.</p>\r\n<p>The selection list also has a display order in which the items on the list will appear during order entry.</p>\r\n<p>Check the Delete box to remove an item from the selection drop-down list.</p>\r\n\r\n',308),(336,43,'Family Calculations','<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Adding and Updating Machine Family Calculations</font></b></center><br>\r\n <i>Use this section to create the calculations to be used with a specific machine family -- both time and materials.</i><br><br>\r\n<p>From the Main Menu select Printing then Print Shop Setup then Family Calculations.  Your screen will look similar to this:</p>\r\n<center><img src=\"images/screenshots/family_calculations.jpg\" border=\"0\"></center>\r\n<p>Select a family from the drop-down list.  Click on the <img src=\"images/edit.gif\"> Edit button to continue with editing the calculations. Your next screen will appear as follows:</p>\r\n<center><img src=\"images/screenshots/family_calculations1.jpg\"></center>\r\n<p>Displayed will be a list of the questions you entered under Machine Families.  To enter the calculations for a specific question, click on the Edit button.  This will change the screen as follows:</p>\r\n<center><img src=\"images/screenshots/family_calculations2.jpg\" border=\"0\"></center>\r\n<p>The example shown is for a Selection List, but they all work in much the same way.  With a Selection List, each item on the list can have different calculations.</p>\r\n<br>\r\n<b>Calculation Quantity:</b> This is a pull-down list. The items on this list are created under Printing->Setup->Formulas.  If you do not see the one you need on this list, you will need to create a new \"formula\". Once this quantity is determined, if it is run time, then it will be divided by the impressions per hour entered on the first Family screen. If it is other time, it should return the number of hours.  If it is materials, it will be multiplied times the costs entered to the right on this screen.<br><br>\r\n<b>Once per Job?:</b> This is important when working with multi-stock jobs. If not checked, it could charge the same for each PART of the job.<br><br>\r\n<b>Inventory:</b> For materials, you can tie into a specific inventory item by making that selection here.  The <img src=\"images/seek.gif\"> Lookup will help you find the inventory item required.<br><br>\r\n<b>Materials Cost:</b> If the materials are NOT from inventory, enter the cost per unit here.<br><br>\r\n<b>Markup Multiplier:</b> For Materials, the multiplier to use for the markup over cost. (25% markup = 1.25 entered here!).<br><br>\r\n<b>Delete:</b> Check the delete box to remove a calculation line.<br><br>\r\n<b><big>NOTE:</big></b><i> You MUST NOT enter BOTH time and materials on the same entry line. If you need both time AND materials, use a separate line for each. To add a new line, click on the Add New Calculation button.</i><br><br>\r\n<p>When you have made all the entries needed for the family, click on the <img src=\"images/save.gif\"> Save button.<br><br>\r\n\r\n\r\n\r\n',309),(337,43,'Machines','<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Adding and Updating Machines</font></b></center><br>\r\n <i>You MUST have AT LEAST one machine for EACH machine family in order for calculations to work correctly. However, you may have many machines for one family. Enter all machines to be used for actual time in your costing. </i><br><br>\r\n<p>From the Main Menu select Printing then Print Shop Setup then Machines.  Your screen will look similar to this:</p><center><img src=\"images/screenshots/machine.jpg\" border=\"0\"></center>\r\n<p>To update an existing machine,  select the machine from the drop-down list.  Click on the <img src=\"images/edit.gif\"> Edit button to continue with editing.</p>\r\n<p> To add a new machine, Click on the <img src=\"images/add.gif\"> Add button.</p>\r\n<p> Whether adding or updating, your next screen will look similar to this:</p>\r\n<center><img src=\"images/screenshots/machine1.jpg\"></center>\r\n<p><b>Machine Name:</b> Name of actual machine.<br><br>\r\n<b>Serial Number:</b> Serial number or other identification for the machine.<br><br>\r\n<b>Machine Family:</b> Select from drop-down list of selected families. Families are entered elsewhere in Setup.<br><br>\r\n<b>Print Location:</b> Print location ties in with inventory, in that inventory allows for multiple warehouses.  Here is where you indicate which warehouse to pull inventory from for this printshop.<br><br>\r\n<b>Default Machine this Family?</b> If you check this box indicating that it is the default machine for this family, then the machine and labor hourly costs, markups and overheads will be pulled from this machine when doing estimates or entering jobs.<br><br>\r\n<b>Machine Cost per Hour:</b> This number can be arrived at by taking the purchase price of the machine, adding upkeep expenses over its life, then dividing the result by the number of hours life (hours life = years life*52*hours used per week).<br><br>\r\n<b>Labor Cost per Hour:</b> Average labor cost (if this machine requires more than one operator, then use the sum of the operators for this number).\r\n<br><br>\r\n<b>Operator Time to Machine Time:</b> If running a particular piece of equipment only requires 50% of the time of an operator (he might be able to run two machines at the same time), then enter 50% here.  If this machine requires the full attention of the operator, then use 100%.<br><br>\r\n<b>Overhead:</b> Overhead is most easily derived from an income statement. It is the sum of all COSTS divided by the sum of DIRECT costs.  This will give you a number like 1.35.  This means that the overhead is 35%. DIRECT costs are actual production labor, costs of materials used in jobs, and other costs directly attributable to job production.  All other costs are overhead costs that need to be distributed over direct costs to come up with total actual costs of doing work.<br><br>\r\n<b>Markup:</b> Markup is PROFIT.  It is the percentage you should retain after all costs are met.<br><br>\r\n</p>\r\n<p>When you are done, click on the <img src=\"images/save.gif\"> Save button to save your changes. </p>\r\n<p>To Delete the machine, click on the <img src=\"images/delete.gif\"> Delete button.</p>\r\n<p>To return to machine selection WITHOUT saving your changes, click on the <img src=\"images/back.gif\">Back button.<br>\r\n',310),(338,43,'Worktypes','<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Adding and Updating Worktypes</font></b></center><br>\r\n <i>Worktypes are like templates for jobs to make order entry a little quicker for standard types of jobs.</i><br><br>\r\n<p>From the Main Menu select Printing then Print Shop Setup then Worktypes.  Your screen will look similar to this:</p><center><img src=\"images/screenshots/worktype.jpg\" border=\"0\"></center>\r\n<p>To select an existing worktype to be edited, select from the drop-down list. Then click on the <img src=\"images/edit.gif\"> Edit button.</p>\r\n<p>To add a new worktype, click on the <img src=\"images/add.gif\">Add button.</p>\r\n<p>Whether adding or updating, your next screen will look similar to this:</p>\r\n<center><img src=\"images/screenshots/worktype1.jpg\" border=\"0\"></center>\r\n<b>Name:</b> The name should be a brief name for the product. Since you also have subgroups with names, this should be a general grouping such as \"Envelopes\"<br><br>\r\n<b>Description:</b> A full description of what this type of work consists of (more important the more complex the type of work).<br><br>\r\n<p>To delete an existing worktype, click on the <img src=\"images/delete.gif\">Delete button.</p>\r\n<p>When you have entered this information, click on the <img src=\"images/next.gif\">Next button.  Your next screen should look like this:</p>\r\n<center><img src=\"images/screenshots/worktype2.jpg\" border=\"0\"></center>\r\n<p>At first, you will see a list of subtypes already entered, and you can Edit these, Delete them, or click on the Add New Subtype button to create a new one.</p>\r\n<p>If you Add a new subtype or Edit an existing one, your screen will look similar to this:</p>\r\n<center><img src=\"images/screenshots/worktype3.jpg\" border=\"0\"></center>\r\n<p>NOTE: you can only edit one subgroup at a time, so pay attention to which one you are editing! The one your are editing will save \"editing\" next to the listing and it repeats the name above the one you are working on (these have been circled in red on the above screen display to make this clearer).</p><br>\r\n<p>\r\n<b>Subtype Name:</b> The name should be a brief name for the product. <br><br>\r\n<b>Description:</b> A full description of what this type of work consists of (more important the more complex the type of work).<br><br>\r\n<b>Usual Number of Parts:</b> How many stocks are usually required.<br><br>\r\n<b>Can be subcontracted:</b> Is this a job type that is Never, Always, or Sometimes vended outside.<br><br>\r\n<b>Usual Days to Complete -- Up to Quantity</b> This will be the default turnaround days for this type of work. To add a new quantity and days, click on the Add New button directly below this section.<br><br>\r\n<b>Family Functions this Subtype can Use:</b> By specifying functions (bindery, prepress, graphics, etc.) that can be a part of this type of work, you can prevent other questions from appearing during order entry. If you select no functions, then all will be included.<br><br>\r\n<b>Category:</b> This refers to inventory categories.  If, for example, you had a worktype that could only use bond paper, and your inventory had a special category for bond paper, you could limit inventory choices during inventory entry to just that category of stock.<br><br>\r\n<b>Part No.:</b> If only a single type of stock is ever used for this type of job, then you can select a specific inventory item that will be the one to be used.<br><br>\r\n<p>At the bottom you can either Add a new Subtype or click on Update Worktype to SAVE your work.<br><br>',311),(339,43,'Default Responses','<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Default Responses</font></b></center><br>\r\n <i>These are default responses for Worktypes.  The purpose is to automatically make certain selections of paper, press, etc. during order entry if a worktype is chosen.</i><br><br>\r\n<p>From the Main Menu select Printing then Print Shop Setup then Default Responses.  Your screen will look similar to this:</p>\r\n<center><img src=\"images/screenshots/default_response.jpg\" border=\"0\"></center>\r\n<p>The drop-down selection will show two columns. On the left will be the main worktype names followed by a colon. On the right are the subtypes contained in the worktypes.  Select the worktype:subtype to be edited, then click on the <img src=\"images/next.gif\"> Next button. Your screen will change to look similar to this:</p>\r\n<center><img src=\"images/screenshots/default_response2.jpg\" border=\"0\"></center>\r\n<p><b>NOTE:</B><i> If you see a message \"no questions\" then that means that in the worktype entry section, you did not specify any families to be automatically included in this subtype.</i></p>\r\n<p>Under each family that was created for this subtype will be the same questions you would see during order entry.  Make the selections here that are the most likely answers for this type of work.</p>\r\n<p>Click on the <img src=\"images/save.gif\"> Save button to save the entries. </p>\r\n<p>Clicking on the <img src=\"images/back.gif\"> Back button will return to the first screen without saving your changes.</p>',312),(340,43,'Printing Formulas','<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Formulas</font></b></center><br>\r\n <i>This is the section where you determine HOW the time is calculated, or what the materials calculations should be. You will undoubtedly need a number of these to cover all possibilities.  It is recommended that you enter a family, a machine, then start on the Family Calculations.  As you create these, you will see what formulas are required.  You can then bounce over to formulas (or keep two windows open, one for Family Calculations and one for Formulas) to create needed new calculations, then apply them in the Family Calculations section.</i><br><br>\r\n<p>From the Main Menu select Printing then Print Shop Setup then Formulas.  Your screen will look similar to this:</p>\r\n<center><img src=\"images/screenshots/formula.jpg\" border=\"0\"></center>\r\n<p>To select an existing formula, click on the formula name.  To create a new formula, click on the <img src=\"images/add.gif\"> Add button.</p>\r\n<p>Whether adding or editing, your next screen should look like this:</p>\r\n<center><img src=\"images/screenshots/formula2.jpg\" border=\"0\"></center>\r\n<p><b>Description:</b> Name of the formula - be sure to make the name specific enough that you won\'t wonder later when picking the formula just what it means!</p>\r\n<p><b>Formula: </b>In the colored box shown below the save, back and delete buttons, is a list of values you can use in your calculations.  You can also use actual numbers. The asterisk (*) is used to indicate multiplication, the plus sign (+) means add, and the minus sign(-) means subtract.  The forward slash (/) means divide.  You can use parentheses to group same as with any math formula. </p>\r\n<p>What you are trying to calculate depends on the calculation type selected.</p>\r\n<li>If the calculation type is RUN TIME, then you are wanting to end up with a quantity of pieces to be processed, as this number will be divided by the IPH entered under Machine Family. \r\n<li>If the calculation is OTHER TIME, then the result of your calculation should be hours.\r\n<li>If the calculation is MATERIALS, then the result of the calculation should be quantity of materials.<br>\r\n<p>Click on the <img src=\"images/save.gif\"> Save button to save your formula.</p>\r\n<p>Click on the <img src=\"images/back.gif\"> Back button to return to the first screen without saving your changes.</p>\r\n<p>Click on the <img src=\"images/delete.gif\"> Delete button to delete this formula.</p>\r\n<br>\r\n<p>You can test this formula for accuracy by clicking on the  \"test this\" link. The test screen will look similar to this:</p>\r\n<center><img src=\"images/screenshots/formula3.jpg\" border=\"0\"></center>\r\n<p>Now you can enter actual quantities in each of the needed fields, then click the \"Test Compute\" button to see what answer you will get.</p>  <p>When you are done with the test, click on the \"Save this calculation\" button.</p>\r\n\r\n\r\n\r\n',313),(341,43,'Locations','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Plant Locations</strong></font></div>\r\n<hr></hr>\r\n<em>This allows you to add or edit information on the locations \r\nwhere inventory is stored - different buildings, different \r\nwarehouses or different plants.  You must have at least one \r\nlocation.</em>\r\n<p>From the Main Menu select either Inventory then Setup then Locations OR Printing then Setup then Locations.</p>\r\n<p>Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Plant1.jpg\"> \r\n</p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit \r\n  an Existing Plant Location</strong></font></div>\r\n<hr>\r\n1) Select the Inventory Location you would like to edit from the pull-down list. \r\n<p>2) Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> Edit button. Your \r\n  screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Setup_Plant2.jpg\"></p>\r\n<p align=\"left\"><br>\r\n  3) Print Location: This is the only item on this screen needing explanation. If you have one of the Nolapro Print modules, then the location to draw inventory from should be check-marked. You must have AT LEAST ONE of the locations check-marked as a print location in order for the updates of inventory to work correctly from the Printshop Module. </p>\r\n<p>4) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save \r\n  the changes.</p>\r\n<p>5) Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> Delete button to \r\n  delete the location.</p>\r\n<p>6) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button to return \r\n  to the previous screen without saving the changes. </p>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Add a New Plant Location</strong></font></div>\r\n<hr>\r\n<p>1) Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> \r\n  Add button. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Setup_Plant3.jpg\">\r\n<p align=\"left\">2) Enter the necessary information for the new plant. </p>\r\n<p>\r\nPrint Location: This is the only item on this screen needing explanation. If you have one of the Nolapro Print modules, then the location to draw inventory from should be check-marked. You must have AT LEAST ONE of the locations check-marked as a print location in order for the updates of inventory to work correctly from the Printshop Module. </p>\r\n\r\n<p>3) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save \r\n  the new location.</p>\r\n\r\n</p>',314),(342,43,'Late Reasons','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Late Reasons</strong></font></div>\r\n<hr></hr>\r\n<em>When jobs are finalized past their due date, you can select from a list of reasons WHY the job was late. This is to assist in finding out the most common late reasons so those areas can be improved.</em>\r\n<p>From the Main Menu select Printing then Setup then Late Reasons. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/LateReason.jpg\"> \r\n</p>\r\n<p>To Edit an existing reason, highlight the reason to be edited, and click on the <img src=\"images/edit.gif\"> Edit button.  To add a new reason, click on the <img src=\"images/add.gif\"> Add button.</p><br>\r\n<p>Your screen should now look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/LateReason2.jpg\"> \r\n</p>\r\n<p>Edit the reason description.</p>\r\n<p>Click the <img src=\"images/save.gif\"> Save button to save your changes.</p>\r\n<p>Click the <img src=\"images/back.gif\"> Back button to exit without saving your changes.</p><p>Click the <img src=\"images/delete.gif\"> Delete button to delete this reason.</p>',315),(343,43,'Stock Purpose','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Stock Purpose</strong></font></div>\r\n<hr></hr>\r\n<em>Since orders can have more than one stock associated with them, as a convenient way of making it clear as to which stock is to be used for what purpose, you can enter a list of standard purposes (or simply call them Part 1, Part 2, etc.). When selecting the stock during order entry, these purposes will be selected with a drop-down list.  The first item (sort order = 1) will be the default selection.</em>\r\n<p>From the Main Menu select Printing then Setup then Stock Purpose. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/StockPurpose.jpg\"> \r\n</p>\r\n<p>To Edit an existing purpose, highlight the stock purpose to be edited, and click on the <img src=\"images/edit.gif\"> Edit button.  To add a new stock purpose, click on the <img src=\"images/add.gif\"> Add button.</p><br>\r\n<p>Your screen should now look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/StockPurpose1.jpg\"> \r\n</p>\r\n<p>Edit the stock purpose description.</p>\r\n<p>Sort Order: Assign the order in which the stock purposes should appear in the drop-down during order entry.  The purpose with the smallest sort order number will the the default selection.</p>\r\n<p>Click the <img src=\"images/save.gif\"> Save button to save your changes.</p>\r\n<p>Click the <img src=\"images/back.gif\"> Back button to exit without saving your changes.</p><p>Click the <img src=\"images/delete.gif\"> Delete button to delete this stock purpose.</p>',316),(344,43,'Work Areas','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Work Areas</strong></font></div>\r\n<hr></hr>\r\n<em>Work Areas should represent Departments within your printing plant. One might be Graphics & Typesetting, another Printing, another Bindery, etc. These names will show up repeatedly when using your program. They are the status headers in the Pending Order List, they are the tabs in the Time and Materials entry screens, etc.</em>\r\n<p>From the Main Menu select Printing then Setup then Work Areas. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/WorkArea.jpg\"> \r\n</p>\r\n<p>To Edit an existing work area, highlight the work area to be edited, and click on the <img src=\"images/edit.gif\"> Edit button.</p><p>To add a new work area, click on the <img src=\"images/add.gif\"> Add button.</p><br>\r\n<p>Your screen should now look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/WorkArea2.jpg\"> \r\n</p>\r\n<p>Edit the Work Area Name.</p>\r\n<p>Ask Instructions during Order Entry: Check this box if the answer is yes. During order entry, you can enter general production instructions. However, if you want to be able enter SPECIFIC instructions for just one department, check this box.</p>\r\n<p>Click the <img src=\"images/save.gif\"> Save button to save your changes.</p>\r\n<p>Click the <img src=\"images/back.gif\"> Back button to exit without saving your changes.</p><p>Click the <img src=\"images/delete.gif\"> Delete button to delete this stock purpose.</p>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Assign Workarea Order and Purpose</strong></font></center></div></div>\r\n<hr></hr> \r\n<p>From the first work area screen, click on <img src=\"images/completebill.gif\"> Assign. Your screen should change to look like this:</p>\r\n<center><img src=\"images/screenshots/WorkArea3.jpg\"></center><br>\r\n<p>The left-most column is your list of work areas. The next column is the FLOW order of the work through these work areas. You cannot have two work areas with the same sort order number.<p>\r\n<p>Special Purpose Assignments: Certain things are added to various screens in time and materials that are dependent on your selection of the right purpose. For example, in the Graphics purpose screens, you will see options about sending and receiving back proofs. Probably the most important one to get right is the one for printing. If the work area has a purpose of printing (and more than one CAN), the list of families using that work area will appear on the drop-down list of print machines to use (in the paper selection area of order entry).</p><br>\r\n<p>To Save your changes, click on the <img src=\"images/save.gif\"> Save button.</p>\r\n<p>To exit without saving, click on the <img src=\"images/back.gif\"> Back button.</p>\r\n',317),(345,43,'Quote Setup','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Quote Setup</strong></font></div>\r\n<hr></hr>\r\n<em>Formatting for pdf style printing quotes are made here, as well as standard information to use when emailing of quotes.</em>\r\n<p>From the Main Menu select Printing then Setup then Quote Setup. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/QuoteSetup.jpg\"> \r\n</p>\r\n<p>The first three items (From, Subject and Message) are used for emailing of quotes.</p>\r\n<li>From: your company email address for the quoting or sales department.\r\n<li>Subject: What appears on the subject line of the email.\r\n<li>Message: What appears in the body of the email.  The actual quote itself will be a pdf formatted attachment to the email.<br>\r\n<p>Lead Time: On the quote is a statement about number of days needed after quote is accepted. This is the number that should show in that statement.</p>\r\n<p>Also Offer: Place to suggest other services you offer, or new services that customers may not yet know about.</p>\r\n<p>Point #1 through Point #6: Paragraphs that will appear on quote to expain terms and conditions associated with all quotes.</p>\r\n<p>Click on the <img src=\"images/save.gif\"> Save button to save your changes.</p><br>\r\n',318),(346,43,'General Markup Information','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>General Markup Information</strong></font></div>\r\n<hr></hr>\r\n<em>Although called General Markup Information, this section is kind of the \"catch-all\" for printing setups.</em>\r\n<p>From the Main Menu select Printing then Setup then General Markups. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/GeneralMarkups.jpg\"> <br>\r\n</p>\r\n<p><b>Markup % for Special Order Stock:</b> Although most stock gets its markups from the inventory module, special orders need a place to get markups from. </p>\r\n<p><b>Markup % for Outside Purchases:</b> For outside vended work, whether part or entire job, apply this markup as the normal.</p>\r\n<p><b>Quantity Unit for Invoice:</b> The normal unit name to describe the order quantity when invoicing the order. These unit names can be created under Billing Setup or under Inventory Setup.</p>\r\n<p><b>Price Unit for Invoice:</b> The normal unit name to describe the pricing unit when invoicing the order. These unit names can be created under Billing Setup or under Inventory Setup.</p>\r\n<p><b>Qty Units/Price Unit:</b> How many of the quantity units are contained in a price unit. (If the quantity unit is sheets and the pricing unit is M or 1000\'s, then the response to this question is 1000).</p>\r\n<p><b>Unpaid days past invoice...:</b> This is used to determine when overdue messages should pop up during order entry.  The number entered will be the number of days past the invoice date. This does not look at the customer terms.</p>\r\n<p><b>First Order Period:</b> Used for the pending order report, which is broken into time frames to indicate how long orders have been in-house.</p>\r\n<p><b>Second Order Period:</b> Used for the pending order report, which is broken into time frames to indicate how long orders have been in-house.</p><br>\r\n<p>Click on the <img src=\"images/save.gif\"> Save button to save any changes made.</p><br>\r\n\r\n',319),(347,41,'Performance Statistics - Printshop','<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Performance Statistics</font></b></center><br>\r\n <i>This report is to provide several views as to how well you are meeting duedates. It is broken into performances based on number of orders, number of impressions, and total dollars. </i><br><br>\r\n<p>From the Main Menu select Printing then Reports then Performance Stats.  Your screen will look similar to this:</p><center><img src=\"images/screenshots/PerformanceStats.jpg\" border=\"0\"></center>\r\n<br>\r\n<p><b>Starting and Ending Dates:</b> Inclusive dates for report data.</p>\r\n<p><b>Select Order Status: Closed or Shipped.</b> When applying the dates, should it look at the final ship date or the date on which the order was ok\'d for billing.</p>\r\n<br>\r\n<p>Click on the <img src=\"images/next.gif\"> Next button to view the report.</p><br>\r\n<center><img src=\"images/screenshots/PerformanceStats2.jpg\" border=\"0\"></center>\r\n<br>\r\n<p>The top three pie charts are the visual representation of the data contained in the line just below the pie charts. These show the percentages of ORDERS, IMPRESSIONS, and DOLLARS that were shipped on-time, early, or late.</p>\r\n<p>Following is a list of all jobs included in the above totals with a color dot to indicate whether that particular job was early, on-time or late.<p>\r\n<p>And at the bottom is a percentage of jobs that were Normal Priority compared to total orders, or Rush Priority compared to total orders.</p>\r\n<br>\r\n',320),(348,41,'Proof History','<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Proof History</font></b></center><br>\r\n <i>The Proof History report gives you a way to determine when proofs were sent out, when they were returned, and if they were approved or needed revision. If one job had a proof go back and forth with the customer multiple times before they were happy, this will be easy to spot. Useful if a customer disputes the dates on which he got or returned proofs. </i><br><br>\r\n<p>From the Main Menu select Printing then Reports then Proof History.  Your screen will look similar to this:</p><center><img src=\"images/screenshots/ProofHistory.jpg\" border=\"0\"></center>\r\n<br>\r\n<p>Select the Proof Status type to be included in the report from the following dropdown: </p>\r\n&nbsp;&nbsp;&nbsp;&nbsp;<img src=\"images/screenshots/ProofHistory1.jpg\" border=\"0\">\r\n<br>\r\n<p>Click on the <img src=\"images/next.gif\"> Next button to proceed to the next screen:</p>\r\n<center><img src=\"images/screenshots/ProofHistory2.jpg\" border=\"0\"></center>\r\n<br>\r\n<p>Select the date range for the proof actions to be included int he report.  When done, Click on the <img src=\"images/next.gif\"> Next button.</p>\r\n<center><img src=\"images/screenshots/ProofHistory3.jpg\" border=\"0\"></center>\r\n<br>\r\n<p>Click on any of the column headers to resort the report by that field.</p>\r\n<p>Click on the <img src=\"images/back.gif\"> Back button to change your selections and create a new report.</p><br>',321),(349,41,'Variance Report - Printshop','<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Variance Report</font></b></center><br>\r\n <i>The variance report shows the differences between ESTIMATED and ACTUAL labor and materials for printshop orders. </i><br><br>\r\n<p>From the Main Menu select Printing then Reports then Variance.  Your screen will look similar to this:</p><center><img src=\"images/screenshots/Variance.jpg\" border=\"0\"></center>\r\n<br>\r\n<p>Pick the beginning and ending completion date for orders to be included in the variance report.</p>\r\n<p>Pick which type of variance report to run from the drop-down list.</p>\r\n<br>\r\n<p>Click on the <img src=\"images/next.gif\"> Next button to bring up the selected report.</p>\r\n<p><b>NOTE:</b><i> Variances will appear as negative variances (the estimated was MORE than the actual) or positive variances (the actuals were MORE than the estimated). On any one order, these variances will not indicate much. However, over time, the sum of all the variances in any given cost center can indicate either a problem or perhaps standards that are not realistic.</i></p><br>\r\n<br><hr><br><center><big>Summary by Order</big></center><br>\r\n<center><img src=\"images/screenshots/Variance1.jpg\" border=\"0\"></center>\r\n<br>\r\n<p>Clicking on the order number will bring up a detailed set of entries for time and materials for that order.</p>\r\n<p>Click on the <img src=\"images/back.gif\"> Back button to change the date selections for the report.</p>\r\n<br><hr><br><center><big>Detail by Order</big></center><br>\r\n<center><img src=\"images/screenshots/Variance2.jpg\" border=\"0\"></center>\r\n<br>\r\n<p>Clicking on the order number will bring up a detailed set of entries for time and materials for that order. The line containing the order number shows the sum of all costs for labor and materials.  Following the order number line will be a list of all cost centers used or estimated for the order and the labor and material variances for just that cost center.</p>\r\n<p>Click on the <img src=\"images/back.gif\"> Back button to change the date selections for the report.</p>\r\n<br><hr><br><center><big>Summary by Cost Center</big></center><br>\r\n<center><img src=\"images/screenshots/Variance3.jpg\" border=\"0\"></center>\r\n<br>\r\n\r\n<p>Click on the <img src=\"images/back.gif\"> Back button to change the date selections for the report.</p>\r\n<br><hr><br><center><big>Detail by Cost Center</big></center><br>\r\n<center><img src=\"images/screenshots/Variance4.jpg\" border=\"0\"></center>\r\n<br>\r\n<p>The line containing the cost center name shows the sum of all costs for labor and materials.  Following this line will be a set of lines containing order numbers showing labor and material variances for that order for that cost center.</p>\r\n<p>Click on the <img src=\"images/back.gif\"> Back button to change the date selections for the report.</p>\r\n<br><br>\r\n\r\n',322),(350,41,'Volume Report - Printshop','<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Volume Report</font></b></center><br>\r\n <i>The volume report shows daily flow of orders in and out of the print management system. For a specific month, it shows orders received, final shipped, priced for billing, and invoiced. </i><br><br>\r\n<p>From the Main Menu select Printing then Reports then Volume Report.  Your screen will look similar to this:</p><center><img src=\"images/screenshots/VolumeReport_Printshop.jpg\" border=\"0\"></center>\r\n<br>\r\n<p>To Change the month shown in the report, change the date at the top, then click on the <img src=\"images/next.gif\"> Next button.</p>\r\n<p>Drill down to data from any of the order counts of Received, Shipped, OK to Bill, or Invoiced.</p>\r\n<br><hr><br>\r\n<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Received Drill-down</font></b></center><br>\r\n<center><img src=\"images/screenshots/VolumeReport2_Printshop.jpg\" border=\"0\"></center>\r\n<br>\r\n\r\n<br><hr><br>\r\n<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Final Shipped Drill-down</font></b></center><br>\r\n<center><img src=\"images/screenshots/VolumeReport3_Printshop.jpg\" border=\"0\"></center>\r\n<br>\r\n\r\n<br><hr><br>\r\n<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Ok to Bill Drill-down</font></b></center><br>\r\n<center><img src=\"images/screenshots/VolumeReport4_Printshop.jpg\" border=\"0\"></center>\r\n<br>\r\n<br><hr><br>\r\n<center><font size=\"+1\" face=\"Arial, Helvetica, sans-serif\"><b>Invoiced Drill-down</font></b></center><br>\r\n<center><img src=\"images/screenshots/VolumeReport5_Printshop.jpg\" border=\"0\"></center>\r\n<br>\r\n\r\n',323),(351,8,'Pick Ticket','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Pick Ticket</strong></font></div>\r\n<hr></hr>\r\n<em>Pick Tickets show all the items contained in an order as a tool for the order-filler to use.</em> \r\n<ol>\r\n<li> You can print a pick ticket from any number of places. From Fulfillment Order Entry, the last step is a pick ticket. From the various pending order lists, you can click on the order number to get a copy of the pick ticket.</li></P>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/PickTicket.jpg\" ></p>\r\n\r\n<p align=\"left\">\r\n<li>To edit the order, click on the <img src=\"images/edit.gif\"> <b>Edit</b> button.</li></p>\r\n<li>To create a .pdf version of the Pick Ticket, click on the <img src=\"images/pdf.gif\"> <b>Print</b> button. The .pdf version looks like this:</li> </p>\r\n<p align=\"center\"><img src=\"images/screenshots/PickTicket2.jpg\" ></p>\r\n\r\n<p align=\"left\">\r\n<li>Click on the <img src=\"images/pdf.gif\"> <b>Confirmation</b> button to print an order Confirmation. Click on link below to see a sample.</li></p>\r\n\r\n<p align=\"left\">\r\n<li> Click on the <imb src=\"images/email.gif\"> <b>Email confirmation</b> button to email a copy of the Order Confirmation.  When emailing, the customer email addresses will be shown to allow you to select which ones should receive this confirmation. OR, you can enter addresses of your own to send this to. Click on link below to see a sample.</li></p>\r\n\r\n<li> To return to the previous screen, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n<br>\r\n',324),(352,9,'Volume Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Order Volume Report</strong></font> </div>\r\n<hr></hr>\r\n<em>Day-by-day report of orders received, shipped and billed for a selected month.</em>\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Reports -> Volume Report</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/FulfillmentVolume.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li> Select the <b>Month</b> and <b>Year</b> for the report from the pull-down boxes.</li></p>\r\n<li> Select <b>Order Type</b> for the report from the pull-down list. Your choices are Fulfillment Orders or Service Orders.</li></p>\r\n\r\n<li> When you have entered this information, then click on the <img src=\"images/next.gif\"> <b>Next</b> button to continue.</li></p>\r\n\r\n<li> Your screen should now look similar to this, with one line for each day in the month on which there was activity:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/FulfillmentVolume1.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> To drilldown and see details of the activity on the report, click on the <b>#Orders columns</b> (received, completed, or billed) in any of the days.</li>\r\n\r\n<li>At any point, you can change the month and year and/or the type of order, and click on the <img src=\"images/next.gif\"> <b>Next</b> button to create a new report.</li>\r\n</ol>\r\n<br>\r\n<hr>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Drilldown to #Orders Completed</strong></font></div>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/FulfillmentVolume2.jpg\" ></p>\r\n<br>\r\n',325),(353,12,'List Build Orders','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> List Build Orders</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_BuildOrderLists/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Produce a report of finalized Build Orders and the details of the orders.</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Manage Build Orders -> List Build Orders</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Manage4a.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the data into the following categories to narrow your report: </b></li></p>\r\n     <ol TYPE=\"a\">\r\n           <li><b>Begin and End Period: </b>Enter a date range for your report manually or click on the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> buttons to bring up a calendar.</li></p> \r\n           <li><b>Location: </b>Select ALL to include all locations, or select a  Location from the pull-down list.</li></p>\r\n      </ol>\r\n\r\n<li>To view your report, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Manage4.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button at the bottom of the scren.</li></p>',326),(354,12,'Item Detail History','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Item Detail History Report</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_itemDetailHistory/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>View a month-by-month breakdown of all sales, purchases and adjustments.</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Reports -> Item Detail History</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemHistory1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data into the following categories to narrow your report: </b></li></p>\r\n      <ol TYPE=\"a\">\r\n            <li><b>Item Name or Code â€“ ID:(required) </b> Enter Item Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the Item number directly into the box on the right. If you want to search by description, type of item, vendor, category, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n\r\n           <li><b>Location: </b> Select whether history is for a specific location or all locations from the pull-down list.</li></p>\r\n      </ol>\r\n\r\n<li>To view your report, click on the <img src=\"images/next.gif\"> <b>Next</b>  button. Your screen will look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemHistory2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To display other years, clicking on the previous year or next year (shown at the top above the details) to display the new data for that year.</li></p>\r\n\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n</ol>',327),(355,12,'Purchase Suggestion List','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Purchase Suggestion List</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_itemReorderList/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr>\r\n<em>This report will show you what items need to be ordered because they are at or below the reorder point. A format of this report is available that will generate a Purchase Order to a selected vendor.</em>\r\n<ol>\r\n\r\n<li>From the Main Menu, select <b><i>Inventory -> Reports -> Purchase Suggestion List</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemReorder_start.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data into the following categories to narrow your report: </b></li></p>\r\n\r\n      <ol TYPE=\"a\">\r\n            <li><b>Location: </b>Select ALL or specify a location chosen from the pull-down list.</li></p>\r\n            <li><b>Vendor Name - ID: </b><i>If you select a \"Vendor Purchase Suggestion\" for your report format, you MUST enter a vendor.</i> Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n            <li><b>Report Format: </b>There are two very different types of reports.</li></p>\r\n                <ul>\r\n                    <li><b>Vendor Purchase Suggestion: </b>Use this report format to auto-create a Purchase Order to a vendor.</li></p>\r\n                    <li><b>Items Needing Reorder: </b>Use this report format to produce a list of items that are at or below their reorder point as defined in the Item Location section of Item Add/Update.</li></p>\r\n                </ul>\r\n         </ol>\r\n\r\n<li>To produce the report you requested, click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p>\r\n</ol>\r\n<hr>\r\n<div align=\"center\"> <big> <strong> Report Using the Items Needing Reorder Option</strong></big></div>\r\n<hr>\r\n<p align=\"left\">\r\n<p>Note: If the warehouse name or item description or code end with \"...\", then positioning your mouse over the words will display the full text.</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_ItemReorder.jpg\"></p>\r\n<br>\r\n<p align=\"left\">\r\n\r\n<ol>\r\n<li>To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n</ol>\r\n<hr>\r\n<div align=\"center\"> <big> <strong>Report Using the Vendor Purchase Suggestion Option</strong> </big></div>\r\n<hr>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/VendorPurchaseSuggestion.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<p>Note: If the warehouse name or item description or code end with \"...\", then positioning your mouse over the words will display the full text.</p>\r\n<ol>\r\n<li><b>Enter the following information to create the Purchase Order to the Vendor.</b></li></p>\r\n      <ol TYPE=\"a\">\r\n             <li><b>Quantity: </b> The suggested quantity will appear in the box, but can be altered for this order.</li></p>\r\n             <li><b>Price/Unit: </b> The usual vendor pricing will appear here, but can be changed for this order.</li></p>\r\n             <li><b>Include?: </b> Check this box if you want it included in the Purchase Order that will be created when you SAVE.</li></p>\r\n             <li><b>Deliver How: </b> Select, from the pull-down list, the Delivery Method from your vendor to you.</li></p>\r\n             <li><b>Due Date: </b> Enter the date you expect delivery. Enter the date manually or select a date using the <img src=\"images/calendar.gif\"> <b>Calendar</b> button.</li></p>\r\n       </ol>\r\n\r\n<li>To create the Purchase Order after entering all the required information, click on the <img src=\"images/save.gif\"> <b>Save</b> button. Your screen will look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/VendorPurchaseSuggestion2.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>To print a copy of the Purchase Order, click on the <img src=\"images/pdf.gif\"> <b>Print</b> button.</li></p>\r\n\r\n<li>To return to the Purchase Suggestion List, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n</ol>',328),(356,23,'Item Search Categories','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Setup - Item Search Categories</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_SearchCategories/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Search Categories are for use with the Shopping Cart. It allows you to specify items as belonging to any number of groups, so when shoppers want to find something, it may appear under several different searches.</em>\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Setup - Inventory -> Item Search Categories</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemSearchCategoryUpdate.jpg\"> \r\n</p>\r\n<p align=\"left\">\r\n\r\n<p>Existing search categories and levels appear on the screen for reference. You can set a \"hierarchy\" or a \"parallel list\" of search categories in Inventory Setup.  A \"hierarchy\" setting allows you to set up categories with subcatgories underneath(called children) further subdividing the \"parent\" category. A \"parallel list\" is an independent list of categories and items can be attached to several of these categories at once.  See <b>Standard GL Accounts (Inventory)</b> in the Related Topics section at the bottom of this Help screen for instructions on setting this option.</p>\r\n\r\n<li><b>Select one of these actions: </b>\r\n    <ol TYPE=\"a\">\r\n          <li>To EDIT a Search Category, click on the word <font color=\"0000FF\"><b>Edit</b></font> to the right of the Search Category you want to edit.</li></p>\r\n          <li>To see the Subcategories beneath this main Category, click on any of the Search Category names.</li></p>\r\n          <li>To ADD a new Search Category(Level 1 or Parent), enter the name of the new Search Category or Subcategory in the empty box and click on the <img src=\"images/add.gif\"> <b>Add</b> button.</li></p>  \r\n          <li>To DELETE a Search Category, click on the word <font color=\"0000FF\"><b>Delete</b></font> to the right of the Search Category you want to delete.  You cannot delete a Search Category with Subcategories (children) underneath it. </li></p>\r\n\r\n<li>Whichever action you choose, your next screen will look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemSearchCategoryUpdate1.jpg\">\r\n</p>\r\n<p align=\"left\">\r\n\r\n<li>To EDIT a Subcategory, click on the name of the Subcategory in <b>bold</b>.  Edit the name of the category.  NOTE: You can assign these search categories and levels to individual items.</li></p>\r\n\r\n<li>To add a Subcategory, enter the Subcategory name in the empty box and click on the <img src=\"images/add.gif\"> <b>Add</b> button.</li></p>\r\n\r\n<li>To DELETE a Subcategory, click on the word <font color=\"0000FF\"> <b>Delete</b></font> to the right of the Subcategory you want to delete. </li></p>\r\n\r\n<li>To update the information, click on the <img src=\"images/save.gif\"> <b>Save</b> button.\r\n\r\n</ol>',329),(357,17,'Email Center','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Email Center</strong></font><a href=\"http://www.nolapro.com/training/admin/admin_email_center/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This area is for use when you want to send emails to customers, vendors, employees, etc.</em> \r\n<p>1) Click Admin.</P>\r\n<p>2) Click Email Center. Your screen should look similar to this: </p>\r\n<p align=\"center\"> <img src=\"images/screenshots/Admin_Email.jpg\" ></p><br>\r\n<blockquote>\r\n<b>From:</b> This should be the return email address (yours, most likely).<br>\r\n<b>Name:</b> Name of who is sending the email (probably the company name).\r\n<b>To:, CC: and BCC:</b> You can either type in a list of email addresses, or you can use the search button to the right to select from groups (vendors, employees, etc.) NOTE: This search process is described in the next section.<br>\r\n<b>Private:</b> Check this box if you want the email to appear to the receiver as though they were the only one getting the email.<br>\r\n<b>Subject:</b> What you want to appear on the subject line of the email.<br>\r\n<b>Message:</b> Text of what you want to say in the email.<br>\r\n<b>Attachments:</b> If you want to attach a file, picture, or other, use the BROWSE button to find it and attach it. Click on the <img src=\"images/add.gif\">Add Attachment button to add that attachment (this also allows you to then pick another attachment.<br>\r\n</blockquote>\r\n<p>When everything is complete, click on the Send Email button to sent the email.</p>\r\n<br><br><hr><br>\r\n<center><big><b>SEARCHING FOR EMAIL ADDRESSES</b></big></center>\r\n<em>If you clicked on one of the <img src=\"images/seek.gif\"> buttons, you will see a screen like this:</em>\r\n<br>\r\n<p align=\"center\"> <img src=\"images/screenshots/Admin_Email1.jpg\" ></p><br>\r\n<p>Depending on which of the tabs is selected (Customers, Employees, Salesmen, Users, Vendors), the questions that appear may be somewhat different.  However, the purpose of the questions is to limit the list that will appear when you click on the next button.</p>\r\n<p>Click on the <img src=\"images/next.gif\"> Next button to see the next screen:</p>\r\n<br>\r\n<p align=\"center\"> <img src=\"images/screenshots/Admin_Email2.jpg\" ></p><br>\r\n\r\n<p>Depending on the NUMBER PER PAGE selected on the prior screen, you may notice that you have a number of pages (shown as 1 2 3 >>) at the bottom of the screen. You can move between pages by clicking on the number of the page you want or by clicking on the >> arrows.</p>\r\n<p>Select all appearing in a page for either TO, CC or BCC by checking the ALL box in the appropriate column header.</p>\r\n<p>Select individual entries to receive the email by checking the box in the appropriate column for that entry.</p>\r\n<p>When you have selected all the ones you want to send an email to, click on the ADD ADDRESSES TO LIST button. Your screen will now change to look similar to this:</p>\r\n\r\n<br>\r\n<p align=\"center\"> <img src=\"images/screenshots/Admin_Email3.jpg\" ></p><br>\r\n<p>At the bottom of the screen you will see a list of all addresses selected. You can then select a different tab, add more addresses, etc. until you have all the addresses you want. Then you will click on the SEND BACK EMAIL ADDRESSES button. This will insert the appropriate email addresses into your main email page.</p><br><br>\r\n',330),(358,45,'Sales Process Add/Update','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales Process Add/Update</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_sales_process/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>A Sales Process ties and categorizes sales information data, such as type of lead, phone call content, notes, etc. to a client.</em>\r\n<p>From Main Menu select <b><i>Billing -> Sales Lead Tracking -> Sales Process Add/Update</i></b>.  Your screen should look similar to this:</P>\r\n<p align=\"center\"><img border=1 src=\"images/screenshots/Salesproc1.jpg\"> \r\n</P>\r\n<p>All customers listed here already have prior sales data listed.<br><br>\r\nTo EDIT their information, click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> EDIT button.<br><br>\r\nTo import a customer from the main list so you can add new sales information about them, click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> ADD button and you\'ll be taken to this screen:</p>\r\n\r\n<p align=\"center\"><img border=1 src=\"images/screenshots/Salesproc2.jpg\"> </P>\r\n<p align=\"left\">\r\nSimply select an customer from the pull-down list and click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> ADD Sales Process for Customer to input new sales data for them.\r\n\r\nTo return to the previous screen, click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button.</p>\r\n\r\nThe add/edit sales process information screen looks like this (note: the \"Add Sales Action\" button only appears on the edit screen):\r\n\r\n<p align=\"center\"><img border=1 src=\"images/screenshots/Salesproc3.jpg\"></p>\r\n<p align=\"left\"></p>\r\n<b>Enter or edit the following information:</b>\r\n<ol>\r\n<b><li>Salesman: </b> Select a Salesman from the pull-down list.</li>\r\n<b><li>Sales Status: </b> Select the Sales Status from the pull-down list.</li>\r\n<b><li>Contact: </b> Enter the name of your contact person for this company.</li>\r\n<b><li>Position: </b> Enter the position held by the contact person.</li>\r\n<b><li>Phone: </b> Enter the phone number(with the dashes) of the contact person.</li>\r\n<b><li>E-mail: </b> Enter the email address for this contact person.</li>\r\n<b><li>Category: </b>Select the Sales Category from the pull-down list. This Sales Category is NOT the same as the Receivables Sales Category. To create/edit Sales Lead Tracking Sales Categories go to <b><i>Billing -> Setup-Lead Tracking -> Sales Categories</b></i>.</li>\r\n<b><li>Lead Quality: </b>Select the quality of this lead from the pull-down list. Choices are Undetermined, Excellent, Good, Fair and Poor.</li>\r\n<b><li>Full Description of Sales Item(s):</b> Enter a full description of the items this contact is interested in buying.</li>\r\n<b><li>Notes: </b> Enter any notes pertinent to this customer.</li>\r\n<b><li>Estimated Sales Amount: </b> Enter the estimated sales amount you will realize from this customer.</li>\r\n<b><li>Completed Sales Amount: </b> Enter the final sales amount the customer actually spent.</li>\r\n</ol>\r\nClick the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save your changes.  You\'ll now find the customer in the first drop down list (see picture 1 above), and you can edit their information or add Sales Action activities to them.</p>\r\n<p>Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button to return to the previous screen WITHOUT saving changes.</p>\r\n<p>Click the <img src=\"images/addlocation.gif\" width=\"30\" height=\"30\"> Add Sales Action button to create Sales Action items for this customer.  See <b><i>Sales Tracker Entry Insert</b></i> in the Related Topics section below for explanation of this feature.</p>\r\n<p>Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> Delete button to delete the customer from the Sales Process screen.</p>\r\n\r\n\r\n',331),(359,45,'Sales Tracker Entry Insert','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales Tracker Entry Insert</strong></font></div>\r\n<hr></hr>\r\n<em>The Sales Tracker is a simple way to keep tabs on contact between your company and a particular customer.</em>\r\n<p>You will reach the Sales Tracker screen from editing a customer under the Sales Process screen or from direct entry via the Sales Action Report (see <em>Related Topics</em> section at the bottom).</P>\r\n\r\n<p>The Sales Tracker screen will look like this:</p>\r\n<p align=\"center\"><img border=1 src=\"images/screenshots/Salestrack1.jpg\"> \r\n</P>\r\n\r\n<p>There are two (2) sections: <b>Completed Action</b> and <b>Assign New Action</b>.  The most current action entered will be displayed.</p>  \r\n<b>Creating a New Entry</b>\r\n<blockquote>\r\nFor new entries, you simply choose the type of action, salesperson, date/time and fill in the comment box in the Completed Action area.  See <b><i> Sales Action </b></i> in the Related Topics section for more information on Sales Actions.  You then have the option to assign future contact with this company by filling out the Assign New Action area.<br>\r\nOnce completed, ensure the <b>Save as New Entry</b> button is marked (default) and click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button.</blockquote>\r\n\r\n<b>Updating an Action</b><blockquote>\r\n<p>When updating an Action, select that existing entry and transfer the Assign New Action data (in essence, the \"to do\" section) up to the Completed Action area (now shown as done) and then fill out updated Assign New Action data for the next scheduled task.  Choose <b>Save as New Entry</b> again and click on the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button.  You\'ll see it adds this new entry underneath the previous Sales Action.\r\n\r\n<p>The <b>Save as Changes</b> selection is only used to change incorrect information on an existing record, not to update client contact data.</blockquote>\r\n\r\n<p><b>Deleting an Entry</b><blockquote>\r\nTo delete an action, complete the <b>Completed Action</b> section at the top, matching the Action\'s information for Action, Salesman and Date/Time entries to the entry you want to delete.  Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> Delete button.  Run the <b>Sales Action Report</b> to verify the entry has been deleted.</p>\r\n\r\n',332),(360,46,'Sales Action','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales Action Add/Update</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_sales_actions/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>A Sales Action is something done by a salesperson in relation to a client (Called, Emailed, Onsite Visit, etc.)</em>\r\n<p align=\"left\"><ol>\r\n<li> From Main Menu select <b><i>Billing -> Setup-Lead Tracking -> Sales Actions</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img border=1 src=\"images/screenshots/Salesaction1.jpg\">\r\n</p>\r\n<p align=\"left\">\r\n<li> To <b>Edit</b> an existing Action, click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> <b>Edit</b> button.</li></p>\r\n<li> To <b>Add</b> a new Action, click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> <b>Add</b> button.</li></p>\r\n<li> Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img border=1 src=\"images/screenshots/Salesaction2.jpg\"> </P>\r\n<p align=\"left\">\r\n<li> Enter/edit the description of the Action.</li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save your changes.</li></p>\r\n<li> If EDITING, Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> <b>Delete</b> button to delete this Action.</li></p>\r\n<li> Click on the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to the previous screen WITHOUT saving your changes.</li></p>\r\n</p>\r\n</ol>',333),(361,46,'Sales Categories','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales Category Add/Update</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_sales_categories/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>A Sales Category is a custom area in which particular sales can be grouped for reporting purposes.  For example, a computer company may have Software Sales, Hardware Sales, Service Calls, Web Hosting, etc.</em>\r\n<p align=\"left\"> <ol>\r\n<li>From Main Menu select <b><i>Billing -> Setup-Lead Tracking -> Sales Categories</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img border=1 src=\"images/screenshots/Salescat1.jpg\"> \r\n</p>\r\n<p align=\"left\">\r\n<li> To <b>Edit</b> an existing Category, click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> <b>Edit</b> button.</li></p>\r\n<li> To <b>Add</b> a new Category, click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> <b>Add</b> button.</li></p>\r\n<li> Your screen should look simliar to this:</li></p>\r\n\r\n<p align=\"center\"><img border=1 src=\"images/screenshots/Salescat2.jpg\"> </p>\r\n<p align=\"left\">\r\n<li> Enter/edit the description for this Category.</li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save your changes.</li></p>\r\n<li> If EDITING, click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> <b> Delete</b> button to delete this Category.</li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to the previous screen WITHOUT saving your changes.</li></p>\r\n</p>',334),(363,45,'Sales Overview Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales Overview Report</strong></font></div>\r\n<hr></hr>\r\n<em>Gives an overview comparison of clients listed in your Sales Lead Tracking Database by your customization.</em>\r\n<p>From the Main Menu select <b><i>Billing -> Sales Lead Tracking -> Sales Overview Report</b></i>.  Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/RptSalesOver.jpg\"></P>\r\n<p align=\"left\">You can choose by any combination of variables to create a custom report for viewing.  </p>\r\n<p>Once your parameters are selected, click on the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button to generate your report, The report should look something like this:\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/RptSalesOver2.jpg\"></P>\r\n<p>You can edit information on the fly by selecting a client name and making changes.  Once you\'ve saved your changes, close that window to exit back to the report and \"refresh\" your screen.</p>\r\n<p>The report can be exported using the <img src=\"images/Excel.gif\" width=\"30\" height=\"30\"> Export button.</p>\r\n<p>To exit the screen, click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button.</p>',336),(364,45,'Sales Action Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Sales Action Report</strong></font></div>\r\n<hr></hr>\r\n<em>Gives an itemized listing of client contact by your personnel.</em>\r\n<p>From the Main Menu select <b><i>Billing -> Sales Lead Tracking -> Sales Action Report</b></i>. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/RptSalesAction.jpg\"></P>\r\n\r\n<p align=\"left\">You can choose by any combination of variables to create a custom report for viewing.  Once your parameters are selected, click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button to generate your report.  The report should look something like this:\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/RptSalesAction2.jpg\"></P>\r\n<p>You can edit information on the fly by selecting a client name and making  changes.  Once you\'ve saved your changes, close that window to exit back to the report and \"refresh\" your screen.</p>\r\n<p>To exit this screen, click on the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button.</p>',337),(366,47,'New Service Order','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> New Service Order</strong></font><a href=\"http://www.nolapro.com/training/ar/service_order_add/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Enter new Service type Orders.</em> \r\n<p align=\"left\"><ol>\r\n\r\n<li> From the Main Menu, select <b><i>Orders -> Service Orders Add/Update</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderUpdateService.jpg\" ></p>\r\n<p align=\"left\">\r\n<li> Do not enter any data, just click on the <img src=\"images/add.gif\"> <b>Add </b>button. Your screen will change to look like the following:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderAddService.jpg\" ></p>\r\n\r\n<p align=\"left\">\r\n<li> <b>Enter Data in the following categories:</b></li></p>\r\n     <ol TYPE=\"a\">\r\n          <li> <b>Location:</b> Select ship FROM default location from the pull-down list. You can over-ride this for specific items on an order. <i>NOTE: if you only have ONE location, this selection will not appear.</i> </li></p>\r\n          <li><b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> <b>Lookup</b> button for detailed searches.  <i><b>NOTE: </b>To Add a New Customer, Click on the <img src=\"images/add.gif\"> <b>Add</b> button next to the customer number entry. For help about adding customers, see that section, or click on the link at the bottom of this Help page.</i></li></p>\r\n        </ol> \r\n\r\n<li> Click on the <img src=\"images/next.gif\"> <b>Next</b> button to continue with this order.</li></p>\r\n<li> Your screen will change to look like the following:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderAddService2.jpg\" ></p>\r\n<p align=\"left\">\r\n<p> NOTE: At the top of the screen will be the customer information and status. You can EDIT the customer information by clicking on the <img src=\"images/edit.gif\"> <b>Edit</b> button, or look more closely at their current status by clicking on <b>VIEW ACCOUNT</b>.</p>\r\n\r\n<li> <b> Enter data into the following categories:</b></li></p>\r\n      <ol TYPE=\"a\">\r\n           <li> <b>Salesperson: </b>Select salesperson from the pull-down list.</li></p>\r\n           <li> <b>Price Level: </b>Select from the pull-down list which price level to use for the parts ordered. </li></p>\r\n           <li> <b>Sales Category: </b>Select a Sales Category for this Order from the pull-down list.</li></p>\r\n           <li> <b>Purchase Order: </b>Enter any customer supplied PO.</li></p>\r\n           <li> <b>Shipping Method: </b>Select a Shipping Method from the pull-down list.</li></p>\r\n           <li> <b>Due Date: </b>You can either enter the date manually or click \r\n    the <img src=\"images/calendar.gif\"> <b>Calendar</b> button to bring up a calendar.</li></p>\r\n           <li> <b>Service Needed: </b>Enter a complete description of the service required.</li></p>\r\n           <li> <b>Estimate Given: </b>If an estimate of the cost of doing this service was given, enter that here.</li></p>\r\n           <li> <b>Deposit With Order: </b>Enter here any amount paid with the order. <i>NOTE: If you enter a deposit amount, your screen will change to allow a  Payment Method to be entered and if you select <b>CREDIT CARD</b>, it will request the Credit Card information when you SAVE the order.</i></li></p>\r\n\r\n<p align=\"center><img src=\"images/screenshots/PaymentForOrderDetail.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n           <li> <b>Payment Method: </b>Select from the pull-down list. Examples: \r\nCredit Card, Open Account, Check, etc.</li></p>\r\n           <li> <b>Deliver To: </b>Select CUSTOMER PICKUP, or the address it will be shipped to from the pull-down list, or click on the <img src=\"images/add.gif\"> <b>ADD</b> button to create a brand-new ship-to address for this customer.\r\n        </ol>\r\n<br>\r\n<li> Click the <img src=\"images/save.gif\" > <b>Save</b> button to save the order. </li></p>\r\n<li> IF a deposit was paid with a <b>CREDIT CARD</b>, the amount of your deposit will display at the top of the following screen:</li></p><hr>\r\n<p align=\"center\"><img src=\"images/screenshots/CreditCardTran.jpg\"></p>\r\n<p align=\"left\">\r\n       <ul TYPE=â€?CIRCLEâ€?>\r\n            <li><b>Enter the information in the following categories:</b></li></p>\r\n         <ol TYPE=\"a\">     \r\n             <li> <b>Credit Card Processor: </b>Select from drop-down box.</li></p>\r\n             <li> <b>Credit Card Number: </b>Do NOT enter the dashes or spaces! </li></p>\r\n             <li> <b>Card Code: </b>Enter the security code from the back of the card (if required by your Credit Card Processor).</li></p>\r\n             <li> <b>Card expiration:</b> Select the Credit Card Expiration Month/Year from the pull-down list. </li></p>\r\n             <li> <b>Credit Card First Name: </b>First Name of credit card holder. </li></p>\r\n             <li> <b>Credit Card Last Name: </b>Last Name of credit card holder. </li></p>\r\n            <li> <b>Authorization Code: </b>Enter an Authorization Code, if required. Voice Authorization Codes are codes obtained from the Credit Card Processor when the transaction amount exceeds a dollar limit imposed by the Credit Card Processor. </li></p>\r\n         </ol>\r\n\r\n        <li> To process the transaction, click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p>\r\n\r\n        </ul>\r\n<hr>\r\n        \r\n<li> After saving the order and entering payment information(if required), your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderAddService3.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> To go back and add more orders, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n<li> To add labor and/or materials to the order immediately, click on the <img src=\"images/edit.gif\"> <b>Edit</b> button. For instructions on adding labor and materials to your Service Order, scroll to the bottom of this Help screen and click on <b>Update Service Order</b> in the Related Topics section.</li></p>\r\n<li> To view or print a copy of the Service Order, click on the <img src=\"images/print.gif\"> <b>Order Ticket</b> button.</li></p>\r\n\r\n<li> Your screen will look simliar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderAddService4.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li> To edit  the Service Order, click on the <img src=\"images/edit.gif\"> <b>Edit</b> button.  See <b>Update Service Order</b> in the Related Topics section below for instructions on editing a Service Order.</li></p>\r\n\r\n<li> To email a copy of the Service Order, click on the <img src=\"images/email.gif\"> <b>E-mail</b> button.  See <b>Email Center</b> in the Related Topics section below for instructions.</li></p>\r\n\r\n<li> To return to the previous screen, click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button. </li></p>\r\n\r\n<li> To view or print the Service Order, click on the <img src=\"images/pdf.gif\"> <b>Print</b> button. A sample Service Order Ticket is shown below:</li></p>\r\n\r\n<hr><br><p><big>SAMPLE ORDER TICKET (pdf version)</big></p>\r\n<p align=\"center\"><img src=\"images/screenshots/OrderAddService5.jpg\"></p>\r\n\r\n</ol>\r\n<br>',338),(367,47,'Update Service Order','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Update Service Order</strong></font><a href=\"http://www.nolapro.com/training/ar/service_order_update/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Use this to add new orders or to view/change an existing open order.</em> \r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Service Order Add/Update</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderUpdateService.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> If you are adding a new order, then click on the <img src=\"images/add.gif\"> <b>Add New</b> button, then view Help for <b>New Service Orders</b> found in the Related Topics section at the bottom of this Help screen.</li></p>\r\n<li>To select an existing order to update, enter any known data into the following categories (NOTE: The more information you fill in, the shorter the list of possible matches will be):</p>\r\n      <ol TYPE=\"a\">\r\n           <li><b> Order Number:</b></li></p>\r\n           <li><b> Purchase Order: </b></li></p>\r\n           <li><b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n           <li><b> Notes: </b> Enter keywords to use as search criteria, if desired.</b></li></p>\r\n           <li><b> Include Which: </b> Select STATUS of orders to be included in list (All Orders, Open Orders Only, Closed Orders Only, or Pending Quotes).</li></p>\r\n      </ol>\r\n\r\n<li> Click the <img src=\"images/next.gif\" > <b>Next</b> button. If there is more than one possible match, you must select the right one from the list, which should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderUpdateService2.jpg\" > \r\n<p align=\"left\">\r\n\r\n<li> To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n<li>Click on the <b>Order Number</b> you would like to view or change. In the status column you can see if the order is Open or Billed (had an invoice created in Receivables). Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/OrderUpdateService3.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<p><b>NOTE:</b> If you selected a Completed order, you can only PRINT the order, not edit it. </p>\r\n\r\n<li><b>Edit any information desired</b>.  To ADD a line item (parts) to an order, click on the small <img src=\"images/add.gif\" width=\"18\" height=\"18\"> <b>ADD</b> button on one of the blank lines. If you need to add more items and the screen is full, click on the <img src=\"images/add.gif\"> <b>ADD MORE LINES</b> button at the bottom of the screen.  For instructions on entering Line Items, see the <b>Adding Line Items(Parts) to an Order</b> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li>At the bottom of the screen, you can alter the estimated price of the job by changing the amount.</li></p>\r\n\r\n<li> Existing Credit Card Deposits will be displayed at the bottom of the screen. An example is shown below:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/DepositPopup2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To add additional payments on the order, click on the <img src=\"images/add.gif\" width=\"16\" height=\"16\"> <b>ADD</b> button to the right of the deposits-to-date. This will bring up a pop-up entry for the deposit information:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/DepositPopup.jpg\"></p>\r\n       <ol TYPE=\"a\">\r\n            <li>When you enter a deposit amount, the <b>Payment Method</b> box will become active on your screen.</li></p>\r\n            <li> IF a deposit was paid with a <b>Credit Card</b>, enter the information in the following categories:</b></li></p>\r\n                     <ol TYPE=\"1\">  \r\n                        <li> <b>Credit Card Type: </b>Select the card type from the pull-down list.</li></p>   \r\n                        <li> <b>Credit Card Number: </b>Do NOT enter the dashes or spaces! </li></p>\r\n                        <li> <b>Card expiration:</b> Select the Credit Card Expiration Month/Year from the pull-down list. </li></p>\r\n                       <li> <b>Credit Card First Name: </b>First Name of credit card holder. </li></p>\r\n                       <li> <b>Credit Card Last Name: </b>Last Name of credit card holder. </li></p>\r\n                    </ol>\r\n                 <ul TYPE=\"CIRCLE\">\r\n                      <li> To send the deposit for processing, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n                      <li> A screen will display confirming the credit card transaction details, to process the transaction, click on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p>\r\n                  </ul>\r\n         \r\n          <li> If the deposit is NOT paid with a credit card, click on the <img src=\"images/save.gif\"> <b>Save</b> button to save the deposit entry, or close the screen with the <img src=\"images/closewindow.gif\"> <b>Close Window</b>  button.</li></p>\r\n          </ol>\r\n<hr>\r\n<li>To get a shipping quote (or to enter a shipping charge), click on the <img src=\"images/ship.gif\"> <b>Get Shipping Quote</b> button. This calls the shipper web interface to find current shipping data.</li></p>\r\n<li>To add time to the order, click on <img src=\"images/morehours.gif\"> <b>ADD LABOR TIME TO ORDER </b> clock button.  For instructions on entering time into a Service Order, click on the <b>Log Time</b> topic in the Related Topics section at the bottom of this Help screen.</li></p>\r\n<li> To save your changes, click the <img src=\"images/save.gif\" > <b>Save</b> button.</li></p>\r\n\r\n<li> To create an invoice for this order, click the <img src=\"images/completebill.gif\" > <b>Invoice Now</b> button. You will see a screen confirming the creation of the invoices and allowing you to view them. Your screen will look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/OrdersToInvoice.jpg\"> </p>\r\n<p align=\"left\">\r\n    <ol TYPE=\"a\">\r\n        <li> To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n        <li> To view/print the invoices, click on the <img src=\"images/pdf.gif\"> <b>Print Invoices</b> button. <b>Note:</b> The number of invoices created will be displayed in the paranthesis.</li></p>\r\n        </ol>\r\n<li> To delete the Service Order, click the <img src=\"images/delete.gif\"> <b> Delete</b> button.</li></p>\r\n<li> To print a Service Order Ticket, click the <img src=\"images/print.gif\"> <b>Print</b> button.</li></p> \r\n<hr><br><br>\r\n</ol>\r\n<p align=\"left\">\r\n<b>NOTE: At the very bottom is an area where you can attach documentation about this order (an agreement, a picture of the piece you are to produce, etc.).</b> <br><br>\r\nTo add a new attachment, click on <b>UPLOAD</b>. To see how this entire process works, click on the <b>Attaching Files</b> link below in the Related Topics Section of this Help screen.<br><br>\r\n\r\n</div>',339),(368,49,'Log Time','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Processing - Service Orders > Log New Time</strong></font><a href=\"http://www.nolapro.com/training/ar/service_order_log_time/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n\r\n<em>Before entering time on service orders, you need to fill in Service Types, Service Classes and Service Order Labor Rates (under Billing > Setup Receivables).  You also need to mark which employees work as service employees, and which vendors are sub-contract for service order work.  The employee and vendor designations must be done AFTER the service types and classes are entered.</em> \r\n<ol>\r\n<li> From the Main Menu select <b><i>Orders -> Service Processing -> Log New Time</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderTime.jpg\" > \r\n</p>\r\n\r\n<li>There are two possible sections to this display: Current Work and Time Entry. You will only see the Current Work section if work has been started but not marked as finished. </li></p>\r\n\r\n<p><big><b>CURRENT WORK:</b></big></p>\r\n     <ol TYPE=\"a\">\r\n        <li>When this screen first appears, the Current Work section will show ONLY work that YOU entered as started -- even if you started the work for someone else. If you want to change this so you can see work started and not finished for ALL workers, click on the \"All Users\" in the upper left corner of the current work area.</li></p>\r\n        <li>If you want to see all work for a Specific (open) Order, enter the order number in the box to the right and click the <img src=\"images/next.gif\"> <b>Next</b> button to change the display.  To switch back to ALL orders, erase the entry in the Specific Order box and click the <b>Next</b> button again. NOTE: If you arrived at this screen from the Service Order Edit screen, the specific order will already be filled in.</li></p>\r\n        <li>To COMPLETE a time entry that was started but not ended (shows a red stop-light), you can either click on the stop-light or enter the total hours directly.</li></p>\r\n        <li>You can also enter <b>NOTES</b> under each time entry to explain what was done, discovered, etc. These notes will pass on to the invoice.</li></p>\r\n\r\n        <li>Be sure to click on the <img src=\"images/save.gif\"> <b>Save</b> button at the bottom of the screen to retain your changes.</li></p>\r\n     </ol>\r\n<br>\r\n<p><big><b>TIME ENTRY:</b></big></p>\r\n     <ol type=\"a\">\r\n        <li><b>Order</b>: Select the order from the drop-down list. <i>NOTE: If you have specified a specific order under Current Work section, then that is the only order you can select. To be able to select ANY order, erase the order number from Specific Order in the upper right corner and click the <b>Next</b> button</i>.</li></p>\r\n        <li><b>Worktype</b>: Select the Worktype from the drop-down list (these are created under Billing->Setup Receivables->Service Types). This name will appear on the invoices.</li></p>\r\n        <li><b>Worker</b>: Select the worker from the drop-down list. This will be either an employee or a sub-contractor. Employee names are followed by (E) and subcontractor names by (C).  Employees must be designated as Service Workers in Employee Add/Update. </li></p>\r\n        <li><b>Start/Stop</b>: Once you have selected an order, a worktype and a worker, a green light will appear in the start/stop column.  Clicking on the green light STARTS the clock on work for this order and changes the light to a red light. To STOP the clock, click the red light and the elapsed time will appear in the hours column.<i> NOTE: If you are going to leave or shut down your computer after STARTING the clock, be sure to click on the SAVE button to record the start time in the database. That way, the next time you return to this screen, you can end the time (it will show in the CURRENT WORK section).</i></p>\r\n       <li><b>Hours</b>: If you use the start/stop lights to calculate the time, you do not need to enter hours. However, if you want to just enter the time spent rather than have the clock track it, you can enter the hours here.</li></p> \r\n       <li><b>Notes</b>: Enter an explanation of work done or any other information you wish.  These notes will appear on the final bill.</li></p>\r\n       <li><b>Private</b>: Notes can be entered which will NOT show on the invoice, but will appear when editing the order.</li></p>\r\n       <li><b>Status</b>: You can also set the status of the order. This status will show on the Open Orders List. The list of status names is created in Billing->Setup Receivables->Service Status Options. </li></p>\r\n       <br>\r\n       <li>If you run out of space for entries, need to shut down your computer, or close the program, be sure to click on the <img src=\"images/save.gif\"> <b>Save</b> button to save your entries.</li></p>\r\n       </ol>\r\n',340),(369,49,'Edit Internal (non-billed) Time','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Processing - Service Orders > Edit Internal Work Time</strong></font><a href=\"http://www.nolapro.com/training/ar/service_order_edit_time/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Edit time entered for internal work.</em> \r\n\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Service Processing -> Edit Internal Work Time</b></i>.</li></p>\r\n \r\n<li> The screen defaults to a range of dates for the past week. <b>Select a date range for time entries</b>. Click on the <b>VOID checkbox</b> if you want to see deleted entries. Then click on the <img src=\"images/next.gif\"> <b>Next</b> button to view/update the entries.</li></p>\r\n\r\n<li> Your screen will now look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/OrderEditTime.jpg\" > \r\n<p align=\"left\">\r\n\r\n<li><b>You can edit the following categories: </b></li></p>\r\n     <ol TYPE=\"a\">\r\n          <li><b>Date:</b> - Edit the date in YYYY-MM-DD format.</li></p>\r\n          <li><b>Hours:</b> - Edit the hours worked, if needed.</li></p></li></p>\r\n          <li><b>Rate per Hour: </b> - Edit the Rate per Hour, if needed. The Rate per Hour comes from the rates entered in <b><i>Billing -> Setup-Receivables -> Service Labor Rates</b></i> for the type of service work on this entry.</li></p>\r\n          <li><b>Cost Per Hour: </b> - <i>NOTE: The COST comes from the employee pay rate plus FRINGES, or from the subcontractor cost per hour</i>. \r\n</li></p>\r\n          <li><b>Delete: </b> - To delete this entry, place a checkmark in this box.</li></p>\r\n          <li><b>Notes: </b> - Edit the Notes, if needed.</li></p>\r\n        </ol>\r\n<li>To save your changes after editing the information, click on the  <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n</ol>\r\n\r\n',341),(370,49,'Orders Over Estimate (Service Orders)','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Service Processing > Orders Over Estimate</strong></font><a href=\"http://www.nolapro.com/training/ar/service_orders_over_estimate/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This report actually shows both orders that have exceeded the estimated amount (only if an estimate was entered) or orders that are within 10% of the total estimated amount. </em> \r\n\r\n<ol>\r\n<li> From the Main Menu select <b><i>Orders -> Service Processing -> Orders Over Estimate</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderOverEstimate.jpg\" > \r\n<p align=\"left\">\r\n\r\n<li>If the <b>Charges to Date</b> column is RED, then the order has exceeded the estimated amount.  Otherwise, it is just getting close to the estimated amount. Only orders within 10% of the Estimate appear on this report.</li></p>\r\n<li> To edit an order on the list, click on the <b>Order Number</b> in the first column. Refresh (press F5) the screen after changes.</li></p>\r\n<li> Close the screen using the <b>Back</b> button on your browser.</li></p>\r\n</ol>\r\n',342),(371,11,'Add/Update Payment Plan','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Add/Update Payment Plan</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_paymentplan_add/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Add or enter Payment Plans (regularly scheduled amounts to be invoiced)</em>\r\n<p>From Main Menu select Billing, then Add/Update Payment Plans. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/PayPlanUpdate.jpg\"></p>\r\n\r\n<p>To ADD a new plan, click on the <img src=\"images/add.gif\"> Add button.</p>\r\n\r\n<p>To UPDATE an existing plan, fill out some of the displayed entries (Plan Number, PO Number, Customer, or some portion of Notes). This will cause a search for matches when you click on the <img src=\"images/next.gif\"> Next button.</p>\r\n<br><hr><br>\r\n<center><big><b>ADDING A NEW PAYMENT PLAN</b></big></center><br>\r\n<p>If you clicked on the ADD button on the first screen, you will then see a screen similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/PayPlanAdd1.jpg\"></p>\r\n<br>\r\n<p>NOTE: The large box with the customer information displayed does not appear until you have selected a customer.</p>\r\n<br>\r\n<blockquote>\r\n<b>Customer Code Number:</b> You can either enter the code number, click on the <img src=\"images/seek.gif\"> to lookup the customer, or if the customer does not yet exist, you can click on the <img src=\"images/add.gif\"> Add button to create a new customer entry. (To select the new customer after adding them, you must use the lookup button).<br>\r\n<b>First Payment Date:</b> The date of the first invoice to be generated for this payment plan. Click on the calendar button for help in selecting a date.<br>\r\n<b>Frequency:</b> Select from Daily, Weekly, Monthly, Quarterly, Yearly or Custom. Custom allows you to enter the actual number of days between invoices.<br>\r\n<b>Custom Frequency Days:</b> ONLY enter if selection on drop-down for Frequency is CUSTOM.<br>\r\n<b>Number of Times to Invoice:</b> This is a count-down number that will change each time a new invoice is generated.  When this number reaches zero it will stop creating new invoices. To have the system keep sending invoices until you tell it to stop, enter a -1 (negative one) here.<br>\r\n<b>Include Coverage Period:</b> A message is printed on the Invoice generated indicating the period of time the invoice covers. Select from Do not display coverage period, Display Coverage:Period Start=Date of Invoice, or Display Coverage:Period:End=Date of Invoice in the drop-down box.<br>\r\n</blockquote>\r\n<br>\r\n<p>Click on the <img src=\"images/next.gif\">Next button to continue. Your next screen should look similar to this:</p>\r\n<br>\r\n<p align=\"center\"><img src=\"images/screenshots/PayPlanAdd2.jpg\"></p>\r\n<br>\r\n<blockquote>\r\n<b>Ship To:</b> Select a ship-to address from the drop-down selection (or enter a new ship-to address by clicking on the <img src=\"images/add.gif\"> Add button to the right of the drop-down).<br>\r\n<b>Plan Number:</b> This is the BASE number for invoices to be generated. Actual invoices will combine this with -01, -02, -03, etc.<br>\r\n<b>Sales Category:</b> Select Sales Category from pull-down list.<br>\r\n<b>Purchase Order:</b> If the customer has issued a PO Number for this purchase, enter than number here so it will appear on their invoices.<br>\r\n<b>Customer Bill Code:</b> If the customer needs you to put his account code on invoices, enter that number here. (This defaults to the number entered in customer entry).<br>\r\n<B>Sales Person:</b> Select the salesperson responsible for the sale from the drop-down box.<br>\r\n<b>Invoice Terms:</b> Select the invoice terms to be used on invoices issued for this payment plan. The default will be the terms entered in the customer entry section.<br>\r\n</blockquote>\r\n<br>\r\n<p>To start all over, click on the <img src=\"images/back.gif\"> Back button.</p>\r\n<p>Click on <img src=\"images/next.gif\"> Next button to move to the next screen:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/PayPlanAdd3.jpg\"></p>\r\n<br>\r\n<blockquote>\r\n<b>Description:</b> Enter the description. If you need more space than is available on one block, simply move to the next description block to continue.<br>\r\n<b>Price (period):</b> What shows in place of period will be what you selected on the previous screen. Enter the amount to be billed each invoice.<br>\r\n<b>Unit:</b> Below the price entry is the unit name description. Select the appropriate unit from the drop-down box.<br>\r\n<b>Tax?:</b> If this is a taxable item, check the box, if not taxable, leave unchecked. The taxable status will default to the customer usual tax status.<br>\r\n<b>GL Sales Account:</b> Select the account in General Ledger that this sale should post into.<br>\r\n</blockquote>\r\n<p>If you need more lines than the five originally displayed, click on the <img src=\"images/add.gif\"> button to display more input lines.</p>\r\n<p>When you have completed your entries, click on the <img src=\"images/next.gif\"> Next button. This will bring up a screen similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/PayPlanAdd4.jpg\"></p>\r\n<br>\r\n<blockquote>\r\n<b>Taxes:</b> If you selected that this is a taxable item, then you will see a  list of the taxes assigned to this customer, along with the amount of tax calculated. You can over-ride the tax if you wish.  This is the amount of tax PER BILLING period.<br>\r\n</blockquote>\r\n\r\n<p>If you want to enter the COST OF GOODS for this invoice, click on the <img src=\"images/costofgoods.gif\"> Enter COGS button, which brings up this screen.</p>\r\n\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceEnterCOGS.jpg\" ></p>\r\n<p align=\"left\">a) Enter Cost of Goods in appropriate box.</p>\r\n<p>b) Select GL account from the pull down list.</p>\r\n<p>c) Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save the entry and open up another line for entering more costs. </p>\r\n<p>When you have entered all the costs you want (and SAVED them), exit by clicking on the <img src=\"images/closewindow.gif\"> Close Window button.</p><br><br>\r\n\r\n<p>When you have entered everything required, click on the <img src=\"images/next.gif\"> Next button to finalize this payment plan entry, which brings up this screen, which has a BACK button to re-start on another Payment plan:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/PayPlanAdd5.jpg\" ></p><br>\r\n\r\n<br><hr><br>\r\n<center><big><b>UPDATE AN EXISTING PAYMENT PLAN</b></big></center><br>\r\n<p>If you clicked on the <img src=\"images/next.gif\"> Next button on the first screen, you will then see a screen similar to this (if there are multiple plans that fit the search criteria. Otherwise skip to the next step):</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/PayPlanUpd1.jpg\"></p>\r\n<br>\r\n<p>Click on the number of the payment plan you want to update.</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/PayPlanUpd2.jpg\" ></p><br>\r\n<p>Update any of the information desired, including Cost of Goods Sold (by clicking on <img src=\"images/costofgoods.gif\"> button. <i>NOTE: For details about input fields, see ADD section above.</i></p>\r\n<p>When editing is complete, click on <img src=\"images/save.gif\"> to SAVE your changes.</p><br>\r\n\r\n',34),(373,49,'Time Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Orders - Service Processing > Time Report</strong></font><a href=\"http://www.nolapro.com/training/ar/service_order_time_report/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Report of time worked on service orders. Run report for specific Employee or specific Order, or range of dates.</em> \r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Service Processing -> Time Report</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderTimeReport.jpg\" > </p>\r\n<p align=\"left\">\r\n\r\n<li><b> Enter data into the following categories to customize your report:</b></li></p>\r\n     <ol TYPE=\"a\">\r\n\r\n         <li><b>Begin Period: </b>Starting work date for service order work. Enter the date or select the date using the <img src=\"images/calendar.gif\" height=\"16\" weight=\"16\"> <b>Calendar</b> button.</li></p>\r\n         <li><b>End Period: </b>Ending work date for service order work.  Enter the date or select the date using the <img src=\"images/calendar.gif\" height=\"16\" weight=\"16\"> <b>Calendar</b> button.</li></p>\r\n         <li><b>Specific Order: </b>Choose one of the following choices:</li>\r\n              <ul TYPE=\"DISC\">\r\n                  <li>Enter a specific Order Number to limit the report to ONE order ONLY.</li>\r\n                  <li>Enter \"-1\" to retrieve Internal Work Only. </li>\r\n                  <li>Leave blank for all orders.</li>\r\n             </ul></p>\r\n         <li><b>Specific Worker: </b>Select All Employees, or limit the report by selecting a specific worker from the pull-down list.</li></p>\r\n         <li><b>Show Notes: </b>Check this box if you want to see the notes entered along with the times. Leave unchecked for just hours.</li></p>\r\n\r\n      </ol>\r\n<li> To proceed with the report, click on the <img src=\"images/next.gif\"> <b>Next</b> button. The report should look similar to the following:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderTimeReport2.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> To export this report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button at the bottom of the screen.</li></p>\r\n<li> To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n</ol>',344),(374,11,'Void Payments','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Void Payments</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_void_payment/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>If a payment gets entered in error, then Void Payments is the way to back out the payment, so it can be put in correctly.</em>\r\n<p>From Main Menu select Billing, then Processing, then Void Payments. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceVoidPayments.jpg\"></P>\r\n<br>\r\n<blockquote>\r\n<b>Begin Period: </b>Enter the beginning payment date to search for the payment to be voided. Click on the calendar icon to help select the date.<br>\r\n<b>End Period: </b>Enter the ending payment date to search for the payment to be voided. Click on the calendar icon to help select the date.<br>\r\n<b>Customer Name-ID: </b>To search for payments made by a specific customer, enter the customer name to see a pull-down list, enter the customer number, or use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> Lookup button to find the customer number.<br></blockquote>\r\n<p>Click on the <img src=\"images/next.gif\"> next button to proceed to the next screen which will look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceVoidPayments2.jpg\"></P>\r\n\r\n<br>\r\n<p>Check the box next to any payment to be voided.  When you have selected the payments to void, click on the <img src=\"images/voidcheck.gif\"> void button to actually process the voids.</p>\r\n<p>When voiding a payment, it backs the payment out of the invoice and general ledger.  If the invoice was closed by this payment, it will re-open the invoice. </p>\r\n<p>Payments by check that have been deposited in the bank and have cleared the bank show \"Deposited in Bank\" and cannot be voided unless marked as Returned. Any check payments that have been deposited in the bank and are returned due to insufficient funds, can be marked as Returned. This \"undeposits\" the check and allows you to void the payment if necessary.</p>\r\n<br>\r\n',42),(375,11,'Non-Invoiced Sales','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Non-Invoiced Sales</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_cash_receipts_no_invoice/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Enter/update sales receipts for which no invoice is entered --- or if you are on a CASH system, enter all receipts here. </em>\r\n<p>From the Main Menu select Billing, then Processing, then Non-Invoiced Sales. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/ARCashReceipts.jpg\"></P>\r\n\r\n<br><hr><br>\r\n<center><big><b>ADD NEW RECEIPTS</b></big></center><br>\r\n<p>Click on the <img src=\"images/add.gif\"> add button to start a new receipt. Your screen will look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/ARCashReceiptsAdd.jpg\"></P><br>\r\n<blockquote>\r\n<p><b>Customer Name - ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"25\" height=\"25\"> Lookup button for detailed searches.  To add a customer, click on the <img src=\"images/add.gif\" width=\"20\" height=\"20\"> Add button.</p>\r\n<p><b>Description: </b> Description of sale (customer name, or item sold, or whatever might help later on when trying to track down a sale).</p>\r\n<p><b>Sales Category: </b> Select a Sales Category from the pull-down list.</p>\r\n<p><b>Payment Date: </b> This default to current date, but you may change it. Click on the <img src=\"images/calendar.gif\" width=\"25\" height=\"25\"> Calendar button to help with date selection.</p>\r\n<p><b>Taxable Sale Amount: </b> You will need to separate taxable from non-taxable portions of a sale so that your sales tax reports are accurate. Enter the taxable amount here (pre-tax).</p>\r\n<p><b>Tax-Exempt Sale Amount: </b> Enter any non-taxable sales amounts here.</p>\r\n<p><b>Exempt Reason: </b>If you entered non-taxable sale amounts, you will need to indicate the REASON why this sale is exempt. Select the reason from the pull-down list.</p>\r\n<p><b>GL Sales Account: </b> This will default to the standard sales account but you can use the pull-down list to select a different account.</p>\r\n<p><b>COGS Amount: </b> Enter the Cost of Goods Sold amount. </p>\r\n<p><b>GL Account for COGS: </b>GL Account for Cost of Sales amount entered on previous line.</p>\r\n<p><b>Sales Tax 1-3: </b>Select applicable tax(es).</p>\r\n<p><b>Tax Amount 1-3: </b>Amount of tax for tax districts selected.</p>\r\n<p><b>Paid How: </b>Select whether payment was check, cash, credit card, or other. When payment is by credit card, it is assumed that this was processed separately to the bank.</p>\r\n</blockquote>\r\n<br>\r\n<p>When you have completed the entries, click on <img src=\"images/save.gif\"> save button to save. After saving, you will be given another blank ADD screen. To return to the UPDATE section, click on the <img src=\"images/back.gif\"> back button.</p><br>\r\n\r\n<br><hr><br>\r\n<center><big><b>VIEW/UPDATE/DELETE RECEIPTS</b></big></center><br>\r\n<p>On the first screen,  select search restrictions:  Begin and End dates of entry, part of the description, and/or customer number.  When these have been entered, click on the <img src=\"images/next.gif\"> next button to see a list of receipts that fit the selections: </p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/ARCashReceiptsUpd.jpg\"></P><br>\r\n<p>Click on the id number of the receipt you want to edit or delete. Your screen will change to look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/ARCashReceiptsUpd2.jpg\"></P><br>\r\n\r\n<blockquote>\r\n<p><b>Customer Name - ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"25\" height=\"25\"> Lookup button for detailed searches.  To add a customer, click on the <img src=\"images/add.gif\" width=\"20\" height=\"20\"> Add button.</p>\r\n<p><b>Description: </b> Description of sale (customer name, or item sold, or whatever might help later on when trying to track down a sale).</p>\r\n<p><b>Payment Date: </b> This default to current date, but you may change it. Click on the <img src=\"images/calendar.gif\" width=\"25\" height=\"25\"> Calendar button to help with date selection.</p>\r\n<p><b>Taxable Sale Amount: </b> You will need to separate taxable from non-taxable portions of a sale so that your sales tax reports are accurate. Enter the taxable amount here (pre-tax).</p>\r\n<p><b>Tax-Exempt Sale Amount: </b> Enter any non-taxable sales amounts here.</p>\r\n<p><b>Exempt Reason: </b>If you entered non-taxable sale amounts, you will need to indicate the REASON why this sale is exempt. Select the reason from the pull-down list.</p>\r\n<p><b>GL Sales Account: </b> This will default to the standard sales account but you can use the pull-down list to select a different account.</p>\r\n<p><b>COGS Amount: </b> Enter the Cost of Goods Sold amount. </p>\r\n<p><b>GL Account for COGS: </b>GL Account for Cost of Sales amount entered on previous line.</p>\r\n<p><b>Sales Tax 1-3: </b>Select applicable tax(es).</p>\r\n<p><b>Tax Amount 1-3: </b>Amount of tax for tax districts selected.</p>\r\n<p><b>Paid How: </b>Select whether payment was check, cash, credit card, or other. When payment is by credit card, it is assumed that this was processed separately to the bank.</p>\r\n</blockquote>\r\n<br>\r\n<p>Click on the <img src=\"images/save.gif\"> save button to save changes.</p>\r\n<p>Click on the <img src=\"images/back.gif\"> back button to return to selection.</p>\r\n<p>Click on the <img src=\"images/delete.gif\"> delete button to delete this cash receipt entry.</p>\r\n<br>\r\n',43),(376,11,'Payment Plan Post','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Post Payment Plans</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_paymentplan_post/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Post all payment plans that are due through a given date.</em>\r\n<p>From Main Menu select Billing, then Processing, then Post Payment Plans. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/PayPlanPost.jpg\"> </P>\r\n<p align=\"left\">Specify which groups to post:</P>\r\n<blockquote> \r\n  <p align=\"left\"> a) <strong>Post Plans Due Through</strong> Post any payments due since the last time posted through the date specified here (could create multiple invoices if the time frame encompasses more than one payment period.<br>\r\n    b) <strong>Include Which: </strong> Select which group to include from the drop-down list.<br>\r\n</blockquote><br>\r\n<p align=\"left\">Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> \r\n  Next button. Your screen should look similar one of the following:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/PayPlanPost2.jpg\"> </P>\r\n<br>\r\n<p>You will see a list of all plans that will post. To NOT post one of the list, uncheck the box in the POST column.</p>\r\n<p>When you have the group to be posted selected correctly, click on the <img src=\"images/next.gif\"> next button to actually create the invoices. Your screen will change to look similar to this: </p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/PayPlanPost3.jpg\"> </P><br>\r\n<p>You will see a list of created invoices.  To print the entire group at once, click on the <img src=\"images/print.gif\"> print button.</p>\r\n<p>To print individual invoices, click on the <img src=\"images/pdf.gif\"> .PDF button on the invoice line you want to print.</p><br>\r\n<p>Click on the <img src=\"images/back.gif\"> back button to return to the original Post screen.</p><br>\r\n',34),(377,11,'Reprint Invoices','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Reprint Invoices</strong></font></div>\r\n<hr></hr>\r\n<em>Reprint invoices for any group of invoices or print or send an email copy of the invoice for specific invoices.</em>\r\n<p>1)  From Main Menu select Billing, then Processing, then Reprint Invoices. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/ReprintInvoice.jpg\"></P>\r\n<br>\r\n<p align=\"left\">To create a list of invoices to be reprinted, you can enter a range of dates and/or enter a range of Invoice numbers.</p>\r\n<p>2) Enter beginning and ending invoice dates or select dates using the <img src=\"images/calendar.gif\" width=\"16\"  height=\"16\"> Calendar button.</p>\r\n<p> Â Â Â Â Enter the beginning and ending invoice numbers to be included in list.</p>\r\n<p>3) Select which Invoices (Any, Open, or Paid) you want to appear on the list.</p>\r\n<p>4) When you have made the entries as to what invoices to show on list, click on the <img src=\"images/next.gif\"> Next button. Your next screen will look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/ReprintInvoice2.jpg\"></P>\r\n<p>You will see a list of invoices that match the criteria entered on the previous screen. </p>\r\n<p>5) To batch print all of the invoices in the list, click on the <img src=\"images/pdf.gif\"> .PDF button.</p>\r\n<p>6) To print individual invoices from the list, click on the invoice number.</p>\r\n<p>7) To email a copy of the invoice, click on the <img src=\"images/email.gif\"> email button. Clicking here will bring up the following screen before the email is actually sent:</p>\r\n<br>\r\n<p align=\"center\"><img src=\"images/screenshots/ReprintInvoice3.jpg\"></P>\r\n<br>\r\n<p>You will see a list of any email addresses assigned to this customer, PLUS additional blank lines where you can enter specific email addresses. </p>\r\n<p>Be sure to check the box next to any email addresses that should receive a copy of this invoice.</p>\r\n<p>When the invoice has been emailed, this email window will close automatically.</p>\r\n\r\n\r\n',345),(378,11,'Refund Credit by Check','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Refund Credit Balance by Check</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_refund_credit/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Write a check to cancel out a credit balance on customer account.</em>\r\n<p>From Main Menu select Billing, then Processing, then Refund Credit by Check. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/RefundCreditBalance.jpg\"></P>\r\n<br>\r\n<blockquote>\r\n<b>Invoice #: </b>If the refund is for a specific invoice, you can enter that number here.  If the refund will cover multiple invoices, leave this field blank.<br> <br>\r\n<b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> Lookup button for detailed searches.<br> <br>\r\n<b>Check Date: </b>This will default to the current date, but can be changed by entering the date or selecting the date using the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> Calendar button.<br> <br>\r\n<b>Checking Account: </b>Pick which checking account (unless you only use one) the refund should be written on.<br> <br>\r\n<b>Endorser: </b>This will default to the usual endorser name for this checking account, but can be overwritten.<br> <br>\r\n<b>Check Number: </b>The check number will default to the next check number for the checking account chosen, but can be changed.<br>\r\n\r\n</blockquote>\r\n<p>When you have made your entries, click on the <img src=\"images/next.gif\"> Next button to continue.  Your screen will now look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/RefundCreditBalance2.jpg\"></P><br>\r\n<p>You will see a list of invoices that match the selection. You can then select which ones you want to be included in the refund check.</p>\r\n<p>As you check-mark those invoices (credits) to be refunded, the check total will automatically update.</p>\r\n<p>When you have selected the correct invoices, click on <img src=\"images/next.gif\"> Write Check button to create the check.</p>\r\n<p>Your screen will now look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/RefundCreditBalance3.jpg\"></P><br>\r\n<p>Click on the check number to print a copy of the check.</p>\r\n<p>Click on the <img src=\"images/back.gif\"> Back button to return to the first screen.</p><br>',346),(379,11,'Non-Invoiced Sales Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Non-Invoiced Sales Report</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_cash_receipts_no_invoice_report/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>List of Sales Receipts entered without Invoices. </em>\r\n<p>From the Main Menu select Billing, then Reports, then Non-Invoiced Sales. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/ARCashReceiptsRpt.jpg\"></P>\r\n<br><p>Enter search criteria for report.</p>\r\n<blockquote>\r\n<p><b>Begin Payment Date: </b>To limit report to specific range of dates received, enter beginning date or use the <img src=\"images/calendar.gif\" width=\"20\" height=\"20\"> Calendar button to select a date.</p>\r\n<p><b>End Payment Date: </b>To limit report to specific range of dates received, enter ending date or use the <img src=\"images/calendar.gif\" width=\"20\" height=\"20\"> Calendar button to select a date.</p>\r\n<p><b>Description: </b>Enter any word or phrase from the description field to limit list to only entries containing that word or phrase in the description.</p>\r\n<p><b>Customer Name - ID: </b>Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> Lookup button for detailed searches.</p>\r\n<p><b>Select Sales Category: </b>To narrow the report to a specific Sales Category, select a Sales Category from the pull-down list.</p>\r\n</blockquote>\r\n<br>\r\n<p>When the limiting criteria have been entered, click on the <img src=\"images/next.gif\"> next button to create the report.</p>\r\n<p>Your next screen will look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/ARCashReceiptsRpt2.jpg\"></P><br>\r\n<p>To edit a one of the reciept entries, click on the Receipt ID.</p>\r\n<p>Click on the <img src=\"images/back.gif\"> Back button to return to the criteria entry screen.</p><br>\r\n\r\n\r\n',43),(380,11,'Payment Plan List','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Payment Plan List</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_paymentplan_report/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Lists of Payment Plans - both pending and completed.</em>\r\n<p>From Main Menu select Billing, then Reports, then Payment Plan List. Your screen should look similar to this:</P>\r\n<p align=\"center\"><img src=\"images/screenshots/PaymentPlanRpt.jpg\"> </P>\r\n<p align=\"left\">Specify criteria for which plans to include in list:</P>\r\n<blockquote>\r\n<b>Begin Due Date: </b>To limit list by next post due date, enter a date here and in End Due Date.<br>\r\n<b>End Due Date: </b>To limit list by next post due date, enter a date here and in Begin Due Date.<br>\r\n<b>Show Plans: </b>Select whether to show ALL, Pending Only, or Completed Only plans.<br>\r\n<b>Report: </b>Select detail for report from the drop-down list.<br>\r\n<b>Order By: </b>Select sort order for report from the drop-down list.<br>\r\n<b>Include Which: </b>Select plan frequency (weekly, quarterly, etc.) to be included in list.<br>\r\n</blockquote>\r\n<p>Once all the criteria have been entered, click on the <img src=\"images/next.gif\"> next button to create the report.  Your screen should then look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/PaymentPlanRpt2.jpg\"> </P>\r\n<br>\r\n<p>To edit a particular plan, click on the plan number.</p>\r\n<p>To return to the report criteria selection screen, click on the <img src=\"images/back.gif\"> back button.</p><br>',34),(381,22,'Service Types Add/Update','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Service Types</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_service_types/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Service Types are used when grouping labor onto service orders. All hours of the same TYPE of work and the same rate, will group onto the invoice.</em>\r\n<p align=\"left\"><ol>\r\n<li> From the Main Menu select <b><i>Billing -> Setup-Receivables -> Service Types</b></i>.</li></p>\r\n\r\n<li> Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/ServiceType.jpg\" ></p>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit an Existing Service Type</strong></font></div>\r\n<hr>\r\n<ol><p align=\"left\">\r\n<li> Select the Service Type to be edited from the pull-down list.</li></p>\r\n<li> Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> <b>Edit</b>  button. Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/ServiceType2.jpg\" ></p>\r\n<p align=\"left\">\r\n<li> Update the description for this Service Type.</li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b>   button to save changes. </li></p>\r\n<li> Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> <b>Delete</b> button to delete the Service Type. </li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to previous screen without saving the changes.</li></p>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add a Service Type</strong></font></div>\r\n  <hr></hr>\r\n<ol>\r\n<li> Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> <b>Add</b> button. Your screen should look similar to this: </li></p></p> \r\n<p align=\"center\"><img src=\"images/screenshots/ServiceType3.jpg\" ></p>\r\n<p align=\"left\">\r\n<li> Enter the description for this Service Type.</li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save the Service Type. </li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to the previous screen without saving.</li></p>\r\n',347),(382,22,'Service Class','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Service Classes</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_service_classes/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Service Classes, together with Service Types are used to determine default hourly rates for work on service orders. Each employee or  subcontractor (vendor who does service order work for you) works at a certain CLASS usually.</em>\r\n<p align=\"left\"><ol>\r\n<li> From the Main Menu, select <b><i>Billing -> Setup-Receivables -> Service Classes</b></i>.</li></p>\r\n<li> Your screen should look similar to this: </li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/ServiceClass.jpg\" ></p>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Edit an Existing Service Class</strong></font></div>\r\n<hr>\r\n<p align=\"left\"><ol>\r\n<li> Select the Service Class to be edited from the pull-down list.</li></p>\r\n<li> Click the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> <b>Edit</b>  button. Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/ServiceClass2.jpg\" ></p>\r\n<li> Update the description for this Service Class.</li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b>  button to save changes. </li></p>\r\n<li> Click the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> <b>Delete</b> button to delete the Service Class. </li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to previous screen without saving the changes.</li></p>\r\n</ol>\r\n<div align=\"center\"><font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"><strong>Add a Service Class</strong></font></div>\r\n  <hr></hr>\r\n<p align=\"left\"><ol>\r\n<li> Click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> <b>Add</b> button. Your screen should look similar to this: </li> </p> \r\n<p align=\"center\"><img src=\"images/screenshots/ServiceClass3.jpg\" ></p>\r\n<p align=\"left\">\r\n<li> Enter the description for this Service Class.</li></p>\r\n<li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save the Service Class. </li></p>\r\n<li> Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to return to the previous screen without saving.</li> </p>\r\n ',348),(383,22,'Service Order Labor Rates','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Service Labor Rates</strong></font></div>\r\n<hr></hr>\r\n<em>Combined with Service TYPES and Service CLASSES, these are the default rates for each of these work types for service orders.</em>\r\n<p align=\"left\"> <ol>\r\n<li> From the Main Menu select <b><i>Billing -> Setup-Receivables -> Service Labor Rates</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></P>\r\n<p align=\"center\"><img src=\"images/screenshots/ServiceOrderLaborRates.jpg\"> </P>\r\n<p align=\"left\">\r\n<li> Enter the default amount to be charged per hour for each of the combinations of TYPE and CLASS or work.</li></p>\r\n<li> When all rates have been entered, click on <img src=\"images/save.gif\"> <b>Save</b> button to save the changes made.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n<p align=\"center\">\r\n<img src=\"images/screenshots/ServiceOrderLaborRates1.jpg\"></p>\r\n<p align=\"left\">\r\n<li> Click on the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to check your entries.</li></p>\r\n',349),(384,22,'Add Beginning Balances (AR)','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Add Beginning Balance Invoices</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_setup_beginning_balances/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Create Invoices for beginning balances (or for each open invoice) when first starting your Nolapro system. Invoices entered in this section will NOT have a net affect on the General Ledger.</em>\r\n<p align=\"left\"><ol>\r\n<li> From Main Menu, select <b><i>Billing -> Setup-Receivables -> Add Beginning Balances</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/ARBeginBal.jpg\" ></p>\r\n<p align=\"left\">\r\n<li> <b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> <b>Lookup</b> button for detailed searches.  If this is a <b>new customer</b>, click on the <img src=\"images/add.gif\"> <b>Add</b> button to the right of this field, enter the new customer, then use the Lookup button to select.</li></p>\r\n\r\n<li> When you have entered the customer number, the screen will redraw in order to show you current credit information about this customer:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/ARBeginBal1.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> You can <b>EDIT</b> the customer information by clicking on the <img src=\"images/edit.gif\"> <b>Edit</b> button next to the customer name. If credit messages are displayed, you can click on the words <b>View Account</b> to see more information about this customer.</li></p>\r\n\r\n<li> <b>Original Invoice Date:</b> This is either the current date (for a single invoice representing many in your older system) or the actual date of the original invoice. You can either enter the date manually or click on <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to bring up a calendar.</li></p>\r\n<li> Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> <b>Next</b>  button to proceed. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/ARBeginBal2.jpg\" ></p>\r\n<p align=\"left\">\r\n<li> <b>Enter the information in the following categories:</b></li></p>\r\n    <ol TYPE=\"a\">\r\n       <li> <b>Ship To Address:</b> Select an address from the pull-down list or add a new one using the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> <b>Add</b> button.</li></p>\r\n       <li> <b>Invoice Number:</b> The next sequential Invoice Number is automatically displayed.</li></p>\r\n       <li> <b>Sales Category:</b> Select the Sales Category for this Invoice (this will originally show the default Sales Category for this customer).</li></p>\r\n       <li> <b>Purchase Order, </b>if one is given.</li></p>\r\n       <li> <b>Shipping Method: </b>Select a shipping method from the pull-down list (this will originally show the default Shipping Method for this customer).</li></p>\r\n       <li> <b>Customer Bill Code: </b> (For customer\'s internal accounting)</li></p>\r\n       <li> <b>Sales Person:</b> Select a Salesperson from the pull-down list (this will originally show the default entry for this customer).</li></p>\r\n       <li> <b>Invoice Terms:</b> Select the Invoice Terms from the pull-down list (this will originally show the default entry for this customer).</li></p>\r\n       </ol></p>\r\n<li> Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/ARBeginBal3.jpg\"></p><br>\r\n\r\n<em>You can enter as many lines of details as needed for each invoice. Additional lines are opened up by clicking on the <b>\"Add More Input Lines\"</b> button at the bottom of the screen. Also at the bottom of the screen you will see the invoice total change with each new line entered.</em><br>\r\n<p align=\"left\"> \r\n<li><b> Enter the data into the following categories:</b></li></p>\r\n<ol TYPE=\"a\"> \r\n        <li><b> Description: </b>Full description.</li></p>\r\n        <li><b> Quantity:</b> The quantity column has both quantity and units. The quantity entered in this column should be the quantity of the units listed directly below.</li></p>\r\n        <li><b>  Sales Quantity Unit Name:</b> Select the sales unit name from the drop-down list.</li></p>\r\n        <li><b> Price:</b> The Price column has both a price and units entry. The price entered should be the price of each of the units selected directly below.</li></p>\r\n        <li><b> Price Unit Name:</b> Select the price unit name from the drop-down list.</li></p>\r\n        <li><b> Qty Unit/Price Unit:</b> This field MUST have a value. It is the number of sales units (in the Quantity column) contained in a Sales Unit (in the Price column). The extended price will not work out correctly if this is incorrect.</li></p>\r\n        <li><b> Tax:</b> This box will come up checked (for charge tax on this item) or unchecked (non-taxable item) depending on the default setting for this customer.  If you want to CHANGE the normal tax status for any line on the invoice, simply change the checked status showing.</li></p>\r\n        <li><b> GL Sales Account:</b> This account will first appear with the default Sales Account from the customer.  You may change it for any line item on the invoice by simply picking a different one from the drop-down list.</li></p>\r\n        </ol>\r\n<p align=\"left\">\r\n<li> To Add more input lines on this invoice, click the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> <b>Add More Input Lines</b> button.</li></p>\r\n<li>To proceed to the final screen, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/ARBeginBal4.jpg\" ></p>\r\n<p align=\"left\"> <ol TYPE=\"a\">\r\n          <li><b> Due Date:</b> Enter the invoice due date or select from the calendar using the <img src=\"images/calendar.gif\" width=\"30\" height=\"30\"> button.  This will auto-calculate the due date based on the customer terms, however you can change this date if desired.</li></p>\r\n          <li><b> Discount Date:</b> Enter the date after which no discounts will apply or select from the calendar using the <img src=\"images/calendar.gif\" width=\"30\" height=\"30\"> button. This will auto-calculate based on the customer terms, however you can change this date if desired.</li></p>\r\n          <li><b> Tax (if applicable): </b>Enter the amount of tax applied to this invoice.  If more than one taxing district is required, each one will display separately.</li></p>\r\n          <li><b> Shipping Cost:</b> Shipping charges (non-taxed) to add to invoice.\r\n</li></p>\r\n          </ol>\r\n<p align=\"left\">\r\n<li> Complete the invoice by clicking on the <img src=\"images/next.gif\"> <b>Next</b> button.</li></p>\r\n<li>If you want to enter the COST OF GOODS for this invoice, click on the <img src=\"images/costofgoods.gif\"> <b>Enter COGS</b> button, which brings up this screen.</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/InvoiceEnterCOGS.jpg\" ></p>\r\n\r\n<p align=\"left\"> <ol TYPE=\"a\">\r\n         <li> Enter <b>Cost of Goods</b> in appropriate box.</li></p>\r\n         <li> Select <b>GL account</b> from the pull down list.</li></p>\r\n         <li> Click the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> <b>Save</b> button to save the entry and open up another line for entering more costs. </li></p>\r\n         <li> When you have entered all the costs you want (and SAVED them), exit by clicking on the <img src=\"images/closewindow.gif\"> <b>Close Window</b>  button.</li></p>\r\n         </ol></p>\r\n<li> A screen will be displayed showing the Invoice number and a confirmation that it was added successfully.  Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> <b>Back</b> button to add more invoices.</li></p>\r\n</ol>',350),(385,23,'Beginning Balances (Inventory)',' <div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Item Beginning Balances</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_setup_beginning_balances/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>To initial setup your Inventory system, you may need to enter the starting on-hand quantities, and NOT have them affect General Ledger in any way. This program is the tool to accomplish this task.</em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Setup - Inventory -> Item Beginning Balances</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryBeginBal.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the information in the following categories to narrow your selections: </b></li></p>\r\n       <ol TYPE=\"a\">\r\n             <li><b> Location: </b> (if you only have one location, you will not see this pull-down). Select ALL Locations or choose a specific Location from the pull-down list.</li></p>\r\n             <li><b>Sort by: </b> Select how you would like the report sorted from the choices shown in the pull-down list.</li></p>\r\n             <li><b>Search for Item Codes/Search for Item Name: </b>Enter an Item Number (or part of a number) in the Search for Item Code box or enter an Item Name (or part of a name) in the Search for Item Name box.</li></p>\r\n             <li><b>Results per Page: </b>Select the number of results you would like to see per page from the pull-down list.</li></p>\r\n       </ol>\r\n\r\n<li>NOTE: To verify and apply any quantities already entered, click on the <img src=\"images/reviewinventory.gif\"> <b>Review and Apply</b> button. (See details further down).</li></p>\r\n\r\n<li>To enter the beginning balances, click the <img src=\"images/next.gif\"> <b>Create Worksheet/Enter Counts</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryBeginBal2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the data in the following categories to load your beginning balances: </b></li></p>\r\n\r\n        <ol TYPE=\"a\">\r\n              <li><b>Beginning Balance: </b>Enter the beginning balance in the appropriate column.</li></p>\r\n              <li><b>Cost per Stock Unit: </b>The stock unit description appears to the right of this box, so BE SURE to enter the costs FOR THIS UNIT.</li></p>\r\n        </ol>\r\n\r\n<li>To see the next page (or a specific page) of results, click on the <b>Next (##)</b> link OR click on any of the <b>numbers (pages)</b> shown at the bottom of the screen.</li></p>\r\n\r\n<li>To search again WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li> </p>\r\n\r\n<li>To save your changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryBeginBal3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>To search again, click on the <img src=\"images/back.gif\"> <b>Back</b> \r\nbutton.</li></p>\r\n\r\n<li>To verify and apply the quantities entered, click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p> \r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryBeginBal5.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>Select how you would like to <b>sort</b> the data from the pull-down list.</li> </p>\r\n\r\n<li>Click on the <img src=\"images/next.gif\"> <b>Next</b> button. Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/InventoryBeginBal6.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li>If you are NOT applying the beginning balance for this specific item, click on the <img src=\"images/cancel.gif\"> <b>Cancel</b> button.</li> </p>\r\n\r\n<li>Check the <b>Apply box</b> for the items you would like to have update the inventory. </li></p>\r\n\r\n<li>To actually update the inventory for the beginning balances, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p> \r\n\r\n<li>To return to the previous screen WITHOUT saving your changes, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n</ol>\r\n',112),(386,15,'Manual Checks','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Manual Checks</strong></font><a href=\"http://www.nolapro.com/training/ap/ap_manual_check/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Create checks for payment without first entering a bill.</em> \r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Payables -> Manual Checks</b></i>.</li></p>\r\n\r\n<li>Your screen should look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ManualChecks.jpg\" ></p><br>\r\n<p align=\"left\">\r\n\r\n<li>Enter data into the following categories: </b></li></p>\r\n      <ol TYPE=\"a\">\r\n         <li><b>Invoice Number: </b>Invoice Number from bill or invoice being paid.</li></p>\r\n         <li><b>Vendor Name â€“ ID: </b>Enter Vendor Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the vendor number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\"> <b>Lookup</b> button for detailed searches. To ADD a new vendor, click on the <img src=\"images/add.gif\" width=\"20\" height=\"20\"> <b>Add</b> button to the right of the Vendor Name - ID box. </li></p>\r\n         <li><b>Total: </b>Amount to be paid (before discount if there is one).</li></p>\r\n         <li><b>Discount Amount: </b>Amount of discount taken.</li></p>\r\n         <li><b>Pay How: </b>Select method of payment from the pull-down list. NOTE: Credit card, ACH, EFT selections for reference only. No automatic processing will take place. You will need to process the credit card transaction file separately.</li></p>\r\n         <li><b>Payment Date: </b>This will be the Check Date. Defaults to current date, but can be changed. You can either enter the date manually or click the <img src=\"images/calendar.gif\" width=\"18\" height=\"18\"> <b>Calendar</b> button to select the date from a calendar.</li></p>\r\n         <li><b>Checking Account: </b> If you have  MORE THAN ONE checking account defined for payables, select the one you want from the pull-down list. (you will not see this prompt if you have only one checking account.)</li></p>\r\n     </ol>\r\n\r\n<li>To continue, click on the <img src=\"images/next.gif\"> <b>Next</b> button to continue with the entry. Your screen should look similar to this:</p></li>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ManualChecks2.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter the data into the following categories: </b></li></p>\r\n       <ol TYPE=\"a\">\r\n            <li><b>Description: </b>This defaults to the standard description for items purchased from this vendor.</li></p>\r\n            <li><b>Endorser: </b>The name of the person who will be signing the checks (defaults to standard endorser for this checking account).</li></p>\r\n            <li><b>Check Number: </b>Defaults to next check number for this checking account. You can override this number.</li></p>\r\n            <li><b>Amount: </b>Enter distribution amounts (amounts for each different expense account). This defaults to the usual expense account for purchases from this vendor.</li></p>\r\n            <li><b>GL Account: </b>General Ledger Account for amount entered on this line.<br>\r\n       </ol>\r\n\r\n<li>If you need to distribute the check to more accounts than you have input lines, click on the <img src=\"images/add.gif\"> <b>Add More Input Lines</b> button at the bottom of the screen.</li></p>\r\n\r\n<li>To exit WITHOUT actually writing the check, click on the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li>To save the entries and print the check, click on the <img src=\"images/print.gif\"> <b>Complete Payment</b> button. Your screen will now look like this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ManualChecks3.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li>To print the check, click on the <font color=\"0000FF\">Check number</font> to print the check.</li></p>\r\n\r\n<li>To return to the Manual Checks screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button. </li></p>\r\n\r\n</ol>',352),(387,16,'Add/Upate Employee Pay & Deductions','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Add/Upate Employee Pay & Deductions</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_employee_payded_add_edit/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Either create all the information for a pay period, or edit the information either before or after calculating a pay period.</em> \r\n<p>From the main menu, select Payroll then Add/Upate Employee Pay & Deductions.</p>\r\n<p>Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeePayAddUpdate.jpg\" > \r\n </p><br>\r\n<blockquote>\r\n<b>Name: </b>Select Employee from the drop-down list.<br>\r\n<b>Period Begin Date: </b>Beginning date of pay period.<br>\r\n<b>Period End Date: </b>End Date of pay period.<br>\r\n</blockquote>\r\n<p>When this data has been filled in, click on the <img src=\"images/next.gif\"> next button to bring up the edit/entry screen:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeePayAddUpdate2.jpg\" ></p>\r\n<p><em>Note that if the pay period for this employee already has data, you will be in EDIT mode.  If there is no matching pay period for this employee, you will come up in ADD mode (all data blank).</em></p><br>\r\n<blockquote>\r\n<b>Hours: </b>You will see multiple lines for hours and pay, one for each of your \"pay types\". The total pay will NOT calculate automatically, you will need to enter it.<br>\r\n<b>Rate: </b>Pay rate.<br>\r\n<b>Total: </b>Total pay (you will need to calculate this yourself using this edit method).<br>\r\n<b>Benefits: </b>Next after the hours and pay lines will come any standard benefits that might apply to this employee. Enter the dollar amount.<br>\r\n<b>Misc. Taxable Pay: </b>Pay that is taxable aside from the hourly pay amounts.<br>\r\n<b>Misc. Taxable Pay Explanation: </b>Explanation of reason for this misc. pay.<br>\r\n\r\n<b>Misc. Non-Taxable Pay: </b>Pay that is NOT taxable (ex: reimbursements).<br>\r\n<b>Misc. Non-Taxable Pay Explanation: </b>Explanation of reason for this misc. pay.<br>\r\n<b>Tips: </b> Amount of tips reported.<br>\r\n<b>Tips as Wages: </b> Amount of tips applied to total pay to bring employee up to minimum wage rate. This is used to determine employer matching taxes.<br>\r\n<b>Deductions: </b>Each of the possible deduction types will be listed and you can enter/edit these deductions.<br>\r\n<b>Company Contributions: </b>These are amounts that the company pays on behalf of an employee that an employee never sees on their checks.<br>\r\n</blockquote><br>\r\n<p>When you have entered or edited all the relevant pay and deduction information, click on the <img src=\"images/save.gif\"> save button to save the data. <b> NOTE:</b> No posting will take place to the General Ledger until you WRITE CHECKS.</p><br><br>\r\n\r\n\r\n\r\n',82),(388,2,'Recurring Ledger Entries','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Recurring Ledger Entries</strong></font><a href=\"http://www.nolapro.com/training/gl/gl_recurring_entries_add/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<p><em> \r\n<p>Use Recurring Entries for sets of transactions that need to be entered into current transactions on a regular basis. Typical examples are depreciation or payroll data if done by an outside service (the payroll would need editing before each post, but it would help to remember all accounts affected). </p>\r\n</em> \r\n<p>From Main Menu select Ledger then Recurring Ledger Entries, then Add/Update Recurring Entries. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/RecurringLedger.jpg\" ></p>\r\n<br><p>Click on the <img src=\"images/add.gif\"> to add a new entry set.</p>\r\n<p>Click on the <img src=\"images/edit.gif\"> edit button to edit an existing entry set.</p><br><br>\r\n<p align=\"center\"><big><b>ADD NEW ENTRY SET</b></big></p><br><hr><br>\r\n<p>After clicking the <img src=\"images/add.gif\"> add button on the first screen, your screen will look similar to this:</p><br>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/RecurringLedgerAdd.jpg\" ></p>\r\n<br>\r\n<blockquote>\r\n<b>Journal Voucher: </b> A brief description of the purpose of this recurring entry.<br>\r\n<b>Description: </b> A Complete description of the purpose of this recurring entry.<br>\r\n</blockquote><br>\r\n<p>Click the <img src=\"images/next.gif\"> button. Your \r\n  screen should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/RecurringLedgerAdd2.jpg\" ><br>\r\n</p><blockquote>\r\n<b>Account: </b>GL Account number that the amount will post to. If you begin to type the account number, it will auto-fill with the rest of the information. If you do not know the number, click on the <img src=\"images/seek2.gif\"> lookup button to find the account.<br>\r\n<b>Amount: </b>In the amount column, enter the amount. <strong>NOTE:</strong> Remember to enter all credit \r\n  amounts as negative and all debit amounts as positive.<br>\r\n</blockquote>\r\n<p>When your debits and credits balance, you will see a button <img src=\"images/completebill.gif\"> to allow you to Complete Voucher. If you need more entry lines than you see, click on the <img src=\"images/add.gif\"> Add button at the bottom of the screen.</p>\r\n<br><hr><br>\r\n<p>When clicking on the <img src=\"images/completebill.gif\"> to Complete the Voucher, you will see a screen like this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/RecurringLedgerAdd3.jpg\" ><br>\r\n</p>\r\n<p>Click on the <img src=\"images/back.gif\"> Back button to create another journal entry.</p><br><br>\r\n<p align=\"center\"><big><b>EDIT EXISTING ENTRY SET</b></big></p><br><hr><br>\r\n<p>Note that the date ranges entered on the first screen are for LAST POSTED DATES. New entries will not have any dates, so you will need to search for them based on other criteria.</p><br>\r\n<p>After filling in the search criteria, click the <img src=\"images/next.gif\"> next button on the first screen, and your screen will look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/RecurringLedgerUpd.jpg\" ><br>\r\n</p>\r\n</p>Click on the <img src=\"images/back.gif\"> back button to return to search criteria screen.</p>\r\n<p>You will see a list of matching entry sets. Select which one you want to edit, and click on the <img src=\"images/edit.gif\"> edit button to continue to edit. Your next screen will look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/RecurringLedgerUpd1.jpg\" ><br>\r\n</p>\r\n<p>Edit the voucher or description if needed.</p>\r\n</p>Click on the <img src=\"images/back.gif\"> back button to return to search criteria screen.</p>\r\n<p>Click on the <img src=\"images/delete.gif\"> delete button to delete this recurring entry set.</p>\r\n<p>Click on <img src=\"images/next.gif\"> next button to continue to details. The details screen will look similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/RecurringLedgerUpd2.jpg\" ><br>\r\n<p>Edit any of the accounts or amounts that get posted.</p>\r\n<p>When done, click <img src=\"images/save.gif\"> save button to save your changes.</p><br><br>\r\n',5),(389,2,'Recurring Ledger Entries - Post','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Recurring Ledger Entries</strong></font><a href=\"http://www.nolapro.com/training/gl/gl_recurring_entries_post/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div><hr></hr>\r\n<p><em> \r\n<p>Pick which recurring entry sets to Post or Reverse post.</p>\r\n</em> \r\n<p>From Main Menu select Ledger then Recurring Ledger Entries, then Post Recurring Entries. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/RecurringLedgerPost.jpg\" ></p><br>\r\n<p>Check the POST NOW box on any line you want to post to current journal for general ledger.</p>\r\n<p>Check the REVERSE POST box on any line you want to remove a prior posting for (it will do the OPPOSITE of what POST does).</p>\r\n<p>Click on the <img src=\"images/next.gif\"> next button to perform the post or reverse post.</p><br><br>',5),(390,11,'Add/View Bank Deposits','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Add/View Bank Deposits</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_bankdeposit_add/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Create new bank deposit slips, or view prior deposits. Bank deposits are used in the bank reconciliation section to aid in balancing your bank balance.</em>\r\n<p>From Main Menu select Billing, then Processing, then Update Bank Deposits. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/BankDeposit.jpg\"></p><br>\r\n<p><b>Add</b> a new deposit by clicking on the <img src=\"images/add.gif\"> Add button.</p>\r\n<p><b>View</b> a list of existing deposits made by clicking on the <img src=\"images/next.gif\"> Next button. See <b>View an Existing Bank Deposit</b> below for features of this screen.</p>\r\n<br><hr><br>\r\n<center><big><b>ADD A NEW DEPOSIT</b></big></center><br><hr><br>\r\n<p>Click on the ADD button on the first screen. This will bring up a screen similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/BankDepositAdd.jpg\"></p><br>\r\n<p align=\"left\">\r\nInvoiced Payments, Non-Invoiced Payments, Customer Deposits, and General Ledger entries to the Bank\'s Cash Account are displayed grouped by Payment Type.<br></p>\r\n1) Enter the following information:<blockquote>\r\n    a) <b>Bank Account: </b> Select the bank account from the pull-down list.<br>\r\n    b) <b>Deposit from Petty Cash: </b> Enter money from Petty Cash deposited into the Bank Account during this transaction. <br>\r\n    c) <b>Cash Withdrawal: </b> Enter cash withdrawn from this deposit.<br>\r\n    d) <b>Deposit Date: </b> Enter the deposit date manually or use the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> Calendar button to select a date.<br>\r\n    e)<b> Include? box: </b> Place a checkmark on the transactions included in this deposit.<br></blockquote>\r\n<br><p align=\"left\">\r\nThe total amount of the deposit is displayed at the bottom of the screen and is adjusted as the individual transactions are selected or deselected. <br><br>\r\n2) Click the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> Next button to update this deposit.<br>\r\n3) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button to CANCEL this deposit and return to the previous screen.<br>\r\n<br> When you click the Next button, you will see a screen similar to this:<br>\r\n<p align=\"center\"><img src=\"images/screenshots/BankDepositAdd2.jpg\"></p><br>\r\n\r\n4) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button to return to the Update Bank Deposits screen.<br>\r\n5) Click the <img src=\"images/htmlpage.gif\" width=\"30\" height=\"30\"> Print Deposit Slip button to view the details of the deposit. You will see a screen similar to this:<br>\r\n<p align=\"center\"><img src=\"images/screenshots/BankDepositAdd3.jpg\"></p><br>\r\n<p align=\"left\">\r\n6) Close the window to return to the previous screen.\r\n<br><hr><br>\r\n<center><big><b>VIEW AN EXISTING DEPOSIT</b></big></center>\r\n<br><hr><br><p align=\"left\">\r\n1)  To View an existing Bank Deposit, enter the criteria below on the first screen: <br> <blockquote>\r\n     a) <b>Bank Account: </b> Select a bank account from the pull-down list.<br>\r\n     b) <b>Beginning Deposit Date: </b> Enter the beginning date in the range you wish to review or use the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> Calendar button to select a date.<br>\r\n     c) <b>Ending Deposit Date: </b> Enter the last date in the range you wish to review or use the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> Calendar button to select a date.</blockquote><br>\r\n2) Click on the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> NEXT button on the first screen. This will bring up a screen similar to this:</p><br>\r\n<p align=\"center\"><img src=\"images/screenshots/BankDepositUpd.jpg\"></p><br>\r\n<p align=\"left\"></p>\r\n3) All deposits meeting the criteria are listed with most recent deposit first.  A column displays whether or not the deposit has been yet reconciled on a bank statement or voided. To change a deposit\'s information, you must Delete the deposit and re-enter the correct information. <br><br>\r\n4) Click on the <b>Deposit ID#</b> to see the details of a deposit.  You will see a screen similar to this:<br><br>\r\n<p align=\"center\"><img src=\"images/screenshots/BankDepositUpd1.jpg\"><br>\r\n<br><p align=\"left\"></p>\r\n5) Click on the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button to return to the Update Bank Deposits screen.<br><br>\r\n6) Click on the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> Delete button to delete this deposit. You can only Delete a deposit if the deposit has not been reconciled on a bank statement.<br>\r\n<hr>',353),(391,16,'Direct Deposit','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Direct Deposit</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_directdeposit_setup/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n\r\nIn order to generate payroll direct deposit files that can be processed by your bank you will need to enter information in two main areas.  The system needs information about your company\'s bank and the banks of your employees. <br><br>\r\n<center>\r\n<font  size=\"+1\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Company Bank Info</strong></font>\r\n</center>\r\n<ol>\r\n<li>To enter in information about your bank do the following:</li></p>\r\n   <ol TYPE=\"a\">\r\n          <li>From the Main Menu, select <b><i>Payroll -> Setup -> Checking Accounts</i></b>.</li></p>\r\n          <li>Select the <b>Bank Account</b> or add a new one that will be used for direct deposit transactions.</li></p>\r\n          <li>Move down to the section labeled <b>â€œDetailed Bank Information\"</b>.  To get Direct Deposit working properly you will need to complete at least the starred fields (you can obtain this information from your bank):\r\n                 <ol>\r\n                   <li><b>*Immediate Origin Routing Number</b> - The routing number of your bank</li>\r\n                   <li><b>*Immediate Origin Name</b> - The name of your bank</li>\r\n                   <li><b>*Bank Account Number</b> - The account number at this bank from which funds will be drawn</li>\r\n                   <li><b>Fractional Routing Number</b> - (not necessary for direct deposit) Used when printing checks on blank check stock</li>\r\n                   <li><b>Bank Address, City, State, Zip </b> - (not necessary for direct deposit) Used when printing checks on blank check stock</li>\r\n                   <li><b>*Immediate Destination Routing Number</b> - The routing number of the Federal Reserve Bank that will handle the transaction</li>\r\n                   <li><b>Immediate Destination Name</b> - (not required) The name of the Federal Reserve Bank that will handle the transaction</li>\r\n                   <li><b>*Company Name</b> - The name of your company as it appears on the ACH contract</li>\r\n                   <li><b>*Company Identification</b> - This is typically your company\'s tax ID number</li>\r\n                   <li><b>Send Prenotes</b> - (not required) A prenote is a zero dollar transaction for an employee that just verifies that the routing and account numbers are valid.  By checking this box you will force employees with new direct deposit bank information to have a prenote transaction ran on their account before regular deposits are made.  A standard check will be printed for this employee during any week that a prenote is sent out.  Once a prenote has cleared, you must mark on the employee\'s bank information page that the prenote was OK for this routing and account number.  After this the employee\'s pay will be direct deposited into his or her account.  If a routing number, account number or account type (savings or checking) is changed for a person, a new prenote transaction will automatically be created for the next week to test the new numbers and the employee will receive a regular check.  A new prenote will also be issued if the employee changes banks.  If <i>Send Prenotes</i> is not checked, no prenotes will ever be sent.  Employees will immediately begin receiving pay via direct deposit.</li>\r\n         </ol>\r\n     </ol>\r\n</ol>\r\n<br>\r\n<center>\r\n<font  size=\"+1\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Employee Bank Info</strong></font>\r\n</center>\r\n<p align=\"left\">\r\nIt is generally required that you obtain <b>written authorization</b> from employees before you may execute electronic fund transfers to or from their bank accounts.  You may create your own authorization form, or you can use NolaPro\'s template form by going to <b><i>Payroll -> Setup -> Direct Deposit Auth.</i></b>\r\n</p>\r\n\r\n<p>To enter information about your employees\' banks, select <b><i>Payroll -> Employee -> Add/Update </i></b>. Select an employee.  To configure direct deposit for the person enter information in the following fields:</p>\r\n       <ol>\r\n            <li><b>Direct Deposit</b> - Check this box if the person wants pay direct deposited (click the <b>Next</b> button to save your changes.)</li>\r\n            <li><b>Bank Information</b> - Click the edit button to enter bank details. Starred items are required.\r\n                 <ul>\r\n                      <li><b>Bank Name</b> - Name of the employee\'s bank</li>\r\n                      <li><b>Bank Address, City, State, Zip, Phone, Contact Name</b> - (not required) Bank contact info useful if there are problems with transactions</li>\r\n                      <li><b>*Bank Account Type </b> - Either checking or savings</li>\r\n                      <li><b>*Bank Routing Number</b> - The routing number of the employee\'s bank</li>\r\n                      <li><b>*Bank Account Number</b> - Account number into which employee would like pay deposited</li>\r\n                      <li><b>Prenote OK</b> - Check this box if a prenote transaction was sent successfully for this bank account.  If your company bank account requires that prenotes be successful before pay is deposited (<b><i>Payroll -> Setup -> Checking Accounts</i></b>), you must check this box after a clear prenote in order for the employee to receive funds on the next pay cycle.</li>\r\n\r\n            </ul>\r\n      </ol>\r\n<br>\r\n<br>\r\n<center>\r\n<font  size=\"+1\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Creating a Direct Deposit File</strong></font>\r\n</center>\r\n<p align=\"left\">\r\nAfter the required banking information has been entered you can now create a direct deposit file. Your bank will provide information on how to submit this file to them so that it can be processed and your payroll distributed. </p>\r\n<ol>\r\n     <li>Enter hours and calculate payroll as normal.</li>\r\n     <li>Go to Write Checks (<i><b>Payroll -> Write Checks</b></i>).</li>\r\n     <li>Be sure the box labeled <i>Create Direct Deposit File</i> is checked.</li>\r\n     <li>Enter text in the box <i>Direct Deposit Transaction Description </i>.  This phrase will show up on employees\' bank statements. You can enter a default value for this box by going to <i><b>Payroll -> Setup -> Standard GL Account</b></i>. </li>\r\n     <li>Click <i>Next</i> to write checks and/or a direct deposit file. (It is OK to have some employees receiving checks and some using direct deposit.  All will be processed at the same time.)</li>\r\n     <li>Click the printer icons to print checks or direct deposit stubs.</li>\r\n     <li>Click the download button to access the direct deposit file. This will open up the ACH Report. You can also get here by going to <i><b>Payroll -> Reports -> Direct Deposit Files</b></i>.</li>\r\n     <li>Click the download button in the column labeled <i>Download</i>.</li>\r\n     <li>Transmit the file to your bank following their specific instructions.</li>\r\n</ol><br><br>',79),(392,9,'Quotes Pending Fulfillment Orders','<div align=\"center\" > <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Pending Fulfillment Quotes Report</strong></font></div>\r\n<hr></hr>\r\n<em>This report shows all pending quotes currently in-house.  You can also edit the quote or turn it into an order from this list.</em>\r\n<ol>\r\n\r\n<li> From the Main Menu, select <b><i>Orders -> Reports -> Pending Fulfillment Quotes</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/PendingQuotes.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li> To edit the Quote, or convert it into an Order, click on the <img src=\"images/edit.gif\"> <b>Edit</b> button.  This will open the Fulfillment Order Add/Update screen.  For further information, see <b>Update Fulfillment Order</b> in the Related Topics section at the bottom of this Help screen.</li></p>\r\n\r\n<li> To print the Quote, click on the <b>Order Number</b>.</li></p>\r\n\r\n<li> To sort the report by <b>Order#, Order By, PO# or Quote Date</b>, click on the appropriate column header.</li></p>\r\n\r\n<li>To create a report for a specific <b>Location</b> (it comes up initially for ALL locations), select a Location from the pull-down box at the top of the report.</li></p>\r\n\r\n<li>To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button.</li></p>\r\n\r\n</ol>',354),(393,9,'Orders Received','<div align=\"center\" > <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Orders Received Report</strong></font></div>\r\n<hr></hr>\r\n<em>This report shows all orders received during a given time-frame. You can also edit the order from this list. Summary and Detail reports are available.</em>\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Reports -> Orders Received</b></i>.</li></p>\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ReceivedOrders.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li><b> Enter the following information to narrow your report:</b></li></p>\r\n      <ol TYPE=\"a\">\r\n           <li><b>Begin Period and End Period: </b>Select a date range for your report.  Enter the dates manually or use the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to select a date from the calendar.</li></p>\r\n           <li><b>Customer Name â€“ ID: </b> Leave blank to include all customers or select a Customer to include ONLY this Customer on the report. Enter the Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> <b>Lookup</b> button for detailed searches.</li></p> \r\n           <li><b>Detail Report: </b>Check this box if you want the report in <b>Detail</b> format, leave unchecked for a <b>Summary</b> report.</li></p>\r\n       </ol></p>\r\n<li> To bring up the report you selected, click on the <img src=\"images/next.gif\">  <b>Next</b> button. Both types of reports are shown below with explanation of the information shown.</li></p>\r\n</ol>\r\n<hr>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Summary Report</strong></font></div>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/ReceivedOrders2.jpg\"></p> \r\n</div>\r\n<hr>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Detail Report</strong></font></div>\r\n<hr>\r\n<p align=\"center\"><img src=\"images/screenshots/ReceivedOrders3.jpg\"></p>\r\n<p align=\"left\">\r\n</div>\r\n<hr>\r\n<ol>\r\n<li> To edit the order, click the <img src=\"images/edit.gif\"> <b>Edit</b> button. For further information on editing an Order, click on <b>Update Fulfillment Order</b> or <b>Update Service Order</b> in the Related Topics section of this Help screen. </li></p>\r\n\r\n<li> To print a Pick Ticket for that order, click on the <b>Order Number</b>. For further information on Pick Tickets, click on <b>Pick Ticket</b> in the Related Topics section of this Help screen.</li></p>\r\n\r\n<li> To sort the list, click on the <b>Order#, Order by, PO# or Due Date</b> column headers.</li></p>\r\n\r\n<li> To create a report for a specific Location (it comes up initially for ALL Locations), select a location from the drop-down box at the top of the report.</li></p>\r\n\r\n<li> To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button at the bottom of the screen.</li></p>\r\n\r\n<li> To return to the previous screen, click on your browser\'s <b>Back</b> button.</li></p>\r\n</ol>\r\n\r\n',355),(394,16,'Direct Deposit Files Report','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Direct Deposit Files (ACH) Report</strong></font></div>\r\n<hr></hr>\r\n<em>\r\nThis report allows you to browse through and download previously created direct deposit files. There are several search options available including file creation date, effective date, bank routing and account numbers and employee name and id just to name a few.  Individual transactions and canceled files are hidden by default.  You can view these items by checking the boxes at the bottom of the search area. </em><br><br>\r\n<b>General File Info Columns</b>\r\n<ol>\r\n<li><b>ID</b> - The ID number for this file</li>\r\n<li><b>Download</b> - Clicking the icon downloads the file. The number shown is the number of times the file has been downloaded.  Clicking the number brings up a list of who downloaded the file and when.</li>\r\n<li><b>Description </b> - The transaction description (shows up on bank statement)</li>\r\n<li><b>File Creation Date </b> - When the file was generated.  Clicking on the date displays all info contained in the file.</li>\r\n<li><b>Effective Date </b> - Date all transactions post to accounts</li>\r\n<li><b>Total Records </b> - Number of individual transactions contained in the file</li>\r\n<li><b>Total Debits </b> - Total amount of withdrawals</li>\r\n<li><b>Total Credits </b> - Total amount of deposits</li>\r\n<li><b>Account </b> - Company bank account used for transactions</li>\r\n<li><b>Created By </b> - User that generated this direct deposit file</li>\r\n</ol>\r\n<b>Transaction Info Columns</b>\r\n<ol>\r\n<li><b>Name</b> - The employee ID number followed by the employee\'s full name</li>\r\n<li><b>Amount</b> - Amount of debit or credit</li>\r\n<li><b>Transaction Type</b> - Either a savings or checking deposit or withdrawal</li>\r\n<li><b>Routing Number</b> - Bank routing number</li>\r\n<li><b>Account Number</b> - Bank account number</li>\r\n<li><b>Bank</b> - Name of the bank for transaction</li>\r\n<li><b>Trace Number</b> - Stored in file sent to bank.  Made from first 8 digits of company bank\'s routing number plus a seven digit sequence number.</li>\r\n</ol>',79),(395,11,'Credit Card Payment Options Setup','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Credit Card Payment Options Setup</strong></font><a href=\"http://www.nolapro.com/training/ar/ar_billing_cc_overview/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em></em> \r\nThis administrative utility allows you to configure NolaPro to accept credit card payments from two gateways: Authorize.net and PSiGate. For other gateways, a Manual gateway can be created and processed offline. You will first need to create an account with one of these processors in order to get the information necessary to complete the NolaPro credit card configuration.<br>\r\n<p align=\"center\"><big><b>Setting Up the Credit Card Processor Account in NolaPro</b></big>\r\n<hr>\r\n<p align=\"left\">\r\n<b><i>Be sure to read the \"Enabling Credit Card Processing in Setup-Receivables-> Company Options\" at the end of this Help Topic.</b></i><br><br>\r\nTo set up your credit card account in Nolapro, go to <i><b>Billing -> Setup-Receivables -> Credit Card Payment Options</b></i><br><br>\r\nTo edit an existing Credit Card Account, select an account from the pull-down list in the <b>Accounts</b> field.<br>\r\nTo Add an account, select the <b>Processor</b> of the account you want to add and click on the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> Add New Account button. <br><br>\r\n<hr><p align=\"center\">\r\nYou will see a screen similar to this for an <b>Authorize.net</b> account:<br><br>\r\n<img src=\"images/screenshots/CreditCardSetup1.jpg\"><br>\r\n<p align=\"left\">\r\n<b>Enter the following information</b>\r\n<ol>\r\n<li><b>Account Name:</b> - Enter a unique name for this processor account (we suggest you include the processor in the name for clarity).</li>\r\n<li><b>Login ID:</b> - Login name provided by Authorize.net</li>\r\n<li><b>Transaction Key:</b> - A code supplied by Authorize.net that is used to verify that transactions actually came from you.</li>\r\n<li><b>Check MD5 hash</b> - Yes or No. Authorize.net will send back a code that NolaPro can check to verify that the response actually came from Authorize.net (recommended).</li>\r\n<li><b>Hash Value</b> - A keyword entered here and in your Authorize.net account that is used for security purposes.</li>\r\n<li><b>Transaction Mode</b> - Select Testing or Production. Switch to production mode when you are ready to run actual transactions.</li>\r\n<li><b>Transaction Type</b> - At this time NolaPro only supports authorization and immediate capture (AUTH_CAPTURE).</li>\r\n<li><b>Email Customer:</b> - Whether Authorize.net should send email receipts to customers.</li>\r\n<li><b>Deliminate Data:</b> - Authorize.net requires this field be set to True. </li>\r\n<li><b>Delimination Character:</b> - Authorize.net requires this field to be set to a comma(\",\").</li>\r\n<li><b>Encapsulation Character:</b> - Authorize.net requires this field to be set to a vertical bar(\"|\").</li>\r\n<li><b>Transaction Method</b> - Only credit card transactions are supported by NolaPro at this time.</li>\r\n<li><b>Program Version:</b> - NolaPro supports Authorize.net Version 3.1 at this time.</li>\r\n<li><b>Relay Response:</b> - Authorize.net requires this field to be set to False.</li>\r\n</ol>\r\nClick the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save configuration settings.<br>\r\n<br><hr><p align=\"center\">\r\nYou will see a screen similar to this for a <b>PSiGate</b> account:<br><br>\r\n<img src=\"images/screenshots/CreditCardSetup2.jpg\"><br>\r\n<p align=\"left\">\r\n<b>Enter the following information</b>\r\n<ol>\r\n<li><b>Account Name:</b> - Enter a unique name for this processor account (we suggest you include the processor in the name for clarity).</li>\r\n<li><b>Merchant ID</b> - ID provided by PSiGate</li>\r\n<li><b>Transaction Mode</b> - Always Good, Always Duplicate, Always Decline, or Production. Switch to Production mode when you are ready to run actual transactions.</li>\r\n<li><b>Transaction Method:</b> - Only Credit Card Sales are supported by NolaPro at this time.</li>\r\n</ol>\r\nClick the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save configuration settings.<br>\r\n<br><hr>\r\nYou will see a screen similar to this for an <b>Manual</b> account:<br><br>\r\n<p align=\"center\"><img src=\"images/screenshots/CreditCardSetup3.jpg\"><br>\r\n<p align=\"left\">\r\n<b>Enter the following information</b>\r\n<ol>\r\n<li><b>Account Name:</b> - Enter a unique name for this processor account (we suggest you include the processor in the name for clarity).</li>\r\n</ol>\r\nClick the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save configuration settings.<br>\r\n<br><hr>\r\n<p align=\"center\"><big><b>Enabling Credit Card Processing in Setup-Receivables-> Company Options</b></big>\r\n<hr>\r\n<p align=\"left\">\r\nOnce you have created the account in <i><b> Billing -> Setup-Receivables -> Credit Card Payment Options</b></i>, be sure to set your default credit card processor for your company to this account. You do this by going to <i><b>Billing -> Setup-Receivables -> Company Options</b></i>. The default selection is to use manual (off-line) processing.<br><br>\r\n1) You will will see a screen similar to this: <br>\r\n<p align=\"center\"><img src=\"images/screenshots/CreditCardSetup_CompOpt.jpg\"> <br><p align=\"left\">\r\n2) <b>Select</b> your credit card processor account created above from the pull-down list and <b>Save</b> your changes.<br>\r\n',356),(396,51,'Attaching Files','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Attaching Files</strong></font></div>\r\n<hr></hr>\r\n<em>Attaching Files to Customers, Vendors, Employees, Salespersons, Orders, Invoices, Bills, Invoices, Payment Plans, etc.</em><br>',357),(397,8,'Order Confirmation','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong>Order Confirmation</strong></font></div>\r\n<hr></hr>\r\n<em>An Order Confirmation shows all the items contained in an order with shipping costs and tax.</em> \r\n\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/confirmation.jpg\" ></p>\r\n<br>\r\n\r\n<br>\r\n',358),(400,9,'Confirm/List Unconfirmed Orders','<div align=\"center\" > <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Unconfirmed Orders Report</strong></font></div>\r\n<hr></hr>\r\n<em>This report shows all unconfirmed orders (orders entered by B2B customers) currently in the system, and provides a way to easily confirm these orders.</em>\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Reports -> Unconfirmed Orders</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/AR_UnconfirmedOrders.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<p><i> Note: Due Dates will show as follows: <font COLOR=\"FF0000\"><b>RED</b></font> for past due orders, <b>BLACK</b> for order on time, <font COLOR=\"008000\"><b>GREEN</b></font> for orders due in the future.</i></p>\r\n\r\n<li> To sort the list by <b>Order#, Order By, PO# or Due Date</b>, click on the corresponding column header.</li></p>\r\n\r\n<li> To create a report for a specific Location (it comes up initially for ALL Locations), select a Location from the drop-down box at the top of the report.</li></p>\r\n\r\n<li> To edit the order, click the <img src=\"images/edit.gif\"> <b>Edit</b> button.  For further information, click on <b>Update Fulfillment Order</b> or <b>Update Service Order</b> in the Related Topics section of this Help screen. <i>Note: If you edit the Order and Save your changes, the Order will change to Confirmed and will not appear on this report</i>.</li></p>\r\n\r\n<li> To export the report in a Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button at the bottom of the screen.</li></p>\r\n\r\n<li> To <b>Confirm an Order, </b>click on the Order Number. This will bring up a pop-up window with further actions:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/AR_UnconfirmedOrders2.jpg\"></p>\r\n<p align=\"left\">\r\n    <ul TYPE=\"DISC\">\r\n       <li>To <b>Print a Pick List</b>, click on the <img src=\"images/picklist.gif\"> <b>Pick List</b> button. For further information see <b>Pick Ticket</b> in the Related Topics section of this Help screen.</li>\r\n       <li>To <b>view/print a Confirmation</b>, click on the <img src=\"images/pdf.gif\"> <b>Confirmation</b> button.</li>\r\n       <li>To <b>Email a Confirmation</b>, click on the <img src=\"images/email.gif\"> <b>Email Confirmation</b> button.</li>\r\n       <li>To <b>Finish</b>, click on the <img src=\"images/closewindow.gif\"> <b>close Window</b> button.  Your screen will now change to show a checkmark next to the confirmed order.</li>\r\n       </ul>\r\n</p>\r\n<p align=\"center\"><img src=\"images/screenshots/AR_UnconfirmedOrders3.jpg\"></p>\r\n<p align=\"left\">\r\n<br>\r\n</ol>',361),(401,9,'Customer Item History','<div align=\"center\" > <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Customer Item Purchase History Report</strong></font></div>\r\n<hr></hr>\r\n<em>This report shows all items ordered by a customer during a given time frame, along with the average price paid for each item during that time.</em>\r\n\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Reports -> Customer Item History</b></i>.</li></p>\r\n\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CustOrderHistory.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b> Enter information into the following categories to narrow your report: </b></li></p>\r\n        <ol TYPE=\"a\">\r\n              <li><b>Begin and End Period: </b>Enter a date range to be included in your report.  Manually enter both dates or click on the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to select dates from the calendar.</li></p>\r\n             <li><b>Customer Name â€“ ID: </b> Leave this field blank if you want to include all Customers or to report on a specific customer, enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n             <li><b>Location: </b>Select a Location from the pull-down list to report activity from a specific location or select ALL to report activity from all locations. </li></p>\r\n          </ol>\r\n<li> To display the report, click on the <img src=\"images/next.gif\"> <b>Next</b>  button. Your screen will look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CustOrderHistory1.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> To sort the report by Item Code or Description, click on the corrsponding column heading.</li></p>\r\n\r\n<li> To view a list of each order that is summed into the average price, click on the Average Price for that item. Your screen should then look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/CustOrderHistory2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li> Clicking on the Customer Total of Extended Price will show you the same report as above, only for each product for that customer.</li></p>\r\n\r\n<li> To export any of these reports to a file in Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button.</li></p>\r\n<li> To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button or on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n</ol>\r\n',362),(402,9,'Item Order History','<div align=\"center\" > <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Item Order History Report</strong></font></div>\r\n<hr></hr>\r\n<em>This report shows all items ordered during a given time frame, summarized by Item within Customer, along with the average price paid for each item during that time.</em>\r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Reports -> Item Order History</b></i>.</li></p>\r\n\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemOrderHistory.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li><b> Enter information into the following categories to narrow your report: </b></li></p>\r\n        <ol TYPE=\"a\">\r\n              <li><b>Begin and End Period: </b>Enter a date range to be included in your report.  Manually enter both dates or click on the <img src=\"images/calendar.gif\" width=\"16\" height=\"16\"> <b>Calendar</b> button to select dates from the calendar.</li></p>\r\n             <li><b>Customer Name â€“ ID: </b> Leave this field blank if you want to include all Customers or to report on a specific customer, enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n             <li><b>Location: </b>Select a Location from the pull-down list to report activity from a specific location or select ALL to report activity from all locations. </li></p>\r\n          </ol>\r\n\r\n<li> To display the report, click on the <img src=\"images/next.gif\"> <b>Next</b>  button. Your screen will look similar to this: </li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemOrderHistory1.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li> To sort this report by Item Code or Description, click on the corresponding column heading.</li></p>\r\n\r\n<li> To view a list of each order that is making up the totals for that customer, click on the Customer Total Extended Price field. Your screen should then look similar to this:</p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/ItemOrderHistory2.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li> To export any of these reports to a file in Microsoft ExcelÂ® format, click on the <img src=\"images/Excel.gif\"> <b>Export</b> button.</li></p>\r\n\r\n<li> To return to the previous screen, click on the <img src=\"images/back.gif\"> <b>Back</b> button or the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button.</li></p>\r\n</ol>',363),(403,44,'B2B Customer Login','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Customer B2B User Add/Update</strong></font></div>\r\n<hr></hr>\r\n<em>Add or Update Customer personnel who can log into your Nolapro B2B Partner Site to view orders, invoices, history of purchases, history of payments, etc. Security levels can be set for each user, limiting what information they can access.</em> \r\n<ol>\r\n<li> From the Main Menu, select <b><i>Orders -> Customer B2B Users</b></i>.</li></p>\r\n\r\n<li> Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/B2Buser.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li><b>Customer Name â€“ ID: </b> Enter Customer Name in the first box (or any portion of the name) to bring up a drop-down of possible matches. Alternately, you can enter the customer number directly into the box on the right. If you want to search by phone, zip code, etc., use the <img src=\"images/seek2.gif\" width=\"30\" height=\"30\"> <b>Lookup</b> button for detailed searches.</li></p>\r\n\r\n<li><b> Bring up the users for this customer</b> - click on the <img src=\"images/next.gif\" width=\"30\" height=\"30\"> <b>Next</b> button. </li></p>\r\n\r\nYour screen should look similar to this: </p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/B2Buser2.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li> Select an existing user from the drop-down list, or click on the <img src=\"images/add.gif\"> <b>Add</b> button to create a new user for this company. In either case the next screen will look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/B2Buser3.jpg\" ></p>\r\n<p align=\"left\">\r\n\r\n<li><b> Enter data into the following categories: </b></li></p>\r\n      <ol TYPE=\"a\">\r\n          <li><b>First Name: </b>First name of user (any user can see all orders, etc. for their company).</li></p>\r\n          <li><b>Last Name: </b>Last name of user.</li></p>\r\n          <li><b>Email: </b>Email address of user.</li></p>\r\n          <li><b>Login Name: </b>Name(User Id) user will use whenever they log onto the B2B site.</li></p>\r\n          <li><b>Password: </b>Password user must enter whenever they log onto the B2B site.</li></p>\r\n          <li><b>Verify: </b>Retype the password for verification.</li></p>\r\n                         <p><i>NOTE: Passwords only need to be entered when ADDING a new user or when CHANGING the Password. Otherwise, if you do not enter a password, the originally entered password is kept.</i></p>\r\n         <li><b>Access Level: </b>Select what access level this user has from the drop-down list. Users with System Administrator rights can add other users for their company from the B2B site. In other words, if you create one System Administrator user, that person can decide who else can see their company information and what areas they can access.</li></p>\r\n       </ol></p>\r\n\r\n<li> To select a different customer, click the <img src=\"images/back.gif\"> <b>Back</b> button.</li></p>\r\n\r\n<li> To select a different user for the SAME customer, click the <img src=\"images/Back2.gif\"> second <b>Back</b> button.</li></p>\r\n\r\n<li> To save any changes, click on the <img src=\"images/save.gif\"> <b>Save</b> button.</li></p>\r\n\r\n<li> If you are updating and want to remove a user\'s access to the B2B Site, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button.</li></p>\r\n</ol>\r\n<br>\r\n',364),(404,16,'Employee Seniority','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <strong> Employee Seniority</strong></font><a href=\"http://www.nolapro.com/training/payroll/pr_seniority_list/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>View a list of your employees, their hire dates and their length of employment.</em> \r\n<p>1) Click Payroll.</p>\r\n<p>2) Click Reports then Employee Seniority. Your screen should look similar to this:</p>\r\n<p align=\"center\"><img src=\"images/screenshots/EmployeeSeniority.jpg\" > \r\n</p>\r\n<br>\r\n<p>3) Click on the <strong>Show Pictures </strong> <img src=\"images/reset.gif\" width=\"30\" height=\"30\"> button to include employee pictures in the list:</p>\r\n<p>3) Click on the <strong>Hide Pictures </strong><img src=\"images/reset.gif\" width=\"30\" height=\"30\"> button to return to the report WITHOUT pictures.</p><br>\r\n',91),(405,23,'Item Option Groups','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n<strong> Item Option Groups</strong></font><a href=\"http://www.nolapro.com/training/inventory/inv_OptionsSetup/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n\r\n<em>Item Option Groups allow you to define groups such as Color Selections, Accessories, Special Handling, etc. that are attached to your inventory items during the ordering process.  Within a Group are the various Options a customer can select when they place the order.</em>\r\n\r\n<ol>\r\n<li>From the Main Menu, select <b><i>Inventory -> Setup - Inventory -> Item Option Groups</b></i>.</li></p>\r\n<li>Your screen should look similar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Setup_ItmOptGrp.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li>To ADD a new Group, click on the <img src=\"images/add.gif\"> Add button.</li></p>\r\n<li>To UPDATE an existing Group, select a Group from the pull-down box. Any Options already on file will display below the Edit Options button. </li></p>\r\n\r\n<li><b><big>Enter or Update the following fields:</b></big></li></p>\r\n      <ol TYPE=\"a\">\r\n          <li><b>Name:</b> Enter the name of your new ITEM OPTION GROUP.</li></p>\r\n          <li><b>Description:</b> Enter the description the group.</li></p>\r\n          <li><b>Type:</b> Select from the pull-down box the type of box the customer will use to select this item. Your may choose from Drop-down Box, Radio (button), Checkbox, or Text.</li></p>\r\n          <li><b>Required?:</b> Select Mandatory or Optional. Mandatory requires the user to make a selection before the order can be finalized. </li></p>\r\n      </ol>\r\n<br>\r\n<li>To save your new Group and return to the Add/Update screen, click on the <img src=\"images/save.gif\"> <b>Save</b> button.  Now you can finish building your Item Option Group.  You will see a screen simliar to this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Setup_ItmOptGrp2.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>View/Upload/Delete Graphic for Option Group - </b>See <b>Attaching Files</b> in the Related Topics Section below to learn how to attach a graphic file to your Group.</li></p>\r\n\r\n<li>Click on the <img src=\"images/next.gif\"> <b>Edit Options</b> button to continue building your Group and it\'s associated choices.</li></p>\r\n\r\n<li>To SAVE your group, click on the <img src=\"images/save.gif\"> <b>Save</b>  button.</li></p>\r\n\r\n<li>To DELETE your group, click on the <img src=\"images/delete.gif\"> <b>Delete</b> button.</li></p>\r\n</ol>\r\n<hr>\r\n<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n<strong> Options Add/Update</strong></font></div>\r\n<hr>\r\n<p align=\"left\">\r\n\r\n<ol>\r\n<li>After selecting the <b>Edit Options</b> button, you will see a screen similar to this:</li></p>\r\n<p align=\"center\"><img src=\"images/screenshots/Inventory_Setup_ItmOptions1.jpg\"> </p>\r\n<p align=\"left\">\r\n\r\n<li><b>Enter data into the following categories: </b></li></p>\r\n    <ol TYPE=\"a\">\r\n         <li><b>Select Option:</b> Select an existing Item Option from the pull-down box or click on the <img src=\"images/add.gif\" width=\"20\" height=\"20\"> <b>Add</b> button to add a New Option. Options set as the Default Option for this Group will be highlighted in blue.</li></p>\r\n<p>You can add a new Option from a <b>copy</b> of an existing Option. Select the Option in the pull-down box and click on the <img src=\"images/copy.gif\" width=\"20\" height=\"20\"> <b>Copy</b> button. Enter a Name for the Option, make any changes desired and Save.</p><br>\r\n        <li><b>Use Item:</b> If the Option is an Inventory Item, enter the Item ID here.  click on the <img src=\"images/search.gif\" width=\"20\" height=\"20\"><b> Lookup</b>  button to search the Inventory file.  To remove an Inventory ID from the Option, click on the <img src=\"images/delete.gif\" width=\"20\" length=\"20\"><b> Remove</b> button.</li></p>\r\n        <li><b>Name:</b> Enter the name of the Option. This text is used in the drop-down box, radio button and checkbox. DO NOT put a number in front of this description as seen in the Select Option box.  The number entered later in the Display Order box will be displayed in front of this text.</li></p>\r\n        <li><b>Desc.:</b> Enter a detailed description of the Option. This text will be displayed to fully describe the purpose and uses of this Option.</li></p>\r\n        <li><b>Pricing Unit:</b> Select a unit name from the pull down list. This is the unit for pricing. (An example might be usage unit of EACH, with a pricing unit of DOZEN). NOTE: Price units are entered in inventory setup.  If the Option is an Inventory Item, the Item\'s Pricing Unit is used.</li></p>\r\n        <li><b>Usage Unit:</b> Select a unit name from the pull down list. This is usually the smallest usage unit. Pricing unit can be different, but all your inventory counts will be in usage units. NOTE: Usage units are entered in inventory setup. If the Option is an Inventory Item, the Item\'s Usage Unit is used.</li></p>\r\n        <li><b>Usage Units per Price Unit:</b> How many usage units are contained in each price unit.  This is used for converting pricing quantities to usage quantities. If usage and pricing units are the same, this should be a 1 (one). If the Option is an Inventory Item, the Item\'s Usage Units per Price Unit is used.</li></p>\r\n        <li><b>Price per Unit:</b> Enter the selling price per unit.  If the Option is an Inventory Item, the Item\'s Selling Price per Unit is used.</li></p>\r\n        <li><b>Cost Per Usage Unit:</b> Enter the cost per Usage unit here. Be sure the number you enter represents the Cost per the Usage Unit entered above. For example, if your Usage Unit is M (per 1000), be sure to enter the Cost per 1000 not the cost of a carton.  If the Option is an Inventory Item, the Item\'s Cost is used.</li></p>\r\n        <li><b>Weight per Price Unit:</b> Used for freight calculations, this is the weight of one of the pricing units.</li></p>\r\n        <li><b>GL Sales Account:</b> Default GL Sales account for posting to General Ledger.</li></p>\r\n        <li><b>Option Code:</b> Enter a code to represent this Option.  This code will be shown behind the Inventory ID to designate which options have been chosen by the customer.  For example, if RI is the Option Code on Inventory ID \"sg-001\", choosing this option would result in this item being displayed on orders, invoices and statements as \"sg001RI\".</li></p>\r\n        <li><b>Taxable:</b> Check this box if the Option is taxable.</li></p>\r\n        <li><b>Dependent on Main Item Qty:</b> Select Yes if the number of units ordered depends on the number of the Main Item units ordered, No if the quantity ordered does not depend on the number of the Main Item ordered.</li></p>\r\n        <li><b>Default Qty Per Main Item If Dependent/Default Qty if Independent:</b>  Enter the quantity of this item that must be ordered when ordering one(1) unit of the Main Item. If \"Dependent on Main Item Qty\" is set to No, then enter the default number of units you want to display on the screen.</li></p>\r\n        <li><b>Min Qty:</b> Enter the minimum number of units that can be ordered.</li></p>\r\n        <li><b>Max Qty:</b> Enter the maximum number of units that can be ordered.</li></p>\r\n        <li><b>Default Option for the Group:</b> Select Yes, if you want this item to be automatically selected when the screen displays. For example, using the CheckBox type of Group, a checkmark will be in this box when first entering the screen. </li></p>\r\n        <li><b>Display Order:</b> Enter the number representing the position of this Option in the drop-down box, checkbox list, or radio button list.</li></p>\r\n        <li><b>View/Updateload/Delete - Graphic for Option: </b>See <b> Attaching Files</b> in the Related Topics Section below to learn how to attach a graphic file to your Group. If a graphic has already been selected, it will be displayed above this link.</li></p>\r\n      </ol>\r\n<br>\r\n<li>To return to the previous screen WITHOUT SAVING your changes, click on the <img src=\"images/back.gif\" width=20 height=20> <b>Edit Option Group</b> button.</li></p>\r\n\r\n<li>To SAVE your changes, click on the <img src=\"images/save.gif\" width=20 height=20> <b>Save</b> button.</li></p>\r\n\r\n<li>To DELETE this Option, click on the <img src=\"images/delete.gif\" width=20 height=20> <b>Delete</b> button.</li></p>\r\n</ol>',365),(406,17,'Link Add/Update','<div align=\"center\">\r\n<font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> <strong>\r\n  Link Add/Update</strong></font></strong><a href=\"http://www.nolapro.com/training/admin/link_add_update/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>This screen allows you to Add or Update Links to external programs that you want to appear on your NolaPro menu.</em> \r\n<p>From the Main Menu select Admin, then Link Add/Update. Your screen should look similar to this: </p>\r\n<p align=\"center\"><img src=\"images/screenshots/Link_AddUpd.jpg\"> </p>\r\n<p align=\"left\">1) To <b>Edit</b> an existing Link, select the Link from the pull-down list and click on the <img src=\"images/edit.gif\" width=\"30\" height=\"30\"> Edit button. </p>\r\n<p>\r\n2) To Add a new Link, click on the <img src=\"images/add.gif\" width=\"30\" height=\"30\"> Add button. </p> \r\n<p> \r\n3) Your screen should look similar to this:</p>\r\n  <p align=\"center\"><img src=\"images/screenshots/Link_AddUpd1.jpg\"></p>\r\n  <p align=\"left\">\r\n4) Update the information for the following categories: </p>\r\n\r\n<blockquote> \r\na) <b>Name:</b> Enter the Name for this Link.<br>\r\n    b) <b>Internal URL:</b> Select the URL type from the pull-down list. Choices are \"http://\". \"https://\", and \"Internal\". Use Internal if calling a program that is not accessible via a Web browser.  Enter the Name of the file or URL in the box to the right of URL type.<br>\r\n    c) <b>Description:</b>Enter a detailed description of this Link.<br>\r\n    d) <b>Active:</b> Place a checkmark in this box if you want this link to be active.</blockquote><br>\r\n\r\n<p align=\"left\">\r\n5) Click the <img src=\"images/back.gif\" width=\"30\" height=\"30\"> Back button to return to the previous screen without saving the changes. <br>\r\n6) Click on the <img src=\"images/save.gif\" width=\"30\" height=\"30\"> Save button to save the Link.<br>\r\n7) If the Link is existing, click on the <img src=\"images/delete.gif\" width=\"30\" height=\"30\"> Delete button to delete this Link.<br>\r\n</p>',366),(407,8,'Adding Line Items(Parts) to an Order','<div align=\"center\"> <font size=\"+2\" face=\"Georgia, Times New Roman, Times, serif\"> \r\n  <b> Adding Line Items (Parts) to an Order</b></font>\r\n<a href=\"http://www.nolapro.com/training/ar/ar_order_entry/\" target=\"_blank\">\r\n<img src=\"images/playmovie.gif\" border=\"0\" alt=\"Play Movie\"></a></div>\r\n<hr></hr>\r\n<em>Enter Inventory Items or miscellaneous parts to Fulfillment Orders or Service Orders.  Inventory Item activity is reflected in the Inventory module.  Pricing and cost information for non-inventory items can be entered. </em> \r\n<p align=\"left\"><ol>\r\n\r\n<li>  This screen is accessed from the Main Menu through <b><i>Orders - Fulfillment Order Add/Update</b></i> or <b><i>Orders -> Service Order Add/Update.</b></i></li></p>\r\n<li> In the Order Add/Update process, you will see a screen simliar to this:</p></li>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderAdd3.jpg\"></p>\r\n<p align=\"left\">\r\n\r\n<li> When you first come to this screen when adding a new order, there will be 10 lines with nothing entered.  To enter information into each line, you must click on the <img src=\"images/add.gif\" height=\"30\"> <b>Add</b> button under the line number. </li></p>\r\n<li> To EDIT an existing line item, click on the <img src=\"images/edit.gif\" height=\"30\"> <b> Edit</b> button under the line number. Edit or Add will bring up a detail screen which looks like this:</li></p>\r\n\r\n<p align=\"center\"><img src=\"images/screenshots/OrderLineItem.jpg\"></p>      \r\n<blockquote>\r\n<em>This entry screen is divided into two sections.  If you are selecting an inventory item, then you need only fill in the TOP section above the words \"BELOW ENTRIES ARE FOR NON-INVENTORY ONLY\".  If Item Options are attached to this Inventory Item, the choices will be displayed below the Item Notes section (as shown in this example). See <b>Item Option Groups</b> in the Related Topics section for instructions on using Item Options.  If it is NOT an inventory item, you MUST fill in the QUANTITY, TAXABLE and SHIP FROM from the top section, then all data in the bottom part.</em><br></blockquote>\r\n    <ol TYPE=\"a\">\r\n       <li> <b>Item Code:</b> Leave this blank if NOT from inventory. Enter the code or description (or any part of these) to bring up a matching entry list, or use the <img src=\"images/seek2.gif\" height=\"30\"> <b>Lookup</b> button to find the item you want. The system will retrieve all the information about pricing, costs, etc. that are in the BOTTOM portion of the input (when you SAVE). However, if you are Editing an inventory item, you can over-ride the usual price, etc.</li></p>\r\n       <li> <b>Quantity:</b> This MUST be filled in for inventory AND non-inventory items.</li></p>\r\n       <li> <b>Taxable:</b> If checked, tax will be charged on this item. The entry for this will default to the customer default tax status. You may see a Taxable checkbox or taxing districts listed depending on your company\'s taxing procedures. See <b>Add/Update Customer</b> and <b>Company Options</b> in the Related Topics section below for more information.</li></p>\r\n       <li> <b>Ship From:</b> If you have multiple locations, and you want to ship some items from one location and some from another, you will need to select a location from the drop-down box.  The location will default to the one selected when the order was started, so if all items are from the same location you should be able to ignore this selection (it will already be right).</li></p>\r\n       <li> <b>Item Notes:</b> Notes entered here can further define information about the item. These notes DO show on the invoice later on.</li></p>\r\n       </ol><hr>\r\n<b>ITEM OPTIONS:</b></p>\r\n<blockquote>\r\nItem Options shown are <b>Color Choices</b> and <b>Gift Wrapping</b>.  Any costs associated with an Option are displayed here and will be added to the Order Total. <b>Note:</b> <i>The Item Options selected will have an abbreviation (YL for Yellow Color Choice in this example) that will appear next to the Inventory Item ID</i>.  This makes it easy to see which options have been chosen by looking at the Inventory ID.  (Example \"sg-100YL\" is the sg-100 inventory item with a color choice of Yellow).</blockquote>\r\n<hr>\r\n<b>NON-INVENTORY ITEMS: </b></p>\r\n        <ol TYPE=a>\r\n             <li> <b>Description:</b> A description of the item sold.</li></p>\r\n             <li> <b>Sales Unit:</b> The unit name for the SALES quantity.</li></p>\r\n             <li> <b>Pricing Unit:</b> The unit name for the PRICE Quantity.</li></p>\r\n             <li> <b>Qty Units/Price Unit:</b> The conversion factor between PRICE and SALES unit (how many of the sell units are contained in the price unit. EX: Sell by Each, price by Dozen. Number of sell units (each) per price unit (dozen) is 12).</li></p>\r\n             <li> <b>Price per Unit:</b> Price per SELL unit.  Following our example above, price per dozen.</li></p>\r\n             <li> <b>Cost per Unit:</b> Cost per SALES unit.</li></p>\r\n             <li> <b>GL Sales Account:</b> General Ledger account to post the sales amount for this item. This account will default to the customer or item sales account depending on how this is specified in setup.</li></p>\r\n             </ol>\r\n<hr>\r\n<li> Click on the <img src=\"images/closewindow.gif\"> <b>Close Window</b> button to close the window and NOT save your changes.</li></p>\r\n<li> Click on the <img src=\"images/save.gif\"> <b>Save</b> button to save the entries you have made.  And if this is a new inventory item being selected, the costs/prices/descriptions will be looked up.</li></p>\r\n<li> Click on the <img src=\"images/delete.gif\"> <b>Delete</b> button to delete the line item displayed.</li></p>\r\n</div>',367);
/*!40000 ALTER TABLE `mod_help_topics` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `modules`
--

DROP TABLE IF EXISTS `modules`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `modules` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `modules`
--

LOCK TABLES `modules` WRITE;
/*!40000 ALTER TABLE `modules` DISABLE KEYS */;
INSERT INTO `modules` VALUES (1,'help');
/*!40000 ALTER TABLE `modules` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `movein`
--

DROP TABLE IF EXISTS `movein`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `movein` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `buildingid` int(11) NOT NULL default '0',
  `unitid` int(11) NOT NULL default '0',
  `leaseid` int(11) NOT NULL default '0',
  `moveindata` text NOT NULL,
  `status` int(11) NOT NULL default '0',
  `lastactivitydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `buildingid` (`buildingid`),
  KEY `unitid` (`unitid`),
  KEY `leaseid` (`leaseid`),
  KEY `cancel` (`cancel`),
  KEY `status` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `movein`
--

LOCK TABLES `movein` WRITE;
/*!40000 ALTER TABLE `movein` DISABLE KEYS */;
/*!40000 ALTER TABLE `movein` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `moveout`
--

DROP TABLE IF EXISTS `moveout`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `moveout` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `buildingid` int(11) NOT NULL default '0',
  `unitid` int(11) NOT NULL default '0',
  `leaseid` int(11) NOT NULL default '0',
  `moveoutdata` text,
  `status` int(11) NOT NULL default '0',
  `lastactivitydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `buildingid` (`buildingid`),
  KEY `unitid` (`unitid`),
  KEY `leaseid` (`leaseid`),
  KEY `cancel` (`cancel`),
  KEY `status` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `moveout`
--

LOCK TABLES `moveout` WRITE;
/*!40000 ALTER TABLE `moveout` DISABLE KEYS */;
/*!40000 ALTER TABLE `moveout` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `note`
--

DROP TABLE IF EXISTS `note`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `note` (
  `id` int(11) NOT NULL auto_increment,
  `notetypeid` int(11) NOT NULL default '0',
  `notecategoryid` int(11) NOT NULL default '0',
  `recordid` int(11) NOT NULL default '0',
  `note` text NOT NULL,
  `companyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `b2buserid` int(11) NOT NULL default '0',
  `internal` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `entryuserid` (`entryuserid`),
  KEY `notetypeid` (`notetypeid`),
  KEY `recordid` (`recordid`),
  KEY `companyid` (`companyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `note`
--

LOCK TABLES `note` WRITE;
/*!40000 ALTER TABLE `note` DISABLE KEYS */;
/*!40000 ALTER TABLE `note` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notecategory`
--

DROP TABLE IF EXISTS `notecategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notecategory` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notecategory`
--

LOCK TABLES `notecategory` WRITE;
/*!40000 ALTER TABLE `notecategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `notecategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notecattype`
--

DROP TABLE IF EXISTS `notecattype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notecattype` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `notetypeid` int(10) unsigned NOT NULL default '0',
  `notecategoryid` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `notetypeid` (`notetypeid`),
  KEY `notecategoryid` (`notecategoryid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notecattype`
--

LOCK TABLES `notecattype` WRITE;
/*!40000 ALTER TABLE `notecattype` DISABLE KEYS */;
/*!40000 ALTER TABLE `notecattype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notetype`
--

DROP TABLE IF EXISTS `notetype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notetype` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(100) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `modaccess` varchar(150) NOT NULL,
  `modbit` varchar(20) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `code` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=14 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notetype`
--

LOCK TABLES `notetype` WRITE;
/*!40000 ALTER TABLE `notetype` DISABLE KEYS */;
INSERT INTO `notetype` VALUES (1,'customer','STR_CUSTOMER_NOTES','Notes to be attached to a specific customer.  This will reference the customer table id record.','ar,pm','011'),(2,'order','STR_ORDER_NOTES','Notes that need to be attached to orders.','ar','011'),(3,'PO','STR_PO_NOTES','Notes that need to be attached to purchase orders.','ap,inv','011'),(4,'invoice','STR_INVOICE_NOTES','Notes that need to be attached to invoices.','ar,pm','011'),(5,'vendor','STR_VENDOR_NOTES','Notes that need to be attached to a vendor.','ap,inv','011'),(6,'bills','STR_PAYABLES_BILL_NOTES','Notes that need to be attached to payables bills.','ap,inv','011'),(7,'employee','STR_EMPLOYEE_NOTES','Notes that need to be attached to an employee.','pr','011'),(8,'lease','STR_LEASE_NOTES','Notes for leases.','ar','011'),(9,'customer_letter','STR_CUSTOMER_LETTERS','Notes for customer letters','ar,pm','011'),(10,'job_prelim','STR_JOB_PRELIM_REQUEST','Notes for job prelim requests','ar','011'),(11,'job','STR_JOB_NOTES','Notes for jobs.','ar','011'),(12,'appointmentschedule','STR_APPOINTMENT_SCHEDULE_NOTES','Notes to be shown or edited in Appointment Schedule Editor (max one per day).','ar','111'),(13,'job_prelim_rec','STR_JOB_PRELIM_REQUEST_RECEIVED','Notes for job prelim requests that have been received.','ar','011');
/*!40000 ALTER TABLE `notetype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `npdb`
--

DROP TABLE IF EXISTS `npdb`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `npdb` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(150) NOT NULL default '',
  `dbname` varchar(50) NOT NULL,
  `domainname` varchar(255) NOT NULL,
  `entrydate` datetime NOT NULL,
  `serialnumber` varchar(45) NOT NULL,
  `codenumber` varchar(45) NOT NULL,
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `masterlicense` varchar(16) NOT NULL,
  `inactive` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `npdb`
--

LOCK TABLES `npdb` WRITE;
/*!40000 ALTER TABLE `npdb` DISABLE KEYS */;
/*!40000 ALTER TABLE `npdb` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `npmodrights`
--

DROP TABLE IF EXISTS `npmodrights`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `npmodrights` (
  `key` varchar(255) NOT NULL,
  `modules` varchar(32) default NULL,
  `read` tinyint(1) default NULL,
  `write` tinyint(1) default NULL,
  `setup` tinyint(1) default NULL,
  `features` tinytext,
  `menu_location` mediumtext,
  `checksum` varchar(32) default NULL,
  PRIMARY KEY  (`key`),
  KEY `menu_location` (`menu_location`(128))
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `npmodrights`
--

LOCK TABLES `npmodrights` WRITE;
/*!40000 ALTER TABLE `npmodrights` DISABLE KEYS */;
INSERT INTO `npmodrights` VALUES ('admin3dcart.php','admin',0,0,1,'3dcart','STR_ADMIN|STR_SETUP_ADMIN|STR_3DCART_SETUP','89b5e1a18aaf58e86f0e63b9d9e995d5'),('adminachdownload.php','pay',0,1,1,'','','2e4feb07124b2e220b1f8a005bdbdedc'),('adminachreport.php','pay',1,1,1,'payroll','STR_PAYROLL|STR_REPORTS|STR_DIRECT_DEPOSITS','8c48648fb99bf71bb9a4e9710bdc063e'),('adminactivitymonitor.php','admin',0,0,0,'activitymonitor','STR_TOOLS|STR_USER_ACTIVITY_MONITOR','0960a4ed5643b59f406a08173adb05bb'),('adminapccgen.php','ap,inv,est',0,0,1,'CCPurchases','STR_PAYABLES|STR_CREDITCARD_BILLS|STR_GENERAL_INFO','087e62175f80566c493170ac575df923'),('adminapcctypeadd.php','ap,inv,est',0,1,1,'CCPurchases','','c74519cf67f87c342474b0c8af4ca935'),('adminapcctypeupd.php','ap,inv,est',0,1,1,'CCPurchases','STR_PAYABLES|STR_CREDITCARD_BILLS|STR_PURCHASE_TYPES','b8f581a1993b5e1abc2060c3454f3a73'),('adminapccvendoradd.php','ap,inv,est',0,1,1,'CCPurchases','','67a3ed7934ddc80839cfd471563763d9'),('adminapccvendorupd.php','ap,inv,est',0,1,1,'CCPurchases','STR_PAYABLES|STR_CREDITCARD_BILLS|STR_CC_CARDS','26af5142e9fc6bfc59437dadbbcb0ffe'),('adminapchkacctadd.php','ap,pay',0,0,1,'','','e90245453725adfab4f599b0caa07d58'),('adminapchkacctupd.php','ap,pay',0,0,1,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_CHECKING_ACCOUNTS','ca2d80040d62f10c6dfa3d7c9b0635cf'),('adminapglacct.php','ap',0,0,1,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_GENERAL_SETUP','45cfe91377e56c9cbd2f7fac2cfdd0fd'),('adminapilog.php','admin',0,0,0,'api','STR_TOOLS|STR_API_LOG_VIEWER','1a2bef3bb405b8f33b8904c847dee92a'),('adminapilogdata.php','admin',0,0,0,'','','b2a5a05bd787c0bb5b6f6eaf8b83f86f'),('adminappaytermsadd.php','ap',0,0,1,'','','01e2855b81ad415f6cd97ca111136821'),('adminappaytermsupd.php','ap',0,0,1,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_VENDOR_TERMS','64d4f1daf803b033710f26e614e92cb8'),('adminapvendortype.php','ap',0,0,1,'VendorType','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_VENDOR_TYPES','7aeb85ce9e2d9015f4fda023c39c9327'),('adminapvendortypeadd.php','ap',0,0,1,'VendorType','','f5cd869b902ff596d2863ce7e51fa052'),('adminar_rmasetup.php','ar',0,0,1,'inventory','STR_ADMIN|STR_SETUP_SERVICE|STR_RMA_SETUP','15f885bb7584f10ddc30c2edebb829a6'),('adminarcarrieradd.php','ar',0,0,1,'','','2a46ec2de5ce59c5de97915dc40b1317'),('adminarcarriermethupd.php','ar',0,0,1,'','','77ca275c9b2c7e0f1c53f5c09a833adf'),('adminarcarrierorder.php','ar',0,0,1,'','','264fc99df2181d26c518fbf03d5a2edb'),('adminarcarrierupd.php','ar,ap',0,0,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_SHIPPING_CARRIERS','6f5c30c007a0cecd4fa5423ad0589ab3'),('adminarcompanytaxupd.php','ar',0,0,1,'','','28c0d8489bf99f3a26ac7a33f47926ef'),('adminarcompanyupd.php','ar',0,0,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_COMPANY_OPTIONS','1885fb99a42a5acdc5cd5648d30e92ff'),('adminarglacct.php','ar',0,0,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_GENERAL_SETUP','9968ddfc006a80ced7cf6a6f027762f8'),('adminargroupsadd.php','ar,inv,est',0,1,1,'CustomerGroups','','1c24bcd7e9909936633ae679f1af3393'),('adminargroupsupd.php','ar,inv,est',0,1,1,'CustomerGroups','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_CUSTOMER_GROUPS','5c772da623d076526a805b8e420d82d9'),('adminarinvoicetext.php','ar',0,0,1,'smallinvoice3','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_INVOICE_TEXT','630aa989fbbb95fda671fa2bf0361013'),('adminarinvtermsadd.php','ar,inv,est',0,1,1,'','','a85e33ee27afc419186b4fca8f2cb317'),('adminarinvtermsupd.php','ar,inv,est',0,1,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_INVOICE_TERMS','b225100a2b0b14f0d361961e751674f0'),('adminarordstatusadd.php','ar,inv,est',0,1,1,'inventory','','bf7e4ec8aa05e43873efe8f2a264ef9e'),('adminarordstatusupd.php','ar,inv,est',0,1,1,'inventory','STR_ADMIN|STR_SETUP_SERVICE|STR_SERVICE_STATUS_OPTIONS','f0692e0b04ce546eb8f60d4c34288041'),('adminarpostaxadd.php','ar,inv,est',0,1,1,'postemplate','','457b6cd2fde9c60c949bcb94c1eb128a'),('adminarpostaxupd.php','ar,inv,est',0,1,1,'postemplate','','98e65b820ffbf5a0c6dcce5dc2080220'),('adminarquotecomadd.php','ar,inv,est',0,1,1,'','','2b71fff7e490c53b55ec6c3af47dbee9'),('adminarquotecomupd.php','ar,inv,est',0,1,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_QUOTE_COMMENTS','4a794f3dc2657d3731b6443917549261'),('adminarsales_category.php','ar',0,0,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_SALES_CATEGORIES','503b5371b7a5b6d44d39f658e950edbb'),('adminarsales_categoryadd.php','ar',0,0,1,'','','1ce0c70264718ee68031e1a46a0a94a9'),('adminarsalesmanadd.php','ar,inv,est',0,1,1,'','STR_CONTACTS|STR_SALES_PERSONNEL|STR_NEW_SALES_PERSONNEL','6cfff29f4dd6899db4b9285e863dbd06'),('adminarsalesmanupd.php','ar,inv,est,pay',0,1,1,'','STR_CONTACTS|STR_SALES_PERSONNEL|STR_EDIT_SALES_PERSONNEL','0e90b5ad80dd3ce45ba21f1f6007a5a9'),('adminarsalestaxadd.php','ar,inv,est',0,1,1,'','','595239e178c8c05af684bc8586680a9a'),('adminarsalestaxupd.php','ar,inv,est',0,1,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_SALES_TAXES','70e2b1a7d684bbd8505659e3f4afaba9'),('adminartaxexadd.php','ar,inv,est',0,1,1,'','','7e7962b4433ceccd190444bbf21b73ad'),('adminartaxexupd.php','ar,inv,est',0,1,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_TAX_EXEMPTIONS','1fd397414706f15c386bb8bb0fe3b580'),('adminartaxgroupsadd.php','ar,inv,est',0,1,1,'','','77848e1efab313df0364bca849433fbb'),('adminartaxgroupsupd.php','ar,inv,est',0,1,1,'','','32e064b7aa888452a811c54eb3e610c8'),('adminb2bsite.php','admin',0,0,1,'b2b','STR_ADMIN|STR_SETUP_ADMIN|STR_B2B_SITE_GRAPHICS','21f320ce7daa3cb071f3c4b500650597'),('adminbarcode.php','inv',0,0,1,'barcodelabel','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_BARCODE_LABELS','d61947fd28fc3b6386fc51ba9f4c907f'),('adminbing.php','admin',0,0,1,'branding','STR_ADMIN|STR_SETUP_ADMIN|STR_LOGO_BRANDING','0a6142255ee804c18f341c95c63b7036'),('adminccsetup.php','admin',0,0,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_CREDIT_CARD_OPTIONS','b169d2c55432cd13c3ae8e6f91887a29'),('admincurrencyedit.php','admin',0,0,1,'multicurrency','STR_ADMIN|STR_SETUP_ADMIN|STR_CURRENCY_NEW_EDIT','7f74697fc03c371665ce31401cfe255a'),('admincurrencyrates.php','admin',0,0,0,'multicurrency','STR_ADMIN|STR_SETUP_ADMIN|STR_CURRENCY_RATES','53e7ecf350f26349e27cf3375d4c3593'),('admindeletionrpt.php','admin',0,0,1,'deletionreport','STR_TOOLS|STR_DELETION_REPORT','cc9eb1049109781963945b6fd472c3c3'),('admindoccenter.php','ar,ap',0,1,1,'doccenter','STR_TOOLS|STR_DOCUMENT_CENTER','13da5af79a30eb7370934d69818edbed'),('admineftdownload.php','ap,ar',0,1,1,'','','90b78e3e376b090008820cfc59f31bfb'),('admineftrpt.php','ar,ap',0,1,1,'','STR_BILLING|STR_REPORTS|STR_EFT_REPORT','092add5830845cc7a8b10f2ca28088be'),('adminemail.php','ar,sc,inv,ap,gl',0,1,1,'','STR_CONTACTS|STR_EMAIL_CENTER','2d360a17dc3efba0c67e0291e0eeff19'),('adminemailpicker.php','admin',0,0,0,'','','315547352feb31fd284e6e81647dd2a5'),('adminemailtemplates.php','ar,sc,inv,ap,gl',0,1,1,'emailtemplates','STR_ADMIN|STR_SETUP_ADMIN|STR_EMAIL_TEMPLATES','bd6f5cecfddcf6a103fb45b509aa210b'),('adminestquote_ordersource.php','est',0,1,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_ORDER_RECEIVED_HOW','af0f8869915e6b0911ebeacb92fa03ec'),('adminestquotecovercolors.php','est',0,0,1,'','','bfb546d09f02cbec1246311d54818683'),('adminestquotegenink.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_INK_INFO','1fb69f5737c64496a7bf34dc4604f394'),('adminestquoteinkadd.php','est',0,0,1,'','','0a04ba77c90d9f4183e9599b26c15a9f'),('adminestquoteinkupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_INKS_ADD_UPDATE','db1903f78ddce3743b11d1cd7a56bde1'),('adminestquotequotenotesadd.php','est',0,0,1,'','','ba75ade43266f968e75f5bf5789a1f98'),('adminestquotequotenotesupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_QUOTE_NOTES_MENU','fb7674c3c0ba32ca5f9002fcd3923f55'),('adminestquotesalescampaigns.php','est',0,1,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_SALES_CAMPAIGNS','3aea1f8058d2caa0240cb60eb9e7899c'),('adminestquotespecialdatesupd.php','est',0,1,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_TYPICAL_DATES','79c9596a838f40ed8e840e58ccd4cef4'),('adminestquotespecials.php','est',0,0,1,'','','5c5d7d0a76276b56f10717f61e26f736'),('adminestquotestdsizeadd.php','est',0,0,1,'','','af4e27db18fd6ca1988909cfcd33172e'),('adminestquotestdsizeupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_STANDARD_SIZES','0fa2fa8d4e2970382f0ee880b1b2d32d'),('adminestquotestockcolor.php','est',0,0,1,'','','0871b41d00824666a451d9dc5a75a5ec'),('adminestquotestockcolorsize.php','est',0,0,1,'','','045a2767748440cb44a5962e7c87937c'),('adminestquotestocksizes.php','est',0,0,1,'','','76117192ae68e65215bffe833ca2088a'),('adminestquotetypeofspecialsupd.php','est',0,1,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_TYPE_OF_SPECIALS','bb59c68512223d01fdfbb1d7f7669980'),('adminestquoteworktypeadd.php','est',0,0,1,'','','48f86c92ecc823745d5c4116e86e249c'),('adminestquoteworktypeaddl.php','est',0,0,1,'','','0878d60d5c0cc1030a30a2243df2494b'),('adminestquoteworktypestdqty.php','est',0,0,1,'','','d015e7f36e3b9d3c2c076b45c4e7e0e8'),('adminestquoteworktypeupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_WORK_TYPE','e09d94bf2a755d1af6c547c7e7ffdcdc'),('adminflexfields.php','admin',0,0,0,'flexfields','STR_TOOLS|STR_CUSTOM_FIELDS_EDITOR','86b7fb62c1d1c5cbd9599ba92a353dca'),('adminglaccttypeupd.php','gl',0,0,1,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL|STR_ACCOUNT_TYPES','76918076d64d20887c851a78718917a5'),('adminglcompanyupd.php','gl',0,0,1,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL|STR_SET_FISCAL_START_MONTH','63717450b0e011e3ccfe299136c4e037'),('admingooglebase.php','admin',0,0,0,'googlebase','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_GOOGLE_BASE_INTEGRATION','c58d28cb4b6f42e75b2aad60a6c1a9ac'),('adminhostingmanager.php','admin',0,0,0,'hostingmanager','STR_TOOLS|STR_HOSTING_MANAGER','2aa4571305f448665a47e6c23c138cee'),('adminhostingmanagerlogin.php','admin',0,0,1,'hostingmanager','','37d7b00811381d7e95e7405abe377dda'),('admininvglacct.php','inv',0,0,1,'inventory','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_GENERAL_SETUP','0027ec7bb1952d120f8e1fd8c67ebfd7'),('admininvlocationadd.php','est,inv',0,0,1,'inventory','','06c255c7d6c3b7828fd645c918ed91da'),('admininvlocationupd.php','est,inv',0,0,1,'inventory','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_PLANT_LOCATIONS','60b9ff0c8a8214d2db62aa097451bc9c'),('admininvoicenotesadd.php','ar',0,0,1,'InvoiceEndNotes','','aa3b7eae5f0c59920d0dd5ffb1d609f4'),('admininvoicenotesupd.php','ar',0,0,1,'InvoiceEndNotes','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_INVOICE_END_NOTES','5dcba20bcb2fc4772dee14b3df4cda0e'),('admininvponotesadd.php','inv',0,0,1,'inventory','','69d130848539c93d6a6d4240038ed43d'),('admininvponotesupd.php','inv',0,0,1,'inventory','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_PO_END_NOTES','351b29bcfc1113b4e60fc2f825385c21'),('admininvunitnameadd.php','ar,inv',0,0,1,'','','e370a612c5847385594db781b49cefd2'),('admininvunitnameupd.php','ar,inv',0,0,1,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_SALES_UNIT','849d99d09b913d4feac4e533a08d40ac'),('adminipaccessmanager.php','admin',0,0,0,'ipaccess','STR_TOOLS|STR_IP_ACCESS_MANAGER','f16e198c3f93d58dff8a48f2c55a1997'),('adminlogin.php','admin',0,0,0,'adminloginany','','f8cdea4057aeeee85824cb539a9bb3cd'),('adminnotecategory.php','admin',0,0,0,'','STR_ADMIN|STR_SETUP_ADMIN|STR_NOTE_CATEGORIES','0b86ec44011fa29d98f49b38ac9de96c'),('adminnotesreport.php','admin',0,0,0,'','STR_TOOLS|STR_NOTES_REPORT','e24fab9363b1a4cea461abeb4ca0c281'),('adminorderlinenotes.php','ar',0,0,1,'','STR_ADMIN|STR_SETUP_SERVICE|STR_ORDER_LINE_ITEM_NOTES','394b6a59dfe52a9f2e0f39c700966c39'),('adminosccompanyupd.php','admin',0,0,1,'oscom','STR_TOOLS|STR_OSCOMMERCE','0b919edb05e09b6e431ceecb3d6012b7'),('adminprben.php','pay',0,1,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_GENERAL_BENEFITS_PAY','b4d9a2b3d801b8a9128c1c381907515b'),('adminprcon.php','pay',0,1,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_COMPANY_CONTRIBUTIONS','344a5c4293e85328ac2a42f2941676e6'),('adminprded.php','pay',0,0,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_GENERAL_DEDUCTIONS','d2263c5b594edf18e49e873d0cad2456'),('adminprdedgroupadd.php','pay',0,0,1,'payroll','','818f357d868ba575f07e295680ee205f'),('adminprdedgroupupd.php','pay',0,0,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_DEDUCTION_GROUPS','247c5e6bedf5dc9ecd45cc421fda0547'),('adminpremplreviewratingadd.php','pay',0,0,1,'payroll','','5b2d2d530d53c76ab765efaa53b16668'),('adminpremplreviewratingupd.php','pay',0,0,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_RATING_SCALE_FOR_REVIEWS','f04b31e18fad8b36365b541912c46825'),('adminprgendat.php','pay',0,0,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_GENERAL_FACTORS','65e8a0df2aaa93feb9ab00a14ed5f539'),('adminprglacct.php','pay',0,0,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_GENERAL_SETUP','4ac69e7def9491a76f6b14650daa2afe'),('adminprpaytypeadd.php','pay',0,0,1,'payroll','','b3a928fcf8305dd929b8958fe763ff5c'),('adminprpaytypeupd.php','pay',0,0,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_PAY_TYPES','c91bd73cdb91707d77bced7a374135d6'),('adminprpens.php','pay',0,0,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_PENSION_PLANS','f195bb911a8d026c991237f9c590072f'),('adminprt_category.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_PRINT_SALES_CATEGORIES','9d053d36b3874d9f4fb30cfe8af83b5c'),('adminprt_categoryadd.php','est',0,0,1,'','','dc969ae5f80dd15962ce21b203508aa7'),('adminprtaxtypeadd.php','pay',0,1,1,'payroll','STR_PAYROLL|STR_TAX_TABLES|STR_NEW_TAX_TYPE','ce95d68869eb59e1c304a06197d6cce2'),('adminprtaxtypedtl.php','pay',0,1,1,'payroll','STR_PAYROLL|STR_TAX_TABLES|STR_EDIT_TAX_TABLE','f668ae3c295f5add1fbe5d4a600fb2c5'),('adminprtaxtypeupd.php','pay',0,1,1,'payroll','STR_PAYROLL|STR_TAX_TABLES|STR_EDIT_TAX_TYPE','b78608f4713d68f40e77583bc6c35e64'),('adminprtemail.php','est',0,1,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_ENTER_EMAIL','2814b10b4d25331c1875d1833dac854d'),('adminprtgeneral.php','est',0,0,1,'','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_ENTER_GENERAL_MARKUPS','36d71904274d8d0dd5a340faf0e5c055'),('adminprtlocationadd.php','est',0,0,1,'','','497245a1f545a6aedbc7ce20460b543d'),('adminprtlocationupd.php','inv,est',0,0,1,'inventory,Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_PRINT_LOCATIONS','ad6b7d9aea093c2739d430c53f9d2591'),('adminprtworkarea_assign.php','est',0,0,1,'Printshop_std','','241ebd37c77af1579d4f1806a194ae7f'),('adminprtworkareaadd.php','est',0,0,1,'','','a5d5c8582a91ed0c92b4eb004d8bb095'),('adminprtworkareaupd.php','est',0,0,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_ENTER_WORK_AREA','bd567b5e5c2fdb1bb727cbe15e0dfc67'),('adminreportcache.php','admin',0,0,0,'HomePageRefresh','STR_ADMIN|STR_SETUP_ADMIN|STR_HOMEPAGE_REFRESH_TIMES','8d3a1971fe83a53eedb8d843994592f1'),('adminserversetup.php','admin',0,0,1,'','STR_TOOLS|STR_DATABASE_INFO','f464192ee8bf5f67cadcf883533da19b'),('adminstagesetup.php','admin',0,0,0,'processstages','STR_ADMIN|STR_SETUP_ADMIN|STR_PROCESS_STAGES','6c95722ae8a185ad690979d30139c041'),('adminsurvey.php','admin',0,0,0,'survey','','2793aae5f9378b2fa2bf39521586be62'),('adminsurveyreport.php','admin',0,0,0,'survey','STR_TOOLS|STR_SURVEYS|STR_SURVEY_REPORTS','edba62a05e99f4baf54c987686971ff4'),('adminsurveyurl.php','admin',0,0,0,'survey','','b04bb90936fc7590e51307829a4c88e2'),('adminsystemsettings.php','admin',0,0,1,'','STR_ADMIN|STR_SETUP_ADMIN|STR_SYSTEM_SETTINGS','0f506cfd74cb91a6493a73b85f6be9ca'),('adminzencompanyupd.php','admin',0,0,1,'zencart','STR_TOOLS|STR_ZEN_CART','fe0816c28026a59f35128966217892fd'),('apbill_preapprove.php','ap',0,1,1,'','','a8ea57b873a8cba7d4904ba2071be5ee'),('apbill_preapprove_edit.php','ap',0,1,1,'','','4b910bffcdf361c1ba59046eec63f778'),('apbilladd.php','ap',0,1,1,'','STR_PAYABLES|STR_VENDOR_BILLS|STR_NEW_VENDOR_BILL','f163402768d771052aba8aa559aa5dd0'),('apbilladd_beginbal.php','ap',0,1,1,'','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_BEGIN_BILLS','c4504e8db7638aab06c7eb7d60c9132f'),('apbilllist.php','ap',1,1,1,'','STR_PAYABLES|STR_REPORTS|STR_PAYABLES_LISTS','5e0c04a98c99661745e33c25034e53a7'),('apbilllistaging.php','ap',1,1,1,'','STR_PAYABLES|STR_REPORTS|STR_DETAIL_AGING','201e13dbb533be00a88ac5e81a360366'),('apbilllistdiscaging.php','ap',1,1,1,'','STR_PAYABLES|STR_REPORTS|STR_DISCOUNT_AGING','808a8711a8b33c5eb789ccc0255907cb'),('apbillpay.php','ap',0,1,1,'','STR_PAYABLES|STR_CHECKS|STR_WRITE_CHECKS','4395421bf948d0422c552092e2093d48'),('apbillpay_preapproved.php','ap',0,1,1,'','','7c2f4acda04bcdf06f9937661ad38f09'),('apbillpayrpr.php','ap',0,1,1,'rpr','STR_PAYABLES|STR_VENDOR_BILLS|STR_PAY_BILLS_FOR_CLIENTS','675c3680c7557a03451b91254cba6630'),('apbillupd.php','ap',0,1,1,'','STR_PAYABLES|STR_VENDOR_BILLS|STR_EDIT_VENDOR_BILL','d2d551e67f8289dd93d4fc3e0230d3cb'),('apbillviewfpdf.php','ap',0,1,1,'','','cab1a6887d6470623bcc3a09385590a5'),('apcashrequirements.php','ap',1,1,1,'CashRequire','STR_PAYABLES|STR_REPORTS|STR_CASH_REQUIREMENTS','fda73ddc41347ad4530620cacbdeed2d'),('apccpurchase2bill.php','ap,inv,est',0,1,1,'CCPurchases','STR_PAYABLES|STR_CREDITCARD_BILLS|STR_NEW_CC_BILLS','a6b2d100acbf610ff6dea64f93ad403a'),('apccpurchase2billupd.php','ap,inv,est',0,1,1,'CCPurchases','STR_PAYABLES|STR_CREDITCARD_BILLS|STR_EDIT_CC_BILLS','39db9ec2a12513ebef841b346a78b5e1'),('apccpurchaseadd.php','ap,inv,est',0,1,1,'CCPurchases','','e9ae35c198a1d65346c383489ef63efb'),('apccpurchaselist.php','ap,inv,est',0,1,1,'CCPurchases','STR_PAYABLES|STR_REPORTS|STR_CREDIT_CARD_PURCHASES','823b57bf6ac9a7909b37acaad7d5b7a8'),('apccpurchaseupd.php','ap,inv,est',0,1,1,'CCPurchases','STR_PAYABLES|STR_CREDITCARD_BILLS|STR_CC_PURCHASES','0f637069eeead2e85552a448b469a809'),('apchecking.php','ap',0,1,1,'','STR_PAYABLES|STR_CHECKS|STR_VIEW_CANCEL_CHECKS','8af8474320fa80462f68b4a1da86ef0e'),('apchecklist.php','ap',1,1,1,'','STR_PAYABLES|STR_REPORTS|STR_LIST_OF_CHECKS','a0a5b1ed4a4bbb6d4cb37598fe49c703'),('apmanualcheck.php','ap',0,1,1,'','STR_PAYABLES|STR_CHECKS','4e1ccf5ab09a7a7907c4e799a70117a1'),('apmanualchecksp.php','ar,gl,ap',0,1,1,'custommanualchecks','STR_PAYABLES|STR_CHECKS|STR_MANUAL_CHECKS','2df45dd763baabb1b1f2858d1b2523dc'),('appayvoucher.php','ap',1,1,1,'','','5cefcf5dbbf9241f3afa37cdf6c651a6'),('apvend1099edit.php','ap',0,1,1,'irs1099','STR_PAYABLES|STR_REPORTS|STR_IRS_1099','f5efd36fa4499e7927cbccbbc3525104'),('apvend1099file.php','ap',0,1,1,'irs1099','','1eb5008b3746fb348aea51d93374c535'),('apvend1099print.php','ap',0,1,1,'irs1099','','26a7d73e691124e62aa9312dae8ba296'),('apvendadd.php','ap,inv',0,1,1,'','STR_CONTACTS|STR_VENDORS|STR_NEW_VENDOR','d92ed9726994558da8c2f4a13b4b096a'),('apvendagentlistview.php','ap,sc,inv',1,1,1,'','','5cdb4143a497f63e4c10fb84a6d1c411'),('apvendcsvlist.php','ap,inv',1,1,1,'','','49ed67438439f7c5562c476d8311d622'),('apvendlist.php','ap,inv',1,1,1,'','STR_CONTACTS|STR_REPORTS|STR_VENDOR_LISTS_LABELS','5f02b910726e643a91fd18655dd541b9'),('apvendlistview.php','ap,sc,inv',1,1,1,'','','3fc606bf61009c5bbc9d18f57872273e'),('apvendoractivity.php','ap',1,1,1,'','STR_CONTACTS|STR_REPORTS|STR_VENDOR_ACTIVITY_HISTORY','130e0ebd76eeb6a7ba2dd0eaaf4250ca'),('apvendorpage_define.php','ap',0,0,1,'VendControl','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_VENDOR_PAGE_CUSTOMIZER','2313bf7757853ac359e4bbade8ea4a08'),('apvendupd.php','ap,inv,sc',0,1,1,'','STR_CONTACTS|STR_VENDORS|STR_EDIT_VENDOR','dc1f7bdd1a634dc1f2c445a83763d1a4'),('ar2inv_close.php','ar,inv,sc',0,1,1,'','','36f5659d57a5531dbaa8b21e28d16deb'),('ar3dcart.php','ar',0,1,1,'3dcart','STR_TOOLS|STR_IMPORTS|STR_IMPORT_3DCART_ORDERS','e95748f8c80a64d0875cf920ce9e5661'),('ar3dcartpricing.php','ar',0,1,1,'3dcart','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_UPDATE_3DCART_PRICES','45adb540748511549e82d1171332c145'),('ar3dcartship.php','ar',0,1,1,'3dcart','','7b167a03e2cf708b8455d7fb2d008f3c'),('ar3dcartstatus.php','ar',1,1,1,'','','c0795d1ec2ca6f9fe7a748a18611ab44'),('araiproducts.php','ar,inv',0,1,1,'','','5c52d254304edbebf02243bc3130bc47'),('arbankdepositadd.php','ar',0,1,1,'','STR_BILLING|STR_BANK_DEPOSITS|STR_NEW_BANK_DEPOSIT','aefb59906f2b75b6c70b90492c593320'),('arbankdepositupd.php','ar',0,1,1,'','STR_BILLING|STR_BANK_DEPOSITS|STR_EDIT_BANK_DEPOSIT','49b8aa73291f6a713bdbeca13acbf9dc'),('arbankdepositviewfpdf.php','ar',0,1,1,'','','f332b71499af89270dd2aec861d6e1ea'),('arbankreconcile.php','gl',0,1,1,'','STR_LEDGER|STR_BANK_RECONCILIATION','08ffe7a280a6bf3e565561fb7712b1df'),('arcashpaymentadd.php','ar',0,1,1,'NonInvoicedSales','STR_BILLING|STR_INVOICES|STR_NEW_NON_INVOICED_SALES','971012b6ba4917b1a238b6515258f2d3'),('arcashpaymentrep.php','ar',0,0,1,'NonInvoicedSales','STR_BILLING|STR_REPORTS|STR_NON_INVOICED_SALES','bcfac4e73dc0555a12a030b6f7d72e06'),('arcashpaymentupd.php','ar',0,1,1,'NonInvoicedSales','STR_BILLING|STR_INVOICES|STR_EDIT_NON_INVOICED_SALES','29293bd6d38456a8aa1b70c87fa76143'),('arcctransactions.php','ar,sc',0,1,1,'','STR_BILLING|STR_REPORTS|STR_CREDIT_CARD_TRANSACTIONS','fbb1c2c619fdf174b38a0436ef809807'),('arcim.php','ar',0,1,1,'','','4e500dbf8ded46da4ae7aa0c60e3eaad'),('arcimue.php','ar',0,1,1,'','','dc1d8be0bf22ab42650c8afd77f6c850'),('arcoinvoice.php','ar',0,1,1,'','','00b89299de6b178727724f33f7269a5a'),('arcredit_writecheck.php','ap',0,1,1,'','STR_BILLING|STR_INVOICES|STR_REFUND_CREDIT','c98388317f224d01485687200679fdb3'),('arcustadd.php','ar,est,sc',0,2,1,'','STR_CONTACTS|STR_CUSTOMERS|STR_NEW_CUSTOMER','0c7b6fdc38331709fe5c0b64b50537f0'),('arcustb2buser.php','ar,est,inv',0,1,1,'b2b','STR_CONTACTS|STR_CUSTOMERS|STR_B2B_USERS','e463a1338f7431ca604cf6b590df0ba1'),('arcustchange.php','ar',0,1,1,'changecustomer','','da5ab2a5505279df3aac66269b29efbd'),('arcustcsvlist.php','ar,est,sc',1,1,1,'','','260789be3431ab50cc2148fcf299942f'),('arcustdupmatch.php','ar,gl,ap',0,1,1,'','','c0550c388e9eab075081198363e91db5'),('arcustitemdiscount.php','ar,sc,inv',0,1,1,'custitemdiscounts','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_CUSTOMER_ITEM_DISCOUNTS','0aab13334ebc4be52efc48897845d119'),('arcustlist.php','ar,est,sc',1,2,1,'','STR_CONTACTS|STR_REPORTS|STR_LIST_CUSTOMERS','b181ec4a4cce84ddfe05dcee308110be'),('arcustlistedit.php','ar',0,1,1,'','','e85597ad9ffd0bc2606c079671dfab9e'),('arcustlistremove.php','ar,sc',0,0,1,'','STR_CONTACTS|STR_REPORTS|STR_INACTIVE_CUSTOMERS','1b87df581a5de2c2be6dd7f7c23de500'),('arcustlistview.php','ar,est,sc',1,1,1,'','','c986fdc5c2e3c6d23a73f1bebc0c52fc'),('arcustmerge.php','ar,est,sc',0,0,1,'MergeCust','STR_CONTACTS|STR_CUSTOMERS|STR_MERGE_CUSTOMERS','83da58425e135435464e95d54e6dd796'),('arcustmerge_customfields.php','ar,est,sc',0,0,1,'MergeCust','','a4ef61ed5a1eb71c336ff972315e38f7'),('arcustomerpage_define.php','ar',0,0,1,'CustControl','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_CUSTOMER_PAGE_CUSTOMIZER','f6e68a8eea37ddb3eae8d5800f82df78'),('arcustupd.php','ar,est,sc',0,2,1,'','STR_CONTACTS|STR_CUSTOMERS','65dcdac47c9a07fe958c429f62c6a649'),('ardiscountedit.php','ar,gl,ap',0,0,1,'discounts','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_INVOICE_DISCOUNTS','1879bcf2686924acdaa2384d6ffb6542'),('areft.php','ar',0,1,1,'','STR_BILLING|STR_INVOICES|STR_ENTER_EFT_PAYMENTS','ce6d7c799132a8965431e3ac5106d7cf'),('arhotelusage.php','ar',0,1,1,'hotelusage','STR_BILLING|STR_HOTEL_USAGE','c7cf7fa698b00baa319cb94e47ebd206'),('arinvoice_writeoff.php','ar',0,1,1,'baddebt','STR_BILLING|STR_INVOICES|STR_BAD_DEBT','397c72d7d607ebe15ce0d265a1f65f67'),('arinvoiceadd.php','ar',0,1,1,'','STR_BILLING|STR_INVOICES|STR_NEW_INVOICE','0d15f925b81d78fefc0cde6ac9a4713a'),('arinvoiceadd_beginbal.php','ar',0,0,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_BEGINNING_BALANCES','adbafdbe03c7e058e9a49a3d359c03fe'),('arinvoiceaddcogs.php','ar',0,1,1,'','','669120172e138f55a3be9a301f49e721'),('arinvoicearchive.php','ar',0,0,1,'archiveinvoices','','f68f04552d9e3e04b6d6f7cd6693ca6b'),('arinvoicebystate.php','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_INVOICES_BY_STATE','75f8656e0c041a7fcdaf39f12386140a'),('arinvoicecalcint.php','ar',0,1,1,'CalculateInterest','STR_BILLING|STR_INVOICES|STR_CALCULATE_INTEREST','1f72b7405160b935ca0a10ffa4758c8f'),('arinvoicedelivery.php','ar',0,1,1,'','','71ff40b199977535779486f7e5fc1659'),('arinvoicehist.php','ar',1,1,1,'','','fad5548c493013e54d6cc364ff0c1a53'),('arinvoiceintrpt.php','ar',0,1,1,'','STR_BILLING|STR_INVOICES|STR_INTEREST_ADJUSTMENTS','8650271be1441a81099d6674585dd1f9'),('arinvoicepay.php','ar',0,1,1,'','STR_BILLING|STR_INVOICES|STR_ENTER_PAYMENTS','a3b5910bcfb89888b2995c9c0a4b7433'),('arinvoicepayreceipt.php','ar',0,1,1,'receipt','','febacfdacbbd2fefd55a347102df163f'),('arinvoicepaysp.php','ar,gl,ap',0,1,1,'customenterpayments','STR_BILLING|STR_INVOICES|STR_ENTER_PAYMENTS','cf77a4f972b4b39ab30e89fb9da2a2e3'),('arinvoicepayuser.php','ar',0,0,1,'userpaymentcollection','STR_BILLING|STR_INVOICES|STR_USER_PAYMENT_COLLECTION','452831616e70ad6735dcd165c03b35a4'),('arinvoicepayvoid.php','ar',0,0,1,'','STR_BILLING|STR_INVOICES|STR_VOID_PAYMENTS','2202339afcc6a9b436358c475cff8713'),('arinvoicerepaging.php','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_AGING_DETAILS','fef0aa492759214c439086be1342b7ae'),('arinvoicerepbalcust.php','ar',1,1,1,'','STR_CONTACTS|STR_REPORTS|STR_CUSTOMER_BALANCE_HISTORY','d7076fe616f28e156892b942eae49cd9'),('arinvoicerepbalcust_detail.php','ar',1,1,1,'','STR_CONTACTS|STR_REPORTS|STR_CUSTOMER_ACTIVITY_HISTORY','6e8528ec58e72451dbdf860cf167f761'),('arinvoicerepcust.php','ar',1,1,1,'','STR_CONTACTS|STR_REPORTS|STR_CUSTOMER_ACCOUNTS','e7caa81c139fbff2b85de3877d4bb783'),('arinvoicereppay.php','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_PAYMENT_REPORTS','07ee46644882f09f80013ed30a9cb31f'),('arinvoicereprint.php','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_REPRINT_INVOICES','07fce77e939cfc941b5fa17b15c87eb6'),('arinvoicereptax.php','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_SALES_TAX_REPORT','964e954d7dc65f9485fda3a4d1019780'),('arinvoicerepvat.php','ar',1,1,1,'','','7a119492813091253d2671b97b1882e0'),('arinvoicereturns.php','ar',0,1,1,'itemreturns','STR_BILLING|STR_INVOICES|STR_ITEM_RETURNS','35716da171f91662da5d95e149386f5e'),('arinvoicereturnsdetail.php','ar',1,1,1,'itemreturns','','f57df67536b2261333b984facebfb444'),('arinvoicestate.php','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_STATEMENTS','c34f42a19becebc4256f5e1de777fa53'),('arinvoicestateemail.php','ar,gl,ap',1,1,1,'','','6297cf6d68692c7ec2fe2c8bc9cb4d92'),('arinvoicesum.php','ar',1,1,1,'',NULL,'a8c752fb6049a5ee4cebaaeaf3a9080a'),('invitemlstreorder.php','inv,ap',1,1,0,'inventory',NULL,'026a0ad4136a86b399475f197e2e09b3'),('arinvoiceupd.php','ar',1,0,0,'','STR_BILLING|STR_INVOICES|STR_EDIT_INVOICE','2f1c0d300fd6131520def866c643d112'),('arinvoiceview.php','ar',1,1,1,'','','9a6e47bdf9c757bf522eb9614a8e237e'),('arinvoiceview_beginbal.php','ar',0,0,1,'','','119c64c664c5a2b3ec521b1a91d0e0f1'),('arinvoiceviewfpdf.php','ar',1,2,1,'','','ccfa18f581e55b89c175814ee07ccd35'),('arinvoiceviewfpdf_small.php','ar',1,2,1,'','','333be3c2bbcfd6ee8c87ca3f6553c939'),('arinvoiceviewfpdf_small2.php','ar',1,2,1,'','','c62ca94344449865f826409a52e97429'),('arinvoiceviewfpdf_small3.php','ar',1,2,1,'','','902f0d751348a3b76243d70f024f65f1'),('aritemcalcreorderpoint.php','inv,sc',1,2,1,'ItemSalesHistory,inventory,orderptcalc','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_CALCULATE_ORDER_POINTS','00c5c118088747ba1b3f613e3334f8d8'),('aritemsaleshistory.php','ar,inv,sc',1,2,1,'inventory,item12mo','STR_INVENTORY|STR_REPORTS|STR_12_MONTH_SALES','9f3a4ac763c88b9264ebeb44a6c80f43'),('aritemsaleslst.php','ar,inv,sc',1,2,1,'ItemSalesHistory,inventory','STR_INVENTORY|STR_REPORTS|STR_INVENTORY_HISTORY','15fae6882be69e819eeae27950829163'),('armessage.php','ar',1,1,1,'','','e8e8b7472c9f312d945a0a3eed737a31'),('arordcc.php','ar,sc,inv',0,2,1,'','','c7d0f5917d6f1bf882ff41f8543eb5ef'),('arordclone.php','ar',0,1,1,'cloneorders','','a8b4174665b5b9ab1c656ca0a2a01d54'),('arordconfirmfpdf.php','ar,inv,sc',1,2,1,'','','c85749394409ddd8e73b98f391109f2d'),('arorder2invoice.php','ar,inv,sc',0,2,1,'inventory','STR_ORDERS|STR_ITEM_ORDERS|STR_ORDERS_INVOICES','e28c534da77c21961bad825ef32b5eb9'),('arorder_activity.php','ar',1,2,1,'','STR_BILLING|STR_REPORTS|STR_SALES_PROFITABILITY','98944054a428afbe5357be0ee78c9be0'),('arorder_add_deposit.php','ar,inv,sc',1,2,1,'','','68971ce810515b8a0a47d22e17bf0e91'),('arorder_confirm.php','ar,inv,sc',0,2,1,'','','2b0adb4d76d71a7dd64076a0e59c7193'),('arorder_hold.php','ar,inv,sc',0,2,1,'','','1358ee8eb55ad4e1e63339d3b0860c64'),('arorder_over_hours.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_HOURS_ORDERED','f1f37b23d2af72e7b6d4bef82adfcb54'),('arorder_unconfirmed.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_ORDERS_UNCONFIRMED','08bf2faccf7465d37a75c3e3cccee6d4'),('arorder_volume.php','ar',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_VOLUME_RPT','803b5c83b02253a8e2e6ef86276e72f0'),('arorder_volume_detail.php','ar',1,2,1,'','','c90117e1d49bc0f43ed9b6cf6385bae6'),('arordercustitemlst.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_CUSTOMER_ITEM_HISTORY','b3f4e1448e6fdaaab901960c36f8daf3'),('arorderitemcustlst.php','ar,inv,sc',1,2,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_ORDER_HISTORY','834864db2279431664c8cfead725b75f'),('arorderitemlst.php','ar,inv,sc',1,2,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_OPEN_ITEMS_ON_ORDERS','8933764e0113dd10283f83cc28775ce3'),('arorderitemlst_backorder.php','ar,inv,sc',1,2,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEMS_BACKORDERED','b38697e73d36323152d5bd526a8ac7f3'),('arorderlist.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_ORDERS_OPEN','8b3bf47f52035836ebf90e85cfcf14be'),('arorderlist_backorder.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_BACK_ORDERS','bc32d71f23f2840095184599b1dbf9fd'),('arorderlist_sum.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_SUMMARY_OPEN_ORDERS','98521c35f884e23b30f97d150f256595'),('arorderlistreceive.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_ORDERS_RECEIVED','0684fd4ef40fe0a844d3516b8acc8ec6'),('arorderlistvoid.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_VOIDED_ORDERS','48615731d07bc312516b3ad8eebf571a'),('arorderlistweight.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_OPEN_ORDER_WEIGHT_VIEW','4467953484126d758e444208b8235689'),('arordermargins.php','ar,gl,ap',0,0,1,'salesmarginblock','STR_ORDERS|STR_REPORTS|STR_MARGIN_EXCEPTION_REPORT','946df97ea67f1b3e3d479c39af93d752'),('arordernumber.php','ar',0,0,1,'inventory','STR_ADMIN|STR_SETUP_SERVICE|STR_SET_NEXT_ORDER_NUMBER','f5ca98d3511ebf3633584962be61e18b'),('arorderquotedel.php','ar',0,1,1,'','','bf1dbe3f5ab443d29fe941327e5a33f1'),('arorderquotelist.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_FULFILLMENT_QUOTES','8fe9c2ae4dbda3056ccfc8f818f4d8a6'),('arorderrmalst.php','ar,inv,sc',1,2,1,'','STR_ORDERS|STR_REPORTS|STR_RMA_LISTS','4279498ba54e2d1b452fc1be1222bd7d'),('arordershipitemlst.php','ar,inv,sc',1,2,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_SHIPMENTS','5d5066da76b686fb45809df4930f6e2c'),('arordershiplst.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_ORDERS_COMPLETED','ef2ed55b8cbd7c6205bccaceeed38ba6'),('arorderstatlst.php','ar,inv,sc',1,2,1,'','STR_ORDERS|STR_REPORTS|STR_PERFORMANCE_STATISTICS','c5cbf8faa32f500b87e177ab609a0644'),('arorderunbilled.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_SHIPPED_NOT_BILLED','3842316559bdd34717a019993a0a5f5b'),('arorderunpaid.php','ar',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_BILLED_NOT_PAID','f38fcee9bfef6729781a9308f5583bcd'),('arordpicktick.php','ar,inv,sc',1,2,1,'','','62a9288918909115e6d52b255f6a321b'),('arordpicktickfpdf.php','ar,inv,sc',1,2,1,'','','4d3d845ae16b551df741e19c22d47a04'),('arordpurge.php','ar,gl,ap',0,1,1,'purgeorders','STR_ADMIN|STR_SETUP_SERVICE|STR_PURGE_FULFILLMENT_ORDERS','635763cb321e80896d4c82d1ca54b9c4'),('arordquotefpdf.php','ar',1,2,1,'','','9caa8e63629888d5903a6518bbfb88a3'),('arordshipadd.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_ITEM_ORDERS|STR_SHIP_ORDER','c157a6d09cad2253471297c3e1637ae2'),('arordshipadd3dcart.php','ar',0,1,1,'3dcart','STR_ORDERS|STR_ITEM_ORDERS|STR_SHIP_3DCART_ORDERS','4df2a613313930ac183a80846a22b51b'),('arordshipadd_group.php','ar,inv,sc',1,2,1,'inventory,groupship','STR_ORDERS|STR_ITEM_ORDERS|STR_GROUP_SHIP_ORDERS','601205ea7bac65aba8f3fe0e093b5798'),('arordshipboxlabelpdf.php','ar,inv,sc',1,2,1,'','','d0ddab975cd5464f7e81a9711250b85a'),('arordshipview.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_VIEW_SHIPPED_ORDERS','904cf53b8b75d5fd4685f471e78d6fb9'),('arpayplan_post.php','ar',1,1,1,'','STR_BILLING|STR_PAYMENT_PLANS|STR_POST_PLANS','672a87c59d772c3be4d1829ceff2dac3'),('arpayplanadd.php','ar',0,1,1,'','STR_BILLING|STR_PAYMENT_PLANS|STR_NEW_PLAN','2f778c69ae4fd4a10abaefb2f5dee3a4'),('arpayplanrep.php','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_LIST_PAYMENT_PLANS','70f832198a13ebc78649d45c59ec0be3'),('arpayplanupd.php','ar',0,1,1,'','STR_BILLING|STR_PAYMENT_PLANS','d89438aa599d2cd9e83028cf980607dd'),('arrmaorderadd.php','ar,inv,sc',1,2,1,'','','2882bc2bb2ba03dc3c3f352be1cb710f'),('arrmaorderreceive.php','ar,inv,sc',1,2,1,'','','0f8857a95cd4a7db4fe03f422ec22e14'),('arrmaorderupd.php','ar,inv,sc',1,2,1,'','','fccfd49a7747e9af0cfb1b83b399951f'),('arrmashipview.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_ITEM_ORDERS|STR_PROCESS_RMAS','b77c323001bd5b6a761ae460cc47b2bf'),('arserialcheck.php','ar',0,1,1,'','','9054556d51b17ae54614b456d9ab11f2'),('arserviceclassadd.php','ar',0,0,1,'inventory','','fef2678f137ecd8848409a7966406c76'),('arserviceclassupd.php','ar',0,0,1,'inventory','STR_ADMIN|STR_SETUP_SERVICE|STR_SERVICE_CLASSES','96af71bcf58a4b7def49e1f3543d64ab'),('arserviceordadd.php','ar,sc,inv',0,2,1,'inventory','STR_ORDERS|STR_SERVICE_ORDERS|STR_NEW_ORDER','c474d785f25d9df09a681fce5b936e07'),('arserviceordconfirmfpdf.php','ar,inv,sc',1,2,1,'servicePF','','7c97f159eeb23acd1981f5199f2544ac'),('arserviceordtick.php','ar,inv,sc',1,2,1,'','','668a78c79e183c1dbf2208f322306262'),('arserviceordtickfpdf.php','ar',1,1,1,'','','bcdaa58c79b8e0ffbf63b8138f62b3da'),('arserviceordupd.php','ar,inv,sc',0,2,1,'inventory','STR_ORDERS|STR_SERVICE_ORDERS','d8dec918976a49c5cc15186742270ec7'),('arserviceordworkdetails.php','ar,inv,sc',0,2,1,'','','8f1adae864a616bf9506b81625860d35'),('arservicerates.php','ar',0,0,1,'inventory','STR_ADMIN|STR_SETUP_SERVICE|STR_SERVICE_LABOR_RATES','6fa624b0877386414baa48d67fc50cd2'),('arservicesubtype.php','ar',0,0,1,'inventory','STR_ADMIN|STR_SETUP_SERVICE|STR_SERVICE_SUBTYPES','e14b21037dd7d323fb8c6b088664df6f'),('arservicetypeadd.php','ar',0,0,1,'inventory','','b87c49695b817f9e09c869b1a2d0aa09'),('arservicetypeupd.php','ar',0,0,1,'inventory','STR_ADMIN|STR_SETUP_SERVICE|STR_SERVICE_TYPES','1bb029a1a04716400af571bd8da6d915'),('arstateviewfpdf.php','ar',1,1,1,'','','30004d249c2f15a25ccc9ee19256c30e'),('arvendb2buser.php','ar,est,inv',0,1,1,'b2b','STR_CONTACTS|STR_VENDORS|STR_VENDOR_B2B_LOGIN_USERS','bb824c43c9f967a23e8d8effda49c10b'),('b2b/estquoteaddform_mail_fpdf.php','est',1,1,1,'','','21fd953f9defbcfd9fe3fec036cecb28'),('b2b/estquotejobticket_ow_fpdf.php','est',1,1,1,'','','7ffdd9d718d28b52eeb120f450fb27f5'),('bankaccountaddupdate.php','pay',1,1,1,'','','ddac8b805902c6e4a0143ea699fba9fe'),('barlabelfpdf.php','ar,inv,sc',1,1,1,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_PRINT_BARCODE','c98bdff7e0a49614c275c211b53627a9'),('bom_list.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_LIST_BOM_DEFINITIONS','5e57b3eb10e35b88ffd00c283fd7a597'),('calcimp.php','est',1,1,1,'','','df728e88b2d6395f75d054f58c10941b'),('changedate_due.php','est',0,1,1,'','','5b9275283f0811bd420cd53a155fe5b6'),('changedate_due_tam.php','est',0,1,1,'','','b899239d9788c5cbbc89f3ae9012e1aa'),('check_calc.php','est',1,1,1,'','','9b677b061996da3aa2ca20b3e300f49c'),('checklist.php','ap,inv,gl,pm',0,1,1,'pm','','0327341056ad8d69454f15ae5761e469'),('checks.php','ap',0,1,1,'','','9f5d568f9ff4510573fd1972ea2582c1'),('checks_one.php','ap',0,1,1,'','','c1b1eeb89fd01138f34c913acb0183ce'),('checksemail.php','ar,gl,ap',1,1,1,'','','10788b6214ba358063747c2f9ae5b28f'),('commissions.php','ar,gl,ap',0,1,1,'commissions','STR_BILLING|STR_REPORTS|STR_COMMISSIONS','4508bf2f8f26a20b9f050df474c09416'),('constructionloanadd.php','ap,inv',0,1,1,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_LOAN_ADD','b989fe89894c60759243f99d8bb4f0d8'),('constructionloanupd.php','ap,inv,sc',0,1,1,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_LOAN_UPDATE_AND_PAY','2818b9fa98e40c13132abdf02d91ca37'),('copytax.php','pay',0,1,1,'payroll,fedtax_update','STR_PAYROLL|STR_TAX_TABLES|STR_START_NEW_YEAR','2ba4282adad3aa4f4cdf8740ee113c97'),('custexportimport.php','ar',0,1,1,'Exports','STR_CONTACTS|STR_CUSTOMERS|STR_EXPORT_IMPORT_EDIT_TOOL','199b91cb62fc058f1755c5cbd4cbb915'),('directdepform.php','pr',1,1,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_DIRECT_DEPOSIT_AUTH','cce25e2de660cb47fd8010f83962b050'),('distributor_commissionreport.php','ap',0,1,1,'commissions','STR_PAYABLES|STR_REPORTS|STR_COMMISSION_CHECKS','31f6efd6ff9f244a749d9f06f401fc40'),('donotdistribute/jenniferhollyer/projectactivity.php','ar,ap',1,1,1,'','','1cc22d87c0479df3b815c2b19e444c6a'),('donotdistribute/jenniferhollyer/projectadd.php','ar,ap',0,1,1,'','','0e06e574890161931d44508c04a1802b'),('donotdistribute/jenniferhollyer/projectgen.php','ar,ap',0,1,1,'','','b891ef924e44e605e1f4d1c2785b0d29'),('donotdistribute/jenniferhollyer/projectinspect.php','ar,ap',1,1,1,'','','b085bf233ade1a49d23cd38a592765a8'),('donotdistribute/jenniferhollyer/projectinvoice.php','ar,ap',0,1,1,'','','f4b546ca186b81b40f1465db91ffadeb'),('donotdistribute/jenniferhollyer/projectlist.php','ar,ap',1,1,1,'','','987d899480ab2036b3901faabcf40b0a'),('donotdistribute/jenniferhollyer/projecttypeadd.php','ar,ap',0,1,1,'','','8c0af0e40b2bbfbcc27944ea3fb0d2b9'),('donotdistribute/jenniferhollyer/projecttypeupd.php','ar,ap',0,1,1,'','','70b5b4196441085795977a52607b90cc'),('donotdistribute/jenniferhollyer/projectupd.php','ar,ap',0,1,1,'','','d6b6cdefe0be9037a9136e888290e79a'),('donotdistribute/jenniferhollyer/projectviewfpdf.php','ar',1,1,1,'','','cd775123cc1741ba3a3630debc633910'),('donotdistribute/logimedix/callreport.php','ar',1,1,1,'','','ef0eeee06fdf42869e7c3e7d5c98378c'),('donotdistribute/logimedix/logimedix_importdaily.php','ar,est,sc',0,0,1,'','','81fae30eede1499f7eb5962e196db776'),('donotdistribute/noguska/inventory_validate_transactions.php','',0,0,1,'','','adbe1f9fd404b805451e2a370afa2f07'),('donotdistribute/postech/adminsummaryemail.php','ar,gl,ap',0,1,1,'','','7ee102920c286107214f0299e65751d8'),('donotdistribute/swiftstaffing/importemployeeandpay.php','pay',0,0,1,'','','b4ef7808197b7f244ac5d6e678791d58'),('donotdistribute/tca/tca_arinvoiceupd.php','ar',0,1,1,'','','182cbfb976b390c44c2a3cfbae820654'),('downloaddb.php','admin',0,0,1,'','','84587d6fedd0dad710ba889f72cf36f2'),('editarnote.php','ar,inv,sc',1,1,1,'','','b447387dd0c38547bb0f8d280eeb4c83'),('editinvponote.php','ap,inv',1,1,1,'','','7623ee7275fc551440fe5c19cf8da1ef'),('est_back_from_proof.php','est',0,1,1,'Printshop_std','STR_PRINTSHOP|STR_PROCESSING|STR_PROOF_PROCESS','3168c125395091db0261ddbc1171f37a'),('est_lists_quotes.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_LIST_PRINT_ORDERS|STR_QUOTE_LISTS','c74a89badb14ded9cc55018c51104e20'),('est_ontime_stats.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_REPORTS|STR_ON_TIME_STATS','7c59da6e7ce386aaabc00e31f4498c29'),('est_out_to_proof.php','est',0,1,1,'Printshop_std','STR_PRINTSHOP|STR_PROCESSING|STR_OUT_TO_PROOF','2a4028070ea9734f797e08d78265d48c'),('est_print_quote.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER|STR_PRINT_QUOTE','28bb2e6a228ab60a6f035c82b7c4311b'),('est_print_quotepdf.php','est',1,1,1,'','','259475ab1550e344c8109606687e1ef2'),('est_proof_history.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_REPORTS|STR_PROOF_HISTORY','5c72d7bf3cb6a730d3d9b691aa5d285f'),('est_redo_stats.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_REPORTS|STR_REDO','71fc8289dc98f36e41d23f0a52d7586f'),('est_review_order_costs.php','est',0,1,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER|STR_REVIEW_COSTS','49842a935b7fd21e03141d967655a1ba'),('est_shop_loading.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_SCHEDULING|STR_SHOP_LOADING','2356cbd71747d07ff01ade1077b53b50'),('est_stock_needs.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_SCHEDULING|STR_STOCK_NEEDS','29f3683fefe82e20de07306b36c4f0cf'),('est_stock_needs_status.php','est',0,1,1,'','','ee394b099e9308a1f9f9054ae8a62105'),('est_update_existing_orders.php','est',1,1,1,'','','6150c3e83b9f75658da1e288fbeb6f54'),('est_variance.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_REPORTS|STR_VARIANCE','3262913509f591a4d9d5e66cc5bf027f'),('est_volume.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_REPORTS|STR_VOLUME_RPT','c2cbaaa169b95114d5c019c7004b981d'),('est_volume_detail.php','est',1,1,1,'','','ae0e88e617b5499db3f1e0ecc8359ce8'),('est_work_in_process.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_SCHEDULING|STR_WIP','27ec862d6f497a0fb76c30e66d203b58'),('estquote2invoice.php','est,ar',0,1,1,'','STR_PRICELIST|STR_LIST_PRINT_ORDERS|STR_ORDERS_INVOICES','ef02ef47754ce606ee72c7976fc40c54'),('estquote2invoice_quick.php','est,ar',0,1,1,'','STR_PRICELIST|STR_LIST_PRINT_ORDERS|STR_ORDERS_INVOICES_QUICK','2379bc46b7f4a9eb715b0bab00ebd4c9'),('estquote_noorderyear.php','est',1,1,1,'','STR_PRICELIST|STR_LIST_PRINT_ORDERS|STR_NO_ORDERS_THIS_YEAR','b59b242a6692318048c139aef29100ba'),('estquote_ontimestats.php','est',1,1,1,'','STR_PRICELIST|STR_REPORTS|STR_ON_TIME_STATS','955340394366a7c136bc6b9ea5c9a17c'),('estquote_stock_needs.php','est',1,1,1,'','STR_PRICELIST|STR_REPORTS|STR_STOCK_NEEDS','e73a6738785dc930320579e787f0081b'),('estquote_volume.php','est',1,1,1,'','STR_PRICELIST|STR_REPORTS|STR_VOLUME_RPT','c5f1e77feb2ae64a15c11b8fdd498e52'),('estquote_volume_detail.php','est',1,1,1,'','','4bfb4a05260cd838ef455a04b37dce44'),('estquoteaddform.php','est',1,1,1,'','STR_PRICELIST|STR_QUOTES','cf4d26f6ee6d3520faee3f9dae1a5594'),('estquoteaddformmail.php','est',1,1,1,'','','0d698fbd034a47052f3a08e1845057c6'),('estquoteaddformmail_fpdf.php','est',1,1,1,'','','45155045d44e23114e5275f5baa37b20'),('estquoteaddformmail_ow_fpdf.php','est',1,1,1,'','','8f30acc697fe76f5900617e5d880207e'),('estquoteaddjob.php','est',1,1,1,'','STR_PRICELIST|STR_PRINT_ORDER|STR_NEW_PRINT_ORDER','2e567ebb03d1b54007ccdb6617e2e467'),('estquoteaddjob2.php','est',1,1,1,'','','d1b2280857677415fa3f5df382a9aa08'),('estquoteaddjob_wt1.php','est',1,1,1,'','','1279338ae849a8d6093eed24263c4c66'),('estquoteaddjob_wt2.php','est',1,1,1,'','','4cf0eb20fd9b104a1a3b82da3766d1c0'),('estquoteaddjobcopy.php','est',1,1,1,'','','c678791d0b31fd4137766f5fc1268b4d'),('estquoteaddjobmail_fpdf.php','est',1,1,1,'','','455867e0c99c41f4c3a7a75564f147c2'),('estquoteaddjobmail_ow2_fpdf.php','est',1,1,1,'','','3af9b5593951ee8d48af083fb96d7e9c'),('estquoteaddjobmail_ow_fpdf.php','est',1,1,1,'','','160f21f54940b5a19b73e9bfce9a076d'),('estquoteaddshipmail_fpdf.php','est',1,1,1,'','','2bf15810487ebd9d502bf320582c7464'),('estquotebilledorder.php','est',1,1,1,'','STR_PRICELIST|STR_LIST_PRINT_ORDERS|STR_BILLED_PRINT_ORDERS','a63d115ada1cdc7e0f7f59200267a197'),('estquotebindlstadd.php','est',0,0,1,'','','609ec4141ee66fa24cb8d4b01ed4601b'),('estquotebindlstaddladd.php','est',0,0,1,'','','cd7923415c04cfb033a83d414c2e94b8'),('estquotebindlstaddlopt.php','est',0,0,1,'','','f1129944b9d9d29deac30644d85a3fcc'),('estquotebindlstaddlsizeupd.php','est',0,0,1,'','','2b0553ea1c63156d5a9f7f12a4376577'),('estquotebindlstaddlupd.php','est',0,0,1,'','','f92468effd2f8de8ed110a1fd20afdff'),('estquotebindlstupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_BINDERY_PRICES','50611862599298229be836090319e227'),('estquoteboxlabel.php','est',1,1,1,'','','7a3c43671a0335e5eff423eba1086556'),('estquoteboxlabel_lpstd.php','est',1,1,1,'','','cd6ab722c5b706269df82e6d4f392b29'),('estquotecc.php','ar,sc,inv',0,1,1,'','','689bfba6ad61fc42f8a32c16954ae988'),('estquotecompleteorder.php','est',1,1,1,'','STR_PRICELIST|STR_LIST_PRINT_ORDERS|STR_CLOSED_PRINT_ORDERS','6b7ec74977d382725332dacb68b17433'),('estquotecompletionsteps.php','est,ar',0,1,1,'','STR_PRICELIST|STR_PRINT_ORDER|STR_COMPLETION_STEPS','1a6072ed7dc4a0e70aa73793f67091f4'),('estquotecomplstadd.php','est',0,0,1,'','','a895d56eeca046050312660650711385'),('estquotecomplstaddladd.php','est',0,0,1,'','','e021f15939d253a54c0e69f2692f96b6'),('estquotecomplstaddlopt.php','est',0,0,1,'','','c09fa1f73fbea9fbef34337e82fa8c4e'),('estquotecomplstaddlsizeupd.php','est',0,0,1,'','','e01c67147e076a3b7eace884be3957f4'),('estquotecomplstaddlupd.php','est',0,0,1,'','','232f3df14083c2320712e7623e49af64'),('estquotecomplstupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_COMPOSITION_PRICES','9ed3118e974c0710adfb220e55d92bbe'),('estquotecouponadd.php','ar,est',0,1,1,'','','607d58864cc3fa5b09309078993abebb'),('estquotecouponupd.php','ar,inv,est',0,1,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_DISCOUNT_COUPONS','33793048ec31a87427ce6c635a53fa24'),('estquotecsrpending.php','est',1,1,1,'','STR_PRICELIST|STR_LIST_PRINT_ORDERS|STR_CSR_REPORT','5f90dd29b054c1a265e1b4ac42b77842'),('estquoteduedate.php','est',0,1,1,'','','f0d43cf3a4ed1e3b56b758dd6db63a2b'),('estquoteeditsearch.php','est',1,1,1,'','STR_PRICELIST|STR_QUOTES|STR_SEARCH_QUOTES','7d46cf28e16da06a1cf4aa8757b21f42'),('estquoteenvimp.php','est',1,1,1,'','STR_PRICELIST|STR_LIST_PRINT_ORDERS|STR_ENVELOPES_TO_PRINT','1998c4603aa225aebc3e92248befb0c4'),('estquotefromaddress.php','est',1,1,1,'','','709ee11d6e8d21bfb4a8709dcbffbd59'),('estquotejobticket.php','est',1,1,1,'','','f55c19c66d7d1c5399c8f6881751ed61'),('estquotejobticket_ow2_fpdf.php','est',1,1,1,'','','a9b45d49445d6591b95f31b3140fae69'),('estquotejobticket_ow_fpdf.php','est',1,1,1,'','','022ca5460168e6bccd7f67cf68a7029b'),('estquotelateorder.php','est',1,1,1,'','STR_PRICELIST|STR_LIST_PRINT_ORDERS|STR_OVERDUE_PRINT_ORDERS','dbd603241c5363dc69871674412427fc'),('estquotelists_unconfirmed.php','est',1,1,1,'','STR_PRICELIST|STR_PRINT_ORDER|STR_CONFIRM_PRT','6e4a1a9dc2184be39fca8c24062fd96b'),('estquotenumperbox.php','est',0,1,1,'','','abda933c0a8e0769c3312a0a6bea172b'),('estquoteopenorder.php','est',1,1,1,'','STR_PRICELIST|STR_LIST_PRINT_ORDERS|STR_PENDING_PRINT_ORDERS','eb9325d139e695827dd740030faaf72d'),('estquoteorderapproved.php','est',1,1,1,'','STR_PRICELIST|STR_PRINT_ORDER|STR_RELEASE_TO_PRESS','ba61bee3bba3bf2c06e6ff3b5b6bfb7a'),('estquoteorderapproved_detail.php','est',1,1,1,'','','2c293c15c4fe50896887964f1b70df26'),('estquoteordernotapproved.php','est',1,1,1,'','STR_PRICELIST|STR_PRINT_ORDER|STR_OK_ORDERS','46e44c89a87f84e572872adec0ddffc8'),('estquoteordersearch.php','est',1,1,1,'','STR_PRICELIST|STR_PRINT_ORDER|STR_EDIT_PRINT_ORDERS','3d37a1a82cb2911f36368143e459f57e'),('estquotepackingslip.php','est',1,1,1,'','','1a50738c9f9e9917a7a61b9f008540e5'),('estquotepieceworkadd.php','est',0,0,1,'','','663ca3683f6a1b0d9a11498f4c50c384'),('estquotepieceworkupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_ENTER_PIECEWORK_GROUPS','e06541f832d6b3f0b31c9dd83c8cfdde'),('estquotepricelstadd.php','est',0,0,1,'','','6244be3f4954cc771f66b6618b3507e3'),('estquotepricelstcolor.php','est',0,0,1,'','','ba13c98a336c19d7f382bbf7415b330d'),('estquotepricelstprice.php','est',0,0,1,'','','55f3a706ee0a73939f38be2d300cfa00'),('estquotepricelststockadd.php','est',0,0,1,'','','0597dfe8ef2a1fc06aeb0a42a1a23d28'),('estquotepricelststockupd.php','est',0,0,1,'','','bb4b6dcc162d4aa69ac6c27610f89da3'),('estquotepricelstupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_PRICE_LIST','08ebafd11be88e693ace77c8fc1b9e82'),('estquoteschedule.php','est',1,1,1,'','STR_PRICELIST|STR_LIST_PRINT_ORDERS|STR_PENDING_WORK','fcf9fe2bfc82fb80cc242883139d7924'),('estquotescheduledetail.php','est',1,1,1,'','','5e9054af006793150eeceaf059ae6e9d'),('estquoteshipping.php','est',1,1,1,'','STR_PRICELIST|STR_PRINT_ORDER|STR_REPRINT_SHIP','15dfca96745f96ed5b7e111367e00047'),('estquotestd_jobdescription.php','est',0,0,1,'oneWrite','','0652345378077558f29d9120694453c7'),('estquotestd_jobdescriptionupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_STANDARD_JOB_DESCRIPTIONS','9ee5318508835629b34a045fd112a06f'),('estquotestockadd.php','est',0,0,1,'','','b438c30a226fb3ab25133a366de37033'),('estquotestockupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_STOCK','f24ab0fd7bb5770a1741a72e882c6c84'),('estquotestockupd_percentage.php','est',0,0,1,'','','52ce2d15bbc911eab2dcdc9ea6d6af9b'),('estquoteworkarea_assign.php','est',0,0,1,'','','951db1831f4f083d3f62df9ad5790746'),('estquoteworkareaadd.php','est',0,0,1,'','','ac70ea74ea039079c0f6b7a2fcf2be79'),('estquoteworkareaupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_ENTER_WORK_AREA','8d8f789e465f0b345433fe94d7001a2b'),('estquoteworkstepsadd.php','est',0,0,1,'','','ea5131d4db499b7996078ac178dda737'),('estquoteworkstepsupd.php','est',0,0,1,'','STR_PRICELIST|STR_PRINT_ORDER_PRICELIST|STR_ENTER_WORK_STEPS','57e9899363132cafaf9bbe813839c59d'),('exportitems.php','ap,inv',0,0,1,'inventory,ExportItems','STR_TOOLS|STR_EXPORTS|STR_EXPORT_ITEMS','3fd97dafa57de58b105ce1871a6ff8ef'),('exportitemsdisplay.php','inv',1,1,1,'','','e1c1aee61324c7b1880f32cea26706fe'),('exportvendors.php','ap',0,0,1,'Exports','STR_TOOLS|STR_EXPORTS|STR_EXPORT_VENDORS','1c810a7763c0057ce5d10ad648b09cad'),('featurelist.php','admin',0,0,1,'','','a92c1279b051a0969b48d149f2d6dd8d'),('featurepurchase.php','admin',1,1,1,'','STR_TOOLS|STR_ADD_ONS','9245b09d5435694052959ec57cc2fedf'),('features.php','admin',0,0,1,'','','7951f9bde4b17dcd5ba4dcf08b33a857'),('gencompanyadd.php','admin',0,0,1,'','','11bdbb8faacac18cae68b6214b55e6df'),('gencompanyupd.php','admin',0,0,1,'','STR_ADMIN|STR_SETUP_ADMIN|STR_COMPANY_ADD_UPDATE','a557e8683e5e392e8a0212e5e3f62b7d'),('genuseradd.php','admin',0,0,1,'','','759f76b7407f285b13888b8437dbee56'),('genuserrights.php','admin',0,0,0,'userrights','','a7475dc71bdd34d97f373c7b7c757b2d'),('genuserrightsgroup.php','admin',0,0,0,'userrights','STR_ADMIN|STR_SETUP_ADMIN|STR_ADVANCED_USER_RIGHTS','4581deaa4b2c6ed1727b8975a7028828'),('genuserupd.php','admin',0,0,1,'','STR_ADMIN|STR_SETUP_ADMIN|STR_USERS','e42eff769f37a3376a945687aad9c8a0'),('gl_admin_cf.php','gl',0,0,1,'cashflow','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL|STR_CASH_FLOW_DEFINITION','98c9e28b2931182bb73045a96269de3f'),('gl_admin_export.php','gl',0,0,1,'Exports','STR_TOOLS|STR_EXPORTS|STR_EXPORT_ACCOUNTS','04a0646b0bf3c5995145df8e217fa68c'),('gl_admin_import.php','gl',0,0,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_ACCOUNTS','81469f1f6dd19dfa8aa1fcbd5ae94bc9'),('gl_admin_import2.php','gl',0,0,1,'','','f467e62aac465f972513c150524ed214'),('gl_admin_import3.php','gl',0,0,1,'','','b1ae45c356332c9999d27024b251ef00'),('gl_sumleveladd.php','gl',0,0,1,'GLSummarize','','f045c7814896e10e5f264af2d4b99772'),('gl_sumlevelupd.php','gl',0,0,1,'GLSummarize','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL|STR_GL_SUMMARY_LEVELS','ba796a14445725b54f8481f9b99a743b'),('glacct_assign.php','gl',1,1,1,'GLSummarize','STR_LEDGER|STR_CHART_OF_ACCOUNTS|STR_ASSIGN_SUMMARIZATION','47861b67d97bc920a6dc91af6b2faf64'),('glacctadd.php','gl',0,1,1,'','STR_LEDGER|STR_CHART_OF_ACCOUNTS|STR_NEW_GL_ACCOUNTS','d2a9a75982290ea79065aec3914f44e5'),('glacctlst.php','gl',1,1,1,'','STR_LEDGER|STR_REPORTS|STR_CHART_OF_ACCOUNTS_LIST','1190bd98c3de280efd819b51b8217d24'),('glacctlst1.php','gl',1,1,1,'','','e0717b67d8dc8ed3b825d5b688157afa'),('glacctupd.php','gl',0,1,1,'','STR_LEDGER|STR_CHART_OF_ACCOUNTS','5e4fbd2829640cb8bf0ca818b926dc84'),('glbankimporttrans.php','ar,gl,ap',0,1,1,'','','0ee17b081d782b6bcf5639751c3bd8d7'),('glbudadd.php','gl',0,1,1,'GLBudgets','STR_LEDGER|STR_BUDGETS|STR_NEW_EDIT_BUDGET','af882ef6823ea424009c265c1f400113'),('glbudlst.php','gl',1,1,1,'GLBudgets','STR_LEDGER|STR_REPORTS|STR_BUDGET_LIST','8e6b275aaa69c2837f6d5e52daa0ccc0'),('glcashflow.php','gl',1,1,1,'cashflow','STR_LEDGER|STR_REPORTS|STR_CASH_FLOW_REPORT','55120953aec8446c30001da49a0f1efc'),('glclose_year.php','gl',0,0,1,'','STR_LEDGER|STR_JOURNAL_ENTRIES|STR_CLOSE_YEAR','b99aaa1c821ea4350c9e5523b3aa9fc8'),('glcost_centeradd.php','gl',0,0,1,'GLCostCenter','','847825fbb5f26e891860952fc122ba10'),('glcost_centerupd.php','gl',0,0,1,'GLCostCenter','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL|STR_GL_COST_CENTERS','3d1021145b6dd7bfcb7f86999d1484a5'),('gljour_std_add.php','gl',0,1,1,'GLRecurring','STR_LEDGER|STR_RECURRING_LEDGER_ENTRIES|STR_NEW_RECURRING_ENTRIES','a3b2b9195bd59857c8e91181e91d8494'),('gljour_std_post.php','gl',0,0,1,'GLRecurring','STR_LEDGER|STR_RECURRING_LEDGER_ENTRIES|STR_GENERATE_RECURRING_ENTRIES','0cbf2d5a4e1dbaabc20b2a0b182954fb'),('gljour_std_upd.php','gl',0,0,1,'GLRecurring','STR_LEDGER|STR_RECURRING_LEDGER_ENTRIES|STR_EDIT_RECURRING_ENTRIES','f4e56d9c6b171c8747840f54453e2192'),('gljouradd.php','gl',0,1,1,'','STR_LEDGER|STR_JOURNAL_ENTRIES|STR_NEW_JOURNAL_ENTRIES','00fe8a2f66c890c154b4ebae4f3a7cfd'),('gljourupd.php','gl',0,0,1,'','STR_LEDGER|STR_JOURNAL_ENTRIES','d161d9ec6c3233bf66569e895e182260'),('glpost_mass_fix.php','gl',0,1,1,'','','cce6e86bbff2fef5743fd6108d4bc96a'),('glpostadd.php','gl',0,1,1,'','STR_LEDGER|STR_JOURNAL_ENTRIES|STR_POST_JOURNALS_NOW','21529c9262d02ea883e66a82dcc701ba'),('glpostreport.php','gl',0,1,1,'','STR_LEDGER|STR_JOURNAL_ENTRIES|STR_CORRECT_JOURNAL_DATES','15f7678dc621f719061ebd1b0114a7f6'),('glpostupd.php','gl',0,0,1,'','STR_LEDGER|STR_JOURNAL_ENTRIES|STR_UNPOST_JOURNAL_ENTRIES','85a78860ce1bac623a739c35006e798b'),('glrepactivity.php','gl',1,1,1,'','STR_LEDGER|STR_REPORTS|STR_ACCOUNT_ACTIVITY','86c81b27ae3afbcd599d4dc75932e0e7'),('glrepactivity_specific.php','gl',1,1,1,'ExpenseReport','STR_LEDGER|STR_REPORTS|STR_EXPENSE_REPORT','654ae41594d1085b6aaa27e12e0f9324'),('glrepbalance.php','gl',1,1,1,'','STR_LEDGER|STR_REPORTS|STR_BALANCE_SHEET','f64ba923c93d331ae3d50a253b8db6ab'),('glrepbalance_detail.php','gl',1,1,1,'','STR_LEDGER|STR_REPORTS|STR_DETAILED_TRIAL_BALANCE','87c8b561404401d1f28657c51d36fe27'),('glrepbalance_summary.php','gl',1,1,1,'','STR_LEDGER|STR_REPORTS|STR_STANDARD_BALANCE_SHEET','fa5a29adcaa0a6f9d1bbaa06a735086b'),('glrepbudvariance.php','gl',1,1,1,'GLBudgets','STR_LEDGER|STR_BUDGETS|STR_BUDGET_VARIANCE','44a5326012346a49c52d6c4bc479cb48'),('glrepdaily.php','gl',1,1,1,'dailyreport','STR_LEDGER|STR_REPORTS|STR_DAILY_REPORT','40e650669c6e95b35981475c880d260a'),('glrepincome.php','gl',1,1,1,'','STR_LEDGER|STR_REPORTS|STR_PROFIT_AND_LOSS','97b8391807884487f87fffda5174fb4c'),('glrepincome_12month.php','gl',1,1,1,'12monthP&L','STR_LEDGER|STR_REPORTS|STR_12_MONTH_PROFIT_AND_LOSS','ec5e03e780e99c4a37f22f98b7701b86'),('glrepjournal.php','gl',1,1,1,'','STR_LEDGER|STR_REPORTS|STR_JOURNAL_REPORTS','431e127663e74447c605a2b2626e9b39'),('glrepjournal_unbalanced.php','gl',1,1,1,'','STR_LEDGER|STR_REPORTS|STR_UNBALANCED','be2d8bc8f43f2c25837daaca75e12ef2'),('costcode.php','gl',0,0,1,'glcostcodes','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL|STR_COST_CODES','c289f16366b577b9560f15174517f3ef'),('costcodeadd.php','gl',0,0,1,'glcostcodes','','80b49ff1eb4bd7eeacd915b917e992d0'),('import_bom.php','inv',0,1,1,'inventory','STR_TOOLS|STR_IMPORTS|STR_IMPORT_BOM_DEFINITIONS','51d3e65b483ef04ec6de3be67921a0a1'),('import_coastpaper.php','ap,inv',0,0,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_IMPORT_COAST_PAPER_INVENTORY_FILES','ec4508befdcc3d4a1d779fca92baf02e'),('import_invitembuildorder.php','inv',0,1,1,'inventory','STR_TOOLS|STR_IMPORTS|STR_IMPORT_BUILD_ORDERS','a567b156cd0668c61cc75dbee0d96c06'),('!/gltransvoucher/hub_detailed_report/','gl',1,1,1,'hubconstruction','STR_LEDGER|STR_REPORTS|STR_IMPORTED_GL_ENTRIES_FROM_ANZIO','85bcba247a9de0cb47fa58db9835ccc1'),('importauthnettrans.php','ar',0,1,1,'authnettransimport','STR_TOOLS|STR_IMPORTS|STR_IMPORT_AUTHORIZENET_TRANSACTIONS','da370cd9521a1ed2fe4f41fb369b12a8'),('importbankofx.php','ar,gl,ap',0,1,1,'bankimport','STR_TOOLS|STR_IMPORTS|STR_IMPORT_BANK_STATEMENTS','33d2e7fe0200db09c143882b78121062'),('importbills.php','ap',0,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_VENDOR_BILLS','daecaf25ebe3bd66ad592ae48c7d9e96'),('importcustomer.php','ar,est,sc',0,0,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_CUSTOMERS','d515cb0ced9384db9b1a2fc2f38fa4cb'),('importemployee.php','pay',0,0,1,'payroll','STR_TOOLS|STR_IMPORTS|STR_IMPORT_EMPLOYEES','76c9d65d47ea352d36f003bf9a5449a7'),('importeporders.php','ar',0,1,1,'','','ac0101b50eac60eda7337d70be054cb4'),('importgljournals.php','ap,inv',0,0,1,'glTransImport','STR_TOOLS|STR_IMPORTS|STR_IMPORT_GL_TRANSACTIONS','69080837117e0dc79acb70ae5888354d'),('importgltotals.php','ap,inv',0,0,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_GL_TOTALS','2a65ea1d535e9636d99b166ee234efe2'),('importinvoices.php','ar',0,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_INVOICES','235d12b8fbd5549e9c14fea35bc33b82'),('importitems.php','ap,inv',0,0,1,'inventory','STR_TOOLS|STR_IMPORTS|STR_IMPORT_INVENTORY_ITEMS','69e38ca1d7e4de886904afece6eb826e'),('importmagentoorders.php','ar',0,1,1,'mage','STR_TOOLS|STR_IMPORTS|STR_IMPORT_MAGENTO_ORDERS','d4cd66d62218d5104deb5d950f3597b0'),('importoscom.php','ar',0,1,1,'oscommanualimport','STR_TOOLS|STR_IMPORTS|STR_IMPORT_OSCOMMERCE_ORDERS','b74ca5c2f77e576985f2176e50c1982d'),('importrprexpenses.php','ap,inv',0,0,1,'rpr','STR_TOOLS|STR_IMPORTS|STR_IMPORT_EXPENSES','8046084e2294a36b336dc9cd85018f64'),('importrprrevenue.php','ar,inv',0,0,1,'rpr','STR_TOOLS|STR_IMPORTS|STR_IMPORT_REVENUE','f7940edb7ef35ea4a90c1038f0d4a46c'),('invai3dcartupd.php','inv',0,1,1,'','STR_ADMIN|STR_SETUP_ADMIN|STR_A_AND_I_PRODUCTS_3DCART_UPDATE','8f6b16733b0f4105f631f8f5dd548999'),('invbeginbal.php','inv',0,0,1,'inventory','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_ITEM_BEGINNING_BALANCES','2b7eb655a4851c62bceea5e4d42aa7e1'),('invcatpriceadjust.php','inv',0,0,1,'itempricecategory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_PRICES_CATEGORY_EDIT','3248c61d795600aa488da187ffae64b3'),('invcotransfer.php','inv',0,1,1,'invcotransfer','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_INTERCOMPANY_ITEM_TRANSFERS','bd8de373ec608db01c0c1afc2727201e'),('inventory_adjustments.php','inv',0,1,1,'inventory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_ADJUSTMENTS','571ccba7dc09113a535b748c7f385767'),('inventory_breakdown.php','inv',0,1,1,'invbkdn','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_BREAKDOWN','1f2ee48303cf02d2622257e93131264a'),('inventory_costadjust.php','inv',0,1,1,'inventory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_COST_ADJUSTMENTS','35ba6f0713754d4b155e58bfb7cb635a'),('inventory_detail_pop.php','ar,inv',1,1,1,'','','05af0db2505079e82cb6766dacf91a69'),('inventory_pricecopy.php','inv',0,1,1,'invcopyprice','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_COPY_PRICING','99503d7450214b99aac70848476bdbb6'),('inventory_recalcFMLW.php','inv',0,1,1,'inventory','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_VERIFY_INVENTORY','3c509551a66d389c20f270775e08cf07'),('inventory_transfers.php','inv',0,1,1,'inventory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_TRANSFERS','9640a46e7c206b68e9e98fbe681ec3aa'),('invexportimport.php','inv',0,1,1,'ExportItems','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_EXPORT_IMPORT_EDIT_TOOL','50a4e7ab70a8e2461ad6e17c9784967f'),('invitemactivity.php','inv',1,1,1,'inventory',NULL,'97601ffca0b62dde9ea920627728704a'),('invitemadd.php','inv',0,1,1,'inventory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ADD_ITEMS','25eceeca44e16863de5e7a7fa246168e'),('invitemadd1.php','inv',0,1,1,'','','c9a0f029630d83556afde8470f143018'),('invitembarcodepdf.php','inv',1,1,1,'','','91f5141002ebebc7803e4d57af7773ed'),('invitembuildorder.php','inv',0,1,1,'inventory','STR_INVENTORY|STR_MANAGE_BUILD_ORDERS|STR_NEW_BUILD_ORDER','d8ca469f9dd525b9bd8939fb69f9e268'),('invitembuildorder_commit.php','ar,inv',0,1,1,'','','89820da0f8b065133162d840dee52dbc'),('invitembuildorder_fill.php','inv',0,1,1,'','','18149aa9864b380b6fb3b86bf425243a'),('invitembuildorderlist.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_LIST_BUILD_ORDERS','f62a1fe2840a392b00213089fcc4b39f'),('invitemcatadd.php','inv',0,0,1,'inventory','','dde4daa01c3c9b07069eb65531e80d65'),('invitemcatremove.php','inv',0,0,1,'inventory,catitemdel','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_DELETE_ITEMS','c22f93bc3e7b449e38d2be8e267a273e'),('invitemcatupd.php','inv',0,0,1,'inventory','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_ITEM_CATEGORIES','25774b175f63f6b73d25e92a1d8481f7'),('invitemgroupupd.php','inv',0,1,1,'','','7476876cda1286be6a19e81c34b7d2b8'),('invitemlstconversions.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_CONVERSIONS','58024ddeff56c5c01fc1c8e5f988ce42'),('invitemlstcost.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_INCOMPLETE_ITEMS','7f00b0517a964cae18df83d7ca215c40'),('invitemlstdist.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_DISTRIBUTION','b73e45d626f6745d225e3c56b6a84f3d'),('invitemlsthistory.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_DETAIL_HISTORY','916e6685faa895422ba22a57bb9d074c'),('invitemlstprice.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_PRICES','d5608b109da5c0dc246d334ecad39c1d'),('invitemlststatus.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_STATUS','c8d271a6960b6346032a7cdf71a12495'),('invitemlstsum.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_SUMMARIES','956317e423986451849eba53f0a68b21'),('invitemlstusage.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_USAGE_HISTORY','12ccb11fd21415e9a4544159f914c09a'),('invitemlstval.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_INVENTORY_VALUATION','70cee657f1d215360a379b5f52ab7fb8'),('invitemlstvendor.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_VENDOR_LIST','ac180af5b3b13db87a9e9c6c219d3fd6'),('invitemlstvendorprice.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_VENDOR_PRICES','eaa6cc92e862a4fefe4d88de9b3e6ad8'),('invitemoption.php','inv',0,0,1,'','','a7adaa42eb5357a15b41f75e5b2caca2'),('invitemoptiongroup.php','inv',0,0,1,'inventory','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_ITEM_OPTION_GROUPS','217d29b334ba1161576c225baa64a1bb'),('invitemoptiongroupitem.php','inv',0,1,1,'','','bb81412e0b01843c64a110b7a5820bb4'),('invitempage_define.php','inv',0,0,1,'ItemControl','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_ITEM_PAGE_CUSTOMIZER','900db52904086e3048ff0f59163d7f44'),('invitemposted_beginbal.php','inv',0,0,1,'','','5974cd7ac459b911f3198c2e87b44041'),('invitempricelevels.php','inv',1,1,1,'edititemprices','STR_INVENTORY|STR_REPORTS|STR_ITEM_PRICE_LEVELS','15567e85d5774af32b7799e9caa85092'),('invitemprices.php','inv',0,1,1,'edititemprices','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_PRICES_MASS_EDIT','c40bf00dacc644ad917afe8943e68970'),('invitemrecadd.php','inv',0,1,1,'inventory','STR_PAYABLES|STR_PURCHASING|STR_RECEIVE_WITHOUT_PO','6cb3dac1755384b9d184b8465b51a8c0'),('invitemreclist.php','inv',1,1,1,'inventory','STR_PAYABLES|STR_REPORTS|STR_ITEMS_RECEIVED','4ed13dc90dd0328a83559364fb7e4623'),('invitemsearchcat.php','inv',0,0,1,'inventory','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_ITEM_CAT_SEARCH','83b14845a17bfc201018d164fc8476cf'),('invitemsearchcat_remote.php','inv',0,0,1,'','','f00f1757bb3b37b6290792b0b7f13ec3'),('invitemstatusvendor.php','inv',1,1,1,'inventory,itemvendorstatus','STR_INVENTORY|STR_REPORTS|STR_ITEM_VENDOR_STATUS','6245391797c313caefd7e5b1cb9268ef'),('invitemupd.php','inv',0,1,1,'inventory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_EDIT_ITEMS','f19d725fce868aca812bbe3b224d2e9d'),('invitemupd1.php','inv',0,1,1,'','','d3281e52edbdcb8d65094c814b99915e'),('invitemvendupd.php','inv',0,1,1,'inventory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_SUPPLIERS','a7bd6c758f5d2f578ef300230945459c'),('invleveladd.php','inv',0,0,1,'inventory','','8d93bc520e9fc2d56089c38cde0fab42'),('invlevelupd.php','inv',0,0,1,'inventory','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_PRICING_LEVELS','11dc49d2da729acf1c6bb7aee7f1db45'),('invmarkupadd.php','inv',0,0,1,'inventory','','29a900a734f1c9d2def1a6d3c316654d'),('mc2xreportofcollection.php','ar',1,1,1,'','','8a0399125c10ec0443c282dfe5b4aca5'),('invmarkupupd.php','inv',0,0,1,'inventory','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_INVENTORY|STR_STANDARD_MARKUP','d1ae4299e41cd77377089c2eb2c7f3ca'),('invnotifications.php','ap,inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_NOTIFICATION_REQUESTS','bc4d98bd71e9edfb34e20b5114b76a50'),('invordline_addedit.php','ar,inv,sc',1,2,1,'','','a112f88502bab5cd0a574c6de8315eb1'),('invpoadd.php','ap,inv',0,1,1,'inventory','STR_PAYABLES|STR_PURCHASING|STR_NEW_PURCHASE_ORDER','cbfa9f6621682ca2628ea0cd0362b258'),('mc2xcashcount.php','ar',0,1,1,'','','f052990e5710ba79e8c6c6a314419cdb'),('invpochecklistfpdf.php','ap,inv',1,1,1,'','','e17259d6c7fd96275d1a9c79e9ad34e7'),('invpolist.php','ap,inv',1,1,1,'inventory','STR_PAYABLES|STR_REPORTS|STR_PO_LISTS','94d34d548d24e99ff423be9e36d1894f'),('invpopricehistory.php','ap',0,1,1,'','','2b600c02c4f59885ded12c9b9c4605cc'),('invporecv.php','ap,inv',0,1,1,'inventory','STR_PAYABLES|STR_PURCHASING|STR_RECEIVE_ITEMS_ON_PO','5c82433d906f9f1b0e5160be458e9067'),('jobbudgetrpt.php','ap',1,2,1,'construction',NULL,'eb7e33e7ffe524f96a9752895688dc90'),('invporeturn.php','ap',0,1,1,'','STR_PAYABLES|STR_PURCHASING|STR_RETURN_RECEIVED_PO','88a47cf0c2248ccea61c503f3d4a1b4f'),('invpotoap.php','ap,inv',0,1,1,'inventory','STR_PAYABLES|STR_PURCHASING|STR_COMPLETED_PO_TO_AP','6580086f67bf91d386725ed096639d46'),('invpotocc.php','ap,inv',0,1,1,'','','33694520060079e5bd3ba5ac6f29a632'),('invpoupd.php','ap,inv',0,1,1,'inventory','STR_PAYABLES|STR_PURCHASING|STR_EDIT_PURCHASE_ORDER','c4c28122ff9441f95fce912f0034c67b'),('invpoviewfpdf.php','ap,inv',1,1,1,'','','e88fdb83cd4371284406bef582cc0db0'),('invpricelistpdf.php','inv',1,1,1,'','STR_INVENTORY|STR_REPORTS|STR_ITEM_PRICE_LIST','fc0ab97993cdbfca5def51755437a870'),('invstatusdetail.php','inv',1,1,1,'','','a76f347124808b90bb3fa25723f031e3'),('invtransferrpt.php','inv',1,1,1,'','STR_INVENTORY|STR_REPORTS|STR_ITEM_TRANSFER_REPORT','3e8360bd7f431e2f38761f1e995f0b88'),('hgchristie_import2.php','gl',0,0,1,'','','e7cbe3a45f42ae874a75b7fbbb722ec3'),('labels2.php','ar,est,inv,sc,ap',1,1,1,'','','6b8c6097e5bb71920f6b412179edeab7'),('langexport.php','admin',0,0,0,'','','6a5a76f2907be829c727c906b6f36b0e'),('link_addupdate.php','gl',0,0,1,'','STR_ADMIN|STR_SETUP_ADMIN|STR_LINKS','90d41ef3401236a0369dee7ab330c035'),('list_db_explanation.php','admin',1,1,1,'','','aac12a0c38a0cbcadf3951a9948d6a49'),('lookuporder.php','ar,sc,inv',0,2,1,'','','bfaa0be65abcafaf8bca243f840007cf'),('managesub.php','admin',0,0,1,'','STR_ADMIN|STR_SETUP_ADMIN|STR_MANAGE_SUBSCRIPTION','36e8e69341880d84bdb6c766488a46fa'),('hgchristie_import1.php','gl',0,0,1,'','','71085974f6c2b3b0989567965c738773'),('mgmtfees.php','ar',1,1,1,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_BILL_MANAGEMENT_FEES','94036a8f663ad5b4fe8a50acad9211cb'),('mgmtfees_paid.php','ar',1,1,1,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_MANAGEMENT_FEES_PAID','01f508d49126e63f30f18e3b4e2802f0'),('hgchristie_import.php','gl',0,0,1,'','','28d4f4cd7a7254eb0de94a8e7f362cec'),('nporder.php','ar,sc,inv',0,2,1,'','STR_ORDERS|STR_ITEM_ORDERS|STR_NEW_EDIT_ORDER','188118c9892b66f8fc9a3fbf6f42b697'),('nporderitemfamily.php','ar,sc,inv',0,2,1,'','','815f529ab9b0e216ba9f9230a45d6bcb'),('nporderitemoptionsremote.php','ar,sc,inv',0,2,1,'','','c59327328f1720002792f180b3362fd1'),('nporderitemremote.php','ar,sc,inv',0,2,1,'','','9fa66350b3fa11f61deccd177e930d87'),('npordermiscremote.php','ar,sc,inv',0,2,1,'','','521c87401420a7c0b0f9f91fafe07deb'),('nporderpayment.php','ar,sc,inv',0,2,1,'','','402c78d7b667638354f95a6c9ee79ca2'),('nporderpricehistory.php','ar,sc,inv',0,2,1,'','','a162d8a0ebd27e8ac72fa8f376d8491e'),('npordersave.php','ar,sc,inv',0,2,1,'','','e83ae75bcc09d5cc4bb26a59835a64ca'),('obs_report.php','est',1,1,1,'','STR_PRICELIST|STR_REPORTS|STR_OBS_REPORT','f38f911fb7631e373001071422a76bd9'),('osadmin/approve_price.php','sc',1,1,1,'','','cab9b54dc6bffb954c0be1bfe6cfd5ea'),('osadmin/apvendupd.php','sc',1,1,1,'','','b21fe605d410f86c5fee31fcea4620f6'),('osadmin/backup.php','sc',0,0,1,'','','202fe784039fb19e99ea1670064349b3'),('osadmin/categories.php','sc',1,1,1,'','','38f5444f096689c843e6bf914703fc4a'),('osadmin/configuration.php','sc',0,0,1,'','','0c340e63762cac017789e1587c7f2db1'),('osadmin/countries.php','sc',1,1,1,'','','af4eb85754704c46a024bead062a60d2'),('osadmin/currencies.php','sc',1,1,1,'','','ab03032de4c92a94f354b5339f8aff4a'),('osadmin/customers.php','sc',1,1,1,'','','b14dada59e8f1bd806cfb020ba3baa05'),('osadmin/default.php','sc',1,1,1,'','','1f0b6767c84d742f46e6278eb81371e4'),('osadmin/discount.php','sc',1,1,1,'','','958deb1da58a731cbd6396f1f0cc6365'),('osadmin/invleveladd.php','sc',1,1,1,'','','73101126cd3f789d1b435e58fda2096b'),('osadmin/invlevelupd.php','sc',1,1,1,'','','c33d442344830baf4bb00e85ec727e11'),('osadmin/list_product.php','sc',1,1,1,'','','d2fb4b56a7c4b4d3e698630cbc23dc57'),('osadmin/manufacturers.php','sc',1,1,1,'','','50ea5e3a970479be4ebe1aa345baab1d'),('osadmin/modules.php','sc',0,0,1,'','','95a690c3df22526937aa7b83009114b9'),('osadmin/orders.php','sc',1,1,1,'','','0afe4c5b7042629a48c8882a4b21724b'),('osadmin/product_ordered_profit.php','sc',1,1,1,'','','40af5db18b6dffbea688e17c29230192'),('osadmin/products_attributes.php','sc',1,1,1,'','','6216cb4c47320020ddb16bd8cd10f60c'),('osadmin/products_expected.php','sc',1,1,1,'','','f5d91be34e79593bce771765a1e82308'),('osadmin/profit_customers.php','sc',1,1,1,'','','57ac7989b729dbeeae273fc41d026b48'),('osadmin/profit_products.php','sc',1,1,1,'','','45ea178a4fe925d3ea12cd31355b5ea7'),('osadmin/readbarcode.php','sc',1,1,1,'','','556bb985ef9bd9dea57e729251391039'),('osadmin/reviews.php','sc',1,1,1,'','','9d57bd0786aab6dd80c46d9eb9c42768'),('osadmin/shipping_modules.php','sc',0,0,1,'','','424f0005d2abfabd76334caf00010d30'),('osadmin/specials.php','sc',1,1,1,'','','aaf8254e6963bab7c49cd88815021cd7'),('osadmin/stats_customers.php','sc',1,1,1,'','','0f37b50298879ff917655c2352114098'),('osadmin/stats_products_purchased.php','sc',1,1,1,'','','3e3e8540a9ab6b02016e624497cf78f7'),('osadmin/stats_products_viewed.php','sc',1,1,1,'','','36054048dded8bfa54d5549089e47ac3'),('osadmin/update_price.php','sc',1,1,1,'','','e690365730ebbb506f63350af8c70076'),('osadmin/update_price_cat.php','sc',1,1,1,'','','1ef510bb87a66bceb8c4e22e282f6de4'),('osadmin/zones.php','sc',1,1,1,'','','93dface0dcd5fb82e76006676cff4643'),('over_estimate_orders_list.php','ar,inv,sc',1,1,1,'inventory','STR_ORDERS|STR_REPORTS|STR_ORDERS_OVER_ESTIMATE','c9f68d24534b1c149693205069a7be39'),('piecework_actions_selections.php','pay',0,0,1,'piecework','','fc84bc9e69eb0511f46b52674f0c9603'),('piecework_actionsadd.php','pay',0,0,1,'piecework','','19b98cb22f5e334576ac4d0e7fc8a74c'),('piecework_actionsupd.php','pay',0,0,1,'piecework','','2881d071c0f6e6e5e2ad14ebd9b965c7'),('piecework_addlrates.php','pay',0,0,1,'piecework','','138986f6283f993de42520fb728cc3b6'),('piecework_areasadd.php','pay',0,0,1,'piecework','','620dcfa4420e1181227335a2b0ecce45'),('piecework_areasupd.php','pay',0,0,1,'piecework','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_TIMECLOCK_PIECEWORK','776f0c30e90b60572be2f8c4a64b32cd'),('piecework_functionsadd.php','pay',0,0,1,'piecework','','be3cf65067f53e8200c75914200bbee0'),('piecework_functionsupd.php','pay',0,0,1,'piecework','','d0d4a6cc57bab1be7cabb75922b5f19c'),('pmagents.php','admin',0,0,0,'pm,pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_AGENTS','c6c8d8aa14c7978c9dfbf41d543bf2e0'),('pmareaadd.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_AREA_ADD_UPDATE','792aef8ba2b5af7addaf7c0179b8ef01'),('pmassuresignsetup.php','admin',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_ASSURESIGN_SETUP','6437c5f74d0356375a991eed9801287e'),('exportepinvoices.php','ar',0,1,1,'','','968dfbdd0135bc0ad97ad96ecbff3486'),('pmbuildingadd.php','admin,pm',0,1,1,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_PROPERTY_ADD_UPDATE','2ffecc5a1563cf1776593addf3fe2c81'),('exportepasn.php','ar',0,1,1,'','','8b8642f540b8426869e6be42d71d79a5'),('pmbuildingtypeadd.php','admin',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_PROPERTY_TYPE_ADD_UPDATE','4d6fef19ae4f175071531440fa6f7b8f'),('estquoteprintexport_ow.php','est',1,1,1,'','','51cf74b200ae647ad27754076fae44e4'),('pmcommissions.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_COMMISSIONS','d8c5fe7c72e01e4de90dad6012296d9f'),('pmcourtfilingsreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_COURT_FILINGS','ed34ff141a27c5a3f21cd23187b9c191'),('pmequipmentadd.php','admin',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_EQUIPMENT_ADD_UPDATE','4fcc0c350b181ede17fee52099e55c0b'),('pmequipmentinventoryreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_EQUIPMENT_INVENTORY','b5b00590358dcb2d8f77968d414fd9eb'),('pmequipmentsignout.php','admin,pm',0,0,0,'pm','','f43df64c8d9cd35ae9b6b387e6a41124'),('pmequipmentsignoutreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_EQUIPMENT_SIGNED_OUT','6657bcf9f6c9fa2a0e4ec06ba125a3bb'),('pmguarantorinforeport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_GUARANTOR_INFO','50c8b48e30227a32766abb42c52a8ec2'),('pminvoicechargesreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_INVOICE_CHARGES_BREAKDOWN','7e23f528ff7dbc0b5c413f0eba3d861b'),('pmleaseexpirationsreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_LEASE_EXPIRATIONS','07004e02df39e7664afaac7f9dad53a4'),('pmleasingrecapreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_LEASING_RECAP','bba012125f3972458bf6c10dda38a7cb'),('pmmoveinsmoveoutsreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_PENDING_MOVE_INS_OUTS','d43800d45181e92376ddf0d4debbb02d'),('pmonsitesetup.php','admin',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_ONSITE_DOT_COM_SETUP','de111247925c06a8f68e6cf16138e081'),('pmpropertydetailsreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_PROPERY_DETAILS','925d86a9f1cebb355eeb55a034ec9837'),('!/processqueue/dataTable/','admin',0,0,1,'','','c61ae054dcfc3eb31e112e6dc3aace50'),('pmrealestatetaxadd.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_REAL_ESTATE_PROPERTY_TAX','e50abb62b40b4beda5cd83d2ed881d21'),('estquotejobticket_ow.php','est',1,1,1,'','','239aaced4eceea5ba13e8c82322b7268'),('pmrealestatetaxtypeadd.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_REAL_ESTATE_TAX_TYPES','904210b142c1b828b14a96c5ac2d7d76'),('pmrentrollreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_RENT_ROLL','d6990b9111645a1f9224a0c01365e8ae'),('pmrevenuerec.php','ar',0,0,1,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_REVENUE_RECOGNITION','e9af5d46f20b58da312da3374eebc743'),('pmsecuritydepositreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_CLEANING_DAMAGE_RELIEF_RECONCILIATIONS','e508d6d5cdddd832400c798573db0f9f'),('pmsignedleases.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_SIGNED_LEASES_MONTHLY','e30ad881cae39cf8b9dac44b745f9b3e'),('pmsignedleasesreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_SIGNED_LEASES','dec1a3ff3ee8ba17c067af9ab57754bd'),('pmstudentclassreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_STUDENT_CLASS','4385b660df5b89f70351a8b3572370a3'),('pmtenantdetailsreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_TENANT_DETAILS','254b1cf13ebc5aaae003409a08b0bb2f'),('pmtenantperformancereport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_TENANT_PERFORMANCE_SUMMARY','553760152cba0cb3322eb70389f121cc'),('pmterminatedleasesreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_RESCINDED_OR_TERMINATED_LEASES','3f1ccafae6540669a3500c6b3f3bc1b7'),('pmunitadd.php','admin,pm',0,1,1,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_UNIT_ADD_UPDATE','824d1d3b0f96c3e61651e449192c0b99'),('pmutilityinvoicingreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_UTILITY_AND_LATE_FEE_INVOICING','5c879b24726afff4afa1e05f85a8e698'),('pmworkorderadd.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_WORK_ORDERS|STR_WORK_ORDERS_ADD_UPDATE','21863f6ca11d3a53c21ed48b4b434735'),('pmworkordernotify.php','admin',0,1,1,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_WORK_ORDER_NOTIFICATIONS','3a1b71354f2f2b82c8d44769ab497f11'),('pmworkorderstatsreport.php','admin,pm',0,0,0,'pm','STR_PROPERTY_MANAGEMENT|STR_REPORTS|STR_WORK_ORDER_STATS','4849025b80b43f67aab777d395230db5'),('pmworktypeadd.php','admin,pm',0,1,1,'pm','STR_PROPERTY_MANAGEMENT|STR_SETUP|STR_WORK_TYPE_ADD_UPDATE','fd7e5e1d749b789f337645c6dba5f637'),('pr941.php','pay',1,1,1,'payroll','STR_PAYROLL|STR_REPORTS|STR_941S','daa153cb9eca4ae00f2a2fd1ee607fdd'),('pr941file.php','pay',0,1,1,'','','eb50d19bb72c9c1eaa8840d3dbd2fc14'),('estquoteaddform_ow.php','est',1,1,1,'','','f174d4739ac4e34763fcdf78732f95ea'),('pr941printaid.php','pay',1,1,1,'','','d579fa65b48a1519d09e0dbf9692da26'),('pr941printdetail.php','pay',1,1,1,'','','48673a37ae11cf6fdae4ba7cc7817df3'),('prcalchours.php','pay',0,1,1,'payroll','STR_PAYROLL|STR_CALCULATE_AND_CHECKS','8fe01dc1cf35f44251295e5258ffb169'),('prchecks.php','pay',1,1,1,'','','758a9506a6e53d8f53357567fa8d3440'),('prchecksum.php','pay',1,1,1,'payroll','STR_PAYROLL|STR_CALCULATE_AND_CHECKS|STR_CHECK_SUMMARY','499bc6786004069981afd3b2f8b027e8'),('prchecksumfuisui.php','pay',1,1,1,'fuisui,payroll','STR_PAYROLL|STR_REPORTS|STR_FUTA_REPORT','319d3ef44b6d682643745b8316fd26a8'),('prchecksumgroup.php','pay',1,1,1,'payroll','STR_PAYROLL|STR_REPORTS|STR_PAY_HISTORY','a55407ee35ac9c2bca1ec9741648ab2c'),('prchecksumsui.php','pay',1,1,1,'fuisui,payroll','STR_PAYROLL|STR_REPORTS|STR_SUTA_REPORT','98a9d855486e01d07a4e20919257e6a2'),('prcheckvoid.php','pay',0,0,1,'','','c1ebcb959bdd2ab78e4c21dad42a6b9a'),('prcheckwrite.php','pay',0,1,1,'payroll','STR_PAYROLL|STR_CALCULATE_AND_CHECKS|STR_WRITE_CHECKS','aab65e9af1887ee35c456ae00f88d720'),('prcost_centeradd.php','pay',0,0,1,'payroll','','e6efbec9d148ae33ffbd6365fa750f84'),('prcost_centerupd.php','pay',0,0,1,'payroll','STR_PAYROLL|STR_REPORTS|STR_COST_CENTERS','bf844b73102f3413765a5400e1ee588a'),('prddemail.php','pay',1,1,1,'','','a1443620a19d4440ba2a70cc9207117c'),('prddvoid.php','pay',0,0,1,'','','4a48279f889039572c3a6294063ddc43'),('prdepcheckwrite.php','pay',0,1,1,'','','332a512dc04bab172c4bbae837f8b9a8'),('premplded.php','pay',0,1,1,'payroll','STR_PAYROLL|STR_EMPLOYEE_DEDUCTIONS','caf218098e9b9003ec52d8e3818a5732'),('prempllist.php','pay',1,1,1,'payroll','STR_CONTACTS|STR_REPORTS|STR_NAME_ADDRESS_PHONE_LIST','3973bc8edb9ea3f02886202c8c03b0fc'),('premployeeadd.php','pay',0,1,1,'payroll','STR_CONTACTS|STR_EMPLOYEES|STR_NEW_EMPLOYEE','718d5fc8faac16d489e7c78f1dcd155f'),('premployeeupd.php','pay',0,1,1,'payroll','STR_CONTACTS|STR_EMPLOYEES','a9ec8db234fa00433452c77ad84c0442'),('premplreviewadd.php','pay',0,1,1,'payroll','','52570d558f8a321b25e9cf4f5cbb0ce7'),('premplreviewupd.php','pay',0,1,1,'payroll','STR_PAYROLL|STR_WRITE_EMPLOYEE_REVIEW','1d33cfce7315e64fd79b858329c156d9'),('premplsum.php','pay',1,1,1,'tabularLogHours','STR_CONTACTS|STR_REPORTS|STR_EMPLOYEE_PAY_SUMMARY','01dc293c8f0afb4902615d8047e34ba2'),('premplweekupd.php','pay',0,1,1,'payroll','STR_PAYROLL|STR_CALCULATE_AND_CHECKS|STR_EMPLOYEE_CHECK_EDIT','84a652a15817a1055707f4b7c2b09c38'),('printorder2invoice.php','est,ar',0,1,1,'Printshop_std','STR_PRINTSHOP|STR_PROCESSING|STR_ORDERS_INVOICES','f6867f0cd369fc4dd1f21ea3aa185fcb'),('printorder_picker.php','est',1,1,1,'','','a17914b1d109cd09554f77a593c4be60'),('prloghours.php','pay',0,1,1,'payroll','STR_PAYROLL|STR_CALCULATE_AND_CHECKS|STR_LOG_HOURS','e0e5e1a0377642f8170048cb9790acb8'),('prloghours_table.php','pay',0,1,1,'tabularLogHours','STR_PAYROLL|STR_CALCULATE_AND_CHECKS|STR_LOG_HOURS_SIMPLE','af0e7f3982365f0c75581623562392bc'),('prpaychange.php','pay',1,1,1,'','','14423eab55acdc51010f15f68ff03900'),('prt_addtime.php','est',1,1,1,'','STR_PRINTSHOP|STR_PROCESSING|STR_TIME_AND_MATERIAL','46ea1fdfad2a79f4d2cbed2c2e3319df'),('prt_cutout.php','est',0,1,1,'','','b46fd49566b43aae7e2cda20c59efde2'),('prt_lists_unconfirmed.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER|STR_CONFIRM_PRT','51a8550c23d49c7f611066ffb04fa8e3'),('prt_orientation.php','est',0,0,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_PRINT_ORIENTATION_TYPE','64bf0ec908d6e7e69efcee2d7051e1b5'),('prt_orientation_add.php','est',0,0,1,'','','ce1f36d3ee7c552b51543a6121cfc460'),('prt_stockpurpose.php','est',0,0,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_PRINT_STOCK_PURPOSE','07505fb6d3442eb8632bcb3b8b21483c'),('prtactual_detail.php','est',1,1,1,'','','b45869cf968c34e9f9db1e2a7dd6edd4'),('prtactual_work.php','est',1,1,1,'','','8a8595781464e4c187a74190718754c9'),('prtboxlabel.php','est',1,1,1,'','','45cf09eb26ba6418552777242f66f77e'),('prtchange_order_price.php','est',1,1,1,'','','2029b3635ef74a54085d92bee05bcba2'),('prtclosedorder.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_LIST_PRINT_ORDERS|STR_CLOSED_ORDERS','d6b861db863271353c979a4b65b6cd12'),('prtdefault_responses.php','est',0,0,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_PRINT_DEFAULT_RESPONSES','99337d65536bcda56760d3641d237966'),('prtfamily.php','est',0,0,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_PRINT_MACHINE_FAMILIES','b5963a98e8ef7e6fb41dd9a8cf7f1f35'),('prtfamily_calculations.php','est',0,0,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_PRINT_FAMILY_CALCULATIONS','b643edcce2fa7127abb56f368e5bafad'),('prtfamily_order.php','est',0,0,1,'','','26cc820bb208215e2e1e43fd63c62f46'),('prtformulas.php','est',0,0,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_PRINT_FORMULAS','2428bce6034816ddcac5715838055c0a'),('prtjobcopy.php','est',1,1,1,'','','0d42325ff4e1d864585a1c50b787339e'),('prtlate_reason.php','est',0,0,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_PRINT_LATE_DELIVERY_REASONS','4bcb5743899ff3318a672780fdab1771'),('prtlate_reason_add.php','est',0,0,1,'','','eb5f63253cc27f121c7f828f6583df05'),('prtlateorder.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_LIST_PRINT_ORDERS|STR_OVERDUE_ORDERS','5023785516eede44398c1e5c2f102455'),('prtmachines.php','est',0,0,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_PRINT_MACHINES','f13988a26ef98402bb10864d5e5fee15'),('prtonholdorder.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_LIST_PRINT_ORDERS|STR_ONHOLD_ORDERS','fe46a6a76a74b260cc060b5175592cb7'),('prtopenorder.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_LIST_PRINT_ORDERS|STR_PENDING_ORDERS','babda581fb669a6472ac0e460ce197ec'),('prtopenorder_close.php','est',0,1,1,'Printshop_std','STR_PRINTSHOP|STR_SCHEDULING|STR_COMPLETE_JOBS','32d2cff34aed510c010270eec2b356a9'),('prtordersearch.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER|STR_SEARCH_PRINT_ORDERS','8fe28588c96d8574e523fce0be7d66a6'),('prtpackingslip.php','est',1,1,1,'','','32a0fa998b95f8c46e15bfd2cd02102e'),('estquote2invoice_ow.php','est,ar',0,1,1,'','','b509b6f28c0bfed22350b4e280a0f76b'),('prtscheduled_shipments.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_LIST_PRINT_ORDERS|STR_SHIPMENTS_DUE','0fd42f5bf93976d56ca2754b1b9c432d'),('prtshippedorder.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_LIST_PRINT_ORDERS|STR_SHIPPED_ORDERS','588f7134eadab5662067ca2c01023b99'),('prtshipping.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_PROCESSING|STR_NEW_SHIPMENT','5f1418af35e1283cd1772e4b9b525914'),('prtstock_purpose_add.php','est',0,0,1,'','','cf6809e14324f518e8baa2cad7881e14'),('prtworktypes.php','est',0,0,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER_SETUP|STR_PRINT_STANDARD_WORKTYPES','7a3ac1b63be099d54145c54016ee331b'),('prw2.php','pay',1,1,1,'payroll','STR_PAYROLL|STR_REPORTS|STR_W2S','a143f76ad79f2888141e5b363fb34066'),('prw2file.php','pay',0,1,1,'','','9611df6da9965242eab2f2d741e9e7a7'),('prw2printfpdf.php','pay',1,1,1,'','','b328f93a0e81eb652667d3bb42696fa8'),('prworkmanscomp.php','pay',1,1,1,'payroll','STR_PAYROLL|STR_REPORTS|STR_WORKMANS_COMP','2a54bb2a9117723d36b1a86b041c7db7'),('qbexportfile.php','admin',0,0,1,'','','bb353e643e745b583355126be3b9f259'),('qbexportstatus.php','admin',0,0,1,'qbimport','STR_TOOLS|STR_EXPORTS|STR_EXPORT_DATA_FROM_QUICKBOOKS','49a3c4c3a27fea9f033721ac0a8367f9'),('qbimport.php','admin',0,0,0,'qbimport','STR_TOOLS|STR_IMPORTS|STR_IMPORT_QUICKBOOKS_FILES','4e94244183fc252a99afd4ee1a4e08e1'),('recent_customers.php','ar',1,1,1,'','STR_CONTACTS|STR_REPORTS|STR_RECENT_CUSTOMERS','a70786c895a6c613719b22ab65059fc2'),('reprint_order_ticket.php','est',1,1,1,'Printshop_std','STR_PRINTSHOP|STR_PRINT_ORDER|STR_REPRINT_TICKET','263049811def3ee000e98d67b9aa99a2'),('invitemupd1.minmaxallowed.php','inv',0,1,1,'inventory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_CAN_EDIT_MIN_MAX_WHEN_NOT_ALLOWED_TO_EDIT_ITEM','33246275cc0f34ffe98d05a71efe2245'),('salesactionlst.php','ar',1,1,1,'','','4bf08d19d85c66a27097bb699a092036'),('salesprocess_addupdate.php','ar',0,1,1,'','','24cf48868ce6018d5a26e113b0a0e4b9'),('salesstatlst.php','ar',1,1,1,'','','67b1454d5bd7c263915e8ba5a00cb17d'),('salestracker_addupdate.php','ar',0,1,1,'','','7a99c8331d261260853e84049f4e4280'),('serviceorder_prepaid_time.php','ar,inv,sc',1,2,1,'','','4b51f0c35c04a7bcc68ea38a2383941b'),('serviceorder_time.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_SERVICE_ORDERS|STR_LOG_TIME','6ef028515c61604d9ba07875cc1ee7ce'),('serviceorder_time_editor.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_SERVICE_ORDERS|STR_EDIT_INTERNAL_WORK','d0b12dbeff29f765e8c16ead793e0610'),('serviceorder_time_reporter.php','ar,inv,sc',1,2,1,'inventory','STR_ORDERS|STR_REPORTS|STR_TIME_REPORT','cb7db34ebc69681d8ed94ef9f975b790'),('serviceorder_time_view.php','ar,inv,sc',1,2,1,'','','4c3a3307cf725c6c09dd84b1f2cf13a3'),('stagechangeorders.php','ar',0,2,1,'processstages','STR_ORDERS|STR_ITEM_ORDERS|STR_PROCESS_STAGES','6290aa903477f32ca058d22600c22dca'),('state_addupdate.php','gl',0,0,1,'','STR_ADMIN|STR_SETUP_ADMIN|STR_NEW_EDIT_STATE','cf8c5f8bb832c1ee52ba9db602971f7e'),('std_acts_popup.php','gl',0,0,1,'','','ec601980fa0c6adb6c3e2185903ed394'),('task.php','ar,ap',0,1,1,'','STR_ADMIN|STR_SETUP_ADMIN|STR_TASKS','52b20a52868e50aefd8ea05ed98d7bab'),('taskaction.php','ar,ap',0,0,1,'','STR_ADMIN|STR_SETUP_ADMIN|STR_TASK_ACTIONS','254e693e5c081f68700b40647ccab6a8'),('taskfetcher.php','ar,ap',0,1,1,'','','13727c7f774e3583d792ac9aba0e16c7'),('taskstatus.php','ar,ap',0,0,1,'','STR_ADMIN|STR_SETUP_ADMIN|STR_TASK_STATUSES','20f228bd7b80eceff23c4f5d8f5c49c0'),('taskuser.php','ar,ap',0,1,1,'','STR_CONTACTS|STR_TASKS','190250f57777f9a473c5a86f711efc0c'),('tcaapbilllist.php','ap',1,1,1,'','','0fa97d48875ca2e1aa1c401583e5ee22'),('tcaarinvoicesum.php','ar',1,1,1,'','','fe7e6302ce8f6128b592f8036a829b07'),('tcadocrequestreport.php','ar,gl,ap',1,1,1,'tcadocrequest','STR_BILLING|STR_REPORTS|STR_DOCTOR_REQUEST_REPORT','03ea923073a2e3363495dd73defff065'),('tcapayrpt.php','ar,gl,ap',1,1,1,'tcadocrequest','STR_BILLING|STR_REPORTS|STR_TCA_INVOICE_REPORT','9091dc983fc8e2e8d68a119b990d6b84'),('!/itemcategory/import/','inv',0,1,1,'inventory','STR_TOOLS|STR_IMPORTS|STR_IMPORT_INVENTORY_CATEGORIES','207c44db7d18bacd3be4e0745470aea7'),('timeclock_editwork.php','pay',0,1,1,'payroll,timeclock','STR_PAYROLL|STR_TIMECLOCK|STR_APPROVE_TIMES','9851091218f74121223ce3537b5ae4d5'),('invitemupd.readonly.php','inv',1,1,1,'inventory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_VIEW_ITEM','bce7cc2cb649cfb18a5c883b80c6a7bd'),('timeclock_jobtime.php','est',1,1,1,'timeclock','','06398487445825c4b2e4b04a82c2c3de'),('timeclock_othertime.php','pay',0,0,1,'timeclock','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_OTHER_TIME','7631dc5c1b88c66377b35f2807e26821'),('timeclock_othertimeadd.php','pay',0,0,1,'timeclock','','99f38ba7d01e9d4ff643290d8e748d17'),('timeclock_piecework_conflict.php','pay',0,1,1,'timeclock','STR_PAYROLL|STR_REPORTS|STR_PIECEWORK_CONFLICTS','b17e2513da73205d24f1086d7522cdb8'),('timeclock_viewstatus.php','pay',0,1,1,'timeclock','STR_PAYROLL|STR_REPORTS|STR_STATUS_OF_EMPLOYEES','b798f6c74b3b89ea156ba0c3fcbbccf1'),('timeclock_viewwork.php','pay',0,1,1,'timeclock','STR_PAYROLL|STR_REPORTS|STR_TIME_SUMMARY','29e12a5c55e0c834d67d0354cfbe1eba'),('topdollar_customers.php','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_CUSTOMERS_BY_SALES','26a0e3f6961985aa1c472e0ee4875e93'),('translation.php','admin',0,0,0,'','STR_TOOLS|STR_LANGUAGE_EDITOR','7ef25fc836ef4b8e7799bd51e73eb03d'),('importvendor.php','ap,inv',0,0,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_VENDORS','144b0ada793247873964273f14b0ad05'),('upgrade.php','admin',0,0,1,'','','e293ec7f5b879a9f622e368c8f5a60d3'),('usershippingrights.php','ar,gl,ap',0,0,1,'usershippingrights','STR_ADMIN|STR_SETUP_SERVICE|STR_USER_SHIPPING_RIGHTS','240a3e994147571a294146b5590fa450'),('view_duedate_history.php','est',1,1,1,'','','8e504bb1ffb52ef362b955e848ef7223'),('voucherdetail.php','gl',1,1,1,'','','12b68272e77676b7465c3aec8df7eea8'),('nporderremote.php','ar,sc,inv',0,2,1,NULL,NULL,'daac903362ea1bf2b15a0f0888bf70da'),('index.php',NULL,0,0,0,NULL,NULL,'53866ee8f4b40bc3d3fa7bfeef0108b2'),('invpoauto.php','ar,ap',0,1,1,'autofopo',NULL,'5bcdfa99ebb85dfdf667c9d4c42b7d94'),('!/arorder/dataTable/','ar',1,0,0,'inventory','STR_ORDERS|STR_REPORTS|STR_ORDERS_TABLE','b538cc7f1049516e58015d775e8b74b8'),('!/arinvoice/dataTable/','ar',1,0,0,NULL,'STR_CONTACTS|STR_CUSTOMERS|STR_INVOICES_TABLE','7d4f57891d6212c1f1bd5c83595b47c1'),('!/arinvoicepaymentdetail/dataTable/','ar',1,0,0,NULL,'STR_REPORTS|STR_BILLING|STR_PAYMENTS_TABLE','fa9401bb96da535bfd7552cc4c4b3b3e'),('!/payment_plan/dataTable/','ar',1,0,0,NULL,'STR_BILLING|STR_PAYMENT_PLANS|STR_PAYMENT_PLANS_TABLE','06c4e6c9fd07a70345a46ddb3538e70f'),('!/bank_deposit/dataTable/','ap',1,0,0,NULL,'STR_BILLING|STR_BANK_DEPOSITS|STR_BANK_DEPOSITS_TABLE','c670c26c63326557cde59eb99e78a377'),('!/customer/dataTable/','ar',1,0,0,NULL,'STR_CONTACTS|STR_CUSTOMERS|STR_CUSTOMER_TABLE','23d5bd5b75ce366793da48a0cdb4845a'),('!/salesman/dataTable/','ar',1,0,0,NULL,'STR_CONTACTS|STR_SALES_PERSONNEL|STR_SALES_PERSONNEL_TABLE','112870afe1b3b3d80e435a5ea4e080f7'),('!/vendor/dataTable/','ap',1,0,0,NULL,'STR_CONTACTS|STR_VENDORS|STR_VENDOR_TABLE','d591cbfb6b010f065d04470314c7555d'),('!/check/dataTable/','ap',1,0,0,NULL,'STR_PAYABLES|STR_CHECKS|STR_CHECKS_TABLE','90d7192a9efcfed0875eae3c01879678'),('!/invpo/dataTable/','inv,ap',1,0,0,'inventory','STR_PAYABLES|STR_PURCHASING|STR_PURCHASE_ORDERS_TABLE','31009772a0520bbf1bf6b07ed149da28'),('!/apbill/dataTable/','ap',1,0,0,NULL,'STR_PAYABLES|STR_VENDOR_BILLS|STR_VENDOR_BILLS_TABLE','15951db6838eeab9e9f42b380d5e6d7b'),('!/ccpurchase/dataTable/','ap',1,0,0,NULL,'STR_PAYABLES|STR_CREDITCARD_BILLS|STR_CREDIT_CARD_PURCHASES_TABLE','8e0759d081c4cbd772fee680cb606edd'),('!/employee/dataTable/','pr',1,0,0,'payroll','STR_CONTACTS|STR_EMPLOYEES|STR_EMPLOYEE_TABLE','ed91b54d196e83a894e82ee75aa9bece'),('!/timeclock/dataTable/','pr',1,0,0,'payroll','STR_PAYROLL|STR_TIMECLOCK|STR_TIMECLOCK_TABLE','37863ec9e87cce31f1a1f7af256cc993'),('!/item/dataTable/','inv',1,0,0,'inventory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEMS_TABLE','896fd26da432c11eb303b204dd6b4e1c'),('!/gltransvoucher/dataTable/','gl',1,0,0,NULL,'STR_LEDGER|STR_RECURRING_LEDGER_ENTRIES|STR_JOURNAL_ENTRIES_TABLE','fe60d4e528a784329045708fd1a5e076'),('!/glaccount/dataTable/','gl',1,0,0,NULL,'STR_LEDGER|STR_CHART_OF_ACCOUNTS|STR_ACCOUNTS_TABLE','fcbaacb91404f796fb68a17c5260e2d1'),('!/glbudgets/dataTable/','gl',1,0,0,NULL,'STR_LEDGER|STR_BUDGETS|STR_BUDGETS_TABLE','91e0ebf45261daaf718552a2a5d825e2'),('adminmessages.php','admin',1,1,0,NULL,NULL,'7240eb71b7e779aa91ac88163f31bb94'),('!/apbill/dataTableCCBills/','ap',1,0,0,NULL,NULL,'83b4067eda8db9f659717dc70211ba21'),('admingraphic.php','admin',1,1,1,NULL,NULL,'e323930a2d21c5ec3520f274c7183856'),('admingraphic_category.php','admin',1,1,1,NULL,NULL,'dcf73cc54d948dcdfb10f6985aff4ecf'),('adminhpgroups.php','admin',1,1,1,NULL,NULL,'044865ed7cffdd06b2b27ed93c7aafdb'),('!/customer/dataList/','ar',1,0,0,NULL,NULL,'570ea455d11b01ecb8bea7672ed324b6'),('adminbatchrpt.php','ar,ap',1,0,0,'rpr',NULL,'371f44548c85cb1cf60522731b5c02ac'),('glverifysetup.php','gl,admin',1,1,1,NULL,NULL,'14f2be9909e37bd91e7c7b895332d557'),('import_distributor_sales.php','ap',1,1,1,'commissions',NULL,'2a03ad517dec287678ad1ce8e41e13d0'),('prepd7a.php','pr',1,0,0,'payroll',NULL,'a24b1fc91e443a1dfcf506199b86aeec'),('wizard_start.php','admin',1,1,1,NULL,NULL,'36af8c8f77cbad51744e5a874c1e64f1'),('invitemcosts.php','inv',0,1,1,'inventory',NULL,'4911771929663cb19e2fffa12a135fee'),('!/item/mobile_manage_location/','inv',1,1,0,'inventory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_MOBILE_LOCATION_MANAGE','e60ffdc036c5893bb38272cf2110e5bb'),('department.php','pay',0,1,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_DEPARTMENTS','558ecc35b4341fadb90cbef9cfc6bc2e'),('prworkerscomp.php','pay',0,1,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_WORKERS_COMP_CODES','9a33f47630000deec1836c1f67251132'),('!/vendor/purchaseorders/','ap,inv',1,0,0,'inventory','STR_PAYABLES|STR_REPORTS|STR_POS_BY_VENDOR','34bfc9735497b4be5e3b7014d115fff2'),('!/invpo/datatableforvendor/','ap,inv',1,0,0,'inventory','STR_PAYABLES|STR_REPORTS|STR_POS_BY_VENDOR','d4f28f3c0f03e04be6d51f452bcd9033'),('!/contact/import/',NULL,1,1,1,NULL,'STR_TOOLS|STR_IMPORTS|STR_CONTACTS','77e6e4048d1465312cc548457086b2d0'),('!/mage/edit/',NULL,1,1,1,'mage','STR_TOOLS|STR_MAGENTO','a492b39b3a9cea33b30ddefc66f1ec9f'),('!/custom_queries/view/',NULL,1,0,0,'report_builder','STR_TOOLS|STR_REPORT_BUILDER|STR_VIEW','3a11b25de25932614ecab74659e837a7'),('!/timeclock/setup/','pr',1,1,1,'timeclock','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_TIMECLOCK_SETUP','b3a26c7c028dd967733be0e3fa82e22b'),('prrpt.php','pay',1,1,1,'payroll','STR_PAYROLL|STR_REPORTS|STR_PAYROLL_INFO','2997ec70b75ab3f6c3feb294f6048c7c'),('!/arorder_deposit/datatable/','ar',1,0,0,NULL,NULL,'c33fe7ce6719fab6d177319b610dc9f4'),('taxclass.php','ar',0,0,1,'taxclasses','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_TAX_CLASSES','fb9a23de74e7859aa7ab42c08e1e5b47'),('jobbudgetadd.php','ap,inv',0,1,1,'construction',NULL,'8a5db743901535abe1bdaf18a4dc2e2a'),('jobbudgetupd.php','ap,inv',0,1,1,'construction',NULL,'a7a0d4d12d084e726c5d5620a8a7246e'),('jobpocopy.php','ap,inv',0,1,1,'construction',NULL,'222156493e900afb45a411d3f1c5e556'),('jobvariancerpt.php','ap',1,2,1,'construction',NULL,'492fee48cd1f73831aa42dd2d3c168a4'),('jobvariancerptdetail.php','ap',1,2,1,'construction',NULL,'a3309baf8445d71385c081987034e167'),('jobadd.php','ar',0,1,1,'construction','STR_BILLING|STR_JOBS|STR_NEW_JOB','8f0007eb9f1943e352060acf2565b94c'),('site.php','ar,ap',0,1,1,'construction',NULL,'5da6e6c49c6d34ab65eccb2ad77cfffa'),('jobupd.php','ar,ap',0,1,1,'construction','STR_BILLING|STR_JOBS|STR_EDIT_JOB','d94610c7a155e98c9efc4968d19512f7'),('!/job/dataTable/','ar,ap',1,1,1,'construction',NULL,'262a815f154794855739695d5412226d'),('indexmain.php',NULL,0,0,0,NULL,NULL,'5aa6a21cb3677b995208638c5cdee335'),('!/customer/report_billed_items','ar,inv',1,0,0,NULL,NULL,'801196445d0e3b5c6672fa0999251c84'),('!/customer/report_billed_items/','ar',1,0,0,'inventory','STR_BILLING|STR_REPORTS|STR_BILLED_ITEMS','9162905544519d3538239472d94b3a22'),('!/item/report_item_billed_history/','inv',1,0,0,'inventory','STR_INVENTORY|STR_REPORTS|STR_ITEM_BILLED_HISTORY','516ff9333c0f3da60bd8a06ea1cfe59b'),('!/mobilepos/index/','ar',1,1,0,'mobile_pos','STR_ORDERS|STR_ITEM_ORDERS|STR_MOBILE_POS','54979f25aa320f18e6d58703acd61f3a'),('!/itemcategory/customer_group_discounts/','inv,ar',1,1,1,'inventory,disc_invcat_to_cxgroup','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_INVENTORY_CATEGORIES_DISCOUNTS','f8d589843bdeac52ed3480175e6cef38'),('!/premplweekpaydetail/dataTable/','pay',1,1,1,'payroll','STR_BILLING|STR_JOBS|STR_LABOR_COSTS','e16985100d22e9b7eb2238ee2d9bab5d'),('prempldedtype.php','pay',0,0,1,'payroll','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYROLL|STR_EMPLOYEE_DEDUCTION_TYPES','a199d8ff61e6cc732e0d4d0ed5916397'),('!/vendor/certificate/','ap',0,1,1,'vendor_certificates','STR_CONTACTS|STR_VENDORS|STR_VENDOR_CERTIFICATE','45450272b19f74d005b8344a53b3e75f'),('!/vendor/certificate_types/','ap',0,0,1,'vendor_certificates','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_VENDOR_CERTIFICATE_TYPES','de7cad8137c1fa9c3e7183d065113dcd'),('!/vendor/certificate_compliance/','ap',1,1,1,'vendor_certificates','STR_PAYABLES|STR_REPORTS|STR_VENDOR_CERTIFICATE_COMPLIANCE','1443cbb241e245217cfd963ebf57f3e0'),('!/vendor/ytd_payments/','ap',1,1,1,NULL,'STR_PAYABLES|STR_REPORTS|STR_YTD_VENDOR_PAYMENTS','e48fad269d359f272007f4d37b98dd9a'),('!/archive_reports/review/','admin',0,0,1,'monthly_archive','STR_TOOLS|STR_ARCHIVED_REPORTS','f117cb3b420d6a5d94ba4b9a46b9343c'),('!/customer/report_overdue_accounts/','ar',1,0,0,NULL,'STR_BILLING|STR_REPORTS|STR_ACCOUNTS_OVERDUE','dd9254d110ce283636ca6617a4399562'),('glexpense.php','gl,ap',0,1,1,'directexpensepayments','STR_PAYABLES|STR_CHECKS|STR_DIRECT_EXPENSE_PAYMENTS','49f55d1c9791dc177ae6c6a0becabd16'),('glexpensetype.php','gl,ap',0,0,1,'directexpensepayments','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_PAYABLES|STR_DIRECT_EXPENSE_TYPES','2a25f75c209e12132fbadc8e98f85ef1'),('gljournalpdf.php','gl',1,1,1,NULL,NULL,'d422b63218ed70af41e05562fba1ae68'),('!/customer/report_credit_limit/','ar',1,1,1,NULL,'STR_BILLING|STR_REPORTS|STR_CUSTOMER_CREDIT_LIMIT_REPORT','c4d4e140ba998750bf64b5889749b3e3'),('!/customer/report_credit_hold/','ar',1,1,1,'customerholds','STR_BILLING|STR_REPORTS|STR_CREDIT_HOLD_REPORT','d5a54d5617d4c5d3fd357c7accf67dd9'),('invpotoapai.php','ap',0,1,1,'aiproducts','STR_PAYABLES|STR_PURCHASING|STR_A_AND_I_COMPLETED_PO_TO_AP','4b194288bf7281230ea43864cf27514b'),('!/writeoffreason/edit/','ar',0,1,1,'writeoffs','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_WRITE_OFF_REASONS','fc2d1ee6ebdfdbdfd720abeb0edee546'),('!/chargebackcode/edit/','ar',0,1,1,'archargeback','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_CHARGE_BACK_CODES','e2e68ab76c93d26262df4dc1cf51f964'),('!/interestchargeoption/edit/','admin',0,1,1,NULL,'STR_CONTACTS|STR_CUSTOMERS|STR_INVOICE_INTEREST_RATE','a053fd0c89618d3efa66d8d2bc2159ee'),('!/customer/letters/','ar',1,1,1,'customerletters','STR_CONTACTS|STR_CUSTOMERS|STR_CUSTOMER_LETTERS','9fa876b78dea8f47297178b17fe4a23f'),('glincome.php','gl,ar',0,1,1,'directarpayments','STR_BILLING|STR_INVOICES|STR_DIRECT_AR_PAYMENTS','5dfaa264f5082bad0fc02b8e11127935'),('glincometype.php','gl,ar',0,0,1,'directarpayments','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_DIRECT_AR_PAYMENT_TYPES','df2467865e55e81fe908cae0b45785f5'),('!/jobtype/edit/','ar',0,1,1,'contractorsupply,construction','STR_BILLING|STR_JOBS|STR_JOB_TYPES','451154f2da8c09f9fcc704bdafddca55'),('importccpurchases.php','ap',0,1,1,'CCPurchases','STR_TOOLS|STR_IMPORTS|STR_IMPORT_CC_PURCHASES','a1e5fb3e324597dba322414b1e71c99d'),('importemployeeexpenses.php','ap',0,1,1,'importemployeeexpenses','STR_TOOLS|STR_IMPORTS|STR_IMPORT_EMPLOYEE_EXPENSES','a387443d35af6099a1026e21e7965c0f'),('importglbudgets.php','gl',0,1,1,'GLBudgets','STR_TOOLS|STR_IMPORTS|STR_IMPORT_GL_BUDGETS','4e15def3c3d1a4da99542e3a3e8aacbc'),('!/batchimport/log/','admin',0,1,1,'importlog','STR_TOOLS|STR_IMPORTS|STR_IMPORT_LOG','848c79e0fb7844473f76d9e9d8f75e7e'),('!/batchimport/settings/','admin',0,1,1,'importlog','STR_TOOLS|STR_IMPORTS|STR_IMPORT_LOG_SETTINGS','2104b6c44d22764e357f0ad2fc7c07a7'),('!/archive_reports/datatablear/','ar',1,1,1,'monthly_archive','STR_BILLING|STR_REPORTS|STR_ARCHIVE','9335b1b0c37e358488067e27d66dc693'),('!/archive_reports/datatableap/','ap',1,1,1,'monthly_archive','STR_PAYABLES|STR_REPORTS|STR_ARCHIVE','f1d01a0978ed9ee7dc8ce6d503a6125e'),('!/glaccount/report_balance_sheet_trial/','gl',1,1,1,'','STR_LEDGER|STR_REPORTS|STR_BALANCE_SHEET_TRIAL','8fdb7d1ae90e4947babd6cf22c4c6251'),('glcategory.php','gl',0,0,1,'glcategories','STR_ADMIN|STR_SETUP_FUNCTIONS_FOR_GL|STR_GL_CATEGORIES','9fd8f71d3496938382cd3ddca82c3426'),('!/archive_reports/datatablepr/','pr',1,1,1,'monthly_archive','STR_PAYROLL|STR_REPORTS|STR_ARCHIVE','6c2dddea63ccc5bdc52b8e0d5286b1b7'),('!/archive_reports/datatableinv/','inv',1,1,1,'monthly_archive','STR_INVENTORY|STR_REPORTS|STR_ARCHIVE','5f2182bb64ac326ec55dd25f5cd99381'),('!/archive_reports/datatablegl/','gl',1,1,1,'monthly_archive','STR_LEDGER|STR_REPORTS|STR_ARCHIVE','0d0f7f0d6d14a096803ec1f9b8343fdb'),('!/faxservices/log/','ar',1,1,1,'fax','STR_BILLING|STR_REPORTS|STR_FAXES','dcda2ed77a224d920f3892b1ae3873d7'),('!/arinvoicepaymentdetail/import/','ar',0,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_CUSTOMER_PAYMENTS','9ca21fc1fa5eabad14ae72dd4e6fe887'),('!/apbillpayment/import/','ap',0,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_VENDOR_PAYMENTS','ad5a267459ed6d70ad5a95b9a7d03b41'),('glclose_month.php','gl',0,0,1,NULL,'STR_LEDGER|STR_JOURNAL_ENTRIES|STR_CLOSE_MONTH','43311d388f29e9d805a71f99faca1c64'),('!/positivepay/review/','ap',1,1,1,'positive_pay','STR_TOOLS|STR_EXPORTS|STR_POSITIVE_PAY','d0d5c6c478a4895af1dd8bd65111c7cb'),('!/positivepay/send/','ap',0,1,1,'positive_pay','STR_TOOLS|STR_EXPORTS|STR_POSITIVE_PAY_SEND','f8e0a03639d6b069ae48cc9d91191a56'),('prtpendingorder.php','est',1,1,1,'Printshop_std,order_val','STR_PRINTSHOP|STR_LIST_PRINT_ORDERS|STR_VALUE_OF_PENDING_ORDERS','38a15f444e367e21b3422d0f46921336'),('!/job/import/','ar',1,1,1,'construction','STR_TOOLS|STR_IMPORTS|STR_IMPORT_JOBS','85e426880cba8b9a27a6688f99537920'),('!/job/batch_send_prelim_request/','ar',0,1,1,'construction','STR_BILLING|STR_JOBS|STR_SEND_PRELIM_REQUESTS','8404a1f8e2581416b4c6745ee84558e2'),('reportcachenavfetcher.php','ar,ap,inv,est,pay,gl',1,1,1,'','','0d666b0dcf8c16b1d59f412c7b8d0ffd'),('!/positivepay/send_commercialap/','ap',0,1,1,'positive_pay','STR_TOOLS|STR_EXPORTS|STR_COMMERCIAL_AP_SEND','1c34390bf47b55ce488a705f423a0f85'),('!/positivepay/review_commercialap/','ap',1,1,1,'positive_pay','STR_TOOLS|STR_EXPORTS|STR_COMMERCIAL_AP','022231a5ad3a95302e393582dfe48a08'),('!/arinvoice/import_customer_and_job_changes/','ar',0,1,1,'importinvoicechanges','STR_TOOLS|STR_IMPORTS|STR_IMPORT_INVOICE_CHANGES','2b471e05333491255bbaf397c20cd3cb'),('glrepjournal_funds.php','gl',1,1,1,'glfunds','STR_LEDGER|STR_REPORTS|STR_FUND_DETAILS','eb3b3aea25b780b86054f37e772a8547'),('glrepincome_fund_summary.php','gl',1,1,1,'glfunds','STR_LEDGER|STR_REPORTS|STR_FUND_SUMMARY','ccfaa9c4c158d26dfe21452ff0c98673'),('jobcostrpt.php','ar,ap',1,1,1,'construction',NULL,'0d2e5c01130690a30c8f818940bb895d'),('!/glaccount/report_balance_sheet_categorized/','gl',1,1,1,'glcostcodes,glcategories','STR_LEDGER|STR_REPORTS|STR_CATEGORIZED_BALANCE_SHEET','90c69f8953d322e41157f7e90df16b32'),('!/vendor/certificates_expiring/','ap',1,1,1,'vendor_certificates','STR_PAYABLES|STR_REPORTS|STR_VENDOR_CERTIFICATES_EXPIRING','ea0571d31e1c5c99cdc23bbde1588197'),('pm/manageprospects.php','ar',1,1,1,'pm','STR_REPORTS|STR_PROPERTY_MANAGEMENT|STR_MANAGEMENT_FEES_PAID','03415ba9b5287f75addd8e6ce417266d'),('pm/propertyavailability.php','ar',1,1,1,'pm','STR_REPORTS|STR_PROPERTY_MANAGEMENT|STR_UNIT_AVAILABILITY','2466c29ac048aa70bc2a541df09cd8f7'),('prtneworder.php','ar',0,1,1,'','STR_PRINTSHOP|STR_PRINT_ORDER|STR_NEW_PRINT_ORDER','5c91838d35f0f98684145adb8fac84ea'),('!/check/edit/','ap',0,1,1,'checkedit','STR_PAYABLES|STR_CHECKS|STR_EDIT','5b8fd46eb92b8bd43fa96cd4e2dd7ba8'),('!/invzone/index/','inv',0,1,1,'invzone','STR_ADMIN|STR_INVENTORY|STR_WAREHOUSE_ZONE','5a8f75c7596ce482a108fe3b9401433d'),('!/invbin/index/','inv',0,1,1,'invzone','STR_ADMIN|STR_INVENTORY|STR_WAREHOUSE_BINS','381d42b3afa56f5b861866e3e8baafdf'),('!/itempricespecial/index/','inv',0,1,1,'itempricesspecial','STR_ADMIN|STR_INVENTORY|STR_SPECIAL_SALES_PRICING','f601d0501bb7479e2c7074349a0bcdd9'),('!/salestax/import/','ar',0,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_SALES_TAX','10637d3e4ca2fa83e186c5b6d3ebcf72'),('!/invadjustmenttype/index/','inv',0,1,1,'','STR_ADMIN|STR_INVENTORY|STR_INVENTORY_ADJUSTMENT_REQUEST_TYPES','1a84dea136ca24a97b6f92aa0793761f'),('!/county/edit/','admin',0,1,1,'','STR_ADMIN|STR_SYSTEM|STR_ADD_EDIT_COUNTY','c48c282eb68156cc7e9aa8b13dbd1081'),('!/invcountbatch/edit/','inv',0,1,1,'invadjustmentrequests','STR_INVENTORY|STR_COUNT_MANAGEMENT|STR_NEW_EDIT','5ead61471be99a92f59806ef95b537ef'),('!/invcountbatch/datatable/','inv',1,1,1,'invadjustmentrequests','STR_INVENTORY|STR_COUNT_MANAGEMENT|STR_TABLE','ba07e468c06337b86836be4e48df7e31'),('!/invcountbatch/assigncounting/','inv',0,1,1,'invadjustmentrequests,inventory','STR_INVENTORY|STR_COUNT_MANAGEMENT|STR_ASSIGN_STOCK_CHECK_REQUEST','c5b34c5746a45e03e19ece60efcb2715'),('!/invcountbatch/entercounts/','inv',0,1,1,'inventory,invadjustmentrequests','STR_INVENTORY|STR_COUNT_MANAGEMENT|STR_ENTER_COUNTS','832406bcd94dbbdbfdca942d47fb7739'),('!/vendor/import/','ap,inv',0,0,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_VENDOR','96985b4e5ba4a9e7995b63b1a5df8506'),('!/vendor/import_orderfrom/','ap,inv',0,0,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_VENDOR_ORDER_FROMS','198751b20940964b0523c11d6ab25b96'),('!/stagingarea/edit/','inv',0,0,1,'dcreorder','STR_ADMIN|STR_INVENTORY|STR_STAGING_AREAS','a8c6277cddd993f74250a358b142d3f9'),('!/freightburden/edit/','inv',0,0,1,'dcreorder,invcotransfer','STR_ADMIN|STR_INVENTORY|STR_FREIGHT_BURDEN','ed9ec7b5914108cd0a03c98f754af46b'),('!/invcotransfer/replenish_transfers/','inv',0,1,1,'inventory,dcreorder,invcotransfer','STR_INVENTORY|STR_ITEMS|STR_REPLENISHMENT_TRANSFERS','19acc86d6e10f7b51432961c6619f0a3'),('!/customer/hipaa_import/','ar',0,1,1,'hipaa_import','STR_TOOLS|STR_IMPORTS|STR_CUSTOMER_HIPAA_IMPORT','2a5a0820e80bbcd2ebc44544c1dc8ad0'),('!/invcotransfer/pdf/','inv',1,1,1,'invcotransfer','STR_INVENTORY|STR_ITEMS|STR_INTERCOMPANY_ITEM_TRANSFER_PRINT','ed834186a2f010b99799ca5a6dd4f6e4'),('!/appointments/edit/','ar',0,1,1,'b2b_appointments','STR_ADMIN|STR_ORDERS|STR_APPOINTMENT_SCHEDULER','9ad59e5e9d8794472a6f2635748ef52a'),('!/invcotransfer/datatable/','inv',1,1,1,'invcotransfer','STR_INVENTORY|STR_TRANSFERS|STR_TABLE','785fcbe2b871f032506798a582c97d26'),('!/customer/patient_import/','ar',0,1,1,'patient_import','STR_TOOLS|STR_IMPORTS|STR_PATIENT_IMPORT','b5de5cfaf4f098914ee5c9ca8cd863a2'),('!/arorder/PDF/','ar',1,0,0,NULL,NULL,'bc40dbb345de73f8c38fe558015fb3af'),('!/arordership/dataTable/','ar',1,0,0,'inventory','STR_ORDERS|STR_REPORTS|STR_SHIPMENTS_TABLE','106089d0d14871281ee4000a1d473965'),('!/customer/index/','ar',1,0,0,NULL,NULL,'bda2e7a8bab6fc3330a2ad19ada9ae1c'),('!/custom_queries/edit/','admin',1,1,0,'report_builder',NULL,'9b91ca30ebb40afa1a0582fc6c15fc31'),('!/gencompany/Edit/','admin',1,1,0,NULL,NULL,'ef06daaac6c81623a54ca433919a8d32'),('!/gencompany/Select/','admin',1,0,0,NULL,NULL,'2d7786afcddbcd32054dfa9230cf06b9'),('!/gltransvoucher/dataTableRecurringEntries/','gl',1,0,0,NULL,NULL,'704effb271abd661c8fddab2b4320b13'),('!/item/ckeditor_info/','inv',1,0,0,'inventory',NULL,'0da38b99d059b61e4cd0ac15ac4c064c'),('!/item/copy/','inv',1,1,0,'inventory',NULL,'68acbb25ad4d3917d617958cb325c635'),('!/mage/Select/','ar',1,0,0,'mage',NULL,'83e5530a16020a8000bf7cc997b3f22e'),('!/mage/sync/','ar,inv,admin',1,1,0,'mage',NULL,'7af010cc18858e29bc97f2958baa97bf'),('!/task/delete/','ar',1,1,0,'task',NULL,'59ad018fe8997d16944e4b545588aec8'),('!/task/edit/','ar',1,1,0,'task',NULL,'3a968b7ed2b9073803d11ff6df91e01a'),('!/task/Select/','ar',1,0,0,'task',NULL,'6473d0f225d70a0b062f98cc92ac516d'),('!/taskaction/delete/','ar',1,1,0,'task',NULL,'e1a38bcf0e9a18a497d62c54c24c8d2a'),('!/taskaction/edit/','ar',1,1,0,'task',NULL,'bdda86efd65683af73ad7617a3d00d6c'),('!/taskaction/Select/','ar',1,0,0,'task',NULL,'0b97b2e078740df36f5bf0a2968d7d56'),('!/taskstatus/delete/','ar',1,1,0,'task',NULL,'f2d39b840fa0cb60aad0ab00e40fa965'),('!/taskstatus/edit/','ar',1,1,0,'task',NULL,'12b99d07ae9956b40d8d76ddd04816a5'),('!/taskstatus/Select/','ar',1,0,0,'task',NULL,'a27723cd26fd0dfe0efe2a1303fa9018'),('!/customer/import_shipto/','ap',0,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_CUSTOMER_SHIP_TOS','d81423f4c158869665c0a2ae06cd175f'),('!/salestax/conflictpopup/','ar',0,1,1,'','','f8bac16697962e3d66342a578d29364d'),('!/itemcategory/discounts/','inv',0,1,1,'','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_ITEM_CATEGORY_DISCOUNTS','35e701e75979627088f65d62f1b900ce'),('!/check/report_bill_payments/','ap',1,1,1,NULL,'STR_PAYABLES|STR_REPORTS|STR_PAYMENT_REPORT','1a3579a48b3fcf6b2a520a59ec4b3a6e'),('!/bankrec/datatable/','ap,gl',1,0,0,'','STR_LEDGER|STR_BANK_RECONCILIATIONS_TABLE','bec14f5eec7f214cd1f5aaaf1fb7d9f0'),('apbill_preapprove_report.php','ap',0,1,1,NULL,NULL,'76c041b82e0901f011fb52fdb4a9b0e0'),('!/invpo/proposal_management/','ar,inv',0,1,1,'purchase_proposal','STR_EXPENSES|STR_PURCHASE_ORDERS|STR_PO_PROPOSAL_MANAGEMENT','28aabd48468a666d311ea9d6c91ada60'),('!/appointments/ajax/','ar',1,1,1,'b2b_appointments','STR_ORDERS|STR_APPOINTMENT_SCHEDULER','4d926320224a0c7fa6fb2d7141ef3967'),('!/appointments/reportcustomerhistory/','ar',1,1,1,'b2b_appointments','','e7c27cbc34e930c679acbbc7ca28f664'),('!/shopify/admin/','admin',0,1,1,'shopify','STR_ADMIN|STR_SYSTEM|STR_SHOPIFY_SETUP','344e08a32169f75e5dc70d92b710caec'),('!/shopify/import/','ar',0,1,1,'shopify','','0bf5c3a11d938acfeae0736a3e431f8e'),('!/ccterminal/edit/','admin,ar',0,0,1,'paxterminal','STR_ADMIN|STR_BILLING|STR_CREDIT_CARD_TERMINALS','1be7626b3092e1e7beda8d5da8f86481'),('!/ccterminallog/dataTable/','admin',1,1,1,'paxterminal','STR_ADMIN|STR_BILLING|STR_CREDIT_CARD_TERMINALS_HISTORY','470dd461e66d84be888cf69d7d82c10a'),('!/maillog/dataTable/','admin',1,1,1,'maillog','STR_ADMIN|STR_SYSTEM|STR_MAIL_LOG','f3eceadb1dc3a6af4a6d6819d93e5666'),('!/maillog/review/','admin',1,1,1,'maillog','STR_ADMIN|STR_SYSTEM|STR_MAIL_LOG_OPEN','61aeb1424866bc348089d88823971303'),('!/arorder/cloneserviceorder/','ar',0,1,1,'cloneserviceorders','','f2a43899c7d1c03bd458abcdf2d08c14'),('!/ebay/admin/','admin',0,1,1,'ebay','STR_ADMIN|STR_SYSTEM|STR_EBAY_SETUP','dd995944205eb13ec3018b5e76fd6c0f'),('!/ebay/import/','ar',0,1,1,'ebay','','074f0d693b5009b1df6df8550380a1db'),('!/scanner/index/','admin,ap,ar,est,gl,inv,pay,pr,sc',1,1,1,'dynamicwebtwain','STR_TOOLS|STR_IMPORTS|STR_QR_DOCUMENT_SCANNER','9bd241d10c5acd0f1c855aec5351d8d9'),('!/ebay/import_ap/','ap',0,1,1,'ebay','','d33f9f8c44801ba8b2ee5a73e0e28a1d'),('!/rma_arorder/batch_create/','ar,inv,sc',0,1,1,'inventory','STR_INCOME|STR_ORDERS|STR_CREATE_MULTIPLE_RMAS','31faad37ac4d225a289c1140b89dd300'),('!/employee/certificate_types/','admin,pr',0,1,1,'payroll,vendor_certificates','STR_ADMIN|STR_EMPLOYEES|STR_EMPLOYEE_CERTIFICATE_TYPE','eb9202344d0e0c737c7e473db9da033d'),('!/arorder/import/','ar',0,1,1,'inventory','STR_TOOLS|STR_IMPORTS|STR_IMPORT_ORDERS','3f4a3f9118a29cf509be0867eba7d9ae'),('!/invpo/import/','ap,inv',0,1,1,'inventory','STR_TOOLS|STR_IMPORTS|STR_IMPORT_INVENTORY_PURCHASE_ORDERS','f9b02079ed16848f4bc7948eaf95bcc0'),('!/arorder/batchshipandinvoice/','inv',0,1,1,'inventory','STR_INCOME|STR_ORDERS|STR_SHIP_MULTIPLE_ORDERS','0b9d8c155d20d5f0de14b59f306d1c1e'),('!/task/import/','ap,ar',0,1,1,'task','STR_TOOLS|STR_IMPORTS|STR_IMPORT_CRM_TASKS','a3d44ac3c1fc404e0e9778e981750ca7'),('!/tasklog/import/','ap,ar',0,1,1,'task','STR_TOOLS|STR_IMPORTS|STR_IMPORT_CRM_TASK_ACTIVITY','dd1e1c31b2c5831af0371339f80a7474'),('!/customfields/report_membershiptracker/','ar',1,1,1,'membershiptracker','','e46c96a0457e43199a327468f9d679e0'),('!/customfields/report_referrals/','ar',1,1,1,'b2b_remoteregistration','','7484ccaad671a71f9dd808f617248c5b'),('!/filecategory/edit/','admin',0,1,1,'','STR_ADMIN|STR_SYSTEM|STR_FILE_CATEGORIES','efaec5c543f16b6371acd2a57b09b7f6'),('!/fileitem/import/','admin',0,1,1,'','STR_ADMIN|STR_TOOLS|STR_IMPORT_FILES','41ee4f248cfbbf22d3372f55547ba428'),('!/customer/export_balances/','ar',1,1,1,'','STR_TOOLS|STR_EXPORTS|STR_EXPORT_CUSTOMER_BALANCES','a41545f2c1e267736cdbb433b0545272'),('!/itemtransaction/import/','inv',0,1,1,'inventory','STR_TOOLS|STR_IMPORT|STR_IMPORT_ITEM_ACTIVITY','44caec5db027b9bf056bb799e9dd3664'),('!/itempricespecial/import/','ar',0,1,1,'itempricesspecial','STR_TOOLS|STR_IMPORT|STR_IMPORT_SPECIAL_SALES_PRICING','5920b0e25a4a3bf2d03a6bb221ad5f60'),('!/invzone/import/','inv',0,1,1,'invzone,inventory','STR_TOOLS|STR_IMPORT|STR_IMPORT_WAREHOUSE_ZONE','02af7f7c6ff509d8e19198d506384a33'),('!/invbin/import/','inv',0,1,1,'invzone,inventory','STR_TOOLS|STR_IMPORT|STR_IMPORT_WAREHOUSE_BIN','1cf85e63aa23c03f35e11c81ea8f132f'),('!/invbinitem/import/','inv',0,1,1,'invzone,inventory','STR_TOOLS|STR_IMPORT|STR_IMPORT_WAREHOUSE_BIN_ITEMS','faca5178ec7cb2a8187b6b6f9f427a0a'),('!/invcotransfer/import/','inv',0,1,1,'invcotransfer','STR_TOOLS|STR_IMPORT|STR_IMPORT_INVENTORY_TRANSFERS','11e428ad47b22cf6579d896301af1d4f'),('!/itemlocation/import/','inv',0,1,1,'invcsvcostedit,inventory','STR_TOOLS|STR_IMPORT|STR_IMPORT_ITEM_LOCATION_DETAILS','ef57b3889af1f6ba1fbbbbb2146e41ed'),('!/search_tree/import/','inv',0,1,1,'inventory','STR_TOOLS|STR_IMPORT|STR_IMPORT_ITEM_SEARCH_CATEGORIES','4f9e7e1e841224c0f95e1b41a4293b9c'),('!/item/import_motorstate/','inv',0,1,1,'motorstate,inventory','STR_TOOLS|STR_IMPORTS|STR_IMPORT_MOTORSTATE_ITEM_CHANGES','c287021e676ddeafee256362e4e7ec76'),('!/billtrust/export/','ar',1,1,1,'','STR_TOOLS|STR_EXPORTS|STR_BILLTRUST','481cd3ac9358b1b69ebc0aa8386a36f2'),('!/producttypetax/edit/','ar',0,1,1,'inventory','STR_ADMIN|STR_BILLING|STR_PRODUCT_TYPE_TAXES','4d9df82bd059d670e21e893a4f817be7'),('!/vendor/inactive/','ap',0,1,1,'','STR_PAYABLES|STR_REPORTS|STR_INACTIVE_VENDORS','be77c9510cffa911686dd2854c980468'),('!/appointments/admin/','admin',0,1,1,'b2b_appointments','','9837cac792e2816438fa8f669fa623a4'),('!/customer/report_custom_list/','admin,ar',1,1,1,'customcustomerlist','','3fc84925c61961a139e4e430cbcbd57e'),('!/vendor/mass_update/','ap',0,1,1,'hubconstruction','STR_EXPENSES|STR_VENDORS|STR_MASS_VENDOR_UPDATE','db0c185de88beb06434ab9261ea0bb14'),('apvariance.php','ap',1,1,1,'apvariancereport','STR_PAYABLES|STR_REPORTS|STR_AP_VARIANCE','5638ee1bdec81bb53db7e98ddb753dcc'),('!/aradmin/ordernumbering/','admin,ar',0,1,1,'ordernumbering','','e20f7f27d4170bca82a3c74dcd057485'),('!/bank_deposit/import_usaepay/','ar',0,1,1,'hubconstruction','STR_TOOLS|STR_IMPORTS|STR_IMPORT_USAEPAY_BATCH_CC_DEPOSIT','a9092303666decaea80626434c0ce7a2'),('!/vendor/mass_insurance_update/','ap',0,1,1,'hubconstruction','STR_EXPENSES|STR_VENDORS|STR_MASS_INSURANCE_UPDATE','af8d15d6f832e88b256a585227dd4e02'),('!/vendor/import_vendor_certificate/','ap',0,1,1,'vendor_certificates','STR_TOOLS|STR_IMPORT|STR_IMPORT_VENDOR_CERTIFICATES','a5a9f34c0f28df933d8860b43ccdd431'),('!/waivertype/edit/','ar',0,1,1,'construction','STR_ADMIN|STR_BILLING|STR_JOB_WAIVER_TYPES','5d95e499288b0d9179b5b8cd4cbe82b4'),('!/waiver/edit/','ar',0,1,1,'construction','STR_INCOME|STR_JOBS|STR_WAIVERS|STR_EDIT_WAIVER','c44cdc05ed259a81f44c299c26337eb3'),('!/waiver/datatable/','ar',1,1,1,'construction','STR_INCOME|STR_JOBS|STR_WAIVERS|STR_LIST','a11bd3a8745ec6c5e2833bab8df1a629'),('!/amazon/admin/','admin,ar',0,0,1,'amazon','','c1c09f03e3c84d26050e3e667b1a9b38'),('!/jobitem/edit/','ar',0,1,1,'construction','STR_BILLING|STR_JOBS|STR_ADD_JOB_COST_ITEMS','0c044aa639a36e311273b2706b4576eb'),('!/employee/sickvacationliability/','pay',1,1,1,'payroll','STR_PAYROLL|STR_REPORTS|STR_SICK_AND_VACATION_TIME_LIABILITY','c7bced44d670a8e6dcaea2963d6f10cb'),('!/jobitem/dataTable/','ar',1,1,1,'construction','STR_BILLING|STR_JOBS|STR_JOB_COST_ITEMS_DATA_TABLE','0e4830e35f73b06337cae9f4d5bcaa16'),('!/jobbudget/edit/','ar,ap',0,1,1,'construction','STR_BILLING|STR_JOBS|STR_JOB_BUDGETS','0cf29d5e0f4c6fd8375e0b57fd53a8cd'),('!/jobbudget/dataTable/','ar,ap',1,1,1,'construction','STR_BILLING|STR_JOBS|STR_JOB_BUDGETS_DATA_TABLE','b4c8c64122bc6c5c58f9049d2bbf09c4'),('!/itemlocation/physicalinv/','admin,inv',0,1,1,'inventory','','5ab922859131465286bd246ee5dee9c1'),('!/arordership/rentalsdatatable/','inv',1,1,1,'rentals,inventory','STR_INCOME|STR_RENTAL_ORDERS|STR_RENTAL_PICKUPS','fec421edf544045d8c363dac853c8dd4'),('!/arorderrentalpickup/edit/','inv',0,1,1,'rentals,inventory','STR_INVENTORY|STR_ITEMS|STR_RENTALS|STR_ADD_EDIT','8a9075d9f68ae6482e8c95eee5824341'),('jobbudgetvariancerpt.php','ar,ap',1,1,1,'construction','STR_BILLING|STR_REPORTS|STR_JOB_BUDGET_VARIANCE','0c10daae65d098c0ad8427af0ff20d30'),('!/arinvoice/generateoverduerentalinvoices/','ar',0,1,1,'inventory,rentals','STR_INCOME|STR_RENTAL_ORDERS|STR_GENERATE_INVOICES_FOR_BILLABLE_RENTALS','40fe13b9cdcd1cd6dc23abeebec70737'),('!/item/statsperlocation/','inv',1,1,1,'inventory','STR_INVENTORY|STR_ITEMS|STR_ITEM_LOCATION_STATS','259c1487e3c768ec4557e4d91dca9243'),('!/amazon/reports/','ar',1,0,0,'amazon','','353d73b8f4e5afd7c2526b1d06dea9c7'),('!/amazon/import/','admin,ar',0,1,1,'amazon','','675506ee43d228dfb96a6c503c9fd365'),('!/waiver/search/','ar,inv',1,1,1,'construction','STR_REPORTS|STR_BILLING|STR_WAIVER_SEARCH','f07e039c4492895c4f5a060a4b14700b'),('!/job/exporttozlien/','ar',1,1,1,'construction,zlien','STR_TOOLS|STR_EXPORTS|STR_EXPORT_JOBS_TO_ZLIEN','6dbce5a205452ab8a9510bf51e4f375c'),('!/job/overcreditlimit/','ar',1,1,1,'construction','STR_REPORTS|STR_BILLING|STR_JOBS_OVER_PRELIM_CREDIT_LIMIT','cadf3ad8f7c162d2c83a21c014fe4848'),('!/arorder/overdueordersmissingitemsonpo/','ap,ar,inv',1,1,1,'inventory','STR_INCOME|STR_REPORTS|STR_OVERDUE_ORDERS_WAITING_ON_PO','3327443abb71aa321eb8f28cbb98685c'),('!/invpo/reportpendingsentap/','ap',1,1,1,'inventory','STR_EXPENSES|STR_REPORTS|STR_COMPLETED_PURCHASE_ORDERS_NOT_SENT_TO_AP','0e6b49e3bdab2ee9e25b4064bcecdf56'),('!/invcotransfer/pick/','inv',0,1,1,'inventory,invcotransfer','STR_INVENTORY|STR_TRANSFERS|STR_PICK_TRANSFER','92bf28e70625fcf4597787861b5010e8'),('!/invcotransfer/receive/','inv',0,1,1,'inventory,invcotransfer','STR_INVENTORY|STR_TRANSFERS|STR_RECEIVE','30d2856147e8c0f8be9be14d19919518'),('!/arordership/adjustment/','ar',0,1,1,'inventory','STR_INCOME|STR_ORDERS|STR_SHIPMENT_ADJUSTMENT','d171aa497b92051a4d433d4e77b45f2a'),('!/shippingroute/dataTable/','ar',1,1,1,'inventory','STR_ADMIN|STR_ORDERS|STR_SHIPPING_ROUTES','f2f2eec4021006eb99d4921dc1495d70'),('!/shippingroute/edit/','ar',0,1,1,'inventory','STR_ADMIN|STR_ORDERS|STR_ADD_EDIT_SHIPPING_ROUTES','c1110bc3ed94a33acd2d01e030e71581'),('!/arordership/shipbyroute/','ar',0,1,1,'inventory','STR_INCOME|STR_ORDERS|STR_SHIP_BY_ROUTE','488fea143e3a725d7231a6645fe0a3cd'),('!/recurringbilling/datatable/','admin,ar',1,0,0,'recurringbilling','','25c82bf4302c56c88d9e16bc90148cd0'),('!/recurringbilling/plan/','admin,ar',1,1,0,'recurringbilling','','104af5cfc6a8ba67e6e5b325eefe1107'),('!/recurringbilling/subscribe/','admin,ar',1,1,0,'recurringbilling','','377c412fa87d079f01c96a078f25d47f'),('!/recurringbilling/report/','admin,ar',1,0,0,'recurringbilling','','e22df0768d99e0151ff595744becc1e7'),('!/recurringbilling/writeoff/','admin,ar',1,1,0,'recurringbilling','','b7f876308ba860c0c7a9620eb58fedc7'),('!/recurringbilling/manualprocessing/','admin,ar',1,1,0,'recurringbilling','','5f58bb1c6a3f188ea872284311b03f8a'),('!/paymentonaccount/entry/','ar',0,1,1,'paymentonaccount','STR_BILLING|STR_PAYMENTS|STR_PAYMENT_ON_ACCOUNT','1879a1dd78029cd4f184142f2411875f'),('!/arorder/shippableorderswithrecievedpo/','inv',1,1,1,'inventory','STR_BILLING|STR_REPORTS|STR_SHIPPABLE_ORDERS_WITH_RECEIVED_PO','86dbdee4366bbc4e9f85aeb439bf1075'),('!/item/setglsforitemcategory/','ar,inv',0,1,1,'','','f6ba6ecf53226db87959e23ab6f25938'),('!/salestax/dataTable/','ar',0,0,1,'','','409611e1065f4eb4713264d6abbff8ef'),('customereditlockinvoicetermsfromoe','ar',0,0,0,'','STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_INVOICE_TERMS','3a8d49b76e9982c812203cad9755c3be'),('customereditlockinvoiceterms','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_INVOICE_TERMS','87b1e969624f3e47d6f7721e17277bb3'),('customereditlockcustomercredit','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_CUSTOMER_CREDIT','93a10d8dd1ce61d366680a905113487b'),('customereditlocksalesgl','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_SALES_GL','344b6bd8658b58eaacff0515b9460675'),('customereditlockpricelevel','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_PRICE_LEVEL','8a3c8308f8489e7e2677bca30992f8f2'),('customereditlockbankinfo','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_BANK_INFO','83c5fe6d21ab79e4ae000f09dd31d50e'),('customereditlockspecialpricing','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_SPECIAL_PRICING','19a8d6ee650e67b444a856e5c45b16e0'),('customereditlockbackorders','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_BACK_ORDERS','07f011f520fb78031ce15f2f239e7f00'),('customereditlockauthorizedbuyers','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_AUTHORIZED_BUYERS','98148060c56a205d16887878e284058a'),('customereditlockexemptdeliverycharge','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_EXEMPT_DELIVERY_CHARGE','91724febb8cfd47643e30d914f067d9a'),('customereditlockexemptfuelcharge','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_EXEMPT_FUEL_CHARGE','f042d695b7ce0402dea685297536bfa3'),('customereditlockshowpricesondeliveryconf','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_SHOW_PRICES_ON_DELIVERY_CONFIRMATION','d806428173a71e2a1b37425deafd4238'),('customereditlockdeliverysalesonly','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_DELIVERY_SALES_ONLY','b036313fbf25d06de18e353d1e6f5f39'),('customereditlockallowordermods','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_ALLOW_ORDER_MODIFICATIONS','097d1296cb925b2337a7f858b0470596'),('customereditlockjobnumberrequired','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_JOB_NUMBER_REQUIRED','0774e56f6cf27b808310abae837c663f'),('customereditlockprelimjobsales','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_PRELIM_JOB_SALES','69800306dcc9946bf97508964c04f2de'),('customereditlockoktoolsonjobaccounts','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_OK_TOOLS_ON_JOB_ACCOUNTS','c3b4d2886a4db5e21575ee7eaa02c9f4'),('customereditlockoktoshipifincompletejobinfo','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_OK_TO_SHIP_IF_INCOMPLETE_JOB_INFO','3871b61d2761cc7b5834b0cab80128a7'),('customereditlockcreditapplicationreceived','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_CREDIT_APPLICATION_RECEIVED','2388639d3bd72956ba4aaafa0fe63573'),('customereditlockcustomercreditfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_CUSTOMER_CREDIT','1161aadda9659eaa18ae59430a3399a9'),('customereditlocksalesglfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_SALES_GL','97a4cac5a508cd122515f94dc1571925'),('customereditlockpricelevelfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_PRICE_LEVEL','a20ba0f0618b75f98fa6734aa41ad4fa'),('customereditlockbankinfofromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_BANK_INFO','ef32b98db2a8eb010b008f46c2be10a4'),('customereditlockspecialpricingfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_SPECIAL_PRICING','64c5afb301df481df7ae6f859bf770e7'),('customereditlockbackordersfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_BACK_ORDERS','f064ecadd07defdc2344c2226566ca21'),('customereditlockauthorizedbuyersfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_AUTHORIZED_BUYERS','194640444d5ff796b690a6a1ceb1ead7'),('customereditlockexemptdeliverychargefromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_EXEMPT_DELIVERY_CHARGE','861f3f59b3a055cb2bb2f8f0fb0e0219'),('customereditlockexemptfuelchargefromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_EXEMPT_FUEL_CHARGE','24598284c6646d048400be13a50664a0'),('customereditlockshowpricesondeliveryconffromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_SHOW_PRICES_ON_DELIVERY_CONFIRMATION','3e69be1416739199fd881472ee7a7f2e'),('customereditlockdeliverysalesonlyfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_DELIVERY_SALES_ONLY','861c0d1cb387b3b27ba9fcb4c1476cfc'),('customereditlockallowordermodsfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_ALLOW_ORDER_MODIFICATIONS','56a715749610a301efb0b139905bb698'),('customereditlockjobnumberrequiredfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_JOB_NUMBER_REQUIRED','358b0c64a8ea6a457f1c347d9c9cc387'),('customereditlockprelimjobsalesfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_PRELIM_JOB_SALES','6234d0624fa32f7498bd2c81d1d053b9'),('customereditlockoktoolsonjobaccountsfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_OK_TOOLS_ON_JOB_ACCOUNTS','be2b04a95bed526b3960b4e2db26f7be'),('customereditlockoktoshipifincompletejobinfofromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_OK_TO_SHIP_IF_INCOMPLETE_JOB_INFO','e592187b4760a5ca866eef8580975a8f'),('customereditlockcreditapplicationreceivedfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_CREDIT_APPLICATION_RECEIVED','addaa7bc0ba5968f78a6d8c514b73cc2'),('!/invcountbatch/reviewcounts/','inv',0,1,1,'invadjustmentrequests,inventory','STR_INVENTORY|STR_COUNT_MANAGEMENT|STR_REVIEW_AND_POST_COUNTS','94adbb95c8a69f6f264c46c3926d4f4d'),('!/invreceive/datatable/','ap,inv',1,1,1,'inventory','STR_EXPENSES|STR_PO_RECEIPTS|STR_TABLE','34989c2680fc4717a33ab93e163620b4'),('!/recurringbilling/plan_invoice/','ar',1,1,1,'recurringbilling','','7d82dc050f0e4e7f7448e89433b2c38f'),('!/item/reportonrent/','ar,inv',1,1,1,'rentals,inventory','STR_INVENTORY|STR_REPORTS|STR_OUT_ON_RENT_ITEMS','b9978ba597db4239b554fbd458e46a61'),('!/arinvoice/dailysalesreport/','ar',1,1,1,'','STR_INCOME|STR_REPORTS|STR_DAILY_SALES_INQUIRY','2f0957728138203c6703c8685f538610'),('customereditlocksalesperson','ar',0,0,0,'','STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_SALES_PERSON','ca66150c8a3e8805c05bd095513a191e'),('customereditlocksalesrep','ar',0,0,0,'','STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_SALES_REP','40b14539ff9a66cee1b06c30b261ea2f'),('!/priceoverriderequest/datatable/','ar',1,1,1,'priceoverriderequests','','8cacb2a70673d24fe72f9ef84941272f'),('!/itemlocation/reportbackordered/','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_BACKORDERED_STOCK','c605e0ff3659a488d7955f31159191a1'),('!/invcotransferdetail/reporttransferdetails/','inv',1,1,1,'inventory,invcotransfer','STR_INVENTORY|STR_REPORTS|STR_TRANSFER_DETAILS','c704ff86b5833aae76dee60d0c124463'),('!/invreceivemain/datatable/','inv',1,1,1,'','','8ce9a88ca4a46695f545aa1f59dbf5f1'),('blockonaccountpaymentmethodfromoe','ar',0,0,0,'paymentonaccount','STR_CUSTOMER_ADD_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_BLOCK_ON_ACCOUNT_PAYMENT_METHOD','4740abc2e4aff68d455f8bfee4f5cdec'),('vendoreditlockgeneral','ap',0,0,0,'','STR_VENDOR_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_GENERAL','c7c945b2d1d833e4412a4c35fc7eed1c'),('vendoreditlockpayto','ap',0,0,0,'','STR_VENDOR_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_PAY_TO','7b5f570667980d3faee801e20afde642'),('vendoreditlockcontacts','ap',0,0,0,'','STR_VENDOR_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_CONTACTS','018a24eac1e82a17f92972b268a6697d'),('vendoreditlockorderfrom','ap',0,0,0,'','STR_VENDOR_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_ORDER_FROM','1040f0a821ab6897a8dc5aa304fa8d22'),('vendoreditlockpayment','ap',0,0,0,'','STR_VENDOR_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_PAYMENT','b0ee85f708c2760431ae92e41577101b'),('vendoreditlockvendorterms','ap',0,0,0,'','STR_VENDOR_EDIT_RESTRICTIONS|STR_ALWAYS|STR_LOCK_VENDOR_TERMS','8eb68f2345108d001c9d3bb8b89107cc'),('!/itemvendor/import/','inv',1,1,1,'inventory','STR_TOOLS|STR_IMPORTS|STR_ITEM_VENDOR_DETAILS','3a06b48679ca99b32738e86bacecec1d'),('!/arinvoice/issuecreditajax/','ar',0,1,1,'','STR_BILLING|STR_INVOICES|STR_ISSUE_SIMPLE_CREDIT','924b7f74d115ec5942ed025979109559'),('!/arinvoice/priceadjustment/','ar',0,1,1,'','STR_BILLING|STR_INVOICES|STR_ISSUE_PRICE_ADJUSTMENT_CREDIT','a4829b74f80483e7f24eedac5820af28'),('!/arinvoice/taxadjustment/','ar',0,1,1,'','STR_BILLING|STR_INVOICES|STR_ISSUE_TAX_ADJUSTMENT','1ba583a9dab0a87a1ada21b1b58dad4a'),('!/invcountbatch/itemstatus/','inv',1,1,1,'invadjustmentrequests,inventory','STR_INVENTORY|STR_COUNT_MANAGEMENT|STR_ITEM_STATUS','c1bfcdf0d01cc612b8c9cb0df8dab96c'),('!/arinvoice/metaMenu/','ar',1,1,1,'','STR_BILLING|STR_INVOICES|STR_META_MENU','43a6c06ce4128d0e1b2a05ecd02652a3'),('!/arorder/metaMenu/','ar',1,1,1,'inventory','STR_ORDERS|STR_ITEM_ORDERS|STR_META_MENU','4a9a1a5b5b80ba5ba8044ebab43eaaa0'),('!/job/metaMenu/','ap,ar',1,1,1,'construction','STR_BILLING|STR_JOBS|STR_META_MENU','24f6b37b44ff26fa16d3016b81993138'),('!/customer/metaMenu/','ar',1,1,1,'','STR_CONTACTS|STR_CUSTOMERS|STR_META_MENU','de1210602deae5a3507d9d77208c0348'),('!/check/metaMenu/','ap',1,1,1,'','STR_PAYABLES|STR_CHECKS|STR_META_MENU','15869bfb47d13253887f05a57987ec8f'),('!/gltransvoucher/metaMenu/','gl',1,1,1,'','STR_LEDGER|STR_JOURNAL_ENTRIES|STR_META_MENU','6b36028797823e01baae928bd0cbd5ba'),('!/vendor/metaMenu/','ap',1,1,1,'','STR_CONTACTS|STR_VENDORS|STR_META_MENU','88085bbd884a8a23d688a6ed984d1ac9'),('!/item/metaMenu/','ap,ar,inv',1,1,1,'inventory','STR_INVENTORY|STR_ITEMS|STR_META_MENU','22758e5a628e447c379d800c30f4fb46'),('!/arordership/metaMenu/','ar',1,1,1,'inventory','STR_ORDERS|STR_ITEM_ORDERS|STR_SHIPMENT_META_MENU','154a595dcd1cdde6f811db7433f0103c'),('!/arordership/unbilledShippedQTY/','ar',1,1,1,'inventory','STR_RECEIVE|STR_ORDERS|STR_UNINVOICED_SHIPMENTS','9c448ffcd5d52a8d2b953cb059e1d7cd'),('!/billtrust/showBilltrustSentInvoices/','ar',1,1,1,'billtrust','STR_REPORTS|STR_BILLING|STR_INVOICES_SENT_TO_BILLTRUST','b652bebf86864c4aeff0c9b84a325766'),('!/itemlocation/edit_lastpocost/','inv',0,0,1,'lastpocost','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_EDIT_LAST_COST','32f5367bbf9aa0604e4c7416402f92e4'),('customereditlocksalespersonfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_SALES_PERSON','b2a644d02343fc5e0517fbb427460405'),('customereditlocksalesrepfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_LOCK_SALES_REP','db437ea109e6ebf89faaa321cadd8b94'),('!/item/reportbybuyer/','inv',1,1,1,'inventory,dcreorder','STR_INVENTORY|STR_REPORTS|STR_ITEMS_BY_BUYER','f1c68c53fdffa48c51485757cdb3a1a8'),('arcustadd_from_orderentry','ar',0,1,1,'','STR_CUSTOMER_ADD_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_ALLOWED','d306b8659a93356a1d6b167832fcd1b6'),('!/item/barcodemassprint/','inv',1,1,1,'barcodelabel','STR_INVENTORY|STR_ITEMS|STR_BARCODE_MASS_PRINT','9f5f632c58aef8913e69b4c15794bfc3'),('customeredithideinvoicingsection','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_ALWAYS|STR_HIDE_INVOICING_SECTION','4f04e30eaad82e2c9f666ea0b5755ae2'),('customeredithideinvoicingsectionfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_EDIT_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_HIDE_INVOICING_SECTION','1539b626e3b7b404a893a74b5fc77cb5'),('customeraddhideinvoicingsection','ar',0,0,0,NULL,'STR_CUSTOMER_ADD_RESTRICTIONS|STR_ALWAYS|STR_HIDE_INVOICING_SECTION','689fc2d937c46e6cc36353f1ef2cd117'),('customeraddhideinvoicingsectionfromoe','ar',0,0,0,NULL,'STR_CUSTOMER_ADD_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_HIDE_INVOICING_SECTION','917b19e8f2b840d9fbbacf94e0dae0f1'),('jobaddhidebankinsurancearchitectsectionfromoe','ar',0,0,0,'construction','STR_JOB_ADD_RESTRICTIONS|STR_FROM_ORDER_ENTRY|STR_HIDE_BANK_INSURANCE_ARCHITECT_SECTION','055c610b2660f87859de974ec41dd66d'),('!/itemlocation/edit_wacost/','inv',0,1,1,'inventory','STR_INVENTORY|STR_INVENTORY_ITEMS|STR_EDIT_AVG_COST','2e53ee0f937e8063f82d4e18ac805be4'),('!/arinvoice/findcustomersettingsmismatch/','ar',0,1,1,'','STR_BILLING|STR_REPORTS|STR_INVOICES_WITH_TERMS_NOT_MATCHING_CUSTOMER','bb2e636c209ebae7fbc0563ac4c0b972'),('!/customer/report_tax_setup/','ar',1,1,1,'customertaxsetupreport','STR_BILLING|STR_REPORTS|STR_CUSTOMER_TAX_SETUP_REPORT','0553c35adec345bbbd62f4948f525e14'),('!/customer/changeincustomersales/','ar',1,1,1,'','STR_INCOME|STR_REPORTS|STR_SALES_CHANGES_ANALYSIS','334976a8fbf579ff8a9ca93353368554'),('paperproofmylarrequestfpdf.php','ar',1,1,1,'','','0b2da46fbf24bf181688e0f8912109a2'),('!/itemlocation/overstockreport/','inv',1,1,1,'inventory','STR_INVENTORY|STR_REPORTS|STR_OVERSTOCK_REPORT','d09258b54e059e2b18e916d2824b0462'),('!/invcotransfer/variancereport/','inv',1,1,1,'inventory,invcotransfer','STR_INVENTORY|STR_REPORTS|STR_TRANSFER_FILL_RATE_ANALYSIS','09111509b94fe8d229f634b0a9639685'),('!/invcountbatch/livecountbybin/','inv',1,1,1,'invadjustmentrequests,inventory','STR_INVENTORY|STR_COUNT_MANAGEMENT|STR_VIEW_ASSIGNED_BINS_FOR_LOCATION','23ad6082c73e42368f0e0c18902a8d2a'),('!/invbinitem/reassignbybarcode/','inv',0,1,1,'inventory,invzone','STR_ADMIN|STR_INVENTORY|STR_QUICK_ITEM_BIN_MAINTENANCE','60153d062ee42a2084498bb2bf2dae41'),('!/customer/report_authorizenet_cim_storedcard/','ar',1,1,1,'authorizenetcim','STR_BILLING|STR_REPORTS|STR_AUTHORIZENET_CIM_CARD_REPORT','9b2e7a80313679586c93323ba5cb4e32'),('!/zipcodealt/dataTable/','admin',0,1,1,'','STR_ADMIN|STR_SYSTEM|STR_MANAGE_ALTERNATIVE_ZIP_CODES','1af872ece376aa948a72118abc8c141b'),('!/item/avgcosthistory/','inv',1,1,1,'companywidewacost','STR_INVENTORY|STR_ITEMS|STR_AVERAGE_COST_HISTORY','266d6c4cb8bc492eea4a8526809bf9c7'),('customcommissions.php','admin,ar,inv,pay',1,1,1,'jbncustomcommissions','STR_BILLING|STR_REPORTS|STR_CUSTOM_COMMISSIONS','49031b9eed5151654b9c7697c6f0f875'),('!/salesterritory/index/','admin,ar',0,1,1,'','STR_INCOME|STR_SALES_PERSONNEL|STR_MANAGE_TERRITORIES','52ad1afa94f841f32cf21954b5820094'),('!/salesregion/index/','admin,ar',0,1,1,'','STR_INCOME|STR_SALES_PERSONNEL|STR_REGION_MANAGEMENT','1f8b4ad31bf7bca52267e0f66f3a521d'),('!/salesterritory/import/','admin,ar',0,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_SALESMAN_TERRITORIES','d6095102d2ba6d78f8cb5818f98896bd'),('!/salesregion/reportRegionSalesSummary/','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_REGION_SALES_SUMMARY','436529386c03b27097d9b22937e7194c'),('!/salesregion/reportRegionSalesByCustomer/','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_REGION_SALES_BY_CUSTOMER','ddb37f38d0975a7c4702fc0340bf8caf'),('!/salesterritory/reportterritorycustomersalesanalysis/','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_TERRITORY_CUSTOMER_SALES_ANALYSIS','0c79f819994dace197097e0f0298a8d0'),('!/salesterritory/reportterritoryitemsales/','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_TERRITORY_ITEM_SALES','2436fbf94c2e66a67d19d49f4d69de32'),('!/salesterritory/reportterritoryaccountperformance/','ar',1,1,1,'','STR_BILLING|STR_REPORTS|STR_TERRITORY_ACCOUNT_PERFORMANCE','78e3a35f6fcd26ade2ce026c4a955574'),('!/itempricespecial/itempricespecialusage/','inv',1,1,1,'itempricesspecial','STR_INCOME|STR_REPORTS|STR_SPECIAL_SALES_PRICING_USAGE','718a412496676028db6ee885bf9cdf72'),('!/invserialnumber/editnumbersused/','ar,inv',0,1,1,'serialnuminnotes','STR_INVENTORY|STR_ITEMS|STR_CHANGE_USED_SERIAL_NUMBER','b365a94985eae9fb0997aaa8de2ca473'),('invitembompo.php','inv,admin',1,0,0,'','STR_INVENTORY|STR_MANAGE_BUILD_ORDERS|STR_CREATE_PO','82e4f97d49f2f774e50217a750071d69'),('bom_entry_or_update.php','inv,admin',1,0,0,'','STR_INVENTORY|STR_MANAGE_BUILD_ORDERS|STR_EDIT_DEFINITIONS','b5848d36fbdd167bc42cca446ba0797c'),('!/arinvoice/aging/','ar,admin',1,0,0,'','STR_BILLING|STR_REPORTS|STR_AGING','48d69c31da68c3607bfcba55cf8eb750'),('!/arinvoicepaymentdetail/import','ap,ar,gl,pay,inv,fix,imp',1,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_CUSTOMER_PAYMENTS','84ccfa927635e7b3ad041eda2e5b4b21'),('!/contact/customer_import','ap,ar,gl,pay,inv,fix,imp',1,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_CUSTOMERS_CONTACTS','de2d5547139a9c8cefcfed460d6ad048'),('!/job/import','ap,ar,gl,pay,inv,fix,imp',1,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_JOBS','3d483465abf3f84a73228d3619c24ca7'),('!/contact/vendor_import','ap,ar,gl,pay,inv,fix,imp',1,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_VENDORS_CONTACTS','8411e2929a2d35c6676180b196efb4ca'),('!/apbillpayment/import','ap,ar,gl,pay,inv,fix,imp',1,1,1,'','STR_TOOLS|STR_IMPORTS|STR_IMPORT_VENDOR_PAYMENTS','e68f89cbf8d1df58eba50fbf49960dd7'),('!/chargebackcode/','ar,admin',0,1,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_CHARGEBACK_CODES','da2dbd3b996c06c8663981ccc236d3dc'),('!/writeoffreason/','ar,admin',0,1,1,'','STR_ADMIN|STR_SETUP_RECEIVABLES|STR_WRITE_OFF_REASONS','ded36b49e8e2a95273972f3e54857165'),('importbudgetposb.php','ap,inv',0,0,1,'construction',NULL,'679eb8e73dbc40aa31a34733c7ad134a'),('itemavgcosthistory','ap,inv',1,1,1,'inventory,inquiriestab','STR_INVENTORY|STR_ITEM_AVG_COST_HISTORY_INQUIRY','c95a585d03594fb2a16ec4ab9da11fe9'),('!/customer/profitabilityreport/','ar',1,1,1,'','STR_BILLING|STR_CUSTOMERS|STR_PROFITABILITY_REPORT','08ec41c4faeaf0e8def5354e73dc579e'),('!/arinvoice/dailyclosereport/','ar',1,1,1,'','STR_INCOME|STR_REPORTS|STR_DAILY_CLOSE','59e50f968c37f12f58797d2f74813ad7'),('canauthbuyers','ar',0,1,1,'','STR_CONTACTS|STR_CUSTOMERS|STR_CAN_AUTHORIZE_BUYER','e27648ee21aad1f2f9425a657c10a4b4'),('!/customfields/report_assignmembershipcoaches/','ar',1,1,1,'membershiptracker','','1f771e85b5055474d9817df1b69f3e3a'),('invoiceslockedbydateexcludecostcode','ar',0,1,1,'invoiceslockedbydate','STR_BILLING|STR_INVOICES|STR_CAN_EDIT_PAST_INVOICE_COST_CODES','099dbb22c9cfb006f1dd27f4f8f83a24'),('invoiceslockedbydateexcludelocation','ar',0,1,1,'invoiceslockedbydate','STR_BILLING|STR_INVOICES|STR_CAN_EDIT_PAST_INVOICE_LOCATIONS','7f1a1e667156902d321d29a1b9f36aa6'),('!/vendor/profitabilityreportdialog/','ap',1,1,1,'inventory','STR_EXPENSES|STR_REPORTS|STR_VENDOR_PROFITABILITY','2e9a7ed9de7f2ad2b9070fde435ba51b'),('!/arinvoice/salesreconciliation/','ar',1,1,1,'','STR_INCOME|STR_REPORTS|STR_SALES_RECONCILIATION','e0a0d153932fae90c0dbbe6cda8c9599');
/*!40000 ALTER TABLE `npmodrights` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `nprights`
--

DROP TABLE IF EXISTS `nprights`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `nprights` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `page` varchar(255) NOT NULL default '',
  `extra` varchar(255) NOT NULL default '',
  `companyid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `page_userid_companyid` (`page`,`userid`,`companyid`),
  KEY `userid` (`userid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `nprights`
--

LOCK TABLES `nprights` WRITE;
/*!40000 ALTER TABLE `nprights` DISABLE KEYS */;
/*!40000 ALTER TABLE `nprights` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `nprightsgroup`
--

DROP TABLE IF EXISTS `nprightsgroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `nprightsgroup` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `nprightsgroup`
--

LOCK TABLES `nprightsgroup` WRITE;
/*!40000 ALTER TABLE `nprightsgroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `nprightsgroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `nprightsgroupdefaults`
--

DROP TABLE IF EXISTS `nprightsgroupdefaults`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `nprightsgroupdefaults` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `nprightsgroupid` int(10) unsigned NOT NULL default '0',
  `level1` varchar(100) NOT NULL default '',
  `level2` varchar(100) NOT NULL default '',
  `level3` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `group` (`nprightsgroupid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `nprightsgroupdefaults`
--

LOCK TABLES `nprightsgroupdefaults` WRITE;
/*!40000 ALTER TABLE `nprightsgroupdefaults` DISABLE KEYS */;
/*!40000 ALTER TABLE `nprightsgroupdefaults` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `nprightsuserdefaults`
--

DROP TABLE IF EXISTS `nprightsuserdefaults`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `nprightsuserdefaults` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `nprightsgroupid` int(10) unsigned NOT NULL default '0',
  `level1` varchar(100) NOT NULL default '',
  `level2` varchar(100) NOT NULL default '',
  `level3` varchar(100) NOT NULL default '',
  `plusminusright` int(11) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `userplusminus` (`userid`,`plusminusright`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `nprightsuserdefaults`
--

LOCK TABLES `nprightsuserdefaults` WRITE;
/*!40000 ALTER TABLE `nprightsuserdefaults` DISABLE KEYS */;
/*!40000 ALTER TABLE `nprightsuserdefaults` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `onsiteconfig`
--

DROP TABLE IF EXISTS `onsiteconfig`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `onsiteconfig` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `originatorid` varchar(25) NOT NULL default '',
  `username` varchar(50) NOT NULL default '',
  `userpassword` varchar(50) NOT NULL default '',
  `propertyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` varchar(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `onsiteconfig`
--

LOCK TABLES `onsiteconfig` WRITE;
/*!40000 ALTER TABLE `onsiteconfig` DISABLE KEYS */;
/*!40000 ALTER TABLE `onsiteconfig` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `onsitereq`
--

DROP TABLE IF EXISTS `onsitereq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `onsitereq` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `onsitepropertyid` int(11) NOT NULL default '0',
  `monthlyrent` decimal(9,2) NOT NULL default '0.00',
  `requestxml` text NOT NULL,
  `status` varchar(20) NOT NULL default '',
  `errorcode` varchar(150) NOT NULL default '',
  `errordescription` text NOT NULL,
  `reportid` int(11) NOT NULL default '0',
  `score` decimal(7,2) NOT NULL default '0.00',
  `decision` varchar(50) NOT NULL default '',
  `response` text NOT NULL,
  `reportdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `onsitepropertyid` (`onsitepropertyid`),
  KEY `status` (`status`),
  KEY `reportid` (`reportid`),
  KEY `reportdate` (`reportdate`),
  KEY `entrydate` (`entrydate`),
  KEY `entryuserid` (`entryuserid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `onsitereq`
--

LOCK TABLES `onsitereq` WRITE;
/*!40000 ALTER TABLE `onsitereq` DISABLE KEYS */;
/*!40000 ALTER TABLE `onsitereq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_actual`
--

DROP TABLE IF EXISTS `order_actual`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_actual` (
  `id_order_actual` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `id_family` int(11) NOT NULL default '0',
  `print_type` int(2) NOT NULL default '0',
  `id_question` int(11) NOT NULL default '0',
  `id_question_detail` int(11) NOT NULL default '0',
  `id_machine` int(11) NOT NULL default '0',
  `id_item` int(11) NOT NULL default '0',
  `redo` int(2) NOT NULL default '0',
  `actual_time` decimal(6,2) NOT NULL default '0.00',
  `hourlyrate` decimal(15,2) NOT NULL default '0.00',
  `production_quantity` decimal(15,2) NOT NULL default '0.00',
  `production_costperunit` decimal(15,4) NOT NULL default '0.0000',
  `actual_matl` decimal(15,2) NOT NULL default '0.00',
  `material_unitcost` decimal(15,4) NOT NULL default '0.0000',
  `comments` varchar(250) NOT NULL default '',
  `initials` varchar(10) NOT NULL default '',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` date default NULL,
  `cancel` int(1) NOT NULL default '0',
  `time_eq_actual` decimal(10,3) default '0.000',
  `time_op_actual` decimal(10,3) default '0.000',
  `cost_op_hour` decimal(10,3) default '0.000',
  `cost_eq_hour` decimal(10,3) default '0.000',
  `matl_qty_actual` decimal(10,3) default '0.000',
  `matl_unitcost_actual` decimal(10,3) default '0.000',
  `markup` decimal(10,3) default '0.000',
  `extendedprice` decimal(10,3) default '0.000',
  `overhead` decimal(10,3) default '0.000',
  `Impressions_actual` decimal(10,3) default '0.000',
  `production_priceperunit` decimal(12,4) NOT NULL default '0.0000',
  `matl_unitprice_actual` decimal(12,4) NOT NULL default '0.0000',
  `price_per_hour` decimal(12,4) NOT NULL default '0.0000',
  `iphunit_name` varchar(20) default NULL,
  `invoiceid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_order_actual`),
  UNIQUE KEY `id_order_actual` (`id_order_actual`),
  KEY `id_printorder` (`id_printorder`),
  KEY `id_family` (`id_family`),
  KEY `id_machine` (`id_machine`),
  KEY `redo` (`redo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_actual`
--

LOCK TABLES `order_actual` WRITE;
/*!40000 ALTER TABLE `order_actual` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_actual` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_actualseq`
--

DROP TABLE IF EXISTS `order_actualseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_actualseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_actualseq`
--

LOCK TABLES `order_actualseq` WRITE;
/*!40000 ALTER TABLE `order_actualseq` DISABLE KEYS */;
INSERT INTO `order_actualseq` VALUES (0);
/*!40000 ALTER TABLE `order_actualseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_additional`
--

DROP TABLE IF EXISTS `order_additional`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_additional` (
  `id` int(11) NOT NULL auto_increment,
  `id_printorder` int(11) NOT NULL default '0',
  `id_gencompany` int(11) NOT NULL default '0',
  `description` varchar(250) NOT NULL default '',
  `quantity` varchar(15) NOT NULL default '',
  `price` decimal(15,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_additional`
--

LOCK TABLES `order_additional` WRITE;
/*!40000 ALTER TABLE `order_additional` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_additional` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_chargenum`
--

DROP TABLE IF EXISTS `order_chargenum`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_chargenum` (
  `id_order_chargenum` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `charge_number` varchar(15) NOT NULL default '',
  `activity_number` varchar(15) NOT NULL default '',
  `subactivity_number` varchar(15) NOT NULL default '',
  `percent_of_order` decimal(10,2) NOT NULL default '0.00',
  `cancel` int(1) NOT NULL default '0',
  `canceldate` date NOT NULL default '0000-00-00',
  `wherefrom` int(2) NOT NULL default '0',
  PRIMARY KEY  (`id_order_chargenum`),
  UNIQUE KEY `id_order_chargenum` (`id_order_chargenum`),
  KEY `id_printorder` (`id_printorder`),
  KEY `charge_number` (`charge_number`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_chargenum`
--

LOCK TABLES `order_chargenum` WRITE;
/*!40000 ALTER TABLE `order_chargenum` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_chargenum` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_chargenumseq`
--

DROP TABLE IF EXISTS `order_chargenumseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_chargenumseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_chargenumseq`
--

LOCK TABLES `order_chargenumseq` WRITE;
/*!40000 ALTER TABLE `order_chargenumseq` DISABLE KEYS */;
INSERT INTO `order_chargenumseq` VALUES (0);
/*!40000 ALTER TABLE `order_chargenumseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_document`
--

DROP TABLE IF EXISTS `order_document`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_document` (
  `id_order_document` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `docname` varchar(255) NOT NULL default '',
  `origdocname` varchar(255) NOT NULL default '',
  `cancel` int(2) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_temp` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_order_document`),
  KEY `id_printorder` (`id_printorder`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_document`
--

LOCK TABLES `order_document` WRITE;
/*!40000 ALTER TABLE `order_document` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_document` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_documentseq`
--

DROP TABLE IF EXISTS `order_documentseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_documentseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_documentseq`
--

LOCK TABLES `order_documentseq` WRITE;
/*!40000 ALTER TABLE `order_documentseq` DISABLE KEYS */;
INSERT INTO `order_documentseq` VALUES (0);
/*!40000 ALTER TABLE `order_documentseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_functions`
--

DROP TABLE IF EXISTS `order_functions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_functions` (
  `id_order_functions` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `id_question` int(11) NOT NULL default '0',
  `sel_response` varchar(100) NOT NULL default '',
  `text_response` varchar(100) NOT NULL default '',
  `time_est` decimal(10,2) NOT NULL default '0.00',
  `time_est_price` decimal(12,2) NOT NULL default '0.00',
  `time_est_cost` decimal(12,2) NOT NULL default '0.00',
  `materials_est_cost` decimal(12,3) NOT NULL default '0.000',
  `materials_est_price` decimal(12,3) NOT NULL default '0.000',
  `time_actual` decimal(12,2) NOT NULL default '0.00',
  `time_actual_cost` decimal(12,2) NOT NULL default '0.00',
  `time_actual_price` decimal(12,2) NOT NULL default '0.00',
  `materials_actual_cost` decimal(12,2) NOT NULL default '0.00',
  `materials_actual_price` decimal(12,2) NOT NULL default '0.00',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  `actual_quantity` decimal(15,2) NOT NULL default '0.00',
  `calc_quantity` decimal(15,2) NOT NULL default '0.00',
  `actual_quantity_materials` decimal(15,2) NOT NULL default '0.00',
  `calc_quantity_materials` decimal(15,2) NOT NULL default '0.00',
  `print_type` int(1) NOT NULL default '0',
  `id_order_partnr` int(11) NOT NULL default '0',
  `id_item` int(11) NOT NULL default '0',
  `id_family` int(11) NOT NULL default '0',
  `time_eq_est` decimal(10,3) NOT NULL default '0.000',
  `time_op_est` decimal(10,3) NOT NULL default '0.000',
  `cost_op_hour` decimal(10,3) NOT NULL default '0.000',
  `cost_eq_hour` decimal(10,3) NOT NULL default '0.000',
  `matl_qty_est` decimal(10,3) NOT NULL default '0.000',
  `matl_unitcost_est` decimal(10,3) NOT NULL default '0.000',
  `overhead` decimal(4,3) NOT NULL default '0.000',
  `markup` decimal(4,3) NOT NULL default '0.000',
  `extendedprice` decimal(10,3) NOT NULL default '0.000',
  `Impressions_est` int(11) NOT NULL default '0',
  `quote_quantity` int(11) NOT NULL default '0',
  `production_quantity` int(14) NOT NULL default '0',
  `production_priceperunit` decimal(12,4) NOT NULL default '0.0000',
  `matl_unitprice_est` decimal(12,4) NOT NULL default '0.0000',
  `price_per_hour` decimal(12,4) NOT NULL default '0.0000',
  `iphunit_name` varchar(20) default NULL,
  PRIMARY KEY  (`id_order_functions`),
  UNIQUE KEY `id_order_functions` (`id_order_functions`),
  KEY `id_question` (`id_question`),
  KEY `id_printorder` (`id_printorder`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_functions`
--

LOCK TABLES `order_functions` WRITE;
/*!40000 ALTER TABLE `order_functions` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_functions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_functionseq`
--

DROP TABLE IF EXISTS `order_functionseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_functionseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_functionseq`
--

LOCK TABLES `order_functionseq` WRITE;
/*!40000 ALTER TABLE `order_functionseq` DISABLE KEYS */;
INSERT INTO `order_functionseq` VALUES (0);
/*!40000 ALTER TABLE `order_functionseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_functionsseq`
--

DROP TABLE IF EXISTS `order_functionsseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_functionsseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_functionsseq`
--

LOCK TABLES `order_functionsseq` WRITE;
/*!40000 ALTER TABLE `order_functionsseq` DISABLE KEYS */;
INSERT INTO `order_functionsseq` VALUES (0);
/*!40000 ALTER TABLE `order_functionsseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_partnr`
--

DROP TABLE IF EXISTS `order_partnr`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_partnr` (
  `id_order_partnr` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `id_item` int(11) NOT NULL default '0',
  `print_method` int(3) NOT NULL default '0',
  `quantity_est` decimal(14,0) NOT NULL default '0',
  `quantity_scrap_cust` decimal(14,0) NOT NULL default '0',
  `quantity_scrap_xrx` decimal(14,0) NOT NULL default '0',
  `quantity_good_actual` decimal(14,0) NOT NULL default '0',
  `cost_per_salesunit` decimal(19,5) NOT NULL default '0.00000',
  `price_per_salesunit` decimal(19,5) NOT NULL default '0.00000',
  `status` int(3) NOT NULL default '0',
  `description` varchar(20) NOT NULL default '',
  `number_up` int(3) NOT NULL default '1',
  `pages` int(5) NOT NULL default '0',
  `num_originals` int(5) NOT NULL default '0',
  `sides` int(1) NOT NULL default '0',
  `special_order` varchar(50) NOT NULL default '',
  `width` decimal(10,4) NOT NULL default '0.0000',
  `length` decimal(10,4) NOT NULL default '0.0000',
  `impressions` decimal(14,0) NOT NULL default '0',
  `num_colors` int(3) NOT NULL default '0',
  `colorlist` varchar(100) NOT NULL default '',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  `mwt` decimal(6,2) NOT NULL default '0.00',
  `press_width` decimal(10,3) NOT NULL default '0.000',
  `press_length` decimal(10,3) NOT NULL default '0.000',
  `number_out` int(3) NOT NULL default '1',
  `colorlist_two` varchar(100) default NULL,
  `num_colors_two` int(3) NOT NULL default '0',
  `pages_per_sig` int(5) NOT NULL default '1',
  `signatures` int(5) NOT NULL default '1',
  `iphqty` int(11) NOT NULL default '0',
  `iphunit_name` varchar(20) default NULL,
  `difficulty` int(3) NOT NULL default '2',
  `print_type` int(2) NOT NULL default '1',
  `caliper` decimal(10,4) NOT NULL default '0.0000',
  `order_date` date default NULL,
  `order_by` int(11) NOT NULL default '0',
  `receive_date` date default NULL,
  `received_by` int(11) NOT NULL default '0',
  `passes` int(11) NOT NULL default '1',
  PRIMARY KEY  (`id_order_partnr`),
  UNIQUE KEY `id_order_partnr` (`id_order_partnr`),
  KEY `id_printorder` (`id_printorder`),
  KEY `id_item` (`id_item`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_partnr`
--

LOCK TABLES `order_partnr` WRITE;
/*!40000 ALTER TABLE `order_partnr` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_partnr` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_partnrseq`
--

DROP TABLE IF EXISTS `order_partnrseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_partnrseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_partnrseq`
--

LOCK TABLES `order_partnrseq` WRITE;
/*!40000 ALTER TABLE `order_partnrseq` DISABLE KEYS */;
INSERT INTO `order_partnrseq` VALUES (0);
/*!40000 ALTER TABLE `order_partnrseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_po`
--

DROP TABLE IF EXISTS `order_po`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_po` (
  `id_order_po` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `id_purchase_order` int(11) NOT NULL default '0',
  `id_workarea` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_order_po`),
  UNIQUE KEY `id_order_po` (`id_order_po`),
  KEY `id_printorder` (`id_printorder`),
  KEY `id_purchase_order` (`id_purchase_order`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_po`
--

LOCK TABLES `order_po` WRITE;
/*!40000 ALTER TABLE `order_po` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_po` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_poseq`
--

DROP TABLE IF EXISTS `order_poseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_poseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_poseq`
--

LOCK TABLES `order_poseq` WRITE;
/*!40000 ALTER TABLE `order_poseq` DISABLE KEYS */;
INSERT INTO `order_poseq` VALUES (0);
/*!40000 ALTER TABLE `order_poseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_proof`
--

DROP TABLE IF EXISTS `order_proof`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_proof` (
  `id_order_proof` int(11) NOT NULL default '0',
  `sentdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `pages` int(3) NOT NULL default '0',
  `proof_status` int(1) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `responsedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `duedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `notes` varchar(250) NOT NULL default '',
  `id_user_create` int(11) NOT NULL default '0',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `days_after` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_order_proof`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_proof`
--

LOCK TABLES `order_proof` WRITE;
/*!40000 ALTER TABLE `order_proof` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_proof` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_proofseq`
--

DROP TABLE IF EXISTS `order_proofseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_proofseq` (
  `id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_proofseq`
--

LOCK TABLES `order_proofseq` WRITE;
/*!40000 ALTER TABLE `order_proofseq` DISABLE KEYS */;
INSERT INTO `order_proofseq` VALUES (0);
/*!40000 ALTER TABLE `order_proofseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_shipment`
--

DROP TABLE IF EXISTS `order_shipment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_shipment` (
  `id_order_shipment` int(11) NOT NULL default '0',
  `id_order_shipto` int(11) NOT NULL default '0',
  `quantity` int(15) NOT NULL default '0',
  `shipdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_order_shipmentlog` int(11) NOT NULL default '0',
  `packslip` int(2) NOT NULL default '0',
  `boxlabel` int(2) NOT NULL default '0',
  `logdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `createdate` date NOT NULL default '0000-00-00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` date default NULL,
  `cancel` int(11) NOT NULL default '0',
  `signfor` varchar(255) NOT NULL default '',
  `failed` int(11) NOT NULL default '0',
  `id_printorder` int(11) default '0',
  `notes` varchar(250) NOT NULL default '',
  `id_order_shipment_group` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_order_shipment`),
  UNIQUE KEY `id_order_shipment` (`id_order_shipment`),
  KEY `id_order_shipment_group` (`id_order_shipment_group`),
  KEY `id_order_shipto` (`id_order_shipto`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_shipment`
--

LOCK TABLES `order_shipment` WRITE;
/*!40000 ALTER TABLE `order_shipment` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_shipment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_shipmentseq`
--

DROP TABLE IF EXISTS `order_shipmentseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_shipmentseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_shipmentseq`
--

LOCK TABLES `order_shipmentseq` WRITE;
/*!40000 ALTER TABLE `order_shipmentseq` DISABLE KEYS */;
INSERT INTO `order_shipmentseq` VALUES (0);
/*!40000 ALTER TABLE `order_shipmentseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_shiptoseq`
--

DROP TABLE IF EXISTS `order_shiptoseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_shiptoseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_shiptoseq`
--

LOCK TABLES `order_shiptoseq` WRITE;
/*!40000 ALTER TABLE `order_shiptoseq` DISABLE KEYS */;
INSERT INTO `order_shiptoseq` VALUES (0);
/*!40000 ALTER TABLE `order_shiptoseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_work`
--

DROP TABLE IF EXISTS `order_work`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `order_work` (
  `id` int(11) NOT NULL auto_increment,
  `id_employee` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `id_family` int(11) NOT NULL default '0',
  `id_question` int(11) NOT NULL default '0',
  `id_question_detail` int(11) NOT NULL default '0',
  `id_machine` int(11) NOT NULL default '0',
  `id_order_actual` int(11) NOT NULL default '0',
  `startdatetime` datetime NOT NULL default '0000-00-00 00:00:00',
  `enddatetime` datetime NOT NULL default '0000-00-00 00:00:00',
  `elapsedtime` decimal(15,3) NOT NULL default '0.000',
  `status` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `order_work`
--

LOCK TABLES `order_work` WRITE;
/*!40000 ALTER TABLE `order_work` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_work` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `orders_products_attributes`
--

DROP TABLE IF EXISTS `orders_products_attributes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `orders_products_attributes` (
  `orders_products_attributes_id` int(5) NOT NULL auto_increment,
  `orders_id` int(5) NOT NULL default '0',
  `orders_products_id` int(5) NOT NULL default '0',
  `products_options` varchar(32) NOT NULL default '',
  `products_options_values` varchar(32) NOT NULL default '',
  `options_values_price` decimal(8,2) NOT NULL default '0.00',
  `price_prefix` char(1) NOT NULL default '',
  PRIMARY KEY  (`orders_products_attributes_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `orders_products_attributes`
--

LOCK TABLES `orders_products_attributes` WRITE;
/*!40000 ALTER TABLE `orders_products_attributes` DISABLE KEYS */;
/*!40000 ALTER TABLE `orders_products_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `originals`
--

DROP TABLE IF EXISTS `originals`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `originals` (
  `id_originals` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  KEY `id_originals` (`id_originals`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `originals`
--

LOCK TABLES `originals` WRITE;
/*!40000 ALTER TABLE `originals` DISABLE KEYS */;
INSERT INTO `originals` VALUES (1,'Hard Copy'),(2,'Disk'),(3,'Email'),(4,'No Originals');
/*!40000 ALTER TABLE `originals` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `osccompany`
--

DROP TABLE IF EXISTS `osccompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `osccompany` (
  `id` int(11) NOT NULL auto_increment,
  `default_pricelevelid` int(11) NOT NULL default '0',
  `locationid` int(11) NOT NULL default '0',
  `cost` int(11) NOT NULL default '0',
  `sales` int(11) NOT NULL default '0',
  `default_sellunitid` int(11) NOT NULL default '0',
  `default_priceunitid` int(11) NOT NULL default '0',
  `checking` int(11) NOT NULL default '0',
  `depositglacctid` int(11) NOT NULL default '0',
  `default_checkacctid` int(11) NOT NULL default '0',
  `default_salescategory_fulfillment` int(11) NOT NULL default '0',
  `default_invoicetermsid` int(11) NOT NULL default '0',
  `oscurl` varchar(255) NOT NULL default '',
  `osclogin` varchar(50) NOT NULL default '',
  `oscpw` varchar(50) NOT NULL default '',
  `oscdbhost` varchar(50) NOT NULL default '',
  `oscdbuser` varchar(50) NOT NULL default '',
  `oscdbpw` varchar(50) NOT NULL default '',
  `oscdbname` varchar(50) NOT NULL default '',
  `oscimporturl` varchar(255) NOT NULL default '',
  `osclastorder` int(11) default '0',
  `oscapikey` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `osccompany`
--

LOCK TABLES `osccompany` WRITE;
/*!40000 ALTER TABLE `osccompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `osccompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ownership`
--

DROP TABLE IF EXISTS `ownership`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ownership` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `companyid` int(11) NOT NULL default '0',
  `owneruserid` int(11) NOT NULL default '0',
  `ownercompanyid` int(11) NOT NULL default '0',
  `percentage` decimal(9,2) NOT NULL default '0.00',
  `notes` text NOT NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `companyid` (`companyid`),
  KEY `owneruserid` (`owneruserid`),
  KEY `ownercompanyid` (`ownercompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ownership`
--

LOCK TABLES `ownership` WRITE;
/*!40000 ALTER TABLE `ownership` DISABLE KEYS */;
/*!40000 ALTER TABLE `ownership` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `paymentplan`
--

DROP TABLE IF EXISTS `paymentplan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `paymentplan` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `description` text,
  `descriptionshort` varchar(25) default NULL,
  `sortorder` int(11) NOT NULL default '0',
  `guarantor` int(11) NOT NULL default '0',
  `enddate` date NOT NULL default '0000-00-00',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `sortorder` (`sortorder`),
  KEY `enddate` (`enddate`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `paymentplan`
--

LOCK TABLES `paymentplan` WRITE;
/*!40000 ALTER TABLE `paymentplan` DISABLE KEYS */;
/*!40000 ALTER TABLE `paymentplan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payplan_bills`
--

DROP TABLE IF EXISTS `payplan_bills`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `payplan_bills` (
  `id` int(11) NOT NULL auto_increment,
  `payplan_invoiceid` int(11) NOT NULL default '0',
  `invoicedate` date default NULL,
  `invoiceid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `payplan_invoiceid` (`payplan_invoiceid`),
  KEY `invoiceid` (`invoiceid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payplan_bills`
--

LOCK TABLES `payplan_bills` WRITE;
/*!40000 ALTER TABLE `payplan_bills` DISABLE KEYS */;
/*!40000 ALTER TABLE `payplan_bills` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `personal_message`
--

DROP TABLE IF EXISTS `personal_message`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `personal_message` (
  `id` int(11) NOT NULL auto_increment,
  `messageid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `receiveddate` datetime default NULL,
  `received` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `userid` (`userid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `personal_message`
--

LOCK TABLES `personal_message` WRITE;
/*!40000 ALTER TABLE `personal_message` DISABLE KEYS */;
/*!40000 ALTER TABLE `personal_message` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pickupsalestax`
--

DROP TABLE IF EXISTS `pickupsalestax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pickupsalestax` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `salestaxid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `salestaxid` (`salestaxid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pickupsalestax`
--

LOCK TABLES `pickupsalestax` WRITE;
/*!40000 ALTER TABLE `pickupsalestax` DISABLE KEYS */;
/*!40000 ALTER TABLE `pickupsalestax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `piecework_addlrates`
--

DROP TABLE IF EXISTS `piecework_addlrates`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `piecework_addlrates` (
  `id` int(11) NOT NULL auto_increment,
  `piecework_functionid` int(11) NOT NULL default '0',
  `piecework_function_detailid` int(11) NOT NULL default '0',
  `rate` decimal(15,5) NOT NULL default '0.00000',
  `sortorder` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `piecework_functionid` (`piecework_functionid`),
  KEY `piecework_function_detailid` (`piecework_function_detailid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `piecework_addlrates`
--

LOCK TABLES `piecework_addlrates` WRITE;
/*!40000 ALTER TABLE `piecework_addlrates` DISABLE KEYS */;
/*!40000 ALTER TABLE `piecework_addlrates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `piecework_areas`
--

DROP TABLE IF EXISTS `piecework_areas`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `piecework_areas` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `sortorder` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `cancel` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `piecework_areas`
--

LOCK TABLES `piecework_areas` WRITE;
/*!40000 ALTER TABLE `piecework_areas` DISABLE KEYS */;
/*!40000 ALTER TABLE `piecework_areas` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `piecework_function_detail`
--

DROP TABLE IF EXISTS `piecework_function_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `piecework_function_detail` (
  `id` int(11) NOT NULL auto_increment,
  `id_piecework_functions` int(11) NOT NULL default '0',
  `entrytype` int(2) NOT NULL default '0',
  `rate` decimal(15,4) NOT NULL default '0.0000',
  `minimum` decimal(15,4) NOT NULL default '0.0000',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `sortorder` int(5) NOT NULL default '0',
  `prompt` varchar(50) default NULL,
  `dividing_quantity_for_rate` int(11) NOT NULL default '0',
  `user_rate_requires_explanation` int(5) NOT NULL default '0',
  `allow_user_rate` int(5) NOT NULL default '0',
  `calc_how` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `id_piecework_functions` (`id_piecework_functions`),
  KEY `cancel` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `piecework_function_detail`
--

LOCK TABLES `piecework_function_detail` WRITE;
/*!40000 ALTER TABLE `piecework_function_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `piecework_function_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `piecework_function_detail_selection`
--

DROP TABLE IF EXISTS `piecework_function_detail_selection`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `piecework_function_detail_selection` (
  `id` int(11) NOT NULL auto_increment,
  `id_piecework_function_detail` int(11) NOT NULL default '0',
  `description` varchar(50) default NULL,
  `rate` decimal(15,4) NOT NULL default '0.0000',
  `minimum` decimal(15,4) NOT NULL default '0.0000',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `sortorder` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `id_piecework_function_detail` (`id_piecework_function_detail`),
  KEY `cancel` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `piecework_function_detail_selection`
--

LOCK TABLES `piecework_function_detail_selection` WRITE;
/*!40000 ALTER TABLE `piecework_function_detail_selection` DISABLE KEYS */;
/*!40000 ALTER TABLE `piecework_function_detail_selection` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `piecework_functions`
--

DROP TABLE IF EXISTS `piecework_functions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `piecework_functions` (
  `id` int(11) NOT NULL auto_increment,
  `id_piecework_area` int(11) NOT NULL default '0',
  `description` varchar(50) default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `sortorder` int(5) NOT NULL default '0',
  `ask_job` int(5) NOT NULL default '0',
  `allow_nojob` int(5) NOT NULL default '0',
  `ask_quantity` int(5) NOT NULL default '0',
  `allow_user_rate` int(5) NOT NULL default '0',
  `minimum` decimal(15,5) NOT NULL default '0.00000',
  `user_rate_require_explanation` int(5) NOT NULL default '0',
  `rate` decimal(15,5) NOT NULL default '0.00000',
  `dividing_quantity_for_rate` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `id_piecework_area` (`id_piecework_area`),
  KEY `cancel` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `piecework_functions`
--

LOCK TABLES `piecework_functions` WRITE;
/*!40000 ALTER TABLE `piecework_functions` DISABLE KEYS */;
/*!40000 ALTER TABLE `piecework_functions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pmworktype`
--

DROP TABLE IF EXISTS `pmworktype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pmworktype` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pmworktype`
--

LOCK TABLES `pmworktype` WRITE;
/*!40000 ALTER TABLE `pmworktype` DISABLE KEYS */;
/*!40000 ALTER TABLE `pmworktype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ponumberseq`
--

DROP TABLE IF EXISTS `ponumberseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ponumberseq` (
  `id` int(11) NOT NULL default '0',
  `apcompanyid` int(11) NOT NULL default '1',
  PRIMARY KEY  (`apcompanyid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ponumberseq`
--

LOCK TABLES `ponumberseq` WRITE;
/*!40000 ALTER TABLE `ponumberseq` DISABLE KEYS */;
INSERT INTO `ponumberseq` VALUES (0,0);
/*!40000 ALTER TABLE `ponumberseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `postaxgroup`
--

DROP TABLE IF EXISTS `postaxgroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `postaxgroup` (
  `id` int(11) NOT NULL auto_increment,
  `groupname` varchar(50) NOT NULL default '',
  `taxid1` int(11) NOT NULL default '0',
  `taxid2` int(11) NOT NULL default '0',
  `taxid3` int(11) NOT NULL default '0',
  `locationid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `groupname` (`groupname`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `postaxgroup`
--

LOCK TABLES `postaxgroup` WRITE;
/*!40000 ALTER TABLE `postaxgroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `postaxgroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `practive`
--

DROP TABLE IF EXISTS `practive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `practive` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `status` int(11) NOT NULL default '0',
  `statuschangedate` date NOT NULL default '0000-00-00',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `practive`
--

LOCK TABLES `practive` WRITE;
/*!40000 ALTER TABLE `practive` DISABLE KEYS */;
/*!40000 ALTER TABLE `practive` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pradditionaltax`
--

DROP TABLE IF EXISTS `pradditionaltax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pradditionaltax` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `abrev` char(3) NOT NULL default '',
  `name` char(30) NOT NULL default '',
  `taxnum` char(20) NOT NULL default '0',
  `deductfed` int(11) NOT NULL default '0',
  `feddeductmax` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `glacctid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `maxexemptpercent` decimal(5,2) NOT NULL default '0.00',
  `maxexemptyear` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt1` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt2` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt3` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt4` decimal(19,4) NOT NULL default '0.0000',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `round_tax` int(2) NOT NULL default '0',
  `mexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `taxyear` int(4) NOT NULL default '2007',
  `mainrec` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pradditionaltax`
--

LOCK TABLES `pradditionaltax` WRITE;
/*!40000 ALTER TABLE `pradditionaltax` DISABLE KEYS */;
/*!40000 ALTER TABLE `pradditionaltax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pradditionaltaxdetail`
--

DROP TABLE IF EXISTS `pradditionaltaxdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pradditionaltaxdetail` (
  `id` int(11) NOT NULL auto_increment,
  `pradditionaltaxid` int(11) NOT NULL default '0',
  `maritalstatus` int(11) NOT NULL default '0',
  `deductiontable` int(11) NOT NULL default '0',
  `tax` decimal(19,4) NOT NULL default '0.0000',
  `percent` decimal(8,4) NOT NULL default '0.0000',
  `over` decimal(19,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pradditionaltaxdetail`
--

LOCK TABLES `pradditionaltaxdetail` WRITE;
/*!40000 ALTER TABLE `pradditionaltaxdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `pradditionaltaxdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prbended`
--

DROP TABLE IF EXISTS `prbended`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prbended` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `paytype` int(11) NOT NULL default '0',
  `bendedtype` int(11) NOT NULL default '0',
  `name` char(30) NOT NULL default '',
  `howfig` int(11) NOT NULL default '0',
  `prdedgroupid` double NOT NULL default '0',
  `rate` decimal(19,5) NOT NULL default '0.00000',
  `ceilingperyear` decimal(19,4) NOT NULL default '0.0000',
  `expenseglacctid` int(11) NOT NULL default '0',
  `payableglacctid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `exemptperyear` decimal(19,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prbended`
--

LOCK TABLES `prbended` WRITE;
/*!40000 ALTER TABLE `prbended` DISABLE KEYS */;
/*!40000 ALTER TABLE `prbended` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prcity`
--

DROP TABLE IF EXISTS `prcity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prcity` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `abrev` char(3) NOT NULL default '',
  `name` char(30) NOT NULL default '',
  `taxnum` char(20) NOT NULL default '0',
  `deductfed` int(11) NOT NULL default '0',
  `feddeductmax` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `glacctid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `maxexemptpercent` decimal(5,2) NOT NULL default '0.00',
  `maxexemptyear` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt1` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt2` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt3` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt4` decimal(19,4) NOT NULL default '0.0000',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `round_tax` int(2) NOT NULL default '0',
  `mexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `taxyear` int(4) NOT NULL default '2007',
  `mainrec` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prcity`
--

LOCK TABLES `prcity` WRITE;
/*!40000 ALTER TABLE `prcity` DISABLE KEYS */;
/*!40000 ALTER TABLE `prcity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prcitydetail`
--

DROP TABLE IF EXISTS `prcitydetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prcitydetail` (
  `id` int(11) NOT NULL auto_increment,
  `prcityid` int(11) NOT NULL default '0',
  `maritalstatus` int(11) NOT NULL default '0',
  `deductiontable` int(11) NOT NULL default '0',
  `tax` decimal(19,4) NOT NULL default '0.0000',
  `percent` decimal(8,4) NOT NULL default '0.0000',
  `over` decimal(19,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prcitydetail`
--

LOCK TABLES `prcitydetail` WRITE;
/*!40000 ALTER TABLE `prcitydetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `prcitydetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prcompany`
--

DROP TABLE IF EXISTS `prcompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prcompany` (
  `id` int(11) NOT NULL default '0',
  `fedtaxnum` varchar(15) NOT NULL default '',
  `w2companyname` varchar(35) default NULL,
  `w2companyaddress1` varchar(100) default NULL,
  `w2companyaddress2` varchar(100) default NULL,
  `w2citystatezip` varchar(100) default NULL,
  `stateunemplnum` varchar(15) default NULL,
  `glcheckaccountid` int(11) NOT NULL default '0',
  `glfitpayableid` int(11) NOT NULL default '0',
  `glficapayableid` int(11) NOT NULL default '0',
  `glficaexpenseid` int(11) NOT NULL default '0',
  `glfuipayableid` int(11) NOT NULL default '0',
  `glfuiexpenseid` int(11) NOT NULL default '0',
  `glmedicarepayableid` int(11) NOT NULL default '0',
  `glmedicareexpenseid` int(11) NOT NULL default '0',
  `glsuipayableid` int(11) NOT NULL default '0',
  `glsuiexpenseid` int(11) NOT NULL default '0',
  `glmiscdedpayableid` int(11) NOT NULL default '0',
  `gltaxexemptexpenseid` int(11) NOT NULL default '0',
  `glworkmanscomppayableid` int(11) NOT NULL default '0',
  `glworkmanscompexpenseid` int(11) NOT NULL default '0',
  `post2payables` int(11) NOT NULL default '1',
  `checkacctid` int(11) NOT NULL default '0',
  `shift2multiplier` decimal(5,2) default '1.00',
  `shift3multiplier` decimal(5,2) default '1.00',
  `sickleavehrsperyear` decimal(5,2) default '0.00',
  `maxsickleave` decimal(7,2) default '0.00',
  `minwagehr` decimal(10,2) default '0.00',
  `autoprintdeposit` int(11) NOT NULL default '0',
  `depositvendorid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `fringes` decimal(10,2) NOT NULL default '0.00',
  `default_dd_desc` varchar(10) NOT NULL default '',
  `glpayroll_payableid` int(11) NOT NULL default '0',
  `post2endperiod` int(5) NOT NULL default '0',
  `w2extra_top` int(5) NOT NULL default '0',
  `w2extra_side` int(5) NOT NULL default '0',
  `extrafield1_desc` varchar(255) default NULL,
  `extrafield2_desc` varchar(255) default NULL,
  `wc_vendorid` int(11) NOT NULL default '0',
  `totalach` int(5) NOT NULL default '0',
  `maxssn_digits` int(5) NOT NULL default '9',
  `check_memoline` varchar(100) default NULL,
  `kindofemployer` char(1) NOT NULL default 'N',
  `hidessnoncheck` tinyint(4) NOT NULL default '0',
  `sickvacstartsonhiredate` tinyint(1) NOT NULL default '0',
  `showloghoursdates` tinyint(4) NOT NULL default '0',
  `hideloghoursshift` tinyint(4) NOT NULL default '0',
  `hideloghoursgl` tinyint(4) NOT NULL default '0',
  `otdeductsfromst` tinyint(4) NOT NULL default '0',
  `stprpaytypeid` int(11) NOT NULL default '0',
  `otprpaytypeid` int(11) NOT NULL default '0',
  `scprpaytypeid` int(11) NOT NULL default '0',
  `roundfederal` tinyint(4) NOT NULL default '0',
  `hideaccruedhoursfromcheck` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prcompany`
--

LOCK TABLES `prcompany` WRITE;
/*!40000 ALTER TABLE `prcompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `prcompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prcompanyperiod`
--

DROP TABLE IF EXISTS `prcompanyperiod`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prcompanyperiod` (
  `id` int(11) NOT NULL auto_increment,
  `prcompanyid` int(11) NOT NULL default '0',
  `prperiodid` int(11) NOT NULL default '0',
  `maxpayhr` decimal(19,4) NOT NULL default '0.0000',
  `maxgross` decimal(19,4) NOT NULL default '0.0000',
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `prcompanyid` (`prcompanyid`),
  KEY `prperiodid` (`prperiodid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prcompanyperiod`
--

LOCK TABLES `prcompanyperiod` WRITE;
/*!40000 ALTER TABLE `prcompanyperiod` DISABLE KEYS */;
/*!40000 ALTER TABLE `prcompanyperiod` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prcostcenter`
--

DROP TABLE IF EXISTS `prcostcenter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prcostcenter` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(30) NOT NULL default '',
  `companyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prcostcenter`
--

LOCK TABLES `prcostcenter` WRITE;
/*!40000 ALTER TABLE `prcostcenter` DISABLE KEYS */;
/*!40000 ALTER TABLE `prcostcenter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prdedgroup`
--

DROP TABLE IF EXISTS `prdedgroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prdedgroup` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(30) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prdedgroup`
--

LOCK TABLES `prdedgroup` WRITE;
/*!40000 ALTER TABLE `prdedgroup` DISABLE KEYS */;
INSERT INTO `prdedgroup` VALUES (1,'A',1),(2,'A',0);
/*!40000 ALTER TABLE `prdedgroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prdepositchecks`
--

DROP TABLE IF EXISTS `prdepositchecks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prdepositchecks` (
  `checkid` int(11) NOT NULL default '0',
  `prperiodid` int(11) NOT NULL default '0',
  `periodbegindate` date NOT NULL default '0000-00-00',
  `periodenddate` date NOT NULL default '0000-00-00',
  `fit` decimal(19,4) NOT NULL default '0.0000',
  `fica` decimal(19,4) NOT NULL default '0.0000',
  `medicare` decimal(19,4) NOT NULL default '0.0000',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`checkid`),
  KEY `prperiodid` (`prperiodid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prdepositchecks`
--

LOCK TABLES `prdepositchecks` WRITE;
/*!40000 ALTER TABLE `prdepositchecks` DISABLE KEYS */;
/*!40000 ALTER TABLE `prdepositchecks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prempldeduction`
--

DROP TABLE IF EXISTS `prempldeduction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prempldeduction` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `prempldeductiontypeid` int(11) NOT NULL default '0',
  `description` char(50) default NULL,
  `amountperperiod` decimal(10,4) default NULL,
  `amounttype` char(1) NOT NULL default 'F',
  `glaccountid` int(11) NOT NULL default '0',
  `periodsremain` int(11) NOT NULL default '0',
  `maxamount` decimal(19,6) NOT NULL default '0.000000',
  `usemaxamount` tinyint(4) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `begindate` date default NULL,
  `enddate` date default NULL,
  PRIMARY KEY  (`id`),
  KEY `employeeid` (`employeeid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prempldeduction`
--

LOCK TABLES `prempldeduction` WRITE;
/*!40000 ALTER TABLE `prempldeduction` DISABLE KEYS */;
/*!40000 ALTER TABLE `prempldeduction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prempldeductiontype`
--

DROP TABLE IF EXISTS `prempldeductiontype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prempldeductiontype` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `glaccountid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prempldeductiontype`
--

LOCK TABLES `prempldeductiontype` WRITE;
/*!40000 ALTER TABLE `prempldeductiontype` DISABLE KEYS */;
/*!40000 ALTER TABLE `prempldeductiontype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `premployee`
--

DROP TABLE IF EXISTS `premployee`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `premployee` (
  `id` int(11) NOT NULL auto_increment,
  `companyid` int(11) NOT NULL default '0',
  `firstname` varchar(30) default NULL,
  `lastname` varchar(30) default NULL,
  `ssnumber` varchar(20) default NULL,
  `dateofbirth` date NOT NULL default '0000-00-00',
  `hiredate` date NOT NULL default '0000-00-00',
  `terminatedate` date NOT NULL default '0000-00-00',
  `lastreviewid` int(11) NOT NULL default '0',
  `paytype` int(11) NOT NULL default '0',
  `payperiod` int(11) NOT NULL default '0',
  `payperperiod` decimal(19,4) NOT NULL default '0.0000',
  `lastpaychangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `glaccountid` int(11) NOT NULL default '0',
  `maritalstatus` int(11) NOT NULL default '0',
  `federalexemptions` int(11) NOT NULL default '0',
  `extrafitperpayperiod` decimal(19,4) NOT NULL default '0.0000',
  `extrafitbasedon` int(11) NOT NULL default '0',
  `eic` int(11) NOT NULL default '0',
  `prstateid` int(11) NOT NULL default '0',
  `stateexemptions` int(11) NOT NULL default '0',
  `extrasitperpayperiod` decimal(19,4) NOT NULL default '0.0000',
  `extrasitbasedon` int(11) NOT NULL default '0',
  `prlocalid` int(11) NOT NULL default '0',
  `localexemptions` int(11) NOT NULL default '0',
  `extralitperpayperiod` decimal(19,4) NOT NULL default '0.0000',
  `extralitbasedon` int(11) NOT NULL default '0',
  `prcityid` int(11) NOT NULL default '0',
  `cityexemptions` int(11) NOT NULL default '0',
  `extracitperpayperiod` decimal(19,4) NOT NULL default '0.0000',
  `extracitbasedon` int(11) NOT NULL default '0',
  `workmanscomprate` decimal(10,6) NOT NULL default '0.000000',
  `pensplanid1` double NOT NULL default '0',
  `pensplandedamount1` decimal(10,4) NOT NULL default '0.0000',
  `pensplanbase1` int(11) NOT NULL default '0',
  `pensplandedmaxyearlyamount1` decimal(19,5) NOT NULL default '0.00000',
  `pensplanid2` double NOT NULL default '0',
  `pensplandedamount2` decimal(10,4) NOT NULL default '0.0000',
  `pensplanbase2` int(11) NOT NULL default '0',
  `pensplandedmaxyearlyamount2` decimal(19,5) NOT NULL default '0.00000',
  `vacationhoursaccrued` decimal(10,2) NOT NULL default '0.00',
  `sickleavehoursaccrued` decimal(10,2) NOT NULL default '0.00',
  `prdedgroupid` text,
  `status` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `image` varchar(64) default NULL,
  `workclassid` int(11) NOT NULL default '0',
  `direct_deposit` int(2) NOT NULL default '0',
  `bankaccountid` int(11) NOT NULL default '0',
  `old_id` varchar(255) default NULL,
  `extrafield1` varchar(255) default NULL,
  `extrafield2` varchar(255) default NULL,
  `timeclock_piecework` int(5) NOT NULL default '0',
  `timeclock_shift` int(5) NOT NULL default '1',
  `pensplanid3` double NOT NULL default '0',
  `pensplandedamount3` decimal(10,4) NOT NULL default '0.0000',
  `pensplanbase3` int(11) NOT NULL default '0',
  `pensplandedmaxyearlyamount3` decimal(19,5) NOT NULL default '0.00000',
  `pensplanid4` double NOT NULL default '0',
  `pensplandedamount4` decimal(10,4) NOT NULL default '0.0000',
  `pensplanbase4` int(11) NOT NULL default '0',
  `pensplandedmaxyearlyamount4` decimal(19,5) NOT NULL default '0.00000',
  `pensplanid5` double NOT NULL default '0',
  `pensplandedamount5` decimal(10,4) NOT NULL default '0.0000',
  `pensplanbase5` int(11) NOT NULL default '0',
  `pensplandedmaxyearlyamount5` decimal(19,5) NOT NULL default '0.00000',
  `federalexemption_annualwages` decimal(19,5) NOT NULL default '0.00000',
  `ismanager` int(5) NOT NULL default '0',
  `timeclock_companyid` int(11) NOT NULL default '0',
  `glid_ficaexpense` int(11) NOT NULL default '0',
  `glid_medicareexpense` int(11) NOT NULL default '0',
  `glid_fuiexpense` int(11) NOT NULL default '0',
  `glid_suiexpense` int(11) NOT NULL default '0',
  `timeclock_companyid2` int(11) NOT NULL default '0',
  `timeclock_jobid` int(11) NOT NULL default '0',
  `timeclock_jobid2` int(11) NOT NULL default '0',
  `timeclock_costcodeid` int(11) NOT NULL default '0',
  `timeclock_costcodeid2` int(11) NOT NULL default '0',
  `timeclock_categoryid` int(11) NOT NULL default '0',
  `timeclock_categoryid2` int(11) NOT NULL default '0',
  `costcenterid` int(11) NOT NULL default '0',
  `payperperiod2` decimal(19,5) NOT NULL default '0.00000',
  `maritalstatus_state` int(11) NOT NULL default '0',
  `maritalstatus_city` int(11) NOT NULL default '0',
  `maritalstatus_local` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `departmentid` int(11) NOT NULL default '0',
  `prworkerscompid` int(11) NOT NULL default '0',
  `blockvacationaccrual` tinyint(4) NOT NULL default '0',
  `blocksickaccrual` tinyint(4) NOT NULL default '0',
  `limithours` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `bankaccountid` (`bankaccountid`),
  KEY `timeclock_companyid` (`timeclock_companyid`),
  KEY `timeclock_companyid2` (`timeclock_companyid2`),
  KEY `costcenterid` (`costcenterid`),
  KEY `status` (`status`),
  KEY `payperiod` (`payperiod`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `premployee`
--

LOCK TABLES `premployee` WRITE;
/*!40000 ALTER TABLE `premployee` DISABLE KEYS */;
/*!40000 ALTER TABLE `premployee` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `premployee_addltaxes`
--

DROP TABLE IF EXISTS `premployee_addltaxes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `premployee_addltaxes` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `pradditionaltaxid` int(11) NOT NULL default '0',
  `exemptions` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `maritalstatus_addltax` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `pradditionaltaxid` (`pradditionaltaxid`),
  KEY `employeeid` (`employeeid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `premployee_addltaxes`
--

LOCK TABLES `premployee_addltaxes` WRITE;
/*!40000 ALTER TABLE `premployee_addltaxes` DISABLE KEYS */;
/*!40000 ALTER TABLE `premployee_addltaxes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `premployeepension`
--

DROP TABLE IF EXISTS `premployeepension`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `premployeepension` (
  `id` int(11) NOT NULL auto_increment,
  `premployeeid` int(11) NOT NULL default '0',
  `plannumber` int(11) default '0',
  `pensplanid` int(11) default '0',
  `pensplandedamount` decimal(10,4) default '0.0000',
  `pensplanbase` int(11) default '0',
  `pensplandedmaxyearlyamount` decimal(19,5) default '0.00000',
  `cancel` int(11) default '0',
  `canceldate` datetime default '0000-00-00 00:00:00',
  `canceluserid` int(11) default '0',
  `entrydate` datetime default '0000-00-00 00:00:00',
  `entryuserid` int(11) default '0',
  PRIMARY KEY  (`id`),
  KEY `premployeeid` (`premployeeid`,`cancel`),
  KEY `pensplanid` (`cancel`,`pensplanid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `premployeepension`
--

LOCK TABLES `premployeepension` WRITE;
/*!40000 ALTER TABLE `premployeepension` DISABLE KEYS */;
/*!40000 ALTER TABLE `premployeepension` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `premplreview`
--

DROP TABLE IF EXISTS `premplreview`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `premplreview` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `evaluatorname` varchar(50) default NULL,
  `evaldate` date NOT NULL default '0000-00-00',
  `premplreviewratingid` int(11) NOT NULL default '0',
  `comments` blob,
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `premplreview`
--

LOCK TABLES `premplreview` WRITE;
/*!40000 ALTER TABLE `premplreview` DISABLE KEYS */;
/*!40000 ALTER TABLE `premplreview` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `premplreviewrating`
--

DROP TABLE IF EXISTS `premplreviewrating`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `premplreviewrating` (
  `id` int(11) NOT NULL auto_increment,
  `description` char(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `premplreviewrating`
--

LOCK TABLES `premplreviewrating` WRITE;
/*!40000 ALTER TABLE `premplreviewrating` DISABLE KEYS */;
/*!40000 ALTER TABLE `premplreviewrating` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `premplweek`
--

DROP TABLE IF EXISTS `premplweek`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `premplweek` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `periodbegindate` date NOT NULL default '0000-00-00',
  `periodenddate` date NOT NULL default '0000-00-00',
  `prperiodid` int(11) NOT NULL default '0',
  `tipspay` decimal(19,4) NOT NULL default '0.0000',
  `tipsaswages` decimal(19,4) NOT NULL default '0.0000',
  `misctaxablepay` decimal(19,4) NOT NULL default '0.0000',
  `misctaxablecomment` char(30) default NULL,
  `miscnontaxablepay` decimal(19,4) NOT NULL default '0.0000',
  `miscnontaxablecomment` char(30) default NULL,
  `vacaccrue` decimal(5,2) NOT NULL default '0.00',
  `sickaccrue` decimal(5,2) NOT NULL default '0.00',
  `federaltax` decimal(19,4) NOT NULL default '0.0000',
  `ficatax` decimal(19,4) NOT NULL default '0.0000',
  `statetax` decimal(19,4) NOT NULL default '0.0000',
  `localtax` decimal(19,4) NOT NULL default '0.0000',
  `citytax` decimal(19,4) NOT NULL default '0.0000',
  `prstateid` int(11) NOT NULL default '0',
  `prcityid` int(11) NOT NULL default '0',
  `prlocalid` int(11) NOT NULL default '0',
  `eiccredit` decimal(19,4) NOT NULL default '0.0000',
  `miscdeduction` decimal(19,4) NOT NULL default '0.0000',
  `miscdeductioncomment` char(30) default NULL,
  `medicarededuction` decimal(19,4) NOT NULL default '0.0000',
  `calculatestatus` int(11) NOT NULL default '0',
  `fuitax` decimal(19,4) NOT NULL default '0.0000',
  `cficatax` decimal(19,4) NOT NULL default '0.0000',
  `cmedicarededuction` decimal(19,4) NOT NULL default '0.0000',
  `suitax` decimal(19,4) NOT NULL default '0.0000',
  `netpay` decimal(19,4) NOT NULL default '0.0000',
  `checkid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `depositcheckid` int(11) NOT NULL default '0',
  `sdiDeduction` decimal(19,5) NOT NULL default '0.00000',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `federalexemptions_override` int(11) NOT NULL default '0',
  `stateexemptions_override` int(11) NOT NULL default '0',
  `localexemptions_override` int(11) NOT NULL default '0',
  `cityexemptions_override` int(11) NOT NULL default '0',
  `jobcostdiff` decimal(8,4) NOT NULL default '0.0000',
  `voucherid` int(11) NOT NULL default '0',
  `block_deductions` text,
  PRIMARY KEY  (`id`),
  KEY `checkid` (`checkid`),
  KEY `cancel` (`cancel`),
  KEY `employeeid` (`employeeid`),
  KEY `perioddate` (`periodbegindate`,`periodenddate`),
  KEY `calculatestatus` (`calculatestatus`),
  KEY `periodbegindate` (`periodbegindate`),
  KEY `periodenddate` (`periodenddate`),
  KEY `voucherid` (`voucherid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `premplweek`
--

LOCK TABLES `premplweek` WRITE;
/*!40000 ALTER TABLE `premplweek` DISABLE KEYS */;
/*!40000 ALTER TABLE `premplweek` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `premplweekdeddetail`
--

DROP TABLE IF EXISTS `premplweekdeddetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `premplweekdeddetail` (
  `id` int(11) NOT NULL auto_increment,
  `premplweekid` int(11) NOT NULL default '0',
  `prempldeductionid` int(11) NOT NULL default '0',
  `prbendedid` int(11) NOT NULL default '0',
  `prpensionid` int(11) NOT NULL default '0',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `dedtype` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `bankaccountid` int(11) NOT NULL default '0',
  `dd_or_check` int(5) NOT NULL default '3',
  `checkid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `checkid` (`checkid`),
  KEY `premplweekid` (`premplweekid`),
  KEY `premplweekdeductionid` (`prempldeductionid`),
  KEY `prbendedid` (`prbendedid`),
  KEY `prpensionid` (`prpensionid`),
  KEY `dedtype` (`dedtype`),
  KEY `vendorid` (`vendorid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `premplweekdeddetail`
--

LOCK TABLES `premplweekdeddetail` WRITE;
/*!40000 ALTER TABLE `premplweekdeddetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `premplweekdeddetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `premplweekpaydetail`
--

DROP TABLE IF EXISTS `premplweekpaydetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `premplweekpaydetail` (
  `id` int(11) NOT NULL auto_increment,
  `premplweekid` int(11) NOT NULL default '0',
  `prpaytypeid` int(11) NOT NULL default '1',
  `prbendedid` int(11) NOT NULL default '0',
  `qty` decimal(8,2) NOT NULL default '0.00',
  `rate` decimal(8,4) NOT NULL default '0.0000',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  `glaccountid` int(11) NOT NULL default '0',
  `categoryid` int(11) NOT NULL default '0',
  `comment` varchar(255) default NULL,
  `departmentid` int(11) NOT NULL default '0',
  `prworkerscompid` int(11) NOT NULL default '0',
  `prworkerscomppercent` decimal(7,4) NOT NULL default '0.0000',
  `jobid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `workdate` date default NULL,
  `jobrate` decimal(8,4) NOT NULL default '0.0000',
  `jobamount` decimal(19,4) NOT NULL default '0.0000',
  `stoffset` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `premplweekid` (`premplweekid`),
  KEY `prpaytypeid` (`prpaytypeid`),
  KEY `glaccountid` (`glaccountid`),
  KEY `prworkerscompid` (`prworkerscompid`),
  KEY `prbendedid` (`prbendedid`),
  KEY `categoryid` (`categoryid`),
  KEY `departmentid` (`departmentid`),
  KEY `gltr_jobid` (`jobid`),
  KEY `workdate` (`workdate`),
  KEY `costcodeid` (`costcodeid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `premplweekpaydetail`
--

LOCK TABLES `premplweekpaydetail` WRITE;
/*!40000 ALTER TABLE `premplweekpaydetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `premplweekpaydetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `premplweekpaygltrans`
--

DROP TABLE IF EXISTS `premplweekpaygltrans`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `premplweekpaygltrans` (
  `id` int(11) NOT NULL auto_increment,
  `premplweekpaydetailid` int(11) NOT NULL default '0',
  `gltransactionid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `premplweekpaydetailid` (`premplweekpaydetailid`),
  KEY `gltransactionid` (`gltransactionid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `premplweekpaygltrans`
--

LOCK TABLES `premplweekpaygltrans` WRITE;
/*!40000 ALTER TABLE `premplweekpaygltrans` DISABLE KEYS */;
/*!40000 ALTER TABLE `premplweekpaygltrans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prfederal`
--

DROP TABLE IF EXISTS `prfederal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prfederal` (
  `id` int(11) NOT NULL auto_increment,
  `maxwagesfica` decimal(19,4) NOT NULL default '0.0000',
  `employeeficapercent` decimal(8,4) NOT NULL default '0.0000',
  `companyficapercent` decimal(8,4) NOT NULL default '0.0000',
  `maxwagesmedicare` decimal(19,4) NOT NULL default '0.0000',
  `employeemedicarepercent` decimal(8,4) NOT NULL default '0.0000',
  `companymedicarepercent` decimal(8,4) NOT NULL default '0.0000',
  `maxwagesfui` decimal(19,4) NOT NULL default '0.0000',
  `companyfuipercent` decimal(8,4) NOT NULL default '0.0000',
  `eicsinglepercent1` decimal(8,4) NOT NULL default '0.0000',
  `eicsingleover1` decimal(19,4) NOT NULL default '0.0000',
  `eicsingletax2` decimal(19,4) NOT NULL default '0.0000',
  `eicsingleover2` decimal(19,4) NOT NULL default '0.0000',
  `eicsingletax3` decimal(19,4) NOT NULL default '0.0000',
  `eicsinglepercent3` decimal(8,4) NOT NULL default '0.0000',
  `eicsingleover3` decimal(19,4) NOT NULL default '0.0000',
  `eicmarriedpercent1` decimal(8,4) NOT NULL default '0.0000',
  `eicmarriedover1` decimal(19,4) NOT NULL default '0.0000',
  `eicmarriedtax2` decimal(19,4) NOT NULL default '0.0000',
  `eicmarriedover2` decimal(19,4) NOT NULL default '0.0000',
  `eicmarriedtax3` decimal(19,4) NOT NULL default '0.0000',
  `eicmarriedpercent3` decimal(8,4) NOT NULL default '0.0000',
  `eicmarriedover3` decimal(19,4) NOT NULL default '0.0000',
  `exemptionallow` decimal(19,4) NOT NULL default '0.0000',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `eicmarriednopercent1` decimal(8,4) NOT NULL default '0.0000',
  `eicmarriednoover1` decimal(19,4) NOT NULL default '0.0000',
  `eicmarriednotax2` decimal(19,4) NOT NULL default '0.0000',
  `eicmarriednoover2` decimal(19,4) NOT NULL default '0.0000',
  `eicmarriednotax3` decimal(19,4) NOT NULL default '0.0000',
  `eicmarriednopercent3` decimal(19,4) NOT NULL default '0.0000',
  `eicmarriednoover3` decimal(19,4) NOT NULL default '0.0000',
  `fui_vendorid` int(11) NOT NULL default '0',
  `taxyear` int(4) NOT NULL default '2007',
  `mainrec` int(11) NOT NULL default '0',
  `deductfica` int(5) NOT NULL default '0',
  `periodfica` int(5) NOT NULL default '0',
  `medicare_wages_over` decimal(19,4) NOT NULL default '0.0000',
  `medicare_over_percent` decimal(8,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` USING BTREE (`gencompanyid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prfederal`
--

LOCK TABLES `prfederal` WRITE;
/*!40000 ALTER TABLE `prfederal` DISABLE KEYS */;
/*!40000 ALTER TABLE `prfederal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prfederaldetail`
--

DROP TABLE IF EXISTS `prfederaldetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prfederaldetail` (
  `id` int(11) NOT NULL auto_increment,
  `prfederalid` double NOT NULL default '0',
  `maritalstatus` int(11) NOT NULL default '0',
  `deductiontable` int(11) NOT NULL default '0',
  `tax` decimal(19,4) NOT NULL default '0.0000',
  `percent` decimal(8,4) NOT NULL default '0.0000',
  `over` decimal(19,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prfederaldetail`
--

LOCK TABLES `prfederaldetail` WRITE;
/*!40000 ALTER TABLE `prfederaldetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `prfederaldetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pricediscount`
--

DROP TABLE IF EXISTS `pricediscount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pricediscount` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `itemlocationid` int(11) NOT NULL default '0',
  `quantity` decimal(18,6) NOT NULL default '1.000000',
  `discount` decimal(6,3) NOT NULL default '0.000',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`),
  KEY `itemlocationid` (`itemlocationid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pricediscount`
--

LOCK TABLES `pricediscount` WRITE;
/*!40000 ALTER TABLE `pricediscount` DISABLE KEYS */;
/*!40000 ALTER TABLE `pricediscount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pricelevel`
--

DROP TABLE IF EXISTS `pricelevel`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pricelevel` (
  `id` int(11) NOT NULL auto_increment,
  `description` char(30) NOT NULL default '',
  `companyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `markdownpricelevelid` int(11) NOT NULL default '0',
  `markdownpercent` decimal(6,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`),
  KEY `companyid` (`companyid`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pricelevel`
--

LOCK TABLES `pricelevel` WRITE;
/*!40000 ALTER TABLE `pricelevel` DISABLE KEYS */;
INSERT INTO `pricelevel` VALUES (1,'Retail',1,0,NULL,NULL,NULL,NULL,'2005-03-08 15:08:39',NULL,0,'0.00'),(2,'Retail',0,0,NULL,NULL,NULL,NULL,'2007-11-08 21:45:58',NULL,0,'0.00'),(3,'Wholesale',1,0,NULL,NULL,NULL,NULL,'2013-04-10 18:00:00',NULL,0,'0.00'),(4,'Distributor',1,0,NULL,NULL,NULL,NULL,'2013-04-10 18:00:00',NULL,0,'0.00'),(5,'Variable',1,0,NULL,NULL,NULL,NULL,'2013-04-10 18:00:00',NULL,0,'0.00');
/*!40000 ALTER TABLE `pricelevel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `priceoverriderequest`
--

DROP TABLE IF EXISTS `priceoverriderequest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `priceoverriderequest` (
  `id` int(11) NOT NULL auto_increment,
  `draftid` varchar(25) NOT NULL default '',
  `linenumber` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `customerid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `currency` varchar(10) NOT NULL default 'USD',
  `currentprice` decimal(19,5) NOT NULL default '0.00000',
  `minimumprice` decimal(19,5) NOT NULL default '0.00000',
  `requestedprice` decimal(19,5) NOT NULL default '0.00000',
  `authorizedprice` decimal(19,5) NOT NULL default '0.00000',
  `authorizedbyuserid` int(11) NOT NULL default '0',
  `authorizeddate` datetime default NULL,
  `notes` mediumtext NOT NULL,
  `reply` mediumtext NOT NULL,
  `companyid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `draftid` (`draftid`),
  KEY `active_company` (`cancel`,`companyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `priceoverriderequest`
--

LOCK TABLES `priceoverriderequest` WRITE;
/*!40000 ALTER TABLE `priceoverriderequest` DISABLE KEYS */;
/*!40000 ALTER TABLE `priceoverriderequest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `priceperpriceunit`
--

DROP TABLE IF EXISTS `priceperpriceunit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `priceperpriceunit` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `itemlocationid` int(11) NOT NULL default '0',
  `pricelevelid` int(11) NOT NULL default '1',
  `price` decimal(19,5) NOT NULL default '0.00000',
  `price_per_day` decimal(19,5) NOT NULL default '0.00000',
  `price_per_week` decimal(19,5) NOT NULL default '0.00000',
  `price_per_month` decimal(19,5) NOT NULL default '0.00000',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `itemid` (`itemid`),
  KEY `itemlocationid` (`itemlocationid`),
  KEY `pricelevelid` (`pricelevelid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `priceperpriceunit`
--

LOCK TABLES `priceperpriceunit` WRITE;
/*!40000 ALTER TABLE `priceperpriceunit` DISABLE KEYS */;
/*!40000 ALTER TABLE `priceperpriceunit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `print_categories`
--

DROP TABLE IF EXISTS `print_categories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `print_categories` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(50) NOT NULL default '',
  `glacctid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `gencompanyid` int(11) NOT NULL default '0',
  `sigs` int(5) NOT NULL default '1',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `print_categories`
--

LOCK TABLES `print_categories` WRITE;
/*!40000 ALTER TABLE `print_categories` DISABLE KEYS */;
/*!40000 ALTER TABLE `print_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `printorder`
--

DROP TABLE IF EXISTS `printorder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `printorder` (
  `id_printorder` int(11) NOT NULL default '0',
  `id_customer` int(11) NOT NULL default '0',
  `id_printorder_main` int(11) NOT NULL default '0',
  `linenum` int(3) NOT NULL default '0',
  `id_worksubtype` int(11) NOT NULL default '0',
  `description` varchar(250) NOT NULL default '',
  `destination_partnr` varchar(30) default NULL,
  `order_quantity` int(14) NOT NULL default '0',
  `order_type` int(2) NOT NULL default '0',
  `vendall` int(1) NOT NULL default '0',
  `order_class` int(2) NOT NULL default '0',
  `status` int(2) NOT NULL default '0',
  `approvedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `duedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `finalshipdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `pricedate` date NOT NULL default '0000-00-00',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  `numperunit` int(5) NOT NULL default '1',
  `totalpages` int(5) NOT NULL default '1',
  `unitname` varchar(10) NOT NULL default 'Sheet',
  `instructions` blob NOT NULL,
  `priority` int(2) NOT NULL default '0',
  `estimated_price` decimal(15,2) NOT NULL default '0.00',
  `estimated_cost` decimal(15,2) NOT NULL default '0.00',
  `actual_price` decimal(15,2) NOT NULL default '0.00',
  `final_width` decimal(10,4) NOT NULL default '0.0000',
  `final_length` decimal(10,4) NOT NULL default '0.0000',
  `who_ok_price` varchar(10) NOT NULL default '',
  `id_latereason` int(11) NOT NULL default '0',
  `enter_initials` char(3) NOT NULL default '',
  `del_initials` char(3) NOT NULL default '',
  `bill_sent` int(2) NOT NULL default '0',
  `bill_month` char(2) NOT NULL default '',
  `bill_year` varchar(4) NOT NULL default '',
  `shiptotal` decimal(14,2) NOT NULL default '0.00',
  `vend_est_total` decimal(14,2) NOT NULL default '0.00',
  `qc_initials` varchar(5) NOT NULL default '',
  `fulldetails` varchar(250) NOT NULL default '""',
  `pickup` int(2) NOT NULL default '0',
  `internalorder` int(2) NOT NULL default '0',
  `mailroom` varchar(5) NOT NULL default '',
  `cliententry` int(11) NOT NULL default '0',
  `id_originals` int(11) NOT NULL default '0',
  `proof` int(2) NOT NULL default '0',
  `quote` int(2) NOT NULL default '0',
  `id_gencompany` int(11) NOT NULL default '0',
  `Graphics_initials` varchar(10) default NULL,
  `Graphics_completedate` datetime default '0000-00-00 00:00:00',
  `Shipping_initials` varchar(10) default NULL,
  `Shipping_completedate` datetime default '0000-00-00 00:00:00',
  `Prepress_initials` varchar(255) default NULL,
  `Prepress_completedate` datetime default '0000-00-00 00:00:00',
  `Press_initials` varchar(255) default NULL,
  `Press_completedate` datetime default '0000-00-00 00:00:00',
  `Digital_Print_initials` varchar(255) default NULL,
  `Digital_Print_completedate` datetime default '0000-00-00 00:00:00',
  `Bindery_initials` varchar(255) default NULL,
  `Bindery_completedate` datetime default '0000-00-00 00:00:00',
  `Outside_Vended_initials` varchar(255) default NULL,
  `Outside_Vended_completedate` datetime default '0000-00-00 00:00:00',
  `Paper_initials` varchar(10) default NULL,
  `Paper_completedate` datetime default '0000-00-00 00:00:00',
  `customer_po` varchar(50) default NULL,
  `multiquotestatus` int(11) NOT NULL default '0',
  `notes` varchar(255) default NULL,
  `orientation` varchar(20) default NULL,
  `quotedesc` text,
  `reprint` int(5) NOT NULL default '0',
  `extrafield1` varchar(255) default NULL,
  `extrafield2` varchar(255) default NULL,
  `extrafield3` varchar(255) default NULL,
  `extrafield4` varchar(255) default NULL,
  `contactname` varchar(255) default NULL,
  `contactphone` varchar(255) default NULL,
  `currency` varchar(5) NOT NULL default 'USD',
  `currate` decimal(22,10) NOT NULL default '1.0000000000',
  PRIMARY KEY  (`id_printorder`),
  UNIQUE KEY `id_printorder` (`id_printorder`),
  KEY `id_customer` (`id_customer`),
  KEY `destination_partnr` (`destination_partnr`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='InnoDB free: 44032 kB';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `printorder`
--

LOCK TABLES `printorder` WRITE;
/*!40000 ALTER TABLE `printorder` DISABLE KEYS */;
/*!40000 ALTER TABLE `printorder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `printorder_misc`
--

DROP TABLE IF EXISTS `printorder_misc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `printorder_misc` (
  `id_printorder` int(11) NOT NULL default '0',
  `shipqty1` int(11) default '0',
  `shipdate1` datetime default '0000-00-00 00:00:00',
  `shipqty2` int(11) default '0',
  `shipdate2` datetime default '0000-00-00 00:00:00',
  `shipqty3` int(11) default '0',
  `shipdate3` datetime default '0000-00-00 00:00:00',
  `shipqty4` int(11) default '0',
  `shipdate4` datetime default '0000-00-00 00:00:00',
  `shipqty5` int(11) default '0',
  `shipdate5` datetime default '0000-00-00 00:00:00',
  `orientation` varchar(50) default '',
  `quote_desc` blob
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `printorder_misc`
--

LOCK TABLES `printorder_misc` WRITE;
/*!40000 ALTER TABLE `printorder_misc` DISABLE KEYS */;
/*!40000 ALTER TABLE `printorder_misc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `printorder_shipsched`
--

DROP TABLE IF EXISTS `printorder_shipsched`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `printorder_shipsched` (
  `id` int(11) NOT NULL auto_increment,
  `id_printorder` int(11) NOT NULL default '0',
  `id_printorder_shipto` int(11) NOT NULL default '0',
  `qty` int(11) NOT NULL default '0',
  `shipdate` date default NULL,
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `id_printorder` (`id_printorder`),
  KEY `id_printorder_shipto` (`id_printorder_shipto`),
  KEY `shipdate` (`shipdate`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `printorder_shipsched`
--

LOCK TABLES `printorder_shipsched` WRITE;
/*!40000 ALTER TABLE `printorder_shipsched` DISABLE KEYS */;
/*!40000 ALTER TABLE `printorder_shipsched` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `printorder_shipto`
--

DROP TABLE IF EXISTS `printorder_shipto`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `printorder_shipto` (
  `id_printorder_shipto` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `attn` varchar(50) default NULL,
  `quantity` int(11) NOT NULL default '0',
  `id_delivery` int(11) NOT NULL default '0',
  `id_shipto` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `shiptoname` varchar(255) default NULL,
  `shiptoaddress` varchar(255) default NULL,
  `shiptoaddress2` varchar(255) default NULL,
  `shiptocity` varchar(50) default NULL,
  `shiptostate` varchar(20) default NULL,
  `shiptozip` varchar(15) default NULL,
  `shiptophone` varchar(20) default NULL,
  `shipfromname` varchar(255) default NULL,
  `shipfromaddress` varchar(255) default NULL,
  `shipfromaddress2` varchar(255) default NULL,
  `shipfromcity` varchar(50) default NULL,
  `shipfromstate` varchar(20) default NULL,
  `shipfromzip` varchar(15) default NULL,
  PRIMARY KEY  (`id_printorder_shipto`),
  KEY `id_printorder` (`id_printorder`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `printorder_shipto`
--

LOCK TABLES `printorder_shipto` WRITE;
/*!40000 ALTER TABLE `printorder_shipto` DISABLE KEYS */;
/*!40000 ALTER TABLE `printorder_shipto` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `printorder_shiptoseq`
--

DROP TABLE IF EXISTS `printorder_shiptoseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `printorder_shiptoseq` (
  `id` int(11) NOT NULL default '1'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `printorder_shiptoseq`
--

LOCK TABLES `printorder_shiptoseq` WRITE;
/*!40000 ALTER TABLE `printorder_shiptoseq` DISABLE KEYS */;
INSERT INTO `printorder_shiptoseq` VALUES (0);
/*!40000 ALTER TABLE `printorder_shiptoseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `printorder_workarea`
--

DROP TABLE IF EXISTS `printorder_workarea`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `printorder_workarea` (
  `id` int(11) NOT NULL default '0',
  `id_printorder` int(11) NOT NULL default '0',
  `id_workarea` int(11) NOT NULL default '0',
  `completedate` datetime default NULL,
  `initials` varchar(5) default NULL,
  PRIMARY KEY  (`id`),
  KEY `id_printorder` (`id_printorder`),
  KEY `id_workarea` (`id_workarea`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `printorder_workarea`
--

LOCK TABLES `printorder_workarea` WRITE;
/*!40000 ALTER TABLE `printorder_workarea` DISABLE KEYS */;
/*!40000 ALTER TABLE `printorder_workarea` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `printorder_workareaseq`
--

DROP TABLE IF EXISTS `printorder_workareaseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `printorder_workareaseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `printorder_workareaseq`
--

LOCK TABLES `printorder_workareaseq` WRITE;
/*!40000 ALTER TABLE `printorder_workareaseq` DISABLE KEYS */;
INSERT INTO `printorder_workareaseq` VALUES (0);
/*!40000 ALTER TABLE `printorder_workareaseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `printorderseq`
--

DROP TABLE IF EXISTS `printorderseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `printorderseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `printorderseq`
--

LOCK TABLES `printorderseq` WRITE;
/*!40000 ALTER TABLE `printorderseq` DISABLE KEYS */;
INSERT INTO `printorderseq` VALUES (0);
/*!40000 ALTER TABLE `printorderseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prleavereq`
--

DROP TABLE IF EXISTS `prleavereq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prleavereq` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `paytype` int(11) NOT NULL default '0',
  `startdate` datetime NOT NULL,
  `enddate` datetime NOT NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `mrgapprove_userid` int(11) NOT NULL default '0',
  `mrgapprove_date` datetime default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  PRIMARY KEY  (`id`),
  KEY `employeeid` (`employeeid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prleavereq`
--

LOCK TABLES `prleavereq` WRITE;
/*!40000 ALTER TABLE `prleavereq` DISABLE KEYS */;
/*!40000 ALTER TABLE `prleavereq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prlocal`
--

DROP TABLE IF EXISTS `prlocal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prlocal` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `abrev` char(3) NOT NULL default '',
  `name` char(30) NOT NULL default '',
  `taxnum` char(20) NOT NULL default '0',
  `deductfed` int(11) NOT NULL default '0',
  `feddeductmax` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `glacctid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `maxexemptpercent` decimal(5,2) NOT NULL default '0.00',
  `maxexemptyear` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt1` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt2` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt3` decimal(19,4) NOT NULL default '0.0000',
  `taxcreditexempt4` decimal(19,4) NOT NULL default '0.0000',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `round_tax` int(2) NOT NULL default '0',
  `mexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `taxyear` int(4) NOT NULL default '2007',
  `mainrec` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prlocal`
--

LOCK TABLES `prlocal` WRITE;
/*!40000 ALTER TABLE `prlocal` DISABLE KEYS */;
/*!40000 ALTER TABLE `prlocal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prlocaldetail`
--

DROP TABLE IF EXISTS `prlocaldetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prlocaldetail` (
  `id` int(11) NOT NULL auto_increment,
  `prlocalid` int(11) NOT NULL default '0',
  `maritalstatus` int(11) NOT NULL default '0',
  `deductiontable` int(11) NOT NULL default '0',
  `tax` decimal(19,4) NOT NULL default '0.0000',
  `percent` decimal(8,4) NOT NULL default '0.0000',
  `over` decimal(19,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prlocaldetail`
--

LOCK TABLES `prlocaldetail` WRITE;
/*!40000 ALTER TABLE `prlocaldetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `prlocaldetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prntax_category`
--

DROP TABLE IF EXISTS `prntax_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prntax_category` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `glaccountid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `taxable` int(5) NOT NULL default '0',
  `sortorder` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `glaccountid` (`glaccountid`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prntax_category`
--

LOCK TABLES `prntax_category` WRITE;
/*!40000 ALTER TABLE `prntax_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `prntax_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `processqueue`
--

DROP TABLE IF EXISTS `processqueue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `processqueue` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `suspendeduntil` datetime NOT NULL,
  `tag` varchar(128) NOT NULL default '',
  `started` tinyint(1) NOT NULL default '0',
  `action` varchar(255) NOT NULL,
  `data` longtext NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `processstarted` datetime NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `active` (`gencompanyid`,`suspendeduntil`,`started`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `processqueue`
--

LOCK TABLES `processqueue` WRITE;
/*!40000 ALTER TABLE `processqueue` DISABLE KEYS */;
INSERT INTO `processqueue` VALUES (3,0,'0000-00-00 00:00:00','',0,'','',0,'0000-00-00 00:00:00','0000-00-00 00:00:00'),(4,0,'0000-00-00 00:00:00','',0,'','',0,'0000-00-00 00:00:00','0000-00-00 00:00:00');
/*!40000 ALTER TABLE `processqueue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `processqueuelog`
--

DROP TABLE IF EXISTS `processqueuelog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `processqueuelog` (
  `id` int(11) NOT NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `suspendeduntil` datetime NOT NULL,
  `tag` varchar(128) NOT NULL default '',
  `action` varchar(255) NOT NULL,
  `data` longtext NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `processstarted` datetime NOT NULL,
  `processscompleted` datetime NOT NULL,
  `elapsedtimespan` int(11) NOT NULL default '0',
  `status` tinyint(1) NOT NULL default '0',
  `errormessage` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `active` (`gencompanyid`),
  KEY `tag` (`tag`,`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `processqueuelog`
--

LOCK TABLES `processqueuelog` WRITE;
/*!40000 ALTER TABLE `processqueuelog` DISABLE KEYS */;
INSERT INTO `processqueuelog` VALUES (1,0,'0000-00-00 00:00:00','','','',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,0,''),(2,0,'0000-00-00 00:00:00','','','',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,0,'');
/*!40000 ALTER TABLE `processqueuelog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `products_attributes`
--

DROP TABLE IF EXISTS `products_attributes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `products_attributes` (
  `products_attributes_id` int(5) NOT NULL auto_increment,
  `products_id` int(5) NOT NULL default '0',
  `options_id` int(5) NOT NULL default '0',
  `options_values_id` int(5) NOT NULL default '0',
  `options_values_price` decimal(8,2) NOT NULL default '0.00',
  `price_prefix` char(1) NOT NULL default '',
  PRIMARY KEY  (`products_attributes_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `products_attributes`
--

LOCK TABLES `products_attributes` WRITE;
/*!40000 ALTER TABLE `products_attributes` DISABLE KEYS */;
/*!40000 ALTER TABLE `products_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `products_expected`
--

DROP TABLE IF EXISTS `products_expected`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `products_expected` (
  `products_expected_id` int(5) NOT NULL auto_increment,
  `products_name` varchar(255) NOT NULL default '',
  `date_expected` varchar(8) default NULL,
  PRIMARY KEY  (`products_expected_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `products_expected`
--

LOCK TABLES `products_expected` WRITE;
/*!40000 ALTER TABLE `products_expected` DISABLE KEYS */;
/*!40000 ALTER TABLE `products_expected` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `products_options`
--

DROP TABLE IF EXISTS `products_options`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `products_options` (
  `products_options_id` int(5) NOT NULL auto_increment,
  `products_options_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`products_options_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `products_options`
--

LOCK TABLES `products_options` WRITE;
/*!40000 ALTER TABLE `products_options` DISABLE KEYS */;
/*!40000 ALTER TABLE `products_options` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `products_options_values`
--

DROP TABLE IF EXISTS `products_options_values`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `products_options_values` (
  `products_options_values_id` int(5) NOT NULL auto_increment,
  `products_options_values_name` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`products_options_values_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `products_options_values`
--

LOCK TABLES `products_options_values` WRITE;
/*!40000 ALTER TABLE `products_options_values` DISABLE KEYS */;
/*!40000 ALTER TABLE `products_options_values` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `products_options_values_to_products_options`
--

DROP TABLE IF EXISTS `products_options_values_to_products_options`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `products_options_values_to_products_options` (
  `products_options_values_to_products_options_id` int(5) NOT NULL auto_increment,
  `products_options_id` int(5) NOT NULL default '0',
  `products_options_values_id` int(5) NOT NULL default '0',
  PRIMARY KEY  (`products_options_values_to_products_options_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `products_options_values_to_products_options`
--

LOCK TABLES `products_options_values_to_products_options` WRITE;
/*!40000 ALTER TABLE `products_options_values_to_products_options` DISABLE KEYS */;
/*!40000 ALTER TABLE `products_options_values_to_products_options` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `producttypetax`
--

DROP TABLE IF EXISTS `producttypetax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `producttypetax` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `taxrate` decimal(12,6) NOT NULL default '0.000000',
  `glaccountid` int(11) NOT NULL default '0',
  `states` text,
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `producttypetax`
--

LOCK TABLES `producttypetax` WRITE;
/*!40000 ALTER TABLE `producttypetax` DISABLE KEYS */;
/*!40000 ALTER TABLE `producttypetax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project`
--

DROP TABLE IF EXISTS `project`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project` (
  `id` int(11) NOT NULL auto_increment,
  `projectname` varchar(255) NOT NULL default '',
  `projectcode` varchar(20) NOT NULL default '',
  `siteid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `deal` text,
  `groundbreakingdate` date default NULL,
  `land_and_entitlements` text,
  `lande_contacts` text,
  `lande_permits` text,
  `lande_other` text,
  `improvements_description` text,
  `improvements_building_plans` text,
  `improvements_phases` text,
  `improvements_quotes` text,
  `feasibility_mktresearch` text,
  `feasibility_mktplans` text,
  `address` text,
  `projecttemplateid` int(11) NOT NULL default '0',
  `project_total` decimal(19,5) NOT NULL default '0.00000',
  `commission1_percent` decimal(4,2) NOT NULL default '0.00',
  `commission1_vendorid` int(11) NOT NULL default '0',
  `commission2_percent` decimal(4,2) NOT NULL default '0.00',
  `commission2_vendorid` int(11) NOT NULL default '0',
  `salestax1_id` int(11) NOT NULL default '0',
  `salestax1_percent` decimal(4,2) NOT NULL default '0.00',
  `salestax1_glacctid` int(11) NOT NULL default '0',
  `salestax2_id` int(11) NOT NULL default '0',
  `salestax2_percent` decimal(4,2) NOT NULL default '0.00',
  `salestax2_glacctid` int(11) NOT NULL default '0',
  `salestax3_id` int(11) NOT NULL default '0',
  `salestax3_percent` decimal(4,2) NOT NULL default '0.00',
  `salestax3_glacctid` int(11) NOT NULL default '0',
  `othertax_name` varchar(20) NOT NULL default '0',
  `othertax_percent` decimal(4,2) NOT NULL default '0.00',
  `othertax_glacctid` int(11) NOT NULL default '0',
  `numweeks` int(5) NOT NULL default '0',
  `status` int(5) NOT NULL default '0',
  `glacctid_income` int(11) NOT NULL default '0',
  `glacctid_cogs` int(11) NOT NULL default '0',
  `glacctid_commission1` int(11) NOT NULL default '0',
  `glacctid_commission2` int(11) NOT NULL default '0',
  `othertax_client_percent` decimal(10,2) NOT NULL default '0.00',
  `startdate` date default NULL,
  `voucherid` int(11) NOT NULL default '0',
  `alt_currency` int(5) NOT NULL default '0',
  `storyedit` varchar(75) default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NULL default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `client` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `vendorid` (`vendorid`),
  KEY `customerid` (`customerid`),
  KEY `cancel` (`cancel`),
  KEY `status` (`status`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `siteid` (`siteid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project`
--

LOCK TABLES `project` WRITE;
/*!40000 ALTER TABLE `project` DISABLE KEYS */;
/*!40000 ALTER TABLE `project` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `projectdetail`
--

DROP TABLE IF EXISTS `projectdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `projectdetail` (
  `id` int(11) NOT NULL auto_increment,
  `projectid` int(11) NOT NULL default '0',
  `description` varchar(255) default NULL,
  `description2` varchar(255) default NULL,
  `description3` varchar(255) default NULL,
  `amount` decimal(19,5) NOT NULL default '0.00000',
  `percent_of_total` decimal(5,2) NOT NULL default '0.00',
  `salestax1_amount` decimal(19,5) NOT NULL default '0.00000',
  `salestax2_amount` decimal(19,5) NOT NULL default '0.00000',
  `salestax3_amount` decimal(19,5) NOT NULL default '0.00000',
  `othertax_amount` decimal(19,5) NOT NULL default '0.00000',
  `commission1_checkid` int(11) NOT NULL default '0',
  `commission2_checkid` int(11) NOT NULL default '0',
  `client_checkid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `commission1_apbillid` int(11) NOT NULL default '0',
  `commission2_apbillid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `projectid` (`projectid`),
  KEY `commission1_checkid` (`commission1_checkid`),
  KEY `commission2_checkid` (`commission2_checkid`),
  KEY `client_checkid` (`client_checkid`),
  KEY `invoiceid` (`invoiceid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `projectdetail`
--

LOCK TABLES `projectdetail` WRITE;
/*!40000 ALTER TABLE `projectdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `projectdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `projectexpenses`
--

DROP TABLE IF EXISTS `projectexpenses`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `projectexpenses` (
  `id` int(11) NOT NULL auto_increment,
  `projectid` int(11) NOT NULL default '0',
  `amount` decimal(19,5) NOT NULL default '0.00000',
  `checkid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `projectid` (`projectid`),
  KEY `checkid` (`checkid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `projectexpenses`
--

LOCK TABLES `projectexpenses` WRITE;
/*!40000 ALTER TABLE `projectexpenses` DISABLE KEYS */;
/*!40000 ALTER TABLE `projectexpenses` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `projectgen`
--

DROP TABLE IF EXISTS `projectgen`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `projectgen` (
  `id` int(11) NOT NULL default '0',
  `default_checkacctid` int(11) NOT NULL default '0',
  `trusttransfer_glacctid` int(11) NOT NULL default '0',
  `gst_commission_alt_glacctid` int(11) NOT NULL default '0',
  `payables_glacctid` int(11) NOT NULL default '0',
  `payables_alt_glacctid` int(11) NOT NULL default '0',
  `trusttransfer_alt_glacctid` int(11) NOT NULL default '0',
  `default_alt_checkacctid` int(11) NOT NULL default '0',
  `receivables_glacctid` int(11) NOT NULL default '0',
  `receivables_alt_glacctid` int(11) NOT NULL default '0',
  `payables_trust_glacctid` int(11) NOT NULL default '0',
  `payables_trust_alt_glacctid` int(11) NOT NULL default '0',
  `commission_income_glacctid` int(11) NOT NULL default '0',
  `commission_income_alt_glacctid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `projectgen`
--

LOCK TABLES `projectgen` WRITE;
/*!40000 ALTER TABLE `projectgen` DISABLE KEYS */;
/*!40000 ALTER TABLE `projectgen` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `projectinvoice`
--

DROP TABLE IF EXISTS `projectinvoice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `projectinvoice` (
  `id` int(11) NOT NULL auto_increment,
  `projectid` int(11) NOT NULL default '0',
  `projectdetailid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `projectid` (`projectid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `projectdetailid` (`projectdetailid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `projectinvoice`
--

LOCK TABLES `projectinvoice` WRITE;
/*!40000 ALTER TABLE `projectinvoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `projectinvoice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `projectpayment`
--

DROP TABLE IF EXISTS `projectpayment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `projectpayment` (
  `id` int(11) NOT NULL auto_increment,
  `checkid` int(11) NOT NULL default '0',
  `projectid` int(11) NOT NULL default '0',
  `projectdetailid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `checkid` (`checkid`),
  KEY `projectid` (`projectid`),
  KEY `projectdetailid` (`projectdetailid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `projectpayment`
--

LOCK TABLES `projectpayment` WRITE;
/*!40000 ALTER TABLE `projectpayment` DISABLE KEYS */;
/*!40000 ALTER TABLE `projectpayment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `projecttemplate`
--

DROP TABLE IF EXISTS `projecttemplate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `projecttemplate` (
  `id` int(11) NOT NULL auto_increment,
  `templatename` varchar(255) default NULL,
  `commission1_percent` decimal(4,2) NOT NULL default '0.00',
  `commission1_vendorid` int(11) NOT NULL default '0',
  `commission2_percent` decimal(4,2) NOT NULL default '0.00',
  `commission2_vendorid` int(11) NOT NULL default '0',
  `salestax1_id` int(11) NOT NULL default '0',
  `salestax1_percent` decimal(4,2) NOT NULL default '0.00',
  `salestax1_glacctid` int(11) NOT NULL default '0',
  `salestax2_id` int(11) NOT NULL default '0',
  `salestax2_percent` decimal(4,2) NOT NULL default '0.00',
  `salestax2_glacctid` int(11) NOT NULL default '0',
  `salestax3_id` int(11) NOT NULL default '0',
  `salestax3_percent` decimal(4,2) NOT NULL default '0.00',
  `salestax3_glacctid` int(11) NOT NULL default '0',
  `othertax_name` varchar(20) NOT NULL default '0',
  `othertax_percent` decimal(4,2) NOT NULL default '0.00',
  `othertax_glacctid` int(11) NOT NULL default '0',
  `weekly` int(5) NOT NULL default '0',
  `glacctid_income` int(11) NOT NULL default '0',
  `glacctid_cogs` int(11) NOT NULL default '0',
  `glacctid_commission1` int(11) NOT NULL default '0',
  `glacctid_commission2` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NULL default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `customdays` int(5) NOT NULL default '0',
  `othertax_client_percent` decimal(10,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `projecttemplate`
--

LOCK TABLES `projecttemplate` WRITE;
/*!40000 ALTER TABLE `projecttemplate` DISABLE KEYS */;
/*!40000 ALTER TABLE `projecttemplate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `projecttemplatedetail`
--

DROP TABLE IF EXISTS `projecttemplatedetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `projecttemplatedetail` (
  `id` int(11) NOT NULL auto_increment,
  `projecttemplateid` int(11) NOT NULL default '0',
  `description` varchar(255) default NULL,
  `description2` varchar(255) default NULL,
  `description3` varchar(255) default NULL,
  `percent_of_total` decimal(4,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`),
  KEY `projecttemplateid` (`projecttemplateid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `projecttemplatedetail`
--

LOCK TABLES `projecttemplatedetail` WRITE;
/*!40000 ALTER TABLE `projecttemplatedetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `projecttemplatedetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prpaychange`
--

DROP TABLE IF EXISTS `prpaychange`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prpaychange` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `oldpay` decimal(19,4) NOT NULL default '0.0000',
  `newpay` decimal(19,4) NOT NULL default '0.0000',
  `paystartdate` date NOT NULL default '0000-00-00',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prpaychange`
--

LOCK TABLES `prpaychange` WRITE;
/*!40000 ALTER TABLE `prpaychange` DISABLE KEYS */;
/*!40000 ALTER TABLE `prpaychange` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prpaytype`
--

DROP TABLE IF EXISTS `prpaytype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prpaytype` (
  `id` int(11) NOT NULL auto_increment,
  `name` char(6) NOT NULL default '',
  `description` char(40) NOT NULL default '',
  `multiplier` decimal(5,2) NOT NULL default '1.00',
  `vacation` int(11) NOT NULL default '0',
  `sick` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `exclude_from_hours_worked` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prpaytype`
--

LOCK TABLES `prpaytype` WRITE;
/*!40000 ALTER TABLE `prpaytype` DISABLE KEYS */;
INSERT INTO `prpaytype` VALUES (1,'ST','Straight Time','1.00',0,0,1,0),(2,'OT','Overtime','1.50',0,0,1,0),(3,'HP','Holiday Pay','1.00',0,0,1,0),(4,'ST','Straight Time','1.00',0,0,0,0),(5,'OT','Overtime','1.50',0,0,0,0),(6,'HP','Holiday Pay','1.00',0,0,0,0),(7,'DT','Double Time','2.00',0,0,1,0),(8,'VAC','Vacation','1.00',1,0,1,0),(9,'SL','Sick Leave','1.00',0,1,1,0),(10,'PL','Personal Leave','1.00',0,0,1,0),(11,'DT','Double Time','2.00',0,0,0,0),(12,'VAC','Vacation','1.00',1,0,0,0),(13,'SL','Sick Leave','1.00',0,1,0,0),(14,'PL','Personal Leave','1.00',0,0,0,0);
/*!40000 ALTER TABLE `prpaytype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prpension`
--

DROP TABLE IF EXISTS `prpension`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prpension` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `name` char(30) NOT NULL default '',
  `w2plantype` int(11) NOT NULL default '0',
  `w2plansubtype` char(2) default NULL,
  `employercontribhow` int(11) NOT NULL default '0',
  `employercontribute` decimal(8,4) NOT NULL default '0.0000',
  `employermaxmatchpercent` decimal(8,4) NOT NULL default '0.0000',
  `mustbeinplan` int(11) NOT NULL default '0',
  `calcbasis` int(11) NOT NULL default '3',
  `prdedgroupid` double NOT NULL default '0',
  `paytype` int(11) NOT NULL default '0',
  `payableglacctid` int(11) NOT NULL default '0',
  `expenseglacctid` int(11) NOT NULL default '0',
  `federalincometax` int(11) NOT NULL default '0',
  `stateincometax` int(11) NOT NULL default '0',
  `localincometax` int(11) NOT NULL default '0',
  `cityincometax` int(11) NOT NULL default '0',
  `employeefica` int(11) NOT NULL default '0',
  `companyfica` int(11) NOT NULL default '0',
  `fui` int(11) NOT NULL default '0',
  `sui` int(11) NOT NULL default '0',
  `workmanscomp` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `employeronly_percent` decimal(12,2) NOT NULL default '0.00',
  `employermaxmatchpercent_uptopercent` decimal(12,2) NOT NULL default '0.00',
  `employermaxmatchpercent2` decimal(12,2) NOT NULL default '0.00',
  `employermaxmatchpercent2_uptopercent` decimal(12,2) NOT NULL default '0.00',
  `w2retirementbox` int(2) NOT NULL default '0',
  `notSpecialPeriod` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prpension`
--

LOCK TABLES `prpension` WRITE;
/*!40000 ALTER TABLE `prpension` DISABLE KEYS */;
/*!40000 ALTER TABLE `prpension` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prperiod`
--

DROP TABLE IF EXISTS `prperiod`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prperiod` (
  `id` int(11) NOT NULL auto_increment,
  `numperyear` int(11) NOT NULL default '52',
  `name` char(15) NOT NULL default '',
  `strname` varchar(30) default NULL,
  `startday` int(5) NOT NULL default '1',
  `startday2` int(5) NOT NULL default '15',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prperiod`
--

LOCK TABLES `prperiod` WRITE;
/*!40000 ALTER TABLE `prperiod` DISABLE KEYS */;
INSERT INTO `prperiod` VALUES (1,52,'Weekly','STR_WEEKLY_PERIOD',1,15),(2,26,'Bi-Weekly','STR_BIWEEKLY_PERIOD',1,15),(3,24,'Semi-Monthly','STR_SEMIMONTHLY_PERIOD',1,15),(4,12,'Monthly','STR_MONTHLY_PERIOD',1,15);
/*!40000 ALTER TABLE `prperiod` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prreimburse`
--

DROP TABLE IF EXISTS `prreimburse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prreimburse` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `jobid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `arorderid` int(11) NOT NULL default '0',
  `mgrapprove_userid` int(11) NOT NULL default '0',
  `mgrapprove_date` datetime default NULL,
  `accountapprove_userid` int(11) NOT NULL default '0',
  `acctapprove_date` datetime default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `adp` int(5) NOT NULL default '0',
  `premplweekid` int(11) NOT NULL default '0',
  `notes` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  KEY `employeeid` (`employeeid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prreimburse`
--

LOCK TABLES `prreimburse` WRITE;
/*!40000 ALTER TABLE `prreimburse` DISABLE KEYS */;
/*!40000 ALTER TABLE `prreimburse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prstate`
--

DROP TABLE IF EXISTS `prstate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prstate` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `genstateid` int(11) NOT NULL default '0',
  `taxnum` char(20) default NULL,
  `suipercent` decimal(8,4) NOT NULL default '0.0000',
  `suimax` decimal(10,2) NOT NULL default '0.00',
  `deductfed` int(11) NOT NULL default '0',
  `feddeductmax` decimal(10,2) NOT NULL default '0.00',
  `exemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `glacctid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `maxexemptpercent` decimal(8,4) default '0.0000',
  `maxexemptyear` decimal(10,2) default '0.00',
  `taxcreditexempt1` decimal(10,2) NOT NULL default '0.00',
  `taxcreditexempt2` decimal(10,2) NOT NULL default '0.00',
  `taxcreditexempt3` decimal(10,2) NOT NULL default '0.00',
  `taxcreditexempt4` decimal(10,2) NOT NULL default '0.00',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `mexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr1` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr2` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr3` decimal(19,4) NOT NULL default '0.0000',
  `hexemptyr4` decimal(19,4) NOT NULL default '0.0000',
  `round_tax` int(2) NOT NULL default '0',
  `hexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `mexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `jexemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `exemptyr0` decimal(19,4) NOT NULL default '0.0000',
  `sui_vendorid` int(11) NOT NULL default '0',
  `taxyear` int(4) NOT NULL default '2007',
  `mainrec` int(11) NOT NULL default '0',
  `sdiFlatAmount` decimal(19,5) NOT NULL default '0.00000',
  `sdiamount1` decimal(19,5) NOT NULL default '0.00000',
  `sdipercent1` decimal(8,3) NOT NULL default '0.000',
  `sdiover1` decimal(19,5) NOT NULL default '0.00000',
  `sdiamount2` decimal(19,5) NOT NULL default '0.00000',
  `sdipercent2` decimal(8,3) NOT NULL default '0.000',
  `sdiover2` decimal(19,5) NOT NULL default '0.00000',
  `sdiamount3` decimal(19,5) NOT NULL default '0.00000',
  `sdipercent3` decimal(8,3) NOT NULL default '0.000',
  `sdiover3` decimal(19,5) NOT NULL default '0.00000',
  `sdiamount4` decimal(19,5) NOT NULL default '0.00000',
  `sdipercent4` decimal(8,3) NOT NULL default '0.000',
  `sdiover4` decimal(19,5) NOT NULL default '0.00000',
  `deductionAsPercentFederal` decimal(8,3) NOT NULL default '0.000',
  `sdiGlacct` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `genstateid` (`genstateid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prstate`
--

LOCK TABLES `prstate` WRITE;
/*!40000 ALTER TABLE `prstate` DISABLE KEYS */;
/*!40000 ALTER TABLE `prstate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prstatedetail`
--

DROP TABLE IF EXISTS `prstatedetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prstatedetail` (
  `id` int(11) NOT NULL auto_increment,
  `prstateid` int(11) NOT NULL default '0',
  `maritalstatus` int(11) NOT NULL default '0',
  `deductiontable` int(11) NOT NULL default '0',
  `tax` decimal(10,2) NOT NULL default '0.00',
  `percent` decimal(8,4) NOT NULL default '0.0000',
  `over` decimal(10,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prstatedetail`
--

LOCK TABLES `prstatedetail` WRITE;
/*!40000 ALTER TABLE `prstatedetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `prstatedetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prt_orientation`
--

DROP TABLE IF EXISTS `prt_orientation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prt_orientation` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prt_orientation`
--

LOCK TABLES `prt_orientation` WRITE;
/*!40000 ALTER TABLE `prt_orientation` DISABLE KEYS */;
/*!40000 ALTER TABLE `prt_orientation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prtimeoff`
--

DROP TABLE IF EXISTS `prtimeoff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prtimeoff` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `startdate` date default NULL,
  `enddate` date default NULL,
  `reason` text,
  `entrydate` datetime default NULL,
  `manager_approved` int(5) NOT NULL default '0',
  `manager_approve_date` datetime default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `employeeid` (`employeeid`),
  KEY `startdate` (`startdate`),
  KEY `manager_approved` (`manager_approved`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prtimeoff`
--

LOCK TABLES `prtimeoff` WRITE;
/*!40000 ALTER TABLE `prtimeoff` DISABLE KEYS */;
/*!40000 ALTER TABLE `prtimeoff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prtlocation`
--

DROP TABLE IF EXISTS `prtlocation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prtlocation` (
  `id` int(11) NOT NULL auto_increment,
  `companyname` varchar(35) default NULL,
  `address1` varchar(100) default NULL,
  `address2` varchar(100) default NULL,
  `mailstop` varchar(20) default NULL,
  `city` varchar(50) default NULL,
  `state` varchar(20) default NULL,
  `zip` varchar(15) default NULL,
  `country` varchar(20) default NULL,
  `phone1` varchar(20) default NULL,
  `phone1comment` varchar(20) default NULL,
  `phone2` varchar(20) default NULL,
  `phone2comment` varchar(20) default NULL,
  `phone3` varchar(20) default NULL,
  `phone3comment` varchar(20) default NULL,
  `phone4` varchar(20) default NULL,
  `phone4comment` varchar(20) default NULL,
  `email1` varchar(50) default NULL,
  `email1comment` varchar(20) default NULL,
  `email2` varchar(50) default NULL,
  `email2comment` varchar(50) default NULL,
  `website` varchar(100) default NULL,
  `federalid` varchar(20) default NULL,
  `cancel` int(2) default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prtlocation`
--

LOCK TABLES `prtlocation` WRITE;
/*!40000 ALTER TABLE `prtlocation` DISABLE KEYS */;
/*!40000 ALTER TABLE `prtlocation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prtlocationseq`
--

DROP TABLE IF EXISTS `prtlocationseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prtlocationseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prtlocationseq`
--

LOCK TABLES `prtlocationseq` WRITE;
/*!40000 ALTER TABLE `prtlocationseq` DISABLE KEYS */;
INSERT INTO `prtlocationseq` VALUES (0);
/*!40000 ALTER TABLE `prtlocationseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prttempseq`
--

DROP TABLE IF EXISTS `prttempseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prttempseq` (
  `id` int(11) NOT NULL default '1'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prttempseq`
--

LOCK TABLES `prttempseq` WRITE;
/*!40000 ALTER TABLE `prttempseq` DISABLE KEYS */;
INSERT INTO `prttempseq` VALUES (1);
/*!40000 ALTER TABLE `prttempseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prvacation`
--

DROP TABLE IF EXISTS `prvacation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prvacation` (
  `id` int(11) NOT NULL auto_increment,
  `yrsbeforeaccrue` decimal(5,2) NOT NULL default '0.00',
  `vacdaysperyear` decimal(5,2) NOT NULL default '0.00',
  `maxaccrue` decimal(5,2) NOT NULL default '0.00',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prvacation`
--

LOCK TABLES `prvacation` WRITE;
/*!40000 ALTER TABLE `prvacation` DISABLE KEYS */;
/*!40000 ALTER TABLE `prvacation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prworkerscomp`
--

DROP TABLE IF EXISTS `prworkerscomp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prworkerscomp` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(45) NOT NULL default '',
  `name` varchar(100) NOT NULL default '',
  `percent` decimal(7,4) NOT NULL default '0.0000',
  `glaccountid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `code` (`code`),
  KEY `name` (`name`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prworkerscomp`
--

LOCK TABLES `prworkerscomp` WRITE;
/*!40000 ALTER TABLE `prworkerscomp` DISABLE KEYS */;
/*!40000 ALTER TABLE `prworkerscomp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `purchase_order_receiveseq`
--

DROP TABLE IF EXISTS `purchase_order_receiveseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `purchase_order_receiveseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `purchase_order_receiveseq`
--

LOCK TABLES `purchase_order_receiveseq` WRITE;
/*!40000 ALTER TABLE `purchase_order_receiveseq` DISABLE KEYS */;
INSERT INTO `purchase_order_receiveseq` VALUES (0);
/*!40000 ALTER TABLE `purchase_order_receiveseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `purchasetype`
--

DROP TABLE IF EXISTS `purchasetype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `purchasetype` (
  `id_purchasetype` int(11) NOT NULL default '0',
  `id_company` int(11) NOT NULL default '0',
  `name` varchar(20) NOT NULL default '',
  `createdate` date NOT NULL default '0000-00-00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default '0000-00-00 00:00:00',
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` date default NULL,
  `cancel` int(11) NOT NULL default '0',
  `include_in_internal_billing` int(2) NOT NULL default '0',
  PRIMARY KEY  (`id_purchasetype`),
  UNIQUE KEY `id_purchasetype` (`id_purchasetype`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `purchasetype`
--

LOCK TABLES `purchasetype` WRITE;
/*!40000 ALTER TABLE `purchasetype` DISABLE KEYS */;
/*!40000 ALTER TABLE `purchasetype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `purchasetypeseq`
--

DROP TABLE IF EXISTS `purchasetypeseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `purchasetypeseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `purchasetypeseq`
--

LOCK TABLES `purchasetypeseq` WRITE;
/*!40000 ALTER TABLE `purchasetypeseq` DISABLE KEYS */;
INSERT INTO `purchasetypeseq` VALUES (0);
/*!40000 ALTER TABLE `purchasetypeseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qbimport`
--

DROP TABLE IF EXISTS `qbimport`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `qbimport` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `module` varchar(45) NOT NULL default '',
  `status` int(11) NOT NULL default '0',
  `numrecords` int(10) unsigned NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qbimport`
--

LOCK TABLES `qbimport` WRITE;
/*!40000 ALTER TABLE `qbimport` DISABLE KEYS */;
/*!40000 ALTER TABLE `qbimport` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queries`
--

DROP TABLE IF EXISTS `queries`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `queries` (
  `id` int(11) NOT NULL auto_increment,
  `name` tinytext,
  `cancel` int(11) default '0',
  `from` text,
  `select` text,
  `join` text,
  `where` text,
  `icon_data` longblob,
  `icon_mime` varchar(16) default NULL,
  `icon_width` int(11) default '0',
  `icon_height` int(11) default '0',
  `menu_location` varchar(45) default NULL,
  `entryuserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `lastchangeuserid` int(11) default NULL,
  `lastchangedate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `canceldate` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=16 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queries`
--

LOCK TABLES `queries` WRITE;
/*!40000 ALTER TABLE `queries` DISABLE KEYS */;
/*!40000 ALTER TABLE `queries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question`
--

DROP TABLE IF EXISTS `question`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `question` (
  `id_question` int(11) NOT NULL default '0',
  `id_family` int(11) NOT NULL default '0',
  `id_responsetype` int(11) NOT NULL default '0',
  `question` varchar(100) NOT NULL default '',
  `unit_of_measure` varchar(10) NOT NULL default '',
  `displayorder` int(3) NOT NULL default '0',
  `internalonly` int(1) NOT NULL default '0',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  `donotshow_on_ticket` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id_question`),
  UNIQUE KEY `id_question` (`id_question`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `question`
--

LOCK TABLES `question` WRITE;
/*!40000 ALTER TABLE `question` DISABLE KEYS */;
/*!40000 ALTER TABLE `question` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question_calc`
--

DROP TABLE IF EXISTS `question_calc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `question_calc` (
  `id_question_calc` int(11) NOT NULL default '0',
  `id_question` int(11) NOT NULL default '0',
  `id_question_detail` int(11) NOT NULL default '0',
  `id_calcqty` int(11) NOT NULL default '0',
  `oneperjob` int(2) NOT NULL default '0',
  `id_item` int(11) NOT NULL default '0',
  `materialcost` decimal(10,4) NOT NULL default '0.0000',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `materialmarkup` decimal(10,2) NOT NULL default '0.00',
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_question_calc`),
  UNIQUE KEY `id_question_calc` (`id_question_calc`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `question_calc`
--

LOCK TABLES `question_calc` WRITE;
/*!40000 ALTER TABLE `question_calc` DISABLE KEYS */;
/*!40000 ALTER TABLE `question_calc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question_calcseq`
--

DROP TABLE IF EXISTS `question_calcseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `question_calcseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `question_calcseq`
--

LOCK TABLES `question_calcseq` WRITE;
/*!40000 ALTER TABLE `question_calcseq` DISABLE KEYS */;
INSERT INTO `question_calcseq` VALUES (0);
/*!40000 ALTER TABLE `question_calcseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question_detail`
--

DROP TABLE IF EXISTS `question_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `question_detail` (
  `id_question_detail` int(11) NOT NULL default '0',
  `id_question` int(11) NOT NULL default '0',
  `id_family` int(11) NOT NULL default '0',
  `selection` varchar(100) NOT NULL default '',
  `displayorder` int(3) NOT NULL default '0',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_question_detail`),
  UNIQUE KEY `id_question_detail` (`id_question_detail`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `question_detail`
--

LOCK TABLES `question_detail` WRITE;
/*!40000 ALTER TABLE `question_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `question_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question_detailseq`
--

DROP TABLE IF EXISTS `question_detailseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `question_detailseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `question_detailseq`
--

LOCK TABLES `question_detailseq` WRITE;
/*!40000 ALTER TABLE `question_detailseq` DISABLE KEYS */;
INSERT INTO `question_detailseq` VALUES (0);
/*!40000 ALTER TABLE `question_detailseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `questionseq`
--

DROP TABLE IF EXISTS `questionseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `questionseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `questionseq`
--

LOCK TABLES `questionseq` WRITE;
/*!40000 ALTER TABLE `questionseq` DISABLE KEYS */;
INSERT INTO `questionseq` VALUES (0);
/*!40000 ALTER TABLE `questionseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quotecomment`
--

DROP TABLE IF EXISTS `quotecomment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `quotecomment` (
  `id` int(11) NOT NULL auto_increment,
  `comments` char(100) NOT NULL default '',
  `cancel` int(11) default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quotecomment`
--

LOCK TABLES `quotecomment` WRITE;
/*!40000 ALTER TABLE `quotecomment` DISABLE KEYS */;
/*!40000 ALTER TABLE `quotecomment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quoteemail`
--

DROP TABLE IF EXISTS `quoteemail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `quoteemail` (
  `id` int(11) NOT NULL default '0',
  `lead_time` int(11) default '0',
  `offer` blob,
  `point1` blob,
  `point2` blob,
  `point3` blob,
  `point4` blob,
  `point5` blob,
  `point6` blob,
  `from_person` blob,
  `subject` blob,
  `message` varchar(100) default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quoteemail`
--

LOCK TABLES `quoteemail` WRITE;
/*!40000 ALTER TABLE `quoteemail` DISABLE KEYS */;
/*!40000 ALTER TABLE `quoteemail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recurringbillinglog`
--

DROP TABLE IF EXISTS `recurringbillinglog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `recurringbillinglog` (
  `id` int(11) NOT NULL auto_increment,
  `recurringbillingsubscriptionid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `autopaymentvoucherid` int(11) NOT NULL default '0' COMMENT 'Only populated if a payment was collected automatically (USAePay CD). Otherwise refer to the referenced invoice.',
  `whichperiodnumber` int(11) NOT NULL default '0' COMMENT 'Which period this run is for the customer, eg: 1 (first), 2 (second), etc. Can have duplicates but should never have 2 successes for the same period number, as this indicates double processing (but there may be cases where that is needed).',
  `success` tinyint(1) NOT NULL default '0' COMMENT 'Boolean value indicating a completely normal run for the period.',
  `description` tinytext NOT NULL COMMENT 'Internal text description of period processing, indicating if it was a cron run, already processed, writeoff, etc.',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Log for recurringbillingplan processing';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recurringbillinglog`
--

LOCK TABLES `recurringbillinglog` WRITE;
/*!40000 ALTER TABLE `recurringbillinglog` DISABLE KEYS */;
/*!40000 ALTER TABLE `recurringbillinglog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recurringbillingplan`
--

DROP TABLE IF EXISTS `recurringbillingplan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `recurringbillingplan` (
  `id` int(11) NOT NULL auto_increment,
  `name` tinytext NOT NULL COMMENT 'Name of this plan.',
  `description` tinytext NOT NULL COMMENT 'Only an internal description for admins for now.',
  `companyid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0' COMMENT 'Defines what to bill. Has to be an invoice with payplan = 1.',
  `periodunit` char(1) NOT NULL default 'M' COMMENT 'Base unit to define period. D=day, W=week, M=month, Y=year. periodmultiplier defines how many of these units = 1 period.',
  `periodmultiplier` int(11) NOT NULL default '1' COMMENT 'How many periodunits are in a period (eg: Dx2 = two day period, Wx3 = three week period, Yx6 = 6 year period, Mx1 = one month period).',
  `periodlimit` int(11) NOT NULL default '0' COMMENT 'The maximum number of periods to process. 0 = infinite, 2 = process 2 times, and so on.',
  `trialperiodlength` int(11) NOT NULL default '0' COMMENT 'How many periods are considered a trial. Typically this would be 0 (no trial period) or 1 (the first period is a trial).',
  `trialperiodprice` decimal(18,6) NOT NULL default '0.000000' COMMENT 'A static price that is used for EACH trial period (not the entire trial length). This will substitute the price on the plan invoice, add a note,  and inherit the other accounting information.',
  `allowcustomercredit` tinyint(1) NOT NULL default '0' COMMENT 'Boolean to determine if this plan is allowed to use customer credit to pay invoices.',
  `disableemails` tinyint(1) NOT NULL default '0' COMMENT 'Override all invoice email options so no invoices will be emailed.',
  `disablecron` tinyint(1) NOT NULL default '0' COMMENT 'Disable the automated features so that this plan has to be run manually - the old way.',
  `cronlastrun` datetime NOT NULL default '0000-00-00 00:00:00' COMMENT 'Keep track of last run time to block excessive or accidental processing. Should only run once per day, as early as possible (eg: 1am).',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Define recurring billing plans. Linked to an invoice tagged ';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recurringbillingplan`
--

LOCK TABLES `recurringbillingplan` WRITE;
/*!40000 ALTER TABLE `recurringbillingplan` DISABLE KEYS */;
/*!40000 ALTER TABLE `recurringbillingplan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `recurringbillingsubscription`
--

DROP TABLE IF EXISTS `recurringbillingsubscription`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `recurringbillingsubscription` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `recurringbillingplanid` int(11) NOT NULL default '0',
  `planstartdate` datetime NOT NULL default '0000-00-00 00:00:00' COMMENT 'This defines the starting date of the plan - when first invoice is generated',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `notes` tinytext NOT NULL COMMENT 'Intended for leaving a cancellation reason.',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Sign a customer up for a defined recurringbillingplan';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `recurringbillingsubscription`
--

LOCK TABLES `recurringbillingsubscription` WRITE;
/*!40000 ALTER TABLE `recurringbillingsubscription` DISABLE KEYS */;
/*!40000 ALTER TABLE `recurringbillingsubscription` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reportarchive`
--

DROP TABLE IF EXISTS `reportarchive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reportarchive` (
  `id` int(11) NOT NULL auto_increment,
  `filename` varchar(255) NOT NULL default '',
  `type` varchar(32) NOT NULL default '',
  `title` varchar(100) NOT NULL default '',
  `entrydate` datetime default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `entrydate` (`entrydate`,`cancel`,`gencompanyid`),
  KEY `type` (`type`,`cancel`,`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reportarchive`
--

LOCK TABLES `reportarchive` WRITE;
/*!40000 ALTER TABLE `reportarchive` DISABLE KEYS */;
/*!40000 ALTER TABLE `reportarchive` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reportarchivestatements`
--

DROP TABLE IF EXISTS `reportarchivestatements`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reportarchivestatements` (
  `id` int(11) NOT NULL auto_increment,
  `reportarchiveid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `begindate` date NOT NULL,
  `endate` date NOT NULL,
  `balance` decimal(19,6) default NULL,
  `current` decimal(19,6) default NULL,
  `aging_0` decimal(19,6) default NULL COMMENT '0 - 30 Days',
  `aging_30` decimal(19,6) default NULL COMMENT '30 - 45 or 30 - 60',
  `aging_45` decimal(19,6) default NULL COMMENT '45 - 60 Days',
  `aging_60` decimal(19,6) default NULL COMMENT '60 - 90 Days',
  `aging_90` decimal(19,6) default NULL COMMENT '90+ Days',
  `sent_email` varchar(255) NOT NULL,
  `sent_fax` varchar(24) NOT NULL,
  `sent_billtrust` tinyint(1) NOT NULL default '0',
  `archived_only` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `reportarchiveid` (`reportarchiveid`),
  KEY `customerid` (`customerid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reportarchivestatements`
--

LOCK TABLES `reportarchivestatements` WRITE;
/*!40000 ALTER TABLE `reportarchivestatements` DISABLE KEYS */;
/*!40000 ALTER TABLE `reportarchivestatements` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `responsetype`
--

DROP TABLE IF EXISTS `responsetype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `responsetype` (
  `id_responsetype` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_responsetype`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `responsetype`
--

LOCK TABLES `responsetype` WRITE;
/*!40000 ALTER TABLE `responsetype` DISABLE KEYS */;
/*!40000 ALTER TABLE `responsetype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `retax`
--

DROP TABLE IF EXISTS `retax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `retax` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `buildingid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `retaxtypeid` int(11) NOT NULL default '0',
  `nameonbill` varchar(255) NOT NULL default '',
  `taxnumber` varchar(50) NOT NULL default '',
  `assessment_date` date default NULL,
  `assessment_amount` decimal(19,5) NOT NULL default '0.00000',
  `howtaxcalculated` text,
  `expenseglacctid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `status` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `buildingid` (`buildingid`),
  KEY `vendorid` (`vendorid`),
  KEY `retaxtypeid` (`retaxtypeid`),
  KEY `cancel` (`cancel`),
  KEY `status` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `retax`
--

LOCK TABLES `retax` WRITE;
/*!40000 ALTER TABLE `retax` DISABLE KEYS */;
/*!40000 ALTER TABLE `retax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `retax_amounts`
--

DROP TABLE IF EXISTS `retax_amounts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `retax_amounts` (
  `id` int(11) NOT NULL auto_increment,
  `retaxid` int(11) NOT NULL default '0',
  `buildingid` int(11) NOT NULL default '0',
  `amountpaid` decimal(19,5) NOT NULL default '0.00000',
  `datepaid` date default NULL,
  `voucherid` int(11) NOT NULL default '0',
  `notes` text,
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`),
  KEY `buildingid` (`buildingid`),
  KEY `retaxid` (`retaxid`),
  KEY `cancel` (`cancel`),
  KEY `voucherid` (`voucherid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `retax_amounts`
--

LOCK TABLES `retax_amounts` WRITE;
/*!40000 ALTER TABLE `retax_amounts` DISABLE KEYS */;
/*!40000 ALTER TABLE `retax_amounts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `retaxtype`
--

DROP TABLE IF EXISTS `retaxtype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `retaxtype` (
  `id` int(11) NOT NULL auto_increment,
  `taxname` varchar(100) NOT NULL default '',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `retaxtype`
--

LOCK TABLES `retaxtype` WRITE;
/*!40000 ALTER TABLE `retaxtype` DISABLE KEYS */;
/*!40000 ALTER TABLE `retaxtype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reviews`
--

DROP TABLE IF EXISTS `reviews`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reviews` (
  `reviews_id` int(5) NOT NULL auto_increment,
  `reviews_text` text NOT NULL,
  `reviews_rating` int(1) default NULL,
  PRIMARY KEY  (`reviews_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reviews`
--

LOCK TABLES `reviews` WRITE;
/*!40000 ALTER TABLE `reviews` DISABLE KEYS */;
/*!40000 ALTER TABLE `reviews` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reviews_extra`
--

DROP TABLE IF EXISTS `reviews_extra`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reviews_extra` (
  `reviews_id` int(5) NOT NULL default '0',
  `products_id` int(5) NOT NULL default '0',
  `customers_id` int(5) NOT NULL default '0',
  `date_added` char(8) NOT NULL default '',
  `reviews_read` int(5) default NULL,
  `reviews_active` int(2) NOT NULL default '0'
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reviews_extra`
--

LOCK TABLES `reviews_extra` WRITE;
/*!40000 ALTER TABLE `reviews_extra` DISABLE KEYS */;
/*!40000 ALTER TABLE `reviews_extra` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rma_action`
--

DROP TABLE IF EXISTS `rma_action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rma_action` (
  `id` int(11) NOT NULL auto_increment,
  `action` varchar(50) default NULL,
  `new_order_required` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rma_action`
--

LOCK TABLES `rma_action` WRITE;
/*!40000 ALTER TABLE `rma_action` DISABLE KEYS */;
/*!40000 ALTER TABLE `rma_action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rma_arorder`
--

DROP TABLE IF EXISTS `rma_arorder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rma_arorder` (
  `id` int(11) NOT NULL auto_increment,
  `rmanumber` varchar(50) NOT NULL default '',
  `orderid` int(11) NOT NULL default '0',
  `arordershipid` int(11) NOT NULL default '0',
  `date_issued` date NOT NULL default '0000-00-00',
  `date_rma_completed` date default NULL,
  `status` int(5) NOT NULL default '0',
  `return_shipping_paid_by` int(5) NOT NULL default '1',
  `send_willcall` int(5) NOT NULL default '0',
  `notes` varchar(255) default NULL,
  `createdate` datetime default NULL,
  `createuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `b2bhidden` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `rmanumber` (`rmanumber`),
  KEY `orderid` (`orderid`),
  KEY `arordershipid` (`arordershipid`),
  KEY `cancel` (`cancel`),
  KEY `status` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rma_arorder`
--

LOCK TABLES `rma_arorder` WRITE;
/*!40000 ALTER TABLE `rma_arorder` DISABLE KEYS */;
/*!40000 ALTER TABLE `rma_arorder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rma_arorder_returned`
--

DROP TABLE IF EXISTS `rma_arorder_returned`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rma_arorder_returned` (
  `id` int(11) NOT NULL auto_increment,
  `rma_arorderid` int(11) NOT NULL default '0',
  `return_date` date default NULL,
  `taxid` int(11) NOT NULL default '0',
  `taxcredit` decimal(19,5) NOT NULL default '0.00000',
  `taxid2` int(11) NOT NULL default '0',
  `taxcredit2` decimal(19,5) NOT NULL default '0.00000',
  `taxid3` int(11) NOT NULL default '0',
  `taxcredit3` decimal(19,5) NOT NULL default '0.00000',
  `shipping_credit` decimal(19,5) NOT NULL default '0.00000',
  `restock_fee` decimal(19,5) NOT NULL default '0.00000',
  `total_credit` decimal(19,5) NOT NULL default '0.00000',
  `invoiceid` int(11) NOT NULL default '0',
  `voucherid` int(11) NOT NULL default '0',
  `new_orderid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `rma_arorderid` (`rma_arorderid`),
  KEY `cancel` (`cancel`),
  KEY `return_date` (`return_date`),
  KEY `invoiceid` (`invoiceid`),
  KEY `voucherid` (`voucherid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rma_arorder_returned`
--

LOCK TABLES `rma_arorder_returned` WRITE;
/*!40000 ALTER TABLE `rma_arorder_returned` DISABLE KEYS */;
/*!40000 ALTER TABLE `rma_arorder_returned` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rma_arorder_returned_extras`
--

DROP TABLE IF EXISTS `rma_arorder_returned_extras`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rma_arorder_returned_extras` (
  `id` int(11) NOT NULL auto_increment,
  `rma_arorder_returnedid` int(11) NOT NULL default '0',
  `creditamount` decimal(19,5) NOT NULL default '0.00000',
  `creditdescription` varchar(255) default NULL,
  `creditclass` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `rma_arorder_returnedid` (`rma_arorder_returnedid`),
  KEY `creditclass` (`creditclass`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rma_arorder_returned_extras`
--

LOCK TABLES `rma_arorder_returned_extras` WRITE;
/*!40000 ALTER TABLE `rma_arorder_returned_extras` DISABLE KEYS */;
/*!40000 ALTER TABLE `rma_arorder_returned_extras` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rma_arorderdetail`
--

DROP TABLE IF EXISTS `rma_arorderdetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rma_arorderdetail` (
  `id` int(11) NOT NULL auto_increment,
  `rma_arorderid` int(11) NOT NULL default '0',
  `orderid` int(11) NOT NULL default '0',
  `arordershipdetailid` int(11) NOT NULL default '0',
  `qty_to_return` decimal(18,6) NOT NULL default '0.000000',
  `qty_returned_actual` decimal(18,6) NOT NULL default '0.000000',
  `order_itemid` int(11) NOT NULL default '0',
  `order_costeach` decimal(19,5) NOT NULL default '0.00000',
  `order_priceach` decimal(19,5) NOT NULL default '0.00000',
  `order_saleunitperpriceunit` decimal(12,5) NOT NULL default '1.00000',
  `order_cogsglid` int(11) NOT NULL default '0',
  `order_salesglid` int(11) NOT NULL default '0',
  `replacement_itemid` int(11) NOT NULL default '0',
  `replacement_costeach` decimal(19,5) NOT NULL default '0.00000',
  `replacement_priceach` decimal(19,5) NOT NULL default '0.00000',
  `replace_saleunitperpriceunit` decimal(12,5) NOT NULL default '1.00000',
  `replace_cogsglid` int(11) NOT NULL default '0',
  `replace_salesglid` int(11) NOT NULL default '0',
  `qty_to_replace` decimal(18,6) NOT NULL default '0.000000',
  `rma_reasonid` int(11) NOT NULL default '0',
  `rma_actionid` int(11) NOT NULL default '0',
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `canceldate` date default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `creditnote` text,
  PRIMARY KEY  (`id`),
  KEY `rma_arorderid` (`rma_arorderid`),
  KEY `orderid` (`orderid`),
  KEY `arordershipdetailid` (`arordershipdetailid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rma_arorderdetail`
--

LOCK TABLES `rma_arorderdetail` WRITE;
/*!40000 ALTER TABLE `rma_arorderdetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `rma_arorderdetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rma_arorderdetail_returned`
--

DROP TABLE IF EXISTS `rma_arorderdetail_returned`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rma_arorderdetail_returned` (
  `id` int(11) NOT NULL auto_increment,
  `rma_arorder_returnedid` int(11) NOT NULL default '0',
  `rma_arorderdetailid` int(11) NOT NULL default '0',
  `qty_received` decimal(18,6) NOT NULL default '0.000000',
  `receive_itemid` int(11) NOT NULL default '0',
  `costeach` decimal(19,5) NOT NULL default '0.00000',
  `priceach` decimal(19,5) NOT NULL default '0.00000',
  `salesglaccountid` int(11) NOT NULL default '0',
  `costglaccountid` int(11) NOT NULL default '0',
  `inventoryglaccountid` int(11) NOT NULL default '0',
  `rma_conditionid` int(11) NOT NULL default '0',
  `rma_actionid` int(11) NOT NULL default '0',
  `restock_fee` decimal(19,5) NOT NULL default '0.00000',
  `total_credit_amount` decimal(19,5) NOT NULL default '0.00000',
  `replace_qty` decimal(18,6) NOT NULL default '0.000000',
  `replace_itemid` int(11) NOT NULL default '0',
  `invoiceid` int(11) NOT NULL default '0',
  `voucherid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  PRIMARY KEY  (`id`),
  KEY `rma_arorderdetailid` (`rma_arorderdetailid`),
  KEY `cancel` (`cancel`),
  KEY `rma_arorder_returnedid` (`rma_arorder_returnedid`),
  KEY `invoiceid` (`invoiceid`),
  KEY `voucherid` (`voucherid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rma_arorderdetail_returned`
--

LOCK TABLES `rma_arorderdetail_returned` WRITE;
/*!40000 ALTER TABLE `rma_arorderdetail_returned` DISABLE KEYS */;
/*!40000 ALTER TABLE `rma_arorderdetail_returned` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rma_condition`
--

DROP TABLE IF EXISTS `rma_condition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rma_condition` (
  `id` int(11) NOT NULL auto_increment,
  `rma_condition` varchar(50) default NULL,
  `percent_restock_fee` decimal(5,2) NOT NULL default '0.00',
  `flat_restock_fee` decimal(12,5) NOT NULL default '0.00000',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `damaged` int(5) NOT NULL default '0',
  `isdefault` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rma_condition`
--

LOCK TABLES `rma_condition` WRITE;
/*!40000 ALTER TABLE `rma_condition` DISABLE KEYS */;
/*!40000 ALTER TABLE `rma_condition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rma_creditclass`
--

DROP TABLE IF EXISTS `rma_creditclass`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rma_creditclass` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(50) default NULL,
  `glaccountid` int(11) NOT NULL default '0',
  `is_taxable` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rma_creditclass`
--

LOCK TABLES `rma_creditclass` WRITE;
/*!40000 ALTER TABLE `rma_creditclass` DISABLE KEYS */;
/*!40000 ALTER TABLE `rma_creditclass` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rma_purchasing`
--

DROP TABLE IF EXISTS `rma_purchasing`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rma_purchasing` (
  `id` int(11) NOT NULL auto_increment,
  `rma` varchar(30) NOT NULL default '',
  `ponumber` varchar(20) NOT NULL default '',
  `ordernumber` varchar(20) NOT NULL default '',
  `invoicenumber` varchar(20) NOT NULL default '',
  `invoicedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `vendorid` int(11) NOT NULL default '0',
  `itemcode` varchar(20) NOT NULL default '',
  `vendorpartnumber` varchar(30) NOT NULL default '',
  `serialnumber` varchar(100) NOT NULL default '',
  `quantity` decimal(18,6) NOT NULL default '0.000000',
  `problem` varchar(255) NOT NULL default '',
  `contactname` varchar(100) NOT NULL default '',
  `sentdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `expectedreturndate` datetime NOT NULL default '0000-00-00 00:00:00',
  `trackingnumber` varchar(50) NOT NULL default '',
  `actionid` int(11) NOT NULL default '0',
  `restockingfee` double(12,2) NOT NULL default '0.00',
  `completed` int(2) NOT NULL default '0',
  `completeddate` varchar(100) NOT NULL default '',
  `address1` varchar(100) NOT NULL default '',
  `address2` varchar(100) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  `state` varchar(20) NOT NULL default '',
  `zip` varchar(15) NOT NULL default '',
  `country` varchar(20) NOT NULL default '',
  `shiptoaddress` varchar(255) NOT NULL default '',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `companyid` int(11) NOT NULL default '0',
  `notes` blob NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rma_purchasing`
--

LOCK TABLES `rma_purchasing` WRITE;
/*!40000 ALTER TABLE `rma_purchasing` DISABLE KEYS */;
/*!40000 ALTER TABLE `rma_purchasing` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rma_purchasing_action`
--

DROP TABLE IF EXISTS `rma_purchasing_action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rma_purchasing_action` (
  `id` int(11) NOT NULL default '0',
  `action` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rma_purchasing_action`
--

LOCK TABLES `rma_purchasing_action` WRITE;
/*!40000 ALTER TABLE `rma_purchasing_action` DISABLE KEYS */;
INSERT INTO `rma_purchasing_action` VALUES (0,'None'),(1,'Repair & Return'),(2,'Replace'),(3,'Credit');
/*!40000 ALTER TABLE `rma_purchasing_action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rma_reason`
--

DROP TABLE IF EXISTS `rma_reason`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rma_reason` (
  `id` int(11) NOT NULL auto_increment,
  `reason` varchar(50) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rma_reason`
--

LOCK TABLES `rma_reason` WRITE;
/*!40000 ALTER TABLE `rma_reason` DISABLE KEYS */;
/*!40000 ALTER TABLE `rma_reason` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_categories`
--

DROP TABLE IF EXISTS `sales_categories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sales_categories` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(50) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `gencompanyid` int(11) NOT NULL default '0',
  `allow_b2b_display` int(11) NOT NULL default '0',
  `mobile_pos_show_customers` tinyint(1) default '0',
  `usewalkintaxesforso` tinyint(4) NOT NULL default '0',
  `defaultcheckaccts` text NOT NULL,
  `defaultsalesglacct` int(11) NOT NULL default '0',
  `defaultcogsglacct` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_categories`
--

LOCK TABLES `sales_categories` WRITE;
/*!40000 ALTER TABLE `sales_categories` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_pipeline`
--

DROP TABLE IF EXISTS `sales_pipeline`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sales_pipeline` (
  `id` int(11) NOT NULL auto_increment,
  `companyid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `description` text,
  `status` int(5) NOT NULL default '0',
  `forecasted_date` date default NULL,
  `address` text,
  `number_of_units` int(11) NOT NULL default '0',
  `sale_price` decimal(19,5) NOT NULL default '0.00000',
  `closing_costs_percent` decimal(5,2) NOT NULL default '0.00',
  `cogs` decimal(19,5) NOT NULL default '0.00000',
  `loan_curtailment` decimal(19,5) NOT NULL default '0.00000',
  `client` varchar(255) NOT NULL default '',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `jobid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `status` (`status`),
  KEY `cancel` (`cancel`),
  KEY `forecasted_date` (`forecasted_date`),
  KEY `companyid` (`companyid`),
  KEY `jobid` (`jobid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_pipeline`
--

LOCK TABLES `sales_pipeline` WRITE;
/*!40000 ALTER TABLE `sales_pipeline` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_pipeline` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salescategory`
--

DROP TABLE IF EXISTS `salescategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salescategory` (
  `id` int(11) NOT NULL default '0',
  `type` varchar(100) NOT NULL default '',
  `description` varchar(100) NOT NULL default '',
  `gencompanyid` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salescategory`
--

LOCK TABLES `salescategory` WRITE;
/*!40000 ALTER TABLE `salescategory` DISABLE KEYS */;
INSERT INTO `salescategory` VALUES (1,'','Retail Sales',1),(2,'','Wholesale Sales',1),(3,'','Customer Support',1);
/*!40000 ALTER TABLE `salescategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salescategoryseq`
--

DROP TABLE IF EXISTS `salescategoryseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salescategoryseq` (
  `id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salescategoryseq`
--

LOCK TABLES `salescategoryseq` WRITE;
/*!40000 ALTER TABLE `salescategoryseq` DISABLE KEYS */;
INSERT INTO `salescategoryseq` VALUES (1);
/*!40000 ALTER TABLE `salescategoryseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesman`
--

DROP TABLE IF EXISTS `salesman`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salesman` (
  `id` int(11) NOT NULL auto_increment,
  `payrollid` int(11) NOT NULL default '0',
  `commissionrate` decimal(6,3) NOT NULL default '0.000',
  `commissionbase` int(11) NOT NULL default '0',
  `servicerep` int(11) NOT NULL default '0',
  `salesman` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `name` varchar(50) NOT NULL default '',
  `address1` varchar(100) NOT NULL default '',
  `address2` varchar(100) NOT NULL default '',
  `mailstop` varchar(20) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  `state` varchar(20) NOT NULL default '',
  `zip` varchar(15) NOT NULL default '',
  `country` varchar(20) NOT NULL default '',
  `phone1` varchar(20) NOT NULL default '',
  `phone1comment` varchar(20) NOT NULL default '',
  `phone2` varchar(20) NOT NULL default '',
  `phone2comment` varchar(20) NOT NULL default '',
  `phone3` varchar(20) NOT NULL default '',
  `phone3comment` varchar(20) NOT NULL default '',
  `phone4` varchar(20) NOT NULL default '',
  `phone4comment` varchar(20) NOT NULL default '',
  `email1` varchar(50) NOT NULL default '',
  `email2` varchar(50) NOT NULL default '',
  `email1comment` varchar(20) NOT NULL default '',
  `email2comment` varchar(20) NOT NULL default '',
  `federalid` varchar(20) NOT NULL default '',
  `commissionrate2` decimal(6,3) NOT NULL default '0.000',
  `vendorid` int(11) NOT NULL default '0',
  `blockchange` int(11) NOT NULL default '0',
  `salesglaccountid` int(11) NOT NULL default '0',
  `checkacctid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `managergenuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `payrollid` (`payrollid`),
  KEY `servicerep` (`servicerep`),
  KEY `salesman` (`salesman`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesman`
--

LOCK TABLES `salesman` WRITE;
/*!40000 ALTER TABLE `salesman` DISABLE KEYS */;
INSERT INTO `salesman` VALUES (1,0,'0.000',0,1,1,1,0,NULL,NULL,NULL,NULL,'2005-03-08 15:08:39',NULL,'House Account','','','','','','','','','','','','','','','','','','','','','0.000',0,0,0,0,0,0),(2,0,'0.000',0,1,1,0,0,NULL,NULL,NULL,NULL,'2007-11-08 21:45:58',NULL,'House Account','','','','','','','','','','','','','','','','','','','','','0.000',0,0,0,0,0,0);
/*!40000 ALTER TABLE `salesman` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesprocess`
--

DROP TABLE IF EXISTS `salesprocess`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salesprocess` (
  `id` int(11) NOT NULL default '0',
  `salesman_id` int(11) NOT NULL default '0',
  `status` int(11) NOT NULL default '0',
  `customer_id` int(11) NOT NULL default '0',
  `contact` varchar(100) NOT NULL default '',
  `position` varchar(100) NOT NULL default '',
  `phone` bigint(10) NOT NULL default '0',
  `email` varchar(100) NOT NULL default '',
  `salescategory_id` int(11) NOT NULL default '0',
  `quality` int(11) NOT NULL default '0',
  `description` varchar(200) NOT NULL default '',
  `notes` varchar(200) NOT NULL default '',
  `estimated_sale` decimal(10,0) NOT NULL default '0',
  `actual_sale` decimal(10,0) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesprocess`
--

LOCK TABLES `salesprocess` WRITE;
/*!40000 ALTER TABLE `salesprocess` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesprocess` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesprocessseq`
--

DROP TABLE IF EXISTS `salesprocessseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salesprocessseq` (
  `id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesprocessseq`
--

LOCK TABLES `salesprocessseq` WRITE;
/*!40000 ALTER TABLE `salesprocessseq` DISABLE KEYS */;
INSERT INTO `salesprocessseq` VALUES (1);
/*!40000 ALTER TABLE `salesprocessseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesregion`
--

DROP TABLE IF EXISTS `salesregion`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salesregion` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(150) NOT NULL default '',
  `code` varchar(32) NOT NULL default '',
  `salesmanid` int(11) NOT NULL default '0',
  `inventorylocationid` tinyint(1) NOT NULL default '0',
  `sendquotestomanager` tinyint(4) NOT NULL default '0',
  `minquoteamountforemail` decimal(18,6) NOT NULL default '0.000000',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `salesmanid` (`salesmanid`),
  KEY `gc` (`gencompanyid`,`cancel`),
  KEY `inventorylocationid` (`inventorylocationid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesregion`
--

LOCK TABLES `salesregion` WRITE;
/*!40000 ALTER TABLE `salesregion` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesregion` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salestax`
--

DROP TABLE IF EXISTS `salestax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salestax` (
  `id` int(11) NOT NULL auto_increment,
  `taxname` varchar(50) default '',
  `taxrate` decimal(7,4) NOT NULL default '0.0000',
  `taxbase` int(11) NOT NULL default '0',
  `glacctid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `taxstate` varchar(5) NOT NULL default '',
  `glacctid_taxpaid` int(11) NOT NULL default '0',
  `capamount` decimal(14,6) NOT NULL default '0.000000',
  `gencompanyid` int(11) NOT NULL default '0',
  `taxnumber` varchar(50) NOT NULL default '',
  `taxcounty` varchar(32) NOT NULL default '',
  `effectivedate` date NOT NULL default '0000-00-00',
  `alternativetax` tinyint(1) NOT NULL default '0',
  `taxcity` varchar(32) NOT NULL default '',
  `imported` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `ccsc` (`taxcity`,`taxcounty`,`taxstate`,`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salestax`
--

LOCK TABLES `salestax` WRITE;
/*!40000 ALTER TABLE `salestax` DISABLE KEYS */;
/*!40000 ALTER TABLE `salestax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salestaxreuters`
--

DROP TABLE IF EXISTS `salestaxreuters`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salestaxreuters` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL,
  `cancel` tinyint(1) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `zip_code` int(11) NOT NULL default '0',
  `state_abbrev` varchar(2) NOT NULL,
  `county_name` varchar(32) NOT NULL,
  `city_name` varchar(32) NOT NULL,
  `state_sales_tax` decimal(7,4) NOT NULL,
  `state_use_tax` decimal(7,4) NOT NULL,
  `county_sales_tax` decimal(7,4) NOT NULL,
  `county_use_tax` decimal(7,4) NOT NULL,
  `city_sales_tax` decimal(7,4) NOT NULL,
  `city_use_tax` decimal(7,4) NOT NULL,
  `total_use_tax` decimal(7,4) NOT NULL,
  `tax_shipping_alone` tinyint(1) NOT NULL,
  `tax_shipping_and_handling_together` tinyint(1) NOT NULL,
  `fips_state` varchar(2) NOT NULL,
  `fips_county` varchar(3) NOT NULL,
  `fips_city` varchar(5) NOT NULL,
  `geocode` varchar(10) NOT NULL,
  `state_effective_date` date NOT NULL,
  `county_effective_date` date NOT NULL,
  `city_effective_date` date NOT NULL,
  `taxbase` tinyint(1) NOT NULL default '0',
  `glacctid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `addresslookup` (`state_abbrev`,`city_name`,`county_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salestaxreuters`
--

LOCK TABLES `salestaxreuters` WRITE;
/*!40000 ALTER TABLE `salestaxreuters` DISABLE KEYS */;
/*!40000 ALTER TABLE `salestaxreuters` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesterritory`
--

DROP TABLE IF EXISTS `salesterritory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salesterritory` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(150) NOT NULL default '',
  `code` varchar(32) NOT NULL default '',
  `salesregionid` int(11) NOT NULL default '0',
  `salesmanid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gc` (`gencompanyid`,`cancel`),
  KEY `salesregionid` (`salesregionid`),
  KEY `inventorylocationid` (`inventorylocationid`),
  KEY `salesmanid` (`salesmanid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesterritory`
--

LOCK TABLES `salesterritory` WRITE;
/*!40000 ALTER TABLE `salesterritory` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesterritory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesterritoryzip`
--

DROP TABLE IF EXISTS `salesterritoryzip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salesterritoryzip` (
  `id` int(11) NOT NULL auto_increment,
  `salesterritoryid` int(11) NOT NULL default '0',
  `zip` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `zip` (`zip`),
  KEY `salesterritoryid` (`salesterritoryid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesterritoryzip`
--

LOCK TABLES `salesterritoryzip` WRITE;
/*!40000 ALTER TABLE `salesterritoryzip` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesterritoryzip` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salestracker`
--

DROP TABLE IF EXISTS `salestracker`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salestracker` (
  `id` int(11) NOT NULL default '0',
  `sales_process_id` int(11) NOT NULL default '0',
  `action_salesman_id` int(11) NOT NULL default '0',
  `action_id` int(11) NOT NULL default '0',
  `action_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `notes` varchar(200) NOT NULL default '',
  `next_action_salesman_id` int(11) NOT NULL default '0',
  `next_action_id` int(11) NOT NULL default '0',
  `next_action_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salestracker`
--

LOCK TABLES `salestracker` WRITE;
/*!40000 ALTER TABLE `salestracker` DISABLE KEYS */;
/*!40000 ALTER TABLE `salestracker` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salestrackerseq`
--

DROP TABLE IF EXISTS `salestrackerseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salestrackerseq` (
  `id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salestrackerseq`
--

LOCK TABLES `salestrackerseq` WRITE;
/*!40000 ALTER TABLE `salestrackerseq` DISABLE KEYS */;
INSERT INTO `salestrackerseq` VALUES (1);
/*!40000 ALTER TABLE `salestrackerseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `scartfreeship`
--

DROP TABLE IF EXISTS `scartfreeship`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `scartfreeship` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `pricelevels` text NOT NULL,
  `shipmethods` text NOT NULL,
  `minamount` decimal(12,6) NOT NULL default '0.000000',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `active` int(11) NOT NULL default '1',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `scartfreeship`
--

LOCK TABLES `scartfreeship` WRITE;
/*!40000 ALTER TABLE `scartfreeship` DISABLE KEYS */;
/*!40000 ALTER TABLE `scartfreeship` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_cat`
--

DROP TABLE IF EXISTS `search_cat`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_cat` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(150) NOT NULL default '',
  `level` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `categories_image` varchar(64) default NULL,
  `companyid` int(11) NOT NULL default '0',
  `parentid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `parentid` (`parentid`),
  KEY `name` (`name`),
  KEY `companyidcancel` (`companyid`,`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_cat`
--

LOCK TABLES `search_cat` WRITE;
/*!40000 ALTER TABLE `search_cat` DISABLE KEYS */;
/*!40000 ALTER TABLE `search_cat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_cat_3dcart`
--

DROP TABLE IF EXISTS `search_cat_3dcart`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_cat_3dcart` (
  `id` int(11) NOT NULL auto_increment,
  `searchcatid` int(11) NOT NULL default '0',
  `threedcompanyid` int(11) NOT NULL default '0',
  `threedcategoryid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `searchcatid` (`searchcatid`),
  KEY `threed` (`threedcompanyid`,`threedcategoryid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_cat_3dcart`
--

LOCK TABLES `search_cat_3dcart` WRITE;
/*!40000 ALTER TABLE `search_cat_3dcart` DISABLE KEYS */;
/*!40000 ALTER TABLE `search_cat_3dcart` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_catseq`
--

DROP TABLE IF EXISTS `search_catseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_catseq` (
  `id` int(11) default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_catseq`
--

LOCK TABLES `search_catseq` WRITE;
/*!40000 ALTER TABLE `search_catseq` DISABLE KEYS */;
INSERT INTO `search_catseq` VALUES (0);
/*!40000 ALTER TABLE `search_catseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_tree`
--

DROP TABLE IF EXISTS `search_tree`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_tree` (
  `id` int(11) NOT NULL auto_increment,
  `itemid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `searchcatid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cis` (`companyid`,`itemid`,`searchcatid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_tree`
--

LOCK TABLES `search_tree` WRITE;
/*!40000 ALTER TABLE `search_tree` DISABLE KEYS */;
/*!40000 ALTER TABLE `search_tree` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_treeseq`
--

DROP TABLE IF EXISTS `search_treeseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_treeseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_treeseq`
--

LOCK TABLES `search_treeseq` WRITE;
/*!40000 ALTER TABLE `search_treeseq` DISABLE KEYS */;
INSERT INTO `search_treeseq` VALUES (0);
/*!40000 ALTER TABLE `search_treeseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `serversetup`
--

DROP TABLE IF EXISTS `serversetup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `serversetup` (
  `changedate` varchar(100) NOT NULL default '',
  `definename` varchar(100) NOT NULL default '',
  `id` int(11) NOT NULL default '0',
  `definevalue` varchar(255) NOT NULL default '',
  `description` varchar(100) default '',
  PRIMARY KEY  (`id`),
  KEY `definename` (`definename`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `serversetup`
--

LOCK TABLES `serversetup` WRITE;
/*!40000 ALTER TABLE `serversetup` DISABLE KEYS */;
INSERT INTO `serversetup` VALUES ('','username2',1,'root','Username used to access database server'),('','password2',2,'','Password used to access database server'),('','serverlocation',3,'localhost','Local location of database server (Ex. LocalHost)'),('','startuptoolbar',4,'1','Either you can have a browser toolbar or run the program without one'),('','currency',5,'$','Current currency you wish to use'),('','decimalplaces',6,'2','How many decimal places you would like shown on financial details'),('','unitprice_decimalplaces',7,'5','How many decimal places you would like shown for unit price displays'),('','character_encoding',8,'utf-8','Default character encoding to use for all HTML pages.'),('','np_license',9,'','Your NolaPro License (copy and paste here)'),('','np_location',10,'/usr/nog/home/groups/program/websites/sdevel/nolapro5','Location of NolaPro'),('','style',11,'','Set a default color for all companies'),('','ads_last_checkin',12,'1391178128',''),('','systemlanguage',13,'en','The default system language.'),('','sub_features_last_check',14,'','DO NOT MODIFY'),('','inv_decimalplaces',15,'0','How many decimal places you would like shown for inventory counts'),('','dbup.itemtransaction.simplify',16,'20170222102157','Action Skipped / Version ahead'),('','dbup.arorder.dropship',17,'20181026163300','Action Skipped / Version ahead'),('','dbup.item.inventorytype',18,'20181026163300','Action Skipped / Version ahead'),('','dbup.invreceive.invreceivemainid',19,'20181026163300','Action Skipped / Version ahead'),('','dbup.customer.emailxstatements',20,'20181026163300','Action Skipped / Version ahead'),('','dbup.itemtransaction.simplify',21,'20181026163300','Action Skipped / Version ahead'),('','dbup.arordershipdetail.rentalreturncomplete',22,'20181026163300','Action Skipped / Version ahead'),('','dbup.invpo.note-urldecode',23,'20181026163300','Action Skipped / Version ahead'),('','dbup.itemcategorygl.inventorytype',24,'20181026163300','Action Skipped / Version ahead'),('','dbup.invadjustmenttypeitemcategory.inventorytype',25,'20181026163300','Action Skipped / Version ahead'),('','dbup.arinvoice.voucherid',26,'20181026163300','Action Skipped / Version ahead'),('','dbup.itemlocation.lastpocost',27,'20181026163300','Action Skipped / Version ahead'),('','dbup.itemlocation.compwacost',28,'20181026163300','Action Skipped / Version ahead'),('','dbup.premployeepension_clone',29,'20181026163300','Action Skipped / Version ahead'),('','dbup.arorder.ordertotal.b',30,'20181026163300','Action Skipped / Version ahead'),('','dbup.arinvoice.paiddate',31,'20181026163300','Action Skipped / Version ahead');
/*!40000 ALTER TABLE `serversetup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `serversetup_large`
--

DROP TABLE IF EXISTS `serversetup_large`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `serversetup_large` (
  `id` int(11) NOT NULL auto_increment,
  `definename` varchar(100) NOT NULL,
  `definevalue` mediumtext,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `definename_UNIQUE` (`definename`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `serversetup_large`
--

LOCK TABLES `serversetup_large` WRITE;
/*!40000 ALTER TABLE `serversetup_large` DISABLE KEYS */;
INSERT INTO `serversetup_large` VALUES (1,'sub_feature_details','');
/*!40000 ALTER TABLE `serversetup_large` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `service`
--

DROP TABLE IF EXISTS `service`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `service` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `categoryid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `categoryid` (`categoryid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `service`
--

LOCK TABLES `service` WRITE;
/*!40000 ALTER TABLE `service` DISABLE KEYS */;
/*!40000 ALTER TABLE `service` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `service_workclass`
--

DROP TABLE IF EXISTS `service_workclass`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `service_workclass` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `service_workclass`
--

LOCK TABLES `service_workclass` WRITE;
/*!40000 ALTER TABLE `service_workclass` DISABLE KEYS */;
/*!40000 ALTER TABLE `service_workclass` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `service_workclass_rates`
--

DROP TABLE IF EXISTS `service_workclass_rates`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `service_workclass_rates` (
  `id` int(11) NOT NULL auto_increment,
  `service_worktypeid` int(11) NOT NULL default '0',
  `service_workclassid` int(11) NOT NULL default '0',
  `rate` decimal(10,4) NOT NULL default '0.0000',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `service_worktypeid` (`service_worktypeid`),
  KEY `service_workclassid` (`service_workclassid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `service_workclass_rates`
--

LOCK TABLES `service_workclass_rates` WRITE;
/*!40000 ALTER TABLE `service_workclass_rates` DISABLE KEYS */;
/*!40000 ALTER TABLE `service_workclass_rates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `service_worksubtype`
--

DROP TABLE IF EXISTS `service_worksubtype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `service_worksubtype` (
  `id` int(11) NOT NULL auto_increment,
  `worktypeid` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `salesglacctid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `service_worksubtype`
--

LOCK TABLES `service_worksubtype` WRITE;
/*!40000 ALTER TABLE `service_worksubtype` DISABLE KEYS */;
/*!40000 ALTER TABLE `service_worksubtype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `service_worktype`
--

DROP TABLE IF EXISTS `service_worktype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `service_worktype` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` date default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `salesglacctid` int(11) NOT NULL default '0',
  `color` varchar(7) NOT NULL default '',
  `defaultlengthminutes` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `service_worktype`
--

LOCK TABLES `service_worktype` WRITE;
/*!40000 ALTER TABLE `service_worktype` DISABLE KEYS */;
/*!40000 ALTER TABLE `service_worktype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `settingsmap`
--

DROP TABLE IF EXISTS `settingsmap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `settingsmap` (
  `id` int(11) NOT NULL,
  `path` text,
  `table` varchar(255) default NULL,
  `field` varchar(255) default NULL,
  `label` varchar(255) default NULL,
  `subtext` varchar(255) default NULL,
  `type` varchar(255) default NULL,
  `params` text,
  `features` tinytext,
  `npmodrightskey` tinytext,
  `sort` int(11) NOT NULL default '0',
  `aftersettingsmapid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `field` (`table`,`field`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `settingsmap`
--

LOCK TABLES `settingsmap` WRITE;
/*!40000 ALTER TABLE `settingsmap` DISABLE KEYS */;
INSERT INTO `settingsmap` VALUES (10,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','location','STR_DEFAULT_LOCATION','','select_inventorylocation','{}','','',0,0),(11,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','pricelevelid','STR_DEFAULT_PRICELEVEL','','select_pricelevel','{}','','',0,0),(12,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','default_rentalpricelevelid','STR_DEFAULT_RENTAL_PRICE_LEVEL','','select_pricelevel','{}','rentals','',0,0),(13,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','breakdown_scrap','STR_ITEM_BREAKDOWN_SCRAP','','select','{\"options\":{\"0\":\"STR_POST_SCRAP_AS_A_SEPARATE_GL_ENTRY\",\"1\":\"STR_SPREAD_SCRAP_COST_TO_OTHER_ITEMS_BASED_ON_WEIGHT\"}}','','',0,0),(14,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','addglatpo','STR_ADD_INV_GL_ENTRIES','','select','{\"options\":{\"0\":\"STR_WHEN_CONVERTING_PO_TO_AP_BILL\",\"1\":\"STR_WHEN_RECEIVING_POS_BASED_ON_WEIGHT\",\"2\":\"STR_BOTH_BY_USING_ACCRUED\"}}','','',0,0),(15,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','backdate_unreceive','STR_BACKDATE_UNRECEIVING_INVENTORY','','checkbox','{}','','',0,0),(16,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','weight_units','STR_ITEM_WEIGHT_UNITS','','select','{\"options\":{\"lbs\":\"lbs\",\"kg\":\"kg\"}}','','',0,0),(17,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','category_hierarchy','STR_CATEGORY_USAGE','','select','{\"options\":{\"1\":\"STR_HIERARCHY\",\"0\":\"STR_PARALLEL_LABELS\"}}','','',0,0),(18,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','multi_quantity','STR_WHICH_ENTRY_QUANTITY','','select','{\"options\":{\"0\":\"STR_ENTER_SELL_QUANTITY_ONLY\",\"4\":\"STR_ENTER_PRICE_OR_SELL_QUANTITY_AND_CALCULATE_OTHER\"}}','','',0,0),(19,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','costmethod','STR_INVENTORY_COST_METHOD','','select','{\"options\":{\"F\":\"STR_FIFO\",\"W\":\"STR_WEIGHTED_AVERAGE\",\"L\":\"STR_LIFO\"}}','','',0,0),(20,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invcompany','costmethodphysical','STR_COST_METHOD_FOR_PHYSICAL_INVENTORY','','select_costmethodphysical','{}','','',0,0),(21,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','locationwacostsame','STR_USE_SAME_AVERAGE_COST_FOR_ALL_LOCATIONS','','checkbox','{}','companywidewacost','',0,0),(22,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','blockifnostockmethod','STR_WHEN_BLOCKING_ORDERS_FOR_NO_STOCK','','select','{\"options\":{\"A\":\"STR_LOOK_AT_QUANTITY_AVAILABLE\",\"O\":\"STR_LOOK_AT_QUANTITY_ON_HAND\"}}','blockifnostock','',0,0),(23,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','blockifnostocktype','STR_IF_NO_STOCK_BLOCK','','select','{\"options\":{\"FPS\":\"STR_FULFILLMENT_ORDERS_POS_ORDERS_AND_SHIPMENTS\",\"PS\":\"STR_POS_ORDERS_AND_SHIPMENTS\"}}','blockifnostock','',0,0),(24,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','max_purch_suggestion','STR_USE_MAX_STOCKING_LEVEL_TO_DETERMINE_ORDER_QTY','','checkbox','{}','maxPurch','',0,0),(25,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','autobuildbomlimited','STR_AUTO_BUILD_BOM_LIMITED_BY_COMPONENTS','','checkbox','{}','bomautoship','',0,0),(27,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','costock','STR_DEFAULT_COMPANIES_TO_VIEW_STOCK_FROM','','select_othercompany','{}','showothercostock','',0,0),(28,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','itemlookupvendor','STR_INCLUDE_VENDOR_PRODUCT_CODE_IN_ITEM_SEARCH_BOX','','select','{\"options\":{\"0\":\"STR_NEVER\",\"1\":\"STR_ALWAYS\",\"2\":\"STR_ITEM_LOOKUP_METHOD: STR_EXTENSIVE\"}}','','',0,0),(29,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','ignorespacesitemsearchbox','STR_IGNORE_SPACES_IN_ITEM_SEARCH_BOX','','checkbox','{}','','',0,0),(30,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','showoptioninvstatus','STR_SHOW_INVENTORY_STATUS_FOR_ITEM_OPTIONS','','checkbox','{}','','',0,0),(31,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invcompany','physicalinventorylockdown','STR_BLOCK_ITEM_ACTIVITY_DURING_PHYSICAL_INVENTORY','','checkbox','{}','','',0,0),(32,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','remoteusesonhand','STR_REMOTE_UPDATES_USE','','select','{\"options\":{\"0\":\"STR_AVAILABLE_QUANTITY\",\"1\":\"STR_ON_HAND_QUANTITY\"}}','','',0,0),(33,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','reorderdcmonthssales','STR_DISTRIBUTION_CENTER_NUM_MONTHS_SALES_FOR_REORDER_CALCULATION','','text','{}','dcreorder','',0,0),(34,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','reordernondcmonthssales','STR_NONDISTRIBUTION_CENTER_NUM_MONTHS_SALES_FOR_REORDER_CALCULATION','','text','{}','dcreorder','',0,0),(35,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','invcotransferpostmethod','STR_INTERCOMPANY_ITEM_TRANSFERS_POSTING','','select','{\"options\":{\"0\":\"STR_POST_BY_LINE\",\"1\":\"STR_POST_BY_SHIPPING_AND_RECEIVING\"}}','invcotransfer','',0,0),(36,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','invcotransferblockstock','STR_BLOCK_TRANSFERS_FOR_INVENTORY_TYPES','','checkbox','{\"addtext\":\"STR_STOCK\"}','invcotransfer','',0,0),(37,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','invcotransferblocknonstock','','','checkbox','{\"addtext\":\"STR_NON_STOCK\"}','invcotransfer','',0,36),(38,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','invcotransferblockothercharges','','','checkbox','{\"addtext\":\"STR_OTHER_CHARGES\"}','invcotransfer','',0,37),(39,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','defaultrentalinventorylocationid','STR_DEFAULT_INVENTORY_LOCATION_FOR_RENTAL_TRANSFERS','','select_inventorylocation_unlimited','{\"addtext\":\"STR_OTHER_CHARGES\"}','rentals','',0,0),(40,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invcompany','invcountbatchcycleinvadjustmenttypeid','STR_STOCK_CHECK_REQUEST_DEFAULT_CYCLE_COUNT_ADJUSTMENT_TYPE','','select_invadjustmenttype','{}','invadjustmentrequests','',0,0),(81,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invcompany','invcountbatchphysinvadjustmenttypeid','STR_STOCK_CHECK_REQUEST_DEFAULT_PHYSICAL_COUNT_ADJUSTMENT_TYPE','','select_invadjustmenttype','{}','invadjustmentrequests','',0,0),(83,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','transfervarianceinvadjustmenttypeid','STR_TRANSFER_VARIANCE_ADJUSTMENT_TYPE','','select_invadjustmenttype','{}','invadjustmentrequests','',0,0),(84,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','onlyallowtransfersfromdc','STR_ONLY_ALLOW_TRANSFERS_FROM_DISTRIBUTION_CENTER','','checkbox','{}','invcotransfer','',0,0),(85,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','autoshowbarcodepopupfornewitems','STR_SHOW_BARCODE_POPUP_AFTER_CREATING_A_NEW_ITEM','','checkbox','{}','barcodelabel','',0,0),(86,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','newitemrequirevendor','STR_REQUIRE_VENDOR_FOR_NEW_ITEMS','','checkbox','{}','','',0,0),(87,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','newitemrequirecategory','STR_REQUIRE_CATEGORY_FOR_NEW_ITEMS','','checkbox','{}','','',0,0),(88,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','emailnewitemnoticesto','STR_EMAIL_NEW_ITEM_NOTICES_TO','','text','{}','','',0,0),(89,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','emailminmaxchanges','STR_EMAIL_MIN_MAX_CHANGE_NOTICES_TO','','text','{}','','',0,0),(90,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invcompany','emailphysicalcountsummaries','STR_EMAIL_PHYSICAL_COUNT_COMPLETE_SUMMARIES_TO','* STR_IF_MORE_THAN_ONE_SEPARATE_BY_COMMAS','text','{}','invadjustmentrequests','',0,0),(91,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invcompany','emailcyclecountsummaries','STR_EMAIL_CYCLE_COUNT_COMPLETE_SUMMARIES_TO','* STR_IF_MORE_THAN_ONE_SEPARATE_BY_COMMAS','text','{}','invadjustmentrequests','',0,0),(92,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invcompany','requireemailpostcycle','STR_REQUIRE_EMAIL_CONFIRMATION_TO_POST_CYCLE_COUNTS','','checkbox','{}','invadjustmentrequests','',0,0),(93,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invcompany','requireemailpostcycleemails','&nbsp;&#9492;&#9472;&nbsp;STR_SEND_CONFIRMATIONS_TO','* STR_IF_MORE_THAN_ONE_SEPARATE_BY_COMMAS','text','{}','invadjustmentrequests','',0,92),(94,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invcompany','requireemailpostphysical','STR_REQUIRE_EMAIL_CONFIRMATION_TO_POST_PHYSICAL_COUNTS','','checkbox','{}','invadjustmentrequests','',0,0),(95,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invcompany','requireemailpostphysicalemails','&nbsp;&#9492;&#9472;&nbsp;STR_SEND_CONFIRMATIONS_TO','* STR_IF_MORE_THAN_ONE_SEPARATE_BY_COMMAS','text','{}','invadjustmentrequests','',0,94),(97,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','stockitemrequireitemlocationprice','STR_REQUIRE_ITEM_LOCATION_PRICE_FOR_STOCK_ITEMS','','checkbox','{}','','',0,0),(98,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','adjustmentsrequirecomments','STR_REQUIRE_COMMENTS_ON_ITEM_ADJUSTMENTS','','checkbox','{}','','',0,0),(99,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','requireuniquevendorproductcodes','STR_REQUIRE_UNIQUE_VENDOR_PRODUCT_CODES','','checkbox','{}','','',0,0),(100,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','senditemspecialpricechangenotices','STR_EMAIL_ITEM_SPECIAL_PRICING_CHANGES','* STR_SENDS_NOTICE_OF_PRICE_CHANGES_TO_PRICE_LIST_ENTRY_USER','checkbox','{}','itempricesspecial','',0,0),(101,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','custoritemglacct','STR_WHICH_GL_ACCT','','checkbox','{}','','',0,0),(102,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','cash','STR_CASH','','autocomplete_gl','{\"account_type_id\":\"10\"}','','',0,0),(103,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','sales','STR_SALES','','autocomplete_gl','{\"account_type_id\":\"50\", \"to_account_type_id\":\"60\"}','','',0,0),(104,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','loss','STR_INVENTORY_LOSS','','autocomplete_gl','{}','','',0,0),(105,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','cost','STR_COST_OF_GOODS','','autocomplete_gl','{\"account_type_id_in\":{\"0\":\"10\",\"1\":\"70\"}}','','',0,0),(106,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','freight','STR_FREIGHT_EXPENSE','','autocomplete_gl','{\"account_type_id_over\":\"70\"}','','',0,0),(107,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','tax','STR_TAX_PAID_EXPENSE','','autocomplete_gl','{\"account_type_id_over\":\"70\"}','','',0,0),(108,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','default_inventoryglacct','STR_DEFAULT_INVENTORY_ACCOUNT','','autocomplete_gl','{\"account_type_id\":\"10\"}','','',0,0),(109,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','costadjustglacctid','STR_DEFAULT_COST_ADJUSTMENT_ACCOUNT','','autocomplete_gl','{}','invbkdn','',0,0),(110,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','invcotransferglaccountid','STR_DEFAULT_INTERCOMPANY_TRANSFER_OFFSET_ACCOUNT','','autocomplete_gl','{}','invcotransfer','',0,0),(111,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','invcotransferburdenglaccountid','STR_INTERBRANCH_TRANSFER_BURDEN_PERCENTAGE_GL_ACCOUNT','','autocomplete_gl','{}','invcotransfer','',0,0),(112,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','invcotransfertransitglaccountid','STR_INVENTORY_IN_TRANSIT_GL_ACCOUNT','','autocomplete_gl','{}','invcotransfer','',0,0),(113,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','accruedpurchasesglid','STR_ACCRUED_PURCHASES','','autocomplete_gl','{}','','',0,0),(117,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','taskbaritem','6343327','STR_ITEM_PAGE_CUSTOMIZER','','taskbaritem','{\"image\":\"{ICON_URL}customer.png\", \"link\":\"javascript:UI.open(\'{NP_BASE_URL}invitempage_define.php?caller=1\')\"}','','invitempage_define.php',0,0),(158,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','salesterritories','STR_SALES_COMMISSIONS_TERRITORY_BASED','','checkbox','{}','','',0,0),(159,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','bestprice','STR_ALWAYS_USE_BEST_PRICE','STR_WILL_USE_LOWEST_PRICE_BETWEEN_STANDARD_AND_CUSTOMER_GROUP','checkbox','{}','CustomerGroups','',0,0),(160,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','salesmanblock','STR_BLOCK_SALESMAN_FROM_SEEING_ORDERS_AND_CUSTOMERS_OTHER_THAN_OWN','STR_SALESMAN_MUST_BE_ATTACHED_TO_SPECIFIC_USER','checkbox','{}','salesmanBlock','',0,0),(161,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','defaulttovendorcost','STR_DEFAULT_ITEM_COSTS_TO_VENDOR_PRICING','','checkbox','{}','defaulttovendorcost','',0,0),(162,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','defaulttostaticcost','STR_DEFAULT_ITEM_COSTS_TO_STATIC_COST','','checkbox','{}','defaulttostaticcost','',0,0),(163,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','defaultorderstostaticcost','STR_DEFAULT_ITEM_COSTS_ON_ORDERS_TO_STATIC_COST_BUT_OVERRIDE_DURING_SHIPPING','','checkbox','{}','','',0,0),(164,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','auto_voucher_number','STR_AUTO_GENERATE_VOUCHER_NUMBER','','checkbox','{}','','',0,0),(165,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','pos_hide_stats','STR_HIDE_INVENTORY_STATS','','checkbox','{}','inventory','',0,0),(166,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','display_profit_pos','STR_DISPLAY_PROFIT','','checkbox','{}','inventory','',0,0),(167,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','display_profit_per_line_pos','STR_DISPLAY_PROFIT_PER_LINE_ITEM','','checkbox','{}','inventory','',0,0),(168,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','display_weights_pos','STR_DISPLAY_WEIGHTS','','checkbox','{}','inventory','',0,0),(169,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','display_linedate_pos','STR_DISPLAY_LINE_ITEM_DATE_BOX','','checkbox','{}','inventory','',0,0),(170,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','display_unit_of_measure','STR_DISPLAY_UNIT_OF_MEASURE','','checkbox','{}','inventory','',0,0),(171,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','posreloadpriceswhenlocationchanges','STR_RELOAD_PRICES_WHEN_SALES_LOCATION_CHANGES','','checkbox','{}','inventory','',0,0),(172,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','showaddl_pos','STR_BY_DEFAULT_START_WITH_ADDITIONAL_ORDER_OPTIONS_WINDOW_OPEN','','checkbox','{}','inventory','',0,0),(173,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','hiderentalnumperiods','STR_HIDE_THE_NUMBER_OF_PERIODS_FOR_RENTAL_ORDERS','','checkbox','{}','rentals','',0,0),(174,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','blockrentalcreditforfirstperiod','STR_BLOCK_RENTAL_CREDIT_FOR_FIRST_PERIOD','','checkbox','{}','rentals','',0,0),(175,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','pos_hide_fulfillment','STR_HIDE_POS_FULFILLMENT_MODE_SWITCH','','checkbox','{}','inventory','',0,0),(176,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','hideposprintinvoice','STR_HIDE_POS_PRINT_INVOICE_BUTTON','','checkbox','{}','','',0,0),(177,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','hidegl_pos','STR_HIDE_GL_INPUTS_ON_POS_SCREEN','STR_ONLY_WORKS_IF_DEFAULT_GL_ACCOUNTS_ARE_SET','checkbox','{}','','',0,0),(178,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','hideqtyperprice','STR_HIDE_QTY_SLASH_PRICE_BOX','','checkbox','{}','','',0,0),(179,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','posblockchilditemsearch','STR_BLOCK_CHILD_ITEMS_FROM_ITEM_LOOKUP','','checkbox','{}','inventory','',0,0),(180,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','showupsshipto','STR_SHOW_UPS_ACCOUNT_BOXES_ON_SHIP_TO_EDIT','TODO: SHOW/HIDE Relevant controls (See adminarcompanyup.php 1266)','checkbox','{}','inventory','',0,0),(181,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','hideshipchargeups','STR_HIDE_SHIPPING_CHARGE_BOXES_IF_UPS_RECEIVER_THIRD_PARTY_OR_CONSIGNEE_CHOSEN','','checkbox','{}','inventory','',0,0),(182,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','showupsshiptopdf','STR_SHOW_UPS_ACCOUNT_ON_INVOICE_PDF_IF_SET','','checkbox','{}','inventory','',0,0),(183,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','requireponumber','STR_REQUIRE_PO_NUMBER_FOR_ORDERS','','checkbox','{}','inventory','',0,0),(184,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','showautocompletecustomercode','STR_SHOW_CUSTOMER_CODE_IN_AUTO_COMPLETE_BOXES','','checkbox','{}','','',0,0),(185,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','preventduplicateshipnames','STR_PREVENT_DUPLICATE_SHIP_NAMES','','checkbox','{}','','',0,0),(186,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','uspsaddressverify','STR_VERIFY_ADDRESSES_VIA_USPS','','checkbox','{}','','',0,0),(187,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','blockfreeinvsales','STR_BLOCK_SALES_OF_ITEMS_WITH_NO_PRICE','','checkbox','{}','','',0,0),(188,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','blocksaleswithoutpurchaseby','STR_BLOCK_SALES_WITHOUT_A_PURCHASED_BY_CONTACT_ASSIGNED','','checkbox','{}','','',0,0),(189,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','blockprofitchangesforstockitems','STR_BLOCK_ITEM_PROFIT_CHANGES_FOR_STOCK_ITEMS','','checkbox','{}','','',0,0),(190,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','blocknondirectglentryediting','STR_BLOCK_NON_DIRECT_GL_ENTRY_EDITING','','checkbox','{}','','',0,0),(191,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','requirereasonforardeletions','STR_REQUIRE_EXPLANATION_TO_DELETE_ORDERS_INVOICES_AND_PAYMENTS','','checkbox','{}','','',0,0),(192,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','ardeletionnoticesadmin','STR_SEND_EMAIL_TO_ADMINS_WHEN_ORDERS_INVOICES_OR_PAYMENTS_DELETED','','checkbox','{}','','',0,0),(193,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','blockitemsnotforsale','STR_BLOCK_NOT_FOR_SALE_ITEM_SELECTION_ON_ORDERS','','checkbox','{}','3dcart','',0,0),(194,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','blockshiptoeditsonorderentry','STR_DO_NOT_ALLOW_SHIP_TO_ADDRESS_EDITS_ON_ORDERS','','checkbox','{}','','',0,0),(195,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','limitedshiptoaddressentry','STR_LIMIT_SHIP_TO_ENTRY_TO_ONLY_KNOWN_CITIES_AND_ZIP_CODES','','checkbox','{}','','',0,0),(197,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','blockinvoiceunpost','STR_INVOICE_UNPOSTING','','select','{\"options\":{\"0\":\"STR_ALLOW\",\"1\":\"STR_BLOCK_UNPOSTING_INVOICES\",\"2\":\"STR_BLOCK_UNPOSTING_INVOICES_AFTER_INVOICE_DATE\"}}','','',1,0),(198,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','pricehistoryautodisplay','STR_AUTOMATICALLY_SHOW_PRICE_HISTORY_PAGE_WHEN_ORDERING','','checkbox','{}','pricehistory','',0,0),(199,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','pricehistorymax','STR_MAX_PRICE_HISTORY_RECORDS_TO_SHOW','','select','{\"options\":{\"0\":\"STR_SHOW_ALL\",\"5\":\"5\",\"10\":\"10\",\"15\":\"15\",\"20\":\"20\",\"50\":\"50\",\"100\":\"100\"}}','pricehistory','',1,0),(200,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','pos_hide_discounts','STR_DISCOUNTS_ENTRY','','select','{\"options\":{\"0\":\"STR_SHOW_DISCOUNTS_ENTRY\",\"1\":\"STR_HIDE_DISCOUNTS_ENTRY\",\"2\":\"STR_HIDE_ONLY_WHOLE_ORDER_DISCOUNTS_ENTRY\"}}','','',1,0),(201,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','surveyorder','STR_SEND_SURVEY_WHEN_FULFILLMENT_ORDER_CREATED','','select_arsurvey','{\"include_blank\":true}','','',0,0),(202,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','default_order_message','STR_DEFAULT_ORDER_NOTE','','textarea','{}','','',2,0),(203,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','defaultquoteprintnote','STR_DEFAULT_QUOTE_PRINTOUT_NOTE','','textarea','{}','','',2,0),(204,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_ZLIEN/','arcompany','zlienkey','STR_API_KEY','','text','{}','','',0,0),(205,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_ZLIEN/','arcompany','zliensecret','STR_API_SECRET','','text','{}','','',0,0),(206,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_ZLIEN/','arcompany','zlienurl','STR_API_URL','','text','{}','','',0,0),(207,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_ZLIEN/','arcompany','zlienportalurl','STR_PORTAL_URL','','text','{}','','',0,0),(208,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_BILLTRUST/','arcompany','billtrust_host','STR_FTP_HOST','','text','{}','','',0,0),(209,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_BILLTRUST/','arcompany','billtrust_user','STR_FTP_USER','','text','{}','','',0,0),(210,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_BILLTRUST/','arcompany','billtrust_pass','STR_FTP_PASSWORD','','password','{}','','',0,0),(211,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','ccprocessorid','STR_DEFAULT_CREDIT_CARD_ACCOUNT','','select_ccaccount','{}','','',0,0),(212,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','checkacctid','STR_PAYMENT_BANK_ACCOUNT','','select_checkacct','{\"account_type\":\"ar\"}','','',0,0),(213,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','b2bccprocessorid','STR_DEFAULT_CREDIT_CARD_ACCOUNT_FOR_B2B','','select_ccaccount','{\"include_blank\":true}','','',0,0),(214,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','minfincharge','STR_MINIMUM_FINANCE_FEE','','currency','{}','pay_finchg','',0,0),(215,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','b2bdefaultinventorylocationid','STR_B2B_PAYMENT_LOCATION','','select_inventorylocation_unlimited','{\"include_company_default_option\":true}','glcostcodes','',0,0),(216,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','paid_on_account_itemid','STR_PAID_ON_ACCOUNT_ITEM_CODE','','autocomplete_item','{\"include_company_default_option\":true}','hubconstruction','',0,0),(217,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','dailyclosevariancemethod','STR_DAILY_CLOSE_OVER_SHORT_METHOD','','select','{}','glcostcodes','',0,0),(218,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','allowdiscountoverride','STR_ALLOW_DISCOUNT_OVERRIDE_WHEN_ENTERING_PAYMENTS','','checkbox','{}','','',0,0),(219,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','inventoryusetax','STR_INVENTORY_USE_TAX','','text','{}','inventoryusetax','',0,0),(220,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','bankdepositautoselect','STR_AUTO_SELECT_PAYMENTS_ON_BANK_DEPOSIT_ADD_PAGE','','checkbox','{}','','',0,0),(221,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','allowcreditdiscount','STR_ALLOW_DISCOUNTS_FOR_CREDIT_INVOICES_ON_PAYMENT_PAGE','','checkbox','{}','','',0,0),(222,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','hidepaymententryafterpos','STR_HIDE_PAYMENT_ENTRY_AFTER_POS','','checkbox','{}','','',0,0),(223,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','hideposprintuntilafterpayment','STR_HIDE_POS_PRINT_OPTIONS_UNTIL_AFTER_PAYMENT','','checkbox','{}','','',0,0),(224,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','hideaccruedinterestonpayment','STR_HIDE_ACCRUED_INTEREST_ON_PAYMENT_PAGE','','checkbox','{}','','',0,0),(225,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','hideenterinterestonpayment','STR_HIDE_INTEREST_ENTRY_ON_PAYMENT_PAGE','','checkbox','{}','','',0,0),(226,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','showlocationonpaymentpage','STR_SHOW_INVENTORY_LOCATION_OPTIONS_ON_PAYMENT_PAGE','','checkbox','{}','','',0,0),(227,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','enterpayments_readonlyinventorylocation','STR_READ_ONLY_INVENTORY_LOCATION_ON_PAYMENT_PAGE','','checkbox','{}','','',0,0),(228,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','showcostcodeonpaymentpage','STR_SHOW_COST_CODE_OPTIONS_ON_PAYMENT_PAGE','','checkbox','{}','glcostcodes','',0,0),(229,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/','arcompany','canadianefttype','STR_CANADIAN_EFT_FORMAT','','select','{\"options\":{\"G\":\"STR_STANDARD\",\"C\":\"STR_CIBC\"}}','eftcanada','',0,0),(230,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/b:STR_WRITEOFFS/','arcompany','writeoffmax','STR_MAX_AMOUNT','','currency','{}','writeoffs','',0,0),(231,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/b:STR_WRITEOFFS/','arcompany','writeoffmaxperc','STR_MAX_PERCENTAGE','','number','{}','writeoffs','',0,0),(232,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/b:STR_CREDIT_CARD/','arcompany','requirecccardcode','STR_REQUIRE_CC_CARD_CODE','','checkbox','{}','','',0,0),(233,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/b:STR_CREDIT_CARD/','arcompany','requireccbillingaddress','STR_REQUIRE_CC_BILLING_ADDRESS','','checkbox','{}','','',0,0),(234,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/b:STR_PAYMENT_ON_ACCOUNT/','arcompany','paymentonaccountbankaccount','STR_POA_BANK_ACCOUNT','','select_ccaccount','{\"account_type\":\"ar\"}','paymentonaccount','',0,0),(235,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/b:STR_PAYMENT_ON_ACCOUNT/','arcompany','paymentonaccountalwayscollectconveniencefee','STR_ALWAYS_COLLECT_CONVENIENCE_FEE','','checkbox','{\"account_type\":\"ar\"}','paymentonaccount&&b2b','',0,0),(236,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/b:STR_FORCE_CHECKING_ACCOUNT_FOR_PAYMENTS/','arcompany','forcecheckingaccountidforposfo','STR_INCOME -> STR_ORDERS -> STR_POS<br>&amp;STR_INCOME -> STR_ORDERS -> STR_FULFILLMENT_ORDER','','select_checkacct','{\"account_type\":\"ar\", \"include_blank\":true}','','',0,0),(237,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','createjobwithnewcustomer','STR_CREATE_NEW_JOB_WITH_EACH_NEW_CUSTOMER','','checkbox','{\"account_type\":\"ar\"}','','',0,0),(238,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','hideaddjobbuttons','STR_HIDE_ADD_JOB_BUTTONS','','checkbox','{\"account_type\":\"ar\"}','','',0,0),(239,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','hidejobnamecolumn','STR_HIDE_JOB_NAME_COLUMN_IN_JOBS_TABLE','','checkbox','{\"account_type\":\"ar\"}','','',0,0),(240,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','jobsrequirescustomer','STR_JOBS_MUST_HAVE_CUSTOMER_SET','','checkbox','{\"account_type\":\"ar\"}','','',0,0),(241,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','lockjobcodes','STR_LOCK_JOB_CODES','','checkbox','{\"account_type\":\"ar\"}','','',0,0),(242,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','convertdeferredrevenueandexpensesonjobclose','STR_CONVERT_DEFERRED_REVENUE_AND_EXPENSES_WHEN_CLOSING_JOBS','','checkbox','{\"account_type\":\"ar\"}','','',0,0),(243,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','notifysalespersonfornewjobs','STR_NOTIFY_SALES_PERSON_FOR_NEW_JOBS','','checkbox','{\"account_type\":\"ar\"}','','',0,0),(244,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','joblinkcontractprelimdates','STR_LINK_PRELIM_DATE_AND_CONTRACT_DATE','','checkbox','{\"account_type\":\"ar\"}','contractorsupply','',0,0),(245,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','daystoprelim','STR_DAYS_TO_PRELIM','','number','{\"account_type\":\"ar\"}','contractorsupply','',0,0),(246,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','nextjobcode','STR_NEXT_JOB_CODE','','number','{\"account_type\":\"ar\"}','','',0,0),(247,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','jobcreditmarkup','STR_JOB_CREDIT_LIMIT_MARKUP','STR_BASED_ON_PRELIM_AMOUNT','text','{\"account_type\":\"ar\"}','hubconstruction','',0,0),(248,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','defaultjobshippingmethod','STR_DEFAULT_JOB_SHIPPING_METHOD','','select_carrierservice','{\"add_options\":{\"0\":\"STR_USE_CUSTOMER_DEFAULT\"}}','','',0,0),(249,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','jobprelimcreditlimit','STR_JOB_CREDIT_LIMIT_DEFAULT','','text','{}','','',0,0),(250,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_BASIC/','arcompany','defaultprelimrequestsearchminimumopenamount','STR_DEFAULT_PRELIM_REQUEST_SEARCH_MIN_OPEN_AMOUNT','','text','{}','','',0,0),(251,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/h:STR_PRELIM_REQUEST_EMAIL_OPTIONS/','arcompany','prelimtemplate','STR_PRELIM_REQUEST_TEMPLATE','','file','{}','','',0,0),(252,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','surveyinvoice','STR_SEND_SURVEY_WHEN_POS_INVOICE_CREATED','','select_arsurvey','{\"rows\":6}','','',0,0),(254,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_GENERAL/h:STR_BASIC/','arcompany','blockrentalsfornocreditcustomers','STR_BLOCK_RENTALS_FOR_CUSTOMERS_MARKED_AS_NO_CREDIT','','checkbox','{}','rentals','',0,0),(255,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_PAYMENT/b:STR_FORCE_CHECKING_ACCOUNT_FOR_PAYMENTS/','arcompany','forcecheckingaccountidforenterpayments','STR_INCOME -> STR_PAYMENTS -> STR_ENTER_PAYMENTS','','select_checkacct','{\"account_type\":\"ar\", \"include_blank\":true}','','',0,0),(256,'m:STR_TOOLS/m:STR_EXPORTS/m:STR_INVOICE_DELIVERY/s:STR_BULLPINNING_INVOICES/','arcompany','invoicedeliverybullpinningenabled','STR_BULLPINNING_ENABLED','','checkbox','{}','','adminarcompanyupd.php',0,0),(257,'m:STR_TOOLS/m:STR_EXPORTS/m:STR_INVOICE_DELIVERY/s:STR_BULLPINNING_INVOICES/','arcompany','invoicedeliverybullpinningexcludeafterdays','STR_EXCLUDE_AFTER_DAYS','','number','{\"step\":1, \"min\":0}','','adminarcompanyupd.php',0,0),(258,'m:STR_TOOLS/m:STR_EXPORTS/m:STR_INVOICE_DELIVERY/s:STR_BULLPINNING_INVOICES/','arcompany','invoicedeliverybullpinningexcludecustomersover','STR_EXCLUDE_CUSTOMERS_WITH_INVOICES_TOTALING_OVER','* STR_SET_AS_ZERO_TO_DISABLE','currency','{\"min\":0}','','adminarcompanyupd.php',0,0),(259,'m:STR_TOOLS/m:STR_EXPORTS/m:STR_INVOICE_DELIVERY/s:STR_BULLPINNING_INVOICES/','arcompany','invoicedeliverybullpinningexcludeinvoicesover','STR_EXCLUDE_INVOICES_WITH_TOTAL_OVER','* STR_SET_AS_ZERO_TO_DISABLE','currency','{\"min\":0}','','adminarcompanyupd.php',0,0),(260,'m:STR_TOOLS/m:STR_EXPORTS/m:STR_INVOICE_DELIVERY/s:STR_BULLPINNING_INVOICES/','arcompany','invoicedeliverybullpinningexcludelastdayofmonth','STR_EXCLUDE_ALL_ON_LAST_DAY_OF_MONTH','','checkbox','{}','','adminarcompanyupd.php',0,0),(261,'m:STR_TOOLS/m:STR_EXPORTS/m:STR_INVOICE_DELIVERY/s:STR_BULLPINNING_INVOICES/','arcompany','invoicedeliverybullpinningexcludeallinvoiceswhenanypending','STR_EXCLUDE_ALL_INVOICES_FOR_CUSTOMER_WHEN_CUSTOMER_HAS_ANY_INVOICES_TO_BE_SENT','','checkbox','{}','','adminarcompanyupd.php',0,0),(262,'m:STR_TOOLS/m:STR_EXPORTS/m:STR_INVOICE_DELIVERY/s:STR_BULLPINNING_INVOICES/','arcompany','invoicedeliverybullpinningexcludeemail','STR_EXCLUDE_DELIVERY_TYPES','','checkbox','{\"addtext\":\"STR_EMAIL\"}','','adminarcompanyupd.php',0,0),(263,'m:STR_TOOLS/m:STR_EXPORTS/m:STR_INVOICE_DELIVERY/s:STR_BULLPINNING_INVOICES/','arcompany','invoicedeliverybullpinningexcludefax','','','checkbox','{\"addtext\":\"STR_FAX\"}','','adminarcompanyupd.php',0,262),(264,'m:STR_TOOLS/m:STR_EXPORTS/m:STR_INVOICE_DELIVERY/s:STR_BULLPINNING_INVOICES/','arcompany','invoicedeliverybullpinningexcludemail','','','checkbox','{\"addtext\":\"STR_MAIL\"}','','adminarcompanyupd.php',0,262),(265,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invcompany','sendcountitemaddednotice','STR_SEND_NOTICE_WHEN_ITEM_ADDED_TO_COUNT','* STR_SENDS_TO_INVENTORY_LOCATION_CONTACT','checkbox','{}','invadjustmentrequests','',0,0),(266,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','sendtransfernoticestoentryuser','STR_SEND_TRANSFER_NOTICES_TO_ENTRY_USER','','checkbox','{}','invcotransfer','',0,0),(267,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','discearn','STR_DISCOUNT','','radios','{\"options\":{\"0\":\"STR_DISCOUNT_LOST\",\"1\":\"STR_DISCOUNT_EARNED\"}}','','',0,0),(268,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','glcommissionid','STR_COMMISSION_EXPENSE','','autocomplete_glaccount','{\"account_type_id_over\":\"70\"}','commissions','',0,0),(269,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','servicecharges','STR_BANK_SERVICE_CHARGES','','autocomplete_glaccount','{\"account_type_id_over\":\"70\"}','','',0,0),(270,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','usetransactiondate','STR_USE_TODAY_AS_TRANSACTION_DATE','','checkbox','{}','','',0,0),(271,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','default_vendor_termsid','STR_DEFAULT_PAYMENT_TERMS','','select_payterms_ap','{}','','',0,0),(272,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','default_checkacctid','STR_DEFAULT_PAYMENT_ACCOUNT','','select_checkacct','{}','','',0,0),(273,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','defaultcostcodeid','STR_DEFAULT_COST_CODE','','autocomplete_costcode','{}','glcostcodes','',0,0),(274,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','defaultglcategoryid','STR_DEFAULT_GL_CATEGORY','','autocomplete_glcategory','{}','glcategories','',0,0),(275,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','hidecostcodes','STR_HIDE_AP_COST_CODE_FIELDS','','checkbox','{}','glcostcodes','',0,0),(276,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','hideendorser','STR_HIDE_CHECK_ENDORSER_BOXES','','checkbox','{}','','',0,0),(277,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','blocknewbillglautofill','STR_BLOCK_GL_AUTO_FILL_FOR_NEW_BILLS','','checkbox','{}','','',0,0),(278,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','paymentemailtemplateid','STR_DEFAULT_PAYMENT_EMAIL_TEMPLATE','','select_emailtemplate','{\"emailtemplateaction\":\"chk\", \"add_options\":{\"0\":\"\"}}','emailtemplates','',0,0),(279,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','emailpaymenttypes','STR_SEND_EMAILS_FOR_WHICH_PAYMENT_TYPES',' * STR_EMAIL_TEMPLATE_MUST_BE_SET','paymeth_serialized','{}','emailtemplates','',0,0),(280,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','maxsingleeftamount','STR_MAX_SINGLE_EFT_TRANSACTION_AMOUNT','','currency','{}','usaepayeft','',0,0),(281,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','maxdailyeftamount','STR_MAX_SINGLE_EFT_TRANSACTION_AMOUNT','','currency','{}','usaepayeft','',0,0),(282,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','showposcashpurchaselink','STR_SHOW_PURCHASE_FROM_CASH_DRAWER_LINK_ON_POS','','checkbox','{}','','',0,0),(283,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','autogenvendorcode','STR_GENERATE_VENDOR_CODE_FOR_NEW_VENDORS','','checkbox','{}','','',0,0),(284,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','nextvendorcode','STR_NEXT_VENDOR_CODE','','text','{}','','',0,0),(285,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','hidevendoraddinpo','STR_HIDE_VENDOR_ADD_IN_PO_PROCESS','','checkbox','{}','','',0,0),(286,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','showccbillsinseparatetab','STR_SHOW_CC_BILLS_IN_SEPARATE_TAB',' * STR_WILL_BE_INCLUDED_IN_VENDOR_BILLS_TAB_IF_NOT_CHECKED','checkbox','{}','CCPurchases','',0,0),(287,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PREAPPROVE_BILLS/','apcompany','must_preapprove','STR_BILLS_MUST_BE_PREAPPROVED_BEFORE_PAYMENT','','checkbox','{}','','',0,0),(288,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PREAPPROVE_BILLS/','apcompany','round_preapprove_pay_date','STR_ROUND_DEFAULT_PAY_DATE_ON_PREAPPROVED','','select','{\"options\":{\"0\":\"STR_NO_ROUNDING\",\"N\":\"STR_ROUND_NEAREST\",\"U\":\"STR_ALWAYS_ROUND_UP\",\"D\":\"STR_ALWAYS_ROUND_DOWN\"}}','','',0,0),(289,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PREAPPROVE_BILLS/','apcompany','forcediscount','STR_FORCE_DISCOUNTS_TO_BE_TAKEN',' * STR_TAKE_DISCOUNT_EVEN_IF_PAYING_AFTER_DISCOUNT_DATE','checkbox','{}','','',0,0),(290,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PREAPPROVE_BILLS/','apcompany','round_preapprove_dates','STR_ROUND_TO_DATES','','text','{}','','',0,0),(291,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PREAPPROVE_BILLS/','apcompany','round_preapprove_holiday','STR_ROUND_TO_AFTER_HOLIDAY','','checkbox','{}','','',0,0),(292,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PREAPPROVE_BILLS/','apcompany','round_preapprove_weekend','STR_ROUND_TO_AFTER_WEEKEND','','checkbox','{}','','',0,0),(293,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PREAPPROVE_BILLS/','apcompany','apbills_approver_count','STR_REQUIRED_NUMBER_OF_APPROVERS_PER_BILL','','number','{}','','',0,0),(294,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PREAPPROVE_BILLS/','apcompany','apbills_approver_check_initials','STR_SHOW_APPROVERS_INITIALS_ON_CHECK_STUB','','checkbox','{}','','',0,0),(295,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PREAPPROVE_BILLS/','apcompany','apbills_approver_limit_users','STR_WHO_CAN_APPROVE_BILLS','','select','{\"options\":{\"0\":\"STR_STANDARD_ACCESS\",\"1\":\"STR_ONLY_SPECIFIC_USERS\"}}','','',0,0),(296,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PREAPPROVE_BILLS/','apcompany','apbills_approver_notices','STR_SEND_EMAIL_NOTICES_WHEN_BILL_APPROVED',' * STR_WHO_CAN_APPROVE_BILLS: STR_ONLY_SPECIFIC_USERS','checkbox','{}','','',0,295),(297,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','sellqtyonly_poentry','STR_PO_ENTRY_ONLY_ENTER_SELL_QUANTITY','','checkbox','{}','','',0,0),(298,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','hidepoentryinvgl','STR_PO_ENTRY_HIDE_GL_ACCOUNT_FIELD','','checkbox','{}','','',0,0),(299,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','pouselastcost','STR_ALWAYS_USE_LAST_COST_AND_NOT_VENDOR_PRICING','','checkbox','{}','','',0,0),(300,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','noshowsell_onpo','STR_SHOW_PURCHASE_QUANTITY_ONLY_ON_PO_CHECKLIST','','checkbox','{}','','',0,0),(301,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','noshow_prices_on_po','STR_DO_NOT_SHOW_PRICES_ON_PO','','checkbox','{}','','',0,0),(302,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','hidesalesordernumber','STR_DO_NOT_SHOW_SALES_ORDER_NUMBER_ON_PO','','checkbox','{}','','',0,0),(303,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','hidepohtml','STR_DO_NOT_SHOW_HTML_PO_VERSION_OPTION','','checkbox','{}','','',0,0),(304,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','showinternal_itemcode','STR_SHOW_INTERNAL_ITEMCODE_ON_PO','','checkbox','{}','','',0,0),(305,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','updatevendorprice','STR_UPDATE_VENDOR_PRICES_AT_PO_TO_AP','','checkbox','{}','','',0,0),(306,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','defaultqtyreceivedtozero','STR_DEFAULT_QUANTITY_RECEIVED_TO_ZERO','','checkbox','{}','','',0,0),(307,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','dismisspoitemimportpopupwarning','STR_DISMISS_PO_ITEM_IMPORT_POPUP_WARNING','','checkbox','{}','','',0,0),(308,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','emailassociatedordersalesmanonreceive','STR_EMAIL_ASSOCIATED_ORDER_SALESMAN_ON_RECEIVE','','checkbox','{}','','',0,0),(309,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','blockchangingpovendorterms','STR_BLOCK_CHANGING_PO_VENDOR_TERMS','','checkbox','{}','','',0,0),(310,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','ponumberseq','id','STR_LAST_PO_NUMBER_USED_NUMBERS_ONLY','','number','{}','','',0,0),(311,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','addlocationcodetoponumber','STR_ADD_INVENTORY_LOCATION_CODE_TO_END_OF_PO_NUMBERS','','checkbox','{}','','',0,0),(312,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','poheaderinventorylocationid','STR_LOCATION_FOR_PO_HEADER','','select_inventorylocation_unlimited','{\"add_options\":{\"0\":\"STR_USE_COMPANY_INFO\"}}','','',0,0),(313,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','dropshipcarrierserviceid','STR_DROP_SHIP_DEFAULT_SHIPPING_METHOD','','select_carrierservice','{}','','',0,0),(314,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','polimititemstoassignedvendorsstock','STR_CAN_ONLY_PURCHASE_FROM_ASSIGNED_VENDORS','','checkbox','{\"addtext\":\"STR_INVENTORY_TYPE - STR_STOCKED\"}','','',0,0),(315,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','polimititemstoassignedvendorsother','','','checkbox','{\"addtext\":\"STR_INVENTORY_TYPE - STR_OTHER_CHARGES\"}','','',0,316),(316,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','polimititemstoassignedvendorsnonstock','','','checkbox','{\"addtext\":\"STR_INVENTORY_TYPE - STR_NON_STOCKED\"}','','',0,314),(317,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','po_pdf_fontsize','STR_DEFAULT_PO_FONT_SIZE','','number','{\"min\":8, \"max\":24, \"step\":1}','','',0,0),(318,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','default_po_message','STR_PURCHASE_ORDER_DEFAULT_MESSAGE','','textarea','{}','','',0,0),(319,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','fromemailforpo','STR_EMAIL_PURCHASE_ORDERS_FROM_ADDRESS','','text','{}','','',0,0),(320,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','fromemailforvendorinsurancerequests','STR_EMAIL_VENDOR_CERTIFICATE_REQUESTS_FROM_ADDRESS','','text','{}','','',0,0),(321,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','po_pdf_columns','STR_PO_TABLE_FORMAT','','popdftablecontrol','{}','','',1,0),(322,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL_LEDGER/','apcompany','payable','STR_PAYABLES','','autocomplete_glaccount','{\"account_type_id\":10}','','',0,0),(323,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL_LEDGER/','apcompany','interestexpense','STR_INTEREST_EXPENSE','','autocomplete_glaccount','{\"account_type_id_over\":70}','','',0,0),(324,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL_LEDGER/','apcompany','discount','STR_DISCOUNT_ACCOUNT','','autocomplete_glaccount','{\"account_type_id_over\":70}','','',0,0),(325,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL_LEDGER/','apcompany','glcashid','STR_CASH_PAYMENT','','autocomplete_glaccount','{\"account_type_id\":10}','','',0,0),(326,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL_LEDGER/','apcompany','glccid','STR_CREDIT_CARD_PAYMENT','','autocomplete_glaccount','{\"account_type_id\":10}','','',0,0),(327,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL_LEDGER/','apcompany','pendingcreditsglaccountid','STR_PENDING_VENDOR_CREDITS','','autocomplete_glaccount','{\"account_type_id\":21}','','',0,0),(328,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_FORMATTING/','apcompany','poformat','STR_PURCHASE_ORDER_FORMAT','','select','{\"options\":{\"0\":\"STR_STANDARD_PRINT\",\"1\":\"STR_SUPRESS_HEADER_FOR_PREPRINT\",\"2\":\"STR_NAME_AND_ADDRESS_LEFT_SIDE\",\"3\":\"STR_NAME_AND_ADDRESS_RIGHT_SIDE_WITH_LOGO\",\"4\":\"STR_STANDARD_PRINT_WITH_LONG_ITEM_CODES\"}}','','',0,0),(329,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_FORMATTING/','apcompany','invpoemailtemplateid','STR_PURCHASE_ORDER_EMAIL_TEMPLATE','','select_emailtemplate','{\"emailtemplateaction\":\"invpo\", \"add_options\":{\"0\":\"\"}}','emailtemplates','',0,0),(330,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_FORMATTING/','apcompany','noboxes_on_po','STR_NO_BOXES_ON_PO_SHIPTO_VENDOR_ETC','','checkbox','{}','','',0,0),(331,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_FORMATTING/','apcompany','suppress_linenum_po','STR_SUPPRESS_LINE_NUMBER_ON_PO_CHECKLIST','','checkbox','{}','','',0,0),(332,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_FORMATTING/','apcompany','poshowmainpagenotesinheader','STR_SHOW_MAIN_PAGE_NOTE_IN_PO_HEADER','','checkbox','{}','','',0,0),(333,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_FORMATTING/','apcompany','podate','STR_PURCHASE_ORDER_DATE_FORMAT','','select','{\"options\":{\"0\":\"YYYY-MM-DD\",\"1\":\"MM-DD-YYYY\",\"2\":\"MONTH DD, YYYY\"}}','','',0,0),(334,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_FORMATTING/','apcompany','adjusty1099','STR_1099_ADJUST_TOP_WHEN_PRINTING','','text','{}','irs1099','',0,0),(335,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_FORMATTING/','apcompany','adjustx1099','STR_1099_ADJUST_SIDE_WHEN_PRINTING','','text','{}','irs1099','',0,0),(336,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO_CHECK_LIST/','apcompany','pochecklistsortorder','STR_SORT_ORDER','','select','{\"options\":{\"L\":\"STR_LINE_NUMBER\",\"I\":\"STR_ITEM_CODE\"}}','','',0,0),(337,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO_CHECK_LIST/','apcompany','pochecklist_pdf_pricelevel_id','STR_PRICE_LEVEL','','select_pricelevel','{\"add_options\":{\"0\":\"STR_DEFAULT\"}}','','',0,0),(338,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO_CHECK_LIST/','apcompany','pochecklist_pdf_cost_method','STR_INVENTORY_COST_METHOD','','select','{\"options\":{\"D\":\"STR_DEFAULT\",\"F\":\"STR_FIFO\",\"W\":\"STR_WEIGHTED_AVERAGE\",\"L\":\"STR_LIFO\",\"A\":\"STR_AS_ORDERED\"}}','','',0,0),(339,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO_CHECK_LIST/','apcompany','pochecklist_pdf_columns','STR_PO_CHECKLIST_TABLE_FORMAT','','pochecklistpdftablecontrol','{}','','',1,0),(340,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PREAPPROVE_BILLS/','apcompany','which_preapprove_ckdate','STR_USE_PREAPPROVAL_DATE_AS_CHECK_DATE',' * STR_ONLY_APPLIES_IF_PREAPPROVING_PAYMENT','radios','{\"options\":{\"0\":\"STR_USE_PREAPPROVAL_DATE\",\"1\":\"STR_USE_CUTOFF_APPROVAL_DATE\"}}','','',0,0),(341,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL_LEDGER/','apcompany','feesgl','STR_MGMT_EXPENSE_FEE','','autocomplete_glaccount','{}','pm','',0,0),(342,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL_LEDGER/','apcompany','retax_liability','STR_REAL_ESTATE_TAX_LIABILITY','','autocomplete_glaccount','{}','pm','',0,0),(343,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL_LEDGER/','apcompany','retax_escrow','STR_REAL_ESTATE_TAX_ESCROW','','autocomplete_glaccount','{}','pm','',0,0),(344,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL_LEDGER/','apcompany','retax_expense','STR_REAL_ESTATE_TAX_EXPENSE','','autocomplete_glaccount','{}','pm','',0,0),(345,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','blockjobfields','STR_HIDE_JOB_FIELDS','','checkbox','{}','construction','',0,0),(346,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL/','apcompany','allowdiscountoncredits','STR_ALLOW_DISCOUNTS_ON_CREDITS','','checkbox','{}','','',0,0),(347,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_GENERAL_LEDGER/','apcompany','glrestockfeeid','STR_PO_RETURN_RESTOCK_FEE','','autocomplete_glaccount','{}','inventory','',0,0),(348,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_FORMATTING/','apcompany','subtotalsonchecks','STR_SHOW_SUBTOTALS_ON_CHECKS','','checkbox','{}','','',0,0),(349,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','userscanchangevendorproductcodesduringpoentry','STR_USERS_CAN_CHANGE_VENDOR_PRODUCT_CODES_DURING_PO_ENTRY','','checkbox','{}','','',0,0),(350,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL/','invcompany','invcotransfertitles','STR_TRANFER_TITLES','','select','{\"options\":{\"0\":\"STR_USER_CAN_ENTER_ANY_TITLE\",\"1\":\"STR_FROM_APPOVED_LIST_ONLY\"}}','','',0,0),(351,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_GENERAL_LEDGER/','invcompany','itemsinvoicingusesglsetupwhen','STR_ITEM_INVOICING_USES_ACCOUNTS_SET','','select','{\"options\":{\"0\":\"STR_AT_TIME_OF_ORDER_ENTRY\",\"1\":\"STR_AT_TIME_OF_INVOICING\"}}','','',-1,0),(352,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','adjustpoqtywhenarorderqtychanges','STR_ADJUST_QTY_ON_PO_WHEN_CUSTOMER_ORDER_QTY_CHANGES','','checkbox','{}','','',0,0),(353,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','apcompany','adjustpocostwhenarordercostchanges','STR_ADJUST_COST_ON_PO_WHEN_CUSTOMER_ORDER_COST_CHANGES','','checkbox','{}','','',0,0);
/*!40000 ALTER TABLE `settingsmap` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `settingsmappath`
--

DROP TABLE IF EXISTS `settingsmappath`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `settingsmappath` (
  `id` int(11) NOT NULL auto_increment,
  `path` text NOT NULL,
  `features` tinytext,
  `npmodrightskey` tinytext,
  `params` text,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `uniq` (`path`(512))
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `settingsmappath`
--

LOCK TABLES `settingsmappath` WRITE;
/*!40000 ALTER TABLE `settingsmappath` DISABLE KEYS */;
INSERT INTO `settingsmappath` VALUES (2,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/','','admininvglacct.php','{}'),(4,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_ZLIEN/','zlien','','{}'),(5,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_BILLTRUST/','billtrust','','{}'),(6,'m:STR_ADMIN/m:STR_BILLING/m:STR_COMPANY_OPTIONS/t:STR_GENERAL/s:STR_CONSTRUCTION/','construction','','{}'),(7,'m:STR_ADMIN/m:STR_INVENTORY/m:STR_COMPANY_OPTIONS/s:STR_COUNT_MANAGEMENT/','invadjustmentrequests','','{}'),(8,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/','','adminapglacct.php','{}'),(9,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO/','inventory','','{}'),(10,'m:STR_ADMIN/m:STR_PAYABLES/m:STR_GENERAL_SETUP/s:STR_PO_CHECK_LIST/','inventory','','{}');
/*!40000 ALTER TABLE `settingsmappath` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `setup`
--

DROP TABLE IF EXISTS `setup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `setup` (
  `billing` int(11) NOT NULL default '0',
  `inventory` int(11) NOT NULL default '0',
  `payroll` int(11) NOT NULL default '0',
  `payable` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `gl` int(11) NOT NULL default '0',
  `admin` int(11) NOT NULL default '0',
  `id` int(11) NOT NULL auto_increment,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `setup`
--

LOCK TABLES `setup` WRITE;
/*!40000 ALTER TABLE `setup` DISABLE KEYS */;
INSERT INTO `setup` VALUES (0,0,0,0,1,0,0,1),(0,0,0,0,0,0,0,2);
/*!40000 ALTER TABLE `setup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shippingroute`
--

DROP TABLE IF EXISTS `shippingroute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shippingroute` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  `gencompanyid` int(11) NOT NULL,
  `entryuserid` int(11) NOT NULL,
  `entrydate` datetime default NULL,
  `cancel` tinyint(1) NOT NULL,
  `canceluserid` int(11) NOT NULL,
  `canceldate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL,
  `lastchangedate` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shippingroute`
--

LOCK TABLES `shippingroute` WRITE;
/*!40000 ALTER TABLE `shippingroute` DISABLE KEYS */;
/*!40000 ALTER TABLE `shippingroute` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shippingroutedetail`
--

DROP TABLE IF EXISTS `shippingroutedetail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shippingroutedetail` (
  `id` int(11) NOT NULL auto_increment,
  `shippingrouteid` int(11) NOT NULL,
  `zip` char(10) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `route` (`shippingrouteid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shippingroutedetail`
--

LOCK TABLES `shippingroutedetail` WRITE;
/*!40000 ALTER TABLE `shippingroutedetail` DISABLE KEYS */;
/*!40000 ALTER TABLE `shippingroutedetail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shipto`
--

DROP TABLE IF EXISTS `shipto`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shipto` (
  `id` int(11) NOT NULL auto_increment,
  `defaultshipvia` double NOT NULL default '1',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `address1` varchar(100) NOT NULL default '',
  `address2` varchar(100) NOT NULL default '',
  `mailstop` varchar(20) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  `state` varchar(20) NOT NULL default '',
  `zip` varchar(15) NOT NULL default '',
  `country` varchar(20) NOT NULL default '',
  `phone1` varchar(20) NOT NULL default '',
  `phone1comment` varchar(20) NOT NULL default '',
  `phone2` varchar(20) NOT NULL default '',
  `phone2comment` varchar(20) NOT NULL default '',
  `phone3` varchar(20) NOT NULL default '',
  `phone3comment` varchar(20) NOT NULL default '',
  `phone4` varchar(20) NOT NULL default '',
  `phone4comment` varchar(20) NOT NULL default '',
  `email1` varchar(255) NOT NULL default '',
  `email2` varchar(255) NOT NULL default '',
  `email1comment` varchar(20) NOT NULL default '',
  `email2comment` varchar(20) NOT NULL default '',
  `customerid` int(11) NOT NULL default '0',
  `shipname` varchar(50) NOT NULL default '',
  `entry_firstname` varchar(32) NOT NULL default '',
  `entry_lastname` varchar(32) NOT NULL default '',
  `entry_country_id` int(5) NOT NULL default '0',
  `entry_zone_id` int(5) NOT NULL default '0',
  `dummy_record` tinyint(1) NOT NULL default '0',
  `taxexemptid` int(11) NOT NULL default '0',
  `salestaxnum` varchar(30) default NULL,
  `weather_cf` char(1) default NULL,
  `weather_zip` varchar(20) NOT NULL default '',
  `time_zone` varchar(6) NOT NULL default '+00:00',
  `is_default` int(5) NOT NULL default '0',
  `shipper_number` varchar(50) NOT NULL default '',
  `upstype` varchar(5) NOT NULL default '',
  `timezoneid` int(11) NOT NULL default '0',
  `shipname2` varchar(50) NOT NULL default '',
  `residential` tinyint(4) NOT NULL default '0',
  `county` varchar(50) NOT NULL default '',
  `countyid` varchar(25) default '',
  `addressverified` varchar(32) default '',
  `blindship` tinyint(1) NOT NULL default '0',
  `unincorporated` tinyint(4) NOT NULL default '0',
  `contactnameid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `is_default` (`is_default`),
  KEY `cancel` (`cancel`),
  KEY `taxexemptid` (`taxexemptid`),
  KEY `zip` (`zip`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shipto`
--

LOCK TABLES `shipto` WRITE;
/*!40000 ALTER TABLE `shipto` DISABLE KEYS */;
/*!40000 ALTER TABLE `shipto` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shiptosalestax`
--

DROP TABLE IF EXISTS `shiptosalestax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shiptosalestax` (
  `id` int(11) NOT NULL auto_increment,
  `shiptoid` int(11) NOT NULL default '0',
  `salestaxid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `shiptoid` (`shiptoid`),
  KEY `salestaxid` (`salestaxid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shiptosalestax`
--

LOCK TABLES `shiptosalestax` WRITE;
/*!40000 ALTER TABLE `shiptosalestax` DISABLE KEYS */;
/*!40000 ALTER TABLE `shiptosalestax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shiptoseq`
--

DROP TABLE IF EXISTS `shiptoseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shiptoseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shiptoseq`
--

LOCK TABLES `shiptoseq` WRITE;
/*!40000 ALTER TABLE `shiptoseq` DISABLE KEYS */;
INSERT INTO `shiptoseq` VALUES (0);
/*!40000 ALTER TABLE `shiptoseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shopifysetup`
--

DROP TABLE IF EXISTS `shopifysetup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shopifysetup` (
  `id` int(11) NOT NULL auto_increment,
  `storename` varchar(100) NOT NULL default '',
  `companyid` int(11) NOT NULL default '0',
  `apikey` varchar(32) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `secret` varchar(32) NOT NULL default '',
  `autosyncitems` tinyint(1) NOT NULL default '0',
  `autosyncitemtags` tinyint(1) NOT NULL default '0',
  `autosyncorders` tinyint(1) NOT NULL default '0',
  `autosyncshipping` tinyint(1) NOT NULL default '0',
  `autosynccustomers` tinyint(1) NOT NULL default '0',
  `autosyncpayments` tinyint(1) NOT NULL default '0',
  `useshopifypayments` tinyint(1) NOT NULL default '0',
  `useshopifyshippingquotes` tinyint(1) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `taxexemptid` int(11) NOT NULL default '0',
  `salestaxglacctid` int(11) NOT NULL default '0',
  `salesglacctid` int(11) NOT NULL default '0',
  `refundglacctid` int(11) NOT NULL default '0',
  `checkacctid` int(11) NOT NULL default '0',
  `paypalcheckacctid` int(11) NOT NULL default '0',
  `uploaditemhtmlandimages` tinyint(1) NOT NULL default '0',
  `setcustomerpricelevelfromtags` tinyint(1) NOT NULL default '0',
  `setcustomersalescategoryfromtags` tinyint(1) NOT NULL default '0',
  `salescategoryid` int(11) NOT NULL default '0',
  `invoicetermsid` int(11) NOT NULL default '0',
  `pricelevelid` int(11) NOT NULL default '0',
  `defaultshipvia` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shopifysetup`
--

LOCK TABLES `shopifysetup` WRITE;
/*!40000 ALTER TABLE `shopifysetup` DISABLE KEYS */;
/*!40000 ALTER TABLE `shopifysetup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shopifywebhookregistry`
--

DROP TABLE IF EXISTS `shopifywebhookregistry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shopifywebhookregistry` (
  `id` int(11) NOT NULL auto_increment,
  `hash` varchar(64) NOT NULL,
  `shopdomain` varchar(255) default NULL,
  `topic` varchar(64) default NULL,
  `data` text,
  `entrydate` datetime default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `hash_UNIQUE` (`hash`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shopifywebhookregistry`
--

LOCK TABLES `shopifywebhookregistry` WRITE;
/*!40000 ALTER TABLE `shopifywebhookregistry` DISABLE KEYS */;
/*!40000 ALTER TABLE `shopifywebhookregistry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `site`
--

DROP TABLE IF EXISTS `site`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `site` (
  `id` int(11) NOT NULL auto_increment,
  `sitecode` varchar(20) NOT NULL default '',
  `deal` text,
  `owner` int(11) NOT NULL default '0',
  `location` varchar(250) default NULL,
  `groundbreakingdate` date default NULL,
  `status` int(5) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` date default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `sitename` varchar(255) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `sitecode` (`sitecode`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `site`
--

LOCK TABLES `site` WRITE;
/*!40000 ALTER TABLE `site` DISABLE KEYS */;
/*!40000 ALTER TABLE `site` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `smtp_users`
--

DROP TABLE IF EXISTS `smtp_users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `smtp_users` (
  `id` int(11) NOT NULL auto_increment,
  `host` varchar(255) default NULL,
  `port` int(11) default NULL,
  `login` mediumtext,
  `password` mediumtext,
  `auth_required` tinyint(4) default NULL,
  `secure` varchar(3) default 'ssl',
  `access_type` varchar(8) default NULL,
  `access_id` int(11) default NULL,
  `enabled` tinyint(4) default NULL,
  `email_address` varchar(255) default NULL,
  `replyto_address` varchar(255) default NULL,
  `replyto_name` varchar(255) default NULL,
  `verify_peer` tinyint(1) NOT NULL default '1',
  `verify_peer_name` tinyint(1) NOT NULL default '1',
  `allow_self_signed` tinyint(1) NOT NULL default '0',
  `allowusersubstitutereplyto` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `smtp_users`
--

LOCK TABLES `smtp_users` WRITE;
/*!40000 ALTER TABLE `smtp_users` DISABLE KEYS */;
/*!40000 ALTER TABLE `smtp_users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `specialdate_worktype`
--

DROP TABLE IF EXISTS `specialdate_worktype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `specialdate_worktype` (
  `id` int(11) NOT NULL auto_increment,
  `specialdate_yesno` int(5) NOT NULL default '0',
  `estquoteworktypeid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `estquoteworktypeid` (`estquoteworktypeid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `specialdate_worktype`
--

LOCK TABLES `specialdate_worktype` WRITE;
/*!40000 ALTER TABLE `specialdate_worktype` DISABLE KEYS */;
/*!40000 ALTER TABLE `specialdate_worktype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `specialdates`
--

DROP TABLE IF EXISTS `specialdates`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `specialdates` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(100) NOT NULL default '',
  `display` varchar(50) NOT NULL default '',
  `specialdate` date NOT NULL,
  `dateLastYear` date default NULL,
  `gencompanyid` int(11) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `specialdate` (`specialdate`),
  KEY `display` (`display`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `specialdates`
--

LOCK TABLES `specialdates` WRITE;
/*!40000 ALTER TABLE `specialdates` DISABLE KEYS */;
/*!40000 ALTER TABLE `specialdates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `specials`
--

DROP TABLE IF EXISTS `specials`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `specials` (
  `specials_id` int(5) NOT NULL auto_increment,
  `products_id` int(5) NOT NULL default '0',
  `specials_new_products_price` decimal(8,2) NOT NULL default '0.00',
  `specials_date_added` char(8) default NULL,
  `pricelevel_id` int(5) NOT NULL default '0',
  PRIMARY KEY  (`specials_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `specials`
--

LOCK TABLES `specials` WRITE;
/*!40000 ALTER TABLE `specials` DISABLE KEYS */;
/*!40000 ALTER TABLE `specials` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stage`
--

DROP TABLE IF EXISTS `stage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stage` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `stagetypeid` int(11) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `code` varchar(15) NOT NULL default '',
  `description` text NOT NULL,
  `autotrigger` varchar(100) NOT NULL default '',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(10) unsigned NOT NULL default '0',
  `cancel` int(10) unsigned NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `sortorder` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `stagetypeid` (`stagetypeid`),
  KEY `autotrigger` (`autotrigger`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stage`
--

LOCK TABLES `stage` WRITE;
/*!40000 ALTER TABLE `stage` DISABLE KEYS */;
/*!40000 ALTER TABLE `stage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stageaction`
--

DROP TABLE IF EXISTS `stageaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stageaction` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `stageid` int(10) unsigned NOT NULL default '0',
  `allow` int(10) unsigned NOT NULL default '0',
  `npaction` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `stageid` (`stageid`),
  KEY `npaction` (`npaction`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stageaction`
--

LOCK TABLES `stageaction` WRITE;
/*!40000 ALTER TABLE `stageaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `stageaction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stagelog`
--

DROP TABLE IF EXISTS `stagelog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stagelog` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `stageid` int(10) unsigned NOT NULL default '0',
  `origstageid` int(10) unsigned NOT NULL default '0',
  `recordid` int(11) NOT NULL default '0',
  `currentstage` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `notes` text NOT NULL,
  `cancel` int(11) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `stageid` (`stageid`),
  KEY `origstageid` (`origstageid`),
  KEY `recordid` (`recordid`),
  KEY `currentstage` (`currentstage`),
  KEY `entryuserid` (`entryuserid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stagelog`
--

LOCK TABLES `stagelog` WRITE;
/*!40000 ALTER TABLE `stagelog` DISABLE KEYS */;
/*!40000 ALTER TABLE `stagelog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stagerights`
--

DROP TABLE IF EXISTS `stagerights`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stagerights` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `stageid` int(10) unsigned NOT NULL default '0',
  `nprightsgroupid` int(10) unsigned NOT NULL default '0',
  `userid` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `stageid` (`stageid`),
  KEY `nprightsgroupid` (`nprightsgroupid`),
  KEY `userid` (`userid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stagerights`
--

LOCK TABLES `stagerights` WRITE;
/*!40000 ALTER TABLE `stagerights` DISABLE KEYS */;
/*!40000 ALTER TABLE `stagerights` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stagetype`
--

DROP TABLE IF EXISTS `stagetype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stagetype` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(100) NOT NULL default '',
  `tablename` varchar(100) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `modaccess` varchar(150) NOT NULL default '',
  `modbit` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `code` (`code`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stagetype`
--

LOCK TABLES `stagetype` WRITE;
/*!40000 ALTER TABLE `stagetype` DISABLE KEYS */;
INSERT INTO `stagetype` VALUES (1,'po','invpo','STR_PURCHASE_ORDERS','Process stages for POs','ap','011'),(2,'posb','invpo','STR_SUBCONTRACT_POS','Process stages for Subcontract POs','ap','011'),(3,'fillorder','arorder','STR_FULFILLMENT_ORDERS','Process stages for Fulfillment Orders','ar','011');
/*!40000 ALTER TABLE `stagetype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stagingarea`
--

DROP TABLE IF EXISTS `stagingarea`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stagingarea` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(64) NOT NULL default '',
  `description` mediumtext NOT NULL,
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastupdatedate` datetime NOT NULL,
  `lastupdateuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `code` (`code`,`cancel`),
  KEY `active` (`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stagingarea`
--

LOCK TABLES `stagingarea` WRITE;
/*!40000 ALTER TABLE `stagingarea` DISABLE KEYS */;
/*!40000 ALTER TABLE `stagingarea` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `statelist`
--

DROP TABLE IF EXISTS `statelist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `statelist` (
  `initials` varchar(5) NOT NULL default '',
  `name` char(30) NOT NULL default '',
  `id` int(11) default NULL,
  PRIMARY KEY  (`initials`),
  UNIQUE KEY `name` (`name`),
  UNIQUE KEY `initials` (`initials`),
  KEY `name_2` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `statelist`
--

LOCK TABLES `statelist` WRITE;
/*!40000 ALTER TABLE `statelist` DISABLE KEYS */;
INSERT INTO `statelist` VALUES ('CA','California',5),('AZ','Arizona',3),('AR','Arkansas',4),('AL','Alabama',1),('AK','Alaska',2),('CO','Colorado',6),('CT','Connecticut',7),('DC','Washington, DC',49),('DE','Delaware',8),('FL','Florida',9),('GA','Georgia',10),('HI','Hawaii',11),('IA','Iowa',15),('ID','Idaho',12),('IL','Illinois',13),('IN','Indiana',14),('KS','Kansas',16),('KY','Kentucky',17),('LA','Louisiana',18),('MA','Massachusetts',21),('ME','Maine',19),('MI','Michigan',22),('MN','Minnesota',23),('MO','Missouri',25),('MS','Mississippi',24),('MT','Montana',26),('NC','North Carolina',33),('ND','North Dakota',34),('NE','Nebraska',27),('NH','New Hampshire',29),('NJ','New Jersey',30),('NM','New Mexico',31),('NV','Nevada',28),('NY','New York',32),('OH','Ohio',35),('OK','Oklahoma',36),('OR','Oregon',37),('PA','Pennsylvania',38),('PR','Puerto Rico',39),('RI','Rhode Island',40),('SC','South Carolina',41),('SD','South Dakota',42),('TN','Tennessee',43),('TX','Texas',44),('UT','Utah',45),('VA','Virginia',47),('VT','Vermont',46),('WA','Washington',48),('WI','Wisconsin',51),('WV','West Virginia',50),('WY','Wyoming',52),('MD','Maryland',20),('AB','Alberta',53),('BC','British Columbia',54),('MB','Manitoba',55),('NB','New Brunswick',56),('NL','Newfoundland & Labrador',57),('NT','Northwest Territories',58),('NS','Nova Scotia',59),('NU','Nunavut',60),('ON','Ontario',61),('PE','Prince Edward Island',62),('QC','Quebec',63),('YT','Yukon Territories',64),('SK','Saskatchewan',65);
/*!40000 ALTER TABLE `statelist` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `std_accounts`
--

DROP TABLE IF EXISTS `std_accounts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `std_accounts` (
  `id` int(11) NOT NULL auto_increment,
  `industry_code` varchar(20) NOT NULL default '',
  `industry_name` varchar(255) default NULL,
  `account_name` varchar(20) NOT NULL default '',
  `account_description` varchar(255) default NULL,
  `account_type` int(5) NOT NULL default '0',
  `cancel` int(2) NOT NULL default '0',
  `glquery` text,
  PRIMARY KEY  (`id`),
  KEY `industry_code` (`industry_code`)
) ENGINE=MyISAM AUTO_INCREMENT=6455 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `std_accounts`
--

LOCK TABLES `std_accounts` WRITE;
/*!40000 ALTER TABLE `std_accounts` DISABLE KEYS */;
INSERT INTO `std_accounts` VALUES (851,'Service - Extensive','Service - Extensive','14000','Prepaid Expenses',10,0,NULL),(850,'Service - Extensive','Service - Extensive','12000','Inventory',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(849,'Service - Extensive','Service - Extensive','11500','Allowance for Doubtful Account',10,0,NULL),(848,'Service - Extensive','Service - Extensive','11400','Other Receivables',10,0,NULL),(847,'Service - Extensive','Service - Extensive','11100','Contracts Receivable',10,0,NULL),(846,'Service - Extensive','Service - Extensive','11000','Accounts Receivable',10,0,'arcompany.receivables'),(845,'Service - Extensive','Service - Extensive','10400','Savings Account',10,0,NULL),(844,'Service - Extensive','Service - Extensive','10300','Payroll Checking Account',10,0,NULL),(843,'Service - Extensive','Service - Extensive','10200','Regular Checking Account',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(842,'Service - Extensive','Service - Extensive','10100','Cash on Hand',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(841,'Service - Extensive','Service - Extensive','10000','Petty Cash',10,0,NULL),(840,'Medical - Simple','Medical - Simple','35000','Retained Earnings',40,0,NULL),(839,'Medical - Simple','Medical - Simple','30000','Equity',30,0,NULL),(838,'Medical - Simple','Medical - Simple','90000','Gain/Loss on Sale of Assets',80,0,NULL),(837,'Medical - Simple','Medical - Simple','89500','Purchase Disc-Expense Items',80,0,NULL),(836,'Medical - Simple','Medical - Simple','89000','Other Expense',80,0,NULL),(835,'Medical - Simple','Medical - Simple','78500','Travel Expense',80,0,NULL),(834,'Medical - Simple','Medical - Simple','78000','Telephone Expense',80,0,NULL),(833,'Medical - Simple','Medical - Simple','77500','Wages Expense',80,0,NULL),(832,'Medical - Simple','Medical - Simple','77000','Salaries Expense',80,0,NULL),(831,'Medical - Simple','Medical - Simple','76500','Repairs Expense',80,0,NULL),(830,'Medical - Simple','Medical - Simple','76000','Rent or Lease Expense',80,0,NULL),(829,'Medical - Simple','Medical - Simple','75500','Professional Development Exp',80,0,NULL),(828,'Medical - Simple','Medical - Simple','75000','Postage Expense',80,0,NULL),(827,'Medical - Simple','Medical - Simple','74500','Meals and Entertainment Expense',80,0,NULL),(826,'Medical - Simple','Medical - Simple','73500','Office Expense',80,0,NULL),(825,'Medical - Simple','Medical - Simple','73000','Other Taxes',80,0,'invcompany.tax'),(824,'Medical - Simple','Medical - Simple','72500','Penalties and Fines Exp',80,0,NULL),(823,'Medical - Simple','Medical - Simple','72000','Payroll Tax Expense',80,0,NULL),(822,'Medical - Simple','Medical - Simple','71500','Maintenance Expense',80,0,NULL),(821,'Medical - Simple','Medical - Simple','71000','Loss on NSF Checks',80,0,NULL),(820,'Medical - Simple','Medical - Simple','70500','Licenses Expense',80,0,NULL),(819,'Medical - Simple','Medical - Simple','70000','Legal and Professional Expense',80,0,NULL),(818,'Medical - Simple','Medical - Simple','69500','Laundry and Cleaning Exp',80,0,NULL),(817,'Medical - Simple','Medical - Simple','68500','Interest Expense',80,0,'apcompany.interestexpense'),(816,'Medical - Simple','Medical - Simple','68000','Insurance Expense',80,0,NULL),(815,'Medical - Simple','Medical - Simple','67500','Income Tax Expense',80,0,NULL),(814,'Medical - Simple','Medical - Simple','67000','Gifts Expense',80,0,NULL),(813,'Medical - Simple','Medical - Simple','66500','Freight Expense',80,0,NULL),(812,'Medical - Simple','Medical - Simple','66000','Drugs and Sundries Expense',80,0,NULL),(811,'Medical - Simple','Medical - Simple','65500','Employee Benefit Programs Exp',80,0,NULL),(810,'Medical - Simple','Medical - Simple','65000','Dues and Subscriptions Exp',80,0,NULL),(809,'Medical - Simple','Medical - Simple','64500','Depreciation Expense',80,0,NULL),(808,'Medical - Simple','Medical - Simple','64000','Commissions and Fees Exp',80,0,NULL),(807,'Medical - Simple','Medical - Simple','63500','Charitable Contributions Exp',80,0,NULL),(806,'Medical - Simple','Medical - Simple','63000','Cash Over and Short',80,0,NULL),(805,'Medical - Simple','Medical - Simple','62500','Bank Charges',80,0,NULL),(804,'Medical - Simple','Medical - Simple','62000','Bad Debt Expense',80,0,'arcompany.baddebt'),(803,'Medical - Simple','Medical - Simple','61500','Auto Expenses',80,0,NULL),(802,'Medical - Simple','Medical - Simple','61000','Answering Service Expense',80,0,NULL),(801,'Medical - Simple','Medical - Simple','60500','Amortization Expense',80,0,NULL),(800,'Medical - Simple','Medical - Simple','60100','Advertising Expense',70,0,NULL),(799,'Medical - Simple','Medical - Simple','60000','Default Purchase Expense',70,0,NULL),(798,'Medical - Simple','Medical - Simple','57000','Cost of Sales-Salaries and Wages',70,0,NULL),(797,'Medical - Simple','Medical - Simple','50000','Cost of Sales',70,0,'arcompany.cost;invcompany.cost;invcompany.costadjustglacctid'),(796,'Medical - Simple','Medical - Simple','49000','Fee Discounts',50,0,'apcompany.discount'),(795,'Medical - Simple','Medical - Simple','48000','Patient Refunds',50,0,'arcompany.refund'),(794,'Medical - Simple','Medical - Simple','45500','Shipping Charges Reimbursed',50,0,NULL),(793,'Medical - Simple','Medical - Simple','45400','Finance Charge Income',50,0,NULL),(792,'Medical - Simple','Medical - Simple','40400','Other Income',50,0,'invcompany.sales;arcompany.restockglid'),(791,'Medical - Simple','Medical - Simple','40200','Interest Income',50,0,'arcompany.interest'),(790,'Medical - Simple','Medical - Simple','40000','Professional Fees',50,0,'arcompany.labor_sales_glacctid'),(789,'Medical - Simple','Medical - Simple','27400','Other Long-Term Liabilities',22,0,NULL),(788,'Medical - Simple','Medical - Simple','27100','Deferred Revenue',22,0,NULL),(787,'Medical - Simple','Medical - Simple','27000','Notes Payable-Noncurrent',22,0,NULL),(786,'Medical - Simple','Medical - Simple','24900','Suspense-Clearing Account',21,0,NULL),(785,'Medical - Simple','Medical - Simple','24800','Other Current Liabilities',21,0,NULL),(784,'Medical - Simple','Medical - Simple','24500','Contracts Payable-Current',21,0,NULL),(783,'Medical - Simple','Medical - Simple','24400','Patient Deposits',21,0,'arcompany.depositglacctid'),(782,'Medical - Simple','Medical - Simple','24200','Current Portion Long-Term Debt',21,0,NULL),(781,'Medical - Simple','Medical - Simple','24100','Employee Benefits Payable',21,0,NULL),(780,'Medical - Simple','Medical - Simple','24000','Other Taxes Payable',21,0,NULL),(779,'Medical - Simple','Medical - Simple','23900','Income Taxes Payable',21,0,NULL),(778,'Medical - Simple','Medical - Simple','23800','Local Payroll Taxes Payable',21,0,NULL),(777,'Medical - Simple','Medical - Simple','23700','SUTA Payable',21,0,NULL),(776,'Medical - Simple','Medical - Simple','23600','State Payroll Taxes Payable',21,0,NULL),(775,'Medical - Simple','Medical - Simple','23500','FUTA Tax Payable',21,0,NULL),(774,'Medical - Simple','Medical - Simple','23400','Federal Payroll Taxes Payable',21,0,NULL),(773,'Medical - Simple','Medical - Simple','23300','Deductions Payable',21,0,NULL),(772,'Medical - Simple','Medical - Simple','23200','Wages Payable',21,0,NULL),(771,'Medical - Simple','Medical - Simple','23100','Sales Tax Payable',21,0,NULL),(770,'Medical - Simple','Medical - Simple','23000','Accrued Expenses',21,0,NULL),(769,'Medical - Simple','Medical - Simple','20000','Accounts Payable',21,0,'apcompany.payable;prcompany.glmiscdedpayableid;arcompany.shipliability'),(768,'Medical - Simple','Medical - Simple','19900','Other Noncurrent Assets',13,0,NULL),(767,'Medical - Simple','Medical - Simple','19200','Note Receivable-Noncurrent',13,0,NULL),(766,'Medical - Simple','Medical - Simple','19150','Accum. Amortiz. - Org. Costs',13,0,NULL),(765,'Medical - Simple','Medical - Simple','19100','Organization Costs',13,0,NULL),(764,'Medical - Simple','Medical - Simple','19000','Deposits',13,0,NULL),(763,'Medical - Simple','Medical - Simple','17600','Accum. Depreciation - Bldg Imp',11,0,NULL),(762,'Medical - Simple','Medical - Simple','17500','Accum. Depreciation - Building',11,0,NULL),(761,'Medical - Simple','Medical - Simple','17400','Accum. Depreciation - Leasehold',11,0,NULL),(760,'Medical - Simple','Medical - Simple','17300','Accum. Depreciation - Other',11,0,NULL),(759,'Medical - Simple','Medical - Simple','17200','Accum. Depreciation - Automobil',11,0,NULL),(758,'Medical - Simple','Medical - Simple','17100','Accum. Depreciation - Equipment',11,0,NULL),(757,'Medical - Simple','Medical - Simple','17000','Accum. Depreciation - Furniture',11,0,NULL),(756,'Medical - Simple','Medical - Simple','16900','Land',11,0,NULL),(755,'Medical - Simple','Medical - Simple','15600','Building Improvements',11,0,NULL),(754,'Medical - Simple','Medical - Simple','15500','Building',11,0,NULL),(753,'Medical - Simple','Medical - Simple','15400','Leasehold Improvements',11,0,NULL),(752,'Medical - Simple','Medical - Simple','15300','Other Depreciable Property',11,0,NULL),(751,'Medical - Simple','Medical - Simple','15200','Automobiles',11,0,NULL),(750,'Medical - Simple','Medical - Simple','15100','Equipment',11,0,NULL),(749,'Medical - Simple','Medical - Simple','15000','Furniture and Fixtures',11,0,NULL),(748,'Medical - Simple','Medical - Simple','14700','Other Current Assets',10,0,NULL),(747,'Medical - Simple','Medical - Simple','14200','Notes Receivable-Current',10,0,NULL),(746,'Medical - Simple','Medical - Simple','14100','Employee Advances',10,0,NULL),(745,'Medical - Simple','Medical - Simple','14000','Prepaid Expenses',10,0,NULL),(744,'Medical - Simple','Medical - Simple','12000','Inventory',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(743,'Medical - Simple','Medical - Simple','11500','Allowance for Doubtful Account',10,0,NULL),(742,'Medical - Simple','Medical - Simple','11400','Other Receivables',10,0,NULL),(741,'Medical - Simple','Medical - Simple','11000','Accounts Receivable',10,0,'arcompany.receivables'),(740,'Medical - Simple','Medical - Simple','10400','Savings Account',10,0,NULL),(739,'Medical - Simple','Medical - Simple','10300','Payroll Checking Account',10,0,NULL),(738,'Medical - Simple','Medical - Simple','10200','Regular Checking Account',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(737,'Medical - Simple','Medical - Simple','10100','Cash on Hand',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(736,'Medical - Simple','Medical - Simple','10000','Petty Cash',10,0,NULL),(735,'Manufacturing - Simp','Manufacturing - Simple','3500','Retained Earnings',40,0,NULL),(734,'Manufacturing - Simp','Manufacturing - Simple','3000','Equity',30,0,NULL),(733,'Manufacturing - Simp','Manufacturing - Simple','6850','Gain/Loss - Sale of Assets Exp',80,0,NULL),(732,'Manufacturing - Simp','Manufacturing - Simple','6800','Depreciation Expense',80,0,NULL),(731,'Manufacturing - Simp','Manufacturing - Simple','6750','Insurance Expense',80,0,NULL),(730,'Manufacturing - Simp','Manufacturing - Simple','6700','Purchase Disc-Expense Items',80,0,'apcompany.discount'),(729,'Manufacturing - Simp','Manufacturing - Simple','6650','Service Charge Expense',80,0,'apcompany.servicecharges'),(728,'Manufacturing - Simp','Manufacturing - Simple','6600','Freight Expense',80,0,NULL),(727,'Manufacturing - Simp','Manufacturing - Simple','6550','Other Office Expense',80,0,NULL),(726,'Manufacturing - Simp','Manufacturing - Simple','6500','Office Supplies Expense',80,0,NULL),(725,'Manufacturing - Simp','Manufacturing - Simple','6450','Telephone Expense',80,0,NULL),(724,'Manufacturing - Simp','Manufacturing - Simple','6400','Utilities Expense',80,0,NULL),(723,'Manufacturing - Simp','Manufacturing - Simple','6350','Maintenance & Repairs Expense',80,0,NULL),(722,'Manufacturing - Simp','Manufacturing - Simple','6300','Rent or Lease Expense',80,0,NULL),(721,'Manufacturing - Simp','Manufacturing - Simple','6250','Other Taxes Expense',80,0,'invcompany.tax'),(720,'Manufacturing - Simp','Manufacturing - Simple','6200','Income Tax Expense',80,0,NULL),(719,'Manufacturing - Simp','Manufacturing - Simple','6150','Bad Debt Expense',80,0,'arcompany.baddebt'),(718,'Manufacturing - Simp','Manufacturing - Simple','6100','Payroll Tax Expense',80,0,NULL),(717,'Manufacturing - Simp','Manufacturing - Simple','6050','Employee Benefit Programs Expense',80,0,NULL),(716,'Manufacturing - Simp','Manufacturing - Simple','6000','Wages Expense',80,0,NULL),(715,'Manufacturing - Simp','Manufacturing - Simple','5900','Inventory Adjustments',70,0,NULL),(714,'Manufacturing - Simp','Manufacturing - Simple','5400','Cost of Sales - Salary & Wage',70,0,'apcompany.glcommissionid'),(713,'Manufacturing - Simp','Manufacturing - Simple','5300','Cost of Sales - Freight',70,0,'invcompany.freight'),(712,'Manufacturing - Simp','Manufacturing - Simple','5200','Indirect Labor',70,0,NULL),(711,'Manufacturing - Simp','Manufacturing - Simple','5100','Direct Labor',70,0,NULL),(710,'Manufacturing - Simp','Manufacturing - Simple','5000','Raw Materials Costs',70,0,'arcompany.cost;invcompany.cost;invcompany.costadjustglacctid;apcompany.interestexpense'),(709,'Manufacturing - Simp','Manufacturing - Simple','4900','Sales Discounts',50,0,'apcompany.discount'),(708,'Manufacturing - Simp','Manufacturing - Simple','4200','Other Income',50,0,NULL),(707,'Manufacturing - Simp','Manufacturing - Simple','4100','Interest Income',50,0,'arcompany.interest'),(706,'Manufacturing - Simp','Manufacturing - Simple','4000','Sales Income',50,0,'invcompany.sales;arcompany.labor_sales_glacctid;arcompany.refund;arcompany.restockglid'),(705,'Manufacturing - Simp','Manufacturing - Simple','2700','Long Term Debt - Noncurrent',22,0,NULL),(704,'Manufacturing - Simp','Manufacturing - Simple','2500','Current Portion Long-Term Debt',21,0,NULL),(703,'Manufacturing - Simp','Manufacturing - Simple','2400','Customer Deposits',21,0,'arcompany.depositglacctid'),(702,'Manufacturing - Simp','Manufacturing - Simple','2380','Income Taxes Payable',21,0,NULL),(701,'Manufacturing - Simp','Manufacturing - Simple','2370','Local Taxes Payable',21,0,NULL),(700,'Manufacturing - Simp','Manufacturing - Simple','2360','SUTA Payable',21,0,NULL),(699,'Manufacturing - Simp','Manufacturing - Simple','2350','State Payroll Taxes Payable',21,0,NULL),(698,'Manufacturing - Simp','Manufacturing - Simple','2340','FUTA Payable',21,0,NULL),(697,'Manufacturing - Simp','Manufacturing - Simple','2330','Federal Payroll Taxes Payable',21,0,NULL),(696,'Manufacturing - Simp','Manufacturing - Simple','2320','Deductions Payable',21,0,NULL),(695,'Manufacturing - Simp','Manufacturing - Simple','2310','Sales Tax Payable',21,0,NULL),(694,'Manufacturing - Simp','Manufacturing - Simple','2000','Accounts Payable',21,0,'apcompany.payable;prcompany.glpayroll_payableid;prcompany.glmiscdedpayableid;arcompany.shipliability'),(693,'Manufacturing - Simp','Manufacturing - Simple','1900','Accum. Depreciation - Prop&Eqt',11,0,NULL),(692,'Manufacturing - Simp','Manufacturing - Simple','1500','Plant Property and Equipment',11,0,NULL),(691,'Manufacturing - Simp','Manufacturing - Simple','1400','Prepaid Expenses',10,0,NULL),(690,'Manufacturing - Simp','Manufacturing - Simple','1300','Finished Goods Inventory',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(689,'Manufacturing - Simp','Manufacturing - Simple','1250','Work in Progress Inventory',10,0,NULL),(688,'Manufacturing - Simp','Manufacturing - Simple','1200','Raw Materials Inventory',10,0,NULL),(687,'Manufacturing - Simp','Manufacturing - Simple','1150','Allowance for Doubtful Accounts',10,0,NULL),(686,'Manufacturing - Simp','Manufacturing - Simple','1100','Accounts Receivable',10,0,'arcompany.receivables'),(685,'Manufacturing - Simp','Manufacturing - Simple','1020','Checking Account',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(684,'Manufacturing - Simp','Manufacturing - Simple','1010','Cash on Hand',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(683,'Manufacturing - Exte','Manufacturing - Extensive','35000','Retained Earnings',40,0,NULL),(682,'Manufacturing - Exte','Manufacturing - Extensive','30000','Equity',30,0,NULL),(681,'Manufacturing - Exte','Manufacturing - Extensive','90000','Gain/Loss on Sale of Assets',80,0,NULL),(680,'Manufacturing - Exte','Manufacturing - Extensive','89500','Purchase Disc-Expense Items',80,0,NULL),(679,'Manufacturing - Exte','Manufacturing - Extensive','89000','Other Expense',80,0,NULL),(678,'Manufacturing - Exte','Manufacturing - Extensive','78000','Utilities Expense',80,0,NULL),(677,'Manufacturing - Exte','Manufacturing - Extensive','77500','Wages Expense',80,0,NULL),(676,'Manufacturing - Exte','Manufacturing - Extensive','77000','Salaries Expense',80,0,NULL),(675,'Manufacturing - Exte','Manufacturing - Extensive','76500','Travel Expense',80,0,NULL),(674,'Manufacturing - Exte','Manufacturing - Extensive','76000','Telephone Expense',80,0,NULL),(673,'Manufacturing - Exte','Manufacturing - Extensive','75500','Supplies Expense',80,0,NULL),(672,'Manufacturing - Exte','Manufacturing - Extensive','74500','Repairs Expense',80,0,NULL),(671,'Manufacturing - Exte','Manufacturing - Extensive','74000','Rent or Lease Expense',80,0,NULL),(670,'Manufacturing - Exte','Manufacturing - Extensive','73500','Postage Expense',80,0,NULL),(669,'Manufacturing - Exte','Manufacturing - Extensive','73000','Other Taxes',80,0,'invcompany.tax'),(668,'Manufacturing - Exte','Manufacturing - Extensive','72500','Penalties and Fines Exp',80,0,NULL),(667,'Manufacturing - Exte','Manufacturing - Extensive','72000','Payroll Tax Expense',80,0,NULL),(666,'Manufacturing - Exte','Manufacturing - Extensive','71000','Office Expense',80,0,NULL),(665,'Manufacturing - Exte','Manufacturing - Extensive','70500','Meals and Entertainment Exp',80,0,NULL),(664,'Manufacturing - Exte','Manufacturing - Extensive','70000','Maintenance Expense',80,0,NULL),(663,'Manufacturing - Exte','Manufacturing - Extensive','69500','Loss on NSF Checks',80,0,NULL),(662,'Manufacturing - Exte','Manufacturing - Extensive','69000','Licenses Expense',80,0,NULL),(661,'Manufacturing - Exte','Manufacturing - Extensive','68500','Legal and Professional Expense',80,0,NULL),(660,'Manufacturing - Exte','Manufacturing - Extensive','68000','Laundry and Cleaning Exp',80,0,NULL),(659,'Manufacturing - Exte','Manufacturing - Extensive','67500','Interest Expense',80,0,'apcompany.interestexpense'),(658,'Manufacturing - Exte','Manufacturing - Extensive','67000','Insurance Expense',80,0,NULL),(657,'Manufacturing - Exte','Manufacturing - Extensive','66500','Income Tax Expense',80,0,NULL),(656,'Manufacturing - Exte','Manufacturing - Extensive','66000','Gifts Expense',80,0,NULL),(655,'Manufacturing - Exte','Manufacturing - Extensive','65500','Freight Expense',80,0,'invcompany.freight'),(654,'Manufacturing - Exte','Manufacturing - Extensive','65000','Employee Benefit Programs Exp',80,0,NULL),(653,'Manufacturing - Exte','Manufacturing - Extensive','64500','Dues and Subscriptions Exp',80,0,NULL),(652,'Manufacturing - Exte','Manufacturing - Extensive','64000','Depreciation Expense',80,0,NULL),(651,'Manufacturing - Exte','Manufacturing - Extensive','63500','Commissions and Fees Exp',80,0,'apcompany.glcommissionid'),(650,'Manufacturing - Exte','Manufacturing - Extensive','63000','Charitable Contributions Exp',80,0,NULL),(649,'Manufacturing - Exte','Manufacturing - Extensive','62500','Cash Over and Short',80,0,NULL),(648,'Manufacturing - Exte','Manufacturing - Extensive','62000','Bank Charges',80,0,NULL),(647,'Manufacturing - Exte','Manufacturing - Extensive','61500','Bad Debt Expense',80,0,'arcompany.baddebt'),(646,'Manufacturing - Exte','Manufacturing - Extensive','61000','Auto Expenses',80,0,NULL),(645,'Manufacturing - Exte','Manufacturing - Extensive','60500','Amortization Expense',80,0,NULL),(644,'Manufacturing - Exte','Manufacturing - Extensive','60100','Advertising Expense',80,0,NULL),(643,'Manufacturing - Exte','Manufacturing - Extensive','60000','Default Purchase Expense',80,0,NULL),(642,'Manufacturing - Exte','Manufacturing - Extensive','59500','Purchase Discounts',70,0,'apcompany.discount'),(641,'Manufacturing - Exte','Manufacturing - Extensive','59000','Purchase Returns and Allowances',70,0,NULL),(640,'Manufacturing - Exte','Manufacturing - Extensive','58500','Inventory Adjustments',70,0,'invcompany.costadjustglacctid'),(639,'Manufacturing - Exte','Manufacturing - Extensive','58000','Cost of Sales-Other',70,0,NULL),(638,'Manufacturing - Exte','Manufacturing - Extensive','57500','Cost of Sales-Freight',70,0,NULL),(637,'Manufacturing - Exte','Manufacturing - Extensive','57000','Cost of Sales-Salaries and Wages',70,0,NULL),(636,'Manufacturing - Exte','Manufacturing - Extensive','53000','Miscellaneous Factory Costs',70,0,NULL),(635,'Manufacturing - Exte','Manufacturing - Extensive','52500','Commissions',70,0,NULL),(634,'Manufacturing - Exte','Manufacturing - Extensive','52000','Heat-Light and Power',70,0,NULL),(633,'Manufacturing - Exte','Manufacturing - Extensive','51500','Indirect Labor Costs',70,0,NULL),(632,'Manufacturing - Exte','Manufacturing - Extensive','51000','Direct Labor Costs',70,0,NULL),(631,'Manufacturing - Exte','Manufacturing - Extensive','50500','Raw Material Purchases',70,0,NULL),(630,'Manufacturing - Exte','Manufacturing - Extensive','50000','Cost of Goods Sold',70,0,'arcompany.cost;invcompany.cost'),(629,'Manufacturing - Exte','Manufacturing - Extensive','49000','Sales Discounts',50,0,'apcompany.discount'),(628,'Manufacturing - Exte','Manufacturing - Extensive','48000','Sales Returns and Allowances',50,0,'arcompany.refund'),(627,'Manufacturing - Exte','Manufacturing - Extensive','45500','Shipping Charges Reimbursed',50,0,NULL),(626,'Manufacturing - Exte','Manufacturing - Extensive','45400','Finance Charge Income',50,0,NULL),(625,'Manufacturing - Exte','Manufacturing - Extensive','40800','Other Income',50,0,'arcompany.restockglid'),(624,'Manufacturing - Exte','Manufacturing - Extensive','40600','Interest Income',50,0,'arcompany.interest'),(623,'Manufacturing - Exte','Manufacturing - Extensive','40400','Sales #3',50,0,NULL),(622,'Manufacturing - Exte','Manufacturing - Extensive','40200','Sales #2',50,0,'arcompany.labor_sales_glacctid'),(621,'Manufacturing - Exte','Manufacturing - Extensive','40000','Sales #1',50,0,'invcompany.sales'),(620,'Manufacturing - Exte','Manufacturing - Extensive','27400','Other Long-Term Liabilities',22,0,NULL),(619,'Manufacturing - Exte','Manufacturing - Extensive','27100','Deferred Revenue',22,0,NULL),(618,'Manufacturing - Exte','Manufacturing - Extensive','27000','Notes Payable-Noncurrent',22,0,NULL),(617,'Manufacturing - Exte','Manufacturing - Extensive','24900','Suspense-Clearing Account',21,0,NULL),(616,'Manufacturing - Exte','Manufacturing - Extensive','24800','Other Current Liabilities',21,0,NULL),(615,'Manufacturing - Exte','Manufacturing - Extensive','24400','Deposits from Customers',21,0,'arcompany.depositglacctid'),(614,'Manufacturing - Exte','Manufacturing - Extensive','24200','Current Portion Long-Term Debt',21,0,NULL),(613,'Manufacturing - Exte','Manufacturing - Extensive','24100','Employee Benefits Payable',21,0,NULL),(612,'Manufacturing - Exte','Manufacturing - Extensive','24000','Other Taxes Payable',21,0,NULL),(611,'Manufacturing - Exte','Manufacturing - Extensive','23900','Income Taxes Payable',21,0,NULL),(610,'Manufacturing - Exte','Manufacturing - Extensive','23800','Local Payroll Taxes Payable',21,0,NULL),(609,'Manufacturing - Exte','Manufacturing - Extensive','23700','SUTA Payable',21,0,NULL),(608,'Manufacturing - Exte','Manufacturing - Extensive','23600','State Payroll Taxes Payable',21,0,NULL),(607,'Manufacturing - Exte','Manufacturing - Extensive','23500','FUTA Tax Payable',21,0,NULL),(606,'Manufacturing - Exte','Manufacturing - Extensive','23400','Federal Payroll Taxes Payable',21,0,NULL),(605,'Manufacturing - Exte','Manufacturing - Extensive','23300','Deductions Payable',21,0,NULL),(604,'Manufacturing - Exte','Manufacturing - Extensive','23200','Wages Payable',21,0,NULL),(603,'Manufacturing - Exte','Manufacturing - Extensive','23100','Sales Tax Payable',21,0,NULL),(602,'Manufacturing - Exte','Manufacturing - Extensive','23000','Accrued Expenses',21,0,NULL),(601,'Manufacturing - Exte','Manufacturing - Extensive','20000','Accounts Payable',21,0,'apcompany.payable;prcompany.glmiscdedpayableid;arcompany.shipliability'),(600,'Manufacturing - Exte','Manufacturing - Extensive','19900','Other Noncurrent Assets',13,0,NULL),(599,'Manufacturing - Exte','Manufacturing - Extensive','19200','Note Receivable-Noncurrent',13,0,NULL),(598,'Manufacturing - Exte','Manufacturing - Extensive','19150','Accum. Amortiz. - Org. Costs',13,0,NULL),(597,'Manufacturing - Exte','Manufacturing - Extensive','19100','Organization Costs',13,0,NULL),(596,'Manufacturing - Exte','Manufacturing - Extensive','19000','Deposits',13,0,NULL),(595,'Manufacturing - Exte','Manufacturing - Extensive','17600','Accum. Depreciation - Bldg Imp',11,0,NULL),(594,'Manufacturing - Exte','Manufacturing - Extensive','17500','Accum. Depreciation - Building',11,0,NULL),(593,'Manufacturing - Exte','Manufacturing - Extensive','17400','Accum. Depreciation - Leasehold',11,0,NULL),(592,'Manufacturing - Exte','Manufacturing - Extensive','17300','Accum. Depreciation - Other',11,0,NULL),(591,'Manufacturing - Exte','Manufacturing - Extensive','17200','Accum. Depreciation - Automobil',11,0,NULL),(590,'Manufacturing - Exte','Manufacturing - Extensive','17100','Accum. Depreciation - Equipment',11,0,NULL),(589,'Manufacturing - Exte','Manufacturing - Extensive','17000','Accum. Depreciation - Furniture',11,0,NULL),(588,'Manufacturing - Exte','Manufacturing - Extensive','16900','Land',11,0,NULL),(587,'Manufacturing - Exte','Manufacturing - Extensive','15600','Building Improvements',11,0,NULL),(586,'Manufacturing - Exte','Manufacturing - Extensive','15500','Building',11,0,NULL),(585,'Manufacturing - Exte','Manufacturing - Extensive','15400','Leasehold Improvements',11,0,NULL),(584,'Manufacturing - Exte','Manufacturing - Extensive','15300','Other Depreciable Property',11,0,NULL),(583,'Manufacturing - Exte','Manufacturing - Extensive','15200','Automobiles',11,0,NULL),(582,'Manufacturing - Exte','Manufacturing - Extensive','15100','Equipment',11,0,NULL),(581,'Manufacturing - Exte','Manufacturing - Extensive','15000','Furniture and Fixtures',11,0,NULL),(580,'Manufacturing - Exte','Manufacturing - Extensive','14700','Other Current Assets',10,0,NULL),(579,'Manufacturing - Exte','Manufacturing - Extensive','14300','Prepaid Interest',10,0,NULL),(578,'Manufacturing - Exte','Manufacturing - Extensive','14200','Notes Receivable-Current',10,0,NULL),(577,'Manufacturing - Exte','Manufacturing - Extensive','14100','Employee Advances',10,0,NULL),(576,'Manufacturing - Exte','Manufacturing - Extensive','14000','Prepaid Expenses',10,0,NULL),(575,'Manufacturing - Exte','Manufacturing - Extensive','12150','Finished Goods Inventory',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(574,'Manufacturing - Exte','Manufacturing - Extensive','12100','Work in Progress Inventory',10,0,NULL),(573,'Manufacturing - Exte','Manufacturing - Extensive','12050','Supplies Inventory',10,0,NULL),(572,'Manufacturing - Exte','Manufacturing - Extensive','12000','Raw Materials Inventory',10,0,NULL),(571,'Manufacturing - Exte','Manufacturing - Extensive','11500','Allowance for Doubtful Account',10,0,NULL),(570,'Manufacturing - Exte','Manufacturing - Extensive','11400','Other Receivables',10,0,NULL),(569,'Manufacturing - Exte','Manufacturing - Extensive','11000','Accounts Receivable',10,0,'arcompany.receivables'),(568,'Manufacturing - Exte','Manufacturing - Extensive','10700','Investments-Cert. of Deposit',10,0,NULL),(567,'Manufacturing - Exte','Manufacturing - Extensive','10600','Investments-Money Market',10,0,NULL),(566,'Manufacturing - Exte','Manufacturing - Extensive','10500','Special Account',10,0,NULL),(565,'Manufacturing - Exte','Manufacturing - Extensive','10400','Savings Account',10,0,NULL),(564,'Manufacturing - Exte','Manufacturing - Extensive','10300','Payroll Checking Account',10,0,NULL),(563,'Manufacturing - Exte','Manufacturing - Extensive','10200','Regular Checking Account',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(562,'Manufacturing - Exte','Manufacturing - Extensive','10100','Cash on Hand',10,0,NULL),(561,'Manufacturing - Exte','Manufacturing - Extensive','10000','Petty Cash',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(560,'Retail - Simple','Retail - Simple','3500','Retained Earnings',40,0,NULL),(559,'Retail - Simple','Retail - Simple','3000','Equity',30,0,NULL),(558,'Retail - Simple','Retail - Simple','7100','Gain/Loss - Sale of Assets Exp',80,0,NULL),(557,'Retail - Simple','Retail - Simple','7050','Depreciation Expense',80,0,NULL),(556,'Retail - Simple','Retail - Simple','7000','Over and Short Expense',80,0,NULL),(555,'Retail - Simple','Retail - Simple','6950','Insurance Expense',80,0,NULL),(554,'Retail - Simple','Retail - Simple','6900','Purchase Disc-Expense Items',80,0,'apcompany.discount'),(553,'Retail - Simple','Retail - Simple','6850','Service Charge Expense',80,0,'apcompany.servicecharges'),(552,'Retail - Simple','Retail - Simple','6800','Freight Expense',80,0,'invcompany.freight'),(551,'Retail - Simple','Retail - Simple','6750','Equipment Rental Expense',80,0,NULL),(550,'Retail - Simple','Retail - Simple','6700','Franchise Fees Expense',80,0,NULL),(549,'Retail - Simple','Retail - Simple','6650','Commissions and Fees Expense',80,0,'apcompany.glcommissionid'),(548,'Retail - Simple','Retail - Simple','6600','Advertising Expense',80,0,NULL),(547,'Retail - Simple','Retail - Simple','6550','Other Office Expense',80,0,NULL),(546,'Retail - Simple','Retail - Simple','6500','Telephone Expense',80,0,NULL),(545,'Retail - Simple','Retail - Simple','6450','Office Supplies Expense',80,0,NULL),(544,'Retail - Simple','Retail - Simple','6400','Utilities Expense',80,0,NULL),(543,'Retail - Simple','Retail - Simple','6350','Maintenance & Repairs Expense',80,0,NULL),(542,'Retail - Simple','Retail - Simple','6300','Rent or Lease Expense',80,0,NULL),(541,'Retail - Simple','Retail - Simple','6250','Other Taxes Expense',80,0,'invcompany.tax'),(540,'Retail - Simple','Retail - Simple','6200','Income Tax Expense',80,0,NULL),(539,'Retail - Simple','Retail - Simple','6150','Bad Debt Expense',80,0,'arcompany.baddebt'),(538,'Retail - Simple','Retail - Simple','6100','Payroll Tax Expense',80,0,NULL),(537,'Retail - Simple','Retail - Simple','6050','Employee Benefit Programs Expense',80,0,NULL),(536,'Retail - Simple','Retail - Simple','6000','Wages Expense',80,0,NULL),(535,'Retail - Simple','Retail - Simple','5900','Inventory Adjustments',70,0,'invcompany.costadjustglacctid'),(534,'Retail - Simple','Retail - Simple','5400','Cost of Sales - Salary & Wage',70,0,NULL),(533,'Retail - Simple','Retail - Simple','5100','Cost of Sales - Freight',70,0,NULL),(532,'Retail - Simple','Retail - Simple','5000','Cost of Sales',70,0,'arcompany.cost;invcompany.cost'),(531,'Retail - Simple','Retail - Simple','4900','Sales Discounts',50,0,'apcompany.discount'),(530,'Retail - Simple','Retail - Simple','4300','Other Income',50,0,NULL),(529,'Retail - Simple','Retail - Simple','4200','Finance Charge Income',50,0,NULL),(528,'Retail - Simple','Retail - Simple','4100','Interest Income',50,0,'arcompany.interest'),(527,'Retail - Simple','Retail - Simple','4000','Sales Income',50,0,'invcompany.sales'),(526,'Retail - Simple','Retail - Simple','2700','Long Term Debt - Noncurrent',22,0,NULL),(525,'Retail - Simple','Retail - Simple','2500','Current Portion Long-Term Debt',21,0,NULL),(524,'Retail - Simple','Retail - Simple','2400','Customer Deposits',21,0,'arcompany.depositglacctid'),(523,'Retail - Simple','Retail - Simple','2380','Income Taxes Payable',21,0,NULL),(522,'Retail - Simple','Retail - Simple','2370','Local Taxes Payable',21,0,NULL),(521,'Retail - Simple','Retail - Simple','2360','SUTA Payable',21,0,'prcompany.glsuipayableid'),(520,'Retail - Simple','Retail - Simple','2350','State Payroll Taxes Payable',21,0,NULL),(519,'Retail - Simple','Retail - Simple','2340','FUTA Payable',21,0,'prcompany.glfuipayableid'),(518,'Retail - Simple','Retail - Simple','2330','Federal Payroll Income Tax Payable',21,0,'prcompany.glfitpayableid'),(517,'Retail - Simple','Retail - Simple','2320','Deductions Payable',21,0,'prcompany.glmiscdedpayableid'),(516,'Retail - Simple','Retail - Simple','2310','Sales Tax Payable',21,0,NULL),(515,'Retail - Simple','Retail - Simple','2000','Accounts Payable',21,0,'apcompany.payable'),(514,'Retail - Simple','Retail - Simple','1900','Accum. Depreciation - Prop&Eqt',11,0,NULL),(513,'Retail - Simple','Retail - Simple','1500','Property and Equipment',11,0,NULL),(512,'Retail - Simple','Retail - Simple','1400','Prepaid Expenses',10,0,NULL),(511,'Retail - Simple','Retail - Simple','1200','Inventory',10,0,'arcompany.inventory;invcompany.default_inventoryglacct'),(510,'Retail - Simple','Retail - Simple','1150','Allowance for Doubtful Account',10,0,''),(509,'Retail - Simple','Retail - Simple','1100','Accounts Receivable',10,0,'arcompany.receivables'),(508,'Retail - Simple','Retail - Simple','1020','Checking Account',10,0,'apcompany.glccid;arcompany.checking;prcompany.glcheckaccountid'),(507,'Retail - Simple','Retail - Simple','1010','Cash on Hand',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(506,'Retail - Extensive','Retail - Extensive','35000','Retained Earnings',40,0,NULL),(505,'Retail - Extensive','Retail - Extensive','30000','Equity',30,0,NULL),(504,'Retail - Extensive','Retail - Extensive','90000','Gain/Loss on Sale of Assets',80,0,NULL),(503,'Retail - Extensive','Retail - Extensive','89500','Purchase Disc-Expense Items',80,0,NULL),(502,'Retail - Extensive','Retail - Extensive','89000','Other Expense',80,0,NULL),(501,'Retail - Extensive','Retail - Extensive','78000','Utilities Expense',80,0,NULL),(500,'Retail - Extensive','Retail - Extensive','77500','Wages Expense',80,0,NULL),(499,'Retail - Extensive','Retail - Extensive','77000','Salaries Expense',80,0,NULL),(498,'Retail - Extensive','Retail - Extensive','76500','Travel Expense',80,0,NULL),(497,'Retail - Extensive','Retail - Extensive','76000','Telephone Expense',80,0,NULL),(496,'Retail - Extensive','Retail - Extensive','75500','Supplies Expense',80,0,NULL),(495,'Retail - Extensive','Retail - Extensive','74500','Repairs Expense',80,0,NULL),(494,'Retail - Extensive','Retail - Extensive','74000','Rent or Lease Expense',80,0,NULL),(493,'Retail - Extensive','Retail - Extensive','73500','Postage Expense',80,0,NULL),(492,'Retail - Extensive','Retail - Extensive','73000','Other Taxes',80,0,'invcompany.tax'),(491,'Retail - Extensive','Retail - Extensive','72500','Penalties and Fines Exp',80,0,NULL),(490,'Retail - Extensive','Retail - Extensive','72000','Payroll Tax Expense',80,0,NULL),(489,'Retail - Extensive','Retail - Extensive','71000','Office Expense',80,0,NULL),(488,'Retail - Extensive','Retail - Extensive','70500','Meals and Entertainment Exp',80,0,NULL),(487,'Retail - Extensive','Retail - Extensive','70000','Maintenance Expense',80,0,NULL),(486,'Retail - Extensive','Retail - Extensive','69500','Loss on NSF Checks',80,0,NULL),(485,'Retail - Extensive','Retail - Extensive','69000','Licenses Expense',80,0,NULL),(484,'Retail - Extensive','Retail - Extensive','68500','Legal and Professional Expense',80,0,NULL),(483,'Retail - Extensive','Retail - Extensive','68000','Laundry and Cleaning Exp',80,0,NULL),(482,'Retail - Extensive','Retail - Extensive','67500','Interest Expense',80,0,'apcompany.interestexpense'),(481,'Retail - Extensive','Retail - Extensive','67000','Insurance Expense',80,0,NULL),(480,'Retail - Extensive','Retail - Extensive','66500','Income Tax Expense',80,0,NULL),(479,'Retail - Extensive','Retail - Extensive','66000','Gifts Expense',80,0,NULL),(478,'Retail - Extensive','Retail - Extensive','65500','Freight Expense',80,0,'invcompany.freight'),(477,'Retail - Extensive','Retail - Extensive','65000','Employee Benefit Programs Exp',80,0,NULL),(476,'Retail - Extensive','Retail - Extensive','64500','Dues and Subscriptions Exp',80,0,NULL),(475,'Retail - Extensive','Retail - Extensive','64000','Depreciation Expense',80,0,NULL),(474,'Retail - Extensive','Retail - Extensive','63500','Commissions and Fees Exp',80,0,'apcompany.glcommissionid'),(473,'Retail - Extensive','Retail - Extensive','63000','Charitable Contributions Exp',80,0,NULL),(472,'Retail - Extensive','Retail - Extensive','62500','Cash Over and Short',80,0,NULL),(471,'Retail - Extensive','Retail - Extensive','62000','Bank Charges',80,0,NULL),(470,'Retail - Extensive','Retail - Extensive','61500','Bad Debt Expense',80,0,'arcompany.baddebt'),(469,'Retail - Extensive','Retail - Extensive','61000','Auto Expenses',80,0,NULL),(468,'Retail - Extensive','Retail - Extensive','60500','Amortization Expense',80,0,NULL),(467,'Retail - Extensive','Retail - Extensive','60100','Advertising Expense',80,0,NULL),(466,'Retail - Extensive','Retail - Extensive','60000','Default Purchase Expense',80,0,NULL),(465,'Retail - Extensive','Retail - Extensive','59500','Purchase Discounts',70,0,'apcompany.discount'),(464,'Retail - Extensive','Retail - Extensive','59000','Purchase Returns and Allowances',70,0,NULL),(463,'Retail - Extensive','Retail - Extensive','58500','Inventory Adjustments',70,0,'invcompany.costadjustglacctid'),(462,'Retail - Extensive','Retail - Extensive','58000','Cost of Sales-Other',70,0,NULL),(461,'Retail - Extensive','Retail - Extensive','57500','Cost of Sales-Freight',70,0,NULL),(460,'Retail - Extensive','Retail - Extensive','57000','Cost of Sales-Salaries and Wages',70,0,NULL),(459,'Retail - Extensive','Retail - Extensive','50500','Cost of Sales-Service',70,0,NULL),(458,'Retail - Extensive','Retail - Extensive','50000','Cost of Goods Sold',70,0,'arcompany.cost;invcompany.cost'),(457,'Retail - Extensive','Retail - Extensive','49000','Sales Discounts',50,0,'apcompany.discount'),(456,'Retail - Extensive','Retail - Extensive','48000','Sales Returns and Allowances',50,0,'arcompany.refund'),(455,'Retail - Extensive','Retail - Extensive','45500','Shipping Charges Reimbursed',50,0,NULL),(454,'Retail - Extensive','Retail - Extensive','45400','Finance Charge Income',50,0,NULL),(453,'Retail - Extensive','Retail - Extensive','40800','Other Income',50,0,'arcompany.restockglid'),(452,'Retail - Extensive','Retail - Extensive','40600','Interest Income',50,0,'arcompany.interest'),(451,'Retail - Extensive','Retail - Extensive','40400','Sales-Clearance',50,0,NULL),(450,'Retail - Extensive','Retail - Extensive','40200','Sales-Services',50,0,'arcompany.labor_sales_glacctid'),(449,'Retail - Extensive','Retail - Extensive','40000','Sales-Merchandise',50,0,'invcompany.sales'),(448,'Retail - Extensive','Retail - Extensive','27400','Other Long-Term Liabilities',22,0,NULL),(447,'Retail - Extensive','Retail - Extensive','27000','Notes Payable-Noncurrent',22,0,NULL),(446,'Retail - Extensive','Retail - Extensive','24900','Suspense-Clearing Account',21,0,NULL),(445,'Retail - Extensive','Retail - Extensive','24800','Other Current Liabilities',21,0,NULL),(444,'Retail - Extensive','Retail - Extensive','24500','Contracts Payable',21,0,NULL),(443,'Retail - Extensive','Retail - Extensive','24400','Customer Deposits',21,0,'arcompany.depositglacctid'),(442,'Retail - Extensive','Retail - Extensive','24200','Current Portion Long-Term Debt',21,0,NULL),(441,'Retail - Extensive','Retail - Extensive','24100','Employee Benefits Payable',21,0,NULL),(440,'Retail - Extensive','Retail - Extensive','24000','Other Taxes Payable',21,0,NULL),(439,'Retail - Extensive','Retail - Extensive','23900','Income Taxes Payable',21,0,NULL),(438,'Retail - Extensive','Retail - Extensive','23800','Local Payroll Taxes Payable',21,0,NULL),(437,'Retail - Extensive','Retail - Extensive','23700','SUTA Payable',21,0,NULL),(436,'Retail - Extensive','Retail - Extensive','23600','State Payroll Taxes Payable',21,0,NULL),(435,'Retail - Extensive','Retail - Extensive','23500','FUTA Tax Payable',21,0,NULL),(434,'Retail - Extensive','Retail - Extensive','23400','Federal Payroll Taxes Payable',21,0,NULL),(433,'Retail - Extensive','Retail - Extensive','23300','Deductions Payable',21,0,NULL),(432,'Retail - Extensive','Retail - Extensive','23200','Wages Payable',21,0,NULL),(431,'Retail - Extensive','Retail - Extensive','23100','Sales Tax Payable',21,0,NULL),(430,'Retail - Extensive','Retail - Extensive','23000','Accrued Expenses',21,0,NULL),(429,'Retail - Extensive','Retail - Extensive','20000','Accounts Payable',21,0,'apcompany.payable;prcompany.glmiscdedpayableid;arcompany.shipliability'),(428,'Retail - Extensive','Retail - Extensive','19900','Other Noncurrent Assets',13,0,NULL),(427,'Retail - Extensive','Retail - Extensive','19200','Note Receivable-Noncurrent',13,0,NULL),(426,'Retail - Extensive','Retail - Extensive','19150','Accum. Amortiz. - Org. Costs',13,0,NULL),(425,'Retail - Extensive','Retail - Extensive','19100','Organization Costs',13,0,NULL),(424,'Retail - Extensive','Retail - Extensive','19000','Deposits',13,0,NULL),(423,'Retail - Extensive','Retail - Extensive','17600','Accum. Depreciation - Bldg Imp',11,0,NULL),(422,'Retail - Extensive','Retail - Extensive','17500','Accum. Depreciation - Building',11,0,NULL),(421,'Retail - Extensive','Retail - Extensive','17400','Accum. Depreciation - Leasehold',11,0,NULL),(420,'Retail - Extensive','Retail - Extensive','17300','Accum. Depreciation - Other',11,0,NULL),(419,'Retail - Extensive','Retail - Extensive','17200','Accum. Depreciation - Automobil',11,0,NULL),(418,'Retail - Extensive','Retail - Extensive','17100','Accum. Depreciation - Equipment',11,0,NULL),(417,'Retail - Extensive','Retail - Extensive','17000','Accum. Depreciation - Furniture',11,0,NULL),(416,'Retail - Extensive','Retail - Extensive','16900','Land',11,0,NULL),(415,'Retail - Extensive','Retail - Extensive','15600','Building Improvements',11,0,NULL),(414,'Retail - Extensive','Retail - Extensive','15500','Building',11,0,NULL),(413,'Retail - Extensive','Retail - Extensive','15400','Leasehold Improvements',11,0,NULL),(412,'Retail - Extensive','Retail - Extensive','15300','Other Depreciable Property',11,0,NULL),(411,'Retail - Extensive','Retail - Extensive','15200','Automobiles',11,0,NULL),(410,'Retail - Extensive','Retail - Extensive','15100','Equipment',11,0,NULL),(409,'Retail - Extensive','Retail - Extensive','15000','Furniture and Fixtures',11,0,NULL),(408,'Retail - Extensive','Retail - Extensive','14700','Other Current Assets',10,0,NULL),(407,'Retail - Extensive','Retail - Extensive','14200','Notes Receivable-Current',10,0,NULL),(406,'Retail - Extensive','Retail - Extensive','14100','Employee Advances',10,0,NULL),(405,'Retail - Extensive','Retail - Extensive','14000','Prepaid Expenses',10,0,NULL),(404,'Retail - Extensive','Retail - Extensive','12100','Office Supplies Inventory',10,0,NULL),(403,'Retail - Extensive','Retail - Extensive','12050','Cleaning Supplies Inventory',10,0,NULL),(402,'Retail - Extensive','Retail - Extensive','12000','Product Inventory',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(401,'Retail - Extensive','Retail - Extensive','11500','Allowance for Doubtful Account',10,0,NULL),(400,'Retail - Extensive','Retail - Extensive','11400','Other Receivables',10,0,NULL),(399,'Retail - Extensive','Retail - Extensive','11100','Accounts Receivable Service',10,0,NULL),(398,'Retail - Extensive','Retail - Extensive','11000','Accounts Receivable',10,0,'arcompany.receivables'),(397,'Retail - Extensive','Retail - Extensive','10400','Savings Account',10,0,NULL),(396,'Retail - Extensive','Retail - Extensive','10300','Payroll Checking Account',10,0,NULL),(395,'Retail - Extensive','Retail - Extensive','10200','Regular Checking Account',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(394,'Retail - Extensive','Retail - Extensive','10100','Cash on Hand',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(393,'Retail - Extensive','Retail - Extensive','10000','Petty Cash',10,0,NULL),(391,'Printers','Printers','30000','Equity',30,0,NULL),(392,'Printers','Printers','35000','Retained Earnings',40,0,NULL),(390,'Printers','Printers','86000','Postage & Freight Exp',80,0,NULL),(389,'Printers','Printers','85500','Water Mains Expense',80,0,NULL),(388,'Printers','Printers','85000','Rent-Equipment',80,0,NULL),(387,'Printers','Printers','84500','Rent-Office',80,0,NULL),(386,'Printers','Printers','84000','Union Welfare Expense',80,0,NULL),(385,'Printers','Printers','83500','Union Dues Paid Expense',80,0,NULL),(384,'Printers','Printers','82500','Travel Expense',80,0,NULL),(383,'Printers','Printers','82000','Training & Education Exp',80,0,NULL),(382,'Printers','Printers','81000','Telephone Expense',80,0,NULL),(381,'Printers','Printers','80000','Subdivision Costs Expense',80,0,NULL),(380,'Printers','Printers','79000','Depreciation Expense',80,0,NULL),(379,'Printers','Printers','78500','Roads & Curbs Expense',80,0,NULL),(378,'Printers','Printers','76000','Licenses & Permits Exp',80,0,NULL),(377,'Printers','Printers','75000','Other Office Expenses',80,0,NULL),(376,'Printers','Printers','71500','Legal and Accounting Expense',80,0,NULL),(375,'Printers','Printers','90000','Gain/Loss on Sale of Assets',80,0,NULL),(374,'Printers','Printers','89500','Purchase Disc-Expense Items',80,0,'apcompany.discount'),(373,'Printers','Printers','89000','Other Expense',80,0,NULL),(372,'Printers','Printers','78000','Utilities Expense',80,0,NULL),(371,'Printers','Printers','77500','Wages Expense',80,0,NULL),(370,'Printers','Printers','77000','Salaries Expense',80,0,NULL),(369,'Printers','Printers','76500','Telephone Expense',80,0,NULL),(368,'Printers','Printers','75500','Supplies Services',80,0,NULL),(367,'Printers','Printers','74500','Repairs Expense',80,0,NULL),(366,'Printers','Printers','74000','Rent or Lease Expense',80,0,NULL),(365,'Printers','Printers','73500','Postage Expense',80,0,NULL),(364,'Printers','Printers','73000','Other Taxes',80,0,'invcompany.tax'),(363,'Printers','Printers','72500','Penalties and Fines Exp',80,0,NULL),(362,'Printers','Printers','72000','Payroll Tax Expense',80,0,NULL),(361,'Printers','Printers','71000','Office Expense',80,0,NULL),(360,'Printers','Printers','70500','Meals and Entertainment Exp',80,0,NULL),(359,'Printers','Printers','70000','Maintenance Expense',80,0,NULL),(358,'Printers','Printers','69500','Loss on NSF Checks',80,0,NULL),(357,'Printers','Printers','69000','Licenses Expense',80,0,NULL),(356,'Printers','Printers','68500','Legal and Professional Expense',80,0,NULL),(355,'Printers','Printers','68000','Laundry and Cleaning Exp',80,0,NULL),(354,'Printers','Printers','67500','Interest Expense',80,0,'apcompany.interestexpense'),(353,'Printers','Printers','67000','Insurance Expense',80,0,NULL),(352,'Printers','Printers','66500','Income Tax Expense',80,0,NULL),(351,'Printers','Printers','66000','Gifts Expense',80,0,NULL),(350,'Printers','Printers','65500','Freight Expense',80,0,'invcompany.freight'),(349,'Printers','Printers','65000','Employee Benefit Programs Exp',80,0,NULL),(348,'Printers','Printers','64500','Dues and Subscriptions Exp',80,0,NULL),(347,'Printers','Printers','64000','Depreciation Expense',80,0,NULL),(346,'Printers','Printers','63500','Commissions and Fees Exp',80,0,'apcompany.glcommissionid'),(345,'Printers','Printers','63000','Charitable Contributions Exp',80,0,NULL),(344,'Printers','Printers','62500','Cash Over and Short',80,0,NULL),(343,'Printers','Printers','62000','Bank Charges',80,0,NULL),(342,'Printers','Printers','61500','Bad Debt Expense',80,0,'arcompany.baddebt'),(341,'Printers','Printers','61000','Auto Expenses',80,0,NULL),(340,'Printers','Printers','60500','Amortization Expense',80,0,NULL),(339,'Printers','Printers','60100','Advertising Expense',80,0,NULL),(338,'Printers','Printers','60000','Default Purchase Expense',80,0,NULL),(337,'Printers','Printers','59500','Purchase Discounts',70,0,NULL),(336,'Printers','Printers','59000','Purchase Returns and Allowance',70,0,NULL),(335,'Printers','Printers','58500','Inventory Adjustments',70,0,NULL),(334,'Printers','Printers','58000','Cost of Sales-Other',70,0,NULL),(333,'Printers','Printers','57500','Cost of Sales-Freight',70,0,NULL),(332,'Printers','Printers','57000','Cost of Sales-Salaries and Wages',70,0,NULL),(331,'Printers','Printers','50000','Cost of Sales',70,0,'arcompany.cost;invcompany.cost;invcompany.costadjustglacctid'),(330,'Printers','Printers','49000','Sales Discounts',50,0,'apcompany.discount'),(329,'Printers','Printers','48000','Sales Returns and Allowances',50,0,'arcompany.refund'),(328,'Printers','Printers','45500','Shipping Charges Reimbursed',50,0,NULL),(327,'Printers','Printers','45400','Finance Charge Income',50,0,NULL),(326,'Printers','Printers','40400','Other Income',50,0,'arcompany.restockglid'),(325,'Printers','Printers','40200','Interest Income',50,0,'arcompany.interest'),(324,'Printers','Printers','40000','Sales',50,0,'invcompany.sales;arcompany.labor_sales_glacctid'),(323,'Printers','Printers','27400','Other Long-Term Liabilities',22,0,NULL),(322,'Printers','Printers','27100','Deferred Revenue',22,0,NULL),(321,'Printers','Printers','27000','Notes Payable-Noncurrent',22,0,NULL),(320,'Printers','Printers','24900','Suspense-Clearing Account',21,0,NULL),(319,'Printers','Printers','24800','Other Current Liabilities',21,0,NULL),(318,'Printers','Printers','24400','Customer Deposits',21,0,'arcompany.depositglacctid'),(317,'Printers','Printers','24200','Current Portion Long-Term Debt',21,0,NULL),(316,'Printers','Printers','24100','Employee Benefits Payable',21,0,NULL),(315,'Printers','Printers','24000','Other Taxes Payable',21,0,NULL),(314,'Printers','Printers','23900','Income Taxes Payable',21,0,NULL),(313,'Printers','Printers','23800','Local Payroll Taxes Payable',21,0,NULL),(312,'Printers','Printers','23700','SUTA Payable',21,0,NULL),(311,'Printers','Printers','23600','State Payroll Taxes Payable',21,0,NULL),(310,'Printers','Printers','23500','FUTA Tax Payable',21,0,NULL),(309,'Printers','Printers','23400','Federal Payroll Taxes Payable',21,0,NULL),(308,'Printers','Printers','23300','Deductions Payable',21,0,NULL),(307,'Printers','Printers','23200','Wages Payable',21,0,NULL),(306,'Printers','Printers','23100','Sales Tax Payable',21,0,NULL),(305,'Printers','Printers','23000','Accrued Expenses',21,0,NULL),(304,'Printers','Printers','20000','Accounts Payable',21,0,'apcompany.payable;arcompany.shipliability'),(303,'Printers','Printers','19900','Other Noncurrent Assets',13,0,NULL),(302,'Printers','Printers','19200','Note Receivable-Noncurrent',13,0,NULL),(301,'Printers','Printers','19150','Accum. Amortiz. - Org. Costs',13,0,NULL),(300,'Printers','Printers','19100','Organization Costs',13,0,NULL),(299,'Printers','Printers','19000','Deposits',13,0,NULL),(298,'Printers','Printers','17600','Accum. Depreciation - Bldg Imp',11,0,NULL),(297,'Printers','Printers','17500','Accum. Depreciation - Building',11,0,NULL),(296,'Printers','Printers','17400','Accum. Depreciation - Leasehold',11,0,NULL),(295,'Printers','Printers','17300','Accum. Depreciation - Other',11,0,NULL),(294,'Printers','Printers','17200','Accum. Depreciation - Automobil',11,0,NULL),(293,'Printers','Printers','17100','Accum. Depreciation - Equipment',11,0,NULL),(292,'Printers','Printers','17000','Accum. Depreciation - Furniture',11,0,NULL),(291,'Printers','Printers','16900','Land',11,0,NULL),(290,'Printers','Printers','15600','Building Improvements',11,0,NULL),(289,'Printers','Printers','15500','Building',11,0,NULL),(288,'Printers','Printers','15400','Leasehold Improvements',11,0,NULL),(287,'Printers','Printers','15300','Other Depreciable Property',11,0,NULL),(286,'Printers','Printers','15200','Automobiles',11,0,NULL),(285,'Printers','Printers','15100','Equipment',11,0,NULL),(284,'Printers','Printers','15000','Furniture and Fixtures',11,0,NULL),(283,'Printers','Printers','14700','Other Current Assets',10,0,NULL),(282,'Printers','Printers','14300','Work in Process',10,0,NULL),(281,'Printers','Printers','14200','Notes Receivable-Current',10,0,NULL),(280,'Printers','Printers','14100','Employee Advances',10,0,NULL),(279,'Printers','Printers','14000','Prepaid Expenses',10,0,NULL),(278,'Printers','Printers','12000','Inventory',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(277,'Printers','Printers','11500','Allowance for Doubtful Account',10,0,NULL),(276,'Printers','Printers','11400','Other Receivables',10,0,NULL),(275,'Printers','Printers','11100','Contracts Receivable',10,0,NULL),(274,'Printers','Printers','11000','Accounts Receivable',10,0,'arcompany.receivables'),(273,'Printers','Printers','10700','Investments-Cert. of Deposit',10,0,NULL),(272,'Printers','Printers','10600','Investments-Money Market',10,0,NULL),(271,'Printers','Printers','10500','Special Account',10,0,NULL),(270,'Printers','Printers','10400','Savings Account',10,0,NULL),(269,'Printers','Printers','10300','Payroll Checking Account',10,0,NULL),(268,'Printers','Printers','10200','Regular Checking Account',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(267,'Printers','Printers','10100','Cash on Hand',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(266,'Printers','Printers','10000','Petty Cash',10,0,NULL),(265,'Accountants','Accountants','35000','Retained Earnings',40,0,NULL),(264,'Accountants','Accountants','30000','Equity',30,0,NULL),(263,'Accountants','Accountants','86000','Postage & Freight Exp',80,0,NULL),(262,'Accountants','Accountants','85500','Water Mains Expense',80,0,NULL),(261,'Accountants','Accountants','85000','Rent-Equipment',80,0,NULL),(260,'Accountants','Accountants','84500','Rent-Office',80,0,NULL),(259,'Accountants','Accountants','84000','Union Welfare Expense',80,0,NULL),(258,'Accountants','Accountants','83500','Union Dues Paid Expense',80,0,NULL),(257,'Accountants','Accountants','82500','Travel Expense',80,0,NULL),(256,'Accountants','Accountants','82000','Training & Education Exp',80,0,NULL),(255,'Accountants','Accountants','81000','Telephone Expense',80,0,NULL),(254,'Accountants','Accountants','71500','Legal and Accounting Expense',80,0,NULL),(253,'Accountants','Accountants','90000','Gain/Loss on Sale of Assets',80,0,NULL),(252,'Accountants','Accountants','89500','Purchase Disc-Expense Items',80,0,NULL),(251,'Accountants','Accountants','89000','Other Expense',80,0,NULL),(250,'Accountants','Accountants','80000','Freight Expense',80,0,'invcompany.freight'),(249,'Accountants','Accountants','79500','Postage Expense',80,0,NULL),(248,'Accountants','Accountants','79000','Telephone Expense',80,0,NULL),(247,'Accountants','Accountants','78500','Utilities Expense',80,0,NULL),(246,'Accountants','Accountants','78000','Travel Expense',80,0,NULL),(245,'Accountants','Accountants','77500','Wages Expense',80,0,NULL),(244,'Accountants','Accountants','77000','Salaries Expense',80,0,NULL),(243,'Accountants','Accountants','76500','Subcontract Fees',80,0,NULL),(242,'Accountants','Accountants','76000','Supplies Expense',80,0,NULL),(241,'Accountants','Accountants','75500','Repair Expense',80,0,NULL),(240,'Accountants','Accountants','75000','Rent or Lease Expense',80,0,NULL),(239,'Accountants','Accountants','74500','Professional Salaries-Nonbillable',80,0,NULL),(238,'Accountants','Accountants','74000','Professional Salaries-Billable',80,0,NULL),(237,'Accountants','Accountants','73500','Professional Development Exp',80,0,NULL),(236,'Accountants','Accountants','72500','Penalties and Fines Exp',80,0,NULL),(235,'Accountants','Accountants','72000','Payroll Tax Expense',80,0,NULL),(234,'Accountants','Accountants','71000','Other Taxes',80,0,'invcompany.tax'),(233,'Accountants','Accountants','70500','Office Expense',80,0,NULL),(232,'Accountants','Accountants','70000','Meals and Entertainment Exp',80,0,NULL),(231,'Accountants','Accountants','69500','Maintenance Expense',80,0,NULL),(230,'Accountants','Accountants','69000','Loss on NSF Checks',80,0,NULL),(229,'Accountants','Accountants','68500','Licenses Expense',80,0,NULL),(228,'Accountants','Accountants','68000','Legal and Professional Expense',80,0,NULL),(227,'Accountants','Accountants','67500','Laundry and Cleaning Exp',80,0,NULL),(226,'Accountants','Accountants','67000','Interest Expense',80,0,'apcompany.interestexpense'),(225,'Accountants','Accountants','66500','Insurance Expense',80,0,NULL),(224,'Accountants','Accountants','66000','Income Tax Expense',80,0,NULL),(223,'Accountants','Accountants','65500','Gifts Expense',80,0,NULL),(222,'Accountants','Accountants','65000','Employee Benefit Programs Exp',80,0,NULL),(221,'Accountants','Accountants','64000','Dues and Subscriptions Exp',80,0,NULL),(220,'Accountants','Accountants','63500','Depreciation Expense Exp',80,0,NULL),(219,'Accountants','Accountants','63000','Commissions and Fees Exp',80,0,'apcompany.glcommissionid'),(218,'Accountants','Accountants','62500','Client Promotion',80,0,NULL),(217,'Accountants','Accountants','62000','Charitable Contributions Exp',80,0,NULL),(216,'Accountants','Accountants','61500','Bad Debt Expense',80,0,'arcompany.baddebt'),(215,'Accountants','Accountants','61000','Cash Over and Short',80,0,NULL),(214,'Accountants','Accountants','60500','Bank Charges',80,0,'apcompany.servicecharges'),(213,'Accountants','Accountants','60100','Auto Expense',80,0,NULL),(212,'Accountants','Accountants','60000','Default Purchase Expense',80,0,NULL),(211,'Accountants','Accountants','57000','Cost of Sales-Salaries and Wages',70,0,NULL),(210,'Accountants','Accountants','50000','Cost of Sales',70,0,'arcompany.cost;invcompany.cost;invcompany.costadjustglacctid'),(209,'Accountants','Accountants','49000','Fee Discounts',50,0,'apcompany.discount;arcompany.discount'),(208,'Accountants','Accountants','48000','Fee Refunds',50,0,'arcompany.refund'),(207,'Accountants','Accountants','45500','Shipping Charges Reimbursed',50,0,NULL),(206,'Accountants','Accountants','45400','Finance Charge Income',50,0,NULL),(205,'Accountants','Accountants','40800','Interest Income',50,0,'arcompany.interest'),(204,'Accountants','Accountants','40600','Other Income',50,0,'invcompany.sales'),(203,'Accountants','Accountants','40400','Consulting Fees',50,0,'arcompany.labor_sales_glacctid;arcompany.restockglid'),(202,'Accountants','Accountants','40200','Tax Fees',50,0,NULL),(201,'Accountants','Accountants','40000','Accounting Fees',50,0,NULL),(200,'Accountants','Accountants','27400','Other Long-Term Liabilities',22,0,NULL),(199,'Accountants','Accountants','27000','Notes Payable-Noncurrent',22,0,NULL),(198,'Accountants','Accountants','24900','Suspense-Clearing Account',21,0,NULL),(197,'Accountants','Accountants','24800','Other Current Liabilities',21,0,NULL),(196,'Accountants','Accountants','24400','Client Deposits',21,0,'arcompany.depositglacctid'),(195,'Accountants','Accountants','24200','Current Portion Long-Term Debt',21,0,NULL),(194,'Accountants','Accountants','24100','Employee Benefits Payable',21,0,NULL),(193,'Accountants','Accountants','24000','Other Taxes Payable',21,0,NULL),(192,'Accountants','Accountants','23900','Income Taxes Payable',21,0,NULL),(191,'Accountants','Accountants','23800','Local Payroll Taxes Payable',21,0,NULL),(190,'Accountants','Accountants','23700','SUTA Payable',21,0,NULL),(189,'Accountants','Accountants','23600','State Payroll Taxes Payable',21,0,NULL),(188,'Accountants','Accountants','23500','FUTA Tax Payable',21,0,NULL),(187,'Accountants','Accountants','23400','Federal Payroll Taxes Payable',21,0,NULL),(186,'Accountants','Accountants','23300','Deductions Payable',21,0,NULL),(185,'Accountants','Accountants','23200','Wages Payable',21,0,NULL),(184,'Accountants','Accountants','23100','Sales Tax Payable',21,0,NULL),(183,'Accountants','Accountants','23000','Accrued Expenses',21,0,NULL),(182,'Accountants','Accountants','20000','Accounts Payable',21,0,'apcompany.payable;arcompany.shipliability'),(181,'Accountants','Accountants','19900','Other Noncurrent Assets',13,0,NULL),(180,'Accountants','Accountants','19200','Note Receivable-Noncurrent',13,0,NULL),(179,'Accountants','Accountants','19150','Accum. Amortiz. - Org. Costs',13,0,NULL),(178,'Accountants','Accountants','19100','Organization Costs',13,0,NULL),(177,'Accountants','Accountants','19000','Deposits',13,0,NULL),(176,'Accountants','Accountants','17600','Accum. Depreciation - Bldg Imp',11,0,NULL),(175,'Accountants','Accountants','17500','Accum. Depreciation - Building',11,0,NULL),(174,'Accountants','Accountants','17400','Accum. Depreciation - Leasehold',11,0,NULL),(173,'Accountants','Accountants','17300','Accum. Depreciation - Other',11,0,NULL),(172,'Accountants','Accountants','17200','Accum. Depreciation - Automobil',11,0,NULL),(171,'Accountants','Accountants','17100','Accum. Depreciation - Equipment',11,0,NULL),(170,'Accountants','Accountants','17000','Accum. Depreciation - Furniture',11,0,NULL),(169,'Accountants','Accountants','16900','Land',11,0,NULL),(168,'Accountants','Accountants','15600','Building Improvements',11,0,NULL),(167,'Accountants','Accountants','15500','Building',11,0,NULL),(166,'Accountants','Accountants','15400','Leasehold Improvements',11,0,NULL),(165,'Accountants','Accountants','15300','Other Depreciable Property',11,0,NULL),(164,'Accountants','Accountants','15200','Automobiles',11,0,NULL),(163,'Accountants','Accountants','15100','Equipment',11,0,NULL),(162,'Accountants','Accountants','15000','Furniture and Fixtures',11,0,NULL),(161,'Accountants','Accountants','14700','Other Current Assets',10,0,NULL),(160,'Accountants','Accountants','14200','Notes Receivable-Current',10,0,NULL),(159,'Accountants','Accountants','14100','Employee Advances',10,0,NULL),(158,'Accountants','Accountants','14000','Prepaid Expenses',10,0,NULL),(157,'Accountants','Accountants','12000','Inventory',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(156,'Accountants','Accountants','11500','Allowance for Doubtful Account',10,0,NULL),(155,'Accountants','Accountants','11400','Other Receivables',10,0,NULL),(154,'Accountants','Accountants','11000','Accounts Receivable',10,0,'arcompany.receivables'),(153,'Accountants','Accountants','10700','Certificates of Deposit',10,0,NULL),(152,'Accountants','Accountants','10600','Money Market Savings',10,0,NULL),(151,'Accountants','Accountants','10500','Special Account',10,0,NULL),(150,'Accountants','Accountants','10400','Savings Account',10,0,NULL),(149,'Accountants','Accountants','10300','Payroll Checking Account',10,0,NULL),(148,'Accountants','Accountants','10200','Regular Checking Account',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(147,'Accountants','Accountants','10100','Cash on Hand',10,0,'apcompany.glccid;apcompany.glcashid'),(146,'Accountants','Accountants','10000','Petty Cash',10,0,NULL),(145,'Computer','Computer','35000','Retained Earnings',40,0,NULL),(144,'Computer','Computer','30000','Equity',30,0,NULL),(143,'Computer','Computer','90000','Gain/Loss on Sale of Assets',80,0,NULL),(142,'Computer','Computer','89500','Purchase Disc-Expense Items',80,0,NULL),(141,'Computer','Computer','89000','Other Expense',80,0,NULL),(140,'Computer','Computer','78000','Utilities Expense',80,0,NULL),(139,'Computer','Computer','77500','Wages Expense',80,0,NULL),(138,'Computer','Computer','77000','Salaries Expense',80,0,NULL),(137,'Computer','Computer','76500','Telephone Expense',80,0,NULL),(136,'Computer','Computer','75500','Supplies Services',80,0,NULL),(135,'Computer','Computer','74500','Repairs Expense',80,0,NULL),(134,'Computer','Computer','74000','Rent or Lease Expense',80,0,NULL),(133,'Computer','Computer','73500','Postage Expense',80,0,NULL),(132,'Computer','Computer','73000','Other Taxes',80,0,'invcompany.tax'),(131,'Computer','Computer','72500','Penalties and Fines Exp',80,0,NULL),(130,'Computer','Computer','72000','Payroll Tax Expense',80,0,NULL),(129,'Computer','Computer','71000','Office Expense',80,0,NULL),(128,'Computer','Computer','70500','Meals and Entertainment Exp',80,0,NULL),(127,'Computer','Computer','70000','Maintenance Expense',80,0,NULL),(126,'Computer','Computer','69500','Loss on NSF Checks',80,0,NULL),(125,'Computer','Computer','69000','Licenses Expense',80,0,NULL),(124,'Computer','Computer','68500','Legal and Professional Expense',80,0,NULL),(123,'Computer','Computer','68000','Laundry and Cleaning Exp',80,0,NULL),(122,'Computer','Computer','67500','Interest Expense',80,0,'apcompany.interestexpense'),(121,'Computer','Computer','67000','Insurance Expense',80,0,NULL),(120,'Computer','Computer','66500','Income Tax Expense',80,0,NULL),(119,'Computer','Computer','66000','Gifts Expense',80,0,NULL),(118,'Computer','Computer','65500','Freight Expense',80,0,'invcompany.freight'),(117,'Computer','Computer','65000','Employee Benefit Programs Exp',80,0,NULL),(116,'Computer','Computer','64500','Dues and Subscriptions Exp',80,0,NULL),(115,'Computer','Computer','64000','Depreciation Expense',80,0,NULL),(114,'Computer','Computer','63500','Commissions and Fees Exp',80,0,'apcompany.glcommissionid'),(113,'Computer','Computer','63000','Charitable Contributions Exp',80,0,NULL),(112,'Computer','Computer','62500','Cash Over and Short',80,0,NULL),(111,'Computer','Computer','62000','Bank Charges',80,0,NULL),(110,'Computer','Computer','61500','Bad Debt Expense',80,0,'arcompany.baddebt'),(109,'Computer','Computer','61000','Auto Expenses',80,0,NULL),(108,'Computer','Computer','60500','Amortization Expense',80,0,NULL),(107,'Computer','Computer','60100','Advertising Expense',80,0,NULL),(106,'Computer','Computer','60000','Default Purchase Expense',80,0,NULL),(105,'Computer','Computer','59500','Purchase Discounts',70,0,'apcompany.discount'),(104,'Computer','Computer','59000','Purchase Returns and Allowance',70,0,NULL),(103,'Computer','Computer','58500','Inventory Adjustments',70,0,'invcompany.costadjustglacctid'),(102,'Computer','Computer','58000','Cost of Sales-Other',70,0,'arcompany.cost;invcompany.cost'),(101,'Computer','Computer','57500','Cost of Sales-Freight',70,0,NULL),(100,'Computer','Computer','57000','Cost of Sales-Salaries and Wages',70,0,NULL),(99,'Computer','Computer','54000','Cost of Sales-Other Inventory',70,0,NULL),(98,'Computer','Computer','53500','Cost of Sales-Service Parts',70,0,NULL),(97,'Computer','Computer','53000','Cost of Sales-Magazines',70,0,NULL),(96,'Computer','Computer','52500','Cost of Sales-Books',70,0,NULL),(95,'Computer','Computer','52000','Cost of Sales-Software',70,0,NULL),(94,'Computer','Computer','51500','Cost of Sales-Other Peripherals',70,0,NULL),(93,'Computer','Computer','51000','Cost of Sales-Printers',70,0,NULL),(92,'Computer','Computer','50500','Cost of Sales-Monitors',70,0,NULL),(91,'Computer','Computer','50000','Cost of Sales-Computer System',70,0,NULL),(90,'Computer','Computer','49000','Sales Discounts',50,0,'apcompany.discount'),(89,'Computer','Computer','48000','Sales Returns and Allowances',50,0,'arcompany.refund'),(88,'Computer','Computer','45500','Shipping Charges Reimbursed',50,0,NULL),(87,'Computer','Computer','45400','Finance Charge Income',50,0,NULL),(86,'Computer','Computer','43800','Software Source Code Fees',50,0,NULL),(85,'Computer','Computer','43600','Software License Revenue',50,0,NULL),(84,'Computer','Computer','43400','Hosting-Maintenance Fees',50,0,NULL),(83,'Computer','Computer','43200','Design Fees',50,0,NULL),(82,'Computer','Computer','43000','Programming Fees',50,0,NULL),(81,'Computer','Computer','42000','Other Income',50,0,'arcompany.restockglid'),(80,'Computer','Computer','41800','Interest Income',50,0,'arcompany.interest'),(79,'Computer','Computer','41600','Repair Service Income',50,0,'arcompany.labor_sales_glacctid'),(78,'Computer','Computer','41400','Sales-Other Inventory',50,0,'invcompany.sales'),(77,'Computer','Computer','41200','Sales-Magazines',50,0,NULL),(75,'Computer','Computer','40800','Sales-Software',50,0,NULL),(76,'Computer','Computer','41000','Sales-Books',50,0,NULL),(74,'Computer','Computer','40600','Sales-Other Peripherals',50,0,NULL),(73,'Computer','Computer','40400','Sales-Printers',50,0,NULL),(72,'Computer','Computer','40200','Sales-Monitors',50,0,NULL),(71,'Computer','Computer','40000','Sales-Computer Systems',50,0,NULL),(70,'Computer','Computer','27400','Other Long-Term Liabilities',22,0,NULL),(69,'Computer','Computer','27100','Deferred Revenue',22,0,NULL),(68,'Computer','Computer','27000','Notes Payable-Noncurrent',22,0,NULL),(67,'Computer','Computer','24900','Suspense-Clearing Account',21,0,NULL),(66,'Computer','Computer','24800','Other Current Liabilities',21,0,NULL),(65,'Computer','Computer','24500','Client Escrow Funds',21,0,NULL),(64,'Computer','Computer','24400','Customer Deposits',21,0,'arcompany.depositglacctid'),(63,'Computer','Computer','24200','Current Portion Long-Term Debt',21,0,NULL),(62,'Computer','Computer','24100','Employee Benefits Payable',21,0,NULL),(61,'Computer','Computer','24000','Other Taxes Payable',21,0,NULL),(60,'Computer','Computer','23900','Income Taxes Payable',21,0,NULL),(59,'Computer','Computer','23800','Local Payroll Taxes Payable',21,0,NULL),(58,'Computer','Computer','23700','SUTA Payable',21,0,NULL),(57,'Computer','Computer','23600','State Payroll Taxes Payable',21,0,NULL),(56,'Computer','Computer','23500','FUTA Tax Payable',21,0,NULL),(55,'Computer','Computer','23400','Federal Payroll Taxes Payable',21,0,NULL),(54,'Computer','Computer','23300','Deductions Payable',21,0,NULL),(53,'Computer','Computer','23200','Wages Payable',21,0,NULL),(52,'Computer','Computer','23100','Sales Tax Payable',21,0,NULL),(51,'Computer','Computer','23000','Accrued Expenses',21,0,NULL),(50,'Computer','Computer','20000','Accounts Payable',21,0,'apcompany.payable;arcompany.shipliability'),(49,'Computer','Computer','19900','Other Noncurrent Assets',13,0,NULL),(48,'Computer','Computer','19350','Accum.Amort.-Software',13,0,NULL),(47,'Computer','Computer','19300','Software Development Costs',13,0,NULL),(46,'Computer','Computer','19200','Note Receivable-Noncurrent',13,0,NULL),(45,'Computer','Computer','19150','Accum. Amortiz. - Org. Costs',13,0,NULL),(44,'Computer','Computer','19100','Organization Costs',13,0,NULL),(43,'Computer','Computer','19000','Deposits',13,0,NULL),(42,'Computer','Computer','17600','Accum. Depreciation - Bldg Imp',11,0,NULL),(41,'Computer','Computer','17500','Accum. Depreciation - Building',11,0,NULL),(40,'Computer','Computer','17400','Accum. Depreciation - Leasehold',11,0,NULL),(39,'Computer','Computer','17300','Accum. Depreciation - Other',11,0,NULL),(38,'Computer','Computer','17200','Accum. Depreciation - Automobil',11,0,NULL),(37,'Computer','Computer','17100','Accum. Depreciation - Equipment',11,0,NULL),(35,'Computer','Computer','16900','Land',11,0,NULL),(36,'Computer','Computer','17000','Accum. Depreciation - Furniture',11,0,NULL),(34,'Computer','Computer','15600','Building Improvements',11,0,NULL),(33,'Computer','Computer','15500','Building',11,0,NULL),(32,'Computer','Computer','15400','Leasehold Improvements',11,0,NULL),(31,'Computer','Computer','15300','Other Depreciable Property',11,0,NULL),(30,'Computer','Computer','15200','Automobiles',11,0,NULL),(29,'Computer','Computer','15100','Equipment',11,0,NULL),(28,'Computer','Computer','15000','Furniture and Fixtures',11,0,NULL),(27,'Computer','Computer','14700','Other Current Assets',10,0,NULL),(26,'Computer','Computer','14300','Work in Process',10,0,NULL),(25,'Computer','Computer','14200','Notes Receivable-Current',10,0,NULL),(24,'Computer','Computer','14100','Employee Advances',10,0,NULL),(23,'Computer','Computer','14000','Prepaid Expenses',10,0,NULL),(22,'Computer','Computer','12400','Other-Inventory',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(21,'Computer','Computer','12350','Service Parts-Inventory',10,0,NULL),(20,'Computer','Computer','12300','Magazines-Inventory',10,0,NULL),(19,'Computer','Computer','12250','Books-Inventory',10,0,NULL),(18,'Computer','Computer','12200','Software-Inventory',10,0,NULL),(17,'Computer','Computer','12150','Other Peripherals-Inventory',10,0,NULL),(16,'Computer','Computer','12100','Printers-Inventory',10,0,NULL),(15,'Computer','Computer','12050','Monitors-Inventory',10,0,NULL),(14,'Computer','Computer','12000','Computer Systems-Inventory',10,0,NULL),(13,'Computer','Computer','11500','Allowance for Doubtful Account',10,0,NULL),(12,'Computer','Computer','11400','Other Receivables',10,0,NULL),(11,'Computer','Computer','11100','Accounts Receivable Service',10,0,NULL),(10,'Computer','Computer','11000','Accounts Receivable',10,0,'arcompany.receivables'),(9,'Computer','Computer','10800','Certificates of Deposit',10,0,NULL),(8,'Computer','Computer','10700','Money Market Savings',10,0,NULL),(7,'Computer','Computer','10600','Trust Account',10,0,NULL),(6,'Computer','Computer','10500','Special Account',10,0,NULL),(5,'Computer','Computer','10400','Savings Account',10,0,NULL),(4,'Computer','Computer','10300','Payroll Checking Account',10,0,NULL),(3,'Computer','Computer','10200','Regular Checking Account',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(2,'Computer','Computer','10100','Cash on Hand',10,0,NULL),(1,'Computer','Computer','10000','Petty Cash',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(852,'Service - Extensive','Service - Extensive','14100','Employee Advances',10,0,NULL),(853,'Service - Extensive','Service - Extensive','14200','Notes Receivable-Current',10,0,NULL),(854,'Service - Extensive','Service - Extensive','14700','Other Current Assets',10,0,NULL),(855,'Service - Extensive','Service - Extensive','15000','Furniture and Fixtures',11,0,NULL),(856,'Service - Extensive','Service - Extensive','15100','Equipment',11,0,NULL),(857,'Service - Extensive','Service - Extensive','15200','Automobiles',11,0,NULL),(858,'Service - Extensive','Service - Extensive','15300','Other Depreciable Property',11,0,NULL),(859,'Service - Extensive','Service - Extensive','15400','Leasehold Improvements',11,0,NULL),(860,'Service - Extensive','Service - Extensive','15500','Building',11,0,NULL),(861,'Service - Extensive','Service - Extensive','15600','Building Improvements',11,0,NULL),(862,'Service - Extensive','Service - Extensive','16900','Land',11,0,NULL),(863,'Service - Extensive','Service - Extensive','17000','Accum. Depreciation - Furniture',11,0,NULL),(864,'Service - Extensive','Service - Extensive','17100','Accum. Depreciation - Equipment',11,0,NULL),(865,'Service - Extensive','Service - Extensive','17200','Accum. Depreciation - Automobil',11,0,NULL),(866,'Service - Extensive','Service - Extensive','17300','Accum. Depreciation - Other',11,0,NULL),(867,'Service - Extensive','Service - Extensive','17400','Accum. Depreciation - Leasehold',11,0,NULL),(868,'Service - Extensive','Service - Extensive','17500','Accum. Depreciation - Building',11,0,NULL),(869,'Service - Extensive','Service - Extensive','17600','Accum. Depreciation - Bldg Imp',11,0,NULL),(870,'Service - Extensive','Service - Extensive','19000','Deposits',13,0,NULL),(871,'Service - Extensive','Service - Extensive','19100','Organization Costs',13,0,NULL),(872,'Service - Extensive','Service - Extensive','19150','Accum. Amortiz. - Org. Costs',13,0,NULL),(873,'Service - Extensive','Service - Extensive','19200','Note Receivable-Noncurrent',13,0,NULL),(874,'Service - Extensive','Service - Extensive','19900','Other Noncurrent Assets',13,0,NULL),(875,'Service - Extensive','Service - Extensive','20000','Accounts Payable',21,0,'apcompany.payable;prcompany.glworkmanscomppayableid;arcompany.shipliability'),(876,'Service - Extensive','Service - Extensive','23000','Accrued Expenses',21,0,NULL),(877,'Service - Extensive','Service - Extensive','23100','Sales Tax Payable',21,0,NULL),(878,'Service - Extensive','Service - Extensive','23200','Wages Payable',21,0,NULL),(879,'Service - Extensive','Service - Extensive','23300','Deductions Payable',21,0,NULL),(880,'Service - Extensive','Service - Extensive','23400','Federal Payroll Taxes Payable',21,0,NULL),(881,'Service - Extensive','Service - Extensive','23500','FUTA Tax Payable',21,0,NULL),(882,'Service - Extensive','Service - Extensive','23600','State Payroll Taxes Payable',21,0,NULL),(883,'Service - Extensive','Service - Extensive','23700','SUTA Payable',21,0,NULL),(884,'Service - Extensive','Service - Extensive','23800','Local Payroll Taxes Payable',21,0,NULL),(885,'Service - Extensive','Service - Extensive','23900','Income Taxes Payable',21,0,NULL),(886,'Service - Extensive','Service - Extensive','24000','Other Taxes Payable',21,0,NULL),(887,'Service - Extensive','Service - Extensive','24100','Employee Benefits Payable',21,0,NULL),(888,'Service - Extensive','Service - Extensive','24200','Current Portion Long-Term Debt',21,0,NULL),(889,'Service - Extensive','Service - Extensive','24400','Customer Deposits',21,0,'arcompany.depositglacctid'),(890,'Service - Extensive','Service - Extensive','24500','Contracts Payable',21,0,NULL),(891,'Service - Extensive','Service - Extensive','24800','Other Current Liabilities',21,0,NULL),(892,'Service - Extensive','Service - Extensive','24900','Suspense-Clearing Account',21,0,NULL),(893,'Service - Extensive','Service - Extensive','27000','Notes Payable-Noncurrent',22,0,NULL),(894,'Service - Extensive','Service - Extensive','27100','Contracts Payable-Noncurrent',22,0,NULL),(895,'Service - Extensive','Service - Extensive','27400','Other Long-Term Liabilities',22,0,NULL),(896,'Service - Extensive','Service - Extensive','40000','Professional Fees',50,0,'arcompany.labor_sales_glacctid'),(897,'Service - Extensive','Service - Extensive','40200','Payment from Agencies',50,0,NULL),(898,'Service - Extensive','Service - Extensive','40400','Sales of Materials',50,0,'invcompany.sales'),(899,'Service - Extensive','Service - Extensive','40600','Overtime',50,0,NULL),(900,'Service - Extensive','Service - Extensive','40800','Interest Income',50,0,'arcompany.interest'),(901,'Service - Extensive','Service - Extensive','41000','Other Income',50,0,'arcompany.restockglid'),(902,'Service - Extensive','Service - Extensive','45400','Finance Charge Income',50,0,NULL),(903,'Service - Extensive','Service - Extensive','45500','Shipping Charges Reimbursed',50,0,NULL),(904,'Service - Extensive','Service - Extensive','48000','Sales/Fee Refunds',50,0,'arcompany.refund'),(905,'Service - Extensive','Service - Extensive','49000','Sales/Fee Discounts',50,0,'apcompany.discount'),(906,'Service - Extensive','Service - Extensive','50000','Cost of Sales',70,0,'arcompany.cost;invcompany.cost;invcompany.costadjustglacctid'),(907,'Service - Extensive','Service - Extensive','57000','Cost of Sales-Salaries and Wages',70,0,NULL),(908,'Service - Extensive','Service - Extensive','60000','Default Purchase Expense',80,0,NULL),(909,'Service - Extensive','Service - Extensive','60100','Advertising Expense',80,0,NULL),(910,'Service - Extensive','Service - Extensive','60500','Amortization Expense',80,0,NULL),(911,'Service - Extensive','Service - Extensive','61000','Auto Expenses',80,0,NULL),(912,'Service - Extensive','Service - Extensive','61500','Bad Debt Expense',80,0,'arcompany.baddebt'),(913,'Service - Extensive','Service - Extensive','62000','Bank Charges',80,0,NULL),(914,'Service - Extensive','Service - Extensive','62500','Cash Over and Short',80,0,NULL),(915,'Service - Extensive','Service - Extensive','63000','Charitable Contributions Exp',80,0,NULL),(916,'Service - Extensive','Service - Extensive','63500','Commissions and Fees Exp',80,0,'apcompany.glcommissionid'),(917,'Service - Extensive','Service - Extensive','64000','Depreciation Expense',80,0,NULL),(918,'Service - Extensive','Service - Extensive','64500','Dues and Subscriptions Exp',80,0,NULL),(919,'Service - Extensive','Service - Extensive','65000','Employee Benefit Programs Exp',80,0,NULL),(920,'Service - Extensive','Service - Extensive','65500','Freight Expense',80,0,'invcompany.freight'),(921,'Service - Extensive','Service - Extensive','66000','Gifts Expense',80,0,NULL),(922,'Service - Extensive','Service - Extensive','66500','Income Tax Expense',80,0,NULL),(923,'Service - Extensive','Service - Extensive','67000','Insurance Expense',80,0,NULL),(924,'Service - Extensive','Service - Extensive','67500','Interest Expense',80,0,'apcompany.interestexpense'),(925,'Service - Extensive','Service - Extensive','68000','Laundry and Cleaning Exp',80,0,NULL),(926,'Service - Extensive','Service - Extensive','68500','Legal and Professional Expense',80,0,NULL),(927,'Service - Extensive','Service - Extensive','69000','Licenses Expense',80,0,NULL),(928,'Service - Extensive','Service - Extensive','69500','Loss on NSF Checks',80,0,NULL),(929,'Service - Extensive','Service - Extensive','70000','Maintenance Expense',80,0,NULL),(930,'Service - Extensive','Service - Extensive','70500','Meals and Entertainment Exp',80,0,NULL),(931,'Service - Extensive','Service - Extensive','71000','Office Expense',80,0,NULL),(932,'Service - Extensive','Service - Extensive','72000','Payroll Tax Expense',80,0,NULL),(933,'Service - Extensive','Service - Extensive','72500','Penalties and Fines Exp',80,0,NULL),(934,'Service - Extensive','Service - Extensive','73000','Other Taxes',80,0,'invcompany.tax'),(935,'Service - Extensive','Service - Extensive','73500','Postage Expense',80,0,NULL),(936,'Service - Extensive','Service - Extensive','74000','Rent or Lease Expense',80,0,NULL),(937,'Service - Extensive','Service - Extensive','74500','Repairs Expense',80,0,NULL),(938,'Service - Extensive','Service - Extensive','75500','Supplies Expense',80,0,NULL),(939,'Service - Extensive','Service - Extensive','76000','Telephone Expense',80,0,NULL),(940,'Service - Extensive','Service - Extensive','76500','Travel Expense',80,0,NULL),(941,'Service - Extensive','Service - Extensive','77000','Salaries Expense',80,0,NULL),(942,'Service - Extensive','Service - Extensive','77500','Wages Expense',80,0,NULL),(943,'Service - Extensive','Service - Extensive','78000','Utilities Expense',80,0,NULL),(944,'Service - Extensive','Service - Extensive','89000','Other Expense',80,0,NULL),(945,'Service - Extensive','Service - Extensive','89500','Purchase Disc-Expense Items',80,0,'apcompany.discount'),(946,'Service - Extensive','Service - Extensive','90000','Gain/Loss on Sale of Assets',80,0,NULL),(947,'Service - Extensive','Service - Extensive','30000','Equity',30,0,NULL),(948,'Service - Extensive','Service - Extensive','35000','Retained Earnings',40,0,NULL),(949,'Service - Simple','Service - Simple','1010','Cash on Hand',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(950,'Service - Simple','Service - Simple','1020','Checking Account',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(951,'Service - Simple','Service - Simple','1100','Accounts Receivable',10,0,'arcompany.receivables'),(952,'Service - Simple','Service - Simple','1150','Allowance for Doubtful Account',10,0,NULL),(953,'Service - Simple','Service - Simple','1200','Inventory',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(954,'Service - Simple','Service - Simple','1400','Prepaid Expenses',10,0,NULL),(955,'Service - Simple','Service - Simple','1500','Property and Equipment',11,0,NULL),(956,'Service - Simple','Service - Simple','1900','Accum. Depreciation - Prop&Eqt',11,0,NULL),(957,'Service - Simple','Service - Simple','2000','Accounts Payable',21,0,'apcompany.payable;prcompany.glworkmanscomppayableid;arcompany.shipliability;prcompany.glpayroll_payableid'),(958,'Service - Simple','Service - Simple','2310','Sales Tax Payable',21,0,NULL),(959,'Service - Simple','Service - Simple','2320','Deductions Payable',21,0,NULL),(960,'Service - Simple','Service - Simple','2330','Federal Payroll Taxes Payable',21,0,NULL),(961,'Service - Simple','Service - Simple','2340','FUTA Payable',21,0,NULL),(962,'Service - Simple','Service - Simple','2350','State Payroll Taxes Payable',21,0,NULL),(963,'Service - Simple','Service - Simple','2360','SUTA Payable',21,0,NULL),(964,'Service - Simple','Service - Simple','2370','Local Taxes Payable',21,0,NULL),(965,'Service - Simple','Service - Simple','2380','Income Taxes Payable',21,0,NULL),(966,'Service - Simple','Service - Simple','2400','Customer Deposits',21,0,'arcompany.depositglacctid'),(967,'Service - Simple','Service - Simple','2500','Current Portion Long-Term Debt',21,0,NULL),(968,'Service - Simple','Service - Simple','2700','Long-Term Debt - Noncurrent',22,0,NULL),(969,'Service - Simple','Service - Simple','4000','Professional Fees',50,0,'arcompany.labor_sales_glacctid'),(970,'Service - Simple','Service - Simple','4050','Sales of Materials',50,0,'invcompany.sales;arcompany.refund;arcompany.restockglid'),(971,'Service - Simple','Service - Simple','4100','Interest Income',50,0,'arcompany.interest'),(972,'Service - Simple','Service - Simple','4200','Finance Charge Income',50,0,NULL),(973,'Service - Simple','Service - Simple','4300','Other Income',50,0,NULL),(974,'Service - Simple','Service - Simple','4900','Sales/Fee Discounts',50,0,'apcompany.discount'),(975,'Service - Simple','Service - Simple','5000','Cost of Sales',70,0,'arcompany.cost;invcompany.cost'),(976,'Service - Simple','Service - Simple','5400','Cost of Sales - Salary & Wage',70,0,NULL),(977,'Service - Simple','Service - Simple','5900','Inventory Adjustments',70,0,'invcompany.costadjustglacctid'),(978,'Service - Simple','Service - Simple','6000','Wages Expense',80,0,NULL),(979,'Service - Simple','Service - Simple','6050','Employee Benefit Programs Expense',80,0,NULL),(980,'Service - Simple','Service - Simple','6100','Payroll Tax Expense',80,0,NULL),(981,'Service - Simple','Service - Simple','6150','Bad Debt Expense',80,0,'arcompany.baddebt'),(982,'Service - Simple','Service - Simple','6200','Income Tax Expense',80,0,NULL),(983,'Service - Simple','Service - Simple','6250','Other Taxes Expense',80,0,'invcompany.tax'),(984,'Service - Simple','Service - Simple','6300','Rent or Lease Expense',80,0,NULL),(985,'Service - Simple','Service - Simple','6350','Maintenance & Repairs Expense',80,0,NULL),(986,'Service - Simple','Service - Simple','6400','Utilities Expense',80,0,NULL),(987,'Service - Simple','Service - Simple','6450','Office Supplies Expense',80,0,NULL),(988,'Service - Simple','Service - Simple','6500','Telephone Expense',80,0,NULL),(989,'Service - Simple','Service - Simple','6550','Other Office Expense',80,0,NULL),(990,'Service - Simple','Service - Simple','6600','Advertising Expense',80,0,NULL),(991,'Service - Simple','Service - Simple','6650','Commissions and Fees Expense',80,0,'apcompany.glcommissionid'),(992,'Service - Simple','Service - Simple','6800','Freight Expense',80,0,'invcompany.freight'),(993,'Service - Simple','Service - Simple','6850','Service Charge Expense',80,0,'apcompany.interestexpense'),(994,'Service - Simple','Service - Simple','6900','Purchase Disc - Expense Items',80,0,'apcompany.discount'),(995,'Service - Simple','Service - Simple','6950','Insurance Expense',80,0,NULL),(996,'Service - Simple','Service - Simple','7050','Depreciation Expense',80,0,NULL),(997,'Service - Simple','Service - Simple','7100','Gain/Loss - Sale of Assets Exp',80,0,NULL),(998,'Service - Simple','Service - Simple','3000','Equity',30,0,NULL),(999,'Service - Simple','Service - Simple','3500','Retained Earnings',40,0,NULL),(1000,'Medical - Extensive','Medical - Extensive','1010','Petty Cash',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(1001,'Medical - Extensive','Medical - Extensive','1020','Cash - Deposit in Transit',10,0,NULL),(1002,'Medical - Extensive','Medical - Extensive','1030','[Primary] Bank Account #1',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(1003,'Medical - Extensive','Medical - Extensive','1031','[Primary] Bank Account #2',10,0,NULL),(1004,'Medical - Extensive','Medical - Extensive','1032','[Primary] Bank Account #3',10,0,NULL),(1005,'Medical - Extensive','Medical - Extensive','1040','[Secondary] Bank Account #1',10,0,NULL),(1006,'Medical - Extensive','Medical - Extensive','1041','[Secondary] Bank Account #2',10,0,NULL),(1007,'Medical - Extensive','Medical - Extensive','1042','[Secondary] Bank Account #3',10,0,NULL),(1008,'Medical - Extensive','Medical - Extensive','1120','Employee Advances',10,0,NULL),(1009,'Medical - Extensive','Medical - Extensive','1210','Prepaid Expense',10,0,NULL),(1010,'Medical - Extensive','Medical - Extensive','1310','Loan Receivables',13,0,'arcompany.receivables'),(1011,'Medical - Extensive','Medical - Extensive','1510','Automotive Equipment',11,0,NULL),(1012,'Medical - Extensive','Medical - Extensive','1520','Computer Equipment',11,0,NULL),(1013,'Medical - Extensive','Medical - Extensive','1525','Computer Software',11,0,NULL),(1014,'Medical - Extensive','Medical - Extensive','1540','Medical Equipment',11,0,NULL),(1015,'Medical - Extensive','Medical - Extensive','1550','Office Equipment',11,0,NULL),(1016,'Medical - Extensive','Medical - Extensive','1555','Office Furniture',11,0,NULL),(1017,'Medical - Extensive','Medical - Extensive','1560','Land',11,0,NULL),(1018,'Medical - Extensive','Medical - Extensive','1570','Building',11,0,NULL),(1019,'Medical - Extensive','Medical - Extensive','1575','Building Improvements',11,0,NULL),(1020,'Medical - Extensive','Medical - Extensive','1580','Leasehold Improvements',11,0,NULL),(1021,'Medical - Extensive','Medical - Extensive','1590','Accumulated Depreciation',11,0,NULL),(1022,'Medical - Extensive','Medical - Extensive','1710','Organizational Costs',13,0,NULL),(1023,'Medical - Extensive','Medical - Extensive','1711','Accumulated Amortization/Org. Costs',13,0,NULL),(1024,'Medical - Extensive','Medical - Extensive','1720','Startup Costs',13,0,NULL),(1025,'Medical - Extensive','Medical - Extensive','1721','Accumulated Amortization/Startup Costs',13,0,NULL),(1026,'Medical - Extensive','Medical - Extensive','1750','Loan Origination Costs',13,0,NULL),(1027,'Medical - Extensive','Medical - Extensive','1760','Prepaid Interest',13,0,NULL),(1028,'Medical - Extensive','Medical - Extensive','1810','Security Deposit',13,0,NULL),(1029,'Medical - Extensive','Medical - Extensive','1811','Due from Related Party #2',13,0,NULL),(1030,'Medical - Extensive','Medical - Extensive','1812','Due from Related Party #3',13,0,NULL),(1031,'Medical - Extensive','Medical - Extensive','2010','Due to [Credit Card #1]',21,0,'apcompany.payable;prcompany.glmiscdedpayableid;prcompany.glpayroll_payableid;arcompany.depositglacctid;arcompany.shipliability'),(1032,'Medical - Extensive','Medical - Extensive','2011','Due to [Credit Card #2]',21,0,NULL),(1033,'Medical - Extensive','Medical - Extensive','2100','Payroll Taxes Payable',21,0,NULL),(1034,'Medical - Extensive','Medical - Extensive','2101','Social Security Tax Withholding',21,0,NULL),(1035,'Medical - Extensive','Medical - Extensive','2102','Federal Income Tax Withholding',21,0,NULL),(1036,'Medical - Extensive','Medical - Extensive','2111','State/Local #1 Income Tax Withholding',21,0,NULL),(1037,'Medical - Extensive','Medical - Extensive','2112','State/Local #2 Income Tax Withholding',21,0,NULL),(1038,'Medical - Extensive','Medical - Extensive','2310','Pension or Profit Sharing Plan Payable',21,0,NULL),(1039,'Medical - Extensive','Medical - Extensive','2510','Bank #1 Loan Payable #1-Current',21,0,NULL),(1040,'Medical - Extensive','Medical - Extensive','2511','Bank #1 Loan Payable #2-Current',21,0,NULL),(1041,'Medical - Extensive','Medical - Extensive','2520','Bank #2 Loan Payable #1-Current',21,0,NULL),(1042,'Medical - Extensive','Medical - Extensive','2810','Bank #1 Loan Payable #1-Long-Term',21,0,NULL),(1043,'Medical - Extensive','Medical - Extensive','2811','Bank #1 Loan Payable #2-Long-Term',21,0,NULL),(1044,'Medical - Extensive','Medical - Extensive','2820','Bank #2 Loan Payable #1-Long-Term',21,0,NULL),(1045,'Medical - Extensive','Medical - Extensive','3010','Common Stock',30,0,NULL),(1046,'Medical - Extensive','Medical - Extensive','3020','Retained Earnings',40,0,NULL),(1047,'Medical - Extensive','Medical - Extensive','3051','Distributions - Shareholder #1',30,0,NULL),(1048,'Medical - Extensive','Medical - Extensive','3052','Distributions - Shareholder #2',30,0,NULL),(1049,'Medical - Extensive','Medical - Extensive','3053','Distributions - Shareholder #3',30,0,NULL),(1050,'Medical - Extensive','Medical - Extensive','4010','Fees Received - General',50,0,'invcompany.sales;arcompany.labor_sales_glacctid;arcompany.restockglid;arcompany.discount'),(1051,'Medical - Extensive','Medical - Extensive','4011','Fees Received - Dr. #1',50,0,NULL),(1052,'Medical - Extensive','Medical - Extensive','4012','Fees Received - Dr. #2',50,0,NULL),(1053,'Medical - Extensive','Medical - Extensive','4013','Fees Received - Dr. #3',50,0,NULL),(1054,'Medical - Extensive','Medical - Extensive','4014','Fees Received - Dr. #4',50,0,NULL),(1055,'Medical - Extensive','Medical - Extensive','4180','Refunds',50,0,'arcompany.refund'),(1056,'Medical - Extensive','Medical - Extensive','6010','Accounting',80,0,NULL),(1057,'Medical - Extensive','Medical - Extensive','6020','Advertising',80,0,NULL),(1058,'Medical - Extensive','Medical - Extensive','6050','Auto Expense',80,0,NULL),(1059,'Medical - Extensive','Medical - Extensive','6055','Auto Lease',80,0,NULL),(1060,'Medical - Extensive','Medical - Extensive','6060','Bank Charges',80,0,NULL),(1061,'Medical - Extensive','Medical - Extensive','6070','Billing Service expense',80,0,NULL),(1062,'Medical - Extensive','Medical - Extensive','6080','Biomed Waste',80,0,NULL),(1063,'Medical - Extensive','Medical - Extensive','6085','Collection Expense',80,0,NULL),(1064,'Medical - Extensive','Medical - Extensive','6090','Computer Expense',80,0,NULL),(1065,'Medical - Extensive','Medical - Extensive','6100','Contract Services',80,0,'apcompany.glcommissionid'),(1066,'Medical - Extensive','Medical - Extensive','6110','Depreciation',80,0,NULL),(1067,'Medical - Extensive','Medical - Extensive','6120','Dues and Subscriptions',80,0,NULL),(1068,'Medical - Extensive','Medical - Extensive','6122','Dues for Clubs',80,0,NULL),(1069,'Medical - Extensive','Medical - Extensive','6130','Education Expense',80,0,NULL),(1070,'Medical - Extensive','Medical - Extensive','6140','Equipment Lease',80,0,NULL),(1071,'Medical - Extensive','Medical - Extensive','6200','Injectibles - Drugs and Supplies',80,0,NULL),(1072,'Medical - Extensive','Medical - Extensive','6210','Insurance - General',80,0,NULL),(1073,'Medical - Extensive','Medical - Extensive','6215','Insurance - Health and Dental',80,0,NULL),(1074,'Medical - Extensive','Medical - Extensive','6230','Janitor and Cleaning',80,0,NULL),(1075,'Medical - Extensive','Medical - Extensive','6240','Legal and Professional Fees',80,0,NULL),(1076,'Medical - Extensive','Medical - Extensive','6250','Marketing',80,0,NULL),(1077,'Medical - Extensive','Medical - Extensive','6270','Medical Supplies',80,0,NULL),(1078,'Medical - Extensive','Medical - Extensive','6280','Meals and Entertainment',80,0,NULL),(1079,'Medical - Extensive','Medical - Extensive','6290','Office Supplies and Expense',80,0,NULL),(1080,'Medical - Extensive','Medical - Extensive','6310','Pension/Profit Sharing Contributions',80,0,NULL),(1081,'Medical - Extensive','Medical - Extensive','6320','Pest Control',80,0,NULL),(1082,'Medical - Extensive','Medical - Extensive','6330','Postage and Delivery',80,0,NULL),(1083,'Medical - Extensive','Medical - Extensive','6340','Printing and Reproduction',80,0,NULL),(1084,'Medical - Extensive','Medical - Extensive','6350','Public Relations',80,0,NULL),(1085,'Medical - Extensive','Medical - Extensive','6360','Recruiting',80,0,NULL),(1086,'Medical - Extensive','Medical - Extensive','6370','Rent Expense',80,0,NULL),(1087,'Medical - Extensive','Medical - Extensive','6390','Repairs and Maintenance',80,0,NULL),(1088,'Medical - Extensive','Medical - Extensive','6410','Salaries - Officer [Owner]',80,0,NULL),(1089,'Medical - Extensive','Medical - Extensive','6420','Salaries - Other',80,0,NULL),(1090,'Medical - Extensive','Medical - Extensive','6440','Security Expense',80,0,NULL),(1091,'Medical - Extensive','Medical - Extensive','6450','Storage Expense',80,0,NULL),(1092,'Medical - Extensive','Medical - Extensive','6510','Taxes and Licenses',80,0,'invcompany.tax'),(1093,'Medical - Extensive','Medical - Extensive','6520','Taxes - Payroll',80,0,NULL),(1094,'Medical - Extensive','Medical - Extensive','6550','Testing Supplies and Services',80,0,NULL),(1095,'Medical - Extensive','Medical - Extensive','6610','Telephone and Communications',80,0,NULL),(1096,'Medical - Extensive','Medical - Extensive','6640','Travel and Seminars',80,0,NULL),(1097,'Medical - Extensive','Medical - Extensive','6720','Uniforms',80,0,NULL),(1098,'Medical - Extensive','Medical - Extensive','6790','Utilities',80,0,'invcompany.freight'),(1099,'Medical - Extensive','Medical - Extensive','8080','Auto Use Reimbursement',90,0,NULL),(1100,'Medical - Extensive','Medical - Extensive','8090','Miscellaneous Income',90,0,NULL),(1101,'Medical - Extensive','Medical - Extensive','8110','Gain on Disposition of Fixed Assets',90,0,NULL),(1102,'Medical - Extensive','Medical - Extensive','8220','Interest income',90,0,'arcompany.interest'),(1103,'Medical - Extensive','Medical - Extensive','9080','Charitable Contributions',90,0,NULL),(1104,'Medical - Extensive','Medical - Extensive','9180','Fines and Penalties',90,0,NULL),(1105,'Medical - Extensive','Medical - Extensive','9220','Interest Expense',90,0,'apcompany.interestexpense'),(1106,'Medical - Extensive','Medical - Extensive','9250','Life Insurance',90,0,NULL),(1107,'Medical - Extensive','Medical - Extensive','9290','Loss on Disposition of Fixed Assets',90,0,NULL),(1108,'Medical - Extensive','Medical - Extensive','9380','Political Contributions',90,0,NULL),(1109,'Medical - Extensive','Medical - Extensive','9999','Temporary Distribution',90,0,'arcompany.baddebt'),(1110,'Medical - Extensive','Medical - Extensive','5000','Cost of Goods Sold',70,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance;arcompany.cost;invcompany.cost;invcompany.costadjustglacctid'),(1111,'Medical - Extensive','Medical - Extensive','5700','Cost of Goods  - Salaries',70,0,'apcompany.glcommissionid'),(1112,'Medical - Extensive','Medical - Extensive','6000','Default Purchases',70,0,NULL),(1113,'Medical - Extensive','Medical - Extensive','6010','Advertising Expense',70,0,NULL),(1114,'Retail - Simple','Retail - Simple','1260','Inventory Loss',10,0,'invcompany.loss;invcompany.inventoryvariance'),(1115,'Retail - Simple','Retail - Simple','2001','Accrued Payroll',21,0,'prcompany.glpayroll_payableid'),(1116,'Retail - Simple','Retail - Simple','2331','FICA Tax Payable',21,0,'prcompany.glficapayableid'),(1117,'Retail - Simple','Retail - Simple','2332','Medicare Tax Payable',21,0,'prcompany.glmedicarepayableid'),(1118,'Retail - Simple','Retail - Simple','2333','Workers Comp Payable',21,0,'prcompany.glworkmanscomppayableid'),(1119,'Retail - Simple','Retail - Simple','2450','Shipping Liability',21,0,'arcompany.shipliability'),(1120,'Retail - Simple','Retail - Simple','4001','Sales - Service Labor',50,0,'arcompany.labor_sales_glacctid'),(1121,'Retail - Simple','Retail - Simple','4002','Sales Refunds',50,0,'arcompany.refund'),(1122,'Retail - Simple','Retail - Simple','6030','Misc Tax Exempt Pay Exp',80,0,'prcompany.gltaxexemptexpenseid'),(1123,'Retail - Simple','Retail - Simple','6110','FICA Tax Expense',80,0,'prcompany.glficaexpenseid'),(1124,'Retail - Simple','Retail - Simple','6120','Medicare Tax Expense',80,0,'prcompany.glmedicareexpenseid'),(1125,'Retail - Simple','Retail - Simple','6140','FUTA Tax Expense',80,0,'prcompany.glfuiexpenseid'),(1126,'Retail - Simple','Retail - Simple','6160','SUTA Tax Expense',80,0,'prcompany.glsuiexpenseid'),(1127,'Retail - Simple','Retail - Simple','6170','Workers Comp Tax Expense',80,0,'prcompany.glworkmanscompexpenseid'),(1128,'Retail - Simple','Retail - Simple','6410','Interest Expense',80,0,'apcompany.interestexpense'),(1129,'Retail - Simple','Retail - Simple','4010','Restock Fees',50,0,'arcompany.restockglid'),(1726,'Medical - Complete','Medical - Complete','1000','ASSETS',10,0,NULL),(1727,'Medical - Complete','Medical - Complete','1100','Cash ',10,0,NULL),(1728,'Medical - Complete','Medical - Complete','1110','Cash - Banks',10,0,NULL),(1729,'Medical - Complete','Medical - Complete','1111','General Checking Accounts',10,0,'apcompany.glccid; arcompany.checking'),(1730,'Medical - Complete','Medical - Complete','1112','Payroll Checking Accounts',10,0,'prcompany.glcheckaccountid'),(1731,'Medical - Complete','Medical - Complete','1113','Other Checking Accounts',10,0,NULL),(1732,'Medical - Complete','Medical - Complete','1120','Cash - On hand',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(1733,'Medical - Complete','Medical - Complete','1121','Change Fund',10,0,NULL),(1734,'Medical - Complete','Medical - Complete','1122','Petty Cash',10,0,NULL),(1735,'Medical - Complete','Medical - Complete','1130','Cash - Restricted',10,0,NULL),(1736,'Medical - Complete','Medical - Complete','1200','Marketable Securities & Short-Term Investments',10,0,NULL),(1737,'Medical - Complete','Medical - Complete','1210','Valuation Allowance - Short-Term Investments',10,0,NULL),(1738,'Medical - Complete','Medical - Complete','1300','Accounts Receivable ',10,0,'arcompany.receivables'),(1739,'Medical - Complete','Medical - Complete','1301','Accounts Receivable - Self Pay',10,0,NULL),(1740,'Medical - Complete','Medical - Complete','1302','Accounts Receivable - Private Insurance',10,0,NULL),(1741,'Medical - Complete','Medical - Complete','1303','Accounts Receivable - Commercial Managed Care',10,0,NULL),(1742,'Medical - Complete','Medical - Complete','1304','Accounts Receivable - Medicare (MCR)',10,0,NULL),(1743,'Medical - Complete','Medical - Complete','1305','Accounts Receivable - Medicaid (MCD)',10,0,NULL),(1744,'Medical - Complete','Medical - Complete','1306','Accounts Receivable - Medicaid Managed Care',10,0,NULL),(1745,'Medical - Complete','Medical - Complete','1307','Accounts Receivable - Other (Patients)',10,0,NULL),(1746,'Medical - Complete','Medical - Complete','1320','Allowance for Estimated Uncollectible Receivables',10,0,NULL),(1747,'Medical - Complete','Medical - Complete','1321','Allowance for Estimated Uncollectible Receivables - Self Pay ',10,0,NULL),(1748,'Medical - Complete','Medical - Complete','1322','Allowance for Estimated Uncollectible Receivables - Private Insurance ',10,0,NULL),(1749,'Medical - Complete','Medical - Complete','1323','Allowance for Estimated Uncollectible Receivables - Commercial Managed Care ',10,0,NULL),(1750,'Medical - Complete','Medical - Complete','1324','Allowance for Estimated Uncollectible Receivables - Medicare',10,0,NULL),(1751,'Medical - Complete','Medical - Complete','1325','Allowance for Estimated Uncollectible Receivables - Medicaid ',10,0,NULL),(1752,'Medical - Complete','Medical - Complete','1326','Allowance for Estimated Uncollectible Receivables - Medicaid Managed Care ',10,0,NULL),(1753,'Medical - Complete','Medical - Complete','1327','Allowance for Estimated Uncollectible Receivables - Other (Patients)',10,0,NULL),(1754,'Medical - Complete','Medical - Complete','1380','Grant and Contract Receivables',10,0,NULL),(1756,'Medical - Complete','Medical - Complete','1400','Supply Inventories',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(1757,'Medical - Complete','Medical - Complete','1401','Drugs and Medications',10,0,NULL),(1758,'Medical - Complete','Medical - Complete','1402','Medical Supplies',10,0,NULL),(1759,'Medical - Complete','Medical - Complete','1403','Administrative Supplies',10,0,NULL),(1760,'Medical - Complete','Medical - Complete','1404','Forms',10,0,NULL),(1761,'Medical - Complete','Medical - Complete','1405','Housekeeping and Maintenance Supplies',10,0,NULL),(1762,'Medical - Complete','Medical - Complete','1406','Linen Supplies',10,0,NULL),(1763,'Medical - Complete','Medical - Complete','1407','Other Supplies',10,0,NULL),(1764,'Medical - Complete','Medical - Complete','1420','Ancillary Department Supplies',10,0,NULL),(1765,'Medical - Complete','Medical - Complete','1500','Prepaid Expenses',10,0,NULL),(1766,'Medical - Complete','Medical - Complete','1501','Prepaid Interest',10,0,NULL),(1767,'Medical - Complete','Medical - Complete','1502','Prepaid Insurance',10,0,NULL),(1768,'Medical - Complete','Medical - Complete','1503','Prepaid Rent',10,0,NULL),(1769,'Medical - Complete','Medical - Complete','1504','Prepaid Taxes',10,0,NULL),(1770,'Medical - Complete','Medical - Complete','1505','Prepaid Dues',10,0,NULL),(1771,'Medical - Complete','Medical - Complete','1506','Other Prepaid Expenses',10,0,NULL),(1772,'Medical - Complete','Medical - Complete','1550','Other Current Assets',10,0,NULL),(1773,'Medical - Complete','Medical - Complete','1600','INVESTMENTS - LONG-TERM RECEIVABLES',13,0,NULL),(1774,'Medical - Complete','Medical - Complete','1610','Long-Term Receivables',13,0,NULL),(1775,'Medical - Complete','Medical - Complete','1630','Long-Term Investments',13,0,NULL),(1776,'Medical - Complete','Medical - Complete','1635','Valuation Allowance - Long-Term Investments',13,0,NULL),(1777,'Medical - Complete','Medical - Complete','1640','Investments in Affiliates',13,0,NULL),(1778,'Medical - Complete','Medical - Complete','1650','Property Held for Future Use',13,0,NULL),(1779,'Medical - Complete','Medical - Complete','1700','PROPERTY, FURNITURE, FIXTURES & EQUIPMENT',11,0,NULL),(1780,'Medical - Complete','Medical - Complete','1710','REAL PROPERTY',11,0,NULL),(1781,'Medical - Complete','Medical - Complete','1711','Land',11,0,NULL),(1782,'Medical - Complete','Medical - Complete','1712','Land Improvements',11,0,NULL),(1783,'Medical - Complete','Medical - Complete','1713','Buildings',11,0,NULL),(1784,'Medical - Complete','Medical - Complete','1714','Capital Leases - Buildings',11,0,NULL),(1785,'Medical - Complete','Medical - Complete','1715','Leasehold Improvements',11,0,NULL),(1786,'Medical - Complete','Medical - Complete','1716','Construction in Progress',11,0,NULL),(1787,'Medical - Complete','Medical - Complete','1717','Other Real Property',11,0,NULL),(1788,'Medical - Complete','Medical - Complete','1750','FURNITURE, FIXTURES & EQUIPMENT',11,0,NULL),(1789,'Medical - Complete','Medical - Complete','1751','Furniture and Fixtures',11,0,NULL),(1790,'Medical - Complete','Medical - Complete','1752','Capital Leases - Furniture and Fixtures',11,0,NULL),(1791,'Medical - Complete','Medical - Complete','1753','Equipment',11,0,NULL),(1792,'Medical - Complete','Medical - Complete','1754','Capital Leases - Equipment',11,0,NULL),(1793,'Medical - Complete','Medical - Complete','1755','Medical Equipment',11,0,NULL),(1794,'Medical - Complete','Medical - Complete','1756','Capital Leases - Medical Equipment',11,0,NULL),(1795,'Medical - Complete','Medical - Complete','1760','Computer',11,0,NULL),(1796,'Medical - Complete','Medical - Complete','1761','Computer - Hardware',11,0,NULL),(1797,'Medical - Complete','Medical - Complete','1762','Computer - Software',11,0,NULL),(1798,'Medical - Complete','Medical - Complete','1763','Computer - Other',11,0,NULL),(1799,'Medical - Complete','Medical - Complete','1770','Capital Leases - Computer',11,0,NULL),(1800,'Medical - Complete','Medical - Complete','1771','Capital Leases - Computer - Hardware',11,0,NULL),(1801,'Medical - Complete','Medical - Complete','1772','Capital Leases - Computer - Software',11,0,NULL),(1802,'Medical - Complete','Medical - Complete','1773','Capital Leases - Computer - Other',11,0,NULL),(1803,'Medical - Complete','Medical - Complete','1780','Vehicles',11,0,NULL),(1804,'Medical - Complete','Medical - Complete','1781','Vehicles',11,0,NULL),(1805,'Medical - Complete','Medical - Complete','1782','Capital Leases - Vehicles',11,0,NULL),(1806,'Medical - Complete','Medical - Complete','1790','Ancillary Service Equipment',11,0,NULL),(1807,'Medical - Complete','Medical - Complete','1791','Laboratory Equipment',11,0,NULL),(1808,'Medical - Complete','Medical - Complete','1792','Radiology Equipment',11,0,NULL),(1809,'Medical - Complete','Medical - Complete','1793','Physical Therapy Equipment',11,0,NULL),(1810,'Medical - Complete','Medical - Complete','1794','Diagnostic Equipment',11,0,NULL),(1811,'Medical - Complete','Medical - Complete','1795','Capital Leases - Ancillary Service Equipment',11,0,NULL),(1812,'Medical - Complete','Medical - Complete','1796','Capital Leases - Laboratory Equipment',11,0,NULL),(1813,'Medical - Complete','Medical - Complete','1797','Capital Leases - Radiology Equipment',11,0,NULL),(1814,'Medical - Complete','Medical - Complete','1798','Capital Leases - Physical Therapy Equipment',11,0,NULL),(1815,'Medical - Complete','Medical - Complete','1799','Capital Leases - Diagnostic Equipment',11,0,NULL),(1816,'Medical - Complete','Medical - Complete','1800','ACCUMULATED DEPRECIATION - PROPERTY, FURNITURE, ETC.',11,0,NULL),(1817,'Medical - Complete','Medical - Complete','1810','ACCUMULATED DEPRECIATION - REAL PROPERTY',11,0,NULL),(1818,'Medical - Complete','Medical - Complete','1812','Accum Depreciation - Land Improvements',11,0,NULL),(1819,'Medical - Complete','Medical - Complete','1813','Accum Depreciation - Buildings',11,0,NULL),(1820,'Medical - Complete','Medical - Complete','1814','Accum Depreciation - Capital Leases - Buildings',11,0,NULL),(1821,'Medical - Complete','Medical - Complete','1815','Accum Depreciation - Leasehold Improvements',11,0,NULL),(1822,'Medical - Complete','Medical - Complete','1817','Accum Depreciation - Other Real Property',11,0,NULL),(1823,'Medical - Complete','Medical - Complete','1850','ACCUM DEPRECIATION - FURNITURE, FIXTURES & EQUIPMENT',11,0,NULL),(1824,'Medical - Complete','Medical - Complete','1851','Accum Depreciation- Furniture and Fixtures',11,0,NULL),(1825,'Medical - Complete','Medical - Complete','1852','Accum Depreciation- Capital Leases - Furniture and Fixtures',11,0,NULL),(1826,'Medical - Complete','Medical - Complete','1853','Accum Depreciation - Equipment',11,0,NULL),(1827,'Medical - Complete','Medical - Complete','1854','Accum Depreciation - Capital Leases - Equipment',11,0,NULL),(1828,'Medical - Complete','Medical - Complete','1855','Accum Depreciation - Medical Equipment',11,0,NULL),(1829,'Medical - Complete','Medical - Complete','1856','Accum Depreciation - Capital Leases - Medical Equipment',11,0,NULL),(1830,'Medical - Complete','Medical - Complete','1860','Accum Depreciation - Computer',11,0,NULL),(1831,'Medical - Complete','Medical - Complete','1861','Accum Depreciation - Computer - Hardware',11,0,NULL),(1832,'Medical - Complete','Medical - Complete','1862','Accum Depreciation - Computer - Software',11,0,NULL),(1833,'Medical - Complete','Medical - Complete','1863','Accum Depreciation - Computer - Other',11,0,NULL),(1834,'Medical - Complete','Medical - Complete','1870','Accum Depreciation - Capital Leases - Computer',11,0,NULL),(1835,'Medical - Complete','Medical - Complete','1871','Accum Depreciation - Capital Leases - Computer Hardware',11,0,NULL),(1836,'Medical - Complete','Medical - Complete','1872','Accum Depreciation - Capital Leases - Computer Software',11,0,NULL),(1837,'Medical - Complete','Medical - Complete','1873','Accum Depreciation - Capital Leases - Computer - Other',11,0,NULL),(1838,'Medical - Complete','Medical - Complete','1880','Accum Depreciation - Vehicles',11,0,NULL),(1839,'Medical - Complete','Medical - Complete','1881','Accum Depreciation - Vehicles',11,0,NULL),(1840,'Medical - Complete','Medical - Complete','1882','Accum Depreciation - Capital Leases - Vehicles',11,0,NULL),(1841,'Medical - Complete','Medical - Complete','1890','Other Accum Depreciation - Ancillary Service Equipment',11,0,NULL),(1842,'Medical - Complete','Medical - Complete','1891','Accum Depreciation - Laboratory Equipment',11,0,NULL),(1843,'Medical - Complete','Medical - Complete','1892','Accum Depreciation - Radiology Equipment',11,0,NULL),(1844,'Medical - Complete','Medical - Complete','1893','Accum Depreciation - Physical Therapy Equipment',11,0,NULL),(1845,'Medical - Complete','Medical - Complete','1894','Accum Depreciation - Diagnostic Equipment',11,0,NULL),(1846,'Medical - Complete','Medical - Complete','1895','Accum Depreciation - Capital Leases - Ancillary Service Equipment',11,0,NULL),(1847,'Medical - Complete','Medical - Complete','1896','Accum Depreciation - Capital Leases - Laboratory Equipment',11,0,NULL),(1848,'Medical - Complete','Medical - Complete','1897','Accum Depreciation - Capital Leases - Radiology Equipment',11,0,NULL),(1849,'Medical - Complete','Medical - Complete','1899','Accum Depreciation - Capital Leases - Physical Therapy Equipment',11,0,NULL),(1850,'Medical - Complete','Medical - Complete','1899','Accum Depreciation - Capital Leases - Diagnostic Equipment',11,0,NULL),(1851,'Medical - Complete','Medical - Complete','1900','INTANGIBLE AND OTHER ASSETS',13,0,NULL),(1852,'Medical - Complete','Medical - Complete','1910','Organization Costs',13,0,NULL),(1853,'Medical - Complete','Medical - Complete','1915','Accumulated Amortization - Organization Costs',13,0,NULL),(1854,'Medical - Complete','Medical - Complete','1920','Goodwill',13,0,NULL),(1855,'Medical - Complete','Medical - Complete','1925','Accumulated Amortization - Goodwill',13,0,NULL),(1856,'Medical - Complete','Medical - Complete','1930','Other Intangible Assets',13,0,NULL),(1857,'Medical - Complete','Medical - Complete','1940','Deposits',13,0,NULL),(1858,'Medical - Complete','Medical - Complete','1950','Noncurrent Expenses Paid in Advance',13,0,NULL),(1859,'Medical - Complete','Medical - Complete','1951','Noncurrent Interest Paid in Advance',13,0,NULL),(1860,'Medical - Complete','Medical - Complete','1952','Noncurrent Insurance Paid in Advance',13,0,NULL),(1861,'Medical - Complete','Medical - Complete','1953','Noncurrent Rent Paid in Advance',13,0,NULL),(1862,'Medical - Complete','Medical - Complete','1954','Noncurrent Taxes Paid in Advance',13,0,NULL),(1863,'Medical - Complete','Medical - Complete','1955','Noncurrent Dues Paid in Advance',13,0,NULL),(1864,'Medical - Complete','Medical - Complete','1956','Other Noncurrent Expenses Paid in Advance',13,0,NULL),(1865,'Medical - Complete','Medical - Complete','1960','Other Assets',13,0,NULL),(1866,'Medical - Complete','Medical - Complete','1961','Cash Surrender Value of Life Insurance Policies',13,0,NULL),(1867,'Medical - Complete','Medical - Complete','2000','LIABILITIES',21,0,NULL),(1868,'Medical - Complete','Medical - Complete','2100','CURRENT LIABILITIES - PAYABLES',21,0,NULL),(1869,'Medical - Complete','Medical - Complete','2110','Accounts Payable',21,0,'apcompany.payable;prcompany.glmiscdedpayableid'),(1870,'Medical - Complete','Medical - Complete','2120','Bank Overdrafts Payable',21,0,NULL),(1871,'Medical - Complete','Medical - Complete','2130','Other Current Liabilities Payable',21,0,NULL),(1872,'Medical - Complete','Medical - Complete','2131','Intercompany Accounts Payable',21,0,NULL),(1873,'Medical - Complete','Medical - Complete','2132','Accounts Payable - Employees',21,0,NULL),(1874,'Medical - Complete','Medical - Complete','2133','Accounts Payable - Related Parties',21,0,NULL),(1875,'Medical - Complete','Medical - Complete','2134','Accounts Payable - Other',21,0,NULL),(1876,'Medical - Complete','Medical - Complete','2160','Contract Claims Payable',21,0,NULL),(1877,'Medical - Complete','Medical - Complete','2200','CURRENT LIABILITIES - PAYROLL',21,0,NULL),(1878,'Medical - Complete','Medical - Complete','2210','Payroll Tax Withholdings Payable',21,0,NULL),(1879,'Medical - Complete','Medical - Complete','2211','Federal Income Tax Withholdings Payable',21,0,'prcompany.glfitpayableid'),(1880,'Medical - Complete','Medical - Complete','2212','State Income Tax Withholdings Payable',21,0,NULL),(1881,'Medical - Complete','Medical - Complete','2213','FICA/Medicare Tax Withholdings Payable',21,0,'prcompany.glficapayableid;prcompany.glmedicarepayableid'),(1882,'Medical - Complete','Medical - Complete','2214','Local Tax Withholdings Payable',21,0,NULL),(1883,'Medical - Complete','Medical - Complete','2215','Other Tax Withholdings Payable',21,0,NULL),(1884,'Medical - Complete','Medical - Complete','2220','Insurance Withholdings Payable',21,0,NULL),(1885,'Medical - Complete','Medical - Complete','2221','Health Insurance Withholdings Payable',21,0,NULL),(1886,'Medical - Complete','Medical - Complete','2222','Life Insurance Withholdings Payable',21,0,NULL),(1887,'Medical - Complete','Medical - Complete','2223','State Disability Insurance Withholdings Payable',21,0,NULL),(1888,'Medical - Complete','Medical - Complete','2224','Other Insurance Withholdings Payable',21,0,NULL),(1889,'Medical - Complete','Medical - Complete','2230','Other Payroll Withholdings Payable',21,0,'prcompany.glmiscdedpayableid'),(1890,'Medical - Complete','Medical - Complete','2231','401(k) Withholdings Payable',21,0,NULL),(1891,'Medical - Complete','Medical - Complete','2232','Cafeteria Plan Withholdings Payable',21,0,NULL),(1892,'Medical - Complete','Medical - Complete','2233','Court Mandated Child Support Withholdings Payable',21,0,NULL),(1893,'Medical - Complete','Medical - Complete','2234','Other Payroll Withholdings Payable',21,0,NULL),(1894,'Medical - Complete','Medical - Complete','2250','Accrued Payroll Liabilities',21,0,NULL),(1895,'Medical - Complete','Medical - Complete','2251','Accrued Payroll',21,0,'prcompany.glpayroll_payableid'),(1896,'Medical - Complete','Medical - Complete','2252','Accrued Vacation, Holiday, & Sick Pay (Compensated Absences)',21,0,NULL),(1897,'Medical - Complete','Medical - Complete','2253','Accrued FICA/Medicare Taxes Payable',21,0,NULL),(1898,'Medical - Complete','Medical - Complete','2254','Accrued State Unemployment Taxes Payable',21,0,'prcompany.glsuipayableid'),(1899,'Medical - Complete','Medical - Complete','2255','Accrued Federal Unemployment Taxes Payable',21,0,'prcompany.glfuipayableid'),(1900,'Medical - Complete','Medical - Complete','2256','Accrued Retirement Plan Contribution',21,0,NULL),(1901,'Medical - Complete','Medical - Complete','2257','Other Accrued Payroll Liabilities',21,0,NULL),(1902,'Medical - Complete','Medical - Complete','2260','Other Payroll Liabilities',21,0,'prcompany.glworkmanscomppayableid'),(1903,'Medical - Complete','Medical - Complete','2300','CURRENT LIABILITIES - OTHER',21,0,NULL),(1904,'Medical - Complete','Medical - Complete','2310','Accrued Liabilities - Nonpayroll',21,0,NULL),(1905,'Medical - Complete','Medical - Complete','2311','Accrued Rent',21,0,NULL),(1906,'Medical - Complete','Medical - Complete','2312','Accrued Interest',21,0,NULL),(1907,'Medical - Complete','Medical - Complete','2313','Accrued Insurance',21,0,NULL),(1908,'Medical - Complete','Medical - Complete','2314','Accrued Income Taxes (Federal/State)',21,0,NULL),(1909,'Medical - Complete','Medical - Complete','2315','Accrued Property Taxes',21,0,NULL),(1910,'Medical - Complete','Medical - Complete','2316','Accrued Franchise Taxes',21,0,NULL),(1911,'Medical - Complete','Medical - Complete','2317','Other Accrued Liabilities',21,0,NULL),(1912,'Medical - Complete','Medical - Complete','2320','Notes and Loans Payable',21,0,NULL),(1913,'Medical - Complete','Medical - Complete','2321','Current Notes and Loans Payable - Vendors',21,0,NULL),(1914,'Medical - Complete','Medical - Complete','2322','Current Notes and Loans Payable - Employees',21,0,NULL),(1915,'Medical - Complete','Medical - Complete','2323','Current Notes and Loans Payable - Stockholders/Partners',21,0,NULL),(1916,'Medical - Complete','Medical - Complete','2324','Current Other Notes and Loans Payable',21,0,NULL),(1917,'Medical - Complete','Medical - Complete','2325','Bank Working Capital Line Outstanding',21,0,NULL),(1918,'Medical - Complete','Medical - Complete','2330','Long-Term Debt - Current Portion',21,0,NULL),(1919,'Medical - Complete','Medical - Complete','2331','Capital Lease Obligation - Current Portion',21,0,NULL),(1920,'Medical - Complete','Medical - Complete','2332','Construction Contracts Payable',21,0,NULL),(1921,'Medical - Complete','Medical - Complete','2333','Other Loans Payable - Current Portion',21,0,NULL),(1922,'Medical - Complete','Medical - Complete','2340','Advances from Settlements Due to Third-Party Agencies',21,0,NULL),(1923,'Medical - Complete','Medical - Complete','2350','Patient Deposits',21,0,'arcompany.depositglacctid'),(1924,'Medical - Complete','Medical - Complete','2360','Claims Payable Incurred But Not Reported',21,0,NULL),(1925,'Medical - Complete','Medical - Complete','2361','Incurred But Not Reported Claims - Commercial',21,0,NULL),(1926,'Medical - Complete','Medical - Complete','2362','Incurred But Not Reported Claims - Medicare',21,0,NULL),(1927,'Medical - Complete','Medical - Complete','2363','Incurred But Not Reported Claims - Medicaid',21,0,NULL),(1928,'Medical - Complete','Medical - Complete','2365','Other Claims Incurred But Not Reported',21,0,NULL),(1929,'Medical - Complete','Medical - Complete','2370','Deferred Revenue',21,0,NULL),(1930,'Medical - Complete','Medical - Complete','2371','Deferred Revenue - Fee for Service',21,0,NULL),(1931,'Medical - Complete','Medical - Complete','2372','Deferred Revenue - Capitated or Prepaid Plan',21,0,NULL),(1932,'Medical - Complete','Medical - Complete','2375','Other Deferred Revenue',21,0,NULL),(1933,'Medical - Complete','Medical - Complete','2390','Other Current Liabilities',21,0,NULL),(1934,'Medical - Complete','Medical - Complete','2395','Refundable Advances - Grants and Contracts',21,0,NULL),(1935,'Medical - Complete','Medical - Complete','2400','LONG-TERM LIABILITIES',22,0,NULL),(1936,'Medical - Complete','Medical - Complete','2410','Long-Term Notes Payable',22,0,NULL),(1937,'Medical - Complete','Medical - Complete','2420','Construction Loans',22,0,NULL),(1938,'Medical - Complete','Medical - Complete','2430','Capital Lease Obligation - Long-Term Portion',22,0,NULL),(1939,'Medical - Complete','Medical - Complete','2440','Other Loans Payable - Long-Term Portion',22,0,NULL),(1940,'Medical - Complete','Medical - Complete','2450','Deferred Third-Party Revenue',22,0,NULL),(1941,'Medical - Complete','Medical - Complete','2451','Deferred Third-Party Revenue - Medicare',22,0,NULL),(1942,'Medical - Complete','Medical - Complete','2452','Deferred Third-Party Revenue - Medicaid',22,0,NULL),(1943,'Medical - Complete','Medical - Complete','2453','Deferred Third-Party Revenue - Other',22,0,NULL),(1944,'Medical - Complete','Medical - Complete','2460','Deferred Compensation',22,0,NULL),(1945,'Medical - Complete','Medical - Complete','2465','Severance Plan',22,0,NULL),(1946,'Medical - Complete','Medical - Complete','2470','Deferred Income Taxes - Long-Term Portion',22,0,NULL),(1947,'Medical - Complete','Medical - Complete','2480','Other Long-Term Liabilities',22,0,NULL),(1948,'Medical - Complete','Medical - Complete','3000','NET ASSETS (NOT-FOR-PROFIT EQUITY)',30,0,NULL),(1949,'Medical - Complete','Medical - Complete','3010','Unrestricted Net Assets',30,0,NULL),(1950,'Medical - Complete','Medical - Complete','3030','Temporarily Restricted Net Assets',30,0,NULL),(1951,'Medical - Complete','Medical - Complete','3040','Permanently Restricted Net Assets',30,0,NULL),(1952,'Medical - Complete','Medical - Complete','3050','Current Surplus/Deficit',30,0,NULL),(1953,'Medical - Complete','Medical - Complete','4000','REVENUES',50,0,'invcompany.sales;arcompany.discount'),(1954,'Medical - Complete','Medical - Complete','4100','GROSS CHARGES',50,0,'arcompany.labor_sales_glacctid'),(1955,'Medical - Complete','Medical - Complete','4110','Gross Charges - FFS - Self Pay',50,0,NULL),(1956,'Medical - Complete','Medical - Complete','4120','Gross Charges - FFS - Private Insurance',50,0,NULL),(1957,'Medical - Complete','Medical - Complete','4130','Gross Charges - Discounted FFS Contracts - Commercial Managed Care',50,0,NULL),(1958,'Medical - Complete','Medical - Complete','4140','Medicare',50,0,NULL),(1959,'Medical - Complete','Medical - Complete','4145','Medicare Retroactive Settlement',50,0,NULL),(1960,'Medical - Complete','Medical - Complete','4150','Medicaid',50,0,NULL),(1961,'Medical - Complete','Medical - Complete','4155','Medicaid Retroactive Settlement',50,0,NULL),(1962,'Medical - Complete','Medical - Complete','4160','Medicaid Managed Care',50,0,NULL),(1963,'Medical - Complete','Medical - Complete','4170','Other Gross Charges- Patient',50,0,NULL),(1964,'Medical - Complete','Medical - Complete','4190','Other Revenue - Patient',50,0,NULL),(1965,'Medical - Complete','Medical - Complete','4200','Fees Collected',50,0,NULL),(1966,'Medical - Complete','Medical - Complete','4210','Fees Collected - FFS',50,0,NULL),(1967,'Medical - Complete','Medical - Complete','4220','Fees Collected - FFS for Managed Care',50,0,NULL),(1968,'Medical - Complete','Medical - Complete','4230','Capitated Premium Revenues - Commercial',50,0,NULL),(1969,'Medical - Complete','Medical - Complete','4240','Capitated Premium Revenues - Medicare',50,0,NULL),(1970,'Medical - Complete','Medical - Complete','4250','Capitated Premium Revenues - Medicaid',50,0,NULL),(1971,'Medical - Complete','Medical - Complete','4260','Capitated Premium Revenues - Other',50,0,NULL),(1972,'Medical - Complete','Medical - Complete','4270','Risk Sharing Revenue',50,0,NULL),(1973,'Medical - Complete','Medical - Complete','4271','Hospital Risk Sharing - Commercial',50,0,NULL),(1974,'Medical - Complete','Medical - Complete','4272','Hospital Risk Sharing - Medicare',50,0,NULL),(1975,'Medical - Complete','Medical - Complete','4273','Hospital Risk Sharing - Medicaid',50,0,NULL),(1976,'Medical - Complete','Medical - Complete','4274','Hospital Risk Sharing - Pharmacy',50,0,NULL),(1977,'Medical - Complete','Medical - Complete','4275','Hospital Risk Sharing - Other',50,0,NULL),(1978,'Medical - Complete','Medical - Complete','4280','Other Managed Care Collected Revenues',50,0,NULL),(1979,'Medical - Complete','Medical - Complete','4281','Copayments',50,0,NULL),(1980,'Medical - Complete','Medical - Complete','4282','Coordination of Benefits',50,0,NULL),(1981,'Medical - Complete','Medical - Complete','4283','Other Prepaid Professional Fees Collected',50,0,NULL),(1982,'Medical - Complete','Medical - Complete','4290','Recoveries',50,0,NULL),(1983,'Medical - Complete','Medical - Complete','4291','Reinsurance Recoveries',50,0,NULL),(1984,'Medical - Complete','Medical - Complete','4292','Bad Debt Recovery',50,0,NULL),(1985,'Medical - Complete','Medical - Complete','4300','Patient Refunds',50,0,'arcompany.refund'),(1986,'Medical - Complete','Medical - Complete','4400','Fees Collected - Other Revenue',50,0,NULL),(1987,'Medical - Complete','Medical - Complete','4410','Sales - Medical Related',50,0,NULL),(1988,'Medical - Complete','Medical - Complete','4420','Patient Records Copying Reimbursement',50,0,NULL),(1989,'Medical - Complete','Medical - Complete','4430','Fees Collected - Other',50,0,'arcompany.restockglid'),(1990,'Medical - Complete','Medical - Complete','4450','Donations Received (Operating Revenue)',50,0,NULL),(1991,'Medical - Complete','Medical - Complete','4455','Donated (In-Kind) Goods and Services ',50,0,NULL),(1992,'Medical - Complete','Medical - Complete','4460','Research/Clinical Studies Income',50,0,NULL),(1993,'Medical - Complete','Medical - Complete','4470','Grant and Contract Revenue',50,0,NULL),(1994,'Medical - Complete','Medical - Complete','4480','Miscellaneous Income',50,0,NULL),(1995,'Medical - Complete','Medical - Complete','4490','Operating Subsidy Income',50,0,NULL),(1996,'Medical - Complete','Medical - Complete','4500','ADJUSTMENTS',60,0,NULL),(1997,'Medical - Complete','Medical - Complete','4510','Self Pay Sliding Fee Adjustment',60,0,NULL),(1998,'Medical - Complete','Medical - Complete','4520','Private Insurance Contractual Allowance',60,0,NULL),(1999,'Medical - Complete','Medical - Complete','4530','Commercial Managed Care Contractual Allowance',60,0,NULL),(2000,'Medical - Complete','Medical - Complete','4540','Medicare Contractual Allowance',60,0,NULL),(2001,'Medical - Complete','Medical - Complete','4541','Medicare- Coinsurance',60,0,NULL),(2002,'Medical - Complete','Medical - Complete','4542','Medicare - Patient Deductibles ',60,0,NULL),(2003,'Medical - Complete','Medical - Complete','4550','Medicaid Contractual Allowance',60,0,NULL),(2004,'Medical - Complete','Medical - Complete','4560','Medicaid Managed Care Contract Allowance',60,0,NULL),(2005,'Medical - Complete','Medical - Complete','4590','Other - Patients\' Contractual Allowance',60,0,NULL),(2006,'Medical - Complete','Medical - Complete','4600','Financial Hardship Care Discount/Adjustment',60,0,'arcompany.discount'),(2007,'Medical - Complete','Medical - Complete','4610','Courtesy Discount/Adjustment',60,0,NULL),(2008,'Medical - Complete','Medical - Complete','4620','Employee Discount/Adjustment',60,0,NULL),(2009,'Medical - Complete','Medical - Complete','4630','Charity Care Discount/Adjustment',60,0,NULL),(2010,'Medical - Complete','Medical - Complete','4700','Third-Party Settlements',60,0,NULL),(2011,'Medical - Complete','Medical - Complete','4720','Private Insurance Settlements',60,0,NULL),(2012,'Medical - Complete','Medical - Complete','4730','Commercial Managed Care Settlements',60,0,NULL),(2013,'Medical - Complete','Medical - Complete','4740','Medicare Settlements',60,0,NULL),(2014,'Medical - Complete','Medical - Complete','4750','Medicaid Settlements',60,0,NULL),(2015,'Medical - Complete','Medical - Complete','4760','Medicaid Managed Care Settlements',60,0,NULL),(2016,'Medical - Complete','Medical - Complete','4800','Provision for Cash Basis Conversion',60,0,NULL),(2017,'Medical - Complete','Medical - Complete','5000','OPERATING EXPENSES - Salary and Fringe Benefits',80,0,NULL),(2018,'Medical - Complete','Medical - Complete','5100','PHYSICIANS - SALARIES',80,0,NULL),(2019,'Medical - Complete','Medical - Complete','5110','Salaries, Distributions and Incentives (Physician)',80,0,NULL),(2020,'Medical - Complete','Medical - Complete','5120','Salaries - Owner/Stockholder (Physician)',80,0,NULL),(2021,'Medical - Complete','Medical - Complete','5130','Distributions and Incentives (Physician)',80,0,NULL),(2022,'Medical - Complete','Medical - Complete','5140','Global/Capitation Distributions (Physician)',80,0,NULL),(2023,'Medical - Complete','Medical - Complete','5150','Employee Salaries (Physician)',80,0,NULL),(2024,'Medical - Complete','Medical - Complete','5160','Employee Incentives (Physician)',80,0,NULL),(2025,'Medical - Complete','Medical - Complete','5170','Administrative Salaries (Physician)',80,0,NULL),(2026,'Medical - Complete','Medical - Complete','5180','Dentists',80,0,NULL),(2027,'Medical - Complete','Medical - Complete','5190','Psychiatrists',80,0,NULL),(2028,'Medical - Complete','Medical - Complete','5195','Salaries - Other Specialists',80,0,NULL),(2029,'Medical - Complete','Medical - Complete','5200','PHYSICIAN - EMPLOYEE-RELATED EXPENSES',80,0,NULL),(2030,'Medical - Complete','Medical - Complete','5210','Payroll Taxes (Physician)',80,0,NULL),(2031,'Medical - Complete','Medical - Complete','5211','Payroll Taxes - FICA/Medicare (Physician)',80,0,NULL),(2032,'Medical - Complete','Medical - Complete','5212','Payroll Taxes - Federal Unemployment Insurance (Physician)',80,0,NULL),(2033,'Medical - Complete','Medical - Complete','5213','Payroll Taxes - State Unemployment Insurance (Physician)',80,0,NULL),(2034,'Medical - Complete','Medical - Complete','5214','Payroll Taxes - Other (Physician)',80,0,NULL),(2035,'Medical - Complete','Medical - Complete','5220','Insurance (Physician)',80,0,NULL),(2036,'Medical - Complete','Medical - Complete','5221','Insurance - Health (Physician)',80,0,NULL),(2037,'Medical - Complete','Medical - Complete','5222','Insurance - Dental (Physician)',80,0,NULL),(2038,'Medical - Complete','Medical - Complete','5223','Insurance - Life (Physician)',80,0,NULL),(2039,'Medical - Complete','Medical - Complete','5224','Insurance - Disability (Physician)',80,0,NULL),(2040,'Medical - Complete','Medical - Complete','5225','Insurance - Workers\' Compensation (Physician)',80,0,NULL),(2041,'Medical - Complete','Medical - Complete','5226','Insurance - Other (Physician)',80,0,NULL),(2042,'Medical - Complete','Medical - Complete','5227','Insurance - Officers\' Life (Physician)',80,0,NULL),(2043,'Medical - Complete','Medical - Complete','5230','Pension and Retirement Benefits (Physician)',80,0,NULL),(2044,'Medical - Complete','Medical - Complete','5231','Pension (Physician)',80,0,NULL),(2045,'Medical - Complete','Medical - Complete','5232','Deferred Compensation (Physician)',80,0,NULL),(2046,'Medical - Complete','Medical - Complete','5233','Severance Plan (Physician)',80,0,NULL),(2047,'Medical - Complete','Medical - Complete','5235','Professional Development (Physician)',80,0,NULL),(2048,'Medical - Complete','Medical - Complete','5240','Books and Subscriptions (Physician)',80,0,NULL),(2049,'Medical - Complete','Medical - Complete','5245','Dues and Memberships (Physician)',80,0,NULL),(2050,'Medical - Complete','Medical - Complete','5250','Licenses (Physician)',80,0,NULL),(2051,'Medical - Complete','Medical - Complete','5255','Meetings (Physician)',80,0,NULL),(2052,'Medical - Complete','Medical - Complete','5260','Travel (Physician)',80,0,NULL),(2053,'Medical - Complete','Medical - Complete','5265','Medical Reimbursement Plan (Physician)',80,0,NULL),(2054,'Medical - Complete','Medical - Complete','5270','Vehicles (Physician)',80,0,NULL),(2055,'Medical - Complete','Medical - Complete','5271','Leased Motor Vehicles (Physician)',80,0,NULL),(2056,'Medical - Complete','Medical - Complete','5275','Parking (Physician)',80,0,NULL),(2057,'Medical - Complete','Medical - Complete','5280','Telephone (Physician)',80,0,NULL),(2058,'Medical - Complete','Medical - Complete','5285','Beepers (Physician)',80,0,NULL),(2059,'Medical - Complete','Medical - Complete','5290','Meals and Entertainment (Physician)',80,0,NULL),(2060,'Medical - Complete','Medical - Complete','5295','Other Benefits (Physician)',80,0,NULL),(2061,'Medical - Complete','Medical - Complete','5300','MIDLEVEL PROVIDERS - SALARIES ',80,0,NULL),(2062,'Medical - Complete','Medical - Complete','5310','Salaries, Distributions and Incentives (Midlevel)',80,0,NULL),(2063,'Medical - Complete','Medical - Complete','5320','Salaries - Owner/Stockholder (Midlevel)',80,0,NULL),(2064,'Medical - Complete','Medical - Complete','5330','Distributions and Incentives (Midlevel)',80,0,NULL),(2065,'Medical - Complete','Medical - Complete','5340','Global/Capitation Distributions (Midlevel)',80,0,NULL),(2066,'Medical - Complete','Medical - Complete','5350','Employee Salaries (Midlevel)',80,0,NULL),(2067,'Medical - Complete','Medical - Complete','5360','Employee Incentives (Midlevel)',80,0,NULL),(2068,'Medical - Complete','Medical - Complete','5370','Administrative Salaries (Midlevel)',80,0,NULL),(2069,'Medical - Complete','Medical - Complete','5380','Other Compensation (Midlevel)',80,0,NULL),(2070,'Medical - Complete','Medical - Complete','5400','MIDLEVEL PROVIDERS - EMPLOYEE-RELATED EXPENSES',80,0,NULL),(2071,'Medical - Complete','Medical - Complete','5410','Payroll Taxes (Midlevel)',80,0,NULL),(2072,'Medical - Complete','Medical - Complete','5411','Payroll Taxes - FICA/Medicare(Midlevel)',80,0,NULL),(2073,'Medical - Complete','Medical - Complete','5412','Payroll Taxes - Federal Unemployment Insurance (Midlevel)',80,0,NULL),(2074,'Medical - Complete','Medical - Complete','5413','Payroll Taxes - State Unemployment Insurance(Midlevel)',80,0,NULL),(2075,'Medical - Complete','Medical - Complete','5414','Payroll Taxes - Other(Midlevel)',80,0,NULL),(2076,'Medical - Complete','Medical - Complete','5420','Insurance(Midlevel)',80,0,NULL),(2077,'Medical - Complete','Medical - Complete','5421','Insurance - Health (Midlevel)',80,0,NULL),(2078,'Medical - Complete','Medical - Complete','5422','Insurance - Dental (Midlevel)',80,0,NULL),(2079,'Medical - Complete','Medical - Complete','5423','Insurance - Life (Midlevel)',80,0,NULL),(2080,'Medical - Complete','Medical - Complete','5424','Insurance - Disability (Midlevel)',80,0,NULL),(2081,'Medical - Complete','Medical - Complete','5425','Insurance - Workers\' Compensation(Midlevel)',80,0,NULL),(2082,'Medical - Complete','Medical - Complete','5426','Insurance - Other(Midlevel)',80,0,NULL),(2083,'Medical - Complete','Medical - Complete','5430','Pension and Retirement Benefits(Midlevel)',80,0,NULL),(2084,'Medical - Complete','Medical - Complete','5431','Pension (Midlevel)',80,0,NULL),(2085,'Medical - Complete','Medical - Complete','5432','Deferred Compensation(Midlevel)',80,0,NULL),(2086,'Medical - Complete','Medical - Complete','5433','Severance Plan(Midlevel)',80,0,NULL),(2087,'Medical - Complete','Medical - Complete','5435','Professional Development (Midlevel)',80,0,NULL),(2088,'Medical - Complete','Medical - Complete','5440','Books and Subscriptions(Midlevel)',80,0,NULL),(2089,'Medical - Complete','Medical - Complete','5445','Dues and Memberships(Midlevel)',80,0,NULL),(2090,'Medical - Complete','Medical - Complete','5450','Licenses (Midlevel)',80,0,NULL),(2091,'Medical - Complete','Medical - Complete','5455','Meetings (Midlevel)',80,0,NULL),(2092,'Medical - Complete','Medical - Complete','5460','Travel(Midlevel)',80,0,NULL),(2093,'Medical - Complete','Medical - Complete','5465','Medical Reimbursement Plan(Midlevel)',80,0,NULL),(2094,'Medical - Complete','Medical - Complete','5470','Vehicles(Midlevel)',80,0,NULL),(2095,'Medical - Complete','Medical - Complete','5475','Parking(Midlevel)',80,0,NULL),(2096,'Medical - Complete','Medical - Complete','5480','Telephones (Midlevel)',80,0,NULL),(2097,'Medical - Complete','Medical - Complete','5485','Beepers(Midlevel)',80,0,NULL),(2098,'Medical - Complete','Medical - Complete','5490','Meals and Entertainment(Midlevel)',80,0,NULL),(2099,'Medical - Complete','Medical - Complete','5495','Other Benefits(Midlevel)',80,0,NULL),(2100,'Medical - Complete','Medical - Complete','5500','ANCILLARY STAFF - SALARIES',80,0,NULL),(2101,'Medical - Complete','Medical - Complete','5510','Salaries - Radiology',80,0,NULL),(2102,'Medical - Complete','Medical - Complete','5520','Salaries - Laboratory',80,0,NULL),(2103,'Medical - Complete','Medical - Complete','5530','Salaries - Optical',80,0,NULL),(2104,'Medical - Complete','Medical - Complete','5540','Salaries - Physical Therapy',80,0,NULL),(2105,'Medical - Complete','Medical - Complete','5545','Salaries - Pharmacists and Assistants',80,0,NULL),(2106,'Medical - Complete','Medical - Complete','5550','Salaries - Other Ancillary Services',80,0,NULL),(2107,'Medical - Complete','Medical - Complete','5600','ANCILLARY STAFF - EMPLOYEE-RELATED EXPENSES ',80,0,NULL),(2108,'Medical - Complete','Medical - Complete','5610','Payroll Taxes (Ancillary)',80,0,NULL),(2109,'Medical - Complete','Medical - Complete','5611','Payroll Taxes - FICA/Medicare(Ancillary)',80,0,NULL),(2110,'Medical - Complete','Medical - Complete','5612','Payroll Taxes - Federal Unemployment Insurance (Ancillary)',80,0,NULL),(2111,'Medical - Complete','Medical - Complete','5613','Payroll Taxes - State Unemployment Insurance (Ancillary)',80,0,NULL),(2112,'Medical - Complete','Medical - Complete','5614','Payroll Taxes - Other (Ancillary)',80,0,NULL),(2113,'Medical - Complete','Medical - Complete','5620','Insurance (Ancillary)',80,0,NULL),(2114,'Medical - Complete','Medical - Complete','5621','Insurance - Health(Ancillary)',80,0,NULL),(2115,'Medical - Complete','Medical - Complete','5622','Insurance - Dental (Ancillary)',80,0,NULL),(2116,'Medical - Complete','Medical - Complete','5623','Insurance - Life (Ancillary)',80,0,NULL),(2117,'Medical - Complete','Medical - Complete','5624','Insurance - Disability (Ancillary)',80,0,NULL),(2118,'Medical - Complete','Medical - Complete','5625','Insurance - Workers\' Compensation (Ancillary)',80,0,NULL),(2119,'Medical - Complete','Medical - Complete','5626','Insurance - Other(Ancillary)',80,0,NULL),(2120,'Medical - Complete','Medical - Complete','5630','Pension and Retirement Benefits(Ancillary)',80,0,NULL),(2121,'Medical - Complete','Medical - Complete','5631','Pension (Ancillary)',80,0,NULL),(2122,'Medical - Complete','Medical - Complete','5632','Deferred Compensation (Ancillary)',80,0,NULL),(2123,'Medical - Complete','Medical - Complete','5633','Severance Plan(Ancillary)',80,0,NULL),(2124,'Medical - Complete','Medical - Complete','5635','Professional Development (Ancillary)',80,0,NULL),(2125,'Medical - Complete','Medical - Complete','5640','Books and Subscriptions (Ancillary)',80,0,NULL),(2126,'Medical - Complete','Medical - Complete','5645','Dues and Memberships (Ancillary)',80,0,NULL),(2127,'Medical - Complete','Medical - Complete','5650','Licenses (Ancillary)',80,0,NULL),(2128,'Medical - Complete','Medical - Complete','5655','Meetings (Ancillary)',80,0,NULL),(2129,'Medical - Complete','Medical - Complete','5660','Travel (Ancillary)',80,0,NULL),(2130,'Medical - Complete','Medical - Complete','5665','Medical Reimbursement Plan (Ancillary)',80,0,NULL),(2131,'Medical - Complete','Medical - Complete','5670','Vehicles (Ancillary)',80,0,NULL),(2132,'Medical - Complete','Medical - Complete','5675','Parking(Ancillary)',80,0,NULL),(2133,'Medical - Complete','Medical - Complete','5680','Telephones (Ancillary)',80,0,NULL),(2134,'Medical - Complete','Medical - Complete','5685','Beepers (Ancillary)',80,0,NULL),(2135,'Medical - Complete','Medical - Complete','5690','Meals and Entertainment(Ancillary)',80,0,NULL),(2136,'Medical - Complete','Medical - Complete','5695','Other Benefits (Ancillary)',80,0,NULL),(2137,'Medical - Complete','Medical - Complete','5700','EMPLOYEES - SALARIES',80,0,NULL),(2138,'Medical - Complete','Medical - Complete','5710','Salaries - General Administrative',80,0,NULL),(2139,'Medical - Complete','Medical - Complete','5715','Salaries - Business Office',80,0,NULL),(2140,'Medical - Complete','Medical - Complete','5720','Salaries - Managed Care Administrative',80,0,NULL),(2141,'Medical - Complete','Medical - Complete','5725','Salaries - Information Services',80,0,NULL),(2142,'Medical - Complete','Medical - Complete','5730','Salaries - Housekeeping/ Maintenance / Security',80,0,NULL),(2143,'Medical - Complete','Medical - Complete','5735','Salaries - Medical Receptionist',80,0,NULL),(2144,'Medical - Complete','Medical - Complete','5740','Salaries - Medical Secretaries / Transcribers',80,0,NULL),(2145,'Medical - Complete','Medical - Complete','5745','Salaries - Medical Records',80,0,NULL),(2146,'Medical - Complete','Medical - Complete','5750','Salaries - Other Administrative Support',80,0,NULL),(2147,'Medical - Complete','Medical - Complete','5755','Salaries - Registered Nurses',80,0,NULL),(2148,'Medical - Complete','Medical - Complete','5760','Salaries - Licensed Practical Nurses',80,0,NULL),(2149,'Medical - Complete','Medical - Complete','5765','Salaries - Medical Assistants / Nurses\' Aids',80,0,NULL),(2150,'Medical - Complete','Medical - Complete','5770','Salaries - Medical Technicians',80,0,NULL),(2151,'Medical - Complete','Medical - Complete','5775','Salaries - Social Service Professionals',80,0,NULL),(2152,'Medical - Complete','Medical - Complete','5780','Salaries - Other',80,0,NULL),(2153,'Medical - Complete','Medical - Complete','5800','EMPLOYEES - EMPLOYEE-RELATED EXPENSES',80,0,NULL),(2154,'Medical - Complete','Medical - Complete','5810','Payroll Taxes (Other)',80,0,NULL),(2155,'Medical - Complete','Medical - Complete','5811','Payroll Taxes - FICA/Medicare (Other)',80,0,'prcompany.glficaexpenseid;prcompany.glmedicareexpenseid'),(2156,'Medical - Complete','Medical - Complete','5812','Payroll Taxes - Federal Unemployment Insurance(Other)',80,0,'prcompany.glfuiexpenseid'),(2157,'Medical - Complete','Medical - Complete','5813','Payroll Taxes - State Unemployment Insurance(Other)',80,0,'prcompany.glsuiexpenseid'),(2158,'Medical - Complete','Medical - Complete','5814','Payroll Taxes - Other(Other)',80,0,NULL),(2159,'Medical - Complete','Medical - Complete','5820','Insurance(Other)',80,0,NULL),(2160,'Medical - Complete','Medical - Complete','5821','Insurance - Health(Other)',80,0,NULL),(2161,'Medical - Complete','Medical - Complete','5822','Insurance - Dental(Other)',80,0,NULL),(2162,'Medical - Complete','Medical - Complete','5823','Insurance - Life(Other)',80,0,NULL),(2163,'Medical - Complete','Medical - Complete','5824','Insurance - Disability(Other)',80,0,NULL),(2164,'Medical - Complete','Medical - Complete','5825','Insurance - Workers\' Compensation(Other)',80,0,'prcompany.glworkmanscompexpenseid'),(2165,'Medical - Complete','Medical - Complete','5826','Insurance - Other(Other)',80,0,NULL),(2166,'Medical - Complete','Medical - Complete','5830','Pension and Retirement Benefits (Other)',80,0,NULL),(2167,'Medical - Complete','Medical - Complete','5831','Pension (Other)',80,0,NULL),(2168,'Medical - Complete','Medical - Complete','5832','Deferred Compensation(Other)',80,0,NULL),(2169,'Medical - Complete','Medical - Complete','5833','Severance Plan (Other)',80,0,NULL),(2170,'Medical - Complete','Medical - Complete','5835','Professional Development(Other)',80,0,NULL),(2171,'Medical - Complete','Medical - Complete','5840','Books and Subscriptions(Other)',80,0,NULL),(2172,'Medical - Complete','Medical - Complete','5845','Dues and Memberships(Other)',80,0,NULL),(2173,'Medical - Complete','Medical - Complete','5850','Licenses(Other)',80,0,NULL),(2174,'Medical - Complete','Medical - Complete','5855','Meetings(Other)',80,0,NULL),(2175,'Medical - Complete','Medical - Complete','5860','Travel(Other)',80,0,NULL),(2176,'Medical - Complete','Medical - Complete','5865','Medical Reimbursement Plan (Other)',80,0,NULL),(2177,'Medical - Complete','Medical - Complete','5870','Vehicles(Other)',80,0,NULL),(2178,'Medical - Complete','Medical - Complete','5875','Parking (Other)',80,0,NULL),(2179,'Medical - Complete','Medical - Complete','5880','Telephones(Other)',80,0,NULL),(2180,'Medical - Complete','Medical - Complete','5885','Beepers(Other)',80,0,NULL),(2181,'Medical - Complete','Medical - Complete','5890','Meals and Entertainment (Other)',80,0,NULL),(2182,'Medical - Complete','Medical - Complete','5895','Other Benefits(Other)',80,0,'prcompany.gltaxexemptexpenseid'),(2183,'Medical - Complete','Medical - Complete','5900','Temporary Employee Salaries',80,0,NULL),(2184,'Medical - Complete','Medical - Complete','5901','Physician Salaries',80,0,NULL),(2185,'Medical - Complete','Medical - Complete','5902','Midlevel Provider Salaries',80,0,NULL),(2186,'Medical - Complete','Medical - Complete','5903','Ancillary Staff Salaries',80,0,NULL),(2187,'Medical - Complete','Medical - Complete','5904','Administrative and Other Staff',80,0,NULL),(2188,'Medical - Complete','Medical - Complete','5910','Temporary Employee Benefits ',80,0,NULL),(2189,'Medical - Complete','Medical - Complete','5911','Physician Benefits',80,0,NULL),(2190,'Medical - Complete','Medical - Complete','5912','Midlevel ProviderBenefits',80,0,NULL),(2191,'Medical - Complete','Medical - Complete','5913','Ancillary Staff Benefits',80,0,NULL),(2192,'Medical - Complete','Medical - Complete','5914','Administrative and Other Staff',80,0,NULL),(2193,'Medical - Complete','Medical - Complete','6000','SERVICES AND GENERAL EXPENSE',80,0,NULL),(2194,'Medical - Complete','Medical - Complete','6100','Office and Administrative Expense',80,0,NULL),(2195,'Medical - Complete','Medical - Complete','6110','Equipment Rentals (Admin)',80,0,NULL),(2196,'Medical - Complete','Medical - Complete','6115','Equipment Maintenance (Admin)',80,0,NULL),(2197,'Medical - Complete','Medical - Complete','6120','Telephone (Admin)',80,0,NULL),(2198,'Medical - Complete','Medical - Complete','6130','Postage (Admin)',80,0,NULL),(2199,'Medical - Complete','Medical - Complete','6140','Courier and Overnight Delivery(Admin)',80,0,'invcompany.freight'),(2200,'Medical - Complete','Medical - Complete','6150','Security',80,0,NULL),(2201,'Medical - Complete','Medical - Complete','6160','Library/Books and Subscriptions',80,0,NULL),(2202,'Medical - Complete','Medical - Complete','6170','Advertising and Marketing',80,0,NULL),(2203,'Medical - Complete','Medical - Complete','6180','General Business and Other Insurance',80,0,NULL),(2204,'Medical - Complete','Medical - Complete','6181','Officers\' and Directors\' Liability',80,0,NULL),(2205,'Medical - Complete','Medical - Complete','6182','Other Liability',80,0,NULL),(2206,'Medical - Complete','Medical - Complete','6183','Reinsurance for Capitation Contracts',80,0,NULL),(2207,'Medical - Complete','Medical - Complete','6184','Keyman and Overhead Insurance',80,0,NULL),(2208,'Medical - Complete','Medical - Complete','6185','Malpractice Insurance',80,0,NULL),(2209,'Medical - Complete','Medical - Complete','6186','Physicians',80,0,NULL),(2210,'Medical - Complete','Medical - Complete','6187','Midlevel Providers',80,0,NULL),(2211,'Medical - Complete','Medical - Complete','6188','Ancillary and Clinical Staff',80,0,NULL),(2212,'Medical - Complete','Medical - Complete','6189','Global Coverage',80,0,NULL),(2213,'Medical - Complete','Medical - Complete','6190','Printing(Admin)',80,0,NULL),(2214,'Medical - Complete','Medical - Complete','6200','Copying(Admin)',80,0,NULL),(2215,'Medical - Complete','Medical - Complete','6210','Medical Forms',80,0,NULL),(2216,'Medical - Complete','Medical - Complete','6220','Answering Service',80,0,NULL),(2217,'Medical - Complete','Medical - Complete','6230','Meals and Entertainment',80,0,NULL),(2218,'Medical - Complete','Medical - Complete','6240','Cafeteria',80,0,NULL),(2219,'Medical - Complete','Medical - Complete','6250','Employee Relations',80,0,NULL),(2220,'Medical - Complete','Medical - Complete','6260','Physician Recruitment',80,0,NULL),(2221,'Medical - Complete','Medical - Complete','6270','Nonphysician Recruitment',80,0,NULL),(2222,'Medical - Complete','Medical - Complete','6300','Depreciation/Amortization',80,0,NULL),(2223,'Medical - Complete','Medical - Complete','6301','Furniture and Fixtures',80,0,NULL),(2224,'Medical - Complete','Medical - Complete','6302','Capital Leases',80,0,NULL),(2225,'Medical - Complete','Medical - Complete','6303','Equipment',80,0,NULL),(2226,'Medical - Complete','Medical - Complete','6304','Computers',80,0,NULL),(2227,'Medical - Complete','Medical - Complete','6305','Vehicles',80,0,NULL),(2228,'Medical - Complete','Medical - Complete','6306','Amortization',80,0,NULL),(2229,'Medical - Complete','Medical - Complete','6307','Other Depreciation',80,0,NULL),(2230,'Medical - Complete','Medical - Complete','6310','Accounting Services',80,0,NULL),(2231,'Medical - Complete','Medical - Complete','6320','Legal Services',80,0,NULL),(2232,'Medical - Complete','Medical - Complete','6330','Actuarial Services',80,0,NULL),(2233,'Medical - Complete','Medical - Complete','6340','Pension Administration Expense',80,0,NULL),(2234,'Medical - Complete','Medical - Complete','6350','Consulting Services',80,0,NULL),(2235,'Medical - Complete','Medical - Complete','6360','Other Professional Services',80,0,NULL),(2236,'Medical - Complete','Medical - Complete','6370','Medical Transcription',80,0,NULL),(2237,'Medical - Complete','Medical - Complete','6380','Payroll Services',80,0,NULL),(2238,'Medical - Complete','Medical - Complete','6390','Business Transportation',80,0,NULL),(2239,'Medical - Complete','Medical - Complete','6400','General Supplies',80,0,NULL),(2240,'Medical - Complete','Medical - Complete','6410','Taxes - Excise and Other Business Taxes',80,0,'invcompany.tax'),(2241,'Medical - Complete','Medical - Complete','6420','Computer Supplies',80,0,NULL),(2242,'Medical - Complete','Medical - Complete','6430','Computer Software',80,0,NULL),(2243,'Medical - Complete','Medical - Complete','6440','Other Office and Administrative Expense',80,0,NULL),(2244,'Medical - Complete','Medical - Complete','6500','Billing Expense',80,0,NULL),(2245,'Medical - Complete','Medical - Complete','6510','Equipment Rentals (Billing)',80,0,NULL),(2246,'Medical - Complete','Medical - Complete','6515','Equipment Maintenance (Billing)',80,0,NULL),(2247,'Medical - Complete','Medical - Complete','6520','Electronic Data Processing ',80,0,NULL),(2248,'Medical - Complete','Medical - Complete','6530','Telephone (Billing)',80,0,NULL),(2249,'Medical - Complete','Medical - Complete','6540','Postage(Billing)',80,0,NULL),(2250,'Medical - Complete','Medical - Complete','6550','Courier and Overnight Delivery (Billing)',80,0,NULL),(2251,'Medical - Complete','Medical - Complete','6560','Printing (Billing)',80,0,NULL),(2252,'Medical - Complete','Medical - Complete','6570','Copying (Billing)',80,0,NULL),(2253,'Medical - Complete','Medical - Complete','6580','Depreciation',80,0,NULL),(2254,'Medical - Complete','Medical - Complete','6600','General Services',80,0,NULL),(2255,'Medical - Complete','Medical - Complete','6650','Other Billing Expense',80,0,NULL),(2256,'Medical - Complete','Medical - Complete','6700','Bad Debt Expense',80,0,'arcompany.baddebt'),(2257,'Medical - Complete','Medical - Complete','6710','Accounts Receivable Write-Offs',80,0,NULL),(2258,'Medical - Complete','Medical - Complete','6720','Collection Agency Write-Offs',80,0,NULL),(2259,'Medical - Complete','Medical - Complete','6730','Collection Expenses',80,0,NULL),(2260,'Medical - Complete','Medical - Complete','7000','Clinical Expense',80,0,NULL),(2261,'Medical - Complete','Medical - Complete','7010','Drugs and Medications',80,0,NULL),(2262,'Medical - Complete','Medical - Complete','7020','Medical Supplies',80,0,NULL),(2263,'Medical - Complete','Medical - Complete','7021','Radiology',80,0,NULL),(2264,'Medical - Complete','Medical - Complete','7022','Laboratory',80,0,NULL),(2265,'Medical - Complete','Medical - Complete','7023','Other Ancillary Supplies',80,0,NULL),(2266,'Medical - Complete','Medical - Complete','7030','Linen Supplies',80,0,NULL),(2267,'Medical - Complete','Medical - Complete','7040','Uniforms and Laundry',80,0,NULL),(2268,'Medical - Complete','Medical - Complete','7050','Patient Education',80,0,NULL),(2269,'Medical - Complete','Medical - Complete','7060','Photography',80,0,NULL),(2270,'Medical - Complete','Medical - Complete','7070','Biohazardous Waste Removal',80,0,NULL),(2271,'Medical - Complete','Medical - Complete','7100','Equipment Rentals (Clinical)',80,0,NULL),(2272,'Medical - Complete','Medical - Complete','7110','Equipment Maintenance (Clinical)',80,0,NULL),(2273,'Medical - Complete','Medical - Complete','7120','Telephone(Clinical)',80,0,NULL),(2274,'Medical - Complete','Medical - Complete','7130','Postage(Clinical)',80,0,NULL),(2275,'Medical - Complete','Medical - Complete','7140','Medical Record Supplies',80,0,NULL),(2276,'Medical - Complete','Medical - Complete','7150','Other Clinical Expense',80,0,NULL),(2277,'Medical - Complete','Medical - Complete','7160','Depreciation(Clinical)',80,0,NULL),(2278,'Medical - Complete','Medical - Complete','7161','General Clinical',80,0,NULL),(2279,'Medical - Complete','Medical - Complete','7162','Radiology',80,0,NULL),(2280,'Medical - Complete','Medical - Complete','7163','Laboratory',80,0,NULL),(2281,'Medical - Complete','Medical - Complete','7500','Occupancy Expense',80,0,NULL),(2282,'Medical - Complete','Medical - Complete','7510','Rent/Lease',80,0,NULL),(2283,'Medical - Complete','Medical - Complete','7520','Condominium Assessments/Monthly Maintenance Fees',80,0,NULL),(2284,'Medical - Complete','Medical - Complete','7530','General Maintenance',80,0,NULL),(2285,'Medical - Complete','Medical - Complete','7540','Utilities',80,0,NULL),(2286,'Medical - Complete','Medical - Complete','7541','Utilities - Water',80,0,NULL),(2287,'Medical - Complete','Medical - Complete','7542','Utilities - Electricity',80,0,NULL),(2288,'Medical - Complete','Medical - Complete','7543','Utilities - Waste Disposal',80,0,NULL),(2289,'Medical - Complete','Medical - Complete','7544','Other Utilities',80,0,NULL),(2290,'Medical - Complete','Medical - Complete','7550','Property Taxes',80,0,NULL),(2291,'Medical - Complete','Medical - Complete','7560','Housekeeping/Maintenance Services',80,0,NULL),(2292,'Medical - Complete','Medical - Complete','7570','Other Occupancy Expense',80,0,NULL),(2293,'Medical - Complete','Medical - Complete','7580','Insurance (Occupancy)',80,0,NULL),(2294,'Medical - Complete','Medical - Complete','7590','Depreciation (Occupancy)',80,0,NULL),(2295,'Medical - Complete','Medical - Complete','7595','Amortization - Leasehold Improvements (Occupancy)',80,0,NULL),(2296,'Medical - Complete','Medical - Complete','7600','Cost of Goods Sold - Medical Related',70,0,'arcompany.cost;invcompany.cost'),(2297,'Medical - Complete','Medical - Complete','7700','PURCHASED SERVICES/MANAGEMENT FEES',80,0,NULL),(2298,'Medical - Complete','Medical - Complete','7710','Medical Directorships',80,0,NULL),(2299,'Medical - Complete','Medical - Complete','7720','General and Administrative Expense - Purchased Services',80,0,NULL),(2300,'Medical - Complete','Medical - Complete','7730','Management Fees - MSO/PPMC',80,0,NULL),(2301,'Medical - Complete','Medical - Complete','7731','Management Fees - Commercial',80,0,NULL),(2302,'Medical - Complete','Medical - Complete','7732','Management Fees - Medicare',80,0,NULL),(2303,'Medical - Complete','Medical - Complete','7733','Management Fees - Medicaid',80,0,NULL),(2304,'Medical - Complete','Medical - Complete','7734','Management Fees - Other',80,0,NULL),(2305,'Medical - Complete','Medical - Complete','7740','Management Company Incentive',80,0,NULL),(2306,'Medical - Complete','Medical - Complete','7800','Purchased Services for HMO/PPO Patients - Professional and Medical',80,0,NULL),(2307,'Medical - Complete','Medical - Complete','7810','FFS Purchased Services for HMO/PPO Patients',80,0,NULL),(2308,'Medical - Complete','Medical - Complete','7811','FFS Purchased Services - Commercial',80,0,NULL),(2309,'Medical - Complete','Medical - Complete','7812','FFS Purchased Services - Medicare',80,0,NULL),(2310,'Medical - Complete','Medical - Complete','7813','FFS Purchased Services - Medicaid',80,0,NULL),(2311,'Medical - Complete','Medical - Complete','7814','FFS Purchased Services - Other',80,0,NULL),(2312,'Medical - Complete','Medical - Complete','7850','Sub-capitation Payments - Primary Care',80,0,NULL),(2313,'Medical - Complete','Medical - Complete','7851','Sub-capitation Payments - Primary Care - Commercial',80,0,NULL),(2314,'Medical - Complete','Medical - Complete','7852','Sub-capitation Payments - Primary Care - Medicare',80,0,NULL),(2315,'Medical - Complete','Medical - Complete','7853','Sub-capitation Payments - Primary Care - Medicaid',80,0,NULL),(2316,'Medical - Complete','Medical - Complete','7854','Sub-capitation Payments - Primary Care - Other',80,0,NULL),(2317,'Medical - Complete','Medical - Complete','7860','Sub-capitation Payments - Specialty Care',80,0,NULL),(2318,'Medical - Complete','Medical - Complete','7861','Sub-capitation Payments - Specialty Care - Commercial',80,0,NULL),(2319,'Medical - Complete','Medical - Complete','7862','Sub-capitation Payments - Specialty Care - Medicare',80,0,NULL),(2320,'Medical - Complete','Medical - Complete','7863','Sub-capitation Payments - Specialty Care - Medicaid',80,0,NULL),(2321,'Medical - Complete','Medical - Complete','7864','Sub-capitation Payments - Specialty Care - Other',80,0,NULL),(2322,'Medical - Complete','Medical - Complete','7870','Sub-capitation Payments - Hospitals',80,0,NULL),(2323,'Medical - Complete','Medical - Complete','7880','Sub-capitation Payments - Other',80,0,NULL),(2324,'Medical - Complete','Medical - Complete','9000','NONOP REVENUE & EXP; INCOME TAXES & OTHER EXP',90,0,NULL),(2325,'Medical - Complete','Medical - Complete','9100','Nonoperating Revenues',90,0,NULL),(2326,'Medical - Complete','Medical - Complete','9110','Interest Income',90,0,'arcompany.interest'),(2327,'Medical - Complete','Medical - Complete','9120','Income from Long-Term Investments',90,0,NULL),(2328,'Medical - Complete','Medical - Complete','9130','Property Rentals',90,0,NULL),(2329,'Medical - Complete','Medical - Complete','9140','Unrealized Gains and Losses - Investments',90,0,NULL),(2330,'Medical - Complete','Medical - Complete','9150','Realized Gains and Losses - Investments',90,0,NULL),(2331,'Medical - Complete','Medical - Complete','9160','Donations Received (Nonoperating Revenue)',90,0,NULL),(2332,'Medical - Complete','Medical - Complete','9170','Nonoperating Subsidy Income',90,0,NULL),(2333,'Medical - Complete','Medical - Complete','9200','Nonoperating Expenses',90,0,NULL),(2334,'Medical - Complete','Medical - Complete','9210','Interest Expense',90,0,'apcompany.interestexpense'),(2335,'Medical - Complete','Medical - Complete','9220','Contributions/Donations Expense',90,0,NULL),(2336,'Medical - Complete','Medical - Complete','9230','Current Income Tax Expense (Recovery)',90,0,NULL),(2337,'Medical - Complete','Medical - Complete','9300','Other Income/Expense',90,0,NULL),(2338,'Medical - Complete','Medical - Complete','6800','Discounts Lost',80,0,'apcompany.discount'),(2339,'Medical - Complete','Medical - Complete','5896','Commission Expense',80,0,'apcompany.glcommissionid'),(2340,'Medical - Complete','Medical - Complete','1430','Inventory Loss',10,0,'invcompany.loss'),(2341,'Medical - Complete','Medical - Complete','2391','Shipping Liability',21,0,'arcompany.shipliability'),(2342,'MenorÃ­a - Simple','MenorÃ­a - Simple','3500','Utilidades Retenidos',40,0,''),(2343,'MenorÃ­a - Simple','MenorÃ­a - Simple','3000','Capital',30,0,''),(2344,'MenorÃ­a - Simple','MenorÃ­a - Simple','7100','Utilidad/PÃ©rdida-Gastos de Venta de Activos',80,0,''),(2345,'MenorÃ­a - Simple','MenorÃ­a - Simple','7050','Gastos de DepreciaciÃ³n',80,0,''),(2346,'MenorÃ­a - Simple','MenorÃ­a - Simple','7000','Gastos de Saldos Positivos/Negativos',80,0,''),(2347,'MenorÃ­a - Simple','MenorÃ­a - Simple','6950','Gastos de Seguros',80,0,''),(2348,'MenorÃ­a - Simple','MenorÃ­a - Simple','6900','Desc. Compras-Items de Gastos',80,0,'apcompany.discount'),(2349,'MenorÃ­a - Simple','MenorÃ­a - Simple','6850','Gastos de Cargos de Servicios',80,0,''),(2350,'MenorÃ­a - Simple','MenorÃ­a - Simple','6800','Gastos de Flete',80,0,'invcompany.freight'),(2351,'MenorÃ­a - Simple','MenorÃ­a - Simple','6750','Gastos de Renta de Equipo',80,0,''),(2352,'MenorÃ­a - Simple','MenorÃ­a - Simple','6700','Gastos de Cuotas de Franquicias',80,0,''),(2353,'MenorÃ­a - Simple','MenorÃ­a - Simple','6650','Gastos de Comisiones y Honorarios',80,0,'apcompany.glcommissionid'),(2354,'MenorÃ­a - Simple','MenorÃ­a - Simple','6600','Gastos de PromociÃ³n',80,0,''),(2355,'MenorÃ­a - Simple','MenorÃ­a - Simple','6550','Otros Gastos de Oficina',80,0,''),(2356,'MenorÃ­a - Simple','MenorÃ­a - Simple','6500','Gastos de TelÃ©fono',80,0,''),(2357,'MenorÃ­a - Simple','MenorÃ­a - Simple','6450','Gastos de Suministros de Oficina',80,0,''),(2358,'MenorÃ­a - Simple','MenorÃ­a - Simple','6400','Gastos de Servicios Publicos',80,0,''),(2359,'MenorÃ­a - Simple','MenorÃ­a - Simple','6350','Gastos de Reparaciones y Mantenimiento',80,0,''),(2360,'MenorÃ­a - Simple','MenorÃ­a - Simple','6300','Gastos de Renta o Arrendimiento',80,0,''),(2361,'MenorÃ­a - Simple','MenorÃ­a - Simple','6250','Otros Gastos de Impuestos',80,0,'invcompany.tax'),(2362,'MenorÃ­a - Simple','MenorÃ­a - Simple','6200','Gastos de Impuestos Sobre la Renta',80,0,''),(2363,'MenorÃ­a - Simple','MenorÃ­a - Simple','6150','Gastos de Malas Deudas',80,0,'arcompany.baddebt'),(2364,'MenorÃ­a - Simple','MenorÃ­a - Simple','6100','Gastos de Impuestos de NÃ³mina',80,0,''),(2365,'MenorÃ­a - Simple','MenorÃ­a - Simple','6050','Gastos de Programas de Beneficio a los Empleados',80,0,''),(2366,'MenorÃ­a - Simple','MenorÃ­a - Simple','6000','Gastos de Sueldos',80,0,''),(2367,'MenorÃ­a - Simple','MenorÃ­a - Simple','5900','Ajuste de Inventario',70,0,''),(2368,'MenorÃ­a - Simple','MenorÃ­a - Simple','5400','Costo de Ventas-Sueldos y Salarios',70,0,''),(2369,'MenorÃ­a - Simple','MenorÃ­a - Simple','5100','Costo de Ventas-Flete',70,0,''),(2370,'MenorÃ­a - Simple','MenorÃ­a - Simple','5000','Costo de Ventas',70,0,'arcompany.cost;invcompany.cost'),(2371,'MenorÃ­a - Simple','MenorÃ­a - Simple','4900','Descuentos de Ventas',50,0,'apcompany.discount'),(2372,'MenorÃ­a - Simple','MenorÃ­a - Simple','4300','Otros Ingresos',50,0,''),(2373,'MenorÃ­a - Simple','MenorÃ­a - Simple','4200','Ingresos por Cargos Financieros',50,0,''),(2374,'MenorÃ­a - Simple','MenorÃ­a - Simple','4100','Ingresos por InterÃ©ses',50,0,'arcompany.interest'),(2375,'MenorÃ­a - Simple','MenorÃ­a - Simple','4000','Ingresos Ventas',50,0,'invcompany.sales'),(2376,'MenorÃ­a - Simple','MenorÃ­a - Simple','2700','Deuda de Largo Plazo-No Corriente',22,0,''),(2377,'MenorÃ­a - Simple','MenorÃ­a - Simple','2500','PorciÃ³n Corriente-Deuda de Largo Plazo',21,0,''),(2378,'MenorÃ­a - Simple','MenorÃ­a - Simple','2400','DepÃ³sitos de Clientes',21,0,'arcompany.depositglacctid'),(2379,'MenorÃ­a - Simple','MenorÃ­a - Simple','2380','Impuesto Sobre la Renta por Pagar',21,0,''),(2380,'MenorÃ­a - Simple','MenorÃ­a - Simple','2370','Impuestos Locales por Pagar',21,0,''),(2381,'MenorÃ­a - Simple','MenorÃ­a - Simple','2360','SUTA por Pagar',21,0,'prcompany.glsuipayableid'),(2382,'MenorÃ­a - Simple','MenorÃ­a - Simple','2350','Impuestos Estatales de NÃ³mina por Pagar',21,0,''),(2383,'MenorÃ­a - Simple','MenorÃ­a - Simple','2340','FUTA por Pagar',21,0,'prcompany.glfuipayableid'),(2384,'MenorÃ­a - Simple','MenorÃ­a - Simple','2330','Imp Sobre la Renta de NÃ³mina Federal por Pagar',21,0,'prcompany.glfitpayableid'),(2385,'MenorÃ­a - Simple','MenorÃ­a - Simple','2320','Deducciones por Pagar',21,0,'prcompany.glmiscdedpayableid'),(2386,'MenorÃ­a - Simple','MenorÃ­a - Simple','2310','Impuesto Sobre Ventas (IVA) por Pagar',21,0,''),(2387,'MenorÃ­a - Simple','MenorÃ­a - Simple','2000','Cuentas por Pagar',21,0,'apcompany.payable'),(2388,'MenorÃ­a - Simple','MenorÃ­a - Simple','1900','DepreciaciÃ³n Acum.- Prop&Equipo',11,0,''),(2389,'MenorÃ­a - Simple','MenorÃ­a - Simple','1500','Propiedad y Equipo',11,0,''),(2390,'MenorÃ­a - Simple','MenorÃ­a - Simple','1400','Gastos Prepagados',10,0,''),(2391,'MenorÃ­a - Simple','MenorÃ­a - Simple','1200','Inventario',10,0,'arcompany.inventory;invcompany.default_inventoryglacct'),(2392,'MenorÃ­a - Simple','MenorÃ­a - Simple','1150','Reserva para Cuentas Dudosas',10,0,''),(2393,'MenorÃ­a - Simple','MenorÃ­a - Simple','1100','Cuentas por Cobrar',10,0,'arcompany.receivables'),(2394,'MenorÃ­a - Simple','MenorÃ­a - Simple','1020','Cuenta de Cheques',10,0,'apcompany.glccid;arcompany.checking;prcompany.glcheckaccountid'),(2395,'MenorÃ­a - Simple','MenorÃ­a - Simple','1010','Efectivo Disponible',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(2396,'MenorÃ­a - Simple','MenorÃ­a - Simple','1260','PÃ©rdida de Inventario',10,0,'invcompany.loss'),(2397,'MenorÃ­a - Simple','MenorÃ­a - Simple','2001','NÃ³mina Acumulada',21,0,'prcompany.glpayroll_payableid'),(2398,'MenorÃ­a - Simple','MenorÃ­a - Simple','2331','Impuesta de FICA por Pagar',21,0,'prcompany.glficapayableid'),(2399,'MenorÃ­a - Simple','MenorÃ­a - Simple','2332','Impuesto de Medicare por Pagar',21,0,'prcompany.glmedicarepayableid'),(2400,'MenorÃ­a - Simple','MenorÃ­a - Simple','2333','CompensaciÃ³n a Trabajadores por Pagar',21,0,'prcompany.glworkmanscomppayableid'),(2401,'MenorÃ­a - Simple','MenorÃ­a - Simple','2450','Responsabilidad Transporte',21,0,'arcompany.shipliability'),(2402,'MenorÃ­a - Simple','MenorÃ­a - Simple','4001','Ventas - Labor de Servicio',50,0,'arcompany.labor_sales_glacctid'),(2403,'MenorÃ­a - Simple','MenorÃ­a - Simple','4002','Ventas Reembolsas',50,0,'arcompany.refund'),(2404,'MenorÃ­a - Simple','MenorÃ­a - Simple','6030','Gastos de Pagos Misc. Exento de Impuestos',80,0,'prcompany.gltaxexemptexpenseid'),(2405,'MenorÃ­a - Simple','MenorÃ­a - Simple','6110','Gastos de Impuestos FICA',80,0,'prcompany.glficaexpenseid'),(2406,'MenorÃ­a - Simple','MenorÃ­a - Simple','6120','Gastos de Impuestos Medicare',80,0,'prcompany.glmedicareexpenseid'),(2407,'MenorÃ­a - Simple','MenorÃ­a - Simple','6140','Gastos de Impuestos FUTA',80,0,'prcompany.glfuiexpenseid'),(2408,'MenorÃ­a - Simple','MenorÃ­a - Simple','6160','Gastos de Impuestos SUTA',80,0,'prcompany.glsuiexpenseid'),(2409,'MenorÃ­a - Simple','MenorÃ­a - Simple','6170','Gastos de Imp de CompensaciÃ³n a los Trabajadores',80,0,'prcompany.glworkmanscompexpenseid'),(2410,'MenorÃ­a - Simple','MenorÃ­a - Simple','6410','Gastos de InterÃ©ses',80,0,'apcompany.interestexpense'),(2411,'MenorÃ­a - Simple','MenorÃ­a - Simple','4010','Gastos de Reabastecer Inventario ',50,0,'arcompany.restockglid'),(3390,'Plan Cuentas 3','Plan Cuentas 3','12000','INVENTARIO',10,0,NULL),(2695,'Plan Cuentas 1','Plan Cuentas 1','6000033000','GASTOS DE VIAJE',80,0,NULL),(2694,'Plan Cuentas 1','Plan Cuentas 1','6000032000','GASTOS Y DERECHOS LEGALES',80,0,NULL),(2693,'Plan Cuentas 1','Plan Cuentas 1','6000031000','IMPUESTOS Y DERECHOS DE IMPORTACION',80,0,NULL),(2692,'Plan Cuentas 1','Plan Cuentas 1','6000030000','DONATIVOS',80,0,NULL),(2691,'Plan Cuentas 1','Plan Cuentas 1','6000029000','CUOTAS Y SUSCRIPCIONES',80,0,NULL),(2690,'Plan Cuentas 1','Plan Cuentas 1','6000028000','HONORARIOS A PROFESIONISTAS',80,0,NULL),(3389,'Plan Cuentas 3','Plan Cuentas 3','11500','RESERVA PARA DEUDA DUDOSO',10,0,NULL),(2689,'Plan Cuentas 1','Plan Cuentas 1','6000027000','HONORARIOS DE ASESORIA',80,0,NULL),(2688,'Plan Cuentas 1','Plan Cuentas 1','6000026000','PAPELERIA Y ARTICULOS PARA OFICINA',80,0,NULL),(2687,'Plan Cuentas 1','Plan Cuentas 1','6000025000','RENTA DE EQUIPO',80,0,NULL),(2686,'Plan Cuentas 1','Plan Cuentas 1','6000024000','RENTA DE LOCALES',80,0,NULL),(2685,'Plan Cuentas 1','Plan Cuentas 1','6000023000','MANTTO. DE EQUIPO',80,0,NULL),(2684,'Plan Cuentas 1','Plan Cuentas 1','6000022000','MANTTO. DE OFICINAS',80,0,NULL),(2683,'Plan Cuentas 1','Plan Cuentas 1','6000021000','DESPENSA Y ART. ASEO PARA OFNA',80,0,NULL),(2682,'Plan Cuentas 1','Plan Cuentas 1','6000020000','CLUBES DEPORTIVOS',80,0,NULL),(3388,'Plan Cuentas 3','Plan Cuentas 3','11400','OTROS COBRABLES',10,0,NULL),(2681,'Plan Cuentas 1','Plan Cuentas 1','6000019000','CURSOS Y BECAS',80,0,NULL),(2680,'Plan Cuentas 1','Plan Cuentas 1','6000018000','GASTOS DE PREVISION SOCIAL',80,0,NULL),(2679,'Plan Cuentas 1','Plan Cuentas 1','6000017000','FONDO DE AHORRO',80,0,NULL),(2678,'Plan Cuentas 1','Plan Cuentas 1','6000013000','APORTACIONES AL INFONAVIT',80,0,NULL),(2677,'Plan Cuentas 1','Plan Cuentas 1','6000012000','CUOTA I.M.S.S.',80,0,NULL),(2676,'Plan Cuentas 1','Plan Cuentas 1','6000011000','AYUDA DE COMEDOR',80,0,NULL),(2675,'Plan Cuentas 1','Plan Cuentas 1','6000009000','VALES DE DESPENSA',80,0,NULL),(2674,'Plan Cuentas 1','Plan Cuentas 1','6000008000','PRIMA VACACIONAL',80,0,NULL),(2673,'Plan Cuentas 1','Plan Cuentas 1','6000007000','VACACIONES',80,0,NULL),(2672,'Plan Cuentas 1','Plan Cuentas 1','6000006000','GRATIFICACIONES',80,0,NULL),(2671,'Plan Cuentas 1','Plan Cuentas 1','6000005000','BONOS',80,0,NULL),(2670,'Plan Cuentas 1','Plan Cuentas 1','6000004000','COMISIONES',80,0,NULL),(2669,'Plan Cuentas 1','Plan Cuentas 1','6000003000','COMPENSACIONES',80,0,NULL),(2668,'Plan Cuentas 1','Plan Cuentas 1','6000002000','HORAS EXTRAS',80,0,NULL),(2667,'Plan Cuentas 1','Plan Cuentas 1','6000001000','SUELDOS Y SALARIOS',80,0,NULL),(2666,'Plan Cuentas 1','Plan Cuentas 1','6000000000','GASTOS DE OPERACION',80,0,NULL),(2665,'Plan Cuentas 1','Plan Cuentas 1','5500000000','MANO DE OBRA',70,0,NULL),(2664,'Plan Cuentas 1','Plan Cuentas 1','5000000000','COSTO DE VENTAS',70,0,NULL),(2663,'Plan Cuentas 1','Plan Cuentas 1','4200004000','DEVOLUCIONES Y REBAJAS EXENTAS I.V.A.',60,0,NULL),(2662,'Plan Cuentas 1','Plan Cuentas 1','4200003000','DEVOLUCIONES Y REBAJAS I.V.A. AL 15%',60,0,NULL),(2661,'Plan Cuentas 1','Plan Cuentas 1','4200002000','DEVOLUCIONES Y REBAJAS I.V.A. AL 8%',60,0,NULL),(2660,'Plan Cuentas 1','Plan Cuentas 1','4200001000','DEVOLUCIONES Y REBAJAS I.V.A. AL 13%',60,0,NULL),(2659,'Plan Cuentas 1','Plan Cuentas 1','4200000000','DEVOLUCIONES Y REBAJAS SOBRE VENTAS',60,0,NULL),(2658,'Plan Cuentas 1','Plan Cuentas 1','4100004000','VENTAS EXENTAS I.V.A.',50,0,NULL),(2657,'Plan Cuentas 1','Plan Cuentas 1','4100003000','VENTAS AL 15%',50,0,NULL),(3387,'Plan Cuentas 3','Plan Cuentas 3','11000','CUENTAS POR COBRAR',10,0,NULL),(2656,'Plan Cuentas 1','Plan Cuentas 1','4100002000','VENTAS AL 10%',50,0,NULL),(2655,'Plan Cuentas 1','Plan Cuentas 1','4100001000','VENTAS AL 3.75%',50,0,NULL),(2654,'Plan Cuentas 1','Plan Cuentas 1','4100000000','VENTAS',50,0,NULL),(2653,'Plan Cuentas 1','Plan Cuentas 1','3500000000','GANANCIA O PERDIDA CAMBIARIA',30,0,NULL),(2652,'Plan Cuentas 1','Plan Cuentas 1','3400000000','RESULTADO DE EJERCICIOS ANTERIORES',40,0,NULL),(3386,'Plan Cuentas 3','Plan Cuentas 3','10700','CERTIFICADOS DE DEPOSITO',10,0,NULL),(2651,'Plan Cuentas 1','Plan Cuentas 1','3300000000','SUPERAVIT POR ACTUALIZACION DE ACT. FIJ',30,0,NULL),(2650,'Plan Cuentas 1','Plan Cuentas 1','3210000000','RESERVA PARA REINVERSION',30,0,NULL),(2649,'Plan Cuentas 1','Plan Cuentas 1','3200000000','RESERVA LEGAL',30,0,NULL),(2648,'Plan Cuentas 1','Plan Cuentas 1','3100000000','CAPITAL SOCIAL',30,0,NULL),(2647,'Plan Cuentas 1','Plan Cuentas 1','2240001000','DOCUMENTOS DIVERSOS',23,0,NULL),(2646,'Plan Cuentas 1','Plan Cuentas 1','2240000000','DOCUMENTOS POR PAGAR A L.P.',22,0,NULL),(2645,'Plan Cuentas 1','Plan Cuentas 1','2220100000','HIPOTECAS',22,0,NULL),(2644,'Plan Cuentas 1','Plan Cuentas 1','2220001000','HIPOTECAS',22,0,NULL),(2643,'Plan Cuentas 1','Plan Cuentas 1','2220000000','CREDITOS HIPOTECARIOS',22,0,NULL),(3385,'Plan Cuentas 3','Plan Cuentas 3','10600','AHORROS DE MONEY MARKET ',10,0,NULL),(2642,'Plan Cuentas 1','Plan Cuentas 1','2180001000','ANTICIPOS DIVERSOS',21,0,NULL),(2641,'Plan Cuentas 1','Plan Cuentas 1','2180000000','ANTICIPOS DE CLIENTES',21,0,NULL),(2640,'Plan Cuentas 1','Plan Cuentas 1','2170003000','I.V.A. AL 15%',21,0,NULL),(2639,'Plan Cuentas 1','Plan Cuentas 1','2170002000','I.V.A. AL 10%',21,0,NULL),(2638,'Plan Cuentas 1','Plan Cuentas 1','2170001000','I.V.A. AL 3.75%',21,0,NULL),(2637,'Plan Cuentas 1','Plan Cuentas 1','2170000000','I.V.A. POR PAGAR',21,0,NULL),(2636,'Plan Cuentas 1','Plan Cuentas 1','2150007000','2% SOBRE NOMINAS',21,0,NULL),(2635,'Plan Cuentas 1','Plan Cuentas 1','2150006000','10% RETENIDO SOBRE HONORARIOS Y RENTA',21,0,NULL),(2634,'Plan Cuentas 1','Plan Cuentas 1','2150005000','2 % S.A.R.',21,0,NULL),(3384,'Plan Cuentas 3','Plan Cuentas 3','10500','CUENTA ESPECIAL',10,0,NULL),(2633,'Plan Cuentas 1','Plan Cuentas 1','2150004000','IMSS CUOTAS OBRERO PATRONALES',21,0,NULL),(2632,'Plan Cuentas 1','Plan Cuentas 1','2150003000','5 % INFONAVIT',21,0,NULL),(2631,'Plan Cuentas 1','Plan Cuentas 1','2150002000','2 % SOBRE RENUM. POR PAGAR',21,0,NULL),(2630,'Plan Cuentas 1','Plan Cuentas 1','2150001000','I.S.P.T. RETENIDO',21,0,NULL),(2629,'Plan Cuentas 1','Plan Cuentas 1','2150000000','IMPUESTOS POR PAGAR',21,0,NULL),(2628,'Plan Cuentas 1','Plan Cuentas 1','2130001000','DOCUMENTOS VARIOS',21,0,NULL),(2627,'Plan Cuentas 1','Plan Cuentas 1','2130000000','DOCUMENTOS POR PAGAR',21,0,NULL),(2626,'Plan Cuentas 1','Plan Cuentas 1','2120001000','ACREEDOR HIPOTECARIO',21,0,NULL),(3383,'Plan Cuentas 3','Plan Cuentas 3','10400','CUENTA DE AHORROS',10,0,NULL),(2625,'Plan Cuentas 1','Plan Cuentas 1','2120000000','ACREEDORES DIVERSOS',21,0,NULL),(2624,'Plan Cuentas 1','Plan Cuentas 1','2110002000','PROVEEDORES ZONA ESTE',21,0,NULL),(2623,'Plan Cuentas 1','Plan Cuentas 1','2110001000','PROVEEDORES ZONA SUR',21,0,NULL),(2622,'Plan Cuentas 1','Plan Cuentas 1','2110000000','PROVEEDORES',21,0,NULL),(2621,'Plan Cuentas 1','Plan Cuentas 1','1350000000','AMORTIZACION DE GASTOS DE ORG. E INST.',11,0,NULL),(2620,'Plan Cuentas 1','Plan Cuentas 1','1340000000','GASTOS DE INSTALACION',11,0,NULL),(2619,'Plan Cuentas 1','Plan Cuentas 1','1330000000','GASTOS DE ORGANIZACION',11,0,NULL),(2618,'Plan Cuentas 1','Plan Cuentas 1','1320001000','DEPOSITOS DE RENTAS',11,0,NULL),(2617,'Plan Cuentas 1','Plan Cuentas 1','1320000000','DEPOSITOS EN GARANTIA',11,0,NULL),(2616,'Plan Cuentas 1','Plan Cuentas 1','1310003000','I.S.R.',11,0,NULL),(2615,'Plan Cuentas 1','Plan Cuentas 1','1310002000','RENTAS',11,0,NULL),(2614,'Plan Cuentas 1','Plan Cuentas 1','1310001000','SEGUROS',11,0,NULL),(2613,'Plan Cuentas 1','Plan Cuentas 1','1310000000','PAGOS ANTICIPADOS',11,0,NULL),(2612,'Plan Cuentas 1','Plan Cuentas 1','1256000000','DEPRECIACION EQUIPO DE COMPUTO',11,0,NULL),(2611,'Plan Cuentas 1','Plan Cuentas 1','1254000000','DEPRECIACION EQUIPO DE TRANSPORTE',11,0,NULL),(2610,'Plan Cuentas 1','Plan Cuentas 1','1252000000','DEPRECIACION DE MOBILIARIO Y EQ. DE OFN',11,0,NULL),(2609,'Plan Cuentas 1','Plan Cuentas 1','1250000000','DEPRECIACION DE EDIFICIOS',11,0,NULL),(3382,'Plan Cuentas 3','Plan Cuentas 3','10300','CUENTA DE CHEQUES DE NOMINAS',10,0,NULL),(2608,'Plan Cuentas 1','Plan Cuentas 1','1245000000','EQUIPO DE OFICINA',11,0,NULL),(2607,'Plan Cuentas 1','Plan Cuentas 1','1240000000','EQUIPO DE COMPUTO',11,0,NULL),(2606,'Plan Cuentas 1','Plan Cuentas 1','1230000000','EQUIPO DE TRANSPORTE',11,0,NULL),(2605,'Plan Cuentas 1','Plan Cuentas 1','1220000000','EDIFICIOS',11,0,NULL),(2604,'Plan Cuentas 1','Plan Cuentas 1','1210000000','TERRENOS',11,0,NULL),(2603,'Plan Cuentas 1','Plan Cuentas 1','1190006000','APLICACION MENSUAL',10,0,NULL),(2602,'Plan Cuentas 1','Plan Cuentas 1','1190005000','EN COMPRAS DIVERSAS',10,0,NULL),(2601,'Plan Cuentas 1','Plan Cuentas 1','1190004000','EN COMPRA DE MATERIALES',10,0,NULL),(2600,'Plan Cuentas 1','Plan Cuentas 1','1190003000','EN IMPORTACIONES',10,0,NULL),(3381,'Plan Cuentas 3','Plan Cuentas 3','10230','WACHOVIA SWEEP ACCOUNT',10,0,NULL),(2599,'Plan Cuentas 1','Plan Cuentas 1','1190002000','SEGUROS Y FIANZAS',10,0,NULL),(2598,'Plan Cuentas 1','Plan Cuentas 1','1190001000','EN COMPRAS DE ACTIVO FIJO',10,0,NULL),(2597,'Plan Cuentas 1','Plan Cuentas 1','1190000000','IVA POR ACREDITAR',10,0,NULL),(2596,'Plan Cuentas 1','Plan Cuentas 1','1180002000','DOCUMENTOS VARIOS',10,0,NULL),(2595,'Plan Cuentas 1','Plan Cuentas 1','1180001000','LETRAS POR COBRAR',10,0,NULL),(2594,'Plan Cuentas 1','Plan Cuentas 1','1180000000','DOCUMENTOS POR COBRAR',10,0,NULL),(2593,'Plan Cuentas 1','Plan Cuentas 1','1172000000','FUNCIONARIOS Y EMPLEADOS',10,0,NULL),(3380,'Plan Cuentas 3','Plan Cuentas 3','10220','WACHOVIA ACCOUNT',10,0,NULL),(2592,'Plan Cuentas 1','Plan Cuentas 1','1170001000','DEUDORES VARIOS',10,0,NULL),(2591,'Plan Cuentas 1','Plan Cuentas 1','1170000000','DEUDORES DIVERSOS',10,0,NULL),(2590,'Plan Cuentas 1','Plan Cuentas 1','1160003000','ALMACEN DE PROD. TERMINADOS',10,0,NULL),(2589,'Plan Cuentas 1','Plan Cuentas 1','1160002000','ALMACEN DE PROD. EN PROCESO',10,0,NULL),(2588,'Plan Cuentas 1','Plan Cuentas 1','1160001000','ALMACEN DE MATERIALES',10,0,NULL),(2587,'Plan Cuentas 1','Plan Cuentas 1','1160000000','ALMACEN',10,0,NULL),(2586,'Plan Cuentas 1','Plan Cuentas 1','1155002000','CLIENTES ZONA ESTE',10,0,NULL),(2585,'Plan Cuentas 1','Plan Cuentas 1','1155001000','CLIENTES ZONA NORTE',10,0,NULL),(3379,'Plan Cuentas 3','Plan Cuentas 3','10210','CUENTA DE TARJETA DE CREDITO',10,0,NULL),(2584,'Plan Cuentas 1','Plan Cuentas 1','1155000000','CLIENTES NACIONALES',10,0,NULL),(2583,'Plan Cuentas 1','Plan Cuentas 1','1150003000','CLIENTES ZONA NORTE',10,0,NULL),(2582,'Plan Cuentas 1','Plan Cuentas 1','1150002000','CLIENTES ZONA SURESTE',10,0,NULL),(2581,'Plan Cuentas 1','Plan Cuentas 1','1150001000','CLIENTES ZONA SUR',10,0,NULL),(2580,'Plan Cuentas 1','Plan Cuentas 1','1150000000','CLIENTES  EXTRANJEROS',10,0,NULL),(2579,'Plan Cuentas 1','Plan Cuentas 1','1140001000','INVERSIONES CUENTA #',10,0,NULL),(2578,'Plan Cuentas 1','Plan Cuentas 1','1140000000','INVERSIONES EN VALORES',10,0,NULL),(2577,'Plan Cuentas 1','Plan Cuentas 1','1125002000','SANTANDER',10,0,NULL),(3378,'Plan Cuentas 3','Plan Cuentas 3','10200','CUENTA DE CHEQUES NORMALES',10,0,NULL),(2576,'Plan Cuentas 1','Plan Cuentas 1','1125001000','BANAMEX',10,0,NULL),(2575,'Plan Cuentas 1','Plan Cuentas 1','1125000000','BANCOS NACIONALES',10,0,NULL),(2574,'Plan Cuentas 1','Plan Cuentas 1','1120003000','BANAMEX',10,0,NULL),(2573,'Plan Cuentas 1','Plan Cuentas 1','1120002000','BITAL',10,0,NULL),(2572,'Plan Cuentas 1','Plan Cuentas 1','1120001000','BANCOMER',10,0,NULL),(2571,'Plan Cuentas 1','Plan Cuentas 1','1120000000','BANCOS  EXTRANJEROS',10,0,NULL),(2570,'Plan Cuentas 1','Plan Cuentas 1','1110002000','EFECTIVO',10,0,NULL),(2569,'Plan Cuentas 1','Plan Cuentas 1','1110001000','FONDO FIJO',10,0,NULL),(2568,'Plan Cuentas 1','Plan Cuentas 1','1110000000','CAJA',10,0,NULL),(2696,'Plan Cuentas 1','Plan Cuentas 1','6000034000','BOLETOS DE AVION',80,0,NULL),(2697,'Plan Cuentas 1','Plan Cuentas 1','6000035000','PASAJES Y TRANSPORTES LOCALES',80,0,NULL),(2698,'Plan Cuentas 1','Plan Cuentas 1','6000036000','GASTOS DE REPRESENTACION',80,0,NULL),(2699,'Plan Cuentas 1','Plan Cuentas 1','6000037000','COMIDAS CON EL PERSONAL',80,0,NULL),(2700,'Plan Cuentas 1','Plan Cuentas 1','6000038000','GASTOS DE FIN DE AÃ‘O',80,0,NULL),(2701,'Plan Cuentas 1','Plan Cuentas 1','6000039000','VIATICOS',80,0,NULL),(2702,'Plan Cuentas 1','Plan Cuentas 1','6000040000','FLETES',80,0,NULL),(2703,'Plan Cuentas 1','Plan Cuentas 1','6000041000','TELEFONOS',80,0,NULL),(2704,'Plan Cuentas 1','Plan Cuentas 1','6000042000','CORREOS',80,0,NULL),(2705,'Plan Cuentas 1','Plan Cuentas 1','6000043000','LUZ',80,0,NULL),(2706,'Plan Cuentas 1','Plan Cuentas 1','6000044000','DEPRECIACIONES',80,0,NULL),(2707,'Plan Cuentas 1','Plan Cuentas 1','6000045000','AMORTIZACION',80,0,NULL),(2708,'Plan Cuentas 1','Plan Cuentas 1','6000046000','COMBUSTIBLES Y LUBRICANTES',80,0,NULL),(2709,'Plan Cuentas 1','Plan Cuentas 1','6000095000','DIVERSOS',80,0,NULL),(2710,'Plan Cuentas 1','Plan Cuentas 1','7100000000','PRODUCTOS FINANCIEROS',90,0,NULL),(2711,'Plan Cuentas 1','Plan Cuentas 1','7100001000','INTERESES GANADOS EN INVERSIONES',90,0,NULL),(2712,'Plan Cuentas 1','Plan Cuentas 1','7100002000','INTERESES COBRADOS A CLIENTES',90,0,NULL),(2713,'Plan Cuentas 1','Plan Cuentas 1','7100003000','OTROS',90,0,NULL),(2714,'Plan Cuentas 1','Plan Cuentas 1','7200000000','OTROS PRODUCTOS',90,0,NULL),(2715,'Plan Cuentas 1','Plan Cuentas 1','7200001000','EN VENTAS DE ACTIVO FIJO',90,0,NULL),(2716,'Plan Cuentas 1','Plan Cuentas 1','7200002000','OTROS',90,0,NULL),(2717,'Plan Cuentas 1','Plan Cuentas 1','7500000000','GASTOS FINANCIEROS',90,0,NULL),(2718,'Plan Cuentas 1','Plan Cuentas 1','7500001000','INTERESES PAGADOS',90,0,NULL),(2719,'Plan Cuentas 1','Plan Cuentas 1','7500002000','COMISIONES Y SITUACIONES BANCARIAS',90,0,NULL),(2720,'Plan Cuentas 1','Plan Cuentas 1','7500003000','COMISIONES SOBRE CHEQUES DEVUELTOS',90,0,NULL),(2721,'Plan Cuentas 1','Plan Cuentas 1','7750000000','OTROS GASTOS',90,0,NULL),(2722,'Plan Cuentas 1','Plan Cuentas 1','7750001000','RESULTADO EN VENTA DE ACTIVO FIJO',90,0,NULL),(2723,'Plan Cuentas 1','Plan Cuentas 1','8000000000','ISR y PTU',90,0,NULL),(2724,'Plan Cuentas 1','Plan Cuentas 1','8000001000','ISR Y PTU',90,0,NULL),(2725,'Plan Cuentas 2','Plan Cuentas 2','100','CAPITAL SOCIAL',30,0,NULL),(2726,'Plan Cuentas 2','Plan Cuentas 2','101','FONDO SOCIAL',30,0,NULL),(2727,'Plan Cuentas 2','Plan Cuentas 2','102','CAPITAL',30,0,NULL),(2728,'Plan Cuentas 2','Plan Cuentas 2','10210','CUENTA DE TARJETA DE CREDITO',10,0,NULL),(2729,'Plan Cuentas 2','Plan Cuentas 2','103','SOCIOS POR DESEMBOLSOS NO EXIGIDOS',30,0,NULL),(2730,'Plan Cuentas 2','Plan Cuentas 2','103.4','SOCIOS POR DES. NO EXIGIDOS, CAP.PEND.IN',30,0,NULL),(2731,'Plan Cuentas 2','Plan Cuentas 2','104','SOCIOS POR APORT. NO DINERARIAS PTE',30,0,NULL),(2732,'Plan Cuentas 2','Plan Cuentas 2','104.4','SOCIOS POR APORT. NO DINER. PTE, C.P.I.',30,0,NULL),(2733,'Plan Cuentas 2','Plan Cuentas 2','108','ACCIONES O PARTICIP. PROPIAS EN SIT.ESP.',30,0,NULL),(2734,'Plan Cuentas 2','Plan Cuentas 2','109','ACCIONES O PARTICIP PROP PARA REDUC.CAP.',30,0,NULL),(2735,'Plan Cuentas 2','Plan Cuentas 2','110','PRIMA DE EMISION O ASUNCION',30,0,NULL),(2736,'Plan Cuentas 2','Plan Cuentas 2','112','RESERVA LEGAL',30,0,NULL),(2737,'Plan Cuentas 2','Plan Cuentas 2','113','RESERVAS VOLUNTARIAS',30,0,NULL),(2738,'Plan Cuentas 2','Plan Cuentas 2','114','RESERVAS ESPECIALES',30,0,NULL),(2739,'Plan Cuentas 2','Plan Cuentas 2','114.1','RESERVAS ESTATUTARIAS',30,0,NULL),(2740,'Plan Cuentas 2','Plan Cuentas 2','114.2','RESERVAS POR CAPITAL AMORTIZADO',30,0,NULL),(2741,'Plan Cuentas 2','Plan Cuentas 2','114.4','RESERVAS ACCIONES PROP. ACEPTADAS GARANT',30,0,NULL),(2742,'Plan Cuentas 2','Plan Cuentas 2','118','APORTACIONES DE SOCIOS O PROPIETARIOS',30,0,NULL),(2743,'Plan Cuentas 2','Plan Cuentas 2','119','DIFERENCIAS POR AJUSTE DE CAP. A EUROS',30,0,NULL),(2744,'Plan Cuentas 2','Plan Cuentas 2','120','REMANENTE',30,0,NULL),(2745,'Plan Cuentas 2','Plan Cuentas 2','121','RESULTADOS NEG. DE EJERCICIOS ANTERIORES',30,0,NULL),(2746,'Plan Cuentas 2','Plan Cuentas 2','129','RESULTADOS DEL EJERCICIO',30,0,NULL),(2747,'Plan Cuentas 2','Plan Cuentas 2','130','SUBVENCIONES OFICIALES DE CAPITAL',30,0,NULL),(2748,'Plan Cuentas 2','Plan Cuentas 2','13000','IVA Acreditable',10,0,NULL),(2749,'Plan Cuentas 2','Plan Cuentas 2','131','DONACIONES Y LEGADOS DE CAPITAL',30,0,NULL),(2750,'Plan Cuentas 2','Plan Cuentas 2','132','OTRAS SUBVENCIONES, DONACIONES Y LEGADOS',30,0,NULL),(2751,'Plan Cuentas 2','Plan Cuentas 2','137','INGRESOS FISCALES A DISTRIBUIR VARIOS EJ',30,0,NULL),(2752,'Plan Cuentas 2','Plan Cuentas 2','137.1','INGRESOS FISCALES DED/BON A DISTR V.E.',30,0,NULL),(2753,'Plan Cuentas 2','Plan Cuentas 2','141','PROVISION PARA IMPUESTOS',22,0,NULL),(2754,'Plan Cuentas 2','Plan Cuentas 2','142','PROVISION PARA OTRAS RESPONSABILIDADES',22,0,NULL),(2755,'Plan Cuentas 2','Plan Cuentas 2','143','PROVIS POR DESMANTELAM. RETIRO O REHA IN',22,0,NULL),(2756,'Plan Cuentas 2','Plan Cuentas 2','145','PROVISION PARA ACTUACIONES MEDIOAMBIEN.',22,0,NULL),(2757,'Plan Cuentas 2','Plan Cuentas 2','150','ACCIONES O PART. L/P CONS. PAS. FINANC.',22,0,NULL),(2758,'Plan Cuentas 2','Plan Cuentas 2','153','DESEMB NO EXIG. POR ACC/PART PASIV.FINAN',22,0,NULL),(2759,'Plan Cuentas 2','Plan Cuentas 2','153.3','DESEMB NO EXIGIDOS, E.G.',30,0,NULL),(2760,'Plan Cuentas 2','Plan Cuentas 2','153.4','DESEMB NO EXIGIDOS, E.A.',30,0,NULL),(2761,'Plan Cuentas 2','Plan Cuentas 2','153.5','DESEMB NO EXIGIDOS, O.P.V.',30,0,NULL),(2762,'Plan Cuentas 2','Plan Cuentas 2','153.6','OTROS DESEMBOLSOS NO EXIGIDOS',30,0,NULL),(2763,'Plan Cuentas 2','Plan Cuentas 2','154','APORT. NO DINER. PTES. ACC/PART PAS.FINA',22,0,NULL),(2764,'Plan Cuentas 2','Plan Cuentas 2','154.3','APORTACIONES NO DINERARIAS PEND., E.G.',30,0,NULL),(2765,'Plan Cuentas 2','Plan Cuentas 2','154.4','APORTACIONES NO DINERARIAS PEND., E.A.',30,0,NULL),(2766,'Plan Cuentas 2','Plan Cuentas 2','154.5','APORTACIONES NO DINERARIAS PEND., O.P.V.',30,0,NULL),(2767,'Plan Cuentas 2','Plan Cuentas 2','154.6','OTRAS APORTACIONES NO DINERARIAS PTES.',30,0,NULL),(2768,'Plan Cuentas 2','Plan Cuentas 2','160','DEUDAS A LARGO P. CON ENT. CRED. VINCUL.',22,0,NULL),(2769,'Plan Cuentas 2','Plan Cuentas 2','160.3','DEUDAS A LARGO P. CON ENT. CRED. EMP.GRU',30,0,NULL),(2770,'Plan Cuentas 2','Plan Cuentas 2','160.4','DEUDAS A LARGO P. CON ENT. CRED. EMP.VIN',30,0,NULL),(2771,'Plan Cuentas 2','Plan Cuentas 2','160.5','DEUDAS A LARGO P. CON OTR.ENT.CRED.VINC.',30,0,NULL),(2772,'Plan Cuentas 2','Plan Cuentas 2','161','PROVEEDORES INMOVILIZADO L.PLAZO PAR.VIN',22,0,NULL),(2773,'Plan Cuentas 2','Plan Cuentas 2','161.3','PROVEEDORES INMOVILIZADO L.PLAZO EMP.GRU',30,0,NULL),(2774,'Plan Cuentas 2','Plan Cuentas 2','161.4','PROVEEDORES INMOVILIZADO L.PLAZO EMP.ASO',30,0,NULL),(2775,'Plan Cuentas 2','Plan Cuentas 2','161.5','PROVEEDORES INMOVILIZADO L.PLAZO O.PAR.V',30,0,NULL),(2776,'Plan Cuentas 2','Plan Cuentas 2','162','ACREEDORES ARREND. FINANC. L/P P.V.',22,0,NULL),(2777,'Plan Cuentas 2','Plan Cuentas 2','162.3','ACREEDORES ARREND. FINANC. L/P E.G.',30,0,NULL),(2778,'Plan Cuentas 2','Plan Cuentas 2','162.4','ACREEDORES ARREND. FINANC. L/P E.A.',30,0,NULL),(2779,'Plan Cuentas 2','Plan Cuentas 2','162.5','ACREEDORES ARREND. FINANC. L/P O.P.V.',30,0,NULL),(2780,'Plan Cuentas 2','Plan Cuentas 2','163','OTRAS DEUDAS L/P CON PARTES VINCULADAS',22,0,NULL),(2781,'Plan Cuentas 2','Plan Cuentas 2','163.3','OTRAS DEUDAS L/P EMPRESAS DEL GRUPO',30,0,NULL),(2782,'Plan Cuentas 2','Plan Cuentas 2','163.4','OTRAS DEUDAS L/P EMPRESAS ASOCIADAS',30,0,NULL),(2783,'Plan Cuentas 2','Plan Cuentas 2','163.5','OTRAS DEUDAS L/P OTRAS PARTES VINCULADAS',30,0,NULL),(2784,'Plan Cuentas 2','Plan Cuentas 2','170','DEUDAS A LARGO P. CON ENTIDADES CREDITO',22,0,NULL),(2785,'Plan Cuentas 2','Plan Cuentas 2','171','DEUDAS A LARGO PLAZO',22,0,NULL),(2786,'Plan Cuentas 2','Plan Cuentas 2','172','DEUDAS L/P TRANSF. SUBV., DONAC. Y LEGAD',22,0,NULL),(2787,'Plan Cuentas 2','Plan Cuentas 2','173','PROVEEDORES INMOVILIZADO LARGO PLAZO',22,0,NULL),(2788,'Plan Cuentas 2','Plan Cuentas 2','174','ACREEDORES ARRENDAMIENTO FINANCIERO L/P',22,0,NULL),(2789,'Plan Cuentas 2','Plan Cuentas 2','175','EFECTOS A PAGAR A LARGO PLAZO',22,0,NULL),(2790,'Plan Cuentas 2','Plan Cuentas 2','176','PASIVOS DERIVADOS FINANCIEROS L/P',22,0,NULL),(2791,'Plan Cuentas 2','Plan Cuentas 2','177','OBLIGACIONES Y BONOS',22,0,NULL),(2792,'Plan Cuentas 2','Plan Cuentas 2','179','DEUDAS REPRES. EN OTROS VALORES NEGOCIA.',22,0,NULL),(2793,'Plan Cuentas 2','Plan Cuentas 2','180','FIANZAS RECIBIDAS A LARGO PLAZO',22,0,NULL),(2794,'Plan Cuentas 2','Plan Cuentas 2','181','ANTICIPOS RECIBIDOS POR VENTAS O PRESTAC',22,0,NULL),(2795,'Plan Cuentas 2','Plan Cuentas 2','185','DEPOSITOS RECIBIDOS A LARGO PLAZO',22,0,NULL),(2796,'Plan Cuentas 2','Plan Cuentas 2','190','ACCIONES O PARTICIPACIONES EMITIDAS',23,0,NULL),(2797,'Plan Cuentas 2','Plan Cuentas 2','192','SUSCRIPTORES DE ACCIONES',23,0,NULL),(2798,'Plan Cuentas 2','Plan Cuentas 2','194','CAPITAL EMITIDO PENDIENTE DE INSCRIPCION',23,0,NULL),(2799,'Plan Cuentas 2','Plan Cuentas 2','195','ACC/PARTIC EMITIDAS PASIVOS FINANCIEROS',23,0,NULL),(2800,'Plan Cuentas 2','Plan Cuentas 2','197','SUSCRIPTORES ACC. CONSIDER. PAS.FINANC.',23,0,NULL),(2801,'Plan Cuentas 2','Plan Cuentas 2','199','ACC/PARTIC EMITID. PAS.FINANC. PEND. INS',23,0,NULL),(2802,'Plan Cuentas 2','Plan Cuentas 2','200','INVESTIGACION',13,0,NULL),(2803,'Plan Cuentas 2','Plan Cuentas 2','201','DESARROLLO',13,0,NULL),(2804,'Plan Cuentas 2','Plan Cuentas 2','202','CONCESIONES ADMINISTRATIVAS',13,0,NULL),(2805,'Plan Cuentas 2','Plan Cuentas 2','203','PROPIEDAD INDUSTRIAL',13,0,NULL),(2806,'Plan Cuentas 2','Plan Cuentas 2','205','DERECHOS DE TRASPASO',13,0,NULL),(2807,'Plan Cuentas 2','Plan Cuentas 2','206','APLICACIONES INFORMATICAS',13,0,NULL),(2808,'Plan Cuentas 2','Plan Cuentas 2','209','ANTICIPOS PARA INMOV. INTANGIBLES',13,0,NULL),(2809,'Plan Cuentas 2','Plan Cuentas 2','210','TERRENOS Y BIENES NATURALES',11,0,NULL),(2810,'Plan Cuentas 2','Plan Cuentas 2','211','CONSTRUCCIONES',11,0,NULL),(2811,'Plan Cuentas 2','Plan Cuentas 2','212','INSTALACIONES TECNICAS',11,0,NULL),(2812,'Plan Cuentas 2','Plan Cuentas 2','213','MAQUINARIA',11,0,NULL),(2813,'Plan Cuentas 2','Plan Cuentas 2','214','UTILLAJE',11,0,NULL),(2814,'Plan Cuentas 2','Plan Cuentas 2','215','OTRAS INSTALACIONES',11,0,NULL),(2815,'Plan Cuentas 2','Plan Cuentas 2','216','MOBILIARIO',11,0,NULL),(2816,'Plan Cuentas 2','Plan Cuentas 2','217','EQUIPOS PARA PROCESOS DE INFORMACION',11,0,NULL),(2817,'Plan Cuentas 2','Plan Cuentas 2','218','ELEMENTOS DE TRANSPORTE',11,0,NULL),(2818,'Plan Cuentas 2','Plan Cuentas 2','219','OTRO INMOVILIZADO MATERIAL',11,0,NULL),(2819,'Plan Cuentas 2','Plan Cuentas 2','220','INVERSIONES TERRENOS Y BIENES NATURALES',11,0,NULL),(2820,'Plan Cuentas 2','Plan Cuentas 2','221','INVERSIONES EN CONSTRUCCIONES',11,0,NULL),(2821,'Plan Cuentas 2','Plan Cuentas 2','230','ADAPTACION DE TERRENOS Y BIENES NATUR.',11,0,NULL),(2822,'Plan Cuentas 2','Plan Cuentas 2','231','CONSTRUCCIONES EN CURSO',11,0,NULL),(2823,'Plan Cuentas 2','Plan Cuentas 2','232','INSTALACIONES TECNICAS EN MONTAJE',11,0,NULL),(2824,'Plan Cuentas 2','Plan Cuentas 2','233','MAQUINARIA EN MONTAJE',11,0,NULL),(2825,'Plan Cuentas 2','Plan Cuentas 2','237','EQUIPOS PARA PROCESOS DE INF. EN MONTAJE',11,0,NULL),(2826,'Plan Cuentas 2','Plan Cuentas 2','239','ANTICIPOS PARA INMOV. MATERIALES',11,0,NULL),(2827,'Plan Cuentas 2','Plan Cuentas 2','240','PARTICIP. A LARGO P. EN PARTES VINCULADA',11,0,NULL),(2828,'Plan Cuentas 2','Plan Cuentas 2','240.3','PARTICIP. A LARGO P. EN EMPRESAS GRUPO',13,0,NULL),(2829,'Plan Cuentas 2','Plan Cuentas 2','240.4','PARTICIP. A LARGO P. EN EMPRESAS ASOCIAD',13,0,NULL),(2830,'Plan Cuentas 2','Plan Cuentas 2','240.5','PARTICIP. A LARGO P. EN OTRAS PARTES VIN',13,0,NULL),(2831,'Plan Cuentas 2','Plan Cuentas 2','241','VALORES REPRES. DEUDAS LARGO P.PAR.VINC',11,0,NULL),(2832,'Plan Cuentas 2','Plan Cuentas 2','241.3','VALORES REPRES. DEUDAS LARGO P.EMP.GRU.',13,0,NULL),(2833,'Plan Cuentas 2','Plan Cuentas 2','241.4','VALORES REPRES. DEUDAS LARGO P.EMP.ASO.',13,0,NULL),(2834,'Plan Cuentas 2','Plan Cuentas 2','241.5','VALORES REPRES. DEUDAS LARGO P.O.P.VINC',13,0,NULL),(2835,'Plan Cuentas 2','Plan Cuentas 2','242','CREDITOS A L/P A P.V.',11,0,NULL),(2836,'Plan Cuentas 2','Plan Cuentas 2','242.3','CREDITOS A L/P A E.G.',13,0,NULL),(2837,'Plan Cuentas 2','Plan Cuentas 2','242.4','CREDITOS A L/P A E.A.',13,0,NULL),(2838,'Plan Cuentas 2','Plan Cuentas 2','242.5','CREDITOS A L/P A O.P.V.',13,0,NULL),(2839,'Plan Cuentas 2','Plan Cuentas 2','24810','Loans From Shareholder',23,0,NULL),(2840,'Plan Cuentas 2','Plan Cuentas 2','249','DESEMB PEND S/PARTICIP L/P EN P.V.',11,0,NULL),(2841,'Plan Cuentas 2','Plan Cuentas 2','249.3','DESEMB PEND S/PARTICIP L/P EN E.G.',13,0,NULL),(2842,'Plan Cuentas 2','Plan Cuentas 2','249.4','DESEMB PEND S/PARTICIP L/P EN E.A.',13,0,NULL),(2843,'Plan Cuentas 2','Plan Cuentas 2','249.5','DESEMB PEND S/PARTICIP L/P EN O.P.V.',13,0,NULL),(2844,'Plan Cuentas 2','Plan Cuentas 2','250','INVERSIONES FINAN A L.PLAZO INSTR.PATRIM',13,0,NULL),(2845,'Plan Cuentas 2','Plan Cuentas 2','251','VALORES REPRESENT. DE DEUDA LARGO PLAZO',13,0,NULL),(2846,'Plan Cuentas 2','Plan Cuentas 2','252','CREDITOS A LARGO PLAZO',13,0,NULL),(2847,'Plan Cuentas 2','Plan Cuentas 2','253','CREDITOS A L/P POR ENAJENACION DE INMOVI',13,0,NULL),(2848,'Plan Cuentas 2','Plan Cuentas 2','254','CREDITOS A LARGO PLAZO AL PERSONAL',13,0,NULL),(2849,'Plan Cuentas 2','Plan Cuentas 2','255','ACTIVOS POR DERIVADOS FINANCIEROS A L/P',13,0,NULL),(2850,'Plan Cuentas 2','Plan Cuentas 2','258','IMPOSICIONES A LARGO PLAZO',13,0,NULL),(2851,'Plan Cuentas 2','Plan Cuentas 2','259','DESEMB PEND S/PART PATRIMONIO NETO L/P',13,0,NULL),(2852,'Plan Cuentas 2','Plan Cuentas 2','260','FIANZAS CONSTITUIDAS A LARGO PLAZO',13,0,NULL),(2853,'Plan Cuentas 2','Plan Cuentas 2','265','DEPOSITOS CONSTITUIDOS A LARGO PLAZO',13,0,NULL),(2854,'Plan Cuentas 2','Plan Cuentas 2','280','AMORT. ACUM. DEL INMOVILIZADO INTANGIBLE',13,0,NULL),(2855,'Plan Cuentas 2','Plan Cuentas 2','280.1','AMORTIZACION ACUMULADA DE DESARROLLO',13,0,NULL),(2856,'Plan Cuentas 2','Plan Cuentas 2','280.2','AMORT. ACUM. DE CONCESIONES ADMINISTRAT.',13,0,NULL),(2857,'Plan Cuentas 2','Plan Cuentas 2','280.3','AMORT. ACUM. DE PROPIEDAD INDUSTRIAL',13,0,NULL),(2858,'Plan Cuentas 2','Plan Cuentas 2','280.5','AMORT. ACUM. DE DERECHOS DE TRASPASO',13,0,NULL),(2859,'Plan Cuentas 2','Plan Cuentas 2','280.6','AMORT. ACUM. DE APLICACIONES INFORMATIC.',13,0,NULL),(2860,'Plan Cuentas 2','Plan Cuentas 2','281','AMORT. ACUM. DEL INMOVILIZADO MATERIAL',13,0,NULL),(2861,'Plan Cuentas 2','Plan Cuentas 2','281.1','AMORTIZACION ACUMULADA DE CONSTRUCCIONES',13,0,NULL),(2862,'Plan Cuentas 2','Plan Cuentas 2','281.2','AMORT. ACUM. DE INSTALACIONES TECNICAS',13,0,NULL),(2863,'Plan Cuentas 2','Plan Cuentas 2','281.3','AMORTIZACION ACUMULADA DE MAQUINARIA',13,0,NULL),(2864,'Plan Cuentas 2','Plan Cuentas 2','281.4','AMORTIZACION ACUMULADA DE UTILLAJE',13,0,NULL),(2865,'Plan Cuentas 2','Plan Cuentas 2','281.5','AMORT. ACUM. DE OTRAS INSTALACIONES',13,0,NULL),(2866,'Plan Cuentas 2','Plan Cuentas 2','281.6','AMORTIZACION ACUMULADA DE MOBILIARIO',13,0,NULL),(2867,'Plan Cuentas 2','Plan Cuentas 2','281.7','AMORT. ACUM. DE EQUIPOS PARA PROC INFORM',13,0,NULL),(2868,'Plan Cuentas 2','Plan Cuentas 2','281.8','AMORT. ACUM. DE ELEMENTOS DE TRANSPORTE',13,0,NULL),(2869,'Plan Cuentas 2','Plan Cuentas 2','281.9','AMORT. ACUM. DE OTRO INMOVIL. MATERIAL',13,0,NULL),(2870,'Plan Cuentas 2','Plan Cuentas 2','282','AMORT. ACUM. DE INVERSIONES INMOBIL.',13,0,NULL),(2871,'Plan Cuentas 2','Plan Cuentas 2','290','DETER. DE VALOR INMOVILIZADO INTANGIBLE',13,0,NULL),(2872,'Plan Cuentas 2','Plan Cuentas 2','290.1','DETERIORO DE VALOR DE DESARROLLO',13,0,NULL),(2873,'Plan Cuentas 2','Plan Cuentas 2','290.2','DETERIORO DE VALOR DE CONCESIONES ADMIN.',13,0,NULL),(2874,'Plan Cuentas 2','Plan Cuentas 2','290.3','DETER. DE VALOR DE PROPIEDAD INDUSTRIAL',13,0,NULL),(2875,'Plan Cuentas 2','Plan Cuentas 2','290.5','DETERIORO DE VALOR DE DERECHOS TRASPASO',13,0,NULL),(2876,'Plan Cuentas 2','Plan Cuentas 2','290.6','DETERIORO DE VALOR DE APLIC INFORMATICAS',13,0,NULL),(2877,'Plan Cuentas 2','Plan Cuentas 2','291','DETER. DE VALOR INMOVILIZADO MATERIAL',13,0,NULL),(2878,'Plan Cuentas 2','Plan Cuentas 2','291.1','DETERIORO DE VALOR DE CONSTRUCCIONES',13,0,NULL),(2879,'Plan Cuentas 2','Plan Cuentas 2','291.2','DETERIORO DE VALOR DE INSTAL. TECNICAS',13,0,NULL),(2880,'Plan Cuentas 2','Plan Cuentas 2','291.3','DETERIORO DE VALOR DE MAQUINARIA',13,0,NULL),(2881,'Plan Cuentas 2','Plan Cuentas 2','291.4','DETERIORO DE VALOR DE UTILLAJE',13,0,NULL),(2882,'Plan Cuentas 2','Plan Cuentas 2','291.5','DETERIORO DE VALOR DE OTRAS INSTALAC.',13,0,NULL),(2883,'Plan Cuentas 2','Plan Cuentas 2','291.6','DETERIORO DE VALOR DE MOBILIARIO',13,0,NULL),(2884,'Plan Cuentas 2','Plan Cuentas 2','291.7','DETERIORO DE VALOR DE EQUIP PROCESOS INF',13,0,NULL),(2885,'Plan Cuentas 2','Plan Cuentas 2','291.8','DETERIORO DE VALOR DE ELEM. TRANSPORTE',13,0,NULL),(2886,'Plan Cuentas 2','Plan Cuentas 2','291.9','DETERIORO DE VALOR OTRO INMOVILIZADO MAT',13,0,NULL),(2887,'Plan Cuentas 2','Plan Cuentas 2','292','DETERIORO DE VALOR INVERS INMOBILIARIAS',13,0,NULL),(2888,'Plan Cuentas 2','Plan Cuentas 2','292.1','DETERIORO DE VALOR DE CONSTRUCCIONES',13,0,NULL),(2889,'Plan Cuentas 2','Plan Cuentas 2','293','DETER. VALOR PARTIC. A/L PARTES VINCULAD',13,0,NULL),(2890,'Plan Cuentas 2','Plan Cuentas 2','293.3','DETER. VALOR PARTIC. A/L EMP. DEL GRUPO',13,0,NULL),(2891,'Plan Cuentas 2','Plan Cuentas 2','293.4','DETER. VALOR PARTIC. A/L EMP. ASOCIADAS',13,0,NULL),(2892,'Plan Cuentas 2','Plan Cuentas 2','293.5','DETER. VALOR PARTIC. A/L OTRAS PARTES VI',13,0,NULL),(2893,'Plan Cuentas 2','Plan Cuentas 2','294','DETER. V/V REPRES. DEUDAS A/C PAR.VIN.',13,0,NULL),(2894,'Plan Cuentas 2','Plan Cuentas 2','294.3','DETER. V/V REPRES. DEUDAS A/L EMP.GRUP',13,0,NULL),(2895,'Plan Cuentas 2','Plan Cuentas 2','294.4','DETER. V/V REPRES. DEUDAS A/L EMP.ASOC',13,0,NULL),(2896,'Plan Cuentas 2','Plan Cuentas 2','294.5','DETER. V/V REPRES. DEUDAS A/L OTR.P.V.',13,0,NULL),(2897,'Plan Cuentas 2','Plan Cuentas 2','295','DETERIORO DE VALOR DE CRED A L/P A P.V.',13,0,NULL),(2898,'Plan Cuentas 2','Plan Cuentas 2','295.3','DETERIORO DE VALOR DE CRED A L/P A E.G.',13,0,NULL),(2899,'Plan Cuentas 2','Plan Cuentas 2','295.4','DETERIORO DE VALOR DE CRED A L/P A E.A.',13,0,NULL),(2900,'Plan Cuentas 2','Plan Cuentas 2','295.5','DETERIORO DE VALOR DE CRED A L/P A O.P.V',13,0,NULL),(2901,'Plan Cuentas 2','Plan Cuentas 2','296','DETER. VALOR PARTIC. EN PATRIM.NETO L.P.',13,0,NULL),(2902,'Plan Cuentas 2','Plan Cuentas 2','297','DETERIORO DE VALOR DE VAL.REP. DEUDA L.P',13,0,NULL),(2903,'Plan Cuentas 2','Plan Cuentas 2','298','DETERIORO DE VALOR DE CREDITOS A L/P',13,0,NULL),(2904,'Plan Cuentas 2','Plan Cuentas 2','300','MERCADERIAS A',10,0,NULL),(2905,'Plan Cuentas 2','Plan Cuentas 2','301','MERCADERIAS B',10,0,NULL),(2906,'Plan Cuentas 2','Plan Cuentas 2','310','MATERIAS PRIMAS A',10,0,NULL),(2907,'Plan Cuentas 2','Plan Cuentas 2','311','MATERIAS PRIMAS B',10,0,NULL),(2908,'Plan Cuentas 2','Plan Cuentas 2','320','ELEMENTOS Y CONJUNTOS INCORPORABLES',10,0,NULL),(2909,'Plan Cuentas 2','Plan Cuentas 2','321','COMBUSTIBLES',10,0,NULL),(2910,'Plan Cuentas 2','Plan Cuentas 2','322','REPUESTOS',10,0,NULL),(2911,'Plan Cuentas 2','Plan Cuentas 2','325','MATERIALES DIVERSOS',10,0,NULL),(2912,'Plan Cuentas 2','Plan Cuentas 2','326','EMBALAJES',10,0,NULL),(2913,'Plan Cuentas 2','Plan Cuentas 2','327','ENVASES',10,0,NULL),(2914,'Plan Cuentas 2','Plan Cuentas 2','328','MATERIAL DE OFICINA',10,0,NULL),(2915,'Plan Cuentas 2','Plan Cuentas 2','330','PRODUCTOS EN CURSO A',10,0,NULL),(2916,'Plan Cuentas 2','Plan Cuentas 2','331','PRODUCTOS EN CURSO B',10,0,NULL),(2917,'Plan Cuentas 2','Plan Cuentas 2','340','PRODUCTOS SEMITERMINADOS A',10,0,NULL),(2918,'Plan Cuentas 2','Plan Cuentas 2','341','PRODUCTOS SEMITERMINADOS B',10,0,NULL),(2919,'Plan Cuentas 2','Plan Cuentas 2','350','PRODUCTOS TERMINADOS A',10,0,NULL),(2920,'Plan Cuentas 2','Plan Cuentas 2','351','PRODUCTOS TERMINADOS B',10,0,NULL),(2921,'Plan Cuentas 2','Plan Cuentas 2','360','SUBPRODUCTOS A',10,0,NULL),(2922,'Plan Cuentas 2','Plan Cuentas 2','361','SUBPRODUCTOS B',10,0,NULL),(2923,'Plan Cuentas 2','Plan Cuentas 2','365','RESIDUOS A',10,0,NULL),(2924,'Plan Cuentas 2','Plan Cuentas 2','366','RESIDUOS B',10,0,NULL),(2925,'Plan Cuentas 2','Plan Cuentas 2','368','MATERIALES RECUPERADOS A',10,0,NULL),(2926,'Plan Cuentas 2','Plan Cuentas 2','369','MATERIALES RECUPERADOS B',10,0,NULL),(2927,'Plan Cuentas 2','Plan Cuentas 2','390','DETERIORO DE VALOR DE LAS MERCADERIAS',10,0,NULL),(2928,'Plan Cuentas 2','Plan Cuentas 2','391','DETERIORO DE VALOR MATERIAS PRIMAS',10,0,NULL),(2929,'Plan Cuentas 2','Plan Cuentas 2','392','DETERIORO DE VALOR DE OTROS APROVISIONAM',10,0,NULL),(2930,'Plan Cuentas 2','Plan Cuentas 2','393','DETERIORO DE VALOR DE PRODTOS EN CURSO',10,0,NULL),(2931,'Plan Cuentas 2','Plan Cuentas 2','394','DETERIORO DE VALOR DE PRODTOS SEMITERMIN',10,0,NULL),(2932,'Plan Cuentas 2','Plan Cuentas 2','395','DETERIORO DE VALOR DE PRODTOS TERMINADOS',10,0,NULL),(2933,'Plan Cuentas 2','Plan Cuentas 2','396','DETERIORO DE VALOR SUBPROD. RESID. M.REC',10,0,NULL),(2934,'Plan Cuentas 2','Plan Cuentas 2','400','PROVEEDORES',21,0,NULL),(2935,'Plan Cuentas 2','Plan Cuentas 2','400.4','PROVEEDORES (MONEDA EXTRANJERA)',13,0,NULL),(2936,'Plan Cuentas 2','Plan Cuentas 2','400.9','PROVEEDORES, FACTURAS PEND. RECIB. O FOR',13,0,NULL),(2937,'Plan Cuentas 2','Plan Cuentas 2','401','PROVEEDORES, EFECTOS COMERCIALES A PAGAR',21,0,NULL),(2938,'Plan Cuentas 2','Plan Cuentas 2','403','PROVEEDORES, EMPRESAS DEL GRUPO',21,0,NULL),(2939,'Plan Cuentas 2','Plan Cuentas 2','403.1','EFECTOS COMERCIALES A PAGAR. EMP.GRU.',13,0,NULL),(2940,'Plan Cuentas 2','Plan Cuentas 2','403.4','PROVEEDORES, EMPRESAS DEL GRUP (MON EXT)',13,0,NULL),(2941,'Plan Cuentas 2','Plan Cuentas 2','403.6','ENVASES Y EMB. A DEVOL. A PROVEED. E.G.',13,0,NULL),(2942,'Plan Cuentas 2','Plan Cuentas 2','403.9','PROV., E.G. FACT. PEND. RECIB O FORM.',13,0,NULL),(2943,'Plan Cuentas 2','Plan Cuentas 2','404','PROVEEDORES, EMPRESAS ASOCIADAS',21,0,NULL),(2944,'Plan Cuentas 2','Plan Cuentas 2','405','PROVEEDORES, OTRAS PARTES VINCULADAS',21,0,NULL),(2945,'Plan Cuentas 2','Plan Cuentas 2','406','ENVASES Y EMB. A DEVOL. A PROVEEDORES',21,0,NULL),(2946,'Plan Cuentas 2','Plan Cuentas 2','407','ANTICIPOS A PROVEEDORES',21,0,NULL),(2947,'Plan Cuentas 2','Plan Cuentas 2','410','ACREEDORES POR PRESTACIONES DE SERVICIOS',21,0,NULL),(2948,'Plan Cuentas 2','Plan Cuentas 2','410.4','ACREED. POR PRESTAC. DE SERV (MON.EXTR)',13,0,NULL),(2949,'Plan Cuentas 2','Plan Cuentas 2','410.9','ACREED. PREST. DE SERV, FAC.PTE.REC FORM',13,0,NULL),(2950,'Plan Cuentas 2','Plan Cuentas 2','411','ACREEDORES, EFECTOS COMERCIALES A PAGAR',21,0,NULL),(2951,'Plan Cuentas 2','Plan Cuentas 2','419','ACREEDORES POR OPERACIONES EN COMUN',21,0,NULL),(2952,'Plan Cuentas 2','Plan Cuentas 2','430','CLIENTES',10,0,NULL),(2953,'Plan Cuentas 2','Plan Cuentas 2','430.4','CLIENTES, (MONEDA EXTRANJERA)',13,0,NULL),(2954,'Plan Cuentas 2','Plan Cuentas 2','430.9','CLIENTES, FACTURAS PEND. DE FORMALIZAR',13,0,NULL),(2955,'Plan Cuentas 2','Plan Cuentas 2','431','CLIENTES, EFECTOS COMERCIALES A COBRAR',10,0,NULL),(2956,'Plan Cuentas 2','Plan Cuentas 2','431.1','EFECTOS COMERCIALES DESCONTADOS',13,0,NULL),(2957,'Plan Cuentas 2','Plan Cuentas 2','431.2','EFECTOS COMERCIALES EN GESTION DE COBRO',13,0,NULL),(2958,'Plan Cuentas 2','Plan Cuentas 2','431.5','EFECTOS COMERCIALES IMPAGADOS',13,0,NULL),(2959,'Plan Cuentas 2','Plan Cuentas 2','432','CLIENTES, OPERACIONES DE FACTORING',10,0,NULL),(2960,'Plan Cuentas 2','Plan Cuentas 2','433','CLIENTES, EMPRESAS DEL GRUPO',10,0,NULL),(2961,'Plan Cuentas 2','Plan Cuentas 2','433.1','EFECTOS COMERCIALES A COBRAR. EMP.GRU.',13,0,NULL),(2962,'Plan Cuentas 2','Plan Cuentas 2','433.2','CLIENTES E.G. OPERACIONES DE FACTORING',13,0,NULL),(2963,'Plan Cuentas 2','Plan Cuentas 2','433.4','CLIENTES E.G. (MONEDA EXTRANJERA)',13,0,NULL),(2964,'Plan Cuentas 2','Plan Cuentas 2','433.6','CLIENTES EMPRESAS DEL GRUPO DUDOSO COBRO',13,0,NULL),(2965,'Plan Cuentas 2','Plan Cuentas 2','433.7','ENVASES Y EMBALAJES DEVOLVER CLI. E.G.',13,0,NULL),(2966,'Plan Cuentas 2','Plan Cuentas 2','433.9','CLIENTES E.G., FACTURAS PEND. FORMALIZAR',13,0,NULL),(2967,'Plan Cuentas 2','Plan Cuentas 2','434','CLIENTES, EMPRESAS ASOCIADAS',10,0,NULL),(2968,'Plan Cuentas 2','Plan Cuentas 2','435','CLIENTES, OTRAS PARTES VINCULADAS',10,0,NULL),(2969,'Plan Cuentas 2','Plan Cuentas 2','436','CLIENTES DE DUDOSO COBRO',10,0,NULL),(2970,'Plan Cuentas 2','Plan Cuentas 2','437','ENVASES Y EMB. A DEVOL. POR CLIENTES',10,0,NULL),(2971,'Plan Cuentas 2','Plan Cuentas 2','438','ANTICIPOS DE CLIENTES',21,0,NULL),(2972,'Plan Cuentas 2','Plan Cuentas 2','440','DEUDORES',10,0,NULL),(2973,'Plan Cuentas 2','Plan Cuentas 2','440.4','DEUDORES (MONEDA EXTRANJERA)',13,0,NULL),(2974,'Plan Cuentas 2','Plan Cuentas 2','440.9','DEUDORES, FACTURAS PTES. DE FORMALIZAR',13,0,NULL),(2975,'Plan Cuentas 2','Plan Cuentas 2','441','DEUDORES, EFECTOS COMERCIALES A COBRAR',10,0,NULL),(2976,'Plan Cuentas 2','Plan Cuentas 2','441.1','DEUDORES, EFECTOS COM. DESCONTADOS',13,0,NULL),(2977,'Plan Cuentas 2','Plan Cuentas 2','441.2','DEUDORES, EFECTOS COM. GEST. COBRO',13,0,NULL),(2978,'Plan Cuentas 2','Plan Cuentas 2','441.5','DEUDORES, EFECTOS COMERCIALES IMPAGADOS',13,0,NULL),(2979,'Plan Cuentas 2','Plan Cuentas 2','446','DEUDORES DE DUDOSO COBRO',10,0,NULL),(2980,'Plan Cuentas 2','Plan Cuentas 2','449','DEUDORES POR OPERACIONES EN COMUN',10,0,NULL),(2981,'Plan Cuentas 2','Plan Cuentas 2','460','ANTICIPOS DE REMUNERACIONES',10,0,NULL),(2982,'Plan Cuentas 2','Plan Cuentas 2','465','REMUNERACIONES PENDIENTES DE PAGO',21,0,NULL),(2983,'Plan Cuentas 2','Plan Cuentas 2','470','HACIENDA PUBLICA, DEUDORA POR DIVER. CON',10,0,NULL),(2984,'Plan Cuentas 2','Plan Cuentas 2','470.8','HACIENDA PUBLICA, POR SUBVEN. CONCEDIDAS',13,0,NULL),(2985,'Plan Cuentas 2','Plan Cuentas 2','470.9','HACIENDA PUBLICA, DEUDORA POR DEV. IMPU.',13,0,NULL),(2986,'Plan Cuentas 2','Plan Cuentas 2','471','ORGANISMOS DE LA SEG.SOCIAL, DEUDORES',10,0,NULL),(2987,'Plan Cuentas 2','Plan Cuentas 2','472','HACIENDA PUBLICA, IVA SOPORTADO',10,0,NULL),(2988,'Plan Cuentas 2','Plan Cuentas 2','473','HACIENDA PUBLICA, RETENCION. Y PAGOS A/C',10,0,NULL),(2989,'Plan Cuentas 2','Plan Cuentas 2','474','ACTIVOS POR IMPUESTO DIFERIDO',10,0,NULL),(2990,'Plan Cuentas 2','Plan Cuentas 2','474.2','DERECHOS POR DEDUD Y BONIF PEND APLICAR',13,0,NULL),(2991,'Plan Cuentas 2','Plan Cuentas 2','474.5','CRED. POR PERDIDAS A COMPENSAR DEL EJER.',13,0,NULL),(2992,'Plan Cuentas 2','Plan Cuentas 2','475','HAC. PUB. ACREEEDORA POR CONC. FISCALES',21,0,NULL),(2993,'Plan Cuentas 2','Plan Cuentas 2','475.1','HACIENDA PUBLICA, ACREEDORA RET. PRACTI.',13,0,NULL),(2994,'Plan Cuentas 2','Plan Cuentas 2','475.2','HAC. PUB. ACREEEDORA POR IMP. SOBRE SOC.',13,0,NULL),(2995,'Plan Cuentas 2','Plan Cuentas 2','475.8','HACIENDA PUBLICA, ACREEDORA SUBVEN.REINT',13,0,NULL),(2996,'Plan Cuentas 2','Plan Cuentas 2','476','ORGANISMOS DE LA SEG.SOCIAL, ACREEDORES',21,0,NULL),(2997,'Plan Cuentas 2','Plan Cuentas 2','477','HACIENDA PUBLICA, IVA REPERCUTIDO',21,0,NULL),(2998,'Plan Cuentas 2','Plan Cuentas 2','479','PASIVOS POR DIFERENCIAS TEMPORARIAS IMP.',30,0,NULL),(2999,'Plan Cuentas 2','Plan Cuentas 2','480','GASTOS ANTICIPADOS',10,0,NULL),(3000,'Plan Cuentas 2','Plan Cuentas 2','485','INGRESOS ANTICIPADOS',10,0,NULL),(3001,'Plan Cuentas 2','Plan Cuentas 2','490','DETERIORO DE VALOR DE CRED POR OPER.COM.',10,0,NULL),(3002,'Plan Cuentas 2','Plan Cuentas 2','493','DETERIORO DE VALOR DE CRED OPER COM P.V.',10,0,NULL),(3003,'Plan Cuentas 2','Plan Cuentas 2','493.3','DETERIORO DE VALOR DE CRED OPER COM E.G.',13,0,NULL),(3004,'Plan Cuentas 2','Plan Cuentas 2','493.4','DETERIORO DE VALOR DE CRED OPER COM E.A.',13,0,NULL),(3005,'Plan Cuentas 2','Plan Cuentas 2','493.5','DETERIORO DE VALOR DE CRED OPER COM O.PV',13,0,NULL),(3006,'Plan Cuentas 2','Plan Cuentas 2','499','PROVISIONES POR OPERACIONES COMERCIALES',10,0,NULL),(3007,'Plan Cuentas 2','Plan Cuentas 2','499.4','PROVISION POR CONTRATOS ONEROSOS',13,0,NULL),(3008,'Plan Cuentas 2','Plan Cuentas 2','499.9','PROVISION PARA OTRAS OPERACIONES COMERC.',13,0,NULL),(3009,'Plan Cuentas 2','Plan Cuentas 2','500','OBLIGACIONES Y BONOS A CORTO PLAZO',21,0,NULL),(3010,'Plan Cuentas 2','Plan Cuentas 2','502','ACC. O PARTICIP. A C/P CONSID PAS.FINANC',21,0,NULL),(3011,'Plan Cuentas 2','Plan Cuentas 2','505','DEUDAS REPRES. EN OTROS VAL.NEG. C.PLAZO',21,0,NULL),(3012,'Plan Cuentas 2','Plan Cuentas 2','506','INTERESES C/P DE EMPRES. Y OT. EMIS.ANAL',21,0,NULL),(3013,'Plan Cuentas 2','Plan Cuentas 2','507','DIVIDENDOS ACC/PART CONSID. PAS.FINANC.',21,0,NULL),(3014,'Plan Cuentas 2','Plan Cuentas 2','509','VALORES NEGOCIABLES AMORTIZADOS',21,0,NULL),(3015,'Plan Cuentas 2','Plan Cuentas 2','509.5','OTROS VALORES NEGOCIABLES AMORTIZADOS',21,0,NULL),(3016,'Plan Cuentas 2','Plan Cuentas 2','510','DEUDAS CORTO PLAZO ENTIDADES CREDITO VIN',21,0,NULL),(3017,'Plan Cuentas 2','Plan Cuentas 2','510.3','DEUDAS CORTO PLAZO ENTIDADES CREDITO E.G',21,0,NULL),(3018,'Plan Cuentas 2','Plan Cuentas 2','510.4','DEUDAS CORTO PLAZO ENTIDADES CREDITO E.A',21,0,NULL),(3019,'Plan Cuentas 2','Plan Cuentas 2','510.5','DEUDAS CORTO PLAZO OTRAS ENT.CRED. VINC.',21,0,NULL),(3020,'Plan Cuentas 2','Plan Cuentas 2','511','PROVEEDORES INMOVILIZADO C.PLAZO PAR.VIN',21,0,NULL),(3021,'Plan Cuentas 2','Plan Cuentas 2','511.3','PROVEEDORES INMOVILIZADO C.PLAZO EMP.GRU',21,0,NULL),(3022,'Plan Cuentas 2','Plan Cuentas 2','511.4','PROVEEDORES INMOVILIZADO C.PLAZO EMP.ASO',21,0,NULL),(3023,'Plan Cuentas 2','Plan Cuentas 2','511.5','PROVEEDORES INMOVILIZADO C.PLAZO O.PAR.V',21,0,NULL),(3024,'Plan Cuentas 2','Plan Cuentas 2','512','ACREEDORES ARRENDA. FINANC. C/P, P.V.',21,0,NULL),(3025,'Plan Cuentas 2','Plan Cuentas 2','512.3','ACREEDORES ARRENDA. FINANC. C/P, E.G.',21,0,NULL),(3026,'Plan Cuentas 2','Plan Cuentas 2','512.4','ACREEDORES ARRENDA. FINANC. C/P, E.A.',21,0,NULL),(3027,'Plan Cuentas 2','Plan Cuentas 2','512.5','ACREEDORES ARRENDA. FINANC. C/P, O.P.V.',21,0,NULL),(3028,'Plan Cuentas 2','Plan Cuentas 2','513','OTRAS DEUDAS A CORTO PLAZO PARTES VINCUL',21,0,NULL),(3029,'Plan Cuentas 2','Plan Cuentas 2','513.3','OTRAS DEUDAS A CORTO PLAZO EMP. GRUPO',21,0,NULL),(3030,'Plan Cuentas 2','Plan Cuentas 2','513.4','OTRAS DEUDAS A CORTO PLAZO EMP. ASOCIAD.',21,0,NULL),(3031,'Plan Cuentas 2','Plan Cuentas 2','513.5','OTRAS DEUDAS A CORTO PLAZO OTRAS PART.VI',21,0,NULL),(3032,'Plan Cuentas 2','Plan Cuentas 2','514','INTERESES A CORTO P. PARTES VINCULADAS',21,0,NULL),(3033,'Plan Cuentas 2','Plan Cuentas 2','514.3','INTERESES A CORTO P. EMPRESAS DEL GRUPO',21,0,NULL),(3034,'Plan Cuentas 2','Plan Cuentas 2','514.4','INTERESES A CORTO P. EMPRESAS ASOCIADAS',21,0,NULL),(3035,'Plan Cuentas 2','Plan Cuentas 2','514.5','INTERESES A CORTO P. OTRAS PART. VINCUL.',21,0,NULL),(3036,'Plan Cuentas 2','Plan Cuentas 2','520','DEUDAS CORTO PLAZO ENTIDADES CREDITO',21,0,NULL),(3037,'Plan Cuentas 2','Plan Cuentas 2','520.1','DEUDAS CORTO PLAZO POR CREDITO DISPUESTO',21,0,NULL),(3038,'Plan Cuentas 2','Plan Cuentas 2','520.8','DEUDAS POR EFECTOS DESCONTADOS',21,0,NULL),(3039,'Plan Cuentas 2','Plan Cuentas 2','520.9','\"DEUDAS POR OPERACIONES DE \"\"FACTORING\"\"\"',21,0,NULL),(3040,'Plan Cuentas 2','Plan Cuentas 2','521','DEUDAS A CORTO PLAZO',21,0,NULL),(3041,'Plan Cuentas 2','Plan Cuentas 2','522','DEUDAS C/P TRANSF. SUBV, DONAC. Y LEGAD.',21,0,NULL),(3042,'Plan Cuentas 2','Plan Cuentas 2','523','PROVEEDORES INMOVILIZADO CORTO PLAZO',21,0,NULL),(3043,'Plan Cuentas 2','Plan Cuentas 2','524','ACREEDORES ARRENDAMIENTO FINANCIERO C/P',21,0,NULL),(3044,'Plan Cuentas 2','Plan Cuentas 2','525','EFECTOS A PAGAR A CORTO PLAZO',21,0,NULL),(3045,'Plan Cuentas 2','Plan Cuentas 2','526','DIVIDENDO ACTIVO A PAGAR',21,0,NULL),(3046,'Plan Cuentas 2','Plan Cuentas 2','527','INTERESES A C/P DE DEUDAS CON ENT. CRED.',21,0,NULL),(3047,'Plan Cuentas 2','Plan Cuentas 2','528','INTERESES A CORTO PLAZO DE DEUDAS',21,0,NULL),(3048,'Plan Cuentas 2','Plan Cuentas 2','529','PROVISIONES A CORTO PLAZO',21,0,NULL),(3049,'Plan Cuentas 2','Plan Cuentas 2','529.1','PROVISION A CORTO PLAZO PARA IMPUESTOS',21,0,NULL),(3050,'Plan Cuentas 2','Plan Cuentas 2','529.2','PROVISION A CORTO PLAZO PARA OTRAS REP',21,0,NULL),(3051,'Plan Cuentas 2','Plan Cuentas 2','529.3','PROVISION C/P DESMANT. RETIR O REHAB INM',21,0,NULL),(3052,'Plan Cuentas 2','Plan Cuentas 2','529.5','PROVISION C/P PARA ACTUACIONES MEDIOAMB.',21,0,NULL),(3053,'Plan Cuentas 2','Plan Cuentas 2','530','PARTICIP. A CORTO P. EN PARTES VINCULADA',10,0,NULL),(3054,'Plan Cuentas 2','Plan Cuentas 2','530.3','PARTICIP. A CORTO P. EN EMPRESAS GRUPO',21,0,NULL),(3055,'Plan Cuentas 2','Plan Cuentas 2','530.4','PARTICIP. A CORTO P. EN EMPRESAS ASOCIAD',21,0,NULL),(3056,'Plan Cuentas 2','Plan Cuentas 2','530.5','PARTICIP. A CORTO P. EN OTRAS PARTES VIN',21,0,NULL),(3057,'Plan Cuentas 2','Plan Cuentas 2','531','VALORES REPRES. DEUDAS CORTO P. PAR.VINC',10,0,NULL),(3058,'Plan Cuentas 2','Plan Cuentas 2','531.3','VALORES REPRES. DEUDAS CORTO P. EMP.GRU',21,0,NULL),(3059,'Plan Cuentas 2','Plan Cuentas 2','531.4','VALORES REPRES. DEUDAS CORTO P. EMP.ASO.',21,0,NULL),(3060,'Plan Cuentas 2','Plan Cuentas 2','531.5','VALORES REPRES. DEUDAS CORTO P. O.P.VINC',21,0,NULL),(3061,'Plan Cuentas 2','Plan Cuentas 2','532','CREDITOS A C/P. A P.V.',10,0,NULL),(3062,'Plan Cuentas 2','Plan Cuentas 2','532.3','CREDITOS A C/P A E.G.',21,0,NULL),(3063,'Plan Cuentas 2','Plan Cuentas 2','532.4','CREDITOS A C/P A E.A.',21,0,NULL),(3064,'Plan Cuentas 2','Plan Cuentas 2','532.5','CREDITOS A C/P A O.P.V.',21,0,NULL),(3065,'Plan Cuentas 2','Plan Cuentas 2','533','INTERESES C/P VAL. REPRES. DEUDA P.V.',10,0,NULL),(3066,'Plan Cuentas 2','Plan Cuentas 2','533.3','INTERESES C/P VAL. REPRES. DEUDA E.G.',21,0,NULL),(3067,'Plan Cuentas 2','Plan Cuentas 2','533.4','INTERESES C/P VAL. REPRES. DEUDA E.A.',21,0,NULL),(3068,'Plan Cuentas 2','Plan Cuentas 2','533.5','INTERESES C/P VAL. REPRES. DEUDA O.P.V.',21,0,NULL),(3069,'Plan Cuentas 2','Plan Cuentas 2','534','INTERESES A CORTO P. DE CREDITOS A P.V.',10,0,NULL),(3070,'Plan Cuentas 2','Plan Cuentas 2','534.3','INTERESES A CORTO P. DE CREDITOS A E.G.',21,0,NULL),(3071,'Plan Cuentas 2','Plan Cuentas 2','534.4','INTERESES A CORTO P. DE CREDITOS A E.A.',21,0,NULL),(3072,'Plan Cuentas 2','Plan Cuentas 2','534.5','INTERESES A CORTO P. DE CREDITOS A O.P.V',21,0,NULL),(3073,'Plan Cuentas 2','Plan Cuentas 2','535','DIVIDENDO A COBRAR INV. FINANC. P.V.',10,0,NULL),(3074,'Plan Cuentas 2','Plan Cuentas 2','535.3','DIVIDENDO A COBRAR DE EMPRESAS DE GRUPO',21,0,NULL),(3075,'Plan Cuentas 2','Plan Cuentas 2','535.4','DIVIDENDO A COBRAR DE EMRPESAS ASOCIADAS',21,0,NULL),(3076,'Plan Cuentas 2','Plan Cuentas 2','535.5','DIVIDENDO A COBRAR DE OTRAS PARTES VINC.',21,0,NULL),(3077,'Plan Cuentas 2','Plan Cuentas 2','539','DESEMB PEND S/PARTICIP C/P DE P.V.',10,0,NULL),(3078,'Plan Cuentas 2','Plan Cuentas 2','539.3','DESEMB PEND S/PARTICIP C/P EN E.G.',21,0,NULL),(3079,'Plan Cuentas 2','Plan Cuentas 2','539.4','DESEMB PEND S/PARTICIP C/P EN E.A.',21,0,NULL),(3080,'Plan Cuentas 2','Plan Cuentas 2','539.5','DESEMB PEND S/PARTICIP C/P EN O.P.V.',21,0,NULL),(3081,'Plan Cuentas 2','Plan Cuentas 2','540','INVERSIONES FINANC. A C/P INSTR. PATRIM',10,0,NULL),(3082,'Plan Cuentas 2','Plan Cuentas 2','541','VALORES REPRESENT. DE DEUDAS CORTO PLAZO',10,0,NULL),(3083,'Plan Cuentas 2','Plan Cuentas 2','542','CREDITOS A CORTO PLAZO',10,0,NULL),(3084,'Plan Cuentas 2','Plan Cuentas 2','543','CREDITOS A C/P POR ENAJENACION DE INMOVI',10,0,NULL),(3085,'Plan Cuentas 2','Plan Cuentas 2','544','CREDITOS A CORTO PLAZO AL PERSONAL',10,0,NULL),(3086,'Plan Cuentas 2','Plan Cuentas 2','545','DIVIDENDO A COBRAR',10,0,NULL),(3087,'Plan Cuentas 2','Plan Cuentas 2','546','INTERESES A C/P VALORES REPRESENT. DEUDA',10,0,NULL),(3088,'Plan Cuentas 2','Plan Cuentas 2','547','INTERESES A CORTO PLAZO DE CREDITOS',10,0,NULL),(3089,'Plan Cuentas 2','Plan Cuentas 2','548','IMPOSICIONES A CORTO PLAZO',10,0,NULL),(3090,'Plan Cuentas 2','Plan Cuentas 2','549','DESEMB PEND S/PARTIC EN PATRIM NETO C/P',10,0,NULL),(3091,'Plan Cuentas 2','Plan Cuentas 2','550','TITULAR DE LA EXPLOTACION',10,0,NULL),(3092,'Plan Cuentas 2','Plan Cuentas 2','551','C/C CON SOCIOS Y ADMINISTRADOR-ES',10,0,NULL),(3093,'Plan Cuentas 2','Plan Cuentas 2','552','C/C CON OTRAS PERSONAS Y ENTID. VINCUL.',10,0,NULL),(3094,'Plan Cuentas 2','Plan Cuentas 2','552.3','CUENTA CORRIENTE CON EMPRESAS GRUPO',21,0,NULL),(3095,'Plan Cuentas 2','Plan Cuentas 2','552.4','CUENTA CORRIENTE CON EMPRESAS ASO',21,0,NULL),(3096,'Plan Cuentas 2','Plan Cuentas 2','552.5','CUENTA CORRIENTE CON OTRAS PARTES',21,0,NULL),(3097,'Plan Cuentas 2','Plan Cuentas 2','554','C/C CON UNIONES TEMPORALES DE EMP Y C.B.',10,0,NULL),(3098,'Plan Cuentas 2','Plan Cuentas 2','555','PARTIDAS PENDIENTES DE APLICACION',21,0,NULL),(3099,'Plan Cuentas 2','Plan Cuentas 2','556','DESEMB EXIG S/PARTICIP EN EL PATRIM NETO',21,0,NULL),(3100,'Plan Cuentas 2','Plan Cuentas 2','556.3','DESEMB EXIGIDOS S/PARTICIPAC, E.G.',21,0,NULL),(3101,'Plan Cuentas 2','Plan Cuentas 2','556.4','DESEMB EXIGIDOS S/PARTICIPAC, E.A.',21,0,NULL),(3102,'Plan Cuentas 2','Plan Cuentas 2','556.5','DESEMB EXIGIDOS S/PARTICIPAC, O.P.V.',21,0,NULL),(3103,'Plan Cuentas 2','Plan Cuentas 2','556.6','DESEMB EXIGIDOS S/PARTICIPAC. DE O.E.',21,0,NULL),(3104,'Plan Cuentas 2','Plan Cuentas 2','557','DIVIDENDO ACTIVO A CUENTA',30,0,NULL),(3105,'Plan Cuentas 2','Plan Cuentas 2','558','SOCIOS POR DESEMBOLSOS EXIGIDOS',10,0,NULL),(3106,'Plan Cuentas 2','Plan Cuentas 2','558.5','SOCIOS DESEM. EX. ACC/PART PAS.FINANC.',21,0,NULL),(3107,'Plan Cuentas 2','Plan Cuentas 2','559','DERIVADOS FINANCIEROS A CORTO PLAZO',10,0,NULL),(3108,'Plan Cuentas 2','Plan Cuentas 2','559.5','PASIVOS POR DERIVADOS FINAN. A CORTO PL.',21,0,NULL),(3109,'Plan Cuentas 2','Plan Cuentas 2','560','FIANZAS RECIBIDAS A CORTO PLAZO',21,0,NULL),(3110,'Plan Cuentas 2','Plan Cuentas 2','561','DEPOSITOS RECIBIDOS A CORTO PLAZO',21,0,NULL),(3111,'Plan Cuentas 2','Plan Cuentas 2','565','FIANZAS CONSTITUIDAS A CORTO PLAZO',10,0,NULL),(3112,'Plan Cuentas 2','Plan Cuentas 2','566','DEPOSITOS CONSTITUIDOS A CORTO PLAZO',10,0,NULL),(3113,'Plan Cuentas 2','Plan Cuentas 2','567','INTERESES PAGADOS POR ANTICIPADO',10,0,NULL),(3114,'Plan Cuentas 2','Plan Cuentas 2','568','INTERESES COBRADOS POR ANTICIPADO',21,0,NULL),(3115,'Plan Cuentas 2','Plan Cuentas 2','570','CAJA, EUROS',10,0,NULL),(3116,'Plan Cuentas 2','Plan Cuentas 2','571','CAJA, MONEDA EXTRANJERA',10,0,NULL),(3117,'Plan Cuentas 2','Plan Cuentas 2','572','BANCOS E INSTIT. DE CREDITO C/C VISTA',10,0,NULL),(3118,'Plan Cuentas 2','Plan Cuentas 2','573','BANC. E INSTIT DE CRED C/C VISTA MON.EXT',10,0,NULL),(3119,'Plan Cuentas 2','Plan Cuentas 2','574','BANCOS E INSTIT. DE CREDITO C/A, EUROS',10,0,NULL),(3120,'Plan Cuentas 2','Plan Cuentas 2','575','BANCOS E INSTIT. DE CREDITO C/A, MON.EXT',10,0,NULL),(3121,'Plan Cuentas 2','Plan Cuentas 2','576','INVERSIONES A CORTO PLAZO DE GRAN LIQUID',10,0,NULL),(3122,'Plan Cuentas 2','Plan Cuentas 2','593','DETER. VALOR PARTIC. A/C PARTES VINCULAD',10,0,NULL),(3123,'Plan Cuentas 2','Plan Cuentas 2','593.3','DETER. VALOR PARTIC. A/C OTRAS PARTES EG',21,0,NULL),(3124,'Plan Cuentas 2','Plan Cuentas 2','593.4','DETER. VALOR PARTIC. A/C OTRAS PARTES EA',21,0,NULL),(3125,'Plan Cuentas 2','Plan Cuentas 2','593.5','DETER. VALOR PARTIC. A/C OTRAS PARTES VI',21,0,NULL),(3126,'Plan Cuentas 2','Plan Cuentas 2','594','DETER. V/V REPRESENT. DEUDA C/P P.V.',10,0,NULL),(3127,'Plan Cuentas 2','Plan Cuentas 2','594.3','DETER. V/V REPRESENT. DEUDA C/P E.G.',21,0,NULL),(3128,'Plan Cuentas 2','Plan Cuentas 2','594.4','DETER. V/V REPRESENT. DEUDA C/P E.A.',21,0,NULL),(3129,'Plan Cuentas 2','Plan Cuentas 2','594.5','DETER. V/V REPRESENT. DEUDA C/P O.P.V.',21,0,NULL),(3130,'Plan Cuentas 2','Plan Cuentas 2','595','DETERIORO DE VALOR DE CRED A C/P A P.V.',10,0,NULL),(3131,'Plan Cuentas 2','Plan Cuentas 2','595.3','DETERIORO DE VALOR DE CRED A C/P A E.G.',21,0,NULL),(3132,'Plan Cuentas 2','Plan Cuentas 2','595.4','DETERIORO DE VALOR DE CRED A C/P A E.A.',21,0,NULL),(3133,'Plan Cuentas 2','Plan Cuentas 2','595.5','DETERIORO DE VALOR DE CRED A C/P A O.P.V',21,0,NULL),(3134,'Plan Cuentas 2','Plan Cuentas 2','596','DETER. VALOR PARTIC. A CORTO PLAZO',10,0,NULL),(3135,'Plan Cuentas 2','Plan Cuentas 2','597','DETERIORO DE VALOR DE VAL.REP. DEUDA C.P',10,0,NULL),(3136,'Plan Cuentas 2','Plan Cuentas 2','598','DETERIORO DE VALOR DE CREDITOS A C/P',10,0,NULL),(3137,'Plan Cuentas 2','Plan Cuentas 2','600','COMPRAS DE MERCADERIAS',70,0,NULL),(3138,'Plan Cuentas 2','Plan Cuentas 2','601','COMPRAS DE MATERIAS PRIMAS',70,0,NULL),(3139,'Plan Cuentas 2','Plan Cuentas 2','602','COMPRAS DE OTROS APROVISIONAMIENTOS',70,0,NULL),(3140,'Plan Cuentas 2','Plan Cuentas 2','60200','Gastos de Mercadotecnia',80,0,NULL),(3141,'Plan Cuentas 2','Plan Cuentas 2','60300','Gastos Promocionales',70,0,NULL),(3142,'Plan Cuentas 2','Plan Cuentas 2','606','DESCUENTOS SOBRE COMPRAS POR PRONTO PAGO',70,0,NULL),(3143,'Plan Cuentas 2','Plan Cuentas 2','606.1','DESCUENTOS SOBRE COMPRAS P/P MAT. PRIMAS',90,0,NULL),(3144,'Plan Cuentas 2','Plan Cuentas 2','606.2','DESCUENTOS SOBRE COMPRAS P/P OTROS APROV',90,0,NULL),(3145,'Plan Cuentas 2','Plan Cuentas 2','607','TRABAJOS REALIZADOS POR OTRAS EMPRESAS',70,0,NULL),(3146,'Plan Cuentas 2','Plan Cuentas 2','608','DEVOL. DE COMPRAS Y OPERAC. SIMILARES',70,0,NULL),(3147,'Plan Cuentas 2','Plan Cuentas 2','608.1','DEVOL. DE COMPRAS DE MATERIAS PRIMAS',90,0,NULL),(3148,'Plan Cuentas 2','Plan Cuentas 2','608.2','DEVOL. DE COMPRAS DE OTROS APROVISIONAM.',90,0,NULL),(3149,'Plan Cuentas 2','Plan Cuentas 2','609','RAPPELS POR COMPRAS',70,0,NULL),(3150,'Plan Cuentas 2','Plan Cuentas 2','609.1','RAPPELS POR COMPRAS DE MATERIAS PRIMAS',90,0,NULL),(3151,'Plan Cuentas 2','Plan Cuentas 2','609.2','RAPPELS POR COMPRAS DE OTROS APROV.',90,0,NULL),(3152,'Plan Cuentas 2','Plan Cuentas 2','610','VARIACION DE EXISTENCIAS DE MERCADERIAS',70,0,NULL),(3153,'Plan Cuentas 2','Plan Cuentas 2','611','VARIACION DE EXISTENCIAS DE MAT. PRIMAS',70,0,NULL),(3154,'Plan Cuentas 2','Plan Cuentas 2','612','VARIACION DE EXISTENCIAS DE OTROS APROV.',70,0,NULL),(3155,'Plan Cuentas 2','Plan Cuentas 2','620','GASTOS EN INVESTIGACION Y DESARR. EJERCI',80,0,NULL),(3156,'Plan Cuentas 2','Plan Cuentas 2','621','ARRENDAMIENTOS Y CANONES',80,0,NULL),(3157,'Plan Cuentas 2','Plan Cuentas 2','622','REPARACIONES Y CONSERVACION',80,0,NULL),(3158,'Plan Cuentas 2','Plan Cuentas 2','623','SERVICIOS DE PROFESIONALES INDEPENDIENT.',80,0,NULL),(3159,'Plan Cuentas 2','Plan Cuentas 2','624','TRANSPORTES',80,0,NULL),(3160,'Plan Cuentas 2','Plan Cuentas 2','625','PRIMAS DE SEGUROS',80,0,NULL),(3161,'Plan Cuentas 2','Plan Cuentas 2','626','SERVICIOS BANCARIOS Y SIMILARES',80,0,NULL),(3162,'Plan Cuentas 2','Plan Cuentas 2','627','PUBLICIDAD, PROPAGANDA Y RELACIONES PUBL',80,0,NULL),(3163,'Plan Cuentas 2','Plan Cuentas 2','628','SUMINISTROS',80,0,NULL),(3164,'Plan Cuentas 2','Plan Cuentas 2','629','OTROS SERVICIOS',80,0,NULL),(3165,'Plan Cuentas 2','Plan Cuentas 2','630','IMPUESTO SOBRE BENEFICIOS',80,0,NULL),(3166,'Plan Cuentas 2','Plan Cuentas 2','630.1','IMPUESTO DIFERIDO',90,0,NULL),(3167,'Plan Cuentas 2','Plan Cuentas 2','631','OTROS TRIBUTOS',80,0,NULL),(3168,'Plan Cuentas 2','Plan Cuentas 2','633','AJUSTES NEG. EN LA IMPOSICION S/BENEFIC.',80,0,NULL),(3169,'Plan Cuentas 2','Plan Cuentas 2','634','AJUSTES NEG. EN LA IMPOSICION INDICERCTA',80,0,NULL),(3170,'Plan Cuentas 2','Plan Cuentas 2','634.1','AJUSTES NEG. EN IVA DE ACTIVO CORRIENTE',90,0,NULL),(3171,'Plan Cuentas 2','Plan Cuentas 2','634.2','AJUSTES NEGATIVOS EN IVA DE INVERSIONES',90,0,NULL),(3172,'Plan Cuentas 2','Plan Cuentas 2','636','DEVOLUCION DE IMPUESTOS',80,0,NULL),(3173,'Plan Cuentas 2','Plan Cuentas 2','638','AJUSTES POS. EN LA IMPOSICION S/BENEFIC.',80,0,NULL),(3174,'Plan Cuentas 2','Plan Cuentas 2','639','AJUSTES POS. EN LA IMPOSICION INDIRECTA',80,0,NULL),(3175,'Plan Cuentas 2','Plan Cuentas 2','639.1','AJUSTES POS. EN IVA DE ACTIVO CORRIENTE',90,0,NULL),(3176,'Plan Cuentas 2','Plan Cuentas 2','639.2','AJUSTES POSITIVOS EN IVA DE INVERSIONES',90,0,NULL),(3177,'Plan Cuentas 2','Plan Cuentas 2','640','SUELDOS Y SALARIOS',80,0,NULL),(3178,'Plan Cuentas 2','Plan Cuentas 2','641','INDEMNIZACIONES',80,0,NULL),(3179,'Plan Cuentas 2','Plan Cuentas 2','642','SEGURIDAD SOCIAL A CARGO DE LA EMPRESA',80,0,NULL),(3180,'Plan Cuentas 2','Plan Cuentas 2','649','OTROS GASTOS SOCIALES',80,0,NULL),(3181,'Plan Cuentas 2','Plan Cuentas 2','650','PERDIDAS DE CRED. COMERC. INCOBRABLES',80,0,NULL),(3182,'Plan Cuentas 2','Plan Cuentas 2','651','RESULTADOS DE OPERACIONES EN COMUN',80,0,NULL),(3183,'Plan Cuentas 2','Plan Cuentas 2','651.1','PERDIDA SOPORTADA (PARTIC.O ASOC. NO GE)',90,0,NULL),(3184,'Plan Cuentas 2','Plan Cuentas 2','659','OTRAS PERDIDAS EN GESTION CORRIENTE',80,0,NULL),(3185,'Plan Cuentas 2','Plan Cuentas 2','660','GASTOS FINCANCIEROS ACTUL PROVISIONES',80,0,NULL),(3186,'Plan Cuentas 2','Plan Cuentas 2','661','INTERESES DE OBLIGACIONES Y BONOS',80,0,NULL),(3187,'Plan Cuentas 2','Plan Cuentas 2','661.1','INTERESES DE OBLIG Y BONOS L.P. EMP.ASOC',90,0,NULL),(3188,'Plan Cuentas 2','Plan Cuentas 2','661.2','INTERESES DE OBLIG Y BONOS L.P. O.PAR.VI',90,0,NULL),(3189,'Plan Cuentas 2','Plan Cuentas 2','661.3','INTERESES DE OBLIG Y BONOS L.P. OTR.EMPR',90,0,NULL),(3190,'Plan Cuentas 2','Plan Cuentas 2','661.5','INTERESES DE OBLIG Y BONOS C.P. EMP.GRUP',90,0,NULL),(3191,'Plan Cuentas 2','Plan Cuentas 2','661.6','INTERESES DE OBLIG Y BONOS C.P. EMP.ASOC',90,0,NULL),(3192,'Plan Cuentas 2','Plan Cuentas 2','661.7','INTERESES DE OBLIG Y BONOS C.P. O.PAR.VI',90,0,NULL),(3193,'Plan Cuentas 2','Plan Cuentas 2','661.8','INTERESES DE OBLIG Y BONOS C.P. OTR.EMPR',90,0,NULL),(3194,'Plan Cuentas 2','Plan Cuentas 2','662','INTERESES DE DEUDAS',80,0,NULL),(3195,'Plan Cuentas 2','Plan Cuentas 2','662.1','INTERESES DE DEUDAS, EMPRESAS ASOCIADAS',90,0,NULL),(3196,'Plan Cuentas 2','Plan Cuentas 2','662.2','INTERESES DE DEUDAS, OTRAS PARTES VINC.',90,0,NULL),(3197,'Plan Cuentas 2','Plan Cuentas 2','662.3','INTERESES DE DEUDAS CON ENT. DE CREDITO',90,0,NULL),(3198,'Plan Cuentas 2','Plan Cuentas 2','662.4','INTERESES DE DEUDAS, OTRAS EMPRESAS',90,0,NULL),(3199,'Plan Cuentas 2','Plan Cuentas 2','663','PERD. VALORACION ACT/PAS FINANC. VAL.RAZ',80,0,NULL),(3200,'Plan Cuentas 2','Plan Cuentas 2','664','DIVIDENDOS ACC/PART CONS. PAS. FINANC.',80,0,NULL),(3201,'Plan Cuentas 2','Plan Cuentas 2','664.1','DIVIDENDOS DE PASIVOS, EMPRESAS ASOC.',90,0,NULL),(3202,'Plan Cuentas 2','Plan Cuentas 2','664.2','DIVIDENDOS DE PASIVOS, OTRAS PART. VINC.',90,0,NULL),(3203,'Plan Cuentas 2','Plan Cuentas 2','664.3','DIVIDENDOS DE PASIVOS, OTRAS EMPRESAS',90,0,NULL),(3204,'Plan Cuentas 2','Plan Cuentas 2','665','INTERESES POR DTO. EFEC/OPER FACTORING',80,0,NULL),(3205,'Plan Cuentas 2','Plan Cuentas 2','665.1','INTERESES POR DTO. DE EFEC. ENT.CRE.ASOC',90,0,NULL),(3206,'Plan Cuentas 2','Plan Cuentas 2','665.2','INTERESES POR DTO. DE EFEC. ENT.CRED.VIN',90,0,NULL),(3207,'Plan Cuentas 2','Plan Cuentas 2','665.3','INTERESES POR DTO. DE EFEC. OTR.ENT.CRED',90,0,NULL),(3208,'Plan Cuentas 2','Plan Cuentas 2','665.4','INTERESES OPER. FACTORING ENT.CREDIT GRP',90,0,NULL),(3209,'Plan Cuentas 2','Plan Cuentas 2','665.5','INTERESES OPER. FACTORING ENT.CREDIT ASO',90,0,NULL),(3210,'Plan Cuentas 2','Plan Cuentas 2','665.6','INTERESES OPER. FACTORING O.ENT.CRED.VIN',90,0,NULL),(3211,'Plan Cuentas 2','Plan Cuentas 2','665.7','INTERESES OPER. FACTORING O.ENT. CREDITO',90,0,NULL),(3212,'Plan Cuentas 2','Plan Cuentas 2','666','PERDIDAS PARTICI. Y VAL. REPR. DE DEUDA',80,0,NULL),(3213,'Plan Cuentas 2','Plan Cuentas 2','666.1','PERDIDAS VALORES REP. DEUDA L/P E.A.',90,0,NULL),(3214,'Plan Cuentas 2','Plan Cuentas 2','666.2','PERDIDAS VALORES REP. DEUDA L/P O.P.V',90,0,NULL),(3215,'Plan Cuentas 2','Plan Cuentas 2','666.3','PERDIDAS PARTICI. VAL.REPR.DEU.L.P. O.EM',90,0,NULL),(3216,'Plan Cuentas 2','Plan Cuentas 2','666.5','PERDIDAS PARTICI. VAL.REPR.DEU.C.P. EM.G',90,0,NULL),(3217,'Plan Cuentas 2','Plan Cuentas 2','666.6','PERDIDAS PARTICI. VAL.REPR.DEU.C.P. EM.A',90,0,NULL),(3218,'Plan Cuentas 2','Plan Cuentas 2','666.7','PERDIDAS VALORES REP. DEUDA C/P O.P.V',90,0,NULL),(3219,'Plan Cuentas 2','Plan Cuentas 2','666.8','PERDIDAS VALORES REP. DEUDA C/P O.E.',90,0,NULL),(3220,'Plan Cuentas 2','Plan Cuentas 2','667','PERDIDAS DE CREDITOS NO COMERCIALES',80,0,NULL),(3221,'Plan Cuentas 2','Plan Cuentas 2','667.1','PERDIDAS DE CRED. A LARGO P. EMPR.ASOC.',90,0,NULL),(3222,'Plan Cuentas 2','Plan Cuentas 2','667.2','PERDIDAS DE CRED. A LARGO P. OT. PART.VI',90,0,NULL),(3223,'Plan Cuentas 2','Plan Cuentas 2','667.3','PERDIDAS DE CRED. A LARGO P. OTRAS EMPR.',90,0,NULL),(3224,'Plan Cuentas 2','Plan Cuentas 2','667.5','PERDIDAS DE CRED. A CORTO P. EMPR. GRUPO',90,0,NULL),(3225,'Plan Cuentas 2','Plan Cuentas 2','667.6','PERDIDAS DE CRED. A CORTO P. EMPR. ASOC.',90,0,NULL),(3226,'Plan Cuentas 2','Plan Cuentas 2','667.7','PERDIDAS DE CRED. A CORTO P. OT. PART.VI',90,0,NULL),(3227,'Plan Cuentas 2','Plan Cuentas 2','667.8','PERDIDAS DE CRED. A CORTO P. OTRAS EMPR.',90,0,NULL),(3228,'Plan Cuentas 2','Plan Cuentas 2','668','DIFERENCIAS NEGATIVAS DE CAMBIO',80,0,NULL),(3229,'Plan Cuentas 2','Plan Cuentas 2','669','OTROS GASTOS FINANCIEROS',80,0,NULL),(3230,'Plan Cuentas 2','Plan Cuentas 2','670','PERDIDAS PROC. INMOVILIZADO INTANGIBLE',80,0,NULL),(3231,'Plan Cuentas 2','Plan Cuentas 2','671','PERDIDAS PROC. INMOVILIZADO MATERIAL',80,0,NULL),(3232,'Plan Cuentas 2','Plan Cuentas 2','672','PERD. PROC. DE LAS INVERSIONES INMOBILI.',80,0,NULL),(3233,'Plan Cuentas 2','Plan Cuentas 2','673','PERD. PROC. DE PARTICIP.L.P. PARTES VIN.',80,0,NULL),(3234,'Plan Cuentas 2','Plan Cuentas 2','673.3','PERD. PROC. DE PARTICIP.L.P. EMP. GRUPO',90,0,NULL),(3235,'Plan Cuentas 2','Plan Cuentas 2','673.4','PERD. PROC. DE PARTICIP.L.P. EMP. ASOCI.',90,0,NULL),(3236,'Plan Cuentas 2','Plan Cuentas 2','673.5','PERD. PROC. DE PARTICIP.L.P. OTR.PAR.VIN',90,0,NULL),(3237,'Plan Cuentas 2','Plan Cuentas 2','675','PERD. POR OPER. CON OBLIGACIONES PROPIAS',80,0,NULL),(3238,'Plan Cuentas 2','Plan Cuentas 2','678','GASTOS EXCEPCIONALES',80,0,NULL),(3239,'Plan Cuentas 2','Plan Cuentas 2','680','AMORTIZACION DEL INMOVILIZADO INTANGIBLE',80,0,NULL),(3240,'Plan Cuentas 2','Plan Cuentas 2','681','AMORTIZACION DEL INMOVILIZADO MATERIAL',80,0,NULL),(3241,'Plan Cuentas 2','Plan Cuentas 2','682','AMORT. DE LAS INVERSIONES INMOBILIARIAS',80,0,NULL),(3242,'Plan Cuentas 2','Plan Cuentas 2','690','PERDIDAS POR DETERIORO DEL INMOV. INTANG',80,0,NULL),(3243,'Plan Cuentas 2','Plan Cuentas 2','691','PERDIDAS POR DETERIORO DEL INMOV. MATER.',80,0,NULL),(3244,'Plan Cuentas 2','Plan Cuentas 2','692','PERDIDAS POR DETERIORO DE INVER.INMOBIL.',80,0,NULL),(3245,'Plan Cuentas 2','Plan Cuentas 2','693','PERDIDAS POR DETERIORO DE EXISTENCIAS',80,0,NULL),(3246,'Plan Cuentas 2','Plan Cuentas 2','693.1','PERDIDAS POR DETERIORO DE MERCADERIAS',90,0,NULL),(3247,'Plan Cuentas 2','Plan Cuentas 2','693.2','PERDIDAS POR DETERIORO DE MAT. PRIMAS',90,0,NULL),(3248,'Plan Cuentas 2','Plan Cuentas 2','693.3','PERDIDAS POR DETERIORO DE OTROS APROV.',90,0,NULL),(3249,'Plan Cuentas 2','Plan Cuentas 2','694','PERDIDAS POR DET.DE CREDITOS COMERCIALES',80,0,NULL),(3250,'Plan Cuentas 2','Plan Cuentas 2','695','DOTACION A LA PROV. POR OPERAC. COMERCI.',80,0,NULL),(3251,'Plan Cuentas 2','Plan Cuentas 2','695.4','DOTACION A LA PROV. POR CONTRATOS ONER.',90,0,NULL),(3252,'Plan Cuentas 2','Plan Cuentas 2','695.9','DOTACION A LA PROV. OTRAS OPER. COMERC.',90,0,NULL),(3253,'Plan Cuentas 2','Plan Cuentas 2','696','PERD. DETER.PARTIC.VALOR.REP. DEUD. L.P.',80,0,NULL),(3254,'Plan Cuentas 2','Plan Cuentas 2','696.1','PERD. DETER.PARTIC.INSTRUM.PAT.L.P.E.ASO',90,0,NULL),(3255,'Plan Cuentas 2','Plan Cuentas 2','696.2','PERD. DETER.PARTIC.INSTRUM.PAT.L.P.O.P.V',90,0,NULL),(3256,'Plan Cuentas 2','Plan Cuentas 2','696.3','PERD. DETER.PARTIC.INSTRUM.PAT.L.P.O.EMP',90,0,NULL),(3257,'Plan Cuentas 2','Plan Cuentas 2','696.5','PERD. DETER. VAL. REPRES. DEUDA L/P E.G.',90,0,NULL),(3258,'Plan Cuentas 2','Plan Cuentas 2','696.6','PERD. DETER. VAL. REPRES. DEUDA L/P E.A.',90,0,NULL),(3259,'Plan Cuentas 2','Plan Cuentas 2','696.7','PERD. DETER.VAL. REPRES. DEUDA L/P O.P.V',90,0,NULL),(3260,'Plan Cuentas 2','Plan Cuentas 2','696.8','PERD. DETER. VAL. REPRES. DEUDA L/P O.E.',90,0,NULL),(3261,'Plan Cuentas 2','Plan Cuentas 2','697','PERDIDAS POR DETER. DE CREDITOS A LARG.P',80,0,NULL),(3262,'Plan Cuentas 2','Plan Cuentas 2','697.1','PERDIDAS POR DET.DE CRED. LARGO P. E.ASO',90,0,NULL),(3263,'Plan Cuentas 2','Plan Cuentas 2','697.2','PERDIDAS POR DET.DE CRED. LARGO P. O.P.V',90,0,NULL),(3264,'Plan Cuentas 2','Plan Cuentas 2','697.3','PERDIDAS POR DET.DE CRED. LARGO P. O.EMP',90,0,NULL),(3265,'Plan Cuentas 2','Plan Cuentas 2','698','PERD. DETER. PART/VAL. REPR. DEUDA C/P',80,0,NULL),(3266,'Plan Cuentas 2','Plan Cuentas 2','698.1','PERD. DETER.PARTIC.INSTRUM.PAT.C.P.E.ASO',90,0,NULL),(3267,'Plan Cuentas 2','Plan Cuentas 2','698.5','PERD. DETER.VALOR.REPRES.DEUD.C.P. E.GRU',90,0,NULL),(3268,'Plan Cuentas 2','Plan Cuentas 2','698.6','PERD. DETER.VALOR.REPRES.DEUD.C.P. E.ASO',90,0,NULL),(3269,'Plan Cuentas 2','Plan Cuentas 2','698.7','PERD. DETER.VALOR.REPRES.DEUD.C.P. O.P.V',90,0,NULL),(3270,'Plan Cuentas 2','Plan Cuentas 2','698.8','PERD. DETER.VALOR.REPRES.DEUD.C.P. O.EMP',90,0,NULL),(3271,'Plan Cuentas 2','Plan Cuentas 2','699','PERDIDAS POR DETERIORO DE CREDITOS A C/P',80,0,NULL),(3272,'Plan Cuentas 2','Plan Cuentas 2','699.1','PERDIDAS POR DETER. DE CREDIT. C/P E.A.',90,0,NULL),(3273,'Plan Cuentas 2','Plan Cuentas 2','699.2','PERDIDAS POR DETER. DE CREDIT. C/P O.P.V',90,0,NULL),(3274,'Plan Cuentas 2','Plan Cuentas 2','699.3','PERDIDAS POR DETER. DE CREDIT. C/P O.E',90,0,NULL),(3275,'Plan Cuentas 2','Plan Cuentas 2','700','VENTAS DE MERCADERIAS',50,0,NULL),(3276,'Plan Cuentas 2','Plan Cuentas 2','701','VENTAS DE PRODUCTOS TERMINADOS',50,0,NULL),(3277,'Plan Cuentas 2','Plan Cuentas 2','702','VENTAS DE PRODUCTOS SEMITERMINADOS',50,0,NULL),(3278,'Plan Cuentas 2','Plan Cuentas 2','703','VENTAS DE SUBPRODUCTOS Y RESIDUOS',50,0,NULL),(3279,'Plan Cuentas 2','Plan Cuentas 2','704','VENTAS DE ENVASES Y EMBALAJES',50,0,NULL),(3280,'Plan Cuentas 2','Plan Cuentas 2','705','PRESTACIONES DE SERVICIOS',50,0,NULL),(3281,'Plan Cuentas 2','Plan Cuentas 2','706','DESCUENTOS SOBRE VENTAS POR PRONTO PAGO',50,0,NULL),(3282,'Plan Cuentas 2','Plan Cuentas 2','706.1','DTOS. S/VENTAS POR P.P. DE PRODUCTOS T',90,0,NULL),(3283,'Plan Cuentas 2','Plan Cuentas 2','706.2','DTOS. S/VENTAS POR P.P. DE PRODUCTOS SEM',90,0,NULL),(3284,'Plan Cuentas 2','Plan Cuentas 2','706.3','DTOS. S/VENTAS POR P.P. DE SUBPRODUC',90,0,NULL),(3285,'Plan Cuentas 2','Plan Cuentas 2','708','DEVOLUCIONES DE VENTAS Y OPERAC. SIMILAR',50,0,NULL),(3286,'Plan Cuentas 2','Plan Cuentas 2','708.1','DEVOLUCIONES DE VENTAS PROD. TERMINADOS',90,0,NULL),(3287,'Plan Cuentas 2','Plan Cuentas 2','708.2','DEVOLUCIONES DE VENTAS PROD. SEMITERMIN.',90,0,NULL),(3288,'Plan Cuentas 2','Plan Cuentas 2','708.3','DEVOLUCIONES DE VENTAS SUBPROD. Y RESID.',90,0,NULL),(3289,'Plan Cuentas 2','Plan Cuentas 2','708.4','DEVOLUCIONES DE VENTAS ENVASES Y EMBAL.',90,0,NULL),(3290,'Plan Cuentas 2','Plan Cuentas 2','709','RAPPELS SOBRE VENTAS',50,0,NULL),(3291,'Plan Cuentas 2','Plan Cuentas 2','709.1','RAPPELS SOBRE VTAS DE PROD TERMINADOS',90,0,NULL),(3292,'Plan Cuentas 2','Plan Cuentas 2','709.2','RAPPELS SOBRE VTAS DE PROD SEMITERMINADS',90,0,NULL),(3293,'Plan Cuentas 2','Plan Cuentas 2','709.3','RAPPELS S/VTAS DE SUBPRODUCT. Y RESIDUOS',90,0,NULL),(3294,'Plan Cuentas 2','Plan Cuentas 2','709.4','RAPPELS SOBRE VTAS DE ENVASES Y EMBAL.',90,0,NULL),(3295,'Plan Cuentas 2','Plan Cuentas 2','710','VARIACION DE EXISTENCIAS DE PROD. CURSO',50,0,NULL),(3296,'Plan Cuentas 2','Plan Cuentas 2','711','VARIACION DE EXISTENCIAS DE PROD. SEMIT.',50,0,NULL),(3297,'Plan Cuentas 2','Plan Cuentas 2','712','VARIACION DE EXISTENCIAS DE PROD. TERMI.',50,0,NULL),(3298,'Plan Cuentas 2','Plan Cuentas 2','713','VARIACION DE EXIST.DE SUBPROD.RES.Y M.R.',50,0,NULL),(3299,'Plan Cuentas 2','Plan Cuentas 2','730','TRABAJOS REALIZ. PARA INMOVIL.INTANGIBL',50,0,NULL),(3300,'Plan Cuentas 2','Plan Cuentas 2','731','TRABAJOS REALIZ. PARA INMOVIL. MATERIAL',50,0,NULL),(3301,'Plan Cuentas 2','Plan Cuentas 2','732','TRABAJOS REALIZ. EN INVERSIONES INMOBIL',50,0,NULL),(3302,'Plan Cuentas 2','Plan Cuentas 2','733','TRABAJOS REALIZ. PARA INMOVIL. MAT. CURS',50,0,NULL),(3303,'Plan Cuentas 2','Plan Cuentas 2','740','SUBVENCIONES, DONACIONES Y LEG. A LA EXP',50,0,NULL),(3304,'Plan Cuentas 2','Plan Cuentas 2','746','SUBVENCIONES, DONAC. Y LEG. DE CAP. TRAN',50,0,NULL),(3305,'Plan Cuentas 2','Plan Cuentas 2','747','OTRAS SUBVENCIONES, DON.LEG.TRANSF. RESU',50,0,NULL),(3306,'Plan Cuentas 2','Plan Cuentas 2','751','RESULTADOS DE OPERACIONES EN COMUN',50,0,NULL),(3307,'Plan Cuentas 2','Plan Cuentas 2','751.1','BENEF ATRIB (PARTICIPE O ASOC NO GESTOR)',90,0,NULL),(3308,'Plan Cuentas 2','Plan Cuentas 2','752','INGRESOS POR ARRENDAMIENTOS',50,0,NULL),(3309,'Plan Cuentas 2','Plan Cuentas 2','753','INGRESOS DE PROPIEDAD IND. CEDIDA EN EXP',50,0,NULL),(3310,'Plan Cuentas 2','Plan Cuentas 2','754','INGRESOS POR COMISIONES',50,0,NULL),(3311,'Plan Cuentas 2','Plan Cuentas 2','755','INGRESOS POR SERVICIOS AL PERSONAL',50,0,NULL),(3312,'Plan Cuentas 2','Plan Cuentas 2','759','INGRESOS POR SERVICIOS DIVERSOS',50,0,NULL),(3313,'Plan Cuentas 2','Plan Cuentas 2','760','INGRESOS PARTIC. EN INSTRUM. PATRI.',50,0,NULL),(3314,'Plan Cuentas 2','Plan Cuentas 2','760.1','INGRESOS PARTIC. EN INSTRUM. PATRI. E.A.',90,0,NULL),(3315,'Plan Cuentas 2','Plan Cuentas 2','760.2','INGRESOS PARTIC. EN INSTRUM. PATRI. OT.P',90,0,NULL),(3316,'Plan Cuentas 2','Plan Cuentas 2','760.3','INGRESOS PARTIC. EN INSTRUM. PATRI. O.E.',90,0,NULL),(3317,'Plan Cuentas 2','Plan Cuentas 2','761','INGRESOS DE VALORES REPRESENT. DE DEUDA',50,0,NULL),(3318,'Plan Cuentas 2','Plan Cuentas 2','761.1','INGRESOS DE VALORES REPRESENT. EMP.ASO.',90,0,NULL),(3319,'Plan Cuentas 2','Plan Cuentas 2','761.2','INGRESOS DE VALORES REPRESENT. OTRAS E.V',90,0,NULL),(3320,'Plan Cuentas 2','Plan Cuentas 2','761.3','INGRESOS DE VALORES REPRESENT. OTRAS EMP',90,0,NULL),(3321,'Plan Cuentas 2','Plan Cuentas 2','762','INGRESOS DE CREDITOS',50,0,NULL),(3322,'Plan Cuentas 2','Plan Cuentas 2','762.1','INGRESOS DE CREDITOS A CORTO PLAZO',90,0,NULL),(3323,'Plan Cuentas 2','Plan Cuentas 2','763','BENEF POR VAL. ACT/PAS FINANC. VAL.RAZ.',50,0,NULL),(3324,'Plan Cuentas 2','Plan Cuentas 2','766','BENEFICIOS EN PART. Y VAL. REPRES. DEUDA',50,0,NULL),(3325,'Plan Cuentas 2','Plan Cuentas 2','766.1','BENEFICIOS VAL. REPRES. DEUDA L/P, E.A.',90,0,NULL),(3326,'Plan Cuentas 2','Plan Cuentas 2','766.2','BENEFICIOS VAL. REPRES. DEUDA L/P, O.P.V',90,0,NULL),(3327,'Plan Cuentas 2','Plan Cuentas 2','766.3','BENEFICIOS VAL. REPRES. DEUDA L/P, O.E.',90,0,NULL),(3328,'Plan Cuentas 2','Plan Cuentas 2','766.5','BENEF.PART.VAL.REPRES. DEUDA C/P, E.G.',90,0,NULL),(3329,'Plan Cuentas 2','Plan Cuentas 2','766.6','BENEF.PART.VAL.REPRES. DEUDA C/P, E.A.',90,0,NULL),(3330,'Plan Cuentas 2','Plan Cuentas 2','766.7','BENEFICIOS VAL. REPRES. DEUDA C/P, O.P.V',90,0,NULL),(3331,'Plan Cuentas 2','Plan Cuentas 2','766.8','BENEFICIOS VAL. REPRES. DEUDA C/P, O.E.',90,0,NULL),(3332,'Plan Cuentas 2','Plan Cuentas 2','768','DIFERENCIAS POSITIVAS DE CAMBIO',50,0,NULL),(3333,'Plan Cuentas 2','Plan Cuentas 2','769','OTROS INGRESOS FINANCIEROS',50,0,NULL),(3334,'Plan Cuentas 2','Plan Cuentas 2','770','BENEF PROC. DEL INMOVILIZADO INTANGIBLE',50,0,NULL),(3335,'Plan Cuentas 2','Plan Cuentas 2','771','BENEF PROC. DEL INMOVILIZADO MATERIAL',50,0,NULL),(3336,'Plan Cuentas 2','Plan Cuentas 2','772','BENEF PROC. DE LAS INVER. INMOBILIARIAS',50,0,NULL),(3337,'Plan Cuentas 2','Plan Cuentas 2','773','BENEF PROC. DE PARTICIP. A L/P, P.V.',50,0,NULL),(3338,'Plan Cuentas 2','Plan Cuentas 2','773.3','BENEF PROC. DE PARTICIP. A L/P, E.G.',90,0,NULL),(3339,'Plan Cuentas 2','Plan Cuentas 2','773.4','BENEF PROC. DE PARTICIP. A L/P, E.A.',90,0,NULL),(3340,'Plan Cuentas 2','Plan Cuentas 2','773.5','BENEF PROC. DE PARTICIP. A L/P, O.P.V.',90,0,NULL),(3341,'Plan Cuentas 2','Plan Cuentas 2','775','BENEF POR OPER. CON OBLIGACIONES PROPIAS',50,0,NULL),(3342,'Plan Cuentas 2','Plan Cuentas 2','778','INGRESOS EXCEPCIONALES',50,0,NULL),(3343,'Plan Cuentas 2','Plan Cuentas 2','790','REVERSION DETER. INMOVILIZADO INTANGIBLE',50,0,NULL),(3344,'Plan Cuentas 2','Plan Cuentas 2','791','REVERSION DETER. INMOVILIZADO MATERIAL',50,0,NULL),(3345,'Plan Cuentas 2','Plan Cuentas 2','792','REVERSION DEL DETERIORO DE INV.INMOBILI.',50,0,NULL),(3346,'Plan Cuentas 2','Plan Cuentas 2','793','REVERSION DEL DETERIORO DE EXISTENCIAS',50,0,NULL),(3347,'Plan Cuentas 2','Plan Cuentas 2','793.1','REVERSION DEL DETERIORO DE MERCADERIAS',90,0,NULL),(3348,'Plan Cuentas 2','Plan Cuentas 2','793.2','REVERSION DEL DETERIORO DE MATERIAS PRIM',90,0,NULL),(3349,'Plan Cuentas 2','Plan Cuentas 2','793.3','REVERSION DEL DETERIORO DE OTROS APROV.',90,0,NULL),(3350,'Plan Cuentas 2','Plan Cuentas 2','794','REVERSION DETERIORO CREDITOS OP. COMERC.',50,0,NULL),(3351,'Plan Cuentas 2','Plan Cuentas 2','795','EXCESO DE PROVISIONES',50,0,NULL),(3352,'Plan Cuentas 2','Plan Cuentas 2','795.1','EXCESO DE PROVISION PARA IMPUESTOS',90,0,NULL),(3353,'Plan Cuentas 2','Plan Cuentas 2','795.2','EXCESO DE PROVISION PARA OTRAS RESPONS',90,0,NULL),(3354,'Plan Cuentas 2','Plan Cuentas 2','795.4','EXCESO DE PROVISION POR OPERACIONES COME',90,0,NULL),(3355,'Plan Cuentas 2','Plan Cuentas 2','795.5','EXCESO DE PROVISION ACTUACIONES MEDIOAMB',90,0,NULL),(3356,'Plan Cuentas 2','Plan Cuentas 2','796','REVER.DETER.PARTIC.VAL.REP.DEUDA L.P.',50,0,NULL),(3357,'Plan Cuentas 2','Plan Cuentas 2','796.1','REVER.DETER.PARTIC.INST.PATR.L.P.EMP.ASO',90,0,NULL),(3358,'Plan Cuentas 2','Plan Cuentas 2','796.2','REVER.DETER.PARTIC.INST.PATR.L.P.O.P.VIN',90,0,NULL),(3359,'Plan Cuentas 2','Plan Cuentas 2','796.3','REVER.DETER.PARTIC.INST.PATR.L.P.OTR.EMP',90,0,NULL),(3360,'Plan Cuentas 2','Plan Cuentas 2','796.5','REVER.DETER.VAL.REPR.DEUDAS L.P. EMP.GRU',90,0,NULL),(3361,'Plan Cuentas 2','Plan Cuentas 2','796.6','REVER.DETER.VAL.REPR.DEUDAS L.P. EMP.ASO',90,0,NULL),(3362,'Plan Cuentas 2','Plan Cuentas 2','796.7','REVER.DETER.VAL.REPR.DEUDAS L.P. O.P.VIN',90,0,NULL),(3363,'Plan Cuentas 2','Plan Cuentas 2','796.8','REVER.DETER.VAL.REPR.DEUDAS L.P. OTR.EMP',90,0,NULL),(3364,'Plan Cuentas 2','Plan Cuentas 2','797','REVERSION DEL DETER.CRED.LARGO PLAZO',50,0,NULL),(3365,'Plan Cuentas 2','Plan Cuentas 2','797.1','REVERSION DEL DETER.CRED.LARGO P.EMP.ASO',90,0,NULL),(3366,'Plan Cuentas 2','Plan Cuentas 2','797.2','REVERSION DEL DETER.CRED.LARGO P.O.P.VIN',90,0,NULL),(3367,'Plan Cuentas 2','Plan Cuentas 2','797.3','REVERSION DEL DETER.CRED.LARGO P.OTR.EMP',90,0,NULL),(3368,'Plan Cuentas 2','Plan Cuentas 2','798','REVER.DETER.PARTIC.VAL.REP.DEUDA C.P.',50,0,NULL),(3369,'Plan Cuentas 2','Plan Cuentas 2','798.1','REVER.DETER.PARTIC.INST.PATR.C.P.EMP.ASO',90,0,NULL),(3370,'Plan Cuentas 2','Plan Cuentas 2','798.5','REVER.DETER.VAL.REPR.DEUDAS C.P. EMP.GRU',90,0,NULL),(3371,'Plan Cuentas 2','Plan Cuentas 2','798.6','REVER.DETER.VAL.REPR.DEUDAS C.P. EMP.ASO',90,0,NULL),(3372,'Plan Cuentas 2','Plan Cuentas 2','798.7','REVER.DETER.VAL.REPR.DEUDAS C.P. O.P.VIN',90,0,NULL),(3373,'Plan Cuentas 2','Plan Cuentas 2','798.8','REVER.DETER.VAL.REPR.DEUDAS C.P. OTR.EMP',90,0,NULL),(3374,'Plan Cuentas 2','Plan Cuentas 2','799','REVERSION DEL DETER.CRED. CORTO PLAZO',50,0,NULL),(3375,'Plan Cuentas 2','Plan Cuentas 2','799.1','REVERSION DEL DETER.CRED.CORTO P.EMP.ASO',90,0,NULL),(3376,'Plan Cuentas 2','Plan Cuentas 2','799.2','REVERSION DEL DETER.CRED.CORTO P.O.P.VIN',90,0,NULL),(3377,'Plan Cuentas 2','Plan Cuentas 2','799.3','REVERSION DEL DETER.CRED.CORTO P.OTR.EMP',90,0,NULL),(3391,'Plan Cuentas 3','Plan Cuentas 3','13000','IVA ACREDITABLE',10,0,NULL),(3392,'Plan Cuentas 3','Plan Cuentas 3','14000','GASTOS PREPAGADOS',10,0,NULL),(3393,'Plan Cuentas 3','Plan Cuentas 3','14100','ADELANTOS AL EMPLEADOS',10,0,NULL),(3394,'Plan Cuentas 3','Plan Cuentas 3','14200','NOTAS POR COBRAR-CORRIENTE',10,0,NULL),(3395,'Plan Cuentas 3','Plan Cuentas 3','14700','OTROS ACTIVOS CORRIENTES',10,0,NULL),(3396,'Plan Cuentas 3','Plan Cuentas 3','15000','MUEBLES Y ACCESORIOS',11,0,NULL),(3397,'Plan Cuentas 3','Plan Cuentas 3','15100','EQUIPO',11,0,NULL),(3398,'Plan Cuentas 3','Plan Cuentas 3','15200','AUTOMOVILES',11,0,NULL),(3399,'Plan Cuentas 3','Plan Cuentas 3','15300','OTRO BIENES DEPRECIABLES',11,0,NULL),(3400,'Plan Cuentas 3','Plan Cuentas 3','15400','LEASEHOLD IMPROVEMENTS',11,0,NULL),(3401,'Plan Cuentas 3','Plan Cuentas 3','15500','EDIFICIO',11,0,NULL),(3402,'Plan Cuentas 3','Plan Cuentas 3','15600','MEJORAS AL EDIFICIO',11,0,NULL),(3403,'Plan Cuentas 3','Plan Cuentas 3','16900','TERRENO',11,0,NULL),(3404,'Plan Cuentas 3','Plan Cuentas 3','17000','ACCUM. DEPRECIACION - MUEBLES',11,0,NULL),(3405,'Plan Cuentas 3','Plan Cuentas 3','17100','ACCUM. DEPRECIACION - EQUIPO',11,0,NULL),(3406,'Plan Cuentas 3','Plan Cuentas 3','17200','ACCUM. DEPRECIACION - AUTOMOVIL',11,0,NULL),(3407,'Plan Cuentas 3','Plan Cuentas 3','17300','ACCUM. DEPRECIACION - OTRO',11,0,NULL),(3408,'Plan Cuentas 3','Plan Cuentas 3','17400','ACCUM. DEPRECIACION - ARRENDAMIENTO',11,0,NULL),(3409,'Plan Cuentas 3','Plan Cuentas 3','17500','ACCUM. DEPRECIACION - EDIFICIO',11,0,NULL),(3410,'Plan Cuentas 3','Plan Cuentas 3','17600','ACCUM. DEPRECIACION - MEJORAS AL EDIF.',11,0,NULL),(3411,'Plan Cuentas 3','Plan Cuentas 3','19000','DEPOSITOS',13,0,NULL),(3412,'Plan Cuentas 3','Plan Cuentas 3','19100','COSTOS DE ORGANIZACION',13,0,NULL),(3413,'Plan Cuentas 3','Plan Cuentas 3','19150','ACCUM. AMORTIZ. - COSTOS DE ORG.',13,0,NULL),(3414,'Plan Cuentas 3','Plan Cuentas 3','19200','NOTAS POR COBRAR-NO CORRIENTE',13,0,NULL),(3415,'Plan Cuentas 3','Plan Cuentas 3','19900','OTROS ACTIVOS NO CORRIENTES',13,0,NULL),(3416,'Plan Cuentas 3','Plan Cuentas 3','20000','CUENTAS POR PAGAR',21,0,NULL),(3417,'Plan Cuentas 3','Plan Cuentas 3','23000','GASTOS ACUMULADOS',21,0,NULL),(3418,'Plan Cuentas 3','Plan Cuentas 3','23100','IMPUESTO SOBRE VENTAS PAGABLE',21,0,NULL),(3419,'Plan Cuentas 3','Plan Cuentas 3','23200','SUELDOS PAGABLES',21,0,NULL),(3420,'Plan Cuentas 3','Plan Cuentas 3','23300','DEDUCCIONES PAGABLES',21,0,NULL),(3421,'Plan Cuentas 3','Plan Cuentas 3','23400','IMPUESTOS SOBRE NOMINA FEDERAL PAGABLE',21,0,NULL),(3422,'Plan Cuentas 3','Plan Cuentas 3','23500','IMPUESTO DE FUTA PAGABLE',21,0,NULL),(3423,'Plan Cuentas 3','Plan Cuentas 3','23600','IMPUESTO DE NOMINA ESTATAL PAGABLE',21,0,NULL),(3424,'Plan Cuentas 3','Plan Cuentas 3','23700','SUTA PAGABLE',21,0,NULL),(3425,'Plan Cuentas 3','Plan Cuentas 3','23800','IMPUESTOS SOBRE NOMINA LOCAL PAGABLE',21,0,NULL),(3426,'Plan Cuentas 3','Plan Cuentas 3','23900','IMPUESTO SOBRE LA RENTA PAGABLE',21,0,NULL),(3427,'Plan Cuentas 3','Plan Cuentas 3','24000','OTROS IMPUESTOS PAGABLES',21,0,NULL),(3428,'Plan Cuentas 3','Plan Cuentas 3','24100','BENEFICIOS A EMPLEADOS PAGABLES',21,0,NULL),(3429,'Plan Cuentas 3','Plan Cuentas 3','24200','PORCION CORRIENTE - DEUDA DE LARGO PLAZO',21,0,NULL),(3430,'Plan Cuentas 3','Plan Cuentas 3','24400','DEPOSITOS DE CLIENTES',21,0,NULL),(3431,'Plan Cuentas 3','Plan Cuentas 3','24500','CONTRATOS PAGABLES',21,0,NULL),(3432,'Plan Cuentas 3','Plan Cuentas 3','24800','OTROS PASIVOS CORRIENTES',21,0,NULL),(3433,'Plan Cuentas 3','Plan Cuentas 3','24810','PRESTAMOS DE ACCIONISTA',23,0,NULL),(3434,'Plan Cuentas 3','Plan Cuentas 3','24900','CUENTA DE COMPENSACION  - SUSPENSION',21,0,NULL),(3435,'Plan Cuentas 3','Plan Cuentas 3','27000','NOTAS PAGABLES - NO CORRIENTES',22,0,NULL),(3436,'Plan Cuentas 3','Plan Cuentas 3','27100','CONTRATOS PAGABLES - NO CORRIENTES',22,0,NULL),(3437,'Plan Cuentas 3','Plan Cuentas 3','27400','OTROS PASIVOS DE LARGO PLAZO',22,0,NULL),(3438,'Plan Cuentas 3','Plan Cuentas 3','30000','CAPITAL',30,0,NULL),(3439,'Plan Cuentas 3','Plan Cuentas 3','30200','SALDOS INICIALES',30,0,NULL),(3440,'Plan Cuentas 3','Plan Cuentas 3','35000','UTILIDADES RETENIDOS',40,0,NULL),(3441,'Plan Cuentas 3','Plan Cuentas 3','40000','HONORARIOS PROFESIONALES',50,0,NULL),(3442,'Plan Cuentas 3','Plan Cuentas 3','40200','PAGOS DE AGENCIAS',50,0,NULL),(3443,'Plan Cuentas 3','Plan Cuentas 3','40300','TARIFAS DE IMPUESTO',50,0,NULL),(3444,'Plan Cuentas 3','Plan Cuentas 3','40400','VENTAS DE MATERIALES',50,0,NULL),(3445,'Plan Cuentas 3','Plan Cuentas 3','40500','HONORARIOS DE CONSULTA',50,0,NULL),(3446,'Plan Cuentas 3','Plan Cuentas 3','40600','INGRESOS DE SOBRETIEMPO',50,0,NULL),(3447,'Plan Cuentas 3','Plan Cuentas 3','40700','OTROS INGRESOS',50,0,NULL),(3448,'Plan Cuentas 3','Plan Cuentas 3','40800','INGRESOS POR INTERESES',50,0,NULL),(3449,'Plan Cuentas 3','Plan Cuentas 3','45400','INGRESOS POR CARGOS FINANCIEROS',50,0,NULL),(3450,'Plan Cuentas 3','Plan Cuentas 3','45500','CARGOS DE TRANSPORTE REEMBOLSADOS',50,0,NULL),(3451,'Plan Cuentas 3','Plan Cuentas 3','48000','REEMBOLSOS VENTAS/HONORARIOS',50,0,NULL),(3452,'Plan Cuentas 3','Plan Cuentas 3','49000','DESCUENTOS VENTAS/HONORARIOS',50,0,NULL),(3453,'Plan Cuentas 3','Plan Cuentas 3','50000','COSTO DE VENTAS',70,0,NULL),(3454,'Plan Cuentas 3','Plan Cuentas 3','57000','COSTO DE VENTAS - SALARIOS Y SUELDOS',70,0,NULL),(3455,'Plan Cuentas 3','Plan Cuentas 3','60000','GASTO DE COMPRA POR DEFECTO',80,0,NULL),(3456,'Plan Cuentas 3','Plan Cuentas 3','60100','GASTOS DE PROMOCION',70,0,NULL),(3457,'Plan Cuentas 3','Plan Cuentas 3','60200','GASTOS DE MARKETING',80,0,NULL),(3458,'Plan Cuentas 3','Plan Cuentas 3','60500','GASTOS DE AMORTIZACIÃ“N',80,0,NULL),(3459,'Plan Cuentas 3','Plan Cuentas 3','60500','CARGOS BANCARIOS',80,0,NULL),(3460,'Plan Cuentas 3','Plan Cuentas 3','61000','GASTOS DE AUTOMOVIL',80,0,NULL),(3461,'Plan Cuentas 3','Plan Cuentas 3','61200','EFECTIVO DE QUE NO DA CUENTA',80,0,NULL),(3462,'Plan Cuentas 3','Plan Cuentas 3','61500','GASTOS DE MALAS DEUDAS',80,0,NULL),(3463,'Plan Cuentas 3','Plan Cuentas 3','62000','GASTOS DE DONACIONES',80,0,NULL),(3464,'Plan Cuentas 3','Plan Cuentas 3','62500','PROMOCION DE CLIENTE',80,0,NULL),(3465,'Plan Cuentas 3','Plan Cuentas 3','63000','GASTOS DE COMISIONES Y GRATIFICACIONES',80,0,NULL),(3466,'Plan Cuentas 3','Plan Cuentas 3','63500','GASTOS DE DEPRECIACION',80,0,NULL),(3467,'Plan Cuentas 3','Plan Cuentas 3','64000','GASTOS DE CUOTAS Y SUSCRIPCIONES',80,0,NULL),(3468,'Plan Cuentas 3','Plan Cuentas 3','65000','GASTOS DE PROG. DE BENEFICIO DE EMPL.',80,0,NULL),(3469,'Plan Cuentas 3','Plan Cuentas 3','65500','GASTOS DE FLETE',80,0,NULL),(3470,'Plan Cuentas 3','Plan Cuentas 3','65500','GASTOS DE REGALOS',80,0,NULL),(3471,'Plan Cuentas 3','Plan Cuentas 3','66000','GASTOS DE ISR',80,0,NULL),(3472,'Plan Cuentas 3','Plan Cuentas 3','66500','GASTOS DE SEGURO',80,0,NULL),(3473,'Plan Cuentas 3','Plan Cuentas 3','67000','GASTOS DE SEGURO',80,0,NULL),(3474,'Plan Cuentas 3','Plan Cuentas 3','67500','GASTOS DE INTERESES',80,0,NULL),(3475,'Plan Cuentas 3','Plan Cuentas 3','68000','GASTOS DE LIMPIEZA Y LAVANDERIA',80,0,NULL),(3476,'Plan Cuentas 3','Plan Cuentas 3','68500','GASTOS LEGALES Y PROFESIONALES',80,0,NULL),(3477,'Plan Cuentas 3','Plan Cuentas 3','69000','GASTOS DE LICENCIAS',80,0,NULL),(3478,'Plan Cuentas 3','Plan Cuentas 3','69500','PERDIDAS SOBRE CHEQUES CON FONDOS INSUFICIENTES',80,0,NULL),(3479,'Plan Cuentas 3','Plan Cuentas 3','70000','GASTOS DE MANTENIMIENTO',80,0,NULL),(3480,'Plan Cuentas 3','Plan Cuentas 3','70500','GASTOS DE COMIDA Y ENTRETENIMIENTO',80,0,NULL),(3481,'Plan Cuentas 3','Plan Cuentas 3','71000','GASTOS DE OFICINA',80,0,NULL),(3482,'Plan Cuentas 3','Plan Cuentas 3','71500','GASTOS LEGALES Y CONTABLES',80,0,NULL),(3483,'Plan Cuentas 3','Plan Cuentas 3','72000','GASTOS DE IMPUESTO DE NOMINA',80,0,NULL),(3484,'Plan Cuentas 3','Plan Cuentas 3','72500','GASTOS DE MULTAS Y RECARGOS',80,0,NULL),(3485,'Plan Cuentas 3','Plan Cuentas 3','73000','OTROS IMPUESTOS',80,0,NULL),(3486,'Plan Cuentas 3','Plan Cuentas 3','73500','GASTOS DE CORREO',80,0,NULL),(3487,'Plan Cuentas 3','Plan Cuentas 3','73700','GASTOS PARA DESARROLLO PROFESIONAL',80,0,NULL),(3488,'Plan Cuentas 3','Plan Cuentas 3','74000','GASTOS DE RENTA O ARRENDAMIENTO',80,0,NULL),(3489,'Plan Cuentas 3','Plan Cuentas 3','74200','SALARIOS PROFESIONALES - FACTURABLES',80,0,NULL),(3490,'Plan Cuentas 3','Plan Cuentas 3','74500','SALARIOS PROFESIONALES - NO FACTURABLES',80,0,NULL),(3491,'Plan Cuentas 3','Plan Cuentas 3','75500','GASTOS DE SUMINISTROS',80,0,NULL),(3492,'Plan Cuentas 3','Plan Cuentas 3','75500','GASTOS DE REPARACION',80,0,NULL),(3493,'Plan Cuentas 3','Plan Cuentas 3','76000','GASTOS DE TELEFONO Y COMUNICACIONES',80,0,NULL),(3494,'Plan Cuentas 3','Plan Cuentas 3','76500','GASTOS DE VIAJE',80,0,NULL),(3495,'Plan Cuentas 3','Plan Cuentas 3','76700','CUOTAS PARA SUB CONTRATOS',80,0,NULL),(3496,'Plan Cuentas 3','Plan Cuentas 3','77000','GASTOS DE SALARIOS',80,0,NULL),(3497,'Plan Cuentas 3','Plan Cuentas 3','77500','GASTOS DE SUELDOS',80,0,NULL),(3498,'Plan Cuentas 3','Plan Cuentas 3','78000','GASTOS DE VIAJE',80,0,NULL),(3499,'Plan Cuentas 3','Plan Cuentas 3','78500','GASTOS DE SERVICIOS PUBLICOS',80,0,NULL),(3500,'Plan Cuentas 3','Plan Cuentas 3','79000','GASTOS DE TELEFONO',80,0,NULL),(3501,'Plan Cuentas 3','Plan Cuentas 3','79500','GASTOS DE CORREO',80,0,NULL),(3502,'Plan Cuentas 3','Plan Cuentas 3','80000','GASTOS DE FLETE',80,0,NULL),(3503,'Plan Cuentas 3','Plan Cuentas 3','82000','GASTOS DE ENTRENEMIENTO Y EDUCACION',80,0,NULL),(3504,'Plan Cuentas 3','Plan Cuentas 3','82500','GASTOS DE VIAJE',80,0,NULL),(3505,'Plan Cuentas 3','Plan Cuentas 3','83500','GASTOS DE CUOTAS DE SINDICATO PAGADO',80,0,NULL),(3506,'Plan Cuentas 3','Plan Cuentas 3','84000','GASTOS DE BENEFICIOS DE SINDICATO',80,0,NULL),(3507,'Plan Cuentas 3','Plan Cuentas 3','84500','RENTA - OFICINA',80,0,NULL),(3508,'Plan Cuentas 3','Plan Cuentas 3','85000','RENTA-EQUIPO',80,0,NULL),(3509,'Plan Cuentas 3','Plan Cuentas 3','85500','GASTOS DE ACUEDUCTO PRINCIPAL',80,0,NULL),(3510,'Plan Cuentas 3','Plan Cuentas 3','86000','GASTOS DE CORREO Y FLETE',80,0,NULL),(3511,'Plan Cuentas 3','Plan Cuentas 3','89000','OTROS GASTOS',80,0,NULL),(3512,'Plan Cuentas 3','Plan Cuentas 3','89500','DESC. DE COMPRA - GASTOS DE ITEMS',80,0,NULL),(3513,'Plan Cuentas 3','Plan Cuentas 3','90000','UTILIDAD/PÃ‰RDIDA SOBRE VENTA DE ACTIVOS',80,0,NULL),(3516,'Vietnamese','Vietnamese','111','Tiá»n mÄƒt',10,0,NULL),(3517,'Vietnamese','Vietnamese','1111','Tiá»n Viá»‡t Nam',10,0,NULL),(3518,'Vietnamese','Vietnamese','1112','Ngoáº¡i tá»‡',10,0,NULL),(3520,'Vietnamese','Vietnamese','1113','VÃ ng báº¡c Ä‘Ã¡ quÃ½, kim khÃ­ quÃ½',10,0,NULL),(3521,'Vietnamese','Vietnamese','112','Tiá»n gá»­i ngÃ¢n hÃ ng',10,0,NULL),(3522,'Vietnamese','Vietnamese','1121','Tiá»n Viá»‡t Nam',10,0,NULL),(3523,'Vietnamese','Vietnamese','1122','Ngoáº¡i tá»‡',10,0,NULL),(3524,'Vietnamese','Vietnamese','1123','VÃ ng báº¡c, Ä‘Ã¡ quÃ½, kim khÃ­ quÃ½',10,0,NULL),(3525,'Vietnamese','Vietnamese','131','Pháº£i thu khÃ¡ch hÃ ng',10,0,NULL),(3526,'Vietnamese','Vietnamese','133','Thuáº¿ giÃ¡ trá»‹ gia tÄƒng Ä‘Æ°á»£c kháº¥u trá»«',10,0,NULL),(3527,'Vietnamese','Vietnamese','1331','Thuáº¿ GTGT Ä‘Æ°á»£c kháº¥u trá»« cá»§a h-hoÃ¡, d-vá»¥',10,0,NULL),(3528,'Vietnamese','Vietnamese','1332','Thuáº¿ GTGT Ä‘Æ°á»£c kháº¥u trá»« cá»§a TSCÄ',10,0,NULL),(3529,'Vietnamese','Vietnamese','136','Pháº£i thu ná»™i bá»™',10,0,NULL),(3530,'Vietnamese','Vietnamese','1361','Vá»‘n kinh doanh á»Ÿ cÃ¡c Ä‘Æ¡n vá»‹ trá»±c thuá»™c',10,0,NULL),(3531,'Vietnamese','Vietnamese','1368','Pháº£i thu ná»™i bá»™ khÃ¡c',10,0,NULL),(3532,'Vietnamese','Vietnamese','138','Pháº£i thu khÃ¡c',13,0,NULL),(3533,'Vietnamese','Vietnamese','1381','TÃ i sáº£n thiáº¿u chá» xá»­ lÃ½',13,0,NULL),(3534,'Vietnamese','Vietnamese','1388','Pháº£i thu khÃ¡c',13,0,NULL),(3535,'Vietnamese','Vietnamese','139','Dá»± phÃ²ng pháº£i thu khÃ³ Ä‘Ã²i',13,0,NULL),(3536,'Vietnamese','Vietnamese','141','Táº¡m á»©ng',13,0,NULL),(3537,'Vietnamese','Vietnamese','142','Chi phÃ­ tráº£ trÆ°á»›c',13,0,NULL),(3538,'Vietnamese','Vietnamese','1421','Chi phÃ­ tráº£ trÆ°á»›c',13,0,NULL),(3539,'Vietnamese','Vietnamese','1422','Chi phÃ­ chá» káº¿t chuyá»ƒn',13,0,NULL),(3540,'Vietnamese','Vietnamese','144','Tháº¿ cháº¥p, kÃ½ cÆ°á»£c, kÃ½ quá»¹ ngáº¯n háº¡n',13,0,NULL),(3541,'Vietnamese','Vietnamese','211','TÃ i sáº£n cá»‘ Ä‘á»‹nh',11,0,NULL),(3542,'Vietnamese','Vietnamese','2111','Äáº¥t Ä‘ai',11,0,NULL),(3543,'Vietnamese','Vietnamese','2112','NhÃ  cá»­a, váº­t kiáº¿n trÃºc',11,0,NULL),(3544,'Vietnamese','Vietnamese','2113','MÃ¡y mÃ³c, thiáº¿t bá»‹',11,0,NULL),(3545,'Vietnamese','Vietnamese','2114','PhÆ°Æ¡ng tiá»‡n váº­n táº£i, truyá»n dáº«n',11,0,NULL),(3546,'Vietnamese','Vietnamese','2115','Thiáº¿t bá»‹, dá»¥ng cá»¥ quáº£n lÃ½',11,0,NULL),(3547,'Vietnamese','Vietnamese','2116','CÃ¢y lÃ¢u nÄƒm, sÃºc váº­t lÃ m viá»‡c cho s.pháº©m',11,0,NULL),(3548,'Vietnamese','Vietnamese','2118','TÃ i sáº£n cá»‘ Ä‘á»‹nh khÃ¡c',11,0,NULL),(3549,'Vietnamese','Vietnamese','212','TÃ i sáº£n cá»‘ Ä‘á»‹nh thuÃª tÃ i chÃ­nh',11,0,NULL),(3550,'Vietnamese','Vietnamese','213','TÃ i sáº£n cá»‘ Ä‘á»‹nh vÃ´ hÃ¬nh',11,0,NULL),(3551,'Vietnamese','Vietnamese','2131','Quyá»n sá»­ dá»¥ng Ä‘áº¥t',11,0,NULL),(3552,'Vietnamese','Vietnamese','2132','Chi phÃ­ thÃ nh láº­p doanh nghiá»‡p',11,0,NULL),(3553,'Vietnamese','Vietnamese','2133','Báº±ng phÃ¡t minh sÃ¡ng cháº¿',11,0,NULL),(3554,'Vietnamese','Vietnamese','2134','Chi phÃ­ nghiÃªn cá»©u phÃ¡t triá»ƒn',11,0,NULL),(3555,'Vietnamese','Vietnamese','2135','Chi phÃ­ vá» lá»£i tháº¿ thÆ°Æ¡ng máº¡i',11,0,NULL),(3556,'Vietnamese','Vietnamese','2138','TÃ i sáº£n cá»‘ Ä‘á»‹nh vÃ´ hÃ¬nh khÃ¡c',11,0,NULL),(3557,'Vietnamese','Vietnamese','214','Hao mÃ²n tÃ i sáº£n cá»‘ Ä‘á»‹nh',11,0,NULL),(3558,'Vietnamese','Vietnamese','2141','Hao mÃ²n tÃ i sáº£n cá»‘ Ä‘á»‹nh há»¯u hÃ¬nh',11,0,NULL),(3559,'Vietnamese','Vietnamese','2142','Hao mÃ²n tÃ i sáº£n cá»‘ Ä‘á»‹nh Ä‘i thuÃª',11,0,NULL),(3560,'Vietnamese','Vietnamese','2143','Hao mÃ²n tÃ i sáº£n cá»‘ Ä‘á»‹nh vÃ´ hÃ¬nh',11,0,NULL),(3561,'Vietnamese','Vietnamese','222','GÃ³p vá»‘n liÃªn doanh',13,0,NULL),(3562,'Vietnamese','Vietnamese','228','Äáº§u tÆ° dÃ i háº¡n khÃ¡c',13,0,NULL),(3563,'Vietnamese','Vietnamese','311','Vay ngáº¯n háº¡n',21,0,NULL),(3564,'Vietnamese','Vietnamese','315','Ná»£ dÃ i háº¡n Ä‘áº¿n háº¡n tráº£',21,0,NULL),(3565,'Vietnamese','Vietnamese','331','Pháº£i tráº£ ngÆ°á»i bÃ¡n',21,0,NULL),(3566,'Vietnamese','Vietnamese','333','Thuáº¿ vÃ  cÃ¡c khoáº£n pháº£i ná»™p cho nhÃ  nÆ°á»›c',21,0,NULL),(3567,'Vietnamese','Vietnamese','3331','Thuáº¿ giÃ¡ trá»‹ gia tÄƒng pháº£i ná»™p',21,0,NULL),(3568,'Vietnamese','Vietnamese','3332','Thuáº¿ tiÃªu thá»¥ Ä‘áº·c biá»‡t',21,0,NULL),(3569,'Vietnamese','Vietnamese','3333','Thuáº¿ xuáº¥t, nháº­p kháº©u',21,0,NULL),(3570,'Vietnamese','Vietnamese','3334','Thuáº¿ lá»£i tá»©c',21,0,NULL),(3571,'Vietnamese','Vietnamese','3338','CÃ¡c loáº¡i thuáº¿ khÃ¡c',21,0,NULL),(3572,'Vietnamese','Vietnamese','3339','PhÃ­, lá»‡ phÃ­ vÃ  cÃ¡c khoáº£n pháº£i ná»™p khÃ¡c',21,0,NULL),(3573,'Vietnamese','Vietnamese','334','Pháº£i tráº£ cÃ´ng nhÃ¢n viÃªn',21,0,NULL),(3574,'Vietnamese','Vietnamese','335','Chi phÃ­ pháº£i tráº£',21,0,NULL),(3575,'Vietnamese','Vietnamese','336','Pháº£i tráº£ ná»™i bá»™',21,0,NULL),(3576,'Vietnamese','Vietnamese','338','Pháº£i tráº£, pháº£i ná»™p khÃ¡c',23,0,NULL),(3577,'Vietnamese','Vietnamese','3381','TÃ i sáº£n thá»©a chá» xá»­ lÃ½',23,0,NULL),(3578,'Vietnamese','Vietnamese','3382','Kinh phÃ­ cÃ´ng Ä‘oÃ n',23,0,NULL),(3579,'Vietnamese','Vietnamese','3383','Báº£o hiá»ƒm xÃ£ há»™i',23,0,NULL),(3580,'Vietnamese','Vietnamese','3384','Báº£o hiá»ƒm y táº¿',23,0,NULL),(3581,'Vietnamese','Vietnamese','3387','Doanh thu nháº­n trá»©Æ¡c',23,0,NULL),(3582,'Vietnamese','Vietnamese','3388','Pháº£i tráº£, pháº£i ná»™p khÃ¡c',23,0,NULL),(3583,'Vietnamese','Vietnamese','341','Vay dÃ i háº¡n',22,0,NULL),(3584,'Vietnamese','Vietnamese','342','Ná»£ dÃ i háº¡n',22,0,NULL),(3585,'Vietnamese','Vietnamese','344','Nháº­n kÃ½ quá»¹, kÃ½ cÆ°á»£c dÃ i háº¡n',22,0,NULL),(3586,'Vietnamese','Vietnamese','511','Doanh thu bÃ¡n hÃ ng',50,0,NULL),(3587,'Vietnamese','Vietnamese','5111','Doanh thu bÃ¡n hÃ ng hoÃ¡',50,0,NULL),(3588,'Vietnamese','Vietnamese','5112','Doanh thu bÃ¡n cÃ¡c thÃ nh pháº©m',50,0,NULL),(3589,'Vietnamese','Vietnamese','5113','Doanh thu cung cáº¥p dá»‹ch vá»¥',50,0,NULL),(3590,'Vietnamese','Vietnamese','5114','Doanh thu trá»£ cáº¥p, trá»£ giÃ¡',50,0,NULL),(3591,'Vietnamese','Vietnamese','512','Doanh thu bÃ¡n hÃ ng ná»™i bá»™',50,0,NULL),(3592,'Vietnamese','Vietnamese','5121','Doanh thu bÃ¡n hÃ ng hoÃ¡',50,0,NULL),(3593,'Vietnamese','Vietnamese','5122','Doanh thu bÃ¡n sáº£n pháº©m',50,0,NULL),(3594,'Vietnamese','Vietnamese','5123','Doanh thu cung cáº¥p dá»‹ch vá»¥',50,0,NULL),(3595,'Vietnamese','Vietnamese','521','Chiáº¿t kháº¥u bÃ¡n hÃ ng',60,0,NULL),(3596,'Vietnamese','Vietnamese','5211','Chiáº¿t kháº¥u bÃ¡n hÃ ng hoÃ¡',60,0,NULL),(3597,'Vietnamese','Vietnamese','5212','Chiáº¿t kháº¥u thÃ nh pháº©m',60,0,NULL),(3598,'Vietnamese','Vietnamese','5213','Chiáº¿t kháº¥u dá»‹ch vá»¥',60,0,NULL),(3599,'Vietnamese','Vietnamese','531','HÃ ng bÃ¡n bá»‹ tráº£ láº¡i',60,0,NULL),(3600,'Vietnamese','Vietnamese','532','Giáº£m giÃ¡ hÃ ng bÃ¡n',60,0,NULL),(3601,'Vietnamese','Vietnamese','635','Chi phÃ­ hoáº¡t Ä‘á»™ng tÃ i chÃ­nh',90,0,NULL),(3602,'Vietnamese','Vietnamese','641','Chi phÃ­ bÃ¡n hÃ ng',70,0,NULL),(3603,'Vietnamese','Vietnamese','6411','Chi phÃ­ nhÃ¢n viÃªn',70,0,NULL),(3604,'Vietnamese','Vietnamese','6412','Chi phÃ­ vÃ¢t liá»‡u bao bÃ¬',70,0,NULL),(3605,'Vietnamese','Vietnamese','6413','Chi phÃ­ dá»¥ng cá»¥ Ä‘á»“ dÃ¹ng',70,0,NULL),(3606,'Vietnamese','Vietnamese','6414','Chi phÃ­ kháº¥u hao TSCÄ',70,0,NULL),(3607,'Vietnamese','Vietnamese','6415','Chi phÃ­ báº£o hÃ nh',70,0,NULL),(3608,'Vietnamese','Vietnamese','6417','Chi phÃ­ dá»‹ch vá»¥ mua ngoÃ i',70,0,NULL),(3609,'Vietnamese','Vietnamese','6418','Chi phÃ­ báº±ng tiá»n khÃ¡c',70,0,NULL),(3610,'Vietnamese','Vietnamese','642','Chi phÃ­ quáº£n lÃ½ doanh nghiá»‡p',80,0,NULL),(3611,'Vietnamese','Vietnamese','6421','Chi phÃ­ nhÃ¢n viÃªn quáº£n lÃ½',80,0,NULL),(3612,'Vietnamese','Vietnamese','6422','Chi phÃ­ vÃ¢t liá»‡u quáº£n lÃ½',80,0,NULL),(3613,'Vietnamese','Vietnamese','6423','Chi phÃ­ Ä‘á»“ dÃ¹ng vÄƒn phÃ²ng',80,0,NULL),(3614,'Vietnamese','Vietnamese','6424','Chi phÃ­ kháº¥u hao TSCÄ',80,0,NULL),(3615,'Vietnamese','Vietnamese','6425','Thuáº¿, phÃ­ vÃ  lá»‡ phÃ­',80,0,NULL),(3616,'Vietnamese','Vietnamese','6426','Chi phÃ­ dá»± phÃ²ng',80,0,NULL),(3617,'Vietnamese','Vietnamese','6427','Chi phÃ­ dá»‹ch vá»¥ mua ngoÃ i',80,0,NULL),(3618,'Vietnamese','Vietnamese','6428','Chi phÃ­ báº±ng tiá»n khÃ¡c',80,0,NULL),(3619,'Vietnamese','Vietnamese','711','Thu nháº­p hoáº¡t Ä‘á»™ng tÃ i chÃ­nh',90,0,NULL),(3620,'Vietnamese','Vietnamese','721','CÃ¡c khoáº£n thu nháº­p báº¥t thÆ°á»ng',90,0,NULL),(3621,'Vietnamese','Vietnamese','811','Chi phÃ­ hoáº¡t Ä‘á»™ng tÃ i chÃ­nh',90,0,NULL),(3622,'Vietnamese','Vietnamese','821','Chi phÃ­ báº¥t thÆ°á»ng',90,0,NULL),(5431,'OsaÃ¼hing','OsaÃ¼hing','70300','Masinate ja seadmete amortisatsioon',80,0,NULL),(5430,'OsaÃ¼hing','OsaÃ¼hing','70200','Ehitiste amortisatsioon',80,0,NULL),(5429,'OsaÃ¼hing','OsaÃ¼hing','70100','Kinnisvarainvesteeringu amortisatsioon',80,0,NULL),(5428,'OsaÃ¼hing','OsaÃ¼hing','70000','PÃµhivara kulum ja vÃ¤Ã¤rtuse langus',80,0,NULL),(5425,'OsaÃ¼hing','OsaÃ¼hing','60510','Puhkusetasu reserv',80,0,NULL),(5426,'OsaÃ¼hing','OsaÃ¼hing','60520','TÃ¶Ã¶tuskindlustusmakse puhkusetasu reserv',80,0,NULL),(5427,'OsaÃ¼hing','OsaÃ¼hing','60530','Sotsiaalmaks puhkusetasu reserv',80,0,NULL),(5424,'OsaÃ¼hing','OsaÃ¼hing','60500','Puhkusetasu reservi kulu',80,0,NULL),(5423,'OsaÃ¼hing','OsaÃ¼hing','60400','Kogumispensioni makse',80,0,NULL),(5422,'OsaÃ¼hing','OsaÃ¼hing','60300','TÃ¶Ã¶tuskindlustusmakse',80,0,NULL),(5419,'OsaÃ¼hing','OsaÃ¼hing','60110','Palgakulu',80,0,NULL),(5420,'OsaÃ¼hing','OsaÃ¼hing','60120','HaigushÃ¼vitis',80,0,NULL),(5421,'OsaÃ¼hing','OsaÃ¼hing','60200','Sotsiaalmaks',80,0,NULL),(5418,'OsaÃ¼hing','OsaÃ¼hing','60000','TÃ¶Ã¶jÃµukulud',80,0,NULL),(5417,'OsaÃ¼hing','OsaÃ¼hing','59900','Muud tegevuskulud',80,0,NULL),(5416,'OsaÃ¼hing','OsaÃ¼hing','59800','Muud halduskulud',80,0,NULL),(5413,'OsaÃ¼hing','OsaÃ¼hing','58110','Tulumaks vastuvÃµtukuludelt',80,0,NULL),(5414,'OsaÃ¼hing','OsaÃ¼hing','59100','Lootusetud debitoorsed vÃµlad',80,0,NULL),(5415,'OsaÃ¼hing','OsaÃ¼hing','59700','Muud turustuskulud',80,0,NULL),(5412,'OsaÃ¼hing','OsaÃ¼hing','58100','KÃ¼laliste vastuvÃµtukulud',80,0,NULL),(5410,'OsaÃ¼hing','OsaÃ¼hing','56420','Sotsiaalmaks erisoodustustelt',80,0,NULL),(5411,'OsaÃ¼hing','OsaÃ¼hing','57100','Transpordi- ja saatekulud',80,0,NULL),(4933,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','86200','Muud finantskulud',80,0,NULL),(4930,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','85100','Kasum valuutakursi muutustest',90,0,NULL),(4931,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','85200','kahjum valuutakursimuutustest',80,0,NULL),(4932,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','86100','Muud finantstulud',90,0,NULL),(4928,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','84100','Intresstulud',90,0,NULL),(4929,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','84200','Intressikulud',80,0,NULL),(4926,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','83100','Finantstulud muudelt pikaajalistelt finantsinvesteeringutelt',90,0,NULL),(4927,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','83200','Finantskulud muudelt pikaajalistelt finantsinvesteeringutelt',80,0,NULL),(4925,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','82200','Finantskulud sidusettevÃµtte aktsiadelt/osadelt',80,0,NULL),(4924,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','82100','Finantstulud sidusettevÃµtjate aktsiatelt/osadelt',90,0,NULL),(4923,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','81200','Finantskulud tÃ¼tarettevÃµtete aktsiatelt/osadelt',80,0,NULL),(4922,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','81100','Finantstulud tÃ¼tarettevÃµtjate aktsiatelt/osadelt',90,0,NULL),(4919,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70290','Muud Ã¤rikulud',80,0,NULL),(4920,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70300','Ãœmardamised',80,0,NULL),(4921,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','80000','Finantstulud ja -kulud',90,0,NULL),(4918,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70280','Tulumaks tegevusega mitteseotud kuludelt',80,0,NULL),(4917,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70270','Tegevusega mitteseotud kulud',80,0,NULL),(4916,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70260','Kahjum kinnisvarainvesteeringute mÃ¼Ã¼gist',80,0,NULL),(4913,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70230','Viivised',80,0,NULL),(4914,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70240','Leppetrahvid',80,0,NULL),(4915,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70250','Kahjum pÃµhivara mÃ¼Ã¼gist',80,0,NULL),(4912,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70220','Maksuameti intressid ja viivised',80,0,NULL),(4910,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70200','Muud Ã¤rikulud',80,0,NULL),(4911,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70210','Valuutakursikahjum arveldusest',80,0,NULL),(4909,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70040','Immateriaalse pÃµhivara amortisatsioon',80,0,NULL),(4908,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70030','Muu materiaalse pÃµhivara amortisatsioon',80,0,NULL),(4907,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70020','Masinate seadmete amortisatsioon',80,0,NULL),(4905,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70000','PÃµhivara kulum ja vÃ¤Ã¤rtuse langus',80,0,NULL),(4906,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','70010','Hoonete rajatiste amortisatsioon',80,0,NULL),(4904,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60773','Sotsiaalmaks puhkusetasu reserv',80,0,NULL),(4902,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60771','Puhkusetasu reserv',80,0,NULL),(4903,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60772','TÃ¶Ã¶tuskindlustusmakse puhkusetasu reserv',80,0,NULL),(4901,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60770','Puhkusetasu reservi kulu',80,0,NULL),(4900,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60760','Kogumispensioni makse',80,0,NULL),(4899,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60750','TÃ¶Ã¶tuskindlustusmakse',80,0,NULL),(4897,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60730','HaigushÃ¼vitis',80,0,NULL),(4898,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60740','Sotsiaalmaks',80,0,NULL),(4896,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60720','Juhatuse liikme tasu',80,0,NULL),(4894,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60700','TÃ¶Ã¶jÃµukulud',80,0,NULL),(4895,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60710','Palgakulu',80,0,NULL),(4892,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60400','Ãœhingute liikmemaksud',80,0,NULL),(4893,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60500','Muud tegevuskulud',80,0,NULL),(4891,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60302','Sotsiaalmaks erisoodustused',80,0,NULL),(4890,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60301','Tulumaks erisoodustused',80,0,NULL),(4889,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60300','Erisoodustused',80,0,NULL),(4886,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60270','Austamiskulud',80,0,NULL),(4888,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60290','Majapidamiskulud',80,0,NULL),(4887,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60280','Maamaks',80,0,NULL),(4885,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60260','RiigilÃµivud',80,0,NULL),(4883,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60240','VÃ¤hevÃ¤Ã¤rtuslik pÃµhivara',80,0,NULL),(4884,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60250','Postikulu perioodika',80,0,NULL),(4881,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60221','Tulumaks vastuvÃµtukuludelt',80,0,NULL),(4882,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60230','Lootusetud debitoorsed vÃµlad',80,0,NULL),(4879,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60210','Koolituskulud',80,0,NULL),(4880,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60220','KÃ¼laliste vastuvÃµtukulud',80,0,NULL),(4877,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60190','Varakindlustus',80,0,NULL),(4878,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60200','Reklaam',80,0,NULL),(4876,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60180','Transporditeenused',80,0,NULL),(4874,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60160','Konsultatsioonid',80,0,NULL),(4875,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60170','Juriidilised kulud',80,0,NULL),(4872,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60144','Halduskulud',80,0,NULL),(4873,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60150','Pangateenused',80,0,NULL),(4870,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60142','Vesi',80,0,NULL),(4871,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60143','KÃ¼ttekulud',80,0,NULL),(4869,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60141','Elekter',80,0,NULL),(4866,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60120','Masinate seadmete rent',80,0,NULL),(4867,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60130','Ruumide rent',80,0,NULL),(4868,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60140','Kommunaalkulud',80,0,NULL),(4864,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60100','Isikliku sÃµiduauto kompensatsioon',80,0,NULL),(4865,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60110','Liikluskindlustus',80,0,NULL),(4862,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60092','Mobiiltelefon',80,0,NULL),(4863,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60093','InternetiÃ¼hendus',80,0,NULL),(4860,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60090','Sidekulud',80,0,NULL),(4861,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60091','Fikstelefon',80,0,NULL),(4859,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60080','Raamatupidamisteenused',80,0,NULL),(4857,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60060','Ãœhiskondlike alade korrashoid (niitmiskulu sh kÃ¼tus jms)',80,0,NULL),(4858,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60070','Kraavide hooldus',80,0,NULL),(4856,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60050','Teede ehitus',80,0,NULL),(4855,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60040','Teede hÃ¶Ã¶veldus lumekoristus',80,0,NULL),(4854,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60030','TÃ¤navavalgustuse elektrikulu',80,0,NULL),(4853,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60020','TÃ¤navavalgustuse elektri seadmete hooldus',80,0,NULL),(4851,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60000','Mitmesugused tegevuskulud',80,0,NULL),(4852,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','60010','Teiste teenuste kulud',80,0,NULL),(4850,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','52040','Jagatud muud mittesihtotstarbelised toetused',80,0,NULL),(4849,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','52030','Jagatud stipendiumid',80,0,NULL),(4847,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','52010','Jagatud annetused',80,0,NULL),(4848,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','52020','Jagatud toetused',80,0,NULL),(4845,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','51040','Jagatud muud sihtotstarbelised toetused',80,0,NULL),(4846,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','52000','Jagatud mittesihtotstarbelised toetused',80,0,NULL),(4844,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','51030','Jagatud stipendiumid',80,0,NULL),(4843,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','51020','Jagatud toetused',80,0,NULL),(4840,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','50000','Jagatud annetused toetused ja stipendiumid',80,0,NULL),(4841,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','51000','Jagatud sihtotstarbelised toetused',80,0,NULL),(4842,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','51010','Jagatud annetused',80,0,NULL),(4839,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41190','Muud sihtotsrabelised kulud',80,0,NULL),(4838,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41180','Biopuhasti keemia',80,0,NULL),(4837,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41170','Vee ja reovee proovid ning analÃ¼Ã¼sid',80,0,NULL),(4835,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41150','Setete (fekaali) Ã¤ravedu',80,0,NULL),(4836,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41160','Elektrikulu (vee ja reovee pumpad sh BP)',80,0,NULL),(4834,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41140','Biopuhasti hooldus',80,0,NULL),(4833,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41130','Elektriseadmete hooldus',80,0,NULL),(4832,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41120','Keskkonnatasud (vee eritasu jms)',80,0,NULL),(4831,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41110','Sihtfin.kÃ¤idukulud seoses Veevar ja Reovee Ã¤rajuht.',80,0,NULL),(4829,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41090','Biopuhasti elektriseadmete remont hooldus jms',80,0,NULL),(4830,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41100','Biopuhasti pumpade remont ost jms',80,0,NULL),(4828,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41080','Biopuhasti seadmete remont ost jms',80,0,NULL),(4827,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41070','Biopuhasti hoone remont ehitus jms',80,0,NULL),(4825,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41050','Ãœlepumplate remondi- ja ehituskulu',80,0,NULL),(4826,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41060','Reoveepumpade remont ost jms',80,0,NULL),(4824,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41040','Vee-ja Kanalisatsioonitrasside remondikulud',80,0,NULL),(4823,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41030','Veepumpade remont ost jms',80,0,NULL),(4820,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41000','Sihtfinantseerimise projektide kulud',80,0,NULL),(4821,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41010','Sihtfin.remondi ja taastamiskulud',80,0,NULL),(4822,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','41020','Puurkaevu ja pumbajaama hoone remondikulud',80,0,NULL),(4819,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','40000','Sihtotstarbeliste projektide otsekulud',80,0,NULL),(4817,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','34600','Tulud valuutakursi muutusest',90,0,NULL),(4818,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','34700','Ãœmardused',90,0,NULL),(4816,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','34500','Valuutakursikasum arveldustest',90,0,NULL),(4815,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','34400','Muud pÃµhitegevusega mitteseotud tulud',90,0,NULL),(4813,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','34200','Leppetrahvid',90,0,NULL),(4814,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','34300','Kasum pÃµhivara mÃ¼Ã¼gist',90,0,NULL),(4811,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','34000','Muud Ã¤ritulud',90,0,NULL),(4812,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','34100','Viivised ostjate arvetelt',90,0,NULL),(4810,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','33500','Muud ettevÃµtluse tulud',90,0,NULL),(4809,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','33400','Tulud kaupade mÃ¼Ã¼gist Euroopa Liit',90,0,NULL),(4807,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','33200','Tulud kaupade mÃ¼Ã¼gist Eesti Vabariik',90,0,NULL),(4808,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','33300','Tulud teenuste mÃ¼Ã¼gist Euroopa Liit',90,0,NULL),(4806,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','33100','Tulud teenuste mÃ¼Ã¼gist Eesti Vabariik',90,0,NULL),(4805,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','33000','Tulu ettevÃµtlusest',90,0,NULL),(4804,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','32000','Netotulu finantsinvesteeringutelt',90,0,NULL),(4803,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','31220','Muud sihtotstarbelised toetused',90,0,NULL),(4802,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','31210','Sihtfinantseerimine projektide katteks',90,0,NULL),(4801,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','31200','Sihtotstarbelised annetused ja toetused',90,0,NULL),(4799,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','31100','Mittesihtotstarbelised annetused ja toetused',90,0,NULL),(4800,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','31110','Muud mittesihtotstarbelised toetused',90,0,NULL),(4798,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','31000','Annetused ja toetused',90,0,NULL),(4797,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','30330','Muud sihtotstarbelised laekumised',90,0,NULL),(4793,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','30220','Muud mittesihtotstarbelised laekumised',90,0,NULL),(4794,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','30300','Sihtotstarbelised laekumised',90,0,NULL),(4795,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','30310','Sihtlaekumised Veevarustuse teenuse osutamisest',90,0,NULL),(4796,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','30320','Sihtlaekumised Reovee Ã¤rajuhtimisteenuse osutamisest',90,0,NULL),(5409,'OsaÃ¼hing','OsaÃ¼hing','56410','Tulumaks erisoodustustelt',80,0,NULL),(5407,'OsaÃ¼hing','OsaÃ¼hing','56300','TÃ¶Ã¶kaitse ja tervishoid',80,0,NULL),(5408,'OsaÃ¼hing','OsaÃ¼hing','56400','Erisoodustused',80,0,NULL),(5406,'OsaÃ¼hing','OsaÃ¼hing','56200','Personali tÃ¤iendÃµpe',80,0,NULL),(5405,'OsaÃ¼hing','OsaÃ¼hing','56140','LÃ¤hetuskulud - muu',80,0,NULL),(5404,'OsaÃ¼hing','OsaÃ¼hing','56130','LÃ¤hetuskulud - pÃ¤evarahad',80,0,NULL),(5403,'OsaÃ¼hing','OsaÃ¼hing','56120','LÃ¤hetuskulud - majutus',80,0,NULL),(5402,'OsaÃ¼hing','OsaÃ¼hing','56110','LÃ¤hetuskulud - transpordikulud',80,0,NULL),(5401,'OsaÃ¼hing','OsaÃ¼hing','56100','LÃ¤hetuskulud',80,0,NULL),(5400,'OsaÃ¼hing','OsaÃ¼hing','55500','Masinate/seadmete rent',80,0,NULL),(5399,'OsaÃ¼hing','OsaÃ¼hing','55400','Autorent',80,0,NULL),(5398,'OsaÃ¼hing','OsaÃ¼hing','55300','Isikliku sÃµiduauto kasutamise kompensatsioon',80,0,NULL),(5397,'OsaÃ¼hing','OsaÃ¼hing','55200','Liikluskindlustus',80,0,NULL),(5396,'OsaÃ¼hing','OsaÃ¼hing','55100','Autoremont ja hoolduskulud',80,0,NULL),(5395,'OsaÃ¼hing','OsaÃ¼hing','55000','AutokÃ¼tus ja kulud',80,0,NULL),(5393,'OsaÃ¼hing','OsaÃ¼hing','53900','Koolituskulud',80,0,NULL),(5394,'OsaÃ¼hing','OsaÃ¼hing','54000','Reklaam',80,0,NULL),(5392,'OsaÃ¼hing','OsaÃ¼hing','53800','Transporditeenused',80,0,NULL),(5391,'OsaÃ¼hing','OsaÃ¼hing','53700','Majapidamiskulud',80,0,NULL),(5390,'OsaÃ¼hing','OsaÃ¼hing','53600','Raamatupidamisteenused',80,0,NULL),(5389,'OsaÃ¼hing','OsaÃ¼hing','53500','Konsultatsioonikulud',80,0,NULL),(5388,'OsaÃ¼hing','OsaÃ¼hing','53400','RiigilÃµivud',80,0,NULL),(5387,'OsaÃ¼hing','OsaÃ¼hing','53300','Juriidilised kulud',80,0,NULL),(5386,'OsaÃ¼hing','OsaÃ¼hing','53200','Lepingutasud',80,0,NULL),(5385,'OsaÃ¼hing','OsaÃ¼hing','53100','Pangateenused',80,0,NULL),(5384,'OsaÃ¼hing','OsaÃ¼hing','52300','InternetiÃ¼hendus',80,0,NULL),(5383,'OsaÃ¼hing','OsaÃ¼hing','52200','Mobiiltelefoni kulud',80,0,NULL),(5382,'OsaÃ¼hing','OsaÃ¼hing','52100','Fikstelefoni kulud',80,0,NULL),(5381,'OsaÃ¼hing','OsaÃ¼hing','52000','Sidekulu',80,0,NULL),(5380,'OsaÃ¼hing','OsaÃ¼hing','51600','Perioodika ja postikulu',80,0,NULL),(5379,'OsaÃ¼hing','OsaÃ¼hing','51500','Info ja Ãµppematerjalid',80,0,NULL),(5378,'OsaÃ¼hing','OsaÃ¼hing','51400','Arvutite- ja vÃµrguhooldus',80,0,NULL),(5377,'OsaÃ¼hing','OsaÃ¼hing','51300','Kontoriinventari hooldus ja remont',80,0,NULL),(5376,'OsaÃ¼hing','OsaÃ¼hing','51200','VÃ¤hevÃ¤Ã¤rtuslik pÃµhivara',80,0,NULL),(5375,'OsaÃ¼hing','OsaÃ¼hing','51100','Kantseleitarbed',80,0,NULL),(5374,'OsaÃ¼hing','OsaÃ¼hing','50400','Kontori tÃ¶Ã¶koja valvekulud',80,0,NULL),(5373,'OsaÃ¼hing','OsaÃ¼hing','50300','Kontori tÃ¶Ã¶koja kindlustus',80,0,NULL),(5372,'OsaÃ¼hing','OsaÃ¼hing','50200','Kontori tÃ¶Ã¶koja korrashoid',80,0,NULL),(5370,'OsaÃ¼hing','OsaÃ¼hing','50130','KÃ¼ttekulud',80,0,NULL),(5371,'OsaÃ¼hing','OsaÃ¼hing','50140','Halduskulud',80,0,NULL),(5369,'OsaÃ¼hing','OsaÃ¼hing','50120','Vesi',80,0,NULL),(5368,'OsaÃ¼hing','OsaÃ¼hing','50110','Elekter',80,0,NULL),(5366,'OsaÃ¼hing','OsaÃ¼hing','50000','ÃœÃ¼rikulud',80,0,NULL),(5367,'OsaÃ¼hing','OsaÃ¼hing','50100','Kommunaalkulud',80,0,NULL),(5365,'OsaÃ¼hing','OsaÃ¼hing','44300','Transpordikulud ostul',80,0,NULL),(5364,'OsaÃ¼hing','OsaÃ¼hing','44200','Tollikulud',80,0,NULL),(5363,'OsaÃ¼hing','OsaÃ¼hing','44100','KÃ¤sitluskulud ostul',80,0,NULL),(5362,'OsaÃ¼hing','OsaÃ¼hing','44000','Kasutusjuhendid ja pakendid',80,0,NULL),(5360,'OsaÃ¼hing','OsaÃ¼hing','43000','Mitmesugused tegevuskulud',80,0,NULL),(5361,'OsaÃ¼hing','OsaÃ¼hing','43010','Ostetud teenused',80,0,NULL),(5359,'OsaÃ¼hing','OsaÃ¼hing','42000','Eesti Vabariigist mÃ¼Ã¼giks ostetud kaubad',80,0,NULL),(5358,'OsaÃ¼hing','OsaÃ¼hing','41200','Euroopa Liidust mÃ¼Ã¼giks ostetud kaubad',80,0,NULL),(5357,'OsaÃ¼hing','OsaÃ¼hing','41100','Euroopa Liidust ostetud toore ja materjal',80,0,NULL),(5356,'OsaÃ¼hing','OsaÃ¼hing','41000','Eesti Vabariigist ostetud toore ja materjal',80,0,NULL),(5355,'OsaÃ¼hing','OsaÃ¼hing','40000','Kaubad/toore/materjal ja teenused',80,0,NULL),(5353,'OsaÃ¼hing','OsaÃ¼hing','37500','Muud Ã¤ritulud',90,0,NULL),(5354,'OsaÃ¼hing','OsaÃ¼hing','37600','Ãœmardused',90,0,NULL),(5352,'OsaÃ¼hing','OsaÃ¼hing','37400','Valuutakursikasum arveldustest',90,0,NULL),(5351,'OsaÃ¼hing','OsaÃ¼hing','37300','Viivised ostjate arvetelt',90,0,NULL),(5349,'OsaÃ¼hing','OsaÃ¼hing','37100','Tulud mitte pÃµhitegevusega seotud mÃ¼Ã¼gist',90,0,NULL),(5350,'OsaÃ¼hing','OsaÃ¼hing','37200','Kasum pÃµhivara mÃ¼Ã¼gist',90,0,NULL),(5348,'OsaÃ¼hing','OsaÃ¼hing','37000','Muud Ã¤ritulud',90,0,NULL),(5346,'OsaÃ¼hing','OsaÃ¼hing','36100','Kauba eksport km 0%',90,0,NULL),(5347,'OsaÃ¼hing','OsaÃ¼hing','36200','Teenuste eksport km 0%',90,0,NULL),(5345,'OsaÃ¼hing','OsaÃ¼hing','35400','Teenuste mÃ¼Ã¼k Euroopa Liidus km 20%',90,0,NULL),(5344,'OsaÃ¼hing','OsaÃ¼hing','35300','Kauba mÃ¼Ã¼k Euroopa Liidus km 20%',90,0,NULL),(5343,'OsaÃ¼hing','OsaÃ¼hing','35200','Teenuste mÃ¼Ã¼k Euroopa Liidus km 0%',90,0,NULL),(5342,'OsaÃ¼hing','OsaÃ¼hing','35100','Kauba mÃ¼Ã¼k Euroopa Liidus km 0%',90,0,NULL),(5341,'OsaÃ¼hing','OsaÃ¼hing','34000','KÃ¤ibemaksuvaba kÃ¤ive',90,0,NULL),(5340,'OsaÃ¼hing','OsaÃ¼hing','33000','MÃ¼Ã¼k Eesti Vabariigis km 9%',90,0,NULL),(5339,'OsaÃ¼hing','OsaÃ¼hing','32000','Teenuste mÃ¼Ã¼k Eesti Vabariigis km 20%',90,0,NULL),(5338,'OsaÃ¼hing','OsaÃ¼hing','31000','Kauba mÃ¼Ã¼k Eesti Vabariigis km 20%',90,0,NULL),(5337,'OsaÃ¼hing','OsaÃ¼hing','30000','MÃ¼Ã¼gitulu',90,0,NULL),(5336,'OsaÃ¼hing','OsaÃ¼hing','29500','Aruandeaasta kasum kahjum',23,0,NULL),(5335,'OsaÃ¼hing','OsaÃ¼hing','29400','Eelmiste perioodide jaotamata kasum kahjum',40,0,NULL),(5333,'OsaÃ¼hing','OsaÃ¼hing','29310','Muud reservid',23,0,NULL),(5334,'OsaÃ¼hing','OsaÃ¼hing','29320','Kohustuslik reservkapital',23,0,NULL),(5332,'OsaÃ¼hing','OsaÃ¼hing','29300','Reservid',23,0,NULL),(5331,'OsaÃ¼hing','OsaÃ¼hing','29200','Oma osad vÃµi aktsiad miinus',23,0,NULL),(5330,'OsaÃ¼hing','OsaÃ¼hing','29100','Ãœlekurss aa?io',23,0,NULL),(5329,'OsaÃ¼hing','OsaÃ¼hing','29000','Osa- aktsia- kapital nimivÃ¤Ã¤rtuses',23,0,NULL),(5328,'OsaÃ¼hing','OsaÃ¼hing','28610','Pensionieraldised',21,0,NULL),(5326,'OsaÃ¼hing','OsaÃ¼hing','28530','Muud pikaajalised vÃµlad',21,0,NULL),(5327,'OsaÃ¼hing','OsaÃ¼hing','28600','Pikaajalised eraldised',21,0,NULL),(5325,'OsaÃ¼hing','OsaÃ¼hing','28520','Pikaajalised vÃµlad sidusettevÃµtjatele',21,0,NULL),(5324,'OsaÃ¼hing','OsaÃ¼hing','28510','Pikaajalised vÃµlad emaettevÃµtjatele ja teistele grupi ettevÃµtetele',21,0,NULL),(5322,'OsaÃ¼hing','OsaÃ¼hing','28400','Pikaajalised konverteeritavad vÃµlakohustused',22,0,NULL),(5323,'OsaÃ¼hing','OsaÃ¼hing','28500','Muud pikaajalised vÃµlakohustused',21,0,NULL),(5321,'OsaÃ¼hing','OsaÃ¼hing','28300','Pikaajalised kapitalirendi kohustused',22,0,NULL),(5320,'OsaÃ¼hing','OsaÃ¼hing','28200','Pikaajalised vÃµlakirjad',21,0,NULL),(5318,'OsaÃ¼hing','OsaÃ¼hing','28000','Pikaajalised vÃµlakohustused',22,0,NULL),(5319,'OsaÃ¼hing','OsaÃ¼hing','28100','Pikaajalised laenud',22,0,NULL),(5316,'OsaÃ¼hing','OsaÃ¼hing','26000','LÃ¼hiajalised eraldised',21,0,NULL),(5317,'OsaÃ¼hing','OsaÃ¼hing','27000','Ettelaekunud tulevaste perioodide tulud',21,0,NULL),(5315,'OsaÃ¼hing','OsaÃ¼hing','25300','IntressivÃµlad',21,0,NULL),(5314,'OsaÃ¼hing','OsaÃ¼hing','25200','DividendivÃµlad',21,0,NULL),(5313,'OsaÃ¼hing','OsaÃ¼hing','25140','Puhkuseatasu reservi tÃ¶Ã¶tuskindlustusmakse',21,0,NULL),(5312,'OsaÃ¼hing','OsaÃ¼hing','25130','Puhkusetasu reservi sotsiaalmaks',21,0,NULL),(5310,'OsaÃ¼hing','OsaÃ¼hing','25110','Palga vahekonto',21,0,NULL),(5311,'OsaÃ¼hing','OsaÃ¼hing','25120','Puhkusetasu reserv',21,0,NULL),(5309,'OsaÃ¼hing','OsaÃ¼hing','25100','VÃµlad tÃ¶Ã¶vÃµtjatele',21,0,NULL),(5307,'OsaÃ¼hing','OsaÃ¼hing','24710','Maamaksu intressivÃµlg',21,0,NULL),(5308,'OsaÃ¼hing','OsaÃ¼hing','25000','ViitvÃµlad',21,0,NULL),(5305,'OsaÃ¼hing','OsaÃ¼hing','24630','Erisoodustuste tulumaksu intressivÃµlg',21,0,NULL),(5306,'OsaÃ¼hing','OsaÃ¼hing','24700','Maamaksu vÃµlg',21,0,NULL),(5304,'OsaÃ¼hing','OsaÃ¼hing','24620','Erisoodustuste tulumaksu vÃµlg',21,0,NULL),(5303,'OsaÃ¼hing','OsaÃ¼hing','24610','EttevÃµtte tulumaksu intressivÃµlg',21,0,NULL),(5302,'OsaÃ¼hing','OsaÃ¼hing','24600','EttevÃµtte tulumaksu vÃµlg',21,0,NULL),(5301,'OsaÃ¼hing','OsaÃ¼hing','24520','Sotsiaalmaksu intressivÃµlg',21,0,NULL),(5300,'OsaÃ¼hing','OsaÃ¼hing','24510','Sotsiaalmaksu viitvÃµlg',21,0,NULL),(5299,'OsaÃ¼hing','OsaÃ¼hing','24500','Sotsiaalmaksu vÃµlg',21,0,NULL),(5298,'OsaÃ¼hing','OsaÃ¼hing','24420','Kogumispensioni makse intressivÃµlg',21,0,NULL),(5297,'OsaÃ¼hing','OsaÃ¼hing','24410','Kogumispensioni makse viitvÃµlg',21,0,NULL),(5296,'OsaÃ¼hing','OsaÃ¼hing','24400','Kogumispensioni makse vÃµlg',21,0,NULL),(5295,'OsaÃ¼hing','OsaÃ¼hing','24320','TÃ¶Ã¶tuskindlustusmakse intressivÃµlg',21,0,NULL),(5294,'OsaÃ¼hing','OsaÃ¼hing','24310','TÃ¶Ã¶tuskindlustusmakse viitvÃµlg',21,0,NULL),(5293,'OsaÃ¼hing','OsaÃ¼hing','24300','TÃ¶Ã¶tuskindlustusmakse vÃµlg',21,0,NULL),(5292,'OsaÃ¼hing','OsaÃ¼hing','24220','Isiku tulumaksu intressivÃµlg',21,0,NULL),(5291,'OsaÃ¼hing','OsaÃ¼hing','24210','Isiku tulumaksu viitvÃµlg',21,0,NULL),(5290,'OsaÃ¼hing','OsaÃ¼hing','24200','Isiku tulumaksu vÃµlg',21,0,NULL),(5289,'OsaÃ¼hing','OsaÃ¼hing','24170','KÃ¤ibemaks ostul 9%',21,0,NULL),(5288,'OsaÃ¼hing','OsaÃ¼hing','24160','KÃ¤ibemaks ostul 20%',21,0,NULL),(5287,'OsaÃ¼hing','OsaÃ¼hing','24151','Maksud ettemaksukontole',21,0,NULL),(5286,'OsaÃ¼hing','OsaÃ¼hing','24150','KÃ¤ibemaksu intressivÃµlg',21,0,NULL),(5285,'OsaÃ¼hing','OsaÃ¼hing','24140','KÃ¤ibemaks Euroopa Liit 9%',21,0,NULL),(5284,'OsaÃ¼hing','OsaÃ¼hing','24130','KÃ¤ibemaks mÃ¼Ã¼gil 9%',21,0,NULL),(5283,'OsaÃ¼hing','OsaÃ¼hing','24120','KÃ¤ibemaks Euroopa Liit 20%',21,0,NULL),(5282,'OsaÃ¼hing','OsaÃ¼hing','24110','KÃ¤ibemaks mÃ¼Ã¼gil 20%',21,0,NULL),(5281,'OsaÃ¼hing','OsaÃ¼hing','24100','KÃ¤ibemaksu vÃµlg km.kogumiskonto',21,0,NULL),(5280,'OsaÃ¼hing','OsaÃ¼hing','24000','MaksuvÃµlad',21,0,NULL),(5279,'OsaÃ¼hing','OsaÃ¼hing','23300','Muud lÃ¼hiajalised vÃµlad',21,0,NULL),(5278,'OsaÃ¼hing','OsaÃ¼hing','23200','VÃµlad sidusettevÃµtjale',21,0,NULL),(5277,'OsaÃ¼hing','OsaÃ¼hing','23100','VÃµlad emaettevÃµtjale ja teistele grupi ettevÃµtetele',21,0,NULL),(5275,'OsaÃ¼hing','OsaÃ¼hing','22200','VÃµlad tarnijatele Euroopa Liit',21,0,NULL),(5276,'OsaÃ¼hing','OsaÃ¼hing','23000','Muud lÃ¼hiajalised vÃµlad',21,0,NULL),(5273,'OsaÃ¼hing','OsaÃ¼hing','22000','VÃµlad tarnijatele',21,0,NULL),(5274,'OsaÃ¼hing','OsaÃ¼hing','22100','VÃµlad tarnijatele Eesti Vabariik',21,0,NULL),(5272,'OsaÃ¼hing','OsaÃ¼hing','21000','Ostjate ettemaksed',21,0,NULL),(5271,'OsaÃ¼hing','OsaÃ¼hing','20400','Konverteeritavad vÃµlakohustused',21,0,NULL),(5270,'OsaÃ¼hing','OsaÃ¼hing','20300','Pikaajalise kapitalirendi tagasimaksed jÃ¤rgmisel perioodil',22,0,NULL),(5269,'OsaÃ¼hing','OsaÃ¼hing','20200','Pikaajalise vÃµlakohustuse tagasimaksed jÃ¤rgmistel perioodidel',22,0,NULL),(5268,'OsaÃ¼hing','OsaÃ¼hing','20100','LÃ¼hiajalised laenud ja vÃµlakirjad',21,0,NULL),(5265,'OsaÃ¼hing','OsaÃ¼hing','19400','Ettemaksed immateriaalse pÃµhivara eest',11,0,NULL),(5266,'OsaÃ¼hing','OsaÃ¼hing','19500','Kulum immateriaalne pÃµhivara',11,0,NULL),(5267,'OsaÃ¼hing','OsaÃ¼hing','20000','VÃµlakohustused',21,0,NULL),(4792,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','30210','Mittesihtotstarbelised laekumised Teiste teenuste osut.',90,0,NULL),(4790,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','30100','Liikmemaksud',90,0,NULL),(4791,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','30200','Mittesihtotstarbelised laekumised',90,0,NULL),(4789,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','30000','Liikmetelt saadud tulud',90,0,NULL),(4788,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','26300','Aruandeaasta tulem',13,0,NULL),(4786,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','26110','Muud reservid',13,0,NULL),(4787,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','26200','Eelmiste perioodide akumuleeritud tulem',13,0,NULL),(4785,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','26100','Reservid',13,0,NULL),(4784,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','26000','Kapital',13,0,NULL),(4783,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','25030','Muud pikaajalised sihtlaekumised',22,0,NULL),(4782,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','25020','Pikaajalised sihtlaekumised vara remondiks',22,0,NULL),(4780,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','25000','Pikaajalised sihtlaekumised',22,0,NULL),(4781,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','25010','Pikaajalised sihtlaekumised pÃµhivara soetamiseks ja ehitamiseks',22,0,NULL),(4779,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','24040','Muud pikaajalised vÃµlad',22,0,NULL),(4776,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','24010','Pikaajalised laenud',22,0,NULL),(4777,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','24020','Pikaajalised vÃµlakirjed',22,0,NULL),(4778,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','24030','Pikaajalised kapitalirendi kohustused',22,0,NULL),(4775,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','24000','Pikaajalised vÃµlakohustused',22,0,NULL),(4773,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','23000','Pikaajalised konventeeritavad vÃµlakohustused',22,0,NULL),(4774,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','23010','Pikaajalised pangalaenud',22,0,NULL),(4772,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','22020','Muud sihtlaekumised',21,0,NULL),(4770,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','22000','LÃ¼hiajalised sihtlaekumised',21,0,NULL),(4771,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','22010','Sihtlaekumised projektidedele',21,0,NULL),(4769,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21710','EttevÃµtte tulumaksu intress',21,0,NULL),(4768,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21700','EttevÃµtte tulumaks',21,0,NULL),(4767,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21610','Maamaksu intressivÃµlg',21,0,NULL),(4766,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21600','Maamaksu vÃµlg',21,0,NULL),(4765,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21520','Kogumispensioni makse intress',21,0,NULL),(4764,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21510','Kogumispensioni makse viitvÃµlg',21,0,NULL),(4763,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21500','Kogumispensioni makse vÃµlg',21,0,NULL),(4762,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21420','TÃ¶Ã¶tuskindlustusmakse intress',21,0,NULL),(4761,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21410','TÃ¶Ã¶tuskindlustusmakse viitvÃµlg',21,0,NULL),(4760,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21400','TÃ¶Ã¶tuskindlustusmakse vÃµlg',21,0,NULL),(4758,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21310','Isiku tulumaksu viitvÃµlg',21,0,NULL),(4759,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21320','Isiku tulumaksu intress',21,0,NULL),(4757,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21300','Isiku tulumaksu vÃµlg',21,0,NULL),(4756,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21220','Sotsiaalmaksu intress',21,0,NULL),(4755,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21210','Sotsiaalmaksu viitvÃµlg',21,0,NULL),(4754,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21200','Sotsiaalmaksu vÃµlg',21,0,NULL),(4753,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21100','KÃ¤ibemaksuvaba kÃ¤ive',21,0,NULL),(4751,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20750','Puhkusetasu reserv tÃ¶Ã¶tuskindlustusmakse',21,0,NULL),(4752,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','21000','MaksuvÃµlad',21,0,NULL),(4750,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20740','Puhkusetasu reserv sotsiaalmaks',21,0,NULL),(4747,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20710','VÃµlad tÃ¶Ã¶vÃµtjatele',21,0,NULL),(4748,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20720','Muud kinnipidamised palgast',21,0,NULL),(4749,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20730','Puhkusetasu reserv',21,0,NULL),(4746,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20700','ViitvÃµlad',21,0,NULL),(4745,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20620','VÃµlgnevus tarnijatele Euroopa Liit',21,0,NULL),(4744,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20610','VÃµlgnevus tarnijatele Ã¼ld',21,0,NULL),(4743,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20600','VÃµlgnevus tarnijatele',21,0,NULL),(4742,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20520','Muude ostjate ettemaksed',21,0,NULL),(4741,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20510','Liikmete ettemaksed',21,0,NULL),(4740,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20500','Ostjate ettemaksed',21,0,NULL),(4739,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20410','LÃ¼hiajalised pangalaenud',21,0,NULL),(4737,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20300','Pikaajalise vÃµlakohustuse tagasimaksed jÃ¤rgmisel perioodil',21,0,NULL),(4738,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20400','Konventeeritavad vÃµlakohustused',21,0,NULL),(4735,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20210','VÃµlad aruandvatele isikutele',21,0,NULL),(4736,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20220','Muud lÃ¼hiajalised vÃµlad',21,0,NULL),(4734,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20200','Muud lÃ¼hiajalised vÃµlad',21,0,NULL),(4733,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20120','Tasumisele kuuluvad nÃµuded nÃµude loov.lep alusel',21,0,NULL),(4731,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20100','LÃ¼hiajalised laenud ja vÃµlakirjad',21,0,NULL),(4732,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20110','Laenud isikutelt',21,0,NULL),(4730,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','20000','VÃµlakohustused',21,0,NULL),(4729,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','19400','Ettemaksed immateriaalse pÃµhivara eest',11,0,NULL),(4727,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','19200','Patendid litsentsid kaubamÃ¤rgid',11,0,NULL),(4728,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','19300','Immateriaalse pÃµhivara akumuleeritud kulum',11,0,NULL),(4725,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','19000','Immateriaalne pÃµhivara',11,0,NULL),(4726,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','19100','ArenguvÃ¤ljaminekud',11,0,NULL),(4724,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','18500','Ettemaksed materiaalse pÃµhivara eest',11,0,NULL),(4723,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','18410','Muu materiaalse pÃµhivara akumuleeritud kulum',11,0,NULL),(4722,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','18400','Muu materiaalne pÃµhivara',11,0,NULL),(4721,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','18310','Masinate seadmete akumuleeritud kulum',11,0,NULL),(4719,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','18210','Hoonete rajatiste akumuleeritud kulum',11,0,NULL),(4720,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','18300','Masinad ja seadmed',11,0,NULL),(4718,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','18200','Hooned ja rajatised',11,0,NULL),(4717,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','18100','Maa',11,0,NULL),(4715,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','17000','Kinnisvarainvesteeringud',11,0,NULL),(4716,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','18000','Materiaalne pÃµhivara',11,0,NULL),(4713,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','16000','Pikaajalised finantsinvesteeringud',11,0,NULL),(4714,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','16100','Pikaajalised finantsinvesteeringud',11,0,NULL),(4711,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','15100','MÃ¼Ã¼giks ostetud kaubad',10,0,NULL),(4712,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','15200','Ettemaksed tarnijatele',10,0,NULL),(4710,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','15000','Varud',10,0,NULL),(4709,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','14300','Sihtlaekumiste Ã¼lekulu',10,0,NULL),(4707,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','14210','Remondifond - veevarustuse teenuste osutamine',10,0,NULL),(4708,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','14220','Remondifond - reovee Ã¤rajuhtimise teenuse osutamine',10,0,NULL),(4704,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','14000','Ettemaksed ja tagasinÃµuded',10,0,NULL),(4706,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','14200','Ettemakstud tulevaste perioodide kulud',10,0,NULL),(4705,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','14100','Maksude ettemaksed',10,0,NULL),(4700,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','13000','Viitlaekumised',10,0,NULL),(4701,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','13100','IntressinÃµuded',10,0,NULL),(4702,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','13200','ViivisenÃµuded',10,0,NULL),(4703,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','13300','Laekumata annetused ja toetused',10,0,NULL),(4699,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','12300','Muud lÃ¼hiajalised nÃµuded',10,0,NULL),(4696,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','12000','Muud lÃ¼hiajalised nÃµuded',10,0,NULL),(4698,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','12200','Tasaarveldused',10,0,NULL),(4697,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','12100','Aruandvad isikud',10,0,NULL),(4695,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','11500','EbatÃµenÃ¤oliselt laekuvad arved (-)',10,0,NULL),(4694,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','11400','Arveldused muude ostjatega',10,0,NULL),(4693,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','11300','Arveldused ostjatega (Kodu)',10,0,NULL),(4692,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','11200','Mitteliikmete arved',10,0,NULL),(4689,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','10400','SEB pank (Konto Leader2)',10,0,NULL),(4690,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','11000','Ostjate laekumata arved',10,0,NULL),(4691,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','11100','Liikmete  arved',10,0,NULL),(4685,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','10000','Raha ja pangakonto',10,0,NULL),(4688,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','10300','SEB pank (Kodu)',10,0,NULL),(4687,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','10200','SEB pank (MTÃœ)',10,0,NULL),(4686,'MittetulundusÃ¼hing','MittetulundusÃ¼hing','10100','Kassa',10,0,NULL),(5264,'OsaÃ¼hing','OsaÃ¼hing','19300','EttevÃµtte vÃ¤Ã¤rtus',11,0,NULL),(5263,'OsaÃ¼hing','OsaÃ¼hing','19200','Patendid- litsentsid ja kaubamÃ¤rgid',11,0,NULL),(5262,'OsaÃ¼hing','OsaÃ¼hing','19100','ArenguvÃ¤ljaminekud',11,0,NULL),(5261,'OsaÃ¼hing','OsaÃ¼hing','19000','Immateriaalne pÃµhivara',11,0,NULL),(5260,'OsaÃ¼hing','OsaÃ¼hing','18160','Ettemaksed materiaalse pÃµhivara eest',11,0,NULL),(5259,'OsaÃ¼hing','OsaÃ¼hing','18150','LÃµpetamata ehitised',11,0,NULL),(5258,'OsaÃ¼hing','OsaÃ¼hing','18143','Kulum muu materiaalne pÃµhivara',11,0,NULL),(5257,'OsaÃ¼hing','OsaÃ¼hing','18142','Kulum masinad ja seadmed',11,0,NULL),(5256,'OsaÃ¼hing','OsaÃ¼hing','18141','Kulum ehitised',11,0,NULL),(5255,'OsaÃ¼hing','OsaÃ¼hing','18140','Kulum kinnisvarainvesteeringud',11,0,NULL),(5254,'OsaÃ¼hing','OsaÃ¼hing','18130','Muu materiaalne pÃµhivara',11,0,NULL),(5253,'OsaÃ¼hing','OsaÃ¼hing','18120','Masinad ja seadmed',11,0,NULL),(5252,'OsaÃ¼hing','OsaÃ¼hing','18110','Maa ja ehitised',11,0,NULL),(5251,'OsaÃ¼hing','OsaÃ¼hing','18100','Materiaalne pÃµhivara',11,0,NULL),(5250,'OsaÃ¼hing','OsaÃ¼hing','18000','Kinnisvarainvesteeringud',11,0,NULL),(5249,'OsaÃ¼hing','OsaÃ¼hing','17600','Mitmesugused pikaajalised nÃµuded',11,0,NULL),(5248,'OsaÃ¼hing','OsaÃ¼hing','17500','Muud aksiad ja vÃ¤Ã¤rtpaberid',11,0,NULL),(5247,'OsaÃ¼hing','OsaÃ¼hing','17400','Pikaajalised nÃµuded sidusettevÃµtjate vastu',11,0,NULL),(5246,'OsaÃ¼hing','OsaÃ¼hing','17300','SidusettevÃµtjate aktsiad ja osad',11,0,NULL),(5245,'OsaÃ¼hing','OsaÃ¼hing','17200','Pikaajalised nÃµuded ema- ja teiste grupi ettevÃµtjate vastu',11,0,NULL),(5244,'OsaÃ¼hing','OsaÃ¼hing','17100','TÃ¼tarettevÃµtjate aktsiad ja osad',11,0,NULL),(5243,'OsaÃ¼hing','OsaÃ¼hing','17000','Pikaajalised finantsinvesteeringud',11,0,NULL),(5242,'OsaÃ¼hing','OsaÃ¼hing','16600','Ettemaksed tarnijatele',10,0,NULL),(5241,'OsaÃ¼hing','OsaÃ¼hing','16520','MÃ¼Ã¼giks ostetud kaubad Ladu 2',10,0,NULL),(5240,'OsaÃ¼hing','OsaÃ¼hing','16510','MÃ¼Ã¼giks ostetud kaubad Ladu 1',10,0,NULL),(5239,'OsaÃ¼hing','OsaÃ¼hing','16500','MÃ¼Ã¼giks ostetud kaubad',10,0,NULL),(5238,'OsaÃ¼hing','OsaÃ¼hing','16400','Valmistoodang',10,0,NULL),(5237,'OsaÃ¼hing','OsaÃ¼hing','16300','LÃµpetamata toodang',10,0,NULL),(5236,'OsaÃ¼hing','OsaÃ¼hing','16200','Tooraine ja material',10,0,NULL),(5235,'OsaÃ¼hing','OsaÃ¼hing','16100','Taara',10,0,NULL),(5234,'OsaÃ¼hing','OsaÃ¼hing','16000','Varud',10,0,NULL),(5233,'OsaÃ¼hing','OsaÃ¼hing','15300','Ettemakstud tulevaste perioodide kulud',10,0,NULL),(5232,'OsaÃ¼hing','OsaÃ¼hing','15200','Ettemakstud maksud',10,0,NULL),(5231,'OsaÃ¼hing','OsaÃ¼hing','15160','Tagatisraha',10,0,NULL),(5230,'OsaÃ¼hing','OsaÃ¼hing','15150','SisendkÃ¤ibemaks Euroopa Liidu kaupadelt 9%',10,0,NULL),(5229,'OsaÃ¼hing','OsaÃ¼hing','15140','PÃµhivara soetamisel tasutud kÃ¤ibemaks',10,0,NULL),(5228,'OsaÃ¼hing','OsaÃ¼hing','15130','Tollis impordilt tasutud kÃ¤ibemaks',10,0,NULL),(5227,'OsaÃ¼hing','OsaÃ¼hing','15120','SisendkÃ¤ibemaks- Euroopa Liidust soetatud kaupadelt 20%',10,0,NULL),(5226,'OsaÃ¼hing','OsaÃ¼hing','15110','SisendkÃ¤ibemaks- teenuste importimisel tasumisele kuuluv',10,0,NULL),(5225,'OsaÃ¼hing','OsaÃ¼hing','15100','SisendkÃ¤ibemaks',10,0,NULL),(5224,'OsaÃ¼hing','OsaÃ¼hing','15000','Ettemaksed ja tagasinÃµuded',10,0,NULL),(5223,'OsaÃ¼hing','OsaÃ¼hing','14400','Muud viitlaekumised',10,0,NULL),(5222,'OsaÃ¼hing','OsaÃ¼hing','14200','VÃ¤Ã¤rtpaberite dividendinÃµuded',10,0,NULL),(5221,'OsaÃ¼hing','OsaÃ¼hing','14100','Intressid',10,0,NULL),(5220,'OsaÃ¼hing','OsaÃ¼hing','14000','Viitlaekumised',10,0,NULL),(5219,'OsaÃ¼hing','OsaÃ¼hing','13300','Muud lÃ¼hiajalised nÃµuded',10,0,NULL),(5218,'OsaÃ¼hing','OsaÃ¼hing','13200','Aruandvad isikud',10,0,NULL),(5217,'OsaÃ¼hing','OsaÃ¼hing','13100','Tasaarveldused',10,0,NULL),(5216,'OsaÃ¼hing','OsaÃ¼hing','13000','Muud lÃ¼hiajalised nÃµuded',10,0,NULL),(5215,'OsaÃ¼hing','OsaÃ¼hing','12500','NÃµuded omanike vastu',10,0,NULL),(5214,'OsaÃ¼hing','OsaÃ¼hing','12400','NÃµuded sidusettevÃµtjate vastu',10,0,NULL),(5213,'OsaÃ¼hing','OsaÃ¼hing','12300','NÃµuded emaettevÃµtte ja teiste grupi ettevÃµtjate vastu',10,0,NULL),(5212,'OsaÃ¼hing','OsaÃ¼hing','12200','EbatÃµenÃ¤liselt laekuvad arved miinus',10,0,NULL),(5211,'OsaÃ¼hing','OsaÃ¼hing','12100','Ostjate laekumata arved',10,0,NULL),(5210,'OsaÃ¼hing','OsaÃ¼hing','12000','NÃµuded ostjate vastu',10,0,NULL),(5209,'OsaÃ¼hing','OsaÃ¼hing','11000','Aktsiad ja vÃ¤Ã¤rtpaberid',10,0,NULL),(5208,'OsaÃ¼hing','OsaÃ¼hing','10240','Marfin Pank',10,0,NULL),(5207,'OsaÃ¼hing','OsaÃ¼hing','10230','Sampo Pank',10,0,NULL),(5206,'OsaÃ¼hing','OsaÃ¼hing','10220','Swedbank',10,0,NULL),(5205,'OsaÃ¼hing','OsaÃ¼hing','10210','SEB Pank',10,0,NULL),(5204,'OsaÃ¼hing','OsaÃ¼hing','10200','Pangakontod',10,0,NULL),(5203,'OsaÃ¼hing','OsaÃ¼hing','10120','Kassa',10,0,NULL),(5202,'OsaÃ¼hing','OsaÃ¼hing','10110','Kassa POS',10,0,NULL),(5201,'OsaÃ¼hing','OsaÃ¼hing','10100','Kassa kokku',10,0,NULL),(5432,'OsaÃ¼hing','OsaÃ¼hing','70400','Muu pÃµhivara amortisatsioon',11,0,NULL),(5433,'OsaÃ¼hing','OsaÃ¼hing','71000','Muud Ã¤rikulud',80,0,NULL),(5434,'OsaÃ¼hing','OsaÃ¼hing','71010','Kahjum pÃµhivara mÃ¼Ã¼gist',80,0,NULL),(5435,'OsaÃ¼hing','OsaÃ¼hing','71020','Kahjum kinnisvarainvesteeringute mÃ¼Ã¼gist',80,0,NULL),(5436,'OsaÃ¼hing','OsaÃ¼hing','72000','EttevÃµtlusega mitteseotud kulud',80,0,NULL),(5437,'OsaÃ¼hing','OsaÃ¼hing','72100','Intressid maksuametile',80,0,NULL),(5438,'OsaÃ¼hing','OsaÃ¼hing','72200','Tulumaks ettevÃµtlusega mitteseotud kuludelt',80,0,NULL),(5439,'OsaÃ¼hing','OsaÃ¼hing','72300','Kingitused ja annetused',80,0,NULL),(5440,'OsaÃ¼hing','OsaÃ¼hing','72400','Tulumaks kingitustelt',80,0,NULL),(5441,'OsaÃ¼hing','OsaÃ¼hing','73100','Valuutakursikahjum arveldustest',80,0,NULL),(5442,'OsaÃ¼hing','OsaÃ¼hing','74100','Maamaks',80,0,NULL),(5443,'OsaÃ¼hing','OsaÃ¼hing','75100','Ãœhingute ja liitude liikmemaksud',80,0,NULL),(5444,'OsaÃ¼hing','OsaÃ¼hing','76100','Trahvid ja viivised',80,0,NULL),(5445,'OsaÃ¼hing','OsaÃ¼hing','79100','Muud Ã¤rikulud',80,0,NULL),(5446,'OsaÃ¼hing','OsaÃ¼hing','79200','Ãœmardamised',80,0,NULL),(5447,'OsaÃ¼hing','OsaÃ¼hing','80000','Finantstulud ja -kulud',90,0,NULL),(5448,'OsaÃ¼hing','OsaÃ¼hing','81000','Finantstulud tÃ¼tarettevÃµtjate aktsiatelt ja osadelt',90,0,NULL),(5449,'OsaÃ¼hing','OsaÃ¼hing','81100','Finantskulud tÃ¼tarettevÃµtjate aktsiatelt ja osadelt',80,0,NULL),(5450,'OsaÃ¼hing','OsaÃ¼hing','82000','Finantstulud sidusettevÃµtjate aktsiatelt ja osadelt',90,0,NULL),(5451,'OsaÃ¼hing','OsaÃ¼hing','82100','Finantskulud sidusettevÃµtjate aktsiatelt ja osadelt',80,0,NULL),(5452,'OsaÃ¼hing','OsaÃ¼hing','83000','Finantstulud muudelt pikaajalistelt finantsinvesteeringutelt',90,0,NULL),(5453,'OsaÃ¼hing','OsaÃ¼hing','83100','Finantskulud muudelt pikaajalistelt finantsinvesteeringutelt',80,0,NULL),(5454,'OsaÃ¼hing','OsaÃ¼hing','84000','Intressitulud',90,0,NULL),(5455,'OsaÃ¼hing','OsaÃ¼hing','84010','Intressitulud km vaba kÃ¤ive',90,0,NULL),(5456,'OsaÃ¼hing','OsaÃ¼hing','84100','Intressikulud',80,0,NULL),(5457,'OsaÃ¼hing','OsaÃ¼hing','85000','Kasum valuutakursi muutustest',90,0,NULL),(5458,'OsaÃ¼hing','OsaÃ¼hing','85100','Kahjum valuutakursi muutustest',80,0,NULL),(5459,'OsaÃ¼hing','OsaÃ¼hing','86000','Muud finantstulud',90,0,NULL),(5460,'OsaÃ¼hing','OsaÃ¼hing','86100','Muud finantskulud',80,0,NULL),(5461,'OsaÃ¼hing','OsaÃ¼hing','87000','Erakorralised tulud',90,0,NULL),(5462,'OsaÃ¼hing','OsaÃ¼hing','87100','Erakorralised kulud',80,0,NULL),(5463,'OsaÃ¼hing','OsaÃ¼hing','89000','Dividendide tulumaks',80,0,NULL),(5464,'OsaÃ¼hing','OsaÃ¼hing','89990','Arvestuslik tulemus',90,0,NULL),(5465,'OsaÃ¼hing','OsaÃ¼hing','90000','Lao ja ostureskontro vÃµrdlus',90,0,NULL),(5466,'OsaÃ¼hing','OsaÃ¼hing','99990','Reguleerimiskonto',90,0,NULL),(5467,'Canadian GIFI - Shor','Canadian GIFI - Short','1000','Cash and deposits',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(5468,'Canadian GIFI - Shor','Canadian GIFI - Short','1002','Deposits in Canadian banks - Canadian currency',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(5469,'Canadian GIFI - Shor','Canadian GIFI - Short','1003','Deposits in Canadian banks - Foreign currency',10,0,NULL),(5470,'Canadian GIFI - Shor','Canadian GIFI - Short','1004','Deposits in foreign banks - Canadian currency',10,0,NULL),(5471,'Canadian GIFI - Shor','Canadian GIFI - Short','1060','Accounts receivable',10,0,'arcompany.receivables'),(5472,'Canadian GIFI - Shor','Canadian GIFI - Short','1061','Allowance for doubtful accounts',10,0,NULL),(5473,'Canadian GIFI - Shor','Canadian GIFI - Short','1120','Inventories',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(5474,'Canadian GIFI - Shor','Canadian GIFI - Short','1126','Raw materials',10,0,NULL),(5475,'Canadian GIFI - Shor','Canadian GIFI - Short','1180','Short-term investments',10,0,NULL),(5476,'Canadian GIFI - Shor','Canadian GIFI - Short','1240','Loans and notes receivable',10,0,NULL),(5477,'Canadian GIFI - Shor','Canadian GIFI - Short','1482','Accrued investment income',10,0,NULL),(5478,'Canadian GIFI - Shor','Canadian GIFI - Short','1484','Prepaid expenses',10,0,NULL),(5479,'Canadian GIFI - Shor','Canadian GIFI - Short','1599','Total current assets',10,0,NULL),(5480,'Canadian GIFI - Shor','Canadian GIFI - Short','1600','Land',11,0,NULL),(5481,'Canadian GIFI - Shor','Canadian GIFI - Short','1601','Land improvements',11,0,NULL),(5482,'Canadian GIFI - Shor','Canadian GIFI - Short','1602','Accumulated amortization of land improvements',11,0,NULL),(5483,'Canadian GIFI - Shor','Canadian GIFI - Short','1680','Buildings',11,0,NULL),(5484,'Canadian GIFI - Shor','Canadian GIFI - Short','1681','Accumulated amortization of buildings',11,0,NULL),(5485,'Canadian GIFI - Shor','Canadian GIFI - Short','1787','Furniture and fixtures',11,0,NULL),(5486,'Canadian GIFI - Shor','Canadian GIFI - Short','1788','Accumulated amortization of furniture and fixtures',11,0,NULL),(5487,'Canadian GIFI - Shor','Canadian GIFI - Short','1900','Other tangible capital assets',11,0,NULL),(5488,'Canadian GIFI - Shor','Canadian GIFI - Short','1901','Accumulated amortization of other tangible capital assets',11,0,NULL),(5489,'Canadian GIFI - Shor','Canadian GIFI - Short','2010','Intangible assets',13,0,NULL),(5490,'Canadian GIFI - Shor','Canadian GIFI - Short','2011','Accumulated amortization of intangible assets',13,0,NULL),(5491,'Canadian GIFI - Shor','Canadian GIFI - Short','2178','Total intangible capital assets',13,0,NULL),(5492,'Canadian GIFI - Shor','Canadian GIFI - Short','2179','Total accumulated amortization of intangible capital assets',13,0,NULL),(5493,'Canadian GIFI - Shor','Canadian GIFI - Short','2300','Long-term investments',13,0,NULL),(5494,'Canadian GIFI - Shor','Canadian GIFI - Short','2627','Employee deductions payable',21,0,NULL),(5495,'Canadian GIFI - Shor','Canadian GIFI - Short','2628','Withholding taxes payable',21,0,NULL),(5496,'Canadian GIFI - Shor','Canadian GIFI - Short','2629','Interest payable',21,0,NULL),(5497,'Canadian GIFI - Shor','Canadian GIFI - Short','2680','Taxes payable',21,0,NULL),(5498,'Canadian GIFI - Shor','Canadian GIFI - Short','2700','Short-term debt',21,0,NULL),(5499,'Canadian GIFI - Shor','Canadian GIFI - Short','2701','Loans from Canadian banks',21,0,NULL),(5500,'Canadian GIFI - Shor','Canadian GIFI - Short','2960','Other current liabilities',21,0,'apcompany.payable;prcompany.glpayroll_payableid;prcompany.glmiscdedpayableid;arcompany.shipliability'),(5501,'Canadian GIFI - Shor','Canadian GIFI - Short','2961','Deposits received',21,0,'arcompany.depositglacctid'),(5502,'Canadian GIFI - Shor','Canadian GIFI - Short','2962','Dividends payable',21,0,NULL),(5503,'Canadian GIFI - Shor','Canadian GIFI - Short','3139','Total current liabilities',21,0,NULL),(5504,'Canadian GIFI - Shor','Canadian GIFI - Short','3140','Long Term debt',22,0,NULL),(5505,'Canadian GIFI - Shor','Canadian GIFI - Short','3141','Mortgages',22,0,NULL),(5506,'Canadian GIFI - Shor','Canadian GIFI - Short','3149','Line of credit',22,0,NULL),(5507,'Canadian GIFI - Shor','Canadian GIFI - Short','3210','Bonds and debentures',22,0,NULL),(5508,'Canadian GIFI - Shor','Canadian GIFI - Short','3320','Other long term liabilities',22,0,NULL),(5509,'Canadian GIFI - Shor','Canadian GIFI - Short','3450','Total long term liabilities',22,0,NULL),(5510,'Canadian GIFI - Shor','Canadian GIFI - Short','3499','Total liabilities',22,0,NULL),(5511,'Canadian GIFI - Shor','Canadian GIFI - Short','3640','Total liabilities and shareholder equity',30,0,NULL),(5512,'Canadian GIFI - Shor','Canadian GIFI - Short','3680','Net income/loss',40,0,NULL),(5513,'Canadian GIFI - Shor','Canadian GIFI - Short','8089','Total sales of goods and services',50,0,'invcompany.sales;arcompany.labor_sales_glacctid;arcompany.refund;arcompany.restockglid'),(5514,'Canadian GIFI - Shor','Canadian GIFI - Short','8210','Realized gains/losses on disposal of assets',50,0,NULL),(5515,'Canadian GIFI - Shor','Canadian GIFI - Short','8230','Other revenue',50,0,'arcompany.interest'),(5516,'Canadian GIFI - Shor','Canadian GIFI - Short','8320','Purchases/cost of materials',70,0,'apcompany.discount;arcompany.cost;invcompany.cost;invcompany.costadjustglacctid'),(5517,'Canadian GIFI - Shor','Canadian GIFI - Short','8520','Advertising and promotion',80,0,NULL),(5518,'Canadian GIFI - Shor','Canadian GIFI - Short','8570','Amortization of intangible assets',80,0,NULL),(5519,'Canadian GIFI - Shor','Canadian GIFI - Short','8590','Bad debt expense',80,0,'arcompany.baddebt'),(5520,'Canadian GIFI - Shor','Canadian GIFI - Short','8622','Employer',80,0,NULL),(5521,'Canadian GIFI - Shor','Canadian GIFI - Short','8690','Insurance',80,0,NULL),(5522,'Canadian GIFI - Shor','Canadian GIFI - Short','8691','Life insurance on executives',80,0,NULL),(5523,'Canadian GIFI - Shor','Canadian GIFI - Short','8710','Interest and bank charges',80,0,'apcompany.interestexpense'),(5524,'Canadian GIFI - Shor','Canadian GIFI - Short','8711','Interest on short-term debt',80,0,NULL),(5525,'Canadian GIFI - Shor','Canadian GIFI - Short','8712','Interest on bonds and debentures',80,0,NULL),(5526,'Canadian GIFI - Shor','Canadian GIFI - Short','8713','Interest on mortgages',80,0,NULL),(5527,'Canadian GIFI - Shor','Canadian GIFI - Short','8714','Interest on long-term debt',80,0,NULL),(5528,'Canadian GIFI - Shor','Canadian GIFI - Short','8715','Bank charges',80,0,'apcompany.servicecharges'),(5529,'Canadian GIFI - Shor','Canadian GIFI - Short','8716','Credit card charges',80,0,NULL),(5530,'Canadian GIFI - Shor','Canadian GIFI - Short','8717','Collection and credit costs',80,0,NULL),(5531,'Canadian GIFI - Shor','Canadian GIFI - Short','8740','Interest paid (financial institutions)',80,0,'apcompany.interestexpense'),(5532,'Canadian GIFI - Shor','Canadian GIFI - Short','8741','Interest paid on deposits',80,0,NULL),(5533,'Canadian GIFI - Shor','Canadian GIFI - Short','8742','Interest paid on bonds and debentures',80,0,NULL),(5534,'Canadian GIFI - Shor','Canadian GIFI - Short','8762','Business taxes',80,0,NULL),(5535,'Canadian GIFI - Shor','Canadian GIFI - Short','8763','Franchise fees',80,0,NULL),(5536,'Canadian GIFI - Shor','Canadian GIFI - Short','8764','Government fees',80,0,NULL),(5537,'Canadian GIFI - Shor','Canadian GIFI - Short','8780','New Brunswick tax on large corporations',80,0,NULL),(5538,'Canadian GIFI - Shor','Canadian GIFI - Short','8790','Nova Scotia tax on large corporations',80,0,NULL),(5539,'Canadian GIFI - Shor','Canadian GIFI - Short','8810','Office expenses',80,0,NULL),(5540,'Canadian GIFI - Shor','Canadian GIFI - Short','8811','Office stationery and supplies',80,0,NULL),(5541,'Canadian GIFI - Shor','Canadian GIFI - Short','8812','Office utilities',80,0,NULL),(5542,'Canadian GIFI - Shor','Canadian GIFI - Short','8860','Professional fees',80,0,NULL),(5543,'Canadian GIFI - Shor','Canadian GIFI - Short','8960','Repairs and maintenance',80,0,NULL),(5544,'Canadian GIFI - Shor','Canadian GIFI - Short','8961','Repairs and maintenance - Buildings',80,0,NULL),(5545,'Canadian GIFI - Shor','Canadian GIFI - Short','8962','Repairs and maintenance - Vehicles',80,0,NULL),(5546,'Canadian GIFI - Shor','Canadian GIFI - Short','8964','Repairs and maintenance - Machinery and equipment',80,0,NULL),(5547,'Canadian GIFI - Shor','Canadian GIFI - Short','9010','Other repairs and maintenance',80,0,NULL),(5548,'Canadian GIFI - Shor','Canadian GIFI - Short','9014','Garbage removal',80,0,NULL),(5549,'Canadian GIFI - Shor','Canadian GIFI - Short','9060','Salaries and wages',80,0,'apcompany.glcommissionid'),(5550,'Canadian GIFI - Shor','Canadian GIFI - Short','9130','Supplies',80,0,NULL),(5551,'Canadian GIFI - Shor','Canadian GIFI - Short','9152','Internet',80,0,NULL),(5552,'Canadian GIFI - Shor','Canadian GIFI - Short','9180','Property taxes',80,0,NULL),(5553,'Canadian GIFI - Shor','Canadian GIFI - Short','9200','Travel expenses',80,0,NULL),(5554,'Canadian GIFI - Shor','Canadian GIFI - Short','9201','Meetings and conventions',80,0,NULL),(5555,'Canadian GIFI - Shor','Canadian GIFI - Short','9220','Utilities',80,0,NULL),(5556,'Canadian GIFI - Shor','Canadian GIFI - Short','9221','Electricity',80,0,NULL),(5557,'Canadian GIFI - Shor','Canadian GIFI - Short','9222','Water',80,0,NULL),(5558,'Canadian GIFI - Shor','Canadian GIFI - Short','9223','Heat',80,0,NULL),(5559,'Canadian GIFI - Shor','Canadian GIFI - Short','9224','Fuel costs',80,0,NULL),(5560,'Canadian GIFI - Shor','Canadian GIFI - Short','9225','Telephone and telecommunications',80,0,NULL),(5561,'Canadian GIFI - Shor','Canadian GIFI - Short','9270','Other expenses',80,0,'invcompany.tax'),(5562,'Canadian GIFI - Shor','Canadian GIFI - Short','9271','Cash over/short',80,0,NULL),(5563,'Canadian GIFI - Shor','Canadian GIFI - Short','9275','Delivery freight and express',80,0,'invcompany.freight'),(5564,'Canadian GIFI - Shor','Canadian GIFI - Short','9281','Vehicle expenses',80,0,NULL),(5565,'Canadian GIFI - Shor','Canadian GIFI - Short','9282','Research and development',80,0,NULL),(5566,'Canadian GIFI - Shor','Canadian GIFI - Short','9283','Withholding taxes',80,0,NULL),(5567,'Canadian GIFI - Shor','Canadian GIFI - Short','9367','Total operating expenses',80,0,NULL),(5568,'Canadian GIFI - Shor','Canadian GIFI - Short','9368','Total expenses',80,0,NULL),(5569,'Canadian GIFI - Shor','Canadian GIFI - Short','9607','Interest income',90,0,NULL),(5570,'Canadian GIFI - Shor','Canadian GIFI - Short','9608','Dividend income',90,0,NULL),(5571,'Canadian GIFI - Shor','Canadian GIFI - Short','9793','Bad debt',90,0,NULL),(5572,'Canadian GIFI - Shor','Canadian GIFI - Short','9980','Unrealized gains/losses',90,0,NULL),(5573,'Canadian GIFI - Long','Canadian GIFI - Long','1000','Cash and deposits',10,0,NULL),(5574,'Canadian GIFI - Long','Canadian GIFI - Long','1001','Cash',10,0,'apcompany.glcashid; arcompany.cash; invcompany.cash'),(5575,'Canadian GIFI - Long','Canadian GIFI - Long','1002','Deposits in Canadian banks - Canadian currency',10,0,'apcompany.glccid; arcompany.checking; prcompany.glcheckaccountid'),(5576,'Canadian GIFI - Long','Canadian GIFI - Long','1003','Deposits in Canadian banks - Foreign currency',10,0,NULL),(5577,'Canadian GIFI - Long','Canadian GIFI - Long','1004','Deposits in foreign banks - Canadian currency',10,0,NULL),(5578,'Canadian GIFI - Long','Canadian GIFI - Long','1005','Deposits in foreign banks - Foreign currency',10,0,NULL),(5579,'Canadian GIFI - Long','Canadian GIFI - Long','1006','Credit union central deposits',10,0,NULL),(5580,'Canadian GIFI - Long','Canadian GIFI - Long','1007','Other cash-like instruments (Gold/Silver)',10,0,NULL),(5581,'Canadian GIFI - Long','Canadian GIFI - Long','1060','Accounts receivable',10,0,'arcompany.receivables'),(5582,'Canadian GIFI - Long','Canadian GIFI - Long','1061','Allowance for doubtful accounts',10,0,NULL),(5583,'Canadian GIFI - Long','Canadian GIFI - Long','1062','Trade accounts receivable',10,0,NULL),(5584,'Canadian GIFI - Long','Canadian GIFI - Long','1063','Allowance for doubtful trade accounts receivable',10,0,NULL),(5585,'Canadian GIFI - Long','Canadian GIFI - Long','1064','Trade accounts receivable from related parties',10,0,NULL),(5586,'Canadian GIFI - Long','Canadian GIFI - Long','1065','Allowance for doubtful trade accounts receivable from related parties',10,0,NULL),(5587,'Canadian GIFI - Long','Canadian GIFI - Long','1066','Taxes receivable',10,0,NULL),(5588,'Canadian GIFI - Long','Canadian GIFI - Long','1067','Interest receivable',10,0,NULL),(5589,'Canadian GIFI - Long','Canadian GIFI - Long','1068','Holdbacks receivable',10,0,NULL),(5590,'Canadian GIFI - Long','Canadian GIFI - Long','1069','Leases receivable',10,0,NULL),(5591,'Canadian GIFI - Long','Canadian GIFI - Long','1070','Allowance for doubtful amounts contained in leases receivable',10,0,NULL),(5592,'Canadian GIFI - Long','Canadian GIFI - Long','1071','Accounts receivable from employees',10,0,NULL),(5593,'Canadian GIFI - Long','Canadian GIFI - Long','1072','Allowance for doubtful accounts receivable from employees',10,0,NULL),(5594,'Canadian GIFI - Long','Canadian GIFI - Long','1073','Amounts receivable from members of NPOs',10,0,NULL),(5595,'Canadian GIFI - Long','Canadian GIFI - Long','1120','Inventories',10,0,NULL),(5596,'Canadian GIFI - Long','Canadian GIFI - Long','1121','Inventory of goods for sale',10,0,'arcompany.inventory;invcompany.default_inventoryglacct;invcompany.loss;invcompany.inventoryvariance'),(5597,'Canadian GIFI - Long','Canadian GIFI - Long','1122','Inventory parts and supplies',10,0,NULL),(5598,'Canadian GIFI - Long','Canadian GIFI - Long','1123','Inventory properties',10,0,NULL),(5599,'Canadian GIFI - Long','Canadian GIFI - Long','1124','Inventory of aggregates',10,0,NULL),(5600,'Canadian GIFI - Long','Canadian GIFI - Long','1125','Work in progress',10,0,NULL),(5601,'Canadian GIFI - Long','Canadian GIFI - Long','1126','Raw materials',10,0,NULL),(5602,'Canadian GIFI - Long','Canadian GIFI - Long','1127','Inventory of securities',10,0,NULL),(5603,'Canadian GIFI - Long','Canadian GIFI - Long','1180','Short-term investments',10,0,NULL),(5604,'Canadian GIFI - Long','Canadian GIFI - Long','1181','Canadian term deposits',10,0,NULL),(5605,'Canadian GIFI - Long','Canadian GIFI - Long','1182','Canadian shares',10,0,NULL),(5606,'Canadian GIFI - Long','Canadian GIFI - Long','1183','Canadian bonds',10,0,NULL),(5607,'Canadian GIFI - Long','Canadian GIFI - Long','1184','Canadian treasury bills',10,0,NULL),(5608,'Canadian GIFI - Long','Canadian GIFI - Long','1185','Securities purchased under resale agreements',10,0,NULL),(5609,'Canadian GIFI - Long','Canadian GIFI - Long','1186','Other short-term Canadian investments',10,0,NULL),(5610,'Canadian GIFI - Long','Canadian GIFI - Long','1187','Short-term foreign investments',10,0,NULL),(5611,'Canadian GIFI - Long','Canadian GIFI - Long','1240','Loans and notes receivable',10,0,NULL),(5612,'Canadian GIFI - Long','Canadian GIFI - Long','1241','Demand loans receivable',10,0,NULL),(5613,'Canadian GIFI - Long','Canadian GIFI - Long','1242','Other loans receivable',10,0,NULL),(5614,'Canadian GIFI - Long','Canadian GIFI - Long','1243','Notes receivable',10,0,NULL),(5615,'Canadian GIFI - Long','Canadian GIFI - Long','1244','Mortgages receivable',10,0,NULL),(5616,'Canadian GIFI - Long','Canadian GIFI - Long','1300','Due from shareholder(s)/director(s)',10,0,NULL),(5617,'Canadian GIFI - Long','Canadian GIFI - Long','1301','Due from individual shareholder(s)',10,0,NULL),(5618,'Canadian GIFI - Long','Canadian GIFI - Long','1302','Due from corporate shareholder(s)',10,0,NULL),(5619,'Canadian GIFI - Long','Canadian GIFI - Long','1303','Due from director(s)',10,0,NULL),(5620,'Canadian GIFI - Long','Canadian GIFI - Long','1360','Investment in joint venture(s)/partnership(s)',10,0,NULL),(5621,'Canadian GIFI - Long','Canadian GIFI - Long','1380','Due from joint venture(s)/partnership(s)',10,0,NULL),(5622,'Canadian GIFI - Long','Canadian GIFI - Long','1400','Due from/investment in related parties',10,0,NULL),(5623,'Canadian GIFI - Long','Canadian GIFI - Long','1401','Demand notes from related parties',10,0,NULL),(5624,'Canadian GIFI - Long','Canadian GIFI - Long','1402','Interest receivable from related parties',10,0,NULL),(5625,'Canadian GIFI - Long','Canadian GIFI - Long','1403','Loans/advances due from related parties',10,0,NULL),(5626,'Canadian GIFI - Long','Canadian GIFI - Long','1460','Customers',10,0,NULL),(5627,'Canadian GIFI - Long','Canadian GIFI - Long','1480','Other current assets',10,0,NULL),(5628,'Canadian GIFI - Long','Canadian GIFI - Long','1481','Future (deferred) income taxes',10,0,NULL),(5629,'Canadian GIFI - Long','Canadian GIFI - Long','1482','Accrued investment income',10,0,NULL),(5630,'Canadian GIFI - Long','Canadian GIFI - Long','1483','Taxes recoverable/refundable',10,0,NULL),(5631,'Canadian GIFI - Long','Canadian GIFI - Long','1484','Prepaid expenses',10,0,NULL),(5632,'Canadian GIFI - Long','Canadian GIFI - Long','1485','Drilling advances',10,0,NULL),(5633,'Canadian GIFI - Long','Canadian GIFI - Long','1486','Security/tender deposits',10,0,NULL),(5634,'Canadian GIFI - Long','Canadian GIFI - Long','1599','Total current assets',10,0,NULL),(5635,'Canadian GIFI - Long','Canadian GIFI - Long','1600','Land',11,0,NULL),(5636,'Canadian GIFI - Long','Canadian GIFI - Long','1601','Land improvements',11,0,NULL),(5637,'Canadian GIFI - Long','Canadian GIFI - Long','1602','Accumulated amortization of land improvements',11,0,NULL),(5638,'Canadian GIFI - Long','Canadian GIFI - Long','1620','Depletable assets',11,0,NULL),(5639,'Canadian GIFI - Long','Canadian GIFI - Long','1621','Accumulated amortization of depletable assets',11,0,NULL),(5640,'Canadian GIFI - Long','Canadian GIFI - Long','1622','Petroleum and natural gas properties',11,0,NULL),(5641,'Canadian GIFI - Long','Canadian GIFI - Long','1623','Accumulated amortization of oil petroleum and natural gas properties',11,0,NULL),(5642,'Canadian GIFI - Long','Canadian GIFI - Long','1624','Mining properties',11,0,NULL),(5643,'Canadian GIFI - Long','Canadian GIFI - Long','1625','Accumulated amortization of mining properties',11,0,NULL),(5644,'Canadian GIFI - Long','Canadian GIFI - Long','1626','Deferred exploration charges',11,0,NULL),(5645,'Canadian GIFI - Long','Canadian GIFI - Long','1627','Accumulated amortization of deferred exploration charges',11,0,NULL),(5646,'Canadian GIFI - Long','Canadian GIFI - Long','1628','Quarries',11,0,NULL),(5647,'Canadian GIFI - Long','Canadian GIFI - Long','1629','Accumulated amortization of quarries',11,0,NULL),(5648,'Canadian GIFI - Long','Canadian GIFI - Long','1630','Gravel pits',11,0,NULL),(5649,'Canadian GIFI - Long','Canadian GIFI - Long','1631','Accumulated amortization of gravel pits',11,0,NULL),(5650,'Canadian GIFI - Long','Canadian GIFI - Long','1632','Timber limits',11,0,NULL),(5651,'Canadian GIFI - Long','Canadian GIFI - Long','1633','Accumulated amortization of timber limits',11,0,NULL),(5652,'Canadian GIFI - Long','Canadian GIFI - Long','1680','Buildings',11,0,NULL),(5653,'Canadian GIFI - Long','Canadian GIFI - Long','1681','Accumulated amortization of buildings',11,0,NULL),(5654,'Canadian GIFI - Long','Canadian GIFI - Long','1682','Manufacturing plant',11,0,NULL),(5655,'Canadian GIFI - Long','Canadian GIFI - Long','1683','Accumulated amortization of manufacturing plant',11,0,NULL),(5656,'Canadian GIFI - Long','Canadian GIFI - Long','1684','Buildings under construction',11,0,NULL),(5657,'Canadian GIFI - Long','Canadian GIFI - Long','1740','Machinery equipment furniture and fixtures',11,0,NULL),(5658,'Canadian GIFI - Long','Canadian GIFI - Long','1741','Accumulated amortization of equipment and furnishings',11,0,NULL),(5659,'Canadian GIFI - Long','Canadian GIFI - Long','1742','Motor vehicles',11,0,NULL),(5660,'Canadian GIFI - Long','Canadian GIFI - Long','1743','Accumulated amortization of motor vehicles',11,0,NULL),(5661,'Canadian GIFI - Long','Canadian GIFI - Long','1744','Tools and dies',11,0,NULL),(5662,'Canadian GIFI - Long','Canadian GIFI - Long','1745','Accumulated amortization of tools and dies',11,0,NULL),(5663,'Canadian GIFI - Long','Canadian GIFI - Long','1746','Construction and excavating equipment',11,0,NULL),(5664,'Canadian GIFI - Long','Canadian GIFI - Long','1747','Accumulated amortization of construction and excavating equipment',11,0,NULL),(5665,'Canadian GIFI - Long','Canadian GIFI - Long','1748','Forestry and logging equipment',11,0,NULL),(5666,'Canadian GIFI - Long','Canadian GIFI - Long','1749','Accumulated amortization of forestry and logging equipment',11,0,NULL),(5667,'Canadian GIFI - Long','Canadian GIFI - Long','1750','Fishing gear and nets',11,0,NULL),(5668,'Canadian GIFI - Long','Canadian GIFI - Long','1751','Accumulated amortization of fishing gear and nets',11,0,NULL),(5669,'Canadian GIFI - Long','Canadian GIFI - Long','1752','Mining equipment',11,0,NULL),(5670,'Canadian GIFI - Long','Canadian GIFI - Long','1753','Accumulated amortization of mining equipment',11,0,NULL),(5671,'Canadian GIFI - Long','Canadian GIFI - Long','1754','Oil and gas systems',11,0,NULL),(5672,'Canadian GIFI - Long','Canadian GIFI - Long','1755','Accumulated amortization of oil and gas systems',11,0,NULL),(5673,'Canadian GIFI - Long','Canadian GIFI - Long','1756','Production equipment for resource industries',11,0,NULL),(5674,'Canadian GIFI - Long','Canadian GIFI - Long','1757','Accumulated amortization of production equipment for resource industries',11,0,NULL),(5675,'Canadian GIFI - Long','Canadian GIFI - Long','1758','Production equipment other than resources',11,0,NULL),(5676,'Canadian GIFI - Long','Canadian GIFI - Long','1759','Accumulated amortization of production equipment other than resources',11,0,NULL),(5677,'Canadian GIFI - Long','Canadian GIFI - Long','1760','Exploration equipment',11,0,NULL),(5678,'Canadian GIFI - Long','Canadian GIFI - Long','1761','Accumulated amortization of exploration equipment',11,0,NULL),(5679,'Canadian GIFI - Long','Canadian GIFI - Long','1762','Shipping equipment',11,0,NULL),(5680,'Canadian GIFI - Long','Canadian GIFI - Long','1763','Accumulated amortization of shipping equipment',11,0,NULL),(5681,'Canadian GIFI - Long','Canadian GIFI - Long','1764','Ships and boats',11,0,NULL),(5682,'Canadian GIFI - Long','Canadian GIFI - Long','1765','Accumulated amortization of ships and boats',11,0,NULL),(5683,'Canadian GIFI - Long','Canadian GIFI - Long','1766','Aircraft',11,0,NULL),(5684,'Canadian GIFI - Long','Canadian GIFI - Long','1767','Accumulated amortization of aircraft',11,0,NULL),(5685,'Canadian GIFI - Long','Canadian GIFI - Long','1768','Signs',11,0,NULL),(5686,'Canadian GIFI - Long','Canadian GIFI - Long','1769','Accumulated amortization of signs',11,0,NULL),(5687,'Canadian GIFI - Long','Canadian GIFI - Long','1770','Small tools',11,0,NULL),(5688,'Canadian GIFI - Long','Canadian GIFI - Long','1771','Accumulated amortization of small tools',11,0,NULL),(5689,'Canadian GIFI - Long','Canadian GIFI - Long','1772','Radio and communication equipment',11,0,NULL),(5690,'Canadian GIFI - Long','Canadian GIFI - Long','1773','Accumulated amortization of radio and communication equipment',11,0,NULL),(5691,'Canadian GIFI - Long','Canadian GIFI - Long','1774','Computer equipment/software',11,0,NULL),(5692,'Canadian GIFI - Long','Canadian GIFI - Long','1775','Accumulated amortization of computer equipment/software',11,0,NULL),(5693,'Canadian GIFI - Long','Canadian GIFI - Long','1776','Musical instruments',11,0,NULL),(5694,'Canadian GIFI - Long','Canadian GIFI - Long','1777','Accumulated amortization of musical instruments',11,0,NULL),(5695,'Canadian GIFI - Long','Canadian GIFI - Long','1778','Satellites',11,0,NULL),(5696,'Canadian GIFI - Long','Canadian GIFI - Long','1779','Accumulated amortization of satellites',11,0,NULL),(5697,'Canadian GIFI - Long','Canadian GIFI - Long','1780','Earth stations',11,0,NULL),(5698,'Canadian GIFI - Long','Canadian GIFI - Long','1781','Accumulated amortization of earth stations',11,0,NULL),(5699,'Canadian GIFI - Long','Canadian GIFI - Long','1782','Machinery and equipment under construction',11,0,NULL),(5700,'Canadian GIFI - Long','Canadian GIFI - Long','1783','Transportation equipment',11,0,NULL),(5701,'Canadian GIFI - Long','Canadian GIFI - Long','1784','Accumulated amortization of transportation equipment',11,0,NULL),(5702,'Canadian GIFI - Long','Canadian GIFI - Long','1785','Other machinery and equipment',11,0,NULL),(5703,'Canadian GIFI - Long','Canadian GIFI - Long','1786','Accumulated amortization of other machinery and equipment',11,0,NULL),(5704,'Canadian GIFI - Long','Canadian GIFI - Long','1787','Furniture and fixtures',11,0,NULL),(5705,'Canadian GIFI - Long','Canadian GIFI - Long','1788','Accumulated amortization of furniture and fixtures',11,0,NULL),(5706,'Canadian GIFI - Long','Canadian GIFI - Long','1900','Other tangible capital assets',11,0,NULL),(5707,'Canadian GIFI - Long','Canadian GIFI - Long','1901','Accumulated amortization of other tangible capital assets',11,0,NULL),(5708,'Canadian GIFI - Long','Canadian GIFI - Long','1902','Logging roads',11,0,NULL),(5709,'Canadian GIFI - Long','Canadian GIFI - Long','1903','Accumulated amortization of logging roads',11,0,NULL),(5710,'Canadian GIFI - Long','Canadian GIFI - Long','1904','Asphalt and parking areas',11,0,NULL),(5711,'Canadian GIFI - Long','Canadian GIFI - Long','1905','Accumulated amortization of asphalt and parking areas',11,0,NULL),(5712,'Canadian GIFI - Long','Canadian GIFI - Long','1906','Wharves',11,0,NULL),(5713,'Canadian GIFI - Long','Canadian GIFI - Long','1907','Accumulated amortization of wharves',11,0,NULL),(5714,'Canadian GIFI - Long','Canadian GIFI - Long','1908','Fences',11,0,NULL),(5715,'Canadian GIFI - Long','Canadian GIFI - Long','1909','Accumulated amortization of fences',11,0,NULL),(5716,'Canadian GIFI - Long','Canadian GIFI - Long','1910','Capital leases - Buildings',11,0,NULL),(5717,'Canadian GIFI - Long','Canadian GIFI - Long','1911','Accumulated amortization of capital leases - Buildings',11,0,NULL),(5718,'Canadian GIFI - Long','Canadian GIFI - Long','1912','Capital leases - Equipment',11,0,NULL),(5719,'Canadian GIFI - Long','Canadian GIFI - Long','1913','Accumulated amortization of capital leases - Equipment',11,0,NULL),(5720,'Canadian GIFI - Long','Canadian GIFI - Long','1914','Capital leases - Vehicles',11,0,NULL),(5721,'Canadian GIFI - Long','Canadian GIFI - Long','1915','Accumulated amortization of capital leases - Vehicles',11,0,NULL),(5722,'Canadian GIFI - Long','Canadian GIFI - Long','1916','Capital leases - Others',11,0,NULL),(5723,'Canadian GIFI - Long','Canadian GIFI - Long','1917','Accumulated amortization of capital leases - Others',11,0,NULL),(5724,'Canadian GIFI - Long','Canadian GIFI - Long','1918','Leasehold improvements',11,0,NULL),(5725,'Canadian GIFI - Long','Canadian GIFI - Long','1919','Accumulated amortization of leasehold improvements',11,0,NULL),(5726,'Canadian GIFI - Long','Canadian GIFI - Long','1920','Other capital assets under construction',11,0,NULL),(5727,'Canadian GIFI - Long','Canadian GIFI - Long','1921','Campsites',11,0,NULL),(5728,'Canadian GIFI - Long','Canadian GIFI - Long','1922','Accumulated amortization of campsites',11,0,NULL),(5729,'Canadian GIFI - Long','Canadian GIFI - Long','2008','Total tangible capital assets',11,0,NULL),(5730,'Canadian GIFI - Long','Canadian GIFI - Long','2009','Total accumulated amortization of tangible capital assets',11,0,NULL),(5731,'Canadian GIFI - Long','Canadian GIFI - Long','2010','Intangible assets',13,0,NULL),(5732,'Canadian GIFI - Long','Canadian GIFI - Long','2011','Accumulated amortization of intangible assets',13,0,NULL),(5733,'Canadian GIFI - Long','Canadian GIFI - Long','2012','Goodwill',13,0,NULL),(5734,'Canadian GIFI - Long','Canadian GIFI - Long','2013','Accumulated amortization of goodwill',13,0,NULL),(5735,'Canadian GIFI - Long','Canadian GIFI - Long','2014','Quota',13,0,NULL),(5736,'Canadian GIFI - Long','Canadian GIFI - Long','2015','Accumulated amortization of quota',13,0,NULL),(5737,'Canadian GIFI - Long','Canadian GIFI - Long','2016','Licences',13,0,NULL),(5738,'Canadian GIFI - Long','Canadian GIFI - Long','2017','Accumulated amortization of licences',13,0,NULL),(5739,'Canadian GIFI - Long','Canadian GIFI - Long','2018','Incorporation costs',13,0,NULL),(5740,'Canadian GIFI - Long','Canadian GIFI - Long','2019','Accumulated amortization of incorporation costs',13,0,NULL),(5741,'Canadian GIFI - Long','Canadian GIFI - Long','2020','Trademarks/patents',13,0,NULL),(5742,'Canadian GIFI - Long','Canadian GIFI - Long','2021','Accumulated amortization of trademarks/patents',13,0,NULL),(5743,'Canadian GIFI - Long','Canadian GIFI - Long','2022','Customer lists',13,0,NULL),(5744,'Canadian GIFI - Long','Canadian GIFI - Long','2023','Accumulated amortization of customer lists',13,0,NULL),(5745,'Canadian GIFI - Long','Canadian GIFI - Long','2024','Rights',13,0,NULL),(5746,'Canadian GIFI - Long','Canadian GIFI - Long','2025','Accumulated amortization of rights',13,0,NULL),(5747,'Canadian GIFI - Long','Canadian GIFI - Long','2026','Research and development',13,0,NULL),(5748,'Canadian GIFI - Long','Canadian GIFI - Long','2027','Accumulated amortization of research and development',13,0,NULL),(5749,'Canadian GIFI - Long','Canadian GIFI - Long','2070','Resource rights',13,0,NULL),(5750,'Canadian GIFI - Long','Canadian GIFI - Long','2071','Accumulated amortization of resource rights',13,0,NULL),(5751,'Canadian GIFI - Long','Canadian GIFI - Long','2072','Timber rights',13,0,NULL),(5752,'Canadian GIFI - Long','Canadian GIFI - Long','2073','Accumulated amortization of timber rights',13,0,NULL),(5753,'Canadian GIFI - Long','Canadian GIFI - Long','2074','Mining rights',13,0,NULL),(5754,'Canadian GIFI - Long','Canadian GIFI - Long','2075','Accumulated amortization of mining rights',13,0,NULL),(5755,'Canadian GIFI - Long','Canadian GIFI - Long','2076','Oil and gas rights',13,0,NULL),(5756,'Canadian GIFI - Long','Canadian GIFI - Long','2077','Accumulated amortization of oil and gas rights',13,0,NULL),(5757,'Canadian GIFI - Long','Canadian GIFI - Long','2178','Total intangible capital assets',13,0,NULL),(5758,'Canadian GIFI - Long','Canadian GIFI - Long','2179','Total accumulated amortization of intangible capital assets',13,0,NULL),(5759,'Canadian GIFI - Long','Canadian GIFI - Long','2180','Due from shareholder(s)/director(s)',13,0,NULL),(5760,'Canadian GIFI - Long','Canadian GIFI - Long','2181','Due from individual shareholder(s)',13,0,NULL),(5761,'Canadian GIFI - Long','Canadian GIFI - Long','2182','Due from corporate shareholder(s)',13,0,NULL),(5762,'Canadian GIFI - Long','Canadian GIFI - Long','2183','Due from director(s)',13,0,NULL),(5763,'Canadian GIFI - Long','Canadian GIFI - Long','2190','Due from members',13,0,NULL),(5764,'Canadian GIFI - Long','Canadian GIFI - Long','2200','Investment in joint venture(s)/partnership(s)',13,0,NULL),(5765,'Canadian GIFI - Long','Canadian GIFI - Long','2220','Due from joint venture(s)/partnership(s)',13,0,NULL),(5766,'Canadian GIFI - Long','Canadian GIFI - Long','2240','Due from/investment in related parties',13,0,NULL),(5767,'Canadian GIFI - Long','Canadian GIFI - Long','2241','Due from/investment in Canadian related parties',13,0,NULL),(5768,'Canadian GIFI - Long','Canadian GIFI - Long','2242','Shares in Canadian related corporations',13,0,NULL),(5769,'Canadian GIFI - Long','Canadian GIFI - Long','2243','Loans/advances to Canadian related corporations',13,0,NULL),(5770,'Canadian GIFI - Long','Canadian GIFI - Long','2244','Investment in Canadian related corporations at cost',13,0,NULL),(5771,'Canadian GIFI - Long','Canadian GIFI - Long','2245','Investment in Canadian related corporations at equity',13,0,NULL),(5772,'Canadian GIFI - Long','Canadian GIFI - Long','2246','Due from/investment in foreign related parties',13,0,NULL),(5773,'Canadian GIFI - Long','Canadian GIFI - Long','2247','Shares in foreign related corporations',13,0,NULL),(5774,'Canadian GIFI - Long','Canadian GIFI - Long','2248','Loans/advances to foreign related corporations',13,0,NULL),(5775,'Canadian GIFI - Long','Canadian GIFI - Long','2249','Investment in foreign related corporations at cost',13,0,NULL),(5776,'Canadian GIFI - Long','Canadian GIFI - Long','2250','Investment in foreign related corporations at equity',13,0,NULL),(5777,'Canadian GIFI - Long','Canadian GIFI - Long','2280','Investment in co-tenancy',13,0,NULL),(5778,'Canadian GIFI - Long','Canadian GIFI - Long','2300','Long-term investments',13,0,NULL),(5779,'Canadian GIFI - Long','Canadian GIFI - Long','2301','Foreign shares',13,0,NULL),(5780,'Canadian GIFI - Long','Canadian GIFI - Long','2302','Other types of foreign investments',13,0,NULL),(5781,'Canadian GIFI - Long','Canadian GIFI - Long','2303','Canadian shares',13,0,NULL),(5782,'Canadian GIFI - Long','Canadian GIFI - Long','2304','Government of Canada debt',13,0,NULL),(5783,'Canadian GIFI - Long','Canadian GIFI - Long','2305','Canadian provincial and municipal government debt',13,0,NULL),(5784,'Canadian GIFI - Long','Canadian GIFI - Long','2306','Canadian corporate bonds and debentures',13,0,NULL),(5785,'Canadian GIFI - Long','Canadian GIFI - Long','2307','Debt securities',13,0,NULL),(5786,'Canadian GIFI - Long','Canadian GIFI - Long','2308','Equity securities',13,0,NULL),(5787,'Canadian GIFI - Long','Canadian GIFI - Long','2309','Securities purchased under resale agreements',13,0,NULL),(5788,'Canadian GIFI - Long','Canadian GIFI - Long','2310','Central credit union shares',13,0,NULL),(5789,'Canadian GIFI - Long','Canadian GIFI - Long','2311','Other Canadian long-term investments',13,0,NULL),(5790,'Canadian GIFI - Long','Canadian GIFI - Long','2360','Long-term loans',13,0,NULL),(5791,'Canadian GIFI - Long','Canadian GIFI - Long','2361','Mortgages',13,0,NULL),(5792,'Canadian GIFI - Long','Canadian GIFI - Long','2362','Personal and credit card loans',13,0,NULL),(5793,'Canadian GIFI - Long','Canadian GIFI - Long','2363','Business and government loans',13,0,NULL),(5794,'Canadian GIFI - Long','Canadian GIFI - Long','2364','Line of credit',13,0,NULL),(5795,'Canadian GIFI - Long','Canadian GIFI - Long','2420','Other long-term assets',13,0,NULL),(5796,'Canadian GIFI - Long','Canadian GIFI - Long','2421','Future (deferred) income taxes',13,0,NULL),(5797,'Canadian GIFI - Long','Canadian GIFI - Long','2422','Deferred pension charges',13,0,NULL),(5798,'Canadian GIFI - Long','Canadian GIFI - Long','2423','Deferred unrealized exchange losses',13,0,NULL),(5799,'Canadian GIFI - Long','Canadian GIFI - Long','2424','Other deferred items/charges',13,0,NULL),(5800,'Canadian GIFI - Long','Canadian GIFI - Long','2425','Accumulated amortization of deferred charges',13,0,NULL),(5801,'Canadian GIFI - Long','Canadian GIFI - Long','2426','Reserve fund',13,0,NULL),(5802,'Canadian GIFI - Long','Canadian GIFI - Long','2427','Cash surrender value of life insurance',13,0,NULL),(5803,'Canadian GIFI - Long','Canadian GIFI - Long','2589','Total long-term assets',13,0,NULL),(5804,'Canadian GIFI - Long','Canadian GIFI - Long','2590','Assets held in trust',13,0,NULL),(5805,'Canadian GIFI - Long','Canadian GIFI - Long','2599','Total assets',13,0,NULL),(5806,'Canadian GIFI - Long','Canadian GIFI - Long','2600','Bank overdraft',21,0,NULL),(5807,'Canadian GIFI - Long','Canadian GIFI - Long','2620','Amounts payable and accrued liabilities',21,0,NULL),(5808,'Canadian GIFI - Long','Canadian GIFI - Long','2621','Trade payables',21,0,'apcompany.payable;arcompany.shipliability'),(5809,'Canadian GIFI - Long','Canadian GIFI - Long','2622','Trade payables to related parties',21,0,NULL),(5810,'Canadian GIFI - Long','Canadian GIFI - Long','2623','Holdbacks payable',21,0,NULL),(5811,'Canadian GIFI - Long','Canadian GIFI - Long','2624','Wages payable',21,0,NULL),(5812,'Canadian GIFI - Long','Canadian GIFI - Long','2625','Management fees payable',21,0,NULL),(5813,'Canadian GIFI - Long','Canadian GIFI - Long','2626','Bonuses payable',21,0,NULL),(5814,'Canadian GIFI - Long','Canadian GIFI - Long','2627','Employee deductions payable',21,0,NULL),(5815,'Canadian GIFI - Long','Canadian GIFI - Long','2628','Withholding taxes payable',21,0,NULL),(5816,'Canadian GIFI - Long','Canadian GIFI - Long','2629','Interest payable',21,0,NULL),(5817,'Canadian GIFI - Long','Canadian GIFI - Long','2630','Amounts payable to members of NPOs',21,0,NULL),(5818,'Canadian GIFI - Long','Canadian GIFI - Long','2680','Taxes payable',21,0,NULL),(5819,'Canadian GIFI - Long','Canadian GIFI - Long','2700','Short-term debt',21,0,'apcompany.payable'),(5820,'Canadian GIFI - Long','Canadian GIFI - Long','2701','Loans from Canadian banks',21,0,NULL),(5821,'Canadian GIFI - Long','Canadian GIFI - Long','2702','Liability for securities sold short',21,0,NULL),(5822,'Canadian GIFI - Long','Canadian GIFI - Long','2703','Liability for securities sold under repurchase agreements',21,0,NULL),(5823,'Canadian GIFI - Long','Canadian GIFI - Long','2704','Gold and silver certificates',21,0,NULL),(5824,'Canadian GIFI - Long','Canadian GIFI - Long','2705','Cheques and other items in transit',21,0,NULL),(5825,'Canadian GIFI - Long','Canadian GIFI - Long','2706','Lien notes',21,0,NULL),(5826,'Canadian GIFI - Long','Canadian GIFI - Long','2707','Credit card loans',21,0,NULL),(5827,'Canadian GIFI - Long','Canadian GIFI - Long','2770','Deferred income',21,0,NULL),(5828,'Canadian GIFI - Long','Canadian GIFI - Long','2780','Due to shareholder(s)/director(s)',21,0,NULL),(5829,'Canadian GIFI - Long','Canadian GIFI - Long','2781','Due to individual shareholder(s)',21,0,NULL),(5830,'Canadian GIFI - Long','Canadian GIFI - Long','2782','Due to corporate shareholder(s)',21,0,NULL),(5831,'Canadian GIFI - Long','Canadian GIFI - Long','2783','Due to director(s)',21,0,NULL),(5832,'Canadian GIFI - Long','Canadian GIFI - Long','2840','Due to joint venture(s)/partnership(s)',21,0,NULL),(5833,'Canadian GIFI - Long','Canadian GIFI - Long','2860','Due to related parties',21,0,NULL),(5834,'Canadian GIFI - Long','Canadian GIFI - Long','2861','Demand notes due to related parties',21,0,NULL),(5835,'Canadian GIFI - Long','Canadian GIFI - Long','2862','Interest payable to related parties',21,0,NULL),(5836,'Canadian GIFI - Long','Canadian GIFI - Long','2863','Advances due to related parties',21,0,NULL),(5837,'Canadian GIFI - Long','Canadian GIFI - Long','2920','Current portion of long-term liability',21,0,NULL),(5838,'Canadian GIFI - Long','Canadian GIFI - Long','2940','Bankers',21,0,NULL),(5839,'Canadian GIFI - Long','Canadian GIFI - Long','2960','Other current liabilities',21,0,NULL),(5840,'Canadian GIFI - Long','Canadian GIFI - Long','2961','Deposits received',21,0,'arcompany.depositglacctid'),(5841,'Canadian GIFI - Long','Canadian GIFI - Long','2962','Dividends payable',21,0,NULL),(5842,'Canadian GIFI - Long','Canadian GIFI - Long','2963','Future (deferred) income taxes',21,0,NULL),(5843,'Canadian GIFI - Long','Canadian GIFI - Long','2964','Reserves for guarantees warranties or indemnities',21,0,NULL),(5844,'Canadian GIFI - Long','Canadian GIFI - Long','2965','General provisions/reserves',21,0,NULL),(5845,'Canadian GIFI - Long','Canadian GIFI - Long','2966','Crew shares',21,0,NULL),(5846,'Canadian GIFI - Long','Canadian GIFI - Long','3139','Total current liabilities',21,0,NULL),(5847,'Canadian GIFI - Long','Canadian GIFI - Long','3140','Long Term debt',22,0,NULL),(5848,'Canadian GIFI - Long','Canadian GIFI - Long','3141','Mortgages',22,0,NULL),(5849,'Canadian GIFI - Long','Canadian GIFI - Long','3142','Farm Credit Corporation loan',22,0,NULL),(5850,'Canadian GIFI - Long','Canadian GIFI - Long','3143','Chartered bank loan',22,0,NULL),(5851,'Canadian GIFI - Long','Canadian GIFI - Long','3144','Credit Union/Caisse Populaire loan',22,0,NULL),(5852,'Canadian GIFI - Long','Canadian GIFI - Long','3145','Provincial or territorial government loan',22,0,NULL),(5853,'Canadian GIFI - Long','Canadian GIFI - Long','3146','Supply company loan',22,0,NULL),(5854,'Canadian GIFI - Long','Canadian GIFI - Long','3147','Private loan',22,0,NULL),(5855,'Canadian GIFI - Long','Canadian GIFI - Long','3148','Central league and federation loans',22,0,NULL),(5856,'Canadian GIFI - Long','Canadian GIFI - Long','3149','Line of credit',22,0,NULL),(5857,'Canadian GIFI - Long','Canadian GIFI - Long','3150','Liability for securities sold short',22,0,NULL),(5858,'Canadian GIFI - Long','Canadian GIFI - Long','3151','Liability for securities sold under repurchase agreements',22,0,NULL),(5859,'Canadian GIFI - Long','Canadian GIFI - Long','3152','Lien notes',22,0,NULL),(5860,'Canadian GIFI - Long','Canadian GIFI - Long','3200','Deposit liabilities of financial institutions',22,0,NULL),(5861,'Canadian GIFI - Long','Canadian GIFI - Long','3210','Bonds and debentures',22,0,NULL),(5862,'Canadian GIFI - Long','Canadian GIFI - Long','3220','Deferred income',22,0,NULL),(5863,'Canadian GIFI - Long','Canadian GIFI - Long','3240','Future (deferred) income taxes',22,0,NULL),(5864,'Canadian GIFI - Long','Canadian GIFI - Long','3260','Due to shareholder(s)/director(s)',22,0,NULL),(5865,'Canadian GIFI - Long','Canadian GIFI - Long','3261','Due to individual shareholder(s)',22,0,NULL),(5866,'Canadian GIFI - Long','Canadian GIFI - Long','3262','Due to corporate shareholder(s)',22,0,NULL),(5867,'Canadian GIFI - Long','Canadian GIFI - Long','3263','Due to director(s)',22,0,NULL),(5868,'Canadian GIFI - Long','Canadian GIFI - Long','3270','Due to members',22,0,NULL),(5869,'Canadian GIFI - Long','Canadian GIFI - Long','3280','Due to joint venture(s)/partnership(s)',22,0,NULL),(5870,'Canadian GIFI - Long','Canadian GIFI - Long','3300','Due to related parties',22,0,NULL),(5871,'Canadian GIFI - Long','Canadian GIFI - Long','3301','Amounts owing to related Canadian parties',22,0,NULL),(5872,'Canadian GIFI - Long','Canadian GIFI - Long','3302','Amounts owing to related foreign parties',22,0,NULL),(5873,'Canadian GIFI - Long','Canadian GIFI - Long','3320','Other long term liabilities',22,0,NULL),(5874,'Canadian GIFI - Long','Canadian GIFI - Long','3321','Long term obligations/commitments/capital leases',22,0,NULL),(5875,'Canadian GIFI - Long','Canadian GIFI - Long','3322','Reserves for guarantees warranties or indemnities',22,0,NULL),(5876,'Canadian GIFI - Long','Canadian GIFI - Long','3323','Provision for site restoration',22,0,NULL),(5877,'Canadian GIFI - Long','Canadian GIFI - Long','3324','Contributions to qualifying environmental trust',22,0,NULL),(5878,'Canadian GIFI - Long','Canadian GIFI - Long','3325','General provisions/reserves',22,0,NULL),(5879,'Canadian GIFI - Long','Canadian GIFI - Long','3326','Preference shares restated',22,0,NULL),(5880,'Canadian GIFI - Long','Canadian GIFI - Long','3327','Member allocations',22,0,NULL),(5881,'Canadian GIFI - Long','Canadian GIFI - Long','3328','Deferred revenue from incomplete contracts',22,0,NULL),(5882,'Canadian GIFI - Long','Canadian GIFI - Long','3450','Total long term liabilities',22,0,NULL),(5883,'Canadian GIFI - Long','Canadian GIFI - Long','3460','Subordinated debt',22,0,NULL),(5884,'Canadian GIFI - Long','Canadian GIFI - Long','3470','Amounts held in trust',22,0,NULL),(5885,'Canadian GIFI - Long','Canadian GIFI - Long','3499','Total liabilities',22,0,NULL),(5886,'Canadian GIFI - Long','Canadian GIFI - Long','3500','Common shares',30,0,NULL),(5887,'Canadian GIFI - Long','Canadian GIFI - Long','3520','Preferred shares',30,0,NULL),(5888,'Canadian GIFI - Long','Canadian GIFI - Long','3540','Contributed and other surplus',30,0,NULL),(5889,'Canadian GIFI - Long','Canadian GIFI - Long','3541','Contributed surplus',30,0,NULL),(5890,'Canadian GIFI - Long','Canadian GIFI - Long','3542','Appraisal surplus',30,0,NULL),(5891,'Canadian GIFI - Long','Canadian GIFI - Long','3543','General reserve',30,0,NULL),(5892,'Canadian GIFI - Long','Canadian GIFI - Long','3570','Head office account',30,0,NULL),(5893,'Canadian GIFI - Long','Canadian GIFI - Long','3580','Accumulated other comprehensive income',30,0,NULL),(5894,'Canadian GIFI - Long','Canadian GIFI - Long','3600','Retained earnings/deficit',30,0,NULL),(5895,'Canadian GIFI - Long','Canadian GIFI - Long','3620','Total shareholder equity',30,0,NULL),(5896,'Canadian GIFI - Long','Canadian GIFI - Long','3640','Total liabilities and shareholder equity',30,0,NULL),(5897,'Canadian GIFI - Long','Canadian GIFI - Long','3680','Net income/loss',40,0,NULL),(5898,'Canadian GIFI - Long','Canadian GIFI - Long','8000','Trade sales of goods and services',50,0,'invcompany.sales;arcompany.labor_sales_glacctid;arcompany.refund;arcompany.restockglid;arcompany.discount;arcompany.cost'),(5899,'Canadian GIFI - Long','Canadian GIFI - Long','8020','Sales of goods and services to related parties',50,0,NULL),(5900,'Canadian GIFI - Long','Canadian GIFI - Long','8030','Interdivisional sales',50,0,NULL),(5901,'Canadian GIFI - Long','Canadian GIFI - Long','8040','Sales from resource properties',50,0,NULL),(5902,'Canadian GIFI - Long','Canadian GIFI - Long','8041','Petroleum and natural gas sales',50,0,NULL),(5903,'Canadian GIFI - Long','Canadian GIFI - Long','8042','Petroleum and natural gas sales to related parties',50,0,NULL),(5904,'Canadian GIFI - Long','Canadian GIFI - Long','8043','Gas marketing',50,0,NULL),(5905,'Canadian GIFI - Long','Canadian GIFI - Long','8044','Processing revenue',50,0,NULL),(5906,'Canadian GIFI - Long','Canadian GIFI - Long','8045','Pipeline revenue',50,0,NULL),(5907,'Canadian GIFI - Long','Canadian GIFI - Long','8046','Seismic sales',50,0,NULL),(5908,'Canadian GIFI - Long','Canadian GIFI - Long','8047','Mining revenue',50,0,NULL),(5909,'Canadian GIFI - Long','Canadian GIFI - Long','8048','Coal revenue',50,0,NULL),(5910,'Canadian GIFI - Long','Canadian GIFI - Long','8049','Oil sands revenue',50,0,NULL),(5911,'Canadian GIFI - Long','Canadian GIFI - Long','8050','Royalty income',50,0,NULL),(5912,'Canadian GIFI - Long','Canadian GIFI - Long','8051','Oil and gas partnership/joint venture income/loss',50,0,NULL),(5913,'Canadian GIFI - Long','Canadian GIFI - Long','8052','Mining partnership/joint venture income/loss',50,0,NULL),(5914,'Canadian GIFI - Long','Canadian GIFI - Long','8053','Other production revenue',50,0,NULL),(5915,'Canadian GIFI - Long','Canadian GIFI - Long','8089','Total sales of goods and services',50,0,NULL),(5916,'Canadian GIFI - Long','Canadian GIFI - Long','8090','Investment revenue',50,0,NULL),(5917,'Canadian GIFI - Long','Canadian GIFI - Long','8091','Interest from foreign sources',50,0,NULL),(5918,'Canadian GIFI - Long','Canadian GIFI - Long','8092','Interest from Canadian bonds and debentures',50,0,NULL),(5919,'Canadian GIFI - Long','Canadian GIFI - Long','8093','Interest from Canadian mortgage loans',50,0,NULL),(5920,'Canadian GIFI - Long','Canadian GIFI - Long','8094','Interest from other Canadian sources',50,0,NULL),(5921,'Canadian GIFI - Long','Canadian GIFI - Long','8095','Dividend income',50,0,NULL),(5922,'Canadian GIFI - Long','Canadian GIFI - Long','8096','Dividends from Canadian sources',50,0,NULL),(5923,'Canadian GIFI - Long','Canadian GIFI - Long','8097','Dividends from foreign sources',50,0,NULL),(5924,'Canadian GIFI - Long','Canadian GIFI - Long','8100','Interest income (financial institutions)',50,0,NULL),(5925,'Canadian GIFI - Long','Canadian GIFI - Long','8101','Loan interest',50,0,NULL),(5926,'Canadian GIFI - Long','Canadian GIFI - Long','8102','Securities interest',50,0,NULL),(5927,'Canadian GIFI - Long','Canadian GIFI - Long','8103','Deposits with banks interest',50,0,NULL),(5928,'Canadian GIFI - Long','Canadian GIFI - Long','8120','Commission revenue',50,0,NULL),(5929,'Canadian GIFI - Long','Canadian GIFI - Long','8121','Commission income on real estate transactions',50,0,NULL),(5930,'Canadian GIFI - Long','Canadian GIFI - Long','8140','Rental revenue',50,0,NULL),(5931,'Canadian GIFI - Long','Canadian GIFI - Long','8141','Real estate rental revenue',50,0,NULL),(5932,'Canadian GIFI - Long','Canadian GIFI - Long','8142','Film rental revenue',50,0,NULL),(5933,'Canadian GIFI - Long','Canadian GIFI - Long','8150','Vehicle leasing',50,0,NULL),(5934,'Canadian GIFI - Long','Canadian GIFI - Long','8160','Fishing revenue',50,0,NULL),(5935,'Canadian GIFI - Long','Canadian GIFI - Long','8161','Fish products',50,0,NULL),(5936,'Canadian GIFI - Long','Canadian GIFI - Long','8162','Other marine products',50,0,NULL),(5937,'Canadian GIFI - Long','Canadian GIFI - Long','8163','Fishing grants credits and rebates',50,0,NULL),(5938,'Canadian GIFI - Long','Canadian GIFI - Long','8164','Fishing subsidies',50,0,NULL),(5939,'Canadian GIFI - Long','Canadian GIFI - Long','8165','Compensation for loss of fishing income or property',50,0,NULL),(5940,'Canadian GIFI - Long','Canadian GIFI - Long','8166','Sharesman income',50,0,NULL),(5941,'Canadian GIFI - Long','Canadian GIFI - Long','8210','Realized gains/losses on disposal of assets',50,0,NULL),(5942,'Canadian GIFI - Long','Canadian GIFI - Long','8211','Realized gains/losses on sale of investments',50,0,NULL),(5943,'Canadian GIFI - Long','Canadian GIFI - Long','8212','Realized gains/losses on sale of resource properties',50,0,NULL),(5944,'Canadian GIFI - Long','Canadian GIFI - Long','8220','NPO amounts received',50,0,NULL),(5945,'Canadian GIFI - Long','Canadian GIFI - Long','8221','Membership fees',50,0,NULL),(5946,'Canadian GIFI - Long','Canadian GIFI - Long','8222','Assessments',50,0,NULL),(5947,'Canadian GIFI - Long','Canadian GIFI - Long','8223','Gifts',50,0,NULL),(5948,'Canadian GIFI - Long','Canadian GIFI - Long','8224','Gross sales and revenues from organizational activities',50,0,NULL),(5949,'Canadian GIFI - Long','Canadian GIFI - Long','8230','Other revenue',50,0,'arcompany.interest'),(5950,'Canadian GIFI - Long','Canadian GIFI - Long','8231','Foreign exchange gains/losses',50,0,NULL),(5951,'Canadian GIFI - Long','Canadian GIFI - Long','8232','Income/loss of subsidiaries/affiliates',50,0,NULL),(5952,'Canadian GIFI - Long','Canadian GIFI - Long','8233','Income/loss of other divisions',50,0,NULL),(5953,'Canadian GIFI - Long','Canadian GIFI - Long','8234','Income/loss of joint ventures',50,0,NULL),(5954,'Canadian GIFI - Long','Canadian GIFI - Long','8235','Income/loss of partnerships',50,0,NULL),(5955,'Canadian GIFI - Long','Canadian GIFI - Long','8236','Realization of deferred revenues',50,0,NULL),(5956,'Canadian GIFI - Long','Canadian GIFI - Long','8237','Royalty income other than resource',50,0,NULL),(5957,'Canadian GIFI - Long','Canadian GIFI - Long','8238','Alberta royalty tax credits',50,0,NULL),(5958,'Canadian GIFI - Long','Canadian GIFI - Long','8239','Management and administration fees',50,0,NULL),(5959,'Canadian GIFI - Long','Canadian GIFI - Long','8240','Telecommunications revenue',50,0,NULL),(5960,'Canadian GIFI - Long','Canadian GIFI - Long','8241','Consulting fees',50,0,NULL),(5961,'Canadian GIFI - Long','Canadian GIFI - Long','8242','Subsidies and grants',50,0,NULL),(5962,'Canadian GIFI - Long','Canadian GIFI - Long','8243','Sale of by-products',50,0,NULL),(5963,'Canadian GIFI - Long','Canadian GIFI - Long','8244','Deposit services',50,0,NULL),(5964,'Canadian GIFI - Long','Canadian GIFI - Long','8245','Credit services',50,0,NULL),(5965,'Canadian GIFI - Long','Canadian GIFI - Long','8246','Card services',50,0,NULL),(5966,'Canadian GIFI - Long','Canadian GIFI - Long','8247','Patronage dividends',50,0,NULL),(5967,'Canadian GIFI - Long','Canadian GIFI - Long','8248','Insurance recoveries',50,0,NULL),(5968,'Canadian GIFI - Long','Canadian GIFI - Long','8249','Expense recoveries',50,0,NULL),(5969,'Canadian GIFI - Long','Canadian GIFI - Long','8250','Bad debt recoveries',50,0,NULL),(5970,'Canadian GIFI - Long','Canadian GIFI - Long','8299','Total revenue',50,0,NULL),(5971,'Canadian GIFI - Long','Canadian GIFI - Long','8300','Opening inventory',70,0,NULL),(5972,'Canadian GIFI - Long','Canadian GIFI - Long','8301','Opening inventory - Finished goods',70,0,NULL),(5973,'Canadian GIFI - Long','Canadian GIFI - Long','8302','Opening inventory - Raw materials',70,0,NULL),(5974,'Canadian GIFI - Long','Canadian GIFI - Long','8303','Opening inventory - Goods in process',70,0,NULL),(5975,'Canadian GIFI - Long','Canadian GIFI - Long','8320','Purchases/cost of materials',70,0,'apcompany.discount'),(5976,'Canadian GIFI - Long','Canadian GIFI - Long','8340','Direct wages',70,0,NULL),(5977,'Canadian GIFI - Long','Canadian GIFI - Long','8350','Benefits on direct wages',70,0,NULL),(5978,'Canadian GIFI - Long','Canadian GIFI - Long','8360','Trades and sub-contracts',70,0,NULL),(5979,'Canadian GIFI - Long','Canadian GIFI - Long','8370','Production costs other than resource',70,0,NULL),(5980,'Canadian GIFI - Long','Canadian GIFI - Long','8400','Resource production costs',70,0,NULL),(5981,'Canadian GIFI - Long','Canadian GIFI - Long','8401','Pipeline operations',70,0,NULL),(5982,'Canadian GIFI - Long','Canadian GIFI - Long','8402','Drilling',70,0,NULL),(5983,'Canadian GIFI - Long','Canadian GIFI - Long','8403','Site restoration costs',70,0,NULL),(5984,'Canadian GIFI - Long','Canadian GIFI - Long','8404','Gross overriding royalty',70,0,NULL),(5985,'Canadian GIFI - Long','Canadian GIFI - Long','8405','Freehold royalties',70,0,NULL),(5986,'Canadian GIFI - Long','Canadian GIFI - Long','8406','Other producing properties rental',70,0,NULL),(5987,'Canadian GIFI - Long','Canadian GIFI - Long','8407','Prospect/geological',70,0,NULL),(5988,'Canadian GIFI - Long','Canadian GIFI - Long','8408','Well operating fuel and equipment',70,0,NULL),(5989,'Canadian GIFI - Long','Canadian GIFI - Long','8409','Well abandonment and dry holes',70,0,NULL),(5990,'Canadian GIFI - Long','Canadian GIFI - Long','8410','Other lease rentals',70,0,NULL),(5991,'Canadian GIFI - Long','Canadian GIFI - Long','8411','Exploration expenses',70,0,NULL),(5992,'Canadian GIFI - Long','Canadian GIFI - Long','8412','Development expenses',70,0,NULL),(5993,'Canadian GIFI - Long','Canadian GIFI - Long','8435','Crown charges',70,0,NULL),(5994,'Canadian GIFI - Long','Canadian GIFI - Long','8436','Crown royalties',70,0,NULL),(5995,'Canadian GIFI - Long','Canadian GIFI - Long','8437','Crown lease rentals',70,0,NULL),(5996,'Canadian GIFI - Long','Canadian GIFI - Long','8438','Freehold mineral tax',70,0,NULL),(5997,'Canadian GIFI - Long','Canadian GIFI - Long','8439','Mining taxes',70,0,NULL),(5998,'Canadian GIFI - Long','Canadian GIFI - Long','8440','Oil sand leases',70,0,NULL),(5999,'Canadian GIFI - Long','Canadian GIFI - Long','8441','Saskatchewan resource surcharge',70,0,NULL),(6000,'Canadian GIFI - Long','Canadian GIFI - Long','8450','Other direct costs',70,0,NULL),(6001,'Canadian GIFI - Long','Canadian GIFI - Long','8451','Equipment hire and operation',70,0,NULL),(6002,'Canadian GIFI - Long','Canadian GIFI - Long','8452','Log yard',70,0,NULL),(6003,'Canadian GIFI - Long','Canadian GIFI - Long','8453','Forestry costs',70,0,NULL),(6004,'Canadian GIFI - Long','Canadian GIFI - Long','8454','Logging road costs',70,0,NULL),(6005,'Canadian GIFI - Long','Canadian GIFI - Long','8455','Stumpage costs',70,0,NULL),(6006,'Canadian GIFI - Long','Canadian GIFI - Long','8456','Royalty costs',70,0,NULL),(6007,'Canadian GIFI - Long','Canadian GIFI - Long','8457','Freight-in and duty',70,0,NULL),(6008,'Canadian GIFI - Long','Canadian GIFI - Long','8458','Inventory write-down',70,0,NULL),(6009,'Canadian GIFI - Long','Canadian GIFI - Long','8459','Direct cost amortization of tangible assets',70,0,NULL),(6010,'Canadian GIFI - Long','Canadian GIFI - Long','8460','Direct cost amortization of natural resource assets',70,0,NULL),(6011,'Canadian GIFI - Long','Canadian GIFI - Long','8461','Overhead expenses allocated to cost of sales',70,0,NULL),(6012,'Canadian GIFI - Long','Canadian GIFI - Long','8500','Closing inventory',70,0,NULL),(6013,'Canadian GIFI - Long','Canadian GIFI - Long','8501','Closing inventory - Finished goods',70,0,NULL),(6014,'Canadian GIFI - Long','Canadian GIFI - Long','8502','Closing inventory - Raw materials',70,0,NULL),(6015,'Canadian GIFI - Long','Canadian GIFI - Long','8503','Closing inventory - Goods in process',70,0,NULL),(6016,'Canadian GIFI - Long','Canadian GIFI - Long','8518','Cost of sales',70,0,'arcompany.cost;invcompany.cost;invcompany.costadjustglacctid;apcompany.discount'),(6017,'Canadian GIFI - Long','Canadian GIFI - Long','8519','Gross profit/loss',70,0,NULL),(6018,'Canadian GIFI - Long','Canadian GIFI - Long','8520','Advertising and promotion',80,0,NULL),(6019,'Canadian GIFI - Long','Canadian GIFI - Long','8521','Advertising',80,0,NULL),(6020,'Canadian GIFI - Long','Canadian GIFI - Long','8522','Donations',80,0,NULL),(6021,'Canadian GIFI - Long','Canadian GIFI - Long','8523','Meals and entertainment',80,0,NULL),(6022,'Canadian GIFI - Long','Canadian GIFI - Long','8524','Promotion',80,0,NULL),(6023,'Canadian GIFI - Long','Canadian GIFI - Long','8570','Amortization of intangible assets',80,0,NULL),(6024,'Canadian GIFI - Long','Canadian GIFI - Long','8571','Goodwill impairment loss',80,0,NULL),(6025,'Canadian GIFI - Long','Canadian GIFI - Long','8590','Bad debt expense',80,0,'arcompany.baddebt'),(6026,'Canadian GIFI - Long','Canadian GIFI - Long','8610','Loan losses',80,0,NULL),(6027,'Canadian GIFI - Long','Canadian GIFI - Long','8611','Provision for loan losses',80,0,NULL),(6028,'Canadian GIFI - Long','Canadian GIFI - Long','8620','Employee benefits',80,0,NULL),(6029,'Canadian GIFI - Long','Canadian GIFI - Long','8621','Group insurance benefits',80,0,NULL),(6030,'Canadian GIFI - Long','Canadian GIFI - Long','8622','Employer',80,0,NULL),(6031,'Canadian GIFI - Long','Canadian GIFI - Long','8623','Contributions to deferred income plans',80,0,NULL),(6032,'Canadian GIFI - Long','Canadian GIFI - Long','8650','Amortization of natural resource assets',80,0,NULL),(6033,'Canadian GIFI - Long','Canadian GIFI - Long','8670','Amortization of tangible assets',80,0,NULL),(6034,'Canadian GIFI - Long','Canadian GIFI - Long','8690','Insurance',80,0,NULL),(6035,'Canadian GIFI - Long','Canadian GIFI - Long','8691','Life insurance on executives',80,0,NULL),(6036,'Canadian GIFI - Long','Canadian GIFI - Long','8710','Interest and bank charges',80,0,'apcompany.interestexpense'),(6037,'Canadian GIFI - Long','Canadian GIFI - Long','8711','Interest on short-term debt',80,0,NULL),(6038,'Canadian GIFI - Long','Canadian GIFI - Long','8712','Interest on bonds and debentures',80,0,NULL),(6039,'Canadian GIFI - Long','Canadian GIFI - Long','8713','Interest on mortgages',80,0,NULL),(6040,'Canadian GIFI - Long','Canadian GIFI - Long','8714','Interest on long-term debt',80,0,NULL),(6041,'Canadian GIFI - Long','Canadian GIFI - Long','8715','Bank charges',80,0,'apcompany.servicecharges'),(6042,'Canadian GIFI - Long','Canadian GIFI - Long','8716','Credit card charges',80,0,NULL),(6043,'Canadian GIFI - Long','Canadian GIFI - Long','8717','Collection and credit costs',80,0,NULL),(6044,'Canadian GIFI - Long','Canadian GIFI - Long','8740','Interest paid (financial institutions)',80,0,NULL),(6045,'Canadian GIFI - Long','Canadian GIFI - Long','8741','Interest paid on deposits',80,0,NULL),(6046,'Canadian GIFI - Long','Canadian GIFI - Long','8742','Interest paid on bonds and debentures',80,0,NULL),(6047,'Canadian GIFI - Long','Canadian GIFI - Long','8760','Business taxes licences and memberships',80,0,NULL),(6048,'Canadian GIFI - Long','Canadian GIFI - Long','8761','Memberships',80,0,NULL),(6049,'Canadian GIFI - Long','Canadian GIFI - Long','8762','Business taxes',80,0,NULL),(6050,'Canadian GIFI - Long','Canadian GIFI - Long','8763','Franchise fees',80,0,NULL),(6051,'Canadian GIFI - Long','Canadian GIFI - Long','8764','Government fees',80,0,NULL),(6052,'Canadian GIFI - Long','Canadian GIFI - Long','8780','New Brunswick tax on large corporations',80,0,NULL),(6053,'Canadian GIFI - Long','Canadian GIFI - Long','8790','Nova Scotia tax on large corporations',80,0,NULL),(6054,'Canadian GIFI - Long','Canadian GIFI - Long','8810','Office expenses',80,0,NULL),(6055,'Canadian GIFI - Long','Canadian GIFI - Long','8811','Office stationery and supplies',80,0,NULL),(6056,'Canadian GIFI - Long','Canadian GIFI - Long','8812','Office utilities',80,0,NULL),(6057,'Canadian GIFI - Long','Canadian GIFI - Long','8813','Data processing',80,0,NULL),(6058,'Canadian GIFI - Long','Canadian GIFI - Long','8860','Professional fees',80,0,NULL),(6059,'Canadian GIFI - Long','Canadian GIFI - Long','8861','Legal fees',80,0,NULL),(6060,'Canadian GIFI - Long','Canadian GIFI - Long','8862','Accounting fees',80,0,NULL),(6061,'Canadian GIFI - Long','Canadian GIFI - Long','8863','Consulting fees',80,0,NULL),(6062,'Canadian GIFI - Long','Canadian GIFI - Long','8864','Architect fees',80,0,NULL),(6063,'Canadian GIFI - Long','Canadian GIFI - Long','8865','Appraisal fees',80,0,NULL),(6064,'Canadian GIFI - Long','Canadian GIFI - Long','8866','Laboratory fees',80,0,NULL),(6065,'Canadian GIFI - Long','Canadian GIFI - Long','8867','Medical fees',80,0,NULL),(6066,'Canadian GIFI - Long','Canadian GIFI - Long','8868','Veterinary fees',80,0,NULL),(6067,'Canadian GIFI - Long','Canadian GIFI - Long','8869','Brokerage fees',80,0,NULL),(6068,'Canadian GIFI - Long','Canadian GIFI - Long','8870','Transfer fees',80,0,NULL),(6069,'Canadian GIFI - Long','Canadian GIFI - Long','8871','Management and administration fees',80,0,NULL),(6070,'Canadian GIFI - Long','Canadian GIFI - Long','8872','Refining and assay',80,0,NULL),(6071,'Canadian GIFI - Long','Canadian GIFI - Long','8873','Registrar and transfer agent fees',80,0,NULL),(6072,'Canadian GIFI - Long','Canadian GIFI - Long','8874','Restructuring costs',80,0,NULL),(6073,'Canadian GIFI - Long','Canadian GIFI - Long','8875','Security commission fees',80,0,NULL),(6074,'Canadian GIFI - Long','Canadian GIFI - Long','8876','Training expense',80,0,NULL),(6075,'Canadian GIFI - Long','Canadian GIFI - Long','8877','Studio and recording',80,0,NULL),(6076,'Canadian GIFI - Long','Canadian GIFI - Long','8910','Rental',80,0,NULL),(6077,'Canadian GIFI - Long','Canadian GIFI - Long','8911','Real estate rental',80,0,NULL),(6078,'Canadian GIFI - Long','Canadian GIFI - Long','8912','Occupancy costs',80,0,NULL),(6079,'Canadian GIFI - Long','Canadian GIFI - Long','8913','Condominium fees',80,0,NULL),(6080,'Canadian GIFI - Long','Canadian GIFI - Long','8914','Equipment rental',80,0,NULL),(6081,'Canadian GIFI - Long','Canadian GIFI - Long','8915','Motor vehicle rentals',80,0,NULL),(6082,'Canadian GIFI - Long','Canadian GIFI - Long','8916','Moorage (boat)',80,0,NULL),(6083,'Canadian GIFI - Long','Canadian GIFI - Long','8917','Storage',80,0,NULL),(6084,'Canadian GIFI - Long','Canadian GIFI - Long','8918','Quota rental',80,0,NULL),(6085,'Canadian GIFI - Long','Canadian GIFI - Long','8960','Repairs and maintenance',80,0,NULL),(6086,'Canadian GIFI - Long','Canadian GIFI - Long','8961','Repairs and maintenance - Buildings',80,0,NULL),(6087,'Canadian GIFI - Long','Canadian GIFI - Long','8962','Repairs and maintenance - Vehicles',80,0,NULL),(6088,'Canadian GIFI - Long','Canadian GIFI - Long','8963','Repairs and maintenance - Boats',80,0,NULL),(6089,'Canadian GIFI - Long','Canadian GIFI - Long','8964','Repairs and maintenance - Machinery and equipment',80,0,NULL),(6090,'Canadian GIFI - Long','Canadian GIFI - Long','9010','Other repairs and maintenance',80,0,NULL),(6091,'Canadian GIFI - Long','Canadian GIFI - Long','9011','Machine shop expense',80,0,NULL),(6092,'Canadian GIFI - Long','Canadian GIFI - Long','9012','Road costs',80,0,NULL),(6093,'Canadian GIFI - Long','Canadian GIFI - Long','9013','Security',80,0,NULL),(6094,'Canadian GIFI - Long','Canadian GIFI - Long','9014','Garbage removal',80,0,NULL),(6095,'Canadian GIFI - Long','Canadian GIFI - Long','9060','Salaries and wages',80,0,NULL),(6096,'Canadian GIFI - Long','Canadian GIFI - Long','9061','Commissions',80,0,'apcompany.glcommissionid'),(6097,'Canadian GIFI - Long','Canadian GIFI - Long','9062','Crew share',80,0,NULL),(6098,'Canadian GIFI - Long','Canadian GIFI - Long','9063','Bonuses',80,0,NULL),(6099,'Canadian GIFI - Long','Canadian GIFI - Long','9064','Directors fees',80,0,NULL),(6100,'Canadian GIFI - Long','Canadian GIFI - Long','9065','Management salaries',80,0,NULL),(6101,'Canadian GIFI - Long','Canadian GIFI - Long','9066','Employee salaries',80,0,NULL),(6102,'Canadian GIFI - Long','Canadian GIFI - Long','9110','Sub-contracts',80,0,NULL),(6103,'Canadian GIFI - Long','Canadian GIFI - Long','9130','Supplies',80,0,NULL),(6104,'Canadian GIFI - Long','Canadian GIFI - Long','9131','Small tools',80,0,NULL),(6105,'Canadian GIFI - Long','Canadian GIFI - Long','9132','Shop expense',80,0,NULL),(6106,'Canadian GIFI - Long','Canadian GIFI - Long','9133','Uniforms',80,0,NULL),(6107,'Canadian GIFI - Long','Canadian GIFI - Long','9134','Laundry',80,0,NULL),(6108,'Canadian GIFI - Long','Canadian GIFI - Long','9135','Food and catering',80,0,NULL),(6109,'Canadian GIFI - Long','Canadian GIFI - Long','9136','Fishing gear',80,0,NULL),(6110,'Canadian GIFI - Long','Canadian GIFI - Long','9137','Nets and traps',80,0,NULL),(6111,'Canadian GIFI - Long','Canadian GIFI - Long','9138','Salt bait and ice',80,0,NULL),(6112,'Canadian GIFI - Long','Canadian GIFI - Long','9139','Camp supplies',80,0,NULL),(6113,'Canadian GIFI - Long','Canadian GIFI - Long','9150','Computer-related expenses',80,0,NULL),(6114,'Canadian GIFI - Long','Canadian GIFI - Long','9151','Upgrade',80,0,NULL),(6115,'Canadian GIFI - Long','Canadian GIFI - Long','9152','Internet',80,0,NULL),(6116,'Canadian GIFI - Long','Canadian GIFI - Long','9180','Property taxes',80,0,NULL),(6117,'Canadian GIFI - Long','Canadian GIFI - Long','9200','Travel expenses',80,0,NULL),(6118,'Canadian GIFI - Long','Canadian GIFI - Long','9201','Meetings and conventions',80,0,NULL),(6119,'Canadian GIFI - Long','Canadian GIFI - Long','9220','Utilities',80,0,NULL),(6120,'Canadian GIFI - Long','Canadian GIFI - Long','9221','Electricity',80,0,NULL),(6121,'Canadian GIFI - Long','Canadian GIFI - Long','9222','Water',80,0,NULL),(6122,'Canadian GIFI - Long','Canadian GIFI - Long','9223','Heat',80,0,NULL),(6123,'Canadian GIFI - Long','Canadian GIFI - Long','9224','Fuel costs',80,0,NULL),(6124,'Canadian GIFI - Long','Canadian GIFI - Long','9225','Telephone and telecommunications',80,0,NULL),(6125,'Canadian GIFI - Long','Canadian GIFI - Long','9270','Other expenses',80,0,NULL),(6126,'Canadian GIFI - Long','Canadian GIFI - Long','9271','Cash over/short',80,0,NULL),(6127,'Canadian GIFI - Long','Canadian GIFI - Long','9272','Reimbursement of parent company expense',80,0,NULL),(6128,'Canadian GIFI - Long','Canadian GIFI - Long','9273','Selling expenses',80,0,NULL),(6129,'Canadian GIFI - Long','Canadian GIFI - Long','9274','Shipping and warehouse expense',80,0,NULL),(6130,'Canadian GIFI - Long','Canadian GIFI - Long','9275','Delivery freight and express',80,0,'invcompany.freight'),(6131,'Canadian GIFI - Long','Canadian GIFI - Long','9276','Warranty expenses',80,0,NULL),(6132,'Canadian GIFI - Long','Canadian GIFI - Long','9277','Royalty expenses - Resident',80,0,NULL),(6133,'Canadian GIFI - Long','Canadian GIFI - Long','9278','Royalty expenses - Non-resident',80,0,NULL),(6134,'Canadian GIFI - Long','Canadian GIFI - Long','9279','Dumping charges',80,0,NULL),(6135,'Canadian GIFI - Long','Canadian GIFI - Long','9280','Land fill fees',80,0,NULL),(6136,'Canadian GIFI - Long','Canadian GIFI - Long','9281','Vehicle expenses',80,0,NULL),(6137,'Canadian GIFI - Long','Canadian GIFI - Long','9282','Research and development',80,0,NULL),(6138,'Canadian GIFI - Long','Canadian GIFI - Long','9283','Withholding taxes',80,0,NULL),(6139,'Canadian GIFI - Long','Canadian GIFI - Long','9284','General and administrative expenses',80,0,NULL),(6140,'Canadian GIFI - Long','Canadian GIFI - Long','9285','Interdivisional expenses',80,0,NULL),(6141,'Canadian GIFI - Long','Canadian GIFI - Long','9286','Interfund transfer',80,0,NULL),(6142,'Canadian GIFI - Long','Canadian GIFI - Long','9367','Total operating expenses',80,0,NULL),(6143,'Canadian GIFI - Long','Canadian GIFI - Long','9368','Total expenses',80,0,NULL),(6144,'Canadian GIFI - Long','Canadian GIFI - Long','9369','Net non-farming income',80,0,NULL),(6145,'Canadian GIFI - Long','Canadian GIFI - Long','9370','Grains and oilseeds',90,0,NULL),(6146,'Canadian GIFI - Long','Canadian GIFI - Long','9371','Wheat',90,0,NULL),(6147,'Canadian GIFI - Long','Canadian GIFI - Long','9372','Oats',90,0,NULL),(6148,'Canadian GIFI - Long','Canadian GIFI - Long','9373','Barley',90,0,NULL),(6149,'Canadian GIFI - Long','Canadian GIFI - Long','9374','Mixed grains',90,0,NULL),(6150,'Canadian GIFI - Long','Canadian GIFI - Long','9375','Corn',90,0,NULL),(6151,'Canadian GIFI - Long','Canadian GIFI - Long','9376','Canola',90,0,NULL),(6152,'Canadian GIFI - Long','Canadian GIFI - Long','9377','Flaxseed',90,0,NULL),(6153,'Canadian GIFI - Long','Canadian GIFI - Long','9378','Soya beans',90,0,NULL),(6154,'Canadian GIFI - Long','Canadian GIFI - Long','9379','Wheat Board payments',90,0,NULL),(6155,'Canadian GIFI - Long','Canadian GIFI - Long','9420','Other crop revenues',90,0,NULL),(6156,'Canadian GIFI - Long','Canadian GIFI - Long','9421','Fruit',90,0,NULL),(6157,'Canadian GIFI - Long','Canadian GIFI - Long','9422','Potatoes',90,0,NULL),(6158,'Canadian GIFI - Long','Canadian GIFI - Long','9423','Vegetables',90,0,NULL),(6159,'Canadian GIFI - Long','Canadian GIFI - Long','9424','Tobacco',90,0,NULL),(6160,'Canadian GIFI - Long','Canadian GIFI - Long','9425','Greenhouse and nursery products',90,0,NULL),(6161,'Canadian GIFI - Long','Canadian GIFI - Long','9426','Forage crops',90,0,NULL),(6162,'Canadian GIFI - Long','Canadian GIFI - Long','9470','Livestock and animal products revenue',90,0,NULL),(6163,'Canadian GIFI - Long','Canadian GIFI - Long','9471','Cattle',90,0,NULL),(6164,'Canadian GIFI - Long','Canadian GIFI - Long','9472','Swine',90,0,NULL),(6165,'Canadian GIFI - Long','Canadian GIFI - Long','9473','Poultry',90,0,NULL),(6166,'Canadian GIFI - Long','Canadian GIFI - Long','9474','Sheep and lambs',90,0,NULL),(6167,'Canadian GIFI - Long','Canadian GIFI - Long','9475','Pregnant mare urine (PMU)',90,0,NULL),(6168,'Canadian GIFI - Long','Canadian GIFI - Long','9476','Milk and cream (excluding dairy subsidies)',90,0,NULL),(6169,'Canadian GIFI - Long','Canadian GIFI - Long','9477','Eggs for consumption',90,0,NULL),(6170,'Canadian GIFI - Long','Canadian GIFI - Long','9478','Hatching eggs',90,0,NULL),(6171,'Canadian GIFI - Long','Canadian GIFI - Long','9479','Aquaculture (hatching and raising)',90,0,NULL),(6172,'Canadian GIFI - Long','Canadian GIFI - Long','9480','Horses (breeding and meat)',90,0,NULL),(6173,'Canadian GIFI - Long','Canadian GIFI - Long','9520','Other commodities',90,0,NULL),(6174,'Canadian GIFI - Long','Canadian GIFI - Long','9521','Maple products',90,0,NULL),(6175,'Canadian GIFI - Long','Canadian GIFI - Long','9522','Artificial insemination',90,0,NULL),(6176,'Canadian GIFI - Long','Canadian GIFI - Long','9523','Semen production',90,0,NULL),(6177,'Canadian GIFI - Long','Canadian GIFI - Long','9524','Embryo production',90,0,NULL),(6178,'Canadian GIFI - Long','Canadian GIFI - Long','9540','Program payment revenues',90,0,NULL),(6179,'Canadian GIFI - Long','Canadian GIFI - Long','9541','Dairy subsidies',90,0,NULL),(6180,'Canadian GIFI - Long','Canadian GIFI - Long','9542','Crop insurance',90,0,NULL),(6181,'Canadian GIFI - Long','Canadian GIFI - Long','9543','NISA payments',90,0,NULL),(6182,'Canadian GIFI - Long','Canadian GIFI - Long','9544','Disaster Assistance Program payments',90,0,NULL),(6183,'Canadian GIFI - Long','Canadian GIFI - Long','9545','AgriStability and AgriInvest benefit',90,0,NULL),(6184,'Canadian GIFI - Long','Canadian GIFI - Long','9546','Production insurance premium benefit',90,0,NULL),(6185,'Canadian GIFI - Long','Canadian GIFI - Long','9570','Rebates',90,0,NULL),(6186,'Canadian GIFI - Long','Canadian GIFI - Long','9571','Rebates - Fuel',90,0,NULL),(6187,'Canadian GIFI - Long','Canadian GIFI - Long','9572','Rebates - Interest',90,0,NULL),(6188,'Canadian GIFI - Long','Canadian GIFI - Long','9573','Rebates - Property taxes',90,0,NULL),(6189,'Canadian GIFI - Long','Canadian GIFI - Long','9574','Resales rebates GST for NISA eligible expenses',90,0,NULL),(6190,'Canadian GIFI - Long','Canadian GIFI - Long','9575','Rebates GST for NISA non-eligible expenses',90,0,NULL),(6191,'Canadian GIFI - Long','Canadian GIFI - Long','9600','Other farm revenues/losses',90,0,NULL),(6192,'Canadian GIFI - Long','Canadian GIFI - Long','9601','Custom or contract work',90,0,NULL),(6193,'Canadian GIFI - Long','Canadian GIFI - Long','9602','Wood sales',90,0,NULL),(6194,'Canadian GIFI - Long','Canadian GIFI - Long','9603','Horse racing',90,0,NULL),(6195,'Canadian GIFI - Long','Canadian GIFI - Long','9604','Insurance proceeds',90,0,NULL),(6196,'Canadian GIFI - Long','Canadian GIFI - Long','9605','Patronage dividends',90,0,NULL),(6197,'Canadian GIFI - Long','Canadian GIFI - Long','9606','Rental income',90,0,NULL),(6198,'Canadian GIFI - Long','Canadian GIFI - Long','9607','Interest income',90,0,NULL),(6199,'Canadian GIFI - Long','Canadian GIFI - Long','9608','Dividend income',90,0,NULL),(6200,'Canadian GIFI - Long','Canadian GIFI - Long','9609','Gains/losses on disposal of assets',90,0,NULL),(6201,'Canadian GIFI - Long','Canadian GIFI - Long','9610','Gravel',90,0,NULL),(6202,'Canadian GIFI - Long','Canadian GIFI - Long','9611','Trucking',90,0,NULL),(6203,'Canadian GIFI - Long','Canadian GIFI - Long','9612','Resale of commodities purchased',90,0,NULL),(6204,'Canadian GIFI - Long','Canadian GIFI - Long','9613','Leases (gas oil well surface etc.)',90,0,NULL),(6205,'Canadian GIFI - Long','Canadian GIFI - Long','9614','Machine rentals',90,0,NULL),(6206,'Canadian GIFI - Long','Canadian GIFI - Long','9615','Farming partnership income/loss',90,0,NULL),(6207,'Canadian GIFI - Long','Canadian GIFI - Long','9616','Farming joint venture income/loss',90,0,NULL),(6208,'Canadian GIFI - Long','Canadian GIFI - Long','9617','Custom feeding',90,0,NULL),(6209,'Canadian GIFI - Long','Canadian GIFI - Long','9650','Non-farming income',90,0,NULL),(6210,'Canadian GIFI - Long','Canadian GIFI - Long','9659','Total farm revenue',90,0,NULL),(6211,'Canadian GIFI - Long','Canadian GIFI - Long','9660','Crop expenses',90,0,NULL),(6212,'Canadian GIFI - Long','Canadian GIFI - Long','9661','Containers twine and baling wire',90,0,NULL),(6213,'Canadian GIFI - Long','Canadian GIFI - Long','9662','Fertilizers and lime',90,0,NULL),(6214,'Canadian GIFI - Long','Canadian GIFI - Long','9663','Pesticides',90,0,NULL),(6215,'Canadian GIFI - Long','Canadian GIFI - Long','9664','Seeds and plants',90,0,NULL),(6216,'Canadian GIFI - Long','Canadian GIFI - Long','9665','Insurance premiums (crop) NISA ACS',90,0,NULL),(6217,'Canadian GIFI - Long','Canadian GIFI - Long','9710','Livestock expenses',90,0,NULL),(6218,'Canadian GIFI - Long','Canadian GIFI - Long','9711','Feed supplements straw and bedding',90,0,NULL),(6219,'Canadian GIFI - Long','Canadian GIFI - Long','9712','Livestock purchases',90,0,NULL),(6220,'Canadian GIFI - Long','Canadian GIFI - Long','9713','Veterinary fees medicine and breeding fees',90,0,NULL),(6221,'Canadian GIFI - Long','Canadian GIFI - Long','9714','Minerals and salts',90,0,NULL),(6222,'Canadian GIFI - Long','Canadian GIFI - Long','9760','Machinery expenses',90,0,NULL),(6223,'Canadian GIFI - Long','Canadian GIFI - Long','9761','Machinery insurance',90,0,NULL),(6224,'Canadian GIFI - Long','Canadian GIFI - Long','9762','Machinery licences',90,0,NULL),(6225,'Canadian GIFI - Long','Canadian GIFI - Long','9763','Machinery repairs',90,0,NULL),(6226,'Canadian GIFI - Long','Canadian GIFI - Long','9764','Machinery fuel',90,0,NULL),(6227,'Canadian GIFI - Long','Canadian GIFI - Long','9765','Machinery lease',90,0,NULL),(6228,'Canadian GIFI - Long','Canadian GIFI - Long','9790','General farm expenses',90,0,NULL),(6229,'Canadian GIFI - Long','Canadian GIFI - Long','9791','Amortization of tangible assets',90,0,NULL),(6230,'Canadian GIFI - Long','Canadian GIFI - Long','9792','Advertising marketing costs and promotion',90,0,NULL),(6231,'Canadian GIFI - Long','Canadian GIFI - Long','9793','Bad debt',90,0,NULL),(6232,'Canadian GIFI - Long','Canadian GIFI - Long','9794','Benefits related to employee salaries',90,0,NULL),(6233,'Canadian GIFI - Long','Canadian GIFI - Long','9795','Building repairs and maintenance',90,0,NULL),(6234,'Canadian GIFI - Long','Canadian GIFI - Long','9796','Clearing levelling and draining land',90,0,NULL),(6235,'Canadian GIFI - Long','Canadian GIFI - Long','9797','Crop insurance Revenue Protection Program and stabilization',90,0,NULL),(6236,'Canadian GIFI - Long','Canadian GIFI - Long','9798','Custom or contract work',90,0,NULL),(6237,'Canadian GIFI - Long','Canadian GIFI - Long','9799','Electricity',90,0,NULL),(6238,'Canadian GIFI - Long','Canadian GIFI - Long','9800','Fence repairs and maintenance',90,0,NULL),(6239,'Canadian GIFI - Long','Canadian GIFI - Long','9801','Freight and trucking',90,0,NULL),(6240,'Canadian GIFI - Long','Canadian GIFI - Long','9802','Heating fuel and curing fuel',90,0,NULL),(6241,'Canadian GIFI - Long','Canadian GIFI - Long','9803','Insurance program overpayment recapture',90,0,NULL),(6242,'Canadian GIFI - Long','Canadian GIFI - Long','9804','Other insurance premiums',90,0,NULL),(6243,'Canadian GIFI - Long','Canadian GIFI - Long','9805','Interest and bank charges',90,0,NULL),(6244,'Canadian GIFI - Long','Canadian GIFI - Long','9806','Marketing board fees',90,0,NULL),(6245,'Canadian GIFI - Long','Canadian GIFI - Long','9807','Memberships/subscription fees',90,0,NULL),(6246,'Canadian GIFI - Long','Canadian GIFI - Long','9808','Office expenses',90,0,NULL),(6247,'Canadian GIFI - Long','Canadian GIFI - Long','9809','Professional fees',90,0,NULL),(6248,'Canadian GIFI - Long','Canadian GIFI - Long','9810','Property taxes',90,0,NULL),(6249,'Canadian GIFI - Long','Canadian GIFI - Long','9811','Rent - Land and buildings',90,0,NULL),(6250,'Canadian GIFI - Long','Canadian GIFI - Long','9812','Rent - Machinery',90,0,NULL),(6251,'Canadian GIFI - Long','Canadian GIFI - Long','9813','Other rental expenses',90,0,NULL),(6252,'Canadian GIFI - Long','Canadian GIFI - Long','9814','Salaries and wages',90,0,NULL),(6253,'Canadian GIFI - Long','Canadian GIFI - Long','9815','Salaries and wages other than for spouse or dependants',90,0,NULL),(6254,'Canadian GIFI - Long','Canadian GIFI - Long','9816','Salaries and wages paid to dependants',90,0,NULL),(6255,'Canadian GIFI - Long','Canadian GIFI - Long','9817','Selling costs',90,0,NULL),(6256,'Canadian GIFI - Long','Canadian GIFI - Long','9818','Supplies',90,0,NULL),(6257,'Canadian GIFI - Long','Canadian GIFI - Long','9819','Motor vehicle expenses',90,0,NULL),(6258,'Canadian GIFI - Long','Canadian GIFI - Long','9820','Small tools',90,0,NULL),(6259,'Canadian GIFI - Long','Canadian GIFI - Long','9821','Soil testing',90,0,NULL),(6260,'Canadian GIFI - Long','Canadian GIFI - Long','9822','Storage/drying',90,0,NULL),(6261,'Canadian GIFI - Long','Canadian GIFI - Long','9823','Licences/permits',90,0,NULL),(6262,'Canadian GIFI - Long','Canadian GIFI - Long','9824','Telephone',90,0,NULL),(6263,'Canadian GIFI - Long','Canadian GIFI - Long','9825','Quota rental (tobacco dairy)',90,0,NULL),(6264,'Canadian GIFI - Long','Canadian GIFI - Long','9826','Gravel',90,0,NULL),(6265,'Canadian GIFI - Long','Canadian GIFI - Long','9827','Purchases of commodities resold',90,0,NULL),(6266,'Canadian GIFI - Long','Canadian GIFI - Long','9828','Salaries and wages paid to spouse',90,0,NULL),(6267,'Canadian GIFI - Long','Canadian GIFI - Long','9829','Motor vehicle interest and leasing costs',90,0,NULL),(6268,'Canadian GIFI - Long','Canadian GIFI - Long','9830','Prepared feed',90,0,NULL),(6269,'Canadian GIFI - Long','Canadian GIFI - Long','9831','Custom feed',90,0,NULL),(6270,'Canadian GIFI - Long','Canadian GIFI - Long','9832','Amortization of intangible assets',90,0,NULL),(6271,'Canadian GIFI - Long','Canadian GIFI - Long','9833','Amortization of milk quota',90,0,NULL),(6272,'Canadian GIFI - Long','Canadian GIFI - Long','9834','Travel expenses',90,0,NULL),(6273,'Canadian GIFI - Long','Canadian GIFI - Long','9850','Non-farming expenses',90,0,NULL),(6274,'Canadian GIFI - Long','Canadian GIFI - Long','9870','Net inventory adjustment',90,0,NULL),(6275,'Canadian GIFI - Long','Canadian GIFI - Long','9898','Total farm expenses',90,0,NULL),(6276,'Canadian GIFI - Long','Canadian GIFI - Long','9899','Net farm income',90,0,NULL),(6277,'Canadian GIFI - Long','Canadian GIFI - Long','9970','Net income/loss before taxes and extraordinary items',90,0,NULL),(6278,'Canadian GIFI - Long','Canadian GIFI - Long','9975','Extraordinary item(s)',90,0,NULL),(6279,'Canadian GIFI - Long','Canadian GIFI - Long','9976','Legal settlements',90,0,NULL),(6280,'Canadian GIFI - Long','Canadian GIFI - Long','9980','Unrealized gains/losses',90,0,NULL),(6281,'Canadian GIFI - Long','Canadian GIFI - Long','9985','Unusual items',90,0,NULL),(6282,'Canadian GIFI - Long','Canadian GIFI - Long','9990','Current income taxes',90,0,NULL),(6283,'Canadian GIFI - Long','Canadian GIFI - Long','9995','Future (deferred) income tax provision',90,0,NULL),(6284,'Canadian GIFI - Long','Canadian GIFI - Long','9998','Total-other comprehensive income',90,0,NULL),(6285,'Canadian GIFI - Long','Canadian GIFI - Long','9999','Net income/loss after taxes and extraordinary items',90,0,NULL),(6286,'Dutch','Dutch','100','Goodwill',11,0,NULL),(6287,'Dutch','Dutch','101','Afschrijving goodwill',11,0,NULL),(6288,'Dutch','Dutch','110','Aanloopkosten',11,0,NULL),(6289,'Dutch','Dutch','111','Afschrijving aanloopkst.',11,0,NULL),(6290,'Dutch','Dutch','200','Gebouwen en terreinen',11,0,NULL),(6291,'Dutch','Dutch','201','Afschrijving gebouwen',11,0,NULL),(6292,'Dutch','Dutch','210','Verbouwing',11,0,NULL),(6293,'Dutch','Dutch','211','Afschrijving verbouwingen',11,0,NULL),(6294,'Dutch','Dutch','220','Machines en installaties',11,0,NULL),(6295,'Dutch','Dutch','221','Afschrijving mach. & inst.',11,0,NULL),(6296,'Dutch','Dutch','230','Inventaris en inrichting',11,0,NULL),(6297,'Dutch','Dutch','231','Afschrijving inv. & inr.',11,0,NULL),(6298,'Dutch','Dutch','240','Computers',11,0,NULL),(6299,'Dutch','Dutch','241','Afschrijving computers',11,0,NULL),(6300,'Dutch','Dutch','250','Vervoersmiddelen',11,0,NULL),(6301,'Dutch','Dutch','251','Afschrijving Vervoersmiddelen',11,0,NULL),(6302,'Dutch','Dutch','320','Lening u/g de heer A',11,0,NULL),(6303,'Dutch','Dutch','500','Kapitaal ',30,0,NULL),(6304,'Dutch','Dutch','501','Resultaat lopend boekjaar',30,0,NULL),(6305,'Dutch','Dutch','502','Fiscale Oudedags Reserve',30,0,NULL),(6306,'Dutch','Dutch','503','Geplaatst kapitaal',30,0,NULL),(6307,'Dutch','Dutch','509','Latente belastingverplichting',30,0,NULL),(6308,'Dutch','Dutch','510','Prive stortingen',30,0,NULL),(6309,'Dutch','Dutch','520','Prive opnamen',30,0,NULL),(6310,'Dutch','Dutch','530','Prive rente',30,0,NULL),(6311,'Dutch','Dutch','540','Prive ziektekosten',30,0,NULL),(6312,'Dutch','Dutch','550','Prive belastingen',30,0,NULL),(6313,'Dutch','Dutch','552','Prive arbeidsong.verzekering',30,0,NULL),(6314,'Dutch','Dutch','560','Prive schenkingen',30,0,NULL),(6315,'Dutch','Dutch','570','Prive verzekeringen',30,0,NULL),(6316,'Dutch','Dutch','590','Prive uitgaven overige',30,0,NULL),(6317,'Dutch','Dutch','591','Prive boetes',30,0,NULL),(6318,'Dutch','Dutch','800','Hypotheek bedrijfspand',22,0,NULL),(6319,'Dutch','Dutch','810','Lening Bank',22,0,NULL),(6320,'Dutch','Dutch','811','Middellang krediet Bank',22,0,NULL),(6321,'Dutch','Dutch','820','Financiallease ',22,0,NULL),(6322,'Dutch','Dutch','880','Lening opgenomen',22,0,NULL),(6323,'Dutch','Dutch','950','Leningen uitgegeven',10,0,NULL),(6324,'Dutch','Dutch','1000','Kas',10,0,NULL),(6325,'Dutch','Dutch','1100','Bank rekening courant',10,0,NULL),(6326,'Dutch','Dutch','1190','Kruisposten',10,0,NULL),(6327,'Dutch','Dutch','1200','Debiteuren',10,0,NULL),(6328,'Dutch','Dutch','1300','Waarborgsommen',10,0,NULL),(6329,'Dutch','Dutch','1350','Transistorische activa',10,0,NULL),(6330,'Dutch','Dutch','1400','Vooruitbetalingen',10,0,NULL),(6331,'Dutch','Dutch','1502','BTW verkoop hoog 21%',21,0,NULL),(6332,'Dutch','Dutch','1510','BTW Verkoop Laag 6%',21,0,NULL),(6333,'Dutch','Dutch','1522','BTW inkoop hoog 21%',21,0,NULL),(6334,'Dutch','Dutch','1530','BTW Inkoop Laag 6%',21,0,NULL),(6335,'Dutch','Dutch','1550','BTW Geen',21,0,NULL),(6336,'Dutch','Dutch','1560','Omzetbelasting betaald',21,0,NULL),(6337,'Dutch','Dutch','1570','BTW kleine ondernemersregeling',21,0,NULL),(6338,'Dutch','Dutch','1600','Crediteuren',21,0,NULL),(6339,'Dutch','Dutch','1700','Netto Salaris',21,0,NULL),(6340,'Dutch','Dutch','1710','Loonheffing betaald',21,0,NULL),(6341,'Dutch','Dutch','1711','Ingehouden loonheffing',21,0,NULL),(6342,'Dutch','Dutch','1751','Ingehouden cao',21,0,NULL),(6343,'Dutch','Dutch','1790','Te betalen VPB',21,0,NULL),(6344,'Dutch','Dutch','1900','Aflossingsverplichtingen',21,0,NULL),(6345,'Dutch','Dutch','1910','Reservering vakantiegeld',21,0,NULL),(6346,'Dutch','Dutch','1911','Reservering vakantiedagen',21,0,NULL),(6347,'Dutch','Dutch','1912','Vooruitbetalingen',21,0,NULL),(6348,'Dutch','Dutch','1920','Transistorische passiva',21,0,NULL),(6349,'Dutch','Dutch','2000','Vraagposten',21,0,NULL),(6350,'Dutch','Dutch','2010','Rek. courant directie',21,0,NULL),(6351,'Dutch','Dutch','3000','Voorraad',10,0,NULL),(6352,'Dutch','Dutch','3010','Onderhanden werk',10,0,NULL),(6353,'Dutch','Dutch','3100','Embalage',10,0,NULL),(6354,'Dutch','Dutch','4000','Bruto lonen',80,0,NULL),(6355,'Dutch','Dutch','4001','Tantieme',80,0,NULL),(6356,'Dutch','Dutch','4010','Subsidies',80,0,NULL),(6357,'Dutch','Dutch','4070','Mutatie vakantiegeld',80,0,NULL),(6358,'Dutch','Dutch','4071','Mutatie vakantiedagen',80,0,NULL),(6359,'Dutch','Dutch','4090','Doorberekende salarissen',80,0,NULL),(6360,'Dutch','Dutch','4100','WAO/WW/AWF/Zvw',80,0,NULL),(6361,'Dutch','Dutch','4110','CAO premie',80,0,NULL),(6362,'Dutch','Dutch','4149','Arbodienst',80,0,NULL),(6363,'Dutch','Dutch','4150','Ziekteverzuimverzekering',80,0,NULL),(6364,'Dutch','Dutch','4200','Reiskostenvergoedingen',80,0,NULL),(6365,'Dutch','Dutch','4230','Studiekosten',80,0,NULL),(6366,'Dutch','Dutch','4240','Kostenvergoeding',80,0,NULL),(6367,'Dutch','Dutch','4270','Kantine en consumptie',80,0,NULL),(6368,'Dutch','Dutch','4290','Overige personeelskosten',80,0,NULL),(6369,'Dutch','Dutch','4300','Afschr. kosten gebouwen',80,0,NULL),(6370,'Dutch','Dutch','4310','Afschr. kosten verbouwing',80,0,NULL),(6371,'Dutch','Dutch','4320','Afschr. kosten mach & ins',80,0,NULL),(6372,'Dutch','Dutch','4330','Afschr. kosten inv. & inr.',80,0,NULL),(6373,'Dutch','Dutch','4340','Afschr. kosten computers',80,0,NULL),(6374,'Dutch','Dutch','4350','Afschr. kosten vervoersmid./autos',80,0,NULL),(6375,'Dutch','Dutch','4380','Afschr. kosten goodwill',80,0,NULL),(6376,'Dutch','Dutch','4390','Afschr. kosten aanloopkst.',80,0,NULL),(6377,'Dutch','Dutch','4500','Huur bedrijfspand',80,0,NULL),(6378,'Dutch','Dutch','4510','Servicekosten',80,0,NULL),(6379,'Dutch','Dutch','4520','Gas water & electra',80,0,NULL),(6380,'Dutch','Dutch','4530','Vaste lasten',80,0,NULL),(6381,'Dutch','Dutch','4540','Onderhoud bedrijfspand',80,0,NULL),(6382,'Dutch','Dutch','4550','Schoonmaakkosten',80,0,NULL),(6383,'Dutch','Dutch','4560','Verzekering bedrijfspand',80,0,NULL),(6384,'Dutch','Dutch','4590','Overige huisvestingskosten',80,0,NULL),(6385,'Dutch','Dutch','4600','Leasekosten auto',80,0,NULL),(6386,'Dutch','Dutch','4605','Huur auto',80,0,NULL),(6387,'Dutch','Dutch','4610','Brandstof auto',80,0,NULL),(6388,'Dutch','Dutch','4615','Motorrijtuigenbelasting',80,0,NULL),(6389,'Dutch','Dutch','4620','Onderhoud auto',80,0,NULL),(6390,'Dutch','Dutch','4630','Verzekering auto',80,0,NULL),(6391,'Dutch','Dutch','4640','Kilometervergoedingen',80,0,NULL),(6392,'Dutch','Dutch','4671','Boetes 0% aftrekbaar',80,0,NULL),(6393,'Dutch','Dutch','4680','BTW privegebruik auto',80,0,NULL),(6394,'Dutch','Dutch','4690','Overige autokosten',80,0,NULL),(6395,'Dutch','Dutch','4700','Reclamekosten',80,0,NULL),(6396,'Dutch','Dutch','4710','Advertentiekosten',80,0,NULL),(6397,'Dutch','Dutch','4711','Sponsoring',80,0,NULL),(6398,'Dutch','Dutch','4720','Beurskosten',80,0,NULL),(6399,'Dutch','Dutch','4730','Relatiegeschenken',80,0,NULL),(6400,'Dutch','Dutch','4740','Reis- en verblijfkosten',80,0,NULL),(6401,'Dutch','Dutch','4742','Voedsel en drank ',80,0,NULL),(6402,'Dutch','Dutch','4743','Kantinekosten (niet gebruiken)',80,0,NULL),(6403,'Dutch','Dutch','4750','Representatiekosten',80,0,NULL),(6404,'Dutch','Dutch','4760','Credit-cardkosten',80,0,NULL),(6405,'Dutch','Dutch','4780','Kasverschillen',80,0,NULL),(6406,'Dutch','Dutch','4781','Afrondingsverschillen',80,0,NULL),(6407,'Dutch','Dutch','4790','Overige verkoopkosten',80,0,NULL),(6408,'Dutch','Dutch','4800','Verzending portikosten',80,0,NULL),(6409,'Dutch','Dutch','4810','Vervoerskosten',80,0,NULL),(6410,'Dutch','Dutch','4890','Overige distributiekosten',80,0,NULL),(6411,'Dutch','Dutch','4900','Tel fax en internetkosten',80,0,NULL),(6412,'Dutch','Dutch','4910','Contributies & abonnement',80,0,NULL),(6413,'Dutch','Dutch','4920','Verzekering algemeen',80,0,NULL),(6414,'Dutch','Dutch','4930','Kantoorkosten',80,0,NULL),(6415,'Dutch','Dutch','4931','Kleine aanschaf kantoor',80,0,NULL),(6416,'Dutch','Dutch','4932','Vakliteratuur',80,0,NULL),(6417,'Dutch','Dutch','4938','Notariskosten',80,0,NULL),(6418,'Dutch','Dutch','4939','Inhuren fiscalist',80,0,NULL),(6419,'Dutch','Dutch','4940','Accountantskosten',80,0,NULL),(6420,'Dutch','Dutch','4941','Administratiekosten',80,0,NULL),(6421,'Dutch','Dutch','4942','Loonadministratiekosten',80,0,NULL),(6422,'Dutch','Dutch','4943','Incasso & advocaatkosten',80,0,NULL),(6423,'Dutch','Dutch','4944','Software',80,0,NULL),(6424,'Dutch','Dutch','4945','Systeembeheer',80,0,NULL),(6425,'Dutch','Dutch','4946','Website',80,0,NULL),(6426,'Dutch','Dutch','4947','Hostingkosten',80,0,NULL),(6427,'Dutch','Dutch','4948','Coaching',80,0,NULL),(6428,'Dutch','Dutch','4950','Drukwerk & papier',80,0,NULL),(6429,'Dutch','Dutch','4960','Branche-organisatiekosten',80,0,NULL),(6430,'Dutch','Dutch','4970','Postzegels',80,0,NULL),(6431,'Dutch','Dutch','4980','Bankkosten',80,0,NULL),(6432,'Dutch','Dutch','4985','Onderhoud inventaris',80,0,NULL),(6433,'Dutch','Dutch','4986','Onderhoud computers',80,0,NULL),(6434,'Dutch','Dutch','4990','Overige algemene kosten',80,0,NULL),(6435,'Dutch','Dutch','4991','Bijzondere baten & lasten',90,0,NULL),(6436,'Dutch','Dutch','4992','Boekverliezen',80,0,NULL),(6437,'Dutch','Dutch','7000','Inkopen 21%',70,0,NULL),(6438,'Dutch','Dutch','7100','Inkopen 6% BTW',70,0,NULL),(6439,'Dutch','Dutch','7200','Inkopen 0% BTW',70,0,NULL),(6440,'Dutch','Dutch','7050','Management vergoeding',70,0,NULL),(6441,'Dutch','Dutch','7300','Werk Derden',70,0,NULL),(6442,'Dutch','Dutch','7700','Mutatie handelsvoorraad',70,0,NULL),(6443,'Dutch','Dutch','7900','Betalingskorting inkoop',70,0,NULL),(6444,'Dutch','Dutch','7920','Prijsverschillen inkoop',70,0,NULL),(6445,'Dutch','Dutch','8000','Omzet 21%',50,0,NULL),(6446,'Dutch','Dutch','8001','Omzet 6% BTW',50,0,NULL),(6447,'Dutch','Dutch','8002','Omzet 0% BTW',50,0,NULL),(6448,'Dutch','Dutch','8003','Omzet verlegd',50,0,NULL),(6449,'Dutch','Dutch','8950','Oninbare debiteuren',50,0,NULL),(6450,'Dutch','Dutch','9000','Rente bate ',90,0,NULL),(6451,'Dutch','Dutch','9100','Rente last ',90,0,NULL),(6452,'Dutch','Dutch','9430','Betalings- en afrondingsverschillen',90,0,NULL),(6453,'Dutch','Dutch','9601','Dotering FOR',60,0,NULL),(6454,'Dutch','Dutch','9602','Vennootschapsbelasting',60,0,NULL);
/*!40000 ALTER TABLE `std_accounts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `std_accounts_lang`
--

DROP TABLE IF EXISTS `std_accounts_lang`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `std_accounts_lang` (
  `industry_code` varchar(20) NOT NULL,
  `lang_code` varchar(3) NOT NULL,
  PRIMARY KEY  (`industry_code`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `std_accounts_lang`
--

LOCK TABLES `std_accounts_lang` WRITE;
/*!40000 ALTER TABLE `std_accounts_lang` DISABLE KEYS */;
INSERT INTO `std_accounts_lang` VALUES ('Accountants','en'),('Canadian GIFI - Long','en'),('Canadian GIFI - Shor','en'),('Computer','en'),('Manufacturing - Exte','en'),('Manufacturing - Simp','en'),('Medical - Complete','en'),('Medical - Extensive','en'),('Medical - Simple','en'),('MenorÃ­a - Simple','es'),('MittetulundusÃ¼hing','et'),('OsaÃ¼hing','et'),('Plan Cuentas 1','es'),('Plan Cuentas 2','es'),('Plan Cuentas 3','es'),('Printers','en'),('Retail - Extensive','en'),('Retail - Simple','en'),('Service - Extensive','en'),('Service - Simple','en'),('Vietnamese','vi'),('Dutch','nl');
/*!40000 ALTER TABLE `std_accounts_lang` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stock_purpose`
--

DROP TABLE IF EXISTS `stock_purpose`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stock_purpose` (
  `id_stockpurpose` int(11) NOT NULL auto_increment,
  `purpose` varchar(30) default NULL,
  `cancel` int(11) NOT NULL default '0',
  `cancel_date` datetime default NULL,
  `cancel_userid` int(11) NOT NULL default '0',
  `createdate` datetime default NULL,
  `create_userid` int(11) NOT NULL default '0',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `sortorder` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_stockpurpose`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stock_purpose`
--

LOCK TABLES `stock_purpose` WRITE;
/*!40000 ALTER TABLE `stock_purpose` DISABLE KEYS */;
/*!40000 ALTER TABLE `stock_purpose` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stock_purposeseq`
--

DROP TABLE IF EXISTS `stock_purposeseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stock_purposeseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stock_purposeseq`
--

LOCK TABLES `stock_purposeseq` WRITE;
/*!40000 ALTER TABLE `stock_purposeseq` DISABLE KEYS */;
INSERT INTO `stock_purposeseq` VALUES (1);
/*!40000 ALTER TABLE `stock_purposeseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stockpurposeseq`
--

DROP TABLE IF EXISTS `stockpurposeseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stockpurposeseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stockpurposeseq`
--

LOCK TABLES `stockpurposeseq` WRITE;
/*!40000 ALTER TABLE `stockpurposeseq` DISABLE KEYS */;
INSERT INTO `stockpurposeseq` VALUES (0);
/*!40000 ALTER TABLE `stockpurposeseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `supervisorlist`
--

DROP TABLE IF EXISTS `supervisorlist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `supervisorlist` (
  `id` int(11) NOT NULL auto_increment,
  `supervisor_employeeid` int(11) NOT NULL default '0',
  `employeeid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `supervisor_employeeid` (`supervisor_employeeid`),
  KEY `employeeid` (`employeeid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `supervisorlist`
--

LOCK TABLES `supervisorlist` WRITE;
/*!40000 ALTER TABLE `supervisorlist` DISABLE KEYS */;
/*!40000 ALTER TABLE `supervisorlist` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `survey`
--

DROP TABLE IF EXISTS `survey`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `survey` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `entryuserid` int(10) unsigned NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `cancel` int(11) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `companyid` int(10) unsigned NOT NULL default '0',
  `surveytype` varchar(20) NOT NULL default '',
  `emailtext` text NOT NULL,
  `active` int(11) NOT NULL default '1',
  `url` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `survey`
--

LOCK TABLES `survey` WRITE;
/*!40000 ALTER TABLE `survey` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `surveycomplete`
--

DROP TABLE IF EXISTS `surveycomplete`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `surveycomplete` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `surveyid` int(10) unsigned NOT NULL default '0',
  `customerid` int(10) unsigned NOT NULL default '0',
  `vendorid` int(10) unsigned NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `ip` varchar(20) NOT NULL default '',
  `referenceid` int(10) unsigned NOT NULL default '0',
  `referencetable` varchar(50) NOT NULL default '',
  `uniqueid` varchar(45) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `referenceid` (`referenceid`),
  KEY `customerid` (`customerid`),
  KEY `vendorid` (`vendorid`),
  KEY `entrydate` (`entrydate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `surveycomplete`
--

LOCK TABLES `surveycomplete` WRITE;
/*!40000 ALTER TABLE `surveycomplete` DISABLE KEYS */;
/*!40000 ALTER TABLE `surveycomplete` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `surveypending`
--

DROP TABLE IF EXISTS `surveypending`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `surveypending` (
  `id` int(11) NOT NULL auto_increment,
  `surveyid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `referencetable` varchar(50) NOT NULL default '',
  `referenceid` int(11) NOT NULL default '0',
  `uniqueid` varchar(45) NOT NULL default '',
  `querystring` varchar(200) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `surveycompleteid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `customerid` (`customerid`),
  KEY `vendorid` (`vendorid`),
  KEY `reference` (`referencetable`,`referenceid`),
  KEY `uniqueid` (`uniqueid`),
  KEY `surveycompleteid` (`surveycompleteid`),
  KEY `surveyid` (`surveyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `surveypending`
--

LOCK TABLES `surveypending` WRITE;
/*!40000 ALTER TABLE `surveypending` DISABLE KEYS */;
/*!40000 ALTER TABLE `surveypending` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `table_modified_times`
--

DROP TABLE IF EXISTS `table_modified_times`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `table_modified_times` (
  `id` int(11) NOT NULL auto_increment,
  `serversetup` int(11) default '-1',
  `genuser` int(11) default '-1',
  `genusercompany` int(11) default '-1',
  `feature_activation` int(11) default '-1',
  `lang` int(11) default '-1',
  `gencompany` int(11) default '-1',
  `arcompany` int(11) default '-1',
  `apcompany` int(11) default '-1',
  `invcompany` int(11) default '-1',
  `prcompany` int(11) default '-1',
  `footer_logo` int(11) default '-1',
  `setup` int(11) default '-1',
  `menusetuptodo` int(11) default '-1',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `table_modified_times`
--

LOCK TABLES `table_modified_times` WRITE;
/*!40000 ALTER TABLE `table_modified_times` DISABLE KEYS */;
INSERT INTO `table_modified_times` VALUES (1,1545175842,1501091945,1552856605,-1,1566227747,-1,-1,-1,-1,-1,-1,-1,-1);
/*!40000 ALTER TABLE `table_modified_times` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `task`
--

DROP TABLE IF EXISTS `task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `task` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(200) NOT NULL default '',
  `description` text,
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(4) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `autoassigncontacts` tinyint(4) NOT NULL default '0',
  `module` varchar(5) NOT NULL default '',
  `aging` tinyint(1) NOT NULL default '0',
  `linkto` varchar(15) NOT NULL default '',
  `beginzip` varchar(15) default '',
  `endzip` varchar(15) default '',
  `exclusivecontacts` tinyint(4) NOT NULL default '0',
  `ignorestatuses` text,
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `entrydate` (`entrydate`),
  KEY `entryuserid` (`entryuserid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `task`
--

LOCK TABLES `task` WRITE;
/*!40000 ALTER TABLE `task` DISABLE KEYS */;
/*!40000 ALTER TABLE `task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taskaction`
--

DROP TABLE IF EXISTS `taskaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taskaction` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(4) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `entrydate` (`entrydate`),
  KEY `entryuserid` (`entryuserid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taskaction`
--

LOCK TABLES `taskaction` WRITE;
/*!40000 ALTER TABLE `taskaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `taskaction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taskassignment`
--

DROP TABLE IF EXISTS `taskassignment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taskassignment` (
  `id` int(11) NOT NULL auto_increment,
  `taskid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `nprightsgroupid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `taskid` (`taskid`),
  KEY `userid` (`userid`),
  KEY `nprightsgroupid` (`nprightsgroupid`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `entrydate` (`entrydate`),
  KEY `entryuserid` (`entryuserid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taskassignment`
--

LOCK TABLES `taskassignment` WRITE;
/*!40000 ALTER TABLE `taskassignment` DISABLE KEYS */;
/*!40000 ALTER TABLE `taskassignment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taskflexfield`
--

DROP TABLE IF EXISTS `taskflexfield`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taskflexfield` (
  `id` int(11) NOT NULL auto_increment,
  `taskid` int(11) NOT NULL default '0',
  `flexfieldid` int(11) NOT NULL default '0',
  `flexfieldvalue` varchar(255) NOT NULL default '',
  `flexcheck` varchar(15) NOT NULL default '',
  `flextype` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `taskid` (`taskid`),
  KEY `flexfieldid` (`flexfieldid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taskflexfield`
--

LOCK TABLES `taskflexfield` WRITE;
/*!40000 ALTER TABLE `taskflexfield` DISABLE KEYS */;
/*!40000 ALTER TABLE `taskflexfield` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tasklog`
--

DROP TABLE IF EXISTS `tasklog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tasklog` (
  `id` int(11) NOT NULL auto_increment,
  `taskid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `taskuserid` int(11) NOT NULL default '0',
  `notes` text,
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `amountconfidencepercent` decimal(5,2) NOT NULL default '0.00',
  `taskstatusid` int(11) NOT NULL default '0',
  `taskactionid` int(11) NOT NULL default '0',
  `nexttaskactionid` int(11) NOT NULL default '0',
  `nexttaskactiondate` datetime default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(4) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `taskid` (`taskid`),
  KEY `userid` (`userid`),
  KEY `taskuserid` (`taskuserid`),
  KEY `taskstatusid` (`taskstatusid`),
  KEY `taskactionid` (`taskactionid`),
  KEY `nexttaskactionid` (`nexttaskactionid`),
  KEY `nexttaskactiondate` (`nexttaskactiondate`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `entrydate` (`entrydate`),
  KEY `entryuserid` (`entryuserid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tasklog`
--

LOCK TABLES `tasklog` WRITE;
/*!40000 ALTER TABLE `tasklog` DISABLE KEYS */;
/*!40000 ALTER TABLE `tasklog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taskstatus`
--

DROP TABLE IF EXISTS `taskstatus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taskstatus` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(4) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `entrydate` (`entrydate`),
  KEY `entryuserid` (`entryuserid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taskstatus`
--

LOCK TABLES `taskstatus` WRITE;
/*!40000 ALTER TABLE `taskstatus` DISABLE KEYS */;
/*!40000 ALTER TABLE `taskstatus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taskuser`
--

DROP TABLE IF EXISTS `taskuser`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taskuser` (
  `id` int(11) NOT NULL auto_increment,
  `taskid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `vendorid` int(11) NOT NULL default '0',
  `contactnameid` int(11) NOT NULL default '0',
  `taskstatusid` int(11) NOT NULL default '0',
  `jobid` int(11) NOT NULL default '0',
  `lasttaskactionid` int(11) NOT NULL default '0',
  `lasttaskactiondate` datetime default NULL,
  `lastnotes` text,
  `nexttaskactionid` int(11) NOT NULL default '0',
  `nexttaskactiondate` datetime default NULL,
  `amount` decimal(19,6) NOT NULL default '0.000000',
  `amountconfidencepercent` decimal(5,2) NOT NULL default '0.00',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(4) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `taskid` (`taskid`),
  KEY `userid` (`userid`),
  KEY `customerid` (`customerid`),
  KEY `vendorid` (`vendorid`),
  KEY `contactnameid` (`contactnameid`),
  KEY `taskstatusid` (`taskstatusid`),
  KEY `lasttaskactionid` (`lasttaskactionid`),
  KEY `nexttaskactionid` (`nexttaskactionid`),
  KEY `nexttaskactiondate` (`nexttaskactiondate`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `entrydate` (`entrydate`),
  KEY `entryuserid` (`entryuserid`),
  KEY `cancel` (`cancel`),
  KEY `lasttaskactiondate` (`lasttaskactiondate`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taskuser`
--

LOCK TABLES `taskuser` WRITE;
/*!40000 ALTER TABLE `taskuser` DISABLE KEYS */;
/*!40000 ALTER TABLE `taskuser` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_class`
--

DROP TABLE IF EXISTS `tax_class`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tax_class` (
  `tax_class_id` int(5) NOT NULL auto_increment,
  `tax_class_title` varchar(32) NOT NULL default '',
  `tax_class_description` varchar(255) NOT NULL default '',
  `last_modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `date_added` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tax_class_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tax_class`
--

LOCK TABLES `tax_class` WRITE;
/*!40000 ALTER TABLE `tax_class` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_class` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_rates`
--

DROP TABLE IF EXISTS `tax_rates`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tax_rates` (
  `tax_rates_id` int(5) NOT NULL auto_increment,
  `tax_zone_id` int(5) NOT NULL default '0',
  `tax_class_id` int(5) NOT NULL default '0',
  `tax_rate` decimal(7,4) NOT NULL default '0.0000',
  `tax_description` varchar(255) NOT NULL default '',
  `last_modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `date_added` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tax_rates_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tax_rates`
--

LOCK TABLES `tax_rates` WRITE;
/*!40000 ALTER TABLE `tax_rates` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_rates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxclass`
--

DROP TABLE IF EXISTS `taxclass`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxclass` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `exempt` tinyint(4) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxclass`
--

LOCK TABLES `taxclass` WRITE;
/*!40000 ALTER TABLE `taxclass` DISABLE KEYS */;
INSERT INTO `taxclass` VALUES (1,'Exempt',1,1,0,NULL,0,'2016-01-11 12:00:00',1),(2,'Labor',0,1,0,NULL,0,'2016-01-11 12:00:00',1),(3,'Material Sales',0,1,0,NULL,0,'2016-01-11 12:00:00',1),(4,'New Construction',1,1,0,NULL,0,'2016-01-11 12:00:00',1),(5,'Resale',1,1,0,NULL,0,'2016-01-11 12:00:00',1);
/*!40000 ALTER TABLE `taxclass` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxexempt`
--

DROP TABLE IF EXISTS `taxexempt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxexempt` (
  `id` int(11) NOT NULL auto_increment,
  `exemptname` varchar(32) NOT NULL default '',
  `partial` tinyint(1) NOT NULL default '0',
  `taxrate` decimal(7,4) NOT NULL default '0.0000',
  `state` varchar(5) NOT NULL default '',
  `glacctid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `contractor` tinyint(4) NOT NULL default '0',
  `donotshowonnewposcustomerentry` tinyint(1) NOT NULL default '0',
  `allowedonjobs` tinyint(1) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxexempt`
--

LOCK TABLES `taxexempt` WRITE;
/*!40000 ALTER TABLE `taxexempt` DISABLE KEYS */;
/*!40000 ALTER TABLE `taxexempt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxgroup`
--

DROP TABLE IF EXISTS `taxgroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxgroup` (
  `id` int(11) NOT NULL auto_increment,
  `groupcode` varchar(20) default NULL,
  `createdate` datetime default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `createuserid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `groupcode` (`groupcode`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxgroup`
--

LOCK TABLES `taxgroup` WRITE;
/*!40000 ALTER TABLE `taxgroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `taxgroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tccompany`
--

DROP TABLE IF EXISTS `tccompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tccompany` (
  `id` int(11) NOT NULL default '0',
  `general_ip_only` varchar(255) default NULL,
  `genuser_ip_yesno` int(5) NOT NULL default '0',
  `hours_day_overtime` decimal(4,2) default '0.00',
  `hours_week_overtime` decimal(5,2) default '0.00',
  `payweek_beginday` int(5) NOT NULL default '0',
  `lunchpaid` int(5) NOT NULL default '0',
  `breakpaid` int(5) NOT NULL default '0',
  `maxtime_perbreak` decimal(4,2) default '0.00',
  `max_breaks_perday` int(5) NOT NULL default '0',
  `allow_comptime` int(5) NOT NULL default '0',
  `stpay_prpaytypeid` int(11) NOT NULL default '0',
  `ot_prpaytypeid` int(11) NOT NULL default '0',
  `maxpaidlunch` decimal(15,2) NOT NULL default '0.00',
  `maxhours` int(11) NOT NULL default '0',
  `salaried_all_stpay` int(5) NOT NULL default '0',
  `salaried_limit_time` int(5) NOT NULL default '0',
  `no_autologout` int(5) NOT NULL default '0',
  `no_paydisplay` int(5) NOT NULL default '0',
  `norelog_viewtimes` int(5) NOT NULL default '0',
  `input_font_size` int(11) NOT NULL default '0',
  `arorder_ok` int(5) NOT NULL default '0',
  `construction_job_ok` int(5) NOT NULL default '0',
  `manager_approval_req` int(5) NOT NULL default '0',
  `default_category` int(11) NOT NULL default '0',
  `alternatepay_starttime` varchar(5) NOT NULL default '00:00',
  `alternatepay_endtime` varchar(5) NOT NULL default '00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tccompany`
--

LOCK TABLES `tccompany` WRITE;
/*!40000 ALTER TABLE `tccompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `tccompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `territory`
--

DROP TABLE IF EXISTS `territory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `territory` (
  `id` int(11) NOT NULL auto_increment,
  `salesmanid` int(11) NOT NULL default '0',
  `state` varchar(5) NOT NULL default '',
  `zipcode_begin` varchar(12) NOT NULL default '',
  `zipcode_end` varchar(12) NOT NULL default '',
  `territoryname` varchar(100) NOT NULL default '',
  `territorycode` varchar(12) NOT NULL default '',
  `territoryregionid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `gencompanyid` (`gencompanyid`),
  KEY `zipcode_end` (`zipcode_end`),
  KEY `zipcode_begin` (`zipcode_begin`),
  KEY `salesmanid` (`salesmanid`),
  KEY `state` (`state`),
  KEY `btreezips` USING BTREE (`cancel`,`territoryregionid`,`zipcode_end`,`zipcode_begin`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `territory`
--

LOCK TABLES `territory` WRITE;
/*!40000 ALTER TABLE `territory` DISABLE KEYS */;
/*!40000 ALTER TABLE `territory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `territory_distribution`
--

DROP TABLE IF EXISTS `territory_distribution`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `territory_distribution` (
  `id` int(11) NOT NULL auto_increment,
  `customerid` int(11) NOT NULL default '0',
  `commission_type` char(1) NOT NULL default '',
  `salesmanid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `itemqty` decimal(18,6) NOT NULL default '0.000000',
  `note` varchar(255) default NULL,
  `sales_order` varchar(50) default NULL,
  `amount` decimal(15,6) NOT NULL default '0.000000',
  `zipcode` varchar(12) default NULL,
  `commission_amount` decimal(15,6) NOT NULL default '0.000000',
  `checkid` int(11) NOT NULL default '0',
  `import_date` date default NULL,
  `check_date` date default NULL,
  `import_userid` int(11) NOT NULL default '0',
  `import_filename` varchar(255) default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `salesmanid` (`salesmanid`),
  KEY `customerid` (`customerid`),
  KEY `checkid` (`checkid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `territory_distribution`
--

LOCK TABLES `territory_distribution` WRITE;
/*!40000 ALTER TABLE `territory_distribution` DISABLE KEYS */;
/*!40000 ALTER TABLE `territory_distribution` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `territoryregion`
--

DROP TABLE IF EXISTS `territoryregion`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `territoryregion` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(150) NOT NULL default '',
  `code` varchar(32) NOT NULL default '',
  `salesmanid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime NOT NULL default '0000-00-00 00:00:00',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `inventorylocationid` int(11) NOT NULL default '0',
  `sendquotestomanager` tinyint(4) NOT NULL default '0',
  `minquoteamountforemail` decimal(18,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `territoryregion`
--

LOCK TABLES `territoryregion` WRITE;
/*!40000 ALTER TABLE `territoryregion` DISABLE KEYS */;
/*!40000 ALTER TABLE `territoryregion` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `threedcompany`
--

DROP TABLE IF EXISTS `threedcompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `threedcompany` (
  `id` int(11) NOT NULL auto_increment,
  `gencompanyid` int(11) NOT NULL default '0',
  `default_pricelevelid` int(11) NOT NULL default '0',
  `locationid` int(11) NOT NULL default '0',
  `cost` int(11) NOT NULL default '0',
  `sales` int(11) NOT NULL default '0',
  `default_sellunitid` int(11) NOT NULL default '0',
  `default_priceunitid` int(11) NOT NULL default '0',
  `checking` int(11) NOT NULL default '0',
  `depositglacctid` int(11) NOT NULL default '0',
  `default_checkacctid` int(11) NOT NULL default '0',
  `default_salescategory_fulfillment` int(11) NOT NULL default '0',
  `default_invoicetermsid` int(11) NOT NULL default '0',
  `siteurl` varchar(255) NOT NULL default '',
  `sitekey` varchar(50) NOT NULL default '',
  `updateshipstatus` tinyint(4) NOT NULL default '1',
  `updateprices` tinyint(4) NOT NULL default '0',
  `cancel` tinyint(4) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `updateextdesc` tinyint(4) NOT NULL default '0',
  `updatenotforsale` tinyint(4) NOT NULL default '1',
  `updatestocklevels` tinyint(4) NOT NULL default '0',
  `updatecustomers` tinyint(4) NOT NULL default '0',
  `updateshortdesc` tinyint(4) NOT NULL default '0',
  `updateprodname` tinyint(4) NOT NULL default '0',
  `updateweight` tinyint(4) NOT NULL default '0',
  `ponumquestid` int(11) NOT NULL default '-1',
  `updateshipsbyitself` tinyint(4) NOT NULL default '0',
  `updatecancelstatus` tinyint(4) NOT NULL default '0',
  `updateshipfee` tinyint(4) NOT NULL default '0',
  `updateshippref` tinyint(4) NOT NULL default '0',
  `updateholdstatus` tinyint(1) NOT NULL default '0',
  `lastautoimport` datetime NOT NULL default '0000-00-00 00:00:00',
  `updatewarehousebin` tinyint(1) NOT NULL default '0',
  `updateonorderlevels` tinyint(1) NOT NULL default '0',
  `donotimportitemcategories` tinyint(1) NOT NULL default '0',
  `restapi` tinyint(1) NOT NULL default '0',
  `taxmethod` tinyint(1) NOT NULL default '0',
  `blockposemailedit` tinyint(1) NOT NULL default '0',
  `updateshippingmarkup` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `threedcompany`
--

LOCK TABLES `threedcompany` WRITE;
/*!40000 ALTER TABLE `threedcompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `threedcompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `threedcompanyitem`
--

DROP TABLE IF EXISTS `threedcompanyitem`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `threedcompanyitem` (
  `id` int(11) NOT NULL auto_increment,
  `threedcompanyid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `threeditemid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `threedcompanyid` (`threedcompanyid`),
  KEY `itemid` (`itemid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `threedcompanyitem`
--

LOCK TABLES `threedcompanyitem` WRITE;
/*!40000 ALTER TABLE `threedcompanyitem` DISABLE KEYS */;
/*!40000 ALTER TABLE `threedcompanyitem` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `timeclock`
--

DROP TABLE IF EXISTS `timeclock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `timeclock` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `name` varchar(50) default NULL,
  `hours` decimal(15,4) NOT NULL default '0.0000',
  `quantity` decimal(15,4) NOT NULL default '0.0000',
  `rateperhour` decimal(15,4) NOT NULL default '0.0000',
  `rateperpiece` decimal(15,4) NOT NULL default '0.0000',
  `totalpay` decimal(15,4) NOT NULL default '0.0000',
  `jobid` int(11) NOT NULL default '0',
  `notes` varchar(255) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `status` int(5) NOT NULL default '0',
  `ordertype` int(5) NOT NULL default '0',
  `timetype` int(5) NOT NULL default '0',
  `piecerate_pricesid` int(11) NOT NULL default '0',
  `employee_edited` int(5) NOT NULL default '0',
  `employee_edit_datetime` datetime default NULL,
  `management_edited` int(5) NOT NULL default '0',
  `management_edited_datetime` datetime default NULL,
  `management_edited_userid` int(11) NOT NULL default '0',
  `premplweekid` int(11) NOT NULL default '0',
  `description` varchar(255) default NULL,
  `startdatetime` datetime default NULL,
  `enddatetime` datetime default NULL,
  `ip` varchar(50) default NULL,
  `ippath` varchar(100) default NULL,
  `otherid` int(11) NOT NULL default '0',
  `comptime` int(5) NOT NULL default '0',
  `shift` int(5) NOT NULL default '1',
  `unpaid_hours` decimal(15,2) NOT NULL default '0.00',
  `calc_othours` decimal(15,2) NOT NULL default '0.00',
  `calc_sthours` decimal(15,2) NOT NULL default '0.00',
  `calc_otpay` decimal(16,5) NOT NULL default '0.00000',
  `calc_stpay` decimal(16,5) NOT NULL default '0.00000',
  `piecework_div` int(11) NOT NULL default '0',
  `calc_pwpay` decimal(19,5) NOT NULL default '0.00000',
  `calc_pwqty` decimal(15,4) NOT NULL default '0.0000',
  `pw_minimum` decimal(19,5) NOT NULL default '0.00000',
  `calc_pwrate` decimal(19,5) NOT NULL default '0.00000',
  `post2date` date default NULL,
  `arorderid` int(11) NOT NULL default '0',
  `costcodeid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `manager_userid` int(11) NOT NULL default '0',
  `manager_approved` int(5) NOT NULL default '0',
  `postcompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `employeeid` (`employeeid`),
  KEY `entrydate` (`entrydate`),
  KEY `startdatetime` (`startdatetime`),
  KEY `postcompanyid` (`postcompanyid`),
  KEY `status` (`status`),
  KEY `timetype` (`timetype`),
  KEY `premplweekid` (`premplweekid`),
  KEY `startdatetime_2` (`startdatetime`),
  KEY `enddatetime` (`enddatetime`),
  KEY `post2date` (`post2date`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `timeclock`
--

LOCK TABLES `timeclock` WRITE;
/*!40000 ALTER TABLE `timeclock` DISABLE KEYS */;
/*!40000 ALTER TABLE `timeclock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `timeclock_othertime`
--

DROP TABLE IF EXISTS `timeclock_othertime`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `timeclock_othertime` (
  `id` int(11) NOT NULL auto_increment,
  `note` varchar(50) default NULL,
  `sortorder` int(5) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `lastupdatedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastupdateuserid` int(11) NOT NULL default '0',
  `paidtime` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `sortorder` (`sortorder`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `timeclock_othertime`
--

LOCK TABLES `timeclock_othertime` WRITE;
/*!40000 ALTER TABLE `timeclock_othertime` DISABLE KEYS */;
/*!40000 ALTER TABLE `timeclock_othertime` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `timeoffrequest`
--

DROP TABLE IF EXISTS `timeoffrequest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `timeoffrequest` (
  `id` int(11) NOT NULL auto_increment,
  `employeeid` int(11) NOT NULL default '0',
  `timetype` char(5) NOT NULL default '',
  `begindate` date NOT NULL default '0000-00-00',
  `enddate` date NOT NULL default '0000-00-00',
  `notes` text NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `status` char(2) NOT NULL default '',
  `manageruserid` int(11) NOT NULL default '0',
  `decisiondate` datetime NOT NULL default '0000-00-00 00:00:00',
  `decisionnotes` text NOT NULL,
  `cancel` int(11) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `begintime` int(5) NOT NULL default '0',
  `endtime` int(5) NOT NULL default '0',
  `postcompanyid` int(11) NOT NULL default '0',
  `hours` decimal(10,2) NOT NULL default '0.00',
  `paytotal` decimal(19,5) NOT NULL default '0.00000',
  `premplweekid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `employeeid` (`employeeid`),
  KEY `timetype` (`timetype`),
  KEY `status` (`status`),
  KEY `entryuserid` (`entryuserid`),
  KEY `entrydate` (`entrydate`),
  KEY `manageruserid` (`manageruserid`),
  KEY `begindate` (`begindate`),
  KEY `enddate` (`enddate`),
  KEY `postcompanyid` (`postcompanyid`),
  KEY `premplweekid` (`premplweekid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `timeoffrequest`
--

LOCK TABLES `timeoffrequest` WRITE;
/*!40000 ALTER TABLE `timeoffrequest` DISABLE KEYS */;
/*!40000 ALTER TABLE `timeoffrequest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `timezone`
--

DROP TABLE IF EXISTS `timezone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `timezone` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` char(64) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=547 DEFAULT CHARSET=utf8 COMMENT='Time zone names';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `timezone`
--

LOCK TABLES `timezone` WRITE;
/*!40000 ALTER TABLE `timezone` DISABLE KEYS */;
INSERT INTO `timezone` VALUES (1,'Africa/Abidjan'),(2,'Africa/Accra'),(3,'Africa/Addis_Ababa'),(4,'Africa/Algiers'),(5,'Africa/Asmera'),(6,'Africa/Bamako'),(7,'Africa/Bangui'),(8,'Africa/Banjul'),(9,'Africa/Bissau'),(10,'Africa/Blantyre'),(11,'Africa/Brazzaville'),(12,'Africa/Bujumbura'),(13,'Africa/Cairo'),(14,'Africa/Casablanca'),(15,'Africa/Ceuta'),(16,'Africa/Conakry'),(17,'Africa/Dakar'),(18,'Africa/Dar_es_Salaam'),(19,'Africa/Djibouti'),(20,'Africa/Douala'),(21,'Africa/El_Aaiun'),(22,'Africa/Freetown'),(23,'Africa/Gaborone'),(24,'Africa/Harare'),(25,'Africa/Johannesburg'),(26,'Africa/Kampala'),(27,'Africa/Khartoum'),(28,'Africa/Kigali'),(29,'Africa/Kinshasa'),(30,'Africa/Lagos'),(31,'Africa/Libreville'),(32,'Africa/Lome'),(33,'Africa/Luanda'),(34,'Africa/Lubumbashi'),(35,'Africa/Lusaka'),(36,'Africa/Malabo'),(37,'Africa/Maputo'),(38,'Africa/Maseru'),(39,'Africa/Mbabane'),(40,'Africa/Mogadishu'),(41,'Africa/Monrovia'),(42,'Africa/Nairobi'),(43,'Africa/Ndjamena'),(44,'Africa/Niamey'),(45,'Africa/Nouakchott'),(46,'Africa/Ouagadougou'),(47,'Africa/Porto-Novo'),(48,'Africa/Sao_Tome'),(49,'Africa/Timbuktu'),(50,'Africa/Tripoli'),(51,'Africa/Tunis'),(52,'Africa/Windhoek'),(53,'America/Adak'),(54,'America/Anchorage'),(55,'America/Anguilla'),(56,'America/Antigua'),(57,'America/Araguaina'),(58,'America/Argentina/Buenos_Aires'),(59,'America/Argentina/Catamarca'),(60,'America/Argentina/ComodRivadavia'),(61,'America/Argentina/Cordoba'),(62,'America/Argentina/Jujuy'),(63,'America/Argentina/La_Rioja'),(64,'America/Argentina/Mendoza'),(65,'America/Argentina/Rio_Gallegos'),(66,'America/Argentina/San_Juan'),(67,'America/Argentina/Tucuman'),(68,'America/Argentina/Ushuaia'),(69,'America/Aruba'),(70,'America/Asuncion'),(71,'America/Atikokan'),(72,'America/Atka'),(73,'America/Bahia'),(74,'America/Barbados'),(75,'America/Belem'),(76,'America/Belize'),(77,'America/Blanc-Sablon'),(78,'America/Boa_Vista'),(79,'America/Bogota'),(80,'America/Boise'),(81,'America/Buenos_Aires'),(82,'America/Cambridge_Bay'),(83,'America/Campo_Grande'),(84,'America/Cancun'),(85,'America/Caracas'),(86,'America/Catamarca'),(87,'America/Cayenne'),(88,'America/Cayman'),(89,'America/Chicago'),(90,'America/Chihuahua'),(91,'America/Coral_Harbour'),(92,'America/Cordoba'),(93,'America/Costa_Rica'),(94,'America/Cuiaba'),(95,'America/Curacao'),(96,'America/Danmarkshavn'),(97,'America/Dawson'),(98,'America/Dawson_Creek'),(99,'America/Denver'),(100,'America/Detroit'),(101,'America/Dominica'),(102,'America/Edmonton'),(103,'America/Eirunepe'),(104,'America/El_Salvador'),(105,'America/Ensenada'),(106,'America/Fort_Wayne'),(107,'America/Fortaleza'),(108,'America/Glace_Bay'),(109,'America/Godthab'),(110,'America/Goose_Bay'),(111,'America/Grand_Turk'),(112,'America/Grenada'),(113,'America/Guadeloupe'),(114,'America/Guatemala'),(115,'America/Guayaquil'),(116,'America/Guyana'),(117,'America/Halifax'),(118,'America/Havana'),(119,'America/Hermosillo'),(120,'America/Indiana/Indianapolis'),(121,'America/Indiana/Knox'),(122,'America/Indiana/Marengo'),(123,'America/Indiana/Petersburg'),(124,'America/Indiana/Vevay'),(125,'America/Indiana/Vincennes'),(126,'America/Indianapolis'),(127,'America/Inuvik'),(128,'America/Iqaluit'),(129,'America/Jamaica'),(130,'America/Jujuy'),(131,'America/Juneau'),(132,'America/Kentucky/Louisville'),(133,'America/Kentucky/Monticello'),(134,'America/Knox_IN'),(135,'America/La_Paz'),(136,'America/Lima'),(137,'America/Los_Angeles'),(138,'America/Louisville'),(139,'America/Maceio'),(140,'America/Managua'),(141,'America/Manaus'),(142,'America/Martinique'),(143,'America/Mazatlan'),(144,'America/Mendoza'),(145,'America/Menominee'),(146,'America/Merida'),(147,'America/Mexico_City'),(148,'America/Miquelon'),(149,'America/Moncton'),(150,'America/Monterrey'),(151,'America/Montevideo'),(152,'America/Montreal'),(153,'America/Montserrat'),(154,'America/Nassau'),(155,'America/New_York'),(156,'America/Nipigon'),(157,'America/Nome'),(158,'America/Noronha'),(159,'America/North_Dakota/Center'),(160,'America/North_Dakota/New_Salem'),(161,'America/Panama'),(162,'America/Pangnirtung'),(163,'America/Paramaribo'),(164,'America/Phoenix'),(165,'America/Port-au-Prince'),(166,'America/Port_of_Spain'),(167,'America/Porto_Acre'),(168,'America/Porto_Velho'),(169,'America/Puerto_Rico'),(170,'America/Rainy_River'),(171,'America/Rankin_Inlet'),(172,'America/Recife'),(173,'America/Regina'),(174,'America/Rio_Branco'),(175,'America/Rosario'),(176,'America/Santiago'),(177,'America/Santo_Domingo'),(178,'America/Sao_Paulo'),(179,'America/Scoresbysund'),(180,'America/Shiprock'),(181,'America/St_Johns'),(182,'America/St_Kitts'),(183,'America/St_Lucia'),(184,'America/St_Thomas'),(185,'America/St_Vincent'),(186,'America/Swift_Current'),(187,'America/Tegucigalpa'),(188,'America/Thule'),(189,'America/Thunder_Bay'),(190,'America/Tijuana'),(191,'America/Toronto'),(192,'America/Tortola'),(193,'America/Vancouver'),(194,'America/Virgin'),(195,'America/Whitehorse'),(196,'America/Winnipeg'),(197,'America/Yakutat'),(198,'America/Yellowknife'),(199,'Antarctica/Casey'),(200,'Antarctica/Davis'),(201,'Antarctica/DumontDUrville'),(202,'Antarctica/Mawson'),(203,'Antarctica/McMurdo'),(204,'Antarctica/Palmer'),(205,'Antarctica/Rothera'),(206,'Antarctica/South_Pole'),(207,'Antarctica/Syowa'),(208,'Antarctica/Vostok'),(209,'Arctic/Longyearbyen'),(210,'Asia/Aden'),(211,'Asia/Almaty'),(212,'Asia/Amman'),(213,'Asia/Anadyr'),(214,'Asia/Aqtau'),(215,'Asia/Aqtobe'),(216,'Asia/Ashgabat'),(217,'Asia/Ashkhabad'),(218,'Asia/Baghdad'),(219,'Asia/Bahrain'),(220,'Asia/Baku'),(221,'Asia/Bangkok'),(222,'Asia/Beirut'),(223,'Asia/Bishkek'),(224,'Asia/Brunei'),(225,'Asia/Calcutta'),(226,'Asia/Choibalsan'),(227,'Asia/Chongqing'),(228,'Asia/Chungking'),(229,'Asia/Colombo'),(230,'Asia/Dacca'),(231,'Asia/Damascus'),(232,'Asia/Dhaka'),(233,'Asia/Dili'),(234,'Asia/Dubai'),(235,'Asia/Dushanbe'),(236,'Asia/Gaza'),(237,'Asia/Harbin'),(238,'Asia/Hong_Kong'),(239,'Asia/Hovd'),(240,'Asia/Irkutsk'),(241,'Asia/Istanbul'),(242,'Asia/Jakarta'),(243,'Asia/Jayapura'),(244,'Asia/Jerusalem'),(245,'Asia/Kabul'),(246,'Asia/Kamchatka'),(247,'Asia/Karachi'),(248,'Asia/Kashgar'),(249,'Asia/Katmandu'),(250,'Asia/Krasnoyarsk'),(251,'Asia/Kuala_Lumpur'),(252,'Asia/Kuching'),(253,'Asia/Kuwait'),(254,'Asia/Macao'),(255,'Asia/Macau'),(256,'Asia/Magadan'),(257,'Asia/Makassar'),(258,'Asia/Manila'),(259,'Asia/Muscat'),(260,'Asia/Nicosia'),(261,'Asia/Novosibirsk'),(262,'Asia/Omsk'),(263,'Asia/Oral'),(264,'Asia/Phnom_Penh'),(265,'Asia/Pontianak'),(266,'Asia/Pyongyang'),(267,'Asia/Qatar'),(268,'Asia/Qyzylorda'),(269,'Asia/Rangoon'),(270,'Asia/Riyadh'),(271,'Asia/Saigon'),(272,'Asia/Sakhalin'),(273,'Asia/Samarkand'),(274,'Asia/Seoul'),(275,'Asia/Shanghai'),(276,'Asia/Singapore'),(277,'Asia/Taipei'),(278,'Asia/Tashkent'),(279,'Asia/Tbilisi'),(280,'Asia/Tehran'),(281,'Asia/Tel_Aviv'),(282,'Asia/Thimbu'),(283,'Asia/Thimphu'),(284,'Asia/Tokyo'),(285,'Asia/Ujung_Pandang'),(286,'Asia/Ulaanbaatar'),(287,'Asia/Ulan_Bator'),(288,'Asia/Urumqi'),(289,'Asia/Vientiane'),(290,'Asia/Vladivostok'),(291,'Asia/Yakutsk'),(292,'Asia/Yekaterinburg'),(293,'Asia/Yerevan'),(294,'Atlantic/Azores'),(295,'Atlantic/Bermuda'),(296,'Atlantic/Canary'),(297,'Atlantic/Cape_Verde'),(298,'Atlantic/Faeroe'),(299,'Atlantic/Jan_Mayen'),(300,'Atlantic/Madeira'),(301,'Atlantic/Reykjavik'),(302,'Atlantic/South_Georgia'),(303,'Atlantic/St_Helena'),(304,'Atlantic/Stanley'),(305,'Australia/ACT'),(306,'Australia/Adelaide'),(307,'Australia/Brisbane'),(308,'Australia/Broken_Hill'),(309,'Australia/Canberra'),(310,'Australia/Currie'),(311,'Australia/Darwin'),(312,'Australia/Hobart'),(313,'Australia/LHI'),(314,'Australia/Lindeman'),(315,'Australia/Lord_Howe'),(316,'Australia/Melbourne'),(317,'Australia/NSW'),(318,'Australia/North'),(319,'Australia/Perth'),(320,'Australia/Queensland'),(321,'Australia/South'),(322,'Australia/Sydney'),(323,'Australia/Tasmania'),(324,'Australia/Victoria'),(325,'Australia/West'),(326,'Australia/Yancowinna'),(327,'Brazil/Acre'),(328,'Brazil/DeNoronha'),(329,'Brazil/East'),(330,'Brazil/West'),(331,'CET'),(332,'CST6CDT'),(333,'Canada/Atlantic'),(334,'Canada/Central'),(335,'Canada/East-Saskatchewan'),(336,'Canada/Eastern'),(337,'Canada/Mountain'),(338,'Canada/Newfoundland'),(339,'Canada/Pacific'),(340,'Canada/Saskatchewan'),(341,'Canada/Yukon'),(342,'Chile/Continental'),(343,'Chile/EasterIsland'),(344,'Cuba'),(345,'EET'),(346,'EST'),(347,'EST5EDT'),(348,'Egypt'),(349,'Eire'),(350,'Etc/GMT'),(351,'Etc/GMT+0'),(352,'Etc/GMT+1'),(353,'Etc/GMT+10'),(354,'Etc/GMT+11'),(355,'Etc/GMT+12'),(356,'Etc/GMT+2'),(357,'Etc/GMT+3'),(358,'Etc/GMT+4'),(359,'Etc/GMT+5'),(360,'Etc/GMT+6'),(361,'Etc/GMT+7'),(362,'Etc/GMT+8'),(363,'Etc/GMT+9'),(364,'Etc/GMT-0'),(365,'Etc/GMT-1'),(366,'Etc/GMT-10'),(367,'Etc/GMT-11'),(368,'Etc/GMT-12'),(369,'Etc/GMT-13'),(370,'Etc/GMT-14'),(371,'Etc/GMT-2'),(372,'Etc/GMT-3'),(373,'Etc/GMT-4'),(374,'Etc/GMT-5'),(375,'Etc/GMT-6'),(376,'Etc/GMT-7'),(377,'Etc/GMT-8'),(378,'Etc/GMT-9'),(379,'Etc/GMT0'),(380,'Etc/Greenwich'),(381,'Etc/UCT'),(382,'Etc/UTC'),(383,'Etc/Universal'),(384,'Etc/Zulu'),(385,'Europe/Amsterdam'),(386,'Europe/Andorra'),(387,'Europe/Athens'),(388,'Europe/Belfast'),(389,'Europe/Belgrade'),(390,'Europe/Berlin'),(391,'Europe/Bratislava'),(392,'Europe/Brussels'),(393,'Europe/Bucharest'),(394,'Europe/Budapest'),(395,'Europe/Chisinau'),(396,'Europe/Copenhagen'),(397,'Europe/Dublin'),(398,'Europe/Gibraltar'),(399,'Europe/Guernsey'),(400,'Europe/Helsinki'),(401,'Europe/Isle_of_Man'),(402,'Europe/Istanbul'),(403,'Europe/Jersey'),(404,'Europe/Kaliningrad'),(405,'Europe/Kiev'),(406,'Europe/Lisbon'),(407,'Europe/Ljubljana'),(408,'Europe/London'),(409,'Europe/Luxembourg'),(410,'Europe/Madrid'),(411,'Europe/Malta'),(412,'Europe/Mariehamn'),(413,'Europe/Minsk'),(414,'Europe/Monaco'),(415,'Europe/Moscow'),(416,'Europe/Nicosia'),(417,'Europe/Oslo'),(418,'Europe/Paris'),(419,'Europe/Podgorica'),(420,'Europe/Prague'),(421,'Europe/Riga'),(422,'Europe/Rome'),(423,'Europe/Samara'),(424,'Europe/San_Marino'),(425,'Europe/Sarajevo'),(426,'Europe/Simferopol'),(427,'Europe/Skopje'),(428,'Europe/Sofia'),(429,'Europe/Stockholm'),(430,'Europe/Tallinn'),(431,'Europe/Tirane'),(432,'Europe/Tiraspol'),(433,'Europe/Uzhgorod'),(434,'Europe/Vaduz'),(435,'Europe/Vatican'),(436,'Europe/Vienna'),(437,'Europe/Vilnius'),(438,'Europe/Volgograd'),(439,'Europe/Warsaw'),(440,'Europe/Zagreb'),(441,'Europe/Zaporozhye'),(442,'Europe/Zurich'),(443,'Factory'),(444,'GB'),(445,'GB-Eire'),(446,'GMT'),(447,'GMT+0'),(448,'GMT-0'),(449,'GMT0'),(450,'Greenwich'),(451,'HST'),(452,'Hongkong'),(453,'Iceland'),(454,'Indian/Antananarivo'),(455,'Indian/Chagos'),(456,'Indian/Christmas'),(457,'Indian/Cocos'),(458,'Indian/Comoro'),(459,'Indian/Kerguelen'),(460,'Indian/Mahe'),(461,'Indian/Maldives'),(462,'Indian/Mauritius'),(463,'Indian/Mayotte'),(464,'Indian/Reunion'),(465,'Iran'),(466,'Israel'),(467,'Jamaica'),(468,'Japan'),(469,'Kwajalein'),(470,'Libya'),(471,'MET'),(472,'MST'),(473,'MST7MDT'),(474,'Mexico/BajaNorte'),(475,'Mexico/BajaSur'),(476,'Mexico/General'),(477,'NZ'),(478,'NZ-CHAT'),(479,'Navajo'),(480,'PRC'),(481,'PST8PDT'),(482,'Pacific/Apia'),(483,'Pacific/Auckland'),(484,'Pacific/Chatham'),(485,'Pacific/Easter'),(486,'Pacific/Efate'),(487,'Pacific/Enderbury'),(488,'Pacific/Fakaofo'),(489,'Pacific/Fiji'),(490,'Pacific/Funafuti'),(491,'Pacific/Galapagos'),(492,'Pacific/Gambier'),(493,'Pacific/Guadalcanal'),(494,'Pacific/Guam'),(495,'Pacific/Honolulu'),(496,'Pacific/Johnston'),(497,'Pacific/Kiritimati'),(498,'Pacific/Kosrae'),(499,'Pacific/Kwajalein'),(500,'Pacific/Majuro'),(501,'Pacific/Marquesas'),(502,'Pacific/Midway'),(503,'Pacific/Nauru'),(504,'Pacific/Niue'),(505,'Pacific/Norfolk'),(506,'Pacific/Noumea'),(507,'Pacific/Pago_Pago'),(508,'Pacific/Palau'),(509,'Pacific/Pitcairn'),(510,'Pacific/Ponape'),(511,'Pacific/Port_Moresby'),(512,'Pacific/Rarotonga'),(513,'Pacific/Saipan'),(514,'Pacific/Samoa'),(515,'Pacific/Tahiti'),(516,'Pacific/Tarawa'),(517,'Pacific/Tongatapu'),(518,'Pacific/Truk'),(519,'Pacific/Wake'),(520,'Pacific/Wallis'),(521,'Pacific/Yap'),(522,'Poland'),(523,'Portugal'),(524,'ROC'),(525,'ROK'),(526,'Singapore'),(527,'Turkey'),(528,'UCT'),(529,'US/Alaska'),(530,'US/Aleutian'),(531,'US/Arizona'),(532,'US/Central'),(533,'US/East-Indiana'),(534,'US/Eastern'),(535,'US/Hawaii'),(536,'US/Indiana-Starke'),(537,'US/Michigan'),(538,'US/Mountain'),(539,'US/Pacific'),(540,'US/Pacific-New'),(541,'US/Samoa'),(542,'UTC'),(543,'Universal'),(544,'W-SU'),(545,'WET'),(546,'Zulu');
/*!40000 ALTER TABLE `timezone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tips`
--

DROP TABLE IF EXISTS `tips`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tips` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `category` varchar(255) default NULL,
  `tip` text,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=340 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tips`
--

LOCK TABLES `tips` WRITE;
/*!40000 ALTER TABLE `tips` DISABLE KEYS */;
INSERT INTO `tips` VALUES (1,'STR_QUICK_SETUP','STR_TIP_1'),(4,'STR_NEW_CUSTOMER','STR_TIP_4'),(5,'STR_EDIT_VIEW_CUSTOMER','STR_TIP_5'),(6,'STR_B2B_USERS','STR_TIP_6'),(10,'STR_NEW_EMPLOYEE','STR_TIP_10'),(11,'STR_EDIT_EMPLOYEE','STR_TIP_11'),(13,'STR_NEW_SALES_PERSONNEL','STR_TIP_13'),(14,'STR_EDIT_SALES_PERSONNEL','STR_TIP_14'),(15,'STR_VENDORS','STR_TIP_15'),(20,'STR_ORDERS','STR_TIP_20'),(22,'STR_ITEM_ORDERS','STR_TIP_22'),(23,'STR_NEW_EDIT_ORDER','STR_TIP_23'),(24,'STR_ORDERS_INVOICES','STR_TIP_24'),(26,'STR_SHIP_ORDER','STR_TIP_26'),(27,'STR_POINT_OF_SALE','STR_TIP_27'),(28,'STR_POINT_OF_SALE','STR_TIP_28'),(29,'STR_SERVICE_ORDERS','STR_TIP_29'),(30,'STR_NEW_ORDER','STR_TIP_30'),(31,'STR_EDIT_ORDER','STR_TIP_31'),(33,'STR_LOG_TIME','STR_TIP_33'),(36,'STR_ADD_ITEMS','STR_TIP_36'),(37,'STR_ADD_ITEMS','STR_TIP_37'),(38,'STR_EDIT_ITEMS','STR_TIP_38'),(41,'STR_ITEM_BREAKDOWN','STR_TIP_41'),(42,'STR_ITEM_COST_ADJUSTMENTS','STR_TIP_42'),(44,'STR_ITEM_REORDER_LIST','STR_TIP_44'),(55,'STR_NEW_BANK_DEPOSIT','STR_TIP_55'),(57,'STR_INVOICES','STR_TIP_57'),(58,'STR_NEW_INVOICE','STR_TIP_58'),(59,'STR_EDIT_INVOICE','STR_TIP_59'),(62,'STR_POINT_OF_SALE','STR_TIP_62'),(64,'STR_CALCULATE_INTEREST','STR_TIP_64'),(65,'STR_ENTER_PAYMENTS','STR_TIP_65'),(67,'STR_VOID_PAYMENTS','STR_TIP_67'),(70,'STR_EDIT_PLAN','STR_TIP_70'),(72,'STR_PAYABLES','STR_TIP_72'),(74,'STR_MANUAL_CHECKS','STR_TIP_74'),(75,'STR_MANUAL_CHECKS','STR_TIP_75'),(77,'STR_WRITE_CHECKS','STR_TIP_77'),(78,'STR_WRITE_CHECKS','STR_TIP_78'),(84,'STR_CC_CARDS','STR_TIP_84'),(86,'STR_PURCHASING','STR_TIP_86'),(87,'STR_NEW_PURCHASE_ORDER','STR_TIP_87'),(88,'STR_NEW_PURCHASE_ORDER','STR_TIP_88'),(89,'STR_EDIT_PURCHASE_ORDER','STR_TIP_89'),(90,'STR_COMPLETED_PO_TO_AP','STR_TIP_89'),(91,'STR_RECEIVE_ITEMS_ON_PO','STR_TIP_91'),(92,'STR_RECEIVE_ITEMS_ON_PO','STR_TIP_92'),(95,'STR_NEW_VENDOR_BILL','STR_TIP_95'),(103,'STR_WRITE_CHECKS','STR_TIP_103'),(114,'STR_LEDGER','STR_TIP_114'),(115,'STR_BANK_RECONCILIATION','STR_TIP_115'),(121,'STR_EDIT_GL_ACCOUNTS','STR_TIP_121'),(134,'STR_ADD_ON_AND_PLUG_IN','STR_TIP_134'),(164,'STR_COMPANY_ADD_UPDATE','STR_TIP_164'),(184,'STR_CUSTOMER_ITEM_DISCOUNTS','STR_TIP_184'),(212,'STR_BEGIN_BILLS','STR_TIP_212'),(244,'STR_LIST_CUSTOMERS','STR_TIP_244'),(260,'STR_ORDERS_OPEN','STR_TIP_260'),(288,'STR_ITEM_USAGE_HISTORY','STR_TIP_288'),(296,'STR_AGING_DETAILS','STR_TIP_296'),(297,'STR_AGING_REPORT','STR_TIP_297'),(307,'STR_REPRINT_INVOICES','STR_TIP_307'),(308,'STR_SALES_TAX_REPORT','STR_TIP_308'),(309,'STR_SUMMARY_OF_INVOICES','STR_TIP_309'),(312,'STR_DETAIL_AGING','STR_TIP_312'),(316,'STR_COMMISSION_CHECKS','STR_TIP_316'),(317,'STR_COMMISSION_CHECKS','STR_TIP_317'),(320,'STR_LIST_ITEMS_RECEIVED','STR_TIP_320'),(324,'STR_CHECK_SUMMARY','STR_TIP_324'),(336,'STR_ACCOUNT_ACTIVITY','STR_TIP_336'),(338,'STR_STANDARD_BALANCE_SHEET','STR_TIP_338'),(339,'STR_CREATE_A_DETAILED_TRIAL_BALANCE_SHEET','STR_TIP_339');
/*!40000 ALTER TABLE `tips` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `uialertmessage`
--

DROP TABLE IF EXISTS `uialertmessage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `uialertmessage` (
  `id` int(11) NOT NULL auto_increment,
  `data` text NOT NULL,
  `datachecksum` int(11) NOT NULL,
  `suspeneduntil` datetime NOT NULL default '0000-00-00 00:00:00',
  `expires` datetime NOT NULL default '0000-00-00 00:00:00',
  `gencompanyid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `activeperiod` (`suspeneduntil`,`expires`,`gencompanyid`),
  KEY `datachecksum` (`datachecksum`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `uialertmessage`
--

LOCK TABLES `uialertmessage` WRITE;
/*!40000 ALTER TABLE `uialertmessage` DISABLE KEYS */;
/*!40000 ALTER TABLE `uialertmessage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `uialertmessagerecipient`
--

DROP TABLE IF EXISTS `uialertmessagerecipient`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `uialertmessagerecipient` (
  `id` int(11) NOT NULL auto_increment,
  `uialertmessageid` int(11) NOT NULL default '0',
  `userid` int(11) NOT NULL default '0',
  `read` tinyint(1) NOT NULL default '0',
  `readdate` datetime NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `user` (`userid`,`read`),
  KEY `parentid` (`uialertmessageid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `uialertmessagerecipient`
--

LOCK TABLES `uialertmessagerecipient` WRITE;
/*!40000 ALTER TABLE `uialertmessagerecipient` DISABLE KEYS */;
/*!40000 ALTER TABLE `uialertmessagerecipient` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `unit`
--

DROP TABLE IF EXISTS `unit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `unit` (
  `id` int(11) NOT NULL auto_increment,
  `buildingid` int(11) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `subname` varchar(100) NOT NULL default '',
  `description` text NOT NULL,
  `squarefeet` int(11) NOT NULL default '0',
  `rentamount` decimal(19,6) NOT NULL default '0.000000',
  `rentperiod` varchar(5) NOT NULL default '',
  `underrepair` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `beds` int(11) default NULL,
  `baths` decimal(4,1) default NULL,
  `furnished` int(11) NOT NULL default '0',
  `den` int(11) NOT NULL default '0',
  `fireplace` int(11) NOT NULL default '0',
  `carpet` int(11) NOT NULL default '0',
  `drapes` int(11) NOT NULL default '0',
  `airconditioning` int(11) NOT NULL default '0',
  `stove` int(11) NOT NULL default '0',
  `washerdryerhookup` int(11) NOT NULL default '0',
  `washer` int(11) NOT NULL default '0',
  `dryer` int(11) NOT NULL default '0',
  `refrigerator` int(11) NOT NULL default '0',
  `dishwasher` int(11) NOT NULL default '0',
  `disposal` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `unit`
--

LOCK TABLES `unit` WRITE;
/*!40000 ALTER TABLE `unit` DISABLE KEYS */;
/*!40000 ALTER TABLE `unit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `unitname`
--

DROP TABLE IF EXISTS `unitname`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `unitname` (
  `id` int(11) NOT NULL auto_increment,
  `unitname` char(50) default NULL,
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `unitname`
--

LOCK TABLES `unitname` WRITE;
/*!40000 ALTER TABLE `unitname` DISABLE KEYS */;
INSERT INTO `unitname` VALUES (1,'Each',0,NULL,NULL,'2004-12-10 00:00:00',1,'2004-12-20 16:36:16',NULL),(2,'Box',0,NULL,NULL,'2013-03-05 00:00:00',1,'2013-03-05 05:00:00',NULL),(3,'Unit',0,NULL,NULL,'2013-03-05 00:00:00',1,'2013-03-05 05:00:00',NULL),(4,'Case',0,NULL,NULL,'2013-03-05 00:00:00',1,'2013-03-05 05:00:00',NULL),(5,'Hour',0,NULL,NULL,'2013-03-05 00:00:00',1,'2013-03-05 05:00:00',NULL),(6,'Daily',0,NULL,NULL,'2013-03-05 00:00:00',1,'2013-03-05 05:00:00',NULL),(7,'SQ FT',0,NULL,NULL,'2013-03-05 00:00:00',1,'2013-03-05 05:00:00',NULL);
/*!40000 ALTER TABLE `unitname` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ups`
--

DROP TABLE IF EXISTS `ups`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ups` (
  `id` int(11) NOT NULL auto_increment,
  `shiptoid` varchar(50) default NULL,
  `orderid` varchar(50) default NULL,
  `rate` decimal(12,5) NOT NULL default '0.00000',
  `shipdate` varchar(12) default NULL,
  `tracknum` varchar(255) default NULL,
  `void` varchar(5) default NULL,
  `posted` int(5) NOT NULL default '0',
  `hundredweight` char(2) default NULL,
  `billableweight` decimal(12,5) NOT NULL default '0.00000',
  PRIMARY KEY  (`id`),
  KEY `shiptoid` (`shiptoid`),
  KEY `orderid` (`orderid`),
  KEY `tracknum` (`tracknum`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ups`
--

LOCK TABLES `ups` WRITE;
/*!40000 ALTER TABLE `ups` DISABLE KEYS */;
/*!40000 ALTER TABLE `ups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `useractivitytimeout`
--

DROP TABLE IF EXISTS `useractivitytimeout`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `useractivitytimeout` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `sessionid` varchar(128) NOT NULL default '',
  `lastactivity` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `timeoutseconds` int(11) NOT NULL default '1200',
  PRIMARY KEY  (`id`),
  KEY `usersession` (`userid`,`sessionid`),
  KEY `lastactivity` (`lastactivity`)
) ENGINE=MyISAM AUTO_INCREMENT=26 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `useractivitytimeout`
--

LOCK TABLES `useractivitytimeout` WRITE;
/*!40000 ALTER TABLE `useractivitytimeout` DISABLE KEYS */;
INSERT INTO `useractivitytimeout` VALUES (24,1,'5dj7j3c4f1tq4amlo7jo0dbgk81428g4','2019-03-17 21:03:30',6960),(25,-24,'5dj7j3c4f1tq4amlo7jo0dbgk81428g4','2019-03-17 21:01:18',6960);
/*!40000 ALTER TABLE `useractivitytimeout` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `usergroupitemcategory`
--

DROP TABLE IF EXISTS `usergroupitemcategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `usergroupitemcategory` (
  `id` int(11) NOT NULL auto_increment,
  `nprightsgroupid` int(11) NOT NULL default '0',
  `itemcategoryid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `nprightsgroupid` (`nprightsgroupid`),
  KEY `itemcategoryid` (`itemcategoryid`),
  KEY `companyid` (`companyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `usergroupitemcategory`
--

LOCK TABLES `usergroupitemcategory` WRITE;
/*!40000 ALTER TABLE `usergroupitemcategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `usergroupitemcategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `useritem`
--

DROP TABLE IF EXISTS `useritem`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `useritem` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `itemid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `userid` (`userid`),
  KEY `itemid` (`itemid`),
  KEY `companyid` (`companyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `useritem`
--

LOCK TABLES `useritem` WRITE;
/*!40000 ALTER TABLE `useritem` DISABLE KEYS */;
/*!40000 ALTER TABLE `useritem` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `useritemcategory`
--

DROP TABLE IF EXISTS `useritemcategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `useritemcategory` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `itemcategoryid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `userid` (`userid`),
  KEY `itemcategoryid` (`itemcategoryid`),
  KEY `companyid` (`companyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `useritemcategory`
--

LOCK TABLES `useritemcategory` WRITE;
/*!40000 ALTER TABLE `useritemcategory` DISABLE KEYS */;
/*!40000 ALTER TABLE `useritemcategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `userpmtcollection`
--

DROP TABLE IF EXISTS `userpmtcollection`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `userpmtcollection` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `paymentdate` date default NULL,
  `cashamt` decimal(19,6) NOT NULL default '0.000000',
  `checkamt` decimal(19,6) NOT NULL default '0.000000',
  `ccamt` decimal(19,6) NOT NULL default '0.000000',
  `otheramt` decimal(19,6) NOT NULL default '0.000000',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `approved` int(11) NOT NULL default '0',
  `approveddate` datetime default NULL,
  `companyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangeuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  PRIMARY KEY  (`id`),
  KEY `userid` (`userid`),
  KEY `paymentdate` (`paymentdate`),
  KEY `entrydate` (`entrydate`),
  KEY `entryuserid` (`entryuserid`),
  KEY `approved` (`approved`),
  KEY `companyid` (`companyid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userpmtcollection`
--

LOCK TABLES `userpmtcollection` WRITE;
/*!40000 ALTER TABLE `userpmtcollection` DISABLE KEYS */;
/*!40000 ALTER TABLE `userpmtcollection` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `userseries`
--

DROP TABLE IF EXISTS `userseries`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `userseries` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `invpadding` int(11) NOT NULL default '0',
  `invnext` int(11) NOT NULL default '0',
  `invprefix` varchar(15) default NULL,
  `invpostfix` varchar(15) default NULL,
  `ordpadding` int(11) NOT NULL default '0',
  `ordnext` int(11) NOT NULL default '0',
  `ordprefix` varchar(15) default NULL,
  `ordpostfix` varchar(15) default NULL,
  `recpadding` int(11) NOT NULL default '0',
  `recnext` int(11) NOT NULL,
  `recprefix` varchar(15) default NULL,
  `recpostfix` varchar(15) default NULL,
  PRIMARY KEY  (`id`),
  KEY `usercompany` (`userid`,`companyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userseries`
--

LOCK TABLES `userseries` WRITE;
/*!40000 ALTER TABLE `userseries` DISABLE KEYS */;
/*!40000 ALTER TABLE `userseries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor`
--

DROP TABLE IF EXISTS `vendor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendor` (
  `name` varchar(30) NOT NULL default '',
  `id` int(11) NOT NULL auto_increment,
  `orderfromname` varchar(30) default NULL,
  `paytermsid` int(11) NOT NULL default '0',
  `paynone` int(11) NOT NULL default '0',
  `defaultglacctid` int(11) default NULL,
  `defaultbilldescription` varchar(50) default NULL,
  `customeraccount` varchar(20) default NULL,
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) default NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) default NULL,
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `lastchangeuserid` int(11) default NULL,
  `companyname` varchar(100) default NULL,
  `address1` varchar(100) NOT NULL default '',
  `address2` varchar(100) NOT NULL default '',
  `mailstop` varchar(20) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  `state` varchar(20) NOT NULL default '',
  `zip` varchar(15) NOT NULL default '',
  `country` varchar(20) NOT NULL default '',
  `phone1` varchar(20) NOT NULL default '',
  `phone1comment` varchar(20) NOT NULL default '',
  `phone2` varchar(20) NOT NULL default '',
  `phone2comment` varchar(20) NOT NULL default '',
  `phone3` varchar(20) NOT NULL default '',
  `phone3comment` varchar(20) NOT NULL default '',
  `phone4` varchar(20) NOT NULL default '',
  `phone4comment` varchar(20) NOT NULL default '',
  `email1` varchar(50) NOT NULL default '',
  `email1comment` varchar(20) NOT NULL default '',
  `email2` varchar(50) NOT NULL default '',
  `email2comment` varchar(20) NOT NULL default '',
  `website` varchar(100) NOT NULL default '',
  `federalid` varchar(20) NOT NULL default '',
  `orderfrom_companyname` varchar(100) default NULL,
  `orderfrom_address1` varchar(100) NOT NULL default '',
  `orderfrom_address2` varchar(100) NOT NULL default '',
  `orderfrom_mailstop` varchar(20) NOT NULL default '',
  `orderfrom_city` varchar(50) NOT NULL default '',
  `orderfrom_state` varchar(20) NOT NULL default '',
  `orderfrom_zip` varchar(15) NOT NULL default '',
  `orderfrom_country` varchar(20) NOT NULL default '',
  `image` varchar(64) NOT NULL default '',
  `scart` int(11) NOT NULL default '0',
  `workclassid` int(11) NOT NULL default '0',
  `default_cost_per_hour` decimal(12,6) NOT NULL default '0.000000',
  `vendor_code` varchar(50) default NULL,
  `vendor_lead_time` int(11) default NULL,
  `carrierserviceid` int(11) NOT NULL default '0',
  `noreturns` int(2) NOT NULL default '0',
  `percent_commission` decimal(8,4) NOT NULL default '0.0000',
  `flat_commission` decimal(12,4) NOT NULL default '0.0000',
  `parent_vendorid` int(11) NOT NULL default '0',
  `bankrouting` varchar(255) default NULL,
  `bankaccountnum` varchar(255) default NULL,
  `taxgroupid` int(11) NOT NULL default '0',
  `vendorgroupid` int(11) NOT NULL default '0',
  `vendorcode` varchar(30) default NULL,
  `salutation` varchar(20) default NULL,
  `first_name` varchar(50) default NULL,
  `middle_name` varchar(50) default NULL,
  `name_suffix` varchar(20) default NULL,
  `vendortypeid` int(11) NOT NULL default '0',
  `default_retainer` decimal(6,3) NOT NULL default '0.000',
  `currency` varchar(10) NOT NULL default 'USD',
  `gets1099` int(11) NOT NULL default '0',
  `basevendorid` int(11) NOT NULL default '0',
  `lead` tinyint(1) NOT NULL default '0',
  `timezoneid` int(11) NOT NULL default '0',
  `taskstatusid` int(11) NOT NULL default '0',
  `paytoname` varchar(150) NOT NULL default '',
  `default_paymethod` tinyint(1) NOT NULL default '0',
  `default_pay_accountid` int(11) NOT NULL default '0',
  `default_pay_cardid` int(11) NOT NULL default '0',
  `orderfrom_phone` varchar(20) NOT NULL default '',
  `orderfrom_fax` varchar(20) NOT NULL default '',
  `orderfrom_email` varchar(50) NOT NULL default '',
  `default_orderfrom_id` int(11) NOT NULL default '0',
  `default_checkacctid` int(11) NOT NULL default '0',
  `buyeruserid` int(11) NOT NULL default '0',
  `paytoemail` varchar(255) NOT NULL default '',
  `insuranceemail` varchar(50) NOT NULL default '',
  `insuranceemailcomment` varchar(50) NOT NULL default '',
  `insurancephone` varchar(20) NOT NULL default '',
  `insurancephonecomment` varchar(50) NOT NULL default '',
  `insurancefax` varchar(20) NOT NULL default '',
  `insurancefaxcomment` varchar(50) NOT NULL default '',
  `excludefrompaymentreport` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `workclassid` (`workclassid`),
  KEY `workclassid_2` (`workclassid`),
  KEY `parent_vendorid` (`parent_vendorid`),
  KEY `taxgroupid` (`taxgroupid`),
  KEY `vendortypeid` (`vendortypeid`),
  KEY `taskstatusid` (`taskstatusid`),
  KEY `lead` (`lead`),
  KEY `vendor_code` (`vendor_code`),
  KEY `vendorcode` (`vendorcode`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendor`
--

LOCK TABLES `vendor` WRITE;
/*!40000 ALTER TABLE `vendor` DISABLE KEYS */;
INSERT INTO `vendor` VALUES ('',1,NULL,0,0,NULL,NULL,NULL,1,0,NULL,NULL,NULL,NULL,'2005-03-08 15:08:39',NULL,'UPS','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','',0,0,'0.000000',NULL,NULL,0,0,'0.0000','0.0000',0,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,0,'0.000','USD',0,0,0,0,0,'',0,0,0,'','','',0,0,0,'','','','','','','',0),('',2,NULL,0,0,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,'2007-11-08 21:45:58',NULL,'UPS','','','','','','','','','','','','','','','','','','','','','',NULL,'','','','','','','','',0,0,'0.000000',NULL,NULL,0,0,'0.0000','0.0000',0,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,0,'0.000','USD',0,0,0,0,0,'',0,0,0,'','','',0,0,0,'','','','','','','',0);
/*!40000 ALTER TABLE `vendor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_certificate`
--

DROP TABLE IF EXISTS `vendor_certificate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendor_certificate` (
  `id` int(11) NOT NULL auto_increment,
  `vendorid` int(11) NOT NULL default '0',
  `name` varchar(64) NOT NULL default '',
  `expires` date default NULL,
  `issuer` varchar(45) NOT NULL default '',
  `state` varchar(45) NOT NULL default '',
  `city` varchar(45) NOT NULL default '',
  `address` varchar(128) NOT NULL default '',
  `address2` varchar(128) NOT NULL default '',
  `zip` varchar(45) NOT NULL default '',
  `country` varchar(45) default NULL,
  `phone` varchar(32) NOT NULL default '',
  `email` varchar(64) NOT NULL default '',
  `typeid` varchar(45) NOT NULL default '0',
  `notes` mediumtext NOT NULL,
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `module` varchar(5) default 'ap',
  `notvalid` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `vendor_active` (`vendorid`,`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendor_certificate`
--

LOCK TABLES `vendor_certificate` WRITE;
/*!40000 ALTER TABLE `vendor_certificate` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_certificate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_certificate_file`
--

DROP TABLE IF EXISTS `vendor_certificate_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendor_certificate_file` (
  `id` int(11) NOT NULL auto_increment,
  `vendor_certificate_id` int(11) NOT NULL,
  `name` varchar(64) NOT NULL default '',
  `mime` varchar(32) NOT NULL default '',
  `length` int(11) NOT NULL default '0',
  `data` longblob,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `vendor_cert` (`vendor_certificate_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendor_certificate_file`
--

LOCK TABLES `vendor_certificate_file` WRITE;
/*!40000 ALTER TABLE `vendor_certificate_file` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_certificate_file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_certificate_type`
--

DROP TABLE IF EXISTS `vendor_certificate_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendor_certificate_type` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(64) default '0',
  `vendors_must_have` tinyint(1) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `email_subject` tinytext,
  `email_body` text,
  `cancel` tinyint(1) NOT NULL default '0',
  `canceluserid` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `email_expiring_soon_subject` tinytext,
  `module` varchar(5) default 'ap',
  `email_expiring_soon_body` text,
  `email_expired_subject` tinytext,
  `email_expired_body` text,
  `email_notvalid_subject` tinytext,
  `email_missing_attachment` mediumblob,
  `email_expiring_soon_attachment` mediumblob,
  `email_expired_attachment` mediumblob,
  `email_notvalid_attachment` mediumblob,
  `email_missing_attachment_name` varchar(255) NOT NULL default '',
  `email_expiring_soon_attachment_name` varchar(255) NOT NULL default '',
  `email_expired_attachment_name` varchar(255) NOT NULL default '',
  `email_notvalid_attachment_name` varchar(255) NOT NULL default '',
  `email_notvalid_body` text,
  PRIMARY KEY  (`id`),
  KEY `comp` (`cancel`,`gencompanyid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendor_certificate_type`
--

LOCK TABLES `vendor_certificate_type` WRITE;
/*!40000 ALTER TABLE `vendor_certificate_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_certificate_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_certificate_type_required`
--

DROP TABLE IF EXISTS `vendor_certificate_type_required`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendor_certificate_type_required` (
  `id` int(11) NOT NULL auto_increment,
  `vendor_certificate_type_id` int(11) NOT NULL default '0',
  `vendortype_id` int(11) NOT NULL default '0',
  `required` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `vtype` (`vendortype_id`),
  KEY `ctype` (`vendor_certificate_type_id`),
  KEY `specific` (`vendor_certificate_type_id`,`vendortype_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendor_certificate_type_required`
--

LOCK TABLES `vendor_certificate_type_required` WRITE;
/*!40000 ALTER TABLE `vendor_certificate_type_required` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_certificate_type_required` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_checkacct`
--

DROP TABLE IF EXISTS `vendor_checkacct`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendor_checkacct` (
  `id` int(11) NOT NULL auto_increment,
  `vendorid` int(11) NOT NULL default '0',
  `checkacctid` int(11) NOT NULL default '0',
  `paystatus` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `vendorid` (`vendorid`),
  KEY `checkacctid` (`checkacctid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendor_checkacct`
--

LOCK TABLES `vendor_checkacct` WRITE;
/*!40000 ALTER TABLE `vendor_checkacct` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_checkacct` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_orderfrom`
--

DROP TABLE IF EXISTS `vendor_orderfrom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendor_orderfrom` (
  `id` int(11) NOT NULL auto_increment,
  `vendorid` int(11) NOT NULL default '0',
  `companyname` varchar(100) NOT NULL default '',
  `contactname` varchar(100) NOT NULL default '',
  `address` varchar(100) NOT NULL default '',
  `address2` varchar(100) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  `state` varchar(20) NOT NULL default '',
  `zip` varchar(15) NOT NULL default '',
  `country` varchar(20) NOT NULL default '',
  `phone` varchar(20) NOT NULL default '',
  `fax` varchar(20) NOT NULL default '',
  `email` varchar(50) NOT NULL default '',
  `mailstop` varchar(20) NOT NULL default '',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `vendorid` (`vendorid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendor_orderfrom`
--

LOCK TABLES `vendor_orderfrom` WRITE;
/*!40000 ALTER TABLE `vendor_orderfrom` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_orderfrom` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendorglaccount`
--

DROP TABLE IF EXISTS `vendorglaccount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendorglaccount` (
  `id` int(11) NOT NULL auto_increment,
  `vendorid` int(11) NOT NULL default '0',
  `glaccountid` int(11) NOT NULL default '0',
  `percent` decimal(5,2) NOT NULL default '0.00',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `vendorid` (`vendorid`),
  KEY `glaccountid` (`glaccountid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendorglaccount`
--

LOCK TABLES `vendorglaccount` WRITE;
/*!40000 ALTER TABLE `vendorglaccount` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendorglaccount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendorreq`
--

DROP TABLE IF EXISTS `vendorreq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendorreq` (
  `id` int(11) NOT NULL auto_increment,
  `vendorid` int(11) NOT NULL default '0',
  `reqtype` varchar(5) NOT NULL default '',
  `begindate` date NOT NULL default '0000-00-00',
  `enddate` date NOT NULL default '0000-00-00',
  `reminder` int(11) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `description` text NOT NULL,
  `ignored` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  `entryuserid` int(11) NOT NULL default '0',
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` varchar(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `vendorid` (`vendorid`),
  KEY `reqtype` (`reqtype`),
  KEY `begindate` (`begindate`),
  KEY `enddate` (`enddate`),
  KEY `ignored` (`ignored`),
  KEY `companyid` (`companyid`),
  KEY `cancel` (`cancel`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendorreq`
--

LOCK TABLES `vendorreq` WRITE;
/*!40000 ALTER TABLE `vendorreq` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendorreq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendorreqnotify`
--

DROP TABLE IF EXISTS `vendorreqnotify`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendorreqnotify` (
  `id` int(11) NOT NULL auto_increment,
  `reqtype` varchar(5) NOT NULL default '',
  `userid` int(11) NOT NULL default '0',
  `nprightsgroupid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `reqtype` (`reqtype`),
  KEY `userid` (`userid`),
  KEY `nprightsgroupid` (`nprightsgroupid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendorreqnotify`
--

LOCK TABLES `vendorreqnotify` WRITE;
/*!40000 ALTER TABLE `vendorreqnotify` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendorreqnotify` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendorsalestax`
--

DROP TABLE IF EXISTS `vendorsalestax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendorsalestax` (
  `id` int(11) NOT NULL auto_increment,
  `vendorid` int(11) NOT NULL default '0',
  `salestaxid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `vendorid` (`vendorid`),
  KEY `salestaxid` (`salestaxid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendorsalestax`
--

LOCK TABLES `vendorsalestax` WRITE;
/*!40000 ALTER TABLE `vendorsalestax` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendorsalestax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendortype`
--

DROP TABLE IF EXISTS `vendortype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `vendortype` (
  `id` int(11) NOT NULL auto_increment,
  `description` varchar(255) default NULL,
  `cancel` int(5) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `lastupdatedate` timestamp NULL default NULL,
  PRIMARY KEY  (`id`),
  KEY `cancel` (`cancel`),
  KEY `gencompanyid` (`gencompanyid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `vendortype`
--

LOCK TABLES `vendortype` WRITE;
/*!40000 ALTER TABLE `vendortype` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendortype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `voucherref`
--

DROP TABLE IF EXISTS `voucherref`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `voucherref` (
  `id` int(11) NOT NULL auto_increment,
  `voucherid` int(11) NOT NULL default '0',
  `tablename` varchar(50) default NULL,
  `tableid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `voucherid` (`voucherid`),
  KEY `tableid` (`tableid`),
  KEY `tablename` (`tablename`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `voucherref`
--

LOCK TABLES `voucherref` WRITE;
/*!40000 ALTER TABLE `voucherref` DISABLE KEYS */;
/*!40000 ALTER TABLE `voucherref` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `waiver`
--

DROP TABLE IF EXISTS `waiver`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `waiver` (
  `id` int(11) NOT NULL auto_increment,
  `jobid` int(11) NOT NULL default '0',
  `waivertypeid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `dateissued` date default NULL,
  `datethrough` date default NULL,
  `amount` decimal(19,6) NOT NULL,
  `exceptions` mediumtext NOT NULL,
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `job` (`jobid`,`cancel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `waiver`
--

LOCK TABLES `waiver` WRITE;
/*!40000 ALTER TABLE `waiver` DISABLE KEYS */;
/*!40000 ALTER TABLE `waiver` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `waivertype`
--

DROP TABLE IF EXISTS `waivertype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `waivertype` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `sortorder` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `active` (`cancel`,`gencompanyid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `waivertype`
--

LOCK TABLES `waivertype` WRITE;
/*!40000 ALTER TABLE `waivertype` DISABLE KEYS */;
/*!40000 ALTER TABLE `waivertype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wherefrom`
--

DROP TABLE IF EXISTS `wherefrom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `wherefrom` (
  `id` int(11) NOT NULL default '0',
  `module` varchar(10) NOT NULL,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wherefrom`
--

LOCK TABLES `wherefrom` WRITE;
/*!40000 ALTER TABLE `wherefrom` DISABLE KEYS */;
INSERT INTO `wherefrom` VALUES (1,'ap','Accounts Payable'),(2,'ar','Accounts Receivable'),(3,'gl','General Ledger'),(4,'inv','Inventory'),(5,'fix','Fixed Asset'),(6,'pay','Payroll'),(7,'est','Estimating');
/*!40000 ALTER TABLE `wherefrom` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `workarea`
--

DROP TABLE IF EXISTS `workarea`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `workarea` (
  `id_workarea` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  `sortorder` int(11) NOT NULL default '0',
  `print` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '1',
  `ask_instructions` int(2) NOT NULL default '0',
  PRIMARY KEY  (`id_workarea`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `workarea`
--

LOCK TABLES `workarea` WRITE;
/*!40000 ALTER TABLE `workarea` DISABLE KEYS */;
/*!40000 ALTER TABLE `workarea` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `workorder`
--

DROP TABLE IF EXISTS `workorder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `workorder` (
  `id` int(11) NOT NULL auto_increment,
  `buildingid` int(11) NOT NULL default '0',
  `unitid` int(11) NOT NULL default '0',
  `ownercompanyid` int(11) NOT NULL default '0',
  `customerid` int(11) NOT NULL default '0',
  `tenantdescription` text NOT NULL,
  `tenantavailable` text NOT NULL,
  `requestuserid` int(11) NOT NULL default '0',
  `description` text NOT NULL,
  `priority` int(11) NOT NULL default '0',
  `resolution` text NOT NULL,
  `status` char(2) NOT NULL default '',
  `deniedreason` text NOT NULL,
  `decisionuserid` int(11) NOT NULL default '0',
  `decisiondate` datetime NOT NULL default '0000-00-00 00:00:00',
  `worktype` char(2) NOT NULL default '',
  `chargeto` char(2) NOT NULL default '',
  `chargecompanyid` int(11) NOT NULL default '0',
  `chargecustomerid` int(11) NOT NULL default '0',
  `employeeid` int(11) NOT NULL default '0',
  `startdate` date NOT NULL default '0000-00-00',
  `estimatedenddate` date NOT NULL default '0000-00-00',
  `jobid` int(11) NOT NULL default '0',
  `markup` decimal(6,2) NOT NULL default '0.00',
  `poandtimemoved` int(11) NOT NULL default '0',
  `enddate` date default NULL,
  `entrydate` datetime NOT NULL default '0000-00-00 00:00:00',
  `entryuserid` int(11) NOT NULL default '0',
  `cancel` int(11) NOT NULL default '0',
  `canceldate` datetime NOT NULL default '0000-00-00 00:00:00',
  `canceluserid` int(11) NOT NULL default '0',
  `pmworktypeid` int(11) NOT NULL default '0',
  `makeready` tinyint(4) NOT NULL default '0',
  `outleaseid` int(11) NOT NULL default '0',
  `inleaseid` int(11) NOT NULL default '0',
  `finishprelimdate` date default NULL,
  `finishpunchdate` date default NULL,
  `finishcleandate` date default NULL,
  `cleancarpetdate` date default NULL,
  `rsinspectionsdate` date default NULL,
  `rating` int(11) NOT NULL default '0',
  `ratingnote` text,
  `finishprelimdateorig` date default NULL,
  `finishpunchdateorig` date default NULL,
  `finishcleandateorig` date default NULL,
  `cleancarpetdateorig` date default NULL,
  `rsinspectionsdateorig` date default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  `lastchangedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `parentworkorderid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `buildingid` (`buildingid`),
  KEY `unitid` (`unitid`),
  KEY `ownercompanyid` (`ownercompanyid`),
  KEY `customerid` (`customerid`),
  KEY `requestuserid` (`requestuserid`),
  KEY `priority` (`priority`),
  KEY `status` (`status`),
  KEY `decisionuserid` (`decisionuserid`),
  KEY `worktype` (`worktype`),
  KEY `chargeto` (`chargeto`),
  KEY `chargecompanyid` (`chargecompanyid`),
  KEY `chargecustomerid` (`chargecustomerid`),
  KEY `employeeid` (`employeeid`),
  KEY `startdate` (`startdate`),
  KEY `estimatedenddate` (`estimatedenddate`),
  KEY `jobid` (`jobid`),
  KEY `enddate` (`enddate`),
  KEY `entrydate` (`entrydate`),
  KEY `cancel` (`cancel`),
  KEY `outleaseid` (`outleaseid`),
  KEY `inleaseid` (`inleaseid`),
  KEY `parentworkorderid` (`parentworkorderid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `workorder`
--

LOCK TABLES `workorder` WRITE;
/*!40000 ALTER TABLE `workorder` DISABLE KEYS */;
/*!40000 ALTER TABLE `workorder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `workordernotify`
--

DROP TABLE IF EXISTS `workordernotify`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `workordernotify` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `nprightsgroupid` int(11) NOT NULL default '0',
  `companyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `workordernotify`
--

LOCK TABLES `workordernotify` WRITE;
/*!40000 ALTER TABLE `workordernotify` DISABLE KEYS */;
/*!40000 ALTER TABLE `workordernotify` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `worksteps`
--

DROP TABLE IF EXISTS `worksteps`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `worksteps` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `createdate` datetime default NULL,
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NULL default NULL,
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  `sortorder` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `sortorder` (`sortorder`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `worksteps`
--

LOCK TABLES `worksteps` WRITE;
/*!40000 ALTER TABLE `worksteps` DISABLE KEYS */;
/*!40000 ALTER TABLE `worksteps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `worksteps_estquotequote`
--

DROP TABLE IF EXISTS `worksteps_estquotequote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `worksteps_estquotequote` (
  `id` int(11) NOT NULL auto_increment,
  `id_printorder` int(11) NOT NULL default '0',
  `workstepsid` int(11) NOT NULL default '0',
  `completedate` datetime default NULL,
  `userid` int(11) NOT NULL default '0',
  `cancel` int(5) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `id_printorder` (`id_printorder`),
  KEY `workstepsid` (`workstepsid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `worksteps_estquotequote`
--

LOCK TABLES `worksteps_estquotequote` WRITE;
/*!40000 ALTER TABLE `worksteps_estquotequote` DISABLE KEYS */;
/*!40000 ALTER TABLE `worksteps_estquotequote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `worksubtype`
--

DROP TABLE IF EXISTS `worksubtype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `worksubtype` (
  `id_worksubtype` int(11) NOT NULL auto_increment,
  `id_worktype` int(11) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `purpose` varchar(255) NOT NULL default '',
  `num_parts` int(3) NOT NULL default '1',
  `vended` int(3) NOT NULL default '4',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_worksubtype`),
  UNIQUE KEY `id_worksubtype` (`id_worksubtype`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `worksubtype`
--

LOCK TABLES `worksubtype` WRITE;
/*!40000 ALTER TABLE `worksubtype` DISABLE KEYS */;
/*!40000 ALTER TABLE `worksubtype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `worksubtype_detail`
--

DROP TABLE IF EXISTS `worksubtype_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `worksubtype_detail` (
  `id_worksubtype` int(11) NOT NULL default '0',
  `id_category` int(11) NOT NULL default '0',
  `id_family` int(11) NOT NULL default '0',
  `id_item` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_worksubtype`,`id_family`,`id_category`,`id_item`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `worksubtype_detail`
--

LOCK TABLES `worksubtype_detail` WRITE;
/*!40000 ALTER TABLE `worksubtype_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `worksubtype_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `worksubtype_quantity`
--

DROP TABLE IF EXISTS `worksubtype_quantity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `worksubtype_quantity` (
  `id_worksubtype_quantity` int(11) NOT NULL auto_increment,
  `id_worksubtype` int(11) NOT NULL default '0',
  `quantity` decimal(18,6) NOT NULL default '0.000000',
  `days` int(5) NOT NULL default '1',
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_worksubtype_quantity`),
  UNIQUE KEY `id_worksubtype_quantity` (`id_worksubtype_quantity`),
  KEY `id_worksubtype` (`id_worksubtype`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `worksubtype_quantity`
--

LOCK TABLES `worksubtype_quantity` WRITE;
/*!40000 ALTER TABLE `worksubtype_quantity` DISABLE KEYS */;
/*!40000 ALTER TABLE `worksubtype_quantity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `worksubtype_quantityseq`
--

DROP TABLE IF EXISTS `worksubtype_quantityseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `worksubtype_quantityseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `worksubtype_quantityseq`
--

LOCK TABLES `worksubtype_quantityseq` WRITE;
/*!40000 ALTER TABLE `worksubtype_quantityseq` DISABLE KEYS */;
INSERT INTO `worksubtype_quantityseq` VALUES (0);
/*!40000 ALTER TABLE `worksubtype_quantityseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `worksubtypeseq`
--

DROP TABLE IF EXISTS `worksubtypeseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `worksubtypeseq` (
  `id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `worksubtypeseq`
--

LOCK TABLES `worksubtypeseq` WRITE;
/*!40000 ALTER TABLE `worksubtypeseq` DISABLE KEYS */;
INSERT INTO `worksubtypeseq` VALUES (0);
/*!40000 ALTER TABLE `worksubtypeseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `worktype`
--

DROP TABLE IF EXISTS `worktype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `worktype` (
  `id_worktype` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `purpose` varchar(255) default NULL,
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `id_user_create` int(11) NOT NULL default '0',
  `orderflag` int(3) NOT NULL default '0',
  `lastrevisedate` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `id_user_revise` int(11) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `cancel` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_worktype`),
  UNIQUE KEY `id_worktype` (`id_worktype`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `worktype`
--

LOCK TABLES `worktype` WRITE;
/*!40000 ALTER TABLE `worktype` DISABLE KEYS */;
/*!40000 ALTER TABLE `worktype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `worktypeseq`
--

DROP TABLE IF EXISTS `worktypeseq`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `worktypeseq` (
  `id` int(11) NOT NULL default '0',
  UNIQUE KEY `id` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `worktypeseq`
--

LOCK TABLES `worktypeseq` WRITE;
/*!40000 ALTER TABLE `worktypeseq` DISABLE KEYS */;
INSERT INTO `worktypeseq` VALUES (0);
/*!40000 ALTER TABLE `worktypeseq` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `writeoffreason`
--

DROP TABLE IF EXISTS `writeoffreason`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `writeoffreason` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `glaccountid` int(11) NOT NULL default '0',
  `glcategoryid` int(11) NOT NULL default '0',
  `gencompanyid` int(11) NOT NULL default '0',
  `cancel` tinyint(1) NOT NULL default '0',
  `canceldate` datetime default NULL,
  `canceluserid` int(11) NOT NULL default '0',
  `entrydate` datetime default NULL,
  `entryuserid` int(11) NOT NULL default '0',
  `lastchangedate` datetime default NULL,
  `lastchangeuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `writeoffreason`
--

LOCK TABLES `writeoffreason` WRITE;
/*!40000 ALTER TABLE `writeoffreason` DISABLE KEYS */;
/*!40000 ALTER TABLE `writeoffreason` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `writeoffreasonnprightsgroup`
--

DROP TABLE IF EXISTS `writeoffreasonnprightsgroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `writeoffreasonnprightsgroup` (
  `id` int(11) NOT NULL auto_increment,
  `writeoffreasonid` int(11) NOT NULL default '0',
  `nprightsgroupid` int(11) NOT NULL default '0',
  `amount` decimal(19,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`id`),
  KEY `writeoffreasonid` (`writeoffreasonid`),
  KEY `nprightsgroupid` (`nprightsgroupid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `writeoffreasonnprightsgroup`
--

LOCK TABLES `writeoffreasonnprightsgroup` WRITE;
/*!40000 ALTER TABLE `writeoffreasonnprightsgroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `writeoffreasonnprightsgroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zencompany`
--

DROP TABLE IF EXISTS `zencompany`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zencompany` (
  `id` int(11) NOT NULL auto_increment,
  `default_pricelevelid` int(11) NOT NULL default '0',
  `locationid` int(11) NOT NULL default '0',
  `cost` int(11) NOT NULL default '0',
  `sales` int(11) NOT NULL default '0',
  `default_sellunitid` int(11) NOT NULL default '0',
  `default_priceunitid` int(11) NOT NULL default '0',
  `checking` int(11) NOT NULL default '0',
  `depositglacctid` int(11) NOT NULL default '0',
  `default_checkacctid` int(11) NOT NULL default '0',
  `default_salescategory_fulfillment` int(11) NOT NULL default '0',
  `default_invoicetermsid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zencompany`
--

LOCK TABLES `zencompany` WRITE;
/*!40000 ALTER TABLE `zencompany` DISABLE KEYS */;
/*!40000 ALTER TABLE `zencompany` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zipcode`
--

DROP TABLE IF EXISTS `zipcode`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zipcode` (
  `zip` char(10) NOT NULL default '',
  `state` char(10) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  `county` varchar(50) NOT NULL default '',
  `latitude` double default NULL,
  `longitude` double default NULL,
  KEY `zip` (`zip`),
  KEY `citystate` USING BTREE (`state`,`city`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zipcode`
--

LOCK TABLES `zipcode` WRITE;
/*!40000 ALTER TABLE `zipcode` DISABLE KEYS */;
INSERT INTO `zipcode` VALUES ('00501','NY','Holtsville','Suffolk',40.8152,-73.0455),('00544','NY','Holtsville','Suffolk',40.8152,-73.0455),('00601','PR','Adjuntas','Adjuntas',18.180103,-66.749472),('00602','PR','Aguada','Aguada',18.363285,-67.180247),('00603','PR','Aguadilla','Aguadilla',18.448619,-67.134224),('00604','PR','Aguadilla','Aguadilla',18.498987,-67.136995),('00605','PR','Aguadilla','Aguadilla',18.449619,-67.112869),('00606','PR','Maricao','Maricao',18.182151,-66.958807),('00610','PR','Anasco','Anasco',18.288319,-67.136046),('00611','PR','Angeles','Utuado',18.28854,-66.770683),('00612','PR','Arecibo','Arecibo',18.449732,-66.698797),('00613','PR','Arecibo','Arecibo',18.44594,-66.743698),('00614','PR','Arecibo','Arecibo',18.44594,-66.743698),('00616','PR','Bajadero','Arecibo',18.426748,-66.676692),('00617','PR','Barceloneta','Barceloneta',18.455499,-66.555758),('00622','PR','Boqueron','Cabo Rojo',18.003125,-67.167456),('00623','PR','Cabo Rojo','Cabo Rojo',18.08643,-67.152226),('00624','PR','Penuelas','Penuelas',18.055399,-66.726029),('00627','PR','Camuy','Camuy',18.435246,-66.856443),('00631','PR','Castaner','Lares',18.186739,-66.851745),('00636','PR','Rosario','San German',18.157471,-67.068268),('00637','PR','Sabana Grande','Sabana Grande',18.073078,-66.948643),('00638','PR','Ciales','Ciales',18.308139,-66.498354),('00641','PR','Utuado','Utuado',18.268896,-66.705193),('00646','PR','Dorado','Dorado',18.442798,-66.276894),('00647','PR','Ensenada','Guanica',17.964529,-66.939932),('00650','PR','Florida','Florida',18.363331,-66.567732),('00652','PR','Garrochales','Arecibo',18.457453,-66.612173),('00653','PR','Guanica','Guanica',17.992112,-66.900977),('00656','PR','Guayanilla','Guayanilla',18.038866,-66.791684),('00659','PR','Hatillo','Hatillo',18.432956,-66.800394),('00660','PR','Hormigueros','Hormigueros',18.139108,-67.120857),('00662','PR','Isabela','Isabela',18.478855,-67.019737),('00664','PR','Jayuya','Jayuya',18.212565,-66.592437),('00667','PR','Lajas','Lajas',18.017819,-67.042267),('00669','PR','Lares','Lares',18.288418,-66.875037),('00670','PR','Las Marias','Las Marias',18.241343,-66.976041),('00674','PR','Manati','Manati',18.426137,-66.486974),('00676','PR','Moca','Moca',18.37956,-67.084245),('00677','PR','Rincon','Rincon',18.336121,-67.236754),('00678','PR','Quebradillas','Quebradillas',18.442334,-66.932756),('00680','PR','Mayaguez','Mayaguez',18.205232,-67.12655),('00681','PR','Mayaguez','Mayaguez',18.211559,-67.102364),('00682','PR','Mayaguez','Mayaguez',18.208402,-67.154286),('00683','PR','San German','San German',18.092807,-67.045245),('00685','PR','San Sebastian','San Sebastian',18.332595,-66.981041),('00687','PR','Morovis','Morovis',18.31708,-66.415286),('00688','PR','Sabana Hoyos','Arecibo',18.40415,-66.613484),('00690','PR','San Antonio','Aguadilla',18.495369,-67.09867),('00692','PR','Vega Alta','Vega Alta',18.419666,-66.331864),('00693','PR','Vega Baja','Vega Baja',18.440667,-66.392106),('00694','PR','Vega Baja','Vega Baja',18.418171,-66.39856),('00698','PR','Yauco','Yauco',18.0306,66.8507),('00703','PR','Aguas Buenas','Aguas Buenas',18.246205,-66.128274),('00704','PR','Aguirre','Guayama',17.970112,-66.22291),('00705','PR','Aibonito','Aibonito',18.12942,-66.265419),('00707','PR','Maunabo','Maunabo',18.014505,-65.910184),('00714','PR','Arroyo','Arroyo',17.987288,-66.055525),('00715','PR','Mercedita','Ponce',18.003492,-66.558687),('00716','PR','Ponce','Ponce',17.999066,-66.599655),('00717','PR','Ponce','Ponce',18.004303,-66.613746),('00718','PR','Naguabo','Naguabo',18.22048,-65.742938),('00719','PR','Naranjito','Naranjito',18.294571,-66.250988),('00720','PR','Orocovis','Orocovis',18.217827,-66.422657),('00721','PR','Palmer','Rio Grande',18.35083,-65.789139),('00723','PR','Patillas','Patillas',18.023196,-66.013105),('00725','PR','Caguas','Caguas',18.233927,-66.04502),('00726','PR','Caguas','Caguas',18.21282,-66.058029),('00727','PR','Caguas','Caguas',18.232,-66.038803),('00728','PR','Ponce','Ponce',18.013353,-66.652183),('00729','PR','Canovanas','Canovanas',18.35615,-65.890899),('00730','PR','Ponce','Ponce',18.022626,-66.617275),('00731','PR','Ponce','Ponce',18.077329,-66.61192),('00732','PR','Ponce','Ponce',18.066851,-66.614754),('00733','PR','Ponce','Ponce',18.010559,-66.637657),('00734','PR','Ponce','Ponce',18.010559,-66.637657),('00735','PR','Ceiba','Ceiba',18.258444,-65.659878),('00736','PR','Cayey','Cayey',18.112895,-66.153773),('00737','PR','Cayey','Cayey',18.115009,-66.163078),('00738','PR','Fajardo','Fajardo',18.32265,-65.661163),('00739','PR','Cidra','Cidra',18.16984,-66.162715),('00740','PR','Puerto Real','Fajardo',18.331711,-65.627617),('00741','PR','Punta Santiago','Humacao',18.160755,-65.757658),('00742','PR','Roosevelt Roads','Ceiba',18.22459,-65.611603),('00744','PR','Rio Blanco','Naguabo',18.24728,-65.793823),('00745','PR','Rio Grande','Rio Grande',18.366213,-65.82277),('00751','PR','Salinas','Salinas',17.993803,-66.265346),('00754','PR','San Lorenzo','San Lorenzo',18.15633,-65.968314),('00757','PR','Santa Isabel','Santa Isabel',17.98631,-66.394573),('00765','PR','Vieques','Vieques',18.125664,-65.456036),('00766','PR','Villalba','Villalba',18.126023,-66.482086),('00767','PR','Yabucoa','Yabucoa',18.072752,-65.897039),('00769','PR','Coamo','Coamo',18.092813,-66.361103),('00771','PR','Las Piedras','Las Piedras',18.18744,-65.870889),('00772','PR','Loiza','Loiza',18.427674,-65.876055),('00773','PR','Luquillo','Luquillo',18.361344,-65.721335),('00775','PR','Culebra','Culebra',18.311149,-65.292575),('00777','PR','Juncos','Juncos',18.224088,-65.913162),('00778','PR','Gurabo','Gurabo',18.258628,-65.977913),('00780','PR','Coto Laurel','Ponce',18.068538,-66.559397),('00782','PR','Comerio','Comerio',18.223348,-66.2267),('00783','PR','Corozal','Corozal',18.304874,-66.323059),('00784','PR','Guayama','Guayama',17.984137,-66.127791),('00785','PR','Guayama','Guayanilla',18.04425,-66.79274),('00786','PR','La Plata','Aibonito',18.158661,-66.234032),('00791','PR','Humacao','Humacao',18.147257,-65.822693),('00792','PR','Humacao','Humacao',18.137991,-65.80838),('00794','PR','Barranquitas','Barranquitas',18.204294,-66.310581),('00795','PR','Juana Diaz','Juana Diaz',18.036253,-66.502899),('00801','VI','St Thomas','Saint Thomas',18.3424,-64.938164),('00802','VI','St Thomas','Saint Thomas',18.357719,-64.985123),('00803','VI','St Thomas','Saint Thomas',18.37224,-64.9132),('00804','VI','St Thomas','Saint Thomas',18.335091,-64.880234),('00805','VI','St Thomas','Saint Thomas',18.350719,-64.935928),('00820','VI','Christiansted','Saint Croix',17.765261,-64.739021),('00821','VI','Christiansted','Saint Croix',17.748501,-64.630371),('00822','VI','Christiansted','Saint Croix',17.723089,-64.669067),('00823','VI','Christiansted','Saint Croix',17.716141,-64.682617),('00824','VI','Christiansted','Saint Croix',17.710079,-64.720863),('00830','VI','St John','Saint John',18.329781,-64.777611),('00831','VI','St John','Saint John',18.343651,-64.730766),('00840','VI','Frederiksted','Saint Croix',17.69771,-64.882339),('00841','VI','Frederiksted','Saint Croix',17.748581,-64.86068),('00850','VI','Kingshill','Saint Croix',17.752569,-64.787979),('00851','VI','Kingshill','Saint Croix',17.71468,-64.790863),('00901','PR','San Juan','San Juan',18.465426,-66.107862),('00902','PR','San Juan','San Juan',18.38958,-66.059258),('00906','PR','San Juan','San Juan',18.46454,-66.100792),('00907','PR','San Juan','San Juan',18.451131,-66.077987),('00908','PR','San Juan','San Juan',18.38958,-66.059258),('00909','PR','San Juan','San Juan',18.442282,-66.067647),('00910','PR','San Juan','San Juan',18.38958,-66.059258),('00911','PR','San Juan','San Juan',18.45009,-66.057706),('00912','PR','San Juan','San Juan',18.445946,-66.059286),('00913','PR','San Juan','San Juan',18.450907,-66.042563),('00914','PR','San Juan','San Juan',18.38958,-66.059258),('00915','PR','San Juan','San Juan',18.436995,-66.048884),('00916','PR','San Juan','San Juan',18.38958,-66.059258),('00917','PR','San Juan','San Juan',18.422263,-66.0513),('00918','PR','San Juan','San Juan',18.417668,-66.06494),('00919','PR','San Juan','San Juan',18.38958,-66.059258),('00920','PR','San Juan','San Juan',18.41242,-66.090693),('00921','PR','San Juan','San Juan',18.394019,-66.086336),('00922','PR','San Juan','San Juan',18.38958,-66.059258),('00923','PR','San Juan','San Juan',18.410681,-66.038062),('00924','PR','San Juan','San Juan',18.401917,-66.011943),('00925','PR','San Juan','San Juan',18.400006,-66.050288),('00926','PR','San Juan','San Juan',18.361363,-66.056208),('00927','PR','San Juan','San Juan',18.39184,-66.068678),('00928','PR','San Juan','San Juan',18.38958,-66.059258),('00929','PR','San Juan','San Juan',18.38958,-66.059258),('00930','PR','San Juan','San Juan',18.38958,-66.059258),('00931','PR','San Juan','San Juan',18.38958,-66.059258),('00933','PR','San Juan','San Juan',18.38958,-66.059258),('00934','PR','Fort Buchanan','Bayamon',18.413511,-66.121987),('00935','PR','San Juan','San Juan',18.38958,-66.059258),('00936','PR','San Juan','San Juan',18.38958,-66.059258),('00937','PR','San Juan','San Juan',18.38958,-66.059258),('00939','PR','San Juan','San Juan',18.38958,-66.059258),('00940','PR','San Juan','San Juan',18.38958,-66.059258),('00949','PR','Toa Baja','Toa Baja',18.433173,-66.204207),('00950','PR','Toa Baja','Toa Baja',18.42404,-66.240356),('00951','PR','Toa Baja','Toa Baja',18.443701,-66.254578),('00952','PR','Sabana Seca','Toa Baja',18.429218,-66.180146),('00953','PR','Toa Alta','Toa Alta',18.36802,-66.234147),('00954','PR','Toa Alta','Toa Alta',18.38834,-66.25032),('00955','PR','San Juan','San Juan',18.38958,-66.059258),('00956','PR','Bayamon','Bayamon',18.34216,-66.16643),('00957','PR','Bayamon','Bayamon',18.369674,-66.186695),('00958','PR','Bayamon','Bayamon',18.344959,-66.166191),('00959','PR','Bayamon','Bayamon',18.387063,-66.159436),('00960','PR','Bayamon','Bayamon',18.37924,-66.163521),('00961','PR','Bayamon','Bayamon',18.412462,-66.160338),('00962','PR','Catano','Catano',18.437683,-66.138474),('00963','PR','Catano','Catano',18.443211,-66.13929),('00965','PR','Guaynabo','Guaynabo',18.431453,-66.117034),('00966','PR','Guaynabo','Guaynabo',18.398507,-66.115224),('00968','PR','Guaynabo','San Juan',18.408479,-66.102507),('00969','PR','Guaynabo','Guaynabo',18.366981,-66.108892),('00970','PR','Guaynabo','Guaynabo',18.3592,-66.112297),('00971','PR','Guaynabo','Guaynabo',18.329688,-66.118768),('00975','PR','San Juan','San Juan',18.38958,-66.059258),('00976','PR','Trujillo Alto','Trujillo Alto',18.346767,-66.005613),('00977','PR','Trujillo Alto','Trujillo Alto',18.337,-65.990021),('00978','PR','Saint Just','Trujillo Alto',18.36838,-66.003677),('00979','PR','Carolina','San Juan',18.431885,-66.012709),('00981','PR','Carolina','San Juan',18.364019,-65.972382),('00982','PR','Carolina','San Juan',18.409345,-65.993138),('00983','PR','Carolina','Carolina',18.414408,-65.975824),('00984','PR','Carolina','Carolina',18.399731,-65.975937),('00985','PR','Carolina','Carolina',18.374896,-65.946912),('00986','PR','Carolina','Carolina',18.399731,-65.975937),('00987','PR','Carolina','Carolina',18.372228,-65.962753),('00988','PR','Carolina','Carolina',18.399731,-65.975937),('01001','MA','Agawam','Hampden',42.069809,-72.619921),('01002','MA','Amherst','Hampshire',42.376584,-72.500397),('01003','MA','Amherst','Hampshire',42.389941,-72.524108),('01004','MA','Amherst','Hampshire',42.3698,-72.5338),('01005','MA','Barre','Worcester',42.410455,-72.107496),('01007','MA','Belchertown','Hampshire',42.277181,-72.409675),('01008','MA','Blandford','Hampden',42.17586,-72.945938),('01009','MA','Bondsville','Hampden',42.211969,-72.341433),('01010','MA','Brimfield','Hampden',42.129477,-72.205302),('01011','MA','Chester','Hampden',42.281439,-72.975548),('01012','MA','Chesterfield','Hampshire',42.391577,-72.841613),('01013','MA','Chicopee','Hampden',42.158732,-72.604967),('01014','MA','Chicopee','Hampden',42.1457,-72.6085),('01020','MA','Chicopee','Hampden',42.173892,-72.573783),('01021','MA','Chicopee','Hampden',42.158,-72.5859),('01022','MA','Chicopee','Hampden',42.197506,-72.549685),('01026','MA','Cummington','Hampshire',42.47179,-72.923314),('01027','MA','Easthampton','Hampshire',42.270687,-72.684793),('01028','MA','East Longmeadow','Hampden',42.065375,-72.509232),('01029','MA','East Otis','Berkshire',42.179701,-73.045335),('01030','MA','Feeding Hills','Hampden',42.072071,-72.675091),('01031','MA','Gilbertville','Worcester',42.322864,-72.188032),('01032','MA','Goshen','Hampshire',42.44677,-72.804415),('01033','MA','Granby','Hampshire',42.255999,-72.516911),('01034','MA','Granville','Hampden',42.085436,-72.944577),('01035','MA','Hadley','Hampshire',42.351589,-72.561943),('01036','MA','Hampden','Hampden',42.062946,-72.417297),('01037','MA','Hardwick','Worcester',42.364881,-72.18893),('01038','MA','Hatfield','Hampshire',42.375866,-72.610823),('01039','MA','Haydenville','Hampshire',42.404278,-72.688922),('01040','MA','Holyoke','Hampden',42.201632,-72.625706),('01041','MA','Holyoke','Hampden',42.2078,-72.6101),('01050','MA','Huntington','Hampshire',42.273976,-72.871369),('01053','MA','Leeds','Hampshire',42.351793,-72.699051),('01054','MA','Leverett','Franklin',42.472574,-72.485084),('01056','MA','Ludlow','Hampden',42.175656,-72.475814),('01057','MA','Monson','Hampden',42.093596,-72.321494),('01059','MA','North Amherst','Hampshire',42.4102,-72.5313),('01060','MA','Northampton','Hampshire',42.324688,-72.635595),('01061','MA','Northampton','Hampshire',42.3209,-72.6278),('01062','MA','Florence','Hampshire',42.327907,-72.676464),('01063','MA','Northampton','Hampshire',42.319575,-72.638629),('01066','MA','North Hatfield','Hampshire',42.4111,-72.6227),('01068','MA','Oakham','Worcester',42.353679,-72.042947),('01069','MA','Palmer','Hampden',42.172164,-72.32565),('01070','MA','Plainfield','Hampshire',42.518446,-72.919017),('01071','MA','Russell','Hampden',42.166686,-72.858096),('01072','MA','Shutesbury','Franklin',42.478734,-72.421896),('01073','MA','Southampton','Hampshire',42.227262,-72.728476),('01074','MA','South Barre','Worcester',42.385177,-72.095754),('01075','MA','South Hadley','Hampshire',42.238891,-72.584158),('01077','MA','Southwick','Hampden',42.052517,-72.764196),('01079','MA','Thorndike','Hampden',42.189292,-72.333404),('01080','MA','Three Rivers','Hampden',42.181352,-72.362674),('01081','MA','Wales','Hampden',42.061646,-72.233817),('01082','MA','Ware','Hampshire',42.273275,-72.268561),('01083','MA','Warren','Worcester',42.205146,-72.191297),('01084','MA','West Chesterfield','Hampshire',42.393435,-72.873666),('01085','MA','Westfield','Hampden',42.133169,-72.747724),('01086','MA','Westfield','Hampden',42.130113,-72.793135),('01088','MA','West Hatfield','Hampshire',42.388343,-72.633405),('01089','MA','West Springfield','Hampden',42.12104,-72.638304),('01090','MA','West Springfield','Hampden',42.1379,-72.622),('01092','MA','West Warren','Worcester',42.205466,-72.238136),('01093','MA','Whately','Franklin',42.434278,-72.649961),('01094','MA','Wheelwright','Worcester',42.359109,-72.136799),('01095','MA','Wilbraham','Hampden',42.128199,-72.435257),('01096','MA','Williamsburg','Hampshire',42.401767,-72.774388),('01097','MA','Woronoco','Hampden',42.166247,-72.827394),('01098','MA','Worthington','Hampshire',42.398309,-72.938155),('01101','MA','Springfield','Hampden',42.106,-72.5977),('01102','MA','Springfield','Hampden',42.106,-72.5977),('01103','MA','Springfield','Hampden',42.104106,-72.592028),('01104','MA','Springfield','Hampden',42.129669,-72.576515),('01105','MA','Springfield','Hampden',42.096854,-72.579762),('01106','MA','Longmeadow','Hampden',42.05164,-72.570761),('01107','MA','Springfield','Hampden',42.119814,-72.605671),('01108','MA','Springfield','Hampden',42.082337,-72.559642),('01109','MA','Springfield','Hampden',42.117824,-72.550129),('01111','MA','Springfield','Hampden',42.106,-72.5977),('01115','MA','Springfield','Hampden',42.106,-72.5977),('01116','MA','Longmeadow','Hampden',42.0558,-72.5512),('01118','MA','Springfield','Hampden',42.093444,-72.528182),('01119','MA','Springfield','Hampden',42.127466,-72.510492),('01128','MA','Springfield','Hampden',42.095725,-72.488487),('01129','MA','Springfield','Hampden',42.123254,-72.487486),('01133','MA','Springfield','Hampden',42.106,-72.5977),('01138','MA','Springfield','Hampden',42.106,-72.5977),('01139','MA','Springfield','Hampden',42.106,-72.5977),('01144','MA','Springfield','Hampden',42.106,-72.5977),('01151','MA','Indian Orchard','Hampden',42.15337,-72.509579),('01152','MA','Springfield','Hampden',42.106,-72.5977),('01195','MA','Springfield','Hampden',42.1015,-72.5898),('01199','MA','Springfield','Hampden',42.106,-72.5977),('01201','MA','Pittsfield','Berkshire',42.45395,-73.253907),('01202','MA','Pittsfield','Berkshire',42.4492,-73.2499),('01203','MA','Pittsfield','Berkshire',42.4492,-73.2499),('01220','MA','Adams','Berkshire',42.622311,-73.119614),('01222','MA','Ashley Falls','Berkshire',42.058703,-73.322175),('01223','MA','Becket','Berkshire',42.285538,-73.093828),('01224','MA','Berkshire','Berkshire',42.506932,-73.195483),('01225','MA','Cheshire','Berkshire',42.558208,-73.159291),('01226','MA','Dalton','Berkshire',42.471282,-73.158309),('01227','MA','Dalton','Berkshire',42.473,-73.165),('01229','MA','Glendale','Berkshire',42.280704,-73.335352),('01230','MA','Great Barrington','Berkshire',42.191219,-73.353988),('01235','MA','Hinsdale','Berkshire',42.434547,-73.094463),('01236','MA','Housatonic','Berkshire',42.262374,-73.37137),('01237','MA','Lanesboro','Berkshire',42.551447,-73.247516),('01238','MA','Lee','Berkshire',42.301233,-73.239096),('01240','MA','Lenox','Berkshire',42.361607,-73.274832),('01242','MA','Lenox Dale','Berkshire',42.334533,-73.247136),('01243','MA','Middlefield','Hampshire',42.350276,-73.006969),('01244','MA','Mill River','Berkshire',42.111307,-73.264823),('01245','MA','Monterey','Berkshire',42.179812,-73.224819),('01247','MA','North Adams','Berkshire',42.695699,-73.093852),('01252','MA','North Egremont','Berkshire',42.1966,-73.4383),('01253','MA','Otis','Berkshire',42.197961,-73.100614),('01254','MA','Richmond','Berkshire',42.375021,-73.363093),('01255','MA','Sandisfield','Berkshire',42.116076,-73.109437),('01256','MA','Savoy','Berkshire',42.594166,-73.02232),('01257','MA','Sheffield','Berkshire',42.102513,-73.365985),('01258','MA','South Egremont','Berkshire',42.11429,-73.455175),('01259','MA','Southfield','Berkshire',42.069261,-73.228949),('01260','MA','South Lee','Berkshire',42.280292,-73.298881),('01262','MA','Stockbridge','Berkshire',42.298153,-73.320032),('01263','MA','Stockbridge','Berkshire',42.2875,-73.3208),('01264','MA','Tyringham','Berkshire',42.228069,-73.194248),('01266','MA','West Stockbridge','Berkshire',42.328265,-73.371216),('01267','MA','Williamstown','Berkshire',42.693369,-73.211648),('01270','MA','Windsor','Berkshire',42.50118,-73.033562),('01301','MA','Greenfield','Franklin',42.603958,-72.601321),('01302','MA','Greenfield','Franklin',42.6525,-72.608),('01330','MA','Ashfield','Franklin',42.516102,-72.809147),('01331','MA','Athol','Worcester',42.580024,-72.208388),('01337','MA','Bernardston','Franklin',42.69032,-72.572649),('01338','MA','Buckland','Franklin',42.571353,-72.811119),('01339','MA','Charlemont','Franklin',42.611295,-72.888301),('01340','MA','Colrain','Franklin',42.673517,-72.717561),('01341','MA','Conway','Franklin',42.508567,-72.707159),('01342','MA','Deerfield','Franklin',42.546117,-72.607204),('01343','MA','Drury','Berkshire',42.660838,-72.997751),('01344','MA','Erving','Franklin',42.601383,-72.433751),('01346','MA','Heath','Franklin',42.693275,-72.823113),('01347','MA','Lake Pleasant','Franklin',42.558733,-72.516236),('01349','MA','Turners Falls','Franklin',42.57656,-72.491972),('01350','MA','Monroe Bridge','Franklin',42.718067,-72.959464),('01351','MA','Montague','Franklin',42.540674,-72.528329),('01354','MA','Gill','Franklin',42.643239,-72.517508),('01355','MA','New Salem','Franklin',42.489749,-72.328491),('01360','MA','Northfield','Franklin',42.681331,-72.455728),('01364','MA','Orange','Franklin',42.601134,-72.295516),('01366','MA','Petersham','Worcester',42.48376,-72.19256),('01367','MA','Rowe','Franklin',42.695582,-72.909185),('01368','MA','Royalston','Worcester',42.669023,-72.180415),('01370','MA','Shelburne Falls','Franklin',42.595569,-72.723506),('01373','MA','South Deerfield','Franklin',42.474829,-72.612684),('01375','MA','Sunderland','Franklin',42.4623,-72.562687),('01376','MA','Turners Falls','Franklin',42.597514,-72.558679),('01378','MA','Warwick','Franklin',42.674173,-72.341204),('01379','MA','Wendell','Franklin',42.55631,-72.407148),('01380','MA','Wendell Depot','Franklin',42.594455,-72.363147),('01420','MA','Fitchburg','Worcester',42.576909,-71.805519),('01430','MA','Ashburnham','Worcester',42.658741,-71.932918),('01431','MA','Ashby','Middlesex',42.674663,-71.817289),('01432','MA','Ayer','Middlesex',42.562257,-71.579692),('01434','MA','Devens','Worcester',42.54184,-71.611779),('01436','MA','Baldwinville','Worcester',42.606625,-72.07532),('01438','MA','East Templeton','Worcester',42.561088,-72.036074),('01440','MA','Gardner','Worcester',42.576146,-71.992351),('01441','MA','Westminster','Worcester',42.5737,-71.9961),('01450','MA','Groton','Middlesex',42.61176,-71.565269),('01451','MA','Harvard','Worcester',42.503872,-71.578126),('01452','MA','Hubbardston','Worcester',42.477493,-71.996567),('01453','MA','Leominster','Worcester',42.526955,-71.751663),('01460','MA','Littleton','Middlesex',42.538728,-71.492429),('01462','MA','Lunenburg','Worcester',42.582607,-71.720464),('01463','MA','Pepperell','Middlesex',42.668132,-71.593468),('01464','MA','Shirley','Middlesex',42.555984,-71.648704),('01467','MA','Still River','Worcester',42.489499,-71.609344),('01468','MA','Templeton','Worcester',42.557697,-72.068357),('01469','MA','Townsend','Middlesex',42.66031,-71.694707),('01470','MA','Groton','Middlesex',42.6079,-71.5715),('01471','MA','Groton','Middlesex',42.6079,-71.5715),('01472','MA','West Groton','Middlesex',42.6041,-71.6277),('01473','MA','Westminster','Worcester',42.548007,-71.901939),('01474','MA','West Townsend','Middlesex',42.675351,-71.75562),('01475','MA','Winchendon','Worcester',42.668473,-72.049496),('01477','MA','Winchendon Springs','Worcester',42.6944,-72.0152),('01501','MA','Auburn','Worcester',42.203233,-71.838453),('01503','MA','Berlin','Worcester',42.375502,-71.625689),('01504','MA','Blackstone','Worcester',42.028545,-71.520289),('01505','MA','Boylston','Worcester',42.344829,-71.729379),('01506','MA','Brookfield','Worcester',42.200436,-72.097971),('01507','MA','Charlton','Worcester',42.136476,-71.970983),('01508','MA','Charlton City','Worcester',42.1458,-71.9888),('01509','MA','Charlton Depot','Worcester',42.173,-71.9791),('01510','MA','Clinton','Worcester',42.418916,-71.684813),('01515','MA','East Brookfield','Worcester',42.216597,-72.050894),('01516','MA','Douglas','Worcester',42.057863,-71.735645),('01517','MA','East Princeton','Worcester',42.4698,-71.8928),('01518','MA','Fiskdale','Worcester',42.12052,-72.119887),('01519','MA','Grafton','Worcester',42.200699,-71.683044),('01520','MA','Holden','Worcester',42.343707,-71.845772),('01521','MA','Holland','Hampden',42.058844,-72.159112),('01522','MA','Jefferson','Worcester',42.375634,-71.867382),('01523','MA','Lancaster','Worcester',42.472349,-71.676128),('01524','MA','Leicester','Worcester',42.240349,-71.917651),('01525','MA','Linwood','Worcester',42.106794,-71.630518),('01526','MA','Manchaug','Worcester',42.0944,-71.748),('01527','MA','Millbury','Worcester',42.19947,-71.768099),('01529','MA','Millville','Worcester',42.032362,-71.576782),('01531','MA','New Braintree','Worcester',42.316628,-72.126211),('01532','MA','Northborough','Worcester',42.321287,-71.64498),('01534','MA','Northbridge','Worcester',42.142778,-71.647105),('01535','MA','North Brookfield','Worcester',42.266193,-72.076696),('01536','MA','North Grafton','Worcester',42.232313,-71.69915),('01537','MA','North Oxford','Worcester',42.170649,-71.890266),('01538','MA','North Uxbridge','Worcester',42.0875,-71.6416),('01540','MA','Oxford','Worcester',42.118781,-71.865519),('01541','MA','Princeton','Worcester',42.452693,-71.88174),('01542','MA','Rochdale','Worcester',42.200019,-71.913627),('01543','MA','Rutland','Worcester',42.380878,-71.964282),('01545','MA','Shrewsbury','Worcester',42.284753,-71.724293),('01546','MA','Shrewsbury','Worcester',42.2934,-71.7188),('01550','MA','Southbridge','Worcester',42.07211,-72.034734),('01560','MA','South Grafton','Worcester',42.173619,-71.683974),('01561','MA','South Lancaster','Worcester',42.44404,-71.686194),('01562','MA','Spencer','Worcester',42.247211,-71.991867),('01564','MA','Sterling','Worcester',42.436751,-71.772749),('01566','MA','Sturbridge','Worcester',42.107267,-72.080475),('01568','MA','Upton','Worcester',42.173806,-71.607493),('01569','MA','Uxbridge','Worcester',42.066402,-71.629051),('01570','MA','Webster','Worcester',42.051846,-71.862338),('01571','MA','Dudley','Worcester',42.054578,-71.919446),('01580','MA','Westborough','Worcester',42.283,-71.6015),('01581','MA','Westborough','Worcester',42.270663,-71.611053),('01582','MA','Westborough','Worcester',42.283,-71.6015),('01583','MA','West Boylston','Worcester',42.359923,-71.784924),('01585','MA','West Brookfield','Worcester',42.242582,-72.158739),('01586','MA','West Millbury','Worcester',42.1906,-71.7617),('01588','MA','Whitinsville','Worcester',42.115766,-71.668748),('01590','MA','Sutton','Worcester',42.135446,-71.742967),('01601','MA','Worcester','Worcester',42.2621,-71.8034),('01602','MA','Worcester','Worcester',42.273875,-71.843872),('01603','MA','Worcester','Worcester',42.239573,-71.834463),('01604','MA','Worcester','Worcester',42.253843,-71.774402),('01605','MA','Worcester','Worcester',42.285942,-71.789269),('01606','MA','Worcester','Worcester',42.311172,-71.796107),('01607','MA','Worcester','Worcester',42.228878,-71.792284),('01608','MA','Worcester','Worcester',42.262305,-71.801146),('01609','MA','Worcester','Worcester',42.274884,-71.817544),('01610','MA','Worcester','Worcester',42.249342,-71.807833),('01611','MA','Cherry Valley','Worcester',42.240788,-71.873717),('01612','MA','Paxton','Worcester',42.312035,-71.926215),('01613','MA','Worcester','Worcester',42.2625,-71.8027),('01614','MA','Worcester','Worcester',42.2625,-71.8027),('01615','MA','Worcester','Worcester',42.2625,-71.8027),('01653','MA','Worcester','Worcester',42.2625,-71.8027),('01654','MA','Worcester','Worcester',42.2625,-71.8027),('01655','MA','Worcester','Worcester',42.2625,-71.8027),('01701','MA','Framingham','Middlesex',42.315703,-71.426846),('01702','MA','Framingham','Middlesex',42.285705,-71.432871),('01703','MA','Framingham','Middlesex',42.2993,-71.4302),('01704','MA','Framingham','Middlesex',42.2782,-71.4188),('01705','MA','Framingham','Middlesex',42.3277,-71.403),('01718','MA','Village Of Nagog Woods','Middlesex',42.520206,-71.429521),('01719','MA','Boxborough','Middlesex',42.488226,-71.514404),('01720','MA','Acton','Middlesex',42.480804,-71.442796),('01721','MA','Ashland','Middlesex',42.256121,-71.458893),('01730','MA','Bedford','Middlesex',42.494451,-71.271106),('01731','MA','Hanscom Afb','Middlesex',42.456722,-71.278406),('01740','MA','Bolton','Worcester',42.435457,-71.611507),('01741','MA','Carlisle','Middlesex',42.529359,-71.348952),('01742','MA','Concord','Middlesex',42.459,-71.367751),('01745','MA','Fayville','Worcester',42.296306,-71.504211),('01746','MA','Holliston','Middlesex',42.197746,-71.438249),('01747','MA','Hopedale','Worcester',42.127147,-71.537866),('01748','MA','Hopkinton','Middlesex',42.227432,-71.539749),('01749','MA','Hudson','Middlesex',42.391612,-71.556707),('01752','MA','Marlborough','Middlesex',42.349832,-71.549762),('01754','MA','Maynard','Middlesex',42.428699,-71.453006),('01756','MA','Mendon','Worcester',42.091504,-71.557054),('01757','MA','Milford','Worcester',42.150274,-71.516116),('01760','MA','Natick','Middlesex',42.288797,-71.354978),('01770','MA','Sherborn','Middlesex',42.235309,-71.369701),('01772','MA','Southborough','Worcester',42.300238,-71.528693),('01773','MA','Lincoln','Middlesex',42.425506,-71.310812),('01775','MA','Stow','Middlesex',42.42595,-71.509089),('01776','MA','Sudbury','Middlesex',42.383464,-71.426752),('01778','MA','Wayland','Middlesex',42.34559,-71.359627),('01784','MA','Woodville','Middlesex',42.2375,-71.5625),('01801','MA','Woburn','Middlesex',42.486406,-71.150886),('01803','MA','Burlington','Middlesex',42.503227,-71.201713),('01805','MA','Burlington','Middlesex',42.4884,-71.2004),('01806','MA','Woburn','Middlesex',42.4791,-71.1527),('01807','MA','Woburn','Middlesex',42.506,-71.1265),('01808','MA','Woburn','Middlesex',42.506,-71.1265),('01810','MA','Andover','Essex',42.648044,-71.161751),('01812','MA','Andover','Essex',42.6464,-71.1657),('01813','MA','Woburn','Middlesex',42.506,-71.1265),('01815','MA','Woburn','Middlesex',42.506,-71.1265),('01821','MA','Billerica','Middlesex',42.54802,-71.250256),('01822','MA','Billerica','Middlesex',42.5569,-71.2677),('01824','MA','Chelmsford','Middlesex',42.596395,-71.349385),('01826','MA','Dracut','Middlesex',42.675952,-71.32225),('01827','MA','Dunstable','Middlesex',42.676078,-71.500517),('01830','MA','Haverhill','Essex',42.787328,-71.068643),('01831','MA','Haverhill','Essex',42.7735,-71.0825),('01832','MA','Haverhill','Essex',42.782722,-71.113332),('01833','MA','Georgetown','Essex',42.72016,-70.982024),('01834','MA','Groveland','Essex',42.755764,-71.027265),('01835','MA','Haverhill','Essex',42.760425,-71.084603),('01840','MA','Lawrence','Essex',42.707559,-71.16055),('01841','MA','Lawrence','Essex',42.711936,-71.168168),('01842','MA','Lawrence','Essex',42.7068,-71.1659),('01843','MA','Lawrence','Essex',42.691142,-71.159351),('01844','MA','Methuen','Essex',42.725159,-71.181621),('01845','MA','North Andover','Essex',42.682412,-71.110662),('01850','MA','Lowell','Middlesex',42.654941,-71.303446),('01851','MA','Lowell','Middlesex',42.628987,-71.332177),('01852','MA','Lowell','Middlesex',42.63096,-71.299246),('01853','MA','Lowell','Middlesex',42.6333,-71.3166),('01854','MA','Lowell','Middlesex',42.648611,-71.334386),('01860','MA','Merrimac','Essex',42.834405,-71.002621),('01862','MA','North Billerica','Middlesex',42.57702,-71.287338),('01863','MA','North Chelmsford','Middlesex',42.631176,-71.388163),('01864','MA','North Reading','Middlesex',42.57845,-71.088867),('01865','MA','Nutting Lake','Middlesex',42.5278,-71.2573),('01866','MA','Pinehurst','Middlesex',42.5269,-71.2263),('01867','MA','Reading','Middlesex',42.525554,-71.108614),('01876','MA','Tewksbury','Middlesex',42.604875,-71.22427),('01879','MA','Tyngsboro','Middlesex',42.671393,-71.417343),('01880','MA','Wakefield','Middlesex',42.503061,-71.070741),('01885','MA','West Boxford','Essex',42.707,-71.0642),('01886','MA','Westford','Middlesex',42.590889,-71.440203),('01887','MA','Wilmington','Middlesex',42.559724,-71.166391),('01888','MA','Woburn','Middlesex',42.506,-71.1265),('01889','MA','North Reading','Middlesex',42.4867,-71.1547),('01890','MA','Winchester','Middlesex',42.452005,-71.143),('01899','MA','Andover','Essex',42.6464,-71.1657),('01901','MA','Lynn','Essex',42.462883,-70.946268),('01902','MA','Lynn','Essex',42.469457,-70.940636),('01903','MA','Lynn','Essex',42.4647,-70.9467),('01904','MA','Lynn','Essex',42.486773,-70.963468),('01905','MA','Lynn','Essex',42.463787,-70.972843),('01906','MA','Saugus','Essex',42.462781,-71.010812),('01907','MA','Swampscott','Essex',42.474287,-70.905908),('01908','MA','Nahant','Essex',42.428234,-70.926071),('01910','MA','Lynn','Essex',42.4647,-70.9467),('01913','MA','Amesbury','Essex',42.852329,-70.937324),('01915','MA','Beverly','Essex',42.561126,-70.872133),('01921','MA','Boxford','Essex',42.680187,-71.010621),('01922','MA','Byfield','Essex',42.752053,-70.926887),('01923','MA','Danvers','Essex',42.569707,-70.948616),('01929','MA','Essex','Essex',42.637393,-70.779514),('01930','MA','Gloucester','Essex',42.625884,-70.674106),('01931','MA','Gloucester','Essex',42.6142,-70.6635),('01936','MA','Hamilton','Essex',42.6208,-70.8577),('01937','MA','Hathorne','Essex',42.585723,-70.984051),('01938','MA','Ipswich','Essex',42.682881,-70.837093),('01940','MA','Lynnfield','Essex',42.527659,-71.027416),('01944','MA','Manchester','Essex',42.579457,-70.763226),('01945','MA','Marblehead','Essex',42.499806,-70.86358),('01949','MA','Middleton','Essex',42.59452,-71.009358),('01950','MA','Newburyport','Essex',42.812628,-70.879801),('01951','MA','Newbury','Essex',42.782721,-70.850792),('01952','MA','Salisbury','Essex',42.843582,-70.859565),('01960','MA','Peabody','Essex',42.534066,-70.961115),('01961','MA','Peabody','Essex',42.5357,-70.948),('01965','MA','Prides Crossing','Essex',42.5592,-70.8281),('01966','MA','Rockport','Essex',42.657799,-70.617258),('01969','MA','Rowley','Essex',42.720873,-70.89122),('01970','MA','Salem','Essex',42.518981,-70.900263),('01971','MA','Salem','Essex',42.5197,-70.8967),('01982','MA','South Hamilton','Essex',42.620733,-70.859233),('01983','MA','Topsfield','Essex',42.641379,-70.94344),('01984','MA','Wenham','Essex',42.59931,-70.877302),('01985','MA','West Newbury','Essex',42.790932,-70.973537),('02018','MA','Accord','Plymouth',42.1747,-70.8871),('02019','MA','Bellingham','Norfolk',42.076682,-71.47449),('02020','MA','Brant Rock','Plymouth',42.0918,-70.6464),('02021','MA','Canton','Norfolk',42.172027,-71.133923),('02025','MA','Cohasset','Norfolk',42.23465,-70.809306),('02026','MA','Dedham','Norfolk',42.242695,-71.168939),('02027','MA','Dedham','Norfolk',42.2484,-71.1748),('02030','MA','Dover','Norfolk',42.241029,-71.279907),('02031','MA','East Mansfield','Bristol',42.023,-71.1777),('02032','MA','East Walpole','Norfolk',42.153743,-71.213845),('02035','MA','Foxboro','Norfolk',42.060276,-71.247589),('02038','MA','Franklin','Norfolk',42.092408,-71.40559),('02040','MA','Greenbush','Plymouth',42.1776,-70.7473),('02041','MA','Green Harbor','Plymouth',42.0777,-70.65),('02043','MA','Hingham','Plymouth',42.227349,-70.886754),('02044','MA','Hingham','Plymouth',42.2424,-70.8906),('02045','MA','Hull','Plymouth',42.286557,-70.877869),('02047','MA','Humarock','Plymouth',42.132286,-70.686487),('02048','MA','Mansfield','Bristol',42.021477,-71.222139),('02050','MA','Marshfield','Plymouth',42.108714,-70.693507),('02051','MA','Marshfield Hills','Plymouth',42.1382,-70.6913),('02052','MA','Medfield','Norfolk',42.186658,-71.305604),('02053','MA','Medway','Norfolk',42.151659,-71.42286),('02054','MA','Millis','Norfolk',42.167288,-71.360718),('02055','MA','Minot','Plymouth',42.1927,-70.7392),('02056','MA','Norfolk','Norfolk',42.119002,-71.325831),('02059','MA','North Marshfield','Plymouth',42.143,-70.7708),('02060','MA','North Scituate','Plymouth',42.2188,-70.7861),('02061','MA','Norwell','Plymouth',42.156928,-70.832883),('02062','MA','Norwood','Norfolk',42.186553,-71.201658),('02065','MA','Ocean Bluff','Plymouth',42.0972,-70.6541),('02066','MA','Scituate','Plymouth',42.203468,-70.751889),('02067','MA','Sharon','Norfolk',42.11632,-71.178232),('02070','MA','Sheldonville','Norfolk',42.0347,-71.3875),('02071','MA','South Walpole','Norfolk',42.103425,-71.273589),('02072','MA','Stoughton','Norfolk',42.127922,-71.106289),('02081','MA','Walpole','Norfolk',42.144296,-71.252128),('02090','MA','Westwood','Norfolk',42.218831,-71.206643),('02093','MA','Wrentham','Norfolk',42.05647,-71.340546),('02108','MA','Boston','Suffolk',42.357767,-71.065586),('02109','MA','Boston','Suffolk',42.362295,-71.053708),('02110','MA','Boston','Suffolk',42.356524,-71.05321),('02111','MA','Boston','Suffolk',42.350694,-71.059849),('02112','MA','Boston','Suffolk',42.3583,-71.0602),('02113','MA','Boston','Suffolk',42.365773,-71.055431),('02114','MA','Boston','Suffolk',42.363164,-71.065782),('02115','MA','Boston','Suffolk',42.34081,-71.092655),('02116','MA','Boston','Suffolk',42.34924,-71.075109),('02117','MA','Boston','Suffolk',42.3503,-71.0762),('02118','MA','Boston','Suffolk',42.339035,-71.071488),('02119','MA','Boston','Suffolk',42.324609,-71.084391),('02120','MA','Boston','Suffolk',42.332761,-71.095813),('02121','MA','Boston','Suffolk',42.307434,-71.083022),('02122','MA','Boston','Suffolk',42.295316,-71.050574),('02123','MA','Boston','Suffolk',42.345,-71.0876),('02124','MA','Boston','Suffolk',42.287033,-71.071632),('02125','MA','Boston','Suffolk',42.316596,-71.06025),('02126','MA','Mattapan','Suffolk',42.273119,-71.093611),('02127','MA','Boston','Suffolk',42.334789,-71.045463),('02128','MA','Boston','Suffolk',42.376346,-71.026112),('02129','MA','Charlestown','Suffolk',42.377794,-71.063916),('02130','MA','Jamaica Plain','Suffolk',42.310398,-71.11357),('02131','MA','Roslindale','Suffolk',42.283915,-71.127643),('02132','MA','West Roxbury','Suffolk',42.280705,-71.159658),('02133','MA','Boston','Suffolk',42.3573,-71.065),('02134','MA','Allston','Suffolk',42.35661,-71.129996),('02135','MA','Brighton','Suffolk',42.349521,-71.152669),('02136','MA','Hyde Park','Suffolk',42.252509,-71.126514),('02137','MA','Readville','Suffolk',42.2399,-71.1338),('02138','MA','Cambridge','Middlesex',42.378206,-71.131096),('02139','MA','Cambridge','Middlesex',42.362986,-71.103353),('02140','MA','Cambridge','Middlesex',42.393273,-71.128347),('02141','MA','Cambridge','Middlesex',42.3703,-71.08256),('02142','MA','Cambridge','Middlesex',42.36379,-71.081096),('02143','MA','Somerville','Middlesex',42.382103,-71.099286),('02144','MA','Somerville','Middlesex',42.399586,-71.121654),('02145','MA','Somerville','Middlesex',42.391027,-71.09088),('02148','MA','Malden','Middlesex',42.429441,-71.060041),('02149','MA','Everett','Middlesex',42.411498,-71.04916),('02150','MA','Chelsea','Suffolk',42.396207,-71.033303),('02151','MA','Revere','Suffolk',42.416306,-71.005325),('02152','MA','Winthrop','Suffolk',42.374839,-70.979489),('02153','MA','Medford','Middlesex',42.4029,-71.1191),('02155','MA','Medford','Middlesex',42.419886,-71.109424),('02156','MA','West Medford','Middlesex',42.4215,-71.134),('02163','MA','Boston','Suffolk',42.366168,-71.12285),('02169','MA','Quincy','Norfolk',42.250612,-70.997919),('02170','MA','Quincy','Norfolk',42.2675,-71.017913),('02171','MA','Quincy','Norfolk',42.285536,-71.024057),('02176','MA','Melrose','Middlesex',42.457809,-71.062042),('02180','MA','Stoneham','Middlesex',42.480242,-71.098168),('02184','MA','Braintree','Norfolk',42.209012,-71.002439),('02185','MA','Braintree','Norfolk',42.2021,-71.0016),('02186','MA','Milton','Norfolk',42.249957,-71.075863),('02187','MA','Milton Village','Norfolk',42.2698,-71.0683),('02188','MA','Weymouth','Norfolk',42.208498,-70.956388),('02189','MA','East Weymouth','Norfolk',42.213298,-70.931588),('02190','MA','South Weymouth','Norfolk',42.171671,-70.947458),('02191','MA','North Weymouth','Norfolk',42.242784,-70.94436),('02196','MA','Boston','Suffolk',42.3583,-71.0602),('02199','MA','Boston','Suffolk',42.348226,-71.081485),('02201','MA','Boston','Suffolk',42.3624,-71.0628),('02203','MA','Boston','Suffolk',42.3624,-71.0628),('02204','MA','Boston','Suffolk',42.3624,-71.0628),('02205','MA','Boston','Suffolk',42.348,-71.0551),('02206','MA','Boston','Suffolk',42.3583,-71.0602),('02207','MA','Boston','Suffolk',42.3576,-71.0579),('02210','MA','Boston','Suffolk',42.34837,-71.044018),('02211','MA','Boston','Suffolk',42.3576,-71.0579),('02212','MA','Boston','Middlesex',42.3576,-71.0579),('02215','MA','Boston','Suffolk',42.347532,-71.101776),('02216','MA','Boston','Suffolk',42.3487,-71.0745),('02217','MA','Boston','Suffolk',42.3487,-71.0745),('02222','MA','Boston','Suffolk',42.367797,-71.062829),('02228','MA','East Boston','Suffolk',42.3605,-71.0249),('02238','MA','Cambridge','Middlesex',42.3731,-71.124),('02239','MA','Cambridge','Middlesex',42.3662,-71.1063),('02241','MA','Boston','Suffolk',42.3576,-71.0579),('02266','MA','Boston','Suffolk',42.3583,-71.0602),('02269','MA','Quincy','Norfolk',42.251,-71.0023),('02283','MA','Boston','Suffolk',42.3483,-71.0556),('02284','MA','Boston','Suffolk',42.3483,-71.0556),('02293','MA','Boston','Suffolk',42.3583,-71.0602),('02295','MA','Boston','Suffolk',42.3487,-71.0745),('02297','MA','Boston','Suffolk',42.3583,-71.0602),('02298','MA','Boston','Suffolk',42.3823,-71.0323),('02301','MA','Brockton','Plymouth',42.080397,-71.038159),('02302','MA','Brockton','Plymouth',42.087224,-71.001713),('02303','MA','Brockton','Plymouth',42.0828,-71.0164),('02304','MA','Brockton','Plymouth',42.0635,-71.0157),('02305','MA','Brockton','Plymouth',42.0635,-71.0157),('02322','MA','Avon','Norfolk',42.123464,-71.047223),('02324','MA','Bridgewater','Plymouth',41.979756,-70.972462),('02325','MA','Bridgewater','Plymouth',41.9898,-70.9653),('02327','MA','Bryantville','Plymouth',42.0598,-70.859),('02330','MA','Carver','Plymouth',41.869054,-70.757195),('02331','MA','Duxbury','Plymouth',42.0237,-70.6838),('02332','MA','Duxbury','Plymouth',42.032481,-70.704864),('02333','MA','East Bridgewater','Plymouth',42.035795,-70.946452),('02334','MA','Easton','Bristol',42.0244,-71.1291),('02337','MA','Elmwood','Plymouth',41.9686,-70.9736),('02338','MA','Halifax','Plymouth',41.993984,-70.860282),('02339','MA','Hanover','Plymouth',42.122956,-70.85631),('02340','MA','Hanover','Plymouth',42.1223,-70.8564),('02341','MA','Hanson','Plymouth',42.060191,-70.870026),('02343','MA','Holbrook','Norfolk',42.146894,-71.012135),('02344','MA','Middleboro','Plymouth',41.8938,-70.9187),('02345','MA','Manomet','Plymouth',41.9186,-70.5666),('02346','MA','Middleboro','Plymouth',41.886472,-70.894307),('02347','MA','Lakeville','Plymouth',41.834474,-70.95704),('02348','MA','Lakeville','Plymouth',41.8309,-70.9599),('02349','MA','Middleboro','Plymouth',41.8938,-70.9187),('02350','MA','Monponsett','Plymouth',42.0183,-70.8472),('02351','MA','Abington','Plymouth',42.117808,-70.953163),('02355','MA','North Carver','Plymouth',41.9202,-70.8),('02356','MA','North Easton','Bristol',42.059979,-71.115263),('02357','MA','North Easton','Bristol',42.059202,-71.078012),('02358','MA','North Pembroke','Plymouth',41.805219,-70.626425),('02359','MA','Pembroke','Plymouth',42.060018,-70.807499),('02360','MA','Plymouth','Plymouth',41.895407,-70.634214),('02361','MA','Plymouth','Plymouth',41.9236,-70.6571),('02362','MA','Plymouth','Plymouth',41.9236,-70.6571),('02364','MA','Kingston','Plymouth',41.993258,-70.738155),('02366','MA','South Carver','Plymouth',41.848208,-70.656216),('02367','MA','Plympton','Plymouth',41.966748,-70.809327),('02368','MA','Randolph','Norfolk',42.174213,-71.048316),('02370','MA','Rockland','Plymouth',42.130855,-70.913674),('02375','MA','South Easton','Bristol',42.031775,-71.100865),('02379','MA','West Bridgewater','Plymouth',42.021768,-71.019343),('02381','MA','White Horse Beach','Plymouth',41.9308,-70.5583),('02382','MA','Whitman','Plymouth',42.082161,-70.937084),('02420','MA','Lexington','Middlesex',42.455587,-71.218545),('02421','MA','Lexington','Middlesex',42.438547,-71.239574),('02445','MA','Brookline','Norfolk',42.330141,-71.13219),('02446','MA','Brookline','Norfolk',42.344184,-71.119919),('02447','MA','Brookline Village','Norfolk',42.3334,-71.1207),('02451','MA','Waltham','Middlesex',42.393248,-71.253086),('02452','MA','Waltham','Middlesex',42.392571,-71.221587),('02453','MA','Waltham','Middlesex',42.369251,-71.238558),('02454','MA','Waltham','Middlesex',42.3888,-71.2426),('02455','MA','North Waltham','Middlesex',42.3586,-71.0605),('02456','MA','New Town','Middlesex',42.3762,-71.2398),('02457','MA','Babson Park','Norfolk',42.299043,-71.265341),('02458','MA','Newton','Middlesex',42.354868,-71.18787),('02459','MA','Newton Center','Middlesex',42.321472,-71.192846),('02460','MA','Newtonville','Middlesex',42.353085,-71.208961),('02461','MA','Newton Highlands','Middlesex',42.319507,-71.207464),('02462','MA','Newton Lower Falls','Middlesex',42.330884,-71.256199),('02464','MA','Newton Upper Falls','Middlesex',42.312975,-71.218882),('02465','MA','West Newton','Middlesex',42.350149,-71.227492),('02466','MA','Auburndale','Middlesex',42.344457,-71.248617),('02467','MA','Chestnut Hill','Norfolk',42.318603,-71.162292),('02468','MA','Waban','Middlesex',42.325975,-71.232597),('02471','MA','Watertown','Middlesex',42.3733,-71.154),('02472','MA','Watertown','Middlesex',42.371036,-71.177264),('02474','MA','Arlington','Middlesex',42.417953,-71.15465),('02475','MA','Arlington Heights','Middlesex',42.4243,-71.1834),('02476','MA','Arlington','Middlesex',42.416395,-71.17712),('02477','MA','Watertown','Middlesex',42.4185,-71.1644),('02478','MA','Belmont','Middlesex',42.391584,-71.174764),('02479','MA','Waverley','Middlesex',42.3876,-71.1914),('02481','MA','Wellesley Hills','Norfolk',42.314352,-71.270743),('02482','MA','Wellesley','Norfolk',42.29772,-71.300259),('02492','MA','Needham','Norfolk',42.278616,-71.234993),('02493','MA','Weston','Middlesex',42.356834,-71.2878),('02494','MA','Needham Heights','Norfolk',42.29949,-71.232519),('02495','MA','Nonantum','Middlesex',42.3526,-71.1885),('02532','MA','Buzzards Bay','Barnstable',41.749753,-70.604156),('02534','MA','Cataumet','Barnstable',41.664763,-70.614364),('02535','MA','Chilmark','Dukes',41.345389,-70.7526),('02536','MA','East Falmouth','Barnstable',41.582518,-70.562782),('02537','MA','East Sandwich','Barnstable',41.733476,-70.437098),('02538','MA','East Wareham','Plymouth',41.780154,-70.652599),('02539','MA','Edgartown','Dukes',41.37841,-70.530948),('02540','MA','Falmouth','Barnstable',41.564797,-70.61874),('02541','MA','Falmouth','Barnstable',41.5522,-70.6167),('02542','MA','Buzzards Bay','Barnstable',41.689408,-70.552054),('02543','MA','Woods Hole','Barnstable',41.505447,-70.706454),('02552','MA','Menemsha','Dukes',41.3516,-70.7647),('02553','MA','Monument Beach','Barnstable',41.714783,-70.614605),('02554','MA','Nantucket','Nantucket',41.279415,-70.10389),('02556','MA','North Falmouth','Barnstable',41.640451,-70.63031),('02557','MA','Oak Bluffs','Dukes',41.448507,-70.572733),('02558','MA','Onset','Plymouth',41.744757,-70.65771),('02559','MA','Pocasset','Barnstable',41.694402,-70.608273),('02561','MA','Sagamore','Barnstable',41.771314,-70.534577),('02562','MA','Sagamore Beach','Barnstable',41.787984,-70.527592),('02563','MA','Sandwich','Barnstable',41.733949,-70.487438),('02564','MA','Siasconset','Nantucket',41.259912,-69.987305),('02565','MA','Silver Beach','Barnstable',41.6513,-70.6126),('02568','MA','Vineyard Haven','Dukes',41.45362,-70.613657),('02571','MA','Wareham','Plymouth',41.759992,-70.705236),('02573','MA','West Chop','Dukes',41.4541,-70.6041),('02574','MA','West Falmouth','Barnstable',41.6041,-70.635),('02575','MA','West Tisbury','Dukes',41.403098,-70.653222),('02576','MA','West Wareham','Plymouth',41.774802,-70.758726),('02584','MA','Nantucket','Nantucket',41.2833,-70.1),('02601','MA','Hyannis','Barnstable',41.656944,-70.295274),('02630','MA','Barnstable','Barnstable',41.701666,-70.299456),('02631','MA','Brewster','Barnstable',41.753112,-70.066983),('02632','MA','Centerville','Barnstable',41.657434,-70.346717),('02633','MA','Chatham','Barnstable',41.686547,-69.97731),('02634','MA','Centerville','Barnstable',41.6486,-70.3486),('02635','MA','Cotuit','Barnstable',41.628333,-70.440578),('02636','MA','Centerville','Barnstable',41.6486,-70.3486),('02637','MA','Cummaquid','Barnstable',41.705725,-70.270929),('02638','MA','Dennis','Barnstable',41.732722,-70.19269),('02639','MA','Dennis Port','Barnstable',41.663617,-70.136165),('02641','MA','East Dennis','Barnstable',41.752427,-70.148122),('02642','MA','Eastham','Barnstable',41.840214,-69.984506),('02643','MA','East Orleans','Barnstable',41.773103,-69.933436),('02644','MA','Forestdale','Barnstable',41.683488,-70.510786),('02645','MA','Harwich','Barnstable',41.705114,-70.057763),('02646','MA','Harwich Port','Barnstable',41.670547,-70.07448),('02647','MA','Hyannis Port','Barnstable',41.631507,-70.303667),('02648','MA','Marstons Mills','Barnstable',41.667728,-70.416738),('02649','MA','Mashpee','Barnstable',41.61165,-70.489384),('02650','MA','North Chatham','Barnstable',41.705615,-69.964766),('02651','MA','North Eastham','Barnstable',41.87008,-70.007426),('02652','MA','North Truro','Barnstable',42.03929,-70.087839),('02653','MA','Orleans','Barnstable',41.780638,-69.975567),('02655','MA','Osterville','Barnstable',41.633232,-70.386631),('02657','MA','Provincetown','Barnstable',42.053709,-70.190068),('02659','MA','South Chatham','Barnstable',41.681443,-70.023521),('02660','MA','South Dennis','Barnstable',41.703639,-70.154678),('02661','MA','South Harwich','Barnstable',41.675799,-70.039606),('02662','MA','South Orleans','Barnstable',41.7505,-69.9916),('02663','MA','South Wellfleet','Barnstable',41.898492,-70.000953),('02664','MA','South Yarmouth','Barnstable',41.670623,-70.197612),('02666','MA','Truro','Barnstable',41.992425,-70.048715),('02667','MA','Wellfleet','Barnstable',41.92773,-70.016626),('02668','MA','West Barnstable','Barnstable',41.703156,-70.363259),('02669','MA','West Chatham','Barnstable',41.675028,-69.997511),('02670','MA','West Dennis','Barnstable',41.659964,-70.168718),('02671','MA','West Harwich','Barnstable',41.66825,-70.112822),('02672','MA','West Hyannisport','Barnstable',41.635922,-70.321341),('02673','MA','West Yarmouth','Barnstable',41.655591,-70.244475),('02675','MA','Yarmouth Port','Barnstable',41.70418,-70.226175),('02702','MA','Assonet','Bristol',41.787503,-71.071986),('02703','MA','Attleboro','Bristol',41.928357,-71.313574),('02712','MA','Chartley','Bristol',41.9515,-71.2367),('02713','MA','Cuttyhunk','Dukes',41.430147,-70.898077),('02714','MA','Dartmouth','Bristol',41.5764,-71.0105),('02715','MA','Dighton','Bristol',41.816873,-71.133549),('02717','MA','East Freetown','Bristol',41.765204,-70.961593),('02718','MA','East Taunton','Bristol',41.877532,-71.019847),('02719','MA','Fairhaven','Bristol',41.634945,-70.884708),('02720','MA','Fall River','Bristol',41.718672,-71.137458),('02721','MA','Fall River','Bristol',41.682723,-71.153184),('02722','MA','Fall River','Bristol',41.7011,-71.1548),('02723','MA','Fall River','Bristol',41.694768,-71.132543),('02724','MA','Fall River','Bristol',41.684221,-71.17445),('02725','MA','Somerset','Bristol',41.721211,-71.179463),('02726','MA','Somerset','Bristol',41.754358,-71.147333),('02738','MA','Marion','Plymouth',41.710964,-70.754707),('02739','MA','Mattapoisett','Plymouth',41.660144,-70.807452),('02740','MA','New Bedford','Bristol',41.634339,-70.938606),('02741','MA','New Bedford','Bristol',41.6364,-70.9275),('02742','MA','New Bedford','Bristol',41.6364,-70.9275),('02743','MA','Acushnet','Bristol',41.699304,-70.903748),('02744','MA','New Bedford','Bristol',41.607859,-70.914231),('02745','MA','New Bedford','Bristol',41.690157,-70.935493),('02746','MA','New Bedford','Bristol',41.658737,-70.933231),('02747','MA','North Dartmouth','Bristol',41.647034,-70.994848),('02748','MA','South Dartmouth','Bristol',41.582261,-70.960616),('02760','MA','North Attleboro','Bristol',41.9725,-71.329882),('02761','MA','North Attleboro','Bristol',41.981,-71.3331),('02762','MA','Plainville','Norfolk',42.018572,-71.323396),('02763','MA','Attleboro Falls','Bristol',41.96829,-71.308588),('02764','MA','North Dighton','Bristol',41.851929,-71.153598),('02766','MA','Norton','Bristol',41.969317,-71.182331),('02767','MA','Raynham','Bristol',41.925682,-71.04276),('02768','MA','Raynham Center','Bristol',41.9236,-71.0527),('02769','MA','Rehoboth','Bristol',41.836528,-71.256736),('02770','MA','Rochester','Plymouth',41.759846,-70.838449),('02771','MA','Seekonk','Bristol',41.83865,-71.326418),('02777','MA','Swansea','Bristol',41.749578,-71.212906),('02779','MA','Berkley','Bristol',41.832642,-71.083667),('02780','MA','Taunton','Bristol',41.909418,-71.103402),('02783','MA','Taunton','Bristol',41.9137,-71.1183),('02790','MA','Westport','Bristol',41.599177,-71.082371),('02791','MA','Westport Point','Bristol',41.524421,-71.073601),('02801','RI','Adamsville','Newport',41.5544,-71.1316),('02802','RI','Albion','Providence',41.95213,-71.456233),('02804','RI','Ashaway','Washington',41.430299,-71.780707),('02806','RI','Barrington','Bristol',41.743738,-71.319975),('02807','RI','Block Island','Washington',41.177039,-71.579939),('02808','RI','Bradford','Washington',41.40499,-71.748552),('02809','RI','Bristol','Bristol',41.68392,-71.26854),('02812','RI','Carolina','Washington',41.467204,-71.664217),('02813','RI','Charlestown','Washington',41.386448,-71.666553),('02814','RI','Chepachet','Providence',41.9028,-71.691447),('02815','RI','Clayville','Providence',41.777701,-71.670431),('02816','RI','Coventry','Kent',41.692069,-71.578046),('02817','RI','West Greenwich','Kent',41.628095,-71.657896),('02818','RI','East Greenwich','Kent',41.648273,-71.475423),('02822','RI','Exeter','Washington',41.570862,-71.612434),('02823','RI','Fiskeville','Providence',41.7341,-71.5486),('02824','RI','Forestdale','Providence',41.9944,-71.5638),('02825','RI','Foster','Providence',41.783951,-71.719969),('02826','RI','Glendale','Providence',41.969632,-71.63876),('02827','RI','Greene','Kent',41.704727,-71.728067),('02828','RI','Greenville','Providence',41.872412,-71.553802),('02829','RI','Harmony','Providence',41.8877,-71.5972),('02830','RI','Harrisville','Providence',41.97498,-71.654226),('02831','RI','Hope','Providence',41.739391,-71.574493),('02832','RI','Hope Valley','Washington',41.508931,-71.719097),('02833','RI','Hopkinton','Washington',41.483434,-71.785481),('02835','RI','Jamestown','Newport',41.510088,-71.378366),('02836','RI','Kenyon','Washington',41.448761,-71.621467),('02837','RI','Little Compton','Newport',41.513053,-71.161262),('02838','RI','Manville','Providence',41.968919,-71.476047),('02839','RI','Mapleville','Providence',41.946977,-71.645517),('02840','RI','Newport','Newport',41.487379,-71.313927),('02841','RI','Newport','Newport',41.511847,-71.325321),('02842','RI','Middletown','Newport',41.517542,-71.288052),('02852','RI','North Kingstown','Washington',41.595101,-71.452701),('02854','RI','North Kingstown','Washington',41.5953,-71.456),('02857','RI','North Scituate','Providence',41.838583,-71.627425),('02858','RI','Oakland','Providence',41.960477,-71.649),('02859','RI','Pascoag','Providence',41.965133,-71.73081),('02860','RI','Pawtucket','Providence',41.872004,-71.390061),('02861','RI','Pawtucket','Providence',41.879727,-71.354679),('02862','RI','Pawtucket','Providence',41.88,-71.3856),('02863','RI','Central Falls','Providence',41.88933,-71.392947),('02864','RI','Cumberland','Providence',41.952907,-71.417051),('02865','RI','Lincoln','Providence',41.908492,-71.441516),('02871','RI','Portsmouth','Newport',41.597584,-71.256196),('02872','RI','Prudence Island','Newport',41.612605,-71.316832),('02873','RI','Rockville','Washington',41.524042,-71.765758),('02874','RI','Saunderstown','Washington',41.515307,-71.456544),('02875','RI','Shannock','Washington',41.447586,-71.638317),('02876','RI','Slatersville','Providence',41.997144,-71.584687),('02877','RI','Slocum','Washington',41.5393,-71.5209),('02878','RI','Tiverton','Newport',41.622984,-71.183455),('02879','RI','Wakefield','Washington',41.422314,-71.525382),('02880','RI','Wakefield','Washington',41.4384,-71.4971),('02881','RI','Kingston','Washington',41.47811,-71.526922),('02882','RI','Narragansett','Washington',41.427872,-71.464774),('02883','RI','Peace Dale','Washington',41.4502,-71.4981),('02885','RI','Warren','Bristol',41.726776,-71.270522),('02886','RI','Warwick','Kent',41.708821,-71.456209),('02887','RI','Warwick','Kent',41.7114,-71.4269),('02888','RI','Warwick','Kent',41.7483,-71.410233),('02889','RI','Warwick','Kent',41.708795,-71.391959),('02891','RI','Westerly','Washington',41.35638,-71.805488),('02892','RI','West Kingston','Washington',41.501809,-71.582969),('02893','RI','West Warwick','Kent',41.701367,-71.516758),('02894','RI','Wood River Junction','Washington',41.44435,-71.703406),('02895','RI','Woonsocket','Providence',42.001561,-71.505429),('02896','RI','North Smithfield','Providence',41.982992,-71.54787),('02898','RI','Wyoming','Washington',41.515079,-71.684857),('02901','RI','Providence','Providence',41.8255,-71.4114),('02902','RI','Providence','Providence',41.8255,-71.4114),('02903','RI','Providence','Providence',41.821692,-71.41372),('02904','RI','Providence','Providence',41.857436,-71.429673),('02905','RI','Providence','Providence',41.787011,-71.404819),('02906','RI','Providence','Providence',41.836525,-71.394586),('02907','RI','Providence','Providence',41.798593,-71.42463),('02908','RI','Providence','Providence',41.83808,-71.437978),('02909','RI','Providence','Providence',41.818507,-71.448374),('02910','RI','Cranston','Providence',41.77662,-71.435948),('02911','RI','North Providence','Providence',41.853276,-71.472265),('02912','RI','Providence','Providence',41.82624,-71.402514),('02914','RI','East Providence','Providence',41.813129,-71.369301),('02915','RI','Riverside','Providence',41.770807,-71.353797),('02916','RI','Rumford','Providence',41.843663,-71.354731),('02917','RI','Smithfield','Providence',41.895367,-71.51706),('02918','RI','Providence','Providence',41.8454,-71.4398),('02919','RI','Johnston','Providence',41.82434,-71.499206),('02920','RI','Cranston','Providence',41.770433,-71.465845),('02921','RI','Cranston','Providence',41.764385,-71.505843),('02940','RI','Providence','Providence',41.8238,-71.4133),('03031','NH','Amherst','Hillsborough',42.854863,-71.607933),('03032','NH','Auburn','Rockingham',43.000201,-71.351826),('03033','NH','Brookline','Hillsborough',42.737311,-71.670602),('03034','NH','Candia','Rockingham',43.046618,-71.308079),('03036','NH','Chester','Rockingham',42.967898,-71.236708),('03037','NH','Deerfield','Rockingham',43.139623,-71.233229),('03038','NH','Derry','Rockingham',42.888351,-71.300177),('03040','NH','East Candia','Rockingham',43.0594,-71.2765),('03041','NH','East Derry','Rockingham',42.8947,-71.2979),('03042','NH','Epping','Rockingham',43.042636,-71.074303),('03043','NH','Francestown','Hillsborough',42.987343,-71.812621),('03044','NH','Fremont','Rockingham',42.983583,-71.12451),('03045','NH','Goffstown','Hillsborough',43.015622,-71.560408),('03046','NH','Dunbarton','Merrimack',43.102815,-71.616379),('03047','NH','Greenfield','Hillsborough',42.941843,-71.863035),('03048','NH','Greenville','Hillsborough',42.74692,-71.776617),('03049','NH','Hollis','Hillsborough',42.740256,-71.578967),('03051','NH','Hudson','Hillsborough',42.759754,-71.420583),('03052','NH','Litchfield','Hillsborough',42.849519,-71.454151),('03053','NH','Londonderry','Rockingham',42.879677,-71.376876),('03054','NH','Merrimack','Hillsborough',42.855619,-71.508735),('03055','NH','Milford','Hillsborough',42.834972,-71.667629),('03057','NH','Mont Vernon','Hillsborough',42.894672,-71.676138),('03060','NH','Nashua','Hillsborough',42.746034,-71.461365),('03061','NH','Nashua','Hillsborough',42.7592,-71.4632),('03062','NH','Nashua','Hillsborough',42.726209,-71.491531),('03063','NH','Nashua','Hillsborough',42.773338,-71.513623),('03064','NH','Nashua','Hillsborough',42.773936,-71.472779),('03070','NH','New Boston','Hillsborough',42.98007,-71.692746),('03071','NH','New Ipswich','Hillsborough',42.753773,-71.867128),('03073','NH','North Salem','Rockingham',42.8252,-71.2337),('03076','NH','Pelham','Hillsborough',42.731657,-71.325413),('03077','NH','Raymond','Rockingham',43.030658,-71.196042),('03079','NH','Salem','Rockingham',42.787048,-71.215482),('03082','NH','Lyndeborough','Hillsborough',42.893331,-71.775131),('03084','NH','Temple','Hillsborough',42.827965,-71.847704),('03086','NH','Wilton','Hillsborough',42.835302,-71.769155),('03087','NH','Windham','Rockingham',42.805298,-71.298566),('03101','NH','Manchester','Hillsborough',42.990435,-71.46464),('03102','NH','Manchester','Hillsborough',42.992118,-71.484457),('03103','NH','Manchester','Hillsborough',42.96543,-71.447939),('03104','NH','Manchester','Hillsborough',43.005677,-71.447356),('03105','NH','Manchester','Hillsborough',42.9925,-71.4635),('03106','NH','Hooksett','Merrimack',43.05985,-71.445175),('03107','NH','Manchester','Hillsborough',42.949,-71.4406),('03108','NH','Manchester','Hillsborough',42.949,-71.4406),('03109','NH','Manchester','Hillsborough',42.975181,-71.411777),('03110','NH','Bedford','Hillsborough',42.9428,-71.513737),('03111','NH','Manchester','Hillsborough',42.949,-71.4406),('03215','NH','Waterville Valley','Grafton',43.951095,-71.504685),('03216','NH','Andover','Merrimack',43.441235,-71.797074),('03217','NH','Ashland','Grafton',43.705693,-71.63261),('03218','NH','Barnstead','Belknap',43.335471,-71.288738),('03220','NH','Belmont','Belknap',43.474596,-71.482372),('03221','NH','Bradford','Merrimack',43.258003,-71.960169),('03222','NH','Bristol','Grafton',43.61358,-71.754705),('03223','NH','Campton','Grafton',43.842577,-71.667165),('03224','NH','Canterbury','Merrimack',43.342432,-71.561094),('03225','NH','Center Barnstead','Belknap',43.364618,-71.238834),('03226','NH','Center Harbor','Belknap',43.696517,-71.497192),('03227','NH','Center Sandwich','Carroll',43.80628,-71.44335),('03229','NH','Contoocook','Merrimack',43.203055,-71.707181),('03230','NH','Danbury','Merrimack',43.522805,-71.865673),('03231','NH','East Andover','Merrimack',43.460846,-71.747651),('03233','NH','Elkins','Merrimack',43.423901,-71.931235),('03234','NH','Epsom','Merrimack',43.216579,-71.349288),('03235','NH','Franklin','Merrimack',43.450413,-71.659099),('03237','NH','Gilmanton','Belknap',43.432762,-71.396765),('03238','NH','Glencliff','Grafton',43.987524,-71.898069),('03240','NH','Grafton','Grafton',43.571324,-71.969303),('03241','NH','Hebron','Grafton',43.696816,-71.81294),('03242','NH','Henniker','Merrimack',43.174896,-71.816867),('03243','NH','Hill','Merrimack',43.537005,-71.760073),('03244','NH','Hillsborough','Hillsborough',43.114517,-71.907473),('03245','NH','Holderness','Grafton',43.745844,-71.594625),('03246','NH','Laconia','Belknap',43.550929,-71.467793),('03247','NH','Laconia','Belknap',43.5297,-71.4703),('03249','NH','Gilford','Belknap',43.560576,-71.396777),('03251','NH','Lincoln','Grafton',44.054074,-71.645862),('03252','NH','Lochmere','Belknap',43.4711,-71.5305),('03253','NH','Meredith','Belknap',43.638817,-71.508227),('03254','NH','Moultonborough','Carroll',43.722545,-71.391164),('03255','NH','Newbury','Merrimack',43.310751,-72.02316),('03256','NH','New Hampton','Belknap',43.627395,-71.629475),('03257','NH','New London','Merrimack',43.413113,-71.993018),('03258','NH','Chichester','Merrimack',43.254947,-71.389166),('03259','NH','North Sandwich','Carroll',43.863424,-71.391153),('03260','NH','North Sutton','Merrimack',43.3565,-71.930338),('03261','NH','Northwood','Rockingham',43.213497,-71.205555),('03262','NH','North Woodstock','Grafton',44.022433,-71.693353),('03263','NH','Pittsfield','Merrimack',43.301777,-71.319086),('03264','NH','Plymouth','Grafton',43.746258,-71.689786),('03266','NH','Rumney','Grafton',43.799214,-71.877461),('03268','NH','Salisbury','Merrimack',43.388618,-71.742746),('03269','NH','Sanbornton','Belknap',43.522571,-71.582076),('03272','NH','South Newbury','Merrimack',43.2955,-71.9972),('03273','NH','South Sutton','Merrimack',43.30169,-71.935348),('03274','NH','Stinson Lake','Grafton',43.8611,-71.8088),('03275','NH','Suncook','Merrimack',43.152491,-71.436813),('03276','NH','Tilton','Merrimack',43.448871,-71.575152),('03278','NH','Warner','Merrimack',43.283697,-71.819048),('03279','NH','Warren','Grafton',43.932136,-71.890029),('03280','NH','Washington','Sullivan',43.171265,-72.092955),('03281','NH','Weare','Hillsborough',43.073451,-71.72087),('03282','NH','Wentworth','Grafton',43.858721,-71.923718),('03284','NH','Springfield','Sullivan',43.472066,-72.050548),('03285','NH','Thornton','Grafton',43.912269,-71.654),('03287','NH','Wilmot','Merrimack',43.434969,-71.909274),('03289','NH','Winnisquam','Belknap',43.5001,-71.4966),('03290','NH','Nottingham','Rockingham',43.123335,-71.111547),('03291','NH','West Nottingham','Rockingham',43.178088,-71.143162),('03293','NH','Woodstock','Grafton',43.965615,-71.679466),('03298','NH','Tilton','Belknap',43.6345,-71.5331),('03299','NH','Tilton','Belknap',43.6345,-71.5331),('03301','NH','Concord','Merrimack',43.215568,-71.534807),('03302','NH','Concord','Merrimack',43.3046,-71.6771),('03303','NH','Concord','Merrimack',43.283801,-71.638335),('03304','NH','Bow','Merrimack',43.144608,-71.53566),('03305','NH','Concord','Merrimack',43.2651,-71.4989),('03307','NH','Loudon','Merrimack',43.317387,-71.454917),('03431','NH','Keene','Cheshire',42.944219,-72.288616),('03435','NH','Keene','Cheshire',42.9271,-72.2796),('03440','NH','Antrim','Hillsborough',43.065105,-71.964188),('03441','NH','Ashuelot','Cheshire',42.787572,-72.441332),('03442','NH','Bennington','Hillsborough',43.007653,-71.912061),('03443','NH','Chesterfield','Cheshire',42.886687,-72.465388),('03444','NH','Dublin','Cheshire',42.895786,-72.059867),('03445','NH','Sullivan','Cheshire',43.001056,-72.208681),('03446','NH','Swanzey','Cheshire',42.865173,-72.295778),('03447','NH','Fitzwilliam','Cheshire',42.753411,-72.138904),('03448','NH','Gilsum','Cheshire',43.047514,-72.261616),('03449','NH','Hancock','Hillsborough',42.974638,-71.981783),('03450','NH','Harrisville','Cheshire',42.937564,-72.102498),('03451','NH','Hinsdale','Cheshire',42.794426,-72.502055),('03452','NH','Jaffrey','Cheshire',42.819074,-72.03259),('03455','NH','Marlborough','Cheshire',42.895102,-72.193761),('03456','NH','Marlow','Cheshire',43.11935,-72.205651),('03457','NH','Nelson','Cheshire',42.997993,-72.134053),('03458','NH','Peterborough','Hillsborough',42.877018,-71.949998),('03461','NH','Rindge','Cheshire',42.74777,-72.015232),('03462','NH','Spofford','Cheshire',42.907504,-72.419344),('03464','NH','Stoddard','Cheshire',43.077482,-72.10027),('03465','NH','Troy','Cheshire',42.826481,-72.183922),('03466','NH','West Chesterfield','Cheshire',42.901146,-72.519823),('03467','NH','Westmoreland','Cheshire',42.971825,-72.441925),('03468','NH','West Peterborough','Hillsborough',42.8872,-71.9858),('03469','NH','West Swanzey','Cheshire',42.8583,-72.325),('03470','NH','Winchester','Cheshire',42.780462,-72.344474),('03561','NH','Littleton','Grafton',44.311845,-71.813477),('03570','NH','Berlin','Coos',44.484816,-71.170782),('03574','NH','Bethlehem','Grafton',44.285488,-71.666027),('03575','NH','Bretton Woods','Coos',44.259405,-71.440316),('03576','NH','Colebrook','Coos',44.908815,-71.416821),('03579','NH','Errol','Coos',44.940682,-71.017678),('03580','NH','Franconia','Grafton',44.194604,-71.753709),('03581','NH','Gorham','Coos',44.384615,-71.170005),('03582','NH','Groveton','Coos',44.607048,-71.460954),('03583','NH','Jefferson','Coos',44.394186,-71.473626),('03584','NH','Lancaster','Coos',44.485823,-71.554291),('03585','NH','Lisbon','Grafton',44.225766,-71.895196),('03586','NH','Sugar Hill','Grafton',44.230083,-71.795274),('03588','NH','Milan','Coos',44.609422,-71.225886),('03589','NH','Mount Washington','Coos',44.2787,-71.2994),('03590','NH','North Stratford','Coos',44.707182,-71.550778),('03592','NH','Pittsburg','Coos',45.098072,-71.292693),('03593','NH','Randolph','Coos',44.369727,-71.305887),('03595','NH','Twin Mountain','Coos',44.285115,-71.547252),('03597','NH','West Stewartstown','Coos',44.783108,-71.428289),('03598','NH','Whitefield','Coos',44.38466,-71.624619),('03601','NH','Acworth','Sullivan',43.236967,-72.288446),('03602','NH','Alstead','Cheshire',43.143171,-72.3277),('03603','NH','Charlestown','Sullivan',43.252311,-72.400918),('03604','NH','Drewsville','Cheshire',43.131249,-72.389954),('03605','NH','Lempster','Sullivan',43.23673,-72.184205),('03607','NH','South Acworth','Sullivan',43.191564,-72.272901),('03608','NH','Walpole','Cheshire',43.078303,-72.420455),('03609','NH','North Walpole','Cheshire',43.141835,-72.445825),('03740','NH','Bath','Grafton',44.160828,-71.972421),('03741','NH','Canaan','Grafton',43.676287,-72.040505),('03743','NH','Claremont','Sullivan',43.373713,-72.345258),('03745','NH','Cornish','Sullivan',43.476331,-72.334115),('03746','NH','Cornish Flat','Sullivan',43.486833,-72.259217),('03748','NH','Enfield','Grafton',43.603314,-72.118598),('03749','NH','Enfield Center','Grafton',43.59,-72.1113),('03750','NH','Etna','Grafton',43.699654,-72.208461),('03751','NH','Georges Mills','Sullivan',43.441328,-72.069961),('03752','NH','Goshen','Sullivan',43.301388,-72.136443),('03753','NH','Grantham','Sullivan',43.515595,-72.135915),('03754','NH','Guild','Sullivan',43.3766,-72.1386),('03755','NH','Hanover','Grafton',43.71694,-72.252373),('03756','NH','Lebanon','Grafton',43.6767,-72.2728),('03765','NH','Haverhill','Grafton',44.035227,-72.050204),('03766','NH','Lebanon','Grafton',43.639977,-72.238858),('03768','NH','Lyme','Grafton',43.818562,-72.136887),('03769','NH','Lyme Center','Grafton',43.7991,-72.1233),('03770','NH','Meriden','Sullivan',43.531639,-72.270714),('03771','NH','Monroe','Grafton',44.282551,-72.028094),('03773','NH','Newport','Sullivan',43.374005,-72.186162),('03774','NH','North Haverhill','Grafton',44.091874,-72.007478),('03777','NH','Orford','Grafton',43.899934,-72.094948),('03779','NH','Piermont','Grafton',43.976466,-72.044233),('03780','NH','Pike','Grafton',44.027726,-71.976891),('03781','NH','Plainfield','Sullivan',43.560058,-72.299358),('03782','NH','Sunapee','Sullivan',43.385733,-72.095353),('03784','NH','West Lebanon','Grafton',43.643669,-72.305089),('03785','NH','Woodsville','Grafton',44.117011,-71.954669),('03801','NH','Portsmouth','Rockingham',43.072918,-70.780939),('03802','NH','Portsmouth','Rockingham',43.0774,-70.7563),('03803','NH','Portsmouth','Rockingham',43.0326,-70.7961),('03804','NH','Portsmouth','Rockingham',43.1135,-70.7369),('03805','NH','Newington','Strafford',43.2359,-70.8213),('03809','NH','Alton','Belknap',43.469908,-71.222552),('03810','NH','Alton Bay','Belknap',43.502494,-71.260508),('03811','NH','Atkinson','Rockingham',42.841612,-71.162904),('03812','NH','Bartlett','Carroll',44.082552,-71.287081),('03813','NH','Center Conway','Carroll',44.035048,-71.033344),('03814','NH','Center Ossipee','Carroll',43.775992,-71.156746),('03815','NH','Center Strafford','Strafford',43.256254,-71.103172),('03816','NH','Center Tuftonboro','Carroll',43.676082,-71.247543),('03817','NH','Chocorua','Carroll',43.878021,-71.220328),('03818','NH','Conway','Carroll',43.988869,-71.167127),('03819','NH','Danville','Rockingham',42.923684,-71.122652),('03820','NH','Dover','Strafford',43.188956,-70.878338),('03821','NH','Dover','Strafford',43.1946,-70.8772),('03822','NH','Dover','Strafford',43.1946,-70.8772),('03823','NH','Madbury','Strafford',43.16532,-70.931392),('03824','NH','Durham','Strafford',43.126723,-70.925238),('03825','NH','Barrington','Strafford',43.215597,-71.039512),('03826','NH','East Hampstead','Rockingham',42.887532,-71.13191),('03827','NH','East Kingston','Rockingham',42.904015,-70.995943),('03830','NH','East Wakefield','Carroll',43.64081,-70.9874),('03832','NH','Eaton Center','Carroll',43.912849,-71.056929),('03833','NH','Exeter','Rockingham',42.977498,-70.976879),('03835','NH','Farmington','Strafford',43.376867,-71.065098),('03836','NH','Freedom','Carroll',43.809699,-71.091652),('03837','NH','Gilmanton Iron Works','Belknap',43.422611,-71.325259),('03838','NH','Glen','Carroll',44.10376,-71.195218),('03839','NH','Rochester','Strafford',43.268781,-70.985498),('03840','NH','Greenland','Rockingham',43.035457,-70.844044),('03841','NH','Hampstead','Rockingham',42.881865,-71.182359),('03842','NH','Hampton','Rockingham',42.937549,-70.828692),('03843','NH','Hampton','Rockingham',42.9357,-70.8399),('03844','NH','Hampton Falls','Rockingham',42.920263,-70.881207),('03845','NH','Intervale','Carroll',44.104576,-71.144524),('03846','NH','Jackson','Carroll',44.16727,-71.182435),('03847','NH','Kearsarge','Carroll',44.066294,-71.117796),('03848','NH','Kingston','Rockingham',42.916461,-71.056781),('03849','NH','Madison','Carroll',43.911872,-71.141939),('03850','NH','Melvin Village','Carroll',43.688136,-71.303181),('03851','NH','Milton','Strafford',43.431102,-71.00581),('03852','NH','Milton Mills','Strafford',43.500162,-70.969811),('03853','NH','Mirror Lake','Carroll',43.642125,-71.279241),('03854','NH','New Castle','Rockingham',43.064512,-70.722144),('03855','NH','New Durham','Strafford',43.463672,-71.152216),('03856','NH','Newfields','Rockingham',43.039859,-70.9565),('03857','NH','Newmarket','Rockingham',43.073343,-70.942711),('03858','NH','Newton','Rockingham',42.870369,-71.045914),('03859','NH','Newton Junction','Rockingham',42.8672,-71.0663),('03860','NH','North Conway','Carroll',44.042664,-71.125471),('03861','NH','Lee','Strafford',43.124382,-71.006844),('03862','NH','North Hampton','Rockingham',42.979955,-70.829447),('03864','NH','Ossipee','Carroll',43.690633,-71.11526),('03865','NH','Plaistow','Rockingham',42.835847,-71.095647),('03866','NH','Rochester','Strafford',43.3086,-70.9739),('03867','NH','Rochester','Strafford',43.302512,-70.975319),('03868','NH','Rochester','Strafford',43.333729,-70.952368),('03869','NH','Rollinsford','Strafford',43.221318,-70.834009),('03870','NH','Rye','Rockingham',43.008649,-70.75833),('03871','NH','Rye Beach','Rockingham',42.980525,-70.771552),('03872','NH','Sanbornville','Carroll',43.577911,-71.034783),('03873','NH','Sandown','Rockingham',42.929858,-71.184505),('03874','NH','Seabrook','Rockingham',42.884628,-70.854495),('03875','NH','Silver Lake','Carroll',43.872535,-71.182347),('03878','NH','Somersworth','Strafford',43.251357,-70.875675),('03882','NH','Effingham','Carroll',43.752019,-71.048317),('03883','NH','South Tamworth','Carroll',43.827398,-71.333906),('03884','NH','Strafford','Strafford',43.261752,-71.139976),('03885','NH','Stratham','Rockingham',43.014992,-70.902609),('03886','NH','Tamworth','Carroll',43.853963,-71.262368),('03887','NH','Union','Strafford',43.477791,-71.056761),('03890','NH','West Ossipee','Carroll',43.821056,-71.200556),('03894','NH','Wolfeboro','Carroll',43.598267,-71.193701),('03896','NH','Wolfeboro Falls','Carroll',43.5985,-71.1982),('03897','NH','Wonalancet','Carroll',43.908738,-71.345072),('03901','ME','Berwick','York',43.289513,-70.843593),('03902','ME','Cape Neddick','York',43.214914,-70.628804),('03903','ME','Eliot','York',43.146142,-70.792873),('03904','ME','Kittery','York',43.1019,-70.736084),('03905','ME','Kittery Point','York',43.079506,-70.688165),('03906','ME','North Berwick','York',43.327111,-70.764698),('03907','ME','Ogunquit','York',43.249759,-70.598563),('03908','ME','South Berwick','York',43.234266,-70.778883),('03909','ME','York','York',43.159243,-70.652739),('03910','ME','York Beach','York',43.173362,-70.610011),('03911','ME','York Harbor','York',43.133492,-70.633377),('04001','ME','Acton','York',43.534467,-70.916119),('04002','ME','Alfred','York',43.495781,-70.687966),('04003','ME','Bailey Island','Cumberland',43.724932,-69.995651),('04004','ME','Bar Mills','York',43.613,-70.5502),('04005','ME','Biddeford','York',43.488985,-70.47296),('04006','ME','Biddeford Pool','York',43.444713,-70.344381),('04007','ME','Biddeford','York',43.4901,-70.4576),('04008','ME','Bowdoinham','Sagadahoc',44.024232,-69.884392),('04009','ME','Bridgton','Cumberland',44.061289,-70.730279),('04010','ME','Brownfield','Oxford',43.937231,-70.906755),('04011','ME','Brunswick','Cumberland',43.90068,-69.954055),('04013','ME','Bustins Island','Cumberland',43.7987,-70.0737),('04014','ME','Cape Porpoise','York',43.3725,-70.4386),('04015','ME','Casco','Cumberland',43.950537,-70.525499),('04016','ME','Center Lovell','Oxford',44.1634,-70.8783),('04017','ME','Chebeague Island','Cumberland',43.728677,-70.110465),('04019','ME','Cliff Island','Cumberland',43.695054,-70.107791),('04020','ME','Cornish','York',43.767187,-70.808862),('04021','ME','Cumberland Center','Cumberland',43.801078,-70.258304),('04022','ME','Denmark','Oxford',43.98353,-70.805395),('04024','ME','East Baldwin','Cumberland',43.824218,-70.682548),('04027','ME','Lebanon','York',43.404441,-70.908988),('04028','ME','East Parsonsfield','York',43.7335,-70.8481),('04029','ME','Sebago','Cumberland',43.888113,-70.677686),('04030','ME','East Waterboro','York',43.589062,-70.696274),('04032','ME','Freeport','Cumberland',43.846449,-70.102622),('04033','ME','Freeport','Cumberland',43.8587,-70.1023),('04034','ME','Freeport','Cumberland',43.8591,-70.1009),('04037','ME','Fryeburg','Oxford',44.063167,-70.947473),('04038','ME','Gorham','Cumberland',43.701803,-70.455333),('04039','ME','Gray','Cumberland',43.889047,-70.336604),('04040','ME','Harrison','Cumberland',44.124512,-70.740789),('04041','ME','Hiram','Oxford',43.871668,-70.833895),('04042','ME','Hollis Center','York',43.629978,-70.615295),('04043','ME','Kennebunk','York',43.385509,-70.547262),('04046','ME','Kennebunkport','York',43.399916,-70.474713),('04047','ME','Parsonsfield','York',43.749564,-70.893583),('04048','ME','Limerick','York',43.686013,-70.76737),('04049','ME','Limington','York',43.735844,-70.695775),('04050','ME','Long Island','Cumberland',43.69116,-70.15313),('04051','ME','Lovell','Oxford',44.170262,-70.892785),('04054','ME','Moody','York',43.275,-70.5975),('04055','ME','Naples','Cumberland',43.958616,-70.605066),('04056','ME','Newfield','York',43.654323,-70.852673),('04057','ME','North Bridgton','Cumberland',44.100342,-70.700116),('04061','ME','North Waterboro','York',43.645533,-70.728128),('04062','ME','Windham','Cumberland',43.810553,-70.416933),('04063','ME','Ocean Park','York',43.502276,-70.388613),('04064','ME','Old Orchard Beach','York',43.515532,-70.386454),('04066','ME','Orrs Island','Cumberland',43.769148,-69.965439),('04068','ME','Porter','Oxford',43.827572,-70.9291),('04069','ME','Pownal','Cumberland',43.908304,-70.181691),('04070','ME','Scarborough','Cumberland',43.578,-70.3222),('04071','ME','Raymond','Cumberland',43.909792,-70.471998),('04072','ME','Saco','York',43.521038,-70.443848),('04073','ME','Sanford','York',43.425204,-70.750126),('04074','ME','Scarborough','Cumberland',43.586711,-70.352824),('04075','ME','Sebago Lake','Cumberland',43.8593,-70.633),('04076','ME','Shapleigh','York',43.553047,-70.847645),('04077','ME','South Casco','Cumberland',43.8426,-70.5239),('04078','ME','South Freeport','Cumberland',43.8617,-70.1052),('04079','ME','Harpswell','Cumberland',43.797224,-69.952115),('04082','ME','South Windham','Cumberland',43.7404,-70.4259),('04083','ME','Springvale','York',43.465575,-70.801965),('04084','ME','Standish','Cumberland',43.762149,-70.566687),('04085','ME','Steep Falls','Cumberland',43.771642,-70.638201),('04086','ME','Topsham','Sagadahoc',43.944477,-69.96459),('04087','ME','Waterboro','York',43.545349,-70.741427),('04088','ME','Waterford','Oxford',44.192238,-70.707961),('04090','ME','Wells','York',43.319139,-70.610441),('04091','ME','West Baldwin','Cumberland',43.824016,-70.751923),('04092','ME','Westbrook','Cumberland',43.681224,-70.357619),('04093','ME','Buxton','York',43.649411,-70.541348),('04094','ME','West Kennebunk','York',43.4086,-70.5819),('04095','ME','West Newfield','York',43.634355,-70.9372),('04096','ME','Yarmouth','Cumberland',43.796515,-70.177449),('04097','ME','North Yarmouth','Cumberland',43.846055,-70.227956),('04098','ME','Westbrook','Cumberland',43.6765,-70.3631),('04101','ME','Portland','Cumberland',43.661318,-70.259315),('04102','ME','Portland','Cumberland',43.660696,-70.296482),('04103','ME','Portland','Cumberland',43.684629,-70.286812),('04104','ME','Portland','Cumberland',43.6582,-70.2671),('04105','ME','Falmouth','Cumberland',43.73561,-70.26592),('04106','ME','South Portland','Cumberland',43.634347,-70.278417),('04107','ME','Cape Elizabeth','Cumberland',43.597987,-70.231256),('04108','ME','Peaks Island','Cumberland',43.657829,-70.190105),('04109','ME','Portland','Cumberland',43.673467,-70.201437),('04110','ME','Cumberland Foreside','Cumberland',43.765454,-70.197704),('04112','ME','Portland','Cumberland',43.6613,-70.2558),('04116','ME','South Portland','Cumberland',43.6367,-70.2508),('04122','ME','Portland','Cumberland',43.6582,-70.2671),('04123','ME','Portland','Cumberland',43.6582,-70.2671),('04124','ME','Portland','Cumberland',43.6582,-70.2671),('04210','ME','Auburn','Androscoggin',44.087028,-70.244546),('04211','ME','Auburn','Androscoggin',44.0763,-70.2566),('04212','ME','Auburn','Androscoggin',44.0986,-70.2266),('04216','ME','Andover','Oxford',44.692147,-70.795866),('04217','ME','Bethel','Oxford',44.378426,-70.81615),('04219','ME','Bryant Pond','Oxford',44.41622,-70.615412),('04220','ME','Buckfield','Oxford',44.32149,-70.353118),('04221','ME','Canton','Oxford',44.451303,-70.305931),('04222','ME','Durham','Androscoggin',43.970287,-70.12711),('04223','ME','Danville','Androscoggin',44.0225,-70.2647),('04224','ME','Dixfield','Oxford',44.559953,-70.415749),('04225','ME','Dryden','Franklin',44.5897,-70.2115),('04226','ME','East Andover','Oxford',44.616584,-70.701607),('04227','ME','East Dixfield','Oxford',44.568622,-70.294759),('04228','ME','East Livermore','Androscoggin',44.426496,-70.11313),('04230','ME','East Poland','Androscoggin',44.0701,-70.3289),('04231','ME','Stoneham','Oxford',44.25969,-70.846329),('04234','ME','East Wilton','Franklin',44.617502,-70.191892),('04236','ME','Greene','Androscoggin',44.189754,-70.145089),('04237','ME','Hanover','Oxford',44.494494,-70.73444),('04238','ME','Hebron','Oxford',44.211101,-70.375129),('04239','ME','Jay','Franklin',44.51685,-70.218378),('04240','ME','Lewiston','Androscoggin',44.095208,-70.19374),('04241','ME','Lewiston','Androscoggin',44.0965,-70.2162),('04243','ME','Lewiston','Androscoggin',44.0965,-70.2162),('04250','ME','Lisbon','Androscoggin',44.027756,-70.110647),('04252','ME','Lisbon Falls','Androscoggin',44.010502,-70.057131),('04253','ME','Livermore','Androscoggin',44.403893,-70.215666),('04254','ME','Livermore Falls','Androscoggin',44.448384,-70.162491),('04255','ME','Greenwood','Oxford',44.359309,-70.672095),('04256','ME','Mechanic Falls','Androscoggin',44.10872,-70.398099),('04257','ME','Mexico','Oxford',44.557527,-70.535743),('04258','ME','Minot','Androscoggin',44.13794,-70.336334),('04259','ME','Monmouth','Kennebec',44.231815,-69.998713),('04260','ME','New Gloucester','Cumberland',43.967885,-70.304378),('04261','ME','Newry','Oxford',44.57112,-70.889963),('04262','ME','North Jay','Franklin',44.5472,-70.2386),('04263','ME','Leeds','Androscoggin',44.303875,-70.135864),('04265','ME','North Monmouth','Kennebec',44.280563,-70.037314),('04266','ME','North Turner','Androscoggin',44.3434,-70.2679),('04267','ME','North Waterford','Oxford',44.210127,-70.800783),('04268','ME','Norway','Oxford',44.226141,-70.57208),('04270','ME','Oxford','Oxford',44.118187,-70.504484),('04271','ME','Paris','Oxford',44.2597,-70.5011),('04274','ME','Poland','Androscoggin',44.052026,-70.386507),('04275','ME','Roxbury','Oxford',44.707073,-70.625203),('04276','ME','Rumford','Oxford',44.535574,-70.566714),('04280','ME','Sabattus','Androscoggin',44.129365,-70.078691),('04281','ME','South Paris','Oxford',44.228889,-70.509101),('04282','ME','Turner','Androscoggin',44.265107,-70.24798),('04284','ME','Wayne','Kennebec',44.350415,-70.05476),('04285','ME','Weld','Franklin',44.695997,-70.433821),('04286','ME','West Bethel','Oxford',44.403191,-70.860193),('04287','ME','Bowdoin','Sagadahoc',44.055698,-69.953711),('04288','ME','West Minot','Androscoggin',44.1711,-70.3663),('04289','ME','West Paris','Oxford',44.332096,-70.54123),('04290','ME','Peru','Oxford',44.497821,-70.424181),('04291','ME','West Poland','Androscoggin',44.0568,-70.4585),('04292','ME','Sumner','Oxford',44.361074,-70.450171),('04294','ME','Wilton','Franklin',44.602508,-70.229031),('04330','ME','Augusta','Kennebec',44.335893,-69.760476),('04332','ME','Augusta','Kennebec',44.3111,-69.7843),('04333','ME','Augusta','Kennebec',44.3071,-69.7836),('04336','ME','Augusta','Kennebec',44.3111,-69.7843),('04338','ME','Augusta','Kennebec',44.3111,-69.7843),('04341','ME','Coopers Mills','Lincoln',44.3264,-69.4337),('04342','ME','Dresden','Lincoln',44.083996,-69.743082),('04343','ME','East Winthrop','Kennebec',44.329687,-69.891507),('04344','ME','Farmingdale','Kennebec',44.254639,-69.803348),('04345','ME','Gardiner','Kennebec',44.210817,-69.810158),('04346','ME','Randolph','Kennebec',44.234064,-69.758152),('04347','ME','Hallowell','Kennebec',44.287046,-69.801518),('04348','ME','Jefferson','Lincoln',44.219129,-69.492414),('04349','ME','Kents Hill','Kennebec',44.434007,-70.067034),('04350','ME','Litchfield','Kennebec',44.172144,-69.9345),('04351','ME','Manchester','Kennebec',44.317032,-69.868439),('04352','ME','Mount Vernon','Kennebec',44.466489,-69.96045),('04353','ME','Whitefield','Lincoln',44.21005,-69.604385),('04354','ME','Palermo','Waldo',44.384425,-69.414427),('04355','ME','Readfield','Kennebec',44.378154,-69.957015),('04357','ME','Richmond','Sagadahoc',44.116836,-69.829592),('04358','ME','South China','Kennebec',44.412738,-69.544552),('04359','ME','South Gardiner','Kennebec',44.183452,-69.757644),('04360','ME','Vienna','Kennebec',44.55484,-69.999631),('04363','ME','Windsor','Kennebec',44.301443,-69.573514),('04364','ME','Winthrop','Kennebec',44.309991,-69.963093),('04401','ME','Bangor','Penobscot',44.818609,-68.798465),('04402','ME','Bangor','Penobscot',44.8048,-68.7739),('04406','ME','Abbot','Piscataquis',45.22187,-69.535847),('04408','ME','Aurora','Hancock',44.96034,-68.250062),('04410','ME','Bradford','Penobscot',45.087447,-68.909662),('04411','ME','Bradley','Penobscot',44.882502,-68.629268),('04412','ME','Brewer','Penobscot',44.78698,-68.754755),('04413','ME','Brookton','Washington',45.571539,-67.742719),('04414','ME','Brownville','Piscataquis',45.369252,-69.036989),('04415','ME','Brownville Junction','Piscataquis',45.363623,-69.067163),('04416','ME','Bucksport','Hancock',44.614713,-68.761596),('04417','ME','Burlington','Penobscot',45.212629,-68.390322),('04418','ME','Greenbush','Penobscot',45.070838,-68.542397),('04419','ME','Carmel','Penobscot',44.799763,-69.041156),('04420','ME','Castine','Hancock',44.4675,-68.7192),('04421','ME','Castine','Hancock',44.400075,-68.804016),('04422','ME','Charleston','Penobscot',45.069132,-69.035051),('04424','ME','Danforth','Washington',45.68954,-67.858265),('04426','ME','Dover Foxcroft','Piscataquis',45.202648,-69.200717),('04427','ME','Corinth','Penobscot',44.979501,-69.006625),('04428','ME','Eddington','Penobscot',44.803009,-68.56095),('04429','ME','Holden','Penobscot',44.712144,-68.614672),('04430','ME','East Millinocket','Penobscot',45.629699,-68.579208),('04431','ME','East Orland','Hancock',44.564166,-68.666972),('04434','ME','Etna','Penobscot',44.804623,-69.129815),('04435','ME','Exeter','Penobscot',44.963218,-69.124994),('04438','ME','Frankfort','Waldo',44.611764,-68.921331),('04441','ME','Greenville','Piscataquis',45.617191,-69.523265),('04442','ME','Greenville Junction','Piscataquis',45.502509,-69.672385),('04443','ME','Guilford','Piscataquis',45.207458,-69.4041),('04444','ME','Hampden','Penobscot',44.740164,-68.900311),('04448','ME','Howland','Penobscot',45.305601,-68.697935),('04449','ME','Hudson','Penobscot',45.000211,-68.883249),('04450','ME','Kenduskeag','Penobscot',44.921127,-68.931079),('04451','ME','Kingman','Penobscot',45.619736,-68.234074),('04453','ME','Lagrange','Penobscot',45.165802,-68.787934),('04454','ME','Lambert Lake','Washington',45.54117,-67.53647),('04455','ME','Lee','Penobscot',45.34125,-68.287915),('04456','ME','Levant','Penobscot',44.876807,-68.996649),('04457','ME','Lincoln','Penobscot',45.375694,-68.498684),('04459','ME','Mattawamkeag','Penobscot',45.568863,-68.338717),('04460','ME','Medway','Penobscot',45.641892,-68.524368),('04461','ME','Milford','Penobscot',44.957325,-68.606924),('04462','ME','Millinocket','Penobscot',45.762923,-68.830401),('04463','ME','Milo','Piscataquis',45.254178,-68.934194),('04464','ME','Monson','Piscataquis',45.352833,-69.462674),('04467','ME','Olamon','Penobscot',45.1208,-68.6111),('04468','ME','Old Town','Penobscot',44.972207,-68.687978),('04469','ME','Orono','Penobscot',44.901092,-68.669682),('04471','ME','Orient','Aroostook',45.867473,-67.844568),('04472','ME','Orland','Hancock',44.572016,-68.69149),('04473','ME','Orono','Penobscot',44.887582,-68.683603),('04474','ME','Orrington','Penobscot',44.722123,-68.789155),('04475','ME','Passadumkeag','Penobscot',45.184082,-68.595944),('04476','ME','Penobscot','Hancock',44.466643,-68.720046),('04478','ME','Rockwood','Somerset',45.776919,-69.824747),('04479','ME','Sangerville','Piscataquis',45.126471,-69.32317),('04481','ME','Sebec','Piscataquis',45.242677,-69.106993),('04485','ME','Shirley Mills','Piscataquis',45.358461,-69.624361),('04487','ME','Springfield','Penobscot',45.360103,-68.081188),('04488','ME','Stetson','Penobscot',44.871642,-69.11391),('04489','ME','Stillwater','Penobscot',44.90954,-68.686531),('04490','ME','Topsfield','Washington',45.405283,-67.81105),('04491','ME','Vanceboro','Washington',45.55811,-67.437955),('04492','ME','Waite','Washington',45.362261,-67.687732),('04493','ME','West Enfield','Penobscot',45.237391,-68.540802),('04495','ME','Winn','Penobscot',45.47494,-68.33804),('04496','ME','Winterport','Waldo',44.654548,-68.881609),('04497','ME','Wytopitlock','Aroostook',45.75461,-68.060944),('04530','ME','Bath','Sagadahoc',43.902347,-69.828201),('04535','ME','Alna','Lincoln',44.084704,-69.627722),('04537','ME','Boothbay','Lincoln',43.884692,-69.633453),('04538','ME','Boothbay Harbor','Lincoln',43.854828,-69.625674),('04539','ME','Bristol','Lincoln',43.973542,-69.501972),('04541','ME','Chamberlain','Lincoln',43.889124,-69.479),('04543','ME','Damariscotta','Lincoln',44.036183,-69.50318),('04544','ME','East Boothbay','Lincoln',43.836493,-69.586862),('04547','ME','Friendship','Knox',43.981178,-69.332859),('04548','ME','Georgetown','Sagadahoc',43.808989,-69.744463),('04549','ME','Isle Of Springs','Lincoln',43.8619,-69.6815),('04551','ME','Bremen','Lincoln',44.015105,-69.434438),('04553','ME','Newcastle','Lincoln',44.042579,-69.571925),('04554','ME','New Harbor','Lincoln',43.85842,-69.50676),('04555','ME','Nobleboro','Lincoln',44.097994,-69.476628),('04556','ME','Edgecomb','Lincoln',43.97357,-69.63324),('04558','ME','Pemaquid','Lincoln',43.889855,-69.518394),('04562','ME','Phippsburg','Sagadahoc',43.775708,-69.834074),('04563','ME','Cushing','Knox',44.002317,-69.265921),('04564','ME','Round Pond','Lincoln',43.938518,-69.455743),('04565','ME','Sebasco Estates','Sagadahoc',43.7895,-69.8639),('04568','ME','South Bristol','Lincoln',43.871798,-69.558277),('04570','ME','Squirrel Island','Lincoln',43.8081,-69.6319),('04571','ME','Trevett','Lincoln',43.896655,-69.674169),('04572','ME','Waldoboro','Lincoln',44.106067,-69.372572),('04573','ME','Walpole','Lincoln',43.94732,-69.554629),('04574','ME','Washington','Knox',44.260617,-69.391542),('04575','ME','West Boothbay Harbor','Lincoln',43.846878,-69.652534),('04576','ME','Southport','Lincoln',43.813337,-69.66287),('04578','ME','Wiscasset','Lincoln',43.983576,-69.683484),('04579','ME','Woolwich','Sagadahoc',43.956827,-69.768813),('04605','ME','Ellsworth','Hancock',44.620104,-68.41275),('04606','ME','Addison','Washington',44.54968,-67.697222),('04607','ME','Gouldsboro','Hancock',44.470014,-68.072394),('04609','ME','Bar Harbor','Hancock',44.390169,-68.25001),('04611','ME','Beals','Washington',44.491648,-67.600143),('04612','ME','Bernard','Hancock',44.250887,-68.367204),('04613','ME','Birch Harbor','Hancock',44.37136,-68.033723),('04614','ME','Blue Hill','Hancock',44.412922,-68.576197),('04616','ME','Brooklin','Hancock',44.272118,-68.561148),('04617','ME','Brooksville','Hancock',44.352307,-68.726208),('04619','ME','Calais','Washington',45.165574,-67.245952),('04622','ME','Cherryfield','Washington',44.726319,-67.954754),('04623','ME','Columbia Falls','Washington',44.705628,-67.775345),('04624','ME','Corea','Hancock',44.408561,-67.984239),('04625','ME','Cranberry Isles','Hancock',44.270633,-68.258933),('04626','ME','Cutler','Washington',44.669855,-67.245887),('04627','ME','Deer Isle','Hancock',44.21883,-68.659573),('04628','ME','Dennysville','Washington',44.871091,-67.260307),('04629','ME','East Blue Hill','Hancock',44.414731,-68.511389),('04630','ME','East Machias','Washington',44.805947,-67.448749),('04631','ME','Eastport','Washington',44.913667,-67.002848),('04634','ME','Franklin','Hancock',44.641053,-68.238333),('04635','ME','Frenchboro','Hancock',44.156504,-68.339265),('04637','ME','Grand Lake Stream','Washington',45.196956,-67.777306),('04640','ME','Hancock','Hancock',44.53749,-68.299152),('04642','ME','Harborside','Hancock',44.327298,-68.80698),('04643','ME','Harrington','Washington',44.578019,-67.811129),('04644','ME','Hulls Cove','Hancock',44.413835,-68.252076),('04645','ME','Isle Au Haut','Knox',44.060741,-68.617307),('04646','ME','Islesford','Hancock',44.261083,-68.231248),('04648','ME','Jonesboro','Washington',44.665504,-67.59497),('04649','ME','Jonesport','Washington',44.550428,-67.5784),('04650','ME','Little Deer Isle','Hancock',44.282849,-68.704579),('04652','ME','Lubec','Washington',44.820637,-67.049986),('04653','ME','Bass Harbor','Hancock',44.230014,-68.339217),('04654','ME','Machias','Washington',44.744587,-67.534547),('04655','ME','Machiasport','Washington',44.645301,-67.384558),('04657','ME','Meddybemps','Washington',44.984075,-67.412481),('04658','ME','Milbridge','Washington',44.50791,-67.878004),('04660','ME','Mount Desert','Hancock',44.340367,-68.321995),('04662','ME','Northeast Harbor','Hancock',44.295602,-68.292944),('04664','ME','Sullivan','Hancock',44.534889,-68.153448),('04666','ME','Pembroke','Washington',44.974327,-67.191096),('04667','ME','Perry','Washington',44.973238,-67.079228),('04668','ME','Princeton','Washington',45.212926,-67.585966),('04669','ME','Prospect Harbor','Hancock',44.413701,-68.011481),('04671','ME','Robbinston','Washington',45.075981,-67.140669),('04672','ME','Salsbury Cove','Hancock',44.430435,-68.284909),('04673','ME','Sargentville','Hancock',44.307504,-68.680298),('04674','ME','Seal Cove','Hancock',44.298621,-68.410616),('04675','ME','Seal Harbor','Hancock',44.301319,-68.251151),('04676','ME','Sedgwick','Hancock',44.335072,-68.660264),('04677','ME','Sorrento','Hancock',44.486052,-68.184127),('04679','ME','Southwest Harbor','Hancock',44.277324,-68.32506),('04680','ME','Steuben','Washington',44.510075,-67.947981),('04681','ME','Stonington','Hancock',44.161375,-68.653317),('04683','ME','Sunset','Hancock',44.24497,-68.756044),('04684','ME','Surry','Hancock',44.494802,-68.524782),('04685','ME','Swans Island','Hancock',44.162533,-68.450555),('04686','ME','Wesley','Washington',44.960523,-67.694488),('04691','ME','Whiting','Washington',44.760322,-67.255047),('04693','ME','Winter Harbor','Hancock',44.376372,-68.093638),('04694','ME','Baileyville','Washington',45.120663,-67.441971),('04730','ME','Houlton','Aroostook',46.133021,-67.86631),('04732','ME','Ashland','Aroostook',46.583942,-68.547438),('04733','ME','Benedicta','Aroostook',45.798418,-68.385281),('04734','ME','Blaine','Aroostook',46.48836,-67.877881),('04735','ME','Bridgewater','Aroostook',46.430522,-67.843104),('04736','ME','Caribou','Aroostook',46.879126,-68.011482),('04737','ME','Clayton Lake','Aroostook',46.6192,-69.5315),('04738','ME','Crouseville','Aroostook',46.755,-68.0969),('04739','ME','Eagle Lake','Aroostook',47.012135,-68.600955),('04740','ME','Easton','Aroostook',46.649588,-67.862),('04741','ME','Estcourt Station','Aroostook',47.3975,-69.2186),('04742','ME','Fort Fairfield','Aroostook',46.770382,-67.848325),('04743','ME','Fort Kent','Aroostook',47.219717,-68.592945),('04744','ME','Fort Kent Mills','Aroostook',47.2388,-68.5844),('04745','ME','Frenchville','Aroostook',47.28134,-68.393121),('04746','ME','Grand Isle','Aroostook',47.279624,-68.117741),('04747','ME','Island Falls','Aroostook',46.01111,-68.258157),('04750','ME','Limestone','Aroostook',46.938803,-67.861691),('04751','ME','Limestone','Aroostook',46.941,-67.9042),('04756','ME','Madawaska','Aroostook',47.348631,-68.322318),('04757','ME','Mapleton','Aroostook',46.686995,-68.14642),('04758','ME','Mars Hill','Aroostook',46.541413,-67.857072),('04760','ME','Monticello','Aroostook',46.327717,-67.889343),('04761','ME','New Limerick','Aroostook',46.117076,-67.983102),('04762','ME','New Sweden','Aroostook',46.976391,-68.114962),('04763','ME','Oakfield','Aroostook',46.099569,-68.123586),('04764','ME','Oxbow','Aroostook',46.425046,-68.520385),('04765','ME','Patten','Penobscot',46.080214,-68.600025),('04766','ME','Perham','Aroostook',46.877593,-68.229427),('04768','ME','Portage','Aroostook',46.796452,-68.73371),('04769','ME','Presque Isle','Aroostook',46.683345,-68.006007),('04772','ME','Saint Agatha','Aroostook',47.237336,-68.332952),('04773','ME','Saint David','Aroostook',47.282209,-68.241555),('04774','ME','Saint Francis','Aroostook',47.123582,-69.017171),('04775','ME','Sheridan','Aroostook',46.6572,-68.4055),('04776','ME','Sherman','Aroostook',45.859789,-68.34023),('04777','ME','Stacyville','Penobscot',45.871221,-68.475642),('04779','ME','Sinclair','Aroostook',47.134512,-68.331898),('04780','ME','Smyrna Mills','Aroostook',46.195406,-68.257705),('04781','ME','Wallagrass','Aroostook',47.150199,-68.613495),('04783','ME','Stockholm','Aroostook',47.039396,-68.168845),('04785','ME','Van Buren','Aroostook',47.138385,-67.956204),('04786','ME','Washburn','Aroostook',46.786492,-68.154769),('04787','ME','Westfield','Aroostook',46.563911,-67.946283),('04841','ME','Rockland','Knox',44.109593,-69.114816),('04843','ME','Camden','Knox',44.219238,-69.075829),('04846','ME','Glen Cove','Knox',44.1336,-69.0947),('04847','ME','Hope','Knox',44.240818,-69.189267),('04848','ME','Islesboro','Waldo',44.298888,-68.915241),('04849','ME','Lincolnville','Waldo',44.325921,-69.047406),('04850','ME','Lincolnville Center','Waldo',44.2977,-69.108),('04851','ME','Matinicus','Knox',43.859145,-68.879348),('04852','ME','Monhegan','Lincoln',43.765538,-69.319469),('04853','ME','North Haven','Knox',44.146096,-68.861001),('04854','ME','Owls Head','Knox',44.075524,-69.079843),('04855','ME','Port Clyde','Knox',43.93246,-69.262033),('04856','ME','Rockport','Knox',44.168363,-69.106247),('04858','ME','South Thomaston','Knox',44.033077,-69.135893),('04859','ME','Spruce Head','Knox',43.983067,-69.122743),('04860','ME','Tenants Harbor','Knox',43.95869,-69.233055),('04861','ME','Thomaston','Knox',44.084455,-69.177138),('04862','ME','Union','Knox',44.234175,-69.26823),('04863','ME','Vinalhaven','Knox',44.06103,-68.838203),('04864','ME','Warren','Knox',44.128907,-69.251532),('04865','ME','West Rockport','Knox',44.1836,-69.1504),('04901','ME','Waterville','Kennebec',44.553943,-69.619533),('04903','ME','Waterville','Kennebec',44.5549,-69.6305),('04910','ME','Albion','Kennebec',44.508416,-69.445185),('04911','ME','Anson','Somerset',44.78009,-69.933696),('04912','ME','Athens','Somerset',44.96526,-69.666935),('04915','ME','Belfast','Waldo',44.444957,-69.022232),('04917','ME','Belgrade','Kennebec',44.47863,-69.834438),('04918','ME','Belgrade Lakes','Kennebec',44.519616,-69.877839),('04920','ME','Bingham','Somerset',45.097144,-69.871452),('04921','ME','Brooks','Waldo',44.554403,-69.125624),('04922','ME','Burnham','Waldo',44.673999,-69.38646),('04923','ME','Cambridge','Somerset',45.029009,-69.445746),('04924','ME','Canaan','Somerset',44.765801,-69.557294),('04925','ME','Caratunk','Somerset',45.261609,-69.923401),('04926','ME','China Village','Kennebec',44.482811,-69.515873),('04927','ME','Clinton','Kennebec',44.665474,-69.540766),('04928','ME','Corinna','Penobscot',44.943087,-69.260018),('04929','ME','Detroit','Somerset',44.773091,-69.301537),('04930','ME','Dexter','Penobscot',45.025584,-69.296497),('04932','ME','Dixmont','Penobscot',44.689536,-69.125294),('04933','ME','East Newport','Penobscot',44.816495,-69.231348),('04935','ME','East Vassalboro','Kennebec',44.4477,-69.6063),('04936','ME','Eustis','Franklin',45.307142,-70.61005),('04937','ME','Fairfield','Somerset',44.612345,-69.619249),('04938','ME','Farmington','Franklin',44.668196,-70.11603),('04939','ME','Garland','Penobscot',45.041591,-69.155975),('04940','ME','Farmington Falls','Franklin',44.622367,-70.075659),('04941','ME','Freedom','Waldo',44.460707,-69.287446),('04942','ME','Harmony','Somerset',45.077023,-69.586446),('04943','ME','Hartland','Somerset',44.86741,-69.500716),('04944','ME','Hinckley','Somerset',44.67928,-69.632933),('04945','ME','Jackman','Somerset',45.589533,-70.265173),('04947','ME','Kingfield','Franklin',44.996704,-70.226647),('04949','ME','Liberty','Waldo',44.369093,-69.336),('04950','ME','Madison','Somerset',44.817477,-69.825211),('04951','ME','Monroe','Waldo',44.592099,-69.048189),('04952','ME','Morrill','Waldo',44.401054,-69.142462),('04953','ME','Newport','Penobscot',44.845505,-69.258459),('04954','ME','New Portland','Somerset',44.904101,-70.104531),('04955','ME','New Sharon','Franklin',44.639911,-70.013727),('04956','ME','New Vineyard','Franklin',44.802063,-70.13175),('04957','ME','Norridgewock','Somerset',44.70006,-69.835003),('04958','ME','North Anson','Somerset',44.899067,-69.918836),('04961','ME','New Port','Somerset',45.12411,-70.144606),('04962','ME','North Vassalboro','Kennebec',44.489522,-69.625025),('04963','ME','Oakland','Kennebec',44.552082,-69.760582),('04964','ME','Oquossoc','Franklin',44.911135,-70.776909),('04965','ME','Palmyra','Somerset',44.845339,-69.360954),('04966','ME','Phillips','Franklin',44.831962,-70.389389),('04967','ME','Pittsfield','Somerset',44.77418,-69.406653),('04969','ME','Plymouth','Penobscot',44.767961,-69.211878),('04970','ME','Rangeley','Franklin',44.972847,-70.647587),('04971','ME','Saint Albans','Somerset',44.927411,-69.387354),('04972','ME','Sandy Point','Waldo',44.5147,-68.8133),('04973','ME','Searsmont','Waldo',44.361453,-69.195097),('04974','ME','Searsport','Waldo',44.479403,-68.931156),('04975','ME','Shawmut','Somerset',44.625378,-69.588327),('04976','ME','Skowhegan','Somerset',44.784694,-69.698024),('04978','ME','Smithfield','Somerset',44.619918,-69.813614),('04979','ME','Solon','Somerset',44.93938,-69.808142),('04981','ME','Stockton Springs','Waldo',44.527386,-68.862051),('04982','ME','Stratton','Franklin',45.128165,-70.430242),('04983','ME','Strong','Franklin',44.860077,-70.257609),('04984','ME','Temple','Franklin',44.697242,-70.243008),('04985','ME','West Forks','Somerset',45.342076,-69.956935),('04986','ME','Thorndike','Waldo',44.555048,-69.229237),('04987','ME','Troy','Waldo',44.68555,-69.254639),('04988','ME','Unity','Waldo',44.607175,-69.340709),('04989','ME','Vassalboro','Kennebec',44.421005,-69.643446),('04992','ME','West Farmington','Franklin',44.661956,-70.154498),('05001','VT','White River Junction','Windsor',43.665259,-72.361618),('05009','VT','White River Junction','Windsor',43.6488,-72.3197),('05030','VT','Ascutney','Windsor',43.4069,-72.4075),('05031','VT','Barnard','Windsor',43.724305,-72.591008),('05032','VT','Bethel','Windsor',43.818393,-72.641394),('05033','VT','Bradford','Orange',44.005599,-72.144793),('05034','VT','Bridgewater','Windsor',43.587532,-72.630035),('05035','VT','Bridgewater Corners','Windsor',43.595116,-72.692821),('05036','VT','Brookfield','Orange',44.028738,-72.582105),('05037','VT','Brownsville','Windsor',43.461585,-72.48545),('05038','VT','Chelsea','Orange',43.993916,-72.459992),('05039','VT','Corinth','Orange',44.02991,-72.298965),('05040','VT','East Corinth','Orange',44.064023,-72.201229),('05041','VT','East Randolph','Orange',43.950959,-72.55006),('05042','VT','East Ryegate','Caledonia',44.214423,-72.080065),('05043','VT','East Thetford','Orange',43.817121,-72.205679),('05045','VT','Fairlee','Orange',43.917846,-72.180296),('05046','VT','Groton','Caledonia',44.234398,-72.233621),('05047','VT','Hartford','Windsor',43.6605,-72.3388),('05048','VT','Hartland','Windsor',43.57094,-72.422633),('05049','VT','Hartland Four Corners','Windsor',43.5595,-72.4481),('05050','VT','Mc Indoe Falls','Caledonia',44.263293,-72.063483),('05051','VT','Newbury','Orange',44.088683,-72.103023),('05052','VT','North Hartland','Windsor',43.593834,-72.355304),('05053','VT','North Pomfret','Windsor',43.719309,-72.48031),('05054','VT','North Thetford','Orange',43.852619,-72.187984),('05055','VT','Norwich','Windsor',43.73591,-72.290381),('05056','VT','Plymouth','Windsor',43.512301,-72.729091),('05058','VT','Post Mills','Orange',43.89093,-72.258192),('05059','VT','Quechee','Windsor',43.641728,-72.419157),('05060','VT','Randolph','Orange',43.948696,-72.67448),('05061','VT','Randolph Center','Orange',43.932854,-72.592701),('05062','VT','Reading','Windsor',43.489424,-72.574102),('05065','VT','Sharon','Windsor',43.775976,-72.423758),('05067','VT','South Pomfret','Windsor',43.678167,-72.531181),('05068','VT','South Royalton','Windsor',43.810378,-72.53264),('05069','VT','South Ryegate','Caledonia',44.185864,-72.137215),('05070','VT','South Strafford','Orange',43.836159,-72.364864),('05071','VT','South Woodstock','Windsor',43.561557,-72.546332),('05072','VT','Strafford','Orange',43.884238,-72.369144),('05073','VT','Taftsville','Windsor',43.625216,-72.477565),('05074','VT','Thetford','Orange',43.815621,-72.222759),('05075','VT','Thetford Center','Orange',43.822226,-72.281275),('05076','VT','Topsham','Orange',44.137802,-72.222477),('05077','VT','Tunbridge','Orange',43.895888,-72.477044),('05079','VT','Vershire','Orange',43.956765,-72.326539),('05081','VT','Wells River','Orange',44.156268,-72.068135),('05083','VT','West Fairlee','Orange',43.918824,-72.262561),('05084','VT','West Hartford','Windsor',43.721327,-72.427244),('05085','VT','West Newbury','Orange',44.062646,-72.139464),('05086','VT','West Topsham','Orange',44.10897,-72.300719),('05088','VT','Wilder','Windsor',43.676947,-72.308201),('05089','VT','Windsor','Windsor',43.475358,-72.421045),('05091','VT','Woodstock','Windsor',43.627491,-72.538125),('05101','VT','Bellows Falls','Windham',43.157816,-72.468814),('05141','VT','Cambridgeport','Windham',43.14932,-72.560502),('05142','VT','Cavendish','Windsor',43.395541,-72.591466),('05143','VT','Chester','Windsor',43.269168,-72.622441),('05144','VT','Chester Depot','Windsor',43.264,-72.5955),('05146','VT','Grafton','Windham',43.170117,-72.599322),('05148','VT','Londonderry','Windham',43.226543,-72.803709),('05149','VT','Ludlow','Windsor',43.398531,-72.702465),('05150','VT','North Springfield','Windsor',43.336335,-72.527292),('05151','VT','Perkinsville','Windsor',43.392108,-72.476783),('05152','VT','Peru','Bennington',43.242357,-72.884786),('05153','VT','Proctorsville','Windsor',43.396243,-72.641972),('05154','VT','Saxtons River','Windham',43.13656,-72.512812),('05155','VT','South Londonderry','Windham',43.148705,-72.858082),('05156','VT','Springfield','Windsor',43.300286,-72.477628),('05158','VT','Westminster','Windham',43.097371,-72.457023),('05159','VT','Westminster Station','Windham',43.0855,-72.4397),('05161','VT','Weston','Windsor',43.302373,-72.792328),('05201','VT','Bennington','Bennington',42.883676,-73.180743),('05250','VT','Arlington','Bennington',43.103754,-73.173044),('05251','VT','Dorset','Bennington',43.244831,-73.092959),('05252','VT','East Arlington','Bennington',43.079677,-73.096857),('05253','VT','East Dorset','Bennington',43.252568,-73.006862),('05254','VT','Manchester','Bennington',43.160007,-73.067015),('05255','VT','Manchester Center','Bennington',43.17268,-73.052762),('05257','VT','North Bennington','Bennington',42.932612,-73.247464),('05260','VT','North Pownal','Bennington',42.805244,-73.266644),('05261','VT','Pownal','Bennington',42.780768,-73.211833),('05262','VT','Shaftsbury','Bennington',42.97241,-73.177798),('05301','VT','Brattleboro','Windham',42.856416,-72.615071),('05302','VT','Brattleboro','Windham',42.852,-72.5587),('05303','VT','Brattleboro','Windham',42.852,-72.5587),('05304','VT','Brattleboro','Windham',42.852,-72.5587),('05340','VT','Bondville','Bennington',43.158142,-72.905206),('05341','VT','East Dover','Windham',42.954168,-72.781288),('05342','VT','Jacksonville','Windham',42.779929,-72.805728),('05343','VT','Jamaica','Windham',43.099316,-72.78963),('05344','VT','Marlboro','Windham',42.851149,-72.740735),('05345','VT','Newfane','Windham',42.987486,-72.664679),('05346','VT','Putney','Windham',43.013914,-72.52467),('05350','VT','Readsboro','Bennington',42.778019,-72.958312),('05351','VT','South Newfane','Windham',42.934798,-72.750621),('05352','VT','Stamford','Bennington',42.772821,-73.061599),('05353','VT','Townshend','Windham',43.054263,-72.664647),('05354','VT','Vernon','Windham',42.76774,-72.517954),('05355','VT','Wardsboro','Windham',43.03408,-72.806677),('05356','VT','West Dover','Windham',42.953273,-72.87246),('05357','VT','West Dummerston','Windham',42.9263,-72.6158),('05358','VT','West Halifax','Windham',42.774238,-72.726328),('05359','VT','West Townshend','Windham',43.143041,-72.719613),('05360','VT','West Wardsboro','Windham',43.019446,-72.941021),('05361','VT','Whitingham','Windham',42.780663,-72.887667),('05362','VT','Williamsville','Windham',42.94731,-72.66763),('05363','VT','Wilmington','Windham',42.882111,-72.885224),('05401','VT','Burlington','Chittenden',44.475391,-73.211673),('05402','VT','Burlington','Chittenden',44.4807,-73.2143),('05403','VT','South Burlington','Chittenden',44.451661,-73.179616),('05404','VT','Winooski','Chittenden',44.493097,-73.182294),('05405','VT','Burlington','Chittenden',44.472763,-73.195878),('05406','VT','Burlington','Chittenden',44.4807,-73.2143),('05407','VT','South Burlington','Chittenden',44.4807,-73.2143),('05408','VT','Burlington','Chittenden',44.511852,-73.249611),('05439','VT','Colchester','Chittenden',44.494362,-73.161895),('05440','VT','Alburgh','Grand Isle',44.966834,-73.270544),('05441','VT','Bakersfield','Franklin',44.790908,-72.795571),('05442','VT','Belvidere Center','Lamoille',44.748807,-72.694425),('05443','VT','Bristol','Addison',44.140363,-73.046854),('05444','VT','Cambridge','Franklin',44.645193,-72.903537),('05445','VT','Charlotte','Chittenden',44.30577,-73.235637),('05446','VT','Colchester','Chittenden',44.541414,-73.183521),('05447','VT','East Berkshire','Franklin',44.932297,-72.701515),('05448','VT','East Fairfield','Franklin',44.757401,-72.878474),('05449','VT','Colchester','Chittenden',44.5438,-73.1483),('05450','VT','Enosburg Falls','Franklin',44.894808,-72.806071),('05451','VT','Essex','Chittenden',44.5215,-73.0609),('05452','VT','Essex Junction','Chittenden',44.502619,-73.093009),('05453','VT','Essex Junction','Chittenden',44.4905,-73.1113),('05454','VT','Fairfax','Franklin',44.690316,-73.026789),('05455','VT','Fairfield','Franklin',44.801687,-72.967394),('05456','VT','Ferrisburgh','Addison',44.20146,-73.251751),('05457','VT','Franklin','Franklin',44.976864,-72.901901),('05458','VT','Grand Isle','Grand Isle',44.71179,-73.307869),('05459','VT','Highgate Center','Franklin',44.94671,-73.018468),('05460','VT','Highgate Springs','Franklin',44.9741,-73.1052),('05461','VT','Hinesburg','Chittenden',44.322716,-73.094962),('05462','VT','Huntington','Chittenden',44.300465,-72.971845),('05463','VT','Isle La Motte','Grand Isle',44.865209,-73.333759),('05464','VT','Jeffersonville','Lamoille',44.650956,-72.825686),('05465','VT','Jericho','Chittenden',44.479508,-72.951131),('05466','VT','Jonesville','Chittenden',44.3838,-72.938),('05468','VT','Milton','Chittenden',44.646019,-73.136669),('05469','VT','Monkton','Addison',44.2385,-73.1482),('05470','VT','Montgomery','Franklin',44.9025,-72.6386),('05471','VT','Montgomery Center','Franklin',44.878745,-72.610961),('05472','VT','New Haven','Addison',44.118012,-73.167481),('05473','VT','North Ferrisburgh','Addison',44.254984,-73.217859),('05474','VT','North Hero','Grand Isle',44.83778,-73.272138),('05476','VT','Richford','Franklin',44.980574,-72.664891),('05477','VT','Richmond','Chittenden',44.400779,-72.979438),('05478','VT','Saint Albans','Franklin',44.811866,-73.089002),('05479','VT','Saint Albans','Franklin',44.81,-73.0843),('05481','VT','Saint Albans Bay','Franklin',44.8077,-73.1397),('05482','VT','Shelburne','Chittenden',44.390462,-73.218019),('05483','VT','Sheldon','Franklin',44.877208,-72.962207),('05485','VT','Sheldon Springs','Franklin',44.903856,-72.975552),('05486','VT','South Hero','Grand Isle',44.642247,-73.30774),('05487','VT','Starksboro','Addison',44.223597,-73.028213),('05488','VT','Swanton','Franklin',44.926105,-73.121341),('05489','VT','Underhill','Chittenden',44.54457,-72.91793),('05490','VT','Underhill Center','Chittenden',44.5075,-72.9),('05491','VT','Vergennes','Addison',44.12465,-73.305652),('05492','VT','Waterville','Lamoille',44.714257,-72.749728),('05494','VT','Westford','Chittenden',44.602523,-73.016993),('05495','VT','Williston','Chittenden',44.444632,-73.098799),('05501','MA','Andover','Essex',42.6464,-71.1657),('05544','MA','Andover','Essex',42.6464,-71.1657),('05601','VT','Montpelier','Washington',44.2574,-72.5698),('05602','VT','Montpelier','Washington',44.259499,-72.588895),('05603','VT','Montpelier','Washington',44.2574,-72.5698),('05604','VT','Montpelier','Washington',44.2574,-72.5698),('05609','VT','Montpelier','Washington',44.2574,-72.5698),('05620','VT','Montpelier','Washington',44.2574,-72.5698),('05633','VT','Montpelier','Washington',44.2574,-72.5698),('05640','VT','Adamant','Washington',44.35163,-72.495323),('05641','VT','Barre','Washington',44.192594,-72.494016),('05647','VT','Cabot','Washington',44.408269,-72.303054),('05648','VT','Calais','Washington',44.384299,-72.488431),('05649','VT','East Barre','Orange',44.153619,-72.389011),('05650','VT','East Calais','Washington',44.390082,-72.44478),('05651','VT','East Montpelier','Washington',44.272339,-72.48693),('05652','VT','Eden','Lamoille',44.715686,-72.571823),('05653','VT','Eden Mills','Lamoille',44.702393,-72.502441),('05654','VT','Graniteville','Washington',44.140669,-72.47683),('05655','VT','Hyde Park','Lamoille',44.618575,-72.587948),('05656','VT','Johnson','Lamoille',44.642144,-72.679217),('05657','VT','Lake Elmore','Lamoille',44.534082,-72.528267),('05658','VT','Marshfield','Washington',44.351486,-72.348354),('05660','VT','Moretown','Washington',44.249791,-72.757574),('05661','VT','Morrisville','Lamoille',44.549427,-72.60306),('05662','VT','Moscow','Lamoille',44.4413,-72.7158),('05663','VT','Northfield','Washington',44.145587,-72.663078),('05664','VT','Northfield Falls','Washington',44.171238,-72.649769),('05665','VT','North Hyde Park','Lamoille',44.6705,-72.5986),('05666','VT','North Montpelier','Washington',44.33865,-72.443829),('05667','VT','Plainfield','Washington',44.277517,-72.417334),('05669','VT','Roxbury','Washington',44.066681,-72.744109),('05670','VT','South Barre','Washington',44.1769,-72.5061),('05671','VT','Waterbury','Washington',44.3285,-72.7466),('05672','VT','Stowe','Lamoille',44.476403,-72.707225),('05673','VT','Waitsfield','Washington',44.18793,-72.828705),('05674','VT','Warren','Washington',44.10952,-72.855377),('05675','VT','Washington','Orange',44.076165,-72.422633),('05676','VT','Waterbury','Washington',44.352467,-72.782679),('05677','VT','Waterbury Center','Washington',44.383152,-72.721209),('05678','VT','Websterville','Washington',44.15135,-72.472383),('05679','VT','Williamstown','Orange',44.10869,-72.531825),('05680','VT','Wolcott','Lamoille',44.551265,-72.474173),('05681','VT','Woodbury','Washington',44.437769,-72.399017),('05682','VT','Worcester','Washington',44.380119,-72.549107),('05701','VT','Rutland','Rutland',43.614651,-72.964694),('05702','VT','Rutland','Rutland',43.6075,-72.9818),('05730','VT','Belmont','Rutland',43.442159,-72.824102),('05731','VT','Benson','Rutland',43.7069,-73.3116),('05732','VT','Bomoseen','Rutland',43.665305,-73.192459),('05733','VT','Brandon','Rutland',43.813268,-73.10059),('05734','VT','Bridport','Addison',43.985413,-73.345914),('05735','VT','Castleton','Rutland',43.616386,-73.1733),('05736','VT','Center Rutland','Rutland',43.603634,-73.014753),('05737','VT','Chittenden','Rutland',43.733434,-72.934308),('05738','VT','Cuttingsville','Rutland',43.509137,-72.868837),('05739','VT','Danby','Rutland',43.35763,-73.010098),('05740','VT','East Middlebury','Addison',43.9733,-73.1066),('05741','VT','East Poultney','Rutland',43.5263,-73.205),('05742','VT','East Wallingford','Rutland',43.449426,-72.876206),('05743','VT','Fair Haven','Rutland',43.650618,-73.272073),('05744','VT','Florence','Rutland',43.699411,-73.061592),('05745','VT','Forest Dale','Rutland',43.8277,-73.0541),('05746','VT','Gaysville','Windsor',43.785433,-72.713666),('05747','VT','Granville','Addison',43.992898,-72.835666),('05748','VT','Hancock','Addison',43.92643,-72.868788),('05750','VT','Hydeville','Rutland',43.619787,-73.232736),('05751','VT','Killington','Rutland',43.659757,-72.794122),('05753','VT','Middlebury','Addison',44.007019,-73.170926),('05757','VT','Middletown Springs','Rutland',43.476002,-73.123921),('05758','VT','Mount Holly','Rutland',43.452116,-72.794149),('05759','VT','North Clarendon','Rutland',43.543136,-72.958705),('05760','VT','Orwell','Addison',43.800615,-73.289701),('05761','VT','Pawlet','Rutland',43.360927,-73.151758),('05762','VT','Pittsfield','Rutland',43.758531,-72.818416),('05763','VT','Pittsford','Rutland',43.720529,-73.004561),('05764','VT','Poultney','Rutland',43.521852,-73.217352),('05765','VT','Proctor','Rutland',43.6577,-73.032279),('05766','VT','Ripton','Addison',43.982023,-73.01545),('05767','VT','Rochester','Windsor',43.872612,-72.810001),('05768','VT','Rupert','Bennington',43.2597,-73.2233),('05769','VT','Salisbury','Addison',43.916583,-73.10687),('05770','VT','Shoreham','Addison',43.890874,-73.31235),('05772','VT','Stockbridge','Windsor',43.76435,-72.739204),('05773','VT','Wallingford','Rutland',43.443167,-72.987192),('05774','VT','Wells','Rutland',43.434496,-73.198192),('05775','VT','West Pawlet','Rutland',43.365106,-73.23588),('05776','VT','West Rupert','Bennington',43.273692,-73.189896),('05777','VT','West Rutland','Rutland',43.575637,-73.042741),('05778','VT','Whiting','Addison',43.876421,-73.212537),('05819','VT','Saint Johnsbury','Caledonia',44.417156,-72.005298),('05820','VT','Albany','Orleans',44.736636,-72.360787),('05821','VT','Barnet','Caledonia',44.312662,-72.097421),('05822','VT','Barton','Orleans',44.748547,-72.160898),('05823','VT','Beebe Plain','Orleans',45.0052,-72.1411),('05824','VT','Concord','Essex',44.427811,-71.869494),('05825','VT','Coventry','Orleans',44.864259,-72.264587),('05826','VT','Craftsbury','Orleans',44.634478,-72.379275),('05827','VT','Craftsbury Common','Orleans',44.678899,-72.349484),('05828','VT','Danville','Caledonia',44.426905,-72.114521),('05829','VT','Derby','Orleans',44.949071,-72.104866),('05830','VT','Derby Line','Orleans',44.992448,-72.047157),('05832','VT','East Burke','Caledonia',44.591479,-71.91798),('05833','VT','East Charleston','Orleans',44.823359,-71.968759),('05836','VT','East Hardwick','Caledonia',44.516607,-72.278508),('05837','VT','East Haven','Essex',44.671287,-71.845211),('05838','VT','East Saint Johnsbury','Caledonia',44.4386,-71.9461),('05839','VT','Glover','Orleans',44.680825,-72.192344),('05840','VT','Granby','Essex',44.612521,-71.715367),('05841','VT','Greensboro','Orleans',44.588847,-72.301978),('05842','VT','Greensboro Bend','Orleans',44.558888,-72.248252),('05843','VT','Hardwick','Caledonia',44.507003,-72.362014),('05845','VT','Irasburg','Orleans',44.811041,-72.292426),('05846','VT','Island Pond','Essex',44.80207,-71.858465),('05847','VT','Lowell','Orleans',44.798671,-72.450174),('05848','VT','Lower Waterford','Caledonia',44.3544,-71.9075),('05849','VT','Lyndon','Caledonia',44.5141,-72.0113),('05850','VT','Lyndon Center','Caledonia',44.541247,-72.014699),('05851','VT','Lyndonville','Caledonia',44.545528,-72.028609),('05853','VT','Morgan','Orleans',44.897273,-71.974125),('05855','VT','Newport','Orleans',44.938469,-72.198213),('05857','VT','Newport Center','Orleans',44.951801,-72.302204),('05858','VT','North Concord','Essex',44.533952,-71.791803),('05859','VT','North Troy','Orleans',44.96437,-72.420542),('05860','VT','Orleans','Orleans',44.806295,-72.157135),('05861','VT','Passumpsic','Caledonia',44.3766,-72.028),('05862','VT','Peacham','Caledonia',44.329246,-72.199012),('05863','VT','Saint Johnsbury Center','Caledonia',44.4572,-72.0065),('05866','VT','Sheffield','Caledonia',44.631732,-72.115111),('05867','VT','Sutton','Caledonia',44.651939,-72.04237),('05868','VT','Troy','Orleans',44.89636,-72.388274),('05871','VT','West Burke','Caledonia',44.66724,-71.964436),('05872','VT','West Charleston','Orleans',44.874867,-72.03022),('05873','VT','West Danville','Caledonia',44.418492,-72.218263),('05874','VT','Westfield','Orleans',44.873104,-72.429275),('05875','VT','West Glover','Orleans',44.69725,-72.259499),('05901','VT','Averill','Essex',44.964837,-71.69312),('05902','VT','Beecher Falls','Essex',45.009093,-71.505766),('05903','VT','Canaan','Essex',44.974307,-71.573839),('05904','VT','Gilman','Essex',44.415867,-71.708879),('05905','VT','Guildhall','Essex',44.690977,-71.642601),('05906','VT','Lunenburg','Essex',44.461197,-71.699277),('05907','VT','Norton','Essex',44.957513,-71.808748),('06001','CT','Avon','Hartford',41.791694,-72.861109),('06002','CT','Bloomfield','Hartford',41.832978,-72.728457),('06006','CT','Windsor','Hartford',41.8525,-72.6441),('06010','CT','Bristol','Hartford',41.682323,-72.933372),('06011','CT','Bristol','Hartford',41.6761,-72.9472),('06013','CT','Burlington','Hartford',41.757849,-72.946507),('06016','CT','Broad Brook','Hartford',41.906893,-72.54416),('06018','CT','Canaan','Litchfield',42.029094,-73.318558),('06019','CT','Canton','Hartford',41.837455,-72.913118),('06020','CT','Canton Center','Hartford',41.864597,-72.910034),('06021','CT','Colebrook','Litchfield',42.022851,-73.110941),('06022','CT','Collinsville','Hartford',41.866456,-72.926725),('06023','CT','East Berlin','Hartford',41.616335,-72.718652),('06024','CT','East Canaan','Litchfield',42.010787,-73.270989),('06025','CT','East Glastonbury','Hartford',41.6941,-72.5341),('06026','CT','East Granby','Hartford',41.929719,-72.745378),('06027','CT','East Hartland','Hartford',41.999021,-72.906476),('06028','CT','East Windsor Hill','Hartford',41.8602,-72.6036),('06029','CT','Ellington','Tolland',41.909209,-72.45047),('06030','CT','Farmington','Hartford',41.7323,-72.7917),('06031','CT','Falls Village','Litchfield',41.948349,-73.32617),('06032','CT','Farmington','Hartford',41.729074,-72.82504),('06033','CT','Glastonbury','Hartford',41.707101,-72.570156),('06034','CT','Farmington','Hartford',41.7114,-72.8395),('06035','CT','Granby','Hartford',41.957793,-72.796475),('06037','CT','Berlin','Hartford',41.623575,-72.768916),('06039','CT','Lakeville','Litchfield',41.952812,-73.437539),('06040','CT','Manchester','Hartford',41.769034,-72.525389),('06041','CT','Manchester','Hartford',41.7758,-72.5219),('06042','CT','Manchester','Hartford',41.796472,-72.523668),('06043','CT','Bolton','Tolland',41.771393,-72.436383),('06045','CT','Manchester','Hartford',41.7758,-72.5219),('06050','CT','New Britain','Hartford',41.6657,-72.7787),('06051','CT','New Britain','Hartford',41.666123,-72.769876),('06052','CT','New Britain','Hartford',41.658118,-72.800373),('06053','CT','New Britain','Hartford',41.687804,-72.790632),('06057','CT','New Hartford','Litchfield',41.855475,-73.002881),('06058','CT','Norfolk','Litchfield',41.986805,-73.196534),('06059','CT','North Canton','Hartford',41.937513,-72.920176),('06060','CT','North Granby','Hartford',42.010312,-72.843011),('06061','CT','Pine Meadow','Litchfield',41.876052,-72.966023),('06062','CT','Plainville','Hartford',41.671541,-72.862932),('06063','CT','Barkhamsted','Litchfield',41.92423,-72.976534),('06064','CT','Poquonock','Hartford',41.9047,-72.6791),('06065','CT','Riverton','Hartford',41.95633,-73.008209),('06066','CT','Vernon Rockville','Tolland',41.84378,-72.467565),('06067','CT','Rocky Hill','Hartford',41.656618,-72.661781),('06068','CT','Salisbury','Litchfield',42.007298,-73.422272),('06069','CT','Sharon','Litchfield',41.86924,-73.454263),('06070','CT','Simsbury','Hartford',41.873902,-72.816184),('06071','CT','Somers','Tolland',41.9965,-72.453237),('06072','CT','Somersville','Tolland',41.9827,-72.4883),('06073','CT','South Glastonbury','Hartford',41.660569,-72.568483),('06074','CT','South Windsor','Hartford',41.830843,-72.56336),('06075','CT','Stafford','Tolland',41.9853,-72.2892),('06076','CT','Stafford Springs','Tolland',41.98506,-72.278503),('06077','CT','Staffordville','Tolland',41.9938,-72.2591),('06078','CT','Suffield','Hartford',41.985212,-72.63925),('06079','CT','Taconic','Litchfield',42.0355,-73.4083),('06080','CT','Suffield','Hartford',41.9829,-72.6564),('06081','CT','Tariffville','Hartford',41.906116,-72.766326),('06082','CT','Enfield','Hartford',41.986157,-72.569609),('06083','CT','Enfield','Hartford',41.9977,-72.5746),('06084','CT','Tolland','Tolland',41.878534,-72.3678),('06085','CT','Unionville','Hartford',41.748957,-72.889416),('06087','CT','Unionville','Hartford',41.7554,-72.8799),('06088','CT','East Windsor','Hartford',41.915052,-72.608167),('06089','CT','Weatogue','Hartford',41.839309,-72.819956),('06090','CT','West Granby','Hartford',41.953737,-72.853309),('06091','CT','West Hartland','Hartford',42.020853,-72.971387),('06092','CT','West Simsbury','Hartford',41.86085,-72.858605),('06093','CT','West Suffield','Hartford',42.007978,-72.737552),('06094','CT','Winchester Center','Litchfield',41.9,-73.1352),('06095','CT','Windsor','Hartford',41.858394,-72.667145),('06096','CT','Windsor Locks','Hartford',41.92779,-72.651616),('06098','CT','Winsted','Litchfield',41.934375,-73.077219),('06101','CT','Hartford','Hartford',41.7636,-72.6855),('06102','CT','Hartford','Hartford',41.7636,-72.6855),('06103','CT','Hartford','Hartford',41.768155,-72.674281),('06104','CT','Hartford','Hartford',41.7636,-72.6855),('06105','CT','Hartford','Hartford',41.770207,-72.702847),('06106','CT','Hartford','Hartford',41.750131,-72.693505),('06107','CT','West Hartford','Hartford',41.756105,-72.756274),('06108','CT','East Hartford','Hartford',41.777122,-72.625467),('06109','CT','Wethersfield','Hartford',41.701769,-72.674025),('06110','CT','West Hartford','Hartford',41.731292,-72.733925),('06111','CT','Newington','Hartford',41.688947,-72.73027),('06112','CT','Hartford','Hartford',41.79246,-72.696212),('06114','CT','Hartford','Hartford',41.737833,-72.676408),('06115','CT','Hartford','Hartford',41.7636,-72.6855),('06117','CT','West Hartford','Hartford',41.788779,-72.749127),('06118','CT','East Hartford','Hartford',41.746971,-72.61061),('06119','CT','West Hartford','Hartford',41.762654,-72.728576),('06120','CT','Hartford','Hartford',41.785537,-72.671494),('06123','CT','Hartford','Hartford',41.7636,-72.6855),('06126','CT','Hartford','Hartford',41.7636,-72.6855),('06127','CT','West Hartford','Hartford',41.7586,-72.7446),('06128','CT','East Hartford','Hartford',41.7683,-72.6444),('06129','CT','Wethersfield','Hartford',41.7092,-72.6619),('06131','CT','Newington','Hartford',41.695,-72.7215),('06132','CT','Hartford','Hartford',41.7813,-72.6968),('06133','CT','West Hartford','Hartford',41.725,-72.7213),('06134','CT','Hartford','Hartford',41.7431,-72.6834),('06137','CT','West Hartford','Hartford',41.7619,-72.7425),('06138','CT','East Hartford','Hartford',41.7653,-72.6043),('06140','CT','Hartford','Hartford',41.7926,-72.678),('06141','CT','Hartford','Hartford',41.7636,-72.6855),('06142','CT','Hartford','Hartford',41.7636,-72.6855),('06143','CT','Hartford','Hartford',41.7636,-72.6855),('06144','CT','Hartford','Hartford',41.7636,-72.6855),('06145','CT','Hartford','Hartford',41.7636,-72.6855),('06146','CT','Hartford','Hartford',41.7636,-72.6855),('06147','CT','Hartford','Hartford',41.7636,-72.6855),('06150','CT','Hartford','Hartford',41.7636,-72.6855),('06151','CT','Hartford','Hartford',41.7636,-72.6855),('06152','CT','Hartford','Hartford',41.7636,-72.6855),('06153','CT','Hartford','Hartford',41.6869,-72.7313),('06154','CT','Hartford','Hartford',41.7636,-72.6855),('06155','CT','Hartford','Hartford',41.7692,-72.6861),('06156','CT','Hartford','Hartford',41.7636,-72.6855),('06160','CT','Hartford','Hartford',41.7636,-72.6855),('06161','CT','Hartford','Hartford',41.6983,-72.6653),('06167','CT','Hartford','Hartford',41.7636,-72.6855),('06176','CT','Hartford','Hartford',41.7636,-72.6855),('06180','CT','Hartford','Hartford',41.7636,-72.6855),('06183','CT','Hartford','Hartford',41.7636,-72.6855),('06199','CT','Hartford','Hartford',41.9266,-72.6546),('06226','CT','Willimantic','Windham',41.715153,-72.210979),('06230','CT','Abington','Windham',41.8605,-72.0072),('06231','CT','Amston','Tolland',41.630158,-72.362894),('06232','CT','Andover','Tolland',41.739515,-72.371911),('06233','CT','Ballouville','Windham',41.8766,-71.8616),('06234','CT','Brooklyn','Windham',41.787653,-71.950123),('06235','CT','Chaplin','Windham',41.785863,-72.127293),('06237','CT','Columbia','Tolland',41.701952,-72.303903),('06238','CT','Coventry','Tolland',41.779163,-72.333998),('06239','CT','Danielson','Windham',41.798948,-71.866606),('06241','CT','Dayville','Windham',41.850298,-71.857431),('06242','CT','Eastford','Windham',41.894904,-72.093603),('06243','CT','East Killingly','Windham',41.8488,-71.805),('06244','CT','East Woodstock','Windham',41.9836,-71.9777),('06245','CT','Fabyan','Windham',42.0136,-71.9402),('06246','CT','Grosvenor Dale','Windham',41.9683,-71.8952),('06247','CT','Hampton','Windham',41.768616,-72.062583),('06248','CT','Hebron','Tolland',41.683698,-72.400561),('06249','CT','Lebanon','New London',41.619017,-72.24013),('06250','CT','Mansfield Center','Tolland',41.758002,-72.204653),('06251','CT','Mansfield Depot','Tolland',41.8013,-72.3069),('06254','CT','North Franklin','New London',41.609878,-72.134026),('06255','CT','North Grosvenordale','Windham',41.9894,-71.896316),('06256','CT','North Windham','Windham',41.743294,-72.169995),('06258','CT','Pomfret','Windham',41.8975,-71.963),('06259','CT','Pomfret Center','Windham',41.871502,-71.987646),('06260','CT','Putnam','Windham',41.916425,-71.891198),('06262','CT','Quinebaug','Windham',42.02311,-71.947256),('06263','CT','Rogers','Windham',41.839787,-71.90782),('06264','CT','Scotland','Windham',41.69218,-72.09966),('06265','CT','South Willington','Tolland',41.8552,-72.3019),('06266','CT','South Windham','Windham',41.675905,-72.167884),('06267','CT','South Woodstock','Windham',41.9388,-71.96),('06268','CT','Storrs Mansfield','Tolland',41.80294,-72.255271),('06269','CT','Storrs Mansfield','Tolland',41.810702,-72.258974),('06277','CT','Thompson','Windham',41.972258,-71.839407),('06278','CT','Ashford','Windham',41.897123,-72.171427),('06279','CT','Willington','Tolland',41.88422,-72.263333),('06280','CT','Windham','Windham',41.688625,-72.148171),('06281','CT','Woodstock','Windham',41.972831,-71.997947),('06282','CT','Woodstock Valley','Windham',41.945539,-72.075477),('06320','CT','New London','New London',41.35401,-72.104906),('06330','CT','Baltic','New London',41.63557,-72.077527),('06331','CT','Canterbury','Windham',41.682395,-72.005353),('06332','CT','Central Village','Windham',41.729303,-71.901659),('06333','CT','East Lyme','New London',41.376233,-72.236371),('06334','CT','Bozrah','New London',41.547388,-72.172358),('06335','CT','Gales Ferry','New London',41.429483,-72.068361),('06336','CT','Gilman','New London',41.578185,-72.199912),('06338','CT','Mashantucket','New London',41.4757,-71.9574),('06339','CT','Ledyard','New London',41.453525,-71.987097),('06340','CT','Groton','New London',41.3564,-72.053749),('06349','CT','Groton','New London',41.3969,-72.0923),('06350','CT','Hanover','New London',41.646329,-72.06507),('06351','CT','Jewett City','New London',41.592037,-71.957225),('06353','CT','Montville','New London',41.458227,-72.144433),('06354','CT','Moosup','Windham',41.717956,-71.871368),('06355','CT','Mystic','New London',41.363589,-71.974385),('06357','CT','Niantic','New London',41.318508,-72.212031),('06359','CT','North Stonington','New London',41.453815,-71.881628),('06360','CT','Norwich','New London',41.536004,-72.082163),('06365','CT','Preston','New London',41.518652,-72.006597),('06370','CT','Oakdale','New London',41.468018,-72.19456),('06371','CT','Old Lyme','New London',41.337304,-72.313299),('06372','CT','Old Mystic','New London',41.3913,-71.9622),('06373','CT','Oneco','Windham',41.668882,-71.790214),('06374','CT','Plainfield','Windham',41.681061,-71.920192),('06375','CT','Quaker Hill','New London',41.406338,-72.123236),('06376','CT','South Lyme','New London',41.293935,-72.253248),('06377','CT','Sterling','Windham',41.730545,-71.819313),('06378','CT','Stonington','New London',41.35719,-71.91658),('06379','CT','Pawcatuck','New London',41.37391,-71.856378),('06380','CT','Taftville','New London',41.566384,-72.051421),('06382','CT','Uncasville','New London',41.4588,-72.114288),('06383','CT','Versailles','New London',41.6016,-72.0377),('06384','CT','Voluntown','New London',41.579193,-71.831228),('06385','CT','Waterford','New London',41.347822,-72.147154),('06386','CT','Waterford','New London',41.3358,-72.1355),('06387','CT','Wauregan','Windham',41.744442,-71.910665),('06388','CT','West Mystic','New London',41.3505,-71.9825),('06389','CT','Yantic','New London',41.56238,-72.127993),('06390','NY','Fishers Island','Suffolk',41.261559,-72.006392),('06401','CT','Ansonia','New Haven',41.344137,-73.074502),('06403','CT','Beacon Falls','New Haven',41.435648,-73.063331),('06404','CT','Botsford','Fairfield',41.3617,-73.2669),('06405','CT','Branford','New Haven',41.277532,-72.805115),('06408','CT','Cheshire','New Haven',41.5104,-72.9044),('06409','CT','Centerbrook','Middlesex',41.353449,-72.416025),('06410','CT','Cheshire','New Haven',41.507926,-72.908577),('06411','CT','Cheshire','New Haven',41.4988,-72.9011),('06412','CT','Chester','Middlesex',41.408018,-72.469718),('06413','CT','Clinton','Middlesex',41.288928,-72.530188),('06414','CT','Cobalt','Middlesex',41.563512,-72.55791),('06415','CT','Colchester','New London',41.563339,-72.341506),('06416','CT','Cromwell','Middlesex',41.609507,-72.663266),('06417','CT','Deep River','Middlesex',41.379414,-72.445614),('06418','CT','Derby','New Haven',41.326124,-73.082574),('06419','CT','Killingworth','Middlesex',41.374419,-72.578328),('06420','CT','Salem','New London',41.481254,-72.263543),('06422','CT','Durham','Middlesex',41.464916,-72.688647),('06423','CT','East Haddam','Middlesex',41.466964,-72.405774),('06424','CT','East Hampton','Middlesex',41.564506,-72.507026),('06426','CT','Essex','Middlesex',41.353427,-72.39925),('06437','CT','Guilford','New Haven',41.311047,-72.698187),('06438','CT','Haddam','Middlesex',41.466313,-72.496907),('06439','CT','Hadlyme','New London',41.4202,-72.4069),('06440','CT','Hawleyville','Fairfield',41.4275,-73.3555),('06441','CT','Higganum','Middlesex',41.459848,-72.567588),('06442','CT','Ivoryton','Middlesex',41.343078,-72.448021),('06443','CT','Madison','New Haven',41.300566,-72.599962),('06444','CT','Marion','Hartford',41.563896,-72.931978),('06447','CT','Marlborough','Hartford',41.635941,-72.458634),('06450','CT','Meriden','New Haven',41.53209,-72.781375),('06451','CT','Meriden','New Haven',41.536137,-72.819366),('06454','CT','Meriden','New Haven',41.54,-72.8017),('06455','CT','Middlefield','Middlesex',41.516903,-72.720994),('06456','CT','Middle Haddam','Middlesex',41.539707,-72.548257),('06457','CT','Middletown','Middlesex',41.553107,-72.660835),('06459','CT','Middletown','Middlesex',41.559,-72.6554),('06460','CT','Milford','New Haven',41.21648,-73.047345),('06461','CT','Milford','New Haven',41.234188,-73.074433),('06467','CT','Milldale','Hartford',41.56866,-72.90027),('06468','CT','Monroe','Fairfield',41.33611,-73.2225),('06469','CT','Moodus','Middlesex',41.507019,-72.446178),('06470','CT','Newtown','Fairfield',41.399088,-73.314805),('06471','CT','North Branford','New Haven',41.325722,-72.774154),('06472','CT','Northford','New Haven',41.389289,-72.780119),('06473','CT','North Haven','New Haven',41.378375,-72.859279),('06474','CT','North Westchester','New London',41.5808,-72.4016),('06475','CT','Old Saybrook','Middlesex',41.291502,-72.383253),('06477','CT','Orange','New Haven',41.284951,-73.024637),('06478','CT','Oxford','New Haven',41.430812,-73.124363),('06479','CT','Plantsville','Hartford',41.575916,-72.896613),('06480','CT','Portland','Middlesex',41.587731,-72.604207),('06481','CT','Rockfall','Middlesex',41.531097,-72.697237),('06482','CT','Sandy Hook','Fairfield',41.409974,-73.252683),('06483','CT','Seymour','New Haven',41.385246,-73.078167),('06484','CT','Shelton','Fairfield',41.306497,-73.129205),('06487','CT','South Britain','New Haven',41.4708,-73.2519),('06488','CT','Southbury','New Haven',41.47573,-73.225153),('06489','CT','Southington','Hartford',41.609118,-72.871636),('06491','CT','Stevenson','Fairfield',41.383,-73.185),('06492','CT','Wallingford','New Haven',41.460993,-72.817188),('06493','CT','Wallingford','New Haven',41.4538,-72.8188),('06494','CT','Wallingford','New Haven',41.4538,-72.8188),('06495','CT','Wallingford','New Haven',41.4588,-72.8041),('06497','CT','Stratford','Fairfield',41.1977,-73.1293),('06498','CT','Westbrook','Middlesex',41.289785,-72.463444),('06501','CT','New Haven','New Haven',41.308,-72.9286),('06502','CT','New Haven','New Haven',41.308,-72.9286),('06503','CT','New Haven','New Haven',41.308,-72.9286),('06504','CT','New Haven','New Haven',41.304697,-72.935614),('06505','CT','New Haven','New Haven',41.308,-72.9286),('06506','CT','New Haven','New Haven',41.308,-72.9286),('06507','CT','New Haven','New Haven',41.308,-72.9286),('06508','CT','New Haven','New Haven',41.308,-72.9286),('06509','CT','New Haven','New Haven',41.308,-72.9286),('06510','CT','New Haven','New Haven',41.307394,-72.925595),('06511','CT','New Haven','New Haven',41.31703,-72.927316),('06512','CT','East Haven','New Haven',41.278274,-72.875249),('06513','CT','New Haven','New Haven',41.3161,-72.881332),('06514','CT','Hamden','New Haven',41.361416,-72.939626),('06515','CT','New Haven','New Haven',41.331453,-72.966587),('06516','CT','West Haven','New Haven',41.272573,-72.964967),('06517','CT','Hamden','New Haven',41.34944,-72.907149),('06518','CT','Hamden','New Haven',41.415249,-72.908262),('06519','CT','New Haven','New Haven',41.296304,-72.936591),('06520','CT','New Haven','New Haven',41.319,-72.9552),('06521','CT','New Haven','New Haven',41.308,-72.9286),('06524','CT','Bethany','New Haven',41.422964,-72.994187),('06525','CT','Woodbridge','New Haven',41.352793,-73.008401),('06530','CT','New Haven','New Haven',41.3001,-72.9189),('06531','CT','New Haven','New Haven',41.3001,-72.9189),('06532','CT','New Haven','New Haven',41.3001,-72.9189),('06533','CT','New Haven','New Haven',41.3001,-72.9189),('06534','CT','New Haven','New Haven',41.3001,-72.9189),('06535','CT','New Haven','New Haven',41.3001,-72.9189),('06536','CT','New Haven','New Haven',41.3001,-72.9189),('06537','CT','New Haven','New Haven',41.4276,-72.9138),('06538','CT','New Haven','New Haven',41.4276,-72.9138),('06540','CT','New Haven','New Haven',41.308,-72.9286),('06601','CT','Bridgeport','Fairfield',41.1669,-73.2052),('06602','CT','Bridgeport','Fairfield',41.1669,-73.2052),('06604','CT','Bridgeport','Fairfield',41.177955,-73.199147),('06605','CT','Bridgeport','Fairfield',41.166439,-73.216075),('06606','CT','Bridgeport','Fairfield',41.20954,-73.207625),('06607','CT','Bridgeport','Fairfield',41.176374,-73.166056),('06608','CT','Bridgeport','Fairfield',41.187702,-73.181157),('06610','CT','Bridgeport','Fairfield',41.201525,-73.170058),('06611','CT','Trumbull','Fairfield',41.252179,-73.206481),('06612','CT','Easton','Fairfield',41.253562,-73.286145),('06614','CT','Stratford','Fairfield',41.218522,-73.135495),('06615','CT','Stratford','Fairfield',41.17691,-73.135766),('06650','CT','Bridgeport','Fairfield',41.1669,-73.2052),('06673','CT','Bridgeport','Fairfield',41.1669,-73.2052),('06699','CT','Bridgeport','Fairfield',41.1669,-73.2052),('06701','CT','Waterbury','New Haven',41.558,-73.0519),('06702','CT','Waterbury','New Haven',41.55647,-73.042002),('06703','CT','Waterbury','New Haven',41.558,-73.0519),('06704','CT','Waterbury','New Haven',41.577525,-73.033657),('06705','CT','Waterbury','New Haven',41.550693,-72.998383),('06706','CT','Waterbury','New Haven',41.536901,-73.028648),('06708','CT','Waterbury','New Haven',41.551769,-73.062152),('06710','CT','Waterbury','New Haven',41.569372,-73.044691),('06712','CT','Prospect','New Haven',41.499248,-72.975635),('06716','CT','Wolcott','New Haven',41.595964,-72.977937),('06720','CT','Waterbury','New Haven',41.558,-73.0519),('06721','CT','Waterbury','New Haven',41.558,-73.0519),('06722','CT','Waterbury','New Haven',41.558,-73.0519),('06723','CT','Waterbury','New Haven',41.558,-73.0519),('06724','CT','Waterbury','New Haven',41.558,-73.0519),('06725','CT','Waterbury','New Haven',41.558,-73.0519),('06726','CT','Waterbury','New Haven',41.558,-73.0519),('06749','CT','Waterbury','New Haven',41.558,-73.0519),('06750','CT','Bantam','Litchfield',41.720286,-73.251668),('06751','CT','Bethlehem','Litchfield',41.638891,-73.217263),('06752','CT','Bridgewater','Litchfield',41.526774,-73.36082),('06753','CT','Cornwall','Litchfield',41.8446,-73.3348),('06754','CT','Cornwall Bridge','Litchfield',41.775369,-73.363115),('06755','CT','Gaylordsville','Litchfield',41.650152,-73.476694),('06756','CT','Goshen','Litchfield',41.836632,-73.235717),('06757','CT','Kent','Litchfield',41.739719,-73.456412),('06758','CT','Lakeside','Litchfield',41.673737,-73.245753),('06759','CT','Litchfield','Litchfield',41.752998,-73.217211),('06762','CT','Middlebury','New Haven',41.525996,-73.117509),('06763','CT','Morris','Litchfield',41.692387,-73.198373),('06770','CT','Naugatuck','New Haven',41.491016,-73.051024),('06776','CT','New Milford','Litchfield',41.581359,-73.413282),('06777','CT','New Preston Marble Dale','Litchfield',41.691339,-73.33435),('06778','CT','Northfield','Litchfield',41.702993,-73.107638),('06779','CT','Oakville','Litchfield',41.592337,-73.085216),('06781','CT','Pequabuck','Litchfield',41.6727,-72.9936),('06782','CT','Plymouth','Litchfield',41.662586,-73.048123),('06783','CT','Roxbury','Litchfield',41.55828,-73.307564),('06784','CT','Sherman','Fairfield',41.571997,-73.49242),('06785','CT','South Kent','Litchfield',41.711618,-73.426927),('06786','CT','Terryville','Litchfield',41.677045,-73.010381),('06787','CT','Thomaston','Litchfield',41.672021,-73.082419),('06790','CT','Torrington','Litchfield',41.821419,-73.118832),('06791','CT','Harwinton','Litchfield',41.762442,-73.067691),('06792','CT','Torrington','Litchfield',41.752,-73.1056),('06793','CT','Washington','Litchfield',41.636203,-73.296901),('06794','CT','Washington Depot','Litchfield',41.646765,-73.32253),('06795','CT','Watertown','Litchfield',41.610315,-73.118419),('06796','CT','West Cornwall','Litchfield',41.871623,-73.331324),('06798','CT','Woodbury','Litchfield',41.554246,-73.202424),('06801','CT','Bethel','Fairfield',41.382767,-73.398042),('06804','CT','Brookfield','Fairfield',41.462974,-73.398169),('06807','CT','Cos Cob','Fairfield',41.048594,-73.591901),('06810','CT','Danbury','Fairfield',41.389529,-73.45388),('06811','CT','Danbury','Fairfield',41.419108,-73.4715),('06812','CT','New Fairfield','Fairfield',41.47661,-73.494302),('06813','CT','Danbury','Fairfield',41.3961,-73.4544),('06814','CT','Danbury','Fairfield',41.3719,-73.4929),('06816','CT','Danbury','Fairfield',41.3719,-73.4929),('06817','CT','Danbury','Fairfield',41.3947,-73.4544),('06820','CT','Darien','Fairfield',41.076992,-73.482501),('06824','CT','Fairfield','Fairfield',41.164656,-73.262795),('06825','CT','Fairfield','Fairfield',41.188555,-73.237259),('06828','CT','Fairfield','Fairfield',41.1411,-73.2642),('06829','CT','Georgetown','Fairfield',41.2555,-73.4352),('06830','CT','Greenwich','Fairfield',41.033449,-73.629028),('06831','CT','Greenwich','Fairfield',41.072358,-73.663346),('06832','CT','Greenwich','Fairfield',41.0254,-73.6264),('06836','CT','Greenwich','Fairfield',41.0254,-73.6264),('06838','CT','Greens Farms','Fairfield',41.1239,-73.3197),('06840','CT','New Canaan','Fairfield',41.150301,-73.491598),('06842','CT','New Canaan','Fairfield',41.1466,-73.4952),('06850','CT','Norwalk','Fairfield',41.124582,-73.436792),('06851','CT','Norwalk','Fairfield',41.133349,-73.40533),('06852','CT','Norwalk','Fairfield',41.1168,-73.4155),('06853','CT','Norwalk','Fairfield',41.0661,-73.438006),('06854','CT','Norwalk','Fairfield',41.093711,-73.429763),('06855','CT','Norwalk','Fairfield',41.097632,-73.398546),('06856','CT','Norwalk','Fairfield',41.111224,-73.420861),('06857','CT','Norwalk','Fairfield',41.0988,-73.422),('06858','CT','Norwalk','Fairfield',41.1175,-73.4083),('06859','CT','Norwalk','Fairfield',41.0988,-73.422),('06860','CT','Norwalk','Fairfield',41.1175,-73.4083),('06870','CT','Old Greenwich','Fairfield',41.034063,-73.568431),('06875','CT','Redding Center','Fairfield',41.3233,-73.3879),('06876','CT','Redding Ridge','Fairfield',41.3138,-73.3508),('06877','CT','Ridgefield','Fairfield',41.298518,-73.499907),('06878','CT','Riverside','Fairfield',41.034988,-73.580377),('06879','CT','Ridgefield','Fairfield',41.2813,-73.4986),('06880','CT','Westport','Fairfield',41.138435,-73.352019),('06881','CT','Westport','Fairfield',41.1413,-73.3617),('06883','CT','Weston','Fairfield',41.215991,-73.373005),('06888','CT','Westport','Fairfield',41.1413,-73.3617),('06889','CT','Westport','Fairfield',41.1413,-73.3617),('06890','CT','Southport','Fairfield',41.141003,-73.287847),('06896','CT','Redding','Fairfield',41.305777,-73.39662),('06897','CT','Wilton','Fairfield',41.200164,-73.434779),('06901','CT','Stamford','Fairfield',41.053457,-73.537485),('06902','CT','Stamford','Fairfield',41.054496,-73.541871),('06903','CT','Stamford','Fairfield',41.136018,-73.571142),('06904','CT','Stamford','Fairfield',41.0485,-73.5396),('06905','CT','Stamford','Fairfield',41.082579,-73.545554),('06906','CT','Stamford','Fairfield',41.070822,-73.523923),('06907','CT','Stamford','Fairfield',41.095077,-73.519883),('06910','CT','Stamford','Fairfield',41.0389,-73.5593),('06911','CT','Stamford','Fairfield',41.0389,-73.5593),('06912','CT','Stamford','Fairfield',41.0533,-73.5391),('06913','CT','Stamford','Fairfield',41.0389,-73.5593),('06914','CT','Stamford','Fairfield',41.0389,-73.5593),('06920','CT','Stamford','Fairfield',41.0533,-73.5391),('06921','CT','Stamford','Fairfield',41.0493,-73.5394),('06922','CT','Stamford','Fairfield',41.0389,-73.5593),('06925','CT','Stamford','Fairfield',41.0533,-73.5391),('06926','CT','Stamford','Fairfield',41.0389,-73.5593),('06927','CT','Stamford','Fairfield',41.0389,-73.5593),('06928','CT','Stamford','Fairfield',41.0389,-73.5593),('07001','NJ','Avenel','Middlesex',40.5817,-74.277745),('07002','NJ','Bayonne','Hudson',40.665753,-74.118367),('07003','NJ','Bloomfield','Essex',40.802874,-74.188646),('07004','NJ','Fairfield','Essex',40.881606,-74.29534),('07005','NJ','Boonton','Morris',40.911563,-74.41528),('07006','NJ','Caldwell','Essex',40.850783,-74.276954),('07007','NJ','Caldwell','Essex',40.8567,-74.3083),('07008','NJ','Carteret','Middlesex',40.582202,-74.229999),('07009','NJ','Cedar Grove','Essex',40.855743,-74.22921),('07010','NJ','Cliffside Park','Bergen',40.821877,-73.988478),('07011','NJ','Clifton','Passaic',40.880427,-74.143246),('07012','NJ','Clifton','Passaic',40.847918,-74.157897),('07013','NJ','Clifton','Passaic',40.870568,-74.171781),('07014','NJ','Clifton','Passaic',40.831337,-74.135432),('07015','NJ','Clifton','Passaic',40.8691,-74.1518),('07016','NJ','Cranford','Union',40.65557,-74.304826),('07017','NJ','East Orange','Essex',40.771682,-74.206398),('07018','NJ','East Orange','Essex',40.756769,-74.21629),('07019','NJ','East Orange','Essex',40.7609,-74.2097),('07020','NJ','Edgewater','Bergen',40.827732,-73.976051),('07021','NJ','Essex Fells','Essex',40.827431,-74.280769),('07022','NJ','Fairview','Bergen',40.816705,-74.000698),('07023','NJ','Fanwood','Union',40.641273,-74.385965),('07024','NJ','Fort Lee','Bergen',40.847323,-73.975797),('07026','NJ','Garfield','Bergen',40.879396,-74.1069),('07027','NJ','Garwood','Union',40.651293,-74.323437),('07028','NJ','Glen Ridge','Essex',40.804798,-74.204569),('07029','NJ','Harrison','Hudson',40.74588,-74.156611),('07030','NJ','Hoboken','Hudson',40.744867,-74.032925),('07031','NJ','North Arlington','Bergen',40.791334,-74.132818),('07032','NJ','Kearny','Hudson',40.763051,-74.137187),('07033','NJ','Kenilworth','Union',40.677113,-74.292057),('07034','NJ','Lake Hiawatha','Morris',40.881235,-74.380804),('07035','NJ','Lincoln Park','Morris',40.923586,-74.296975),('07036','NJ','Linden','Union',40.63392,-74.249896),('07039','NJ','Livingston','Essex',40.789092,-74.32145),('07040','NJ','Maplewood','Essex',40.727992,-74.266549),('07041','NJ','Millburn','Essex',40.723266,-74.298983),('07042','NJ','Montclair','Essex',40.813151,-74.21582),('07043','NJ','Montclair','Essex',40.844008,-74.202114),('07044','NJ','Verona','Essex',40.830534,-74.243009),('07045','NJ','Montville','Morris',40.906942,-74.365608),('07046','NJ','Mountain Lakes','Morris',40.891374,-74.441114),('07047','NJ','North Bergen','Hudson',40.7946,-74.019621),('07050','NJ','Orange','Essex',40.76804,-74.235692),('07051','NJ','Orange','Essex',40.7735,-74.2335),('07052','NJ','West Orange','Essex',40.788567,-74.255321),('07054','NJ','Parsippany','Morris',40.858884,-74.411877),('07055','NJ','Passaic','Passaic',40.857552,-74.129089),('07057','NJ','Wallington','Bergen',40.853496,-74.108896),('07058','NJ','Pine Brook','Morris',40.869148,-74.342865),('07059','NJ','Warren','Somerset',40.636914,-74.512436),('07060','NJ','Plainfield','Union',40.617143,-74.423066),('07061','NJ','Plainfield','Union',40.6195,-74.421),('07062','NJ','Plainfield','Union',40.631253,-74.403884),('07063','NJ','Plainfield','Union',40.604288,-74.445783),('07064','NJ','Port Reading','Middlesex',40.569089,-74.247061),('07065','NJ','Rahway','Union',40.608898,-74.281808),('07066','NJ','Clark','Union',40.620632,-74.309217),('07067','NJ','Colonia','Middlesex',40.591907,-74.314047),('07068','NJ','Roseland','Essex',40.821435,-74.304527),('07069','NJ','Watchung','Somerset',40.642845,-74.436233),('07070','NJ','Rutherford','Bergen',40.826696,-74.109136),('07071','NJ','Lyndhurst','Bergen',40.806694,-74.120813),('07072','NJ','Carlstadt','Bergen',40.833295,-74.081095),('07073','NJ','East Rutherford','Bergen',40.828525,-74.091647),('07074','NJ','Moonachie','Bergen',40.837237,-74.061991),('07075','NJ','Wood Ridge','Bergen',40.847329,-74.087457),('07076','NJ','Scotch Plains','Union',40.638396,-74.373952),('07077','NJ','Sewaren','Middlesex',40.553465,-74.256987),('07078','NJ','Short Hills','Essex',40.73603,-74.328291),('07079','NJ','South Orange','Essex',40.747776,-74.258502),('07080','NJ','South Plainfield','Middlesex',40.580416,-74.414252),('07081','NJ','Springfield','Union',40.701863,-74.322136),('07082','NJ','Towaco','Morris',40.926343,-74.346563),('07083','NJ','Union','Union',40.695266,-74.269078),('07086','NJ','Weehawken','Hudson',40.767174,-74.021573),('07087','NJ','Union City','Hudson',40.76765,-74.031677),('07088','NJ','Vauxhall','Union',40.718106,-74.283512),('07090','NJ','Westfield','Union',40.6495,-74.342242),('07091','NJ','Westfield','Union',40.652,-74.3476),('07092','NJ','Mountainside','Union',40.678495,-74.356356),('07093','NJ','West New York','Hudson',40.788758,-74.010707),('07094','NJ','Secaucus','Hudson',40.784022,-74.063606),('07095','NJ','Woodbridge','Middlesex',40.556048,-74.285093),('07096','NJ','Secaucus','Hudson',40.7735,-74.0642),('07097','NJ','Jersey City','Hudson',40.7164,-74.038),('07099','NJ','Kearny','Hudson',40.7683,-74.1458),('07101','NJ','Newark','Essex',40.7308,-74.1744),('07102','NJ','Newark','Essex',40.735333,-74.173875),('07103','NJ','Newark','Essex',40.738454,-74.194896),('07104','NJ','Newark','Essex',40.767816,-74.168376),('07105','NJ','Newark','Essex',40.72615,-74.148778),('07106','NJ','Newark','Essex',40.742131,-74.229851),('07107','NJ','Newark','Essex',40.760697,-74.187812),('07108','NJ','Newark','Essex',40.722691,-74.201279),('07109','NJ','Belleville','Essex',40.793463,-74.161187),('07110','NJ','Nutley','Essex',40.818874,-74.156688),('07111','NJ','Irvington','Essex',40.725549,-74.231823),('07112','NJ','Newark','Essex',40.711617,-74.212846),('07114','NJ','Newark','Essex',40.705516,-74.174731),('07175','NJ','Newark','Essex',40.7355,-74.1727),('07182','NJ','Newark','Essex',40.731,-74.174),('07184','NJ','Newark','Essex',40.7355,-74.1727),('07188','NJ','Newark','Essex',40.7355,-74.1727),('07189','NJ','Newark','Essex',40.7949,-74.1624),('07191','NJ','Newark','Essex',40.7355,-74.1727),('07192','NJ','Newark','Essex',40.7355,-74.1727),('07193','NJ','Newark','Essex',40.7355,-74.1727),('07194','NJ','Newark','Essex',40.7355,-74.1727),('07195','NJ','Newark','Essex',40.7355,-74.1727),('07198','NJ','Newark','Essex',40.7355,-74.1727),('07199','NJ','Newark','Essex',40.7355,-74.1727),('07201','NJ','Elizabeth','Union',40.67244,-74.194925),('07202','NJ','Elizabeth','Union',40.654064,-74.216622),('07203','NJ','Roselle','Union',40.653439,-74.260446),('07204','NJ','Roselle Park','Union',40.665557,-74.267514),('07205','NJ','Hillside','Union',40.695889,-74.2288),('07206','NJ','Elizabeth','Union',40.652952,-74.191762),('07207','NJ','Elizabeth','Union',40.6698,-74.2164),('07208','NJ','Elizabeth','Union',40.673147,-74.227945),('07302','NJ','Jersey City','Hudson',40.721136,-74.047264),('07303','NJ','Jersey City','Hudson',40.7164,-74.038),('07304','NJ','Jersey City','Hudson',40.716495,-74.072593),('07305','NJ','Jersey City','Hudson',40.701338,-74.088562),('07306','NJ','Jersey City','Hudson',40.733657,-74.065576),('07307','NJ','Jersey City','Hudson',40.747399,-74.049892),('07308','NJ','Jersey City','Hudson',40.7164,-74.038),('07309','NJ','Jersey City','Hudson',40.7164,-74.038),('07310','NJ','Jersey City','Hudson',40.731082,-74.038712),('07311','NJ','Jersey City','Hudson',40.720216,-74.032724),('07395','NJ','Jersey City','Hudson',40.7282,-74.0776),('07399','NJ','Jersey City','Hudson',40.728,-74.078),('07401','NJ','Allendale','Bergen',41.032669,-74.133826),('07403','NJ','Bloomingdale','Passaic',41.013835,-74.329397),('07405','NJ','Butler','Morris',40.993513,-74.361382),('07407','NJ','Elmwood Park','Bergen',40.905011,-74.122094),('07410','NJ','Fair Lawn','Bergen',40.934247,-74.115505),('07416','NJ','Franklin','Sussex',41.113663,-74.586975),('07417','NJ','Franklin Lakes','Bergen',41.010553,-74.20849),('07418','NJ','Glenwood','Sussex',41.233703,-74.485351),('07419','NJ','Hamburg','Sussex',41.154291,-74.575805),('07420','NJ','Haskell','Passaic',41.027936,-74.29813),('07421','NJ','Hewitt','Passaic',41.174644,-74.373295),('07422','NJ','Highland Lakes','Sussex',41.179521,-74.45418),('07423','NJ','Ho Ho Kus','Bergen',41.001527,-74.102377),('07424','NJ','Little Falls','Passaic',40.886206,-74.213663),('07428','NJ','Mc Afee','Sussex',41.181052,-74.517965),('07430','NJ','Mahwah','Bergen',41.078926,-74.159883),('07432','NJ','Midland Park','Bergen',40.993783,-74.142414),('07435','NJ','Newfoundland','Passaic',41.026028,-74.461917),('07436','NJ','Oakland','Bergen',41.028211,-74.238384),('07438','NJ','Oak Ridge','Morris',41.025111,-74.514404),('07439','NJ','Ogdensburg','Sussex',41.077932,-74.599771),('07440','NJ','Pequannock','Morris',40.946468,-74.29304),('07442','NJ','Pompton Lakes','Passaic',40.999215,-74.28763),('07444','NJ','Pompton Plains','Morris',40.966324,-74.30012),('07446','NJ','Ramsey','Bergen',41.058129,-74.140959),('07450','NJ','Ridgewood','Bergen',40.983641,-74.113129),('07451','NJ','Ridgewood','Bergen',40.9792,-74.1166),('07452','NJ','Glen Rock','Bergen',40.959471,-74.125202),('07456','NJ','Ringwood','Passaic',41.100109,-74.260107),('07457','NJ','Riverdale','Morris',40.99294,-74.308835),('07458','NJ','Saddle River','Bergen',41.050049,-74.100898),('07460','NJ','Stockholm','Sussex',41.099795,-74.513468),('07461','NJ','Sussex','Sussex',41.231664,-74.590881),('07462','NJ','Vernon','Sussex',41.192148,-74.508313),('07463','NJ','Waldwick','Bergen',41.013262,-74.122377),('07465','NJ','Wanaque','Passaic',41.051135,-74.282987),('07470','NJ','Wayne','Passaic',40.939765,-74.251285),('07474','NJ','Wayne','Passaic',40.9128,-74.2631),('07477','NJ','Wayne','Passaic',40.9252,-74.2769),('07480','NJ','West Milford','Passaic',41.098335,-74.372799),('07481','NJ','Wyckoff','Bergen',40.999093,-74.168849),('07495','NJ','Mahwah','Bergen',41.0886,-74.1441),('07501','NJ','Paterson','Passaic',40.912324,-74.169318),('07502','NJ','Paterson','Passaic',40.917226,-74.194815),('07503','NJ','Paterson','Passaic',40.896979,-74.157079),('07504','NJ','Paterson','Passaic',40.91252,-74.142699),('07505','NJ','Paterson','Passaic',40.915997,-74.171175),('07506','NJ','Hawthorne','Passaic',40.957279,-74.156125),('07507','NJ','Hawthorne','Passaic',40.9486,-74.1538),('07508','NJ','Haledon','Passaic',40.945949,-74.181267),('07509','NJ','Paterson','Passaic',40.9146,-74.1682),('07510','NJ','Paterson','Passaic',40.9146,-74.1682),('07511','NJ','Totowa','Passaic',40.9028,-74.2162),('07512','NJ','Totowa','Passaic',40.901333,-74.218722),('07513','NJ','Paterson','Passaic',40.905828,-74.147841),('07514','NJ','Paterson','Passaic',40.924786,-74.144542),('07522','NJ','Paterson','Passaic',40.925284,-74.177111),('07524','NJ','Paterson','Passaic',40.931711,-74.15687),('07533','NJ','Paterson','Passaic',40.8945,-74.1603),('07538','NJ','Haledon','Passaic',40.9377,-74.1822),('07543','NJ','Paterson','Passaic',40.906,-74.1527),('07544','NJ','Paterson','Passaic',40.9335,-74.1545),('07601','NJ','Hackensack','Bergen',40.887848,-74.047745),('07602','NJ','Hackensack','Bergen',40.8853,-74.0441),('07603','NJ','Bogota','Bergen',40.873927,-74.027809),('07604','NJ','Hasbrouck Heights','Bergen',40.863512,-74.074411),('07605','NJ','Leonia','Bergen',40.863391,-73.988471),('07606','NJ','South Hackensack','Bergen',40.862151,-74.046974),('07607','NJ','Maywood','Bergen',40.905063,-74.062773),('07608','NJ','Teterboro','Bergen',40.852994,-74.060355),('07620','NJ','Alpine','Bergen',40.952819,-73.931111),('07621','NJ','Bergenfield','Bergen',40.924737,-73.999012),('07624','NJ','Closter','Bergen',40.97201,-73.961857),('07626','NJ','Cresskill','Bergen',40.942672,-73.964678),('07627','NJ','Demarest','Bergen',40.955531,-73.960714),('07628','NJ','Dumont','Bergen',40.945239,-73.992428),('07630','NJ','Emerson','Bergen',40.976145,-74.026835),('07631','NJ','Englewood','Bergen',40.893855,-73.976627),('07632','NJ','Englewood Cliffs','Bergen',40.882542,-73.952847),('07640','NJ','Harrington Park','Bergen',40.988709,-73.980613),('07641','NJ','Haworth','Bergen',40.961083,-73.989068),('07642','NJ','Hillsdale','Bergen',41.006669,-74.042516),('07643','NJ','Little Ferry','Bergen',40.848201,-74.040349),('07644','NJ','Lodi','Bergen',40.877629,-74.082905),('07645','NJ','Montvale','Bergen',41.049075,-74.04046),('07646','NJ','New Milford','Bergen',40.936199,-74.019023),('07647','NJ','Northvale','Bergen',41.010635,-73.951164),('07648','NJ','Norwood','Bergen',40.994547,-73.956007),('07649','NJ','Oradell','Bergen',40.953084,-74.031248),('07650','NJ','Palisades Park','Bergen',40.845745,-73.994862),('07652','NJ','Paramus','Bergen',40.948759,-74.070055),('07653','NJ','Paramus','Bergen',40.9483,-74.0689),('07656','NJ','Park Ridge','Bergen',41.034672,-74.040797),('07657','NJ','Ridgefield','Bergen',40.832717,-74.004755),('07660','NJ','Ridgefield Park','Bergen',40.856708,-74.022653),('07661','NJ','River Edge','Bergen',40.926766,-74.037468),('07662','NJ','Rochelle Park','Bergen',40.906496,-74.078005),('07663','NJ','Saddle Brook','Bergen',40.904603,-74.093962),('07666','NJ','Teaneck','Bergen',40.892683,-74.011641),('07670','NJ','Tenafly','Bergen',40.924559,-73.964846),('07675','NJ','Westwood','Bergen',40.999314,-74.014884),('07676','NJ','Township Of Washington','Bergen',40.989429,-74.06125),('07677','NJ','Woodcliff Lake','Bergen',41.023333,-74.059028),('07699','NJ','Teterboro','Bergen',40.8597,-74.0597),('07701','NJ','Red Bank','Monmouth',40.356623,-74.083871),('07702','NJ','Shrewsbury','Monmouth',40.326516,-74.059309),('07703','NJ','Fort Monmouth','Monmouth',40.314589,-74.043473),('07704','NJ','Fair Haven','Monmouth',40.360347,-74.037847),('07709','NJ','Red Bank','Monmouth',40.2393,-74.0051),('07710','NJ','Adelphia','Monmouth',40.218,-74.2566),('07711','NJ','Allenhurst','Monmouth',40.237603,-74.006722),('07712','NJ','Asbury Park','Monmouth',40.237117,-74.035165),('07715','NJ','Belmar','Monmouth',40.174,-74.0272),('07716','NJ','Atlantic Highlands','Monmouth',40.406757,-74.033659),('07717','NJ','Avon By The Sea','Monmouth',40.191588,-74.017255),('07718','NJ','Belford','Monmouth',40.417783,-74.087109),('07719','NJ','Belmar','Monmouth',40.172778,-74.052185),('07720','NJ','Bradley Beach','Monmouth',40.201884,-74.013809),('07721','NJ','Cliffwood','Monmouth',40.435334,-74.235966),('07722','NJ','Colts Neck','Monmouth',40.279803,-74.172507),('07723','NJ','Deal','Monmouth',40.249716,-74.000514),('07724','NJ','Eatontown','Monmouth',40.300342,-74.071369),('07726','NJ','Englishtown','Monmouth',40.297122,-74.330015),('07727','NJ','Farmingdale','Monmouth',40.205491,-74.157535),('07728','NJ','Freehold','Monmouth',40.24013,-74.275456),('07730','NJ','Hazlet','Monmouth',40.423713,-74.178971),('07731','NJ','Howell','Monmouth',40.146842,-74.206216),('07732','NJ','Highlands','Monmouth',40.419151,-73.986745),('07733','NJ','Holmdel','Monmouth',40.38357,-74.169994),('07734','NJ','Keansburg','Monmouth',40.442989,-74.134775),('07735','NJ','Keyport','Monmouth',40.43873,-74.193269),('07737','NJ','Leonardo','Monmouth',40.415969,-74.060711),('07738','NJ','Lincroft','Monmouth',40.335446,-74.124069),('07739','NJ','Little Silver','Monmouth',40.334981,-74.041125),('07740','NJ','Long Branch','Monmouth',40.298905,-73.991746),('07746','NJ','Marlboro','Monmouth',40.318129,-74.257208),('07747','NJ','Matawan','Monmouth',40.414524,-74.240015),('07748','NJ','Middletown','Monmouth',40.406041,-74.112689),('07750','NJ','Monmouth Beach','Monmouth',40.333406,-73.983523),('07751','NJ','Morganville','Monmouth',40.359105,-74.270747),('07752','NJ','Navesink','Monmouth',40.3994,-74.0358),('07753','NJ','Neptune','Monmouth',40.212509,-74.059321),('07754','NJ','Neptune','Monmouth',40.2218,-74.0441),('07755','NJ','Oakhurst','Monmouth',40.263574,-74.020263),('07756','NJ','Ocean Grove','Monmouth',40.211815,-74.009431),('07757','NJ','Oceanport','Monmouth',40.315647,-74.015675),('07758','NJ','Port Monmouth','Monmouth',40.42798,-74.105142),('07760','NJ','Rumson','Monmouth',40.369052,-73.996641),('07762','NJ','Spring Lake','Monmouth',40.153409,-74.033732),('07763','NJ','Tennent','Monmouth',40.2794,-74.3347),('07764','NJ','West Long Branch','Monmouth',40.290913,-74.016847),('07765','NJ','Wickatunk','Monmouth',40.35,-74.2483),('07799','NJ','Eatontown','Monmouth',40.363,-74.0776),('07801','NJ','Dover','Morris',40.900458,-74.550913),('07802','NJ','Dover','Morris',40.8848,-74.5588),('07803','NJ','Mine Hill','Morris',40.879466,-74.600606),('07806','NJ','Picatinny Arsenal','Morris',40.8866,-74.5809),('07820','NJ','Allamuchy','Warren',40.9216,-74.8105),('07821','NJ','Andover','Sussex',40.968052,-74.742328),('07822','NJ','Augusta','Sussex',41.137333,-74.704495),('07823','NJ','Belvidere','Warren',40.827177,-75.050068),('07825','NJ','Blairstown','Warren',40.969829,-74.959725),('07826','NJ','Branchville','Sussex',41.176069,-74.759945),('07827','NJ','Montague','Sussex',41.301558,-74.756361),('07828','NJ','Budd Lake','Morris',40.880981,-74.741144),('07829','NJ','Buttzville','Warren',40.8322,-75.0066),('07830','NJ','Califon','Hunterdon',40.724087,-74.818184),('07831','NJ','Changewater','Warren',40.738,-74.9444),('07832','NJ','Columbia','Warren',40.942904,-75.067006),('07833','NJ','Delaware','Warren',40.89564,-75.067135),('07834','NJ','Denville','Morris',40.885893,-74.486606),('07836','NJ','Flanders','Morris',40.85089,-74.703817),('07837','NJ','Glasser','Sussex',40.99,-74.6204),('07838','NJ','Great Meadows','Warren',40.885345,-74.900919),('07839','NJ','Greendell','Sussex',40.9738,-74.8213),('07840','NJ','Hackettstown','Warren',40.854696,-74.829553),('07842','NJ','Hibernia','Morris',40.94239,-74.49725),('07843','NJ','Hopatcong','Sussex',40.938025,-74.66088),('07844','NJ','Hope','Warren',40.9111,-74.9677),('07845','NJ','Ironia','Morris',40.8227,-74.6261),('07846','NJ','Johnsonburg','Warren',40.964334,-74.876052),('07847','NJ','Kenvil','Morris',40.880151,-74.623946),('07848','NJ','Lafayette','Sussex',41.098777,-74.69027),('07849','NJ','Lake Hopatcong','Morris',40.963479,-74.613416),('07850','NJ','Landing','Morris',40.908377,-74.657278),('07851','NJ','Layton','Sussex',41.231437,-74.846827),('07852','NJ','Ledgewood','Morris',40.885519,-74.658913),('07853','NJ','Long Valley','Morris',40.787399,-74.78213),('07855','NJ','Middleville','Sussex',41.0558,-74.8633),('07856','NJ','Mount Arlington','Morris',40.916194,-74.636992),('07857','NJ','Netcong','Morris',40.897852,-74.701704),('07860','NJ','Newton','Sussex',41.066069,-74.80265),('07863','NJ','Oxford','Warren',40.818578,-74.973761),('07865','NJ','Port Murray','Warren',40.784095,-74.897436),('07866','NJ','Rockaway','Morris',40.927641,-74.505413),('07869','NJ','Randolph','Morris',40.84786,-74.575183),('07870','NJ','Schooleys Mountain','Morris',40.804015,-74.819675),('07871','NJ','Sparta','Sussex',41.038325,-74.642007),('07874','NJ','Stanhope','Sussex',40.917356,-74.722802),('07875','NJ','Stillwater','Sussex',41.0358,-74.8786),('07876','NJ','Succasunna','Morris',40.855854,-74.652412),('07877','NJ','Swartswood','Sussex',41.0869,-74.8275),('07878','NJ','Mount Tabor','Morris',40.872016,-74.478841),('07879','NJ','Tranquility','Sussex',40.9561,-74.8088),('07880','NJ','Vienna','Warren',40.87481,-74.889786),('07881','NJ','Wallpack Center','Sussex',41.125256,-74.913779),('07882','NJ','Washington','Warren',40.754663,-74.99001),('07885','NJ','Wharton','Morris',40.91857,-74.584422),('07890','NJ','Branchville','Sussex',41.1463,-74.7527),('07901','NJ','Summit','Union',40.714418,-74.363079),('07902','NJ','Summit','Union',40.7163,-74.36),('07920','NJ','Basking Ridge','Somerset',40.678663,-74.5702),('07921','NJ','Bedminster','Somerset',40.651185,-74.652431),('07922','NJ','Berkeley Heights','Union',40.678362,-74.431838),('07924','NJ','Bernardsville','Somerset',40.72381,-74.577424),('07926','NJ','Brookside','Morris',40.801262,-74.570122),('07927','NJ','Cedar Knolls','Morris',40.822108,-74.450635),('07928','NJ','Chatham','Morris',40.731043,-74.400152),('07930','NJ','Chester','Morris',40.788452,-74.687814),('07931','NJ','Far Hills','Somerset',40.703725,-74.645821),('07932','NJ','Florham Park','Morris',40.776521,-74.390439),('07933','NJ','Gillette','Morris',40.683174,-74.467868),('07934','NJ','Gladstone','Somerset',40.721879,-74.668316),('07935','NJ','Green Village','Morris',40.735502,-74.451188),('07936','NJ','East Hanover','Morris',40.818553,-74.363742),('07938','NJ','Liberty Corner','Somerset',40.6647,-74.5777),('07939','NJ','Lyons','Somerset',40.666754,-74.556372),('07940','NJ','Madison','Morris',40.759992,-74.415767),('07945','NJ','Mendham','Morris',40.782221,-74.594785),('07946','NJ','Millington','Morris',40.675044,-74.514786),('07950','NJ','Morris Plains','Morris',40.846026,-74.482314),('07960','NJ','Morristown','Morris',40.791759,-74.482031),('07961','NJ','Morristown','Morris',40.7966,-74.4819),('07962','NJ','Morristown','Morris',40.8051,-74.4647),('07963','NJ','Morristown','Morris',40.8051,-74.4647),('07970','NJ','Mount Freedom','Morris',40.807897,-74.572814),('07974','NJ','New Providence','Union',40.697598,-74.401977),('07976','NJ','New Vernon','Morris',40.7226,-74.493417),('07977','NJ','Peapack','Somerset',40.7068,-74.661187),('07978','NJ','Pluckemin','Somerset',40.6455,-74.6394),('07979','NJ','Pottersville','Hunterdon',40.703474,-74.719927),('07980','NJ','Stirling','Morris',40.674029,-74.495567),('07981','NJ','Whippany','Morris',40.821669,-74.425099),('07983','NJ','Whippany','Morris',40.823,-74.4188),('07999','NJ','Whippany','Morris',40.8252,-74.4369),('08001','NJ','Alloway','Salem',39.560014,-75.358132),('08002','NJ','Cherry Hill','Camden',39.930041,-75.024336),('08003','NJ','Cherry Hill','Camden',39.880602,-74.973066),('08004','NJ','Atco','Camden',39.765101,-74.877077),('08005','NJ','Barnegat','Ocean',39.760738,-74.275761),('08006','NJ','Barnegat Light','Ocean',39.753725,-74.110303),('08007','NJ','Barrington','Camden',39.868038,-75.054207),('08008','NJ','Beach Haven','Ocean',39.619116,-74.199541),('08009','NJ','Berlin','Camden',39.776452,-74.933664),('08010','NJ','Beverly','Burlington',40.057604,-74.91404),('08011','NJ','Birmingham','Burlington',39.972692,-74.713108),('08012','NJ','Blackwood','Camden',39.784702,-75.057041),('08014','NJ','Bridgeport','Gloucester',39.803594,-75.348775),('08015','NJ','Browns Mills','Burlington',39.951583,-74.551868),('08016','NJ','Burlington','Burlington',40.067765,-74.843771),('08018','NJ','Cedar Brook','Camden',39.7152,-74.9011),('08019','NJ','Chatsworth','Burlington',39.777292,-74.534218),('08020','NJ','Clarksboro','Gloucester',39.801658,-75.223788),('08021','NJ','Clementon','Camden',39.809097,-74.999293),('08022','NJ','Columbus','Burlington',40.075264,-74.711452),('08023','NJ','Deepwater','Salem',39.685806,-75.495412),('08025','NJ','Ewan','Gloucester',39.6986,-75.1863),('08026','NJ','Gibbsboro','Camden',39.835943,-74.965733),('08027','NJ','Gibbstown','Gloucester',39.824315,-75.280482),('08028','NJ','Glassboro','Gloucester',39.700945,-75.117697),('08029','NJ','Glendora','Camden',39.840297,-75.07008),('08030','NJ','Gloucester City','Camden',39.891694,-75.116692),('08031','NJ','Bellmawr','Camden',39.867686,-75.093563),('08032','NJ','Grenloch','Gloucester',39.781264,-75.0609),('08033','NJ','Haddonfield','Camden',39.895361,-75.040201),('08034','NJ','Cherry Hill','Camden',39.908933,-74.999226),('08035','NJ','Haddon Heights','Camden',39.879127,-75.065918),('08036','NJ','Hainesport','Burlington',39.981224,-74.832886),('08037','NJ','Hammonton','Atlantic',39.625668,-74.775377),('08038','NJ','Hancocks Bridge','Salem',39.488507,-75.49404),('08039','NJ','Harrisonville','Gloucester',39.685522,-75.266963),('08041','NJ','Jobstown','Burlington',40.03591,-74.690967),('08042','NJ','Juliustown','Burlington',40.013446,-74.662488),('08043','NJ','Voorhees','Camden',39.847333,-74.960209),('08045','NJ','Lawnside','Camden',39.868933,-75.032164),('08046','NJ','Willingboro','Burlington',40.02938,-74.884509),('08048','NJ','Lumberton','Burlington',39.968554,-74.797647),('08049','NJ','Magnolia','Camden',39.854163,-75.037574),('08050','NJ','Manahawkin','Ocean',39.705877,-74.260163),('08051','NJ','Mantua','Gloucester',39.786451,-75.179582),('08052','NJ','Maple Shade','Burlington',39.952381,-74.994896),('08053','NJ','Marlton','Burlington',39.879888,-74.901268),('08054','NJ','Mount Laurel','Burlington',39.949075,-74.90331),('08055','NJ','Medford','Burlington',39.863376,-74.819123),('08056','NJ','Mickleton','Gloucester',39.787247,-75.248755),('08057','NJ','Moorestown','Burlington',39.969142,-74.949107),('08059','NJ','Mount Ephraim','Camden',39.884825,-75.092667),('08060','NJ','Mount Holly','Burlington',40.003333,-74.791073),('08061','NJ','Mount Royal','Gloucester',39.807517,-75.206517),('08062','NJ','Mullica Hill','Gloucester',39.716075,-75.219264),('08063','NJ','National Park','Gloucester',39.866368,-75.178518),('08064','NJ','New Lisbon','Burlington',39.957492,-74.630716),('08065','NJ','Palmyra','Burlington',40.002251,-75.027077),('08066','NJ','Paulsboro','Gloucester',39.834298,-75.228463),('08067','NJ','Pedricktown','Salem',39.739885,-75.411655),('08068','NJ','Pemberton','Burlington',39.961394,-74.665924),('08069','NJ','Penns Grove','Salem',39.711374,-75.465285),('08070','NJ','Pennsville','Salem',39.641811,-75.515317),('08071','NJ','Pitman','Gloucester',39.730445,-75.129371),('08072','NJ','Quinton','Salem',39.544638,-75.418269),('08073','NJ','Rancocas','Burlington',40.010517,-74.868014),('08074','NJ','Richwood','Gloucester',39.716166,-75.16344),('08075','NJ','Riverside','Burlington',40.030084,-74.951053),('08076','NJ','Riverton','Burlington',40.0094,-75.0116),('08077','NJ','Riverton','Burlington',39.998384,-74.999241),('08078','NJ','Runnemede','Camden',39.851925,-75.077031),('08079','NJ','Salem','Salem',39.548145,-75.441819),('08080','NJ','Sewell','Gloucester',39.751409,-75.104593),('08081','NJ','Sicklerville','Camden',39.738168,-74.99075),('08083','NJ','Somerdale','Camden',39.842724,-75.024951),('08084','NJ','Stratford','Camden',39.82926,-75.013882),('08085','NJ','Swedesboro','Gloucester',39.753766,-75.33104),('08086','NJ','Thorofare','Gloucester',39.842012,-75.185397),('08087','NJ','Tuckerton','Ocean',39.598676,-74.361514),('08088','NJ','Vincentown','Burlington',39.865646,-74.699429),('08089','NJ','Waterford Works','Camden',39.720972,-74.852191),('08090','NJ','Wenonah','Gloucester',39.796374,-75.151912),('08091','NJ','West Berlin','Camden',39.80522,-74.93152),('08092','NJ','West Creek','Ocean',39.661491,-74.292501),('08093','NJ','Westville','Gloucester',39.862478,-75.132224),('08094','NJ','Williamstown','Gloucester',39.659899,-74.968792),('08095','NJ','Winslow','Camden',39.64818,-74.861065),('08096','NJ','Blackwood Ter','Gloucester',39.83047,-75.131686),('08097','NJ','Woodbury Heights','Gloucester',39.815179,-75.151854),('08098','NJ','Woodstown','Salem',39.639535,-75.329849),('08099','NJ','Bellmawr','Camden',39.8675,-75.095),('08101','NJ','Camden','Camden',39.9458,-75.1221),('08102','NJ','Camden','Camden',39.950067,-75.119265),('08103','NJ','Camden','Camden',39.936483,-75.114651),('08104','NJ','Camden','Camden',39.91645,-75.109597),('08105','NJ','Camden','Camden',39.949827,-75.088373),('08106','NJ','Audubon','Camden',39.890992,-75.073329),('08107','NJ','Oaklyn','Camden',39.907848,-75.087118),('08108','NJ','Collingswood','Camden',39.915529,-75.064033),('08109','NJ','Merchantville','Camden',39.949023,-75.052428),('08110','NJ','Pennsauken','Camden',39.964864,-75.058203),('08201','NJ','Absecon','Atlantic',39.428977,-74.504051),('08202','NJ','Avalon','Cape May',39.093507,-74.730105),('08203','NJ','Brigantine','Atlantic',39.40257,-74.378428),('08204','NJ','Cape May','Cape May',38.964368,-74.926611),('08205','NJ','Absecon','Atlantic',39.477569,-74.494652),('08210','NJ','Cape May Court House','Cape May',39.093972,-74.822923),('08212','NJ','Cape May Point','Cape May',38.935578,-74.961486),('08213','NJ','Cologne','Atlantic',39.5047,-74.6136),('08214','NJ','Dennisville','Cape May',39.193,-74.8255),('08215','NJ','Egg Harbor City','Atlantic',39.552034,-74.609802),('08217','NJ','Elwood','Atlantic',39.575761,-74.719161),('08218','NJ','Goshen','Cape May',39.1413,-74.8533),('08219','NJ','Green Creek','Cape May',39.0461,-74.9016),('08220','NJ','Leeds Point','Atlantic',39.4919,-74.4294),('08221','NJ','Linwood','Atlantic',39.346903,-74.574258),('08223','NJ','Marmora','Cape May',39.266333,-74.65269),('08224','NJ','New Gretna','Burlington',39.601878,-74.467363),('08225','NJ','Northfield','Atlantic',39.369659,-74.551989),('08226','NJ','Ocean City','Cape May',39.264146,-74.595249),('08230','NJ','Ocean View','Cape May',39.210516,-74.707023),('08231','NJ','Oceanville','Atlantic',39.4711,-74.4608),('08232','NJ','Pleasantville','Atlantic',39.393615,-74.522082),('08234','NJ','Egg Harbor Township','Atlantic',39.398098,-74.596279),('08240','NJ','Pomona','Atlantic',39.492668,-74.533251),('08241','NJ','Port Republic','Atlantic',39.529037,-74.490956),('08242','NJ','Rio Grande','Cape May',39.019051,-74.87787),('08243','NJ','Sea Isle City','Cape May',39.14641,-74.700088),('08244','NJ','Somers Point','Atlantic',39.319379,-74.598708),('08245','NJ','South Dennis','Cape May',39.176208,-74.817235),('08246','NJ','South Seaville','Cape May',39.180965,-74.765806),('08247','NJ','Stone Harbor','Cape May',39.052464,-74.766719),('08248','NJ','Strathmere','Cape May',39.196778,-74.65774),('08250','NJ','Tuckahoe','Cape May',39.29,-74.7541),('08251','NJ','Villas','Cape May',39.022183,-74.936),('08252','NJ','Whitesboro','Cape May',39.037404,-74.857494),('08260','NJ','Wildwood','Cape May',38.989119,-74.823819),('08270','NJ','Woodbine','Cape May',39.266781,-74.799247),('08302','NJ','Bridgeton','Cumberland',39.435967,-75.24771),('08310','NJ','Buena','Atlantic',39.522077,-74.907842),('08311','NJ','Cedarville','Cumberland',39.333305,-75.205831),('08312','NJ','Clayton','Gloucester',39.65614,-75.0877),('08313','NJ','Deerfield Street','Cumberland',39.530314,-75.229013),('08314','NJ','Delmont','Cumberland',39.236912,-74.947828),('08315','NJ','Dividing Creek','Cumberland',39.2702,-75.1013),('08316','NJ','Dorchester','Cumberland',39.274671,-74.967507),('08317','NJ','Dorothy','Atlantic',39.405821,-74.828214),('08318','NJ','Elmer','Salem',39.552116,-75.169303),('08319','NJ','Estell Manor','Atlantic',39.362915,-74.826117),('08320','NJ','Fairton','Cumberland',39.3816,-75.2202),('08321','NJ','Fortescue','Cumberland',39.23625,-75.13795),('08322','NJ','Franklinville','Gloucester',39.611103,-75.048771),('08323','NJ','Greenwich','Cumberland',39.402891,-75.366961),('08324','NJ','Heislerville','Cumberland',39.224372,-75.000227),('08326','NJ','Landisville','Atlantic',39.52597,-74.936291),('08327','NJ','Leesburg','Cumberland',39.255559,-74.986515),('08328','NJ','Malaga','Gloucester',39.574417,-75.056062),('08329','NJ','Mauricetown','Cumberland',39.284171,-74.99447),('08330','NJ','Mays Landing','Atlantic',39.47497,-74.746539),('08332','NJ','Millville','Cumberland',39.377595,-75.026451),('08340','NJ','Milmay','Atlantic',39.440649,-74.875169),('08341','NJ','Minotola','Atlantic',39.521228,-74.950215),('08342','NJ','Mizpah','Atlantic',39.4866,-74.8361),('08343','NJ','Monroeville','Gloucester',39.638205,-75.149684),('08344','NJ','Newfield','Gloucester',39.558075,-75.016489),('08345','NJ','Newport','Cumberland',39.273333,-75.171555),('08346','NJ','Newtonville','Atlantic',39.565043,-74.861716),('08347','NJ','Norma','Salem',39.4961,-75.0883),('08348','NJ','Port Elizabeth','Cumberland',39.307484,-74.979566),('08349','NJ','Port Norris','Cumberland',39.265257,-75.065483),('08350','NJ','Richland','Atlantic',39.490653,-74.871767),('08352','NJ','Rosenhayn','Cumberland',39.475606,-75.12926),('08353','NJ','Shiloh','Cumberland',39.45819,-75.297636),('08360','NJ','Vineland','Cumberland',39.490578,-75.017283),('08361','NJ','Vineland','Cumberland',39.460905,-74.976245),('08362','NJ','Vineland','Cumberland',39.4741,-74.9844),('08401','NJ','Atlantic City','Atlantic',39.365861,-74.440954),('08402','NJ','Margate City','Atlantic',39.329087,-74.507039),('08403','NJ','Longport','Atlantic',39.315304,-74.526471),('08404','NJ','Atlantic City','Atlantic',39.359,-74.4313),('08405','NJ','Atlantic City','Atlantic',39.3641,-74.4233),('08406','NJ','Ventnor City','Atlantic',39.342076,-74.48265),('08501','NJ','Allentown','Monmouth',40.161709,-74.561983),('08502','NJ','Belle Mead','Somerset',40.449506,-74.646404),('08504','NJ','Blawenburg','Somerset',40.4075,-74.703),('08505','NJ','Bordentown','Burlington',40.128338,-74.722084),('08510','NJ','Millstone Township','Monmouth',40.187207,-74.425013),('08511','NJ','Cookstown','Burlington',40.042379,-74.557037),('08512','NJ','Cranbury','Mercer',40.306573,-74.527375),('08514','NJ','Cream Ridge','Monmouth',40.124176,-74.491688),('08515','NJ','Chesterfield','Burlington',40.127285,-74.649463),('08518','NJ','Florence','Burlington',40.117722,-74.803048),('08520','NJ','Hightstown','Mercer',40.264168,-74.529738),('08525','NJ','Hopewell','Mercer',40.386889,-74.781606),('08526','NJ','Imlaystown','Monmouth',40.1668,-74.5236),('08527','NJ','Jackson','Ocean',40.113646,-74.328225),('08528','NJ','Kingston','Somerset',40.38432,-74.619706),('08530','NJ','Lambertville','Hunterdon',40.375263,-74.930847),('08533','NJ','New Egypt','Ocean',40.07679,-74.49528),('08534','NJ','Pennington','Mercer',40.319699,-74.785256),('08535','NJ','Millstone Township','Monmouth',40.234224,-74.440515),('08536','NJ','Plainsboro','Middlesex',40.332261,-74.581065),('08540','NJ','Princeton','Mercer',40.358763,-74.644436),('08541','NJ','Princeton','Mercer',40.3486,-74.6594),('08542','NJ','Princeton','Mercer',40.351658,-74.659756),('08543','NJ','Princeton','Mercer',40.3486,-74.6594),('08544','NJ','Princeton','Mercer',40.3444,-74.6554),('08550','NJ','Princeton Junction','Mercer',40.288927,-74.611966),('08551','NJ','Ringoes','Hunterdon',40.445949,-74.85195),('08553','NJ','Rocky Hill','Somerset',40.400348,-74.638922),('08554','NJ','Roebling','Burlington',40.117114,-74.778864),('08555','NJ','Roosevelt','Monmouth',40.218286,-74.470792),('08556','NJ','Rosemont','Hunterdon',40.4323,-75),('08557','NJ','Sergeantsville','Hunterdon',40.4458,-74.9438),('08558','NJ','Skillman','Somerset',40.410548,-74.697573),('08559','NJ','Stockton','Hunterdon',40.427413,-74.969992),('08560','NJ','Titusville','Mercer',40.303259,-74.85986),('08561','NJ','Windsor','Mercer',40.242009,-74.580064),('08562','NJ','Wrightstown','Burlington',40.055335,-74.585266),('08601','NJ','Trenton','Mercer',40.2169,-74.7433),('08602','NJ','Trenton','Mercer',40.2169,-74.7433),('08603','NJ','Trenton','Mercer',40.2169,-74.7433),('08604','NJ','Trenton','Mercer',40.2169,-74.7433),('08605','NJ','Trenton','Mercer',40.2169,-74.7433),('08606','NJ','Trenton','Mercer',40.2169,-74.7433),('08607','NJ','Trenton','Mercer',40.2169,-74.7433),('08608','NJ','Trenton','Mercer',40.218865,-74.765586),('08609','NJ','Trenton','Mercer',40.224975,-74.742152),('08610','NJ','Trenton','Mercer',40.199014,-74.720645),('08611','NJ','Trenton','Mercer',40.20631,-74.75155),('08618','NJ','Trenton','Mercer',40.238329,-74.781944),('08619','NJ','Trenton','Mercer',40.239431,-74.694958),('08620','NJ','Trenton','Mercer',40.173438,-74.665265),('08625','NJ','Trenton','Mercer',40.206709,-74.756435),('08628','NJ','Trenton','Mercer',40.260653,-74.827443),('08629','NJ','Trenton','Mercer',40.219163,-74.732482),('08638','NJ','Trenton','Mercer',40.249406,-74.759029),('08640','NJ','Fort Dix','Burlington',40.009627,-74.616335),('08641','NJ','Trenton','Burlington',40.032806,-74.588269),('08645','NJ','Trenton','Mercer',40.2169,-74.7433),('08646','NJ','Trenton','Mercer',40.2169,-74.7433),('08647','NJ','Trenton','Mercer',40.2169,-74.7433),('08648','NJ','Trenton','Mercer',40.275788,-74.723495),('08650','NJ','Trenton','Mercer',40.2169,-74.7433),('08666','NJ','Trenton','Mercer',40.2169,-74.7433),('08690','NJ','Trenton','Mercer',40.224505,-74.660279),('08691','NJ','Trenton','Mercer',40.208558,-74.612373),('08695','NJ','Trenton','Mercer',40.2169,-74.7433),('08701','NJ','Lakewood','Ocean',40.078752,-74.208098),('08720','NJ','Allenwood','Monmouth',40.141054,-74.10682),('08721','NJ','Bayville','Ocean',39.905631,-74.156476),('08722','NJ','Beachwood','Ocean',39.930139,-74.19755),('08723','NJ','Brick','Ocean',40.042384,-74.122764),('08724','NJ','Brick','Ocean',40.08443,-74.115941),('08730','NJ','Brielle','Monmouth',40.108479,-74.062252),('08731','NJ','Forked River','Ocean',39.845425,-74.214563),('08732','NJ','Island Heights','Ocean',39.943118,-74.147019),('08733','NJ','Lakehurst','Ocean',40.023911,-74.323355),('08734','NJ','Lanoka Harbor','Ocean',39.862916,-74.166413),('08735','NJ','Lavallette','Ocean',39.980841,-74.068605),('08736','NJ','Manasquan','Monmouth',40.120733,-74.05979),('08738','NJ','Mantoloking','Ocean',40.029217,-74.053544),('08739','NJ','Normandy Beach','Ocean',40.0025,-74.0608),('08740','NJ','Ocean Gate','Ocean',39.926453,-74.134759),('08741','NJ','Pine Beach','Ocean',39.934753,-74.16789),('08742','NJ','Point Pleasant Beach','Ocean',40.081058,-74.060177),('08750','NJ','Sea Girt','Monmouth',40.134975,-74.042053),('08751','NJ','Seaside Heights','Ocean',39.948293,-74.07722),('08752','NJ','Seaside Park','Ocean',39.90874,-74.080702),('08753','NJ','Toms River','Ocean',39.97441,-74.155228),('08754','NJ','Toms River','Ocean',39.953,-74.2031),('08755','NJ','Toms River','Ocean',40.002853,-74.226317),('08756','NJ','Toms River','Ocean',39.953,-74.2031),('08757','NJ','Toms River','Ocean',39.973762,-74.252153),('08758','NJ','Waretown','Ocean',39.790729,-74.214609),('08759','NJ','Manchester Township','Ocean',39.983687,-74.350214),('08801','NJ','Annandale','Hunterdon',40.631134,-74.889366),('08802','NJ','Asbury','Hunterdon',40.671028,-75.017983),('08803','NJ','Baptistown','Hunterdon',40.5216,-75.0063),('08804','NJ','Bloomsbury','Hunterdon',40.651804,-75.091065),('08805','NJ','Bound Brook','Somerset',40.569251,-74.539631),('08807','NJ','Bridgewater','Somerset',40.587944,-74.623542),('08808','NJ','Broadway','Warren',40.73213,-75.04903),('08809','NJ','Clinton','Hunterdon',40.640864,-74.912802),('08810','NJ','Dayton','Middlesex',40.377705,-74.511353),('08812','NJ','Dunellen','Middlesex',40.593905,-74.475982),('08816','NJ','East Brunswick','Middlesex',40.430913,-74.406928),('08817','NJ','Edison','Middlesex',40.516185,-74.397602),('08818','NJ','Edison','Middlesex',40.5261,-74.387),('08820','NJ','Edison','Middlesex',40.576624,-74.361333),('08821','NJ','Flagtown','Somerset',40.518816,-74.685383),('08822','NJ','Flemington','Hunterdon',40.514892,-74.854441),('08823','NJ','Franklin Park','Somerset',40.436506,-74.555847),('08824','NJ','Kendall Park','Middlesex',40.423771,-74.550449),('08825','NJ','Frenchtown','Hunterdon',40.523193,-75.036972),('08826','NJ','Glen Gardner','Hunterdon',40.704286,-74.915493),('08827','NJ','Hampton','Hunterdon',40.668619,-74.968086),('08828','NJ','Helmetta','Middlesex',40.377625,-74.421426),('08829','NJ','High Bridge','Hunterdon',40.668451,-74.892219),('08830','NJ','Iselin','Middlesex',40.571521,-74.317033),('08831','NJ','Monroe Township','Middlesex',40.334715,-74.442192),('08832','NJ','Keasbey','Middlesex',40.517426,-74.300529),('08833','NJ','Lebanon','Hunterdon',40.64154,-74.823011),('08834','NJ','Little York','Hunterdon',40.6111,-75.0763),('08835','NJ','Manville','Somerset',40.53904,-74.593007),('08836','NJ','Martinsville','Somerset',40.593986,-74.552497),('08837','NJ','Edison','Middlesex',40.529404,-74.338458),('08840','NJ','Metuchen','Middlesex',40.543904,-74.358201),('08844','NJ','Hillsborough','Somerset',40.505513,-74.652293),('08846','NJ','Middlesex','Middlesex',40.574772,-74.502403),('08848','NJ','Milford','Hunterdon',40.588055,-75.103662),('08850','NJ','Milltown','Middlesex',40.45123,-74.439684),('08852','NJ','Monmouth Junction','Middlesex',40.387285,-74.545959),('08853','NJ','Neshanic Station','Somerset',40.526855,-74.735572),('08854','NJ','Piscataway','Middlesex',40.555591,-74.461048),('08855','NJ','Piscataway','Middlesex',40.4991,-74.3994),('08857','NJ','Old Bridge','Middlesex',40.397318,-74.329851),('08858','NJ','Oldwick','Hunterdon',40.67497,-74.728576),('08859','NJ','Parlin','Middlesex',40.461187,-74.301554),('08861','NJ','Perth Amboy','Middlesex',40.520152,-74.276753),('08862','NJ','Perth Amboy','Middlesex',40.5102,-74.2716),('08863','NJ','Fords','Middlesex',40.535068,-74.313369),('08865','NJ','Phillipsburg','Warren',40.692342,-75.167821),('08867','NJ','Pittstown','Hunterdon',40.578937,-74.967529),('08868','NJ','Quakertown','Hunterdon',40.5655,-74.9419),('08869','NJ','Raritan','Somerset',40.572171,-74.63905),('08870','NJ','Readington','Hunterdon',40.5686,-74.738),('08871','NJ','Sayreville','Middlesex',40.46,-74.361),('08872','NJ','Sayreville','Middlesex',40.460672,-74.345555),('08873','NJ','Somerset','Somerset',40.506997,-74.511139),('08875','NJ','Somerset','Somerset',40.4956,-74.5259),('08876','NJ','Somerville','Somerset',40.572157,-74.6804),('08879','NJ','South Amboy','Middlesex',40.469214,-74.278774),('08880','NJ','South Bound Brook','Somerset',40.553689,-74.529534),('08882','NJ','South River','Middlesex',40.445485,-74.380574),('08884','NJ','Spotswood','Middlesex',40.393534,-74.392833),('08885','NJ','Stanton','Hunterdon',40.575,-74.838),('08886','NJ','Stewartsville','Warren',40.694413,-75.113893),('08887','NJ','Three Bridges','Hunterdon',40.525357,-74.795906),('08888','NJ','Whitehouse','Hunterdon',40.6183,-74.7447),('08889','NJ','Whitehouse Station','Hunterdon',40.614876,-74.7643),('08890','NJ','Zarephath','Somerset',40.4956,-74.5259),('08899','NJ','Edison','Middlesex',40.5261,-74.387),('08901','NJ','New Brunswick','Middlesex',40.488612,-74.447624),('08902','NJ','North Brunswick','Middlesex',40.450928,-74.48419),('08903','NJ','New Brunswick','Middlesex',40.5203,-74.4143),('08904','NJ','Highland Park','Middlesex',40.500583,-74.42545),('08905','NJ','New Brunswick','Middlesex',40.4587,-74.4648),('08906','NJ','New Brunswick','Middlesex',40.4861,-74.4522),('08922','NJ','New Brunswick','Middlesex',40.4861,-74.4522),('08933','NJ','New Brunswick','Middlesex',40.4861,-74.4522),('08988','NJ','New Brunswick','Middlesex',40.4502,-74.4804),('08989','NJ','New Brunswick','Middlesex',40.4502,-74.4804),('09001','AE','Apo','',0,0),('09002','AE','Apo','',0,0),('09003','AE','Apo','',0,0),('09004','AE','Apo','',0,0),('09005','AE','Apo','',0,0),('09006','AE','Apo','',0,0),('09007','AE','Apo','',0,0),('09008','AE','Apo','',0,0),('09009','AE','Apo','',0,0),('09010','AE','Apo','',0,0),('09011','AE','Apo','',0,0),('09012','AE','Apo','',0,0),('09013','AE','Apo','',0,0),('09014','AE','Apo','',0,0),('09020','AE','Apo','',0,0),('09021','AE','Apo','',49.45,7.75),('09028','AE','Apo','',0,0),('09031','AE','Apo','',0,0),('09033','AE','Apo','',0,0),('09034','AE','Apo','',0,0),('09036','AE','Apo','',0,0),('09038','AE','Apo','',0,0),('09042','AE','Apo','',0,0),('09045','AE','Apo','',0,0),('09046','AE','Apo','',0,0),('09049','AE','Apo','',0,0),('09051','AE','Apo','',0,0),('09053','AE','Apo','',19.341921,-99.049911),('09054','AE','Apo','',0,0),('09055','AE','Apo','',0,0),('09056','AE','Apo','',0,0),('09058','AE','Apo','',0,0),('09059','AE','Apo','',19.341921,-99.049911),('09060','AE','Apo','',0,0),('09063','AE','Apo','',0,0),('09067','AE','Apo','',0,0),('09068','AE','Apo','',0,0),('09069','AE','Apo','',19.341921,-99.049911),('09074','AE','Apo','',0,0),('09075','AE','Apo','',0,0),('09076','AE','Apo','',0,0),('09079','AE','Apo','',0,0),('09080','AE','Apo','',0,0),('09081','AE','Apo','',0,0),('09086','AE','Apo','',0,0),('09088','AE','Apo','',0,0),('09089','AE','Apo','',19.341921,-99.049911),('09090','AE','Apo','',0,0),('09092','AE','Apo','',0,0),('09094','AE','Apo','',0,0),('09095','AE','Apo','',0,0),('09096','AE','Apo','',0,0),('09099','AE','Apo','',0,0),('09100','AE','Apo','',0,0),('09102','AE','Apo','',0,0),('09103','AE','Apo','',0,0),('09104','AE','Apo','',0,0),('09107','AE','Apo','',0,0),('09110','AE','Apo','',0,0),('09112','AE','Apo','',0,0),('09114','AE','Apo','',0,0),('09123','AE','Apo','',0,0),('09126','AE','Apo','',0,0),('09128','AE','Apo','',0,0),('09131','AE','Apo','',0,0),('09136','AE','Apo','',0,0),('09137','AE','Apo','',0,0),('09138','AE','Apo','',0,0),('09139','AE','Apo','',0,0),('09140','AE','Apo','',0,0),('09142','AE','Apo','',0,0),('09143','AE','Apo','',0,0),('09154','AE','Apo','',0,0),('09165','AE','Apo','',0,0),('09166','AE','Apo','',0,0),('09169','AE','Apo','',0,0),('09172','AE','Apo','',0,0),('09173','AE','Apo','',0,0),('09175','AE','Apo','',0,0),('09177','AE','Apo','',0,0),('09180','AE','Apo','',0,0),('09182','AE','Apo','',0,0),('09183','AE','Apo','',0,0),('09185','AE','Apo','',0,0),('09186','AE','Apo','',0,0),('09201','AE','Apo','',0,0),('09211','AE','Apo','',0,0),('09212','AE','Apo','',0,0),('09213','AE','Apo','',0,0),('09214','AE','Apo','',0,0),('09225','AE','Apo','',0,0),('09226','AE','Apo','',0,0),('09227','AE','Apo','',0,0),('09229','AE','Apo','',0,0),('09237','AE','Apo','',0,0),('09244','AE','Apo','',0,0),('09245','AE','Apo','',0,0),('09250','AE','Apo','',0,0),('09252','AE','Apo','',0,0),('09261','AE','Apo','',0,0),('09262','AE','Apo','',0,0),('09263','AE','Apo','',0,0),('09264','AE','Apo','',0,0),('09265','AE','Apo','',0,0),('09266','AE','Apo','',0,0),('09267','AE','Apo','',0,0),('09301','AE','Apo','',0,0),('09302','AE','Apo','',0,0),('09304','AE','Apo','',0,0),('09305','AE','Apo','',0,0),('09306','AE','Apo','',0,0),('09307','AE','Apo','',0,0),('09308','AE','Apo','',0,0),('09309','AE','Apo','',0,0),('09310','AE','Apo','',0,0),('09311','AE','Apo','',0,0),('09312','AE','Apo','',0,0),('09313','AE','Apo','',0,0),('09314','AE','Apo','',0,0),('09315','AE','Apo','',0,0),('09316','AE','Apo','',0,0),('09317','AE','Apo','',0,0),('09318','AE','Apo','',0,0),('09320','AE','Apo','',0,0),('09321','AE','Apo','',0,0),('09322','AE','Apo','',0,0),('09324','AE','Apo','',0,0),('09327','AE','Apo','',0,0),('09328','AE','Apo','',0,0),('09330','AE','Apo','',0,0),('09331','AE','Apo','',0,0),('09332','AE','Apo','',0,0),('09333','AE','Apo','',0,0),('09334','AE','Apo','',0,0),('09336','AE','Apo','',0,0),('09337','AE','Apo','',0,0),('09338','AE','Apo','',0,0),('09339','AE','Apo','',0,0),('09340','AE','Apo','',0,0),('09342','AE','Apo','',0,0),('09343','AE','Apo','',0,0),('09344','AE','Apo','',0,0),('09346','AE','Apo','',0,0),('09347','AP','Apo','',0,0),('09348','AE','Apo','',0,0),('09350','AE','Apo','',0,0),('09351','AE','Apo','',0,0),('09352','AP','Apo','',0,0),('09353','AE','Apo','',0,0),('09354','AE','Apo','',0,0),('09355','AE','Apo','',0,0),('09356','AE','Apo','',0,0),('09357','AE','Apo','',0,0),('09358','AE','Apo','',0,0),('09359','AE','Apo','',0,0),('09360','AE','Apo','',0,0),('09361','AE','Apo','',0,0),('09362','AE','Apo','',0,0),('09363','AE','Apo','',0,0),('09364','AE','Fpo','',0,0),('09365','AE','Apo','',0,0),('09366','AE','Apo','',0,0),('09367','AE','Apo','',0,0),('09368','AP','Apo','',0,0),('09369','AE','Fpo','',0,0),('09370','AE','Fpo','',0,0),('09371','AE','Apo','',0,0),('09372','AE','Fpo','',0,0),('09373','AE','Fpo','',0,0),('09374','AE','Apo','',0,0),('09375','AE','Apo','',0,0),('09376','AE','Fpo','',0,0),('09377','AE','Fpo','',0,0),('09378','AE','Apo','',0,0),('09380','AE','Apo','',0,0),('09381','AE','Apo','',0,0),('09382','AE','Apo','',0,0),('09383','AE','Apo','',0,0),('09384','AP','Apo','',0,0),('09386','AE','Apo','',0,0),('09387','AE','Apo','',0,0),('09388','AE','Apo','',0,0),('09389','AE','Apo','',0,0),('09390','AE','Apo','',0,0),('09391','AE','Apo','',0,0),('09393','AE','Apo','',0,0),('09396','AE','Apo','',0,0),('09399','AP','Apo','',0,0),('09402','AE','Apo','',0,0),('09403','AP','Apo','',0,0),('09409','AE','Fpo','',0,0),('09420','AE','Fpo','',0,0),('09421','AE','Fpo','',0,0),('09447','AE','Apo','',0,0),('09454','AE','Apo','',0,0),('09456','AE','Apo','',0,0),('09459','AE','Apo','',0,0),('09461','AE','Apo','',0,0),('09463','AE','Apo','',0,0),('09464','AE','Apo','',0,0),('09468','AE','Apo','',0,0),('09469','AE','Apo','',0,0),('09470','AE','Apo','',0,0),('09494','AE','Apo','',0,0),('09496','AE','Apo','',0,0),('09498','AE','Fpo','',0,0),('09499','AE','Fpo','',0,0),('09501','AE','Fpo','',0,0),('09502','AE','Fpo','',0,0),('09503','AE','Fpo','',0,0),('09504','AE','Fpo','',0,0),('09505','AE','Fpo','',0,0),('09506','AE','Fpo','',0,0),('09507','AE','Fpo','',0,0),('09508','AE','Fpo','',0,0),('09509','AE','Fpo','',0,0),('09510','AE','Fpo','',0,0),('09511','AE','Fpo','',0,0),('09513','AE','Apo','',0,0),('09517','AE','Fpo','',0,0),('09524','AE','Fpo','',0,0),('09532','AE','Fpo','',0,0),('09534','AE','Fpo','',0,0),('09543','AE','Fpo','',0,0),('09545','AE','Fpo','',0,0),('09549','AE','Fpo','',0,0),('09550','AE','Fpo','',0,0),('09554','AE','Fpo','',0,0),('09556','AE','Fpo','',0,0),('09557','AE','Fpo','',0,0),('09564','AE','Fpo','',0,0),('09565','AE','Fpo','',0,0),('09566','AE','Fpo','',0,0),('09567','AE','Fpo','',0,0),('09568','AE','Fpo','',0,0),('09569','AE','Fpo','',0,0),('09570','AE','Fpo','',0,0),('09573','AE','Fpo','',0,0),('09574','AE','Fpo','',0,0),('09575','AE','Fpo','',0,0),('09576','AE','Fpo','',0,0),('09577','AE','Fpo','',0,0),('09578','AE','Fpo','',0,0),('09579','AE','Fpo','',0,0),('09581','AE','Fpo','',0,0),('09582','AE','Fpo','',0,0),('09586','AE','Fpo','',0,0),('09587','AE','Fpo','',0,0),('09588','AE','Fpo','',0,0),('09589','AE','Fpo','',0,0),('09590','AE','Fpo','',0,0),('09591','AE','Fpo','',0,0),('09593','AE','Fpo','',0,0),('09594','AE','Fpo','',0,0),('09596','AE','Fpo','',0,0),('09599','AE','Fpo','',0,0),('09601','AE','Apo','',0,0),('09602','AE','Apo','',0,0),('09603','AE','Apo','',0,0),('09604','AE','Apo','',0,0),('09605','AE','Apo','',0,0),('09606','AE','Apo','',0,0),('09607','AE','Apo','',0,0),('09608','AE','Fpo','',0,0),('09609','AE','Fpo','',0,0),('09610','AE','Apo','',0,0),('09612','AE','Fpo','',0,0),('09613','AE','Apo','',0,0),('09617','AE','Apo','',0,0),('09618','AE','Fpo','',0,0),('09619','AE','Fpo','',0,0),('09620','AE','Fpo','',0,0),('09621','AE','Fpo','',0,0),('09622','AE','Fpo','',0,0),('09623','AE','Fpo','',0,0),('09624','AE','Apo','',0,0),('09625','AE','Fpo','',0,0),('09626','AE','Fpo','',0,0),('09627','AE','Fpo','',0,0),('09630','AE','Apo','',0,0),('09631','AE','Fpo','',0,0),('09633','AP','Apo','',0,0),('09636','AE','Fpo','',0,0),('09642','AE','Apo','',0,0),('09643','AE','Apo','',0,0),('09644','AE','Fpo','',0,0),('09645','AE','Fpo','',0,0),('09647','AE','Apo','',0,0),('09648','AE','Fpo','',0,0),('09649','AE','Fpo','',0,0),('09701','AE','Apo','',0,0),('09702','AE','Apo','',0,0),('09703','AE','Apo','',0,0),('09704','AE','Apo','',0,0),('09705','AE','Apo','',0,0),('09706','AE','Apo','',0,0),('09707','AE','Apo','',0,0),('09708','AE','Apo','',0,0),('09709','AE','Apo','',0,0),('09710','AE','Apo','',0,0),('09711','AE','Apo','',0,0),('09713','AE','Apo','',0,0),('09714','AE','Apo','',0,0),('09715','AE','Apo','',0,0),('09716','AE','Apo','',0,0),('09717','AE','Apo','',0,0),('09718','AE','Apo','',0,0),('09719','AE','Apo','',0,0),('09720','AE','Apo','',0,0),('09721','AE','Apo','',0,0),('09722','AE','Apo','',0,0),('09723','AE','Apo','',0,0),('09724','AE','Apo','',0,0),('09726','AE','Apo','',0,0),('09727','AE','Fpo','',0,0),('09728','AE','Dpo','',0,0),('09729','AE','Fpo','',0,0),('09730','AE','Fpo','',0,0),('09731','AE','Apo','',0,0),('09732','AE','Apo','',0,0),('09733','AE','Fpo','',0,0),('09734','AE','Apo','',0,0),('09735','AE','Apo','',0,0),('09736','AE','Apo','',0,0),('09737','AE','Apo','',0,0),('09738','AE','Apo','',0,0),('09739','AE','Apo','',0,0),('09740','AE','Apo','',0,0),('09741','AE','Apo','',0,0),('09742','AE','Apo','',0,0),('09743','AE','Apo','',0,0),('09744','AE','Apo','',0,0),('09745','AE','Apo','',0,0),('09746','AE','Apo','',0,0),('09747','AE','Fpo','',0,0),('09748','AE','Dpo','',0,0),('09749','AE','Apo','',0,0),('09750','AE','Apo','',0,0),('09751','AE','Apo','',0,0),('09752','AE','Apo','',0,0),('09753','AE','Apo','',0,0),('09754','AE','Apo','',0,0),('09755','AE','Apo','',0,0),('09756','AE','Apo','',0,0),('09757','AE','Apo','',0,0),('09758','AE','Dpo','',0,0),('09759','AE','Dpo','',0,0),('09762','AE','Apo','',0,0),('09769','AE','Dpo','',0,0),('09777','AE','Apo','',0,0),('09780','AE','Apo','',0,0),('09789','AE','Apo','',0,0),('09790','AE','Apo','',0,0),('09798','AE','Apo','',0,0),('09801','AE','Apo','',0,0),('09802','AE','Apo','',0,0),('09803','AE','Apo','',0,0),('09804','AE','Apo','',0,0),('09805','AE','Fpo','',0,0),('09806','AE','Apo','',0,0),('09807','AE','Apo','',0,0),('09808','AE','Apo','',0,0),('09809','AE','Fpo','',0,0),('09810','AP','Apo','',0,0),('09811','AE','Apo','',0,0),('09812','AE','Apo','',0,0),('09813','AE','Dpo','',0,0),('09814','AE','Apo','',0,0),('09815','AE','Apo','',0,0),('09816','AE','Dpo','',0,0),('09817','AE','Apo','',0,0),('09818','AP','Apo','',0,0),('09819','AE','Apo','',0,0),('09820','AE','Apo','',0,0),('09821','AE','Apo','',0,0),('09822','AE','Apo','',0,0),('09823','AE','Apo','',0,0),('09824','AE','Apo','',0,0),('09825','AE','Apo','',0,0),('09826','AE','Apo','',0,0),('09827','AE','Apo','',0,0),('09828','AE','Apo','',0,0),('09829','AP','Apo','',0,0),('09830','AE','Apo','',0,0),('09831','AE','Apo','',0,0),('09832','AE','Apo','',0,0),('09833','AE','Apo','',0,0),('09834','AE','Fpo','',0,0),('09835','AE','Fpo','',0,0),('09836','AE','Fpo','',0,0),('09837','AE','Fpo','',0,0),('09838','AE','Fpo','',0,0),('09839','AE','Apo','',0,0),('09840','AE','Fpo','',0,0),('09841','AE','Apo','',0,0),('09842','AE','Apo','',0,0),('09843','AE','Apo','',0,0),('09844','AE','Apo','',0,0),('09845','AE','Apo','',0,0),('09852','AE','Apo','',0,0),('09853','AE','Apo','',0,0),('09855','AE','Apo','',0,0),('09858','AE','Apo','',0,0),('09859','AE','Fpo','',0,0),('09865','AE','Fpo','',0,0),('09868','AE','Apo','',0,0),('09870','AE','Apo','',0,0),('09880','AE','Apo','',0,0),('09888','AE','Apo','',0,0),('09890','AE','Apo','',0,0),('09892','AE','Apo','',0,0),('09898','AE','Apo','',0,0),('10001','NY','New York','New York',40.750582,-73.996472),('10002','NY','New York','New York',40.716554,-73.986873),('10003','NY','New York','New York',40.732019,-73.989247),('10004','NY','New York','New York',40.700736,-74.014686),('10005','NY','New York','New York',40.705603,-74.008601),('10006','NY','New York','New York',40.70856,-74.012906),('10007','NY','New York','New York',40.71427,-74.007351),('10008','NY','New York','New York',40.7121,-74.0102),('10009','NY','New York','New York',40.726077,-73.978935),('10010','NY','New York','New York',40.738691,-73.981783),('10011','NY','New York','New York',40.740775,-73.999921),('10012','NY','New York','New York',40.7254,-73.998476),('10013','NY','New York','New York',40.720019,-74.004663),('10014','NY','New York','New York',40.734202,-74.005446),('10015','NY','New York','New York',40.7141,-74.0063),('10016','NY','New York','New York',40.745895,-73.977472),('10017','NY','New York','New York',40.751907,-73.972154),('10018','NY','New York','New York',40.755,-73.993277),('10019','NY','New York','New York',40.765079,-73.98593),('10020','NY','New York','New York',40.758667,-73.980241),('10021','NY','New York','New York',40.769617,-73.959235),('10022','NY','New York','New York',40.758166,-73.967587),('10023','NY','New York','New York',40.776109,-73.982722),('10024','NY','New York','New York',40.791455,-73.97505),('10025','NY','New York','New York',40.79849,-73.968062),('10026','NY','New York','New York',40.802042,-73.952923),('10027','NY','New York','New York',40.811408,-73.95306),('10028','NY','New York','New York',40.776714,-73.954056),('10029','NY','New York','New York',40.791681,-73.943903),('10030','NY','New York','New York',40.818136,-73.943493),('10031','NY','New York','New York',40.824889,-73.949824),('10032','NY','New York','New York',40.837711,-73.940986),('10033','NY','New York','New York',40.84903,-73.936231),('10034','NY','New York','New York',40.865233,-73.923134),('10035','NY','New York','New York',40.801594,-73.935842),('10036','NY','New York','New York',40.759444,-73.990036),('10037','NY','New York','New York',40.812736,-73.936258),('10038','NY','New York','New York',40.710114,-74.002496),('10039','NY','New York','New York',40.828356,-73.936359),('10040','NY','New York','New York',40.857454,-73.931736),('10041','NY','New York','New York',40.703042,-74.010093),('10043','NY','New York','New York',40.7141,-74.0063),('10044','NY','New York','New York',40.76232,-73.949154),('10045','NY','New York','New York',40.7056,-74.0081),('10046','NY','New York','New York',40.7121,-74.0102),('10047','NY','New York','New York',40.7102,-74.0128),('10048','NY','New York','New York',40.712086,-74.012275),('10055','NY','New York','New York',40.7589,-73.9735),('10060','NY','New York','New York',40.7507,-73.9946),('10065','NY','New York','New York',40.764523,-73.962952),('10069','NY','New York','New York',40.777531,-73.989375),('10072','NY','New York','New York',40.7501,-73.9978),('10075','NY','New York','New York',40.773469,-73.956424),('10079','NY','New York','New York',40.7141,-74.0063),('10080','NY','New York','New York',40.7121,-74.0102),('10081','NY','New York','New York',40.7141,-74.0063),('10082','NY','New York','New York',40.7753,-73.9844),('10087','NY','New York','New York',40.7507,-73.9946),('10090','NY','New York','New York',40.7141,-74.0063),('10094','NY','New York','New York',40.7141,-74.0063),('10095','NY','New York','New York',40.7507,-73.9946),('10096','NY','New York','New York',40.7141,-74.0063),('10098','NY','New York','New York',40.7507,-73.9946),('10099','NY','New York','New York',40.7141,-74.0063),('10101','NY','New York','New York',40.7632,-73.9862),('10102','NY','New York','New York',40.7632,-73.9862),('10103','NY','New York','New York',40.760915,-73.977852),('10104','NY','New York','New York',40.7603,-73.9794),('10105','NY','New York','New York',40.7632,-73.9862),('10106','NY','New York','New York',40.7647,-73.9804),('10107','NY','New York','New York',40.7661,-73.9825),('10108','NY','New York','New York',40.7574,-73.9918),('10109','NY','New York','New York',40.7574,-73.9918),('10110','NY','New York','New York',40.754499,-73.982256),('10111','NY','New York','New York',40.759235,-73.977755),('10112','NY','New York','New York',40.759291,-73.979799),('10113','NY','New York','New York',40.7417,-74.0004),('10114','NY','New York','New York',40.7417,-74.0004),('10115','NY','New York','New York',40.810906,-73.963756),('10116','NY','New York','New York',40.8113,-73.9534),('10117','NY','New York','New York',40.7507,-73.9946),('10118','NY','New York','New York',40.7483,-73.9865),('10119','NY','New York','New York',40.750824,-73.99289),('10120','NY','New York','New York',40.7496,-73.9884),('10121','NY','New York','New York',40.7497,-73.9919),('10122','NY','New York','New York',40.7507,-73.9946),('10123','NY','New York','New York',40.7507,-73.9946),('10124','NY','New York','New York',40.7577,-73.978),('10125','NY','New York','New York',40.7995,-73.9679),('10126','NY','New York','New York',40.7586,-73.9724),('10128','NY','New York','New York',40.781848,-73.950309),('10129','NY','New York','New York',40.7574,-73.9918),('10130','NY','New York','New York',40.7778,-73.9541),('10131','NY','New York','New York',40.7679,-73.9611),('10132','NY','New York','New York',40.7849,-73.9748),('10133','NY','New York','New York',40.7716,-73.9873),('10138','NY','New York','New York',40.754,-73.9909),('10149','NY','New York','New York',40.7655,-73.9873),('10150','NY','New York','New York',40.7583,-73.9688),('10151','NY','New York','New York',40.7631,-73.9733),('10152','NY','New York','New York',40.758611,-73.972238),('10153','NY','New York','New York',40.763742,-73.97268),('10154','NY','New York','New York',40.757986,-73.972674),('10155','NY','New York','New York',40.7609,-73.9679),('10156','NY','New York','New York',40.753,-73.9924),('10157','NY','New York','New York',40.753,-73.9924),('10158','NY','New York','New York',40.7487,-73.9753),('10159','NY','New York','New York',40.7389,-73.9845),('10160','NY','New York','New York',40.7389,-73.9845),('10161','NY','New York','New York',40.7141,-74.0063),('10162','NY','New York','New York',40.769298,-73.949942),('10163','NY','New York','New York',40.7516,-73.9761),('10164','NY','New York','New York',40.7516,-73.9761),('10165','NY','New York','New York',40.752354,-73.978905),('10166','NY','New York','New York',40.7532,-73.9766),('10167','NY','New York','New York',40.754862,-73.974953),('10168','NY','New York','New York',40.7516,-73.9761),('10169','NY','New York','New York',40.754463,-73.976063),('10170','NY','New York','New York',40.752859,-73.976081),('10171','NY','New York','New York',40.756099,-73.974017),('10172','NY','New York','New York',40.755494,-73.974477),('10173','NY','New York','New York',40.754302,-73.979559),('10174','NY','New York','New York',40.7516,-73.9761),('10175','NY','New York','New York',40.7538,-73.98),('10176','NY','New York','New York',40.7516,-73.9761),('10177','NY','New York','New York',40.755345,-73.976096),('10178','NY','New York','New York',40.7516,-73.9761),('10179','NY','New York','New York',40.7506,-73.9784),('10184','NY','New York','New York',40.7141,-74.0063),('10185','NY','New York','New York',40.7577,-73.978),('10196','NY','New York','New York',40.7141,-74.0063),('10197','NY','New York','New York',40.7141,-74.0063),('10199','NY','New York','New York',40.7507,-73.9945),('10203','NY','New York','New York',40.7121,-74.0102),('10211','NY','New York','New York',40.7314,-73.9904),('10212','NY','New York','New York',40.7051,-74.014),('10213','NY','New York','New York',40.7204,-74.0044),('10242','NY','New York','New York',40.7121,-74.0102),('10249','NY','New York','New York',40.7121,-74.0102),('10256','NY','New York','New York',40.7121,-74.0102),('10257','NY','New York','New York',40.7141,-74.0063),('10258','NY','New York','New York',40.7141,-74.0063),('10259','NY','New York','New York',40.7121,-74.0102),('10260','NY','New York','New York',40.7121,-74.0102),('10261','NY','New York','New York',40.7121,-74.0102),('10265','NY','New York','New York',40.7056,-74.0081),('10268','NY','New York','New York',40.7056,-74.0081),('10269','NY','New York','New York',40.7056,-74.0081),('10270','NY','New York','New York',40.7056,-74.0081),('10271','NY','New York','New York',40.708669,-74.010439),('10272','NY','New York','New York',40.7141,-74.0063),('10273','NY','New York','New York',40.7141,-74.0063),('10274','NY','New York','New York',40.7051,-74.014),('10275','NY','New York','New York',40.7051,-74.014),('10276','NY','New York','New York',40.7314,-73.9904),('10277','NY','New York','New York',40.7121,-74.0102),('10278','NY','New York','New York',40.715721,-74.003957),('10279','NY','New York','New York',40.713062,-74.008571),('10280','NY','New York','New York',40.709316,-74.017309),('10281','NY','New York','New York',40.7147,-74.016),('10282','NY','New York','New York',40.71624,-74.015052),('10285','NY','New York','New York',40.7121,-74.0102),('10286','NY','New York','New York',40.7121,-74.0102),('10292','NY','New York','New York',40.7066,-74.0053),('10301','NY','Staten Island','Richmond',40.631882,-74.09431),('10302','NY','Staten Island','Richmond',40.630759,-74.137614),('10303','NY','Staten Island','Richmond',40.630217,-74.161084),('10304','NY','Staten Island','Richmond',40.608848,-74.089463),('10305','NY','Staten Island','Richmond',40.598391,-74.074461),('10306','NY','Staten Island','Richmond',40.568855,-74.118926),('10307','NY','Staten Island','Richmond',40.507753,-74.242091),('10308','NY','Staten Island','Richmond',40.550714,-74.150753),('10309','NY','Staten Island','Richmond',40.532547,-74.215449),('10310','NY','Staten Island','Richmond',40.632355,-74.115414),('10311','NY','Staten Island','Richmond',40.6047,-74.1781),('10312','NY','Staten Island','Richmond',40.541576,-74.176908),('10313','NY','Staten Island','Richmond',40.5781,-74.1697),('10314','NY','Staten Island','Richmond',40.605423,-74.149988),('10451','NY','Bronx','Bronx',40.819641,-73.922608),('10452','NY','Bronx','Bronx',40.838587,-73.922441),('10453','NY','Bronx','Bronx',40.850828,-73.912932),('10454','NY','Bronx','Bronx',40.805845,-73.916237),('10455','NY','Bronx','Bronx',40.815404,-73.908784),('10456','NY','Bronx','Bronx',40.829689,-73.908571),('10457','NY','Bronx','Bronx',40.846647,-73.898953),('10458','NY','Bronx','Bronx',40.863042,-73.890081),('10459','NY','Bronx','Bronx',40.825331,-73.893407),('10460','NY','Bronx','Bronx',40.840702,-73.878996),('10461','NY','Bronx','Bronx',40.845887,-73.839958),('10462','NY','Bronx','Bronx',40.842148,-73.8587),('10463','NY','Bronx','Bronx',40.881184,-73.907448),('10464','NY','Bronx','Bronx',40.857479,-73.790772),('10465','NY','Bronx','Bronx',40.825895,-73.819668),('10466','NY','Bronx','Bronx',40.891039,-73.847226),('10467','NY','Bronx','Bronx',40.874307,-73.8698),('10468','NY','Bronx','Bronx',40.867206,-73.900314),('10469','NY','Bronx','Bronx',40.868699,-73.848578),('10470','NY','Bronx','Bronx',40.900423,-73.861058),('10471','NY','Bronx','Bronx',40.900799,-73.903798),('10472','NY','Bronx','Bronx',40.830425,-73.868421),('10473','NY','Bronx','Bronx',40.81869,-73.858474),('10474','NY','Bronx','Bronx',40.813289,-73.886643),('10475','NY','Bronx','Bronx',40.874514,-73.825916),('10499','NY','Bronx','Bronx',40.8262,-73.8232),('10501','NY','Amawalk','Westchester',41.290143,-73.764961),('10502','NY','Ardsley','Westchester',41.011312,-73.841314),('10503','NY','Ardsley On Hudson','Westchester',41.026556,-73.87531),('10504','NY','Armonk','Westchester',41.130104,-73.703844),('10505','NY','Baldwin Place','Westchester',41.340179,-73.747223),('10506','NY','Bedford','Westchester',41.189773,-73.638569),('10507','NY','Bedford Hills','Westchester',41.236909,-73.690011),('10509','NY','Brewster','Putnam',41.410855,-73.59434),('10510','NY','Briarcliff Manor','Westchester',41.148991,-73.836714),('10511','NY','Buchanan','Westchester',41.26113,-73.939916),('10512','NY','Carmel','Putnam',41.444947,-73.684465),('10514','NY','Chappaqua','Westchester',41.165613,-73.77514),('10516','NY','Cold Spring','Putnam',41.441607,-73.922427),('10517','NY','Crompond','Westchester',41.298912,-73.862723),('10518','NY','Cross River','Westchester',41.267139,-73.607513),('10519','NY','Croton Falls','Westchester',41.348844,-73.659875),('10520','NY','Croton On Hudson','Westchester',41.2123,-73.884388),('10521','NY','Croton On Hudson','Westchester',41.2355,-73.9295),('10522','NY','Dobbs Ferry','Westchester',41.011415,-73.863688),('10523','NY','Elmsford','Westchester',41.056909,-73.816609),('10524','NY','Garrison','Putnam',41.36335,-73.926264),('10526','NY','Goldens Bridge','Westchester',41.293318,-73.671278),('10527','NY','Granite Springs','Westchester',41.312927,-73.757487),('10528','NY','Harrison','Westchester',40.973782,-73.718971),('10530','NY','Hartsdale','Westchester',41.024648,-73.805793),('10532','NY','Hawthorne','Westchester',41.102528,-73.798058),('10533','NY','Irvington','Westchester',41.038868,-73.859726),('10535','NY','Jefferson Valley','Westchester',41.333817,-73.802137),('10536','NY','Katonah','Westchester',41.264862,-73.687275),('10537','NY','Lake Peekskill','Putnam',41.33547,-73.884001),('10538','NY','Larchmont','Westchester',40.933989,-73.756696),('10540','NY','Lincolndale','Westchester',41.3227,-73.7186),('10541','NY','Mahopac','Putnam',41.372757,-73.753911),('10542','NY','Mahopac Falls','Putnam',41.3719,-73.7622),('10543','NY','Mamaroneck','Westchester',40.953552,-73.733738),('10545','NY','Maryknoll','Westchester',41.178591,-73.83545),('10546','NY','Millwood','Westchester',41.195571,-73.801088),('10547','NY','Mohegan Lake','Westchester',41.316792,-73.846126),('10548','NY','Montrose','Westchester',41.249289,-73.936918),('10549','NY','Mount Kisco','Westchester',41.203367,-73.725914),('10550','NY','Mount Vernon','Westchester',40.907654,-73.837093),('10551','NY','Mount Vernon','Westchester',40.9008,-73.8246),('10552','NY','Mount Vernon','Westchester',40.923587,-73.826875),('10553','NY','Mount Vernon','Westchester',40.909347,-73.821326),('10557','NY','Mount Vernon','Westchester',40.9008,-73.8246),('10558','NY','Mount Vernon','Westchester',40.9008,-73.8246),('10560','NY','North Salem','Westchester',41.333711,-73.614465),('10562','NY','Ossining','Westchester',41.176928,-73.846991),('10566','NY','Peekskill','Westchester',41.288128,-73.919336),('10567','NY','Cortlandt Manor','Westchester',41.292509,-73.892744),('10570','NY','Pleasantville','Westchester',41.132189,-73.788959),('10571','NY','Pleasantville','Westchester',41.1343,-73.7946),('10572','NY','Pleasantville','Westchester',41.1343,-73.7946),('10573','NY','Port Chester','Westchester',41.010444,-73.673149),('10576','NY','Pound Ridge','Westchester',41.221577,-73.572332),('10577','NY','Purchase','Westchester',41.031148,-73.714279),('10578','NY','Purdys','Westchester',41.324019,-73.668648),('10579','NY','Putnam Valley','Putnam',41.387909,-73.83378),('10580','NY','Rye','Westchester',40.976877,-73.689516),('10583','NY','Scarsdale','Westchester',40.988638,-73.799096),('10587','NY','Shenorock','Westchester',41.3316,-73.7386),('10588','NY','Shrub Oak','Westchester',41.331077,-73.828344),('10589','NY','Somers','Westchester',41.334408,-73.69118),('10590','NY','South Salem','Westchester',41.254803,-73.539551),('10591','NY','Tarrytown','Westchester',41.078268,-73.854293),('10594','NY','Thornwood','Westchester',41.120114,-73.776871),('10595','NY','Valhalla','Westchester',41.083671,-73.780868),('10596','NY','Verplanck','Westchester',41.252418,-73.958712),('10597','NY','Waccabuc','Westchester',41.289541,-73.600461),('10598','NY','Yorktown Heights','Westchester',41.297003,-73.789462),('10601','NY','White Plains','Westchester',41.032553,-73.764592),('10602','NY','White Plains','Westchester',41.0274,-73.775),('10603','NY','White Plains','Westchester',41.054503,-73.776571),('10604','NY','West Harrison','Westchester',41.044893,-73.742069),('10605','NY','White Plains','Westchester',41.008286,-73.74951),('10606','NY','White Plains','Westchester',41.022925,-73.777803),('10607','NY','White Plains','Westchester',41.041421,-73.806543),('10610','NY','White Plains','Westchester',41.0276,-73.7744),('10701','NY','Yonkers','Westchester',40.943827,-73.882726),('10702','NY','Yonkers','Westchester',40.9311,-73.8991),('10703','NY','Yonkers','Westchester',40.956947,-73.880916),('10704','NY','Yonkers','Westchester',40.920484,-73.861166),('10705','NY','Yonkers','Westchester',40.91758,-73.889626),('10706','NY','Hastings On Hudson','Westchester',40.989393,-73.870546),('10707','NY','Tuckahoe','Westchester',40.958952,-73.823444),('10708','NY','Bronxville','Westchester',40.938719,-73.831899),('10709','NY','Eastchester','Westchester',40.954297,-73.810696),('10710','NY','Yonkers','Westchester',40.9654,-73.844785),('10801','NY','New Rochelle','Westchester',40.916149,-73.785066),('10802','NY','New Rochelle','Westchester',40.9112,-73.7823),('10803','NY','Pelham','Westchester',40.901766,-73.806874),('10804','NY','New Rochelle','Westchester',40.946896,-73.788879),('10805','NY','New Rochelle','Westchester',40.8982,-73.780249),('10901','NY','Suffern','Rockland',41.124919,-74.12257),('10910','NY','Arden','Orange',41.2744,-74.1533),('10911','NY','Bear Mountain','Rockland',41.3081,-73.9941),('10912','NY','Bellvale','Orange',41.2502,-74.3111),('10913','NY','Blauvelt','Rockland',41.062119,-73.959484),('10914','NY','Blooming Grove','Orange',41.417717,-74.200026),('10915','NY','Bullville','Orange',41.540059,-74.356874),('10916','NY','Campbell Hall','Orange',41.449335,-74.244749),('10917','NY','Central Valley','Orange',41.324512,-74.120613),('10918','NY','Chester','Orange',41.353122,-74.259074),('10919','NY','Circleville','Orange',41.530169,-74.381572),('10920','NY','Congers','Rockland',41.148809,-73.939274),('10921','NY','Florida','Orange',41.331209,-74.359307),('10922','NY','Fort Montgomery','Orange',41.330026,-73.988906),('10923','NY','Garnerville','Rockland',41.20146,-73.999837),('10924','NY','Goshen','Orange',41.385514,-74.334336),('10925','NY','Greenwood Lake','Orange',41.215141,-74.296431),('10926','NY','Harriman','Orange',41.306911,-74.141721),('10927','NY','Haverstraw','Rockland',41.196335,-73.968588),('10928','NY','Highland Falls','Orange',41.364565,-73.968924),('10930','NY','Highland Mills','Orange',41.356613,-74.120414),('10931','NY','Hillburn','Rockland',41.131227,-74.168383),('10932','NY','Howells','Orange',41.48216,-74.464285),('10933','NY','Johnson','Orange',41.367984,-74.512968),('10940','NY','Middletown','Orange',41.449445,-74.437059),('10941','NY','Middletown','Orange',41.478581,-74.359141),('10943','NY','Middletown','Orange',41.442,-74.4217),('10949','NY','Monroe','Orange',41.3086,-74.1993),('10950','NY','Monroe','Orange',41.326789,-74.190586),('10952','NY','Monsey','Rockland',41.116801,-74.073653),('10953','NY','Mountainville','Orange',41.404806,-74.079773),('10954','NY','Nanuet','Rockland',41.101458,-74.012969),('10956','NY','New City','Rockland',41.14901,-73.997864),('10958','NY','New Hampton','Orange',41.39482,-74.416325),('10959','NY','New Milford','Orange',41.2344,-74.4141),('10960','NY','Nyack','Rockland',41.089093,-73.925027),('10962','NY','Orangeburg','Rockland',41.04776,-73.961841),('10963','NY','Otisville','Orange',41.463529,-74.543423),('10964','NY','Palisades','Rockland',41.010444,-73.923999),('10965','NY','Pearl River','Rockland',41.063507,-74.016826),('10968','NY','Piermont','Rockland',41.040224,-73.917548),('10969','NY','Pine Island','Orange',41.294859,-74.488006),('10970','NY','Pomona','Rockland',41.188355,-74.043126),('10973','NY','Slate Hill','Orange',41.391449,-74.471892),('10974','NY','Sloatsburg','Rockland',41.159159,-74.187964),('10975','NY','Southfields','Orange',41.253079,-74.167064),('10976','NY','Sparkill','Rockland',41.029286,-73.927336),('10977','NY','Spring Valley','Rockland',41.116641,-74.04498),('10979','NY','Sterling Forest','Orange',41.182775,-74.317411),('10980','NY','Stony Point','Rockland',41.231696,-74.020142),('10981','NY','Sugar Loaf','Orange',41.3208,-74.2858),('10982','NY','Tallman','Rockland',41.1111,-74.1002),('10983','NY','Tappan','Rockland',41.029211,-73.950533),('10984','NY','Thiells','Rockland',41.204442,-74.018432),('10985','NY','Thompson Ridge','Orange',41.580719,-74.375013),('10986','NY','Tomkins Cove','Rockland',41.273898,-73.98707),('10987','NY','Tuxedo Park','Orange',41.199576,-74.213456),('10988','NY','Unionville','Orange',41.299732,-74.557353),('10989','NY','Valley Cottage','Rockland',41.122956,-73.938027),('10990','NY','Warwick','Orange',41.261484,-74.358023),('10992','NY','Washingtonville','Orange',41.429772,-74.160601),('10993','NY','West Haverstraw','Rockland',41.210661,-73.977909),('10994','NY','West Nyack','Rockland',41.096511,-73.974685),('10996','NY','West Point','Orange',41.393699,-73.972175),('10997','NY','West Point','Orange',41.3913,-73.9563),('10998','NY','Westtown','Orange',41.33802,-74.541002),('11001','NY','Floral Park','Nassau',40.723849,-73.705352),('11002','NY','Floral Park','Nassau',40.7264,-73.7088),('11003','NY','Elmont','Nassau',40.700796,-73.704327),('11004','NY','Glen Oaks','Queens',40.74585,-73.710995),('11005','NY','Floral Park','Queens',40.757666,-73.714914),('11010','NY','Franklin Square','Nassau',40.701721,-73.675052),('11020','NY','Great Neck','Nassau',40.773377,-73.718226),('11021','NY','Great Neck','Nassau',40.788033,-73.726852),('11022','NY','Great Neck','Nassau',40.7875,-73.725),('11023','NY','Great Neck','Nassau',40.798909,-73.733653),('11024','NY','Great Neck','Nassau',40.812895,-73.741002),('11025','NY','Great Neck','Nassau',40.8005,-73.7288),('11026','NY','Great Neck','Nassau',40.8005,-73.7288),('11027','NY','Great Neck','Nassau',40.7875,-73.725),('11030','NY','Manhasset','Nassau',40.796641,-73.689558),('11040','NY','New Hyde Park','Nassau',40.742951,-73.681927),('11041','NY','New Hyde Park','Nassau',40.735,-73.6883),('11042','NY','New Hyde Park','Nassau',40.760029,-73.694056),('11043','NY','New Hyde Park','Nassau',40.7317,-73.6821),('11044','NY','New Hyde Park','Nassau',40.735,-73.6883),('11050','NY','Port Washington','Nassau',40.833153,-73.693098),('11051','NY','Port Washington','Nassau',40.8308,-73.6842),('11052','NY','Port Washington','Nassau',40.8308,-73.6842),('11053','NY','Port Washington','Nassau',40.8255,-73.6986),('11054','NY','Port Washington','Nassau',40.8308,-73.6842),('11055','NY','Port Washington','Nassau',40.8255,-73.6986),('11096','NY','Inwood','Nassau',40.618003,-73.747912),('11099','NY','New Hyde Park','Nassau',40.735,-73.6883),('11101','NY','Long Island City','Queens',40.74713,-73.939736),('11102','NY','Astoria','Queens',40.771779,-73.925031),('11103','NY','Astoria','Queens',40.763748,-73.912351),('11104','NY','Sunnyside','Queens',40.744175,-73.919932),('11105','NY','Astoria','Queens',40.776028,-73.908147),('11106','NY','Astoria','Queens',40.762211,-73.931528),('11109','NY','Long Island City','Queens',40.745115,-73.956928),('11120','NY','Long Island City','Queens',40.7447,-73.9491),('11201','NY','Brooklyn','Kings',40.695634,-73.989391),('11202','NY','Brooklyn','Kings',40.6959,-73.9934),('11203','NY','Brooklyn','Kings',40.649348,-73.93354),('11204','NY','Brooklyn','Kings',40.619186,-73.984883),('11205','NY','Brooklyn','Kings',40.695738,-73.967845),('11206','NY','Brooklyn','Kings',40.702427,-73.94152),('11207','NY','Brooklyn','Kings',40.671473,-73.894251),('11208','NY','Brooklyn','Kings',40.673446,-73.871825),('11209','NY','Brooklyn','Kings',40.622771,-74.02986),('11210','NY','Brooklyn','Kings',40.628132,-73.945639),('11211','NY','Brooklyn','Kings',40.711498,-73.955522),('11212','NY','Brooklyn','Kings',40.662696,-73.913322),('11213','NY','Brooklyn','Kings',40.671255,-73.935062),('11214','NY','Brooklyn','Kings',40.599633,-73.996841),('11215','NY','Brooklyn','Kings',40.667706,-73.98587),('11216','NY','Brooklyn','Kings',40.680779,-73.948595),('11217','NY','Brooklyn','Kings',40.682306,-73.978099),('11218','NY','Brooklyn','Kings',40.64365,-73.976015),('11219','NY','Brooklyn','Kings',40.632629,-73.996467),('11220','NY','Brooklyn','Kings',40.641027,-74.016399),('11221','NY','Brooklyn','Kings',40.692193,-73.927401),('11222','NY','Brooklyn','Kings',40.726128,-73.946657),('11223','NY','Brooklyn','Kings',40.5981,-73.973497),('11224','NY','Brooklyn','Kings',40.577024,-73.991884),('11225','NY','Brooklyn','Kings',40.663233,-73.955492),('11226','NY','Brooklyn','Kings',40.645708,-73.956456),('11228','NY','Brooklyn','Kings',40.61785,-74.011773),('11229','NY','Brooklyn','Kings',40.599382,-73.941169),('11230','NY','Brooklyn','Kings',40.623514,-73.965445),('11231','NY','Brooklyn','Kings',40.67878,-74.002389),('11232','NY','Brooklyn','Kings',40.656255,-74.003872),('11233','NY','Brooklyn','Kings',40.677407,-73.91871),('11234','NY','Brooklyn','Kings',40.6176,-73.921427),('11235','NY','Brooklyn','Kings',40.583794,-73.951606),('11236','NY','Brooklyn','Kings',40.640802,-73.903552),('11237','NY','Brooklyn','Kings',40.703719,-73.9204),('11238','NY','Brooklyn','Kings',40.680396,-73.962923),('11239','NY','Brooklyn','Kings',40.649065,-73.880238),('11240','NY','Brooklyn','Kings',40.6981,-73.986),('11241','NY','Brooklyn','Kings',40.6932,-73.9911),('11242','NY','Brooklyn','Kings',40.6932,-73.9911),('11243','NY','Brooklyn','Kings',40.6846,-73.9804),('11244','NY','Brooklyn','Kings',40.6895,-73.9906),('11245','NY','Brooklyn','Kings',40.6873,-73.9896),('11247','NY','Brooklyn','Kings',40.68,-73.9476),('11248','NY','Brooklyn','Kings',40.6991,-73.9928),('11249','NY','Brooklyn','Kings',40.6942,-73.9907),('11251','NY','Brooklyn','Kings',40.7011,-73.9732),('11252','NY','Brooklyn','Kings',40.6199,-74.0275),('11254','NY','Brooklyn','Kings',40.6983,-73.9917),('11255','NY','Brooklyn','Kings',40.6953,-73.9899),('11256','NY','Brooklyn','Kings',40.6632,-73.8603),('11351','NY','Flushing','Queens',40.7816,-73.8272),('11352','NY','Flushing','Queens',40.7476,-73.8263),('11354','NY','Flushing','Queens',40.768589,-73.825511),('11355','NY','Flushing','Queens',40.750123,-73.820977),('11356','NY','College Point','Queens',40.786064,-73.844319),('11357','NY','Whitestone','Queens',40.785126,-73.810037),('11358','NY','Flushing','Queens',40.761404,-73.795699),('11359','NY','Bayside','Queens',40.7922,-73.7773),('11360','NY','Bayside','Queens',40.780515,-73.78254),('11361','NY','Bayside','Queens',40.763164,-73.773242),('11362','NY','Little Neck','Queens',40.759908,-73.734091),('11363','NY','Little Neck','Queens',40.773807,-73.746493),('11364','NY','Oakland Gardens','Queens',40.746762,-73.76056),('11365','NY','Fresh Meadows','Queens',40.739595,-73.793461),('11366','NY','Fresh Meadows','Queens',40.727485,-73.790965),('11367','NY','Flushing','Queens',40.729438,-73.824053),('11368','NY','Corona','Queens',40.749742,-73.853078),('11369','NY','East Elmhurst','Queens',40.763492,-73.872028),('11370','NY','East Elmhurst','Queens',40.767834,-73.889972),('11371','NY','Flushing','Queens',40.772072,-73.875095),('11372','NY','Jackson Heights','Queens',40.750816,-73.884032),('11373','NY','Elmhurst','Queens',40.738749,-73.878207),('11374','NY','Rego Park','Queens',40.726394,-73.862015),('11375','NY','Forest Hills','Queens',40.721254,-73.846105),('11377','NY','Woodside','Queens',40.744737,-73.905107),('11378','NY','Maspeth','Queens',40.724796,-73.90527),('11379','NY','Middle Village','Queens',40.718231,-73.879864),('11380','NY','Elmhurst','Queens',40.7652,-73.8177),('11381','NY','Flushing','Queens',40.7652,-73.8177),('11385','NY','Ridgewood','Queens',40.703722,-73.893161),('11386','NY','Ridgewood','Queens',40.7004,-73.897),('11390','NY','Flushing','Queens',40.7652,-73.8177),('11405','NY','Jamaica','Queens',40.6913,-73.8061),('11411','NY','Cambria Heights','Queens',40.694754,-73.735764),('11412','NY','Saint Albans','Queens',40.69845,-73.759215),('11413','NY','Springfield Gardens','Queens',40.671336,-73.751338),('11414','NY','Howard Beach','Queens',40.659539,-73.843377),('11415','NY','Kew Gardens','Queens',40.70766,-73.829949),('11416','NY','Ozone Park','Queens',40.684014,-73.850266),('11417','NY','Ozone Park','Queens',40.676331,-73.844641),('11418','NY','Richmond Hill','Queens',40.699656,-73.833674),('11419','NY','South Richmond Hill','Queens',40.689692,-73.822903),('11420','NY','South Ozone Park','Queens',40.674503,-73.81527),('11421','NY','Woodhaven','Queens',40.69163,-73.85829),('11422','NY','Rosedale','Queens',40.663075,-73.734587),('11423','NY','Hollis','Queens',40.715146,-73.768801),('11424','NY','Jamaica','Queens',40.6913,-73.8061),('11425','NY','Jamaica','Queens',40.6913,-73.8061),('11426','NY','Bellerose','Queens',40.733984,-73.721884),('11427','NY','Queens Village','Queens',40.729162,-73.748661),('11428','NY','Queens Village','Queens',40.72159,-73.742672),('11429','NY','Queens Village','Queens',40.708768,-73.738836),('11430','NY','Jamaica','Queens',40.655907,-73.794505),('11431','NY','Jamaica','Queens',40.6913,-73.8061),('11432','NY','Jamaica','Queens',40.714764,-73.793797),('11433','NY','Jamaica','Queens',40.6979,-73.787125),('11434','NY','Jamaica','Queens',40.676808,-73.776425),('11435','NY','Jamaica','Queens',40.700489,-73.809392),('11436','NY','Jamaica','Queens',40.675835,-73.796874),('11439','NY','Jamaica','Queens',40.6913,-73.8061),('11451','NY','Jamaica','Queens',40.7011,-73.8006),('11499','NY','Jamaica','Queens',40.6913,-73.8061),('11501','NY','Mineola','Nassau',40.747295,-73.638374),('11507','NY','Albertson','Nassau',40.770039,-73.650089),('11509','NY','Atlantic Beach','Nassau',40.589458,-73.729277),('11510','NY','Baldwin','Nassau',40.654116,-73.609607),('11514','NY','Carle Place','Nassau',40.749595,-73.613051),('11516','NY','Cedarhurst','Nassau',40.627479,-73.727879),('11518','NY','East Rockaway','Nassau',40.640347,-73.66674),('11520','NY','Freeport','Nassau',40.654265,-73.58549),('11530','NY','Garden City','Nassau',40.727568,-73.640822),('11531','NY','Garden City','Nassau',40.7235,-73.6334),('11535','NY','Garden City','Nassau',40.7235,-73.6334),('11536','NY','Garden City','Nassau',40.6743,-73.7042),('11542','NY','Glen Cove','Nassau',40.867358,-73.627645),('11545','NY','Glen Head','Nassau',40.827919,-73.604641),('11547','NY','Glenwood Landing','Nassau',40.828084,-73.644148),('11548','NY','Greenvale','Nassau',40.813472,-73.621688),('11549','NY','Hempstead','Nassau',40.717641,-73.602618),('11550','NY','Hempstead','Nassau',40.7024,-73.617605),('11551','NY','Hempstead','Nassau',40.7074,-73.6287),('11552','NY','West Hempstead','Nassau',40.695203,-73.653797),('11553','NY','Uniondale','Nassau',40.701826,-73.59436),('11554','NY','East Meadow','Nassau',40.715298,-73.557141),('11555','NY','Uniondale','Nassau',40.7193,-73.5833),('11556','NY','Uniondale','Nassau',40.6967,-73.5774),('11557','NY','Hewlett','Nassau',40.639374,-73.693309),('11558','NY','Island Park','Nassau',40.603272,-73.654365),('11559','NY','Lawrence','Nassau',40.613397,-73.730902),('11560','NY','Locust Valley','Nassau',40.882196,-73.592598),('11561','NY','Long Beach','Nassau',40.588047,-73.665432),('11563','NY','Lynbrook','Nassau',40.656956,-73.67329),('11565','NY','Malverne','Nassau',40.675077,-73.670981),('11566','NY','Merrick','Nassau',40.669403,-73.554981),('11568','NY','Old Westbury','Nassau',40.785816,-73.595539),('11569','NY','Point Lookout','Nassau',40.590629,-73.581749),('11570','NY','Rockville Centre','Nassau',40.66445,-73.636683),('11571','NY','Rockville Centre','Nassau',40.6559,-73.6467),('11572','NY','Oceanside','Nassau',40.636155,-73.637668),('11575','NY','Roosevelt','Nassau',40.680231,-73.586512),('11576','NY','Roslyn','Nassau',40.796569,-73.646885),('11577','NY','Roslyn Heights','Nassau',40.785569,-73.640125),('11579','NY','Sea Cliff','Nassau',40.846427,-73.644616),('11580','NY','Valley Stream','Nassau',40.6741,-73.703799),('11581','NY','Valley Stream','Nassau',40.652144,-73.710034),('11582','NY','Valley Stream','Nassau',40.6618,-73.7028),('11590','NY','Westbury','Nassau',40.756402,-73.575545),('11592','NY','Rockville Centre','Nassau',40.7566,-73.5729),('11594','NY','Westbury','Nassau',40.7555,-73.588),('11595','NY','Westbury','Nassau',40.7556,-73.5863),('11596','NY','Williston Park','Nassau',40.759077,-73.644439),('11597','NY','Westbury','Nassau',40.7555,-73.588),('11598','NY','Woodmere','Nassau',40.632342,-73.713536),('11599','NY','Garden City','Nassau',40.7266,-73.6347),('11690','NY','Far Rockaway','Queens',40.6126,-73.7716),('11691','NY','Far Rockaway','Queens',40.600596,-73.759571),('11692','NY','Arverne','Queens',40.592338,-73.793211),('11693','NY','Far Rockaway','Queens',40.597491,-73.820406),('11694','NY','Rockaway Park','Queens',40.57798,-73.845588),('11695','NY','Far Rockaway','Queens',40.5607,-73.9069),('11697','NY','Breezy Point','Queens',40.56102,-73.909616),('11701','NY','Amityville','Suffolk',40.686584,-73.415652),('11702','NY','Babylon','Suffolk',40.68357,-73.321348),('11703','NY','North Babylon','Suffolk',40.733429,-73.322321),('11704','NY','West Babylon','Suffolk',40.719224,-73.358249),('11705','NY','Bayport','Suffolk',40.748286,-73.054132),('11706','NY','Bay Shore','Suffolk',40.7174,-73.240937),('11707','NY','West Babylon','Suffolk',40.6444,-73.2949),('11708','NY','Amityville','Suffolk',40.686,-73.4125),('11709','NY','Bayville','Nassau',40.906313,-73.558244),('11710','NY','Bellmore','Nassau',40.675999,-73.533092),('11713','NY','Bellport','Suffolk',40.774146,-72.946302),('11714','NY','Bethpage','Nassau',40.740277,-73.485752),('11715','NY','Blue Point','Suffolk',40.749072,-73.034379),('11716','NY','Bohemia','Suffolk',40.770126,-73.113684),('11717','NY','Brentwood','Suffolk',40.783968,-73.245322),('11718','NY','Brightwaters','Suffolk',40.719643,-73.265856),('11719','NY','Brookhaven','Suffolk',40.780567,-72.915943),('11720','NY','Centereach','Suffolk',40.869756,-73.081275),('11721','NY','Centerport','Suffolk',40.891026,-73.375364),('11722','NY','Central Islip','Suffolk',40.783496,-73.199075),('11724','NY','Cold Spring Harbor','Suffolk',40.868806,-73.450572),('11725','NY','Commack','Suffolk',40.840975,-73.28011),('11726','NY','Copiague','Suffolk',40.680923,-73.395821),('11727','NY','Coram','Suffolk',40.884843,-73.002405),('11729','NY','Deer Park','Suffolk',40.760913,-73.329445),('11730','NY','East Islip','Suffolk',40.731293,-73.180882),('11731','NY','East Northport','Suffolk',40.867579,-73.320052),('11732','NY','East Norwich','Nassau',40.847386,-73.534602),('11733','NY','East Setauket','Suffolk',40.928939,-73.102493),('11735','NY','Farmingdale','Nassau',40.725687,-73.443412),('11736','NY','Farmingdale','Nassau',40.7325,-73.4458),('11737','NY','Farmingdale','Nassau',40.7301,-73.446),('11738','NY','Farmingville','Suffolk',40.834798,-73.038449),('11739','NY','Great River','Suffolk',40.727106,-73.160287),('11740','NY','Greenlawn','Suffolk',40.862947,-73.361156),('11741','NY','Holbrook','Suffolk',40.799737,-73.074665),('11742','NY','Holtsville','Suffolk',40.809687,-73.040197),('11743','NY','Huntington','Suffolk',40.867765,-73.412003),('11746','NY','Huntington Station','Suffolk',40.821748,-73.37482),('11747','NY','Melville','Suffolk',40.791583,-73.405429),('11749','NY','Islandia','Suffolk',40.804582,-73.172827),('11750','NY','Huntington Station','Suffolk',40.8348,-73.3782),('11751','NY','Islip','Suffolk',40.737004,-73.214443),('11752','NY','Islip Terrace','Suffolk',40.755112,-73.182848),('11753','NY','Jericho','Nassau',40.788933,-73.536902),('11754','NY','Kings Park','Suffolk',40.888525,-73.242489),('11755','NY','Lake Grove','Suffolk',40.856098,-73.117021),('11756','NY','Levittown','Nassau',40.726512,-73.516241),('11757','NY','Lindenhurst','Suffolk',40.690155,-73.374465),('11758','NY','Massapequa','Nassau',40.679192,-73.461636),('11760','NY','Islandia','Suffolk',40.8233,-73.2074),('11762','NY','Massapequa Park','Nassau',40.684989,-73.447092),('11763','NY','Medford','Suffolk',40.822943,-72.983491),('11764','NY','Miller Place','Suffolk',40.946682,-72.988146),('11765','NY','Mill Neck','Nassau',40.882186,-73.558941),('11766','NY','Mount Sinai','Suffolk',40.930255,-73.013557),('11767','NY','Nesconset','Suffolk',40.843616,-73.142068),('11768','NY','Northport','Suffolk',40.90608,-73.329896),('11769','NY','Oakdale','Suffolk',40.736771,-73.132517),('11770','NY','Ocean Beach','Suffolk',40.648374,-73.15507),('11771','NY','Oyster Bay','Nassau',40.870208,-73.523787),('11772','NY','Patchogue','Suffolk',40.768204,-73.0018),('11773','NY','Syosset','Nassau',40.7623,-73.524),('11774','NY','Farmingdale','Nassau',40.7325,-73.4458),('11775','NY','Melville','Suffolk',40.7912,-73.4164),('11776','NY','Port Jefferson Station','Suffolk',40.911719,-73.045749),('11777','NY','Port Jefferson','Suffolk',40.945806,-73.062115),('11778','NY','Rocky Point','Suffolk',40.955176,-72.930034),('11779','NY','Ronkonkoma','Suffolk',40.818795,-73.115795),('11780','NY','Saint James','Suffolk',40.883869,-73.159568),('11782','NY','Sayville','Suffolk',40.7284,-73.079919),('11783','NY','Seaford','Nassau',40.680767,-73.489482),('11784','NY','Selden','Suffolk',40.869283,-73.042326),('11786','NY','Shoreham','Suffolk',40.947104,-72.895102),('11787','NY','Smithtown','Suffolk',40.852529,-73.205963),('11788','NY','Hauppauge','Suffolk',40.819305,-73.2096),('11789','NY','Sound Beach','Suffolk',40.957478,-72.972256),('11790','NY','Stony Brook','Suffolk',40.905836,-73.128125),('11791','NY','Syosset','Nassau',40.815548,-73.502411),('11792','NY','Wading River','Suffolk',40.952725,-72.831678),('11793','NY','Wantagh','Nassau',40.673206,-73.512299),('11794','NY','Stony Brook','Suffolk',40.914666,-73.129099),('11795','NY','West Islip','Suffolk',40.713514,-73.299858),('11796','NY','West Sayville','Suffolk',40.733235,-73.100761),('11797','NY','Woodbury','Nassau',40.811943,-73.472629),('11798','NY','Wyandanch','Suffolk',40.752988,-73.365541),('11801','NY','Hicksville','Nassau',40.763594,-73.523296),('11802','NY','Hicksville','Nassau',40.7674,-73.5331),('11803','NY','Plainview','Nassau',40.780131,-73.479493),('11804','NY','Old Bethpage','Nassau',40.765736,-73.457824),('11815','NY','Hicksville','Nassau',40.7683,-73.5255),('11819','NY','Hicksville','Nassau',40.7674,-73.5331),('11853','NY','Jericho','Nassau',40.7919,-73.5402),('11854','NY','Hicksville','Nassau',40.7683,-73.5255),('11855','NY','Hicksville','Nassau',40.7683,-73.5255),('11901','NY','Riverhead','Suffolk',40.919054,-72.652294),('11930','NY','Amagansett','Suffolk',40.984853,-72.104768),('11931','NY','Aquebogue','Suffolk',40.933949,-72.612438),('11932','NY','Bridgehampton','Suffolk',40.934224,-72.303315),('11933','NY','Calverton','Suffolk',40.932928,-72.746585),('11934','NY','Center Moriches','Suffolk',40.799313,-72.796523),('11935','NY','Cutchogue','Suffolk',41.012867,-72.472369),('11937','NY','East Hampton','Suffolk',40.992552,-72.190052),('11939','NY','East Marion','Suffolk',41.124557,-72.338856),('11940','NY','East Moriches','Suffolk',40.807795,-72.753604),('11941','NY','Eastport','Suffolk',40.83016,-72.729761),('11942','NY','East Quogue','Suffolk',40.849267,-72.578898),('11944','NY','Greenport','Suffolk',41.103675,-72.367657),('11946','NY','Hampton Bays','Suffolk',40.875666,-72.520119),('11947','NY','Jamesport','Suffolk',40.950985,-72.575812),('11948','NY','Laurel','Suffolk',40.96364,-72.553489),('11949','NY','Manorville','Suffolk',40.856699,-72.797822),('11950','NY','Mastic','Suffolk',40.804836,-72.846589),('11951','NY','Mastic Beach','Suffolk',40.763437,-72.845605),('11952','NY','Mattituck','Suffolk',40.996193,-72.53702),('11953','NY','Middle Island','Suffolk',40.884061,-72.953054),('11954','NY','Montauk','Suffolk',41.041229,-71.938566),('11955','NY','Moriches','Suffolk',40.805326,-72.820941),('11956','NY','New Suffolk','Suffolk',40.992796,-72.475098),('11957','NY','Orient','Suffolk',41.149434,-72.265558),('11958','NY','Peconic','Suffolk',41.039067,-72.464419),('11959','NY','Quogue','Suffolk',40.824082,-72.602277),('11960','NY','Remsenburg','Suffolk',40.803858,-72.704123),('11961','NY','Ridge','Suffolk',40.906961,-72.883122),('11962','NY','Sagaponack','Suffolk',40.930895,-72.268719),('11963','NY','Sag Harbor','Suffolk',40.997558,-72.313084),('11964','NY','Shelter Island','Suffolk',41.063905,-72.333927),('11965','NY','Shelter Island Heights','Suffolk',41.078628,-72.347465),('11967','NY','Shirley','Suffolk',40.794226,-72.871588),('11968','NY','Southampton','Suffolk',40.905926,-72.415663),('11969','NY','Southampton','Suffolk',40.8841,-72.39),('11970','NY','South Jamesport','Suffolk',40.938798,-72.578387),('11971','NY','Southold','Suffolk',41.059493,-72.420335),('11972','NY','Speonk','Suffolk',40.83274,-72.707723),('11973','NY','Upton','Suffolk',40.870216,-72.881039),('11975','NY','Wainscott','Suffolk',40.947325,-72.244582),('11976','NY','Water Mill','Suffolk',40.918527,-72.345566),('11977','NY','Westhampton','Suffolk',40.820263,-72.673052),('11978','NY','Westhampton Beach','Suffolk',40.814369,-72.649065),('11980','NY','Yaphank','Suffolk',40.832204,-72.916043),('12007','NY','Alcove','Albany',42.459015,-73.935671),('12008','NY','Alplaus','Schenectady',42.854074,-73.905154),('12009','NY','Altamont','Albany',42.698927,-74.023296),('12010','NY','Amsterdam','Montgomery',42.939567,-74.18314),('12015','NY','Athens','Greene',42.276919,-73.823354),('12016','NY','Auriesville','Montgomery',42.8738,-74.3527),('12017','NY','Austerlitz','Columbia',42.321148,-73.455928),('12018','NY','Averill Park','Rensselaer',42.625323,-73.538795),('12019','NY','Ballston Lake','Saratoga',42.92431,-73.860319),('12020','NY','Ballston Spa','Saratoga',43.007447,-73.865511),('12022','NY','Berlin','Rensselaer',42.686836,-73.3592),('12023','NY','Berne','Albany',42.607551,-74.152999),('12024','NY','Brainard','Columbia',42.469965,-73.533724),('12025','NY','Broadalbin','Fulton',43.076333,-74.152367),('12027','NY','Burnt Hills','Saratoga',42.913422,-73.907852),('12028','NY','Buskirk','Rensselaer',42.934442,-73.44227),('12029','NY','Canaan','Columbia',42.401059,-73.423333),('12031','NY','Carlisle','Schoharie',42.765997,-74.451612),('12032','NY','Caroga Lake','Fulton',43.188863,-74.520324),('12033','NY','Castleton On Hudson','Rensselaer',42.5347,-73.710925),('12035','NY','Central Bridge','Schoharie',42.731386,-74.343502),('12036','NY','Charlotteville','Schoharie',42.543511,-74.686241),('12037','NY','Chatham','Columbia',42.356243,-73.588047),('12040','NY','Cherry Plain','Rensselaer',42.63415,-73.356761),('12041','NY','Clarksville','Albany',42.57636,-73.961214),('12042','NY','Climax','Greene',42.383649,-73.87957),('12043','NY','Cobleskill','Schoharie',42.700153,-74.506566),('12045','NY','Coeymans','Albany',42.473962,-73.793214),('12046','NY','Coeymans Hollow','Albany',42.480506,-73.923711),('12047','NY','Cohoes','Albany',42.776181,-73.710585),('12050','NY','Columbiaville','Columbia',42.3183,-73.7536),('12051','NY','Coxsackie','Greene',42.348391,-73.826896),('12052','NY','Cropseyville','Rensselaer',42.75896,-73.480652),('12053','NY','Delanson','Schenectady',42.749315,-74.186116),('12054','NY','Delmar','Albany',42.615062,-73.840523),('12055','NY','Dormansville','Albany',42.4385,-74.2024),('12056','NY','Duanesburg','Schenectady',42.769868,-74.095623),('12057','NY','Eagle Bridge','Washington',42.969515,-73.355261),('12058','NY','Earlton','Greene',42.343367,-73.929379),('12059','NY','East Berne','Albany',42.62201,-74.049925),('12060','NY','East Chatham','Columbia',42.419682,-73.503532),('12061','NY','East Greenbush','Rensselaer',42.593351,-73.680702),('12062','NY','East Nassau','Rensselaer',42.525389,-73.503296),('12063','NY','East Schodack','Rensselaer',42.561102,-73.636217),('12064','NY','East Worcester','Otsego',42.615468,-74.659267),('12065','NY','Clifton Park','Saratoga',42.854674,-73.784765),('12066','NY','Esperance','Schoharie',42.784569,-74.307188),('12067','NY','Feura Bush','Albany',42.561779,-73.925623),('12068','NY','Fonda','Montgomery',42.953469,-74.382442),('12069','NY','Fort Hunter','Montgomery',42.94235,-74.281999),('12070','NY','Fort Johnson','Montgomery',42.974708,-74.250675),('12071','NY','Fultonham','Schoharie',42.540816,-74.419229),('12072','NY','Fultonville','Montgomery',42.902307,-74.378119),('12073','NY','Gallupville','Schoharie',42.6625,-74.233),('12074','NY','Galway','Saratoga',43.050577,-74.052937),('12075','NY','Ghent','Columbia',42.30236,-73.65069),('12076','NY','Gilboa','Schoharie',42.41881,-74.4097),('12077','NY','Glenmont','Albany',42.598117,-73.797539),('12078','NY','Gloversville','Fulton',43.06967,-74.339685),('12082','NY','Grafton','Rensselaer',42.7688,-73.4513),('12083','NY','Greenville','Greene',42.42513,-74.036864),('12084','NY','Guilderland','Albany',42.698968,-73.895657),('12085','NY','Guilderland Center','Albany',42.701279,-73.960684),('12086','NY','Hagaman','Montgomery',42.987359,-74.136263),('12087','NY','Hannacroix','Greene',42.424014,-73.888959),('12089','NY','Hoosick','Rensselaer',42.868209,-73.313767),('12090','NY','Hoosick Falls','Rensselaer',42.88929,-73.353319),('12092','NY','Howes Cave','Schoharie',42.702089,-74.367649),('12093','NY','Jefferson','Schoharie',42.493791,-74.617184),('12094','NY','Johnsonville','Rensselaer',42.899406,-73.490162),('12095','NY','Johnstown','Fulton',43.012497,-74.382964),('12106','NY','Kinderhook','Columbia',42.389507,-73.70958),('12107','NY','Knox','Albany',42.6711,-74.1161),('12108','NY','Lake Pleasant','Hamilton',43.544126,-74.435031),('12110','NY','Latham','Albany',42.748146,-73.770171),('12115','NY','Malden Bridge','Columbia',42.473881,-73.577524),('12116','NY','Maryland','Otsego',42.53093,-74.925381),('12117','NY','Mayfield','Fulton',43.147073,-74.235395),('12118','NY','Mechanicville','Saratoga',42.908941,-73.71353),('12120','NY','Medusa','Albany',42.446751,-74.14316),('12121','NY','Melrose','Rensselaer',42.839897,-73.607392),('12122','NY','Middleburgh','Schoharie',42.557556,-74.310896),('12123','NY','Nassau','Rensselaer',42.517679,-73.606793),('12124','NY','New Baltimore','Greene',42.445136,-73.792602),('12125','NY','New Lebanon','Columbia',42.468004,-73.395716),('12128','NY','Newtonville','Albany',42.7244,-73.7588),('12130','NY','Niverville','Columbia',42.442811,-73.657891),('12131','NY','North Blenheim','Schoharie',42.454859,-74.476851),('12132','NY','North Chatham','Columbia',42.475169,-73.632467),('12133','NY','North Hoosick','Rensselaer',42.928,-73.3433),('12134','NY','Northville','Fulton',43.238011,-74.170777),('12136','NY','Old Chatham','Columbia',42.437634,-73.555931),('12137','NY','Pattersonville','Schenectady',42.86494,-74.118405),('12138','NY','Petersburg','Rensselaer',42.74883,-73.370376),('12139','NY','Piseco','Hamilton',43.500184,-74.579588),('12140','NY','Poestenkill','Rensselaer',42.693579,-73.572154),('12141','NY','Quaker Street','Schenectady',42.7347,-74.1866),('12143','NY','Ravena','Albany',42.469062,-73.829527),('12144','NY','Rensselaer','Rensselaer',42.637451,-73.725924),('12147','NY','Rensselaerville','Albany',42.518605,-74.158859),('12148','NY','Rexford','Saratoga',42.83635,-73.858481),('12149','NY','Richmondville','Schoharie',42.628846,-74.569479),('12150','NY','Rotterdam Junction','Schenectady',42.876807,-74.054825),('12151','NY','Round Lake','Saratoga',42.934613,-73.79314),('12153','NY','Sand Lake','Rensselaer',42.631696,-73.46225),('12154','NY','Schaghticoke','Rensselaer',42.917875,-73.60107),('12155','NY','Schenevus','Otsego',42.590732,-74.826437),('12156','NY','Schodack Landing','Rensselaer',42.485906,-73.739381),('12157','NY','Schoharie','Schoharie',42.666511,-74.303032),('12158','NY','Selkirk','Albany',42.542043,-73.816561),('12159','NY','Slingerlands','Albany',42.641946,-73.876163),('12160','NY','Sloansville','Schoharie',42.763362,-74.363533),('12161','NY','South Bethlehem','Albany',42.533962,-73.846846),('12164','NY','Speculator','Hamilton',43.517799,-74.373377),('12165','NY','Spencertown','Columbia',42.315673,-73.520048),('12166','NY','Sprakers','Montgomery',42.827982,-74.463201),('12167','NY','Stamford','Delaware',42.414771,-74.596185),('12168','NY','Stephentown','Rensselaer',42.549254,-73.38397),('12169','NY','Stephentown','Rensselaer',42.579014,-73.442241),('12170','NY','Stillwater','Saratoga',42.991423,-73.656442),('12172','NY','Stottville','Columbia',42.28726,-73.738568),('12173','NY','Stuyvesant','Columbia',42.380013,-73.75966),('12174','NY','Stuyvesant Falls','Columbia',42.356308,-73.731353),('12175','NY','Summit','Schoharie',42.544369,-74.55622),('12176','NY','Surprise','Greene',42.378137,-73.963338),('12177','NY','Tribes Hill','Montgomery',42.950924,-74.287293),('12180','NY','Troy','Rensselaer',42.732352,-73.659758),('12181','NY','Troy','Rensselaer',42.7311,-73.6894),('12182','NY','Troy','Rensselaer',42.783852,-73.661355),('12183','NY','Troy','Albany',42.743139,-73.694094),('12184','NY','Valatie','Columbia',42.423059,-73.659108),('12185','NY','Valley Falls','Rensselaer',42.906351,-73.544941),('12186','NY','Voorheesville','Albany',42.636609,-73.95998),('12187','NY','Warnerville','Schoharie',42.628331,-74.466258),('12188','NY','Waterford','Saratoga',42.807339,-73.689766),('12189','NY','Watervliet','Albany',42.729162,-73.709056),('12190','NY','Wells','Hamilton',43.440235,-74.292943),('12192','NY','West Coxsackie','Greene',42.394693,-73.825186),('12193','NY','Westerlo','Albany',42.521751,-74.04803),('12194','NY','West Fulton','Schoharie',42.51159,-74.460721),('12195','NY','West Lebanon','Columbia',42.483698,-73.47038),('12196','NY','West Sand Lake','Rensselaer',42.63933,-73.615854),('12197','NY','Worcester','Otsego',42.609999,-74.724749),('12198','NY','Wynantskill','Rensselaer',42.685862,-73.638971),('12201','NY','Albany','Albany',42.6525,-73.7566),('12202','NY','Albany','Albany',42.639387,-73.760622),('12203','NY','Albany','Albany',42.677595,-73.830112),('12204','NY','Albany','Albany',42.68598,-73.728761),('12205','NY','Albany','Albany',42.71101,-73.822647),('12206','NY','Albany','Albany',42.67216,-73.780021),('12207','NY','Albany','Albany',42.653606,-73.74953),('12208','NY','Albany','Albany',42.658205,-73.801447),('12209','NY','Albany','Albany',42.640085,-73.786893),('12210','NY','Albany','Albany',42.658186,-73.759509),('12211','NY','Albany','Albany',42.705617,-73.770599),('12212','NY','Albany','Albany',42.6525,-73.7566),('12214','NY','Albany','Albany',42.6525,-73.7566),('12220','NY','Albany','Albany',42.6525,-73.7566),('12222','NY','Albany','Albany',42.685261,-73.82323),('12223','NY','Albany','Albany',42.6525,-73.7566),('12224','NY','Albany','Albany',42.6525,-73.7566),('12225','NY','Albany','Albany',42.6525,-73.7566),('12226','NY','Albany','Albany',42.6525,-73.7566),('12227','NY','Albany','Albany',42.6525,-73.7566),('12228','NY','Albany','Albany',42.6525,-73.7566),('12229','NY','Albany','Albany',42.6525,-73.7566),('12230','NY','Albany','Albany',42.6525,-73.7566),('12231','NY','Albany','Albany',42.6525,-73.7566),('12232','NY','Albany','Albany',42.6525,-73.7566),('12233','NY','Albany','Albany',42.7174,-73.8285),('12234','NY','Albany','Albany',42.6525,-73.7566),('12235','NY','Albany','Albany',42.7174,-73.8285),('12236','NY','Albany','Albany',42.6525,-73.7566),('12237','NY','Albany','Albany',42.6525,-73.7566),('12238','NY','Albany','Albany',42.6525,-73.7566),('12239','NY','Albany','Albany',42.6525,-73.7566),('12240','NY','Albany','Albany',42.6525,-73.7566),('12241','NY','Albany','Albany',42.6525,-73.7566),('12242','NY','Albany','Albany',42.6525,-73.7566),('12243','NY','Albany','Albany',42.6525,-73.7566),('12244','NY','Albany','Albany',42.6525,-73.7566),('12245','NY','Albany','Albany',42.6525,-73.7566),('12246','NY','Albany','Albany',42.647,-73.75),('12247','NY','Albany','Albany',42.6525,-73.7566),('12248','NY','Albany','Albany',42.6525,-73.7566),('12249','NY','Albany','Albany',42.6525,-73.7566),('12250','NY','Albany','Albany',42.6525,-73.7566),('12252','NY','Albany','Albany',42.6525,-73.7566),('12255','NY','Albany','Albany',42.6525,-73.7566),('12256','NY','Albany','Albany',42.6525,-73.7566),('12257','NY','Albany','Albany',42.6525,-73.7566),('12260','NY','Albany','Albany',42.6525,-73.7566),('12261','NY','Albany','Albany',42.7174,-73.8285),('12288','NY','Albany','Albany',42.7174,-73.8285),('12301','NY','Schenectady','Schenectady',42.8155,-73.9395),('12302','NY','Schenectady','Schenectady',42.859821,-73.96421),('12303','NY','Schenectady','Schenectady',42.769516,-73.936284),('12304','NY','Schenectady','Schenectady',42.779231,-73.90444),('12305','NY','Schenectady','Schenectady',42.813497,-73.946185),('12306','NY','Schenectady','Schenectady',42.796426,-73.993052),('12307','NY','Schenectady','Schenectady',42.805337,-73.935268),('12308','NY','Schenectady','Schenectady',42.82098,-73.91967),('12309','NY','Schenectady','Schenectady',42.801983,-73.878623),('12325','NY','Schenectady','Schenectady',42.869,-73.9325),('12345','NY','Schenectady','Schenectady',42.8102,-73.9507),('12401','NY','Kingston','Ulster',41.934429,-74.02054),('12402','NY','Kingston','Ulster',41.9317,-74.001),('12404','NY','Accord','Ulster',41.818959,-74.236081),('12405','NY','Acra','Greene',42.321292,-74.086084),('12406','NY','Arkville','Delaware',42.134646,-74.585005),('12407','NY','Ashland','Greene',42.323566,-74.363939),('12409','NY','Bearsville','Ulster',42.044868,-74.156835),('12410','NY','Big Indian','Ulster',42.085492,-74.449839),('12411','NY','Bloomington','Ulster',41.879005,-74.039774),('12412','NY','Boiceville','Ulster',42.007897,-74.271033),('12413','NY','Cairo','Greene',42.306568,-74.010793),('12414','NY','Catskill','Greene',42.22513,-73.904553),('12416','NY','Chichester','Ulster',42.10512,-74.292511),('12417','NY','Connelly','Ulster',41.909175,-73.989732),('12418','NY','Cornwallville','Greene',42.358994,-74.151636),('12419','NY','Cottekill','Ulster',41.861119,-74.102017),('12420','NY','Cragsmoor','Ulster',41.668838,-74.378415),('12421','NY','Denver','Delaware',42.236175,-74.557029),('12422','NY','Durham','Greene',42.394281,-74.190554),('12423','NY','East Durham','Greene',42.374575,-74.105847),('12424','NY','East Jewett','Greene',42.244523,-74.150286),('12427','NY','Elka Park','Greene',42.15487,-74.143689),('12428','NY','Ellenville','Ulster',41.724964,-74.416865),('12429','NY','Esopus','Ulster',41.829046,-73.965915),('12430','NY','Fleischmanns','Delaware',42.183398,-74.520682),('12431','NY','Freehold','Greene',42.357335,-74.020978),('12432','NY','Glasco','Ulster',42.044266,-73.94303),('12433','NY','Glenford','Ulster',42.000642,-74.156566),('12434','NY','Grand Gorge','Delaware',42.360569,-74.485202),('12435','NY','Greenfield Park','Ulster',41.730835,-74.513284),('12436','NY','Haines Falls','Greene',42.195759,-74.077813),('12438','NY','Halcottsville','Delaware',42.209125,-74.597671),('12439','NY','Hensonville','Greene',42.320269,-74.182531),('12440','NY','High Falls','Ulster',41.792929,-74.159312),('12441','NY','Highmount','Ulster',42.145589,-74.499216),('12442','NY','Hunter','Greene',42.219134,-74.223176),('12443','NY','Hurley','Ulster',41.926444,-74.067225),('12444','NY','Jewett','Greene',42.257133,-74.297531),('12446','NY','Kerhonkson','Ulster',41.790388,-74.304632),('12448','NY','Lake Hill','Ulster',42.073235,-74.189378),('12449','NY','Lake Katrine','Ulster',41.992378,-73.993774),('12450','NY','Lanesville','Greene',42.129971,-74.252683),('12451','NY','Leeds','Greene',42.279644,-73.931843),('12452','NY','Lexington','Greene',42.261742,-74.368592),('12453','NY','Malden On Hudson','Ulster',42.093473,-73.934782),('12454','NY','Maplecrest','Greene',42.286593,-74.172076),('12455','NY','Margaretville','Delaware',42.149624,-74.6612),('12456','NY','Mount Marion','Ulster',42.03539,-73.996445),('12457','NY','Mount Tremper','Ulster',42.042689,-74.26801),('12458','NY','Napanoch','Ulster',41.783667,-74.417874),('12459','NY','New Kingston','Delaware',42.240382,-74.678893),('12460','NY','Oak Hill','Greene',42.408578,-74.152436),('12461','NY','Olivebridge','Ulster',41.910919,-74.239587),('12463','NY','Palenville','Greene',42.180712,-74.015712),('12464','NY','Phoenicia','Ulster',42.080717,-74.322059),('12465','NY','Pine Hill','Ulster',42.139593,-74.48068),('12466','NY','Port Ewen','Ulster',41.906849,-73.977827),('12468','NY','Prattsville','Greene',42.303275,-74.416877),('12469','NY','Preston Hollow','Albany',42.437289,-74.236775),('12470','NY','Purling','Greene',42.284996,-74.034768),('12471','NY','Rifton','Ulster',41.838679,-74.040522),('12472','NY','Rosendale','Ulster',41.846927,-74.074883),('12473','NY','Round Top','Greene',42.257791,-74.024506),('12474','NY','Roxbury','Delaware',42.277313,-74.575657),('12475','NY','Ruby','Ulster',42.019346,-74.011406),('12477','NY','Saugerties','Ulster',42.081117,-73.98048),('12480','NY','Shandaken','Ulster',42.135422,-74.391343),('12481','NY','Shokan','Ulster',41.976695,-74.227962),('12482','NY','South Cairo','Greene',42.270768,-73.957313),('12483','NY','Spring Glen','Ulster',41.676735,-74.425516),('12484','NY','Stone Ridge','Ulster',41.85456,-74.163668),('12485','NY','Tannersville','Greene',42.196627,-74.14098),('12486','NY','Tillson','Ulster',41.831832,-74.067182),('12487','NY','Ulster Park','Ulster',41.869399,-73.998795),('12489','NY','Wawarsing','Ulster',41.750485,-74.358293),('12490','NY','West Camp','Ulster',42.125013,-73.929384),('12491','NY','West Hurley','Ulster',41.972285,-74.125875),('12492','NY','West Kill','Greene',42.198813,-74.362881),('12493','NY','West Park','Ulster',41.804195,-73.967585),('12494','NY','West Shokan','Ulster',41.961774,-74.277595),('12495','NY','Willow','Ulster',42.064775,-74.24021),('12496','NY','Windham','Greene',42.312504,-74.257818),('12498','NY','Woodstock','Ulster',42.03597,-74.103137),('12501','NY','Amenia','Dutchess',41.861585,-73.549914),('12502','NY','Ancram','Columbia',42.08335,-73.656655),('12503','NY','Ancramdale','Columbia',42.046451,-73.577729),('12504','NY','Annandale On Hudson','Dutchess',42.023029,-73.914269),('12506','NY','Bangall','Dutchess',41.8755,-73.6916),('12507','NY','Barrytown','Dutchess',42.005561,-73.923962),('12508','NY','Beacon','Dutchess',41.506051,-73.963176),('12510','NY','Billings','Dutchess',41.6711,-73.7636),('12511','NY','Castle Point','Dutchess',41.5461,-73.96),('12512','NY','Chelsea','Dutchess',41.552439,-73.968271),('12513','NY','Claverack','Columbia',42.219308,-73.720479),('12514','NY','Clinton Corners','Dutchess',41.872978,-73.766401),('12515','NY','Clintondale','Ulster',41.684332,-74.063798),('12516','NY','Copake','Columbia',42.105164,-73.564405),('12517','NY','Copake Falls','Columbia',42.123337,-73.514462),('12518','NY','Cornwall','Orange',41.432825,-74.032882),('12520','NY','Cornwall On Hudson','Orange',41.442722,-74.013905),('12521','NY','Craryville','Columbia',42.163078,-73.633351),('12522','NY','Dover Plains','Dutchess',41.730308,-73.581116),('12523','NY','Elizaville','Columbia',42.080009,-73.770818),('12524','NY','Fishkill','Dutchess',41.53474,-73.897471),('12525','NY','Gardiner','Ulster',41.685208,-74.169455),('12526','NY','Germantown','Columbia',42.124185,-73.866128),('12527','NY','Glenham','Dutchess',41.518346,-73.93702),('12528','NY','Highland','Ulster',41.713908,-73.995071),('12529','NY','Hillsdale','Columbia',42.204775,-73.547616),('12530','NY','Hollowville','Columbia',42.205446,-73.684933),('12531','NY','Holmes','Dutchess',41.527906,-73.673815),('12533','NY','Hopewell Junction','Dutchess',41.566341,-73.79163),('12534','NY','Hudson','Columbia',42.229398,-73.758443),('12537','NY','Hughsonville','Dutchess',41.5808,-73.9275),('12538','NY','Hyde Park','Dutchess',41.781685,-73.90785),('12540','NY','Lagrangeville','Dutchess',41.659014,-73.744163),('12541','NY','Livingston','Columbia',42.1419,-73.7783),('12542','NY','Marlboro','Ulster',41.604688,-73.988179),('12543','NY','Maybrook','Orange',41.491379,-74.191129),('12544','NY','Mellenville','Columbia',42.253,-73.668),('12545','NY','Millbrook','Dutchess',41.78715,-73.681741),('12546','NY','Millerton','Dutchess',41.965944,-73.52468),('12547','NY','Milton','Ulster',41.65622,-73.969625),('12548','NY','Modena','Ulster',41.667794,-74.107024),('12549','NY','Montgomery','Orange',41.523644,-74.244932),('12550','NY','Newburgh','Orange',41.520368,-74.04279),('12551','NY','Newburgh','Orange',41.503,-74.011),('12552','NY','Newburgh','Orange',41.503,-74.011),('12553','NY','New Windsor','Orange',41.465173,-74.062445),('12555','NY','Newburgh','Orange',41.5375,-74.0472),('12561','NY','New Paltz','Ulster',41.74953,-74.092621),('12563','NY','Patterson','Putnam',41.485123,-73.579391),('12564','NY','Pawling','Dutchess',41.570978,-73.598407),('12565','NY','Philmont','Columbia',42.248362,-73.649782),('12566','NY','Pine Bush','Ulster',41.612102,-74.326832),('12567','NY','Pine Plains','Dutchess',41.980947,-73.654984),('12568','NY','Plattekill','Ulster',41.6175,-74.0763),('12569','NY','Pleasant Valley','Dutchess',41.733832,-73.803647),('12570','NY','Poughquag','Dutchess',41.612731,-73.683798),('12571','NY','Red Hook','Dutchess',42.007516,-73.823254),('12572','NY','Rhinebeck','Dutchess',41.928785,-73.877772),('12574','NY','Rhinecliff','Dutchess',41.919024,-73.950559),('12575','NY','Rock Tavern','Orange',41.469789,-74.157304),('12577','NY','Salisbury Mills','Orange',41.432275,-74.12033),('12578','NY','Salt Point','Dutchess',41.803367,-73.781412),('12580','NY','Staatsburg','Dutchess',41.859015,-73.889917),('12581','NY','Stanfordville','Dutchess',41.901615,-73.700592),('12582','NY','Stormville','Dutchess',41.547559,-73.726675),('12583','NY','Tivoli','Dutchess',42.06587,-73.877637),('12584','NY','Vails Gate','Orange',41.4541,-74.058),('12585','NY','Verbank','Dutchess',41.719408,-73.708023),('12586','NY','Walden','Orange',41.56431,-74.175571),('12588','NY','Walker Valley','Ulster',41.6336,-74.3783),('12589','NY','Wallkill','Ulster',41.618845,-74.144822),('12590','NY','Wappingers Falls','Dutchess',41.591587,-73.899153),('12592','NY','Wassaic','Dutchess',41.783775,-73.549366),('12593','NY','West Copake','Columbia',42.0958,-73.5827),('12594','NY','Wingdale','Dutchess',41.656896,-73.557259),('12601','NY','Poughkeepsie','Dutchess',41.700576,-73.919574),('12602','NY','Poughkeepsie','Dutchess',41.707,-73.9287),('12603','NY','Poughkeepsie','Dutchess',41.677733,-73.88315),('12604','NY','Poughkeepsie','Dutchess',41.686719,-73.891187),('12701','NY','Monticello','Sullivan',41.653116,-74.697619),('12719','NY','Barryville','Sullivan',41.482664,-74.930781),('12720','NY','Bethel','Sullivan',41.660714,-74.904646),('12721','NY','Bloomingburg','Sullivan',41.561733,-74.428697),('12722','NY','Burlingham','Sullivan',41.589918,-74.383889),('12723','NY','Callicoon','Sullivan',41.76752,-75.038106),('12724','NY','Callicoon Center','Sullivan',41.852327,-74.951341),('12725','NY','Claryville','Ulster',41.954566,-74.553174),('12726','NY','Cochecton','Sullivan',41.694745,-74.975509),('12727','NY','Cochecton Center','Sullivan',41.657225,-74.981613),('12729','NY','Cuddebackville','Orange',41.466489,-74.606786),('12732','NY','Eldred','Sullivan',41.551488,-74.874603),('12733','NY','Fallsburg','Sullivan',41.737795,-74.612149),('12734','NY','Ferndale','Sullivan',41.744715,-74.751439),('12736','NY','Fremont Center','Sullivan',41.86047,-75.04045),('12737','NY','Glen Spey','Sullivan',41.492424,-74.81222),('12738','NY','Glen Wild','Sullivan',41.652609,-74.583707),('12740','NY','Grahamsville','Sullivan',41.864429,-74.498044),('12741','NY','Hankins','Sullivan',41.833238,-75.082033),('12742','NY','Harris','Sullivan',41.71867,-74.728726),('12743','NY','Highland Lake','Sullivan',41.525184,-74.842938),('12745','NY','Hortonville','Sullivan',41.77801,-75.02273),('12746','NY','Huguenot','Orange',41.442338,-74.656782),('12747','NY','Hurleyville','Sullivan',41.759119,-74.667897),('12748','NY','Jeffersonville','Sullivan',41.770705,-74.922355),('12749','NY','Kauneonga Lake','Sullivan',41.689255,-74.833093),('12750','NY','Kenoza Lake','Sullivan',41.743364,-74.956448),('12751','NY','Kiamesha Lake','Sullivan',41.684378,-74.662805),('12752','NY','Lake Huntington','Sullivan',41.677968,-74.990077),('12754','NY','Liberty','Sullivan',41.794968,-74.735738),('12758','NY','Livingston Manor','Sullivan',41.910933,-74.802142),('12759','NY','Loch Sheldrake','Sullivan',41.777388,-74.653676),('12760','NY','Long Eddy','Delaware',41.882144,-75.105542),('12762','NY','Mongaup Valley','Sullivan',41.680097,-74.788568),('12763','NY','Mountain Dale','Sullivan',41.685295,-74.523452),('12764','NY','Narrowsburg','Sullivan',41.591549,-74.995557),('12765','NY','Neversink','Sullivan',41.846729,-74.614533),('12766','NY','North Branch','Sullivan',41.815188,-74.978929),('12767','NY','Obernburg','Sullivan',41.838093,-74.994415),('12768','NY','Parksville','Sullivan',41.864443,-74.730022),('12769','NY','Phillipsport','Sullivan',41.640109,-74.454411),('12770','NY','Pond Eddy','Sullivan',41.449116,-74.845027),('12771','NY','Port Jervis','Orange',41.379399,-74.662078),('12775','NY','Rock Hill','Sullivan',41.616013,-74.587574),('12776','NY','Roscoe','Sullivan',41.949095,-74.932285),('12777','NY','Forestburgh','Sullivan',41.561802,-74.709618),('12778','NY','Smallwood','Sullivan',41.657656,-74.810903),('12779','NY','South Fallsburg','Sullivan',41.706248,-74.630529),('12780','NY','Sparrow Bush','Orange',41.440146,-74.72735),('12781','NY','Summitville','Sullivan',41.629755,-74.457347),('12783','NY','Swan Lake','Sullivan',41.743674,-74.82773),('12784','NY','Thompsonville','Sullivan',41.675366,-74.628427),('12785','NY','Westbrookville','Sullivan',41.510197,-74.559578),('12786','NY','White Lake','Sullivan',41.646123,-74.861566),('12787','NY','White Sulphur Springs','Sullivan',41.803601,-74.832204),('12788','NY','Woodbourne','Sullivan',41.779422,-74.597795),('12789','NY','Woodridge','Sullivan',41.70802,-74.570025),('12790','NY','Wurtsboro','Sullivan',41.590552,-74.506342),('12791','NY','Youngsville','Sullivan',41.809376,-74.877324),('12792','NY','Yulan','Sullivan',41.524559,-74.935523),('12801','NY','Glens Falls','Warren',43.312031,-73.647748),('12803','NY','South Glens Falls','Saratoga',43.289659,-73.636718),('12804','NY','Queensbury','Warren',43.326761,-73.677853),('12808','NY','Adirondack','Warren',43.749724,-73.747233),('12809','NY','Argyle','Washington',43.23711,-73.466604),('12810','NY','Athol','Warren',43.518658,-73.954654),('12811','NY','Bakers Mills','Warren',43.606653,-74.034632),('12812','NY','Blue Mountain Lake','Hamilton',43.861615,-74.436561),('12814','NY','Bolton Landing','Warren',43.579414,-73.657631),('12815','NY','Brant Lake','Warren',43.692495,-73.7191),('12816','NY','Cambridge','Washington',43.044231,-73.382043),('12817','NY','Chestertown','Warren',43.639585,-73.823628),('12819','NY','Clemons','Washington',43.619868,-73.453969),('12820','NY','Cleverdale','Warren',43.3109,-73.6454),('12821','NY','Comstock','Washington',43.453564,-73.415995),('12822','NY','Corinth','Saratoga',43.249151,-73.851162),('12823','NY','Cossayuna','Washington',43.179961,-73.409117),('12824','NY','Diamond Point','Warren',43.513567,-73.702204),('12827','NY','Fort Ann','Washington',43.430446,-73.501586),('12828','NY','Fort Edward','Washington',43.257198,-73.588914),('12831','NY','Gansevoort','Saratoga',43.18117,-73.699545),('12832','NY','Granville','Washington',43.3768,-73.3118),('12833','NY','Greenfield Center','Saratoga',43.130121,-73.856308),('12834','NY','Greenwich','Washington',43.099854,-73.50563),('12835','NY','Hadley','Saratoga',43.312943,-73.95855),('12836','NY','Hague','Warren',43.762475,-73.532701),('12837','NY','Hampton','Washington',43.521514,-73.258635),('12838','NY','Hartford','Washington',43.350624,-73.402767),('12839','NY','Hudson Falls','Washington',43.315397,-73.572656),('12841','NY','Huletts Landing','Washington',43.647214,-73.500659),('12842','NY','Indian Lake','Hamilton',43.755596,-74.246553),('12843','NY','Johnsburg','Warren',43.583456,-73.989555),('12844','NY','Kattskill Bay','Washington',43.494599,-73.629533),('12845','NY','Lake George','Warren',43.419436,-73.707753),('12846','NY','Lake Luzerne','Warren',43.335341,-73.826176),('12847','NY','Long Lake','Hamilton',43.960073,-74.565839),('12848','NY','Middle Falls','Washington',43.0257,-73.5435),('12849','NY','Middle Granville','Washington',43.441613,-73.300072),('12850','NY','Middle Grove','Saratoga',43.093054,-73.969607),('12851','NY','Minerva','Essex',43.841891,-74.034467),('12852','NY','Newcomb','Essex',43.955684,-74.173635),('12853','NY','North Creek','Warren',43.700222,-73.98066),('12854','NY','North Granville','Washington',43.4973,-73.3177),('12855','NY','North Hudson','Essex',43.99626,-73.72157),('12856','NY','North River','Warren',43.699725,-74.096264),('12857','NY','Olmstedville','Essex',43.796516,-73.91508),('12858','NY','Paradox','Essex',43.896662,-73.673473),('12859','NY','Porter Corners','Saratoga',43.167176,-73.896576),('12860','NY','Pottersville','Warren',43.72735,-73.816553),('12861','NY','Putnam Station','Washington',43.759787,-73.408217),('12862','NY','Riparius','Warren',43.73,-73.5535),('12863','NY','Rock City Falls','Saratoga',43.065577,-73.931755),('12864','NY','Sabael','Hamilton',43.728025,-74.305091),('12865','NY','Salem','Washington',43.20004,-73.343022),('12866','NY','Saratoga Springs','Saratoga',43.078296,-73.765495),('12870','NY','Schroon Lake','Essex',43.836786,-73.758637),('12871','NY','Schuylerville','Saratoga',43.082836,-73.602041),('12872','NY','Severance','Essex',43.875797,-73.729762),('12873','NY','Shushan','Washington',43.106403,-73.306336),('12874','NY','Silver Bay','Warren',43.692571,-73.506604),('12878','NY','Stony Creek','Warren',43.434941,-73.960556),('12879','NY','Newcomb','Essex',43.9694,-74.165),('12883','NY','Ticonderoga','Essex',43.853941,-73.451637),('12884','NY','Victory Mills','Saratoga',43.088745,-73.593325),('12885','NY','Warrensburg','Warren',43.533861,-73.797065),('12886','NY','Wevertown','Warren',43.645192,-73.925236),('12887','NY','Whitehall','Washington',43.551272,-73.384815),('12901','NY','Plattsburgh','Clinton',44.696843,-73.4675),('12903','NY','Plattsburgh','Clinton',44.681116,-73.447547),('12910','NY','Altona','Clinton',44.877714,-73.648523),('12911','NY','Keeseville','Clinton',44.520931,-73.464393),('12912','NY','Au Sable Forks','Clinton',44.465928,-73.730727),('12913','NY','Bloomingdale','Essex',44.421616,-73.990748),('12914','NY','Bombay','Franklin',44.932176,-74.620873),('12915','NY','Brainardsville','Franklin',44.8577,-74.0338),('12916','NY','Brushton','Franklin',44.833097,-74.513562),('12917','NY','Burke','Franklin',44.915515,-74.167267),('12918','NY','Cadyville','Clinton',44.692195,-73.665376),('12919','NY','Champlain','Clinton',44.97972,-73.443904),('12920','NY','Chateaugay','Franklin',44.88398,-74.066519),('12921','NY','Chazy','Clinton',44.893948,-73.432496),('12922','NY','Childwold','St. Lawrence',44.280326,-74.716095),('12923','NY','Churubusco','Clinton',44.947335,-73.966627),('12924','NY','Keeseville','Clinton',44.476691,-73.590669),('12926','NY','Constable','Franklin',44.950396,-74.327758),('12927','NY','Cranberry Lake','St. Lawrence',44.207226,-74.809778),('12928','NY','Crown Point','Essex',43.955524,-73.464491),('12929','NY','Dannemora','Clinton',44.720843,-73.718998),('12930','NY','Dickinson Center','Franklin',44.728144,-74.5397),('12932','NY','Elizabethtown','Essex',44.212794,-73.595599),('12933','NY','Ellenburg','Clinton',44.890994,-73.845341),('12934','NY','Ellenburg Center','Clinton',44.875182,-73.886337),('12935','NY','Ellenburg Depot','Clinton',44.842973,-73.795622),('12936','NY','Essex','Essex',44.271603,-73.386711),('12937','NY','Fort Covington','Franklin',44.968159,-74.480575),('12939','NY','Gabriels','Franklin',44.419859,-74.177089),('12941','NY','Jay','Essex',44.378313,-73.720606),('12942','NY','Keene','Essex',44.257029,-73.783148),('12943','NY','Keene Valley','Essex',44.176469,-73.782619),('12944','NY','Keeseville','Essex',44.476279,-73.488306),('12945','NY','Lake Clear','Franklin',44.363034,-74.244221),('12946','NY','Lake Placid','Essex',44.275684,-73.980142),('12949','NY','Lawrenceville','Saint Lawrence',44.7471,-74.6569),('12950','NY','Lewis','Essex',44.300705,-73.544927),('12952','NY','Lyon Mountain','Clinton',44.714794,-73.918389),('12953','NY','Malone','Franklin',44.800563,-74.266774),('12955','NY','Lyon Mountain','Clinton',44.779724,-73.981958),('12956','NY','Mineville','Essex',44.086693,-73.513978),('12957','NY','Moira','Franklin',44.848526,-74.564794),('12958','NY','Mooers','Clinton',44.953539,-73.572924),('12959','NY','Mooers Forks','Clinton',44.951615,-73.681345),('12960','NY','Moriah','Essex',44.044378,-73.528343),('12961','NY','Moriah Center','Essex',44.053086,-73.541149),('12962','NY','Morrisonville','Clinton',44.698694,-73.57996),('12964','NY','New Russia','Essex',44.160352,-73.610675),('12965','NY','Nicholville','St. Lawrence',44.701578,-74.69267),('12966','NY','North Bangor','Franklin',44.812595,-74.409947),('12967','NY','North Lawrence','St. Lawrence',44.769,-74.653374),('12969','NY','Owls Head','Franklin',44.695811,-74.11245),('12970','NY','Paul Smiths','Franklin',44.465308,-74.326456),('12972','NY','Peru','Clinton',44.563485,-73.523759),('12973','NY','Piercefield','St. Lawrence',44.261536,-74.59212),('12974','NY','Port Henry','Essex',44.043605,-73.466543),('12975','NY','Port Kent','Essex',44.526277,-73.411598),('12976','NY','Rainbow Lake','Franklin',44.467882,-74.178222),('12977','NY','Ray Brook','Essex',44.293886,-74.092864),('12978','NY','Redford','Clinton',44.609629,-73.801057),('12979','NY','Rouses Point','Clinton',44.987531,-73.367637),('12980','NY','Saint Regis Falls','Franklin',44.563851,-74.524079),('12981','NY','Saranac','Clinton',44.637958,-73.79729),('12983','NY','Saranac Lake','Franklin',44.33863,-74.180573),('12985','NY','Schuyler Falls','Clinton',44.584615,-73.70598),('12986','NY','Tupper Lake','Franklin',44.232157,-74.468216),('12987','NY','Upper Jay','Essex',44.318123,-73.779848),('12989','NY','Vermontville','Franklin',44.53695,-74.084728),('12992','NY','West Chazy','Clinton',44.813694,-73.502585),('12993','NY','Westport','Essex',44.195185,-73.471454),('12995','NY','Whippleville','Franklin',44.7333,-74.2645),('12996','NY','Willsboro','Essex',44.374178,-73.408582),('12997','NY','Wilmington','Essex',44.392703,-73.803019),('12998','NY','Witherbee','Essex',44.09198,-73.548921),('13020','NY','Apulia Station','Onondaga',42.817121,-76.072334),('13021','NY','Auburn','Cayuga',42.926811,-76.561994),('13022','NY','Auburn','Cayuga',42.9297,-76.5702),('13024','NY','Auburn','Cayuga',42.934596,-76.574232),('13026','NY','Aurora','Cayuga',42.758405,-76.669339),('13027','NY','Baldwinsville','Onondaga',43.163321,-76.336759),('13028','NY','Bernhards Bay','Oswego',43.279282,-75.931947),('13029','NY','Brewerton','Onondaga',43.225924,-76.139876),('13030','NY','Bridgeport','Madison',43.163516,-75.959158),('13031','NY','Camillus','Onondaga',43.041008,-76.288443),('13032','NY','Canastota','Madison',43.084968,-75.761863),('13033','NY','Cato','Cayuga',43.176506,-76.573334),('13034','NY','Cayuga','Cayuga',42.914837,-76.706443),('13035','NY','Cazenovia','Madison',42.940856,-75.830147),('13036','NY','Central Square','Oswego',43.297142,-76.158161),('13037','NY','Chittenango','Madison',43.059256,-75.872928),('13039','NY','Cicero','Onondaga',43.170186,-76.095026),('13040','NY','Cincinnatus','Cortland',42.559703,-75.945782),('13041','NY','Clay','Onondaga',43.179219,-76.180529),('13042','NY','Cleveland','Oswego',43.251319,-75.850073),('13043','NY','Clockville','Madison',43.0416,-75.745),('13044','NY','Constantia','Oswego',43.278981,-76.004008),('13045','NY','Cortland','Cortland',42.589361,-76.188061),('13051','NY','Delphi Falls','Onondaga',42.880099,-75.911776),('13052','NY','De Ruyter','Madison',42.73449,-75.869152),('13053','NY','Dryden','Tompkins',42.483119,-76.279225),('13054','NY','Durhamville','Oneida',43.164479,-75.671737),('13056','NY','East Homer','Cortland',42.6661,-76.1019),('13057','NY','East Syracuse','Onondaga',43.078437,-76.059059),('13060','NY','Elbridge','Onondaga',43.023637,-76.425986),('13061','NY','Erieville','Madison',42.858748,-75.745465),('13062','NY','Etna','Tompkins',42.484095,-76.384376),('13063','NY','Fabius','Onondaga',42.848735,-75.988688),('13064','NY','Fair Haven','Cayuga',43.322924,-76.71701),('13065','NY','Fayette','Seneca',42.8141,-76.8094),('13066','NY','Fayetteville','Onondaga',43.029572,-76.012093),('13068','NY','Freeville','Tompkins',42.505312,-76.353115),('13069','NY','Fulton','Oswego',43.32353,-76.4004),('13071','NY','Genoa','Cayuga',42.6746,-76.533562),('13072','NY','Georgetown','Madison',42.76221,-75.763989),('13073','NY','Groton','Tompkins',42.58367,-76.387923),('13074','NY','Hannibal','Oswego',43.305378,-76.558773),('13076','NY','Hastings','Oswego',43.352822,-76.144404),('13077','NY','Homer','Cortland',42.678348,-76.188042),('13078','NY','Jamesville','Onondaga',42.97993,-76.074165),('13080','NY','Jordan','Onondaga',43.080299,-76.479183),('13081','NY','King Ferry','Cayuga',42.660983,-76.62683),('13082','NY','Kirkville','Madison',43.102732,-75.959887),('13083','NY','Lacona','Oswego',43.646359,-76.017146),('13084','NY','La Fayette','Onondaga',42.894277,-76.108308),('13087','NY','Little York','Cortland',42.707481,-76.157208),('13088','NY','Liverpool','Onondaga',43.107862,-76.190473),('13089','NY','Liverpool','Onondaga',43.1385,-76.2263),('13090','NY','Liverpool','Onondaga',43.150854,-76.222208),('13092','NY','Locke','Cayuga',42.649602,-76.424087),('13093','NY','Lycoming','Oswego',43.4986,-76.3861),('13101','NY','Mc Graw','Cortland',42.598103,-76.082391),('13102','NY','Mc Lean','Tompkins',42.550304,-76.292002),('13103','NY','Mallory','Oswego',43.32576,-76.109544),('13104','NY','Manlius','Onondaga',42.987071,-75.967571),('13107','NY','Maple View','Oswego',43.4572,-76.1455),('13108','NY','Marcellus','Onondaga',42.978994,-76.336158),('13110','NY','Marietta','Onondaga',42.891636,-76.283471),('13111','NY','Martville','Cayuga',43.269075,-76.617022),('13112','NY','Memphis','Onondaga',43.106266,-76.417239),('13113','NY','Meridian','Cayuga',43.160903,-76.540308),('13114','NY','Mexico','Oswego',43.46807,-76.240983),('13115','NY','Minetto','Oswego',43.398465,-76.475712),('13116','NY','Minoa','Onondaga',43.076841,-76.006932),('13117','NY','Montezuma','Cayuga',43.008072,-76.707678),('13118','NY','Moravia','Cayuga',42.749724,-76.409954),('13119','NY','Mottville','Onondaga',42.9736,-76.4427),('13120','NY','Nedrow','Onondaga',42.955772,-76.163523),('13121','NY','New Haven','Oswego',43.4797,-76.3155),('13122','NY','New Woodstock','Madison',42.83784,-75.861518),('13123','NY','North Bay','Oneida',43.232038,-75.77042),('13124','NY','North Pitcher','Chenango',42.63621,-75.817393),('13126','NY','Oswego','Oswego',43.440684,-76.484575),('13131','NY','Parish','Oswego',43.412717,-76.112095),('13132','NY','Pennellville','Oswego',43.267942,-76.231997),('13134','NY','Peterboro','Madison',42.967151,-75.684378),('13135','NY','Phoenix','Oswego',43.244353,-76.315682),('13136','NY','Pitcher','Chenango',42.614098,-75.844788),('13137','NY','Plainville','Onondaga',43.1591,-76.4475),('13138','NY','Pompey','Onondaga',42.898704,-76.014192),('13139','NY','Poplar Ridge','Cayuga',42.7383,-76.6183),('13140','NY','Port Byron','Cayuga',43.04732,-76.648161),('13141','NY','Preble','Cortland',42.768053,-76.184654),('13142','NY','Pulaski','Oswego',43.556231,-76.138366),('13143','NY','Red Creek','Wayne',43.235788,-76.714793),('13144','NY','Richland','Oswego',43.568755,-75.977019),('13145','NY','Sandy Creek','Oswego',43.646739,-76.116286),('13146','NY','Savannah','Wayne',43.100851,-76.756863),('13147','NY','Scipio Center','Cayuga',42.775581,-76.569762),('13148','NY','Seneca Falls','Seneca',42.924761,-76.782933),('13152','NY','Skaneateles','Onondaga',42.898123,-76.39061),('13153','NY','Skaneateles Falls','Onondaga',42.994624,-76.458299),('13154','NY','South Butler','Wayne',43.2303,-76.8143),('13155','NY','South Otselic','Chenango',42.65164,-75.777188),('13156','NY','Sterling','Cayuga',43.338174,-76.67403),('13157','NY','Sylvan Beach','Oneida',43.203422,-75.726111),('13158','NY','Truxton','Cortland',42.719951,-75.966886),('13159','NY','Tully','Onondaga',42.798122,-76.122525),('13160','NY','Union Springs','Cayuga',42.831238,-76.661185),('13162','NY','Verona Beach','Oneida',43.189242,-75.727969),('13163','NY','Wampsville','Madison',43.080122,-75.710933),('13164','NY','Warners','Onondaga',43.092372,-76.312887),('13165','NY','Waterloo','Seneca',42.910947,-76.870313),('13166','NY','Weedsport','Cayuga',43.050725,-76.552248),('13167','NY','West Monroe','Oswego',43.326755,-76.060339),('13201','NY','Syracuse','Onondaga',43.0459,-76.1528),('13202','NY','Syracuse','Onondaga',43.046496,-76.150178),('13203','NY','Syracuse','Onondaga',43.060864,-76.137174),('13204','NY','Syracuse','Onondaga',43.049858,-76.175549),('13205','NY','Syracuse','Onondaga',43.009939,-76.143987),('13206','NY','Syracuse','Onondaga',43.069731,-76.108017),('13207','NY','Syracuse','Onondaga',43.02016,-76.164032),('13208','NY','Syracuse','Onondaga',43.075048,-76.150988),('13209','NY','Syracuse','Onondaga',43.081015,-76.236229),('13210','NY','Syracuse','Onondaga',43.035219,-76.127442),('13211','NY','Syracuse','Onondaga',43.099866,-76.139674),('13212','NY','Syracuse','Onondaga',43.125815,-76.134614),('13214','NY','Syracuse','Onondaga',43.038709,-76.075591),('13215','NY','Syracuse','Onondaga',42.996992,-76.218566),('13217','NY','Syracuse','Onondaga',43.0512,-76.122),('13218','NY','Syracuse','Onondaga',43.0301,-76.1259),('13219','NY','Syracuse','Onondaga',43.041266,-76.224195),('13220','NY','Syracuse','Onondaga',43.1232,-76.1278),('13221','NY','Syracuse','Onondaga',43.1232,-76.1278),('13224','NY','Syracuse','Onondaga',43.041425,-76.102761),('13225','NY','Syracuse','Onondaga',43.1232,-76.1278),('13235','NY','Syracuse','Onondaga',43.0321,-76.1271),('13244','NY','Syracuse','Onondaga',43.0394,-76.1361),('13250','NY','Syracuse','Onondaga',43.0435,-76.151),('13251','NY','Syracuse','Onondaga',43.0435,-76.151),('13252','NY','Syracuse','Onondaga',43.0435,-76.151),('13261','NY','Syracuse','Onondaga',43.0433,-76.1508),('13290','NY','Syracuse','Onondaga',43.075066,-76.174117),('13301','NY','Alder Creek','Oneida',43.41871,-75.21964),('13302','NY','Altmar','Oswego',43.500637,-75.977775),('13303','NY','Ava','Oneida',43.367415,-75.468212),('13304','NY','Barneveld','Oneida',43.247196,-75.16986),('13305','NY','Beaver Falls','Lewis',43.885628,-75.433898),('13308','NY','Blossvale','Oneida',43.242909,-75.663545),('13309','NY','Boonville','Oneida',43.485401,-75.339952),('13310','NY','Bouckville','Madison',42.88962,-75.571545),('13312','NY','Brantingham','Lewis',43.695389,-75.265741),('13313','NY','Bridgewater','Oneida',42.878829,-75.256026),('13314','NY','Brookfield','Madison',42.810729,-75.320162),('13315','NY','Burlington Flats','Otsego',42.744144,-75.143611),('13316','NY','Camden','Oneida',43.379803,-75.743131),('13317','NY','Canajoharie','Montgomery',42.870642,-74.58114),('13318','NY','Cassville','Oneida',42.930229,-75.247937),('13319','NY','Chadwicks','Oneida',43.027861,-75.269894),('13320','NY','Cherry Valley','Otsego',42.777805,-74.740798),('13321','NY','Clark Mills','Oneida',43.09207,-75.372179),('13322','NY','Clayville','Oneida',42.962314,-75.225191),('13323','NY','Clinton','Oneida',43.049037,-75.378378),('13324','NY','Cold Brook','Herkimer',43.317442,-74.974135),('13325','NY','Constableville','Lewis',43.568427,-75.50211),('13326','NY','Cooperstown','Otsego',42.722511,-74.895371),('13327','NY','Croghan','Lewis',43.945508,-75.304677),('13328','NY','Deansboro','Oneida',42.980285,-75.427424),('13329','NY','Dolgeville','Herkimer',43.113313,-74.728047),('13331','NY','Eagle Bay','Herkimer',43.821079,-74.881138),('13332','NY','Earlville','Madison',42.752806,-75.550792),('13333','NY','East Springfield','Otsego',42.836995,-74.818644),('13334','NY','Eaton','Madison',42.836486,-75.660796),('13335','NY','Edmeston','Otsego',42.696792,-75.242535),('13337','NY','Fly Creek','Otsego',42.743197,-74.981487),('13338','NY','Forestport','Oneida',43.486577,-75.074759),('13339','NY','Fort Plain','Montgomery',42.94066,-74.653762),('13340','NY','Frankfort','Herkimer',43.047144,-75.09745),('13341','NY','Franklin Springs','Oneida',43.034323,-75.396029),('13342','NY','Garrattsville','Otsego',42.644136,-75.191592),('13343','NY','Glenfield','Lewis',43.742054,-75.350675),('13345','NY','Greig','Lewis',43.683421,-75.345905),('13346','NY','Hamilton','Madison',42.823722,-75.543714),('13348','NY','Hartwick','Otsego',42.703112,-75.067279),('13350','NY','Herkimer','Herkimer',43.036801,-74.986581),('13352','NY','Hinckley','Oneida',43.313337,-75.116208),('13353','NY','Hoffmeister','Hamilton',43.433336,-74.724669),('13354','NY','Holland Patent','Oneida',43.261565,-75.255215),('13355','NY','Hubbardsville','Madison',42.815355,-75.440036),('13357','NY','Ilion','Herkimer',42.994905,-75.061144),('13360','NY','Inlet','Hamilton',43.742686,-74.764241),('13361','NY','Jordanville','Herkimer',42.904352,-74.86756),('13362','NY','Knoxboro','Oneida',42.982178,-75.522003),('13363','NY','Lee Center','Oneida',43.313616,-75.506008),('13364','NY','Leonardsville','Madison',42.808968,-75.253646),('13365','NY','Little Falls','Herkimer',43.06051,-74.848959),('13367','NY','Lowville','Lewis',43.814552,-75.424848),('13368','NY','Lyons Falls','Lewis',43.639992,-75.334534),('13401','NY','Mc Connellsville','Oneida',43.2675,-75.6084),('13402','NY','Madison','Madison',42.892391,-75.500514),('13403','NY','Marcy','Oneida',43.155094,-75.275303),('13404','NY','Martinsburg','Lewis',43.735501,-75.470416),('13406','NY','Middleville','Herkimer',43.137809,-74.952019),('13407','NY','Mohawk','Herkimer',42.991208,-74.948422),('13408','NY','Morrisville','Madison',42.910026,-75.663575),('13409','NY','Munnsville','Madison',42.97406,-75.592989),('13410','NY','Nelliston','Montgomery',42.933475,-74.613558),('13411','NY','New Berlin','Chenango',42.625568,-75.317813),('13413','NY','New Hartford','Oneida',43.070126,-75.291023),('13415','NY','New Lisbon','Otsego',42.588423,-75.200177),('13416','NY','Newport','Herkimer',43.178761,-74.986721),('13417','NY','New York Mills','Oneida',43.100537,-75.295265),('13418','NY','North Brookfield','Madison',42.847748,-75.389226),('13420','NY','Old Forge','Herkimer',43.707698,-74.945978),('13421','NY','Oneida','Madison',43.080586,-75.648456),('13424','NY','Oriskany','Oneida',43.148635,-75.345292),('13425','NY','Oriskany Falls','Oneida',42.95923,-75.480076),('13426','NY','Orwell','Oswego',43.5747,-75.9966),('13428','NY','Palatine Bridge','Montgomery',42.922301,-74.555184),('13431','NY','Poland','Herkimer',43.215652,-75.085439),('13433','NY','Port Leyden','Lewis',43.580437,-75.317769),('13435','NY','Prospect','Oneida',43.304766,-75.149847),('13436','NY','Raquette Lake','Hamilton',43.806194,-74.649453),('13437','NY','Redfield','Oswego',43.580293,-75.803822),('13438','NY','Remsen','Oneida',43.340431,-75.171858),('13439','NY','Richfield Springs','Otsego',42.854623,-74.993806),('13440','NY','Rome','Oneida',43.216061,-75.455261),('13441','NY','Rome','Oneida',43.220765,-75.409263),('13442','NY','Rome','Oneida',43.2196,-75.45),('13449','NY','Rome','Oneida',43.2196,-75.45),('13450','NY','Roseboom','Otsego',42.694978,-74.814019),('13452','NY','Saint Johnsville','Montgomery',43.021603,-74.643283),('13454','NY','Salisbury Center','Herkimer',43.161748,-74.756286),('13455','NY','Sangerfield','Oneida',42.9138,-75.3794),('13456','NY','Sauquoit','Oneida',43.005622,-75.261856),('13457','NY','Schuyler Lake','Otsego',42.7802,-75.0283),('13459','NY','Sharon Springs','Schoharie',42.779151,-74.584521),('13460','NY','Sherburne','Chenango',42.688486,-75.462041),('13461','NY','Sherrill','Oneida',43.071249,-75.598769),('13464','NY','Smyrna','Chenango',42.687973,-75.615788),('13465','NY','Solsville','Madison',42.9105,-75.518),('13468','NY','Springfield Center','Otsego',42.838909,-74.868707),('13469','NY','Stittville','Oneida',43.214161,-75.29706),('13470','NY','Stratford','Fulton',43.181227,-74.667165),('13471','NY','Taberg','Oneida',43.36375,-75.598824),('13472','NY','Thendara','Herkimer',43.692992,-75.017895),('13473','NY','Turin','Lewis',43.646445,-75.443432),('13475','NY','Van Hornesville','Herkimer',42.894885,-74.827757),('13476','NY','Vernon','Oneida',43.075707,-75.523303),('13477','NY','Vernon Center','Oneida',43.03502,-75.503932),('13478','NY','Verona','Oneida',43.144013,-75.581897),('13479','NY','Washington Mills','Oneida',43.05,-75.2733),('13480','NY','Waterville','Oneida',42.926344,-75.36982),('13482','NY','West Burlington','Otsego',42.6914,-75.183),('13483','NY','Westdale','Oneida',43.399201,-75.82548),('13484','NY','West Eaton','Madison',42.856977,-75.6568),('13485','NY','West Edmeston','Madison',42.777822,-75.308467),('13486','NY','Westernville','Oneida',43.336105,-75.361408),('13488','NY','Westford','Otsego',42.688085,-74.756293),('13489','NY','West Leyden','Lewis',43.471435,-75.53247),('13490','NY','Westmoreland','Oneida',43.11196,-75.414782),('13491','NY','West Winfield','Herkimer',42.872679,-75.170084),('13492','NY','Whitesboro','Oneida',43.118727,-75.315811),('13493','NY','Williamstown','Oswego',43.423574,-75.905023),('13494','NY','Woodgate','Oneida',43.534679,-75.149775),('13495','NY','Yorkville','Oneida',43.111957,-75.278081),('13501','NY','Utica','Oneida',43.087723,-75.226707),('13502','NY','Utica','Oneida',43.114929,-75.221759),('13503','NY','Utica','Oneida',43.1015,-75.2319),('13504','NY','Utica','Oneida',43.1008,-75.233),('13505','NY','Utica','Oneida',43.1008,-75.233),('13599','NY','Utica','Oneida',43.1008,-75.233),('13601','NY','Watertown','Jefferson',43.976722,-75.9081),('13602','NY','Fort Drum','Jefferson',44.042332,-75.75088),('13603','NY','Watertown','Jefferson',44.03322,-75.800986),('13605','NY','Adams','Jefferson',43.811703,-76.04912),('13606','NY','Adams Center','Jefferson',43.879963,-76.004132),('13607','NY','Alexandria Bay','Jefferson',44.324864,-75.932995),('13608','NY','Antwerp','Jefferson',44.238362,-75.605886),('13611','NY','Belleville','Jefferson',43.7908,-76.1203),('13612','NY','Black River','Jefferson',44.000683,-75.782913),('13613','NY','Brasher Falls','St. Lawrence',44.843066,-74.749089),('13614','NY','Brier Hill','St. Lawrence',44.539055,-75.705715),('13615','NY','Brownville','Jefferson',44.007518,-75.982068),('13616','NY','Calcium','Jefferson',44.022161,-75.848626),('13617','NY','Canton','St. Lawrence',44.587818,-75.156738),('13618','NY','Cape Vincent','Jefferson',44.117496,-76.282508),('13619','NY','Carthage','Jefferson',43.986763,-75.621295),('13620','NY','Castorland','Lewis',43.894433,-75.464266),('13621','NY','Chase Mills','St. Lawrence',44.850786,-75.067885),('13622','NY','Chaumont','Jefferson',44.092841,-76.119977),('13623','NY','Chippewa Bay','St. Lawrence',44.444704,-75.756337),('13624','NY','Clayton','Jefferson',44.227497,-76.095456),('13625','NY','Colton','St. Lawrence',44.535634,-74.932564),('13626','NY','Copenhagen','Lewis',43.848046,-75.713974),('13627','NY','Deer River','Lewis',43.9297,-75.5894),('13628','NY','Deferiet','Jefferson',44.034423,-75.682762),('13630','NY','De Kalb Junction','St. Lawrence',44.490185,-75.308672),('13631','NY','Denmark','Lewis',43.8981,-75.6032),('13632','NY','Depauville','Jefferson',44.1383,-76.0658),('13633','NY','De Peyster','St. Lawrence',44.498882,-75.48531),('13634','NY','Dexter','Jefferson',44.013694,-76.05959),('13635','NY','Edwards','St. Lawrence',44.309789,-75.248438),('13636','NY','Ellisburg','Jefferson',43.742213,-76.12235),('13637','NY','Evans Mills','Jefferson',44.087067,-75.816237),('13638','NY','Felts Mills','Jefferson',44.022404,-75.75882),('13639','NY','Fine','St. Lawrence',44.244681,-75.143916),('13640','NY','Wellesley Island','Jefferson',44.330206,-75.978978),('13641','NY','Fishers Landing','Jefferson',44.274305,-76.008051),('13642','NY','Gouverneur','St. Lawrence',44.315623,-75.457526),('13643','NY','Great Bend','Jefferson',44.032846,-75.717751),('13645','NY','Hailesboro','Saint Lawrence',44.31,-75.4466),('13646','NY','Hammond','St. Lawrence',44.449892,-75.687754),('13647','NY','Hannawa Falls','St. Lawrence',44.605875,-74.98058),('13648','NY','Harrisville','Lewis',44.155516,-75.318453),('13649','NY','Helena','Saint Lawrence',44.9206,-74.7249),('13650','NY','Henderson','Jefferson',43.821038,-76.201415),('13651','NY','Henderson Harbor','Jefferson',43.877013,-76.17947),('13652','NY','Hermon','St. Lawrence',44.440818,-75.217239),('13654','NY','Heuvelton','St. Lawrence',44.577112,-75.436848),('13655','NY','Hogansburg','Franklin',44.979488,-74.683844),('13656','NY','La Fargeville','Jefferson',44.205304,-75.943945),('13657','NY','Limerick','Jefferson',44.0291,-76.0433),('13658','NY','Lisbon','St. Lawrence',44.746542,-75.275257),('13659','NY','Lorraine','Jefferson',43.748439,-75.889635),('13660','NY','Madrid','St. Lawrence',44.753619,-75.141564),('13661','NY','Mannsville','Jefferson',43.712742,-76.100998),('13662','NY','Massena','St. Lawrence',44.941942,-74.865161),('13664','NY','Morristown','St. Lawrence',44.586276,-75.647534),('13665','NY','Natural Bridge','Jefferson',44.062863,-75.464343),('13666','NY','Newton Falls','St. Lawrence',44.21369,-74.949761),('13667','NY','Norfolk','St. Lawrence',44.820615,-74.970162),('13668','NY','Norwood','St. Lawrence',44.74989,-74.993151),('13669','NY','Ogdensburg','St. Lawrence',44.683242,-75.492773),('13670','NY','Oswegatchie','St. Lawrence',44.208206,-75.089293),('13671','NY','Oxbow','Jefferson',44.2724,-75.5769),('13672','NY','Parishville','St. Lawrence',44.525839,-74.716434),('13673','NY','Philadelphia','Jefferson',44.158141,-75.705173),('13674','NY','Pierrepont Manor','Jefferson',43.736823,-76.058358),('13675','NY','Plessis','Jefferson',44.271056,-75.852388),('13676','NY','Potsdam','St. Lawrence',44.651383,-74.95245),('13677','NY','Pyrites','St. Lawrence',44.514892,-75.181604),('13678','NY','Raymondville','St. Lawrence',44.828821,-74.975962),('13679','NY','Redwood','Jefferson',44.329432,-75.786073),('13680','NY','Rensselaer Falls','St. Lawrence',44.587376,-75.326326),('13681','NY','Richville','St. Lawrence',44.414434,-75.379211),('13682','NY','Rodman','Jefferson',43.836827,-75.8996),('13683','NY','Rooseveltown','Saint Lawrence',44.9727,-74.7313),('13684','NY','Russell','St. Lawrence',44.377254,-75.065858),('13685','NY','Sackets Harbor','Jefferson',43.940592,-76.138177),('13687','NY','South Colton','St. Lawrence',44.457353,-74.822952),('13690','NY','Star Lake','St. Lawrence',44.154282,-75.015878),('13691','NY','Theresa','Jefferson',44.216481,-75.794829),('13692','NY','Thousand Island Park','Jefferson',44.287229,-76.026086),('13693','NY','Three Mile Bay','Jefferson',44.023521,-76.239492),('13694','NY','Waddington','St. Lawrence',44.864425,-75.181278),('13695','NY','Wanakena','St. Lawrence',44.144878,-74.917378),('13696','NY','West Stockholm','St. Lawrence',44.712162,-74.905894),('13697','NY','Winthrop','St. Lawrence',44.755539,-74.795106),('13699','NY','Potsdam','Saint Lawrence',44.6633,-74.9945),('13730','NY','Afton','Chenango',42.230407,-75.526536),('13731','NY','Andes','Delaware',42.141475,-74.7997),('13732','NY','Apalachin','Tioga',42.061671,-76.149276),('13733','NY','Bainbridge','Chenango',42.297252,-75.470359),('13734','NY','Barton','Tioga',42.069955,-76.409653),('13736','NY','Berkshire','Tioga',42.316398,-76.2007),('13737','NY','Bible School Park','Broome',42.1079,-75.9743),('13738','NY','Blodgett Mills','Cortland',42.5683,-76.1261),('13739','NY','Bloomville','Delaware',42.349084,-74.788989),('13740','NY','Bovina Center','Delaware',42.258428,-74.772784),('13743','NY','Candor','Tioga',42.208134,-76.346453),('13744','NY','Castle Creek','Broome',42.237781,-75.913247),('13745','NY','Chenango Bridge','Broome',42.2858,-75.9122),('13746','NY','Chenango Forks','Broome',42.252553,-75.83406),('13747','NY','Colliersville','Otsego',42.4908,-74.9825),('13748','NY','Conklin','Broome',42.043125,-75.805437),('13749','NY','Corbettsville','Broome',42.0155,-75.7908),('13750','NY','Davenport','Delaware',42.476586,-74.825765),('13751','NY','Davenport Center','Delaware',42.456486,-74.898892),('13752','NY','Delancey','Delaware',42.180339,-74.903437),('13753','NY','Delhi','Delaware',42.284045,-74.914097),('13754','NY','Deposit','Broome',42.072859,-75.442522),('13755','NY','Downsville','Delaware',42.069738,-74.994582),('13756','NY','East Branch','Delaware',42.004099,-75.10067),('13757','NY','East Meredith','Delaware',42.410607,-74.891229),('13758','NY','East Pharsalia','Chenango',42.558,-75.7175),('13760','NY','Endicott','Broome',42.113666,-76.053787),('13761','NY','Endicott','Broome',42.1007,-76.0485),('13762','NY','Endwell','Broome',42.109,-76.0246),('13763','NY','Endicott','Broome',42.0952,-76.0653),('13774','NY','Fishs Eddy','Delaware',41.967713,-75.172694),('13775','NY','Franklin','Delaware',42.329027,-75.154601),('13776','NY','Gilbertsville','Otsego',42.470275,-75.328293),('13777','NY','Glen Aubrey','Broome',42.245702,-76.00709),('13778','NY','Greene','Chenango',42.336926,-75.758689),('13780','NY','Guilford','Chenango',42.422486,-75.476583),('13782','NY','Hamden','Delaware',42.169631,-74.991294),('13783','NY','Hancock','Delaware',41.97082,-75.277982),('13784','NY','Harford','Cortland',42.428011,-76.222158),('13786','NY','Harpersfield','Delaware',42.445155,-74.703016),('13787','NY','Harpursville','Broome',42.204125,-75.656434),('13788','NY','Hobart','Delaware',42.362353,-74.6637),('13790','NY','Johnson City','Broome',42.124349,-75.968536),('13794','NY','Killawog','Broome',42.401768,-76.019948),('13795','NY','Kirkwood','Broome',42.057829,-75.79901),('13796','NY','Laurens','Otsego',42.537206,-75.141651),('13797','NY','Lisle','Broome',42.333665,-76.040401),('13801','NY','Mc Donough','Chenango',42.505085,-75.77697),('13802','NY','Maine','Broome',42.239454,-76.049879),('13803','NY','Marathon','Cortland',42.453588,-76.070007),('13804','NY','Masonville','Delaware',42.195953,-75.356891),('13806','NY','Meridale','Delaware',42.368473,-74.966538),('13807','NY','Milford','Otsego',42.605671,-74.972671),('13808','NY','Morris','Otsego',42.530472,-75.254515),('13809','NY','Mount Upton','Chenango',42.39449,-75.397639),('13810','NY','Mount Vision','Otsego',42.606818,-75.108363),('13811','NY','Newark Valley','Tioga',42.226946,-76.166864),('13812','NY','Nichols','Tioga',42.02823,-76.373655),('13813','NY','Nineveh','Broome',42.163706,-75.551338),('13814','NY','North Norwich','Chenango',42.6169,-75.5272),('13815','NY','Norwich','Chenango',42.544136,-75.524207),('13820','NY','Oneonta','Otsego',42.460882,-75.050479),('13825','NY','Otego','Otsego',42.439496,-75.197888),('13826','NY','Ouaquaga','Broome',42.109,-75.6378),('13827','NY','Owego','Tioga',42.119872,-76.258779),('13830','NY','Oxford','Chenango',42.439023,-75.618434),('13832','NY','Plymouth','Chenango',42.654592,-75.662548),('13833','NY','Port Crane','Broome',42.183149,-75.775963),('13834','NY','Portlandville','Otsego',42.529252,-74.96816),('13835','NY','Richford','Tioga',42.397838,-76.171987),('13837','NY','Shinhopple','Delaware',42.0386,-75.068),('13838','NY','Sidney','Delaware',42.301013,-75.392067),('13839','NY','Sidney Center','Delaware',42.262039,-75.252051),('13840','NY','Smithboro','Tioga',42.1005,-76.3672),('13841','NY','Smithville Flats','Chenango',42.419708,-75.837294),('13842','NY','South Kortright','Delaware',42.358684,-74.719121),('13843','NY','South New Berlin','Chenango',42.523908,-75.382759),('13844','NY','South Plymouth','Chenango',42.608179,-75.668317),('13845','NY','Tioga Center','Tioga',42.053985,-76.350246),('13846','NY','Treadwell','Delaware',42.363723,-75.054746),('13847','NY','Trout Creek','Delaware',42.180595,-75.292138),('13848','NY','Tunnel','Broome',42.2161,-75.7269),('13849','NY','Unadilla','Otsego',42.334429,-75.313702),('13850','NY','Vestal','Broome',42.082274,-76.016585),('13851','NY','Vestal','Broome',42.0952,-76.0042),('13856','NY','Walton','Delaware',42.181947,-75.16173),('13859','NY','Wells Bridge','Otsego',42.369872,-75.249051),('13860','NY','West Davenport','Delaware',42.446358,-74.954306),('13861','NY','West Oneonta','Otsego',42.501932,-75.128164),('13862','NY','Whitney Point','Broome',42.328029,-75.951508),('13863','NY','Willet','Cortland',42.455212,-75.915668),('13864','NY','Willseyville','Tioga',42.298096,-76.388539),('13865','NY','Windsor','Broome',42.070368,-75.635967),('13901','NY','Binghamton','Broome',42.143926,-75.888957),('13902','NY','Binghamton','Broome',42.091542,-75.970546),('13903','NY','Binghamton','Broome',42.07978,-75.902604),('13904','NY','Binghamton','Broome',42.115327,-75.850445),('13905','NY','Binghamton','Broome',42.120801,-75.932475),('14001','NY','Akron','Erie',43.027194,-78.510268),('14004','NY','Alden','Erie',42.898819,-78.51648),('14005','NY','Alexander','Genesee',42.905879,-78.252529),('14006','NY','Angola','Erie',42.634524,-79.045184),('14008','NY','Appleton','Niagara',43.320935,-78.633537),('14009','NY','Arcade','Wyoming',42.580647,-78.404082),('14010','NY','Athol Springs','Erie',42.7697,-78.8666),('14011','NY','Attica','Wyoming',42.844426,-78.278155),('14012','NY','Barker','Niagara',43.338104,-78.528764),('14013','NY','Basom','Genesee',43.074525,-78.403661),('14020','NY','Batavia','Genesee',42.996933,-78.195439),('14021','NY','Batavia','Genesee',42.9986,-78.1885),('14024','NY','Bliss','Wyoming',42.579503,-78.252544),('14025','NY','Boston','Erie',42.62882,-78.737237),('14026','NY','Bowmansville','Erie',42.940931,-78.686016),('14027','NY','Brant','Erie',42.5883,-79.018),('14028','NY','Burt','Niagara',43.322171,-78.71792),('14029','NY','Centerville','Allegany',42.4797,-78.25),('14030','NY','Chaffee','Erie',42.559698,-78.490075),('14031','NY','Clarence','Erie',42.981637,-78.61494),('14032','NY','Clarence Center','Erie',43.020204,-78.635425),('14033','NY','Colden','Erie',42.65479,-78.684583),('14034','NY','Collins','Erie',42.504518,-78.892993),('14035','NY','Collins Center','Erie',42.492289,-78.852957),('14036','NY','Corfu','Genesee',42.973849,-78.389529),('14037','NY','Cowlesville','Wyoming',42.817993,-78.46123),('14038','NY','Crittenden','Erie',43.022,-78.5167),('14039','NY','Dale','Wyoming',42.836294,-78.176883),('14040','NY','Darien Center','Genesee',42.890873,-78.376631),('14041','NY','Dayton','Cattaraugus',42.417068,-78.976109),('14042','NY','Delevan','Cattaraugus',42.473254,-78.479781),('14043','NY','Depew','Erie',42.904861,-78.701788),('14047','NY','Derby','Erie',42.694685,-78.9829),('14048','NY','Dunkirk','Chautauqua',42.479416,-79.328149),('14051','NY','East Amherst','Erie',43.030339,-78.70082),('14052','NY','East Aurora','Erie',42.770287,-78.599643),('14054','NY','East Bethany','Genesee',42.908974,-78.127841),('14055','NY','East Concord','Erie',42.55689,-78.618227),('14056','NY','East Pembroke','Genesee',42.9955,-78.3102),('14057','NY','Eden','Erie',42.650975,-78.877904),('14058','NY','Elba','Genesee',43.096408,-78.151175),('14059','NY','Elma','Erie',42.836549,-78.635672),('14060','NY','Farmersville Station','Cattaraugus',42.438698,-78.329213),('14061','NY','Farnham','Erie',42.591295,-79.085857),('14062','NY','Forestville','Chautauqua',42.450893,-79.152595),('14063','NY','Fredonia','Chautauqua',42.427398,-79.344993),('14065','NY','Freedom','Cattaraugus',42.485768,-78.29851),('14066','NY','Gainesville','Wyoming',42.635967,-78.180481),('14067','NY','Gasport','Niagara',43.203945,-78.569383),('14068','NY','Getzville','Erie',43.022894,-78.75847),('14069','NY','Glenwood','Erie',42.599875,-78.642039),('14070','NY','Gowanda','Erie',42.455638,-78.934279),('14072','NY','Grand Island','Erie',43.014952,-78.959694),('14075','NY','Hamburg','Erie',42.734058,-78.839173),('14080','NY','Holland','Erie',42.643477,-78.531523),('14081','NY','Irving','Erie',42.564016,-79.092819),('14082','NY','Java Center','Wyoming',42.661245,-78.377451),('14083','NY','Java Village','Wyoming',42.676913,-78.440751),('14085','NY','Lake View','Erie',42.718441,-78.930179),('14086','NY','Lancaster','Erie',42.901589,-78.654367),('14091','NY','Lawtons','Erie',42.532811,-78.891909),('14092','NY','Lewiston','Niagara',43.171716,-79.023016),('14094','NY','Lockport','Niagara',43.160995,-78.689951),('14095','NY','Lockport','Niagara',43.1707,-78.6885),('14098','NY','Lyndonville','Orleans',43.339434,-78.392287),('14101','NY','Machias','Cattaraugus',42.392657,-78.526872),('14102','NY','Marilla','Erie',42.838249,-78.553024),('14103','NY','Medina','Orleans',43.217778,-78.387749),('14105','NY','Middleport','Niagara',43.206956,-78.483102),('14107','NY','Model City','Niagara',43.185,-78.9838),('14108','NY','Newfane','Niagara',43.277416,-78.710489),('14109','NY','Niagara University','Niagara',43.137707,-79.037274),('14110','NY','North Boston','Erie',42.6855,-78.7769),('14111','NY','North Collins','Erie',42.587979,-78.923063),('14112','NY','North Evans','Erie',42.696543,-78.940816),('14113','NY','North Java','Wyoming',42.678592,-78.344709),('14120','NY','North Tonawanda','Niagara',43.049765,-78.860451),('14125','NY','Oakfield','Genesee',43.084919,-78.274609),('14126','NY','Olcott','Niagara',43.337281,-78.718512),('14127','NY','Orchard Park','Erie',42.75994,-78.75329),('14129','NY','Perrysburg','Cattaraugus',42.469281,-79.01247),('14130','NY','Pike','Wyoming',42.55569,-78.155237),('14131','NY','Ransomville','Niagara',43.237719,-78.908792),('14132','NY','Sanborn','Niagara',43.142107,-78.877609),('14133','NY','Sandusky','Cattaraugus',42.4958,-78.3847),('14134','NY','Sardinia','Erie',42.532536,-78.521702),('14135','NY','Sheridan','Chautauqua',42.490489,-79.242585),('14136','NY','Silver Creek','Chautauqua',42.533768,-79.16331),('14138','NY','South Dayton','Cattaraugus',42.371867,-79.055614),('14139','NY','South Wales','Erie',42.720092,-78.55295),('14140','NY','Spring Brook','Erie',42.818,-78.6758),('14141','NY','Springville','Erie',42.516377,-78.694218),('14143','NY','Stafford','Genesee',42.977138,-78.075723),('14144','NY','Stella Niagara','Niagara',43.2019,-79.0425),('14145','NY','Strykersville','Wyoming',42.720825,-78.434295),('14150','NY','Tonawanda','Erie',43.00039,-78.864386),('14151','NY','Tonawanda','Erie',43.0168,-78.8792),('14166','NY','Van Buren Point','Chautauqua',42.4488,-79.4186),('14167','NY','Varysburg','Wyoming',42.737917,-78.308446),('14168','NY','Versailles','Cattaraugus',42.520385,-78.990541),('14169','NY','Wales Center','Erie',42.764629,-78.522752),('14170','NY','West Falls','Erie',42.701344,-78.673592),('14171','NY','West Valley','Cattaraugus',42.424674,-78.649832),('14172','NY','Wilson','Niagara',43.306399,-78.832618),('14173','NY','Yorkshire','Cattaraugus',42.525566,-78.472141),('14174','NY','Youngstown','Niagara',43.246928,-79.015975),('14201','NY','Buffalo','Erie',42.89657,-78.885427),('14202','NY','Buffalo','Erie',42.886599,-78.879289),('14203','NY','Buffalo','Erie',42.881085,-78.869992),('14204','NY','Buffalo','Erie',42.884105,-78.861672),('14205','NY','Buffalo','Erie',42.8925,-78.8707),('14206','NY','Buffalo','Erie',42.880078,-78.810472),('14207','NY','Buffalo','Erie',42.947116,-78.897232),('14208','NY','Buffalo','Erie',42.915101,-78.850144),('14209','NY','Buffalo','Erie',42.913325,-78.866337),('14210','NY','Buffalo','Erie',42.866689,-78.829234),('14211','NY','Buffalo','Erie',42.907319,-78.823718),('14212','NY','Buffalo','Erie',42.8946,-78.825332),('14213','NY','Buffalo','Erie',42.916309,-78.891815),('14214','NY','Buffalo','Erie',42.941352,-78.837821),('14215','NY','Buffalo','Erie',42.934123,-78.812042),('14216','NY','Buffalo','Erie',42.949613,-78.859721),('14217','NY','Buffalo','Erie',42.968849,-78.874763),('14218','NY','Buffalo','Erie',42.819654,-78.824654),('14219','NY','Buffalo','Erie',42.790871,-78.827434),('14220','NY','Buffalo','Erie',42.845692,-78.81858),('14221','NY','Buffalo','Erie',42.977515,-78.733536),('14222','NY','Buffalo','Erie',42.917799,-78.877385),('14223','NY','Buffalo','Erie',42.972187,-78.84484),('14224','NY','Buffalo','Erie',42.838517,-78.758151),('14225','NY','Buffalo','Erie',42.927905,-78.759298),('14226','NY','Buffalo','Erie',42.967915,-78.800797),('14227','NY','Buffalo','Erie',42.880409,-78.7447),('14228','NY','Buffalo','Erie',43.029791,-78.792772),('14231','NY','Buffalo','Erie',42.9783,-78.7356),('14233','NY','Buffalo','Erie',42.8849,-78.8265),('14240','NY','Buffalo','Erie',42.8849,-78.8265),('14241','NY','Buffalo','Erie',42.8849,-78.8265),('14260','NY','Buffalo','Erie',43.0003,-78.7902),('14261','NY','Buffalo','Erie',43.002963,-78.791646),('14263','NY','Buffalo','Erie',42.8849,-78.8265),('14264','NY','Buffalo','Erie',42.8849,-78.8265),('14265','NY','Buffalo','Erie',42.8849,-78.8265),('14267','NY','Buffalo','Erie',42.8849,-78.8265),('14269','NY','Buffalo','Erie',42.8849,-78.8265),('14270','NY','Buffalo','Erie',42.8849,-78.8265),('14272','NY','Buffalo','Erie',42.8849,-78.8265),('14273','NY','Buffalo','Erie',42.8849,-78.8265),('14276','NY','Buffalo','Erie',42.8849,-78.8265),('14280','NY','Buffalo','Erie',42.8849,-78.8265),('14301','NY','Niagara Falls','Niagara',43.095997,-79.039306),('14302','NY','Niagara Falls','Niagara',43.093896,-79.049193),('14303','NY','Niagara Falls','Niagara',43.086286,-79.040122),('14304','NY','Niagara Falls','Niagara',43.091368,-78.963746),('14305','NY','Niagara Falls','Niagara',43.115525,-79.037685),('14410','NY','Adams Basin','Monroe',43.1929,-77.8563),('14411','NY','Albion','Orleans',43.242425,-78.203092),('14413','NY','Alton','Wayne',43.2111,-76.9808),('14414','NY','Avon','Livingston',42.898209,-77.720635),('14415','NY','Bellona','Yates',42.754261,-77.01902),('14416','NY','Bergen','Genesee',43.070166,-77.987412),('14418','NY','Branchport','Yates',42.60496,-77.200956),('14420','NY','Brockport','Monroe',43.214773,-77.937167),('14422','NY','Byron','Genesee',43.076583,-78.066963),('14423','NY','Caledonia','Livingston',42.937674,-77.835232),('14424','NY','Canandaigua','Ontario',42.854999,-77.291749),('14425','NY','Farmington','Ontario',42.984893,-77.346232),('14427','NY','Castile','Wyoming',42.632077,-78.046644),('14428','NY','Churchville','Monroe',43.091741,-77.833582),('14429','NY','Clarendon','Orleans',43.1933,-78.065),('14430','NY','Clarkson','Monroe',43.233,-77.9277),('14432','NY','Clifton Springs','Ontario',42.961826,-77.144827),('14433','NY','Clyde','Wayne',43.075009,-76.873997),('14435','NY','Conesus','Livingston',42.714831,-77.674952),('14437','NY','Dansville','Livingston',42.578316,-77.730247),('14441','NY','Dresden','Yates',42.683928,-76.957046),('14443','NY','East Bloomfield','Ontario',42.895,-77.435),('14445','NY','East Rochester','Monroe',43.11221,-77.487176),('14449','NY','East Williamson','Wayne',43.2305,-77.1455),('14450','NY','Fairport','Monroe',43.091936,-77.434946),('14452','NY','Fancher','Orleans',43.2447,-78.0913),('14453','NY','Fishers','Ontario',43.0086,-77.465),('14454','NY','Geneseo','Livingston',42.797498,-77.779066),('14456','NY','Geneva','Ontario',42.856405,-76.988144),('14461','NY','Gorham','Ontario',42.7988,-77.1319),('14462','NY','Groveland','Livingston',42.675999,-77.747566),('14463','NY','Hall','Ontario',42.7938,-77.0666),('14464','NY','Hamlin','Monroe',43.327044,-77.932164),('14466','NY','Hemlock','Ontario',42.776949,-77.586798),('14467','NY','Henrietta','Monroe',43.047111,-77.609199),('14468','NY','Hilton','Monroe',43.292286,-77.792254),('14469','NY','Bloomfield','Ontario',42.873417,-77.46299),('14470','NY','Holley','Orleans',43.214884,-78.056344),('14471','NY','Honeoye','Ontario',42.761222,-77.504962),('14472','NY','Honeoye Falls','Monroe',42.96444,-77.59161),('14475','NY','Ionia','Ontario',42.936599,-77.498345),('14476','NY','Kendall','Orleans',43.32943,-78.036991),('14477','NY','Kent','Orleans',43.3444,-78.14273),('14478','NY','Keuka Park','Yates',42.599256,-77.116993),('14479','NY','Knowlesville','Orleans',43.240938,-78.311452),('14480','NY','Lakeville','Livingston',42.838441,-77.705781),('14481','NY','Leicester','Livingston',42.765403,-77.909911),('14482','NY','Le Roy','Genesee',42.98443,-77.967188),('14485','NY','Lima','Livingston',42.882635,-77.601026),('14486','NY','Linwood','Livingston',42.890464,-77.924311),('14487','NY','Livonia','Livingston',42.815902,-77.659425),('14488','NY','Livonia Center','Livingston',42.8213,-77.6388),('14489','NY','Lyons','Wayne',43.072406,-76.9911),('14502','NY','Macedon','Wayne',43.0884,-77.330711),('14504','NY','Manchester','Ontario',42.972731,-77.227087),('14505','NY','Marion','Wayne',43.15942,-77.168961),('14506','NY','Mendon','Monroe',42.998954,-77.502547),('14507','NY','Middlesex','Yates',42.701364,-77.268699),('14508','NY','Morton','Orleans',43.3236,-78.0008),('14510','NY','Mount Morris','Livingston',42.701383,-77.878326),('14511','NY','Mumford','Monroe',42.993151,-77.861655),('14512','NY','Naples','Ontario',42.628611,-77.394325),('14513','NY','Newark','Wayne',43.052251,-77.094302),('14514','NY','North Chili','Monroe',43.111686,-77.804592),('14515','NY','North Greece','Monroe',43.2536,-77.7327),('14516','NY','North Rose','Wayne',43.199399,-76.914145),('14517','NY','Nunda','Livingston',42.591627,-77.908088),('14518','NY','Oaks Corners','Ontario',42.9322,-77.0127),('14519','NY','Ontario','Wayne',43.233972,-77.314631),('14520','NY','Ontario Center','Wayne',43.2258,-77.3061),('14521','NY','Ovid','Seneca',42.683591,-76.821789),('14522','NY','Palmyra','Wayne',43.064995,-77.218157),('14525','NY','Pavilion','Genesee',42.877977,-78.000957),('14526','NY','Penfield','Monroe',43.145644,-77.458352),('14527','NY','Penn Yan','Yates',42.663583,-77.058809),('14529','NY','Perkinsville','Steuben',42.541683,-77.629655),('14530','NY','Perry','Wyoming',42.721938,-78.000879),('14532','NY','Phelps','Ontario',42.964306,-77.024778),('14533','NY','Piffard','Livingston',42.839871,-77.88222),('14534','NY','Pittsford','Monroe',43.069924,-77.512414),('14536','NY','Portageville','Wyoming',42.542818,-78.083998),('14537','NY','Port Gibson','Ontario',43.036481,-77.157554),('14538','NY','Pultneyville','Wayne',43.2797,-77.1863),('14539','NY','Retsof','Livingston',42.834254,-77.880137),('14541','NY','Romulus','Seneca',42.741077,-76.862942),('14542','NY','Rose','Wayne',43.156038,-76.864714),('14543','NY','Rush','Monroe',42.990648,-77.679529),('14544','NY','Rushville','Yates',42.757789,-77.238666),('14545','NY','Scottsburg','Livingston',42.664505,-77.709142),('14546','NY','Scottsville','Monroe',43.032824,-77.763836),('14547','NY','Seneca Castle','Ontario',42.8329,-77.0753),('14548','NY','Shortsville','Ontario',42.966405,-77.246879),('14549','NY','Silver Lake','Wyoming',42.700122,-78.017031),('14550','NY','Silver Springs','Wyoming',42.678425,-78.09466),('14551','NY','Sodus','Wayne',43.226736,-77.036895),('14555','NY','Sodus Point','Wayne',43.268335,-76.982947),('14556','NY','Sonyea','Livingston',42.6788,-77.8275),('14557','NY','South Byron','Genesee',43.0483,-78.0658),('14558','NY','South Lima','Livingston',42.8552,-77.6755),('14559','NY','Spencerport','Monroe',43.188857,-77.81405),('14560','NY','Springwater','Livingston',42.670486,-77.576274),('14561','NY','Stanley','Ontario',42.816427,-77.130001),('14563','NY','Union Hill','Wayne',43.2226,-77.3738),('14564','NY','Victor','Ontario',42.987822,-77.417662),('14568','NY','Walworth','Wayne',43.1345,-77.281069),('14569','NY','Warsaw','Wyoming',42.748741,-78.155176),('14571','NY','Waterport','Orleans',43.34755,-78.246087),('14572','NY','Wayland','Steuben',42.560867,-77.57841),('14580','NY','Webster','Monroe',43.220018,-77.455988),('14585','NY','West Bloomfield','Ontario',42.905333,-77.55269),('14586','NY','West Henrietta','Monroe',43.043388,-77.688507),('14588','NY','Willard','Seneca',42.680772,-76.869826),('14589','NY','Williamson','Wayne',43.248572,-77.184225),('14590','NY','Wolcott','Wayne',43.237002,-76.825432),('14591','NY','Wyoming','Wyoming',42.829196,-78.088772),('14592','NY','York','Livingston',42.870511,-77.883617),('14602','NY','Rochester','Monroe',43.1683,-77.6026),('14603','NY','Rochester','Monroe',43.1615,-77.6073),('14604','NY','Rochester','Monroe',43.157054,-77.603547),('14605','NY','Rochester','Monroe',43.167643,-77.600707),('14606','NY','Rochester','Monroe',43.169736,-77.682431),('14607','NY','Rochester','Monroe',43.149729,-77.589043),('14608','NY','Rochester','Monroe',43.154099,-77.62293),('14609','NY','Rochester','Monroe',43.175333,-77.561287),('14610','NY','Rochester','Monroe',43.142643,-77.545602),('14611','NY','Rochester','Monroe',43.148989,-77.643261),('14612','NY','Rochester','Monroe',43.261165,-77.666231),('14613','NY','Rochester','Monroe',43.182133,-77.63793),('14614','NY','Rochester','Monroe',43.156088,-77.614183),('14615','NY','Rochester','Monroe',43.203961,-77.65495),('14616','NY','Rochester','Monroe',43.230455,-77.650427),('14617','NY','Rochester','Monroe',43.22318,-77.597176),('14618','NY','Rochester','Monroe',43.116014,-77.556315),('14619','NY','Rochester','Monroe',43.136473,-77.646669),('14620','NY','Rochester','Monroe',43.133461,-77.602744),('14621','NY','Rochester','Monroe',43.185297,-77.603407),('14622','NY','Rochester','Monroe',43.213034,-77.554067),('14623','NY','Rochester','Monroe',43.088365,-77.638264),('14624','NY','Rochester','Monroe',43.127788,-77.722132),('14625','NY','Rochester','Monroe',43.140645,-77.510184),('14626','NY','Rochester','Monroe',43.214104,-77.706453),('14627','NY','Rochester','Monroe',43.128507,-77.629962),('14638','NY','Rochester','Monroe',43.1572,-77.6064),('14639','NY','Rochester','Monroe',43.1572,-77.6064),('14642','NY','Rochester','Monroe',43.1242,-77.6231),('14643','NY','Rochester','Monroe',43.1572,-77.6064),('14644','NY','Rochester','Monroe',43.1572,-77.6064),('14645','NY','Rochester','Monroe',43.1572,-77.6064),('14646','NY','Rochester','Monroe',43.1572,-77.6064),('14647','NY','Rochester','Monroe',43.1572,-77.6064),('14649','NY','Rochester','Monroe',43.1572,-77.6064),('14650','NY','Rochester','Monroe',43.1541,-77.6255),('14651','NY','Rochester','Monroe',43.1541,-77.6255),('14652','NY','Rochester','Monroe',43.1541,-77.6255),('14653','NY','Rochester','Monroe',43.1541,-77.6255),('14664','NY','Rochester','Monroe',43.1572,-77.6064),('14673','NY','Rochester','Monroe',43.1572,-77.6064),('14683','NY','Rochester','Monroe',43.1572,-77.6064),('14692','NY','Rochester','Monroe',43.0869,-77.5973),('14694','NY','Rochester','Monroe',43.1541,-77.6255),('14701','NY','Jamestown','Chautauqua',42.091951,-79.245183),('14702','NY','Jamestown','Chautauqua',42.0969,-79.2355),('14706','NY','Allegany','Cattaraugus',42.10426,-78.518126),('14707','NY','Allentown','Allegany',42.080019,-78.06544),('14708','NY','Alma','Allegany',42.015988,-78.05728),('14709','NY','Angelica','Allegany',42.3315,-78.004286),('14710','NY','Ashville','Chautauqua',42.098496,-79.408737),('14711','NY','Belfast','Allegany',42.329973,-78.12127),('14712','NY','Bemus Point','Chautauqua',42.170977,-79.376419),('14714','NY','Black Creek','Allegany',42.283744,-78.240131),('14715','NY','Bolivar','Allegany',42.068063,-78.150343),('14716','NY','Brocton','Chautauqua',42.391151,-79.439413),('14717','NY','Caneadea','Allegany',42.370772,-78.188698),('14718','NY','Cassadaga','Chautauqua',42.347098,-79.295627),('14719','NY','Cattaraugus','Cattaraugus',42.329756,-78.874311),('14720','NY','Celoron','Chautauqua',42.108549,-79.282049),('14721','NY','Ceres','Allegany',42.009336,-78.276587),('14722','NY','Chautauqua','Chautauqua',42.209123,-79.466657),('14723','NY','Cherry Creek','Chautauqua',42.298236,-79.130962),('14724','NY','Clymer','Chautauqua',42.046328,-79.66983),('14726','NY','Conewango Valley','Cattaraugus',42.247667,-79.030874),('14727','NY','Cuba','Allegany',42.207061,-78.279918),('14728','NY','Dewittville','Chautauqua',42.25072,-79.427019),('14729','NY','East Otto','Cattaraugus',42.380299,-78.722775),('14730','NY','East Randolph','Cattaraugus',42.1727,-78.948),('14731','NY','Ellicottville','Cattaraugus',42.290854,-78.662121),('14732','NY','Ellington','Chautauqua',42.227113,-79.110738),('14733','NY','Falconer','Chautauqua',42.131745,-79.188631),('14735','NY','Fillmore','Allegany',42.456878,-78.107749),('14736','NY','Findley Lake','Chautauqua',42.129826,-79.743097),('14737','NY','Franklinville','Cattaraugus',42.333055,-78.445165),('14738','NY','Frewsburg','Chautauqua',42.03796,-79.075957),('14739','NY','Friendship','Allegany',42.192627,-78.143026),('14740','NY','Gerry','Chautauqua',42.211793,-79.191681),('14741','NY','Great Valley','Cattaraugus',42.219971,-78.611617),('14742','NY','Greenhurst','Chautauqua',42.118374,-79.309367),('14743','NY','Hinsdale','Cattaraugus',42.201818,-78.407487),('14744','NY','Houghton','Allegany',42.428186,-78.186656),('14745','NY','Hume','Allegany',42.4727,-78.1366),('14747','NY','Kennedy','Chautauqua',42.148394,-79.082691),('14748','NY','Kill Buck','Cattaraugus',42.133702,-78.640099),('14750','NY','Lakewood','Chautauqua',42.096165,-79.324299),('14751','NY','Leon','Cattaraugus',42.293,-79.0166),('14752','NY','Lily Dale','Chautauqua',42.351906,-79.323978),('14753','NY','Limestone','Cattaraugus',42.035804,-78.618941),('14754','NY','Little Genesee','Allegany',42.025967,-78.218734),('14755','NY','Little Valley','Cattaraugus',42.246776,-78.804835),('14756','NY','Maple Springs','Chautauqua',42.19688,-79.421969),('14757','NY','Mayville','Chautauqua',42.23669,-79.492254),('14758','NY','Niobe','Chautauqua',42.0125,-79.4497),('14760','NY','Olean','Cattaraugus',42.077772,-78.428929),('14766','NY','Otto','Cattaraugus',42.3561,-78.8319),('14767','NY','Panama','Chautauqua',42.057352,-79.514135),('14769','NY','Portland','Chautauqua',42.37688,-79.46925),('14770','NY','Portville','Cattaraugus',42.046054,-78.306823),('14772','NY','Randolph','Cattaraugus',42.157656,-78.961117),('14774','NY','Richburg','Allegany',42.08797,-78.14956),('14775','NY','Ripley','Chautauqua',42.256365,-79.701236),('14777','NY','Rushford','Allegany',42.390688,-78.233022),('14778','NY','Saint Bonaventure','Cattaraugus',42.079532,-78.481143),('14779','NY','Salamanca','Cattaraugus',42.13715,-78.741407),('14781','NY','Sherman','Chautauqua',42.157391,-79.599996),('14782','NY','Sinclairville','Chautauqua',42.265389,-79.259689),('14783','NY','Steamburg','Cattaraugus',42.082149,-78.887383),('14784','NY','Stockton','Chautauqua',42.319116,-79.389155),('14785','NY','Stow','Chautauqua',42.1566,-79.4016),('14786','NY','West Clarksville','Allegany',42.128,-78.2433),('14787','NY','Westfield','Chautauqua',42.326268,-79.574682),('14788','NY','Westons Mills','Cattaraugus',42.06341,-78.380753),('14801','NY','Addison','Steuben',42.092044,-77.284097),('14802','NY','Alfred','Allegany',42.255773,-77.790692),('14803','NY','Alfred Station','Allegany',42.256451,-77.778504),('14804','NY','Almond','Allegany',42.317776,-77.820227),('14805','NY','Alpine','Schuyler',42.362105,-76.728656),('14806','NY','Andover','Allegany',42.161971,-77.789449),('14807','NY','Arkport','Steuben',42.421006,-77.711347),('14808','NY','Atlanta','Steuben',42.560432,-77.469396),('14809','NY','Avoca','Steuben',42.419103,-77.439247),('14810','NY','Bath','Steuben',42.34728,-77.338178),('14812','NY','Beaver Dams','Schuyler',42.283923,-76.975276),('14813','NY','Belmont','Allegany',42.242607,-78.015524),('14814','NY','Big Flats','Chemung',42.14186,-76.950494),('14815','NY','Bradford','Schuyler',42.387569,-77.088688),('14816','NY','Breesport','Chemung',42.177126,-76.734203),('14817','NY','Brooktondale','Tompkins',42.36367,-76.352231),('14818','NY','Burdett','Schuyler',42.439494,-76.832162),('14819','NY','Cameron','Steuben',42.210486,-77.425608),('14820','NY','Cameron Mills','Steuben',42.19328,-77.3599),('14821','NY','Campbell','Steuben',42.231621,-77.201917),('14822','NY','Canaseraga','Allegany',42.432664,-77.828177),('14823','NY','Canisteo','Steuben',42.258904,-77.583975),('14824','NY','Cayuta','Schuyler',42.27448,-76.715081),('14825','NY','Chemung','Chemung',42.046957,-76.624009),('14826','NY','Cohocton','Steuben',42.485289,-77.503963),('14827','NY','Coopers Plains','Steuben',42.181052,-77.141407),('14830','NY','Corning','Steuben',42.141717,-77.045341),('14831','NY','Corning','Steuben',42.142,-77.0577),('14836','NY','Dalton','Livingston',42.522237,-77.930118),('14837','NY','Dundee','Yates',42.502471,-77.001393),('14838','NY','Erin','Chemung',42.185596,-76.670575),('14839','NY','Greenwood','Steuben',42.132925,-77.648239),('14840','NY','Hammondsport','Steuben',42.441073,-77.188573),('14841','NY','Hector','Schuyler',42.519527,-76.857825),('14842','NY','Himrod','Yates',42.596871,-76.947175),('14843','NY','Hornell','Steuben',42.332548,-77.653589),('14845','NY','Horseheads','Chemung',42.183154,-76.836938),('14846','NY','Hunt','Livingston',42.542636,-77.995632),('14847','NY','Interlaken','Seneca',42.614615,-76.724111),('14850','NY','Ithaca','Tompkins',42.446774,-76.495397),('14851','NY','Ithaca','Tompkins',42.4355,-76.5014),('14852','NY','Ithaca','Tompkins',42.5047,-76.4712),('14853','NY','Ithaca','Tompkins',42.446406,-76.481236),('14854','NY','Jacksonville','Tompkins',42.5083,-76.6152),('14855','NY','Jasper','Steuben',42.143828,-77.509712),('14856','NY','Kanona','Steuben',42.377689,-77.365982),('14857','NY','Lakemont','Yates',42.515233,-76.92063),('14858','NY','Lindley','Steuben',42.02979,-77.134956),('14859','NY','Lockwood','Tioga',42.114833,-76.538141),('14860','NY','Lodi','Seneca',42.596404,-76.844882),('14861','NY','Lowman','Chemung',42.07092,-76.693745),('14863','NY','Mecklenburg','Schuyler',42.4575,-76.7105),('14864','NY','Millport','Chemung',42.267663,-76.838592),('14865','NY','Montour Falls','Schuyler',42.347968,-76.841671),('14867','NY','Newfield','Tompkins',42.358025,-76.602241),('14869','NY','Odessa','Schuyler',42.352008,-76.777048),('14870','NY','Painted Post','Steuben',42.164599,-77.120387),('14871','NY','Pine City','Chemung',42.044782,-76.899286),('14872','NY','Pine Valley','Chemung',42.225809,-76.861749),('14873','NY','Prattsburgh','Steuben',42.527504,-77.303518),('14874','NY','Pulteney','Steuben',42.530131,-77.159591),('14876','NY','Reading Center','Schuyler',42.4302,-76.933),('14877','NY','Rexville','Steuben',42.057511,-77.696487),('14878','NY','Rock Stream','Schuyler',42.450844,-76.931384),('14879','NY','Savona','Steuben',42.307683,-77.202498),('14880','NY','Scio','Allegany',42.176081,-77.976234),('14881','NY','Slaterville Springs','Tompkins',42.399901,-76.358994),('14882','NY','Lansing','Tompkins',42.579578,-76.553706),('14883','NY','Spencer','Tioga',42.234849,-76.486357),('14884','NY','Swain','Allegany',42.479522,-77.893852),('14885','NY','Troupsburg','Steuben',42.040638,-77.56285),('14886','NY','Trumansburg','Tompkins',42.515381,-76.668415),('14887','NY','Tyrone','Schuyler',42.408,-77.0586),('14889','NY','Van Etten','Chemung',42.212634,-76.585919),('14891','NY','Watkins Glen','Schuyler',42.37977,-76.904127),('14892','NY','Waverly','Tioga',42.030867,-76.526653),('14893','NY','Wayne','Steuben',42.467953,-77.107738),('14894','NY','Wellsburg','Chemung',42.01395,-76.753182),('14895','NY','Wellsville','Allegany',42.096543,-77.945805),('14897','NY','Whitesville','Allegany',42.031915,-77.788828),('14898','NY','Woodhull','Steuben',42.065213,-77.439902),('14901','NY','Elmira','Chemung',42.089096,-76.78679),('14902','NY','Elmira','Chemung',42.0909,-76.8061),('14903','NY','Elmira','Chemung',42.129333,-76.844488),('14904','NY','Elmira','Chemung',42.072419,-76.803777),('14905','NY','Elmira','Chemung',42.087822,-76.836267),('14925','NY','Elmira','Chemung',42.1146,-76.8055),('15001','PA','Aliquippa','Beaver',40.603004,-80.288021),('15003','PA','Ambridge','Beaver',40.595118,-80.222462),('15004','PA','Atlasburg','Washington',40.343085,-80.384027),('15005','PA','Baden','Beaver',40.640957,-80.205939),('15006','PA','Bairdford','Allegheny',40.63121,-79.879181),('15007','PA','Bakerstown','Allegheny',40.652762,-79.933065),('15009','PA','Beaver','Beaver',40.697,-80.330479),('15010','PA','Beaver Falls','Beaver',40.765855,-80.336455),('15012','PA','Belle Vernon','Westmoreland',40.144636,-79.837267),('15014','PA','Brackenridge','Allegheny',40.608316,-79.742442),('15015','PA','Bradfordwoods','Allegheny',40.638134,-80.083054),('15017','PA','Bridgeville','Allegheny',40.349057,-80.11598),('15018','PA','Buena Vista','Allegheny',40.265885,-79.797067),('15019','PA','Bulger','Washington',40.406974,-80.328574),('15020','PA','Bunola','Allegheny',40.238626,-79.945078),('15021','PA','Burgettstown','Washington',40.388578,-80.41838),('15022','PA','Charleroi','Washington',40.133985,-79.912959),('15024','PA','Cheswick','Allegheny',40.563204,-79.829841),('15025','PA','Clairton','Allegheny',40.295565,-79.903995),('15026','PA','Clinton','Beaver',40.505208,-80.354846),('15027','PA','Conway','Beaver',40.66408,-80.235169),('15028','PA','Coulters','Allegheny',40.297833,-79.803463),('15030','PA','Creighton','Allegheny',40.581843,-79.779494),('15031','PA','Cuddy','Allegheny',40.345717,-80.162487),('15032','PA','Curtisville','Allegheny',40.5388,-79.8338),('15033','PA','Donora','Washington',40.176736,-79.861193),('15034','PA','Dravosburg','Allegheny',40.350648,-79.890176),('15035','PA','East Mc Keesport','Allegheny',40.383923,-79.808964),('15037','PA','Elizabeth','Allegheny',40.265522,-79.868104),('15038','PA','Elrama','Washington',40.251482,-79.924953),('15042','PA','Freedom','Beaver',40.681727,-80.22697),('15043','PA','Georgetown','Beaver',40.574051,-80.491597),('15044','PA','Gibsonia','Allegheny',40.631216,-79.957044),('15045','PA','Glassport','Allegheny',40.326845,-79.889294),('15046','PA','Crescent','Allegheny',40.557972,-80.227275),('15047','PA','Greenock','Allegheny',40.2488,-79.8303),('15049','PA','Harwick','Allegheny',40.555241,-79.807282),('15050','PA','Hookstown','Beaver',40.556217,-80.443063),('15051','PA','Indianola','Allegheny',40.563695,-79.857937),('15052','PA','Industry','Beaver',40.658731,-80.430743),('15053','PA','Joffre','Washington',40.379987,-80.360848),('15054','PA','Langeloth','Washington',40.36281,-80.408913),('15055','PA','Lawrence','Washington',40.305141,-80.121045),('15056','PA','Leetsdale','Allegheny',40.563684,-80.212035),('15057','PA','Mc Donald','Washington',40.362239,-80.246652),('15059','PA','Midland','Beaver',40.648425,-80.472606),('15060','PA','Midway','Washington',40.368087,-80.293017),('15061','PA','Monaca','Beaver',40.675823,-80.291907),('15062','PA','Monessen','Westmoreland',40.152494,-79.883744),('15063','PA','Monongahela','Washington',40.193119,-79.928461),('15064','PA','Morgan','Allegheny',40.353103,-80.145239),('15065','PA','Natrona Heights','Allegheny',40.628562,-79.725173),('15066','PA','New Brighton','Beaver',40.739859,-80.293868),('15067','PA','New Eagle','Washington',40.207156,-79.953342),('15068','PA','New Kensington','Westmoreland',40.57135,-79.741758),('15069','PA','New Kensington','Westmoreland',40.5444,-79.6511),('15071','PA','Oakdale','Allegheny',40.419179,-80.186989),('15072','PA','Pricedale','Westmoreland',40.139184,-79.856361),('15074','PA','Rochester','Beaver',40.708597,-80.273364),('15075','PA','Rural Ridge','Allegheny',40.586108,-79.826188),('15076','PA','Russellton','Allegheny',40.612507,-79.834538),('15077','PA','Shippingport','Beaver',40.625441,-80.423957),('15078','PA','Slovan','Washington',40.357848,-80.388917),('15081','PA','South Heights','Beaver',40.575072,-80.236103),('15082','PA','Sturgeon','Allegheny',40.379724,-80.211174),('15083','PA','Sutersville','Westmoreland',40.238028,-79.796824),('15084','PA','Tarentum','Allegheny',40.616515,-79.785986),('15085','PA','Trafford','Westmoreland',40.3871,-79.74342),('15086','PA','Warrendale','Allegheny',40.661168,-80.092914),('15087','PA','Webster','Westmoreland',40.185861,-79.850519),('15088','PA','West Elizabeth','Allegheny',40.272826,-79.895286),('15089','PA','West Newton','Westmoreland',40.212169,-79.755769),('15090','PA','Wexford','Allegheny',40.620408,-80.060372),('15091','PA','Wildwood','Allegheny',40.5941,-79.9702),('15095','PA','Warrendale','Allegheny',40.6533,-80.0797),('15096','PA','Warrendale','Allegheny',40.6533,-80.0797),('15101','PA','Allison Park','Allegheny',40.572063,-79.96514),('15102','PA','Bethel Park','Allegheny',40.324799,-80.037605),('15104','PA','Braddock','Allegheny',40.40598,-79.864386),('15106','PA','Carnegie','Allegheny',40.404077,-80.091574),('15108','PA','Coraopolis','Allegheny',40.500044,-80.193033),('15110','PA','Duquesne','Allegheny',40.370134,-79.850507),('15112','PA','East Pittsburgh','Allegheny',40.402903,-79.837775),('15116','PA','Glenshaw','Allegheny',40.537065,-79.957417),('15120','PA','Homestead','Allegheny',40.396213,-79.905173),('15122','PA','West Mifflin','Allegheny',40.366099,-79.894675),('15123','PA','West Mifflin','Allegheny',40.3423,-79.9547),('15126','PA','Imperial','Allegheny',40.461071,-80.274616),('15127','PA','Ingomar','Allegheny',40.5808,-80.0611),('15129','PA','South Park','Allegheny',40.296801,-80.002552),('15131','PA','Mckeesport','Allegheny',40.342927,-79.811655),('15132','PA','Mckeesport','Allegheny',40.3417,-79.847951),('15133','PA','Mckeesport','Allegheny',40.33344,-79.864663),('15134','PA','Mckeesport','Allegheny',40.3471,-79.8644),('15135','PA','Mckeesport','Allegheny',40.309482,-79.817313),('15136','PA','Mc Kees Rocks','Allegheny',40.472281,-80.077557),('15137','PA','North Versailles','Allegheny',40.377377,-79.813418),('15139','PA','Oakmont','Allegheny',40.519808,-79.837362),('15140','PA','Pitcairn','Allegheny',40.405802,-79.776626),('15142','PA','Presto','Allegheny',40.382445,-80.125527),('15143','PA','Sewickley','Allegheny',40.560335,-80.155172),('15144','PA','Springdale','Allegheny',40.542277,-79.781984),('15145','PA','Turtle Creek','Allegheny',40.410192,-79.825072),('15146','PA','Monroeville','Allegheny',40.428872,-79.764643),('15147','PA','Verona','Allegheny',40.497431,-79.831096),('15148','PA','Wilmerding','Allegheny',40.394292,-79.803084),('15201','PA','Pittsburgh','Allegheny',40.472425,-79.954749),('15202','PA','Pittsburgh','Allegheny',40.502467,-80.068477),('15203','PA','Pittsburgh','Allegheny',40.426161,-79.978634),('15204','PA','Pittsburgh','Allegheny',40.455194,-80.058851),('15205','PA','Pittsburgh','Allegheny',40.43821,-80.079915),('15206','PA','Pittsburgh','Allegheny',40.469597,-79.916984),('15207','PA','Pittsburgh','Allegheny',40.402779,-79.93657),('15208','PA','Pittsburgh','Allegheny',40.454041,-79.897653),('15209','PA','Pittsburgh','Allegheny',40.492508,-79.974353),('15210','PA','Pittsburgh','Allegheny',40.40924,-79.989633),('15211','PA','Pittsburgh','Allegheny',40.428816,-80.013516),('15212','PA','Pittsburgh','Allegheny',40.461955,-80.008504),('15213','PA','Pittsburgh','Allegheny',40.442989,-79.957237),('15214','PA','Pittsburgh','Allegheny',40.480075,-80.01315),('15215','PA','Pittsburgh','Allegheny',40.498279,-79.919094),('15216','PA','Pittsburgh','Allegheny',40.400164,-80.034905),('15217','PA','Pittsburgh','Allegheny',40.430599,-79.922874),('15218','PA','Pittsburgh','Allegheny',40.424109,-79.889422),('15219','PA','Pittsburgh','Allegheny',40.442538,-79.981339),('15220','PA','Pittsburgh','Allegheny',40.428544,-80.043126),('15221','PA','Pittsburgh','Allegheny',40.437975,-79.87389),('15222','PA','Pittsburgh','Allegheny',40.446672,-79.993162),('15223','PA','Pittsburgh','Allegheny',40.503882,-79.951654),('15224','PA','Pittsburgh','Allegheny',40.464149,-79.946887),('15225','PA','Pittsburgh','Allegheny',40.510802,-80.120698),('15226','PA','Pittsburgh','Allegheny',40.394636,-80.015783),('15227','PA','Pittsburgh','Allegheny',40.37695,-79.976742),('15228','PA','Pittsburgh','Allegheny',40.371613,-80.045048),('15229','PA','Pittsburgh','Allegheny',40.518196,-80.034682),('15230','PA','Pittsburgh','Allegheny',40.5085,-80.0786),('15231','PA','Pittsburgh','Allegheny',40.495874,-80.255891),('15232','PA','Pittsburgh','Allegheny',40.453146,-79.931353),('15233','PA','Pittsburgh','Allegheny',40.457743,-80.028557),('15234','PA','Pittsburgh','Allegheny',40.368953,-80.018793),('15235','PA','Pittsburgh','Allegheny',40.458781,-79.831293),('15236','PA','Pittsburgh','Allegheny',40.345299,-79.97975),('15237','PA','Pittsburgh','Allegheny',40.549076,-80.035536),('15238','PA','Pittsburgh','Allegheny',40.518163,-79.869403),('15239','PA','Pittsburgh','Allegheny',40.482538,-79.741252),('15240','PA','Pittsburgh','Allegheny',40.4405,-79.9961),('15241','PA','Pittsburgh','Allegheny',40.334706,-80.073381),('15242','PA','Pittsburgh','Allegheny',40.4121,-80.0679),('15243','PA','Pittsburgh','Allegheny',40.373073,-80.071598),('15244','PA','Pittsburgh','Allegheny',40.4405,-79.9961),('15250','PA','Pittsburgh','Allegheny',40.4432,-79.955),('15251','PA','Pittsburgh','Allegheny',40.4432,-79.955),('15252','PA','Pittsburgh','Allegheny',40.4432,-79.955),('15253','PA','Pittsburgh','Allegheny',40.4432,-79.955),('15254','PA','Pittsburgh','Allegheny',40.4432,-79.955),('15255','PA','Pittsburgh','Allegheny',40.4432,-79.9818),('15257','PA','Pittsburgh','Allegheny',40.4432,-79.955),('15258','PA','Pittsburgh','Allegheny',40.4432,-79.955),('15259','PA','Pittsburgh','Allegheny',40.4432,-79.955),('15260','PA','Pittsburgh','Allegheny',40.4424,-79.9507),('15261','PA','Pittsburgh','Allegheny',40.4442,-79.9617),('15262','PA','Pittsburgh','Allegheny',40.4983,-80.0618),('15263','PA','Pittsburgh','Allegheny',40.4432,-79.9818),('15264','PA','Pittsburgh','Allegheny',40.4432,-79.955),('15265','PA','Pittsburgh','Allegheny',40.4473,-79.9939),('15266','PA','Pittsburgh','Allegheny',40.442629,-79.996448),('15267','PA','Pittsburgh','Allegheny',40.4432,-79.9818),('15268','PA','Pittsburgh','Allegheny',40.4983,-80.0618),('15270','PA','Pittsburgh','Allegheny',40.4036,-80.0344),('15272','PA','Pittsburgh','Allegheny',40.4473,-79.9939),('15273','PA','Pittsburgh','Allegheny',40.37,-79.9),('15274','PA','Pittsburgh','Allegheny',40.4432,-79.955),('15275','PA','Pittsburgh','Allegheny',40.4513,-80.1788),('15276','PA','Pittsburgh','Allegheny',40.4292,-80.1253),('15277','PA','Pittsburgh','Allegheny',40.4405,-79.9961),('15278','PA','Pittsburgh','Allegheny',40.4983,-80.0618),('15279','PA','Pittsburgh','Allegheny',40.4432,-79.9818),('15281','PA','Pittsburgh','Allegheny',40.4432,-79.9818),('15282','PA','Pittsburgh','Allegheny',40.4371,-79.9929),('15283','PA','Pittsburgh','Allegheny',40.4199,-80.0499),('15285','PA','Pittsburgh','Allegheny',40.4405,-79.9961),('15286','PA','Pittsburgh','Allegheny',40.4983,-80.0618),('15288','PA','Pittsburgh','Allegheny',40.444638,-79.942966),('15289','PA','Pittsburgh','Allegheny',40.4406,-79.9961),('15290','PA','Pittsburgh','Allegheny',40.4983,-80.0618),('15295','PA','Pittsburgh','Allegheny',40.4747,-79.9521),('15301','PA','Washington','Washington',40.169176,-80.251169),('15310','PA','Aleppo','Greene',39.792888,-80.486065),('15311','PA','Amity','Washington',40.043959,-80.189196),('15312','PA','Avella','Washington',40.261222,-80.446029),('15313','PA','Beallsville','Washington',40.065407,-80.022986),('15314','PA','Bentleyville','Washington',40.135259,-80.010703),('15315','PA','Bobtown','Greene',39.760599,-79.983107),('15316','PA','Brave','Greene',39.724476,-80.260104),('15317','PA','Canonsburg','Washington',40.267269,-80.166446),('15320','PA','Carmichaels','Greene',39.886422,-79.973739),('15321','PA','Cecil','Washington',40.321876,-80.190558),('15322','PA','Clarksville','Greene',39.977115,-80.042793),('15323','PA','Claysville','Washington',40.112251,-80.405659),('15324','PA','Cokeburg','Washington',40.101899,-80.064966),('15325','PA','Crucible','Greene',39.949798,-79.966113),('15327','PA','Dilliner','Greene',39.747933,-79.954537),('15329','PA','Prosperity','Washington',40.020798,-80.260475),('15330','PA','Eighty Four','Washington',40.17871,-80.100242),('15331','PA','Ellsworth','Washington',40.106941,-80.020279),('15332','PA','Finleyville','Washington',40.249741,-79.987434),('15333','PA','Fredericktown','Washington',40.011182,-80.00289),('15334','PA','Garards Fort','Greene',39.807197,-79.963041),('15336','PA','Gastonville','Washington',40.2572,-79.9961),('15337','PA','Graysville','Greene',39.942454,-80.378765),('15338','PA','Greensboro','Greene',39.80667,-79.945607),('15339','PA','Hendersonville','Washington',40.2991,-80.1525),('15340','PA','Hickory','Washington',40.286024,-80.317816),('15341','PA','Holbrook','Greene',39.824542,-80.343603),('15342','PA','Houston','Washington',40.244062,-80.214448),('15344','PA','Jefferson','Greene',39.927825,-80.058959),('15345','PA','Marianna','Washington',40.022515,-80.0972),('15346','PA','Mather','Greene',39.933915,-80.074694),('15347','PA','Meadow Lands','Washington',40.215782,-80.223155),('15348','PA','Millsboro','Washington',39.988311,-79.994493),('15349','PA','Mount Morris','Greene',39.748104,-80.073249),('15350','PA','Muse','Washington',40.29297,-80.201568),('15351','PA','Nemacolin','Greene',39.879251,-79.925052),('15352','PA','New Freeport','Greene',39.754979,-80.392083),('15353','PA','Nineveh','Greene',39.960344,-80.306899),('15357','PA','Rices Landing','Greene',39.946214,-79.993337),('15358','PA','Richeyville','Washington',40.056057,-79.998282),('15359','PA','Rogersville','Greene',39.879129,-80.273387),('15360','PA','Scenery Hill','Washington',40.084697,-80.068888),('15361','PA','Southview','Washington',40.328273,-80.257732),('15362','PA','Spraggs','Greene',39.75941,-80.209971),('15363','PA','Strabane','Washington',40.252053,-80.199201),('15364','PA','Sycamore','Greene',39.939775,-80.288397),('15365','PA','Taylorstown','Washington',40.1597,-80.3783),('15366','PA','Van Voorhis','Washington',40.155704,-79.973503),('15367','PA','Venetia','Washington',40.26911,-80.058289),('15368','PA','Vestaburg','Washington',40.015518,-79.990239),('15370','PA','Waynesburg','Greene',39.890563,-80.174532),('15376','PA','West Alexander','Washington',40.105737,-80.496892),('15377','PA','West Finley','Washington',39.975816,-80.445914),('15378','PA','Westland','Washington',40.27758,-80.27408),('15379','PA','West Middletown','Washington',40.241751,-80.421335),('15380','PA','Wind Ridge','Greene',39.875263,-80.469322),('15401','PA','Uniontown','Fayette',39.900586,-79.730899),('15410','PA','Adah','Fayette',39.911354,-79.902222),('15411','PA','Addison','Somerset',39.752042,-79.355246),('15412','PA','Allenport','Washington',40.093036,-79.848313),('15413','PA','Allison','Fayette',39.985307,-79.873133),('15415','PA','Brier Hill','Fayette',39.9802,-79.8283),('15416','PA','Brownfield','Fayette',39.8699,-79.7155),('15417','PA','Brownsville','Fayette',40.016729,-79.900067),('15419','PA','California','Washington',40.0642,-79.890776),('15420','PA','Cardale','Fayette',39.958229,-79.867342),('15421','PA','Chalk Hill','Fayette',39.845758,-79.597609),('15422','PA','Chestnut Ridge','Fayette',39.980005,-79.8107),('15423','PA','Coal Center','Washington',40.077791,-79.91863),('15424','PA','Confluence','Somerset',39.813514,-79.35499),('15425','PA','Connellsville','Fayette',40.021933,-79.584527),('15427','PA','Daisytown','Washington',40.061537,-79.962189),('15428','PA','Dawson','Fayette',40.074204,-79.672679),('15429','PA','Denbo','Washington',40.002852,-79.938276),('15430','PA','Dickerson Run','Fayette',40.041948,-79.660048),('15431','PA','Dunbar','Fayette',39.973982,-79.624309),('15432','PA','Dunlevy','Washington',40.117662,-79.86402),('15433','PA','East Millsboro','Fayette',39.970222,-79.949052),('15434','PA','Elco','Washington',40.079243,-79.874796),('15435','PA','Fairbank','Fayette',39.94497,-79.850116),('15436','PA','Fairchance','Fayette',39.82154,-79.750401),('15437','PA','Farmington','Fayette',39.79444,-79.590438),('15438','PA','Fayette City','Fayette',40.09028,-79.835366),('15439','PA','Gans','Fayette',39.7427,-79.8244),('15440','PA','Gibbon Glade','Fayette',39.729537,-79.608726),('15442','PA','Grindstone','Fayette',40.014572,-79.832165),('15443','PA','Hibbs','Fayette',39.928279,-79.885721),('15444','PA','Hiller','Fayette',40.01127,-79.905497),('15445','PA','Hopwood','Fayette',39.877586,-79.68819),('15446','PA','Indian Head','Fayette',40.029472,-79.394454),('15447','PA','Isabella','Fayette',39.945704,-79.939606),('15448','PA','Jacobs Creek','Westmoreland',40.135366,-79.742681),('15449','PA','Keisterville','Fayette',39.963096,-79.78478),('15450','PA','La Belle','Fayette',40.008851,-79.976624),('15451','PA','Lake Lynn','Fayette',39.73702,-79.83545),('15454','PA','Leckrone','Fayette',39.859655,-79.874811),('15455','PA','Leisenring','Fayette',40.001408,-79.642247),('15456','PA','Lemont Furnace','Fayette',39.923729,-79.660103),('15458','PA','Mc Clellandtown','Fayette',39.885746,-79.865459),('15459','PA','Markleysburg','Fayette',39.75797,-79.462188),('15460','PA','Martin','Fayette',39.807993,-79.911872),('15461','PA','Masontown','Fayette',39.846877,-79.903795),('15462','PA','Melcroft','Fayette',40.052735,-79.386844),('15463','PA','Merrittstown','Fayette',39.9626,-79.8755),('15464','PA','Mill Run','Fayette',39.930139,-79.436213),('15465','PA','Mount Braddock','Fayette',39.9457,-79.6472),('15466','PA','Newell','Fayette',40.075343,-79.895629),('15467','PA','New Geneva','Fayette',39.787219,-79.910928),('15468','PA','New Salem','Fayette',39.937237,-79.836164),('15469','PA','Normalville','Fayette',40.014033,-79.439974),('15470','PA','Ohiopyle','Fayette',39.851055,-79.532465),('15472','PA','Oliver','Fayette',39.919937,-79.71652),('15473','PA','Perryopolis','Fayette',40.078518,-79.758982),('15474','PA','Point Marion','Fayette',39.740608,-79.900928),('15475','PA','Republic','Fayette',39.962417,-79.879406),('15476','PA','Ronco','Fayette',39.870628,-79.920176),('15477','PA','Roscoe','Washington',40.078503,-79.865128),('15478','PA','Smithfield','Fayette',39.796365,-79.812479),('15479','PA','Smithton','Westmoreland',40.160493,-79.737154),('15480','PA','Smock','Fayette',39.985623,-79.77357),('15482','PA','Star Junction','Fayette',40.062579,-79.762356),('15483','PA','Stockdale','Washington',40.08302,-79.850922),('15484','PA','Uledi','Fayette',39.893519,-79.787179),('15485','PA','Ursina','Somerset',39.816608,-79.330093),('15486','PA','Vanderbilt','Fayette',40.033796,-79.690297),('15488','PA','Waltersburg','Fayette',39.9831,-79.7562),('15489','PA','West Leisenring','Fayette',39.958234,-79.700107),('15490','PA','White','Fayette',40.07268,-79.452916),('15492','PA','Wickhaven','Fayette',40.118335,-79.764304),('15501','PA','Somerset','Somerset',40.028445,-79.110163),('15502','PA','Hidden Valley','Somerset',40.051271,-79.253973),('15510','PA','Somerset','Somerset',39.967532,-79.039925),('15520','PA','Acosta','Somerset',40.109632,-79.069156),('15521','PA','Alum Bank','Bedford',40.189639,-78.634644),('15522','PA','Bedford','Bedford',39.978529,-78.534085),('15530','PA','Berlin','Somerset',39.940809,-78.924026),('15531','PA','Boswell','Somerset',40.176017,-79.072386),('15532','PA','Boynton','Somerset',39.764561,-79.066355),('15533','PA','Breezewood','Bedford',39.988275,-78.24267),('15534','PA','Buffalo Mills','Bedford',39.904967,-78.701975),('15535','PA','Clearville','Bedford',39.815159,-78.46538),('15536','PA','Crystal Spring','Fulton',39.954556,-78.203555),('15537','PA','Everett','Bedford',40.012461,-78.366526),('15538','PA','Fairhope','Somerset',39.863752,-78.833758),('15539','PA','Fishertown','Bedford',40.128546,-78.584474),('15540','PA','Fort Hill','Somerset',39.795093,-79.245012),('15541','PA','Friedens','Somerset',40.053859,-78.987071),('15542','PA','Garrett','Somerset',39.86467,-79.065129),('15544','PA','Gray','Somerset',40.134751,-79.092436),('15545','PA','Hyndman','Bedford',39.789698,-78.743471),('15546','PA','Jenners','Somerset',40.141569,-79.045542),('15547','PA','Jennerstown','Somerset',40.16028,-79.066834),('15548','PA','Kantner','Somerset',40.0983,-78.9409),('15549','PA','Listie','Somerset',40.028,-79.0136),('15550','PA','Manns Choice','Bedford',39.999985,-78.64166),('15551','PA','Markleton','Somerset',39.885189,-79.255704),('15552','PA','Meyersdale','Somerset',39.80458,-79.01954),('15553','PA','New Baltimore','Somerset',39.983808,-78.772154),('15554','PA','New Paris','Bedford',40.127249,-78.610417),('15555','PA','Quecreek','Somerset',40.091195,-79.083497),('15557','PA','Rockwood','Somerset',39.935644,-79.220912),('15558','PA','Salisbury','Somerset',39.742879,-79.093871),('15559','PA','Schellsburg','Bedford',40.050296,-78.668495),('15560','PA','Shanksville','Somerset',40.017027,-78.905833),('15561','PA','Sipesville','Somerset',40.093469,-79.090493),('15562','PA','Springs','Somerset',39.736189,-79.143468),('15563','PA','Stoystown','Somerset',40.098989,-78.952198),('15564','PA','Wellersburg','Somerset',39.728549,-78.843751),('15565','PA','West Salisbury','Somerset',39.7541,-79.1068),('15601','PA','Greensburg','Westmoreland',40.300028,-79.542139),('15605','PA','Greensburg','Westmoreland',40.3013,-79.5391),('15606','PA','Greensburg','Westmoreland',40.3013,-79.5391),('15610','PA','Acme','Westmoreland',40.137879,-79.424268),('15611','PA','Adamsburg','Westmoreland',40.306406,-79.65166),('15612','PA','Alverton','Westmoreland',40.135065,-79.594915),('15613','PA','Apollo','Westmoreland',40.559481,-79.576529),('15615','PA','Ardara','Westmoreland',40.363032,-79.735077),('15616','PA','Armbrust','Westmoreland',40.222652,-79.554477),('15617','PA','Arona','Westmoreland',40.269595,-79.66053),('15618','PA','Avonmore','Westmoreland',40.538705,-79.45456),('15619','PA','Bovard','Westmoreland',40.3197,-79.5036),('15620','PA','Bradenville','Westmoreland',40.320866,-79.339932),('15621','PA','Calumet','Westmoreland',40.213751,-79.484306),('15622','PA','Champion','Fayette',40.032247,-79.308555),('15623','PA','Claridge','Westmoreland',40.366837,-79.619121),('15624','PA','Crabtree','Westmoreland',40.363257,-79.470448),('15625','PA','Darragh','Westmoreland',40.266475,-79.677931),('15626','PA','Delmont','Westmoreland',40.409968,-79.573236),('15627','PA','Derry','Westmoreland',40.340343,-79.305571),('15628','PA','Donegal','Westmoreland',40.10871,-79.381553),('15629','PA','East Vandergrift','Westmoreland',40.597894,-79.562633),('15631','PA','Everson','Fayette',40.090814,-79.586647),('15632','PA','Export','Westmoreland',40.425637,-79.606997),('15633','PA','Forbes Road','Westmoreland',40.353868,-79.522109),('15634','PA','Grapeville','Westmoreland',40.324202,-79.606003),('15635','PA','Hannastown','Westmoreland',40.350726,-79.4959),('15636','PA','Harrison City','Westmoreland',40.361187,-79.656844),('15637','PA','Herminie','Westmoreland',40.263572,-79.712374),('15638','PA','Hostetter','Westmoreland',40.265152,-79.398543),('15639','PA','Hunker','Westmoreland',40.203652,-79.593808),('15640','PA','Hutchinson','Westmoreland',40.225913,-79.730957),('15641','PA','Hyde Park','Westmoreland',40.631645,-79.589328),('15642','PA','Irwin','Westmoreland',40.326299,-79.712536),('15644','PA','Jeannette','Westmoreland',40.33156,-79.613012),('15646','PA','Jones Mills','Westmoreland',40.088728,-79.33887),('15647','PA','Larimer','Westmoreland',40.344789,-79.726105),('15650','PA','Latrobe','Westmoreland',40.29698,-79.392074),('15655','PA','Laughlintown','Westmoreland',40.200621,-79.191097),('15656','PA','Leechburg','Westmoreland',40.631896,-79.612423),('15658','PA','Ligonier','Westmoreland',40.245276,-79.230145),('15660','PA','Lowber','Westmoreland',40.24496,-79.771548),('15661','PA','Loyalhanna','Westmoreland',40.320571,-79.361104),('15662','PA','Luxor','Westmoreland',40.335011,-79.477216),('15663','PA','Madison','Westmoreland',40.248753,-79.679165),('15664','PA','Mammoth','Westmoreland',40.2008,-79.4633),('15665','PA','Manor','Westmoreland',40.334358,-79.665046),('15666','PA','Mount Pleasant','Westmoreland',40.160815,-79.520712),('15668','PA','Murrysville','Westmoreland',40.451429,-79.680897),('15670','PA','New Alexandria','Westmoreland',40.401915,-79.429507),('15671','PA','New Derry','Westmoreland',40.347116,-79.318653),('15672','PA','New Stanton','Westmoreland',40.233496,-79.618738),('15673','PA','North Apollo','Armstrong',40.593047,-79.558588),('15674','PA','Norvelt','Westmoreland',40.2071,-79.496191),('15675','PA','Penn','Westmoreland',40.330279,-79.64077),('15676','PA','Pleasant Unity','Westmoreland',40.243302,-79.45916),('15677','PA','Rector','Westmoreland',40.175107,-79.242193),('15678','PA','Rillton','Westmoreland',40.288453,-79.729495),('15679','PA','Ruffs Dale','Westmoreland',40.187654,-79.655809),('15680','PA','Salina','Westmoreland',40.520151,-79.499065),('15681','PA','Saltsburg','Indiana',40.502624,-79.444278),('15682','PA','Schenley','Armstrong',40.6844,-79.6619),('15683','PA','Scottdale','Westmoreland',40.10345,-79.590807),('15684','PA','Slickville','Westmoreland',40.458785,-79.523637),('15685','PA','Southwest','Westmoreland',40.196455,-79.524666),('15686','PA','Spring Church','Armstrong',40.623731,-79.431),('15687','PA','Stahlstown','Westmoreland',40.127452,-79.31168),('15688','PA','Tarrs','Westmoreland',40.168207,-79.590697),('15689','PA','United','Westmoreland',40.220649,-79.491139),('15690','PA','Vandergrift','Westmoreland',40.612298,-79.558735),('15691','PA','Wendel','Westmoreland',40.293706,-79.686951),('15692','PA','Westmoreland City','Westmoreland',40.331664,-79.676108),('15693','PA','Whitney','Westmoreland',40.253223,-79.40844),('15695','PA','Wyano','Westmoreland',40.195838,-79.695396),('15696','PA','Youngstown','Westmoreland',40.280771,-79.365096),('15697','PA','Youngwood','Westmoreland',40.236319,-79.582018),('15698','PA','Yukon','Westmoreland',40.218287,-79.685167),('15701','PA','Indiana','Indiana',40.626607,-79.161303),('15705','PA','Indiana','Indiana',40.6156,-79.1599),('15710','PA','Alverda','Indiana',40.63647,-78.87102),('15711','PA','Anita','Jefferson',41.001072,-78.96525),('15712','PA','Arcadia','Indiana',40.793412,-78.846998),('15713','PA','Aultman','Indiana',40.563954,-79.259833),('15714','PA','Northern Cambria','Cambria',40.659928,-78.798408),('15715','PA','Big Run','Jefferson',40.970724,-78.87743),('15716','PA','Black Lick','Indiana',40.471623,-79.191619),('15717','PA','Blairsville','Indiana',40.446748,-79.246806),('15720','PA','Brush Valley','Indiana',40.5437,-79.0804),('15721','PA','Burnside','Clearfield',40.813907,-78.787391),('15722','PA','Carrolltown','Cambria',40.594913,-78.724479),('15723','PA','Chambersville','Indiana',40.704602,-79.163749),('15724','PA','Cherry Tree','Indiana',40.735522,-78.813412),('15725','PA','Clarksburg','Indiana',40.519096,-79.348807),('15727','PA','Clune','Indiana',40.556101,-79.304238),('15728','PA','Clymer','Indiana',40.675266,-78.987823),('15729','PA','Commodore','Indiana',40.710027,-78.930415),('15730','PA','Coolspring','Jefferson',41.046423,-79.090401),('15731','PA','Coral','Indiana',40.501127,-79.174687),('15732','PA','Creekside','Indiana',40.710109,-79.205032),('15733','PA','De Lancey','Jefferson',40.984945,-78.96139),('15734','PA','Dixonville','Indiana',40.720856,-79.006281),('15736','PA','Elderton','Armstrong',40.693964,-79.343843),('15737','PA','Elmora','Cambria',40.611578,-78.757507),('15738','PA','Emeigh','Cambria',40.694761,-78.789265),('15739','PA','Ernest','Indiana',40.677507,-79.168881),('15740','PA','Frostburg','Jefferson',40.9644,-79.0336),('15741','PA','Gipsy','Indiana',40.805067,-78.878302),('15742','PA','Glen Campbell','Indiana',40.813443,-78.845553),('15744','PA','Hamilton','Jefferson',40.916804,-79.084676),('15745','PA','Heilwood','Indiana',40.62269,-78.917989),('15746','PA','Hillsdale','Indiana',40.758509,-78.889294),('15747','PA','Home','Indiana',40.759353,-79.143491),('15748','PA','Homer City','Indiana',40.529424,-79.142155),('15750','PA','Josephine','Indiana',40.483084,-79.185231),('15752','PA','Kent','Indiana',40.539994,-79.282604),('15753','PA','La Jose','Clearfield',40.790958,-78.671887),('15754','PA','Lucernemines','Indiana',40.55671,-79.151278),('15756','PA','Mc Intyre','Indiana',40.57042,-79.299037),('15757','PA','Mahaffey','Clearfield',40.881116,-78.728409),('15758','PA','Marchand','Indiana',40.903,-79.0574),('15759','PA','Marion Center','Indiana',40.773037,-79.031786),('15760','PA','Marsteller','Cambria',40.651949,-78.798235),('15761','PA','Mentcle','Indiana',40.63162,-78.888697),('15762','PA','Nicktown','Cambria',40.594306,-78.829301),('15763','PA','Northpoint','Indiana',40.906164,-79.137578),('15764','PA','Oliveburg','Jefferson',40.987013,-79.027561),('15765','PA','Penn Run','Indiana',40.60283,-79.003831),('15767','PA','Punxsutawney','Jefferson',40.953384,-78.970106),('15770','PA','Ringgold','Jefferson',40.998791,-79.168135),('15771','PA','Rochester Mills','Indiana',40.830191,-79.001384),('15772','PA','Rossiter','Indiana',40.870692,-78.905814),('15773','PA','Saint Benedict','Cambria',40.627778,-78.729928),('15774','PA','Shelocta','Indiana',40.661279,-79.327808),('15775','PA','Spangler','Cambria',40.641113,-78.773351),('15776','PA','Sprankle Mills','Jefferson',41.006263,-79.12039),('15777','PA','Starford','Indiana',40.70041,-78.957372),('15778','PA','Timblin','Jefferson',40.966183,-79.199534),('15779','PA','Torrance','Westmoreland',40.416349,-79.233108),('15780','PA','Valier','Jefferson',40.915951,-79.050172),('15781','PA','Walston','Jefferson',40.958908,-78.989983),('15783','PA','West Lebanon','Indiana',40.601823,-79.354362),('15784','PA','Worthville','Jefferson',41.024426,-79.141266),('15801','PA','Du Bois','Clearfield',41.126269,-78.747086),('15821','PA','Benezett','Elk',41.345903,-78.361874),('15822','PA','Brandy Camp','Elk',41.3208,-78.6877),('15823','PA','Brockport','Elk',41.253893,-78.715232),('15824','PA','Brockway','Jefferson',41.234874,-78.808534),('15825','PA','Brookville','Jefferson',41.161292,-79.057545),('15827','PA','Byrnedale','Elk',41.301222,-78.502463),('15828','PA','Clarington','Jefferson',41.322636,-79.148822),('15829','PA','Corsica','Jefferson',41.178794,-79.19532),('15831','PA','Dagus Mines','Elk',41.3538,-78.6058),('15832','PA','Driftwood','Cameron',41.349495,-78.187384),('15834','PA','Emporium','Cameron',41.520462,-78.257931),('15840','PA','Falls Creek','Jefferson',41.154257,-78.811058),('15841','PA','Force','Elk',41.259475,-78.513879),('15845','PA','Johnsonburg','Elk',41.494335,-78.681534),('15846','PA','Kersey','Elk',41.35278,-78.601023),('15847','PA','Knox Dale','Jefferson',41.086282,-79.031661),('15848','PA','Luthersburg','Clearfield',41.039272,-78.712506),('15849','PA','Penfield','Clearfield',41.184592,-78.557981),('15851','PA','Reynoldsville','Jefferson',41.095676,-78.893279),('15853','PA','Ridgway','Elk',41.410461,-78.759762),('15856','PA','Rockton','Clearfield',41.089002,-78.642092),('15857','PA','Saint Marys','Elk',41.436976,-78.543525),('15860','PA','Sigel','Jefferson',41.357643,-79.037621),('15861','PA','Sinnamahoning','Cameron',41.320842,-78.078458),('15863','PA','Stump Creek','Jefferson',41.012925,-78.836982),('15864','PA','Summerville','Jefferson',41.102233,-79.190133),('15865','PA','Sykesville','Jefferson',41.050223,-78.821273),('15866','PA','Troutville','Clearfield',41.023054,-78.788263),('15868','PA','Weedville','Elk',41.281558,-78.438043),('15870','PA','Wilcox','Elk',41.576567,-78.603481),('15901','PA','Johnstown','Cambria',40.32451,-78.915759),('15902','PA','Johnstown','Cambria',40.308813,-78.901903),('15904','PA','Johnstown','Cambria',40.289389,-78.864854),('15905','PA','Johnstown','Cambria',40.301318,-78.939684),('15906','PA','Johnstown','Cambria',40.349232,-78.939385),('15907','PA','Johnstown','Cambria',40.3259,-78.917),('15909','PA','Johnstown','Cambria',40.365041,-78.876906),('15915','PA','Johnstown','Cambria',40.3259,-78.917),('15920','PA','Armagh','Indiana',40.458229,-79.046141),('15921','PA','Beaverdale','Cambria',40.31476,-78.694799),('15922','PA','Belsano','Cambria',40.520201,-78.881968),('15923','PA','Bolivar','Westmoreland',40.37745,-79.151488),('15924','PA','Cairnbrook','Somerset',40.123113,-78.804849),('15925','PA','Cassandra','Cambria',40.409113,-78.64102),('15926','PA','Central City','Somerset',40.092907,-78.817639),('15927','PA','Colver','Cambria',40.542086,-78.788807),('15928','PA','Davidsville','Somerset',40.232463,-78.926968),('15929','PA','Dilltown','Indiana',40.465979,-79.003189),('15930','PA','Dunlo','Cambria',40.294405,-78.719791),('15931','PA','Ebensburg','Cambria',40.501538,-78.740031),('15934','PA','Elton','Cambria',40.280455,-78.803248),('15935','PA','Hollsopple','Somerset',40.205328,-78.958963),('15936','PA','Hooversville','Somerset',40.15695,-78.906237),('15937','PA','Jerome','Somerset',40.208848,-78.985072),('15938','PA','Lilly','Cambria',40.426521,-78.61909),('15940','PA','Loretto','Cambria',40.508916,-78.630879),('15942','PA','Mineral Point','Cambria',40.411273,-78.834139),('15943','PA','Nanty Glo','Cambria',40.471932,-78.837291),('15944','PA','New Florence','Westmoreland',40.373824,-79.078265),('15945','PA','Parkhill','Cambria',40.35546,-78.864091),('15946','PA','Portage','Cambria',40.377192,-78.660772),('15948','PA','Revloc','Cambria',40.49127,-78.764105),('15949','PA','Robinson','Indiana',40.398882,-79.127392),('15951','PA','Saint Michael','Cambria',40.337885,-78.771037),('15952','PA','Salix','Cambria',40.299573,-78.764052),('15953','PA','Seanor','Somerset',40.206995,-78.886184),('15954','PA','Seward','Indiana',40.416094,-79.017476),('15955','PA','Sidman','Cambria',40.319192,-78.719557),('15956','PA','South Fork','Cambria',40.361089,-78.785707),('15957','PA','Strongstown','Indiana',40.546404,-78.90128),('15958','PA','Summerhill','Cambria',40.382699,-78.735724),('15959','PA','Tire Hill','Somerset',40.2686,-78.9161),('15960','PA','Twin Rocks','Cambria',40.496063,-78.866453),('15961','PA','Vintondale','Indiana',40.471163,-78.942556),('15962','PA','Wilmore','Cambria',40.387455,-78.716545),('15963','PA','Windber','Somerset',40.230005,-78.81795),('16001','PA','Butler','Butler',40.87668,-79.911358),('16002','PA','Butler','Butler',40.822093,-79.857331),('16003','PA','Butler','Butler',40.9095,-79.9399),('16016','PA','Boyers','Butler',41.1083,-79.8991),('16017','PA','Boyers','Butler',41.1083,-79.8991),('16018','PA','Boyers','Butler',41.1083,-79.8991),('16020','PA','Boyers','Butler',41.10913,-79.908979),('16021','PA','Branchton','Butler',41.0725,-79.9858),('16022','PA','Bruin','Butler',41.05663,-79.730945),('16023','PA','Cabot','Butler',40.781885,-79.75777),('16024','PA','Callery','Butler',40.739525,-80.037674),('16025','PA','Chicora','Butler',40.946227,-79.754012),('16027','PA','Connoquenessing','Butler',40.817808,-80.013816),('16028','PA','East Brady','Clarion',40.973627,-79.622894),('16029','PA','East Butler','Butler',40.878759,-79.844714),('16030','PA','Eau Claire','Butler',41.135842,-79.798048),('16033','PA','Evans City','Butler',40.783867,-80.051121),('16034','PA','Fenelton','Butler',40.868299,-79.725403),('16035','PA','Forestville','Butler',41.108355,-80.005725),('16036','PA','Foxburg','Clarion',41.134544,-79.67467),('16037','PA','Harmony','Butler',40.822318,-80.133104),('16038','PA','Harrisville','Butler',41.161057,-79.963038),('16039','PA','Herman','Butler',40.83,-79.8113),('16040','PA','Hilliards','Butler',41.099029,-79.832253),('16041','PA','Karns City','Butler',41.010155,-79.702468),('16045','PA','Lyndora','Butler',40.849999,-79.914629),('16046','PA','Mars','Butler',40.695827,-80.037266),('16048','PA','North Washington','Butler',41.054154,-79.821429),('16049','PA','Parker','Clarion',41.100671,-79.655083),('16050','PA','Petrolia','Butler',41.030715,-79.753125),('16051','PA','Portersville','Butler',40.950106,-80.14367),('16052','PA','Prospect','Butler',40.908261,-80.059854),('16053','PA','Renfrew','Butler',40.810726,-79.978148),('16054','PA','Saint Petersburg','Clarion',41.158747,-79.654755),('16055','PA','Sarver','Butler',40.718795,-79.737131),('16056','PA','Saxonburg','Butler',40.732877,-79.834773),('16057','PA','Slippery Rock','Butler',41.033524,-80.051484),('16058','PA','Turkey City','Clarion',41.1852,-79.6136),('16059','PA','Valencia','Butler',40.696599,-79.939623),('16061','PA','West Sunbury','Butler',41.005246,-79.885854),('16063','PA','Zelienople','Butler',40.783625,-80.133844),('16066','PA','Cranberry Twp','Butler',40.702362,-80.110387),('16101','PA','New Castle','Lawrence',40.990091,-80.325033),('16102','PA','New Castle','Lawrence',40.96935,-80.386783),('16103','PA','New Castle','Lawrence',41.0036,-80.3472),('16105','PA','New Castle','Lawrence',41.038488,-80.342128),('16107','PA','New Castle','Lawrence',41.0036,-80.3472),('16108','PA','New Castle','Lawrence',41.0036,-80.3472),('16110','PA','Adamsville','Crawford',41.505249,-80.380762),('16111','PA','Atlantic','Crawford',41.518516,-80.283532),('16112','PA','Bessemer','Lawrence',40.97483,-80.494372),('16113','PA','Clark','Mercer',41.282116,-80.426817),('16114','PA','Clarks Mills','Mercer',41.406875,-80.179035),('16115','PA','Darlington','Beaver',40.801998,-80.448661),('16116','PA','Edinburg','Lawrence',41.02993,-80.453527),('16117','PA','Ellwood City','Lawrence',40.859348,-80.278139),('16120','PA','Enon Valley','Lawrence',40.890027,-80.46705),('16121','PA','Farrell','Mercer',41.211588,-80.494107),('16123','PA','Fombell','Beaver',40.808627,-80.201404),('16124','PA','Fredonia','Mercer',41.33103,-80.26104),('16125','PA','Greenville','Mercer',41.400882,-80.377979),('16127','PA','Grove City','Mercer',41.170065,-80.081584),('16130','PA','Hadley','Mercer',41.44578,-80.212378),('16131','PA','Hartstown','Crawford',41.550454,-80.372801),('16132','PA','Hillsville','Lawrence',41.010725,-80.509467),('16133','PA','Jackson Center','Mercer',41.274054,-80.12355),('16134','PA','Jamestown','Crawford',41.506808,-80.461551),('16136','PA','Koppel','Beaver',40.834956,-80.324472),('16137','PA','Mercer','Mercer',41.232938,-80.23227),('16140','PA','New Bedford','Lawrence',41.095489,-80.506704),('16141','PA','New Galilee','Lawrence',40.855871,-80.397151),('16142','PA','New Wilmington','Lawrence',41.133554,-80.337246),('16143','PA','Pulaski','Lawrence',41.106362,-80.461752),('16145','PA','Sandy Lake','Mercer',41.385996,-80.096588),('16146','PA','Sharon','Mercer',41.232307,-80.499727),('16148','PA','Hermitage','Mercer',41.232421,-80.450445),('16150','PA','Sharpsville','Mercer',41.27298,-80.461309),('16151','PA','Sheakleyville','Mercer',41.442783,-80.207952),('16153','PA','Stoneboro','Mercer',41.333393,-80.096201),('16154','PA','Transfer','Mercer',41.330142,-80.427748),('16155','PA','Villa Maria','Lawrence',41.073666,-80.507594),('16156','PA','Volant','Lawrence',41.103195,-80.231944),('16157','PA','Wampum','Lawrence',40.889587,-80.340743),('16159','PA','West Middlesex','Mercer',41.169027,-80.456489),('16160','PA','West Pittsburg','Lawrence',40.930897,-80.364482),('16161','PA','Wheatland','Mercer',41.201107,-80.494677),('16172','PA','New Wilmington','Lawrence',41.1183,-80.3291),('16201','PA','Kittanning','Armstrong',40.809646,-79.498474),('16210','PA','Adrian','Armstrong',40.893657,-79.502503),('16211','PA','Beyer','Indiana',40.78633,-79.20067),('16212','PA','Cadogan','Armstrong',40.753038,-79.582802),('16213','PA','Callensburg','Clarion',41.126214,-79.55704),('16214','PA','Clarion','Clarion',41.198862,-79.373479),('16215','PA','Kittanning','Armstrong',40.8163,-79.5222),('16217','PA','Cooksburg','Forest',41.32662,-79.192944),('16218','PA','Cowansville','Armstrong',40.923952,-79.591268),('16220','PA','Crown','Clarion',41.3897,-79.2711),('16221','PA','Curllsville','Clarion',41.0986,-79.4469),('16222','PA','Dayton','Armstrong',40.861199,-79.25179),('16223','PA','Distant','Armstrong',40.969045,-79.358951),('16224','PA','Fairmount City','Clarion',41.052196,-79.291312),('16225','PA','Fisher','Clarion',41.2646,-79.2513),('16226','PA','Ford City','Armstrong',40.738934,-79.5122),('16228','PA','Ford Cliff','Armstrong',40.760011,-79.536267),('16229','PA','Freeport','Armstrong',40.701433,-79.667385),('16230','PA','Hawthorn','Clarion',41.020642,-79.274137),('16232','PA','Knox','Clarion',41.225809,-79.547293),('16233','PA','Leeper','Clarion',41.361409,-79.26319),('16234','PA','Limestone','Clarion',41.127485,-79.326954),('16235','PA','Lucinda','Clarion',41.322674,-79.35142),('16236','PA','Mc Grann','Armstrong',40.781134,-79.522974),('16238','PA','Manorville','Armstrong',40.787837,-79.520848),('16239','PA','Marienville','Forest',41.480246,-79.128281),('16240','PA','Mayport','Clarion',41.032145,-79.222248),('16242','PA','New Bethlehem','Clarion',41.010805,-79.352538),('16244','PA','Nu Mine','Armstrong',40.795197,-79.279233),('16245','PA','Oak Ridge','Armstrong',41.007807,-79.297349),('16246','PA','Plumville','Indiana',40.791017,-79.182425),('16248','PA','Rimersburg','Clarion',41.037373,-79.505561),('16249','PA','Rural Valley','Armstrong',40.775179,-79.311653),('16250','PA','Sagamore','Armstrong',40.776469,-79.231862),('16253','PA','Seminole','Armstrong',40.954226,-79.342764),('16254','PA','Shippenville','Clarion',41.249634,-79.458827),('16255','PA','Sligo','Clarion',41.117399,-79.468252),('16256','PA','Smicksburg','Indiana',40.866227,-79.120853),('16257','PA','Snydersburg','Clarion',41.3327,-79.3558),('16258','PA','Strattanville','Clarion',41.221224,-79.304374),('16259','PA','Templeton','Armstrong',40.916198,-79.457647),('16260','PA','Vowinckel','Clarion',41.400915,-79.224512),('16261','PA','Widnoon','Armstrong',40.9611,-79.4675),('16262','PA','Worthington','Armstrong',40.837789,-79.646993),('16263','PA','Yatesboro','Armstrong',40.800387,-79.333122),('16301','PA','Oil City','Venango',41.441419,-79.682115),('16311','PA','Carlton','Mercer',41.462085,-80.022994),('16312','PA','Chandlers Valley','Warren',41.933131,-79.303899),('16313','PA','Clarendon','Warren',41.76652,-79.105149),('16314','PA','Cochranton','Crawford',41.521608,-80.064999),('16316','PA','Conneaut Lake','Crawford',41.609241,-80.295856),('16317','PA','Cooperstown','Venango',41.524123,-79.860597),('16319','PA','Cranberry','Venango',41.32022,-79.61952),('16321','PA','East Hickory','Forest',41.575336,-79.401701),('16322','PA','Endeavor','Forest',41.597126,-79.373567),('16323','PA','Franklin','Venango',41.407566,-79.839111),('16326','PA','Fryburg','Clarion',41.36148,-79.432101),('16327','PA','Guys Mills','Crawford',41.62931,-79.962027),('16328','PA','Hydetown','Crawford',41.651449,-79.724367),('16329','PA','Irvine','Warren',41.81941,-79.2718),('16331','PA','Kossuth','Clarion',41.294832,-79.569717),('16332','PA','Lickingville','Clarion',41.370402,-79.355174),('16333','PA','Ludlow','Mc Kean',41.72506,-78.942935),('16334','PA','Marble','Clarion',41.315003,-79.446115),('16335','PA','Meadville','Crawford',41.632705,-80.149194),('16340','PA','Pittsfield','Warren',41.829045,-79.422833),('16341','PA','Pleasantville','Venango',41.572682,-79.539792),('16342','PA','Polk','Venango',41.347614,-79.922404),('16343','PA','Reno','Venango',41.411519,-79.75274),('16344','PA','Rouseville','Venango',41.471431,-79.689568),('16345','PA','Russell','Warren',41.94867,-79.1249),('16346','PA','Seneca','Venango',41.37882,-79.685354),('16347','PA','Sheffield','Warren',41.657402,-79.039704),('16350','PA','Sugar Grove','Warren',41.97685,-79.33014),('16351','PA','Tidioute','Warren',41.67988,-79.384253),('16352','PA','Tiona','Warren',41.770736,-79.059266),('16353','PA','Tionesta','Forest',41.492112,-79.389517),('16354','PA','Titusville','Crawford',41.623178,-79.693714),('16360','PA','Townville','Crawford',41.684871,-79.886578),('16361','PA','Tylersburg','Clarion',41.38389,-79.345873),('16362','PA','Utica','Venango',41.447296,-79.963457),('16364','PA','Venus','Venango',41.369761,-79.517173),('16365','PA','Warren','Warren',41.851623,-79.153873),('16366','PA','Warren','Warren',41.8467,-79.1463),('16367','PA','Warren','Warren',41.8467,-79.1463),('16368','PA','Warren','Warren',41.8391,-79.2686),('16369','PA','Warren','Warren',41.8391,-79.2686),('16370','PA','West Hickory','Forest',41.573424,-79.422645),('16371','PA','Youngsville','Warren',41.862085,-79.320928),('16372','PA','Clintonville','Venango',41.19886,-79.871567),('16373','PA','Emlenton','Venango',41.191861,-79.69657),('16374','PA','Kennerdell','Venango',41.263208,-79.815345),('16375','PA','Lamartine','Clarion',41.2225,-79.6341),('16388','PA','Meadville','Crawford',41.637,-80.1553),('16401','PA','Albion','Erie',41.888846,-80.381575),('16402','PA','Bear Lake','Warren',41.961661,-79.469604),('16403','PA','Cambridge Springs','Crawford',41.800778,-80.03653),('16404','PA','Centerville','Crawford',41.727006,-79.789388),('16405','PA','Columbus','Warren',41.943266,-79.555212),('16406','PA','Conneautville','Crawford',41.750339,-80.359513),('16407','PA','Corry','Erie',41.917733,-79.656832),('16410','PA','Cranesville','Erie',41.92304,-80.329124),('16411','PA','East Springfield','Erie',41.982724,-80.429933),('16412','PA','Edinboro','Erie',41.874549,-80.149747),('16413','PA','Elgin','Erie',41.903,-79.7438),('16415','PA','Fairview','Erie',42.037521,-80.230321),('16416','PA','Garland','Warren',41.81103,-79.45377),('16417','PA','Girard','Erie',41.986396,-80.314491),('16420','PA','Grand Valley','Warren',41.701177,-79.546731),('16421','PA','Harborcreek','Erie',42.169486,-79.939858),('16422','PA','Harmonsburg','Crawford',41.660527,-80.31678),('16423','PA','Lake City','Erie',42.0211,-80.340132),('16424','PA','Linesville','Crawford',41.653388,-80.448385),('16426','PA','Mc Kean','Erie',41.99355,-80.147621),('16427','PA','Mill Village','Erie',41.876005,-79.96958),('16428','PA','North East','Erie',42.200485,-79.826229),('16430','PA','North Springfield','Erie',42.0028,-80.429),('16432','PA','Riceville','Crawford',41.7775,-79.803),('16433','PA','Saegertown','Crawford',41.730074,-80.149183),('16434','PA','Spartansburg','Crawford',41.79672,-79.668697),('16435','PA','Springboro','Crawford',41.818275,-80.381403),('16436','PA','Spring Creek','Warren',41.86017,-79.490576),('16438','PA','Union City','Erie',41.875364,-79.842382),('16440','PA','Venango','Crawford',41.782126,-80.115318),('16441','PA','Waterford','Erie',41.945169,-79.985133),('16442','PA','Wattsburg','Erie',42.029551,-79.825232),('16443','PA','West Springfield','Erie',41.940202,-80.471311),('16444','PA','Edinboro','Erie',41.872063,-80.125808),('16475','PA','Albion','Erie',41.8904,-80.366),('16501','PA','Erie','Erie',42.123049,-80.08417),('16502','PA','Erie','Erie',42.111822,-80.100503),('16503','PA','Erie','Erie',42.12772,-80.063836),('16504','PA','Erie','Erie',42.110235,-80.051857),('16505','PA','Erie','Erie',42.102226,-80.151351),('16506','PA','Erie','Erie',42.072618,-80.145131),('16507','PA','Erie','Erie',42.132829,-80.084334),('16508','PA','Erie','Erie',42.098579,-80.091997),('16509','PA','Erie','Erie',42.070152,-80.06863),('16510','PA','Erie','Erie',42.124609,-79.999015),('16511','PA','Erie','Erie',42.157363,-80.012913),('16512','PA','Erie','Erie',42.1185,-80.0229),('16514','PA','Erie','Erie',42.1185,-80.0229),('16515','PA','Erie','Erie',42.1185,-80.0229),('16522','PA','Erie','Erie',42.1185,-80.0229),('16530','PA','Erie','Erie',42.1185,-80.0229),('16531','PA','Erie','Erie',42.1185,-80.0229),('16532','PA','Erie','Erie',42.1185,-80.0229),('16533','PA','Erie','Erie',42.1185,-80.0229),('16534','PA','Erie','Erie',42.1185,-80.0229),('16538','PA','Erie','Erie',42.1185,-80.0229),('16541','PA','Erie','Erie',42.1185,-80.0229),('16544','PA','Erie','Erie',42.1185,-80.0229),('16546','PA','Erie','Erie',42.105366,-80.053864),('16550','PA','Erie','Erie',42.1185,-80.0229),('16553','PA','Erie','Erie',42.1185,-80.0229),('16554','PA','Erie','Erie',42.1185,-80.0229),('16563','PA','Erie','Erie',42.117345,-79.983397),('16565','PA','Erie','Erie',42.0674,-80.0999),('16601','PA','Altoona','Blair',40.526481,-78.398361),('16602','PA','Altoona','Blair',40.502135,-78.39115),('16603','PA','Altoona','Blair',40.5154,-78.4012),('16611','PA','Alexandria','Huntingdon',40.559522,-78.098295),('16613','PA','Ashville','Cambria',40.556914,-78.535584),('16616','PA','Beccaria','Clearfield',40.767547,-78.440079),('16617','PA','Bellwood','Blair',40.601751,-78.333397),('16619','PA','Blandburg','Cambria',40.680524,-78.4177),('16620','PA','Brisbin','Clearfield',40.837794,-78.35223),('16621','PA','Broad Top','Huntingdon',40.211027,-78.135142),('16622','PA','Calvin','Huntingdon',40.322947,-78.059949),('16623','PA','Cassville','Huntingdon',40.275171,-78.044163),('16624','PA','Chest Springs','Cambria',40.577801,-78.607889),('16625','PA','Claysburg','Blair',40.282411,-78.496517),('16627','PA','Coalport','Clearfield',40.755193,-78.512442),('16629','PA','Coupon','Cambria',40.534,-78.5143),('16630','PA','Cresson','Cambria',40.4639,-78.585627),('16631','PA','Curryville','Blair',40.273484,-78.34528),('16633','PA','Defiance','Bedford',40.159025,-78.233022),('16634','PA','Dudley','Huntingdon',40.210019,-78.176112),('16635','PA','Duncansville','Blair',40.422977,-78.449257),('16636','PA','Dysart','Cambria',40.613912,-78.515835),('16637','PA','East Freedom','Blair',40.339811,-78.445422),('16638','PA','Entriken','Huntingdon',40.335193,-78.203989),('16639','PA','Fallentimber','Cambria',40.691572,-78.46177),('16640','PA','Flinton','Cambria',40.70247,-78.562627),('16641','PA','Gallitzin','Cambria',40.485984,-78.552655),('16644','PA','Glasgow','Cambria',40.7075,-78.4461),('16645','PA','Glen Hope','Clearfield',40.798958,-78.500238),('16646','PA','Hastings','Cambria',40.668951,-78.711219),('16647','PA','Hesston','Huntingdon',40.408071,-78.101937),('16648','PA','Hollidaysburg','Blair',40.436761,-78.375552),('16650','PA','Hopewell','Bedford',40.116375,-78.275206),('16651','PA','Houtzdale','Clearfield',40.82936,-78.364024),('16652','PA','Huntingdon','Huntingdon',40.502539,-77.982057),('16654','PA','Huntingdon','Huntingdon',40.5696,-77.9088),('16655','PA','Imler','Bedford',40.23585,-78.535187),('16656','PA','Irvona','Clearfield',40.791536,-78.559129),('16657','PA','James Creek','Huntingdon',40.331495,-78.18282),('16659','PA','Loysburg','Bedford',40.160171,-78.379238),('16660','PA','Mc Connellstown','Huntingdon',40.4546,-78.0835),('16661','PA','Madera','Clearfield',40.831088,-78.460928),('16662','PA','Martinsburg','Blair',40.304057,-78.3193),('16663','PA','Morann','Clearfield',40.789079,-78.375007),('16664','PA','New Enterprise','Bedford',40.179951,-78.42228),('16665','PA','Newry','Blair',40.391825,-78.43553),('16666','PA','Osceola Mills','Clearfield',40.854763,-78.293123),('16667','PA','Osterburg','Bedford',40.174285,-78.528519),('16668','PA','Patton','Cambria',40.634845,-78.62935),('16669','PA','Petersburg','Huntingdon',40.643589,-77.918945),('16670','PA','Queen','Bedford',40.262809,-78.508048),('16671','PA','Ramey','Clearfield',40.800197,-78.401182),('16672','PA','Riddlesburg','Bedford',40.161669,-78.24976),('16673','PA','Roaring Spring','Blair',40.320199,-78.400128),('16674','PA','Robertsdale','Huntingdon',40.199979,-78.090817),('16675','PA','Saint Boniface','Cambria',40.6644,-78.7131),('16677','PA','Sandy Ridge','Centre',40.811918,-78.23228),('16678','PA','Saxton','Bedford',40.217868,-78.24512),('16679','PA','Six Mile Run','Bedford',40.155253,-78.194384),('16680','PA','Smithmill','Clearfield',40.753506,-78.404636),('16681','PA','Smokerun','Clearfield',40.792825,-78.435597),('16682','PA','Sproul','Blair',40.269581,-78.460236),('16683','PA','Spruce Creek','Huntingdon',40.64057,-78.094386),('16684','PA','Tipton','Blair',40.6358,-78.2961),('16685','PA','Todd','Huntingdon',40.283719,-78.068733),('16686','PA','Tyrone','Blair',40.667916,-78.242113),('16689','PA','Waterfall','Fulton',40.09655,-78.091116),('16691','PA','Wells Tannery','Fulton',40.075648,-78.144142),('16692','PA','Westover','Clearfield',40.750827,-78.710802),('16693','PA','Williamsburg','Blair',40.457561,-78.217965),('16694','PA','Wood','Bedford',40.166267,-78.141708),('16695','PA','Woodbury','Bedford',40.211464,-78.371368),('16698','PA','Houtzdale','Clearfield',40.849,-78.377),('16699','PA','Cresson','Cambria',40.447211,-78.560505),('16701','PA','Bradford','Mc Kean',41.93734,-78.67867),('16720','PA','Austin','Potter',41.584111,-78.049157),('16724','PA','Crosby','Mc Kean',41.747066,-78.380282),('16725','PA','Custer City','Mc Kean',41.906014,-78.650675),('16726','PA','Cyclone','Mc Kean',41.81459,-78.572463),('16727','PA','Derrick City','Mc Kean',41.976866,-78.534481),('16728','PA','De Young','Elk',41.568802,-78.922438),('16729','PA','Duke Center','Mc Kean',41.962654,-78.484527),('16730','PA','East Smethport','Mc Kean',41.817813,-78.422813),('16731','PA','Eldred','Mc Kean',41.955081,-78.38717),('16732','PA','Gifford','Mc Kean',41.850891,-78.605331),('16733','PA','Hazel Hurst','Mc Kean',41.70655,-78.588184),('16734','PA','James City','Elk',41.61909,-78.838034),('16735','PA','Kane','Mc Kean',41.654568,-78.807635),('16738','PA','Lewis Run','Mc Kean',41.817405,-78.712012),('16740','PA','Mount Jewett','Mc Kean',41.722558,-78.623562),('16743','PA','Port Allegany','Mc Kean',41.803167,-78.269425),('16744','PA','Rew','Mc Kean',41.867144,-78.572209),('16745','PA','Rixford','Mc Kean',41.924507,-78.498412),('16746','PA','Roulette','Potter',41.798244,-78.145337),('16748','PA','Shinglehouse','Potter',41.949677,-78.160886),('16749','PA','Smethport','Mc Kean',41.801648,-78.44403),('16750','PA','Turtlepoint','Mc Kean',41.875238,-78.327324),('16801','PA','State College','Centre',40.791616,-77.848972),('16802','PA','University Park','Centre',40.801592,-77.859912),('16803','PA','State College','Centre',40.808657,-77.891105),('16804','PA','State College','Centre',40.7915,-77.8604),('16805','PA','State College','Centre',40.7915,-77.8604),('16820','PA','Aaronsburg','Centre',40.891511,-77.431994),('16821','PA','Allport','Clearfield',40.966539,-78.204949),('16822','PA','Beech Creek','Clinton',41.134988,-77.686838),('16823','PA','Bellefonte','Centre',40.910883,-77.77219),('16825','PA','Bigler','Clearfield',40.985012,-78.310295),('16826','PA','Blanchard','Centre',41.065187,-77.597915),('16827','PA','Boalsburg','Centre',40.779077,-77.77684),('16828','PA','Centre Hall','Centre',40.828595,-77.68561),('16829','PA','Clarence','Centre',41.074311,-77.904509),('16830','PA','Clearfield','Clearfield',41.033939,-78.433306),('16832','PA','Coburn','Centre',40.859942,-77.462127),('16833','PA','Curwensville','Clearfield',40.94172,-78.559132),('16834','PA','Drifting','Clearfield',41.035569,-78.107327),('16835','PA','Fleming','Centre',40.907086,-77.876245),('16836','PA','Frenchville','Clearfield',41.12745,-78.26442),('16837','PA','Glen Richey','Clearfield',40.94544,-78.474451),('16838','PA','Grampian','Clearfield',40.984445,-78.626528),('16839','PA','Grassflat','Clearfield',41.003445,-78.113073),('16840','PA','Hawk Run','Clearfield',40.925216,-78.204199),('16841','PA','Howard','Centre',41.032577,-77.670979),('16843','PA','Hyde','Clearfield',41.001076,-78.464792),('16844','PA','Julian','Centre',40.897525,-77.917135),('16845','PA','Karthaus','Clearfield',41.145638,-78.078532),('16847','PA','Kylertown','Clearfield',40.994364,-78.168098),('16848','PA','Lamar','Clinton',41.012408,-77.536227),('16849','PA','Lanse','Clearfield',40.967008,-78.118626),('16850','PA','Lecontes Mills','Clearfield',41.083,-78.2836),('16851','PA','Lemont','Centre',40.815742,-77.810632),('16852','PA','Madisonburg','Centre',40.93107,-77.521679),('16853','PA','Milesburg','Centre',40.940786,-77.785807),('16854','PA','Millheim','Centre',40.891717,-77.475218),('16855','PA','Mineral Springs','Clearfield',40.997587,-78.372961),('16856','PA','Mingoville','Centre',40.929263,-77.645819),('16858','PA','Morrisdale','Clearfield',40.980907,-78.206073),('16859','PA','Moshannon','Centre',41.026092,-78.017223),('16860','PA','Munson','Clearfield',40.954563,-78.170484),('16861','PA','New Millport','Clearfield',40.876576,-78.532317),('16863','PA','Olanta','Clearfield',40.913115,-78.489497),('16864','PA','Orviston','Centre',41.105537,-77.752731),('16865','PA','Pennsylvania Furnace','Centre',40.709977,-77.972309),('16866','PA','Philipsburg','Centre',40.89359,-78.202234),('16868','PA','Pine Grove Mills','Centre',40.73387,-77.884264),('16870','PA','Port Matilda','Centre',40.798497,-78.024239),('16871','PA','Pottersdale','Clearfield',41.186789,-78.038746),('16872','PA','Rebersburg','Centre',40.96026,-77.375787),('16873','PA','Shawville','Clearfield',41.0691,-78.3583),('16874','PA','Snow Shoe','Centre',41.016283,-77.948242),('16875','PA','Spring Mills','Centre',40.833519,-77.575471),('16876','PA','Wallaceton','Clearfield',40.960655,-78.290216),('16877','PA','Warriors Mark','Huntingdon',40.730665,-78.070367),('16878','PA','West Decatur','Clearfield',40.943798,-78.308546),('16879','PA','Winburne','Clearfield',40.969884,-78.150238),('16881','PA','Woodland','Clearfield',41.017287,-78.324731),('16882','PA','Woodward','Centre',40.912948,-77.334578),('16901','PA','Wellsboro','Tioga',41.735958,-77.31945),('16910','PA','Alba','Bradford',41.705,-76.8286),('16911','PA','Arnot','Tioga',41.661004,-77.124422),('16912','PA','Blossburg','Tioga',41.674156,-77.051351),('16914','PA','Columbia Cross Roads','Bradford',41.861257,-76.775623),('16915','PA','Coudersport','Potter',41.796526,-77.988712),('16917','PA','Covington','Tioga',41.740071,-77.065682),('16918','PA','Cowanesque','Tioga',41.932815,-77.498051),('16920','PA','Elkland','Tioga',41.9868,-77.303721),('16921','PA','Gaines','Tioga',41.724116,-77.556264),('16922','PA','Galeton','Potter',41.70165,-77.674526),('16923','PA','Genesee','Potter',41.950526,-77.870604),('16925','PA','Gillett','Bradford',41.948502,-76.783646),('16926','PA','Granville Summit','Bradford',41.718771,-76.705339),('16927','PA','Harrison Valley','Potter',41.958271,-77.674167),('16928','PA','Knoxville','Tioga',41.954894,-77.432426),('16929','PA','Lawrenceville','Tioga',41.983956,-77.133029),('16930','PA','Liberty','Tioga',41.549289,-77.149203),('16932','PA','Mainesburg','Tioga',41.795737,-76.941602),('16933','PA','Mansfield','Tioga',41.811388,-77.069024),('16935','PA','Middlebury Center','Tioga',41.872746,-77.321806),('16936','PA','Millerton','Tioga',41.952861,-76.946633),('16937','PA','Mills','Potter',41.968273,-77.718002),('16938','PA','Morris','Tioga',41.564007,-77.336483),('16939','PA','Morris Run','Tioga',41.678718,-77.017711),('16940','PA','Nelson','Tioga',41.981056,-77.238947),('16941','PA','Genesee','Potter',41.99309,-77.763792),('16942','PA','Osceola','Tioga',41.970139,-77.342771),('16943','PA','Sabinsville','Tioga',41.846801,-77.594509),('16945','PA','Sylvania','Bradford',41.805,-76.8572),('16946','PA','Tioga','Tioga',41.916822,-77.135962),('16947','PA','Troy','Bradford',41.773816,-76.791731),('16948','PA','Ulysses','Potter',41.875113,-77.759264),('16950','PA','Westfield','Tioga',41.899908,-77.531951),('17001','PA','Camp Hill','Cumberland',40.2397,-76.9202),('17002','PA','Allensville','Mifflin',40.522151,-77.826932),('17003','PA','Annville','Lebanon',40.367081,-76.549888),('17004','PA','Belleville','Mifflin',40.60141,-77.730866),('17005','PA','Berrysburg','Dauphin',40.602506,-76.811308),('17006','PA','Blain','Perry',40.311681,-77.52848),('17007','PA','Boiling Springs','Cumberland',40.144779,-77.12266),('17008','PA','Bowmansdale','Cumberland',40.2322,-77.0222),('17009','PA','Burnham','Mifflin',40.63691,-77.566017),('17010','PA','Campbelltown','Lebanon',40.280149,-76.5806),('17011','PA','Camp Hill','Cumberland',40.237291,-76.93092),('17012','PA','Camp Hill','Cumberland',40.2397,-76.9202),('17013','PA','Carlisle','Cumberland',40.214874,-77.190397),('17014','PA','Cocolamus','Juniata',40.6571,-77.1036),('17015','PA','Carlisle','Cumberland',40.186879,-77.209811),('17016','PA','Cornwall','Lebanon',40.274452,-76.402906),('17017','PA','Dalmatia','Northumberland',40.64276,-76.875841),('17018','PA','Dauphin','Dauphin',40.379766,-76.935634),('17019','PA','Dillsburg','York',40.101705,-77.02772),('17020','PA','Duncannon','Perry',40.407283,-77.029196),('17021','PA','East Waterford','Juniata',40.346629,-77.638712),('17022','PA','Elizabethtown','Lancaster',40.160624,-76.609156),('17023','PA','Elizabethville','Dauphin',40.560751,-76.818272),('17024','PA','Elliottsburg','Perry',40.413065,-77.301518),('17025','PA','Enola','Cumberland',40.289975,-76.949824),('17026','PA','Fredericksburg','Lebanon',40.450618,-76.430441),('17027','PA','Grantham','Cumberland',40.155998,-76.995461),('17028','PA','Grantville','Dauphin',40.388698,-76.649039),('17029','PA','Granville','Mifflin',40.550615,-77.618043),('17030','PA','Gratz','Dauphin',40.610821,-76.719412),('17032','PA','Halifax','Dauphin',40.474186,-76.879331),('17033','PA','Hershey','Dauphin',40.278911,-76.643731),('17034','PA','Highspire','Dauphin',40.207616,-76.784718),('17035','PA','Honey Grove','Juniata',40.423906,-77.585601),('17036','PA','Hummelstown','Dauphin',40.270564,-76.705209),('17037','PA','Ickesburg','Perry',40.436768,-77.406617),('17038','PA','Jonestown','Lebanon',40.442454,-76.517397),('17039','PA','Kleinfeltersville','Lebanon',40.292709,-76.240707),('17040','PA','Landisburg','Perry',40.337124,-77.310232),('17041','PA','Lawn','Lebanon',40.219207,-76.540103),('17042','PA','Lebanon','Lebanon',40.322081,-76.425625),('17043','PA','Lemoyne','Cumberland',40.24676,-76.898438),('17044','PA','Lewistown','Mifflin',40.592192,-77.578193),('17045','PA','Liverpool','Perry',40.587926,-76.993005),('17046','PA','Lebanon','Lebanon',40.357156,-76.425466),('17047','PA','Loysville','Perry',40.371392,-77.412213),('17048','PA','Lykens','Dauphin',40.586086,-76.717303),('17049','PA','Mc Alisterville','Juniata',40.647144,-77.238573),('17050','PA','Mechanicsburg','Cumberland',40.246148,-77.00638),('17051','PA','Mc Veytown','Mifflin',40.468132,-77.762573),('17052','PA','Mapleton Depot','Huntingdon',40.338095,-77.978223),('17053','PA','Marysville','Perry',40.339321,-76.961096),('17054','PA','Mattawana','Mifflin',40.4961,-77.7297),('17055','PA','Mechanicsburg','Cumberland',40.188363,-76.99644),('17056','PA','Mexico','Juniata',40.536301,-77.353985),('17057','PA','Middletown','Dauphin',40.20133,-76.735708),('17058','PA','Mifflin','Juniata',40.518511,-77.496456),('17059','PA','Mifflintown','Juniata',40.582006,-77.368905),('17060','PA','Mill Creek','Huntingdon',40.453439,-77.91111),('17061','PA','Millersburg','Dauphin',40.549853,-76.935592),('17062','PA','Millerstown','Perry',40.551574,-77.155065),('17063','PA','Milroy','Mifflin',40.735326,-77.531407),('17064','PA','Mount Gretna','Lebanon',40.247494,-76.469152),('17065','PA','Mount Holly Springs','Cumberland',40.117164,-77.190707),('17066','PA','Mount Union','Huntingdon',40.373302,-77.871923),('17067','PA','Myerstown','Lebanon',40.390423,-76.315048),('17068','PA','New Bloomfield','Perry',40.41252,-77.174683),('17069','PA','New Buffalo','Perry',40.45445,-76.970172),('17070','PA','New Cumberland','Cumberland',40.220046,-76.869409),('17071','PA','New Germantown','Perry',40.30487,-77.576959),('17072','PA','New Kingstown','Cumberland',40.232848,-77.08145),('17073','PA','Newmanstown','Lebanon',40.310455,-76.251734),('17074','PA','Newport','Perry',40.478901,-77.148585),('17075','PA','Newton Hamilton','Mifflin',40.393866,-77.835285),('17076','PA','Oakland Mills','Juniata',40.617442,-77.311663),('17077','PA','Ono','Lebanon',40.403009,-76.535937),('17078','PA','Palmyra','Lebanon',40.301742,-76.591516),('17080','PA','Pillow','Dauphin',40.640453,-76.803031),('17081','PA','Plainfield','Cumberland',40.202339,-77.28661),('17082','PA','Port Royal','Juniata',40.507727,-77.419961),('17083','PA','Quentin','Lebanon',40.277538,-76.438654),('17084','PA','Reedsville','Mifflin',40.6742,-77.603666),('17085','PA','Rexmont','Lebanon',40.2772,-76.3827),('17086','PA','Richfield','Juniata',40.685241,-77.117791),('17087','PA','Richland','Lebanon',40.380774,-76.258279),('17088','PA','Schaefferstown','Lebanon',40.297942,-76.296908),('17089','PA','Camp Hill','Cumberland',40.2397,-76.9202),('17090','PA','Shermans Dale','Perry',40.329303,-77.176321),('17091','PA','Lebanon','Cumberland',40.2397,-76.9205),('17093','PA','Summerdale','Cumberland',40.309915,-76.929276),('17094','PA','Thompsontown','Juniata',40.574419,-77.231713),('17097','PA','Wiconisco','Dauphin',40.574291,-76.686925),('17098','PA','Williamstown','Dauphin',40.582402,-76.62219),('17099','PA','Yeagertown','Mifflin',40.640585,-77.57772),('17101','PA','Harrisburg','Dauphin',40.261549,-76.882739),('17102','PA','Harrisburg','Dauphin',40.272686,-76.890627),('17103','PA','Harrisburg','Dauphin',40.275016,-76.860704),('17104','PA','Harrisburg','Dauphin',40.258413,-76.859122),('17105','PA','Harrisburg','Dauphin',40.2846,-76.8736),('17106','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17107','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17108','PA','Harrisburg','Dauphin',40.2615,-76.8831),('17109','PA','Harrisburg','Dauphin',40.289275,-76.828414),('17110','PA','Harrisburg','Dauphin',40.304755,-76.885851),('17111','PA','Harrisburg','Dauphin',40.26396,-76.801984),('17112','PA','Harrisburg','Dauphin',40.342065,-76.779758),('17113','PA','Harrisburg','Dauphin',40.232535,-76.825285),('17120','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17121','PA','Harrisburg','Dauphin',40.3136,-76.875),('17122','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17123','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17124','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17125','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17126','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17127','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17128','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17129','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17130','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17140','PA','Harrisburg','Dauphin',40.2315,-76.8195),('17177','PA','Harrisburg','Dauphin',40.2959,-76.8553),('17201','PA','Chambersburg','Franklin',39.950497,-77.654769),('17202','PA','Chambersburg','Franklin',39.910528,-77.652277),('17210','PA','Amberson','Franklin',40.197285,-77.648151),('17211','PA','Artemas','Bedford',39.745154,-78.419417),('17212','PA','Big Cove Tannery','Fulton',39.818162,-78.072077),('17213','PA','Blairs Mills','Huntingdon',40.255665,-77.764753),('17214','PA','Blue Ridge Summit','Franklin',39.729918,-77.469341),('17215','PA','Burnt Cabins','Fulton',40.089822,-77.884813),('17217','PA','Concord','Franklin',40.242968,-77.71086),('17219','PA','Doylesburg','Franklin',40.225206,-77.695685),('17220','PA','Dry Run','Franklin',40.178881,-77.746677),('17221','PA','Fannettsburg','Franklin',40.068125,-77.816484),('17222','PA','Fayetteville','Franklin',39.889395,-77.519562),('17223','PA','Fort Littleton','Fulton',40.065385,-77.957701),('17224','PA','Fort Loudon','Franklin',39.954079,-77.906144),('17225','PA','Greencastle','Franklin',39.791361,-77.75161),('17228','PA','Harrisonville','Fulton',39.995429,-78.093322),('17229','PA','Hustontown','Fulton',40.07028,-78.022998),('17231','PA','Lemasters','Franklin',39.8611,-77.8597),('17232','PA','Lurgan','Franklin',40.1046,-77.6399),('17233','PA','Mc Connellsburg','Fulton',39.94556,-77.995631),('17235','PA','Marion','Franklin',39.857328,-77.697619),('17236','PA','Mercersburg','Franklin',39.799688,-77.910053),('17237','PA','Mont Alto','Franklin',39.841568,-77.551631),('17238','PA','Needmore','Fulton',39.853914,-78.13746),('17239','PA','Neelyton','Huntingdon',40.111597,-77.85325),('17240','PA','Newburg','Cumberland',40.146199,-77.561567),('17241','PA','Newville','Cumberland',40.178636,-77.412223),('17243','PA','Orbisonia','Huntingdon',40.257231,-77.857031),('17244','PA','Orrstown','Franklin',40.080568,-77.638849),('17246','PA','Pleasant Hall','Franklin',40.054961,-77.661422),('17247','PA','Quincy','Franklin',39.799652,-77.578964),('17249','PA','Rockhill Furnace','Huntingdon',40.24179,-77.900091),('17250','PA','Rouzerville','Franklin',39.73738,-77.524655),('17251','PA','Roxbury','Franklin',40.132472,-77.675266),('17252','PA','Saint Thomas','Franklin',39.91479,-77.814679),('17253','PA','Saltillo','Huntingdon',40.212399,-78.006445),('17254','PA','Scotland','Franklin',39.969017,-77.593042),('17255','PA','Shade Gap','Huntingdon',40.154688,-77.861623),('17256','PA','Shady Grove','Franklin',39.782579,-77.677057),('17257','PA','Shippensburg','Cumberland',40.057001,-77.502853),('17260','PA','Shirleysburg','Huntingdon',40.296381,-77.893721),('17261','PA','South Mountain','Franklin',39.849498,-77.50274),('17262','PA','Spring Run','Franklin',40.144998,-77.740213),('17263','PA','State Line','Franklin',39.724086,-77.721205),('17264','PA','Three Springs','Huntingdon',40.190893,-77.980779),('17265','PA','Upperstrasburg','Franklin',40.032179,-77.774993),('17266','PA','Walnut Bottom','Cumberland',40.085634,-77.409368),('17267','PA','Warfordsburg','Fulton',39.79782,-78.244012),('17268','PA','Waynesboro','Franklin',39.766067,-77.572842),('17270','PA','Williamson','Franklin',39.85261,-77.797853),('17271','PA','Willow Hill','Franklin',40.101239,-77.808082),('17272','PA','Zullinger','Franklin',39.771235,-77.621316),('17301','PA','Abbottstown','Adams',39.889428,-76.983004),('17302','PA','Airville','York',39.810179,-76.40271),('17303','PA','Arendtsville','Adams',39.923,-77.2988),('17304','PA','Aspers','Adams',39.975161,-77.225315),('17306','PA','Bendersville','Adams',39.983183,-77.249454),('17307','PA','Biglerville','Adams',39.935307,-77.298278),('17309','PA','Brogue','York',39.868086,-76.444144),('17310','PA','Cashtown','Adams',39.8844,-77.3597),('17311','PA','Codorus','York',39.817229,-76.842194),('17312','PA','Craley','York',39.9475,-76.5108),('17313','PA','Dallastown','York',39.899697,-76.645047),('17314','PA','Delta','York',39.749246,-76.331646),('17315','PA','Dover','York',40.012062,-76.857213),('17316','PA','East Berlin','Adams',39.958421,-77.005186),('17317','PA','East Prospect','York',39.971059,-76.522107),('17318','PA','Emigsville','York',40.018043,-76.72904),('17319','PA','Etters','York',40.154136,-76.790406),('17320','PA','Fairfield','Adams',39.757727,-77.377247),('17321','PA','Fawn Grove','York',39.74967,-76.44436),('17322','PA','Felton','York',39.852764,-76.545318),('17323','PA','Franklintown','York',40.0766,-77.0286),('17324','PA','Gardners','Cumberland',40.030991,-77.218036),('17325','PA','Gettysburg','Adams',39.830096,-77.223639),('17326','PA','Gettysburg','Adams',39.832,-77.2394),('17327','PA','Glen Rock','York',39.780237,-76.747838),('17329','PA','Glenville','York',39.758643,-76.85251),('17331','PA','Hanover','York',39.797794,-76.979717),('17332','PA','Hanover','York',39.8,-76.9869),('17333','PA','Hanover','York',39.8005,-76.9833),('17334','PA','Hanover','York',39.8009,-76.9835),('17335','PA','Hanover','York',39.8236,76.9924),('17337','PA','Idaville','Adams',40.0147,-77.203),('17339','PA','Lewisberry','York',40.137985,-76.869274),('17340','PA','Littlestown','Adams',39.750322,-77.106013),('17342','PA','Loganville','York',39.8555,-76.7094),('17343','PA','Mc Knightstown','Adams',39.870994,-77.330522),('17344','PA','Mc Sherrystown','Adams',39.805645,-77.019059),('17345','PA','Manchester','York',40.069418,-76.724761),('17347','PA','Mount Wolf','York',40.065864,-76.695189),('17349','PA','New Freedom','York',39.751716,-76.684427),('17350','PA','New Oxford','Adams',39.881983,-77.069817),('17352','PA','New Park','York',39.771799,-76.496848),('17353','PA','Orrtanna','Adams',39.880512,-77.386286),('17354','PA','Porters Sideling','York',39.8252,-76.895),('17355','PA','Railroad','York',39.757751,-76.699491),('17356','PA','Red Lion','York',39.900702,-76.599228),('17358','PA','Rossville','York',40.0637,-76.9143),('17360','PA','Seven Valleys','York',39.852893,-76.761706),('17361','PA','Shrewsbury','York',39.764395,-76.677085),('17362','PA','Spring Grove','York',39.858355,-76.863894),('17363','PA','Stewartstown','York',39.765154,-76.593813),('17364','PA','Thomasville','York',39.92434,-76.896065),('17365','PA','Wellsville','York',40.060066,-76.938392),('17366','PA','Windsor','York',39.929648,-76.564354),('17368','PA','Wrightsville','York',39.995897,-76.521981),('17370','PA','York Haven','York',40.12036,-76.758613),('17371','PA','York New Salem','York',39.90242,-76.787558),('17372','PA','York Springs','Adams',40.004234,-77.110619),('17375','PA','Peach Glen','Adams',40.023,-77.2302),('17401','PA','York','York',39.958006,-76.73309),('17402','PA','York','York',39.962956,-76.666223),('17403','PA','York','York',39.950596,-76.710999),('17404','PA','York','York',39.977162,-76.758621),('17405','PA','York','York',39.9594,-76.7263),('17406','PA','York','York',39.999705,-76.661331),('17407','PA','York','York',39.882674,-76.712246),('17408','PA','York','York',39.954413,-76.801341),('17415','PA','York','York',39.9933,-76.6475),('17501','PA','Akron','Lancaster',40.156459,-76.20404),('17502','PA','Bainbridge','Lancaster',40.097061,-76.667845),('17503','PA','Bart','Lancaster',39.9397,-76.1149),('17504','PA','Bausman','Lancaster',40.0241,-76.3311),('17505','PA','Bird In Hand','Lancaster',40.056935,-76.189378),('17506','PA','Blue Ball','Lancaster',40.1186,-76.0475),('17507','PA','Bowmansville','Lancaster',40.198042,-76.016233),('17508','PA','Brownstown','Lancaster',40.125509,-76.217735),('17509','PA','Christiana','Lancaster',39.924269,-76.025971),('17512','PA','Columbia','Lancaster',40.037461,-76.492224),('17516','PA','Conestoga','Lancaster',39.94846,-76.361728),('17517','PA','Denver','Lancaster',40.234355,-76.10855),('17518','PA','Drumore','Lancaster',39.803962,-76.263311),('17519','PA','East Earl','Lancaster',40.141438,-76.023423),('17520','PA','East Petersburg','Lancaster',40.099455,-76.350534),('17521','PA','Elm','Lancaster',40.2038,-76.3491),('17522','PA','Ephrata','Lancaster',40.176774,-76.177693),('17527','PA','Gap','Lancaster',40.008881,-75.991296),('17528','PA','Goodville','Lancaster',39.8977,-76.3274),('17529','PA','Gordonville','Lancaster',40.035156,-76.11239),('17532','PA','Holtwood','Lancaster',39.850839,-76.300581),('17533','PA','Hopeland','Lancaster',40.2336,-76.2625),('17534','PA','Intercourse','Lancaster',40.0374,-76.109),('17535','PA','Kinzers','Lancaster',40.009174,-76.048938),('17536','PA','Kirkwood','Lancaster',39.848034,-76.073774),('17537','PA','Lampeter','Lancaster',39.99,-76.24),('17538','PA','Landisville','Lancaster',40.093942,-76.416393),('17540','PA','Leola','Lancaster',40.101309,-76.195938),('17543','PA','Lititz','Lancaster',40.162713,-76.295932),('17545','PA','Manheim','Lancaster',40.172494,-76.414419),('17547','PA','Marietta','Lancaster',40.062103,-76.568866),('17549','PA','Martindale','Lancaster',40.153,-76.0888),('17550','PA','Maytown','Lancaster',40.074829,-76.582298),('17551','PA','Millersville','Lancaster',39.994272,-76.363219),('17552','PA','Mount Joy','Lancaster',40.108735,-76.506924),('17554','PA','Mountville','Lancaster',40.040293,-76.426802),('17555','PA','Narvon','Lancaster',40.126973,-75.96809),('17557','PA','New Holland','Lancaster',40.09985,-76.072742),('17560','PA','New Providence','Lancaster',39.918858,-76.22083),('17562','PA','Paradise','Lancaster',39.987891,-76.096042),('17563','PA','Peach Bottom','Lancaster',39.766224,-76.18719),('17564','PA','Penryn','Lancaster',40.205,-76.3686),('17565','PA','Pequea','Lancaster',39.903074,-76.325635),('17566','PA','Quarryville','Lancaster',39.878622,-76.149911),('17567','PA','Reamstown','Lancaster',40.2113,-76.1236),('17568','PA','Refton','Lancaster',40.015,-76.2471),('17569','PA','Reinholds','Lancaster',40.263531,-76.093582),('17570','PA','Rheems','Lancaster',40.129661,-76.568496),('17572','PA','Ronks','Lancaster',40.005623,-76.152161),('17573','PA','Ronks','Lancaster',40.0173,-76.1656),('17575','PA','Silver Spring','Lancaster',40.0004,-76.329),('17576','PA','Smoketown','Lancaster',40.037111,-76.197806),('17578','PA','Stevens','Lancaster',40.226099,-76.159806),('17579','PA','Strasburg','Lancaster',39.964702,-76.181548),('17580','PA','Talmage','Lancaster',40.1266,-76.1808),('17581','PA','Terre Hill','Lancaster',40.156342,-76.049171),('17582','PA','Washington Boro','Lancaster',39.985644,-76.45168),('17583','PA','West Willow','Lancaster',39.8977,-76.3274),('17584','PA','Willow Street','Lancaster',39.958658,-76.266592),('17585','PA','Witmer','Lancaster',40.048,-76.2116),('17601','PA','Lancaster','Lancaster',40.072285,-76.315327),('17602','PA','Lancaster','Lancaster',40.030189,-76.27587),('17603','PA','Lancaster','Lancaster',40.03112,-76.331507),('17604','PA','Lancaster','Lancaster',40.0598,-76.3357),('17605','PA','Lancaster','Lancaster',40.0494,-76.2506),('17606','PA','Lancaster','Lancaster',40.112734,-76.304715),('17607','PA','Lancaster','Lancaster',40.038018,-76.301441),('17608','PA','Lancaster','Lancaster',40.0405,-76.308),('17611','PA','Lancaster','Lancaster',40.079,-76.3794),('17622','PA','Lancaster','Lancaster',40.076233,-76.425018),('17699','PA','Lancaster','Lancaster',40.0377,-76.3058),('17701','PA','Williamsport','Lycoming',41.256746,-77.010754),('17702','PA','Williamsport','Lycoming',41.222488,-77.023658),('17703','PA','Williamsport','Lycoming',41.2411,-77.0013),('17705','PA','Williamsport','Lycoming',41.2239,-77.0817),('17720','PA','Antes Fort','Lycoming',41.1916,-77.2241),('17721','PA','Avis','Clinton',41.184976,-77.316323),('17723','PA','Cammal,','Lycoming',41.418681,-77.485104),('17724','PA','Canton','Bradford',41.656419,-76.815225),('17726','PA','Castanea','Clinton',41.1247,-77.43),('17727','PA','Cedar Run','Lycoming',41.510785,-77.496161),('17728','PA','Cogan Station','Lycoming',41.318777,-77.076627),('17729','PA','Cross Fork','Clinton',41.483941,-77.757458),('17730','PA','Dewart','Northumberland',41.109633,-76.877666),('17731','PA','Eagles Mere','Sullivan',41.419939,-76.582735),('17735','PA','Grover','Bradford',41.6144,-76.8675),('17737','PA','Hughesville','Lycoming',41.25998,-76.699957),('17738','PA','Hyner','Clinton',41.335148,-77.640146),('17739','PA','Jersey Mills','Lycoming',41.388147,-77.41868),('17740','PA','Jersey Shore','Lycoming',41.221184,-77.269692),('17742','PA','Lairdsville','Lycoming',41.231635,-76.608458),('17744','PA','Linden','Lycoming',41.231602,-77.156521),('17745','PA','Lock Haven','Clinton',41.178,-77.434975),('17747','PA','Loganton','Clinton',41.036018,-77.31099),('17748','PA','Mc Elhattan','Clinton',41.151369,-77.354943),('17749','PA','Mc Ewensville','Northumberland',41.072586,-76.81853),('17750','PA','Mackeyville','Clinton',41.056442,-77.464634),('17751','PA','Mill Hall','Clinton',41.113123,-77.502818),('17752','PA','Montgomery','Lycoming',41.171667,-76.886952),('17754','PA','Montoursville','Lycoming',41.266681,-76.907184),('17756','PA','Muncy','Lycoming',41.206506,-76.749457),('17758','PA','Muncy Valley','Sullivan',41.354422,-76.554052),('17760','PA','North Bend','Clinton',41.382856,-77.668933),('17762','PA','Picture Rocks','Lycoming',41.281401,-76.711079),('17763','PA','Ralston','Lycoming',41.515033,-76.96546),('17764','PA','Renovo','Clinton',41.341107,-77.800052),('17765','PA','Roaring Branch','Tioga',41.568342,-76.961988),('17767','PA','Salona','Clinton',41.084082,-77.462596),('17768','PA','Shunk','Sullivan',41.54636,-76.73965),('17769','PA','Slate Run','Lycoming',41.4727,-77.5019),('17771','PA','Trout Run','Lycoming',41.43745,-77.035428),('17772','PA','Turbotville','Northumberland',41.103492,-76.744685),('17773','PA','Tylersville','Clinton',40.9905,-77.4252),('17774','PA','Unityville','Lycoming',41.251867,-76.546733),('17776','PA','Waterville','Lycoming',41.402671,-77.332453),('17777','PA','Watsontown','Northumberland',41.094978,-76.850266),('17778','PA','Westport','Clinton',41.293333,-77.949566),('17779','PA','Woolrich','Clinton',41.200671,-77.382729),('17801','PA','Sunbury','Northumberland',40.849192,-76.76373),('17810','PA','Allenwood','Union',41.118443,-76.990791),('17812','PA','Beaver Springs','Snyder',40.75012,-77.224947),('17813','PA','Beavertown','Snyder',40.772205,-77.173847),('17814','PA','Benton','Columbia',41.243306,-76.371355),('17815','PA','Bloomsburg','Columbia',41.013467,-76.434992),('17820','PA','Catawissa','Columbia',40.912109,-76.437735),('17821','PA','Danville','Montour',40.977706,-76.625904),('17822','PA','Danville','Montour',40.9668,-76.6032),('17823','PA','Dornsife','Northumberland',40.718622,-76.743347),('17824','PA','Elysburg','Northumberland',40.859178,-76.521999),('17827','PA','Freeburg','Snyder',40.76006,-76.945849),('17829','PA','Hartleton','Union',40.900616,-77.155277),('17830','PA','Herndon','Northumberland',40.686064,-76.80517),('17831','PA','Hummels Wharf','Snyder',40.8316,-76.8361),('17832','PA','Marion Heights','Northumberland',40.805314,-76.462649),('17833','PA','Kreamer','Snyder',40.802232,-76.96291),('17834','PA','Kulpmont','Northumberland',40.78761,-76.468357),('17835','PA','Laurelton','Union',40.883385,-77.198237),('17836','PA','Leck Kill','Northumberland',40.717877,-76.596975),('17837','PA','Lewisburg','Union',40.969075,-76.916385),('17839','PA','Lightstreet','Columbia',41.0361,-76.4238),('17840','PA','Locust Gap','Northumberland',40.772135,-76.438364),('17841','PA','Mc Clure','Mifflin',40.720397,-77.34361),('17842','PA','Middleburg','Snyder',40.804352,-77.026653),('17843','PA','Beaver Springs','Snyder',40.819,-76.9687),('17844','PA','Mifflinburg','Union',40.940834,-77.068401),('17845','PA','Millmont','Union',40.879903,-77.195258),('17846','PA','Millville','Columbia',41.130039,-76.512187),('17847','PA','Milton','Northumberland',41.008477,-76.833997),('17850','PA','Montandon','Northumberland',40.96533,-76.857169),('17851','PA','Mount Carmel','Northumberland',40.796263,-76.421819),('17853','PA','Mount Pleasant Mills','Snyder',40.699267,-77.002532),('17855','PA','New Berlin','Union',40.87974,-76.984908),('17856','PA','New Columbia','Union',41.049826,-76.89773),('17857','PA','Northumberland','Northumberland',40.905787,-76.789015),('17858','PA','Numidia','Columbia',40.8805,-76.4025),('17859','PA','Orangeville','Columbia',41.10079,-76.401492),('17860','PA','Paxinos','Northumberland',40.836485,-76.628027),('17861','PA','Paxtonville','Snyder',40.771155,-77.084705),('17862','PA','Penns Creek','Snyder',40.859908,-77.057489),('17864','PA','Port Trevorton','Snyder',40.694177,-76.902842),('17865','PA','Potts Grove','Northumberland',40.992795,-76.786756),('17866','PA','Coal Township','Northumberland',40.780716,-76.561866),('17867','PA','Rebuck','Northumberland',40.716278,-76.689361),('17868','PA','Riverside','Northumberland',40.957847,-76.633178),('17870','PA','Selinsgrove','Snyder',40.816918,-76.871353),('17872','PA','Shamokin','Northumberland',40.783882,-76.56413),('17876','PA','Shamokin Dam','Snyder',40.849958,-76.823501),('17877','PA','Snydertown','Northumberland',40.8716,-76.6737),('17878','PA','Stillwater','Columbia',41.169003,-76.326096),('17880','PA','Swengel','Union',40.894309,-77.122077),('17881','PA','Trevorton','Northumberland',40.781374,-76.675606),('17882','PA','Troxelville','Snyder',40.801614,-77.20537),('17883','PA','Vicksburg','Union',40.9386,-76.9883),('17884','PA','Washingtonville','Montour',41.052461,-76.673704),('17885','PA','Weikert','Union',40.850455,-77.314905),('17886','PA','West Milton','Union',41.018266,-76.868424),('17887','PA','White Deer','Union',41.07531,-76.895759),('17888','PA','Wilburton','Columbia',40.813915,-76.383478),('17889','PA','Winfield','Union',40.885695,-76.922536),('17901','PA','Pottsville','Schuylkill',40.686542,-76.215055),('17920','PA','Aristes','Columbia',40.817698,-76.33819),('17921','PA','Ashland','Schuylkill',40.773127,-76.350933),('17922','PA','Auburn','Schuylkill',40.59213,-76.127652),('17923','PA','Branchdale','Schuylkill',40.661474,-76.324314),('17925','PA','Brockton','Schuylkill',40.750579,-76.068913),('17929','PA','Cressona','Schuylkill',40.630768,-76.193052),('17930','PA','Cumbola','Schuylkill',40.711157,-76.13858),('17931','PA','Frackville','Schuylkill',40.781195,-76.231016),('17932','PA','Frackville','Schuylkill',40.7838,-76.2305),('17933','PA','Friedensburg','Schuylkill',40.602364,-76.241678),('17934','PA','Gilberton','Schuylkill',40.799432,-76.216387),('17935','PA','Girardville','Schuylkill',40.793466,-76.28178),('17936','PA','Gordon','Schuylkill',40.751009,-76.339505),('17938','PA','Hegins','Schuylkill',40.654229,-76.492923),('17941','PA','Klingerstown','Schuylkill',40.685576,-76.626835),('17942','PA','Landingville','Schuylkill',40.6261,-76.1238),('17943','PA','Lavelle','Schuylkill',40.762372,-76.383434),('17944','PA','Llewellyn','Schuylkill',40.673376,-76.278729),('17945','PA','Locustdale','Columbia',40.777746,-76.373581),('17946','PA','Lost Creek','Schuylkill',40.809614,-76.247356),('17948','PA','Mahanoy City','Schuylkill',40.815497,-76.135474),('17949','PA','Mahanoy Plane','Schuylkill',40.793996,-76.243652),('17951','PA','Mar Lin','Schuylkill',40.679503,-76.246196),('17952','PA','Mary D','Schuylkill',40.757627,-76.055933),('17953','PA','Middleport','Schuylkill',40.738978,-76.098393),('17954','PA','Minersville','Schuylkill',40.690026,-76.26075),('17957','PA','Muir','Schuylkill',40.59247,-76.519749),('17959','PA','New Philadelphia','Schuylkill',40.732845,-76.13383),('17960','PA','New Ringgold','Schuylkill',40.69984,-75.958187),('17961','PA','Orwigsburg','Schuylkill',40.649361,-76.076701),('17963','PA','Pine Grove','Schuylkill',40.557383,-76.376999),('17964','PA','Pitman','Schuylkill',40.713684,-76.516468),('17965','PA','Port Carbon','Schuylkill',40.697842,-76.165302),('17966','PA','Ravine','Schuylkill',40.5744,-76.4041),('17967','PA','Ringtown','Schuylkill',40.856252,-76.21652),('17968','PA','Sacramento','Schuylkill',40.638898,-76.605447),('17970','PA','Saint Clair','Schuylkill',40.718418,-76.191053),('17972','PA','Schuylkill Haven','Schuylkill',40.614868,-76.192913),('17974','PA','Seltzer','Schuylkill',40.696205,-76.235521),('17976','PA','Shenandoah','Schuylkill',40.820818,-76.204121),('17978','PA','Spring Glen','Schuylkill',40.625383,-76.616419),('17979','PA','Summit Station','Schuylkill',40.563379,-76.202944),('17980','PA','Tower City','Schuylkill',40.582609,-76.557542),('17981','PA','Tremont','Schuylkill',40.629446,-76.397346),('17982','PA','Tuscarora','Schuylkill',40.769401,-76.033675),('17983','PA','Valley View','Schuylkill',40.644262,-76.543056),('17985','PA','Zion Grove','Schuylkill',40.908055,-76.204241),('18001','PA','Lehigh Valley','Northampton',40.5897,-75.4647),('18002','PA','Lehigh Valley','Northampton',40.6729,-75.3793),('18003','PA','Lehigh Valley','Northampton',40.7386,-75.6376),('18010','PA','Ackermanville','Northampton',40.8648,-75.2073),('18011','PA','Alburtis','Lehigh',40.499048,-75.62164),('18012','PA','Aquashicola','Carbon',40.811206,-75.59136),('18013','PA','Bangor','Northampton',40.858609,-75.187939),('18014','PA','Bath','Northampton',40.758303,-75.405579),('18015','PA','Bethlehem','Northampton',40.601079,-75.376791),('18016','PA','Bethlehem','Northampton',40.6209,-75.3645),('18017','PA','Bethlehem','Northampton',40.645246,-75.371492),('18018','PA','Bethlehem','Lehigh',40.624918,-75.388802),('18020','PA','Bethlehem','Northampton',40.659484,-75.327772),('18025','PA','Bethlehem','Lehigh',40.6335,-75.3952),('18030','PA','Bowmanstown','Carbon',40.799719,-75.663461),('18031','PA','Breinigsville','Lehigh',40.549545,-75.640132),('18032','PA','Catasauqua','Lehigh',40.656737,-75.470859),('18034','PA','Center Valley','Lehigh',40.54151,-75.409163),('18035','PA','Cherryville','Northampton',40.748955,-75.539457),('18036','PA','Coopersburg','Lehigh',40.509951,-75.396888),('18037','PA','Coplay','Lehigh',40.667695,-75.506733),('18038','PA','Danielsville','Northampton',40.790267,-75.481113),('18039','PA','Durham','Bucks',40.5755,-75.2236),('18040','PA','Easton','Northampton',40.732396,-75.223318),('18041','PA','East Greenville','Montgomery',40.409992,-75.508632),('18042','PA','Easton','Northampton',40.680461,-75.222207),('18043','PA','Easton','Northampton',40.6883,-75.2211),('18044','PA','Easton','Northampton',40.6898,-75.2075),('18045','PA','Easton','Northampton',40.685271,-75.268635),('18046','PA','East Texas','Lehigh',40.6088,-75.549),('18049','PA','Emmaus','Lehigh',40.533058,-75.499953),('18050','PA','Flicksville','Northampton',40.8648,-75.2073),('18051','PA','Fogelsville','Lehigh',40.59288,-75.651997),('18052','PA','Whitehall','Lehigh',40.651503,-75.49423),('18053','PA','Germansville','Lehigh',40.711306,-75.705253),('18054','PA','Green Lane','Montgomery',40.352984,-75.444131),('18055','PA','Hellertown','Northampton',40.586084,-75.326219),('18056','PA','Hereford','Berks',40.449482,-75.552701),('18058','PA','Kunkletown','Monroe',40.89686,-75.493308),('18059','PA','Laurys Station','Lehigh',40.725817,-75.53364),('18060','PA','Limeport','Lehigh',40.5088,-75.4475),('18062','PA','Macungie','Lehigh',40.521944,-75.568967),('18063','PA','Martins Creek','Northampton',40.78238,-75.182784),('18064','PA','Nazareth','Northampton',40.749364,-75.316012),('18065','PA','Neffs','Lehigh',40.6944,-75.61),('18066','PA','New Tripoli','Lehigh',40.664462,-75.7401),('18067','PA','Northampton','Northampton',40.69371,-75.486686),('18068','PA','Old Zionsville','Lehigh',40.484829,-75.520041),('18069','PA','Orefield','Lehigh',40.624234,-75.602468),('18070','PA','Palm','Montgomery',40.429076,-75.535272),('18071','PA','Palmerton','Carbon',40.814742,-75.603305),('18072','PA','Pen Argyl','Northampton',40.853318,-75.254949),('18073','PA','Pennsburg','Montgomery',40.388839,-75.487557),('18074','PA','Perkiomenville','Montgomery',40.319723,-75.506284),('18076','PA','Red Hill','Montgomery',40.376766,-75.483244),('18077','PA','Riegelsville','Bucks',40.578562,-75.221316),('18078','PA','Schnecksville','Lehigh',40.674675,-75.61381),('18079','PA','Slatedale','Lehigh',40.744069,-75.656754),('18080','PA','Slatington','Lehigh',40.737664,-75.621788),('18081','PA','Springtown','Bucks',40.557549,-75.287683),('18083','PA','Stockertown','Northampton',40.754952,-75.267086),('18084','PA','Sumneytown','Montgomery',40.3288,-75.4513),('18085','PA','Tatamy','Northampton',40.740721,-75.253326),('18086','PA','Treichlers','Northampton',40.73671,-75.546377),('18087','PA','Trexlertown','Lehigh',40.549195,-75.600484),('18088','PA','Walnutport','Northampton',40.761044,-75.56559),('18091','PA','Wind Gap','Northampton',40.829795,-75.306005),('18092','PA','Zionsville','Lehigh',40.467526,-75.524823),('18098','PA','Emmaus','Lehigh',40.5358,-75.4947),('18099','PA','Emmaus','Lehigh',40.5358,-75.4947),('18101','PA','Allentown','Lehigh',40.602658,-75.469236),('18102','PA','Allentown','Lehigh',40.607717,-75.479372),('18103','PA','Allentown','Lehigh',40.578393,-75.471787),('18104','PA','Allentown','Lehigh',40.602356,-75.522865),('18105','PA','Allentown','Lehigh',40.600718,-75.493612),('18106','PA','Allentown','Lehigh',40.569513,-75.590026),('18109','PA','Allentown','Lehigh',40.621809,-75.438724),('18175','PA','Allentown','Lehigh',40.6029,-75.4679),('18195','PA','Allentown','Lehigh',40.5728,-75.6153),('18201','PA','Hazleton','Luzerne',40.956259,-75.975038),('18202','PA','Hazleton','Luzerne',40.957202,-76.027392),('18210','PA','Albrightsville','Carbon',40.997372,-75.556101),('18211','PA','Andreas','Schuylkill',40.749316,-75.829281),('18212','PA','Ashfield','Carbon',40.782266,-75.708333),('18214','PA','Barnesville','Schuylkill',40.816227,-76.070366),('18216','PA','Beaver Meadows','Carbon',40.930509,-75.919569),('18218','PA','Coaldale','Schuylkill',40.822057,-75.912235),('18219','PA','Conyngham','Luzerne',40.989593,-76.059185),('18220','PA','Delano','Schuylkill',40.838263,-76.066987),('18221','PA','Drifton','Luzerne',41.004854,-75.906789),('18222','PA','Drums','Luzerne',41.032637,-75.996242),('18223','PA','Ebervale','Luzerne',40.984437,-75.958309),('18224','PA','Freeland','Luzerne',41.015808,-75.897711),('18225','PA','Harleigh','Luzerne',40.981291,-75.971414),('18229','PA','Jim Thorpe','Carbon',40.91003,-75.691198),('18230','PA','Junedale','Carbon',40.923863,-75.939236),('18231','PA','Kelayres','Schuylkill',40.901259,-76.004678),('18232','PA','Lansford','Carbon',40.83201,-75.883542),('18234','PA','Lattimer Mines','Luzerne',40.992738,-75.961696),('18235','PA','Lehighton','Carbon',40.829786,-75.698619),('18237','PA','Mcadoo','Schuylkill',40.894753,-75.995798),('18239','PA','Milnesville','Luzerne',40.988365,-75.981049),('18240','PA','Nesquehoning','Carbon',40.861175,-75.838954),('18241','PA','Nuremberg','Schuylkill',40.940347,-76.159539),('18242','PA','Oneida','Schuylkill',40.907349,-76.12734),('18244','PA','Parryville','Carbon',40.831651,-75.677604),('18245','PA','Quakake','Schuylkill',40.852821,-76.035404),('18246','PA','Rock Glen','Luzerne',40.964017,-76.186934),('18247','PA','Saint Johns','Luzerne',41.028,-76.0063),('18248','PA','Sheppton','Schuylkill',40.895428,-76.115068),('18249','PA','Sugarloaf','Luzerne',40.991436,-76.095766),('18250','PA','Summit Hill','Carbon',40.827071,-75.86582),('18251','PA','Sybertsville','Luzerne',41.009041,-76.077782),('18252','PA','Tamaqua','Schuylkill',40.794758,-75.976295),('18254','PA','Tresckow','Carbon',40.914997,-75.964227),('18255','PA','Weatherly','Carbon',40.939511,-75.831922),('18256','PA','Weston','Luzerne',40.941755,-76.143436),('18301','PA','East Stroudsburg','Monroe',41.024366,-75.183117),('18302','PA','East Stroudsburg','Monroe',41.091942,-75.11201),('18320','PA','Analomink','Monroe',41.0511,-75.2208),('18321','PA','Bartonsville','Monroe',41.013527,-75.288676),('18322','PA','Brodheadsville','Monroe',40.923029,-75.400989),('18323','PA','Buck Hill Falls','Monroe',41.191084,-75.269785),('18324','PA','Bushkill','Pike',41.136822,-74.998393),('18325','PA','Canadensis','Monroe',41.207791,-75.238596),('18326','PA','Cresco','Monroe',41.140906,-75.269937),('18327','PA','Delaware Water Gap','Monroe',40.983772,-75.140428),('18328','PA','Dingmans Ferry','Pike',41.241891,-74.959192),('18330','PA','Effort','Monroe',40.970649,-75.455861),('18331','PA','Gilbert','Monroe',40.913397,-75.442176),('18332','PA','Henryville','Monroe',41.087339,-75.269119),('18333','PA','Kresgeville','Monroe',40.900556,-75.499084),('18334','PA','Long Pond','Monroe',41.080242,-75.425457),('18335','PA','Marshalls Creek','Monroe',41.069873,-75.106389),('18336','PA','Matamoras','Pike',41.369489,-74.706478),('18337','PA','Milford','Pike',41.325512,-74.872496),('18340','PA','Millrift','Pike',41.417763,-74.765883),('18341','PA','Minisink Hills','Monroe',40.999857,-75.132543),('18342','PA','Mountainhome','Monroe',41.172257,-75.273166),('18343','PA','Mount Bethel','Northampton',40.898675,-75.110153),('18344','PA','Mount Pocono','Monroe',41.117009,-75.349337),('18346','PA','Pocono Summit','Monroe',41.123964,-75.395062),('18347','PA','Pocono Lake','Monroe',41.143924,-75.553716),('18348','PA','Pocono Lake Preserve','Monroe',41.1053,-75.4764),('18349','PA','Pocono Manor','Monroe',41.10036,-75.364566),('18350','PA','Pocono Pines','Monroe',41.114797,-75.460677),('18351','PA','Portland','Northampton',40.922079,-75.098343),('18352','PA','Reeders','Monroe',41.010013,-75.358369),('18353','PA','Saylorsburg','Monroe',40.906499,-75.359552),('18354','PA','Sciota','Monroe',40.928493,-75.32405),('18355','PA','Scotrun','Monroe',41.074291,-75.358082),('18356','PA','Shawnee On Delaware','Monroe',41.009775,-75.116293),('18357','PA','Skytop','Monroe',41.228117,-75.235315),('18360','PA','Stroudsburg','Monroe',40.978227,-75.256191),('18370','PA','Swiftwater','Monroe',41.094735,-75.325986),('18371','PA','Tamiment','Pike',41.154516,-75.032026),('18372','PA','Tannersville','Monroe',41.049642,-75.317781),('18373','PA','Unity House','Pike',41.1499,-75.0333),('18403','PA','Archbald','Lackawanna',41.496035,-75.548254),('18405','PA','Beach Lake','Wayne',41.599551,-75.10424),('18407','PA','Carbondale','Lackawanna',41.584135,-75.51199),('18410','PA','Chinchilla','Lackawanna',41.475,-75.6775),('18411','PA','Clarks Summit','Lackawanna',41.481303,-75.714856),('18413','PA','Clifford','Susquehanna',41.650743,-75.600216),('18414','PA','Dalton','Lackawanna',41.539347,-75.727803),('18415','PA','Damascus','Wayne',41.738258,-75.115028),('18416','PA','Elmhurst','Lackawanna',41.3777,-75.545),('18417','PA','Equinunk','Wayne',41.809764,-75.201095),('18419','PA','Factoryville','Wyoming',41.569966,-75.789528),('18420','PA','Fleetville','Lackawanna',41.602006,-75.710133),('18421','PA','Forest City','Susquehanna',41.652778,-75.470509),('18424','PA','Gouldsboro','Lackawanna',41.250091,-75.484922),('18425','PA','Greeley','Pike',41.415904,-75.015261),('18426','PA','Greentown','Pike',41.339141,-75.251775),('18427','PA','Hamlin','Wayne',41.404977,-75.406897),('18428','PA','Hawley','Pike',41.427903,-75.135132),('18430','PA','Herrick Center','Susquehanna',41.75322,-75.4777),('18431','PA','Honesdale','Wayne',41.597797,-75.257154),('18433','PA','Jermyn','Lackawanna',41.550302,-75.567397),('18434','PA','Jessup','Lackawanna',41.468802,-75.560817),('18435','PA','Lackawaxen','Pike',41.501621,-75.009088),('18436','PA','Lake Ariel','Wayne',41.42821,-75.384644),('18437','PA','Lake Como','Wayne',41.851908,-75.330189),('18438','PA','Lakeville','Wayne',41.432454,-75.245288),('18439','PA','Lakewood','Wayne',41.825503,-75.348966),('18440','PA','La Plume','Lackawanna',41.5566,-75.7541),('18441','PA','Lenoxville','Susquehanna',41.664366,-75.629022),('18443','PA','Milanville','Wayne',41.666196,-75.100436),('18444','PA','Moscow','Lackawanna',41.343773,-75.528651),('18445','PA','Newfoundland','Wayne',41.288952,-75.355326),('18446','PA','Nicholson','Wyoming',41.641316,-75.746791),('18447','PA','Olyphant','Lackawanna',41.48702,-75.608919),('18448','PA','Olyphant','Lackawanna',41.4707,-75.6059),('18449','PA','Orson','Wayne',41.8136,-75.4483),('18451','PA','Paupack','Pike',41.409174,-75.229867),('18452','PA','Peckville','Lackawanna',41.480913,-75.585688),('18453','PA','Pleasant Mount','Wayne',41.745029,-75.367604),('18454','PA','Poyntelle','Wayne',41.829438,-75.428104),('18455','PA','Preston Park','Wayne',41.880507,-75.350594),('18456','PA','Prompton','Wayne',41.601545,-75.342998),('18457','PA','Rowland','Pike',41.47111,-75.044976),('18458','PA','Shohola','Pike',41.406913,-74.927168),('18459','PA','South Canaan','Wayne',41.504102,-75.428839),('18460','PA','South Sterling','Wayne',41.273125,-75.334978),('18461','PA','Starlight','Wayne',41.924706,-75.332116),('18462','PA','Starrucca','Wayne',41.896229,-75.425728),('18463','PA','Sterling','Wayne',41.35079,-75.402144),('18464','PA','Tafton','Pike',41.418006,-75.188981),('18465','PA','Thompson','Susquehanna',41.831306,-75.516842),('18466','PA','Tobyhanna','Monroe',41.191379,-75.374266),('18469','PA','Tyler Hill','Wayne',41.690931,-75.12803),('18470','PA','Union Dale','Susquehanna',41.724706,-75.535517),('18471','PA','Waverly','Lackawanna',41.527457,-75.697474),('18472','PA','Waymart','Wayne',41.588566,-75.392037),('18473','PA','White Mills','Wayne',41.526374,-75.209644),('18501','PA','Scranton','Lackawanna',41.3731,-75.6841),('18502','PA','Scranton','Lackawanna',41.3732,-75.6788),('18503','PA','Scranton','Lackawanna',41.410545,-75.666245),('18504','PA','Scranton','Lackawanna',41.415606,-75.689296),('18505','PA','Scranton','Lackawanna',41.392038,-75.663517),('18507','PA','Moosic','Lackawanna',41.354707,-75.710728),('18508','PA','Scranton','Lackawanna',41.441469,-75.66004),('18509','PA','Scranton','Lackawanna',41.427965,-75.646365),('18510','PA','Scranton','Lackawanna',41.407478,-75.64543),('18512','PA','Scranton','Lackawanna',41.426921,-75.616975),('18514','PA','Scranton','Lackawanna',41.3731,-75.6841),('18515','PA','Scranton','Lackawanna',41.4476,-75.6669),('18517','PA','Taylor','Lackawanna',41.38641,-75.715286),('18518','PA','Old Forge','Lackawanna',41.371702,-75.738117),('18519','PA','Dickson City','Lackawanna',41.462759,-75.626597),('18522','PA','Scranton','Lackawanna',41.4303,-75.6437),('18540','PA','Scranton','Lackawanna',41.3731,-75.6841),('18577','PA','Scranton','Lackawanna',41.3731,-75.6841),('18601','PA','Beach Haven','Luzerne',41.067712,-76.176269),('18602','PA','Bear Creek','Luzerne',41.179733,-75.753207),('18603','PA','Berwick','Columbia',41.064671,-76.247056),('18610','PA','Blakeslee','Monroe',41.054316,-75.543116),('18611','PA','Cambra','Luzerne',41.196076,-76.307358),('18612','PA','Dallas','Luzerne',41.345137,-75.977302),('18614','PA','Dushore','Sullivan',41.501157,-76.384181),('18615','PA','Falls','Wyoming',41.455116,-75.854478),('18616','PA','Forksville','Sullivan',41.513241,-76.61638),('18617','PA','Glen Lyon','Luzerne',41.176236,-76.070813),('18618','PA','Harveys Lake','Luzerne',41.364718,-76.044674),('18619','PA','Hillsgrove','Sullivan',41.462387,-76.700002),('18621','PA','Hunlock Creek','Luzerne',41.255347,-76.091065),('18622','PA','Huntington Mills','Luzerne',41.201232,-76.273515),('18623','PA','Laceyville','Wyoming',41.661534,-76.144623),('18624','PA','Lake Harmony','Carbon',41.056678,-75.603489),('18625','PA','Lake Winola','Wyoming',41.508183,-75.851149),('18626','PA','Laporte','Sullivan',41.420014,-76.500259),('18627','PA','Lehman','Luzerne',41.3169,-76.0227),('18628','PA','Lopez','Sullivan',41.439565,-76.32443),('18629','PA','Mehoopany','Wyoming',41.545061,-76.1178),('18630','PA','Meshoppen','Wyoming',41.65235,-76.031387),('18631','PA','Mifflinville','Columbia',41.02879,-76.307238),('18632','PA','Mildred','Sullivan',41.475976,-76.380201),('18634','PA','Nanticoke','Luzerne',41.197872,-76.004061),('18635','PA','Nescopeck','Luzerne',41.03859,-76.20759),('18636','PA','Noxen','Wyoming',41.404265,-76.073249),('18640','PA','Pittston','Luzerne',41.313897,-75.777668),('18641','PA','Pittston','Luzerne',41.332521,-75.740912),('18642','PA','Duryea','Luzerne',41.350321,-75.766281),('18643','PA','Pittston','Luzerne',41.337666,-75.816461),('18644','PA','Wyoming','Luzerne',41.317472,-75.852422),('18651','PA','Plymouth','Luzerne',41.243991,-75.950776),('18653','PA','Ransom','Lackawanna',41.39657,-75.824471),('18654','PA','Shawanese','Luzerne',41.3513,-76.0344),('18655','PA','Shickshinny','Luzerne',41.180051,-76.192242),('18656','PA','Sweet Valley','Luzerne',41.31066,-76.193283),('18657','PA','Tunkhannock','Wyoming',41.53025,-75.951385),('18660','PA','Wapwallopen','Luzerne',41.098814,-76.062699),('18661','PA','White Haven','Luzerne',41.075529,-75.767115),('18690','PA','Dallas','Luzerne',41.3383,-75.9654),('18701','PA','Wilkes Barre','Luzerne',41.243261,-75.884557),('18702','PA','Wilkes Barre','Luzerne',41.241864,-75.84592),('18703','PA','Wilkes Barre','Luzerne',41.2401,-75.8914),('18704','PA','Kingston','Luzerne',41.275344,-75.891145),('18705','PA','Wilkes Barre','Luzerne',41.267397,-75.845359),('18706','PA','Wilkes Barre','Luzerne',41.213094,-75.920523),('18707','PA','Mountain Top','Luzerne',41.13284,-75.92403),('18708','PA','Shavertown','Luzerne',41.304401,-75.951915),('18709','PA','Luzerne','Luzerne',41.283817,-75.893182),('18710','PA','Wilkes Barre','Luzerne',41.2454,-75.8819),('18711','PA','Wilkes Barre','Luzerne',41.2474,-75.8536),('18762','PA','Wilkes Barre','Luzerne',41.2401,-75.8914),('18764','PA','Wilkes Barre','Luzerne',41.2401,-75.8914),('18765','PA','Wilkes Barre','Luzerne',41.2401,-75.8914),('18766','PA','Wilkes Barre','Luzerne',41.2401,-75.8914),('18767','PA','Wilkes Barre','Luzerne',41.2401,-75.8914),('18769','PA','Wilkes Barre','Luzerne',41.2401,-75.8914),('18773','PA','Wilkes Barre','Luzerne',41.2401,-75.8914),('18801','PA','Montrose','Susquehanna',41.832163,-75.920134),('18810','PA','Athens','Bradford',41.947669,-76.517137),('18812','PA','Brackney','Susquehanna',41.970205,-75.943307),('18813','PA','Brooklyn','Susquehanna',41.753339,-75.80831),('18814','PA','Burlington','Bradford',41.778272,-76.603996),('18815','PA','Camptown','Bradford',41.7311,-76.235),('18816','PA','Dimock','Susquehanna',41.74894,-75.909856),('18817','PA','East Smithfield','Bradford',41.86397,-76.626083),('18818','PA','Friendsville','Susquehanna',41.917608,-76.036458),('18820','PA','Gibson','Susquehanna',41.803936,-75.64431),('18821','PA','Great Bend','Susquehanna',41.976197,-75.744244),('18822','PA','Hallstead','Susquehanna',41.952388,-75.775125),('18823','PA','Harford','Susquehanna',41.778326,-75.690124),('18824','PA','Hop Bottom','Susquehanna',41.705921,-75.781928),('18825','PA','Jackson','Susquehanna',41.809153,-75.592415),('18826','PA','Kingsley','Susquehanna',41.744456,-75.733986),('18827','PA','Lanesboro','Susquehanna',41.963293,-75.582034),('18828','PA','Lawton','Susquehanna',41.802203,-76.105927),('18829','PA','Le Raysville','Bradford',41.831768,-76.174329),('18830','PA','Little Meadows','Susquehanna',41.959088,-76.11444),('18831','PA','Milan','Bradford',41.897212,-76.584953),('18832','PA','Monroeton','Bradford',41.70183,-76.554475),('18833','PA','New Albany','Bradford',41.594622,-76.45016),('18834','PA','New Milford','Susquehanna',41.850476,-75.723676),('18837','PA','Rome','Bradford',41.915054,-76.302838),('18840','PA','Sayre','Bradford',41.984419,-76.529534),('18842','PA','South Gibson','Susquehanna',41.749695,-75.623434),('18843','PA','South Montrose','Susquehanna',41.79653,-75.895313),('18844','PA','Springville','Susquehanna',41.695875,-75.918372),('18845','PA','Stevensville','Bradford',41.78788,-76.182444),('18846','PA','Sugar Run','Bradford',41.61512,-76.238737),('18847','PA','Susquehanna','Susquehanna',41.928812,-75.578958),('18848','PA','Towanda','Bradford',41.762373,-76.461538),('18850','PA','Ulster','Bradford',41.849126,-76.500216),('18851','PA','Warren Center','Bradford',41.92625,-76.168036),('18853','PA','Wyalusing','Bradford',41.719133,-76.265303),('18854','PA','Wysox','Bradford',41.790684,-76.355747),('18901','PA','Doylestown','Bucks',40.306969,-75.142238),('18902','PA','Doylestown','Bucks',40.347803,-75.094931),('18910','PA','Bedminster','Bucks',40.4258,-75.1794),('18911','PA','Blooming Glen','Bucks',40.3696,-75.2487),('18912','PA','Buckingham','Bucks',40.3224,-75.0617),('18913','PA','Carversville','Bucks',40.39013,-75.060167),('18914','PA','Chalfont','Bucks',40.283562,-75.211262),('18915','PA','Colmar','Montgomery',40.271768,-75.258082),('18916','PA','Danboro','Bucks',40.3544,-75.133),('18917','PA','Dublin','Bucks',40.370667,-75.204308),('18918','PA','Earlington','Montgomery',40.3208,-75.3727),('18920','PA','Erwinna','Bucks',40.496421,-75.075928),('18921','PA','Ferndale','Bucks',40.5336,-75.1791),('18922','PA','Forest Grove','Bucks',40.2922,-75.0594),('18923','PA','Fountainville','Bucks',40.363397,-75.187351),('18924','PA','Franconia','Montgomery',40.3077,-75.358),('18925','PA','Furlong','Bucks',40.290482,-75.063304),('18926','PA','Gardenville','Bucks',40.3725,-75.108),('18927','PA','Hilltown','Bucks',40.324823,-75.2436),('18928','PA','Holicong','Bucks',40.328,-75.0557),('18929','PA','Jamison','Bucks',40.259603,-75.08636),('18930','PA','Kintnersville','Bucks',40.530146,-75.204475),('18931','PA','Lahaska','Bucks',40.3474,-75.0322),('18932','PA','Line Lexington','Bucks',40.288932,-75.259847),('18933','PA','Lumberville','Bucks',40.3911,-75.0364),('18934','PA','Mechanicsville','Bucks',40.36,-75.0593),('18935','PA','Milford Square','Bucks',40.437633,-75.396818),('18936','PA','Montgomeryville','Montgomery',40.229445,-75.228027),('18938','PA','New Hope','Bucks',40.351984,-74.987961),('18940','PA','Newtown','Bucks',40.244506,-74.938485),('18942','PA','Ottsville','Bucks',40.468826,-75.166811),('18943','PA','Penns Park','Bucks',40.2658,-74.9983),('18944','PA','Perkasie','Bucks',40.382693,-75.25394),('18946','PA','Pineville','Bucks',40.2954,-75.0057),('18947','PA','Pipersville','Bucks',40.422899,-75.117839),('18949','PA','Plumsteadville','Bucks',40.3872,-75.1469),('18950','PA','Point Pleasant','Bucks',40.436138,-75.068306),('18951','PA','Quakertown','Bucks',40.444771,-75.352033),('18953','PA','Revere','Bucks',40.5213,-75.1669),('18954','PA','Richboro','Bucks',40.219468,-75.00295),('18955','PA','Richlandtown','Bucks',40.479216,-75.318182),('18956','PA','Rushland','Bucks',40.2575,-75.0311),('18957','PA','Salford','Montgomery',40.2958,-75.4547),('18958','PA','Salfordville','Montgomery',40.2933,-75.4333),('18960','PA','Sellersville','Bucks',40.361325,-75.313073),('18962','PA','Silverdale','Bucks',40.346684,-75.271138),('18963','PA','Solebury','Bucks',40.3805,-75.0086),('18964','PA','Souderton','Montgomery',40.30639,-75.324445),('18966','PA','Southampton','Bucks',40.191545,-75.007038),('18968','PA','Spinnerstown','Bucks',40.4385,-75.4361),('18969','PA','Telford','Montgomery',40.326021,-75.347235),('18970','PA','Trumbauersville','Bucks',40.411302,-75.381762),('18971','PA','Tylersport','Montgomery',40.3494,-75.3813),('18972','PA','Upper Black Eddy','Bucks',40.534518,-75.121327),('18974','PA','Warminster','Bucks',40.2119,-75.08725),('18976','PA','Warrington','Bucks',40.240977,-75.139119),('18977','PA','Washington Crossing','Bucks',40.288043,-74.878864),('18979','PA','Woxall','Montgomery',40.3105,-75.4491),('18980','PA','Wycombe','Bucks',40.273651,-75.023528),('18981','PA','Zionhill','Bucks',40.4841,-75.3941),('18991','PA','Warminster','Bucks',40.2139,-75.0822),('19001','PA','Abington','Montgomery',40.127421,-75.126388),('19002','PA','Ambler','Montgomery',40.17155,-75.21182),('19003','PA','Ardmore','Montgomery',40.001029,-75.297981),('19004','PA','Bala Cynwyd','Montgomery',40.012004,-75.232723),('19006','PA','Huntingdon Valley','Montgomery',40.129455,-75.061528),('19007','PA','Bristol','Bucks',40.109812,-74.855273),('19008','PA','Broomall','Delaware',39.975383,-75.358736),('19009','PA','Bryn Athyn','Montgomery',40.134767,-75.064791),('19010','PA','Bryn Mawr','Delaware',40.02331,-75.327236),('19012','PA','Cheltenham','Montgomery',40.059801,-75.104935),('19013','PA','Chester','Delaware',39.846121,-75.37544),('19014','PA','Aston','Delaware',39.864141,-75.431177),('19015','PA','Brookhaven','Delaware',39.866978,-75.387498),('19016','PA','Chester','Delaware',39.8494,-75.3561),('19017','PA','Chester Heights','Delaware',39.888937,-75.466493),('19018','PA','Clifton Heights','Delaware',39.923618,-75.296988),('19019','PA','Philadelphia','Philadelphia',40.1162,-75.0141),('19020','PA','Bensalem','Bucks',40.103781,-74.937585),('19021','PA','Croydon','Bucks',40.089826,-74.898515),('19022','PA','Crum Lynne','Delaware',39.86275,-75.340032),('19023','PA','Darby','Delaware',39.916494,-75.265242),('19025','PA','Dresher','Montgomery',40.144478,-75.162259),('19026','PA','Drexel Hill','Delaware',39.949594,-75.302834),('19027','PA','Elkins Park','Montgomery',40.073118,-75.124431),('19028','PA','Edgemont','Delaware',39.9074,-75.5006),('19029','PA','Essington','Delaware',39.868404,-75.290408),('19030','PA','Fairless Hills','Bucks',40.175946,-74.845362),('19031','PA','Flourtown','Montgomery',40.10874,-75.212264),('19032','PA','Folcroft','Delaware',39.893645,-75.281243),('19033','PA','Folsom','Delaware',39.889868,-75.329024),('19034','PA','Fort Washington','Montgomery',40.135375,-75.201493),('19035','PA','Gladwyne','Montgomery',40.042079,-75.279861),('19036','PA','Glenolden','Delaware',39.903869,-75.293272),('19037','PA','Glen Riddle Lima','Delaware',39.9117,-75.4401),('19038','PA','Glenside','Montgomery',40.103627,-75.168525),('19039','PA','Gradyville','Delaware',39.943,-75.4697),('19040','PA','Hatboro','Montgomery',40.176697,-75.107059),('19041','PA','Haverford','Delaware',40.01043,-75.31177),('19043','PA','Holmes','Delaware',39.900115,-75.309134),('19044','PA','Horsham','Montgomery',40.185046,-75.143798),('19046','PA','Jenkintown','Montgomery',40.097449,-75.1112),('19047','PA','Langhorne','Bucks',40.176442,-74.911094),('19048','PA','Fort Washington','Bucks',40.1744,-74.923),('19049','PA','Fort Washington','Bucks',40.1744,-74.923),('19050','PA','Lansdowne','Delaware',39.937637,-75.262449),('19052','PA','Lenni','Delaware',39.8938,-75.448),('19053','PA','Feasterville Trevose','Bucks',40.150053,-74.981247),('19054','PA','Levittown','Bucks',40.168199,-74.820529),('19055','PA','Levittown','Bucks',40.149273,-74.836327),('19056','PA','Levittown','Bucks',40.149339,-74.885815),('19057','PA','Levittown','Bucks',40.138001,-74.855821),('19058','PA','Levittown','Bucks',40.1539,-74.8557),('19060','PA','Garnet Valley','Delaware',39.848112,-75.49624),('19061','PA','Marcus Hook','Delaware',39.829299,-75.431257),('19063','PA','Media','Delaware',39.917134,-75.404888),('19064','PA','Springfield','Delaware',39.932078,-75.338962),('19065','PA','Media','Delaware',39.9163,-75.3878),('19066','PA','Merion Station','Montgomery',40.001697,-75.249853),('19067','PA','Morrisville','Bucks',40.209582,-74.817171),('19070','PA','Morton','Delaware',39.906598,-75.325126),('19072','PA','Narberth','Montgomery',40.015263,-75.258078),('19073','PA','Newtown Square','Delaware',39.984404,-75.418886),('19074','PA','Norwood','Delaware',39.889755,-75.297757),('19075','PA','Oreland','Montgomery',40.1147,-75.186595),('19076','PA','Prospect Park','Delaware',39.883709,-75.307608),('19078','PA','Ridley Park','Delaware',39.876314,-75.323034),('19079','PA','Sharon Hill','Delaware',39.903718,-75.269525),('19080','PA','Wayne','Delaware',40.0435,-75.388),('19081','PA','Swarthmore','Delaware',39.898018,-75.346983),('19082','PA','Upper Darby','Delaware',39.958866,-75.268561),('19083','PA','Havertown','Delaware',39.977457,-75.308645),('19085','PA','Villanova','Delaware',40.039229,-75.347843),('19086','PA','Wallingford','Delaware',39.88901,-75.370185),('19087','PA','Wayne','Chester',40.059209,-75.40077),('19088','PA','Wayne','Delaware',40.0438,-75.388),('19089','PA','Wayne','Delaware',40.0435,-75.388),('19090','PA','Willow Grove','Montgomery',40.149936,-75.123541),('19091','PA','Media','Delaware',39.9166,-75.388),('19092','PA','Philadelphia','Philadelphia',39.9543,-75.1832),('19093','PA','Philadelphia','Philadelphia',39.9543,-75.1832),('19094','PA','Woodlyn','Delaware',39.874564,-75.345815),('19095','PA','Wyncote','Montgomery',40.086631,-75.151215),('19096','PA','Wynnewood','Montgomery',39.99296,-75.274476),('19098','PA','Holmes','Delaware',39.9041,-75.3088),('19099','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19101','PA','Philadelphia','Philadelphia',39.9543,-75.1832),('19102','PA','Philadelphia','Philadelphia',39.954023,-75.164149),('19103','PA','Philadelphia','Philadelphia',39.952451,-75.174387),('19104','PA','Philadelphia','Philadelphia',39.960893,-75.198505),('19105','PA','Philadelphia','Philadelphia',39.9543,-75.1832),('19106','PA','Philadelphia','Philadelphia',39.951271,-75.14624),('19107','PA','Philadelphia','Philadelphia',39.952334,-75.158981),('19108','PA','Philadelphia','Philadelphia',39.959662,-75.160506),('19109','PA','Philadelphia','Philadelphia',39.9498,-75.1641),('19110','PA','Philadelphia','Philadelphia',39.9504,-75.164),('19111','PA','Philadelphia','Philadelphia',40.058244,-75.081048),('19112','PA','Philadelphia','Philadelphia',39.895677,-75.19044),('19113','PA','Philadelphia','Delaware',39.872484,-75.260081),('19114','PA','Philadelphia','Philadelphia',40.064246,-75.001087),('19115','PA','Philadelphia','Philadelphia',40.090698,-75.042868),('19116','PA','Philadelphia','Philadelphia',40.116349,-75.014981),('19118','PA','Philadelphia','Philadelphia',40.072569,-75.208051),('19119','PA','Philadelphia','Philadelphia',40.0551,-75.189104),('19120','PA','Philadelphia','Philadelphia',40.032606,-75.121459),('19121','PA','Philadelphia','Philadelphia',39.98117,-75.174827),('19122','PA','Philadelphia','Philadelphia',39.977793,-75.144685),('19123','PA','Philadelphia','Philadelphia',39.964136,-75.148109),('19124','PA','Philadelphia','Philadelphia',40.018032,-75.088993),('19125','PA','Philadelphia','Philadelphia',39.977245,-75.125222),('19126','PA','Philadelphia','Philadelphia',40.055558,-75.13808),('19127','PA','Philadelphia','Philadelphia',40.026922,-75.224829),('19128','PA','Philadelphia','Philadelphia',40.039904,-75.221695),('19129','PA','Philadelphia','Philadelphia',40.011681,-75.187217),('19130','PA','Philadelphia','Philadelphia',39.966983,-75.172957),('19131','PA','Philadelphia','Philadelphia',39.983701,-75.22124),('19132','PA','Philadelphia','Philadelphia',39.99562,-75.170039),('19133','PA','Philadelphia','Philadelphia',39.993007,-75.141016),('19134','PA','Philadelphia','Philadelphia',39.990949,-75.110753),('19135','PA','Philadelphia','Philadelphia',40.02367,-75.049898),('19136','PA','Philadelphia','Philadelphia',40.043148,-75.025048),('19137','PA','Philadelphia','Philadelphia',40.00037,-75.074202),('19138','PA','Philadelphia','Philadelphia',40.056045,-75.157113),('19139','PA','Philadelphia','Philadelphia',39.962642,-75.229616),('19140','PA','Philadelphia','Philadelphia',40.012177,-75.145495),('19141','PA','Philadelphia','Philadelphia',40.036631,-75.144967),('19142','PA','Philadelphia','Philadelphia',39.922934,-75.234667),('19143','PA','Philadelphia','Philadelphia',39.944397,-75.227253),('19144','PA','Philadelphia','Philadelphia',40.033858,-75.174075),('19145','PA','Philadelphia','Philadelphia',39.921597,-75.182896),('19146','PA','Philadelphia','Philadelphia',39.938812,-75.18082),('19147','PA','Philadelphia','Philadelphia',39.937168,-75.155221),('19148','PA','Philadelphia','Philadelphia',39.919718,-75.158356),('19149','PA','Philadelphia','Philadelphia',40.037711,-75.066618),('19150','PA','Philadelphia','Philadelphia',40.072323,-75.171245),('19151','PA','Philadelphia','Philadelphia',39.976025,-75.252898),('19152','PA','Philadelphia','Philadelphia',40.060307,-75.0476),('19153','PA','Philadelphia','Philadelphia',39.9001,-75.232548),('19154','PA','Philadelphia','Philadelphia',40.091502,-74.979527),('19155','PA','Philadelphia','Philadelphia',40.0947,-74.9818),('19160','PA','Philadelphia','Philadelphia',40.0117,-75.1463),('19161','PA','Philadelphia','Philadelphia',40.0614,-75.0795),('19162','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19170','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19171','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19172','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19173','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19175','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19176','PA','Philadelphia','Philadelphia',39.9523,-75.1638),('19177','PA','Philadelphia','Philadelphia',39.9543,-75.1832),('19178','PA','Philadelphia','Philadelphia',39.9543,-75.1832),('19179','PA','Philadelphia','Philadelphia',40.0315,-75.1764),('19181','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19182','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19183','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19184','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19185','PA','Philadelphia','Philadelphia',39.8893,-75.1701),('19187','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19188','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19190','PA','Philadelphia','Philadelphia',39.9484,-75.1442),('19191','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19192','PA','Philadelphia','Philadelphia',39.9543,-75.1832),('19193','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19194','PA','Philadelphia','Philadelphia',39.9543,-75.1827),('19195','PA','Philadelphia','Philadelphia',39.9522,-75.1642),('19196','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19197','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19244','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19255','PA','Philadelphia','Philadelphia',39.9522,-75.1641),('19301','PA','Paoli','Chester',40.04056,-75.482591),('19310','PA','Atglen','Chester',39.943935,-75.972231),('19311','PA','Avondale','Chester',39.821095,-75.771347),('19312','PA','Berwyn','Chester',40.03812,-75.450213),('19316','PA','Brandamore','Chester',40.054082,-75.833825),('19317','PA','Chadds Ford','Delaware',39.858079,-75.598512),('19318','PA','Chatham','Chester',39.8533,-75.8219),('19319','PA','Cheyney','Delaware',39.930034,-75.525622),('19320','PA','Coatesville','Chester',39.980565,-75.825166),('19330','PA','Cochranville','Chester',39.871898,-75.914423),('19331','PA','Concordville','Delaware',39.885,-75.5205),('19333','PA','Devon','Chester',40.045013,-75.422096),('19335','PA','Downingtown','Chester',40.022997,-75.716174),('19339','PA','Concordville','Delaware',39.885,-75.5205),('19340','PA','Concordville','Delaware',39.885,-75.5205),('19341','PA','Exton','Chester',40.042944,-75.636231),('19342','PA','Glen Mills','Delaware',39.897502,-75.501696),('19343','PA','Glenmoore','Chester',40.095349,-75.746934),('19344','PA','Honey Brook','Chester',40.076483,-75.875326),('19345','PA','Immaculata','Chester',40.030731,-75.564981),('19346','PA','Kelton','Chester',39.8031,-75.8755),('19347','PA','Kemblesville','Chester',39.7488,-75.8244),('19348','PA','Kennett Square','Chester',39.856809,-75.706253),('19350','PA','Landenberg','Chester',39.766904,-75.784025),('19351','PA','Lewisville','Chester',39.7225,-75.8752),('19352','PA','Lincoln University','Chester',39.786102,-75.891564),('19353','PA','Lionville','Chester',40.0536,-75.6602),('19354','PA','Lyndell','Chester',40.0594,-75.745),('19355','PA','Malvern','Chester',40.042661,-75.529059),('19357','PA','Mendenhall','Chester',39.8538,-75.6416),('19358','PA','Modena','Chester',39.962335,-75.802129),('19360','PA','New London','Chester',39.7825,-75.8758),('19362','PA','Nottingham','Chester',39.751108,-76.064225),('19363','PA','Oxford','Chester',39.782951,-75.971708),('19365','PA','Parkesburg','Chester',39.963892,-75.920103),('19366','PA','Pocopson','Chester',39.9002,-75.6261),('19367','PA','Pomeroy','Chester',39.964794,-75.882856),('19369','PA','Sadsburyville','Chester',39.985257,-75.889842),('19371','PA','Suplee','Chester',40.0994,-75.8794),('19372','PA','Thorndale','Chester',39.997483,-75.759228),('19373','PA','Thornton','Delaware',39.897792,-75.53554),('19374','PA','Toughkenamon','Chester',39.829841,-75.758973),('19375','PA','Unionville','Chester',39.89475,-75.735483),('19376','PA','Wagontown','Chester',40.0105,-75.843),('19380','PA','West Chester','Chester',39.983904,-75.593608),('19381','PA','West Chester','Chester',39.9611,-75.6044),('19382','PA','West Chester','Chester',39.940614,-75.597571),('19383','PA','West Chester','Chester',39.951218,-75.601307),('19388','PA','West Chester','Chester',39.994613,-75.584993),('19390','PA','West Grove','Chester',39.821595,-75.843766),('19395','PA','Westtown','Chester',39.9308,-75.5522),('19397','PA','Southeastern','Chester',40.0631,-75.4047),('19398','PA','Southeastern','Chester',40.0407,-75.4231),('19399','PA','Southeastern','Chester',40.0704,-75.4251),('19401','PA','Norristown','Montgomery',40.124195,-75.33919),('19403','PA','Norristown','Montgomery',40.141867,-75.385266),('19404','PA','Norristown','Montgomery',40.1213,-75.3402),('19405','PA','Bridgeport','Montgomery',40.10426,-75.340968),('19406','PA','King Of Prussia','Montgomery',40.094129,-75.377226),('19407','PA','Audubon','Montgomery',40.1244,-75.4359),('19408','PA','Eagleville','Montgomery',40.1567,-75.4045),('19409','PA','Fairview Village','Montgomery',40.1577,-75.3875),('19415','PA','Eagleville','Montgomery',40.1215,-75.3405),('19420','PA','Arcola','Montgomery',40.1525,-75.4569),('19421','PA','Birchrunville','Chester',40.138889,-75.633324),('19422','PA','Blue Bell','Montgomery',40.161226,-75.279426),('19423','PA','Cedars','Montgomery',40.2125,-75.3688),('19424','PA','Blue Bell','Montgomery',40.1522,-75.2666),('19425','PA','Chester Springs','Chester',40.097076,-75.651065),('19426','PA','Collegeville','Montgomery',40.190614,-75.450267),('19428','PA','Conshohocken','Montgomery',40.079259,-75.30593),('19429','PA','Conshohocken','Montgomery',40.0791,-75.3019),('19430','PA','Creamery','Montgomery',40.22,-75.4166),('19432','PA','Devault','Chester',40.1269,-75.5331),('19435','PA','Frederick','Montgomery',40.327484,-75.569174),('19436','PA','Gwynedd','Montgomery',40.20143,-75.250962),('19437','PA','Gwynedd Valley','Montgomery',40.184212,-75.262661),('19438','PA','Harleysville','Montgomery',40.269705,-75.385987),('19440','PA','Hatfield','Montgomery',40.280661,-75.29417),('19441','PA','Harleysville','Montgomery',40.2794,-75.3875),('19442','PA','Kimberton','Chester',40.1305,-75.5725),('19443','PA','Kulpsville','Montgomery',40.2458,-75.3383),('19444','PA','Lafayette Hill','Montgomery',40.08724,-75.256621),('19446','PA','Lansdale','Montgomery',40.237837,-75.293251),('19450','PA','Lederach','Montgomery',40.2616,-75.4063),('19451','PA','Mainland','Montgomery',40.2558,-75.3605),('19453','PA','Mont Clare','Montgomery',40.137417,-75.503458),('19454','PA','North Wales','Montgomery',40.224442,-75.249015),('19455','PA','North Wales','Montgomery',40.2108,-75.2786),('19456','PA','Oaks','Montgomery',40.132927,-75.459614),('19457','PA','Parker Ford','Chester',40.204581,-75.584434),('19460','PA','Phoenixville','Chester',40.127703,-75.521535),('19462','PA','Plymouth Meeting','Montgomery',40.116251,-75.291344),('19464','PA','Pottstown','Montgomery',40.253126,-75.632217),('19465','PA','Pottstown','Chester',40.205898,-75.66107),('19468','PA','Royersford','Montgomery',40.201755,-75.5355),('19470','PA','Saint Peters','Chester',40.18,-75.7311),('19472','PA','Sassamansville','Montgomery',40.339207,-75.573725),('19473','PA','Schwenksville','Montgomery',40.255748,-75.467096),('19474','PA','Skippack','Montgomery',40.223873,-75.403743),('19475','PA','Spring City','Chester',40.174684,-75.582074),('19477','PA','Spring House','Montgomery',40.183781,-75.230427),('19478','PA','Spring Mount','Montgomery',40.276511,-75.458204),('19480','PA','Uwchland','Chester',40.0768,-75.6881),('19481','PA','Valley Forge','Chester',40.0969,-75.47),('19482','PA','Valley Forge','Chester',40.0969,-75.47),('19483','PA','Valley Forge','Montgomery',40.08,-75.4159),('19484','PA','Valley Forge','Montgomery',40.1016,-75.3991),('19485','PA','Valley Forge','Montgomery',40.1016,-75.3991),('19486','PA','West Point','Montgomery',40.2066,-75.2997),('19487','PA','King Of Prussia','Chester',40.1024,-75.4785),('19488','PA','Norristown','Chester',40.0959,-75.3733),('19489','PA','Norristown','Chester',40.102,-75.4772),('19490','PA','Worcester','Montgomery',40.2011,-75.3469),('19492','PA','Zieglerville','Montgomery',40.282144,-75.494193),('19493','PA','Valley Forge','Chester',40.0969,-75.47),('19494','PA','Valley Forge','Chester',40.0969,-75.47),('19495','PA','Valley Forge','Chester',40.0969,-75.47),('19496','PA','Valley Forge','Chester',40.0969,-75.47),('19501','PA','Adamstown','Lancaster',40.241793,-76.055043),('19503','PA','Bally','Berks',40.403587,-75.58614),('19504','PA','Barto','Berks',40.406069,-75.585008),('19505','PA','Bechtelsville','Berks',40.373963,-75.622686),('19506','PA','Bernville','Berks',40.44631,-76.119196),('19507','PA','Bethel','Berks',40.488958,-76.273221),('19508','PA','Birdsboro','Berks',40.267156,-75.825402),('19510','PA','Blandon','Berks',40.446424,-75.881053),('19511','PA','Bowers','Berks',40.486059,-75.741603),('19512','PA','Boyertown','Berks',40.340758,-75.665004),('19516','PA','Centerport','Berks',40.486726,-76.00719),('19518','PA','Douglassville','Berks',40.273312,-75.740477),('19519','PA','Earlville','Berks',40.319983,-75.732533),('19520','PA','Elverson','Chester',40.157803,-75.796205),('19522','PA','Fleetwood','Berks',40.448939,-75.81837),('19523','PA','Geigertown','Berks',40.206468,-75.83836),('19525','PA','Gilbertsville','Montgomery',40.307936,-75.592258),('19526','PA','Hamburg','Berks',40.546933,-75.987537),('19529','PA','Kempton','Berks',40.630619,-75.839777),('19530','PA','Kutztown','Berks',40.531295,-75.773874),('19533','PA','Leesport','Berks',40.435676,-75.987649),('19534','PA','Lenhartsville','Berks',40.573973,-75.87428),('19535','PA','Limekiln','Berks',40.340764,-75.805179),('19536','PA','Lyon Station','Berks',40.480065,-75.757374),('19538','PA','Maxatawny','Berks',40.541474,-75.69997),('19539','PA','Mertztown','Berks',40.496322,-75.68354),('19540','PA','Mohnton','Berks',40.253443,-75.970618),('19541','PA','Mohrsville','Berks',40.483169,-76.016707),('19542','PA','Monocacy Station','Berks',40.2578,-75.7428),('19543','PA','Morgantown','Berks',40.165074,-75.886863),('19544','PA','Mount Aetna','Berks',40.418049,-76.29589),('19545','PA','New Berlinville','Berks',40.340898,-75.629811),('19547','PA','Oley','Berks',40.384915,-75.762799),('19548','PA','Pine Forge','Berks',40.2827,-75.6911),('19549','PA','Port Clinton','Schuylkill',40.58095,-76.024612),('19550','PA','Rehrersburg','Berks',40.457417,-76.245363),('19551','PA','Robesonia','Berks',40.35584,-76.137991),('19554','PA','Shartlesville','Berks',40.512968,-76.105126),('19555','PA','Shoemakersville','Berks',40.497842,-75.963476),('19559','PA','Strausstown','Berks',40.492308,-76.184853),('19560','PA','Temple','Berks',40.407286,-75.911515),('19562','PA','Topton','Berks',40.5015,-75.700689),('19564','PA','Virginville','Berks',40.523792,-75.87241),('19565','PA','Wernersville','Berks',40.333292,-76.087337),('19567','PA','Womelsdorf','Berks',40.374218,-76.202867),('19601','PA','Reading','Berks',40.348352,-75.936232),('19602','PA','Reading','Berks',40.330058,-75.917821),('19603','PA','Reading','Berks',40.3362,-75.9277),('19604','PA','Reading','Berks',40.351861,-75.913026),('19605','PA','Reading','Berks',40.387356,-75.934336),('19606','PA','Reading','Berks',40.327438,-75.873349),('19607','PA','Reading','Berks',40.304053,-75.95743),('19608','PA','Reading','Berks',40.317414,-76.026135),('19609','PA','Reading','Berks',40.326925,-75.992937),('19610','PA','Reading','Berks',40.335019,-75.969515),('19611','PA','Reading','Berks',40.324674,-75.942857),('19612','PA','Reading','Berks',40.3683,-75.9116),('19640','PA','Reading','Berks',40.3683,-75.9116),('19701','DE','Bear','New Castle',39.600872,-75.690335),('19702','DE','Newark','New Castle',39.632675,-75.707619),('19703','DE','Claymont','New Castle',39.802185,-75.463453),('19706','DE','Delaware City','New Castle',39.573285,-75.591252),('19707','DE','Hockessin','New Castle',39.782262,-75.688252),('19708','DE','Kirkwood','New Castle',39.5716,-75.6966),('19709','DE','Middletown','New Castle',39.470206,-75.699234),('19710','DE','Montchanin','New Castle',39.788562,-75.588815),('19711','DE','Newark','New Castle',39.697683,-75.738754),('19712','DE','Newark','New Castle',39.6836,-75.75),('19713','DE','Newark','New Castle',39.668942,-75.715551),('19714','DE','Newark','New Castle',39.6836,-75.75),('19715','DE','Newark','New Castle',39.6832,-75.749),('19716','DE','Newark','New Castle',39.688988,-75.75767),('19717','DE','Newark','New Castle',39.679706,-75.752189),('19718','DE','Newark','New Castle',39.6836,-75.75),('19720','DE','New Castle','New Castle',39.671989,-75.592343),('19721','DE','New Castle','New Castle',39.6619,-75.5666),('19725','DE','Newark','New Castle',39.6836,-75.75),('19726','DE','Newark','New Castle',39.6836,-75.75),('19730','DE','Odessa','New Castle',39.455692,-75.658363),('19731','DE','Port Penn','New Castle',39.516268,-75.577368),('19732','DE','Rockland','New Castle',39.777212,-75.56919),('19733','DE','Saint Georges','New Castle',39.5573,-75.652074),('19734','DE','Townsend','New Castle',39.391288,-75.666641),('19735','DE','Winterthur','New Castle',39.8027,-75.5919),('19736','DE','Yorklyn','New Castle',39.790911,-75.649341),('19801','DE','Wilmington','New Castle',39.737934,-75.548722),('19802','DE','Wilmington','New Castle',39.756418,-75.532881),('19803','DE','Wilmington','New Castle',39.794217,-75.533962),('19804','DE','Wilmington','New Castle',39.720296,-75.609872),('19805','DE','Wilmington','New Castle',39.74313,-75.583518),('19806','DE','Wilmington','New Castle',39.759446,-75.56369),('19807','DE','Wilmington','New Castle',39.78145,-75.603651),('19808','DE','Wilmington','New Castle',39.735302,-75.66149),('19809','DE','Wilmington','New Castle',39.768808,-75.497335),('19810','DE','Wilmington','New Castle',39.818373,-75.503437),('19850','DE','Wilmington','New Castle',39.7458,-75.5469),('19880','DE','Wilmington','New Castle',39.7458,-75.5469),('19884','DE','Wilmington','New Castle',39.7458,-75.5469),('19885','DE','Wilmington','New Castle',39.7458,-75.5469),('19886','DE','Wilmington','New Castle',39.7458,-75.5469),('19887','DE','Wilmington','New Castle',39.8187,-75.508),('19889','DE','Wilmington','New Castle',39.7458,-75.5469),('19890','DE','Wilmington','New Castle',39.7458,-75.5469),('19891','DE','Wilmington','New Castle',39.7458,-75.5469),('19892','DE','Wilmington','New Castle',39.7458,-75.5469),('19893','DE','Wilmington','New Castle',39.7458,-75.5469),('19894','DE','Wilmington','New Castle',39.7458,-75.5469),('19895','DE','Wilmington','New Castle',39.7458,-75.5469),('19896','DE','Wilmington','New Castle',39.7458,-75.5469),('19897','DE','Wilmington','New Castle',39.7856,-75.5458),('19898','DE','Wilmington','New Castle',39.7458,-75.5469),('19899','DE','Wilmington','New Castle',39.7458,-75.5469),('19901','DE','Dover','Kent',39.156692,-75.51039),('19902','DE','Dover Afb','Kent',39.125035,-75.480618),('19903','DE','Dover','Kent',39.158,-75.5247),('19904','DE','Dover','Kent',39.165545,-75.564787),('19905','DE','Dover','Kent',39.158,-75.5247),('19906','DE','Dover','Kent',39.1535,-75.5431),('19930','DE','Bethany Beach','Sussex',38.540641,-75.060986),('19931','DE','Bethel','Sussex',38.571695,-75.621548),('19933','DE','Bridgeville','Sussex',38.733031,-75.602868),('19934','DE','Camden Wyoming','Kent',39.09984,-75.580265),('19936','DE','Cheswold','Kent',39.218569,-75.58635),('19938','DE','Clayton','Kent',39.267807,-75.667716),('19939','DE','Dagsboro','Sussex',38.557748,-75.21389),('19940','DE','Delmar','Sussex',38.477529,-75.565152),('19941','DE','Ellendale','Sussex',38.801632,-75.426564),('19943','DE','Felton','Kent',39.012452,-75.572109),('19944','DE','Fenwick Island','Sussex',38.463415,-75.054698),('19945','DE','Frankford','Sussex',38.517802,-75.180128),('19946','DE','Frederica','Kent',39.035111,-75.457981),('19947','DE','Georgetown','Sussex',38.683046,-75.389688),('19950','DE','Greenwood','Sussex',38.818451,-75.596743),('19951','DE','Harbeson','Sussex',38.689047,-75.244857),('19952','DE','Harrington','Kent',38.913392,-75.59949),('19953','DE','Hartly','Kent',39.15397,-75.701362),('19954','DE','Houston','Kent',38.909797,-75.512911),('19955','DE','Kenton','Kent',39.226325,-75.667219),('19956','DE','Laurel','Sussex',38.549144,-75.556054),('19958','DE','Lewes','Sussex',38.743615,-75.169022),('19960','DE','Lincoln','Sussex',38.855956,-75.406922),('19961','DE','Little Creek','Kent',39.1669,-75.4486),('19962','DE','Magnolia','Kent',39.068826,-75.505481),('19963','DE','Milford','Sussex',38.919686,-75.413757),('19964','DE','Marydel','Kent',39.103115,-75.730121),('19966','DE','Millsboro','Sussex',38.59535,-75.231132),('19967','DE','Millville','Sussex',38.535935,-75.121966),('19968','DE','Milton','Sussex',38.773914,-75.286878),('19969','DE','Nassau','Sussex',38.7519,-75.188),('19970','DE','Ocean View','Sussex',38.549945,-75.100159),('19971','DE','Rehoboth Bch','Sussex',38.708506,-75.098809),('19973','DE','Seaford','Sussex',38.64445,-75.610127),('19975','DE','Selbyville','Sussex',38.468992,-75.152919),('19977','DE','Smyrna','Kent',39.288328,-75.598257),('19979','DE','Viola','Kent',39.04467,-75.571974),('19980','DE','Woodside','Kent',39.07027,-75.570575),('20001','DC','Washington','District Of Columbia',38.909103,-77.01756),('20002','DC','Washington','District Of Columbia',38.902573,-76.990027),('20003','DC','Washington','District Of Columbia',38.881997,-76.993203),('20004','DC','Washington','District Of Columbia',38.8955,-77.027548),('20005','DC','Washington','District Of Columbia',38.905083,-77.031436),('20006','DC','Washington','District Of Columbia',38.898956,-77.042575),('20007','DC','Washington','District Of Columbia',38.913099,-77.071895),('20008','DC','Washington','District Of Columbia',38.933912,-77.059431),('20009','DC','Washington','District Of Columbia',38.91928,-77.037922),('20010','DC','Washington','District Of Columbia',38.932825,-77.031798),('20011','DC','Washington','District Of Columbia',38.952575,-77.020914),('20012','DC','Washington','District Of Columbia',38.978336,-77.028777),('20013','DC','Washington','District Of Columbia',38.895,-77.0366),('20015','DC','Washington','District Of Columbia',38.965376,-77.067298),('20016','DC','Washington','District Of Columbia',38.942187,-77.089323),('20017','DC','Washington','District Of Columbia',38.937704,-76.990949),('20018','DC','Washington','District Of Columbia',38.92863,-76.974897),('20019','DC','Washington','District Of Columbia',38.892269,-76.93848),('20020','DC','Washington','District Of Columbia',38.864978,-76.974286),('20022','DC','Washington','District Of Columbia',38.9008,-77.0104),('20023','DC','Washington','District Of Columbia',38.9008,-77.0104),('20024','DC','Washington','District Of Columbia',38.88146,-77.02614),('20026','DC','Washington','District Of Columbia',38.895,-77.0366),('20027','DC','Washington','District Of Columbia',38.9008,-76.9827),('20029','DC','Washington','District Of Columbia',38.8938,-76.9501),('20030','DC','Washington','District Of Columbia',38.8648,-76.9707),('20032','DC','Washington','District Of Columbia',38.833719,-77.006591),('20033','DC','Washington','District Of Columbia',38.895,-77.0366),('20035','DC','Washington','District Of Columbia',38.9026,-77.0398),('20036','DC','Washington','District Of Columbia',38.907009,-77.041802),('20037','DC','Washington','District Of Columbia',38.900238,-77.052787),('20038','DC','Washington','District Of Columbia',38.9008,-77.0328),('20039','DC','Washington','District Of Columbia',38.9528,-77.0234),('20040','DC','Washington','District Of Columbia',38.9658,-77.0276),('20041','DC','Washington','District Of Columbia',38.89037,-77.031999),('20042','DC','Washington','District Of Columbia',38.9164,-76.9949),('20043','DC','Washington','District Of Columbia',38.9033,-77.0325),('20044','DC','Washington','District Of Columbia',38.8947,-77.0287),('20045','DC','Washington','District Of Columbia',38.8947,-77.0287),('20046','DC','Washington','District Of Columbia',38.9164,-76.9949),('20047','DC','Washington','District Of Columbia',38.9164,-76.9949),('20049','DC','Washington','District Of Columbia',38.8963,-77.02),('20050','DC','Washington','District Of Columbia',38.895,-77.0366),('20051','DC','Washington','District Of Columbia',38.9164,-76.9949),('20052','DC','Washington','District Of Columbia',38.900126,-77.046981),('20053','DC','Washington','District Of Columbia',38.9164,-76.9949),('20055','DC','Washington','District Of Columbia',38.9164,-76.9949),('20056','DC','Washington','District Of Columbia',38.9158,-77.0321),('20057','DC','Washington','District Of Columbia',38.908612,-77.078658),('20058','DC','Washington','District Of Columbia',38.9164,-76.9949),('20059','DC','Washington','District Of Columbia',38.9226,-77.0212),('20060','DC','Washington','District Of Columbia',38.9164,-76.9949),('20061','DC','Washington','District Of Columbia',38.9164,-76.9949),('20062','DC','Washington','District Of Columbia',38.9164,-76.9949),('20063','DC','Washington','District Of Columbia',38.9055,-77.0467),('20064','DC','Washington','District Of Columbia',38.936358,-76.999358),('20065','DC','Washington','District Of Columbia',38.9164,-76.9949),('20066','DC','Washington','District Of Columbia',38.9164,-76.9949),('20067','DC','Washington','District Of Columbia',38.9164,-76.9949),('20068','DC','Washington','District Of Columbia',38.9002,-77.0437),('20069','DC','Washington','District Of Columbia',38.9164,-76.9949),('20070','DC','Washington','District Of Columbia',38.9164,-76.9949),('20071','DC','Washington','District Of Columbia',38.9164,-76.9949),('20073','DC','Washington','District Of Columbia',38.9164,-76.9949),('20074','DC','Washington','District Of Columbia',38.9164,-76.9949),('20075','DC','Washington','District Of Columbia',38.9164,-76.9949),('20076','DC','Washington','District Of Columbia',38.9164,-76.9949),('20077','DC','Washington','District Of Columbia',38.9164,-76.9949),('20078','DC','Washington','District Of Columbia',38.9164,-76.9949),('20080','DC','Washington','District Of Columbia',38.9164,-76.9949),('20081','DC','Washington','District Of Columbia',38.9164,-76.9949),('20082','DC','Washington','District Of Columbia',38.9164,-76.9949),('20088','DC','Washington','District Of Columbia',38.9417,-77.0771),('20090','DC','Washington','District Of Columbia',38.9164,-76.9949),('20091','DC','Washington','District Of Columbia',38.895,-77.0366),('20097','DC','Washington','District Of Columbia',38.8858,-77.0063),('20098','DC','Washington','District Of Columbia',38.895,-77.0366),('20101','VA','Dulles','Loudoun',38.9886,-77.4507),('20102','VA','Dulles','Loudoun',38.9886,-77.4507),('20103','VA','Dulles','Loudoun',38.9886,-77.4507),('20104','VA','Dulles','Loudoun',38.9886,-77.4507),('20105','VA','Aldie','Loudoun',38.941237,-77.580378),('20106','VA','Amissville','Culpeper',38.689934,-77.993223),('20107','VA','Arcola','Loudoun',38.9663,-77.5277),('20108','VA','Manassas','Manassas City',38.7518,-77.4728),('20109','VA','Manassas','Prince William',38.785519,-77.51818),('20110','VA','Manassas','Manassas City',38.751308,-77.480458),('20111','VA','Manassas','Prince William',38.763171,-77.442276),('20112','VA','Manassas','Prince William',38.682703,-77.434071),('20113','VA','Manassas','Manassas Park City',38.7776,-77.5197),('20115','VA','Marshall','Fauquier',38.836506,-77.890368),('20116','VA','Marshall','Fauquier',38.8256,-77.8947),('20117','VA','Middleburg','Loudoun',38.978803,-77.743287),('20118','VA','Middleburg','Loudoun',38.967799,-77.737461),('20119','VA','Catlett','Fauquier',38.636701,-77.636339),('20120','VA','Centreville','Fairfax',38.850328,-77.452724),('20121','VA','Centreville','Fairfax',38.82126,-77.448659),('20122','VA','Centreville','Fairfax',38.8422,-77.4715),('20124','VA','Clifton','Fairfax',38.796109,-77.400109),('20128','VA','Orlean','Fauquier',38.7606,-77.9514),('20129','VA','Paeonian Springs','Loudoun',39.15278,-77.605739),('20130','VA','Paris','Clarke',39.024319,-77.943534),('20131','VA','Philomont','Loudoun',39.0379,-77.7703),('20132','VA','Purcellville','Loudoun',39.153243,-77.719204),('20134','VA','Purcellville','Loudoun',39.1393,-77.7138),('20135','VA','Bluemont','Clarke',39.093775,-77.857116),('20136','VA','Bristow','Prince William',38.745635,-77.562194),('20137','VA','Broad Run','Fauquier',38.816742,-77.708074),('20138','VA','Calverton','Fauquier',38.630238,-77.672951),('20139','VA','Casanova','Fauquier',38.649531,-77.70006),('20140','VA','Rectortown','Fauquier',38.918124,-77.872436),('20141','VA','Round Hill','Loudoun',39.120747,-77.781192),('20142','VA','Round Hill','Loudoun',39.1031,-77.7923),('20143','VA','Catharpin','Prince William',38.859556,-77.564143),('20144','VA','Delaplane','Fauquier',38.907572,-77.926866),('20146','VA','Ashburn','Loudoun',39.0322,-77.4985),('20147','VA','Ashburn','Loudoun',39.043004,-77.48806),('20148','VA','Ashburn','Loudoun',38.991647,-77.520513),('20149','VA','Ashburn','Loudoun',39.0322,-77.4985),('20151','VA','Chantilly','Fairfax',38.896466,-77.438845),('20152','VA','Chantilly','Loudoun',38.910692,-77.508855),('20153','VA','Chantilly','Fairfax',38.8857,-77.4403),('20155','VA','Gainesville','Prince William',38.797717,-77.620686),('20156','VA','Gainesville','Prince William',38.8004,-77.636),('20158','VA','Hamilton','Loudoun',39.13653,-77.663474),('20159','VA','Hamilton','Loudoun',39.1376,-77.6636),('20160','VA','Lincoln','Loudoun',39.1148,-77.6962),('20163','VA','Sterling','Loudoun',39.0061,-77.4288),('20164','VA','Sterling','Loudoun',39.01214,-77.393336),('20165','VA','Sterling','Loudoun',39.044135,-77.389755),('20166','VA','Sterling','Loudoun',38.991028,-77.434165),('20167','VA','Sterling','Loudoun',39.0061,-77.4288),('20168','VA','Haymarket','Prince William',38.8128,-77.6362),('20169','VA','Haymarket','Prince William',38.856445,-77.641661),('20170','VA','Herndon','Fairfax',38.979657,-77.382402),('20171','VA','Herndon','Fairfax',38.932114,-77.401953),('20172','VA','Herndon','Fairfax',38.9335,-77.3477),('20175','VA','Leesburg','Loudoun',39.078237,-77.581107),('20176','VA','Leesburg','Loudoun',39.129426,-77.529411),('20177','VA','Leesburg','Loudoun',39.128,-77.5686),('20178','VA','Leesburg','Loudoun',39.128,-77.5686),('20180','VA','Lovettsville','Loudoun',39.267476,-77.625305),('20181','VA','Nokesville','Prince William',38.694899,-77.572613),('20182','VA','Nokesville','Prince William',38.6841,-77.5616),('20184','VA','Upperville','Fauquier',39.002392,-77.867751),('20185','VA','Upperville','Fauquier',38.9932,-77.8803),('20186','VA','Warrenton','Fauquier',38.701923,-77.821245),('20187','VA','Warrenton','Fauquier',38.738883,-77.744671),('20188','VA','Warrenton','Fauquier',38.7129,-77.7945),('20189','VA','Dulles','Loudoun',38.8951,-77.0369),('20190','VA','Reston','Fairfax',38.959631,-77.346093),('20191','VA','Reston','Fairfax',38.934709,-77.347032),('20192','VA','Herndon','Fairfax',38.9496,-77.366),('20193','VA','Reston','Fairfax',38.9335,-77.3477),('20194','VA','Reston','Fairfax',38.980982,-77.344439),('20195','VA','Reston','Fairfax',38.9335,-77.3477),('20196','VA','Reston','Fairfax',38.9253,-77.3971),('20197','VA','Waterford','Loudoun',39.195454,-77.627818),('20198','VA','The Plains','Fauquier',38.885591,-77.761881),('20199','VA','Dulles','Loudoun',39.0011,-77.4562),('20201','DC','Washington','District Of Columbia',38.9164,-76.9949),('20202','DC','Washington','District Of Columbia',38.9164,-76.9949),('20203','DC','Washington','District Of Columbia',38.9164,-76.9949),('20204','DC','Washington','District Of Columbia',38.9164,-76.9949),('20206','DC','Washington','District Of Columbia',38.9164,-76.9949),('20207','DC','Washington','District Of Columbia',38.9164,-76.9949),('20208','DC','Washington','District Of Columbia',38.9164,-76.9949),('20210','DC','Washington','District Of Columbia',38.9164,-76.9949),('20211','DC','Washington','District Of Columbia',38.9164,-76.9949),('20212','DC','Washington','District Of Columbia',38.8971,-77.0084),('20213','DC','Washington','District Of Columbia',38.9164,-76.9949),('20214','DC','Washington','District Of Columbia',38.9164,-76.9949),('20215','DC','Washington','District Of Columbia',38.9164,-76.9949),('20216','DC','Washington','District Of Columbia',38.9164,-76.9949),('20217','DC','Washington','District Of Columbia',38.9164,-76.9949),('20218','DC','Washington','District Of Columbia',38.9164,-76.9949),('20219','DC','Washington','District Of Columbia',38.9164,-76.9949),('20220','DC','Washington','District Of Columbia',38.9164,-76.9949),('20221','DC','Washington','District Of Columbia',38.9164,-76.9949),('20222','DC','Washington','District Of Columbia',38.9164,-76.9949),('20223','DC','Washington','District Of Columbia',38.8976,-77.0424),('20224','DC','Washington','District Of Columbia',38.9164,-76.9949),('20226','DC','Washington','District Of Columbia',38.9164,-76.9949),('20227','DC','Washington','District Of Columbia',38.9164,-76.9949),('20228','DC','Washington','District Of Columbia',38.9164,-76.9949),('20229','DC','Washington','District Of Columbia',38.9164,-76.9949),('20230','DC','Washington','District Of Columbia',38.9164,-76.9949),('20232','DC','Washington','District Of Columbia',38.9164,-76.9949),('20233','DC','Washington','District Of Columbia',38.9164,-76.9949),('20235','DC','Washington','District Of Columbia',38.9164,-76.9949),('20237','DC','Washington','District Of Columbia',38.8951,-77.0369),('20238','DC','Washington','District Of Columbia',38.895,-77.0366),('20239','DC','Washington','District Of Columbia',38.9164,-76.9949),('20240','DC','Washington','District Of Columbia',38.9164,-76.9949),('20241','DC','Washington','District Of Columbia',38.9164,-76.9949),('20242','DC','Washington','District Of Columbia',38.9164,-76.9949),('20244','DC','Washington','District Of Columbia',38.9164,-76.9949),('20245','DC','Washington','District Of Columbia',38.9164,-76.9949),('20250','DC','Washington','District Of Columbia',38.9164,-76.9949),('20251','DC','Washington','District Of Columbia',38.9164,-76.9949),('20254','DC','Washington','District Of Columbia',38.9164,-76.9949),('20260','DC','Washington','District Of Columbia',38.8836,-77.02),('20261','DC','Washington','District Of Columbia',38.9164,-76.9949),('20262','DC','Washington','District Of Columbia',38.9164,-76.9949),('20265','DC','Washington','District Of Columbia',38.9164,-76.9949),('20266','DC','Washington','District Of Columbia',38.9164,-76.9949),('20268','DC','Washington','District Of Columbia',38.9164,-76.9949),('20270','DC','Washington','District Of Columbia',38.9164,-76.9949),('20277','DC','Washington','District Of Columbia',38.9164,-76.9949),('20289','DC','Washington','District Of Columbia',38.9164,-76.9949),('20299','DC','Washington','District Of Columbia',38.895,-77.0366),('20301','DC','Washington','District Of Columbia',38.8829,-77.0357),('20303','DC','Washington','District Of Columbia',38.9171,-76.994),('20306','DC','Washington','District Of Columbia',38.9768,-77.0323),('20307','DC','Washington','District Of Columbia',38.974772,-77.031354),('20310','DC','Washington','District Of Columbia',38.8575,-77.0527),('20314','DC','Washington','District Of Columbia',38.9164,-76.9949),('20317','DC','Washington','District Of Columbia',38.93571,-77.010236),('20318','DC','Washington','District Of Columbia',38.9164,-76.9949),('20319','DC','Washington','District Of Columbia',38.86817,-77.016986),('20330','DC','Washington','District Of Columbia',38.8575,-77.0527),('20340','DC','Washington','District Of Columbia',38.9164,-76.9949),('20350','DC','Washington','District Of Columbia',38.9164,-76.9949),('20355','DC','Washington','District Of Columbia',38.8951,-77.0369),('20370','DC','Washington','District Of Columbia',38.9164,-76.9949),('20372','DC','Washington','District Of Columbia',38.9164,-76.9949),('20373','DC','Naval Anacost Annex','District Of Columbia',38.858625,-77.007865),('20374','DC','Washington Navy Yard','District Of Columbia',38.8742,-76.9943),('20375','DC','Washington','District Of Columbia',38.822713,-77.023227),('20376','DC','Washington Navy Yard','District Of Columbia',38.8763,-76.9932),('20380','DC','Washington','District Of Columbia',38.9164,-76.9949),('20388','DC','Washington Navy Yard','District Of Columbia',38.8728,-76.9961),('20389','DC','Washington','District Of Columbia',38.9164,-76.9949),('20390','DC','Washington','District Of Columbia',38.87898,-76.993163),('20391','DC','Washington Navy Yard','District Of Columbia',38.9164,-76.9949),('20392','DC','Washington','District Of Columbia',38.9164,-76.9949),('20393','DC','Washington','District Of Columbia',38.9164,-76.9949),('20394','DC','Washington','District Of Columbia',38.9164,-76.9949),('20395','DC','Washington','District Of Columbia',38.8619,-76.9738),('20398','DC','Washington Navy Yard','District Of Columbia',38.9164,-76.9949),('20401','DC','Washington','District Of Columbia',38.9164,-76.9949),('20402','DC','Washington','District Of Columbia',38.9164,-76.9949),('20403','DC','Washington','District Of Columbia',38.9164,-76.9949),('20404','DC','Washington','District Of Columbia',38.9164,-76.9949),('20405','DC','Washington','District Of Columbia',38.9164,-76.9949),('20406','DC','Washington','District Of Columbia',38.9164,-76.9949),('20407','DC','Washington','District Of Columbia',38.9164,-76.9949),('20408','DC','Washington','District Of Columbia',38.9164,-76.9949),('20409','DC','Washington','District Of Columbia',38.9164,-76.9949),('20410','DC','Washington','District Of Columbia',38.9164,-76.9949),('20411','DC','Washington','District Of Columbia',38.9164,-76.9949),('20412','DC','Washington','District Of Columbia',38.9164,-76.9949),('20413','DC','Washington','District Of Columbia',38.9164,-76.9949),('20414','DC','Washington','District Of Columbia',38.9164,-76.9949),('20415','DC','Washington','District Of Columbia',38.9164,-76.9949),('20416','DC','Washington','District Of Columbia',38.9164,-76.9949),('20418','DC','Washington','District Of Columbia',38.9164,-76.9949),('20419','DC','Washington','District Of Columbia',38.9164,-76.9949),('20420','DC','Washington','District Of Columbia',38.9164,-76.9949),('20421','DC','Washington','District Of Columbia',38.9164,-76.9949),('20422','DC','Washington','District Of Columbia',38.9164,-76.9949),('20423','DC','Washington','District Of Columbia',38.9164,-76.9949),('20424','DC','Washington','District Of Columbia',38.9164,-76.9949),('20425','DC','Washington','District Of Columbia',38.9164,-76.9949),('20426','DC','Washington','District Of Columbia',38.9164,-76.9949),('20427','DC','Washington','District Of Columbia',38.9164,-76.9949),('20428','DC','Washington','District Of Columbia',38.9164,-76.9949),('20429','DC','Washington','District Of Columbia',38.9164,-76.9949),('20431','DC','Washington','District Of Columbia',38.9164,-76.9949),('20433','DC','Washington','District Of Columbia',38.9164,-76.9949),('20434','DC','Washington','District Of Columbia',38.9058,-77.0472),('20435','DC','Washington','District Of Columbia',38.9164,-76.9949),('20436','DC','Washington','District Of Columbia',38.9164,-76.9949),('20437','DC','Washington','District Of Columbia',38.9164,-76.9949),('20439','DC','Washington','District Of Columbia',38.8991,-77.035),('20440','DC','Washington','District Of Columbia',38.9164,-76.9949),('20441','DC','Washington','District Of Columbia',38.9164,-76.9949),('20442','DC','Washington','District Of Columbia',38.9164,-76.9949),('20444','DC','Washington','District Of Columbia',38.9164,-76.9949),('20447','DC','Washington','District Of Columbia',38.9164,-76.9949),('20451','DC','Washington','District Of Columbia',38.9164,-76.9949),('20453','DC','Washington','District Of Columbia',38.9164,-76.9949),('20456','DC','Washington','District Of Columbia',38.9164,-76.9949),('20460','DC','Washington','District Of Columbia',38.9164,-76.9949),('20463','DC','Washington','District Of Columbia',38.9164,-76.9949),('20468','DC','Washington','District Of Columbia',38.895,-77.0366),('20469','DC','Washington','District Of Columbia',38.9164,-76.9949),('20470','DC','Washington','District Of Columbia',38.895,-77.0366),('20472','DC','Washington','District Of Columbia',38.9164,-76.9949),('20500','DC','Washington','District Of Columbia',38.8985,-77.0371),('20501','DC','Washington','District Of Columbia',38.8985,-77.0371),('20502','DC','Washington','District Of Columbia',38.8985,-77.0371),('20503','DC','Washington','District Of Columbia',38.9164,-76.9949),('20504','DC','Washington','District Of Columbia',38.9164,-76.9949),('20505','DC','Washington','District Of Columbia',38.9164,-76.9949),('20506','DC','Washington','District Of Columbia',38.9164,-76.9949),('20507','DC','Washington','District Of Columbia',38.9164,-76.9949),('20508','DC','Washington','District Of Columbia',38.9164,-76.9949),('20509','DC','Washington','District Of Columbia',38.8951,-77.0369),('20510','DC','Washington','District Of Columbia',38.9164,-76.9949),('20511','DC','Washington','District Of Columbia',38.977,-77.0527),('20515','DC','Washington','District Of Columbia',38.9164,-76.9949),('20520','DC','Washington','District Of Columbia',38.9164,-76.9949),('20521','DC','Washington','District Of Columbia',38.9164,-76.9949),('20522','DC','Washington','District Of Columbia',38.9164,-76.9949),('20523','DC','Washington','District Of Columbia',38.9164,-76.9949),('20524','DC','Washington','District Of Columbia',38.9164,-76.9949),('20525','DC','Washington','District Of Columbia',38.9164,-76.9949),('20526','DC','Washington','District Of Columbia',38.9164,-76.9949),('20527','DC','Washington','District Of Columbia',38.9164,-76.9949),('20528','DC','Washington','District Of Columbia',38.895,-77.0367),('20529','DC','Washington','District Of Columbia',38.8951,-77.0364),('20530','DC','Washington','District Of Columbia',38.894,-77.025),('20531','DC','Washington','District Of Columbia',38.9164,-76.9949),('20532','DC','Washington','District Of Columbia',38.9164,-76.9949),('20533','DC','Washington','District Of Columbia',38.9164,-76.9949),('20534','DC','Washington','District Of Columbia',38.9164,-76.9949),('20535','DC','Washington','District Of Columbia',38.9164,-76.9949),('20536','DC','Washington','District Of Columbia',38.9164,-76.9949),('20537','DC','Washington','District Of Columbia',38.9164,-76.9949),('20538','DC','Washington','District Of Columbia',38.9164,-76.9949),('20539','DC','Washington','District Of Columbia',38.9164,-76.9949),('20540','DC','Washington','District Of Columbia',38.9164,-76.9949),('20541','DC','Washington','District Of Columbia',38.9164,-76.9949),('20542','DC','Washington','District Of Columbia',38.9164,-76.9949),('20543','DC','Washington','District Of Columbia',38.9164,-76.9949),('20544','DC','Washington','District Of Columbia',38.8968,-77.0079),('20546','DC','Washington','District Of Columbia',38.9164,-76.9949),('20547','DC','Washington','District Of Columbia',38.9164,-76.9949),('20548','DC','Washington','District Of Columbia',38.9164,-76.9949),('20549','DC','Washington','District Of Columbia',38.9164,-76.9949),('20551','DC','Washington','District Of Columbia',38.9164,-76.9949),('20552','DC','Washington','District Of Columbia',38.8982,-77.0406),('20553','DC','Washington','District Of Columbia',38.9164,-76.9949),('20554','DC','Washington','District Of Columbia',38.9164,-76.9949),('20555','DC','Washington','District Of Columbia',38.9164,-76.9949),('20557','DC','Washington','District Of Columbia',38.9164,-76.9949),('20558','DC','Washington','District Of Columbia',38.895,-77.0366),('20559','DC','Washington','District Of Columbia',38.9164,-76.9949),('20560','DC','Washington','District Of Columbia',38.8888,-77.0254),('20565','DC','Washington','District Of Columbia',38.9164,-76.9949),('20566','DC','Washington','District Of Columbia',38.8958,-77.056),('20570','DC','Washington','District Of Columbia',38.9164,-76.9949),('20571','DC','Washington','District Of Columbia',38.9164,-76.9949),('20572','DC','Washington','District Of Columbia',38.9164,-76.9949),('20573','DC','Washington','District Of Columbia',38.9164,-76.9949),('20575','DC','Washington','District Of Columbia',38.9164,-76.9949),('20576','DC','Washington','District Of Columbia',38.9164,-76.9949),('20577','DC','Washington','District Of Columbia',38.9164,-76.9949),('20578','DC','Washington','District Of Columbia',38.895,-77.0366),('20579','DC','Washington','District Of Columbia',38.9164,-76.9949),('20580','DC','Washington','District Of Columbia',38.9164,-76.9949),('20581','DC','Washington','District Of Columbia',38.9164,-76.9949),('20585','DC','Washington','District Of Columbia',38.9164,-76.9949),('20586','DC','Washington','District Of Columbia',38.9164,-76.9949),('20588','MD','Dhs','Prince Georges',39.994613,-75.584993),('20590','DC','Washington','District Of Columbia',38.9164,-76.9949),('20591','DC','Washington','District Of Columbia',38.9164,-76.9949),('20593','DC','Washington','District Of Columbia',38.9164,-76.9949),('20594','DC','Washington','District Of Columbia',38.9164,-76.9949),('20597','DC','Washington','District Of Columbia',38.895,-77.0366),('20598','VA','Dhs','Fairfax',38.880661,-77.23204),('20599','DC','Washington','District Of Columbia',38.895,-77.0366),('20601','MD','Waldorf','Charles',38.620982,-76.865898),('20602','MD','Waldorf','Charles',38.591393,-76.899607),('20603','MD','Waldorf','Charles',38.629718,-76.95605),('20604','MD','Waldorf','Charles',38.6244,-76.9394),('20606','MD','Abell','St. Marys',38.253882,-76.736401),('20607','MD','Accokeek','Prince Georges',38.672976,-77.014525),('20608','MD','Aquasco','Prince Georges',38.574527,-76.696443),('20609','MD','Avenue','St. Marys',38.262178,-76.7643),('20610','MD','Barstow','Calvert',38.5252,-76.6163),('20611','MD','Bel Alton','Charles',38.46236,-76.987283),('20612','MD','Benedict','Charles',38.511225,-76.679543),('20613','MD','Brandywine','Prince Georges',38.669992,-76.810594),('20615','MD','Broomes Island','Calvert',38.419775,-76.546239),('20616','MD','Bryans Road','Charles',38.638786,-77.074948),('20617','MD','Bryantown','Charles',38.543441,-76.841024),('20618','MD','Bushwood','St. Marys',38.272022,-76.800417),('20619','MD','California','St. Marys',38.300436,-76.518481),('20620','MD','Callaway','St. Marys',38.229499,-76.519779),('20621','MD','Chaptico','St. Marys',38.311564,-76.806891),('20622','MD','Charlotte Hall','Charles',38.45999,-76.835891),('20623','MD','Cheltenham','Prince Georges',38.742644,-76.832949),('20624','MD','Clements','St. Marys',38.325183,-76.733805),('20625','MD','Cobb Island','Charles',38.262537,-76.849358),('20626','MD','Coltons Point','St. Marys',38.231644,-76.762078),('20627','MD','Compton','Saint Marys',38.2772,-76.6927),('20628','MD','Dameron','St. Marys',38.135545,-76.33824),('20629','MD','Dowell','Calvert',38.334862,-76.453803),('20630','MD','Drayden','St. Marys',38.16057,-76.480518),('20632','MD','Faulkner','Charles',38.424765,-76.964156),('20634','MD','Great Mills','St. Marys',38.255495,-76.489461),('20635','MD','Helen','Saint Marys',38.3827,-76.7219),('20636','MD','Hollywood','St. Marys',38.343344,-76.558461),('20637','MD','Hughesville','Charles',38.528704,-76.781154),('20639','MD','Huntingtown','Calvert',38.602696,-76.605091),('20640','MD','Indian Head','Charles',38.584463,-77.166042),('20643','MD','Ironsides','Charles',38.4916,-77.16),('20645','MD','Issue','Charles',38.299851,-76.911317),('20646','MD','La Plata','Charles',38.527364,-76.991078),('20650','MD','Leonardtown','St. Marys',38.273531,-76.650428),('20653','MD','Lexington Park','St. Marys',38.245771,-76.448339),('20656','MD','Loveville','Saint Marys',38.3529,-76.6784),('20657','MD','Lusby','Calvert',38.376068,-76.439516),('20658','MD','Marbury','Charles',38.565784,-77.160564),('20659','MD','Mechanicsville','St. Marys',38.432665,-76.726157),('20660','MD','Morganza','St. Marys',38.373949,-76.699485),('20661','MD','Mount Victoria','Charles',38.3533,-76.8961),('20662','MD','Nanjemoy','Charles',38.44171,-77.199059),('20664','MD','Newburg','Charles',38.354485,-76.925395),('20667','MD','Park Hall','St. Marys',38.219073,-76.440438),('20670','MD','Patuxent River','St. Marys',38.282176,-76.430635),('20674','MD','Piney Point','St. Marys',38.134201,-76.496184),('20675','MD','Pomfret','Charles',38.581859,-77.025142),('20676','MD','Port Republic','Calvert',38.489375,-76.538086),('20677','MD','Port Tobacco','Charles',38.50672,-77.038718),('20678','MD','Prince Frederick','Calvert',38.526867,-76.597007),('20680','MD','Ridge','St. Marys',38.110036,-76.37837),('20682','MD','Rock Point','Charles',38.3482,-76.9205),('20684','MD','Saint Inigoes','St. Marys',38.146377,-76.416466),('20685','MD','Saint Leonard','Calvert',38.443548,-76.511027),('20686','MD','Saint Marys City','St. Marys',38.180687,-76.430619),('20687','MD','Scotland','St. Marys',38.07238,-76.337749),('20688','MD','Solomons','Calvert',38.339839,-76.464433),('20689','MD','Sunderland','Calvert',38.665382,-76.583134),('20690','MD','Tall Timbers','St. Marys',38.166749,-76.532638),('20692','MD','Valley Lee','St. Marys',38.178932,-76.514264),('20693','MD','Welcome','Charles',38.459058,-77.087352),('20695','MD','White Plains','Charles',38.590366,-76.968256),('20697','MD','Southern Md Facility','Prince Georges',39.1412,-77.1901),('20701','MD','Annapolis Junction','Howard',39.126193,-76.793383),('20703','MD','Lanham','Prince Georges',38.9765,-76.8381),('20704','MD','Beltsville','Prince Georges',39.0397,-76.9092),('20705','MD','Beltsville','Prince Georges',39.045211,-76.909779),('20706','MD','Lanham','Prince Georges',38.96319,-76.85156),('20707','MD','Laurel','Prince Georges',39.097575,-76.869367),('20708','MD','Laurel','Prince Georges',39.057829,-76.840959),('20709','MD','Laurel','Prince Georges',39.0991,-76.8486),('20710','MD','Bladensburg','Prince Georges',38.94093,-76.929936),('20711','MD','Lothian','Anne Arundel',38.792541,-76.66872),('20712','MD','Mount Rainier','Prince Georges',38.943085,-76.964125),('20714','MD','North Beach','Calvert',38.711692,-76.535565),('20715','MD','Bowie','Prince Georges',38.983552,-76.744331),('20716','MD','Bowie','Prince Georges',38.934283,-76.724035),('20717','MD','Bowie','Prince Georges',38.9091,-76.719),('20718','MD','Bowie','Prince Georges',38.9827,-76.7574),('20719','MD','Bowie','Prince Georges',38.9827,-76.7574),('20720','MD','Bowie','Prince Georges',38.981692,-76.790138),('20721','MD','Bowie','Prince Georges',38.920259,-76.7987),('20722','MD','Brentwood','Prince Georges',38.937646,-76.951889),('20723','MD','Laurel','Howard',39.136925,-76.860229),('20724','MD','Laurel','Anne Arundel',39.102206,-76.806265),('20725','MD','Laurel','Prince Georges',39.1043,-76.8445),('20726','MD','Laurel','Prince Georges',39.1043,-76.8445),('20731','MD','Capitol Heights','Prince Georges',38.8847,-76.9108),('20732','MD','Chesapeake Beach','Calvert',38.671401,-76.535024),('20733','MD','Churchton','Anne Arundel',38.801322,-76.523961),('20735','MD','Clinton','Prince Georges',38.754563,-76.896297),('20736','MD','Owings','Calvert',38.689914,-76.617274),('20737','MD','Riverdale','Prince Georges',38.962688,-76.919592),('20738','MD','Riverdale','Prince Georges',38.9656,-76.9386),('20740','MD','College Park','Prince Georges',38.99975,-76.928771),('20741','MD','College Park','Prince Georges',38.9805,-76.9372),('20742','MD','College Park','Prince Georges',38.990102,-76.945827),('20743','MD','Capitol Heights','Prince Georges',38.886622,-76.902519),('20744','MD','Fort Washington','Prince Georges',38.758324,-76.984032),('20745','MD','Oxon Hill','Prince Georges',38.807144,-76.992161),('20746','MD','Suitland','Prince Georges',38.838099,-76.919702),('20747','MD','District Heights','Prince Georges',38.854296,-76.891243),('20748','MD','Temple Hills','Prince Georges',38.821118,-76.944295),('20749','MD','Fort Washington','Prince Georges',38.7303,-76.9923),('20750','MD','Oxon Hill','Prince Georges',38.8033,-76.9925),('20751','MD','Deale','Anne Arundel',38.782062,-76.548849),('20752','MD','Suitland','Prince Georges',38.8516,-76.9308),('20753','MD','District Heights','Prince Georges',38.8531,-76.8965),('20754','MD','Dunkirk','Calvert',38.73862,-76.6516),('20755','MD','Fort George G Meade','Anne Arundel',39.106851,-76.742044),('20757','MD','Temple Hills','Prince Georges',38.8239,-76.949),('20758','MD','Friendship','Anne Arundel',38.730922,-76.594648),('20759','MD','Fulton','Howard',39.156022,-76.922433),('20762','MD','Andrews Air Force Base','Prince Georges',38.810619,-76.879365),('20763','MD','Savage','Howard',39.133726,-76.8155),('20764','MD','Shady Side','Anne Arundel',38.838929,-76.511205),('20765','MD','Galesville','Anne Arundel',38.844484,-76.54301),('20768','MD','Greenbelt','Prince Georges',39.0004,-76.8766),('20769','MD','Glenn Dale','Prince Georges',38.985057,-76.813517),('20770','MD','Greenbelt','Prince Georges',38.99978,-76.879745),('20771','MD','Greenbelt','Prince Georges',38.9963,-76.852),('20772','MD','Upper Marlboro','Prince Georges',38.791739,-76.780013),('20773','MD','Upper Marlboro','Prince Georges',38.8158,-76.75),('20774','MD','Upper Marlboro','Prince Georges',38.888359,-76.800562),('20775','MD','Upper Marlboro','Prince Georges',38.7838,-76.7679),('20776','MD','Harwood','Anne Arundel',38.878615,-76.59038),('20777','MD','Highland','Howard',39.17502,-76.968988),('20778','MD','West River','Anne Arundel',38.832426,-76.55758),('20779','MD','Tracys Landing','Anne Arundel',38.769013,-76.571028),('20781','MD','Hyattsville','Prince Georges',38.945273,-76.934533),('20782','MD','Hyattsville','Prince Georges',38.962947,-76.964346),('20783','MD','Hyattsville','Prince Georges',38.992131,-76.974573),('20784','MD','Hyattsville','Prince Georges',38.950256,-76.889362),('20785','MD','Hyattsville','Prince Georges',38.919707,-76.885841),('20787','MD','Hyattsville','Prince Georges',38.9857,-76.9868),('20788','MD','Hyattsville','Prince Georges',38.9684,-76.9535),('20790','MD','Capitol Heights','Prince Georges',38.8541,-76.9304),('20791','MD','Capitol Heights','Prince Georges',38.8183,-76.9418),('20792','MD','Upper Marlboro','Prince Georges',38.8159,-76.7498),('20794','MD','Jessup','Howard',39.15239,-76.793342),('20797','MD','Southern Md Facility','Prince Georges',39.0917,-76.8425),('20799','MD','Capitol Heights','Prince Georges',38.8809,-76.8545),('20810','MD','Bethesda','Montgomery',38.9806,-77.1008),('20811','MD','Bethesda','Montgomery',38.9806,-77.1008),('20812','MD','Glen Echo','Montgomery',38.968315,-77.143152),('20813','MD','Bethesda','Montgomery',38.9643,-77.0884),('20814','MD','Bethesda','Montgomery',39.000559,-77.100326),('20815','MD','Chevy Chase','Montgomery',38.981055,-77.07956),('20816','MD','Bethesda','Montgomery',38.958657,-77.114047),('20817','MD','Bethesda','Montgomery',38.999171,-77.136507),('20818','MD','Cabin John','Montgomery',38.974833,-77.161949),('20824','MD','Bethesda','Montgomery',38.9832,-77.0942),('20825','MD','Chevy Chase','Montgomery',38.97,-77.0777),('20827','MD','Bethesda','Montgomery',39.014,-77.1602),('20830','MD','Olney','Montgomery',39.1577,-77.0738),('20832','MD','Olney','Montgomery',39.153151,-77.074534),('20833','MD','Brookeville','Montgomery',39.183241,-77.049977),('20837','MD','Poolesville','Montgomery',39.130166,-77.410989),('20838','MD','Barnesville','Montgomery',39.223924,-77.376097),('20839','MD','Beallsville','Montgomery',39.19315,-77.421185),('20841','MD','Boyds','Montgomery',39.184593,-77.306356),('20842','MD','Dickerson','Montgomery',39.219138,-77.425244),('20847','MD','Rockville','Montgomery',39.0838,-77.153),('20848','MD','Rockville','Montgomery',39.0753,-77.1165),('20849','MD','Rockville','Montgomery',39.084,-77.1537),('20850','MD','Rockville','Montgomery',39.092529,-77.17222),('20851','MD','Rockville','Montgomery',39.075755,-77.122611),('20852','MD','Rockville','Montgomery',39.051928,-77.12204),('20853','MD','Rockville','Montgomery',39.091236,-77.094124),('20854','MD','Potomac','Montgomery',39.035507,-77.199553),('20855','MD','Derwood','Montgomery',39.134982,-77.144422),('20857','MD','Rockville','Montgomery',39.0629,-77.1152),('20859','MD','Potomac','Montgomery',39.0192,-77.2102),('20860','MD','Sandy Spring','Montgomery',39.142366,-77.025412),('20861','MD','Ashton','Montgomery',39.1499,-76.991902),('20862','MD','Brinklow','Montgomery',39.18123,-77.018806),('20866','MD','Burtonsville','Montgomery',39.102591,-76.934728),('20868','MD','Spencerville','Montgomery',39.124213,-76.979738),('20871','MD','Clarksburg','Montgomery',39.247135,-77.271531),('20872','MD','Damascus','Montgomery',39.28204,-77.226918),('20874','MD','Germantown','Montgomery',39.162026,-77.276429),('20875','MD','Germantown','Montgomery',39.1791,-77.273),('20876','MD','Germantown','Montgomery',39.196855,-77.242604),('20877','MD','Gaithersburg','Montgomery',39.141183,-77.187612),('20878','MD','Gaithersburg','Montgomery',39.117087,-77.235191),('20879','MD','Gaithersburg','Montgomery',39.168443,-77.184443),('20880','MD','Washington Grove','Montgomery',39.139054,-77.17457),('20882','MD','Gaithersburg','Montgomery',39.221149,-77.155327),('20883','MD','Gaithersburg','Montgomery',39.1743,-77.1915),('20884','MD','Gaithersburg','Montgomery',39.139,-77.1942),('20885','MD','Gaithersburg','Montgomery',39.1433,-77.2016),('20886','MD','Montgomery Village','Montgomery',39.180863,-77.194171),('20889','MD','Bethesda','Montgomery',38.9805,-77.1005),('20891','MD','Kensington','Montgomery',39.0255,-77.0766),('20892','MD','Bethesda','Montgomery',38.9805,-77.1005),('20894','MD','Bethesda','Montgomery',38.9805,-77.1005),('20895','MD','Kensington','Montgomery',39.02703,-77.077539),('20896','MD','Garrett Park','Montgomery',39.035382,-77.092454),('20897','MD','Suburb Maryland Fac','Montgomery',39.1412,-77.1901),('20898','MD','Gaithersburg','Montgomery',39.1272,-77.1727),('20899','MD','Gaithersburg','Montgomery',39.143736,-77.216228),('20901','MD','Silver Spring','Montgomery',39.017614,-77.010976),('20902','MD','Silver Spring','Montgomery',39.041596,-77.04894),('20903','MD','Silver Spring','Montgomery',39.01498,-76.981311),('20904','MD','Silver Spring','Montgomery',39.068038,-76.973974),('20905','MD','Silver Spring','Montgomery',39.103953,-76.994846),('20906','MD','Silver Spring','Montgomery',39.078764,-77.063974),('20907','MD','Silver Spring','Montgomery',38.9965,-77.0341),('20908','MD','Silver Spring','Montgomery',39.1029,-77.0763),('20910','MD','Silver Spring','Montgomery',39.001275,-77.034912),('20911','MD','Silver Spring','Montgomery',38.9943,-77.0302),('20912','MD','Takoma Park','Montgomery',38.98262,-77.000531),('20913','MD','Takoma Park','Montgomery',38.9693,-77.0002),('20914','MD','Silver Spring','Montgomery',39.0714,-77.0031),('20915','MD','Silver Spring','Montgomery',39.0426,-77.0477),('20916','MD','Silver Spring','Montgomery',39.083,-77.0785),('20918','MD','Silver Spring','Montgomery',39.0213,-77.015),('20993','MD','Silver Spring','Montgomery',38.9907,-77.0261),('20997','MD','Silver Spring','Montgomery',39.1127,-77.248),('21001','MD','Aberdeen','Harford',39.507849,-76.181129),('21005','MD','Aberdeen Proving Ground','Harford',39.478567,-76.120402),('21009','MD','Abingdon','Harford',39.472787,-76.301264),('21010','MD','Gunpowder','Harford',39.393456,-76.298752),('21012','MD','Arnold','Anne Arundel',39.049309,-76.49904),('21013','MD','Baldwin','Baltimore',39.511502,-76.490788),('21014','MD','Bel Air','Harford',39.536826,-76.350566),('21015','MD','Bel Air','Harford',39.534711,-76.303023),('21017','MD','Belcamp','Harford',39.475886,-76.240333),('21018','MD','Benson','Harford',39.5052,-76.3866),('21020','MD','Boring','Baltimore',39.5316,-76.823),('21022','MD','Brooklandville','Baltimore',39.4207,-76.67),('21023','MD','Butler','Baltimore',39.535,-76.7274),('21027','MD','Chase','Baltimore',39.3633,-76.3713),('21028','MD','Churchville','Harford',39.571857,-76.238298),('21029','MD','Clarksville','Howard',39.203872,-76.943418),('21030','MD','Cockeysville','Baltimore',39.482666,-76.648805),('21031','MD','Hunt Valley','Baltimore',39.488943,-76.659371),('21032','MD','Crownsville','Anne Arundel',39.042705,-76.590339),('21034','MD','Darlington','Harford',39.65347,-76.213001),('21035','MD','Davidsonville','Anne Arundel',38.9383,-76.626588),('21036','MD','Dayton','Howard',39.232452,-76.993061),('21037','MD','Edgewater','Anne Arundel',38.924632,-76.540327),('21040','MD','Edgewood','Harford',39.433664,-76.30529),('21041','MD','Ellicott City','Howard',39.2672,-76.7986),('21042','MD','Ellicott City','Howard',39.269348,-76.868867),('21043','MD','Ellicott City','Howard',39.255839,-76.801491),('21044','MD','Columbia','Howard',39.21194,-76.880148),('21045','MD','Columbia','Howard',39.203232,-76.824413),('21046','MD','Columbia','Howard',39.174941,-76.841771),('21047','MD','Fallston','Harford',39.527497,-76.43112),('21048','MD','Finksburg','Carroll',39.506664,-76.907158),('21050','MD','Forest Hill','Harford',39.578098,-76.383757),('21051','MD','Fork','Baltimore',39.470827,-76.449145),('21052','MD','Fort Howard','Baltimore',39.205972,-76.446067),('21053','MD','Freeland','Baltimore',39.697219,-76.713555),('21054','MD','Gambrills','Anne Arundel',39.039913,-76.676363),('21056','MD','Gibson Island','Anne Arundel',39.07525,-76.428946),('21057','MD','Glen Arm','Baltimore',39.450316,-76.502891),('21060','MD','Glen Burnie','Anne Arundel',39.164701,-76.592689),('21061','MD','Glen Burnie','Anne Arundel',39.161943,-76.629444),('21062','MD','Glen Burnie','Anne Arundel',39.1625,-76.625),('21065','MD','Hunt Valley','Baltimore',39.4808,-76.6448),('21071','MD','Glyndon','Baltimore',39.47479,-76.812784),('21074','MD','Hampstead','Carroll',39.616528,-76.849941),('21075','MD','Elkridge','Howard',39.197563,-76.759164),('21076','MD','Hanover','Anne Arundel',39.162234,-76.721923),('21077','MD','Harmans','Anne Arundel',39.155024,-76.698307),('21078','MD','Havre De Grace','Harford',39.552747,-76.120934),('21082','MD','Hydes','Baltimore',39.478136,-76.473523),('21084','MD','Jarrettsville','Harford',39.613561,-76.466441),('21085','MD','Joppa','Harford',39.432184,-76.355715),('21087','MD','Kingsville','Baltimore',39.44445,-76.406832),('21088','MD','Lineboro','Carroll',39.717,-76.8381),('21090','MD','Linthicum Heights','Anne Arundel',39.209728,-76.66188),('21092','MD','Long Green','Baltimore',39.4727,-76.5233),('21093','MD','Lutherville Timonium','Baltimore',39.438839,-76.634685),('21094','MD','Lutherville Timonium','Baltimore',39.4529,-76.6405),('21098','MD','Hanover','Anne Arundel',39.1928,-76.7244),('21102','MD','Manchester','Carroll',39.682834,-76.850538),('21104','MD','Marriottsville','Carroll',39.339427,-76.913597),('21105','MD','Maryland Line','Baltimore',39.717524,-76.653896),('21106','MD','Mayo','Anne Arundel',38.8952,-76.5115),('21108','MD','Millersville','Anne Arundel',39.097517,-76.622708),('21111','MD','Monkton','Baltimore',39.575537,-76.589692),('21113','MD','Odenton','Anne Arundel',39.078033,-76.70744),('21114','MD','Crofton','Anne Arundel',39.011846,-76.684369),('21117','MD','Owings Mills','Baltimore',39.421012,-76.779274),('21120','MD','Parkton','Baltimore',39.658519,-76.668375),('21122','MD','Pasadena','Anne Arundel',39.126551,-76.51768),('21123','MD','Pasadena','Anne Arundel',39.1209,-76.5128),('21128','MD','Perry Hall','Baltimore',39.403387,-76.44304),('21130','MD','Perryman','Harford',39.467941,-76.199411),('21131','MD','Phoenix','Baltimore',39.505875,-76.570928),('21132','MD','Pylesville','Harford',39.69554,-76.422196),('21133','MD','Randallstown','Baltimore',39.375068,-76.802506),('21136','MD','Reisterstown','Baltimore',39.472462,-76.81682),('21139','MD','Riderwood','Baltimore',39.4091,-76.6488),('21140','MD','Riva','Anne Arundel',38.951992,-76.58272),('21144','MD','Severn','Anne Arundel',39.128614,-76.686934),('21146','MD','Severna Park','Anne Arundel',39.079136,-76.558699),('21150','MD','Simpsonville','Howard',39.1846,-76.8721),('21152','MD','Sparks Glencoe','Baltimore',39.544029,-76.669619),('21153','MD','Stevenson','Baltimore',39.411781,-76.709714),('21154','MD','Street','Harford',39.657449,-76.360475),('21155','MD','Upperco','Baltimore',39.566934,-76.813263),('21156','MD','Upper Falls','Baltimore',39.437256,-76.399565),('21157','MD','Westminster','Carroll',39.559416,-76.988728),('21158','MD','Westminster','Carroll',39.624308,-77.035962),('21160','MD','Whiteford','Harford',39.706946,-76.323977),('21161','MD','White Hall','Harford',39.658988,-76.568166),('21162','MD','White Marsh','Baltimore',39.392336,-76.411729),('21163','MD','Woodstock','Howard',39.330014,-76.864258),('21201','MD','Baltimore','Baltimore City',39.295341,-76.621645),('21202','MD','Baltimore','Baltimore City',39.29614,-76.607708),('21203','MD','Baltimore','Baltimore City',39.291,-76.6055),('21204','MD','Towson','Baltimore',39.405466,-76.626091),('21205','MD','Baltimore','Baltimore City',39.301119,-76.570054),('21206','MD','Baltimore','Baltimore City',39.337205,-76.540636),('21207','MD','Gwynn Oak','Baltimore',39.324167,-76.719484),('21208','MD','Pikesville','Baltimore',39.378733,-76.728709),('21209','MD','Baltimore','Baltimore',39.366995,-76.666569),('21210','MD','Baltimore','Baltimore City',39.354375,-76.633816),('21211','MD','Baltimore','Baltimore City',39.329196,-76.633701),('21212','MD','Baltimore','Baltimore City',39.364752,-76.612203),('21213','MD','Baltimore','Baltimore City',39.314414,-76.577747),('21214','MD','Baltimore','Baltimore City',39.351775,-76.564046),('21215','MD','Baltimore','Baltimore City',39.344995,-76.681638),('21216','MD','Baltimore','Baltimore City',39.310607,-76.670233),('21217','MD','Baltimore','Baltimore City',39.30729,-76.638706),('21218','MD','Baltimore','Baltimore City',39.327711,-76.604083),('21219','MD','Sparrows Point','Baltimore',39.229345,-76.454688),('21220','MD','Middle River','Baltimore',39.340619,-76.41093),('21221','MD','Essex','Baltimore',39.306131,-76.449847),('21222','MD','Dundalk','Baltimore',39.264853,-76.50633),('21223','MD','Baltimore','Baltimore City',39.286806,-76.647853),('21224','MD','Baltimore','Baltimore City',39.284265,-76.549963),('21225','MD','Brooklyn','Baltimore City',39.230357,-76.61186),('21226','MD','Curtis Bay','Anne Arundel',39.210879,-76.567301),('21227','MD','Halethorpe','Baltimore',39.242701,-76.677339),('21228','MD','Catonsville','Baltimore',39.277888,-76.739999),('21229','MD','Baltimore','Baltimore City',39.28615,-76.68845),('21230','MD','Baltimore','Baltimore City',39.268124,-76.626723),('21231','MD','Baltimore','Baltimore City',39.288507,-76.592024),('21233','MD','Baltimore','Baltimore City',39.291,-76.6055),('21234','MD','Parkville','Baltimore',39.386962,-76.541473),('21235','MD','Baltimore','Baltimore City',39.3111,-76.7213),('21236','MD','Nottingham','Baltimore',39.386059,-76.487288),('21237','MD','Rosedale','Baltimore',39.333226,-76.501322),('21239','MD','Baltimore','Baltimore City',39.362218,-76.58849),('21240','MD','Baltimore','Anne Arundel',39.1824,-76.6782),('21241','MD','Baltimore','Baltimore City',39.291,-76.6055),('21244','MD','Windsor Mill','Baltimore',39.334205,-76.763392),('21250','MD','Baltimore','Baltimore',39.255219,-76.710124),('21251','MD','Baltimore','Baltimore City',39.346015,-76.582672),('21252','MD','Baltimore','Baltimore',39.393046,-76.608135),('21260','MD','Baltimore','Baltimore City',39.359404,-76.706178),('21261','MD','Baltimore','Baltimore',39.307737,-76.45171),('21263','MD','Baltimore','Baltimore City',39.291,-76.6055),('21264','MD','Baltimore','Baltimore City',39.291,-76.6055),('21265','MD','Baltimore','Baltimore City',39.291,-76.6055),('21268','MD','Baltimore','Baltimore City',39.2192,-76.7214),('21270','MD','Baltimore','Baltimore City',39.3339,-76.674),('21273','MD','Baltimore','Baltimore City',39.291,-76.6055),('21274','MD','Baltimore','Baltimore City',39.291,-76.6055),('21275','MD','Baltimore','Baltimore City',39.291,-76.6055),('21278','MD','Baltimore','Baltimore City',39.291,-76.6055),('21279','MD','Baltimore','Baltimore City',39.291,-76.6055),('21280','MD','Baltimore','Baltimore City',39.291,-76.6055),('21281','MD','Baltimore','Baltimore City',39.2873,-76.5419),('21282','MD','Baltimore','Baltimore',39.3749,-76.727),('21283','MD','Baltimore','Baltimore City',39.2902,-76.6125),('21284','MD','Baltimore','Baltimore',39.393,-76.574),('21285','MD','Baltimore','Baltimore',39.4164,-76.608),('21286','MD','Towson','Baltimore',39.39922,-76.584067),('21287','MD','Baltimore','Baltimore City',39.2946,-76.5908),('21288','MD','Baltimore','Baltimore City',39.291,-76.6055),('21289','MD','Baltimore','Baltimore City',39.291,-76.6055),('21290','MD','Baltimore','Baltimore City',39.291,-76.6055),('21297','MD','Baltimore','Baltimore City',39.291,-76.6055),('21298','MD','Baltimore','Baltimore City',39.291,-76.6055),('21401','MD','Annapolis','Anne Arundel',38.985074,-76.528581),('21402','MD','Annapolis','Anne Arundel',38.984781,-76.482622),('21403','MD','Annapolis','Anne Arundel',38.949034,-76.486532),('21404','MD','Annapolis','Anne Arundel',38.9783,-76.4925),('21405','MD','Annapolis','Anne Arundel',39.027692,-76.544567),('21409','MD','Annapolis','Anne Arundel',39.024829,-76.451139),('21411','MD','Annapolis','Anne Arundel',38.9724,-76.5502),('21412','MD','Annapolis','Anne Arundel',38.9724,-76.5502),('21501','MD','Cumberland','Allegany',39.6504,-78.7574),('21502','MD','Cumberland','Allegany',39.646782,-78.77331),('21503','MD','Cumberland','Allegany',39.6504,-78.7574),('21504','MD','Cumberland','Allegany',39.6504,-78.7574),('21505','MD','Cumberland','Allegany',39.6504,-78.7574),('21520','MD','Accident','Garrett',39.629713,-79.313714),('21521','MD','Barton','Allegany',39.536796,-79.020224),('21522','MD','Bittinger','Garrett',39.609995,-79.223548),('21523','MD','Bloomington','Garrett',39.479019,-79.073125),('21524','MD','Corriganville','Allegany',39.696709,-78.797164),('21528','MD','Eckhart Mines','Allegany',39.652187,-78.901231),('21529','MD','Ellerslie','Allegany',39.718488,-78.775499),('21530','MD','Flintstone','Allegany',39.695474,-78.547072),('21531','MD','Friendsville','Garrett',39.662455,-79.417077),('21532','MD','Frostburg','Allegany',39.64721,-78.937897),('21536','MD','Grantsville','Garrett',39.66717,-79.167653),('21538','MD','Kitzmiller','Garrett',39.394522,-79.208554),('21539','MD','Lonaconing','Allegany',39.584158,-78.994578),('21540','MD','Luke','Allegany',39.47547,-79.059952),('21541','MD','Mc Henry','Garrett',39.561545,-79.36848),('21542','MD','Midland','Allegany',39.591314,-78.949016),('21543','MD','Midlothian','Allegany',39.643665,-78.956789),('21545','MD','Mount Savage','Allegany',39.701521,-78.87327),('21550','MD','Oakland','Garrett',39.412904,-79.389116),('21555','MD','Oldtown','Allegany',39.576174,-78.562397),('21556','MD','Pinto','Allegany',39.5774,-78.848),('21557','MD','Rawlings','Allegany',39.494193,-78.931046),('21560','MD','Spring Gap','Allegany',39.564946,-78.711003),('21561','MD','Swanton','Garrett',39.479581,-79.22858),('21562','MD','Westernport','Allegany',39.488057,-79.032957),('21601','MD','Easton','Talbot',38.778763,-76.082717),('21606','MD','Easton','Talbot',38.7741,-76.0766),('21607','MD','Barclay','Queen Annes',39.142145,-75.861967),('21609','MD','Bethlehem','Caroline',38.7454,-75.944),('21610','MD','Betterton','Kent',39.370696,-76.06971),('21612','MD','Bozman','Talbot',38.752206,-76.269995),('21613','MD','Cambridge','Dorchester',38.541952,-76.098107),('21617','MD','Centreville','Queen Annes',39.049762,-76.057587),('21619','MD','Chester','Queen Annes',38.96877,-76.27762),('21620','MD','Chestertown','Kent',39.212248,-76.094801),('21622','MD','Church Creek','Dorchester',38.407493,-76.186516),('21623','MD','Church Hill','Queen Annes',39.124035,-75.966748),('21624','MD','Claiborne','Talbot',38.839638,-76.272236),('21625','MD','Cordova','Talbot',38.8791,-75.997346),('21626','MD','Crapo','Dorchester',38.341359,-76.098361),('21627','MD','Crocheron','Dorchester',38.233029,-76.046342),('21628','MD','Crumpton','Queen Annes',39.2397,-75.923213),('21629','MD','Denton','Caroline',38.874411,-75.825345),('21631','MD','East New Market','Dorchester',38.591281,-75.94323),('21632','MD','Federalsburg','Caroline',38.706752,-75.766268),('21634','MD','Fishing Creek','Dorchester',38.288059,-76.186749),('21635','MD','Galena','Kent',39.349878,-75.844373),('21636','MD','Goldsboro','Caroline',39.028318,-75.790629),('21638','MD','Grasonville','Queen Annes',38.95467,-76.213107),('21639','MD','Greensboro','Caroline',38.969449,-75.799103),('21640','MD','Henderson','Caroline',39.078214,-75.800864),('21641','MD','Hillsboro','Caroline',38.916792,-75.942565),('21643','MD','Hurlock','Dorchester',38.64633,-75.864998),('21644','MD','Ingleside','Queen Annes',39.095693,-75.873224),('21645','MD','Kennedyville','Kent',39.315859,-75.956142),('21647','MD','Mcdaniel','Talbot',38.812353,-76.283453),('21648','MD','Madison','Dorchester',38.485356,-76.23933),('21649','MD','Marydel','Caroline',39.121344,-75.767145),('21650','MD','Massey','Kent',39.317217,-75.821293),('21651','MD','Millington','Kent',39.260585,-75.854035),('21652','MD','Neavitt','Talbot',38.722384,-76.280797),('21653','MD','Newcomb','Talbot',38.751508,-76.178755),('21654','MD','Oxford','Talbot',38.682692,-76.143347),('21655','MD','Preston','Caroline',38.742322,-75.921129),('21656','MD','Price','Queen Annes',39.1411,-75.9858),('21657','MD','Queen Anne','Queen Annes',38.938602,-75.98108),('21658','MD','Queenstown','Queen Annes',38.950168,-76.161864),('21659','MD','Rhodesdale','Dorchester',38.583983,-75.782345),('21660','MD','Ridgely','Caroline',38.949072,-75.885828),('21661','MD','Rock Hall','Kent',39.126095,-76.228705),('21662','MD','Royal Oak','Talbot',38.714248,-76.20068),('21663','MD','Saint Michaels','Talbot',38.786956,-76.230812),('21664','MD','Secretary','Dorchester',38.608941,-75.948449),('21665','MD','Sherwood','Talbot',38.749102,-76.323356),('21666','MD','Stevensville','Queen Annes',38.940146,-76.335814),('21667','MD','Still Pond','Kent',39.339578,-76.049159),('21668','MD','Sudlersville','Queen Annes',39.191191,-75.853),('21669','MD','Taylors Island','Dorchester',38.469165,-76.294317),('21670','MD','Templeville','Caroline',39.1362,-75.7666),('21671','MD','Tilghman','Talbot',38.707093,-76.336164),('21672','MD','Toddville','Dorchester',38.276998,-76.06216),('21673','MD','Trappe','Talbot',38.657147,-76.061054),('21675','MD','Wingate','Dorchester',38.288979,-76.0896),('21676','MD','Wittman','Talbot',38.787435,-76.301138),('21677','MD','Woolford','Dorchester',38.509955,-76.183041),('21678','MD','Worton','Kent',39.313127,-76.104689),('21679','MD','Wye Mills','Talbot',38.919317,-76.074718),('21681','MD','Ridgely','Caroline',38.9477,-75.8847),('21682','MD','Ridgely','Caroline',38.9477,-75.8847),('21683','MD','Ridgely','Caroline',38.9477,-75.8847),('21684','MD','Ridgely','Caroline',38.9477,-75.8847),('21685','MD','Ridgely','Caroline',38.9477,-75.8847),('21686','MD','Ridgely','Caroline',38.9477,-75.8847),('21687','MD','Ridgely','Caroline',38.9477,-75.8847),('21688','MD','Ridgely','Caroline',38.9477,-75.8847),('21690','MD','Chestertown','Queen Annes',39.2105,-76.0669),('21701','MD','Frederick','Frederick',39.42908,-77.382487),('21702','MD','Frederick','Frederick',39.448187,-77.438699),('21703','MD','Frederick','Frederick',39.378143,-77.448728),('21704','MD','Frederick','Frederick',39.360342,-77.380644),('21705','MD','Frederick','Frederick',39.40886,-77.410008),('21709','MD','Frederick','Frederick',39.4138,-77.4083),('21710','MD','Adamstown','Frederick',39.304676,-77.454972),('21711','MD','Big Pool','Washington',39.654657,-78.019415),('21713','MD','Boonsboro','Washington',39.521638,-77.665169),('21714','MD','Braddock Heights','Frederick',39.4205,-77.503791),('21715','MD','Brownsville','Washington',39.3822,-77.6606),('21716','MD','Brunswick','Frederick',39.314848,-77.624948),('21717','MD','Buckeystown','Frederick',39.334864,-77.433303),('21718','MD','Burkittsville','Frederick',39.392295,-77.627014),('21719','MD','Cascade','Washington',39.710067,-77.492048),('21720','MD','Cavetown','Washington',39.6442,-77.5853),('21721','MD','Chewsville','Washington',39.6428,-77.6349),('21722','MD','Clear Spring','Washington',39.65603,-77.914732),('21723','MD','Cooksville','Howard',39.328608,-77.015578),('21727','MD','Emmitsburg','Frederick',39.694157,-77.320278),('21733','MD','Fairplay','Washington',39.547117,-77.752705),('21734','MD','Funkstown','Washington',39.609114,-77.707489),('21737','MD','Glenelg','Howard',39.260096,-77.00953),('21738','MD','Glenwood','Howard',39.279305,-77.021345),('21740','MD','Hagerstown','Washington',39.634055,-77.734825),('21741','MD','Hagerstown','Washington',39.6437,-77.7205),('21742','MD','Hagerstown','Washington',39.662257,-77.68881),('21746','MD','Hagerstown','Washington',39.562872,-77.71519),('21747','MD','Hagerstown','Washington',39.6437,-77.7205),('21748','MD','Hagerstown','Washington',39.6437,-77.7205),('21749','MD','Hagerstown','Washington',39.6437,-77.7205),('21750','MD','Hancock','Washington',39.697535,-78.196719),('21754','MD','Ijamsville','Frederick',39.340794,-77.315928),('21755','MD','Jefferson','Frederick',39.357647,-77.55857),('21756','MD','Keedysville','Washington',39.459857,-77.693494),('21757','MD','Keymar','Frederick',39.588719,-77.262847),('21758','MD','Knoxville','Frederick',39.343328,-77.654334),('21759','MD','Ladiesburg','Frederick',39.5781,-77.262),('21762','MD','Libertytown','Frederick',39.484219,-77.245613),('21765','MD','Lisbon','Howard',39.3246,-77.012),('21766','MD','Little Orleans','Allegany',39.661046,-78.378438),('21767','MD','Maugansville','Washington',39.696581,-77.745667),('21769','MD','Middletown','Frederick',39.443566,-77.551129),('21770','MD','Monrovia','Frederick',39.345895,-77.25306),('21771','MD','Mount Airy','Frederick',39.386713,-77.159321),('21773','MD','Myersville','Frederick',39.518157,-77.561358),('21774','MD','New Market','Frederick',39.399722,-77.282871),('21775','MD','New Midway','Frederick',39.5669,-77.2911),('21776','MD','New Windsor','Carroll',39.529266,-77.097147),('21777','MD','Point Of Rocks','Frederick',39.275917,-77.529674),('21778','MD','Rocky Ridge','Frederick',39.610783,-77.334624),('21779','MD','Rohrersville','Washington',39.430852,-77.661626),('21780','MD','Sabillasville','Frederick',39.677237,-77.470036),('21781','MD','Saint James','Washington',39.57276,-77.759919),('21782','MD','Sharpsburg','Washington',39.456824,-77.756189),('21783','MD','Smithsburg','Washington',39.651228,-77.564731),('21784','MD','Sykesville','Carroll',39.396182,-76.964722),('21787','MD','Taneytown','Carroll',39.664644,-77.172821),('21788','MD','Thurmont','Frederick',39.603696,-77.40415),('21790','MD','Tuscarora','Frederick',39.260432,-77.489623),('21791','MD','Union Bridge','Carroll',39.546502,-77.185211),('21792','MD','Unionville','Frederick',39.4747,-77.1858),('21793','MD','Walkersville','Frederick',39.48836,-77.346943),('21794','MD','West Friendship','Howard',39.295441,-76.968593),('21795','MD','Williamsport','Washington',39.598425,-77.816084),('21797','MD','Woodbine','Howard',39.336494,-77.065969),('21798','MD','Woodsboro','Frederick',39.536018,-77.306651),('21801','MD','Salisbury','Wicomico',38.372534,-75.622207),('21802','MD','Salisbury','Wicomico',38.344471,-75.583264),('21803','MD','Salisbury','Wicomico',38.3605,-75.5997),('21804','MD','Salisbury','Wicomico',38.34972,-75.564504),('21810','MD','Allen','Wicomico',38.291935,-75.698255),('21811','MD','Berlin','Worcester',38.333149,-75.187691),('21813','MD','Bishopville','Worcester',38.427291,-75.17323),('21814','MD','Bivalve','Wicomico',38.292631,-75.893542),('21817','MD','Crisfield','Somerset',37.98584,-75.840139),('21821','MD','Deal Island','Somerset',38.173947,-75.933914),('21822','MD','Eden','Somerset',38.285172,-75.653822),('21824','MD','Ewell','Somerset',37.987043,-76.031691),('21826','MD','Fruitland','Wicomico',38.317773,-75.620564),('21829','MD','Girdletree','Worcester',38.090663,-75.383667),('21830','MD','Hebron','Wicomico',38.407928,-75.701685),('21835','MD','Linkwood','Dorchester',38.536345,-75.946803),('21836','MD','Manokin','Somerset',38.1156,-75.7502),('21837','MD','Mardela Springs','Wicomico',38.463481,-75.758101),('21838','MD','Marion Station','Somerset',38.018507,-75.73884),('21840','MD','Nanticoke','Wicomico',38.264148,-75.900052),('21841','MD','Newark','Worcester',38.233604,-75.289559),('21842','MD','Ocean City','Worcester',38.379858,-75.073439),('21843','MD','Ocean City','Worcester',38.3983,-75.0668),('21849','MD','Parsonsburg','Wicomico',38.381337,-75.461634),('21850','MD','Pittsville','Wicomico',38.372296,-75.401314),('21851','MD','Pocomoke City','Worcester',38.070293,-75.551614),('21852','MD','Powellville','Wicomico',38.3286,-75.3758),('21853','MD','Princess Anne','Somerset',38.204736,-75.710179),('21856','MD','Quantico','Wicomico',38.33073,-75.794885),('21857','MD','Rehobeth','Somerset',38.0388,-75.6633),('21861','MD','Sharptown','Wicomico',38.539257,-75.719732),('21862','MD','Showell','Worcester',38.397465,-75.217338),('21863','MD','Snow Hill','Worcester',38.187913,-75.399041),('21864','MD','Stockton','Worcester',38.042106,-75.412101),('21865','MD','Tyaskin','Wicomico',38.287338,-75.841179),('21866','MD','Tylerton','Somerset',37.967164,-76.022435),('21867','MD','Upper Fairmount','Somerset',38.108675,-75.792178),('21869','MD','Vienna','Dorchester',38.459188,-75.869129),('21871','MD','Westover','Somerset',38.10548,-75.741276),('21872','MD','Whaleyville','Worcester',38.410723,-75.295749),('21874','MD','Willards','Wicomico',38.396061,-75.358066),('21875','MD','Delmar','Wicomico',38.443186,-75.561375),('21890','MD','Westover','Somerset',38.155278,-75.703915),('21901','MD','North East','Cecil',39.59501,-75.955619),('21902','MD','Perry Point','Cecil',39.551565,-76.065439),('21903','MD','Perryville','Cecil',39.574725,-76.053508),('21904','MD','Port Deposit','Cecil',39.623405,-76.084149),('21911','MD','Rising Sun','Cecil',39.695618,-76.05193),('21912','MD','Warwick','Cecil',39.427371,-75.81504),('21913','MD','Cecilton','Cecil',39.403177,-75.868874),('21914','MD','Charlestown','Cecil',39.572338,-75.97868),('21915','MD','Chesapeake City','Cecil',39.511181,-75.830876),('21916','MD','Childs','Cecil',39.641234,-75.86147),('21917','MD','Colora','Cecil',39.671632,-76.097397),('21918','MD','Conowingo','Cecil',39.680714,-76.162153),('21919','MD','Earleville','Cecil',39.416838,-75.933623),('21920','MD','Elk Mills','Cecil',39.65955,-75.827677),('21921','MD','Elkton','Cecil',39.626438,-75.846641),('21922','MD','Elkton','Cecil',39.6063,-75.8337),('21930','MD','Georgetown','Cecil',39.370132,-75.887333),('22003','VA','Annandale','Fairfax',38.830087,-77.216551),('22009','VA','Burke','Fairfax',38.7946,-77.2733),('22015','VA','Burke','Fairfax',38.785989,-77.280055),('22025','VA','Dumfries','Prince William',38.602815,-77.340311),('22026','VA','Dumfries','Prince William',38.57025,-77.306693),('22027','VA','Dunn Loring','Fairfax',38.893482,-77.220549),('22030','VA','Fairfax','Fairfax',38.84802,-77.331106),('22031','VA','Fairfax','Fairfax',38.864972,-77.262037),('22032','VA','Fairfax','Fairfax',38.818698,-77.292827),('22033','VA','Fairfax','Fairfax',38.873727,-77.384294),('22034','VA','Fairfax','Fairfax',38.8595,-77.2659),('22035','VA','Fairfax','Fairfax',38.854,-77.3577),('22036','VA','Fairfax','Fairfax',38.86,-77.2593),('22037','VA','Fairfax','Fairfax',38.8594,-77.2269),('22038','VA','Fairfax','Fairfax City',38.8482,-77.3065),('22039','VA','Fairfax Station','Fairfax',38.75607,-77.313969),('22040','VA','Falls Church','Falls Church City',38.8838,-77.1741),('22041','VA','Falls Church','Fairfax',38.846822,-77.143888),('22042','VA','Falls Church','Fairfax',38.867222,-77.191625),('22043','VA','Falls Church','Fairfax',38.899657,-77.196952),('22044','VA','Falls Church','Fairfax',38.862044,-77.154372),('22046','VA','Falls Church','Falls Church City',38.886221,-77.178553),('22047','VA','Falls Church','Fairfax',38.869,-77.2241),('22060','VA','Fort Belvoir','Fairfax',38.702506,-77.148855),('22066','VA','Great Falls','Fairfax',39.003844,-77.30144),('22067','VA','Greenway','Fairfax',38.9702,-77.2339),('22079','VA','Lorton','Fairfax',38.695204,-77.210377),('22081','VA','Merrifield','Fairfax',38.8741,-77.2272),('22082','VA','Merrifield','Fairfax',38.8741,-77.2272),('22092','VA','Herndon','Fairfax',38.9694,-77.3863),('22093','VA','Ashburn','Loudoun',39.0436,-77.4877),('22095','VA','Herndon','Fairfax',38.9694,-77.3863),('22096','VA','Reston','Fairfax',38.9686,-77.3413),('22101','VA','Mc Lean','Fairfax',38.93296,-77.166897),('22102','VA','Mc Lean','Fairfax',38.938326,-77.220689),('22103','VA','West Mclean','Fairfax',38.9287,-77.2397),('22106','VA','Mc Lean','Fairfax',38.9372,-77.1786),('22107','VA','Mc Lean','Fairfax',38.9327,-77.1828),('22108','VA','Mc Lean','Fairfax',38.9327,-77.1828),('22109','VA','Mc Lean','Fairfax',38.9327,-77.1825),('22116','VA','Merrifield','Fairfax',38.8741,-77.2272),('22118','VA','Merrifield','Fairfax',38.8741,-77.2272),('22119','VA','Merrifield','Fairfax',38.8741,-77.2272),('22120','VA','Merrifield','Fairfax',38.8741,-77.2272),('22121','VA','Mount Vernon','Fairfax',38.7077,-77.0863),('22122','VA','Newington','Fairfax',38.7383,-77.1852),('22124','VA','Oakton','Fairfax',38.889159,-77.324959),('22125','VA','Occoquan','Prince William',38.682997,-77.260786),('22134','VA','Quantico','Prince William',38.522671,-77.357634),('22135','VA','Quantico','Prince William',38.5222,-77.2938),('22150','VA','Springfield','Fairfax',38.776666,-77.184473),('22151','VA','Springfield','Fairfax',38.804093,-77.207804),('22152','VA','Springfield','Fairfax',38.774493,-77.232029),('22153','VA','Springfield','Fairfax',38.744969,-77.23564),('22156','VA','Springfield','Fairfax',38.7891,-77.1875),('22158','VA','Springfield','Fairfax',38.7891,-77.1875),('22159','VA','Springfield','Fairfax',38.7891,-77.1875),('22160','VA','Springfield','Fairfax',38.8111,-77.2182),('22161','VA','Springfield','Fairfax',38.7891,-77.1875),('22172','VA','Triangle','Prince William',38.553346,-77.337547),('22180','VA','Vienna','Fairfax',38.894654,-77.255207),('22181','VA','Vienna','Fairfax',38.902216,-77.289193),('22182','VA','Vienna','Fairfax',38.928996,-77.262958),('22183','VA','Vienna','Fairfax',38.9013,-77.2685),('22184','VA','Vienna','Fairfax',38.9013,-77.2685),('22185','VA','Vienna','Fairfax',38.9013,-77.2685),('22191','VA','Woodbridge','Prince William',38.62701,-77.269064),('22192','VA','Woodbridge','Prince William',38.67541,-77.30386),('22193','VA','Woodbridge','Prince William',38.642826,-77.341861),('22194','VA','Woodbridge','Prince William',38.6316,-77.2679),('22195','VA','Woodbridge','Prince William',38.6329,-77.2694),('22199','VA','Lorton','Fairfax',38.7041,-77.228),('22201','VA','Arlington','Arlington',38.886712,-77.094379),('22202','VA','Arlington','Arlington',38.858551,-77.05459),('22203','VA','Arlington','Arlington',38.874851,-77.114737),('22204','VA','Arlington','Arlington',38.860941,-77.096428),('22205','VA','Arlington','Arlington',38.882794,-77.139933),('22206','VA','Arlington','Arlington',38.843182,-77.087767),('22207','VA','Arlington','Arlington',38.903763,-77.127352),('22209','VA','Arlington','Arlington',38.894159,-77.075369),('22210','VA','Arlington','Arlington',38.8856,-77.0998),('22211','VA','Ft Myer','Arlington',38.881399,-77.072111),('22212','VA','Arlington','Arlington',38.8809,-76.8545),('22213','VA','Arlington','Arlington',38.894542,-77.163891),('22214','VA','Arlington','Arlington',38.868499,-77.073318),('22215','VA','Arlington','Arlington',38.8793,-77.1131),('22216','VA','Arlington','Arlington',38.8916,-77.0839),('22217','VA','Arlington','Arlington',38.8856,-77.0998),('22218','VA','Arlington','Arlington',38.8856,-77.0998),('22219','VA','Arlington','Arlington',38.8944,-77.07),('22222','VA','Arlington','Arlington',38.8582,-77.0533),('22223','VA','Arlington','Arlington',38.8867,-77.0936),('22225','VA','Arlington','Arlington',38.8566,-77.0584),('22226','VA','Arlington','Arlington',38.8856,-77.0998),('22227','VA','Arlington','Arlington',38.8582,-77.0533),('22229','VA','Arlington','Arlington',38.8944,-77.07),('22230','VA','Arlington','Arlington',38.873,-77.1042),('22234','VA','Arlington','Arlington',38.8944,-77.07),('22240','VA','Arlington','Arlington',38.88,-77.1153),('22241','VA','Arlington','Arlington',38.8582,-77.0533),('22242','VA','Arlington','Arlington',38.8582,-77.0533),('22243','VA','Arlington','Arlington',38.8582,-77.0533),('22244','VA','Arlington','Arlington',38.8582,-77.0533),('22245','VA','Arlington','Arlington',38.8582,-77.0533),('22246','VA','Arlington','Arlington',38.8575,-77.0531),('22301','VA','Alexandria','Alexandria City',38.819982,-77.058936),('22302','VA','Alexandria','Alexandria City',38.830641,-77.084589),('22303','VA','Alexandria','Fairfax',38.79438,-77.078837),('22304','VA','Alexandria','Alexandria City',38.815131,-77.114755),('22305','VA','Alexandria','Alexandria City',38.835701,-77.063214),('22306','VA','Alexandria','Fairfax',38.754894,-77.084552),('22307','VA','Alexandria','Fairfax',38.77397,-77.060927),('22308','VA','Alexandria','Fairfax',38.729282,-77.060994),('22309','VA','Alexandria','Fairfax',38.725052,-77.107515),('22310','VA','Alexandria','Fairfax',38.785785,-77.124547),('22311','VA','Alexandria','Alexandria City',38.836538,-77.122823),('22312','VA','Alexandria','Fairfax',38.815728,-77.154327),('22313','VA','Alexandria','Alexandria City',38.8047,-77.0472),('22314','VA','Alexandria','Alexandria City',38.807536,-77.052627),('22315','VA','Alexandria','Fairfax',38.758337,-77.151192),('22320','VA','Alexandria','Alexandria City',38.8047,-77.0472),('22321','VA','Alexandria','Fairfax',38.8062,-77.0528),('22331','VA','Alexandria','Alexandria City',38.8047,-77.0472),('22332','VA','Alexandria','Alexandria City',38.8047,-77.0472),('22333','VA','Alexandria','Alexandria City',38.8047,-77.0472),('22334','VA','Alexandria','Alexandria City',38.8047,-77.0472),('22336','VA','Alexandria','Alexandria City',38.8047,-77.0472),('22401','VA','Fredericksburg','Fredericksburg City',38.298445,-77.479533),('22402','VA','Fredericksburg','Fredericksburg City',38.2985,-77.4582),('22403','VA','Fredericksburg','Stafford',38.3242,-77.4685),('22404','VA','Fredericksburg','Fredericksburg City',38.2985,-77.4582),('22405','VA','Fredericksburg','Stafford',38.312954,-77.433671),('22406','VA','Fredericksburg','Stafford',38.380194,-77.539077),('22407','VA','Fredericksburg','Spotsylvania',38.273296,-77.562494),('22408','VA','Fredericksburg','Spotsylvania',38.23812,-77.455852),('22412','VA','Fredericksburg','Spotsylvania',38.3971,-77.5516),('22427','VA','Bowling Green','Caroline',38.091018,-77.287733),('22428','VA','Bowling Green','Caroline',38.0488,-77.3483),('22430','VA','Brooke','Stafford',38.3865,-77.3797),('22432','VA','Burgess','Northumberland',37.860856,-76.355437),('22433','VA','Burr Hill','Orange',38.358661,-77.85403),('22435','VA','Callao','Northumberland',37.983473,-76.566241),('22436','VA','Caret','Essex',38.069614,-77.094802),('22437','VA','Center Cross','Essex',37.791348,-76.778365),('22438','VA','Champlain','Essex',38.042972,-76.995776),('22442','VA','Coles Point','Westmoreland',38.1436,-76.6358),('22443','VA','Colonial Beach','Westmoreland',38.215238,-76.984969),('22446','VA','Corbin','Caroline',38.1994,-77.3891),('22448','VA','Dahlgren','King George',38.333996,-77.03224),('22451','VA','Dogue','King George',38.2319,-77.2161),('22454','VA','Dunnsville','Essex',37.852044,-76.822721),('22456','VA','Edwardsville','Northumberland',37.9063,-76.3655),('22460','VA','Farnham','Richmond',37.883852,-76.617746),('22463','VA','Garrisonville','Stafford',38.4825,-77.4269),('22469','VA','Hague','Westmoreland',38.099854,-76.637694),('22471','VA','Hartwood','Stafford',38.4022,-77.5655),('22472','VA','Haynesville','Richmond',37.95,-76.6627),('22473','VA','Heathsville','Northumberland',37.899815,-76.391402),('22476','VA','Hustle','Essex',38.037846,-77.078743),('22480','VA','Irvington','Lancaster',37.663543,-76.419422),('22481','VA','Jersey','King George',38.2113,-77.1397),('22482','VA','Kilmarnock','Lancaster',37.725731,-76.354698),('22485','VA','King George','King George',38.287547,-77.168794),('22488','VA','Kinsale','Westmoreland',38.046998,-76.577026),('22501','VA','Ladysmith','Caroline',38.0175,-77.5155),('22503','VA','Lancaster','Lancaster',37.741007,-76.505849),('22504','VA','Laneview','Essex',37.768926,-76.720682),('22507','VA','Lively','Lancaster',37.762848,-76.497493),('22508','VA','Locust Grove','Orange',38.323714,-77.775178),('22509','VA','Loretto','Essex',38.104829,-77.074301),('22511','VA','Lottsburg','Northumberland',37.994433,-76.503969),('22513','VA','Merry Point','Lancaster',37.7336,-76.4827),('22514','VA','Milford','Caroline',37.98793,-77.290775),('22517','VA','Mollusk','Lancaster',37.73,-76.5383),('22520','VA','Montross','Westmoreland',38.119585,-76.780049),('22523','VA','Morattico','Lancaster',37.7891,-76.6294),('22524','VA','Mount Holly','Westmoreland',38.0911,-76.7183),('22526','VA','Ninde','King George',38.2711,-77.0563),('22528','VA','Nuttsville','Lancaster',37.7933,-76.5511),('22529','VA','Oldhams','Westmoreland',38.011392,-76.689236),('22530','VA','Ophelia','Northumberland',37.90033,-76.291163),('22534','VA','Partlow','Spotsylvania',38.072649,-77.671284),('22535','VA','Port Royal','Caroline',38.149441,-77.164252),('22538','VA','Rappahannock Academy','Caroline',38.221844,-77.267022),('22539','VA','Reedville','Northumberland',37.853039,-76.281354),('22542','VA','Rhoadesville','Orange',38.30839,-77.878236),('22544','VA','Rollins Fork','King George',38.2625,-77.1209),('22545','VA','Ruby','Stafford',38.5041,-77.5158),('22546','VA','Ruther Glen','Caroline',37.956109,-77.467463),('22547','VA','Sealston','King George',38.2613,-77.3322),('22548','VA','Sharps','Richmond',37.823655,-76.69744),('22551','VA','Spotsylvania','Spotsylvania',38.163668,-77.665942),('22552','VA','Sparta','Caroline',38.0417,-77.2127),('22553','VA','Spotsylvania','Spotsylvania',38.272441,-77.636167),('22554','VA','Stafford','Stafford',38.450158,-77.392934),('22555','VA','Stafford','Stafford',38.4219,-77.4086),('22556','VA','Stafford','Stafford',38.478206,-77.482866),('22558','VA','Stratford','Westmoreland',38.1164,-76.7898),('22560','VA','Tappahannock','Essex',37.916392,-76.917649),('22565','VA','Thornburg','Spotsylvania',38.1333,-77.5219),('22567','VA','Unionville','Orange',38.239135,-77.909262),('22570','VA','Village','Richmond',37.9488,-76.6044),('22572','VA','Warsaw','Richmond',37.9653,-76.771086),('22576','VA','Weems','Lancaster',37.690486,-76.440355),('22577','VA','Sandy Point','Westmoreland',38.0641,-76.5591),('22578','VA','White Stone','Lancaster',37.651379,-76.355996),('22579','VA','Wicomico Church','Northumberland',37.800823,-76.320424),('22580','VA','Woodford','Caroline',38.098016,-77.450779),('22581','VA','Zacata','Westmoreland',38.12,-76.7825),('22601','VA','Winchester','Winchester City',39.178797,-78.168494),('22602','VA','Winchester','Frederick',39.154595,-78.230685),('22603','VA','Winchester','Frederick',39.250867,-78.191519),('22604','VA','Winchester','Winchester City',39.1853,-78.1532),('22610','VA','Bentonville','Warren',38.832818,-78.289568),('22611','VA','Berryville','Clarke',39.159935,-77.981631),('22620','VA','Boyce','Clarke',39.069865,-78.037424),('22622','VA','Brucetown','Frederick',39.2544,-78.0669),('22623','VA','Chester Gap','Rappahannock',38.852076,-78.14459),('22624','VA','Clear Brook','Frederick',39.268264,-78.088111),('22625','VA','Cross Junction','Frederick',39.362491,-78.309265),('22626','VA','Fishers Hill','Shenandoah',38.980286,-78.401102),('22627','VA','Flint Hill','Rappahannock',38.763858,-78.092943),('22630','VA','Front Royal','Warren',38.935,-78.179862),('22637','VA','Gore','Frederick',39.257069,-78.352176),('22639','VA','Hume','Fauquier',38.810304,-78.034925),('22640','VA','Huntly','Rappahannock',38.808539,-78.112215),('22641','VA','Strasburg','Shenandoah',39.074119,-78.392025),('22642','VA','Linden','Warren',38.922276,-78.069619),('22643','VA','Markham','Fauquier',38.904842,-77.993938),('22644','VA','Maurertown','Shenandoah',38.93729,-78.482187),('22645','VA','Middletown','Frederick',39.023192,-78.28095),('22646','VA','Millwood','Clarke',39.077311,-78.036527),('22649','VA','Middletown','Warren',38.9982,-78.254),('22650','VA','Rileyville','Page',38.769379,-78.378268),('22652','VA','Fort Valley','Shenandoah',38.844098,-78.419736),('22654','VA','Star Tannery','Frederick',39.066244,-78.464009),('22655','VA','Stephens City','Frederick',39.079509,-78.207411),('22656','VA','Stephenson','Frederick',39.228062,-78.094768),('22657','VA','Strasburg','Shenandoah',38.999963,-78.348015),('22660','VA','Toms Brook','Shenandoah',38.944061,-78.431429),('22663','VA','White Post','Frederick',39.054289,-78.122178),('22664','VA','Woodstock','Shenandoah',38.879922,-78.513414),('22701','VA','Culpeper','Culpeper',38.459486,-77.998913),('22709','VA','Aroda','Madison',38.328731,-78.213737),('22711','VA','Banco','Madison',38.476275,-78.272902),('22712','VA','Bealeton','Fauquier',38.561457,-77.75659),('22713','VA','Boston','Culpeper',38.545419,-78.141395),('22714','VA','Brandy Station','Culpeper',38.512782,-77.89537),('22715','VA','Brightwood','Madison',38.410696,-78.185599),('22716','VA','Castleton','Rappahannock',38.635765,-78.105909),('22718','VA','Elkwood','Culpeper',38.477181,-77.82746),('22719','VA','Etlan','Madison',38.525944,-78.275611),('22720','VA','Goldvein','Fauquier',38.473656,-77.643695),('22721','VA','Graves Mill','Madison',38.393351,-78.287375),('22722','VA','Haywood','Madison',38.466262,-78.227069),('22723','VA','Hood','Madison',38.334605,-78.380361),('22724','VA','Jeffersonton','Culpeper',38.622904,-77.89899),('22725','VA','Leon','Madison',38.4432,-78.1544),('22726','VA','Lignum','Culpeper',38.403339,-77.813451),('22727','VA','Madison','Madison',38.394113,-78.277433),('22728','VA','Midland','Fauquier',38.589708,-77.703363),('22729','VA','Mitchells','Culpeper',38.363797,-78.0174),('22730','VA','Oakpark','Madison',38.373001,-78.167027),('22731','VA','Pratts','Madison',38.337492,-78.26163),('22732','VA','Radiant','Madison',38.319016,-78.196034),('22733','VA','Rapidan','Culpeper',38.325887,-78.057838),('22734','VA','Remington','Fauquier',38.531281,-77.809598),('22735','VA','Reva','Culpeper',38.466946,-78.163676),('22736','VA','Richardsville','Culpeper',38.391087,-77.700162),('22737','VA','Rixeyville','Culpeper',38.591019,-77.998849),('22738','VA','Rochelle','Madison',38.293898,-78.295945),('22739','VA','Somerville','Fauquier',38.6169,-77.6439),('22740','VA','Sperryville','Rappahannock',38.631677,-78.238868),('22741','VA','Stevensburg','Culpeper',38.448109,-77.88931),('22742','VA','Sumerduck','Fauquier',38.464605,-77.708333),('22743','VA','Syria','Madison',38.513685,-78.362131),('22746','VA','Viewtown','Rappahannock',38.638635,-78.030611),('22747','VA','Washington','Rappahannock',38.711698,-78.16398),('22748','VA','Wolftown','Madison',38.3555,-78.3477),('22749','VA','Woodville','Rappahannock',38.634106,-78.173546),('22801','VA','Harrisonburg','Harrisonburg City',38.418055,-78.874182),('22802','VA','Harrisonburg','Harrisonburg City',38.486791,-78.853838),('22803','VA','Harrisonburg','Harrisonburg City',38.5056,-78.9398),('22807','VA','Harrisonburg','Harrisonburg City',38.434755,-78.868247),('22810','VA','Basye','Shenandoah',38.812631,-78.778194),('22811','VA','Bergton','Rockingham',38.785166,-78.970519),('22812','VA','Bridgewater','Rockingham',38.386038,-79.000133),('22815','VA','Broadway','Rockingham',38.610948,-78.801657),('22820','VA','Criders','Rockingham',38.747876,-79.008271),('22821','VA','Dayton','Rockingham',38.434999,-78.998295),('22824','VA','Edinburg','Shenandoah',38.831891,-78.606352),('22827','VA','Elkton','Rockingham',38.402058,-78.625924),('22830','VA','Fulks Run','Rockingham',38.652297,-78.958213),('22831','VA','Hinton','Rockingham',38.551589,-79.070769),('22832','VA','Keezletown','Rockingham',38.441325,-78.773284),('22833','VA','Lacey Spring','Rockingham',38.5411,-78.7666),('22834','VA','Linville','Rockingham',38.559256,-78.860046),('22835','VA','Luray','Page',38.663198,-78.450104),('22840','VA','Mc Gaheysville','Rockingham',38.378388,-78.739578),('22841','VA','Mount Crawford','Rockingham',38.345277,-78.910066),('22842','VA','Mount Jackson','Shenandoah',38.779793,-78.679449),('22843','VA','Mount Solon','Augusta',38.351568,-79.146625),('22844','VA','New Market','Shenandoah',38.654366,-78.668132),('22845','VA','Orkney Springs','Shenandoah',38.788499,-78.814881),('22846','VA','Penn Laird','Rockingham',38.379905,-78.794314),('22847','VA','Quicksburg','Shenandoah',38.71371,-78.690297),('22848','VA','Pleasant Valley','Rockingham',38.3847,-78.8975),('22849','VA','Shenandoah','Page',38.506514,-78.612723),('22850','VA','Singers Glen','Rockingham',38.548066,-78.929468),('22851','VA','Stanley','Page',38.567784,-78.507076),('22853','VA','Timberville','Rockingham',38.646046,-78.768552),('22901','VA','Charlottesville','Albemarle',38.075916,-78.52004),('22902','VA','Charlottesville','Charlottesville City',38.004803,-78.47204),('22903','VA','Charlottesville','Charlottesville City',38.024632,-78.547382),('22904','VA','Charlottesville','Albemarle',38.032855,-78.51682),('22905','VA','Charlottesville','Charlottesville City',38.0519,-78.501),('22906','VA','Charlottesville','Charlottesville City',38.0883,-78.4701),('22907','VA','Charlottesville','Charlottesville City',38.0575,-78.4922),('22908','VA','Charlottesville','Charlottesville City',38.0291,-78.4769),('22909','VA','Charlottesville','Albemarle',38.0444,-78.4726),('22910','VA','Charlottesville','Charlottesville City',38.0291,-78.4769),('22911','VA','Charlottesville','Albemarle',38.086449,-78.418396),('22920','VA','Afton','Nelson',37.987092,-78.808728),('22922','VA','Arrington','Nelson',37.686732,-78.92642),('22923','VA','Barboursville','Greene',38.188326,-78.318434),('22924','VA','Batesville','Albemarle',38.000289,-78.726626),('22931','VA','Covesville','Albemarle',37.892632,-78.703544),('22932','VA','Crozet','Albemarle',38.106007,-78.695542),('22935','VA','Dyke','Greene',38.270473,-78.557727),('22936','VA','Earlysville','Albemarle',38.14128,-78.483862),('22937','VA','Esmont','Albemarle',37.797229,-78.619208),('22938','VA','Faber','Nelson',37.860436,-78.775732),('22939','VA','Fishersville','Augusta',38.10786,-78.978798),('22940','VA','Free Union','Albemarle',38.197491,-78.593305),('22942','VA','Gordonsville','Louisa',38.116608,-78.188563),('22943','VA','Greenwood','Albemarle',38.039354,-78.773504),('22945','VA','Ivy','Albemarle',38.0563,-78.5969),('22946','VA','Keene','Albemarle',37.850493,-78.563633),('22947','VA','Keswick','Albemarle',38.0284,-78.330669),('22948','VA','Locust Dale','Madison',38.351239,-78.117413),('22949','VA','Lovingston','Nelson',37.777155,-78.86957),('22952','VA','Lyndhurst','Augusta',37.989252,-78.941827),('22957','VA','Montpelier Station','Orange',38.221405,-78.19026),('22958','VA','Nellysford','Nelson',37.901799,-78.897013),('22959','VA','North Garden','Albemarle',37.938547,-78.638324),('22960','VA','Orange','Orange',38.222052,-78.077924),('22963','VA','Palmyra','Fluvanna',37.871258,-78.308069),('22964','VA','Piney River','Nelson',37.717822,-79.01167),('22965','VA','Quinque','Greene',38.25,-78.398),('22967','VA','Roseland','Nelson',37.790067,-78.997611),('22968','VA','Ruckersville','Greene',38.241063,-78.389844),('22969','VA','Schuyler','Nelson',37.784918,-78.702592),('22971','VA','Shipman','Nelson',37.744963,-78.803561),('22972','VA','Somerset','Orange',38.210614,-78.220679),('22973','VA','Stanardsville','Greene',38.320325,-78.457522),('22974','VA','Troy','Fluvanna',37.976315,-78.278408),('22976','VA','Tyro','Nelson',37.841085,-79.047187),('22980','VA','Waynesboro','Waynesboro City',38.078816,-78.898305),('22987','VA','White Hall','Albemarle',38.1177,-78.6616),('22989','VA','Woodberry Forest','Madison',38.29321,-78.11901),('23001','VA','Achilles','Gloucester',37.293165,-76.410579),('23002','VA','Amelia Court House','Amelia',37.350276,-77.946565),('23003','VA','Ark','Gloucester',37.4383,-76.5761),('23004','VA','Arvonia','Buckingham',37.684714,-78.388881),('23005','VA','Ashland','Hanover',37.756515,-77.478512),('23009','VA','Aylett','King William',37.807858,-77.166716),('23011','VA','Barhamsville','New Kent',37.477354,-76.812452),('23014','VA','Beaumont','Goochland',37.7205,-77.9986),('23015','VA','Beaverdam','Hanover',37.934834,-77.634794),('23018','VA','Bena','Gloucester',37.2708,-76.4558),('23021','VA','Bohannon','Mathews',37.393558,-76.363775),('23022','VA','Bremo Bluff','Fluvanna',37.723148,-78.271511),('23023','VA','Bruington','King And Queen',37.771488,-76.960446),('23024','VA','Bumpass','Louisa',37.96075,-77.768476),('23025','VA','Cardinal','Mathews',37.412536,-76.359552),('23027','VA','Cartersville','Cumberland',37.656556,-78.127353),('23030','VA','Charles City','Charles City',37.352441,-77.078498),('23031','VA','Christchurch','Middlesex',37.6047,-76.5347),('23032','VA','Church View','Middlesex',37.662694,-76.683379),('23035','VA','Cobbs Creek','Mathews',37.50559,-76.371952),('23038','VA','Columbia','Goochland',37.746046,-78.146015),('23039','VA','Crozier','Goochland',37.642481,-77.805978),('23040','VA','Cumberland','Cumberland',37.498752,-78.257509),('23043','VA','Deltaville','Middlesex',37.552092,-76.335904),('23045','VA','Diggs','Mathews',37.440715,-76.258792),('23047','VA','Doswell','Hanover',37.844148,-77.469396),('23050','VA','Dutton','Mathews',37.497645,-76.4319),('23055','VA','Fork Union','Fluvanna',37.773279,-78.209218),('23056','VA','Foster','Mathews',37.420347,-76.361398),('23058','VA','Glen Allen','Henrico',37.6658,-77.5066),('23059','VA','Glen Allen','Henrico',37.690759,-77.54653),('23060','VA','Glen Allen','Henrico',37.657533,-77.530585),('23061','VA','Gloucester','Gloucester',37.425875,-76.530016),('23062','VA','Gloucester Point','Gloucester',37.257088,-76.495641),('23063','VA','Goochland','Goochland',37.716117,-77.994446),('23064','VA','Grimstead','Mathews',37.493576,-76.309095),('23065','VA','Gum Spring','Goochland',37.799259,-77.919817),('23066','VA','Gwynn','Mathews',37.495636,-76.286578),('23067','VA','Hadensville','Goochland',37.8237,-78.0049),('23068','VA','Hallieford','Mathews',37.497219,-76.337868),('23069','VA','Hanover','Hanover',37.76889,-77.339042),('23070','VA','Hardyville','Middlesex',37.554948,-76.390675),('23071','VA','Hartfield','Middlesex',37.536037,-76.450326),('23072','VA','Hayes','Gloucester',37.290247,-76.474845),('23075','VA','Highland Springs','Henrico',37.544709,-77.320835),('23076','VA','Hudgins','Mathews',37.475475,-76.313292),('23079','VA','Jamaica','Middlesex',37.72393,-76.687354),('23081','VA','Jamestown','James City',37.208,-76.7744),('23083','VA','Jetersville','Amelia',37.299331,-78.114845),('23084','VA','Kents Store','Fluvanna',37.882519,-78.10418),('23085','VA','King And Queen Court House','King And Queen',37.675939,-76.883406),('23086','VA','King William','King William',37.668573,-77.054414),('23089','VA','Lanexa','New Kent',37.440249,-76.901801),('23090','VA','Lightfoot','York',37.2686,-76.7551),('23091','VA','Little Plymouth','King And Queen',37.632111,-76.826641),('23092','VA','Locust Hill','Middlesex',37.601465,-76.506591),('23093','VA','Louisa','Louisa',38.004167,-78.040057),('23101','VA','Macon','Powhatan',37.5216,-77.9622),('23102','VA','Maidens','Goochland',37.715761,-77.823023),('23103','VA','Manakin Sabot','Goochland',37.640336,-77.728038),('23105','VA','Mannboro','Amelia',37.3486,-77.9638),('23106','VA','Manquin','King William',37.712966,-77.200593),('23107','VA','Maryus','Gloucester',37.2794,-76.403),('23108','VA','Mascot','King And Queen',37.656133,-76.720486),('23109','VA','Mathews','Mathews',37.43272,-76.332503),('23110','VA','Mattaponi','King And Queen',37.56501,-76.778016),('23111','VA','Mechanicsville','Hanover',37.613073,-77.303679),('23112','VA','Midlothian','Chesterfield',37.428792,-77.650065),('23113','VA','Midlothian','Chesterfield',37.52854,-77.653719),('23114','VA','Midlothian','Chesterfield',37.48438,-77.649582),('23115','VA','Millers Tavern','Essex',37.797709,-76.915187),('23116','VA','Mechanicsville','Hanover',37.660274,-77.366905),('23117','VA','Mineral','Louisa',38.016527,-77.865099),('23119','VA','Moon','Mathews',37.451739,-76.284649),('23120','VA','Moseley','Chesterfield',37.399648,-77.783769),('23123','VA','New Canton','Buckingham',37.666772,-78.294699),('23124','VA','New Kent','New Kent',37.549825,-77.060553),('23125','VA','New Point','Mathews',37.342723,-76.280715),('23126','VA','Newtown','King And Queen',37.903073,-77.147726),('23127','VA','Norge','James City',37.2686,-76.7551),('23128','VA','North','Mathews',37.447022,-76.429541),('23129','VA','Oilville','Goochland',37.697347,-77.77824),('23130','VA','Onemo','Mathews',37.387759,-76.27618),('23131','VA','Ordinary','Gloucester',37.3152,-76.5136),('23138','VA','Port Haywood','Mathews',37.371711,-76.306085),('23139','VA','Powhatan','Powhatan',37.546703,-77.910176),('23140','VA','Providence Forge','New Kent',37.440794,-77.038538),('23141','VA','Quinton','New Kent',37.515943,-77.155894),('23146','VA','Rockville','Hanover',37.73149,-77.704529),('23147','VA','Ruthville','Charles City',37.3672,-77.0413),('23148','VA','Saint Stephens Church','King And Queen',37.839632,-77.058621),('23149','VA','Saluda','Middlesex',37.578643,-76.602575),('23150','VA','Sandston','Henrico',37.516935,-77.278774),('23153','VA','Sandy Hook','Goochland',37.776241,-77.951646),('23154','VA','Schley','Gloucester',37.3894,-76.4552),('23155','VA','Severn','Gloucester',37.2941,-76.4158),('23156','VA','Shacklefords','King And Queen',37.505487,-76.705295),('23160','VA','State Farm','Powhatan',37.628163,-77.845916),('23161','VA','Stevensville','King And Queen',37.715866,-76.935072),('23162','VA','Studley','Hanover',37.6755,-77.2911),('23163','VA','Susan','Mathews',37.353131,-76.31131),('23168','VA','Toano','James City',37.403146,-76.823964),('23169','VA','Topping','Middlesex',37.594788,-76.449243),('23170','VA','Trevilians','Louisa',38.0513,-78.073),('23173','VA','University Of Richmond','Richmond City',37.577676,-77.536969),('23175','VA','Urbanna','Middlesex',37.652883,-76.599569),('23176','VA','Wake','Middlesex',37.572901,-76.414966),('23177','VA','Walkerton','King And Queen',37.729995,-77.017778),('23178','VA','Ware Neck','Gloucester',37.400287,-76.46089),('23180','VA','Water View','Middlesex',37.692893,-76.612831),('23181','VA','West Point','King William',37.571839,-76.842377),('23183','VA','White Marsh','Gloucester',37.3422,-76.5216),('23184','VA','Wicomico','Gloucester',37.285188,-76.529806),('23185','VA','Williamsburg','James City',37.25474,-76.691854),('23186','VA','Williamsburg','Williamsburg City',37.270994,-76.717226),('23187','VA','Williamsburg','Williamsburg City',37.266229,-76.720898),('23188','VA','Williamsburg','James City',37.321918,-76.743921),('23190','VA','Woods Cross Roads','Gloucester',37.4819,-76.619),('23192','VA','Montpelier','Hanover',37.814069,-77.678045),('23218','VA','Richmond','Richmond City',37.5594,-77.4472),('23219','VA','Richmond','Richmond City',37.540604,-77.434733),('23220','VA','Richmond','Richmond City',37.55003,-77.458747),('23221','VA','Richmond','Richmond City',37.557891,-77.488501),('23222','VA','Richmond','Richmond City',37.575524,-77.42497),('23223','VA','Richmond','Henrico',37.546972,-77.397193),('23224','VA','Richmond','Richmond City',37.503872,-77.462768),('23225','VA','Richmond','Richmond City',37.519365,-77.502539),('23226','VA','Richmond','Richmond City',37.58126,-77.517945),('23227','VA','Richmond','Henrico',37.604981,-77.450218),('23228','VA','Richmond','Henrico',37.622787,-77.491598),('23229','VA','Richmond','Henrico',37.592649,-77.565409),('23230','VA','Richmond','Henrico',37.581267,-77.488439),('23231','VA','Richmond','Henrico',37.475329,-77.356111),('23232','VA','Richmond','Richmond City',37.5594,-77.4472),('23233','VA','Richmond','Henrico',37.642869,-77.619196),('23234','VA','Richmond','Chesterfield',37.454663,-77.466355),('23235','VA','Richmond','Chesterfield',37.515039,-77.569774),('23236','VA','Richmond','Chesterfield',37.473445,-77.586363),('23237','VA','Richmond','Chesterfield',37.406914,-77.450882),('23238','VA','Richmond','Henrico',37.605105,-77.623835),('23240','VA','Richmond','Richmond City',37.5536,-77.4605),('23241','VA','Richmond','Richmond City',37.5441,-77.4406),('23242','VA','Richmond','Henrico',37.6171,-77.6149),('23249','VA','Richmond','Richmond City',37.4967,-77.4672),('23250','VA','Richmond','Henrico',37.507,-77.3332),('23255','VA','Richmond','Henrico',37.6074,-77.5672),('23260','VA','Richmond','Richmond City',37.5594,-77.4472),('23261','VA','Richmond','Richmond City',37.5594,-77.4472),('23269','VA','Richmond','Richmond City',37.5594,-77.4472),('23273','VA','Richmond','Richmond City',37.5536,-77.4605),('23274','VA','Richmond','Richmond City',37.5536,-77.4605),('23276','VA','Richmond','Richmond City',37.5536,-77.4605),('23278','VA','Richmond','Richmond City',37.5536,-77.4605),('23279','VA','Richmond','Richmond City',37.5536,-77.4605),('23282','VA','Richmond','Richmond City',37.5536,-77.4605),('23284','VA','Richmond','Richmond City',37.5484,-77.454),('23285','VA','Richmond','Richmond City',37.5594,-77.4472),('23286','VA','Richmond','Richmond City',37.5594,-77.4472),('23288','VA','Richmond','Henrico',37.5992,-77.5456),('23289','VA','Richmond','Henrico',37.5439,-77.4489),('23290','VA','Richmond','Richmond City',37.5536,-77.4605),('23291','VA','Richmond','Richmond City',37.5536,-77.4605),('23292','VA','Richmond','Richmond City',37.5536,-77.4605),('23293','VA','Richmond','Richmond City',37.5428,-77.4396),('23294','VA','Richmond','Henrico',37.631281,-77.542534),('23295','VA','Richmond','Richmond City',37.5537,-77.4609),('23297','VA','Richmond','Chesterfield',37.4019,-77.4597),('23298','VA','Richmond','Richmond City',37.539694,-77.428159),('23301','VA','Accomac','Accomack',37.704301,-75.653543),('23302','VA','Assawoman','Accomack',37.86567,-75.520915),('23303','VA','Atlantic','Accomack',37.903366,-75.506367),('23304','VA','Battery Park','Isle Of Wight',36.996135,-76.572107),('23306','VA','Belle Haven','Accomack',37.559597,-75.861814),('23307','VA','Birdsnest','Northampton',37.43778,-75.874821),('23308','VA','Bloxom','Accomack',37.828389,-75.612827),('23310','VA','Cape Charles','Northampton',37.265137,-75.969753),('23313','VA','Capeville','Northampton',37.203979,-75.942304),('23314','VA','Carrollton','Isle Of Wight',36.946021,-76.537279),('23315','VA','Carrsville','Isle Of Wight',36.73739,-76.840511),('23316','VA','Cheriton','Northampton',37.290987,-75.974636),('23320','VA','Chesapeake','Chesapeake City',36.761675,-76.24382),('23321','VA','Chesapeake','Chesapeake City',36.819103,-76.414816),('23322','VA','Chesapeake','Chesapeake City',36.677585,-76.229396),('23323','VA','Chesapeake','Chesapeake City',36.752264,-76.337223),('23324','VA','Chesapeake','Chesapeake City',36.803582,-76.271381),('23325','VA','Chesapeake','Chesapeake City',36.813625,-76.239857),('23326','VA','Chesapeake','Chesapeake City',36.7662,-76.252),('23327','VA','Chesapeake','Chesapeake City',36.7662,-76.252),('23328','VA','Chesapeake','Chesapeake City',36.7296,-76.2268),('23336','VA','Chincoteague Island','Accomack',37.929343,-75.362858),('23337','VA','Wallops Island','Accomack',37.924095,-75.485616),('23341','VA','Craddockville','Accomack',37.5816,-75.8691),('23345','VA','Davis Wharf','Accomack',37.5527,-75.8783),('23347','VA','Eastville','Northampton',37.346262,-75.960696),('23350','VA','Exmore','Northampton',37.520555,-75.859274),('23354','VA','Franktown','Northampton',37.46672,-75.9096),('23356','VA','Greenbackville','Accomack',37.999971,-75.415855),('23357','VA','Greenbush','Accomack',37.754235,-75.679201),('23358','VA','Hacksneck','Accomack',37.652664,-75.867947),('23359','VA','Hallwood','Accomack',37.875163,-75.580988),('23389','VA','Harborton','Accomack',37.664424,-75.831153),('23395','VA','Horntown','Accomack',37.965961,-75.460057),('23396','VA','Oak Hall','Accomack',37.9352,-75.5752),('23397','VA','Isle Of Wight','Isle Of Wight',36.8547,-76.721),('23398','VA','Jamesville','Northampton',37.50511,-75.945093),('23399','VA','Jenkins Bridge','Accomack',37.9208,-75.6432),('23401','VA','Keller','Accomack',37.621714,-75.766627),('23404','VA','Locustville','Accomack',37.635838,-75.666429),('23405','VA','Machipongo','Northampton',37.411716,-75.926589),('23407','VA','Mappsville','Accomack',37.845607,-75.557491),('23408','VA','Marionville','Northampton',37.452913,-75.843475),('23409','VA','Mears','Accomack',37.867372,-75.632464),('23410','VA','Melfa','Accomack',37.644811,-75.747181),('23412','VA','Modest Town','Accomack',37.8127,-75.5652),('23413','VA','Nassawadox','Northampton',37.473584,-75.862087),('23414','VA','Nelsonia','Accomack',37.813459,-75.586979),('23415','VA','New Church','Accomack',37.96913,-75.518564),('23416','VA','Oak Hall','Accomack',37.933901,-75.550083),('23417','VA','Onancock','Accomack',37.725102,-75.76865),('23418','VA','Onley','Accomack',37.682353,-75.700079),('23419','VA','Oyster','Northampton',37.2863,-75.9227),('23420','VA','Painter','Accomack',37.581486,-75.801263),('23421','VA','Parksley','Accomack',37.777387,-75.624336),('23422','VA','Pungoteague','Accomack',37.632017,-75.822282),('23423','VA','Quinby','Accomack',37.525301,-75.71431),('23424','VA','Rescue','Isle Of Wight',36.9958,-76.5608),('23426','VA','Sanford','Accomack',37.923438,-75.668716),('23427','VA','Saxis','Accomack',37.909575,-75.728501),('23429','VA','Seaview','Northampton',37.2616,-75.9461),('23430','VA','Smithfield','Isle Of Wight',36.976087,-76.637188),('23431','VA','Smithfield','Isle Of Wight',36.9804,-76.6347),('23432','VA','Suffolk','Suffolk City',36.876452,-76.553978),('23433','VA','Suffolk','Suffolk City',36.909367,-76.497037),('23434','VA','Suffolk','Suffolk City',36.740284,-76.603924),('23435','VA','Suffolk','Suffolk City',36.853461,-76.463079),('23436','VA','Suffolk','Suffolk City',36.90002,-76.507345),('23437','VA','Suffolk','Suffolk City',36.638153,-76.803489),('23438','VA','Suffolk','Suffolk City',36.581022,-76.702687),('23439','VA','Suffolk','Suffolk City',36.7367,-76.5823),('23440','VA','Tangier','Accomack',37.828481,-75.991991),('23441','VA','Tasley','Accomack',37.708259,-75.701461),('23442','VA','Temperanceville','Accomack',37.904349,-75.570089),('23443','VA','Townsend','Northampton',37.1844,-75.9586),('23450','VA','Virginia Beach','Virginia Beach City',36.8527,-75.9783),('23451','VA','Virginia Beach','Virginia Beach City',36.862546,-76.002453),('23452','VA','Virginia Beach','Virginia Beach City',36.838783,-76.093551),('23453','VA','Virginia Beach','Virginia Beach City',36.791677,-76.089228),('23454','VA','Virginia Beach','Virginia Beach City',36.83606,-76.030447),('23455','VA','Virginia Beach','Virginia Beach City',36.891472,-76.14806),('23456','VA','Virginia Beach','Virginia Beach City',36.750874,-76.060537),('23457','VA','Virginia Beach','Virginia Beach City',36.615464,-76.043089),('23458','VA','Virginia Beach','Virginia Beach City',36.8525,-75.9767),('23459','VA','Virginia Beach','Virginia Beach City',36.925494,-76.015319),('23460','VA','Virginia Beach','Virginia Beach City',36.809332,-76.028586),('23461','VA','Virginia Beach','Virginia Beach City',36.775769,-75.961976),('23462','VA','Virginia Beach','Virginia Beach City',36.83869,-76.152161),('23463','VA','Virginia Beach','Virginia Beach City',36.7996,-76.1902),('23464','VA','Virginia Beach','Virginia Beach City',36.800268,-76.180545),('23465','VA','Virginia Beach','Virginia Beach City',36.8018,-76.1735),('23466','VA','Virginia Beach','Virginia Beach City',36.8527,-75.9783),('23467','VA','Virginia Beach','Virginia Beach City',36.8018,-76.1735),('23471','VA','Virginia Beach','Virginia Beach City',36.8952,-76.1416),('23479','VA','Virginia Beach','Virginia Beach City',36.8527,-75.9783),('23480','VA','Wachapreague','Accomack',37.607829,-75.689938),('23482','VA','Wardtown','Northampton',37.5347,-75.8772),('23483','VA','Wattsville','Accomack',37.9338,-75.5),('23486','VA','Willis Wharf','Northampton',37.513775,-75.808535),('23487','VA','Windsor','Isle Of Wight',36.838252,-76.73053),('23488','VA','Withams','Accomack',37.950827,-75.599122),('23501','VA','Norfolk','Norfolk City',36.8466,-76.2855),('23502','VA','Norfolk','Norfolk City',36.856479,-76.210811),('23503','VA','Norfolk','Norfolk City',36.945559,-76.258156),('23504','VA','Norfolk','Norfolk City',36.859202,-76.269922),('23505','VA','Norfolk','Norfolk City',36.916802,-76.284942),('23506','VA','Norfolk','Norfolk City',36.8466,-76.2855),('23507','VA','Norfolk','Norfolk City',36.862983,-76.300038),('23508','VA','Norfolk','Norfolk City',36.885913,-76.301633),('23509','VA','Norfolk','Norfolk City',36.880094,-76.261185),('23510','VA','Norfolk','Norfolk City',36.85268,-76.288611),('23511','VA','Norfolk','Norfolk City',36.942745,-76.313957),('23512','VA','Norfolk','Norfolk City',36.9214,-76.3161),('23513','VA','Norfolk','Norfolk City',36.889682,-76.238743),('23514','VA','Norfolk','Norfolk City',36.8469,-76.2904),('23515','VA','Norfolk','Norfolk City',36.9471,-76.3005),('23517','VA','Norfolk','Norfolk City',36.869736,-76.292523),('23518','VA','Norfolk','Norfolk City',36.91681,-76.217891),('23519','VA','Norfolk','Norfolk City',36.9222,-76.1884),('23520','VA','Norfolk','Norfolk City',36.8466,-76.2855),('23521','VA','Norfolk','Virginia Beach City',36.916397,-76.152707),('23523','VA','Norfolk','Norfolk City',36.831087,-76.272359),('23529','VA','Norfolk','Norfolk City',36.8871,-76.3053),('23541','VA','Norfolk','Norfolk City',36.8466,-76.2855),('23551','VA','Norfolk','Norfolk City',36.923933,-76.288717),('23601','VA','Newport News','Newport News City',37.054686,-76.462951),('23602','VA','Newport News','Newport News City',37.114016,-76.510998),('23603','VA','Newport News','Newport News City',37.192048,-76.56757),('23604','VA','Fort Eustis','Newport News City',37.148333,-76.581637),('23605','VA','Newport News','Newport News City',37.021148,-76.437588),('23606','VA','Newport News','Newport News City',37.076972,-76.492519),('23607','VA','Newport News','Newport News City',36.988803,-76.420592),('23608','VA','Newport News','Newport News City',37.148425,-76.546305),('23609','VA','Newport News','Newport News City',36.9786,-76.4283),('23612','VA','Newport News','Newport News City',37.0679,-76.4959),('23628','VA','Newport News','Newport News City',36.9786,-76.4283),('23630','VA','Hampton','Hampton City',37.0065,-76.413),('23651','VA','Fort Monroe','Hampton City',37.006987,-76.309022),('23661','VA','Hampton','Hampton City',37.005782,-76.386453),('23662','VA','Poquoson','Poquoson City',37.13601,-76.373047),('23663','VA','Hampton','Hampton City',37.031994,-76.315214),('23664','VA','Hampton','Hampton City',37.060264,-76.293403),('23665','VA','Hampton','York',37.085003,-76.370535),('23666','VA','Hampton','Hampton City',37.052763,-76.4033),('23667','VA','Hampton','Hampton City',37.0297,-76.3455),('23668','VA','Hampton','Hampton City',37.0207,-76.3323),('23669','VA','Hampton','Hampton City',37.038146,-76.344672),('23670','VA','Hampton','Hampton City',37.0059,-76.4122),('23681','VA','Hampton','Hampton City',37.1009,-76.3932),('23690','VA','Yorktown','York',37.2249,-76.516204),('23691','VA','Yorktown','York',37.244964,-76.552741),('23692','VA','Yorktown','York',37.180762,-76.459909),('23693','VA','Yorktown','York',37.119163,-76.440022),('23694','VA','Lackey','York',37.2308,-76.553),('23696','VA','Seaford','York',37.19172,-76.428875),('23701','VA','Portsmouth','Portsmouth City',36.810851,-76.36775),('23702','VA','Portsmouth','Portsmouth City',36.803227,-76.323827),('23703','VA','Portsmouth','Portsmouth City',36.869864,-76.378454),('23704','VA','Portsmouth','Portsmouth City',36.828153,-76.311186),('23705','VA','Portsmouth','Portsmouth City',36.8352,-76.2986),('23707','VA','Portsmouth','Portsmouth City',36.836183,-76.34301),('23708','VA','Portsmouth','Portsmouth City',36.845865,-76.308606),('23709','VA','Portsmouth','Portsmouth City',36.813552,-76.305252),('23801','VA','Fort Lee','Prince George',37.23696,-77.339003),('23803','VA','Petersburg','Petersburg City',37.214735,-77.436414),('23804','VA','Petersburg','Petersburg City',37.2284,-77.4027),('23805','VA','Petersburg','Petersburg City',37.163668,-77.38883),('23806','VA','Petersburg','Chesterfield',37.238645,-77.418281),('23821','VA','Alberta','Brunswick',36.870214,-77.910137),('23822','VA','Ammon','Dinwiddie',37.1509,-77.7444),('23824','VA','Blackstone','Nottoway',37.065879,-77.970047),('23825','VA','Blackstone','Nottoway',37.0862,-77.9955),('23827','VA','Boykins','Southampton',36.593391,-77.198834),('23828','VA','Branchville','Southampton',36.573154,-77.270139),('23829','VA','Capron','Southampton',36.73267,-77.217351),('23830','VA','Carson','Prince George',37.022308,-77.40547),('23831','VA','Chester','Chesterfield',37.350719,-77.44233),('23832','VA','Chesterfield','Chesterfield',37.404681,-77.583487),('23833','VA','Church Road','Dinwiddie',37.206293,-77.661488),('23834','VA','Colonial Heights','Colonial Heights City',37.271449,-77.400756),('23836','VA','Chester','Chesterfield',37.339847,-77.34959),('23837','VA','Courtland','Southampton',36.731762,-77.063637),('23838','VA','Chesterfield','Chesterfield',37.319771,-77.611193),('23839','VA','Dendron','Surry',37.079815,-76.920618),('23840','VA','Dewitt','Dinwiddie',37.059352,-77.655647),('23841','VA','Dinwiddie','Dinwiddie',37.060951,-77.562169),('23842','VA','Disputanta','Prince George',37.12664,-77.235746),('23843','VA','Dolphin','Brunswick',36.850251,-77.809581),('23844','VA','Drewryville','Southampton',36.680032,-77.326525),('23845','VA','Ebony','Brunswick',36.561574,-78.000685),('23846','VA','Elberon','Surry',37.047155,-76.84052),('23847','VA','Emporia','Greensville',36.68613,-77.565561),('23850','VA','Ford','Dinwiddie',37.162914,-77.74487),('23851','VA','Franklin','Franklin City',36.669384,-76.937515),('23856','VA','Freeman','Brunswick',36.78287,-77.703334),('23857','VA','Gasburg','Brunswick',36.58473,-77.881511),('23860','VA','Hopewell','Hopewell City',37.287268,-77.286298),('23866','VA','Ivor','Southampton',36.921797,-76.873699),('23867','VA','Jarratt','Greensville',36.820372,-77.488594),('23868','VA','Lawrenceville','Brunswick',36.722009,-77.817381),('23870','VA','Jarratt','Greensville',36.8003,-77.4925),('23872','VA','Mc Kenney','Dinwiddie',36.991837,-77.73309),('23873','VA','Meredithville','Brunswick',36.6971,-77.8152),('23874','VA','Newsoms','Southampton',36.610467,-77.102275),('23875','VA','Prince George','Prince George',37.233054,-77.28141),('23876','VA','Rawlings','Brunswick',36.955753,-77.83361),('23878','VA','Sedley','Southampton',36.821973,-77.006914),('23879','VA','Skippers','Greensville',36.592275,-77.596839),('23881','VA','Spring Grove','Surry',37.178459,-76.995304),('23882','VA','Stony Creek','Sussex',36.923804,-77.433131),('23883','VA','Surry','Surry',37.127249,-76.745809),('23884','VA','Sussex','Sussex',36.915071,-77.280009),('23885','VA','Sutherland','Dinwiddie',37.197641,-77.571544),('23887','VA','Valentines','Brunswick',36.559251,-77.82962),('23888','VA','Wakefield','Sussex',36.967207,-76.978722),('23889','VA','Warfield','Brunswick',36.900108,-77.745861),('23890','VA','Waverly','Sussex',37.009181,-77.118263),('23891','VA','Waverly','Sussex',37.044274,-77.209052),('23893','VA','White Plains','Brunswick',36.621803,-77.930991),('23894','VA','Wilsons','Dinwiddie',37.125697,-77.832046),('23897','VA','Yale','Sussex',36.829008,-77.283615),('23898','VA','Zuni','Isle Of Wight',36.842048,-76.840506),('23899','VA','Claremont','Surry',37.228808,-76.96576),('23901','VA','Farmville','Prince Edward',37.312044,-78.401632),('23909','VA','Farmville','Prince Edward',37.300499,-78.39563),('23915','VA','Baskerville','Mecklenburg',36.693141,-78.287418),('23917','VA','Boydton','Mecklenburg',36.616189,-78.309898),('23919','VA','Bracey','Mecklenburg',36.585691,-78.12264),('23920','VA','Brodnax','Brunswick',36.724247,-77.987645),('23921','VA','Buckingham','Buckingham',37.594144,-78.61345),('23922','VA','Burkeville','Nottoway',37.191409,-78.211524),('23923','VA','Charlotte Court House','Charlotte',37.094925,-78.63399),('23924','VA','Chase City','Mecklenburg',36.804778,-78.455605),('23927','VA','Clarksville','Mecklenburg',36.624753,-78.530016),('23930','VA','Crewe','Nottoway',37.175237,-78.115987),('23934','VA','Cullen','Charlotte',37.164072,-78.625165),('23936','VA','Dillwyn','Buckingham',37.536524,-78.480384),('23937','VA','Drakes Branch','Charlotte',36.948539,-78.526869),('23938','VA','Dundas','Brunswick',36.910629,-78.006198),('23939','VA','Evergreen','Appomattox',37.312972,-78.772032),('23941','VA','Fort Mitchell','Lunenburg',37.0363,-78.4637),('23942','VA','Green Bay','Prince Edward',37.129727,-78.298581),('23943','VA','Hampden Sydney','Prince Edward',37.242617,-78.457208),('23944','VA','Kenbridge','Lunenburg',36.915361,-78.12952),('23947','VA','Keysville','Charlotte',37.026164,-78.454997),('23950','VA','La Crosse','Mecklenburg',36.685867,-78.081992),('23952','VA','Lunenburg','Lunenburg',36.929262,-78.278451),('23954','VA','Meherrin','Prince Edward',37.110183,-78.383469),('23955','VA','Nottoway','Nottoway',37.1291,-78.078),('23958','VA','Pamplin','Appomattox',37.268134,-78.661768),('23959','VA','Phenix','Charlotte',37.093916,-78.791606),('23960','VA','Prospect','Prince Edward',37.304158,-78.557633),('23962','VA','Randolph','Charlotte',36.893068,-78.705292),('23963','VA','Red House','Charlotte',37.196764,-78.817862),('23964','VA','Red Oak','Charlotte',36.784463,-78.619094),('23966','VA','Rice','Prince Edward',37.28035,-78.275329),('23967','VA','Saxe','Charlotte',36.91118,-78.621212),('23968','VA','Skipwith','Mecklenburg',36.725266,-78.528519),('23970','VA','South Hill','Mecklenburg',36.738662,-78.166987),('23974','VA','Victoria','Lunenburg',36.983149,-78.238713),('23976','VA','Wylliesburg','Charlotte',36.849757,-78.590507),('24001','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24002','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24003','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24004','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24005','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24006','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24007','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24008','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24009','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24010','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24011','VA','Roanoke','Roanoke City',37.270818,-79.939834),('24012','VA','Roanoke','Roanoke City',37.306099,-79.926894),('24013','VA','Roanoke','Roanoke City',37.267728,-79.925461),('24014','VA','Roanoke','Roanoke City',37.236871,-79.928517),('24015','VA','Roanoke','Roanoke City',37.261217,-79.977521),('24016','VA','Roanoke','Roanoke City',37.271332,-79.951798),('24017','VA','Roanoke','Roanoke City',37.290523,-79.984604),('24018','VA','Roanoke','Roanoke',37.223607,-80.025518),('24019','VA','Roanoke','Roanoke',37.340333,-79.946831),('24020','VA','Roanoke','Roanoke',37.357769,-79.940562),('24022','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24023','VA','Roanoke','Montgomery',37.2698,-79.9537),('24024','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24025','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24026','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24027','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24028','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24029','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24030','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24031','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24032','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24033','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24034','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24035','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24036','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24037','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24038','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24040','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24042','VA','Roanoke','Roanoke City',37.2695,-79.9386),('24043','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24044','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24045','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24048','VA','Roanoke','Roanoke City',37.2708,-79.9416),('24050','VA','Roanoke','Botetourt',37.2725,-79.953),('24053','VA','Ararat','Patrick',36.609952,-80.541027),('24054','VA','Axton','Henry',36.666377,-79.709152),('24055','VA','Bassett','Henry',36.760514,-79.987737),('24058','VA','Belspring','Pulaski',37.188422,-80.608641),('24059','VA','Bent Mountain','Roanoke',37.152618,-80.140502),('24060','VA','Blacksburg','Montgomery',37.228782,-80.423796),('24061','VA','Blacksburg','Montgomery',37.2285,-80.4232),('24062','VA','Blacksburg','Montgomery',37.2294,-80.4141),('24063','VA','Blacksburg','Montgomery',37.2294,-80.4141),('24064','VA','Blue Ridge','Botetourt',37.37602,-79.770367),('24065','VA','Boones Mill','Franklin',37.123519,-79.953411),('24066','VA','Buchanan','Botetourt',37.529524,-79.696554),('24067','VA','Callaway','Franklin',37.024366,-80.065468),('24068','VA','Christiansburg','Montgomery',37.1296,-80.4089),('24069','VA','Cascade','Pittsylvania',36.591585,-79.638303),('24070','VA','Catawba','Roanoke',37.369478,-80.187389),('24072','VA','Check','Floyd',37.033101,-80.231001),('24073','VA','Christiansburg','Montgomery',37.140252,-80.420093),('24076','VA','Claudville','Patrick',36.591094,-80.419867),('24077','VA','Cloverdale','Botetourt',37.36548,-79.906508),('24078','VA','Collinsville','Henry',36.72404,-79.916431),('24079','VA','Copper Hill','Floyd',37.041963,-80.144768),('24082','VA','Critz','Patrick',36.620086,-80.116523),('24083','VA','Daleville','Botetourt',37.408887,-79.915405),('24084','VA','Dublin','Pulaski',37.099266,-80.71491),('24085','VA','Eagle Rock','Botetourt',37.682617,-79.816831),('24086','VA','Eggleston','Giles',37.28532,-80.621623),('24087','VA','Elliston','Montgomery',37.22097,-80.231688),('24088','VA','Ferrum','Franklin',36.898956,-80.070447),('24089','VA','Fieldale','Henry',36.70693,-79.953849),('24090','VA','Fincastle','Botetourt',37.510567,-79.871454),('24091','VA','Floyd','Floyd',36.91752,-80.317882),('24092','VA','Glade Hill','Franklin',37.003701,-79.771438),('24093','VA','Glen Lyn','Giles',37.376139,-80.856771),('24095','VA','Goodview','Bedford',37.212369,-79.737005),('24101','VA','Hardy','Franklin',37.192486,-79.782547),('24102','VA','Henry','Franklin',36.838156,-79.989493),('24104','VA','Huddleston','Bedford',37.109545,-79.51682),('24105','VA','Indian Valley','Floyd',36.894288,-80.599826),('24111','VA','Mc Coy','Montgomery',37.218,-80.5988),('24112','VA','Martinsville','Henry',36.695856,-79.865326),('24113','VA','Martinsville','Martinsville City',36.6803,-79.8537),('24114','VA','Martinsville','Martinsville City',36.6803,-79.8537),('24115','VA','Martinsville','Martinsville City',36.6803,-79.8537),('24120','VA','Meadows Of Dan','Patrick',36.719,-80.42091),('24121','VA','Moneta','Bedford',37.148319,-79.64347),('24122','VA','Montvale','Bedford',37.410146,-79.703081),('24124','VA','Narrows','Giles',37.321634,-80.840104),('24126','VA','Newbern','Pulaski',37.0733,-80.6908),('24127','VA','New Castle','Craig',37.499386,-80.181313),('24128','VA','Newport','Giles',37.32552,-80.469663),('24129','VA','New River','Pulaski',37.1333,-80.5916),('24130','VA','Oriskany','Botetourt',37.6163,-79.9838),('24131','VA','Paint Bank','Craig',37.569212,-80.261466),('24132','VA','Parrott','Pulaski',37.214092,-80.631778),('24133','VA','Patrick Springs','Patrick',36.663555,-80.151984),('24134','VA','Pearisburg','Giles',37.276304,-80.742955),('24136','VA','Pembroke','Giles',37.3185,-80.619584),('24137','VA','Penhook','Franklin',36.947793,-79.635496),('24138','VA','Pilot','Montgomery',37.050348,-80.325083),('24139','VA','Pittsville','Pittsylvania',37.013166,-79.481073),('24141','VA','Radford','Radford City',37.12178,-80.565498),('24142','VA','Radford','Radford City',37.137882,-80.550906),('24143','VA','Radford','Pulaski',37.1406,-80.5581),('24146','VA','Redwood','Franklin',37.0197,-79.8122),('24147','VA','Rich Creek','Giles',37.391971,-80.822001),('24148','VA','Ridgeway','Henry',36.591761,-79.868218),('24149','VA','Riner','Montgomery',37.019926,-80.436362),('24150','VA','Ripplemead','Giles',37.387633,-80.653667),('24151','VA','Rocky Mount','Franklin',36.977231,-79.875982),('24153','VA','Salem','Salem City',37.288265,-80.087425),('24155','VA','Roanoke','Salem',37.2935,-80.0553),('24157','VA','Roanoke,','Salem',37.2912,-80.0649),('24161','VA','Sandy Level','Pittsylvania',36.986112,-79.539299),('24162','VA','Shawsville','Montgomery',37.145264,-80.256425),('24165','VA','Spencer','Henry',36.590933,-80.033183),('24167','VA','Staffordsville','Giles',37.242045,-80.727759),('24168','VA','Stanleytown','Henry',36.736979,-79.946065),('24171','VA','Stuart','Patrick',36.65606,-80.238681),('24174','VA','Thaxton','Bedford',37.349416,-79.661749),('24175','VA','Troutville','Botetourt',37.410848,-79.912331),('24176','VA','Union Hall','Franklin',37.0225,-79.699744),('24177','VA','Vesta','Patrick',36.7166,-80.358),('24178','VA','Villamont','Bedford',37.3952,-79.7763),('24179','VA','Vinton','Roanoke',37.278874,-79.844515),('24184','VA','Wirtz','Franklin',37.069767,-79.770695),('24185','VA','Woolwine','Patrick',36.803569,-80.265391),('24201','VA','Bristol','Bristol City',36.606425,-82.180961),('24202','VA','Bristol','Washington',36.641352,-82.175734),('24203','VA','Bristol','Bristol',36.5963,-82.1886),('24205','VA','Bristol','Bristol',36.613,-82.172),('24209','VA','Bristol','Bristol',36.5963,-82.1886),('24210','VA','Abingdon','Washington',36.737958,-82.0019),('24211','VA','Abingdon','Washington',36.652363,-81.963865),('24212','VA','Abingdon','Washington',36.7097,-81.9775),('24215','VA','Andover','Wise',36.921924,-82.796443),('24216','VA','Appalachia','Wise',36.93051,-82.79477),('24217','VA','Bee','Dickenson',37.07743,-82.155247),('24218','VA','Ben Hur','Lee',36.733931,-83.0635),('24219','VA','Big Stone Gap','Wise',36.85423,-82.770881),('24220','VA','Birchleaf','Dickenson',37.155059,-82.246617),('24221','VA','Blackwater','Lee',36.627796,-82.966017),('24224','VA','Castlewood','Russell',36.873328,-82.276225),('24225','VA','Cleveland','Russell',36.97127,-82.14257),('24226','VA','Clinchco','Dickenson',37.154014,-82.34906),('24228','VA','Clintwood','Dickenson',37.156041,-82.452067),('24230','VA','Coeburn','Wise',36.956688,-82.469657),('24236','VA','Damascus','Washington',36.636194,-81.749602),('24237','VA','Dante','Dickenson',37.023599,-82.251981),('24239','VA','Davenport','Buchanan',37.113761,-82.148859),('24243','VA','Dryden','Lee',36.780153,-82.923147),('24244','VA','Duffield','Scott',36.70567,-82.801043),('24245','VA','Dungannon','Scott',36.819827,-82.481565),('24246','VA','East Stone Gap','Wise',36.867158,-82.744308),('24248','VA','Ewing','Lee',36.62923,-83.520599),('24250','VA','Fort Blackmore','Scott',36.754289,-82.598896),('24251','VA','Gate City','Scott',36.646559,-82.60493),('24256','VA','Haysi','Dickenson',37.21631,-82.286792),('24258','VA','Hiltons','Scott',36.645372,-82.422038),('24260','VA','Honaker','Russell',37.030725,-82.014818),('24263','VA','Jonesville','Lee',36.681647,-83.145662),('24265','VA','Keokee','Lee',36.838137,-82.949061),('24266','VA','Lebanon','Russell',36.887273,-82.097125),('24269','VA','Mc Clure','Dickenson',37.08315,-82.366854),('24270','VA','Mendota','Washington',36.721074,-82.25884),('24271','VA','Nickelsville','Scott',36.742066,-82.422016),('24272','VA','Nora','Dickenson',37.01781,-82.333363),('24273','VA','Norton','Norton City',36.9454,-82.639374),('24277','VA','Pennington Gap','Lee',36.752776,-83.029786),('24279','VA','Pound','Wise',37.101336,-82.598954),('24280','VA','Rosedale','Russell',36.958955,-81.933494),('24281','VA','Rose Hill','Lee',36.667175,-83.342387),('24282','VA','Saint Charles','Lee',36.812419,-83.057261),('24283','VA','Saint Paul','Wise',36.9286,-82.334981),('24290','VA','Weber City','Scott',36.61578,-82.56742),('24292','VA','Whitetop','Grayson',36.605952,-81.588185),('24293','VA','Wise','Wise',36.991399,-82.574979),('24301','VA','Pulaski','Pulaski',37.0542,-80.768379),('24311','VA','Atkins','Smyth',36.870686,-81.406176),('24312','VA','Austinville','Carroll',36.842129,-80.881362),('24313','VA','Barren Springs','Wythe',36.910789,-80.796892),('24314','VA','Bastian','Bland',37.182029,-81.18907),('24315','VA','Bland','Bland',37.149981,-81.050213),('24316','VA','Broadford','Tazewell',36.944341,-81.667428),('24317','VA','Cana','Carroll',36.600565,-80.67853),('24318','VA','Ceres','Bland',36.982348,-81.407311),('24319','VA','Chilhowie','Smyth',36.770949,-81.665473),('24322','VA','Cripple Creek','Wythe',36.821905,-81.113353),('24323','VA','Crockett','Wythe',36.874596,-81.200536),('24324','VA','Draper','Pulaski',36.974312,-80.776884),('24325','VA','Dugspur','Carroll',36.808578,-80.58906),('24326','VA','Elk Creek','Grayson',36.730997,-81.198935),('24327','VA','Emory','Washington',36.773659,-81.827713),('24328','VA','Fancy Gap','Carroll',36.660473,-80.686274),('24330','VA','Fries','Grayson',36.715103,-81.004283),('24333','VA','Galax','Galax City',36.648852,-80.926593),('24340','VA','Glade Spring','Washington',36.77014,-81.774334),('24343','VA','Hillsville','Carroll',36.762509,-80.698109),('24347','VA','Hiwassee','Pulaski',36.953115,-80.683816),('24348','VA','Independence','Grayson',36.633948,-81.157209),('24350','VA','Ivanhoe','Wythe',36.833174,-80.986694),('24351','VA','Lambsburg','Carroll',36.575619,-80.761162),('24352','VA','Laurel Fork','Carroll',36.715765,-80.53172),('24354','VA','Marion','Smyth',36.825055,-81.542283),('24360','VA','Max Meadows','Wythe',36.92812,-80.905923),('24361','VA','Meadowview','Washington',36.764671,-81.850105),('24363','VA','Mouth Of Wilson','Grayson',36.610027,-81.379687),('24366','VA','Rocky Gap','Bland',37.258713,-81.134197),('24368','VA','Rural Retreat','Wythe',36.885238,-81.285882),('24370','VA','Saltville','Smyth',36.893977,-81.731653),('24374','VA','Speedwell','Wythe',36.809855,-81.201063),('24375','VA','Sugar Grove','Smyth',36.773266,-81.392347),('24377','VA','Tannersville','Tazewell',36.994366,-81.588248),('24378','VA','Troutdal','Grayson',36.689512,-81.430703),('24380','VA','Willis','Floyd',36.86698,-80.506299),('24381','VA','Woodlawn','Carroll',36.729045,-80.846459),('24382','VA','Wytheville','Wythe',36.952069,-81.092163),('24401','VA','Staunton','Staunton City',38.145095,-79.07068),('24402','VA','Staunton','Staunton City',38.1628,-79.0668),('24411','VA','Augusta Springs','Augusta',38.104784,-79.314935),('24412','VA','Bacova','Bath',38.056308,-79.841059),('24413','VA','Blue Grass','Highland',38.529862,-79.579727),('24415','VA','Brownsburg','Rockbridge',37.927478,-79.32043),('24416','VA','Buena Vista','Buena Vista City',37.737396,-79.357331),('24421','VA','Churchville','Augusta',38.241493,-79.17835),('24422','VA','Clifton Forge','Alleghany',37.822122,-79.791572),('24426','VA','Covington','Alleghany',37.77869,-80.043032),('24430','VA','Craigsville','Augusta',38.08459,-79.363116),('24431','VA','Crimora','Augusta',38.168106,-78.841337),('24432','VA','Deerfield','Augusta',38.162439,-79.413077),('24433','VA','Doe Hill','Highland',38.423241,-79.469112),('24435','VA','Fairfield','Rockbridge',37.87433,-79.299307),('24437','VA','Fort Defiance','Augusta',38.228429,-78.940918),('24438','VA','Glen Wilton','Botetourt',37.6501,-79.8392),('24439','VA','Goshen','Rockbridge',37.986855,-79.49016),('24440','VA','Greenville','Augusta',37.995553,-79.151883),('24441','VA','Grottoes','Rockingham',38.251674,-78.828859),('24442','VA','Head Waters','Highland',38.318731,-79.420458),('24445','VA','Hot Springs','Bath',37.966117,-79.876989),('24448','VA','Iron Gate','Alleghany',37.798642,-79.791033),('24450','VA','Lexington','Rockbridge',37.791974,-79.475545),('24457','VA','Low Moor','Alleghany',37.785963,-79.88886),('24458','VA','Mc Dowell','Highland',38.315742,-79.527468),('24459','VA','Middlebrook','Augusta',38.0152,-79.278889),('24460','VA','Millboro','Bath',38.01546,-79.650911),('24463','VA','Mint Spring','Augusta',38.064112,-79.109798),('24464','VA','Montebello','Nelson',37.878663,-79.11403),('24465','VA','Monterey','Highland',38.374315,-79.635328),('24467','VA','Mount Sidney','Augusta',38.251671,-78.954474),('24468','VA','Mustoe','Highland',38.2881,-79.657),('24469','VA','New Hope','Augusta',38.1977,-78.9061),('24471','VA','Port Republic','Rockingham',38.304244,-78.804369),('24472','VA','Raphine','Rockbridge',37.934796,-79.240858),('24473','VA','Rockbridge Baths','Rockbridge',37.902996,-79.412267),('24474','VA','Selma','Alleghany',37.807043,-79.845358),('24476','VA','Steeles Tavern','Augusta',37.958491,-79.233199),('24477','VA','Stuarts Draft','Augusta',38.012818,-79.032242),('24479','VA','Swoope','Augusta',38.160667,-79.209934),('24482','VA','Verona','Augusta',38.200989,-78.994596),('24483','VA','Vesuvius','Rockbridge',37.816561,-79.244524),('24484','VA','Warm Springs','Bath',38.129083,-79.812948),('24485','VA','West Augusta','Augusta',38.267603,-79.333024),('24486','VA','Weyers Cave','Augusta',38.293319,-78.920598),('24487','VA','Williamsville','Bath',38.205685,-79.561541),('24501','VA','Lynchburg','Lynchburg City',37.380203,-79.161951),('24502','VA','Lynchburg','Lynchburg City',37.354185,-79.218986),('24503','VA','Lynchburg','Lynchburg City',37.440683,-79.210253),('24504','VA','Lynchburg','Lynchburg City',37.395435,-79.111397),('24505','VA','Lynchburg','Lynchburg City',37.4146,-79.1434),('24506','VA','Lynchburg','Lynchburg City',37.3802,-79.1603),('24512','VA','Lynchburg','Campbell',37.4502,-79.2501),('24513','VA','Lynchburg','Campbell',37.3802,-79.1603),('24514','VA','Lynchburg','Lynchburg City',37.3802,-79.1603),('24515','VA','Lynchburg','Lynchburg City',37.3802,-79.1603),('24517','VA','Altavista','Campbell',37.130199,-79.26728),('24520','VA','Alton','Halifax',36.585006,-79.047537),('24521','VA','Amherst','Amherst',37.614215,-79.058796),('24522','VA','Appomattox','Appomattox',37.36563,-78.798218),('24523','VA','Bedford','Bedford',37.327471,-79.528253),('24526','VA','Big Island','Bedford',37.539503,-79.386144),('24527','VA','Blairs','Pittsylvania',36.724787,-79.357786),('24528','VA','Brookneal','Campbell',37.074348,-78.898818),('24529','VA','Buffalo Junction','Mecklenburg',36.635989,-78.640846),('24530','VA','Callands','Pittsylvania',36.814668,-79.606576),('24531','VA','Chatham','Pittsylvania',36.833432,-79.445188),('24533','VA','Clifford','Amherst',37.582488,-78.936183),('24534','VA','Clover','Halifax',36.852453,-78.751816),('24535','VA','Cluster Springs','Halifax',36.6208,-78.9219),('24536','VA','Coleman Falls','Bedford',37.493242,-79.313702),('24538','VA','Concord','Campbell',37.352041,-78.97472),('24539','VA','Crystal Hill','Halifax',36.844685,-78.921297),('24540','VA','Danville','Danville City',36.622662,-79.400252),('24541','VA','Danville','Danville City',36.583863,-79.460532),('24543','VA','Danville','Danville City',36.5842,-79.3969),('24544','VA','Danville','Danville City',36.5842,-79.3969),('24549','VA','Dry Fork','Pittsylvania',36.705312,-79.501836),('24550','VA','Evington','Campbell',37.247271,-79.25982),('24551','VA','Forest','Bedford',37.348609,-79.30191),('24553','VA','Gladstone','Nelson',37.547234,-78.822365),('24554','VA','Gladys','Campbell',37.133651,-79.061799),('24555','VA','Glasgow','Rockbridge',37.657378,-79.459498),('24556','VA','Goode','Bedford',37.36606,-79.39522),('24557','VA','Gretna','Pittsylvania',36.973255,-79.315976),('24558','VA','Halifax','Halifax',36.772159,-78.944188),('24562','VA','Howardsville','Buckingham',37.703166,-78.641499),('24563','VA','Hurt','Pittsylvania',37.076244,-79.287816),('24565','VA','Java','Pittsylvania',36.859006,-79.181679),('24566','VA','Keeling','Pittsylvania',36.721766,-79.25583),('24569','VA','Long Island','Pittsylvania',37.048988,-79.117684),('24570','VA','Lowry','Bedford',37.3532,-79.4347),('24571','VA','Lynch Station','Campbell',37.132961,-79.372748),('24572','VA','Madison Heights','Amherst',37.450362,-79.103767),('24574','VA','Monroe','Amherst',37.56954,-79.229347),('24576','VA','Naruna','Campbell',37.1058,-79.0027),('24577','VA','Nathalie','Halifax',36.949134,-78.982808),('24578','VA','Natural Bridge','Rockbridge',37.654222,-79.54419),('24579','VA','Natural Bridge Station','Rockbridge',37.593038,-79.509694),('24580','VA','Nelson','Mecklenburg',36.574294,-78.683428),('24581','VA','Norwood','Nelson',37.644171,-78.794472),('24586','VA','Ringgold','Pittsylvania',36.596307,-79.288153),('24588','VA','Rustburg','Campbell',37.268433,-79.120756),('24589','VA','Scottsburg','Halifax',36.760808,-78.758048),('24590','VA','Scottsville','Albemarle',37.803122,-78.472304),('24592','VA','South Boston','Halifax',36.695143,-78.92568),('24593','VA','Spout Spring','Appomattox',37.334231,-78.914273),('24594','VA','Sutherlin','Pittsylvania',36.632748,-79.189965),('24595','VA','Sweet Briar','Amherst',37.557015,-79.075945),('24597','VA','Vernon Hill','Halifax',36.781459,-79.100003),('24598','VA','Virgilina','Halifax',36.607324,-78.764783),('24599','VA','Wingina','Buckingham',37.63641,-78.720188),('24601','VA','Amonate','Tazewell',37.183921,-81.648401),('24602','VA','Bandy','Tazewell',37.179001,-81.659202),('24603','VA','Big Rock','Buchanan',37.354782,-82.191416),('24604','VA','Bishop','Tazewell',37.209465,-81.545525),('24605','VA','Bluefield','Tazewell',37.241127,-81.327274),('24606','VA','Boissevain','Tazewell',37.289328,-81.391084),('24607','VA','Breaks','Buchanan',37.30004,-82.271786),('24608','VA','Burkes Garden','Tazewell',37.098,-81.3411),('24609','VA','Cedar Bluff','Tazewell',37.045768,-81.785568),('24612','VA','Doran','Tazewell',37.092694,-81.836627),('24613','VA','Falls Mills','Tazewell',37.270541,-81.322849),('24614','VA','Grundy','Buchanan',37.299576,-82.081353),('24619','VA','Horsepen','Tazewell',37.2331,-81.4995),('24620','VA','Hurley','Buchanan',37.421143,-82.020928),('24622','VA','Jewell Ridge','Buchanan',37.213334,-81.797869),('24624','VA','Keen Mountain','Buchanan',37.204272,-81.979361),('24627','VA','Mavisdale','Buchanan',37.187,-82.2167),('24628','VA','Maxie','Buchanan',37.294294,-82.20721),('24630','VA','North Tazewell','Tazewell',37.158133,-81.487816),('24631','VA','Oakwood','Buchanan',37.208137,-81.99957),('24634','VA','Pilgrims Knob','Buchanan',37.264053,-81.907785),('24635','VA','Pocahontas','Tazewell',37.309616,-81.345203),('24637','VA','Pounding Mill','Tazewell',37.069444,-81.708486),('24639','VA','Raven','Tazewell',37.149643,-81.889579),('24640','VA','Red Ash','Tazewell',37.1133,-81.8711),('24641','VA','Richlands','Tazewell',37.099533,-81.803256),('24646','VA','Rowe','Buchanan',37.146987,-82.030809),('24647','VA','Shortt Gap','Buchanan',37.1572,-81.873),('24649','VA','Swords Creek','Russell',37.073199,-81.902192),('24651','VA','Tazewell','Tazewell',37.103796,-81.510484),('24656','VA','Vansant','Buchanan',37.184481,-82.102742),('24657','VA','Whitewood','Buchanan',37.216181,-81.858678),('24658','VA','Wolford','Buchanan',37.3644,-81.9913),('24701','WV','Bluefield','Mercer',37.285483,-81.21042),('24712','WV','Athens','Mercer',37.434544,-81.006759),('24714','WV','Beeson','Mercer',37.468594,-81.178425),('24715','WV','Bramwell','Mercer',37.32757,-81.32253),('24716','WV','Bud','Wyoming',37.482901,-81.390838),('24719','WV','Covel','Wyoming',37.487993,-81.322254),('24724','WV','Freeman','Mercer',37.327786,-81.299964),('24726','WV','Herndon','Wyoming',37.520383,-81.366019),('24729','WV','Hiawatha','Mercer',37.441621,-81.243582),('24731','WV','Kegley','Mercer',37.395107,-81.145452),('24732','WV','Kellysville','Mercer',37.3447,-80.928),('24733','WV','Lashmeet','Mercer',37.434379,-81.205747),('24736','WV','Matoaka','Mercer',37.425546,-81.260434),('24737','WV','Montcalm','Mercer',37.354182,-81.250722),('24738','WV','Nemours','Mercer',37.302041,-81.3097),('24739','WV','Oakvale','Mercer',37.336554,-80.955234),('24740','WV','Princeton','Mercer',37.367796,-81.068168),('24747','WV','Rock','Mercer',37.391193,-81.219784),('24751','WV','Wolfe','Mercer',37.3072,-81.3288),('24801','WV','Welch','Mcdowell',37.440395,-81.584201),('24808','WV','Anawalt','Mcdowell',37.338439,-81.429907),('24811','WV','Avondale','Mcdowell',37.402504,-81.784717),('24813','WV','Bartley','Mcdowell',37.345642,-81.730691),('24815','WV','Berwind','Mcdowell',37.233724,-81.665605),('24816','WV','Big Sandy','Mcdowell',37.460541,-81.701849),('24817','WV','Bradshaw','Mcdowell',37.352474,-81.800332),('24818','WV','Brenton','Wyoming',37.595716,-81.637216),('24822','WV','Clear Fork','Wyoming',37.621765,-81.686656),('24823','WV','Coal Mountain','Wyoming',37.663762,-81.734398),('24826','WV','Cucumber','Mcdowell',37.286538,-81.637963),('24827','WV','Cyclone','Wyoming',37.738333,-81.686727),('24828','WV','Davy','Mcdowell',37.48148,-81.646859),('24829','WV','Eckman','Mcdowell',37.40273,-81.462902),('24830','WV','Elbert','Mcdowell',37.323195,-81.538179),('24831','WV','Elkhorn','Mcdowell',37.389922,-81.41964),('24834','WV','Fanrock','Wyoming',37.554256,-81.62312),('24836','WV','Gary','Mcdowell',37.351504,-81.545232),('24839','WV','Hanover','Wyoming',37.569138,-81.778561),('24842','WV','Hemphill','Mcdowell',37.444465,-81.596843),('24843','WV','Hensley','Mcdowell',37.472981,-81.706897),('24844','WV','Iaeger','Mcdowell',37.455399,-81.794224),('24845','WV','Ikes Fork','Wyoming',37.526965,-81.794621),('24846','WV','Isaban','Mingo',37.529558,-81.91285),('24847','WV','Itmann','Wyoming',37.573921,-81.417519),('24848','WV','Jenkinjones','Mcdowell',37.284088,-81.447462),('24849','WV','Jesse','Wyoming',37.669237,-81.566852),('24850','WV','Jolo','Mcdowell',37.30447,-81.830318),('24851','WV','Justice','Mingo',37.592455,-81.83118),('24853','WV','Kimball','Mcdowell',37.420505,-81.515959),('24854','WV','Kopperston','Wyoming',37.7529,-81.565009),('24855','WV','Kyle','Mcdowell',37.409655,-81.425592),('24857','WV','Lynco','Wyoming',37.673981,-81.661783),('24859','WV','Marianna','Wyoming',37.613,-81.573),('24860','WV','Matheny','Wyoming',37.66587,-81.600526),('24861','WV','Maybeury','Mcdowell',37.363906,-81.365393),('24862','WV','Mohawk','Mcdowell',37.478984,-81.954968),('24866','WV','Newhall','Mcdowell',37.255086,-81.596076),('24867','WV','New Richmond','Wyoming',37.595704,-81.457571),('24868','WV','Northfork','Mcdowell',37.421718,-81.416772),('24869','WV','North Spring','Wyoming',37.582384,-81.82514),('24870','WV','Oceana','Wyoming',37.705538,-81.602344),('24871','WV','Pageton','Mcdowell',37.345074,-81.474696),('24872','WV','Panther','Mcdowell',37.464177,-81.891185),('24873','WV','Paynesville','Mcdowell',37.357009,-81.89682),('24874','WV','Pineville','Wyoming',37.574318,-81.531846),('24878','WV','Premier','Mcdowell',37.435435,-81.620904),('24879','WV','Raysal','Mcdowell',37.335746,-81.770838),('24880','WV','Rock View','Wyoming',37.63438,-81.549205),('24881','WV','Roderfield','Mcdowell',37.445886,-81.701736),('24882','WV','Simon','Wyoming',37.619327,-81.745123),('24884','WV','Squire','Mcdowell',37.249651,-81.551883),('24887','WV','Switchback','Mcdowell',37.371236,-81.386515),('24888','WV','Thorpe','Mcdowell',37.372511,-81.498544),('24892','WV','War','Mcdowell',37.310799,-81.69429),('24894','WV','Warriormine','Mcdowell',37.288368,-81.69378),('24895','WV','Wilcoe','Mcdowell',37.381834,-81.563428),('24898','WV','Wyoming','Wyoming',37.590241,-81.603897),('24901','WV','Lewisburg','Greenbrier',37.80965,-80.44565),('24902','WV','Fairlea','Greenbrier',37.7805,-80.4572),('24910','WV','Alderson','Greenbrier',37.730687,-80.654151),('24915','WV','Arbovale','Pocahontas',38.455343,-79.799876),('24916','WV','Asbury','Greenbrier',37.842318,-80.569366),('24918','WV','Ballard','Monroe',37.525145,-80.75267),('24920','WV','Bartow','Pocahontas',38.560815,-79.731483),('24924','WV','Buckeye','Pocahontas',38.19429,-80.135885),('24925','WV','Caldwell','Greenbrier',37.766241,-80.394832),('24927','WV','Cass','Pocahontas',38.376704,-79.94442),('24931','WV','Crawley','Greenbrier',37.92768,-80.593034),('24934','WV','Dunmore','Pocahontas',38.340804,-79.896163),('24935','WV','Forest Hill','Summers',37.562069,-80.794114),('24938','WV','Frankford','Greenbrier',37.915143,-80.365078),('24941','WV','Gap Mills','Monroe',37.602101,-80.346656),('24943','WV','Grassy Meadows','Greenbrier',37.838288,-80.75393),('24944','WV','Green Bank','Pocahontas',38.410344,-79.811667),('24945','WV','Greenville','Monroe',37.542082,-80.687336),('24946','WV','Hillsboro','Pocahontas',38.13879,-80.237117),('24951','WV','Lindside','Monroe',37.477245,-80.647387),('24954','WV','Marlinton','Pocahontas',38.224907,-80.056049),('24957','WV','Maxwelton','Greenbrier',37.873414,-80.411329),('24961','WV','White Sulphur Springs','Greenbrier',37.974239,-80.115791),('24962','WV','Pence Springs','Summers',37.677035,-80.726017),('24963','WV','Peterstown','Monroe',37.427648,-80.78169),('24966','WV','Renick','Greenbrier',38.032796,-80.372895),('24970','WV','Ronceverte','Greenbrier',37.741206,-80.481378),('24974','WV','Secondcreek','Monroe',37.66466,-80.442183),('24976','WV','Sinks Grove','Monroe',37.672384,-80.526776),('24977','WV','Smoot','Greenbrier',37.906212,-80.663855),('24981','WV','Talcott','Summers',37.644573,-80.737845),('24983','WV','Union','Monroe',37.57229,-80.531446),('24984','WV','Waiteville','Monroe',37.505382,-80.395257),('24985','WV','Wayside','Monroe',37.597231,-80.746381),('24986','WV','White Sulphur Springs','Greenbrier',37.852569,-80.245761),('24991','WV','Williamsburg','Greenbrier',37.997624,-80.496374),('24993','WV','Wolfcreek','Monroe',37.6194,-80.6085),('25002','WV','Alloy','Fayette',38.130193,-81.258042),('25003','WV','Alum Creek','Lincoln',38.255694,-81.790634),('25005','WV','Amma','Roane',38.5745,-81.261913),('25007','WV','Arnett','Raleigh',37.83064,-81.431445),('25008','WV','Artie','Raleigh',37.933997,-81.360726),('25009','WV','Ashford','Boone',38.190697,-81.723004),('25011','WV','Bancroft','Putnam',38.508943,-81.840383),('25015','WV','Belle','Kanawha',38.222621,-81.52057),('25019','WV','Bickmore','Clay',38.380827,-81.08981),('25021','WV','Bim','Boone',37.922417,-81.687442),('25022','WV','Blair','Logan',37.860342,-81.819064),('25024','WV','Bloomingrose','Boone',38.143414,-81.634533),('25025','WV','Blount','Kanawha',38.308335,-81.39705),('25026','WV','Blue Creek','Kanawha',38.4505,-81.4575),('25028','WV','Bob White','Boone',37.951658,-81.715066),('25030','WV','Bomont','Clay',38.453291,-81.225965),('25031','WV','Boomer','Fayette',38.145314,-81.282543),('25033','WV','Buffalo','Putnam',38.609138,-81.954522),('25035','WV','Cabin Creek','Kanawha',38.189664,-81.49957),('25036','WV','Cannelton','Fayette',38.204719,-81.271647),('25039','WV','Cedar Grove','Kanawha',38.237617,-81.406742),('25040','WV','Charlton Heights','Fayette',38.125151,-81.243389),('25043','WV','Clay','Clay',38.45633,-81.017817),('25044','WV','Clear Creek','Raleigh',37.904232,-81.350041),('25045','WV','Clendenin','Kanawha',38.459886,-81.328587),('25047','WV','Clothier','Logan',37.945768,-81.795603),('25048','WV','Colcord','Raleigh',37.942975,-81.436741),('25049','WV','Comfort','Boone',38.126193,-81.587768),('25051','WV','Costa','Boone',38.164477,-81.709954),('25053','WV','Danville','Boone',38.046895,-81.845494),('25054','WV','Dawes','Kanawha',38.124098,-81.455322),('25057','WV','Deep Water','Fayette',38.126649,-81.258266),('25059','WV','Dixie','Fayette',38.248263,-81.203422),('25060','WV','Dorothy','Raleigh',37.949126,-81.437623),('25061','WV','Drybranch','Kanawha',38.174452,-81.456679),('25062','WV','Dry Creek','Raleigh',37.867103,-81.456172),('25063','WV','Duck','Braxton',38.575353,-80.915176),('25064','WV','Dunbar','Kanawha',38.370262,-81.747046),('25067','WV','East Bank','Kanawha',38.209505,-81.429139),('25070','WV','Eleanor','Putnam',38.538354,-81.92849),('25071','WV','Elkview','Kanawha',38.443958,-81.473941),('25075','WV','Eskdale','Kanawha',38.056658,-81.436551),('25076','WV','Ethel','Logan',37.863417,-81.921052),('25079','WV','Falling Rock','Kanawha',38.4756,-81.389),('25081','WV','Foster','Boone',38.096285,-81.782087),('25082','WV','Fraziers Bottom','Putnam',38.618041,-82.012999),('25083','WV','Gallagher','Kanawha',38.08237,-81.369616),('25085','WV','Gauley Bridge','Fayette',38.173298,-81.193687),('25086','WV','Glasgow','Kanawha',38.211204,-81.419222),('25088','WV','Glen','Clay',38.390103,-81.216286),('25090','WV','Glen Ferris','Fayette',38.150428,-81.214459),('25093','WV','Gordon','Boone',37.985244,-81.669761),('25102','WV','Handley','Kanawha',38.186855,-81.366013),('25103','WV','Hansford','Kanawha',38.2003,-81.394482),('25106','WV','Henderson','Mason',38.813355,-82.103779),('25107','WV','Hernshaw','Kanawha',38.23013,-81.64026),('25108','WV','Hewett','Boone',37.954606,-81.865622),('25109','WV','Hometown','Putnam',38.525742,-81.85639),('25110','WV','Hugheston','Kanawha',38.212308,-81.343437),('25111','WV','Indore','Clay',38.367485,-81.137266),('25112','WV','Institute','Kanawha',38.381718,-81.766067),('25113','WV','Ivydale','Clay',38.557158,-81.037293),('25114','WV','Jeffrey','Boone',37.97555,-81.816876),('25115','WV','Kanawha Falls','Fayette',38.133605,-81.196369),('25118','WV','Kimberly','Fayette',38.130159,-81.303101),('25119','WV','Kincaid','Fayette',38.044217,-81.264838),('25121','WV','Lake','Logan',37.925319,-81.889013),('25123','WV','Leon','Mason',38.732508,-81.914846),('25124','WV','Liberty','Putnam',38.616682,-81.757768),('25125','WV','Lizemores','Clay',38.305574,-81.181501),('25126','WV','London','Kanawha',38.202786,-81.372614),('25130','WV','Madison','Boone',38.044741,-81.800369),('25132','WV','Mammoth','Kanawha',38.292803,-81.357224),('25133','WV','Maysel','Clay',38.486773,-81.121812),('25134','WV','Miami','Kanawha',38.159839,-81.459064),('25136','WV','Montgomery','Fayette',38.175122,-81.330352),('25139','WV','Mount Carbon','Fayette',38.141068,-81.287587),('25140','WV','Naoma','Raleigh',37.873947,-81.505482),('25141','WV','Nebo','Clay',38.634481,-81.041226),('25142','WV','Nellis','Boone',38.153517,-81.72976),('25143','WV','Nitro','Kanawha',38.418666,-81.833156),('25148','WV','Orgas','Boone',38.050946,-81.576183),('25149','WV','Ottawa','Boone',37.94641,-81.808094),('25152','WV','Page','Fayette',38.052356,-81.266634),('25154','WV','Peytona','Boone',38.120302,-81.69408),('25156','WV','Pinch','Kanawha',38.185016,-81.341478),('25159','WV','Poca','Putnam',38.492421,-81.793391),('25160','WV','Pond Gap','Kanawha',38.296297,-81.293367),('25161','WV','Powellton','Fayette',38.069914,-81.336244),('25162','WV','Pratt','Kanawha',38.209536,-81.385212),('25164','WV','Procious','Clay',38.500283,-81.189328),('25165','WV','Racine','Boone',38.142014,-81.653409),('25168','WV','Red House','Putnam',38.560276,-81.895728),('25169','WV','Ridgeview','Boone',38.131843,-81.775641),('25173','WV','Robson','Fayette',38.091231,-81.22983),('25174','WV','Rock Creek','Raleigh',37.851493,-81.445854),('25177','WV','Saint Albans','Kanawha',38.378328,-81.827853),('25180','WV','Saxon','Raleigh',37.800183,-81.41834),('25181','WV','Seth','Boone',38.070596,-81.625306),('25183','WV','Sharples','Logan',37.909119,-81.836661),('25185','WV','Mount Olive','Fayette',38.236356,-81.240317),('25186','WV','Smithers','Fayette',38.177058,-81.302894),('25187','WV','Southside','Mason',38.747628,-82.02315),('25193','WV','Sylvester','Boone',38.025489,-81.525735),('25201','WV','Tad','Kanawha',38.337734,-81.487379),('25202','WV','Tornado','Kanawha',38.323666,-81.844605),('25203','WV','Turtle Creek','Boone',38.010977,-81.885409),('25204','WV','Twilight','Boone',37.925321,-81.61456),('25205','WV','Uneeda','Boone',38.017993,-81.773304),('25206','WV','Van','Boone',37.974161,-81.712872),('25208','WV','Wharton','Boone',37.868091,-81.637114),('25209','WV','Whitesville','Boone',37.969056,-81.532951),('25211','WV','Widen','Clay',38.458608,-80.87939),('25213','WV','Winfield','Putnam',38.513205,-81.90184),('25214','WV','Winifrede','Kanawha',38.191275,-81.555225),('25231','WV','Advent','Jackson',38.597265,-81.579347),('25234','WV','Arnoldsburg','Calhoun',38.810325,-81.151102),('25235','WV','Chloe','Calhoun',38.663649,-81.083983),('25239','WV','Cottageville','Jackson',38.859924,-81.837075),('25241','WV','Evans','Jackson',38.794888,-81.809376),('25243','WV','Gandeeville','Roane',38.68969,-81.462954),('25244','WV','Gay','Jackson',38.767566,-81.550872),('25245','WV','Given','Jackson',38.69742,-81.755385),('25247','WV','Hartford','Mason',39.005244,-81.992085),('25248','WV','Kenna','Jackson',38.629413,-81.618584),('25251','WV','Left Hand','Roane',38.603803,-81.218288),('25252','WV','Le Roy','Jackson',38.871186,-81.547918),('25253','WV','Letart','Mason',38.921064,-81.96149),('25259','WV','Looneyville','Roane',38.671641,-81.250221),('25260','WV','Mason','Mason',39.016465,-82.029694),('25261','WV','Millstone','Calhoun',38.83338,-81.090148),('25262','WV','Millwood','Jackson',38.905172,-81.833696),('25264','WV','Mount Alto','Jackson',38.855443,-81.896304),('25265','WV','New Haven','Mason',38.986622,-81.957737),('25266','WV','Newton','Roane',38.596306,-81.161687),('25267','WV','Normantown','Gilmer',38.848341,-80.951064),('25268','WV','Orma','Calhoun',38.736558,-81.099263),('25270','WV','Reedy','Roane',38.878819,-81.434007),('25271','WV','Ripley','Jackson',38.799698,-81.695749),('25275','WV','Sandyville','Jackson',38.919938,-81.615837),('25276','WV','Spencer','Roane',38.79631,-81.338839),('25285','WV','Wallback','Clay',38.543473,-81.116558),('25286','WV','Walton','Roane',38.616475,-81.410553),('25287','WV','West Columbia','Mason',38.95558,-82.065998),('25301','WV','Charleston','Kanawha',38.350719,-81.630359),('25302','WV','Charleston','Kanawha',38.372941,-81.62563),('25303','WV','Charleston','Kanawha',38.362334,-81.689233),('25304','WV','Charleston','Kanawha',38.315144,-81.586985),('25305','WV','Charleston','Kanawha',38.3367,-81.6085),('25306','WV','Charleston','Kanawha',38.311148,-81.531213),('25309','WV','Charleston','Kanawha',38.329817,-81.737317),('25311','WV','Charleston','Kanawha',38.357356,-81.584072),('25312','WV','Charleston','Kanawha',38.425295,-81.667661),('25313','WV','Charleston','Kanawha',38.423986,-81.763566),('25314','WV','Charleston','Kanawha',38.332174,-81.658403),('25315','WV','Charleston','Kanawha',38.235888,-81.555994),('25317','WV','Charleston','Kanawha',38.3497,-81.6327),('25320','WV','Charleston','Kanawha',38.531403,-81.628676),('25321','WV','Charleston','Kanawha',38.3495,-81.6322),('25322','WV','Charleston','Kanawha',38.3495,-81.6322),('25323','WV','Charleston','Kanawha',38.3495,-81.6322),('25324','WV','Charleston','Kanawha',38.3495,-81.6322),('25325','WV','Charleston','Kanawha',38.3495,-81.6322),('25326','WV','Charleston','Kanawha',38.3495,-81.6322),('25327','WV','Charleston','Kanawha',38.3495,-81.6322),('25328','WV','Charleston','Kanawha',38.3495,-81.6322),('25329','WV','Charleston','Kanawha',38.3495,-81.6322),('25330','WV','Charleston','Kanawha',38.3495,-81.6322),('25331','WV','Charleston','Kanawha',38.3495,-81.6322),('25332','WV','Charleston','Kanawha',38.3495,-81.6322),('25333','WV','Charleston','Kanawha',38.3495,-81.6322),('25334','WV','Charleston','Kanawha',38.3495,-81.6322),('25335','WV','Charleston','Kanawha',38.3495,-81.6322),('25336','WV','Charleston','Kanawha',38.3495,-81.6322),('25337','WV','Charleston','Kanawha',38.3495,-81.6322),('25338','WV','Charleston','Kanawha',38.3495,-81.6322),('25339','WV','Charleston','Kanawha',38.3495,-81.6322),('25350','WV','Charleston','Kanawha',38.3497,-81.6327),('25356','WV','Charleston','Kanawha',38.4461,-81.7553),('25357','WV','Charleston','Kanawha',38.3759,-81.6733),('25358','WV','Charleston','Kanawha',38.3528,-81.6314),('25360','WV','Charleston','Kanawha',38.4538,-81.6666),('25361','WV','Charleston','Kanawha',38.3422,-81.6213),('25362','WV','Charleston','Kanawha',38.3601,-81.6462),('25364','WV','Charleston','Kanawha',38.3219,-81.5827),('25365','WV','Charleston','Kanawha',38.2335,-81.5734),('25375','WV','Charleston','Kanawha',38.3497,-81.6327),('25387','WV','Charleston','Kanawha',38.3102,-81.5674),('25389','WV','Charleston','Kanawha',38.3529,-81.6381),('25392','WV','Charleston','Kanawha',38.3495,-81.6322),('25396','WV','Charleston','Kanawha',38.3373,-81.6276),('25401','WV','Martinsburg','Berkeley',39.455233,-77.971135),('25402','WV','Martinsburg','Berkeley',39.4643,-77.9513),('25403','WV','Martinsburg','Berkeley',39.489123,-77.9933),('25404','WV','Martinsburg','Berkeley',39.482832,-77.92739),('25405','WV','Martinsburg','Berkeley',39.415474,-77.961625),('25410','WV','Bakerton','Jefferson',39.3627,-77.7633),('25411','WV','Berkeley Springs','Morgan',39.567834,-78.227922),('25413','WV','Bunker Hill','Berkeley',39.317378,-78.046682),('25414','WV','Charles Town','Jefferson',39.274656,-77.861845),('25419','WV','Falling Waters','Berkeley',39.587313,-77.890612),('25420','WV','Gerrardstown','Berkeley',39.382139,-78.112471),('25421','WV','Glengary','Berkeley',39.372769,-78.167608),('25422','WV','Great Cacapon','Morgan',39.564968,-78.358214),('25423','WV','Halltown','Jefferson',39.3138,-77.798),('25425','WV','Harpers Ferry','Jefferson',39.276323,-77.782404),('25427','WV','Hedgesville','Berkeley',39.536135,-78.062507),('25428','WV','Inwood','Berkeley',39.36807,-78.028287),('25429','WV','Martinsburg','Jefferson',39.3203,-77.9491),('25430','WV','Kearneysville','Jefferson',39.353521,-77.919703),('25431','WV','Levels','Hampshire',39.487274,-78.571804),('25432','WV','Millville','Jefferson',39.305665,-77.783915),('25434','WV','Paw Paw','Hampshire',39.471671,-78.451262),('25437','WV','Points','Hampshire',39.427818,-78.578929),('25438','WV','Ranson','Jefferson',39.308032,-77.857601),('25440','WV','Ridgeway','Berkeley',39.2972,-78.0719),('25441','WV','Rippon','Jefferson',39.210527,-77.914031),('25442','WV','Shenandoah Junction','Jefferson',39.361425,-77.833214),('25443','WV','Shepherdstown','Jefferson',39.439278,-77.812277),('25444','WV','Slanesville','Hampshire',39.409527,-78.520212),('25446','WV','Summit Point','Jefferson',39.239516,-77.963662),('25501','WV','Alkol','Lincoln',38.15746,-81.943776),('25502','WV','Apple Grove','Mason',38.658438,-82.139693),('25503','WV','Ashton','Mason',38.614681,-82.133046),('25504','WV','Barboursville','Cabell',38.392092,-82.285476),('25505','WV','Big Creek','Logan',38.005272,-82.042182),('25506','WV','Branchland','Lincoln',38.210992,-82.187474),('25507','WV','Ceredo','Wayne',38.396031,-82.559102),('25508','WV','Chapmanville','Logan',37.967051,-82.017827),('25510','WV','Culloden','Cabell',38.399784,-82.061681),('25511','WV','Dunlow','Wayne',38.044067,-82.354622),('25512','WV','East Lynn','Wayne',38.184721,-82.327258),('25514','WV','Fort Gay','Wayne',38.105624,-82.558579),('25515','WV','Gallipolis Ferry','Mason',38.759899,-82.173002),('25517','WV','Genoa','Wayne',38.111454,-82.466124),('25520','WV','Glenwood','Mason',38.57513,-82.170795),('25521','WV','Griffithsville','Lincoln',38.22856,-82.000526),('25523','WV','Hamlin','Lincoln',38.280276,-82.092545),('25524','WV','Harts','Lincoln',38.021877,-82.117498),('25526','WV','Hurricane','Putnam',38.429824,-81.99396),('25529','WV','Julian','Boone',38.152463,-81.845141),('25530','WV','Kenova','Wayne',38.385435,-82.573642),('25534','WV','Kiahsville','Wayne',38.088788,-82.276506),('25535','WV','Lavalette','Wayne',38.308132,-82.430092),('25537','WV','Lesage','Cabell',38.533383,-82.281971),('25540','WV','Midkiff','Lincoln',38.158665,-82.14272),('25541','WV','Milton','Cabell',38.440027,-82.133176),('25544','WV','Myra','Lincoln',38.219991,-82.114621),('25545','WV','Ona','Cabell',38.434329,-82.223708),('25547','WV','Pecks Mill','Logan',37.930216,-81.968777),('25550','WV','Point Pleasant','Mason',38.869781,-82.107894),('25555','WV','Prichard','Wayne',38.238353,-82.564181),('25557','WV','Ranger','Lincoln',38.09481,-82.153454),('25559','WV','Salt Rock','Cabell',38.325152,-82.229426),('25560','WV','Scott Depot','Putnam',38.445477,-81.897836),('25562','WV','Shoals','Wayne',38.3269,-82.4752),('25564','WV','Sod','Lincoln',38.269332,-81.888398),('25565','WV','Spurlockville','Lincoln',38.102286,-81.964578),('25567','WV','Sumerco','Lincoln',38.220411,-81.878069),('25569','WV','Teays','Putnam',38.4416,-81.953),('25570','WV','Wayne','Wayne',38.223452,-82.433492),('25571','WV','West Hamlin','Lincoln',38.296697,-82.165208),('25572','WV','Woodville','Lincoln',38.1544,-81.8953),('25573','WV','Yawkey','Lincoln',38.218971,-81.936282),('25601','WV','Logan','Logan',37.856292,-81.993804),('25606','WV','Accoville','Logan',37.767119,-81.838256),('25607','WV','Amherstdale','Logan',37.786125,-81.797895),('25608','WV','Baisden','Mingo',37.559944,-81.895776),('25611','WV','Bruno','Logan',37.690228,-81.854516),('25612','WV','Chauncey','Logan',37.76662,-81.987551),('25614','WV','Cora','Logan',37.8341,-82.0266),('25617','WV','Davin','Logan',37.729354,-81.792962),('25621','WV','Gilbert','Mingo',37.618416,-81.889682),('25624','WV','Henlawson','Logan',37.904799,-81.982798),('25625','WV','Holden','Logan',37.819353,-82.081279),('25628','WV','Kistler','Logan',37.757632,-81.855637),('25630','WV','Lorado','Logan',37.800337,-81.709501),('25632','WV','Lyburn','Logan',37.768748,-81.923856),('25634','WV','Mallory','Logan',37.73025,-81.862653),('25635','WV','Man','Logan',37.732333,-81.875471),('25637','WV','Mount Gay','Logan',37.850317,-82.023683),('25638','WV','Omar','Logan',37.734929,-82.014377),('25639','WV','Peach Creek','Logan',37.884482,-81.973183),('25644','WV','Sarah Ann','Logan',37.711518,-82.005268),('25646','WV','Stollings','Logan',37.821745,-81.912652),('25647','WV','Switzer','Logan',37.791327,-81.98981),('25649','WV','Verdunville','Logan',37.855866,-82.068023),('25650','WV','Verner','Mingo',37.669945,-81.846361),('25651','WV','Wharncliffe','Mingo',37.572908,-81.973103),('25652','WV','Whitman','Logan',37.799721,-82.046768),('25653','WV','Wilkinson','Logan',37.829733,-81.999277),('25654','WV','Yolyn','Logan',37.819536,-81.881988),('25661','WV','Williamson','Mingo',37.707656,-82.277184),('25665','WV','Borderland','Mingo',37.714369,-82.308735),('25666','WV','Breeden','Mingo',37.922297,-82.252801),('25667','WV','Chattaroy','Mingo',37.703827,-82.278244),('25669','WV','Crum','Wayne',37.923253,-82.451931),('25670','WV','Delbarton','Mingo',37.70768,-82.13741),('25671','WV','Dingess','Mingo',37.880198,-82.188311),('25672','WV','Edgarton','Mingo',37.571664,-82.128036),('25674','WV','Kermit','Mingo',37.856626,-82.376007),('25676','WV','Lenore','Mingo',37.824162,-82.233917),('25678','WV','Matewan','Mingo',37.595426,-82.135322),('25685','WV','Naugatuck','Mingo',37.786897,-82.343734),('25686','WV','Newtown','Mingo',37.6277,-82.0858),('25688','WV','North Matewan','Mingo',37.631465,-82.15021),('25690','WV','Ragland','Mingo',37.696607,-82.125592),('25691','WV','Rawl','Mingo',37.643043,-82.217019),('25692','WV','Red Jacket','Mingo',37.643176,-82.118106),('25696','WV','Varney','Mingo',37.669672,-82.120062),('25699','WV','Wilsondale','Wayne',37.971699,-82.339064),('25701','WV','Huntington','Cabell',38.402884,-82.439301),('25702','WV','Huntington','Cabell',38.429271,-82.374021),('25703','WV','Huntington','Cabell',38.421828,-82.419506),('25704','WV','Huntington','Wayne',38.384162,-82.506143),('25705','WV','Huntington','Cabell',38.408576,-82.368027),('25706','WV','Huntington','Cabell',38.4231,-82.4383),('25707','WV','Huntington','Cabell',38.4191,-82.4452),('25708','WV','Huntington','Cabell',38.4231,-82.4383),('25709','WV','Huntington','Wayne',38.4141,-82.458),('25710','WV','Huntington','Cabell',38.4191,-82.4452),('25711','WV','Huntington','Cabell',38.4191,-82.4452),('25712','WV','Huntington','Cabell',38.4231,-82.4383),('25713','WV','Huntington','Cabell',38.4231,-82.4383),('25714','WV','Huntington','Cabell',38.4231,-82.4383),('25715','WV','Huntington','Cabell',38.4191,-82.4452),('25716','WV','Huntington','Cabell',38.4231,-82.4383),('25717','WV','Huntington','Cabell',38.4231,-82.4383),('25718','WV','Huntington','Cabell',38.4231,-82.4383),('25719','WV','Huntington','Cabell',38.4231,-82.4383),('25720','WV','Huntington','Cabell',38.4231,-82.4383),('25721','WV','Huntington','Cabell',38.4231,-82.4383),('25722','WV','Huntington','Cabell',38.4231,-82.4383),('25723','WV','Huntington','Cabell',38.4191,-82.4452),('25724','WV','Huntington','Cabell',38.4231,-82.4383),('25725','WV','Huntington','Cabell',38.4231,-82.4383),('25726','WV','Huntington','Cabell',38.4231,-82.4383),('25727','WV','Huntington','Cabell',38.4231,-82.4383),('25728','WV','Huntington','Cabell',38.4231,-82.4383),('25729','WV','Huntington','Cabell',38.4231,-82.4383),('25755','WV','Huntington','Cabell',38.4226,-82.4315),('25770','WV','Huntington','Cabell',38.4156,-82.4741),('25771','WV','Huntington','Cabell',38.4156,-82.4741),('25772','WV','Huntington','Cabell',38.4156,-82.4743),('25773','WV','Huntington','Cabell',38.4156,-82.4743),('25774','WV','Huntington','Cabell',38.4156,-82.4743),('25775','WV','Huntington','Cabell',38.4156,-82.4743),('25776','WV','Huntington','Cabell',38.4156,-82.4743),('25777','WV','Huntington','Cabell',38.4156,-82.4743),('25778','WV','Huntington','Cabell',38.4156,-82.4743),('25779','WV','Huntington','Cabell',38.4156,-82.4741),('25801','WV','Beckley','Raleigh',37.789056,-81.201796),('25802','WV','Beckley','Raleigh',37.7792,-81.1882),('25810','WV','Allen Junction','Wyoming',37.588732,-81.347746),('25811','WV','Amigo','Wyoming',37.585162,-81.307392),('25812','WV','Ansted','Fayette',38.137753,-81.105589),('25813','WV','Beaver','Raleigh',37.758815,-81.135991),('25817','WV','Bolt','Raleigh',37.764236,-81.405612),('25818','WV','Bradley','Raleigh',37.864222,-81.191498),('25820','WV','Camp Creek','Mercer',37.504695,-81.116025),('25823','WV','Coal City','Raleigh',37.662775,-81.196327),('25825','WV','Cool Ridge','Raleigh',37.653613,-81.086998),('25826','WV','Corinne','Wyoming',37.573137,-81.359056),('25827','WV','Crab Orchard','Raleigh',37.738687,-81.238067),('25831','WV','Danese','Fayette',37.95008,-80.92055),('25832','WV','Daniels','Raleigh',37.728543,-81.105945),('25833','WV','Dothan','Fayette',37.9672,-81.2222),('25836','WV','Eccles','Raleigh',37.781899,-81.266164),('25837','WV','Edmond','Fayette',38.050035,-81.020374),('25839','WV','Fairdale','Raleigh',37.780329,-81.370766),('25840','WV','Fayetteville','Fayette',38.047307,-81.113613),('25841','WV','Flat Top','Mercer',37.548811,-81.071759),('25843','WV','Ghent','Raleigh',37.617617,-81.112444),('25844','WV','Glen Daniel','Raleigh',37.788806,-81.359728),('25845','WV','Glen Fork','Wyoming',37.694697,-81.526738),('25846','WV','Glen Jean','Fayette',37.924759,-81.154495),('25848','WV','Glen Rogers','Wyoming',37.718151,-81.428283),('25849','WV','Glen White','Raleigh',37.730117,-81.279993),('25851','WV','Harper','Raleigh',37.7986,-81.2616),('25853','WV','Helen','Raleigh',37.640407,-81.3121),('25854','WV','Hico','Fayette',38.130741,-80.987844),('25855','WV','Hilltop','Fayette',37.93681,-81.156453),('25857','WV','Josephine','Raleigh',37.61363,-81.255315),('25860','WV','Lanark','Raleigh',37.8275,-81.1463),('25862','WV','Lansing','Fayette',38.079613,-81.062481),('25864','WV','Layland','Fayette',37.876046,-81.036063),('25865','WV','Lester','Raleigh',37.737341,-81.32656),('25866','WV','Lochgelly','Fayette',38.007725,-81.139107),('25868','WV','Lookout','Fayette',38.066546,-80.964312),('25870','WV','Maben','Wyoming',37.62717,-81.390446),('25871','WV','Mabscott','Raleigh',37.769863,-81.2091),('25873','WV','Mac Arthur','Raleigh',37.753182,-81.216704),('25875','WV','Mc Graws','Wyoming',37.679115,-81.460797),('25876','WV','Saulsville','Wyoming',37.637431,-81.43979),('25878','WV','Midway','Raleigh',37.721979,-81.230787),('25879','WV','Minden','Fayette',37.976017,-81.107312),('25880','WV','Mount Hope','Raleigh',37.879691,-81.199486),('25882','WV','Mullens','Wyoming',37.5981,-81.382019),('25901','WV','Oak Hill','Fayette',37.97823,-81.143971),('25902','WV','Odd','Raleigh',37.595911,-81.207735),('25904','WV','Pax','Fayette',37.917781,-81.269179),('25906','WV','Piney View','Raleigh',37.836873,-81.114415),('25907','WV','Prince','Fayette',37.85651,-81.071658),('25908','WV','Princewick','Raleigh',37.679799,-81.249632),('25909','WV','Prosperity','Raleigh',37.837706,-81.197223),('25911','WV','Raleigh','Raleigh',37.756806,-81.168971),('25913','WV','Ravencliff','Wyoming',37.700197,-81.483253),('25915','WV','Rhodell','Raleigh',37.61807,-81.291454),('25916','WV','Sabine','Wyoming',37.68094,-81.498042),('25917','WV','Scarbro','Fayette',37.970881,-81.24183),('25918','WV','Shady Spring','Raleigh',37.746255,-81.007816),('25919','WV','Skelton','Raleigh',37.8105,-81.1875),('25920','WV','Slab Fork','Raleigh',37.686426,-81.336322),('25921','WV','Sophia','Raleigh',37.691967,-81.273245),('25922','WV','Spanishburg','Mercer',37.465406,-81.103884),('25926','WV','Sprague','Raleigh',37.793,-81.1841),('25927','WV','Stanaford','Raleigh',37.8158,-81.1525),('25928','WV','Stephenson','Wyoming',37.563361,-81.335412),('25932','WV','Surveyor','Raleigh',37.766389,-81.316734),('25936','WV','Thurmond','Fayette',37.929723,-81.059505),('25938','WV','Victor','Fayette',38.141726,-81.052095),('25942','WV','Winona','Fayette',38.038816,-80.995563),('25943','WV','Wyco','Wyoming',37.5988,-81.343),('25951','WV','Hinton','Summers',37.662054,-80.864989),('25958','WV','Charmco','Greenbrier',38.007395,-80.742676),('25962','WV','Rainelle','Greenbrier',37.967245,-80.790012),('25965','WV','Elton','Summers',37.8379,-80.7895),('25966','WV','Green Sulphur Springs','Summers',37.798406,-80.770397),('25969','WV','Jumping Branch','Summers',37.622041,-80.994379),('25971','WV','Lerona','Mercer',37.486058,-80.99901),('25972','WV','Leslie','Greenbrier',38.043517,-80.729477),('25976','WV','Meadow Bridge','Fayette',37.847495,-80.832836),('25977','WV','Meadow Creek','Summers',37.798478,-80.903302),('25978','WV','Nimitz','Summers',37.617427,-80.939484),('25979','WV','Pipestem','Summers',37.525517,-80.927463),('25981','WV','Quinwood','Greenbrier',38.071481,-80.697874),('25984','WV','Rupert','Greenbrier',37.991703,-80.641552),('25985','WV','Sandstone','Summers',37.783173,-80.853455),('25986','WV','Spring Dale','Fayette',37.878258,-80.802179),('25989','WV','White Oak','Raleigh',37.680938,-81.069851),('26003','WV','Wheeling','Ohio',40.069093,-80.688833),('26030','WV','Beech Bottom','Brooke',40.225127,-80.652531),('26031','WV','Benwood','Marshall',40.012807,-80.733449),('26032','WV','Bethany','Brooke',40.198062,-80.548418),('26033','WV','Cameron','Marshall',39.82514,-80.575429),('26034','WV','Chester','Hancock',40.608659,-80.55519),('26035','WV','Colliers','Brooke',40.362048,-80.561754),('26036','WV','Dallas','Marshall',39.980507,-80.540565),('26037','WV','Follansbee','Brooke',40.329355,-80.59033),('26038','WV','Glen Dale','Marshall',39.951594,-80.747834),('26039','WV','Glen Easton','Marshall',39.800371,-80.672556),('26040','WV','Mcmechen','Marshall',39.987914,-80.731256),('26041','WV','Moundsville','Marshall',39.914001,-80.734488),('26047','WV','New Cumberland','Hancock',40.519854,-80.597712),('26050','WV','Newell','Hancock',40.616396,-80.611535),('26055','WV','Proctor','Marshall',39.767394,-80.802489),('26056','WV','New Manchester','Hancock',40.53159,-80.579572),('26058','WV','Short Creek','Brooke',40.1855,-80.6747),('26059','WV','Triadelphia','Ohio',40.064589,-80.606969),('26060','WV','Valley Grove','Ohio',40.103671,-80.549347),('26062','WV','Weirton','Hancock',40.41077,-80.578385),('26070','WV','Wellsburg','Brooke',40.269153,-80.600557),('26074','WV','West Liberty','Ohio',40.166694,-80.59664),('26075','WV','Windsor Heights','Brooke',40.191493,-80.666201),('26101','WV','Parkersburg','Wood',39.256396,-81.55109),('26102','WV','Parkersburg','Wood',39.3239,-81.5052),('26103','WV','Parkersburg','Wood',39.2508,-81.553),('26104','WV','Parkersburg','Wood',39.279767,-81.501923),('26105','WV','Vienna','Wood',39.326897,-81.539146),('26106','WV','Parkersburg','Wood',39.3239,-81.5052),('26120','WV','Mineral Wells','Wood',39.21,-81.5305),('26121','WV','Mineral Wells','Wood',39.21,-81.5305),('26133','WV','Belleville','Wood',39.130152,-81.690813),('26134','WV','Belmont','Pleasants',39.374067,-81.28175),('26136','WV','Big Bend','Calhoun',38.964826,-81.156439),('26137','WV','Big Springs','Calhoun',39.009948,-81.046305),('26138','WV','Brohard','Wirt',39.029971,-81.201886),('26141','WV','Creston','Calhoun',38.923656,-81.25668),('26142','WV','Davisville','Wood',39.214126,-81.450616),('26143','WV','Elizabeth','Wirt',39.066546,-81.383542),('26146','WV','Friendly','Tyler',39.461931,-81.054109),('26147','WV','Grantsville','Calhoun',38.913083,-81.073714),('26148','WV','Macfarlan','Ritchie',39.057598,-81.184309),('26149','WV','Middlebourne','Tyler',39.472558,-80.895115),('26150','WV','Mineral Wells','Wood',39.170862,-81.526079),('26151','WV','Mount Zion','Calhoun',38.884737,-81.164407),('26152','WV','Munday','Wirt',39.005732,-81.199657),('26155','WV','New Martinsville','Wetzel',39.642255,-80.824998),('26159','WV','Paden City','Wetzel',39.603538,-80.933534),('26160','WV','Palestine','Wirt',38.981326,-81.412055),('26161','WV','Petroleum','Ritchie',39.164987,-81.257375),('26162','WV','Porters Falls','Wetzel',39.576419,-80.772117),('26164','WV','Ravenswood','Jackson',38.966489,-81.743341),('26167','WV','Reader','Wetzel',39.563953,-80.734691),('26169','WV','Rockport','Wood',39.072445,-81.571291),('26170','WV','Saint Marys','Pleasants',39.372069,-81.189351),('26175','WV','Sistersville','Tyler',39.546434,-80.977625),('26178','WV','Smithville','Ritchie',39.066573,-81.054416),('26180','WV','Walker','Wood',39.194479,-81.378608),('26181','WV','Washington','Wood',39.226603,-81.674741),('26184','WV','Waverly','Wood',39.307596,-81.369644),('26187','WV','Williamstown','Wood',39.37957,-81.448944),('26201','WV','Buckhannon','Upshur',38.994632,-80.2147),('26202','WV','Fenwick','Nicholas',38.223997,-80.605547),('26203','WV','Erbacon','Webster',38.527812,-80.578644),('26205','WV','Craigsville','Nicholas',38.32954,-80.64706),('26206','WV','Cowen','Webster',38.422376,-80.539607),('26208','WV','Camden On Gauley','Webster',38.344096,-80.544879),('26209','WV','Snowshoe','Pocahontas',38.422104,-79.998749),('26210','WV','Adrian','Upshur',38.900064,-80.267952),('26215','WV','Cleveland','Webster',38.713695,-80.399799),('26217','WV','Diana','Webster',38.59959,-80.470547),('26218','WV','French Creek','Upshur',38.854263,-80.284135),('26219','WV','Frenchton','Upshur',38.8727,-80.3566),('26222','WV','Hacker Valley','Webster',38.65767,-80.377234),('26224','WV','Helvetia','Randolph',38.725636,-80.183548),('26228','WV','Kanawha Head','Upshur',38.748602,-80.382956),('26229','WV','Lorentz','Upshur',39.0108,-80.3025),('26230','WV','Pickens','Randolph',38.66375,-80.21993),('26234','WV','Rock Cave','Upshur',38.783089,-80.323641),('26236','WV','Selbyville','Upshur',38.749026,-80.234836),('26237','WV','Tallmansville','Upshur',38.852963,-80.164205),('26238','WV','Volga','Barbour',39.101069,-80.159274),('26241','WV','Elkins','Randolph',38.920774,-79.836726),('26250','WV','Belington','Barbour',39.028663,-79.952629),('26253','WV','Beverly','Randolph',38.822208,-79.875514),('26254','WV','Bowden','Randolph',38.887336,-79.664727),('26257','WV','Coalton','Randolph',38.907331,-79.97983),('26259','WV','Dailey','Randolph',38.801708,-79.895359),('26260','WV','Davis','Tucker',39.09538,-79.433348),('26261','WV','Richwood','Nicholas',38.217019,-80.549198),('26263','WV','Dryfork','Randolph',38.974485,-79.468525),('26264','WV','Durbin','Pocahontas',38.550811,-79.831664),('26266','WV','Upperglade','Webster',38.410247,-80.496182),('26267','WV','Ellamore','Randolph',38.915477,-80.074155),('26268','WV','Glady','Randolph',38.761354,-79.742286),('26269','WV','Hambleton','Tucker',39.100097,-79.633024),('26270','WV','Harman','Randolph',38.900117,-79.547031),('26271','WV','Hendricks','Tucker',39.047023,-79.581297),('26273','WV','Huttonsville','Randolph',38.664348,-79.93982),('26275','WV','Junior','Barbour',38.978265,-79.953002),('26276','WV','Kerens','Randolph',39.011199,-79.780479),('26278','WV','Mabie','Randolph',38.83381,-80.008502),('26280','WV','Mill Creek','Randolph',38.737376,-79.98901),('26282','WV','Monterville','Randolph',38.524898,-80.146731),('26283','WV','Montrose','Randolph',39.05319,-79.824497),('26285','WV','Norton','Randolph',38.921025,-79.952433),('26287','WV','Parsons','Tucker',39.148106,-79.685863),('26288','WV','Webster Springs','Webster',38.501458,-80.37928),('26289','WV','Red Creek','Tucker',38.99095,-79.502178),('26291','WV','Slatyfork','Pocahontas',38.413275,-80.124648),('26292','WV','Thomas','Tucker',39.151205,-79.508759),('26293','WV','Valley Bend','Randolph',38.77677,-79.928359),('26294','WV','Valley Head','Randolph',38.526734,-80.041333),('26296','WV','Whitmer','Randolph',38.764498,-79.553568),('26298','WV','Bergoo','Webster',38.478159,-80.274348),('26301','WV','Clarksburg','Harrison',39.280935,-80.347234),('26302','WV','Clarksburg','Harrison',39.26277,-80.308589),('26306','WV','Clarksburg','Harrison',39.2957,-80.3829),('26320','WV','Alma','Tyler',39.423323,-80.816287),('26321','WV','Alum Bridge','Lewis',39.052246,-80.694151),('26323','WV','Anmoore','Harrison',39.258914,-80.291096),('26325','WV','Auburn','Ritchie',39.097958,-80.859642),('26327','WV','Berea','Ritchie',39.122886,-80.94277),('26330','WV','Bridgeport','Harrison',39.296516,-80.241738),('26335','WV','Burnsville','Braxton',38.853112,-80.66447),('26337','WV','Cairo','Ritchie',39.230279,-81.161011),('26338','WV','Camden','Lewis',39.082428,-80.618986),('26339','WV','Center Point','Doddridge',39.410806,-80.60498),('26342','WV','Coxs Mills','Gilmer',39.021077,-80.870623),('26343','WV','Crawford','Lewis',38.837397,-80.420574),('26346','WV','Ellenboro','Ritchie',39.278115,-81.068477),('26347','WV','Flemington','Taylor',39.25403,-80.126166),('26348','WV','Folsom','Wetzel',39.462602,-80.545355),('26349','WV','Galloway','Barbour',39.235496,-80.127026),('26351','WV','Glenville','Gilmer',38.938848,-80.849218),('26354','WV','Grafton','Taylor',39.339705,-80.027814),('26361','WV','Gypsy','Harrison',39.369234,-80.318259),('26362','WV','Harrisville','Ritchie',39.16709,-81.054504),('26366','WV','Haywood','Harrison',39.383118,-80.335137),('26369','WV','Hepzibah','Harrison',39.335232,-80.331364),('26372','WV','Horner','Lewis',38.969558,-80.372339),('26374','WV','Independence','Preston',39.452312,-79.875207),('26376','WV','Ireland','Lewis',38.770185,-80.447576),('26377','WV','Jacksonburg','Wetzel',39.496273,-80.646847),('26378','WV','Jane Lew','Lewis',39.110967,-80.419668),('26384','WV','Linn','Gilmer',38.981248,-80.706813),('26385','WV','Lost Creek','Harrison',39.163157,-80.355434),('26386','WV','Lumberport','Harrison',39.384125,-80.369911),('26404','WV','Meadowbrook','Harrison',39.342694,-80.315966),('26405','WV','Moatsville','Barbour',39.225164,-79.910422),('26408','WV','Mount Clare','Harrison',39.209603,-80.302351),('26410','WV','Newburg','Preston',39.404008,-79.830264),('26411','WV','New Milton','Doddridge',39.169251,-80.706509),('26412','WV','Orlando','Lewis',38.877334,-80.591622),('26415','WV','Pennsboro','Ritchie',39.293619,-80.95094),('26416','WV','Philippi','Barbour',39.157918,-80.042151),('26419','WV','Pine Grove','Wetzel',39.552684,-80.668982),('26421','WV','Pullman','Ritchie',39.181955,-80.924287),('26422','WV','Reynoldsville','Harrison',39.288655,-80.438771),('26424','WV','Rosemont','Taylor',39.267917,-80.168165),('26425','WV','Rowlesburg','Preston',39.324834,-79.691519),('26426','WV','Salem','Harrison',39.286182,-80.556732),('26430','WV','Sand Fork','Gilmer',38.894189,-80.742233),('26431','WV','Shinnston','Harrison',39.394598,-80.293315),('26434','WV','Shirley','Tyler',39.398,-80.7652),('26435','WV','Simpson','Taylor',39.266212,-80.091363),('26436','WV','Smithburg','Doddridge',39.289762,-80.735465),('26437','WV','Smithfield','Wetzel',39.518432,-80.543761),('26438','WV','Spelter','Harrison',39.346488,-80.319004),('26440','WV','Thornton','Taylor',39.331444,-79.903384),('26443','WV','Troy','Gilmer',39.055848,-80.767174),('26444','WV','Tunnelton','Preston',39.363716,-79.770661),('26447','WV','Walkersville','Lewis',38.908317,-80.475009),('26448','WV','Wallace','Harrison',39.40669,-80.486723),('26451','WV','West Milford','Harrison',39.202855,-80.403483),('26452','WV','Weston','Lewis',39.035283,-80.477459),('26456','WV','West Union','Doddridge',39.294388,-80.765215),('26461','WV','Wilsonburg','Harrison',39.2925,-80.3963),('26463','WV','Wyatt','Harrison',39.440245,-80.352333),('26501','WV','Morgantown','Monongalia',39.627176,-79.988537),('26502','WV','Morgantown','Monongalia',39.5863,-79.959),('26504','WV','Morgantown','Monongalia',39.5863,-79.959),('26505','WV','Morgantown','Monongalia',39.64621,-79.952766),('26506','WV','Morgantown','Monongalia',39.6494,-79.9571),('26507','WV','Morgantown','Monongalia',39.6276,-79.9574),('26508','WV','Morgantown','Monongalia',39.613305,-79.900476),('26519','WV','Albright','Preston',39.550363,-79.6372),('26520','WV','Arthurdale','Preston',39.495484,-79.820314),('26521','WV','Blacksville','Monongalia',39.718688,-80.219536),('26524','WV','Bretz','Preston',39.5422,-79.8008),('26525','WV','Bruceton Mills','Preston',39.646588,-79.593795),('26527','WV','Cassville','Monongalia',39.6655,-80.0638),('26531','WV','Dellslow','Monongalia',39.607447,-79.890128),('26534','WV','Granville','Monongalia',39.648073,-79.991543),('26537','WV','Kingwood','Preston',39.475047,-79.696093),('26541','WV','Maidsville','Monongalia',39.69115,-80.078899),('26542','WV','Masontown','Preston',39.557072,-79.793381),('26543','WV','Osage','Monongalia',39.664583,-79.999896),('26544','WV','Pentress','Monongalia',39.707009,-80.164518),('26546','WV','Pursglove','Monongalia',39.7161,-80.0863),('26547','WV','Reedsville','Preston',39.510797,-79.801549),('26554','WV','Fairmont','Marion',39.466579,-80.143078),('26555','WV','Fairmont','Marion',39.485,-80.1427),('26559','WV','Barrackville','Marion',39.503437,-80.17009),('26560','WV','Baxter','Marion',39.540869,-80.143768),('26561','WV','Big Run','Wetzel',39.5937,-80.5642),('26562','WV','Burton','Wetzel',39.655275,-80.423069),('26563','WV','Carolina','Marion',39.48146,-80.272962),('26566','WV','Colfax','Marion',39.4347,-80.1319),('26568','WV','Enterprise','Harrison',39.421221,-80.276356),('26570','WV','Fairview','Monongalia',39.644271,-80.221749),('26571','WV','Farmington','Marion',39.512515,-80.250596),('26572','WV','Four States','Marion',39.480378,-80.308359),('26574','WV','Grant Town','Marion',39.560943,-80.177824),('26575','WV','Hundred','Wetzel',39.685095,-80.448797),('26576','WV','Idamay','Marion',39.495461,-80.258673),('26578','WV','Kingmont','Marion',39.4469,-80.1761),('26581','WV','Littleton','Wetzel',39.669681,-80.547428),('26582','WV','Mannington','Marion',39.525052,-80.353182),('26585','WV','Metz','Marion',39.612062,-80.412236),('26586','WV','Montana Mines','Marion',39.525505,-80.10866),('26587','WV','Rachel','Marion',39.518954,-80.298958),('26588','WV','Rivesville','Marion',39.549226,-80.129257),('26590','WV','Wana','Monongalia',39.677429,-80.313351),('26591','WV','Worthington','Marion',39.453359,-80.275522),('26601','WV','Sutton','Braxton',38.639811,-80.678105),('26610','WV','Birch River','Nicholas',38.493219,-80.735519),('26611','WV','Cedarville','Gilmer',38.842435,-80.820104),('26615','WV','Copen','Braxton',38.846429,-80.727924),('26617','WV','Dille','Clay',38.493272,-80.824887),('26619','WV','Exchange','Braxton',38.774847,-80.747383),('26621','WV','Flatwoods','Braxton',38.724464,-80.576784),('26623','WV','Frametown','Braxton',38.636386,-80.863972),('26624','WV','Gassaway','Braxton',38.691371,-80.789577),('26627','WV','Heaters','Braxton',38.76358,-80.604653),('26629','WV','Little Birch','Braxton',38.571012,-80.714323),('26631','WV','Napier','Braxton',38.788521,-80.555714),('26636','WV','Rosedale','Gilmer',38.747389,-80.943408),('26638','WV','Shock','Gilmer',38.767524,-81.015835),('26651','WV','Summersville','Nicholas',38.309024,-80.874304),('26656','WV','Belva','Nicholas',38.252019,-81.162355),('26660','WV','Calvin','Nicholas',38.34627,-80.699163),('26662','WV','Canvas','Nicholas',38.264324,-80.761472),('26667','WV','Drennen','Nicholas',38.268633,-80.981485),('26671','WV','Gilboa','Nicholas',38.302121,-80.935495),('26675','WV','Keslers Cross Lanes','Nicholas',38.2448,-80.9432),('26676','WV','Leivasy','Nicholas',38.153158,-80.671027),('26678','WV','Mount Lookout','Nicholas',38.163747,-80.911985),('26679','WV','Mount Nebo','Nicholas',38.191583,-80.819371),('26680','WV','Nallen','Fayette',38.091805,-80.873207),('26681','WV','Nettie','Nicholas',38.230755,-80.697186),('26684','WV','Pool','Nicholas',38.163524,-80.868648),('26690','WV','Swiss','Fayette',38.230643,-81.126264),('26691','WV','Tioga','Nicholas',38.405252,-80.668943),('26704','WV','Augusta','Hampshire',39.294298,-78.590582),('26705','WV','Aurora','Preston',39.318913,-79.564308),('26707','WV','Bayard','Grant',39.257609,-79.381937),('26710','WV','Burlington','Mineral',39.323572,-78.92384),('26711','WV','Capon Bridge','Hampshire',39.275642,-78.463415),('26714','WV','Delray','Hampshire',39.181282,-78.626001),('26716','WV','Eglon','Preston',39.262677,-79.508117),('26717','WV','Elk Garden','Mineral',39.353344,-79.174194),('26719','WV','Fort Ashby','Mineral',39.500433,-78.771949),('26720','WV','Gormania','Grant',39.282919,-79.338239),('26722','WV','Green Spring','Hampshire',39.511657,-78.639646),('26726','WV','Keyser','Mineral',39.429185,-78.967551),('26731','WV','Lahmansville','Grant',39.161221,-79.070428),('26739','WV','Mount Storm','Grant',39.22796,-79.272025),('26743','WV','New Creek','Mineral',39.300459,-79.058694),('26750','WV','Piedmont','Mineral',39.479198,-79.047196),('26753','WV','Ridgeley','Mineral',39.576811,-78.788013),('26755','WV','Rio','Hampshire',39.15041,-78.727589),('26757','WV','Romney','Hampshire',39.330409,-78.749133),('26761','WV','Shanks','Hampshire',39.287353,-78.692544),('26763','WV','Springfield','Hampshire',39.454032,-78.687737),('26764','WV','Terra Alta','Preston',39.453648,-79.543283),('26767','WV','Wiley Ford','Mineral',39.614853,-78.773847),('26801','WV','Baker','Hardy',39.052656,-78.790825),('26802','WV','Brandywine','Pendleton',38.626845,-79.204429),('26804','WV','Circleville','Pendleton',38.633055,-79.526793),('26807','WV','Franklin','Pendleton',38.642458,-79.351152),('26808','WV','High View','Hampshire',39.213975,-78.441317),('26810','WV','Lost City','Hardy',38.974871,-78.743902),('26812','WV','Mathias','Hardy',38.877387,-78.880718),('26814','WV','Riverton','Pendleton',38.75325,-79.445988),('26815','WV','Sugar Grove','Pendleton',38.493516,-79.364475),('26817','WV','Bloomery','Hampshire',39.355873,-78.372178),('26818','WV','Fisher','Hardy',39.063958,-79.020185),('26823','WV','Capon Springs','Hampshire',39.13711,-78.489062),('26833','WV','Maysville','Grant',39.099411,-79.201599),('26836','WV','Moorefield','Hardy',39.024097,-78.971996),('26838','WV','Milam','Hardy',38.81801,-79.091072),('26845','WV','Old Fields','Hardy',39.161934,-78.952385),('26847','WV','Petersburg','Grant',38.963754,-79.137246),('26851','WV','Wardensville','Hardy',39.076812,-78.615259),('26852','WV','Purgitsville','Hampshire',39.245389,-78.910578),('26855','WV','Cabins','Grant',38.985602,-79.251929),('26865','WV','Yellow Spring','Hampshire',39.20795,-78.490265),('26866','WV','Upper Tract','Pendleton',38.80407,-79.24863),('26884','WV','Seneca Rocks','Pendleton',38.847112,-79.376763),('26886','WV','Onego','Pendleton',38.844294,-79.422066),('27006','NC','Advance','Davie',35.970208,-80.433593),('27007','NC','Ararat','Surry',36.393287,-80.587802),('27009','NC','Belews Creek','Forsyth',36.230919,-80.078625),('27010','NC','Bethania','Forsyth',36.1822,-80.3383),('27011','NC','Boonville','Yadkin',36.219426,-80.708357),('27012','NC','Clemmons','Forsyth',36.020487,-80.389157),('27013','NC','Cleveland','Rowan',35.738279,-80.705358),('27014','NC','Cooleemee','Davie',35.814232,-80.554909),('27016','NC','Danbury','Stokes',36.419099,-80.215387),('27017','NC','Dobson','Surry',36.37809,-80.743561),('27018','NC','East Bend','Yadkin',36.200327,-80.525705),('27019','NC','Germanton','Stokes',36.274379,-80.236247),('27020','NC','Hamptonville','Yadkin',36.107209,-80.818152),('27021','NC','King','Stokes',36.293034,-80.354495),('27022','NC','Lawsonville','Stokes',36.512594,-80.216013),('27023','NC','Lewisville','Forsyth',36.096047,-80.425948),('27024','NC','Lowgap','Surry',36.52413,-80.837652),('27025','NC','Madison','Rockingham',36.379051,-79.969387),('27027','NC','Mayodan','Rockingham',36.421544,-79.971833),('27028','NC','Mocksville','Davie',35.912921,-80.56982),('27030','NC','Mount Airy','Surry',36.488833,-80.621887),('27031','NC','White Plains','Surry',36.4455,-80.6336),('27040','NC','Pfafftown','Forsyth',36.173602,-80.377267),('27041','NC','Pilot Mountain','Surry',36.401074,-80.487769),('27042','NC','Pine Hall','Stokes',36.336747,-80.051542),('27043','NC','Pinnacle','Stokes',36.329801,-80.452),('27045','NC','Rural Hall','Forsyth',36.231361,-80.303544),('27046','NC','Sandy Ridge','Stokes',36.488937,-80.093225),('27047','NC','Siloam','Surry',36.309397,-80.581851),('27048','NC','Stoneville','Rockingham',36.467402,-79.908385),('27049','NC','Toast','Surry',36.5002,-80.6266),('27050','NC','Tobaccoville','Forsyth',36.238844,-80.385839),('27051','NC','Walkertown','Forsyth',36.175129,-80.161712),('27052','NC','Walnut Cove','Stokes',36.30337,-80.145279),('27053','NC','Westfield','Stokes',36.474276,-80.34785),('27054','NC','Woodleaf','Rowan',35.788461,-80.593132),('27055','NC','Yadkinville','Yadkin',36.118437,-80.647549),('27094','NC','Rural Hall','Forsyth',36.2402,-80.2936),('27098','NC','Rural Hall','Forsyth',36.2454,-80.299),('27099','NC','Rural Hall','Forsyth',36.2454,-80.299),('27101','NC','Winston Salem','Forsyth',36.105825,-80.218892),('27102','NC','Winston Salem','Forsyth',36.1135,-80.2422),('27103','NC','Winston Salem','Forsyth',36.062493,-80.311121),('27104','NC','Winston Salem','Forsyth',36.096781,-80.316508),('27105','NC','Winston Salem','Forsyth',36.146253,-80.237288),('27106','NC','Winston Salem','Forsyth',36.140873,-80.318333),('27107','NC','Winston Salem','Forsyth',36.040207,-80.188165),('27108','NC','Winston Salem','Forsyth',36.0869,-80.2486),('27109','NC','Winston Salem','Forsyth',36.133462,-80.27794),('27110','NC','Winston Salem','Forsyth',36.090121,-80.225634),('27111','NC','Winston Salem','Forsyth',36.1267,-80.0669),('27113','NC','Winston Salem','Forsyth',36.0894,-80.2738),('27114','NC','Winston Salem','Forsyth',36.0758,-80.3103),('27115','NC','Winston Salem','Forsyth',36.1351,-80.2426),('27116','NC','Winston Salem','Forsyth',36.1412,-80.2995),('27117','NC','Winston Salem','Forsyth',36.0699,-80.2067),('27120','NC','Winston Salem','Forsyth',36.1042,-80.2442),('27127','NC','Winston Salem','Forsyth',36.031521,-80.262948),('27130','NC','Winston Salem','Forsyth',36.0586,-80.3203),('27150','NC','Winston Salem','Forsyth',36.1135,-80.2422),('27151','NC','Winston Salem','Forsyth',36.1135,-80.2422),('27152','NC','Winston Salem','Forsyth',36.1005,-80.208),('27155','NC','Winston Salem','Forsyth',36.1135,-80.2422),('27156','NC','Winston Salem','Forsyth',36.1434,-80.2275),('27157','NC','Winston Salem','Forsyth',36.0586,-80.3203),('27198','NC','Winston Salem','Forsyth',36.1028,-80.2225),('27199','NC','Winston Salem','Forsyth',36.1135,-80.2422),('27201','NC','Alamance','Alamance',36.034205,-79.484834),('27202','NC','Altamahaw','Alamance',36.185712,-79.504961),('27203','NC','Asheboro','Randolph',35.724263,-79.79997),('27204','NC','Asheboro','Randolph',35.7057,-79.8203),('27205','NC','Asheboro','Randolph',35.667188,-79.837082),('27207','NC','Bear Creek','Chatham',35.611777,-79.396248),('27208','NC','Bennett','Chatham',35.558587,-79.545715),('27209','NC','Biscoe','Montgomery',35.351705,-79.775445),('27212','NC','Blanch','Caswell',36.449321,-79.286814),('27213','NC','Bonlee','Chatham',35.6458,-79.4147),('27214','NC','Browns Summit','Guilford',36.202786,-79.717871),('27215','NC','Burlington','Alamance',36.069433,-79.478292),('27216','NC','Burlington','Alamance',36.0285,-79.4812),('27217','NC','Burlington','Alamance',36.131653,-79.412748),('27220','NC','Burlington','Alamance',36.0285,-79.4812),('27228','NC','Bynum','Chatham',35.7738,-79.1425),('27229','NC','Candor','Montgomery',35.265553,-79.77589),('27230','NC','Cedar Falls','Randolph',35.8043,-79.7243),('27231','NC','Cedar Grove','Orange',36.201003,-79.165769),('27233','NC','Climax','Randolph',35.923719,-79.699295),('27235','NC','Colfax','Guilford',36.081622,-80.007013),('27237','NC','Cumnock','Lee',35.4709,-79.1722),('27239','NC','Denton','Davidson',35.619274,-80.111455),('27242','NC','Eagle Springs','Moore',35.329657,-79.648955),('27243','NC','Efland','Orange',36.078069,-79.187276),('27244','NC','Elon, Nc','Alamance',36.14717,-79.506382),('27247','NC','Ether','Montgomery',35.4397,-79.7841),('27248','NC','Franklinville','Randolph',35.772902,-79.706285),('27249','NC','Gibsonville','Guilford',36.12936,-79.5701),('27252','NC','Goldston','Chatham',35.563166,-79.338905),('27253','NC','Graham','Alamance',36.027825,-79.374036),('27256','NC','Gulf','Chatham',35.562184,-79.287517),('27258','NC','Haw River','Alamance',36.062063,-79.347383),('27259','NC','Highfalls','Moore',35.479,-79.5231),('27260','NC','High Point','Guilford',35.952974,-79.992589),('27261','NC','High Point','Guilford',35.9537,-80.0024),('27262','NC','High Point','Guilford',35.964606,-80.02412),('27263','NC','High Point','Randolph',35.914458,-79.954559),('27264','NC','High Point','Guilford',36.0354,-79.998),('27265','NC','High Point','Guilford',36.014335,-80.00858),('27278','NC','Hillsborough','Orange',36.076712,-79.090139),('27281','NC','Jackson Springs','Moore',35.184595,-79.612259),('27282','NC','Jamestown','Guilford',36.005266,-79.932939),('27283','NC','Julian','Guilford',35.944045,-79.649287),('27284','NC','Kernersville','Forsyth',36.112632,-80.086395),('27285','NC','Kernersville','Forsyth',36.1239,-80.0779),('27288','NC','Eden','Rockingham',36.504197,-79.748256),('27289','NC','Eden','Rockingham',36.4883,-79.7669),('27291','NC','Leasburg','Caswell',36.424049,-79.151807),('27292','NC','Lexington','Davidson',35.766596,-80.229732),('27293','NC','Lexington','Davidson',35.7351,-80.2068),('27294','NC','Lexington','Davidson',35.7351,-80.2068),('27295','NC','Lexington','Davidson',35.867669,-80.289982),('27298','NC','Liberty','Randolph',35.885115,-79.567545),('27299','NC','Linwood','Davidson',35.751097,-80.365025),('27301','NC','Mc Leansville','Guilford',36.097511,-79.671426),('27302','NC','Mebane','Alamance',36.09897,-79.273011),('27305','NC','Milton','Caswell',36.529475,-79.219106),('27306','NC','Mount Gilead','Montgomery',35.232103,-79.995789),('27310','NC','Oak Ridge','Guilford',36.174689,-79.992629),('27311','NC','Pelham','Caswell',36.489014,-79.485945),('27312','NC','Pittsboro','Chatham',35.749377,-79.175723),('27313','NC','Pleasant Garden','Guilford',35.932332,-79.744745),('27314','NC','Prospect Hill','Caswell',36.288353,-79.18873),('27315','NC','Providence','Caswell',36.504079,-79.388248),('27316','NC','Ramseur','Randolph',35.712281,-79.637307),('27317','NC','Randleman','Randolph',35.819371,-79.804861),('27320','NC','Reidsville','Rockingham',36.345763,-79.670904),('27321','NC','Reidsville','Rockingham',36.3563,-79.6662),('27322','NC','Reidsville','Rockingham',36.3563,-79.6662),('27323','NC','Reidsville','Rockingham',36.3563,-79.6662),('27325','NC','Robbins','Moore',35.450653,-79.563615),('27326','NC','Ruffin','Rockingham',36.478726,-79.572757),('27330','NC','Sanford','Lee',35.496974,-79.18275),('27331','NC','Sanford','Lee',35.4709,-79.1722),('27332','NC','Sanford','Lee',35.398257,-79.141358),('27340','NC','Saxapahaw','Alamance',35.945873,-79.317167),('27341','NC','Seagrove','Randolph',35.525338,-79.725558),('27342','NC','Sedalia','Guilford',36.075975,-79.631328),('27343','NC','Semora','Person',36.500332,-79.090895),('27344','NC','Siler City','Chatham',35.728899,-79.452975),('27349','NC','Snow Camp','Alamance',35.901313,-79.416062),('27350','NC','Sophia','Randolph',35.812812,-79.902389),('27351','NC','Southmont','Davidson',35.8156,-80.2638),('27355','NC','Staley','Randolph',35.796232,-79.567942),('27356','NC','Star','Montgomery',35.42143,-79.786243),('27357','NC','Stokesdale','Rockingham',36.26261,-79.976815),('27358','NC','Summerfield','Guilford',36.210964,-79.887418),('27359','NC','Swepsonville','Alamance',36.0211,-79.3616),('27360','NC','Thomasville','Davidson',35.867629,-80.088964),('27361','NC','Thomasville','Davidson',35.8825,-80.0822),('27370','NC','Trinity','Randolph',35.843931,-79.983269),('27371','NC','Troy','Montgomery',35.385739,-79.93754),('27373','NC','Wallburg','Davidson',36.01,-80.1394),('27374','NC','Welcome','Davidson',35.9027,-80.2572),('27375','NC','Wentworth','Rockingham',36.4,-79.7747),('27376','NC','West End','Moore',35.239166,-79.53506),('27377','NC','Whitsett','Guilford',36.054702,-79.593452),('27379','NC','Yanceyville','Caswell',36.381785,-79.340257),('27395','NC','Greensboro','Guilford',36.0726,-79.792),('27401','NC','Greensboro','Guilford',36.071408,-79.774092),('27402','NC','Greensboro','Guilford',36.0681,-79.952),('27403','NC','Greensboro','Guilford',36.064686,-79.822307),('27404','NC','Greensboro','Guilford',36.0853,-79.833),('27405','NC','Greensboro','Guilford',36.111431,-79.748214),('27406','NC','Greensboro','Guilford',36.021993,-79.779887),('27407','NC','Greensboro','Guilford',36.025643,-79.870314),('27408','NC','Greensboro','Guilford',36.101595,-79.814628),('27409','NC','Greensboro','Guilford',36.085526,-79.939541),('27410','NC','Greensboro','Guilford',36.11377,-79.887198),('27411','NC','Greensboro','Guilford',36.078,-79.7706),('27412','NC','Greensboro','Guilford',36.0725,-79.7922),('27413','NC','Greensboro','Guilford',36.0712,-79.8114),('27415','NC','Greensboro','Guilford',36.0917,-79.7805),('27416','NC','Greensboro','Guilford',36.0018,-79.7626),('27417','NC','Greensboro','Guilford',36.0091,-79.8743),('27419','NC','Greensboro','Guilford',36.1271,-79.944),('27420','NC','Greensboro','Guilford',36.0681,-79.952),('27425','NC','Greensboro','Guilford',36.1271,-79.944),('27427','NC','Greensboro','Guilford',36.0725,-79.7922),('27429','NC','Greensboro','Guilford',36.0935,-79.8147),('27435','NC','Greensboro','Guilford',36.0655,-79.8052),('27438','NC','Greensboro','Guilford',36.1129,-79.8333),('27455','NC','Greensboro','Guilford',36.162186,-79.808354),('27480','NC','Greensboro','Guilford',36.0725,-79.7922),('27495','NC','Greensboro','Guilford',36.0389,-79.9433),('27497','NC','Greensboro','Guilford',36.0725,-79.7922),('27498','NC','Greensboro','Guilford',36.0725,-79.7922),('27499','NC','Greensboro','Guilford',36.0725,-79.7922),('27501','NC','Angier','Harnett',35.493825,-78.709286),('27502','NC','Apex','Wake',35.730004,-78.868411),('27503','NC','Bahama','Durham',36.15886,-78.874659),('27504','NC','Benson','Johnston',35.39347,-78.531726),('27505','NC','Broadway','Harnett',35.427826,-79.031187),('27506','NC','Buies Creek','Harnett',35.406513,-78.738485),('27507','NC','Bullock','Granville',36.525889,-78.571572),('27508','NC','Bunn','Franklin',35.955273,-78.255928),('27509','NC','Butner','Granville',36.134752,-78.764756),('27510','NC','Carrboro','Orange',35.912545,-79.081911),('27511','NC','Cary','Wake',35.766075,-78.782089),('27512','NC','Cary','Wake',35.764,-78.7875),('27513','NC','Cary','Wake',35.796866,-78.801237),('27514','NC','Chapel Hill','Orange',35.946217,-79.037462),('27515','NC','Chapel Hill','Orange',35.913,-79.0561),('27516','NC','Chapel Hill','Orange',35.908421,-79.10466),('27517','NC','Chapel Hill','Orange',35.898566,-79.015463),('27518','NC','Cary','Wake',35.730242,-78.770986),('27519','NC','Cary','Wake',35.809049,-78.880774),('27520','NC','Clayton','Johnston',35.627035,-78.464084),('27521','NC','Coats','Harnett',35.409386,-78.66744),('27522','NC','Creedmoor','Granville',36.114244,-78.688126),('27523','NC','Apex','Wake',35.75689,-78.901001),('27524','NC','Four Oaks','Johnston',35.418239,-78.421924),('27525','NC','Franklinton','Franklin',36.10537,-78.463206),('27526','NC','Fuquay Varina','Wake',35.576848,-78.795815),('27527','NC','Clayton','Johnston',35.65161,-78.39047),('27528','NC','Clayton','Johnston',35.6507,-78.4564),('27529','NC','Garner','Wake',35.677441,-78.600018),('27530','NC','Goldsboro','Wayne',35.387974,-78.012129),('27531','NC','Goldsboro','Wayne',35.347406,-77.966469),('27532','NC','Goldsboro','Wayne',35.3847,-77.993),('27533','NC','Goldsboro','Wayne',35.3833,-77.9931),('27534','NC','Goldsboro','Wayne',35.372471,-77.929193),('27536','NC','Henderson','Vance',36.324479,-78.405987),('27537','NC','Henderson','Vance',36.3512,-78.384986),('27539','NC','Apex','Wake',35.68059,-78.797327),('27540','NC','Holly Springs','Wake',35.640107,-78.837654),('27541','NC','Hurdle Mills','Person',36.264862,-79.083217),('27542','NC','Kenly','Johnston',35.604752,-78.136996),('27543','NC','Kipling','Harnett',35.4797,-78.8213),('27544','NC','Kittrell','Vance',36.21353,-78.438141),('27545','NC','Knightdale','Wake',35.785359,-78.487973),('27546','NC','Lillington','Harnett',35.387972,-78.841853),('27549','NC','Louisburg','Franklin',36.075853,-78.253587),('27551','NC','Macon','Warren',36.471037,-78.072075),('27552','NC','Mamers','Harnett',35.4166,-78.9336),('27553','NC','Manson','Warren',36.486561,-78.305322),('27555','NC','Micro','Johnston',35.562114,-78.203538),('27556','NC','Middleburg','Vance',36.402281,-78.318978),('27557','NC','Middlesex','Nash',35.784989,-78.196548),('27559','NC','Moncure','Chatham',35.620956,-79.089191),('27560','NC','Morrisville','Wake',35.853314,-78.832105),('27562','NC','New Hill','Chatham',35.651819,-78.97554),('27563','NC','Norlina','Warren',36.438631,-78.236608),('27564','NC','Creedmoor','Granville',36.1102,-78.688),('27565','NC','Oxford','Granville',36.333866,-78.62362),('27568','NC','Pine Level','Johnston',35.507822,-78.244703),('27569','NC','Princeton','Johnston',35.459018,-78.163624),('27570','NC','Ridgeway','Warren',36.441215,-78.240446),('27571','NC','Rolesville','Wake',35.922446,-78.463173),('27572','NC','Rougemont','Person',36.247218,-78.88971),('27573','NC','Roxboro','Person',36.39769,-78.979514),('27574','NC','Roxboro','Person',36.438118,-78.966842),('27576','NC','Selma','Johnston',35.551424,-78.269153),('27577','NC','Smithfield','Johnston',35.50697,-78.34259),('27581','NC','Stem','Granville',36.194793,-78.726263),('27582','NC','Stovall','Granville',36.450024,-78.568632),('27583','NC','Timberlake','Person',36.292958,-78.935362),('27584','NC','Townsville','Vance',36.528939,-78.445047),('27586','NC','Vaughan','Warren',36.4263,-78.0038),('27587','NC','Wake Forest','Wake',35.968724,-78.522473),('27588','NC','Wake Forest','Wake',35.9797,-78.51),('27589','NC','Warrenton','Warren',36.378632,-78.140684),('27591','NC','Wendell','Wake',35.781359,-78.380712),('27592','NC','Willow Spring','Wake',35.558201,-78.6789),('27593','NC','Wilsons Mills','Johnston',35.5828,-78.3567),('27594','NC','Wise','Warren',36.4863,-78.1711),('27596','NC','Youngsville','Franklin',36.015914,-78.471321),('27597','NC','Zebulon','Wake',35.841015,-78.30268),('27599','NC','Chapel Hill','Orange',35.9052,-79.0474),('27601','NC','Raleigh','Wake',35.774734,-78.634294),('27602','NC','Raleigh','Wake',35.7719,-78.6388),('27603','NC','Raleigh','Wake',35.706905,-78.65872),('27604','NC','Raleigh','Wake',35.816047,-78.584394),('27605','NC','Raleigh','Wake',35.790869,-78.653964),('27606','NC','Raleigh','Wake',35.763736,-78.715171),('27607','NC','Raleigh','Wake',35.803473,-78.705772),('27608','NC','Raleigh','Wake',35.808489,-78.64713),('27609','NC','Raleigh','Wake',35.843765,-78.633643),('27610','NC','Raleigh','Wake',35.761912,-78.578854),('27611','NC','Raleigh','Wake',35.7719,-78.6388),('27612','NC','Raleigh','Wake',35.850894,-78.698069),('27613','NC','Raleigh','Wake',35.899864,-78.710136),('27614','NC','Raleigh','Wake',35.945612,-78.597523),('27615','NC','Raleigh','Wake',35.895067,-78.63424),('27616','NC','Raleigh','Wake',35.867922,-78.547462),('27617','NC','Raleigh','Wake',35.905183,-78.782058),('27619','NC','Raleigh','Wake',35.8973,-78.6338),('27620','NC','Raleigh','Wake',35.7719,-78.6388),('27621','NC','Raleigh','Wake',35.7719,-78.6388),('27622','NC','Raleigh','Wake',35.8501,-78.6916),('27623','NC','Raleigh','Wake',35.8607,-78.7928),('27624','NC','Raleigh','Wake',35.8423,-78.6337),('27625','NC','Raleigh','Wake',35.7719,-78.6388),('27626','NC','Raleigh','Wake',35.7719,-78.6388),('27627','NC','Raleigh','Wake',35.7676,-78.695),('27628','NC','Raleigh','Wake',35.7719,-78.6388),('27629','NC','Raleigh','Wake',35.7719,-78.6388),('27634','NC','Raleigh','Wake',35.7719,-78.6388),('27635','NC','Raleigh','Wake',35.7719,-78.6388),('27636','NC','Raleigh','Wake',35.7719,-78.6388),('27640','NC','Raleigh','Wake',35.7719,-78.6388),('27650','NC','Raleigh','Wake',35.7719,-78.6388),('27656','NC','Raleigh','Wake',35.8501,-78.6916),('27658','NC','Raleigh','Wake',35.8478,-78.5965),('27661','NC','Raleigh','Wake',35.8928,-78.56),('27668','NC','Raleigh','Wake',35.8422,-78.6337),('27675','NC','Raleigh','Wake',35.9025,-78.7452),('27676','NC','Raleigh','Wake',35.9057,-78.7488),('27690','NC','Raleigh','Wake',35.8932,-78.6251),('27695','NC','Raleigh','Wake',35.8086,-78.7196),('27697','NC','Raleigh','Wake',35.7719,-78.6388),('27698','NC','Raleigh','Wake',35.7719,-78.6388),('27699','NC','Raleigh','Wake',35.6682,-78.6618),('27701','NC','Durham','Durham',35.998341,-78.899084),('27702','NC','Durham','Durham',35.9938,-78.8988),('27703','NC','Durham','Durham',35.960668,-78.833117),('27704','NC','Durham','Durham',36.037638,-78.862718),('27705','NC','Durham','Durham',36.018116,-78.956565),('27706','NC','Durham','Durham',35.993143,-78.937358),('27707','NC','Durham','Durham',35.960717,-78.938185),('27708','NC','Durham','Durham',35.9985,-78.9394),('27709','NC','Durham','Durham',35.926516,-78.83224),('27710','NC','Durham','Durham',35.9938,-78.8988),('27711','NC','Durham','Durham',35.905,-78.8785),('27712','NC','Durham','Durham',36.088538,-78.912084),('27713','NC','Durham','Durham',35.908006,-78.921013),('27715','NC','Durham','Durham',35.9938,-78.8988),('27717','NC','Durham','Durham',35.9938,-78.8988),('27722','NC','Durham','Durham',36.1002,-78.9248),('27801','NC','Rocky Mount','Edgecombe',35.933094,-77.768095),('27802','NC','Rocky Mount','Edgecombe',35.9396,-77.8006),('27803','NC','Rocky Mount','Nash',35.920438,-77.832901),('27804','NC','Rocky Mount','Nash',35.977461,-77.834262),('27805','NC','Aulander','Hertford',36.230475,-77.100018),('27806','NC','Aurora','Beaufort',35.308056,-76.785797),('27807','NC','Bailey','Nash',35.79768,-78.106492),('27808','NC','Bath','Beaufort',35.470384,-76.778496),('27809','NC','Battleboro','Nash',36.03664,-77.781582),('27810','NC','Belhaven','Beaufort',35.534023,-76.607067),('27811','NC','Bellarthur','Pitt',35.5856,-77.517),('27812','NC','Bethel','Pitt',35.80206,-77.377799),('27813','NC','Black Creek','Wilson',35.634462,-77.9341),('27814','NC','Blounts Creek','Beaufort',35.391778,-76.929579),('27815','NC','Rocky Mount','Nash',35.8979,-77.7935),('27816','NC','Castalia','Nash',36.098183,-78.073602),('27817','NC','Chocowinity','Beaufort',35.481032,-77.081958),('27818','NC','Como','Hertford',36.499725,-77.018505),('27819','NC','Conetoe','Edgecombe',35.817451,-77.457115),('27820','NC','Conway','Northampton',36.419851,-77.238972),('27821','NC','Edward','Beaufort',35.322066,-76.874087),('27822','NC','Elm City','Wilson',35.805856,-77.86011),('27823','NC','Enfield','Halifax',36.189865,-77.717715),('27824','NC','Engelhard','Hyde',35.491799,-76.026759),('27825','NC','Everetts','Martin',35.833102,-77.173794),('27826','NC','Fairfield','Hyde',35.557181,-76.216462),('27827','NC','Falkland','Pitt',35.695315,-77.512887),('27828','NC','Farmville','Pitt',35.595989,-77.587499),('27829','NC','Fountain','Pitt',35.681327,-77.643803),('27830','NC','Fremont','Wayne',35.550983,-77.967395),('27831','NC','Garysburg','Northampton',36.459608,-77.577023),('27832','NC','Gaston','Northampton',36.503407,-77.673768),('27833','NC','Greenville','Pitt',35.6594,-77.3974),('27834','NC','Greenville','Pitt',35.618586,-77.388271),('27835','NC','Greenville','Pitt',35.6111,-77.3731),('27836','NC','Greenville','Pitt',35.6658,-77.3367),('27837','NC','Grimesland','Pitt',35.54095,-77.205175),('27839','NC','Halifax','Halifax',36.309989,-77.592688),('27840','NC','Hamilton','Martin',35.947003,-77.210736),('27841','NC','Hassell','Martin',35.907604,-77.278655),('27842','NC','Henrico','Northampton',36.531014,-77.862885),('27843','NC','Hobgood','Halifax',36.011082,-77.409225),('27844','NC','Hollister','Halifax',36.25675,-77.939099),('27845','NC','Jackson','Northampton',36.385688,-77.423814),('27846','NC','Jamesville','Martin',35.759174,-76.894188),('27847','NC','Kelford','Bertie',36.178202,-77.201851),('27849','NC','Lewiston Woodville','Bertie',36.097695,-77.188551),('27850','NC','Littleton','Halifax',36.445056,-77.893007),('27851','NC','Lucama','Wilson',35.638338,-78.02109),('27852','NC','Macclesfield','Edgecombe',35.750459,-77.636931),('27853','NC','Margarettsville','Northampton',36.529525,-77.308796),('27854','NC','Milwaukee','Northampton',36.40519,-77.232422),('27855','NC','Murfreesboro','Hertford',36.436272,-77.096167),('27856','NC','Nashville','Nash',35.987488,-77.972666),('27857','NC','Oak City','Martin',35.962816,-77.289123),('27858','NC','Greenville','Pitt',35.580026,-77.33695),('27860','NC','Pantego','Beaufort',35.637173,-76.687857),('27861','NC','Parmele','Martin',35.815106,-77.315882),('27862','NC','Pendleton','Northampton',36.508072,-77.192201),('27863','NC','Pikeville','Wayne',35.487654,-77.981732),('27864','NC','Pinetops','Edgecombe',35.795752,-77.639641),('27865','NC','Pinetown','Beaufort',35.589832,-76.836651),('27866','NC','Pleasant Hill','Northampton',36.522279,-77.53275),('27867','NC','Potecasi','Northampton',36.363,-77.2394),('27868','NC','Red Oak','Nash',36.0383,-77.9066),('27869','NC','Rich Square','Northampton',36.275687,-77.297077),('27870','NC','Roanoke Rapids','Halifax',36.447861,-77.676899),('27871','NC','Robersonville','Martin',35.821058,-77.257344),('27872','NC','Roxobel','Bertie',36.202912,-77.23745),('27873','NC','Saratoga','Wilson',35.652171,-77.775621),('27874','NC','Scotland Neck','Halifax',36.124624,-77.417978),('27875','NC','Scranton','Hyde',35.455692,-76.491119),('27876','NC','Seaboard','Northampton',36.497468,-77.423326),('27877','NC','Severn','Northampton',36.515084,-77.184388),('27878','NC','Sharpsburg','Nash',35.867356,-77.830429),('27879','NC','Simpson','Pitt',35.573787,-77.27829),('27880','NC','Sims','Wilson',35.751556,-78.080737),('27881','NC','Speed','Edgecombe',35.969999,-77.444116),('27882','NC','Spring Hope','Nash',35.936475,-78.129652),('27883','NC','Stantonsburg','Wilson',35.600536,-77.803697),('27884','NC','Stokes','Pitt',35.70352,-77.266635),('27885','NC','Swanquarter','Hyde',35.422966,-76.279818),('27886','NC','Tarboro','Edgecombe',35.899234,-77.539551),('27887','NC','Tillery','Halifax',36.2516,-77.4858),('27888','NC','Walstonburg','Greene',35.59651,-77.697547),('27889','NC','Washington','Beaufort',35.564509,-77.035217),('27890','NC','Weldon','Halifax',36.422814,-77.60694),('27891','NC','Whitakers','Nash',36.10603,-77.741033),('27892','NC','Williamston','Martin',35.826018,-77.086625),('27893','NC','Wilson','Wilson',35.713783,-77.922093),('27894','NC','Wilson','Wilson',35.7211,-77.9158),('27895','NC','Wilson','Wilson',35.7211,-77.9158),('27896','NC','Wilson','Wilson',35.76788,-77.955206),('27897','NC','Woodland','Northampton',36.332189,-77.210794),('27906','NC','Elizabeth City','Pasquotank',36.3019,-76.2236),('27907','NC','Elizabeth City','Pasquotank',36.3019,-76.2236),('27909','NC','Elizabeth City','Pasquotank',36.294546,-76.245761),('27910','NC','Ahoskie','Hertford',36.293511,-76.987331),('27915','NC','Avon','Dare',35.355011,-75.504223),('27916','NC','Aydlett','Currituck',36.32541,-75.907728),('27917','NC','Barco','Currituck',36.387978,-75.982856),('27919','NC','Belvidere','Perquimans',36.319627,-76.496088),('27920','NC','Buxton','Dare',35.262752,-75.535278),('27921','NC','Camden','Camden',36.340448,-76.170758),('27922','NC','Cofield','Hertford',36.332029,-76.869118),('27923','NC','Coinjock','Currituck',36.372174,-75.941224),('27924','NC','Colerain','Bertie',36.1932,-76.835723),('27925','NC','Columbia','Tyrrell',35.886881,-76.229305),('27926','NC','Corapeake','Gates',36.522703,-76.617316),('27927','NC','Corolla','Currituck',36.419931,-75.837884),('27928','NC','Creswell','Washington',35.85846,-76.415424),('27929','NC','Currituck','Currituck',36.435452,-75.987038),('27930','NC','Durants Neck','Perquimans',36.157,-76.3163),('27932','NC','Edenton','Chowan',36.091055,-76.630067),('27935','NC','Eure','Gates',36.437072,-76.86329),('27936','NC','Frisco','Dare',35.238153,-75.601073),('27937','NC','Gates','Gates',36.508724,-76.788898),('27938','NC','Gatesville','Gates',36.395288,-76.723275),('27939','NC','Grandy','Currituck',36.242999,-75.873567),('27941','NC','Harbinger','Currituck',36.105013,-75.816213),('27942','NC','Harrellsville','Hertford',36.290169,-76.767952),('27943','NC','Hatteras','Dare',35.214521,-75.697771),('27944','NC','Hertford','Perquimans',36.15516,-76.425136),('27946','NC','Hobbsville','Gates',36.356269,-76.578156),('27947','NC','Jarvisburg','Currituck',36.186079,-75.865964),('27948','NC','Kill Devil Hills','Dare',36.022266,-75.677097),('27949','NC','Kitty Hawk','Dare',36.106063,-75.721733),('27950','NC','Knotts Island','Currituck',36.533449,-75.981552),('27953','NC','Manns Harbor','Dare',35.788386,-75.864065),('27954','NC','Manteo','Dare',35.908614,-75.675157),('27956','NC','Maple','Currituck',36.4015,-76.000575),('27957','NC','Merry Hill','Bertie',36.058781,-76.777972),('27958','NC','Moyock','Currituck',36.496208,-76.140413),('27959','NC','Nags Head','Dare',35.913846,-75.600752),('27960','NC','Ocracoke','Hyde',35.120328,-75.941826),('27962','NC','Plymouth','Washington',35.853013,-76.741405),('27964','NC','Point Harbor','Currituck',36.083046,-75.806214),('27965','NC','Poplar Branch','Currituck',36.286931,-75.908025),('27966','NC','Powells Point','Currituck',36.133434,-75.837906),('27967','NC','Powellsville','Bertie',36.225852,-76.927694),('27968','NC','Rodanthe','Dare',35.661916,-75.489352),('27969','NC','Roduco','Gates',36.4616,-76.8127),('27970','NC','Roper','Washington',35.901505,-76.592052),('27972','NC','Salvo','Dare',35.541834,-75.474419),('27973','NC','Shawboro','Currituck',36.373467,-76.072688),('27974','NC','Shiloh','Camden',36.237834,-76.040924),('27976','NC','South Mills','Camden',36.476273,-76.340697),('27978','NC','Stumpy Point','Dare',35.706885,-75.75635),('27979','NC','Sunbury','Gates',36.420755,-76.556706),('27980','NC','Tyner','Chowan',36.245352,-76.625618),('27981','NC','Wanchese','Dare',35.852855,-75.637424),('27982','NC','Waves','Dare',35.566411,-75.469533),('27983','NC','Windsor','Bertie',35.990579,-76.930611),('27985','NC','Winfall','Perquimans',36.21865,-76.464597),('27986','NC','Winton','Hertford',36.385251,-76.928825),('28001','NC','Albemarle','Stanly',35.349879,-80.198852),('28002','NC','Albemarle','Stanly',35.3542,-80.1902),('28006','NC','Alexis','Gaston',35.403709,-81.09997),('28007','NC','Ansonville','Anson',35.104508,-80.109269),('28009','NC','Badin','Stanly',35.405276,-80.11293),('28010','NC','Barium Springs','Iredell',35.7188,-80.8983),('28012','NC','Belmont','Gaston',35.233003,-81.038452),('28016','NC','Bessemer City','Gaston',35.291551,-81.283172),('28017','NC','Boiling Springs','Cleveland',35.246055,-81.667551),('28018','NC','Bostic','Rutherford',35.430127,-81.810166),('28019','NC','Caroleen','Rutherford',35.282911,-81.792467),('28020','NC','Casar','Cleveland',35.518616,-81.627234),('28021','NC','Cherryville','Gaston',35.38398,-81.393837),('28023','NC','China Grove','Rowan',35.565495,-80.590762),('28024','NC','Cliffside','Rutherford',35.238,-81.77),('28025','NC','Concord','Cabarrus',35.400175,-80.564291),('28026','NC','Concord','Cabarrus',35.4107,-80.5781),('28027','NC','Concord','Cabarrus',35.39837,-80.659774),('28031','NC','Cornelius','Mecklenburg',35.472851,-80.877312),('28032','NC','Cramerton','Gaston',35.239628,-81.076055),('28033','NC','Crouse','Lincoln',35.416403,-81.319191),('28034','NC','Dallas','Gaston',35.334969,-81.183988),('28035','NC','Davidson','Mecklenburg',35.5095,-80.8433),('28036','NC','Davidson','Mecklenburg',35.487397,-80.816708),('28037','NC','Denver','Lincoln',35.512489,-81.005899),('28038','NC','Earl','Cleveland',35.198687,-81.541626),('28039','NC','East Spencer','Rowan',35.681976,-80.435544),('28040','NC','Ellenboro','Rutherford',35.350991,-81.75448),('28041','NC','Faith','Rowan',35.6514,-80.5055),('28042','NC','Fallston','Cleveland',35.4288,-81.5016),('28043','NC','Forest City','Rutherford',35.318482,-81.869935),('28052','NC','Gastonia','Gaston',35.244749,-81.21567),('28053','NC','Gastonia','Gaston',35.2633,-81.1861),('28054','NC','Gastonia','Gaston',35.261637,-81.152953),('28055','NC','Gastonia','Gaston',35.2619,-81.1875),('28056','NC','Gastonia','Gaston',35.233561,-81.123975),('28070','NC','Huntersville','Mecklenburg',35.4181,-80.8679),('28071','NC','Gold Hill','Rowan',35.513721,-80.327332),('28072','NC','Granite Quarry','Rowan',35.614382,-80.444346),('28073','NC','Grover','Cleveland',35.188057,-81.480937),('28074','NC','Harris','Rutherford',35.2427,-81.875),('28075','NC','Harrisburg','Cabarrus',35.314358,-80.647476),('28076','NC','Henrietta','Rutherford',35.264016,-81.788077),('28077','NC','High Shoals','Gaston',35.402546,-81.202751),('28078','NC','Huntersville','Mecklenburg',35.411098,-80.862887),('28079','NC','Indian Trail','Union',35.084598,-80.628712),('28080','NC','Iron Station','Lincoln',35.458104,-81.121338),('28081','NC','Kannapolis','Cabarrus',35.498553,-80.645584),('28082','NC','Kannapolis','Cabarrus',35.4957,-80.6282),('28083','NC','Kannapolis','Cabarrus',35.493888,-80.600767),('28086','NC','Kings Mountain','Cleveland',35.241811,-81.356443),('28088','NC','Landis','Rowan',35.543851,-80.61171),('28089','NC','Lattimore','Cleveland',35.318099,-81.661225),('28090','NC','Lawndale','Cleveland',35.454659,-81.559555),('28091','NC','Lilesville','Anson',34.967976,-79.938449),('28092','NC','Lincolnton','Lincoln',35.475755,-81.24043),('28093','NC','Lincolnton','Lincoln',35.4718,-81.255),('28097','NC','Locust','Stanly',35.277843,-80.415787),('28098','NC','Lowell','Gaston',35.268618,-81.0978),('28101','NC','Mc Adenville','Gaston',35.258652,-81.078101),('28102','NC','Mc Farlan','Anson',34.812448,-79.973112),('28103','NC','Marshville','Union',34.99607,-80.35711),('28104','NC','Matthews','Union',35.069036,-80.690661),('28105','NC','Matthews','Mecklenburg',35.115655,-80.714143),('28106','NC','Matthews','Mecklenburg',35.1151,-80.7218),('28107','NC','Midland','Cabarrus',35.242976,-80.518715),('28108','NC','Mineral Springs','Union',34.934781,-80.681183),('28109','NC','Misenheimer','Stanly',35.484369,-80.287103),('28110','NC','Monroe','Union',35.035353,-80.555463),('28111','NC','Monroe','Union',34.8881,-80.5068),('28112','NC','Monroe','Union',34.943242,-80.544629),('28114','NC','Mooresboro','Rutherford',35.238653,-81.753167),('28115','NC','Mooresville','Iredell',35.577342,-80.801833),('28117','NC','Mooresville','Iredell',35.57961,-80.879702),('28119','NC','Morven','Anson',34.847119,-80.01438),('28120','NC','Mount Holly','Gaston',35.318007,-81.019326),('28123','NC','Mount Mourne','Iredell',35.543,-80.8475),('28124','NC','Mount Pleasant','Cabarrus',35.393211,-80.422365),('28125','NC','Mount Ulla','Rowan',35.666209,-80.714447),('28126','NC','Newell','Mecklenburg',35.2794,-80.7358),('28127','NC','New London','Stanly',35.462786,-80.165467),('28128','NC','Norwood','Stanly',35.229429,-80.144917),('28129','NC','Oakboro','Stanly',35.234845,-80.335917),('28130','NC','Paw Creek','Mecklenburg',35.2747,-80.9386),('28133','NC','Peachland','Anson',34.969373,-80.269875),('28134','NC','Pineville','Mecklenburg',35.082655,-80.884857),('28135','NC','Polkton','Anson',35.041611,-80.206637),('28136','NC','Polkville','Cleveland',35.4175,-81.643),('28137','NC','Richfield','Stanly',35.493441,-80.255562),('28138','NC','Rockwell','Rowan',35.535271,-80.42668),('28139','NC','Rutherfordton','Rutherford',35.356893,-81.977375),('28144','NC','Salisbury','Rowan',35.682065,-80.463741),('28145','NC','Salisbury','Rowan',35.6624,-80.4648),('28146','NC','Salisbury','Rowan',35.613308,-80.428459),('28147','NC','Salisbury','Rowan',35.667031,-80.544737),('28150','NC','Shelby','Cleveland',35.314062,-81.556726),('28151','NC','Shelby','Cleveland',35.3666,-81.5964),('28152','NC','Shelby','Cleveland',35.253756,-81.577768),('28159','NC','Spencer','Rowan',35.692751,-80.434481),('28160','NC','Spindale','Rutherford',35.360671,-81.925436),('28163','NC','Stanfield','Stanly',35.221973,-80.422389),('28164','NC','Stanley','Gaston',35.381835,-81.056076),('28166','NC','Troutman','Iredell',35.677047,-80.890012),('28167','NC','Union Mills','Rutherford',35.494885,-81.956536),('28168','NC','Vale','Lincoln',35.547137,-81.431375),('28169','NC','Waco','Cleveland',35.361006,-81.42843),('28170','NC','Wadesboro','Anson',34.991752,-80.085877),('28173','NC','Waxhaw','Union',34.947423,-80.743933),('28174','NC','Wingate','Union',34.981541,-80.443149),('28201','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28202','NC','Charlotte','Mecklenburg',35.228062,-80.843056),('28203','NC','Charlotte','Mecklenburg',35.209957,-80.856511),('28204','NC','Charlotte','Mecklenburg',35.214833,-80.826604),('28205','NC','Charlotte','Mecklenburg',35.227408,-80.79304),('28206','NC','Charlotte','Mecklenburg',35.250983,-80.825605),('28207','NC','Charlotte','Mecklenburg',35.197787,-80.827291),('28208','NC','Charlotte','Mecklenburg',35.235895,-80.892923),('28209','NC','Charlotte','Mecklenburg',35.178714,-80.853985),('28210','NC','Charlotte','Mecklenburg',35.134767,-80.856566),('28211','NC','Charlotte','Mecklenburg',35.170905,-80.793828),('28212','NC','Charlotte','Mecklenburg',35.187772,-80.744584),('28213','NC','Charlotte','Mecklenburg',35.284041,-80.737848),('28214','NC','Charlotte','Mecklenburg',35.280466,-80.96606),('28215','NC','Charlotte','Mecklenburg',35.246544,-80.708222),('28216','NC','Charlotte','Mecklenburg',35.296491,-80.879112),('28217','NC','Charlotte','Mecklenburg',35.171107,-80.901062),('28218','NC','Charlotte','Mecklenburg',35.1985,-80.7893),('28219','NC','Charlotte','Mecklenburg',35.2063,-80.9419),('28220','NC','Charlotte','Mecklenburg',35.1755,-80.851),('28221','NC','Charlotte','Mecklenburg',35.2967,-80.7998),('28222','NC','Charlotte','Mecklenburg',35.1663,-80.7959),('28223','NC','Charlotte','Mecklenburg',35.305552,-80.733034),('28224','NC','Charlotte','Mecklenburg',35.1503,-80.8763),('28226','NC','Charlotte','Mecklenburg',35.10888,-80.81753),('28227','NC','Charlotte','Mecklenburg',35.188086,-80.659419),('28228','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28229','NC','Charlotte','Mecklenburg',35.2027,-80.7346),('28230','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28231','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28232','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28233','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28234','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28235','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28236','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28237','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28241','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28242','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28243','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28244','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28246','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28247','NC','Charlotte','Mecklenburg',35.1034,-80.825),('28250','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28253','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28254','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28255','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28256','NC','Charlotte','Mecklenburg',35.2802,-80.7656),('28258','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28260','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28262','NC','Charlotte','Mecklenburg',35.325657,-80.738942),('28263','NC','Charlotte','Mecklenburg',35.2281,-80.8438),('28265','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28266','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28269','NC','Charlotte','Mecklenburg',35.334106,-80.801327),('28270','NC','Charlotte','Mecklenburg',35.107901,-80.761071),('28271','NC','Charlotte','Mecklenburg',35.2267,-80.8434),('28272','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28273','NC','Charlotte','Mecklenburg',35.126911,-80.940619),('28274','NC','Charlotte','Mecklenburg',35.1873,-80.8298),('28275','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28277','NC','Charlotte','Mecklenburg',35.049722,-80.818268),('28278','NC','Charlotte','Mecklenburg',35.132606,-80.997072),('28280','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28281','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28282','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28284','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28285','NC','Charlotte','Mecklenburg',35.223,-80.8308),('28287','NC','Charlotte','Mecklenburg',35.15,-80.84),('28288','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28289','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28290','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28296','NC','Charlotte','Mecklenburg',35.2269,-80.8433),('28297','NC','Charlotte','Mecklenburg',35.2762,-80.8558),('28299','NC','Charlotte','Mecklenburg',35.2189,-80.8122),('28301','NC','Fayetteville','Cumberland',35.067257,-78.884728),('28302','NC','Fayetteville','Cumberland',34.9677,-78.7392),('28303','NC','Fayetteville','Cumberland',35.084085,-78.953245),('28304','NC','Fayetteville','Cumberland',35.027454,-78.973088),('28305','NC','Fayetteville','Cumberland',35.056388,-78.903877),('28306','NC','Fayetteville','Cumberland',34.99994,-78.933072),('28307','NC','Fort Bragg','Cumberland',35.143922,-78.987692),('28308','NC','Pope A F B','Cumberland',35.17155,-79.017085),('28309','NC','Fayetteville','Cumberland',35.0554,-78.8777),('28310','NC','Fort Bragg','Cumberland',35.146466,-79.027098),('28311','NC','Fayetteville','Cumberland',35.132579,-78.890401),('28312','NC','Fayetteville','Cumberland',35.024216,-78.795486),('28314','NC','Fayetteville','Cumberland',35.059952,-79.008761),('28315','NC','Aberdeen','Moore',35.127068,-79.431455),('28318','NC','Autryville','Sampson',35.026077,-78.619985),('28319','NC','Barnesville','Robeson',34.4086,-79.0469),('28320','NC','Bladenboro','Bladen',34.549333,-78.778343),('28323','NC','Bunnlevel','Harnett',35.313935,-78.848435),('28325','NC','Calypso','Duplin',35.152421,-78.104648),('28326','NC','Cameron','Harnett',35.29117,-79.192496),('28327','NC','Carthage','Moore',35.314082,-79.398966),('28328','NC','Clinton','Sampson',34.99932,-78.331076),('28329','NC','Clinton','Sampson',34.9958,-78.3256),('28330','NC','Cordova','Richmond',34.913517,-79.823326),('28331','NC','Cumberland','Cumberland',35.0047,-78.9675),('28332','NC','Dublin','Bladen',34.656037,-78.72509),('28333','NC','Dudley','Wayne',35.294895,-78.024864),('28334','NC','Dunn','Harnett',35.301228,-78.599363),('28335','NC','Dunn','Harnett',35.3061,-78.6091),('28337','NC','Elizabethtown','Bladen',34.635611,-78.583397),('28338','NC','Ellerbe','Richmond',35.091513,-79.761909),('28339','NC','Erwin','Harnett',35.328901,-78.690415),('28340','NC','Fairmont','Robeson',34.478063,-79.128481),('28341','NC','Faison','Duplin',35.113192,-78.161552),('28342','NC','Falcon','Cumberland',35.191183,-78.651262),('28343','NC','Gibson','Scotland',34.763093,-79.597624),('28344','NC','Godwin','Sampson',35.172188,-78.638143),('28345','NC','Hamlet','Richmond',34.883849,-79.69672),('28347','NC','Hoffman','Richmond',35.034685,-79.55227),('28348','NC','Hope Mills','Cumberland',34.953578,-78.936151),('28349','NC','Kenansville','Duplin',34.966229,-77.943678),('28350','NC','Lakeview','Moore',35.243601,-79.309304),('28351','NC','Laurel Hill','Scotland',34.828398,-79.562685),('28352','NC','Laurinburg','Scotland',34.769871,-79.46265),('28353','NC','Laurinburg','Scotland',34.7738,-79.463),('28355','NC','Lemon Springs','Lee',35.3894,-79.1947),('28356','NC','Linden','Cumberland',35.23958,-78.795349),('28357','NC','Lumber Bridge','Robeson',34.903265,-79.077841),('28358','NC','Lumberton','Robeson',34.620775,-78.988269),('28359','NC','Lumberton','Robeson',34.6213,-79.0044),('28360','NC','Lumberton','Robeson',34.666399,-79.055754),('28362','NC','Marietta','Robeson',34.368246,-79.121245),('28363','NC','Marston','Scotland',34.948887,-79.525986),('28364','NC','Maxton','Robeson',34.73742,-79.322682),('28365','NC','Mount Olive','Wayne',35.172565,-78.052357),('28366','NC','Newton Grove','Sampson',35.237002,-78.365088),('28367','NC','Norman','Richmond',35.171137,-79.723291),('28368','NC','Olivia','Harnett',35.35149,-79.105865),('28369','NC','Orrum','Robeson',34.434619,-79.036742),('28370','NC','Pinehurst','Moore',35.1897,-79.4714),('28371','NC','Parkton','Robeson',34.91166,-78.999589),('28372','NC','Pembroke','Robeson',34.688602,-79.185823),('28373','NC','Pinebluff','Moore',35.100666,-79.476372),('28374','NC','Pinehurst','Moore',35.19738,-79.461782),('28375','NC','Proctorville','Robeson',34.475767,-79.036572),('28376','NC','Raeford','Hoke',34.99437,-79.215448),('28377','NC','Red Springs','Robeson',34.833668,-79.203505),('28378','NC','Rex','Robeson',34.858715,-79.047053),('28379','NC','Rockingham','Richmond',34.93376,-79.772913),('28380','NC','Rockingham','Richmond',34.9389,-79.774),('28382','NC','Roseboro','Sampson',34.976974,-78.508122),('28383','NC','Rowland','Robeson',34.570703,-79.274385),('28384','NC','Saint Pauls','Robeson',34.802343,-78.965112),('28385','NC','Salemburg','Sampson',35.032532,-78.500934),('28386','NC','Shannon','Robeson',34.852234,-79.125493),('28387','NC','Southern Pines','Moore',35.177014,-79.393863),('28388','NC','Southern Pines','Moore',35.1738,-79.3925),('28390','NC','Spring Lake','Harnett',35.196482,-78.963992),('28391','NC','Stedman','Cumberland',35.021629,-78.698798),('28392','NC','Tar Heel','Bladen',34.738795,-78.799479),('28393','NC','Turkey','Sampson',34.989099,-78.184161),('28394','NC','Vass','Moore',35.217456,-79.241537),('28395','NC','Wade','Cumberland',35.141565,-78.74812),('28396','NC','Wagram','Scotland',34.914519,-79.397486),('28398','NC','Warsaw','Duplin',34.992914,-78.080361),('28399','NC','White Oak','Bladen',34.776143,-78.736741),('28401','NC','Wilmington','New Hanover',34.231628,-77.939855),('28402','NC','Wilmington','New Hanover',34.237,-77.9495),('28403','NC','Wilmington','New Hanover',34.222079,-77.886908),('28404','NC','Wilmington','Brunswick',34.2251,-77.9377),('28405','NC','Wilmington','New Hanover',34.256002,-77.870059),('28406','NC','Wilmington','New Hanover',34.237,-77.9495),('28407','NC','Wilmington','New Hanover',34.1569,-77.8925),('28408','NC','Wilmington','New Hanover',34.1279,-77.8991),('28409','NC','Wilmington','New Hanover',34.158127,-77.873415),('28410','NC','Wilmington','New Hanover',34.1388,-77.9168),('28411','NC','Wilmington','New Hanover',34.288595,-77.800539),('28412','NC','Wilmington','New Hanover',34.156666,-77.912427),('28420','NC','Ash','Brunswick',34.092344,-78.452655),('28421','NC','Atkinson','Pender',34.524109,-78.185835),('28422','NC','Bolivia','Brunswick',34.00451,-78.180668),('28423','NC','Bolton','Columbus',34.318847,-78.377003),('28424','NC','Brunswick','Columbus',34.288167,-78.699694),('28425','NC','Burgaw','Pender',34.551084,-77.924343),('28428','NC','Carolina Beach','New Hanover',34.034325,-77.898979),('28429','NC','Castle Hayne','New Hanover',34.338849,-77.9017),('28430','NC','Cerro Gordo','Columbus',34.298167,-78.92451),('28431','NC','Chadbourn','Columbus',34.310639,-78.829952),('28432','NC','Clarendon','Columbus',34.183943,-78.791329),('28433','NC','Clarkton','Bladen',34.489319,-78.63479),('28434','NC','Council','Bladen',34.445699,-78.46065),('28435','NC','Currie','Pender',34.41708,-78.088834),('28436','NC','Delco','Columbus',34.285066,-78.247515),('28438','NC','Evergreen','Columbus',34.42932,-78.917997),('28439','NC','Fair Bluff','Columbus',34.30695,-79.020915),('28441','NC','Garland','Sampson',34.78427,-78.408148),('28442','NC','Hallsboro','Columbus',34.319876,-78.595834),('28443','NC','Hampstead','Pender',34.415837,-77.642893),('28444','NC','Harrells','Sampson',34.688156,-78.320109),('28445','NC','Holly Ridge','Onslow',34.447654,-77.560592),('28447','NC','Ivanhoe','Sampson',34.59469,-78.235716),('28448','NC','Kelly','Bladen',34.46062,-78.291045),('28449','NC','Kure Beach','New Hanover',33.989916,-77.911805),('28450','NC','Lake Waccamaw','Columbus',34.32466,-78.515299),('28451','NC','Leland','Brunswick',34.24284,-78.065429),('28452','NC','Longwood','Brunswick',34.007921,-78.548088),('28453','NC','Magnolia','Duplin',34.88929,-78.061987),('28454','NC','Maple Hill','Onslow',34.666312,-77.622329),('28455','NC','Nakina','Columbus',34.101304,-78.639),('28456','NC','Riegelwood','Columbus',34.365591,-78.271859),('28457','NC','Rocky Point','Pender',34.443357,-77.901528),('28458','NC','Rose Hill','Duplin',34.82516,-78.036194),('28459','NC','Shallotte','Brunswick',33.9465,-78.4123),('28460','NC','Sneads Ferry','Onslow',34.522233,-77.422017),('28461','NC','Southport','Brunswick',33.958903,-78.037515),('28462','NC','Supply','Brunswick',33.955816,-78.297692),('28463','NC','Tabor City','Columbus',34.133188,-78.836416),('28464','NC','Teachey','Duplin',34.775313,-78.003591),('28465','NC','Oak Island','Brunswick',33.915529,-78.128229),('28466','NC','Wallace','Duplin',34.744145,-77.962859),('28467','NC','Calabash','Brunswick',33.907949,-78.57311),('28468','NC','Sunset Beach','Brunswick',33.887149,-78.516035),('28469','NC','Ocean Isle Beach','Brunswick',33.906321,-78.455236),('28470','NC','Shallotte','Brunswick',33.955205,-78.385973),('28472','NC','Whiteville','Columbus',34.316786,-78.708204),('28478','NC','Willard','Pender',34.647803,-78.035903),('28479','NC','Winnabow','Brunswick',34.083405,-78.020041),('28480','NC','Wrightsville Beach','New Hanover',34.214753,-77.800506),('28501','NC','Kinston','Lenoir',35.262155,-77.563638),('28502','NC','Kinston','Lenoir',35.2599,-77.5795),('28503','NC','Kinston','Lenoir',35.2599,-77.5795),('28504','NC','Kinston','Lenoir',35.263305,-77.624025),('28508','NC','Albertson','Duplin',35.099668,-77.824788),('28509','NC','Alliance','Pamlico',35.1447,-76.8025),('28510','NC','Arapahoe','Pamlico',34.99198,-76.814031),('28511','NC','Atlantic','Carteret',34.888249,-76.341399),('28512','NC','Atlantic Beach','Carteret',34.702533,-76.767192),('28513','NC','Ayden','Pitt',35.45837,-77.416042),('28515','NC','Bayboro','Pamlico',35.168015,-76.717128),('28516','NC','Beaufort','Carteret',34.820159,-76.600244),('28518','NC','Beulaville','Duplin',34.908227,-77.764665),('28519','NC','Bridgeton','Craven',35.122656,-77.021698),('28520','NC','Cedar Island','Carteret',34.972477,-76.294113),('28521','NC','Chinquapin','Duplin',34.820721,-77.758324),('28522','NC','Comfort','Jones',35.0055,-77.4883),('28523','NC','Cove City','Craven',35.192203,-77.319334),('28524','NC','Davis','Carteret',34.79445,-76.463848),('28525','NC','Deep Run','Lenoir',35.132385,-77.687054),('28526','NC','Dover','Craven',35.242214,-77.425102),('28527','NC','Ernul','Craven',35.259504,-77.015065),('28528','NC','Gloucester','Carteret',34.732058,-76.538662),('28529','NC','Grantsboro','Pamlico',35.099905,-76.853979),('28530','NC','Grifton','Pitt',35.371048,-77.426506),('28531','NC','Harkers Island','Carteret',34.698499,-76.554761),('28532','NC','Havelock','Craven',34.899751,-76.891077),('28533','NC','Cherry Point','Craven',34.901925,-76.900859),('28537','NC','Hobucken','Pamlico',35.244698,-76.549397),('28538','NC','Hookerton','Greene',35.415123,-77.580262),('28539','NC','Hubert','Onslow',34.68894,-77.206296),('28540','NC','Jacksonville','Onslow',34.754574,-77.461976),('28541','NC','Jacksonville','Onslow',34.6689,-77.2389),('28542','NC','Camp Lejeune','Onslow',34.6459,-77.3231),('28543','NC','Tarawa Terrace','Onslow',34.736034,-77.376625),('28544','NC','Midway Park','Onslow',34.727716,-77.325372),('28545','NC','Mccutcheon Field','Onslow',34.7157,-77.4501),('28546','NC','Jacksonville','Onslow',34.779642,-77.380142),('28547','NC','Camp Lejeune','Onslow',34.677942,-77.370387),('28551','NC','La Grange','Lenoir',35.317197,-77.786172),('28552','NC','Lowland','Pamlico',35.29632,-76.556727),('28553','NC','Marshallberg','Carteret',34.72635,-76.516134),('28554','NC','Maury','Greene',35.479344,-77.585536),('28555','NC','Maysville','Onslow',34.881907,-77.225658),('28556','NC','Merritt','Pamlico',35.139926,-76.654829),('28557','NC','Morehead City','Carteret',34.731421,-76.753799),('28560','NC','New Bern','Craven',35.107928,-77.017044),('28561','NC','New Bern','Craven',35.0456,-77.057),('28562','NC','New Bern','Craven',35.086977,-77.09744),('28563','NC','New Bern','Craven',35.102,-77.0994),('28564','NC','New Bern','Craven',35.102,-77.0994),('28570','NC','Newport','Carteret',34.770714,-76.879156),('28571','NC','Oriental','Pamlico',35.040257,-76.697959),('28572','NC','Pink Hill','Duplin',35.027895,-77.736417),('28573','NC','Pollocksville','Jones',35.010087,-77.215223),('28574','NC','Richlands','Onslow',34.886904,-77.576775),('28575','NC','Salter Path','Carteret',34.688017,-76.892349),('28577','NC','Sealevel','Carteret',34.869873,-76.38379),('28578','NC','Seven Springs','Wayne',35.195136,-77.856973),('28579','NC','Smyrna','Carteret',34.754331,-76.515603),('28580','NC','Snow Hill','Greene',35.445259,-77.687066),('28581','NC','Stacy','Carteret',34.845644,-76.41493),('28582','NC','Stella','Onslow',34.770507,-77.153721),('28583','NC','Stonewall','Pamlico',35.13718,-76.747074),('28584','NC','Swansboro','Carteret',34.702125,-77.092694),('28585','NC','Trenton','Jones',35.072912,-77.408913),('28586','NC','Vanceboro','Craven',35.300562,-77.153865),('28587','NC','Vandemere','Pamlico',35.186789,-76.666791),('28589','NC','Williston','Carteret',34.800961,-76.49182),('28590','NC','Winterville','Pitt',35.536252,-77.399477),('28594','NC','Emerald Isle','Carteret',34.667428,-77.015119),('28601','NC','Hickory','Catawba',35.762643,-81.325625),('28602','NC','Hickory','Catawba',35.702227,-81.356185),('28603','NC','Hickory','Catawba',35.733,-81.3413),('28604','NC','Banner Elk','Watauga',36.17046,-81.847339),('28605','NC','Blowing Rock','Watauga',36.135304,-81.685167),('28606','NC','Boomer','Wilkes',36.069299,-81.299902),('28607','NC','Boone','Watauga',36.219531,-81.6602),('28608','NC','Boone','Watauga',36.2141,-81.6787),('28609','NC','Catawba','Catawba',35.695351,-81.060387),('28610','NC','Claremont','Catawba',35.725356,-81.142728),('28611','NC','Collettsville','Caldwell',36.012764,-81.740233),('28612','NC','Connellys Springs','Burke',35.712155,-81.504055),('28613','NC','Conover','Catawba',35.723409,-81.213476),('28615','NC','Creston','Ashe',36.456065,-81.652231),('28616','NC','Crossnore','Avery',36.025757,-81.924402),('28617','NC','Crumpler','Ashe',36.49032,-81.3861),('28618','NC','Deep Gap','Watauga',36.208311,-81.516919),('28619','NC','Drexel','Burke',35.755017,-81.6041),('28621','NC','Elkin','Surry',36.278862,-80.84239),('28622','NC','Elk Park','Avery',36.174981,-81.952645),('28623','NC','Ennice','Alleghany',36.534916,-80.970911),('28624','NC','Ferguson','Wilkes',36.128228,-81.410888),('28625','NC','Statesville','Iredell',35.840543,-80.879695),('28626','NC','Fleetwood','Ashe',36.292547,-81.517798),('28627','NC','Glade Valley','Alleghany',36.452099,-81.021337),('28628','NC','Glen Alpine','Burke',35.727838,-81.782384),('28629','NC','Glendale Springs','Ashe',36.338736,-81.373742),('28630','NC','Granite Falls','Caldwell',35.810459,-81.430762),('28631','NC','Grassy Creek','Ashe',36.56059,-81.386395),('28633','NC','Lenoir','Caldwell',35.977,-81.5287),('28634','NC','Harmony','Iredell',35.975732,-80.773069),('28635','NC','Hays','Wilkes',36.29786,-81.127786),('28636','NC','Hiddenite','Alexander',35.931384,-81.064571),('28637','NC','Hildebran','Burke',35.718051,-81.419066),('28638','NC','Hudson','Caldwell',35.839117,-81.486861),('28640','NC','Jefferson','Ashe',36.406041,-81.423898),('28641','NC','Jonas Ridge','Burke',35.9725,-81.895),('28642','NC','Jonesville','Yadkin',36.228858,-80.826284),('28643','NC','Lansing','Ashe',36.523276,-81.526729),('28644','NC','Laurel Springs','Alleghany',36.426213,-81.27798),('28645','NC','Lenoir','Caldwell',35.934604,-81.544228),('28646','NC','Linville','Avery',36.078143,-81.857968),('28647','NC','Linville Falls','Avery',35.955837,-81.954517),('28649','NC','Mc Grady','Wilkes',36.325716,-81.196635),('28650','NC','Maiden','Catawba',35.571094,-81.18078),('28651','NC','Millers Creek','Wilkes',36.241898,-81.267016),('28652','NC','Minneapolis','Avery',36.09926,-81.980585),('28653','NC','Montezuma','Avery',36.065,-81.9027),('28654','NC','Moravian Falls','Wilkes',36.067653,-81.1721),('28655','NC','Morganton','Burke',35.734617,-81.714188),('28656','NC','North Wilkesboro','Wilkes',36.1583,-81.1477),('28657','NC','Newland','Avery',36.041435,-81.933558),('28658','NC','Newton','Catawba',35.650067,-81.239719),('28659','NC','North Wilkesboro','Wilkes',36.167103,-81.111634),('28660','NC','Olin','Iredell',35.971218,-80.864432),('28661','NC','Patterson','Caldwell',35.9991,-81.5641),('28662','NC','Pineola','Avery',36.025048,-81.894201),('28663','NC','Piney Creek','Alleghany',36.542644,-81.318087),('28664','NC','Plumtree','Avery',36.0269,-82.008),('28665','NC','Purlear','Wilkes',36.210025,-81.364045),('28666','NC','Icard','Burke',35.72338,-81.470739),('28667','NC','Rhodhiss','Caldwell',35.773852,-81.430077),('28668','NC','Roaring Gap','Alleghany',36.400372,-80.997965),('28669','NC','Roaring River','Wilkes',36.223084,-80.987824),('28670','NC','Ronda','Wilkes',36.208189,-80.927283),('28671','NC','Rutherford College','Burke',35.752244,-81.531821),('28672','NC','Scottville','Ashe',36.483566,-81.331343),('28673','NC','Sherrills Ford','Catawba',35.598377,-80.996336),('28674','NC','North Wilkesboro','Wilkes',36.1583,-81.1477),('28675','NC','Sparta','Alleghany',36.504495,-81.126646),('28676','NC','State Road','Surry',36.326366,-80.860832),('28677','NC','Statesville','Iredell',35.765881,-80.899625),('28678','NC','Stony Point','Alexander',35.847822,-81.050485),('28679','NC','Sugar Grove','Watauga',36.255536,-81.830147),('28680','NC','Morganton','Burke',35.7452,-81.685),('28681','NC','Taylorsville','Alexander',35.91214,-81.209936),('28682','NC','Terrell','Catawba',35.585668,-80.963076),('28683','NC','Thurmond','Surry',36.379131,-80.916477),('28684','NC','Todd','Ashe',36.320509,-81.611573),('28685','NC','Traphill','Wilkes',36.348741,-81.049785),('28687','NC','Statesville','Iredell',35.7825,-80.8875),('28688','NC','Turnersburg','Iredell',35.8567,-80.8583),('28689','NC','Union Grove','Iredell',36.046216,-80.927386),('28690','NC','Valdese','Burke',35.740953,-81.570917),('28691','NC','Valle Crucis','Watauga',36.2207,-81.9046),('28692','NC','Vilas','Watauga',36.260726,-81.771882),('28693','NC','Warrensville','Ashe',36.470629,-81.53552),('28694','NC','West Jefferson','Ashe',36.37139,-81.475825),('28697','NC','Wilkesboro','Wilkes',36.137967,-81.180148),('28698','NC','Zionville','Watauga',36.325692,-81.745919),('28699','NC','Scotts','Iredell',35.8427,-81.0094),('28701','NC','Alexander','Buncombe',35.705098,-82.636467),('28702','NC','Almond','Graham',35.390116,-83.600548),('28704','NC','Arden','Buncombe',35.466302,-82.543274),('28705','NC','Bakersville','Mitchell',36.020532,-82.15976),('28707','NC','Balsam','Jackson',35.408836,-83.07145),('28708','NC','Balsam Grove','Transylvania',35.257335,-82.857261),('28709','NC','Barnardsville','Buncombe',35.767147,-82.424622),('28710','NC','Bat Cave','Henderson',35.464897,-82.283074),('28711','NC','Black Mountain','Buncombe',35.602478,-82.308121),('28712','NC','Brevard','Transylvania',35.193702,-82.746866),('28713','NC','Bryson City','Swain',35.398116,-83.475846),('28714','NC','Burnsville','Yancey',35.902494,-82.299538),('28715','NC','Candler','Buncombe',35.53305,-82.698949),('28716','NC','Canton','Haywood',35.503801,-82.841929),('28717','NC','Cashiers','Jackson',35.10619,-83.106421),('28718','NC','Cedar Mountain','Transylvania',35.15437,-82.62725),('28719','NC','Cherokee','Swain',35.495168,-83.294216),('28720','NC','Chimney Rock','Rutherford',35.439746,-82.247421),('28721','NC','Clyde','Haywood',35.595598,-82.935918),('28722','NC','Columbus','Polk',35.248557,-82.175275),('28723','NC','Cullowhee','Jackson',35.259882,-83.158514),('28724','NC','Dana','Henderson',35.3291,-82.3755),('28725','NC','Dillsboro','Jackson',35.36855,-83.253213),('28726','NC','East Flat Rock','Henderson',35.281539,-82.419992),('28727','NC','Edneyville','Henderson',35.392,-82.3424),('28728','NC','Enka','Buncombe',35.5497,-82.6502),('28729','NC','Etowah','Henderson',35.319122,-82.604014),('28730','NC','Fairview','Buncombe',35.5262,-82.376123),('28731','NC','Flat Rock','Henderson',35.285,-82.407229),('28732','NC','Fletcher','Henderson',35.437662,-82.490208),('28733','NC','Fontana Dam','Graham',35.441012,-83.811708),('28734','NC','Franklin','Macon',35.186335,-83.394194),('28735','NC','Gerton','Henderson',35.478638,-82.348715),('28736','NC','Glenville','Jackson',35.18702,-83.100177),('28737','NC','Glenwood','Mcdowell',35.6812,-82.0084),('28738','NC','Hazelwood','Haywood',35.4768,-83.0082),('28739','NC','Hendersonville','Henderson',35.289906,-82.509732),('28740','NC','Green Mountain','Yancey',36.033714,-82.28068),('28741','NC','Highlands','Macon',35.066707,-83.205098),('28742','NC','Horse Shoe','Henderson',35.344186,-82.601384),('28743','NC','Hot Springs','Madison',35.829177,-82.872698),('28744','NC','Franklin','Macon',35.1807,-83.3801),('28745','NC','Lake Junaluska','Haywood',35.529987,-82.969999),('28746','NC','Lake Lure','Rutherford',35.445006,-82.18185),('28747','NC','Lake Toxaway','Transylvania',35.145941,-82.922794),('28748','NC','Leicester','Buncombe',35.653713,-82.737541),('28749','NC','Little Switzerland','Mcdowell',35.849571,-82.087391),('28750','NC','Lynn','Polk',35.2283,-82.2347),('28751','NC','Maggie Valley','Haywood',35.515886,-83.091818),('28752','NC','Marion','Mcdowell',35.693712,-82.011435),('28753','NC','Marshall','Madison',35.842603,-82.689093),('28754','NC','Mars Hill','Madison',35.864295,-82.523231),('28755','NC','Micaville','Yancey',35.909707,-82.213959),('28756','NC','Mill Spring','Polk',35.34472,-82.180388),('28757','NC','Montreat','Buncombe',35.643573,-82.308649),('28758','NC','Mountain Home','Henderson',35.37094,-82.494506),('28759','NC','Mills River','Henderson',35.381462,-82.588562),('28760','NC','Naples','Henderson',35.3925,-82.5008),('28761','NC','Nebo','Mcdowell',35.690291,-81.906875),('28762','NC','Old Fort','Mcdowell',35.624595,-82.17716),('28763','NC','Otto','Macon',35.051642,-83.396611),('28765','NC','Penland','Mitchell',35.931539,-82.110721),('28766','NC','Penrose','Transylvania',35.249022,-82.618229),('28768','NC','Pisgah Forest','Transylvania',35.274023,-82.684136),('28770','NC','Ridgecrest','Buncombe',35.6205,-82.2827),('28771','NC','Robbinsville','Graham',35.348628,-83.815613),('28772','NC','Rosman','Transylvania',35.128979,-82.827224),('28773','NC','Saluda','Polk',35.240222,-82.339091),('28774','NC','Sapphire','Transylvania',35.117484,-83.007199),('28775','NC','Scaly Mountain','Macon',35.021346,-83.321736),('28776','NC','Skyland','Buncombe',35.4891,-82.5244),('28777','NC','Spruce Pine','Mitchell',35.899538,-82.07186),('28778','NC','Swannanoa','Buncombe',35.602433,-82.402152),('28779','NC','Sylva','Jackson',35.366951,-83.201008),('28781','NC','Topton','Macon',35.224512,-83.655627),('28782','NC','Tryon','Polk',35.221881,-82.203149),('28783','NC','Tuckasegee','Jackson',35.2516,-83.039313),('28784','NC','Tuxedo','Henderson',35.219796,-82.431862),('28785','NC','Waynesville','Haywood',35.576069,-83.010541),('28786','NC','Waynesville','Haywood',35.483635,-82.992454),('28787','NC','Weaverville','Buncombe',35.724414,-82.551219),('28788','NC','Webster','Jackson',35.3461,-83.2194),('28789','NC','Whittier','Jackson',35.413514,-83.325879),('28790','NC','Zirconia','Henderson',35.211889,-82.450463),('28791','NC','Hendersonville','Henderson',35.345242,-82.497077),('28792','NC','Hendersonville','Henderson',35.356525,-82.415656),('28793','NC','Hendersonville','Henderson',35.3174,-82.4644),('28801','NC','Asheville','Buncombe',35.596669,-82.556833),('28802','NC','Asheville','Buncombe',35.594,-82.5554),('28803','NC','Asheville','Buncombe',35.540543,-82.522821),('28804','NC','Asheville','Buncombe',35.63854,-82.564658),('28805','NC','Asheville','Buncombe',35.597054,-82.495553),('28806','NC','Asheville','Buncombe',35.574295,-82.604393),('28810','NC','Asheville','Buncombe',35.6008,-82.5541),('28813','NC','Asheville','Buncombe',35.5439,-82.5335),('28814','NC','Asheville','Buncombe',35.6237,-82.5545),('28815','NC','Asheville','Buncombe',35.6008,-82.5541),('28816','NC','Asheville','Buncombe',35.5835,-82.6048),('28901','NC','Andrews','Cherokee',35.200268,-83.817373),('28902','NC','Brasstown','Clay',35.023307,-83.947922),('28903','NC','Culberson','Cherokee',34.9916,-84.1677),('28904','NC','Hayesville','Clay',35.041854,-83.771412),('28905','NC','Marble','Cherokee',35.160787,-83.941875),('28906','NC','Murphy','Cherokee',35.088207,-84.109717),('28909','NC','Warne','Clay',35.001522,-83.912604),('29001','SC','Alcolu','Clarendon',33.769809,-80.17339),('29002','SC','Ballentine','Richland',34.1241,-81.2375),('29003','SC','Bamberg','Bamberg',33.269976,-81.037449),('29006','SC','Batesburg','Lexington',33.876547,-81.545915),('29009','SC','Bethune','Kershaw',34.422784,-80.364084),('29010','SC','Bishopville','Lee',34.21081,-80.264834),('29014','SC','Blackstock','Chester',34.550172,-81.130826),('29015','SC','Blair','Fairfield',34.426499,-81.356916),('29016','SC','Blythewood','Richland',34.200727,-80.986258),('29018','SC','Bowman','Orangeburg',33.341565,-80.649477),('29020','SC','Camden','Kershaw',34.270642,-80.589485),('29021','SC','Camden','Kershaw',34.2974,-80.6089),('29030','SC','Cameron','Calhoun',33.585798,-80.665447),('29031','SC','Carlisle','Union',34.596458,-81.445662),('29032','SC','Cassatt','Kershaw',34.333079,-80.472929),('29033','SC','Cayce','Lexington',33.96485,-81.066192),('29036','SC','Chapin','Lexington',34.133691,-81.334021),('29037','SC','Chappells','Newberry',34.177184,-81.873994),('29038','SC','Cope','Orangeburg',33.372136,-80.984358),('29039','SC','Cordova','Orangeburg',33.426795,-80.904188),('29040','SC','Dalzell','Sumter',34.029132,-80.448838),('29041','SC','Davis Station','Clarendon',33.6025,-80.2647),('29042','SC','Denmark','Bamberg',33.316865,-81.142391),('29044','SC','Eastover','Richland',33.926675,-80.701879),('29045','SC','Elgin','Kershaw',34.162506,-80.815504),('29046','SC','Elliott','Lee',34.10556,-80.163284),('29047','SC','Elloree','Orangeburg',33.527185,-80.578741),('29048','SC','Eutawville','Orangeburg',33.395038,-80.310916),('29051','SC','Gable','Sumter',33.871322,-80.118901),('29052','SC','Gadsden','Richland',33.83847,-80.746906),('29053','SC','Gaston','Lexington',33.828457,-81.096875),('29054','SC','Gilbert','Lexington',33.941953,-81.383082),('29055','SC','Great Falls','Chester',34.56755,-80.903065),('29056','SC','Greeleyville','Williamsburg',33.608642,-80.006025),('29058','SC','Heath Springs','Lancaster',34.588831,-80.700028),('29059','SC','Holly Hill','Orangeburg',33.336109,-80.42818),('29061','SC','Hopkins','Richland',33.904919,-80.851127),('29062','SC','Horatio','Sumter',34.004286,-80.605521),('29063','SC','Irmo','Richland',34.119177,-81.200763),('29065','SC','Jenkinsville','Fairfield',34.281203,-81.299115),('29067','SC','Kershaw','Lancaster',34.551662,-80.551692),('29069','SC','Lamar','Darlington',34.194899,-80.091259),('29070','SC','Leesville','Lexington',33.92766,-81.465257),('29071','SC','Lexington','Lexington',33.9813,-81.2363),('29072','SC','Lexington','Lexington',33.991498,-81.24635),('29073','SC','Lexington','Lexington',33.917757,-81.218689),('29074','SC','Liberty Hill','Kershaw',34.448682,-80.795286),('29075','SC','Little Mountain','Newberry',34.198734,-81.388418),('29078','SC','Lugoff','Kershaw',34.21068,-80.7052),('29079','SC','Lydia','Darlington',34.288214,-80.112331),('29080','SC','Lynchburg','Lee',34.01536,-80.077955),('29081','SC','Ehrhardt','Bamberg',33.094312,-81.0426),('29082','SC','Lodge','Colleton',33.044887,-80.956302),('29101','SC','Mc Bee','Chesterfield',34.460246,-80.247858),('29102','SC','Manning','Clarendon',33.64912,-80.216856),('29104','SC','Mayesville','Sumter',34.00922,-80.220214),('29105','SC','Monetta','Aiken',33.838023,-81.598855),('29107','SC','Neeses','Orangeburg',33.534616,-81.127244),('29108','SC','Newberry','Newberry',34.278041,-81.616498),('29111','SC','New Zion','Clarendon',33.789039,-80.006369),('29112','SC','North','Orangeburg',33.622696,-81.092221),('29113','SC','Norway','Orangeburg',33.44714,-81.123425),('29114','SC','Olanta','Florence',33.945828,-79.93564),('29115','SC','Orangeburg','Orangeburg',33.487806,-80.856423),('29116','SC','Orangeburg','Orangeburg',33.4916,-80.8558),('29117','SC','Orangeburg','Orangeburg',33.497631,-80.849626),('29118','SC','Orangeburg','Orangeburg',33.549912,-80.882793),('29122','SC','Peak','Newberry',34.241597,-81.327385),('29123','SC','Pelion','Lexington',33.772385,-81.259982),('29125','SC','Pinewood','Sumter',33.707718,-80.447314),('29126','SC','Pomaria','Newberry',34.29875,-81.415778),('29127','SC','Prosperity','Newberry',34.17348,-81.505909),('29128','SC','Rembert','Sumter',34.087793,-80.526802),('29129','SC','Ridge Spring','Aiken',33.808667,-81.669878),('29130','SC','Ridgeway','Fairfield',34.307861,-80.90529),('29132','SC','Rion','Fairfield',34.309957,-81.127248),('29133','SC','Rowesville','Orangeburg',33.364733,-80.817177),('29135','SC','Saint Matthews','Calhoun',33.676289,-80.790164),('29137','SC','Salley','Aiken',33.596191,-81.321416),('29138','SC','Saluda','Saluda',34.035267,-81.762463),('29142','SC','Santee','Orangeburg',33.474079,-80.506866),('29143','SC','Sardinia','Clarendon',33.7798,-80.0165),('29145','SC','Silverstreet','Newberry',34.221367,-81.752529),('29146','SC','Springfield','Orangeburg',33.507614,-81.289673),('29147','SC','State Park','Richland',34.0258,-80.9652),('29148','SC','Summerton','Clarendon',33.559981,-80.344404),('29150','SC','Sumter','Sumter',33.916138,-80.359243),('29151','SC','Sumter','Sumter',33.922,-80.3416),('29152','SC','Shaw A F B','Sumter',33.975127,-80.480698),('29153','SC','Sumter','Sumter',33.957766,-80.318846),('29154','SC','Sumter','Sumter',33.907803,-80.431148),('29160','SC','Swansea','Lexington',33.74078,-81.072543),('29161','SC','Timmonsville','Florence',34.111358,-79.932328),('29162','SC','Turbeville','Clarendon',33.890066,-80.018881),('29163','SC','Vance','Orangeburg',33.429587,-80.439904),('29164','SC','Wagener','Aiken',33.653865,-81.411845),('29166','SC','Ward','Saluda',33.890386,-81.70545),('29168','SC','Wedgefield','Sumter',33.866777,-80.537194),('29169','SC','West Columbia','Lexington',33.993193,-81.087558),('29170','SC','West Columbia','Lexington',33.943834,-81.141166),('29171','SC','West Columbia','Lexington',33.9793,-81.0787),('29172','SC','West Columbia','Lexington',33.906653,-81.082625),('29175','SC','Westville','Kershaw',34.441543,-80.600888),('29177','SC','White Rock','Richland',34.143934,-81.272814),('29178','SC','Whitmire','Newberry',34.503629,-81.615161),('29180','SC','Winnsboro','Fairfield',34.360031,-81.089567),('29201','SC','Columbia','Richland',33.995934,-81.033071),('29202','SC','Columbia','Richland',33.993555,-81.03101),('29203','SC','Columbia','Richland',34.068458,-81.023731),('29204','SC','Columbia','Richland',34.026973,-81.00287),('29205','SC','Columbia','Richland',33.990655,-80.9982),('29206','SC','Columbia','Richland',34.034137,-80.960403),('29207','SC','Columbia','Richland',34.023198,-80.912503),('29208','SC','Columbia','Richland',33.998226,-81.028613),('29209','SC','Columbia','Richland',33.963229,-80.942582),('29210','SC','Columbia','Richland',34.039872,-81.10469),('29211','SC','Columbia','Richland',34.003,-81.0322),('29212','SC','Columbia','Lexington',34.077923,-81.172987),('29214','SC','Columbia','Richland',33.9967,-81.0481),('29215','SC','Columbia','Richland',34.0005,-81.035),('29216','SC','Columbia','Richland',34.0005,-81.035),('29217','SC','Columbia','Richland',34.0005,-81.035),('29218','SC','Columbia','Richland',34.0005,-81.035),('29219','SC','Columbia','Richland',34.0005,-81.035),('29220','SC','Columbia','Richland',34.0005,-81.035),('29221','SC','Columbia','Richland',34.0407,-81.0973),('29222','SC','Columbia','Richland',34.0005,-81.035),('29223','SC','Columbia','Richland',34.084041,-80.930912),('29224','SC','Columbia','Richland',34.0568,-80.8456),('29225','SC','Columbia','Richland',33.996177,-81.025028),('29226','SC','Columbia','Richland',34.0005,-81.035),('29227','SC','Columbia','Richland',34.0005,-81.035),('29228','SC','Columbia','Lexington',33.9207,-81.0927),('29229','SC','Columbia','Richland',34.148267,-80.890498),('29230','SC','Columbia','Richland',34.1402,-81.0648),('29240','SC','Columbia','Richland',34.0298,-81.0075),('29250','SC','Columbia','Richland',34.0001,-81.0167),('29260','SC','Columbia','Richland',34.0125,-80.9664),('29290','SC','Columbia','Richland',33.9641,-80.9425),('29292','SC','Columbia','Richland',34.0062,-81.0377),('29301','SC','Spartanburg','Spartanburg',34.939264,-81.990515),('29302','SC','Spartanburg','Spartanburg',34.924207,-81.879942),('29303','SC','Spartanburg','Spartanburg',34.980566,-81.959434),('29304','SC','Spartanburg','Spartanburg',34.9445,-81.9294),('29305','SC','Spartanburg','Spartanburg',35.0039,-81.9702),('29306','SC','Spartanburg','Spartanburg',34.926577,-81.931758),('29307','SC','Spartanburg','Spartanburg',34.979599,-81.859783),('29316','SC','Boiling Springs','Spartanburg',35.033541,-81.974273),('29318','SC','Spartanburg','Spartanburg',34.9445,-81.9294),('29319','SC','Spartanburg','Spartanburg',34.95,-81.929),('29320','SC','Arcadia','Spartanburg',34.958401,-81.993676),('29321','SC','Buffalo','Union',34.715602,-81.712045),('29322','SC','Campobello','Spartanburg',35.117788,-82.136374),('29323','SC','Chesnee','Spartanburg',35.135375,-81.890615),('29324','SC','Clifton','Spartanburg',34.983681,-81.826604),('29325','SC','Clinton','Laurens',34.473503,-81.871469),('29329','SC','Converse','Spartanburg',34.993127,-81.836092),('29330','SC','Cowpens','Spartanburg',35.040871,-81.80983),('29331','SC','Cross Anchor','Spartanburg',34.645199,-81.854531),('29332','SC','Cross Hill','Laurens',34.270782,-81.982761),('29333','SC','Drayton','Spartanburg',34.970938,-81.909222),('29334','SC','Duncan','Spartanburg',34.917,-82.133771),('29335','SC','Enoree','Spartanburg',34.659271,-81.906658),('29336','SC','Fairforest','Spartanburg',34.9563,-82.0102),('29338','SC','Fingerville','Spartanburg',35.13654,-82.002961),('29340','SC','Gaffney','Cherokee',35.040511,-81.624487),('29341','SC','Gaffney','Cherokee',35.104203,-81.692204),('29342','SC','Gaffney','Cherokee',35.0716,-81.65),('29346','SC','Glendale','Spartanburg',34.945038,-81.837835),('29348','SC','Gramling','Spartanburg',35.0766,-82.1327),('29349','SC','Inman','Spartanburg',35.063612,-82.068068),('29351','SC','Joanna','Laurens',34.41464,-81.814425),('29353','SC','Jonesville','Union',34.8272,-81.668205),('29355','SC','Kinards','Laurens',34.371523,-81.772432),('29356','SC','Landrum','Spartanburg',35.15942,-82.212675),('29360','SC','Laurens','Laurens',34.503955,-82.021055),('29364','SC','Lockhart','Union',34.787315,-81.460963),('29365','SC','Lyman','Spartanburg',34.969974,-82.152588),('29368','SC','Mayo','Spartanburg',35.083186,-81.862372),('29369','SC','Moore','Spartanburg',34.870883,-82.022206),('29370','SC','Mountville','Laurens',34.365895,-81.966252),('29372','SC','Pacolet','Spartanburg',34.900785,-81.748677),('29373','SC','Pacolet Mills','Spartanburg',34.922901,-81.742902),('29374','SC','Pauline','Spartanburg',34.784549,-81.853472),('29375','SC','Reidville','Spartanburg',34.861433,-82.11342),('29376','SC','Roebuck','Spartanburg',34.845105,-81.955092),('29377','SC','Startex','Spartanburg',34.928848,-82.099607),('29378','SC','Una','Spartanburg',34.966995,-81.970455),('29379','SC','Union','Union',34.716588,-81.59963),('29384','SC','Waterloo','Laurens',34.329233,-82.084776),('29385','SC','Wellford','Spartanburg',34.958942,-82.096028),('29386','SC','White Stone','Spartanburg',34.9552,-81.8533),('29388','SC','Woodruff','Spartanburg',34.756485,-82.049322),('29390','SC','Duncan','Spartanburg',34.9375,-82.1421),('29391','SC','Duncan','Spartanburg',34.9375,-82.1421),('29395','SC','Jonesville','Union',34.8567,-81.7407),('29401','SC','Charleston','Charleston',32.77932,-79.935457),('29402','SC','Charleston','Charleston',32.7763,-79.9317),('29403','SC','Charleston','Charleston',32.799942,-79.947511),('29404','SC','Charleston Afb','Charleston',32.896927,-80.060199),('29405','SC','North Charleston','Charleston',32.858102,-79.979554),('29406','SC','Charleston','Charleston',32.925718,-80.032934),('29407','SC','Charleston','Charleston',32.797035,-80.004133),('29409','SC','Charleston','Charleston',32.796119,-79.96084),('29410','SC','Hanahan,','Berkeley',32.926778,-79.999685),('29412','SC','Charleston','Charleston',32.733901,-79.956004),('29413','SC','Charleston','Charleston',32.7919,-79.9314),('29414','SC','Charleston','Charleston',32.821894,-80.063552),('29415','SC','North Charleston','Charleston',32.8672,-79.9978),('29416','SC','Charleston','Charleston',32.8753,-80.0599),('29417','SC','Charleston','Charleston',32.7865,-79.9923),('29418','SC','North Charleston','Charleston',32.88518,-80.066196),('29419','SC','North Charleston','Charleston',32.9169,-80.0282),('29420','SC','North Charleston','Dorchester',32.929364,-80.098192),('29422','SC','Charleston','Charleston',32.6823,-79.9575),('29423','SC','Charleston','Charleston',32.97876,-80.071205),('29424','SC','Charleston','Charleston',32.783747,-79.937261),('29425','SC','Charleston','Charleston',32.7848,-79.9493),('29426','SC','Adams Run','Charleston',32.772145,-80.374085),('29429','SC','Awendaw','Charleston',32.955835,-79.672375),('29430','SC','Bethera','Berkeley',33.174292,-79.789912),('29431','SC','Bonneau','Berkeley',33.291996,-79.924535),('29432','SC','Branchville','Orangeburg',33.243183,-80.805208),('29433','SC','Canadys','Colleton',32.8882,-80.7107),('29434','SC','Cordesville','Berkeley',33.137231,-79.846161),('29435','SC','Cottageville','Colleton',32.953108,-80.466101),('29436','SC','Cross','Berkeley',33.326124,-80.188964),('29437','SC','Dorchester','Dorchester',33.135176,-80.417764),('29438','SC','Edisto Island','Charleston',32.554544,-80.309861),('29439','SC','Folly Beach','Charleston',32.660998,-79.934369),('29440','SC','Georgetown','Georgetown',33.373967,-79.317691),('29442','SC','Georgetown','Georgetown',33.4428,-79.3432),('29445','SC','Goose Creek','Berkeley',32.994688,-80.018315),('29446','SC','Green Pond','Colleton',32.660589,-80.550607),('29447','SC','Grover','Dorchester',33.1677,-80.5733),('29448','SC','Harleyville','Dorchester',33.237476,-80.452375),('29449','SC','Hollywood','Charleston',32.712735,-80.268673),('29450','SC','Huger','Berkeley',33.047374,-79.800915),('29451','SC','Isle Of Palms','Charleston',32.803735,-79.759568),('29452','SC','Jacksonboro','Colleton',32.707967,-80.443346),('29453','SC','Jamestown','Berkeley',33.23357,-79.63002),('29455','SC','Johns Island','Charleston',32.71724,-80.093218),('29456','SC','Ladson','Dorchester',32.985877,-80.11544),('29457','SC','Johns Island','Charleston',32.6842,-80.0896),('29458','SC','Mc Clellanville','Charleston',33.105454,-79.465719),('29461','SC','Moncks Corner','Berkeley',33.159399,-80.018576),('29464','SC','Mount Pleasant','Charleston',32.817343,-79.8551),('29465','SC','Mount Pleasant','Charleston',32.8452,-79.8109),('29466','SC','Mount Pleasant','Charleston',32.875415,-79.797614),('29468','SC','Pineville','Berkeley',33.427296,-80.079799),('29469','SC','Pinopolis','Berkeley',33.24683,-80.094375),('29470','SC','Ravenel','Charleston',32.817977,-80.23656),('29471','SC','Reevesville','Dorchester',33.198373,-80.656309),('29472','SC','Ridgeville','Dorchester',33.055553,-80.306658),('29474','SC','Round O','Colleton',32.897057,-80.503867),('29475','SC','Ruffin','Colleton',32.966876,-80.819388),('29476','SC','Russellville','Berkeley',33.3969,-79.9719),('29477','SC','Saint George','Dorchester',33.188558,-80.577426),('29479','SC','Saint Stephen','Berkeley',33.392932,-79.920261),('29481','SC','Smoaks','Colleton',33.105802,-80.810718),('29482','SC','Sullivans Island','Charleston',32.763547,-79.837445),('29483','SC','Summerville','Dorchester',33.035812,-80.179174),('29484','SC','Summerville','Dorchester',33.0211,-80.1701),('29485','SC','Summerville','Dorchester',32.974247,-80.173796),('29487','SC','Wadmalaw Island','Charleston',32.653234,-80.175253),('29488','SC','Walterboro','Colleton',32.907553,-80.666289),('29492','SC','Charleston','Berkeley',32.902287,-79.89893),('29493','SC','Williams','Colleton',33.034303,-80.84314),('29501','SC','Florence','Florence',34.194672,-79.814148),('29502','SC','Florence','Florence',34.1952,-79.8026),('29503','SC','Florence','Florence',34.1968,-79.7729),('29504','SC','Florence','Florence',34.1652,-79.7644),('29505','SC','Florence','Florence',34.144819,-79.748026),('29506','SC','Florence','Florence',34.211026,-79.717047),('29510','SC','Andrews','Georgetown',33.450238,-79.59384),('29511','SC','Aynor','Horry',33.982328,-79.151468),('29512','SC','Bennettsville','Marlboro',34.633048,-79.68842),('29516','SC','Blenheim','Marlboro',34.459509,-79.627712),('29518','SC','Cades','Williamsburg',33.783887,-79.825892),('29519','SC','Centenary','Marion',34.027543,-79.357697),('29520','SC','Cheraw','Chesterfield',34.695305,-79.923732),('29525','SC','Clio','Marlboro',34.574479,-79.540038),('29526','SC','Conway','Horry',33.85105,-79.01416),('29527','SC','Conway','Horry',33.809624,-79.111506),('29528','SC','Conway','Horry',33.833,-79.054),('29530','SC','Coward','Florence',33.98539,-79.740726),('29532','SC','Darlington','Darlington',34.29084,-79.878893),('29536','SC','Dillon','Dillon',34.411856,-79.363286),('29540','SC','Darlington','Darlington',34.37725,-79.891013),('29541','SC','Effingham','Florence',34.078376,-79.759506),('29543','SC','Fork','Dillon',34.289535,-79.269542),('29544','SC','Galivants Ferry','Horry',34.003598,-79.187903),('29545','SC','Green Sea','Horry',34.162784,-78.961813),('29546','SC','Gresham','Marion',33.883845,-79.349409),('29547','SC','Hamer','Dillon',34.481856,-79.326273),('29550','SC','Hartsville','Darlington',34.385956,-80.083369),('29551','SC','Hartsville','Darlington',34.3738,-80.0736),('29554','SC','Hemingway','Williamsburg',33.716916,-79.408914),('29555','SC','Johnsonville','Florence',33.840872,-79.457376),('29556','SC','Kingstree','Williamsburg',33.675829,-79.793149),('29560','SC','Lake City','Florence',33.857091,-79.756365),('29563','SC','Lake View','Dillon',34.344942,-79.182542),('29564','SC','Lane','Williamsburg',33.488356,-79.858033),('29565','SC','Latta','Dillon',34.340717,-79.460959),('29566','SC','Little River','Horry',33.869061,-78.651649),('29567','SC','Little Rock','Dillon',34.548397,-79.438354),('29568','SC','Longs','Horry',33.873782,-78.762975),('29569','SC','Loris','Horry',34.039486,-78.899549),('29570','SC','Mc Coll','Marlboro',34.671148,-79.552719),('29571','SC','Marion','Marion',34.168176,-79.398225),('29572','SC','Myrtle Beach','Horry',33.765564,-78.791951),('29573','SC','Minturn','Dillon',34.5169,-79.4725),('29574','SC','Mullins','Marion',34.193038,-79.261928),('29575','SC','Myrtle Beach','Horry',33.620802,-78.96776),('29576','SC','Murrells Inlet','Horry',33.56706,-79.03652),('29577','SC','Myrtle Beach','Horry',33.696982,-78.897876),('29578','SC','Myrtle Beach','Horry',33.6888,-78.8869),('29579','SC','Myrtle Beach','Horry',33.738805,-78.935185),('29580','SC','Nesmith','Williamsburg',33.670034,-79.566308),('29581','SC','Nichols','Horry',34.215091,-79.10941),('29582','SC','North Myrtle Beach','Horry',33.82553,-78.678355),('29583','SC','Pamplico','Florence',33.988069,-79.566827),('29584','SC','Patrick','Chesterfield',34.58615,-80.06017),('29585','SC','Pawleys Island','Georgetown',33.468232,-79.129594),('29587','SC','Myrtle Beach','Horry',33.8144,-78.6998),('29588','SC','Myrtle Beach','Horry',33.674511,-79.00794),('29589','SC','Rains','Marion',34.095976,-79.317383),('29590','SC','Salters','Williamsburg',33.573632,-79.852519),('29591','SC','Scranton','Florence',33.918627,-79.758032),('29592','SC','Sellers','Dillon',34.280519,-79.472893),('29593','SC','Society Hill','Darlington',34.508879,-79.871732),('29594','SC','Tatum','Marlboro',34.642173,-79.58148),('29596','SC','Wallace','Marlboro',34.736402,-79.821183),('29597','SC','North Myrtle Beach','Horry',33.6851,-78.9491),('29598','SC','North Myrtle Beach','Horry',33.8158,-78.6802),('29601','SC','Greenville','Greenville',34.84766,-82.404349),('29602','SC','Greenville','Greenville',34.8545,-82.4091),('29603','SC','Greenville','Greenville',34.8499,-82.3969),('29604','SC','Greenville','Greenville',34.8276,-82.3996),('29605','SC','Greenville','Greenville',34.799234,-82.391347),('29606','SC','Greenville','Greenville',34.8422,-82.3612),('29607','SC','Greenville','Greenville',34.825427,-82.341393),('29608','SC','Greenville','Greenville',34.8794,-82.405),('29609','SC','Greenville','Greenville',34.8893,-82.393321),('29610','SC','Greenville','Greenville',34.8839,-82.4697),('29611','SC','Greenville','Greenville',34.838371,-82.441853),('29612','SC','Greenville','Greenville',34.8525,-82.3941),('29613','SC','Greenville','Greenville',34.924566,-82.438736),('29614','SC','Greenville','Greenville',34.874169,-82.363336),('29615','SC','Greenville','Greenville',34.864097,-82.313511),('29616','SC','Greenville','Greenville',34.8525,-82.3941),('29617','SC','Greenville','Greenville',34.897398,-82.447149),('29620','SC','Abbeville','Abbeville',34.182424,-82.425604),('29621','SC','Anderson','Anderson',34.524177,-82.627534),('29622','SC','Anderson','Anderson',34.5082,-82.6498),('29623','SC','Anderson','Anderson',34.5453,-82.6696),('29624','SC','Anderson','Anderson',34.474762,-82.644704),('29625','SC','Anderson','Anderson',34.538325,-82.724601),('29626','SC','Anderson','Anderson',34.465296,-82.740489),('29627','SC','Belton','Anderson',34.516974,-82.490805),('29628','SC','Calhoun Falls','Abbeville',34.091778,-82.582521),('29630','SC','Central','Pickens',34.734487,-82.789488),('29631','SC','Clemson','Pickens',34.682493,-82.816796),('29632','SC','Clemson','Pickens',34.677,-82.836),('29633','SC','Clemson','Pickens',34.6833,-82.8375),('29634','SC','Clemson','Pickens',34.677472,-82.839503),('29635','SC','Cleveland','Greenville',35.079308,-82.612903),('29636','SC','Conestee','Greenville',34.768,-82.35),('29638','SC','Donalds','Abbeville',34.369789,-82.333247),('29639','SC','Due West','Abbeville',34.321643,-82.39875),('29640','SC','Easley','Pickens',34.850807,-82.591897),('29641','SC','Easley','Pickens',34.8297,-82.6016),('29642','SC','Easley','Pickens',34.794728,-82.561105),('29643','SC','Fair Play','Oconee',34.507251,-82.988983),('29644','SC','Fountain Inn','Greenville',34.67974,-82.199589),('29645','SC','Gray Court','Laurens',34.603221,-82.119759),('29646','SC','Greenwood','Greenwood',34.169366,-82.151908),('29647','SC','Greenwood','Greenwood',34.1788,-82.1632),('29648','SC','Greenwood','Greenwood',34.1894,-82.1585),('29649','SC','Greenwood','Greenwood',34.227581,-82.155466),('29650','SC','Greer','Greenville',34.908736,-82.252125),('29651','SC','Greer','Greenville',34.939866,-82.222296),('29652','SC','Greer','Greenville',34.9386,-82.2272),('29653','SC','Hodges','Greenwood',34.287074,-82.23601),('29654','SC','Honea Path','Anderson',34.453682,-82.38234),('29655','SC','Iva','Anderson',34.27195,-82.653128),('29656','SC','La France','Anderson',34.612144,-82.762634),('29657','SC','Liberty','Pickens',34.774277,-82.691462),('29658','SC','Long Creek','Oconee',34.768625,-83.275867),('29659','SC','Lowndesville','Abbeville',34.210292,-82.649605),('29661','SC','Marietta','Greenville',35.04878,-82.52621),('29662','SC','Mauldin','Greenville',34.776876,-82.30112),('29664','SC','Mountain Rest','Oconee',34.860889,-83.157553),('29665','SC','Newry','Oconee',34.724742,-82.909277),('29666','SC','Ninety Six','Greenwood',34.147142,-82.002415),('29667','SC','Norris','Pickens',34.767428,-82.757523),('29669','SC','Pelzer','Anderson',34.646628,-82.441364),('29670','SC','Pendleton','Anderson',34.638145,-82.758099),('29671','SC','Pickens','Pickens',34.918004,-82.718304),('29672','SC','Seneca','Oconee',34.738392,-82.940169),('29673','SC','Piedmont','Greenville',34.723596,-82.457396),('29675','SC','Richland','Oconee',34.6777,-83.0255),('29676','SC','Salem','Oconee',34.901111,-82.938167),('29677','SC','Sandy Springs','Anderson',34.589662,-82.74935),('29678','SC','Seneca','Oconee',34.658437,-82.933368),('29679','SC','Seneca','Oconee',34.6855,-82.9533),('29680','SC','Simpsonville','Greenville',34.706445,-82.286243),('29681','SC','Simpsonville','Greenville',34.764524,-82.243919),('29682','SC','Six Mile','Pickens',34.832706,-82.839216),('29683','SC','Slater','Greenville',35.028835,-82.494215),('29684','SC','Starr','Anderson',34.384248,-82.711336),('29685','SC','Sunset','Pickens',34.951983,-82.854109),('29686','SC','Tamassee','Oconee',34.901478,-83.044183),('29687','SC','Taylors','Greenville',34.939783,-82.325022),('29688','SC','Tigerville','Greenville',35.068914,-82.370612),('29689','SC','Townville','Anderson',34.527643,-82.867641),('29690','SC','Travelers Rest','Greenville',35.028696,-82.425189),('29691','SC','Walhalla','Oconee',34.770688,-83.066635),('29692','SC','Ware Shoals','Laurens',34.405138,-82.234277),('29693','SC','Westminster','Oconee',34.64063,-83.118385),('29695','SC','Hodges','Greenwood',34.2875,-82.2444),('29696','SC','West Union','Oconee',34.763557,-83.020061),('29697','SC','Williamston','Anderson',34.622192,-82.512838),('29698','SC','Greenville','Spartanburg',34.9137,-82.0978),('29702','SC','Blacksburg','Cherokee',35.110942,-81.491608),('29703','SC','Bowling Green','York',35.1497,-81.2125),('29704','SC','Catawba','York',34.829662,-80.925052),('29706','SC','Chester','Chester',34.720755,-81.21484),('29707','SC','Fort Mill','Lancaster',34.969711,-80.853446),('29708','SC','Fort Mill','York',35.038045,-80.988834),('29709','SC','Chesterfield','Chesterfield',34.718158,-80.091315),('29710','SC','Clover','York',35.108683,-81.193447),('29712','SC','Edgemoor','Chester',34.798769,-80.994883),('29714','SC','Fort Lawn','Chester',34.701658,-80.905592),('29715','SC','Fort Mill','York',35.018287,-80.932489),('29716','SC','Fort Mill','York',35.007,-80.9393),('29717','SC','Hickory Grove','York',34.96902,-81.436555),('29718','SC','Jefferson','Chesterfield',34.626249,-80.346673),('29720','SC','Lancaster','Lancaster',34.730199,-80.762509),('29721','SC','Lancaster','Lancaster',34.7254,-80.774),('29722','SC','Lancaster','Lancaster',34.7448,-80.7232),('29724','SC','Lando','Chester',34.774347,-81.00994),('29726','SC','Mc Connells','York',34.859591,-81.221179),('29727','SC','Mount Croghan','Chesterfield',34.720942,-80.2677),('29728','SC','Pageland','Chesterfield',34.767716,-80.39547),('29729','SC','Richburg','Chester',34.689135,-81.00676),('29730','SC','Rock Hill','York',34.915239,-81.00805),('29731','SC','Rock Hill','York',34.9264,-81.0327),('29732','SC','Rock Hill','York',34.967919,-81.053007),('29733','SC','Rock Hill','York',34.938922,-81.032615),('29734','SC','Rock Hill','York',34.9264,-81.0327),('29741','SC','Ruby','Chesterfield',34.729376,-80.198681),('29742','SC','Sharon','York',34.864495,-81.378417),('29743','SC','Smyrna','York',35.038623,-81.409624),('29744','SC','Van Wyck','Lancaster',34.9157,-80.8443),('29745','SC','York','York',35.005234,-81.211658),('29801','SC','Aiken','Aiken',33.572801,-81.717899),('29802','SC','Aiken','Aiken',33.6125,-81.7089),('29803','SC','Aiken','Aiken',33.461688,-81.7053),('29804','SC','Aiken','Aiken',33.5149,-81.7321),('29805','SC','Aiken','Aiken',33.647719,-81.616601),('29808','SC','Aiken','Aiken',33.2541,-81.6281),('29809','SC','New Ellenton','Aiken',33.417796,-81.686258),('29810','SC','Allendale','Allendale',33.005482,-81.335367),('29812','SC','Barnwell','Barnwell',33.239198,-81.458388),('29813','SC','Hilda','Barnwell',33.2438,-81.3632),('29816','SC','Bath','Aiken',33.503473,-81.871597),('29817','SC','Blackville','Barnwell',33.361467,-81.27224),('29819','SC','Bradley','Greenwood',34.059313,-82.22633),('29821','SC','Clarks Hill','Mccormick',33.641354,-82.123474),('29822','SC','Clearwater','Aiken',33.498386,-81.897059),('29824','SC','Edgefield','Edgefield',33.827048,-81.964224),('29826','SC','Elko','Barnwell',33.376386,-81.375277),('29827','SC','Fairfax','Allendale',32.964977,-81.242475),('29828','SC','Gloverville','Aiken',33.525443,-81.828128),('29829','SC','Graniteville','Aiken',33.565956,-81.841219),('29831','SC','Jackson','Aiken',33.31394,-81.78147),('29832','SC','Johnston','Edgefield',33.830417,-81.804214),('29834','SC','Langley','Aiken',33.513272,-81.850824),('29835','SC','Mc Cormick','Mccormick',33.91411,-82.299158),('29836','SC','Martin','Allendale',33.150642,-81.606917),('29838','SC','Modoc','Edgefield',33.730639,-82.185706),('29839','SC','Montmorenci','Aiken',33.543,-81.6719),('29840','SC','Mount Carmel','Mccormick',34.007203,-82.521302),('29841','SC','North Augusta','Aiken',33.518223,-81.950009),('29842','SC','Beech Island','Aiken',33.4533,-81.886619),('29843','SC','Olar','Bamberg',33.184744,-81.188006),('29844','SC','Parksville','Mccormick',33.780438,-82.215018),('29845','SC','Plum Branch','Mccormick',33.825859,-82.213392),('29846','SC','Sycamore','Allendale',33.047132,-81.221858),('29847','SC','Trenton','Edgefield',33.70191,-81.83885),('29848','SC','Troy','Greenwood',33.982079,-82.153877),('29849','SC','Ulmer','Allendale',33.09435,-81.225429),('29850','SC','Vaucluse','Aiken',33.612139,-81.808646),('29851','SC','Warrenville','Aiken',33.530649,-81.817262),('29853','SC','Williston','Barnwell',33.39918,-81.43175),('29856','SC','Windsor','Aiken',33.483306,-81.516325),('29860','SC','North Augusta','Edgefield',33.585238,-81.959079),('29861','SC','North Augusta','Aiken',33.5074,-81.9625),('29899','SC','Mc Cormick','Mccormick',33.928023,-82.250602),('29901','SC','Beaufort','Beaufort',32.4335,-80.6728),('29902','SC','Beaufort','Beaufort',32.413899,-80.690805),('29903','SC','Beaufort','Beaufort',32.4335,-80.6728),('29904','SC','Beaufort','Beaufort',32.457304,-80.717921),('29905','SC','Beaufort','Beaufort',32.349597,-80.68244),('29906','SC','Beaufort','Beaufort',32.44449,-80.744351),('29907','SC','Ladys Island','Beaufort',32.430653,-80.641186),('29909','SC','Okatie','Beaufort',32.314144,-80.916023),('29910','SC','Bluffton','Beaufort',32.242461,-80.882386),('29911','SC','Brunson','Hampton',32.928833,-81.155189),('29912','SC','Coosawhatchie','Jasper',32.4818,-80.9849),('29913','SC','Crocketville','Hampton',32.9163,-81.0775),('29914','SC','Dale','Beaufort',32.5563,-80.69),('29915','SC','Daufuskie Island','Beaufort',32.113571,-80.866751),('29916','SC','Early Branch','Hampton',32.728814,-80.954433),('29918','SC','Estill','Hampton',32.751369,-81.224794),('29920','SC','Saint Helena Island','Beaufort',32.372175,-80.55029),('29921','SC','Furman','Hampton',32.682984,-81.175677),('29922','SC','Garnett','Hampton',32.625831,-81.277273),('29923','SC','Gifford','Hampton',32.860108,-81.243042),('29924','SC','Hampton','Hampton',32.870359,-81.113413),('29925','SC','Hilton Head Island','Beaufort',32.1632,-80.7533),('29926','SC','Hilton Head Island','Beaufort',32.224289,-80.740801),('29927','SC','Hardeeville','Jasper',32.263611,-81.058859),('29928','SC','Hilton Head Island','Beaufort',32.164349,-80.751035),('29929','SC','Islandton','Colleton',32.927698,-80.946988),('29931','SC','Lobeco','Beaufort',32.5525,-80.7436),('29932','SC','Luray','Hampton',32.818214,-81.321092),('29933','SC','Miley','Hampton',32.9477,-81.0319),('29934','SC','Pineland','Jasper',32.595837,-81.124006),('29935','SC','Port Royal','Beaufort',32.384993,-80.693492),('29936','SC','Ridgeland','Jasper',32.47902,-80.971204),('29938','SC','Hilton Head Island','Beaufort',32.1632,-80.7533),('29939','SC','Scotia','Hampton',32.674703,-81.250166),('29940','SC','Seabrook','Beaufort',32.552564,-80.737195),('29941','SC','Sheldon','Beaufort',32.547943,-80.815689),('29943','SC','Tillman','Jasper',32.459968,-81.175141),('29944','SC','Varnville','Hampton',32.825098,-81.043717),('29945','SC','Yemassee','Hampton',32.68248,-80.82617),('30002','GA','Avondale Estates','Dekalb',33.774362,-84.263962),('30003','GA','Norcross','Gwinnett',33.9392,-84.2053),('30004','GA','Alpharetta','Fulton',34.12286,-84.288566),('30005','GA','Alpharetta','Fulton',34.081718,-84.226167),('30006','GA','Marietta','Cobb',33.9043,-84.468),('30007','GA','Marietta','Cobb',33.9802,-84.425),('30008','GA','Marietta','Cobb',33.908079,-84.577741),('30009','GA','Alpharetta','Fulton',34.074715,-84.301639),('30010','GA','Norcross','Gwinnett',33.9392,-84.2053),('30011','GA','Auburn','Barrow',34.019861,-83.836749),('30012','GA','Conyers','Rockdale',33.695997,-84.016059),('30013','GA','Conyers','Rockdale',33.63846,-83.981596),('30014','GA','Covington','Newton',33.585747,-83.846682),('30015','GA','Covington','Newton',33.5983,-83.863),('30016','GA','Covington','Newton',33.54841,-83.939657),('30017','GA','Grayson','Gwinnett',33.88335,-83.96587),('30018','GA','Jersey','Walton',33.7413,-83.8137),('30019','GA','Dacula','Gwinnett',33.989681,-83.890831),('30021','GA','Clarkston','Dekalb',33.810251,-84.239827),('30022','GA','Alpharetta','Fulton',34.034216,-84.245909),('30023','GA','Alpharetta','Fulton',34.0421,-84.2406),('30024','GA','Suwanee','Gwinnett',34.052708,-84.083607),('30025','GA','Social Circle','Walton',33.650218,-83.704852),('30026','GA','North Metro','Gwinnett',33.977,-84.1493),('30028','GA','Cumming','Forsyth',34.288433,-84.168133),('30029','GA','North Metro','Gwinnett',33.977,-84.1493),('30030','GA','Decatur','Dekalb',33.771582,-84.29415),('30031','GA','Decatur','Dekalb',33.77402,-84.296454),('30032','GA','Decatur','Dekalb',33.740511,-84.264563),('30033','GA','Decatur','Dekalb',33.811659,-84.28323),('30034','GA','Decatur','Dekalb',33.694418,-84.247429),('30035','GA','Decatur','Dekalb',33.728503,-84.209172),('30036','GA','Decatur','Dekalb',33.772,-84.2917),('30037','GA','Decatur','Dekalb',33.7059,-84.2719),('30038','GA','Lithonia','Dekalb',33.680705,-84.145239),('30039','GA','Snellville','Gwinnett',33.799472,-84.036979),('30040','GA','Cumming','Forsyth',34.210444,-84.172937),('30041','GA','Cumming','Forsyth',34.187713,-84.105317),('30042','GA','Lawrenceville','Gwinnett',33.9435,-83.9643),('30043','GA','Lawrenceville','Gwinnett',33.996556,-84.01784),('30044','GA','Lawrenceville','Gwinnett',33.921502,-84.068873),('30045','GA','Lawrenceville','Gwinnett',33.937055,-83.948311),('30046','GA','Lawrenceville','Gwinnett',33.948631,-83.995764),('30047','GA','Lilburn','Gwinnett',33.87293,-84.116937),('30048','GA','Lilburn','Gwinnett',33.8741,-84.1116),('30049','GA','Lawrenceville','Gwinnett',33.6361,-84.2919),('30052','GA','Loganville','Walton',33.828259,-83.900082),('30054','GA','Oxford','Newton',33.658316,-83.873254),('30055','GA','Mansfield','Jasper',33.496702,-83.749992),('30056','GA','Newborn','Jasper',33.498813,-83.678372),('30058','GA','Lithonia','Dekalb',33.732958,-84.115392),('30060','GA','Marietta','Cobb',33.931823,-84.544027),('30061','GA','Marietta','Cobb',33.9529,-84.5454),('30062','GA','Marietta','Cobb',33.989246,-84.481629),('30063','GA','Marietta','Cobb',33.9529,-84.5454),('30064','GA','Marietta','Cobb',33.937448,-84.607619),('30065','GA','Marietta','Cobb',33.9525,-84.55),('30066','GA','Marietta','Cobb',34.023063,-84.516458),('30067','GA','Marietta','Cobb',33.928756,-84.478064),('30068','GA','Marietta','Cobb',33.964406,-84.447609),('30069','GA','Marietta','Cobb',33.9178,-84.5212),('30070','GA','Porterdale','Newton',33.57436,-83.894915),('30071','GA','Norcross','Gwinnett',33.939325,-84.205307),('30072','GA','Pine Lake','Dekalb',33.790707,-84.205837),('30073','GA','Decatur','Dekalb',33.7034,-84.2573),('30074','GA','Redan','Dekalb',33.7452,-84.1316),('30075','GA','Roswell','Fulton',34.047971,-84.383884),('30076','GA','Roswell','Fulton',34.02785,-84.319845),('30077','GA','Roswell','Fulton',34.0304,-84.3428),('30078','GA','Snellville','Gwinnett',33.861019,-84.017993),('30079','GA','Scottdale','Dekalb',33.792284,-84.258887),('30080','GA','Smyrna','Cobb',33.871047,-84.499258),('30081','GA','Smyrna','Cobb',33.8942,-84.5283),('30082','GA','Smyrna','Cobb',33.857733,-84.534708),('30083','GA','Stone Mountain','Dekalb',33.799853,-84.194944),('30084','GA','Tucker','Dekalb',33.854067,-84.220211),('30085','GA','Tucker','Dekalb',33.854,-84.212),('30086','GA','Stone Mountain','Dekalb',33.8064,-84.1801),('30087','GA','Stone Mountain','Dekalb',33.819706,-84.127994),('30088','GA','Stone Mountain','Dekalb',33.761135,-84.180914),('30090','GA','Marietta','Cobb',33.9527,-84.5489),('30091','GA','Norcross','Gwinnett',33.9405,-84.2078),('30092','GA','Norcross','Gwinnett',33.968603,-84.233538),('30093','GA','Norcross','Gwinnett',33.907985,-84.181865),('30094','GA','Conyers','Rockdale',33.623582,-84.044243),('30095','GA','Duluth','Gwinnett',33.9774,-84.1508),('30096','GA','Duluth','Gwinnett',33.978939,-84.148501),('30097','GA','Duluth','Fulton',34.023027,-84.145599),('30098','GA','Duluth','Gwinnett',33.9774,-84.1508),('30099','GA','Duluth','Gwinnett',33.9774,-84.1508),('30101','GA','Acworth','Cobb',34.053467,-84.688908),('30102','GA','Acworth','Cherokee',34.093677,-84.624485),('30103','GA','Adairsville','Bartow',34.367701,-84.928493),('30104','GA','Aragon','Polk',34.06692,-85.066481),('30105','GA','Armuchee','Floyd',34.432605,-85.172546),('30106','GA','Austell','Cobb',33.829081,-84.62613),('30107','GA','Ball Ground','Cherokee',34.337122,-84.368014),('30108','GA','Bowdon','Carroll',33.529049,-85.258704),('30109','GA','Bowdon Junction','Carroll',33.663,-85.1469),('30110','GA','Bremen','Haralson',33.724671,-85.140386),('30111','GA','Clarkdale','Cobb',33.8225,-84.6309),('30112','GA','Carrollton','Carroll',33.5809,-85.0792),('30113','GA','Buchanan','Haralson',33.845544,-85.194551),('30114','GA','Canton','Cherokee',34.22921,-84.511504),('30115','GA','Canton','Cherokee',34.193801,-84.438551),('30116','GA','Carrollton','Carroll',33.557086,-85.018684),('30117','GA','Carrollton','Carroll',33.591119,-85.105705),('30118','GA','Carrollton','Carroll',33.573222,-85.101132),('30119','GA','Carrollton','Carroll',33.5668,-85.0756),('30120','GA','Cartersville','Bartow',34.16657,-84.828076),('30121','GA','Cartersville','Bartow',34.198513,-84.780684),('30122','GA','Lithia Springs','Douglas',33.769923,-84.634523),('30123','GA','Cassville','Bartow',34.2447,-84.8522),('30124','GA','Cave Spring','Floyd',34.125227,-85.342748),('30125','GA','Cedartown','Polk',34.013787,-85.252455),('30126','GA','Mableton','Cobb',33.815025,-84.553831),('30127','GA','Powder Springs','Cobb',33.874753,-84.687833),('30129','GA','Coosa','Floyd',34.2544,-85.3544),('30132','GA','Dallas','Paulding',33.957298,-84.830506),('30133','GA','Douglasville','Douglas',33.7494,-84.7459),('30134','GA','Douglasville','Douglas',33.769706,-84.758436),('30135','GA','Douglasville','Douglas',33.70065,-84.730844),('30137','GA','Emerson','Bartow',34.126036,-84.757584),('30138','GA','Esom Hill','Polk',33.9488,-85.3877),('30139','GA','Fairmount','Gordon',34.432966,-84.702065),('30140','GA','Felton','Haralson',33.8593,-85.2451),('30141','GA','Hiram','Paulding',33.870387,-84.767178),('30142','GA','Holly Springs','Cherokee',34.1738,-84.5013),('30143','GA','Jasper','Pickens',34.457169,-84.421597),('30144','GA','Kennesaw','Cobb',34.034885,-84.595243),('30145','GA','Kingston','Bartow',34.22435,-84.973007),('30146','GA','Lebanon','Cherokee',34.2182,-84.4449),('30147','GA','Lindale','Floyd',34.169292,-85.186077),('30148','GA','Marble Hill','Pickens',34.458792,-84.258613),('30149','GA','Mount Berry','Floyd',34.299468,-85.209116),('30150','GA','Mount Zion','Carroll',33.6341,-85.1872),('30151','GA','Nelson','Cherokee',34.3824,-84.3693),('30152','GA','Kennesaw','Cobb',34.00174,-84.633759),('30153','GA','Rockmart','Polk',33.992561,-85.054305),('30154','GA','Douglasville','Douglas',33.7708,-84.7788),('30156','GA','Kennesaw','Cobb',33.9919,-84.6543),('30157','GA','Dallas','Paulding',33.904122,-84.82381),('30160','GA','Kennesaw','Cobb',33.9919,-84.6543),('30161','GA','Rome','Floyd',34.248306,-85.156656),('30162','GA','Rome','Floyd',34.2552,-85.1679),('30163','GA','Rome','Floyd',34.2569,-85.1647),('30164','GA','Rome','Floyd',34.2729,-85.2289),('30165','GA','Rome','Floyd',34.284009,-85.238251),('30168','GA','Austell','Cobb',33.794378,-84.600697),('30169','GA','Canton','Cherokee',34.1417,-84.2951),('30170','GA','Roopville','Carroll',33.432399,-85.171873),('30171','GA','Rydal','Bartow',34.346202,-84.73276),('30172','GA','Shannon','Floyd',34.3366,-85.0713),('30173','GA','Silver Creek','Floyd',34.133121,-85.153505),('30175','GA','Talking Rock','Pickens',34.538354,-84.510585),('30176','GA','Tallapoosa','Haralson',33.746306,-85.293725),('30177','GA','Tate','Pickens',34.400659,-84.376201),('30178','GA','Taylorsville','Bartow',34.10207,-84.97083),('30179','GA','Temple','Carroll',33.75233,-85.022645),('30180','GA','Villa Rica','Carroll',33.719384,-84.923204),('30182','GA','Waco','Carroll',33.66444,-85.227743),('30183','GA','Waleska','Cherokee',34.348007,-84.585864),('30184','GA','White','Bartow',34.252908,-84.742204),('30185','GA','Whitesburg','Carroll',33.518508,-84.919289),('30187','GA','Winston','Douglas',33.67134,-84.838366),('30188','GA','Woodstock','Cherokee',34.10903,-84.484976),('30189','GA','Woodstock','Cherokee',34.122874,-84.564562),('30204','GA','Barnesville','Lamar',33.058169,-84.147539),('30205','GA','Brooks','Fayette',33.282322,-84.463094),('30206','GA','Concord','Pike',33.087032,-84.451285),('30212','GA','Experiment','Spalding',33.2652,-84.2816),('30213','GA','Fairburn','Fulton',33.572558,-84.601419),('30214','GA','Fayetteville','Fayette',33.48711,-84.475561),('30215','GA','Fayetteville','Fayette',33.409873,-84.457916),('30216','GA','Flovilla','Butts',33.243364,-83.899723),('30217','GA','Franklin','Heard',33.299432,-85.110559),('30218','GA','Gay','Meriwether',33.12465,-84.572522),('30219','GA','Glenn','Heard',33.2808,-85.1206),('30220','GA','Grantville','Coweta',33.230862,-84.824854),('30222','GA','Greenville','Meriwether',33.037182,-84.735424),('30223','GA','Griffin','Spalding',33.271153,-84.278543),('30224','GA','Griffin','Spalding',33.215462,-84.254475),('30228','GA','Hampton','Henry',33.401311,-84.302863),('30229','GA','Haralson','Coweta',33.2255,-84.5697),('30230','GA','Hogansville','Troup',33.172457,-84.922925),('30233','GA','Jackson','Butts',33.296983,-83.966939),('30234','GA','Jenkinsburg','Butts',33.32385,-84.037171),('30236','GA','Jonesboro','Clayton',33.528317,-84.333774),('30237','GA','Jonesboro','Clayton',33.5319,-84.3563),('30238','GA','Jonesboro','Clayton',33.501413,-84.376837),('30240','GA','Lagrange','Troup',33.027127,-85.083399),('30241','GA','Lagrange','Troup',33.034526,-84.984875),('30248','GA','Locust Grove','Henry',33.346005,-84.109703),('30250','GA','Lovejoy','Clayton',33.436527,-84.31446),('30251','GA','Luthersville','Meriwether',33.19502,-84.703189),('30252','GA','Mcdonough','Henry',33.46249,-84.088357),('30253','GA','Mcdonough','Henry',33.452229,-84.17768),('30256','GA','Meansville','Pike',33.020577,-84.318246),('30257','GA','Milner','Lamar',33.141056,-84.195024),('30258','GA','Molena','Pike',32.995482,-84.469831),('30259','GA','Moreland','Coweta',33.273462,-84.752042),('30260','GA','Morrow','Clayton',33.586876,-84.329992),('30261','GA','Lagrange','Troup',33.0391,-85.0313),('30263','GA','Newnan','Coweta',33.387785,-84.821363),('30264','GA','Newnan','Coweta',33.3805,-84.7997),('30265','GA','Newnan','Coweta',33.401887,-84.717193),('30266','GA','Orchard Hill','Spalding',33.1863,-84.2113),('30268','GA','Palmetto','Fulton',33.528444,-84.68709),('30269','GA','Peachtree City','Fayette',33.402692,-84.570163),('30270','GA','Peachtree City','Fayette',33.575,-83.8938),('30271','GA','Newnan','Coweta',33.3924,-84.8561),('30272','GA','Red Oak','Fulton',33.622,-84.5016),('30273','GA','Rex','Clayton',33.581154,-84.274602),('30274','GA','Riverdale','Clayton',33.554129,-84.401228),('30275','GA','Sargent','Coweta',33.431181,-84.867333),('30276','GA','Senoia','Coweta',33.280499,-84.580446),('30277','GA','Sharpsburg','Coweta',33.373626,-84.660395),('30281','GA','Stockbridge','Henry',33.54834,-84.221245),('30284','GA','Sunny Side','Spalding',33.342876,-84.288958),('30285','GA','The Rock','Upson',32.983024,-84.25057),('30286','GA','Thomaston','Upson',32.892928,-84.332243),('30287','GA','Morrow','Clayton',33.5597,-84.346),('30288','GA','Conley','Clayton',33.652583,-84.327038),('30289','GA','Turin','Coweta',33.327296,-84.636927),('30290','GA','Tyrone','Fayette',33.480413,-84.586803),('30291','GA','Union City','Fulton',33.579559,-84.538712),('30292','GA','Williamson','Pike',33.173011,-84.380854),('30293','GA','Woodbury','Meriwether',32.973226,-84.590444),('30294','GA','Ellenwood','Dekalb',33.632041,-84.277901),('30295','GA','Zebulon','Pike',33.094643,-84.324428),('30296','GA','Riverdale','Clayton',33.564552,-84.438856),('30297','GA','Forest Park','Clayton',33.617488,-84.369544),('30298','GA','Forest Park','Clayton',33.6149,-84.3648),('30301','GA','Atlanta','Fulton',33.7564,-84.3918),('30302','GA','Atlanta','Fulton',33.7493,-84.3958),('30303','GA','Atlanta','Fulton',33.753802,-84.389635),('30304','GA','Atlanta','Fulton',33.6605,-84.3858),('30305','GA','Atlanta','Fulton',33.833886,-84.386603),('30306','GA','Atlanta','Fulton',33.789323,-84.351498),('30307','GA','Atlanta','Dekalb',33.766439,-84.339924),('30308','GA','Atlanta','Fulton',33.771905,-84.38107),('30309','GA','Atlanta','Fulton',33.794315,-84.386003),('30310','GA','Atlanta','Fulton',33.726317,-84.421226),('30311','GA','Atlanta','Fulton',33.723258,-84.475999),('30312','GA','Atlanta','Fulton',33.745034,-84.377896),('30313','GA','Atlanta','Fulton',33.759827,-84.39675),('30314','GA','Atlanta','Fulton',33.758032,-84.423798),('30315','GA','Atlanta','Fulton',33.708453,-84.385415),('30316','GA','Atlanta','Dekalb',33.728621,-84.337745),('30317','GA','Atlanta','Dekalb',33.750246,-84.318596),('30318','GA','Atlanta','Fulton',33.788209,-84.442034),('30319','GA','Atlanta','Dekalb',33.872229,-84.335865),('30320','GA','Atlanta','Fulton',33.6377,-84.4431),('30321','GA','Atlanta','Fulton',33.7488,-84.388),('30322','GA','Atlanta','Dekalb',33.794338,-84.326462),('30324','GA','Atlanta','Fulton',33.819786,-84.35949),('30325','GA','Atlanta','Fulton',33.8007,-84.4153),('30326','GA','Atlanta','Fulton',33.850163,-84.362383),('30327','GA','Atlanta','Fulton',33.857151,-84.423767),('30328','GA','Atlanta','Fulton',33.933593,-84.377845),('30329','GA','Atlanta','Dekalb',33.8305,-84.325862),('30330','GA','Atlanta','Fulton',33.7069,-84.432),('30331','GA','Atlanta','Fulton',33.712926,-84.523486),('30332','GA','Atlanta','Fulton',33.779169,-84.405141),('30333','GA','Atlanta','Dekalb',33.8049,-84.3369),('30334','GA','Atlanta','Fulton',33.7486,-84.3875),('30336','GA','Atlanta','Fulton',33.749201,-84.552482),('30337','GA','Atlanta','Fulton',33.645251,-84.452364),('30338','GA','Atlanta','Dekalb',33.942144,-84.319736),('30339','GA','Atlanta','Cobb',33.881827,-84.465041),('30340','GA','Atlanta','Dekalb',33.896768,-84.252292),('30341','GA','Atlanta','Dekalb',33.888505,-84.289532),('30342','GA','Atlanta','Fulton',33.881223,-84.369849),('30343','GA','Atlanta','Fulton',33.7595,-84.387),('30344','GA','Atlanta','Fulton',33.676147,-84.451213),('30345','GA','Atlanta','Dekalb',33.851722,-84.283624),('30346','GA','Atlanta','Dekalb',33.923572,-84.340944),('30347','GA','Atlanta','Fulton',33.8281,-84.3337),('30348','GA','Atlanta','Fulton',33.8345,-84.3893),('30349','GA','Atlanta','Fulton',33.61395,-84.504643),('30350','GA','Atlanta','Fulton',33.978548,-84.338644),('30353','GA','Atlanta','Fulton',33.7488,-84.388),('30354','GA','Atlanta','Fulton',33.658274,-84.398208),('30355','GA','Atlanta','Fulton',33.8365,-84.3689),('30356','GA','Atlanta','Dekalb',33.9472,-84.3321),('30357','GA','Atlanta','Fulton',33.7488,-84.388),('30358','GA','Atlanta','Fulton',33.9213,-84.3774),('30359','GA','Atlanta','Dekalb',33.8374,-84.3112),('30360','GA','Atlanta','Dekalb',33.926556,-84.275023),('30361','GA','Atlanta','Fulton',33.7488,-84.388),('30362','GA','Atlanta','Dekalb',33.9021,-84.2738),('30363','GA','Atlanta','Fulton',33.791538,-84.39694),('30364','GA','Atlanta','Fulton',33.6759,-84.443),('30366','GA','Atlanta','Dekalb',33.8956,-84.2987),('30368','GA','Atlanta','Fulton',33.7488,-84.388),('30369','GA','Atlanta','Fulton',33.7488,-84.388),('30370','GA','Atlanta','Fulton',33.7488,-84.388),('30371','GA','Atlanta','Fulton',33.7488,-84.388),('30374','GA','Atlanta','Fulton',33.7488,-84.388),('30375','GA','Atlanta','Fulton',33.6605,-84.3858),('30376','GA','Atlanta','Fulton',33.8196,-84.3563),('30377','GA','Atlanta','Fulton',33.781,-84.4125),('30378','GA','Atlanta','Fulton',33.748053,-84.39093),('30379','GA','Atlanta','Fulton',33.7488,-84.388),('30380','GA','Atlanta','Fulton',33.6605,-84.3858),('30384','GA','Atlanta','Fulton',33.7488,-84.388),('30385','GA','Atlanta','Fulton',33.6605,-84.3858),('30386','GA','Atlanta','Fulton',33.6487,-84.3915),('30387','GA','Atlanta','Fulton',33.7488,-84.388),('30388','GA','Atlanta','Fulton',33.6487,-84.3915),('30389','GA','Atlanta','Fulton',33.7488,-84.388),('30390','GA','Atlanta','Fulton',33.7488,-84.388),('30392','GA','Atlanta','Fulton',33.7488,-84.388),('30394','GA','Atlanta','Fulton',33.7488,-84.388),('30396','GA','Atlanta','Fulton',33.6487,-84.3915),('30398','GA','Atlanta','Fulton',33.7488,-84.388),('30399','GA','Atlanta','Fulton',33.7488,-84.388),('30401','GA','Swainsboro','Emanuel',32.599132,-82.342324),('30410','GA','Ailey','Montgomery',32.178666,-82.524377),('30411','GA','Alamo','Wheeler',32.124103,-82.793957),('30412','GA','Alston','Montgomery',32.080242,-82.479687),('30413','GA','Bartow','Jefferson',32.884037,-82.508469),('30414','GA','Bellville','Evans',32.15499,-81.978264),('30415','GA','Brooklet','Bulloch',32.334688,-81.60764),('30417','GA','Claxton','Evans',32.165886,-81.909405),('30420','GA','Cobbtown','Tattnall',32.284733,-82.164998),('30421','GA','Collins','Tattnall',32.182159,-82.113907),('30423','GA','Daisy','Evans',32.148196,-81.834993),('30424','GA','Dover','Screven',32.5769,-81.7152),('30425','GA','Garfield','Emanuel',32.653177,-82.03642),('30426','GA','Girard','Burke',33.017979,-81.625003),('30427','GA','Glennville','Tattnall',31.939086,-81.933468),('30428','GA','Glenwood','Wheeler',32.215116,-82.685084),('30429','GA','Hagan','Evans',32.163223,-81.934959),('30434','GA','Louisville','Jefferson',33.005419,-82.379408),('30436','GA','Lyons','Toombs',32.184677,-82.30571),('30438','GA','Manassas','Tattnall',32.163104,-82.022098),('30439','GA','Metter','Candler',32.40119,-82.063274),('30441','GA','Midville','Emanuel',32.80906,-82.240562),('30442','GA','Millen','Jenkins',32.800656,-81.974748),('30445','GA','Mount Vernon','Montgomery',32.172066,-82.58348),('30446','GA','Newington','Screven',32.580802,-81.473303),('30447','GA','Norristown','Emanuel',32.505913,-82.495026),('30448','GA','Nunez','Emanuel',32.488099,-82.355694),('30449','GA','Oliver','Screven',32.515028,-81.540797),('30450','GA','Portal','Bulloch',32.556481,-81.928119),('30451','GA','Pulaski','Candler',32.391108,-81.954185),('30452','GA','Register','Bulloch',32.325318,-81.888852),('30453','GA','Reidsville','Tattnall',32.037201,-82.131071),('30454','GA','Rockledge','Laurens',32.437044,-82.720113),('30455','GA','Rocky Ford','Screven',32.681708,-81.811999),('30456','GA','Sardis','Burke',32.983661,-81.773058),('30457','GA','Soperton','Treutlen',32.396422,-82.578126),('30458','GA','Statesboro','Bulloch',32.414565,-81.807031),('30459','GA','Statesboro','Bulloch',32.4486,-81.7833),('30460','GA','Statesboro','Bulloch',32.418713,-81.781175),('30461','GA','Statesboro','Bulloch',32.496921,-81.723093),('30464','GA','Stillmore','Emanuel',32.440523,-82.217567),('30467','GA','Sylvania','Screven',32.767933,-81.62714),('30470','GA','Tarrytown','Montgomery',32.329411,-82.539887),('30471','GA','Twin City','Emanuel',32.543651,-82.167487),('30473','GA','Uvalda','Montgomery',32.021753,-82.476932),('30474','GA','Vidalia','Toombs',32.220364,-82.4157),('30475','GA','Vidalia','Toombs',32.2153,-82.4143),('30477','GA','Wadley','Jefferson',32.872217,-82.403544),('30499','GA','Reidsville','Tattnall',32.0866,-82.118),('30501','GA','Gainesville','Hall',34.309612,-83.822029),('30502','GA','Chestnut Mountain','Hall',34.185,-83.9252),('30503','GA','Gainesville','Hall',34.2977,-83.8241),('30504','GA','Gainesville','Hall',34.267804,-83.874316),('30506','GA','Gainesville','Hall',34.346947,-83.895596),('30507','GA','Gainesville','Hall',34.256648,-83.782606),('30510','GA','Alto','Habersham',34.451791,-83.586977),('30511','GA','Baldwin','Banks',34.464272,-83.497753),('30512','GA','Blairsville','Union',34.877557,-84.002901),('30513','GA','Blue Ridge','Fannin',34.859645,-84.330269),('30514','GA','Blairsville','Union',34.8729,-83.9566),('30515','GA','Buford','Gwinnett',34.1313,-84.0267),('30516','GA','Bowersville','Hart',34.372126,-83.048525),('30517','GA','Braselton','Jackson',34.123731,-83.79847),('30518','GA','Buford','Gwinnett',34.124547,-84.020374),('30519','GA','Buford','Gwinnett',34.087437,-83.944991),('30520','GA','Canon','Franklin',34.335868,-83.083691),('30521','GA','Carnesville','Franklin',34.360635,-83.28581),('30522','GA','Cherry Log','Gilmer',34.786774,-84.355545),('30523','GA','Clarkesville','Habersham',34.6827,-83.523448),('30525','GA','Clayton','Rabun',34.889334,-83.386781),('30527','GA','Clermont','Hall',34.481368,-83.783789),('30528','GA','Cleveland','White',34.59231,-83.768733),('30529','GA','Commerce','Jackson',34.214352,-83.469907),('30530','GA','Commerce','Banks',34.222298,-83.3937),('30531','GA','Cornelia','Habersham',34.516059,-83.546224),('30533','GA','Dahlonega','Lumpkin',34.540125,-83.996053),('30534','GA','Dawsonville','Dawson',34.415386,-84.109803),('30535','GA','Demorest','Habersham',34.573552,-83.560515),('30536','GA','Ellijay','Gilmer',34.661625,-84.383072),('30537','GA','Dillard','Rabun',34.977397,-83.351779),('30538','GA','Eastanollee','Stephens',34.510599,-83.267903),('30539','GA','East Ellijay','Gilmer',34.680011,-84.471545),('30540','GA','Ellijay','Gilmer',34.691212,-84.525349),('30541','GA','Epworth','Fannin',34.937957,-84.437168),('30542','GA','Flowery Branch','Hall',34.183028,-83.90674),('30543','GA','Gillsville','Hall',34.290463,-83.649536),('30544','GA','Demorest','Habersham',34.565,-83.5452),('30545','GA','Helen','White',34.708313,-83.739951),('30546','GA','Hiawassee','Towns',34.924672,-83.729716),('30547','GA','Homer','Banks',34.355728,-83.474126),('30548','GA','Hoschton','Jackson',34.09058,-83.782397),('30549','GA','Jefferson','Jackson',34.112061,-83.587993),('30552','GA','Lakemont','Rabun',34.762455,-83.435776),('30553','GA','Lavonia','Franklin',34.456998,-83.089659),('30554','GA','Lula','Hall',34.393083,-83.659508),('30555','GA','Mc Caysville','Fannin',34.979042,-84.390319),('30557','GA','Martin','Stephens',34.492187,-83.175552),('30558','GA','Maysville','Jackson',34.25933,-83.555382),('30559','GA','Mineral Bluff','Fannin',34.9423,-84.282369),('30560','GA','Morganton','Fannin',34.888642,-84.205632),('30562','GA','Mountain City','Rabun',34.917334,-83.383672),('30563','GA','Mount Airy','Habersham',34.564317,-83.475675),('30564','GA','Murrayville','Hall',34.471046,-83.887074),('30565','GA','Nicholson','Jackson',34.093696,-83.416468),('30566','GA','Oakwood','Hall',34.236851,-83.89103),('30567','GA','Pendergrass','Jackson',34.173071,-83.683594),('30568','GA','Rabun Gap','Rabun',34.953927,-83.409679),('30571','GA','Sautee Nacoochee','White',34.700735,-83.681238),('30572','GA','Suches','Union',34.735794,-84.072487),('30573','GA','Tallulah Falls','Rabun',34.740065,-83.399001),('30575','GA','Talmo','Jackson',34.196988,-83.716108),('30576','GA','Tiger','Rabun',34.838176,-83.445799),('30577','GA','Toccoa','Stephens',34.561406,-83.317159),('30580','GA','Turnerville','Habersham',34.6866,-83.4261),('30581','GA','Wiley','Rabun',34.797611,-83.423294),('30582','GA','Young Harris','Towns',34.956429,-83.877629),('30596','GA','Alto','Habersham',34.4493,-83.5946),('30597','GA','Dahlonega','Lumpkin',34.5287,-83.9844),('30598','GA','Toccoa Falls','Stephens',34.597674,-83.362078),('30599','GA','Commerce','Jackson',34.2038,-83.4572),('30601','GA','Athens','Clarke',33.977903,-83.363235),('30602','GA','Athens','Clarke',33.943907,-83.373853),('30603','GA','Athens','Clarke',33.9597,-83.3765),('30604','GA','Athens','Clarke',33.9496,-83.41),('30605','GA','Athens','Clarke',33.923672,-83.344985),('30606','GA','Athens','Clarke',33.944574,-83.420496),('30607','GA','Athens','Clarke',34.008548,-83.437561),('30608','GA','Athens','Clarke',33.9608,-83.378),('30609','GA','Athens','Clarke',33.949464,-83.382008),('30612','GA','Athens','Clarke',33.9013,-83.3203),('30619','GA','Arnoldsville','Oglethorpe',33.872868,-83.230952),('30620','GA','Bethlehem','Barrow',33.927085,-83.75103),('30621','GA','Bishop','Oconee',33.809798,-83.489989),('30622','GA','Bogart','Oconee',33.928644,-83.513821),('30623','GA','Bostwick','Morgan',33.7385,-83.52074),('30624','GA','Bowman','Elbert',34.197255,-83.039038),('30625','GA','Buckhead','Morgan',33.531069,-83.323047),('30627','GA','Carlton','Oglethorpe',33.994998,-82.977758),('30628','GA','Colbert','Madison',34.039342,-83.212134),('30629','GA','Comer','Madison',34.073905,-83.118926),('30630','GA','Crawford','Oglethorpe',33.896186,-83.157259),('30631','GA','Crawfordville','Taliaferro',33.572774,-82.878298),('30633','GA','Danielsville','Madison',34.171156,-83.245757),('30634','GA','Dewy Rose','Elbert',34.213235,-82.944202),('30635','GA','Elberton','Elbert',34.11825,-82.823043),('30638','GA','Farmington','Oconee',33.775001,-83.424564),('30639','GA','Franklin Springs','Franklin',34.281721,-83.147463),('30641','GA','Good Hope','Walton',33.769567,-83.56475),('30642','GA','Greensboro','Greene',33.544809,-83.197066),('30643','GA','Hartwell','Hart',34.365734,-82.919068),('30645','GA','High Shoals','Morgan',33.8,-83.5012),('30646','GA','Hull','Madison',34.061732,-83.310594),('30647','GA','Ila','Madison',34.1725,-83.2922),('30648','GA','Lexington','Oglethorpe',33.879979,-83.052055),('30650','GA','Madison','Morgan',33.587395,-83.47199),('30655','GA','Monroe','Walton',33.786295,-83.708081),('30656','GA','Monroe','Walton',33.842518,-83.716859),('30660','GA','Rayle','Wilkes',33.786947,-82.948939),('30662','GA','Royston','Franklin',34.270404,-83.134118),('30663','GA','Rutledge','Morgan',33.618265,-83.608602),('30664','GA','Sharon','Taliaferro',33.556259,-82.798319),('30665','GA','Siloam','Greene',33.533155,-83.065285),('30666','GA','Statham','Barrow',33.955628,-83.587777),('30667','GA','Stephens','Oglethorpe',33.768934,-83.156355),('30668','GA','Tignall','Wilkes',33.916633,-82.69277),('30669','GA','Union Point','Greene',33.653083,-83.10082),('30671','GA','Maxeys','Oglethorpe',33.748344,-83.185388),('30673','GA','Washington','Wilkes',33.725668,-82.721883),('30677','GA','Watkinsville','Oconee',33.833132,-83.413705),('30678','GA','White Plains','Greene',33.449456,-83.08061),('30680','GA','Winder','Barrow',33.996265,-83.711189),('30683','GA','Winterville','Clarke',33.944937,-83.271225),('30701','GA','Calhoun','Gordon',34.49874,-84.935125),('30703','GA','Calhoun','Gordon',34.5026,-84.9539),('30705','GA','Chatsworth','Murray',34.758834,-84.771745),('30707','GA','Chickamauga','Walker',34.836433,-85.330187),('30708','GA','Cisco','Murray',34.970004,-84.67703),('30710','GA','Cohutta','Whitfield',34.937159,-84.947953),('30711','GA','Crandall','Murray',34.936775,-84.766436),('30719','GA','Dalton','Whitfield',34.7697,-84.9702),('30720','GA','Dalton','Whitfield',34.766683,-84.988517),('30721','GA','Dalton','Whitfield',34.781318,-84.939892),('30722','GA','Dalton','Whitfield',34.7697,-84.9702),('30724','GA','Eton','Murray',34.822176,-84.759672),('30725','GA','Flintstone','Walker',34.932159,-85.348256),('30726','GA','Graysville','Catoosa',34.975939,-85.141609),('30728','GA','La Fayette','Walker',34.697646,-85.259672),('30730','GA','Lyerly','Chattooga',34.36377,-85.416023),('30731','GA','Menlo','Chattooga',34.577815,-85.478852),('30732','GA','Oakman','Gordon',34.5663,-84.7083),('30733','GA','Plainville','Gordon',34.408927,-85.030734),('30734','GA','Ranger','Gordon',34.529568,-84.704901),('30735','GA','Resaca','Gordon',34.603999,-84.919238),('30736','GA','Ringgold','Catoosa',34.912998,-85.1476),('30738','GA','Rising Fawn','Dade',34.800937,-85.494224),('30739','GA','Rock Spring','Walker',34.802881,-85.219891),('30740','GA','Rocky Face','Whitfield',34.766814,-85.053662),('30741','GA','Rossville','Walker',34.959575,-85.272936),('30742','GA','Fort Oglethorpe','Catoosa',34.952324,-85.248142),('30746','GA','Sugar Valley','Gordon',34.570502,-85.02283),('30747','GA','Summerville','Chattooga',34.489244,-85.327682),('30750','GA','Lookout Mountain','Walker',34.949179,-85.379954),('30751','GA','Tennga','Murray',34.983987,-84.737096),('30752','GA','Trenton','Dade',34.888947,-85.525076),('30753','GA','Trion','Chattooga',34.56579,-85.301059),('30755','GA','Tunnel Hill','Whitfield',34.865607,-85.036393),('30756','GA','Varnell','Whitfield',34.900872,-84.977402),('30757','GA','Wildwood','Dade',34.95511,-85.429683),('30802','GA','Appling','Columbia',33.601437,-82.299935),('30803','GA','Avera','Jefferson',33.180096,-82.533364),('30805','GA','Blythe','Richmond',33.30145,-82.198169),('30806','GA','Boneville','Mcduffie',33.4333,-82.4411),('30807','GA','Camak','Warren',33.452929,-82.649606),('30808','GA','Dearing','Mcduffie',33.396909,-82.406234),('30809','GA','Evans','Columbia',33.560675,-82.149734),('30810','GA','Gibson','Glascock',33.233432,-82.58643),('30811','GA','Gough','Burke',33.0916,-82.2266),('30812','GA','Gracewood','Richmond',33.367921,-82.028959),('30813','GA','Grovetown','Columbia',33.457852,-82.202342),('30814','GA','Harlem','Columbia',33.417026,-82.309164),('30815','GA','Hephzibah','Richmond',33.325715,-82.08813),('30816','GA','Keysville','Burke',33.149203,-82.168221),('30817','GA','Lincolnton','Lincoln',33.792151,-82.448299),('30818','GA','Matthews','Jefferson',33.275023,-82.341113),('30819','GA','Mesena','Warren',33.4597,-82.5902),('30820','GA','Mitchell','Glascock',33.218356,-82.723151),('30821','GA','Norwood','Warren',33.482891,-82.725358),('30822','GA','Perkins','Jenkins',32.914251,-81.866753),('30823','GA','Stapleton','Jefferson',33.254677,-82.453735),('30824','GA','Thomson','Mcduffie',33.492201,-82.503009),('30828','GA','Warrenton','Warren',33.38716,-82.660851),('30830','GA','Waynesboro','Burke',33.084098,-81.978026),('30833','GA','Wrens','Jefferson',33.200655,-82.377385),('30901','GA','Augusta','Richmond',33.460147,-81.968177),('30903','GA','Augusta','Columbia',33.490166,-82.162742),('30904','GA','Augusta','Richmond',33.475585,-82.011872),('30905','GA','Augusta','Richmond',33.41631,-82.149205),('30906','GA','Augusta','Richmond',33.390424,-82.020041),('30907','GA','Augusta','Columbia',33.512366,-82.090385),('30909','GA','Augusta','Richmond',33.47629,-82.067383),('30911','GA','Augusta','Richmond',33.4712,-81.9675),('30912','GA','Augusta','Richmond',33.470169,-81.987881),('30913','GA','Augusta','Richmond',33.4712,-81.9675),('30914','GA','Augusta','Richmond',33.4695,-82.0211),('30916','GA','Augusta','Richmond',33.4213,-82.0208),('30917','GA','Augusta','Columbia',33.5167,-82.0579),('30919','GA','Augusta','Richmond',33.4692,-82.0669),('30999','GA','Augusta','Richmond',33.4712,-81.9675),('31001','GA','Abbeville','Wilcox',31.976256,-83.339665),('31002','GA','Adrian','Emanuel',32.537952,-82.583024),('31003','GA','Allentown','Wilkinson',32.593178,-83.216789),('31004','GA','Bolingbroke','Monroe',32.9496,-83.8028),('31005','GA','Bonaire','Houston',32.555133,-83.6224),('31006','GA','Butler','Taylor',32.571219,-84.243011),('31007','GA','Byromville','Dooly',32.188594,-83.927243),('31008','GA','Byron','Peach',32.644333,-83.750696),('31009','GA','Cadwell','Laurens',32.286273,-83.01145),('31010','GA','Cordele','Crisp',31.9679,-83.7811),('31011','GA','Chauncey','Dodge',32.111993,-83.068198),('31012','GA','Chester','Dodge',32.397541,-83.158952),('31013','GA','Clinchfield','Houston',32.3553,-83.709),('31014','GA','Cochran','Bleckley',32.391909,-83.337531),('31015','GA','Cordele','Crisp',31.95035,-83.776875),('31016','GA','Culloden','Monroe',32.844778,-84.120254),('31017','GA','Danville','Twiggs',32.607173,-83.239638),('31018','GA','Davisboro','Washington',32.973167,-82.616996),('31019','GA','Dexter','Laurens',32.424244,-83.051342),('31020','GA','Dry Branch','Twiggs',32.715164,-83.484867),('31021','GA','Dublin','Laurens',32.530184,-82.929493),('31022','GA','Dudley','Laurens',32.52345,-83.091845),('31023','GA','Eastman','Dodge',32.196523,-83.186167),('31024','GA','Eatonton','Putnam',33.308246,-83.35946),('31025','GA','Elko','Houston',32.346394,-83.746852),('31026','GA','Eatonton','Putnam',33.30156,-83.37881),('31027','GA','East Dub','Laurens',32.560364,-82.832965),('31028','GA','Centerville','Houston',32.632377,-83.678799),('31029','GA','Forsyth','Monroe',33.047871,-83.933917),('31030','GA','Fort Valley','Peach',32.561981,-83.87005),('31031','GA','Gordon','Wilkinson',32.896292,-83.333644),('31032','GA','Gray','Jones',33.003872,-83.566742),('31033','GA','Haddock','Jones',33.054724,-83.434549),('31034','GA','Hardwick','Baldwin',33.040103,-83.218207),('31035','GA','Harrison','Washington',32.841866,-82.709291),('31036','GA','Hawkinsville','Pulaski',32.292357,-83.50979),('31037','GA','Helena','Telfair',32.088652,-82.908282),('31038','GA','Hillsboro','Jasper',33.164431,-83.628404),('31039','GA','Howard','Taylor',32.587537,-84.389501),('31040','GA','Dublin','Laurens',32.5378,-82.9121),('31041','GA','Ideal','Macon',32.371441,-84.182168),('31042','GA','Irwinton','Wilkinson',32.773638,-83.173952),('31044','GA','Jeffersonville','Twiggs',32.625076,-83.38504),('31045','GA','Jewell','Warren',33.293347,-82.784992),('31046','GA','Juliette','Monroe',33.057565,-83.79673),('31047','GA','Kathleen','Houston',32.497033,-83.626496),('31049','GA','Kite','Johnson',32.687244,-82.515167),('31050','GA','Knoxville','Crawford',32.739006,-83.954033),('31051','GA','Lilly','Dooly',32.14922,-83.878453),('31052','GA','Lizella','Bibb',32.788379,-83.808634),('31054','GA','Mc Intyre','Wilkinson',32.86959,-83.210739),('31055','GA','Mc Rae','Telfair',32.045348,-82.891565),('31057','GA','Marshallville','Macon',32.443422,-83.932824),('31058','GA','Mauk','Marion',32.503029,-84.417078),('31059','GA','Milledgeville','Baldwin',33.0769,-83.3032),('31060','GA','Milan','Telfair',32.002859,-83.063253),('31061','GA','Milledgeville','Baldwin',33.091967,-83.242626),('31062','GA','Milledgeville','Baldwin',33.051922,-83.217545),('31063','GA','Montezuma','Macon',32.290115,-83.992247),('31064','GA','Monticello','Jasper',33.314842,-83.699813),('31065','GA','Montrose','Laurens',32.561494,-83.158607),('31066','GA','Musella','Crawford',32.789772,-84.00861),('31067','GA','Oconee','Washington',32.855341,-82.949371),('31068','GA','Oglethorpe','Macon',32.325756,-84.084926),('31069','GA','Perry','Houston',32.452573,-83.739998),('31070','GA','Pinehurst','Dooly',32.182775,-83.77485),('31071','GA','Pineview','Wilcox',32.121979,-83.518371),('31072','GA','Pitts','Wilcox',31.954486,-83.560269),('31075','GA','Rentz','Laurens',32.363246,-82.969833),('31076','GA','Reynolds','Taylor',32.541965,-84.100923),('31077','GA','Rhine','Dodge',31.958263,-83.195222),('31078','GA','Roberta','Crawford',32.704967,-84.035426),('31079','GA','Rochelle','Wilcox',31.927743,-83.455762),('31081','GA','Rupert','Taylor',32.419232,-84.282732),('31082','GA','Sandersville','Washington',32.989066,-82.863301),('31083','GA','Scotland','Telfair',32.048726,-82.817939),('31084','GA','Seville','Wilcox',31.961855,-83.604122),('31085','GA','Shady Dale','Jasper',33.421359,-83.613271),('31086','GA','Smarr','Monroe',32.9852,-83.8822),('31087','GA','Sparta','Hancock',33.249942,-83.020137),('31088','GA','Warner Robins','Houston',32.588577,-83.655817),('31089','GA','Tennille','Washington',32.890956,-82.837255),('31090','GA','Toomsboro','Wilkinson',32.829744,-83.068206),('31091','GA','Unadilla','Dooly',32.244012,-83.714658),('31092','GA','Vienna','Dooly',32.090531,-83.799894),('31093','GA','Warner Robins','Houston',32.637699,-83.643294),('31094','GA','Warthen','Washington',33.112574,-82.791138),('31095','GA','Warner Robins','Houston',32.6208,-83.6),('31096','GA','Wrightsville','Johnson',32.729419,-82.707827),('31097','GA','Yatesville','Upson',32.909063,-84.145809),('31098','GA','Warner Robins','Houston',32.612587,-83.588302),('31099','GA','Warner Robins','Houston',32.6208,-83.6),('31106','GA','Atlanta','Fulton',33.7488,-84.388),('31107','GA','Atlanta','Fulton',33.7488,-84.388),('31119','GA','Atlanta','Dekalb',33.8571,-84.3462),('31120','GA','Atlanta','Fulton',33.7487,-84.3877),('31126','GA','Atlanta','Fulton',33.8473,-84.3606),('31131','GA','Atlanta','Fulton',33.6927,-84.5109),('31136','GA','Atlanta','Fulton',33.7473,-84.3824),('31139','GA','Atlanta','Fulton',33.8705,-84.4611),('31141','GA','Atlanta','Dekalb',33.8872,-84.2897),('31145','GA','Atlanta','Dekalb',33.8491,-84.2835),('31146','GA','Atlanta','Dekalb',33.9246,-84.3381),('31150','GA','Atlanta','Fulton',33.9861,-84.3439),('31156','GA','Atlanta','Fulton',33.9605,-84.3659),('31169','GA','Peachtree City','Fayette',33.40147,-84.462711),('31191','GA','Atlanta','Fulton',33.7917,-84.4476),('31192','GA','Atlanta','Fulton',33.6222,-84.53),('31193','GA','Atlanta','Fulton',33.6605,-84.3858),('31195','GA','Atlanta','Fulton',33.7488,-84.388),('31196','GA','Atlanta','Fulton',33.7488,-84.388),('31197','GA','Atlanta','Fulton',33.7488,-84.388),('31198','GA','Atlanta','Fulton',33.7488,-84.388),('31199','GA','Atlanta','Fulton',33.7488,-84.388),('31201','GA','Macon','Bibb',32.831691,-83.634802),('31202','GA','Macon','Bibb',32.8405,-83.6325),('31203','GA','Macon','Bibb',32.8405,-83.6325),('31204','GA','Macon','Bibb',32.842546,-83.674124),('31205','GA','Macon','Bibb',32.7501,-83.658),('31206','GA','Macon','Bibb',32.797766,-83.674301),('31207','GA','Macon','Bibb',32.827125,-83.647938),('31208','GA','Macon','Bibb',32.8405,-83.6325),('31209','GA','Macon','Bibb',32.8405,-83.6325),('31210','GA','Macon','Bibb',32.893488,-83.722608),('31211','GA','Macon','Bibb',32.879815,-83.600331),('31212','GA','Macon','Bibb',32.7509,-83.6772),('31213','GA','Macon','Bibb',32.7509,-83.6772),('31216','GA','Macon','Bibb',32.723139,-83.677057),('31217','GA','Macon','Bibb',32.841949,-83.556649),('31220','GA','Macon','Bibb',32.864621,-83.791918),('31221','GA','Macon','Bibb',32.88,-83.821),('31294','GA','Macon','Bibb',32.8405,-83.6325),('31295','GA','Macon','Bibb',32.8405,-83.6325),('31296','GA','Macon','Bibb',32.8405,-83.6325),('31297','GA','Macon','Bibb',32.7032,-83.65),('31301','GA','Allenhurst','Liberty',31.760925,-81.612278),('31302','GA','Bloomingdale','Effingham',32.120029,-81.332923),('31303','GA','Clyo','Effingham',32.50019,-81.293654),('31304','GA','Crescent','Mcintosh',31.4969,-81.3683),('31305','GA','Darien','Mcintosh',31.387478,-81.415012),('31307','GA','Eden','Effingham',32.172843,-81.398602),('31308','GA','Ellabell','Bryan',32.17325,-81.478427),('31309','GA','Fleming','Liberty',31.891975,-81.427824),('31310','GA','Hinesville','Liberty',31.8488,-81.5971),('31312','GA','Guyton','Effingham',32.286073,-81.382972),('31313','GA','Hinesville','Liberty',31.83267,-81.621684),('31314','GA','Fort Stewart','Liberty',31.870254,-81.615684),('31315','GA','Fort Stewart','Liberty',31.890004,-81.597308),('31316','GA','Ludowici','Long',31.734546,-81.745335),('31318','GA','Meldrim','Effingham',32.143991,-81.374982),('31319','GA','Meridian','Mcintosh',31.478486,-81.345283),('31320','GA','Midway','Liberty',31.789485,-81.375658),('31321','GA','Pembroke','Bryan',32.164605,-81.658081),('31322','GA','Pooler','Chatham',32.105149,-81.25445),('31323','GA','Riceboro','Liberty',31.719045,-81.439673),('31324','GA','Richmond Hill','Bryan',31.897937,-81.291535),('31326','GA','Rincon','Effingham',32.292819,-81.229725),('31327','GA','Sapelo Island','Mcintosh',31.444106,-81.267247),('31328','GA','Tybee Island','Chatham',32.006241,-80.852286),('31329','GA','Springfield','Effingham',32.390552,-81.320779),('31331','GA','Townsend','Mcintosh',31.525876,-81.417764),('31333','GA','Walthourville','Liberty',31.77789,-81.645345),('31401','GA','Savannah','Chatham',32.069263,-81.093709),('31402','GA','Savannah','Chatham',32.0828,-81.0992),('31403','GA','Savannah','Chatham',32.0454,-81.1094),('31404','GA','Savannah','Chatham',32.047643,-81.064959),('31405','GA','Savannah','Chatham',32.042435,-81.127097),('31406','GA','Savannah','Chatham',31.988142,-81.092212),('31407','GA','Savannah','Chatham',32.173913,-81.188444),('31408','GA','Savannah','Chatham',32.106694,-81.169247),('31409','GA','Savannah','Chatham',32.016111,-81.144672),('31410','GA','Savannah','Chatham',32.020537,-80.992496),('31411','GA','Savannah','Chatham',31.931564,-81.042669),('31412','GA','Savannah','Chatham',32.0771,-81.0927),('31414','GA','Savannah','Chatham',32.0436,-81.0639),('31415','GA','Savannah','Chatham',32.077484,-81.121711),('31416','GA','Savannah','Chatham',32.005,-81.0957),('31418','GA','Savannah','Chatham',32.1137,-81.1642),('31419','GA','Savannah','Chatham',31.999352,-81.221333),('31420','GA','Savannah','Chatham',32.0722,-81.1102),('31421','GA','Savannah','Chatham',32.0873,-81.0856),('31501','GA','Waycross','Ware',31.220302,-82.350872),('31502','GA','Waycross','Ware',31.213,-82.3611),('31503','GA','Waycross','Ware',31.204423,-82.385318),('31510','GA','Alma','Bacon',31.556836,-82.462515),('31512','GA','Ambrose','Coffee',31.566078,-83.01614),('31513','GA','Baxley','Appling',31.77104,-82.349257),('31515','GA','Baxley','Appling',31.7839,-82.3298),('31516','GA','Blackshear','Pierce',31.306153,-82.253891),('31518','GA','Bristol','Appling',31.512607,-82.185093),('31519','GA','Broxton','Coffee',31.655409,-82.871914),('31520','GA','Brunswick','Glynn',31.170465,-81.493667),('31521','GA','Brunswick','Glynn',31.1497,-81.4916),('31522','GA','Saint Simons Island','Glynn',31.193324,-81.373831),('31523','GA','Brunswick','Glynn',31.201184,-81.602334),('31524','GA','Brunswick','Glynn',31.3085,-81.5191),('31525','GA','Brunswick','Glynn',31.263059,-81.497731),('31527','GA','Jekyll Island','Glynn',31.069472,-81.425347),('31532','GA','Denton','Jeff Davis',31.719621,-82.738436),('31533','GA','Douglas','Coffee',31.529841,-82.837474),('31534','GA','Douglas','Coffee',31.5088,-82.8462),('31535','GA','Douglas','Coffee',31.461219,-82.867955),('31537','GA','Folkston','Charlton',30.872786,-82.015721),('31539','GA','Hazlehurst','Jeff Davis',31.84177,-82.592369),('31542','GA','Hoboken','Brantley',31.151743,-82.136841),('31543','GA','Hortense','Brantley',31.330787,-81.835354),('31544','GA','Jacksonville','Telfair',31.848058,-82.940472),('31545','GA','Jesup','Wayne',31.63412,-81.910286),('31546','GA','Jesup','Wayne',31.552143,-81.830879),('31547','GA','Kings Bay','Camden',30.79032,-81.56555),('31548','GA','Kingsland','Camden',30.794328,-81.679991),('31549','GA','Lumber City','Telfair',31.928619,-82.693453),('31550','GA','Manor','Ware',31.122871,-82.583538),('31551','GA','Mershon','Pierce',31.488074,-82.266915),('31552','GA','Millwood','Ware',31.28876,-82.620067),('31553','GA','Nahunta','Brantley',31.181701,-81.972104),('31554','GA','Nicholls','Coffee',31.497513,-82.620494),('31555','GA','Odum','Wayne',31.680798,-82.057647),('31556','GA','Offerman','Pierce',31.412498,-82.109879),('31557','GA','Patterson','Pierce',31.384963,-82.109819),('31558','GA','Saint Marys','Camden',30.769267,-81.55075),('31560','GA','Screven','Wayne',31.513148,-82.038726),('31561','GA','Sea Island','Glynn',31.195625,-81.341762),('31562','GA','Saint George','Charlton',30.518085,-82.094113),('31563','GA','Surrency','Appling',31.72063,-82.187438),('31564','GA','Waresboro','Ware',31.2477,-82.4738),('31565','GA','Waverly','Camden',31.07585,-81.652125),('31566','GA','Waynesville','Brantley',31.201006,-81.800149),('31567','GA','West Green','Coffee',31.617943,-82.718471),('31568','GA','White Oak','Camden',31.013362,-81.819101),('31569','GA','Woodbine','Camden',30.914669,-81.693012),('31598','GA','Jesup','Wayne',31.5039,-81.8264),('31599','GA','Jesup','Wayne',31.5693,-81.8864),('31601','GA','Valdosta','Lowndes',30.806932,-83.293171),('31602','GA','Valdosta','Lowndes',30.867941,-83.307245),('31603','GA','Valdosta','Lowndes',30.7493,-83.3371),('31604','GA','Valdosta','Lowndes',30.9504,-83.238),('31605','GA','Valdosta','Lowndes',30.921645,-83.249378),('31606','GA','Valdosta','Lowndes',30.806227,-83.198572),('31620','GA','Adel','Cook',31.129185,-83.428988),('31622','GA','Alapaha','Berrien',31.385168,-83.215745),('31623','GA','Argyle','Clinch',31.074849,-82.645739),('31624','GA','Axson','Atkinson',31.317102,-82.726741),('31625','GA','Barney','Brooks',31.001974,-83.525476),('31626','GA','Boston','Thomas',30.784933,-83.791732),('31627','GA','Cecil','Cook',31.045545,-83.393553),('31629','GA','Dixie','Brooks',30.804734,-83.681575),('31630','GA','Du Pont','Clinch',30.949913,-82.876926),('31631','GA','Fargo','Clinch',30.703315,-82.588456),('31632','GA','Hahira','Lowndes',30.989275,-83.363791),('31634','GA','Homerville','Clinch',31.0384,-82.757958),('31635','GA','Lakeland','Lanier',31.068506,-83.062172),('31636','GA','Lake Park','Lowndes',30.724164,-83.144217),('31637','GA','Lenox','Cook',31.292152,-83.45314),('31638','GA','Morven','Brooks',30.934361,-83.505362),('31639','GA','Nashville','Berrien',31.198714,-83.219761),('31641','GA','Naylor','Lowndes',30.941773,-83.091348),('31642','GA','Pearson','Atkinson',31.287073,-82.86578),('31643','GA','Quitman','Brooks',30.783341,-83.548805),('31645','GA','Ray City','Berrien',31.062312,-83.200725),('31647','GA','Sparks','Cook',31.186254,-83.439509),('31648','GA','Statenville','Echols',30.706012,-83.019006),('31649','GA','Stockton','Lanier',30.958808,-83.005327),('31650','GA','Willacoochee','Atkinson',31.37865,-83.024662),('31698','GA','Valdosta','Lowndes',30.848991,-83.28964),('31699','GA','Moody A F B','Lowndes',30.975053,-83.204093),('31701','GA','Albany','Dougherty',31.578433,-84.160421),('31702','GA','Albany','Dougherty',31.5783,-84.1558),('31703','GA','Albany','Dougherty',31.5783,-84.1558),('31704','GA','Albany','Dougherty',31.5509,-84.068),('31705','GA','Albany','Dougherty',31.553287,-84.091766),('31706','GA','Albany','Dougherty',31.5783,-84.1558),('31707','GA','Albany','Dougherty',31.587015,-84.195359),('31708','GA','Albany','Dougherty',31.5221,-84.2955),('31709','GA','Americus','Sumter',32.067391,-84.194107),('31711','GA','Andersonville','Sumter',32.198521,-84.112617),('31712','GA','Arabi','Crisp',31.836548,-83.713918),('31714','GA','Ashburn','Turner',31.707918,-83.671625),('31716','GA','Baconton','Mitchell',31.376172,-84.124225),('31719','GA','Americus','Sumter',32.083984,-84.253693),('31720','GA','Barwick','Thomas',30.892046,-83.736679),('31721','GA','Albany','Dougherty',31.525261,-84.301465),('31722','GA','Berlin','Colquitt',31.067453,-83.622768),('31727','GA','Brookfield','Tift',31.4183,-83.3911),('31730','GA','Camilla','Mitchell',31.207439,-84.258982),('31733','GA','Chula','Tift',31.59319,-83.489763),('31735','GA','Cobb','Sumter',31.964289,-83.950144),('31738','GA','Coolidge','Thomas',31.010079,-83.869388),('31739','GA','Cotton','Mitchell',31.1613,-84.0669),('31743','GA','De Soto','Sumter',31.912708,-84.026851),('31744','GA','Doerun','Colquitt',31.332508,-83.919491),('31747','GA','Ellenton','Colquitt',31.176703,-83.587067),('31749','GA','Enigma','Berrien',31.428044,-83.342444),('31750','GA','Fitzgerald','Ben Hill',31.718739,-83.239451),('31753','GA','Funston','Colquitt',31.1997,-83.8736),('31756','GA','Hartsfield','Colquitt',31.176891,-83.962264),('31757','GA','Thomasville','Thomas',30.882456,-83.922702),('31758','GA','Thomasville','Thomas',30.862,-83.911),('31760','GA','Irwinville','Irwin',31.6531,-83.4014),('31763','GA','Leesburg','Lee',31.704035,-84.172517),('31764','GA','Leslie','Sumter',31.976312,-84.088839),('31765','GA','Meigs','Thomas',31.081177,-84.050604),('31768','GA','Moultrie','Colquitt',31.17855,-83.804421),('31769','GA','Mystic','Irwin',31.6219,-83.3358),('31771','GA','Norman Park','Colquitt',31.252761,-83.670966),('31772','GA','Oakfield','Worth',31.724155,-83.961027),('31773','GA','Ochlocknee','Thomas',30.974047,-84.060261),('31774','GA','Ocilla','Irwin',31.587285,-83.279103),('31775','GA','Omega','Tift',31.331794,-83.602254),('31776','GA','Moultrie','Colquitt',31.1786,-83.7839),('31778','GA','Pavo','Thomas',30.968045,-83.717211),('31779','GA','Pelham','Mitchell',31.11452,-84.160931),('31780','GA','Plains','Sumter',32.031757,-84.402769),('31781','GA','Poulan','Worth',31.526002,-83.787549),('31782','GA','Putney','Dougherty',31.47,-84.1177),('31783','GA','Rebecca','Turner',31.754052,-83.478916),('31784','GA','Sale City','Mitchell',31.25804,-84.028769),('31787','GA','Smithville','Lee',31.901761,-84.251523),('31788','GA','Moultrie','Colquitt',31.131403,-83.708013),('31789','GA','Sumner','Worth',31.507769,-83.735698),('31790','GA','Sycamore','Turner',31.652476,-83.577968),('31791','GA','Sylvester','Worth',31.536986,-83.860431),('31792','GA','Thomasville','Thomas',30.806768,-84.012637),('31793','GA','Tifton','Tift',31.472103,-83.565586),('31794','GA','Tifton','Tift',31.457127,-83.488281),('31795','GA','Ty Ty','Tift',31.473246,-83.667331),('31796','GA','Warwick','Worth',31.792133,-83.885823),('31798','GA','Wray','Irwin',31.609328,-83.058597),('31799','GA','Thomasville','Thomas',30.759,-84.0489),('31801','GA','Box Springs','Marion',32.516428,-84.608642),('31803','GA','Buena Vista','Marion',32.310815,-84.525076),('31804','GA','Cataula','Harris',32.652433,-84.888419),('31805','GA','Cusseta','Chattahoochee',32.287594,-84.755087),('31806','GA','Ellaville','Schley',32.248645,-84.312489),('31807','GA','Ellerslie','Harris',32.637651,-84.796362),('31808','GA','Fortson','Harris',32.631009,-85.012245),('31810','GA','Geneva','Talbot',32.575899,-84.541402),('31811','GA','Hamilton','Harris',32.75047,-84.930117),('31812','GA','Junction City','Talbot',32.625223,-84.42555),('31814','GA','Louvale','Stewart',32.206516,-84.855546),('31815','GA','Lumpkin','Stewart',32.03672,-84.825124),('31816','GA','Manchester','Meriwether',32.865768,-84.614032),('31820','GA','Midland','Muscogee',32.570817,-84.833196),('31821','GA','Omaha','Stewart',32.132984,-84.974378),('31822','GA','Pine Mountain','Harris',32.85881,-84.885177),('31823','GA','Pine Mountain Valley','Harris',32.8053,-84.821561),('31824','GA','Preston','Webster',32.059105,-84.533342),('31825','GA','Richland','Stewart',32.110115,-84.657799),('31826','GA','Shiloh','Harris',32.802057,-84.693653),('31827','GA','Talbotton','Talbot',32.689019,-84.531292),('31829','GA','Upatoi','Muscogee',32.559738,-84.74068),('31830','GA','Warm Springs','Meriwether',32.895471,-84.711849),('31831','GA','Waverly Hall','Harris',32.696976,-84.712271),('31832','GA','Weston','Webster',31.957981,-84.614915),('31833','GA','West Point','Troup',32.864244,-85.131359),('31836','GA','Woodland','Talbot',32.796402,-84.53509),('31901','GA','Columbus','Muscogee',32.472322,-84.981665),('31902','GA','Columbus','Muscogee',32.4608,-84.9877),('31903','GA','Columbus','Muscogee',32.424166,-84.947002),('31904','GA','Columbus','Muscogee',32.514022,-84.979208),('31905','GA','Fort Benning','Chattahoochee',32.366764,-84.914361),('31906','GA','Columbus','Muscogee',32.466875,-84.950156),('31907','GA','Columbus','Muscogee',32.479594,-84.909796),('31908','GA','Columbus','Muscogee',32.4608,-84.9877),('31909','GA','Columbus','Muscogee',32.535973,-84.925712),('31914','GA','Columbus','Muscogee',32.5573,-85.0045),('31917','GA','Columbus','Muscogee',32.4608,-84.9877),('31993','GA','Columbus','Muscogee',32.4608,-84.9877),('31995','GA','Fort Benning','Muscogee',32.4087,-84.9508),('31997','GA','Columbus','Muscogee',32.4608,-84.9877),('31998','GA','Columbus','Muscogee',32.4608,-84.9877),('31999','GA','Columbus','Muscogee',32.4608,-84.9877),('32003','FL','Orange Park','Clay',30.096072,-81.71333),('32004','FL','Ponte Vedra Beach','Saint Johns',30.2394,-81.3858),('32006','FL','Fleming Island','Clay',30.107,-81.7167),('32007','FL','Bostwick','Putnam',29.7738,-81.6372),('32008','FL','Branford','Suwannee',29.925379,-82.908222),('32009','FL','Bryceville','Nassau',30.421697,-81.957921),('32011','FL','Callahan','Nassau',30.563505,-81.835005),('32013','FL','Day','Lafayette',30.193758,-83.292663),('32024','FL','Lake City','Columbia',30.108697,-82.71475),('32025','FL','Lake City','Columbia',30.15553,-82.618643),('32026','FL','Raiford','Bradford',30.061138,-82.182542),('32030','FL','Doctors Inlet','Clay',30.1,-81.7763),('32033','FL','Elkton','St. Johns',29.787856,-81.446744),('32034','FL','Fernandina Beach','Nassau',30.631641,-81.469417),('32035','FL','Fernandina Beach','Nassau',30.6694,-81.4627),('32038','FL','Fort White','Columbia',29.929305,-82.715164),('32040','FL','Glen Saint Mary','Baker',30.257495,-82.215494),('32041','FL','Yulee','Nassau',30.6516,-81.625),('32042','FL','Graham','Bradford',29.86,-82.2186),('32043','FL','Green Cove Springs','Clay',29.984292,-81.730774),('32044','FL','Hampton','Bradford',29.864726,-82.159814),('32046','FL','Hilliard','Nassau',30.687638,-81.933931),('32050','FL','Middleburg','Clay',30.0722,-81.8632),('32052','FL','Jasper','Hamilton',30.490829,-82.944614),('32053','FL','Jennings','Hamilton',30.575561,-83.12606),('32054','FL','Lake Butler','Union',30.014928,-82.386973),('32055','FL','Lake City','Columbia',30.216109,-82.649542),('32056','FL','Lake City','Columbia',30.2988,-82.6063),('32058','FL','Lawtey','Bradford',30.077919,-82.08512),('32059','FL','Lee','Madison',30.393164,-83.267355),('32060','FL','Live Oak','Suwannee',30.289438,-83.046593),('32061','FL','Lulu','Columbia',30.101348,-82.503768),('32062','FL','Mc Alpin','Suwannee',30.136188,-82.962663),('32063','FL','Macclenny','Baker',30.264258,-82.121896),('32064','FL','Live Oak','Suwannee',30.29501,-82.985697),('32065','FL','Orange Park','Clay',30.144116,-81.791865),('32066','FL','Mayo','Lafayette',30.063676,-83.209178),('32067','FL','Orange Park','Clay',30.1644,-81.7227),('32068','FL','Middleburg','Clay',30.077129,-81.868283),('32071','FL','O Brien','Suwannee',30.039828,-82.948383),('32072','FL','Olustee','Baker',30.193957,-82.427417),('32073','FL','Orange Park','Clay',30.173798,-81.735982),('32079','FL','Penney Farms','Clay',29.979126,-81.809952),('32080','FL','Saint Augustine','St. Johns',29.835703,-81.274901),('32081','FL','Ponte Vedra','St. Johns',30.11468,-81.417466),('32082','FL','Ponte Vedra Beach','St. Johns',30.186708,-81.381107),('32083','FL','Raiford','Union',30.070426,-82.226768),('32084','FL','Saint Augustine','St. Johns',29.902507,-81.330523),('32085','FL','Saint Augustine','Saint Johns',29.8914,-81.3167),('32086','FL','Saint Augustine','St. Johns',29.805218,-81.311974),('32087','FL','Sanderson','Baker',30.356082,-82.263623),('32091','FL','Starke','Bradford',29.944039,-82.093071),('32092','FL','Saint Augustine','St. Johns',29.964644,-81.52369),('32094','FL','Wellborn','Suwannee',30.212824,-82.819289),('32095','FL','Saint Augustine','St. Johns',29.991767,-81.369624),('32096','FL','White Springs','Hamilton',30.378143,-82.745463),('32097','FL','Yulee','Nassau',30.645691,-81.60854),('32099','FL','Jacksonville','Duval',30.3163,-81.4175),('32102','FL','Astor','Lake',29.164372,-81.546631),('32105','FL','Barberville','Volusia',29.1869,-81.4211),('32110','FL','Bunnell','Flagler',29.448124,-81.304544),('32111','FL','Candler','Marion',29.0713,-81.9738),('32112','FL','Crescent City','Putnam',29.433923,-81.551324),('32113','FL','Citra','Marion',29.39227,-82.089892),('32114','FL','Daytona Beach','Volusia',29.203591,-81.037021),('32115','FL','Daytona Beach','Volusia',29.2105,-81.023),('32116','FL','Daytona Beach','Volusia',29.2105,-81.023),('32117','FL','Daytona Beach','Volusia',29.23839,-81.05525),('32118','FL','Daytona Beach','Volusia',29.200553,-80.99717),('32119','FL','Daytona Beach','Volusia',29.164167,-81.021607),('32120','FL','Daytona Beach','Volusia',29.2105,-81.023),('32121','FL','Daytona Beach','Volusia',29.2105,-81.023),('32122','FL','Daytona Beach','Volusia',29.1479,-81.03),('32123','FL','Port Ora','Volusia',29.1479,-81.03),('32124','FL','Daytona Beach','Volusia',29.172075,-81.126272),('32125','FL','Daytona Beach','Volusia',29.2105,-81.023),('32126','FL','Daytona Beach','Volusia',29.2105,-81.023),('32127','FL','Port Orange','Volusia',29.114414,-80.98173),('32128','FL','Port Orange','Volusia',29.092779,-81.048616),('32129','FL','Port Orange','Volusia',29.138541,-81.024206),('32130','FL','De Leon Springs','Volusia',29.136306,-81.338572),('32131','FL','East Palatka','Putnam',29.662348,-81.5847),('32132','FL','Edgewater','Volusia',28.977037,-80.912598),('32133','FL','Eastlake Weir','Marion',29.017567,-81.909596),('32134','FL','Fort Mc Coy','Marion',29.390667,-81.871807),('32135','FL','Palm Coast','Flagler',29.5847,-81.208),('32136','FL','Flagler Beach','Flagler',29.466699,-81.132173),('32137','FL','Palm Coast','Flagler',29.578403,-81.215395),('32138','FL','Grandin','Putnam',29.727276,-81.9205),('32139','FL','Georgetown','Putnam',29.385019,-81.610803),('32140','FL','Florahome','Putnam',29.763094,-81.87056),('32141','FL','Edgewater','Volusia',28.945042,-80.895495),('32142','FL','Palm Coast','Flagler',29.4788,-81.2142),('32143','FL','Palm Coast','Flagler',29.473079,-81.132317),('32145','FL','Hastings','St. Johns',29.660381,-81.458704),('32147','FL','Hollister','Putnam',29.627603,-81.800694),('32148','FL','Interlachen','Putnam',29.64614,-81.882954),('32149','FL','Edgar, F','Putnam',29.6236,-81.8905),('32157','FL','Lake Como','Putnam',29.4796,-81.571449),('32158','FL','Lady Lake','Lake',28.9172,-81.923),('32159','FL','Lady Lake','Lake',28.928059,-81.932393),('32160','FL','Lake Geneva','Clay',29.9004,-81.9457),('32162','FL','The Vill','Sumter',28.917748,-81.994689),('32163','FL','The Villages','Sumter',28.9338,-81.9914),('32164','FL','Palm Coast','Flagler',29.496421,-81.222182),('32168','FL','New Smyrna Beach','Volusia',29.018708,-80.965897),('32169','FL','New Smyrna Beach','Volusia',29.006751,-80.883782),('32170','FL','New Smyrna Beach','Volusia',29.0385,-80.8985),('32173','FL','Ormond Beach','Volusia',29.2855,-81.0561),('32174','FL','Ormond Beach','Volusia',29.28516,-81.108152),('32175','FL','Ormond Beach','Volusia',29.2855,-81.0561),('32176','FL','Ormond Beach','Volusia',29.318374,-81.056885),('32177','FL','Palatka','Putnam',29.65999,-81.673043),('32178','FL','Palatka','Putnam',29.7289,-81.6807),('32179','FL','Ocklawaha','Marion',29.064054,-81.884199),('32180','FL','Pierson','Volusia',29.227684,-81.449303),('32181','FL','Pomona Park','Putnam',29.483147,-81.606564),('32182','FL','Orange Springs','Marion',29.493034,-81.965233),('32183','FL','Ocklawaha','Marion',29.084013,-81.834901),('32185','FL','Putnam Hall','Putnam',29.740034,-81.95858),('32187','FL','San Mateo','Putnam',29.599268,-81.573744),('32189','FL','Satsuma','Putnam',29.55683,-81.64741),('32190','FL','Seville','Volusia',29.334227,-81.51166),('32192','FL','Sparr','Marion',29.3383,-82.1127),('32193','FL','Welaka','Putnam',29.480261,-81.671309),('32195','FL','Weirsdale','Marion',28.984922,-81.909776),('32198','FL','Daytona Beach','Volusia',29.2105,-81.023),('32201','FL','Jacksonville','Duval',30.3294,-81.6613),('32202','FL','Jacksonville','Duval',30.327358,-81.650281),('32203','FL','Jacksonville','Duval',30.3163,-81.4175),('32204','FL','Jacksonville','Duval',30.323441,-81.681931),('32205','FL','Jacksonville','Duval',30.305504,-81.71882),('32206','FL','Jacksonville','Duval',30.350866,-81.646456),('32207','FL','Jacksonville','Duval',30.295527,-81.634994),('32208','FL','Jacksonville','Duval',30.392304,-81.679667),('32209','FL','Jacksonville','Duval',30.355505,-81.69043),('32210','FL','Jacksonville','Duval',30.268979,-81.7421),('32211','FL','Jacksonville','Duval',30.332346,-81.586101),('32212','FL','Jacksonville','Duval',30.214966,-81.687118),('32214','FL','Jacksonville','Duval',30.2128,-81.6867),('32215','FL','Jacksonville','Duval',30.23289,-81.914859),('32216','FL','Jacksonville','Duval',30.283823,-81.586559),('32217','FL','Jacksonville','Duval',30.239592,-81.618202),('32218','FL','Jacksonville','Duval',30.448745,-81.658039),('32219','FL','Jacksonville','Duval',30.409041,-81.755429),('32220','FL','Jacksonville','Duval',30.326445,-81.812985),('32221','FL','Jacksonville','Duval',30.283344,-81.818117),('32222','FL','Jacksonville','Duval',30.224886,-81.814975),('32223','FL','Jacksonville','Duval',30.157603,-81.629844),('32224','FL','Jacksonville','Duval',30.283417,-81.463011),('32225','FL','Jacksonville','Duval',30.35182,-81.509061),('32226','FL','Jacksonville','Duval',30.447873,-81.540338),('32227','FL','Jacksonville','Duval',30.383673,-81.407489),('32228','FL','Jacksonville','Duval',30.393048,-81.399718),('32229','FL','Jacksonville','Duval',30.4937,-81.6715),('32230','FL','Jacksonville','Duval',30.3268,-81.7339),('32231','FL','Jacksonville','Duval',30.3163,-81.4175),('32232','FL','Jacksonville','Duval',30.3163,-81.4175),('32233','FL','Atlantic Beach','Duval',30.345513,-81.413092),('32234','FL','Jacksonville','Duval',30.226001,-81.983522),('32235','FL','Jacksonville','Duval',30.2908,-81.6316),('32236','FL','Jacksonville','Duval',30.3118,-81.7379),('32237','FL','Jacksonville','Duval',30.2006,-81.6157),('32238','FL','Jacksonville','Duval',30.2469,-81.7387),('32239','FL','Jacksonville','Duval',30.3521,-81.5688),('32240','FL','Jacksonville Beach','Duval',30.2778,-81.411),('32241','FL','Jacksonville','Duval',30.1535,-81.6326),('32244','FL','Jacksonville','Duval',30.222494,-81.756704),('32245','FL','Jacksonville','Duval',30.2482,-81.5525),('32246','FL','Jacksonville','Duval',30.29685,-81.521738),('32247','FL','Jacksonville','Duval',30.2937,-81.627),('32250','FL','Jacksonville Beach','Duval',30.282707,-81.39901),('32254','FL','Jacksonville','Duval',30.335848,-81.728113),('32255','FL','Jacksonville','Duval',30.2482,-81.5525),('32256','FL','Jacksonville','Duval',30.208538,-81.545822),('32257','FL','Jacksonville','Duval',30.194282,-81.604579),('32258','FL','Jacksonville','Duval',30.140666,-81.552716),('32259','FL','Saint Johns','St. Johns',30.087821,-81.593958),('32260','FL','Jacksonville','Saint Johns',30.0759,-81.5803),('32266','FL','Neptune Beach','Duval',30.317199,-81.404259),('32267','FL','Jacksonville','Duval',30.3826,-81.4199),('32277','FL','Jacksonville','Duval',30.364234,-81.590759),('32290','FL','Jacksonville','Duval',30.3318,-81.6555),('32301','FL','Tallahassee','Leon',30.430023,-84.268175),('32302','FL','Tallahassee','Leon',30.4418,-84.284),('32303','FL','Tallahassee','Leon',30.486937,-84.321065),('32304','FL','Tallahassee','Leon',30.448802,-84.326898),('32305','FL','Tallahassee','Leon',30.360767,-84.296321),('32306','FL','Tallahassee','Leon',30.4424,-84.303),('32307','FL','Tallahassee','Leon',30.4241,-84.2856),('32308','FL','Tallahassee','Leon',30.47429,-84.233207),('32309','FL','Tallahassee','Leon',30.542333,-84.135126),('32310','FL','Tallahassee','Leon',30.406524,-84.389135),('32311','FL','Tallahassee','Leon',30.402585,-84.18933),('32312','FL','Tallahassee','Leon',30.565269,-84.243958),('32313','FL','Tallahassee','Leon',30.4126,-84.2834),('32314','FL','Tallahassee','Leon',30.4126,-84.2834),('32315','FL','Tallahassee','Leon',30.4648,-84.2854),('32316','FL','Tallahassee','Leon',30.437,-84.2979),('32317','FL','Tallahassee','Leon',30.459769,-84.144416),('32318','FL','Tallahassee','Leon',30.5567,-84.1766),('32320','FL','Apalachicola','Franklin',29.732798,-85.014776),('32321','FL','Bristol','Liberty',30.288313,-84.98774),('32322','FL','Carrabelle','Franklin',29.875988,-84.639144),('32323','FL','Lanark Village','Franklin',29.891511,-84.613733),('32324','FL','Chattahoochee','Gadsden',30.676023,-84.809801),('32326','FL','Crawfordville','Wakulla',30.1758,-84.3752),('32327','FL','Crawfordville','Wakulla',30.190466,-84.318422),('32328','FL','Eastpoint','Franklin',29.740314,-84.896407),('32329','FL','Apalachicola','Franklin',29.7255,-84.9833),('32330','FL','Greensboro','Gadsden',30.571647,-84.745258),('32331','FL','Greenville','Madison',30.435747,-83.643799),('32332','FL','Gretna','Gadsden',30.615717,-84.662479),('32333','FL','Havana','Gadsden',30.607737,-84.417592),('32334','FL','Hosford','Liberty',30.335511,-84.763024),('32335','FL','Sumatra','Liberty',30.060351,-85.044776),('32336','FL','Lamont','Jefferson',30.263057,-83.865499),('32337','FL','Lloyd','Jefferson',30.478502,-84.020839),('32340','FL','Madison','Madison',30.477094,-83.409087),('32341','FL','Madison','Madison',30.4675,-83.4032),('32343','FL','Midway','Gadsden',30.493498,-84.452003),('32344','FL','Monticello','Jefferson',30.498449,-83.899266),('32345','FL','Monticello','Jefferson',30.545,-83.8702),('32346','FL','Panacea','Wakulla',29.998086,-84.387039),('32347','FL','Perry','Taylor',30.135153,-83.595513),('32348','FL','Perry','Taylor',30.01689,-83.584246),('32350','FL','Pinetta','Madison',30.58997,-83.331991),('32351','FL','Quincy','Gadsden',30.556212,-84.634595),('32352','FL','Quincy','Gadsden',30.64621,-84.597366),('32353','FL','Quincy','Gadsden',30.5762,-84.5924),('32355','FL','Saint Marks','Wakulla',30.166096,-84.208292),('32356','FL','Salem','Taylor',29.876547,-83.422625),('32357','FL','Shady Grove','Taylor',30.28163,-83.630822),('32358','FL','Sopchoppy','Wakulla',30.056077,-84.521478),('32359','FL','Steinhatchee','Taylor',29.670148,-83.377081),('32360','FL','Telogia','Liberty',30.184365,-84.883556),('32361','FL','Wacissa','Jefferson',30.358411,-83.98844),('32362','FL','Woodville','Leon',30.311,-84.2485),('32395','FL','Tallahassee','Leon',30.4126,-84.2834),('32399','FL','Tallahassee','Leon',30.420146,-84.233313),('32401','FL','Panama City','Bay',30.161218,-85.652989),('32402','FL','Panama City','Bay',30.1558,-85.6629),('32403','FL','Panama City','Bay',30.060278,-85.577027),('32404','FL','Panama City','Bay',30.19287,-85.553148),('32405','FL','Panama City','Bay',30.197963,-85.66776),('32406','FL','Panama City','Bay',30.1786,-85.6841),('32407','FL','Panama City Beach','Bay',30.195016,-85.808479),('32408','FL','Panama City','Bay',30.159175,-85.762961),('32409','FL','Panama City','Bay',30.356756,-85.653691),('32410','FL','Mexico Beach','Bay',29.959664,-85.406012),('32411','FL','Panama City','Bay',30.1516,-85.7246),('32412','FL','Panama City','Bay',30.1586,-85.6602),('32413','FL','Panama City Beach','Bay',30.262242,-85.92616),('32417','FL','Panama City','Bay',30.1586,-85.6602),('32420','FL','Alford','Jackson',30.641262,-85.375559),('32421','FL','Altha','Calhoun',30.52375,-85.195596),('32422','FL','Argyle','Walton',30.716494,-86.038896),('32423','FL','Bascom','Jackson',30.946765,-85.078509),('32424','FL','Blountstown','Calhoun',30.399456,-85.08475),('32425','FL','Bonifay','Holmes',30.848859,-85.710793),('32426','FL','Campbellton','Jackson',30.954851,-85.386966),('32427','FL','Caryville','Washington',30.743376,-85.799418),('32428','FL','Chipley','Washington',30.61575,-85.572945),('32430','FL','Clarksville','Calhoun',30.428259,-85.222841),('32431','FL','Cottondale','Jackson',30.788034,-85.39709),('32432','FL','Cypress','Jackson',30.713868,-85.077906),('32433','FL','Defuniak Springs','Walton',30.799961,-86.19316),('32434','FL','Mossy Head','Walton',30.743,-86.315),('32435','FL','Defuniak Springs','Walton',30.69272,-86.130352),('32437','FL','Ebro','Washington',30.434958,-85.889383),('32438','FL','Fountain','Bay',30.493789,-85.414974),('32439','FL','Freeport','Walton',30.482828,-86.1453),('32440','FL','Graceville','Jackson',30.930536,-85.521597),('32442','FL','Grand Ridge','Jackson',30.694222,-85.016264),('32443','FL','Greenwood','Jackson',30.872521,-85.10942),('32444','FL','Lynn Haven','Bay',30.238333,-85.647071),('32445','FL','Malone','Jackson',30.961376,-85.170364),('32446','FL','Marianna','Jackson',30.804046,-85.213916),('32447','FL','Marianna','Jackson',30.759671,-85.254167),('32448','FL','Marianna','Jackson',30.677402,-85.240862),('32449','FL','Wewahitc','Calhoun',30.285065,-85.242029),('32452','FL','Noma','Holmes',30.9819,-85.6186),('32454','FL','Point Washington','Walton',30.3719,-86.1176),('32455','FL','Ponce De Leon','Walton',30.650047,-85.955059),('32456','FL','Port Saint Joe','Gulf',29.823876,-85.307238),('32457','FL','Port Saint Joe','Gulf',29.8148,-85.3044),('32459','FL','Santa Rosa Beach','Walton',30.345565,-86.189055),('32460','FL','Sneads','Jackson',30.739718,-84.9295),('32461','FL','Rosemary Beach','Walton',30.286851,-86.026586),('32462','FL','Vernon','Washington',30.548136,-85.830594),('32463','FL','Wausau','Washington',30.631172,-85.589736),('32464','FL','Westville','Holmes',30.896756,-85.940501),('32465','FL','Wewahitchka','Gulf',30.050645,-85.203689),('32466','FL','Youngstown','Bay',30.380659,-85.526515),('32501','FL','Pensacola','Escambia',30.426893,-87.222083),('32502','FL','Pensacola','Escambia',30.410521,-87.222319),('32503','FL','Pensacola','Escambia',30.449767,-87.20671),('32504','FL','Pensacola','Escambia',30.486159,-87.188322),('32505','FL','Pensacola','Escambia',30.444348,-87.254049),('32506','FL','Pensacola','Escambia',30.404926,-87.322742),('32507','FL','Pensacola','Escambia',30.36209,-87.328027),('32508','FL','Pensacola','Escambia',30.35256,-87.293821),('32509','FL','Pensacola','Escambia',30.465416,-87.341503),('32511','FL','Pensacola','Escambia',30.406794,-87.290321),('32512','FL','Pensacola','Escambia',30.3969,-87.3013),('32513','FL','Pensacola','Escambia',30.4441,-87.215),('32514','FL','Pensacola','Escambia',30.52887,-87.216904),('32516','FL','Pensacola','Escambia',30.426,-87.2876),('32520','FL','Pensacola','Escambia',30.4123,-87.2035),('32521','FL','Pensacola','Escambia',30.3527,-87.3044),('32522','FL','Pensacola','Escambia',30.4338,-87.2347),('32523','FL','Pensacola','Escambia',30.4338,-87.2347),('32524','FL','Pensacola','Escambia',30.498,-87.1961),('32526','FL','Pensacola','Escambia',30.489702,-87.332412),('32530','FL','Bagdad','Santa Rosa',30.597751,-87.030955),('32531','FL','Baker','Okaloosa',30.854362,-86.690079),('32533','FL','Cantonment','Escambia',30.600084,-87.318939),('32534','FL','Pensacola','Escambia',30.527926,-87.278361),('32535','FL','Century','Escambia',30.968482,-87.329764),('32536','FL','Crestview','Okaloosa',30.759145,-86.585154),('32537','FL','Milligan','Okaloosa',30.8195,-86.452),('32538','FL','Paxton','Walton',30.9688,-86.2998),('32539','FL','Crestview','Okaloosa',30.761264,-86.510837),('32540','FL','Destin','Okaloosa',30.392,-86.4834),('32541','FL','Destin','Okaloosa',30.392746,-86.459767),('32542','FL','Eglin Afb','Okaloosa',30.471919,-86.538259),('32544','FL','Hurlburt Field','Okaloosa',30.422346,-86.694364),('32547','FL','Fort Walton Beach','Okaloosa',30.450243,-86.627051),('32548','FL','Fort Walton Beach','Okaloosa',30.413706,-86.620664),('32549','FL','Fort Walton Beach','Okaloosa',30.4162,-86.6109),('32550','FL','Miramar','Walton',30.382905,-86.348325),('32559','FL','Pensacola','Escambia',30.3527,-87.3044),('32560','FL','Gonzalez','Escambia',30.582,-87.29),('32561','FL','Gulf Breeze','Santa Rosa',30.35392,-87.157623),('32562','FL','Gulf Breeze','Santa Rosa',30.3655,-87.1701),('32563','FL','Gulf Breeze','Santa Rosa',30.392771,-87.046899),('32564','FL','Holt','Okaloosa',30.722772,-86.791372),('32565','FL','Jay','Santa Rosa',30.900222,-87.132545),('32566','FL','Navarre','Santa Rosa',30.425323,-86.892241),('32567','FL','Laurel Hill','Okaloosa',30.934183,-86.436409),('32568','FL','Mc David','Escambia',30.886098,-87.452135),('32569','FL','Mary Esther','Okaloosa',30.413059,-86.718137),('32570','FL','Milton','Santa Rosa',30.723638,-87.009286),('32571','FL','Milton','Santa Rosa',30.633171,-87.163963),('32572','FL','Milton','Santa Rosa',30.7855,-87.0163),('32577','FL','Molino','Escambia',30.741184,-87.367461),('32578','FL','Niceville','Okaloosa',30.500345,-86.443141),('32579','FL','Shalimar','Okaloosa',30.445701,-86.573463),('32580','FL','Valparaiso','Okaloosa',30.505013,-86.500925),('32583','FL','Milton','Santa Rosa',30.595286,-87.008464),('32588','FL','Niceville','Okaloosa',30.525,-86.4737),('32590','FL','Pensacola','Escambia',30.4211,-87.2169),('32591','FL','Pensacola','Escambia',30.4211,-87.2169),('32592','FL','Pensacola','Escambia',30.4211,-87.2169),('32601','FL','Gainesville','Alachua',29.652318,-82.324499),('32602','FL','Gainesville','Alachua',29.6513,-82.325),('32603','FL','Gainesville','Alachua',29.653171,-82.348562),('32604','FL','Gainesville','Alachua',29.6526,-82.3437),('32605','FL','Gainesville','Alachua',29.675847,-82.369141),('32606','FL','Gainesville','Alachua',29.682894,-82.425407),('32607','FL','Gainesville','Alachua',29.647472,-82.400263),('32608','FL','Gainesville','Alachua',29.609211,-82.40401),('32609','FL','Gainesville','Alachua',29.72282,-82.289362),('32610','FL','Gainesville','Alachua',29.6396,-82.3439),('32611','FL','Gainesville','Alachua',29.6441,-82.3479),('32612','FL','Gainesville','Alachua',29.648811,-82.3495),('32613','FL','Gainesville','Alachua',29.6646,-82.3244),('32614','FL','Gainesville','Alachua',29.6771,-82.3717),('32615','FL','Alachua','Alachua',29.803553,-82.487046),('32616','FL','Alachua','Alachua',29.790733,-82.49353),('32617','FL','Anthony','Marion',29.31166,-82.089539),('32618','FL','Archer','Alachua',29.523799,-82.541765),('32619','FL','Bell','Gilchrist',29.762919,-82.865211),('32621','FL','Bronson','Levy',29.445189,-82.612487),('32622','FL','Brooker','Bradford',29.900067,-82.307034),('32625','FL','Cedar Key','Levy',29.18158,-83.005782),('32626','FL','Chiefland','Levy',29.468373,-82.889947),('32627','FL','Gainesville','Alachua',29.6462,-82.3261),('32628','FL','Cross City','Dixie',29.632861,-83.15938),('32631','FL','Earleton','Alachua',29.740766,-82.110703),('32633','FL','Evinston','Alachua',29.4866,-82.2313),('32634','FL','Fairfield','Marion',29.3666,-82.2513),('32635','FL','Gainesville','Alachua',29.7077,-82.3979),('32639','FL','Gulf Hammock','Levy',29.236869,-82.725843),('32640','FL','Hawthorne','Putnam',29.586709,-82.073908),('32641','FL','Gainesville','Alachua',29.642768,-82.271971),('32643','FL','High Springs','Alachua',29.815975,-82.623599),('32644','FL','Chiefland','Levy',29.4199,-82.8976),('32648','FL','Horseshoe Beach','Dixie',29.483151,-83.274395),('32653','FL','Gainesville','Alachua',29.734258,-82.387612),('32654','FL','Island Grove','Alachua',29.459973,-82.108193),('32655','FL','High Springs','Alachua',29.811,-82.6061),('32656','FL','Keystone Heights','Clay',29.792776,-82.001991),('32658','FL','La Crosse','Alachua',29.847991,-82.401183),('32662','FL','Lochloosa','Alachua',29.514298,-82.098298),('32663','FL','Lowell','Marion',29.3302,-82.1916),('32664','FL','Mc Intosh','Marion',29.449345,-82.221874),('32666','FL','Melrose','Putnam',29.726003,-82.000835),('32667','FL','Micanopy','Alachua',29.511195,-82.297501),('32668','FL','Morriston','Levy',29.28039,-82.488601),('32669','FL','Newberry','Alachua',29.640529,-82.595286),('32680','FL','Old Town','Dixie',29.624824,-83.03695),('32681','FL','Orange Lake','Marion',29.423936,-82.205373),('32683','FL','Otter Creek','Levy',29.317728,-82.778945),('32686','FL','Reddick','Marion',29.359879,-82.234576),('32692','FL','Suwannee','Dixie',29.331884,-83.140737),('32693','FL','Trenton','Gilchrist',29.622385,-82.821061),('32694','FL','Waldo','Alachua',29.790601,-82.161661),('32696','FL','Williston','Levy',29.38344,-82.491598),('32697','FL','Worthington Springs','Union',29.928188,-82.425637),('32701','FL','Altamonte Springs','Seminole',28.663522,-81.36967),('32702','FL','Altoona','Lake',29.027454,-81.641998),('32703','FL','Apopka','Orange',28.659664,-81.503352),('32704','FL','Apopka','Orange',28.6876,-81.5096),('32706','FL','Cassadaga','Volusia',28.965591,-81.236547),('32707','FL','Casselberry','Seminole',28.663959,-81.315021),('32708','FL','Winter Springs','Seminole',28.684709,-81.275367),('32709','FL','Christmas','Orange',28.526398,-80.993079),('32710','FL','Clarcona','Orange',28.6133,-81.4807),('32712','FL','Apopka','Orange',28.716893,-81.524449),('32713','FL','Debary','Volusia',28.887472,-81.311763),('32714','FL','Altamonte Springs','Seminole',28.664178,-81.410395),('32715','FL','Altamonte Springs','Seminole',28.6656,-81.3584),('32716','FL','Altamonte Springs','Seminole',28.666,-81.4028),('32718','FL','Casselberry','Seminole',28.6775,-81.328),('32719','FL','Winter Springs','Seminole',28.6986,-81.3083),('32720','FL','Deland','Volusia',29.021476,-81.331265),('32721','FL','Deland','Volusia',29.0276,-81.3069),('32722','FL','Glenwood','Volusia',29.0754,-81.352),('32723','FL','Deland','Volusia',29.0276,-81.3069),('32724','FL','Deland','Volusia',29.038153,-81.276184),('32725','FL','Deltona','Volusia',28.902099,-81.244629),('32726','FL','Eustis','Lake',28.849717,-81.680426),('32727','FL','Eustis','Lake',28.8552,-81.6845),('32728','FL','Deltona','Volusia',28.8888,-81.2755),('32730','FL','Casselberry','Seminole',28.652601,-81.341791),('32732','FL','Geneva','Seminole',28.744592,-81.116442),('32733','FL','Goldenrod','Seminole',28.6108,-81.2863),('32735','FL','Grand Island','Lake',28.890421,-81.739041),('32736','FL','Eustis','Lake',28.886072,-81.546733),('32738','FL','Deltona','Volusia',28.905506,-81.192324),('32739','FL','Deltona','Volusia',28.9222,-81.1872),('32744','FL','Lake Helen','Volusia',28.978116,-81.232758),('32745','FL','Mid Florida','Seminole',28.7461,-81.6672),('32746','FL','Lake Mary','Seminole',28.761625,-81.342636),('32747','FL','Lake Monroe','Seminole',28.8244,-81.3272),('32750','FL','Longwood','Seminole',28.702832,-81.353024),('32751','FL','Maitland','Orange',28.6293,-81.35948),('32752','FL','Longwood','Seminole',28.7027,-81.3386),('32753','FL','Debary','Volusia',28.8833,-81.3092),('32754','FL','Mims','Brevard',28.682117,-80.898884),('32756','FL','Mount Dora','Lake',28.8025,-81.6446),('32757','FL','Mount Dora','Lake',28.796804,-81.645939),('32759','FL','Oak Hill','Volusia',28.874552,-80.860065),('32762','FL','Oviedo','Seminole',28.672,-81.2058),('32763','FL','Orange City','Volusia',28.942203,-81.30052),('32764','FL','Osteen','Volusia',28.843521,-81.111674),('32765','FL','Oviedo','Seminole',28.65229,-81.210617),('32766','FL','Oviedo','Seminole',28.642427,-81.120562),('32767','FL','Paisley','Lake',29.012084,-81.501637),('32768','FL','Plymouth','Orange',28.7,-81.5572),('32771','FL','Sanford','Seminole',28.803825,-81.292485),('32772','FL','Sanford','Seminole',28.8135,-81.2659),('32773','FL','Sanford','Seminole',28.76685,-81.272991),('32774','FL','Orange City','Volusia',28.9486,-81.2988),('32775','FL','Scottsmoor','Brevard',28.76507,-80.873152),('32776','FL','Sorrento','Lake',28.804922,-81.526046),('32777','FL','Tangerine','Orange',28.6629,-81.5695),('32778','FL','Tavares','Lake',28.798671,-81.733747),('32779','FL','Longwood','Seminole',28.702819,-81.421329),('32780','FL','Titusville','Brevard',28.560208,-80.811461),('32781','FL','Titusville','Brevard',28.5862,-80.8017),('32782','FL','Titusville','Brevard',28.6121,-80.8059),('32783','FL','Titusville','Brevard',28.5573,-80.8097),('32784','FL','Umatilla','Lake',28.950446,-81.701586),('32789','FL','Winter Park','Orange',28.598192,-81.355828),('32790','FL','Winter Park','Orange',28.5983,-81.3529),('32791','FL','Longwood','Seminole',28.7032,-81.4198),('32792','FL','Winter Park','Orange',28.608582,-81.30156),('32793','FL','Winter Park','Orange',28.5977,-81.3049),('32794','FL','Maitland','Orange',28.6278,-81.366),('32795','FL','Lake Mary','Seminole',28.7586,-81.318),('32796','FL','Titusville','Brevard',28.622166,-80.836191),('32798','FL','Zellwood','Orange',28.723714,-81.58772),('32799','FL','Mid Florida','Seminole',28.7642,-81.3574),('32801','FL','Orlando','Orange',28.541774,-81.374351),('32802','FL','Orlando','Orange',28.5453,-81.3783),('32803','FL','Orlando','Orange',28.556152,-81.351053),('32804','FL','Orlando','Orange',28.57507,-81.393441),('32805','FL','Orlando','Orange',28.530132,-81.40088),('32806','FL','Orlando','Orange',28.514728,-81.360443),('32807','FL','Orlando','Orange',28.547037,-81.302428),('32808','FL','Orlando','Orange',28.577438,-81.444802),('32809','FL','Orlando','Orange',28.463673,-81.387869),('32810','FL','Orlando','Orange',28.619558,-81.42535),('32811','FL','Orlando','Orange',28.520915,-81.447746),('32812','FL','Orlando','Orange',28.497,-81.32792),('32814','FL','Orlando','Orange',28.570411,-81.328174),('32815','FL','Orlando','Brevard',28.6213,-80.6998),('32816','FL','Orlando','Orange',28.6049,-81.205),('32817','FL','Orlando','Orange',28.591155,-81.246321),('32818','FL','Orlando','Orange',28.580409,-81.487248),('32819','FL','Orlando','Orange',28.459137,-81.473143),('32820','FL','Orlando','Orange',28.564849,-81.111385),('32821','FL','Orlando','Orange',28.392165,-81.473732),('32822','FL','Orlando','Orange',28.498741,-81.294714),('32824','FL','Orlando','Orange',28.395645,-81.356536),('32825','FL','Orlando','Orange',28.543246,-81.249588),('32826','FL','Orlando','Orange',28.58683,-81.187587),('32827','FL','Orlando','Orange',28.4268,-81.301403),('32828','FL','Orlando','Orange',28.53188,-81.168761),('32829','FL','Orlando','Orange',28.484772,-81.253281),('32830','FL','Orlando','Orange',28.379241,-81.558424),('32831','FL','Orlando','Orange',28.469091,-81.157787),('32832','FL','Orlando','Orange',28.414068,-81.212263),('32833','FL','Orlando','Orange',28.511944,-81.091376),('32834','FL','Orlando','Orange',28.538,-81.3794),('32835','FL','Orlando','Orange',28.524526,-81.476714),('32836','FL','Orlando','Orange',28.411727,-81.509759),('32837','FL','Orlando','Orange',28.383045,-81.417629),('32839','FL','Orlando','Orange',28.488851,-81.406754),('32853','FL','Orlando','Orange',28.5515,-81.3644),('32854','FL','Orlando','Orange',28.5665,-81.3894),('32855','FL','Orlando','Orange',28.538,-81.3794),('32856','FL','Orlando','Orange',28.5109,-81.3727),('32857','FL','Orlando','Orange',28.538,-81.3794),('32858','FL','Orlando','Orange',28.5527,-81.4498),('32859','FL','Orlando','Orange',28.4521,-81.3644),('32860','FL','Orlando','Orange',28.6218,-81.4392),('32861','FL','Orlando','Orange',28.538,-81.3794),('32862','FL','Orlando','Orange',28.483,-81.3299),('32867','FL','Orlando','Orange',28.5675,-81.253),('32868','FL','Orlando','Orange',28.583,-81.476),('32869','FL','Orlando','Orange',28.5901,-81.4936),('32872','FL','Orlando','Orange',28.5148,-81.2882),('32877','FL','Orlando','Orange',28.5416,-81.3739),('32878','FL','Orlando','Orange',28.538,-81.3794),('32885','FL','Orlando','Orange',28.5382,-81.3795),('32886','FL','Orlando','Orange',28.538,-81.3794),('32887','FL','Orlando','Orange',28.3804,-81.4704),('32890','FL','Orlando','Orange',28.4611,-81.3845),('32891','FL','Orlando','Orange',28.538,-81.3794),('32893','FL','Orlando','Orange',28.4286,-81.3097),('32896','FL','Orlando','Orange',28.3212,-81.2299),('32897','FL','Orlando','Orange',28.538,-81.3794),('32898','FL','Orlando','Orange',28.538,-81.3794),('32899','FL','Orlando','Brevard',28.6138,-80.6774),('32901','FL','Melbourne','Brevard',28.075742,-80.620861),('32902','FL','Melbourne','Brevard',28.0833,-80.6083),('32903','FL','Indialantic','Brevard',28.10573,-80.575672),('32904','FL','Melbourne','Brevard',28.073598,-80.671829),('32905','FL','Palm Bay','Brevard',28.031367,-80.600412),('32906','FL','Palm Bay','Brevard',28.0449,-80.6053),('32907','FL','Palm Bay','Brevard',28.012309,-80.677317),('32908','FL','Palm Bay','Brevard',27.951575,-80.694104),('32909','FL','Palm Bay','Brevard',27.951684,-80.646333),('32910','FL','Palm Bay','Brevard',28.0341,-80.5888),('32911','FL','Palm Bay','Brevard',28.0775,-80.6266),('32912','FL','Melbourne','Brevard',28.0775,-80.6266),('32919','FL','Melbourne','Brevard',28.0833,-80.6083),('32920','FL','Cape Canaveral','Brevard',28.394691,-80.60409),('32922','FL','Cocoa','Brevard',28.366165,-80.742182),('32923','FL','Cocoa','Brevard',28.2615,-80.7059),('32924','FL','Cocoa','Brevard',28.2615,-80.7059),('32925','FL','Patrick Afb','Brevard',28.250479,-80.606835),('32926','FL','Cocoa','Brevard',28.392897,-80.796017),('32927','FL','Cocoa','Brevard',28.470754,-80.795771),('32931','FL','Cocoa Beach','Brevard',28.328901,-80.612886),('32932','FL','Cocoa Beach','Brevard',28.3193,-80.6113),('32934','FL','Melbourne','Brevard',28.142586,-80.696393),('32935','FL','Melbourne','Brevard',28.142307,-80.649738),('32936','FL','Melbourne','Brevard',28.1307,-80.6296),('32937','FL','Satellite Beach','Brevard',28.170889,-80.597292),('32940','FL','Melbourne','Brevard',28.227127,-80.709855),('32941','FL','Melbourne','Brevard',28.0833,-80.6083),('32948','FL','Fellsmere','Indian River',27.777376,-80.611245),('32949','FL','Grant','Brevard',27.926177,-80.529642),('32950','FL','Malabar','Brevard',27.987057,-80.58245),('32951','FL','Melbourne Beach','Brevard',28.018971,-80.53597),('32952','FL','Merritt Island','Brevard',28.345104,-80.685929),('32953','FL','Merritt Island','Brevard',28.396428,-80.702479),('32954','FL','Merritt Island','Brevard',28.45,-80.69),('32955','FL','Rockledge','Brevard',28.306519,-80.727327),('32956','FL','Rockledge','Brevard',28.3071,-80.722),('32957','FL','Roseland','Indian River',27.8355,-80.4933),('32958','FL','Sebastian','Indian River',27.791084,-80.480183),('32959','FL','Sharpes','Brevard',28.4319,-80.7602),('32960','FL','Vero Beach','Indian River',27.637868,-80.400918),('32961','FL','Vero Beach','Indian River',27.6383,-80.3975),('32962','FL','Vero Beach','Indian River',27.582905,-80.389761),('32963','FL','Vero Beach','Indian River',27.686733,-80.37363),('32964','FL','Vero Beach','Indian River',27.6515,-80.3576),('32965','FL','Vero Beach','Indian River',27.7257,-80.3893),('32966','FL','Vero Beach','Indian River',27.639252,-80.510627),('32967','FL','Vero Beach','Indian River',27.719437,-80.46468),('32968','FL','Vero Beach','Indian River',27.593676,-80.444689),('32969','FL','Vero Beach','Indian River',27.639,-80.3989),('32970','FL','Wabasso','Indian River',27.751727,-80.456763),('32971','FL','Winter Beach','Indian River',27.7188,-80.4208),('32976','FL','Sebastian','Brevard',27.876351,-80.515266),('32978','FL','Sebastian','Indian River',27.7818,-80.4629),('33001','FL','Long Key','Monroe',24.822608,-80.816501),('33002','FL','Hialeah','Miami Dade',25.905,-80.3049),('33004','FL','Dania','Broward',26.053219,-80.143319),('33008','FL','Hallandale','Broward',25.9808,-80.1486),('33009','FL','Hallandale','Broward',25.985947,-80.149879),('33010','FL','Hialeah','Miami-dade',25.832277,-80.278722),('33011','FL','Hialeah','Miami Dade',25.8248,-80.2835),('33012','FL','Hialeah','Miami-dade',25.864442,-80.301412),('33013','FL','Hialeah','Miami-dade',25.8603,-80.271647),('33014','FL','Hialeah','Miami-dade',25.903003,-80.304749),('33015','FL','Hialeah','Miami-dade',25.940565,-80.31818),('33016','FL','Hialeah','Miami-dade',25.890386,-80.330898),('33017','FL','Hialeah','Miami Dade',25.9402,-80.304),('33018','FL','Hialeah','Miami-dade',25.905573,-80.355715),('33019','FL','Hollywood','Broward',26.018468,-80.123004),('33020','FL','Hollywood','Broward',26.016924,-80.149372),('33021','FL','Hollywood','Broward',26.023181,-80.188762),('33022','FL','Hollywood','Broward',26.0131,-80.1435),('33023','FL','Hollywood','Broward',25.988484,-80.212462),('33024','FL','Hollywood','Broward',26.024786,-80.238641),('33025','FL','Hollywood','Broward',25.989729,-80.277625),('33026','FL','Hollywood','Broward',26.026198,-80.295994),('33027','FL','Hollywood','Broward',25.980517,-80.341827),('33028','FL','Hollywood','Broward',26.018636,-80.346177),('33029','FL','Hollywood','Broward',25.99994,-80.400454),('33030','FL','Homestead','Miami-dade',25.478449,-80.488569),('33031','FL','Homestead','Miami-dade',25.526237,-80.496232),('33032','FL','Homestead','Miami-dade',25.52854,-80.397537),('33033','FL','Homestead','Miami-dade',25.489045,-80.425906),('33034','FL','Homestead','Miami-dade',25.391396,-80.537603),('33035','FL','Homestead','Miami-dade',25.449189,-80.439491),('33036','FL','Islamorada','Monroe',24.923493,-80.631643),('33037','FL','Key Largo','Monroe',25.139273,-80.40288),('33039','FL','Homestead','Miami-dade',25.501952,-80.400817),('33040','FL','Key West','Monroe',24.567377,-81.762657),('33041','FL','Key West','Monroe',24.5555,-81.8052),('33042','FL','Summerland Key','Monroe',24.663433,-81.4895),('33043','FL','Big Pine Key','Monroe',24.678376,-81.348701),('33045','FL','Key West','Monroe',24.5858,-81.7051),('33050','FL','Marathon','Monroe',24.732344,-81.025113),('33051','FL','Key Colony Beach','Monroe',24.723278,-81.020527),('33052','FL','Marathon Shores','Monroe',24.7117,-81.091),('33054','FL','Opa Locka','Miami-dade',25.908405,-80.250891),('33055','FL','Opa Locka','Miami-dade',25.944291,-80.277153),('33056','FL','Opa Locka','Miami-dade',25.948358,-80.247506),('33060','FL','Pompano Beach','Broward',26.232038,-80.122041),('33061','FL','Pompano Beach','Broward',26.2594,-80.1147),('33062','FL','Pompano Beach','Broward',26.235411,-80.095736),('33063','FL','Pompano Beach','Broward',26.25201,-80.210374),('33064','FL','Pompano Beach','Broward',26.278883,-80.113127),('33065','FL','Pompano Beach','Broward',26.271876,-80.256426),('33066','FL','Pompano Beach','Broward',26.252982,-80.178575),('33067','FL','Pompano Beach','Broward',26.300981,-80.22492),('33068','FL','Pompano Beach','Broward',26.215954,-80.217951),('33069','FL','Pompano Beach','Broward',26.233706,-80.157834),('33070','FL','Tavernier','Monroe',25.00247,-80.528002),('33071','FL','Pompano Beach','Broward',26.244601,-80.265314),('33072','FL','Pompano Beach','Broward',26.2327,-80.0925),('33073','FL','Pompano Beach','Broward',26.304194,-80.185087),('33074','FL','Pompano Beach','Broward',26.2375,-80.125),('33075','FL','Pompano Beach','Broward',26.2434,-80.266),('33076','FL','Pompano Beach','Broward',26.302654,-80.277249),('33077','FL','Pompano Beach','Broward',26.2392,-80.2517),('33081','FL','Hollywood','Broward',26.0174,-80.2036),('33082','FL','Pembroke Pines','Broward',26.0167,-80.2042),('33083','FL','Hollywood','Broward',26.1499,-80.2314),('33084','FL','Hollywood','Broward',26.0304,-80.2489),('33090','FL','Homestead','Miami Dade',25.4762,-80.4765),('33092','FL','Homestead','Miami Dade',25.5339,-80.4126),('33093','FL','Pompano Beach','Broward',26.2441,-80.2066),('33097','FL','Pompano Beach','Broward',26.3173,-80.1808),('33101','FL','Miami','Miami Dade',25.779,-80.1982),('33102','FL','Miami','Miami Dade',25.7965,-80.3133),('33107','FL','Miami','Miami Dade',25.7965,-80.3133),('33109','FL','Miami Beach','Miami-dade',25.760179,-80.139665),('33110','FL','Miami','Miami Dade',25.8519,-80.2073),('33111','FL','Miami','Miami Dade',25.7738,-80.1938),('33112','FL','Miami','Miami Dade',25.7968,-80.3826),('33114','FL','Miami','Miami Dade',25.7473,-80.2597),('33116','FL','Miami','Miami Dade',25.6719,-80.3746),('33119','FL','Miami Beach','Miami Dade',25.7836,-80.1324),('33121','FL','Miami','Miami Dade',25.7965,-80.3133),('33122','FL','Miami','Miami Dade',25.799962,-80.317756),('33124','FL','Miami','Miami Dade',25.7473,-80.2597),('33125','FL','Miami','Miami-dade',25.783473,-80.235879),('33126','FL','Miami','Miami-dade',25.779492,-80.299573),('33127','FL','Miami','Miami-dade',25.813175,-80.205808),('33128','FL','Miami','Miami-dade',25.776727,-80.203388),('33129','FL','Miami','Miami-dade',25.755681,-80.206354),('33130','FL','Miami','Miami-dade',25.768577,-80.201687),('33131','FL','Miami','Miami-dade',25.767038,-80.189296),('33132','FL','Miami','Miami-dade',25.78336,-80.18668),('33133','FL','Miami','Miami-dade',25.732201,-80.242663),('33134','FL','Miami','Miami-dade',25.754095,-80.270402),('33135','FL','Miami','Miami-dade',25.7666,-80.235766),('33136','FL','Miami','Miami-dade',25.785902,-80.202979),('33137','FL','Miami','Miami-dade',25.817259,-80.18879),('33138','FL','Miami','Miami-dade',25.852784,-80.186149),('33139','FL','Miami Beach','Miami-dade',25.784585,-80.140417),('33140','FL','Miami Beach','Miami-dade',25.815182,-80.130886),('33141','FL','Miami Beach','Miami-dade',25.856783,-80.131248),('33142','FL','Miami','Miami-dade',25.81255,-80.237875),('33143','FL','Miami','Miami-dade',25.703082,-80.296335),('33144','FL','Miami','Miami-dade',25.76235,-80.308946),('33145','FL','Miami','Miami-dade',25.753114,-80.233259),('33146','FL','Miami','Miami-dade',25.72085,-80.272571),('33147','FL','Miami','Miami-dade',25.850089,-80.237819),('33148','FL','Miami','Miami Dade',25.7965,-80.3133),('33149','FL','Key Biscayne','Miami-dade',25.705602,-80.158803),('33150','FL','Miami','Miami-dade',25.852159,-80.206419),('33151','FL','Miami','Miami Dade',25.8315,-80.2098),('33152','FL','Miami','Miami Dade',25.7965,-80.3133),('33153','FL','Miami','Miami Dade',25.8655,-80.1936),('33154','FL','Miami Beach','Miami-dade',25.883362,-80.129957),('33155','FL','Miami','Miami-dade',25.739633,-80.308885),('33156','FL','Miami','Miami-dade',25.668276,-80.308526),('33157','FL','Miami','Miami-dade',25.605485,-80.346323),('33158','FL','Miami','Miami-dade',25.637742,-80.313948),('33159','FL','Miami','Miami Dade',25.7738,-80.1938),('33160','FL','North Miami Beach','Miami-dade',25.937576,-80.136088),('33161','FL','Miami','Miami-dade',25.892746,-80.181492),('33162','FL','Miami','Miami-dade',25.929958,-80.178275),('33163','FL','Miami','Miami Dade',25.9496,-80.1495),('33164','FL','Miami','Miami Dade',25.9289,-80.1786),('33165','FL','Miami','Miami-dade',25.734345,-80.358271),('33166','FL','Miami','Miami-dade',25.823941,-80.304605),('33167','FL','Miami','Miami-dade',25.886918,-80.232891),('33168','FL','Miami','Miami-dade',25.892827,-80.210234),('33169','FL','Miami','Miami-dade',25.943117,-80.214686),('33170','FL','Miami','Miami-dade',25.556186,-80.410839),('33172','FL','Miami','Miami-dade',25.781927,-80.360743),('33173','FL','Miami','Miami-dade',25.701071,-80.358541),('33174','FL','Miami','Miami-dade',25.762614,-80.359561),('33175','FL','Miami','Miami-dade',25.734183,-80.408732),('33176','FL','Miami','Miami-dade',25.655195,-80.360539),('33177','FL','Miami','Miami-dade',25.596182,-80.402187),('33178','FL','Miami','Miami-dade',25.842392,-80.376053),('33179','FL','Miami','Miami-dade',25.95919,-80.181308),('33180','FL','Miami','Miami-dade',25.962149,-80.140904),('33181','FL','Miami','Miami-dade',25.900303,-80.157679),('33182','FL','Miami','Miami-dade',25.779797,-80.411568),('33183','FL','Miami','Miami-dade',25.700641,-80.407599),('33184','FL','Miami','Miami-dade',25.759637,-80.407186),('33185','FL','Miami','Miami-dade',25.732668,-80.443051),('33186','FL','Miami','Miami-dade',25.65871,-80.406409),('33187','FL','Miami','Miami-dade',25.596705,-80.472456),('33188','FL','Miami','Miami Dade',25.7965,-80.3133),('33189','FL','Miami','Miami-dade',25.575099,-80.347551),('33190','FL','Miami','Miami-dade',25.56153,-80.348713),('33193','FL','Miami','Miami-dade',25.699453,-80.449336),('33194','FL','Miami','Miami-dade',25.745346,-80.497723),('33195','FL','Miami','Miami Dade',25.7965,-80.3133),('33196','FL','Miami','Miami-dade',25.65834,-80.452721),('33197','FL','Miami','Miami Dade',25.5953,-80.3601),('33199','FL','Miami','Miami Dade',25.7574,-80.3754),('33222','FL','Miami','Miami Dade',25.7577,-80.3748),('33231','FL','Miami','Miami Dade',25.7299,-80.3013),('33233','FL','Miami','Miami Dade',25.7272,-80.2585),('33234','FL','Miami','Miami Dade',25.7299,-80.2426),('33238','FL','Miami','Miami Dade',25.8518,-80.1944),('33239','FL','Miami Beach','Miami Dade',25.7902,-80.1424),('33242','FL','Miami','Miami Dade',25.8059,-80.224),('33243','FL','Miami','Miami Dade',25.7057,-80.2902),('33245','FL','Miami','Miami Dade',25.7481,-80.2877),('33247','FL','Miami','Miami Dade',25.8348,-80.2415),('33255','FL','Miami','Miami Dade',25.7738,-80.1938),('33256','FL','Miami','Miami Dade',25.6624,-80.3251),('33257','FL','Miami','Miami Dade',25.6113,-80.3486),('33261','FL','Miami','Miami Dade',25.9075,-80.1583),('33265','FL','Miami','Miami Dade',25.7331,-80.3834),('33266','FL','Miami','Miami Dade',25.821,-80.2837),('33269','FL','Miami','Miami Dade',25.9449,-80.2057),('33280','FL','Miami','Miami Dade',25.9335,-80.1366),('33283','FL','Miami','Miami Dade',25.6933,-80.3821),('33296','FL','Miami','Miami Dade',25.657,-80.3592),('33299','FL','Miami','Miami Dade',25.7738,-80.1938),('33301','FL','Fort Lauderdale','Broward',26.121841,-80.132788),('33302','FL','Fort Lauderdale','Broward',26.1198,-80.1469),('33303','FL','Fort Lauderdale','Broward',26.1186,-80.1296),('33304','FL','Fort Lauderdale','Broward',26.138196,-80.126318),('33305','FL','Fort Lauderdale','Broward',26.152588,-80.125108),('33306','FL','Fort Lauderdale','Broward',26.165442,-80.113853),('33307','FL','Fort Lauderdale','Broward',26.1824,-80.1347),('33308','FL','Fort Lauderdale','Broward',26.190276,-80.107814),('33309','FL','Fort Lauderdale','Broward',26.187156,-80.172127),('33310','FL','Fort Lauderdale','Broward',26.1648,-80.1708),('33311','FL','Fort Lauderdale','Broward',26.139679,-80.169583),('33312','FL','Fort Lauderdale','Broward',26.091773,-80.179936),('33313','FL','Fort Lauderdale','Broward',26.149271,-80.225025),('33314','FL','Fort Lauderdale','Broward',26.067953,-80.219793),('33315','FL','Fort Lauderdale','Broward',26.093489,-80.154647),('33316','FL','Fort Lauderdale','Broward',26.101192,-80.129128),('33317','FL','Fort Lauderdale','Broward',26.113578,-80.223908),('33318','FL','Fort Lauderdale','Broward',26.1278,-80.2502),('33319','FL','Fort Lauderdale','Broward',26.184045,-80.221178),('33320','FL','Fort Lauderdale','Broward',26.179,-80.2754),('33321','FL','Fort Lauderdale','Broward',26.212545,-80.267221),('33322','FL','Fort Lauderdale','Broward',26.151635,-80.274234),('33323','FL','Fort Lauderdale','Broward',26.157992,-80.314115),('33324','FL','Fort Lauderdale','Broward',26.112091,-80.272467),('33325','FL','Fort Lauderdale','Broward',26.112438,-80.323195),('33326','FL','Fort Lauderdale','Broward',26.114814,-80.373259),('33327','FL','Fort Lauderdale','Broward',26.124431,-80.414668),('33328','FL','Fort Lauderdale','Broward',26.064049,-80.272407),('33329','FL','Fort Lauderdale','Broward',26.1219,-80.1436),('33330','FL','Fort Lauderdale','Broward',26.055669,-80.312564),('33331','FL','Fort Lauderdale','Broward',26.054693,-80.363628),('33332','FL','Fort Lauderdale','Broward',26.052882,-80.414338),('33334','FL','Fort Lauderdale','Broward',26.182573,-80.133587),('33335','FL','Fort Lauderdale','Broward',26.1824,-80.1347),('33336','FL','Fort Lauderdale','Broward',26.1113,-80.2749),('33337','FL','Fort Lauderdale','Broward',26.1113,-80.2749),('33338','FL','Fort Lauderdale','Broward',26.1367,-80.1231),('33339','FL','Fort Lauderdale','Broward',26.1646,-80.1141),('33340','FL','Fort Lauderdale','Broward',26.1648,-80.1708),('33345','FL','Fort Lauderdale','Broward',26.1659,-80.2958),('33346','FL','Fort Lauderdale','Broward',26.179,-80.2754),('33348','FL','Fort Lauderdale','Broward',26.1692,-80.1022),('33349','FL','Fort Lauderdale','Broward',26.1648,-80.1708),('33351','FL','Fort Lauderdale','Broward',26.179526,-80.275009),('33355','FL','Fort Lauderdale','Broward',26.112,-80.3037),('33359','FL','Fort Lauderdale','Broward',26.1814,-80.2276),('33388','FL','Fort Lauderdale','Broward',26.120714,-80.253269),('33394','FL','Fort Lauderdale','Broward',26.121364,-80.139166),('33401','FL','West Palm Beach','Palm Beach',26.711066,-80.062173),('33402','FL','West Palm Beach','Palm Beach',26.7131,-80.058),('33403','FL','West Palm Beach','Palm Beach',26.802686,-80.070465),('33404','FL','West Palm Beach','Palm Beach',26.779629,-80.066888),('33405','FL','West Palm Beach','Palm Beach',26.668567,-80.057606),('33406','FL','West Palm Beach','Palm Beach',26.660077,-80.089537),('33407','FL','West Palm Beach','Palm Beach',26.750405,-80.072781),('33408','FL','North Palm Beach','Palm Beach',26.843841,-80.061146),('33409','FL','West Palm Beach','Palm Beach',26.709845,-80.095996),('33410','FL','Palm Beach Gardens','Palm Beach',26.843223,-80.085579),('33411','FL','West Palm Beach','Palm Beach',26.715394,-80.215191),('33412','FL','West Palm Beach','Palm Beach',26.798666,-80.239202),('33413','FL','West Palm Beach','Palm Beach',26.666568,-80.147201),('33414','FL','West Palm Beach','Palm Beach',26.656572,-80.248354),('33415','FL','West Palm Beach','Palm Beach',26.660205,-80.126573),('33416','FL','West Palm Beach','Palm Beach',26.715,-80.0536),('33417','FL','West Palm Beach','Palm Beach',26.715978,-80.125996),('33418','FL','Palm Beach Gardens','Palm Beach',26.845536,-80.142998),('33419','FL','West Palm Beach','Palm Beach',26.7819,-80.0927),('33420','FL','West Palm Beach','Palm Beach',26.8555,-80.086),('33421','FL','West Palm Beach','Palm Beach',26.708,-80.2308),('33422','FL','West Palm Beach','Palm Beach',26.7231,-80.1253),('33424','FL','Boynton Beach','Palm Beach',26.525,-80.0666),('33425','FL','Boynton Beach','Palm Beach',26.5283,-80.0643),('33426','FL','Boynton Beach','Palm Beach',26.530464,-80.082926),('33427','FL','Boca Raton','Palm Beach',26.3583,-80.0833),('33428','FL','Boca Raton','Palm Beach',26.34554,-80.214928),('33429','FL','Boca Raton','Palm Beach',26.352,-80.0847),('33430','FL','Belle Glade','Palm Beach',26.68116,-80.656894),('33431','FL','Boca Raton','Palm Beach',26.381133,-80.097404),('33432','FL','Boca Raton','Palm Beach',26.34719,-80.084602),('33433','FL','Boca Raton','Palm Beach',26.345979,-80.15747),('33434','FL','Boca Raton','Palm Beach',26.383168,-80.167688),('33435','FL','Boynton Beach','Palm Beach',26.524927,-80.063044),('33436','FL','Boynton Beach','Palm Beach',26.532236,-80.107888),('33437','FL','Boynton Beach','Palm Beach',26.513093,-80.14596),('33438','FL','Canal Point','Palm Beach',26.919296,-80.604882),('33439','FL','Bryant','Palm Beach',26.8499,-80.615),('33440','FL','Clewiston','Hendry',26.652259,-81.008105),('33441','FL','Deerfield Beach','Broward',26.311098,-80.097874),('33442','FL','Deerfield Beach','Broward',26.310646,-80.144167),('33443','FL','Deerfield Beach','Broward',26.3181,-80.1058),('33444','FL','Delray Beach','Palm Beach',26.46072,-80.07867),('33445','FL','Delray Beach','Palm Beach',26.458991,-80.107319),('33446','FL','Delray Beach','Palm Beach',26.45242,-80.164962),('33447','FL','Delray Beach','Palm Beach',26.4685,-80.0718),('33448','FL','Delray Beach','Palm Beach',26.4567,-80.1378),('33449','FL','Lake Worth','Palm Beach',26.609964,-80.224744),('33454','FL','Lake Worth','Palm Beach',26.6155,-80.1469),('33455','FL','Hobe Sound','Martin',27.076454,-80.147235),('33458','FL','Jupiter','Palm Beach',26.921914,-80.120228),('33459','FL','Lake Harbor','Palm Beach',26.6927,-80.8147),('33460','FL','Lake Worth','Palm Beach',26.619692,-80.057724),('33461','FL','Lake Worth','Palm Beach',26.620583,-80.088537),('33462','FL','Lake Worth','Palm Beach',26.579058,-80.074528),('33463','FL','Lake Worth','Palm Beach',26.606163,-80.128066),('33464','FL','Boca Raton','Palm Beach',26.5844,-80.0526),('33465','FL','Lake Worth','Palm Beach',26.5844,-80.0526),('33466','FL','Lake Worth','Palm Beach',26.618,-80.1083),('33467','FL','Lake Worth','Palm Beach',26.597867,-80.171506),('33468','FL','Jupiter','Palm Beach',26.9232,-80.1026),('33469','FL','Jupiter','Palm Beach',26.968425,-80.100772),('33470','FL','Loxahatchee','Palm Beach',26.758237,-80.30136),('33471','FL','Moore Haven','Glades',26.839094,-81.122212),('33472','FL','Boynton Beach','Palm Beach',26.544077,-80.165116),('33473','FL','Boynton Beach','Palm Beach',26.505298,-80.191345),('33474','FL','Boynton Beach','Palm Beach',26.5272,-80.0911),('33475','FL','Hobe Sound','Martin',27.0591,-80.1366),('33476','FL','Pahokee','Palm Beach',26.818423,-80.652783),('33477','FL','Jupiter','Palm Beach',26.922116,-80.080501),('33478','FL','Jupiter','Palm Beach',26.931284,-80.226744),('33480','FL','Palm Beach','Palm Beach',26.71282,-80.039512),('33481','FL','Boca Raton','Palm Beach',26.3583,-80.0833),('33482','FL','Delray Beach','Palm Beach',26.4611,-80.073),('33483','FL','Delray Beach','Palm Beach',26.463598,-80.065039),('33484','FL','Delray Beach','Palm Beach',26.452302,-80.133482),('33486','FL','Boca Raton','Palm Beach',26.344548,-80.112129),('33487','FL','Boca Raton','Palm Beach',26.410604,-80.087769),('33488','FL','Boca Raton','Palm Beach',26.349,-80.1141),('33493','FL','South Bay','Palm Beach',26.628188,-80.711579),('33496','FL','Boca Raton','Palm Beach',26.404021,-80.163374),('33497','FL','Boca Raton','Palm Beach',26.349,-80.2211),('33498','FL','Boca Raton','Palm Beach',26.389963,-80.217761),('33499','FL','Boca Raton','Palm Beach',26.3757,-80.1216),('33503','FL','Balm','Hillsborough',27.763831,-82.276174),('33508','FL','Brandon','Hillsborough',27.9378,-82.2861),('33509','FL','Brandon','Hillsborough',27.9338,-82.3036),('33510','FL','Brandon','Hillsborough',27.955637,-82.296693),('33511','FL','Brandon','Hillsborough',27.912666,-82.296647),('33513','FL','Bushnell','Sumter',28.663399,-82.146391),('33514','FL','Center Hill','Sumter',28.660828,-81.987421),('33521','FL','Coleman','Sumter',28.799321,-82.070005),('33523','FL','Dade City','Pasco',28.428633,-82.209151),('33524','FL','Crystal Springs','Pasco',28.1811,-82.1577),('33525','FL','Dade City','Pasco',28.341557,-82.198375),('33526','FL','Dade City','Pasco',28.3644,-82.1961),('33527','FL','Dover','Hillsborough',27.976145,-82.21763),('33530','FL','Durant','Hillsborough',27.9083,-82.1863),('33534','FL','Gibsonton','Hillsborough',27.831171,-82.376252),('33537','FL','Lacoochee','Pasco',28.4655,-82.1722),('33538','FL','Lake Panasoffkee','Sumter',28.83524,-82.148124),('33539','FL','Zephyrhills','Pasco',28.2333,-82.1813),('33540','FL','Zephyrhills','Pasco',28.237282,-82.148869),('33541','FL','Zephyrhills','Pasco',28.23256,-82.207374),('33542','FL','Zephyrhills','Pasco',28.237625,-82.181092),('33543','FL','Wesley C','Pasco',28.200849,-82.303545),('33544','FL','Wesley C','Pasco',28.227961,-82.366814),('33545','FL','Wesley Chapel','Pasco',28.255921,-82.300796),('33547','FL','Lithia','Hillsborough',27.810903,-82.152469),('33548','FL','Lutz','Hillsborough',28.135922,-82.474728),('33549','FL','Lutz','Hillsborough',28.131316,-82.447991),('33550','FL','Mango','Hillsborough',27.9059,-82.2449),('33556','FL','Odessa','Hillsborough',28.134304,-82.583937),('33558','FL','Lutz','Hillsborough',28.152314,-82.519928),('33559','FL','Lutz','Hillsborough',28.14683,-82.413435),('33563','FL','Plant City','Hillsborough',28.018354,-82.128565),('33564','FL','Plant City','Hillsborough',28.0183,-82.113),('33565','FL','Plant City','Hillsborough',28.066087,-82.144116),('33566','FL','Plant City','Hillsborough',27.984498,-82.130091),('33567','FL','Plant City','Hillsborough',27.918265,-82.144277),('33568','FL','Riverview','Hillsborough',27.8532,-82.2726),('33569','FL','Riverview','Hillsborough',27.845876,-82.305295),('33570','FL','Ruskin','Hillsborough',27.69998,-82.445122),('33571','FL','Sun City Center','Hillsborough',27.7205,-82.4333),('33572','FL','Apollo Beach','Hillsborough',27.764569,-82.409523),('33573','FL','Sun City Center','Hillsborough',27.713047,-82.364309),('33574','FL','Saint Leo','Pasco',28.3369,-82.2586),('33575','FL','Ruskin','Hillsborough',27.713,-82.3599),('33576','FL','San Antonio','Pasco',28.329708,-82.304575),('33578','FL','Riverview','Hillsborough',27.863234,-82.343812),('33579','FL','Riverview','Hillsborough',27.796862,-82.30402),('33583','FL','Seffner','Hillsborough',27.9834,-82.2777),('33584','FL','Seffner','Hillsborough',27.996663,-82.286868),('33585','FL','Sumterville','Sumter',28.748733,-82.069139),('33586','FL','Sun City','Hillsborough',27.678,-82.4788),('33587','FL','Sydney','Hillsborough',27.9059,-82.2449),('33592','FL','Thonotosassa','Hillsborough',28.078866,-82.296807),('33593','FL','Trilby','Pasco',28.4622,-82.195),('33594','FL','Valrico','Hillsborough',27.932468,-82.241519),('33595','FL','Valrico','Hillsborough',27.938482,-82.252607),('33596','FL','Valrico','Hillsborough',27.886516,-82.242864),('33597','FL','Webster','Sumter',28.558122,-82.120809),('33598','FL','Wimauma','Hillsborough',27.688609,-82.330048),('33601','FL','Tampa','Hillsborough',27.9428,-82.4549),('33602','FL','Tampa','Hillsborough',27.954679,-82.457282),('33603','FL','Tampa','Hillsborough',27.984094,-82.462786),('33604','FL','Tampa','Hillsborough',28.016617,-82.455779),('33605','FL','Tampa','Hillsborough',27.963445,-82.432178),('33606','FL','Tampa','Hillsborough',27.9366,-82.468232),('33607','FL','Tampa','Hillsborough',27.963583,-82.498346),('33608','FL','Tampa','Hillsborough',27.8594,-82.4997),('33609','FL','Tampa','Hillsborough',27.943907,-82.50889),('33610','FL','Tampa','Hillsborough',27.992864,-82.402009),('33611','FL','Tampa','Hillsborough',27.891345,-82.505665),('33612','FL','Tampa','Hillsborough',28.048672,-82.452029),('33613','FL','Tampa','Hillsborough',28.079587,-82.448978),('33614','FL','Tampa','Hillsborough',28.007962,-82.503778),('33615','FL','Tampa','Hillsborough',28.00623,-82.580035),('33616','FL','Tampa','Hillsborough',27.868576,-82.52459),('33617','FL','Tampa','Hillsborough',28.039066,-82.393931),('33618','FL','Tampa','Hillsborough',28.069731,-82.495644),('33619','FL','Tampa','Hillsborough',27.943412,-82.377408),('33620','FL','Tampa','Hillsborough',28.061368,-82.412801),('33621','FL','Tampa','Hillsborough',27.850013,-82.4921),('33622','FL','Tampa','Hillsborough',27.9597,-82.5327),('33623','FL','Tampa','Hillsborough',27.9597,-82.5327),('33624','FL','Tampa','Hillsborough',28.080256,-82.528248),('33625','FL','Tampa','Hillsborough',28.066997,-82.557957),('33626','FL','Tampa','Hillsborough',28.058918,-82.616802),('33629','FL','Tampa','Hillsborough',27.920833,-82.506994),('33630','FL','Tampa','Hillsborough',27.9597,-82.5327),('33631','FL','Tampa','Hillsborough',27.9597,-82.5327),('33633','FL','Tampa','Hillsborough',27.9597,-82.5327),('33634','FL','Tampa','Hillsborough',28.004279,-82.547115),('33635','FL','Tampa','Hillsborough',28.033222,-82.608092),('33637','FL','Tampa','Hillsborough',28.044664,-82.359318),('33646','FL','Tampa','Hillsborough',27.996469,-82.5326),('33647','FL','Tampa','Hillsborough',28.134186,-82.356999),('33650','FL','Tampa','Hillsborough',27.9597,-82.5327),('33651','FL','Tampa','Hillsborough',27.9597,-82.5327),('33655','FL','Tampa','Hillsborough',27.9597,-82.5327),('33660','FL','Tampa','Hillsborough',27.9597,-82.5327),('33661','FL','Tampa','Hillsborough',27.9597,-82.5327),('33662','FL','Tampa','Hillsborough',27.9597,-82.5327),('33663','FL','Tampa','Hillsborough',27.9281,-82.3734),('33664','FL','Tampa','Hillsborough',27.967,-82.5177),('33672','FL','Tampa','Hillsborough',27.9519,-82.4588),('33673','FL','Tampa','Hillsborough',27.9943,-82.4597),('33674','FL','Tampa','Hillsborough',28.0088,-82.4514),('33675','FL','Tampa','Hillsborough',27.9641,-82.4376),('33677','FL','Tampa','Hillsborough',27.958,-82.4833),('33679','FL','Tampa','Hillsborough',27.9521,-82.5083),('33680','FL','Tampa','Hillsborough',27.9958,-82.4273),('33681','FL','Tampa','Hillsborough',27.8959,-82.5227),('33682','FL','Tampa','Hillsborough',28.0552,-82.4593),('33684','FL','Tampa','Hillsborough',27.996,-82.4964),('33685','FL','Tampa','Hillsborough',27.9985,-82.5827),('33686','FL','Tampa','Hillsborough',27.8682,-82.5276),('33687','FL','Tampa','Hillsborough',28.0357,-82.394),('33688','FL','Tampa','Hillsborough',28.0613,-82.5036),('33689','FL','Tampa','Hillsborough',28.0792,-82.4924),('33690','FL','Tampa','Hillsborough',27.9212,-82.4939),('33694','FL','Tampa','Hillsborough',28.0696,-82.4949),('33701','FL','Saint Petersburg','Pinellas',27.769885,-82.63778),('33702','FL','Saint Petersburg','Pinellas',27.845074,-82.642676),('33703','FL','Saint Petersburg','Pinellas',27.817949,-82.629554),('33704','FL','Saint Petersburg','Pinellas',27.796218,-82.637529),('33705','FL','Saint Petersburg','Pinellas',27.740775,-82.644),('33706','FL','Saint Petersburg','Pinellas',27.740872,-82.753291),('33707','FL','Saint Petersburg','Pinellas',27.756404,-82.719171),('33708','FL','Saint Petersburg','Pinellas',27.81366,-82.791635),('33709','FL','Saint Petersburg','Pinellas',27.815949,-82.728337),('33710','FL','Saint Petersburg','Pinellas',27.788885,-82.724033),('33711','FL','Saint Petersburg','Pinellas',27.751049,-82.689517),('33712','FL','Saint Petersburg','Pinellas',27.745213,-82.665804),('33713','FL','Saint Petersburg','Pinellas',27.789186,-82.677509),('33714','FL','Saint Petersburg','Pinellas',27.817073,-82.676189),('33715','FL','Saint Petersburg','Pinellas',27.682039,-82.720348),('33716','FL','Saint Petersburg','Pinellas',27.87506,-82.648609),('33729','FL','Saint Petersburg','Pinellas',27.8831,-82.6672),('33730','FL','Saint Petersburg','Pinellas',27.7719,-82.676),('33731','FL','Saint Petersburg','Pinellas',27.7717,-82.6387),('33732','FL','Saint Petersburg','Pinellas',27.7705,-82.6794),('33733','FL','Saint Petersburg','Pinellas',27.7719,-82.676),('33734','FL','Saint Petersburg','Pinellas',27.8031,-82.6469),('33736','FL','Saint Petersburg','Pinellas',27.7427,-82.7481),('33737','FL','Saint Petersburg','Pinellas',27.7382,-82.7081),('33738','FL','Saint Petersburg','Pinellas',27.8013,-82.8017),('33740','FL','Saint Petersburg','Pinellas',27.7689,-82.7686),('33741','FL','Saint Petersburg','Pinellas',27.743,-82.7516),('33742','FL','Saint Petersburg','Pinellas',27.8423,-82.6478),('33743','FL','Saint Petersburg','Pinellas',27.7838,-82.7293),('33744','FL','Bay Pines','Pinellas',27.809344,-82.77614),('33747','FL','Saint Petersburg','Pinellas',27.7893,-82.7268),('33755','FL','Clearwater','Pinellas',27.979868,-82.782744),('33756','FL','Clearwater','Pinellas',27.944306,-82.78693),('33757','FL','Clearwater','Pinellas',27.9797,-82.7807),('33758','FL','Clearwater','Pinellas',27.9797,-82.7807),('33759','FL','Clearwater','Pinellas',27.977804,-82.715154),('33760','FL','Clearwater','Pinellas',27.908463,-82.714314),('33761','FL','Clearwater','Pinellas',28.03078,-82.727367),('33762','FL','Clearwater','Pinellas',27.893195,-82.686597),('33763','FL','Clearwater','Pinellas',28.002357,-82.744184),('33764','FL','Clearwater','Pinellas',27.932627,-82.741041),('33765','FL','Clearwater','Pinellas',27.973447,-82.745087),('33766','FL','Clearwater','Pinellas',27.9797,-82.7807),('33767','FL','Clearwater Beach','Pinellas',27.982607,-82.825755),('33769','FL','Clearwater','Pinellas',27.9887,-82.7548),('33770','FL','Largo','Pinellas',27.915621,-82.800422),('33771','FL','Largo','Pinellas',27.905873,-82.755516),('33772','FL','Seminole','Pinellas',27.843331,-82.793343),('33773','FL','Largo','Pinellas',27.882294,-82.75592),('33774','FL','Largo','Pinellas',27.884443,-82.826751),('33775','FL','Seminole','Pinellas',27.8441,-82.7959),('33776','FL','Seminole','Pinellas',27.852976,-82.827103),('33777','FL','Seminole','Pinellas',27.853533,-82.759349),('33778','FL','Largo','Pinellas',27.884224,-82.794525),('33779','FL','Largo','Pinellas',27.9062,-82.7599),('33780','FL','Pinellas Park','Pinellas',27.8387,-82.7151),('33781','FL','Pinellas Park','Pinellas',27.83897,-82.713637),('33782','FL','Pinellas Park','Pinellas',27.861505,-82.710412),('33784','FL','Saint Petersburg','Pinellas',27.7705,-82.6794),('33785','FL','Indian Rocks Beach','Pinellas',27.884003,-82.846013),('33786','FL','Belleair Beach','Pinellas',27.921991,-82.842179),('33801','FL','Lakeland','Polk',28.042878,-81.919514),('33802','FL','Lakeland','Polk',28.0454,-81.9585),('33803','FL','Lakeland','Polk',28.012976,-81.949943),('33804','FL','Lakeland','Polk',28.0786,-81.9534),('33805','FL','Lakeland','Polk',28.079037,-81.949293),('33806','FL','Lakeland','Polk',28.029,-81.9576),('33807','FL','Lakeland','Polk',27.9734,-81.9607),('33809','FL','Lakeland','Polk',28.136919,-81.952533),('33810','FL','Lakeland','Polk',28.115296,-82.007915),('33811','FL','Lakeland','Polk',27.984748,-82.014696),('33812','FL','Lakeland','Polk',27.971442,-81.894476),('33813','FL','Lakeland','Polk',27.961591,-81.943815),('33815','FL','Lakeland','Polk',28.042894,-81.9888),('33820','FL','Alturas','Polk',27.7914,-81.8585),('33823','FL','Auburndale','Polk',28.071773,-81.807116),('33825','FL','Avon Park','Highlands',27.602387,-81.507298),('33826','FL','Avon Park','Highlands',27.5944,-81.5003),('33827','FL','Babson Park','Polk',27.824993,-81.53007),('33830','FL','Bartow','Polk',27.894543,-81.827044),('33831','FL','Bartow','Polk',27.895,-81.8423),('33834','FL','Bowling Green','Hardee',27.631395,-81.884745),('33835','FL','Bradley','Polk',27.710056,-81.951968),('33836','FL','Davenport','Polk',28.22,-81.6205),('33837','FL','Davenport','Polk',28.185542,-81.618919),('33838','FL','Dundee','Polk',28.020943,-81.618528),('33839','FL','Eagle Lake','Polk',27.980408,-81.75301),('33840','FL','Eaton Park','Polk',28.2069,-81.91),('33841','FL','Fort Meade','Polk',27.748934,-81.789883),('33843','FL','Frostproof','Polk',27.739247,-81.538136),('33844','FL','Haines City','Polk',28.105376,-81.620692),('33845','FL','Haines City','Polk',28.152,-81.6331),('33846','FL','Highland City','Polk',27.965,-81.878),('33847','FL','Homeland','Polk',27.813692,-81.825327),('33848','FL','Intercession City','Osceola',28.26472,-81.505725),('33849','FL','Kathleen','Polk',28.22607,-82.068888),('33850','FL','Lake Alfred','Polk',28.096439,-81.73044),('33851','FL','Lake Hamilton','Polk',28.043715,-81.624768),('33852','FL','Lake Placid','Highlands',27.290403,-81.372581),('33853','FL','Lake Wales','Polk',27.900707,-81.58445),('33854','FL','Fedhaven','Polk',27.856274,-81.40993),('33855','FL','Indian Lake Estates','Polk',27.795078,-81.352158),('33856','FL','Nalcrest','Polk',27.856354,-81.428375),('33857','FL','Lorida','Highlands',27.392675,-81.16499),('33858','FL','Loughman','Polk',28.152,-81.6331),('33859','FL','Lake Wales','Polk',27.899717,-81.612205),('33860','FL','Mulberry','Polk',27.836112,-81.986217),('33862','FL','Lake Placid','Highlands',27.2927,-81.363),('33863','FL','Nichols','Polk',27.7914,-81.8585),('33865','FL','Ona','Hardee',27.408186,-81.940513),('33867','FL','River Ranch','Polk',27.7704,-81.189579),('33868','FL','Polk City','Polk',28.18619,-81.824145),('33870','FL','Sebring','Highlands',27.499025,-81.445155),('33871','FL','Sebring','Highlands',27.5001,-81.4396),('33872','FL','Sebring','Highlands',27.512955,-81.512545),('33873','FL','Wauchula','Hardee',27.550669,-81.804668),('33875','FL','Sebring','Highlands',27.428098,-81.464109),('33876','FL','Sebring','Highlands',27.435916,-81.360889),('33877','FL','Waverly','Polk',27.987524,-81.616625),('33880','FL','Winter Haven','Polk',28.000101,-81.750312),('33881','FL','Winter Haven','Polk',28.049532,-81.722335),('33882','FL','Winter Haven','Polk',28.0218,-81.7271),('33883','FL','Winter Haven','Polk',28.0218,-81.7271),('33884','FL','Winter Haven','Polk',27.987605,-81.674135),('33885','FL','Winter Haven','Polk',28.0451,-81.727),('33888','FL','Winter Haven','Polk',28.0218,-81.7271),('33890','FL','Zolfo Springs','Hardee',27.489434,-81.722999),('33896','FL','Davenport','Polk',28.249514,-81.597864),('33897','FL','Davenport','Polk',28.302984,-81.66823),('33898','FL','Lake Wales','Polk',27.867827,-81.426651),('33900','FL','Fort Myers','Lee',26.628432,-81.841793),('33901','FL','Fort Myers','Lee',26.623697,-81.872839),('33902','FL','Fort Myers','Lee',26.6439,-81.8727),('33903','FL','North Fort Myers','Lee',26.693975,-81.908172),('33904','FL','Cape Coral','Lee',26.578671,-81.950294),('33905','FL','Fort Myers','Lee',26.675453,-81.780316),('33906','FL','Fort Myers','Lee',26.5932,-81.8578),('33907','FL','Fort Myers','Lee',26.56609,-81.871983),('33908','FL','Fort Myers','Lee',26.502918,-81.925901),('33909','FL','Cape Coral','Lee',26.690924,-81.94695),('33910','FL','Cape Coral','Lee',26.6279,-81.9468),('33911','FL','Fort Myers','Lee',26.6402,-81.8725),('33912','FL','Fort Myers','Lee',26.538413,-81.831601),('33913','FL','Fort Myers','Lee',26.550638,-81.746683),('33914','FL','Cape Coral','Lee',26.574527,-82.00441),('33915','FL','Cape Coral','Lee',26.5797,-81.9564),('33916','FL','Fort Myers','Lee',26.639942,-81.844153),('33917','FL','North Fort Myers','Lee',26.714788,-81.862218),('33918','FL','North Fort Myers','Lee',26.6821,-81.8834),('33919','FL','Fort Myers','Lee',26.555511,-81.901106),('33920','FL','Alva','Lee',26.707085,-81.642083),('33921','FL','Boca Grande','Lee',26.760078,-82.263173),('33922','FL','Bokeelia','Lee',26.664396,-82.141313),('33924','FL','Captiva','Lee',26.583883,-82.213839),('33927','FL','El Jobean','Charlotte',26.9885,-82.1973),('33928','FL','Estero','Lee',26.430908,-81.799043),('33929','FL','Estero','Lee',26.42913,-81.810879),('33930','FL','Felda','Hendry',26.554068,-81.447572),('33931','FL','Fort Myers Beach','Lee',26.445744,-81.922972),('33932','FL','Fort Myers Beach','Lee',26.451,-81.9495),('33935','FL','Labelle','Hendry',26.755755,-81.425197),('33936','FL','Lehigh Acres','Lee',26.605344,-81.620253),('33938','FL','Murdock','Charlotte',27.0057,-82.1386),('33944','FL','Palmdale','Glades',26.96553,-81.309436),('33945','FL','Pineland','Lee',26.601746,-82.219792),('33946','FL','Placida','Charlotte',26.847465,-82.266144),('33947','FL','Rotonda West','Charlotte',26.898477,-82.268657),('33948','FL','Port Charlotte','Charlotte',26.983441,-82.148678),('33949','FL','Port Charlotte','Charlotte',26.9758,-82.0908),('33950','FL','Punta Gorda','Charlotte',26.911241,-82.04271),('33951','FL','Punta Gorda','Charlotte',26.9359,-82.0494),('33952','FL','Port Charlotte','Charlotte',26.993904,-82.098283),('33953','FL','Port Charlotte','Charlotte',27.011894,-82.211715),('33954','FL','Port Charlotte','Charlotte',27.024724,-82.122407),('33955','FL','Punta Gorda','Charlotte',26.831338,-81.994987),('33956','FL','Saint James City','Lee',26.532708,-82.089644),('33957','FL','Sanibel','Lee',26.442955,-82.083653),('33960','FL','Venus','Highlands',27.051356,-81.4334),('33965','FL','Fort Myers','Lee',26.463505,-81.777793),('33966','FL','Fort Myers','Lee',26.581483,-81.838327),('33967','FL','Fort Myers','Lee',26.471507,-81.812241),('33970','FL','Lehigh Acres','Lee',26.625,-81.625),('33971','FL','Lehigh Acres','Lee',26.637627,-81.696945),('33972','FL','Lehigh Acres','Lee',26.649272,-81.61771),('33973','FL','Lehigh Acres','Lee',26.600661,-81.730435),('33974','FL','Lehigh Acres','Lee',26.562732,-81.598316),('33975','FL','Labelle','Hendry',26.742327,-81.278631),('33976','FL','Lehigh Acres','Lee',26.59329,-81.682257),('33980','FL','Port Charlotte','Charlotte',26.983884,-82.059642),('33981','FL','Port Charlotte','Charlotte',26.926182,-82.231172),('33982','FL','Punta Gorda','Charlotte',26.957164,-81.970093),('33983','FL','Punta Gorda','Charlotte',27.000133,-82.014859),('33990','FL','Cape Coral','Lee',26.629941,-81.949087),('33991','FL','Cape Coral','Lee',26.630407,-82.00661),('33993','FL','Cape Coral','Lee',26.685184,-82.0203),('33994','FL','Fort Myers','Lee',26.6734,-81.8175),('34002','AA','Apo','',0,0),('34004','AA','Dpo','',0,0),('34006','AA','Apo','',0,0),('34007','AA','Apo','',0,0),('34008','AA','Apo','',0,0),('34011','AA','Dpo','',0,0),('34020','AA','Apo','',0,0),('34021','AA','Apo','',0,0),('34022','AA','Apo','',0,0),('34023','AA','Apo','',0,0),('34024','AA','Apo','',0,0),('34025','AA','Apo','',0,0),('34030','AA','Apo','',0,0),('34031','AA','Apo','',0,0),('34032','AA','Apo','',0,0),('34033','AA','Apo','',0,0),('34034','AA','Apo','',0,0),('34035','AA','Apo','',0,0),('34036','AA','Apo','',0,0),('34037','AA','Apo','',0,0),('34038','AA','Apo','',0,0),('34039','AA','Apo','',0,0),('34041','AA','Apo','',0,0),('34042','AA','Apo','',0,0),('34043','AA','Apo','',0,0),('34050','AA','Fpo','',0,0),('34055','AA','Fpo','',0,0),('34058','AA','Fpo','',0,0),('34060','AA','Dpo','',0,0),('34076','AA','Apo','',0,0),('34078','AA','Apo','',0,0),('34079','AA','Fpo','',0,0),('34090','AA','Fpo','',0,0),('34091','AA','Fpo','',0,0),('34092','AA','Fpo','',0,0),('34093','AA','Fpo','',0,0),('34095','AA','Fpo','',0,0),('34098','AA','Fpo','',0,0),('34099','AA','Fpo','',0,0),('34101','FL','Naples','Collier',26.1377,-81.7966),('34102','FL','Naples','Collier',26.144836,-81.798028),('34103','FL','Naples','Collier',26.19083,-81.801807),('34104','FL','Naples','Collier',26.1513,-81.744339),('34105','FL','Naples','Collier',26.190061,-81.764906),('34106','FL','Naples','Collier',26.1377,-81.7966),('34107','FL','Vanderbilt Beach','Collier',26.1627,-81.7912),('34108','FL','Naples','Collier',26.248901,-81.807546),('34109','FL','Naples','Collier',26.242321,-81.766281),('34110','FL','Naples','Collier',26.291496,-81.782957),('34112','FL','Naples','Collier',26.12191,-81.752522),('34113','FL','Naples','Collier',26.069111,-81.719219),('34114','FL','Naples','Collier',25.99852,-81.61658),('34116','FL','Naples','Collier',26.183507,-81.70654),('34117','FL','Naples','Collier',26.180909,-81.605313),('34119','FL','Naples','Collier',26.259564,-81.718778),('34120','FL','Naples','Collier',26.283962,-81.584163),('34133','FL','Bonita Springs','Lee',26.3869,-81.733),('34134','FL','Bonita Springs','Lee',26.353032,-81.824051),('34135','FL','Bonita Springs','Lee',26.352003,-81.771628),('34136','FL','Bonita Springs','Lee',26.3869,-81.733),('34137','FL','Copeland','Collier',25.941401,-81.362793),('34138','FL','Chokoloskee','Collier',25.813768,-81.363451),('34139','FL','Everglades City','Collier',25.849912,-81.389953),('34140','FL','Goodland','Collier',25.926008,-81.651025),('34141','FL','Ochopee','Collier',25.954827,-81.264595),('34142','FL','Immokalee','Collier',26.371783,-81.386836),('34143','FL','Immokalee','Collier',26.429,-81.4334),('34145','FL','Marco Island','Collier',25.933347,-81.7125),('34146','FL','Marco Island','Collier',25.9533,-81.7167),('34201','FL','Bradenton','Manatee',27.401694,-82.468511),('34202','FL','Bradenton','Manatee',27.407491,-82.417051),('34203','FL','Bradenton','Manatee',27.446011,-82.517079),('34204','FL','Bradenton','Manatee',27.4462,-82.511),('34205','FL','Bradenton','Manatee',27.482313,-82.582502),('34206','FL','Bradenton','Manatee',27.4952,-82.5709),('34207','FL','Bradenton','Manatee',27.438988,-82.57791),('34208','FL','Bradenton','Manatee',27.487432,-82.528922),('34209','FL','Bradenton','Manatee',27.487982,-82.630582),('34210','FL','Bradenton','Manatee',27.452096,-82.626564),('34211','FL','Bradenton','Manatee',27.451635,-82.408399),('34212','FL','Bradenton','Manatee',27.50362,-82.418784),('34215','FL','Cortez','Manatee',27.468434,-82.686595),('34216','FL','Anna Maria','Manatee',27.530884,-82.734878),('34217','FL','Bradenton Beach','Manatee',27.499689,-82.712252),('34218','FL','Holmes Beach','Manatee',27.4972,-82.7091),('34219','FL','Parrish','Manatee',27.566479,-82.399484),('34220','FL','Palmetto','Manatee',27.5211,-82.5725),('34221','FL','Palmetto','Manatee',27.55563,-82.556969),('34222','FL','Ellenton','Manatee',27.534273,-82.504258),('34223','FL','Englewood','Sarasota',26.974116,-82.366296),('34224','FL','Englewood','Charlotte',26.925497,-82.297643),('34228','FL','Longboat Key','Sarasota',27.395596,-82.64348),('34229','FL','Osprey','Sarasota',27.192368,-82.485242),('34230','FL','Sarasota','Sarasota',27.3348,-82.5375),('34231','FL','Sarasota','Sarasota',27.268006,-82.516762),('34232','FL','Sarasota','Sarasota',27.321101,-82.473765),('34233','FL','Sarasota','Sarasota',27.2843,-82.473077),('34234','FL','Sarasota','Sarasota',27.365271,-82.533848),('34235','FL','Sarasota','Sarasota',27.367325,-82.482043),('34236','FL','Sarasota','Sarasota',27.333618,-82.550121),('34237','FL','Sarasota','Sarasota',27.337013,-82.514037),('34238','FL','Sarasota','Sarasota',27.234115,-82.4751),('34239','FL','Sarasota','Sarasota',27.311192,-82.519707),('34240','FL','Sarasota','Sarasota',27.3333,-82.400945),('34241','FL','Sarasota','Sarasota',27.266,-82.403807),('34242','FL','Sarasota','Sarasota',27.270787,-82.5495),('34243','FL','Sarasota','Manatee',27.403063,-82.523066),('34250','FL','Terra Ceia','Manatee',27.575972,-82.584937),('34251','FL','Myakka City','Manatee',27.39847,-82.205177),('34260','FL','Sarasota','Manatee',27.403,-82.5437),('34264','FL','Oneco','Manatee',27.4472,-82.5463),('34265','FL','Arcadia','De Soto',27.1861,-81.8095),('34266','FL','Arcadia','Desoto',27.210981,-81.852393),('34267','FL','Fort Ogden','De Soto',27.1861,-81.8095),('34268','FL','Nocatee','Desoto',27.159041,-81.889888),('34269','FL','Arcadia','Desoto',27.064837,-81.98738),('34270','FL','Tallevast','Manatee',27.4013,-82.543),('34272','FL','Laurel','Sarasota',27.13,-82.4533),('34274','FL','Nokomis','Sarasota',27.1188,-82.4444),('34275','FL','Nokomis','Sarasota',27.140873,-82.437344),('34276','FL','Sarasota','Sarasota',27.3361,-82.5308),('34277','FL','Sarasota','Sarasota',27.3027,-82.5293),('34278','FL','Sarasota','Sarasota',27.322,-82.5022),('34280','FL','Bradenton','Manatee',27.4994,-82.6364),('34281','FL','Bradenton','Manatee',27.4401,-82.5827),('34282','FL','Bradenton','Manatee',27.4401,-82.5827),('34284','FL','Venice','Sarasota',27.09944,-82.450144),('34285','FL','Venice','Sarasota',27.094922,-82.437266),('34286','FL','North Port','Sarasota',27.073321,-82.182424),('34287','FL','North Port','Sarasota',27.051008,-82.244222),('34288','FL','North Port','Sarasota',27.052528,-82.110526),('34289','FL','North Port','Sarasota',27.087165,-82.143913),('34290','FL','North Port','Sarasota',27.0459,-82.2491),('34291','FL','North Po','Sarasota',27.094231,-82.232516),('34292','FL','Venice','Sarasota',27.103566,-82.36417),('34293','FL','Venice','Sarasota',27.052261,-82.388828),('34295','FL','Englewood','Sarasota',26.9659,-82.3318),('34420','FL','Belleview','Marion',29.052869,-82.04385),('34421','FL','Belleview','Marion',29.055,-82.0625),('34423','FL','Crystal River','Citrus',28.9593,-82.6259),('34428','FL','Crystal River','Citrus',28.951231,-82.613126),('34429','FL','Crystal River','Citrus',28.878806,-82.615325),('34430','FL','Dunnellon','Marion',29.0488,-82.4611),('34431','FL','Dunnellon','Marion',29.130602,-82.506135),('34432','FL','Dunnellon','Marion',29.065636,-82.366546),('34433','FL','Dunnellon','Citrus',28.992643,-82.505526),('34434','FL','Dunnellon','Citrus',28.992352,-82.452776),('34436','FL','Floral City','Citrus',28.745971,-82.28626),('34442','FL','Hernando','Citrus',28.924396,-82.396611),('34445','FL','Holder','Citrus',28.9637,-82.4186),('34446','FL','Homosassa','Citrus',28.749922,-82.534524),('34447','FL','Homosassa Springs','Citrus',28.8033,-82.5761),('34448','FL','Homosassa','Citrus',28.786208,-82.604071),('34449','FL','Inglis','Levy',29.054467,-82.669389),('34450','FL','Inverness','Citrus',28.834,-82.306183),('34451','FL','Inverness','Citrus',28.8355,-82.3305),('34452','FL','Inverness','Citrus',28.80699,-82.341699),('34453','FL','Inverness','Citrus',28.867039,-82.363103),('34460','FL','Lecanto','Citrus',28.9303,-82.4905),('34461','FL','Lecanto','Citrus',28.848792,-82.482157),('34464','FL','Beverly Hills','Citrus',28.9166,-82.4583),('34465','FL','Beverly Hills','Citrus',28.927919,-82.472203),('34470','FL','Ocala','Marion',29.198819,-82.101252),('34471','FL','Ocala','Marion',29.172162,-82.121906),('34472','FL','Ocala','Marion',29.116721,-82.017332),('34473','FL','Ocala','Marion',29.005686,-82.198471),('34474','FL','Ocala','Marion',29.157635,-82.203988),('34475','FL','Ocala','Marion',29.214797,-82.154078),('34476','FL','Ocala','Marion',29.082326,-82.211473),('34477','FL','Ocala','Marion',29.1869,-82.1402),('34478','FL','Ocala','Marion',29.1869,-82.1402),('34479','FL','Ocala','Marion',29.237981,-82.112277),('34480','FL','Ocala','Marion',29.125452,-82.082954),('34481','FL','Ocala','Marion',29.123233,-82.319199),('34482','FL','Ocala','Marion',29.226096,-82.237999),('34483','FL','Ocala','Marion',29.1541,-82.1937),('34484','FL','Oxford','Sumter',28.927242,-82.043906),('34487','FL','Homosassa','Citrus',28.7811,-82.6152),('34488','FL','Silver Springs','Marion',29.2066,-81.912069),('34489','FL','Silver Springs','Marion',29.2163,-82.0577),('34491','FL','Summerfield','Marion',29.000379,-82.016455),('34492','FL','Summerfield','Marion',29.0083,-82.035),('34498','FL','Yankeetown','Levy',29.031552,-82.736088),('34601','FL','Brooksville','Hernando',28.561235,-82.378398),('34602','FL','Brooksville','Hernando',28.513759,-82.290859),('34603','FL','Brooksville','Hernando',28.5562,-82.3862),('34604','FL','Brooksville','Hernando',28.473023,-82.458804),('34605','FL','Brooksville','Hernando',28.555,-82.388),('34606','FL','Spring Hill','Hernando',28.468477,-82.595728),('34607','FL','Spring Hill','Hernando',28.50886,-82.645324),('34608','FL','Spring Hill','Hernando',28.482826,-82.552854),('34609','FL','Spring Hill','Hernando',28.475551,-82.513468),('34610','FL','Spring Hill','Pasco',28.388301,-82.528859),('34611','FL','Spring Hill','Hernando',28.4859,-82.5832),('34613','FL','Brooksville','Hernando',28.551889,-82.533527),('34614','FL','Brooksville','Hernando',28.636322,-82.538042),('34636','FL','Istachatta','Hernando',28.6597,-82.2777),('34637','FL','Land O Lakes','Pasco',28.274435,-82.466577),('34638','FL','Land O Lakes','Pasco',28.259118,-82.502483),('34639','FL','Land O Lakes','Pasco',28.224543,-82.432243),('34652','FL','New Port Richey','Pasco',28.237841,-82.729221),('34653','FL','New Port Richey','Pasco',28.245067,-82.699509),('34654','FL','New Port Richey','Pasco',28.295595,-82.626926),('34655','FL','New Port Richey','Pasco',28.208567,-82.660965),('34656','FL','New Port Richey','Pasco',28.2438,-82.7194),('34660','FL','Ozona','Pinellas',28.0691,-82.7758),('34661','FL','Nobleton','Hernando',28.640909,-82.263265),('34667','FL','Hudson','Pasco',28.374744,-82.667821),('34668','FL','Port Richey','Pasco',28.300154,-82.697401),('34669','FL','Hudson','Pasco',28.352747,-82.615157),('34673','FL','Port Richey','Pasco',28.274,-82.72),('34674','FL','Hudson','Pasco',28.3537,-82.6978),('34677','FL','Oldsmar','Pinellas',28.04593,-82.679593),('34679','FL','Aripeka','Pasco',28.43092,-82.659483),('34680','FL','Elfers','Pasco',28.2092,-82.7155),('34681','FL','Crystal Beach','Pinellas',28.087588,-82.77672),('34682','FL','Palm Harbor','Pinellas',28.0777,-82.7638),('34683','FL','Palm Harbor','Pinellas',28.080378,-82.760939),('34684','FL','Palm Harbor','Pinellas',28.079131,-82.726341),('34685','FL','Palm Harbor','Pinellas',28.097386,-82.695327),('34688','FL','Tarpon Springs','Pinellas',28.147321,-82.701626),('34689','FL','Tarpon Springs','Pinellas',28.149572,-82.758008),('34690','FL','Holiday','Pasco',28.190247,-82.726848),('34691','FL','Holiday','Pasco',28.191282,-82.761155),('34692','FL','Holiday','Pasco',28.1857,-82.7379),('34695','FL','Safety Harbor','Pinellas',28.004967,-82.695091),('34697','FL','Dunedin','Pinellas',28.0256,-82.7636),('34698','FL','Dunedin','Pinellas',28.027472,-82.773433),('34705','FL','Astatula','Lake',28.707304,-81.727883),('34711','FL','Clermont','Lake',28.539263,-81.744866),('34712','FL','Clermont','Lake',28.4936,-81.7451),('34713','FL','Clermont','Lake',28.5436,-81.7503),('34714','FL','Clermont','Lake',28.385362,-81.696265),('34715','FL','Clermont','Lake',28.609554,-81.758022),('34729','FL','Ferndale','Lake',28.6216,-81.7036),('34731','FL','Fruitland Park','Lake',28.861811,-81.903571),('34734','FL','Gotha','Orange',28.543167,-81.523379),('34736','FL','Groveland','Lake',28.598014,-81.873194),('34737','FL','Howey In The Hills','Lake',28.695733,-81.785347),('34739','FL','Kenansville','Osceola',27.949383,-81.086205),('34740','FL','Killarney','Orange',28.4867,-81.6051),('34741','FL','Kissimmee','Osceola',28.303603,-81.422599),('34742','FL','Kissimmee','Osceola',28.2916,-81.4077),('34743','FL','Kissimmee','Osceola',28.327161,-81.352301),('34744','FL','Kissimmee','Osceola',28.305978,-81.363648),('34745','FL','Kissimmee','Osceola',28.3229,-81.3911),('34746','FL','Kissimmee','Osceola',28.287243,-81.46921),('34747','FL','Kissimmee','Osceola',28.315153,-81.582304),('34748','FL','Leesburg','Lake',28.777472,-81.882546),('34749','FL','Leesburg','Lake',28.8105,-81.878),('34753','FL','Mascotte','Lake',28.582517,-81.890931),('34755','FL','Minneola','Lake',28.5741,-81.7463),('34756','FL','Montverde','Lake',28.590954,-81.676296),('34758','FL','Kissimmee','Osceola',28.192115,-81.485787),('34759','FL','Kissimmee','Polk',28.102773,-81.482166),('34760','FL','Oakland','Orange',28.555591,-81.631023),('34761','FL','Ocoee','Orange',28.576693,-81.534416),('34762','FL','Okahumpka','Lake',28.746962,-81.898067),('34769','FL','Saint Cloud','Osceola',28.248493,-81.28861),('34770','FL','Saint Cloud','Osceola',28.2486,-81.2813),('34771','FL','Saint Cloud','Osceola',28.26868,-81.206521),('34772','FL','Saint Cloud','Osceola',28.187112,-81.269081),('34773','FL','Saint Cloud','Osceola',28.134039,-81.013798),('34777','FL','Winter Garden','Orange',28.4867,-81.6051),('34778','FL','Winter Garden','Orange',28.497,-81.616),('34785','FL','Wildwood','Sumter',28.847561,-82.034224),('34786','FL','Windermere','Orange',28.472674,-81.547484),('34787','FL','Winter Garden','Orange',28.521047,-81.600367),('34788','FL','Leesburg','Lake',28.858214,-81.784069),('34789','FL','Leesburg','Lake',28.8366,-81.7736),('34797','FL','Yalaha','Lake',28.741278,-81.818511),('34945','FL','Fort Pierce','St. Lucie',27.441405,-80.483974),('34946','FL','Fort Pierce','St. Lucie',27.487477,-80.351614),('34947','FL','Fort Pierce','St. Lucie',27.445698,-80.364066),('34948','FL','Fort Pierce','Saint Lucie',27.5147,-80.422),('34949','FL','Fort Pierce','St. Lucie',27.473103,-80.298542),('34950','FL','Fort Pierce','St. Lucie',27.447348,-80.336478),('34951','FL','Fort Pierce','St. Lucie',27.534279,-80.405864),('34952','FL','Port Saint Lucie','St. Lucie',27.288094,-80.296773),('34953','FL','Port Saint Lucie','St. Lucie',27.247699,-80.380979),('34954','FL','Fort Pierce','Saint Lucie',27.4467,-80.3419),('34956','FL','Indiantown','Martin',27.049641,-80.480559),('34957','FL','Jensen Beach','Martin',27.255181,-80.230515),('34958','FL','Jensen Beach','Martin',27.234,-80.2367),('34972','FL','Okeechobee','Okeechobee',27.397255,-80.89837),('34973','FL','Okeechobee','Okeechobee',27.322,-80.9805),('34974','FL','Okeechobee','Okeechobee',27.189298,-80.84931),('34979','FL','Fort Pierce','Saint Lucie',27.4463,-80.3258),('34981','FL','Fort Pierce','St. Lucie',27.401831,-80.364809),('34982','FL','Fort Pierce','St. Lucie',27.39144,-80.325103),('34983','FL','Port Saint Lucie','St. Lucie',27.317654,-80.351469),('34984','FL','Port Saint Lucie','St. Lucie',27.266887,-80.343592),('34985','FL','Port Saint Lucie','Saint Lucie',27.2936,-80.3505),('34986','FL','Port Saint Lucie','St. Lucie',27.322789,-80.400275),('34987','FL','Port Saint Lucie','St. Lucie',27.281955,-80.464878),('34988','FL','Port Saint Lucie','Saint Lucie',27.2854,-80.5892),('34990','FL','Palm City','Martin',27.166881,-80.30883),('34991','FL','Palm City','Martin',27.0718,-80.3248),('34992','FL','Port Salerno','Martin',27.1438,-80.2008),('34994','FL','Stuart','Martin',27.195736,-80.254096),('34995','FL','Stuart','Martin',27.1972,-80.253),('34996','FL','Stuart','Martin',27.194669,-80.210797),('34997','FL','Stuart','Martin',27.115697,-80.239713),('35004','AL','Moody','St. Clair',33.590799,-86.506468),('35005','AL','Adamsville','Jefferson',33.594284,-86.962824),('35006','AL','Adger','Jefferson',33.456805,-87.202905),('35007','AL','Alabaster','Shelby',33.227497,-86.810021),('35010','AL','Alexander City','Tallapoosa',32.908688,-85.937054),('35011','AL','Alexander City','Tallapoosa',32.9438,-85.9538),('35013','AL','Allgood','Blount',33.9018,-86.517019),('35014','AL','Alpine','Talladega',33.357764,-86.273197),('35015','AL','Alton','Jefferson',33.5791,-86.6375),('35016','AL','Arab','Marshall',34.327887,-86.493585),('35019','AL','Baileyton','Cullman',34.28649,-86.630504),('35020','AL','Bessemer','Jefferson',33.406407,-86.953079),('35021','AL','Bessemer','Jefferson',33.3942,-86.9609),('35022','AL','Bessemer','Jefferson',33.338599,-86.953822),('35023','AL','Bessemer','Jefferson',33.445246,-87.019922),('35031','AL','Blountsville','Blount',34.116105,-86.55225),('35032','AL','Bon Air','Talladega',33.2643,-86.334975),('35033','AL','Bremen','Cullman',33.956565,-87.03968),('35034','AL','Brent','Bibb',32.917218,-87.223353),('35035','AL','Brierfield','Bibb',33.042396,-86.957224),('35036','AL','Brookside','Jefferson',33.640216,-86.919714),('35038','AL','Burnwell','Walker',33.705,-87.084),('35040','AL','Calera','Shelby',33.120947,-86.744636),('35041','AL','Cardiff','Jefferson',33.6456,-86.9334),('35042','AL','Centreville','Bibb',32.957703,-87.137555),('35043','AL','Chelsea','Shelby',33.321245,-86.651499),('35044','AL','Childersburg','Talladega',33.269738,-86.356302),('35045','AL','Clanton','Chilton',32.834511,-86.641739),('35046','AL','Clanton','Chilton',32.911989,-86.548065),('35048','AL','Clay','Jefferson',33.7025,-86.5997),('35049','AL','Cleveland','Blount',33.9662,-86.598015),('35051','AL','Columbiana','Shelby',33.20804,-86.6185),('35052','AL','Cook Springs','St. Clair',33.590756,-86.409398),('35053','AL','Crane Hill','Cullman',34.035761,-87.069528),('35054','AL','Cropwell','St. Clair',33.50058,-86.310493),('35055','AL','Cullman','Cullman',34.168774,-86.82228),('35056','AL','Cullman','Cullman',34.1747,-86.8436),('35057','AL','Cullman','Cullman',34.13829,-86.924954),('35058','AL','Cullman','Cullman',34.221843,-86.776459),('35060','AL','Docena','Jefferson',33.559704,-86.933014),('35061','AL','Dolomite','Jefferson',33.463935,-86.959402),('35062','AL','Dora','Jefferson',33.720438,-87.032685),('35063','AL','Empire','Walker',33.809168,-87.009441),('35064','AL','Fairfield','Jefferson',33.480193,-86.915851),('35068','AL','Fultondale','Jefferson',33.61115,-86.814913),('35070','AL','Garden City','Cullman',34.01109,-86.748152),('35071','AL','Gardendale','Jefferson',33.682439,-86.821166),('35072','AL','Goodwater','Coosa',33.084243,-86.055645),('35073','AL','Graysville','Jefferson',33.643174,-86.969195),('35074','AL','Green Pond','Bibb',33.221897,-87.125009),('35077','AL','Hanceville','Cullman',34.046062,-86.801097),('35078','AL','Harpersville','Shelby',33.324276,-86.444487),('35079','AL','Hayden','Blount',33.924976,-86.766696),('35080','AL','Helena','Shelby',33.273753,-86.887762),('35082','AL','Hollins','Clay',33.116909,-86.169802),('35083','AL','Holly Pond','Cullman',34.188639,-86.602799),('35085','AL','Jemison','Chilton',32.97497,-86.728885),('35087','AL','Joppa','Cullman',34.303256,-86.583155),('35089','AL','Kellyton','Coosa',32.951201,-86.050514),('35091','AL','Kimberly','Jefferson',33.775542,-86.789164),('35094','AL','Leeds','Jefferson',33.530066,-86.553303),('35096','AL','Lincoln','Talladega',33.604415,-86.121235),('35097','AL','Locust Fork','Blount',33.896759,-86.630149),('35098','AL','Logan','Cullman',34.122318,-87.054166),('35111','AL','Mc Calla','Tuscaloosa',33.279854,-87.099396),('35112','AL','Margaret','St. Clair',33.689494,-86.473896),('35114','AL','Maylene','Shelby',33.225447,-86.8629),('35115','AL','Montevallo','Shelby',33.115889,-86.87417),('35116','AL','Morris','Jefferson',33.748742,-86.783746),('35117','AL','Mount Olive','Jefferson',33.655716,-86.880179),('35118','AL','Mulga','Jefferson',33.536793,-87.029404),('35119','AL','New Castle','Jefferson',33.641557,-86.775219),('35120','AL','Odenville','St. Clair',33.672585,-86.441274),('35121','AL','Oneonta','Blount',33.944821,-86.457985),('35123','AL','Palmerdale','Jefferson',33.7386,-86.6461),('35124','AL','Pelham','Shelby',33.311886,-86.781782),('35125','AL','Pell City','St. Clair',33.60871,-86.289508),('35126','AL','Pinson','Jefferson',33.715781,-86.655473),('35127','AL','Pleasant Grove','Jefferson',33.493203,-86.973678),('35128','AL','Pell City','St. Clair',33.560319,-86.303812),('35130','AL','Quinton','Walker',33.633615,-87.126636),('35131','AL','Ragland','St. Clair',33.722206,-86.173006),('35133','AL','Remlap','Blount',33.823096,-86.600413),('35135','AL','Riverside','St. Clair',33.614474,-86.203308),('35136','AL','Rockford','Coosa',32.886371,-86.30878),('35137','AL','Saginaw','Shelby',33.2161,-86.7919),('35139','AL','Sayre','Jefferson',33.711686,-86.975065),('35142','AL','Shannon','Jefferson',33.4052,-86.8719),('35143','AL','Shelby','Shelby',33.084555,-86.550751),('35144','AL','Siluria','Shelby',33.2291,-86.825),('35146','AL','Springville','St. Clair',33.780035,-86.45091),('35147','AL','Sterrett','Shelby',33.39315,-86.54006),('35148','AL','Sumiton','Walker',33.75331,-87.045743),('35149','AL','Sycamore','Talladega',33.251347,-86.205391),('35150','AL','Sylacauga','Talladega',33.188151,-86.259666),('35151','AL','Sylacauga','Talladega',33.119694,-86.339366),('35160','AL','Talladega','Talladega',33.42569,-86.11373),('35161','AL','Talladega','Talladega',33.3846,-86.0476),('35171','AL','Thorsby','Chilton',32.906853,-86.718816),('35172','AL','Trafford','Blount',33.826919,-86.712891),('35173','AL','Trussville','Jefferson',33.638787,-86.580364),('35175','AL','Union Grove','Marshall',34.437416,-86.521203),('35176','AL','Vandiver','Shelby',33.478367,-86.509882),('35178','AL','Vincent','Shelby',33.409599,-86.40275),('35179','AL','Vinemont','Cullman',34.257944,-86.922765),('35180','AL','Warrior','Jefferson',33.82643,-86.824656),('35181','AL','Watson','Jefferson',33.6867,-86.7769),('35182','AL','Wattsville','Saint Clair',33.7404,-86.4307),('35183','AL','Weogufka','Coosa',33.011521,-86.346605),('35184','AL','West Blocton','Bibb',33.126371,-87.128481),('35185','AL','Westover','Shelby',33.3494,-86.5358),('35186','AL','Wilsonville','Shelby',33.257633,-86.498929),('35187','AL','Wilton','Shelby',33.080534,-86.885794),('35188','AL','Woodstock','Bibb',33.202727,-87.155777),('35201','AL','Birmingham','Jefferson',33.519,-86.8014),('35202','AL','Birmingham','Jefferson',33.519,-86.8014),('35203','AL','Birmingham','Jefferson',33.519245,-86.809838),('35204','AL','Birmingham','Jefferson',33.520118,-86.837797),('35205','AL','Birmingham','Jefferson',33.497013,-86.805802),('35206','AL','Birmingham','Jefferson',33.565313,-86.722108),('35207','AL','Birmingham','Jefferson',33.559942,-86.818534),('35208','AL','Birmingham','Jefferson',33.495617,-86.880141),('35209','AL','Birmingham','Jefferson',33.470239,-86.805963),('35210','AL','Birmingham','Jefferson',33.544043,-86.676695),('35211','AL','Birmingham','Jefferson',33.478577,-86.859707),('35212','AL','Birmingham','Jefferson',33.540833,-86.752248),('35213','AL','Birmingham','Jefferson',33.507961,-86.744877),('35214','AL','Birmingham','Jefferson',33.560897,-86.892527),('35215','AL','Birmingham','Jefferson',33.638318,-86.694612),('35216','AL','Birmingham','Jefferson',33.420505,-86.785925),('35217','AL','Birmingham','Jefferson',33.589637,-86.765328),('35218','AL','Birmingham','Jefferson',33.507768,-86.894813),('35219','AL','Birmingham','Jefferson',33.4735,-86.8259),('35220','AL','Birmingham','Jefferson',33.6464,-86.6816),('35221','AL','Birmingham','Jefferson',33.451194,-86.895839),('35222','AL','Birmingham','Jefferson',33.523332,-86.772703),('35223','AL','Birmingham','Jefferson',33.48833,-86.744064),('35224','AL','Birmingham','Jefferson',33.518677,-86.931028),('35225','AL','Birmingham','Jefferson',33.4641,-86.813),('35226','AL','Birmingham','Jefferson',33.406923,-86.83312),('35228','AL','Birmingham','Jefferson',33.455673,-86.926095),('35229','AL','Birmingham','Jefferson',33.464275,-86.791159),('35230','AL','Birmingham','Jefferson',33.4641,-86.813),('35231','AL','Birmingham','Jefferson',33.564,-86.8953),('35232','AL','Birmingham','Jefferson',33.5375,-86.7564),('35233','AL','Birmingham','Jefferson',33.509833,-86.799796),('35234','AL','Birmingham','Jefferson',33.538314,-86.80759),('35235','AL','Birmingham','Jefferson',33.609854,-86.655123),('35236','AL','Birmingham','Jefferson',33.3733,-86.8104),('35237','AL','Birmingham','Jefferson',33.5167,-86.8071),('35238','AL','Birmingham','Jefferson',33.4144,-86.6753),('35240','AL','Birmingham','Jefferson',33.4641,-86.813),('35242','AL','Birmingham','Shelby',33.415344,-86.687552),('35243','AL','Birmingham','Jefferson',33.440918,-86.741509),('35244','AL','Birmingham','Jefferson',33.358318,-86.816121),('35245','AL','Birmingham','Jefferson',33.4641,-86.813),('35246','AL','Birmingham','Jefferson',33.519,-86.8014),('35249','AL','Birmingham','Jefferson',33.5055,-86.8015),('35253','AL','Birmingham','Jefferson',33.4848,-86.7737),('35254','AL','Birmingham','Jefferson',33.518012,-86.851923),('35255','AL','Birmingham','Jefferson',33.4991,-86.7985),('35259','AL','Birmingham','Jefferson',33.4828,-86.7918),('35260','AL','Birmingham','Jefferson',33.4131,-86.8471),('35261','AL','Birmingham','Jefferson',33.5847,-86.7038),('35263','AL','Birmingham','Jefferson',33.5311,-86.7834),('35266','AL','Birmingham','Jefferson',33.4444,-86.7908),('35277','AL','Birmingham','Jefferson',33.4429,-86.739),('35278','AL','Birmingham','Jefferson',33.4641,-86.813),('35279','AL','Birmingham','Jefferson',33.423,-86.7866),('35280','AL','Birmingham','Jefferson',33.519,-86.8014),('35281','AL','Birmingham','Jefferson',33.519,-86.8014),('35282','AL','Birmingham','Jefferson',33.519,-86.8014),('35283','AL','Birmingham','Jefferson',33.519,-86.8014),('35285','AL','Birmingham','Jefferson',33.519,-86.8014),('35286','AL','Birmingham','Jefferson',33.423,-86.7866),('35287','AL','Birmingham','Jefferson',33.519,-86.8014),('35288','AL','Birmingham','Jefferson',33.4641,-86.813),('35289','AL','Birmingham','Jefferson',33.519,-86.8014),('35290','AL','Birmingham','Jefferson',33.519,-86.8014),('35291','AL','Birmingham','Jefferson',33.519,-86.8014),('35292','AL','Birmingham','Jefferson',33.519,-86.8014),('35293','AL','Birmingham','Jefferson',33.4641,-86.813),('35294','AL','Birmingham','Jefferson',33.519,-86.8014),('35295','AL','Birmingham','Jefferson',33.519,-86.8014),('35296','AL','Birmingham','Jefferson',33.519,-86.8014),('35297','AL','Birmingham','Jefferson',33.519,-86.8014),('35298','AL','Birmingham','Jefferson',33.519,-86.8014),('35299','AL','Birmingham','Jefferson',33.519,-86.8014),('35401','AL','Tuscaloosa','Tuscaloosa',33.19383,-87.575898),('35402','AL','Tuscaloosa','Tuscaloosa',33.147,-87.6128),('35403','AL','Tuscaloosa','Tuscaloosa',33.205073,-87.52749),('35404','AL','Tuscaloosa','Tuscaloosa',33.215665,-87.495654),('35405','AL','Tuscaloosa','Tuscaloosa',33.147976,-87.525317),('35406','AL','Tuscaloosa','Tuscaloosa',33.277291,-87.50494),('35407','AL','Tuscaloosa','Tuscaloosa',33.1681,-87.5216),('35440','AL','Abernant','Tuscaloosa',33.2902,-87.198),('35441','AL','Akron','Hale',32.852763,-87.750329),('35442','AL','Aliceville','Pickens',33.10011,-88.164917),('35443','AL','Boligee','Greene',32.751369,-88.016364),('35444','AL','Brookwood','Tuscaloosa',33.289981,-87.298841),('35446','AL','Buhl','Tuscaloosa',33.200577,-87.737735),('35447','AL','Carrollton','Pickens',33.251569,-88.167326),('35448','AL','Clinton','Greene',32.9136,-87.9925),('35449','AL','Coaling','Tuscaloosa',33.1588,-87.3408),('35452','AL','Coker','Tuscaloosa',33.251206,-87.672301),('35453','AL','Cottondale','Tuscaloosa',33.178493,-87.405121),('35456','AL','Duncanville','Tuscaloosa',33.069686,-87.440815),('35457','AL','Echola','Tuscaloosa',33.279866,-87.776965),('35458','AL','Elrod','Tuscaloosa',33.344803,-87.784117),('35459','AL','Emelle','Sumter',32.825642,-88.30101),('35460','AL','Epes','Sumter',32.706614,-88.142697),('35461','AL','Ethelsville','Pickens',33.417374,-88.213613),('35462','AL','Eutaw','Greene',32.92298,-87.93743),('35463','AL','Fosters','Tuscaloosa',33.067553,-87.672524),('35464','AL','Gainesville','Sumter',32.816777,-88.160398),('35466','AL','Gordo','Pickens',33.289892,-87.89591),('35468','AL','Kellerman','Tuscaloosa',33.3405,-87.3047),('35469','AL','Knoxville','Greene',32.981199,-87.768414),('35470','AL','Livingston','Sumter',32.552502,-88.136136),('35471','AL','Mc Shan','Pickens',33.402134,-88.147325),('35473','AL','Northport','Tuscaloosa',33.26636,-87.585152),('35474','AL','Moundville','Hale',32.967957,-87.602081),('35475','AL','Northport','Tuscaloosa',33.379804,-87.590356),('35476','AL','Northport','Tuscaloosa',33.22904,-87.590773),('35477','AL','Panola','Sumter',32.956225,-88.24116),('35478','AL','Peterson','Tuscaloosa',33.2238,-87.4332),('35480','AL','Ralph','Tuscaloosa',33.078038,-87.819226),('35481','AL','Reform','Pickens',33.392061,-88.02667),('35482','AL','Samantha','Tuscaloosa',33.4222,-87.6052),('35485','AL','Tuscaloosa','Tuscaloosa',33.2097,-87.5691),('35486','AL','Tuscaloosa','Tuscaloosa',33.2097,-87.5691),('35487','AL','Tuscaloosa','Tuscaloosa',33.2177,-87.5455),('35490','AL','Vance','Tuscaloosa',33.194313,-87.249163),('35491','AL','West Greene','Greene',32.9236,-88.0852),('35501','AL','Jasper','Walker',33.828053,-87.283242),('35502','AL','Jasper','Walker',33.8311,-87.2775),('35503','AL','Jasper','Walker',33.91453,-87.299612),('35504','AL','Jasper','Walker',33.885885,-87.209199),('35540','AL','Addison','Winston',34.223269,-87.1714),('35541','AL','Arley','Winston',34.075356,-87.193045),('35542','AL','Bankston','Fayette',33.714567,-87.67859),('35543','AL','Bear Creek','Marion',34.248024,-87.719149),('35544','AL','Beaverton','Lamar',33.948167,-88.016378),('35545','AL','Belk','Fayette',33.649397,-87.931466),('35546','AL','Berry','Fayette',33.628887,-87.580668),('35548','AL','Brilliant','Marion',34.045003,-87.751136),('35549','AL','Carbon Hill','Walker',33.878787,-87.5246),('35550','AL','Cordova','Walker',33.755627,-87.165427),('35551','AL','Delmar','Winston',34.17,-87.6058),('35552','AL','Detroit','Lamar',34.062347,-88.139227),('35553','AL','Double Springs','Winston',34.13821,-87.393637),('35554','AL','Eldridge','Fayette',33.902883,-87.652717),('35555','AL','Fayette','Fayette',33.682625,-87.825904),('35559','AL','Glen Allen','Fayette',33.908183,-87.73461),('35560','AL','Goodsprings','Walker',33.6688,-87.2316),('35563','AL','Guin','Marion',33.978523,-87.89186),('35564','AL','Hackleburg','Marion',34.273198,-87.834644),('35565','AL','Haleyville','Winston',34.225299,-87.611947),('35570','AL','Hamilton','Marion',34.149533,-88.00349),('35571','AL','Hodges','Franklin',34.345278,-87.947429),('35572','AL','Houston','Winston',34.155508,-87.284273),('35573','AL','Kansas','Walker',33.9016,-87.5519),('35574','AL','Kennedy','Lamar',33.586869,-87.966206),('35575','AL','Lynn','Winston',34.049987,-87.572394),('35576','AL','Millport','Lamar',33.58546,-88.108027),('35577','AL','Natural Bridge','Winston',34.093359,-87.604289),('35578','AL','Nauvoo','Walker',33.971516,-87.45678),('35579','AL','Oakman','Walker',33.668716,-87.375675),('35580','AL','Parrish','Walker',33.68946,-87.263995),('35581','AL','Phil Campbell','Franklin',34.348512,-87.706415),('35582','AL','Red Bay','Franklin',34.454968,-88.121016),('35584','AL','Sipsey','Walker',33.823106,-87.08626),('35585','AL','Spruce Pine','Franklin',34.414988,-87.767808),('35586','AL','Sulligent','Lamar',33.867496,-88.132305),('35587','AL','Townley','Walker',33.806715,-87.428898),('35592','AL','Vernon','Lamar',33.752919,-88.091493),('35593','AL','Vina','Franklin',34.376375,-88.06382),('35594','AL','Winfield','Marion',33.927754,-87.789759),('35601','AL','Decatur','Morgan',34.594381,-86.989615),('35602','AL','Decatur','Morgan',34.6065,-86.9822),('35603','AL','Decatur','Morgan',34.5463,-86.968664),('35609','AL','Decatur','Morgan',34.6065,-86.9822),('35610','AL','Anderson','Lauderdale',34.954458,-87.245959),('35611','AL','Athens','Limestone',34.784165,-87.039522),('35612','AL','Athens','Limestone',34.8048,-86.9821),('35613','AL','Athens','Limestone',34.803998,-86.901069),('35614','AL','Athens','Limestone',34.859236,-87.060236),('35615','AL','Belle Mina','Limestone',34.6566,-86.8791),('35616','AL','Cherokee','Colbert',34.749956,-88.004619),('35617','AL','Cloverdale','Lauderdale',34.9386,-87.7713),('35618','AL','Courtland','Lawrence',34.663222,-87.308586),('35619','AL','Danville','Morgan',34.40805,-87.13081),('35620','AL','Elkmont','Limestone',34.924799,-86.982057),('35621','AL','Eva','Morgan',34.332659,-86.750215),('35622','AL','Falkville','Morgan',34.347256,-86.906008),('35630','AL','Florence','Lauderdale',34.819397,-87.662969),('35631','AL','Florence','Lauderdale',34.8932,-87.6375),('35632','AL','Florence','Lauderdale',34.8071,-87.681),('35633','AL','Florence','Lauderdale',34.891241,-87.760702),('35634','AL','Florence','Lauderdale',34.892377,-87.59959),('35640','AL','Hartselle','Morgan',34.443188,-86.94257),('35643','AL','Hillsboro','Lawrence',34.652617,-87.203249),('35645','AL','Killen','Lauderdale',34.894134,-87.509373),('35646','AL','Leighton','Colbert',34.660155,-87.535178),('35647','AL','Lester','Limestone',34.963463,-87.120904),('35648','AL','Lexington','Lauderdale',34.961544,-87.380788),('35649','AL','Mooresville','Limestone',34.62406,-86.872432),('35650','AL','Moulton','Lawrence',34.492216,-87.283284),('35651','AL','Mount Hope','Lawrence',34.481511,-87.488487),('35652','AL','Rogersville','Lauderdale',34.836701,-87.3118),('35653','AL','Russellville','Franklin',34.521618,-87.801145),('35654','AL','Russellville','Franklin',34.50851,-87.659572),('35660','AL','Sheffield','Colbert',34.759276,-87.694575),('35661','AL','Muscle Shoals','Colbert',34.759298,-87.621983),('35662','AL','Muscle Shoals','Colbert',34.7447,-87.6675),('35670','AL','Somerville','Morgan',34.481522,-86.753573),('35671','AL','Tanner','Limestone',34.66899,-86.950044),('35672','AL','Town Creek','Lawrence',34.64812,-87.41156),('35673','AL','Trinity','Lawrence',34.57517,-87.134216),('35674','AL','Tuscumbia','Colbert',34.698066,-87.721229),('35677','AL','Waterloo','Lauderdale',34.94876,-88.026799),('35699','AL','Decatur','Morgan',34.6065,-86.9822),('35739','AL','Ardmore','Limestone',34.972502,-86.801836),('35740','AL','Bridgeport','Jackson',34.944145,-85.731504),('35741','AL','Brownsboro','Madison',34.715375,-86.488326),('35742','AL','Capshaw','Limestone',34.813577,-86.804053),('35744','AL','Dutton','Jackson',34.607142,-85.911765),('35745','AL','Estillfork','Jackson',34.943634,-86.180196),('35746','AL','Fackler','Jackson',34.81901,-85.98013),('35747','AL','Grant','Marshall',34.479197,-86.28947),('35748','AL','Gurley','Madison',34.709444,-86.394098),('35749','AL','Harvest','Madison',34.818362,-86.754074),('35750','AL','Hazel Green','Madison',34.947226,-86.585519),('35751','AL','Hollytree','Jackson',34.807639,-86.249432),('35752','AL','Hollywood','Jackson',34.746295,-85.933347),('35754','AL','Laceys Spring','Morgan',34.515417,-86.602285),('35755','AL','Langston','Marshall',34.502175,-86.124512),('35756','AL','Madison','Limestone',34.649907,-86.802907),('35757','AL','Madison','Madison',34.774035,-86.748527),('35758','AL','Madison','Madison',34.714852,-86.742716),('35759','AL','Meridianville','Madison',34.862389,-86.563603),('35760','AL','New Hope','Madison',34.544651,-86.393171),('35761','AL','New Market','Madison',34.897687,-86.443101),('35762','AL','Normal','Madison',34.7924,-86.5718),('35763','AL','Owens Cross Roads','Madison',34.635774,-86.469857),('35764','AL','Paint Rock','Jackson',34.690848,-86.317059),('35765','AL','Pisgah','Jackson',34.681436,-85.811678),('35766','AL','Princeton','Jackson',34.858369,-86.230299),('35767','AL','Ryland','Madison',34.7697,-86.4796),('35768','AL','Scottsboro','Jackson',34.715472,-86.070777),('35769','AL','Scottsboro','Jackson',34.608365,-86.072934),('35771','AL','Section','Jackson',34.543759,-85.993399),('35772','AL','Stevenson','Jackson',34.871165,-85.837835),('35773','AL','Toney','Madison',34.891069,-86.707941),('35774','AL','Trenton','Jackson',34.755336,-86.213417),('35775','AL','Valhermoso Springs','Morgan',34.542934,-86.70596),('35776','AL','Woodville','Jackson',34.665149,-86.240094),('35801','AL','Huntsville','Madison',34.727009,-86.575682),('35802','AL','Huntsville','Madison',34.670229,-86.559785),('35803','AL','Huntsville','Madison',34.595216,-86.546047),('35804','AL','Huntsville','Madison',34.7277,-86.5926),('35805','AL','Huntsville','Madison',34.711457,-86.618016),('35806','AL','Huntsville','Madison',34.756254,-86.68009),('35807','AL','Huntsville','Madison',34.7197,-86.6148),('35808','AL','Huntsville','Madison',34.639224,-86.648786),('35809','AL','Huntsville','Madison',34.7302,-86.5861),('35810','AL','Huntsville','Madison',34.782309,-86.605015),('35811','AL','Huntsville','Madison',34.785613,-86.521809),('35812','AL','Huntsville','Madison',34.7953,-86.706),('35813','AL','Huntsville','Madison',34.6451,-86.7533),('35814','AL','Huntsville','Madison',34.7367,-86.6269),('35815','AL','Huntsville','Madison',34.7267,-86.5414),('35816','AL','Huntsville','Madison',34.739847,-86.628853),('35824','AL','Huntsville','Madison',34.64963,-86.749165),('35893','AL','Huntsville','Madison',34.7302,-86.5861),('35894','AL','Huntsville','Madison',34.6451,-86.7533),('35895','AL','Huntsville','Madison',34.7302,-86.5861),('35896','AL','Huntsville','Madison',34.755495,-86.654276),('35897','AL','Huntsville','Madison',34.7302,-86.5861),('35898','AL','Huntsville','Madison',34.6347,-86.6503),('35899','AL','Huntsville','Madison',34.7302,-86.5861),('35901','AL','Gadsden','Etowah',34.015945,-85.993683),('35902','AL','Gadsden','Etowah',34.0747,-85.9352),('35903','AL','Gadsden','Etowah',33.996997,-85.931346),('35904','AL','Gadsden','Etowah',34.026619,-86.036287),('35905','AL','Gadsden','Etowah',33.943787,-85.922632),('35906','AL','Rainbow City','Etowah',33.943179,-86.064348),('35907','AL','Gadsden','Etowah',33.903312,-86.026296),('35950','AL','Albertville','Marshall',34.261537,-86.235242),('35951','AL','Albertville','Marshall',34.318908,-86.177997),('35952','AL','Altoona','Etowah',34.058408,-86.323093),('35953','AL','Ashville','St. Clair',33.822694,-86.239015),('35954','AL','Attalla','Etowah',34.0412,-86.076676),('35956','AL','Boaz','Etowah',34.156248,-86.131968),('35957','AL','Boaz','Marshall',34.203773,-86.173055),('35958','AL','Bryant','Jackson',34.920565,-85.640234),('35959','AL','Cedar Bluff','Cherokee',34.228587,-85.597205),('35960','AL','Centre','Cherokee',34.143014,-85.614645),('35961','AL','Collinsville','Dekalb',34.278577,-85.855754),('35962','AL','Crossville','Dekalb',34.299346,-86.036639),('35963','AL','Dawson','Dekalb',34.351631,-85.926545),('35964','AL','Douglas','Marshall',34.1736,-86.3236),('35966','AL','Flat Rock','Jackson',34.785646,-85.688561),('35967','AL','Fort Payne','Dekalb',34.4239,-85.703079),('35968','AL','Fort Payne','Dekalb',34.489106,-85.758754),('35971','AL','Fyffe','Dekalb',34.457087,-85.929761),('35972','AL','Gallant','Etowah',33.993999,-86.24687),('35973','AL','Gaylesville','Cherokee',34.333119,-85.552517),('35974','AL','Geraldine','Dekalb',34.362751,-86.010291),('35975','AL','Groveoak','Dekalb',34.439345,-86.052603),('35976','AL','Guntersville','Marshall',34.347836,-86.310055),('35978','AL','Henagar','Dekalb',34.641114,-85.737821),('35979','AL','Higdon','Dekalb',34.834876,-85.61153),('35980','AL','Horton','Marshall',34.178588,-86.36724),('35981','AL','Ider','Dekalb',34.718566,-85.654477),('35983','AL','Leesburg','Cherokee',34.18495,-85.765439),('35984','AL','Mentone','Dekalb',34.541509,-85.57738),('35986','AL','Rainsville','Dekalb',34.500923,-85.845078),('35987','AL','Steele','St. Clair',33.913458,-86.242447),('35988','AL','Sylvania','Dekalb',34.560655,-85.800316),('35989','AL','Valley Head','Dekalb',34.590655,-85.64239),('35990','AL','Walnut Grove','Etowah',34.066448,-86.304539),('36003','AL','Autaugaville','Autauga',32.435099,-86.698826),('36005','AL','Banks','Pike',31.858389,-85.743382),('36006','AL','Billingsley','Autauga',32.651344,-86.715241),('36008','AL','Booth','Autauga',32.5002,-86.5719),('36009','AL','Brantley','Crenshaw',31.5752,-86.293291),('36010','AL','Brundidge','Pike',31.678844,-85.824426),('36013','AL','Cecil','Montgomery',32.295059,-85.994989),('36015','AL','Chapman','Butler',31.7304,-86.739),('36016','AL','Clayton','Barbour',31.850222,-85.414701),('36017','AL','Clio','Barbour',31.692752,-85.564379),('36020','AL','Coosada','Elmore',32.496899,-86.326776),('36022','AL','Deatsville','Elmore',32.610998,-86.389611),('36023','AL','East Tallassee','Tallapoosa',32.6074,-85.808),('36024','AL','Eclectic','Elmore',32.680002,-86.020728),('36025','AL','Elmore','Elmore',32.539375,-86.333667),('36026','AL','Equality','Coosa',32.770945,-86.083661),('36027','AL','Eufaula','Barbour',31.875614,-85.174002),('36028','AL','Dozier','Covington',31.472655,-86.37868),('36029','AL','Fitzpatrick','Bullock',32.207341,-85.920927),('36030','AL','Forest Home','Butler',31.861907,-86.857492),('36031','AL','Fort Davis','Macon',32.252034,-85.722892),('36032','AL','Fort Deposit','Lowndes',31.987167,-86.557897),('36033','AL','Georgiana','Butler',31.648547,-86.748925),('36034','AL','Glenwood','Pike',31.6325,-86.133888),('36035','AL','Goshen','Pike',31.757318,-86.129909),('36036','AL','Grady','Montgomery',31.974969,-86.142662),('36037','AL','Greenville','Butler',31.803205,-86.612642),('36038','AL','Gantt','Covington',31.41719,-86.484911),('36039','AL','Hardaway','Macon',32.285675,-85.821328),('36040','AL','Hayneville','Lowndes',32.188824,-86.67919),('36041','AL','Highland Home','Crenshaw',31.9138,-86.319978),('36042','AL','Honoraville','Crenshaw',31.855035,-86.445534),('36043','AL','Hope Hull','Montgomery',32.213407,-86.40767),('36045','AL','Kent','Elmore',32.6642,-86.0253),('36046','AL','Lapine','Crenshaw',32.022765,-86.336448),('36047','AL','Letohatchee','Lowndes',32.088123,-86.483798),('36048','AL','Louisville','Barbour',31.776136,-85.591462),('36049','AL','Luverne','Crenshaw',31.747961,-86.27335),('36051','AL','Marbury','Autauga',32.684059,-86.476141),('36052','AL','Mathews','Montgomery',32.187968,-86.041593),('36053','AL','Midway','Bullock',32.036684,-85.445927),('36054','AL','Millbrook','Elmore',32.492112,-86.369713),('36057','AL','Mount Meigs','Montgomery',32.3625,-86.1019),('36061','AL','Perote','Bullock',31.9286,-85.6975),('36062','AL','Petrey','Crenshaw',31.8486,-86.2077),('36064','AL','Pike Road','Montgomery',32.325774,-86.091222),('36065','AL','Pine Level','Montgomery',32.042813,-86.051409),('36066','AL','Prattville','Autauga',32.469507,-86.423901),('36067','AL','Prattville','Autauga',32.479195,-86.512478),('36068','AL','Prattville','Autauga',32.4595,-86.4728),('36069','AL','Ramer','Montgomery',32.087074,-86.15524),('36071','AL','Rutledge','Crenshaw',31.711192,-86.373251),('36072','AL','Eufaula','Barbour',31.8911,-85.1455),('36075','AL','Shorter','Macon',32.402916,-85.92805),('36078','AL','Tallassee','Elmore',32.549252,-85.915555),('36079','AL','Troy','Pike',31.779179,-85.995843),('36080','AL','Titus','Elmore',32.689871,-86.293612),('36081','AL','Troy','Pike',31.85191,-85.924091),('36082','AL','Troy','Pike',31.801919,-85.95478),('36083','AL','Tuskegee','Macon',32.436112,-85.698608),('36087','AL','Tuskegee Institute','Macon',32.415,-85.6802),('36088','AL','Tuskegee Institute','Macon',32.417226,-85.716754),('36089','AL','Union Springs','Bullock',32.141241,-85.714097),('36091','AL','Verbena','Chilton',32.752938,-86.509814),('36092','AL','Wetumpka','Elmore',32.585078,-86.223539),('36093','AL','Wetumpka','Elmore',32.477886,-86.171396),('36101','AL','Montgomery','Montgomery',32.3743,-86.3118),('36102','AL','Montgomery','Montgomery',32.3666,-86.3),('36103','AL','Montgomery','Montgomery',32.3666,-86.3),('36104','AL','Montgomery','Montgomery',32.379961,-86.313395),('36105','AL','Montgomery','Montgomery',32.302423,-86.307181),('36106','AL','Montgomery','Montgomery',32.354596,-86.269671),('36107','AL','Montgomery','Montgomery',32.37854,-86.278964),('36108','AL','Montgomery','Montgomery',32.350543,-86.362617),('36109','AL','Montgomery','Montgomery',32.383576,-86.24475),('36110','AL','Montgomery','Montgomery',32.429402,-86.270329),('36111','AL','Montgomery','Montgomery',32.339004,-86.27303),('36112','AL','Montgomery','Montgomery',32.380519,-86.349787),('36113','AL','Montgomery','Montgomery',32.380598,-86.346991),('36114','AL','Montgomery','Montgomery',32.4092,-86.2499),('36115','AL','Montgomery','Montgomery',32.407146,-86.247149),('36116','AL','Montgomery','Montgomery',32.305299,-86.228077),('36117','AL','Montgomery','Montgomery',32.369543,-86.156609),('36118','AL','Montgomery','Montgomery',32.3666,-86.3),('36119','AL','Montgomery','Montgomery',32.3666,-86.3),('36120','AL','Montgomery','Montgomery',32.3104,-86.2362),('36121','AL','Montgomery','Montgomery',32.3666,-86.3),('36123','AL','Montgomery','Montgomery',32.3494,-86.2212),('36124','AL','Montgomery','Montgomery',32.3666,-86.3),('36125','AL','Montgomery','Montgomery',32.3134,-86.3214),('36130','AL','Montgomery','Montgomery',32.378,-86.2982),('36131','AL','Montgomery','Montgomery',32.3666,-86.3),('36132','AL','Montgomery','Montgomery',32.3666,-86.3),('36133','AL','Montgomery','Montgomery',32.3666,-86.3),('36134','AL','Montgomery','Montgomery',32.3666,-86.3),('36135','AL','Montgomery','Montgomery',32.3666,-86.3),('36140','AL','Montgomery','Montgomery',32.3666,-86.3),('36141','AL','Montgomery','Montgomery',32.3666,-86.3),('36142','AL','Montgomery','Montgomery',32.3666,-86.3),('36177','AL','Montgomery','Montgomery',32.2289,-86.1893),('36191','AL','Montgomery','Montgomery',32.2289,-86.1893),('36201','AL','Anniston','Calhoun',33.660443,-85.851559),('36202','AL','Anniston','Calhoun',33.6584,-85.8268),('36203','AL','Oxford','Calhoun',33.59329,-85.836547),('36204','AL','Anniston','Calhoun',33.6853,-85.8231),('36205','AL','Anniston','Calhoun',33.718892,-85.788129),('36206','AL','Anniston','Calhoun',33.722643,-85.827765),('36207','AL','Anniston','Calhoun',33.65039,-85.766017),('36210','AL','Anniston','Calhoun',33.6578,-85.7717),('36250','AL','Alexandria','Calhoun',33.764709,-85.893939),('36251','AL','Ashland','Clay',33.251255,-85.854648),('36253','AL','Bynum','Calhoun',33.613,-85.9611),('36254','AL','Choccolocco','Calhoun',33.6591,-85.7036),('36255','AL','Cragford','Clay',33.182489,-85.737301),('36256','AL','Daviston','Tallapoosa',33.032499,-85.708841),('36257','AL','De Armanville','Calhoun',33.6772,-85.8365),('36258','AL','Delta','Clay',33.469506,-85.691517),('36260','AL','Eastaboga','Calhoun',33.590973,-85.990341),('36261','AL','Edwardsville','Cleburne',33.7072,-85.5091),('36262','AL','Fruithurst','Cleburne',33.78736,-85.453621),('36263','AL','Graham','Randolph',33.470072,-85.362114),('36264','AL','Heflin','Cleburne',33.614166,-85.554446),('36265','AL','Jacksonville','Calhoun',33.824816,-85.7713),('36266','AL','Lineville','Clay',33.327058,-85.718709),('36267','AL','Millerville','Clay',33.199544,-85.947356),('36268','AL','Munford','Talladega',33.508506,-85.950167),('36269','AL','Muscadine','Cleburne',33.739798,-85.383878),('36271','AL','Ohatchee','Calhoun',33.791785,-86.021026),('36272','AL','Piedmont','Calhoun',33.942782,-85.612432),('36273','AL','Ranburne','Cleburne',33.537096,-85.361999),('36274','AL','Roanoke','Randolph',33.161134,-85.371488),('36275','AL','Spring Garden','Cherokee',33.9727,-85.5538),('36276','AL','Wadley','Randolph',33.134003,-85.576944),('36277','AL','Weaver','Calhoun',33.756471,-85.820476),('36278','AL','Wedowee','Randolph',33.327299,-85.51218),('36279','AL','Wellington','Calhoun',33.854754,-85.898982),('36280','AL','Woodland','Randolph',33.38066,-85.396641),('36301','AL','Dothan','Houston',31.176172,-85.401083),('36302','AL','Dothan','Houston',31.2274,-85.3937),('36303','AL','Dothan','Houston',31.25479,-85.412205),('36304','AL','Dothan','Houston',31.2527,-85.4133),('36305','AL','Dothan','Houston',31.213554,-85.478704),('36310','AL','Abbeville','Henry',31.601814,-85.218305),('36311','AL','Ariton','Dale',31.590191,-85.684131),('36312','AL','Ashford','Houston',31.178994,-85.24262),('36313','AL','Bellwood','Geneva',31.176668,-85.795612),('36314','AL','Black','Geneva',31.011786,-85.769469),('36316','AL','Chancellor','Geneva',31.175669,-85.863817),('36317','AL','Clopton','Henry',31.656401,-85.386162),('36318','AL','Coffee Springs','Geneva',31.169524,-85.950531),('36319','AL','Columbia','Houston',31.312619,-85.144663),('36320','AL','Cottonwood','Houston',31.05051,-85.327022),('36321','AL','Cowarts','Houston',31.201092,-85.300719),('36322','AL','Daleville','Dale',31.284449,-85.721101),('36323','AL','Elba','Coffee',31.419283,-86.069574),('36330','AL','Enterprise','Coffee',31.32047,-85.835778),('36331','AL','Enterprise','Coffee',31.4121,-85.8664),('36340','AL','Geneva','Geneva',31.043152,-85.880717),('36343','AL','Gordon','Houston',31.08366,-85.132624),('36344','AL','Hartford','Geneva',31.09546,-85.702878),('36345','AL','Headland','Henry',31.367734,-85.327085),('36346','AL','Jack','Coffee',31.557904,-85.925052),('36349','AL','Malvern','Geneva',31.1485,-85.5063),('36350','AL','Midland City','Dale',31.319062,-85.491202),('36351','AL','New Brockton','Coffee',31.406429,-85.917226),('36352','AL','Newton','Houston',31.264999,-85.609699),('36353','AL','Newville','Henry',31.455384,-85.348865),('36360','AL','Ozark','Dale',31.449771,-85.636159),('36361','AL','Ozark','Dale',31.4562,-85.6459),('36362','AL','Fort Rucker','Dale',31.33981,-85.706558),('36370','AL','Pansey','Houston',31.143856,-85.166637),('36371','AL','Pinckard','Dale',31.315307,-85.548217),('36373','AL','Shorterville','Henry',31.541592,-85.0974),('36374','AL','Skipperville','Dale',31.590768,-85.504338),('36375','AL','Slocomb','Geneva',31.088299,-85.548628),('36376','AL','Webb','Houston',31.256576,-85.2713),('36401','AL','Evergreen','Conecuh',31.456384,-86.947945),('36420','AL','Andalusia','Covington',31.237084,-86.505788),('36421','AL','Andalusia','Covington',31.341036,-86.49042),('36425','AL','Beatrice','Monroe',31.741647,-87.196859),('36426','AL','Brewton','Escambia',31.129765,-87.083418),('36427','AL','Brewton','Escambia',31.105,-87.0722),('36429','AL','Brooklyn','Conecuh',31.4944,-86.9125),('36432','AL','Castleberry','Conecuh',31.295981,-87.036726),('36435','AL','Coy','Wilcox',31.869578,-87.451384),('36436','AL','Dickinson','Clarke',31.774796,-87.675976),('36439','AL','Excel','Monroe',31.42736,-87.340774),('36441','AL','Flomaton','Escambia',31.023756,-87.249776),('36442','AL','Florala','Covington',31.04546,-86.334493),('36444','AL','Franklin','Monroe',31.675426,-87.452134),('36445','AL','Frisco City','Monroe',31.433167,-87.415574),('36446','AL','Fulton','Clarke',31.790814,-87.724978),('36449','AL','Goodway','Monroe',31.3951,-87.4184),('36451','AL','Grove Hill','Clarke',31.711867,-87.781245),('36453','AL','Kinston','Coffee',31.195383,-86.154085),('36454','AL','Lenox','Conecuh',31.33468,-87.207499),('36455','AL','Lockhart','Covington',31.012229,-86.352249),('36456','AL','Mc Kenzie','Butler',31.548429,-86.770709),('36457','AL','Megargel','Monroe',31.3797,-87.4283),('36458','AL','Mexia','Monroe',31.5069,-87.3883),('36460','AL','Monroeville','Monroe',31.502751,-87.320515),('36461','AL','Monroeville','Monroe',31.5277,-87.3247),('36462','AL','Monroeville','Monroe',31.5277,-87.3247),('36467','AL','Opp','Covington',31.271501,-86.259866),('36470','AL','Perdue Hill','Monroe',31.563114,-87.535471),('36471','AL','Peterman','Monroe',31.605612,-87.255785),('36473','AL','Range','Conecuh',31.312362,-87.234757),('36474','AL','Red Level','Covington',31.42064,-86.611226),('36475','AL','Repton','Conecuh',31.37844,-87.239485),('36476','AL','River Falls','Covington',31.362361,-86.549731),('36477','AL','Samson','Geneva',31.087299,-86.066739),('36480','AL','Uriah','Monroe',31.322465,-87.586382),('36481','AL','Vredenburgh','Monroe',31.822757,-87.345029),('36482','AL','Whatley','Clarke',31.622568,-87.659297),('36483','AL','Wing','Covington',31.037467,-86.703269),('36501','AL','Alma','Clarke',31.463968,-87.738833),('36502','AL','Atmore','Escambia',31.089676,-87.484434),('36503','AL','Atmore','Escambia',31.1322,-87.4696),('36504','AL','Atmore','Escambia',31.0236,-87.4938),('36505','AL','Axis','Mobile',30.946828,-88.016705),('36507','AL','Bay Minette','Baldwin',30.868438,-87.771482),('36509','AL','Bayou La Batre','Mobile',30.400964,-88.25129),('36511','AL','Bon Secour','Baldwin',30.308282,-87.738377),('36512','AL','Bucks','Mobile',31.00119,-88.020391),('36513','AL','Calvert','Washington',31.160437,-88.012889),('36515','AL','Carlton','Clarke',31.375467,-87.785061),('36518','AL','Chatom','Washington',31.456615,-88.261355),('36521','AL','Chunchula','Mobile',30.959716,-88.191636),('36522','AL','Citronelle','Mobile',31.067317,-88.268868),('36523','AL','Coden','Mobile',30.385143,-88.184112),('36524','AL','Coffeeville','Clarke',31.79114,-88.067774),('36525','AL','Creola','Mobile',30.892743,-88.024122),('36526','AL','Daphne','Baldwin',30.620523,-87.878492),('36527','AL','Spanish Fort','Baldwin',30.68174,-87.890462),('36528','AL','Dauphin Island','Mobile',30.252732,-88.114879),('36529','AL','Deer Park','Washington',31.277445,-88.278821),('36530','AL','Elberta','Baldwin',30.388904,-87.56448),('36532','AL','Fairhope','Baldwin',30.511001,-87.881595),('36533','AL','Fairhope','Baldwin',30.5227,-87.8992),('36535','AL','Foley','Baldwin',30.393928,-87.697674),('36536','AL','Foley','Baldwin',30.4079,-87.6851),('36538','AL','Frankville','Washington',31.645776,-88.141817),('36539','AL','Fruitdale','Washington',31.348624,-88.394107),('36540','AL','Gainestown','Clarke',31.453874,-87.692117),('36541','AL','Grand Bay','Mobile',30.490875,-88.339134),('36542','AL','Gulf Shores','Baldwin',30.280396,-87.736226),('36543','AL','Huxford','Escambia',31.219607,-87.462209),('36544','AL','Irvington','Mobile',30.467437,-88.237107),('36545','AL','Jackson','Clarke',31.488511,-87.871704),('36547','AL','Gulf Shores','Baldwin',30.2458,-87.7008),('36548','AL','Leroy','Washington',31.48898,-87.967725),('36549','AL','Lillian','Baldwin',30.402163,-87.457664),('36550','AL','Little River','Baldwin',31.228497,-87.718975),('36551','AL','Loxley','Baldwin',30.632266,-87.74914),('36553','AL','Mc Intosh','Washington',31.242826,-88.05275),('36555','AL','Magnolia Springs','Baldwin',30.403615,-87.772915),('36556','AL','Malcolm','Washington',31.207954,-87.965168),('36558','AL','Millry','Washington',31.621199,-88.327956),('36559','AL','Montrose','Baldwin',30.564656,-87.902194),('36560','AL','Mount Vernon','Mobile',31.088166,-88.040353),('36561','AL','Orange Beach','Baldwin',30.289974,-87.571589),('36562','AL','Perdido','Baldwin',31.024027,-87.64895),('36564','AL','Point Clear','Baldwin',30.478695,-87.926509),('36567','AL','Robertsdale','Baldwin',30.59092,-87.613563),('36568','AL','Saint Elmo','Mobile',30.51716,-88.27621),('36569','AL','Saint Stephens','Washington',31.538323,-88.068978),('36571','AL','Saraland','Mobile',30.834785,-88.09292),('36572','AL','Satsuma','Mobile',30.85796,-88.054147),('36574','AL','Seminole','Baldwin',30.511993,-87.467658),('36575','AL','Semmes','Mobile',30.766252,-88.265686),('36576','AL','Silverhill','Baldwin',30.541444,-87.755582),('36577','AL','Spanish Fort','Baldwin',30.668757,-87.939711),('36578','AL','Stapleton','Baldwin',30.737421,-87.771667),('36579','AL','Stockton','Baldwin',31.100108,-87.807949),('36580','AL','Summerdale','Baldwin',30.483448,-87.71265),('36581','AL','Sunflower','Washington',31.374972,-87.968913),('36582','AL','Theodore','Mobile',30.529721,-88.165965),('36583','AL','Tibbie','Washington',31.340424,-88.200355),('36584','AL','Vinegar Bend','Washington',31.18909,-88.370791),('36585','AL','Wagarville','Washington',31.392412,-88.04881),('36587','AL','Wilmer','Mobile',30.834059,-88.345664),('36590','AL','Theodore','Mobile',30.5475,-88.1752),('36601','AL','Mobile','Mobile',30.6959,-88.0434),('36602','AL','Mobile','Mobile',30.692024,-88.045826),('36603','AL','Mobile','Mobile',30.682902,-88.045686),('36604','AL','Mobile','Mobile',30.681191,-88.068279),('36605','AL','Mobile','Mobile',30.625119,-88.085625),('36606','AL','Mobile','Mobile',30.673113,-88.10722),('36607','AL','Mobile','Mobile',30.697341,-88.106724),('36608','AL','Mobile','Mobile',30.68974,-88.207721),('36609','AL','Mobile','Mobile',30.662185,-88.159207),('36610','AL','Mobile','Mobile',30.736634,-88.079325),('36611','AL','Mobile','Mobile',30.76579,-88.08165),('36612','AL','Mobile','Mobile',30.752432,-88.111309),('36613','AL','Eight Mile','Mobile',30.798491,-88.170499),('36615','AL','Mobile','Mobile',30.643289,-88.067876),('36616','AL','Mobile','Mobile',30.6941,-88.043),('36617','AL','Mobile','Mobile',30.716026,-88.095707),('36618','AL','Mobile','Mobile',30.731238,-88.172723),('36619','AL','Mobile','Mobile',30.59273,-88.182876),('36621','AL','Mobile','Mobile',30.6959,-88.0434),('36622','AL','Mobile','Mobile',30.6959,-88.0434),('36625','AL','Mobile','Mobile',30.6959,-88.0434),('36628','AL','Mobile','Mobile',30.6959,-88.0434),('36630','AL','Mobile','Mobile',30.6959,-88.0434),('36633','AL','Mobile','Mobile',30.6959,-88.0434),('36640','AL','Mobile','Mobile',30.6901,-88.0568),('36641','AL','Mobile','Mobile',30.6901,-88.0568),('36644','AL','Mobile','Mobile',30.6925,-88.0432),('36652','AL','Mobile','Mobile',30.6959,-88.0434),('36660','AL','Mobile','Mobile',30.675,-88.0867),('36663','AL','Mobile','Mobile',30.8179,-88.1926),('36670','AL','Mobile','Mobile',30.6954,-88.1059),('36671','AL','Mobile','Mobile',30.7753,-88.0791),('36675','AL','Mobile','Mobile',30.6941,-88.043),('36685','AL','Mobile','Mobile',30.6941,-88.043),('36688','AL','Mobile','Mobile',30.695645,-88.181582),('36689','AL','Mobile','Mobile',30.6893,-88.1731),('36690','AL','Mobile','Mobile',30.6959,-88.0434),('36691','AL','Mobile','Mobile',30.6267,-88.1499),('36693','AL','Mobile','Mobile',30.631002,-88.150466),('36695','AL','Mobile','Mobile',30.651477,-88.23499),('36701','AL','Selma','Dallas',32.433762,-87.045356),('36702','AL','Selma','Dallas',32.4058,-87.0235),('36703','AL','Selma','Dallas',32.418515,-86.971336),('36720','AL','Alberta','Wilcox',32.161501,-87.346372),('36721','AL','Annemanie','Wilcox',32.0527,-87.5708),('36722','AL','Arlington','Wilcox',32.079159,-87.575694),('36723','AL','Boykin','Wilcox',32.068375,-87.294343),('36726','AL','Camden','Wilcox',31.998119,-87.303871),('36727','AL','Campbell','Clarke',31.928116,-88.016305),('36728','AL','Catherine','Wilcox',32.156959,-87.458948),('36732','AL','Demopolis','Marengo',32.48547,-87.861628),('36736','AL','Dixons Mills','Marengo',32.060282,-87.776198),('36738','AL','Faunsdale','Marengo',32.42097,-87.624965),('36740','AL','Forkland','Greene',32.6143,-87.836028),('36741','AL','Furman','Wilcox',31.9377,-87.0096),('36742','AL','Gallion','Marengo',32.481518,-87.758877),('36744','AL','Greensboro','Hale',32.703517,-87.60311),('36745','AL','Jefferson','Marengo',32.3866,-87.898),('36748','AL','Linden','Marengo',32.294376,-87.787348),('36749','AL','Jones','Autauga',32.536256,-86.893789),('36750','AL','Maplesville','Chilton',32.789617,-86.849378),('36751','AL','Lower Peach Tree','Monroe',31.81112,-87.533308),('36752','AL','Lowndesboro','Lowndes',32.30724,-86.646498),('36753','AL','Mc Williams','Monroe',31.829003,-87.093714),('36754','AL','Magnolia','Marengo',32.150971,-87.707986),('36756','AL','Marion','Perry',32.680374,-87.273438),('36758','AL','Plantersville','Dallas',32.647325,-86.913177),('36759','AL','Marion Junction','Dallas',32.428406,-87.272448),('36761','AL','Minter','Dallas',32.085584,-86.9631),('36762','AL','Morvin','Clarke',31.98,-87.9794),('36763','AL','Myrtlewood','Marengo',32.256218,-87.9565),('36764','AL','Nanafalia','Marengo',32.1127,-87.988),('36765','AL','Newbern','Hale',32.581957,-87.525112),('36766','AL','Oak Hill','Wilcox',31.924897,-87.086917),('36767','AL','Orrville','Dallas',32.277225,-87.224302),('36768','AL','Pine Apple','Wilcox',31.894928,-87.017687),('36769','AL','Pine Hill','Wilcox',31.994502,-87.565413),('36773','AL','Safford','Dallas',32.258945,-87.357531),('36775','AL','Sardis','Dallas',32.212647,-86.999704),('36776','AL','Sawyerville','Hale',32.752376,-87.736738),('36782','AL','Sweet Water','Marengo',32.114817,-87.901785),('36783','AL','Thomaston','Marengo',32.247263,-87.597245),('36784','AL','Thomasville','Clarke',31.931245,-87.759195),('36785','AL','Tyler','Lowndes',32.279993,-86.823354),('36786','AL','Uniontown','Perry',32.440992,-87.495473),('36790','AL','Stanton','Chilton',32.731347,-86.900316),('36792','AL','Randolph','Bibb',32.931002,-86.891603),('36793','AL','Lawley','Bibb',32.840566,-86.99986),('36801','AL','Opelika','Lee',32.665401,-85.39386),('36802','AL','Opelika','Lee',32.645,-85.3742),('36803','AL','Opelika','Lee',32.645,-85.3742),('36804','AL','Opelika','Lee',32.576895,-85.330734),('36830','AL','Auburn','Lee',32.587412,-85.476057),('36831','AL','Auburn','Lee',32.5161,-85.4832),('36832','AL','Auburn','Lee',32.591295,-85.535385),('36849','AL','Auburn University','Lee',32.602499,-85.485759),('36850','AL','Camp Hill','Tallapoosa',32.799869,-85.650466),('36851','AL','Cottonton','Russell',32.1466,-85.0738),('36852','AL','Cusseta','Lee',32.750248,-85.277636),('36853','AL','Dadeville','Tallapoosa',32.793514,-85.791648),('36854','AL','Valley','Chambers',32.778837,-85.17464),('36855','AL','Five Points','Chambers',33.037096,-85.303445),('36856','AL','Fort Mitchell','Russell',32.29812,-85.002002),('36858','AL','Hatchechubbee','Russell',32.296965,-85.31421),('36859','AL','Holy Trinity','Russell',32.220059,-85.001693),('36860','AL','Hurtsboro','Russell',32.240396,-85.42259),('36861','AL','Jacksons Gap','Tallapoosa',32.873618,-85.844449),('36862','AL','Lafayette','Chambers',32.90321,-85.428616),('36863','AL','Lanett','Chambers',32.867986,-85.212864),('36865','AL','Loachapoka','Lee',32.602618,-85.589334),('36866','AL','Notasulga','Macon',32.551615,-85.705004),('36867','AL','Phenix City','Russell',32.488761,-85.020249),('36868','AL','Phenix City','Russell',32.3877,-85.1008),('36869','AL','Phenix City','Russell',32.43131,-85.046843),('36870','AL','Phenix City','Lee',32.485303,-85.079544),('36871','AL','Pittsview','Russell',32.171174,-85.127539),('36872','AL','Valley','Lee',32.7772,-85.1473),('36874','AL','Salem','Lee',32.583597,-85.187705),('36875','AL','Seale','Russell',32.323377,-85.13161),('36877','AL','Smiths Station','Lee',32.545335,-85.093242),('36879','AL','Waverly','Lee',32.71812,-85.553104),('36901','AL','Bellamy','Sumter',32.450915,-88.135247),('36904','AL','Butler','Choctaw',32.09684,-88.229143),('36907','AL','Cuba','Sumter',32.41577,-88.354329),('36908','AL','Gilbertown','Choctaw',31.896824,-88.293498),('36910','AL','Jachin','Choctaw',32.203362,-88.144691),('36912','AL','Lisman','Choctaw',32.227539,-88.324244),('36913','AL','Melvin','Choctaw',31.969309,-88.443017),('36915','AL','Needham','Choctaw',31.973753,-88.363694),('36916','AL','Pennington','Choctaw',32.209837,-88.059888),('36919','AL','Silas','Choctaw',31.780502,-88.302296),('36921','AL','Toxey','Choctaw',31.904199,-88.244472),('36922','AL','Ward','Choctaw',32.309639,-88.175575),('36925','AL','York','Sumter',32.456583,-88.254757),('37010','TN','Adams','Montgomery',36.5624,-87.093532),('37011','TN','Antioch','Davidson',36.0489,-86.6463),('37012','TN','Alexandria','Dekalb',36.076926,-86.01867),('37013','TN','Antioch','Davidson',36.049008,-86.647437),('37014','TN','Arrington','Williamson',35.860229,-86.655675),('37015','TN','Ashland City','Cheatham',36.298113,-87.069254),('37016','TN','Auburntown','Cannon',35.951146,-86.096045),('37018','TN','Beechgrove','Coffee',35.652869,-86.197139),('37019','TN','Belfast','Marshall',35.390541,-86.709393),('37020','TN','Bell Buckle','Bedford',35.617019,-86.399936),('37022','TN','Bethpage','Sumner',36.493474,-86.306502),('37023','TN','Big Rock','Stewart',36.582282,-87.786317),('37024','TN','Brentwood','Williamson',36.033,-86.7827),('37025','TN','Bon Aqua','Hickman',35.949815,-87.295444),('37026','TN','Bradyville','Cannon',35.700723,-86.110277),('37027','TN','Brentwood','Williamson',36.005063,-86.782005),('37028','TN','Bumpus Mills','Stewart',36.633252,-87.86798),('37029','TN','Burns','Dickson',36.044077,-87.283659),('37030','TN','Carthage','Smith',36.267154,-85.957587),('37031','TN','Castalian Springs','Sumner',36.377463,-86.301172),('37032','TN','Cedar Hill','Robertson',36.52448,-87.022656),('37033','TN','Centerville','Hickman',35.751944,-87.521077),('37034','TN','Chapel Hill','Marshall',35.634114,-86.69056),('37035','TN','Chapmansboro','Cheatham',36.37465,-87.12757),('37036','TN','Charlotte','Dickson',36.225733,-87.290967),('37037','TN','Christiana','Rutherford',35.703084,-86.351238),('37040','TN','Clarksville','Montgomery',36.54087,-87.336338),('37041','TN','Clarksville','Montgomery',36.5297,-87.3594),('37042','TN','Clarksville','Montgomery',36.587177,-87.403836),('37043','TN','Clarksville','Montgomery',36.50648,-87.257183),('37044','TN','Clarksville','Montgomery',36.5297,-87.3594),('37046','TN','College Grove','Williamson',35.787063,-86.717883),('37047','TN','Cornersville','Marshall',35.329091,-86.846322),('37048','TN','Cottontown','Sumner',36.493693,-86.598823),('37049','TN','Cross Plains','Robertson',36.561987,-86.682346),('37050','TN','Cumberland City','Stewart',36.375358,-87.646295),('37051','TN','Cumberland Furnace','Dickson',36.299826,-87.41119),('37052','TN','Cunningham','Montgomery',36.378785,-87.408538),('37055','TN','Dickson','Dickson',36.066203,-87.406352),('37056','TN','Dickson','Dickson',36.0754,-87.386),('37057','TN','Dixon Springs','Smith',36.394877,-86.044583),('37058','TN','Dover','Stewart',36.478666,-87.856056),('37059','TN','Dowelltown','Dekalb',35.998705,-85.904753),('37060','TN','Eagleville','Rutherford',35.741742,-86.642194),('37061','TN','Erin','Houston',36.299412,-87.676473),('37062','TN','Fairview','Williamson',35.977253,-87.141114),('37063','TN','Fosterville','Rutherford',35.655,-86.403),('37064','TN','Franklin','Williamson',35.894972,-86.896958),('37065','TN','Franklin','Williamson',35.925,-86.8688),('37066','TN','Gallatin','Sumner',36.382726,-86.456618),('37067','TN','Franklin','Williamson',35.930138,-86.802675),('37068','TN','Franklin','Williamson',35.925,-86.8688),('37069','TN','Franklin','Williamson',35.978854,-86.889224),('37070','TN','Goodlettsville','Davidson',36.323,-86.7133),('37071','TN','Gladeville','Wilson',36.1125,-86.4163),('37072','TN','Goodlettsville','Davidson',36.3478,-86.721949),('37073','TN','Greenbrier','Robertson',36.427085,-86.804385),('37074','TN','Hartsville','Trousdale',36.405517,-86.149597),('37075','TN','Hendersonville','Sumner',36.318422,-86.606107),('37076','TN','Hermitage','Davidson',36.18044,-86.600098),('37077','TN','Hendersonville','Sumner',36.3047,-86.62),('37078','TN','Hurricane Mills','Humphreys',35.930412,-87.760054),('37079','TN','Indian Mound','Stewart',36.486701,-87.664022),('37080','TN','Joelton','Davidson',36.332792,-86.916891),('37082','TN','Kingston Springs','Cheatham',36.090196,-87.110611),('37083','TN','Lafayette','Macon',36.543692,-86.017506),('37085','TN','Lascassas','Rutherford',35.950506,-86.297288),('37086','TN','La Vergne','Rutherford',36.015944,-86.564953),('37087','TN','Lebanon','Wilson',36.242384,-86.300283),('37088','TN','Lebanon','Wilson',36.208,-86.2911),('37089','TN','La Vergne','Rutherford',36.0155,-86.5819),('37090','TN','Lebanon','Wilson',36.142952,-86.318955),('37091','TN','Lewisburg','Marshall',35.460973,-86.781102),('37095','TN','Liberty','Dekalb',35.994622,-85.962687),('37096','TN','Linden','Perry',35.612995,-87.87107),('37097','TN','Lobelville','Perry',35.762247,-87.801062),('37098','TN','Lyles','Hickman',35.882281,-87.31371),('37101','TN','Mc Ewen','Humphreys',36.060977,-87.627856),('37110','TN','Mc Minnville','Warren',35.684436,-85.780668),('37111','TN','Mc Minnville','Warren',35.6808,-85.7727),('37115','TN','Madison','Davidson',36.264991,-86.7054),('37116','TN','Madison','Davidson',36.2623,-86.7063),('37118','TN','Milton','Rutherford',35.929948,-86.190957),('37119','TN','Mitchellville','Sumner',36.6319,-86.5408),('37121','TN','Mount Juliet','Wilson',36.1608,-86.4833),('37122','TN','Mount Juliet','Wilson',36.19204,-86.495252),('37127','TN','Murfreesboro','Rutherford',35.789032,-86.345777),('37128','TN','Murfreesboro','Rutherford',35.817549,-86.450924),('37129','TN','Murfreesboro','Rutherford',35.897627,-86.429552),('37130','TN','Murfreesboro','Rutherford',35.862638,-86.362375),('37131','TN','Murfreesboro','Rutherford',35.8911,-86.3822),('37132','TN','Murfreesboro','Rutherford',35.848794,-86.3647),('37133','TN','Murfreesboro','Rutherford',35.8369,-86.393),('37134','TN','New Johnsonville','Humphreys',36.02151,-87.9577),('37135','TN','Nolensville','Williamson',35.952744,-86.664851),('37136','TN','Norene','Wilson',36.1176,-86.2939),('37137','TN','Nunnelly','Hickman',35.883907,-87.505495),('37138','TN','Old Hickory','Davidson',36.2407,-86.622564),('37140','TN','Only','Hickman',35.868328,-87.669121),('37141','TN','Orlinda','Robertson',36.612993,-86.686603),('37142','TN','Palmyra','Montgomery',36.416882,-87.4919),('37143','TN','Pegram','Cheatham',36.109999,-87.034794),('37144','TN','Petersburg','Lincoln',35.303346,-86.653864),('37145','TN','Pleasant Shade','Smith',36.380906,-85.916991),('37146','TN','Pleasant View','Cheatham',36.394672,-87.028836),('37148','TN','Portland','Sumner',36.577263,-86.513567),('37149','TN','Readyville','Cannon',35.809105,-86.199272),('37150','TN','Red Boiling Springs','Macon',36.550408,-85.827243),('37151','TN','Riddleton','Smith',36.309201,-86.04302),('37152','TN','Ridgetop','Robertson',36.396821,-86.766797),('37153','TN','Rockvale','Rutherford',35.760768,-86.540924),('37160','TN','Shelbyville','Bedford',35.482012,-86.462809),('37161','TN','Shelbyville','Bedford',35.4833,-86.4602),('37162','TN','Shelbyville','Bedford',35.4716,-86.4841),('37165','TN','Slayden','Dickson',36.2942,-87.471677),('37166','TN','Smithville','Dekalb',35.925548,-85.804939),('37167','TN','Smyrna','Rutherford',35.966153,-86.520934),('37171','TN','Southside','Montgomery',36.359697,-87.304007),('37172','TN','Springfield','Robertson',36.514395,-86.872353),('37174','TN','Spring Hill','Williamson',35.732124,-86.912844),('37175','TN','Stewart','Houston',36.324423,-87.889562),('37178','TN','Tennessee Ridge','Houston',36.317213,-87.782037),('37179','TN','Thompsons Station','Williamson',35.798706,-86.90769),('37180','TN','Unionville','Bedford',35.621483,-86.575353),('37181','TN','Vanleer','Dickson',36.243075,-87.486294),('37183','TN','Wartrace','Bedford',35.511879,-86.311005),('37184','TN','Watertown','Wilson',36.102226,-86.139212),('37185','TN','Waverly','Humphreys',36.085663,-87.824573),('37186','TN','Westmoreland','Sumner',36.57635,-86.238936),('37187','TN','White Bluff','Dickson',36.121419,-87.218355),('37188','TN','White House','Robertson',36.468854,-86.675282),('37189','TN','Whites Creek','Davidson',36.269424,-86.821327),('37190','TN','Woodbury','Cannon',35.817982,-86.048652),('37191','TN','Woodlawn','Montgomery',36.508568,-87.548791),('37201','TN','Nashville','Davidson',36.164848,-86.777319),('37202','TN','Nashville','Davidson',36.158,-86.7837),('37203','TN','Nashville','Davidson',36.150278,-86.790486),('37204','TN','Nashville','Davidson',36.114107,-86.775771),('37205','TN','Nashville','Davidson',36.116258,-86.859356),('37206','TN','Nashville','Davidson',36.179294,-86.743524),('37207','TN','Nashville','Davidson',36.212886,-86.773073),('37208','TN','Nashville','Davidson',36.175118,-86.804154),('37209','TN','Nashville','Davidson',36.152706,-86.851695),('37210','TN','Nashville','Davidson',36.141731,-86.747587),('37211','TN','Nashville','Davidson',36.078001,-86.728916),('37212','TN','Nashville','Davidson',36.133744,-86.800426),('37213','TN','Nashville','Davidson',36.167221,-86.768181),('37214','TN','Nashville','Davidson',36.167022,-86.667408),('37215','TN','Nashville','Davidson',36.097055,-86.826581),('37216','TN','Nashville','Davidson',36.215017,-86.726911),('37217','TN','Nashville','Davidson',36.103566,-86.666783),('37218','TN','Nashville','Davidson',36.205905,-86.856953),('37219','TN','Nashville','Davidson',36.167084,-86.781939),('37220','TN','Nashville','Davidson',36.069573,-86.772773),('37221','TN','Nashville','Davidson',36.065479,-86.956201),('37222','TN','Nashville','Davidson',36.0687,-86.7255),('37224','TN','Nashville','Davidson',36.1658,-86.7844),('37227','TN','Nashville','Davidson',36.1658,-86.7844),('37228','TN','Nashville','Davidson',36.190754,-86.800641),('37229','TN','Nashville','Davidson',36.1658,-86.7844),('37230','TN','Nashville','Davidson',36.1658,-86.7844),('37232','TN','Nashville','Davidson',36.1658,-86.7844),('37234','TN','Nashville','Davidson',36.1658,-86.7844),('37235','TN','Nashville','Davidson',36.1658,-86.7844),('37236','TN','Nashville','Davidson',36.1658,-86.7844),('37237','TN','Nashville','Davidson',36.1658,-86.7844),('37238','TN','Nashville','Davidson',36.1656,-86.7803),('37240','TN','Nashville','Davidson',36.144723,-86.80522),('37241','TN','Nashville','Davidson',36.1089,-86.672),('37242','TN','Nashville','Davidson',36.1658,-86.7844),('37243','TN','Nashville','Davidson',36.1687,-86.7845),('37244','TN','Nashville','Davidson',36.1658,-86.7844),('37245','TN','Nashville','Davidson',36.1658,-86.7844),('37246','TN','Nashville','Davidson',36.1585,-86.79),('37247','TN','Nashville','Davidson',36.1658,-86.7844),('37248','TN','Nashville','Davidson',36.1658,-86.7844),('37249','TN','Nashville','Davidson',36.1658,-86.7844),('37250','TN','Nashville','Davidson',36.1658,-86.7844),('37301','TN','Altamont','Grundy',35.42418,-85.766064),('37302','TN','Apison','Hamilton',35.018103,-85.015654),('37303','TN','Athens','Mcminn',35.445265,-84.619595),('37304','TN','Bakewell','Hamilton',35.3951,-85.1177),('37305','TN','Beersheba Springs','Grundy',35.468098,-85.687421),('37306','TN','Belvidere','Franklin',35.124358,-86.211837),('37307','TN','Benton','Polk',35.182451,-84.631786),('37308','TN','Birchwood','Hamilton',35.342635,-84.993756),('37309','TN','Calhoun','Mcminn',35.306071,-84.746494),('37310','TN','Charleston','Bradley',35.275335,-84.776713),('37311','TN','Cleveland','Bradley',35.146446,-84.887716),('37312','TN','Cleveland','Bradley',35.210763,-84.861704),('37313','TN','Coalmont','Grundy',35.359966,-85.705063),('37314','TN','Cokercreek','Monroe',35.3392,-84.2347),('37315','TN','Collegedale','Hamilton',35.04796,-85.05073),('37316','TN','Conasauga','Polk',34.995039,-84.729515),('37317','TN','Copperhill','Polk',35.017711,-84.401261),('37318','TN','Cowan','Franklin',35.168121,-86.006466),('37320','TN','Cleveland','Bradley',35.1594,-84.8766),('37321','TN','Dayton','Rhea',35.496039,-85.012496),('37322','TN','Decatur','Meigs',35.511952,-84.805316),('37323','TN','Cleveland','Bradley',35.114954,-84.828581),('37324','TN','Decherd','Franklin',35.246236,-86.026306),('37325','TN','Delano','Polk',35.251359,-84.591718),('37326','TN','Ducktown','Polk',35.034808,-84.382583),('37327','TN','Dunlap','Sequatchie',35.403444,-85.388498),('37328','TN','Elora','Lincoln',35.01862,-86.361169),('37329','TN','Englewood','Mcminn',35.418116,-84.478841),('37330','TN','Estill Springs','Franklin',35.280427,-86.121968),('37331','TN','Etowah','Mcminn',35.325818,-84.529924),('37332','TN','Evensville','Rhea',35.586104,-84.950978),('37333','TN','Farner','Polk',35.14988,-84.324035),('37334','TN','Fayetteville','Lincoln',35.144019,-86.576797),('37335','TN','Flintville','Lincoln',35.06272,-86.417565),('37336','TN','Georgetown','Bradley',35.300762,-84.942882),('37337','TN','Grandview','Rhea',35.775418,-84.870105),('37338','TN','Graysville','Rhea',35.441808,-85.186045),('37339','TN','Gruetli Laager','Grundy',35.375295,-85.624939),('37340','TN','Guild','Marion',35.026869,-85.535773),('37341','TN','Harrison','Hamilton',35.180225,-85.08661),('37342','TN','Hillsboro','Coffee',35.379796,-85.97066),('37343','TN','Hixson','Hamilton',35.165906,-85.218074),('37345','TN','Huntland','Franklin',35.053437,-86.268813),('37347','TN','Jasper','Marion',35.065549,-85.61861),('37348','TN','Kelso','Lincoln',35.114418,-86.44512),('37349','TN','Manchester','Coffee',35.5027,-86.0796),('37350','TN','Lookout Mountain','Hamilton',34.995212,-85.350024),('37351','TN','Lupton City','Hamilton',35.103906,-85.263937),('37352','TN','Lynchburg','Moore',35.27068,-86.366474),('37353','TN','Mc Donald','Bradley',35.114817,-84.985268),('37354','TN','Madisonville','Monroe',35.505914,-84.357447),('37355','TN','Manchester','Coffee',35.485908,-86.082479),('37356','TN','Monteagle','Grundy',35.237065,-85.825843),('37357','TN','Morrison','Warren',35.596705,-85.922926),('37359','TN','Mulberry','Lincoln',35.205927,-86.408849),('37360','TN','Normandy','Coffee',35.431523,-86.258955),('37361','TN','Ocoee','Polk',35.110142,-84.700374),('37362','TN','Old Fort','Polk',35.028331,-84.722586),('37363','TN','Ooltewah','Hamilton',35.08771,-85.08168),('37364','TN','Cleveland','Bradley',35.1056,-84.865),('37365','TN','Palmer','Grundy',35.372967,-85.555831),('37366','TN','Pelham','Grundy',35.302709,-85.856501),('37367','TN','Pikeville','Bledsoe',35.635605,-85.199067),('37369','TN','Reliance','Polk',35.197176,-84.483824),('37370','TN','Riceville','Mcminn',35.375918,-84.708838),('37371','TN','Athens','Mcminn',35.4427,-84.593),('37373','TN','Sale Creek','Hamilton',35.386997,-85.099496),('37374','TN','Sequatchie','Marion',35.162238,-85.644234),('37375','TN','Sewanee','Franklin',35.185743,-85.902145),('37376','TN','Sherwood','Franklin',35.060823,-85.922097),('37377','TN','Signal Mountain','Hamilton',35.156375,-85.338127),('37378','TN','Smartt','Warren',35.6402,-85.8366),('37379','TN','Soddy Daisy','Hamilton',35.26684,-85.165329),('37380','TN','South Pittsburg','Marion',35.032854,-85.712669),('37381','TN','Spring City','Rhea',35.682244,-84.855492),('37382','TN','Summitville','Coffee',35.5594,-85.9925),('37383','TN','Sewanee','Franklin',35.2072,-85.919),('37384','TN','Soddy Daisy','Hamilton',35.2842,-85.1803),('37385','TN','Tellico Plains','Monroe',35.335135,-84.291106),('37387','TN','Tracy City','Grundy',35.264685,-85.741636),('37388','TN','Tullahoma','Coffee',35.361008,-86.208397),('37389','TN','Arnold A F B','Coffee',35.3602,-86.2137),('37391','TN','Turtletown','Polk',35.093261,-84.353923),('37394','TN','Viola','Warren',35.539818,-85.860288),('37396','TN','Whiteside','Marion',34.9935,-85.49722),('37397','TN','Whitwell','Marion',35.210412,-85.502969),('37398','TN','Winchester','Franklin',35.1926,-86.127982),('37401','TN','Chattanooga','Hamilton',35.0455,-85.3081),('37402','TN','Chattanooga','Hamilton',35.04632,-85.313316),('37403','TN','Chattanooga','Hamilton',35.045589,-85.297771),('37404','TN','Chattanooga','Hamilton',35.029986,-85.273613),('37405','TN','Chattanooga','Hamilton',35.079381,-85.319743),('37406','TN','Chattanooga','Hamilton',35.066917,-85.250524),('37407','TN','Chattanooga','Hamilton',35.000742,-85.286426),('37408','TN','Chattanooga','Hamilton',35.029913,-85.307755),('37409','TN','Chattanooga','Hamilton',35.004118,-85.33288),('37410','TN','Chattanooga','Hamilton',35.004835,-85.314289),('37411','TN','Chattanooga','Hamilton',35.023532,-85.233222),('37412','TN','Chattanooga','Hamilton',34.997088,-85.236176),('37414','TN','Chattanooga','Hamilton',35.0123,-85.2267),('37415','TN','Chattanooga','Hamilton',35.117976,-85.283105),('37416','TN','Chattanooga','Hamilton',35.090497,-85.182939),('37419','TN','Chattanooga','Hamilton',35.031618,-85.372895),('37421','TN','Chattanooga','Hamilton',35.031137,-85.160793),('37422','TN','Chattanooga','Hamilton',35.0537,-85.1893),('37424','TN','Chattanooga','Hamilton',35.0455,-85.3097),('37450','TN','Chattanooga','Hamilton',35.0489,-85.3116),('37501','TN','Memphis','Shelby',35.0337,-89.9343),('37544','TN','Memphis','Shelby',35.1495,-90.049),('37601','TN','Johnson City','Washington',36.332494,-82.339921),('37602','TN','Johnson City','Washington',36.3133,-82.3536),('37604','TN','Johnson City','Washington',36.312822,-82.382851),('37605','TN','Johnson City','Washington',36.3133,-82.3536),('37614','TN','Johnson City','Washington',36.301439,-82.369629),('37615','TN','Johnson City','Washington',36.400637,-82.449039),('37616','TN','Afton','Greene',36.221319,-82.745893),('37617','TN','Blountville','Sullivan',36.52449,-82.365651),('37618','TN','Bluff City','Sullivan',36.471874,-82.23793),('37620','TN','Bristol','Sullivan',36.564342,-82.17094),('37621','TN','Bristol','Sullivan',36.5933,-82.183),('37625','TN','Bristol','Sullivan',36.595,-82.1888),('37640','TN','Butler','Johnson',36.334395,-81.976779),('37641','TN','Chuckey','Greene',36.222083,-82.674417),('37642','TN','Church Hill','Hawkins',36.537046,-82.714937),('37643','TN','Elizabethton','Carter',36.354012,-82.192432),('37644','TN','Elizabethton','Carter',36.3486,-82.2108),('37645','TN','Mount Carmel','Hawkins',36.555565,-82.661412),('37650','TN','Erwin','Unicoi',36.131153,-82.422604),('37656','TN','Fall Branch','Washington',36.401618,-82.627618),('37657','TN','Flag Pond','Unicoi',36.013252,-82.555376),('37658','TN','Hampton','Carter',36.273387,-82.161115),('37659','TN','Jonesborough','Washington',36.29335,-82.496275),('37660','TN','Kingsport','Sullivan',36.544763,-82.558417),('37662','TN','Kingsport','Sullivan',36.5483,-82.5619),('37663','TN','Kingsport','Sullivan',36.468758,-82.497249),('37664','TN','Kingsport','Sullivan',36.52181,-82.508704),('37665','TN','Kingsport','Sullivan',36.581488,-82.572258),('37669','TN','Kingsport','Sullivan',36.5483,-82.5619),('37680','TN','Laurel Bloomery','Johnson',36.569205,-81.750227),('37681','TN','Limestone','Washington',36.240253,-82.621879),('37682','TN','Milligan College','Carter',36.300574,-82.292453),('37683','TN','Mountain City','Johnson',36.447484,-81.82074),('37684','TN','Mountain Home','Washington',36.309201,-82.373381),('37686','TN','Piney Flats','Sullivan',36.430622,-82.333061),('37687','TN','Roan Mountain','Carter',36.192849,-82.085022),('37688','TN','Shady Valley','Johnson',36.528304,-81.918688),('37690','TN','Telford','Washington',36.246653,-82.547888),('37691','TN','Trade','Johnson',36.363253,-81.756143),('37692','TN','Unicoi','Unicoi',36.203942,-82.321362),('37694','TN','Watauga','Carter',36.379067,-82.28885),('37699','TN','Piney Flats','Sullivan',36.4194,-82.3041),('37701','TN','Alcoa','Blount',35.789182,-83.979505),('37705','TN','Andersonville','Anderson',36.212395,-84.021837),('37707','TN','Arthur','Claiborne',36.548,-83.6708),('37708','TN','Bean Station','Grainger',36.322857,-83.317094),('37709','TN','Blaine','Grainger',36.158793,-83.677143),('37710','TN','Briceville','Anderson',36.160509,-84.295141),('37711','TN','Bulls Gap','Hawkins',36.268188,-83.057071),('37713','TN','Bybee','Cocke',36.094248,-83.126852),('37714','TN','Caryville','Campbell',36.287307,-84.213393),('37715','TN','Clairfield','Claiborne',36.551145,-83.950821),('37716','TN','Clinton','Anderson',36.101576,-84.147016),('37717','TN','Clinton','Anderson',36.1033,-84.1319),('37719','TN','Coalfield','Morgan',36.028299,-84.423972),('37721','TN','Corryton','Knox',36.142084,-83.806855),('37722','TN','Cosby','Cocke',35.819647,-83.230693),('37723','TN','Crab Orchard','Cumberland',35.933319,-84.861319),('37724','TN','Cumberland Gap','Claiborne',36.567975,-83.676573),('37725','TN','Dandridge','Jefferson',36.006785,-83.405151),('37726','TN','Deer Lodge','Morgan',36.204228,-84.830525),('37727','TN','Del Rio','Cocke',35.897708,-83.010609),('37729','TN','Duff','Campbell',36.497811,-84.043707),('37730','TN','Eagan','Claiborne',36.547528,-83.976589),('37731','TN','Eidson','Hawkins',36.545355,-83.022331),('37732','TN','Elgin','Scott',36.330263,-84.606988),('37733','TN','Rugby','Morgan',36.360812,-84.710539),('37737','TN','Friendsville','Blount',35.761367,-84.120426),('37738','TN','Gatlinburg','Sevier',35.725559,-83.47544),('37742','TN','Greenback','Loudon',35.668539,-84.181905),('37743','TN','Greeneville','Greene',36.107992,-82.865427),('37744','TN','Greeneville','Greene',36.182289,-82.73948),('37745','TN','Greeneville','Greene',36.228384,-82.809225),('37748','TN','Harriman','Roane',35.93124,-84.532264),('37752','TN','Harrogate','Claiborne',36.579082,-83.596441),('37753','TN','Hartford','Cocke',35.822282,-83.11287),('37754','TN','Heiskell','Anderson',36.139099,-84.029801),('37755','TN','Helenwood','Scott',36.418476,-84.533904),('37756','TN','Huntsville','Scott',36.334752,-84.434414),('37757','TN','Jacksboro','Campbell',36.321916,-84.167168),('37760','TN','Jefferson City','Jefferson',36.109442,-83.479923),('37762','TN','Jellico','Campbell',36.578018,-84.131645),('37763','TN','Kingston','Roane',35.84827,-84.489896),('37764','TN','Kodak','Sevier',35.973215,-83.608318),('37765','TN','Kyles Ford','Hancock',36.572337,-83.058609),('37766','TN','La Follette','Campbell',36.379159,-84.085804),('37769','TN','Lake City','Anderson',36.218837,-84.147689),('37770','TN','Lancing','Morgan',36.132384,-84.690961),('37771','TN','Lenoir City','Loudon',35.823275,-84.293664),('37772','TN','Lenoir City','Loudon',35.802652,-84.233905),('37773','TN','Lone Mountain','Claiborne',36.3905,-83.585),('37774','TN','Loudon','Loudon',35.72606,-84.330889),('37777','TN','Louisville','Blount',35.835702,-84.009872),('37778','TN','Lowland','Hamblen',36.1576,-83.2512),('37779','TN','Luttrell','Union',36.208104,-83.758827),('37801','TN','Maryville','Blount',35.717692,-84.043575),('37802','TN','Maryville','Blount',35.6877,-84.0203),('37803','TN','Maryville','Blount',35.69401,-83.984034),('37804','TN','Maryville','Blount',35.781138,-83.934782),('37806','TN','Mascot','Knox',36.086101,-83.740591),('37807','TN','Maynardville','Union',36.250826,-83.824909),('37809','TN','Midway','Greene',36.162366,-83.021323),('37810','TN','Mohawk','Greene',36.191961,-83.093381),('37811','TN','Mooresburg','Hawkins',36.346153,-83.228789),('37813','TN','Morristown','Hamblen',36.184708,-83.272796),('37814','TN','Morristown','Hamblen',36.21943,-83.314735),('37815','TN','Morristown','Hamblen',36.2138,-83.295),('37816','TN','Morristown','Hamblen',36.2138,-83.295),('37818','TN','Mosheim','Greene',36.200512,-82.966404),('37819','TN','Newcomb','Campbell',36.544408,-84.189206),('37820','TN','New Market','Jefferson',36.08996,-83.565558),('37821','TN','Newport','Cocke',35.965802,-83.199899),('37822','TN','Newport','Cocke',35.9482,-83.2054),('37824','TN','New Tazewell','Claiborne',36.4138,-83.6795),('37825','TN','New Tazewell','Claiborne',36.422947,-83.656136),('37826','TN','Niota','Mcminn',35.548051,-84.584552),('37828','TN','Norris','Anderson',36.194017,-84.070359),('37829','TN','Oakdale','Morgan',35.992656,-84.598492),('37830','TN','Oak Ridge','Anderson',35.97901,-84.284115),('37831','TN','Oak Ridge','Anderson',36.0102,-84.2697),('37840','TN','Oliver Springs','Roane',36.042376,-84.358604),('37841','TN','Oneida','Scott',36.499673,-84.530026),('37843','TN','Parrottsville','Cocke',36.016713,-83.056496),('37845','TN','Petros','Morgan',36.0957,-84.44092),('37846','TN','Philadelphia','Loudon',35.673519,-84.457701),('37847','TN','Pioneer','Scott',36.434741,-84.277722),('37848','TN','Powder Springs','Grainger',36.241279,-83.686249),('37849','TN','Powell','Knox',36.054314,-84.046043),('37851','TN','Pruden','Claiborne',36.584938,-83.902671),('37852','TN','Robbins','Scott',36.324155,-84.579526),('37853','TN','Rockford','Blount',35.834437,-83.93467),('37854','TN','Rockwood','Roane',35.873392,-84.692487),('37857','TN','Rogersville','Hawkins',36.413949,-82.96731),('37860','TN','Russellville','Hamblen',36.240107,-83.192529),('37861','TN','Rutledge','Grainger',36.253105,-83.50764),('37862','TN','Sevierville','Sevier',35.82049,-83.581755),('37863','TN','Pigeon Forge','Sevier',35.793454,-83.563553),('37864','TN','Sevierville','Sevier',35.868,-83.5619),('37865','TN','Seymour','Sevier',35.860082,-83.750319),('37866','TN','Sharps Chapel','Union',36.347283,-83.843304),('37867','TN','Shawanee','Claiborne',36.5805,-83.6388),('37868','TN','Pigeon Forge','Sevier',35.7883,-83.5544),('37869','TN','Sneedville','Hancock',36.521452,-83.227448),('37870','TN','Speedwell','Claiborne',36.456027,-83.852046),('37871','TN','Strawberry Plains','Jefferson',36.04111,-83.679527),('37872','TN','Sunbright','Morgan',36.26047,-84.650333),('37873','TN','Surgoinsville','Hawkins',36.50385,-82.836355),('37874','TN','Sweetwater','Monroe',35.600346,-84.467272),('37876','TN','Sevierville','Sevier',35.867155,-83.502993),('37877','TN','Talbott','Hamblen',36.153521,-83.411701),('37878','TN','Tallassee','Blount',35.609033,-83.951763),('37879','TN','Tazewell','Claiborne',36.473912,-83.535863),('37880','TN','Ten Mile','Meigs',35.685695,-84.677934),('37881','TN','Thorn Hill','Grainger',36.40648,-83.342523),('37882','TN','Townsend','Blount',35.664375,-83.771774),('37885','TN','Vonore','Monroe',35.547631,-84.187197),('37886','TN','Walland','Blount',35.742346,-83.812725),('37887','TN','Wartburg','Morgan',36.093777,-84.574068),('37888','TN','Washburn','Grainger',36.307278,-83.610098),('37890','TN','White Pine','Jefferson',36.096564,-83.28901),('37891','TN','Whitesburg','Hamblen',36.278082,-83.140742),('37892','TN','Winfield','Scott',36.562619,-84.407365),('37901','TN','Knoxville','Knox',35.9609,-83.9189),('37902','TN','Knoxville','Knox',35.963643,-83.92061),('37909','TN','Knoxville','Knox',35.947589,-84.021077),('37912','TN','Knoxville','Knox',36.00709,-83.983374),('37914','TN','Knoxville','Knox',35.984036,-83.833591),('37915','TN','Knoxville','Knox',35.969381,-83.903927),('37916','TN','Knoxville','Knox',35.954655,-83.933775),('37917','TN','Knoxville','Knox',35.993408,-83.919112),('37918','TN','Knoxville','Knox',36.049789,-83.921576),('37919','TN','Knoxville','Knox',35.922896,-84.004015),('37920','TN','Knoxville','Knox',35.921606,-83.891001),('37921','TN','Knoxville','Knox',35.975621,-83.977837),('37922','TN','Knoxville','Knox',35.877512,-84.09538),('37923','TN','Knoxville','Knox',35.928248,-84.078607),('37924','TN','Knoxville','Knox',36.028708,-83.806932),('37927','TN','Knoxville','Knox',35.9956,-83.9225),('37928','TN','Knoxville','Knox',36.0357,-83.9309),('37929','TN','Knoxville','Knox',35.9622,-83.9164),('37930','TN','Knoxville','Knox',35.917,-84.0741),('37931','TN','Knoxville','Knox',35.970602,-84.115846),('37932','TN','Knoxville','Knox',35.919692,-84.172529),('37933','TN','Knoxville','Knox',35.8655,-84.1267),('37934','TN','Knoxville','Knox',35.871784,-84.171546),('37938','TN','Knoxville','Knox',36.113567,-83.937744),('37939','TN','Knoxville','Knox',35.9365,-83.9936),('37940','TN','Knoxville','Knox',35.9081,-83.8654),('37950','TN','Knoxville','Knox',35.945,-84.015),('37990','TN','Knoxville','Knox',35.8655,-84.1267),('37995','TN','Knoxville','Knox',35.945,-84.015),('37996','TN','Knoxville','Knox',35.9529,-83.9293),('37997','TN','Knoxville','Knox',35.945,-84.015),('37998','TN','Knoxville','Knox',35.945,-84.015),('38001','TN','Alamo','Crockett',35.796011,-89.139153),('38002','TN','Arlington','Shelby',35.267737,-89.708349),('38004','TN','Atoka','Tipton',35.423625,-89.780445),('38006','TN','Bells','Crockett',35.698993,-89.072913),('38007','TN','Bogota','Dyer',36.168414,-89.432501),('38008','TN','Bolivar','Hardeman',35.254971,-88.98725),('38010','TN','Braden','Fayette',35.3794,-89.568),('38011','TN','Brighton','Tipton',35.480609,-89.71926),('38012','TN','Brownsville','Haywood',35.594714,-89.258118),('38014','TN','Brunswick','Shelby',35.2672,-89.7686),('38015','TN','Burlison','Tipton',35.551512,-89.823724),('38016','TN','Cordova','Shelby',35.177969,-89.774872),('38017','TN','Collierville','Shelby',35.055185,-89.680582),('38018','TN','Cordova','Shelby',35.142516,-89.784028),('38019','TN','Covington','Tipton',35.561244,-89.64117),('38021','TN','Crockett Mills','Crockett',35.867886,-89.168391),('38023','TN','Drummonds','Tipton',35.461319,-89.912132),('38024','TN','Dyersburg','Dyer',36.038703,-89.381751),('38025','TN','Dyersburg','Dyer',36.0344,-89.3855),('38027','TN','Collierville','Shelby',35.0408,-89.6659),('38028','TN','Eads','Fayette',35.198661,-89.6162),('38029','TN','Ellendale','Shelby',35.2305,-89.8258),('38030','TN','Finley','Dyer',36.023301,-89.570062),('38034','TN','Friendship','Crockett',35.904282,-89.244467),('38036','TN','Gallaway','Fayette',35.32278,-89.620922),('38037','TN','Gates','Lauderdale',35.824185,-89.407439),('38039','TN','Grand Junction','Hardeman',35.0572,-89.186231),('38040','TN','Halls','Lauderdale',35.88412,-89.411831),('38041','TN','Henning','Lauderdale',35.653136,-89.668972),('38042','TN','Hickory Valley','Hardeman',35.1455,-89.158622),('38044','TN','Hornsby','Hardeman',35.211593,-88.809627),('38045','TN','Laconia','Fayette',35.2822,-89.2519),('38046','TN','La Grange','Fayette',35.052044,-89.241571),('38047','TN','Lenox','Dyer',36.088895,-89.49847),('38048','TN','Macon','Fayette',35.153,-89.4897),('38049','TN','Mason','Tipton',35.376511,-89.553256),('38050','TN','Maury City','Crockett',35.817749,-89.226132),('38052','TN','Middleton','Hardeman',35.077739,-88.904976),('38053','TN','Millington','Shelby',35.339317,-89.89656),('38054','TN','Millington','Shelby',35.336094,-89.873907),('38055','TN','Millington','Shelby',35.3423,-89.8972),('38057','TN','Moscow','Fayette',35.044359,-89.369622),('38058','TN','Munford','Tipton',35.448532,-89.818577),('38059','TN','Newbern','Dyer',36.116735,-89.252739),('38060','TN','Oakland','Fayette',35.220948,-89.515776),('38061','TN','Pocahontas','Hardeman',35.06839,-88.770907),('38063','TN','Ripley','Lauderdale',35.748545,-89.552845),('38066','TN','Rossville','Fayette',35.058771,-89.540297),('38067','TN','Saulsbury','Hardeman',35.091059,-89.030738),('38068','TN','Somerville','Fayette',35.265542,-89.345167),('38069','TN','Stanton','Haywood',35.459002,-89.3561),('38070','TN','Tigrett','Dyer',35.946314,-89.241155),('38071','TN','Tipton','Tipton',35.4679,-89.9707),('38075','TN','Whiteville','Hardeman',35.347298,-89.158305),('38076','TN','Williston','Fayette',35.148207,-89.43462),('38077','TN','Wynnburg','Lake',36.32785,-89.475128),('38079','TN','Tiptonville','Lake',36.417118,-89.471374),('38080','TN','Ridgely','Lake',36.224069,-89.497761),('38083','TN','Millington','Shelby',35.341,-89.9018),('38088','TN','Cordova','Shelby',35.1555,-89.7761),('38101','TN','Memphis','Shelby',35.1494,-90.0488),('38103','TN','Memphis','Shelby',35.149678,-90.052975),('38104','TN','Memphis','Shelby',35.13355,-90.005329),('38105','TN','Memphis','Shelby',35.152659,-90.03596),('38106','TN','Memphis','Shelby',35.103136,-90.040261),('38107','TN','Memphis','Shelby',35.164973,-90.019326),('38108','TN','Memphis','Shelby',35.173207,-89.963884),('38109','TN','Memphis','Shelby',35.051894,-90.078707),('38110','TN','Memphis','Shelby',35.0519,-89.941),('38111','TN','Memphis','Shelby',35.109435,-89.943733),('38112','TN','Memphis','Shelby',35.147662,-89.976392),('38113','TN','Memphis','Shelby',35.1002,-90.1034),('38114','TN','Memphis','Shelby',35.100613,-89.985697),('38115','TN','Memphis','Shelby',35.055721,-89.859788),('38116','TN','Memphis','Shelby',35.033181,-90.011396),('38117','TN','Memphis','Shelby',35.113065,-89.904408),('38118','TN','Memphis','Shelby',35.050652,-89.926601),('38119','TN','Memphis','Shelby',35.081744,-89.848178),('38120','TN','Memphis','Shelby',35.123762,-89.861916),('38122','TN','Memphis','Shelby',35.155932,-89.925665),('38124','TN','Memphis','Shelby',35.1144,-89.9059),('38125','TN','Memphis','Shelby',35.033802,-89.798745),('38126','TN','Memphis','Shelby',35.12702,-90.044064),('38127','TN','Memphis','Shelby',35.223049,-90.005303),('38128','TN','Memphis','Shelby',35.219596,-89.925988),('38130','TN','Memphis','Shelby',35.0248,-89.9803),('38131','TN','Memphis','Shelby',35.063236,-89.994034),('38132','TN','Memphis','Shelby',35.073545,-89.997888),('38133','TN','Memphis','Shelby',35.208865,-89.805384),('38134','TN','Memphis','Shelby',35.186326,-89.865569),('38135','TN','Memphis','Shelby',35.232106,-89.852201),('38136','TN','Memphis','Shelby',35.1325,-90.0565),('38137','TN','Memphis','Shelby',35.0997,-89.8694),('38138','TN','Germantown','Shelby',35.090522,-89.803064),('38139','TN','Germantown','Shelby',35.085554,-89.759613),('38141','TN','Memphis','Shelby',35.016758,-89.846842),('38142','TN','Memphis','Shelby',35.1494,-90.0488),('38145','TN','Memphis','Shelby',35.1494,-90.0488),('38147','TN','Memphis','Shelby',35.1494,-90.0488),('38148','TN','Memphis','Shelby',35.1494,-90.0488),('38150','TN','Memphis','Shelby',35.1494,-90.0488),('38151','TN','Memphis','Shelby',35.1494,-90.0488),('38152','TN','Memphis','Shelby',35.123369,-89.934178),('38157','TN','Memphis','Shelby',35.114416,-89.891896),('38159','TN','Memphis','Shelby',35.1494,-90.0488),('38161','TN','Memphis','Shelby',35.0785,-89.8447),('38163','TN','Memphis','Shelby',35.1506,-90.0155),('38165','TN','Memphis','Shelby',35.1494,-90.0488),('38166','TN','Memphis','Shelby',35.0997,-89.8694),('38167','TN','Memphis','Shelby',35.2103,-90.023),('38168','TN','Memphis','Shelby',35.2266,-89.904),('38173','TN','Memphis','Shelby',35.1494,-90.0488),('38174','TN','Memphis','Shelby',35.1494,-90.0488),('38175','TN','Memphis','Shelby',35.0465,-89.8663),('38177','TN','Memphis','Shelby',35.1494,-90.0488),('38181','TN','Memphis','Shelby',35.0519,-89.941),('38182','TN','Memphis','Shelby',35.1494,-90.0488),('38183','TN','Germantown','Shelby',35.0962,-89.804),('38184','TN','Memphis','Shelby',35.1494,-90.0488),('38186','TN','Memphis','Shelby',35.0335,-90.0167),('38187','TN','Memphis','Shelby',35.0785,-89.8447),('38188','TN','Memphis','Shelby',35.0997,-89.8694),('38190','TN','Memphis','Shelby',35.0549,-90.0599),('38193','TN','Memphis','Shelby',35.0465,-89.8663),('38194','TN','Memphis','Shelby',35.0655,-89.9984),('38197','TN','Memphis','Shelby',35.0997,-89.8694),('38201','TN','Mc Kenzie','Carroll',36.129485,-88.518991),('38220','TN','Atwood','Carroll',35.982012,-88.669337),('38221','TN','Big Sandy','Benton',36.240802,-88.057516),('38222','TN','Buchanan','Henry',36.453109,-88.142383),('38223','TN','Como','Henry',36.293,-88.5122),('38224','TN','Cottage Grove','Henry',36.395718,-88.49535),('38225','TN','Dresden','Weakley',36.299867,-88.687878),('38226','TN','Dukedom','Weakley',36.476246,-88.684018),('38227','TN','Elbridge','Obion',20.66522,-100.866539),('38229','TN','Gleason','Weakley',36.222095,-88.609238),('38230','TN','Greenfield','Weakley',36.158373,-88.784974),('38231','TN','Henry','Henry',36.208783,-88.419613),('38232','TN','Hornbeak','Obion',36.359019,-89.32418),('38233','TN','Kenton','Gibson',36.203065,-89.035349),('38235','TN','Mc Lemoresville','Carroll',35.988838,-88.575164),('38236','TN','Mansfield','Henry',36.168113,-88.26805),('38237','TN','Martin','Weakley',36.347011,-88.842837),('38238','TN','Martin','Weakley',36.3437,-88.863),('38240','TN','Obion','Obion',36.253305,-89.254876),('38241','TN','Palmersville','Weakley',36.415182,-88.576171),('38242','TN','Paris','Henry',36.298784,-88.322747),('38251','TN','Puryear','Henry',36.44447,-88.35854),('38253','TN','Rives','Obion',36.308105,-89.059109),('38254','TN','Samburg','Obion',36.377811,-89.353397),('38255','TN','Sharon','Weakley',36.234845,-88.844635),('38256','TN','Springville','Henry',36.32096,-88.123361),('38257','TN','South Fulton','Obion',36.479386,-88.875271),('38258','TN','Trezevant','Carroll',36.0146,-88.620977),('38259','TN','Trimble','Dyer',36.199152,-89.183658),('38260','TN','Troy','Obion',36.345337,-89.191814),('38261','TN','Union City','Obion',36.42475,-89.068291),('38271','TN','Woodland Mills','Obion',36.4883,-89.115),('38281','TN','Union City','Obion',36.4241,-89.0569),('38301','TN','Jackson','Madison',35.610024,-88.824656),('38302','TN','Jackson','Madison',35.6144,-88.8138),('38303','TN','Jackson','Madison',35.6144,-88.8138),('38305','TN','Jackson','Madison',35.687784,-88.818272),('38308','TN','Jackson','Madison',35.6144,-88.8138),('38310','TN','Adamsville','Mcnairy',35.244773,-88.386946),('38311','TN','Bath Springs','Decatur',35.435277,-88.109491),('38313','TN','Beech Bluff','Madison',35.610339,-88.619827),('38314','TN','Jackson','Madison',35.5727,-88.8213),('38315','TN','Bethel Springs','Mcnairy',35.262488,-88.631818),('38316','TN','Bradford','Gibson',36.069335,-88.811682),('38317','TN','Bruceton','Carroll',36.05237,-88.251944),('38318','TN','Buena Vista','Carroll',35.94926,-88.270743),('38320','TN','Camden','Benton',36.044949,-88.102808),('38321','TN','Cedar Grove','Carroll',35.82709,-88.523714),('38324','TN','Clarksburg','Carroll',35.8716,-88.393),('38326','TN','Counce','Hardin',35.055543,-88.282017),('38327','TN','Crump','Hardin',35.222292,-88.300447),('38328','TN','Darden','Henderson',35.666348,-88.213774),('38329','TN','Decaturville','Decatur',35.554654,-88.105841),('38330','TN','Dyer','Gibson',36.072417,-89.016341),('38331','TN','Eaton','Gibson',35.9688,-89.1319),('38332','TN','Enville','Chester',35.3968,-88.41944),('38333','TN','Eva','Benton',36.113256,-87.977521),('38334','TN','Finger','Mcnairy',35.355828,-88.610945),('38336','TN','Fruitvale','Crockett',35.7466,-89.0305),('38337','TN','Gadsden','Crockett',35.780701,-89.00008),('38338','TN','Gibson','Gibson',35.8752,-88.8466),('38339','TN','Guys','Mcnairy',35.047907,-88.518624),('38340','TN','Henderson','Chester',35.412281,-88.672915),('38341','TN','Holladay','Benton',35.881936,-88.103938),('38342','TN','Hollow Rock','Carroll',36.082181,-88.280914),('38343','TN','Humboldt','Gibson',35.825518,-88.905237),('38344','TN','Huntingdon','Carroll',35.988497,-88.41754),('38345','TN','Huron','Henderson',35.59818,-88.505481),('38346','TN','Idlewild','Gibson',36.0297,-88.808),('38347','TN','Jacks Creek','Chester',35.475185,-88.499592),('38348','TN','Lavinia','Carroll',35.873769,-88.665276),('38351','TN','Lexington','Henderson',35.661876,-88.405036),('38352','TN','Luray','Chester',35.529455,-88.533846),('38355','TN','Medina','Gibson',35.798622,-88.776181),('38356','TN','Medon','Madison',35.427877,-88.886518),('38357','TN','Michie','Mcnairy',35.054597,-88.420285),('38358','TN','Milan','Gibson',35.900324,-88.752095),('38359','TN','Milledgeville','Mcnairy',35.376905,-88.359651),('38361','TN','Morris Chapel','Hardin',35.314458,-88.283647),('38362','TN','Oakfield','Madison',35.716663,-88.77458),('38363','TN','Parsons','Decatur',35.661391,-88.117367),('38365','TN','Pickwick Dam','Hardin',35.053,-88.2379),('38366','TN','Pinson','Madison',35.486844,-88.728035),('38367','TN','Ramer','Mcnairy',35.060229,-88.610628),('38368','TN','Reagan','Henderson',35.504974,-88.344542),('38369','TN','Rutherford','Gibson',36.129391,-88.981487),('38370','TN','Saltillo','Hardin',35.382411,-88.225348),('38371','TN','Sardis','Henderson',35.432638,-88.305221),('38372','TN','Savannah','Hardin',35.178242,-88.196101),('38374','TN','Scotts Hill','Henderson',35.519612,-88.240137),('38375','TN','Selmer','Mcnairy',35.164376,-88.587087),('38376','TN','Shiloh','Hardin',35.099209,-88.368705),('38377','TN','Silerton','Hardeman',35.3402,-88.8061),('38378','TN','Spring Creek','Madison',35.764637,-88.685008),('38379','TN','Stantonville','Mcnairy',35.160385,-88.42446),('38380','TN','Sugar Tree','Decatur',35.779544,-88.026005),('38381','TN','Toone','Hardeman',35.35042,-88.946467),('38382','TN','Trenton','Gibson',35.973332,-88.960474),('38387','TN','Westport','Carroll',35.884752,-88.286324),('38388','TN','Wildersville','Henderson',35.782007,-88.333155),('38389','TN','Yorkville','Gibson',36.0994,-89.1188),('38390','TN','Yuma','Carroll',35.848568,-88.383135),('38391','TN','Denmark','Madison',35.554912,-89.015632),('38392','TN','Mercer','Madison',35.455048,-89.045302),('38393','TN','Chewalla','Mcnairy',35.0133,-88.6463),('38401','TN','Columbia','Maury',35.624188,-87.03757),('38402','TN','Columbia','Maury',35.615,-87.0352),('38425','TN','Clifton','Wayne',35.401087,-87.972004),('38449','TN','Ardmore','Giles',35.035316,-86.843893),('38450','TN','Collinwood','Wayne',35.178509,-87.759815),('38451','TN','Culleoka','Maury',35.47233,-86.99164),('38452','TN','Cypress Inn','Wayne',35.074246,-87.795187),('38453','TN','Dellrose','Lincoln',35.12132,-86.822741),('38454','TN','Duck River','Hickman',35.728205,-87.345301),('38455','TN','Elkton','Giles',35.051595,-86.89088),('38456','TN','Ethridge','Lawrence',35.329784,-87.277918),('38457','TN','Five Points','Lawrence',35.028378,-87.294943),('38459','TN','Frankewing','Lincoln',35.188656,-86.808472),('38460','TN','Goodspring','Giles',35.083508,-87.160536),('38461','TN','Hampshire','Maury',35.602903,-87.331482),('38462','TN','Hohenwald','Lewis',35.537091,-87.548702),('38463','TN','Iron City','Wayne',35.055509,-87.633991),('38464','TN','Lawrenceburg','Lawrence',35.259872,-87.374331),('38468','TN','Leoma','Lawrence',35.140405,-87.295488),('38469','TN','Loretto','Lawrence',35.070385,-87.419496),('38471','TN','Lutts','Wayne',35.084144,-87.913426),('38472','TN','Lynnville','Giles',35.376223,-87.034642),('38473','TN','Minor Hill','Giles',35.031469,-87.166714),('38474','TN','Mount Pleasant','Maury',35.520535,-87.219436),('38475','TN','Olivehill','Hardin',35.261004,-88.018262),('38476','TN','Primm Springs','Williamson',35.83484,-87.220792),('38477','TN','Prospect','Giles',35.050598,-86.993252),('38478','TN','Pulaski','Giles',35.20371,-87.010196),('38481','TN','Saint Joseph','Lawrence',35.03896,-87.500811),('38482','TN','Santa Fe','Maury',35.768837,-87.149926),('38483','TN','Summertown','Lawrence',35.434214,-87.336954),('38485','TN','Waynesboro','Wayne',35.342557,-87.762003),('38486','TN','Westpoint','Lawrence',35.165092,-87.540994),('38487','TN','Williamsport','Maury',35.727893,-87.227394),('38488','TN','Taft','Lincoln',35.045213,-86.690979),('38501','TN','Cookeville','Putnam',36.181642,-85.52094),('38502','TN','Cookeville','Putnam',36.2139,-85.5332),('38503','TN','Cookeville','Putnam',36.1627,-85.5016),('38504','TN','Allardt','Fentress',36.390947,-84.73289),('38505','TN','Cookeville','Putnam',36.174461,-85.50537),('38506','TN','Cookeville','Putnam',36.169378,-85.461053),('38541','TN','Allons','Overton',36.521902,-85.34255),('38542','TN','Allred','Overton',36.324628,-85.205922),('38543','TN','Alpine','Overton',36.398972,-85.167603),('38544','TN','Baxter','Putnam',36.135789,-85.645475),('38545','TN','Bloomington Springs','Jackson',36.218514,-85.642764),('38547','TN','Brush Creek','Smith',36.141982,-86.002654),('38548','TN','Buffalo Valley','Putnam',36.157218,-85.794334),('38549','TN','Byrdstown','Pickett',36.572279,-85.149794),('38550','TN','Campaign','Warren',35.7708,-85.6286),('38551','TN','Celina','Clay',36.547514,-85.488997),('38552','TN','Chestnut Mound','Smith',36.217719,-85.81368),('38553','TN','Clarkrange','Fentress',36.200885,-85.01038),('38554','TN','Crawford','Overton',36.257217,-85.157949),('38555','TN','Crossville','Cumberland',35.940883,-85.014859),('38556','TN','Jamestown','Fentress',36.417822,-84.92481),('38557','TN','Crossville','Cumberland',35.9488,-85.0269),('38558','TN','Crossville','Cumberland',35.996788,-84.882687),('38559','TN','Doyle','White',35.83641,-85.517101),('38560','TN','Elmwood','Smith',36.236144,-85.883603),('38562','TN','Gainesboro','Jackson',36.355623,-85.662547),('38563','TN','Gordonsville','Smith',36.1836,-85.984129),('38564','TN','Granville','Jackson',36.275185,-85.761659),('38565','TN','Grimsley','Fentress',36.263787,-84.99505),('38567','TN','Hickman','Smith',36.148197,-85.90932),('38568','TN','Hilham','Overton',36.418522,-85.459526),('38569','TN','Lancaster','Smith',36.105638,-85.854403),('38570','TN','Livingston','Overton',36.376276,-85.326452),('38571','TN','Crossville','Cumberland',36.029737,-85.03944),('38572','TN','Crossville','Cumberland',35.861849,-85.105101),('38573','TN','Monroe','Overton',36.483984,-85.202592),('38574','TN','Monterey','Putnam',36.130725,-85.24013),('38575','TN','Moss','Clay',36.563101,-85.658261),('38577','TN','Pall Mall','Pickett',36.565976,-84.972395),('38578','TN','Pleasant Hill','Cumberland',35.981767,-85.198328),('38579','TN','Quebeck','White',35.813712,-85.550937),('38580','TN','Rickman','Overton',36.281157,-85.333709),('38581','TN','Rock Island','Warren',35.764199,-85.632661),('38582','TN','Silver Point','Putnam',36.093087,-85.75815),('38583','TN','Sparta','White',35.936584,-85.445883),('38585','TN','Spencer','Van Buren',35.696991,-85.436296),('38587','TN','Walling','White',35.840197,-85.612659),('38588','TN','Whitleyville','Jackson',36.446354,-85.730662),('38589','TN','Wilder','Overton',36.280567,-85.088666),('38601','MS','Abbeville','Lafayette',34.479075,-89.460997),('38602','MS','Arkabutla','Tate',34.6988,-90.1222),('38603','MS','Ashland','Benton',34.831323,-89.15798),('38606','MS','Batesville','Panola',34.312097,-89.93919),('38609','MS','Belen','Quitman',34.275423,-90.373925),('38610','MS','Blue Mountain','Tippah',34.657608,-89.024948),('38611','MS','Byhalia','Marshall',34.88375,-89.663039),('38614','MS','Clarksdale','Coahoma',34.175128,-90.584675),('38617','MS','Coahoma','Coahoma',34.356029,-90.51331),('38618','MS','Coldwater','Tate',34.699741,-89.943391),('38619','MS','Como','Panola',34.517014,-89.869583),('38620','MS','Courtland','Panola',34.236736,-89.916136),('38621','MS','Crenshaw','Panola',34.473038,-90.168678),('38622','MS','Crowder','Quitman',34.173132,-90.137776),('38623','MS','Darling','Quitman',34.367331,-90.275926),('38625','MS','Dumas','Tippah',34.606003,-88.840474),('38626','MS','Dundee','Tunica',34.517738,-90.428479),('38627','MS','Etta','Union',34.41783,-89.207943),('38628','MS','Falcon','Quitman',34.393,-90.2563),('38629','MS','Falkner','Tippah',34.868301,-88.99004),('38630','MS','Farrell','Coahoma',34.281009,-90.678771),('38631','MS','Friars Point','Coahoma',34.366975,-90.631902),('38632','MS','Hernando','Desoto',34.817171,-90.003656),('38633','MS','Hickory Flat','Benton',34.631209,-89.192158),('38634','MS','Holly Springs','Marshall',34.7687,-89.4483),('38635','MS','Holly Springs','Marshall',34.784563,-89.459222),('38637','MS','Horn Lake','Desoto',34.956157,-90.050246),('38638','MS','Independence','Tate',34.705,-89.8088),('38639','MS','Jonestown','Coahoma',34.311932,-90.448891),('38641','MS','Lake Cormorant','Desoto',34.896412,-90.184581),('38642','MS','Lamar','Benton',34.922998,-89.345315),('38643','MS','Lambert','Quitman',34.172554,-90.267475),('38644','MS','Lula','Coahoma',34.456169,-90.490896),('38645','MS','Lyon','Coahoma',34.240199,-90.493381),('38646','MS','Marks','Quitman',34.267768,-90.292008),('38647','MS','Michigan City','Benton',34.963796,-89.225967),('38649','MS','Mount Pleasant','Marshall',34.962714,-89.540231),('38650','MS','Myrtle','Union',34.531242,-89.135061),('38651','MS','Nesbit','Desoto',34.889508,-89.972769),('38652','MS','New Albany','Union',34.488901,-89.000071),('38654','MS','Olive Branch','Desoto',34.951966,-89.836429),('38655','MS','Oxford','Lafayette',34.347747,-89.510683),('38658','MS','Pope','Panola',34.188011,-89.900518),('38659','MS','Potts Camp','Marshall',34.640224,-89.320447),('38661','MS','Red Banks','Marshall',34.875544,-89.575659),('38663','MS','Ripley','Tippah',34.737421,-88.918156),('38664','MS','Robinsonville','Tunica',34.806224,-90.300031),('38665','MS','Sarah','Tate',34.586548,-90.166135),('38666','MS','Sardis','Panola',34.419055,-89.905097),('38668','MS','Senatobia','Tate',34.611707,-89.942471),('38669','MS','Sherard','Coahoma',34.18658,-90.717538),('38670','MS','Sledge','Quitman',34.414983,-90.263929),('38671','MS','Southaven','Desoto',34.969755,-89.997757),('38672','MS','Southaven','Desoto',34.942215,-89.946963),('38673','MS','Taylor','Lafayette',34.284278,-89.602082),('38674','MS','Tiplersville','Tippah',34.885425,-88.897357),('38675','MS','Tula','Lafayette',34.3449,-89.3895),('38676','MS','Tunica','Tunica',34.680971,-90.367806),('38677','MS','University','Lafayette',34.36547,-89.53608),('38679','MS','Victoria','Marshall',34.8461,-89.618),('38680','MS','Walls','Desoto',34.962461,-90.136994),('38683','MS','Walnut','Tippah',34.932631,-88.865292),('38685','MS','Waterford','Marshall',34.606438,-89.492899),('38686','MS','Walls','De Soto',34.9577,-90.1516),('38701','MS','Greenville','Washington',33.37297,-91.050191),('38702','MS','Greenville','Washington',33.2848,-91.0198),('38703','MS','Greenville','Washington',33.449646,-91.028097),('38704','MS','Greenville','Issaquena',33.003823,-91.022197),('38720','MS','Alligator','Coahoma',34.112229,-90.759576),('38721','MS','Anguilla','Sharkey',32.986746,-90.778693),('38722','MS','Arcola','Washington',33.26711,-90.882253),('38723','MS','Avon','Washington',33.229975,-91.047071),('38725','MS','Benoit','Bolivar',33.640891,-91.021173),('38726','MS','Beulah','Bolivar',33.753407,-90.977334),('38730','MS','Boyle','Bolivar',33.696581,-90.75923),('38731','MS','Chatham','Washington',33.078354,-91.05177),('38732','MS','Cleveland','Bolivar',33.749576,-90.723807),('38733','MS','Cleveland','Bolivar',33.745,-90.7353),('38736','MS','Doddsville','Sunflower',33.654013,-90.529444),('38737','MS','Drew','Sunflower',33.847921,-90.514321),('38738','MS','Parchman','Sunflower',33.933485,-90.52334),('38739','MS','Dublin','Coahoma',34.060111,-90.502755),('38740','MS','Duncan','Bolivar',34.055242,-90.801065),('38744','MS','Glen Allan','Washington',33.012116,-91.029856),('38745','MS','Grace','Issaquena',32.983861,-90.973027),('38746','MS','Gunnison','Bolivar',33.969878,-90.91369),('38748','MS','Hollandale','Washington',33.155428,-90.874742),('38749','MS','Holly Ridge','Sunflower',33.448361,-90.750468),('38751','MS','Indianola','Sunflower',33.447264,-90.661569),('38753','MS','Inverness','Sunflower',33.34618,-90.574409),('38754','MS','Isola','Humphreys',33.250695,-90.61146),('38756','MS','Leland','Washington',33.397046,-90.875297),('38759','MS','Merigold','Bolivar',33.824358,-90.71919),('38760','MS','Metcalfe','Washington',33.45674,-90.993517),('38761','MS','Moorhead','Sunflower',33.441813,-90.498607),('38762','MS','Mound Bayou','Bolivar',33.885873,-90.727846),('38764','MS','Pace','Bolivar',33.792477,-90.861129),('38765','MS','Panther Burn','Sharkey',33.069341,-90.874264),('38767','MS','Rena Lara','Coahoma',34.141236,-90.783888),('38768','MS','Rome','Sunflower',33.962203,-90.482466),('38769','MS','Rosedale','Bolivar',33.84752,-90.994741),('38771','MS','Ruleville','Sunflower',33.732985,-90.54045),('38772','MS','Scott','Bolivar',33.568059,-91.05331),('38773','MS','Shaw','Bolivar',33.600228,-90.770228),('38774','MS','Shelby','Bolivar',33.955722,-90.76723),('38776','MS','Stoneville','Washington',33.4238,-90.915),('38778','MS','Sunflower','Sunflower',33.556834,-90.513166),('38780','MS','Wayside','Washington',33.2685,-91.0884),('38781','MS','Winstonville','Bolivar',33.910263,-90.752431),('38782','MS','Winterville','Washington',33.2848,-91.0198),('38801','MS','Tupelo','Lee',34.234651,-88.750632),('38802','MS','Tupelo','Lee',34.2519,-88.7463),('38803','MS','Tupelo','Lee',34.2519,-88.7463),('38804','MS','Tupelo','Lee',34.281415,-88.690757),('38820','MS','Algoma','Pontotoc',34.1761,-89.0311),('38821','MS','Amory','Monroe',33.982428,-88.466452),('38824','MS','Baldwyn','Prentiss',34.51325,-88.632765),('38825','MS','Becker','Monroe',33.933,-88.4811),('38826','MS','Belden','Lee',34.3012,-88.817463),('38827','MS','Belmont','Tishomingo',34.518402,-88.208025),('38828','MS','Blue Springs','Union',34.407109,-88.871383),('38829','MS','Booneville','Prentiss',34.657732,-88.536913),('38833','MS','Burnsville','Tishomingo',34.823117,-88.329614),('38834','MS','Corinth','Alcorn',34.925535,-88.534948),('38835','MS','Corinth','Alcorn',34.9341,-88.5222),('38838','MS','Dennis','Tishomingo',34.545517,-88.254088),('38839','MS','Derma','Calhoun',33.8555,-89.2844),('38841','MS','Ecru','Pontotoc',34.348266,-89.024815),('38843','MS','Fulton','Itawamba',34.262136,-88.384788),('38844','MS','Gattman','Monroe',33.859375,-88.235996),('38846','MS','Glen','Alcorn',34.859083,-88.39751),('38847','MS','Golden','Itawamba',34.433528,-88.222031),('38848','MS','Greenwood Springs','Monroe',33.936684,-88.282673),('38849','MS','Guntown','Lee',34.449276,-88.671585),('38850','MS','Houlka','Chickasaw',34.050856,-89.021542),('38851','MS','Houston','Chickasaw',33.911758,-88.977322),('38852','MS','Iuka','Tishomingo',34.835744,-88.21268),('38855','MS','Mantachie','Itawamba',34.320834,-88.492433),('38856','MS','Marietta','Itawamba',34.467115,-88.455149),('38857','MS','Mooreville','Lee',34.276752,-88.58079),('38858','MS','Nettleton','Monroe',34.08058,-88.57128),('38859','MS','New Site','Prentiss',34.530604,-88.368197),('38860','MS','Okolona','Chickasaw',33.981141,-88.74149),('38862','MS','Plantersville','Lee',34.181711,-88.64161),('38863','MS','Pontotoc','Pontotoc',34.236907,-89.002987),('38864','MS','Randolph','Pontotoc',34.14068,-89.181946),('38865','MS','Rienzi','Alcorn',34.775946,-88.574733),('38866','MS','Saltillo','Lee',34.362497,-88.685363),('38868','MS','Shannon','Lee',34.120314,-88.724096),('38869','MS','Sherman','Pontotoc',34.359685,-88.838867),('38870','MS','Smithville','Monroe',34.06538,-88.368121),('38871','MS','Thaxton','Pontotoc',34.321488,-89.193539),('38873','MS','Tishomingo','Tishomingo',34.659729,-88.243056),('38874','MS','Toccopola','Lafayette',34.248527,-89.244809),('38875','MS','Trebloc','Chickasaw',33.9121,-88.9306),('38876','MS','Tremont','Itawamba',34.220451,-88.238987),('38877','MS','Van Vleet','Chickasaw',33.9869,-88.9002),('38878','MS','Vardaman','Calhoun',33.886173,-89.181976),('38879','MS','Verona','Lee',34.184625,-88.718416),('38880','MS','Wheeler','Prentiss',34.57971,-88.608177),('38901','MS','Grenada','Grenada',33.767971,-89.80136),('38902','MS','Grenada','Grenada',33.7688,-89.8083),('38913','MS','Banner','Calhoun',34.126643,-89.402117),('38914','MS','Big Creek','Calhoun',33.857771,-89.460563),('38915','MS','Bruce','Calhoun',34.011428,-89.356675),('38916','MS','Calhoun City','Calhoun',33.842007,-89.334099),('38917','MS','Carrollton','Carroll',33.537739,-89.943003),('38920','MS','Cascilla','Tallahatchie',33.883422,-90.093523),('38921','MS','Charleston','Tallahatchie',33.977565,-90.12459),('38922','MS','Coffeeville','Yalobusha',33.942987,-89.655648),('38923','MS','Coila','Carroll',33.372159,-89.990855),('38924','MS','Cruger','Holmes',33.304763,-90.22873),('38925','MS','Duck Hill','Montgomery',33.638646,-89.68739),('38926','MS','Elliott','Grenada',33.6833,-89.7491),('38927','MS','Enid','Tallahatchie',34.137894,-90.011599),('38928','MS','Glendora','Tallahatchie',33.852283,-90.28586),('38929','MS','Gore Springs','Grenada',33.751027,-89.54867),('38930','MS','Greenwood','Leflore',33.522894,-90.172895),('38935','MS','Greenwood','Leflore',33.5713,-90.1799),('38940','MS','Holcomb','Grenada',33.753542,-90.009689),('38941','MS','Itta Bena','Leflore',33.504096,-90.339411),('38943','MS','Mc Carley','Carroll',33.525998,-89.852746),('38944','MS','Minter City','Leflore',33.745984,-90.331381),('38945','MS','Money','Leflore',33.579603,-90.157705),('38946','MS','Morgan City','Leflore',33.363899,-90.366608),('38947','MS','North Carrollton','Carroll',33.519628,-89.914567),('38948','MS','Oakland','Yalobusha',34.085233,-89.884656),('38949','MS','Paris','Lafayette',34.191215,-89.434608),('38950','MS','Philipp','Tallahatchie',33.759926,-90.198772),('38951','MS','Pittsboro','Calhoun',33.963967,-89.312024),('38952','MS','Schlater','Leflore',33.628122,-90.344867),('38953','MS','Scobey','Tallahatchie',33.932028,-89.916146),('38954','MS','Sidon','Leflore',33.424595,-90.221189),('38955','MS','Slate Spring','Calhoun',33.8096,-89.3439),('38957','MS','Sumner','Tallahatchie',33.977829,-90.350157),('38958','MS','Swan Lake','Leflore',33.303673,-90.428149),('38959','MS','Swiftown','Leflore',33.304241,-90.426658),('38960','MS','Tie Plant','Grenada',33.7413,-89.79),('38961','MS','Tillatoba','Yalobusha',33.969796,-89.868191),('38962','MS','Tippo','Tallahatchie',33.88506,-90.174763),('38963','MS','Tutwiler','Tallahatchie',34.007767,-90.411593),('38964','MS','Vance','Quitman',34.081504,-90.383557),('38965','MS','Water Valley','Yalobusha',34.146054,-89.631431),('38966','MS','Webb','Tallahatchie',33.928583,-90.35118),('38967','MS','Winona','Montgomery',33.478282,-89.737707),('39038','MS','Belzoni','Humphreys',33.1922,-90.490461),('39039','MS','Benton','Yazoo',32.833015,-90.218902),('39040','MS','Bentonia','Yazoo',32.645814,-90.386052),('39041','MS','Bolton','Hinds',32.387938,-90.449058),('39042','MS','Brandon','Rankin',32.238747,-89.936812),('39043','MS','Brandon','Rankin',32.2819,-90.0064),('39044','MS','Braxton','Simpson',32.021094,-89.972031),('39045','MS','Camden','Madison',32.817721,-89.800215),('39046','MS','Canton','Madison',32.617857,-90.017407),('39047','MS','Brandon','Rankin',32.391158,-89.991298),('39051','MS','Carthage','Leake',32.778355,-89.512193),('39054','MS','Cary','Sharkey',32.804396,-90.926819),('39056','MS','Clinton','Hinds',32.345538,-90.331425),('39057','MS','Conehatta','Newton',32.482901,-89.288885),('39058','MS','Clinton','Hinds',32.3371,-90.3306),('39059','MS','Crystal Springs','Copiah',31.983187,-90.359283),('39060','MS','Clinton','Hinds',32.350688,-90.269549),('39061','MS','Delta City','Sharkey',33.088441,-90.819931),('39062','MS','D Lo','Simpson',31.986318,-89.899912),('39063','MS','Durant','Holmes',33.101169,-89.876237),('39066','MS','Edwards','Hinds',32.298256,-90.605851),('39067','MS','Ethel','Attala',33.117295,-89.458691),('39069','MS','Fayette','Jefferson',31.700645,-91.072359),('39071','MS','Flora','Madison',32.558898,-90.314223),('39072','MS','Pocahontas','Hinds',32.415,-90.226),('39073','MS','Florence','Rankin',32.134303,-90.120307),('39074','MS','Forest','Scott',32.389359,-89.474614),('39077','MS','Gallman','Copiah',31.9319,-90.3891),('39078','MS','Georgetown','Copiah',31.882746,-90.174866),('39079','MS','Goodman','Holmes',32.935473,-89.913288),('39080','MS','Harperville','Scott',32.4941,-89.4894),('39081','MS','Harriston','Jefferson',31.725,-91.0322),('39082','MS','Harrisville','Simpson',31.941419,-90.130912),('39083','MS','Hazlehurst','Copiah',31.848978,-90.423578),('39086','MS','Hermanville','Claiborne',31.970316,-90.78283),('39087','MS','Hillsboro','Scott',32.4591,-89.5113),('39088','MS','Holly Bluff','Yazoo',32.773026,-90.712823),('39090','MS','Kosciusko','Attala',33.026782,-89.567126),('39092','MS','Lake','Scott',32.336143,-89.355715),('39094','MS','Lena','Leake',32.592793,-89.676781),('39095','MS','Lexington','Holmes',33.115926,-90.076661),('39096','MS','Lorman','Claiborne',31.83084,-91.08343),('39097','MS','Louise','Humphreys',32.984047,-90.59201),('39098','MS','Ludlow','Scott',32.56195,-89.709289),('39107','MS','Mc Adams','Attala',33.025946,-89.683747),('39108','MS','Mc Cool','Attala',33.149349,-89.338532),('39109','MS','Madden','Leake',32.671826,-89.332405),('39110','MS','Madison','Madison',32.493253,-90.124465),('39111','MS','Magee','Simpson',31.880379,-89.725219),('39113','MS','Mayersville','Issaquena',32.911298,-91.043825),('39114','MS','Mendenhall','Simpson',31.947782,-89.841049),('39115','MS','Midnight','Humphreys',33.044863,-90.566898),('39116','MS','Mize','Smith',31.881483,-89.550917),('39117','MS','Morton','Scott',32.315874,-89.664868),('39119','MS','Mount Olive','Covington',31.763911,-89.664512),('39120','MS','Natchez','Adams',31.539461,-91.359025),('39121','MS','Natchez','Adams',31.5085,-91.3602),('39122','MS','Natchez','Adams',31.5085,-91.3602),('39130','MS','Madison','Madison',32.4616,-90.1152),('39140','MS','Newhebron','Lawrence',31.744563,-89.974577),('39144','MS','Pattison','Claiborne',31.829174,-90.813125),('39145','MS','Pelahatchie','Rankin',32.327985,-89.796993),('39146','MS','Pickens','Holmes',32.876001,-89.994907),('39148','MS','Piney Woods','Rankin',32.057964,-89.991179),('39149','MS','Pinola','Simpson',31.8545,-89.990517),('39150','MS','Port Gibson','Claiborne',31.968158,-90.979026),('39151','MS','Puckett','Rankin',32.08065,-89.776002),('39152','MS','Pulaski','Smith',32.210952,-89.55949),('39153','MS','Raleigh','Smith',32.045134,-89.490046),('39154','MS','Raymond','Hinds',32.242645,-90.442113),('39156','MS','Redwood','Warren',32.529748,-90.794974),('39157','MS','Ridgeland','Madison',32.423681,-90.135383),('39158','MS','Ridgeland','Madison',32.4063,-90.1235),('39159','MS','Rolling Fork','Sharkey',32.855125,-90.922842),('39160','MS','Sallis','Attala',33.003126,-89.747132),('39161','MS','Sandhill','Rankin',32.503522,-89.870393),('39162','MS','Satartia','Yazoo',32.640024,-90.630423),('39163','MS','Sharon','Madison',32.6583,-89.9361),('39165','MS','Sibley','Adams',31.3791,-91.3986),('39166','MS','Silver City','Humphreys',33.053641,-90.491557),('39167','MS','Star','Rankin',32.0938,-90.0461),('39168','MS','Taylorsville','Smith',31.823103,-89.409045),('39169','MS','Tchula','Holmes',33.139113,-90.272047),('39170','MS','Terry','Hinds',32.120655,-90.326379),('39171','MS','Thomastown','Leake',32.8638,-89.6694),('39173','MS','Tinsley','Yazoo',32.7396,-90.4696),('39174','MS','Tougaloo','Madison',32.396678,-90.155681),('39175','MS','Utica','Hinds',32.103611,-90.622226),('39176','MS','Vaiden','Carroll',33.312888,-89.745946),('39177','MS','Valley Park','Issaquena',32.61693,-90.809028),('39179','MS','Vaughan','Yazoo',32.814358,-90.0785),('39180','MS','Vicksburg','Warren',32.290157,-90.871385),('39181','MS','Vicksburg','Warren',32.3525,-90.8777),('39182','MS','Vicksburg','Warren',32.3525,-90.8777),('39183','MS','Vicksburg','Warren',32.391414,-90.83477),('39189','MS','Walnut Grove','Leake',32.60189,-89.420806),('39190','MS','Washington','Adams',31.5786,-91.2991),('39191','MS','Wesson','Copiah',31.710863,-90.409682),('39192','MS','West','Attala',33.184795,-89.746236),('39193','MS','Whitfield','Rankin',32.242431,-90.07023),('39194','MS','Yazoo City','Yazoo',32.850877,-90.453294),('39201','MS','Jackson','Hinds',32.292384,-90.184334),('39202','MS','Jackson','Hinds',32.313604,-90.1758),('39203','MS','Jackson','Hinds',32.308616,-90.201115),('39204','MS','Jackson','Hinds',32.284071,-90.227869),('39205','MS','Jackson','Hinds',32.2986,-90.1847),('39206','MS','Jackson','Hinds',32.368626,-90.171628),('39207','MS','Jackson','Hinds',32.2986,-90.1847),('39208','MS','Pearl','Rankin',32.270148,-90.09497),('39209','MS','Jackson','Hinds',32.328867,-90.257155),('39210','MS','Jackson','Hinds',32.325012,-90.179026),('39211','MS','Jackson','Hinds',32.372289,-90.128265),('39212','MS','Jackson','Hinds',32.251424,-90.261282),('39213','MS','Jackson','Hinds',32.357873,-90.213266),('39215','MS','Jackson','Hinds',32.2986,-90.1847),('39216','MS','Jackson','Hinds',32.333767,-90.165349),('39217','MS','Jackson','Hinds',32.299131,-90.210495),('39218','MS','Richland','Rankin',32.221739,-90.157149),('39225','MS','Jackson','Hinds',32.2986,-90.1847),('39232','MS','Flowood','Rankin',32.324576,-90.102812),('39235','MS','Jackson','Hinds',32.2986,-90.1847),('39236','MS','Jackson','Hinds',32.3628,-90.1459),('39250','MS','Jackson','Hinds',32.2986,-90.1847),('39269','MS','Jackson','Hinds',32.300996,-90.188591),('39271','MS','Jackson','Hinds',32.2986,-90.1847),('39272','MS','Byram','Hinds',32.18885,-90.266735),('39282','MS','Jackson','Hinds',32.2539,-90.2501),('39283','MS','Jackson','Hinds',32.3661,-90.2246),('39284','MS','Jackson','Hinds',32.2725,-90.216),('39286','MS','Jackson','Hinds',32.3509,-90.1765),('39288','MS','Pearl','Rankin',32.2993,-90.1427),('39289','MS','Jackson','Hinds',32.3852,-90.2747),('39296','MS','Jackson','Hinds',32.3342,-90.1755),('39298','MS','Jackson','Rankin',32.2999,-90.1843),('39301','MS','Meridian','Lauderdale',32.33597,-88.655385),('39302','MS','Meridian','Lauderdale',32.3656,-88.7007),('39303','MS','Meridian','Lauderdale',32.41,-88.6994),('39304','MS','Meridian','Lauderdale',32.3656,-88.7227),('39305','MS','Meridian','Lauderdale',32.443829,-88.697673),('39307','MS','Meridian','Lauderdale',32.357037,-88.747164),('39309','MS','Meridian','Lauderdale',32.547983,-88.610042),('39320','MS','Bailey','Lauderdale',32.542515,-88.744656),('39322','MS','Buckatunna','Wayne',31.573198,-88.548042),('39323','MS','Chunky','Newton',32.342735,-88.930042),('39324','MS','Clara','Wayne',31.5779,-88.6973),('39325','MS','Collinsville','Lauderdale',32.547402,-88.863052),('39326','MS','Daleville','Lauderdale',32.584752,-88.672715),('39327','MS','Decatur','Newton',32.445954,-89.118863),('39328','MS','De Kalb','Kemper',32.742668,-88.701533),('39330','MS','Enterprise','Clarke',32.180798,-88.843393),('39332','MS','Hickory','Newton',32.313812,-89.003063),('39335','MS','Lauderdale','Lauderdale',32.516802,-88.524501),('39336','MS','Lawrence','Newton',32.32757,-89.253575),('39337','MS','Little Rock','Newton',32.514061,-88.984419),('39338','MS','Louin','Jasper',32.098263,-89.228695),('39339','MS','Louisville','Winston',33.108741,-89.04787),('39341','MS','Macon','Noxubee',33.109665,-88.572477),('39342','MS','Marion','Lauderdale',32.423018,-88.646945),('39345','MS','Newton','Newton',32.317229,-89.146796),('39346','MS','Noxapater','Winston',32.965035,-89.095535),('39347','MS','Pachuta','Jasper',32.048246,-88.914672),('39348','MS','Paulding','Jasper',32.013616,-89.039507),('39350','MS','Philadelphia','Neshoba',32.7846,-89.131076),('39352','MS','Porterville','Kemper',32.676292,-88.490597),('39354','MS','Preston','Kemper',32.88204,-88.834536),('39355','MS','Quitman','Clarke',32.056668,-88.670831),('39356','MS','Rose Hill','Jasper',32.1376,-89.017023),('39358','MS','Scooba','Kemper',32.838477,-88.478128),('39359','MS','Sebastopol','Scott',32.572577,-89.336156),('39360','MS','Shubuta','Clarke',31.882288,-88.733041),('39361','MS','Shuqualak','Noxubee',32.995488,-88.596416),('39362','MS','State Line','Wayne',31.389955,-88.533821),('39363','MS','Stonewall','Clarke',32.136076,-88.786724),('39364','MS','Toomsuba','Lauderdale',32.418106,-88.506447),('39365','MS','Union','Neshoba',32.58671,-89.124481),('39366','MS','Vossburg','Jasper',31.939431,-88.914373),('39367','MS','Waynesboro','Wayne',31.68595,-88.654217),('39401','MS','Hattiesburg','Forrest',31.276809,-89.274602),('39402','MS','Hattiesburg','Lamar',31.322327,-89.380526),('39403','MS','Hattiesburg','Forrest',31.3222,-89.3476),('39404','MS','Hattiesburg','Forrest',31.3222,-89.3476),('39406','MS','Hattiesburg','Forrest',31.327386,-89.333246),('39407','MS','Hattiesburg','Forrest',31.3269,-89.2902),('39421','MS','Bassfield','Jefferson Davis',31.486353,-89.718209),('39422','MS','Bay Springs','Jasper',31.966097,-89.271354),('39423','MS','Beaumont','Perry',31.170495,-88.915119),('39425','MS','Brooklyn','Forrest',31.036898,-89.125064),('39426','MS','Carriere','Pearl River',30.633329,-89.652716),('39427','MS','Carson','Jefferson Davis',31.498554,-89.813411),('39428','MS','Collins','Covington',31.652038,-89.56001),('39429','MS','Columbia','Marion',31.266913,-89.799271),('39436','MS','Eastabuchie','Jones',31.436305,-89.294646),('39437','MS','Ellisville','Jones',31.589927,-89.212645),('39439','MS','Heidelberg','Jasper',31.864244,-89.01352),('39440','MS','Laurel','Jones',31.694724,-89.139772),('39441','MS','Laurel','Jones',31.6938,-89.1305),('39442','MS','Laurel','Jones',31.6938,-89.1305),('39443','MS','Laurel','Jones',31.716759,-89.110953),('39451','MS','Leakesville','Greene',31.173065,-88.600133),('39452','MS','Lucedale','George',30.882684,-88.597874),('39455','MS','Lumberton','Lamar',31.004792,-89.448971),('39456','MS','Mc Lain','Greene',31.081021,-88.812292),('39457','MS','Mc Neill','Pearl River',30.6635,-89.6342),('39459','MS','Moselle','Jones',31.502341,-89.297986),('39460','MS','Moss','Jasper',31.8486,-89.1526),('39461','MS','Neely','Greene',31.172966,-88.739726),('39462','MS','New Augusta','Perry',31.217885,-89.054913),('39463','MS','Nicholson','Pearl River',30.4769,-89.6936),('39464','MS','Ovett','Jones',31.468092,-89.070986),('39465','MS','Petal','Forrest',31.350493,-89.213676),('39466','MS','Picayune','Pearl River',30.526165,-89.659073),('39470','MS','Poplarville','Pearl River',30.814566,-89.560641),('39474','MS','Prentiss','Jefferson Davis',31.610238,-89.8599),('39475','MS','Purvis','Lamar',31.160303,-89.403623),('39476','MS','Richton','Perry',31.360069,-88.87433),('39477','MS','Sandersville','Jones',31.785375,-89.034539),('39478','MS','Sandy Hook','Marion',31.054046,-89.873771),('39479','MS','Seminary','Covington',31.546657,-89.457288),('39480','MS','Soso','Jones',31.721286,-89.306682),('39481','MS','Stringer','Jasper',31.862809,-89.252271),('39482','MS','Sumrall','Lamar',31.377197,-89.585264),('39483','MS','Foxworth','Marion',31.217031,-89.904218),('39501','MS','Gulfport','Harrison',30.379684,-89.096719),('39502','MS','Gulfport','Harrison',30.3672,-89.0927),('39503','MS','Gulfport','Harrison',30.45818,-89.093949),('39505','MS','Gulfport','Harrison',30.3672,-89.0927),('39506','MS','Gulfport','Harrison',30.4756,-89.1444),('39507','MS','Gulfport','Harrison',30.396917,-89.040083),('39520','MS','Bay Saint Louis','Hancock',30.30528,-89.408636),('39521','MS','Bay Saint Louis','Hancock',30.3086,-89.33),('39522','MS','Stennis Space Center','Hancock',30.3086,-89.33),('39525','MS','Diamondhead','Hancock',30.386523,-89.367166),('39529','MS','Stennis Space Center','Hancock',30.3806,-89.6085),('39530','MS','Biloxi','Harrison',30.398093,-88.894722),('39531','MS','Biloxi','Harrison',30.402991,-88.965204),('39532','MS','Biloxi','Harrison',30.470966,-88.941398),('39533','MS','Biloxi','Harrison',30.395,-88.8855),('39534','MS','Biloxi','Harrison',30.406397,-88.916555),('39535','MS','Biloxi','Harrison',30.4832,-89.1997),('39540','MS','Diberville','Harrison',30.437849,-88.897927),('39552','MS','Escatawpa','Jackson',30.4402,-88.5436),('39553','MS','Gautier','Jackson',30.410447,-88.643886),('39555','MS','Hurley','Jackson',30.5582,-88.5024),('39556','MS','Kiln','Hancock',30.429426,-89.43411),('39558','MS','Lakeshore','Hancock',30.2463,-89.4358),('39560','MS','Long Beach','Harrison',30.360354,-89.16186),('39561','MS','Mc Henry','Stone',30.704422,-89.142154),('39562','MS','Moss Point','Jackson',30.540601,-88.513303),('39563','MS','Moss Point','Jackson',30.411871,-88.523526),('39564','MS','Ocean Springs','Jackson',30.401086,-88.775165),('39565','MS','Vancleave','Jackson',30.53678,-88.730931),('39566','MS','Ocean Springs','Jackson',30.416,-88.8217),('39567','MS','Pascagoula','Jackson',30.36002,-88.54853),('39568','MS','Pascagoula','Jackson',30.3655,-88.5561),('39569','MS','Pascagoula','Jackson',30.5603,-88.4933),('39571','MS','Pass Christian','Harrison',30.356984,-89.268677),('39572','MS','Pearlington','Hancock',30.250769,-89.604943),('39573','MS','Perkinston','Stone',30.734206,-89.139368),('39574','MS','Saucier','Harrison',30.594695,-89.121308),('39576','MS','Waveland','Hancock',30.28981,-89.383391),('39577','MS','Wiggins','Stone',30.879944,-89.132182),('39581','MS','Pascagoula','Jackson',30.362018,-88.514825),('39595','MS','Pascagoula','Jackson',30.3702,-88.5651),('39601','MS','Brookhaven','Lincoln',31.572024,-90.462025),('39602','MS','Brookhaven','Lincoln',31.5895,-90.4721),('39603','MS','Brookhaven','Lincoln',31.5895,-90.4721),('39629','MS','Bogue Chitto','Lincoln',31.458453,-90.456511),('39630','MS','Bude','Franklin',31.462261,-90.849061),('39631','MS','Centreville','Wilkinson',31.080321,-91.075986),('39632','MS','Chatawa','Pike',31.059186,-90.467067),('39633','MS','Crosby','Wilkinson',31.300038,-91.148108),('39635','MS','Fernwood','Pike',31.189219,-90.451124),('39638','MS','Gloster','Amite',31.203872,-90.997005),('39641','MS','Jayess','Walthall',31.356403,-90.181851),('39643','MS','Kokomo','Marion',31.232352,-90.024936),('39645','MS','Liberty','Amite',31.153772,-90.801994),('39647','MS','Mc Call Creek','Franklin',31.509907,-90.710069),('39648','MS','Mccomb','Pike',31.223601,-90.43477),('39649','MS','Mccomb','Pike',31.1687,-90.3676),('39652','MS','Magnolia','Pike',31.11444,-90.453506),('39653','MS','Meadville','Franklin',31.463909,-90.875643),('39654','MS','Monticello','Lawrence',31.55163,-90.126846),('39656','MS','Oak Vale','Jefferson Davis',31.44702,-89.939144),('39657','MS','Osyka','Pike',31.017616,-90.452071),('39661','MS','Roxie','Franklin',31.495409,-91.07025),('39662','MS','Ruth','Lincoln',31.3873,-90.282128),('39663','MS','Silver Creek','Lawrence',31.599492,-90.013735),('39664','MS','Smithdale','Amite',31.321207,-90.688484),('39665','MS','Sontag','Lawrence',31.630904,-90.214434),('39666','MS','Summit','Pike',31.290715,-90.467838),('39667','MS','Tylertown','Walthall',31.131169,-90.142844),('39668','MS','Union Church','Jefferson',31.674352,-90.779355),('39669','MS','Woodville','Wilkinson',31.150673,-91.362519),('39701','MS','Columbus','Lowndes',33.464691,-88.457748),('39702','MS','Columbus','Lowndes',33.466087,-88.358428),('39703','MS','Columbus','Lowndes',33.5379,-88.4351),('39704','MS','Columbus','Lowndes',33.69048,-88.330978),('39705','MS','Columbus','Lowndes',33.579925,-88.433571),('39710','MS','Columbus','Lowndes',33.6298,-88.4468),('39730','MS','Aberdeen','Monroe',33.832725,-88.554638),('39735','MS','Ackerman','Choctaw',33.338312,-89.185736),('39736','MS','Artesia','Lowndes',33.422,-88.646731),('39737','MS','Bellefontaine','Webster',33.663961,-89.324087),('39739','MS','Brooksville','Noxubee',33.242655,-88.578593),('39740','MS','Caledonia','Lowndes',33.695834,-88.322819),('39741','MS','Cedarbluff','Clay',33.65193,-88.879257),('39743','MS','Crawford','Lowndes',33.315003,-88.626263),('39744','MS','Eupora','Webster',33.556824,-89.290853),('39745','MS','French Camp','Choctaw',33.300896,-89.439355),('39746','MS','Hamilton','Monroe',33.741696,-88.43743),('39747','MS','Kilmichael','Montgomery',33.428847,-89.568427),('39750','MS','Maben','Webster',33.558461,-89.071119),('39751','MS','Mantee','Webster',33.704459,-89.060178),('39752','MS','Mathiston','Webster',33.530527,-89.149184),('39753','MS','Mayhew','Lowndes',33.4847,-88.6344),('39754','MS','Montpelier','Clay',33.7198,-88.94),('39755','MS','Pheba','Clay',33.609399,-88.957514),('39756','MS','Prairie','Clay',33.780971,-88.707925),('39759','MS','Starkville','Oktibbeha',33.452841,-88.818825),('39760','MS','Starkville','Oktibbeha',33.4502,-88.8183),('39762','MS','Mississippi State','Oktibbeha',33.453824,-88.795268),('39766','MS','Steens','Lowndes',33.586571,-88.321105),('39767','MS','Stewart','Webster',33.467999,-89.452318),('39769','MS','Sturgis','Oktibbeha',33.321926,-89.017838),('39771','MS','Walthall','Webster',33.607922,-89.277746),('39772','MS','Weir','Choctaw',33.295122,-89.304493),('39773','MS','West Point','Clay',33.617138,-88.647614),('39776','MS','Woodland','Chickasaw',33.773224,-89.010403),('39813','GA','Arlington','Calhoun',31.420453,-84.687827),('39815','GA','Attapulgus','Decatur',30.73885,-84.490698),('39817','GA','Bainbridge','Decatur',30.93443,-84.577087),('39818','GA','Bainbridge','Decatur',30.9036,-84.5756),('39819','GA','Bainbridge','Decatur',30.842382,-84.610082),('39823','GA','Blakely','Early',31.325395,-84.960688),('39824','GA','Bluffton','Clay',31.512102,-84.883513),('39825','GA','Brinson','Decatur',30.939769,-84.72188),('39826','GA','Bronwood','Terrell',31.825854,-84.359189),('39827','GA','Cairo','Grady',30.950847,-84.209264),('39828','GA','Cairo','Grady',30.831377,-84.218381),('39829','GA','Calvary','Grady',30.7305,-84.345),('39832','GA','Cedar Springs','Early',31.1833,-85.0381),('39834','GA','Climax','Decatur',30.875631,-84.424568),('39836','GA','Coleman','Randolph',31.665983,-84.868547),('39837','GA','Colquitt','Miller',31.15388,-84.696309),('39840','GA','Cuthbert','Randolph',31.780895,-84.764694),('39841','GA','Damascus','Early',31.292866,-84.685044),('39842','GA','Dawson','Terrell',31.769323,-84.43466),('39845','GA','Donalsonville','Seminole',30.951468,-84.892839),('39846','GA','Edison','Calhoun',31.564165,-84.753665),('39851','GA','Fort Gaines','Clay',31.630652,-85.018171),('39852','GA','Fowlstown','Decatur',30.8025,-84.5472),('39854','GA','Georgetown','Quitman',31.852388,-85.063405),('39859','GA','Iron City','Seminole',31.014047,-84.800849),('39861','GA','Jakin','Early',31.130814,-84.98647),('39862','GA','Leary','Calhoun',31.459371,-84.517381),('39866','GA','Morgan','Calhoun',31.554677,-84.603412),('39867','GA','Morris','Clay',31.828416,-84.927893),('39870','GA','Newton','Baker',31.314665,-84.376218),('39877','GA','Parrott','Terrell',31.915159,-84.511576),('39885','GA','Sasser','Terrell',31.71879,-84.348595),('39886','GA','Shellman','Randolph',31.741418,-84.616573),('39897','GA','Whigham','Grady',30.899607,-84.318943),('39901','GA','Atlanta','Dekalb',33.8872,-84.2897),('40003','KY','Bagdad','Shelby',38.276689,-85.043822),('40004','KY','Bardstown','Nelson',37.811381,-85.461061),('40006','KY','Bedford','Trimble',38.599895,-85.320743),('40007','KY','Bethlehem','Henry',38.458345,-84.99915),('40008','KY','Bloomfield','Nelson',37.918522,-85.270846),('40009','KY','Bradfordsville','Marion',37.473382,-85.11574),('40010','KY','Buckner','Oldham',38.37432,-85.442743),('40011','KY','Campbellsburg','Henry',38.527652,-85.190615),('40012','KY','Chaplin','Nelson',37.900841,-85.191983),('40013','KY','Coxs Creek','Nelson',37.941656,-85.469961),('40014','KY','Crestwood','Oldham',38.34024,-85.452075),('40018','KY','Eastwood','Jefferson',38.2325,-85.4522),('40019','KY','Eminence','Henry',38.370576,-85.179),('40020','KY','Fairfield','Nelson',37.934332,-85.384979),('40022','KY','Finchville','Shelby',38.152649,-85.323036),('40023','KY','Fisherville','Jefferson',38.17414,-85.432339),('40025','KY','Glenview','Jefferson',38.30106,-85.650799),('40026','KY','Goshen','Oldham',38.41322,-85.559923),('40027','KY','Harrods Creek','Jefferson',38.328,-85.636),('40031','KY','La Grange','Oldham',38.411317,-85.391743),('40032','KY','La Grange','Oldham',38.4075,-85.3788),('40033','KY','Lebanon','Marion',37.561225,-85.249037),('40036','KY','Lockport','Henry',38.428974,-84.993151),('40037','KY','Loretto','Marion',37.652593,-85.400093),('40040','KY','Mackville','Washington',37.753895,-85.05499),('40041','KY','Masonic Home','Jefferson',38.257178,-85.664654),('40045','KY','Milton','Trimble',38.699017,-85.362353),('40046','KY','Mount Eden','Spencer',38.023931,-85.169791),('40047','KY','Mount Washington','Bullitt',38.043622,-85.55879),('40048','KY','Nazareth','Nelson',37.84704,-85.470265),('40049','KY','Nerinx','Marion',37.663524,-85.395026),('40050','KY','New Castle','Henry',38.437775,-85.174464),('40051','KY','New Haven','Nelson',37.652202,-85.579583),('40052','KY','New Hope','Nelson',37.603228,-85.502925),('40055','KY','Pendleton','Henry',38.48903,-85.316724),('40056','KY','Pewee Valley','Oldham',38.301984,-85.486026),('40057','KY','Pleasureville','Henry',38.382514,-85.055686),('40058','KY','Port Royal','Henry',38.433044,-85.170983),('40059','KY','Prospect','Jefferson',38.354009,-85.592991),('40060','KY','Raywick','Marion',37.543291,-85.435446),('40061','KY','Saint Catharine','Washington',37.701,-85.26),('40062','KY','Saint Francis','Marion',37.59915,-85.430397),('40063','KY','Saint Mary','Marion',37.56928,-85.343004),('40065','KY','Shelbyville','Shelby',38.209317,-85.216134),('40066','KY','Shelbyville','Shelby',38.2119,-85.2236),('40067','KY','Simpsonville','Shelby',38.209484,-85.358329),('40068','KY','Smithfield','Henry',38.400899,-85.266289),('40069','KY','Springfield','Washington',37.709191,-85.227577),('40070','KY','Sulphur','Henry',38.48363,-85.25671),('40071','KY','Taylorsville','Spencer',38.052964,-85.352383),('40075','KY','Turners Station','Henry',38.576881,-85.126401),('40076','KY','Waddy','Shelby',38.123848,-85.066331),('40077','KY','Westport','Oldham',38.48441,-85.471088),('40078','KY','Willisburg','Washington',37.849479,-85.16068),('40104','KY','Battletown','Meade',38.107751,-86.341263),('40107','KY','Boston','Nelson',37.756178,-85.651571),('40108','KY','Brandenburg','Meade',37.973416,-86.138524),('40109','KY','Brooks','Bullitt',38.062389,-85.736207),('40110','KY','Clermont','Bullitt',37.932836,-85.658363),('40111','KY','Cloverport','Breckinridge',37.817413,-86.634104),('40115','KY','Custer','Breckinridge',37.735743,-86.238196),('40117','KY','Ekron','Meade',37.916353,-86.144495),('40118','KY','Fairdale','Jefferson',38.112206,-85.757917),('40119','KY','Falls Of Rough','Grayson',37.599309,-86.522073),('40121','KY','Fort Knox','Hardin',37.904583,-85.951438),('40122','KY','Fort Knox','Hardin',37.891,-85.952),('40129','KY','Hillview','Bullitt',38.0719,-85.672),('40140','KY','Garfield','Breckinridge',37.720388,-86.283688),('40142','KY','Guston','Meade',37.893218,-86.204086),('40143','KY','Hardinsburg','Breckinridge',37.762812,-86.496094),('40144','KY','Harned','Breckinridge',37.72968,-86.385941),('40145','KY','Hudson','Breckinridge',37.634062,-86.301875),('40146','KY','Irvington','Breckinridge',37.86034,-86.31554),('40150','KY','Lebanon Junction','Bullitt',37.845869,-85.727618),('40152','KY','Mc Daniels','Breckinridge',37.626887,-86.443492),('40153','KY','Mc Quady','Breckinridge',37.7123,-86.518),('40155','KY','Muldraugh','Meade',37.9377,-85.992567),('40157','KY','Payneville','Meade',38.034846,-86.413075),('40159','KY','Radcliff','Hardin',37.8402,-85.9491),('40160','KY','Radcliff','Hardin',37.827872,-85.938417),('40161','KY','Rhodelia','Meade',37.999385,-86.388706),('40162','KY','Rineyville','Hardin',37.753982,-85.98135),('40165','KY','Shepherdsville','Bullitt',37.998257,-85.69299),('40170','KY','Stephensport','Breckinridge',37.971741,-86.511671),('40171','KY','Union Star','Breckinridge',37.976723,-86.452364),('40175','KY','Vine Grove','Hardin',37.82548,-86.03306),('40176','KY','Webster','Breckinridge',37.921418,-86.345795),('40177','KY','West Point','Hardin',37.99756,-85.943823),('40178','KY','Westview','Breckinridge',37.646483,-86.405489),('40201','KY','Louisville','Jefferson',38.2435,-85.7639),('40202','KY','Louisville','Jefferson',38.252816,-85.751301),('40203','KY','Louisville','Jefferson',38.246198,-85.764271),('40204','KY','Louisville','Jefferson',38.237669,-85.725704),('40205','KY','Louisville','Jefferson',38.224622,-85.686973),('40206','KY','Louisville','Jefferson',38.257068,-85.7043),('40207','KY','Louisville','Jefferson',38.260036,-85.652405),('40208','KY','Louisville','Jefferson',38.216765,-85.762648),('40209','KY','Louisville','Jefferson',38.19141,-85.747832),('40210','KY','Louisville','Jefferson',38.234663,-85.787577),('40211','KY','Louisville','Jefferson',38.241173,-85.811562),('40212','KY','Louisville','Jefferson',38.264779,-85.800896),('40213','KY','Louisville','Jefferson',38.185997,-85.715183),('40214','KY','Louisville','Jefferson',38.162971,-85.77526),('40215','KY','Louisville','Jefferson',38.191897,-85.783637),('40216','KY','Louisville','Jefferson',38.186906,-85.833702),('40217','KY','Louisville','Jefferson',38.217585,-85.740412),('40218','KY','Louisville','Jefferson',38.193068,-85.657144),('40219','KY','Louisville','Jefferson',38.140718,-85.682253),('40220','KY','Louisville','Jefferson',38.215669,-85.621778),('40221','KY','Louisville','Jefferson',38.1967,-85.6973),('40222','KY','Louisville','Jefferson',38.264884,-85.613436),('40223','KY','Louisville','Jefferson',38.259847,-85.551046),('40224','KY','Louisville','Jefferson',38.2289,-85.575),('40225','KY','Louisville','Jefferson',38.1967,-85.6973),('40228','KY','Louisville','Jefferson',38.143473,-85.629412),('40229','KY','Louisville','Jefferson',38.091579,-85.668413),('40231','KY','Louisville','Jefferson',38.1967,-85.6973),('40232','KY','Louisville','Jefferson',38.1967,-85.6973),('40233','KY','Louisville','Jefferson',38.1967,-85.6973),('40241','KY','Louisville','Jefferson',38.305564,-85.584096),('40242','KY','Louisville','Jefferson',38.277617,-85.588623),('40243','KY','Louisville','Jefferson',38.237416,-85.537077),('40245','KY','Louisville','Jefferson',38.265524,-85.473659),('40250','KY','Louisville','Jefferson',38.2164,-85.6236),('40251','KY','Louisville','Jefferson',38.2497,-85.7974),('40252','KY','Louisville','Jefferson',38.2628,-85.605),('40253','KY','Louisville','Jefferson',38.2432,-85.5291),('40255','KY','Louisville','Jefferson',38.2237,-85.6868),('40256','KY','Louisville','Jefferson',38.1928,-85.8068),('40257','KY','Louisville','Jefferson',38.2505,-85.628),('40258','KY','Louisville','Jefferson',38.14209,-85.865903),('40259','KY','Louisville','Jefferson',38.1389,-85.6866),('40261','KY','Louisville','Jefferson',38.1942,-85.6515),('40266','KY','Louisville','Jefferson',38.1967,-85.6973),('40268','KY','Louisville','Jefferson',38.1435,-85.8384),('40269','KY','Louisville','Jefferson',38.1931,-85.5668),('40270','KY','Louisville','Jefferson',38.2529,-85.7575),('40272','KY','Louisville','Jefferson',38.092961,-85.860587),('40280','KY','Louisville','Jefferson',38.247636,-85.688309),('40281','KY','Louisville','Jefferson',38.1447,-85.8665),('40282','KY','Louisville','Jefferson',38.1341,-85.8953),('40283','KY','Louisville','Jefferson',38.1341,-85.8953),('40285','KY','Louisville','Jefferson',38.1967,-85.6973),('40287','KY','Louisville','Jefferson',38.1967,-85.6973),('40289','KY','Louisville','Jefferson',38.2564,-85.7527),('40290','KY','Louisville','Jefferson',38.2564,-85.7527),('40291','KY','Louisville','Jefferson',38.142807,-85.586309),('40292','KY','Louisville','Jefferson',38.2183,-85.7593),('40293','KY','Louisville','Jefferson',38.2564,-85.7527),('40294','KY','Louisville','Jefferson',38.2564,-85.7527),('40295','KY','Louisville','Jefferson',38.2564,-85.7527),('40296','KY','Louisville','Jefferson',38.2564,-85.7527),('40297','KY','Louisville','Jefferson',38.2564,-85.7527),('40298','KY','Louisville','Jefferson',38.2564,-85.7527),('40299','KY','Louisville','Jefferson',38.184654,-85.548161),('40310','KY','Burgin','Mercer',37.753004,-84.767369),('40311','KY','Carlisle','Nicholas',38.320838,-84.028942),('40312','KY','Clay City','Powell',37.858033,-83.934695),('40313','KY','Clearfield','Rowan',38.149174,-83.416106),('40316','KY','Denniston','Menifee',37.921801,-83.52481),('40317','KY','Elliottville','Rowan',38.1827,-83.2758),('40319','KY','Farmers','Rowan',38.1427,-83.5461),('40322','KY','Frenchburg','Menifee',37.938657,-83.634973),('40324','KY','Georgetown','Scott',38.221355,-84.554349),('40328','KY','Gravel Switch','Marion',37.562638,-85.031169),('40330','KY','Harrodsburg','Mercer',37.774186,-84.849501),('40334','KY','Hope','Montgomery',38.017203,-83.764652),('40336','KY','Irvine','Estill',37.696436,-83.977458),('40337','KY','Jeffersonville','Montgomery',37.9595,-83.841778),('40339','KY','Keene','Jessamine',37.942941,-84.644187),('40340','KY','Nicholasville','Jessamine',37.8752,-84.5748),('40342','KY','Lawrenceburg','Anderson',38.014086,-84.945882),('40346','KY','Means','Menifee',37.966602,-83.746791),('40347','KY','Midway','Woodford',38.161329,-84.704895),('40348','KY','Millersburg','Bourbon',38.29969,-84.146938),('40350','KY','Moorefield','Nicholas',38.304672,-83.873854),('40351','KY','Morehead','Rowan',38.188582,-83.440617),('40353','KY','Mount Sterling','Montgomery',38.059804,-83.936611),('40355','KY','New Liberty','Owen',38.606023,-84.827903),('40356','KY','Nicholasville','Jessamine',37.887393,-84.573095),('40357','KY','North Middletown','Bourbon',38.145,-84.1091),('40358','KY','Olympia','Bath',38.057558,-83.684089),('40359','KY','Owenton','Owen',38.468285,-84.811662),('40360','KY','Owingsville','Bath',38.14571,-83.770957),('40361','KY','Paris','Bourbon',38.210667,-84.228882),('40362','KY','Paris','Bourbon',38.2097,-84.253),('40363','KY','Perry Park','Owen',38.522034,-85.006072),('40366','KY','Preston','Bath',38.0823,-83.7588),('40370','KY','Sadieville','Scott',38.395261,-84.540825),('40371','KY','Salt Lick','Bath',38.082524,-83.611888),('40372','KY','Salvisa','Mercer',37.914575,-84.871977),('40374','KY','Sharpsburg','Bath',38.207872,-83.920142),('40376','KY','Slade','Powell',37.78248,-83.689192),('40379','KY','Stamping Ground','Scott',38.311255,-84.684323),('40380','KY','Stanton','Powell',37.832286,-83.805143),('40383','KY','Versailles','Woodford',38.035175,-84.730666),('40384','KY','Versailles','Woodford',38.0526,-84.7272),('40385','KY','Waco','Madison',37.741635,-84.134527),('40386','KY','Versailles','Woodford',38.0233,-84.747),('40387','KY','Wellington','Menifee',37.935027,-83.491144),('40390','KY','Wilmore','Jessamine',37.857115,-84.663329),('40391','KY','Winchester','Clark',37.976815,-84.164436),('40392','KY','Winchester','Clark',37.99,-84.1797),('40402','KY','Annville','Jackson',37.292686,-83.975517),('40403','KY','Berea','Madison',37.584019,-84.283378),('40404','KY','Berea','Madison',37.571978,-84.289069),('40405','KY','Bighill','Madison',37.5544,-84.2083),('40409','KY','Brodhead','Rockcastle',37.369255,-84.434837),('40410','KY','Bryantsville','Garrard',37.7144,-84.6491),('40419','KY','Crab Orchard','Lincoln',37.446774,-84.502589),('40422','KY','Danville','Boyle',37.641042,-84.780043),('40423','KY','Danville','Boyle',37.6425,-84.7717),('40434','KY','Gray Hawk','Jackson',37.394162,-83.940822),('40437','KY','Hustonville','Lincoln',37.452304,-84.834562),('40440','KY','Junction City','Boyle',37.582539,-84.79998),('40442','KY','Kings Mountain','Lincoln',37.349602,-84.721659),('40444','KY','Lancaster','Garrard',37.658392,-84.596682),('40445','KY','Livingston','Rockcastle',37.299811,-84.195787),('40446','KY','Lancaster','Garrard',37.6929,-84.5946),('40447','KY','Mc Kee','Jackson',37.452013,-84.019239),('40448','KY','Mc Kinney','Lincoln',37.460003,-84.756764),('40452','KY','Mitchellsburg','Boyle',37.6005,-84.9497),('40456','KY','Mount Vernon','Rockcastle',37.362238,-84.333378),('40460','KY','Orlando','Rockcastle',37.391176,-84.248732),('40461','KY','Paint Lick','Madison',37.592297,-84.409419),('40464','KY','Parksville','Boyle',37.553348,-84.9276),('40468','KY','Perryville','Boyle',37.648263,-84.972441),('40472','KY','Ravenna','Estill',37.695116,-83.898892),('40473','KY','Renfro Valley','Rockcastle',37.3877,-84.3316),('40475','KY','Richmond','Madison',37.755621,-84.304436),('40476','KY','Richmond','Madison',37.7477,-84.2947),('40481','KY','Sandgap','Jackson',37.448874,-84.090064),('40484','KY','Stanford','Lincoln',37.522822,-84.665685),('40486','KY','Tyner','Jackson',37.365509,-83.875942),('40488','KY','Waneta','Jackson',37.471602,-84.039366),('40489','KY','Waynesburg','Lincoln',37.359309,-84.627808),('40492','KY','Wildie','Rockcastle',37.4233,-84.3022),('40495','KY','Winston','Estill',37.7055,-84.0822),('40502','KY','Lexington','Fayette',38.016182,-84.484535),('40503','KY','Lexington','Fayette',38.006777,-84.534525),('40504','KY','Lexington','Fayette',38.039704,-84.54378),('40505','KY','Lexington','Fayette',38.05894,-84.46138),('40506','KY','Lexington','Fayette',38.028952,-84.505287),('40507','KY','Lexington','Fayette',38.045936,-84.495808),('40508','KY','Lexington','Fayette',38.049585,-84.493462),('40509','KY','Lexington','Fayette',38.008368,-84.411604),('40510','KY','Lexington','Fayette',38.063352,-84.599981),('40511','KY','Lexington','Fayette',38.103716,-84.509685),('40512','KY','Lexington','Fayette',38.1375,-84.4698),('40513','KY','Lexington','Fayette',38.013639,-84.576099),('40514','KY','Lexington','Fayette',37.982035,-84.561976),('40515','KY','Lexington','Fayette',37.960295,-84.467304),('40516','KY','Lexington','Fayette',38.072059,-84.389569),('40517','KY','Lexington','Fayette',37.983774,-84.490206),('40522','KY','Lexington','Fayette',38.0196,-84.488),('40523','KY','Lexington','Fayette',37.9864,-84.5165),('40524','KY','Lexington','Fayette',37.9864,-84.5165),('40526','KY','Lexington','Fayette',38.0271,-84.5044),('40533','KY','Lexington','Fayette',38.039,-84.5525),('40536','KY','Lexington','Fayette',38.0271,-84.5044),('40544','KY','Lexington','Fayette',38.039,-84.5525),('40546','KY','Lexington','Fayette',38.0271,-84.5044),('40550','KY','Lexington','Fayette',38.1375,-84.4698),('40555','KY','Lexington','Fayette',38.0491,-84.5002),('40574','KY','Lexington','Fayette',38.1362,-84.4728),('40575','KY','Lexington','Fayette',38.1362,-84.4728),('40576','KY','Lexington','Fayette',38.1362,-84.4728),('40577','KY','Lexington','Fayette',38.1375,-84.4698),('40578','KY','Lexington','Fayette',38.1362,-84.4728),('40579','KY','Lexington','Fayette',38.1375,-84.4698),('40580','KY','Lexington','Fayette',38.1362,-84.4728),('40581','KY','Lexington','Fayette',38.1362,-84.4728),('40582','KY','Lexington','Fayette',38.1362,-84.4728),('40583','KY','Lexington','Fayette',38.1362,-84.4728),('40588','KY','Lexington','Fayette',38.0469,-84.4951),('40591','KY','Lexington','Fayette',38.0469,-84.4951),('40598','KY','Lexington','Fayette',38.0494,-84.5004),('40601','KY','Frankfort','Franklin',38.201903,-84.872601),('40602','KY','Frankfort','Franklin',38.2008,-84.8721),('40603','KY','Frankfort','Franklin',38.2017,-84.8324),('40604','KY','Frankfort','Franklin',38.174629,-84.870977),('40618','KY','Frankfort','Franklin',38.2008,-84.8721),('40619','KY','Frankfort','Franklin',38.2008,-84.8721),('40620','KY','Frankfort','Franklin',38.2008,-84.8721),('40621','KY','Frankfort','Franklin',38.2008,-84.8721),('40622','KY','Frankfort','Franklin',38.2008,-84.8721),('40701','KY','Corbin','Whitley',36.940935,-84.113022),('40702','KY','Corbin','Whitley',36.9515,-84.087),('40724','KY','Bush','Laurel',37.0902,-83.8805),('40729','KY','East Bernstadt','Laurel',37.219692,-84.136414),('40730','KY','Emlyn','Whitley',36.705162,-84.145952),('40734','KY','Gray','Knox',36.931161,-83.98068),('40737','KY','Keavy','Laurel',37.000844,-84.133774),('40740','KY','Lily','Laurel',37.01842,-84.050847),('40741','KY','London','Laurel',37.144224,-84.091592),('40742','KY','London','Laurel',37.1288,-84.0833),('40743','KY','London','Laurel',37.077492,-84.118904),('40744','KY','London','Laurel',37.055911,-84.085377),('40745','KY','London','Laurel',37.1288,-84.0833),('40754','KY','Nevisdale','Whitley',36.6581,-84.1142),('40755','KY','Pittsburg','Laurel',37.16,-84.1041),('40759','KY','Rockholds','Whitley',36.826614,-84.05785),('40763','KY','Siler','Whitley',36.689214,-83.925551),('40769','KY','Williamsburg','Whitley',36.720013,-84.149313),('40771','KY','Woodbine','Knox',36.884068,-84.061872),('40801','KY','Ages Brookside','Harlan',36.857679,-83.249196),('40803','KY','Asher','Leslie',37.046365,-83.420032),('40806','KY','Baxter','Harlan',36.867621,-83.318749),('40807','KY','Benham','Harlan',36.963904,-82.954987),('40808','KY','Big Laurel','Harlan',36.983247,-83.247127),('40810','KY','Bledsoe','Harlan',36.922305,-83.330136),('40813','KY','Calvin','Bell',36.737534,-83.603448),('40815','KY','Cawood','Harlan',36.775908,-83.242431),('40816','KY','Chappell','Leslie',36.99913,-83.319342),('40818','KY','Coalgood','Harlan',36.812297,-83.25323),('40819','KY','Coldiron','Harlan',36.826148,-83.47627),('40820','KY','Cranks','Harlan',36.763677,-83.174287),('40823','KY','Cumberland','Harlan',36.973972,-82.993541),('40824','KY','Dayhoit','Harlan',36.84019,-83.376399),('40826','KY','Eolia','Letcher',37.046259,-82.794573),('40827','KY','Essie','Leslie',37.029521,-83.487337),('40828','KY','Evarts','Harlan',36.875526,-83.163837),('40829','KY','Grays Knob','Harlan',36.807142,-83.304232),('40830','KY','Gulston','Harlan',36.774991,-83.330325),('40831','KY','Harlan','Harlan',36.822752,-83.320788),('40840','KY','Helton','Leslie',36.918895,-83.421908),('40843','KY','Holmes Mill','Harlan',36.870324,-82.976118),('40844','KY','Hoskinston','Leslie',37.066815,-83.379654),('40845','KY','Hulen','Bell',36.791917,-83.519514),('40847','KY','Kenvir','Harlan',36.853916,-83.161457),('40849','KY','Lejunior','Harlan',36.89389,-83.131751),('40854','KY','Loyall','Harlan',36.850023,-83.353503),('40855','KY','Lynch','Harlan',36.959772,-82.90916),('40856','KY','Miracle','Bell',36.728944,-83.561104),('40858','KY','Mozelle','Leslie',37.007593,-83.398446),('40862','KY','Partridge','Letcher',37.012346,-82.881175),('40863','KY','Pathfork','Harlan',36.752279,-83.44953),('40865','KY','Putney','Harlan',36.909808,-83.217586),('40868','KY','Stinnett','Leslie',37.096615,-83.424208),('40870','KY','Totz','Harlan',36.933632,-83.144042),('40873','KY','Wallins Creek','Harlan',36.825525,-83.409997),('40874','KY','Warbranch','Leslie',36.989144,-83.447547),('40902','KY','Arjay','Bell',36.834999,-83.633223),('40903','KY','Artemus','Knox',36.823075,-83.834083),('40906','KY','Barbourville','Knox',36.863231,-83.883031),('40913','KY','Beverly','Clay',36.942318,-83.532186),('40914','KY','Big Creek','Clay',37.119312,-83.563952),('40915','KY','Bimble','Knox',36.877518,-83.824344),('40921','KY','Bryants Store','Knox',36.775022,-83.911666),('40923','KY','Cannon','Knox',36.924417,-83.850155),('40927','KY','Closplint','Harlan',36.888413,-83.047474),('40930','KY','Dewitt','Knox',36.855044,-83.739009),('40931','KY','Eriline','Clay',37.1102,-83.7549),('40932','KY','Fall Rock','Clay',37.2197,-83.7883),('40935','KY','Flat Lick','Knox',36.859693,-83.75169),('40939','KY','Fourmile','Bell',36.794989,-83.741506),('40940','KY','Frakes','Whitley',36.614601,-83.92319),('40941','KY','Garrard','Clay',37.130701,-83.741162),('40943','KY','Girdler','Knox',36.945495,-83.841602),('40944','KY','Goose Rock','Clay',37.0902,-83.6944),('40946','KY','Green Road','Knox',36.985567,-83.820806),('40949','KY','Heidrick','Knox',36.884183,-83.879032),('40951','KY','Hima','Clay',37.1205,-83.7783),('40953','KY','Hinkle','Knox',36.928466,-83.82616),('40955','KY','Ingram','Bell',36.7302,-83.7983),('40958','KY','Kettle Island','Bell',36.795701,-83.585345),('40962','KY','Manchester','Clay',37.167577,-83.755639),('40964','KY','Mary Alice','Harlan',36.784854,-83.331181),('40965','KY','Middlesboro','Bell',36.619025,-83.720594),('40972','KY','Oneida','Clay',37.266042,-83.62386),('40977','KY','Pineville','Bell',36.739387,-83.724176),('40979','KY','Roark','Leslie',37.014801,-83.50979),('40981','KY','Saul','Perry',37.2725,-83.4955),('40982','KY','Scalf','Knox',36.927392,-83.696434),('40983','KY','Sextons Creek','Clay',37.33096,-83.754547),('40988','KY','Stoney Fork','Bell',36.840605,-83.516492),('40995','KY','Trosper','Knox',36.7626,-83.816488),('40997','KY','Walker','Knox',36.889432,-83.688711),('40999','KY','Woollum','Knox',37.005242,-83.805082),('41001','KY','Alexandria','Campbell',38.939379,-84.392337),('41002','KY','Augusta','Bracken',38.75877,-83.991752),('41003','KY','Berry','Harrison',38.530595,-84.389223),('41004','KY','Brooksville','Bracken',38.678523,-84.100355),('41005','KY','Burlington','Boone',39.019914,-84.745391),('41006','KY','Butler','Pendleton',38.784528,-84.349183),('41007','KY','California','Campbell',38.899729,-84.287984),('41008','KY','Carrollton','Carroll',38.670995,-85.167307),('41010','KY','Corinth','Grant',38.486178,-84.610929),('41011','KY','Covington','Kenton',39.074259,-84.521772),('41012','KY','Covington','Kenton',39.0832,-84.5079),('41014','KY','Covington','Kenton',39.067856,-84.504019),('41015','KY','Latonia','Kenton',39.012904,-84.494462),('41016','KY','Covington','Kenton',39.08832,-84.548634),('41017','KY','Ft Mitchell','Kenton',39.034599,-84.560801),('41018','KY','Erlanger','Kenton',39.013995,-84.598868),('41019','KY','Covington','Kenton',39.0832,-84.5079),('41022','KY','Florence','Boone',39.0083,-84.624),('41030','KY','Crittenden','Grant',38.791781,-84.603611),('41031','KY','Cynthiana','Harrison',38.401281,-84.293645),('41033','KY','De Mossville','Pendleton',38.781409,-84.458463),('41034','KY','Dover','Mason',38.723934,-83.891318),('41035','KY','Dry Ridge','Grant',38.719224,-84.654354),('41037','KY','Elizaville','Fleming',38.4194,-83.8255),('41039','KY','Ewing','Fleming',38.411655,-83.884946),('41040','KY','Falmouth','Pendleton',38.655944,-84.325278),('41041','KY','Flemingsburg','Fleming',38.418141,-83.725504),('41042','KY','Florence','Boone',38.987219,-84.647016),('41043','KY','Foster','Bracken',38.776128,-84.191253),('41044','KY','Germantown','Bracken',38.623496,-83.978191),('41045','KY','Ghent','Carroll',38.729485,-85.028213),('41046','KY','Glencoe','Gallatin',38.717491,-84.807138),('41048','KY','Hebron','Boone',39.079652,-84.691364),('41049','KY','Hillsboro','Fleming',38.268518,-83.654374),('41051','KY','Independence','Kenton',38.946181,-84.552763),('41052','KY','Jonesville','Grant',38.656441,-84.775333),('41053','KY','Kenton','Kenton',38.8683,-84.4561),('41054','KY','Mason','Grant',38.5761,-84.5852),('41055','KY','Mayslick','Mason',38.512222,-83.8478),('41056','KY','Maysville','Mason',38.62436,-83.764622),('41059','KY','Melbourne','Campbell',39.013379,-84.351398),('41061','KY','Milford','Bracken',38.5816,-84.1566),('41062','KY','Minerva','Mason',38.70401,-83.92284),('41063','KY','Morning View','Kenton',38.847406,-84.48682),('41064','KY','Mount Olivet','Robertson',38.51336,-84.047537),('41065','KY','Muses Mills','Fleming',38.35,-83.5272),('41071','KY','Newport','Campbell',39.084286,-84.487102),('41072','KY','Newport','Campbell',39.0908,-84.4974),('41073','KY','Bellevue','Campbell',39.103047,-84.479861),('41074','KY','Dayton','Campbell',39.112016,-84.470751),('41075','KY','Fort Thomas','Campbell',39.07486,-84.451538),('41076','KY','Newport','Campbell',39.023405,-84.442811),('41080','KY','Petersburg','Boone',39.060784,-84.843027),('41081','KY','Plummers Landing','Fleming',38.3188,-83.5611),('41083','KY','Sanders','Carroll',38.682979,-84.964467),('41085','KY','Silver Grove','Campbell',39.034399,-84.39167),('41086','KY','Sparta','Gallatin',38.710961,-84.882749),('41091','KY','Union','Boone',38.934062,-84.699066),('41092','KY','Verona','Boone',38.814385,-84.688274),('41093','KY','Wallingford','Fleming',38.387403,-83.558464),('41094','KY','Walton','Boone',38.884581,-84.617749),('41095','KY','Warsaw','Gallatin',38.784835,-84.863895),('41096','KY','Washington','Mason',38.6158,-83.8086),('41097','KY','Williamstown','Grant',38.625977,-84.56813),('41098','KY','Worthville','Owen',38.594349,-85.041534),('41099','KY','Newport','Campbell',39.038896,-84.466011),('41101','KY','Ashland','Boyd',38.46978,-82.64187),('41102','KY','Ashland','Boyd',38.435751,-82.695974),('41105','KY','Ashland','Boyd',38.4801,-82.6457),('41114','KY','Ashland','Boyd',38.4801,-82.6457),('41121','KY','Argillite','Greenup',38.456682,-82.826464),('41124','KY','Blaine','Lawrence',38.029987,-82.839075),('41128','KY','Carter','Carter',38.4288,-83.1208),('41129','KY','Catlettsburg','Boyd',38.340882,-82.622603),('41132','KY','Denton','Carter',38.251582,-82.840242),('41135','KY','Emerson','Lewis',38.367445,-83.28703),('41139','KY','Flatwoods','Greenup',38.519558,-82.719622),('41141','KY','Garrison','Lewis',38.576247,-83.154255),('41142','KY','Grahn','Carter',38.285647,-83.075766),('41143','KY','Grayson','Carter',38.323179,-82.950084),('41144','KY','Greenup','Greenup',38.556995,-82.859385),('41146','KY','Hitchins','Carter',38.271989,-82.90437),('41149','KY','Isonville','Elliott',38.076145,-83.043093),('41159','KY','Martha','Lawrence',38.003345,-82.952926),('41160','KY','Mazie','Lawrence',38.0269,-82.9725),('41164','KY','Olive Hill','Carter',38.294189,-83.177066),('41166','KY','Quincy','Lewis',38.643355,-83.109081),('41168','KY','Rush','Boyd',38.321204,-82.780737),('41169','KY','Russell','Greenup',38.533431,-82.717373),('41171','KY','Sandy Hook','Elliott',38.089208,-83.094733),('41173','KY','Soldier','Carter',38.2591,-83.2994),('41174','KY','South Portsmouth','Greenup',38.709882,-83.026261),('41175','KY','South Shore','Greenup',38.686789,-82.943717),('41179','KY','Vanceburg','Lewis',38.53634,-83.3684),('41180','KY','Webbville','Lawrence',38.141939,-82.85488),('41181','KY','Willard','Carter',38.2116,-82.8972),('41183','KY','Worthington','Greenup',38.550041,-82.736276),('41189','KY','Tollesboro','Lewis',38.554411,-83.548349),('41201','KY','Adams','Lawrence',38.059285,-82.741889),('41203','KY','Beauty','Martin',37.840175,-82.434006),('41204','KY','Boons Camp','Johnson',37.821258,-82.686261),('41214','KY','Debord','Martin',37.806528,-82.590771),('41216','KY','East Point','Floyd',37.732573,-82.803369),('41219','KY','Flatgap','Johnson',37.917424,-82.894714),('41222','KY','Hagerhill','Johnson',37.777318,-82.831369),('41224','KY','Inez','Martin',37.855864,-82.544428),('41226','KY','Keaton','Johnson',37.988634,-82.954683),('41230','KY','Louisa','Lawrence',38.078179,-82.643116),('41231','KY','Lovely','Martin',37.809115,-82.395616),('41232','KY','Lowmansville','Lawrence',37.918421,-82.738852),('41234','KY','Meally','Johnson',37.796621,-82.738337),('41238','KY','Oil Springs','Johnson',37.855001,-82.946042),('41240','KY','Paintsville','Johnson',37.829471,-82.779962),('41250','KY','Pilgrim','Martin',37.741086,-82.469966),('41254','KY','River','Johnson',37.887162,-82.715358),('41255','KY','Sitka','Johnson',37.918145,-82.835955),('41256','KY','Staffordsville','Johnson',37.833874,-82.863224),('41257','KY','Stambaugh','Johnson',37.932695,-82.814249),('41260','KY','Thelma','Johnson',37.82907,-82.762443),('41262','KY','Tomahawk','Martin',37.867567,-82.603006),('41263','KY','Tutor Key','Johnson',37.844628,-82.760427),('41264','KY','Ulysses','Lawrence',37.945381,-82.673303),('41265','KY','Van Lear','Johnson',37.749386,-82.711958),('41267','KY','Warfield','Martin',37.856459,-82.418841),('41268','KY','West Van Lear','Johnson',37.78715,-82.782375),('41271','KY','Williamsport','Johnson',37.82788,-82.730735),('41274','KY','Wittensville','Johnson',37.856986,-82.810282),('41301','KY','Campton','Wolfe',37.722089,-83.513802),('41307','KY','Athol','Breathitt',37.5073,-83.3429),('41310','KY','Bays','Breathitt',37.640938,-83.244661),('41311','KY','Beattyville','Lee',37.58009,-83.698127),('41313','KY','Bethany','Wolfe',37.7458,-83.5005),('41314','KY','Booneville','Owsley',37.432505,-83.675632),('41317','KY','Clayhole','Breathitt',37.451477,-83.19005),('41332','KY','Hazel Green','Wolfe',37.791939,-83.373853),('41333','KY','Heidelberg','Lee',37.5552,-83.7788),('41338','KY','Island City','Owsley',37.3815,-83.7185),('41339','KY','Jackson','Breathitt',37.532244,-83.324445),('41347','KY','Lone','Lee',37.59,-83.7191),('41348','KY','Lost Creek','Breathitt',37.431714,-83.316413),('41351','KY','Mistletoe','Owsley',37.31,-83.5779),('41352','KY','Mize','Morgan',37.822932,-83.33029),('41360','KY','Pine Ridge','Wolfe',37.784228,-83.632374),('41362','KY','Primrose','Lee',37.6022,-83.6086),('41364','KY','Ricetown','Owsley',37.382832,-83.623275),('41365','KY','Rogers','Wolfe',37.709514,-83.636718),('41366','KY','Rousseau','Breathitt',37.6125,-83.2148),('41367','KY','Rowdy','Perry',37.423119,-83.210828),('41368','KY','Saint Helens','Lee',37.5827,-83.6472),('41385','KY','Vancleve','Breathitt',37.63523,-83.375877),('41386','KY','Vincent','Owsley',37.473347,-83.817223),('41390','KY','Whick','Breathitt',37.412679,-83.384676),('41397','KY','Zoe','Lee',37.689048,-83.673356),('41408','KY','Cannel City','Morgan',37.78975,-83.275443),('41413','KY','Crockett','Morgan',37.9855,-83.0908),('41421','KY','Elkfork','Morgan',37.985626,-83.180788),('41425','KY','Ezel','Morgan',37.88487,-83.440763),('41426','KY','Falcon','Magoffin',37.784924,-82.997836),('41433','KY','Gapville','Magoffin',37.63,-82.9591),('41451','KY','Malone','Morgan',37.8719,-83.2583),('41459','KY','Ophir','Morgan',37.9072,-83.0144),('41464','KY','Royalton','Magoffin',37.672144,-82.996682),('41465','KY','Salyersville','Magoffin',37.737331,-83.087045),('41472','KY','West Liberty','Morgan',37.9337,-83.23065),('41477','KY','Wrigley','Morgan',38.0036,-83.3266),('41501','KY','Pikeville','Pike',37.478362,-82.529937),('41502','KY','Pikeville','Pike',37.5576,-82.5108),('41503','KY','South Williamson','Pike',37.670679,-82.284759),('41512','KY','Ashcamp','Pike',37.251328,-82.483868),('41513','KY','Belcher','Pike',37.364686,-82.345047),('41514','KY','Belfry','Pike',37.650745,-82.297128),('41517','KY','Burdine','Letcher',37.192205,-82.596584),('41519','KY','Canada','Pike',37.597671,-82.327995),('41520','KY','Dorton','Pike',37.2766,-82.5791),('41522','KY','Elkhorn City','Pike',37.311224,-82.391732),('41524','KY','Fedscreek','Pike',37.401893,-82.245811),('41526','KY','Fords Branch','Pike',37.432884,-82.509153),('41527','KY','Forest Hills','Pike',37.641701,-82.276891),('41528','KY','Freeburn','Pike',37.559039,-82.147825),('41531','KY','Hardy','Pike',37.610731,-82.233108),('41534','KY','Hellier','Pike',37.274323,-82.487285),('41535','KY','Huddy','Pike',37.598319,-82.276584),('41537','KY','Jenkins','Letcher',37.205472,-82.623564),('41538','KY','Jonancy','Pike',37.315047,-82.58828),('41539','KY','Kimper','Pike',37.498686,-82.346107),('41540','KY','Lick Creek','Pike',37.388137,-82.326361),('41542','KY','Lookout','Pike',37.3133,-82.4669),('41543','KY','Mc Andrews','Pike',37.564312,-82.27267),('41544','KY','Mc Carr','Pike',37.608745,-82.170177),('41547','KY','Majestic','Pike',37.551956,-82.102976),('41548','KY','Mouthcard','Pike',37.373801,-82.249808),('41549','KY','Myra','Pike',37.293386,-82.600198),('41553','KY','Phelps','Pike',37.503576,-82.16054),('41554','KY','Phyllis','Pike',37.44934,-82.322298),('41555','KY','Pinsonfork','Pike',37.541739,-82.257923),('41557','KY','Raccoon','Pike',37.50458,-82.450119),('41558','KY','Ransom','Pike',37.536486,-82.210155),('41559','KY','Regina','Pike',37.369129,-82.402626),('41560','KY','Robinson Creek','Pike',37.400209,-82.56504),('41561','KY','Rockhouse','Pike',37.3269,-82.4525),('41562','KY','Shelbiana','Pike',37.418532,-82.465068),('41563','KY','Shelby Gap','Pike',37.232191,-82.536631),('41564','KY','Sidney','Pike',37.61397,-82.358297),('41566','KY','Steele','Pike',37.399057,-82.208709),('41567','KY','Stone','Pike',37.576514,-82.278018),('41568','KY','Stopover','Pike',37.500757,-82.06141),('41571','KY','Varney','Pike',37.63555,-82.44636),('41572','KY','Virgie','Pike',37.322342,-82.619259),('41601','KY','Allen','Floyd',37.613907,-82.724189),('41602','KY','Auxier','Floyd',37.736429,-82.751902),('41603','KY','Banner','Floyd',37.572381,-82.695618),('41604','KY','Beaver','Floyd',37.383718,-82.660797),('41605','KY','Betsy Layne','Floyd',37.553656,-82.632051),('41606','KY','Bevinsville','Floyd',37.360906,-82.727836),('41607','KY','Blue River','Floyd',37.633962,-82.835022),('41612','KY','Bypro','Floyd',37.359683,-82.724647),('41615','KY','Dana','Floyd',37.549305,-82.691134),('41616','KY','David','Floyd',37.588647,-82.869113),('41619','KY','Drift','Floyd',37.485465,-82.75383),('41621','KY','Dwale','Floyd',37.623154,-82.72688),('41622','KY','Eastern','Floyd',37.516407,-82.808452),('41630','KY','Garrett','Floyd',37.470307,-82.858483),('41631','KY','Grethel','Floyd',37.47352,-82.655341),('41632','KY','Gunlock','Magoffin',37.564418,-82.926997),('41635','KY','Harold','Floyd',37.509466,-82.634576),('41636','KY','Hi Hat','Floyd',37.387218,-82.728581),('41640','KY','Hueysville','Floyd',37.480577,-82.909741),('41642','KY','Ivel','Floyd',37.586262,-82.660475);
INSERT INTO `zipcode` VALUES ('41643','KY','Lackey','Knott',37.459416,-82.838933),('41645','KY','Langley','Floyd',37.535105,-82.790411),('41647','KY','Mc Dowell','Floyd',37.451388,-82.727765),('41649','KY','Martin','Floyd',37.569206,-82.763401),('41650','KY','Melvin','Floyd',37.351309,-82.693392),('41651','KY','Minnie','Floyd',37.465744,-82.754929),('41653','KY','Prestonsburg','Floyd',37.667947,-82.758695),('41655','KY','Printer','Floyd',37.510702,-82.720036),('41659','KY','Stanville','Floyd',37.566108,-82.64035),('41660','KY','Teaberry','Floyd',37.428164,-82.643612),('41663','KY','Tram','Floyd',37.572207,-82.652349),('41666','KY','Wayland','Floyd',37.446472,-82.807096),('41667','KY','Weeksbury','Floyd',37.308041,-82.702288),('41669','KY','Wheelwright','Floyd',37.331773,-82.718746),('41701','KY','Hazard','Perry',37.275137,-83.19251),('41702','KY','Hazard','Perry',37.2494,-83.1933),('41712','KY','Ary','Perry',37.369556,-83.133329),('41713','KY','Avawam','Perry',37.219635,-83.275962),('41714','KY','Bear Branch','Leslie',37.16637,-83.521024),('41719','KY','Bonnyman','Perry',37.295824,-83.24732),('41721','KY','Buckhorn','Perry',37.324568,-83.492022),('41722','KY','Bulan','Perry',37.34898,-83.113139),('41723','KY','Busy','Perry',37.275585,-83.312138),('41725','KY','Carrie','Knott',37.333677,-83.042197),('41727','KY','Chavies','Perry',37.380844,-83.292686),('41729','KY','Combs','Perry',37.265154,-83.214484),('41731','KY','Cornettsville','Perry',37.114108,-83.07571),('41735','KY','Delphia','Perry',37.035743,-83.096846),('41736','KY','Dice','Perry',37.370521,-83.237149),('41739','KY','Dwarf','Perry',37.336884,-83.128264),('41740','KY','Emmalena','Knott',37.359264,-83.050502),('41743','KY','Fisty','Knott',37.3935,-83.1303),('41745','KY','Gays Creek','Perry',37.331712,-83.435045),('41746','KY','Happy','Perry',37.214632,-83.095753),('41747','KY','Hardburly','Perry',37.2425,-83.2039),('41749','KY','Hyden','Leslie',37.191942,-83.396252),('41751','KY','Jeff','Perry',37.208771,-83.133212),('41754','KY','Krypton','Perry',37.30138,-83.320849),('41759','KY','Sassafras','Knott',37.224009,-83.043434),('41760','KY','Scuddy','Perry',37.204821,-83.082568),('41762','KY','Sizerock','Leslie',37.262208,-83.480421),('41763','KY','Slemp','Perry',37.047105,-83.136317),('41764','KY','Smilax','Leslie',37.116657,-83.254014),('41766','KY','Thousandsticks','Leslie',37.179942,-83.465633),('41772','KY','Vest','Knott',37.427431,-83.068722),('41773','KY','Vicco','Perry',37.211328,-83.03793),('41774','KY','Viper','Perry',37.16389,-83.136861),('41775','KY','Wendover','Leslie',37.103557,-83.339427),('41776','KY','Wooton','Leslie',37.154291,-83.29503),('41777','KY','Yeaddiss','Leslie',37.069733,-83.229062),('41778','KY','Yerkes','Perry',37.279297,-83.318704),('41804','KY','Blackey','Letcher',37.140154,-82.987998),('41810','KY','Cromona','Letcher',37.183382,-82.690666),('41812','KY','Deane','Letcher',37.241229,-82.749061),('41815','KY','Ermine','Letcher',37.14739,-82.795011),('41817','KY','Garner','Knott',37.364304,-82.927355),('41819','KY','Gordon','Letcher',36.986332,-83.062723),('41821','KY','Hallie','Letcher',37.091804,-83.01338),('41822','KY','Hindman','Knott',37.33051,-82.987955),('41824','KY','Isom','Letcher',37.194545,-82.886382),('41825','KY','Jackhorn','Letcher',37.217014,-82.703191),('41826','KY','Jeremiah','Letcher',37.172591,-82.923336),('41828','KY','Kite','Knott',37.310832,-82.789091),('41831','KY','Leburn','Knott',37.393515,-82.959855),('41832','KY','Letcher','Letcher',37.147531,-82.96006),('41833','KY','Linefork','Letcher',37.025999,-82.985771),('41834','KY','Littcarr','Knott',37.233902,-82.954984),('41835','KY','Mc Roberts','Letcher',37.205673,-82.673817),('41836','KY','Mallie','Knott',37.259038,-82.908548),('41837','KY','Mayking','Letcher',37.136943,-82.761875),('41838','KY','Millstone','Letcher',37.168269,-82.749775),('41839','KY','Mousie','Knott',37.40332,-82.89402),('41840','KY','Neon','Letcher',37.192813,-82.712953),('41843','KY','Pine Top','Knott',37.273252,-82.87214),('41844','KY','Pippa Passes','Knott',37.335525,-82.870741),('41845','KY','Premium','Letcher',37.129368,-82.913581),('41847','KY','Redfox','Knott',37.215771,-82.954556),('41848','KY','Roxana','Letcher',37.110184,-82.950903),('41849','KY','Seco','Letcher',37.173565,-82.730152),('41855','KY','Thornton','Letcher',37.17394,-82.768864),('41858','KY','Whitesburg','Letcher',37.127216,-82.838274),('41859','KY','Dema','Knott',37.400393,-82.786802),('41861','KY','Raven','Knott',37.401272,-82.809173),('41862','KY','Topmost','Knott',37.35833,-82.796947),('42001','KY','Paducah','Mccracken',37.065637,-88.662782),('42002','KY','Paducah','Mccracken',37.0351,-88.7183),('42003','KY','Paducah','Mccracken',37.037926,-88.591413),('42020','KY','Almo','Calloway',36.689318,-88.294998),('42021','KY','Arlington','Carlisle',36.797878,-89.014918),('42022','KY','Bandana','Ballard',37.144988,-88.944769),('42023','KY','Bardwell','Carlisle',36.884298,-88.982837),('42024','KY','Barlow','Ballard',37.057072,-89.046102),('42025','KY','Benton','Marshall',36.859674,-88.334676),('42027','KY','Boaz','Graves',36.920297,-88.636825),('42028','KY','Burna','Livingston',37.224822,-88.350139),('42029','KY','Calvert City','Marshall',37.014028,-88.369081),('42031','KY','Clinton','Hickman',36.672553,-88.986302),('42032','KY','Columbus','Hickman',36.76318,-89.106166),('42033','KY','Crayne','Crittenden',37.2705,-88.0825),('42035','KY','Cunningham','Carlisle',36.910185,-88.851174),('42036','KY','Dexter','Calloway',36.735598,-88.24458),('42037','KY','Dycusburg','Crittenden',37.334,-88.0788),('42038','KY','Eddyville','Lyon',37.054604,-88.039275),('42039','KY','Fancy Farm','Graves',36.788709,-88.825434),('42040','KY','Farmington','Graves',36.625296,-88.497073),('42041','KY','Fulton','Fulton',36.527498,-88.888384),('42044','KY','Gilbertsville','Marshall',36.978186,-88.275304),('42045','KY','Grand Rivers','Livingston',37.033125,-88.245009),('42047','KY','Hampton','Livingston',37.279141,-88.378811),('42048','KY','Hardin','Marshall',36.769237,-88.24016),('42049','KY','Hazel','Calloway',36.516315,-88.348773),('42050','KY','Hickman','Fulton',36.55212,-89.204866),('42051','KY','Hickory','Graves',36.851759,-88.638431),('42053','KY','Kevil','Mccracken',37.105155,-88.863796),('42054','KY','Kirksey','Calloway',36.71648,-88.44698),('42055','KY','Kuttawa','Lyon',37.060186,-88.144541),('42056','KY','La Center','Ballard',37.090869,-88.987377),('42058','KY','Ledbetter','Livingston',37.051893,-88.482912),('42060','KY','Lovelaceville','Ballard',36.968911,-88.828729),('42061','KY','Lowes','Graves',36.883562,-88.772631),('42063','KY','Lynnville','Graves',36.5602,-88.5691),('42064','KY','Marion','Crittenden',37.334033,-88.083469),('42066','KY','Mayfield','Graves',36.735015,-88.628872),('42069','KY','Melber','Graves',36.918791,-88.756493),('42070','KY','Milburn','Carlisle',36.7986,-88.8997),('42071','KY','Murray','Calloway',36.614797,-88.291538),('42076','KY','New Concord','Calloway',36.557512,-88.092705),('42078','KY','Salem','Livingston',37.276396,-88.250914),('42079','KY','Sedalia','Graves',36.567762,-88.588811),('42081','KY','Smithland','Livingston',37.198855,-88.404734),('42082','KY','Symsonia','Graves',36.922865,-88.493257),('42083','KY','Tiline','Livingston',37.161098,-88.287818),('42084','KY','Tolu','Crittenden',37.4332,-88.244989),('42085','KY','Water Valley','Graves',36.568579,-88.812203),('42086','KY','West Paducah','Mccracken',37.088547,-88.771835),('42087','KY','Wickliffe','Ballard',36.972013,-89.045119),('42088','KY','Wingo','Graves',36.621991,-88.753918),('42101','KY','Bowling Green','Warren',37.011342,-86.460903),('42102','KY','Bowling Green','Warren',37.003731,-86.418234),('42103','KY','Bowling Green','Warren',36.968931,-86.393468),('42104','KY','Bowling Green','Warren',36.92979,-86.448259),('42120','KY','Adolphus','Allen',36.668318,-86.252283),('42122','KY','Alvaton','Warren',36.885389,-86.366074),('42123','KY','Austin','Barren',36.820844,-86.000351),('42124','KY','Beaumont','Metcalfe',36.87026,-85.64209),('42127','KY','Cave City','Barren',37.128781,-85.947311),('42128','KY','Drake','Warren',36.8361,-86.4097),('42129','KY','Edmonton','Metcalfe',36.996801,-85.603021),('42130','KY','Eighty Eight','Barren',36.925865,-85.786306),('42131','KY','Etoile','Barren',36.82928,-85.908062),('42133','KY','Fountain Run','Monroe',36.722179,-85.968704),('42134','KY','Franklin','Simpson',36.719031,-86.574298),('42135','KY','Franklin','Simpson',36.713,-86.5765),('42140','KY','Gamaliel','Monroe',36.648811,-85.807638),('42141','KY','Glasgow','Barren',36.969294,-85.917924),('42142','KY','Glasgow','Barren',36.9974,-85.9076),('42151','KY','Hestand','Monroe',36.635478,-85.561308),('42152','KY','Hiseville','Barren',37.1008,-85.8125),('42153','KY','Holland','Allen',36.662368,-86.066301),('42154','KY','Knob Lick','Metcalfe',37.062715,-85.734622),('42156','KY','Lucas','Barren',36.854847,-86.054908),('42157','KY','Mount Hermon','Monroe',36.792663,-85.828394),('42159','KY','Oakland','Warren',37.007603,-86.245193),('42160','KY','Park City','Barren',37.072762,-86.064972),('42163','KY','Rocky Hill','Edmonson',37.07906,-86.134145),('42164','KY','Scottsville','Allen',36.776548,-86.17403),('42166','KY','Summer Shade','Metcalfe',36.879116,-85.712171),('42167','KY','Tompkinsville','Monroe',36.711814,-85.671086),('42170','KY','Woodburn','Warren',36.842943,-86.550019),('42171','KY','Smiths Grove','Warren',37.042176,-86.172711),('42201','KY','Aberdeen','Butler',37.2538,-86.6816),('42202','KY','Adairville','Logan',36.681265,-86.853713),('42204','KY','Allensville','Todd',36.709569,-87.068962),('42206','KY','Auburn','Logan',36.882165,-86.719646),('42207','KY','Bee Spring','Edmonson',37.315627,-86.251508),('42210','KY','Brownsville','Edmonson',37.206664,-86.252301),('42211','KY','Cadiz','Trigg',36.834632,-87.859622),('42214','KY','Center','Metcalfe',37.138077,-85.683348),('42215','KY','Cerulean','Christian',36.98034,-87.684524),('42216','KY','Clifty','Todd',36.9952,-87.1477),('42217','KY','Crofton','Christian',37.048885,-87.455943),('42219','KY','Dunbar','Butler',37.188,-86.7569),('42220','KY','Elkton','Todd',36.883052,-87.188053),('42221','KY','Fairview','Christian',36.8433,-87.3038),('42223','KY','Fort Campbell','Christian',36.634845,-87.457125),('42232','KY','Gracey','Christian',36.855418,-87.66123),('42234','KY','Guthrie','Todd',36.674339,-87.178702),('42236','KY','Herndon','Christian',36.716286,-87.614237),('42240','KY','Hopkinsville','Christian',36.864658,-87.477902),('42241','KY','Hopkinsville','Christian',36.8655,-87.4886),('42252','KY','Jetson','Butler',37.2209,-86.5054),('42254','KY','La Fayette','Christian',36.650655,-87.647395),('42256','KY','Lewisburg','Logan',37.027791,-86.9503),('42259','KY','Mammoth Cave','Edmonson',37.277769,-86.177059),('42261','KY','Morgantown','Butler',37.216538,-86.684522),('42262','KY','Oak Grove','Christian',36.668066,-87.41739),('42265','KY','Olmstead','Logan',36.739223,-87.004306),('42266','KY','Pembroke','Christian',36.771869,-87.354516),('42273','KY','Rochester','Butler',37.214278,-86.86796),('42274','KY','Rockfield','Warren',36.942773,-86.610628),('42275','KY','Roundhill','Butler',37.21922,-86.443665),('42276','KY','Russellville','Logan',36.861117,-86.888044),('42280','KY','Sharon Grove','Todd',36.941119,-87.094442),('42283','KY','South Union','Logan',36.8763,-86.6563),('42285','KY','Sweeden','Edmonson',37.265403,-86.27078),('42286','KY','Trenton','Todd',36.730766,-87.272865),('42287','KY','Welchs Creek','Butler',37.311676,-86.529139),('42288','KY','Woodbury','Butler',37.1833,-86.6338),('42301','KY','Owensboro','Daviess',37.756788,-87.17051),('42302','KY','Owensboro','Daviess',37.7741,-87.1133),('42303','KY','Owensboro','Daviess',37.754405,-87.081421),('42304','KY','Owensboro','Daviess',37.7741,-87.1133),('42320','KY','Beaver Dam','Ohio',37.377116,-86.883729),('42321','KY','Beech Creek','Muhlenberg',37.175741,-87.058133),('42322','KY','Beech Grove','Mclean',37.5394,-87.2584),('42323','KY','Beechmont','Muhlenberg',37.176164,-87.034063),('42324','KY','Belton','Muhlenberg',37.12122,-87.023178),('42325','KY','Bremen','Muhlenberg',37.332046,-87.274361),('42326','KY','Browder','Muhlenberg',37.227289,-87.013341),('42327','KY','Calhoun','Mclean',37.578772,-87.283287),('42328','KY','Centertown','Ohio',37.410572,-87.034119),('42330','KY','Central City','Muhlenberg',37.306125,-87.122229),('42332','KY','Cleaton','Muhlenberg',37.251321,-87.089313),('42333','KY','Cromwell','Ohio',37.350547,-86.767761),('42334','KY','Curdsville','Daviess',37.735,-87.3316),('42337','KY','Drakesboro','Muhlenberg',37.248173,-87.026609),('42338','KY','Dundee','Ohio',37.559325,-86.772533),('42339','KY','Dunmor','Muhlenberg',37.10343,-86.946018),('42343','KY','Fordsville','Ohio',37.639981,-86.693576),('42344','KY','Graham','Muhlenberg',37.255415,-87.311827),('42345','KY','Greenville','Muhlenberg',37.165719,-87.179963),('42347','KY','Hartford','Ohio',37.495741,-86.885153),('42348','KY','Hawesville','Hancock',37.878751,-86.763442),('42349','KY','Horse Branch','Ohio',37.434515,-86.66933),('42350','KY','Island','Mclean',37.445756,-87.160524),('42351','KY','Lewisport','Hancock',37.918616,-86.892462),('42352','KY','Livermore','Mclean',37.506856,-87.116189),('42354','KY','Mc Henry','Ohio',37.379489,-86.925961),('42355','KY','Maceo','Daviess',37.857206,-86.993126),('42356','KY','Maple Mount','Daviess',37.692313,-87.323845),('42361','KY','Olaton','Ohio',37.517166,-86.683941),('42364','KY','Pellville','Hancock',37.7522,-86.8136),('42366','KY','Philpot','Daviess',37.724233,-86.954649),('42367','KY','Powderly','Muhlenberg',37.239421,-87.159905),('42368','KY','Reynolds Station','Ohio',37.700677,-86.753317),('42369','KY','Rockport','Ohio',37.337877,-86.999691),('42370','KY','Rosine','Ohio',37.44962,-86.739814),('42371','KY','Rumsey','Mclean',37.494971,-87.285968),('42372','KY','Sacramento','Mclean',37.404737,-87.277907),('42374','KY','South Carrollton','Muhlenberg',37.334773,-87.142305),('42375','KY','Stanley','Daviess',37.8233,-87.2438),('42376','KY','Utica','Daviess',37.60579,-87.076719),('42377','KY','West Louisville','Daviess',37.6966,-87.2869),('42378','KY','Whitesville','Daviess',37.667286,-86.863261),('42402','KY','Baskett','Henderson',37.7879,-87.5078),('42403','KY','Blackford','Webster',37.448198,-87.933912),('42404','KY','Clay','Webster',37.474356,-87.838413),('42406','KY','Corydon','Henderson',37.741668,-87.714092),('42408','KY','Dawson Springs','Hopkins',37.17642,-87.684506),('42409','KY','Dixon','Webster',37.538637,-87.692934),('42410','KY','Earlington','Hopkins',37.274228,-87.514222),('42411','KY','Fredonia','Caldwell',37.215525,-88.015967),('42413','KY','Hanson','Hopkins',37.433898,-87.483507),('42419','KY','Henderson','Henderson',37.7879,-87.5078),('42420','KY','Henderson','Henderson',37.825212,-87.556031),('42431','KY','Madisonville','Hopkins',37.327715,-87.499815),('42436','KY','Manitou','Hopkins',37.413274,-87.574819),('42437','KY','Morganfield','Union',37.676149,-87.907974),('42440','KY','Mortons Gap','Hopkins',37.240867,-87.470134),('42441','KY','Nebo','Hopkins',37.360691,-87.66645),('42442','KY','Nortonville','Hopkins',37.179498,-87.464516),('42444','KY','Poole','Webster',37.641689,-87.637866),('42445','KY','Princeton','Caldwell',37.122077,-87.875585),('42450','KY','Providence','Webster',37.398623,-87.760712),('42451','KY','Reed','Henderson',37.876199,-87.384383),('42452','KY','Robards','Henderson',37.680131,-87.537665),('42453','KY','Saint Charles','Hopkins',37.177942,-87.595404),('42455','KY','Sebree','Webster',37.599504,-87.525392),('42456','KY','Slaughters','Webster',37.511082,-87.488832),('42457','KY','Smith Mills','Henderson',37.801347,-87.765868),('42458','KY','Spottsville','Henderson',37.849544,-87.420279),('42459','KY','Sturgis','Union',37.551088,-87.989719),('42460','KY','Sullivan','Union',37.4975,-87.9452),('42461','KY','Uniontown','Union',37.777483,-87.924979),('42462','KY','Waverly','Union',37.733998,-87.800244),('42463','KY','Wheatcroft','Webster',37.487692,-87.86426),('42464','KY','White Plains','Hopkins',37.185394,-87.383064),('42501','KY','Somerset','Pulaski',37.05571,-84.556109),('42502','KY','Somerset','Pulaski',37.0944,-84.6043),('42503','KY','Somerset','Pulaski',37.105218,-84.590726),('42516','KY','Bethelridge','Casey',37.222156,-84.786027),('42518','KY','Bronston','Pulaski',36.952799,-84.624781),('42519','KY','Burnside','Pulaski',36.964934,-84.554567),('42528','KY','Dunnville','Casey',37.196943,-85.012787),('42533','KY','Ferguson','Pulaski',37.066355,-84.599858),('42539','KY','Liberty','Casey',37.301646,-84.947839),('42541','KY','Middleburg','Casey',37.375916,-84.79734),('42544','KY','Nancy','Pulaski',37.023144,-84.803472),('42553','KY','Science Hill','Pulaski',37.177797,-84.667534),('42558','KY','Tateville','Pulaski',36.9763,-84.4042),('42564','KY','West Somerset','Pulaski',37.0944,-84.6043),('42565','KY','Windsor','Casey',37.142413,-84.906452),('42566','KY','Yosemite','Casey',37.295552,-84.802273),('42567','KY','Eubank','Pulaski',37.264571,-84.616391),('42602','KY','Albany','Clinton',36.718811,-85.134673),('42603','KY','Alpha','Clinton',36.77246,-85.019054),('42629','KY','Jamestown','Russell',36.945592,-85.100658),('42631','KY','Marshes Siding','Mccreary',36.762748,-84.510367),('42633','KY','Monticello','Wayne',36.812643,-84.848498),('42634','KY','Parkers Lake','Mccreary',36.861918,-84.434973),('42635','KY','Pine Knot','Mccreary',36.66225,-84.417737),('42638','KY','Revelo','Mccreary',36.674414,-84.47046),('42642','KY','Russell Springs','Russell',37.052892,-85.052919),('42647','KY','Stearns','Mccreary',36.713492,-84.563889),('42649','KY','Strunk','Mccreary',36.628246,-84.422351),('42653','KY','Whitley City','Mccreary',36.773694,-84.466589),('42701','KY','Elizabethtown','Hardin',37.705971,-85.859677),('42702','KY','Elizabethtown','Hardin',37.6938,-85.8591),('42712','KY','Big Clifty','Grayson',37.556562,-86.150848),('42713','KY','Bonnieville','Hart',37.376875,-85.889333),('42715','KY','Breeding','Adair',36.94691,-85.408888),('42716','KY','Buffalo','Larue',37.480447,-85.612147),('42717','KY','Burkesville','Cumberland',36.770538,-85.38383),('42718','KY','Campbellsville','Taylor',37.362918,-85.35873),('42719','KY','Campbellsville','Taylor',37.3418,-85.3428),('42720','KY','Cane Valley','Adair',37.1802,-85.3197),('42721','KY','Caneyville','Grayson',37.412778,-86.502389),('42722','KY','Canmer','Hart',37.276586,-85.716132),('42724','KY','Cecilia','Hardin',37.653626,-86.008287),('42726','KY','Clarkson','Grayson',37.421163,-86.171734),('42728','KY','Columbia','Adair',37.117103,-85.289858),('42729','KY','Cub Run','Hart',37.305624,-86.130778),('42731','KY','Dubre','Cumberland',36.843265,-85.547235),('42732','KY','Eastview','Hardin',37.59796,-86.094283),('42733','KY','Elk Horn','Taylor',37.33439,-85.174377),('42740','KY','Glendale','Hardin',37.595007,-85.921341),('42741','KY','Glens Fork','Adair',36.999228,-85.238426),('42742','KY','Gradyville','Adair',37.098391,-85.501991),('42743','KY','Greensburg','Green',37.233431,-85.522501),('42746','KY','Hardyville','Hart',37.212381,-85.732393),('42748','KY','Hodgenville','Larue',37.566147,-85.71546),('42749','KY','Horse Cave','Hart',37.182856,-85.888672),('42753','KY','Knifley','Adair',37.226153,-85.19137),('42754','KY','Leitchfield','Grayson',37.47899,-86.303589),('42755','KY','Leitchfield','Grayson',37.4784,-86.2943),('42757','KY','Magnolia','Hart',37.416592,-85.717038),('42758','KY','Mannsville','Taylor',37.371997,-85.196612),('42759','KY','Marrowbone','Cumberland',36.824961,-85.50481),('42762','KY','Millwood','Grayson',37.449066,-86.401012),('42764','KY','Mount Sherman','Green',37.44418,-85.627542),('42765','KY','Munfordville','Hart',37.293232,-85.906916),('42776','KY','Sonora','Hardin',37.522704,-85.893607),('42782','KY','Summersville','Green',37.349104,-85.643583),('42784','KY','Upton','Hardin',37.455561,-85.910799),('42788','KY','White Mills','Hardin',37.537422,-86.041504),('43001','OH','Alexandria','Licking',40.093218,-82.613228),('43002','OH','Amlin','Franklin',40.059282,-83.173155),('43003','OH','Ashley','Delaware',40.41354,-82.969322),('43004','OH','Blacklick','Franklin',40.00402,-82.797361),('43005','OH','Bladensburg','Knox',40.284132,-82.282369),('43006','OH','Brinkhaven','Holmes',40.469985,-82.162289),('43007','OH','Broadway','Union',40.3411,-83.4122),('43008','OH','Buckeye Lake','Licking',39.934497,-82.480854),('43009','OH','Cable','Champaign',40.171656,-83.638061),('43010','OH','Catawba','Clark',40.00001,-83.621105),('43011','OH','Centerburg','Knox',40.302997,-82.679662),('43013','OH','Croton','Licking',40.236254,-82.687643),('43014','OH','Danville','Knox',40.466759,-82.262514),('43015','OH','Delaware','Delaware',40.29117,-83.069328),('43016','OH','Dublin','Franklin',40.09746,-83.150103),('43017','OH','Dublin','Franklin',40.112902,-83.127778),('43018','OH','Etna','Licking',39.956994,-82.683072),('43019','OH','Fredericktown','Knox',40.490834,-82.558922),('43021','OH','Galena','Delaware',40.207298,-82.902203),('43022','OH','Gambier','Knox',40.349527,-82.354809),('43023','OH','Granville','Licking',40.067574,-82.524362),('43025','OH','Hebron','Licking',39.957493,-82.508685),('43026','OH','Hilliard','Franklin',40.02246,-83.157885),('43027','OH','Homer','Licking',40.2527,-82.5197),('43028','OH','Howard','Knox',40.411193,-82.313468),('43029','OH','Irwin','Madison',40.112517,-83.475274),('43030','OH','Jacksontown','Licking',39.959759,-82.415578),('43031','OH','Johnstown','Licking',40.154019,-82.669515),('43032','OH','Kilbourne','Delaware',40.328644,-82.958097),('43033','OH','Kirkersville','Licking',39.960574,-82.597648),('43035','OH','Lewis Center','Delaware',40.174772,-83.0026),('43036','OH','Magnetic Springs','Union',40.352893,-83.262153),('43037','OH','Martinsburg','Knox',40.275324,-82.344001),('43040','OH','Marysville','Union',40.253876,-83.368568),('43041','OH','Marysville','Union',40.2363,-83.3672),('43044','OH','Mechanicsburg','Champaign',40.059141,-83.567777),('43045','OH','Milford Center','Union',40.176473,-83.440007),('43046','OH','Millersport','Fairfield',39.902046,-82.536091),('43047','OH','Mingo','Champaign',40.208,-83.6383),('43048','OH','Mount Liberty','Knox',40.3466,-82.6302),('43050','OH','Mount Vernon','Knox',40.385096,-82.488149),('43054','OH','New Albany','Franklin',40.084936,-82.819189),('43055','OH','Newark','Licking',40.081092,-82.399407),('43056','OH','Heath','Licking',40.016575,-82.372926),('43058','OH','Newark','Licking',40.1189,-82.3524),('43060','OH','North Lewisburg','Champaign',40.222848,-83.558345),('43061','OH','Ostrander','Delaware',40.280525,-83.204499),('43062','OH','Pataskala','Licking',39.993891,-82.678682),('43064','OH','Plain City','Madison',40.114273,-83.264018),('43065','OH','Powell','Delaware',40.161923,-83.08793),('43066','OH','Radnor','Delaware',40.402576,-83.172895),('43067','OH','Raymond','Union',40.347413,-83.46431),('43068','OH','Reynoldsburg','Franklin',39.957428,-82.790142),('43069','OH','Reynoldsburg','Franklin',39.9872,-82.7737),('43070','OH','Rosewood','Champaign',40.218089,-83.959009),('43071','OH','Saint Louisville','Licking',40.183211,-82.372472),('43072','OH','Saint Paris','Champaign',40.119674,-83.956704),('43073','OH','Summit Station','Licking',40.058,-82.6875),('43074','OH','Sunbury','Delaware',40.26952,-82.850663),('43076','OH','Thornville','Perry',39.913432,-82.40988),('43077','OH','Unionville Center','Union',40.13705,-83.341267),('43078','OH','Urbana','Champaign',40.110483,-83.764054),('43080','OH','Utica','Licking',40.235968,-82.432864),('43081','OH','Westerville','Franklin',40.107869,-82.902745),('43082','OH','Westerville','Delaware',40.150797,-82.914789),('43083','OH','Westville','Champaign',40.1094,-83.838),('43084','OH','Woodstock','Champaign',40.16687,-83.535825),('43085','OH','Columbus','Franklin',40.098167,-83.016045),('43086','OH','Westerville','Franklin',40.1195,-82.9292),('43093','OH','Newark','Licking',40.1189,-82.3524),('43098','OH','Hebron','Licking',39.9664,-82.4904),('43101','OH','Adelphi','Ross',39.46604,-82.746394),('43102','OH','Amanda','Fairfield',39.648364,-82.758147),('43103','OH','Ashville','Pickaway',39.719048,-82.952035),('43105','OH','Baltimore','Fairfield',39.860175,-82.61358),('43106','OH','Bloomingburg','Fayette',39.624981,-83.402829),('43107','OH','Bremen','Fairfield',39.701018,-82.418319),('43109','OH','Brice','Franklin',39.916577,-82.833428),('43110','OH','Canal Winchester','Franklin',39.858472,-82.813521),('43111','OH','Carbon Hill','Hocking',39.502068,-82.242711),('43112','OH','Carroll','Fairfield',39.801543,-82.706816),('43113','OH','Circleville','Pickaway',39.597883,-82.945571),('43115','OH','Clarksburg','Ross',39.502984,-83.162577),('43116','OH','Commercial Point','Pickaway',39.77097,-83.059346),('43117','OH','Derby','Pickaway',39.7686,-83.2058),('43119','OH','Galloway','Franklin',39.937044,-83.178249),('43123','OH','Grove City','Franklin',39.877515,-83.07407),('43125','OH','Groveport','Franklin',39.857074,-82.890333),('43126','OH','Harrisburg','Franklin',39.810667,-83.170239),('43127','OH','Haydenville','Hocking',39.478589,-82.32662),('43128','OH','Jeffersonville','Fayette',39.637267,-83.584484),('43130','OH','Lancaster','Fairfield',39.714245,-82.607968),('43135','OH','Laurelville','Hocking',39.463708,-82.704786),('43136','OH','Lithopolis','Fairfield',39.801825,-82.809457),('43137','OH','Lockbourne','Pickaway',39.824098,-82.981083),('43138','OH','Logan','Hocking',39.531255,-82.409394),('43140','OH','London','Madison',39.900929,-83.438815),('43142','OH','Milledgeville','Fayette',39.593231,-83.587701),('43143','OH','Mount Sterling','Madison',39.716403,-83.276202),('43144','OH','Murray City','Hocking',39.514235,-82.171907),('43145','OH','New Holland','Pickaway',39.56161,-83.26273),('43146','OH','Orient','Pickaway',39.784969,-83.14557),('43147','OH','Pickerington','Fairfield',39.899293,-82.759225),('43148','OH','Pleasantville','Fairfield',39.814373,-82.51091),('43149','OH','Rockbridge','Hocking',39.547674,-82.563068),('43150','OH','Rushville','Fairfield',39.776448,-82.41454),('43151','OH','Sedalia','Madison',39.732867,-83.476236),('43152','OH','South Bloomingville','Hocking',39.389652,-82.623917),('43153','OH','South Solon','Madison',39.722927,-83.55825),('43154','OH','Stoutsville','Fairfield',39.606803,-82.826064),('43155','OH','Sugar Grove','Fairfield',39.628651,-82.51482),('43156','OH','Tarlton','Pickaway',39.555323,-82.777512),('43157','OH','Thurston','Fairfield',39.841294,-82.545839),('43158','OH','Union Furnace','Hocking',39.45601,-82.357381),('43160','OH','Washington Court House','Fayette',39.536577,-83.438254),('43162','OH','West Jefferson','Madison',39.940672,-83.289547),('43163','OH','West Rushville','Fairfield',39.7638,-82.4475),('43164','OH','Williamsport','Pickaway',39.599221,-83.12059),('43194','OH','Lockbourne','Pickaway',39.810679,-82.970037),('43195','OH','Groveport','Franklin',39.8614,-82.8916),('43196','OH','Groveport','Franklin',39.8614,-82.8916),('43198','OH','Groveport','Franklin',39.8614,-82.8916),('43199','OH','Groveport','Franklin',39.8534,-82.8944),('43201','OH','Columbus','Franklin',39.990881,-83.00116),('43202','OH','Columbus','Franklin',40.018825,-83.009607),('43203','OH','Columbus','Franklin',39.972442,-82.970127),('43204','OH','Columbus','Franklin',39.961292,-83.081964),('43205','OH','Columbus','Franklin',39.957322,-82.965975),('43206','OH','Columbus','Franklin',39.944477,-82.981077),('43207','OH','Columbus','Franklin',39.897719,-82.969732),('43209','OH','Columbus','Franklin',39.957499,-82.928446),('43210','OH','Columbus','Franklin',40.005435,-83.023227),('43211','OH','Columbus','Franklin',40.01265,-82.971157),('43212','OH','Columbus','Franklin',39.98719,-83.040021),('43213','OH','Columbus','Franklin',39.967792,-82.871341),('43214','OH','Columbus','Franklin',40.053006,-83.018863),('43215','OH','Columbus','Franklin',39.966171,-83.00566),('43216','OH','Columbus','Franklin',39.9611,-82.9988),('43217','OH','Columbus','Franklin',39.822396,-82.939912),('43218','OH','Columbus','Franklin',39.9611,-82.9988),('43219','OH','Columbus','Franklin',40.006321,-82.927896),('43220','OH','Columbus','Franklin',40.048777,-83.068799),('43221','OH','Columbus','Franklin',40.025195,-83.082485),('43222','OH','Columbus','Franklin',39.958394,-83.029808),('43223','OH','Columbus','Franklin',39.934795,-83.041424),('43224','OH','Columbus','Franklin',40.039634,-82.96819),('43226','OH','Columbus','Franklin',40.1035,-82.9866),('43227','OH','Columbus','Franklin',39.946765,-82.888591),('43228','OH','Columbus','Franklin',39.956172,-83.12513),('43229','OH','Columbus','Franklin',40.08496,-82.970777),('43230','OH','Columbus','Franklin',40.040528,-82.872655),('43231','OH','Columbus','Franklin',40.080654,-82.939607),('43232','OH','Columbus','Franklin',39.922495,-82.865724),('43234','OH','Columbus','Franklin',40.1011,-83.0555),('43235','OH','Columbus','Franklin',40.103519,-83.050032),('43236','OH','Columbus','Franklin',39.9611,-82.9988),('43240','OH','Columbus','Delaware',40.145121,-82.98282),('43251','OH','Columbus','Franklin',39.9611,-82.9988),('43260','OH','Columbus','Franklin',39.9618,-83.0009),('43265','OH','Columbus','Franklin',39.9611,-82.9988),('43266','OH','Columbus','Franklin',39.9611,-82.9988),('43268','OH','Columbus','Franklin',39.9611,-82.9988),('43270','OH','Columbus','Franklin',39.9611,-82.9988),('43271','OH','Columbus','Franklin',39.9611,-82.9988),('43272','OH','Columbus','Franklin',39.9611,-82.9988),('43279','OH','Columbus','Franklin',39.9611,-82.9988),('43287','OH','Columbus','Franklin',39.9611,-82.9988),('43291','OH','Columbus','Franklin',39.9611,-82.9988),('43299','OH','Columbus','Franklin',40.0395,-82.8695),('43301','OH','Marion','Marion',40.5886,-83.1286),('43302','OH','Marion','Marion',40.589017,-83.118507),('43306','OH','Marion','Marion',40.5886,-83.1286),('43307','OH','Marion','Marion',40.5886,-83.1286),('43310','OH','Belle Center','Logan',40.51835,-83.780897),('43311','OH','Bellefontaine','Logan',40.365963,-83.753837),('43314','OH','Caledonia','Marion',40.646988,-82.959375),('43315','OH','Cardington','Morrow',40.491195,-82.873497),('43316','OH','Carey','Wyandot',40.95306,-83.381446),('43317','OH','Chesterville','Morrow',40.478945,-82.682994),('43318','OH','De Graff','Logan',40.3109,-83.913767),('43319','OH','East Liberty','Logan',40.304016,-83.565572),('43320','OH','Edison','Morrow',40.575028,-82.886815),('43321','OH','Fulton','Morrow',40.462603,-82.828691),('43322','OH','Green Camp','Marion',40.530337,-83.209448),('43323','OH','Harpster','Wyandot',40.729737,-83.23381),('43324','OH','Huntsville','Logan',40.464244,-83.832403),('43325','OH','Iberia','Morrow',40.6702,-82.8436),('43326','OH','Kenton','Hardin',40.641596,-83.606804),('43330','OH','Kirby','Wyandot',40.810957,-83.419516),('43331','OH','Lakeview','Logan',40.507804,-83.907249),('43332','OH','La Rue','Marion',40.585103,-83.384641),('43333','OH','Lewistown','Logan',40.433815,-83.909377),('43334','OH','Marengo','Morrow',40.40313,-82.808119),('43335','OH','Martel','Marion',40.6681,-82.909),('43336','OH','Middleburg','Logan',40.292671,-83.582579),('43337','OH','Morral','Marion',40.689191,-83.21959),('43338','OH','Mount Gilead','Morrow',40.556072,-82.77289),('43340','OH','Mount Victory','Hardin',40.538931,-83.494605),('43341','OH','New Bloomington','Marion',40.587546,-83.317209),('43342','OH','Prospect','Marion',40.468891,-83.18415),('43343','OH','Quincy','Logan',40.314056,-83.973838),('43344','OH','Richwood','Union',40.430934,-83.344615),('43345','OH','Ridgeway','Hardin',40.513211,-83.577283),('43346','OH','Roundhead','Hardin',40.5551,-83.8389),('43347','OH','Rushsylvania','Logan',40.472382,-83.663069),('43348','OH','Russells Point','Logan',40.47042,-83.888325),('43349','OH','Shauck','Morrow',40.6197,-82.665),('43350','OH','Sparta','Morrow',40.394773,-82.699527),('43351','OH','Upper Sandusky','Wyandot',40.828206,-83.293069),('43356','OH','Waldo','Marion',40.453866,-83.054295),('43357','OH','West Liberty','Logan',40.25491,-83.75527),('43358','OH','West Mansfield','Logan',40.415164,-83.512659),('43359','OH','Wharton','Wyandot',40.866682,-83.460656),('43360','OH','Zanesfield','Logan',40.325535,-83.653822),('43402','OH','Bowling Green','Wood',41.389816,-83.658745),('43403','OH','Bowling Green','Wood',41.375775,-83.636931),('43406','OH','Bradner','Wood',41.327789,-83.438007),('43407','OH','Burgoon','Sandusky',41.275598,-83.244787),('43408','OH','Clay Center','Ottawa',41.565206,-83.363094),('43410','OH','Clyde','Sandusky',41.304546,-82.970898),('43412','OH','Curtice','Lucas',41.631291,-83.32189),('43413','OH','Cygnet','Wood',41.242275,-83.650721),('43414','OH','Dunbridge','Wood',41.458,-83.6102),('43416','OH','Elmore','Ottawa',41.473918,-83.287397),('43420','OH','Fremont','Sandusky',41.357922,-83.110237),('43430','OH','Genoa','Ottawa',41.522189,-83.369834),('43431','OH','Gibsonburg','Sandusky',41.390536,-83.320495),('43432','OH','Graytown','Ottawa',41.553784,-83.256072),('43433','OH','Gypsum','Ottawa',41.504077,-82.873157),('43434','OH','Harbor View','Lucas',41.693241,-83.444749),('43435','OH','Helena','Sandusky',41.33397,-83.303548),('43436','OH','Isle Saint George','Ottawa',41.7155,-82.8185),('43437','OH','Jerry City','Wood',41.253326,-83.60596),('43438','OH','Kelleys Island','Erie',41.601738,-82.697988),('43439','OH','Lacarne','Ottawa',41.517609,-83.042311),('43440','OH','Lakeside Marblehead','Ottawa',41.534476,-82.770114),('43441','OH','Lemoyne','Wood',41.4958,-83.4741),('43442','OH','Lindsey','Sandusky',41.420928,-83.222096),('43443','OH','Luckey','Wood',41.462138,-83.477375),('43445','OH','Martin','Ottawa',41.583459,-83.296408),('43446','OH','Middle Bass','Ottawa',41.681576,-82.814453),('43447','OH','Millbury','Wood',41.560421,-83.438076),('43449','OH','Oak Harbor','Ottawa',41.528686,-83.133709),('43450','OH','Pemberville','Wood',41.405904,-83.472068),('43451','OH','Portage','Wood',41.318447,-83.628525),('43452','OH','Port Clinton','Ottawa',41.516726,-82.939471),('43456','OH','Put In Bay','Ottawa',41.656896,-82.828566),('43457','OH','Risingsun','Wood',41.269299,-83.431811),('43458','OH','Rocky Ridge','Ottawa',41.531647,-83.213889),('43460','OH','Rossford','Wood',41.602073,-83.56202),('43462','OH','Rudolph','Wood',41.285805,-83.694064),('43463','OH','Stony Ridge','Wood',41.5102,-83.5072),('43464','OH','Vickery','Sandusky',41.40488,-82.924109),('43465','OH','Walbridge','Wood',41.577308,-83.498167),('43466','OH','Wayne','Wood',41.291047,-83.501411),('43467','OH','West Millgrove','Wood',41.242673,-83.485276),('43468','OH','Williston','Ottawa',41.600798,-83.340044),('43469','OH','Woodville','Sandusky',41.45417,-83.36346),('43501','OH','Alvordton','Williams',41.672802,-84.447111),('43502','OH','Archbold','Fulton',41.525965,-84.30571),('43504','OH','Berkey','Lucas',41.699742,-83.824454),('43505','OH','Blakeslee','Williams',41.524348,-84.732117),('43506','OH','Bryan','Williams',41.473937,-84.555268),('43510','OH','Colton','Henry',41.4647,-83.9525),('43511','OH','Custar','Wood',41.262555,-83.829145),('43512','OH','Defiance','Defiance',41.289792,-84.362814),('43515','OH','Delta','Fulton',41.58681,-84.009865),('43516','OH','Deshler','Henry',41.211267,-83.905863),('43517','OH','Edgerton','Williams',41.442282,-84.734817),('43518','OH','Edon','Williams',41.5788,-84.760733),('43519','OH','Evansport','Defiance',41.426841,-84.39688),('43520','OH','Farmer','Defiance',41.383,-84.6305),('43521','OH','Fayette','Fulton',41.661524,-84.307975),('43522','OH','Grand Rapids','Wood',41.428582,-83.851741),('43523','OH','Grelton','Henry',41.3416,-83.9997),('43524','OH','Hamler','Henry',41.227122,-84.038444),('43525','OH','Haskins','Wood',41.465347,-83.704677),('43526','OH','Hicksville','Defiance',41.306347,-84.74556),('43527','OH','Holgate','Henry',41.252603,-84.145338),('43528','OH','Holland','Lucas',41.623458,-83.726198),('43529','OH','Hoytville','Wood',41.189525,-83.783686),('43530','OH','Jewell','Defiance',41.3258,-84.2855),('43531','OH','Kunkle','Williams',41.635859,-84.494379),('43532','OH','Liberty Center','Henry',41.451758,-83.975281),('43533','OH','Lyons','Fulton',41.690037,-84.075154),('43534','OH','Mc Clure','Henry',41.366664,-83.931901),('43535','OH','Malinta','Henry',41.315878,-84.030244),('43536','OH','Mark Center','Defiance',41.310732,-84.630076),('43537','OH','Maumee','Lucas',41.577677,-83.671662),('43540','OH','Metamora','Fulton',41.700556,-83.933975),('43541','OH','Milton Center','Wood',41.301574,-83.828157),('43542','OH','Monclova','Lucas',41.571316,-83.761055),('43543','OH','Montpelier','Williams',41.601199,-84.626853),('43545','OH','Napoleon','Henry',41.390705,-84.12451),('43547','OH','Neapolis','Lucas',41.491162,-83.872677),('43548','OH','New Bavaria','Henry',41.192831,-84.175412),('43549','OH','Ney','Defiance',41.377412,-84.51826),('43550','OH','Okolona','Henry',41.3901,-84.1264),('43551','OH','Perrysburg','Wood',41.542118,-83.596358),('43552','OH','Perrysburg','Wood',41.5424,-83.6179),('43553','OH','Pettisville','Fulton',41.531375,-84.227357),('43554','OH','Pioneer','Williams',41.665422,-84.560744),('43555','OH','Ridgeville Corners','Henry',41.437586,-84.256351),('43556','OH','Sherwood','Defiance',41.298333,-84.558836),('43557','OH','Stryker','Williams',41.487605,-84.399458),('43558','OH','Swanton','Fulton',41.584874,-83.885249),('43560','OH','Sylvania','Lucas',41.706406,-83.711451),('43565','OH','Tontogany','Wood',41.419589,-83.740058),('43566','OH','Waterville','Lucas',41.504226,-83.735662),('43567','OH','Wauseon','Fulton',41.571445,-84.151027),('43569','OH','Weston','Wood',41.353246,-83.792436),('43570','OH','West Unity','Williams',41.586955,-84.4375),('43571','OH','Whitehouse','Lucas',41.519522,-83.810212),('43601','OH','Toledo','Lucas',41.642,-83.5438),('43603','OH','Toledo','Lucas',41.6497,-83.5341),('43604','OH','Toledo','Lucas',41.654109,-83.53875),('43605','OH','Toledo','Lucas',41.640851,-83.511539),('43606','OH','Toledo','Lucas',41.671626,-83.606484),('43607','OH','Toledo','Lucas',41.650084,-83.598685),('43608','OH','Toledo','Lucas',41.679334,-83.532682),('43609','OH','Toledo','Lucas',41.631329,-83.571056),('43610','OH','Toledo','Lucas',41.677795,-83.560726),('43611','OH','Toledo','Lucas',41.70171,-83.491067),('43612','OH','Toledo','Lucas',41.705083,-83.55795),('43613','OH','Toledo','Lucas',41.702054,-83.605281),('43614','OH','Toledo','Lucas',41.603316,-83.624953),('43615','OH','Toledo','Lucas',41.655603,-83.672497),('43616','OH','Oregon','Lucas',41.653308,-83.451053),('43617','OH','Toledo','Lucas',41.669201,-83.715104),('43618','OH','Oregon','Lucas',41.676897,-83.399729),('43619','OH','Northwood','Wood',41.609072,-83.492521),('43620','OH','Toledo','Lucas',41.665399,-83.55399),('43623','OH','Toledo','Lucas',41.708344,-83.646602),('43635','OH','Toledo','Lucas',41.6615,-83.6861),('43652','OH','Toledo','Lucas',41.642,-83.5438),('43654','OH','Toledo','Lucas',41.642,-83.5438),('43656','OH','Toledo','Lucas',41.7043,-83.6509),('43657','OH','Toledo','Lucas',41.642,-83.5438),('43659','OH','Toledo','Lucas',41.6465,-83.536),('43660','OH','Toledo','Lucas',41.642,-83.5438),('43661','OH','Toledo','Lucas',41.642,-83.5438),('43666','OH','Toledo','Lucas',41.642,-83.5438),('43667','OH','Toledo','Lucas',41.642,-83.5438),('43681','OH','Toledo','Lucas',41.642,-83.5438),('43682','OH','Toledo','Lucas',41.642,-83.5438),('43697','OH','Toledo','Lucas',41.642,-83.5438),('43699','OH','Toledo','Lucas',41.642,-83.5438),('43701','OH','S Zanesv','Muskingum',39.95115,-82.005333),('43702','OH','S Zanesv','Muskingum',39.9379,-82.0078),('43711','OH','Ava','Noble',39.8316,-81.575),('43713','OH','Barnesville','Belmont',39.987991,-81.166254),('43716','OH','Beallsville','Monroe',39.86068,-81.017879),('43717','OH','Belle Valley','Noble',39.78975,-81.554629),('43718','OH','Belmont','Belmont',40.022768,-81.000272),('43719','OH','Bethesda','Belmont',40.005924,-81.075064),('43720','OH','Blue Rock','Muskingum',39.807275,-81.869619),('43721','OH','Brownsville','Licking',39.947301,-82.257164),('43722','OH','Buffalo','Guernsey',39.916977,-81.519284),('43723','OH','Byesville','Guernsey',39.969318,-81.545551),('43724','OH','Caldwell','Noble',39.739369,-81.515698),('43725','OH','Cambridge','Guernsey',40.026897,-81.58887),('43727','OH','Chandlersville','Muskingum',39.878946,-81.816732),('43728','OH','Chesterhill','Morgan',39.495627,-81.891958),('43730','OH','Corning','Perry',39.618641,-82.10144),('43731','OH','Crooksville','Perry',39.744438,-82.088385),('43732','OH','Cumberland','Guernsey',39.850723,-81.651834),('43733','OH','Derwent','Guernsey',39.922819,-81.539574),('43734','OH','Duncan Falls','Muskingum',39.875992,-81.906921),('43735','OH','East Fultonham','Muskingum',39.851615,-82.122664),('43736','OH','Fairview','Guernsey',40.057786,-81.234738),('43738','OH','Fultonham','Muskingum',39.855294,-82.141677),('43739','OH','Glenford','Perry',39.919142,-82.285437),('43740','OH','Gratiot','Licking',39.951588,-82.213035),('43746','OH','Hopewell','Muskingum',39.965416,-82.183858),('43747','OH','Jerusalem','Monroe',39.877029,-81.116799),('43748','OH','Junction City','Perry',39.7121,-82.303401),('43749','OH','Kimbolton','Guernsey',40.166779,-81.561488),('43750','OH','Kipling','Guernsey',39.999848,-81.505997),('43752','OH','Laings','Monroe',39.7169,-81.0125),('43754','OH','Lewisville','Monroe',39.753965,-81.243277),('43755','OH','Lore City','Guernsey',40.033361,-81.443493),('43756','OH','Mcconnelsville','Morgan',39.675463,-81.794827),('43757','OH','Malaga','Monroe',39.8547,-81.1494),('43758','OH','Malta','Morgan',39.62036,-81.917385),('43759','OH','Morristown','Belmont',40.065011,-81.070166),('43760','OH','Mount Perry','Perry',39.888632,-82.194743),('43761','OH','Moxahala','Perry',39.663955,-82.135678),('43762','OH','New Concord','Muskingum',40.015465,-81.730888),('43764','OH','New Lexington','Perry',39.713571,-82.194946),('43766','OH','New Straitsville','Perry',39.593272,-82.252886),('43767','OH','Norwich','Muskingum',39.988801,-81.80704),('43768','OH','Old Washington','Guernsey',40.03774,-81.441861),('43771','OH','Philo','Muskingum',39.853303,-81.924188),('43772','OH','Pleasant City','Guernsey',39.887648,-81.53185),('43773','OH','Quaker City','Guernsey',39.982321,-81.299094),('43777','OH','Roseville','Muskingum',39.814347,-82.079443),('43778','OH','Salesville','Guernsey',40.010197,-81.368815),('43779','OH','Sarahsville','Noble',39.803775,-81.431928),('43780','OH','Senecaville','Guernsey',39.926714,-81.443628),('43782','OH','Shawnee','Perry',39.611383,-82.212419),('43783','OH','Somerset','Perry',39.801727,-82.291763),('43786','OH','Stafford','Monroe',39.709484,-81.278123),('43787','OH','Stockport','Morgan',39.539263,-81.802477),('43788','OH','Summerfield','Noble',39.805527,-81.333987),('43789','OH','Sycamore Valley','Monroe',39.6698,-81.2318),('43791','OH','White Cottage','Muskingum',39.855474,-82.114926),('43793','OH','Woodsfield','Monroe',39.745144,-81.096103),('43802','OH','Adamsville','Muskingum',40.093013,-81.864449),('43803','OH','Bakersville','Coshocton',40.3555,-81.6458),('43804','OH','Baltic','Holmes',40.453903,-81.730912),('43805','OH','Blissfield','Coshocton',40.39985,-81.9714),('43811','OH','Conesville','Coshocton',40.17986,-81.920852),('43812','OH','Coshocton','Coshocton',40.270142,-81.867791),('43821','OH','Dresden','Muskingum',40.130945,-82.007441),('43822','OH','Frazeysburg','Muskingum',40.164238,-82.165456),('43824','OH','Fresno','Coshocton',40.356541,-81.749211),('43828','OH','Keene','Coshocton',40.345,-81.8683),('43830','OH','Nashport','Muskingum',40.065724,-82.164506),('43832','OH','Newcomerstown','Tuscarawas',40.277533,-81.593117),('43836','OH','Plainfield','Coshocton',40.208174,-81.719399),('43837','OH','Port Washington','Tuscarawas',40.320151,-81.501034),('43840','OH','Stone Creek','Tuscarawas',40.405828,-81.589877),('43842','OH','Trinway','Muskingum',40.140933,-82.01212),('43843','OH','Walhonding','Coshocton',40.339855,-82.185493),('43844','OH','Warsaw','Coshocton',40.332744,-82.050874),('43845','OH','West Lafayette','Coshocton',40.267847,-81.742309),('43901','OH','Adena','Jefferson',40.217836,-80.871571),('43902','OH','Alledonia','Belmont',39.899956,-80.966302),('43903','OH','Amsterdam','Jefferson',40.469149,-80.934163),('43905','OH','Barton','Belmont',40.105373,-80.838929),('43906','OH','Bellaire','Belmont',40.014987,-80.763912),('43907','OH','Cadiz','Harrison',40.261785,-81.003358),('43908','OH','Bergholz','Jefferson',40.515646,-80.885218),('43909','OH','Blaine','Belmont',40.067767,-80.818366),('43910','OH','Bloomingdale','Jefferson',40.365407,-80.817951),('43912','OH','Bridgeport','Belmont',40.070633,-80.777866),('43913','OH','Brilliant','Jefferson',40.26543,-80.630782),('43914','OH','Cameron','Monroe',39.769651,-80.944942),('43915','OH','Clarington','Monroe',39.770266,-80.88025),('43916','OH','Colerain','Belmont',40.1258,-80.8088),('43917','OH','Dillonvale','Jefferson',40.212073,-80.780701),('43920','OH','East Liverpool','Columbiana',40.643232,-80.578429),('43925','OH','East Springfield','Jefferson',40.449895,-80.860374),('43926','OH','Empire','Jefferson',40.510697,-80.623393),('43927','OH','Fairpoint','Belmont',40.120516,-80.937165),('43928','OH','Glencoe','Belmont',40.008138,-80.894721),('43930','OH','Hammondsville','Jefferson',40.569617,-80.744022),('43931','OH','Hannibal','Monroe',39.668369,-80.872033),('43932','OH','Irondale','Jefferson',40.528597,-80.746253),('43933','OH','Jacobsburg','Belmont',39.938655,-80.887074),('43934','OH','Lansing','Belmont',40.077846,-80.789223),('43935','OH','Martins Ferry','Belmont',40.108667,-80.732904),('43937','OH','Maynard','Belmont',40.1233,-80.8794),('43938','OH','Mingo Junction','Jefferson',40.315378,-80.635061),('43939','OH','Mount Pleasant','Jefferson',40.175697,-80.79972),('43940','OH','Neffs','Belmont',40.027991,-80.816357),('43941','OH','Piney Fork','Jefferson',40.2547,-80.8272),('43942','OH','Powhatan Point','Belmont',39.866998,-80.823972),('43943','OH','Rayland','Jefferson',40.2223,-80.716704),('43944','OH','Richmond','Jefferson',40.424339,-80.763722),('43945','OH','Salineville','Columbiana',40.627342,-80.842383),('43946','OH','Sardis','Monroe',39.641505,-80.949062),('43947','OH','Shadyside','Belmont',39.959929,-80.762338),('43948','OH','Smithfield','Jefferson',40.270394,-80.780971),('43950','OH','Saint Clairsville','Belmont',40.088491,-80.909695),('43951','OH','Lafferty','Belmont',40.111839,-81.013708),('43952','OH','Steubenville','Jefferson',40.373147,-80.63537),('43953','OH','Steubenville','Jefferson',40.369948,-80.704812),('43961','OH','Stratton','Jefferson',40.522612,-80.627922),('43962','OH','Summitville','Columbiana',40.678117,-80.886013),('43963','OH','Tiltonsville','Jefferson',40.170267,-80.697993),('43964','OH','Toronto','Jefferson',40.466159,-80.623443),('43967','OH','Warnock','Belmont',40.022806,-80.940931),('43968','OH','Wellsville','Columbiana',40.621283,-80.662994),('43970','OH','Wolf Run','Jefferson',40.4672,-80.8894),('43971','OH','Yorkville','Jefferson',40.156232,-80.708341),('43972','OH','Bannock','Belmont',40.101801,-80.97624),('43973','OH','Freeport','Harrison',40.193865,-81.270078),('43974','OH','Harrisville','Harrison',40.181927,-80.887173),('43976','OH','Hopedale','Harrison',40.354746,-80.903347),('43977','OH','Flushing','Belmont',40.138808,-81.085565),('43981','OH','New Athens','Harrison',40.184401,-80.995196),('43983','OH','Piedmont','Belmont',40.14794,-81.202488),('43984','OH','New Rumley','Harrison',40.4016,-81.0311),('43985','OH','Holloway','Belmont',40.161882,-81.136427),('43986','OH','Jewett','Harrison',40.374809,-80.992007),('43988','OH','Scio','Harrison',40.406978,-81.108821),('44001','OH','Amherst','Lorain',41.383334,-82.237129),('44003','OH','Andover','Ashtabula',41.609998,-80.563493),('44004','OH','Ashtabula','Ashtabula',41.866851,-80.791766),('44005','OH','Ashtabula','Ashtabula',41.8677,-80.7865),('44010','OH','Austinburg','Ashtabula',41.765743,-80.867362),('44011','OH','Avon','Lorain',41.451058,-82.023159),('44012','OH','Avon Lake','Lorain',41.498323,-82.011946),('44017','OH','Berea','Cuyahoga',41.370548,-81.861757),('44021','OH','Burton','Geauga',41.449726,-81.158103),('44022','OH','Chagrin Falls','Cuyahoga',41.438118,-81.397399),('44023','OH','Chagrin Falls','Geauga',41.38633,-81.314968),('44024','OH','Chardon','Geauga',41.577756,-81.193894),('44026','OH','Chesterland','Geauga',41.535793,-81.3299),('44028','OH','Columbia Station','Lorain',41.316683,-81.934123),('44030','OH','Conneaut','Ashtabula',41.930367,-80.578891),('44032','OH','Dorset','Ashtabula',41.664726,-80.66405),('44033','OH','East Claridon','Geauga',41.5325,-81.1158),('44035','OH','Elyria','Lorain',41.372323,-82.109641),('44036','OH','Elyria','Lorain',41.37,-82.0965),('44039','OH','North Ridgeville','Lorain',41.387642,-82.01015),('44040','OH','Gates Mills','Cuyahoga',41.526615,-81.412576),('44041','OH','Geneva','Ashtabula',41.799354,-80.94487),('44044','OH','Grafton','Lorain',41.281854,-82.04736),('44045','OH','Grand River','Lake',41.742073,-81.282117),('44046','OH','Huntsburg','Geauga',41.528625,-81.082919),('44047','OH','Jefferson','Ashtabula',41.729538,-80.745135),('44048','OH','Kingsville','Ashtabula',41.867514,-80.650659),('44049','OH','Kipton','Lorain',41.26673,-82.302926),('44050','OH','Lagrange','Lorain',41.243972,-82.13576),('44052','OH','Lorain','Lorain',41.458753,-82.170273),('44053','OH','Lorain','Lorain',41.427095,-82.205699),('44054','OH','Sheffield Lake','Lorain',41.476455,-82.098964),('44055','OH','Lorain','Lorain',41.434269,-82.137016),('44056','OH','Macedonia','Summit',41.317885,-81.501275),('44057','OH','Madison','Lake',41.80017,-81.05922),('44060','OH','Mentor','Lake',41.683468,-81.333434),('44061','OH','Mentor','Lake',41.6868,-81.3325),('44062','OH','Middlefield','Geauga',41.45854,-81.052453),('44064','OH','Montville','Geauga',41.612308,-81.054468),('44065','OH','Newbury','Geauga',41.4716,-81.24567),('44067','OH','Northfield','Summit',41.314366,-81.538937),('44068','OH','North Kingsville','Ashtabula',41.9058,-80.6905),('44070','OH','North Olmsted','Cuyahoga',41.415549,-81.915271),('44072','OH','Novelty','Geauga',41.471706,-81.340197),('44073','OH','Novelty','Geauga',41.4644,-81.3402),('44074','OH','Oberlin','Lorain',41.284949,-82.219061),('44076','OH','Orwell','Ashtabula',41.534329,-80.836353),('44077','OH','Painesville','Lake',41.713615,-81.241753),('44080','OH','Parkman','Geauga',41.370175,-81.064323),('44081','OH','Perry','Lake',41.770671,-81.143254),('44082','OH','Pierpont','Ashtabula',41.75948,-80.570029),('44084','OH','Rock Creek','Ashtabula',41.659739,-80.867368),('44085','OH','Rome','Ashtabula',41.612779,-80.855258),('44086','OH','Thompson','Geauga',41.675726,-81.058597),('44087','OH','Twinsburg','Summit',41.321009,-81.445719),('44088','OH','Unionville','Ashtabula',41.7823,-81.0021),('44089','OH','Vermilion','Erie',41.402832,-82.361437),('44090','OH','Wellington','Lorain',41.158875,-82.234808),('44092','OH','Wickliffe','Lake',41.602905,-81.469535),('44093','OH','Williamsfield','Ashtabula',41.539702,-80.587368),('44094','OH','Willoughby','Lake',41.627067,-81.399465),('44095','OH','Eastlake','Lake',41.652467,-81.445831),('44096','OH','Willoughby','Lake',41.6131,-81.3873),('44097','OH','Eastlake','Lake',41.6625,-81.4348),('44099','OH','Windsor','Ashtabula',41.540284,-80.966405),('44101','OH','Cleveland','Cuyahoga',41.489232,-81.667768),('44102','OH','Cleveland','Cuyahoga',41.474027,-81.73579),('44103','OH','Cleveland','Cuyahoga',41.514678,-81.6429),('44104','OH','Cleveland','Cuyahoga',41.484039,-81.62632),('44105','OH','Cleveland','Cuyahoga',41.450502,-81.622385),('44106','OH','Cleveland','Cuyahoga',41.507882,-81.608357),('44107','OH','Lakewood','Cuyahoga',41.48205,-81.799958),('44108','OH','Cleveland','Cuyahoga',41.535733,-81.610568),('44109','OH','Cleveland','Cuyahoga',41.448575,-81.703388),('44110','OH','Cleveland','Cuyahoga',41.563625,-81.570838),('44111','OH','Cleveland','Cuyahoga',41.459238,-81.782528),('44112','OH','Cleveland','Cuyahoga',41.53484,-81.574894),('44113','OH','Cleveland','Cuyahoga',41.485,-81.700065),('44114','OH','Cleveland','Cuyahoga',41.510597,-81.674494),('44115','OH','Cleveland','Cuyahoga',41.493546,-81.671226),('44116','OH','Rocky River','Cuyahoga',41.473794,-81.849553),('44117','OH','Euclid','Cuyahoga',41.572368,-81.527933),('44118','OH','Cleveland','Cuyahoga',41.500125,-81.555366),('44119','OH','Cleveland','Cuyahoga',41.586896,-81.546201),('44120','OH','Cleveland','Cuyahoga',41.47271,-81.583283),('44121','OH','Cleveland','Cuyahoga',41.526194,-81.533259),('44122','OH','Beachwood','Cuyahoga',41.47284,-81.522259),('44123','OH','Euclid','Cuyahoga',41.602998,-81.524381),('44124','OH','Cleveland','Cuyahoga',41.50965,-81.471333),('44125','OH','Cleveland','Cuyahoga',41.412288,-81.610689),('44126','OH','Cleveland','Cuyahoga',41.4417,-81.85731),('44127','OH','Cleveland','Cuyahoga',41.47082,-81.649622),('44128','OH','Cleveland','Cuyahoga',41.441179,-81.551925),('44129','OH','Cleveland','Cuyahoga',41.396546,-81.735205),('44130','OH','Cleveland','Cuyahoga',41.377903,-81.778064),('44131','OH','Independence','Cuyahoga',41.386914,-81.655519),('44132','OH','Euclid','Cuyahoga',41.608262,-81.500575),('44133','OH','North Royalton','Cuyahoga',41.322248,-81.746094),('44134','OH','Cleveland','Cuyahoga',41.393839,-81.704876),('44135','OH','Cleveland','Cuyahoga',41.43227,-81.804598),('44136','OH','Strongsville','Cuyahoga',41.309254,-81.813465),('44137','OH','Maple Heights','Cuyahoga',41.41027,-81.561065),('44138','OH','Olmsted Falls','Cuyahoga',41.373955,-81.914957),('44139','OH','Solon','Cuyahoga',41.384233,-81.443374),('44140','OH','Bay Village','Cuyahoga',41.484081,-81.926468),('44141','OH','Brecksville','Cuyahoga',41.299666,-81.616544),('44142','OH','Brook Pa','Cuyahoga',41.400461,-81.820696),('44143','OH','Cleveland','Cuyahoga',41.550898,-81.479871),('44144','OH','Cleveland','Cuyahoga',41.437372,-81.734774),('44145','OH','Westlake','Cuyahoga',41.455508,-81.928197),('44146','OH','Bedford','Cuyahoga',41.388006,-81.526803),('44147','OH','Broadview Heights','Cuyahoga',41.318155,-81.679264),('44149','OH','Strongsville','Cuyahoga',41.316544,-81.853583),('44178','OH','Cleveland','Cuyahoga',41.4994,-81.6955),('44181','OH','Cleveland','Cuyahoga',41.4918,-81.6757),('44185','OH','Cleveland','Cuyahoga',41.4918,-81.6757),('44188','OH','Cleveland','Cuyahoga',41.4017,-81.8266),('44189','OH','Cleveland','Cuyahoga',41.4918,-81.6757),('44190','OH','Cleveland','Cuyahoga',41.4918,-81.6757),('44191','OH','Cleveland','Cuyahoga',41.4918,-81.6757),('44192','OH','Cleveland','Cuyahoga',41.4918,-81.6757),('44193','OH','Cleveland','Cuyahoga',41.4918,-81.6757),('44194','OH','Cleveland','Cuyahoga',41.4918,-81.6757),('44195','OH','Cleveland','Cuyahoga',41.4918,-81.6757),('44197','OH','Cleveland','Cuyahoga',41.4918,-81.6757),('44198','OH','Cleveland','Cuyahoga',41.4918,-81.6757),('44199','OH','Cleveland','Cuyahoga',41.5047,-81.6911),('44201','OH','Atwater','Portage',41.020074,-81.196558),('44202','OH','Aurora','Portage',41.316473,-81.354956),('44203','OH','Barberton','Summit',41.018496,-81.618933),('44210','OH','Bath','Summit',41.1888,-81.6363),('44211','OH','Brady Lake','Portage',41.1594,-81.3172),('44212','OH','Brunswick','Medina',41.244488,-81.828842),('44214','OH','Burbank','Wayne',40.951923,-81.999753),('44215','OH','Chippewa Lake','Medina',41.06843,-81.902037),('44216','OH','Clinton','Summit',40.936336,-81.590135),('44217','OH','Creston','Wayne',40.971353,-81.909673),('44221','OH','Cuyahoga Falls','Summit',41.140092,-81.479362),('44222','OH','Cuyahoga Falls','Summit',41.1352,-81.4843),('44223','OH','Cuyahoga Falls','Summit',41.151113,-81.513009),('44224','OH','Stow','Summit',41.171899,-81.444401),('44230','OH','Doylestown','Wayne',40.965619,-81.689987),('44231','OH','Garrettsville','Portage',41.295898,-81.080567),('44232','OH','Green','Summit',40.9458,-81.4833),('44233','OH','Hinckley','Medina',41.249084,-81.737866),('44234','OH','Hiram','Portage',41.325805,-81.152241),('44235','OH','Homerville','Medina',41.031119,-82.11677),('44236','OH','Hudson','Summit',41.248865,-81.449019),('44237','OH','Hudson','Summit',41.2535,-81.4835),('44240','OH','Kent','Portage',41.145345,-81.351048),('44241','OH','Streetsboro','Portage',41.243366,-81.349682),('44242','OH','Kent','Portage',41.1474,-81.3606),('44243','OH','Kent','Portage',41.147682,-81.339449),('44250','OH','Lakemore','Summit',41.020734,-81.43451),('44251','OH','Westfield Center','Medina',41.030596,-81.929594),('44253','OH','Litchfield','Medina',41.162776,-82.033343),('44254','OH','Lodi','Medina',41.037783,-82.01334),('44255','OH','Mantua','Portage',41.283417,-81.236207),('44256','OH','Medina','Medina',41.139888,-81.855763),('44258','OH','Medina','Medina',41.1421,-81.8649),('44260','OH','Mogadore','Portage',41.03493,-81.350352),('44262','OH','Munroe Falls','Summit',41.139561,-81.436066),('44264','OH','Peninsula','Summit',41.226285,-81.545856),('44265','OH','Randolph','Portage',41.0327,-81.2486),('44266','OH','Ravenna','Portage',41.157613,-81.226789),('44270','OH','Rittman','Wayne',40.973111,-81.778296),('44272','OH','Rootstown','Portage',41.091027,-81.197294),('44273','OH','Seville','Medina',41.027626,-81.882074),('44274','OH','Sharon Center','Medina',41.099191,-81.735481),('44275','OH','Spencer','Medina',41.101814,-82.104267),('44276','OH','Sterling','Wayne',40.950622,-81.826305),('44278','OH','Tallmadge','Summit',41.094093,-81.424972),('44280','OH','Valley City','Medina',41.231421,-81.923748),('44281','OH','Wadsworth','Medina',41.038296,-81.730565),('44282','OH','Wadsworth','Medina',41.0255,-81.73),('44285','OH','Wayland','Portage',41.158948,-81.069536),('44286','OH','Richfield','Summit',41.233113,-81.633613),('44287','OH','West Salem','Wayne',40.946453,-82.115825),('44288','OH','Windham','Portage',41.239104,-81.07605),('44301','OH','Akron','Summit',41.044129,-81.519181),('44302','OH','Akron','Summit',41.089409,-81.538957),('44303','OH','Akron','Summit',41.103086,-81.536138),('44304','OH','Akron','Summit',41.082486,-81.508468),('44305','OH','Akron','Summit',41.075352,-81.463988),('44306','OH','Akron','Summit',41.046245,-81.49053),('44307','OH','Akron','Summit',41.070418,-81.543211),('44308','OH','Akron','Summit',41.081623,-81.517527),('44309','OH','Akron','Summit',41.0655,-81.5204),('44310','OH','Akron','Summit',41.107664,-81.50091),('44311','OH','Akron','Summit',41.062745,-81.520979),('44312','OH','Akron','Summit',41.034588,-81.440924),('44313','OH','Akron','Summit',41.123363,-81.571237),('44314','OH','Akron','Summit',41.039979,-81.559022),('44315','OH','Akron','Summit',41.0655,-81.5204),('44316','OH','Akron','Summit',41.0655,-81.5204),('44317','OH','Akron','Summit',41.0655,-81.5204),('44319','OH','Akron','Summit',40.992212,-81.530776),('44320','OH','Akron','Summit',41.08305,-81.570029),('44321','OH','Akron','Summit',41.107022,-81.650536),('44322','OH','Akron','Summit',41.043496,-81.585361),('44325','OH','Akron','Summit',41.0748,-81.5165),('44326','OH','Akron','Summit',41.0655,-81.5204),('44328','OH','Akron','Summit',41.0758,-81.5206),('44333','OH','Akron','Summit',41.146316,-81.621256),('44334','OH','Fairlawn','Summit',41.1365,-81.5667),('44372','OH','Akron','Summit',41.112,-81.5746),('44393','OH','Akron','Summit',41.0655,-81.5204),('44396','OH','Akron','Summit',41.0813,-81.5191),('44398','OH','Akron','Summit',41.0655,-81.5204),('44399','OH','Akron','Summit',41.0655,-81.5204),('44401','OH','Berlin Center','Mahoning',41.028914,-80.95059),('44402','OH','Bristolville','Trumbull',41.383256,-80.863011),('44403','OH','Brookfield','Trumbull',41.242829,-80.58251),('44404','OH','Burghill','Trumbull',41.32238,-80.532426),('44405','OH','Campbell','Mahoning',41.077176,-80.590544),('44406','OH','Canfield','Mahoning',41.019433,-80.757121),('44408','OH','Columbiana','Columbiana',40.888888,-80.685394),('44410','OH','Cortland','Trumbull',41.331326,-80.726495),('44411','OH','Deerfield','Portage',41.031503,-81.050457),('44412','OH','Diamond','Portage',41.099621,-81.022645),('44413','OH','East Palestine','Columbiana',40.838613,-80.546047),('44415','OH','Elkton','Columbiana',40.7619,-80.6988),('44416','OH','Ellsworth','Mahoning',41.0241,-80.8575),('44417','OH','Farmdale','Trumbull',41.428769,-80.656088),('44418','OH','Fowler','Trumbull',41.301623,-80.610078),('44420','OH','Girard','Trumbull',41.160662,-80.69305),('44422','OH','Greenford','Mahoning',40.9438,-80.7916),('44423','OH','Hanoverton','Columbiana',40.750726,-80.903944),('44424','OH','Hartford','Trumbull',41.3113,-80.5686),('44425','OH','Hubbard','Trumbull',41.162334,-80.575384),('44427','OH','Kensington','Columbiana',40.724381,-80.948919),('44428','OH','Kinsman','Trumbull',41.44435,-80.588313),('44429','OH','Lake Milton','Mahoning',41.100539,-80.986673),('44430','OH','Leavittsburg','Trumbull',41.24256,-80.889016),('44431','OH','Leetonia','Columbiana',40.867844,-80.752857),('44432','OH','Lisbon','Columbiana',40.762005,-80.762389),('44436','OH','Lowellville','Mahoning',41.044244,-80.545911),('44437','OH','Mc Donald','Trumbull',41.159247,-80.731825),('44438','OH','Masury','Trumbull',41.22265,-80.526614),('44439','OH','Mesopotamia','Trumbull',41.45849,-80.954839),('44440','OH','Mineral Ridge','Trumbull',41.141861,-80.7712),('44441','OH','Negley','Columbiana',40.773494,-80.549241),('44442','OH','New Middletown','Mahoning',40.965546,-80.558322),('44443','OH','New Springfield','Mahoning',40.923979,-80.592534),('44444','OH','Newton Falls','Trumbull',41.189372,-80.969353),('44445','OH','New Waterford','Columbiana',40.84625,-80.622503),('44446','OH','Niles','Trumbull',41.186989,-80.751709),('44449','OH','North Benton','Mahoning',40.991755,-81.040577),('44450','OH','North Bloomfield','Trumbull',41.445707,-80.81962),('44451','OH','North Jackson','Mahoning',41.093956,-80.851806),('44452','OH','North Lima','Mahoning',40.959222,-80.656001),('44453','OH','Orangeville','Trumbull',41.3106,-80.5686),('44454','OH','Petersburg','Mahoning',40.918076,-80.534348),('44455','OH','Rogers','Columbiana',40.787312,-80.612635),('44460','OH','Salem','Columbiana',40.898958,-80.859564),('44470','OH','Southington','Trumbull',41.296695,-80.95568),('44471','OH','Struthers','Mahoning',41.05217,-80.593894),('44473','OH','Vienna','Trumbull',41.231168,-80.671742),('44481','OH','Warren','Trumbull',41.203719,-80.861052),('44482','OH','Warren','Trumbull',41.1742,-80.8702),('44483','OH','Warren','Trumbull',41.253826,-80.807893),('44484','OH','Warren','Trumbull',41.227841,-80.763804),('44485','OH','Warren','Trumbull',41.237873,-80.843597),('44486','OH','Warren','Trumbull',41.3004,-80.8436),('44488','OH','Warren','Trumbull',41.2375,-80.8162),('44490','OH','Washingtonville','Columbiana',40.900347,-80.764617),('44491','OH','West Farmington','Trumbull',41.370203,-80.963771),('44492','OH','West Point','Columbiana',40.7083,-80.7025),('44493','OH','Winona','Columbiana',40.825585,-80.891432),('44501','OH','Youngstown','Mahoning',41.0986,-80.6474),('44502','OH','Youngstown','Mahoning',41.087188,-80.645783),('44503','OH','Youngstown','Mahoning',41.099326,-80.649074),('44504','OH','Youngstown','Mahoning',41.123512,-80.654651),('44505','OH','Youngstown','Mahoning',41.123025,-80.624207),('44506','OH','Youngstown','Mahoning',41.095511,-80.627722),('44507','OH','Youngstown','Mahoning',41.074345,-80.655692),('44509','OH','Youngstown','Mahoning',41.106206,-80.693289),('44510','OH','Youngstown','Mahoning',41.119518,-80.668506),('44511','OH','Youngstown','Mahoning',41.068375,-80.69133),('44512','OH','Youngstown','Mahoning',41.032514,-80.664629),('44513','OH','Youngstown','Mahoning',41.0241,-80.6752),('44514','OH','Youngstown','Mahoning',41.017728,-80.616074),('44515','OH','Youngstown','Mahoning',41.097206,-80.75007),('44555','OH','Youngstown','Mahoning',41.1073,-80.6513),('44601','OH','Alliance','Stark',40.920118,-81.116377),('44606','OH','Apple Creek','Wayne',40.739234,-81.798763),('44607','OH','Augusta','Carroll',40.69641,-81.031639),('44608','OH','Beach City','Stark',40.649429,-81.583802),('44609','OH','Beloit','Mahoning',40.90595,-80.988257),('44610','OH','Berlin','Holmes',40.561431,-81.798273),('44611','OH','Big Prairie','Holmes',40.617231,-82.090669),('44612','OH','Bolivar','Tuscarawas',40.641988,-81.454922),('44613','OH','Brewster','Stark',40.712069,-81.59756),('44614','OH','Canal Fulton','Stark',40.888221,-81.587803),('44615','OH','Carrollton','Carroll',40.568007,-81.081561),('44617','OH','Charm','Holmes',40.5066,-81.785),('44618','OH','Dalton','Wayne',40.784186,-81.700355),('44619','OH','Damascus','Mahoning',40.901738,-80.957239),('44620','OH','Dellroy','Carroll',40.569155,-81.211336),('44621','OH','Dennison','Tuscarawas',40.409996,-81.320633),('44622','OH','Dover','Tuscarawas',40.53182,-81.482138),('44624','OH','Dundee','Holmes',40.608468,-81.66146),('44625','OH','East Rochester','Columbiana',40.758514,-81.00807),('44626','OH','East Sparta','Stark',40.688904,-81.381772),('44627','OH','Fredericksburg','Wayne',40.670879,-81.837044),('44628','OH','Glenmont','Holmes',40.532944,-82.156116),('44629','OH','Gnadenhutten','Tuscarawas',40.361593,-81.437553),('44630','OH','Greentown','Stark',40.9275,-81.4027),('44631','OH','Harlem Springs','Carroll',40.5208,-81.0033),('44632','OH','Hartville','Stark',40.967796,-81.328537),('44633','OH','Holmesville','Holmes',40.631451,-81.929573),('44634','OH','Homeworth','Columbiana',40.839299,-81.057304),('44636','OH','Kidron','Wayne',40.7408,-81.745),('44637','OH','Killbuck','Holmes',40.485485,-82.01284),('44638','OH','Lakeville','Holmes',40.655393,-82.132923),('44639','OH','Leesville','Carroll',40.4516,-81.2122),('44640','OH','Limaville','Stark',40.982566,-81.147454),('44641','OH','Louisville','Stark',40.848457,-81.263027),('44643','OH','Magnolia','Stark',40.647267,-81.307543),('44644','OH','Malvern','Carroll',40.686078,-81.182001),('44645','OH','Marshallville','Wayne',40.915937,-81.712054),('44646','OH','Massillon','Stark',40.807673,-81.502359),('44647','OH','Massillon','Stark',40.798927,-81.553614),('44648','OH','Massillon','Stark',40.793,-81.5219),('44650','OH','Maximo','Stark',40.8763,-81.1722),('44651','OH','Mechanicstown','Carroll',40.629538,-80.963072),('44652','OH','Middlebranch','Stark',40.896519,-81.325688),('44653','OH','Midvale','Tuscarawas',40.436299,-81.37233),('44654','OH','Millersburg','Holmes',40.537937,-81.870867),('44656','OH','Mineral City','Tuscarawas',40.569108,-81.334736),('44657','OH','Minerva','Stark',40.735801,-81.092715),('44659','OH','Mount Eaton','Wayne',40.694148,-81.702525),('44660','OH','Mount Hope','Holmes',40.6238,-81.7847),('44661','OH','Nashville','Holmes',40.596264,-82.113101),('44662','OH','Navarre','Stark',40.72372,-81.532136),('44663','OH','New Philadelphia','Tuscarawas',40.478262,-81.442278),('44665','OH','North Georgetown','Columbiana',40.843,-80.9861),('44666','OH','North Lawrence','Stark',40.840353,-81.627224),('44667','OH','Orrville','Wayne',40.83385,-81.770311),('44669','OH','Paris','Stark',40.799446,-81.159757),('44670','OH','Robertsville','Stark',40.762764,-81.190726),('44671','OH','Sandyville','Tuscarawas',40.641711,-81.368586),('44672','OH','Sebring','Mahoning',40.921684,-81.024117),('44675','OH','Sherrodsville','Carroll',40.503972,-81.246254),('44676','OH','Shreve','Wayne',40.683853,-82.027456),('44677','OH','Smithville','Wayne',40.865559,-81.857162),('44678','OH','Somerdale','Tuscarawas',40.567282,-81.356188),('44679','OH','Stillwater','Tuscarawas',40.3233,-81.3086),('44680','OH','Strasburg','Tuscarawas',40.598406,-81.532843),('44681','OH','Sugarcreek','Tuscarawas',40.506935,-81.655322),('44682','OH','Tuscarawas','Tuscarawas',40.397208,-81.405298),('44683','OH','Uhrichsville','Tuscarawas',40.382014,-81.342224),('44685','OH','Uniontown','Summit',40.962005,-81.425557),('44687','OH','Walnut Creek','Holmes',40.539243,-81.720373),('44688','OH','Waynesburg','Stark',40.682812,-81.26087),('44689','OH','Wilmot','Stark',40.659499,-81.645512),('44690','OH','Winesburg','Holmes',40.616101,-81.695003),('44691','OH','Wooster','Wayne',40.801524,-81.956054),('44693','OH','Deersville','Harrison',40.306622,-81.187166),('44695','OH','Bowerston','Carroll',40.43598,-81.183404),('44697','OH','Zoar','Tuscarawas',40.612033,-81.421717),('44699','OH','Tippecanoe','Harrison',40.282599,-81.281535),('44701','OH','Canton','Stark',40.7962,-81.3768),('44702','OH','Canton','Stark',40.798796,-81.374607),('44703','OH','Canton','Stark',40.810149,-81.381104),('44704','OH','Canton','Stark',40.799681,-81.355586),('44705','OH','Canton','Stark',40.822462,-81.340952),('44706','OH','Canton','Stark',40.774141,-81.407243),('44707','OH','Canton','Stark',40.78439,-81.366063),('44708','OH','Canton','Stark',40.811474,-81.417179),('44709','OH','Canton','Stark',40.838098,-81.387185),('44710','OH','Canton','Stark',40.791581,-81.415927),('44711','OH','Canton','Stark',40.827,-81.3853),('44714','OH','Canton','Stark',40.828506,-81.360479),('44718','OH','Canton','Stark',40.850554,-81.437358),('44720','OH','North Ca','Stark',40.888263,-81.416565),('44721','OH','Canton','Stark',40.885326,-81.332404),('44730','OH','East Can','Stark',40.77601,-81.274601),('44735','OH','Canton','Stark',40.8436,-81.4363),('44750','OH','Canton','Stark',40.827,-81.3853),('44767','OH','Canton','Stark',40.827,-81.3853),('44799','OH','Canton','Stark',40.827,-81.3853),('44802','OH','Alvada','Seneca',41.053971,-83.414158),('44804','OH','Arcadia','Hancock',41.116609,-83.526356),('44805','OH','Ashland','Ashland',40.868435,-82.316261),('44807','OH','Attica','Seneca',41.059801,-82.876936),('44809','OH','Bascom','Seneca',41.133152,-83.283333),('44811','OH','Bellevue','Sandusky',41.259016,-82.832806),('44813','OH','Bellville','Richland',40.608571,-82.528189),('44814','OH','Berlin Heights','Erie',41.32411,-82.472168),('44815','OH','Bettsville','Seneca',41.244093,-83.234878),('44816','OH','Birmingham','Erie',41.33011,-82.353205),('44817','OH','Bloomdale','Wood',41.184492,-83.54465),('44818','OH','Bloomville','Seneca',40.998342,-82.989373),('44820','OH','Bucyrus','Crawford',40.81556,-82.971372),('44822','OH','Butler','Richland',40.560978,-82.409698),('44824','OH','Castalia','Erie',41.386257,-82.795994),('44825','OH','Chatfield','Crawford',40.954176,-82.942452),('44826','OH','Collins','Huron',41.238333,-82.486334),('44827','OH','Crestline','Crawford',40.79673,-82.743928),('44828','OH','Flat Rock','Seneca',41.234451,-82.859913),('44830','OH','Fostoria','Seneca',41.164285,-83.410651),('44833','OH','Galion','Crawford',40.725207,-82.790513),('44836','OH','Green Springs','Seneca',41.249361,-83.059202),('44837','OH','Greenwich','Huron',41.017595,-82.484355),('44838','OH','Hayesville','Ashland',40.77302,-82.261741),('44839','OH','Huron','Erie',41.387421,-82.549718),('44840','OH','Jeromesville','Ashland',40.792533,-82.185527),('44841','OH','Kansas','Seneca',41.250545,-83.294458),('44842','OH','Loudonville','Ashland',40.642214,-82.225902),('44843','OH','Lucas','Richland',40.697468,-82.40926),('44844','OH','Mc Cutchenville','Wyandot',40.990719,-83.261967),('44845','OH','Melmore','Seneca',41.0364,-83.1456),('44846','OH','Milan','Erie',41.311022,-82.60535),('44847','OH','Monroeville','Huron',41.236546,-82.703774),('44848','OH','Nankin','Ashland',40.9213,-82.2819),('44849','OH','Nevada','Wyandot',40.818585,-83.128113),('44850','OH','New Haven','Huron',41.033952,-82.680909),('44851','OH','New London','Huron',41.094183,-82.395771),('44853','OH','New Riegel','Seneca',41.057428,-83.294751),('44854','OH','New Washington','Crawford',40.950691,-82.853249),('44855','OH','North Fairfield','Huron',41.10364,-82.604556),('44856','OH','North Robinson','Crawford',40.79384,-82.857364),('44857','OH','Norwalk','Huron',41.237657,-82.603472),('44859','OH','Nova','Ashland',41.021963,-82.330724),('44860','OH','Oceola','Crawford',40.845335,-83.092698),('44861','OH','Old Fort','Seneca',41.239495,-83.148379),('44862','OH','Ontario','Richland',40.7594,-82.5902),('44864','OH','Perrysville','Ashland',40.662925,-82.324407),('44865','OH','Plymouth','Huron',40.994209,-82.668463),('44866','OH','Polk','Ashland',40.912067,-82.182475),('44867','OH','Republic','Seneca',41.14171,-82.997671),('44870','OH','Sandusky','Erie',41.432607,-82.715604),('44871','OH','Sandusky','Erie',41.4488,-82.708),('44874','OH','Savannah','Ashland',40.966221,-82.364918),('44875','OH','Shelby','Richland',40.885857,-82.654777),('44878','OH','Shiloh','Richland',40.941152,-82.531221),('44880','OH','Sullivan','Ashland',41.034602,-82.220113),('44881','OH','Sulphur Springs','Crawford',40.870493,-82.876273),('44882','OH','Sycamore','Wyandot',40.953717,-83.140765),('44883','OH','Tiffin','Seneca',41.121218,-83.176796),('44887','OH','Tiro','Crawford',40.916215,-82.790698),('44888','OH','Willard','Huron',41.0559,-82.7258),('44889','OH','Wakeman','Huron',41.238654,-82.388318),('44890','OH','Willard','Huron',41.066174,-82.72101),('44901','OH','Mansfield','Richland',40.791493,-82.511998),('44902','OH','Mansfield','Richland',40.758704,-82.511277),('44903','OH','Mansfield','Richland',40.77091,-82.517068),('44904','OH','Mansfield','Richland',40.676794,-82.577851),('44905','OH','Mansfield','Richland',40.775006,-82.478066),('44906','OH','Mansfield','Richland',40.765867,-82.567259),('44907','OH','Mansfield','Richland',40.732875,-82.521383),('44999','OH','Mansfield','Richland',40.7633,-82.5138),('45001','OH','Addyston','Hamilton',39.138143,-84.712887),('45002','OH','Cleves','Hamilton',39.186447,-84.738903),('45003','OH','College Corner','Preble',39.584404,-84.776607),('45004','OH','Collinsville','Butler',39.5152,-84.6094),('45005','OH','Franklin','Warren',39.546532,-84.307515),('45011','OH','Hamilton','Butler',39.404168,-84.519768),('45012','OH','Hamilton','Butler',39.3993,-84.5638),('45013','OH','Hamilton','Butler',39.409155,-84.604197),('45014','OH','Fairfield','Butler',39.328588,-84.550194),('45015','OH','Hamilton','Butler',39.367122,-84.550144),('45018','OH','Fairfield','Butler',39.3993,-84.5638),('45025','OH','Hamilton','Butler',39.3993,-84.5638),('45026','OH','Hamilton','Butler',39.3993,-84.5638),('45030','OH','Harrison','Hamilton',39.256416,-84.765502),('45032','OH','Harveysburg','Warren',39.500938,-84.00873),('45033','OH','Hooven','Hamilton',39.177021,-84.762416),('45034','OH','Kings Mills','Warren',39.356535,-84.246301),('45036','OH','Lebanon','Warren',39.433354,-84.221382),('45039','OH','Maineville','Warren',39.324764,-84.244232),('45040','OH','Mason','Warren',39.34552,-84.310392),('45041','OH','Miamitown','Hamilton',39.213282,-84.704219),('45042','OH','Middletown','Butler',39.529022,-84.391364),('45043','OH','Middletown','Butler',39.4484,-84.4147),('45044','OH','Middletown','Butler',39.480286,-84.383325),('45050','OH','Monroe','Butler',39.435712,-84.357104),('45051','OH','Mount Saint Joseph','Hamilton',39.097962,-84.646609),('45052','OH','North Bend','Hamilton',39.146846,-84.776506),('45053','OH','Okeana','Butler',39.354065,-84.787831),('45054','OH','Oregonia','Warren',39.43883,-84.085066),('45055','OH','Overpeck','Butler',39.4508,-84.5144),('45056','OH','Oxford','Butler',39.500877,-84.74037),('45061','OH','Ross','Butler',39.4008,-84.6362),('45062','OH','Seven Mile','Butler',39.481232,-84.553878),('45063','OH','Shandon','Butler',39.3263,-84.7147),('45064','OH','Somerville','Butler',39.570635,-84.590777),('45065','OH','South Lebanon','Warren',39.368987,-84.211888),('45066','OH','Springboro','Warren',39.558624,-84.224936),('45067','OH','Trenton','Butler',39.478808,-84.466373),('45068','OH','Waynesville','Warren',39.529869,-84.064751),('45069','OH','West Chester','Butler',39.345769,-84.409944),('45070','OH','West Elkton','Preble',39.589496,-84.554346),('45071','OH','West Chester','Butler',39.3331,-84.4043),('45101','OH','Aberdeen','Brown',38.674279,-83.76275),('45102','OH','Amelia','Clermont',39.022991,-84.21335),('45103','OH','Batavia','Clermont',39.088031,-84.158506),('45105','OH','Bentonville','Adams',38.7494,-83.6133),('45106','OH','Bethel','Clermont',38.953313,-84.07558),('45107','OH','Blanchester','Clinton',39.295047,-83.972913),('45110','OH','Buford','Highland',39.0766,-83.8441),('45111','OH','Camp Dennison','Hamilton',39.196313,-84.29223),('45112','OH','Chilo','Clermont',38.793093,-84.139912),('45113','OH','Clarksville','Clinton',39.399914,-83.985809),('45114','OH','Cuba','Clinton',39.362778,-83.864327),('45115','OH','Decatur','Brown',38.814997,-83.703788),('45118','OH','Fayetteville','Brown',39.180663,-83.947066),('45119','OH','Feesburg','Brown',38.8783,-83.9988),('45120','OH','Felicity','Clermont',38.828417,-84.090027),('45121','OH','Georgetown','Brown',38.869605,-83.902795),('45122','OH','Goshen','Clermont',39.22111,-84.123303),('45123','OH','Greenfield','Highland',39.348119,-83.389572),('45130','OH','Hamersville','Brown',38.914183,-83.993553),('45131','OH','Higginsport','Brown',38.789761,-83.966967),('45132','OH','Highland','Highland',39.343906,-83.599583),('45133','OH','Hillsboro','Highland',39.16311,-83.580641),('45135','OH','Leesburg','Highland',39.342351,-83.550877),('45138','OH','Lees Creek','Clinton',39.42,-83.6494),('45140','OH','Loveland','Clermont',39.25936,-84.258611),('45142','OH','Lynchburg','Highland',39.213153,-83.808063),('45144','OH','Manchester','Adams',38.691314,-83.617637),('45145','OH','Marathon','Clermont',39.1447,-84.0063),('45146','OH','Martinsville','Clinton',39.321379,-83.797898),('45147','OH','Miamiville','Clermont',39.212401,-84.298231),('45148','OH','Midland','Clinton',39.290218,-83.887266),('45150','OH','Milford','Clermont',39.17019,-84.246565),('45152','OH','Morrow','Warren',39.350726,-84.133754),('45153','OH','Moscow','Clermont',38.868744,-84.215548),('45154','OH','Mount Orab','Brown',39.045861,-83.923475),('45155','OH','Mowrystown','Highland',39.038389,-83.750634),('45156','OH','Neville','Clermont',38.811868,-84.213562),('45157','OH','New Richmond','Clermont',38.959803,-84.253452),('45158','OH','Newtonsville','Clermont',39.182205,-84.086103),('45159','OH','New Vienna','Clinton',39.324848,-83.694186),('45160','OH','Owensville','Clermont',39.123096,-84.135343),('45162','OH','Pleasant Plain','Warren',39.271498,-84.086044),('45164','OH','Port William','Clinton',39.553184,-83.785577),('45166','OH','Reesville','Clinton',39.481797,-83.678573),('45167','OH','Ripley','Brown',38.754339,-83.810988),('45168','OH','Russellville','Brown',38.859369,-83.759348),('45169','OH','Sabina','Clinton',39.514954,-83.65912),('45171','OH','Sardinia','Brown',38.984557,-83.784983),('45172','OH','Sinking Spring','Highland',39.07412,-83.387146),('45174','OH','Terrace Park','Hamilton',39.160134,-84.30851),('45176','OH','Williamsburg','Clermont',39.073329,-84.021239),('45177','OH','Wilmington','Clinton',39.456993,-83.852612),('45201','OH','Cincinnati','Hamilton',39.1063,-84.5356),('45202','OH','Cincinnati','Hamilton',39.108183,-84.509272),('45203','OH','Cincinnati','Hamilton',39.102519,-84.53153),('45204','OH','Cincinnati','Hamilton',39.096785,-84.570717),('45205','OH','Cincinnati','Hamilton',39.111708,-84.575151),('45206','OH','Cincinnati','Hamilton',39.126584,-84.488884),('45207','OH','Cincinnati','Hamilton',39.142246,-84.470101),('45208','OH','Cincinnati','Hamilton',39.13584,-84.433795),('45209','OH','Cincinnati','Hamilton',39.154229,-84.429432),('45211','OH','Cincinnati','Hamilton',39.1537,-84.603906),('45212','OH','Cincinnati','Hamilton',39.162137,-84.454861),('45213','OH','Cincinnati','Hamilton',39.179466,-84.420552),('45214','OH','Cincinnati','Hamilton',39.120632,-84.535237),('45215','OH','Cincinnati','Hamilton',39.231093,-84.456244),('45216','OH','Cincinnati','Hamilton',39.197712,-84.480302),('45217','OH','Cincinnati','Hamilton',39.166056,-84.497807),('45218','OH','Cincinnati','Hamilton',39.268978,-84.518802),('45219','OH','Cincinnati','Hamilton',39.1277,-84.512211),('45220','OH','Cincinnati','Hamilton',39.145723,-84.517532),('45221','OH','Cincinnati','Hamilton',39.1325,-84.5159),('45222','OH','Cincinnati','Hamilton',39.197,-84.4579),('45223','OH','Cincinnati','Hamilton',39.162129,-84.544713),('45224','OH','Cincinnati','Hamilton',39.205168,-84.537457),('45225','OH','Cincinnati','Hamilton',39.138828,-84.547998),('45226','OH','Cincinnati','Hamilton',39.116308,-84.430116),('45227','OH','Cincinnati','Hamilton',39.153239,-84.38659),('45228','OH','Cincinnati','Hamilton',39.0647,-84.4241),('45229','OH','Cincinnati','Hamilton',39.152154,-84.488484),('45230','OH','Cincinnati','Hamilton',39.079877,-84.389365),('45231','OH','Cincinnati','Hamilton',39.244679,-84.545074),('45232','OH','Cincinnati','Hamilton',39.175945,-84.512294),('45233','OH','Cincinnati','Hamilton',39.119519,-84.681017),('45234','OH','Cincinnati','Hamilton',39.2771,-84.4013),('45235','OH','Cincinnati','Hamilton',39.2771,-84.4013),('45236','OH','Cincinnati','Hamilton',39.205435,-84.395454),('45237','OH','Cincinnati','Hamilton',39.190137,-84.460813),('45238','OH','Cincinnati','Hamilton',39.112436,-84.608418),('45239','OH','Cincinnati','Hamilton',39.207956,-84.573836),('45240','OH','Cincinnati','Hamilton',39.284509,-84.529331),('45241','OH','Cincinnati','Hamilton',39.276362,-84.397108),('45242','OH','Cincinnati','Hamilton',39.24028,-84.36093),('45243','OH','Cincinnati','Hamilton',39.19042,-84.35483),('45244','OH','Cincinnati','Hamilton',39.119304,-84.333629),('45245','OH','Cincinnati','Clermont',39.065668,-84.274105),('45246','OH','Cincinnati','Hamilton',39.289272,-84.473206),('45247','OH','Cincinnati','Hamilton',39.210012,-84.637744),('45248','OH','Cincinnati','Hamilton',39.160235,-84.650681),('45249','OH','Cincinnati','Hamilton',39.278302,-84.330398),('45250','OH','Cincinnati','Hamilton',39.1145,-84.5359),('45251','OH','Cincinnati','Hamilton',39.259073,-84.588221),('45252','OH','Cincinnati','Hamilton',39.270192,-84.628137),('45253','OH','Cincinnati','Hamilton',39.23,-84.5897),('45254','OH','Cincinnati','Hamilton',39.0751,-84.3317),('45255','OH','Cincinnati','Hamilton',39.064877,-84.325866),('45258','OH','Cincinnati','Hamilton',39.1419,-84.6254),('45262','OH','Cincinnati','Hamilton',39.1212,-84.5448),('45263','OH','Cincinnati','Hamilton',39.1063,-84.5356),('45264','OH','Cincinnati','Hamilton',39.136,-84.5372),('45267','OH','Cincinnati','Hamilton',39.1396,-84.5038),('45268','OH','Cincinnati','Hamilton',39.1329,-84.5093),('45269','OH','Cincinnati','Hamilton',39.107,-84.4991),('45270','OH','Cincinnati','Hamilton',39.1063,-84.5356),('45271','OH','Cincinnati','Hamilton',39.1063,-84.5356),('45273','OH','Cincinnati','Hamilton',39.1063,-84.5356),('45274','OH','Cincinnati','Hamilton',39.136,-84.5372),('45275','OH','Cincinnati','Brown',39.0424,-84.6608),('45277','OH','Cincinnati','Hamilton',38.9846,-84.4889),('45280','OH','Cincinnati','Hamilton',39.1616,-84.4569),('45296','OH','Cincinnati','Hamilton',39.136,-84.5372),('45298','OH','Cincinnati','Hamilton',39.0678,-84.5309),('45299','OH','Cincinnati','Hamilton',39.1063,-84.5356),('45301','OH','Alpha','Greene',39.711446,-84.021566),('45302','OH','Anna','Shelby',40.403292,-84.191878),('45303','OH','Ansonia','Darke',40.214793,-84.645598),('45304','OH','Arcanum','Darke',39.991004,-84.538424),('45305','OH','Bellbrook','Greene',39.640797,-84.085678),('45306','OH','Botkins','Shelby',40.460565,-84.182942),('45307','OH','Bowersville','Greene',39.580062,-83.723527),('45308','OH','Bradford','Darke',40.123132,-84.447569),('45309','OH','Brookville','Montgomery',39.844821,-84.417944),('45310','OH','Burkettsville','Mercer',40.352096,-84.643783),('45311','OH','Camden','Preble',39.626451,-84.663662),('45312','OH','Casstown','Miami',40.062036,-84.095062),('45314','OH','Cedarville','Greene',39.746266,-83.793836),('45315','OH','Clayton','Montgomery',39.854564,-84.342981),('45316','OH','Clifton','Greene',39.796898,-83.825988),('45317','OH','Conover','Champaign',40.17057,-84.024116),('45318','OH','Covington','Miami',40.124834,-84.358199),('45319','OH','Donnelsville','Clark',39.918159,-83.946519),('45320','OH','Eaton','Preble',39.746757,-84.652441),('45321','OH','Eldorado','Preble',39.889686,-84.677464),('45322','OH','Englewood','Montgomery',39.877996,-84.310442),('45323','OH','Enon','Clark',39.86771,-83.936715),('45324','OH','Fairborn','Greene',39.809118,-84.017585),('45325','OH','Farmersville','Montgomery',39.684635,-84.422633),('45326','OH','Fletcher','Miami',40.140039,-84.109592),('45327','OH','Germantown','Montgomery',39.629644,-84.385474),('45328','OH','Gettysburg','Darke',40.113887,-84.493511),('45330','OH','Gratis','Preble',39.648271,-84.52774),('45331','OH','Greenville','Darke',40.096915,-84.634281),('45332','OH','Hollansburg','Darke',39.998439,-84.790098),('45333','OH','Houston','Shelby',40.254335,-84.332744),('45334','OH','Jackson Center','Shelby',40.443271,-84.04345),('45335','OH','Jamestown','Greene',39.6398,-83.741205),('45336','OH','Kettlersville','Shelby',40.439581,-84.263541),('45337','OH','Laura','Miami',39.988132,-84.414106),('45338','OH','Lewisburg','Preble',39.846716,-84.544369),('45339','OH','Ludlow Falls','Miami',40.00061,-84.340968),('45340','OH','Maplewood','Shelby',40.37565,-84.044722),('45341','OH','Medway','Clark',39.880386,-84.026059),('45342','OH','Miamisburg','Montgomery',39.628949,-84.268096),('45343','OH','Miamisburg','Montgomery',39.637,-84.265),('45344','OH','New Carlisle','Clark',39.939966,-84.024143),('45345','OH','New Lebanon','Montgomery',39.743083,-84.392493),('45346','OH','New Madison','Darke',39.974275,-84.705672),('45347','OH','New Paris','Preble',39.871376,-84.768083),('45348','OH','New Weston','Darke',40.329646,-84.64879),('45349','OH','North Hampton','Clark',39.989956,-83.939775),('45350','OH','North Star','Darke',40.326766,-84.57371),('45351','OH','Osgood','Darke',40.339025,-84.494684),('45352','OH','Palestine','Darke',40.05045,-84.743878),('45353','OH','Pemberton','Shelby',40.292435,-84.033361),('45354','OH','Phillipsburg','Montgomery',39.905203,-84.401588),('45356','OH','Piqua','Miami',40.155791,-84.238867),('45358','OH','Pitsburg','Darke',39.987281,-84.488049),('45359','OH','Pleasant Hill','Miami',40.052383,-84.34848),('45360','OH','Port Jefferson','Shelby',40.330159,-84.092195),('45361','OH','Potsdam','Miami',39.963682,-84.417085),('45362','OH','Rossburg','Darke',40.286295,-84.639423),('45363','OH','Russia','Shelby',40.239308,-84.40007),('45365','OH','Sidney','Shelby',40.284717,-84.16352),('45367','OH','Sidney','Shelby',40.2841,-84.1555),('45368','OH','South Charleston','Clark',39.858788,-83.66033),('45369','OH','South Vienna','Clark',39.942814,-83.603327),('45370','OH','Spring Valley','Greene',39.608306,-84.032996),('45371','OH','Tipp City','Miami',39.948485,-84.171226),('45372','OH','Tremont City','Clark',40.013828,-83.835218),('45373','OH','Troy','Miami',40.038203,-84.207531),('45374','OH','Troy','Miami',40.0366,-84.2057),('45377','OH','Vandalia','Montgomery',39.890585,-84.206391),('45378','OH','Verona','Preble',39.903878,-84.488712),('45380','OH','Versailles','Darke',40.231784,-84.499133),('45381','OH','West Alexandria','Preble',39.735509,-84.532871),('45382','OH','West Manchester','Preble',39.902452,-84.622608),('45383','OH','West Milton','Miami',39.957175,-84.331101),('45384','OH','Wilberforce','Greene',39.716271,-83.881455),('45385','OH','Xenia','Greene',39.682245,-83.928052),('45387','OH','Yellow Springs','Greene',39.797957,-83.882453),('45388','OH','Yorkshire','Darke',40.327999,-84.48022),('45389','OH','Christiansburg','Champaign',40.055788,-84.025195),('45390','OH','Union City','Darke',40.207985,-84.778208),('45400','OH','Dayton','Montgomery',39.763422,-84.198532),('45401','OH','Dayton','Montgomery',39.7578,-84.1777),('45402','OH','Dayton','Montgomery',39.757938,-84.207427),('45403','OH','Dayton','Montgomery',39.763003,-84.151916),('45404','OH','Dayton','Montgomery',39.783849,-84.165512),('45405','OH','Dayton','Montgomery',39.787558,-84.211005),('45406','OH','Dayton','Montgomery',39.781964,-84.237601),('45408','OH','Dayton','Montgomery',39.741558,-84.223627),('45409','OH','Dayton','Montgomery',39.728409,-84.187336),('45410','OH','Dayton','Montgomery',39.747357,-84.161346),('45412','OH','Dayton','Montgomery',39.7578,-84.1777),('45413','OH','Dayton','Montgomery',39.8225,-84.1914),('45414','OH','Dayton','Montgomery',39.824069,-84.194997),('45415','OH','Dayton','Montgomery',39.838903,-84.260616),('45416','OH','Dayton','Montgomery',39.804908,-84.257768),('45417','OH','Dayton','Montgomery',39.74444,-84.25098),('45418','OH','Dayton','Montgomery',39.700189,-84.259933),('45419','OH','Dayton','Montgomery',39.714333,-84.165114),('45420','OH','Dayton','Montgomery',39.724333,-84.135643),('45422','OH','Dayton','Montgomery',39.76,-84.1959),('45423','OH','Dayton','Montgomery',39.7578,-84.1777),('45424','OH','Dayton','Montgomery',39.83831,-84.122303),('45426','OH','Dayton','Montgomery',39.805504,-84.299998),('45427','OH','Dayton','Montgomery',39.755758,-84.278676),('45428','OH','Dayton','Montgomery',39.744004,-84.260088),('45429','OH','Dayton','Montgomery',39.687387,-84.159431),('45430','OH','Dayton','Greene',39.720308,-84.08314),('45431','OH','Dayton','Montgomery',39.767142,-84.091051),('45432','OH','Dayton','Greene',39.740826,-84.093301),('45433','OH','Dayton','Greene',39.800488,-84.057967),('45434','OH','Dayton','Greene',39.71889,-84.036358),('45435','OH','Dayton','Montgomery',39.7578,-84.1777),('45437','OH','Dayton','Montgomery',39.7692,-84.1226),('45439','OH','Dayton','Montgomery',39.696091,-84.216786),('45440','OH','Dayton','Montgomery',39.674125,-84.106375),('45441','OH','Dayton','Montgomery',39.6458,-84.1669),('45448','OH','Dayton','Montgomery',39.6325,-84.1564),('45449','OH','Dayton','Montgomery',39.664614,-84.242096),('45454','OH','Dayton','Montgomery',39.6976,-84.2213),('45458','OH','Dayton','Montgomery',39.610634,-84.167155),('45459','OH','Dayton','Montgomery',39.647433,-84.170599),('45463','OH','Dayton','Montgomery',39.7578,-84.1777),('45469','OH','Dayton','Montgomery',39.7331,-84.1804),('45470','OH','Dayton','Montgomery',39.6274,-84.2775),('45475','OH','Dayton','Montgomery',39.6371,-84.2205),('45479','OH','Dayton','Montgomery',39.7578,-84.1777),('45481','OH','Dayton','Montgomery',39.7578,-84.1777),('45482','OH','Dayton','Montgomery',39.7578,-84.1777),('45490','OH','Dayton','Montgomery',39.8968,-84.2227),('45501','OH','Springfield','Clark',39.8531,-83.8088),('45502','OH','Springfield','Clark',39.924252,-83.815189),('45503','OH','Springfield','Clark',39.948244,-83.782508),('45504','OH','Springfield','Clark',39.938151,-83.836555),('45505','OH','Springfield','Clark',39.910174,-83.778662),('45506','OH','Springfield','Clark',39.9102,-83.832414),('45601','OH','Chillicothe','Ross',39.330186,-82.97151),('45612','OH','Bainbridge','Ross',39.229039,-83.284474),('45613','OH','Beaver','Pike',39.012479,-82.853561),('45614','OH','Bidwell','Gallia',38.918909,-82.29522),('45616','OH','Blue Creek','Adams',38.782744,-83.322745),('45617','OH','Bourneville','Ross',39.280815,-83.159081),('45618','OH','Cherry Fork','Adams',38.885494,-83.616413),('45619','OH','Chesapeake','Lawrence',38.449146,-82.460858),('45620','OH','Cheshire','Gallia',38.947907,-82.133055),('45621','OH','Coalton','Jackson',39.11141,-82.61088),('45622','OH','Creola','Vinton',39.375004,-82.490842),('45623','OH','Crown City','Gallia',38.631981,-82.272434),('45624','OH','Cynthiana','Pike',39.173046,-83.34766),('45628','OH','Frankfort','Ross',39.389145,-83.1938),('45629','OH','Franklin Furnace','Scioto',38.656319,-82.826173),('45630','OH','Friendship','Scioto',38.69861,-83.094086),('45631','OH','Gallipolis','Gallia',38.820254,-82.22791),('45633','OH','Hallsville','Ross',39.4438,-82.8272),('45634','OH','Hamden','Vinton',39.170163,-82.500124),('45636','OH','Haverhill','Scioto',38.588554,-82.82245),('45638','OH','Ironton','Lawrence',38.537931,-82.677404),('45640','OH','Jackson','Jackson',39.034549,-82.636523),('45642','OH','Jasper','Pike',39.047577,-83.053826),('45643','OH','Kerr','Gallia',38.8727,-82.2608),('45644','OH','Kingston','Ross',39.457491,-82.879537),('45645','OH','Kitts Hill','Lawrence',38.556564,-82.535562),('45646','OH','Latham','Pike',39.084857,-83.311827),('45647','OH','Londonderry','Ross',39.286069,-82.750841),('45648','OH','Lucasville','Scioto',38.905789,-82.998531),('45650','OH','Lynx','Adams',38.738286,-83.422082),('45651','OH','Mc Arthur','Vinton',39.270882,-82.472076),('45652','OH','Mc Dermott','Scioto',38.834602,-83.075483),('45653','OH','Minford','Scioto',38.878113,-82.840818),('45654','OH','New Plymouth','Vinton',39.367206,-82.392271),('45656','OH','Oak Hill','Jackson',38.891401,-82.582193),('45657','OH','Otway','Scioto',38.862618,-83.218763),('45658','OH','Patriot','Gallia',38.775669,-82.41398),('45659','OH','Pedro','Lawrence',38.673192,-82.63442),('45660','OH','Peebles','Adams',38.981802,-83.368006),('45661','OH','Piketon','Pike',39.037901,-83.057522),('45662','OH','Portsmouth','Scioto',38.755263,-82.939713),('45663','OH','West Portsmouth','Scioto',38.74766,-83.057358),('45669','OH','Proctorville','Lawrence',38.470857,-82.358867),('45671','OH','Rarden','Scioto',38.93724,-83.241572),('45672','OH','Ray','Jackson',39.206169,-82.694132),('45673','OH','Richmond Dale','Ross',39.203375,-82.814478),('45674','OH','Rio Grande','Gallia',38.882422,-82.374668),('45675','OH','Rock Camp','Lawrence',38.5215,-82.5698),('45677','OH','Scioto Furnace','Scioto',38.7986,-82.765),('45678','OH','Scottown','Lawrence',38.595997,-82.374443),('45679','OH','Seaman','Adams',38.953396,-83.560616),('45680','OH','South Point','Lawrence',38.429138,-82.559005),('45681','OH','South Salem','Ross',39.308342,-83.256236),('45682','OH','South Webster','Scioto',38.809212,-82.708822),('45683','OH','Stockdale','Pike',39.0245,-82.8483),('45684','OH','Stout','Scioto',38.646984,-83.27482),('45685','OH','Thurman','Gallia',38.916008,-82.452248),('45686','OH','Vinton','Gallia',39.004336,-82.360606),('45687','OH','Wakefield','Pike',38.9702,-83.02),('45688','OH','Waterloo','Lawrence',38.727454,-82.509225),('45690','OH','Waverly','Pike',39.123951,-82.999593),('45692','OH','Wellston','Jackson',39.11876,-82.548851),('45693','OH','West Union','Adams',38.794289,-83.540531),('45694','OH','Wheelersburg','Scioto',38.730499,-82.816301),('45695','OH','Wilkesville','Vinton',39.145816,-82.362044),('45696','OH','Willow Wood','Lawrence',38.593115,-82.460773),('45697','OH','Winchester','Adams',38.939346,-83.669974),('45698','OH','Zaleski','Vinton',39.283986,-82.394309),('45699','OH','Lucasville','Scioto',38.8794,-82.9969),('45701','OH','Athens','Athens',39.323429,-82.098284),('45710','OH','Albany','Athens',39.208497,-82.228941),('45711','OH','Amesville','Athens',39.428432,-81.931976),('45712','OH','Barlow','Washington',39.40032,-81.662093),('45713','OH','Bartlett','Washington',39.419647,-81.816403),('45714','OH','Belpre','Washington',39.296646,-81.606917),('45715','OH','Beverly','Washington',39.583119,-81.632851),('45716','OH','Buchtel','Athens',39.461077,-82.181674),('45717','OH','Carbondale','Athens',39.3777,-82.2711),('45719','OH','Chauncey','Athens',39.400596,-82.127702),('45720','OH','Chester','Meigs',39.0875,-81.9227),('45721','OH','Coal Run','Washington',39.565044,-81.583992),('45723','OH','Coolville','Athens',39.220258,-81.81303),('45724','OH','Cutler','Washington',39.379315,-81.788213),('45727','OH','Dexter City','Noble',39.656237,-81.474256),('45729','OH','Fleming','Washington',39.414862,-81.600372),('45732','OH','Glouster','Athens',39.508816,-82.074687),('45734','OH','Graysville','Monroe',39.655335,-81.192523),('45735','OH','Guysville','Athens',39.261786,-81.928198),('45739','OH','Hockingport','Athens',39.188,-81.7519),('45740','OH','Jacksonville','Athens',39.475711,-82.080769),('45741','OH','Langsville','Meigs',39.075062,-82.247085),('45742','OH','Little Hocking','Washington',39.270078,-81.706226),('45743','OH','Long Bottom','Meigs',39.070523,-81.849754),('45744','OH','Lowell','Washington',39.530343,-81.504036),('45745','OH','Lower Salem','Washington',39.600947,-81.348997),('45746','OH','Macksburg','Washington',39.613401,-81.457672),('45750','OH','Marietta','Washington',39.424307,-81.434442),('45760','OH','Middleport','Meigs',39.006752,-82.08211),('45761','OH','Millfield','Athens',39.431439,-82.09326),('45764','OH','Nelsonville','Athens',39.452314,-82.231253),('45766','OH','New Marshfield','Athens',39.325249,-82.257669),('45767','OH','New Matamoras','Washington',39.538892,-81.126733),('45768','OH','Newport','Washington',39.399861,-81.252656),('45769','OH','Pomeroy','Meigs',39.089833,-82.028541),('45770','OH','Portland','Meigs',38.990342,-81.799228),('45771','OH','Racine','Meigs',38.987889,-81.902447),('45772','OH','Reedsville','Meigs',39.1371,-81.827587),('45773','OH','Reno','Washington',39.462691,-81.261885),('45775','OH','Rutland','Meigs',39.075477,-82.159435),('45776','OH','Shade','Meigs',39.192535,-82.025518),('45777','OH','Sharpsburg','Athens',39.4406,-81.9126),('45778','OH','Stewart','Athens',39.340043,-81.886087),('45779','OH','Syracuse','Meigs',38.997655,-81.974455),('45780','OH','The Plains','Athens',39.370401,-82.133486),('45782','OH','Trimble','Athens',39.485027,-82.078396),('45783','OH','Tuppers Plains','Meigs',39.1686,-81.8466),('45784','OH','Vincent','Washington',39.388458,-81.678142),('45786','OH','Waterford','Washington',39.524745,-81.662015),('45787','OH','Watertown','Washington',39.468248,-81.632005),('45788','OH','Whipple','Washington',39.509259,-81.378514),('45789','OH','Wingett Run','Washington',39.548192,-81.254725),('45801','OH','Lima','Allen',40.760198,-84.084556),('45802','OH','Lima','Allen',40.7413,-84.1086),('45804','OH','Lima','Allen',40.722471,-84.089388),('45805','OH','Lima','Allen',40.738978,-84.14611),('45806','OH','Lima','Allen',40.674863,-84.13105),('45807','OH','Lima','Allen',40.796269,-84.165444),('45808','OH','Beaverdam','Allen',40.832488,-83.973383),('45809','OH','Gomer','Allen',40.844841,-84.186292),('45810','OH','Ada','Hardin',40.772896,-83.822433),('45812','OH','Alger','Hardin',40.689296,-83.818521),('45813','OH','Antwerp','Paulding',41.188422,-84.735145),('45814','OH','Arlington','Hancock',40.899318,-83.630161),('45815','OH','Belmore','Putnam',41.0972,-83.9855),('45816','OH','Benton Ridge','Hancock',41.00437,-83.794051),('45817','OH','Bluffton','Allen',40.882395,-83.898659),('45819','OH','Buckland','Auglaize',40.623446,-84.260112),('45820','OH','Cairo','Allen',40.83121,-84.084396),('45821','OH','Cecil','Paulding',41.227429,-84.587644),('45822','OH','Celina','Mercer',40.542291,-84.579848),('45826','OH','Chickasaw','Mercer',40.436635,-84.493241),('45827','OH','Cloverdale','Putnam',41.009962,-84.298785),('45828','OH','Coldwater','Mercer',40.480125,-84.64751),('45830','OH','Columbus Grove','Putnam',40.906437,-84.081512),('45831','OH','Continental','Putnam',41.114668,-84.256608),('45832','OH','Convoy','Van Wert',40.931557,-84.722055),('45833','OH','Delphos','Allen',40.841261,-84.340701),('45835','OH','Dola','Hardin',40.768885,-83.699897),('45836','OH','Dunkirk','Hardin',40.791407,-83.642135),('45837','OH','Dupont','Putnam',41.054934,-84.300757),('45838','OH','Elgin','Van Wert',40.739782,-84.476915),('45839','OH','Findlay','Hancock',41.0441,-83.65),('45840','OH','Findlay','Hancock',41.03967,-83.644818),('45841','OH','Jenera','Hancock',40.888476,-83.732018),('45843','OH','Forest','Hardin',40.783055,-83.5286),('45844','OH','Fort Jennings','Putnam',40.91141,-84.27566),('45845','OH','Fort Loramie','Shelby',40.325498,-84.37405),('45846','OH','Fort Recovery','Mercer',40.404818,-84.759217),('45848','OH','Glandorf','Putnam',41.0288,-84.0791),('45849','OH','Grover Hill','Paulding',41.003896,-84.453421),('45850','OH','Harrod','Allen',40.711643,-83.931046),('45851','OH','Haviland','Paulding',41.02626,-84.60182),('45853','OH','Kalida','Putnam',40.984581,-84.20062),('45854','OH','Lafayette','Allen',40.759743,-83.950651),('45855','OH','Latty','Paulding',41.08726,-84.585206),('45856','OH','Leipsic','Putnam',41.113072,-83.991075),('45858','OH','Mc Comb','Hancock',41.106285,-83.803399),('45859','OH','Mc Guffey','Hardin',40.691926,-83.784645),('45860','OH','Maria Stein','Mercer',40.399268,-84.504127),('45861','OH','Melrose','Paulding',41.089789,-84.421007),('45862','OH','Mendon','Mercer',40.668094,-84.519436),('45863','OH','Middle Point','Van Wert',40.896706,-84.450402),('45864','OH','Miller City','Putnam',41.103212,-84.132015),('45865','OH','Minster','Auglaize',40.387086,-84.368231),('45866','OH','Montezuma','Mercer',40.489987,-84.549111),('45867','OH','Mount Blanchard','Hancock',40.902194,-83.543109),('45868','OH','Mount Cory','Hancock',40.958891,-83.835836),('45869','OH','New Bremen','Auglaize',40.44578,-84.38715),('45870','OH','New Hampshire','Auglaize',40.555845,-83.953088),('45871','OH','New Knoxville','Auglaize',40.493097,-84.312722),('45872','OH','North Baltimore','Wood',41.184068,-83.6692),('45873','OH','Oakwood','Paulding',41.106744,-84.393462),('45874','OH','Ohio City','Van Wert',40.781637,-84.656556),('45875','OH','Ottawa','Putnam',41.022225,-84.046015),('45876','OH','Ottoville','Putnam',40.929827,-84.340394),('45877','OH','Pandora','Putnam',40.951244,-83.949843),('45879','OH','Paulding','Paulding',41.128003,-84.563586),('45880','OH','Payne','Paulding',41.071213,-84.732946),('45881','OH','Rawson','Hancock',40.954854,-83.781874),('45882','OH','Rockford','Mercer',40.683521,-84.658842),('45883','OH','Saint Henry','Mercer',40.414095,-84.632176),('45884','OH','Saint Johns','Auglaize',40.555439,-84.082811),('45885','OH','Saint Marys','Auglaize',40.556015,-84.391977),('45886','OH','Scott','Van Wert',40.986773,-84.608017),('45887','OH','Spencerville','Allen',40.712336,-84.349516),('45888','OH','Uniopolis','Auglaize',40.602153,-84.087117),('45889','OH','Van Buren','Hancock',41.1408,-83.644277),('45890','OH','Vanlue','Hancock',40.972825,-83.488288),('45891','OH','Van Wert','Van Wert',40.874067,-84.578876),('45893','OH','Vaughnsville','Putnam',40.8816,-84.1505),('45894','OH','Venedocia','Van Wert',40.770279,-84.463169),('45895','OH','Wapakoneta','Auglaize',40.570808,-84.17008),('45896','OH','Waynesfield','Auglaize',40.601048,-83.95671),('45897','OH','Williamstown','Hancock',40.83419,-83.65502),('45898','OH','Willshire','Van Wert',40.743473,-84.769653),('45899','OH','Wren','Van Wert',40.799821,-84.774098),('45999','OH','Cincinnati','Hamilton',39.0678,-84.5309),('46001','IN','Alexandria','Madison',40.256388,-85.671788),('46011','IN','Anderson','Madison',40.112787,-85.736981),('46012','IN','Anderson','Madison',40.132822,-85.651146),('46013','IN','Anderson','Madison',40.061152,-85.676647),('46014','IN','Anderson','Madison',40.0865,-85.6837),('46015','IN','Anderson','Madison',40.1059,-85.6784),('46016','IN','Anderson','Madison',40.098777,-85.684526),('46017','IN','Anderson','Madison',40.098286,-85.60152),('46018','IN','Anderson','Madison',40.1052,-85.6802),('46030','IN','Arcadia','Hamilton',40.172388,-86.01578),('46031','IN','Atlanta','Hamilton',40.211118,-86.024467),('46032','IN','Carmel','Hamilton',39.970322,-86.159502),('46033','IN','Carmel','Hamilton',39.980047,-86.087873),('46034','IN','Cicero','Hamilton',40.124518,-86.030928),('46035','IN','Colfax','Clinton',40.191328,-86.672412),('46036','IN','Elwood','Madison',40.27842,-85.835867),('46037','IN','Fishers','Hamilton',39.96086,-85.954102),('46038','IN','Fishers','Hamilton',39.969678,-86.013618),('46039','IN','Forest','Clinton',40.361865,-86.32024),('46040','IN','Fortville','Hancock',39.934105,-85.84871),('46041','IN','Frankfort','Clinton',40.289314,-86.501917),('46044','IN','Frankton','Madison',40.22217,-85.777531),('46045','IN','Goldsmith','Tipton',40.288512,-86.148613),('46047','IN','Hobbs','Tipton',40.28424,-85.94796),('46048','IN','Ingalls','Madison',39.955884,-85.804417),('46049','IN','Kempton','Tipton',40.292236,-86.227397),('46050','IN','Kirklin','Clinton',40.197031,-86.358914),('46051','IN','Lapel','Madison',40.064124,-85.846295),('46052','IN','Lebanon','Boone',40.046218,-86.466562),('46055','IN','Mc Cordsville','Hancock',39.899219,-85.917111),('46056','IN','Markleville','Madison',39.976133,-85.614083),('46057','IN','Michigantown','Clinton',40.325182,-86.389534),('46058','IN','Mulberry','Clinton',40.345998,-86.663263),('46060','IN','Noblesville','Hamilton',40.043293,-85.972565),('46061','IN','Noblesville','Hamilton',40.0394,-86.0015),('46062','IN','Noblesville','Hamilton',40.056435,-86.051382),('46063','IN','Orestes','Madison',40.269631,-85.726296),('46064','IN','Pendleton','Madison',39.997287,-85.75621),('46065','IN','Rossville','Clinton',40.432733,-86.612713),('46067','IN','Sedalia','Clinton',40.4155,-86.5147),('46068','IN','Sharpsville','Tipton',40.378925,-86.096192),('46069','IN','Sheridan','Hamilton',40.13842,-86.223646),('46070','IN','Summitville','Madison',40.341061,-85.646458),('46071','IN','Thorntown','Boone',40.127745,-86.598818),('46072','IN','Tipton','Tipton',40.28326,-86.050716),('46074','IN','Westfield','Hamilton',40.027951,-86.167514),('46075','IN','Whitestown','Boone',39.9913,-86.352178),('46076','IN','Windfall','Tipton',40.363638,-85.950824),('46077','IN','Zionsville','Boone',39.961671,-86.285634),('46082','IN','Carmel','Hamilton',39.9664,-86.1694),('46085','IN','Fishers','Hamilton',39.958335,-86.017091),('46102','IN','Advance','Boone',39.996577,-86.619289),('46103','IN','Amo','Hendricks',39.688577,-86.613995),('46104','IN','Arlington','Rush',39.650236,-85.58478),('46105','IN','Bainbridge','Putnam',39.762028,-86.804659),('46106','IN','Bargersville','Johnson',39.528734,-86.191589),('46107','IN','Beech Grove','Marion',39.717199,-86.093978),('46110','IN','Boggstown','Shelby',39.568289,-85.924052),('46111','IN','Brooklyn','Morgan',39.538061,-86.36952),('46112','IN','Brownsburg','Hendricks',39.849431,-86.387505),('46113','IN','Camby','Marion',39.629155,-86.313011),('46115','IN','Carthage','Rush',39.738938,-85.572314),('46117','IN','Charlottesville','Hancock',39.803683,-85.6143),('46118','IN','Clayton','Hendricks',39.662376,-86.518005),('46120','IN','Cloverdale','Putnam',39.511144,-86.799924),('46121','IN','Coatesville','Putnam',39.685569,-86.675741),('46122','IN','Danville','Hendricks',39.763275,-86.520984),('46123','IN','Avon','Hendricks',39.762858,-86.393326),('46124','IN','Edinburgh','Johnson',39.356498,-85.962709),('46125','IN','Eminence','Morgan',39.521887,-86.640916),('46126','IN','Fairland','Shelby',39.61382,-85.889776),('46127','IN','Falmouth','Rush',39.720817,-85.325891),('46128','IN','Fillmore','Putnam',39.662988,-86.747179),('46129','IN','Finly','Hancock',39.798,-85.7621),('46130','IN','Fountaintown','Shelby',39.679873,-85.829309),('46131','IN','Franklin','Johnson',39.482375,-86.052955),('46133','IN','Glenwood','Fayette',39.607962,-85.308994),('46135','IN','Greencastle','Putnam',39.6492,-86.876748),('46140','IN','Greenfield','Hancock',39.803675,-85.782401),('46142','IN','Greenwood','Johnson',39.620092,-86.153075),('46143','IN','Greenwood','Johnson',39.596514,-86.130852),('46144','IN','Gwynneville','Shelby',39.661059,-85.649578),('46146','IN','Homer','Rush',39.577735,-85.576534),('46147','IN','Jamestown','Boone',39.96593,-86.619868),('46148','IN','Knightstown','Henry',39.804432,-85.518746),('46149','IN','Lizton','Hendricks',39.889277,-86.550566),('46150','IN','Manilla','Rush',39.563216,-85.611973),('46151','IN','Martinsville','Morgan',39.442604,-86.413301),('46154','IN','Maxwell','Hancock',39.798,-85.7621),('46155','IN','Mays','Rush',39.743935,-85.429203),('46156','IN','Milroy','Rush',39.487245,-85.477039),('46157','IN','Monrovia','Morgan',39.559917,-86.509551),('46158','IN','Mooresville','Morgan',39.593564,-86.376641),('46160','IN','Morgantown','Brown',39.354587,-86.261486),('46161','IN','Morristown','Shelby',39.674281,-85.70092),('46162','IN','Needham','Johnson',39.54744,-85.957514),('46163','IN','New Palestine','Hancock',39.728041,-85.899231),('46164','IN','Nineveh','Johnson',39.320058,-86.117397),('46165','IN','North Salem','Hendricks',39.852136,-86.644931),('46166','IN','Paragon','Morgan',39.416804,-86.575565),('46167','IN','Pittsboro','Hendricks',39.864825,-86.457419),('46168','IN','Plainfield','Hendricks',39.699121,-86.392309),('46170','IN','Putnamville','Putnam',39.5746,-86.8643),('46171','IN','Reelsville','Putnam',39.525102,-86.960902),('46172','IN','Roachdale','Putnam',39.842438,-86.83188),('46173','IN','Rushville','Rush',39.609514,-85.43652),('46175','IN','Russellville','Putnam',39.840997,-86.986027),('46176','IN','Shelbyville','Shelby',39.524077,-85.771039),('46180','IN','Stilesville','Hendricks',39.603706,-86.631004),('46181','IN','Trafalgar','Johnson',39.388236,-86.16502),('46182','IN','Waldron','Shelby',39.456595,-85.667115),('46183','IN','West Newton','Marion',39.653447,-86.280865),('46184','IN','Whiteland','Johnson',39.558067,-86.090076),('46186','IN','Wilkinson','Hancock',39.89348,-85.626135),('46201','IN','Indianapolis','Marion',39.775482,-86.110232),('46202','IN','Indianapolis','Marion',39.782781,-86.156626),('46203','IN','Indianapolis','Marion',39.740164,-86.115489),('46204','IN','Indianapolis','Marion',39.773012,-86.155598),('46205','IN','Indianapolis','Marion',39.824655,-86.135978),('46206','IN','Indianapolis','Marion',39.761,-86.161),('46207','IN','Indianapolis','Marion',39.761,-86.161),('46208','IN','Indianapolis','Marion',39.819104,-86.171087),('46209','IN','Indianapolis','Marion',39.761,-86.161),('46211','IN','Indianapolis','Marion',39.9036,-86.069),('46214','IN','Indianapolis','Marion',39.792817,-86.291529),('46216','IN','Indianapolis','Marion',39.858789,-86.009917),('46217','IN','Indianapolis','Marion',39.665723,-86.184784),('46218','IN','Indianapolis','Marion',39.805991,-86.101701),('46219','IN','Indianapolis','Marion',39.779994,-86.049239),('46220','IN','Indianapolis','Marion',39.867102,-86.123462),('46221','IN','Indianapolis','Marion',39.717807,-86.223181),('46222','IN','Indianapolis','Marion',39.785882,-86.212883),('46223','IN','Indianapolis','Marion',39.761,-86.161),('46224','IN','Indianapolis','Marion',39.796021,-86.256498),('46225','IN','Indianapolis','Marion',39.74741,-86.158698),('46226','IN','Indianapolis','Marion',39.836623,-86.051762),('46227','IN','Indianapolis','Marion',39.676864,-86.131261),('46228','IN','Indianapolis','Marion',39.849543,-86.204501),('46229','IN','Indianapolis','Marion',39.788484,-85.977075),('46230','IN','Indianapolis','Marion',39.8686,-86.1443),('46231','IN','Indianapolis','Marion',39.725109,-86.323776),('46234','IN','Indianapolis','Marion',39.800576,-86.326403),('46235','IN','Indianapolis','Marion',39.832709,-85.986179),('46236','IN','Indianapolis','Marion',39.886133,-85.964769),('46237','IN','Indianapolis','Marion',39.678759,-86.080547),('46239','IN','Indianapolis','Marion',39.723575,-86.011153),('46240','IN','Indianapolis','Marion',39.903931,-86.128958),('46241','IN','Indianapolis','Marion',39.736208,-86.252127),('46242','IN','Indianapolis','Marion',39.7279,-86.2559),('46244','IN','Indianapolis','Marion',39.7735,-86.1583),('46247','IN','Indianapolis','Marion',39.6792,-86.1317),('46249','IN','Indianapolis','Marion',39.8552,-86.0138),('46250','IN','Indianapolis','Marion',39.905904,-86.067388),('46251','IN','Indianapolis','Marion',39.7269,-86.268),('46253','IN','Indianapolis','Marion',39.8282,-86.2721),('46254','IN','Indianapolis','Marion',39.844091,-86.264747),('46255','IN','Indianapolis','Marion',39.761,-86.161),('46256','IN','Indianapolis','Marion',39.906054,-86.016265),('46259','IN','Indianapolis','Marion',39.657661,-85.991294),('46260','IN','Indianapolis','Marion',39.900244,-86.181944),('46262','IN','Indianapolis','Marion',39.8269,-86.2374),('46266','IN','Indianapolis','Marion',39.761,-86.161),('46268','IN','Indianapolis','Marion',39.897779,-86.226254),('46274','IN','Indianapolis','Marion',39.9036,-86.069),('46275','IN','Indianapolis','Marion',39.761,-86.161),('46277','IN','Indianapolis','Marion',39.761,-86.161),('46278','IN','Indianapolis','Marion',39.901189,-86.292056),('46280','IN','Indianapolis','Hamilton',39.938989,-86.132858),('46282','IN','Indianapolis','Marion',39.761,-86.161),('46283','IN','Indianapolis','Marion',39.761,-86.161),('46285','IN','Indianapolis','Marion',39.761,-86.161),('46290','IN','Indianapolis','Hamilton',39.934016,-86.163275),('46291','IN','Indianapolis','Marion',39.761,-86.161),('46295','IN','Indianapolis','Marion',39.673,-86.1931),('46296','IN','Indianapolis','Marion',39.7683,-86.1582),('46298','IN','Indianapolis','Marion',39.8966,-86.2313),('46301','IN','Beverly Shores','Porter',41.68326,-86.984107),('46302','IN','Boone Grove','Porter',41.3547,-87.1294),('46303','IN','Cedar Lake','Lake',41.371528,-87.448059),('46304','IN','Chesterton','Porter',41.609882,-87.059787),('46307','IN','Crown Point','Lake',41.418135,-87.342497),('46308','IN','Crown Point','Lake',41.3981,-87.328),('46310','IN','Demotte','Jasper',41.176686,-87.235),('46311','IN','Dyer','Lake',41.487288,-87.508355),('46312','IN','East Chicago','Lake',41.638983,-87.462421),('46319','IN','Griffith','Lake',41.53092,-87.424123),('46320','IN','Hammond','Lake',41.618832,-87.507417),('46321','IN','Munster','Lake',41.551437,-87.502006),('46322','IN','Highland','Lake',41.54996,-87.45881),('46323','IN','Hammond','Lake',41.589453,-87.454935),('46324','IN','Hammond','Lake',41.583767,-87.504417),('46325','IN','Hammond','Lake',41.6139,-87.5134),('46327','IN','Hammond','Lake',41.634698,-87.509355),('46340','IN','Hanna','La Porte',41.397139,-86.7705),('46341','IN','Hebron','Porter',41.327458,-87.211332),('46342','IN','Hobart','Lake',41.533627,-87.262806),('46345','IN','Kingsbury','La Porte',41.527187,-86.700328),('46346','IN','Kingsford Heights','La Porte',41.478448,-86.692453),('46347','IN','Kouts','Porter',41.314495,-87.012514),('46348','IN','La Crosse','La Porte',41.308887,-86.879446),('46349','IN','Lake Village','Newton',41.11198,-87.424918),('46350','IN','La Porte','La Porte',41.605565,-86.718432),('46352','IN','La Porte','La Porte',41.5597,-86.7031),('46355','IN','Leroy','Lake',41.36,-87.2719),('46356','IN','Lowell','Lake',41.28105,-87.409855),('46360','IN','Michigan City','La Porte',41.707551,-86.877952),('46361','IN','Michigan City','La Porte',41.7179,-86.9038),('46365','IN','Mill Creek','La Porte',41.602177,-86.528284),('46366','IN','North Judson','Starke',41.216005,-86.766998),('46368','IN','Portage','Porter',41.582186,-87.181226),('46371','IN','Rolling Prairie','La Porte',41.677291,-86.606505),('46372','IN','Roselawn','Newton',40.9472,-87.4548),('46373','IN','Saint John','Lake',41.446942,-87.471253),('46374','IN','San Pierre','Starke',41.215566,-86.891933),('46375','IN','Schererville','Lake',41.491453,-87.452867),('46376','IN','Schneider','Lake',41.186602,-87.45254),('46377','IN','Shelby','Lake',41.193042,-87.345455),('46379','IN','Sumava Resorts','Newton',41.167053,-87.437907),('46380','IN','Tefft','Jasper',41.1948,-86.9686),('46381','IN','Thayer','Newton',41.171761,-87.331399),('46382','IN','Union Mills','La Porte',41.478902,-86.773099),('46383','IN','Valparaiso','Porter',41.476959,-87.032072),('46384','IN','Valparaiso','Porter',41.4436,-87.0595),('46385','IN','Valparaiso','Porter',41.489747,-87.108185),('46390','IN','Wanatah','La Porte',41.427427,-86.884624),('46391','IN','Westville','La Porte',41.555017,-86.909167),('46392','IN','Wheatfield','Jasper',41.188774,-87.051766),('46393','IN','Wheeler','Porter',41.51051,-87.179188),('46394','IN','Whiting','Lake',41.678152,-87.499495),('46401','IN','Gary','Lake',41.5933,-87.3463),('46402','IN','Gary','Lake',41.59929,-87.337468),('46403','IN','Gary','Lake',41.603361,-87.262197),('46404','IN','Gary','Lake',41.58921,-87.372867),('46405','IN','Lake Station','Lake',41.570895,-87.257495),('46406','IN','Gary','Lake',41.596673,-87.408331),('46407','IN','Gary','Lake',41.58063,-87.336306),('46408','IN','Gary','Lake',41.542703,-87.358205),('46409','IN','Gary','Lake',41.544837,-87.326102),('46410','IN','Merrillville','Lake',41.486953,-87.340574),('46411','IN','Merrillville','Lake',41.4721,-87.3788),('46501','IN','Argos','Marshall',41.232998,-86.251181),('46502','IN','Atwood','Kosciusko',41.259173,-85.976088),('46504','IN','Bourbon','Marshall',41.299409,-86.112156),('46506','IN','Bremen','Marshall',41.453962,-86.165636),('46507','IN','Bristol','Elkhart',41.720839,-85.820483),('46508','IN','Burket','Kosciusko',41.155228,-85.969895),('46510','IN','Claypool','Kosciusko',41.122041,-85.887406),('46511','IN','Culver','Marshall',41.218524,-86.42421),('46513','IN','Donaldson','Marshall',41.361567,-86.445459),('46514','IN','Elkhart','Elkhart',41.708983,-85.974148),('46515','IN','Elkhart','Elkhart',41.682,-85.971),('46516','IN','Elkhart','Elkhart',41.676217,-85.960768),('46517','IN','Elkhart','Elkhart',41.649693,-85.97413),('46524','IN','Etna Green','Kosciusko',41.28158,-86.030993),('46526','IN','Goshen','Elkhart',41.57094,-85.843408),('46527','IN','Goshen','Elkhart',41.589,-85.8412),('46528','IN','Goshen','Elkhart',41.602028,-85.820443),('46530','IN','Granger','St. Joseph',41.740241,-86.142393),('46531','IN','Grovertown','Starke',41.366962,-86.505863),('46532','IN','Hamlet','Starke',41.404868,-86.603106),('46534','IN','Knox','Starke',41.281567,-86.614874),('46536','IN','Lakeville','St. Joseph',41.521533,-86.278301),('46537','IN','Lapaz','Marshall',41.458926,-86.307361),('46538','IN','Leesburg','Kosciusko',41.321687,-85.789138),('46539','IN','Mentone','Kosciusko',41.169062,-86.01156),('46540','IN','Middlebury','Elkhart',41.676549,-85.696844),('46542','IN','Milford','Kosciusko',41.407442,-85.858791),('46543','IN','Millersburg','Elkhart',41.532558,-85.683718),('46544','IN','Mishawaka','St. Joseph',41.65087,-86.163077),('46545','IN','Mishawaka','St. Joseph',41.682167,-86.16972),('46546','IN','Mishawaka','St Joseph',41.6118,-86.1383),('46550','IN','Nappanee','Elkhart',41.443372,-85.995613),('46552','IN','New Carlisle','St. Joseph',41.703994,-86.500823),('46553','IN','New Paris','Elkhart',41.491851,-85.840154),('46554','IN','North Liberty','St. Joseph',41.557413,-86.416992),('46555','IN','North Webster','Kosciusko',41.320446,-85.690341),('46556','IN','Notre Dame','St. Joseph',41.704067,-86.250654),('46561','IN','Osceola','St. Joseph',41.676623,-86.077526),('46562','IN','Pierceton','Kosciusko',41.227619,-85.700074),('46563','IN','Plymouth','Marshall',41.349498,-86.325106),('46565','IN','Shipshewana','Lagrange',41.692527,-85.581282),('46567','IN','Syracuse','Kosciusko',41.40964,-85.734777),('46570','IN','Tippecanoe','Marshall',41.207976,-86.120079),('46571','IN','Topeka','Lagrange',41.558284,-85.546921),('46572','IN','Tyner','Marshall',41.4097,-86.4025),('46573','IN','Wakarusa','Elkhart',41.535139,-86.032806),('46574','IN','Walkerton','St. Joseph',41.467738,-86.489005),('46580','IN','Warsaw','Kosciusko',41.231412,-85.864099),('46581','IN','Warsaw','Kosciusko',41.238,-85.853),('46582','IN','Warsaw','Kosciusko',41.281092,-85.818639),('46590','IN','Winona Lake','Kosciusko',41.221287,-85.816775),('46595','IN','Wyatt','St. Joseph',41.526586,-86.168427),('46601','IN','South Bend','St. Joseph',41.671621,-86.253094),('46604','IN','South Bend','St Joseph',41.6833,-86.25),('46613','IN','South Bend','St. Joseph',41.65508,-86.247477),('46614','IN','South Bend','St. Joseph',41.626827,-86.251257),('46615','IN','South Bend','St. Joseph',41.668906,-86.210146),('46616','IN','South Bend','St. Joseph',41.691539,-86.264735),('46617','IN','South Bend','St. Joseph',41.684563,-86.237526),('46619','IN','South Bend','St. Joseph',41.666666,-86.306592),('46620','IN','South Bend','St Joseph',41.6833,-86.25),('46624','IN','South Bend','St Joseph',41.6833,-86.25),('46626','IN','South Bend','St Joseph',41.6833,-86.25),('46628','IN','South Bend','St. Joseph',41.70112,-86.300672),('46634','IN','South Bend','St Joseph',41.6833,-86.25),('46635','IN','South Bend','St. Joseph',41.711091,-86.205516),('46637','IN','South Bend','St. Joseph',41.727145,-86.242644),('46660','IN','South Bend','St Joseph',41.6944,-86.2143),('46680','IN','South Bend','St Joseph',41.5762,-86.2407),('46699','IN','South Bend','St Joseph',41.6833,-86.25),('46701','IN','Albion','Noble',41.360958,-85.439436),('46702','IN','Andrews','Huntington',40.832798,-85.610993),('46703','IN','Angola','Steuben',41.655635,-85.016316),('46704','IN','Arcola','Allen',41.10425,-85.292568),('46705','IN','Ashley','De Kalb',41.525102,-85.060684),('46706','IN','Auburn','De Kalb',41.359811,-85.052128),('46710','IN','Avilla','Noble',41.358182,-85.242352),('46711','IN','Berne','Adams',40.663259,-84.942949),('46713','IN','Bippus','Huntington',40.9441,-85.6238),('46714','IN','Bluffton','Wells',40.729861,-85.16233),('46721','IN','Butler','De Kalb',41.423982,-84.872751),('46723','IN','Churubusco','Whitley',41.239081,-85.328115),('46725','IN','Columbia City','Whitley',41.161166,-85.482409),('46730','IN','Corunna','De Kalb',41.445474,-85.151628),('46731','IN','Craigville','Wells',40.793538,-85.099634),('46732','IN','Cromwell','Noble',41.386922,-85.637766),('46733','IN','Decatur','Adams',40.830057,-84.937097),('46737','IN','Fremont','Steuben',41.725871,-84.967157),('46738','IN','Garrett','De Kalb',41.341219,-85.135867),('46740','IN','Geneva','Adams',40.600047,-84.969163),('46741','IN','Grabill','Allen',41.211295,-84.961804),('46742','IN','Hamilton','Steuben',41.547314,-84.889978),('46743','IN','Harlan','Allen',41.214558,-84.863858),('46745','IN','Hoagland','Allen',40.95419,-85.008613),('46746','IN','Howe','Lagrange',41.723111,-85.393483),('46747','IN','Hudson','Steuben',41.554713,-85.152193),('46748','IN','Huntertown','Allen',41.240042,-85.166225),('46750','IN','Huntington','Huntington',40.876753,-85.493329),('46755','IN','Kendallville','Noble',41.447668,-85.270329),('46759','IN','Keystone','Wells',40.603863,-85.192859),('46760','IN','Kimmell','Noble',41.359408,-85.561543),('46761','IN','Lagrange','Lagrange',41.634365,-85.377513),('46763','IN','Laotto','Noble',41.287756,-85.221078),('46764','IN','Larwill','Whitley',41.214362,-85.620243),('46765','IN','Leo','Allen',41.221415,-85.026962),('46766','IN','Liberty Center','Wells',40.708959,-85.292269),('46767','IN','Ligonier','Noble',41.465498,-85.585109),('46769','IN','Linn Grove','Adams',40.645,-85.033),('46770','IN','Markle','Wells',40.837684,-85.324251),('46771','IN','Mongo','Lagrange',41.686535,-85.284033),('46772','IN','Monroe','Adams',40.724128,-84.927099),('46773','IN','Monroeville','Allen',40.987089,-84.873769),('46774','IN','New Haven','Allen',41.082425,-84.993593),('46776','IN','Orland','Steuben',41.733702,-85.153099),('46777','IN','Ossian','Wells',40.876093,-85.161477),('46778','IN','Petroleum','Wells',40.6113,-85.1508),('46779','IN','Pleasant Lake','Steuben',41.578206,-85.028492),('46780','IN','Pleasant Mills','Adams',40.8525,-84.8618),('46781','IN','Poneto','Wells',40.647839,-85.266814),('46782','IN','Preble','Adams',40.8322,-85.0147),('46783','IN','Roanoke','Huntington',40.966879,-85.343437),('46784','IN','Rome City','Noble',41.493666,-85.381676),('46785','IN','Saint Joe','De Kalb',41.318247,-84.897272),('46786','IN','South Milford','Lagrange',41.531754,-85.272588),('46787','IN','South Whitley','Whitley',41.079991,-85.629178),('46788','IN','Spencerville','Allen',41.265867,-84.93545),('46789','IN','Stroh','Lagrange',41.5834,-85.1991),('46791','IN','Uniondale','Wells',40.832976,-85.243062),('46792','IN','Warren','Huntington',40.688962,-85.438612),('46793','IN','Waterloo','De Kalb',41.441729,-85.01977),('46794','IN','Wawaka','Noble',41.46219,-85.452204),('46795','IN','Wolcottville','Lagrange',41.548341,-85.34551),('46796','IN','Wolflake','Noble',41.335,-85.4958),('46797','IN','Woodburn','Allen',41.1274,-84.861535),('46798','IN','Yoder','Allen',40.942454,-85.233389),('46799','IN','Zanesville','Wells',40.915467,-85.281229),('46801','IN','Fort Wayne','Allen',41.0716,-85.1367),('46802','IN','Fort Wayne','Allen',41.072976,-85.151575),('46803','IN','Fort Wayne','Allen',41.069947,-85.10538),('46804','IN','Fort Wayne','Allen',41.051299,-85.241898),('46805','IN','Fort Wayne','Allen',41.100045,-85.120189),('46806','IN','Fort Wayne','Allen',41.048312,-85.109852),('46807','IN','Fort Wayne','Allen',41.046962,-85.145106),('46808','IN','Fort Wayne','Allen',41.094397,-85.165008),('46809','IN','Fort Wayne','Allen',41.019011,-85.187835),('46814','IN','Fort Wayne','Allen',41.048682,-85.305902),('46815','IN','Fort Wayne','Allen',41.105339,-85.063383),('46816','IN','Fort Wayne','Allen',41.009336,-85.070981),('46818','IN','Fort Wayne','Allen',41.150578,-85.216497),('46819','IN','Fort Wayne','Allen',40.996119,-85.145606),('46825','IN','Fort Wayne','Allen',41.150407,-85.126405),('46835','IN','Fort Wayne','Allen',41.13925,-85.058982),('46845','IN','Fort Wayne','Allen',41.196745,-85.109089),('46850','IN','Fort Wayne','Allen',41.0716,-85.1367),('46851','IN','Fort Wayne','Allen',41.0716,-85.1367),('46852','IN','Fort Wayne','Allen',41.0716,-85.1367),('46853','IN','Fort Wayne','Allen',41.0716,-85.1367),('46854','IN','Fort Wayne','Allen',41.0716,-85.1367),('46855','IN','Fort Wayne','Allen',41.0716,-85.1367),('46856','IN','Fort Wayne','Allen',41.0716,-85.1367),('46857','IN','Fort Wayne','Allen',41.0716,-85.1367),('46858','IN','Fort Wayne','Allen',41.0716,-85.1367),('46859','IN','Fort Wayne','Allen',41.0716,-85.1367),('46860','IN','Fort Wayne','Allen',41.0716,-85.1367),('46861','IN','Fort Wayne','Allen',41.0716,-85.1367),('46862','IN','Fort Wayne','Allen',41.0716,-85.1367),('46863','IN','Fort Wayne','Allen',41.0716,-85.1367),('46864','IN','Fort Wayne','Allen',41.0716,-85.1367),('46865','IN','Fort Wayne','Allen',41.0716,-85.1367),('46866','IN','Fort Wayne','Allen',41.0716,-85.1367),('46867','IN','Fort Wayne','Allen',41.0716,-85.1367),('46868','IN','Fort Wayne','Allen',41.0716,-85.1367),('46869','IN','Fort Wayne','Allen',41.0716,-85.1367),('46885','IN','Fort Wayne','Allen',41.1204,-85.0651),('46895','IN','Fort Wayne','Allen',41.1057,-85.1145),('46896','IN','Fort Wayne','Allen',41.0073,-85.0625),('46897','IN','Fort Wayne','Allen',41.0716,-85.1367),('46898','IN','Fort Wayne','Allen',41.1305,-85.1288),('46899','IN','Fort Wayne','Allen',41.0298,-85.1663),('46901','IN','Kokomo','Howard',40.498969,-86.141235),('46902','IN','Kokomo','Howard',40.45146,-86.122755),('46903','IN','Kokomo','Howard',40.5247,-86.1757),('46904','IN','Kokomo','Howard',40.525,-86.1833),('46910','IN','Akron','Fulton',41.039547,-86.030574),('46911','IN','Amboy','Miami',40.637581,-85.93142),('46912','IN','Athens','Fulton',41.0536,-86.1252),('46913','IN','Bringhurst','Carroll',40.507076,-86.5013),('46914','IN','Bunker Hill','Miami',40.647748,-86.099545),('46915','IN','Burlington','Carroll',40.481176,-86.392754),('46916','IN','Burrows','Carroll',40.6766,-86.5075),('46917','IN','Camden','Carroll',40.61986,-86.489379),('46919','IN','Converse','Miami',40.581908,-85.864097),('46920','IN','Cutler','Carroll',40.467449,-86.51466),('46921','IN','Deedsville','Miami',40.911001,-86.100523),('46922','IN','Delong','Fulton',41.1383,-86.4163),('46923','IN','Delphi','Carroll',40.596194,-86.655362),('46926','IN','Denver','Miami',40.874678,-86.063753),('46928','IN','Fairmount','Grant',40.413644,-85.665709),('46929','IN','Flora','Carroll',40.545879,-86.498802),('46930','IN','Fowlerton','Grant',40.409643,-85.570557),('46931','IN','Fulton','Fulton',40.948255,-86.2641),('46932','IN','Galveston','Cass',40.592943,-86.231877),('46933','IN','Gas City','Grant',40.486528,-85.594321),('46935','IN','Grass Creek','Fulton',40.9475,-86.4044),('46936','IN','Greentown','Howard',40.4778,-85.949503),('46937','IN','Hemlock','Howard',40.42,-86.0413),('46938','IN','Jonesboro','Grant',40.459646,-85.626941),('46939','IN','Kewanna','Fulton',41.006339,-86.404236),('46940','IN','La Fontaine','Wabash',40.680044,-85.724637),('46941','IN','Lagro','Wabash',40.823694,-85.703137),('46942','IN','Lake Cicott','Cass',40.7641,-86.5241),('46943','IN','Laketon','Wabash',40.974435,-85.838729),('46945','IN','Leiters Ford','Fulton',41.1216,-86.3858),('46946','IN','Liberty Mills','Wabash',41.036759,-85.735194),('46947','IN','Logansport','Cass',40.755003,-86.36695),('46950','IN','Lucerne','Cass',40.88551,-86.375112),('46951','IN','Macy','Miami',40.945384,-86.123172),('46952','IN','Marion','Grant',40.581148,-85.660125),('46953','IN','Marion','Grant',40.531028,-85.659363),('46957','IN','Matthews','Grant',40.387435,-85.495503),('46958','IN','Mexico','Miami',40.821631,-86.116107),('46959','IN','Miami','Miami',40.615506,-86.107022),('46960','IN','Monterey','Pulaski',41.161035,-86.516056),('46961','IN','New Waverly','Cass',40.765276,-86.191709),('46962','IN','North Manchester','Wabash',40.994515,-85.777315),('46965','IN','Oakford','Howard',40.4191,-86.1041),('46967','IN','Onward','Cass',40.694626,-86.194157),('46968','IN','Ora','Starke',41.172351,-86.550408),('46970','IN','Peru','Miami',40.750278,-86.075552),('46971','IN','Grissom Arb','Miami',40.6626,-86.1426),('46974','IN','Roann','Wabash',40.938937,-85.9183),('46975','IN','Rochester','Fulton',41.072333,-86.239939),('46977','IN','Rockfield','Carroll',40.6411,-86.5738),('46978','IN','Royal Center','Cass',40.861894,-86.503513),('46979','IN','Russiaville','Howard',40.429768,-86.268655),('46980','IN','Servia','Wabash',40.9541,-85.7402),('46982','IN','Silver Lake','Kosciusko',41.051037,-85.904956),('46984','IN','Somerset','Wabash',40.668101,-85.829219),('46985','IN','Star City','Pulaski',40.961686,-86.578736),('46986','IN','Swayzee','Grant',40.504375,-85.824485),('46987','IN','Sweetser','Grant',40.568836,-85.765265),('46988','IN','Twelve Mile','Cass',40.877117,-86.234743),('46989','IN','Upland','Grant',40.459025,-85.489035),('46990','IN','Urbana','Wabash',40.898322,-85.757275),('46991','IN','Van Buren','Grant',40.623967,-85.506266),('46992','IN','Wabash','Wabash',40.793209,-85.828536),('46994','IN','Walton','Cass',40.675003,-86.245565),('46995','IN','West Middleton','Howard',40.4394,-86.2161),('46996','IN','Winamac','Pulaski',41.053251,-86.646518),('46998','IN','Young America','Cass',40.568147,-86.348389),('47001','IN','Aurora','Dearborn',39.062535,-84.942256),('47003','IN','West College Corner','Union',39.563687,-84.819787),('47006','IN','Batesville','Ripley',39.290931,-85.215982),('47010','IN','Bath','Franklin',39.515776,-84.843802),('47011','IN','Bennington','Switzerland',38.871401,-85.078162),('47012','IN','Brookville','Franklin',39.422842,-85.004176),('47016','IN','Cedar Grove','Franklin',39.364371,-84.928102),('47017','IN','Cross Plains','Ripley',38.94049,-85.181406),('47018','IN','Dillsboro','Dearborn',39.001906,-85.078029),('47019','IN','East Enterprise','Switzerland',38.881346,-84.944377),('47020','IN','Florence','Switzerland',38.813251,-84.940778),('47021','IN','Friendship','Ripley',38.966859,-85.145307),('47022','IN','Guilford','Dearborn',39.203598,-84.94669),('47023','IN','Holton','Ripley',39.075876,-85.38237),('47024','IN','Laurel','Franklin',39.485401,-85.194443),('47025','IN','Lawrenceburg','Dearborn',39.13267,-84.863195),('47030','IN','Metamora','Franklin',39.424093,-85.132377),('47031','IN','Milan','Ripley',39.119392,-85.156704),('47032','IN','Moores Hill','Dearborn',39.086081,-85.064967),('47033','IN','Morris','Ripley',39.2822,-85.1775),('47034','IN','Napoleon','Ripley',39.204363,-85.328461),('47035','IN','New Trenton','Franklin',39.3102,-84.902318),('47036','IN','Oldenburg','Franklin',39.382101,-85.238732),('47037','IN','Osgood','Ripley',39.145365,-85.306745),('47038','IN','Patriot','Switzerland',38.844661,-84.838624),('47039','IN','Pierceville','Ripley',39.1333,-85.1797),('47040','IN','Rising Sun','Ohio',38.938456,-84.907606),('47041','IN','Sunman','Ripley',39.241135,-85.086022),('47042','IN','Versailles','Ripley',39.021966,-85.244964),('47043','IN','Vevay','Switzerland',38.77771,-85.088731),('47060','IN','West Harrison','Dearborn',39.279301,-84.87125),('47102','IN','Austin','Scott',38.747257,-85.802555),('47104','IN','Bethlehem','Clark',38.5461,-85.4243),('47106','IN','Borden','Clark',38.456686,-85.911921),('47107','IN','Bradford','Harrison',38.3677,-86.0619),('47108','IN','Campbellsburg','Washington',38.640467,-86.265471),('47110','IN','Central','Harrison',38.096995,-86.183798),('47111','IN','Charlestown','Clark',38.448796,-85.649015),('47112','IN','Corydon','Harrison',38.207888,-86.129846),('47114','IN','Crandall','Harrison',38.288186,-86.065757),('47115','IN','Depauw','Harrison',38.34955,-86.226562),('47116','IN','Eckerty','Crawford',38.336463,-86.615898),('47117','IN','Elizabeth','Harrison',38.115526,-85.98273),('47118','IN','English','Crawford',38.312612,-86.47983),('47119','IN','Floyds Knobs','Floyd',38.346914,-85.888359),('47120','IN','Fredericksburg','Washington',38.437528,-86.190356),('47122','IN','Georgetown','Floyd',38.299652,-85.967178),('47123','IN','Grantsburg','Crawford',38.2832,-86.474795),('47124','IN','Greenville','Floyd',38.368863,-85.989633),('47125','IN','Hardinsburg','Washington',38.461121,-86.298286),('47126','IN','Henryville','Clark',38.543365,-85.772927),('47129','IN','Clarksville','Clark',38.308929,-85.768884),('47130','IN','Jeffersonville','Clark',38.313845,-85.714335),('47131','IN','Jeffersonville','Clark',38.3398,-85.6991),('47132','IN','Jeffersonville','Clark',38.3398,-85.6991),('47133','IN','Jeffersonville','Clark',38.3398,-85.6991),('47134','IN','Jeffersonville','Clark',38.3398,-85.6991),('47135','IN','Laconia','Harrison',38.036838,-86.070397),('47136','IN','Lanesville','Harrison',38.235085,-85.966747),('47137','IN','Leavenworth','Crawford',38.179242,-86.382146),('47138','IN','Lexington','Scott',38.677285,-85.599625),('47139','IN','Little York','Washington',38.700523,-85.904059),('47140','IN','Marengo','Crawford',38.37153,-86.350234),('47141','IN','Marysville','Clark',38.547956,-85.612115),('47142','IN','Mauckport','Harrison',38.079529,-86.230778),('47143','IN','Memphis','Clark',38.471549,-85.766649),('47144','IN','Jeffersonville','Clark',38.3398,-85.6991),('47145','IN','Milltown','Crawford',38.329776,-86.306724),('47146','IN','Mount Saint Francis','Floyd',38.3175,-85.9132),('47147','IN','Nabb','Clark',38.592633,-85.527095),('47150','IN','New Albany','Floyd',38.307027,-85.826453),('47151','IN','New Albany','Floyd',38.2874,-85.8232),('47160','IN','New Middletown','Harrison',38.164149,-86.050472),('47161','IN','New Salisbury','Harrison',38.315058,-86.09527),('47162','IN','New Washington','Clark',38.560218,-85.50276),('47163','IN','Otisco','Clark',38.526865,-85.669082),('47164','IN','Palmyra','Harrison',38.408666,-86.101516),('47165','IN','Pekin','Washington',38.500373,-86.013206),('47166','IN','Ramsey','Harrison',38.313071,-86.166474),('47167','IN','Salem','Washington',38.603183,-86.096681),('47170','IN','Scottsburg','Scott',38.684766,-85.812225),('47172','IN','Sellersburg','Clark',38.393214,-85.7615),('47174','IN','Sulphur','Crawford',38.210303,-86.466576),('47175','IN','Taswell','Crawford',38.356133,-86.557038),('47177','IN','Underwood','Clark',38.597426,-85.77267),('47190','IN','Jeffersonville','Clark',38.2868,-85.7338),('47199','IN','Jeffersonville','Clark',38.3398,-85.6991),('47201','IN','Columbus','Bartholomew',39.198977,-85.934069),('47202','IN','Columbus','Bartholomew',39.2013,-85.9213),('47203','IN','Columbus','Bartholomew',39.2338,-85.871015),('47220','IN','Brownstown','Jackson',38.882957,-86.047916),('47223','IN','Butlerville','Jennings',39.050184,-85.497713),('47224','IN','Canaan','Switzerland',38.89044,-85.227992),('47225','IN','Clarksburg','Decatur',39.4333,-85.3477),('47226','IN','Clifford','Bartholomew',39.282617,-85.869666),('47227','IN','Commiskey','Jennings',38.872029,-85.643381),('47228','IN','Cortland','Jackson',38.9554,-86.0767),('47229','IN','Crothersville','Jackson',38.805511,-85.84809),('47230','IN','Deputy','Jefferson',38.788109,-85.633532),('47231','IN','Dupont','Jefferson',38.889926,-85.494882),('47232','IN','Elizabethtown','Bartholomew',39.124045,-85.793818),('47234','IN','Flat Rock','Shelby',39.375634,-85.777887),('47235','IN','Freetown','Jackson',38.972654,-86.128635),('47236','IN','Grammer','Bartholomew',39.1524,-85.7252),('47240','IN','Greensburg','Decatur',39.333491,-85.471854),('47243','IN','Hanover','Jefferson',38.699502,-85.472606),('47244','IN','Hartsville','Bartholomew',39.245848,-85.701754),('47245','IN','Hayden','Jennings',38.983,-85.7405),('47246','IN','Hope','Bartholomew',39.295189,-85.768757),('47247','IN','Jonesville','Bartholomew',39.060099,-85.88936),('47249','IN','Kurtz','Jackson',38.9605,-86.2033),('47250','IN','Madison','Jefferson',38.78678,-85.379831),('47260','IN','Medora','Jackson',38.828461,-86.18376),('47261','IN','Millhousen','Decatur',39.3205,-85.4772),('47263','IN','New Point','Decatur',39.309115,-85.330046),('47264','IN','Norman','Jackson',38.952043,-86.273034),('47265','IN','North Vernon','Jennings',39.012112,-85.633787),('47270','IN','Paris Crossing','Jennings',38.839277,-85.712436),('47272','IN','Saint Paul','Decatur',39.421627,-85.624793),('47273','IN','Scipio','Jennings',39.077228,-85.734513),('47274','IN','Seymour','Jackson',38.962009,-85.90311),('47280','IN','Taylorsville','Bartholomew',39.296742,-85.950682),('47281','IN','Vallonia','Jackson',38.800474,-86.101566),('47282','IN','Vernon','Jennings',38.982995,-85.610634),('47283','IN','Westport','Decatur',39.173606,-85.574967),('47302','IN','Muncie','Delaware',40.165152,-85.382314),('47303','IN','Muncie','Delaware',40.227763,-85.378491),('47304','IN','Muncie','Delaware',40.216065,-85.437286),('47305','IN','Muncie','Delaware',40.1924,-85.387125),('47306','IN','Muncie','Delaware',40.207513,-85.410817),('47307','IN','Muncie','Delaware',40.1248,-85.3404),('47308','IN','Muncie','Delaware',40.1314,-85.3764),('47320','IN','Albany','Delaware',40.293856,-85.247883),('47322','IN','Bentonville','Fayette',39.7452,-85.1941),('47324','IN','Boston','Wayne',39.739288,-84.849948),('47325','IN','Brownsville','Union',39.674264,-85.014579),('47326','IN','Bryant','Jay',40.54868,-84.967266),('47327','IN','Cambridge City','Wayne',39.824513,-85.167095),('47330','IN','Centerville','Wayne',39.807608,-85.012108),('47331','IN','Connersville','Fayette',39.642775,-85.145201),('47334','IN','Daleville','Delaware',40.110252,-85.538176),('47335','IN','Dublin','Wayne',39.811527,-85.206596),('47336','IN','Dunkirk','Jay',40.386188,-85.210647),('47337','IN','Dunreith','Henry',39.803002,-85.436883),('47338','IN','Eaton','Delaware',40.337195,-85.348957),('47339','IN','Economy','Wayne',39.975878,-85.101566),('47340','IN','Farmland','Randolph',40.178272,-85.129375),('47341','IN','Fountain City','Wayne',39.962113,-84.903084),('47342','IN','Gaston','Delaware',40.321932,-85.512967),('47344','IN','Greensboro','Henry',39.877274,-85.465462),('47345','IN','Greens Fork','Wayne',39.887242,-85.045827),('47346','IN','Hagerstown','Wayne',39.919688,-85.160158),('47348','IN','Hartford City','Blackford',40.450802,-85.362663),('47351','IN','Kennard','Henry',39.903497,-85.520067),('47352','IN','Lewisville','Henry',39.79595,-85.360522),('47353','IN','Liberty','Union',39.61262,-84.930431),('47354','IN','Losantville','Randolph',40.044108,-85.204018),('47355','IN','Lynn','Randolph',40.044653,-84.937017),('47356','IN','Middletown','Henry',40.0471,-85.52736),('47357','IN','Milton','Wayne',39.761388,-85.145422),('47358','IN','Modoc','Randolph',40.048032,-85.112026),('47359','IN','Montpelier','Blackford',40.550075,-85.278767),('47360','IN','Mooreland','Henry',40.011265,-85.258203),('47361','IN','Mount Summit','Henry',40.003811,-85.385236),('47362','IN','New Castle','Henry',39.925787,-85.369992),('47366','IN','New Lisbon','Henry',39.8633,-85.263),('47367','IN','Oakville','Delaware',40.08249,-85.389598),('47368','IN','Parker City','Randolph',40.184239,-85.202878),('47369','IN','Pennville','Jay',40.494879,-85.142958),('47370','IN','Pershing','Wayne',39.8134,-85.1353),('47371','IN','Portland','Jay',40.418182,-84.974091),('47373','IN','Redkey','Jay',40.344423,-85.155184),('47374','IN','Richmond','Wayne',39.83109,-84.893358),('47375','IN','Richmond','Wayne',39.8307,-84.8944),('47380','IN','Ridgeville','Randolph',40.286525,-85.019974),('47381','IN','Salamonia','Jay',40.382009,-84.866966),('47382','IN','Saratoga','Randolph',40.236206,-84.917734),('47383','IN','Selma','Delaware',40.16308,-85.264513),('47384','IN','Shirley','Henry',39.898189,-85.567269),('47385','IN','Spiceland','Henry',39.832869,-85.441231),('47386','IN','Springport','Henry',40.055073,-85.385654),('47387','IN','Straughn','Henry',39.838586,-85.284318),('47388','IN','Sulphur Springs','Henry',40.005061,-85.44441),('47390','IN','Union City','Randolph',40.203178,-84.831628),('47392','IN','Webster','Wayne',39.903236,-84.943346),('47393','IN','Williamsburg','Wayne',39.954483,-85.002998),('47394','IN','Winchester','Randolph',40.174322,-84.978172),('47396','IN','Yorktown','Delaware',40.186583,-85.503588),('47401','IN','Bloomington','Monroe',39.125418,-86.496231),('47402','IN','Bloomington','Monroe',39.0936,-86.4657),('47403','IN','Bloomington','Monroe',39.118151,-86.571139),('47404','IN','Bloomington','Monroe',39.194745,-86.572849),('47405','IN','Bloomington','Monroe',39.167362,-86.518478),('47406','IN','Bloomington','Monroe',39.17693,-86.515643),('47407','IN','Bloomington','Monroe',39.2458,-86.4546),('47408','IN','Bloomington','Monroe',39.193521,-86.490253),('47420','IN','Avoca','Lawrence',38.9126,-86.549748),('47421','IN','Bedford','Lawrence',38.863016,-86.479667),('47424','IN','Bloomfield','Greene',39.023916,-86.891242),('47426','IN','Clear Creek','Monroe',39.1091,-86.54),('47427','IN','Coal City','Owen',39.238565,-87.021958),('47429','IN','Ellettsville','Monroe',39.244566,-86.621332),('47430','IN','Fort Ritner','Lawrence',38.773826,-86.281463),('47431','IN','Freedom','Owen',39.228278,-86.888669),('47432','IN','French Lick','Orange',38.508144,-86.629376),('47433','IN','Gosport','Owen',39.356236,-86.657562),('47434','IN','Harrodsburg','Monroe',39.012783,-86.547019),('47435','IN','Helmsburg','Brown',39.2661,-86.2959),('47436','IN','Heltonville','Lawrence',38.961446,-86.411686),('47437','IN','Huron','Lawrence',38.7222,-86.6705),('47438','IN','Jasonville','Greene',39.165312,-87.205761),('47439','IN','Koleen','Greene',39.0306,-86.854),('47441','IN','Linton','Greene',39.042655,-87.166893),('47443','IN','Lyons','Greene',38.965189,-87.099611),('47445','IN','Midland','Greene',39.125078,-87.193325),('47446','IN','Mitchell','Lawrence',38.737775,-86.480332),('47448','IN','Nashville','Brown',39.199648,-86.240285),('47449','IN','Newberry','Greene',38.920796,-87.003738),('47451','IN','Oolitic','Lawrence',38.895702,-86.524853),('47452','IN','Orleans','Orange',38.647143,-86.43343),('47453','IN','Owensburg','Greene',38.918461,-86.757193),('47454','IN','Paoli','Orange',38.531695,-86.482897),('47455','IN','Patricksburg','Owen',39.311662,-86.953996),('47456','IN','Quincy','Owen',39.463714,-86.710492),('47457','IN','Scotland','Greene',38.911854,-86.90472),('47458','IN','Smithville','Monroe',39.0711,-86.5069),('47459','IN','Solsberry','Greene',39.113598,-86.750627),('47460','IN','Spencer','Owen',39.290076,-86.775045),('47462','IN','Springville','Lawrence',38.960907,-86.632423),('47463','IN','Stanford','Monroe',39.0897,-86.6666),('47464','IN','Stinesville','Monroe',39.299206,-86.650127),('47465','IN','Switz City','Greene',39.045085,-87.049961),('47467','IN','Tunnelton','Lawrence',38.768436,-86.344512),('47468','IN','Unionville','Monroe',39.251932,-86.392977),('47469','IN','West Baden Springs','Orange',38.591989,-86.613683),('47470','IN','Williams','Lawrence',38.814239,-86.656461),('47471','IN','Worthington','Greene',39.129836,-86.991837),('47490','IN','Bloomington','Monroe',39.0936,-86.4657),('47501','IN','Washington','Daviess',38.655812,-87.176499),('47512','IN','Bicknell','Knox',38.772405,-87.308228),('47513','IN','Birdseye','Dubois',38.319783,-86.692084),('47514','IN','Branchville','Perry',38.149251,-86.589589),('47515','IN','Bristow','Perry',38.183912,-86.703981),('47516','IN','Bruceville','Knox',38.762183,-87.423454),('47519','IN','Cannelburg','Daviess',38.63873,-86.990164),('47520','IN','Cannelton','Perry',37.944943,-86.668258),('47521','IN','Celestine','Dubois',38.396081,-86.724575),('47522','IN','Crane','Martin',38.893525,-86.850848),('47523','IN','Dale','Spencer',38.170923,-86.99891),('47524','IN','Decker','Knox',38.49708,-87.571932),('47525','IN','Derby','Perry',38.032369,-86.559731),('47527','IN','Dubois','Dubois',38.456734,-86.7779),('47528','IN','Edwardsport','Knox',38.820728,-87.254709),('47529','IN','Elnora','Daviess',38.870925,-87.082235),('47531','IN','Evanston','Spencer',38.033108,-86.855578),('47532','IN','Ferdinand','Dubois',38.220677,-86.865193),('47535','IN','Freelandville','Knox',38.865077,-87.304909),('47536','IN','Fulda','Spencer',38.11245,-86.83667),('47537','IN','Gentryville','Spencer',38.091095,-87.047545),('47541','IN','Holland','Dubois',38.243625,-87.041543),('47542','IN','Huntingburg','Dubois',38.302977,-86.970862),('47545','IN','Ireland','Dubois',38.413906,-87.000604),('47546','IN','Jasper','Dubois',38.408633,-86.932422),('47547','IN','Jasper','Dubois',38.3913,-86.9311),('47549','IN','Jasper','Dubois',38.3913,-86.9311),('47550','IN','Lamar','Spencer',38.067186,-86.921311),('47551','IN','Leopold','Perry',38.114113,-86.569573),('47552','IN','Lincoln City','Spencer',38.113284,-86.998703),('47553','IN','Loogootee','Martin',38.677458,-86.916855),('47556','IN','Mariah Hill','Spencer',38.128,-86.8714),('47557','IN','Monroe City','Knox',38.578834,-87.342778),('47558','IN','Montgomery','Daviess',38.662329,-87.044444),('47561','IN','Oaktown','Knox',38.861909,-87.434483),('47562','IN','Odon','Daviess',38.831692,-86.984555),('47564','IN','Otwell','Pike',38.471185,-87.099573),('47567','IN','Petersburg','Pike',38.471619,-87.289986),('47568','IN','Plainville','Daviess',38.803192,-87.148247),('47573','IN','Ragsdale','Knox',38.7458,-87.325),('47574','IN','Rome','Perry',37.94249,-86.539448),('47575','IN','Saint Anthony','Dubois',38.318687,-86.823061),('47576','IN','Saint Croix','Perry',38.185649,-86.599743),('47577','IN','Saint Meinrad','Spencer',38.159276,-86.809653),('47578','IN','Sandborn','Knox',38.896895,-87.188462),('47579','IN','Santa Claus','Spencer',38.114829,-86.922962),('47580','IN','Schnellville','Dubois',38.355203,-86.767156),('47581','IN','Shoals','Martin',38.675251,-86.768638),('47584','IN','Spurgeon','Pike',38.25317,-87.257724),('47585','IN','Stendal','Pike',38.268269,-87.157956),('47586','IN','Tell City','Perry',37.980542,-86.744739),('47588','IN','Troy','Perry',38.036487,-86.791663),('47590','IN','Velpen','Pike',38.350302,-87.09061),('47591','IN','Vincennes','Knox',38.662754,-87.508742),('47596','IN','Westphalia','Knox',38.863014,-87.225122),('47597','IN','Wheatland','Knox',38.654389,-87.2988),('47598','IN','Winslow','Pike',38.383122,-87.213613),('47601','IN','Boonville','Warrick',38.045821,-87.260974),('47610','IN','Chandler','Warrick',38.041716,-87.388064),('47611','IN','Chrisney','Spencer',38.021211,-87.043655),('47612','IN','Cynthiana','Posey',38.188931,-87.701707),('47613','IN','Elberfeld','Warrick',38.171941,-87.425279),('47614','IN','Folsomville','Warrick',38.1291,-87.1641),('47615','IN','Grandview','Spencer',37.959844,-86.96866),('47616','IN','Griffin','Posey',38.23869,-87.904545),('47617','IN','Hatfield','Spencer',37.9032,-87.2259),('47618','IN','Inglefield','Vanderburgh',38.108,-87.5588),('47619','IN','Lynnville','Warrick',38.199615,-87.307243),('47620','IN','Mount Vernon','Posey',37.942459,-87.885518),('47629','IN','Newburgh','Warrick',37.9568,-87.4028),('47630','IN','Newburgh','Warrick',37.963004,-87.384262),('47631','IN','New Harmony','Posey',38.108927,-87.924225),('47633','IN','Poseyville','Posey',38.173143,-87.783814),('47634','IN','Richland','Spencer',37.929925,-87.20065),('47635','IN','Rockport','Spencer',37.898399,-87.084078),('47637','IN','Tennyson','Warrick',38.123454,-87.134601),('47638','IN','Wadesville','Posey',38.077764,-87.770905),('47639','IN','Haubstadt','Gibson',38.18787,-87.566675),('47640','IN','Hazleton','Gibson',38.484021,-87.516998),('47647','IN','Buckskin','Gibson',38.215226,-87.423192),('47648','IN','Fort Branch','Gibson',38.246721,-87.566433),('47649','IN','Francisco','Gibson',38.341133,-87.442988),('47654','IN','Mackey','Gibson',38.251966,-87.392146),('47660','IN','Oakland City','Gibson',38.318323,-87.339918),('47665','IN','Owensville','Gibson',38.282302,-87.711632),('47666','IN','Patoka','Gibson',38.412193,-87.593669),('47670','IN','Princeton','Gibson',38.349606,-87.574682),('47683','IN','Somerville','Gibson',38.277611,-87.377773),('47701','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47702','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47703','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47704','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47705','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47706','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47708','IN','Evansville','Vanderburgh',37.974624,-87.573265),('47710','IN','Evansville','Vanderburgh',38.003238,-87.575619),('47711','IN','Evansville','Vanderburgh',38.002609,-87.542441),('47712','IN','Evansville','Vanderburgh',37.960654,-87.640476),('47713','IN','Evansville','Vanderburgh',37.96383,-87.558603),('47714','IN','Evansville','Vanderburgh',37.959112,-87.524795),('47715','IN','Evansville','Vanderburgh',37.976016,-87.480627),('47716','IN','Evansville','Vanderburgh',37.9624,-87.4924),('47719','IN','Evansville','Vanderburgh',38.087,-87.5321),('47720','IN','Evansville','Vanderburgh',38.041535,-87.635604),('47721','IN','Evansville','Vanderburgh',37.9128,-87.6471),('47722','IN','Evansville','Vanderburgh',37.9734,-87.5301),('47724','IN','Evansville','Vanderburgh',38.0814,-87.5259),('47725','IN','Evansville','Vanderburgh',38.094706,-87.517491),('47727','IN','Evansville','Vanderburgh',38.0814,-87.5259),('47728','IN','Evansville','Vanderburgh',37.9625,-87.5309),('47730','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47731','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47732','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47733','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47734','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47735','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47736','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47737','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47739','IN','Evansville','Vanderburgh',38.0271,-87.576),('47740','IN','Evansville','Vanderburgh',38.0271,-87.576),('47741','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47744','IN','Evansville','Vanderburgh',37.9128,-87.6471),('47747','IN','Evansville','Vanderburgh',38.0271,-87.576),('47750','IN','Evansville','Vanderburgh',37.9746,-87.5674),('47801','IN','Terre Haute','Vigo',39.4666,-87.4138),('47802','IN','Terre Haute','Vigo',39.400609,-87.401811),('47803','IN','Terre Haute','Vigo',39.466386,-87.3492),('47804','IN','Terre Haute','Vigo',39.494727,-87.391988),('47805','IN','Terre Haute','Vigo',39.535537,-87.353701),('47807','IN','Terre Haute','Vigo',39.471161,-87.399698),('47808','IN','Terre Haute','Vigo',39.4667,-87.4068),('47809','IN','Terre Haute','Vigo',39.471157,-87.409093),('47811','IN','Terre Haute','Vigo',39.4667,-87.4068),('47812','IN','Terre Haute','Vigo',39.4667,-87.4068),('47830','IN','Bellmore','Parke',39.7591,-87.1052),('47831','IN','Blanford','Vermillion',39.665,-87.5205),('47832','IN','Bloomingdale','Parke',39.86248,-87.25863),('47833','IN','Bowling Green','Owen',39.367885,-86.973005),('47834','IN','Brazil','Clay',39.519524,-87.129394),('47836','IN','Bridgeton','Parke',39.647929,-87.175296),('47837','IN','Carbon','Clay',39.627378,-87.114909),('47838','IN','Carlisle','Sullivan',38.963003,-87.381006),('47840','IN','Centerpoint','Clay',39.407889,-87.06772),('47841','IN','Clay City','Clay',39.277976,-87.112459),('47842','IN','Clinton','Vermillion',39.668411,-87.435852),('47845','IN','Coalmont','Clay',39.1933,-87.2311),('47846','IN','Cory','Clay',39.381585,-87.195043),('47847','IN','Dana','Vermillion',39.817433,-87.485619),('47848','IN','Dugger','Sullivan',39.06588,-87.259076),('47849','IN','Fairbanks','Sullivan',39.195304,-87.56374),('47850','IN','Farmersburg','Sullivan',39.250273,-87.410141),('47851','IN','Fontanet','Vigo',39.5736,-87.2453),('47852','IN','Graysville','Sullivan',39.1175,-87.5561),('47853','IN','Harmony','Clay',39.538503,-87.072396),('47854','IN','Hillsdale','Vermillion',39.803007,-87.403058),('47855','IN','Hymera','Sullivan',39.186787,-87.300995),('47856','IN','Judson','Parke',39.813543,-87.136353),('47857','IN','Knightsville','Clay',39.525503,-87.091983),('47858','IN','Lewis','Clay',39.257466,-87.241906),('47859','IN','Marshall','Parke',39.87152,-87.176537),('47860','IN','Mecca','Parke',39.725271,-87.331378),('47861','IN','Merom','Sullivan',39.060482,-87.569237),('47862','IN','Montezuma','Parke',39.787204,-87.35874),('47863','IN','New Goshen','Vigo',39.577797,-87.458127),('47864','IN','New Lebanon','Sullivan',39.1115,-87.4279),('47865','IN','Paxton','Sullivan',39.020826,-87.390252),('47866','IN','Pimento','Vigo',39.289957,-87.327106),('47868','IN','Poland','Owen',39.410594,-86.896288),('47869','IN','Prairie Creek','Vigo',39.273762,-87.49727),('47870','IN','Prairieton','Vigo',39.37,-87.4744),('47871','IN','Riley','Vigo',39.389858,-87.299603),('47872','IN','Rockville','Parke',39.754325,-87.178981),('47874','IN','Rosedale','Parke',39.626978,-87.259804),('47875','IN','Saint Bernice','Vermillion',39.7934,-87.4563),('47876','IN','Saint Mary Of The Woods','Vigo',39.509798,-87.458331),('47878','IN','Seelyville','Vigo',39.4919,-87.2672),('47879','IN','Shelburn','Sullivan',39.184578,-87.391424),('47880','IN','Shepardsville','Vigo',39.599947,-87.418329),('47881','IN','Staunton','Clay',39.487257,-87.189426),('47882','IN','Sullivan','Sullivan',39.092528,-87.403547),('47884','IN','Universal','Vermillion',39.619517,-87.45042),('47885','IN','West Terre Haute','Vigo',39.503645,-87.458852),('47901','IN','Lafayette','Tippecanoe',40.41868,-86.889655),('47902','IN','Lafayette','Tippecanoe',40.4175,-86.8543),('47903','IN','Lafayette','Tippecanoe',40.4175,-86.8543),('47904','IN','Lafayette','Tippecanoe',40.429428,-86.875295),('47905','IN','Lafayette','Tippecanoe',40.416677,-86.819442),('47906','IN','West Lafayette','Tippecanoe',40.460252,-86.933426),('47907','IN','West Lafayette','Tippecanoe',40.4249,-86.9159),('47909','IN','Lafayette','Tippecanoe',40.358852,-86.887235),('47916','IN','Alamo','Montgomery',39.98349,-87.055335),('47917','IN','Ambia','Benton',40.469525,-87.483379),('47918','IN','Attica','Fountain',40.308358,-87.225628),('47920','IN','Battle Ground','Tippecanoe',40.538178,-86.822294),('47921','IN','Boswell','Benton',40.502169,-87.377841),('47922','IN','Brook','Newton',40.870157,-87.36496),('47923','IN','Brookston','White',40.604716,-86.889258),('47924','IN','Buck Creek','Tippecanoe',40.487786,-86.762802),('47925','IN','Buffalo','White',40.881486,-86.744751),('47926','IN','Burnettsville','White',40.768752,-86.593519),('47928','IN','Cayuga','Vermillion',39.94072,-87.462569),('47929','IN','Chalmers','White',40.670493,-86.891265),('47930','IN','Clarks Hill','Tippecanoe',40.245975,-86.728548),('47932','IN','Covington','Fountain',40.134328,-87.415242),('47933','IN','Crawfordsville','Montgomery',40.038878,-86.890817),('47934','IN','Crawfordsville','Montgomery',40.0414,-86.8984),('47935','IN','Crawfordsville','Montgomery',40.0414,-86.8984),('47936','IN','Crawfordsville','Montgomery',40.0414,-86.8984),('47937','IN','Crawfordsville','Montgomery',40.0414,-86.8984),('47938','IN','Crawfordsville','Montgomery',40.0414,-86.8984),('47939','IN','Crawfordsville','Montgomery',40.0414,-86.8984),('47940','IN','Darlington','Montgomery',40.119127,-86.751373),('47941','IN','Dayton','Tippecanoe',40.377047,-86.771633),('47942','IN','Earl Park','Benton',40.688356,-87.430197),('47943','IN','Fair Oaks','Jasper',41.074778,-87.261976),('47944','IN','Fowler','Benton',40.616954,-87.325645),('47946','IN','Francesville','Pulaski',40.984741,-86.87581),('47948','IN','Goodland','Newton',40.775349,-87.287251),('47949','IN','Hillsboro','Fountain',40.072167,-87.136979),('47950','IN','Idaville','White',40.800274,-86.649339),('47951','IN','Kentland','Newton',40.781991,-87.443883),('47952','IN','Kingman','Fountain',39.959654,-87.299191),('47954','IN','Ladoga','Montgomery',39.902675,-86.803946),('47955','IN','Linden','Montgomery',40.193781,-86.88849),('47957','IN','Medaryville','Pulaski',41.083522,-86.875725),('47958','IN','Mellott','Fountain',40.164573,-87.147979),('47959','IN','Monon','White',40.860528,-86.876982),('47960','IN','Monticello','White',40.776701,-86.761249),('47962','IN','Montmorenci','Tippecanoe',40.4741,-87.0294),('47963','IN','Morocco','Newton',40.962213,-87.450068),('47964','IN','Mount Ayr','Newton',40.952638,-87.298282),('47965','IN','New Market','Montgomery',39.952967,-86.92059),('47966','IN','Newport','Vermillion',39.885015,-87.405361),('47967','IN','New Richmond','Montgomery',40.183936,-86.988555),('47968','IN','New Ross','Montgomery',39.96029,-86.736635),('47969','IN','Newtown','Fountain',40.205209,-87.149147),('47970','IN','Otterbein','Benton',40.465457,-87.117975),('47971','IN','Oxford','Benton',40.526543,-87.235425),('47974','IN','Perrysville','Vermillion',40.044611,-87.463974),('47975','IN','Pine Village','Warren',40.448715,-87.252486),('47977','IN','Remington','Jasper',40.760994,-87.153008),('47978','IN','Rensselaer','Jasper',40.963391,-87.135178),('47980','IN','Reynolds','White',40.754105,-86.887532),('47981','IN','Romney','Tippecanoe',40.247623,-86.916384),('47982','IN','State Line','Warren',40.196831,-87.526933),('47983','IN','Stockwell','Tippecanoe',40.28478,-86.771981),('47984','IN','Talbot','Benton',40.5052,-87.4541),('47986','IN','Templeton','Benton',40.512643,-87.207061),('47987','IN','Veedersburg','Fountain',40.123911,-87.243407),('47988','IN','Wallace','Fountain',39.9863,-87.1483),('47989','IN','Waveland','Montgomery',39.890995,-87.055869),('47990','IN','Waynetown','Montgomery',40.078601,-87.059458),('47991','IN','West Lebanon','Warren',40.276233,-87.40501),('47992','IN','Westpoint','Tippecanoe',40.330917,-87.04794),('47993','IN','Williamsport','Warren',40.302081,-87.386025),('47994','IN','Wingate','Montgomery',40.170724,-87.068877),('47995','IN','Wolcott','White',40.754898,-87.038697),('47996','IN','West Lafayette','Tippecanoe',40.4853,-86.9814),('47997','IN','Yeoman','Carroll',40.667939,-86.723719),('48001','MI','Algonac','St. Clair',42.631884,-82.565703),('48002','MI','Allenton','St. Clair',42.935043,-82.916493),('48003','MI','Almont','Lapeer',42.929158,-83.046081),('48004','MI','Anchorville','Saint Clair',42.6911,-82.6886),('48005','MI','Armada','Macomb',42.842453,-82.914423),('48006','MI','Avoca','St. Clair',43.071789,-82.700608),('48007','MI','Troy','Oakland',42.5609,-83.1471),('48009','MI','Birmingham','Oakland',42.544832,-83.215456),('48012','MI','Birmingham','Oakland',42.5466,-83.2113),('48014','MI','Capac','St. Clair',43.011737,-82.935761),('48015','MI','Center Line','Macomb',42.481361,-83.025427),('48017','MI','Clawson','Oakland',42.535445,-83.151383),('48021','MI','Eastpointe','Macomb',42.46608,-82.946341),('48022','MI','Emmett','St. Clair',43.013248,-82.793409),('48023','MI','Fair Haven','St. Clair',42.697618,-82.67183),('48025','MI','Franklin','Oakland',42.524031,-83.254793),('48026','MI','Fraser','Macomb',42.536638,-82.948221),('48027','MI','Goodells','St. Clair',42.954122,-82.684426),('48028','MI','Harsens Island','St. Clair',42.562699,-82.636432),('48030','MI','Hazel Park','Oakland',42.461126,-83.098765),('48032','MI','Jeddo','St. Clair',43.134176,-82.606347),('48033','MI','Southfield','Oakland',42.463078,-83.286724),('48034','MI','Southfield','Oakland',42.49693,-83.291001),('48035','MI','Clinton Township','Macomb',42.5566,-82.907589),('48036','MI','Clinton Township','Macomb',42.587521,-82.900221),('48037','MI','Southfield','Oakland',42.4869,-83.2636),('48038','MI','Clinton Township','Macomb',42.60318,-82.944651),('48039','MI','Marine City','St. Clair',42.710063,-82.50777),('48040','MI','Marysville','St. Clair',42.910313,-82.480603),('48041','MI','Memphis','St. Clair',42.932073,-82.803153),('48042','MI','Macomb','Macomb',42.683169,-82.92354),('48043','MI','Mount Clemens','Macomb',42.598056,-82.881506),('48044','MI','Macomb','Macomb',42.64759,-82.929294),('48045','MI','Harrison Township','Macomb',42.587388,-82.829019),('48046','MI','Mount Clemens','Macomb',42.5914,-82.8806),('48047','MI','New Baltimore','Macomb',42.674357,-82.781753),('48048','MI','New Haven','Macomb',42.736178,-82.79485),('48049','MI','North Street','St. Clair',43.033722,-82.576054),('48050','MI','New Haven','Macomb',42.786069,-82.808637),('48051','MI','New Baltimore','Macomb',42.684845,-82.822815),('48054','MI','East China','St. Clair',42.773774,-82.522345),('48059','MI','Fort Gratiot','St. Clair',43.083762,-82.488334),('48060','MI','Port Huron','St. Clair',42.980025,-82.444304),('48061','MI','Port Huron','Saint Clair',42.9703,-82.4244),('48062','MI','Richmond','Macomb',42.835,-82.770476),('48063','MI','Columbus','St. Clair',42.854647,-82.678391),('48064','MI','Casco','St. Clair',42.764617,-82.666777),('48065','MI','Romeo','Macomb',42.839658,-83.041284),('48066','MI','Roseville','Macomb',42.503346,-82.938587),('48067','MI','Royal Oak','Oakland',42.489088,-83.137771),('48068','MI','Royal Oak','Oakland',42.4886,-83.1463),('48069','MI','Pleasant Ridge','Oakland',42.470807,-83.144875),('48070','MI','Huntington Woods','Oakland',42.481899,-83.168088),('48071','MI','Madison Heights','Oakland',42.49953,-83.103217),('48072','MI','Berkley','Oakland',42.497277,-83.184243),('48073','MI','Royal Oak','Oakland',42.52027,-83.166575),('48074','MI','Smiths Creek','St. Clair',42.950684,-82.553793),('48075','MI','Southfield','Oakland',42.461868,-83.223734),('48076','MI','Southfield','Oakland',42.49741,-83.228655),('48079','MI','Saint Clair','St. Clair',42.839509,-82.509371),('48080','MI','Saint Clair Shores','Macomb',42.462745,-82.901633),('48081','MI','Saint Clair Shores','Macomb',42.495664,-82.901196),('48082','MI','Saint Clair Shores','Macomb',42.526938,-82.887639),('48083','MI','Troy','Oakland',42.557345,-83.116183),('48084','MI','Troy','Oakland',42.561468,-83.178565),('48085','MI','Troy','Oakland',42.596386,-83.11684),('48086','MI','Southfield','Oakland',42.4869,-83.2636),('48088','MI','Warren','Macomb',42.516547,-82.983374),('48089','MI','Warren','Macomb',42.467265,-82.998823),('48090','MI','Warren','Macomb',42.5009,-83.0461),('48091','MI','Warren','Macomb',42.465957,-83.056103),('48092','MI','Warren','Macomb',42.512731,-83.058303),('48093','MI','Warren','Macomb',42.512987,-83.01523),('48094','MI','Washington','Macomb',42.729918,-83.044662),('48095','MI','Washington','Macomb',42.778736,-83.04807),('48096','MI','Ray','Macomb',42.757475,-82.921037),('48097','MI','Yale','St. Clair',43.12205,-82.827575),('48098','MI','Troy','Oakland',42.598839,-83.180357),('48099','MI','Troy','Oakland',42.5609,-83.1471),('48101','MI','Allen Park','Wayne',42.257639,-83.211218),('48103','MI','Ann Arbor','Washtenaw',42.279603,-83.793073),('48104','MI','Ann Arbor','Washtenaw',42.265278,-83.720556),('48105','MI','Ann Arbor','Washtenaw',42.308,-83.701275),('48106','MI','Ann Arbor','Washtenaw',42.2723,-83.7747),('48107','MI','Ann Arbor','Washtenaw',42.2796,-83.7461),('48108','MI','Ann Arbor','Washtenaw',42.233411,-83.725268),('48109','MI','Ann Arbor','Washtenaw',42.281937,-83.729153),('48110','MI','Azalia','Monroe',42.0188,-83.6658),('48111','MI','Belleville','Wayne',42.200142,-83.486898),('48112','MI','Belleville','Wayne',42.2047,-83.4852),('48113','MI','Ann Arbor','Washtenaw',42.3107,-83.6922),('48114','MI','Brighton','Livingston',42.566649,-83.745768),('48115','MI','Bridgewater','Washtenaw',42.1708,-83.7741),('48116','MI','Brighton','Livingston',42.505753,-83.779505),('48117','MI','Carleton','Monroe',42.052224,-83.397079),('48118','MI','Chelsea','Washtenaw',42.30941,-84.038931),('48120','MI','Dearborn','Wayne',42.311707,-83.168834),('48121','MI','Dearborn','Wayne',42.3115,-83.1913),('48122','MI','Melvindale','Wayne',42.281254,-83.179148),('48123','MI','Dearborn','Wayne',42.3041,-83.2491),('48124','MI','Dearborn','Wayne',42.295633,-83.249614),('48125','MI','Dearborn Heights','Wayne',42.277459,-83.259884),('48126','MI','Dearborn','Wayne',42.330392,-83.183492),('48127','MI','Dearborn Heights','Wayne',42.335819,-83.282042),('48128','MI','Dearborn','Wayne',42.321215,-83.263664),('48130','MI','Dexter','Washtenaw',42.341962,-83.898662),('48131','MI','Dundee','Monroe',41.962477,-83.665531),('48133','MI','Erie','Monroe',41.774591,-83.489471),('48134','MI','Flat Rock','Wayne',42.106413,-83.287679),('48135','MI','Garden City','Wayne',42.324533,-83.338239),('48136','MI','Garden City','Wayne',42.3109,-83.3491),('48137','MI','Gregory','Livingston',42.439098,-84.065027),('48138','MI','Grosse Ile','Wayne',42.131288,-83.155729),('48139','MI','Hamburg','Livingston',42.451388,-83.80016),('48140','MI','Ida','Monroe',41.873694,-83.582125),('48141','MI','Inkster','Wayne',42.2918,-83.314148),('48143','MI','Lakeland','Livingston',42.454366,-83.833727),('48144','MI','Lambertville','Monroe',41.752443,-83.628666),('48145','MI','La Salle','Monroe',41.846166,-83.446391),('48146','MI','Lincoln Park','Wayne',42.245035,-83.180916),('48150','MI','Livonia','Wayne',42.365417,-83.368964),('48151','MI','Livonia','Wayne',42.3717,-83.3526),('48152','MI','Livonia','Wayne',42.4272,-83.366355),('48153','MI','Livonia','Wayne',42.3683,-83.3527),('48154','MI','Livonia','Wayne',42.393805,-83.373343),('48157','MI','Luna Pier','Monroe',41.81144,-83.442357),('48158','MI','Manchester','Washtenaw',42.147266,-84.037787),('48159','MI','Maybee','Monroe',42.019159,-83.547956),('48160','MI','Milan','Washtenaw',42.083283,-83.68451),('48161','MI','Monroe','Monroe',41.903572,-83.417995),('48162','MI','Monroe','Monroe',41.943137,-83.391958),('48164','MI','New Boston','Wayne',42.135188,-83.385746),('48165','MI','New Hudson','Oakland',42.502839,-83.62614),('48166','MI','Newport','Monroe',41.984487,-83.292048),('48167','MI','Northville','Oakland',42.435325,-83.491647),('48168','MI','Northville','Wayne',42.406689,-83.489927),('48169','MI','Pinckney','Livingston',42.449915,-83.930911),('48170','MI','Plymouth','Wayne',42.371053,-83.485211),('48173','MI','Rockwood','Wayne',42.074784,-83.216397),('48174','MI','Romulus','Wayne',42.221377,-83.369534),('48175','MI','Salem','Washtenaw',42.4061,-83.58),('48176','MI','Saline','Washtenaw',42.165706,-83.782018),('48177','MI','Samaria','Monroe',41.802037,-83.580612),('48178','MI','South Lyon','Oakland',42.459306,-83.667681),('48179','MI','South Rockwood','Monroe',42.04371,-83.253561),('48180','MI','Taylor','Wayne',42.23128,-83.264568),('48182','MI','Temperance','Monroe',41.773058,-83.577413),('48183','MI','Trenton','Wayne',42.134617,-83.217232),('48184','MI','Wayne','Wayne',42.276783,-83.378715),('48185','MI','Westland','Wayne',42.33612,-83.378882),('48186','MI','Westland','Wayne',42.294083,-83.374684),('48187','MI','Canton','Wayne',42.330037,-83.474998),('48188','MI','Canton','Wayne',42.290157,-83.484553),('48189','MI','Whitmore Lake','Washtenaw',42.425458,-83.783655),('48190','MI','Whittaker','Washtenaw',42.133906,-83.597342),('48191','MI','Willis','Washtenaw',42.127005,-83.561536),('48192','MI','Wyandotte','Wayne',42.208419,-83.163598),('48193','MI','Riverview','Wayne',42.174994,-83.20456),('48195','MI','Southgate','Wayne',42.205175,-83.200455),('48197','MI','Ypsilanti','Washtenaw',42.213712,-83.632658),('48198','MI','Ypsilanti','Washtenaw',42.247802,-83.582365),('48201','MI','Detroit','Wayne',42.344599,-83.061492),('48202','MI','Detroit','Wayne',42.374062,-83.077727),('48203','MI','Highland Park','Wayne',42.42058,-83.099711),('48204','MI','Detroit','Wayne',42.365262,-83.14253),('48205','MI','Detroit','Wayne',42.433672,-82.980612),('48206','MI','Detroit','Wayne',42.37489,-83.107912),('48207','MI','Detroit','Wayne',42.352769,-83.024654),('48208','MI','Detroit','Wayne',42.348669,-83.090339),('48209','MI','Detroit','Wayne',42.306144,-83.114189),('48210','MI','Detroit','Wayne',42.337392,-83.127373),('48211','MI','Detroit','Wayne',42.380196,-83.044579),('48212','MI','Hamtramck','Wayne',42.409914,-83.058277),('48213','MI','Detroit','Wayne',42.397311,-82.994511),('48214','MI','Detroit','Wayne',42.366451,-82.992003),('48215','MI','Detroit','Wayne',42.377862,-82.953236),('48216','MI','Detroit','Wayne',42.326461,-83.078099),('48217','MI','Detroit','Wayne',42.274646,-83.15464),('48218','MI','River Rouge','Wayne',42.2708,-83.135568),('48219','MI','Detroit','Wayne',42.425354,-83.248937),('48220','MI','Ferndale','Oakland',42.459013,-83.133502),('48221','MI','Detroit','Wayne',42.42876,-83.149942),('48222','MI','Detroit','Wayne',42.2927,-83.1386),('48223','MI','Detroit','Wayne',42.394528,-83.242991),('48224','MI','Detroit','Wayne',42.410415,-82.943287),('48225','MI','Harper Woods','Wayne',42.438152,-82.927953),('48226','MI','Detroit','Wayne',42.33204,-83.049152),('48227','MI','Detroit','Wayne',42.388653,-83.191916),('48228','MI','Detroit','Wayne',42.355158,-83.217129),('48229','MI','Ecorse','Wayne',42.251195,-83.147944),('48230','MI','Grosse Pointe','Wayne',42.382037,-82.923209),('48231','MI','Detroit','Wayne',42.3316,-83.05),('48232','MI','Detroit','Wayne',42.2927,-83.1386),('48233','MI','Detroit','Wayne',42.2927,-83.1386),('48234','MI','Detroit','Wayne',42.432649,-83.043021),('48235','MI','Detroit','Wayne',42.427865,-83.194306),('48236','MI','Grosse Pointe','Wayne',42.425597,-82.898397),('48237','MI','Oak Park','Oakland',42.468912,-83.181788),('48238','MI','Detroit','Wayne',42.396762,-83.14054),('48239','MI','Redford','Wayne',42.378188,-83.286247),('48240','MI','Redford','Wayne',42.428441,-83.301315),('48242','MI','Detroit','Wayne',42.20649,-83.352974),('48243','MI','Detroit','Wayne',42.3305,-83.0385),('48244','MI','Detroit','Wayne',42.2927,-83.1386),('48255','MI','Detroit','Wayne',42.2927,-83.1386),('48260','MI','Detroit','Wayne',42.2927,-83.1386),('48264','MI','Detroit','Wayne',42.2927,-83.1386),('48265','MI','Detroit','Wayne',42.4388,-82.9293),('48266','MI','Detroit','Wayne',42.2927,-83.1386),('48267','MI','Detroit','Wayne',42.2927,-83.1386),('48268','MI','Detroit','Wayne',42.2927,-83.1386),('48269','MI','Detroit','Wayne',42.2927,-83.1386),('48272','MI','Detroit','Wayne',42.2927,-83.1386),('48275','MI','Detroit','Wayne',42.2927,-83.1386),('48277','MI','Detroit','Wayne',42.2927,-83.1386),('48278','MI','Detroit','Wayne',42.2927,-83.1386),('48279','MI','Detroit','Wayne',42.2927,-83.1386),('48288','MI','Detroit','Wayne',42.4221,-83.1034),('48301','MI','Bloomfield Hills','Oakland',42.546471,-83.281144),('48302','MI','Bloomfield Hills','Oakland',42.586677,-83.297164),('48303','MI','Bloomfield Hills','Oakland',42.5836,-83.2455),('48304','MI','Bloomfield Hills','Oakland',42.591665,-83.231056),('48306','MI','Rochester','Oakland',42.718,-83.156373),('48307','MI','Rochester','Oakland',42.662375,-83.127514),('48308','MI','Rochester','Oakland',42.6805,-83.1338),('48309','MI','Rochester','Oakland',42.662056,-83.181858),('48310','MI','Sterling Heights','Macomb',42.566479,-83.067923),('48311','MI','Sterling Heights','Macomb',42.5802,-83.0302),('48312','MI','Sterling Heights','Macomb',42.561469,-83.005193),('48313','MI','Sterling Heights','Macomb',42.601659,-82.999156),('48314','MI','Sterling Heights','Macomb',42.611623,-83.048845),('48315','MI','Utica','Macomb',42.660826,-82.993861),('48316','MI','Utica','Macomb',42.690907,-83.062096),('48317','MI','Utica','Macomb',42.64484,-83.051972),('48318','MI','Utica','Macomb',42.6261,-83.0336),('48320','MI','Keego Harbor','Oakland',42.611789,-83.338928),('48321','MI','Auburn Hills','Oakland',42.6395,-83.2941),('48322','MI','West Bloomfield','Oakland',42.544921,-83.381406),('48323','MI','West Bloomfield','Oakland',42.568435,-83.374064),('48324','MI','West Bloomfield','Oakland',42.596544,-83.394369),('48325','MI','West Bloomfield','Oakland',42.6242,-83.3183),('48326','MI','Auburn Hills','Oakland',42.666391,-83.247946),('48327','MI','Waterford','Oakland',42.641398,-83.405446),('48328','MI','Waterford','Oakland',42.641227,-83.351529),('48329','MI','Waterford','Oakland',42.687016,-83.388622),('48330','MI','Drayton Plains','Oakland',42.6841,-83.3772),('48331','MI','Farmington','Oakland',42.508798,-83.408811),('48332','MI','Farmington','Oakland',42.4644,-83.3763),('48333','MI','Farmington','Oakland',42.4644,-83.3763),('48334','MI','Farmington','Oakland',42.50688,-83.353804),('48335','MI','Farmington','Oakland',42.465272,-83.398405),('48336','MI','Farmington','Oakland',42.4568,-83.34475),('48340','MI','Pontiac','Oakland',42.670121,-83.290635),('48341','MI','Pontiac','Oakland',42.627943,-83.300261),('48342','MI','Pontiac','Oakland',42.64259,-83.281987),('48343','MI','Pontiac','Oakland',42.6388,-83.2911),('48346','MI','Clarkston','Oakland',42.719868,-83.406888),('48347','MI','Clarkston','Oakland',42.7358,-83.4188),('48348','MI','Clarkston','Oakland',42.768029,-83.378099),('48350','MI','Davisburg','Oakland',42.751858,-83.523076),('48353','MI','Hartland','Livingston',42.64592,-83.722631),('48356','MI','Highland','Oakland',42.666009,-83.585845),('48357','MI','Highland','Oakland',42.645222,-83.629399),('48359','MI','Lake Orion','Oakland',42.72278,-83.285267),('48360','MI','Lake Orion','Oakland',42.747492,-83.259919),('48361','MI','Lake Orion','Oakland',42.7844,-83.2397),('48362','MI','Lake Orion','Oakland',42.785468,-83.247896),('48363','MI','Oakland','Oakland',42.765357,-83.172743),('48366','MI','Lakeville','Oakland',42.8213,-83.1502),('48367','MI','Leonard','Oakland',42.838562,-83.14451),('48370','MI','Oxford','Oakland',42.828391,-83.209475),('48371','MI','Oxford','Oakland',42.827106,-83.276689),('48374','MI','Novi','Oakland',42.468,-83.522099),('48375','MI','Novi','Oakland',42.463082,-83.461486),('48376','MI','Novi','Oakland',42.4871,-83.476),('48377','MI','Novi','Oakland',42.507695,-83.4731),('48380','MI','Milford','Oakland',42.583002,-83.666824),('48381','MI','Milford','Oakland',42.577477,-83.597172),('48382','MI','Commerce Township','Oakland',42.592303,-83.48842),('48383','MI','White Lake','Oakland',42.658045,-83.544541),('48386','MI','White Lake','Oakland',42.642638,-83.472295),('48387','MI','Union Lake','Oakland',42.6147,-83.4469),('48390','MI','Walled Lake','Oakland',42.54787,-83.479526),('48391','MI','Walled Lake','Oakland',42.5377,-83.4811),('48393','MI','Wixom','Oakland',42.527218,-83.535587),('48397','MI','Warren','Macomb',42.4916,-83.0402),('48401','MI','Applegate','Sanilac',43.356171,-82.664072),('48410','MI','Argyle','Sanilac',43.5641,-82.9361),('48411','MI','Atlas','Genesee',42.936607,-83.533517),('48412','MI','Attica','Lapeer',43.053596,-83.16657),('48413','MI','Bad Axe','Huron',43.804819,-83.001952),('48414','MI','Bancroft','Shiawassee',42.869407,-84.075407),('48415','MI','Birch Run','Saginaw',43.271876,-83.808105),('48416','MI','Brown City','Sanilac',43.213318,-82.976407),('48417','MI','Burt','Saginaw',43.258216,-83.938886),('48418','MI','Byron','Shiawassee',42.812963,-83.948704),('48419','MI','Carsonville','Sanilac',43.418871,-82.659738),('48420','MI','Clio','Genesee',43.177974,-83.725291),('48421','MI','Columbiaville','Lapeer',43.155716,-83.380848),('48422','MI','Croswell','Sanilac',43.265077,-82.642514),('48423','MI','Davison','Genesee',43.033179,-83.52197),('48426','MI','Decker','Sanilac',43.508618,-83.065131),('48427','MI','Deckerville','Sanilac',43.519957,-82.712816),('48428','MI','Dryden','Lapeer',42.938506,-83.136454),('48429','MI','Durand','Shiawassee',42.919442,-84.002534),('48430','MI','Fenton','Genesee',42.772767,-83.747495),('48432','MI','Filion','Huron',43.897532,-82.995918),('48433','MI','Flushing','Genesee',43.070907,-83.847802),('48434','MI','Forestville','Sanilac',43.661417,-82.61085),('48435','MI','Fostoria','Tuscola',43.245379,-83.359338),('48436','MI','Gaines','Genesee',42.865316,-83.87683),('48437','MI','Genesee','Genesee',43.111606,-83.618204),('48438','MI','Goodrich','Genesee',42.912456,-83.463907),('48439','MI','Grand Blanc','Genesee',42.924718,-83.636756),('48440','MI','Hadley','Lapeer',42.952964,-83.405447),('48441','MI','Harbor Beach','Huron',43.813207,-82.69284),('48442','MI','Holly','Oakland',42.797343,-83.599855),('48444','MI','Imlay City','Lapeer',43.041881,-83.06618),('48445','MI','Kinde','Huron',43.952118,-83.01966),('48446','MI','Lapeer','Lapeer',43.052249,-83.32659),('48449','MI','Lennon','Shiawassee',42.989112,-83.935232),('48450','MI','Lexington','Sanilac',43.241252,-82.526684),('48451','MI','Linden','Genesee',42.800082,-83.811363),('48453','MI','Marlette','Sanilac',43.324632,-83.050073),('48454','MI','Melvin','Sanilac',43.194577,-82.82535),('48455','MI','Metamora','Lapeer',42.94524,-83.287358),('48456','MI','Minden City','Sanilac',43.666971,-82.762208),('48457','MI','Montrose','Genesee',43.187488,-83.904358),('48458','MI','Mount Morris','Genesee',43.115382,-83.69118),('48460','MI','New Lothrop','Shiawassee',43.123857,-83.984481),('48461','MI','North Branch','Lapeer',43.210801,-83.206169),('48462','MI','Ortonville','Oakland',42.848513,-83.421668),('48463','MI','Otisville','Genesee',43.160593,-83.531946),('48464','MI','Otter Lake','Lapeer',43.218816,-83.436327),('48465','MI','Palms','Sanilac',43.619011,-82.687688),('48466','MI','Peck','Sanilac',43.269566,-82.825106),('48467','MI','Port Austin','Huron',44.021453,-82.992947),('48468','MI','Port Hope','Huron',43.95299,-82.775744),('48469','MI','Port Sanilac','Sanilac',43.450636,-82.549222),('48470','MI','Ruth','Huron',43.732181,-82.73918),('48471','MI','Sandusky','Sanilac',43.41177,-82.837065),('48472','MI','Snover','Sanilac',43.50136,-82.96263),('48473','MI','Swartz Creek','Genesee',42.949548,-83.816047),('48475','MI','Ubly','Huron',43.673813,-82.928065),('48476','MI','Vernon','Shiawassee',42.939392,-84.031803),('48480','MI','Grand Blanc','Genesee',42.9275,-83.63),('48501','MI','Flint','Genesee',43.0233,-83.6856),('48502','MI','Flint','Genesee',43.013295,-83.689361),('48503','MI','Flint','Genesee',43.011304,-83.692827),('48504','MI','Flint','Genesee',43.044104,-83.732899),('48505','MI','Flint','Genesee',43.063047,-83.695157),('48506','MI','Flint','Genesee',43.048271,-83.64513),('48507','MI','Flint','Genesee',42.976805,-83.702472),('48509','MI','Burton','Genesee',43.023941,-83.604709),('48519','MI','Burton','Genesee',42.985712,-83.610772),('48529','MI','Burton','Genesee',42.972589,-83.670787),('48531','MI','Flint','Genesee',43.0467,-83.7444),('48532','MI','Flint','Genesee',43.005112,-83.761182),('48550','MI','Flint','Genesee',43.0233,-83.6856),('48551','MI','Flint','Genesee',42.9645,-83.7185),('48552','MI','Flint','Genesee',42.9645,-83.7185),('48553','MI','Flint','Genesee',42.9645,-83.7185),('48554','MI','Flint','Genesee',42.9724,-83.7952),('48555','MI','Flint','Genesee',43.0097,-83.7093),('48556','MI','Flint','Genesee',43.0233,-83.6856),('48557','MI','Flint','Genesee',42.9645,-83.7185),('48559','MI','Flint','Genesee',43.0233,-83.6856),('48601','MI','Saginaw','Saginaw',43.414362,-83.91642),('48602','MI','Saginaw','Saginaw',43.423695,-83.971277),('48603','MI','Saginaw','Saginaw',43.454831,-84.015274),('48604','MI','Saginaw','Saginaw',43.47833,-83.94498),('48605','MI','Saginaw','Saginaw',43.4207,-83.9458),('48606','MI','Saginaw','Saginaw',43.432,-83.9341),('48607','MI','Saginaw','Saginaw',43.432412,-83.933828),('48608','MI','Saginaw','Saginaw',43.4392,-84.0292),('48609','MI','Saginaw','Saginaw',43.394508,-84.093404),('48610','MI','Alger','Arenac',44.141129,-84.141243),('48611','MI','Auburn','Bay',43.60533,-84.088606),('48612','MI','Beaverton','Gladwin',43.876382,-84.42166),('48613','MI','Bentley','Bay',43.947886,-84.155644),('48614','MI','Brant','Saginaw',43.251216,-84.298286),('48615','MI','Breckenridge','Gratiot',43.4218,-84.47426),('48616','MI','Chesaning','Saginaw',43.191074,-84.113461),('48617','MI','Clare','Clare',43.827554,-84.745637),('48618','MI','Coleman','Midland',43.748962,-84.556398),('48619','MI','Comins','Oscoda',44.835287,-84.0305),('48620','MI','Edenville','Midland',43.807728,-84.377858),('48621','MI','Fairview','Oscoda',44.736899,-84.012427),('48622','MI','Farwell','Clare',43.843681,-84.869537),('48623','MI','Freeland','Saginaw',43.524344,-84.138242),('48624','MI','Gladwin','Gladwin',44.041708,-84.46229),('48625','MI','Harrison','Clare',44.052142,-84.837443),('48626','MI','Hemlock','Saginaw',43.412438,-84.214723),('48627','MI','Higgins Lake','Roscommon',44.462164,-84.748107),('48628','MI','Hope','Midland',43.807346,-84.33807),('48629','MI','Houghton Lake','Roscommon',44.319113,-84.764608),('48630','MI','Houghton Lake Heights','Roscommon',44.327702,-84.77229),('48631','MI','Kawkawlin','Bay',43.680676,-83.980856),('48632','MI','Lake','Clare',43.87628,-85.006896),('48633','MI','Lake George','Clare',43.948976,-84.93383),('48634','MI','Linwood','Bay',43.742832,-84.011224),('48635','MI','Lupton','Ogemaw',44.387169,-83.99443),('48636','MI','Luzerne','Oscoda',44.608325,-84.287054),('48637','MI','Merrill','Saginaw',43.410676,-84.339368),('48638','MI','Saginaw','Saginaw',43.418926,-84.018242),('48640','MI','Midland','Midland',43.605429,-84.273104),('48641','MI','Midland','Midland',43.6231,-84.2272),('48642','MI','Midland','Midland',43.657135,-84.222571),('48647','MI','Mio','Oscoda',44.654072,-84.115605),('48649','MI','Oakley','Saginaw',43.147833,-84.183959),('48650','MI','Pinconning','Bay',43.846094,-83.976792),('48651','MI','Prudenville','Roscommon',44.278827,-84.642258),('48652','MI','Rhodes','Gladwin',43.848279,-84.196876),('48653','MI','Roscommon','Roscommon',44.4968,-84.649712),('48654','MI','Rose City','Ogemaw',44.461063,-84.140565),('48655','MI','Saint Charles','Saginaw',43.297254,-84.146308),('48656','MI','Saint Helen','Roscommon',44.360345,-84.438205),('48657','MI','Sanford','Midland',43.694503,-84.398364),('48658','MI','Standish','Arenac',43.974575,-83.906302),('48659','MI','Sterling','Arenac',44.077653,-84.026763),('48661','MI','West Branch','Ogemaw',44.325063,-84.226541),('48662','MI','Wheeler','Gratiot',43.400996,-84.416668),('48663','MI','Saginaw','Saginaw',43.4207,-83.9458),('48667','MI','Midland','Midland',43.6231,-84.2272),('48670','MI','Midland','Midland',43.6231,-84.2272),('48674','MI','Midland','Midland',43.6165,-84.1972),('48686','MI','Midland','Midland',43.6231,-84.2272),('48701','MI','Akron','Tuscola',43.587666,-83.554404),('48703','MI','Au Gres','Arenac',44.053564,-83.656711),('48705','MI','Barton City','Alcona',44.706331,-83.636158),('48706','MI','Bay City','Bay',43.607267,-83.914039),('48707','MI','Bay City','Bay',43.6003,-83.8873),('48708','MI','Bay City','Bay',43.58214,-83.87766),('48710','MI','University Center','Bay',43.5608,-83.9899),('48720','MI','Bay Port','Huron',43.846213,-83.349398),('48721','MI','Black River','Alcona',44.808439,-83.331844),('48722','MI','Bridgeport','Saginaw',43.345544,-83.855833),('48723','MI','Caro','Tuscola',43.482295,-83.388154),('48724','MI','Carrollton','Saginaw',43.458897,-83.927305),('48725','MI','Caseville','Huron',43.945501,-83.236492),('48726','MI','Cass City','Tuscola',43.603753,-83.175605),('48727','MI','Clifford','Lapeer',43.311895,-83.180862),('48728','MI','Curran','Alcona',44.74215,-83.829724),('48729','MI','Deford','Tuscola',43.496553,-83.187601),('48730','MI','East Tawas','Iosco',44.321747,-83.454813),('48731','MI','Elkton','Huron',43.839099,-83.163611),('48732','MI','Essexville','Bay',43.612212,-83.808229),('48733','MI','Fairgrove','Tuscola',43.544691,-83.612783),('48734','MI','Frankenmuth','Saginaw',43.337711,-83.741194),('48735','MI','Gagetown','Tuscola',43.664407,-83.260052),('48736','MI','Gilford','Tuscola',43.4941,-83.6219),('48737','MI','Glennie','Alcona',44.549723,-83.712024),('48738','MI','Greenbush','Alcona',44.558917,-83.329011),('48739','MI','Hale','Iosco',44.381294,-83.855176),('48740','MI','Harrisville','Alcona',44.663651,-83.352536),('48741','MI','Kingston','Tuscola',43.404614,-83.174768),('48742','MI','Lincoln','Alcona',44.725173,-83.439248),('48743','MI','Long Lake','Iosco',44.437698,-83.88399),('48744','MI','Mayville','Tuscola',43.347618,-83.357764),('48745','MI','Mikado','Alcona',44.584367,-83.479177),('48746','MI','Millington','Tuscola',43.272773,-83.542388),('48747','MI','Munger','Bay',43.518879,-83.764927),('48748','MI','National City','Iosco',44.319492,-83.671423),('48749','MI','Omer','Arenac',44.060325,-83.88475),('48750','MI','Oscoda','Iosco',44.445937,-83.391505),('48754','MI','Owendale','Huron',43.736647,-83.24756),('48755','MI','Pigeon','Huron',43.837217,-83.284076),('48756','MI','Prescott','Ogemaw',44.205265,-83.996321),('48757','MI','Reese','Tuscola',43.464725,-83.690939),('48758','MI','Richville','Tuscola',43.4091,-83.6772),('48759','MI','Sebewaing','Huron',43.738444,-83.427184),('48760','MI','Silverwood','Tuscola',43.332734,-83.253462),('48761','MI','South Branch','Iosco',44.515461,-83.873344),('48762','MI','Spruce','Alcona',44.80735,-83.516053),('48763','MI','Tawas City','Iosco',44.261372,-83.568237),('48764','MI','Tawas City','Iosco',44.2694,-83.5147),('48765','MI','Turner','Arenac',44.144868,-83.726737),('48766','MI','Twining','Arenac',44.106047,-83.837152),('48767','MI','Unionville','Tuscola',43.651629,-83.473479),('48768','MI','Vassar','Tuscola',43.368754,-83.577665),('48769','MI','Tuscola','Tuscola',43.3368,-83.3475),('48770','MI','Whittemore','Iosco',44.251183,-83.814184),('48787','MI','Frankenmuth','Saginaw',43.3316,-83.738),('48801','MI','Alma','Gratiot',43.377236,-84.664198),('48802','MI','Alma','Gratiot',43.3788,-84.6597),('48804','MI','Mount Pleasant','Isabella',43.6025,-84.7752),('48805','MI','Okemos','Ingham',42.7222,-84.4275),('48806','MI','Ashley','Gratiot',43.179354,-84.506064),('48807','MI','Bannister','Gratiot',43.148174,-84.423992),('48808','MI','Bath','Clinton',42.819068,-84.457241),('48809','MI','Belding','Ionia',43.0865,-85.251534),('48811','MI','Carson City','Montcalm',43.182061,-84.849538),('48812','MI','Cedar Lake','Montcalm',43.4061,-84.975),('48813','MI','Charlotte','Eaton',42.577976,-84.822773),('48815','MI','Clarksville','Ionia',42.846559,-85.250189),('48816','MI','Cohoctah','Livingston',42.759248,-83.950867),('48817','MI','Corunna','Shiawassee',42.997502,-84.074237),('48818','MI','Crystal','Montcalm',43.270877,-84.915573),('48819','MI','Dansville','Ingham',42.54423,-84.293281),('48820','MI','Dewitt','Clinton',42.84435,-84.575046),('48821','MI','Dimondale','Eaton',42.645178,-84.644436),('48822','MI','Eagle','Clinton',42.828925,-84.76386),('48823','MI','East Lansing','Ingham',42.747719,-84.471382),('48824','MI','East Lansing','Ingham',42.725884,-84.479202),('48825','MI','East Lansing','Ingham',42.726467,-84.478436),('48826','MI','East Lansing','Ingham',42.7457,-84.4838),('48827','MI','Eaton Rapids','Eaton',42.50841,-84.65391),('48829','MI','Edmore','Montcalm',43.403695,-85.030725),('48830','MI','Elm Hall','Gratiot',43.362879,-84.83662),('48831','MI','Elsie','Clinton',43.096845,-84.386391),('48832','MI','Elwell','Gratiot',43.419158,-84.776609),('48833','MI','Eureka','Clinton',43.1036,-84.5138),('48834','MI','Fenwick','Montcalm',43.126998,-85.056958),('48835','MI','Fowler','Clinton',43.02836,-84.731264),('48836','MI','Fowlerville','Livingston',42.666635,-84.071799),('48837','MI','Grand Ledge','Eaton',42.754121,-84.748307),('48838','MI','Greenville','Montcalm',43.180285,-85.264773),('48840','MI','Haslett','Ingham',42.760818,-84.389243),('48841','MI','Henderson','Shiawassee',43.10822,-84.216316),('48842','MI','Holt','Ingham',42.639256,-84.526928),('48843','MI','Howell','Livingston',42.586182,-83.912347),('48844','MI','Howell','Livingston',42.6072,-83.9294),('48845','MI','Hubbardston','Ionia',43.095736,-84.846157),('48846','MI','Ionia','Ionia',42.982254,-85.063622),('48847','MI','Ithaca','Gratiot',43.269925,-84.591867),('48848','MI','Laingsburg','Shiawassee',42.888505,-84.360037),('48849','MI','Lake Odessa','Ionia',42.79094,-85.135811),('48850','MI','Lakeview','Montcalm',43.445297,-85.255106),('48851','MI','Lyons','Ionia',42.969158,-84.936256),('48852','MI','Mcbrides','Montcalm',43.352502,-85.043425),('48853','MI','Maple Rapids','Clinton',43.103328,-84.691674),('48854','MI','Mason','Ingham',42.581677,-84.44945),('48855','MI','Howell','Livingston',42.683439,-83.917717),('48856','MI','Middleton','Gratiot',43.196944,-84.733375),('48857','MI','Morrice','Shiawassee',42.846107,-84.166251),('48858','MI','Mount Pleasant','Isabella',43.605367,-84.784869),('48859','MI','Mount Pleasant','Isabella',43.5836,-84.7761),('48860','MI','Muir','Ionia',43.024382,-84.92646),('48861','MI','Mulliken','Eaton',42.733839,-84.916069),('48862','MI','North Star','Gratiot',43.2598,-84.5353),('48863','MI','Pearces','Livingston',42.6323,-83.9167),('48864','MI','Okemos','Ingham',42.704404,-84.416419),('48865','MI','Orleans','Ionia',43.094042,-85.117625),('48866','MI','Ovid','Clinton',42.997596,-84.376341),('48867','MI','Owosso','Shiawassee',42.995641,-84.179599),('48870','MI','Palo','Ionia',43.110402,-84.984595),('48871','MI','Perrinton','Gratiot',43.157853,-84.674417),('48872','MI','Perry','Shiawassee',42.812005,-84.223901),('48873','MI','Pewamo','Ionia',42.996853,-84.84415),('48874','MI','Pompeii','Gratiot',43.184446,-84.601882),('48875','MI','Portland','Ionia',42.862708,-84.916836),('48876','MI','Potterville','Eaton',42.637377,-84.735486),('48877','MI','Riverdale','Gratiot',43.395372,-84.840729),('48878','MI','Rosebush','Isabella',43.71062,-84.770508),('48879','MI','Saint Johns','Clinton',43.006609,-84.570162),('48880','MI','Saint Louis','Gratiot',43.430489,-84.592706),('48881','MI','Saranac','Ionia',42.926091,-85.20273),('48882','MI','Shaftsburg','Shiawassee',42.8047,-84.293),('48883','MI','Shepherd','Isabella',43.543726,-84.673888),('48884','MI','Sheridan','Montcalm',43.205735,-85.06636),('48885','MI','Sidney','Montcalm',43.250256,-85.154062),('48886','MI','Six Lakes','Montcalm',43.426582,-85.150022),('48887','MI','Smyrna','Ionia',43.0594,-85.2627),('48888','MI','Stanton','Montcalm',43.301874,-85.108788),('48889','MI','Sumner','Gratiot',43.29641,-84.800326),('48890','MI','Sunfield','Eaton',42.766874,-84.966363),('48891','MI','Vestaburg','Montcalm',43.399693,-84.918345),('48892','MI','Webberville','Ingham',42.650784,-84.177195),('48893','MI','Weidman','Isabella',43.663811,-84.981273),('48894','MI','Westphalia','Clinton',42.929753,-84.790501),('48895','MI','Williamston','Ingham',42.689721,-84.278412),('48896','MI','Winn','Isabella',43.523818,-84.902734),('48897','MI','Woodland','Barry',42.705224,-85.12449),('48901','MI','Lansing','Ingham',42.7323,-84.556),('48906','MI','Lansing','Ingham',42.769314,-84.566163),('48908','MI','Lansing','Eaton',42.7335,-84.6391),('48909','MI','Lansing','Ingham',42.6849,-84.4986),('48910','MI','Lansing','Ingham',42.703904,-84.543314),('48911','MI','Lansing','Ingham',42.67688,-84.571154),('48912','MI','Lansing','Ingham',42.735817,-84.524441),('48913','MI','Lansing','Ingham',42.6849,-84.4986),('48915','MI','Lansing','Ingham',42.737954,-84.570938),('48916','MI','Lansing','Ingham',42.6636,-84.5361),('48917','MI','Lansing','Eaton',42.730422,-84.624845),('48918','MI','Lansing','Ingham',42.6849,-84.4986),('48919','MI','Lansing','Ingham',42.6849,-84.4986),('48921','MI','Lansing','Ingham',42.6849,-84.4986),('48922','MI','Lansing','Ingham',42.6849,-84.4986),('48924','MI','Lansing','Ingham',42.6849,-84.4986),('48929','MI','Lansing','Ingham',42.6849,-84.4986),('48930','MI','Lansing','Ingham',42.6849,-84.4986),('48933','MI','Lansing','Ingham',42.731992,-84.553083),('48937','MI','Lansing','Ingham',42.7487,-84.5587),('48950','MI','Lansing','Ingham',42.6849,-84.4986),('48951','MI','Lansing','Ingham',42.7327,-84.5558),('48956','MI','Lansing','Ingham',42.6849,-84.4986),('48980','MI','Lansing','Ingham',42.6849,-84.4986),('49001','MI','Kalamazoo','Kalamazoo',42.268622,-85.567749),('49002','MI','Portage','Kalamazoo',42.208338,-85.567184),('49003','MI','Kalamazoo','Kalamazoo',42.2661,-85.5663),('49004','MI','Kalamazoo','Kalamazoo',42.330537,-85.572835),('49005','MI','Kalamazoo','Kalamazoo',42.2919,-85.5798),('49006','MI','Kalamazoo','Kalamazoo',42.294178,-85.623049),('49007','MI','Kalamazoo','Kalamazoo',42.298396,-85.585597),('49008','MI','Kalamazoo','Kalamazoo',42.265927,-85.610954),('49009','MI','Kalamazoo','Kalamazoo',42.280616,-85.683095),('49010','MI','Allegan','Allegan',42.529143,-85.873281),('49011','MI','Athens','Calhoun',42.091648,-85.234655),('49012','MI','Augusta','Kalamazoo',42.350751,-85.344597),('49013','MI','Bangor','Van Buren',42.308732,-86.121994),('49014','MI','Battle Creek','Calhoun',42.311039,-85.139048),('49015','MI','Battle Creek','Calhoun',42.28905,-85.206499),('49016','MI','Battle Creek','Calhoun',42.316112,-85.18006),('49017','MI','Battle Creek','Calhoun',42.370038,-85.196287),('49018','MI','Battle Creek','Calhoun',42.3954,-85.2165),('49019','MI','Kalamazoo','Kalamazoo',42.2916,-85.5872),('49020','MI','Bedford','Calhoun',42.321,-85.1287),('49021','MI','Bellevue','Eaton',42.441038,-85.045184),('49022','MI','Benton Harbor','Berrien',42.110356,-86.416188),('49023','MI','Benton Harbor','Berrien',42.1083,-86.4645),('49024','MI','Portage','Kalamazoo',42.216893,-85.617471),('49026','MI','Bloomingdale','Van Buren',42.376862,-85.963435),('49027','MI','Breedsville','Van Buren',42.34601,-86.071922),('49028','MI','Bronson','Branch',41.84975,-85.189679),('49029','MI','Burlington','Calhoun',42.142013,-85.097672),('49030','MI','Burr Oak','St. Joseph',41.854628,-85.329708),('49031','MI','Cassopolis','Cass',41.905342,-85.993838),('49032','MI','Centreville','St. Joseph',41.924266,-85.510109),('49033','MI','Ceresco','Calhoun',42.239194,-85.093008),('49034','MI','Climax','Kalamazoo',42.237364,-85.336819),('49035','MI','Cloverdale','Barry',42.6367,-85.3088),('49036','MI','Coldwater','Branch',41.909987,-85.013415),('49037','MI','Battle Creek','Calhoun',42.331501,-85.230601),('49038','MI','Coloma','Berrien',42.209503,-86.33364),('49039','MI','Hagar Shores','Berrien',42.1861,-86.3083),('49040','MI','Colon','St. Joseph',41.95886,-85.327298),('49041','MI','Comstock','Kalamazoo',42.2866,-85.5133),('49042','MI','Constantine','St. Joseph',41.847389,-85.664082),('49043','MI','Covert','Van Buren',42.297575,-86.27447),('49045','MI','Decatur','Van Buren',42.106153,-85.996188),('49046','MI','Delton','Barry',42.504192,-85.405077),('49047','MI','Dowagiac','Cass',41.997422,-86.123527),('49048','MI','Kalamazoo','Kalamazoo',42.291257,-85.525113),('49050','MI','Dowling','Barry',42.504302,-85.245704),('49051','MI','East Leroy','Calhoun',42.196317,-85.231687),('49052','MI','Fulton','Kalamazoo',42.111897,-85.31681),('49053','MI','Galesburg','Kalamazoo',42.289293,-85.418987),('49055','MI','Gobles','Van Buren',42.371095,-85.86122),('49056','MI','Grand Junction','Van Buren',42.398364,-86.056337),('49057','MI','Hartford','Van Buren',42.199515,-86.169071),('49058','MI','Hastings','Barry',42.639998,-85.294296),('49060','MI','Hickory Corners','Barry',42.424345,-85.40485),('49061','MI','Jones','Cass',41.873542,-85.815243),('49062','MI','Kendall','Van Buren',42.3616,-85.8133),('49063','MI','Lacota','Van Buren',42.4136,-86.1297),('49064','MI','Lawrence','Van Buren',42.218657,-86.050505),('49065','MI','Lawton','Van Buren',42.148312,-85.844444),('49066','MI','Leonidas','St. Joseph',42.038025,-85.357001),('49067','MI','Marcellus','Cass',42.025232,-85.804708),('49068','MI','Marshall','Calhoun',42.277763,-84.952619),('49069','MI','Marshall','Calhoun',42.2718,-84.9575),('49070','MI','Martin','Allegan',42.537938,-85.639793),('49071','MI','Mattawan','Van Buren',42.241731,-85.787096),('49072','MI','Mendon','St. Joseph',42.005822,-85.46412),('49073','MI','Nashville','Barry',42.588939,-85.124212),('49074','MI','Nazareth','Kalamazoo',42.31702,-85.538186),('49075','MI','Nottawa','St. Joseph',41.918134,-85.449077),('49076','MI','Olivet','Eaton',42.439003,-84.910181),('49077','MI','Oshtemo','Kalamazoo',42.2588,-85.6775),('49078','MI','Otsego','Allegan',42.460225,-85.712409),('49079','MI','Paw Paw','Van Buren',42.226324,-85.898771),('49080','MI','Plainwell','Allegan',42.455776,-85.611317),('49081','MI','Portage','Kalamazoo',42.2294,-85.6269),('49082','MI','Quincy','Branch',41.941034,-84.876582),('49083','MI','Richland','Kalamazoo',42.376122,-85.445505),('49084','MI','Riverside','Berrien',42.18237,-86.38288),('49085','MI','Saint Joseph','Berrien',42.074543,-86.476537),('49087','MI','Schoolcraft','Kalamazoo',42.117711,-85.656435),('49088','MI','Scotts','Kalamazoo',42.185097,-85.440814),('49089','MI','Sherwood','Branch',42.007846,-85.237858),('49090','MI','South Haven','Van Buren',42.403469,-86.249045),('49091','MI','Sturgis','St. Joseph',41.822304,-85.432431),('49092','MI','Tekonsha','Calhoun',42.098874,-84.978737),('49093','MI','Three Rivers','St. Joseph',41.959434,-85.633465),('49094','MI','Union City','Branch',42.061414,-85.119919),('49095','MI','Vandalia','Cass',41.906366,-85.885593),('49096','MI','Vermontville','Eaton',42.631564,-85.019854),('49097','MI','Vicksburg','Kalamazoo',42.125866,-85.520496),('49098','MI','Watervliet','Berrien',42.188871,-86.252601),('49099','MI','White Pigeon','St. Joseph',41.793262,-85.671752),('49101','MI','Baroda','Berrien',41.944432,-86.483468),('49102','MI','Berrien Center','Berrien',41.95374,-86.266273),('49103','MI','Berrien Springs','Berrien',41.944619,-86.350873),('49104','MI','Berrien Springs','Berrien',41.963623,-86.35885),('49106','MI','Bridgman','Berrien',41.943236,-86.556223),('49107','MI','Buchanan','Berrien',41.837923,-86.38045),('49111','MI','Eau Claire','Berrien',42.021498,-86.290681),('49112','MI','Edwardsburg','Cass',41.797537,-86.036793),('49113','MI','Galien','Berrien',41.800675,-86.503682),('49115','MI','Harbert','Berrien',41.875928,-86.6336),('49116','MI','Lakeside','Berrien',41.849054,-86.667124),('49117','MI','New Buffalo','Berrien',41.785352,-86.750964),('49119','MI','New Troy','Berrien',41.875069,-86.549235),('49120','MI','Niles','Berrien',41.828361,-86.244953),('49121','MI','Niles','Berrien',41.8275,-86.2541),('49125','MI','Sawyer','Berrien',41.892713,-86.595616),('49126','MI','Sodus','Berrien',42.036177,-86.372719),('49127','MI','Stevensville','Berrien',42.015114,-86.513679),('49128','MI','Three Oaks','Berrien',41.809206,-86.609451),('49129','MI','Union Pier','Berrien',41.82407,-86.691593),('49130','MI','Union','Cass',41.785825,-85.848623),('49201','MI','Jackson','Jackson',42.251669,-84.388279),('49202','MI','Jackson','Jackson',42.263782,-84.410873),('49203','MI','Jackson','Jackson',42.225125,-84.406034),('49204','MI','Jackson','Jackson',42.3202,-84.3911),('49220','MI','Addison','Lenawee',41.992139,-84.329852),('49221','MI','Adrian','Lenawee',41.902334,-84.046133),('49224','MI','Albion','Calhoun',42.264265,-84.753336),('49227','MI','Allen','Hillsdale',41.957015,-84.765407),('49228','MI','Blissfield','Lenawee',41.82118,-83.874227),('49229','MI','Britton','Lenawee',41.989427,-83.830395),('49230','MI','Brooklyn','Jackson',42.085953,-84.220989),('49232','MI','Camden','Hillsdale',41.731106,-84.660328),('49233','MI','Cement City','Hillsdale',42.063402,-84.357603),('49234','MI','Clarklake','Jackson',42.12217,-84.36399),('49235','MI','Clayton','Lenawee',41.854458,-84.208799),('49236','MI','Clinton','Lenawee',42.075472,-83.95701),('49237','MI','Concord','Jackson',42.176612,-84.652988),('49238','MI','Deerfield','Lenawee',41.900446,-83.786869),('49239','MI','Frontier','Hillsdale',41.7816,-84.6047),('49240','MI','Grass Lake','Jackson',42.268829,-84.195579),('49241','MI','Hanover','Jackson',42.107843,-84.603335),('49242','MI','Hillsdale','Hillsdale',41.901586,-84.626471),('49245','MI','Homer','Calhoun',42.143245,-84.806667),('49246','MI','Horton','Jackson',42.12088,-84.494733),('49247','MI','Hudson','Lenawee',41.854188,-84.34966),('49248','MI','Jasper','Lenawee',41.764886,-84.013489),('49249','MI','Jerome','Hillsdale',42.048823,-84.445448),('49250','MI','Jonesville','Hillsdale',42.006261,-84.635158),('49251','MI','Leslie','Ingham',42.45583,-84.412956),('49252','MI','Litchfield','Hillsdale',42.041349,-84.764178),('49253','MI','Manitou Beach','Lenawee',41.974565,-84.279507),('49254','MI','Michigan Center','Jackson',42.226665,-84.31953),('49255','MI','Montgomery','Branch',41.7816,-84.844988),('49256','MI','Morenci','Lenawee',41.746804,-84.214469),('49257','MI','Moscow','Hillsdale',42.0494,-84.51),('49258','MI','Mosherville','Hillsdale',42.0602,-84.6594),('49259','MI','Munith','Jackson',42.368058,-84.247482),('49261','MI','Napoleon','Jackson',42.161234,-84.240815),('49262','MI','North Adams','Hillsdale',41.96362,-84.482009),('49263','MI','Norvell','Jackson',42.158739,-84.182747),('49264','MI','Onondaga','Ingham',42.440376,-84.554876),('49265','MI','Onsted','Lenawee',42.013555,-84.165596),('49266','MI','Osseo','Hillsdale',41.852878,-84.55127),('49267','MI','Ottawa Lake','Monroe',41.757365,-83.709774),('49268','MI','Palmyra','Lenawee',41.868834,-83.937655),('49269','MI','Parma','Jackson',42.288195,-84.580066),('49270','MI','Petersburg','Monroe',41.873774,-83.681721),('49271','MI','Pittsford','Hillsdale',41.834038,-84.456449),('49272','MI','Pleasant Lake','Jackson',42.386331,-84.343276),('49274','MI','Reading','Hillsdale',41.846694,-84.759649),('49276','MI','Riga','Lenawee',41.797393,-83.793452),('49277','MI','Rives Junction','Jackson',42.38861,-84.460237),('49279','MI','Sand Creek','Lenawee',41.79201,-84.10881),('49281','MI','Somerset','Hillsdale',42.050744,-84.377624),('49282','MI','Somerset Center','Hillsdale',42.04714,-84.409745),('49283','MI','Spring Arbor','Jackson',42.205005,-84.549083),('49284','MI','Springport','Jackson',42.386845,-84.71037),('49285','MI','Stockbridge','Ingham',42.464515,-84.201035),('49286','MI','Tecumseh','Lenawee',42.011483,-83.941412),('49287','MI','Tipton','Lenawee',42.036065,-84.091245),('49288','MI','Waldron','Hillsdale',41.733259,-84.447935),('49289','MI','Weston','Lenawee',41.770777,-84.101551),('49301','MI','Ada','Kent',42.966661,-85.483159),('49302','MI','Alto','Kent',42.820969,-85.403212),('49303','MI','Bailey','Muskegon',43.271279,-85.841168),('49304','MI','Baldwin','Lake',43.895446,-85.896484),('49305','MI','Barryton','Mecosta',43.749043,-85.167768),('49306','MI','Belmont','Kent',43.074928,-85.591138),('49307','MI','Big Rapids','Mecosta',43.695042,-85.481164),('49309','MI','Bitely','Newaygo',43.752855,-85.88189),('49310','MI','Blanchard','Isabella',43.517495,-85.066381),('49311','MI','Bradley','Allegan',42.6302,-85.643),('49312','MI','Brohman','Newaygo',43.696022,-85.811056),('49314','MI','Burnips','Allegan',42.7319,-85.8394),('49315','MI','Byron Center','Kent',42.816189,-85.709719),('49316','MI','Caledonia','Kent',42.804553,-85.555433),('49317','MI','Cannonsburg','Kent',43.1271,-85.4824),('49318','MI','Casnovia','Muskegon',43.227269,-85.820379),('49319','MI','Cedar Springs','Kent',43.224563,-85.543689),('49320','MI','Chippewa Lake','Mecosta',43.753586,-85.275467),('49321','MI','Comstock Park','Kent',43.059745,-85.673277),('49322','MI','Coral','Montcalm',43.370002,-85.372027),('49323','MI','Dorr','Allegan',42.721536,-85.778873),('49325','MI','Freeport','Barry',42.765033,-85.307916),('49326','MI','Gowen','Kent',43.244415,-85.337114),('49327','MI','Grant','Newaygo',43.339989,-85.827095),('49328','MI','Hopkins','Allegan',42.637569,-85.760066),('49329','MI','Howard City','Montcalm',43.407835,-85.487167),('49330','MI','Kent City','Kent',43.241536,-85.736679),('49331','MI','Lowell','Kent',42.950066,-85.352142),('49332','MI','Mecosta','Mecosta',43.633754,-85.255198),('49333','MI','Middleville','Barry',42.687365,-85.463579),('49335','MI','Moline','Allegan',42.739903,-85.665605),('49336','MI','Morley','Mecosta',43.50012,-85.437436),('49337','MI','Newaygo','Newaygo',43.430008,-85.73415),('49338','MI','Paris','Mecosta',43.764976,-85.57226),('49339','MI','Pierson','Montcalm',43.330552,-85.490475),('49340','MI','Remus','Mecosta',43.617418,-85.096155),('49341','MI','Rockford','Kent',43.119187,-85.515582),('49342','MI','Rodney','Mecosta',43.696106,-85.309982),('49343','MI','Sand Lake','Kent',43.291183,-85.512439),('49344','MI','Shelbyville','Allegan',42.587856,-85.571214),('49345','MI','Sparta','Kent',43.158511,-85.689441),('49346','MI','Stanwood','Mecosta',43.587512,-85.378472),('49347','MI','Trufant','Montcalm',43.312346,-85.352485),('49348','MI','Wayland','Allegan',42.676899,-85.618041),('49349','MI','White Cloud','Newaygo',43.579679,-85.765663),('49351','MI','Rockford','Kent',43.1207,-85.5609),('49355','MI','Ada','Kent',42.9541,-85.4888),('49356','MI','Ada','Kent',42.9541,-85.4888),('49357','MI','Ada','Kent',42.9541,-85.4888),('49401','MI','Allendale','Ottawa',42.974484,-85.929815),('49402','MI','Branch','Mason',43.912415,-86.043748),('49403','MI','Conklin','Ottawa',43.140975,-85.857766),('49404','MI','Coopersville','Ottawa',43.057241,-85.949733),('49405','MI','Custer','Mason',43.903445,-86.186205),('49406','MI','Douglas','Allegan',42.64232,-86.203832),('49408','MI','Fennville','Allegan',42.584785,-86.131916),('49409','MI','Ferrysburg','Ottawa',43.0844,-86.2202),('49410','MI','Fountain','Mason',44.021556,-86.129269),('49411','MI','Free Soil','Mason',44.100414,-86.251761),('49412','MI','Fremont','Newaygo',43.465751,-85.946178),('49413','MI','Fremont','Newaygo',43.4675,-85.9419),('49415','MI','Fruitport','Muskegon',43.143173,-86.136147),('49416','MI','Glenn','Allegan',42.5202,-86.2275),('49417','MI','Grand Haven','Ottawa',43.041359,-86.190106),('49418','MI','Grandville','Kent',42.889711,-85.766151),('49419','MI','Hamilton','Allegan',42.675784,-85.995515),('49420','MI','Hart','Oceana',43.716786,-86.301159),('49421','MI','Hesperia','Oceana',43.595934,-86.08661),('49422','MI','Holland','Ottawa',42.7902,-86.099),('49423','MI','Holland','Ottawa',42.765959,-86.10196),('49424','MI','Holland','Ottawa',42.826037,-86.131545),('49425','MI','Holton','Muskegon',43.450514,-86.110729),('49426','MI','Hudsonville','Ottawa',42.870022,-85.873585),('49427','MI','Jamestown','Ottawa',42.8255,-85.8425),('49428','MI','Jenison','Ottawa',42.90973,-85.825322),('49429','MI','Jenison','Ottawa',42.8994,-85.8013),('49430','MI','Lamont','Ottawa',43.0086,-85.9061),('49431','MI','Ludington','Mason',43.962047,-86.426678),('49434','MI','Macatawa','Ottawa',42.768619,-86.205978),('49435','MI','Marne','Ottawa',43.024459,-85.83498),('49436','MI','Mears','Oceana',43.678308,-86.466113),('49437','MI','Montague','Muskegon',43.451315,-86.361217),('49440','MI','Muskegon','Muskegon',43.23545,-86.252161),('49441','MI','Muskegon','Muskegon',43.198208,-86.273856),('49442','MI','Muskegon','Muskegon',43.23508,-86.191098),('49443','MI','Muskegon','Muskegon',43.2354,-86.2495),('49444','MI','Muskegon','Muskegon',43.192763,-86.223473),('49445','MI','Muskegon','Muskegon',43.28304,-86.270374),('49446','MI','New Era','Oceana',43.556956,-86.39104),('49448','MI','Nunica','Ottawa',43.085244,-86.074816),('49449','MI','Pentwater','Oceana',43.787161,-86.396047),('49450','MI','Pullman','Allegan',42.484734,-86.079298),('49451','MI','Ravenna','Muskegon',43.19853,-85.962775),('49452','MI','Rothbury','Oceana',43.516373,-86.263835),('49453','MI','Saugatuck','Allegan',42.661043,-86.185009),('49454','MI','Scottville','Mason',43.952829,-86.286613),('49455','MI','Shelby','Oceana',43.607948,-86.362684),('49456','MI','Spring Lake','Ottawa',43.086889,-86.19311),('49457','MI','Twin Lake','Muskegon',43.365496,-86.175523),('49458','MI','Walhalla','Mason',43.933579,-86.098559),('49459','MI','Walkerville','Oceana',43.726296,-86.110017),('49460','MI','West Olive','Ottawa',42.933162,-86.145345),('49461','MI','Whitehall','Muskegon',43.392702,-86.333272),('49463','MI','Sylvan Beach','Muskegon',43.3714,-86.4224),('49464','MI','Zeeland','Ottawa',42.833232,-86.007009),('49468','MI','Grandville','Kent',42.9104,-85.7633),('49501','MI','Grand Rapids','Kent',42.9704,-85.6738),('49502','MI','Grand Rapids','Kent',42.9704,-85.6738),('49503','MI','Grand Rapids','Kent',42.96219,-85.662962),('49504','MI','Grand Rapids','Kent',42.978111,-85.698944),('49505','MI','Grand Rapids','Kent',42.999837,-85.646759),('49506','MI','Grand Rapids','Kent',42.945801,-85.619408),('49507','MI','Grand Rapids','Kent',42.931845,-85.653996),('49508','MI','Grand Rapids','Kent',42.878022,-85.628828),('49509','MI','Wyoming,','Kent',42.908342,-85.69281),('49510','MI','Grand Rapids','Kent',43.021,-85.6106),('49512','MI','Grand Rapids','Kent',42.887835,-85.557812),('49514','MI','Grand Rapids','Kent',42.9872,-85.7092),('49515','MI','Grand Rapids','Kent',43.0136,-85.6254),('49516','MI','Grand Rapids','Kent',42.9567,-85.6331),('49518','MI','Grand Rapids','Kent',42.8839,-85.6252),('49519','MI','Wyoming','Kent',42.902822,-85.720315),('49523','MI','Grand Rapids','Kent',42.9633,-85.668),('49525','MI','Grand Rapids','Kent',43.023338,-85.604317),('49528','MI','Grand Rapids','Kent',42.9039,-85.6684),('49530','MI','Grand Rapids','Kent',42.9704,-85.6738),('49534','MI','Grand Rapids','Kent',42.976795,-85.780772),('49544','MI','Grand Rapids','Kent',43.025724,-85.718163),('49546','MI','Grand Rapids','Kent',42.930563,-85.551967),('49548','MI','Grand Rapids','Kent',42.867826,-85.662972),('49550','MI','Grand Rapids','Kent',42.9704,-85.6738),('49555','MI','Grand Rapids','Kent',42.9704,-85.6738),('49560','MI','Grand Rapids','Kent',42.8733,-85.6242),('49588','MI','Grand Rapids','Kent',42.9633,-85.668),('49599','MI','Grand Rapids','Kent',42.9704,-85.6738),('49601','MI','Cadillac','Wexford',44.248048,-85.452058),('49610','MI','Acme','Grand Traverse',44.7719,-85.5013),('49611','MI','Alba','Antrim',44.974465,-84.973112),('49612','MI','Alden','Antrim',44.874293,-85.250454),('49613','MI','Arcadia','Manistee',44.502462,-86.221762),('49614','MI','Bear Lake','Manistee',44.435033,-86.114344),('49615','MI','Bellaire','Antrim',44.962803,-85.201733),('49616','MI','Benzonia','Benzie',44.586009,-86.088012),('49617','MI','Beulah','Benzie',44.650405,-86.05376),('49618','MI','Boon','Wexford',44.300436,-85.600873),('49619','MI','Brethren','Manistee',44.303821,-86.005353),('49620','MI','Buckley','Wexford',44.516271,-85.686369),('49621','MI','Cedar','Leelanau',44.870672,-85.787832),('49622','MI','Central Lake','Antrim',45.073923,-85.2691),('49623','MI','Chase','Lake',43.892013,-85.668368),('49625','MI','Copemish','Manistee',44.447007,-85.888798),('49626','MI','Eastlake','Manistee',44.244376,-86.295069),('49627','MI','Eastport','Antrim',45.106508,-85.35688),('49628','MI','Elberta','Benzie',44.619653,-86.227625),('49629','MI','Elk Rapids','Antrim',44.900852,-85.406243),('49630','MI','Empire','Leelanau',44.822566,-86.026024),('49631','MI','Evart','Osceola',43.894403,-85.262962),('49632','MI','Falmouth','Missaukee',44.233413,-84.974695),('49633','MI','Fife Lake','Kalkaska',44.560894,-85.226706),('49634','MI','Filer City','Manistee',44.215873,-86.29017),('49635','MI','Frankfort','Benzie',44.631067,-86.215153),('49636','MI','Glen Arbor','Leelanau',44.886617,-85.981834),('49637','MI','Grawn','Grand Traverse',44.636119,-85.710561),('49638','MI','Harrietta','Wexford',44.287429,-85.755618),('49639','MI','Hersey','Osceola',43.84701,-85.408527),('49640','MI','Honor','Benzie',44.708415,-86.056371),('49642','MI','Idlewild','Lake',43.882848,-85.79024),('49643','MI','Interlochen','Grand Traverse',44.642048,-85.809914),('49644','MI','Irons','Lake',44.111533,-85.917804),('49645','MI','Kaleva','Manistee',44.368322,-86.035973),('49646','MI','Kalkaska','Kalkaska',44.733418,-85.088804),('49648','MI','Kewadin','Antrim',45.005036,-85.365873),('49649','MI','Kingsley','Grand Traverse',44.576467,-85.524656),('49650','MI','Lake Ann','Benzie',44.727413,-85.856468),('49651','MI','Lake City','Missaukee',44.378263,-85.157041),('49653','MI','Lake Leelanau','Leelanau',44.974001,-85.725018),('49654','MI','Leland','Leelanau',45.007538,-85.772369),('49655','MI','Leroy','Osceola',44.034164,-85.448217),('49656','MI','Luther','Lake',44.05272,-85.697599),('49657','MI','Mc Bain','Missaukee',44.212501,-85.169164),('49659','MI','Mancelona','Antrim',44.899484,-85.031661),('49660','MI','Manistee','Manistee',44.233101,-86.262541),('49663','MI','Manton','Wexford',44.434314,-85.377904),('49664','MI','Maple City','Leelanau',44.868729,-85.900586),('49665','MI','Marion','Osceola',44.095238,-85.092546),('49666','MI','Mayfield','Grand Traverse',44.631527,-85.551131),('49667','MI','Merritt','Missaukee',44.363329,-84.914644),('49668','MI','Mesick','Wexford',44.402603,-85.721452),('49670','MI','Northport','Leelanau',45.119275,-85.612555),('49673','MI','Old Mission','Grand Traverse',44.8954,-85.5246),('49674','MI','Omena','Leelanau',45.052502,-85.591843),('49675','MI','Onekama','Manistee',44.369902,-86.21496),('49676','MI','Rapid City','Kalkaska',44.831621,-85.28542),('49677','MI','Reed City','Osceola',43.90259,-85.524942),('49679','MI','Sears','Osceola',43.868061,-85.153159),('49680','MI','South Boardman','Kalkaska',44.646004,-85.262702),('49682','MI','Suttons Bay','Leelanau',44.991969,-85.638701),('49683','MI','Thompsonville','Benzie',44.532424,-85.939977),('49684','MI','Traverse City','Grand Traverse',44.749662,-85.68223),('49685','MI','Traverse City','Grand Traverse',44.7628,-85.6236),('49686','MI','Traverse City','Grand Traverse',44.726345,-85.536342),('49688','MI','Tustin','Osceola',44.117773,-85.436049),('49689','MI','Wellston','Manistee',44.216111,-85.923866),('49690','MI','Williamsburg','Grand Traverse',44.781124,-85.412223),('49696','MI','Traverse City','Grand Traverse',44.739,-85.5143),('49701','MI','Mackinaw City','Emmet',45.774913,-84.732953),('49705','MI','Afton','Cheboygan',45.348552,-84.463353),('49706','MI','Alanson','Emmet',45.431108,-84.776565),('49707','MI','Alpena','Alpena',45.077441,-83.470738),('49709','MI','Atlanta','Montmorency',45.039006,-84.153661),('49710','MI','Barbeau','Chippewa',46.248848,-84.184597),('49711','MI','Bay Shore','Charlevoix',45.3487,-85.154),('49712','MI','Boyne City','Charlevoix',45.216647,-85.012256),('49713','MI','Boyne Falls','Charlevoix',45.203476,-84.859495),('49715','MI','Brimley','Chippewa',46.405964,-84.678702),('49716','MI','Brutus','Emmet',45.508556,-84.740708),('49717','MI','Burt Lake','Cheboygan',45.428875,-84.688808),('49718','MI','Carp Lake','Emmet',45.721218,-84.811765),('49719','MI','Cedarville','Mackinac',45.995077,-84.309099),('49720','MI','Charlevoix','Charlevoix',45.290151,-85.244623),('49721','MI','Cheboygan','Cheboygan',45.594092,-84.466467),('49722','MI','Conway','Emmet',45.418816,-84.865454),('49723','MI','Cross Village','Emmet',45.5843,-85.0393),('49724','MI','Dafter','Chippewa',46.33887,-84.422137),('49725','MI','De Tour Village','Chippewa',45.984736,-83.977329),('49726','MI','Drummond Island','Chippewa',46.010926,-83.737858),('49727','MI','East Jordan','Charlevoix',45.145079,-85.116525),('49728','MI','Eckerman','Chippewa',46.394427,-85.004668),('49729','MI','Ellsworth','Antrim',45.149246,-85.274523),('49730','MI','Elmira','Antrim',45.012868,-84.871559),('49733','MI','Frederic','Crawford',44.810436,-84.70691),('49734','MI','Gaylord','Otsego',45.0003,-84.6603),('49735','MI','Gaylord','Otsego',44.988061,-84.677701),('49736','MI','Goetzville','Chippewa',46.065012,-84.123551),('49737','MI','Good Hart','Emmet',45.5672,-85.113),('49738','MI','Grayling','Crawford',44.686971,-84.648568),('49739','MI','Grayling','Crawford',44.6621,-84.7136),('49740','MI','Harbor Springs','Emmet',45.486911,-84.998567),('49743','MI','Hawks','Presque Isle',45.27634,-83.904646),('49744','MI','Herron','Alpena',45.011148,-83.661676),('49745','MI','Hessel','Mackinac',46.03979,-84.522382),('49746','MI','Hillman','Montmorency',45.062994,-83.951021),('49747','MI','Hubbard Lake','Alpena',44.835571,-83.629725),('49748','MI','Hulbert','Chippewa',46.374707,-85.212496),('49749','MI','Indian River','Cheboygan',45.420303,-84.595435),('49751','MI','Johannesburg','Otsego',44.982838,-84.430167),('49752','MI','Kinross','Chippewa',46.26933,-84.489943),('49753','MI','Lachine','Alpena',45.005064,-83.778369),('49755','MI','Levering','Emmet',45.634812,-84.778231),('49756','MI','Lewiston','Montmorency',44.839419,-84.300372),('49757','MI','Mackinac Island','Mackinac',45.854386,-84.62369),('49759','MI','Millersburg','Presque Isle',45.41325,-84.081293),('49760','MI','Moran','Mackinac',46.04057,-84.90251),('49761','MI','Mullett Lake','Cheboygan',45.563799,-84.524053),('49762','MI','Naubinway','Mackinac',46.128454,-85.317933),('49764','MI','Oden','Emmet',45.423208,-84.826218),('49765','MI','Onaway','Presque Isle',45.326433,-84.246876),('49766','MI','Ossineke','Alpena',44.915176,-83.441034),('49768','MI','Paradise','Chippewa',46.649047,-85.091961),('49769','MI','Pellston','Emmet',45.558621,-84.823432),('49770','MI','Petoskey','Emmet',45.360188,-84.937771),('49774','MI','Pickford','Chippewa',46.162451,-84.315258),('49775','MI','Pointe Aux Pins','Mackinac',45.743775,-84.461423),('49776','MI','Posen','Presque Isle',45.251001,-83.691484),('49777','MI','Presque Isle','Presque Isle',45.311924,-83.49196),('49779','MI','Rogers City','Presque Isle',45.412321,-83.838036),('49780','MI','Rudyard','Chippewa',46.206371,-84.686281),('49781','MI','Saint Ignace','Mackinac',45.905674,-84.747356),('49782','MI','Beaver Island','Charlevoix',45.716561,-85.540287),('49783','MI','Sault Sainte Marie','Chippewa',46.448171,-84.334397),('49784','MI','Kincheloe','Chippewa',46.3663,-84.8461),('49785','MI','Kincheloe','Chippewa',46.3663,-84.8461),('49786','MI','Kincheloe','Chippewa',46.4177,-84.7442),('49788','MI','Kincheloe','Chippewa',46.266433,-84.458808),('49790','MI','Strongs','Chippewa',46.3577,-84.9694),('49791','MI','Topinabee','Cheboygan',45.483329,-84.596616),('49792','MI','Tower','Cheboygan',45.354677,-84.300749),('49793','MI','Trout Lake','Chippewa',46.192177,-85.044852),('49795','MI','Vanderbilt','Otsego',45.150214,-84.603437),('49796','MI','Walloon Lake','Charlevoix',45.263542,-84.928618),('49797','MI','Waters','Otsego',44.8797,-84.6986),('49799','MI','Wolverine','Cheboygan',45.270572,-84.591966),('49801','MI','Iron Mountain','Dickinson',45.87101,-88.0474),('49802','MI','Kingsford','Dickinson',45.799469,-88.082174),('49805','MI','Allouez','Keweenaw',47.320324,-88.401376),('49806','MI','Au Train','Alger',46.435313,-86.875341),('49807','MI','Bark River','Delta',45.764543,-87.353372),('49808','MI','Big Bay','Marquette',46.79106,-87.858525),('49812','MI','Carney','Menominee',45.600765,-87.522597),('49814','MI','Champion','Marquette',46.538797,-87.895893),('49815','MI','Channing','Dickinson',46.194644,-88.029422),('49816','MI','Chatham','Alger',46.290631,-86.89544),('49817','MI','Cooks','Schoolcraft',45.955423,-86.479767),('49818','MI','Cornell','Delta',45.973843,-87.342544),('49819','MI','Arnold','Marquette',46.075235,-87.488799),('49820','MI','Curtis','Mackinac',46.201813,-85.731627),('49821','MI','Daggett','Menominee',45.520277,-87.619709),('49822','MI','Deerton','Alger',46.459773,-87.045738),('49825','MI','Eben Junction','Alger',46.357811,-86.972916),('49826','MI','Rumely','Alger',46.356462,-87.022357),('49827','MI','Engadine','Mackinac',46.176762,-85.560826),('49829','MI','Escanaba','Delta',45.75114,-87.089359),('49831','MI','Felch','Dickinson',46.051588,-87.771531),('49833','MI','Little Lake','Marquette',46.29334,-87.338235),('49834','MI','Foster City','Dickinson',45.936759,-87.749938),('49835','MI','Garden','Delta',45.752743,-86.581721),('49836','MI','Germfask','Schoolcraft',46.201767,-85.903573),('49837','MI','Gladstone','Delta',45.848962,-87.055049),('49838','MI','Gould City','Mackinac',46.086806,-85.765723),('49839','MI','Grand Marais','Alger',46.638576,-86.030814),('49840','MI','Gulliver','Schoolcraft',46.066713,-86.014761),('49841','MI','Gwinn','Marquette',46.301009,-87.4575),('49845','MI','Harris','Menominee',45.919,-87.4236),('49847','MI','Hermansville','Menominee',45.709321,-87.611911),('49848','MI','Ingalls','Menominee',45.370704,-87.627381),('49849','MI','Ishpeming','Marquette',46.447905,-87.729656),('49852','MI','Loretto','Dickinson',45.78237,-87.817669),('49853','MI','Mc Millan','Luce',46.335701,-85.732652),('49854','MI','Manistique','Schoolcraft',46.076184,-86.345773),('49855','MI','Marquette','Marquette',46.55453,-87.432285),('49858','MI','Menominee','Menominee',45.14739,-87.613694),('49861','MI','Michigamme','Marquette',46.552534,-88.124587),('49862','MI','Munising','Alger',46.370087,-86.709896),('49863','MI','Nadeau','Menominee',45.610566,-87.553219),('49864','MI','Nahma','Delta',45.845778,-86.669005),('49865','MI','National Mine','Marquette',46.4586,-87.6813),('49866','MI','Negaunee','Marquette',46.499384,-87.580005),('49868','MI','Newberry','Luce',46.51035,-85.518321),('49870','MI','Norway','Dickinson',45.806591,-87.90861),('49871','MI','Palmer','Marquette',46.438928,-87.576945),('49872','MI','Perkins','Delta',46.00645,-87.08116),('49873','MI','Perronville','Menominee',45.897254,-87.519558),('49874','MI','Powers','Menominee',45.693414,-87.511541),('49876','MI','Quinnesec','Dickinson',45.803416,-87.988661),('49877','MI','Ralph','Dickinson',46.118188,-87.709365),('49878','MI','Rapid River','Delta',45.945698,-86.860412),('49879','MI','Republic','Marquette',46.357416,-88.021211),('49880','MI','Rock','Delta',46.111029,-87.22236),('49881','MI','Sagola','Dickinson',46.07322,-88.047262),('49883','MI','Seney','Schoolcraft',46.431726,-86.000888),('49884','MI','Shingleton','Alger',46.41592,-86.356975),('49885','MI','Skandia','Marquette',46.340765,-87.231674),('49886','MI','Spalding','Menominee',45.704932,-87.515733),('49887','MI','Stephenson','Menominee',45.424959,-87.608704),('49891','MI','Trenary','Alger',46.230332,-86.989864),('49892','MI','Vulcan','Dickinson',45.768442,-87.79186),('49893','MI','Wallace','Menominee',45.304859,-87.623021),('49894','MI','Wells','Delta',45.781108,-87.076013),('49895','MI','Wetmore','Alger',46.191673,-86.654347),('49896','MI','Wilson','Menominee',45.686768,-87.378061),('49901','MI','Ahmeek','Keweenaw',47.299508,-88.398352),('49902','MI','Alpha','Iron',46.044918,-88.37847),('49903','MI','Amasa','Iron',46.315018,-88.435603),('49905','MI','Atlantic Mine','Houghton',47.118428,-88.689031),('49908','MI','Baraga','Baraga',46.768392,-88.545852),('49910','MI','Bergland','Ontonagon',46.597091,-89.576347),('49911','MI','Bessemer','Gogebic',46.481538,-90.053257),('49912','MI','Bruce Crossing','Ontonagon',46.47535,-89.186625),('49913','MI','Calumet','Houghton',47.243819,-88.456818),('49915','MI','Caspian','Iron',46.064089,-88.625901),('49916','MI','Chassell','Houghton',46.999023,-88.570213),('49917','MI','Copper City','Houghton',47.284337,-88.384368),('49918','MI','Copper Harbor','Keweenaw',47.446495,-87.871618),('49919','MI','Covington','Baraga',46.531051,-88.467317),('49920','MI','Crystal Falls','Iron',46.114457,-88.338567),('49921','MI','Dodgeville','Houghton',47.092564,-88.582649),('49922','MI','Dollar Bay','Houghton',47.11646,-88.498631),('49925','MI','Ewen','Ontonagon',46.540001,-89.347984),('49927','MI','Gaastra','Iron',46.053134,-88.593635),('49929','MI','Greenland','Ontonagon',46.780935,-89.095957),('49930','MI','Hancock','Houghton',47.145101,-88.571755),('49931','MI','Houghton','Houghton',47.117959,-88.574566),('49934','MI','Hubbell','Houghton',47.170502,-88.434025),('49935','MI','Iron River','Iron',46.186172,-88.718791),('49938','MI','Ironwood','Gogebic',46.488899,-90.145354),('49942','MI','Kearsarge','Houghton',47.269765,-88.416015),('49945','MI','Lake Linden','Houghton',47.184367,-88.352073),('49946','MI','Lanse','Baraga',46.720928,-88.372368),('49947','MI','Marenisco','Gogebic',46.358472,-89.628928),('49948','MI','Mass City','Ontonagon',46.746689,-89.017838),('49950','MI','Mohawk','Keweenaw',47.391091,-88.176052),('49952','MI','Nisula','Houghton',46.70225,-88.785769),('49953','MI','Ontonagon','Ontonagon',46.823661,-89.352963),('49955','MI','Painesdale','Houghton',47.027288,-88.69822),('49958','MI','Pelkie','Houghton',46.829741,-88.649833),('49959','MI','Ramsay','Gogebic',46.471388,-89.998513),('49960','MI','Rockland','Ontonagon',46.724366,-89.195619),('49961','MI','Sidnaw','Houghton',46.512772,-88.719037),('49962','MI','Skanee','Baraga',46.822057,-88.147724),('49963','MI','South Range','Houghton',47.066926,-88.644495),('49964','MI','Stambaugh','Iron',46.081472,-88.628062),('49965','MI','Toivola','Houghton',46.954515,-88.857655),('49967','MI','Trout Creek','Ontonagon',46.456631,-88.922208),('49968','MI','Wakefield','Gogebic',46.493904,-89.914006),('49969','MI','Watersmeet','Gogebic',46.245827,-89.270407),('49970','MI','Watton','Baraga',46.580693,-88.606183),('49971','MI','White Pine','Ontonagon',46.678226,-89.717289),('50001','IA','Ackworth','Warren',41.36605,-93.426872),('50002','IA','Adair','Adair',41.50764,-94.648255),('50003','IA','Adel','Dallas',41.611647,-94.032134),('50005','IA','Albion','Marshall',42.118078,-93.010521),('50006','IA','Alden','Hardin',42.518089,-93.397316),('50007','IA','Alleman','Polk',41.805055,-93.604403),('50008','IA','Allerton','Wayne',40.68815,-93.378446),('50009','IA','Altoona','Polk',41.648294,-93.473),('50010','IA','Ames','Story',42.032621,-93.609761),('50011','IA','Ames','Story',42.024034,-93.636451),('50012','IA','Ames','Story',42.026647,-93.642886),('50013','IA','Ames','Story',42.0237,-93.6405),('50014','IA','Ames','Story',42.031439,-93.672927),('50020','IA','Anita','Cass',41.445771,-94.762986),('50021','IA','Ankeny','Polk',41.725795,-93.580243),('50022','IA','Atlantic','Cass',41.415327,-95.006064),('50023','IA','Ankeny','Polk',41.719311,-93.627768),('50025','IA','Audubon','Audubon',41.738744,-94.927787),('50026','IA','Bagley','Guthrie',41.851883,-94.442536),('50027','IA','Barnes City','Mahaska',41.481124,-92.475128),('50028','IA','Baxter','Jasper',41.820947,-93.150867),('50029','IA','Bayard','Guthrie',41.844878,-94.5567),('50031','IA','Beaver','Boone',42.0384,-94.1091),('50032','IA','Berwick','Polk',41.666866,-93.541827),('50033','IA','Bevington','Madison',41.360992,-93.792193),('50034','IA','Blairsburg','Hamilton',42.507272,-93.641724),('50035','IA','Bondurant','Polk',41.704532,-93.461786),('50036','IA','Boone','Boone',42.071566,-93.878815),('50037','IA','Boone','Boone',42.1243,-93.8293),('50038','IA','Booneville','Dallas',41.525073,-93.903282),('50039','IA','Bouton','Dallas',41.838424,-94.005747),('50040','IA','Boxholm','Boone',42.174905,-94.105523),('50041','IA','Bradford','Franklin',42.634044,-93.243946),('50042','IA','Brayton','Audubon',41.533786,-94.905317),('50043','IA','Buckeye','Hardin',42.4172,-93.3747),('50044','IA','Bussey','Marion',41.202078,-92.88278),('50046','IA','Cambridge','Story',41.900438,-93.53513),('50047','IA','Carlisle','Warren',41.489761,-93.488697),('50048','IA','Casey','Guthrie',41.510192,-94.51971),('50049','IA','Chariton','Lucas',41.024192,-93.302722),('50050','IA','Churdan','Greene',42.158973,-94.503593),('50051','IA','Clemons','Marshall',42.132776,-93.151856),('50052','IA','Clio','Wayne',40.637363,-93.446406),('50054','IA','Colfax','Jasper',41.683104,-93.241565),('50055','IA','Collins','Story',41.882027,-93.298703),('50056','IA','Colo','Story',42.010438,-93.318696),('50057','IA','Columbia','Marion',41.174287,-93.172814),('50058','IA','Coon Rapids','Carroll',41.865538,-94.693333),('50059','IA','Cooper','Greene',41.919495,-94.345182),('50060','IA','Corydon','Wayne',40.758127,-93.319257),('50061','IA','Cumming','Warren',41.497515,-93.780168),('50062','IA','Dallas','Marion',41.234012,-93.235971),('50063','IA','Dallas Center','Dallas',41.691534,-93.956012),('50064','IA','Dana','Greene',42.108983,-94.235932),('50065','IA','Davis City','Decatur',40.621822,-93.801273),('50066','IA','Dawson','Dallas',41.827322,-94.231857),('50067','IA','Decatur','Decatur',40.730896,-93.852207),('50068','IA','Derby','Lucas',40.948916,-93.466408),('50069','IA','De Soto','Dallas',41.529055,-94.011822),('50070','IA','Dexter','Dallas',41.486524,-94.238549),('50071','IA','Dows','Wright',42.652923,-93.500323),('50072','IA','Earlham','Madison',41.476366,-94.11809),('50073','IA','Elkhart','Polk',41.793555,-93.520124),('50074','IA','Ellston','Ringgold',40.850849,-94.075432),('50075','IA','Ellsworth','Hamilton',42.332084,-93.569814),('50076','IA','Exira','Audubon',41.592627,-94.868768),('50078','IA','Ferguson','Marshall',41.937509,-92.864913),('50099','IA','Boone','Boone',42.057896,-93.880835),('50101','IA','Galt','Wright',42.681979,-93.614578),('50102','IA','Garden City','Hardin',42.244983,-93.397688),('50103','IA','Garden Grove','Decatur',40.801314,-93.609103),('50104','IA','Gibson','Keokuk',41.481624,-92.391678),('50105','IA','Gilbert','Story',42.107628,-93.641212),('50106','IA','Gilman','Marshall',41.881076,-92.805779),('50107','IA','Grand Junction','Greene',42.036016,-94.227234),('50108','IA','Grand River','Decatur',40.833764,-93.956821),('50109','IA','Granger','Dallas',41.754645,-93.797746),('50110','IA','Gray','Audubon',41.84115,-94.981201),('50111','IA','Grimes','Polk',41.678396,-93.788219),('50112','IA','Grinnell','Poweshiek',41.727512,-92.721775),('50115','IA','Guthrie Center','Guthrie',41.689703,-94.526221),('50116','IA','Hamilton','Marion',41.179761,-92.950307),('50117','IA','Hamlin','Audubon',41.669872,-94.849235),('50118','IA','Hartford','Warren',41.454943,-93.37578),('50119','IA','Harvey','Marion',41.313093,-92.939687),('50120','IA','Haverhill','Marshall',41.925883,-92.971343),('50122','IA','Hubbard','Hardin',42.305362,-93.311807),('50123','IA','Humeston','Wayne',40.848312,-93.509076),('50124','IA','Huxley','Story',41.893288,-93.597027),('50125','IA','Indianola','Warren',41.352874,-93.575105),('50126','IA','Iowa Falls','Hardin',42.516377,-93.26005),('50127','IA','Ira','Jasper',41.7529,-93.181),('50128','IA','Jamaica','Guthrie',41.855589,-94.300236),('50129','IA','Jefferson','Greene',42.015765,-94.376747),('50130','IA','Jewell','Hamilton',42.303169,-93.652516),('50131','IA','Johnston','Polk',41.681217,-93.714711),('50132','IA','Kamrar','Hamilton',42.390768,-93.709198),('50133','IA','Kellerton','Ringgold',40.702844,-94.063667),('50134','IA','Kelley','Story',41.940959,-93.658727),('50135','IA','Kellogg','Jasper',41.724347,-92.883437),('50136','IA','Keswick','Keokuk',41.476125,-92.26824),('50137','IA','Killduff','Jasper',41.607887,-92.905739),('50138','IA','Knoxville','Marion',41.315704,-93.098189),('50139','IA','Lacona','Warren',41.198463,-93.369878),('50140','IA','Lamoni','Decatur',40.630251,-93.965428),('50141','IA','Laurel','Marshall',41.871139,-92.948129),('50142','IA','Le Grand','Marshall',42.005337,-92.776306),('50143','IA','Leighton','Mahaska',41.327157,-92.803006),('50144','IA','Leon','Decatur',40.739901,-93.747485),('50145','IA','Liberty Center','Warren',41.203946,-93.500699),('50146','IA','Linden','Dallas',41.66834,-94.247425),('50147','IA','Lineville','Wayne',40.606587,-93.52848),('50148','IA','Liscomb','Marshall',42.185795,-92.998975),('50149','IA','Lorimor','Union',41.148781,-94.081273),('50150','IA','Lovilia','Monroe',41.130429,-92.928789),('50151','IA','Lucas','Lucas',41.062698,-93.497844),('50152','IA','Luther','Boone',41.967091,-93.821069),('50153','IA','Lynnville','Jasper',41.575843,-92.792594),('50154','IA','Mc Callsburg','Story',42.165918,-93.393734),('50155','IA','Macksburg','Madison',41.207769,-94.204201),('50156','IA','Madrid','Boone',41.881803,-93.812597),('50157','IA','Malcom','Poweshiek',41.734779,-92.555991),('50158','IA','Marshalltown','Marshall',42.038794,-92.906322),('50160','IA','Martensdale','Warren',41.373267,-93.739859),('50161','IA','Maxwell','Story',41.866431,-93.402141),('50162','IA','Melbourne','Marshall',41.925161,-93.082146),('50163','IA','Melcher','Marion',41.223045,-93.241135),('50164','IA','Menlo','Guthrie',41.50559,-94.425967),('50165','IA','Millerton','Wayne',40.849249,-93.300975),('50166','IA','Milo','Warren',41.282712,-93.430749),('50167','IA','Minburn','Dallas',41.746907,-94.048139),('50168','IA','Mingo','Jasper',41.780312,-93.269291),('50169','IA','Mitchellville','Polk',41.662265,-93.35284),('50170','IA','Monroe','Jasper',41.527795,-93.108499),('50171','IA','Montezuma','Poweshiek',41.588762,-92.539019),('50173','IA','Montour','Tama',41.979125,-92.71409),('50174','IA','Murray','Clarke',41.039943,-93.956713),('50201','IA','Nevada','Story',42.02458,-93.448872),('50206','IA','New Providence','Hardin',42.244805,-93.182782),('50207','IA','New Sharon','Mahaska',41.444133,-92.648176),('50208','IA','Newton','Jasper',41.702124,-93.044648),('50210','IA','New Virginia','Warren',41.193491,-93.714359),('50211','IA','Norwalk','Warren',41.472627,-93.677705),('50212','IA','Ogden','Boone',42.047597,-94.047231),('50213','IA','Osceola','Clarke',41.033894,-93.772917),('50214','IA','Otley','Marion',41.454057,-93.068644),('50216','IA','Panora','Guthrie',41.696678,-94.372297),('50217','IA','Paton','Greene',42.170196,-94.245517),('50218','IA','Patterson','Madison',41.348986,-93.87964),('50219','IA','Pella','Marion',41.410013,-92.910423),('50220','IA','Perry','Dallas',41.846618,-94.108677),('50222','IA','Peru','Madison',41.224017,-93.94296),('50223','IA','Pilot Mound','Boone',42.159241,-94.037685),('50225','IA','Pleasantville','Marion',41.377982,-93.277647),('50226','IA','Polk City','Polk',41.783749,-93.714169),('50227','IA','Popejoy','Franklin',42.595697,-93.427527),('50228','IA','Prairie City','Jasper',41.588323,-93.236636),('50229','IA','Prole','Warren',41.377604,-93.78579),('50230','IA','Radcliffe','Hardin',42.303252,-93.453415),('50231','IA','Randall','Hamilton',42.237575,-93.602605),('50232','IA','Reasnor','Jasper',41.560124,-92.980053),('50233','IA','Redfield','Dallas',41.606464,-94.209377),('50234','IA','Rhodes','Marshall',41.893094,-93.181953),('50235','IA','Rippey','Greene',41.931836,-94.205606),('50236','IA','Roland','Story',42.166033,-93.490633),('50237','IA','Runnells','Polk',41.539793,-93.372021),('50238','IA','Russell','Lucas',40.963784,-93.182607),('50239','IA','Saint Anthony','Marshall',42.142843,-93.202958),('50240','IA','Saint Charles','Madison',41.302447,-93.796066),('50241','IA','Saint Marys','Warren',41.308451,-93.73157),('50242','IA','Searsboro','Poweshiek',41.565377,-92.691605),('50243','IA','Sheldahl','Story',41.863867,-93.696361),('50244','IA','Slater','Story',41.871372,-93.673468),('50246','IA','Stanhope','Hamilton',42.281871,-93.790061),('50247','IA','State Center','Marshall',42.016382,-93.162713),('50248','IA','Story City','Story',42.185295,-93.596717),('50249','IA','Stratford','Hamilton',42.273161,-93.917616),('50250','IA','Stuart','Guthrie',41.497469,-94.326154),('50251','IA','Sully','Jasper',41.57558,-92.855379),('50252','IA','Swan','Marion',41.4606,-93.312635),('50254','IA','Thayer','Union',40.991243,-94.059406),('50255','IA','Thornburg','Keokuk',41.455039,-92.333978),('50256','IA','Tracy','Marion',41.276014,-92.903331),('50257','IA','Truro','Madison',41.19207,-93.84695),('50258','IA','Union','Hardin',42.239848,-93.067387),('50259','IA','Gifford','Hardin',42.2883,-93.0902),('50261','IA','Van Meter','Dallas',41.48418,-93.935178),('50262','IA','Van Wert','Decatur',40.857399,-93.803435),('50263','IA','Waukee','Dallas',41.594397,-93.863015),('50264','IA','Weldon','Decatur',40.898982,-93.707358),('50265','IA','West Des Moines','Polk',41.568295,-93.7398),('50266','IA','West Des Moines','Polk',41.575768,-93.789793),('50268','IA','What Cheer','Keokuk',41.402069,-92.354057),('50269','IA','Whitten','Hardin',42.261478,-93.007387),('50271','IA','Williams','Hamilton',42.486353,-93.544043),('50272','IA','Williamson','Lucas',41.088714,-93.257056),('50273','IA','Winterset','Madison',41.33494,-94.031333),('50274','IA','Wiota','Cass',41.394671,-94.862754),('50275','IA','Woodburn','Clarke',41.016938,-93.591699),('50276','IA','Woodward','Dallas',41.859074,-93.922297),('50277','IA','Yale','Guthrie',41.774421,-94.351808),('50278','IA','Zearing','Story',42.15648,-93.296499),('50301','IA','Des Moines','Polk',41.6005,-93.6088),('50302','IA','Des Moines','Polk',41.6005,-93.6088),('50303','IA','Des Moines','Polk',41.6005,-93.6088),('50304','IA','Des Moines','Polk',41.6005,-93.6088),('50305','IA','Des Moines','Polk',41.6005,-93.6088),('50306','IA','Des Moines','Polk',41.6005,-93.6088),('50307','IA','Des Moines','Polk',41.6005,-93.6088),('50308','IA','Des Moines','Polk',41.6005,-93.6088),('50309','IA','Des Moines','Polk',41.586431,-93.620186),('50310','IA','Des Moines','Polk',41.624707,-93.676707),('50311','IA','Des Moines','Polk',41.602171,-93.670679),('50312','IA','Des Moines','Polk',41.587207,-93.671981),('50313','IA','Des Moines','Polk',41.639514,-93.616288),('50314','IA','Des Moines','Polk',41.60338,-93.631189),('50315','IA','Des Moines','Polk',41.54677,-93.620119),('50316','IA','Des Moines','Polk',41.606405,-93.598303),('50317','IA','Des Moines','Polk',41.609546,-93.555293),('50318','IA','Des Moines','Polk',41.6005,-93.6088),('50319','IA','Des Moines','Polk',41.594,-93.6146),('50320','IA','Des Moines','Polk',41.537092,-93.58063),('50321','IA','Des Moines','Polk',41.542804,-93.66193),('50322','IA','Urbandale','Polk',41.631131,-93.726255),('50323','IA','Urbandale','Dallas',41.631102,-93.80813),('50324','IA','Windsor Heights','Polk',41.604894,-93.712116),('50325','IA','Clive','Polk',41.611547,-93.788134),('50327','IA','Des Moines','Polk',41.588288,-93.497292),('50328','IA','Des Moines','Polk',41.6005,-93.6088),('50329','IA','Des Moines','Polk',41.6005,-93.6088),('50330','IA','Des Moines','Polk',41.6005,-93.6088),('50331','IA','Des Moines','Polk',41.6005,-93.6088),('50332','IA','Des Moines','Polk',41.6005,-93.6088),('50333','IA','Des Moines','Polk',41.6564,-93.623),('50334','IA','Des Moines','Polk',41.6005,-93.6088),('50335','IA','Des Moines','Polk',41.6005,-93.6088),('50336','IA','Des Moines','Polk',41.6005,-93.6088),('50339','IA','Des Moines','Polk',41.6005,-93.6088),('50340','IA','Des Moines','Polk',41.6005,-93.6088),('50347','IA','Des Moines','Polk',41.6005,-93.6088),('50359','IA','Des Moines','Polk',41.6005,-93.6088),('50360','IA','Des Moines','Polk',41.6005,-93.6088),('50361','IA','Des Moines','Polk',41.6005,-93.6088),('50362','IA','Des Moines','Polk',41.6005,-93.6088),('50363','IA','Des Moines','Polk',41.6005,-93.6088),('50364','IA','Des Moines','Polk',41.6005,-93.6088),('50367','IA','Des Moines','Polk',41.6005,-93.6088),('50368','IA','Des Moines','Polk',41.6005,-93.6088),('50369','IA','Des Moines','Polk',41.6005,-93.6088),('50380','IA','Des Moines','Polk',41.6005,-93.6088),('50381','IA','Des Moines','Polk',41.6005,-93.6088),('50391','IA','Des Moines','Polk',41.6005,-93.6088),('50392','IA','Des Moines','Polk',41.5878,-93.6271),('50393','IA','Des Moines','Polk',41.6005,-93.6088),('50394','IA','Des Moines','Polk',41.6005,-93.6088),('50395','IA','Des Moines','Polk',41.6005,-93.6088),('50396','IA','Des Moines','Polk',41.6005,-93.6088),('50397','IA','Des Moines','Polk',41.6005,-93.6088),('50398','IA','West Des Moines','Polk',41.5772,-93.7111),('50401','IA','Mason City','Cerro Gordo',43.151346,-93.20347),('50402','IA','Mason City','Cerro Gordo',43.1536,-93.2008),('50420','IA','Alexander','Franklin',42.811851,-93.46805),('50421','IA','Belmond','Wright',42.846316,-93.619212),('50423','IA','Britt','Hancock',43.098274,-93.804954),('50424','IA','Buffalo Center','Winnebago',43.393034,-93.937073),('50426','IA','Carpenter','Mitchell',43.415483,-93.016778),('50427','IA','Chapin','Franklin',42.8336,-93.2219),('50428','IA','Clear Lake','Cerro Gordo',43.137197,-93.380887),('50430','IA','Corwith','Hancock',42.985207,-93.961444),('50431','IA','Coulter','Franklin',42.735326,-93.369244),('50432','IA','Crystal Lake','Hancock',43.222724,-93.79201),('50433','IA','Dougherty','Cerro Gordo',42.92004,-93.044665),('50434','IA','Fertile','Worth',43.26402,-93.430626),('50435','IA','Floyd','Floyd',43.146997,-92.757292),('50436','IA','Forest City','Winnebago',43.262365,-93.655278),('50438','IA','Garner','Hancock',43.100987,-93.612598),('50439','IA','Goodell','Hancock',42.930648,-93.62678),('50440','IA','Grafton','Worth',43.328665,-93.072996),('50441','IA','Hampton','Franklin',42.743121,-93.212843),('50444','IA','Hanlontown','Worth',43.283375,-93.380572),('50446','IA','Joice','Worth',43.349573,-93.450771),('50447','IA','Kanawha','Hancock',42.92686,-93.808144),('50448','IA','Kensett','Worth',43.349886,-93.240596),('50449','IA','Klemme','Hancock',43.001662,-93.584238),('50450','IA','Lake Mills','Winnebago',43.418915,-93.519671),('50451','IA','Lakota','Kossuth',43.373535,-94.093705),('50452','IA','Latimer','Franklin',42.781099,-93.367352),('50453','IA','Leland','Winnebago',43.363364,-93.64742),('50454','IA','Little Cedar','Mitchell',43.383034,-92.729341),('50455','IA','Mc Intire','Mitchell',43.451213,-92.624394),('50456','IA','Manly','Worth',43.28863,-93.21083),('50457','IA','Meservey','Cerro Gordo',42.915799,-93.493433),('50458','IA','Nora Springs','Floyd',43.147707,-93.00499),('50459','IA','Northwood','Worth',43.444474,-93.240113),('50460','IA','Orchard','Mitchell',43.219933,-92.722402),('50461','IA','Osage','Mitchell',43.292178,-92.820517),('50464','IA','Plymouth','Cerro Gordo',43.248783,-93.102566),('50465','IA','Rake','Winnebago',43.485449,-93.917988),('50466','IA','Riceville','Mitchell',43.371242,-92.535683),('50467','IA','Rock Falls','Cerro Gordo',43.208804,-93.084029),('50468','IA','Rockford','Floyd',43.050559,-92.950847),('50469','IA','Rockwell','Cerro Gordo',42.994855,-93.201985),('50470','IA','Rowan','Wright',42.740372,-93.560299),('50471','IA','Rudd','Floyd',43.148095,-92.887515),('50472','IA','Saint Ansgar','Mitchell',43.413155,-92.949286),('50473','IA','Scarville','Winnebago',43.465984,-93.666682),('50475','IA','Sheffield','Franklin',42.881443,-93.21611),('50476','IA','Stacyville','Mitchell',43.442761,-92.77759),('50477','IA','Swaledale','Cerro Gordo',42.987757,-93.329701),('50478','IA','Thompson','Winnebago',43.393018,-93.78368),('50479','IA','Thornton','Cerro Gordo',42.929672,-93.389392),('50480','IA','Titonka','Kossuth',43.243446,-94.043247),('50481','IA','Toeterville','Mitchell',43.4422,-92.8902),('50482','IA','Ventura','Cerro Gordo',43.11779,-93.475309),('50483','IA','Wesley','Kossuth',43.104329,-94.000026),('50484','IA','Woden','Hancock',43.232312,-93.910713),('50501','IA','Fort Dodge','Webster',42.500512,-94.181803),('50510','IA','Albert City','Buena Vista',42.756163,-94.963052),('50511','IA','Algona','Kossuth',43.074001,-94.226095),('50514','IA','Armstrong','Emmet',43.415156,-94.47241),('50515','IA','Ayrshire','Palo Alto',43.03275,-94.847738),('50516','IA','Badger','Webster',42.618598,-94.141948),('50517','IA','Bancroft','Kossuth',43.291506,-94.21875),('50518','IA','Barnum','Webster',42.513178,-94.375032),('50519','IA','Bode','Humboldt',42.88551,-94.275835),('50520','IA','Bradgate','Humboldt',42.804816,-94.413391),('50521','IA','Burnside','Webster',42.347015,-94.107328),('50522','IA','Burt','Kossuth',43.191263,-94.194638),('50523','IA','Callender','Webster',42.365132,-94.295411),('50524','IA','Clare','Webster',42.597402,-94.349481),('50525','IA','Clarion','Wright',42.738462,-93.738393),('50526','IA','Clarion','Wright',42.7316,-93.7327),('50527','IA','Curlew','Palo Alto',42.959692,-94.787033),('50528','IA','Cylinder','Palo Alto',43.124695,-94.548443),('50529','IA','Dakota City','Humboldt',42.721982,-94.200786),('50530','IA','Dayton','Webster',42.263405,-94.052491),('50531','IA','Dolliver','Emmet',43.46483,-94.616279),('50532','IA','Duncombe','Webster',42.460118,-94.000869),('50533','IA','Eagle Grove','Wright',42.661464,-93.911006),('50535','IA','Early','Sac',42.453186,-95.162489),('50536','IA','Emmetsburg','Palo Alto',43.114208,-94.692004),('50538','IA','Farnhamville','Calhoun',42.277678,-94.417479),('50539','IA','Fenton','Kossuth',43.224786,-94.426157),('50540','IA','Fonda','Pocahontas',42.588268,-94.841879),('50541','IA','Gilmore City','Humboldt',42.71038,-94.452922),('50542','IA','Goldfield','Wright',42.753839,-93.941583),('50543','IA','Gowrie','Webster',42.276424,-94.303319),('50544','IA','Harcourt','Webster',42.25688,-94.17453),('50545','IA','Hardy','Humboldt',42.80744,-94.070187),('50546','IA','Havelock','Pocahontas',42.83664,-94.705938),('50548','IA','Humboldt','Humboldt',42.719963,-94.225058),('50551','IA','Jolley','Calhoun',42.483145,-94.749941),('50552','IA','Knierim','Calhoun',42.455148,-94.45652),('50554','IA','Laurens','Pocahontas',42.843976,-94.842655),('50556','IA','Ledyard','Kossuth',43.448036,-94.197289),('50557','IA','Lehigh','Webster',42.35896,-94.055773),('50558','IA','Livermore','Humboldt',42.867357,-94.175581),('50559','IA','Lone Rock','Kossuth',43.204774,-94.315423),('50560','IA','Lu Verne','Kossuth',42.949415,-94.111419),('50561','IA','Lytton','Sac',42.425099,-94.850504),('50562','IA','Mallard','Palo Alto',42.95713,-94.659284),('50563','IA','Manson','Calhoun',42.52491,-94.532518),('50565','IA','Marathon','Buena Vista',42.857925,-94.988064),('50566','IA','Moorland','Webster',42.43777,-94.323652),('50567','IA','Nemaha','Sac',42.525236,-95.101297),('50568','IA','Newell','Buena Vista',42.611801,-94.998704),('50569','IA','Otho','Webster',42.407996,-94.140131),('50570','IA','Ottosen','Humboldt',42.901218,-94.371361),('50571','IA','Palmer','Pocahontas',42.639033,-94.589006),('50573','IA','Plover','Pocahontas',42.877965,-94.622985),('50574','IA','Pocahontas','Pocahontas',42.724184,-94.68406),('50575','IA','Pomeroy','Calhoun',42.555749,-94.688414),('50576','IA','Rembrandt','Buena Vista',42.812035,-95.170965),('50577','IA','Renwick','Humboldt',42.845471,-93.981421),('50578','IA','Ringsted','Emmet',43.306004,-94.541273),('50579','IA','Rockwell City','Calhoun',42.397601,-94.636948),('50581','IA','Rolfe','Pocahontas',42.841901,-94.531422),('50582','IA','Rutland','Humboldt',42.77889,-94.29554),('50583','IA','Sac City','Sac',42.430096,-94.992464),('50585','IA','Sioux Rapids','Buena Vista',42.910474,-95.138998),('50586','IA','Somers','Calhoun',42.401923,-94.435318),('50588','IA','Storm Lake','Buena Vista',42.647879,-95.185354),('50590','IA','Swea City','Kossuth',43.39118,-94.305312),('50591','IA','Thor','Humboldt',42.684486,-94.0545),('50592','IA','Truesdale','Buena Vista',42.728665,-95.183036),('50593','IA','Varina','Pocahontas',42.657606,-94.898411),('50594','IA','Vincent','Webster',42.579515,-94.030886),('50595','IA','Webster City','Hamilton',42.463741,-93.820371),('50597','IA','West Bend','Palo Alto',42.97525,-94.451731),('50598','IA','Whittemore','Kossuth',43.066721,-94.422172),('50599','IA','Woolstock','Wright',42.579274,-93.803665),('50601','IA','Ackley','Hardin',42.565772,-93.058851),('50602','IA','Allison','Butler',42.747639,-92.803236),('50603','IA','Alta Vista','Chickasaw',43.187621,-92.45581),('50604','IA','Aplington','Butler',42.609992,-92.898006),('50605','IA','Aredale','Butler',42.833868,-93.013655),('50606','IA','Arlington','Fayette',42.747858,-91.674898),('50607','IA','Aurora','Buchanan',42.616872,-91.745598),('50608','IA','Austinville','Butler',42.6164,-92.9717),('50609','IA','Beaman','Grundy',42.228377,-92.809466),('50611','IA','Bristow','Butler',42.795618,-92.89804),('50612','IA','Buckingham','Tama',42.275083,-92.397171),('50613','IA','Cedar Falls','Black Hawk',42.529142,-92.456362),('50614','IA','Cedar Falls','Black Hawk',42.5131,-92.4607),('50616','IA','Charles City','Floyd',43.070493,-92.670579),('50619','IA','Clarksville','Butler',42.788725,-92.665629),('50620','IA','Colwell','Floyd',43.15761,-92.593266),('50621','IA','Conrad','Grundy',42.247076,-92.899875),('50622','IA','Denver','Bremer',42.67249,-92.339905),('50623','IA','Dewar','Black Hawk',42.526943,-92.21802),('50624','IA','Dike','Grundy',42.467861,-92.653923),('50625','IA','Dumont','Butler',42.754336,-92.975206),('50626','IA','Dunkerton','Black Hawk',42.577682,-92.166035),('50627','IA','Eldora','Hardin',42.355243,-93.097278),('50628','IA','Elma','Howard',43.261825,-92.414609),('50629','IA','Fairbank','Buchanan',42.632003,-92.071281),('50630','IA','Fredericksburg','Chickasaw',42.95768,-92.213959),('50631','IA','Frederika','Bremer',42.882349,-92.304778),('50632','IA','Garwin','Tama',42.079644,-92.708127),('50633','IA','Geneva','Franklin',42.671824,-93.138401),('50634','IA','Gilbertville','Black Hawk',42.417246,-92.214014),('50635','IA','Gladbrook','Tama',42.192374,-92.707827),('50636','IA','Greene','Butler',42.893601,-92.808582),('50638','IA','Grundy Center','Grundy',42.360909,-92.785367),('50641','IA','Hazleton','Buchanan',42.599142,-91.907688),('50642','IA','Holland','Grundy',42.4343,-92.797861),('50643','IA','Hudson','Black Hawk',42.377306,-92.465767),('50644','IA','Independence','Buchanan',42.471912,-91.889858),('50645','IA','Ionia','Chickasaw',43.030703,-92.466271),('50647','IA','Janesville','Bremer',42.65115,-92.474451),('50648','IA','Jesup','Buchanan',42.453205,-92.09323),('50649','IA','Kesley','Butler',42.662282,-92.910997),('50650','IA','Lamont','Buchanan',42.604546,-91.647388),('50651','IA','La Porte City','Black Hawk',42.31691,-92.18844),('50652','IA','Lincoln','Tama',42.262452,-92.691768),('50653','IA','Marble Rock','Floyd',42.96697,-92.880278),('50654','IA','Masonville','Delaware',42.472923,-91.598395),('50655','IA','Maynard','Fayette',42.774532,-91.883346),('50657','IA','Morrison','Grundy',42.3441,-92.6736),('50658','IA','Nashua','Chickasaw',42.959039,-92.531022),('50659','IA','New Hampton','Chickasaw',43.072102,-92.324024),('50660','IA','New Hartford','Butler',42.576987,-92.63598),('50661','IA','North Washington','Chickasaw',43.118,-92.4166),('50662','IA','Oelwein','Fayette',42.678735,-91.922314),('50664','IA','Oran','Fayette',42.700766,-92.075245),('50665','IA','Parkersburg','Butler',42.575557,-92.777796),('50666','IA','Plainfield','Bremer',42.85442,-92.503231),('50667','IA','Raymond','Black Hawk',42.468357,-92.221194),('50668','IA','Readlyn','Bremer',42.692962,-92.22889),('50669','IA','Reinbeck','Grundy',42.327534,-92.605516),('50670','IA','Shell Rock','Butler',42.707831,-92.592793),('50671','IA','Stanley','Buchanan',42.643328,-91.808952),('50672','IA','Steamboat Rock','Hardin',42.413948,-93.068541),('50673','IA','Stout','Grundy',42.52611,-92.712086),('50674','IA','Sumner','Bremer',42.848751,-92.118017),('50675','IA','Traer','Tama',42.199324,-92.488195),('50676','IA','Tripoli','Bremer',42.81155,-92.263944),('50677','IA','Waverly','Bremer',42.736568,-92.456639),('50680','IA','Wellsburg','Grundy',42.440027,-92.929223),('50681','IA','Westgate','Fayette',42.780153,-92.004272),('50682','IA','Winthrop','Buchanan',42.449382,-91.706513),('50701','IA','Waterloo','Black Hawk',42.470652,-92.359998),('50702','IA','Waterloo','Black Hawk',42.471627,-92.328778),('50703','IA','Waterloo','Black Hawk',42.516718,-92.326237),('50704','IA','Waterloo','Black Hawk',42.5004,-92.3393),('50706','IA','Waterloo','Black Hawk',42.407588,-92.266575),('50707','IA','Evansdale','Black Hawk',42.477385,-92.281752),('50801','IA','Creston','Union',41.065643,-94.378217),('50830','IA','Afton','Union',41.026228,-94.195818),('50831','IA','Arispe','Union',40.9494,-94.2188),('50833','IA','Bedford','Taylor',40.671294,-94.706184),('50835','IA','Benton','Ringgold',40.712112,-94.36005),('50836','IA','Blockton','Taylor',40.616129,-94.482545),('50837','IA','Bridgewater','Adair',41.242821,-94.669836),('50839','IA','Carbon','Adams',41.050312,-94.82386),('50840','IA','Clearfield','Taylor',40.800326,-94.484934),('50841','IA','Corning','Adams',40.998437,-94.750014),('50842','IA','Cromwell','Union',41.04005,-94.462961),('50843','IA','Cumberland','Cass',41.235077,-94.892378),('50845','IA','Diagonal','Ringgold',40.813943,-94.349589),('50846','IA','Fontanelle','Adair',41.29543,-94.563617),('50847','IA','Grant','Montgomery',41.142367,-94.983255),('50848','IA','Gravity','Taylor',40.780922,-94.764274),('50849','IA','Greenfield','Adair',41.303486,-94.437477),('50851','IA','Lenox','Taylor',40.894803,-94.539162),('50853','IA','Massena','Cass',41.246407,-94.770463),('50854','IA','Mount Ayr','Ringgold',40.700153,-94.230875),('50857','IA','Nodaway','Adams',40.934778,-94.879425),('50858','IA','Orient','Adair',41.205079,-94.403945),('50859','IA','Prescott','Adams',41.048836,-94.60425),('50860','IA','Redding','Ringgold',40.624836,-94.353726),('50861','IA','Shannon City','Union',40.904087,-94.264309),('50862','IA','Sharpsburg','Taylor',40.807022,-94.648162),('50863','IA','Tingley','Ringgold',40.854453,-94.18519),('50864','IA','Villisca','Montgomery',40.958935,-94.990126),('50936','IA','Des Moines','Polk',41.6005,-93.6088),('50940','IA','Des Moines','Polk',41.6005,-93.6088),('50947','IA','Des Moines','Polk',41.6005,-93.6088),('50950','IA','Des Moines','Polk',41.6005,-93.6088),('50980','IA','Des Moines','Polk',41.6005,-93.6088),('50981','IA','Des Moines','Polk',41.6005,-93.6088),('50982','IA','Des Moines','Polk',41.583,-93.639),('50983','IA','Des Moines','Polk',41.583,-93.639),('51001','IA','Akron','Plymouth',42.842199,-96.554359),('51002','IA','Alta','Buena Vista',42.688436,-95.319027),('51003','IA','Alton','Sioux',42.984817,-96.0017),('51004','IA','Anthon','Woodbury',42.378846,-95.892601),('51005','IA','Aurelia','Cherokee',42.710429,-95.429893),('51006','IA','Battle Creek','Ida',42.316147,-95.610472),('51007','IA','Bronson','Woodbury',42.41181,-96.195148),('51008','IA','Brunsville','Plymouth',42.809271,-96.268504),('51009','IA','Calumet','Obrien',42.945653,-95.550815),('51010','IA','Castana','Monona',42.075907,-95.907159),('51011','IA','Chatsworth','Sioux',42.915903,-96.516141),('51012','IA','Cherokee','Cherokee',42.747236,-95.56018),('51014','IA','Cleghorn','Cherokee',42.786037,-95.710584),('51015','IA','Climbing Hill','Woodbury',42.3416,-96.0775),('51016','IA','Correctionville','Woodbury',42.471828,-95.805288),('51018','IA','Cushing','Woodbury',42.450232,-95.679034),('51019','IA','Danbury','Woodbury',42.255686,-95.72795),('51020','IA','Galva','Ida',42.510109,-95.413547),('51022','IA','Granville','Sioux',42.974873,-95.850362),('51023','IA','Hawarden','Sioux',43.004328,-96.482878),('51024','IA','Hinton','Plymouth',42.612142,-96.262983),('51025','IA','Holstein','Ida',42.488347,-95.549419),('51026','IA','Hornick','Woodbury',42.250562,-96.078293),('51027','IA','Ireton','Sioux',42.970872,-96.325564),('51028','IA','Kingsley','Plymouth',42.596655,-95.98764),('51029','IA','Larrabee','Cherokee',42.875426,-95.542411),('51030','IA','Lawton','Woodbury',42.497741,-96.188321),('51031','IA','Le Mars','Plymouth',42.796698,-96.179068),('51033','IA','Linn Grove','Buena Vista',42.910063,-95.249401),('51034','IA','Mapleton','Monona',42.165246,-95.785175),('51035','IA','Marcus','Cherokee',42.800197,-95.799544),('51036','IA','Maurice','Sioux',42.969544,-96.187762),('51037','IA','Meriden','Cherokee',42.817019,-95.642089),('51038','IA','Merrill','Plymouth',42.698955,-96.292397),('51039','IA','Moville','Woodbury',42.474763,-96.058146),('51040','IA','Onawa','Monona',42.03139,-96.097913),('51041','IA','Orange City','Sioux',43.021228,-96.069061),('51044','IA','Oto','Woodbury',42.295102,-95.909247),('51045','IA','Oyens','Plymouth',42.820632,-96.056548),('51046','IA','Paullina','Obrien',42.973643,-95.6785),('51047','IA','Peterson','Clay',42.921019,-95.350346),('51048','IA','Pierson','Woodbury',42.571716,-95.855424),('51049','IA','Quimby','Cherokee',42.630008,-95.640073),('51050','IA','Remsen','Plymouth',42.786022,-95.947941),('51051','IA','Rodney','Monona',42.205347,-95.95505),('51052','IA','Salix','Woodbury',42.311936,-96.292271),('51053','IA','Schaller','Sac',42.51095,-95.279088),('51054','IA','Sergeant Bluff','Woodbury',42.387806,-96.35047),('51055','IA','Sloan','Woodbury',42.221559,-96.246437),('51056','IA','Smithland','Woodbury',42.23088,-95.937571),('51058','IA','Sutherland','Obrien',42.98231,-95.481428),('51060','IA','Ute','Monona',42.04226,-95.703047),('51061','IA','Washta','Cherokee',42.575325,-95.717926),('51062','IA','Westfield','Plymouth',42.727605,-96.536314),('51063','IA','Whiting','Monona',42.139159,-96.168318),('51101','IA','Sioux City','Woodbury',42.493687,-96.395658),('51102','IA','Sioux City','Woodbury',42.4924,-96.4014),('51103','IA','Sioux City','Woodbury',42.505302,-96.427736),('51104','IA','Sioux City','Woodbury',42.524164,-96.401953),('51105','IA','Sioux City','Woodbury',42.505169,-96.383495),('51106','IA','Sioux City','Woodbury',42.466663,-96.350622),('51108','IA','Sioux City','Woodbury',42.549394,-96.356674),('51109','IA','Sioux City','Woodbury',42.519264,-96.478425),('51111','IA','Sioux City','Woodbury',42.414912,-96.376569),('51201','IA','Sheldon','Obrien',43.184144,-95.852774),('51230','IA','Alvord','Lyon',43.365083,-96.310923),('51231','IA','Archer','Obrien',43.098584,-95.740378),('51232','IA','Ashton','Osceola',43.301916,-95.803152),('51234','IA','Boyden','Sioux',43.195343,-96.015235),('51235','IA','Doon','Lyon',43.282524,-96.227388),('51237','IA','George','Lyon',43.332139,-96.00039),('51238','IA','Hospers','Sioux',43.071353,-95.898863),('51239','IA','Hull','Sioux',43.196739,-96.142762),('51240','IA','Inwood','Lyon',43.309587,-96.458182),('51241','IA','Larchwood','Lyon',43.45121,-96.451775),('51242','IA','Lester','Lyon',43.438009,-96.333442),('51243','IA','Little Rock','Lyon',43.44738,-95.893951),('51244','IA','Matlock','Sioux',43.243092,-95.935437),('51245','IA','Primghar','Obrien',43.075541,-95.612665),('51246','IA','Rock Rapids','Lyon',43.42675,-96.171786),('51247','IA','Rock Valley','Sioux',43.192582,-96.324584),('51248','IA','Sanborn','Obrien',43.189796,-95.65346),('51249','IA','Sibley','Osceola',43.404912,-95.742254),('51250','IA','Sioux Center','Sioux',43.08254,-96.190932),('51301','IA','Spencer','Clay',43.152103,-95.149789),('51331','IA','Arnolds Park','Dickinson',43.364813,-95.128004),('51333','IA','Dickens','Clay',43.136586,-95.014992),('51334','IA','Estherville','Emmet',43.399699,-94.811045),('51338','IA','Everly','Clay',43.190889,-95.29892),('51340','IA','Fostoria','Clay',43.2197,-95.1937),('51341','IA','Gillett Grove','Clay',43.015298,-95.036749),('51342','IA','Graettinger','Palo Alto',43.238708,-94.74405),('51343','IA','Greenville','Clay',43.002203,-95.103611),('51344','IA','Gruver','Emmet',43.393113,-94.704719),('51345','IA','Harris','Osceola',43.422367,-95.436696),('51346','IA','Hartley','Obrien',43.178588,-95.465195),('51347','IA','Lake Park','Dickinson',43.437422,-95.31662),('51350','IA','Melvin','Osceola',43.307777,-95.596279),('51351','IA','Milford','Dickinson',43.331419,-95.163777),('51354','IA','Ocheyedan','Osceola',43.404618,-95.529054),('51355','IA','Okoboji','Dickinson',43.388177,-95.136693),('51357','IA','Royal','Clay',43.062192,-95.277963),('51358','IA','Ruthven','Palo Alto',43.135068,-94.897075),('51360','IA','Spirit Lake','Dickinson',43.434593,-95.108233),('51363','IA','Superior','Dickinson',43.432024,-94.945758),('51364','IA','Terril','Dickinson',43.305937,-94.966944),('51365','IA','Wallingford','Emmet',43.309567,-94.747621),('51366','IA','Webb','Clay',42.960599,-95.023258),('51401','IA','Carroll','Carroll',42.066342,-94.867714),('51430','IA','Arcadia','Carroll',42.089718,-95.02385),('51431','IA','Arthur','Ida',42.341428,-95.357419),('51432','IA','Aspinwall','Crawford',41.8886,-95.125),('51433','IA','Auburn','Sac',42.282982,-94.87067),('51436','IA','Breda','Carroll',42.174624,-95.004801),('51439','IA','Charter Oak','Crawford',42.085015,-95.578448),('51440','IA','Dedham','Carroll',41.914061,-94.814817),('51441','IA','Deloit','Crawford',42.113278,-95.315415),('51442','IA','Denison','Crawford',42.020129,-95.357285),('51443','IA','Glidden','Carroll',42.093014,-94.71136),('51444','IA','Halbur','Carroll',42.006284,-94.971505),('51445','IA','Ida Grove','Ida',42.337712,-95.468664),('51446','IA','Irwin','Shelby',41.783295,-95.197931),('51447','IA','Kirkman','Shelby',41.724506,-95.199407),('51448','IA','Kiron','Crawford',42.198973,-95.307703),('51449','IA','Lake City','Calhoun',42.266877,-94.740454),('51450','IA','Lake View','Sac',42.307787,-95.036097),('51451','IA','Lanesboro','Carroll',42.184068,-94.692446),('51452','IA','Lidderdale','Carroll',42.126994,-94.784493),('51453','IA','Lohrville','Calhoun',42.277205,-94.538524),('51454','IA','Manilla','Crawford',41.885129,-95.217948),('51455','IA','Manning','Carroll',41.909498,-95.066894),('51458','IA','Odebolt','Sac',42.315559,-95.235443),('51459','IA','Ralston','Carroll',42.041196,-94.634178),('51460','IA','Ricketts','Crawford',42.1906,-95.6358),('51461','IA','Schleswig','Crawford',42.163287,-95.467805),('51462','IA','Scranton','Greene',42.023153,-94.552479),('51463','IA','Templeton','Carroll',41.909938,-94.927619),('51465','IA','Vail','Crawford',42.074114,-95.20253),('51466','IA','Wall Lake','Sac',42.256933,-95.106626),('51467','IA','Westside','Crawford',42.071948,-95.107228),('51501','IA','Council Bluffs','Pottawattamie',41.249161,-95.873051),('51502','IA','Council Bluffs','Pottawattamie',41.269884,-95.797529),('51503','IA','Council Bluffs','Pottawattamie',41.246938,-95.812201),('51510','IA','Carter Lake','Pottawattamie',41.289955,-95.914476),('51520','IA','Arion','Crawford',41.9675,-95.450853),('51521','IA','Avoca','Pottawattamie',41.480855,-95.336091),('51523','IA','Blencoe','Monona',41.915664,-96.080463),('51525','IA','Carson','Pottawattamie',41.235932,-95.414286),('51526','IA','Crescent','Pottawattamie',41.363005,-95.880641),('51527','IA','Defiance','Shelby',41.826931,-95.344653),('51528','IA','Dow City','Crawford',41.930786,-95.4976),('51529','IA','Dunlap','Harrison',41.856672,-95.607684),('51530','IA','Earling','Shelby',41.775931,-95.427695),('51531','IA','Elk Horn','Shelby',41.597501,-95.07284),('51532','IA','Elliott','Montgomery',41.138167,-95.132731),('51533','IA','Emerson','Mills',41.02547,-95.385476),('51534','IA','Glenwood','Mills',41.041434,-95.732599),('51535','IA','Griswold','Cass',41.233195,-95.132026),('51536','IA','Hancock','Pottawattamie',41.38717,-95.368089),('51537','IA','Harlan','Shelby',41.644385,-95.309912),('51540','IA','Hastings','Mills',41.021227,-95.495925),('51541','IA','Henderson','Mills',41.138257,-95.398784),('51542','IA','Honey Creek','Pottawattamie',41.428226,-95.840061),('51543','IA','Kimballton','Audubon',41.638956,-95.083516),('51544','IA','Lewis','Cass',41.312854,-95.097566),('51545','IA','Little Sioux','Harrison',41.823825,-96.038097),('51546','IA','Logan','Harrison',41.642456,-95.78138),('51548','IA','Mc Clelland','Pottawattamie',41.313457,-95.645477),('51549','IA','Macedonia','Pottawattamie',41.191133,-95.433146),('51550','IA','Magnolia','Harrison',41.694334,-95.873622),('51551','IA','Malvern','Mills',40.999494,-95.589388),('51552','IA','Marne','Cass',41.476369,-95.119933),('51553','IA','Minden','Pottawattamie',41.437596,-95.543777),('51554','IA','Mineola','Mills',41.142642,-95.691003),('51555','IA','Missouri Valley','Harrison',41.550338,-95.911159),('51556','IA','Modale','Harrison',41.632785,-96.021506),('51557','IA','Mondamin','Harrison',41.736188,-95.991415),('51558','IA','Moorhead','Monona',41.909032,-95.863918),('51559','IA','Neola','Pottawattamie',41.455385,-95.643007),('51560','IA','Oakland','Pottawattamie',41.321853,-95.405633),('51561','IA','Pacific Junction','Mills',41.021726,-95.806776),('51562','IA','Panama','Shelby',41.725074,-95.49332),('51563','IA','Persia','Harrison',41.570702,-95.585717),('51564','IA','Pisgah','Harrison',41.819704,-95.907117),('51565','IA','Portsmouth','Shelby',41.642467,-95.520674),('51566','IA','Red Oak','Montgomery',41.011557,-95.228535),('51570','IA','Shelby','Shelby',41.519397,-95.45655),('51571','IA','Silver City','Mills',41.124213,-95.622163),('51572','IA','Soldier','Monona',41.983069,-95.787527),('51573','IA','Stanton','Montgomery',40.979559,-95.097052),('51575','IA','Treynor','Pottawattamie',41.245097,-95.611588),('51576','IA','Underwood','Pottawattamie',41.363683,-95.69623),('51577','IA','Walnut','Pottawattamie',41.463552,-95.206908),('51578','IA','Westphalia','Shelby',41.719239,-95.394469),('51579','IA','Woodbine','Harrison',41.741743,-95.709031),('51591','IA','Red Oak','Montgomery',41.0097,-95.2252),('51593','IA','Harlan','Shelby',41.2651,-95.7912),('51601','IA','Shenandoah','Page',40.752703,-95.362072),('51602','IA','Shenandoah','Page',40.7667,-95.3721),('51603','IA','Shenandoah','Page',40.7667,-95.3721),('51630','IA','Blanchard','Page',40.602988,-95.192613),('51631','IA','Braddyville','Page',40.591418,-95.009999),('51632','IA','Clarinda','Page',40.744548,-95.044091),('51636','IA','Coin','Page',40.666451,-95.228984),('51637','IA','College Springs','Page',40.62109,-95.120494),('51638','IA','Essex','Page',40.835915,-95.284064),('51639','IA','Farragut','Fremont',40.718512,-95.476418),('51640','IA','Hamburg','Fremont',40.608424,-95.656839),('51645','IA','Imogene','Fremont',40.884132,-95.431238),('51646','IA','New Market','Taylor',40.747685,-94.874449),('51647','IA','Northboro','Page',40.60378,-95.307261),('51648','IA','Percival','Fremont',40.727629,-95.809322),('51649','IA','Randolph','Fremont',40.865894,-95.546854),('51650','IA','Riverton','Fremont',40.679881,-95.564868),('51651','IA','Shambaugh','Page',40.669,-95.045),('51652','IA','Sidney','Fremont',40.761255,-95.637455),('51653','IA','Tabor','Fremont',40.890028,-95.673718),('51654','IA','Thurman','Fremont',40.834885,-95.781549),('51656','IA','Yorktown','Page',40.734813,-95.155323),('52001','IA','Dubuque','Dubuque',42.51255,-90.67946),('52002','IA','Dubuque','Dubuque',42.511211,-90.75406),('52003','IA','Dubuque','Dubuque',42.46523,-90.686614),('52004','IA','Dubuque','Dubuque',42.4987,-90.6677),('52030','IA','Andrew','Jackson',42.153288,-90.591868),('52031','IA','Bellevue','Jackson',42.252271,-90.455591),('52032','IA','Bernard','Dubuque',42.274333,-90.813617),('52033','IA','Cascade','Dubuque',42.283638,-91.002515),('52035','IA','Colesburg','Delaware',42.674163,-91.184074),('52036','IA','Delaware','Delaware',42.473959,-91.342283),('52037','IA','Delmar','Clinton',41.977751,-90.618055),('52038','IA','Dundee','Delaware',42.581466,-91.549953),('52039','IA','Durango','Dubuque',42.531342,-90.842255),('52040','IA','Dyersville','Dubuque',42.487248,-91.125118),('52041','IA','Earlville','Delaware',42.498122,-91.255823),('52042','IA','Edgewood','Clayton',42.679857,-91.38352),('52043','IA','Elkader','Clayton',42.852243,-91.409185),('52044','IA','Elkport','Clayton',42.763396,-91.300838),('52045','IA','Epworth','Dubuque',42.450807,-90.930907),('52046','IA','Farley','Dubuque',42.442321,-91.008008),('52047','IA','Farmersburg','Clayton',42.958715,-91.364696),('52048','IA','Garber','Clayton',42.734491,-91.260095),('52049','IA','Garnavillo','Clayton',42.877749,-91.188203),('52050','IA','Greeley','Delaware',42.599533,-91.329866),('52052','IA','Guttenberg','Clayton',42.768679,-91.103892),('52053','IA','Holy Cross','Dubuque',42.60104,-90.959658),('52054','IA','La Motte','Jackson',42.301059,-90.623835),('52056','IA','Luxemburg','Dubuque',42.60483,-91.076542),('52057','IA','Manchester','Delaware',42.485414,-91.446923),('52060','IA','Maquoketa','Jackson',42.084453,-90.678432),('52064','IA','Miles','Jackson',42.080995,-90.325985),('52065','IA','New Vienna','Dubuque',42.572474,-91.101674),('52066','IA','North Buena Vista','Clayton',42.681229,-90.953298),('52068','IA','Peosta','Dubuque',42.442681,-90.814749),('52069','IA','Preston','Jackson',42.058458,-90.410742),('52070','IA','Sabula','Jackson',42.077564,-90.197466),('52071','IA','Saint Donatus','Jackson',42.36059,-90.53879),('52072','IA','Saint Olaf','Clayton',42.915415,-91.376568),('52073','IA','Sherrill','Dubuque',42.644407,-90.833399),('52074','IA','Spragueville','Jackson',42.119105,-90.481241),('52075','IA','Springbrook','Jackson',42.161997,-90.479878),('52076','IA','Strawberry Point','Clayton',42.683835,-91.525931),('52077','IA','Volga','Clayton',42.814267,-91.556574),('52078','IA','Worthington','Dubuque',42.407323,-91.128501),('52079','IA','Zwingle','Jackson',42.288083,-90.700871),('52099','IA','Dubuque','Dubuque',42.4988,-90.6678),('52101','IA','Decorah','Winneshiek',43.338146,-91.769695),('52132','IA','Calmar','Winneshiek',43.198038,-91.89989),('52133','IA','Castalia','Winneshiek',43.116183,-91.667637),('52134','IA','Chester','Howard',43.486202,-92.392628),('52135','IA','Clermont','Fayette',43.003057,-91.660065),('52136','IA','Cresco','Howard',43.383343,-92.104217),('52140','IA','Dorchester','Allamakee',43.446177,-91.560869),('52141','IA','Elgin','Fayette',42.946846,-91.642666),('52142','IA','Fayette','Fayette',42.834299,-91.797829),('52144','IA','Fort Atkinson','Winneshiek',43.135234,-91.949475),('52146','IA','Harpers Ferry','Allamakee',43.18524,-91.179747),('52147','IA','Hawkeye','Fayette',42.957592,-91.95837),('52149','IA','Highlandville','Winneshiek',43.4176,-91.6922),('52151','IA','Lansing','Allamakee',43.341104,-91.243394),('52154','IA','Lawler','Chickasaw',43.108935,-92.153662),('52155','IA','Lime Springs','Howard',43.421674,-92.307374),('52156','IA','Luana','Clayton',43.048099,-91.464029),('52157','IA','Mc Gregor','Clayton',43.0066,-91.196253),('52158','IA','Marquette','Clayton',43.044148,-91.179665),('52159','IA','Monona','Clayton',43.070715,-91.357008),('52160','IA','New Albin','Allamakee',43.484558,-91.329573),('52161','IA','Ossian','Winneshiek',43.12861,-91.748903),('52162','IA','Postville','Allamakee',43.110434,-91.560214),('52163','IA','Protivin','Howard',43.216649,-92.092204),('52164','IA','Randalia','Fayette',42.853589,-91.889535),('52165','IA','Ridgeway','Winneshiek',43.298656,-91.982111),('52166','IA','Saint Lucas','Fayette',43.067185,-91.934167),('52168','IA','Spillville','Winneshiek',43.205423,-91.951182),('52169','IA','Wadena','Fayette',42.845249,-91.658727),('52170','IA','Waterville','Allamakee',43.211433,-91.300233),('52171','IA','Waucoma','Fayette',43.068495,-92.053235),('52172','IA','Waukon','Allamakee',43.267048,-91.475937),('52175','IA','West Union','Fayette',42.986172,-91.814221),('52201','IA','Ainsworth','Washington',41.318454,-91.545497),('52202','IA','Alburnett','Linn',42.14587,-91.636177),('52203','IA','Amana','Iowa',41.802753,-91.889418),('52204','IA','Amana','Iowa',41.8,-91.8705),('52205','IA','Anamosa','Jones',42.107395,-91.28007),('52206','IA','Atkins','Benton',41.994528,-91.869757),('52207','IA','Baldwin','Jackson',42.077307,-90.832369),('52208','IA','Belle Plaine','Benton',41.889786,-92.26865),('52209','IA','Blairstown','Benton',41.906919,-92.088809),('52210','IA','Brandon','Buchanan',42.328901,-91.998454),('52211','IA','Brooklyn','Poweshiek',41.75389,-92.449753),('52212','IA','Center Junction','Jones',42.112851,-91.090112),('52213','IA','Center Point','Linn',42.192389,-91.787358),('52214','IA','Central City','Linn',42.199219,-91.518277),('52215','IA','Chelsea','Tama',41.914886,-92.395483),('52216','IA','Clarence','Cedar',41.887952,-91.047407),('52217','IA','Clutier','Tama',42.078806,-92.400543),('52218','IA','Coggon','Linn',42.289246,-91.563128),('52219','IA','Prairieburg','Linn',42.237899,-91.424685),('52220','IA','Conroy','Iowa',41.729142,-91.997041),('52221','IA','Guernsey','Poweshiek',41.641142,-92.333784),('52222','IA','Deep River','Poweshiek',41.575757,-92.340918),('52223','IA','Delhi','Delaware',42.425468,-91.339217),('52224','IA','Dysart','Tama',42.164998,-92.302397),('52225','IA','Elberon','Tama',42.010552,-92.331157),('52227','IA','Ely','Linn',41.894468,-91.568527),('52228','IA','Fairfax','Linn',41.913157,-91.784444),('52229','IA','Garrison','Benton',42.149703,-92.151822),('52231','IA','Harper','Keokuk',41.358956,-92.058688),('52232','IA','Hartwick','Poweshiek',41.805026,-92.327984),('52233','IA','Hiawatha','Linn',42.044673,-91.682535),('52235','IA','Hills','Johnson',41.556752,-91.532858),('52236','IA','Homestead','Iowa',41.731386,-91.870836),('52237','IA','Hopkinton','Delaware',42.346317,-91.242191),('52240','IA','Iowa City','Johnson',41.645301,-91.517836),('52241','IA','Coralville','Johnson',41.692606,-91.586327),('52242','IA','Iowa City','Johnson',41.659721,-91.541793),('52243','IA','Iowa City','Johnson',41.6563,-91.5342),('52244','IA','Iowa City','Johnson',41.6563,-91.5342),('52245','IA','Iowa City','Johnson',41.665432,-91.508098),('52246','IA','Iowa City','Johnson',41.651157,-91.563286),('52247','IA','Kalona','Washington',41.504104,-91.718829),('52248','IA','Keota','Keokuk',41.357622,-91.93686),('52249','IA','Keystone','Benton',42.002231,-92.201792),('52251','IA','Ladora','Iowa',41.732477,-92.193162),('52252','IA','Langworthy','Jones',42.1901,-91.223),('52253','IA','Lisbon','Linn',41.904502,-91.36373),('52254','IA','Lost Nation','Clinton',41.952852,-90.791314),('52255','IA','Lowden','Cedar',41.862325,-90.9457),('52257','IA','Luzerne','Benton',41.908203,-92.177389),('52301','IA','Marengo','Iowa',41.788658,-92.082116),('52302','IA','Marion','Linn',42.046188,-91.58614),('52305','IA','Martelle','Jones',42.027526,-91.342766),('52306','IA','Mechanicsville','Cedar',41.900835,-91.255346),('52307','IA','Middle Amana','Iowa',41.794254,-91.900722),('52308','IA','Millersburg','Iowa',41.572739,-92.159752),('52309','IA','Monmouth','Jackson',42.111697,-90.887184),('52310','IA','Monticello','Jones',42.223196,-91.188921),('52312','IA','Morley','Jones',42.006022,-91.247374),('52313','IA','Mount Auburn','Benton',42.257377,-92.096977),('52314','IA','Mount Vernon','Linn',41.929203,-91.437123),('52315','IA','Newhall','Benton',41.995973,-91.966615),('52316','IA','North English','Iowa',41.53258,-92.083514),('52317','IA','North Liberty','Johnson',41.752469,-91.616933),('52318','IA','Norway','Benton',41.883466,-91.899674),('52319','IA','Oakdale','Johnson',41.7063,-91.6027),('52320','IA','Olin','Jones',42.002647,-91.14567),('52321','IA','Onslow','Jones',42.135701,-91.003672),('52322','IA','Oxford','Johnson',41.689637,-91.767627),('52323','IA','Oxford Junction','Jones',41.983915,-90.959089),('52324','IA','Palo','Linn',42.064862,-91.79513),('52325','IA','Parnell','Iowa',41.58185,-91.926903),('52326','IA','Quasqueton','Buchanan',42.393997,-91.757699),('52327','IA','Riverside','Washington',41.486136,-91.571981),('52328','IA','Robins','Linn',42.070282,-91.661033),('52329','IA','Rowley','Buchanan',42.366306,-91.843897),('52330','IA','Ryan','Delaware',42.347182,-91.510027),('52332','IA','Shellsburg','Benton',42.099462,-91.880388),('52333','IA','Solon','Johnson',41.806079,-91.503395),('52334','IA','South Amana','Iowa',41.740353,-91.939177),('52335','IA','South English','Keokuk',41.446122,-92.053787),('52336','IA','Springville','Linn',42.061387,-91.439367),('52337','IA','Stanwood','Cedar',41.887982,-91.14741),('52338','IA','Swisher','Johnson',41.837351,-91.685029),('52339','IA','Tama','Tama',41.945086,-92.596455),('52340','IA','Tiffin','Johnson',41.705652,-91.676614),('52341','IA','Toddville','Linn',42.102851,-91.726175),('52342','IA','Toledo','Tama',42.025322,-92.571758),('52344','IA','Troy Mills','Linn',42.29,-91.6822),('52345','IA','Urbana','Benton',42.225729,-91.879363),('52346','IA','Van Horne','Benton',42.006352,-92.081023),('52347','IA','Victor','Iowa',41.726766,-92.296351),('52348','IA','Vining','Tama',41.990297,-92.381975),('52349','IA','Vinton','Benton',42.175673,-92.013003),('52350','IA','Viola','Linn',42.0352,-91.4227),('52351','IA','Walford','Benton',41.876942,-91.835122),('52352','IA','Walker','Linn',42.288954,-91.78146),('52353','IA','Washington','Washington',41.299736,-91.697393),('52354','IA','Watkins','Benton',41.913003,-91.978304),('52355','IA','Webster','Keokuk',41.459265,-92.17875),('52356','IA','Wellman','Washington',41.479644,-91.837865),('52358','IA','West Branch','Cedar',41.679592,-91.333361),('52359','IA','West Chester','Washington',41.354288,-91.815583),('52361','IA','Williamsburg','Iowa',41.655186,-92.015227),('52362','IA','Wyoming','Jones',42.056091,-91.004655),('52401','IA','Cedar Rapids','Linn',41.976302,-91.660022),('52402','IA','Cedar Rapids','Linn',42.020149,-91.654452),('52403','IA','Cedar Rapids','Linn',41.978558,-91.608799),('52404','IA','Cedar Rapids','Linn',41.946483,-91.691573),('52405','IA','Cedar Rapids','Linn',41.979482,-91.708865),('52406','IA','Cedar Rapids','Linn',41.9189,-91.6785),('52407','IA','Cedar Rapids','Linn',41.9771,-91.6593),('52408','IA','Cedar Rapids','Linn',41.9771,-91.6593),('52409','IA','Cedar Rapids','Linn',41.9771,-91.6593),('52410','IA','Cedar Rapids','Linn',41.9771,-91.6593),('52411','IA','Cedar Rapids','Linn',42.042599,-91.722936),('52497','IA','Cedar Rapids','Linn',42.0213,-91.66),('52498','IA','Cedar Rapids','Linn',41.9771,-91.6593),('52499','IA','Cedar Rapids','Linn',41.9771,-91.6593),('52501','IA','Ottumwa','Wapello',41.024335,-92.420737),('52530','IA','Agency','Wapello',40.993474,-92.302508),('52531','IA','Albia','Monroe',41.027609,-92.805237),('52533','IA','Batavia','Jefferson',41.013701,-92.14962),('52534','IA','Beacon','Mahaska',41.275646,-92.681914),('52535','IA','Birmingham','Van Buren',40.862944,-91.959572),('52536','IA','Blakesburg','Wapello',40.963805,-92.624096),('52537','IA','Bloomfield','Davis',40.744599,-92.42969),('52538','IA','West Grove','Davis',40.6907,-92.6166),('52540','IA','Brighton','Washington',41.156484,-91.821476),('52542','IA','Cantril','Van Buren',40.63147,-92.059463),('52543','IA','Cedar','Mahaska',41.213282,-92.522592),('52544','IA','Centerville','Appanoose',40.735246,-92.886749),('52548','IA','Chillicothe','Wapello',41.085911,-92.528318),('52549','IA','Cincinnati','Appanoose',40.61642,-92.93139),('52550','IA','Delta','Keokuk',41.328171,-92.346439),('52551','IA','Douds','Van Buren',40.839605,-92.099704),('52552','IA','Drakesville','Davis',40.819435,-92.533959),('52553','IA','Eddyville','Wapello',41.151626,-92.635505),('52554','IA','Eldon','Wapello',40.919698,-92.222449),('52555','IA','Exline','Appanoose',40.64712,-92.815628),('52556','IA','Fairfield','Jefferson',41.013608,-91.955305),('52557','IA','Fairfield','Jefferson',41.022979,-91.965902),('52560','IA','Floris','Davis',40.859679,-92.266373),('52561','IA','Fremont','Mahaska',41.216196,-92.441676),('52562','IA','Hayesville','Keokuk',41.26457,-92.24888),('52563','IA','Hedrick','Keokuk',41.169622,-92.276329),('52565','IA','Keosauqua','Van Buren',40.734947,-91.946816),('52566','IA','Kirkville','Wapello',41.144067,-92.504465),('52567','IA','Libertyville','Jefferson',40.933662,-92.071414),('52568','IA','Martinsburg','Keokuk',41.178396,-92.250044),('52569','IA','Melrose','Monroe',40.934178,-93.039958),('52570','IA','Milton','Van Buren',40.686005,-92.173564),('52571','IA','Moravia','Appanoose',40.865248,-92.844884),('52572','IA','Moulton','Appanoose',40.68242,-92.676477),('52573','IA','Mount Sterling','Van Buren',40.616112,-91.938387),('52574','IA','Mystic','Appanoose',40.804928,-92.951062),('52576','IA','Ollie','Keokuk',41.215153,-92.109419),('52577','IA','Oskaloosa','Mahaska',41.279202,-92.653372),('52580','IA','Packwood','Jefferson',41.130785,-92.096935),('52581','IA','Plano','Appanoose',40.791096,-93.050205),('52583','IA','Promise City','Wayne',40.790202,-93.156523),('52584','IA','Pulaski','Davis',40.664311,-92.264418),('52585','IA','Richland','Keokuk',41.193756,-91.979513),('52586','IA','Rose Hill','Mahaska',41.343386,-92.473853),('52588','IA','Selma','Van Buren',40.865786,-92.170984),('52590','IA','Seymour','Wayne',40.675603,-93.12661),('52591','IA','Sigourney','Keokuk',41.325936,-92.202282),('52593','IA','Udell','Appanoose',40.777954,-92.739251),('52594','IA','Unionville','Appanoose',40.836198,-92.652642),('52595','IA','University Park','Mahaska',41.287421,-92.619475),('52601','IA','Burlington','Des Moines',40.813657,-91.119002),('52619','IA','Argyle','Lee',40.526372,-91.569114),('52620','IA','Bonaparte','Van Buren',40.695215,-91.802877),('52621','IA','Crawfordsville','Washington',41.212063,-91.534214),('52623','IA','Danville','Des Moines',40.863508,-91.335699),('52624','IA','Denmark','Lee',40.741229,-91.336375),('52625','IA','Donnellson','Lee',40.660783,-91.57415),('52626','IA','Farmington','Van Buren',40.627392,-91.751286),('52627','IA','Fort Madison','Lee',40.637897,-91.340397),('52630','IA','Hillsboro','Henry',40.809876,-91.711407),('52631','IA','Houghton','Lee',40.784287,-91.607169),('52632','IA','Keokuk','Lee',40.411871,-91.401419),('52635','IA','Lockridge','Jefferson',40.995559,-91.754289),('52637','IA','Mediapolis','Des Moines',41.006671,-91.150897),('52638','IA','Middletown','Des Moines',40.80585,-91.244596),('52639','IA','Montrose','Lee',40.532399,-91.43149),('52640','IA','Morning Sun','Louisa',41.10094,-91.279828),('52641','IA','Mount Pleasant','Henry',40.973848,-91.571313),('52642','IA','Rome','Henry',40.9813,-91.6822),('52644','IA','Mount Union','Henry',41.038763,-91.409664),('52645','IA','New London','Henry',40.916099,-91.406561),('52646','IA','Oakville','Louisa',41.069668,-91.01499),('52647','IA','Olds','Henry',41.133371,-91.545551),('52648','IA','Pilot Grove','Lee',40.7627,-91.5366),('52649','IA','Salem','Henry',40.848427,-91.617323),('52650','IA','Sperry','Des Moines',40.952086,-91.165259),('52651','IA','Stockport','Van Buren',40.864342,-91.799689),('52652','IA','Swedesburg','Henry',41.103879,-91.546646),('52653','IA','Wapello','Louisa',41.170856,-91.168821),('52654','IA','Wayland','Henry',41.140194,-91.67018),('52655','IA','West Burlington','Des Moines',40.831668,-91.186661),('52656','IA','West Point','Lee',40.723781,-91.461087),('52657','IA','Saint Paul','Lee',40.76694,-91.517045),('52658','IA','Wever','Lee',40.703804,-91.239206),('52659','IA','Winfield','Henry',41.128154,-91.441016),('52660','IA','Yarmouth','Des Moines',40.994596,-91.29937),('52701','IA','Andover','Clinton',41.980307,-90.250111),('52720','IA','Atalissa','Muscatine',41.580526,-91.147929),('52721','IA','Bennett','Cedar',41.749907,-90.965611),('52722','IA','Bettendorf','Scott',41.550658,-90.488035),('52726','IA','Blue Grass','Scott',41.498418,-90.775946),('52727','IA','Bryant','Clinton',41.962748,-90.329739),('52728','IA','Buffalo','Scott',41.456394,-90.728198),('52729','IA','Calamus','Clinton',41.805744,-90.752466),('52730','IA','Camanche','Clinton',41.782687,-90.285308),('52731','IA','Charlotte','Clinton',41.963012,-90.476994),('52732','IA','Clinton','Clinton',41.85889,-90.215634),('52733','IA','Clinton','Clinton',41.8444,-90.1886),('52734','IA','Clinton','Clinton',41.8191,-90.2337),('52736','IA','Clinton','Clinton',41.8444,-90.1886),('52737','IA','Columbus City','Louisa',41.259023,-91.374638),('52738','IA','Columbus Junction','Louisa',41.268556,-91.367809),('52739','IA','Conesville','Muscatine',41.357557,-91.359169),('52742','IA','De Witt','Clinton',41.829402,-90.525536),('52745','IA','Dixon','Scott',41.717925,-90.76642),('52746','IA','Donahue','Scott',41.716455,-90.670392),('52747','IA','Durant','Cedar',41.603678,-90.910106),('52748','IA','Eldridge','Scott',41.658279,-90.56814),('52749','IA','Fruitland','Muscatine',41.353624,-91.126298),('52750','IA','Goose Lake','Clinton',41.937061,-90.397108),('52751','IA','Grand Mound','Clinton',41.836473,-90.67006),('52752','IA','Grandview','Louisa',41.27631,-91.189329),('52753','IA','Le Claire','Scott',41.604809,-90.363225),('52754','IA','Letts','Louisa',41.350016,-91.246634),('52755','IA','Lone Tree','Johnson',41.471266,-91.431755),('52756','IA','Long Grove','Scott',41.719562,-90.544241),('52757','IA','Low Moor','Clinton',41.803961,-90.358488),('52758','IA','Mc Causland','Scott',41.745922,-90.441844),('52759','IA','Montpelier','Muscatine',41.4591,-90.8069),('52760','IA','Moscow','Muscatine',41.573068,-91.093957),('52761','IA','Muscatine','Muscatine',41.424167,-91.052694),('52765','IA','New Liberty','Scott',41.735148,-90.869615),('52766','IA','Nichols','Muscatine',41.467543,-91.295421),('52767','IA','Pleasant Valley','Scott',41.568539,-90.419614),('52768','IA','Princeton','Scott',41.691011,-90.368918),('52769','IA','Stockton','Muscatine',41.595874,-90.858129),('52771','IA','Teeds Grove','Clinton',42.0116,-90.2475),('52772','IA','Tipton','Cedar',41.749216,-91.133181),('52773','IA','Walcott','Scott',41.616192,-90.768161),('52774','IA','Welton','Clinton',41.908885,-90.595792),('52776','IA','West Liberty','Muscatine',41.577183,-91.261962),('52777','IA','Wheatland','Clinton',41.843061,-90.860614),('52778','IA','Wilton','Muscatine',41.604692,-91.006533),('52801','IA','Davenport','Scott',41.522145,-90.574839),('52802','IA','Davenport','Scott',41.512673,-90.616076),('52803','IA','Davenport','Scott',41.53943,-90.561799),('52804','IA','Davenport','Scott',41.532141,-90.623809),('52805','IA','Davenport','Scott',41.521,-90.5865),('52806','IA','Davenport','Scott',41.578129,-90.597945),('52807','IA','Davenport','Scott',41.576112,-90.536212),('52808','IA','Davenport','Scott',41.521,-90.5865),('52809','IA','Davenport','Scott',41.521,-90.5865),('53001','WI','Adell','Sheboygan',43.608244,-88.031119),('53002','WI','Allenton','Washington',43.460841,-88.363956),('53003','WI','Ashippun','Dodge',43.211953,-88.518068),('53004','WI','Belgium','Ozaukee',43.498615,-87.861468),('53005','WI','Brookfield','Waukesha',43.060483,-88.095938),('53006','WI','Brownsville','Dodge',43.627825,-88.516463),('53007','WI','Butler','Waukesha',43.107413,-88.068868),('53008','WI','Brookfield','Waukesha',43.0605,-88.1063),('53010','WI','Campbellsport','Fond Du Lac',43.607008,-88.263745),('53011','WI','Cascade','Sheboygan',43.655535,-88.073502),('53012','WI','Cedarburg','Ozaukee',43.303604,-87.997595),('53013','WI','Cedar Grove','Sheboygan',43.574777,-87.836278),('53014','WI','Chilton','Calumet',44.029061,-88.168371),('53015','WI','Cleveland','Manitowoc',43.909982,-87.768457),('53016','WI','Clyman','Dodge',43.312263,-88.716862),('53017','WI','Colgate','Washington',43.201787,-88.248488),('53018','WI','Delafield','Waukesha',43.051422,-88.390817),('53019','WI','Eden','Fond Du Lac',43.697711,-88.321059),('53020','WI','Elkhart Lake','Sheboygan',43.855108,-88.0021),('53021','WI','Fredonia','Ozaukee',43.479681,-87.986115),('53022','WI','Germantown','Washington',43.216362,-88.120088),('53023','WI','Glenbeulah','Sheboygan',43.7897,-88.106031),('53024','WI','Grafton','Ozaukee',43.324101,-87.943825),('53026','WI','Greenbush','Sheboygan',43.7766,-88.0838),('53027','WI','Hartford','Washington',43.315235,-88.371918),('53029','WI','Hartland','Waukesha',43.128671,-88.34459),('53031','WI','Hingham','Sheboygan',43.639559,-87.915635),('53032','WI','Horicon','Dodge',43.447948,-88.632252),('53033','WI','Hubertus','Washington',43.235634,-88.247729),('53034','WI','Hustisford','Dodge',43.34856,-88.601727),('53035','WI','Iron Ridge','Dodge',43.397678,-88.540642),('53036','WI','Ixonia','Jefferson',43.179661,-88.575045),('53037','WI','Jackson','Washington',43.320498,-88.168496),('53038','WI','Johnson Creek','Jefferson',43.078323,-88.778392),('53039','WI','Juneau','Dodge',43.376218,-88.709821),('53040','WI','Kewaskum','Washington',43.524518,-88.212657),('53042','WI','Kiel','Manitowoc',43.924272,-88.002792),('53044','WI','Kohler','Sheboygan',43.741673,-87.783281),('53045','WI','Brookfield','Waukesha',43.05536,-88.150142),('53046','WI','Lannon','Waukesha',43.148787,-88.16513),('53047','WI','Lebanon','Dodge',43.257077,-88.627304),('53048','WI','Lomira','Dodge',43.582658,-88.441133),('53049','WI','Malone','Fond Du Lac',43.884911,-88.311154),('53050','WI','Mayville','Dodge',43.501401,-88.543522),('53051','WI','Menomonee Falls','Waukesha',43.152333,-88.110353),('53052','WI','Menomonee Falls','Waukesha',43.1788,-88.1172),('53056','WI','Merton','Waukesha',43.1466,-88.3066),('53057','WI','Mount Calvary','Fond Du Lac',43.806118,-88.254086),('53058','WI','Nashotah','Waukesha',43.10892,-88.402894),('53059','WI','Neosho','Dodge',43.300933,-88.531914),('53060','WI','Newburg','Washington',43.4316,-88.0463),('53061','WI','New Holstein','Calumet',43.951512,-88.099161),('53062','WI','New Holstein','Calumet',43.95,-88.0841),('53063','WI','Newton','Manitowoc',43.971849,-87.77652),('53064','WI','North Lake','Waukesha',43.1561,-88.3705),('53065','WI','Oakfield','Fond Du Lac',43.690769,-88.566622),('53066','WI','Oconomowoc','Waukesha',43.103765,-88.487508),('53069','WI','Okauchee','Waukesha',43.113361,-88.43803),('53070','WI','Oostburg','Sheboygan',43.624026,-87.800116),('53072','WI','Pewaukee','Waukesha',43.077915,-88.258393),('53073','WI','Plymouth','Sheboygan',43.756719,-87.981729),('53074','WI','Port Washington','Ozaukee',43.400304,-87.882695),('53075','WI','Random Lake','Sheboygan',43.564515,-87.990969),('53076','WI','Richfield','Washington',43.269015,-88.193295),('53078','WI','Rubicon','Dodge',43.317498,-88.451047),('53079','WI','Saint Cloud','Fond Du Lac',43.800968,-88.181371),('53080','WI','Saukville','Ozaukee',43.390106,-87.955589),('53081','WI','Sheboygan','Sheboygan',43.734884,-87.730724),('53082','WI','Sheboygan','Sheboygan',43.75,-87.7145),('53083','WI','Sheboygan','Sheboygan',43.79774,-87.756249),('53085','WI','Sheboygan Falls','Sheboygan',43.729505,-87.840294),('53086','WI','Slinger','Washington',43.329268,-88.278559),('53088','WI','Stockbridge','Calumet',44.074062,-88.300224),('53089','WI','Sussex','Waukesha',43.140585,-88.231639),('53090','WI','West Bend','Washington',43.446782,-88.178531),('53091','WI','Theresa','Dodge',43.514511,-88.440773),('53092','WI','Thiensville','Ozaukee',43.223234,-87.952629),('53093','WI','Waldo','Sheboygan',43.665462,-87.940953),('53094','WI','Watertown','Jefferson',43.164952,-88.722383),('53095','WI','West Bend','Washington',43.401467,-88.182934),('53097','WI','Mequon','Ozaukee',43.234618,-88.004748),('53098','WI','Watertown','Dodge',43.243007,-88.724141),('53099','WI','Woodland','Dodge',43.3702,-88.5186),('53101','WI','Bassett','Kenosha',42.5405,-88.2277),('53102','WI','Benet Lake','Kenosha',42.5387,-88.024),('53103','WI','Big Bend','Waukesha',42.890596,-88.210808),('53104','WI','Bristol','Kenosha',42.547457,-88.03928),('53105','WI','Burlington','Racine',42.662905,-88.280268),('53108','WI','Caledonia','Racine',42.825927,-87.943148),('53109','WI','Camp Lake','Kenosha',42.5347,-88.1436),('53110','WI','Cudahy','Milwaukee',42.95147,-87.861025),('53114','WI','Darien','Walworth',42.595631,-88.737467),('53115','WI','Delavan','Walworth',42.633702,-88.643067),('53118','WI','Dousman','Waukesha',42.990413,-88.477965),('53119','WI','Eagle','Waukesha',42.879248,-88.476368),('53120','WI','East Troy','Walworth',42.8008,-88.398174),('53121','WI','Elkhorn','Walworth',42.704602,-88.538248),('53122','WI','Elm Grove','Waukesha',43.047561,-88.087045),('53125','WI','Fontana','Walworth',42.545139,-88.565916),('53126','WI','Franksville','Racine',42.778305,-87.966452),('53127','WI','Genesee Depot','Waukesha',42.8864,-88.3628),('53128','WI','Genoa City','Walworth',42.526865,-88.336227),('53129','WI','Greendale','Milwaukee',42.937437,-87.995798),('53130','WI','Hales Corners','Milwaukee',42.941233,-88.049449),('53132','WI','Franklin','Milwaukee',42.898314,-88.007911),('53137','WI','Helenville','Jefferson',43.007883,-88.669078),('53138','WI','Honey Creek','Walworth',42.7483,-88.3077),('53139','WI','Kansasville','Racine',42.693422,-88.127137),('53140','WI','Kenosha','Kenosha',42.605711,-87.830422),('53141','WI','Kenosha','Kenosha',42.5834,-87.8211),('53142','WI','Kenosha','Kenosha',42.566025,-87.886445),('53143','WI','Kenosha','Kenosha',42.565064,-87.831148),('53144','WI','Kenosha','Kenosha',42.604853,-87.878198),('53146','WI','New Berlin','Waukesha',42.973705,-88.155385),('53147','WI','Lake Geneva','Walworth',42.587297,-88.451314),('53148','WI','Lyons','Walworth',42.649557,-88.359652),('53149','WI','Mukwonago','Waukesha',42.872724,-88.344097),('53150','WI','Muskego','Waukesha',42.901402,-88.122302),('53151','WI','New Berlin','Waukesha',42.981826,-88.094525),('53152','WI','New Munster','Kenosha',42.5794,-88.2277),('53153','WI','North Prairie','Waukesha',42.934471,-88.407089),('53154','WI','Oak Creek','Milwaukee',42.882205,-87.90343),('53156','WI','Palmyra','Jefferson',42.879186,-88.589792),('53157','WI','Pell Lake','Walworth',42.538,-88.3508),('53158','WI','Pleasant Prairie','Kenosha',42.524575,-87.883449),('53159','WI','Powers Lake','Kenosha',42.5536,-88.2944),('53167','WI','Rochester','Racine',42.741754,-88.223793),('53168','WI','Salem','Kenosha',42.566594,-88.124359),('53170','WI','Silver Lake','Kenosha',42.550116,-88.168671),('53171','WI','Somers','Kenosha',42.5803,-87.8953),('53172','WI','South Milwaukee','Milwaukee',42.909225,-87.863972),('53176','WI','Springfield','Walworth',42.642223,-88.41179),('53177','WI','Sturtevant','Racine',42.699156,-87.916748),('53178','WI','Sullivan','Jefferson',43.015954,-88.595824),('53179','WI','Trevor','Kenosha',42.513801,-88.130588),('53181','WI','Twin Lakes','Kenosha',42.518135,-88.252681),('53182','WI','Union Grove','Racine',42.697428,-88.041751),('53183','WI','Wales','Waukesha',43.002993,-88.373602),('53184','WI','Walworth','Walworth',42.533406,-88.5967),('53185','WI','Waterford','Racine',42.785829,-88.194357),('53186','WI','Waukesha','Waukesha',43.015499,-88.2065),('53187','WI','Waukesha','Waukesha',43.0088,-88.2237),('53188','WI','Waukesha','Waukesha',43.020728,-88.269551),('53189','WI','Waukesha','Waukesha',42.968382,-88.264542),('53190','WI','Whitewater','Walworth',42.822191,-88.7266),('53191','WI','Williams Bay','Walworth',42.576407,-88.541698),('53192','WI','Wilmot','Kenosha',42.512333,-88.182999),('53194','WI','Woodworth','Kenosha',42.558,-88.0011),('53195','WI','Zenda','Walworth',42.513971,-88.485146),('53199','WI','Silver Lake','Kenosha',42.5548,-88.1716),('53201','WI','Milwaukee','Milwaukee',43.0343,-87.9151),('53202','WI','Milwaukee','Milwaukee',43.044856,-87.900264),('53203','WI','Milwaukee','Milwaukee',43.039463,-87.915267),('53204','WI','Milwaukee','Milwaukee',43.017556,-87.926055),('53205','WI','Milwaukee','Milwaukee',43.053714,-87.93456),('53206','WI','Milwaukee','Milwaukee',43.073276,-87.934292),('53207','WI','Milwaukee','Milwaukee',42.985617,-87.899953),('53208','WI','Milwaukee','Milwaukee',43.047816,-87.966274),('53209','WI','Milwaukee','Milwaukee',43.119554,-87.947048),('53210','WI','Milwaukee','Milwaukee',43.068864,-87.975554),('53211','WI','Milwaukee','Milwaukee',43.084612,-87.886354),('53212','WI','Milwaukee','Milwaukee',43.070211,-87.908982),('53213','WI','Milwaukee','Milwaukee',43.049066,-88.000369),('53214','WI','Milwaukee','Milwaukee',43.020328,-88.01287),('53215','WI','Milwaukee','Milwaukee',42.999261,-87.943078),('53216','WI','Milwaukee','Milwaukee',43.086127,-87.974746),('53217','WI','Milwaukee','Milwaukee',43.143271,-87.90859),('53218','WI','Milwaukee','Milwaukee',43.111029,-87.994251),('53219','WI','Milwaukee','Milwaukee',42.996541,-87.992932),('53220','WI','Milwaukee','Milwaukee',42.968173,-87.991852),('53221','WI','Milwaukee','Milwaukee',42.953925,-87.945684),('53222','WI','Milwaukee','Milwaukee',43.081475,-88.028226),('53223','WI','Milwaukee','Milwaukee',43.163471,-87.985336),('53224','WI','Milwaukee','Milwaukee',43.15696,-88.04),('53225','WI','Milwaukee','Milwaukee',43.115154,-88.042944),('53226','WI','Milwaukee','Milwaukee',43.049005,-88.04223),('53227','WI','Milwaukee','Milwaukee',42.996753,-88.036652),('53228','WI','Milwaukee','Milwaukee',42.9673,-88.039697),('53233','WI','Milwaukee','Milwaukee',43.039456,-87.933566),('53234','WI','Milwaukee','Milwaukee',43.0031,-87.9679),('53235','WI','Milwaukee','Milwaukee',42.970222,-87.875314),('53237','WI','Milwaukee','Milwaukee',42.9443,-87.9093),('53244','WI','Milwaukee','Milwaukee',42.9426,-87.9119),('53259','WI','Milwaukee','Milwaukee',43.0388,-87.9063),('53263','WI','Milwaukee','Milwaukee',43.0388,-87.9063),('53267','WI','Milwaukee','Milwaukee',43.0439,-87.9097),('53268','WI','Milwaukee','Milwaukee',43.0388,-87.9063),('53274','WI','Milwaukee','Milwaukee',43.0345,-87.9153),('53278','WI','Milwaukee','Milwaukee',43.0343,-87.9151),('53288','WI','Milwaukee','Milwaukee',43.0388,-87.9063),('53290','WI','Milwaukee','Milwaukee',43.0343,-87.9151),('53293','WI','Milwaukee','Milwaukee',43.0343,-87.9151),('53295','WI','Milwaukee','Milwaukee',43.022406,-87.969776),('53401','WI','Racine','Racine',42.726,-87.7825),('53402','WI','Racine','Racine',42.773921,-87.800114),('53403','WI','Racine','Racine',42.704968,-87.800768),('53404','WI','Racine','Racine',42.743222,-87.80519),('53405','WI','Racine','Racine',42.714491,-87.824196),('53406','WI','Racine','Racine',42.729652,-87.857942),('53407','WI','Racine','Racine',42.7261,-87.7827),('53408','WI','Racine','Racine',42.717,-87.8395),('53501','WI','Afton','Rock',42.6909,-89.093),('53502','WI','Albany','Green',42.722486,-89.43946),('53503','WI','Arena','Iowa',43.146457,-89.948646),('53504','WI','Argyle','Lafayette',42.700617,-89.864415),('53505','WI','Avalon','Rock',42.661039,-88.820854),('53506','WI','Avoca','Iowa',43.164957,-90.286598),('53507','WI','Barneveld','Iowa',43.010282,-89.903986),('53508','WI','Belleville','Dane',42.871619,-89.546406),('53510','WI','Belmont','Lafayette',42.734894,-90.324847),('53511','WI','Beloit','Rock',42.525155,-89.035416),('53512','WI','Beloit','Rock',42.5083,-89.0316),('53515','WI','Black Earth','Dane',43.129046,-89.738807),('53516','WI','Blanchardville','Lafayette',42.796356,-89.871814),('53517','WI','Blue Mounds','Dane',43.030881,-89.836846),('53518','WI','Blue River','Richland',43.240989,-90.59513),('53520','WI','Brodhead','Green',42.606408,-89.370498),('53521','WI','Brooklyn','Dane',42.838105,-89.400302),('53522','WI','Browntown','Green',42.567438,-89.787168),('53523','WI','Cambridge','Dane',42.992201,-89.022936),('53525','WI','Clinton','Rock',42.560254,-88.862655),('53526','WI','Cobb','Iowa',42.967764,-90.335138),('53527','WI','Cottage Grove','Dane',43.074553,-89.198656),('53528','WI','Cross Plains','Dane',43.112592,-89.644589),('53529','WI','Dane','Dane',43.236582,-89.521944),('53530','WI','Darlington','Lafayette',42.684586,-90.108615),('53531','WI','Deerfield','Dane',43.055094,-89.090924),('53532','WI','De Forest','Dane',43.228322,-89.335644),('53533','WI','Dodgeville','Iowa',42.9811,-90.146525),('53534','WI','Edgerton','Rock',42.843167,-89.072394),('53535','WI','Edmund','Iowa',42.9675,-90.2644),('53536','WI','Evansville','Rock',42.773179,-89.277298),('53537','WI','Footville','Rock',42.668587,-89.209867),('53538','WI','Fort Atkinson','Jefferson',42.919068,-88.849218),('53540','WI','Gotham','Richland',43.223709,-90.293503),('53541','WI','Gratiot','Lafayette',42.57583,-90.022606),('53542','WI','Hanover','Rock',42.7052,-89.0057),('53543','WI','Highland','Iowa',43.057644,-90.345152),('53544','WI','Hollandale','Iowa',42.880086,-89.916746),('53545','WI','Janesville','Rock',42.703714,-89.012648),('53546','WI','Janesville','Rock',42.668982,-88.991071),('53547','WI','Janesville','Rock',42.7052,-89.0057),('53548','WI','Janesville','Rock',42.684206,-89.065092),('53549','WI','Jefferson','Jefferson',43.000303,-88.795768),('53550','WI','Juda','Green',42.566765,-89.493247),('53551','WI','Lake Mills','Jefferson',43.080094,-88.907243),('53553','WI','Linden','Iowa',42.914952,-90.280697),('53554','WI','Livingston','Grant',42.900584,-90.437994),('53555','WI','Lodi','Columbia',43.324932,-89.560696),('53556','WI','Lone Rock','Richland',43.212757,-90.225141),('53557','WI','Lowell','Dodge',43.340183,-88.809929),('53558','WI','Mc Farland','Dane',43.01483,-89.285777),('53559','WI','Marshall','Dane',43.169742,-89.069609),('53560','WI','Mazomanie','Dane',43.188353,-89.77129),('53561','WI','Merrimac','Sauk',43.373839,-89.664146),('53562','WI','Middleton','Dane',43.102748,-89.511379),('53563','WI','Milton','Rock',42.77845,-88.957179),('53565','WI','Mineral Point','Iowa',42.838677,-90.166831),('53566','WI','Monroe','Green',42.603478,-89.64044),('53569','WI','Montfort','Grant',42.989029,-90.438953),('53570','WI','Monticello','Green',42.743733,-89.610145),('53571','WI','Morrisonville','Dane',43.277857,-89.357902),('53572','WI','Mount Horeb','Dane',42.98222,-89.734801),('53573','WI','Muscoda','Grant',43.194049,-90.455141),('53574','WI','New Glarus','Green',42.815859,-89.639332),('53575','WI','Oregon','Dane',42.929282,-89.38463),('53576','WI','Orfordville','Rock',42.63119,-89.24704),('53577','WI','Plain','Sauk',43.296903,-90.069305),('53578','WI','Prairie Du Sac','Sauk',43.328653,-89.744571),('53579','WI','Reeseville','Dodge',43.295981,-88.867735),('53580','WI','Rewey','Iowa',42.849537,-90.37588),('53581','WI','Richland Center','Richland',43.361645,-90.409175),('53582','WI','Ridgeway','Iowa',43.022326,-89.979104),('53583','WI','Sauk City','Sauk',43.267292,-89.769111),('53584','WI','Sextonville','Richland',43.2783,-90.2908),('53585','WI','Sharon','Walworth',42.519072,-88.722446),('53586','WI','Shullsburg','Lafayette',42.574785,-90.239843),('53587','WI','South Wayne','Lafayette',42.584745,-89.902782),('53588','WI','Spring Green','Sauk',43.176005,-90.073159),('53589','WI','Stoughton','Dane',42.927416,-89.221398),('53590','WI','Sun Prairie','Dane',43.189579,-89.228713),('53593','WI','Verona','Dane',42.994263,-89.553637),('53594','WI','Waterloo','Jefferson',43.185671,-88.975886),('53595','WI','Dodgeville','Iowa',42.9602,-90.13),('53596','WI','Sun Prairie','Dane',43.184,-89.2107),('53597','WI','Waunakee','Dane',43.180492,-89.449306),('53598','WI','Windsor','Dane',43.209983,-89.341959),('53599','WI','Woodford','Lafayette',42.648782,-89.862021),('53701','WI','Madison','Dane',43.073,-89.3817),('53702','WI','Madison','Waukesha',43.060926,-88.230636),('53703','WI','Madison','Dane',43.078736,-89.377259),('53704','WI','Madison','Dane',43.122983,-89.348903),('53705','WI','Madison','Dane',43.072794,-89.457946),('53706','WI','Madison','Dane',43.074531,-89.410282),('53707','WI','Madison','Dane',43.0985,-89.317),('53708','WI','Madison','Dane',43.0985,-89.317),('53711','WI','Madison','Dane',43.034564,-89.444272),('53713','WI','Madison','Dane',43.037908,-89.391271),('53714','WI','Madison','Dane',43.099993,-89.316818),('53715','WI','Madison','Dane',43.06152,-89.400228),('53716','WI','Madison','Dane',43.061492,-89.318203),('53717','WI','Madison','Dane',43.073069,-89.519916),('53718','WI','Madison','Dane',43.099154,-89.272239),('53719','WI','Madison','Dane',43.02974,-89.505053),('53725','WI','Madison','Dane',43.0569,-89.4038),('53726','WI','Madison','Dane',43.069935,-89.421886),('53744','WI','Madison','Dane',43.0157,-89.4166),('53774','WI','Madison','Dane',43.0733,-89.4012),('53777','WI','Madison','Dane',43.073,-89.4011),('53778','WI','Madison','Dane',43.0985,-89.317),('53779','WI','Madison','Dane',43.073,-89.4011),('53782','WI','Madison','Dane',43.073,-89.4011),('53783','WI','Madison','Dane',43.073,-89.4011),('53784','WI','Madison','Dane',43.073,-89.4011),('53785','WI','Madison','Dane',43.073,-89.4011),('53786','WI','Madison','Dane',43.073,-89.4011),('53788','WI','Madison','Dane',43.073,-89.4011),('53789','WI','Madison','Dane',43.073,-89.4011),('53790','WI','Madison','Dane',43.073,-89.4011),('53791','WI','Madison','Dane',43.0985,-89.317),('53792','WI','Madison','Dane',43.077533,-89.43066),('53793','WI','Madison','Dane',43.073,-89.4011),('53794','WI','Madison','Dane',43.073,-89.4011),('53801','WI','Bagley','Grant',42.928892,-91.088252),('53802','WI','Beetown','Grant',42.806826,-90.888401),('53803','WI','Benton','Lafayette',42.563885,-90.365323),('53804','WI','Bloomington','Grant',42.881945,-90.916191),('53805','WI','Boscobel','Grant',43.138826,-90.698512),('53806','WI','Cassville','Grant',42.733916,-90.950221),('53807','WI','Cuba City','Grant',42.605992,-90.470223),('53808','WI','Dickeyville','Grant',42.626709,-90.594523),('53809','WI','Fennimore','Grant',42.990955,-90.639149),('53810','WI','Glen Haven','Grant',42.820565,-91.003264),('53811','WI','Hazel Green','Grant',42.531953,-90.515094),('53812','WI','Kieler','Grant',42.5813,-90.6025),('53813','WI','Lancaster','Grant',42.841877,-90.708752),('53816','WI','Mount Hope','Grant',42.97883,-90.858098),('53817','WI','Patch Grove','Grant',42.940784,-90.973186),('53818','WI','Platteville','Grant',42.741845,-90.484985),('53820','WI','Potosi','Grant',42.695287,-90.692886),('53821','WI','Prairie Du Chien','Crawford',43.046405,-91.112966),('53824','WI','Sinsinawa','Grant',42.5236,-90.5391),('53825','WI','Stitzer','Grant',42.926474,-90.567344),('53826','WI','Wauzeka','Crawford',43.114683,-90.888028),('53827','WI','Woodman','Grant',43.062083,-90.821411),('53901','WI','Portage','Columbia',43.549363,-89.480804),('53910','WI','Adams','Adams',43.90721,-89.816273),('53911','WI','Arlington','Columbia',43.325821,-89.367495),('53913','WI','Baraboo','Sauk',43.488441,-89.744452),('53916','WI','Beaver Dam','Dodge',43.456756,-88.840337),('53919','WI','Brandon','Fond Du Lac',43.733668,-88.788371),('53920','WI','Briggsville','Marquette',43.660293,-89.592846),('53922','WI','Burnett','Dodge',43.52093,-88.715147),('53923','WI','Cambria','Columbia',43.560091,-89.137602),('53924','WI','Cazenovia','Richland',43.496023,-90.258379),('53925','WI','Columbus','Columbia',43.341387,-89.038511),('53926','WI','Dalton','Green Lake',43.675976,-89.20676),('53927','WI','Dellwood','Adams',43.9841,-89.9386),('53928','WI','Doylestown','Columbia',43.42669,-89.150373),('53929','WI','Elroy','Juneau',43.749593,-90.283928),('53930','WI','Endeavor','Marquette',43.691635,-89.486742),('53931','WI','Fairwater','Fond Du Lac',43.743099,-88.865334),('53932','WI','Fall River','Columbia',43.404915,-89.05952),('53933','WI','Fox Lake','Dodge',43.566965,-88.904725),('53934','WI','Friendship','Adams',43.980299,-89.854723),('53935','WI','Friesland','Columbia',43.589721,-89.066176),('53936','WI','Grand Marsh','Adams',43.868893,-89.707306),('53937','WI','Hillpoint','Sauk',43.381145,-90.148444),('53939','WI','Kingston','Green Lake',43.693731,-89.128459),('53940','WI','Lake Delton','Sauk',43.589593,-89.793067),('53941','WI','La Valle','Sauk',43.581311,-90.135827),('53942','WI','Lime Ridge','Sauk',43.4609,-90.0839),('53943','WI','Loganville','Sauk',43.410242,-90.041707),('53944','WI','Lyndon Station','Juneau',43.703464,-89.898533),('53946','WI','Markesan','Green Lake',43.723867,-89.035878),('53947','WI','Marquette','Green Lake',43.745691,-89.140376),('53948','WI','Mauston','Juneau',43.787857,-90.058109),('53949','WI','Montello','Marquette',43.783646,-89.331798),('53950','WI','New Lisbon','Juneau',43.901142,-90.137808),('53951','WI','North Freedom','Sauk',43.41256,-89.870215),('53952','WI','Oxford','Adams',43.78229,-89.592947),('53953','WI','Packwaukee','Marquette',43.768221,-89.460667),('53954','WI','Pardeeville','Columbia',43.540504,-89.329113),('53955','WI','Poynette','Columbia',43.425915,-89.428256),('53956','WI','Randolph','Dodge',43.540027,-89.010742),('53957','WI','Randolph','Columbia',43.5384,-89.0072),('53958','WI','Reedsburg','Sauk',43.5282,-90.0016),('53959','WI','Reedsburg','Sauk',43.529654,-89.988473),('53960','WI','Rio','Columbia',43.43891,-89.238097),('53961','WI','Rock Springs','Sauk',43.465709,-89.926006),('53962','WI','Union Center','Juneau',43.685137,-90.265786),('53963','WI','Waupun','Dodge',43.634709,-88.732829),('53964','WI','Westfield','Marquette',43.906378,-89.4941),('53965','WI','Wisconsin Dells','Sauk',43.642856,-89.781058),('53968','WI','Wonewoc','Juneau',43.643413,-90.236137),('53969','WI','Wyocena','Columbia',43.494795,-89.307615),('54001','WI','Amery','Polk',45.323415,-92.380756),('54002','WI','Baldwin','St. Croix',44.964453,-92.374456),('54003','WI','Beldenville','Pierce',44.783102,-92.446405),('54004','WI','Clayton','Polk',45.316589,-92.146035),('54005','WI','Clear Lake','Polk',45.238812,-92.246981),('54006','WI','Cushing','Polk',45.590696,-92.646689),('54007','WI','Deer Park','St. Croix',45.189887,-92.370066),('54009','WI','Dresser','Polk',45.350268,-92.602896),('54010','WI','East Ellsworth','Pierce',44.734167,-92.466277),('54011','WI','Ellsworth','Pierce',44.719761,-92.465227),('54013','WI','Glenwood City','St. Croix',45.082941,-92.207587),('54014','WI','Hager City','Pierce',44.615059,-92.560463),('54015','WI','Hammond','St. Croix',44.959227,-92.444452),('54016','WI','Hudson','St. Croix',44.976821,-92.718161),('54017','WI','New Richmond','St. Croix',45.121077,-92.539963),('54020','WI','Osceola','Polk',45.299473,-92.642553),('54021','WI','Prescott','Pierce',44.749886,-92.770109),('54022','WI','River Falls','Pierce',44.854761,-92.619949),('54023','WI','Roberts','St. Croix',44.97418,-92.547008),('54024','WI','Saint Croix Falls','Polk',45.457544,-92.633714),('54025','WI','Somerset','St. Croix',45.138987,-92.680829),('54026','WI','Star Prairie','Polk',45.2191,-92.535708),('54027','WI','Wilson','St. Croix',44.933885,-92.195245),('54028','WI','Woodville','St. Croix',44.94729,-92.284754),('54082','WI','Houlton','St. Croix',45.074662,-92.754028),('54101','WI','Abrams','Oconto',44.790905,-88.046161),('54102','WI','Amberg','Marinette',45.498425,-88.01521),('54103','WI','Armstrong Creek','Forest',45.661295,-88.492625),('54104','WI','Athelstane','Marinette',45.455109,-88.278893),('54106','WI','Black Creek','Outagamie',44.47925,-88.457497),('54107','WI','Bonduel','Shawano',44.718308,-88.445576),('54110','WI','Brillion','Calumet',44.179158,-88.074295),('54111','WI','Cecil','Shawano',44.825641,-88.402751),('54112','WI','Coleman','Marinette',45.053956,-88.05565),('54113','WI','Combined Locks','Outagamie',44.261909,-88.305102),('54114','WI','Crivitz','Marinette',45.243372,-88.115948),('54115','WI','De Pere','Brown',44.422085,-88.085132),('54119','WI','Dunbar','Marinette',45.607459,-88.159732),('54120','WI','Fence','Florence',45.737298,-88.484678),('54121','WI','Florence','Florence',45.871031,-88.270029),('54123','WI','Forest Junction','Calumet',44.210656,-88.146083),('54124','WI','Gillett','Oconto',44.897444,-88.379348),('54125','WI','Goodman','Marinette',45.618056,-88.352918),('54126','WI','Greenleaf','Brown',44.304624,-88.040212),('54127','WI','Green Valley','Shawano',44.796168,-88.268714),('54128','WI','Gresham','Shawano',44.859767,-88.795364),('54129','WI','Hilbert','Calumet',44.131051,-88.19449),('54130','WI','Kaukauna','Outagamie',44.291407,-88.261901),('54131','WI','Freedom','Outagamie',44.3707,-88.3141),('54135','WI','Keshena','Menominee',44.902147,-88.595537),('54136','WI','Kimberly','Outagamie',44.268219,-88.338535),('54137','WI','Krakow','Shawano',44.760382,-88.254469),('54138','WI','Lakewood','Oconto',45.333222,-88.45613),('54139','WI','Lena','Oconto',44.939799,-88.06979),('54140','WI','Little Chute','Outagamie',44.284503,-88.312344),('54141','WI','Little Suamico','Oconto',44.719892,-88.017196),('54143','WI','Marinette','Marinette',45.087183,-87.653903),('54149','WI','Mountain','Oconto',45.205298,-88.503435),('54150','WI','Neopit','Menominee',44.982738,-88.827065),('54151','WI','Niagara','Marinette',45.718363,-87.966359),('54152','WI','Nichols','Outagamie',44.565437,-88.467179),('54153','WI','Oconto','Oconto',44.889881,-87.903828),('54154','WI','Oconto Falls','Oconto',44.87521,-88.167498),('54155','WI','Oneida','Brown',44.524838,-88.18105),('54156','WI','Pembine','Marinette',45.619316,-87.996188),('54157','WI','Peshtigo','Marinette',45.052381,-87.777255),('54159','WI','Porterfield','Marinette',45.207268,-87.82094),('54160','WI','Potter','Calumet',44.121727,-88.096943),('54161','WI','Pound','Marinette',45.114758,-88.146649),('54162','WI','Pulaski','Brown',44.662482,-88.255638),('54165','WI','Seymour','Outagamie',44.514339,-88.317489),('54166','WI','Shawano','Shawano',44.779278,-88.606542),('54169','WI','Sherwood','Calumet',44.176686,-88.280739),('54170','WI','Shiocton','Outagamie',44.497092,-88.586543),('54171','WI','Sobieski','Oconto',44.7097,-88.11068),('54173','WI','Suamico','Brown',44.640859,-88.03741),('54174','WI','Suring','Oconto',45.041611,-88.400611),('54175','WI','Townsend','Oconto',45.303618,-88.62097),('54177','WI','Wausaukee','Marinette',45.359451,-87.894158),('54180','WI','Wrightstown','Brown',44.326038,-88.170319),('54182','WI','Zachow','Shawano',44.7322,-88.3636),('54201','WI','Algoma','Kewaunee',44.616669,-87.461088),('54202','WI','Baileys Harbor','Door',45.058458,-87.136961),('54204','WI','Brussels','Door',44.757026,-87.632711),('54205','WI','Casco','Kewaunee',44.588922,-87.622736),('54207','WI','Collins','Manitowoc',44.086224,-87.983174),('54208','WI','Denmark','Brown',44.355904,-87.793588),('54209','WI','Egg Harbor','Door',45.030884,-87.281031),('54210','WI','Ellison Bay','Door',45.249232,-87.048791),('54211','WI','Ephraim','Door',45.15632,-87.171381),('54212','WI','Fish Creek','Door',45.139551,-87.240804),('54213','WI','Forestville','Door',44.693481,-87.511972),('54214','WI','Francis Creek','Manitowoc',44.199789,-87.717436),('54215','WI','Kellnersville','Manitowoc',44.224851,-87.79943),('54216','WI','Kewaunee','Kewaunee',44.451946,-87.554889),('54217','WI','Luxemburg','Kewaunee',44.567027,-87.718584),('54220','WI','Manitowoc','Manitowoc',44.097245,-87.694077),('54221','WI','Manitowoc','Manitowoc',44.0905,-87.6634),('54226','WI','Maplewood','Door',44.7475,-87.4791),('54227','WI','Maribel','Manitowoc',44.285563,-87.789888),('54228','WI','Mishicot','Manitowoc',44.26147,-87.647961),('54229','WI','New Franken','Brown',44.556891,-87.835788),('54230','WI','Reedsville','Manitowoc',44.153061,-87.910385),('54232','WI','Saint Nazianz','Manitowoc',44.007088,-87.923943),('54234','WI','Sister Bay','Door',45.186816,-87.110582),('54235','WI','Sturgeon Bay','Door',44.839438,-87.382463),('54240','WI','Tisch Mills','Manitowoc',44.326784,-87.622397),('54241','WI','Two Rivers','Manitowoc',44.174775,-87.588733),('54245','WI','Valders','Manitowoc',44.038283,-87.90051),('54246','WI','Washington Island','Door',45.36588,-86.899231),('54247','WI','Whitelaw','Manitowoc',44.195359,-87.786296),('54301','WI','Green Bay','Brown',44.489391,-88.016465),('54302','WI','Green Bay','Brown',44.5052,-87.979112),('54303','WI','Green Bay','Brown',44.532397,-88.047592),('54304','WI','Green Bay','Brown',44.499204,-88.063482),('54305','WI','Green Bay','Brown',44.5126,-88.0103),('54306','WI','Green Bay','Brown',44.5191,-88.0197),('54307','WI','Green Bay','Brown',44.470363,-88.036686),('54308','WI','Green Bay','Brown',44.5192,-87.9718),('54311','WI','Green Bay','Brown',44.488534,-87.925399),('54313','WI','Green Bay','Brown',44.563061,-88.10135),('54324','WI','Green Bay','Brown',44.4794,-88.0181),('54344','WI','Green Bay','Brown',44.4207,-88.1102),('54401','WI','Wausau','Marathon',44.957684,-89.670269),('54402','WI','Wausau','Marathon',45.0361,-89.5103),('54403','WI','Wausau','Marathon',44.976104,-89.59202),('54404','WI','Marshfield','Wood',44.6688,-90.1716),('54405','WI','Abbotsford','Clark',44.950658,-90.304758),('54406','WI','Amherst','Portage',44.421836,-89.308307),('54407','WI','Amherst Junction','Portage',44.511294,-89.304479),('54408','WI','Aniwa','Marathon',45.011905,-89.300395),('54409','WI','Antigo','Langlade',45.127423,-89.145144),('54410','WI','Arpin','Wood',44.536297,-90.043142),('54411','WI','Athens','Marathon',45.040485,-90.023967),('54412','WI','Auburndale','Wood',44.663038,-89.994686),('54413','WI','Babcock','Wood',44.291574,-90.128395),('54414','WI','Birnamwood','Shawano',44.947761,-89.164484),('54415','WI','Blenker','Wood',44.6131,-89.9207),('54416','WI','Bowler','Shawano',44.876209,-88.932203),('54417','WI','Brokaw','Marathon',45.026967,-89.653285),('54418','WI','Bryant','Langlade',45.210981,-88.96404),('54420','WI','Chili','Clark',44.625612,-90.356993),('54421','WI','Colby','Clark',44.907868,-90.30674),('54422','WI','Curtiss','Clark',44.97709,-90.445976),('54423','WI','Custer','Portage',44.578887,-89.425913),('54424','WI','Deerbrook','Langlade',45.287161,-89.172916),('54425','WI','Dorchester','Clark',45.004133,-90.336626),('54426','WI','Edgar','Marathon',44.907876,-89.979674),('54427','WI','Eland','Marathon',44.83434,-89.239116),('54428','WI','Elcho','Langlade',45.421166,-89.135714),('54429','WI','Elderon','Marathon',44.7838,-89.2447),('54430','WI','Elton','Langlade',45.146788,-88.893249),('54432','WI','Galloway','Marathon',44.7127,-89.2641),('54433','WI','Gilman','Taylor',45.186178,-90.818893),('54434','WI','Jump River','Taylor',45.353,-90.8011),('54435','WI','Gleason','Lincoln',45.356748,-89.453024),('54436','WI','Granton','Clark',44.552632,-90.435325),('54437','WI','Greenwood','Clark',44.777208,-90.629136),('54439','WI','Hannibal','Taylor',45.2525,-90.7888),('54440','WI','Hatley','Marathon',44.830315,-89.373088),('54441','WI','Hewitt','Wood',44.640094,-90.107543),('54442','WI','Irma','Lincoln',45.356519,-89.671894),('54443','WI','Junction City','Portage',44.612637,-89.741743),('54446','WI','Loyal','Clark',44.749818,-90.484491),('54447','WI','Lublin','Taylor',45.078514,-90.733624),('54448','WI','Marathon','Marathon',44.933905,-89.831679),('54449','WI','Marshfield','Wood',44.657552,-90.180963),('54450','WI','Mattoon','Shawano',45.005357,-89.041088),('54451','WI','Medford','Taylor',45.183568,-90.404862),('54452','WI','Merrill','Lincoln',45.187825,-89.702727),('54454','WI','Milladore','Wood',44.608528,-89.877537),('54455','WI','Mosinee','Marathon',44.784519,-89.690188),('54456','WI','Neillsville','Clark',44.539822,-90.611179),('54457','WI','Nekoosa','Wood',44.246171,-89.890179),('54458','WI','Nelsonville','Portage',44.495451,-89.310441),('54459','WI','Ogema','Price',45.413177,-90.237492),('54460','WI','Owen','Clark',44.938782,-90.543199),('54462','WI','Pearson','Langlade',45.392002,-89.007393),('54463','WI','Pelican Lake','Oneida',45.512403,-89.209494),('54464','WI','Phlox','Langlade',45.0511,-89.0141),('54465','WI','Pickerel','Langlade',45.384302,-88.895539),('54466','WI','Pittsville','Wood',44.399857,-90.254434),('54467','WI','Plover','Portage',44.451967,-89.546105),('54469','WI','Port Edwards','Wood',44.348442,-89.863923),('54470','WI','Rib Lake','Taylor',45.302036,-90.172801),('54471','WI','Ringle','Marathon',44.925154,-89.424525),('54472','WI','Marshfield','Wood',44.6688,-90.1716),('54473','WI','Rosholt','Portage',44.631281,-89.335135),('54474','WI','Rothschild','Marathon',44.881745,-89.620661),('54475','WI','Rudolph','Wood',44.485225,-89.776942),('54476','WI','Schofield','Marathon',44.907078,-89.572171),('54479','WI','Spencer','Marathon',44.764348,-90.331892),('54480','WI','Stetsonville','Taylor',45.069392,-90.291125),('54481','WI','Stevens Point','Portage',44.519107,-89.57769),('54482','WI','Stevens Point','Portage',44.544972,-89.526471),('54484','WI','Stratford','Marathon',44.793167,-90.061128),('54485','WI','Summit Lake','Langlade',45.38162,-89.215267),('54486','WI','Tigerton','Shawano',44.727011,-89.033223),('54487','WI','Tomahawk','Lincoln',45.509709,-89.722727),('54488','WI','Unity','Clark',44.842866,-90.328274),('54489','WI','Vesper','Wood',44.454751,-90.001993),('54490','WI','Westboro','Taylor',45.335391,-90.370529),('54491','WI','White Lake','Langlade',45.212415,-88.742841),('54492','WI','Stevens Point','Portage',44.5236,-89.5744),('54493','WI','Willard','Clark',44.717839,-90.801653),('54494','WI','Wisconsin Rapids','Wood',44.36948,-89.783916),('54495','WI','Wisconsin Rapids','Wood',44.376794,-89.908249),('54498','WI','Withee','Clark',45.011552,-90.626104),('54499','WI','Wittenberg','Shawano',44.813551,-89.176254),('54501','WI','Rhinelander','Oneida',45.640808,-89.379013),('54511','WI','Argonne','Forest',45.693279,-88.815559),('54512','WI','Boulder Junction','Vilas',46.107371,-89.67147),('54513','WI','Brantwood','Price',45.557575,-90.100637),('54514','WI','Butternut','Ashland',46.025917,-90.479976),('54515','WI','Catawba','Price',45.528643,-90.498372),('54517','WI','Clam Lake','Ashland',46.145917,-90.930676),('54519','WI','Conover','Vilas',46.049659,-89.267567),('54520','WI','Crandon','Forest',45.547687,-88.89284),('54521','WI','Eagle River','Vilas',45.926538,-89.261205),('54524','WI','Fifield','Price',45.853802,-90.399785),('54525','WI','Gile','Iron',46.429938,-90.222562),('54526','WI','Glen Flora','Rusk',45.499225,-90.869401),('54527','WI','Glidden','Ashland',46.131413,-90.625664),('54529','WI','Harshaw','Oneida',45.696656,-89.67234),('54530','WI','Hawkins','Rusk',45.54465,-90.732502),('54531','WI','Hazelhurst','Oneida',45.752815,-89.774667),('54532','WI','Heafford Junction','Lincoln',45.5472,-89.7152),('54534','WI','Hurley','Iron',46.405183,-90.218107),('54536','WI','Iron Belt','Iron',46.350142,-90.367942),('54537','WI','Kennan','Price',45.525731,-90.596812),('54538','WI','Lac Du Flambeau','Vilas',45.970064,-89.911919),('54539','WI','Lake Tomahawk','Oneida',45.809185,-89.577389),('54540','WI','Land O Lakes','Vilas',46.15752,-89.351958),('54541','WI','Laona','Forest',45.539572,-88.638831),('54542','WI','Long Lake','Florence',45.925554,-88.71926),('54543','WI','Mc Naughton','Oneida',45.731478,-89.525256),('54545','WI','Manitowish Waters','Vilas',46.120036,-89.855743),('54546','WI','Mellen','Ashland',46.304972,-90.684351),('54547','WI','Mercer','Iron',46.185116,-90.080556),('54548','WI','Minocqua','Oneida',45.861545,-89.781681),('54550','WI','Montreal','Iron',46.409586,-90.252146),('54552','WI','Park Falls','Price',45.931702,-90.369336),('54554','WI','Phelps','Vilas',46.061927,-89.06321),('54555','WI','Phillips','Price',45.706379,-90.42446),('54556','WI','Prentice','Price',45.542951,-90.301825),('54557','WI','Presque Isle','Vilas',46.221519,-89.746583),('54558','WI','Saint Germain','Vilas',45.925113,-89.499368),('54559','WI','Saxon','Iron',46.492704,-90.461607),('54560','WI','Sayner','Vilas',46.011417,-89.537993),('54561','WI','Star Lake','Vilas',46.09755,-89.51339),('54562','WI','Three Lakes','Oneida',45.810474,-89.122652),('54563','WI','Tony','Rusk',45.483126,-90.98242),('54564','WI','Tripoli','Oneida',45.598905,-89.960408),('54565','WI','Upson','Iron',46.318356,-90.435062),('54566','WI','Wabeno','Forest',45.437856,-88.636701),('54568','WI','Woodruff','Vilas',45.930308,-89.693324),('54601','WI','La Crosse','La Crosse',43.797241,-91.212844),('54602','WI','La Crosse','La Crosse',43.8131,-91.2495),('54603','WI','La Crosse','La Crosse',43.850407,-91.247514),('54610','WI','Alma','Buffalo',44.378223,-91.86334),('54611','WI','Alma Center','Jackson',44.444536,-90.938175),('54612','WI','Arcadia','Trempealeau',44.247299,-91.484326),('54613','WI','Arkdale','Adams',44.061083,-89.908489),('54614','WI','Bangor','La Crosse',43.892072,-90.980696),('54615','WI','Black River Falls','Jackson',44.270909,-90.79666),('54616','WI','Blair','Trempealeau',44.295062,-91.236733),('54618','WI','Camp Douglas','Juneau',43.948638,-90.283565),('54619','WI','Cashton','Monroe',43.757441,-90.774002),('54620','WI','Cataract','Monroe',44.0877,-90.8422),('54621','WI','Chaseburg','Vernon',43.65655,-91.09235),('54622','WI','Cochrane','Buffalo',44.245311,-91.829831),('54623','WI','Coon Valley','Vernon',43.727289,-91.024998),('54624','WI','De Soto','Vernon',43.464703,-91.180254),('54625','WI','Dodge','Trempealeau',44.134689,-91.526618),('54626','WI','Eastman','Crawford',43.219573,-91.053955),('54627','WI','Ettrick','Trempealeau',44.167639,-91.254709),('54628','WI','Ferryville','Crawford',43.354467,-91.014625),('54629','WI','Fountain City','Buffalo',44.131836,-91.678257),('54630','WI','Galesville','Trempealeau',44.093188,-91.357897),('54631','WI','Gays Mills','Crawford',43.291025,-90.834443),('54632','WI','Genoa','Vernon',43.576358,-91.187245),('54634','WI','Hillsboro','Vernon',43.602902,-90.397957),('54635','WI','Hixton','Jackson',44.402903,-91.045552),('54636','WI','Holmen','La Crosse',43.977757,-91.251579),('54637','WI','Hustler','Juneau',43.879368,-90.271088),('54638','WI','Kendall','Monroe',43.801282,-90.381227),('54639','WI','La Farge','Vernon',43.602031,-90.63024),('54640','WI','Lynxville','Crawford',43.246161,-91.054296),('54641','WI','Mather','Juneau',44.1795,-90.2517),('54642','WI','Melrose','Jackson',44.137843,-91.045144),('54643','WI','Millston','Jackson',44.18697,-90.63818),('54644','WI','Mindoro','La Crosse',44.037312,-91.062575),('54645','WI','Mount Sterling','Crawford',43.317156,-90.927152),('54646','WI','Necedah','Juneau',44.068991,-90.079857),('54648','WI','Norwalk','Monroe',43.839225,-90.629186),('54649','WI','Oakdale','Monroe',43.9597,-90.3816),('54650','WI','Onalaska','La Crosse',43.897654,-91.221074),('54651','WI','Ontario','Vernon',43.723612,-90.573186),('54652','WI','Readstown','Vernon',43.452923,-90.765653),('54653','WI','Rockland','La Crosse',43.874356,-90.914738),('54654','WI','Seneca','Crawford',43.265049,-90.958795),('54655','WI','Soldiers Grove','Crawford',43.381518,-90.763231),('54656','WI','Sparta','Monroe',43.978652,-90.786172),('54657','WI','Steuben','Crawford',43.190011,-90.896661),('54658','WI','Stoddard','Vernon',43.682125,-91.186976),('54659','WI','Taylor','Jackson',44.299111,-91.114789),('54660','WI','Tomah','Monroe',43.9916,-90.481866),('54661','WI','Trempealeau','Trempealeau',44.035629,-91.450596),('54662','WI','Tunnel City','Monroe',44.0072,-90.5655),('54664','WI','Viola','Richland',43.503542,-90.656592),('54665','WI','Viroqua','Vernon',43.543793,-90.889939),('54666','WI','Warrens','Monroe',44.146622,-90.441931),('54667','WI','Westby','Vernon',43.661279,-90.852787),('54669','WI','West Salem','La Crosse',43.899973,-91.089214),('54670','WI','Wilton','Monroe',43.827377,-90.497531),('54701','WI','Eau Claire','Eau Claire',44.780156,-91.480499),('54702','WI','Eau Claire','Eau Claire',44.8144,-91.5012),('54703','WI','Eau Claire','Eau Claire',44.829712,-91.505364),('54720','WI','Altoona','Eau Claire',44.803255,-91.437029),('54721','WI','Arkansaw','Pepin',44.621879,-92.063033),('54722','WI','Augusta','Eau Claire',44.701461,-91.125183),('54723','WI','Bay City','Pierce',44.598881,-92.451516),('54724','WI','Bloomer','Chippewa',45.099013,-91.478128),('54725','WI','Boyceville','Dunn',45.074635,-92.02347),('54726','WI','Boyd','Chippewa',44.987715,-91.034757),('54727','WI','Cadott','Chippewa',44.95347,-91.160795),('54728','WI','Chetek','Barron',45.31308,-91.64449),('54729','WI','Chippewa Falls','Chippewa',44.934189,-91.389576),('54730','WI','Colfax','Dunn',45.022473,-91.745072),('54731','WI','Conrath','Rusk',45.351414,-91.055121),('54732','WI','Cornell','Chippewa',45.154492,-91.17174),('54733','WI','Dallas','Barron',45.277504,-91.837092),('54734','WI','Downing','Dunn',45.074809,-92.115503),('54735','WI','Downsville','Dunn',44.7747,-91.9319),('54736','WI','Durand','Pepin',44.612883,-91.924649),('54737','WI','Eau Galle','Dunn',44.721111,-91.995685),('54738','WI','Eleva','Eau Claire',44.57913,-91.474423),('54739','WI','Elk Mound','Dunn',44.870668,-91.688888),('54740','WI','Elmwood','Pierce',44.763851,-92.15087),('54741','WI','Fairchild','Eau Claire',44.609651,-90.983173),('54742','WI','Fall Creek','Eau Claire',44.766536,-91.286557),('54743','WI','Gilmanton','Buffalo',44.4708,-91.6758),('54745','WI','Holcombe','Chippewa',45.25009,-91.149274),('54746','WI','Humbird','Clark',44.533724,-90.88523),('54747','WI','Independence','Trempealeau',44.380758,-91.457209),('54748','WI','Jim Falls','Chippewa',45.066945,-91.24449),('54749','WI','Knapp','Dunn',44.947494,-92.09247),('54750','WI','Maiden Rock','Pierce',44.608216,-92.312032),('54751','WI','Menomonie','Dunn',44.865931,-91.924098),('54754','WI','Merrillan','Jackson',44.435726,-90.78463),('54755','WI','Mondovi','Buffalo',44.586921,-91.687089),('54756','WI','Nelson','Buffalo',44.457713,-91.973427),('54757','WI','New Auburn','Chippewa',45.22296,-91.552238),('54758','WI','Osseo','Trempealeau',44.537769,-91.226604),('54759','WI','Pepin','Pepin',44.475783,-92.124218),('54760','WI','Pigeon Falls','Trempealeau',44.423491,-91.208293),('54761','WI','Plum City','Pierce',44.628097,-92.185433),('54762','WI','Prairie Farm','Barron',45.24642,-91.993563),('54763','WI','Ridgeland','Dunn',45.180074,-91.888597),('54764','WI','Rock Falls','Dunn',44.7186,-91.6897),('54765','WI','Sand Creek','Dunn',45.169625,-91.685255),('54766','WI','Sheldon','Rusk',45.32461,-90.894679),('54767','WI','Spring Valley','Pierce',44.834142,-92.27013),('54768','WI','Stanley','Chippewa',44.956964,-90.927261),('54769','WI','Stockholm','Pepin',44.504348,-92.257467),('54770','WI','Strum','Trempealeau',44.54161,-91.3845),('54771','WI','Thorp','Clark',44.937239,-90.810624),('54772','WI','Wheeler','Dunn',45.078271,-91.892797),('54773','WI','Whitehall','Trempealeau',44.377746,-91.30783),('54774','WI','Chippewa Falls','Chippewa',44.9369,-91.3927),('54801','WI','Spooner','Washburn',45.863923,-91.937491),('54805','WI','Almena','Barron',45.412024,-92.023417),('54806','WI','Ashland','Ashland',46.578126,-90.885158),('54810','WI','Balsam Lake','Polk',45.455392,-92.393977),('54812','WI','Barron','Barron',45.395035,-91.865014),('54813','WI','Barronett','Barron',45.647932,-91.991928),('54814','WI','Bayfield','Bayfield',46.865073,-90.902182),('54816','WI','Benoit','Bayfield',46.5019,-91.0766),('54817','WI','Birchwood','Washburn',45.679198,-91.571765),('54818','WI','Brill','Barron',45.6027,-91.6719),('54819','WI','Bruce','Rusk',45.459439,-91.289422),('54820','WI','Brule','Douglas',46.565954,-91.563629),('54821','WI','Cable','Bayfield',46.216959,-91.166168),('54822','WI','Cameron','Barron',45.400393,-91.731279),('54824','WI','Centuria','Polk',45.461375,-92.537747),('54826','WI','Comstock','Barron',45.495241,-92.159669),('54827','WI','Cornucopia','Bayfield',46.824859,-91.11459),('54828','WI','Couderay','Sawyer',45.860704,-91.258584),('54829','WI','Cumberland','Barron',45.55338,-92.042398),('54830','WI','Danbury','Burnett',46.048697,-92.21723),('54832','WI','Drummond','Bayfield',46.326003,-91.299624),('54834','WI','Edgewater','Sawyer',45.742668,-91.476482),('54835','WI','Exeland','Sawyer',45.67342,-91.248201),('54836','WI','Foxboro','Douglas',46.47726,-92.214982),('54837','WI','Frederic','Polk',45.669717,-92.404281),('54838','WI','Gordon','Douglas',46.242808,-91.813295),('54839','WI','Grand View','Bayfield',46.360741,-91.143065),('54840','WI','Grantsburg','Burnett',45.751169,-92.671588),('54841','WI','Haugen','Barron',45.608502,-91.77742),('54842','WI','Hawthorne','Douglas',46.503212,-91.861001),('54843','WI','Hayward','Sawyer',45.994779,-91.331022),('54844','WI','Herbster','Bayfield',46.804784,-91.233188),('54845','WI','Hertel','Burnett',45.812268,-92.160771),('54846','WI','High Bridge','Ashland',46.382344,-90.734216),('54847','WI','Iron River','Bayfield',46.564848,-91.395046),('54848','WI','Ladysmith','Rusk',45.474511,-91.107943),('54849','WI','Lake Nebagamon','Douglas',46.497607,-91.706106),('54850','WI','La Pointe','Ashland',46.816314,-90.699702),('54853','WI','Luck','Polk',45.575903,-92.44716),('54854','WI','Maple','Douglas',46.633106,-91.689396),('54855','WI','Marengo','Ashland',46.396101,-90.833268),('54856','WI','Mason','Bayfield',46.442747,-91.129309),('54857','WI','Mikana','Barron',45.591678,-91.602133),('54858','WI','Milltown','Polk',45.512431,-92.480558),('54859','WI','Minong','Washburn',46.127359,-91.840618),('54861','WI','Odanah','Ashland',46.597111,-90.650718),('54862','WI','Ojibwa','Sawyer',45.793023,-91.131384),('54864','WI','Poplar','Douglas',46.589059,-91.807202),('54865','WI','Port Wing','Bayfield',46.75723,-91.394599),('54867','WI','Radisson','Sawyer',45.76489,-91.227701),('54868','WI','Rice Lake','Barron',45.509702,-91.731511),('54870','WI','Sarona','Washburn',45.711673,-91.78597),('54871','WI','Shell Lake','Washburn',45.728792,-91.993322),('54872','WI','Siren','Burnett',45.778991,-92.391929),('54873','WI','Solon Springs','Douglas',46.340445,-91.691759),('54874','WI','South Range','Douglas',46.590943,-91.929441),('54875','WI','Springbrook','Washburn',45.955158,-91.690564),('54876','WI','Stone Lake','Sawyer',45.827511,-91.501096),('54880','WI','Superior','Douglas',46.679034,-92.100956),('54888','WI','Trego','Washburn',45.967431,-91.878996),('54889','WI','Turtle Lake','Barron',45.407854,-92.164664),('54890','WI','Wascott','Douglas',46.1725,-91.798),('54891','WI','Washburn','Bayfield',46.694609,-90.935734),('54893','WI','Webster','Burnett',45.870979,-92.293657),('54895','WI','Weyerhaeuser','Rusk',45.420995,-91.423165),('54896','WI','Winter','Sawyer',45.842145,-90.943287),('54901','WI','Oshkosh','Winnebago',44.045791,-88.535851),('54902','WI','Oshkosh','Winnebago',43.98457,-88.550837),('54903','WI','Oshkosh','Winnebago',43.9959,-88.5635),('54904','WI','Oshkosh','Winnebago',44.023834,-88.610411),('54906','WI','Oshkosh','Winnebago',43.947,-88.5397),('54909','WI','Almond','Portage',44.280704,-89.367441),('54911','WI','Appleton','Outagamie',44.276734,-88.394602),('54912','WI','Appleton','Outagamie',44.2619,-88.4152),('54913','WI','Appleton','Outagamie',44.317952,-88.39723),('54914','WI','Appleton','Outagamie',44.265022,-88.440019),('54915','WI','Appleton','Outagamie',44.242758,-88.373263),('54919','WI','Appleton','Outagamie',44.2619,-88.4152),('54921','WI','Bancroft','Portage',44.309709,-89.549021),('54922','WI','Bear Creek','Outagamie',44.533847,-88.741462),('54923','WI','Berlin','Green Lake',43.976534,-88.954879),('54926','WI','Big Falls','Waupaca',44.6158,-89.0166),('54927','WI','Butte Des Morts','Winnebago',44.103128,-88.654369),('54928','WI','Caroline','Shawano',44.72801,-88.883894),('54929','WI','Clintonville','Waupaca',44.636478,-88.742073),('54930','WI','Coloma','Waushara',44.020011,-89.519947),('54931','WI','Dale','Outagamie',44.273561,-88.679423),('54932','WI','Eldorado','Fond Du Lac',43.830171,-88.625723),('54933','WI','Embarrass','Waupaca',44.667037,-88.707106),('54934','WI','Eureka','Winnebago',44.004464,-88.841021),('54935','WI','Fond Du Lac','Fond Du Lac',43.774762,-88.440225),('54936','WI','Fond Du Lac','Fond Du Lac',43.773,-88.4469),('54937','WI','Fond Du Lac','Fond Du Lac',43.79258,-88.458697),('54940','WI','Fremont','Waupaca',44.24325,-88.847214),('54941','WI','Green Lake','Green Lake',43.848666,-88.9757),('54942','WI','Greenville','Outagamie',44.295848,-88.530382),('54943','WI','Hancock','Waushara',44.13394,-89.572811),('54944','WI','Hortonville','Outagamie',44.334422,-88.624217),('54945','WI','Iola','Waupaca',44.555209,-89.141025),('54946','WI','King','Waupaca',44.337014,-89.145084),('54947','WI','Larsen','Winnebago',44.193455,-88.693163),('54948','WI','Leopolis','Shawano',44.778223,-88.85834),('54949','WI','Manawa','Waupaca',44.469913,-88.918953),('54950','WI','Marion','Waupaca',44.657218,-88.918064),('54952','WI','Menasha','Winnebago',44.212103,-88.402987),('54956','WI','Neenah','Winnebago',44.182763,-88.486684),('54957','WI','Neenah','Winnebago',44.1858,-88.4625),('54960','WI','Neshkoro','Marquette',43.955247,-89.223239),('54961','WI','New London','Waupaca',44.39706,-88.753354),('54962','WI','Ogdensburg','Waupaca',44.486188,-89.030971),('54963','WI','Omro','Winnebago',44.044425,-88.762245),('54964','WI','Pickett','Winnebago',43.927504,-88.719634),('54965','WI','Pine River','Waushara',44.167973,-89.043887),('54966','WI','Plainfield','Waushara',44.219799,-89.508419),('54967','WI','Poy Sippi','Waushara',44.134608,-88.998373),('54968','WI','Princeton','Green Lake',43.844119,-89.136984),('54969','WI','Readfield','Waupaca',44.2725,-88.7697),('54970','WI','Redgranite','Waushara',44.058699,-89.102888),('54971','WI','Ripon','Fond Du Lac',43.849425,-88.841187),('54974','WI','Rosendale','Fond Du Lac',43.796206,-88.665087),('54976','WI','Saxeville','Waushara',44.176716,-89.112715),('54977','WI','Scandinavia','Waupaca',44.456438,-89.15945),('54978','WI','Tilleda','Shawano',44.805167,-88.900604),('54979','WI','Van Dyne','Fond Du Lac',43.876268,-88.52565),('54980','WI','Waukau','Winnebago',43.987364,-88.771466),('54981','WI','Waupaca','Waupaca',44.331766,-89.113088),('54982','WI','Wautoma','Waushara',44.064356,-89.288654),('54983','WI','Weyauwega','Waupaca',44.320969,-88.926741),('54984','WI','Wild Rose','Waushara',44.186201,-89.202422),('54985','WI','Winnebago','Winnebago',44.075362,-88.517882),('54986','WI','Winneconne','Winnebago',44.118442,-88.72709),('54990','WI','Iola','Waupaca',44.5606,-89.1531),('55001','MN','Afton','Washington',44.909707,-92.819075),('55002','MN','Almelund','Chisago',45.4913,-92.7852),('55003','MN','Bayport','Washington',45.017892,-92.781384),('55005','MN','Bethel','Anoka',45.393778,-93.236103),('55006','MN','Braham','Isanti',45.730413,-93.194708),('55007','MN','Brook Park','Kanabec',45.959772,-93.119076),('55008','MN','Cambridge','Isanti',45.566817,-93.243811),('55009','MN','Cannon Falls','Goodhue',44.492885,-92.892157),('55010','MN','Castle Rock','Dakota',44.544465,-93.153539),('55011','MN','Cedar','Anoka',45.339957,-93.2678),('55012','MN','Center City','Chisago',45.416885,-92.806832),('55013','MN','Chisago City','Chisago',45.369547,-92.896092),('55014','MN','Circle Pines','Anoka',45.158403,-93.13916),('55016','MN','Cottage Grove','Washington',44.826482,-92.937179),('55017','MN','Dalbo','Isanti',45.673102,-93.422531),('55018','MN','Dennison','Goodhue',44.423179,-93.001277),('55019','MN','Dundas','Rice',44.418239,-93.219974),('55020','MN','Elko','Scott',44.579036,-93.355927),('55021','MN','Faribault','Rice',44.296116,-93.290127),('55024','MN','Farmington','Dakota',44.648686,-93.151072),('55025','MN','Forest Lake','Washington',45.269018,-92.992518),('55026','MN','Frontenac','Goodhue',44.516343,-92.337264),('55027','MN','Goodhue','Goodhue',44.408877,-92.631291),('55029','MN','Grandy','Isanti',45.637185,-93.195329),('55030','MN','Grasston','Pine',45.826493,-93.124543),('55031','MN','Hampton','Dakota',44.613983,-92.985405),('55032','MN','Harris','Chisago',45.584868,-92.997915),('55033','MN','Hastings','Dakota',44.732736,-92.861482),('55036','MN','Henriette','Pine',45.869911,-93.118824),('55037','MN','Hinckley','Pine',46.004429,-92.809964),('55038','MN','Hugo','Washington',45.165993,-93.003332),('55040','MN','Isanti','Isanti',45.468957,-93.279973),('55041','MN','Lake City','Wabasha',44.426716,-92.290659),('55042','MN','Lake Elmo','Washington',44.996181,-92.901536),('55043','MN','Lakeland','Washington',44.936542,-92.768301),('55044','MN','Lakeville','Dakota',44.673718,-93.260615),('55045','MN','Lindstrom','Chisago',45.386118,-92.842449),('55046','MN','Lonsdale','Rice',44.467277,-93.420534),('55047','MN','Marine On Saint Croix','Washington',45.200486,-92.813992),('55049','MN','Medford','Steele',44.170229,-93.241649),('55051','MN','Mora','Kanabec',45.905532,-93.296994),('55052','MN','Morristown','Rice',44.234711,-93.437352),('55053','MN','Nerstrand','Rice',44.346587,-93.061282),('55054','MN','New Market','Scott',44.571699,-93.351921),('55055','MN','Newport','Washington',44.87356,-93.001985),('55056','MN','North Branch','Chisago',45.51068,-92.971261),('55057','MN','Northfield','Rice',44.466212,-93.169195),('55060','MN','Owatonna','Steele',44.076316,-93.227281),('55063','MN','Pine City','Pine',45.824785,-92.957995),('55065','MN','Randolph','Dakota',44.531134,-93.01133),('55066','MN','Red Wing','Goodhue',44.547725,-92.540017),('55067','MN','Rock Creek','Pine',45.7536,-92.9288),('55068','MN','Rosemount','Dakota',44.738579,-93.124288),('55069','MN','Rush City','Chisago',45.690491,-92.967441),('55070','MN','Saint Francis','Anoka',45.39601,-93.370034),('55071','MN','Saint Paul Park','Washington',44.837554,-92.990227),('55072','MN','Sandstone','Pine',46.115475,-92.719702),('55073','MN','Scandia','Washington',45.276262,-92.830353),('55074','MN','Shafer','Chisago',45.380027,-92.728702),('55075','MN','South Saint Paul','Dakota',44.886227,-93.044292),('55076','MN','Inver Grove Heights','Dakota',44.845411,-93.035351),('55077','MN','Inver Grove Heights','Dakota',44.829117,-93.071483),('55078','MN','Stacy','Chisago',45.3999,-93.015),('55079','MN','Stacy','Chisago',45.404336,-93.026729),('55080','MN','Stanchfield','Isanti',45.657548,-93.203959),('55082','MN','Stillwater','Washington',45.057064,-92.833159),('55083','MN','Stillwater','Washington',45.0563,-92.8058),('55084','MN','Taylors Falls','Chisago',45.435162,-92.677065),('55085','MN','Vermillion','Dakota',44.67416,-92.968164),('55087','MN','Warsaw','Rice',44.249037,-93.394726),('55088','MN','Webster','Rice',44.532665,-93.376128),('55089','MN','Welch','Goodhue',44.593268,-92.709011),('55090','MN','Willernie','Washington',45.054233,-92.95732),('55092','MN','Wyoming','Chisago',45.335812,-93.059919),('55101','MN','Saint Paul','Ramsey',44.951483,-93.090649),('55102','MN','Saint Paul','Ramsey',44.934571,-93.120447),('55103','MN','Saint Paul','Ramsey',44.962505,-93.122542),('55104','MN','Saint Paul','Ramsey',44.95395,-93.159362),('55105','MN','Saint Paul','Ramsey',44.934707,-93.165751),('55106','MN','Saint Paul','Ramsey',44.967468,-93.050106),('55107','MN','Saint Paul','Ramsey',44.928355,-93.087339),('55108','MN','Saint Paul','Ramsey',44.982515,-93.179693),('55109','MN','Saint Paul','Ramsey',45.012016,-93.022233),('55110','MN','Saint Paul','Ramsey',45.081748,-93.008997),('55111','MN','Saint Paul','Hennepin',44.8866,-93.1969),('55112','MN','Saint Paul','Ramsey',45.077495,-93.199721),('55113','MN','Saint Paul','Ramsey',45.011173,-93.155474),('55114','MN','Saint Paul','Ramsey',44.964228,-93.196638),('55115','MN','Saint Paul','Washington',45.05793,-92.958002),('55116','MN','Saint Paul','Ramsey',44.912988,-93.170799),('55117','MN','Saint Paul','Ramsey',44.990449,-93.104745),('55118','MN','Saint Paul','Dakota',44.902906,-93.10026),('55119','MN','Saint Paul','Ramsey',44.954677,-93.006452),('55120','MN','Saint Paul','Dakota',44.870691,-93.145701),('55121','MN','Saint Paul','Dakota',44.849766,-93.144961),('55122','MN','Saint Paul','Dakota',44.802828,-93.198847),('55123','MN','Saint Paul','Dakota',44.803781,-93.134746),('55124','MN','Saint Paul','Dakota',44.742835,-93.202063),('55125','MN','Saint Paul','Washington',44.923564,-92.946967),('55126','MN','Saint Paul','Ramsey',45.085674,-93.134938),('55127','MN','Saint Paul','Ramsey',45.075831,-93.082972),('55128','MN','Saint Paul','Washington',44.986396,-92.965613),('55129','MN','Saint Paul','Washington',44.913923,-92.896451),('55130','MN','Saint Paul','Ramsey',44.972403,-93.082416),('55133','MN','Saint Paul','Ramsey',44.9444,-93.093),('55144','MN','Saint Paul','Ramsey',44.9444,-93.093),('55145','MN','Saint Paul','Ramsey',44.9444,-93.093),('55146','MN','Saint Paul','Ramsey',44.9444,-93.093),('55150','MN','Mendota','Dakota',44.884889,-93.164374),('55155','MN','Saint Paul','Ramsey',44.954,-93.1023),('55161','MN','Saint Paul','Ramsey',45.0136,-93.1567),('55164','MN','Saint Paul','Ramsey',44.9466,-93.087),('55165','MN','Saint Paul','Ramsey',44.9466,-93.087),('55166','MN','Saint Paul','Ramsey',44.9466,-93.087),('55168','MN','Saint Paul','Ramsey',44.9444,-93.093),('55169','MN','Saint Paul','Ramsey',44.9444,-93.093),('55170','MN','Saint Paul','Ramsey',44.9444,-93.093),('55171','MN','Saint Paul','Ramsey',44.9444,-93.093),('55172','MN','Saint Paul','Ramsey',44.9466,-93.087),('55175','MN','Saint Paul','Ramsey',44.9466,-93.087),('55177','MN','Saint Paul','Ramsey',45.0136,-93.1567),('55187','MN','Saint Paul','Ramsey',44.9445,-93.0932),('55188','MN','Saint Paul','Ramsey',44.9453,-92.9105),('55191','MN','Saint Paul','Ramsey',45.076,-93.1901),('55301','MN','Albertville','Wright',45.239504,-93.659132),('55302','MN','Annandale','Wright',45.251977,-94.132521),('55303','MN','Anoka','Anoka',45.246249,-93.412415),('55304','MN','Andover','Anoka',45.252257,-93.287957),('55305','MN','Hopkins','Hennepin',44.952248,-93.433481),('55306','MN','Burnsville','Dakota',44.732469,-93.289784),('55307','MN','Arlington','Sibley',44.608077,-94.089428),('55308','MN','Becker','Sherburne',45.416002,-93.85429),('55309','MN','Big Lake','Sherburne',45.358176,-93.742146),('55310','MN','Bird Island','Renville',44.766797,-94.883398),('55311','MN','Osseo','Hennepin',45.096451,-93.490293),('55312','MN','Brownton','Mcleod',44.711182,-94.345641),('55313','MN','Buffalo','Wright',45.174591,-93.856816),('55314','MN','Buffalo Lake','Renville',44.753192,-94.607752),('55315','MN','Carver','Carver',44.739902,-93.661771),('55316','MN','Champlin','Hennepin',45.171589,-93.38477),('55317','MN','Chanhassen','Carver',44.861051,-93.549238),('55318','MN','Chaska','Carver',44.814434,-93.615969),('55319','MN','Clear Lake','Sherburne',45.471792,-93.95229),('55320','MN','Clearwater','Wright',45.395403,-94.06697),('55321','MN','Cokato','Wright',45.089561,-94.187341),('55322','MN','Cologne','Carver',44.775827,-93.781013),('55323','MN','Crystal Bay','Hennepin',44.9535,-93.576),('55324','MN','Darwin','Meeker',45.059865,-94.419149),('55325','MN','Dassel','Meeker',45.092619,-94.315667),('55327','MN','Dayton','Hennepin',45.21515,-93.476177),('55328','MN','Delano','Wright',45.033235,-93.794272),('55329','MN','Eden Valley','Stearns',45.304542,-94.558937),('55330','MN','Elk River','Sherburne',45.317733,-93.57212),('55331','MN','Excelsior','Hennepin',44.899792,-93.586997),('55332','MN','Fairfax','Renville',44.523686,-94.714818),('55333','MN','Franklin','Renville',44.541915,-94.873289),('55334','MN','Gaylord','Sibley',44.552638,-94.215643),('55335','MN','Gibbon','Sibley',44.533796,-94.54417),('55336','MN','Glencoe','Mcleod',44.775511,-94.165767),('55337','MN','Burnsville','Dakota',44.769635,-93.276489),('55338','MN','Green Isle','Sibley',44.676694,-94.006579),('55339','MN','Hamburg','Carver',44.730729,-93.957944),('55340','MN','Hamel','Hennepin',45.069302,-93.562139),('55341','MN','Hanover','Wright',45.157963,-93.662899),('55342','MN','Hector','Renville',44.744502,-94.723878),('55343','MN','Hopkins','Hennepin',44.919317,-93.411107),('55344','MN','Eden Prairie','Hennepin',44.862972,-93.43362),('55345','MN','Minnetonka','Hennepin',44.916835,-93.4842),('55346','MN','Eden Prairie','Hennepin',44.879803,-93.486811),('55347','MN','Eden Prairie','Hennepin',44.838136,-93.467017),('55348','MN','Maple Plain','Hennepin',45.0079,-93.6542),('55349','MN','Howard Lake','Wright',45.061012,-94.071511),('55350','MN','Hutchinson','Mcleod',44.894865,-94.384179),('55352','MN','Jordan','Scott',44.66612,-93.611195),('55353','MN','Kimball','Stearns',45.325042,-94.304349),('55354','MN','Lester Prairie','Mcleod',44.88183,-94.049778),('55355','MN','Litchfield','Meeker',45.107218,-94.527372),('55356','MN','Long Lake','Hennepin',44.985506,-93.583911),('55357','MN','Loretto','Hennepin',45.089097,-93.650645),('55358','MN','Maple Lake','Wright',45.246914,-93.998625),('55359','MN','Maple Plain','Hennepin',45.010024,-93.686488),('55360','MN','Mayer','Carver',44.898239,-93.903986),('55361','MN','Minnetonka Beach','Hennepin',44.9404,-93.597),('55362','MN','Monticello','Wright',45.299115,-93.800242),('55363','MN','Montrose','Wright',45.058232,-93.913658),('55364','MN','Mound','Hennepin',44.935573,-93.658561),('55365','MN','Monticello','Wright',45.3055,-93.7938),('55366','MN','New Auburn','Sibley',44.672825,-94.230352),('55367','MN','New Germany','Carver',44.892914,-93.973042),('55368','MN','Norwood','Carver',44.753026,-93.916618),('55369','MN','Osseo','Hennepin',45.120461,-93.433734),('55370','MN','Plato','Mcleod',44.78083,-94.041717),('55371','MN','Princeton','Mille Lacs',45.575625,-93.575462),('55372','MN','Prior Lake','Scott',44.705315,-93.421796),('55373','MN','Rockford','Wright',45.088141,-93.734355),('55374','MN','Rogers','Hennepin',45.193708,-93.562312),('55375','MN','Saint Bonifacius','Hennepin',44.901736,-93.746533),('55376','MN','Saint Michael','Wright',45.209594,-93.661921),('55377','MN','Santiago','Sherburne',45.4513,-93.8337),('55378','MN','Savage','Scott',44.755681,-93.359082),('55379','MN','Shakopee','Scott',44.775325,-93.499391),('55380','MN','Silver Creek','Wright',45.3284,-93.958),('55381','MN','Silver Lake','Mcleod',44.909155,-94.196083),('55382','MN','South Haven','Stearns',45.295439,-94.209692),('55383','MN','Norwood','Carver',44.768,-93.9272),('55384','MN','Spring Park','Hennepin',44.935929,-93.630188),('55385','MN','Stewart','Mcleod',44.740897,-94.486431),('55386','MN','Victoria','Carver',44.858241,-93.661592),('55387','MN','Waconia','Carver',44.851259,-93.785297),('55388','MN','Watertown','Carver',44.955086,-93.845023),('55389','MN','Watkins','Meeker',45.285969,-94.437391),('55390','MN','Waverly','Wright',45.066466,-93.972021),('55391','MN','Wayzata','Hennepin',44.961035,-93.533981),('55392','MN','Navarre','Hennepin',44.9345,-93.6099),('55393','MN','Maple Plain','Wright',45.0079,-93.6542),('55394','MN','Young America','Carver',44.7827,-93.9133),('55395','MN','Winsted','Mcleod',44.956933,-94.052832),('55396','MN','Winthrop','Sibley',44.536806,-94.363693),('55397','MN','Young America','Carver',44.798625,-93.918557),('55398','MN','Zimmerman','Sherburne',45.45738,-93.594087),('55399','MN','Young America','Carver',44.7827,-93.9133),('55401','MN','Minneapolis','Hennepin',44.985367,-93.270208),('55402','MN','Minneapolis','Hennepin',44.975517,-93.270608),('55403','MN','Minneapolis','Hennepin',44.97057,-93.284032),('55404','MN','Minneapolis','Hennepin',44.962267,-93.261817),('55405','MN','Minneapolis','Hennepin',44.969842,-93.30218),('55406','MN','Minneapolis','Hennepin',44.93869,-93.221042),('55407','MN','Minneapolis','Hennepin',44.936843,-93.254312),('55408','MN','Minneapolis','Hennepin',44.945675,-93.287492),('55409','MN','Minneapolis','Hennepin',44.929575,-93.281162),('55410','MN','Minneapolis','Hennepin',44.913363,-93.319493),('55411','MN','Minneapolis','Hennepin',44.999184,-93.299945),('55412','MN','Minneapolis','Hennepin',45.027476,-93.303546),('55413','MN','Minneapolis','Hennepin',44.99781,-93.250536),('55414','MN','Minneapolis','Hennepin',44.981795,-93.230465),('55415','MN','Minneapolis','Hennepin',44.974689,-93.259882),('55416','MN','Minneapolis','Hennepin',44.946877,-93.342262),('55417','MN','Minneapolis','Hennepin',44.904405,-93.235501),('55418','MN','Minneapolis','Hennepin',45.019498,-93.243002),('55419','MN','Minneapolis','Hennepin',44.906994,-93.287065),('55420','MN','Minneapolis','Hennepin',44.841621,-93.276523),('55421','MN','Minneapolis','Anoka',45.050884,-93.253812),('55422','MN','Minneapolis','Hennepin',45.014236,-93.339527),('55423','MN','Minneapolis','Hennepin',44.877197,-93.280079),('55424','MN','Minneapolis','Hennepin',44.906206,-93.338561),('55425','MN','Minneapolis','Hennepin',44.844781,-93.245869),('55426','MN','Minneapolis','Hennepin',44.952156,-93.37784),('55427','MN','Minneapolis','Hennepin',45.005956,-93.382157),('55428','MN','Minneapolis','Hennepin',45.059908,-93.378572),('55429','MN','Minneapolis','Hennepin',45.063552,-93.341097),('55430','MN','Minneapolis','Hennepin',45.061126,-93.300749),('55431','MN','Minneapolis','Hennepin',44.829492,-93.309931),('55432','MN','Minneapolis','Anoka',45.096587,-93.254518),('55433','MN','Minneapolis','Anoka',45.1606,-93.313204),('55434','MN','Minneapolis','Anoka',45.163716,-93.250487),('55435','MN','Minneapolis','Hennepin',44.8758,-93.334926),('55436','MN','Minneapolis','Hennepin',44.904105,-93.370159),('55437','MN','Minneapolis','Hennepin',44.822972,-93.344341),('55438','MN','Minneapolis','Hennepin',44.827456,-93.380301),('55439','MN','Minneapolis','Hennepin',44.877142,-93.371431),('55440','MN','Minneapolis','Hennepin',44.9832,-93.2647),('55441','MN','Minneapolis','Hennepin',45.002433,-93.42317),('55442','MN','Minneapolis','Hennepin',45.047806,-93.428334),('55443','MN','Minneapolis','Hennepin',45.119513,-93.339002),('55444','MN','Minneapolis','Hennepin',45.104855,-93.303996),('55445','MN','Minneapolis','Hennepin',45.116967,-93.375441),('55446','MN','Minneapolis','Hennepin',45.039712,-93.480536),('55447','MN','Minneapolis','Hennepin',45.001096,-93.489561),('55448','MN','Minneapolis','Anoka',45.185741,-93.303218),('55449','MN','Minneapolis','Anoka',45.168345,-93.206646),('55450','MN','Minneapolis','Hennepin',44.879528,-93.224307),('55454','MN','Minneapolis','Hennepin',44.969263,-93.243216),('55455','MN','Minneapolis','Hennepin',44.972992,-93.231008),('55458','MN','Minneapolis','Hennepin',44.9832,-93.2647),('55459','MN','Minneapolis','Hennepin',44.9832,-93.2647),('55460','MN','Minneapolis','Hennepin',44.98,-93.2636),('55467','MN','Minneapolis','Hennepin',44.98,-93.2638),('55468','MN','Minneapolis','Hennepin',44.98,-93.2636),('55470','MN','Minneapolis','Hennepin',44.9832,-93.2647),('55472','MN','Minneapolis','Hennepin',44.98,-93.2636),('55473','MN','Minneapolis','Carver',44.7827,-93.9133),('55474','MN','Minneapolis','Hennepin',44.9767,-93.2682),('55478','MN','Minneapolis','Hennepin',44.9832,-93.2647),('55479','MN','Minneapolis','Hennepin',44.98,-93.2636),('55480','MN','Minneapolis','Hennepin',44.9832,-93.2647),('55483','MN','Minneapolis','Hennepin',44.98,-93.2636),('55484','MN','Minneapolis','Hennepin',44.98,-93.2636),('55485','MN','Minneapolis','Hennepin',44.9832,-93.2647),('55486','MN','Minneapolis','Hennepin',44.98,-93.2636),('55487','MN','Minneapolis','Hennepin',44.98,-93.2636),('55488','MN','Minneapolis','Hennepin',44.9758,-93.262),('55550','MN','Young America','Carver',44.7827,-93.9133),('55551','MN','Young America','Carver',44.7827,-93.9133),('55552','MN','Young America','Carver',44.7827,-93.9133),('55553','MN','Young America','Carver',44.7827,-93.9133),('55554','MN','Norwood','Carver',44.7827,-93.9133),('55555','MN','Young America','Carver',44.7827,-93.9133),('55556','MN','Young America','Carver',44.7827,-93.9133),('55557','MN','Young America','Carver',44.7827,-93.9133),('55558','MN','Young America','Carver',44.7827,-93.9133),('55559','MN','Young America','Carver',44.7827,-93.9133),('55560','MN','Young America','Carver',44.7827,-93.9133),('55561','MN','Monticello','Carver',45.2797,-93.8097),('55562','MN','Young America','Carver',44.7827,-93.9133),('55563','MN','Monticello','Carver',45.2797,-93.8097),('55564','MN','Young America','Carver',44.7827,-93.9133),('55565','MN','Monticello','Wright',45.3055,-93.7938),('55566','MN','Young America','Carver',44.7827,-93.9133),('55567','MN','Young America','Carver',44.7827,-93.9133),('55568','MN','Young America','Carver',44.7827,-93.9133),('55569','MN','Osseo','Hennepin',45.0479,-93.4267),('55570','MN','Maple Plain','Hennepin',45.0079,-93.6542),('55571','MN','Maple Plain','Hennepin',45.0079,-93.6542),('55572','MN','Rockford','Hennepin',45.0079,-93.6542),('55573','MN','Young America','Hennepin',44.8148,-93.921),('55574','MN','Maple Plain','Hennepin',45.0079,-93.6542),('55575','MN','Howard Lake','Hennepin',44.9919,-93.7146),('55576','MN','Maple Plain','Hennepin',45.0079,-93.6542),('55577','MN','Rockford','Hennepin',45.0079,-93.6542),('55578','MN','Maple Plain','Hennepin',45.0079,-93.6542),('55579','MN','Maple Plain','Hennepin',45.0079,-93.6542),('55580','MN','Monticello','Wright',45.3055,-93.7938),('55581','MN','Monticello','Wright',45.3055,-93.7938),('55582','MN','Monticello','Wright',45.3055,-93.7938),('55583','MN','Norwood','Carver',44.768,-93.9272),('55584','MN','Monticello','Wright',45.3055,-93.7938),('55585','MN','Monticello','Wright',45.3055,-93.7938),('55586','MN','Monticello','Wright',45.3055,-93.7938),('55587','MN','Monticello','Wright',45.3055,-93.7938),('55588','MN','Monticello','Wright',45.3055,-93.7938),('55589','MN','Monticello','Wright',45.3055,-93.7938),('55590','MN','Monticello','Wright',45.3055,-93.7938),('55591','MN','Monticello','Wright',45.3055,-93.7938),('55592','MN','Maple Plain','Wright',45.0079,-93.6542),('55593','MN','Maple Plain','Hennepin',45.0079,-93.6542),('55594','MN','Young America','Carver',44.7827,-93.9133),('55595','MN','Loretto','Hennepin',45.1083,-93.6673),('55596','MN','Loretto','Hennepin',45.1083,-93.6673),('55597','MN','Loretto','Hennepin',45.1083,-93.6673),('55598','MN','Loretto','Hennepin',45.1083,-93.6673),('55599','MN','Loretto','Hennepin',45.0612,-93.6638),('55601','MN','Beaver Bay','Lake',47.270129,-91.305616),('55602','MN','Brimson','St. Louis',47.322698,-91.855336),('55603','MN','Finland','Lake',47.550775,-91.206393),('55604','MN','Grand Marais','Cook',47.936563,-90.633743),('55605','MN','Grand Portage','Cook',47.957994,-89.69266),('55606','MN','Hovland','Cook',47.942152,-90.017745),('55607','MN','Isabella','Lake',47.652017,-91.485215),('55609','MN','Knife River','Lake',46.952216,-91.785535),('55612','MN','Lutsen','Cook',47.740201,-90.683197),('55613','MN','Schroeder','Cook',47.570287,-90.96581),('55614','MN','Silver Bay','Lake',47.329051,-91.31463),('55615','MN','Tofte','Cook',47.746544,-90.85118),('55616','MN','Two Harbors','Lake',47.109796,-91.670673),('55701','MN','Adolph','Saint Louis',46.841,-92.2201),('55702','MN','Alborn','St. Louis',46.956045,-92.64124),('55703','MN','Angora','St. Louis',47.730884,-92.750096),('55704','MN','Askov','Pine',46.208505,-92.793066),('55705','MN','Aurora','St. Louis',47.492688,-92.242834),('55706','MN','Babbitt','St. Louis',47.72534,-91.942454),('55707','MN','Barnum','Carlton',46.53751,-92.62483),('55708','MN','Biwabik','St. Louis',47.538571,-92.337251),('55709','MN','Bovey','Itasca',47.370877,-93.38259),('55710','MN','Britt','St. Louis',47.633729,-92.68859),('55711','MN','Brookston','St. Louis',46.846803,-92.656053),('55712','MN','Bruno','Pine',46.268746,-92.590639),('55713','MN','Buhl','St. Louis',47.492203,-92.776459),('55716','MN','Calumet','Itasca',47.321257,-93.27439),('55717','MN','Canyon','St. Louis',47.053876,-92.439691),('55718','MN','Carlton','Carlton',46.649491,-92.484783),('55719','MN','Chisholm','St. Louis',47.503661,-92.880556),('55720','MN','Cloquet','Carlton',46.7271,-92.473196),('55721','MN','Cohasset','Itasca',47.235145,-93.657552),('55722','MN','Coleraine','Itasca',47.285036,-93.432738),('55723','MN','Cook','St. Louis',47.851338,-92.808597),('55724','MN','Cotton','St. Louis',47.171086,-92.410153),('55725','MN','Crane Lake','St. Louis',48.203886,-92.383016),('55726','MN','Cromwell','Carlton',46.668784,-92.860051),('55730','MN','Grand Rapids','Itasca',47.2378,-93.53),('55731','MN','Ely','St. Louis',47.927898,-91.779819),('55732','MN','Embarrass','St. Louis',47.651228,-92.215911),('55733','MN','Esko','Carlton',46.707705,-92.361663),('55734','MN','Eveleth','St. Louis',47.420984,-92.51155),('55735','MN','Finlayson','Pine',46.209815,-92.97291),('55736','MN','Floodwood','St. Louis',46.94372,-92.912681),('55738','MN','Forbes','St. Louis',47.291777,-92.664859),('55741','MN','Gilbert','St. Louis',47.476819,-92.417514),('55742','MN','Goodland','Itasca',47.204293,-93.136731),('55744','MN','Grand Rapids','Itasca',47.239686,-93.515297),('55745','MN','Grand Rapids','Itasca',47.2372,-93.53),('55746','MN','Hibbing','St. Louis',47.406699,-92.94057),('55747','MN','Hibbing','Saint Louis',47.4272,-92.9375),('55748','MN','Hill City','Aitkin',46.989447,-93.5938),('55749','MN','Holyoke','Carlton',46.439223,-92.439329),('55750','MN','Hoyt Lakes','St. Louis',47.517135,-92.068734),('55751','MN','Iron','St. Louis',47.407674,-92.631405),('55752','MN','Jacobson','Aitkin',46.963864,-93.290274),('55753','MN','Keewatin','Itasca',47.396306,-93.078572),('55756','MN','Kerrick','Pine',46.369497,-92.597626),('55757','MN','Kettle River','Carlton',46.50841,-92.922818),('55758','MN','Kinney','St. Louis',47.513706,-92.731458),('55760','MN','Mcgregor','Aitkin',46.677525,-93.283638),('55763','MN','Makinen','St. Louis',47.32784,-92.177421),('55764','MN','Marble','Itasca',47.321376,-93.30206),('55765','MN','Meadowlands','St. Louis',47.087516,-92.741649),('55766','MN','Melrude','St. Louis',47.25763,-92.442606),('55767','MN','Moose Lake','Carlton',46.451415,-92.761126),('55768','MN','Mountain Iron','St. Louis',47.494034,-92.667446),('55769','MN','Nashwauk','Itasca',47.443037,-93.189683),('55771','MN','Orr','St. Louis',48.132096,-92.8175),('55772','MN','Nett Lake','Koochiching',48.094304,-93.119798),('55775','MN','Pengilly','Itasca',47.321124,-93.177922),('55777','MN','Virginia','Saint Louis',47.6165,-92.4421),('55779','MN','Saginaw','St. Louis',46.908849,-92.448827),('55780','MN','Sawyer','Carlton',46.669534,-92.689789),('55781','MN','Side Lake','St. Louis',47.669455,-93.033039),('55782','MN','Soudan','St. Louis',47.815567,-92.227467),('55783','MN','Sturgeon Lake','Pine',46.381678,-92.812057),('55784','MN','Swan River','Itasca',47.058152,-93.203511),('55785','MN','Swatara','Aitkin',46.922035,-93.731344),('55786','MN','Taconite','Itasca',47.312025,-93.38796),('55787','MN','Tamarack','Aitkin',46.678418,-93.102978),('55790','MN','Tower','St. Louis',47.856852,-92.307505),('55791','MN','Twig','Saint Louis',46.7684,-92.1288),('55792','MN','Virginia','St. Louis',47.53578,-92.537852),('55793','MN','Warba','Itasca',47.116282,-93.26867),('55795','MN','Willow River','Pine',46.316553,-92.838679),('55796','MN','Winton','Saint Louis',47.930468,-91.799439),('55797','MN','Wrenshall','Carlton',46.593622,-92.382538),('55798','MN','Wright','Carlton',46.723256,-92.967783),('55801','MN','Duluth','Saint Louis',47.0775,-91.859),('55802','MN','Duluth','St. Louis',46.781312,-92.099031),('55803','MN','Duluth','St. Louis',46.961041,-92.099606),('55804','MN','Duluth','St. Louis',46.859246,-91.98595),('55805','MN','Duluth','St. Louis',46.799409,-92.09469),('55806','MN','Duluth','St. Louis',46.771299,-92.126116),('55807','MN','Duluth','St. Louis',46.739331,-92.169953),('55808','MN','Duluth','St. Louis',46.677086,-92.231552),('55810','MN','Duluth','St. Louis',46.74206,-92.248995),('55811','MN','Duluth','St. Louis',46.815905,-92.176602),('55812','MN','Duluth','St. Louis',46.809946,-92.073681),('55814','MN','Duluth','St. Louis',46.83506,-92.197706),('55815','MN','Duluth','Saint Louis',46.8197,-92.2595),('55816','MN','Duluth','Saint Louis',46.7596,-92.132),('55901','MN','Rochester','Olmsted',44.052945,-92.501388),('55902','MN','Rochester','Olmsted',43.991169,-92.491688),('55903','MN','Rochester','Olmsted',44.0216,-92.4627),('55904','MN','Rochester','Olmsted',43.983005,-92.426367),('55905','MN','Rochester','Olmsted',44.0213,-92.4671),('55906','MN','Rochester','Olmsted',44.064189,-92.438746),('55909','MN','Adams','Mower',43.565986,-92.726152),('55910','MN','Altura','Winona',44.128407,-91.959718),('55912','MN','Austin','Mower',43.674478,-92.980658),('55917','MN','Blooming Prairie','Steele',43.881564,-93.061991),('55918','MN','Brownsdale','Mower',43.740027,-92.859309),('55919','MN','Brownsville','Houston',43.618519,-91.271025),('55920','MN','Byron','Olmsted',44.024796,-92.627882),('55921','MN','Caledonia','Houston',43.632521,-91.482998),('55922','MN','Canton','Fillmore',43.555004,-91.919721),('55923','MN','Chatfield','Fillmore',43.845397,-92.171543),('55924','MN','Claremont','Dodge',44.043494,-93.006034),('55925','MN','Dakota','Winona',43.914663,-91.407675),('55926','MN','Dexter','Mower',43.732186,-92.708751),('55927','MN','Dodge Center','Dodge',44.040504,-92.859171),('55929','MN','Dover','Olmsted',43.975308,-92.142311),('55931','MN','Eitzen','Houston',43.521304,-91.414231),('55932','MN','Elgin','Wabasha',44.132611,-92.26624),('55933','MN','Elkton','Mower',43.652021,-92.694394),('55934','MN','Eyota','Olmsted',43.996092,-92.256081),('55935','MN','Fountain','Fillmore',43.753752,-92.121469),('55936','MN','Grand Meadow','Mower',43.717078,-92.577693),('55939','MN','Harmony','Fillmore',43.551268,-92.049801),('55940','MN','Hayfield','Dodge',43.899441,-92.808853),('55941','MN','Hokah','Houston',43.749589,-91.357252),('55942','MN','Homer','Winona',44.0213,-91.5563),('55943','MN','Houston','Houston',43.77038,-91.573152),('55944','MN','Kasson','Dodge',44.016789,-92.744092),('55945','MN','Kellogg','Wabasha',44.281154,-92.052474),('55946','MN','Kenyon','Goodhue',44.269149,-92.971437),('55947','MN','La Crescent','Houston',43.824782,-91.331491),('55949','MN','Lanesboro','Fillmore',43.702995,-91.940599),('55950','MN','Lansing','Mower',43.7451,-92.969291),('55951','MN','Le Roy','Mower',43.529039,-92.498701),('55952','MN','Lewiston','Winona',43.957953,-91.850494),('55953','MN','Lyle','Mower',43.521538,-92.96332),('55954','MN','Mabel','Fillmore',43.557063,-91.780104),('55955','MN','Mantorville','Dodge',44.076921,-92.753081),('55956','MN','Mazeppa','Wabasha',44.27035,-92.530752),('55957','MN','Millville','Wabasha',44.270316,-92.275497),('55959','MN','Minnesota City','Winona',44.096513,-91.752306),('55960','MN','Oronoco','Olmsted',44.146803,-92.537548),('55961','MN','Ostrander','Fillmore',43.609009,-92.464396),('55962','MN','Peterson','Fillmore',43.773606,-91.845696),('55963','MN','Pine Island','Goodhue',44.196188,-92.650682),('55964','MN','Plainview','Wabasha',44.165494,-92.158581),('55965','MN','Preston','Fillmore',43.638883,-92.125814),('55967','MN','Racine','Mower',43.795188,-92.516771),('55968','MN','Reads Landing','Wabasha',44.401503,-92.078663),('55969','MN','Rollingstone','Winona',44.082795,-91.855986),('55970','MN','Rose Creek','Mower',43.606651,-92.829567),('55971','MN','Rushford','Fillmore',43.812243,-91.750854),('55972','MN','Saint Charles','Winona',43.978251,-92.060047),('55973','MN','Sargeant','Mower',43.812257,-92.779877),('55974','MN','Spring Grove','Houston',43.577122,-91.647985),('55975','MN','Spring Valley','Fillmore',43.690499,-92.380675),('55976','MN','Stewartville','Olmsted',43.861445,-92.490819),('55977','MN','Taopi','Mower',43.558572,-92.643411),('55979','MN','Utica','Winona',43.932571,-91.950204),('55981','MN','Wabasha','Wabasha',44.367104,-92.034474),('55982','MN','Waltham','Mower',43.821479,-92.878698),('55983','MN','Wanamingo','Goodhue',44.289244,-92.797112),('55985','MN','West Concord','Dodge',44.159936,-92.875488),('55987','MN','Winona','Winona',44.035294,-91.644),('55988','MN','Stockton','Winona',44.025446,-91.773046),('55990','MN','Wykoff','Fillmore',43.73444,-92.256705),('55991','MN','Zumbro Falls','Wabasha',44.245657,-92.415121),('55992','MN','Zumbrota','Goodhue',44.298065,-92.683256),('56001','MN','Mankato','Blue Earth',44.156276,-93.989121),('56002','MN','Mankato','Blue Earth',44.1638,-94.0036),('56003','MN','Mankato','Nicollet',44.189336,-94.044421),('56006','MN','Mankato','Blue Earth',44.1638,-94.0036),('56007','MN','Albert Lea','Freeborn',43.653006,-93.348622),('56009','MN','Alden','Freeborn',43.666893,-93.547727),('56010','MN','Amboy','Blue Earth',43.89116,-94.194516),('56011','MN','Belle Plaine','Scott',44.616185,-93.770575),('56013','MN','Blue Earth','Faribault',43.632907,-94.101628),('56014','MN','Bricelyn','Faribault',43.586391,-93.826771),('56016','MN','Clarks Grove','Freeborn',43.76241,-93.333383),('56017','MN','Cleveland','Le Sueur',44.305344,-93.819616),('56019','MN','Comfrey','Brown',44.11197,-94.896884),('56020','MN','Conger','Freeborn',43.613755,-93.532175),('56021','MN','Courtland','Nicollet',44.278448,-94.312711),('56022','MN','Darfur','Watonwan',44.052092,-94.83764),('56023','MN','Delavan','Faribault',43.782339,-94.013565),('56024','MN','Eagle Lake','Blue Earth',44.161907,-93.868645),('56025','MN','Easton','Faribault',43.761203,-93.900481),('56026','MN','Ellendale','Steele',43.871193,-93.292673),('56027','MN','Elmore','Faribault',43.505434,-94.111103),('56028','MN','Elysian','Le Sueur',44.216343,-93.693236),('56029','MN','Emmons','Freeborn',43.521515,-93.514107),('56030','MN','Essig','Brown',44.3217,-94.5962),('56031','MN','Fairmont','Martin',43.647227,-94.456653),('56032','MN','Freeborn','Freeborn',43.765235,-93.563425),('56033','MN','Frost','Faribault',43.565044,-93.918222),('56034','MN','Garden City','Blue Earth',44.041989,-94.181059),('56035','MN','Geneva','Freeborn',43.823153,-93.268039),('56036','MN','Glenville','Freeborn',43.550803,-93.239552),('56037','MN','Good Thunder','Blue Earth',44.021665,-94.061893),('56039','MN','Granada','Martin',43.670612,-94.335659),('56041','MN','Hanska','Brown',44.148688,-94.499172),('56042','MN','Hartland','Freeborn',43.795699,-93.491874),('56043','MN','Hayward','Freeborn',43.651474,-93.23612),('56044','MN','Henderson','Sibley',44.546503,-93.923781),('56045','MN','Hollandale','Freeborn',43.76319,-93.203173),('56046','MN','Hope','Steele',43.96257,-93.276602),('56047','MN','Huntley','Faribault',43.731276,-94.235988),('56048','MN','Janesville','Waseca',44.104571,-93.712461),('56050','MN','Kasota','Le Sueur',44.26883,-93.957885),('56051','MN','Kiester','Faribault',43.535116,-93.71402),('56052','MN','Kilkenny','Le Sueur',44.320349,-93.571004),('56054','MN','Lafayette','Nicollet',44.43183,-94.375832),('56055','MN','Lake Crystal','Blue Earth',44.126714,-94.236673),('56056','MN','La Salle','Watonwan',44.071213,-94.573021),('56057','MN','Le Center','Le Sueur',44.388191,-93.723942),('56058','MN','Le Sueur','Le Sueur',44.451374,-93.906458),('56060','MN','Lewisville','Watonwan',43.929273,-94.440943),('56062','MN','Madelia','Watonwan',44.044767,-94.418272),('56063','MN','Madison Lake','Blue Earth',44.213556,-93.818431),('56065','MN','Mapleton','Blue Earth',43.931416,-93.928471),('56068','MN','Minnesota Lake','Faribault',43.848646,-93.817189),('56069','MN','Montgomery','Le Sueur',44.433468,-93.572894),('56071','MN','New Prague','Scott',44.540117,-93.578357),('56072','MN','New Richland','Waseca',43.89201,-93.520676),('56073','MN','New Ulm','Brown',44.311084,-94.461986),('56074','MN','Nicollet','Nicollet',44.326971,-94.19696),('56075','MN','Northrop','Martin',43.734877,-94.435976),('56078','MN','Pemberton','Blue Earth',44.006996,-93.777943),('56080','MN','Saint Clair','Blue Earth',44.081006,-93.856543),('56081','MN','Saint James','Watonwan',43.986793,-94.626093),('56082','MN','Saint Peter','Nicollet',44.337909,-93.993336),('56083','MN','Sanborn','Redwood',44.213257,-95.134933),('56084','MN','Searles','Brown',44.2286,-94.4344),('56085','MN','Sleepy Eye','Brown',44.29972,-94.736222),('56087','MN','Springfield','Brown',44.238089,-94.976858),('56088','MN','Truman','Martin',43.824262,-94.443294),('56089','MN','Twin Lakes','Freeborn',43.560684,-93.426244),('56090','MN','Vernon Center','Blue Earth',43.951314,-94.226965),('56091','MN','Waldorf','Waseca',43.933587,-93.693116),('56093','MN','Waseca','Waseca',44.071393,-93.509858),('56096','MN','Waterville','Le Sueur',44.23492,-93.587772),('56097','MN','Wells','Faribault',43.720968,-93.713282),('56098','MN','Winnebago','Faribault',43.764854,-94.181135),('56101','MN','Windom','Cottonwood',43.875203,-95.130526),('56110','MN','Adrian','Nobles',43.622237,-95.94497),('56111','MN','Alpha','Jackson',43.652155,-94.876376),('56113','MN','Arco','Lincoln',44.397443,-96.166999),('56114','MN','Avoca','Murray',43.971277,-95.612491),('56115','MN','Balaton','Lyon',44.231461,-95.901396),('56116','MN','Beaver Creek','Rock',43.610544,-96.38075),('56117','MN','Bigelow','Nobles',43.521721,-95.682883),('56118','MN','Bingham Lake','Cottonwood',43.929173,-95.038969),('56119','MN','Brewster','Nobles',43.703035,-95.475857),('56120','MN','Butterfield','Watonwan',43.962087,-94.794585),('56121','MN','Ceylon','Martin',43.532192,-94.624863),('56122','MN','Chandler','Murray',43.902308,-95.944171),('56123','MN','Currie','Murray',44.073835,-95.634319),('56125','MN','Dovray','Murray',44.054601,-95.549208),('56127','MN','Dunnell','Martin',43.556069,-94.774403),('56128','MN','Edgerton','Pipestone',43.883572,-96.130675),('56129','MN','Ellsworth','Nobles',43.523701,-96.029983),('56131','MN','Fulda','Murray',43.855847,-95.572539),('56132','MN','Garvin','Lyon',44.212556,-95.760131),('56134','MN','Hardwick','Rock',43.797515,-96.222242),('56136','MN','Hendricks','Lincoln',44.510085,-96.411013),('56137','MN','Heron Lake','Jackson',43.826123,-95.330849),('56138','MN','Hills','Rock',43.529176,-96.367005),('56139','MN','Holland','Pipestone',44.095793,-96.185249),('56140','MN','Ihlen','Pipestone',43.907739,-96.369409),('56141','MN','Iona','Murray',43.899421,-95.793942),('56142','MN','Ivanhoe','Lincoln',44.466066,-96.244425),('56143','MN','Jackson','Jackson',43.634989,-94.998541),('56144','MN','Jasper','Pipestone',43.862921,-96.397741),('56145','MN','Jeffers','Cottonwood',44.057626,-95.185251),('56146','MN','Kanaranzi','Rock',43.575414,-96.095643),('56147','MN','Kenneth','Rock',43.757411,-96.057786),('56149','MN','Lake Benton','Lincoln',44.292286,-96.292093),('56150','MN','Lakefield','Jackson',43.649332,-95.204874),('56151','MN','Lake Wilson','Murray',44.015163,-95.933829),('56152','MN','Lamberton','Redwood',44.225632,-95.2712),('56153','MN','Leota','Nobles',43.834441,-96.018754),('56155','MN','Lismore','Nobles',43.77245,-95.944787),('56156','MN','Luverne','Rock',43.655945,-96.223832),('56157','MN','Lynd','Lyon',44.384969,-95.921096),('56158','MN','Magnolia','Rock',43.643953,-96.074951),('56159','MN','Mountain Lake','Cottonwood',43.939764,-94.929061),('56160','MN','Odin','Watonwan',43.846169,-94.771779),('56161','MN','Okabena','Jackson',43.725029,-95.325419),('56162','MN','Ormsby','Martin',43.840858,-94.684029),('56164','MN','Pipestone','Pipestone',44.02758,-96.335733),('56165','MN','Reading','Nobles',43.725343,-95.703057),('56166','MN','Revere','Redwood',44.202676,-95.364705),('56167','MN','Round Lake','Nobles',43.536446,-95.434499),('56168','MN','Rushmore','Nobles',43.619048,-95.803679),('56169','MN','Russell','Lyon',44.326228,-95.979087),('56170','MN','Ruthton','Pipestone',44.174243,-96.090566),('56171','MN','Sherburn','Martin',43.663581,-94.741155),('56172','MN','Slayton','Murray',44.004819,-95.75557),('56173','MN','Steen','Rock',43.522083,-96.243049),('56174','MN','Storden','Cottonwood',44.029954,-95.305801),('56175','MN','Tracy','Lyon',44.247205,-95.624328),('56176','MN','Trimont','Martin',43.777014,-94.735843),('56177','MN','Trosky','Pipestone',43.88764,-96.255974),('56178','MN','Tyler','Lincoln',44.278722,-96.131681),('56180','MN','Walnut Grove','Redwood',44.248739,-95.469021),('56181','MN','Welcome','Martin',43.680742,-94.616091),('56183','MN','Westbrook','Cottonwood',44.03594,-95.420745),('56185','MN','Wilmont','Nobles',43.782836,-95.822337),('56186','MN','Woodstock','Pipestone',44.019078,-96.089543),('56187','MN','Worthington','Nobles',43.625047,-95.593921),('56201','MN','Willmar','Kandiyohi',45.117947,-95.043489),('56207','MN','Alberta','Stevens',45.505918,-96.066571),('56208','MN','Appleton','Swift',45.224063,-96.02039),('56209','MN','Atwater','Kandiyohi',45.132138,-94.786189),('56210','MN','Barry','Big Stone',45.559164,-96.56008),('56211','MN','Beardsley','Big Stone',45.585421,-96.698827),('56212','MN','Bellingham','Lac Qui Parle',45.130873,-96.323833),('56214','MN','Belview','Redwood',44.603788,-95.33009),('56215','MN','Benson','Swift',45.311097,-95.584934),('56216','MN','Blomkest','Kandiyohi',44.942614,-95.059305),('56218','MN','Boyd','Lac Qui Parle',44.841386,-95.940137),('56219','MN','Browns Valley','Traverse',45.599659,-96.840055),('56220','MN','Canby','Yellow Medicine',44.725909,-96.287621),('56221','MN','Chokio','Stevens',45.556679,-96.190165),('56222','MN','Clara City','Chippewa',44.97424,-95.366162),('56223','MN','Clarkfield','Yellow Medicine',44.762144,-95.818773),('56224','MN','Clements','Redwood',44.372814,-95.052134),('56225','MN','Clinton','Big Stone',45.449038,-96.462498),('56226','MN','Clontarf','Swift',45.394548,-95.681035),('56227','MN','Correll','Big Stone',45.290841,-96.168828),('56228','MN','Cosmos','Meeker',44.935362,-94.68242),('56229','MN','Cottonwood','Lyon',44.608494,-95.716643),('56230','MN','Danube','Renville',44.790752,-95.092113),('56231','MN','Danvers','Swift',45.272368,-95.762922),('56232','MN','Dawson','Lac Qui Parle',44.931111,-96.045366),('56235','MN','Donnelly','Stevens',45.696482,-96.022675),('56236','MN','Dumont','Traverse',45.664944,-96.39621),('56237','MN','Echo','Yellow Medicine',44.623589,-95.43109),('56239','MN','Ghent','Lyon',44.512651,-95.896145),('56240','MN','Graceville','Big Stone',45.566908,-96.463153),('56241','MN','Granite Falls','Yellow Medicine',44.797339,-95.557369),('56243','MN','Grove City','Meeker',45.17024,-94.686488),('56244','MN','Hancock','Stevens',45.485108,-95.777888),('56245','MN','Hanley Falls','Yellow Medicine',44.68663,-95.654947),('56248','MN','Herman','Grant',45.801737,-96.136569),('56249','MN','Holloway','Swift',45.296565,-95.89695),('56251','MN','Kandiyohi','Kandiyohi',45.133339,-94.918539),('56252','MN','Kerkhoven','Swift',45.185517,-95.302766),('56253','MN','Lake Lillian','Kandiyohi',44.958509,-94.888498),('56255','MN','Lucan','Redwood',44.397066,-95.419313),('56256','MN','Madison','Lac Qui Parle',45.032313,-96.193744),('56257','MN','Marietta','Lac Qui Parle',44.986744,-96.409526),('56258','MN','Marshall','Lyon',44.448539,-95.776487),('56260','MN','Maynard','Chippewa',44.935704,-95.482392),('56262','MN','Milan','Chippewa',45.115071,-95.869707),('56263','MN','Milroy','Redwood',44.417176,-95.549896),('56264','MN','Minneota','Lyon',44.57025,-95.984716),('56265','MN','Montevideo','Chippewa',44.979099,-95.711129),('56266','MN','Morgan','Redwood',44.420144,-94.922437),('56267','MN','Morris','Stevens',45.58586,-95.915588),('56270','MN','Morton','Renville',44.54989,-94.99487),('56271','MN','Murdock','Swift',45.238795,-95.414788),('56273','MN','New London','Kandiyohi',45.320561,-94.951178),('56274','MN','Norcross','Grant',45.897893,-96.244534),('56276','MN','Odessa','Big Stone',45.24643,-96.324208),('56277','MN','Olivia','Renville',44.767102,-94.999145),('56278','MN','Ortonville','Big Stone',45.341206,-96.41354),('56279','MN','Pennock','Kandiyohi',45.195153,-95.173789),('56280','MN','Porter','Yellow Medicine',44.632231,-96.163962),('56281','MN','Prinsburg','Kandiyohi',44.943377,-95.174787),('56282','MN','Raymond','Kandiyohi',45.02955,-95.223324),('56283','MN','Redwood Falls','Redwood',44.541927,-95.124475),('56284','MN','Renville','Renville',44.783368,-95.204304),('56285','MN','Sacred Heart','Renville',44.788636,-95.357152),('56287','MN','Seaforth','Redwood',44.476791,-95.326999),('56288','MN','Spicer','Kandiyohi',45.238995,-94.949862),('56289','MN','Sunburg','Kandiyohi',45.333244,-95.224479),('56291','MN','Taunton','Lyon',44.614427,-96.066033),('56292','MN','Vesta','Redwood',44.495586,-95.432582),('56293','MN','Wabasso','Redwood',44.41763,-95.260183),('56294','MN','Wanda','Redwood',44.316082,-95.212416),('56295','MN','Watson','Chippewa',45.027656,-95.830164),('56296','MN','Wheaton','Traverse',45.817049,-96.48957),('56297','MN','Wood Lake','Yellow Medicine',44.649009,-95.543613),('56301','MN','Saint Cloud','Stearns',45.525406,-94.205726),('56302','MN','Saint Cloud','Stearns',45.6176,-94.2451),('56303','MN','Saint Cloud','Stearns',45.570344,-94.196177),('56304','MN','Saint Cloud','Sherburne',45.546273,-94.112317),('56307','MN','Albany','Stearns',45.63677,-94.577007),('56308','MN','Alexandria','Douglas',45.887034,-95.385055),('56309','MN','Ashby','Grant',46.07926,-95.805971),('56310','MN','Avon','Stearns',45.61955,-94.450723),('56311','MN','Barrett','Grant',45.904331,-95.884021),('56312','MN','Belgrade','Stearns',45.450121,-94.956198),('56313','MN','Bock','Mille Lacs',45.784894,-93.553053),('56314','MN','Bowlus','Morrison',45.809234,-94.413816),('56315','MN','Brandon','Douglas',45.9676,-95.597131),('56316','MN','Brooten','Stearns',45.499557,-95.132413),('56317','MN','Buckman','Morrison',45.8975,-94.0933),('56318','MN','Burtrum','Todd',45.853038,-94.67453),('56319','MN','Carlos','Douglas',45.990791,-95.270455),('56320','MN','Cold Spring','Stearns',45.457194,-94.423431),('56321','MN','Collegeville','Stearns',45.581249,-94.394479),('56323','MN','Cyrus','Pope',45.623798,-95.732217),('56324','MN','Dalton','Otter Tail',46.171617,-95.912534),('56325','MN','Elrosa','Stearns',45.562396,-94.946868),('56326','MN','Evansville','Douglas',46.016665,-95.686109),('56327','MN','Farwell','Douglas',45.763081,-95.606674),('56328','MN','Flensburg','Morrison',45.952786,-94.528792),('56329','MN','Foley','Benton',45.687021,-93.919325),('56330','MN','Foreston','Mille Lacs',45.738424,-93.729528),('56331','MN','Freeport','Stearns',45.679866,-94.670818),('56332','MN','Garfield','Douglas',45.943877,-95.512948),('56333','MN','Gilman','Benton',45.7355,-93.948),('56334','MN','Glenwood','Pope',45.620937,-95.35288),('56335','MN','Greenwald','Stearns',45.601627,-94.859687),('56336','MN','Grey Eagle','Todd',45.821795,-94.751244),('56338','MN','Hillman','Morrison',46.060409,-93.910668),('56339','MN','Hoffman','Grant',45.830057,-95.800423),('56340','MN','Holdingford','Stearns',45.746432,-94.463845),('56341','MN','Holmes City','Douglas',45.8361,-95.54),('56342','MN','Isle','Mille Lacs',46.157565,-93.441607),('56343','MN','Kensington','Douglas',45.804236,-95.683579),('56344','MN','Lastrup','Morrison',46.0394,-94.063),('56345','MN','Little Falls','Morrison',45.989874,-94.368155),('56347','MN','Long Prairie','Todd',45.968577,-94.864637),('56349','MN','Lowry','Pope',45.718194,-95.520186),('56350','MN','Mc Grath','Aitkin',46.268293,-93.247325),('56352','MN','Melrose','Stearns',45.659384,-94.80941),('56353','MN','Milaca','Mille Lacs',45.761247,-93.632745),('56354','MN','Miltona','Douglas',46.05986,-95.294616),('56355','MN','Nelson','Douglas',45.920336,-95.240003),('56356','MN','New Munich','Stearns',45.627958,-94.754597),('56357','MN','Oak Park','Benton',45.690998,-93.79826),('56358','MN','Ogilvie','Kanabec',45.830183,-93.431231),('56359','MN','Onamia','Mille Lacs',46.070036,-93.673427),('56360','MN','Osakis','Douglas',45.872392,-95.118167),('56361','MN','Parkers Prairie','Otter Tail',46.160236,-95.332488),('56362','MN','Paynesville','Stearns',45.389098,-94.707866),('56363','MN','Pease','Mille Lacs',45.695279,-93.646378),('56364','MN','Pierz','Morrison',45.99178,-94.086985),('56367','MN','Rice','Benton',45.746381,-94.196851),('56368','MN','Richmond','Stearns',45.438806,-94.528194),('56369','MN','Rockville','Stearns',45.471114,-94.341285),('56371','MN','Roscoe','Stearns',45.433044,-94.637852),('56372','MN','Saint Cloud','Stearns',45.6176,-94.2451),('56373','MN','Royalton','Morrison',45.83889,-94.265287),('56374','MN','Saint Joseph','Stearns',45.579157,-94.321615),('56375','MN','Saint Stephen','Stearns',45.703057,-94.274734),('56376','MN','Saint Martin','Stearns',45.502023,-94.670242),('56377','MN','Sartell','Stearns',45.621582,-94.220425),('56378','MN','Sauk Centre','Stearns',45.73098,-94.962938),('56379','MN','Sauk Rapids','Benton',45.606408,-94.143124),('56381','MN','Starbuck','Pope',45.563647,-95.549827),('56382','MN','Swanville','Morrison',45.903805,-94.623385),('56384','MN','Upsala','Morrison',45.807999,-94.570354),('56385','MN','Villard','Pope',45.700872,-95.232188),('56386','MN','Wahkon','Mille Lacs',46.122588,-93.520293),('56387','MN','Waite Park','Stearns',45.549574,-94.226729),('56388','MN','Waite Park','Stearns',45.558,-94.225),('56389','MN','West Union','Todd',45.79752,-95.086076),('56393','MN','Saint Cloud','Stearns',45.6176,-94.2451),('56395','MN','Saint Cloud','Stearns',45.6176,-94.2451),('56396','MN','Saint Cloud','Stearns',45.6176,-94.2451),('56397','MN','Saint Cloud','Stearns',45.48,-94.2518),('56398','MN','Saint Cloud','Stearns',45.48,-94.2518),('56399','MN','Saint Cloud','Stearns',45.7207,-94.2455),('56401','MN','Brainerd','Crow Wing',46.353304,-94.184709),('56425','MN','Baxter','Crow Wing',46.350192,-94.261313),('56430','MN','Ah Gwah Ching','Cass',47.0789,-94.567),('56431','MN','Aitkin','Aitkin',46.501765,-93.685161),('56433','MN','Akeley','Hubbard',46.977405,-94.71995),('56434','MN','Aldrich','Todd',46.367162,-94.941769),('56435','MN','Backus','Cass',46.814795,-94.49874),('56436','MN','Benedict','Hubbard',47.157054,-94.689251),('56437','MN','Bertha','Todd',46.258761,-95.047958),('56438','MN','Browerville','Todd',46.138539,-94.819257),('56440','MN','Clarissa','Todd',46.130253,-94.954354),('56441','MN','Crosby','Crow Wing',46.528259,-93.979123),('56442','MN','Crosslake','Crow Wing',46.677986,-94.110197),('56443','MN','Cushing','Morrison',46.181696,-94.612703),('56444','MN','Deerwood','Crow Wing',46.435465,-93.890633),('56446','MN','Eagle Bend','Todd',46.128615,-95.068182),('56447','MN','Emily','Crow Wing',46.73592,-93.936017),('56448','MN','Fifty Lakes','Crow Wing',46.746749,-94.060946),('56449','MN','Fort Ripley','Crow Wing',46.186485,-94.301706),('56450','MN','Garrison','Crow Wing',46.254031,-93.820779),('56452','MN','Hackensack','Cass',46.952451,-94.461469),('56453','MN','Hewitt','Todd',46.318359,-95.14456),('56455','MN','Ironton','Crow Wing',46.465151,-94.013975),('56456','MN','Jenkins','Crow Wing',46.643266,-94.335564),('56458','MN','Lake George','Hubbard',47.206464,-94.977172),('56459','MN','Lake Hubert','Crow Wing',46.5022,-94.2572),('56461','MN','Laporte','Hubbard',47.229861,-94.801432),('56464','MN','Menahga','Wadena',46.773411,-95.08432),('56465','MN','Merrifield','Crow Wing',46.516843,-94.123041),('56466','MN','Motley','Cass',46.37453,-94.638017),('56467','MN','Nevis','Hubbard',46.961735,-94.845555),('56468','MN','Nisswa','Crow Wing',46.501415,-94.297006),('56469','MN','Palisade','Aitkin',46.727362,-93.526133),('56470','MN','Park Rapids','Hubbard',46.984915,-95.063673),('56472','MN','Pequot Lakes','Crow Wing',46.606773,-94.286247),('56473','MN','Pillager','Cass',46.341152,-94.479567),('56474','MN','Pine River','Cass',46.720689,-94.378025),('56475','MN','Randall','Morrison',46.097147,-94.511641),('56477','MN','Sebeka','Wadena',46.646975,-95.02747),('56478','MN','Nimrod','Wadena',46.6388,-94.8805),('56479','MN','Staples','Todd',46.403765,-94.797645),('56481','MN','Verndale','Wadena',46.433978,-94.95722),('56482','MN','Wadena','Wadena',46.444683,-95.141165),('56484','MN','Walker','Cass',47.099001,-94.534609),('56501','MN','Detroit Lakes','Becker',46.810127,-95.849493),('56502','MN','Detroit Lakes','Becker',46.8172,-95.845),('56510','MN','Ada','Norman',47.332919,-96.520875),('56511','MN','Audubon','Becker',46.862105,-95.991951),('56514','MN','Barnesville','Clay',46.652895,-96.425867),('56515','MN','Battle Lake','Otter Tail',46.300169,-95.710149),('56516','MN','Bejou','Mahnomen',47.44854,-95.98767),('56517','MN','Beltrami','Polk',47.564276,-96.545578),('56518','MN','Bluffton','Otter Tail',46.478034,-95.244118),('56519','MN','Borup','Norman',47.144019,-96.490029),('56520','MN','Breckenridge','Wilkin',46.279358,-96.553124),('56521','MN','Callaway','Becker',46.998985,-95.901997),('56522','MN','Campbell','Wilkin',46.130219,-96.399014),('56523','MN','Climax','Polk',47.651363,-96.80404),('56524','MN','Clitherall','Otter Tail',46.235301,-95.615667),('56525','MN','Comstock','Clay',46.661042,-96.749897),('56527','MN','Deer Creek','Otter Tail',46.385261,-95.324129),('56528','MN','Dent','Otter Tail',46.528125,-95.797316),('56529','MN','Dilworth','Clay',46.878032,-96.701037),('56531','MN','Elbow Lake','Grant',45.986008,-95.962872),('56533','MN','Elizabeth','Otter Tail',46.39868,-96.142104),('56534','MN','Erhard','Otter Tail',46.455988,-96.008025),('56535','MN','Erskine','Polk',47.667204,-96.035046),('56536','MN','Felton','Clay',47.046794,-96.522969),('56537','MN','Fergus Falls','Otter Tail',46.284012,-96.076889),('56538','MN','Fergus Falls','Otter Tail',46.283,-96.0738),('56540','MN','Fertile','Polk',47.540106,-96.274722),('56541','MN','Flom','Norman',47.162393,-96.141503),('56542','MN','Fosston','Polk',47.570428,-95.736629),('56543','MN','Foxhome','Wilkin',46.289488,-96.332255),('56544','MN','Frazee','Becker',46.736495,-95.653898),('56545','MN','Gary','Norman',47.375846,-96.224297),('56546','MN','Georgetown','Clay',47.100433,-96.743078),('56547','MN','Glyndon','Clay',46.887145,-96.579918),('56548','MN','Halstad','Norman',47.364645,-96.782438),('56549','MN','Hawley','Clay',46.859486,-96.29139),('56550','MN','Hendrum','Norman',47.259229,-96.781205),('56551','MN','Henning','Otter Tail',46.328496,-95.462393),('56552','MN','Hitterdal','Clay',46.985193,-96.234198),('56553','MN','Kent','Wilkin',46.434907,-96.645204),('56554','MN','Lake Park','Becker',46.873381,-96.114815),('56556','MN','Mcintosh','Polk',47.651831,-95.882691),('56557','MN','Mahnomen','Mahnomen',47.296089,-95.879249),('56560','MN','Moorhead','Clay',46.861265,-96.751039),('56561','MN','Moorhead','Clay',46.9237,-96.7141),('56562','MN','Moorhead','Clay',46.8629,-96.7687),('56563','MN','Moorhead','Clay',46.8667,-96.7574),('56565','MN','Nashua','Wilkin',46.043667,-96.317845),('56566','MN','Naytahwaush','Mahnomen',47.249252,-95.634918),('56567','MN','New York Mills','Otter Tail',46.524023,-95.38423),('56568','MN','Nielsville','Polk',47.535231,-96.783178),('56569','MN','Ogema','Becker',47.077169,-95.835245),('56570','MN','Osage','Becker',46.91793,-95.367145),('56571','MN','Ottertail','Otter Tail',46.43824,-95.554733),('56572','MN','Pelican Rapids','Otter Tail',46.601267,-96.061972),('56573','MN','Perham','Otter Tail',46.602228,-95.5611),('56574','MN','Perley','Norman',47.197049,-96.729336),('56575','MN','Ponsford','Becker',47.034736,-95.444397),('56576','MN','Richville','Otter Tail',46.463112,-95.699414),('56577','MN','Richwood','Becker',46.974158,-95.803454),('56578','MN','Rochert','Becker',46.922154,-95.656198),('56579','MN','Rothsay','Wilkin',46.463501,-96.33858),('56580','MN','Sabin','Clay',46.745763,-96.612515),('56581','MN','Shelly','Norman',47.450942,-96.79918),('56583','MN','Tintah','Traverse',46.014415,-96.379922),('56584','MN','Twin Valley','Norman',47.249232,-96.231672),('56585','MN','Ulen','Clay',47.088367,-96.246304),('56586','MN','Underwood','Otter Tail',46.326103,-95.845094),('56587','MN','Vergas','Otter Tail',46.660143,-95.852793),('56588','MN','Vining','Otter Tail',46.231412,-95.516813),('56589','MN','Waubun','Mahnomen',47.178956,-95.716145),('56590','MN','Wendell','Grant',46.035607,-96.152722),('56591','MN','White Earth','Becker',47.093756,-95.841564),('56592','MN','Winger','Polk',47.538305,-96.00938),('56593','MN','Wolf Lake','Becker',46.803794,-95.354075),('56594','MN','Wolverton','Wilkin',46.565493,-96.666456),('56601','MN','Bemidji','Beltrami',47.484049,-94.869558),('56619','MN','Bemidji','Beltrami',47.4736,-94.88),('56621','MN','Bagley','Clearwater',47.43451,-95.412503),('56623','MN','Baudette','Lake Of The Woods',48.669966,-94.617117),('56626','MN','Bena','Cass',47.349392,-94.25012),('56627','MN','Big Falls','Koochiching',48.245865,-93.933139),('56628','MN','Bigfork','Itasca',47.679962,-93.624635),('56629','MN','Birchdale','Koochiching',48.578584,-94.160379),('56630','MN','Blackduck','Beltrami',47.739144,-94.50926),('56631','MN','Bowstring','Itasca',47.543,-93.7963),('56633','MN','Cass Lake','Cass',47.37537,-94.5782),('56634','MN','Clearbrook','Clearwater',47.680503,-95.420627),('56636','MN','Deer River','Itasca',47.412045,-93.859631),('56637','MN','Talmoon','Itasca',47.598538,-93.82085),('56639','MN','Effie','Itasca',47.873879,-93.540912),('56641','MN','Federal Dam','Cass',47.237782,-94.220739),('56644','MN','Gonvick','Clearwater',47.754986,-95.50906),('56646','MN','Gully','Polk',47.773594,-95.632726),('56647','MN','Hines','Beltrami',47.667087,-94.618467),('56649','MN','International Falls','Koochiching',48.57199,-93.331049),('56650','MN','Kelliher','Beltrami',48.005049,-94.557591),('56651','MN','Lengby','Mahnomen',47.4596,-95.643803),('56652','MN','Leonard','Clearwater',47.708135,-95.22766),('56653','MN','Littlefork','Koochiching',48.322481,-93.515126),('56654','MN','Loman','Koochiching',48.525502,-93.852517),('56655','MN','Longville','Cass',46.980788,-94.231461),('56657','MN','Marcell','Itasca',47.573006,-93.634311),('56658','MN','Margie','Koochiching',48.1573,-93.8637),('56659','MN','Max','Itasca',47.653088,-94.017436),('56660','MN','Mizpah','Koochiching',47.952422,-94.161906),('56661','MN','Northome','Koochiching',47.844473,-94.169293),('56662','MN','Outing','Cass',46.847102,-93.940017),('56663','MN','Pennington','Beltrami',47.492496,-94.446038),('56666','MN','Ponemah','Beltrami',48.019342,-94.888589),('56667','MN','Puposky','Beltrami',47.728438,-94.924799),('56668','MN','Ranier','Koochiching',48.613385,-93.346928),('56669','MN','Kabetoga','Koochiching',48.426275,-93.167915),('56670','MN','Redby','Beltrami',47.845828,-94.886636),('56671','MN','Redlake','Beltrami',47.871593,-95.147543),('56672','MN','Remer','Cass',47.05623,-94.007449),('56673','MN','Roosevelt','Roseau',48.836115,-95.101527),('56676','MN','Shevlin','Clearwater',47.530506,-95.207004),('56678','MN','Solway','Beltrami',47.43646,-95.115242),('56679','MN','South International Falls','Koochiching',48.5328,-93.2993),('56680','MN','Spring Lake','Itasca',47.644357,-93.969851),('56681','MN','Squaw Lake','Itasca',47.611763,-94.237388),('56682','MN','Swift','Roseau',48.8542,-95.2775),('56683','MN','Tenstrike','Beltrami',47.698017,-94.750797),('56684','MN','Trail','Polk',47.836302,-95.699614),('56685','MN','Waskish','Beltrami',48.212838,-94.574546),('56686','MN','Williams','Lake Of The Woods',48.766156,-94.923325),('56687','MN','Wilton','Beltrami',47.501155,-94.994802),('56688','MN','Wirt','Itasca',47.738819,-93.939146),('56701','MN','Thief River Falls','Pennington',48.116713,-96.176455),('56710','MN','Alvarado','Marshall',48.204054,-97.008338),('56711','MN','Angle Inlet','Lake Of The Woods',49.347415,-95.069822),('56713','MN','Argyle','Marshall',48.348012,-96.8135),('56714','MN','Badger','Roseau',48.796404,-96.018298),('56715','MN','Brooks','Red Lake',47.814569,-95.971813),('56716','MN','Crookston','Polk',47.749879,-96.582368),('56720','MN','Donaldson','Kittson',48.574131,-96.896603),('56721','MN','East Grand Forks','Polk',47.956393,-96.987805),('56722','MN','Euclid','Polk',47.970636,-96.666652),('56723','MN','Fisher','Polk',47.807684,-96.801525),('56724','MN','Gatzke','Marshall',48.44603,-95.763256),('56725','MN','Goodridge','Pennington',48.128914,-95.798382),('56726','MN','Greenbush','Roseau',48.717333,-96.205858),('56727','MN','Grygla','Marshall',48.321594,-95.513495),('56728','MN','Hallock','Kittson',48.784275,-96.977458),('56729','MN','Halma','Kittson',48.664801,-96.598954),('56731','MN','Humboldt','Kittson',48.913017,-97.072561),('56732','MN','Karlstad','Kittson',48.57933,-96.509207),('56733','MN','Kennedy','Kittson',48.637117,-96.897483),('56734','MN','Lake Bronson','Kittson',48.731397,-96.648374),('56735','MN','Lancaster','Kittson',48.8976,-96.744156),('56736','MN','Mentor','Polk',47.693105,-96.169569),('56737','MN','Middle River','Marshall',48.419694,-96.069146),('56738','MN','Newfolden','Marshall',48.335371,-96.312528),('56740','MN','Noyes','Kittson',48.9709,-97.1259),('56741','MN','Oak Island','Lake Of The Woods',49.263023,-94.868171),('56742','MN','Oklee','Red Lake',47.913753,-95.827765),('56744','MN','Oslo','Marshall',48.240118,-97.128668),('56748','MN','Plummer','Red Lake',47.917746,-96.006228),('56750','MN','Red Lake Falls','Red Lake',47.891893,-96.290569),('56751','MN','Roseau','Roseau',48.814404,-95.743815),('56754','MN','Saint Hilaire','Pennington',48.007759,-96.20065),('56755','MN','Saint Vincent','Kittson',48.982171,-97.162358),('56756','MN','Salol','Roseau',48.876157,-95.517008),('56757','MN','Stephen','Marshall',48.469429,-96.88404),('56758','MN','Strandquist','Marshall',48.471039,-96.507424),('56759','MN','Strathcona','Roseau',48.565368,-96.09209),('56760','MN','Viking','Marshall',48.233704,-96.448114),('56761','MN','Wannaska','Roseau',48.605094,-95.701637),('56762','MN','Warren','Marshall',48.177136,-96.749477),('56763','MN','Warroad','Roseau',48.865322,-95.333128),('56901','DC','Washington','District Of Columbia',38.8951,-77.0364),('56902','DC','Parcel Return Service','District Of Columbia',38.894,77.036),('56904','DC','Parcel Return Service','District Of Columbia',38.8945,77.0365),('56915','DC','Washington','District Of Columbia',38.9164,-76.9949),('56920','DC','Washington','District Of Columbia',38.8951,-77.0364),('56933','DC','Washington','District Of Columbia',38.8952,-77.0365),('56944','DC','Washington','District Of Columbia',38.8952,-77.0365),('56945','IA','Hp Enterprise Services','Polk',41.583,-93.639),('56950','DC','Parcel Return Service','District Of Columbia',38.8952,77.0365),('56965','DC','Parcel Return Service','Polk',38.895,-77.037),('56972','DC','Washington','District Of Columbia',38.8952,-77.0365),('57001','SD','Alcester','Union',42.989264,-96.657247),('57002','SD','Aurora','Brookings',44.290227,-96.676564),('57003','SD','Baltic','Minnehaha',43.744024,-96.755131),('57004','SD','Beresford','Union',43.08141,-96.786779),('57005','SD','Brandon','Minnehaha',43.592908,-96.583769),('57006','SD','Brookings','Brookings',44.304932,-96.792699),('57007','SD','Brookings','Brookings',44.3183,-96.7817),('57010','SD','Burbank','Clay',42.808405,-96.824223),('57012','SD','Canistota','Mccook',43.593815,-97.276953),('57013','SD','Canton','Lincoln',43.296203,-96.603663),('57014','SD','Centerville','Turner',43.111915,-96.956158),('57015','SD','Chancellor','Turner',43.395535,-96.974307),('57016','SD','Chester','Lake',43.897649,-96.941302),('57017','SD','Colman','Moody',44.008116,-96.814223),('57018','SD','Colton','Minnehaha',43.797678,-96.960784),('57020','SD','Crooks','Minnehaha',43.671763,-96.816898),('57021','SD','Davis','Turner',43.258046,-96.988956),('57022','SD','Dell Rapids','Minnehaha',43.831421,-96.718472),('57024','SD','Egan','Moody',43.998099,-96.657632),('57025','SD','Elk Point','Union',42.714936,-96.694712),('57026','SD','Elkton','Brookings',44.249215,-96.506573),('57027','SD','Fairview','Lincoln',43.203614,-96.477277),('57028','SD','Flandreau','Moody',44.051982,-96.607918),('57029','SD','Freeman','Hutchinson',43.335575,-97.469983),('57030','SD','Garretson','Minnehaha',43.737814,-96.513182),('57031','SD','Gayville','Yankton',42.888802,-97.176322),('57032','SD','Harrisburg','Lincoln',43.430338,-96.691523),('57033','SD','Hartford','Minnehaha',43.613643,-96.951369),('57034','SD','Hudson','Lincoln',43.119837,-96.51966),('57035','SD','Humboldt','Minnehaha',43.638053,-97.07588),('57036','SD','Hurley','Turner',43.268815,-97.137195),('57037','SD','Irene','Yankton',43.104561,-97.249244),('57038','SD','Jefferson','Union',42.569053,-96.579531),('57039','SD','Lennox','Lincoln',43.349378,-96.876411),('57040','SD','Lesterville','Yankton',43.060987,-97.587371),('57041','SD','Lyons','Minnehaha',43.726203,-96.870798),('57042','SD','Madison','Lake',43.995216,-97.124396),('57043','SD','Marion','Turner',43.422671,-97.29031),('57045','SD','Menno','Hutchinson',43.219368,-97.548444),('57046','SD','Mission Hill','Yankton',42.930962,-97.289031),('57047','SD','Monroe','Turner',43.506981,-97.219215),('57048','SD','Montrose','Mccook',43.730022,-97.193135),('57049','SD','North Sioux City','Union',42.517002,-96.497316),('57050','SD','Nunda','Lake',44.160489,-97.016951),('57051','SD','Oldham','Kingsbury',44.231987,-97.321937),('57052','SD','Olivet','Hutchinson',43.291881,-97.707832),('57053','SD','Parker','Turner',43.411764,-97.133985),('57054','SD','Ramona','Lake',44.131409,-97.239835),('57055','SD','Renner','Minnehaha',43.661802,-96.734381),('57056','SD','Rowena','Minnehaha',43.52,-96.5576),('57057','SD','Rutland','Lake',44.102232,-96.95925),('57058','SD','Salem','Mccook',43.726955,-97.392662),('57059','SD','Scotland','Bon Homme',43.131256,-97.731301),('57061','SD','Sinai','Brookings',44.245023,-97.041909),('57062','SD','Springfield','Bon Homme',42.857933,-97.931243),('57063','SD','Tabor','Bon Homme',42.944496,-97.684836),('57064','SD','Tea','Lincoln',43.4511,-96.839673),('57065','SD','Trent','Moody',43.898795,-96.632393),('57066','SD','Tyndall','Bon Homme',42.993778,-97.867886),('57067','SD','Utica','Yankton',43.024298,-97.488452),('57068','SD','Valley Springs','Minnehaha',43.58328,-96.484147),('57069','SD','Vermillion','Clay',42.817452,-96.968568),('57070','SD','Viborg','Turner',43.177223,-97.150713),('57071','SD','Volga','Brookings',44.289856,-96.938562),('57072','SD','Volin','Yankton',42.964433,-97.176796),('57073','SD','Wakonda','Clay',43.003894,-97.071316),('57075','SD','Wentworth','Lake',43.994074,-96.968814),('57076','SD','Winfred','Lake',43.997811,-97.366863),('57077','SD','Worthing','Lincoln',43.326972,-96.76304),('57078','SD','Yankton','Yankton',42.888135,-97.40969),('57079','SD','Yankton','Yankton',42.8703,-97.3933),('57101','SD','Sioux Falls','Minnehaha',43.6017,-96.7051),('57103','SD','Sioux Falls','Minnehaha',43.540263,-96.693981),('57104','SD','Sioux Falls','Minnehaha',43.564991,-96.72915),('57105','SD','Sioux Falls','Minnehaha',43.525033,-96.733136),('57106','SD','Sioux Falls','Minnehaha',43.513649,-96.808194),('57107','SD','Sioux Falls','Minnehaha',43.578974,-96.802622),('57108','SD','Sioux Falls','Lincoln',43.484318,-96.73066),('57109','SD','Sioux Falls','Minnehaha',43.5149,-96.7508),('57110','SD','Sioux Falls','Minnehaha',43.539839,-96.646528),('57117','SD','Sioux Falls','Minnehaha',43.531243,-96.754971),('57118','SD','Sioux Falls','Minnehaha',43.6017,-96.7051),('57186','SD','Sioux Falls','Minnehaha',43.5503,-96.7002),('57188','SD','Sioux Falls','Minnehaha',43.6017,-96.7051),('57189','SD','Sioux Falls','Minnehaha',43.6017,-96.7051),('57192','SD','Sioux Falls','Minnehaha',43.6017,-96.7051),('57193','SD','Sioux Falls','Minnehaha',43.6017,-96.7051),('57194','SD','Sioux Falls','Minnehaha',43.6017,-96.7051),('57195','SD','Sioux Falls','Minnehaha',43.6017,-96.7051),('57196','SD','Sioux Falls','Minnehaha',43.5444,-96.7232),('57197','SD','Sioux Falls','Minnehaha',43.524568,-96.738629),('57198','SD','Sioux Falls','Minnehaha',43.7326,-96.6285),('57201','SD','Watertown','Codington',44.915159,-97.108995),('57212','SD','Arlington','Kingsbury',44.371361,-97.146773),('57213','SD','Astoria','Deuel',44.550644,-96.530613),('57214','SD','Badger','Kingsbury',44.485582,-97.20974),('57216','SD','Big Stone City','Grant',45.287935,-96.501206),('57217','SD','Bradley','Clark',45.090476,-97.652278),('57218','SD','Brandt','Deuel',44.658963,-96.601839),('57219','SD','Bristol','Day',45.311599,-97.775295),('57220','SD','Bruce','Brookings',44.45976,-96.917332),('57221','SD','Bryant','Hamlin',44.595522,-97.456376),('57223','SD','Castlewood','Hamlin',44.706054,-97.014754),('57224','SD','Claire City','Roberts',45.851845,-97.134437),('57225','SD','Clark','Clark',44.883934,-97.732389),('57226','SD','Clear Lake','Deuel',44.775236,-96.704222),('57227','SD','Corona','Roberts',45.358134,-96.724444),('57231','SD','De Smet','Kingsbury',44.378149,-97.574407),('57232','SD','Eden','Marshall',45.624999,-97.384818),('57233','SD','Erwin','Kingsbury',44.4991,-97.420513),('57234','SD','Estelline','Hamlin',44.60657,-96.894254),('57235','SD','Florence','Codington',45.060168,-97.319352),('57236','SD','Garden City','Clark',44.971163,-97.585756),('57237','SD','Gary','Deuel',44.777477,-96.482623),('57238','SD','Goodwin','Deuel',44.873359,-96.860868),('57239','SD','Grenville','Day',45.490662,-97.317704),('57241','SD','Hayti','Hamlin',44.695552,-97.216194),('57242','SD','Hazel','Hamlin',44.767709,-97.360124),('57243','SD','Henry','Codington',44.898254,-97.407247),('57245','SD','Kranzburg','Codington',44.892847,-96.918867),('57246','SD','Labolt','Grant',45.055051,-96.667899),('57247','SD','Lake City','Marshall',45.71354,-97.420813),('57248','SD','Lake Norden','Hamlin',44.571856,-97.186392),('57249','SD','Lake Preston','Kingsbury',44.362183,-97.36747),('57251','SD','Marvin','Grant',45.267235,-96.926294),('57252','SD','Milbank','Grant',45.219502,-96.616401),('57253','SD','Milbank','Grant',45.1517,-96.6068),('57255','SD','New Effington','Roberts',45.857568,-96.922239),('57256','SD','Ortley','Roberts',45.290137,-97.190772),('57257','SD','Peever','Roberts',45.507605,-97.004834),('57258','SD','Raymond','Clark',44.883554,-97.928476),('57259','SD','Revillo','Grant',44.998797,-96.552792),('57260','SD','Rosholt','Roberts',45.856275,-96.719619),('57261','SD','Roslyn','Day',45.54368,-97.489586),('57262','SD','Sisseton','Roberts',45.66692,-97.060591),('57263','SD','South Shore','Codington',45.129306,-97.015186),('57264','SD','Stockholm','Grant',45.103004,-96.787027),('57265','SD','Strandburg','Grant',45.020539,-96.788661),('57266','SD','Summit','Roberts',45.275194,-97.092607),('57268','SD','Toronto','Deuel',44.573474,-96.684083),('57269','SD','Twin Brooks','Grant',45.228231,-96.79403),('57270','SD','Veblen','Marshall',45.826944,-97.361453),('57271','SD','Vienna','Clark',44.731986,-97.532247),('57272','SD','Wallace','Codington',45.090522,-97.462893),('57273','SD','Waubay','Day',45.363558,-97.278087),('57274','SD','Webster','Day',45.318822,-97.539965),('57276','SD','White','Brookings',44.419658,-96.636456),('57278','SD','Willow Lake','Clark',44.62374,-97.684861),('57279','SD','Wilmot','Roberts',45.421222,-96.876323),('57301','SD','Mitchell','Davison',43.709962,-98.023359),('57311','SD','Alexandria','Hanson',43.646402,-97.769437),('57312','SD','Alpena','Jerauld',44.204007,-98.365896),('57313','SD','Armour','Douglas',43.304789,-98.354755),('57314','SD','Artesian','Sanborn',44.031823,-98.000765),('57315','SD','Avon','Bon Homme',43.000513,-98.040927),('57317','SD','Bonesteel','Gregory',43.090236,-98.972173),('57319','SD','Bridgewater','Mccook',43.539214,-97.475484),('57321','SD','Canova','Miner',43.87048,-97.54047),('57322','SD','Carpenter','Beadle',44.611736,-97.987805),('57323','SD','Carthage','Miner',44.157757,-97.720191),('57324','SD','Cavour','Beadle',44.304397,-98.044291),('57325','SD','Chamberlain','Brule',43.792478,-99.314791),('57326','SD','Chamberlain','Brule',43.7497,-99.3448),('57328','SD','Corsica','Douglas',43.434953,-98.420558),('57329','SD','Dante','Charles Mix',43.001907,-98.162723),('57330','SD','Delmont','Douglas',43.257561,-98.158883),('57331','SD','Dimock','Hutchinson',43.478086,-98.026994),('57332','SD','Emery','Hanson',43.565097,-97.637166),('57334','SD','Ethan','Davison',43.543933,-97.98049),('57335','SD','Fairfax','Gregory',43.035662,-98.813173),('57337','SD','Fedora','Miner',44.011912,-97.795752),('57339','SD','Fort Thompson','Buffalo',44.069602,-99.410315),('57340','SD','Fulton','Hanson',43.767893,-97.839479),('57341','SD','Gann Valley','Buffalo',44.075786,-99.057681),('57342','SD','Geddes','Charles Mix',43.25508,-98.693076),('57344','SD','Harrison','Douglas',43.449194,-98.618878),('57345','SD','Highmore','Hyde',44.554853,-99.443468),('57346','SD','Stephan','Hyde',44.254849,-99.53961),('57348','SD','Hitchcock','Beadle',44.611178,-98.392428),('57349','SD','Howard','Miner',44.030009,-97.560632),('57350','SD','Huron','Beadle',44.380227,-98.208046),('57353','SD','Iroquois','Kingsbury',44.377156,-97.841425),('57354','SD','Kaylor','Hutchinson',43.2164,-97.8145),('57355','SD','Kimball','Brule',43.755587,-98.958595),('57356','SD','Lake Andes','Charles Mix',43.15817,-98.529608),('57358','SD','Lane','Jerauld',44.070524,-98.42379),('57359','SD','Letcher','Sanborn',43.900263,-98.14638),('57361','SD','Marty','Charles Mix',42.993061,-98.429095),('57362','SD','Miller','Hand',44.494244,-99.034616),('57363','SD','Mount Vernon','Davison',43.680487,-98.25552),('57364','SD','New Holland','Douglas',43.427237,-98.607742),('57365','SD','Oacoma','Lyman',43.805175,-99.408359),('57366','SD','Parkston','Hutchinson',43.391569,-97.946598),('57367','SD','Pickstown','Charles Mix',43.064086,-98.537451),('57368','SD','Plankinton','Aurora',43.724571,-98.465194),('57369','SD','Platte','Charles Mix',43.420444,-98.88412),('57370','SD','Pukwana','Brule',43.78952,-99.166735),('57371','SD','Ree Heights','Hand',44.434094,-99.220495),('57373','SD','Saint Lawrence','Hand',44.532937,-98.889914),('57374','SD','Spencer','Mccook',43.739012,-97.600142),('57375','SD','Stickney','Aurora',43.578043,-98.469829),('57376','SD','Tripp','Hutchinson',43.220075,-97.942229),('57379','SD','Virgil','Beadle',44.259103,-98.52058),('57380','SD','Wagner','Charles Mix',43.045208,-98.318271),('57381','SD','Wessington','Beadle',44.435787,-98.706267),('57382','SD','Wessington Springs','Jerauld',44.061182,-98.643248),('57383','SD','White Lake','Aurora',43.708571,-98.704103),('57384','SD','Wolsey','Beadle',44.420968,-98.479387),('57385','SD','Woonsocket','Sanborn',44.05827,-98.271703),('57386','SD','Yale','Beadle',44.495961,-98.002152),('57399','SD','Huron','Beadle',44.3618,-98.2138),('57401','SD','Aberdeen','Brown',45.46635,-98.492117),('57402','SD','Aberdeen','Brown',45.4613,-98.4858),('57420','SD','Akaska','Walworth',45.328884,-100.119848),('57421','SD','Amherst','Marshall',45.755098,-97.927439),('57422','SD','Andover','Day',45.421382,-97.909125),('57424','SD','Ashton','Spink',45.007946,-98.536998),('57426','SD','Barnard','Brown',45.73408,-98.497307),('57427','SD','Bath','Brown',45.480547,-98.318576),('57428','SD','Bowdle','Edmunds',45.454315,-99.661763),('57429','SD','Brentford','Spink',45.169208,-98.30982),('57430','SD','Britton','Marshall',45.812693,-97.71958),('57432','SD','Claremont','Brown',45.672853,-98.020084),('57433','SD','Columbia','Brown',45.638241,-98.320765),('57434','SD','Conde','Spink',45.172705,-98.080116),('57435','SD','Cresbard','Faulk',45.179825,-98.929385),('57436','SD','Doland','Spink',44.863765,-98.07865),('57437','SD','Eureka','Mcpherson',45.796138,-99.604078),('57438','SD','Faulkton','Faulk',45.063918,-99.13442),('57439','SD','Ferney','Brown',45.334491,-98.089767),('57440','SD','Frankfort','Spink',44.856927,-98.271864),('57441','SD','Frederick','Brown',45.834346,-98.515067),('57442','SD','Gettysburg','Potter',45.013458,-100.083095),('57445','SD','Groton','Brown',45.454418,-98.133226),('57446','SD','Hecla','Brown',45.863039,-98.165244),('57448','SD','Hosmer','Edmunds',45.612884,-99.438546),('57449','SD','Houghton','Brown',45.744656,-98.201968),('57450','SD','Hoven','Potter',45.237798,-99.822276),('57451','SD','Ipswich','Edmunds',45.438054,-98.936499),('57452','SD','Java','Walworth',45.521495,-99.865063),('57454','SD','Langford','Marshall',45.609723,-97.762848),('57455','SD','Lebanon','Potter',45.026377,-99.767897),('57456','SD','Leola','Mcpherson',45.731697,-98.941343),('57457','SD','Longlake','Mcpherson',45.877277,-99.154299),('57460','SD','Mansfield','Brown',45.264994,-98.650162),('57461','SD','Mellette','Spink',45.164943,-98.462533),('57465','SD','Northville','Spink',45.12203,-98.666864),('57466','SD','Onaka','Faulk',45.223605,-99.460633),('57467','SD','Orient','Hand',44.84137,-99.121682),('57468','SD','Pierpont','Day',45.493347,-97.785785),('57469','SD','Redfield','Spink',44.864256,-98.540822),('57470','SD','Rockham','Faulk',44.882114,-98.84571),('57471','SD','Roscoe','Edmunds',45.404536,-99.318265),('57472','SD','Selby','Walworth',45.456542,-100.048392),('57473','SD','Seneca','Faulk',45.020473,-99.501661),('57474','SD','Stratford','Brown',45.306496,-98.278645),('57475','SD','Tolstoy','Potter',45.223553,-99.624615),('57476','SD','Tulare','Spink',44.713393,-98.594928),('57477','SD','Turton','Spink',45.060313,-98.151183),('57479','SD','Warner','Brown',45.321597,-98.464198),('57481','SD','Westport','Brown',45.641516,-98.61153),('57501','SD','Pierre','Hughes',44.41038,-100.291283),('57520','SD','Agar','Sully',44.845585,-100.132384),('57521','SD','Belvidere','Jackson',43.778507,-101.137223),('57522','SD','Blunt','Hughes',44.501845,-99.994871),('57523','SD','Burke','Gregory',43.184046,-99.277802),('57528','SD','Colome','Tripp',43.219739,-99.761321),('57529','SD','Dallas','Gregory',43.23784,-99.563438),('57531','SD','Draper','Jones',43.951693,-100.506751),('57532','SD','Fort Pierre','Stanley',44.353862,-100.460541),('57533','SD','Gregory','Gregory',43.280785,-99.428698),('57534','SD','Hamill','Tripp',43.583102,-99.697686),('57536','SD','Harrold','Hughes',44.46174,-99.775018),('57537','SD','Hayes','Stanley',44.544939,-101.07634),('57538','SD','Herrick','Gregory',43.088522,-99.147561),('57540','SD','Holabird','Hyde',44.476072,-99.593452),('57541','SD','Ideal','Tripp',43.632702,-99.891567),('57543','SD','Kadoka','Jackson',43.821313,-101.558668),('57544','SD','Kennebec','Lyman',43.893499,-99.861384),('57547','SD','Long Valley','Jackson',43.476993,-101.500312),('57548','SD','Lower Brule','Lyman',44.07402,-99.596443),('57551','SD','Martin','Bennett',43.170393,-101.704041),('57552','SD','Midland','Haakon',44.182465,-101.147601),('57553','SD','Milesville','Haakon',44.495215,-101.688781),('57555','SD','Mission','Todd',43.285887,-100.666557),('57559','SD','Murdo','Jones',43.908405,-100.71892),('57560','SD','Norris','Mellette',43.485038,-101.184219),('57562','SD','Okaton','Jones',43.884372,-100.94488),('57563','SD','Okreek','Todd',43.360193,-100.385151),('57564','SD','Onida','Sully',44.693386,-100.029809),('57566','SD','Parmelee','Todd',43.324556,-101.068971),('57567','SD','Philip','Haakon',44.037991,-101.727624),('57568','SD','Presho','Lyman',43.907894,-100.064458),('57569','SD','Reliance','Lyman',43.863825,-99.596998),('57570','SD','Rosebud','Todd',43.247546,-100.887509),('57571','SD','Saint Charles','Gregory',43.087371,-99.094676),('57572','SD','Saint Francis','Todd',43.148512,-100.97771),('57574','SD','Tuthill','Bennett',43.14613,-101.365503),('57576','SD','Vivian','Lyman',43.91184,-100.310685),('57577','SD','Wanblee','Jackson',43.525559,-101.726059),('57579','SD','White River','Mellette',43.59938,-100.781593),('57580','SD','Winner','Tripp',43.32703,-99.976013),('57584','SD','Witten','Tripp',43.493971,-100.077397),('57585','SD','Wood','Mellette',43.530579,-100.404109),('57601','SD','Mobridge','Walworth',45.530917,-100.444216),('57620','SD','Bison','Perkins',45.445367,-102.495894),('57621','SD','Bullhead','Corson',45.750774,-101.077831),('57622','SD','Cherry Creek','Ziebach',44.630281,-101.514192),('57623','SD','Dupree','Ziebach',45.045244,-101.665116),('57625','SD','Eagle Butte','Dewey',44.965044,-101.181559),('57626','SD','Faith','Meade',45.030523,-102.244035),('57630','SD','Glencross','Dewey',45.457253,-100.906004),('57631','SD','Glenham','Walworth',45.551195,-100.289922),('57632','SD','Herreid','Campbell',45.829455,-100.07925),('57633','SD','Isabel','Dewey',45.47213,-101.447579),('57634','SD','Keldron','Corson',45.811507,-101.855578),('57636','SD','Lantry','Dewey',45.030325,-101.438241),('57638','SD','Lemmon','Perkins',45.932248,-102.188059),('57639','SD','Little Eagle','Corson',45.686214,-100.79293),('57640','SD','Lodgepole','Perkins',45.820066,-102.745845),('57641','SD','Mc Intosh','Corson',45.936937,-101.340952),('57642','SD','Mc Laughlin','Corson',45.817918,-100.760224),('57644','SD','Meadow','Perkins',45.414735,-102.138171),('57645','SD','Morristown','Corson',46.005862,-101.754539),('57646','SD','Mound City','Campbell',45.68242,-100.081671),('57648','SD','Pollock','Campbell',45.914969,-100.345405),('57649','SD','Prairie City','Perkins',45.488704,-102.848894),('57650','SD','Ralph','Harding',45.871333,-103.015707),('57651','SD','Reva','Harding',45.522221,-103.096407),('57652','SD','Ridgeview','Dewey',45.176043,-100.636978),('57656','SD','Timber Lake','Dewey',45.437138,-101.088257),('57657','SD','Trail City','Corson',45.510826,-100.837098),('57658','SD','Wakpala','Corson',45.662669,-100.526301),('57659','SD','Walker','Corson',45.9168,-101.089),('57660','SD','Watauga','Corson',45.852643,-101.548194),('57661','SD','Whitehorse','Dewey',45.27434,-100.92197),('57701','SD','Rapid City','Pennington',44.085398,-103.214727),('57702','SD','Rapid City','Pennington',44.050414,-103.339467),('57703','SD','Rapid City','Pennington',44.056689,-103.132979),('57706','SD','Ellsworth Afb','Meade',44.147682,-103.072745),('57709','SD','Rapid City','Pennington',44.0798,-103.2146),('57714','SD','Allen','Bennett',43.302801,-101.93303),('57716','SD','Batesland','Shannon',43.124182,-102.199032),('57717','SD','Belle Fourche','Butte',44.725093,-103.898992),('57718','SD','Black Hawk','Meade',44.171639,-103.331238),('57719','SD','Box Elder','Pennington',44.126254,-103.06041),('57720','SD','Buffalo','Harding',45.588183,-103.638087),('57722','SD','Buffalo Gap','Custer',43.477582,-102.971364),('57724','SD','Camp Crook','Harding',45.5664,-104.02979),('57725','SD','Caputa','Pennington',43.947202,-102.850827),('57730','SD','Custer','Custer',43.752027,-103.611948),('57732','SD','Deadwood','Lawrence',44.313796,-103.685037),('57735','SD','Edgemont','Fall River',43.347248,-103.859574),('57737','SD','Enning','Meade',44.560996,-102.576776),('57738','SD','Fairburn','Custer',43.684261,-103.203931),('57741','SD','Fort Meade','Meade',44.409074,-103.474742),('57744','SD','Hermosa','Custer',43.793329,-103.077469),('57745','SD','Hill City','Pennington',43.998552,-103.68314),('57747','SD','Hot Springs','Fall River',43.417527,-103.494427),('57748','SD','Howes','Ziebach',44.549295,-102.14062),('57750','SD','Interior','Jackson',43.60972,-101.952488),('57751','SD','Keystone','Pennington',43.86915,-103.401788),('57752','SD','Kyle','Shannon',43.431536,-102.179583),('57754','SD','Lead','Lawrence',44.321649,-103.81636),('57755','SD','Ludlow','Harding',45.827883,-103.361394),('57756','SD','Manderson','Shannon',43.219532,-102.482942),('57758','SD','Mud Butte','Meade',44.980444,-102.784344),('57759','SD','Nemo','Lawrence',44.223248,-103.570126),('57760','SD','Newell','Butte',44.793746,-103.349093),('57761','SD','New Underwood','Pennington',44.133056,-102.788051),('57762','SD','Nisland','Butte',44.694536,-103.587224),('57763','SD','Oelrichs','Fall River',43.15097,-103.239658),('57764','SD','Oglala','Shannon',43.193705,-102.801439),('57766','SD','Oral','Fall River',43.379798,-103.270708),('57767','SD','Owanka','Pennington',44.102998,-102.589922),('57769','SD','Piedmont','Meade',44.230359,-103.334128),('57770','SD','Pine Ridge','Shannon',43.060356,-102.574925),('57772','SD','Porcupine','Shannon',43.441825,-102.468054),('57773','SD','Pringle','Custer',43.599787,-103.587046),('57775','SD','Quinn','Pennington',44.064117,-102.03807),('57776','SD','Redig','Harding',45.289209,-103.372225),('57779','SD','Saint Onge','Lawrence',44.55934,-103.738721),('57780','SD','Scenic','Pennington',43.748683,-102.431387),('57782','SD','Smithwick','Fall River',43.304038,-103.21559),('57783','SD','Spearfish','Lawrence',44.493813,-103.869926),('57785','SD','Sturgis','Meade',44.411515,-103.468621),('57787','SD','Union Center','Meade',44.6973,-102.657055),('57788','SD','Vale','Butte',44.61283,-103.37536),('57790','SD','Wall','Pennington',44.059564,-102.237828),('57791','SD','Wasta','Pennington',44.162378,-102.433924),('57792','SD','White Owl','Meade',44.584701,-102.361451),('57793','SD','Whitewood','Lawrence',44.485947,-103.604022),('57794','SD','Wounded Knee','Shannon',43.134654,-102.37908),('57799','SD','Spearfish','Lawrence',44.50189,-103.872172),('58001','ND','Abercrombie','Richland',46.44725,-96.72352),('58002','ND','Absaraka','Cass',46.9993,-97.3648),('58004','ND','Amenia','Cass',47.028317,-97.250321),('58005','ND','Argusville','Cass',47.057284,-96.950271),('58006','ND','Arthur','Cass',47.104452,-97.211233),('58007','ND','Ayr','Cass',47.023978,-97.469116),('58008','ND','Barney','Richland',46.289622,-96.998104),('58009','ND','Blanchard','Traill',47.332678,-97.231163),('58011','ND','Buffalo','Cass',46.918147,-97.539836),('58012','ND','Casselton','Cass',46.912518,-97.189324),('58013','ND','Cayuga','Sargent',46.069764,-97.354218),('58015','ND','Christine','Richland',46.594617,-96.823015),('58016','ND','Clifford','Traill',47.360575,-97.442223),('58017','ND','Cogswell','Sargent',46.059121,-97.809801),('58018','ND','Colfax','Richland',46.448813,-96.872524),('58021','ND','Davenport','Cass',46.735142,-97.081699),('58027','ND','Enderlin','Ransom',46.630594,-97.603802),('58029','ND','Erie','Cass',47.119024,-97.394066),('58030','ND','Fairmount','Richland',46.029532,-96.669372),('58031','ND','Fingal','Barnes',46.773877,-97.65962),('58032','ND','Forman','Sargent',46.091081,-97.631078),('58033','ND','Fort Ransom','Ransom',46.44913,-97.919438),('58035','ND','Galesburg','Traill',47.261511,-97.409395),('58036','ND','Gardner','Cass',47.158888,-96.94629),('58038','ND','Grandin','Cass',47.242335,-96.989384),('58040','ND','Gwinner','Sargent',46.221012,-97.74724),('58041','ND','Hankinson','Richland',46.063575,-96.906569),('58042','ND','Harwood','Cass',46.970758,-96.934845),('58043','ND','Havana','Sargent',45.979447,-97.55807),('58045','ND','Hillsboro','Traill',47.389656,-97.053504),('58046','ND','Hope','Steele',47.324273,-97.730377),('58047','ND','Horace','Cass',46.724263,-96.872758),('58048','ND','Hunter','Cass',47.198466,-97.217807),('58049','ND','Kathryn','Barnes',46.665777,-97.981663),('58051','ND','Kindred','Cass',46.642744,-97.01514),('58052','ND','Leonard','Cass',46.64221,-97.276708),('58053','ND','Lidgerwood','Richland',46.07134,-97.187652),('58054','ND','Lisbon','Ransom',46.434413,-97.673905),('58056','ND','Luverne','Steele',47.236889,-97.942676),('58057','ND','Mcleod','Richland',46.419808,-97.265026),('58058','ND','Mantador','Richland',46.174993,-96.979716),('58059','ND','Mapleton','Cass',46.844695,-97.108658),('58060','ND','Milnor','Sargent',46.251742,-97.42571),('58061','ND','Mooreton','Richland',46.276044,-96.8814),('58062','ND','Nome','Barnes',46.65194,-97.829115),('58063','ND','Oriska','Barnes',46.963829,-97.797242),('58064','ND','Page','Cass',47.15136,-97.603219),('58065','ND','Pillsbury','Barnes',47.185575,-97.764458),('58067','ND','Rutland','Sargent',46.05995,-97.488562),('58068','ND','Sheldon','Ransom',46.56506,-97.437627),('58069','ND','Stirum','Sargent',46.243105,-97.839635),('58071','ND','Tower City','Cass',46.936416,-97.676693),('58072','ND','Valley City','Barnes',46.925839,-98.012832),('58074','ND','Wahpeton','Richland',46.2651,-96.6133),('58075','ND','Wahpeton','Richland',46.271974,-96.678203),('58076','ND','Wahpeton','Richland',46.273562,-96.6073),('58077','ND','Walcott','Richland',46.535186,-96.937937),('58078','ND','West Fargo','Cass',46.864412,-96.904194),('58079','ND','Wheatland','Cass',46.875162,-97.346966),('58081','ND','Wyndmere','Richland',46.28179,-97.134764),('58102','ND','Fargo','Cass',46.897876,-96.810322),('58103','ND','Fargo','Cass',46.858396,-96.821158),('58104','ND','Fargo','Cass',46.812349,-96.8314),('58105','ND','Fargo','Cass',46.894071,-96.806495),('58106','ND','Fargo','Cass',46.8782,-96.7895),('58107','ND','Fargo','Cass',46.8782,-96.7895),('58108','ND','Fargo','Cass',46.8782,-96.7895),('58109','ND','Fargo','Cass',46.808,-96.8642),('58121','ND','Fargo','Cass',46.8772,-96.7894),('58122','ND','Fargo','Cass',46.8772,-96.7894),('58124','ND','Fargo','Cass',46.8772,-96.7894),('58125','ND','Fargo','Cass',46.8548,-96.8563),('58126','ND','Fargo','Cass',46.8772,-96.7894),('58201','ND','Grand Forks','Grand Forks',47.895612,-97.065961),('58202','ND','Grand Forks','Grand Forks',47.920759,-97.072208),('58203','ND','Grand Forks','Grand Forks',47.943996,-97.092212),('58204','ND','Grand Forks Afb','Grand Forks',47.953164,-97.375474),('58205','ND','Grand Forks Afb','Grand Forks',47.9516,-97.377867),('58206','ND','Grand Forks','Grand Forks',47.9252,-97.0325),('58207','ND','Grand Forks','Grand Forks',47.9252,-97.0325),('58208','ND','Grand Forks','Grand Forks',47.9252,-97.0325),('58210','ND','Adams','Walsh',48.405652,-98.09004),('58212','ND','Aneta','Nelson',47.69067,-98.005755),('58214','ND','Arvilla','Grand Forks',47.932258,-97.497152),('58216','ND','Bathgate','Pembina',48.874382,-97.451787),('58218','ND','Buxton','Traill',47.592293,-97.075133),('58219','ND','Caledonia','Traill',47.472392,-96.888432),('58220','ND','Cavalier','Pembina',48.788279,-97.712607),('58222','ND','Crystal','Pembina',48.609949,-97.678687),('58223','ND','Cummings','Traill',47.505232,-97.037889),('58224','ND','Dahlen','Nelson',48.168775,-97.937091),('58225','ND','Drayton','Pembina',48.606029,-97.206582),('58227','ND','Edinburg','Walsh',48.531097,-97.908002),('58228','ND','Emerado','Grand Forks',47.897009,-97.356034),('58229','ND','Fairdale','Walsh',48.493183,-98.233326),('58230','ND','Finley','Steele',47.492526,-97.821541),('58231','ND','Fordville','Walsh',48.202239,-97.829398),('58233','ND','Forest River','Walsh',48.223789,-97.52147),('58235','ND','Gilby','Grand Forks',48.092646,-97.470967),('58236','ND','Glasston','Pembina',48.714076,-97.447411),('58237','ND','Grafton','Walsh',48.421076,-97.409528),('58238','ND','Hamilton','Pembina',48.78294,-97.414751),('58239','ND','Hannah','Cavalier',48.954733,-98.716824),('58240','ND','Hatton','Traill',47.635906,-97.483627),('58241','ND','Hensel','Pembina',48.695712,-97.678053),('58243','ND','Hoople','Walsh',48.506916,-97.677178),('58244','ND','Inkster','Grand Forks',48.147796,-97.638648),('58249','ND','Langdon','Cavalier',48.812048,-98.33215),('58250','ND','Lankin','Walsh',48.288949,-97.97916),('58251','ND','Larimore','Grand Forks',47.93302,-97.666722),('58254','ND','Mcville','Nelson',47.764746,-98.16312),('58255','ND','Maida','Cavalier',48.999101,-98.352412),('58256','ND','Manvel','Grand Forks',48.083894,-97.190514),('58257','ND','Mayville','Traill',47.498962,-97.305085),('58258','ND','Mekinock','Grand Forks',48.012678,-97.344224),('58259','ND','Michigan','Nelson',48.039163,-98.119952),('58260','ND','Milton','Cavalier',48.623631,-98.036702),('58261','ND','Minto','Walsh',48.242266,-97.319417),('58262','ND','Mountain','Pembina',48.685801,-97.866718),('58265','ND','Neche','Pembina',48.956228,-97.590138),('58266','ND','Niagara','Grand Forks',47.998845,-97.850048),('58267','ND','Northwood','Grand Forks',47.751359,-97.612622),('58269','ND','Osnabrock','Cavalier',48.680891,-98.155244),('58270','ND','Park River','Walsh',48.398334,-97.763658),('58271','ND','Pembina','Pembina',48.927335,-97.280158),('58272','ND','Petersburg','Nelson',48.02928,-97.988771),('58273','ND','Pisek','Walsh',48.295967,-97.687952),('58274','ND','Portland','Traill',47.501362,-97.458919),('58275','ND','Reynolds','Grand Forks',47.68218,-97.110291),('58276','ND','Saint Thomas','Pembina',48.634305,-97.447192),('58277','ND','Sharon','Steele',47.615663,-97.823773),('58278','ND','Thompson','Grand Forks',47.772382,-97.110648),('58281','ND','Wales','Cavalier',48.858717,-98.605854),('58282','ND','Walhalla','Pembina',48.901361,-97.949568),('58301','ND','Devils Lake','Ramsey',48.114171,-98.87194),('58310','ND','Agate','Rolette',48.617378,-99.63453),('58311','ND','Alsen','Cavalier',48.6521,-98.590163),('58313','ND','Balta','Pierce',48.165299,-100.038402),('58316','ND','Belcourt','Rolette',48.842176,-99.764576),('58317','ND','Bisbee','Towner',48.62371,-99.37752),('58318','ND','Bottineau','Bottineau',48.86487,-100.413743),('58319','ND','Bremen','Wells',47.724,-99.3671),('58321','ND','Brocket','Ramsey',48.200714,-98.344818),('58323','ND','Calvin','Cavalier',48.859352,-98.90352),('58324','ND','Cando','Towner',48.47955,-99.206642),('58325','ND','Churchs Ferry','Ramsey',48.262289,-99.18276),('58327','ND','Crary','Ramsey',48.086422,-98.583882),('58329','ND','Dunseith','Rolette',48.863506,-100.052381),('58330','ND','Edmore','Ramsey',48.43375,-98.478781),('58331','ND','Egeland','Towner',48.638515,-99.090041),('58332','ND','Esmond','Benson',48.044159,-99.772971),('58335','ND','Fort Totten','Benson',47.981379,-99.003304),('58338','ND','Hampden','Ramsey',48.520873,-98.6351),('58339','ND','Hansboro','Towner',48.892233,-99.417151),('58341','ND','Harvey','Wells',47.782143,-99.865903),('58343','ND','Knox','Benson',48.312933,-99.707783),('58344','ND','Lakota','Nelson',48.027839,-98.341509),('58345','ND','Lawton','Ramsey',48.303674,-98.335345),('58346','ND','Leeds','Benson',48.28606,-99.434316),('58348','ND','Maddock','Benson',47.957314,-99.528058),('58351','ND','Minnewaukan','Benson',48.100693,-99.275633),('58352','ND','Munich','Cavalier',48.696049,-98.872682),('58353','ND','Mylo','Rolette',48.632368,-99.591636),('58355','ND','Nekoma','Cavalier',48.58926,-98.366384),('58356','ND','New Rockford','Eddy',47.67668,-99.112172),('58357','ND','Oberon','Benson',47.924265,-99.223062),('58361','ND','Pekin','Nelson',47.775981,-98.331888),('58362','ND','Penn','Ramsey',48.216806,-99.090154),('58363','ND','Perth','Towner',48.740019,-99.449191),('58365','ND','Rocklake','Towner',48.844093,-99.266203),('58366','ND','Rolette','Rolette',48.668213,-99.874072),('58367','ND','Rolla','Rolette',48.861969,-99.605964),('58368','ND','Rugby','Pierce',48.274356,-100.031294),('58369','ND','Saint John','Rolette',48.943639,-99.797109),('58370','ND','Saint Michael','Benson',47.989719,-98.866422),('58372','ND','Sarles','Cavalier',48.943487,-99.00144),('58374','ND','Sheyenne','Eddy',47.833081,-99.107216),('58377','ND','Starkweather','Ramsey',48.453706,-98.868244),('58379','ND','Tokio','Benson',47.919438,-98.818319),('58380','ND','Tolna','Nelson',47.811522,-98.505281),('58381','ND','Warwick','Benson',47.832303,-98.725247),('58382','ND','Webster','Ramsey',48.318001,-98.799048),('58384','ND','Willow City','Bottineau',48.608934,-100.265348),('58385','ND','Wolford','Pierce',48.490608,-99.672832),('58386','ND','York','Benson',48.303584,-99.598866),('58401','ND','Jamestown','Stutsman',46.901478,-98.724901),('58402','ND','Jamestown','Stutsman',46.882286,-98.68756),('58405','ND','Jamestown','Stutsman',46.91509,-98.698882),('58413','ND','Ashley','Mcintosh',46.035484,-99.358095),('58415','ND','Berlin','Lamoure',46.373335,-98.489402),('58416','ND','Binford','Griggs',47.536557,-98.36136),('58418','ND','Bowdon','Wells',47.436053,-99.660731),('58420','ND','Buchanan','Stutsman',47.073584,-98.816542),('58421','ND','Carrington','Foster',47.44358,-99.094236),('58422','ND','Cathay','Wells',47.593517,-99.405537),('58423','ND','Chaseley','Wells',47.42173,-99.830503),('58424','ND','Cleveland','Stutsman',46.885947,-99.106796),('58425','ND','Cooperstown','Griggs',47.448582,-98.124585),('58426','ND','Courtenay','Stutsman',47.218524,-98.589253),('58428','ND','Dawson','Kidder',46.864671,-99.745499),('58429','ND','Dazey','Barnes',47.200811,-98.131372),('58430','ND','Denhoff','Sheridan',47.55238,-100.26675),('58431','ND','Dickey','Lamoure',46.527622,-98.473704),('58433','ND','Edgeley','Lamoure',46.359397,-98.712027),('58436','ND','Ellendale','Dickey',46.060924,-98.555485),('58438','ND','Fessenden','Wells',47.666874,-99.602381),('58439','SD','Forbes','Mcpherson',45.974328,-98.829483),('58440','ND','Fredonia','Logan',46.287943,-99.148379),('58441','ND','Fullerton','Dickey',46.181343,-98.391755),('58442','ND','Gackle','Logan',46.596908,-99.161647),('58443','ND','Glenfield','Foster',47.46428,-98.659779),('58444','ND','Goodrich','Sheridan',47.508581,-100.129036),('58445','ND','Grace City','Foster',47.550704,-98.79915),('58448','ND','Hannaford','Griggs',47.314582,-98.223122),('58451','ND','Hurdsfield','Wells',47.454185,-99.937184),('58452','ND','Jessie','Griggs',47.543348,-98.237588),('58454','ND','Jud','Lamoure',46.578051,-98.912032),('58455','ND','Kensal','Stutsman',47.284117,-98.753353),('58456','ND','Kulm','Lamoure',46.280275,-98.946446),('58458','ND','Lamoure','Lamoure',46.36511,-98.305024),('58460','ND','Lehr','Mcintosh',46.281596,-99.336433),('58461','ND','Litchville','Barnes',46.649481,-98.191629),('58463','ND','Mcclusky','Sheridan',47.485008,-100.471338),('58464','ND','Mchenry','Foster',47.601237,-98.586289),('58466','ND','Marion','Lamoure',46.609041,-98.369188),('58467','ND','Medina','Stutsman',46.874839,-99.33051),('58472','ND','Montpelier','Stutsman',46.639405,-98.629121),('58474','ND','Oakes','Dickey',46.115184,-98.104441),('58475','ND','Pettibone','Kidder',47.14699,-99.534225),('58476','ND','Pingree','Stutsman',47.205115,-98.973965),('58477','ND','Regan','Burleigh',47.218641,-100.505625),('58478','ND','Robinson','Kidder',47.149547,-99.745776),('58479','ND','Rogers','Barnes',47.092281,-98.182703),('58480','ND','Sanborn','Barnes',46.924981,-98.238273),('58481','ND','Spiritwood','Barnes',46.935323,-98.434047),('58482','ND','Steele','Kidder',46.86444,-99.91241),('58483','ND','Streeter','Stutsman',46.641105,-99.403054),('58484','ND','Sutton','Griggs',47.382732,-98.457033),('58486','ND','Sykeston','Wells',47.4213,-99.404722),('58487','ND','Tappen','Kidder',46.856829,-99.605753),('58488','ND','Tuttle','Kidder',47.169164,-99.999295),('58490','ND','Verona','Lamoure',46.368371,-98.061327),('58492','ND','Wimbledon','Barnes',47.156383,-98.441265),('58494','ND','Wing','Burleigh',47.149326,-100.259975),('58495','ND','Wishek','Mcintosh',46.262831,-99.592037),('58496','ND','Woodworth','Stutsman',47.14646,-99.328693),('58497','ND','Ypsilanti','Stutsman',46.770124,-98.555756),('58501','ND','Bismarck','Burleigh',46.818156,-100.760601),('58502','ND','Bismarck','Burleigh',46.849,-100.7169),('58503','ND','Bismarck','Burleigh',46.861738,-100.777775),('58504','ND','Bismarck','Burleigh',46.765361,-100.753212),('58505','ND','Bismarck','Burleigh',46.82126,-100.781312),('58506','ND','Bismarck','Burleigh',46.7287,-100.6156),('58507','ND','Bismarck','Burleigh',46.849,-100.7169),('58520','ND','Almont','Morton',46.706773,-101.530411),('58521','ND','Baldwin','Burleigh',47.028177,-100.733096),('58523','ND','Beulah','Mercer',47.284637,-101.781514),('58524','ND','Braddock','Emmons',46.582,-100.073961),('58528','ND','Cannon Ball','Sioux',46.338628,-100.636798),('58529','ND','Carson','Grant',46.34468,-101.56793),('58530','ND','Center','Oliver',47.131904,-101.164206),('58531','ND','Coleharbor','Mclean',47.560001,-101.217018),('58532','ND','Driscoll','Burleigh',46.847398,-100.109279),('58533','ND','Elgin','Grant',46.41924,-101.812643),('58535','ND','Flasher','Morton',46.501772,-101.247276),('58538','ND','Fort Yates','Sioux',46.099022,-100.674239),('58540','ND','Garrison','Mclean',47.639285,-101.57839),('58541','ND','Golden Valley','Mercer',47.306811,-102.065447),('58542','ND','Hague','Emmons',46.068267,-100.01626),('58544','ND','Hazelton','Emmons',46.489267,-100.336519),('58545','ND','Hazen','Mercer',47.331069,-101.587417),('58549','ND','Kintyre','Emmons',46.461509,-99.936411),('58552','ND','Linton','Emmons',46.2472,-100.28306),('58554','ND','Mandan','Morton',46.804843,-100.919395),('58558','ND','Menoken','Burleigh',46.813503,-100.530736),('58559','ND','Mercer','Mclean',47.465672,-100.726809),('58560','ND','Moffit','Burleigh',46.664796,-100.267288),('58561','ND','Napoleon','Logan',46.473478,-99.715607),('58562','ND','New Leipzig','Grant',46.377861,-101.995682),('58563','ND','New Salem','Morton',46.908264,-101.444215),('58564','ND','Raleigh','Grant',46.291488,-101.357779),('58565','ND','Riverdale','Mclean',47.494707,-101.377107),('58566','ND','Saint Anthony','Morton',46.580444,-100.921865),('58568','ND','Selfridge','Sioux',46.059168,-100.996881),('58569','ND','Shields','Grant',46.243646,-101.186411),('58570','ND','Solen','Morton',46.403063,-100.884268),('58571','ND','Stanton','Mercer',47.288087,-101.372159),('58572','ND','Sterling','Burleigh',46.836367,-100.341036),('58573','ND','Strasburg','Emmons',46.123757,-100.181054),('58575','ND','Turtle Lake','Mclean',47.534572,-100.897533),('58576','ND','Underwood','Mclean',47.433915,-101.192358),('58577','ND','Washburn','Mclean',47.31773,-101.052291),('58579','ND','Wilton','Mclean',47.178779,-100.761463),('58580','ND','Zap','Mercer',47.2808,-101.90497),('58581','ND','Zeeland','Mcintosh',46.028106,-99.816114),('58601','ND','Dickinson','Stark',46.886385,-102.797851),('58602','ND','Dickinson','Stark',46.8791,-102.7891),('58620','ND','Amidon','Slope',46.497896,-103.37416),('58621','ND','Beach','Golden Valley',46.984779,-103.962604),('58622','ND','Belfield','Stark',46.894326,-103.220901),('58623','ND','Bowman','Bowman',46.186898,-103.415721),('58625','ND','Dodge','Dunn',47.290135,-102.198115),('58626','ND','Dunn Center','Dunn',47.353996,-102.618141),('58627','ND','Fairfield','Billings',47.206238,-103.264891),('58630','ND','Gladstone','Stark',46.926663,-102.570297),('58631','ND','Glen Ullin','Morton',46.798688,-101.837419),('58632','ND','Golva','Golden Valley',46.703996,-103.95181),('58634','ND','Grassy Butte','Mckenzie',47.416699,-103.374073),('58636','ND','Halliday','Dunn',47.392699,-102.36402),('58638','ND','Hebron','Morton',46.912108,-102.038458),('58639','ND','Hettinger','Adams',46.053745,-102.619276),('58640','ND','Killdeer','Dunn',47.407559,-102.863815),('58641','ND','Lefor','Stark',46.667877,-102.513912),('58642','ND','Manning','Dunn',47.212991,-102.795037),('58643','ND','Marmarth','Slope',46.301368,-103.934837),('58644','ND','Marshall','Dunn',47.138,-102.3325),('58645','ND','Medora','Billings',46.914875,-103.566968),('58646','ND','Mott','Hettinger',46.392913,-102.287643),('58647','ND','New England','Hettinger',46.520926,-102.90104),('58649','ND','Reeder','Adams',46.125724,-102.914842),('58650','ND','Regent','Hettinger',46.405851,-102.602326),('58651','ND','Rhame','Bowman',46.255679,-103.719798),('58652','ND','Richardton','Stark',46.853743,-102.268477),('58653','ND','Scranton','Bowman',46.086572,-103.130077),('58654','ND','Sentinel Butte','Golden Valley',46.851937,-103.78489),('58655','ND','South Heart','Stark',46.825671,-103.025675),('58656','ND','Taylor','Stark',46.94001,-102.448553),('58701','ND','Minot','Ward',48.201556,-101.275558),('58702','ND','Minot','Ward',48.1385,-101.391),('58703','ND','Minot','Ward',48.283341,-101.315716),('58704','ND','Minot Afb','Ward',48.423604,-101.320223),('58705','ND','Minot Afb','Ward',48.42335,-101.331934),('58707','ND','Minot','Ward',48.246292,-101.300519),('58710','ND','Anamoose','Mchenry',47.882149,-100.232642),('58711','ND','Antler','Bottineau',48.936495,-101.293215),('58712','ND','Balfour','Mchenry',47.970973,-100.531684),('58713','ND','Bantry','Mchenry',48.508885,-100.608398),('58716','ND','Benedict','Mclean',47.815703,-101.076055),('58718','ND','Berthold','Ward',48.332465,-101.766163),('58721','ND','Bowbells','Burke',48.814514,-102.272829),('58722','ND','Burlington','Ward',48.271309,-101.459856),('58723','ND','Butte','Mclean',47.789732,-100.606809),('58725','ND','Carpio','Ward',48.481061,-101.679899),('58727','ND','Columbus','Burke',48.858779,-102.798154),('58730','ND','Crosby','Divide',48.890738,-103.322873),('58731','ND','Deering','Mchenry',48.422216,-100.983926),('58733','ND','Des Lacs','Ward',48.189443,-101.587849),('58734','ND','Donnybrook','Ward',48.504363,-101.927371),('58735','ND','Douglas','Ward',47.877021,-101.496644),('58736','ND','Drake','Mchenry',47.924479,-100.388593),('58737','ND','Flaxton','Burke',48.91786,-102.403984),('58740','ND','Glenburn','Renville',48.480435,-101.223026),('58741','ND','Granville','Mchenry',48.266034,-100.835284),('58744','ND','Karlsruhe','Mchenry',48.116546,-100.61532),('58746','ND','Kenmare','Ward',48.693581,-102.082696),('58748','ND','Kramer','Bottineau',48.684066,-100.667291),('58750','ND','Lansford','Bottineau',48.625609,-101.397254),('58752','ND','Lignite','Burke',48.856362,-102.57929),('58755','ND','Mcgregor','Williams',48.611567,-102.940327),('58756','ND','Makoti','Ward',47.962584,-101.810847),('58757','ND','Mandaree','Mckenzie',47.686282,-102.555817),('58758','ND','Martin','Sheridan',47.801559,-100.101078),('58759','ND','Max','Mclean',47.862054,-101.259097),('58760','ND','Maxbass','Bottineau',48.697536,-101.157943),('58761','ND','Mohall','Renville',48.774397,-101.534828),('58762','ND','Newburg','Bottineau',48.668973,-100.939598),('58763','ND','New Town','Mountrail',47.977932,-102.542164),('58765','ND','Noonan','Divide',48.88563,-103.048425),('58768','ND','Norwich','Mchenry',48.228307,-101.013326),('58769','ND','Palermo','Mountrail',48.334434,-102.219157),('58770','ND','Parshall','Mountrail',47.901272,-102.156025),('58771','ND','Plaza','Mountrail',48.059358,-101.954529),('58772','ND','Portal','Burke',48.973988,-102.600861),('58773','ND','Powers Lake','Burke',48.58258,-102.657837),('58775','ND','Roseglen','Mclean',47.710059,-101.861201),('58776','ND','Ross','Mountrail',48.254469,-102.59122),('58778','ND','Ruso','Mclean',47.787886,-100.934223),('58779','ND','Ryder','Ward',47.869389,-101.775409),('58781','ND','Sawyer','Ward',48.030096,-101.112359),('58782','ND','Sherwood','Renville',48.944346,-101.70467),('58783','ND','Souris','Bottineau',48.900931,-100.764052),('58784','ND','Stanley','Mountrail',48.3489,-102.407692),('58785','ND','Surrey','Ward',48.261864,-101.112077),('58787','ND','Tolley','Renville',48.747524,-101.79001),('58788','ND','Towner','Mchenry',48.345799,-100.467754),('58789','ND','Upham','Mchenry',48.567668,-100.787577),('58790','ND','Velva','Mchenry',48.043721,-100.936218),('58792','ND','Voltaire','Mchenry',47.985774,-100.768446),('58793','ND','Westhope','Bottineau',48.872266,-101.027725),('58794','ND','White Earth','Mountrail',48.312513,-102.786863),('58795','ND','Wildrose','Williams',48.625384,-103.157282),('58801','ND','Williston','Williams',48.175933,-103.701655),('58802','ND','Williston','Williams',48.3,-103.6892),('58830','ND','Alamo','Williams',48.586629,-103.467016),('58831','ND','Alexander','Mckenzie',47.831683,-103.650397),('58833','ND','Ambrose','Divide',48.930262,-103.497886),('58835','ND','Arnegard','Mckenzie',47.761007,-103.44395),('58838','ND','Cartwright','Mckenzie',47.833401,-103.92631),('58843','ND','Epping','Williams',48.248265,-103.378022),('58844','ND','Fortuna','Divide',48.861799,-103.728163),('58845','ND','Grenora','Williams',48.633663,-103.935902),('58847','ND','Keene','Mckenzie',47.919688,-102.909086),('58849','ND','Ray','Williams',48.30615,-103.184911),('58852','ND','Tioga','Williams',48.36439,-102.946888),('58853','ND','Trenton','Williams',48.068958,-103.837557),('58854','ND','Watford City','Mckenzie',47.814932,-103.203888),('58856','ND','Zahl','Williams',48.558703,-103.700636),('59001','MT','Absarokee','Stillwater',45.502143,-109.49196),('59002','MT','Acton','Yellowstone',45.938408,-108.685468),('59003','MT','Ashland','Rosebud',45.495438,-106.204529),('59004','MT','Ashland','Rosebud',45.5944,-106.2702),('59006','MT','Ballantine','Yellowstone',45.947362,-108.098413),('59007','MT','Bearcreek','Carbon',45.161003,-109.166844),('59008','MT','Belfry','Carbon',45.097956,-109.062145),('59010','MT','Bighorn','Treasure',46.033336,-107.316876),('59011','MT','Big Timber','Sweet Grass',45.877684,-109.955774),('59012','MT','Birney','Rosebud',45.296029,-106.491394),('59013','MT','Boyd','Carbon',45.470096,-109.082885),('59014','MT','Bridger','Carbon',45.26438,-108.807367),('59015','MT','Broadview','Yellowstone',46.081749,-108.852505),('59016','MT','Busby','Big Horn',45.419289,-106.972087),('59018','MT','Clyde Park','Park',45.853458,-110.585874),('59019','MT','Columbus','Stillwater',45.63448,-109.267349),('59020','MT','Cooke City','Park',45.047867,-109.935072),('59022','MT','Crow Agency','Big Horn',45.591335,-107.437239),('59024','MT','Custer','Yellowstone',46.113122,-107.597322),('59025','MT','Decker','Big Horn',45.08485,-106.705426),('59026','MT','Edgar','Carbon',45.467471,-108.82901),('59027','MT','Emigrant','Park',45.26604,-110.862174),('59028','MT','Fishtail','Stillwater',45.37501,-109.6516),('59029','MT','Fromberg','Carbon',45.38549,-108.847183),('59030','MT','Gardiner','Park',45.072568,-110.697534),('59031','MT','Garryowen','Big Horn',45.503905,-107.414191),('59032','MT','Grass Range','Fergus',47.089525,-108.748293),('59033','MT','Greycliff','Sweet Grass',45.735402,-109.682903),('59034','MT','Hardin','Big Horn',45.752504,-107.596569),('59035','MT','Yellowtail','Big Horn',45.318466,-107.946589),('59036','MT','Harlowton','Wheatland',46.453486,-109.925164),('59037','MT','Huntley','Yellowstone',45.845711,-108.292527),('59038','MT','Hysham','Treasure',46.080263,-107.141801),('59039','MT','Ingomar','Rosebud',46.686774,-107.291122),('59041','MT','Joliet','Carbon',45.493437,-108.954978),('59043','MT','Lame Deer','Rosebud',45.591336,-106.645909),('59044','MT','Laurel','Yellowstone',45.66679,-108.762135),('59046','MT','Lavina','Golden Valley',46.398483,-109.015696),('59047','MT','Livingston','Park',45.63831,-110.548752),('59050','MT','Lodge Grass','Big Horn',45.276849,-107.454626),('59052','MT','Mc Leod','Sweet Grass',45.527268,-110.136341),('59053','MT','Martinsdale','Meagher',46.479211,-110.408948),('59054','MT','Melstone','Musselshell',46.641179,-107.808628),('59055','MT','Melville','Sweet Grass',46.114672,-109.820201),('59057','MT','Molt','Yellowstone',45.846346,-108.933516),('59058','MT','Mosby','Garfield',47.020297,-107.846099),('59059','MT','Musselshell','Musselshell',46.461071,-108.08601),('59061','MT','Nye','Stillwater',45.433084,-109.812026),('59062','MT','Otter','Powder River',45.106589,-106.138958),('59063','MT','Park City','Stillwater',45.627461,-108.943708),('59064','MT','Pompeys Pillar','Yellowstone',45.93629,-107.929143),('59065','MT','Pray','Park',45.305883,-110.751441),('59066','MT','Pryor','Big Horn',45.335866,-108.510339),('59067','MT','Rapelje','Stillwater',45.956436,-109.271174),('59068','MT','Red Lodge','Carbon',45.20971,-109.324387),('59069','MT','Reed Point','Stillwater',45.716839,-109.562399),('59070','MT','Roberts','Carbon',45.374663,-109.196985),('59071','MT','Roscoe','Carbon',45.308631,-109.524174),('59072','MT','Roundup','Musselshell',46.487645,-108.512409),('59073','MT','Roundup','Musselshell',46.4961,-108.568),('59074','MT','Ryegate','Golden Valley',46.354573,-109.253347),('59075','MT','Saint Xavier','Big Horn',45.394747,-107.869168),('59076','MT','Sanders','Treasure',46.291252,-107.075571),('59077','MT','Sand Springs','Garfield',47.108914,-107.626297),('59078','MT','Shawmut','Wheatland',46.368068,-109.516964),('59079','MT','Shepherd','Yellowstone',46.012938,-108.347607),('59081','MT','Silver Gate','Park',45.008335,-109.980904),('59082','MT','Springdale','Park',45.740702,-110.223424),('59083','MT','Sumatra','Rosebud',46.6688,-107.5815),('59084','MT','Teigen','Petroleum',47.1175,-108.2494),('59085','MT','Two Dot','Wheatland',46.425718,-110.118352),('59086','MT','Wilsall','Park',46.051286,-110.595802),('59087','MT','Winnett','Petroleum',47.007754,-108.215072),('59088','MT','Worden','Yellowstone',46.060727,-108.076854),('59089','MT','Wyola','Big Horn',45.062368,-107.416843),('59101','MT','Billings','Yellowstone',45.754177,-108.485475),('59102','MT','Billings','Yellowstone',45.779336,-108.576998),('59103','MT','Billings','Yellowstone',45.6349,-108.3635),('59104','MT','Billings','Yellowstone',45.7744,-108.4937),('59105','MT','Billings','Yellowstone',45.836462,-108.471175),('59106','MT','Billings','Yellowstone',45.780074,-108.663932),('59107','MT','Billings','Yellowstone',45.6349,-108.3635),('59108','MT','Billings','Yellowstone',45.7744,-108.4937),('59111','MT','Billings','Yellowstone',45.6349,-108.3635),('59112','MT','Billings','Yellowstone',45.7833,-108.5),('59114','MT','Billings','Yellowstone',45.6349,-108.3635),('59115','MT','Billings','Yellowstone',45.6349,-108.3635),('59116','MT','Billings','Yellowstone',45.6349,-108.3635),('59117','MT','Billings','Yellowstone',45.6349,-108.3635),('59201','MT','Wolf Point','Roosevelt',48.124845,-105.657713),('59211','MT','Antelope','Sheridan',48.715054,-104.386232),('59212','MT','Bainville','Roosevelt',48.14746,-104.194562),('59213','MT','Brockton','Roosevelt',48.144349,-104.857968),('59214','MT','Brockway','Mccone',47.303493,-106.073878),('59215','MT','Circle','Mccone',47.47749,-105.680879),('59217','MT','Crane','Richland',47.581945,-104.253194),('59218','MT','Culbertson','Roosevelt',48.117797,-104.518782),('59219','MT','Dagmar','Sheridan',48.552336,-104.190565),('59221','MT','Fairview','Richland',47.892963,-104.108462),('59222','MT','Flaxville','Daniels',48.744339,-105.158519),('59223','MT','Fort Peck','Valley',47.959994,-106.382074),('59225','MT','Frazer','Valley',48.249588,-105.966707),('59226','MT','Froid','Roosevelt',48.332794,-104.494916),('59230','MT','Glasgow','Valley',48.170765,-106.693065),('59231','MT','Saint Marie','Valley',48.404059,-106.544427),('59240','MT','Glentana','Valley',48.851361,-106.247559),('59241','MT','Hinsdale','Valley',48.355708,-107.117113),('59242','MT','Homestead','Sheridan',48.425652,-104.464897),('59243','MT','Lambert','Richland',47.75825,-104.664068),('59244','MT','Larslan','Valley',48.620523,-106.315871),('59247','MT','Medicine Lake','Sheridan',48.505455,-104.494136),('59248','MT','Nashua','Valley',48.13839,-106.355034),('59250','MT','Opheim','Valley',48.81695,-106.465903),('59252','MT','Outlook','Sheridan',48.903442,-104.787865),('59253','MT','Peerless','Daniels',48.739561,-105.856909),('59254','MT','Plentywood','Sheridan',48.766125,-104.565129),('59255','MT','Poplar','Roosevelt',48.116677,-105.145471),('59256','MT','Raymond','Sheridan',48.909312,-104.584127),('59257','MT','Redstone','Sheridan',48.779103,-104.970067),('59258','MT','Reserve','Sheridan',48.589145,-104.634686),('59259','MT','Richey','Dawson',47.739698,-105.042375),('59260','MT','Richland','Valley',48.73914,-106.085615),('59261','MT','Saco','Phillips',48.554385,-107.403256),('59262','MT','Savage','Richland',47.481756,-104.370225),('59263','MT','Scobey','Daniels',48.79159,-105.459072),('59270','MT','Sidney','Richland',47.626467,-104.034727),('59273','MT','Vandalia','Valley',48.3547,-106.9091),('59274','MT','Vida','Mccone',47.819279,-105.416641),('59275','MT','Westby','Sheridan',48.882013,-104.174887),('59276','MT','Whitetail','Daniels',48.911889,-105.196563),('59301','MT','Miles City','Custer',46.330746,-105.813455),('59311','MT','Alzada','Carter',45.158774,-104.456856),('59312','MT','Angela','Garfield',47.065573,-106.154764),('59313','MT','Baker','Fallon',46.354215,-104.279904),('59314','MT','Biddle','Powder River',45.080012,-105.358999),('59315','MT','Bloomfield','Dawson',47.441726,-104.906932),('59316','MT','Boyes','Carter',45.4795,-104.8742),('59317','MT','Broadus','Powder River',45.387429,-105.483704),('59318','MT','Brusett','Garfield',47.436259,-107.386687),('59319','MT','Capitol','Carter',45.4668,-104.169),('59322','MT','Cohagen','Garfield',47.02372,-106.682096),('59323','MT','Colstrip','Rosebud',45.913526,-106.641098),('59324','MT','Ekalaka','Carter',45.799485,-104.523549),('59326','MT','Fallon','Prairie',46.832616,-105.038166),('59327','MT','Forsyth','Rosebud',46.161734,-106.701953),('59330','MT','Glendive','Dawson',47.102871,-104.729219),('59332','MT','Hammond','Carter',45.358289,-104.675501),('59333','MT','Hathaway','Rosebud',46.274106,-106.20664),('59336','MT','Ismay','Custer',46.344314,-104.884736),('59337','MT','Jordan','Garfield',47.317697,-106.915425),('59338','MT','Kinsey','Custer',46.630332,-105.617867),('59339','MT','Lindsay','Dawson',47.257992,-105.209893),('59341','MT','Mildred','Prairie',46.7376,-104.7992),('59343','MT','Olive','Powder River',45.656119,-105.437803),('59344','MT','Plevna','Fallon',46.475633,-104.564738),('59345','MT','Powderville','Powder River',45.7401,-105.216),('59347','MT','Rosebud','Rosebud',46.393832,-106.372059),('59349','MT','Terry','Prairie',46.786866,-105.36611),('59351','MT','Volborg','Powder River',45.766174,-105.790912),('59353','MT','Wibaux','Wibaux',46.960463,-104.189694),('59354','MT','Willard','Fallon',46.181244,-104.369246),('59401','MT','Great Falls','Cascade',47.509023,-111.273779),('59402','MT','Malmstrom A F B','Cascade',47.5113,-111.1783),('59403','MT','Great Falls','Cascade',47.5066,-111.303),('59404','MT','Great Falls','Cascade',47.51504,-111.341098),('59405','MT','Great Falls','Cascade',47.460998,-111.271066),('59406','MT','Great Falls','Cascade',47.4498,-111.1766),('59410','MT','Augusta','Lewis And Clark',47.444895,-112.476679),('59411','MT','Babb','Glacier',48.84332,-113.412731),('59412','MT','Belt','Cascade',47.35507,-110.89569),('59414','MT','Black Eagle','Cascade',47.52635,-111.278232),('59416','MT','Brady','Pondera',48.04517,-111.645011),('59417','MT','Browning','Glacier',48.569943,-113.038381),('59418','MT','Buffalo','Judith Basin',46.810547,-109.895481),('59419','MT','Bynum','Teton',47.977789,-112.391084),('59420','MT','Carter','Chouteau',47.822732,-111.011788),('59421','MT','Cascade','Cascade',47.196295,-111.776159),('59422','MT','Choteau','Teton',47.833481,-112.343246),('59424','MT','Coffee Creek','Fergus',47.336307,-110.108586),('59425','MT','Conrad','Pondera',48.185326,-111.939566),('59427','MT','Cut Bank','Glacier',48.668252,-112.418274),('59430','MT','Denton','Fergus',47.358612,-109.914812),('59432','MT','Dupuyer','Pondera',48.172199,-112.479312),('59433','MT','Dutton','Teton',47.889989,-111.750059),('59434','MT','East Glacier Park','Glacier',48.429264,-113.232886),('59435','MT','Ethridge','Toole',48.5577,-112.1197),('59436','MT','Fairfield','Teton',47.623971,-112.025622),('59440','MT','Floweree','Chouteau',47.697956,-111.150911),('59441','MT','Forest Grove','Fergus',46.860554,-108.988855),('59442','MT','Fort Benton','Chouteau',47.860734,-110.626723),('59443','MT','Fort Shaw','Cascade',47.560181,-111.826069),('59444','MT','Galata','Liberty',48.638976,-111.295438),('59446','MT','Geraldine','Chouteau',47.616555,-110.24125),('59447','MT','Geyser','Judith Basin',47.26575,-110.486314),('59448','MT','Heart Butte','Pondera',48.268799,-112.828081),('59450','MT','Highwood','Chouteau',47.57466,-110.699186),('59451','MT','Hilger','Fergus',47.356558,-109.376473),('59452','MT','Hobson','Judith Basin',46.882286,-110.064185),('59453','MT','Judith Gap','Wheatland',46.645831,-109.674929),('59454','MT','Kevin','Toole',48.738786,-111.977501),('59456','MT','Ledger','Toole',48.27015,-111.36167),('59457','MT','Lewistown','Fergus',47.076328,-109.455823),('59460','MT','Loma','Chouteau',48.03033,-110.498291),('59461','MT','Lothair','Liberty',48.484729,-111.222365),('59462','MT','Moccasin','Judith Basin',47.09159,-109.893638),('59463','MT','Monarch','Cascade',47.029906,-110.832691),('59464','MT','Moore','Fergus',46.939581,-109.702317),('59465','MT','Neihart','Cascade',46.885093,-110.70447),('59466','MT','Oilmont','Toole',48.747653,-111.785806),('59467','MT','Pendroy','Teton',48.101248,-112.398135),('59468','MT','Power','Teton',47.705014,-111.652868),('59469','MT','Raynesford','Judith Basin',47.256438,-110.726558),('59471','MT','Roy','Fergus',47.386338,-108.83347),('59472','MT','Sand Coulee','Cascade',47.412569,-111.153662),('59474','MT','Shelby','Toole',48.486846,-111.79757),('59477','MT','Simms','Cascade',47.477927,-111.92564),('59479','MT','Stanford','Judith Basin',47.065375,-110.277871),('59480','MT','Stockett','Cascade',47.293787,-111.142401),('59482','MT','Sunburst','Toole',48.871569,-111.912187),('59483','MT','Sun River','Cascade',47.461203,-111.712717),('59484','MT','Sweet Grass','Toole',48.998111,-111.896493),('59485','MT','Ulm','Cascade',47.411363,-111.536809),('59486','MT','Valier','Pondera',48.300703,-112.308331),('59487','MT','Vaughn','Cascade',47.578488,-111.600849),('59489','MT','Winifred','Fergus',47.584055,-109.302095),('59501','MT','Havre','Hill',48.598975,-109.754055),('59520','MT','Big Sandy','Chouteau',48.158575,-110.068881),('59521','MT','Box Elder','Hill',48.31293,-109.916296),('59522','MT','Chester','Liberty',48.517968,-111.005069),('59523','MT','Chinook','Blaine',48.52498,-109.195484),('59524','MT','Dodson','Phillips',48.22898,-108.336962),('59525','MT','Gildford','Hill',48.689648,-110.302843),('59526','MT','Harlem','Blaine',48.45453,-108.746258),('59527','MT','Hays','Blaine',48.026397,-108.693853),('59528','MT','Hingham','Hill',48.563839,-110.400959),('59529','MT','Hogeland','Blaine',48.833128,-108.662221),('59530','MT','Inverness','Hill',48.602794,-110.695563),('59531','MT','Joplin','Liberty',48.686136,-110.783192),('59532','MT','Kremlin','Hill',48.593783,-110.074655),('59535','MT','Lloyd','Blaine',48.024426,-109.29484),('59537','MT','Loring','Phillips',48.854829,-107.986468),('59538','MT','Malta','Phillips',48.23575,-107.807392),('59540','MT','Rudyard','Hill',48.573697,-110.564625),('59542','MT','Turner','Blaine',48.807468,-108.379369),('59544','MT','Whitewater','Phillips',48.757637,-107.619156),('59545','MT','Whitlash','Liberty',48.93269,-111.180101),('59546','MT','Zortman','Phillips',47.845156,-108.607001),('59547','MT','Zurich','Blaine',48.617483,-109.027157),('59601','MT','Helena','Lewis And Clark',46.590058,-112.046067),('59602','MT','Helena','Lewis And Clark',46.696186,-111.975345),('59604','MT','Helena','Lewis And Clark',46.6075,-112.0122),('59620','MT','Helena','Lewis And Clark',46.5325,-112.1589),('59623','MT','Helena','Lewis And Clark',46.5325,-112.1589),('59624','MT','Helena','Lewis And Clark',46.6075,-112.0122),('59625','MT','Helena','Lewis And Clark',46.601,-112.0391),('59626','MT','Helena','Lewis And Clark',46.5927,-112.0352),('59631','MT','Basin','Jefferson',46.316738,-112.320094),('59632','MT','Boulder','Jefferson',46.218436,-112.060006),('59633','MT','Canyon Creek','Lewis And Clark',46.801369,-112.339224),('59634','MT','Clancy','Jefferson',46.495029,-111.979207),('59635','MT','East Helena','Lewis And Clark',46.58667,-111.895004),('59636','MT','Fort Harrison','Lewis And Clark',46.622482,-112.104521),('59638','MT','Jefferson City','Jefferson',46.36705,-112.037239),('59639','MT','Lincoln','Lewis And Clark',46.962061,-112.616727),('59640','MT','Marysville','Lewis And Clark',46.74351,-112.307418),('59641','MT','Radersburg','Broadwater',46.1391,-111.6682),('59642','MT','Ringling','Meagher',46.28703,-110.74355),('59643','MT','Toston','Broadwater',46.171381,-111.549999),('59644','MT','Townsend','Broadwater',46.392604,-111.459329),('59645','MT','White Sulphur Springs','Meagher',46.639871,-111.057247),('59647','MT','Winston','Broadwater',46.479237,-111.685423),('59648','MT','Wolf Creek','Lewis And Clark',47.080714,-112.079777),('59701','MT','Butte','Silver Bow',46.001293,-112.512308),('59702','MT','Butte','Silver Bow',45.9077,-112.4929),('59703','MT','Butte','Silver Bow',46.046876,-112.532994),('59707','MT','Butte','Silver Bow',45.9077,-112.4929),('59710','MT','Alder','Madison',45.119614,-112.042909),('59711','MT','Anaconda','Deer Lodge',46.129584,-112.971717),('59713','MT','Avon','Powell',46.628653,-112.575587),('59714','MT','Belgrade','Gallatin',45.832547,-111.170553),('59715','MT','Bozeman','Gallatin',45.702429,-110.999525),('59716','MT','Big Sky','Gallatin',45.243854,-111.407871),('59717','MT','Bozeman','Gallatin',45.6678,-111.0499),('59718','MT','Bozeman','Gallatin',45.66215,-111.12471),('59719','MT','Bozeman','Gallatin',45.6476,-111.171),('59720','MT','Cameron','Madison',44.943202,-111.614568),('59721','MT','Cardwell','Madison',45.847919,-111.868259),('59722','MT','Deer Lodge','Powell',46.36677,-112.74342),('59724','MT','Dell','Beaverhead',44.719246,-112.721552),('59725','MT','Dillon','Beaverhead',45.159034,-112.775375),('59727','MT','Divide','Silver Bow',45.832995,-112.797813),('59728','MT','Elliston','Powell',46.551116,-112.407401),('59729','MT','Ennis','Madison',45.299716,-111.70442),('59730','MT','Gallatin Gateway','Gallatin',45.316688,-111.187294),('59731','MT','Garrison','Powell',46.546832,-112.77065),('59732','MT','Glen','Beaverhead',45.502721,-112.728818),('59733','MT','Gold Creek','Powell',46.571067,-112.924226),('59735','MT','Harrison','Madison',45.671865,-111.815023),('59736','MT','Jackson','Beaverhead',45.345905,-113.367249),('59739','MT','Lima','Beaverhead',44.653172,-112.32185),('59740','MT','Mc Allister','Madison',45.464692,-111.783349),('59741','MT','Manhattan','Gallatin',45.821085,-111.321397),('59743','MT','Melrose','Silver Bow',45.649851,-112.698359),('59745','MT','Norris','Madison',45.567496,-111.651208),('59746','MT','Polaris','Beaverhead',45.355065,-113.080127),('59747','MT','Pony','Madison',45.663963,-111.918768),('59748','MT','Ramsay','Silver Bow',46.025159,-112.707419),('59749','MT','Sheridan','Madison',45.45474,-112.160727),('59750','MT','Butte','Silver Bow',45.96476,-112.693571),('59751','MT','Silver Star','Madison',45.625164,-112.491113),('59752','MT','Three Forks','Gallatin',45.901007,-111.529016),('59754','MT','Twin Bridges','Madison',45.47316,-112.349794),('59755','MT','Virginia City','Madison',45.334497,-111.954964),('59756','MT','Warm Springs','Deer Lodge',46.188275,-112.79344),('59758','MT','West Yellowstone','Gallatin',44.727922,-111.18559),('59759','MT','Whitehall','Jefferson',45.855779,-112.204177),('59760','MT','Willow Creek','Gallatin',45.809895,-111.685226),('59761','MT','Wisdom','Beaverhead',45.659129,-113.576966),('59762','MT','Wise River','Beaverhead',45.808525,-113.148923),('59771','MT','Bozeman','Gallatin',45.6785,-111.0374),('59772','MT','Bozeman','Gallatin',45.6785,-111.0374),('59773','MT','Bozeman','Gallatin',45.6785,-111.0374),('59801','MT','Missoula','Missoula',46.856223,-114.013183),('59802','MT','Missoula','Missoula',46.879614,-113.952266),('59803','MT','Missoula','Missoula',46.820928,-114.014174),('59804','MT','Missoula','Missoula',46.869523,-114.113889),('59806','MT','Missoula','Missoula',46.8516,-114.0141),('59807','MT','Missoula','Missoula',47.0005,-113.9872),('59808','MT','Missoula','Missoula',46.932171,-114.082842),('59812','MT','Missoula','Missoula',46.8625,-113.9808),('59820','MT','Alberton','Mineral',46.91703,-114.579006),('59821','MT','Arlee','Lake',47.178096,-114.070522),('59823','MT','Bonner','Missoula',46.951045,-113.53443),('59824','MT','Charlo','Lake',47.420671,-114.180141),('59825','MT','Clinton','Missoula',46.72748,-113.691975),('59826','MT','Condon','Missoula',47.470616,-113.73091),('59827','MT','Conner','Ravalli',45.900086,-114.069229),('59828','MT','Corvallis','Ravalli',46.330396,-114.077559),('59829','MT','Darby','Ravalli',45.845479,-114.226452),('59830','MT','De Borgia','Mineral',47.399854,-115.334414),('59831','MT','Dixon','Sanders',47.307011,-114.337452),('59832','MT','Drummond','Granite',46.678196,-113.230428),('59833','MT','Florence','Ravalli',46.64528,-114.029976),('59834','MT','Frenchtown','Missoula',47.040432,-114.248957),('59835','MT','Grantsdale','Ravalli',46.1351,-114.1869),('59837','MT','Hall','Granite',46.537656,-113.284327),('59840','MT','Hamilton','Ravalli',46.209005,-114.163263),('59841','MT','Pinesdale','Ravalli',46.333498,-114.222195),('59842','MT','Haugan','Mineral',47.369723,-115.405894),('59843','MT','Helmville','Powell',46.843011,-112.901925),('59844','MT','Heron','Sanders',48.042479,-115.96705),('59845','MT','Hot Springs','Sanders',47.68009,-114.587406),('59846','MT','Huson','Missoula',47.1114,-114.490179),('59847','MT','Lolo','Missoula',46.708454,-114.379625),('59848','MT','Lonepine','Sanders',47.710009,-114.689787),('59851','MT','Milltown','Missoula',46.871065,-113.881379),('59853','MT','Noxon','Sanders',48.008232,-115.781089),('59854','MT','Ovando','Powell',47.020417,-113.098393),('59855','MT','Pablo','Lake',47.600678,-114.118769),('59856','MT','Paradise','Sanders',47.367801,-114.787088),('59858','MT','Philipsburg','Granite',46.296821,-113.39844),('59859','MT','Plains','Sanders',47.517761,-114.87857),('59860','MT','Polson','Lake',47.693499,-114.146131),('59863','MT','Ravalli','Lake',47.278874,-114.183389),('59864','MT','Ronan','Lake',47.536223,-114.115499),('59865','MT','Saint Ignatius','Lake',47.331329,-114.058901),('59866','MT','Saint Regis','Mineral',47.326842,-115.14477),('59867','MT','Saltese','Mineral',47.426299,-115.589411),('59868','MT','Seeley Lake','Missoula',47.187673,-113.494502),('59870','MT','Stevensville','Ravalli',46.524841,-114.051677),('59871','MT','Sula','Ravalli',45.871835,-113.86658),('59872','MT','Superior','Mineral',47.141597,-114.850512),('59873','MT','Thompson Falls','Sanders',47.668305,-115.297327),('59874','MT','Trout Creek','Sanders',47.822957,-115.595717),('59875','MT','Victor','Ravalli',46.409498,-114.173693),('59901','MT','Kalispell','Flathead',48.211154,-114.316341),('59903','MT','Kalispell','Flathead',48.079,-113.7287),('59904','MT','Kalispell','Flathead',48.079,-113.7287),('59910','MT','Big Arm','Lake',47.787733,-114.331535),('59911','MT','Bigfork','Flathead',47.967672,-113.973603),('59912','MT','Columbia Falls','Flathead',48.378639,-114.183136),('59913','MT','Coram','Flathead',48.43854,-114.028805),('59914','MT','Dayton','Lake',47.864379,-114.283863),('59915','MT','Elmo','Lake',47.834472,-114.354581),('59916','MT','Essex','Flathead',48.2904,-113.596691),('59917','MT','Eureka','Lincoln',48.881914,-114.986065),('59918','MT','Fortine','Lincoln',48.767472,-114.933965),('59919','MT','Hungry Horse','Flathead',48.220814,-113.763143),('59920','MT','Kila','Flathead',48.058045,-114.519004),('59921','MT','Lake Mc Donald','Flathead',48.605472,-113.88505),('59922','MT','Lakeside','Flathead',47.998548,-114.229104),('59923','MT','Libby','Lincoln',48.287134,-115.331924),('59925','MT','Marion','Flathead',48.078824,-114.807248),('59926','MT','Martin City','Flathead',48.387441,-114.032223),('59927','MT','Olney','Flathead',48.556623,-114.638043),('59928','MT','Polebridge','Flathead',48.766789,-114.391989),('59929','MT','Proctor','Lake',47.927006,-114.357008),('59930','MT','Rexford','Lincoln',48.877814,-115.156214),('59931','MT','Rollins','Lake',47.908985,-114.200904),('59932','MT','Somers','Flathead',48.05785,-114.248312),('59933','MT','Stryker','Lincoln',48.679108,-114.786636),('59934','MT','Trego','Lincoln',48.648304,-114.906553),('59935','MT','Troy','Lincoln',48.585514,-115.874901),('59936','MT','West Glacier','Flathead',48.557499,-113.988651),('59937','MT','Whitefish','Flathead',48.409256,-114.423028),('60001','IL','Alden','Mchenry',42.4588,-88.5177),('60002','IL','Antioch','Lake',42.467513,-88.095821),('60004','IL','Arlington Heights','Cook',42.110869,-87.979139),('60005','IL','Arlington Heights','Cook',42.06334,-87.982957),('60006','IL','Arlington Heights','Cook',42.088,-87.9944),('60007','IL','Elk Grove Village','Cook',42.005755,-87.996951),('60008','IL','Rolling Meadows','Cook',42.071851,-88.024933),('60009','IL','Elk Grove Village','Cook',42.0149,-87.9789),('60010','IL','Barrington','Lake',42.163892,-88.152531),('60011','IL','Barrington','Lake',42.1523,-88.1349),('60012','IL','Crystal Lake','Mchenry',42.266884,-88.31558),('60013','IL','Cary','Mchenry',42.217552,-88.244486),('60014','IL','Crystal Lake','Mchenry',42.229176,-88.332121),('60015','IL','Deerfield','Lake',42.170385,-87.871782),('60016','IL','Des Plaines','Cook',42.04807,-87.889612),('60017','IL','Des Plaines','Cook',42.0237,-87.9003),('60018','IL','Des Plaines','Cook',42.007866,-87.893368),('60019','IL','Des Plaines','Cook',42.0237,-87.9003),('60020','IL','Fox Lake','Lake',42.391881,-88.174675),('60021','IL','Fox River Grove','Mchenry',42.194697,-88.217108),('60022','IL','Glencoe','Cook',42.131032,-87.764618),('60025','IL','Glenview','Cook',42.074711,-87.818574),('60026','IL','Glenview','Cook',42.091151,-87.837827),('60029','IL','Golf','Cook',42.059195,-87.780334),('60030','IL','Grayslake','Lake',42.34082,-88.033563),('60031','IL','Gurnee','Lake',42.37678,-87.937912),('60033','IL','Harvard','Mchenry',42.42343,-88.61291),('60034','IL','Hebron','Mchenry',42.468054,-88.433419),('60035','IL','Highland Park','Lake',42.184815,-87.809259),('60037','IL','Fort Sheridan','Lake',42.21196,-87.808081),('60038','IL','Palatine','Cook',42.1258,-88.0764),('60039','IL','Crystal Lake','Mchenry',42.2411,-88.3161),('60040','IL','Highwood','Lake',42.205883,-87.811629),('60041','IL','Ingleside','Lake',42.372588,-88.151438),('60042','IL','Island Lake','Mchenry',42.279267,-88.199084),('60043','IL','Kenilworth','Cook',42.088182,-87.715725),('60044','IL','Lake Bluff','Lake',42.285334,-87.862892),('60045','IL','Lake Forest','Lake',42.235997,-87.864777),('60046','IL','Lake Villa','Lake',42.414131,-88.056365),('60047','IL','Lake Zurich','Lake',42.19995,-88.05776),('60048','IL','Libertyville','Lake',42.29218,-87.952096),('60049','IL','Long Grove','Lake',42.1783,-87.9977),('60050','IL','Mchenry','Mchenry',42.340282,-88.282305),('60051','IL','Mchenry','Mchenry',42.351188,-88.224845),('60053','IL','Morton Grove','Cook',42.042501,-87.785893),('60055','IL','Palatine','Cook',42.1258,-88.0764),('60056','IL','Mount Prospect','Cook',42.063908,-87.936023),('60060','IL','Mundelein','Lake',42.263519,-88.014542),('60061','IL','Vernon Hills','Lake',42.23085,-87.966694),('60062','IL','Northbrook','Cook',42.126279,-87.845088),('60064','IL','North Chicago','Lake',42.324002,-87.853093),('60065','IL','Northbrook','Cook',42.1385,-87.8875),('60067','IL','Palatine','Cook',42.106017,-88.055789),('60068','IL','Park Ridge','Cook',42.011818,-87.841004),('60069','IL','Lincolnshire','Lake',42.190977,-87.928151),('60070','IL','Prospect Heights','Cook',42.105569,-87.928235),('60071','IL','Richmond','Mchenry',42.468357,-88.299795),('60072','IL','Ringwood','Mchenry',42.397548,-88.30695),('60073','IL','Round Lake','Lake',42.358724,-88.101722),('60074','IL','Palatine','Cook',42.128306,-88.02193),('60075','IL','Russell','Lake',42.4905,-87.9125),('60076','IL','Skokie','Cook',42.033741,-87.730998),('60077','IL','Skokie','Cook',42.03381,-87.755834),('60078','IL','Palatine','Cook',42.1102,-88.0341),('60079','IL','Waukegan','Lake',42.3642,-87.8317),('60081','IL','Spring Grove','Mchenry',42.439678,-88.216507),('60082','IL','Techny','Cook',42.1131,-87.8004),('60083','IL','Wadsworth','Lake',42.435447,-87.937555),('60084','IL','Wauconda','Lake',42.268985,-88.139155),('60085','IL','Waukegan','Lake',42.358578,-87.862933),('60086','IL','North Chicago','Lake',42.3321,-87.84),('60087','IL','Waukegan','Lake',42.406116,-87.862863),('60088','IL','Great Lakes','Lake',42.30723,-87.851418),('60089','IL','Buffalo Grove','Lake',42.165981,-87.961826),('60090','IL','Wheeling','Cook',42.1323,-87.931221),('60091','IL','Wilmette','Cook',42.076756,-87.717578),('60092','IL','Libertyville','Lake',42.283,-87.953),('60093','IL','Winnetka','Cook',42.104067,-87.753933),('60094','IL','Palatine','Cook',42.1258,-88.0764),('60095','IL','Palatine','Cook',42.0967,-88.0112),('60096','IL','Winthrop Harbor','Lake',42.483323,-87.83196),('60097','IL','Wonder Lake','Mchenry',42.383577,-88.350069),('60098','IL','Woodstock','Mchenry',42.314419,-88.437252),('60099','IL','Zion','Lake',42.453209,-87.848417),('60101','IL','Addison','Dupage',41.932243,-88.006036),('60102','IL','Algonquin','Mchenry',42.16347,-88.303237),('60103','IL','Bartlett','Dupage',41.977229,-88.201131),('60104','IL','Bellwood','Cook',41.88246,-87.87746),('60105','IL','Bensenville','Du Page',41.9536,-87.935),('60106','IL','Bensenville','Dupage',41.954196,-87.946042),('60107','IL','Streamwood','Cook',42.023115,-88.177461),('60108','IL','Bloomingdale','Dupage',41.949191,-88.085652),('60109','IL','Burlington','Kane',42.050291,-88.546772),('60110','IL','Carpentersville','Kane',42.12423,-88.276247),('60111','IL','Clare','Dekalb',42.008519,-88.839284),('60112','IL','Cortland','Dekalb',41.924797,-88.690186),('60113','IL','Creston','Ogle',41.931576,-88.965096),('60115','IL','Dekalb','Dekalb',41.925959,-88.748001),('60116','IL','Carol Stream','Du Page',41.9166,-88.1209),('60117','IL','Bloomingdale','Du Page',41.9539,-88.0869),('60118','IL','Dundee','Kane',42.101139,-88.293945),('60119','IL','Elburn','Kane',41.879626,-88.463193),('60120','IL','Elgin','Kane',42.03816,-88.259452),('60121','IL','Elgin','Kane',42.0372,-88.2811),('60122','IL','Carol Stream','Kane',42.0372,-88.2811),('60123','IL','Elgin','Kane',42.037536,-88.307577),('60124','IL','Elgin','Kane',42.025141,-88.377782),('60125','IL','Carol Stream','Du Page',41.9166,-88.1209),('60126','IL','Elmhurst','Dupage',41.891128,-87.94188),('60128','IL','Carol Stream','Du Page',41.9166,-88.1209),('60129','IL','Esmond','Dekalb',42.015127,-88.951708),('60130','IL','Forest Park','Cook',41.871044,-87.812018),('60131','IL','Franklin Park','Cook',41.935702,-87.874885),('60132','IL','Carol Stream','Du Page',41.9166,-88.1209),('60133','IL','Hanover Park','Cook',41.97968,-88.144617),('60134','IL','Geneva','Kane',41.882072,-88.329337),('60135','IL','Genoa','Dekalb',42.097756,-88.691625),('60136','IL','Gilberts','Kane',42.095515,-88.367653),('60137','IL','Glen Ellyn','Dupage',41.869729,-88.062695),('60138','IL','Glen Ellyn','Du Page',41.8775,-88.0669),('60139','IL','Glendale Heights','Dupage',41.918877,-88.078095),('60140','IL','Hampshire','Kane',42.090084,-88.490841),('60141','IL','Hines','Cook',41.858448,-87.837344),('60142','IL','Huntley','Mchenry',42.165662,-88.432135),('60143','IL','Itasca','Dupage',41.972278,-88.022272),('60144','IL','Kaneville','Kane',41.835529,-88.521845),('60145','IL','Kingston','Dekalb',42.100386,-88.769886),('60146','IL','Kirkland','Dekalb',42.100452,-88.874353),('60147','IL','Lafox','Kane',41.8867,-88.4086),('60148','IL','Lombard','Dupage',41.873793,-88.017158),('60150','IL','Malta','Dekalb',41.921884,-88.875374),('60151','IL','Maple Park','Kane',41.918475,-88.574468),('60152','IL','Marengo','Mchenry',42.240158,-88.609668),('60153','IL','Maywood','Cook',41.880222,-87.844784),('60154','IL','Westchester','Cook',41.853995,-87.885084),('60155','IL','Broadview','Cook',41.861271,-87.854764),('60156','IL','Lake In The Hills','Mchenry',42.187357,-88.353069),('60157','IL','Medinah','Dupage',41.970657,-88.056173),('60159','IL','Schaumburg','Cook',42.0333,-88.0833),('60160','IL','Melrose Park','Cook',41.899983,-87.858428),('60161','IL','Melrose Park','Cook',41.9071,-87.8643),('60162','IL','Hillside','Cook',41.873671,-87.9016),('60163','IL','Berkeley','Cook',41.884607,-87.911868),('60164','IL','Melrose Park','Cook',41.917222,-87.897577),('60165','IL','Stone Park','Cook',41.904483,-87.879734),('60168','IL','Schaumburg','Cook',42.0269,-88.092),('60169','IL','Hoffman Estates','Cook',42.049962,-88.109095),('60170','IL','Plato Center','Kane',42.0266,-88.43),('60171','IL','River Grove','Cook',41.928827,-87.841263),('60172','IL','Roselle','Dupage',41.980221,-88.088059),('60173','IL','Schaumburg','Cook',42.052152,-88.048595),('60174','IL','Saint Charles','Kane',41.921254,-88.306552),('60175','IL','Saint Charles','Kane',41.94695,-88.385068),('60176','IL','Schiller Park','Cook',41.957145,-87.870405),('60177','IL','South Elgin','Kane',41.992501,-88.308269),('60178','IL','Sycamore','Dekalb',41.994356,-88.681627),('60179','IL','Hoffman Estates','Cook',42.0269,-88.092),('60180','IL','Union','Mchenry',42.232104,-88.532804),('60181','IL','Villa Park','Dupage',41.880571,-87.976447),('60183','IL','Wasco','Kane',41.938,-88.4044),('60184','IL','Wayne','Dupage',41.952151,-88.255407),('60185','IL','West Chicago','Dupage',41.891894,-88.204982),('60186','IL','West Chicago','Du Page',41.8847,-88.2038),('60187','IL','Wheaton','Dupage',41.871659,-88.108151),('60188','IL','Carol Stream','Dupage',41.91487,-88.132866),('60189','IL','Wheaton','Dupage',41.840491,-88.117938),('60190','IL','Winfield','Dupage',41.874737,-88.152676),('60191','IL','Wood Dale','Dupage',41.963467,-87.978332),('60192','IL','Schaumburg','Cook',42.066951,-88.182777),('60193','IL','Schaumburg','Cook',42.009561,-88.102844),('60194','IL','Schaumburg','Cook',42.036293,-88.116705),('60195','IL','Schaumburg','Cook',42.065234,-88.090371),('60196','IL','Schaumburg','Cook',42.0269,-88.092),('60197','IL','Carol Stream','Du Page',41.9166,-88.1209),('60199','IL','Carol Stream','Du Page',41.9166,-88.1209),('60201','IL','Evanston','Cook',42.055423,-87.698461),('60202','IL','Evanston','Cook',42.031301,-87.68965),('60203','IL','Evanston','Cook',42.047899,-87.716688),('60204','IL','Evanston','Cook',42.0472,-87.6872),('60208','IL','Evanston','Cook',42.0491,-87.677),('60209','IL','Evanston','Cook',42.0472,-87.6872),('60290','IL','Chicago','Cook',41.9613,-87.8849),('60301','IL','Oak Park','Cook',41.887936,-87.79895),('60302','IL','Oak Park','Cook',41.895418,-87.78857),('60303','IL','Oak Park','Cook',41.8884,-87.7971),('60304','IL','Oak Park','Cook',41.872781,-87.788504),('60305','IL','River Forest','Cook',41.892963,-87.817147),('60399','IL','Wood Dal','Du Page',41.9552,-87.9401),('60401','IL','Beecher','Will',41.350682,-87.623791),('60402','IL','Berwyn','Cook',41.838997,-87.789948),('60403','IL','Crest Hill','Will',41.562869,-88.11858),('60404','IL','Shorewood','Will',41.513594,-88.212806),('60406','IL','Blue Island','Cook',41.657585,-87.680434),('60407','IL','Braceville','Grundy',41.230738,-88.265874),('60408','IL','Braidwood','Will',41.26229,-88.223148),('60409','IL','Calumet City','Cook',41.613648,-87.549822),('60410','IL','Channahon','Will',41.427067,-88.223893),('60411','IL','Chicago Heights','Cook',41.506781,-87.611889),('60412','IL','Chicago Heights','Cook',41.5053,-87.5926),('60415','IL','Chicago Ridge','Cook',41.702245,-87.778728),('60416','IL','Coal City','Grundy',41.293992,-88.278896),('60417','IL','Crete','Will',41.44725,-87.609535),('60419','IL','Dolton','Cook',41.627271,-87.59839),('60420','IL','Dwight','Livingston',41.091299,-88.425291),('60421','IL','Elwood','Will',41.428124,-88.103698),('60422','IL','Flossmoor','Cook',41.539424,-87.685696),('60423','IL','Frankfort','Will',41.49619,-87.84063),('60424','IL','Gardner','Grundy',41.178602,-88.32067),('60425','IL','Glenwood','Cook',41.544537,-87.612683),('60426','IL','Harvey','Cook',41.612639,-87.652288),('60428','IL','Markham','Cook',41.597681,-87.690822),('60429','IL','Hazel Crest','Cook',41.57382,-87.680201),('60430','IL','Homewood','Cook',41.557043,-87.66361),('60431','IL','Joliet','Will',41.54036,-88.19817),('60432','IL','Joliet','Will',41.534956,-88.052563),('60433','IL','Joliet','Will',41.508405,-88.056246),('60434','IL','Joliet','Will',41.515,-88.1307),('60435','IL','Joliet','Will',41.543328,-88.122714),('60436','IL','Joliet','Will',41.505851,-88.109076),('60437','IL','Kinsman','Grundy',41.173771,-88.557901),('60438','IL','Lansing','Cook',41.567463,-87.546318),('60439','IL','Lemont','Cook',41.67733,-87.984934),('60440','IL','Bolingbrook','Will',41.703377,-88.074301),('60441','IL','Lockport','Will',41.586996,-88.046481),('60442','IL','Manhattan','Will',41.421946,-87.975846),('60443','IL','Matteson','Cook',41.507108,-87.741041),('60444','IL','Mazon','Grundy',41.246588,-88.403074),('60445','IL','Midlothian','Cook',41.631744,-87.730796),('60446','IL','Romeoville','Will',41.635657,-88.109946),('60447','IL','Minooka','Grundy',41.465342,-88.291091),('60448','IL','Mokena','Will',41.536712,-87.888307),('60449','IL','Monee','Will',41.422499,-87.755745),('60450','IL','Morris','Grundy',41.370814,-88.407508),('60451','IL','New Lenox','Will',41.508926,-87.96273),('60452','IL','Oak Forest','Cook',41.606636,-87.753326),('60453','IL','Oak Lawn','Cook',41.71519,-87.75383),('60454','IL','Oak Lawn','Cook',41.7089,-87.8028),('60455','IL','Bridgeview','Cook',41.741536,-87.807348),('60456','IL','Hometown','Cook',41.730295,-87.73241),('60457','IL','Hickory Hills','Cook',41.723836,-87.827189),('60458','IL','Justice','Cook',41.744674,-87.834218),('60459','IL','Burbank','Cook',41.74589,-87.77023),('60460','IL','Odell','Livingston',41.001943,-88.523863),('60461','IL','Olympia Fields','Cook',41.515941,-87.685788),('60462','IL','Orland Park','Cook',41.623103,-87.83576),('60463','IL','Palos Heights','Cook',41.665351,-87.791441),('60464','IL','Palos Park','Cook',41.665079,-87.846884),('60465','IL','Palos Hills','Cook',41.698861,-87.827948),('60466','IL','Park Forest','Cook',41.482916,-87.683147),('60467','IL','Orland Park','Cook',41.593341,-87.888671),('60468','IL','Peotone','Will',41.331525,-87.800406),('60469','IL','Posen','Cook',41.628217,-87.686572),('60470','IL','Ransom','La Salle',41.163608,-88.638637),('60471','IL','Richton Park','Cook',41.481851,-87.727506),('60472','IL','Robbins','Cook',41.643003,-87.709287),('60473','IL','South Holland','Cook',41.596377,-87.601266),('60474','IL','South Wilmington','Grundy',41.179801,-88.266441),('60475','IL','Steger','Will',41.470255,-87.633701),('60476','IL','Thornton','Cook',41.571368,-87.607592),('60477','IL','Tinley Park','Cook',41.577264,-87.788442),('60478','IL','Country Club Hills','Cook',41.5614,-87.722787),('60479','IL','Verona','Grundy',41.226237,-88.514935),('60480','IL','Willow Springs','Cook',41.736471,-87.874719),('60481','IL','Wilmington','Will',41.307869,-88.153373),('60482','IL','Worth','Cook',41.688211,-87.792577),('60484','IL','University Park','Will',41.44063,-87.697016),('60487','IL','Tinley Park','Cook',41.566284,-87.832933),('60490','IL','Bolingbrook','Will',41.680461,-88.141688),('60491','IL','Homer Glen','Will',41.610417,-87.96402),('60499','IL','Bedford Park','Cook',41.7627,-87.8),('60501','IL','Summit Argo','Cook',41.783871,-87.816155),('60502','IL','Aurora','Dupage',41.790651,-88.259738),('60503','IL','Aurora','Will',41.714471,-88.257471),('60504','IL','Aurora','Dupage',41.743403,-88.244106),('60505','IL','Aurora','Kane',41.760159,-88.298646),('60506','IL','Aurora','Kane',41.762433,-88.348744),('60507','IL','Aurora','Kane',41.7605,-88.32),('60510','IL','Batavia','Kane',41.845003,-88.304335),('60511','IL','Big Rock','Kane',41.756334,-88.543931),('60512','IL','Bristol','Kendall',41.701155,-88.42636),('60513','IL','Brookfield','Cook',41.823313,-87.847682),('60514','IL','Clarendon Hills','Dupage',41.793079,-87.957252),('60515','IL','Downers Grove','Dupage',41.804488,-88.016591),('60516','IL','Downers Grove','Dupage',41.761403,-88.011544),('60517','IL','Woodridge','Dupage',41.74036,-88.041919),('60518','IL','Earlville','La Salle',41.598881,-88.919842),('60519','IL','Eola','Dupage',41.777617,-88.242366),('60520','IL','Hinckley','Dekalb',41.774935,-88.646287),('60521','IL','Hinsdale','Dupage',41.801949,-87.929971),('60522','IL','Hinsdale','Du Page',41.8037,-87.927),('60523','IL','Oak Brook','Dupage',41.837408,-87.958605),('60525','IL','La Grange','Cook',41.788565,-87.873615),('60526','IL','La Grange Park','Cook',41.83164,-87.869719),('60527','IL','Willowbrook','Dupage',41.74998,-87.934745),('60530','IL','Lee','Lee',41.797064,-88.952226),('60531','IL','Leland','La Salle',41.617859,-88.792368),('60532','IL','Lisle','Dupage',41.791715,-88.083985),('60534','IL','Lyons','Cook',41.813484,-87.823564),('60536','IL','Millbrook','Kendall',41.600949,-88.550655),('60537','IL','Millington','La Salle',41.562497,-88.600293),('60538','IL','Montgomery','Kendall',41.723867,-88.35558),('60539','IL','Mooseheart','Kane',41.825778,-88.333585),('60540','IL','Naperville','Dupage',41.764776,-88.141224),('60541','IL','Newark','Kendall',41.530381,-88.536004),('60542','IL','North Aurora','Kane',41.810247,-88.343336),('60543','IL','Oswego','Kendall',41.685662,-88.336208),('60544','IL','Plainfield','Will',41.617481,-88.193638),('60545','IL','Plano','Kendall',41.665066,-88.528516),('60546','IL','Riverside','Cook',41.840609,-87.82302),('60548','IL','Sandwich','Dekalb',41.648456,-88.63246),('60549','IL','Serena','La Salle',41.492389,-88.733805),('60550','IL','Shabbona','Dekalb',41.769348,-88.868765),('60551','IL','Sheridan','La Salle',41.526953,-88.684021),('60552','IL','Somonauk','La Salle',41.643372,-88.684924),('60553','IL','Steward','Lee',41.82571,-89.017077),('60554','IL','Sugar Grove','Kane',41.779671,-88.443004),('60555','IL','Warrenville','Dupage',41.821654,-88.188199),('60556','IL','Waterman','Dekalb',41.766676,-88.771742),('60557','IL','Wedron','La Salle',41.438531,-88.769339),('60558','IL','Western Springs','Cook',41.805505,-87.902382),('60559','IL','Westmont','Dupage',41.795435,-87.976032),('60560','IL','Yorkville','Kendall',41.635979,-88.440025),('60561','IL','Darien','Dupage',41.74773,-87.980738),('60563','IL','Naperville','Dupage',41.795736,-88.166924),('60564','IL','Naperville','Will',41.699798,-88.200866),('60565','IL','Naperville','Dupage',41.73001,-88.127843),('60566','IL','Naperville','Du Page',41.7858,-88.1472),('60567','IL','Naperville','Du Page',41.7858,-88.1472),('60568','IL','Aurora','Kane',41.7605,-88.32),('60570','IL','Hinsdale','Du Page',41.8478,-87.9042),('60572','IL','Aurora','Du Page',41.8017,-88.0685),('60585','IL','Plainfield','Will',41.653305,-88.231547),('60586','IL','Plainfield','Will',41.568719,-88.223333),('60597','IL','Fox Valley','Du Page',41.7631,-88.224),('60598','IL','Aurora','Du Page',41.7749,-88.2486),('60599','IL','Fox Valley','Du Page',41.7749,-88.2486),('60601','IL','Chicago','Cook',41.885656,-87.621511),('60602','IL','Chicago','Cook',41.882904,-87.628649),('60603','IL','Chicago','Cook',41.880411,-87.628543),('60604','IL','Chicago','Cook',41.877546,-87.628118),('60605','IL','Chicago','Cook',41.869511,-87.625067),('60606','IL','Chicago','Cook',41.882557,-87.636907),('60607','IL','Chicago','Cook',41.876898,-87.65321),('60608','IL','Chicago','Cook',41.85057,-87.669724),('60609','IL','Chicago','Cook',41.811421,-87.656859),('60610','IL','Chicago','Cook',41.905336,-87.634804),('60611','IL','Chicago','Cook',41.894586,-87.621528),('60612','IL','Chicago','Cook',41.880462,-87.687908),('60613','IL','Chicago','Cook',41.953536,-87.662789),('60614','IL','Chicago','Cook',41.922652,-87.653219),('60615','IL','Chicago','Cook',41.803146,-87.602679),('60616','IL','Chicago','Cook',41.846369,-87.6305),('60617','IL','Chicago','Cook',41.722423,-87.557291),('60618','IL','Chicago','Cook',41.947568,-87.702647),('60619','IL','Chicago','Cook',41.744879,-87.605361),('60620','IL','Chicago','Cook',41.740507,-87.651948),('60621','IL','Chicago','Cook',41.777084,-87.640208),('60622','IL','Chicago','Cook',41.902881,-87.680916),('60623','IL','Chicago','Cook',41.850655,-87.717809),('60624','IL','Chicago','Cook',41.879581,-87.722333),('60625','IL','Chicago','Cook',41.970471,-87.701852),('60626','IL','Chicago','Cook',42.008773,-87.668563),('60628','IL','Chicago','Cook',41.693705,-87.624633),('60629','IL','Chicago','Cook',41.777722,-87.709167),('60630','IL','Chicago','Cook',41.97063,-87.760079),('60631','IL','Chicago','Cook',41.998028,-87.810967),('60632','IL','Chicago','Cook',41.808281,-87.709165),('60633','IL','Chicago','Cook',41.655797,-87.554987),('60634','IL','Chicago','Cook',41.944317,-87.796851),('60636','IL','Chicago','Cook',41.776691,-87.668118),('60637','IL','Chicago','Cook',41.77928,-87.605569),('60638','IL','Chicago','Cook',41.787951,-87.772191),('60639','IL','Chicago','Cook',41.921381,-87.755145),('60640','IL','Chicago','Cook',41.972175,-87.664409),('60641','IL','Chicago','Cook',41.946583,-87.746788),('60642','IL','Chicago','Cook',41.899412,-87.659526),('60643','IL','Chicago','Cook',41.698716,-87.660264),('60644','IL','Chicago','Cook',41.882583,-87.756978),('60645','IL','Chicago','Cook',42.008356,-87.693762),('60646','IL','Chicago','Cook',41.991323,-87.763822),('60647','IL','Chicago','Cook',41.921215,-87.701028),('60649','IL','Chicago','Cook',41.760028,-87.572157),('60651','IL','Chicago','Cook',41.901419,-87.740737),('60652','IL','Chicago','Cook',41.744886,-87.711187),('60653','IL','Chicago','Cook',41.818759,-87.610505),('60654','IL','Chicago','Cook',41.892559,-87.636326),('60655','IL','Chicago','Cook',41.696167,-87.697745),('60656','IL','Chicago','Cook',41.975297,-87.8129),('60657','IL','Chicago','Cook',41.939627,-87.658045),('60659','IL','Chicago','Cook',41.990623,-87.703654),('60660','IL','Chicago','Cook',41.991519,-87.666404),('60661','IL','Chicago','Cook',41.882727,-87.644957),('60663','IL','Chicago','Cook',41.8767,-87.6381),('60664','IL','Chicago','Cook',41.85,-87.65),('60666','IL','Chicago,','Cook',41.9772,-87.8906),('60668','IL','Chicago','Cook',41.879,-87.6306),('60669','IL','Chicago','Cook',41.8767,-87.6381),('60670','IL','Chicago','Cook',41.8767,-87.6381),('60673','IL','Chicago','Cook',41.8767,-87.6381),('60674','IL','Chicago','Cook',41.8796,-87.6322),('60675','IL','Chicago','Cook',41.8767,-87.6381),('60677','IL','Chicago','Cook',41.8819,-87.6369),('60678','IL','Chicago','Cook',41.8767,-87.6381),('60679','IL','Chicago','Cook',41.8767,-87.6381),('60680','IL','Chicago','Cook',41.8767,-87.6381),('60681','IL','Chicago','Cook',41.8846,-87.6222),('60682','IL','Chicago','Cook',41.8649,-87.8115),('60684','IL','Chicago','Cook',41.8767,-87.6381),('60685','IL','Chicago','Cook',41.8767,-87.6381),('60686','IL','Chicago','Cook',41.85,-87.65),('60687','IL','Chicago','Cook',41.8767,-87.6381),('60688','IL','Chicago','Cook',41.8501,-87.65),('60689','IL','Chicago','Cook',41.8746,-87.6332),('60690','IL','Chicago','Cook',41.879,-87.6306),('60691','IL','Chicago','Cook',41.879,-87.6306),('60693','IL','Chicago','Cook',41.8767,-87.6381),('60694','IL','Chicago','Cook',41.8767,-87.6381),('60695','IL','Chicago','Cook',41.8501,-87.65),('60696','IL','Chicago','Cook',41.8501,-87.65),('60697','IL','Chicago','Cook',41.8767,-87.6381),('60699','IL','Chicago','Cook',41.8727,-87.6393),('60701','IL','Chicago','Cook',42.0274,-87.808),('60706','IL','Harwood Heights','Cook',41.964504,-87.815153),('60707','IL','Elmwood Park','Cook',41.922563,-87.808359),('60712','IL','Lincolnwood','Cook',42.006041,-87.731628),('60714','IL','Niles','Cook',42.030563,-87.815898),('60803','IL','Alsip','Cook',41.674763,-87.730847),('60804','IL','Cicero','Cook',41.843947,-87.762183),('60805','IL','Evergreen Park','Cook',41.720458,-87.703659),('60827','IL','Riverdale','Cook',41.650561,-87.636071),('60901','IL','Kankakee','Kankakee',41.11433,-87.871026),('60910','IL','Aroma Park','Kankakee',41.078067,-87.806486),('60911','IL','Ashkum','Iroquois',40.883127,-87.969016),('60912','IL','Beaverville','Iroquois',40.968059,-87.614288),('60913','IL','Bonfield','Kankakee',41.147922,-88.06376),('60914','IL','Bourbonnais','Kankakee',41.171941,-87.867226),('60915','IL','Bradley','Kankakee',41.145334,-87.862209),('60917','IL','Buckingham','Kankakee',41.046818,-88.185472),('60918','IL','Buckley','Iroquois',40.600304,-88.033252),('60919','IL','Cabery','Ford',40.987875,-88.237518),('60920','IL','Campus','Livingston',41.026072,-88.306125),('60921','IL','Chatsworth','Livingston',40.751031,-88.292864),('60922','IL','Chebanse','Kankakee',41.00804,-87.904907),('60924','IL','Cissna Park','Iroquois',40.563236,-87.888401),('60926','IL','Claytonville','Iroquois',40.568901,-87.816798),('60927','IL','Clifton','Iroquois',40.939323,-87.952971),('60928','IL','Crescent City','Iroquois',40.7668,-87.85606),('60929','IL','Cullom','Livingston',40.878649,-88.279318),('60930','IL','Danforth','Iroquois',40.823671,-87.987085),('60931','IL','Donovan','Iroquois',40.888973,-87.601691),('60932','IL','East Lynn','Vermilion',40.465251,-87.801128),('60933','IL','Elliott','Ford',40.465325,-88.271246),('60934','IL','Emington','Livingston',40.968107,-88.355713),('60935','IL','Essex','Kankakee',41.178432,-88.187371),('60936','IL','Gibson City','Ford',40.463042,-88.369888),('60938','IL','Gilman','Iroquois',40.767622,-87.993517),('60939','IL','Goodwine','Iroquois',40.5672,-87.7844),('60940','IL','Grant Park','Kankakee',41.245626,-87.645009),('60941','IL','Herscher','Kankakee',41.051738,-88.08858),('60942','IL','Hoopeston','Vermilion',40.465587,-87.667596),('60944','IL','Hopkins Park','Kankakee',41.0633,-87.625),('60945','IL','Iroquois','Iroquois',40.826943,-87.583462),('60946','IL','Kempton','Ford',40.91641,-88.21735),('60948','IL','Loda','Iroquois',40.519872,-88.081823),('60949','IL','Ludlow','Champaign',40.383777,-88.11946),('60950','IL','Manteno','Kankakee',41.247966,-87.850337),('60951','IL','Martinton','Iroquois',40.914602,-87.755127),('60952','IL','Melvin','Ford',40.566915,-88.248742),('60953','IL','Milford','Iroquois',40.622609,-87.695166),('60954','IL','Momence','Kankakee',41.160494,-87.646081),('60955','IL','Onarga','Iroquois',40.706195,-87.995284),('60956','IL','Papineau','Iroquois',40.9691,-87.7163),('60957','IL','Paxton','Ford',40.451931,-88.111878),('60958','IL','Pembroke Township','Kankakee',41.068229,-87.593195),('60959','IL','Piper City','Ford',40.784616,-88.183679),('60960','IL','Rankin','Vermilion',40.450441,-87.886639),('60961','IL','Reddick','Kankakee',41.109011,-88.250282),('60962','IL','Roberts','Ford',40.625918,-88.186908),('60963','IL','Rossville','Vermilion',40.372069,-87.658873),('60964','IL','Saint Anne','Kankakee',41.056623,-87.73804),('60966','IL','Sheldon','Iroquois',40.764641,-87.571412),('60967','IL','Stockland','Iroquois',40.613942,-87.592595),('60968','IL','Thawville','Iroquois',40.673725,-88.110164),('60969','IL','Union Hill','Kankakee',41.108029,-88.147224),('60970','IL','Watseka','Iroquois',40.786288,-87.740853),('60973','IL','Wellington','Iroquois',40.548361,-87.654281),('60974','IL','Woodland','Iroquois',40.715107,-87.730369),('61001','IL','Apple River','Jo Daviess',42.472481,-90.120627),('61006','IL','Ashton','Lee',41.864932,-89.215353),('61007','IL','Baileyville','Ogle',42.198721,-89.596691),('61008','IL','Belvidere','Boone',42.259112,-88.852393),('61010','IL','Byron','Ogle',42.127837,-89.266399),('61011','IL','Caledonia','Boone',42.368199,-88.922759),('61012','IL','Capron','Boone',42.401646,-88.747305),('61013','IL','Cedarville','Stephenson',42.373418,-89.635139),('61014','IL','Chadwick','Carroll',41.984758,-89.886983),('61015','IL','Chana','Ogle',41.983643,-89.21263),('61016','IL','Cherry Valley','Winnebago',42.21578,-88.95283),('61018','IL','Dakota','Stephenson',42.402841,-89.553078),('61019','IL','Davis','Stephenson',42.439557,-89.409906),('61020','IL','Davis Junction','Ogle',42.104352,-89.094561),('61021','IL','Dixon','Lee',41.839533,-89.475911),('61024','IL','Durand','Winnebago',42.434938,-89.313383),('61025','IL','East Dubuque','Jo Daviess',42.471456,-90.587712),('61027','IL','Eleroy','Stephenson',42.3325,-89.7605),('61028','IL','Elizabeth','Jo Daviess',42.298493,-90.175792),('61030','IL','Forreston','Ogle',42.118499,-89.581993),('61031','IL','Franklin Grove','Lee',41.840922,-89.310889),('61032','IL','Freeport','Stephenson',42.30273,-89.631748),('61036','IL','Galena','Jo Daviess',42.408727,-90.409592),('61037','IL','Galt','Whiteside',41.78889,-89.760475),('61038','IL','Garden Prairie','Boone',42.251805,-88.734815),('61039','IL','German Valley','Stephenson',42.208063,-89.464235),('61041','IL','Hanover','Jo Daviess',42.272932,-90.310733),('61042','IL','Harmon','Lee',41.691726,-89.567598),('61043','IL','Holcomb','Ogle',42.062971,-89.09792),('61044','IL','Kent','Stephenson',42.320247,-89.912433),('61046','IL','Lanark','Carroll',42.118546,-89.842605),('61047','IL','Leaf River','Ogle',42.14574,-89.405025),('61048','IL','Lena','Stephenson',42.381026,-89.832134),('61049','IL','Lindenwood','Ogle',42.046818,-89.02044),('61050','IL','Mc Connell','Stephenson',42.442176,-89.728402),('61051','IL','Milledgeville','Carroll',41.968506,-89.755784),('61052','IL','Monroe Center','Ogle',42.10413,-89.002591),('61053','IL','Mount Carroll','Carroll',42.099949,-89.97944),('61054','IL','Mount Morris','Ogle',42.048073,-89.441961),('61057','IL','Nachusa','Lee',41.83175,-89.389498),('61059','IL','Nora','Jo Daviess',42.455586,-89.942304),('61060','IL','Orangeville','Stephenson',42.472221,-89.636272),('61061','IL','Oregon','Ogle',42.004885,-89.339602),('61062','IL','Pearl City','Stephenson',42.250101,-89.836271),('61063','IL','Pecatonica','Winnebago',42.307656,-89.343625),('61064','IL','Polo','Ogle',41.989685,-89.584304),('61065','IL','Poplar Grove','Boone',42.363516,-88.841631),('61067','IL','Ridott','Stephenson',42.305046,-89.478928),('61068','IL','Rochelle','Ogle',41.934009,-89.06489),('61070','IL','Rock City','Stephenson',42.411317,-89.470493),('61071','IL','Rock Falls','Whiteside',41.763332,-89.695507),('61072','IL','Rockton','Winnebago',42.449104,-89.079268),('61073','IL','Roscoe','Winnebago',42.421779,-89.00319),('61074','IL','Savanna','Carroll',42.116002,-90.158436),('61075','IL','Scales Mound','Jo Daviess',42.47325,-90.251843),('61077','IL','Seward','Winnebago',42.237959,-89.35735),('61078','IL','Shannon','Carroll',42.158792,-89.734981),('61079','IL','Shirland','Winnebago',42.443628,-89.19733),('61080','IL','South Beloit','Winnebago',42.484827,-89.028941),('61081','IL','Sterling','Whiteside',41.80696,-89.705191),('61084','IL','Stillman Valley','Ogle',42.112242,-89.185594),('61085','IL','Stockton','Jo Daviess',42.340769,-90.035658),('61087','IL','Warren','Jo Daviess',42.490194,-89.990317),('61088','IL','Winnebago','Winnebago',42.271384,-89.250317),('61089','IL','Winslow','Stephenson',42.473936,-89.816655),('61091','IL','Woosung','Ogle',41.904697,-89.539893),('61101','IL','Rockford','Winnebago',42.299165,-89.122071),('61102','IL','Rockford','Winnebago',42.254699,-89.128417),('61103','IL','Rockford','Winnebago',42.303564,-89.082582),('61104','IL','Rockford','Winnebago',42.254716,-89.075715),('61105','IL','Rockford','Winnebago',42.3358,-89.1353),('61106','IL','Rockford','Winnebago',42.2522,-89.0798),('61107','IL','Rockford','Winnebago',42.279983,-89.033708),('61108','IL','Rockford','Winnebago',42.253605,-89.014169),('61109','IL','Rockford','Winnebago',42.213625,-89.052476),('61110','IL','Rockford','Winnebago',42.2668,-89.0823),('61111','IL','Loves Park','Winnebago',42.327612,-89.016865),('61112','IL','Rockford','Winnebago',42.24147,-88.974342),('61114','IL','Rockford','Winnebago',42.305947,-89.00454),('61115','IL','Machesney Park','Winnebago',42.35409,-89.038007),('61125','IL','Rockford','Winnebago',42.2381,-89.0143),('61126','IL','Rockford','Winnebago',42.2381,-89.0143),('61130','IL','Loves Park','Winnebago',42.3254,-89.0328),('61131','IL','Loves Park','Winnebago',42.3254,-89.0328),('61132','IL','Loves Park','Winnebago',42.3254,-89.0328),('61201','IL','Rock Island','Rock Island',41.489516,-90.570125),('61204','IL','Rock Island','Rock Island',41.5107,-90.5725),('61230','IL','Albany','Whiteside',41.769723,-90.210771),('61231','IL','Aledo','Mercer',41.202457,-90.731143),('61232','IL','Andalusia','Rock Island',41.439915,-90.724323),('61233','IL','Andover','Henry',41.292977,-90.293349),('61234','IL','Annawan','Henry',41.409195,-89.917896),('61235','IL','Atkinson','Henry',41.410647,-90.012991),('61236','IL','Barstow','Rock Island',41.512743,-90.35951),('61237','IL','Buffalo Prairie','Rock Island',41.3905,-90.8446),('61238','IL','Cambridge','Henry',41.292313,-90.189685),('61239','IL','Carbon Cliff','Rock Island',41.492578,-90.391452),('61240','IL','Coal Valley','Rock Island',41.439524,-90.428232),('61241','IL','Colona','Henry',41.478454,-90.343776),('61242','IL','Cordova','Rock Island',41.696117,-90.30323),('61243','IL','Deer Grove','Whiteside',41.619106,-89.679026),('61244','IL','East Moline','Rock Island',41.513629,-90.407646),('61250','IL','Erie','Whiteside',41.66112,-90.088428),('61251','IL','Fenton','Whiteside',41.737177,-90.066435),('61252','IL','Fulton','Whiteside',41.86137,-90.145399),('61254','IL','Geneseo','Henry',41.460734,-90.165054),('61256','IL','Hampton','Rock Island',41.557602,-90.407837),('61257','IL','Hillsdale','Rock Island',41.587552,-90.211183),('61258','IL','Hooppole','Henry',41.522375,-89.913462),('61259','IL','Illinois City','Rock Island',41.380484,-90.939014),('61260','IL','Joy','Mercer',41.22905,-90.875805),('61261','IL','Lyndon','Whiteside',41.718805,-89.921372),('61262','IL','Lynn Center','Henry',41.285295,-90.344132),('61263','IL','Matherville','Mercer',41.259127,-90.604069),('61264','IL','Milan','Rock Island',41.430223,-90.57641),('61265','IL','Moline','Rock Island',41.487177,-90.501674),('61266','IL','Moline','Rock Island',41.507,-90.5134),('61270','IL','Morrison','Whiteside',41.815894,-89.961881),('61272','IL','New Boston','Mercer',41.220466,-91.011386),('61273','IL','Orion','Henry',41.359773,-90.391832),('61274','IL','Osco','Henry',41.378371,-90.289646),('61275','IL','Port Byron','Rock Island',41.584909,-90.323686),('61276','IL','Preemption','Mercer',41.306364,-90.598076),('61277','IL','Prophetstown','Whiteside',41.631309,-89.929514),('61278','IL','Rapids City','Rock Island',41.582103,-90.344322),('61279','IL','Reynolds','Rock Island',41.320161,-90.709371),('61281','IL','Sherrard','Mercer',41.303046,-90.506056),('61282','IL','Silvis','Rock Island',41.501267,-90.413979),('61283','IL','Tampico','Whiteside',41.606002,-89.77612),('61284','IL','Taylor Ridge','Rock Island',41.406507,-90.734899),('61285','IL','Thomson','Carroll',41.978287,-90.092579),('61299','IL','Rock Island','Rock Island',41.5107,-90.5725),('61301','IL','La Salle','La Salle',41.349491,-89.087353),('61310','IL','Amboy','Lee',41.70968,-89.339897),('61311','IL','Ancona','Livingston',41.043708,-88.861913),('61312','IL','Arlington','Bureau',41.436355,-89.234905),('61313','IL','Blackstone','Livingston',41.070008,-88.671612),('61314','IL','Buda','Bureau',41.300318,-89.676619),('61315','IL','Bureau','Bureau',41.289215,-89.368018),('61316','IL','Cedar Point','La Salle',41.261737,-89.127036),('61317','IL','Cherry','Bureau',41.426568,-89.211121),('61318','IL','Compton','Lee',41.711285,-89.078271),('61319','IL','Cornell','Livingston',41.021306,-88.752643),('61320','IL','Dalzell','Bureau',41.356187,-89.169336),('61321','IL','Dana','La Salle',40.964096,-88.960285),('61322','IL','Depue','Bureau',41.323839,-89.302163),('61323','IL','Dover','Bureau',41.435187,-89.39592),('61324','IL','Eldena','Lee',41.770926,-89.412657),('61325','IL','Grand Ridge','La Salle',41.2338,-88.827564),('61326','IL','Granville','Putnam',41.260989,-89.232995),('61327','IL','Hennepin','Putnam',41.252934,-89.323446),('61328','IL','Kasbeer','Bureau',41.504659,-89.464143),('61329','IL','Ladd','Bureau',41.381187,-89.214859),('61330','IL','La Moille','Bureau',41.537828,-89.276289),('61331','IL','Lee Center','Lee',41.747471,-89.27713),('61332','IL','Leonore','La Salle',41.189369,-88.982682),('61333','IL','Long Point','Livingston',40.987312,-88.884418),('61334','IL','Lostant','La Salle',41.144278,-89.090101),('61335','IL','Mc Nabb','Putnam',41.165994,-89.218658),('61336','IL','Magnolia','Putnam',41.104026,-89.222225),('61337','IL','Malden','Bureau',41.426881,-89.34294),('61338','IL','Manlius','Bureau',41.455975,-89.669534),('61340','IL','Mark','Putnam',41.263988,-89.24845),('61341','IL','Marseilles','La Salle',41.336405,-88.697158),('61342','IL','Mendota','La Salle',41.544234,-89.104856),('61344','IL','Mineral','Bureau',41.40313,-89.84073),('61345','IL','Neponset','Bureau',41.279823,-89.783629),('61346','IL','New Bedford','Bureau',41.513092,-89.719112),('61348','IL','Oglesby','La Salle',41.295729,-89.061852),('61349','IL','Ohio','Bureau',41.545798,-89.442416),('61350','IL','Ottawa','La Salle',41.354463,-88.843477),('61353','IL','Paw Paw','Lee',41.704316,-88.991053),('61354','IL','Peru','La Salle',41.331724,-89.12985),('61356','IL','Princeton','Bureau',41.374284,-89.443729),('61358','IL','Rutland','La Salle',40.985936,-89.046669),('61359','IL','Seatonville','Bureau',41.362716,-89.275816),('61360','IL','Seneca','La Salle',41.312116,-88.604106),('61361','IL','Sheffield','Bureau',41.386984,-89.754061),('61362','IL','Spring Valley','Bureau',41.334743,-89.211353),('61363','IL','Standard','Putnam',41.256405,-89.177752),('61364','IL','Streator','La Salle',41.123547,-88.836786),('61367','IL','Sublette','Lee',41.636459,-89.269355),('61368','IL','Tiskilwa','Bureau',41.274731,-89.506298),('61369','IL','Toluca','Marshall',40.997153,-89.143516),('61370','IL','Tonica','La Salle',41.210714,-89.038855),('61371','IL','Triumph','La Salle',41.4994,-89.0219),('61372','IL','Troy Grove','La Salle',41.46533,-89.080059),('61373','IL','Utica','La Salle',41.377369,-89.004542),('61374','IL','Van Orin','Bureau',41.551646,-89.355225),('61375','IL','Varna','Marshall',41.049781,-89.249098),('61376','IL','Walnut','Bureau',41.543441,-89.618267),('61377','IL','Wenona','Marshall',41.056818,-89.051179),('61378','IL','West Brooklyn','Lee',41.723397,-89.155183),('61379','IL','Wyanet','Bureau',41.366399,-89.590127),('61401','IL','Galesburg','Knox',40.948007,-90.36882),('61402','IL','Galesburg','Knox',40.9477,-90.3711),('61410','IL','Abingdon','Knox',40.803812,-90.398313),('61411','IL','Adair','Mcdonough',40.407036,-90.494661),('61412','IL','Alexis','Warren',41.067902,-90.561266),('61413','IL','Alpha','Henry',41.187259,-90.369751),('61414','IL','Altona','Knox',41.119069,-90.159393),('61415','IL','Avon','Fulton',40.661337,-90.434298),('61416','IL','Bardolph','Mcdonough',40.496672,-90.563317),('61417','IL','Berwick','Warren',40.781924,-90.52843),('61418','IL','Biggsville','Henderson',40.852672,-90.86144),('61419','IL','Bishop Hill','Henry',41.200674,-90.118293),('61420','IL','Blandinsville','Mcdonough',40.548552,-90.86895),('61421','IL','Bradford','Stark',41.176618,-89.662209),('61422','IL','Bushnell','Mcdonough',40.55038,-90.520683),('61423','IL','Cameron','Warren',40.892955,-90.505723),('61424','IL','Camp Grove','Marshall',41.079762,-89.633815),('61425','IL','Carman','Henderson',40.779302,-91.058919),('61426','IL','Castleton','Stark',41.118521,-89.708554),('61427','IL','Cuba','Fulton',40.499966,-90.182657),('61428','IL','Dahinda','Knox',40.95529,-90.132152),('61430','IL','East Galesburg','Knox',40.943954,-90.312066),('61431','IL','Ellisville','Fulton',40.60756,-90.29032),('61432','IL','Fairview','Fulton',40.640664,-90.163849),('61433','IL','Fiatt','Fulton',40.554375,-90.168989),('61434','IL','Galva','Henry',41.168438,-90.035351),('61435','IL','Gerlaw','Warren',40.980871,-90.56762),('61436','IL','Gilson','Knox',40.860164,-90.223166),('61437','IL','Gladstone','Henderson',40.848791,-90.987759),('61438','IL','Good Hope','Mcdonough',40.568866,-90.65544),('61439','IL','Henderson','Knox',41.025724,-90.355826),('61440','IL','Industry','Mcdonough',40.324095,-90.601874),('61441','IL','Ipava','Fulton',40.348148,-90.303028),('61442','IL','Keithsburg','Mercer',41.093805,-90.933767),('61443','IL','Kewanee','Henry',41.247452,-89.928554),('61447','IL','Kirkwood','Warren',40.863748,-90.750642),('61448','IL','Knoxville','Knox',40.91,-90.270426),('61449','IL','La Fayette','Stark',41.095076,-89.975158),('61450','IL','La Harpe','Hancock',40.578272,-90.972631),('61451','IL','Laura','Peoria',40.938094,-89.958079),('61452','IL','Littleton','Schuyler',40.227421,-90.655288),('61453','IL','Little York','Warren',41.010622,-90.759315),('61454','IL','Lomax','Henderson',40.684838,-91.052636),('61455','IL','Macomb','Mcdonough',40.455727,-90.669533),('61458','IL','Maquon','Knox',40.78225,-90.183364),('61459','IL','Marietta','Fulton',40.505288,-90.403134),('61460','IL','Media','Henderson',40.734078,-90.826791),('61462','IL','Monmouth','Warren',40.915606,-90.644382),('61465','IL','New Windsor','Mercer',41.198946,-90.455744),('61466','IL','North Henderson','Mercer',41.093699,-90.477638),('61467','IL','Oneida','Knox',41.072801,-90.232729),('61468','IL','Ophiem','Henry',41.256683,-90.387748),('61469','IL','Oquawka','Henderson',40.955819,-90.936912),('61470','IL','Prairie City','Mcdonough',40.614954,-90.473691),('61471','IL','Raritan','Henderson',40.696238,-90.826394),('61472','IL','Rio','Knox',41.102471,-90.385835),('61473','IL','Roseville','Warren',40.705238,-90.66316),('61474','IL','Saint Augustine','Knox',40.721558,-90.39148),('61475','IL','Sciota','Mcdonough',40.581483,-90.761451),('61476','IL','Seaton','Mercer',41.097033,-90.815699),('61477','IL','Smithfield','Fulton',40.498686,-90.315042),('61478','IL','Smithshire','Warren',40.766393,-90.764672),('61479','IL','Speer','Stark',41.009573,-89.643388),('61480','IL','Stronghurst','Henderson',40.741322,-90.915598),('61482','IL','Table Grove','Fulton',40.367433,-90.423326),('61483','IL','Toulon','Stark',41.098945,-89.863807),('61484','IL','Vermont','Fulton',40.291409,-90.424827),('61485','IL','Victoria','Knox',41.021282,-90.102912),('61486','IL','Viola','Mercer',41.20052,-90.579972),('61488','IL','Wataga','Knox',41.03086,-90.297085),('61489','IL','Williamsfield','Knox',40.927588,-90.021381),('61490','IL','Woodhull','Henry',41.18834,-90.295836),('61491','IL','Wyoming','Stark',41.068763,-89.744486),('61501','IL','Astoria','Fulton',40.241517,-90.326985),('61516','IL','Benson','Woodford',40.851648,-89.123895),('61517','IL','Brimfield','Peoria',40.819412,-89.848084),('61519','IL','Bryant','Fulton',40.466434,-90.09629),('61520','IL','Canton','Fulton',40.550136,-90.030733),('61523','IL','Chillicothe','Peoria',40.909143,-89.511457),('61524','IL','Dunfermline','Fulton',40.49174,-90.032869),('61525','IL','Dunlap','Peoria',40.834647,-89.644868),('61526','IL','Edelstein','Peoria',40.935917,-89.619584),('61528','IL','Edwards','Peoria',40.776901,-89.718271),('61529','IL','Elmwood','Peoria',40.78041,-89.955528),('61530','IL','Eureka','Woodford',40.714738,-89.2685),('61531','IL','Farmington','Fulton',40.688601,-90.021794),('61532','IL','Forest City','Mason',40.357158,-89.823699),('61533','IL','Glasford','Peoria',40.5872,-89.829429),('61534','IL','Green Valley','Tazewell',40.416265,-89.652518),('61535','IL','Groveland','Tazewell',40.588867,-89.539846),('61536','IL','Hanna City','Peoria',40.692538,-89.787468),('61537','IL','Henry','Marshall',41.111519,-89.384412),('61539','IL','Kingston Mines','Peoria',40.557342,-89.770627),('61540','IL','Lacon','Marshall',41.023762,-89.39525),('61541','IL','La Rose','Marshall',40.982559,-89.236076),('61542','IL','Lewistown','Fulton',40.39444,-90.148692),('61543','IL','Liverpool','Fulton',40.416009,-89.981937),('61544','IL','London Mills','Fulton',40.70226,-90.244024),('61545','IL','Lowpoint','Woodford',40.86429,-89.3669),('61546','IL','Manito','Mason',40.45629,-89.790381),('61547','IL','Mapleton','Peoria',40.596336,-89.732147),('61548','IL','Metamora','Woodford',40.7857,-89.409865),('61550','IL','Morton','Tazewell',40.612651,-89.460781),('61552','IL','Mossville','Peoria',40.816961,-89.567906),('61553','IL','Norris','Fulton',40.625568,-90.031784),('61554','IL','Pekin','Tazewell',40.565516,-89.630464),('61555','IL','Pekin','Tazewell',40.5672,-89.6449),('61558','IL','Pekin','Tazewell',40.5675,-89.6405),('61559','IL','Princeville','Peoria',40.926646,-89.764389),('61560','IL','Putnam','Putnam',41.187262,-89.41979),('61561','IL','Roanoke','Woodford',40.794175,-89.192429),('61562','IL','Rome','Peoria',40.880248,-89.501027),('61563','IL','Saint David','Fulton',40.490953,-90.053485),('61564','IL','South Pekin','Tazewell',40.492718,-89.650325),('61565','IL','Sparland','Marshall',41.034982,-89.481008),('61567','IL','Topeka','Mason',40.34075,-89.909349),('61568','IL','Tremont','Tazewell',40.51361,-89.472102),('61569','IL','Trivoli','Peoria',40.690718,-89.891179),('61570','IL','Washburn','Woodford',40.922458,-89.307908),('61571','IL','Washington','Tazewell',40.702599,-89.442889),('61572','IL','Yates City','Knox',40.796803,-90.028595),('61601','IL','Peoria','Peoria',40.6854,-89.5953),('61602','IL','Peoria','Peoria',40.681449,-89.603908),('61603','IL','Peoria','Peoria',40.711887,-89.580713),('61604','IL','Peoria','Peoria',40.707571,-89.633948),('61605','IL','Peoria','Peoria',40.6782,-89.627469),('61606','IL','Peoria','Peoria',40.700423,-89.611085),('61607','IL','Peoria','Peoria',40.643719,-89.668203),('61610','IL','Creve Coeur','Tazewell',40.642116,-89.59956),('61611','IL','East Peoria','Tazewell',40.693324,-89.542208),('61612','IL','Peoria','Peoria',40.7595,-89.5926),('61613','IL','Peoria','Peoria',40.7419,-89.6276),('61614','IL','Peoria','Peoria',40.753698,-89.605619),('61615','IL','Peoria','Peoria',40.776366,-89.652837),('61616','IL','Peoria Heights','Peoria',40.744205,-89.577023),('61625','IL','Peoria','Peoria',40.697637,-89.611958),('61629','IL','Peoria','Peoria',40.6936,-89.5888),('61630','IL','Peoria','Peoria',40.6854,-89.5953),('61633','IL','Peoria','Peoria',40.7311,-89.6038),('61634','IL','Peoria','Peoria',40.6893,-89.5921),('61635','IL','Peoria','Peoria',40.7045,-89.5219),('61636','IL','Peoria','Peoria',40.7005,-89.5949),('61637','IL','Peoria','Peoria',40.6936,-89.5888),('61638','IL','Peoria','Peoria',40.8019,-89.6281),('61639','IL','Peoria','Peoria',40.6936,-89.5888),('61641','IL','Peoria','Peoria',40.6936,-89.5888),('61643','IL','Peoria','Peoria',40.7247,-89.5566),('61650','IL','Peoria','Peoria',40.6936,-89.5888),('61651','IL','Peoria','Peoria',40.6936,-89.5888),('61652','IL','Peoria','Peoria',40.6936,-89.5888),('61653','IL','Peoria','Peoria',40.6936,-89.5888),('61654','IL','Peoria','Peoria',40.6936,-89.5888),('61655','IL','Peoria','Peoria',40.6936,-89.5888),('61656','IL','Peoria','Peoria',40.6936,-89.5888),('61701','IL','Bloomington','Mclean',40.477159,-88.993),('61702','IL','Bloomington','Mclean',40.4885,-88.9563),('61704','IL','Bloomington','Mclean',40.476429,-88.95126),('61705','IL','Bloomington','Mclean',40.436252,-89.009283),('61709','IL','Bloomington','Mclean',40.4638,-88.9564),('61710','IL','Bloomington','Mclean',40.4783,-88.9535),('61720','IL','Anchor','Mclean',40.55915,-88.522317),('61721','IL','Armington','Tazewell',40.341204,-89.32017),('61722','IL','Arrowsmith','Mclean',40.423806,-88.622027),('61723','IL','Atlanta','Logan',40.261285,-89.242419),('61724','IL','Bellflower','Mclean',40.338399,-88.528847),('61725','IL','Carlock','Mclean',40.596299,-89.132973),('61726','IL','Chenoa','Mclean',40.743379,-88.707205),('61727','IL','Clinton','De Witt',40.147543,-88.965896),('61728','IL','Colfax','Mclean',40.567284,-88.62114),('61729','IL','Congerville','Woodford',40.617503,-89.22216),('61730','IL','Cooksville','Mclean',40.542301,-88.719722),('61731','IL','Cropsey','Mclean',40.613589,-88.488106),('61732','IL','Danvers','Mclean',40.530447,-89.190417),('61733','IL','Deer Creek','Tazewell',40.626015,-89.330209),('61734','IL','Delavan','Tazewell',40.371552,-89.53728),('61735','IL','Dewitt','De Witt',40.18906,-88.812969),('61736','IL','Downs','Mclean',40.396022,-88.863434),('61737','IL','Ellsworth','Mclean',40.446061,-88.73192),('61738','IL','El Paso','Woodford',40.741958,-89.020161),('61739','IL','Fairbury','Livingston',40.743228,-88.513956),('61740','IL','Flanagan','Livingston',40.882795,-88.859509),('61741','IL','Forrest','Livingston',40.755401,-88.404985),('61742','IL','Goodfield','Woodford',40.630218,-89.271667),('61743','IL','Graymont','Livingston',40.878543,-88.778607),('61744','IL','Gridley','Mclean',40.746317,-88.884071),('61745','IL','Heyworth','Mclean',40.321121,-88.974947),('61747','IL','Hopedale','Tazewell',40.424743,-89.42561),('61748','IL','Hudson','Mclean',40.627891,-88.976953),('61749','IL','Kenney','De Witt',40.092954,-89.103674),('61750','IL','Lane','De Witt',40.122097,-88.856228),('61751','IL','Lawndale','Logan',40.219136,-89.284463),('61752','IL','Le Roy','Mclean',40.343043,-88.75855),('61753','IL','Lexington','Mclean',40.639664,-88.787202),('61754','IL','Mc Lean','Mclean',40.319994,-89.159979),('61755','IL','Mackinaw','Tazewell',40.531936,-89.345116),('61756','IL','Maroa','Macon',40.03319,-88.960453),('61758','IL','Merna','Mclean',40.52835,-88.840754),('61759','IL','Minier','Tazewell',40.432466,-89.318268),('61760','IL','Minonk','Woodford',40.891186,-89.032484),('61761','IL','Normal','Mclean',40.519467,-88.982119),('61764','IL','Pontiac','Livingston',40.882422,-88.631451),('61769','IL','Saunemin','Livingston',40.885478,-88.399506),('61770','IL','Saybrook','Mclean',40.437155,-88.527016),('61771','IL','Secor','Woodford',40.727846,-89.134528),('61772','IL','Shirley','Mclean',40.397724,-89.069385),('61773','IL','Sibley','Ford',40.577733,-88.384172),('61774','IL','Stanford','Mclean',40.435469,-89.202655),('61775','IL','Strawn','Livingston',40.653893,-88.390272),('61776','IL','Towanda','Mclean',40.574247,-88.88288),('61777','IL','Wapella','De Witt',40.227741,-88.961936),('61778','IL','Waynesville','De Witt',40.242292,-89.10768),('61790','IL','Normal','Mclean',40.5193,-89.0087),('61791','IL','Bloomington','Mclean',40.4885,-88.9563),('61799','IL','Bloomington','Mclean',40.4297,-88.9819),('61801','IL','Urbana','Champaign',40.110071,-88.211041),('61802','IL','Urbana','Champaign',40.118858,-88.180605),('61803','IL','Urbana','Champaign',40.1118,-88.207),('61810','IL','Allerton','Vermilion',39.917464,-87.932387),('61811','IL','Alvin','Vermilion',40.296216,-87.625945),('61812','IL','Armstrong','Vermilion',40.273515,-87.889004),('61813','IL','Bement','Piatt',39.918682,-88.561004),('61814','IL','Bismarck','Vermilion',40.242453,-87.589041),('61815','IL','Bondville','Champaign',40.110574,-88.371003),('61816','IL','Broadlands','Champaign',39.917065,-88.002418),('61817','IL','Catlin','Vermilion',40.059317,-87.7061),('61818','IL','Cerro Gordo','Piatt',39.884405,-88.728105),('61820','IL','Champaign','Champaign',40.114434,-88.242272),('61821','IL','Champaign','Champaign',40.10854,-88.27347),('61822','IL','Champaign','Champaign',40.121814,-88.293529),('61824','IL','Champaign','Champaign',40.109,-88.2433),('61825','IL','Champaign','Champaign',40.1371,-88.2771),('61826','IL','Champaign','Champaign',40.1371,-88.2771),('61830','IL','Cisco','Piatt',40.021064,-88.722254),('61831','IL','Collison','Vermilion',40.229497,-87.784498),('61832','IL','Danville','Vermilion',40.133923,-87.627665),('61833','IL','Tilton','Vermilion',40.098398,-87.645921),('61834','IL','Danville','Vermilion',40.177241,-87.622986),('61839','IL','De Land','Piatt',40.136633,-88.632383),('61840','IL','Dewey','Champaign',40.310022,-88.306149),('61841','IL','Fairmount','Vermilion',40.039612,-87.830275),('61842','IL','Farmer City','De Witt',40.244624,-88.647903),('61843','IL','Fisher','Champaign',40.319323,-88.361799),('61844','IL','Fithian','Vermilion',40.129809,-87.868761),('61845','IL','Foosland','Champaign',40.376419,-88.403633),('61846','IL','Georgetown','Vermilion',39.976041,-87.630877),('61847','IL','Gifford','Champaign',40.310887,-88.018909),('61848','IL','Henning','Vermilion',40.304149,-87.700637),('61849','IL','Homer','Champaign',40.028734,-87.957339),('61850','IL','Indianola','Vermilion',39.929815,-87.73521),('61851','IL','Ivesdale','Champaign',39.95062,-88.439821),('61852','IL','Longview','Champaign',39.901708,-88.075554),('61853','IL','Mahomet','Champaign',40.205287,-88.402758),('61854','IL','Mansfield','Piatt',40.2108,-88.515652),('61855','IL','Milmine','Piatt',39.922088,-88.659873),('61856','IL','Monticello','Piatt',40.033703,-88.575849),('61857','IL','Muncie','Vermilion',40.115942,-87.844463),('61858','IL','Oakwood','Vermilion',40.120712,-87.744417),('61859','IL','Ogden','Champaign',40.150428,-87.962905),('61862','IL','Penfield','Champaign',40.315691,-87.940691),('61863','IL','Pesotum','Champaign',39.906185,-88.275862),('61864','IL','Philo','Champaign',39.988007,-88.153372),('61865','IL','Potomac','Vermilion',40.30487,-87.80151),('61866','IL','Rantoul','Champaign',40.308504,-88.154942),('61870','IL','Ridge Farm','Vermilion',39.895234,-87.641807),('61871','IL','Royal','Champaign',40.192937,-87.973121),('61872','IL','Sadorus','Champaign',39.931225,-88.365125),('61873','IL','Saint Joseph','Champaign',40.127396,-88.040339),('61874','IL','Savoy','Champaign',40.056357,-88.252057),('61875','IL','Seymour','Champaign',40.108716,-88.424205),('61876','IL','Sidell','Vermilion',39.906094,-87.827596),('61877','IL','Sidney','Champaign',40.015361,-88.070329),('61878','IL','Thomasboro','Champaign',40.24628,-88.170216),('61880','IL','Tolono','Champaign',39.981298,-88.256906),('61882','IL','Weldon','De Witt',40.120649,-88.768099),('61883','IL','Westville','Vermilion',40.041481,-87.638956),('61884','IL','White Heath','Piatt',40.10032,-88.498665),('61910','IL','Arcola','Douglas',39.680383,-88.306045),('61911','IL','Arthur','Douglas',39.710444,-88.464444),('61912','IL','Ashmore','Coles',39.53023,-88.032971),('61913','IL','Atwood','Douglas',39.809987,-88.452786),('61914','IL','Bethany','Moultrie',39.638455,-88.753486),('61917','IL','Brocton','Edgar',39.70324,-87.91607),('61919','IL','Camargo','Douglas',39.795373,-88.150562),('61920','IL','Charleston','Coles',39.497533,-88.172599),('61924','IL','Chrisman','Edgar',39.798048,-87.652049),('61925','IL','Dalton City','Moultrie',39.718402,-88.822528),('61928','IL','Gays','Moultrie',39.440422,-88.499675),('61929','IL','Hammond','Piatt',39.806593,-88.608686),('61930','IL','Hindsboro','Douglas',39.690768,-88.128466),('61931','IL','Humboldt','Coles',39.5963,-88.349551),('61932','IL','Hume','Edgar',39.794652,-87.869163),('61933','IL','Kansas','Edgar',39.546031,-87.926025),('61936','IL','La Place','Piatt',39.799751,-88.719783),('61937','IL','Lovington','Moultrie',39.740605,-88.646934),('61938','IL','Mattoon','Coles',39.476619,-88.373164),('61940','IL','Metcalf','Edgar',39.80328,-87.808015),('61941','IL','Murdock','Douglas',39.801185,-88.077387),('61942','IL','Newman','Douglas',39.804365,-87.989802),('61943','IL','Oakland','Coles',39.655242,-88.020763),('61944','IL','Paris','Edgar',39.608259,-87.699879),('61949','IL','Redmon','Edgar',39.644054,-87.863092),('61951','IL','Sullivan','Moultrie',39.593862,-88.600218),('61953','IL','Tuscola','Douglas',39.794487,-88.291837),('61955','IL','Vermilion','Edgar',39.580386,-87.58863),('61956','IL','Villa Grove','Douglas',39.859513,-88.151127),('61957','IL','Windsor','Shelby',39.445777,-88.604286),('62001','IL','Alhambra','Madison',38.884106,-89.74941),('62002','IL','Alton','Madison',38.903886,-90.155362),('62006','IL','Batchtown','Calhoun',39.066,-90.666039),('62009','IL','Benld','Macoupin',39.093575,-89.802867),('62010','IL','Bethalto','Madison',38.910705,-90.045222),('62011','IL','Bingham','Fayette',39.116142,-89.214153),('62012','IL','Brighton','Macoupin',39.038606,-90.14),('62013','IL','Brussels','Calhoun',38.977365,-90.561616),('62014','IL','Bunker Hill','Macoupin',39.040556,-89.953485),('62015','IL','Butler','Montgomery',39.217001,-89.555123),('62016','IL','Carrollton','Greene',39.295408,-90.406486),('62017','IL','Coffeen','Montgomery',39.083422,-89.379961),('62018','IL','Cottage Hills','Madison',38.906073,-90.084253),('62019','IL','Donnellson','Montgomery',39.030787,-89.466614),('62021','IL','Dorsey','Madison',38.984867,-89.971728),('62022','IL','Dow','Jersey',38.997296,-90.340175),('62023','IL','Eagarville','Macoupin',39.109175,-89.787095),('62024','IL','East Alton','Madison',38.881027,-90.09436),('62025','IL','Edwardsville','Madison',38.812393,-89.96368),('62026','IL','Edwardsville','Madison',38.7927,-89.9963),('62027','IL','Eldred','Greene',39.261665,-90.566482),('62028','IL','Elsah','Jersey',38.95822,-90.354972),('62030','IL','Fidelity','Jersey',39.153704,-90.164658),('62031','IL','Fieldon','Jersey',39.101345,-90.534296),('62032','IL','Fillmore','Montgomery',39.115051,-89.285501),('62033','IL','Gillespie','Macoupin',39.123098,-89.827875),('62034','IL','Glen Carbon','Madison',38.756909,-89.966045),('62035','IL','Godfrey','Madison',38.946878,-90.21392),('62036','IL','Golden Eagle','Calhoun',38.910268,-90.572941),('62037','IL','Grafton','Jersey',38.987808,-90.469441),('62040','IL','Granite City','Madison',38.724321,-90.113054),('62044','IL','Greenfield','Greene',39.349261,-90.20937),('62045','IL','Hamburg','Calhoun',39.245889,-90.721873),('62046','IL','Hamel','Madison',38.888655,-89.844458),('62047','IL','Hardin','Calhoun',39.127327,-90.615811),('62048','IL','Hartford','Madison',38.811794,-90.097443),('62049','IL','Hillsboro','Montgomery',39.1543,-89.483709),('62050','IL','Hillview','Greene',39.440017,-90.54472),('62051','IL','Irving','Montgomery',39.206397,-89.406074),('62052','IL','Jerseyville','Jersey',39.114727,-90.324649),('62053','IL','Kampsville','Calhoun',39.321494,-90.641771),('62054','IL','Kane','Greene',39.194619,-90.352788),('62056','IL','Litchfield','Montgomery',39.180799,-89.657139),('62058','IL','Livingston','Madison',38.96733,-89.761345),('62059','IL','Lovejoy','St. Clair',38.656373,-90.166554),('62060','IL','Madison','Madison',38.679508,-90.151111),('62061','IL','Marine','Madison',38.785871,-89.780908),('62062','IL','Maryville','Madison',38.729066,-89.96169),('62063','IL','Medora','Macoupin',39.188627,-90.146629),('62065','IL','Michael','Calhoun',39.235647,-90.629056),('62067','IL','Moro','Madison',38.921095,-90.002622),('62069','IL','Mount Olive','Macoupin',39.078007,-89.734422),('62070','IL','Mozier','Calhoun',39.299637,-90.743156),('62071','IL','National Stock Yards','Saint Clair',38.6445,-90.1503),('62074','IL','New Douglas','Madison',38.965773,-89.682594),('62075','IL','Nokomis','Montgomery',39.300691,-89.289524),('62076','IL','Ohlman','Montgomery',39.345106,-89.21758),('62077','IL','Panama','Montgomery',39.030459,-89.523187),('62078','IL','Patterson','Greene',39.481174,-90.482748),('62079','IL','Piasa','Macoupin',39.1105,-90.143849),('62080','IL','Ramsey','Fayette',39.137908,-89.10422),('62081','IL','Rockbridge','Greene',39.266308,-90.221086),('62082','IL','Roodhouse','Greene',39.494099,-90.352902),('62083','IL','Rosamond','Christian',39.35808,-89.185468),('62084','IL','Roxana','Madison',38.838368,-90.063668),('62085','IL','Sawyerville','Macoupin',39.078986,-89.806157),('62086','IL','Sorento','Bond',38.995447,-89.574025),('62087','IL','South Roxana','Madison',38.823943,-90.061416),('62088','IL','Staunton','Macoupin',39.012374,-89.788454),('62089','IL','Taylor Springs','Montgomery',39.131543,-89.491509),('62090','IL','Venice','Madison',38.671558,-90.170521),('62091','IL','Walshville','Montgomery',39.058273,-89.607741),('62092','IL','White Hall','Greene',39.432355,-90.402411),('62093','IL','Wilsonville','Macoupin',39.068983,-89.855065),('62094','IL','Witt','Montgomery',39.249925,-89.350742),('62095','IL','Wood River','Madison',38.862396,-90.085443),('62097','IL','Worden','Madison',38.936656,-89.852627),('62098','IL','Wrights','Greene',39.376527,-90.295227),('62201','IL','East Saint Louis','St. Clair',38.63464,-90.142038),('62202','IL','East Saint Louis','Saint Clair',38.6223,-90.154),('62203','IL','East Saint Louis','St. Clair',38.598505,-90.076694),('62204','IL','East Saint Louis','St. Clair',38.631437,-90.100235),('62205','IL','East Saint Louis','St. Clair',38.615038,-90.127155),('62206','IL','East Saint Louis','St. Clair',38.564391,-90.163237),('62207','IL','East Saint Louis','St. Clair',38.586962,-90.128214),('62208','IL','Fairview Heights','St. Clair',38.595325,-89.996353),('62214','IL','Addieville','Washington',38.377391,-89.575111),('62215','IL','Albers','Clinton',38.525267,-89.608994),('62216','IL','Aviston','Clinton',38.611662,-89.606163),('62217','IL','Baldwin','Randolph',38.182849,-89.846773),('62218','IL','Bartelso','Clinton',38.532212,-89.464942),('62219','IL','Beckemeyer','Clinton',38.605277,-89.435298),('62220','IL','Belleville','St. Clair',38.500748,-89.981693),('62221','IL','Belleville','St. Clair',38.525011,-89.929847),('62222','IL','Belleville','Saint Clair',38.5124,-89.9862),('62223','IL','Belleville','St. Clair',38.554692,-90.048245),('62224','IL','Mascoutah','Saint Clair',38.4902,-89.793),('62225','IL','Scott Air Force Base','St. Clair',38.540608,-89.861352),('62226','IL','Belleville','St. Clair',38.540791,-89.999744),('62230','IL','Breese','Clinton',38.62139,-89.527061),('62231','IL','Carlyle','Clinton',38.637017,-89.347414),('62232','IL','Caseyville','St. Clair',38.636574,-90.018491),('62233','IL','Chester','Randolph',37.927642,-89.810439),('62234','IL','Collinsville','Madison',38.678805,-89.996389),('62236','IL','Columbia','Monroe',38.442882,-90.207386),('62237','IL','Coulterville','Randolph',38.191284,-89.593787),('62238','IL','Cutler','Perry',38.034209,-89.54244),('62239','IL','Dupo','St. Clair',38.523365,-90.198973),('62240','IL','East Carondelet','St. Clair',38.536719,-90.218656),('62241','IL','Ellis Grove','Randolph',38.008319,-89.902304),('62242','IL','Evansville','Randolph',38.094616,-89.935156),('62243','IL','Freeburg','St. Clair',38.424547,-89.896255),('62244','IL','Fults','Monroe',38.204684,-90.202413),('62245','IL','Germantown','Clinton',38.55388,-89.555232),('62246','IL','Greenville','Bond',38.890412,-89.40955),('62247','IL','Hagarstown','Fayette',38.9433,-89.1683),('62248','IL','Hecker','Monroe',38.304888,-89.99315),('62249','IL','Highland','Madison',38.7551,-89.675922),('62250','IL','Hoffman','Clinton',38.540311,-89.263202),('62252','IL','Huey','Clinton',38.6044,-89.2911),('62253','IL','Keyesport','Bond',38.763401,-89.291254),('62254','IL','Lebanon','St. Clair',38.600322,-89.819327),('62255','IL','Lenzburg','St. Clair',38.305854,-89.792282),('62256','IL','Maeystown','Monroe',38.239,-90.206),('62257','IL','Marissa','St. Clair',38.262544,-89.7451),('62258','IL','Mascoutah','St. Clair',38.470283,-89.785074),('62259','IL','Menard','Randolph',37.91,-89.8397),('62260','IL','Millstadt','St. Clair',38.463458,-90.094867),('62261','IL','Modoc','Randolph',37.997579,-90.000394),('62262','IL','Mulberry Grove','Bond',38.929989,-89.267648),('62263','IL','Nashville','Washington',38.342558,-89.38824),('62264','IL','New Athens','St. Clair',38.318541,-89.889492),('62265','IL','New Baden','Clinton',38.520447,-89.677066),('62266','IL','New Memphis','Clinton',38.478889,-89.678478),('62268','IL','Oakdale','Washington',38.272364,-89.51619),('62269','IL','O Fallon','St. Clair',38.592799,-89.911649),('62271','IL','Okawville','Washington',38.437263,-89.533159),('62272','IL','Percy','Randolph',38.007457,-89.616483),('62273','IL','Pierron','Bond',38.781058,-89.595105),('62274','IL','Pinckneyville','Perry',38.07651,-89.387278),('62275','IL','Pocahontas','Bond',38.809868,-89.551148),('62277','IL','Prairie Du Rocher','Randolph',38.086634,-90.101437),('62278','IL','Red Bud','Randolph',38.207515,-89.986268),('62279','IL','Renault','Monroe',38.15232,-90.133575),('62280','IL','Rockwood','Randolph',37.846833,-89.667502),('62281','IL','Saint Jacob','Madison',38.715759,-89.786618),('62282','IL','Saint Libory','St. Clair',38.364731,-89.716545),('62284','IL','Smithboro','Bond',38.878303,-89.323075),('62285','IL','Smithton','St. Clair',38.398006,-89.996871),('62286','IL','Sparta','Randolph',38.128438,-89.709871),('62288','IL','Steeleville','Randolph',38.002966,-89.667991),('62289','IL','Summerfield','St. Clair',38.596049,-89.751288),('62292','IL','Tilden','Randolph',38.213358,-89.683152),('62293','IL','Trenton','Clinton',38.6136,-89.688339),('62294','IL','Troy','Madison',38.725616,-89.890623),('62295','IL','Valmeyer','Monroe',38.294843,-90.309258),('62297','IL','Walsh','Randolph',38.056515,-89.82121),('62298','IL','Waterloo','Monroe',38.328128,-90.147524),('62301','IL','Quincy','Adams',39.932478,-91.392005),('62305','IL','Quincy','Adams',39.93129,-91.357233),('62306','IL','Quincy','Adams',39.9496,-91.3588),('62311','IL','Augusta','Hancock',40.222576,-90.935227),('62312','IL','Barry','Pike',39.70074,-91.034451),('62313','IL','Basco','Hancock',40.313676,-91.208422),('62314','IL','Baylis','Pike',39.755773,-90.894918),('62316','IL','Bowen','Hancock',40.233053,-91.059591),('62319','IL','Camden','Schuyler',40.15994,-90.731233),('62320','IL','Camp Point','Adams',40.023279,-91.074221),('62321','IL','Carthage','Hancock',40.410096,-91.114371),('62323','IL','Chambersburg','Pike',39.818212,-90.669227),('62324','IL','Clayton','Adams',39.98898,-90.949765),('62325','IL','Coatsburg','Adams',40.034625,-91.162811),('62326','IL','Colchester','Mcdonough',40.42231,-90.799225),('62329','IL','Colusa','Hancock',40.5708,-91.1677),('62330','IL','Dallas City','Hancock',40.590636,-91.149312),('62334','IL','Elvaston','Hancock',40.395595,-91.248792),('62336','IL','Ferris','Hancock',40.467922,-91.171469),('62338','IL','Fowler','Adams',39.990399,-91.256094),('62339','IL','Golden','Adams',40.117769,-91.023584),('62340','IL','Griggsville','Pike',39.713982,-90.720437),('62341','IL','Hamilton','Hancock',40.400648,-91.335333),('62343','IL','Hull','Pike',39.714382,-91.251867),('62344','IL','Huntsville','Schuyler',40.170917,-90.828239),('62345','IL','Kinderhook','Pike',39.700043,-91.142716),('62346','IL','La Prairie','Adams',40.150624,-90.951257),('62347','IL','Liberty','Adams',39.864915,-91.097099),('62348','IL','Lima','Adams',40.179462,-91.376986),('62349','IL','Loraine','Adams',40.164703,-91.210558),('62351','IL','Mendon','Adams',40.101424,-91.271399),('62352','IL','Milton','Pike',39.564198,-90.649518),('62353','IL','Mount Sterling','Brown',39.977437,-90.754502),('62354','IL','Nauvoo','Hancock',40.530752,-91.365546),('62355','IL','Nebo','Pike',39.412755,-90.778832),('62356','IL','New Canton','Pike',39.598368,-91.091112),('62357','IL','New Salem','Pike',39.687272,-90.858109),('62358','IL','Niota','Hancock',40.598755,-91.250808),('62359','IL','Paloma','Adams',40.022763,-91.201144),('62360','IL','Payson','Adams',39.815341,-91.264855),('62361','IL','Pearl','Pike',39.474425,-90.635574),('62362','IL','Perry','Pike',39.782472,-90.744999),('62363','IL','Pittsfield','Pike',39.606401,-90.787744),('62365','IL','Plainville','Adams',39.7964,-91.165131),('62366','IL','Pleasant Hill','Pike',39.455666,-90.880184),('62367','IL','Plymouth','Hancock',40.297711,-90.883067),('62370','IL','Rockport','Pike',39.517293,-91.007228),('62373','IL','Sutter','Hancock',40.241879,-91.339323),('62374','IL','Tennessee','Mcdonough',40.403562,-90.883242),('62375','IL','Timewell','Brown',40.003719,-90.872941),('62376','IL','Ursa','Adams',40.103713,-91.407746),('62378','IL','Versailles','Brown',39.891315,-90.638028),('62379','IL','Warsaw','Hancock',40.32235,-91.410478),('62380','IL','West Point','Hancock',40.252554,-91.184795),('62401','IL','Effingham','Effingham',39.123623,-88.556417),('62410','IL','Allendale','Wabash',38.527734,-87.729098),('62411','IL','Altamont','Effingham',39.068203,-88.742694),('62413','IL','Annapolis','Crawford',39.138799,-87.837748),('62414','IL','Beecher City','Fayette',39.167786,-88.825372),('62417','IL','Bridgeport','Lawrence',38.730057,-87.767823),('62418','IL','Brownstown','Fayette',39.022359,-88.960075),('62419','IL','Calhoun','Richland',38.625444,-87.994291),('62420','IL','Casey','Clark',39.298128,-87.998652),('62421','IL','Claremont','Richland',38.743365,-87.953758),('62422','IL','Cowden','Shelby',39.246045,-88.875408),('62423','IL','Dennison','Clark',39.453143,-87.569414),('62424','IL','Dieterich','Effingham',39.008426,-88.427969),('62425','IL','Dundas','Richland',38.835652,-88.091582),('62426','IL','Edgewood','Effingham',38.911153,-88.665115),('62427','IL','Flat Rock','Crawford',38.873398,-87.664224),('62428','IL','Greenup','Cumberland',39.256483,-88.138414),('62431','IL','Herrick','Shelby',39.221443,-88.989343),('62432','IL','Hidalgo','Jasper',39.139403,-88.148534),('62433','IL','Hutsonville','Crawford',39.110772,-87.675994),('62434','IL','Ingraham','Clay',38.854018,-88.335238),('62435','IL','Janesville','Cumberland',39.3741,-88.2436),('62436','IL','Jewett','Cumberland',39.191243,-88.257796),('62438','IL','Lakewood','Shelby',39.316428,-88.879121),('62439','IL','Lawrenceville','Lawrence',38.731103,-87.662872),('62440','IL','Lerna','Coles',39.39692,-88.266561),('62441','IL','Marshall','Clark',39.396465,-87.696066),('62442','IL','Martinsville','Clark',39.325185,-87.863665),('62443','IL','Mason','Effingham',38.960836,-88.629499),('62444','IL','Mode','Shelby',39.277095,-88.741384),('62445','IL','Montrose','Cumberland',39.17437,-88.346021),('62446','IL','Mount Erie','Wayne',38.48835,-88.219971),('62447','IL','Neoga','Cumberland',39.317236,-88.452297),('62448','IL','Newton','Jasper',38.97406,-88.178242),('62449','IL','Oblong','Crawford',39.007209,-87.902858),('62450','IL','Olney','Richland',38.725865,-88.085969),('62451','IL','Palestine','Crawford',39.006913,-87.612015),('62452','IL','Parkersburg','Richland',38.58749,-88.035117),('62454','IL','Robinson','Crawford',39.004406,-87.747863),('62458','IL','Saint Elmo','Fayette',39.035727,-88.873609),('62459','IL','Sainte Marie','Jasper',38.931492,-88.025406),('62460','IL','Saint Francisville','Lawrence',38.598089,-87.672998),('62461','IL','Shumway','Effingham',39.19415,-88.665619),('62462','IL','Sigel','Shelby',39.234016,-88.481736),('62463','IL','Stewardson','Shelby',39.280665,-88.609832),('62464','IL','Stoy','Crawford',38.9975,-87.833),('62465','IL','Strasburg','Shelby',39.349589,-88.635023),('62466','IL','Sumner','Lawrence',38.723836,-87.847274),('62467','IL','Teutopolis','Effingham',39.125605,-88.45585),('62468','IL','Toledo','Cumberland',39.272206,-88.258758),('62469','IL','Trilla','Cumberland',39.351236,-88.333828),('62471','IL','Vandalia','Fayette',38.963304,-89.108215),('62473','IL','Watson','Effingham',39.023209,-88.559764),('62474','IL','Westfield','Clark',39.450119,-87.991718),('62475','IL','West Liberty','Jasper',38.886489,-88.04754),('62476','IL','West Salem','Edwards',38.528229,-88.000038),('62477','IL','West Union','Clark',39.227055,-87.66098),('62478','IL','West York','Crawford',39.176272,-87.72199),('62479','IL','Wheeler','Jasper',39.037041,-88.306897),('62480','IL','Willow Hill','Jasper',38.993209,-88.001887),('62481','IL','Yale','Jasper',39.122321,-88.019502),('62501','IL','Argenta','Macon',39.941961,-88.805357),('62510','IL','Assumption','Christian',39.530414,-89.028788),('62512','IL','Beason','Logan',40.14223,-89.195576),('62513','IL','Blue Mound','Macon',39.719647,-89.128584),('62514','IL','Boody','Macon',39.76503,-89.048547),('62515','IL','Buffalo','Sangamon',39.852804,-89.378286),('62517','IL','Bulpitt','Christian',39.591638,-89.427609),('62518','IL','Chestnut','Logan',40.050296,-89.188555),('62519','IL','Cornland','Logan',39.93702,-89.401776),('62520','IL','Dawson','Sangamon',39.824552,-89.456341),('62521','IL','Decatur','Macon',39.828842,-88.928418),('62522','IL','Decatur','Macon',39.837268,-89.008873),('62523','IL','Decatur','Macon',39.844191,-88.952196),('62524','IL','Decatur','Macon',39.9045,-88.9642),('62525','IL','Decatur','Macon',39.8426,-88.9525),('62526','IL','Decatur','Macon',39.879895,-88.95745),('62530','IL','Divernon','Sangamon',39.569156,-89.653802),('62531','IL','Edinburg','Christian',39.661611,-89.390125),('62532','IL','Elwin','Macon',39.777362,-88.979883),('62533','IL','Farmersville','Montgomery',39.443722,-89.638968),('62534','IL','Findlay','Shelby',39.515388,-88.77264),('62535','IL','Forsyth','Macon',39.925434,-88.960099),('62536','IL','Glenarm','Sangamon',39.63306,-89.658175),('62537','IL','Harristown','Macon',39.854874,-89.086504),('62538','IL','Harvel','Montgomery',39.358451,-89.524382),('62539','IL','Illiopolis','Sangamon',39.859167,-89.256289),('62540','IL','Kincaid','Christian',39.587059,-89.413953),('62541','IL','Lake Fork','Logan',39.969319,-89.351589),('62543','IL','Latham','Logan',39.96696,-89.159156),('62544','IL','Macon','Macon',39.708212,-88.992864),('62545','IL','Mechanicsburg','Sangamon',39.772255,-89.390741),('62546','IL','Morrisonville','Christian',39.43221,-89.449256),('62547','IL','Mount Auburn','Christian',39.766531,-89.253215),('62548','IL','Mount Pulaski','Logan',39.996517,-89.281397),('62549','IL','Mt Zion','Macon',39.777058,-88.871699),('62550','IL','Moweaqua','Shelby',39.616651,-89.012459),('62551','IL','Niantic','Macon',39.849655,-89.158622),('62553','IL','Oconee','Shelby',39.275525,-89.108968),('62554','IL','Oreana','Macon',39.93799,-88.862972),('62555','IL','Owaneco','Christian',39.474737,-89.22072),('62556','IL','Palmer','Christian',39.469287,-89.393883),('62557','IL','Pana','Christian',39.38981,-89.08193),('62558','IL','Pawnee','Sangamon',39.586712,-89.549853),('62560','IL','Raymond','Montgomery',39.310611,-89.595007),('62561','IL','Riverton','Sangamon',39.858145,-89.527875),('62563','IL','Rochester','Sangamon',39.731379,-89.511377),('62565','IL','Shelbyville','Shelby',39.408208,-88.801419),('62567','IL','Stonington','Christian',39.639295,-89.190247),('62568','IL','Taylorville','Christian',39.54982,-89.298076),('62570','IL','Tovey','Christian',39.58858,-89.4496),('62571','IL','Tower Hill','Shelby',39.381449,-88.956191),('62572','IL','Waggoner','Montgomery',39.361835,-89.699513),('62573','IL','Warrensburg','Macon',39.95086,-89.077228),('62601','IL','Alexander','Morgan',39.740304,-90.032776),('62610','IL','Alsey','Scott',39.560307,-90.434657),('62611','IL','Arenzville','Cass',39.887836,-90.40038),('62612','IL','Ashland','Cass',39.891785,-90.036586),('62613','IL','Athens','Menard',39.982621,-89.703242),('62615','IL','Auburn','Sangamon',39.587019,-89.749084),('62617','IL','Bath','Mason',40.156822,-90.16989),('62618','IL','Beardstown','Cass',40.004198,-90.42677),('62621','IL','Bluffs','Scott',39.720788,-90.535015),('62622','IL','Bluff Springs','Cass',39.9877,-90.3458),('62624','IL','Browning','Schuyler',40.145439,-90.365177),('62625','IL','Cantrall','Sangamon',39.910049,-89.687467),('62626','IL','Carlinville','Macoupin',39.281483,-89.877911),('62627','IL','Chandlerville','Cass',40.062292,-90.135595),('62628','IL','Chapin','Morgan',39.772776,-90.398056),('62629','IL','Chatham','Sangamon',39.677741,-89.693319),('62630','IL','Chesterfield','Macoupin',39.278791,-90.075402),('62631','IL','Concord','Morgan',39.816588,-90.36552),('62633','IL','Easton','Mason',40.223648,-89.870732),('62634','IL','Elkhart','Logan',40.029458,-89.466518),('62635','IL','Emden','Logan',40.296705,-89.475561),('62638','IL','Franklin','Morgan',39.60975,-90.079989),('62639','IL','Frederick','Schuyler',40.036151,-90.479664),('62640','IL','Girard','Macoupin',39.429491,-89.792282),('62642','IL','Greenview','Menard',40.09594,-89.70805),('62643','IL','Hartsburg','Logan',40.248665,-89.44509),('62644','IL','Havana','Mason',40.297432,-90.051814),('62649','IL','Hettick','Macoupin',39.355818,-90.070997),('62650','IL','Jacksonville','Morgan',39.729267,-90.227544),('62651','IL','Jacksonville','Morgan',39.7338,-90.2288),('62655','IL','Kilbourne','Mason',40.155606,-89.985532),('62656','IL','Lincoln','Logan',40.146772,-89.371246),('62659','IL','Lincolns New Salem','Menard',40.0446,-89.8544),('62660','IL','Literberry','Morgan',39.8541,-90.1994),('62661','IL','Loami','Sangamon',39.668222,-89.84743),('62662','IL','Lowder','Sangamon',39.5508,-89.8458),('62663','IL','Manchester','Scott',39.541924,-90.329634),('62664','IL','Mason City','Mason',40.201455,-89.704297),('62665','IL','Meredosia','Morgan',39.809834,-90.557989),('62666','IL','Middletown','Logan',40.088353,-89.567996),('62667','IL','Modesto','Macoupin',39.487765,-89.992297),('62668','IL','Murrayville','Morgan',39.576393,-90.24905),('62670','IL','New Berlin','Sangamon',39.740538,-89.878562),('62671','IL','New Holland','Logan',40.180239,-89.566123),('62672','IL','Nilwood','Macoupin',39.397478,-89.807336),('62673','IL','Oakford','Menard',40.102583,-89.98358),('62674','IL','Palmyra','Macoupin',39.434924,-90.005337),('62675','IL','Petersburg','Menard',40.01351,-89.845632),('62677','IL','Pleasant Plains','Sangamon',39.852674,-89.879391),('62681','IL','Rushville','Schuyler',40.126617,-90.551347),('62682','IL','San Jose','Mason',40.297988,-89.630956),('62683','IL','Scottville','Macoupin',39.4873,-90.1088),('62684','IL','Sherman','Sangamon',39.895924,-89.588744),('62685','IL','Shipman','Macoupin',39.143519,-89.994121),('62688','IL','Tallula','Menard',39.943309,-89.934304),('62689','IL','Thayer','Sangamon',39.539015,-89.760856),('62690','IL','Virden','Macoupin',39.504639,-89.764326),('62691','IL','Virginia','Cass',39.955577,-90.215052),('62692','IL','Waverly','Morgan',39.586367,-89.944154),('62693','IL','Williamsville','Sangamon',39.958545,-89.531254),('62694','IL','Winchester','Scott',39.630384,-90.469156),('62695','IL','Woodson','Morgan',39.627368,-90.221053),('62701','IL','Springfield','Sangamon',39.801143,-89.648598),('62702','IL','Springfield','Sangamon',39.820005,-89.641721),('62703','IL','Springfield','Sangamon',39.772165,-89.63224),('62704','IL','Springfield','Sangamon',39.777741,-89.681535),('62705','IL','Springfield','Sangamon',39.799,-89.6465),('62706','IL','Springfield','Sangamon',39.7987,-89.6534),('62707','IL','Springfield','Sangamon',39.841791,-89.620506),('62708','IL','Springfield','Sangamon',39.7946,-89.6247),('62711','IL','Springfield','Sangamon',39.754195,-89.716013),('62712','IL','Springfield','Sangamon',39.727493,-89.60427),('62713','IL','Springfield','Sangamon',39.8016,-89.6436),('62715','IL','Springfield','Sangamon',39.8016,-89.6436),('62716','IL','Springfield','Sangamon',39.8016,-89.6436),('62719','IL','Springfield','Sangamon',39.8016,-89.6436),('62721','IL','Springfield','Sangamon',39.8016,-89.6436),('62722','IL','Springfield','Sangamon',39.8016,-89.6436),('62723','IL','Springfield','Sangamon',39.8016,-89.6436),('62726','IL','Springfield','Sangamon',39.8016,-89.6436),('62736','IL','Springfield','Sangamon',39.8016,-89.6436),('62739','IL','Springfield','Sangamon',39.8003,-89.6471),('62746','IL','Springfield','Sangamon',39.8016,-89.6436),('62756','IL','Springfield','Sangamon',39.7971,-89.6535),('62757','IL','Springfield','Sangamon',39.8016,-89.6436),('62761','IL','Springfield','Sangamon',39.8016,-89.6436),('62762','IL','Springfield','Sangamon',39.8016,-89.6436),('62763','IL','Springfield','Sangamon',39.8016,-89.6436),('62764','IL','Springfield','Sangamon',39.8016,-89.6436),('62765','IL','Springfield','Sangamon',39.8016,-89.6436),('62766','IL','Springfield','Sangamon',39.8016,-89.6436),('62767','IL','Springfield','Sangamon',39.7946,-89.6247),('62769','IL','Springfield','Sangamon',39.8016,-89.6436),('62776','IL','Springfield','Sangamon',39.8016,-89.6436),('62777','IL','Springfield','Sangamon',39.8022,-89.6547),('62781','IL','Springfield','Sangamon',39.8016,-89.6436),('62786','IL','Springfield','Sangamon',39.8016,-89.6436),('62791','IL','Springfield','Sangamon',39.7946,-89.6247),('62794','IL','Springfield','Sangamon',39.8016,-89.6436),('62796','IL','Springfield','Sangamon',39.8016,-89.6436),('62801','IL','Centralia','Marion',38.524194,-89.126408),('62803','IL','Hoyleton','Washington',38.44579,-89.299832),('62805','IL','Akin','Franklin',37.9877,-88.7522),('62806','IL','Albion','Edwards',38.377367,-88.067991),('62807','IL','Alma','Marion',38.734432,-88.919127),('62808','IL','Ashley','Washington',38.311966,-89.186444),('62809','IL','Barnhill','Wayne',38.257572,-88.334062),('62810','IL','Belle Rive','Jefferson',38.219664,-88.739927),('62811','IL','Bellmont','Wabash',38.383866,-87.907995),('62812','IL','Benton','Franklin',37.998452,-88.925662),('62814','IL','Bluford','Jefferson',38.349995,-88.735144),('62815','IL','Bone Gap','Edwards',38.452346,-87.993961),('62816','IL','Bonnie','Jefferson',38.192994,-88.931066),('62817','IL','Broughton','Hamilton',37.954569,-88.478429),('62818','IL','Browns','Edwards',38.383094,-87.963482),('62819','IL','Buckner','Franklin',37.981016,-89.015659),('62820','IL','Burnt Prairie','White',38.250007,-88.235216),('62821','IL','Carmi','White',38.079464,-88.153544),('62822','IL','Christopher','Franklin',37.973972,-89.054102),('62823','IL','Cisne','Wayne',38.517538,-88.44156),('62824','IL','Clay City','Clay',38.683976,-88.35328),('62825','IL','Coello','Franklin',37.997364,-89.068669),('62827','IL','Crossville','White',38.164921,-88.030556),('62828','IL','Dahlgren','Hamilton',38.207107,-88.620444),('62829','IL','Dale','Hamilton',37.988998,-88.490205),('62830','IL','Dix','Jefferson',38.451372,-88.970134),('62831','IL','Du Bois','Washington',38.224456,-89.216238),('62832','IL','Du Quoin','Perry',38.011822,-89.24891),('62833','IL','Ellery','Wayne',38.364262,-88.164836),('62834','IL','Emma','White',37.9747,-88.1202),('62835','IL','Enfield','White',38.101841,-88.329651),('62836','IL','Ewing','Franklin',38.096453,-88.827764),('62837','IL','Fairfield','Wayne',38.374506,-88.359358),('62838','IL','Farina','Fayette',38.8656,-88.769406),('62839','IL','Flora','Clay',38.668431,-88.486622),('62840','IL','Frankfort Heights','Franklin',37.8983,-88.8395),('62841','IL','Freeman Spur','Williamson',37.857365,-89.000659),('62842','IL','Geff','Wayne',38.460311,-88.371217),('62843','IL','Golden Gate','Wayne',38.375178,-88.192981),('62844','IL','Grayville','White',38.258072,-88.020806),('62846','IL','Ina','Jefferson',38.14957,-88.89475),('62848','IL','Irvington','Washington',38.436971,-89.161721),('62849','IL','Iuka','Marion',38.594956,-88.759432),('62850','IL','Johnsonville','Wayne',38.497553,-88.57555),('62851','IL','Keenes','Wayne',38.41492,-88.659513),('62852','IL','Keensburg','Wabash',38.350269,-87.86703),('62853','IL','Kell','Marion',38.513333,-88.931422),('62854','IL','Kinmundy','Marion',38.76978,-88.815159),('62855','IL','Lancaster','Wabash',38.5178,-87.9064),('62856','IL','Logan','Franklin',37.956426,-88.839678),('62857','IL','Loogootee','Fayette',38.911662,-88.877473),('62858','IL','Louisville','Clay',38.801077,-88.488016),('62859','IL','Mc Leansboro','Hamilton',38.086592,-88.532374),('62860','IL','Macedonia','Franklin',38.050565,-88.730961),('62861','IL','Maunie','White',38.034676,-88.043212),('62862','IL','Mill Shoals','White',38.227315,-88.320747),('62863','IL','Mount Carmel','Wabash',38.408418,-87.806415),('62864','IL','Mount Vernon','Jefferson',38.323223,-88.909648),('62865','IL','Mulkeytown','Franklin',37.962596,-89.069023),('62866','IL','Nason','Jefferson',38.1399,-89.0186),('62867','IL','New Haven','Gallatin',37.914722,-88.120151),('62868','IL','Noble','Richland',38.69382,-88.232569),('62869','IL','Norris City','White',37.969285,-88.295712),('62870','IL','Odin','Marion',38.614285,-89.047409),('62871','IL','Omaha','Gallatin',37.877557,-88.291327),('62872','IL','Opdyke','Jefferson',38.271833,-88.801109),('62874','IL','Orient','Franklin',37.922515,-88.978266),('62875','IL','Patoka','Marion',38.752553,-89.102686),('62876','IL','Radom','Washington',38.282386,-89.194798),('62877','IL','Richview','Washington',38.385607,-89.201759),('62878','IL','Rinard','Wayne',38.574732,-88.502404),('62879','IL','Sailor Springs','Clay',38.763676,-88.361383),('62880','IL','Saint Peter','Fayette',38.87575,-88.873231),('62881','IL','Salem','Marion',38.623867,-88.953562),('62882','IL','Sandoval','Marion',38.610078,-89.121117),('62883','IL','Scheller','Jefferson',38.168359,-89.101894),('62884','IL','Sesser','Franklin',38.086503,-89.046151),('62885','IL','Shobonier','Fayette',38.859553,-89.05352),('62886','IL','Sims','Wayne',38.379255,-88.535908),('62887','IL','Springerton','White',38.193381,-88.361591),('62888','IL','Tamaroa','Perry',38.123937,-89.236013),('62889','IL','Texico','Jefferson',38.45769,-88.837257),('62890','IL','Thompsonville','Franklin',37.909761,-88.744272),('62891','IL','Valier','Franklin',38.015023,-89.041196),('62892','IL','Vernon','Marion',38.805155,-89.083467),('62893','IL','Walnut Hill','Marion',38.469338,-89.037342),('62894','IL','Waltonville','Jefferson',38.209563,-89.036696),('62895','IL','Wayne City','Wayne',38.306889,-88.559934),('62896','IL','West Frankfort','Franklin',37.894587,-88.926004),('62897','IL','Whittington','Franklin',38.093889,-88.911821),('62898','IL','Woodlawn','Jefferson',38.342099,-89.049128),('62899','IL','Xenia','Clay',38.636238,-88.641403),('62901','IL','Carbondale','Jackson',37.7314,-89.21506),('62902','IL','Carbondale','Jackson',37.677027,-89.132435),('62903','IL','Carbondale','Jackson',37.675319,-89.253751),('62905','IL','Alto Pass','Union',37.579303,-89.351696),('62906','IL','Anna','Union',37.461842,-89.219515),('62907','IL','Ava','Jackson',37.861577,-89.505045),('62908','IL','Belknap','Massac',37.313844,-88.871619),('62909','IL','Boles','Johnson',37.4253,-88.9661),('62910','IL','Brookport','Massac',37.134986,-88.575314),('62912','IL','Buncombe','Johnson',37.476199,-89.032408),('62914','IL','Cairo','Alexander',37.027171,-89.187909),('62915','IL','Cambria','Williamson',37.784512,-89.11979),('62916','IL','Campbell Hill','Jackson',37.9292,-89.568729),('62917','IL','Carrier Mills','Saline',37.70513,-88.650355),('62918','IL','Carterville','Williamson',37.768166,-89.081601),('62919','IL','Cave In Rock','Hardin',37.494722,-88.159363),('62920','IL','Cobden','Union',37.537906,-89.250851),('62921','IL','Colp','Williamson',37.804886,-89.081407),('62922','IL','Creal Springs','Williamson',37.615081,-88.837872),('62923','IL','Cypress','Johnson',37.336001,-89.023121),('62924','IL','De Soto','Jackson',37.823932,-89.209349),('62926','IL','Dongola','Union',37.364822,-89.155577),('62927','IL','Dowell','Jackson',37.93867,-89.239539),('62928','IL','Eddyville','Pope',37.497065,-88.588112),('62930','IL','Eldorado','Saline',37.822131,-88.442283),('62931','IL','Elizabethtown','Hardin',37.507265,-88.283496),('62932','IL','Elkville','Jackson',37.904275,-89.231949),('62933','IL','Energy','Williamson',37.772371,-89.025656),('62934','IL','Equality','Gallatin',37.715799,-88.359451),('62935','IL','Galatia','Saline',37.829214,-88.630999),('62938','IL','Golconda','Pope',37.365677,-88.541853),('62939','IL','Goreville','Johnson',37.558531,-88.966368),('62940','IL','Gorham','Jackson',37.727115,-89.476265),('62941','IL','Grand Chain','Pulaski',37.236828,-88.956997),('62942','IL','Grand Tower','Jackson',37.629594,-89.481062),('62943','IL','Grantsburg','Johnson',37.360748,-88.733214),('62946','IL','Harrisburg','Saline',37.725717,-88.544384),('62947','IL','Herod','Hardin',37.560431,-88.424965),('62948','IL','Herrin','Williamson',37.804003,-89.02811),('62949','IL','Hurst','Williamson',37.831132,-89.144618),('62950','IL','Jacob','Jackson',37.760088,-89.551658),('62951','IL','Johnston City','Williamson',37.820286,-88.930488),('62952','IL','Jonesboro','Union',37.421505,-89.311968),('62953','IL','Joppa','Massac',37.209266,-88.846999),('62954','IL','Junction','Gallatin',37.702127,-88.264578),('62955','IL','Karbers Ridge','Hardin',37.4672,-88.3671),('62956','IL','Karnak','Pulaski',37.29431,-88.937153),('62957','IL','Mc Clure','Alexander',37.310252,-89.439918),('62958','IL','Makanda','Jackson',37.625214,-89.209464),('62959','IL','Marion','Williamson',37.725127,-88.929367),('62960','IL','Metropolis','Massac',37.184984,-88.728435),('62961','IL','Millcreek','Union',37.341645,-89.254601),('62962','IL','Miller City','Alexander',37.108722,-89.343096),('62963','IL','Mound City','Pulaski',37.087392,-89.164176),('62964','IL','Mounds','Pulaski',37.117496,-89.201509),('62965','IL','Muddy','Saline',37.76419,-88.517367),('62966','IL','Murphysboro','Jackson',37.773573,-89.337439),('62967','IL','New Burnside','Johnson',37.582341,-88.76375),('62969','IL','Olive Branch','Alexander',37.158854,-89.343643),('62970','IL','Olmsted','Pulaski',37.196116,-89.095565),('62971','IL','Oraville','Jackson',37.8646,-89.3813),('62972','IL','Ozark','Johnson',37.536148,-88.819492),('62973','IL','Perks','Pulaski',37.3097,-89.0808),('62974','IL','Pittsburg','Williamson',37.780055,-88.815305),('62975','IL','Pomona','Jackson',37.639429,-89.366944),('62976','IL','Pulaski','Pulaski',37.220517,-89.204003),('62977','IL','Raleigh','Saline',37.842728,-88.543868),('62979','IL','Ridgway','Gallatin',37.802401,-88.24264),('62982','IL','Rosiclare','Hardin',37.427031,-88.345481),('62983','IL','Royalton','Franklin',37.885611,-89.110884),('62984','IL','Shawneetown','Gallatin',37.704938,-88.167769),('62985','IL','Simpson','Johnson',37.44865,-88.702692),('62987','IL','Stonefort','Saline',37.633397,-88.68043),('62988','IL','Tamms','Alexander',37.234055,-89.29377),('62990','IL','Thebes','Alexander',37.220418,-89.433559),('62992','IL','Ullin','Pulaski',37.277294,-89.165865),('62993','IL','Unity','Alexander',37.150263,-89.273513),('62994','IL','Vergennes','Jackson',37.903048,-89.338849),('62995','IL','Vienna','Johnson',37.425746,-88.878666),('62996','IL','Villa Ridge','Pulaski',37.165673,-89.158195),('62997','IL','Willisville','Perry',37.983572,-89.590535),('62998','IL','Wolf Lake','Union',37.515637,-89.445311),('62999','IL','Zeigler','Franklin',37.898108,-89.054551),('63001','MO','Allenton','Saint Louis',38.5036,-90.6758),('63005','MO','Chesterfield','St. Louis',38.644758,-90.625485),('63006','MO','Chesterfield','Saint Louis',38.663,-90.5769),('63010','MO','Arnold','Jefferson',38.429752,-90.384459),('63011','MO','Ballwin','St. Louis',38.604681,-90.550242),('63012','MO','Barnhart','Jefferson',38.330022,-90.431919),('63013','MO','Beaufort','Franklin',38.418782,-91.151862),('63014','MO','Berger','Franklin',38.659004,-91.337877),('63015','MO','Catawissa','Franklin',38.40324,-90.750235),('63016','MO','Cedar Hill','Jefferson',38.353191,-90.641039),('63017','MO','Chesterfield','St. Louis',38.646546,-90.537013),('63019','MO','Crystal City','Jefferson',38.225767,-90.381941),('63020','MO','De Soto','Jefferson',38.119415,-90.553314),('63021','MO','Ballwin','St. Louis',38.575352,-90.53377),('63022','MO','Ballwin','Saint Louis',38.595,-90.5461),('63023','MO','Dittmer','Jefferson',38.27449,-90.711481),('63024','MO','Ballwin','Saint Louis',38.6042,-90.5526),('63025','MO','Eureka','St. Louis',38.499429,-90.617264),('63026','MO','Fenton','St. Louis',38.507045,-90.457779),('63028','MO','Festus','Jefferson',38.194628,-90.411326),('63030','MO','Fletcher','Washington',38.129107,-90.744215),('63031','MO','Florissant','St. Louis',38.803775,-90.338748),('63032','MO','Florissant','Saint Louis',38.8025,-90.3109),('63033','MO','Florissant','St. Louis',38.79196,-90.283064),('63034','MO','Florissant','St. Louis',38.834931,-90.285107),('63036','MO','French Village','St. Francois',37.984151,-90.349833),('63037','MO','Gerald','Franklin',38.414566,-91.31695),('63038','MO','Glencoe','St. Louis',38.583799,-90.660359),('63039','MO','Gray Summit','Franklin',38.496215,-90.832024),('63040','MO','Grover','St. Louis',38.576574,-90.622392),('63041','MO','Grubville','Franklin',38.244845,-90.780639),('63042','MO','Hazelwood','St. Louis',38.78012,-90.367728),('63043','MO','Maryland Heights','St. Louis',38.725877,-90.449818),('63044','MO','Bridgeton','St. Louis',38.760946,-90.421565),('63045','MO','Earth City','Saint Louis',38.7664,-90.461),('63047','MO','Hematite','Jefferson',38.1331,-90.3677),('63048','MO','Herculaneum','Jefferson',38.25866,-90.393907),('63049','MO','High Ridge','Jefferson',38.477926,-90.526908),('63050','MO','Hillsboro','Jefferson',38.260132,-90.561522),('63051','MO','House Springs','Jefferson',38.40777,-90.571549),('63052','MO','Imperial','Jefferson',38.383842,-90.410155),('63053','MO','Kimmswick','Jefferson',38.366567,-90.364166),('63055','MO','Labadie','Franklin',38.526389,-90.839132),('63056','MO','Leslie','Franklin',38.399872,-91.23326),('63057','MO','Liguori','Jefferson',38.342505,-90.407549),('63060','MO','Lonedell','Franklin',38.256273,-90.86041),('63061','MO','Luebbering','Franklin',38.271639,-90.810838),('63065','MO','Mapaville','Jefferson',38.2488,-90.4833),('63066','MO','Morse Mill','Jefferson',38.2766,-90.653),('63068','MO','New Haven','Franklin',38.561638,-91.232207),('63069','MO','Pacific','Franklin',38.481635,-90.736678),('63070','MO','Pevely','Jefferson',38.28267,-90.409024),('63071','MO','Richwoods','Washington',38.151434,-90.815763),('63072','MO','Robertsville','Franklin',38.369617,-90.813033),('63073','MO','Saint Albans','Franklin',38.584692,-90.769496),('63074','MO','Saint Ann','St. Louis',38.726423,-90.387364),('63077','MO','Saint Clair','Franklin',38.339597,-90.98548),('63079','MO','Stanton','Franklin',38.259714,-91.102952),('63080','MO','Sullivan','Franklin',38.196519,-91.116776),('63084','MO','Union','Franklin',38.437882,-90.995801),('63087','MO','Valles Mines','St. Francois',38.023581,-90.462136),('63088','MO','Valley Park','St. Louis',38.55227,-90.495244),('63089','MO','Villa Ridge','Franklin',38.46478,-90.882121),('63090','MO','Washington','Franklin',38.537259,-91.018792),('63091','MO','Rosebud','Gasconade',38.383924,-91.393892),('63099','MO','Fenton','Saint Louis',38.513,-90.4358),('63101','MO','Saint Louis','St. Louis City',38.631415,-90.193064),('63102','MO','Saint Louis','St. Louis City',38.630973,-90.187198),('63103','MO','Saint Louis','St. Louis City',38.631195,-90.214185),('63104','MO','Saint Louis','St. Louis City',38.612103,-90.214222),('63105','MO','Saint Louis','St. Louis',38.644359,-90.328871),('63106','MO','Saint Louis','St. Louis City',38.644233,-90.206479),('63107','MO','Saint Louis','St. Louis City',38.66257,-90.209786),('63108','MO','Saint Louis','St. Louis City',38.643531,-90.251828),('63109','MO','Saint Louis','St. Louis City',38.585935,-90.29399),('63110','MO','Saint Louis','St. Louis City',38.622443,-90.261891),('63111','MO','Saint Louis','St. Louis City',38.559241,-90.251931),('63112','MO','Saint Louis','St. Louis City',38.66031,-90.284429),('63113','MO','Saint Louis','St. Louis City',38.657701,-90.246603),('63114','MO','Saint Louis','St. Louis',38.703754,-90.359104),('63115','MO','Saint Louis','St. Louis City',38.679386,-90.240246),('63116','MO','Saint Louis','St. Louis City',38.580814,-90.264108),('63117','MO','Saint Louis','St. Louis',38.629477,-90.327499),('63118','MO','Saint Louis','St. Louis City',38.592889,-90.228632),('63119','MO','Saint Louis','St. Louis',38.587119,-90.350529),('63120','MO','Saint Louis','St. Louis City',38.693623,-90.259976),('63121','MO','Saint Louis','St. Louis',38.705998,-90.298164),('63122','MO','Saint Louis','St. Louis',38.580829,-90.4144),('63123','MO','Saint Louis','St. Louis',38.549382,-90.323679),('63124','MO','Saint Louis','St. Louis',38.636547,-90.374644),('63125','MO','Saint Louis','St. Louis',38.521465,-90.291211),('63126','MO','Saint Louis','St. Louis',38.553064,-90.380273),('63127','MO','Saint Louis','St. Louis',38.536826,-90.412886),('63128','MO','Saint Louis','St. Louis',38.497027,-90.374789),('63129','MO','Saint Louis','St. Louis',38.468386,-90.322106),('63130','MO','Saint Louis','St. Louis',38.665066,-90.323673),('63131','MO','Saint Louis','St. Louis',38.61673,-90.439554),('63132','MO','Saint Louis','St. Louis',38.676582,-90.374837),('63133','MO','Saint Louis','St. Louis',38.677242,-90.305469),('63134','MO','Saint Louis','St. Louis',38.742113,-90.341789),('63135','MO','Saint Louis','St. Louis',38.747905,-90.301488),('63136','MO','Saint Louis','St. Louis',38.738681,-90.260948),('63137','MO','Saint Louis','St. Louis',38.750526,-90.217133),('63138','MO','Saint Louis','St. Louis',38.78956,-90.207545),('63139','MO','Saint Louis','St. Louis City',38.609724,-90.291159),('63140','MO','Saint Louis','St. Louis',38.739561,-90.321872),('63141','MO','Saint Louis','St. Louis',38.661232,-90.457862),('63143','MO','Saint Louis','St. Louis',38.611601,-90.318239),('63144','MO','Saint Louis','St. Louis',38.621084,-90.348176),('63145','MO','Saint Louis','Saint Louis',38.7397,-90.3627),('63146','MO','Saint Louis','St. Louis',38.69094,-90.449966),('63147','MO','Saint Louis','St. Louis City',38.696601,-90.222066),('63150','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63151','MO','Saint Louis','Saint Louis',38.4688,-90.305),('63155','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63156','MO','Saint Louis','Saint Louis City',38.6368,-90.2445),('63157','MO','Saint Louis','Saint Louis City',38.6072,-90.2007),('63158','MO','Saint Louis','Saint Louis City',38.6041,-90.2226),('63160','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63163','MO','Saint Louis','Saint Louis City',38.5994,-90.2422),('63164','MO','Saint Louis','Saint Louis City',38.6189,-90.1994),('63166','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63167','MO','Saint Louis','Saint Louis',38.6723,-90.4048),('63169','MO','Saint Louis','Saint Louis City',38.6288,-90.1924),('63171','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63177','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63178','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63179','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63180','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63182','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63188','MO','Saint Louis','Saint Louis City',38.6294,-90.1963),('63190','MO','Saint Louis','Saint Louis City',38.6272,-90.1978),('63195','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63196','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63197','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63198','MO','Saint Louis','Saint Louis',38.6583,-90.5672),('63199','MO','Saint Louis','Saint Louis City',38.6291,-90.2054),('63301','MO','Saint Charles','St. Charles',38.809687,-90.500968),('63302','MO','Saint Charles','Saint Charles',38.8606,-90.4712),('63303','MO','Saint Charles','St. Charles',38.761835,-90.539067),('63304','MO','Saint Charles','St. Charles',38.725293,-90.652758),('63330','MO','Annada','Pike',39.261557,-90.811959),('63332','MO','Augusta','St. Charles',38.596381,-90.894211),('63333','MO','Bellflower','Montgomery',39.02968,-91.324568),('63334','MO','Bowling Green','Pike',39.320532,-91.184785),('63336','MO','Clarksville','Pike',39.360912,-90.939626),('63338','MO','Cottleville','Saint Charles',38.7461,-90.6538),('63339','MO','Curryville','Pike',39.336612,-91.375802),('63341','MO','Defiance','St. Charles',38.677137,-90.795776),('63342','MO','Dutzow','Warren',38.6055,-90.9944),('63343','MO','Elsberry','Lincoln',39.15172,-90.812316),('63344','MO','Eolia','Pike',39.22785,-91.017386),('63345','MO','Farber','Audrain',39.271226,-91.572117),('63346','MO','Flinthill','Saint Charles',38.8094,-90.8277),('63347','MO','Foley','Lincoln',39.060581,-90.774847),('63348','MO','Foristell','St. Charles',38.822899,-90.947442),('63349','MO','Hawk Point','Lincoln',38.97821,-91.151078),('63350','MO','High Hill','Montgomery',38.886715,-91.366932),('63351','MO','Jonesburg','Montgomery',38.85822,-91.310612),('63352','MO','Laddonia','Audrain',39.242316,-91.648359),('63353','MO','Louisiana','Pike',39.442576,-91.092651),('63357','MO','Marthasville','Warren',38.647855,-91.104928),('63359','MO','Middletown','Montgomery',39.159982,-91.339227),('63361','MO','Montgomery City','Montgomery',38.962507,-91.535085),('63362','MO','Moscow Mills','Lincoln',38.936585,-90.902256),('63363','MO','New Florence','Montgomery',38.882006,-91.449017),('63365','MO','New Melle','Saint Charles',38.6386,-90.8703),('63366','MO','O Fallon','St. Charles',38.817502,-90.715641),('63367','MO','Lake Saint Louis','St. Charles',38.780031,-90.789541),('63368','MO','O Fallon','St. Charles',38.751048,-90.726392),('63369','MO','Old Monroe','Lincoln',38.930913,-90.768016),('63370','MO','Olney','Lincoln',39.086167,-91.242364),('63373','MO','Portage Des Sioux','St. Charles',38.932545,-90.374733),('63376','MO','Saint Peters','St. Charles',38.781916,-90.621978),('63377','MO','Silex','Lincoln',39.105397,-91.086557),('63378','MO','Treloar','Warren',38.7817,-91.2456),('63379','MO','Troy','Lincoln',38.987831,-90.984568),('63381','MO','Truxton','Warren',38.986402,-91.253305),('63382','MO','Vandalia','Audrain',39.298523,-91.494758),('63383','MO','Warrenton','Warren',38.808086,-91.167291),('63384','MO','Wellsville','Montgomery',39.092529,-91.553592),('63385','MO','Wentzville','St. Charles',38.805646,-90.857414),('63386','MO','West Alton','St. Charles',38.873404,-90.226342),('63387','MO','Whiteside','Lincoln',39.183559,-91.016743),('63388','MO','Williamsburg','Callaway',38.875111,-91.757122),('63389','MO','Winfield','Lincoln',39.000511,-90.772845),('63390','MO','Wright City','Warren',38.8036,-91.048591),('63401','MO','Hannibal','Marion',39.703867,-91.406269),('63430','MO','Alexandria','Clark',40.385949,-91.512371),('63431','MO','Anabel','Macon',39.750986,-92.329145),('63432','MO','Arbela','Scotland',40.497239,-91.993928),('63433','MO','Ashburn','Pike',39.540451,-91.137451),('63434','MO','Bethel','Shelby',39.906255,-91.966712),('63435','MO','Canton','Lewis',40.174101,-91.555266),('63436','MO','Center','Ralls',39.503568,-91.541187),('63437','MO','Clarence','Shelby',39.738756,-92.253658),('63438','MO','Durham','Lewis',39.952825,-91.686547),('63439','MO','Emden','Shelby',39.801491,-91.850228),('63440','MO','Ewing','Lewis',39.989736,-91.734677),('63441','MO','Frankford','Pike',39.488963,-91.313019),('63442','MO','Granger','Scotland',40.4677,-91.9755),('63443','MO','Hunnewell','Shelby',39.66059,-91.869521),('63445','MO','Kahoka','Clark',40.416561,-91.718194),('63446','MO','Knox City','Knox',40.140034,-92.002285),('63447','MO','La Belle','Lewis',40.110054,-91.909131),('63448','MO','La Grange','Lewis',40.038139,-91.525444),('63450','MO','Lentner','Shelby',39.66768,-92.150734),('63451','MO','Leonard','Shelby',39.902176,-92.191318),('63452','MO','Lewistown','Lewis',40.086309,-91.794439),('63453','MO','Luray','Clark',40.487081,-91.860051),('63454','MO','Maywood','Marion',39.943605,-91.62785),('63456','MO','Monroe City','Monroe',39.628942,-91.725393),('63457','MO','Monticello','Lewis',40.142139,-91.709981),('63458','MO','Newark','Knox',39.989704,-92.00292),('63459','MO','New London','Ralls',39.584423,-91.38531),('63460','MO','Novelty','Knox',40.0031,-92.20883),('63461','MO','Palmyra','Marion',39.793162,-91.546622),('63462','MO','Perry','Ralls',39.443257,-91.692504),('63463','MO','Philadelphia','Marion',39.836529,-91.753831),('63464','MO','Plevna','Knox',39.973213,-92.086902),('63465','MO','Revere','Clark',40.510627,-91.679142),('63466','MO','Saint Patrick','Clark',40.3124,-91.6538),('63467','MO','Saverton','Ralls',39.64562,-91.266611),('63468','MO','Shelbina','Shelby',39.690327,-92.024402),('63469','MO','Shelbyville','Shelby',39.825851,-92.041218),('63471','MO','Taylor','Marion',39.923199,-91.52194),('63472','MO','Wayland','Clark',40.395002,-91.584706),('63473','MO','Williamstown','Lewis',40.248136,-91.793158),('63474','MO','Wyaconda','Clark',40.378441,-91.909743),('63501','MO','Kirksville','Adair',40.184515,-92.581164),('63530','MO','Atlanta','Macon',39.911835,-92.464292),('63531','MO','Baring','Knox',40.276911,-92.231951),('63532','MO','Bevier','Macon',39.748032,-92.571631),('63533','MO','Brashear','Adair',40.174369,-92.393234),('63534','MO','Callao','Macon',39.737309,-92.648407),('63535','MO','Coatsville','Schuyler',40.566666,-92.636255),('63536','MO','Downing','Schuyler',40.492284,-92.361391),('63537','MO','Edina','Knox',40.156165,-92.167725),('63538','MO','Elmer','Macon',39.949938,-92.667296),('63539','MO','Ethel','Macon',39.895883,-92.745161),('63540','MO','Gibbs','Adair',40.10324,-92.414892),('63541','MO','Glenwood','Schuyler',40.513653,-92.598856),('63543','MO','Gorin','Scotland',40.359352,-92.022117),('63544','MO','Green Castle','Sullivan',40.243351,-92.850174),('63545','MO','Green City','Sullivan',40.26475,-92.967999),('63546','MO','Greentop','Adair',40.333311,-92.546151),('63547','MO','Hurdland','Knox',40.1452,-92.303606),('63548','MO','Lancaster','Schuyler',40.52047,-92.50802),('63549','MO','La Plata','Macon',40.01968,-92.496993),('63551','MO','Livonia','Putnam',40.496575,-92.724492),('63552','MO','Macon','Macon',39.747623,-92.471851),('63555','MO','Memphis','Scotland',40.469625,-92.180401),('63556','MO','Milan','Sullivan',40.186276,-93.124706),('63557','MO','New Boston','Linn',39.971058,-92.890654),('63558','MO','New Cambria','Macon',39.741717,-92.743332),('63559','MO','Novinger','Adair',40.226526,-92.726959),('63560','MO','Pollock','Sullivan',40.372284,-93.112011),('63561','MO','Queen City','Schuyler',40.404985,-92.550193),('63563','MO','Rutledge','Scotland',40.304779,-92.070411),('63565','MO','Unionville','Putnam',40.474241,-92.982556),('63566','MO','Winigan','Sullivan',40.043275,-92.925622),('63567','MO','Worthington','Putnam',40.409892,-92.69119),('63601','MO','Park Hills','St. Francois',37.845171,-90.527234),('63620','MO','Annapolis','Iron',37.386654,-90.66807),('63621','MO','Arcadia','Iron',37.512212,-90.608427),('63622','MO','Belgrade','Washington',37.798131,-90.88893),('63623','MO','Belleview','Iron',37.678887,-90.841492),('63624','MO','Bismarck','St. Francois',37.740314,-90.639681),('63625','MO','Black','Reynolds',37.554897,-90.971768),('63626','MO','Blackwell','Washington',38.069144,-90.703175),('63627','MO','Bloomsdale','Ste. Genevieve',38.047307,-90.253079),('63628','MO','Bonne Terre','St. Francois',37.929194,-90.555376),('63629','MO','Bunker','Reynolds',37.415948,-91.21123),('63630','MO','Cadet','Washington',38.001164,-90.72278),('63631','MO','Caledonia','Washington',37.752846,-90.787783),('63632','MO','Cascade','Wayne',37.2994,-90.2691),('63633','MO','Centerville','Reynolds',37.442437,-91.019897),('63636','MO','Des Arc','Iron',37.29208,-90.607479),('63637','MO','Doe Run','St. Francois',37.740852,-90.499752),('63638','MO','Ellington','Reynolds',37.23941,-90.994373),('63640','MO','Farmington','St. Francois',37.784996,-90.410662),('63645','MO','Fredericktown','Madison',37.546795,-90.311779),('63648','MO','Irondale','Washington',37.826907,-90.683622),('63650','MO','Ironton','Iron',37.614512,-90.639465),('63651','MO','Knob Lick','Saint Francois',37.6752,-90.3672),('63653','MO','Leadwood','St. Francois',37.863222,-90.590679),('63654','MO','Lesterville','Reynolds',37.459158,-90.85744),('63655','MO','Marquand','Madison',37.415031,-90.184512),('63656','MO','Middle Brook','Iron',37.602741,-90.784267),('63660','MO','Mineral Point','Washington',37.913621,-90.713118),('63662','MO','Patton','Bollinger',37.512795,-90.022486),('63663','MO','Pilot Knob','Iron',37.623615,-90.643486),('63664','MO','Potosi','Washington',37.924171,-90.859237),('63665','MO','Redford','Reynolds',37.292837,-90.843843),('63666','MO','Reynolds','Reynolds',37.402982,-91.055857),('63670','MO','Sainte Genevieve','Ste. Genevieve',37.912733,-90.156623),('63673','MO','Saint Mary','Ste. Genevieve',37.858226,-89.97581),('63674','MO','Tiff','Washington',38.019156,-90.657175),('63675','MO','Vulcan','Iron',37.318132,-90.670157),('63701','MO','Cape Girardeau','Cape Girardeau',37.32664,-89.568238),('63702','MO','Cape Girardeau','Cape Girardeau',37.3081,-89.5247),('63703','MO','Cape Girardeau','Cape Girardeau',37.28855,-89.548631),('63730','MO','Advance','Stoddard',37.100892,-89.91903),('63732','MO','Altenburg','Perry',37.594398,-89.577138),('63735','MO','Bell City','Stoddard',36.999937,-89.776014),('63736','MO','Benton','Scott',37.08253,-89.527888),('63737','MO','Brazeau','Perry',37.7127,-89.8906),('63738','MO','Brownwood','Stoddard',37.082476,-89.955894),('63739','MO','Burfordville','Cape Girardeau',37.359103,-89.800548),('63740','MO','Chaffee','Scott',37.185171,-89.674264),('63742','MO','Commerce','Scott',37.157204,-89.446538),('63743','MO','Daisy','Cape Girardeau',37.512935,-89.839044),('63744','MO','Delta','Cape Girardeau',37.196328,-89.737241),('63745','MO','Dutchtown','Cape Girardeau',37.246919,-89.675494),('63746','MO','Farrar','Perry',37.701185,-89.692677),('63747','MO','Friedheim','Cape Girardeau',37.556794,-89.800952),('63748','MO','Frohna','Perry',37.672226,-89.617272),('63750','MO','Gipsy','Bollinger',37.155078,-90.190076),('63751','MO','Glenallen','Bollinger',37.28691,-90.112986),('63752','MO','Gordonville','Cape Girardeau',37.3111,-89.6791),('63755','MO','Jackson','Cape Girardeau',37.411754,-89.652513),('63758','MO','Kelso','Scott',37.18867,-89.552532),('63760','MO','Leopold','Bollinger',37.248066,-89.888786),('63763','MO','Mc Gee','Wayne',37.066931,-90.147907),('63764','MO','Marble Hill','Bollinger',37.314949,-89.987733),('63766','MO','Millersville','Cape Girardeau',37.441955,-89.850171),('63767','MO','Morley','Scott',37.043037,-89.61156),('63769','MO','Oak Ridge','Cape Girardeau',37.522395,-89.736567),('63770','MO','Old Appleton','Cape Girardeau',37.596341,-89.711023),('63771','MO','Oran','Scott',37.074902,-89.679934),('63774','MO','Perkins','Scott',37.103084,-89.770898),('63775','MO','Perryville','Perry',37.719722,-89.877458),('63776','MO','Mc Bride','Perry',37.7127,-89.8906),('63779','MO','Pocahontas','Cape Girardeau',37.5011,-89.6388),('63780','MO','Scott City','Scott',37.210092,-89.528188),('63781','MO','Sedgewickville','Bollinger',37.528306,-89.927272),('63782','MO','Sturdivant','Bollinger',37.072359,-90.009702),('63783','MO','Uniontown','Perry',37.606331,-89.677769),('63784','MO','Vanduser','Scott',36.990151,-89.686532),('63785','MO','Whitewater','Cape Girardeau',37.266398,-89.822752),('63787','MO','Zalma','Bollinger',37.134524,-90.091896),('63801','MO','Sikeston','Scott',36.891268,-89.580764),('63820','MO','Anniston','Mississippi',36.825367,-89.327368),('63821','MO','Arbyrd','Dunklin',36.052341,-90.236122),('63822','MO','Bernie','Stoddard',36.664295,-90.008051),('63823','MO','Bertrand','Mississippi',36.902664,-89.451956),('63824','MO','Blodgett','Scott',37.005332,-89.527016),('63825','MO','Bloomfield','Stoddard',36.922558,-89.940503),('63826','MO','Braggadocio','Pemiscot',36.176973,-89.831265),('63827','MO','Bragg City','Pemiscot',36.255483,-89.883327),('63828','MO','Canalou','New Madrid',36.753544,-89.687077),('63829','MO','Cardwell','Dunklin',36.042766,-90.306619),('63830','MO','Caruthersville','Pemiscot',36.169167,-89.673875),('63833','MO','Catron','New Madrid',36.625305,-89.73038),('63834','MO','Charleston','Mississippi',36.921656,-89.303781),('63837','MO','Clarkton','Dunklin',36.455841,-89.975601),('63839','MO','Cooter','Pemiscot',36.046404,-89.811218),('63840','MO','Deering','Pemiscot',36.1908,-89.8827),('63841','MO','Dexter','Stoddard',36.788858,-89.974722),('63845','MO','East Prairie','Mississippi',36.747595,-89.355235),('63846','MO','Essex','Stoddard',36.830957,-89.816809),('63847','MO','Gibson','Dunklin',36.440603,-90.038967),('63848','MO','Gideon','New Madrid',36.444407,-89.906012),('63849','MO','Gobler','Dunklin',36.128878,-89.981564),('63850','MO','Grayridge','Stoddard',36.822129,-89.781706),('63851','MO','Hayti','Pemiscot',36.239449,-89.752048),('63852','MO','Holcomb','Dunklin',36.385417,-90.018698),('63853','MO','Holland','Pemiscot',36.057324,-89.870227),('63855','MO','Hornersville','Dunklin',36.052317,-90.078564),('63857','MO','Kennett','Dunklin',36.237025,-90.046597),('63860','MO','Kewanee','New Madrid',36.660544,-89.578816),('63862','MO','Lilbourn','New Madrid',36.579458,-89.638555),('63863','MO','Malden','Dunklin',36.57039,-89.976745),('63866','MO','Marston','New Madrid',36.523041,-89.604823),('63867','MO','Matthews','New Madrid',36.748267,-89.551553),('63868','MO','Morehouse','New Madrid',36.845623,-89.690977),('63869','MO','New Madrid','New Madrid',36.596791,-89.533102),('63870','MO','Parma','New Madrid',36.611839,-89.842651),('63873','MO','Portageville','New Madrid',36.435209,-89.67774),('63874','MO','Risco','New Madrid',36.550512,-89.818647),('63875','MO','Rives','Dunklin',36.0936,-90.0133),('63876','MO','Senath','Dunklin',36.129651,-90.171117),('63877','MO','Steele','Pemiscot',36.079496,-89.849151),('63878','MO','Tallapoosa','New Madrid',36.507751,-89.819967),('63879','MO','Wardell','Pemiscot',36.352929,-89.812573),('63880','MO','Whiteoak','Dunklin',36.330242,-90.026562),('63881','MO','Wolf Island','Mississippi',36.7391,-89.2102),('63882','MO','Wyatt','Mississippi',36.913048,-89.223674),('63901','MO','Poplar Bluff','Butler',36.764478,-90.431317),('63902','MO','Poplar Bluff','Butler',36.7555,-90.3945),('63931','MO','Briar','Ripley',36.6403,-90.9493),('63932','MO','Broseley','Butler',36.690085,-90.246371),('63933','MO','Campbell','Dunklin',36.515992,-90.101734),('63934','MO','Clubb','Wayne',37.198512,-90.368659),('63935','MO','Doniphan','Ripley',36.633686,-90.868905),('63936','MO','Dudley','Stoddard',36.798852,-90.129433),('63937','MO','Ellsinore','Carter',36.936396,-90.757862),('63938','MO','Fagus','Butler',36.512944,-90.26609),('63939','MO','Fairdealing','Ripley',36.665097,-90.676501),('63940','MO','Fisk','Butler',36.777063,-90.223444),('63941','MO','Fremont','Carter',36.927643,-91.172216),('63942','MO','Gatewood','Ripley',36.557014,-91.062435),('63943','MO','Grandin','Carter',36.837636,-90.818314),('63944','MO','Greenville','Wayne',37.088338,-90.378566),('63945','MO','Harviell','Butler',36.644973,-90.543605),('63950','MO','Lodi','Wayne',37.2487,-90.4782),('63951','MO','Lowndes','Wayne',37.145354,-90.257109),('63952','MO','Mill Spring','Wayne',37.013476,-90.654065),('63953','MO','Naylor','Ripley',36.584826,-90.620053),('63954','MO','Neelyville','Butler',36.568591,-90.470945),('63955','MO','Oxly','Ripley',36.605653,-90.684402),('63956','MO','Patterson','Wayne',37.202362,-90.517905),('63957','MO','Piedmont','Wayne',37.143761,-90.702498),('63960','MO','Puxico','Stoddard',36.95694,-90.131465),('63961','MO','Qulin','Butler',36.581946,-90.261386),('63962','MO','Rombauer','Butler',36.843,-90.28),('63963','MO','Shook','Wayne',37.072189,-90.30884),('63964','MO','Silva','Wayne',37.263614,-90.434649),('63965','MO','Van Buren','Carter',36.998183,-90.985287),('63966','MO','Wappapello','Wayne',36.943781,-90.275484),('63967','MO','Williamsville','Wayne',36.925818,-90.45862),('64001','MO','Alma','Lafayette',39.101216,-93.536522),('64002','MO','Lees Summit','Jackson',38.918017,-94.378738),('64011','MO','Bates City','Lafayette',38.973162,-94.074002),('64012','MO','Belton','Cass',38.811787,-94.533126),('64013','MO','Blue Springs','Jackson',39.0169,-94.2813),('64014','MO','Blue Springs','Jackson',39.015387,-94.259115),('64015','MO','Blue Springs','Jackson',39.015015,-94.29951),('64016','MO','Buckner','Jackson',39.128791,-94.207098),('64017','MO','Camden','Ray',39.19743,-94.024994),('64018','MO','Camden Point','Platte',39.445616,-94.737706),('64019','MO','Centerview','Johnson',38.764294,-93.865437),('64020','MO','Concordia','Lafayette',38.983243,-93.57828),('64021','MO','Corder','Lafayette',39.101626,-93.632809),('64022','MO','Dover','Lafayette',39.195247,-93.686704),('64024','MO','Excelsior Springs','Clay',39.338987,-94.230146),('64028','MO','Farley','Platte',39.281,-94.8313),('64029','MO','Grain Valley','Jackson',39.014288,-94.215029),('64030','MO','Grandview','Jackson',38.881359,-94.522744),('64034','MO','Greenwood','Jackson',38.849042,-94.323421),('64035','MO','Hardin','Ray',39.294999,-93.822857),('64036','MO','Henrietta','Ray',39.213218,-93.929412),('64037','MO','Higginsville','Lafayette',39.050928,-93.72086),('64040','MO','Holden','Johnson',38.72376,-93.98766),('64048','MO','Holt','Clay',39.443985,-94.348514),('64050','MO','Independence','Jackson',39.100651,-94.413412),('64051','MO','Independence','Jackson',39.0921,-94.4187),('64052','MO','Independence','Jackson',39.07466,-94.450123),('64053','MO','Independence','Jackson',39.107206,-94.46222),('64054','MO','Independence','Jackson',39.10863,-94.440882),('64055','MO','Independence','Jackson',39.050599,-94.403057),('64056','MO','Independence','Jackson',39.112977,-94.338896),('64057','MO','Independence','Jackson',39.064456,-94.350887),('64058','MO','Independence','Jackson',39.161333,-94.347023),('64060','MO','Kearney','Clay',39.36011,-94.363273),('64061','MO','Kingsville','Johnson',38.786883,-94.084498),('64062','MO','Lawson','Ray',39.449331,-94.192837),('64063','MO','Lees Summit','Jackson',38.912943,-94.362557),('64064','MO','Lees Summit','Jackson',38.983592,-94.35678),('64065','MO','Lees Summit','Jackson',38.947228,-94.40653),('64066','MO','Levasy','Jackson',39.135867,-94.126259),('64067','MO','Lexington','Lafayette',39.170832,-93.866264),('64068','MO','Liberty','Clay',39.24322,-94.419328),('64069','MO','Liberty','Clay',39.2601,-94.4169),('64070','MO','Lone Jack','Jackson',38.886623,-94.14889),('64071','MO','Mayview','Lafayette',39.044934,-93.841705),('64072','MO','Missouri City','Clay',39.237695,-94.295886),('64073','MO','Mosby','Clay',39.3155,-94.2936),('64074','MO','Napoleon','Lafayette',39.089949,-94.086263),('64075','MO','Oak Grove','Jackson',38.996482,-94.141949),('64076','MO','Odessa','Lafayette',38.986788,-93.95579),('64077','MO','Orrick','Ray',39.223983,-94.123143),('64078','MO','Peculiar','Cass',38.709657,-94.458067),('64079','MO','Platte City','Platte',39.356494,-94.787314),('64080','MO','Pleasant Hill','Cass',38.777086,-94.257567),('64081','MO','Lees Summit','Jackson',38.910878,-94.40544),('64082','MO','Lees Summit','Jackson',38.857839,-94.40187),('64083','MO','Raymore','Cass',38.80357,-94.452269),('64084','MO','Rayville','Ray',39.372531,-94.065516),('64085','MO','Richmond','Ray',39.299124,-93.95766),('64086','MO','Lees Summit','Jackson',38.921063,-94.311331),('64088','MO','Sibley','Jackson',39.151558,-94.181903),('64089','MO','Smithville','Clay',39.391034,-94.567178),('64090','MO','Strasburg','Cass',38.760997,-94.164415),('64092','MO','Waldron','Platte',39.211451,-94.783867),('64093','MO','Warrensburg','Johnson',38.773093,-93.73366),('64096','MO','Waverly','Lafayette',39.208822,-93.552504),('64097','MO','Wellington','Lafayette',39.121959,-93.989539),('64098','MO','Weston','Platte',39.438759,-94.913162),('64101','MO','Kansas City','Jackson',39.103625,-94.598954),('64102','MO','Kansas City','Jackson',39.093854,-94.60411),('64105','MO','Kansas City','Jackson',39.104278,-94.589318),('64106','MO','Kansas City','Jackson',39.103262,-94.572283),('64108','MO','Kansas City','Jackson',39.08546,-94.582858),('64109','MO','Kansas City','Jackson',39.065794,-94.566343),('64110','MO','Kansas City','Jackson',39.033584,-94.572835),('64111','MO','Kansas City','Jackson',39.056338,-94.594356),('64112','MO','Kansas City','Jackson',39.037454,-94.595163),('64113','MO','Kansas City','Jackson',39.013767,-94.594814),('64114','MO','Kansas City','Jackson',38.964524,-94.596234),('64116','MO','Kansas City','Clay',39.152384,-94.574089),('64117','MO','Kansas City','Clay',39.165168,-94.52938),('64118','MO','Kansas City','Clay',39.212683,-94.572539),('64119','MO','Kansas City','Clay',39.204773,-94.519523),('64120','MO','Kansas City','Jackson',39.125559,-94.528103),('64121','MO','Kansas City','Jackson',39.0906,-94.538),('64123','MO','Kansas City','Jackson',39.113542,-94.523886),('64124','MO','Kansas City','Jackson',39.107287,-94.539706),('64125','MO','Kansas City','Jackson',39.105365,-94.495048),('64126','MO','Kansas City','Jackson',39.091683,-94.498275),('64127','MO','Kansas City','Jackson',39.089679,-94.53975),('64128','MO','Kansas City','Jackson',39.066614,-94.536359),('64129','MO','Kansas City','Jackson',39.051354,-94.496138),('64130','MO','Kansas City','Jackson',39.035334,-94.545086),('64131','MO','Kansas City','Jackson',38.971648,-94.577073),('64132','MO','Kansas City','Jackson',38.991363,-94.549639),('64133','MO','Kansas City','Jackson',39.016305,-94.461283),('64134','MO','Kansas City','Jackson',38.929431,-94.497957),('64136','MO','Kansas City','Jackson',39.016601,-94.395763),('64137','MO','Kansas City','Jackson',38.931962,-94.539626),('64138','MO','Kansas City','Jackson',38.967424,-94.473791),('64139','MO','Kansas City','Jackson',38.959001,-94.416363),('64141','MO','Kansas City','Jackson',39.0832,-94.587),('64144','MO','Kansas City','Clay',39.1433,-94.571),('64145','MO','Kansas City','Jackson',38.887844,-94.59403),('64146','MO','Kansas City','Jackson',38.90025,-94.573038),('64147','MO','Kansas City','Jackson',38.848937,-94.545863),('64148','MO','Kansas City','Jackson',39.0997,-94.5783),('64149','MO','Kansas City','Jackson',38.879348,-94.473157),('64150','MO','Riverside','Platte',39.175153,-94.622558),('64151','MO','Kansas City','Platte',39.213268,-94.631144),('64152','MO','Kansas City','Platte',39.220609,-94.696239),('64153','MO','Kansas City','Platte',39.275329,-94.70749),('64154','MO','Kansas City','Platte',39.265336,-94.635491),('64155','MO','Kansas City','Clay',39.278712,-94.578695),('64156','MO','Kansas City','Clay',39.27255,-94.524479),('64157','MO','Kansas City','Clay',39.273246,-94.476047),('64158','MO','Kansas City','Clay',39.234315,-94.485477),('64161','MO','Kansas City','Clay',39.16278,-94.462447),('64163','MO','Kansas City','Platte',39.320232,-94.676927),('64164','MO','Kansas City','Platte',39.329495,-94.627147),('64165','MO','Kansas City','Clay',39.320719,-94.576867),('64166','MO','Kansas City','Clay',39.325308,-94.510521),('64167','MO','Kansas City','Clay',39.318963,-94.483055),('64168','MO','Kansas City','Platte',39.171,-94.6117),('64170','MO','Kansas City','Jackson',38.9573,-94.574),('64171','MO','Kansas City','Jackson',39.0544,-94.5886),('64172','MO','Kansas City','Jackson',39.0997,-94.5783),('64179','MO','Kansas City','Jackson',39.0832,-94.587),('64180','MO','Kansas City','Jackson',39.0832,-94.587),('64183','MO','Kansas City','Jackson',39.0997,-94.5783),('64184','MO','Kansas City','Jackson',39.0832,-94.587),('64185','MO','Kansas City','Jackson',39.0832,-94.587),('64187','MO','Kansas City','Jackson',39.0997,-94.5783),('64188','MO','Kansas City','Jackson',39.2239,-94.5852),('64190','MO','Kansas City','Platte',39.2815,-94.7326),('64191','MO','Kansas City','Jackson',39.0844,-94.5844),('64192','MO','Kansas City','Jackson',38.953942,-94.5237),('64193','MO','Kansas City','Jackson',39.0832,-94.587),('64194','MO','Kansas City','Jackson',39.0832,-94.587),('64195','MO','Kansas City','Platte',39.3035,-94.7198),('64196','MO','Kansas City','Jackson',39.1006,-94.5831),('64197','MO','Kansas City','Jackson',38.9573,-94.574),('64198','MO','Kansas City','Jackson',39.0832,-94.587),('64199','MO','Kansas City','Jackson',39.1032,-94.5826),('64401','MO','Agency','Buchanan',39.634922,-94.733848),('64402','MO','Albany','Gentry',40.248937,-94.33222),('64420','MO','Allendale','Worth',40.484809,-94.289979),('64421','MO','Amazonia','Andrew',39.907662,-94.916861),('64422','MO','Amity','Dekalb',39.88551,-94.487123),('64423','MO','Barnard','Nodaway',40.192873,-94.851659),('64424','MO','Bethany','Harrison',40.264579,-94.030611),('64426','MO','Blythedale','Harrison',40.506954,-93.879354),('64427','MO','Bolckow','Andrew',40.108578,-94.846324),('64428','MO','Burlington Junction','Nodaway',40.445329,-95.070328),('64429','MO','Cameron','Clinton',39.744499,-94.232324),('64430','MO','Clarksdale','Dekalb',39.826717,-94.567131),('64431','MO','Clearmont','Nodaway',40.528193,-94.996257),('64432','MO','Clyde','Nodaway',40.265518,-94.669043),('64433','MO','Conception','Nodaway',40.244158,-94.684552),('64434','MO','Conception Junction','Nodaway',40.259166,-94.723475),('64436','MO','Cosby','Andrew',39.856464,-94.697889),('64437','MO','Craig','Holt',40.135659,-95.355486),('64438','MO','Darlington','Gentry',40.171906,-94.41037),('64439','MO','Dearborn','Platte',39.528785,-94.76442),('64440','MO','De Kalb','Buchanan',39.584756,-94.909381),('64441','MO','Denver','Worth',40.392917,-94.2713),('64442','MO','Eagleville','Harrison',40.487767,-93.993916),('64443','MO','Easton','Buchanan',39.742886,-94.653163),('64444','MO','Edgerton','Platte',39.495113,-94.63054),('64445','MO','Elmo','Nodaway',40.539058,-95.129699),('64446','MO','Fairfax','Atchison',40.321713,-95.438301),('64447','MO','Fairport','Dekalb',39.9877,-94.3458),('64448','MO','Faucett','Buchanan',39.600271,-94.806321),('64449','MO','Fillmore','Andrew',40.0412,-94.978475),('64451','MO','Forest City','Holt',40.001495,-95.193705),('64453','MO','Gentry','Gentry',40.336453,-94.448702),('64454','MO','Gower','Clinton',39.60785,-94.593794),('64455','MO','Graham','Nodaway',40.187893,-95.021627),('64456','MO','Grant City','Worth',40.484701,-94.401626),('64457','MO','Guilford','Nodaway',40.162713,-94.682355),('64458','MO','Hatfield','Harrison',40.514955,-94.145198),('64459','MO','Helena','Andrew',39.928943,-94.649389),('64461','MO','Hopkins','Nodaway',40.535722,-94.811608),('64463','MO','King City','Gentry',40.057894,-94.500871),('64465','MO','Lathrop','Clinton',39.53554,-94.306266),('64466','MO','Maitland','Holt',40.164626,-95.09645),('64467','MO','Martinsville','Harrison',40.385211,-94.163518),('64468','MO','Maryville','Nodaway',40.34344,-94.872137),('64469','MO','Maysville','Dekalb',39.918689,-94.365018),('64470','MO','Mound City','Holt',40.149165,-95.2333),('64471','MO','New Hampton','Harrison',40.260562,-94.193611),('64473','MO','Oregon','Holt',39.979316,-95.09719),('64474','MO','Osborn','Dekalb',39.761714,-94.367177),('64475','MO','Parnell','Nodaway',40.436532,-94.629096),('64476','MO','Pickering','Nodaway',40.449662,-94.842245),('64477','MO','Plattsburg','Clinton',39.571579,-94.455798),('64479','MO','Ravenwood','Nodaway',40.35259,-94.672548),('64480','MO','Rea','Andrew',40.062732,-94.716562),('64481','MO','Ridgeway','Harrison',40.371706,-93.897449),('64482','MO','Rock Port','Atchison',40.43102,-95.537438),('64483','MO','Rosendale','Andrew',40.042672,-94.82521),('64484','MO','Rushville','Buchanan',39.568785,-95.031473),('64485','MO','Savannah','Andrew',39.945331,-94.828746),('64486','MO','Sheridan','Worth',40.523722,-94.641235),('64487','MO','Skidmore','Nodaway',40.29791,-95.083931),('64489','MO','Stanberry','Gentry',40.21863,-94.550365),('64490','MO','Stewartsville','Dekalb',39.747011,-94.512966),('64491','MO','Tarkio','Atchison',40.446856,-95.375361),('64492','MO','Trimble','Clinton',39.481857,-94.544417),('64493','MO','Turney','Clinton',39.635382,-94.318242),('64494','MO','Union Star','Dekalb',39.989408,-94.609608),('64496','MO','Watson','Atchison',40.497538,-95.630995),('64497','MO','Weatherby','Dekalb',39.924568,-94.216665),('64498','MO','Westboro','Atchison',40.537771,-95.324861),('64499','MO','Worth','Worth',40.401347,-94.444532),('64501','MO','Saint Joseph','Buchanan',39.766249,-94.843798),('64502','MO','Saint Joseph','Buchanan',39.7655,-94.8506),('64503','MO','Saint Joseph','Buchanan',39.743325,-94.832865),('64504','MO','Saint Joseph','Buchanan',39.707747,-94.875126),('64505','MO','Saint Joseph','Buchanan',39.811107,-94.842249),('64506','MO','Saint Joseph','Buchanan',39.787978,-94.806238),('64507','MO','Saint Joseph','Buchanan',39.748036,-94.7931),('64508','MO','Saint Joseph','Buchanan',39.7768,-94.7995),('64601','MO','Chillicothe','Livingston',39.786621,-93.547485),('64620','MO','Altamont','Daviess',39.8902,-94.088252),('64622','MO','Bogard','Carroll',39.492386,-93.542868),('64623','MO','Bosworth','Carroll',39.469931,-93.328809),('64624','MO','Braymer','Caldwell',39.584635,-93.787787),('64625','MO','Breckenridge','Caldwell',39.75336,-93.802728),('64628','MO','Brookfield','Linn',39.793249,-93.056414),('64630','MO','Browning','Linn',40.034026,-93.160322),('64631','MO','Bucklin','Linn',39.803414,-92.886782),('64632','MO','Cainsville','Harrison',40.451049,-93.772969),('64633','MO','Carrollton','Carroll',39.36173,-93.493371),('64635','MO','Chula','Livingston',39.935482,-93.459691),('64636','MO','Coffey','Daviess',40.108183,-93.996429),('64637','MO','Cowgill','Caldwell',39.575717,-93.917412),('64638','MO','Dawn','Livingston',39.619849,-93.623365),('64639','MO','De Witt','Carroll',39.38765,-93.223938),('64640','MO','Gallatin','Daviess',39.91017,-93.957302),('64641','MO','Galt','Grundy',40.171672,-93.387145),('64642','MO','Gilman City','Harrison',40.154856,-93.831236),('64643','MO','Hale','Carroll',39.614731,-93.352567),('64644','MO','Hamilton','Caldwell',39.7381,-93.988579),('64645','MO','Harris','Sullivan',40.303468,-93.324221),('64646','MO','Humphreys','Sullivan',40.112961,-93.315975),('64647','MO','Jameson','Daviess',40.031136,-93.984725),('64648','MO','Jamesport','Daviess',39.979571,-93.80366),('64649','MO','Kidder','Caldwell',39.774787,-94.097941),('64650','MO','Kingston','Caldwell',39.637875,-94.053727),('64651','MO','Laclede','Linn',39.773425,-93.184849),('64652','MO','Laredo','Grundy',40.022997,-93.44025),('64653','MO','Linneus','Linn',39.887214,-93.211207),('64654','MO','Lock Springs','Daviess',39.846392,-93.773906),('64655','MO','Lucerne','Putnam',40.460991,-93.243436),('64656','MO','Ludlow','Livingston',39.658587,-93.701405),('64657','MO','Mc Fall','Gentry',40.125928,-94.218206),('64658','MO','Marceline','Linn',39.67986,-92.926044),('64659','MO','Meadville','Linn',39.786124,-93.295294),('64660','MO','Mendon','Chariton',39.571701,-93.103921),('64661','MO','Mercer','Mercer',40.522152,-93.531571),('64664','MO','Mooresville','Livingston',39.754922,-93.66643),('64667','MO','Newtown','Sullivan',40.377576,-93.329649),('64668','MO','Norborne','Carroll',39.345295,-93.691269),('64670','MO','Pattonsburg','Daviess',40.04961,-94.125029),('64671','MO','Polo','Caldwell',39.542625,-94.04958),('64672','MO','Powersville','Putnam',40.544835,-93.255082),('64673','MO','Princeton','Mercer',40.388559,-93.583299),('64674','MO','Purdin','Linn',39.965275,-93.146434),('64676','MO','Rothville','Chariton',39.645893,-93.062295),('64679','MO','Spickard','Grundy',40.237646,-93.597333),('64680','MO','Stet','Carroll',39.3464,-93.6638),('64681','MO','Sumner','Chariton',39.645516,-93.230453),('64682','MO','Tina','Carroll',39.532438,-93.467532),('64683','MO','Trenton','Grundy',40.077692,-93.612),('64686','MO','Utica','Livingston',39.744194,-93.627145),('64688','MO','Wheeling','Livingston',39.777289,-93.366268),('64689','MO','Winston','Daviess',39.871346,-94.144883),('64701','MO','Harrisonville','Cass',38.638014,-94.342966),('64720','MO','Adrian','Bates',38.404292,-94.343392),('64722','MO','Amoret','Bates',38.267023,-94.568773),('64723','MO','Amsterdam','Bates',38.364395,-94.574584),('64724','MO','Appleton City','St. Clair',38.161027,-94.009746),('64725','MO','Archie','Cass',38.485241,-94.348507),('64726','MO','Blairstown','Henry',38.54387,-93.934074),('64728','MO','Bronaugh','Vernon',37.702386,-94.501602),('64730','MO','Butler','Bates',38.250144,-94.329156),('64733','MO','Chilhowee','Johnson',38.584819,-93.827198),('64734','MO','Cleveland','Cass',38.661873,-94.586094),('64735','MO','Clinton','Henry',38.35854,-93.7478),('64738','MO','Collins','St. Clair',37.901664,-93.651689),('64739','MO','Creighton','Cass',38.509854,-94.091356),('64740','MO','Deepwater','Henry',38.23401,-93.715944),('64741','MO','Deerfield','Vernon',37.831214,-94.538219),('64742','MO','Drexel','Cass',38.48344,-94.574775),('64743','MO','East Lynne','Cass',38.668886,-94.229699),('64744','MO','El Dorado Springs','Cedar',37.856621,-93.984964),('64745','MO','Foster','Bates',38.165573,-94.504551),('64746','MO','Freeman','Cass',38.620229,-94.490153),('64747','MO','Garden City','Cass',38.570917,-94.174934),('64748','MO','Golden City','Barton',37.371441,-94.099149),('64750','MO','Harwood','Vernon',37.937965,-94.129569),('64752','MO','Hume','Bates',38.065018,-94.563468),('64755','MO','Jasper','Jasper',37.339289,-94.310224),('64756','MO','Jerico Springs','Cedar',37.615002,-94.016558),('64759','MO','Lamar','Barton',37.511918,-94.269043),('64761','MO','Leeton','Johnson',38.588337,-93.693704),('64762','MO','Liberal','Barton',37.549169,-94.514805),('64763','MO','Lowry City','St. Clair',38.143058,-93.676761),('64765','MO','Metz','Vernon',37.995885,-94.443796),('64766','MO','Milford','Barton',37.5115,-94.2681),('64767','MO','Milo','Vernon',37.756994,-94.192369),('64769','MO','Mindenmines','Barton',37.478598,-94.585147),('64770','MO','Montrose','Henry',38.281457,-93.989537),('64771','MO','Moundville','Vernon',37.763356,-94.454996),('64772','MO','Nevada','Vernon',37.840125,-94.347699),('64776','MO','Osceola','St. Clair',38.044741,-93.683795),('64778','MO','Richards','Vernon',37.919357,-94.479382),('64779','MO','Rich Hill','Bates',38.087887,-94.369496),('64780','MO','Rockville','Bates',38.058944,-94.05576),('64781','MO','Roscoe','St. Clair',37.983378,-93.811108),('64783','MO','Schell City','Vernon',38.011813,-94.097401),('64784','MO','Sheldon','Vernon',37.663624,-94.251809),('64788','MO','Urich','Henry',38.435838,-94.014007),('64789','MO','Vista','Saint Clair',37.9883,-93.6638),('64790','MO','Walker','Vernon',37.932527,-94.228033),('64801','MO','Joplin','Jasper',37.094101,-94.495667),('64802','MO','Joplin','Jasper',37.0914,-94.5126),('64803','MO','Joplin','Jasper',37.1143,-94.5151),('64804','MO','Joplin','Jasper',37.038365,-94.511826),('64830','MO','Alba','Jasper',37.235398,-94.417224),('64831','MO','Anderson','Mcdonald',36.651767,-94.443951),('64832','MO','Asbury','Jasper',37.313711,-94.583539),('64833','MO','Avilla','Jasper',37.194338,-94.130581),('64834','MO','Carl Junction','Jasper',37.174146,-94.55529),('64835','MO','Carterville','Jasper',37.149504,-94.440192),('64836','MO','Carthage','Jasper',37.168299,-94.306252),('64840','MO','Diamond','Newton',37.003739,-94.325442),('64841','MO','Duenweg','Jasper',37.078058,-94.413081),('64842','MO','Fairview','Newton',36.799752,-94.101641),('64843','MO','Goodman','Mcdonald',36.734489,-94.430079),('64844','MO','Granby','Newton',36.917162,-94.246886),('64847','MO','Lanagan','Mcdonald',36.604947,-94.450266),('64848','MO','La Russell','Lawrence',37.162829,-94.010752),('64849','MO','Neck City','Jasper',37.256453,-94.443894),('64850','MO','Neosho','Newton',36.860001,-94.391515),('64853','MO','Newtonia','Newton',36.8766,-94.1852),('64854','MO','Noel','Mcdonald',36.552395,-94.473886),('64855','MO','Oronogo','Jasper',37.26934,-94.481895),('64856','MO','Pineville','Mcdonald',36.557769,-94.300213),('64857','MO','Purcell','Jasper',37.24199,-94.437666),('64858','MO','Racine','Newton',36.897279,-94.530189),('64859','MO','Reeds','Jasper',37.147229,-94.158835),('64861','MO','Rocky Comfort','Mcdonald',36.713701,-94.14653),('64862','MO','Sarcoxie','Jasper',37.078969,-94.116401),('64863','MO','South West City','Mcdonald',36.532371,-94.599866),('64864','MO','Saginaw','Newton',37.0238,-94.468),('64865','MO','Seneca','Newton',36.852988,-94.584888),('64866','MO','Stark City','Newton',36.87553,-94.151432),('64867','MO','Stella','Mcdonald',36.739635,-94.230149),('64868','MO','Tiff City','Mcdonald',36.668,-94.6164),('64869','MO','Waco','Jasper',37.2469,-94.5991),('64870','MO','Webb City','Jasper',37.153606,-94.469248),('64873','MO','Wentworth','Lawrence',37.022378,-94.060182),('64874','MO','Wheaton','Barry',36.762133,-94.055326),('64944','MO','Kansas City','Jackson',38.9573,-94.574),('64999','MO','Kansas City','Jackson',38.9573,-94.574),('65001','MO','Argyle','Osage',38.286755,-92.015943),('65010','MO','Ashland','Boone',38.785632,-92.252226),('65011','MO','Barnett','Morgan',38.370231,-92.725162),('65013','MO','Belle','Maries',38.279634,-91.736731),('65014','MO','Bland','Gasconade',38.303143,-91.625685),('65016','MO','Bonnots Mill','Osage',38.560628,-91.919455),('65017','MO','Brumley','Miller',38.083655,-92.504767),('65018','MO','California','Moniteau',38.626805,-92.563522),('65020','MO','Camdenton','Camden',38.032655,-92.782641),('65023','MO','Centertown','Cole',38.637097,-92.415665),('65024','MO','Chamois','Osage',38.632076,-91.772275),('65025','MO','Clarksburg','Moniteau',38.650476,-92.687826),('65026','MO','Eldon','Miller',38.316435,-92.583769),('65032','MO','Eugene','Miller',38.343788,-92.39117),('65034','MO','Fortuna','Morgan',38.561525,-92.80196),('65035','MO','Freeburg','Osage',38.354476,-91.931529),('65036','MO','Gasconade','Gasconade',38.675775,-91.589685),('65037','MO','Gravois Mills','Morgan',38.236458,-92.824524),('65038','MO','Laurie','Morgan',38.4626,-92.7577),('65039','MO','Hartsburg','Boone',38.69383,-92.276493),('65040','MO','Henley','Cole',38.351846,-92.320302),('65041','MO','Hermann','Gasconade',38.671019,-91.479636),('65042','MO','High Point','Moniteau',38.4592,-92.5993),('65043','MO','Holts Summit','Callaway',38.635896,-92.109624),('65046','MO','Jamestown','Moniteau',38.769237,-92.483904),('65047','MO','Kaiser','Miller',38.147056,-92.57353),('65048','MO','Koeltztown','Osage',38.335703,-92.045131),('65049','MO','Lake Ozark','Camden',38.200107,-92.664669),('65050','MO','Latham','Moniteau',38.550075,-92.688924),('65051','MO','Linn','Osage',38.467048,-91.813026),('65052','MO','Linn Creek','Camden',38.05902,-92.685803),('65053','MO','Lohman','Cole',38.543175,-92.362753),('65054','MO','Loose Creek','Osage',38.491382,-91.932346),('65055','MO','Mc Girk','Moniteau',38.6111,-92.4807),('65058','MO','Meta','Maries',38.277799,-92.153181),('65059','MO','Mokane','Callaway',38.679325,-91.862307),('65061','MO','Morrison','Gasconade',38.602971,-91.633323),('65062','MO','Mount Sterling','Gasconade',38.492591,-91.642926),('65063','MO','New Bloomfield','Callaway',38.723692,-92.076101),('65064','MO','Olean','Miller',38.407476,-92.48739),('65065','MO','Osage Beach','Camden',38.138111,-92.65943),('65066','MO','Owensville','Gasconade',38.351804,-91.49031),('65067','MO','Portland','Callaway',38.744622,-91.728111),('65068','MO','Prairie Home','Cooper',38.820801,-92.611855),('65069','MO','Rhineland','Montgomery',38.754787,-91.564196),('65072','MO','Rocky Mount','Morgan',38.257126,-92.719549),('65074','MO','Russellville','Cole',38.492426,-92.474233),('65075','MO','Saint Elizabeth','Miller',38.243527,-92.26917),('65076','MO','Saint Thomas','Cole',38.366086,-92.19459),('65077','MO','Steedman','Callaway',38.783194,-91.800423),('65078','MO','Stover','Morgan',38.359494,-92.998097),('65079','MO','Sunrise Beach','Camden',38.156607,-92.758324),('65080','MO','Tebbetts','Callaway',38.636261,-91.978927),('65081','MO','Tipton','Moniteau',38.647141,-92.777283),('65082','MO','Tuscumbia','Miller',38.230946,-92.43211),('65083','MO','Ulman','Miller',38.143775,-92.430402),('65084','MO','Versailles','Morgan',38.432973,-92.84135),('65085','MO','Westphalia','Osage',38.410255,-92.048535),('65101','MO','Jefferson City','Cole',38.542114,-92.149031),('65102','MO','Jefferson City','Cole',38.5004,-92.1514),('65103','MO','Jefferson City','Cole',38.5004,-92.1514),('65104','MO','Jefferson City','Cole',38.5004,-92.1514),('65105','MO','Jefferson City','Cole',38.5004,-92.1514),('65106','MO','Jefferson City','Cole',38.5004,-92.1514),('65107','MO','Jefferson City','Cole',38.5004,-92.1514),('65108','MO','Jefferson City','Cole',38.5004,-92.1514),('65109','MO','Jefferson City','Cole',38.576192,-92.254529),('65110','MO','Jefferson City','Cole',38.5004,-92.1514),('65111','MO','Jefferson City','Cole',38.5004,-92.1514),('65201','MO','Columbia','Boone',38.925929,-92.290591),('65202','MO','Columbia','Boone',38.99795,-92.303977),('65203','MO','Columbia','Boone',38.922468,-92.372293),('65205','MO','Columbia','Boone',38.9528,-92.3313),('65211','MO','Columbia','Boone',38.9368,-92.3221),('65212','MO','Columbia','Boone',38.9528,-92.3313),('65215','MO','Columbia','Boone',38.953173,-92.32085),('65216','MO','Columbia','Boone',38.9566,-92.3268),('65217','MO','Columbia','Boone',38.8976,-92.3349),('65218','MO','Columbia','Boone',38.8935,-92.3963),('65230','MO','Armstrong','Howard',39.287741,-92.693775),('65231','MO','Auxvasse','Callaway',39.012423,-91.894672),('65232','MO','Benton City','Audrain',39.154589,-91.756185),('65233','MO','Boonville','Cooper',38.936587,-92.73712),('65236','MO','Brunswick','Chariton',39.432611,-93.099423),('65237','MO','Bunceton','Cooper',38.785683,-92.79616),('65239','MO','Cairo','Randolph',39.530029,-92.442383),('65240','MO','Centralia','Boone',39.213829,-92.134379),('65243','MO','Clark','Randolph',39.277508,-92.351016),('65244','MO','Clifton Hill','Randolph',39.497789,-92.654922),('65246','MO','Dalton','Chariton',39.370188,-92.993886),('65247','MO','Excello','Macon',39.642799,-92.504237),('65248','MO','Fayette','Howard',39.148791,-92.65861),('65250','MO','Franklin','Howard',39.035282,-92.830608),('65251','MO','Fulton','Callaway',38.848934,-91.955501),('65254','MO','Glasgow','Howard',39.224627,-92.847812),('65255','MO','Hallsville','Boone',39.101852,-92.235965),('65256','MO','Harrisburg','Boone',39.140084,-92.459234),('65257','MO','Higbee','Randolph',39.275478,-92.528725),('65258','MO','Holliday','Monroe',39.518453,-92.130761),('65259','MO','Huntsville','Randolph',39.45526,-92.553344),('65260','MO','Jacksonville','Randolph',39.584322,-92.41923),('65261','MO','Keytesville','Chariton',39.486959,-92.923032),('65262','MO','Kingdom City','Callaway',38.950534,-91.942898),('65263','MO','Madison','Monroe',39.456341,-92.216073),('65264','MO','Martinsburg','Audrain',39.094646,-91.678995),('65265','MO','Mexico','Audrain',39.178608,-91.881348),('65270','MO','Moberly','Randolph',39.421936,-92.431402),('65274','MO','New Franklin','Howard',39.013617,-92.70448),('65275','MO','Paris','Monroe',39.475749,-91.994687),('65276','MO','Pilot Grove','Cooper',38.848577,-92.936375),('65278','MO','Renick','Randolph',39.342384,-92.412287),('65279','MO','Rocheport','Boone',39.001364,-92.530977),('65280','MO','Rush Hill','Audrain',39.222803,-91.737034),('65281','MO','Salisbury','Chariton',39.459068,-92.79625),('65282','MO','Santa Fe','Monroe',39.387929,-91.822967),('65283','MO','Stoutsville','Monroe',39.509272,-91.827525),('65284','MO','Sturgeon','Boone',39.206233,-92.293309),('65285','MO','Thompson','Audrain',39.204026,-91.999682),('65286','MO','Triplett','Chariton',39.506801,-93.217135),('65287','MO','Wooldridge','Cooper',38.891824,-92.523201),('65299','MO','Columbia','Boone',38.909,-92.2463),('65301','MO','Sedalia','Pettis',38.702194,-93.2338),('65302','MO','Sedalia','Pettis',38.7068,-93.2242),('65305','MO','Whiteman Air Force Base','Johnson',38.728145,-93.560893),('65320','MO','Arrow Rock','Saline',39.070053,-92.947263),('65321','MO','Blackburn','Saline',39.094393,-93.47811),('65322','MO','Blackwater','Cooper',38.961085,-92.96122),('65323','MO','Calhoun','Henry',38.453477,-93.624351),('65324','MO','Climax Springs','Camden',38.144519,-92.971144),('65325','MO','Cole Camp','Benton',38.440362,-93.198892),('65326','MO','Edwards','Benton',38.208575,-93.148266),('65327','MO','Emma','Saline',38.974337,-93.494322),('65329','MO','Florence','Morgan',38.61252,-92.957268),('65330','MO','Gilliam','Saline',39.217726,-92.952862),('65332','MO','Green Ridge','Pettis',38.618204,-93.409166),('65333','MO','Houstonia','Pettis',38.90366,-93.30298),('65334','MO','Hughesville','Pettis',38.836922,-93.23931),('65335','MO','Ionia','Benton',38.504092,-93.3295),('65336','MO','Knob Noster','Johnson',38.769665,-93.569751),('65337','MO','La Monte','Pettis',38.774778,-93.427947),('65338','MO','Lincoln','Benton',38.339763,-93.257633),('65339','MO','Malta Bend','Saline',39.196072,-93.378883),('65340','MO','Marshall','Saline',39.100068,-93.191582),('65344','MO','Miami','Saline',39.30945,-93.225887),('65345','MO','Mora','Pettis',38.546118,-93.109932),('65347','MO','Nelson','Saline',38.993536,-93.041363),('65348','MO','Otterville','Cooper',38.712417,-92.98994),('65349','MO','Slater','Saline',39.226857,-93.051234),('65350','MO','Smithton','Pettis',38.65422,-93.092397),('65351','MO','Sweet Springs','Saline',38.976337,-93.393017),('65354','MO','Syracuse','Morgan',38.66318,-92.885212),('65355','MO','Warsaw','Benton',38.241655,-93.374001),('65360','MO','Windsor','Henry',38.528491,-93.514454),('65401','MO','Rolla','Phelps',37.937416,-91.769386),('65402','MO','Rolla','Phelps',37.9498,-91.7755),('65409','MO','Rolla','Phelps',37.9546,-91.7737),('65436','MO','Beulah','Phelps',37.6125,-91.968934),('65438','MO','Birch Tree','Shannon',36.94609,-91.497556),('65439','MO','Bixby','Iron',37.652415,-91.118788),('65440','MO','Boss','Dent',37.606128,-91.168875),('65441','MO','Bourbon','Crawford',38.120347,-91.198431),('65443','MO','Brinktown','Maries',38.149634,-92.094067),('65444','MO','Bucyrus','Texas',37.385596,-92.071318),('65446','MO','Cherryville','Crawford',37.774412,-91.271049),('65449','MO','Cook','Crawford',37.85203,-91.494665),('65452','MO','Crocker','Pulaski',37.946406,-92.25969),('65453','MO','Cuba','Crawford',38.083398,-91.423187),('65456','MO','Davisville','Crawford',37.78387,-91.188498),('65457','MO','Devils Elbow','Pulaski',37.82874,-92.057715),('65459','MO','Dixon','Pulaski',37.997559,-92.091039),('65461','MO','Duke','Phelps',37.676732,-92.043738),('65462','MO','Edgar Springs','Phelps',37.694638,-91.858339),('65463','MO','Eldridge','Laclede',37.846073,-92.78594),('65464','MO','Elk Creek','Texas',37.175159,-91.912785),('65466','MO','Eminence','Shannon',37.166178,-91.355207),('65468','MO','Eunice','Texas',37.247843,-91.786208),('65470','MO','Falcon','Laclede',37.540677,-92.403958),('65473','MO','Fort Leonard Wood','Pulaski',37.733635,-92.129951),('65479','MO','Hartshorn','Texas',37.346933,-91.634553),('65483','MO','Houston','Texas',37.310008,-91.95545),('65484','MO','Huggins','Texas',37.36908,-92.221454),('65486','MO','Iberia','Miller',38.103191,-92.306674),('65501','MO','Jadwin','Dent',37.439357,-91.583717),('65529','MO','Jerome','Phelps',37.924747,-91.980869),('65532','MO','Lake Spring','Dent',37.782433,-91.671425),('65534','MO','Laquey','Pulaski',37.708179,-92.28),('65535','MO','Leasburg','Crawford',38.087153,-91.295747),('65536','MO','Lebanon','Laclede',37.674986,-92.651873),('65541','MO','Lenox','Dent',37.653705,-91.761231),('65542','MO','Licking','Texas',37.503837,-91.878942),('65543','MO','Lynchburg','Laclede',37.482049,-92.311542),('65546','MO','Montier','Shannon',36.9869,-91.5752),('65548','MO','Mountain View','Howell',37.001968,-91.721441),('65550','MO','Newburg','Phelps',37.867926,-91.94461),('65552','MO','Plato','Texas',37.528872,-92.183742),('65555','MO','Raymondville','Texas',37.354145,-91.782349),('65556','MO','Richland','Pulaski',37.81122,-92.395218),('65557','MO','Roby','Texas',37.512192,-92.117898),('65559','MO','Saint James','Phelps',38.007623,-91.614055),('65560','MO','Salem','Dent',37.637605,-91.522791),('65564','MO','Solo','Texas',37.227369,-91.968826),('65565','MO','Steelville','Crawford',37.919814,-91.267529),('65566','MO','Viburnum','Iron',37.71833,-91.129881),('65567','MO','Stoutland','Camden',37.851731,-92.544515),('65570','MO','Success','Texas',37.452634,-92.094798),('65571','MO','Summersville','Texas',37.167725,-91.654052),('65580','MO','Vichy','Maries',38.105305,-91.801503),('65582','MO','Vienna','Maries',38.190319,-91.942949),('65583','MO','Waynesville','Pulaski',37.817684,-92.240711),('65584','MO','Saint Robert','Pulaski',37.823862,-92.136331),('65586','MO','Wesco','Crawford',37.845486,-91.427656),('65588','MO','Winona','Shannon',36.998499,-91.300553),('65589','MO','Yukon','Texas',37.237768,-91.839752),('65590','MO','Long Lane','Dallas',37.613776,-92.958997),('65591','MO','Montreal','Camden',37.979303,-92.591207),('65601','MO','Aldrich','Polk',37.539862,-93.588004),('65603','MO','Arcola','Dade',37.552755,-93.847642),('65604','MO','Ash Grove','Greene',37.279694,-93.607988),('65605','MO','Aurora','Lawrence',36.918092,-93.710547),('65606','MO','Alton','Oregon',36.687995,-91.361761),('65607','MO','Caplinger Mills','Cedar',37.7941,-93.8041),('65608','MO','Ava','Douglas',36.921053,-92.662168),('65609','MO','Bakersfield','Ozark',36.524388,-92.143924),('65610','MO','Billings','Christian',37.038368,-93.520623),('65611','MO','Blue Eye','Stone',36.546972,-93.359383),('65612','MO','Bois D Arc','Greene',37.215187,-93.547128),('65613','MO','Bolivar','Polk',37.616761,-93.400817),('65614','MO','Bradleyville','Taney',36.752935,-92.91234),('65615','MO','Branson','Taney',36.6436,-93.2183),('65616','MO','Branson','Taney',36.647766,-93.267527),('65617','MO','Brighton','Polk',37.436417,-93.348486),('65618','MO','Brixey','Ozark',36.760693,-92.368069),('65619','MO','Brookline','Greene',37.132557,-93.385788),('65620','MO','Bruner','Christian',37.019207,-92.94873),('65622','MO','Buffalo','Dallas',37.619775,-93.104768),('65623','MO','Butterfield','Barry',36.748302,-93.906946),('65624','MO','Cape Fair','Stone',36.738603,-93.530395),('65625','MO','Cassville','Barry',36.676921,-93.848572),('65626','MO','Caulfield','Ozark',36.610843,-92.14413),('65627','MO','Cedarcreek','Taney',36.546584,-93.02275),('65629','MO','Chadwick','Christian',36.898619,-93.00955),('65630','MO','Chestnutridge','Christian',36.828574,-93.209577),('65631','MO','Clever','Christian',37.017257,-93.427294),('65632','MO','Conway','Laclede',37.491867,-92.840314),('65633','MO','Crane','Stone',36.899539,-93.533577),('65634','MO','Cross Timbers','Hickory',38.015397,-93.194616),('65635','MO','Dadeville','Dade',37.531741,-93.717143),('65636','MO','Diggins','Webster',37.1725,-92.8541),('65637','MO','Dora','Ozark',36.75932,-92.20919),('65638','MO','Drury','Douglas',36.838649,-92.335798),('65640','MO','Dunnegan','Polk',37.68795,-93.562805),('65641','MO','Eagle Rock','Barry',36.538532,-93.7414),('65644','MO','Elkland','Dallas',37.510937,-93.038245),('65645','MO','Eudora','Polk',37.4825,-93.5375),('65646','MO','Everton','Dade',37.348332,-93.710341),('65647','MO','Exeter','Barry',36.690551,-93.982498),('65648','MO','Fair Grove','Greene',37.391269,-93.162438),('65649','MO','Fair Play','Polk',37.618541,-93.611642),('65650','MO','Flemington','Hickory',37.814958,-93.421544),('65652','MO','Fordland','Webster',37.145868,-92.948567),('65653','MO','Forsyth','Taney',36.7155,-93.113098),('65654','MO','Freistatt','Lawrence',37.020684,-93.899131),('65655','MO','Gainesville','Ozark',36.603066,-92.418849),('65656','MO','Galena','Stone',36.77238,-93.468347),('65657','MO','Garrison','Christian',36.826021,-93.013051),('65658','MO','Golden','Barry',36.546676,-93.638135),('65660','MO','Graff','Wright',37.345342,-92.28308),('65661','MO','Greenfield','Dade',37.455679,-93.823841),('65662','MO','Grovespring','Wright',37.453739,-92.588127),('65663','MO','Half Way','Polk',37.630156,-93.246009),('65664','MO','Halltown','Lawrence',37.194193,-93.626024),('65666','MO','Hardenville','Ozark',36.5912,-92.3754),('65667','MO','Hartville','Wright',37.296327,-92.494655),('65668','MO','Hermitage','Hickory',37.905186,-93.296438),('65669','MO','Highlandville','Christian',36.920498,-93.294488),('65672','MO','Hollister','Taney',36.590437,-93.236366),('65673','MO','Hollister','Taney',36.6246,-93.2171),('65674','MO','Humansville','Polk',37.791021,-93.608175),('65675','MO','Hurley','Stone',36.930861,-93.498619),('65676','MO','Isabella','Ozark',36.57641,-92.617496),('65679','MO','Kirbyville','Taney',36.61214,-93.129166),('65680','MO','Kissee Mills','Taney',36.664938,-93.025634),('65681','MO','Lampe','Stone',36.561853,-93.46826),('65682','MO','Lockwood','Dade',37.396617,-93.96561),('65685','MO','Louisburg','Dallas',37.752301,-93.166953),('65686','MO','Kimberling City','Stone',36.630288,-93.433728),('65688','MO','Brandsville','Howell',36.649,-91.6937),('65689','MO','Cabool','Texas',37.128103,-92.091628),('65690','MO','Couch','Oregon',36.584955,-91.253357),('65692','MO','Koshkonong','Oregon',36.613358,-91.643061),('65701','MO','Mc Clurg','Taney',36.79589,-92.772862),('65702','MO','Macomb','Wright',37.091436,-92.496852),('65704','MO','Mansfield','Wright',37.116279,-92.581746),('65705','MO','Marionville','Lawrence',37.00432,-93.625543),('65706','MO','Marshfield','Webster',37.333942,-92.907316),('65707','MO','Miller','Lawrence',37.221954,-93.832696),('65708','MO','Monett','Barry',36.915327,-93.918305),('65710','MO','Morrisville','Polk',37.487046,-93.427027),('65711','MO','Mountain Grove','Wright',37.169785,-92.275857),('65712','MO','Mount Vernon','Lawrence',37.102913,-93.806844),('65713','MO','Niangua','Webster',37.402094,-92.774242),('65714','MO','Nixa','Christian',37.04256,-93.307053),('65715','MO','Noble','Ozark',36.737713,-92.575677),('65717','MO','Norwood','Wright',37.079291,-92.422642),('65720','MO','Oldfield','Christian',36.934721,-92.954167),('65721','MO','Ozark','Christian',37.018555,-93.215037),('65722','MO','Phillipsburg','Laclede',37.582936,-92.773702),('65723','MO','Pierce City','Lawrence',36.950734,-94.032635),('65724','MO','Pittsburg','Hickory',37.853149,-93.317592),('65725','MO','Pleasant Hope','Polk',37.437418,-93.274463),('65726','MO','Point Lookout','Taney',36.6199,-93.2395),('65727','MO','Polk','Polk',37.769123,-93.279499),('65728','MO','Ponce De Leon','Stone',36.875487,-93.346279),('65729','MO','Pontiac','Ozark',36.519999,-92.59839),('65730','MO','Powell','Mcdonald',36.625341,-94.173011),('65731','MO','Powersite','Taney',36.651097,-93.124168),('65732','MO','Preston','Hickory',37.933266,-93.185303),('65733','MO','Protem','Taney',36.519199,-92.842805),('65734','MO','Purdy','Barry',36.795214,-93.941818),('65735','MO','Quincy','Hickory',38.058523,-93.483764),('65737','MO','Reeds Spring','Stone',36.689741,-93.376572),('65738','MO','Republic','Greene',37.122153,-93.468939),('65739','MO','Ridgedale','Taney',36.526126,-93.283511),('65740','MO','Rockaway Beach','Taney',36.711926,-93.163213),('65741','MO','Rockbridge','Ozark',36.7894,-92.4088),('65742','MO','Rogersville','Webster',37.119416,-93.085269),('65744','MO','Rueter','Taney',36.617348,-92.898167),('65745','MO','Seligman','Barry',36.530708,-93.970641),('65746','MO','Seymour','Webster',37.159045,-92.792302),('65747','MO','Shell Knob','Barry',36.592585,-93.582222),('65752','MO','South Greenfield','Dade',37.340263,-93.827443),('65753','MO','Sparta','Christian',37.005045,-93.065263),('65754','MO','Spokane','Christian',36.84589,-93.309708),('65755','MO','Squires','Douglas',36.801591,-92.63269),('65756','MO','Stotts City','Lawrence',37.108068,-93.972291),('65757','MO','Strafford','Greene',37.276827,-93.107999),('65759','MO','Taneyville','Taney',36.738602,-93.031607),('65760','MO','Tecumseh','Ozark',36.616251,-92.276774),('65761','MO','Theodosia','Ozark',36.557662,-92.693777),('65762','MO','Thornfield','Ozark',36.659042,-92.626432),('65764','MO','Tunas','Dallas',37.829212,-92.965798),('65765','MO','Turners','Greene',37.1814,-93.1566),('65766','MO','Udall','Ozark',36.540333,-92.258807),('65767','MO','Urbana','Dallas',37.84134,-93.171795),('65768','MO','Vanzant','Douglas',36.915574,-92.26604),('65769','MO','Verona','Lawrence',36.921969,-93.783255),('65770','MO','Walnut Grove','Greene',37.422627,-93.548227),('65771','MO','Walnut Shade','Taney',36.769385,-93.20949),('65772','MO','Washburn','Barry',36.583876,-94.013354),('65773','MO','Wasola','Ozark',36.764431,-92.516636),('65774','MO','Weaubleau','Hickory',37.917907,-93.511486),('65775','MO','West Plains','Howell',36.718113,-91.873773),('65776','MO','South Fork','Howell',36.6242,-91.919),('65777','MO','Moody','Howell',36.520541,-91.996779),('65778','MO','Myrtle','Oregon',36.529757,-91.269785),('65779','MO','Wheatland','Hickory',37.92154,-93.380676),('65781','MO','Willard','Greene',37.335974,-93.417415),('65783','MO','Windyville','Dallas',37.709598,-92.91973),('65784','MO','Zanoni','Ozark',36.695557,-92.329494),('65785','MO','Stockton','Cedar',37.700511,-93.805285),('65786','MO','Macks Creek','Camden',37.967635,-92.942482),('65787','MO','Roach','Camden',38.065914,-92.87503),('65788','MO','Peace Valley','Howell',36.813525,-91.704771),('65789','MO','Pomona','Howell',36.856343,-91.890152),('65790','MO','Pottersville','Howell',36.701006,-92.127823),('65791','MO','Thayer','Oregon',36.540448,-91.532434),('65793','MO','Willow Springs','Howell',36.99687,-91.959184),('65801','MO','Springfield','Greene',37.2152,-93.295),('65802','MO','Springfield','Greene',37.212731,-93.317417),('65803','MO','Springfield','Greene',37.254302,-93.287458),('65804','MO','Springfield','Greene',37.157982,-93.254706),('65805','MO','Springfield','Greene',37.2152,-93.298),('65806','MO','Springfield','Greene',37.205695,-93.299244),('65807','MO','Springfield','Greene',37.16549,-93.316197),('65808','MO','Springfield','Greene',37.1885,-93.2619),('65809','MO','Springfield','Greene',37.17062,-93.205211),('65810','MO','Springfield','Greene',37.119859,-93.313938),('65814','MO','Springfield','Greene',37.209109,-93.291556),('65817','MO','Springfield','Greene',37.1173,-93.3089),('65890','MO','Springfield','Greene',37.2152,-93.295),('65897','MO','Springfield','Greene',37.1991,-93.2761),('65898','MO','Springfield','Greene',37.2376,-93.2492),('65899','MO','Springfield','Greene',37.1494,-93.2502),('66002','KS','Atchison','Atchison',39.547339,-95.133927),('66006','KS','Baldwin City','Douglas',38.787386,-95.210747),('66007','KS','Basehor','Leavenworth',39.142054,-94.934948),('66008','KS','Bendena','Doniphan',39.726702,-95.181703),('66010','KS','Blue Mound','Linn',38.09533,-95.006255),('66012','KS','Bonner Springs','Wyandotte',39.076846,-94.900931),('66013','KS','Bucyrus','Miami',38.723788,-94.687256),('66014','KS','Centerville','Linn',38.219529,-94.997208),('66015','KS','Colony','Anderson',38.075724,-95.400167),('66016','KS','Cummings','Atchison',39.478743,-95.231961),('66017','KS','Denton','Doniphan',39.718403,-95.274119),('66018','KS','De Soto','Johnson',38.96843,-94.970868),('66019','KS','Clearview City','Johnson',38.946258,-95.002186),('66020','KS','Easton','Leavenworth',39.343537,-95.104922),('66021','KS','Edgerton','Johnson',38.75263,-95.002078),('66023','KS','Effingham','Atchison',39.521383,-95.392675),('66024','KS','Elwood','Doniphan',39.753465,-94.878557),('66025','KS','Eudora','Douglas',38.923126,-95.093425),('66026','KS','Fontana','Miami',38.403561,-94.85828),('66027','KS','Fort Leavenworth','Leavenworth',39.352365,-94.921093),('66030','KS','Gardner','Johnson',38.813756,-94.926626),('66031','KS','New Century','Johnson',38.834012,-94.897715),('66032','KS','Garnett','Anderson',38.284184,-95.26382),('66033','KS','Greeley','Anderson',38.363332,-95.126391),('66035','KS','Highland','Doniphan',39.863674,-95.262767),('66036','KS','Hillsdale','Miami',38.6697,-94.8573),('66039','KS','Kincaid','Anderson',38.095797,-95.176213),('66040','KS','Lacygne','Linn',38.352798,-94.737279),('66041','KS','Lancaster','Atchison',39.587021,-95.310468),('66042','KS','Lane','Franklin',38.437786,-95.079788),('66043','KS','Lansing','Leavenworth',39.253567,-94.890237),('66044','KS','Lawrence','Douglas',38.989989,-95.230948),('66045','KS','Lawrence','Douglas',38.959047,-95.250919),('66046','KS','Lawrence','Douglas',38.934336,-95.222502),('66047','KS','Lawrence','Douglas',38.912306,-95.316258),('66048','KS','Leavenworth','Leavenworth',39.296701,-94.939041),('66049','KS','Lawrence','Douglas',38.978469,-95.30325),('66050','KS','Lecompton','Douglas',39.025738,-95.430057),('66051','KS','Olathe','Johnson',38.8822,-94.8178),('66052','KS','Linwood','Leavenworth',39.007201,-95.045415),('66053','KS','Louisburg','Miami',38.592167,-94.677487),('66054','KS','Mc Louth','Jefferson',39.197713,-95.203759),('66056','KS','Mound City','Linn',38.143113,-94.825687),('66058','KS','Muscotah','Atchison',39.54992,-95.520512),('66060','KS','Nortonville','Jefferson',39.414806,-95.330147),('66061','KS','Olathe','Johnson',38.895413,-94.835764),('66062','KS','Olathe','Johnson',38.858273,-94.775049),('66063','KS','Olathe','Johnson',38.8813,-94.8188),('66064','KS','Osawatomie','Miami',38.490739,-94.964381),('66066','KS','Oskaloosa','Jefferson',39.194293,-95.334046),('66067','KS','Ottawa','Franklin',38.615043,-95.271045),('66070','KS','Ozawkie','Jefferson',39.196339,-95.45132),('66071','KS','Paola','Miami',38.576631,-94.867898),('66072','KS','Parker','Linn',38.317958,-94.980644),('66073','KS','Perry','Jefferson',39.090674,-95.390918),('66075','KS','Pleasanton','Linn',38.192,-94.701386),('66076','KS','Pomona','Franklin',38.61217,-95.44494),('66077','KS','Potter','Atchison',39.423964,-95.128707),('66078','KS','Princeton','Franklin',38.48544,-95.259302),('66079','KS','Rantoul','Franklin',38.551648,-95.106874),('66080','KS','Richmond','Franklin',38.401813,-95.255552),('66083','KS','Spring Hill','Johnson',38.731928,-94.834999),('66085','KS','Stilwell','Johnson',38.812173,-94.651246),('66086','KS','Tonganoxie','Leavenworth',39.111994,-95.078031),('66087','KS','Troy','Doniphan',39.794014,-95.127089),('66088','KS','Valley Falls','Jefferson',39.338675,-95.457103),('66090','KS','Wathena','Doniphan',39.768716,-94.954175),('66091','KS','Welda','Anderson',38.187546,-95.320651),('66092','KS','Wellsville','Franklin',38.7015,-95.097953),('66093','KS','Westphalia','Anderson',38.20781,-95.494138),('66094','KS','White Cloud','Doniphan',39.971136,-95.32838),('66095','KS','Williamsburg','Franklin',38.469895,-95.443552),('66097','KS','Winchester','Jefferson',39.328599,-95.246083),('66101','KS','Kansas City','Wyandotte',39.117046,-94.625416),('66102','KS','Kansas City','Wyandotte',39.112219,-94.672478),('66103','KS','Kansas City','Wyandotte',39.05946,-94.625773),('66104','KS','Kansas City','Wyandotte',39.137738,-94.67389),('66105','KS','Kansas City','Wyandotte',39.086635,-94.634671),('66106','KS','Kansas City','Wyandotte',39.068636,-94.688619),('66109','KS','Kansas City','Wyandotte',39.152376,-94.812606),('66110','KS','Kansas City','Wyandotte',39.1164,-94.6916),('66111','KS','Kansas City','Wyandotte',39.084029,-94.789887),('66112','KS','Kansas City','Wyandotte',39.117331,-94.766484),('66113','KS','Edwardsville','Wyandotte',39.0587,-94.8255),('66115','KS','Kansas City','Wyandotte',39.141419,-94.618784),('66117','KS','Kansas City','Wyandotte',39.1176,-94.6227),('66118','KS','Kansas City','Wyandotte',39.105854,-94.613292),('66119','KS','Kansas City','Wyandotte',39.0616,-94.6092),('66160','KS','Kansas City','Wyandotte',39.0572,-94.6117),('66201','KS','Mission','Johnson',39.0198,-94.6651),('66202','KS','Mission','Johnson',39.023108,-94.666622),('66203','KS','Shawnee','Johnson',39.020331,-94.705787),('66204','KS','Overland Park','Johnson',38.992265,-94.675294),('66205','KS','Mission','Johnson',39.030618,-94.630934),('66206','KS','Leawood','Johnson',38.958711,-94.618649),('66207','KS','Overland Park','Johnson',38.957362,-94.647129),('66208','KS','Prairie Village','Johnson',38.997753,-94.628268),('66209','KS','Leawood','Johnson',38.900835,-94.637353),('66210','KS','Overland Park','Johnson',38.925779,-94.705558),('66211','KS','Leawood','Johnson',38.926152,-94.639939),('66212','KS','Overland Park','Johnson',38.958661,-94.682264),('66213','KS','Overland Park','Johnson',38.900238,-94.707571),('66214','KS','Overland Park','Johnson',38.962468,-94.713439),('66215','KS','Lenexa','Johnson',38.958812,-94.742553),('66216','KS','Shawnee','Johnson',39.009316,-94.739435),('66217','KS','Shawnee','Johnson',39.010374,-94.781334),('66218','KS','Shawnee','Johnson',39.02069,-94.818803),('66219','KS','Lenexa','Johnson',38.961047,-94.772334),('66220','KS','Lenexa','Johnson',38.959736,-94.819103),('66221','KS','Overland Park','Johnson',38.867387,-94.712279),('66222','KS','Mission','Johnson',39.0224,-94.6477),('66223','KS','Overland Park','Johnson',38.860127,-94.669137),('66224','KS','Overland Park','Johnson',38.863539,-94.626804),('66225','KS','Overland Park','Johnson',38.8878,-94.6861),('66226','KS','Shawnee','Johnson',39.03038,-94.853324),('66227','KS','Lenexa','Johnson',38.972307,-94.863869),('66250','KS','Shawnee Mission','Johnson',38.9566,-94.7847),('66251','KS','Overland Park','Johnson',38.9165,-94.6579),('66276','KS','Shawnee Mission','Johnson',39.0198,-94.6651),('66279','KS','Shawnee Mission','Johnson',39.0198,-94.6651),('66282','KS','Overland Park','Johnson',38.952,-94.6859),('66283','KS','Overland Park','Johnson',38.8625,-94.6668),('66285','KS','Lenexa','Johnson',38.9601,-94.7424),('66286','KS','Shawnee','Johnson',38.9601,-94.7424),('66401','KS','Alma','Wabaunsee',38.989381,-96.29132),('66402','KS','Auburn','Shawnee',38.914963,-95.828693),('66403','KS','Axtell','Marshall',39.879847,-96.268913),('66404','KS','Baileyville','Nemaha',39.878146,-96.173343),('66406','KS','Beattie','Marshall',39.877798,-96.416851),('66407','KS','Belvue','Pottawatomie',39.233431,-96.190232),('66408','KS','Bern','Nemaha',39.959434,-95.970009),('66409','KS','Berryton','Shawnee',38.9192,-95.555145),('66411','KS','Blue Rapids','Marshall',39.661686,-96.642111),('66412','KS','Bremen','Marshall',39.90763,-96.777462),('66413','KS','Burlingame','Osage',38.768022,-95.881114),('66414','KS','Carbondale','Osage',38.831289,-95.685298),('66415','KS','Centralia','Nemaha',39.706036,-96.134183),('66416','KS','Circleville','Jackson',39.52723,-95.854255),('66417','KS','Corning','Nemaha',39.657913,-96.033722),('66418','KS','Delia','Jackson',39.281711,-95.933095),('66419','KS','Denison','Jackson',39.378094,-95.604046),('66420','KS','Dover','Shawnee',38.9644,-95.9353),('66422','KS','Emmett','Pottawatomie',39.325991,-96.06733),('66423','KS','Eskridge','Wabaunsee',38.854987,-96.112908),('66424','KS','Everest','Brown',39.674689,-95.404063),('66425','KS','Fairview','Brown',39.8119,-95.72866),('66426','KS','Fostoria','Pottawatomie',39.4397,-96.5075),('66427','KS','Frankfort','Marshall',39.682429,-96.439002),('66428','KS','Goff','Nemaha',39.676116,-95.931359),('66429','KS','Grantville','Jefferson',39.091333,-95.557418),('66431','KS','Harveyville','Wabaunsee',38.800518,-95.994464),('66432','KS','Havensville','Pottawatomie',39.483218,-96.077858),('66434','KS','Hiawatha','Brown',39.863218,-95.545121),('66436','KS','Holton','Jackson',39.468021,-95.709613),('66438','KS','Home','Marshall',39.842813,-96.505859),('66439','KS','Horton','Brown',39.662632,-95.539387),('66440','KS','Hoyt','Jackson',39.258466,-95.683685),('66441','KS','Junction City','Geary',39.018063,-96.83619),('66442','KS','Fort Riley','Riley',39.091848,-96.790137),('66449','KS','Leonardville','Riley',39.3728,-96.863602),('66451','KS','Lyndon','Osage',38.615874,-95.666025),('66501','KS','Mc Farland','Wabaunsee',39.053379,-96.238619),('66502','KS','Manhattan','Riley',39.184079,-96.565811),('66503','KS','Manhattan','Riley',39.218154,-96.644656),('66505','KS','Manhattan','Riley',39.1123,-96.512),('66506','KS','Manhattan','Riley',39.191321,-96.579205),('66507','KS','Maple Hill','Wabaunsee',39.059554,-96.037713),('66508','KS','Marysville','Marshall',39.848376,-96.640128),('66509','KS','Mayetta','Jackson',39.340315,-95.762633),('66510','KS','Melvern','Osage',38.499626,-95.610199),('66512','KS','Meriden','Jefferson',39.1963,-95.546665),('66514','KS','Milford','Geary',39.119289,-96.889769),('66515','KS','Morrill','Brown',39.936243,-95.703731),('66516','KS','Netawaka','Jackson',39.628058,-95.720847),('66517','KS','Ogden','Riley',39.112742,-96.708882),('66518','KS','Oketo','Marshall',39.965642,-96.56713),('66520','KS','Olsburg','Pottawatomie',39.406786,-96.608366),('66521','KS','Onaga','Pottawatomie',39.482539,-96.211896),('66522','KS','Oneida','Nemaha',39.865695,-95.940323),('66523','KS','Osage City','Osage',38.6116,-95.831553),('66524','KS','Overbrook','Osage',38.798105,-95.52008),('66526','KS','Paxico','Wabaunsee',39.066252,-96.162385),('66527','KS','Powhattan','Brown',39.745395,-95.673711),('66528','KS','Quenemo','Osage',38.604717,-95.538526),('66531','KS','Riley','Riley',39.301847,-96.843282),('66532','KS','Robinson','Brown',39.806908,-95.379318),('66533','KS','Rossville','Shawnee',39.143074,-95.951547),('66534','KS','Sabetha','Nemaha',39.893832,-95.818606),('66535','KS','Saint George','Pottawatomie',39.224054,-96.429584),('66536','KS','Saint Marys','Pottawatomie',39.205429,-96.072129),('66537','KS','Scranton','Osage',38.760605,-95.728011),('66538','KS','Seneca','Nemaha',39.842941,-96.051415),('66539','KS','Silver Lake','Shawnee',39.11992,-95.858048),('66540','KS','Soldier','Jackson',39.499628,-95.975072),('66541','KS','Summerfield','Marshall',39.987865,-96.367776),('66542','KS','Tecumseh','Shawnee',39.022326,-95.564465),('66543','KS','Vassar','Osage',38.651031,-95.601717),('66544','KS','Vermillion','Marshall',39.692051,-96.280047),('66546','KS','Wakarusa','Shawnee',38.903992,-95.719793),('66547','KS','Wamego','Pottawatomie',39.220427,-96.31196),('66548','KS','Waterville','Marshall',39.692167,-96.756286),('66549','KS','Westmoreland','Pottawatomie',39.420613,-96.435763),('66550','KS','Wetmore','Nemaha',39.649291,-95.817398),('66552','KS','Whiting','Jackson',39.585291,-95.620263),('66554','KS','Randolph','Riley',39.480949,-96.770887),('66601','KS','Topeka','Shawnee',39.0541,-95.6719),('66603','KS','Topeka','Shawnee',39.056162,-95.675334),('66604','KS','Topeka','Shawnee',39.040992,-95.719417),('66605','KS','Topeka','Shawnee',39.012975,-95.6438),('66606','KS','Topeka','Shawnee',39.060911,-95.714617),('66607','KS','Topeka','Shawnee',39.042775,-95.644991),('66608','KS','Topeka','Shawnee',39.077438,-95.667463),('66609','KS','Topeka','Shawnee',38.986954,-95.678921),('66610','KS','Topeka','Shawnee',38.985012,-95.774026),('66611','KS','Topeka','Shawnee',39.016075,-95.697836),('66612','KS','Topeka','Shawnee',39.040547,-95.680526),('66614','KS','Topeka','Shawnee',39.015731,-95.762779),('66615','KS','Topeka','Shawnee',39.0579,-95.853056),('66616','KS','Topeka','Shawnee',39.064831,-95.636444),('66617','KS','Topeka','Shawnee',39.122257,-95.61943),('66618','KS','Topeka','Shawnee',39.124416,-95.729042),('66619','KS','Topeka','Shawnee',38.948558,-95.692223),('66620','KS','Topeka','Shawnee',38.9459,-95.7131),('66621','KS','Topeka','Shawnee',39.033664,-95.699276),('66622','KS','Topeka','Shawnee',39.025861,-95.723686),('66624','KS','Topeka','Shawnee',38.9353,-95.6898),('66625','KS','Topeka','Shawnee',39.0541,-95.6719),('66626','KS','Topeka','Shawnee',39.0541,-95.6719),('66628','KS','Topeka','Shawnee',39.0541,-95.6719),('66629','KS','Topeka','Shawnee',39.0541,-95.6719),('66636','KS','Topeka','Shawnee',39.0541,-95.6719),('66637','KS','Topeka','Shawnee',39.0154,-95.6957),('66642','KS','Topeka','Shawnee',39.0682,-95.6662),('66647','KS','Topeka','Shawnee',39.0419,-95.7278),('66652','KS','Topeka','Shawnee',39.0541,-95.6719),('66653','KS','Topeka','Shawnee',39.0541,-95.6719),('66667','KS','Topeka','Shawnee',39.0419,-95.7278),('66675','KS','Topeka','Shawnee',39.1439,-95.7457),('66683','KS','Topeka','Shawnee',39.0682,-95.6662),('66692','KS','Topeka','Shawnee',39.0541,-95.6719),('66699','KS','Topeka','Shawnee',39.0541,-95.6719),('66701','KS','Fort Scott','Bourbon',37.82796,-94.727263),('66710','KS','Altoona','Wilson',37.536704,-95.657336),('66711','KS','Arcadia','Crawford',37.644358,-94.65501),('66712','KS','Arma','Crawford',37.547148,-94.704553),('66713','KS','Baxter Springs','Cherokee',37.026261,-94.748426),('66714','KS','Benedict','Wilson',37.631545,-95.723246),('66716','KS','Bronson','Bourbon',37.917189,-95.046309),('66717','KS','Buffalo','Wilson',37.703656,-95.700999),('66720','KS','Chanute','Neosho',37.66607,-95.458689),('66724','KS','Cherokee','Crawford',37.345273,-94.832756),('66725','KS','Columbus','Cherokee',37.174739,-94.877098),('66728','KS','Crestline','Cherokee',37.1684,-94.7054),('66732','KS','Elsmore','Allen',37.798066,-95.169782),('66733','KS','Erie','Neosho',37.581758,-95.248129),('66734','KS','Farlington','Crawford',37.618573,-94.826663),('66735','KS','Franklin','Crawford',37.523535,-94.705729),('66736','KS','Fredonia','Wilson',37.541085,-95.840801),('66738','KS','Fulton','Bourbon',38.012412,-94.709774),('66739','KS','Galena','Cherokee',37.089178,-94.652091),('66740','KS','Galesburg','Neosho',37.465939,-95.370467),('66741','KS','Garland','Bourbon',37.721449,-94.64003),('66742','KS','Gas','Allen',37.9236,-95.3458),('66743','KS','Girard','Crawford',37.502646,-94.865633),('66746','KS','Hepler','Crawford',37.66494,-94.965767),('66748','KS','Humboldt','Allen',37.801181,-95.434564),('66749','KS','Iola','Allen',37.928691,-95.397852),('66751','KS','La Harpe','Allen',37.915303,-95.296257),('66753','KS','Mc Cune','Crawford',37.363785,-95.01616),('66754','KS','Mapleton','Bourbon',38.008019,-94.902113),('66755','KS','Moran','Allen',37.929154,-95.167684),('66756','KS','Mulberry','Crawford',37.547434,-94.641132),('66757','KS','Neodesha','Wilson',37.422899,-95.685517),('66758','KS','Neosho Falls','Woodson',38.005746,-95.569257),('66759','KS','New Albany','Wilson',37.568611,-95.939261),('66760','KS','Opolis','Crawford',37.344095,-94.621594),('66761','KS','Piqua','Woodson',37.911167,-95.561332),('66762','KS','Pittsburg','Crawford',37.409559,-94.704418),('66763','KS','Frontenac','Crawford',37.45693,-94.693232),('66767','KS','Prescott','Linn',38.066879,-94.695061),('66769','KS','Redfield','Bourbon',37.835711,-94.892545),('66770','KS','Riverton','Cherokee',37.075882,-94.712596),('66771','KS','Saint Paul','Neosho',37.498312,-95.155763),('66772','KS','Savonburg','Allen',37.754519,-95.206284),('66773','KS','Scammon','Cherokee',37.273664,-94.827135),('66775','KS','Stark','Neosho',37.698715,-95.144509),('66776','KS','Thayer','Neosho',37.462882,-95.489391),('66777','KS','Toronto','Woodson',37.794218,-95.94953),('66778','KS','Treece','Cherokee',37.000352,-94.843726),('66779','KS','Uniontown','Bourbon',37.843777,-94.975356),('66780','KS','Walnut','Crawford',37.608415,-95.056095),('66781','KS','Weir','Cherokee',37.29908,-94.75081),('66782','KS','West Mineral','Cherokee',37.284553,-94.926067),('66783','KS','Yates Center','Woodson',37.875791,-95.729285),('66801','KS','Emporia','Lyon',38.40957,-96.192186),('66830','KS','Admire','Lyon',38.624943,-96.097349),('66833','KS','Allen','Lyon',38.66729,-96.15059),('66834','KS','Alta Vista','Wabaunsee',38.85492,-96.464594),('66835','KS','Americus','Lyon',38.527417,-96.258603),('66838','KS','Burdick','Morris',38.543408,-96.791789),('66839','KS','Burlington','Coffey',38.208289,-95.740746),('66840','KS','Burns','Butler',38.077488,-96.877457),('66842','KS','Cassoday','Butler',38.028937,-96.6596),('66843','KS','Cedar Point','Chase',38.225133,-96.76466),('66845','KS','Cottonwood Falls','Chase',38.34111,-96.528618),('66846','KS','Council Grove','Morris',38.657377,-96.47753),('66849','KS','Dwight','Morris',38.877492,-96.589623),('66850','KS','Elmdale','Chase',38.395438,-96.69558),('66851','KS','Florence','Marion',38.236966,-96.92821),('66852','KS','Gridley','Coffey',38.090228,-95.886722),('66853','KS','Hamilton','Greenwood',38.006849,-96.205062),('66854','KS','Hartford','Lyon',38.264225,-95.965608),('66855','KS','Lamont','Greenwood',38.1125,-96.0263),('66856','KS','Lebo','Coffey',38.41163,-95.830422),('66857','KS','Le Roy','Coffey',38.093047,-95.634378),('66858','KS','Lincolnville','Marion',38.485667,-96.956204),('66859','KS','Lost Springs','Marion',38.556929,-96.96488),('66860','KS','Madison','Greenwood',38.124904,-96.166141),('66861','KS','Marion','Marion',38.35867,-97.02243),('66862','KS','Matfield Green','Chase',38.155587,-96.546227),('66863','KS','Neal','Greenwood',37.832176,-96.079517),('66864','KS','Neosho Rapids','Lyon',38.363763,-95.98368),('66865','KS','Olpe','Lyon',38.24075,-96.241444),('66866','KS','Peabody','Marion',38.172897,-97.106387),('66868','KS','Reading','Lyon',38.544773,-95.979419),('66869','KS','Strong City','Chase',38.405566,-96.522624),('66870','KS','Virgil','Greenwood',37.958411,-96.028001),('66871','KS','Waverly','Coffey',38.368677,-95.628157),('66872','KS','White City','Morris',38.795198,-96.744665),('66873','KS','Wilsey','Morris',38.63555,-96.67467),('66901','KS','Concordia','Cloud',39.569642,-97.644582),('66930','KS','Agenda','Republic',39.706465,-97.471161),('66932','KS','Athol','Smith',39.768535,-98.919256),('66933','KS','Barnes','Washington',39.689894,-96.872818),('66935','KS','Belleville','Republic',39.82604,-97.630131),('66936','KS','Burr Oak','Jewell',39.907386,-98.31423),('66937','KS','Clifton','Washington',39.58228,-97.272625),('66938','KS','Clyde','Cloud',39.588905,-97.406218),('66939','KS','Courtland','Republic',39.834732,-97.904193),('66940','KS','Cuba','Republic',39.807788,-97.448891),('66941','KS','Esbon','Jewell',39.835576,-98.438848),('66942','KS','Formoso','Jewell',39.797256,-98.003674),('66943','KS','Greenleaf','Washington',39.703233,-96.982009),('66944','KS','Haddam','Washington',39.854539,-97.300195),('66945','KS','Hanover','Washington',39.889256,-96.885047),('66946','KS','Hollenberg','Washington',39.964596,-96.988865),('66948','KS','Jamestown','Cloud',39.606627,-97.846989),('66949','KS','Jewell','Jewell',39.661489,-98.184963),('66951','KS','Kensington','Smith',39.807116,-99.038931),('66952','KS','Lebanon','Smith',39.820841,-98.58865),('66953','KS','Linn','Washington',39.675476,-97.116219),('66955','KS','Mahaska','Washington',39.980007,-97.32062),('66956','KS','Mankato','Jewell',39.78867,-98.218007),('66958','KS','Morrowville','Washington',39.879297,-97.177737),('66959','KS','Munden','Republic',39.9356,-97.53289),('66960','KS','Narka','Republic',39.94011,-97.416193),('66961','KS','Norway','Republic',39.7012,-97.8577),('66962','KS','Palmer','Washington',39.606105,-97.117064),('66963','KS','Randall','Jewell',39.640258,-98.003411),('66964','KS','Republic','Republic',39.937132,-97.829619),('66966','KS','Scandia','Republic',39.772899,-97.773726),('66967','KS','Smith Center','Smith',39.790448,-98.785962),('66968','KS','Washington','Washington',39.819517,-97.059039),('66970','KS','Webber','Jewell',39.934268,-98.036147),('67001','KS','Andale','Sedgwick',37.78313,-97.630986),('67002','KS','Andover','Butler',37.690608,-97.117114),('67003','KS','Anthony','Harper',37.134607,-98.046649),('67004','KS','Argonia','Sumner',37.274022,-97.760337),('67005','KS','Arkansas City','Cowley',37.065309,-97.02321),('67008','KS','Atlanta','Cowley',37.46924,-96.798233),('67009','KS','Attica','Harper',37.232492,-98.247563),('67010','KS','Augusta','Butler',37.683067,-96.981244),('67012','KS','Beaumont','Butler',37.65918,-96.53453),('67013','KS','Belle Plaine','Sumner',37.389525,-97.287823),('67016','KS','Bentley','Sedgwick',37.886421,-97.515964),('67017','KS','Benton','Butler',37.817755,-97.107967),('67018','KS','Bluff City','Harper',37.07233,-97.852032),('67019','KS','Burden','Cowley',37.30657,-96.777587),('67020','KS','Burrton','Harvey',38.017228,-97.675761),('67021','KS','Byers','Pratt',37.784037,-98.894751),('67022','KS','Caldwell','Sumner',37.055296,-97.618888),('67023','KS','Cambridge','Cowley',37.319594,-96.633765),('67024','KS','Cedar Vale','Chautauqua',37.099035,-96.479564),('67025','KS','Cheney','Sedgwick',37.645355,-97.789244),('67026','KS','Clearwater','Sedgwick',37.516028,-97.496806),('67028','KS','Coats','Pratt',37.468202,-98.933505),('67029','KS','Coldwater','Comanche',37.242701,-99.309206),('67030','KS','Colwich','Sedgwick',37.789728,-97.537757),('67031','KS','Conway Springs','Sumner',37.399688,-97.645781),('67035','KS','Cunningham','Kingman',37.65396,-98.39284),('67036','KS','Danville','Harper',37.283597,-97.877924),('67037','KS','Derby','Sedgwick',37.558437,-97.251834),('67038','KS','Dexter','Cowley',37.133699,-96.733008),('67039','KS','Douglass','Butler',37.517081,-97.001985),('67041','KS','Elbing','Butler',38.052302,-97.128498),('67042','KS','El Dorado','Butler',37.834868,-96.84185),('67045','KS','Eureka','Greenwood',37.854518,-96.322318),('67047','KS','Fall River','Greenwood',37.638581,-96.052226),('67049','KS','Freeport','Harper',37.182879,-97.846609),('67050','KS','Garden Plain','Sedgwick',37.663678,-97.68285),('67051','KS','Geuda Springs','Sumner',37.101708,-97.178119),('67052','KS','Goddard','Sedgwick',37.652427,-97.572431),('67053','KS','Goessel','Marion',38.246079,-97.345571),('67054','KS','Greensburg','Kiowa',37.59041,-99.298198),('67055','KS','Greenwich','Sedgwick',37.783374,-97.203149),('67056','KS','Halstead','Harvey',38.009316,-97.52144),('67057','KS','Hardtner','Barber',37.052147,-98.703422),('67058','KS','Harper','Harper',37.298142,-98.039285),('67059','KS','Haviland','Kiowa',37.636927,-99.097253),('67060','KS','Haysville','Sedgwick',37.555001,-97.349991),('67061','KS','Hazelton','Barber',37.083378,-98.375198),('67062','KS','Hesston','Harvey',38.143452,-97.433047),('67063','KS','Hillsboro','Marion',38.349368,-97.210486),('67065','KS','Isabel','Barber',37.467573,-98.541993),('67066','KS','Iuka','Pratt',37.75536,-98.748469),('67067','KS','Kechi','Sedgwick',37.790254,-97.27688),('67068','KS','Kingman','Kingman',37.633774,-98.11212),('67070','KS','Kiowa','Barber',37.029402,-98.490196),('67071','KS','Lake City','Barber',37.290969,-98.835331),('67072','KS','Latham','Butler',37.556302,-96.633227),('67073','KS','Lehigh','Marion',38.376729,-97.316154),('67074','KS','Leon','Butler',37.68134,-96.727025),('67101','KS','Maize','Sedgwick',37.774205,-97.46405),('67102','KS','Maple City','Cowley',37.043519,-96.759243),('67103','KS','Mayfield','Sumner',37.266634,-97.557855),('67104','KS','Medicine Lodge','Barber',37.289167,-98.608661),('67105','KS','Milan','Sumner',37.248565,-97.671949),('67106','KS','Milton','Sumner',37.451794,-97.760682),('67107','KS','Moundridge','Mcpherson',38.1989,-97.524896),('67108','KS','Mount Hope','Sedgwick',37.832384,-97.674672),('67109','KS','Mullinville','Kiowa',37.588269,-99.473647),('67110','KS','Mulvane','Sedgwick',37.473045,-97.234571),('67111','KS','Murdock','Kingman',37.625546,-97.926738),('67112','KS','Nashville','Kingman',37.452755,-98.418897),('67114','KS','Newton','Harvey',38.055386,-97.324923),('67117','KS','North Newton','Harvey',38.07339,-97.348812),('67118','KS','Norwich','Kingman',37.467475,-97.853373),('67119','KS','Oxford','Sumner',37.264671,-97.173558),('67120','KS','Peck','Sumner',37.455466,-97.374317),('67122','KS','Piedmont','Greenwood',37.631181,-96.405589),('67123','KS','Potwin','Butler',37.937096,-97.010924),('67124','KS','Pratt','Pratt',37.643111,-98.755854),('67127','KS','Protection','Comanche',37.197511,-99.487559),('67131','KS','Rock','Cowley',37.434802,-96.949702),('67132','KS','Rosalia','Butler',37.814942,-96.577424),('67133','KS','Rose Hill','Butler',37.57636,-97.115691),('67134','KS','Sawyer','Pratt',37.495699,-98.683141),('67135','KS','Sedgwick','Harvey',37.924217,-97.441219),('67137','KS','Severy','Greenwood',37.642534,-96.223368),('67138','KS','Sharon','Barber',37.252972,-98.421681),('67140','KS','South Haven','Sumner',37.064404,-97.374003),('67142','KS','Spivey','Kingman',37.464203,-98.163549),('67143','KS','Sun City','Barber',37.357425,-98.927375),('67144','KS','Towanda','Butler',37.798388,-97.005824),('67146','KS','Udall','Cowley',37.40084,-97.110141),('67147','KS','Valley Center','Sedgwick',37.848181,-97.334978),('67149','KS','Viola','Sedgwick',37.539818,-97.626022),('67150','KS','Waldron','Harper',37.002797,-98.193749),('67151','KS','Walton','Harvey',38.138456,-97.255097),('67152','KS','Wellington','Sumner',37.267671,-97.408714),('67154','KS','Whitewater','Butler',37.963538,-97.122174),('67155','KS','Wilmore','Comanche',37.316183,-99.155288),('67156','KS','Winfield','Cowley',37.260915,-96.971857),('67159','KS','Zenda','Kingman',37.421219,-98.300708),('67201','KS','Wichita','Sedgwick',37.6898,-97.3415),('67202','KS','Wichita','Sedgwick',37.686984,-97.33492),('67203','KS','Wichita','Sedgwick',37.703924,-97.362377),('67204','KS','Wichita','Sedgwick',37.755959,-97.358088),('67205','KS','Wichita','Sedgwick',37.74052,-97.430917),('67206','KS','Wichita','Sedgwick',37.703342,-97.231677),('67207','KS','Wichita','Sedgwick',37.670098,-97.231267),('67208','KS','Wichita','Sedgwick',37.701999,-97.281146),('67209','KS','Wichita','Sedgwick',37.66998,-97.435984),('67210','KS','Wichita','Sedgwick',37.635168,-97.253701),('67211','KS','Wichita','Sedgwick',37.668993,-97.317857),('67212','KS','Wichita','Sedgwick',37.701254,-97.434357),('67213','KS','Wichita','Sedgwick',37.668965,-97.36066),('67214','KS','Wichita','Sedgwick',37.705361,-97.317734),('67215','KS','Wichita','Sedgwick',37.626807,-97.429849),('67216','KS','Wichita','Sedgwick',37.616184,-97.312481),('67217','KS','Wichita','Sedgwick',37.624182,-97.363115),('67218','KS','Wichita','Sedgwick',37.669443,-97.279625),('67219','KS','Wichita','Sedgwick',37.766738,-97.32057),('67220','KS','Wichita','Sedgwick',37.747813,-97.275216),('67221','KS','Mcconnell Afb','Sedgwick',37.6298,-97.2562),('67223','KS','Wichita','Sedgwick',37.733132,-97.494506),('67226','KS','Wichita','Sedgwick',37.750803,-97.231144),('67227','KS','Wichita','Sedgwick',37.628435,-97.489664),('67228','KS','Wichita','Sedgwick',37.750177,-97.17795),('67230','KS','Wichita','Sedgwick',37.687566,-97.17282),('67232','KS','Wichita','Sedgwick',37.636887,-97.17362),('67235','KS','Wichita','Sedgwick',37.687262,-97.493805),('67260','KS','Wichita','Sedgwick',37.7165,-97.2968),('67275','KS','Wichita','Sedgwick',37.6728,-97.4437),('67276','KS','Wichita','Sedgwick',37.6655,-97.4261),('67277','KS','Wichita','Sedgwick',37.6655,-97.4261),('67278','KS','Wichita','Sedgwick',37.6922,-97.3372),('67301','KS','Independence','Montgomery',37.219698,-95.726089),('67330','KS','Altamont','Labette',37.181527,-95.299834),('67332','KS','Bartlett','Labette',37.051647,-95.222616),('67333','KS','Caney','Montgomery',37.021256,-95.916512),('67334','KS','Chautauqua','Chautauqua',37.025044,-96.178559),('67335','KS','Cherryvale','Montgomery',37.275162,-95.54649),('67336','KS','Chetopa','Labette',37.044358,-95.087815),('67337','KS','Coffeyville','Montgomery',37.043957,-95.622744),('67340','KS','Dearing','Montgomery',37.058073,-95.710186),('67341','KS','Dennis','Labette',37.349057,-95.42153),('67342','KS','Edna','Labette',37.057587,-95.355991),('67344','KS','Elk City','Montgomery',37.291676,-95.927794),('67345','KS','Elk Falls','Elk',37.377332,-96.192116),('67346','KS','Grenola','Elk',37.331339,-96.444474),('67347','KS','Havana','Montgomery',37.104308,-95.942982),('67349','KS','Howard','Elk',37.475396,-96.271594),('67351','KS','Liberty','Montgomery',37.1415,-95.582138),('67352','KS','Longton','Elk',37.367486,-96.080915),('67353','KS','Moline','Elk',37.330137,-96.305689),('67354','KS','Mound Valley','Labette',37.202703,-95.4099),('67355','KS','Niotaze','Chautauqua',37.046836,-96.010838),('67356','KS','Oswego','Labette',37.176048,-95.12867),('67357','KS','Parsons','Labette',37.340947,-95.260003),('67360','KS','Peru','Chautauqua',37.070213,-96.095461),('67361','KS','Sedan','Chautauqua',37.1237,-96.212489),('67363','KS','Sycamore','Montgomery',37.327608,-95.718427),('67364','KS','Tyro','Montgomery',37.035742,-95.822933),('67401','KS','Salina','Saline',38.825267,-97.617167),('67402','KS','Salina','Saline',38.8402,-97.6111),('67410','KS','Abilene','Dickinson',38.936882,-97.221783),('67416','KS','Assaria','Saline',38.673763,-97.59773),('67417','KS','Aurora','Cloud',39.444732,-97.545615),('67418','KS','Barnard','Lincoln',39.185155,-98.043096),('67420','KS','Beloit','Mitchell',39.433647,-98.082318),('67422','KS','Bennington','Ottawa',39.030228,-97.592868),('67423','KS','Beverly','Lincoln',38.966038,-97.993018),('67425','KS','Brookville','Saline',38.813645,-97.928328),('67427','KS','Bushton','Rice',38.508809,-98.393474),('67428','KS','Canton','Mcpherson',38.373064,-97.427233),('67430','KS','Cawker City','Mitchell',39.520906,-98.437744),('67431','KS','Chapman','Dickinson',38.965311,-97.010157),('67432','KS','Clay Center','Clay',39.35759,-97.146677),('67436','KS','Delphos','Ottawa',39.284885,-97.732525),('67437','KS','Downs','Osborne',39.504372,-98.552251),('67438','KS','Durham','Marion',38.493061,-97.266499),('67439','KS','Ellsworth','Ellsworth',38.749469,-98.220562),('67441','KS','Enterprise','Dickinson',38.897959,-97.110705),('67442','KS','Falun','Saline',38.656321,-97.767308),('67443','KS','Galva','Mcpherson',38.376947,-97.528883),('67444','KS','Geneseo','Rice',38.538375,-98.145803),('67445','KS','Glasco','Cloud',39.365274,-97.830393),('67446','KS','Glen Elder','Mitchell',39.499537,-98.307739),('67447','KS','Green','Clay',39.471219,-96.982436),('67448','KS','Gypsum','Saline',38.667147,-97.399749),('67449','KS','Herington','Dickinson',38.67797,-96.926612),('67450','KS','Holyrood','Ellsworth',38.601654,-98.434136),('67451','KS','Hope','Dickinson',38.703171,-97.12158),('67452','KS','Hunter','Mitchell',39.226689,-98.368421),('67454','KS','Kanopolis','Ellsworth',38.703099,-98.137855),('67455','KS','Lincoln','Lincoln',39.028106,-98.152492),('67456','KS','Lindsborg','Mcpherson',38.586208,-97.672958),('67457','KS','Little River','Rice',38.394699,-98.003428),('67458','KS','Longford','Clay',39.171703,-97.287774),('67459','KS','Lorraine','Ellsworth',38.572582,-98.340669),('67460','KS','Mcpherson','Mcpherson',38.369091,-97.6739),('67464','KS','Marquette','Mcpherson',38.586202,-97.890247),('67466','KS','Miltonvale','Cloud',39.342841,-97.471766),('67467','KS','Minneapolis','Ottawa',39.137742,-97.711507),('67468','KS','Morganville','Clay',39.459764,-97.237591),('67470','KS','New Cambria','Saline',38.892563,-97.492316),('67473','KS','Osborne','Osborne',39.412805,-98.723449),('67474','KS','Portis','Osborne',39.567381,-98.718172),('67475','KS','Ramona','Marion',38.599732,-97.047531),('67476','KS','Roxbury','Mcpherson',38.4648,-97.452),('67478','KS','Simpson','Mitchell',39.385039,-97.933699),('67480','KS','Solomon','Dickinson',38.936064,-97.381228),('67481','KS','Sylvan Grove','Lincoln',39.020085,-98.393375),('67482','KS','Talmage','Dickinson',39.026621,-97.259332),('67483','KS','Tampa','Marion',38.553571,-97.167918),('67484','KS','Tescott','Ottawa',38.99209,-97.822638),('67485','KS','Tipton','Mitchell',39.321382,-98.49935),('67487','KS','Wakefield','Clay',39.182056,-97.04526),('67490','KS','Wilson','Ellsworth',38.814743,-98.442161),('67491','KS','Windom','Mcpherson',38.369545,-97.915473),('67492','KS','Woodbine','Dickinson',38.812906,-96.964),('67501','KS','Hutchinson','Reno',38.034954,-97.92531),('67502','KS','Hutchinson','Reno',38.096029,-97.928239),('67504','KS','Hutchinson','Reno',38.0531,-97.9296),('67505','KS','South Hutchinson','Reno',38.028492,-97.939364),('67510','KS','Abbyville','Reno',37.992123,-98.206508),('67511','KS','Albert','Barton',38.442226,-99.023677),('67512','KS','Alden','Rice',38.231486,-98.316555),('67513','KS','Alexander','Rush',38.466532,-99.550375),('67514','KS','Arlington','Reno',37.876493,-98.187559),('67515','KS','Arnold','Ness',38.630996,-100.056441),('67516','KS','Bazine','Ness',38.392976,-99.68689),('67518','KS','Beeler','Ness',38.448157,-100.185686),('67519','KS','Belpre','Edwards',37.942877,-99.098445),('67520','KS','Bison','Rush',38.573868,-99.189399),('67521','KS','Brownell','Ness',38.61815,-99.726521),('67522','KS','Buhler','Reno',38.122196,-97.747612),('67523','KS','Burdett','Pawnee',38.197898,-99.540455),('67524','KS','Chase','Rice',38.369443,-98.359511),('67525','KS','Claflin','Barton',38.557236,-98.564171),('67526','KS','Ellinwood','Barton',38.341976,-98.571324),('67529','KS','Garfield','Pawnee',38.070806,-99.24985),('67530','KS','Great Bend','Barton',38.364835,-98.786905),('67543','KS','Haven','Reno',37.898061,-97.790446),('67544','KS','Hoisington','Barton',38.557947,-98.766121),('67545','KS','Hudson','Stafford',38.151321,-98.628898),('67546','KS','Inman','Mcpherson',38.23752,-97.818053),('67547','KS','Kinsley','Edwards',37.921097,-99.432871),('67548','KS','La Crosse','Rush',38.546339,-99.319238),('67550','KS','Larned','Pawnee',38.181061,-99.114884),('67552','KS','Lewis','Edwards',37.890831,-99.23252),('67553','KS','Liebenthal','Rush',38.655704,-99.31702),('67554','KS','Lyons','Rice',38.359342,-98.201869),('67556','KS','Mc Cracken','Rush',38.603781,-99.540671),('67557','KS','Macksville','Stafford',37.934602,-98.958462),('67559','KS','Nekoma','Rush',38.400217,-99.455489),('67560','KS','Ness City','Ness',38.428898,-99.926155),('67561','KS','Nickerson','Reno',38.136897,-98.089461),('67563','KS','Offerle','Edwards',37.861829,-99.560924),('67564','KS','Olmitz','Barton',38.52039,-98.935741),('67565','KS','Otis','Rush',38.587459,-99.042139),('67566','KS','Partridge','Reno',37.948164,-98.096049),('67567','KS','Pawnee Rock','Barton',38.268173,-98.977537),('67568','KS','Plevna','Reno',38.006314,-98.316595),('67570','KS','Pretty Prairie','Reno',37.784698,-97.982353),('67572','KS','Ransom','Ness',38.660732,-99.908482),('67573','KS','Raymond','Rice',38.278624,-98.414513),('67574','KS','Rozel','Pawnee',38.202572,-99.39059),('67575','KS','Rush Center','Rush',38.43862,-99.256963),('67576','KS','Saint John','Stafford',38.029011,-98.785028),('67578','KS','Stafford','Stafford',37.976631,-98.591318),('67579','KS','Sterling','Rice',38.201019,-98.196763),('67581','KS','Sylvia','Reno',37.977536,-98.408746),('67583','KS','Turon','Reno',37.799431,-98.475),('67584','KS','Utica','Ness',38.65722,-100.164952),('67585','KS','Yoder','Reno',37.9402,-97.868),('67601','KS','Hays','Ellis',38.881002,-99.324632),('67621','KS','Agra','Phillips',39.792587,-99.132342),('67622','KS','Almena','Norton',39.893871,-99.71853),('67623','KS','Alton','Osborne',39.459547,-98.950803),('67625','KS','Bogue','Graham',39.363103,-99.685906),('67626','KS','Bunker Hill','Russell',38.879018,-98.708914),('67627','KS','Catharine','Ellis',39.0441,-99.1793),('67628','KS','Cedar','Smith',39.62641,-98.968736),('67629','KS','Clayton','Norton',39.705136,-100.175709),('67631','KS','Collyer','Trego',39.027126,-100.092645),('67632','KS','Damar','Rooks',39.329025,-99.586629),('67634','KS','Dorrance','Russell',38.820273,-98.604461),('67635','KS','Dresden','Decatur',39.603973,-100.431253),('67637','KS','Ellis','Ellis',38.934539,-99.587083),('67638','KS','Gaylord','Smith',39.640446,-98.848952),('67639','KS','Glade','Phillips',39.653432,-99.306173),('67640','KS','Gorham','Russell',38.907142,-99.030174),('67642','KS','Hill City','Graham',39.357246,-99.844347),('67643','KS','Jennings','Decatur',39.67642,-100.295321),('67644','KS','Kirwin','Phillips',39.64808,-99.140086),('67645','KS','Lenora','Norton',39.610728,-99.908389),('67646','KS','Logan','Phillips',39.626895,-99.578502),('67647','KS','Long Island','Phillips',39.948248,-99.53822),('67648','KS','Lucas','Russell',39.070451,-98.549789),('67649','KS','Luray','Russell',39.127469,-98.690258),('67650','KS','Morland','Graham',39.352691,-100.105984),('67651','KS','Natoma','Osborne',39.207141,-99.03859),('67653','KS','Norcatur','Decatur',39.892709,-100.202627),('67654','KS','Norton','Norton',39.824176,-99.930351),('67656','KS','Ogallah','Trego',38.972938,-99.755155),('67657','KS','Palco','Rooks',39.227312,-99.596185),('67658','KS','Paradise','Russell',39.118745,-98.929874),('67659','KS','Penokee','Graham',39.324097,-99.986311),('67660','KS','Pfeifer','Ellis',38.713081,-99.167492),('67661','KS','Phillipsburg','Phillips',39.799744,-99.328499),('67663','KS','Plainville','Rooks',39.212629,-99.316956),('67664','KS','Prairie View','Phillips',39.828126,-99.571986),('67665','KS','Russell','Russell',38.867352,-98.865703),('67667','KS','Schoenchen','Ellis',38.713253,-99.331767),('67669','KS','Stockton','Rooks',39.43642,-99.323971),('67671','KS','Victoria','Ellis',38.856082,-99.144757),('67672','KS','Wakeeney','Trego',39.015019,-99.891935),('67673','KS','Waldo','Osborne',39.16944,-98.79731),('67674','KS','Walker','Ellis',38.863828,-99.076143),('67675','KS','Woodston','Rooks',39.451132,-99.102143),('67701','KS','Colby','Thomas',39.387604,-101.046441),('67730','KS','Atwood','Rawlins',39.816662,-101.07973),('67731','KS','Bird City','Cheyenne',39.757385,-101.538014),('67732','KS','Brewster','Thomas',39.381313,-101.381526),('67733','KS','Edson','Sherman',39.353407,-101.530839),('67734','KS','Gem','Thomas',39.488724,-100.897413),('67735','KS','Goodland','Sherman',39.332689,-101.737718),('67736','KS','Gove','Gove',38.879828,-100.455539),('67737','KS','Grainfield','Gove',39.126467,-100.484332),('67738','KS','Grinnell','Gove',39.054859,-100.638074),('67739','KS','Herndon','Rawlins',39.90103,-100.796608),('67740','KS','Hoxie','Sheridan',39.368635,-100.395459),('67741','KS','Kanorado','Sherman',39.36528,-102.004745),('67743','KS','Levant','Thomas',39.423575,-101.221858),('67744','KS','Ludell','Rawlins',39.856934,-100.939441),('67745','KS','Mc Donald','Rawlins',39.800057,-101.3635),('67747','KS','Monument','Logan',39.068389,-101.040054),('67748','KS','Oakley','Logan',39.103081,-100.853457),('67749','KS','Oberlin','Decatur',39.832422,-100.539065),('67751','KS','Park','Gove',39.126189,-100.364779),('67752','KS','Quinter','Gove',39.038367,-100.232364),('67753','KS','Rexford','Thomas',39.422872,-100.740984),('67756','KS','Saint Francis','Cheyenne',39.767432,-101.823021),('67757','KS','Selden','Sheridan',39.537248,-100.587513),('67758','KS','Sharon Springs','Wallace',38.887757,-101.749866),('67761','KS','Wallace','Wallace',38.943714,-101.50848),('67762','KS','Weskan','Wallace',38.887208,-101.97287),('67764','KS','Winona','Logan',38.976063,-101.203203),('67801','KS','Dodge City','Ford',37.751323,-100.024333),('67831','KS','Ashland','Clark',37.193647,-99.761672),('67834','KS','Bucklin','Ford',37.544144,-99.64028),('67835','KS','Cimarron','Gray',37.835048,-100.345688),('67836','KS','Coolidge','Hamilton',38.037414,-102.006019),('67837','KS','Copeland','Gray',37.554795,-100.656945),('67838','KS','Deerfield','Kearny',38.035454,-101.12642),('67839','KS','Dighton','Lane',38.504335,-100.448645),('67840','KS','Englewood','Clark',37.047426,-99.995056),('67841','KS','Ensign','Gray',37.635204,-100.242517),('67842','KS','Ford','Ford',37.578647,-99.767074),('67843','KS','Fort Dodge','Ford',37.731676,-99.936527),('67844','KS','Fowler','Meade',37.401836,-100.207347),('67846','KS','Garden City','Finney',37.982475,-100.845563),('67849','KS','Hanston','Hodgeman',38.146637,-99.715184),('67850','KS','Healy','Lane',38.576759,-100.604362),('67851','KS','Holcomb','Finney',38.072552,-101.006486),('67853','KS','Ingalls','Gray',37.852753,-100.513985),('67854','KS','Jetmore','Hodgeman',38.080628,-99.96313),('67855','KS','Johnson','Stanton',37.558998,-101.690392),('67857','KS','Kendall','Hamilton',37.99492,-101.556383),('67859','KS','Kismet','Seward',37.227636,-100.770473),('67860','KS','Lakin','Kearny',37.965361,-101.285666),('67861','KS','Leoti','Wichita',38.49052,-101.395254),('67862','KS','Manter','Stanton',37.556086,-101.934695),('67863','KS','Marienthal','Wichita',38.551181,-101.220728),('67864','KS','Meade','Meade',37.233951,-100.334756),('67865','KS','Minneola','Clark',37.448879,-99.987187),('67867','KS','Montezuma','Gray',37.584001,-100.461121),('67868','KS','Pierceville','Finney',37.849331,-100.710386),('67869','KS','Plains','Meade',37.252236,-100.579938),('67870','KS','Satanta','Haskell',37.490304,-100.999587),('67871','KS','Scott City','Scott',38.504127,-100.916277),('67876','KS','Spearville','Ford',37.847651,-99.725869),('67877','KS','Sublette','Haskell',37.518807,-100.851197),('67878','KS','Syracuse','Hamilton',38.024902,-101.783264),('67879','KS','Tribune','Greeley',38.492059,-101.772004),('67880','KS','Ulysses','Grant',37.576213,-101.328431),('67882','KS','Wright','Ford',37.789478,-99.887594),('67901','KS','Liberal','Seward',37.06561,-100.917258),('67905','KS','Liberal','Seward',37.1249,-100.9626),('67950','KS','Elkhart','Morton',37.022351,-101.882506),('67951','KS','Hugoton','Stevens',37.173882,-101.341823),('67952','KS','Moscow','Stevens',37.296882,-101.151072),('67953','KS','Richfield','Morton',37.250781,-101.872973),('67954','KS','Rolla','Morton',37.196278,-101.635778),('68001','NE','Abie','Butler',41.334602,-96.951035),('68002','NE','Arlington','Washington',41.485904,-96.344759),('68003','NE','Ashland','Saunders',41.067157,-96.373635),('68004','NE','Bancroft','Cuming',42.009573,-96.62326),('68005','NE','Bellevue','Sarpy',41.145169,-95.904815),('68007','NE','Bennington','Douglas',41.353364,-96.16514),('68008','NE','Blair','Washington',41.539907,-96.138632),('68009','NE','Blair','Washington',41.5444,-96.1247),('68010','NE','Boys Town','Douglas',41.258367,-96.130916),('68014','NE','Bruno','Butler',41.283249,-96.958258),('68015','NE','Cedar Bluffs','Saunders',41.393956,-96.635725),('68016','NE','Cedar Creek','Cass',41.041448,-96.105394),('68017','NE','Ceresco','Saunders',41.067885,-96.650621),('68018','NE','Colon','Saunders',41.309484,-96.616948),('68019','NE','Craig','Burt',41.782754,-96.365503),('68020','NE','Decatur','Burt',41.988659,-96.256074),('68022','NE','Elkhorn','Douglas',41.268085,-96.235908),('68023','NE','Fort Calhoun','Washington',41.454995,-96.0254),('68025','NE','Fremont','Dodge',41.434902,-96.490322),('68026','NE','Fremont','Dodge',41.4347,-96.4938),('68028','NE','Gretna','Sarpy',41.119158,-96.253467),('68029','NE','Herman','Washington',41.657008,-96.273639),('68030','NE','Homer','Dakota',42.319403,-96.461387),('68031','NE','Hooper','Dodge',41.627016,-96.530473),('68033','NE','Ithaca','Saunders',41.138424,-96.507451),('68034','NE','Kennard','Washington',41.464945,-96.21078),('68036','NE','Linwood','Butler',41.401572,-96.95621),('68037','NE','Louisville','Cass',41.001176,-96.14237),('68038','NE','Lyons','Burt',41.947307,-96.466942),('68039','NE','Macy','Thurston',42.111634,-96.341756),('68040','NE','Malmo','Saunders',41.288829,-96.739594),('68041','NE','Mead','Saunders',41.230779,-96.491811),('68042','NE','Memphis','Saunders',41.097608,-96.435959),('68044','NE','Nickerson','Dodge',41.541755,-96.457796),('68045','NE','Oakland','Burt',41.828577,-96.481604),('68046','NE','Papillion','Sarpy',41.146278,-96.048829),('68047','NE','Pender','Thurston',42.111188,-96.733089),('68048','NE','Plattsmouth','Cass',40.999597,-95.913014),('68050','NE','Prague','Saunders',41.308808,-96.836689),('68055','NE','Rosalie','Thurston',42.053823,-96.492345),('68056','NE','St Columbans','Sarpy',41.1029,-95.8732),('68057','NE','Scribner','Dodge',41.662391,-96.700641),('68058','NE','South Bend','Cass',41.00422,-96.245213),('68059','NE','Springfield','Sarpy',41.062551,-96.147362),('68061','NE','Tekamah','Burt',41.785882,-96.217369),('68062','NE','Thurston','Thurston',42.183801,-96.676451),('68063','NE','Uehling','Dodge',41.73482,-96.504108),('68064','NE','Valley','Douglas',41.332893,-96.351086),('68065','NE','Valparaiso','Saunders',41.081433,-96.846103),('68066','NE','Wahoo','Saunders',41.197235,-96.622963),('68067','NE','Walthill','Thurston',42.148994,-96.486319),('68068','NE','Washington','Washington',41.397833,-96.208759),('68069','NE','Waterloo','Douglas',41.252559,-96.31012),('68070','NE','Weston','Saunders',41.206474,-96.79105),('68071','NE','Winnebago','Thurston',42.232662,-96.467981),('68072','NE','Winslow','Dodge',41.609105,-96.505051),('68073','NE','Yutan','Saunders',41.247927,-96.400838),('68101','NE','Omaha','Douglas',41.261,-95.9376),('68102','NE','Omaha','Douglas',41.261658,-95.93583),('68103','NE','Omaha','Douglas',41.2495,-95.9305),('68104','NE','Omaha','Douglas',41.292725,-96.001645),('68105','NE','Omaha','Douglas',41.240737,-95.96366),('68106','NE','Omaha','Douglas',41.240807,-95.999584),('68107','NE','Omaha','Douglas',41.205038,-95.955329),('68108','NE','Omaha','Douglas',41.238821,-95.933947),('68109','NE','Omaha','Douglas',41.2345,-95.937),('68110','NE','Omaha','Douglas',41.290475,-95.930576),('68111','NE','Omaha','Douglas',41.294553,-95.964911),('68112','NE','Omaha','Douglas',41.338699,-95.960372),('68113','NE','Offutt A F B','Sarpy',41.115652,-95.916744),('68114','NE','Omaha','Douglas',41.264956,-96.04872),('68116','NE','Omaha','Douglas',41.296784,-96.163942),('68117','NE','Omaha','Douglas',41.207586,-95.995886),('68118','NE','Omaha','Douglas',41.264361,-96.175133),('68119','NE','Omaha','Douglas',41.2586,-95.9375),('68120','NE','Omaha','Douglas',41.2795,-95.9461),('68122','NE','Omaha','Douglas',41.343373,-96.046091),('68123','NE','Bellevue','Sarpy',41.121476,-95.949058),('68124','NE','Omaha','Douglas',41.235456,-96.051812),('68127','NE','Omaha','Douglas',41.203373,-96.049874),('68128','NE','La Vista','Sarpy',41.181794,-96.0621),('68130','NE','Omaha','Douglas',41.235572,-96.192562),('68131','NE','Omaha','Douglas',41.264302,-95.96399),('68132','NE','Omaha','Douglas',41.265701,-95.998683),('68133','NE','Papillion','Sarpy',41.139473,-95.999971),('68134','NE','Omaha','Douglas',41.299215,-96.052977),('68135','NE','Omaha','Douglas',41.204147,-96.189047),('68136','NE','Omaha','Sarpy',41.176593,-96.176971),('68137','NE','Omaha','Douglas',41.206806,-96.121037),('68138','NE','Omaha','Sarpy',41.171816,-96.136356),('68139','NE','Omaha','Douglas',41.2179,-96.1206),('68142','NE','Omaha','Douglas',41.359669,-96.095459),('68144','NE','Omaha','Douglas',41.234675,-96.113893),('68145','NE','Omaha','Douglas',41.2348,-96.1198),('68147','NE','Bellevue','Sarpy',41.179676,-95.953851),('68152','NE','Omaha','Douglas',41.346831,-95.99882),('68154','NE','Omaha','Douglas',41.265139,-96.114445),('68155','NE','Omaha','Douglas',41.2586,-95.9375),('68157','NE','Omaha','Sarpy',41.178501,-95.991522),('68164','NE','Omaha','Douglas',41.298193,-96.112229),('68172','NE','Omaha','Douglas',41.2495,-95.9305),('68175','NE','Omaha','Douglas',41.2495,-95.9305),('68176','NE','Omaha','Douglas',41.2495,-95.9305),('68178','NE','Omaha','Douglas',41.265859,-95.946014),('68179','NE','Omaha','Douglas',41.2495,-95.9305),('68180','NE','Omaha','Douglas',41.2495,-95.9305),('68181','NE','Omaha','Douglas',41.2495,-95.9305),('68182','NE','Omaha','Douglas',41.2594,-96.0049),('68183','NE','Omaha','Douglas',41.2495,-95.9305),('68197','NE','Omaha','Douglas',41.2353,-96.1213),('68198','NE','Omaha','Douglas',41.2547,-95.9784),('68301','NE','Adams','Gage',40.470495,-96.524982),('68303','NE','Alexandria','Thayer',40.247369,-97.41071),('68304','NE','Alvo','Cass',40.873985,-96.388447),('68305','NE','Auburn','Nemaha',40.376577,-95.848914),('68307','NE','Avoca','Cass',40.788873,-96.131003),('68309','NE','Barneston','Gage',40.049705,-96.57336),('68310','NE','Beatrice','Gage',40.262325,-96.740612),('68313','NE','Beaver Crossing','Seward',40.781565,-97.26775),('68314','NE','Bee','Seward',41.017521,-97.046966),('68315','NE','Belvidere','Thayer',40.252627,-97.553608),('68316','NE','Benedict','York',41.013204,-97.613575),('68317','NE','Bennet','Lancaster',40.681264,-96.50727),('68318','NE','Blue Springs','Gage',40.145683,-96.659383),('68319','NE','Bradshaw','York',40.912413,-97.759786),('68320','NE','Brock','Nemaha',40.484931,-95.956931),('68321','NE','Brownville','Nemaha',40.393004,-95.667782),('68322','NE','Bruning','Thayer',40.342773,-97.549711),('68323','NE','Burchard','Pawnee',40.141918,-96.377199),('68324','NE','Burr','Otoe',40.549845,-96.297696),('68325','NE','Byron','Thayer',40.01423,-97.758252),('68326','NE','Carleton','Thayer',40.29229,-97.677324),('68327','NE','Chester','Thayer',40.016004,-97.619426),('68328','NE','Clatonia','Gage',40.473129,-96.837063),('68329','NE','Cook','Johnson',40.507685,-96.164405),('68330','NE','Cordova','Seward',40.716216,-97.352201),('68331','NE','Cortland','Gage',40.481641,-96.704494),('68332','NE','Crab Orchard','Johnson',40.327746,-96.402758),('68333','NE','Crete','Saline',40.622729,-96.964457),('68335','NE','Davenport','Thayer',40.292703,-97.811647),('68336','NE','Davey','Lancaster',40.936693,-96.672071),('68337','NE','Dawson','Richardson',40.098408,-95.831894),('68338','NE','Daykin','Jefferson',40.300585,-97.274732),('68339','NE','Denton','Lancaster',40.739206,-96.848923),('68340','NE','Deshler','Thayer',40.123637,-97.729816),('68341','NE','De Witt','Saline',40.392443,-96.902294),('68342','NE','Diller','Jefferson',40.104017,-96.949449),('68343','NE','Dorchester','Saline',40.632415,-97.132073),('68344','NE','Douglas','Otoe',40.576777,-96.397593),('68345','NE','Du Bois','Pawnee',40.037496,-96.02467),('68346','NE','Dunbar','Otoe',40.666471,-96.027862),('68347','NE','Eagle','Cass',40.813448,-96.429579),('68348','NE','Elk Creek','Johnson',40.292539,-96.138211),('68349','NE','Elmwood','Cass',40.837147,-96.295338),('68350','NE','Endicott','Jefferson',40.06576,-97.080829),('68351','NE','Exeter','Fillmore',40.650778,-97.434866),('68352','NE','Fairbury','Jefferson',40.146314,-97.206903),('68354','NE','Fairmont','Fillmore',40.634728,-97.582208),('68355','NE','Falls City','Richardson',40.07653,-95.586208),('68357','NE','Filley','Gage',40.298789,-96.548914),('68358','NE','Firth','Lancaster',40.531301,-96.608278),('68359','NE','Friend','Saline',40.643926,-97.290301),('68360','NE','Garland','Seward',40.9528,-96.973875),('68361','NE','Geneva','Fillmore',40.521052,-97.603728),('68362','NE','Gilead','Thayer',40.148186,-97.416065),('68364','NE','Goehner','Seward',40.832812,-97.219861),('68365','NE','Grafton','Fillmore',40.619512,-97.721346),('68366','NE','Greenwood','Cass',40.963137,-96.431192),('68367','NE','Gresham','York',41.032447,-97.391968),('68368','NE','Hallam','Lancaster',40.554333,-96.813019),('68370','NE','Hebron','Thayer',40.152871,-97.570807),('68371','NE','Henderson','York',40.763634,-97.783303),('68372','NE','Hickman','Lancaster',40.614875,-96.617654),('68375','NE','Hubbell','Thayer',40.025909,-97.473435),('68376','NE','Humboldt','Richardson',40.172631,-95.945357),('68377','NE','Jansen','Jefferson',40.208113,-97.024572),('68378','NE','Johnson','Nemaha',40.385629,-96.018847),('68379','NE','Julian','Nemaha',40.521425,-95.867222),('68380','NE','Lewiston','Pawnee',40.242601,-96.404675),('68381','NE','Liberty','Gage',40.069139,-96.491899),('68382','NE','Lorton','Otoe',40.596294,-96.024032),('68401','NE','Mc Cool Junction','York',40.743545,-97.588122),('68402','NE','Malcolm','Lancaster',40.906552,-96.861781),('68403','NE','Manley','Cass',40.919543,-96.165596),('68404','NE','Martell','Lancaster',40.613634,-96.752848),('68405','NE','Milford','Seward',40.773305,-97.061808),('68406','NE','Milligan','Fillmore',40.501091,-97.392648),('68407','NE','Murdock','Cass',40.922907,-96.263729),('68409','NE','Murray','Cass',40.916268,-95.936871),('68410','NE','Nebraska City','Otoe',40.665119,-95.867988),('68413','NE','Nehawka','Cass',40.832804,-96.001912),('68414','NE','Nemaha','Nemaha',40.312594,-95.673977),('68415','NE','Odell','Gage',40.055786,-96.811014),('68416','NE','Ohiowa','Fillmore',40.412338,-97.45268),('68417','NE','Otoe','Otoe',40.733168,-96.094147),('68418','NE','Palmyra','Otoe',40.702493,-96.388186),('68419','NE','Panama','Lancaster',40.597825,-96.510551),('68420','NE','Pawnee City','Pawnee',40.109749,-96.180696),('68421','NE','Peru','Nemaha',40.485725,-95.729173),('68422','NE','Pickrell','Gage',40.388579,-96.704901),('68423','NE','Pleasant Dale','Seward',40.816074,-96.942886),('68424','NE','Plymouth','Jefferson',40.29138,-97.011656),('68428','NE','Raymond','Lancaster',40.966093,-96.805216),('68429','NE','Reynolds','Thayer',40.0445,-97.3227),('68430','NE','Roca','Lancaster',40.670868,-96.674364),('68431','NE','Rulo','Richardson',40.056224,-95.428704),('68433','NE','Salem','Richardson',40.053054,-95.738208),('68434','NE','Seward','Seward',40.909586,-97.116949),('68436','NE','Shickley','Fillmore',40.415768,-97.738474),('68437','NE','Shubert','Richardson',40.24035,-95.649378),('68438','NE','Sprague','Lancaster',40.626421,-96.745417),('68439','NE','Staplehurst','Seward',40.995896,-97.205463),('68440','NE','Steele City','Jefferson',40.042927,-97.022781),('68441','NE','Steinauer','Pawnee',40.220822,-96.227054),('68442','NE','Stella','Richardson',40.23622,-95.772266),('68443','NE','Sterling','Johnson',40.4537,-96.369371),('68444','NE','Strang','Fillmore',40.414072,-97.58463),('68445','NE','Swanton','Saline',40.38207,-97.080743),('68446','NE','Syracuse','Otoe',40.658745,-96.180887),('68447','NE','Table Rock','Pawnee',40.192144,-96.083887),('68448','NE','Talmage','Otoe',40.543134,-96.021982),('68450','NE','Tecumseh','Johnson',40.369061,-96.204249),('68452','NE','Ong','Clay',40.398261,-97.841678),('68453','NE','Tobias','Saline',40.413636,-97.338673),('68454','NE','Unadilla','Otoe',40.690775,-96.280496),('68455','NE','Union','Cass',40.830808,-95.896719),('68456','NE','Utica','Seward',40.909053,-97.320861),('68457','NE','Verdon','Richardson',40.150562,-95.709761),('68458','NE','Virginia','Gage',40.239079,-96.511417),('68460','NE','Waco','York',40.883366,-97.440294),('68461','NE','Walton','Lancaster',40.762391,-96.530669),('68462','NE','Waverly','Lancaster',40.931568,-96.523579),('68463','NE','Weeping Water','Cass',40.87199,-96.145191),('68464','NE','Western','Saline',40.413179,-97.189883),('68465','NE','Wilber','Saline',40.487422,-96.998521),('68466','NE','Wymore','Gage',40.078535,-96.645128),('68467','NE','York','York',40.866049,-97.590066),('68501','NE','Lincoln','Lancaster',40.8169,-96.7103),('68502','NE','Lincoln','Lancaster',40.789007,-96.696174),('68503','NE','Lincoln','Lancaster',40.823401,-96.675686),('68504','NE','Lincoln','Lancaster',40.845051,-96.658225),('68505','NE','Lincoln','Lancaster',40.825441,-96.622841),('68506','NE','Lincoln','Lancaster',40.785658,-96.644799),('68507','NE','Lincoln','Lancaster',40.852282,-96.627163),('68508','NE','Lincoln','Lancaster',40.814213,-96.706255),('68509','NE','Lincoln','Lancaster',40.8,-96.6666),('68510','NE','Lincoln','Lancaster',40.8071,-96.654894),('68512','NE','Lincoln','Lancaster',40.743332,-96.697019),('68514','NE','Lincoln','Lancaster',40.900613,-96.643915),('68516','NE','Lincoln','Lancaster',40.745141,-96.645154),('68517','NE','Lincoln','Lancaster',40.92178,-96.614939),('68520','NE','Lincoln','Lancaster',40.796733,-96.583025),('68521','NE','Lincoln','Lancaster',40.858801,-96.711899),('68522','NE','Lincoln','Lancaster',40.792901,-96.747035),('68523','NE','Lincoln','Lancaster',40.738361,-96.757129),('68524','NE','Lincoln','Lancaster',40.858805,-96.788509),('68526','NE','Lincoln','Lancaster',40.73712,-96.590803),('68527','NE','Lincoln','Lancaster',40.849224,-96.530512),('68528','NE','Lincoln','Lancaster',40.81633,-96.780098),('68529','NE','Lincoln','Lancaster',40.8583,-96.6349),('68531','NE','Lincoln','Lancaster',40.89938,-96.72081),('68532','NE','Lincoln','Lancaster',40.793233,-96.842815),('68542','NE','Lincoln','Lancaster',40.8,-96.6666),('68583','NE','Lincoln','Lancaster',40.8303,-96.6667),('68588','NE','Lincoln','Lancaster',40.8207,-96.7026),('68601','NE','Columbus','Platte',41.437897,-97.369074),('68602','NE','Columbus','Platte',41.4318,-97.3561),('68620','NE','Albion','Boone',41.708129,-98.01917),('68621','NE','Ames','Dodge',41.469831,-96.621987),('68622','NE','Bartlett','Wheeler',41.922578,-98.520851),('68623','NE','Belgrade','Nance',41.448393,-98.117112),('68624','NE','Bellwood','Butler',41.356866,-97.227329),('68626','NE','Brainard','Butler',41.169497,-96.992008),('68627','NE','Cedar Rapids','Boone',41.556556,-98.148286),('68628','NE','Clarks','Merrick',41.208783,-97.838071),('68629','NE','Clarkson','Colfax',41.706294,-97.126983),('68631','NE','Creston','Platte',41.699819,-97.359062),('68632','NE','David City','Butler',41.256602,-97.126382),('68633','NE','Dodge','Dodge',41.698543,-96.885964),('68634','NE','Duncan','Platte',41.389749,-97.494007),('68635','NE','Dwight','Butler',41.082683,-97.011443),('68636','NE','Elgin','Antelope',42.009211,-98.133263),('68637','NE','Ericson','Wheeler',41.780651,-98.640459),('68638','NE','Fullerton','Nance',41.368275,-97.971642),('68640','NE','Genoa','Nance',41.45976,-97.757449),('68641','NE','Howells','Colfax',41.729512,-97.007688),('68642','NE','Humphrey','Platte',41.687978,-97.502365),('68643','NE','Leigh','Colfax',41.701094,-97.246519),('68644','NE','Lindsay','Platte',41.707961,-97.685827),('68647','NE','Monroe','Platte',41.505036,-97.609865),('68648','NE','Morse Bluff','Saunders',41.415528,-96.780656),('68649','NE','North Bend','Dodge',41.475738,-96.785221),('68651','NE','Osceola','Polk',41.199164,-97.569833),('68652','NE','Petersburg','Boone',41.861404,-98.044181),('68653','NE','Platte Center','Platte',41.543481,-97.486889),('68654','NE','Polk','Polk',41.069939,-97.784729),('68655','NE','Primrose','Boone',41.633711,-98.242952),('68658','NE','Rising City','Butler',41.195033,-97.293075),('68659','NE','Rogers','Colfax',41.528437,-96.932937),('68660','NE','Saint Edward','Boone',41.571653,-97.865331),('68661','NE','Schuyler','Colfax',41.461284,-97.064625),('68662','NE','Shelby','Polk',41.197914,-97.421679),('68663','NE','Silver Creek','Merrick',41.30266,-97.689685),('68664','NE','Snyder','Dodge',41.70452,-96.788219),('68665','NE','Spalding','Greeley',41.693101,-98.385213),('68666','NE','Stromsburg','Polk',41.110595,-97.611211),('68667','NE','Surprise','Butler',41.106799,-97.313729),('68669','NE','Ulysses','Butler',41.082876,-97.22465),('68701','NE','Norfolk','Madison',42.028243,-97.422361),('68702','NE','Norfolk','Madison',42.0283,-97.4166),('68710','NE','Allen','Dixon',42.433068,-96.852903),('68711','NE','Amelia','Holt',42.159415,-99.016018),('68713','NE','Atkinson','Holt',42.558775,-98.941552),('68714','NE','Bassett','Rock',42.47759,-99.537882),('68715','NE','Battle Creek','Madison',41.981528,-97.607674),('68716','NE','Beemer','Cuming',41.934792,-96.823748),('68717','NE','Belden','Cedar',42.411326,-97.21767),('68718','NE','Bloomfield','Knox',42.64675,-97.689759),('68719','NE','Bristow','Boyd',42.939459,-98.565166),('68720','NE','Brunswick','Antelope',42.3424,-98.00855),('68722','NE','Butte','Boyd',42.927615,-98.86003),('68723','NE','Carroll','Wayne',42.286218,-97.203058),('68724','NE','Center','Knox',42.629709,-97.87345),('68725','NE','Chambers','Holt',42.201161,-98.755542),('68726','NE','Clearwater','Antelope',42.175973,-98.199686),('68727','NE','Coleridge','Cedar',42.511089,-97.207159),('68728','NE','Concord','Dixon',42.379104,-96.962364),('68729','NE','Creighton','Knox',42.469433,-97.905567),('68730','NE','Crofton','Knox',42.793982,-97.534316),('68731','NE','Dakota City','Dakota',42.421396,-96.448227),('68732','NE','Dixon','Dixon',42.4751,-96.981239),('68733','NE','Emerson','Dixon',42.278132,-96.734399),('68734','NE','Emmet','Holt',42.474121,-98.80323),('68735','NE','Ewing','Holt',42.198499,-98.405475),('68736','NE','Fordyce','Cedar',42.750135,-97.376871),('68738','NE','Hadar','Pierce',42.105,-97.4488),('68739','NE','Hartington','Cedar',42.627643,-97.26157),('68740','NE','Hoskins','Wayne',42.138866,-97.307976),('68741','NE','Hubbard','Dakota',42.369794,-96.580683),('68742','NE','Inman','Holt',42.37124,-98.521567),('68743','NE','Jackson','Dakota',42.460769,-96.595307),('68745','NE','Laurel','Cedar',42.437665,-97.090739),('68746','NE','Lynch','Boyd',42.809842,-98.437678),('68747','NE','Mclean','Pierce',42.392877,-97.479857),('68748','NE','Madison','Madison',41.837049,-97.454835),('68749','NE','Magnet','Cedar',42.455373,-97.470772),('68751','NE','Maskell','Dixon',42.691051,-96.98228),('68752','NE','Meadow Grove','Madison',42.010467,-97.727259),('68753','NE','Mills','Keya Paha',42.895701,-99.456909),('68755','NE','Naper','Boyd',42.939042,-99.117244),('68756','NE','Neligh','Antelope',42.161779,-98.014096),('68757','NE','Newcastle','Dixon',42.649379,-96.915048),('68758','NE','Newman Grove','Madison',41.778573,-97.784372),('68759','NE','Newport','Rock',42.702604,-99.314725),('68760','NE','Niobrara','Knox',42.768064,-98.050913),('68761','NE','Oakdale','Antelope',42.067066,-97.962173),('68763','NE','Oneill','Holt',42.517346,-98.613125),('68764','NE','Orchard','Antelope',42.384541,-98.233264),('68765','NE','Osmond','Pierce',42.34219,-97.613811),('68766','NE','Page','Holt',42.414099,-98.405206),('68767','NE','Pierce','Pierce',42.198667,-97.541458),('68768','NE','Pilger','Stanton',41.991176,-97.068432),('68769','NE','Plainview','Pierce',42.335817,-97.794721),('68770','NE','Ponca','Dixon',42.556966,-96.760308),('68771','NE','Randolph','Cedar',42.379265,-97.355606),('68773','NE','Royal','Antelope',42.360998,-98.118065),('68774','NE','Saint Helena','Cedar',42.820884,-97.278334),('68776','NE','South Sioux City','Dakota',42.46395,-96.419858),('68777','NE','Spencer','Boyd',42.845198,-98.6846),('68778','NE','Springview','Keya Paha',42.849501,-99.824917),('68779','NE','Stanton','Stanton',41.960911,-97.212107),('68780','NE','Stuart','Holt',42.605092,-99.132426),('68781','NE','Tilden','Madison',42.037017,-97.853605),('68783','NE','Verdigre','Knox',42.614769,-98.118367),('68784','NE','Wakefield','Dixon',42.250572,-96.881885),('68785','NE','Waterbury','Dixon',42.441098,-96.726952),('68786','NE','Wausa','Knox',42.503489,-97.555094),('68787','NE','Wayne','Wayne',42.227055,-97.023325),('68788','NE','West Point','Cuming',41.835276,-96.717933),('68789','NE','Winnetoon','Knox',42.542303,-97.989859),('68790','NE','Winside','Wayne',42.167461,-97.164316),('68791','NE','Wisner','Cuming',41.995294,-96.921967),('68792','NE','Wynot','Cedar',42.735174,-97.131453),('68801','NE','Grand Island','Hall',40.923171,-98.333208),('68802','NE','Grand Island','Hall',40.925,-98.3416),('68803','NE','Grand Island','Hall',40.925508,-98.384395),('68810','NE','Alda','Hall',40.86715,-98.46618),('68812','NE','Amherst','Buffalo',40.887782,-99.283842),('68813','NE','Anselmo','Custer',41.660685,-99.816296),('68814','NE','Ansley','Custer',41.32268,-99.405461),('68815','NE','Arcadia','Valley',41.418284,-99.14399),('68816','NE','Archer','Merrick',41.171386,-98.133739),('68817','NE','Ashton','Sherman',41.262155,-98.774387),('68818','NE','Aurora','Hamilton',40.842279,-98.002451),('68820','NE','Boelus','Howard',41.104911,-98.71073),('68821','NE','Brewster','Blaine',41.935552,-99.841561),('68822','NE','Broken Bow','Custer',41.408169,-99.636964),('68823','NE','Burwell','Garfield',41.822759,-99.113297),('68824','NE','Cairo','Hall',40.982469,-98.579416),('68825','NE','Callaway','Custer',41.282991,-99.940545),('68826','NE','Central City','Merrick',41.130168,-98.001415),('68827','NE','Chapman','Merrick',41.031677,-98.170703),('68828','NE','Comstock','Custer',41.557101,-99.24531),('68831','NE','Dannebrog','Howard',41.12294,-98.570854),('68832','NE','Doniphan','Hall',40.77626,-98.367136),('68833','NE','Dunning','Blaine',41.849276,-100.149752),('68834','NE','Eddyville','Dawson',41.040442,-99.653998),('68835','NE','Elba','Howard',41.32709,-98.6082),('68836','NE','Elm Creek','Buffalo',40.696019,-99.370721),('68837','NE','Elyria','Valley',41.664757,-99.05793),('68838','NE','Farwell','Howard',41.21284,-98.670894),('68840','NE','Gibbon','Buffalo',40.733762,-98.883286),('68841','NE','Giltner','Hamilton',40.768081,-98.164771),('68842','NE','Greeley','Greeley',41.545855,-98.506993),('68843','NE','Hampton','Hamilton',40.894148,-97.893277),('68844','NE','Hazard','Sherman',41.072153,-99.0638),('68845','NE','Kearney','Buffalo',40.711656,-99.116459),('68846','NE','Hordville','Hamilton',41.067424,-97.885997),('68847','NE','Kearney','Buffalo',40.711031,-99.056218),('68848','NE','Kearney','Buffalo',40.8392,-98.9767),('68849','NE','Kearney','Buffalo',40.699624,-99.100278),('68850','NE','Lexington','Dawson',40.778552,-99.739473),('68852','NE','Litchfield','Sherman',41.166507,-99.131766),('68853','NE','Loup City','Sherman',41.283496,-98.968246),('68854','NE','Marquette','Hamilton',41.022663,-98.002502),('68855','NE','Mason City','Custer',41.169218,-99.318341),('68856','NE','Merna','Custer',41.487073,-99.808449),('68858','NE','Miller','Buffalo',40.965845,-99.37754),('68859','NE','North Loup','Valley',41.488857,-98.796589),('68860','NE','Oconto','Custer',41.145959,-99.764123),('68861','NE','Odessa','Buffalo',40.701171,-99.256979),('68862','NE','Ord','Valley',41.600245,-98.940875),('68863','NE','Overton','Dawson',40.735536,-99.5308),('68864','NE','Palmer','Merrick',41.241906,-98.242144),('68865','NE','Phillips','Hamilton',40.897487,-98.197157),('68866','NE','Pleasanton','Buffalo',40.977964,-99.123992),('68869','NE','Ravenna','Buffalo',41.005518,-98.887001),('68870','NE','Riverdale','Buffalo',40.807919,-99.169605),('68871','NE','Rockville','Sherman',41.122154,-98.830316),('68872','NE','Saint Libory','Howard',41.082897,-98.33489),('68873','NE','Saint Paul','Howard',41.227854,-98.462282),('68874','NE','Sargent','Custer',41.632592,-99.408379),('68875','NE','Scotia','Greeley',41.483064,-98.688791),('68876','NE','Shelton','Buffalo',40.78491,-98.739966),('68878','NE','Sumner','Dawson',40.981521,-99.506693),('68879','NE','Taylor','Loup',41.82862,-99.490975),('68881','NE','Westerville','Custer',41.422454,-99.353527),('68882','NE','Wolbach','Greeley',41.408576,-98.405116),('68883','NE','Wood River','Hall',40.81601,-98.59518),('68901','NE','Hastings','Adams',40.590038,-98.36738),('68902','NE','Hastings','Adams',40.5862,-98.3856),('68920','NE','Alma','Harlan',40.140209,-99.358229),('68922','NE','Arapahoe','Furnas',40.318572,-99.900269),('68923','NE','Atlanta','Phelps',40.367321,-99.472884),('68924','NE','Axtell','Kearney',40.487413,-99.120556),('68925','NE','Ayr','Adams',40.431425,-98.438903),('68926','NE','Beaver City','Furnas',40.105983,-99.840291),('68927','NE','Bertrand','Phelps',40.547115,-99.615428),('68928','NE','Bladen','Webster',40.299407,-98.6042),('68929','NE','Bloomington','Franklin',40.124097,-99.045611),('68930','NE','Blue Hill','Webster',40.29933,-98.415524),('68932','NE','Campbell','Franklin',40.301393,-98.726775),('68933','NE','Clay Center','Clay',40.518511,-98.040294),('68934','NE','Deweese','Clay',40.35112,-98.138125),('68935','NE','Edgar','Clay',40.372434,-97.957259),('68936','NE','Edison','Furnas',40.315974,-99.772314),('68937','NE','Elwood','Gosper',40.627717,-99.863354),('68938','NE','Fairfield','Clay',40.424993,-98.107577),('68939','NE','Franklin','Franklin',40.099237,-98.962559),('68940','NE','Funk','Phelps',40.533063,-99.243748),('68941','NE','Glenvil','Clay',40.473519,-98.287545),('68942','NE','Guide Rock','Webster',40.096586,-98.320788),('68943','NE','Hardy','Nuckolls',40.038293,-97.906051),('68944','NE','Harvard','Clay',40.632015,-98.094396),('68945','NE','Heartwell','Kearney',40.569441,-98.783478),('68946','NE','Hendley','Furnas',40.118297,-99.989018),('68947','NE','Hildreth','Franklin',40.306892,-99.057091),('68948','NE','Holbrook','Furnas',40.315266,-100.020256),('68949','NE','Holdrege','Phelps',40.440249,-99.380179),('68950','NE','Holstein','Adams',40.465139,-98.657637),('68952','NE','Inavale','Webster',40.087684,-98.671309),('68954','NE','Inland','Clay',40.604427,-98.232333),('68955','NE','Juniata','Adams',40.595465,-98.522853),('68956','NE','Kenesaw','Adams',40.633021,-98.676743),('68957','NE','Lawrence','Nuckolls',40.277768,-98.246327),('68958','NE','Loomis','Phelps',40.517614,-99.502689),('68959','NE','Minden','Kearney',40.487565,-98.940478),('68960','NE','Naponee','Franklin',40.089589,-99.135138),('68961','NE','Nelson','Nuckolls',40.202142,-98.043042),('68964','NE','Oak','Nuckolls',40.234398,-97.904484),('68966','NE','Orleans','Harlan',40.145431,-99.466623),('68967','NE','Oxford','Furnas',40.249951,-99.626656),('68969','NE','Ragan','Harlan',40.30962,-99.288966),('68970','NE','Red Cloud','Webster',40.098767,-98.508958),('68971','NE','Republican City','Harlan',40.110887,-99.236598),('68972','NE','Riverton','Franklin',40.106531,-98.791059),('68973','NE','Roseland','Adams',40.459032,-98.562967),('68974','NE','Ruskin','Nuckolls',40.137014,-97.869),('68975','NE','Saronville','Clay',40.609271,-97.949617),('68976','NE','Smithfield','Gosper',40.583399,-99.731675),('68977','NE','Stamford','Harlan',40.092238,-99.630566),('68978','NE','Superior','Nuckolls',40.026414,-98.083041),('68979','NE','Sutton','Clay',40.596474,-97.855856),('68980','NE','Trumbull','Clay',40.685554,-98.262411),('68981','NE','Upland','Franklin',40.284367,-98.897374),('68982','NE','Wilcox','Kearney',40.342882,-99.179761),('69001','NE','Mc Cook','Red Willow',40.219606,-100.637695),('69020','NE','Bartley','Red Willow',40.231371,-100.307381),('69021','NE','Benkelman','Dundy',40.097787,-101.540578),('69022','NE','Cambridge','Furnas',40.327128,-100.188132),('69023','NE','Champion','Chase',40.488421,-101.897343),('69024','NE','Culbertson','Hitchcock',40.241769,-100.849202),('69025','NE','Curtis','Frontier',40.630535,-100.511994),('69026','NE','Danbury','Red Willow',40.039748,-100.431013),('69027','NE','Enders','Chase',40.431246,-101.536731),('69028','NE','Eustis','Frontier',40.663965,-100.035675),('69029','NE','Farnam','Dawson',40.692982,-100.237672),('69030','NE','Haigler','Dundy',40.102933,-101.928497),('69032','NE','Hayes Center','Hayes',40.538979,-101.009385),('69033','NE','Imperial','Chase',40.530413,-101.675637),('69034','NE','Indianola','Red Willow',40.233755,-100.416626),('69036','NE','Lebanon','Red Willow',40.054333,-100.279791),('69037','NE','Max','Dundy',40.15096,-101.399772),('69038','NE','Maywood','Frontier',40.631341,-100.705755),('69039','NE','Moorefield','Frontier',40.652011,-100.372327),('69040','NE','Palisade','Hitchcock',40.354996,-101.119758),('69041','NE','Parks','Dundy',40.134279,-101.739556),('69042','NE','Stockville','Frontier',40.510532,-100.377169),('69043','NE','Stratton','Hitchcock',40.149718,-101.228856),('69044','NE','Trenton','Hitchcock',40.159086,-101.031212),('69045','NE','Wauneta','Chase',40.460384,-101.379375),('69046','NE','Wilsonville','Furnas',40.086527,-100.09405),('69101','NE','North Platte','Lincoln',41.131212,-100.77783),('69103','NE','North Platte','Lincoln',41.1238,-100.765),('69120','NE','Arnold','Custer',41.413624,-100.198876),('69121','NE','Arthur','Arthur',41.582369,-101.655118),('69122','NE','Big Springs','Deuel',41.079038,-102.102435),('69123','NE','Brady','Lincoln',41.023899,-100.372754),('69125','NE','Broadwater','Morrill',41.600494,-102.863777),('69127','NE','Brule','Keith',41.116081,-101.890385),('69128','NE','Bushnell','Kimball',41.20922,-103.906121),('69129','NE','Chappell','Deuel',41.097577,-102.428375),('69130','NE','Cozad','Dawson',40.862719,-99.971595),('69131','NE','Dalton','Cheyenne',41.402483,-102.987948),('69132','NE','Dickens','Lincoln',40.869371,-101.002692),('69133','NE','Dix','Kimball',41.207049,-103.471399),('69134','NE','Elsie','Perkins',40.842435,-101.37385),('69135','NE','Elsmere','Cherry',42.214362,-100.225629),('69138','NE','Gothenburg','Dawson',40.952917,-100.162742),('69140','NE','Grant','Perkins',40.850334,-101.754322),('69141','NE','Gurley','Cheyenne',41.299748,-103.00333),('69142','NE','Halsey','Thomas',41.901267,-100.301727),('69143','NE','Hershey','Lincoln',41.169036,-101.029604),('69144','NE','Keystone','Keith',41.241989,-101.602042),('69145','NE','Kimball','Kimball',41.232523,-103.66406),('69146','NE','Lemoyne','Keith',41.312561,-101.77343),('69147','NE','Lewellen','Garden',41.348716,-102.081077),('69148','NE','Lisco','Garden',41.540042,-102.608157),('69149','NE','Lodgepole','Cheyenne',41.185098,-102.686483),('69150','NE','Madrid','Perkins',40.849635,-101.538883),('69151','NE','Maxwell','Lincoln',41.054302,-100.552657),('69152','NE','Mullen','Hooker',42.210251,-101.125815),('69153','NE','Ogallala','Keith',41.117033,-101.698131),('69154','NE','Oshkosh','Garden',41.401932,-102.348719),('69155','NE','Paxton','Keith',41.120393,-101.38032),('69156','NE','Potter','Cheyenne',41.271034,-103.319713),('69157','NE','Purdum','Blaine',42.042967,-100.171099),('69160','NE','Sidney','Cheyenne',41.1156,-102.9598),('69161','NE','Seneca','Thomas',42.077326,-100.803903),('69162','NE','Sidney','Cheyenne',41.14327,-103.004853),('69163','NE','Stapleton','Logan',41.484802,-100.540004),('69165','NE','Sutherland','Lincoln',41.153944,-101.159801),('69166','NE','Thedford','Thomas',42.07698,-100.584178),('69167','NE','Tryon','Mcpherson',41.596043,-100.953283),('69168','NE','Venango','Perkins',40.76381,-102.002139),('69169','NE','Wallace','Lincoln',40.821043,-101.179886),('69170','NE','Wellfleet','Lincoln',40.778053,-100.730113),('69171','NE','Willow Island','Dawson',40.88744,-100.069558),('69190','NE','Oshkosh','Garden',41.6771,-102.3452),('69201','NE','Valentine','Cherry',42.81397,-100.552346),('69210','NE','Ainsworth','Brown',42.535922,-99.861255),('69211','NE','Cody','Cherry',42.844099,-101.323515),('69212','NE','Crookston','Cherry',42.942221,-100.795375),('69214','NE','Johnstown','Brown',42.604626,-100.069169),('69216','NE','Kilgore','Cherry',42.994755,-100.958733),('69217','NE','Long Pine','Brown',42.514956,-99.701125),('69218','NE','Merriman','Cherry',42.8224,-101.645698),('69219','NE','Nenzel','Cherry',42.690037,-101.134835),('69220','NE','Sparks','Cherry',42.892973,-100.203176),('69221','NE','Wood Lake','Cherry',42.614229,-100.297994),('69301','NE','Alliance','Box Butte',42.124632,-102.871621),('69331','NE','Angora','Morrill',41.829477,-102.989142),('69333','NE','Ashby','Grant',42.150047,-101.983403),('69334','NE','Bayard','Morrill',41.781691,-103.319817),('69335','NE','Bingham','Sheridan',42.063036,-102.094263),('69336','NE','Bridgeport','Morrill',41.650042,-103.112425),('69337','NE','Chadron','Dawes',42.813417,-102.996351),('69339','NE','Crawford','Dawes',42.646778,-103.397808),('69340','NE','Ellsworth','Sheridan',42.221532,-102.198221),('69341','NE','Gering','Scotts Bluff',41.801516,-103.667116),('69343','NE','Gordon','Sheridan',42.768178,-102.158627),('69345','NE','Harrisburg','Banner',41.55964,-103.716287),('69346','NE','Harrison','Sioux',42.721237,-103.802201),('69347','NE','Hay Springs','Sheridan',42.606676,-102.664666),('69348','NE','Hemingford','Box Butte',42.328944,-103.150899),('69350','NE','Hyannis','Grant',41.986323,-101.702461),('69351','NE','Lakeside','Sheridan',42.109886,-102.421279),('69352','NE','Lyman','Scotts Bluff',41.864686,-103.997659),('69353','NE','Mcgrew','Scotts Bluff',41.747066,-103.416448),('69354','NE','Marsland','Dawes',42.448654,-103.352929),('69355','NE','Melbeta','Scotts Bluff',41.781927,-103.516286),('69356','NE','Minatare','Scotts Bluff',41.856864,-103.47032),('69357','NE','Mitchell','Scotts Bluff',41.943924,-103.801978),('69358','NE','Morrill','Scotts Bluff',41.997827,-103.9578),('69360','NE','Rushville','Sheridan',42.726908,-102.48824),('69361','NE','Scottsbluff','Scotts Bluff',41.885609,-103.652414),('69363','NE','Scottsbluff','Scotts Bluff',41.9185,-103.6435),('69365','NE','Whiteclay','Sheridan',42.981043,-102.540384),('69366','NE','Whitman','Grant',42.135423,-101.555742),('69367','NE','Whitney','Dawes',42.780338,-103.278727),('70001','LA','Metairie','Jefferson Parish',29.985646,-90.168569),('70002','LA','Metairie','Jefferson Parish',30.009311,-90.162641),('70003','LA','Metairie','Jefferson Parish',29.999411,-90.214128),('70004','LA','Metairie','Jefferson',29.9759,-90.1608),('70005','LA','Metairie','Jefferson Parish',29.999416,-90.134065),('70006','LA','Metairie','Jefferson Parish',30.01305,-90.191085),('70009','LA','Metairie','Jefferson',30.0091,-90.1563),('70010','LA','Metairie','Jefferson',30.0091,-90.1563),('70011','LA','Metairie','Jefferson',30.0091,-90.1563),('70030','LA','Des Allemands','St. Charles Parish',29.822453,-90.446662),('70031','LA','Ama','St. Charles Parish',29.946957,-90.301505),('70032','LA','Arabi','St. Bernard Parish',29.958978,-89.998798),('70033','LA','Metairie','Jefferson',29.9838,-90.1527),('70036','LA','Barataria','Jefferson Parish',29.715641,-90.11615),('70037','LA','Belle Chasse','Plaquemines Parish',29.809113,-90.008696),('70038','LA','Boothville','Plaquemines Parish',29.321727,-89.394104),('70039','LA','Boutte','St. Charles Parish',29.892232,-90.390281),('70040','LA','Braithwaite','Plaquemines Parish',29.800301,-89.958024),('70041','LA','Buras','Plaquemines Parish',29.358171,-89.527899),('70043','LA','Chalmette','St. Bernard Parish',29.947039,-89.962079),('70044','LA','Chalmette','Saint Bernard',29.9494,-89.9604),('70047','LA','Destrehan','St. Charles Parish',29.973061,-90.377748),('70049','LA','Edgard','St. John The Baptist Parish',30.030493,-90.567863),('70050','LA','Empire','Plaquemines Parish',29.385179,-89.596999),('70051','LA','Garyville','St. John The Baptist Parish',30.059202,-90.620858),('70052','LA','Gramercy','St. James Parish',30.057371,-90.692661),('70053','LA','Gretna','Jefferson Parish',29.915443,-90.053353),('70054','LA','Gretna','Jefferson',29.9144,-90.0538),('70055','LA','Metairie','Jefferson',29.9838,-90.1527),('70056','LA','Gretna','Jefferson Parish',29.894003,-90.030757),('70057','LA','Hahnville','St. Charles Parish',29.981201,-90.452964),('70058','LA','Harvey','Jefferson Parish',29.878777,-90.06687),('70059','LA','Harvey','Jefferson',29.9033,-90.0772),('70060','LA','Metairie','Jefferson',29.8675,-90.0691),('70062','LA','Kenner','Jefferson Parish',29.990813,-90.246042),('70063','LA','Kenner','Jefferson',29.9938,-90.2416),('70064','LA','Kenner','Jefferson',29.9972,-90.241),('70065','LA','Kenner','Jefferson Parish',30.025183,-90.251801),('70067','LA','Lafitte','Jefferson Parish',29.716327,-90.11348),('70068','LA','La Place','St. John The Baptist Parish',30.069517,-90.477027),('70069','LA','La Place','St John The Baptist',30.1638,-90.4612),('70070','LA','Luling','St. Charles Parish',29.904864,-90.35484),('70071','LA','Lutcher','St. James Parish',30.046125,-90.699878),('70072','LA','Marrero','Jefferson Parish',29.869677,-90.107928),('70073','LA','Marrero','Jefferson',29.8991,-90.1002),('70075','LA','Meraux','St. Bernard Parish',29.93268,-89.92349),('70076','LA','Mount Airy','St. John The Baptist Parish',30.061769,-90.646247),('70078','LA','New Sarpy','Saint Charles',29.9777,-90.3877),('70079','LA','Norco','St. Charles Parish',30.003858,-90.411441),('70080','LA','Paradis','St. Charles Parish',29.874919,-90.436456),('70081','LA','Pilottown','Plaquemines',29.1813,-89.2575),('70082','LA','Pointe A La Hache','Plaquemines Parish',29.571514,-89.779883),('70083','LA','Port Sulphur','Plaquemines Parish',29.492362,-89.805623),('70084','LA','Reserve','St. John The Baptist Parish',30.064235,-90.564546),('70085','LA','Saint Bernard','St. Bernard Parish',29.860721,-89.798268),('70086','LA','Saint James','St. James Parish',30.031271,-90.862113),('70087','LA','Saint Rose','St. Charles Parish',29.961733,-90.309344),('70090','LA','Vacherie','St. James Parish',29.985748,-90.712013),('70091','LA','Venice','Plaquemines Parish',29.191165,-89.258694),('70092','LA','Violet','St. Bernard Parish',29.901215,-89.896911),('70093','LA','Belle Chasse','Plaquemines',29.5341,-89.7945),('70094','LA','Westwego','Jefferson Parish',29.917097,-90.187098),('70096','LA','Westwego','Jefferson',29.9058,-90.1422),('70097','LA','Kenner','Jefferson',29.9565,-90.2635),('70112','LA','New Orleans','Orleans Parish',29.957678,-90.076929),('70113','LA','New Orleans','Orleans Parish',29.943326,-90.083038),('70114','LA','New Orleans','Orleans Parish',29.937495,-90.034664),('70115','LA','New Orleans','Orleans Parish',29.927071,-90.102116),('70116','LA','New Orleans','Orleans Parish',29.968297,-90.065948),('70117','LA','New Orleans','Orleans Parish',29.970471,-90.030385),('70118','LA','New Orleans','Orleans Parish',29.950868,-90.123521),('70119','LA','New Orleans','Orleans Parish',29.975137,-90.086944),('70121','LA','New Orleans','Jefferson Parish',29.963168,-90.161681),('70122','LA','New Orleans','Orleans Parish',30.008613,-90.063042),('70123','LA','New Orleans','Jefferson Parish',29.952465,-90.2055),('70124','LA','New Orleans','Orleans Parish',30.003656,-90.107424),('70125','LA','New Orleans','Orleans Parish',29.951612,-90.104178),('70126','LA','New Orleans','Orleans Parish',30.013719,-90.020274),('70127','LA','New Orleans','Orleans Parish',30.030303,-89.97757),('70128','LA','New Orleans','Orleans Parish',30.047426,-89.955362),('70129','LA','New Orleans','Orleans Parish',30.050095,-89.874339),('70130','LA','New Orleans','Orleans Parish',29.937622,-90.070879),('70131','LA','New Orleans','Orleans Parish',29.915914,-89.986804),('70139','LA','New Orleans','Orleans',29.95,-90.071),('70140','LA','New Orleans','Orleans',29.9544,-90.075),('70141','LA','New Orleans','Jefferson',29.9928,-90.2587),('70142','LA','New Orleans','Orleans',29.9544,-90.075),('70143','LA','New Orleans','Orleans',29.8272,-90.0212),('70145','LA','New Orleans','Orleans',29.9544,-90.075),('70146','LA','New Orleans','Orleans',29.9614,-90.0332),('70148','LA','New Orleans','Orleans',30.0315,-90.0437),('70149','LA','New Orleans','Orleans',29.9544,-90.075),('70150','LA','New Orleans','Orleans',29.9544,-90.075),('70151','LA','New Orleans','Orleans',29.9544,-90.075),('70152','LA','New Orleans','Orleans',29.9544,-90.075),('70153','LA','New Orleans','Orleans',29.9544,-90.075),('70154','LA','New Orleans','Orleans',29.9544,-90.075),('70156','LA','New Orleans','Orleans',29.9544,-90.075),('70157','LA','New Orleans','Orleans',29.9544,-90.075),('70158','LA','New Orleans','Orleans',29.9544,-90.075),('70159','LA','New Orleans','Orleans',29.9544,-90.075),('70160','LA','New Orleans','Orleans',29.9544,-90.075),('70161','LA','New Orleans','Orleans',29.9544,-90.075),('70162','LA','New Orleans','Orleans',29.9544,-90.075),('70163','LA','New Orleans','Orleans',29.95006,-90.07532),('70164','LA','New Orleans','Orleans',30.0063,-90.0047),('70165','LA','New Orleans','Orleans',29.9544,-90.075),('70166','LA','New Orleans','Orleans',29.9544,-90.075),('70167','LA','New Orleans','Orleans',29.9544,-90.075),('70170','LA','New Orleans','Orleans',29.9518,-90.0697),('70172','LA','New Orleans','Orleans',29.9544,-90.075),('70174','LA','New Orleans','Orleans',29.9544,-90.075),('70175','LA','New Orleans','Orleans',29.9544,-90.075),('70176','LA','New Orleans','Orleans',29.9544,-90.075),('70177','LA','New Orleans','Orleans',29.9544,-90.075),('70178','LA','New Orleans','Orleans',29.9544,-90.075),('70179','LA','New Orleans','Orleans',29.9544,-90.075),('70181','LA','New Orleans','Jefferson',29.9639,-90.0654),('70182','LA','New Orleans','Orleans',30.0089,-90.0647),('70183','LA','New Orleans','Jefferson',29.9656,-90.0644),('70184','LA','New Orleans','Orleans',29.9544,-90.075),('70185','LA','New Orleans','Orleans',29.9544,-90.075),('70186','LA','New Orleans','Orleans',30.0063,-90.0047),('70187','LA','New Orleans','Orleans',30.0235,-89.975),('70189','LA','New Orleans','Orleans',30.0749,-89.8161),('70190','LA','New Orleans','Orleans',29.9544,-90.075),('70195','LA','New Orleans','Orleans',29.9544,-90.075),('70301','LA','Thibodaux','Lafourche Parish',29.801941,-90.804686),('70302','LA','Thibodaux','Lafourche',29.7955,-90.8227),('70310','LA','Thibodaux','Lafourche',29.7955,-90.8227),('70339','LA','Pierre Part','Assumption Parish',29.928601,-91.200174),('70340','LA','Amelia','St. Mary Parish',29.668991,-91.103079),('70341','LA','Belle Rose','Assumption Parish',30.02908,-91.075432),('70342','LA','Berwick','St. Mary Parish',29.695024,-91.230421),('70343','LA','Bourg','Terrebonne Parish',29.560151,-90.590692),('70344','LA','Chauvin','Terrebonne Parish',29.263048,-90.622252),('70345','LA','Cut Off','Lafourche Parish',29.514885,-90.317087),('70346','LA','Donaldsonville','Ascension Parish',30.103158,-91.001568),('70352','LA','Donner','Terrebonne Parish',29.695793,-90.948582),('70353','LA','Dulac','Terrebonne Parish',29.366448,-90.712335),('70354','LA','Galliano','Lafourche Parish',29.422783,-90.292424),('70355','LA','Gheens','Lafourche Parish',29.687187,-90.435472),('70356','LA','Gibson','Terrebonne Parish',29.658976,-90.974185),('70357','LA','Golden Meadow','Lafourche Parish',29.257935,-90.225037),('70358','LA','Grand Isle','Jefferson Parish',29.2304,-90.006456),('70359','LA','Gray','Terrebonne Parish',29.689835,-90.778343),('70360','LA','Houma','Terrebonne Parish',29.591367,-90.745674),('70361','LA','Houma','Terrebonne',29.5955,-90.7194),('70363','LA','Houma','Terrebonne Parish',29.561818,-90.691183),('70364','LA','Houma','Terrebonne Parish',29.626139,-90.723663),('70371','LA','Kraemer','Lafourche',29.8116,-90.7407),('70372','LA','Labadieville','Assumption Parish',29.822958,-90.969149),('70373','LA','Larose','Lafourche Parish',29.571492,-90.375343),('70374','LA','Lockport','Lafourche Parish',29.62628,-90.509991),('70375','LA','Mathews','Lafourche Parish',29.693991,-90.537908),('70377','LA','Montegut','Terrebonne Parish',29.354244,-90.522661),('70380','LA','Morgan City','St. Mary Parish',29.694819,-91.175327),('70381','LA','Morgan City','Saint Mary',29.6991,-91.2066),('70390','LA','Napoleonville','Assumption Parish',29.923419,-91.02399),('70391','LA','Paincourtville','Assumption Parish',29.988562,-91.058958),('70392','LA','Patterson','St. Mary Parish',29.6998,-91.311683),('70393','LA','Plattenville','Assumption Parish',29.992321,-91.021717),('70394','LA','Raceland','Lafourche Parish',29.712357,-90.593255),('70395','LA','Schriever','Terrebonne Parish',29.711475,-90.83283),('70397','LA','Theriot','Terrebonne Parish',29.411469,-90.785397),('70401','LA','Hammond','Tangipahoa Parish',30.518013,-90.472515),('70402','LA','Hammond','Tangipahoa Parish',30.516161,-90.470129),('70403','LA','Hammond','Tangipahoa Parish',30.484826,-90.476446),('70404','LA','Hammond','Tangipahoa',30.5041,-90.4611),('70420','LA','Abita Springs','St. Tammany Parish',30.481935,-90.006267),('70421','LA','Akers','Tangipahoa',30.4414,-90.4404),('70422','LA','Amite','Tangipahoa Parish',30.72876,-90.508929),('70426','LA','Angie','Washington Parish',30.938376,-89.834815),('70427','LA','Bogalusa','Washington Parish',30.75743,-89.878278),('70429','LA','Bogalusa','Washington',30.7908,-89.8486),('70431','LA','Bush','St. Tammany Parish',30.608402,-89.963804),('70433','LA','Covington','St. Tammany Parish',30.464855,-90.106137),('70434','LA','Covington','Saint Tammany',30.4752,-90.1008),('70435','LA','Covington','St. Tammany Parish',30.545415,-90.096941),('70436','LA','Fluker','Tangipahoa Parish',30.806693,-90.518013),('70437','LA','Folsom','St. Tammany Parish',30.625583,-90.190641),('70438','LA','Franklinton','Washington Parish',30.844017,-90.120879),('70441','LA','Greensburg','St. Helena Parish',30.853907,-90.752803),('70442','LA','Husser','Tangipahoa Parish',30.679979,-90.325616),('70443','LA','Independence','Tangipahoa Parish',30.627478,-90.518625),('70444','LA','Kentwood','Tangipahoa Parish',30.905925,-90.500762),('70445','LA','Lacombe','St. Tammany Parish',30.337607,-89.914481),('70446','LA','Loranger','Tangipahoa Parish',30.626226,-90.358768),('70447','LA','Madisonville','St. Tammany Parish',30.425487,-90.183837),('70448','LA','Mandeville','St. Tammany Parish',30.367233,-90.060097),('70449','LA','Maurepas','Livingston Parish',30.260967,-90.712679),('70450','LA','Mount Hermon','Washington Parish',30.941434,-90.260528),('70451','LA','Natalbany','Tangipahoa Parish',30.547284,-90.48218),('70452','LA','Pearl River','St. Tammany Parish',30.405633,-89.775923),('70453','LA','Pine Grove','St. Helena Parish',30.692614,-90.756864),('70454','LA','Ponchatoula','Tangipahoa Parish',30.433494,-90.41526),('70455','LA','Robert','Tangipahoa Parish',30.508258,-90.329621),('70456','LA','Roseland','Tangipahoa Parish',30.771571,-90.514091),('70457','LA','Saint Benedict','Saint Tammany',30.5266,-90.1125),('70458','LA','Slidell','St. Tammany Parish',30.272267,-89.772932),('70459','LA','Slidell','Saint Tammany',30.275,-89.7811),('70460','LA','Slidell','St. Tammany Parish',30.298364,-89.811743),('70461','LA','Slidell','St. Tammany Parish',30.264352,-89.732825),('70462','LA','Springfield','Livingston Parish',30.389568,-90.581546),('70463','LA','Sun','St. Tammany Parish',30.658239,-89.903867),('70464','LA','Talisheek','St. Tammany Parish',30.53573,-89.893877),('70465','LA','Tangipahoa','Tangipahoa Parish',30.863897,-90.516477),('70466','LA','Tickfaw','Tangipahoa Parish',30.561315,-90.506707),('70467','LA','Varnado,','Washington',30.985,-89.7547),('70469','LA','Slidell','Saint Tammany',30.3342,-89.8359),('70470','LA','Mandeville','Saint Tammany',30.4587,-90.1268),('70471','LA','Mandeville','St. Tammany Parish',30.401948,-90.084652),('70500','LA','Lafayette','Lafayette',30.220212,-92.017365),('70501','LA','Lafayette','Lafayette Parish',30.233573,-92.009307),('70502','LA','Lafayette','Lafayette',30.239,-92.0075),('70503','LA','Lafayette','Lafayette Parish',30.179615,-92.054954),('70504','LA','Lafayette','Lafayette',30.2244,-92.0451),('70505','LA','Lafayette','Lafayette',30.205,-92.0157),('70506','LA','Lafayette','Lafayette Parish',30.211043,-92.061749),('70507','LA','Lafayette','Lafayette Parish',30.280305,-92.023854),('70508','LA','Lafayette','Lafayette Parish',30.160507,-92.021508),('70509','LA','Lafayette','Lafayette',30.239,-92.0075),('70510','LA','Abbeville','Vermilion Parish',29.948157,-92.149156),('70511','LA','Abbeville','Vermilion',29.9752,-92.1353),('70512','LA','Arnaudville','St. Landry Parish',30.406694,-91.923619),('70513','LA','Avery Island','Iberia Parish',29.907042,-91.905633),('70514','LA','Baldwin','St. Mary Parish',29.835956,-91.548734),('70515','LA','Basile','Evangeline Parish',30.472775,-92.584874),('70516','LA','Branch','Acadia Parish',30.370902,-92.303577),('70517','LA','Breaux Bridge','St. Martin Parish',30.304766,-91.850394),('70518','LA','Broussard','Lafayette Parish',30.127333,-91.950625),('70519','LA','Cade','St. Martin Parish',30.082597,-91.902065),('70520','LA','Carencro','Lafayette Parish',30.326822,-92.042699),('70521','LA','Cecilia','Saint Martin',30.336379,-91.847867),('70522','LA','Centerville','Saint Mary',29.8234,-91.4544),('70523','LA','Charenton','St. Mary Parish',29.885348,-91.52134),('70524','LA','Chataignier','Evangeline Parish',30.565974,-92.320722),('70525','LA','Church Point','Acadia Parish',30.414184,-92.219663),('70526','LA','Crowley','Acadia Parish',30.216486,-92.378191),('70527','LA','Crowley','Acadia',30.2138,-92.3744),('70528','LA','Delcambre','Vermilion Parish',29.948798,-91.988885),('70529','LA','Duson','Lafayette Parish',30.202279,-92.16158),('70531','LA','Egan','Acadia Parish',30.238683,-92.506141),('70532','LA','Elton','Jefferson Davis Parish',30.4709,-92.697075),('70533','LA','Erath','Vermilion Parish',29.940583,-92.031903),('70534','LA','Estherwood','Acadia Parish',30.186813,-92.459243),('70535','LA','Eunice','St. Landry Parish',30.490097,-92.413798),('70537','LA','Evangeline','Acadia Parish',30.262164,-92.567109),('70538','LA','Franklin','St. Mary Parish',29.762379,-91.526393),('70540','LA','Garden City','Saint Mary',29.761665,-91.465693),('70541','LA','Grand Coteau','St. Landry Parish',30.422795,-92.047563),('70542','LA','Gueydan','Vermilion Parish',30.011366,-92.555666),('70543','LA','Iota','Acadia Parish',30.32821,-92.494449),('70544','LA','Jeanerette','Iberia Parish',29.906064,-91.663341),('70546','LA','Jennings','Jefferson Davis Parish',30.246451,-92.661877),('70548','LA','Kaplan','Vermilion Parish',29.959483,-92.318222),('70549','LA','Lake Arthur','Jefferson Davis Parish',30.073672,-92.740326),('70550','LA','Lawtell','St. Landry Parish',30.517863,-92.188614),('70551','LA','Leonville','Saint Landry',30.4702,-91.9783),('70552','LA','Loreauville','Iberia Parish',30.063911,-91.726054),('70554','LA','Mamou','Evangeline Parish',30.628299,-92.426621),('70555','LA','Maurice','Vermilion Parish',30.086493,-92.12867),('70556','LA','Mermentau','Acadia Parish',30.19103,-92.570372),('70558','LA','Milton','Lafayette Parish',30.100772,-92.075674),('70559','LA','Morse','Acadia Parish',30.139347,-92.508109),('70560','LA','New Iberia','Iberia Parish',29.981849,-91.849648),('70562','LA','New Iberia','Iberia',29.9907,-91.8191),('70563','LA','New Iberia','Iberia Parish',30.01804,-91.775699),('70569','LA','Lydia','Iberia',29.9191,-91.7952),('70570','LA','Opelousas','St. Landry Parish',30.530652,-92.092528),('70571','LA','Opelousas','Saint Landry',30.5333,-92.0813),('70575','LA','Perry','Vermilion Parish',29.948857,-92.157923),('70576','LA','Pine Prairie','Evangeline Parish',30.781815,-92.419713),('70577','LA','Port Barre','St. Landry Parish',30.547387,-91.937512),('70578','LA','Rayne','Acadia Parish',30.23279,-92.259334),('70580','LA','Reddell','Evangeline Parish',30.674822,-92.42665),('70581','LA','Roanoke','Jefferson Davis Parish',30.247697,-92.739868),('70582','LA','Saint Martinville','St. Martin Parish',30.153776,-91.804264),('70583','LA','Scott','Lafayette Parish',30.250613,-92.102589),('70584','LA','Sunset','St. Landry Parish',30.394794,-92.085305),('70585','LA','Turkey Creek','Evangeline Parish',30.879943,-92.40979),('70586','LA','Ville Platte','Evangeline Parish',30.714457,-92.305835),('70589','LA','Washington','St. Landry Parish',30.651035,-92.040531),('70591','LA','Welsh','Jefferson Davis Parish',30.257744,-92.832802),('70592','LA','Youngsville','Lafayette Parish',30.096826,-92.00081),('70593','LA','Lafayette','Lafayette',30.220285,-92.016926),('70595','LA','Lafayette','Lafayette',30.2259,-92.0218),('70596','LA','Lafayette','Lafayette',30.220285,-92.016926),('70598','LA','Lafayette','Lafayette',30.1765,-92.008),('70601','LA','Lake Charles','Calcasieu Parish',30.227262,-93.206341),('70602','LA','Lake Charles','Calcasieu',30.2263,-93.2172),('70605','LA','Lake Charles','Calcasieu Parish',30.163612,-93.251174),('70606','LA','Lake Charles','Calcasieu',30.166,-93.232),('70607','LA','Lake Charles','Calcasieu Parish',30.128108,-93.198669),('70609','LA','Lake Charles','Calcasieu',30.1809,-93.2157),('70611','LA','Lake Charles','Calcasieu Parish',30.327616,-93.203849),('70612','LA','Lake Charles','Calcasieu',30.2263,-93.2172),('70615','LA','Lake Charles','Calcasieu Parish',30.240276,-93.140831),('70616','LA','Lake Charles','Calcasieu',30.2263,-93.2172),('70629','LA','Lake Charles','Calcasieu',30.2263,-93.2172),('70630','LA','Bell City','Calcasieu Parish',30.0353,-92.989291),('70631','LA','Cameron','Cameron Parish',29.834971,-93.631238),('70632','LA','Creole','Cameron Parish',29.815618,-93.027617),('70633','LA','Dequincy','Calcasieu Parish',30.444425,-93.412283),('70634','LA','Deridder','Beauregard Parish',30.817006,-93.260012),('70637','LA','Dry Creek','Allen Parish',30.688985,-92.978341),('70638','LA','Elizabeth','Allen Parish',30.864743,-92.793992),('70639','LA','Evans','Vernon Parish',30.983355,-93.497879),('70640','LA','Fenton','Jefferson Davis Parish',30.367067,-92.916502),('70643','LA','Grand Chenier','Cameron Parish',29.790814,-92.811879),('70644','LA','Grant','Allen Parish',30.792345,-92.945596),('70645','LA','Hackberry','Cameron Parish',29.987249,-93.38242),('70646','LA','Hayes','Calcasieu Parish',30.107392,-92.921016),('70647','LA','Iowa','Calcasieu Parish',30.25317,-93.01483),('70648','LA','Kinder','Allen Parish',30.485663,-92.883398),('70650','LA','Lacassine','Jefferson Davis Parish',30.237299,-92.922759),('70651','LA','Leblanc','Allen Parish',30.515652,-92.952896),('70652','LA','Longville','Beauregard Parish',30.60566,-93.259758),('70653','LA','Merryville','Beauregard Parish',30.703823,-93.550052),('70654','LA','Mittie','Allen Parish',30.659467,-92.890417),('70655','LA','Oberlin','Allen Parish',30.6352,-92.746107),('70656','LA','Pitkin','Vernon Parish',31.013122,-93.000713),('70657','LA','Ragley','Beauregard Parish',30.503084,-93.153008),('70658','LA','Reeves','Allen Parish',30.527772,-93.043397),('70659','LA','Rosepine','Vernon Parish',30.92233,-93.282862),('70660','LA','Singer','Beauregard Parish',30.547813,-93.435506),('70661','LA','Starks','Calcasieu Parish',30.354504,-93.649655),('70662','LA','Sugartown','Beauregard Parish',30.808824,-92.993473),('70663','LA','Sulphur','Calcasieu Parish',30.245365,-93.363976),('70664','LA','Sulphur','Calcasieu',30.1811,-93.403),('70665','LA','Sulphur','Calcasieu Parish',30.161404,-93.397175),('70668','LA','Vinton','Calcasieu Parish',30.18576,-93.598333),('70669','LA','Westlake','Calcasieu Parish',30.248978,-93.267272),('70704','LA','Baker','East Baton Rouge',30.588,-91.168),('70706','LA','Denham Springs','Livingston Parish',30.594978,-90.926514),('70707','LA','Gonzales','Ascension',30.2193,-90.9202),('70710','LA','Addis','West Baton Rouge Parish',30.35475,-91.259709),('70711','LA','Albany','Livingston Parish',30.510191,-90.590448),('70712','LA','Angola','West Feliciana Parish',30.968411,-91.597952),('70714','LA','Baker','East Baton Rouge Parish',30.584887,-91.146376),('70715','LA','Batchelor','Pointe Coupee Parish',30.789734,-91.684125),('70718','LA','Brittany','Ascension',30.2109,-90.8872),('70719','LA','Brusly','West Baton Rouge Parish',30.386657,-91.254013),('70721','LA','Carville','Iberville Parish',30.216284,-91.083038),('70722','LA','Clinton','East Feliciana Parish',30.833884,-90.925042),('70723','LA','Convent','St. James Parish',30.058907,-90.839605),('70725','LA','Darrow','Ascension Parish',30.134884,-90.955566),('70726','LA','Denham Springs','Livingston Parish',30.462461,-90.925623),('70727','LA','Denham Springs','Livingston',30.4241,-90.8942),('70728','LA','Duplessis','Ascension',30.2691,-90.9462),('70729','LA','Erwinville','West Baton Rouge Parish',30.565804,-91.36295),('70730','LA','Ethel','East Feliciana Parish',30.810679,-91.09362),('70732','LA','Fordoche','Pointe Coupee Parish',30.59989,-91.619454),('70733','LA','French Settlement','Livingston Parish',30.30368,-90.798704),('70734','LA','Geismar','Ascension Parish',30.214675,-91.00151),('70736','LA','Glynn','Pointe Coupee Parish',30.62986,-91.336768),('70737','LA','Gonzales','Ascension Parish',30.227062,-90.922198),('70738','LA','Burnside','Ascension',30.2378,-90.9314),('70739','LA','Greenwell Springs','East Baton Rouge Parish',30.571363,-90.985284),('70740','LA','Grosse Tete','Iberville Parish',30.394229,-91.432067),('70743','LA','Hester','St. James Parish',30.01946,-90.772142),('70744','LA','Holden','Livingston Parish',30.533128,-90.65058),('70747','LA','Innis','Pointe Coupee Parish',30.873785,-91.671716),('70748','LA','Jackson','East Feliciana Parish',30.796083,-91.224497),('70749','LA','Jarreau','Pointe Coupee Parish',30.650223,-91.394511),('70750','LA','Krotz Springs','St. Landry Parish',30.521366,-91.769651),('70752','LA','Lakeland','Pointe Coupee Parish',30.585565,-91.404442),('70753','LA','Lettsworth','Pointe Coupee Parish',30.950571,-91.740981),('70754','LA','Livingston','Livingston Parish',30.447117,-90.751078),('70755','LA','Livonia','Pointe Coupee Parish',30.568456,-91.544264),('70756','LA','Lottie','Pointe Coupee Parish',30.549564,-91.615711),('70757','LA','Maringouin','Iberville Parish',30.484971,-91.509499),('70759','LA','Morganza','Pointe Coupee Parish',30.720795,-91.593442),('70760','LA','New Roads','Pointe Coupee Parish',30.699871,-91.445372),('70761','LA','Norwood','East Feliciana Parish',30.973472,-91.061612),('70762','LA','Oscar','Pointe Coupee Parish',30.581097,-91.471388),('70763','LA','Paulina','St. James Parish',30.038963,-90.741111),('70764','LA','Plaquemine','Iberville Parish',30.265735,-91.248131),('70765','LA','Plaquemine','Iberville',30.2048,-91.3534),('70767','LA','Port Allen','West Baton Rouge Parish',30.473587,-91.26955),('70769','LA','Prairieville','Ascension Parish',30.310808,-90.943589),('70770','LA','Pride','East Baton Rouge Parish',30.639971,-91.006819),('70772','LA','Rosedale','Iberville Parish',30.437146,-91.469224),('70773','LA','Rougon','Pointe Coupee Parish',30.610268,-91.363185),('70774','LA','Saint Amant','Ascension Parish',30.217018,-90.820347),('70775','LA','Saint Francisville','West Feliciana Parish',30.859767,-91.370703),('70776','LA','Saint Gabriel','Iberville Parish',30.268087,-91.100579),('70777','LA','Slaughter','East Feliciana Parish',30.719938,-91.094021),('70778','LA','Sorrento','Ascension Parish',30.167558,-90.856448),('70780','LA','Sunshine','Iberville Parish',30.302637,-91.143552),('70782','LA','Tunica','West Feliciana Parish',30.950346,-91.538615),('70783','LA','Ventress','Pointe Coupee Parish',30.682414,-91.413639),('70784','LA','Wakefield','West Feliciana',30.9477,-91.3468),('70785','LA','Walker','Livingston Parish',30.5269,-90.840068),('70786','LA','Watson','Livingston',30.5755,-90.953),('70787','LA','Weyanoke','West Feliciana Parish',30.972714,-91.458041),('70788','LA','White Castle','Iberville Parish',30.156845,-91.152258),('70789','LA','Wilson','East Feliciana Parish',30.922775,-91.105805),('70791','LA','Zachary','East Baton Rouge Parish',30.652489,-91.151529),('70792','LA','Uncle Sam','Saint James',30.0207,-90.7799),('70801','LA','Baton Rouge','East Baton Rouge Parish',30.449899,-91.186472),('70802','LA','Baton Rouge','East Baton Rouge Parish',30.4477,-91.173062),('70803','LA','Baton Rouge','East Baton Rouge Parish',30.414537,-91.177176),('70804','LA','Baton Rouge','East Baton Rouge',30.4505,-91.1544),('70805','LA','Baton Rouge','East Baton Rouge Parish',30.486846,-91.155202),('70806','LA','Baton Rouge','East Baton Rouge Parish',30.447559,-91.134221),('70807','LA','Baton Rouge','East Baton Rouge Parish',30.533271,-91.178902),('70808','LA','Baton Rouge','East Baton Rouge Parish',30.41221,-91.146996),('70809','LA','Baton Rouge','East Baton Rouge Parish',30.403191,-91.079638),('70810','LA','Baton Rouge','East Baton Rouge Parish',30.359781,-91.087665),('70811','LA','Baton Rouge','East Baton Rouge Parish',30.530497,-91.130117),('70812','LA','Baton Rouge','East Baton Rouge Parish',30.505764,-91.118532),('70813','LA','Baton Rouge','East Baton Rouge',30.524685,-91.190872),('70814','LA','Baton Rouge','East Baton Rouge Parish',30.486731,-91.065824),('70815','LA','Baton Rouge','East Baton Rouge Parish',30.453985,-91.065446),('70816','LA','Baton Rouge','East Baton Rouge Parish',30.426247,-91.038668),('70817','LA','Baton Rouge','East Baton Rouge Parish',30.387761,-91.006163),('70818','LA','Baton Rouge','East Baton Rouge Parish',30.537706,-91.048584),('70819','LA','Baton Rouge','East Baton Rouge Parish',30.465528,-91.016948),('70820','LA','Baton Rouge','East Baton Rouge Parish',30.381173,-91.172607),('70821','LA','Baton Rouge','East Baton Rouge',30.4494,-91.1827),('70822','LA','Baton Rouge','East Baton Rouge',30.4494,-91.1827),('70823','LA','Baton Rouge','East Baton Rouge',30.4494,-91.1827),('70825','LA','Baton Rouge','East Baton Rouge',30.4484,-91.1832),('70826','LA','Baton Rouge','East Baton Rouge',30.3979,-91.0768),('70827','LA','Baton Rouge','East Baton Rouge',30.4505,-91.1544),('70831','LA','Baton Rouge','East Baton Rouge',30.4505,-91.1544),('70833','LA','Baton Rouge','East Baton Rouge',30.4494,-91.1827),('70835','LA','Baton Rouge','East Baton Rouge',30.4505,-91.1544),('70836','LA','Baton Rouge','East Baton Rouge',30.388292,-91.086316),('70837','LA','Baton Rouge','East Baton Rouge',30.5538,-91.0373),('70873','LA','Baton Rouge','East Baton Rouge',30.5305,-91.1163),('70874','LA','Baton Rouge','East Baton Rouge',30.5211,-91.1451),('70879','LA','Baton Rouge','East Baton Rouge',30.3733,-90.9815),('70883','LA','Baton Rouge','East Baton Rouge',30.4494,-91.1827),('70884','LA','Baton Rouge','East Baton Rouge',30.3786,-91.0974),('70891','LA','Baton Rouge','East Baton Rouge',30.4492,-91.1547),('70892','LA','Baton Rouge','East Baton Rouge',30.4965,-91.1575),('70893','LA','Baton Rouge','East Baton Rouge',30.4505,-91.1544),('70894','LA','Baton Rouge','East Baton Rouge',30.4505,-91.1544),('70895','LA','Baton Rouge','East Baton Rouge',30.4534,-91.0767),('70896','LA','Baton Rouge','East Baton Rouge',30.444,-91.1434),('70898','LA','Baton Rouge','East Baton Rouge',30.4205,-91.1396),('71001','LA','Arcadia','Bienville Parish',32.567469,-92.917392),('71002','LA','Ashland','Natchitoches',32.129489,-93.082732),('71003','LA','Athens','Claiborne Parish',32.636196,-93.032274),('71004','LA','Belcher','Caddo Parish',32.767025,-93.879245),('71006','LA','Benton','Bossier Parish',32.69573,-93.704504),('71007','LA','Bethany','Caddo Parish',32.375487,-94.008313),('71008','LA','Bienville','Bienville Parish',32.333028,-92.959698),('71009','LA','Blanchard','Caddo',32.579853,-93.893174),('71016','LA','Castor','Bienville Parish',32.222006,-93.091924),('71018','LA','Cotton Valley','Webster Parish',32.810662,-93.412706),('71019','LA','Coushatta','Red River Parish',32.048755,-93.316966),('71021','LA','Cullen','Webster Parish',32.968783,-93.448288),('71023','LA','Doyline','Webster Parish',32.478642,-93.396796),('71024','LA','Dubberly','Webster Parish',32.502501,-93.223297),('71027','LA','Frierson','De Soto Parish',32.239102,-93.684998),('71028','LA','Gibsland','Bienville Parish',32.517489,-93.061966),('71029','LA','Gilliam','Caddo Parish',32.82663,-93.84189),('71030','LA','Gloster','De Soto Parish',32.187717,-93.813527),('71031','LA','Goldonna','Natchitoches Parish',32.001274,-92.920495),('71032','LA','Grand Cane','De Soto Parish',32.108789,-93.785504),('71033','LA','Greenwood','Caddo Parish',32.44458,-93.988733),('71034','LA','Hall Summit','Red River Parish',32.177023,-93.305105),('71037','LA','Haughton','Bossier Parish',32.540309,-93.538552),('71038','LA','Haynesville','Claiborne Parish',32.953873,-93.121943),('71039','LA','Heflin','Webster Parish',32.4395,-93.300248),('71040','LA','Homer','Claiborne Parish',32.777562,-93.033656),('71043','LA','Hosston','Caddo Parish',32.88608,-93.882689),('71044','LA','Ida','Caddo Parish',32.983823,-93.892616),('71045','LA','Jamestown','Bienville Parish',32.363538,-93.187164),('71046','LA','Keatchie','De Soto Parish',32.160756,-93.947045),('71047','LA','Keithville','Caddo Parish',32.326372,-93.868869),('71048','LA','Lisbon','Claiborne Parish',32.820625,-92.847314),('71049','LA','Logansport','De Soto Parish',31.982764,-93.978289),('71050','LA','Longstreet','De Soto',32.0975,-93.9519),('71051','LA','Elm Grove','Bossier Parish',32.348176,-93.513395),('71052','LA','Mansfield','De Soto Parish',32.021736,-93.662627),('71055','LA','Minden','Webster Parish',32.616587,-93.305679),('71058','LA','Minden','Webster',32.6152,-93.2866),('71060','LA','Mooringsport','Caddo Parish',32.677258,-93.965686),('71061','LA','Oil City','Caddo Parish',32.757333,-93.959361),('71063','LA','Pelican','De Soto Parish',31.915684,-93.484751),('71064','LA','Plain Dealing','Bossier Parish',32.915171,-93.689501),('71065','LA','Pleasant Hill','Sabine Parish',31.815179,-93.507646),('71066','LA','Powhatan','Natchitoches',31.874172,-93.197195),('71067','LA','Princeton','Bossier Parish',32.600224,-93.50464),('71068','LA','Ringgold','Bienville Parish',32.289414,-93.307238),('71069','LA','Rodessa','Caddo Parish',32.975042,-93.995552),('71070','LA','Saline','Natchitoches Parish',32.101917,-93.012875),('71071','LA','Sarepta','Webster Parish',32.923133,-93.452707),('71072','LA','Shongaloo','Webster Parish',32.94266,-93.316046),('71073','LA','Sibley','Webster Parish',32.540823,-93.309869),('71075','LA','Springhill','Webster Parish',32.995921,-93.463549),('71078','LA','Stonewall','De Soto Parish',32.278744,-93.804141),('71079','LA','Summerfield','Claiborne Parish',32.957142,-92.809241),('71080','LA','Taylor','Bienville',32.5455,-93.1191),('71082','LA','Vivian','Caddo Parish',32.840497,-93.974707),('71101','LA','Shreveport','Caddo Parish',32.505424,-93.748748),('71102','LA','Shreveport','Caddo',32.4881,-93.7677),('71103','LA','Shreveport','Caddo Parish',32.491976,-93.770516),('71104','LA','Shreveport','Caddo Parish',32.484386,-93.736685),('71105','LA','Shreveport','Caddo Parish',32.459782,-93.711953),('71106','LA','Shreveport','Caddo Parish',32.41876,-93.745184),('71107','LA','Shreveport','Caddo Parish',32.569776,-93.829745),('71108','LA','Shreveport','Caddo Parish',32.449107,-93.781074),('71109','LA','Shreveport','Caddo Parish',32.472722,-93.802311),('71110','LA','Barksdale Afb','Bossier Parish',32.502175,-93.650931),('71111','LA','Bossier City','Bossier Parish',32.557123,-93.703555),('71112','LA','Bossier City','Bossier Parish',32.477212,-93.67029),('71113','LA','Bossier City','Bossier',32.4654,-93.6662),('71115','LA','Shreveport','Caddo Parish',32.356839,-93.636667),('71118','LA','Shreveport','Caddo Parish',32.39861,-93.804297),('71119','LA','Shreveport','Caddo Parish',32.481537,-93.886955),('71120','LA','Shreveport','Caddo',32.5127,-93.7468),('71129','LA','Shreveport','Caddo Parish',32.418441,-93.886219),('71130','LA','Shreveport','Caddo',32.4881,-93.7677),('71133','LA','Shreveport','Caddo',32.4881,-93.7677),('71134','LA','Shreveport','Caddo',32.4814,-93.7367),('71135','LA','Shreveport','Caddo',32.4431,-93.7098),('71136','LA','Shreveport','Caddo',32.4222,-93.7587),('71137','LA','Shreveport','Caddo',32.5935,-93.8539),('71138','LA','Shreveport','Caddo',32.4081,-93.7979),('71148','LA','Shreveport','Caddo',32.456,-93.7777),('71149','LA','Shreveport','Caddo',32.525,-93.75),('71150','LA','Shreveport','Caddo',32.5056,-93.7434),('71151','LA','Shreveport','Caddo',32.525,-93.75),('71152','LA','Shreveport','Caddo',32.4405,-93.7886),('71153','LA','Shreveport','Caddo',32.525,-93.75),('71154','LA','Shreveport','Caddo',32.525,-93.75),('71156','LA','Shreveport','Caddo',32.525,-93.75),('71161','LA','Shreveport','Caddo',32.5127,-93.7468),('71162','LA','Shreveport','Caddo',32.525,-93.75),('71163','LA','Shreveport','Caddo',32.525,-93.75),('71164','LA','Shreveport','Caddo',32.5127,-93.7468),('71165','LA','Shreveport','Caddo',32.5127,-93.7468),('71166','LA','Shreveport','Caddo',32.525,-93.75),('71171','LA','Bossier City','Bossier',32.5783,-93.6899),('71172','LA','Bossier City','Bossier',32.5158,-93.7319),('71201','LA','Monroe','Ouachita Parish',32.522545,-92.106558),('71202','LA','Monroe','Ouachita Parish',32.455349,-92.088215),('71203','LA','Monroe','Ouachita Parish',32.560562,-92.046314),('71207','LA','Monroe','Ouachita',32.5148,-92.116),('71208','LA','Monroe','Ouachita',32.4967,-92.0756),('71209','LA','Monroe','Ouachita Parish',32.528999,-92.069586),('71210','LA','Monroe','Ouachita',32.5006,-92.1146),('71211','LA','Monroe','Ouachita',32.5985,-92.0179),('71212','LA','Monroe','Ouachita',32.509757,-92.119145),('71213','LA','Monroe','Ouachita',32.5259,-92.0811),('71217','LA','Monroe','Ouachita',32.5116,-92.0849),('71218','LA','Archibald','Richland',32.350427,-91.772208),('71219','LA','Baskin','Franklin Parish',32.292935,-91.718114),('71220','LA','Bastrop','Morehouse Parish',32.813491,-91.906303),('71221','LA','Bastrop','Morehouse',32.8732,-91.9151),('71222','LA','Bernice','Union Parish',32.829191,-92.662467),('71223','LA','Bonita','Morehouse Parish',32.91364,-91.679452),('71225','LA','Calhoun','Ouachita Parish',32.515251,-92.341042),('71226','LA','Chatham','Jackson Parish',32.263446,-92.441923),('71227','LA','Choudrant','Lincoln Parish',32.525164,-92.489775),('71229','LA','Collinston','Morehouse Parish',32.6637,-91.895226),('71230','LA','Crowville','Franklin',32.2405,-91.59),('71232','LA','Delhi','Richland Parish',32.434611,-91.498062),('71233','LA','Delta','Madison Parish',32.32276,-90.931249),('71234','LA','Downsville','Union Parish',32.638677,-92.356404),('71235','LA','Dubach','Lincoln Parish',32.679979,-92.675752),('71237','LA','Epps','West Carroll Parish',32.596355,-91.48726),('71238','LA','Eros','Ouachita Parish',32.381193,-92.387652),('71240','LA','Fairbanks','Ouachita',32.6441,-92.0363),('71241','LA','Farmerville','Union Parish',32.765821,-92.362591),('71242','LA','Forest','West Carroll',32.7919,-91.4133),('71243','LA','Fort Necessity','Franklin Parish',31.941051,-91.800065),('71245','LA','Grambling','Lincoln Parish',32.527582,-92.719229),('71247','LA','Hodge','Jackson Parish',32.273656,-92.722016),('71249','LA','Jigger','Franklin',32.0347,-91.7466),('71250','LA','Jones','Morehouse Parish',32.969466,-91.599931),('71251','LA','Jonesboro','Jackson Parish',32.231862,-92.690239),('71253','LA','Kilbourne','West Carroll Parish',32.99526,-91.31571),('71254','LA','Lake Providence','East Carroll Parish',32.791474,-91.229652),('71256','LA','Lillie','Union Parish',32.947661,-92.696384),('71259','LA','Mangham','Richland Parish',32.285513,-91.814941),('71260','LA','Marion','Union Parish',32.884181,-92.23008),('71261','LA','Mer Rouge','Morehouse Parish',32.778125,-91.740424),('71263','LA','Oak Grove','West Carroll Parish',32.882663,-91.412158),('71264','LA','Oak Ridge','Richland Parish',32.591776,-91.775224),('71266','LA','Pioneer','West Carroll Parish',32.686512,-91.471262),('71268','LA','Quitman','Jackson Parish',32.328587,-92.726812),('71269','LA','Rayville','Richland Parish',32.452516,-91.772152),('71270','LA','Ruston','Lincoln Parish',32.525266,-92.640332),('71272','LA','Ruston','Lincoln Parish',32.525469,-92.647878),('71273','LA','Ruston','Lincoln',32.5328,-92.6389),('71275','LA','Simsboro','Lincoln Parish',32.511899,-92.816833),('71276','LA','Sondheimer','East Carroll Parish',32.572201,-91.155631),('71277','LA','Spearsville','Union Parish',32.9434,-92.572652),('71279','LA','Start','Richland Parish',32.48692,-91.859262),('71280','LA','Sterlington','Ouachita Parish',32.70766,-92.07405),('71281','LA','Swartz','Ouachita',32.5686,-91.985),('71282','LA','Tallulah','Madison Parish',32.382227,-91.156959),('71284','LA','Tallulah','Madison',32.4109,-91.185),('71286','LA','Transylvania','East Carroll Parish',32.659217,-91.199406),('71291','LA','West Monroe','Ouachita Parish',32.530054,-92.165973),('71292','LA','West Monroe','Ouachita Parish',32.455617,-92.186713),('71294','LA','West Monroe','Ouachita',32.3905,-92.2075),('71295','LA','Winnsboro','Franklin Parish',32.141302,-91.735622),('71301','LA','Alexandria','Rapides Parish',31.294663,-92.460233),('71302','LA','Alexandria','Rapides Parish',31.258197,-92.422078),('71303','LA','Alexandria','Rapides Parish',31.301651,-92.502858),('71306','LA','Alexandria','Rapides',31.2524,-92.4753),('71307','LA','Alexandria','Rapides',31.2856,-92.4507),('71309','LA','Alexandria','Rapides',31.2524,-92.4753),('71315','LA','Alexandria','Rapides',31.2524,-92.4753),('71316','LA','Acme','Concordia Parish',31.267342,-91.790082),('71320','LA','Bordelonville','Avoyelles',31.1741,-91.725012),('71322','LA','Bunkie','Avoyelles Parish',30.902661,-92.173685),('71323','LA','Center Point','Avoyelles Parish',31.23887,-92.207111),('71324','LA','Chase','Franklin',32.0969,-91.6988),('71325','LA','Cheneyville','Rapides Parish',30.994777,-92.325893),('71326','LA','Clayton','Concordia Parish',31.757866,-91.567046),('71327','LA','Cottonport','Avoyelles Parish',30.989772,-92.043557),('71328','LA','Deville','Rapides Parish',31.35648,-92.164354),('71329','LA','Dupont','Avoyelles',30.9291,-91.9477),('71330','LA','Echo','Rapides',31.110171,-92.236574),('71331','LA','Effie','Avoyelles Parish',31.267158,-92.077965),('71333','LA','Evergreen','Avoyelles Parish',30.92992,-92.089579),('71334','LA','Ferriday','Concordia Parish',31.650688,-91.552127),('71336','LA','Gilbert','Franklin Parish',32.029192,-91.620098),('71339','LA','Hamburg','Avoyelles Parish',31.023845,-91.929026),('71340','LA','Harrisonburg','Catahoula Parish',31.766634,-91.8164),('71341','LA','Hessmer','Avoyelles Parish',31.056714,-92.155585),('71342','LA','Jena','La Salle Parish',31.653344,-92.128872),('71343','LA','Jonesville','Catahoula Parish',31.5555,-91.885837),('71345','LA','Lebeau','St. Landry Parish',30.730517,-91.975819),('71346','LA','Lecompte','Rapides Parish',31.119627,-92.405739),('71348','LA','Libuse','Rapides',31.3538,-92.3333),('71350','LA','Mansura','Avoyelles Parish',31.070687,-92.056391),('71351','LA','Marksville','Avoyelles Parish',31.146318,-92.053769),('71353','LA','Melville','St. Landry Parish',30.699638,-91.766421),('71354','LA','Monterey','Concordia Parish',31.42976,-91.755799),('71355','LA','Moreauville','Avoyelles Parish',31.078807,-91.91226),('71356','LA','Morrow','St. Landry Parish',30.817981,-92.056424),('71357','LA','Newellton','Tensas Parish',32.10455,-91.267252),('71358','LA','Palmetto','St. Landry Parish',30.703728,-91.891188),('71359','LA','Pineville','Rapides',31.3238,-92.4246),('71360','LA','Pineville','Rapides Parish',31.342682,-92.390729),('71361','LA','Pineville','Rapides',31.3324,-92.4085),('71362','LA','Plaucheville','Avoyelles Parish',30.936603,-91.968367),('71363','LA','Rhinehart','Catahoula',31.6361,-92.0012),('71365','LA','Ruby','Rapides',31.3312,-92.232),('71366','LA','Saint Joseph','Tensas Parish',31.940102,-91.316941),('71367','LA','Saint Landry','Evangeline Parish',30.893014,-92.283189),('71368','LA','Sicily Island','Catahoula Parish',31.858821,-91.674729),('71369','LA','Simmesport','Avoyelles Parish',30.960973,-91.843288),('71371','LA','Trout','La Salle Parish',31.692657,-92.239613),('71373','LA','Vidalia','Concordia Parish',31.47629,-91.532561),('71375','LA','Waterproof','Tensas Parish',31.832873,-91.442273),('71377','LA','Wildsville','Concordia Parish',31.615983,-91.788504),('71378','LA','Wisner','Franklin Parish',31.94526,-91.714692),('71401','LA','Aimwell','Catahoula',31.769334,-91.979983),('71403','LA','Anacoco','Vernon Parish',31.214324,-93.406999),('71404','LA','Atlanta','Winn Parish',31.747006,-92.751585),('71405','LA','Ball','Rapides Parish',31.402637,-92.403099),('71406','LA','Belmont','Sabine Parish',31.735342,-93.503055),('71407','LA','Bentley','Grant Parish',31.514649,-92.491473),('71409','LA','Boyce','Rapides Parish',31.33242,-92.672563),('71410','LA','Calvin','Winn Parish',31.964535,-92.772834),('71411','LA','Campti','Natchitoches Parish',31.898569,-93.074881),('71414','LA','Clarence','Natchitoches Parish',31.825376,-93.023452),('71415','LA','Clarks','Caldwell',32.026445,-92.139516),('71416','LA','Cloutierville','Natchitoches Parish',31.544014,-92.896992),('71417','LA','Colfax','Grant Parish',31.526413,-92.678164),('71418','LA','Columbia','Caldwell Parish',32.153925,-92.06672),('71419','LA','Converse','Sabine Parish',31.786598,-93.725401),('71422','LA','Dodson','Winn Parish',32.074936,-92.649071),('71423','LA','Dry Prong','Grant Parish',31.564592,-92.544307),('71424','LA','Elmer','Rapides Parish',31.169869,-92.677403),('71425','LA','Enterprise','Catahoula Parish',31.899528,-91.910314),('71426','LA','Fisher','Sabine Parish',31.494487,-93.463693),('71427','LA','Flatwoods','Rapides Parish',31.385079,-92.892675),('71428','LA','Flora','Natchitoches',31.6122,-93.0975),('71429','LA','Florien','Sabine Parish',31.395333,-93.446491),('71430','LA','Forest Hill','Rapides Parish',31.051735,-92.509495),('71431','LA','Gardner','Rapides',31.2694,-92.6927),('71432','LA','Georgetown','Grant Parish',31.760845,-92.419247),('71433','LA','Glenmora','Rapides Parish',31.00183,-92.618844),('71434','LA','Gorum','Natchitoches',31.440908,-92.947247),('71435','LA','Grayson','Caldwell Parish',32.031741,-92.166355),('71438','LA','Hineston','Rapides Parish',31.095318,-92.844994),('71439','LA','Hornbeck','Vernon Parish',31.33328,-93.389433),('71440','LA','Joyce','Winn',31.9391,-92.5986),('71441','LA','Kelly','Caldwell Parish',31.952146,-92.132345),('71443','LA','Kurthwood','Vernon',31.3372,-93.1655),('71446','LA','Leesville','Vernon Parish',31.142744,-93.210996),('71447','LA','Lena','Rapides Parish',31.463925,-92.798993),('71448','LA','Longleaf','Rapides',31.0063,-92.5525),('71449','LA','Many','Sabine Parish',31.532364,-93.531551),('71450','LA','Marthaville','Natchitoches Parish',31.765404,-93.416898),('71452','LA','Melrose','Natchitoches Parish',31.605275,-92.962586),('71454','LA','Montgomery','Grant Parish',31.677341,-92.853995),('71455','LA','Mora','Rapides Parish',31.394002,-92.954115),('71456','LA','Natchez','Natchitoches Parish',31.651155,-93.002157),('71457','LA','Natchitoches','Natchitoches Parish',31.752763,-93.080848),('71458','LA','Natchitoches','Natchitoches',31.7605,-93.0861),('71459','LA','Fort Pol','Vernon Parish',31.063578,-93.214786),('71460','LA','Negreet','Sabine',31.4691,-93.5747),('71461','LA','Newllano','Vernon Parish',31.114714,-93.27985),('71462','LA','Noble','Sabine Parish',31.668997,-93.706911),('71463','LA','Oakdale','Allen Parish',30.811623,-92.646989),('71465','LA','Olla','La Salle Parish',31.86184,-92.192978),('71466','LA','Otis','Rapides Parish',31.220869,-92.732515),('71467','LA','Pollock','Grant Parish',31.535367,-92.398114),('71468','LA','Provencal','Natchitoches Parish',31.485196,-93.15928),('71469','LA','Robeline','Natchitoches Parish',31.694472,-93.270631),('71471','LA','Saint Maurice','Winn',31.7594,-92.9588),('71472','LA','Sieper','Rapides Parish',31.208877,-92.805784),('71473','LA','Sikes','Winn Parish',32.068991,-92.429771),('71474','LA','Simpson','Vernon Parish',31.260842,-93.01075),('71475','LA','Slagle','Vernon',31.2022,-93.1272),('71477','LA','Tioga','Rapides',31.4147,-92.4694),('71479','LA','Tullos','La Salle Parish',31.829234,-92.340531),('71480','LA','Urania','La Salle Parish',31.862145,-92.294952),('71483','LA','Winnfield','Winn Parish',31.914352,-92.634914),('71485','LA','Woodworth','Rapides Parish',31.161548,-92.508962),('71486','LA','Zwolle','Sabine Parish',31.611469,-93.646057),('71496','LA','Leesville','Vernon',31.1433,-93.2608),('71497','LA','Natchitoches','Natchitoches',31.7605,-93.0861),('71601','AR','Pine Bluff','Jefferson',34.216015,-91.981136),('71602','AR','White Hall','Jefferson',34.269298,-92.090086),('71603','AR','Pine Bluff','Jefferson',34.18759,-92.050221),('71611','AR','Pine Bluff','Jefferson',34.2212,-92.002),('71612','AR','White Hall','Jefferson',34.1375,-92.1046),('71613','AR','Pine Bluff','Jefferson',34.1375,-92.1046),('71630','AR','Arkansas City','Desha',33.611038,-91.206449),('71631','AR','Banks','Bradley',33.579473,-92.263426),('71635','AR','Crossett','Ashley',33.133324,-91.975667),('71638','AR','Dermott','Chicot',33.522071,-91.462699),('71639','AR','Dumas','Desha',33.90073,-91.486486),('71640','AR','Eudora','Chicot',33.110539,-91.272515),('71642','AR','Fountain Hill','Ashley',33.378326,-91.877367),('71643','AR','Gould','Lincoln',34.008131,-91.562498),('71644','AR','Grady','Lincoln',34.098927,-91.681587),('71646','AR','Hamburg','Ashley',33.230827,-91.791146),('71647','AR','Hermitage','Bradley',33.383719,-92.148629),('71651','AR','Jersey','Bradley',33.3284,-92.293638),('71652','AR','Kingsland','Cleveland',33.916282,-92.331608),('71653','AR','Lake Village','Chicot',33.33807,-91.264781),('71654','AR','Mc Gehee','Desha',33.625431,-91.38706),('71655','AR','Monticello','Drew',33.626276,-91.767772),('71656','AR','Monticello','Drew',33.592575,-91.812379),('71657','AR','Monticello','Drew',33.5803,-91.7922),('71658','AR','Montrose','Ashley',33.319903,-91.55393),('71659','AR','Moscow','Jefferson',34.149515,-91.795084),('71660','AR','New Edinburg','Cleveland',33.757957,-92.196855),('71661','AR','Parkdale','Ashley',33.135525,-91.544723),('71662','AR','Pickens','Desha',33.841692,-91.485475),('71663','AR','Portland','Ashley',33.242351,-91.45242),('71665','AR','Rison','Cleveland',33.942147,-92.147401),('71666','AR','Mc Gehee','Desha',33.771653,-91.27538),('71667','AR','Star City','Lincoln',33.934582,-91.835392),('71670','AR','Tillar','Desha',33.737245,-91.425147),('71671','AR','Warren','Bradley',33.607098,-92.081187),('71674','AR','Watson','Desha',33.828911,-91.237869),('71675','AR','Wilmar','Drew',33.593526,-91.936722),('71676','AR','Wilmot','Ashley',33.052184,-91.567641),('71677','AR','Winchester','Drew',33.767967,-91.477924),('71678','AR','Yorktown','Lincoln',34.0241,-91.7846),('71701','AR','Camden','Ouachita',33.574937,-92.82428),('71711','AR','Camden','Calhoun',33.633161,-92.71658),('71720','AR','Bearden','Ouachita',33.729417,-92.648691),('71721','AR','Beirne','Clark',33.8886,-93.2038),('71722','AR','Bluff City','Nevada',33.725374,-93.141712),('71724','AR','Calion','Union',33.329321,-92.537413),('71725','AR','Carthage','Dallas',34.042918,-92.561247),('71726','AR','Chidester','Ouachita',33.68659,-93.019688),('71728','AR','Curtis','Clark',33.9977,-93.1055),('71730','AR','El Dorado','Union',33.214146,-92.647638),('71731','AR','El Dorado','Union',33.2075,-92.6661),('71740','AR','Emerson','Columbia',33.094488,-93.166585),('71742','AR','Fordyce','Dallas',33.83585,-92.433838),('71743','AR','Gurdon','Clark',33.91798,-93.139676),('71744','AR','Hampton','Calhoun',33.51899,-92.478714),('71745','AR','Harrell','Calhoun',33.507659,-92.400979),('71747','AR','Huttig','Union',33.055769,-92.177675),('71748','AR','Ivan','Dallas',33.9108,-92.4429),('71749','AR','Junction City','Union',33.073458,-92.788149),('71750','AR','Lawson','Union',33.1974,-92.4818),('71751','AR','Louann','Ouachita',33.400281,-92.762313),('71752','AR','Mc Neil','Columbia',33.371247,-93.182781),('71753','AR','Magnolia','Columbia',33.249482,-93.201998),('71754','AR','Magnolia','Columbia',33.2342,-93.2652),('71758','AR','Mount Holly','Union',33.305614,-92.916524),('71759','AR','Norphlet','Union',33.319723,-92.658204),('71762','AR','Smackover','Union',33.354269,-92.732288),('71763','AR','Sparkman','Dallas',33.922936,-92.792006),('71764','AR','Stephens','Ouachita',33.413865,-93.058551),('71765','AR','Strong','Union',33.128453,-92.352883),('71766','AR','Thornton','Calhoun',33.745328,-92.489655),('71768','AR','Urbana','Union',33.103,-92.493),('71770','AR','Waldo','Columbia',33.356631,-93.310077),('71772','AR','Whelen Springs','Clark',33.833045,-93.125732),('71801','AR','Hope','Hempstead',33.655048,-93.597611),('71802','AR','Hope','Hempstead',33.6683,-93.5882),('71820','AR','Alleene','Little River',33.78381,-94.284185),('71822','AR','Ashdown','Little River',33.671711,-94.134941),('71823','AR','Ben Lomond','Sevier',33.806117,-94.120221),('71825','AR','Blevins','Hempstead',33.87188,-93.569482),('71826','AR','Bradley','Lafayette',33.096171,-93.70361),('71827','AR','Buckner','Lafayette',33.405357,-93.424408),('71828','AR','Cale','Nevada',33.6192,-93.2635),('71831','AR','Columbus','Hempstead',33.7815,-93.8132),('71832','AR','De Queen','Sevier',34.036244,-94.338515),('71833','AR','Dierks','Howard',34.150823,-94.022978),('71834','AR','Doddridge','Miller',33.100095,-93.953623),('71835','AR','Emmet','Nevada',33.69067,-93.464584),('71836','AR','Foreman','Little River',33.729764,-94.392673),('71837','AR','Fouke','Miller',33.273358,-93.876034),('71838','AR','Fulton','Hempstead',33.643335,-93.804516),('71839','AR','Garland City','Miller',33.330344,-93.733999),('71840','AR','Genoa','Miller',33.3836,-93.9094),('71841','AR','Gillham','Sevier',34.169823,-94.316706),('71842','AR','Horatio','Sevier',33.914135,-94.305249),('71844','AR','Laneburg','Nevada',33.685,-93.3466),('71845','AR','Lewisville','Lafayette',33.34742,-93.611314),('71846','AR','Lockesburg','Sevier',33.948032,-94.149682),('71847','AR','Mc Caskill','Hempstead',33.91988,-93.636504),('71851','AR','Mineral Springs','Howard',33.859524,-93.935359),('71852','AR','Nashville','Howard',33.987019,-93.852928),('71853','AR','Ogden','Little River',33.581074,-94.015759),('71854','AR','Texarkana','Miller',33.436343,-93.987116),('71855','AR','Ozan','Hempstead',33.866028,-93.754132),('71857','AR','Prescott','Nevada',33.807815,-93.365983),('71858','AR','Rosston','Nevada',33.589657,-93.285356),('71859','AR','Saratoga','Hempstead',33.744921,-93.910876),('71860','AR','Stamps','Lafayette',33.342876,-93.494689),('71861','AR','Taylor','Columbia',33.100673,-93.499952),('71862','AR','Washington','Hempstead',33.761323,-93.712067),('71864','AR','Willisville','Nevada',33.4931,-93.2948),('71865','AR','Wilton','Little River',33.740739,-94.148932),('71866','AR','Winthrop','Little River',33.868736,-94.385065),('71901','AR','Hot Springs National Park','Garland',34.505892,-93.013682),('71902','AR','Hot Springs National Park','Garland',34.5036,-93.055),('71903','AR','Hot Springs National Park','Garland',34.5114,-93.0537),('71909','AR','Hot Springs Village','Garland',34.654441,-92.978663),('71910','AR','Hot Springs Village','Garland',34.6411,-93.0574),('71913','AR','Hot Springs National Park','Garland',34.47094,-93.091405),('71914','AR','Hot Springs National Park','Garland',34.5036,-93.055),('71920','AR','Alpine','Clark',34.2647,-93.4608),('71921','AR','Amity','Clark',34.250837,-93.405287),('71922','AR','Antoine','Pike',34.029116,-93.419859),('71923','AR','Arkadelphia','Clark',34.11426,-93.060346),('71929','AR','Bismarck','Hot Spring',34.298345,-93.163735),('71932','AR','Board Camp','Polk',34.5377,-94.0952),('71933','AR','Bonnerdale','Garland',34.412174,-93.399306),('71935','AR','Caddo Gap','Montgomery',34.378928,-93.710964),('71937','AR','Cove','Polk',34.405692,-94.383085),('71940','AR','Delight','Pike',34.027159,-93.508965),('71941','AR','Donaldson','Hot Spring',34.256639,-92.958582),('71942','AR','Friendship','Hot Spring',34.2169,-93.0047),('71943','AR','Glenwood','Pike',34.331462,-93.567236),('71944','AR','Grannis','Polk',34.248479,-94.322023),('71945','AR','Hatfield','Polk',34.482583,-94.358944),('71949','AR','Jessieville','Garland',34.689378,-93.209503),('71950','AR','Kirby','Pike',34.241776,-93.732646),('71951','AR','Hot Springs National Park','Garland',34.5036,-93.055),('71952','AR','Langley','Pike',34.293862,-93.838971),('71953','AR','Mena','Polk',34.588015,-94.209984),('71956','AR','Mountain Pine','Garland',34.587697,-93.153553),('71957','AR','Mount Ida','Montgomery',34.565024,-93.574701),('71958','AR','Murfreesboro','Pike',34.103557,-93.673908),('71959','AR','Newhope','Pike',34.245302,-93.921972),('71960','AR','Norman','Montgomery',34.465995,-93.708839),('71961','AR','Oden','Montgomery',34.589853,-93.833105),('71962','AR','Okolona','Clark',34.053708,-93.328995),('71964','AR','Pearcy','Garland',34.423599,-93.23224),('71965','AR','Pencil Bluff','Montgomery',34.65554,-93.726516),('71966','AR','Oden','Montgomery',34.6188,-93.7766),('71968','AR','Royal','Garland',34.52362,-93.267203),('71969','AR','Sims','Montgomery',34.658566,-93.641044),('71970','AR','Story','Montgomery',34.659459,-93.50897),('71971','AR','Umpire','Howard',34.299083,-94.03424),('71972','AR','Vandervoort','Polk',34.381299,-94.307054),('71973','AR','Wickes','Polk',34.302457,-94.333792),('71998','AR','Arkadelphia','Clark',34.125571,-93.055263),('71999','AR','Arkadelphia','Clark',34.126799,-93.057707),('72001','AR','Adona','Perry',35.058204,-92.885606),('72002','AR','Alexander','Saline',34.644746,-92.494166),('72003','AR','Almyra','Arkansas',34.386814,-91.404574),('72004','AR','Altheimer','Jefferson',34.278318,-91.802086),('72005','AR','Amagon','Jackson',35.553198,-91.084463),('72006','AR','Augusta','Woodruff',35.256514,-91.3506),('72007','AR','Austin','Lonoke',35.001906,-91.9832),('72010','AR','Bald Knob','White',35.327573,-91.551674),('72011','AR','Bauxite','Saline',34.532277,-92.487764),('72012','AR','Beebe','White',35.081464,-91.900767),('72013','AR','Bee Branch','Van Buren',35.466055,-92.3622),('72014','AR','Beedeville','Jackson',35.429668,-91.108748),('72015','AR','Benton','Saline',34.542724,-92.589449),('72016','AR','Bigelow','Perry',34.970307,-92.628547),('72017','AR','Biscoe','Prairie',34.861369,-91.406092),('72018','AR','Benton','Saline',34.5639,-92.588),('72019','AR','Benton','Saline',34.607967,-92.614625),('72020','AR','Bradford','White',35.455087,-91.453349),('72021','AR','Brinkley','Monroe',34.865938,-91.202286),('72022','AR','Bryant','Saline',34.612545,-92.492132),('72023','AR','Cabot','Lonoke',34.969199,-92.033226),('72024','AR','Carlisle','Lonoke',34.770002,-91.752274),('72025','AR','Casa','Perry',35.043941,-93.007316),('72026','AR','Casscoe','Arkansas',34.521226,-91.308235),('72027','AR','Center Ridge','Conway',35.363555,-92.595109),('72028','AR','Choctaw','Van Buren',35.5192,-92.4068),('72029','AR','Clarendon','Monroe',34.696557,-91.286515),('72030','AR','Cleveland','Conway',35.42709,-92.675901),('72031','AR','Clinton','Van Buren',35.594924,-92.481784),('72032','AR','Conway','Faulkner',35.082341,-92.394565),('72033','AR','Conway','Faulkner',35.0886,-92.4419),('72034','AR','Conway','Faulkner',35.072579,-92.472953),('72035','AR','Conway','Faulkner',35.077861,-92.458023),('72036','AR','Cotton Plant','Woodruff',35.003893,-91.252566),('72037','AR','Coy','Lonoke',34.536242,-91.864376),('72038','AR','Crocketts Bluff','Arkansas',34.437219,-91.232129),('72039','AR','Damascus','Faulkner',35.358783,-92.407387),('72040','AR','Des Arc','Prairie',34.976835,-91.523367),('72041','AR','De Valls Bluff','Prairie',34.755401,-91.473523),('72042','AR','De Witt','Arkansas',34.285099,-91.325784),('72043','AR','Diaz','Jackson',35.633263,-91.261873),('72044','AR','Edgemont','Cleburne',35.625828,-92.161819),('72045','AR','El Paso','White',35.141575,-92.075525),('72046','AR','England','Lonoke',34.549191,-91.953652),('72047','AR','Enola','Faulkner',35.214562,-92.210126),('72048','AR','Ethel','Arkansas',34.245755,-91.147488),('72051','AR','Fox','Stone',35.790041,-92.296245),('72052','AR','Garner','White',35.1394,-91.7864),('72053','AR','College Station','Pulaski',34.708292,-92.227644),('72055','AR','Gillett','Arkansas',34.11266,-91.371274),('72057','AR','Grapevine','Grant',34.1467,-92.31467),('72058','AR','Greenbrier','Faulkner',35.248596,-92.373958),('72059','AR','Gregory','Woodruff',35.130706,-91.344718),('72060','AR','Griffithville','White',35.090399,-91.603521),('72061','AR','Guy','Faulkner',35.318704,-92.310619),('72063','AR','Hattieville','Conway',35.310792,-92.767861),('72064','AR','Hazen','Prairie',34.7902,-91.584324),('72065','AR','Hensley','Saline',34.514027,-92.274324),('72066','AR','Hickory Plains','Prairie',34.9901,-91.746),('72067','AR','Higden','Cleburne',35.566911,-92.173429),('72068','AR','Higginson','White',35.195308,-91.713389),('72069','AR','Holly Grove','Monroe',34.553313,-91.137766),('72070','AR','Houston','Perry',35.022588,-92.71105),('72072','AR','Humnoke','Lonoke',34.521333,-91.746426),('72073','AR','Humphrey','Arkansas',34.402043,-91.662177),('72074','AR','Hunter','Woodruff',35.06709,-91.103174),('72075','AR','Jacksonport','Jackson',35.640464,-91.304124),('72076','AR','Jacksonville','Pulaski',34.882371,-92.124939),('72078','AR','Jacksonville','Pulaski',34.8676,-92.1221),('72079','AR','Jefferson','Jefferson',34.396959,-92.184518),('72080','AR','Jerusalem','Conway',35.501282,-92.82296),('72081','AR','Judsonia','White',35.306944,-91.650387),('72082','AR','Kensett','White',35.232803,-91.671898),('72083','AR','Keo','Lonoke',34.598666,-92.012654),('72084','AR','Leola','Grant',34.163036,-92.662471),('72085','AR','Letona','White',35.361953,-91.82837),('72086','AR','Lonoke','Lonoke',34.805242,-91.914304),('72087','AR','Lonsdale','Saline',34.598331,-92.831612),('72088','AR','Fairfield Bay','Van Buren',35.594981,-92.269751),('72089','AR','Bryant','Saline',34.5958,-92.4888),('72099','AR','Little Rock Air Force Base','Pulaski',34.899719,-92.140308),('72101','AR','Mc Crory','Woodruff',35.245353,-91.161531),('72102','AR','Mc Rae','White',35.12795,-91.82639),('72103','AR','Mabelvale','Saline',34.600051,-92.38561),('72104','AR','Malvern','Hot Spring',34.373626,-92.821153),('72105','AR','Jones Mill','Hot Spring',34.437118,-92.892789),('72106','AR','Mayflower','Faulkner',34.962371,-92.440355),('72107','AR','Menifee','Conway',35.147272,-92.548492),('72108','AR','Monroe','Monroe',34.711003,-91.127188),('72110','AR','Morrilton','Conway',35.157809,-92.757883),('72111','AR','Mount Vernon','Faulkner',35.225048,-92.124728),('72112','AR','Newport','Jackson',35.594123,-91.2442),('72113','AR','Maumelle','Pulaski',34.849429,-92.396596),('72114','AR','North Little Rock','Pulaski',34.765766,-92.26579),('72115','AR','North Little Rock','Pulaski',34.7789,-92.2694),('72116','AR','North Little Rock','Pulaski',34.799928,-92.246268),('72117','AR','North Little Rock','Pulaski',34.776477,-92.179334),('72118','AR','North Little Rock','Pulaski',34.814614,-92.300881),('72119','AR','North Little Rock','Pulaski',34.835324,-92.293056),('72120','AR','Sherwood','Pulaski',34.853214,-92.218647),('72121','AR','Pangburn','White',35.433067,-91.818965),('72122','AR','Paron','Saline',34.777208,-92.769434),('72123','AR','Patterson','Woodruff',35.257665,-91.235524),('72124','AR','North Little Rock','Pulaski',34.7789,-92.2694),('72125','AR','Perry','Perry',35.056363,-92.794632),('72126','AR','Perryville','Perry',34.948308,-92.890209),('72127','AR','Plumerville','Conway',35.157802,-92.611491),('72128','AR','Poyen','Grant',34.31141,-92.640646),('72129','AR','Prattsville','Grant',34.328855,-92.544695),('72130','AR','Prim','Cleburne',35.647479,-92.087081),('72131','AR','Quitman','Cleburne',35.415979,-92.189371),('72132','AR','Redfield','Jefferson',34.445464,-92.180333),('72133','AR','Reydell','Jefferson',34.165734,-91.571699),('72134','AR','Roe','Monroe',34.639437,-91.37858),('72135','AR','Roland','Pulaski',34.893239,-92.52928),('72136','AR','Romance','White',35.227038,-92.028545),('72137','AR','Rose Bud','White',35.335407,-92.043123),('72139','AR','Russell','White',35.36181,-91.508035),('72140','AR','Saint Charles','Arkansas',34.37668,-91.162888),('72141','AR','Scotland','Van Buren',35.524055,-92.665362),('72142','AR','Scott','Lonoke',34.688212,-92.077231),('72143','AR','Searcy','White',35.237434,-91.736344),('72145','AR','Searcy','White',35.2526,-91.7429),('72149','AR','Searcy','White',35.2486,-91.7278),('72150','AR','Sheridan','Grant',34.319545,-92.399198),('72152','AR','Sherrill','Jefferson',34.359096,-91.980035),('72153','AR','Shirley','Van Buren',35.61953,-92.325401),('72156','AR','Solgohachia','Conway',35.276022,-92.692882),('72157','AR','Springfield','Conway',35.27907,-92.559497),('72158','AR','Benton','Saline',34.5644,-92.5866),('72160','AR','Stuttgart','Arkansas',34.469183,-91.542751),('72164','AR','Sweet Home','Pulaski',34.6863,-92.2422),('72165','AR','Thida','Independence',35.57939,-91.465491),('72166','AR','Tichnor','Arkansas',34.058494,-91.233567),('72167','AR','Traskwood','Saline',34.436622,-92.660604),('72168','AR','Tucker','Jefferson',34.432302,-91.982333),('72169','AR','Tupelo','Jackson',35.393712,-91.229397),('72170','AR','Ulm','Prairie',34.577091,-91.448358),('72173','AR','Vilonia','Faulkner',35.095626,-92.216681),('72175','AR','Wabbaseka','Jefferson',34.353662,-91.783649),('72176','AR','Ward','Lonoke',35.006543,-91.905248),('72178','AR','West Point','White',35.2069,-91.6141),('72179','AR','Wilburn','Cleburne',35.501444,-91.870092),('72180','AR','Woodson','Pulaski',34.528857,-92.211758),('72181','AR','Wooster','Faulkner',35.15857,-92.429019),('72182','AR','Wright','Jefferson',34.4673,-92.0326),('72183','AR','Wrightsville','Pulaski',34.600398,-92.195136),('72189','AR','Mc Crory','Woodruff',35.2561,-91.2),('72190','AR','North Little Rock','Pulaski',34.7789,-92.2694),('72198','AR','North Little Rock','Pulaski',34.772,-92.2717),('72199','AR','North Little Rock','Pulaski',34.8707,-92.3002),('72201','AR','Little Rock','Pulaski',34.745635,-92.278183),('72202','AR','Little Rock','Pulaski',34.739983,-92.273772),('72203','AR','Little Rock','Pulaski',34.7463,-92.2894),('72204','AR','Little Rock','Pulaski',34.729657,-92.336886),('72205','AR','Little Rock','Pulaski',34.752933,-92.334119),('72206','AR','Little Rock','Pulaski',34.690827,-92.26276),('72207','AR','Little Rock','Pulaski',34.771248,-92.340847),('72209','AR','Little Rock','Pulaski',34.676379,-92.345074),('72210','AR','Little Rock','Pulaski',34.695639,-92.467104),('72211','AR','Little Rock','Pulaski',34.752785,-92.418673),('72212','AR','Little Rock','Pulaski',34.781846,-92.407037),('72214','AR','Little Rock','Pulaski',34.7463,-92.2894),('72215','AR','Little Rock','Pulaski',34.7463,-92.2894),('72216','AR','Little Rock','Pulaski',34.6537,-92.2489),('72217','AR','Little Rock','Pulaski',34.7463,-92.2894),('72219','AR','Little Rock','Pulaski',34.6803,-92.3452),('72221','AR','Little Rock','Pulaski',34.7463,-92.2894),('72222','AR','Little Rock','Pulaski',34.8025,-92.4398),('72223','AR','Little Rock','Pulaski',34.797047,-92.468177),('72225','AR','Little Rock','Pulaski',34.7463,-92.2894),('72227','AR','Little Rock','Pulaski',34.772467,-92.372445),('72231','AR','Little Rock','Pulaski',34.7463,-92.2894),('72260','AR','Little Rock','Pulaski',34.7476,-92.2814),('72295','AR','Little Rock','Pulaski',34.7463,-92.2894),('72301','AR','West Memphis','Crittenden',35.149592,-90.176361),('72303','AR','West Memphis','Crittenden',35.1463,-90.1844),('72310','AR','Armorel','Mississippi',35.8862,-89.7471),('72311','AR','Aubrey','Lee',34.720176,-90.898363),('72312','AR','Barton','Phillips',34.5978,-90.7968),('72313','AR','Bassett','Mississippi',35.4678,-90.215),('72315','AR','Blytheville','Mississippi',35.922129,-89.913344),('72316','AR','Blytheville','Mississippi',35.9272,-89.9188),('72319','AR','Gosnell','Mississippi',35.9272,-89.9188),('72320','AR','Brickeys','Lee',34.830216,-90.508385),('72321','AR','Burdette','Mississippi',35.814078,-89.941165),('72322','AR','Caldwell','St. Francis',35.065848,-90.815727),('72324','AR','Cherry Valley','Cross',35.393226,-90.770246),('72325','AR','Clarkedale','Crittenden',35.321149,-90.246468),('72326','AR','Colt','St. Francis',35.113201,-90.880258),('72327','AR','Crawfordsville','Crittenden',35.224003,-90.339841),('72328','AR','Crumrod','Phillips',34.090428,-90.984571),('72329','AR','Driver','Mississippi',35.620064,-89.994213),('72330','AR','Dyess','Mississippi',35.590913,-90.210692),('72331','AR','Earle','Crittenden',35.271567,-90.46172),('72332','AR','Edmondson','Crittenden',35.102532,-90.308497),('72333','AR','Elaine','Phillips',34.299592,-90.866266),('72335','AR','Forrest City','St. Francis',35.008093,-90.778886),('72336','AR','Forrest City','Saint Francis',35.0098,-90.7818),('72338','AR','Frenchmans Bayou','Mississippi',35.435338,-90.1122),('72339','AR','Gilmore','Crittenden',35.411774,-90.275283),('72340','AR','Goodwin','St. Francis',34.935379,-91.02737),('72341','AR','Haynes','Lee',34.891394,-90.78184),('72342','AR','Helena','Phillips',34.485986,-90.647772),('72346','AR','Heth','St. Francis',35.083986,-90.467319),('72347','AR','Hickory Ridge','Cross',35.381674,-90.992503),('72348','AR','Hughes','St. Francis',34.940769,-90.442368),('72350','AR','Joiner','Mississippi',35.506641,-90.138513),('72351','AR','Keiser','Mississippi',35.674452,-90.094909),('72352','AR','La Grange','Lee',34.6563,-90.7327),('72353','AR','Lambrook','Phillips',34.316764,-91.007304),('72354','AR','Lepanto','Poinsett',35.617145,-90.323638),('72355','AR','Lexa','Phillips',34.564196,-90.751844),('72358','AR','Luxora','Mississippi',35.776182,-89.895444),('72359','AR','Madison','St. Francis',35.013689,-90.723073),('72360','AR','Marianna','Lee',34.75671,-90.767247),('72364','AR','Marion','Crittenden',35.202521,-90.199396),('72365','AR','Marked Tree','Poinsett',35.524816,-90.429404),('72366','AR','Marvell','Phillips',34.535916,-90.936055),('72367','AR','Mellwood','Phillips',34.206718,-90.956241),('72368','AR','Moro','Lee',34.810402,-91.023371),('72369','AR','Oneida','Phillips',34.459854,-90.780224),('72370','AR','Osceola','Mississippi',35.694104,-90.034597),('72372','AR','Palestine','St. Francis',34.974694,-90.943585),('72373','AR','Parkin','Cross',35.278108,-90.575621),('72374','AR','Poplar Grove','Phillips',34.558368,-90.838019),('72376','AR','Proctor','Crittenden',35.102351,-90.318481),('72377','AR','Rivervale','Poinsett',35.676178,-90.34085),('72379','AR','Snow Lake','Desha',34.046849,-91.055998),('72383','AR','Turner','Phillips',34.498519,-91.051675),('72384','AR','Turrell','Crittenden',35.373782,-90.243898),('72386','AR','Tyronza','Poinsett',35.476305,-90.354246),('72387','AR','Vanndale','Cross',35.328336,-90.771343),('72389','AR','Wabash','Phillips',34.371479,-90.870993),('72390','AR','West Helena','Phillips',34.546222,-90.658662),('72391','AR','West Ridge','Mississippi',35.6174,-90.248),('72392','AR','Wheatley','St. Francis',34.930971,-91.102665),('72394','AR','Widener','St. Francis',35.051645,-90.63394),('72395','AR','Wilson','Mississippi',35.582533,-90.079719),('72396','AR','Wynne','Cross',35.229839,-90.802525),('72401','AR','Jonesboro','Craighead',35.847652,-90.685857),('72402','AR','Jonesboro','Craighead',35.8422,-90.7041),('72403','AR','Jonesboro','Craighead',35.8422,-90.7041),('72404','AR','Jonesboro','Craighead',35.787582,-90.734003),('72410','AR','Alicia','Lawrence',35.918834,-91.0778),('72411','AR','Bay','Craighead',35.746193,-90.570057),('72412','AR','Beech Grove','Greene',36.130088,-90.690592),('72413','AR','Biggers','Randolph',36.325768,-90.816501),('72414','AR','Black Oak','Craighead',35.824609,-90.374049),('72415','AR','Black Rock','Lawrence',36.123226,-91.152056),('72416','AR','Bono','Craighead',35.94306,-90.79102),('72417','AR','Brookland','Craighead',35.921816,-90.57412),('72419','AR','Caraway','Craighead',35.749509,-90.335827),('72421','AR','Cash','Craighead',35.797528,-90.967052),('72422','AR','Corning','Clay',36.418794,-90.570207),('72424','AR','Datto','Clay',36.391406,-90.729253),('72425','AR','Delaplaine','Greene',36.211031,-90.740099),('72426','AR','Dell','Mississippi',35.8587,-90.039692),('72427','AR','Egypt','Craighead',35.864499,-90.935723),('72428','AR','Etowah','Mississippi',35.735739,-90.222538),('72429','AR','Fisher','Poinsett',35.49267,-90.941744),('72430','AR','Greenway','Clay',36.341304,-90.192521),('72431','AR','Grubbs','Jackson',35.648921,-91.075997),('72432','AR','Harrisburg','Poinsett',35.556241,-90.712553),('72433','AR','Hoxie','Lawrence',36.045099,-91.003155),('72434','AR','Imboden','Lawrence',36.2105,-91.175969),('72435','AR','Knobel','Clay',36.315976,-90.583381),('72436','AR','Lafe','Greene',36.224737,-90.490281),('72437','AR','Lake City','Craighead',35.833584,-90.446824),('72438','AR','Leachville','Mississippi',35.93895,-90.238946),('72439','AR','Light','Greene',36.07,-90.7477),('72440','AR','Lynn','Lawrence',36.006633,-91.251996),('72441','AR','Mc Dougal','Clay',36.437556,-90.387758),('72442','AR','Manila','Mississippi',35.846526,-90.183067),('72443','AR','Marmaduke','Greene',36.179536,-90.4042),('72444','AR','Maynard','Randolph',36.429978,-90.876095),('72445','AR','Minturn','Lawrence',35.974586,-91.028896),('72447','AR','Monette','Craighead',35.923049,-90.332656),('72449','AR','O Kean','Randolph',36.168571,-90.814985),('72450','AR','Paragould','Greene',36.066505,-90.51123),('72451','AR','Paragould','Greene',36.0583,-90.5),('72453','AR','Peach Orchard','Clay',36.285413,-90.674365),('72454','AR','Piggott','Clay',36.395957,-90.196309),('72455','AR','Pocahontas','Randolph',36.29079,-91.004661),('72456','AR','Pollard','Clay',36.458934,-90.307581),('72457','AR','Portia','Lawrence',36.085981,-91.068021),('72458','AR','Powhatan','Lawrence',36.075995,-91.154119),('72459','AR','Ravenden','Lawrence',36.270449,-91.279117),('72460','AR','Ravenden Springs','Randolph',36.342489,-91.184552),('72461','AR','Rector','Clay',36.258395,-90.287667),('72462','AR','Reyno','Randolph',36.3642,-90.7581),('72464','AR','Saint Francis','Clay',36.455973,-90.143288),('72465','AR','Sedgwick','Lawrence',35.9776,-90.8615),('72466','AR','Smithville','Lawrence',36.052107,-91.328336),('72467','AR','State University','Craighead',35.842087,-90.676175),('72469','AR','Strawberry','Lawrence',35.953951,-91.307433),('72470','AR','Success','Clay',36.460303,-90.705097),('72471','AR','Swifton','Jackson',35.82865,-91.129761),('72472','AR','Trumann','Poinsett',35.611586,-90.527987),('72473','AR','Tuckerman','Jackson',35.727801,-91.198577),('72474','AR','Walcott','Greene',36.0433,-90.6711),('72475','AR','Waldenburg','Poinsett',35.564737,-90.932541),('72476','AR','Walnut Ridge','Lawrence',36.062547,-90.943437),('72478','AR','Warm Springs','Randolph',36.455065,-91.055701),('72479','AR','Weiner','Poinsett',35.629898,-90.893177),('72482','AR','Williford','Sharp',36.282532,-91.372578),('72501','AR','Batesville','Independence',35.77791,-91.638052),('72503','AR','Batesville','Independence',35.8273,-91.6428),('72512','AR','Horseshoe Bend','Izard',36.22625,-91.743584),('72513','AR','Ash Flat','Sharp',36.229503,-91.644018),('72515','AR','Bexar','Fulton',36.269824,-92.044599),('72517','AR','Brockwell','Izard',36.140979,-91.970824),('72519','AR','Calico Rock','Izard',36.153465,-92.164588),('72520','AR','Camp','Fulton',36.399369,-91.725626),('72521','AR','Cave City','Sharp',35.956644,-91.545305),('72522','AR','Charlotte','Independence',35.816223,-91.464671),('72523','AR','Concord','Cleburne',35.646974,-91.838888),('72524','AR','Cord','Independence',35.828336,-91.29796),('72525','AR','Cherokee Village','Sharp',36.302469,-91.597449),('72526','AR','Cushman','Independence',35.876069,-91.758178),('72527','AR','Desha','Independence',35.734627,-91.682326),('72528','AR','Dolph','Izard',36.236902,-92.140677),('72529','AR','Cherokee Village','Sharp',36.297914,-91.566511),('72530','AR','Drasco','Cleburne',35.59749,-91.969679),('72531','AR','Elizabeth','Fulton',36.317274,-92.15654),('72532','AR','Evening Shade','Sharp',36.085552,-91.611468),('72533','AR','Fifty Six','Stone',35.962908,-92.248508),('72534','AR','Floral','Independence',35.590319,-91.739175),('72536','AR','Franklin','Izard',36.165515,-91.774407),('72537','AR','Gamaliel','Baxter',36.421197,-92.243089),('72538','AR','Gepp','Fulton',36.426917,-92.112896),('72539','AR','Glencoe','Fulton',36.332486,-91.712249),('72540','AR','Guion','Izard',35.919476,-91.910964),('72542','AR','Hardy','Sharp',36.305091,-91.495171),('72543','AR','Heber Springs','Cleburne',35.486079,-92.030416),('72544','AR','Henderson','Baxter',36.388872,-92.203243),('72545','AR','Heber Springs','Cleburne',35.6265,-92.032),('72546','AR','Ida','Cleburne',35.576798,-91.935336),('72550','AR','Locust Grove','Independence',35.720387,-91.782081),('72553','AR','Magness','Independence',35.701816,-91.48158),('72554','AR','Mammoth Spring','Fulton',36.443562,-91.555142),('72555','AR','Marcella','Stone',35.763827,-91.878328),('72556','AR','Melbourne','Izard',36.045065,-91.934311),('72560','AR','Mountain View','Stone',35.871649,-92.106284),('72561','AR','Mount Pleasant','Izard',35.961467,-91.78448),('72562','AR','Newark','Independence',35.72066,-91.423571),('72564','AR','Oil Trough','Independence',35.62257,-91.453392),('72565','AR','Oxford','Izard',36.21782,-91.910698),('72566','AR','Pineville','Izard',36.219928,-92.093673),('72567','AR','Pleasant Grove','Stone',35.815202,-91.924692),('72568','AR','Pleasant Plains','Independence',35.568044,-91.621624),('72569','AR','Poughkeepsie','Sharp',36.098681,-91.452098),('72571','AR','Rosie','Independence',35.639598,-91.518237),('72572','AR','Saffell','Lawrence',35.903609,-91.284521),('72573','AR','Sage','Izard',36.067359,-91.800655),('72575','AR','Salado','Independence',35.7001,-91.5927),('72576','AR','Salem','Fulton',36.356183,-91.834735),('72577','AR','Sidney','Izard',36.018489,-91.707595),('72578','AR','Sturkie','Fulton',36.463259,-91.882008),('72579','AR','Sulphur Rock','Independence',35.786124,-91.47421),('72581','AR','Tumbling Shoals','Cleburne',35.544833,-91.992077),('72583','AR','Viola','Fulton',36.397118,-91.999004),('72584','AR','Violet Hill','Izard',36.141262,-91.85163),('72585','AR','Wideman','Izard',36.170455,-92.016988),('72587','AR','Wiseman','Izard',36.233906,-91.81663),('72601','AR','Harrison','Boone',36.237023,-93.094827),('72602','AR','Harrison','Boone',36.2297,-93.1075),('72611','AR','Alpena','Carroll',36.270824,-93.320837),('72613','AR','Beaver','Carroll',36.4736,-93.7672),('72615','AR','Bergman','Boone',36.3161,-93.0075),('72616','AR','Berryville','Carroll',36.350078,-93.563212),('72617','AR','Big Flat','Baxter',36.021108,-92.380994),('72619','AR','Bull Shoals','Marion',36.379005,-92.582619),('72623','AR','Clarkridge','Baxter',36.484334,-92.306999),('72624','AR','Compton','Newton',36.069518,-93.367164),('72626','AR','Cotter','Baxter',36.27727,-92.53054),('72628','AR','Deer','Newton',35.853472,-93.30037),('72629','AR','Dennard','Van Buren',35.730788,-92.559088),('72630','AR','Diamond City','Boone',36.466365,-92.92011),('72631','AR','Eureka Springs','Carroll',36.458155,-93.781059),('72632','AR','Eureka Springs','Carroll',36.392392,-93.747366),('72633','AR','Everton','Boone',36.130141,-92.89713),('72634','AR','Flippin','Marion',36.249888,-92.56144),('72635','AR','Gassville','Baxter',36.307358,-92.489358),('72636','AR','Gilbert','Searcy',35.989702,-92.716224),('72638','AR','Green Forest','Carroll',36.322765,-93.404544),('72639','AR','Harriet','Searcy',36.021866,-92.496667),('72640','AR','Hasty','Newton',36.001187,-93.062042),('72641','AR','Jasper','Newton',35.99703,-93.212398),('72642','AR','Lakeview','Baxter',36.375735,-92.540277),('72644','AR','Lead Hill','Boone',36.422398,-92.935688),('72645','AR','Leslie','Searcy',35.804138,-92.575385),('72648','AR','Marble Falls','Newton',36.078548,-93.151902),('72650','AR','Marshall','Searcy',35.889301,-92.672916),('72651','AR','Midway','Baxter',36.388396,-92.482359),('72653','AR','Mountain Home','Baxter',36.327554,-92.360128),('72654','AR','Mountain Home','Baxter',36.24,-92.378),('72655','AR','Mount Judea','Newton',35.939006,-93.001895),('72657','AR','Timbo','Stone',35.8965,-92.2515),('72658','AR','Norfork','Baxter',36.18493,-92.289659),('72659','AR','Norfork','Baxter',36.2094,-92.2841),('72660','AR','Oak Grove','Carroll',36.478937,-93.368844),('72661','AR','Oakland','Marion',36.454674,-92.602961),('72662','AR','Omaha','Boone',36.445349,-93.197011),('72663','AR','Onia','Stone',35.925711,-92.313654),('72666','AR','Parthenon','Newton',35.938889,-93.283576),('72668','AR','Peel','Marion',36.442399,-92.752627),('72669','AR','Pindall','Searcy',36.06481,-92.883203),('72670','AR','Ponca','Newton',35.953473,-93.400335),('72672','AR','Pyatt','Marion',36.257012,-92.841111),('72675','AR','Saint Joe','Searcy',36.005114,-92.773907),('72677','AR','Summit','Marion',36.250271,-92.68889),('72679','AR','Tilly','Pope',35.721699,-92.825896),('72680','AR','Timbo','Stone',35.894508,-92.316723),('72682','AR','Valley Springs','Marion',36.13843,-92.73334),('72683','AR','Vendor','Newton',35.933733,-93.088676),('72685','AR','Western Grove','Newton',36.056313,-92.973075),('72686','AR','Witts Springs','Searcy',35.772885,-92.853996),('72687','AR','Yellville','Marion',36.253343,-92.716773),('72701','AR','Fayetteville','Washington',36.034724,-94.131056),('72702','AR','Fayetteville','Washington',35.9788,-94.0805),('72703','AR','Fayetteville','Washington',36.107067,-94.11612),('72704','AR','Fayetteville','Washington',36.096727,-94.244666),('72711','AR','Avoca','Benton',36.40137,-94.071068),('72712','AR','Bentonville','Benton',36.352228,-94.235118),('72714','AR','Bella Vista','Benton',36.465602,-94.208947),('72715','AR','Bella Vista','Benton',36.466618,-94.306242),('72716','AR','Bentonville','Benton',36.3228,-94.1838),('72717','AR','Canehill','Washington',35.856329,-94.430562),('72718','AR','Cave Springs','Benton',36.268458,-94.219446),('72719','AR','Centerton','Benton',36.364162,-94.289658),('72721','AR','Combs','Madison',35.812626,-93.802011),('72722','AR','Decatur','Benton',36.338324,-94.463504),('72727','AR','Elkins','Washington',35.963757,-93.96524),('72728','AR','Elm Springs','Washington',36.2061,-94.2341),('72729','AR','Evansville','Washington',35.795752,-94.470258),('72730','AR','Farmington','Washington',36.036859,-94.256007),('72732','AR','Garfield','Benton',36.425402,-93.948032),('72733','AR','Gateway','Benton',36.4843,-93.9369),('72734','AR','Gentry','Benton',36.264317,-94.455956),('72735','AR','Goshen','Washington',36.1089,-93.9861),('72736','AR','Gravette','Benton',36.405674,-94.4449),('72737','AR','Greenland','Washington',35.994,-94.1734),('72738','AR','Hindsville','Madison',36.1559,-93.886845),('72739','AR','Hiwasse','Benton',36.423559,-94.327701),('72740','AR','Huntsville','Madison',36.090893,-93.685705),('72741','AR','Johnson','Washington',36.1327,-94.1652),('72742','AR','Kingston','Madison',35.989571,-93.514905),('72744','AR','Lincoln','Washington',35.956522,-94.432102),('72745','AR','Lowell','Benton',36.252325,-94.123895),('72747','AR','Maysville','Benton',36.374466,-94.588282),('72749','AR','Morrow','Washington',35.868416,-94.437597),('72751','AR','Pea Ridge','Benton',36.45621,-94.121699),('72752','AR','Pettigrew','Madison',35.781092,-93.599983),('72753','AR','Prairie Grove','Washington',35.94552,-94.324804),('72756','AR','Rogers','Benton',36.340064,-94.074034),('72757','AR','Rogers','Benton',36.3332,-94.1245),('72758','AR','Rogers','Benton',36.306879,-94.153402),('72760','AR','Saint Paul','Madison',35.824187,-93.745405),('72761','AR','Siloam Springs','Benton',36.178726,-94.501885),('72762','AR','Springdale','Washington',36.187473,-94.203984),('72764','AR','Springdale','Washington',36.173462,-94.104275),('72765','AR','Springdale','Washington',36.1866,-94.1286),('72766','AR','Springdale','Washington',36.1866,-94.1286),('72768','AR','Sulphur Springs','Benton',36.485999,-94.469885),('72769','AR','Summers','Washington',36.035853,-94.495892),('72770','AR','Tontitown','Washington',36.1777,-94.2333),('72773','AR','Wesley','Madison',36.016269,-93.868912),('72774','AR','West Fork','Washington',35.89137,-94.207812),('72776','AR','Witter','Madison',35.914754,-93.654366),('72801','AR','Russellville','Pope',35.278776,-93.137942),('72802','AR','Russellville','Pope',35.314946,-93.102291),('72811','AR','Russellville','Pope',35.276,-93.1316),('72812','AR','Russellville','Pope',35.2896,-93.1088),('72820','AR','Alix','Franklin',35.415616,-93.733832),('72821','AR','Altus','Franklin',35.445279,-93.735528),('72823','AR','Atkins','Pope',35.255011,-92.926377),('72824','AR','Belleville','Yell',35.109616,-93.427227),('72826','AR','Blue Mountain','Logan',35.126399,-93.709267),('72827','AR','Bluffton','Yell',34.881594,-93.608929),('72828','AR','Briggsville','Yell',34.930718,-93.534997),('72829','AR','Centerville','Yell',35.110131,-93.172791),('72830','AR','Clarksville','Johnson',35.481654,-93.49471),('72832','AR','Coal Hill','Johnson',35.428333,-93.668624),('72833','AR','Danville','Yell',35.044838,-93.418012),('72834','AR','Dardanelle','Yell',35.186535,-93.17916),('72835','AR','Delaware','Logan',35.292,-93.331534),('72837','AR','Dover','Pope',35.445582,-93.105624),('72838','AR','Gravelly','Yell',34.896364,-93.679331),('72839','AR','Hagarville','Johnson',35.676461,-93.262871),('72840','AR','Hartman','Johnson',35.445886,-93.601759),('72841','AR','Harvey','Scott',34.850968,-93.760542),('72842','AR','Havana','Yell',35.109837,-93.57717),('72843','AR','Hector','Pope',35.523578,-92.944314),('72845','AR','Knoxville','Johnson',35.374795,-93.365188),('72846','AR','Lamar','Johnson',35.456864,-93.352835),('72847','AR','London','Pope',35.374416,-93.269824),('72851','AR','New Blaine','Logan',35.293286,-93.450398),('72852','AR','Oark','Johnson',35.683284,-93.573046),('72853','AR','Ola','Yell',35.025224,-93.213343),('72854','AR','Ozone','Johnson',35.696686,-93.428617),('72855','AR','Paris','Logan',35.285771,-93.723342),('72856','AR','Pelsor','Newton',35.76906,-93.057581),('72857','AR','Plainview','Yell',34.888506,-93.311615),('72858','AR','Pottsville','Pope',35.243349,-93.037987),('72860','AR','Rover','Yell',34.960347,-93.420413),('72863','AR','Scranton','Logan',35.373793,-93.521305),('72865','AR','Subiaco','Logan',35.311888,-93.604236),('72901','AR','Fort Smith','Sebastian',35.372849,-94.413701),('72902','AR','Fort Smith','Sebastian',35.3512,-94.3508),('72903','AR','Fort Smith','Sebastian',35.358407,-94.367368),('72904','AR','Fort Smith','Sebastian',35.404847,-94.38874),('72905','AR','Fort Smith','Sebastian',35.2118,-94.0407),('72906','AR','Fort Smith','Sebastian',35.332,-94.4001),('72908','AR','Fort Smith','Sebastian',35.305474,-94.412955),('72913','AR','Fort Smith','Sebastian',35.3339,-94.3753),('72914','AR','Fort Smith','Sebastian',35.3858,-94.3983),('72916','AR','Fort Smith','Sebastian',35.276405,-94.377644),('72917','AR','Fort Smith','Sebastian',35.3512,-94.3508),('72918','AR','Fort Smith','Sebastian',35.3511,-94.3509),('72919','AR','Fort Smith','Sebastian',35.3512,-94.3508),('72921','AR','Alma','Crawford',35.489967,-94.207848),('72923','AR','Barling','Sebastian',35.31509,-94.302757),('72926','AR','Boles','Scott',34.757356,-94.062026),('72927','AR','Booneville','Logan',35.096641,-93.951635),('72928','AR','Branch','Franklin',35.302473,-93.9286),('72930','AR','Cecil','Franklin',35.425267,-93.952921),('72932','AR','Cedarville','Crawford',35.590679,-94.366037),('72933','AR','Charleston','Franklin',35.328499,-94.013245),('72934','AR','Chester','Crawford',35.681578,-94.24017),('72935','AR','Dyer','Crawford',35.493112,-94.132259),('72936','AR','Greenwood','Sebastian',35.207129,-94.257912),('72937','AR','Hackett','Sebastian',35.159217,-94.389975),('72938','AR','Hartford','Sebastian',35.029258,-94.361273),('72940','AR','Huntington','Sebastian',35.097943,-94.269624),('72941','AR','Lavaca','Sebastian',35.348218,-94.170996),('72943','AR','Magazine','Logan',35.157283,-93.801971),('72944','AR','Mansfield','Sebastian',35.056935,-94.23396),('72945','AR','Midland','Sebastian',35.091644,-94.351401),('72946','AR','Mountainburg','Crawford',35.649633,-94.149528),('72947','AR','Mulberry','Crawford',35.539453,-94.032065),('72948','AR','Natural Dam','Crawford',35.722268,-94.408964),('72949','AR','Ozark','Franklin',35.526464,-93.819611),('72950','AR','Parks','Scott',34.793784,-93.901265),('72951','AR','Ratcliff','Logan',35.315462,-93.87833),('72952','AR','Rudy','Crawford',35.560152,-94.309637),('72955','AR','Uniontown','Crawford',35.607176,-94.455915),('72956','AR','Van Buren','Crawford',35.456885,-94.345585),('72957','AR','Van Buren','Crawford',35.4572,-94.31),('72958','AR','Waldron','Scott',34.903829,-94.137433),('72959','AR','Winslow','Washington',35.798039,-94.111865),('73001','OK','Albert','Caddo',35.2327,-98.4111),('73002','OK','Alex','Grady',34.937477,-97.744481),('73003','OK','Edmond','Oklahoma',35.662594,-97.497248),('73004','OK','Amber','Grady',35.145631,-97.86647),('73005','OK','Anadarko','Caddo',35.065772,-98.246097),('73006','OK','Apache','Caddo',34.898198,-98.369507),('73007','OK','Arcadia','Oklahoma',35.685355,-97.327459),('73008','OK','Bethany','Oklahoma',35.507443,-97.640075),('73009','OK','Binger','Caddo',35.282479,-98.356844),('73010','OK','Blanchard','Mcclain',35.126799,-97.67061),('73011','OK','Bradley','Grady',34.85239,-97.727363),('73012','OK','Edmond','Oklahoma',35.660693,-97.557992),('73013','OK','Edmond','Oklahoma',35.625003,-97.488481),('73014','OK','Calumet','Canadian',35.587534,-98.145189),('73015','OK','Carnegie','Caddo',35.102185,-98.594291),('73016','OK','Cashion','Kingfisher',35.796166,-97.686871),('73017','OK','Cement','Caddo',34.935392,-98.115256),('73018','OK','Chickasha','Grady',35.040545,-97.944822),('73019','OK','Norman','Cleveland',35.205661,-97.442738),('73020','OK','Choctaw','Oklahoma',35.464344,-97.265704),('73021','OK','Colony','Washita',35.349175,-98.66374),('73022','OK','Concho','Canadian',35.618487,-97.991884),('73023','OK','Chickasha','Grady',35.0499,-97.9411),('73024','OK','Corn','Washita',35.370371,-98.791617),('73025','OK','Edmond','Oklahoma',35.72143,-97.535255),('73026','OK','Norman','Cleveland',35.226728,-97.282118),('73027','OK','Coyle','Logan',35.958735,-97.254573),('73028','OK','Crescent','Logan',35.963794,-97.630885),('73029','OK','Cyril','Caddo',34.920292,-98.20726),('73030','OK','Davis','Murray',34.486581,-97.147597),('73031','OK','Dibble','Mcclain',35.027,-97.628019),('73032','OK','Dougherty','Murray',34.399722,-97.049791),('73033','OK','Eakly','Caddo',35.303201,-98.552395),('73034','OK','Edmond','Oklahoma',35.67864,-97.442497),('73036','OK','El Reno','Canadian',35.522906,-97.955432),('73038','OK','Fort Cobb','Caddo',35.144275,-98.452126),('73039','OK','Davis','Murray',34.506,-97.1131),('73040','OK','Geary','Blaine',35.628599,-98.327657),('73041','OK','Gotebo','Kiowa',35.063954,-98.869855),('73042','OK','Gracemont','Caddo',35.219704,-98.261784),('73043','OK','Greenfield','Blaine',35.729288,-98.385287),('73044','OK','Guthrie','Logan',35.857474,-97.426442),('73045','OK','Harrah','Oklahoma',35.493424,-97.160205),('73047','OK','Hinton','Caddo',35.471232,-98.332755),('73048','OK','Hydro','Caddo',35.49103,-98.561247),('73049','OK','Jones','Oklahoma',35.573049,-97.295875),('73050','OK','Langston','Logan',35.944327,-97.259398),('73051','OK','Lexington','Cleveland',35.040411,-97.291516),('73052','OK','Lindsay','Garvin',34.841097,-97.602997),('73053','OK','Lookeba','Caddo',35.355475,-98.413999),('73054','OK','Luther','Oklahoma',35.662665,-97.189625),('73055','OK','Marlow','Stephens',34.636072,-97.939894),('73056','OK','Marshall','Logan',36.162108,-97.637505),('73057','OK','Maysville','Garvin',34.820028,-97.415142),('73058','OK','Meridian','Logan',35.819955,-97.22974),('73059','OK','Minco','Grady',35.32706,-98.003914),('73061','OK','Morrison','Noble',36.320537,-97.011357),('73062','OK','Mountain View','Kiowa',35.084724,-98.747306),('73063','OK','Mulhall','Logan',36.054469,-97.409724),('73064','OK','Mustang','Canadian',35.385618,-97.733441),('73065','OK','Newcastle','Mcclain',35.258018,-97.605895),('73066','OK','Nicoma Park','Oklahoma',35.498947,-97.330093),('73067','OK','Ninnekah','Grady',34.909793,-97.925137),('73068','OK','Noble','Cleveland',35.138697,-97.326937),('73069','OK','Norman','Cleveland',35.2293,-97.459744),('73070','OK','Norman','Cleveland',35.2212,-97.4448),('73071','OK','Norman','Cleveland',35.221327,-97.420466),('73072','OK','Norman','Cleveland',35.210552,-97.483572),('73073','OK','Orlando','Logan',36.151395,-97.379333),('73074','OK','Paoli','Garvin',34.826316,-97.279715),('73075','OK','Pauls Valley','Garvin',34.738517,-97.228016),('73077','OK','Perry','Noble',36.293762,-97.276066),('73078','OK','Piedmont','Canadian',35.658005,-97.759255),('73079','OK','Pocasset','Grady',35.196487,-97.993753),('73080','OK','Purcell','Mcclain',35.018513,-97.396734),('73082','OK','Rush Springs','Grady',34.782966,-97.922393),('73083','OK','Edmond','Oklahoma',35.5193,-97.3362),('73084','OK','Spencer','Oklahoma',35.518414,-97.345193),('73085','OK','Yukon','Canadian',35.5066,-97.7622),('73086','OK','Sulphur','Murray',34.498637,-96.982991),('73089','OK','Tuttle','Grady',35.273525,-97.771808),('73090','OK','Union City','Canadian',35.394815,-97.935202),('73092','OK','Verden','Grady',35.109394,-98.099939),('73093','OK','Washington','Mcclain',35.089917,-97.485654),('73094','OK','Washita','Caddo',35.1027,-98.3405),('73095','OK','Wayne','Mcclain',34.913457,-97.316153),('73096','OK','Weatherford','Custer',35.527353,-98.70702),('73097','OK','Wheatland','Oklahoma',35.398371,-97.651949),('73098','OK','Wynnewood','Garvin',34.629246,-97.168384),('73099','OK','Yukon','Canadian',35.508416,-97.743313),('73101','OK','Oklahoma City','Oklahoma',35.473,-97.5177),('73102','OK','Oklahoma City','Oklahoma',35.470432,-97.51867),('73103','OK','Oklahoma City','Oklahoma',35.488589,-97.518184),('73104','OK','Oklahoma City','Oklahoma',35.475292,-97.504281),('73105','OK','Oklahoma City','Oklahoma',35.507769,-97.502161),('73106','OK','Oklahoma City','Oklahoma',35.482307,-97.534927),('73107','OK','Oklahoma City','Oklahoma',35.483658,-97.571249),('73108','OK','Oklahoma City','Oklahoma',35.446842,-97.561082),('73109','OK','Oklahoma City','Oklahoma',35.433749,-97.524867),('73110','OK','Oklahoma City','Oklahoma',35.460583,-97.398368),('73111','OK','Oklahoma City','Oklahoma',35.509482,-97.48222),('73112','OK','Oklahoma City','Oklahoma',35.518006,-97.572972),('73113','OK','Oklahoma City','Oklahoma',35.5657,-97.5175),('73114','OK','Oklahoma City','Oklahoma',35.570811,-97.524861),('73115','OK','Oklahoma City','Oklahoma',35.440775,-97.441747),('73116','OK','Oklahoma City','Oklahoma',35.542564,-97.553379),('73117','OK','Oklahoma City','Oklahoma',35.476525,-97.474158),('73118','OK','Oklahoma City','Oklahoma',35.516466,-97.530937),('73119','OK','Oklahoma City','Oklahoma',35.42317,-97.562164),('73120','OK','Oklahoma City','Oklahoma',35.578983,-97.565462),('73121','OK','Oklahoma City','Oklahoma',35.51264,-97.441129),('73122','OK','Oklahoma City','Oklahoma',35.516841,-97.613426),('73123','OK','Oklahoma City','Oklahoma',35.537,-97.6228),('73124','OK','Oklahoma City','Oklahoma',35.4597,-97.518),('73125','OK','Oklahoma City','Oklahoma',35.4597,-97.518),('73126','OK','Oklahoma City','Oklahoma',35.4597,-97.518),('73127','OK','Oklahoma City','Oklahoma',35.481315,-97.644191),('73128','OK','Oklahoma City','Canadian',35.454312,-97.635534),('73129','OK','Oklahoma City','Oklahoma',35.434395,-97.492496),('73130','OK','Oklahoma City','Oklahoma',35.458682,-97.351978),('73131','OK','Oklahoma City','Oklahoma',35.581842,-97.457458),('73132','OK','Oklahoma City','Oklahoma',35.552346,-97.641265),('73134','OK','Oklahoma City','Oklahoma',35.610403,-97.57494),('73135','OK','Oklahoma City','Oklahoma',35.400268,-97.433076),('73136','OK','Oklahoma City','Oklahoma',35.4946,-97.4778),('73137','OK','Oklahoma City','Oklahoma',35.4675,-97.5161),('73139','OK','Oklahoma City','Oklahoma',35.386377,-97.525689),('73140','OK','Oklahoma City','Oklahoma',35.4641,-97.3838),('73141','OK','Oklahoma City','Oklahoma',35.492772,-97.384695),('73142','OK','Oklahoma City','Oklahoma',35.605473,-97.634903),('73143','OK','Oklahoma City','Oklahoma',35.4675,-97.5161),('73144','OK','Oklahoma City','Oklahoma',35.4087,-97.5548),('73145','OK','Oklahoma City','Oklahoma',35.43372,-97.405854),('73146','OK','Oklahoma City','Oklahoma',35.4945,-97.53),('73147','OK','Oklahoma City','Oklahoma',35.4861,-97.5817),('73148','OK','Oklahoma City','Oklahoma',35.4546,-97.5543),('73149','OK','Oklahoma City','Oklahoma',35.393945,-97.495066),('73150','OK','Oklahoma City','Oklahoma',35.409433,-97.339037),('73151','OK','Oklahoma City','Oklahoma',35.57348,-97.408366),('73152','OK','Oklahoma City','Oklahoma',35.4933,-97.505),('73153','OK','Oklahoma City','Oklahoma',35.3337,-97.4922),('73154','OK','Oklahoma City','Oklahoma',35.5235,-97.5249),('73155','OK','Oklahoma City','Oklahoma',35.4203,-97.4376),('73156','OK','Oklahoma City','Oklahoma',35.5659,-97.5489),('73157','OK','Oklahoma City','Oklahoma',35.5109,-97.5658),('73159','OK','Oklahoma City','Oklahoma',35.386835,-97.558815),('73160','OK','Oklahoma City','Cleveland',35.338788,-97.48321),('73162','OK','Oklahoma City','Oklahoma',35.582011,-97.640928),('73163','OK','Oklahoma City','Oklahoma',35.4675,-97.5161),('73164','OK','Oklahoma City','Oklahoma',35.4597,-97.518),('73165','OK','Oklahoma City','Cleveland',35.339453,-97.365993),('73167','OK','Oklahoma City','Oklahoma',35.4675,-97.5161),('73169','OK','Oklahoma City','Oklahoma',35.387727,-97.641275),('73170','OK','Oklahoma City','Cleveland',35.336074,-97.539678),('73172','OK','Oklahoma City','Oklahoma',35.5797,-97.6449),('73173','OK','Oklahoma City','Cleveland',35.346604,-97.620193),('73178','OK','Oklahoma City','Oklahoma',35.5368,-97.565),('73179','OK','Oklahoma City','Oklahoma',35.421498,-97.641342),('73184','OK','Oklahoma City','Oklahoma',35.6166,-97.568),('73185','OK','Oklahoma City','Oklahoma',35.4675,-97.5161),('73189','OK','Oklahoma City','Oklahoma',35.3929,-97.579),('73190','OK','Oklahoma City','Oklahoma',35.4597,-97.518),('73193','OK','Oklahoma City','Oklahoma',35.4597,-97.518),('73194','OK','Oklahoma City','Oklahoma',35.5182,-97.5025),('73195','OK','Oklahoma City','Oklahoma',35.4678,-97.5164),('73196','OK','Oklahoma City','Oklahoma',35.4597,-97.518),('73197','OK','Oklahoma City','Oklahoma',35.4675,-97.5161),('73198','OK','Oklahoma City','Oklahoma',35.5277,-97.569),('73199','OK','Oklahoma City','Oklahoma',35.4597,-97.518),('73301','TX','Austin','Travis',30.2303,-97.7144),('73344','TX','Austin','Travis',30.1798,-97.729),('73401','OK','Ardmore','Carter',34.188535,-97.126018),('73402','OK','Ardmore','Carter',34.2588,-97.183),('73403','OK','Ardmore','Carter',34.2588,-97.183),('73425','OK','Countyline','Carter',34.447345,-97.561063),('73430','OK','Burneyville','Love',33.910881,-97.32844),('73432','OK','Coleman','Johnston',34.250153,-96.42668),('73433','OK','Elmore City','Garvin',34.62497,-97.399162),('73434','OK','Foster','Stephens',34.616044,-97.606792),('73435','OK','Fox','Carter',34.354547,-97.484303),('73436','OK','Gene Autry','Carter',34.2836,-97.0377),('73437','OK','Graham','Carter',34.379461,-97.422535),('73438','OK','Healdton','Carter',34.247397,-97.482994),('73439','OK','Kingston','Marshall',33.959923,-96.715109),('73440','OK','Lebanon','Marshall',33.98215,-96.909154),('73441','OK','Leon','Love',33.881836,-97.428668),('73442','OK','Loco','Stephens',34.326181,-97.661395),('73443','OK','Lone Grove','Carter',34.173,-97.290698),('73444','OK','Hennepin','Murray',34.475095,-97.361366),('73446','OK','Madill','Marshall',34.089652,-96.758412),('73447','OK','Mannsville','Johnston',34.223548,-96.860457),('73448','OK','Marietta','Love',33.93856,-97.109195),('73449','OK','Mead','Bryan',33.993257,-96.530981),('73450','OK','Milburn','Johnston',34.259877,-96.540289),('73451','OK','Ardmore','Carter',59.584833,16.233721),('73453','OK','Overbrook','Love',34.041675,-97.238508),('73454','OK','Ardmore','Carter',20.02795,-97.675713),('73455','OK','Ravia','Johnston',34.239374,-96.759437),('73456','OK','Ringling','Jefferson',34.144137,-97.611728),('73458','OK','Springer','Carter',34.326552,-97.201087),('73459','OK','Thackerville','Love',33.781,-97.134873),('73460','OK','Tishomingo','Johnston',34.257717,-96.674593),('73461','OK','Wapanucka','Johnston',34.356085,-96.433062),('73463','OK','Wilson','Carter',34.148625,-97.430687),('73481','OK','Ratliff City','Carter',34.452423,-97.517349),('73487','OK','Tatums','Carter',34.48316,-97.458181),('73488','OK','Tussy','Carter',34.4836,-97.547836),('73491','OK','Velma','Stephens',34.463023,-97.660635),('73501','OK','Lawton','Comanche',34.58401,-98.368817),('73502','OK','Lawton','Comanche',34.6086,-98.39),('73503','OK','Fort Sill','Comanche',34.671479,-98.440347),('73505','OK','Lawton','Comanche',34.611016,-98.459952),('73506','OK','Lawton','Comanche',34.6086,-98.39),('73507','OK','Lawton','Comanche',34.638039,-98.406257),('73520','OK','Addington','Jefferson',34.246458,-97.966982),('73521','OK','Altus','Jackson',34.645646,-99.320738),('73522','OK','Altus','Jackson',34.638,-99.3336),('73523','OK','Altus Afb','Jackson',34.6558,-99.2813),('73526','OK','Blair','Jackson',34.790747,-99.308593),('73527','OK','Cache','Comanche',34.608618,-98.618596),('73528','OK','Chattanooga','Comanche',34.413321,-98.63587),('73529','OK','Comanche','Stephens',34.372282,-97.981801),('73530','OK','Davidson','Tillman',34.254437,-99.036758),('73531','OK','Devol','Cotton',34.180922,-98.549066),('73532','OK','Duke','Jackson',34.644683,-99.578884),('73533','OK','Duncan','Stephens',34.503834,-97.951583),('73534','OK','Duncan','Stephens',34.5008,-97.9612),('73536','OK','Duncan','Stephens',34.5008,-97.9612),('73537','OK','Eldorado','Jackson',34.465354,-99.658913),('73538','OK','Elgin','Comanche',34.770525,-98.302072),('73539','OK','Elmer','Jackson',34.471632,-99.29392),('73540','OK','Faxon','Comanche',34.464808,-98.567077),('73541','OK','Fletcher','Comanche',34.804419,-98.194772),('73542','OK','Frederick','Tillman',34.39938,-98.984554),('73543','OK','Geronimo','Comanche',34.46956,-98.383045),('73544','OK','Gould','Harmon',34.670764,-99.76799),('73546','OK','Grandfield','Tillman',34.230398,-98.697737),('73547','OK','Granite','Greer',34.973221,-99.391676),('73548','OK','Hastings','Stephens',34.250024,-98.126179),('73549','OK','Headrick','Jackson',34.645489,-99.150011),('73550','OK','Hollis','Harmon',34.693028,-99.916681),('73551','OK','Hollister','Tillman',34.343736,-98.870711),('73552','OK','Indiahoma','Comanche',34.631942,-98.737963),('73553','OK','Loveland','Tillman',34.318335,-98.743788),('73554','OK','Mangum','Greer',34.878292,-99.540458),('73555','OK','Manitou','Tillman',34.509082,-98.975184),('73556','OK','Martha','Jackson',34.726678,-99.386365),('73557','OK','Medicine Park','Comanche',34.728033,-98.495986),('73558','OK','Meers','Comanche',34.7827,-98.5786),('73559','OK','Mountain Park','Kiowa',34.706003,-98.956351),('73560','OK','Olustee','Jackson',34.542378,-99.447932),('73561','OK','Oscar','Jefferson',34.023916,-97.648019),('73562','OK','Randlett','Cotton',34.187495,-98.432074),('73564','OK','Roosevelt','Kiowa',34.841782,-99.011751),('73565','OK','Ryan','Jefferson',34.012887,-97.940291),('73566','OK','Snyder','Kiowa',34.641455,-98.953962),('73567','OK','Sterling','Comanche',34.748563,-98.169116),('73568','OK','Temple','Cotton',34.262165,-98.228326),('73569','OK','Terral','Jefferson',33.910673,-97.878305),('73570','OK','Tipton','Tillman',34.507489,-99.106036),('73571','OK','Vinson','Harmon',34.932885,-99.893965),('73572','OK','Walters','Cotton',34.360059,-98.32796),('73573','OK','Waurika','Jefferson',34.168498,-97.99909),('73601','OK','Clinton','Custer',35.504261,-98.969142),('73620','OK','Arapaho','Custer',35.591003,-98.98704),('73622','OK','Bessie','Washita',35.385434,-99.002649),('73624','OK','Burns Flat','Washita',35.34972,-99.177366),('73625','OK','Butler','Custer',35.640462,-99.201166),('73626','OK','Canute','Washita',35.418358,-99.276068),('73627','OK','Carter','Beckham',35.211747,-99.461552),('73628','OK','Cheyenne','Roger Mills',35.61689,-99.677247),('73632','OK','Cordell','Washita',35.284167,-98.96665),('73638','OK','Crawford','Roger Mills',35.839701,-99.798201),('73639','OK','Custer City','Custer',35.718116,-98.933501),('73641','OK','Dill City','Washita',35.271729,-99.154136),('73642','OK','Durham','Roger Mills',35.81295,-99.904426),('73644','OK','Elk City','Beckham',35.40797,-99.418179),('73645','OK','Erick','Beckham',35.220954,-99.888854),('73646','OK','Fay','Blaine',35.828079,-98.617981),('73647','OK','Foss','Washita',35.439307,-99.170039),('73648','OK','Elk City','Beckham',35.4119,-99.4038),('73650','OK','Hammon','Roger Mills',35.63199,-99.402241),('73651','OK','Hobart','Kiowa',35.021923,-99.087285),('73654','OK','Leedey','Dewey',35.85589,-99.335782),('73655','OK','Lone Wolf','Kiowa',34.979683,-99.263291),('73658','OK','Oakwood','Dewey',35.955694,-98.728642),('73659','OK','Putnam','Dewey',35.871751,-98.9203),('73660','OK','Reydon','Roger Mills',35.631691,-99.91387),('73661','OK','Rocky','Washita',35.174901,-99.034121),('73662','OK','Sayre','Beckham',35.29619,-99.649315),('73663','OK','Seiling','Dewey',36.129746,-98.920641),('73664','OK','Sentinel','Washita',35.167595,-99.210517),('73666','OK','Sweetwater','Roger Mills',35.458456,-99.902424),('73667','OK','Taloga','Dewey',36.005614,-99.003161),('73668','OK','Texola','Beckham',35.219721,-99.992281),('73669','OK','Thomas','Custer',35.739356,-98.747104),('73673','OK','Willow','Greer',35.051596,-99.53628),('73701','OK','Enid','Garfield',36.409673,-97.851095),('73702','OK','Enid','Garfield',36.3942,-97.8813),('73703','OK','Enid','Garfield',36.404845,-97.925808),('73705','OK','Enid','Garfield',36.339986,-97.900991),('73706','OK','Enid','Garfield',36.3942,-97.8813),('73716','OK','Aline','Alfalfa',36.498003,-98.456434),('73717','OK','Alva','Woods',36.81507,-98.683835),('73718','OK','Ames','Major',36.224823,-98.184686),('73719','OK','Amorita','Alfalfa',36.94963,-98.282915),('73720','OK','Bison','Garfield',36.195694,-97.879758),('73722','OK','Burlington','Alfalfa',36.884062,-98.315431),('73724','OK','Canton','Blaine',36.052152,-98.663719),('73726','OK','Carmen','Alfalfa',36.583551,-98.471915),('73727','OK','Carrier','Garfield',36.488592,-98.040056),('73728','OK','Cherokee','Alfalfa',36.746447,-98.387221),('73729','OK','Cleo Springs','Major',36.402468,-98.455647),('73730','OK','Covington','Garfield',36.325486,-97.5595),('73731','OK','Dacoma','Woods',36.648323,-98.581505),('73733','OK','Douglas','Garfield',36.253199,-97.684421),('73734','OK','Dover','Kingfisher',35.978388,-97.863019),('73735','OK','Drummond','Garfield',36.289303,-98.05086),('73736','OK','Fairmont','Garfield',36.347201,-97.692395),('73737','OK','Fairview','Major',36.282186,-98.563313),('73738','OK','Garber','Garfield',36.440805,-97.559621),('73739','OK','Goltry','Alfalfa',36.523139,-98.139532),('73741','OK','Helena','Alfalfa',36.55371,-98.270121),('73742','OK','Hennessey','Kingfisher',36.098623,-97.915338),('73743','OK','Hillsdale','Garfield',36.572307,-98.005819),('73744','OK','Hitchcock','Blaine',35.949404,-98.307925),('73746','OK','Hopeton','Woods',36.686859,-98.666599),('73747','OK','Isabella','Major',36.227717,-98.321041),('73749','OK','Jet','Alfalfa',36.732535,-98.153273),('73750','OK','Kingfisher','Kingfisher',35.858314,-97.929741),('73753','OK','Kremlin','Garfield',36.553481,-97.85046),('73754','OK','Lahoma','Garfield',36.393335,-98.087548),('73755','OK','Longdale','Blaine',36.139744,-98.579044),('73756','OK','Loyal','Kingfisher',35.985079,-98.120163),('73757','OK','Lucien','Noble',36.287647,-97.445665),('73758','OK','Manchester','Grant',36.949292,-98.084231),('73759','OK','Medford','Grant',36.832904,-97.724123),('73760','OK','Meno','Major',36.38278,-98.168238),('73761','OK','Nash','Grant',36.682888,-98.043385),('73762','OK','Okarche','Kingfisher',35.711858,-97.968381),('73763','OK','Okeene','Blaine',36.108539,-98.32808),('73764','OK','Omega','Kingfisher',35.846201,-98.19669),('73766','OK','Pond Creek','Grant',36.657979,-97.814791),('73768','OK','Ringwood','Major',36.339603,-98.293679),('73770','OK','Southard','Blaine',36.073,-98.4579),('73771','OK','Wakita','Grant',36.861428,-97.95674),('73772','OK','Watonga','Blaine',35.856707,-98.415853),('73773','OK','Waukomis','Garfield',36.265865,-97.916668),('73801','OK','Woodward','Woodward',36.437756,-99.409631),('73802','OK','Woodward','Woodward',36.543405,-99.290471),('73832','OK','Arnett','Ellis',36.089766,-99.711389),('73834','OK','Buffalo','Harper',36.849524,-99.594121),('73835','OK','Camargo','Dewey',35.960666,-99.200163),('73838','OK','Chester','Major',36.241999,-98.888868),('73840','OK','Fargo','Ellis',36.372157,-99.629),('73841','OK','Fort Supply','Woodward',36.564491,-99.58249),('73842','OK','Freedom','Woods',36.754796,-99.156742),('73843','OK','Gage','Ellis',36.390173,-99.811513),('73844','OK','Gate','Beaver',36.884585,-100.12454),('73848','OK','Laverne','Harper',36.658904,-99.992116),('73851','OK','May','Harper',36.592914,-99.803549),('73852','OK','Mooreland','Woodward',36.446338,-99.152544),('73853','OK','Mutual','Woodward',36.223927,-99.142207),('73855','OK','Rosston','Harper',36.902652,-99.87464),('73857','OK','Sharon','Woodward',36.283183,-99.326756),('73858','OK','Shattuck','Ellis',36.236995,-99.90282),('73859','OK','Vici','Dewey',36.137814,-99.26811),('73860','OK','Waynoka','Woods',36.542084,-98.841957),('73901','OK','Adams','Texas',36.754591,-101.05303),('73931','OK','Balko','Beaver',36.587331,-100.801469),('73932','OK','Beaver','Beaver',36.739573,-100.514762),('73933','OK','Boise City','Cimarron',36.73414,-102.510488),('73937','OK','Felt','Cimarron',36.552396,-102.795684),('73938','OK','Forgan','Beaver',36.914187,-100.585222),('73939','OK','Goodwell','Texas',36.714846,-101.735569),('73942','OK','Guymon','Texas',36.720061,-101.489103),('73944','OK','Hardesty','Texas',36.594674,-101.143049),('73945','OK','Hooker','Texas',36.830152,-101.253427),('73946','OK','Kenton','Cimarron',36.901495,-102.896936),('73947','OK','Keyes','Cimarron',36.827822,-102.185201),('73949','OK','Texhoma','Texas',36.550122,-101.886029),('73950','OK','Turpin','Beaver',36.871128,-100.887536),('73951','OK','Tyrone','Texas',36.9531,-101.06324),('74001','OK','Avant','Osage',36.492234,-96.0667),('74002','OK','Barnsdall','Osage',36.555065,-96.148494),('74003','OK','Bartlesville','Washington',36.74565,-96.005899),('74004','OK','Bartlesville','Washington',36.7472,-95.9805),('74005','OK','Bartlesville','Washington',36.7472,-95.9805),('74006','OK','Bartlesville','Washington',36.733647,-95.918692),('74008','OK','Bixby','Tulsa',35.95107,-95.883004),('74010','OK','Bristow','Creek',35.835581,-96.379943),('74011','OK','Broken Arrow','Tulsa',35.986397,-95.810435),('74012','OK','Broken Arrow','Tulsa',36.051414,-95.805721),('74013','OK','Broken Arrow','Tulsa',36.04,-95.7905),('74014','OK','Broken Arrow','Wagoner',36.057047,-95.704645),('74015','OK','Catoosa','Rogers',36.179766,-95.72767),('74016','OK','Chelsea','Rogers',36.547762,-95.444363),('74017','OK','Claremore','Rogers',36.348061,-95.593952),('74018','OK','Claremore','Rogers',36.3167,-95.6088),('74019','OK','Claremore','Rogers',36.276577,-95.627627),('74020','OK','Cleveland','Pawnee',36.256522,-96.415343),('74021','OK','Collinsville','Tulsa',36.367168,-95.835945),('74022','OK','Copan','Washington',36.923339,-95.964588),('74023','OK','Cushing','Payne',35.975376,-96.759796),('74026','OK','Davenport','Lincoln',35.708483,-96.764531),('74027','OK','Delaware','Nowata',36.785169,-95.596988),('74028','OK','Depew','Creek',35.805607,-96.529081),('74029','OK','Dewey','Washington',36.813558,-95.919431),('74030','OK','Drumright','Creek',35.986127,-96.584856),('74031','OK','Foyil','Rogers',36.3324,-95.5739),('74032','OK','Glencoe','Payne',36.219608,-96.920336),('74033','OK','Glenpool','Tulsa',35.956444,-96.004202),('74034','OK','Hallett','Pawnee',36.228867,-96.572173),('74035','OK','Hominy','Osage',36.410828,-96.368895),('74036','OK','Inola','Rogers',36.155436,-95.515882),('74037','OK','Jenks','Tulsa',36.006636,-95.98015),('74038','OK','Jennings','Pawnee',36.147997,-96.548568),('74039','OK','Kellyville','Creek',35.924637,-96.229672),('74041','OK','Kiefer','Creek',35.942289,-96.054733),('74042','OK','Lenapah','Nowata',36.85473,-95.622337),('74043','OK','Leonard','Tulsa',35.9202,-95.7991),('74044','OK','Mannford','Creek',36.117872,-96.374635),('74045','OK','Maramec','Pawnee',36.228522,-96.704102),('74046','OK','Milfay','Creek',35.752665,-96.564984),('74047','OK','Mounds','Okmulgee',35.863201,-96.016445),('74048','OK','Nowata','Nowata',36.693262,-95.635196),('74050','OK','Oakhurst','Creek',36.074093,-96.064318),('74051','OK','Ochelata','Washington',36.602474,-95.975402),('74052','OK','Oilton','Creek',36.08232,-96.583519),('74053','OK','Oologah','Rogers',36.43292,-95.718609),('74054','OK','Osage','Osage',36.273952,-96.370961),('74055','OK','Owasso','Tulsa',36.28349,-95.828115),('74056','OK','Pawhuska','Osage',36.756704,-96.319633),('74058','OK','Pawnee','Pawnee',36.350334,-96.764988),('74059','OK','Perkins','Payne',35.971429,-97.035648),('74060','OK','Prue','Osage',36.249729,-96.259734),('74061','OK','Ramona','Washington',36.527115,-95.913368),('74062','OK','Ripley','Payne',36.030262,-96.907624),('74063','OK','Sand Springs','Tulsa',36.139241,-96.165964),('74066','OK','Sapulpa','Creek',35.995399,-96.118386),('74067','OK','Sapulpa','Creek',35.9929,-96.1138),('74068','OK','Shamrock','Creek',35.910751,-96.580244),('74070','OK','Skiatook','Osage',36.372398,-96.058883),('74071','OK','Slick','Creek',35.781275,-96.270519),('74072','OK','S Coffeyville','Nowata',36.957837,-95.592257),('74073','OK','Sperry','Tulsa',36.303064,-96.013677),('74074','OK','Stillwater','Payne',36.100317,-97.076713),('74075','OK','Stillwater','Payne',36.152016,-97.077891),('74076','OK','Stillwater','Payne',36.1132,-97.0569),('74077','OK','Stillwater','Payne',36.1206,-97.0737),('74078','OK','Stillwater','Payne',36.125698,-97.072414),('74079','OK','Stroud','Lincoln',35.741728,-96.660583),('74080','OK','Talala','Rogers',36.517951,-95.721151),('74081','OK','Terlton','Pawnee',36.179593,-96.44642),('74082','OK','Vera','Washington',36.4497,-95.881445),('74083','OK','Wann','Nowata',36.92437,-95.78031),('74084','OK','Wynona','Osage',36.540204,-96.323621),('74085','OK','Yale','Payne',36.105357,-96.698112),('74101','OK','Tulsa','Tulsa',36.1504,-95.9953),('74102','OK','Tulsa','Tulsa',36.1504,-95.9953),('74103','OK','Tulsa','Tulsa',36.156153,-95.994671),('74104','OK','Tulsa','Tulsa',36.146443,-95.954298),('74105','OK','Tulsa','Tulsa',36.097162,-95.966759),('74106','OK','Tulsa','Tulsa',36.185126,-95.985121),('74107','OK','Tulsa','Tulsa',36.102006,-96.030125),('74108','OK','Tulsa','Tulsa',36.154795,-95.796093),('74110','OK','Tulsa','Tulsa',36.181382,-95.954354),('74112','OK','Tulsa','Tulsa',36.149252,-95.911365),('74114','OK','Tulsa','Tulsa',36.126943,-95.946695),('74115','OK','Tulsa','Tulsa',36.178436,-95.911338),('74116','OK','Tulsa','Tulsa',36.177223,-95.833476),('74117','OK','Tulsa','Tulsa',36.246037,-95.901508),('74119','OK','Tulsa','Tulsa',36.14296,-95.989036),('74120','OK','Tulsa','Tulsa',36.150737,-95.977408),('74121','OK','Tulsa','Tulsa',36.1504,-95.9953),('74126','OK','Tulsa','Tulsa',36.240447,-96.000829),('74127','OK','Tulsa','Tulsa',36.160032,-96.031462),('74128','OK','Tulsa','Tulsa',36.146688,-95.852415),('74129','OK','Tulsa','Tulsa',36.127501,-95.868342),('74130','OK','Tulsa','Tulsa',36.239645,-95.958562),('74131','OK','Tulsa','Creek',36.057271,-96.070098),('74132','OK','Tulsa','Tulsa',36.050108,-96.0229),('74133','OK','Tulsa','Tulsa',36.043958,-95.883057),('74134','OK','Tulsa','Tulsa',36.110312,-95.817633),('74135','OK','Tulsa','Tulsa',36.097972,-95.924535),('74136','OK','Tulsa','Tulsa',36.059702,-95.939359),('74137','OK','Tulsa','Tulsa',36.022434,-95.930585),('74141','OK','Tulsa','Tulsa',36.1303,-95.8752),('74145','OK','Tulsa','Tulsa',36.09618,-95.88502),('74146','OK','Tulsa','Tulsa',36.100749,-95.854974),('74147','OK','Tulsa','Tulsa',36.0969,-95.8861),('74148','OK','Tulsa','Tulsa',36.191,-95.9856),('74149','OK','Tulsa','Tulsa',36.1607,-96.036),('74150','OK','Tulsa','Tulsa',36.1592,-95.9578),('74152','OK','Tulsa','Tulsa',36.1538,-95.9925),('74153','OK','Tulsa','Tulsa',36.0888,-95.9058),('74155','OK','Tulsa','Tulsa',36.097,-95.8775),('74156','OK','Tulsa','Tulsa',36.2481,-95.9752),('74157','OK','Tulsa','Tulsa',36.1011,-96.036),('74158','OK','Tulsa','Tulsa',36.1661,-95.9176),('74159','OK','Tulsa','Tulsa',36.1414,-95.9595),('74169','OK','Tulsa','Tulsa',36.1218,-95.8327),('74170','OK','Tulsa','Tulsa',36.0626,-95.9604),('74171','OK','Tulsa','Tulsa',36.0513,-95.9577),('74172','OK','Tulsa','Tulsa',36.1549,-95.9916),('74182','OK','Tulsa','Tulsa',36.1504,-95.9953),('74183','OK','Tulsa','Tulsa',36.0616,-95.9412),('74184','OK','Tulsa','Tulsa',36.0616,-95.9412),('74186','OK','Tulsa','Tulsa',36.1504,-95.9953),('74187','OK','Tulsa','Tulsa',36.1504,-95.9953),('74189','OK','Tulsa','Tulsa',36.1504,-95.9953),('74192','OK','Tulsa','Tulsa',36.1504,-95.9953),('74193','OK','Tulsa','Tulsa',36.1504,-95.9953),('74194','OK','Tulsa','Tulsa',36.1504,-95.9953),('74301','OK','Vinita','Craig',36.625334,-95.167188),('74330','OK','Adair','Mayes',36.436391,-95.26022),('74331','OK','Afton','Delaware',36.619177,-94.934146),('74332','OK','Big Cabin','Craig',36.516971,-95.22863),('74333','OK','Bluejacket','Craig',36.793273,-95.082513),('74335','OK','Cardin','Ottawa',36.975692,-94.851612),('74337','OK','Chouteau','Mayes',36.157125,-95.332208),('74338','OK','Colcord','Delaware',36.23021,-94.69757),('74339','OK','Commerce','Ottawa',36.933511,-94.871618),('74340','OK','Disney','Mayes',36.477591,-95.020869),('74342','OK','Eucha','Delaware',36.452028,-94.950134),('74343','OK','Fairland','Ottawa',36.750983,-94.839737),('74344','OK','Grove','Delaware',36.602986,-94.766371),('74345','OK','Grove','Delaware',36.5945,-94.7581),('74346','OK','Jay','Delaware',36.45034,-94.779107),('74347','OK','Kansas','Delaware',36.187115,-94.779684),('74349','OK','Ketchum','Craig',36.52326,-95.027124),('74350','OK','Langley','Mayes',36.472133,-95.050095),('74352','OK','Locust Grove','Mayes',36.173463,-95.175521),('74354','OK','Miami','Ottawa',36.882125,-94.868114),('74355','OK','Miami','Ottawa',36.8744,-94.8772),('74358','OK','North Miami','Ottawa',36.917633,-94.880063),('74359','OK','Oaks','Delaware',36.177836,-94.844212),('74360','OK','Picher','Ottawa',36.98151,-94.832772),('74361','OK','Pryor','Mayes',36.289831,-95.29515),('74362','OK','Pryor','Mayes',36.3054,-95.3173),('74363','OK','Quapaw','Ottawa',36.94937,-94.73199),('74364','OK','Rose','Delaware',36.205244,-94.963141),('74365','OK','Salina','Mayes',36.288009,-95.105978),('74366','OK','Spavinaw','Mayes',36.393895,-95.051445),('74367','OK','Strang','Mayes',36.416089,-95.112887),('74368','OK','Twin Oaks','Delaware',36.207534,-94.846067),('74369','OK','Welch','Craig',36.909456,-95.151845),('74370','OK','Wyandotte','Ottawa',36.767107,-94.690014),('74401','OK','Muskogee','Muskogee',35.739827,-95.413649),('74402','OK','Muskogee','Muskogee',35.6728,-95.3103),('74403','OK','Muskogee','Muskogee',35.717422,-95.334962),('74421','OK','Beggs','Okmulgee',35.755507,-96.035666),('74422','OK','Boynton','Muskogee',35.645936,-95.669164),('74423','OK','Braggs','Muskogee',35.664774,-95.183724),('74425','OK','Canadian','Pittsburg',35.177017,-95.632264),('74426','OK','Checotah','Mcintosh',35.436656,-95.558979),('74427','OK','Cookson','Cherokee',35.688839,-94.939606),('74428','OK','Council Hill','Mcintosh',35.551878,-95.646896),('74429','OK','Coweta','Wagoner',35.953832,-95.645627),('74430','OK','Crowder','Pittsburg',35.122075,-95.672758),('74431','OK','Dewar','Okmulgee',35.458836,-95.949159),('74432','OK','Eufaula','Mcintosh',35.291785,-95.607891),('74434','OK','Fort Gibson','Muskogee',35.803758,-95.227392),('74435','OK','Gore','Sequoyah',35.567629,-95.096044),('74436','OK','Haskell','Muskogee',35.80279,-95.677178),('74437','OK','Henryetta','Okmulgee',35.448304,-95.952973),('74438','OK','Hitchita','Mcintosh',35.520803,-95.753837),('74439','OK','Braggs','Muskogee',35.6767,-95.1775),('74440','OK','Hoyt','Haskell',35.269955,-95.302057),('74441','OK','Hulbert','Cherokee',35.958049,-95.153386),('74442','OK','Indianola','Pittsburg',35.137863,-95.78066),('74444','OK','Moodys','Cherokee',36.053001,-94.966822),('74445','OK','Morris','Okmulgee',35.616786,-95.846232),('74446','OK','Okay','Wagoner',35.850051,-95.315724),('74447','OK','Okmulgee','Okmulgee',35.629343,-95.972122),('74450','OK','Oktaha','Muskogee',35.595532,-95.473924),('74451','OK','Park Hill','Cherokee',35.750467,-94.956665),('74452','OK','Peggs','Cherokee',36.106137,-95.098535),('74454','OK','Porter','Wagoner',35.862872,-95.50691),('74455','OK','Porum','Muskogee',35.360387,-95.292302),('74456','OK','Preston','Okmulgee',35.712132,-95.992203),('74457','OK','Proctor','Adair',36.042853,-94.806424),('74458','OK','Redbird','Wagoner',35.886556,-95.589285),('74459','OK','Rentiesville','Mcintosh',35.528992,-95.48917),('74460','OK','Schulter','Okmulgee',35.514993,-95.95627),('74461','OK','Stidham','Mcintosh',35.384048,-95.70731),('74462','OK','Stigler','Haskell',35.279271,-95.204994),('74463','OK','Taft','Muskogee',35.761892,-95.546685),('74464','OK','Tahlequah','Cherokee',35.917963,-94.969507),('74465','OK','Tahlequah','Cherokee',35.9152,-94.9697),('74467','OK','Wagoner','Wagoner',35.957413,-95.361906),('74468','OK','Wainwright','Muskogee',35.613434,-95.566042),('74469','OK','Warner','Muskogee',35.491247,-95.30905),('74470','OK','Webbers Falls','Muskogee',35.489444,-95.159356),('74471','OK','Welling','Cherokee',35.834204,-94.871883),('74472','OK','Whitefield','Haskell',35.2543,-95.244695),('74477','OK','Wagoner','Wagoner',35.9594,-95.3691),('74501','OK','Mcalester','Pittsburg',34.947984,-95.763303),('74502','OK','Mcalester','Pittsburg',34.9323,-95.7622),('74521','OK','Albion','Pushmataha',34.661795,-95.096935),('74522','OK','Alderson','Pittsburg',34.901444,-95.693969),('74523','OK','Antlers','Pushmataha',34.232283,-95.61494),('74525','OK','Atoka','Atoka',34.361836,-96.08773),('74528','OK','Blanco','Pittsburg',34.715892,-95.761536),('74529','OK','Blocker','Pittsburg',35.0613,-95.568),('74530','OK','Bromide','Johnston',34.416818,-96.494525),('74531','OK','Calvin','Hughes',34.896428,-96.247393),('74533','OK','Caney','Atoka',34.213928,-96.213622),('74534','OK','Centrahoma','Coal',34.612573,-96.354725),('74535','OK','Clarita','Coal',34.481517,-96.435844),('74536','OK','Clayton','Pushmataha',34.568366,-95.403002),('74538','OK','Coalgate','Coal',34.554012,-96.240786),('74540','OK','Daisy','Atoka',34.54059,-95.716229),('74542','OK','Farris,','Atoka',34.384,-96.1261),('74543','OK','Finley','Pushmataha',34.37055,-95.437629),('74545','OK','Gowen','Latimer',34.877067,-95.478324),('74546','OK','Haileyville','Pittsburg',34.855236,-95.578499),('74547','OK','Hartshorne','Pittsburg',34.847159,-95.565494),('74549','OK','Kiamichi Christian Mission','Pushmataha',34.554026,-94.940208),('74552','OK','Kinta','Haskell',35.119759,-95.238238),('74553','OK','Kiowa','Pittsburg',34.705296,-95.906148),('74554','OK','Krebs','Pittsburg',34.928145,-95.720615),('74555','OK','Lane','Atoka',34.275942,-95.959244),('74556','OK','Lehigh','Coal',34.472185,-96.204231),('74557','OK','Moyers','Pushmataha',34.386199,-95.665618),('74558','OK','Nashoba','Pushmataha',34.485205,-95.162652),('74559','OK','Panola','Latimer',34.8127,-95.2566),('74560','OK','Pittsburg','Pittsburg',34.661707,-95.81771),('74561','OK','Quinton','Pittsburg',35.144071,-95.397045),('74562','OK','Rattan','Pushmataha',34.301458,-95.280363),('74563','OK','Red Oak','Latimer',34.958346,-95.075599),('74565','OK','Savanna','Pittsburg',34.818723,-95.84798),('74567','OK','Snow','Pushmataha',34.43168,-95.387736),('74569','OK','Stringtown','Atoka',34.46136,-95.954628),('74570','OK','Stuart','Hughes',34.851426,-96.092051),('74571','OK','Talihina','Le Flore',34.731691,-95.035149),('74572','OK','Tupelo','Coal',34.627216,-96.433387),('74574','OK','Tuskahoma','Pushmataha',34.646722,-95.276405),('74576','OK','Wardville','Atoka',34.654606,-96.029707),('74577','OK','Whitesboro','Le Flore',34.691309,-94.87228),('74578','OK','Wilburton','Latimer',34.902441,-95.339485),('74601','OK','Ponca City','Kay',36.706906,-97.105822),('74602','OK','Ponca City','Kay',36.7069,-97.0852),('74604','OK','Ponca City','Kay',36.708657,-97.01528),('74630','OK','Billings','Noble',36.513447,-97.417203),('74631','OK','Blackwell','Kay',36.801499,-97.295111),('74632','OK','Braman','Kay',36.933008,-97.32943),('74633','OK','Burbank','Osage',36.710203,-96.776628),('74636','OK','Deer Creek','Grant',36.814485,-97.525351),('74637','OK','Fairfax','Osage',36.577351,-96.697993),('74640','OK','Hunter','Garfield',36.556606,-97.64898),('74641','OK','Kaw City','Kay',36.78114,-96.869331),('74643','OK','Lamont','Grant',36.672696,-97.565136),('74644','OK','Marland','Noble',36.559566,-97.14373),('74646','OK','Nardin','Kay',36.819354,-97.441431),('74647','OK','Newkirk','Kay',36.894768,-97.053168),('74650','OK','Ralston','Pawnee',36.481161,-96.751583),('74651','OK','Red Rock','Noble',36.466116,-97.179353),('74652','OK','Shidler','Osage',36.812323,-96.677959),('74653','OK','Tonkawa','Kay',36.663755,-97.326506),('74701','OK','Durant','Bryan',34.007813,-96.389421),('74702','OK','Durant','Bryan',33.9911,-96.3738),('74720','OK','Achille','Bryan',33.834012,-96.386974),('74721','OK','Albany','Bryan',33.888549,-96.172448),('74722','OK','Battiest','Mccurtain',34.394905,-94.930312),('74723','OK','Bennington','Bryan',33.998481,-96.029925),('74724','OK','Bethel','Mccurtain',34.349011,-94.841795),('74726','OK','Bokchito','Bryan',33.971395,-96.168046),('74727','OK','Boswell','Choctaw',34.028832,-95.856134),('74728','OK','Broken Bow','Mccurtain',34.107048,-94.779203),('74729','OK','Caddo','Bryan',34.119284,-96.273562),('74730','OK','Calera','Bryan',33.921803,-96.441713),('74731','OK','Cartwright','Bryan',33.875934,-96.568213),('74733','OK','Colbert','Bryan',33.83614,-96.502179),('74734','OK','Eagletown','Mccurtain',34.09334,-94.538474),('74735','OK','Fort Towson','Choctaw',34.065531,-95.256706),('74736','OK','Garvin','Mccurtain',33.933894,-94.975923),('74737','OK','Golden','Mccurtain',34.032184,-94.896491),('74738','OK','Grant','Choctaw',33.916314,-95.488497),('74740','OK','Haworth','Mccurtain',33.790515,-94.622367),('74741','OK','Hendrix','Bryan',33.755212,-96.300376),('74743','OK','Hugo','Choctaw',34.011147,-95.505503),('74745','OK','Idabel','Mccurtain',33.887493,-94.825982),('74747','OK','Kemp','Bryan',33.770766,-96.354945),('74748','OK','Kenefic','Johnston',34.135866,-96.473572),('74750','OK','Millerton','Mccurtain',33.985587,-95.014944),('74752','OK','Pickens','Mccurtain',34.3963,-95.0116),('74753','OK','Platter','Bryan',33.918732,-96.546403),('74754','OK','Ringold','Mccurtain',34.205752,-95.118198),('74755','OK','Rufe','Mccurtain',34.134683,-95.114767),('74756','OK','Sawyer','Choctaw',34.050109,-95.374441),('74759','OK','Soper','Choctaw',34.036412,-95.697287),('74760','OK','Spencerville','Choctaw',34.156868,-95.379594),('74761','OK','Swink','Choctaw',34.01844,-95.203037),('74764','OK','Valliant','Mccurtain',34.03636,-95.089829),('74766','OK','Wright City','Mccurtain',34.10681,-94.976572),('74801','OK','Shawnee','Pottawatomie',35.323616,-96.940269),('74802','OK','Shawnee','Pottawatomie',35.3287,-96.9228),('74804','OK','Shawnee','Pottawatomie',35.375311,-96.933861),('74818','OK','Seminole','Seminole',35.2244,-96.6702),('74820','OK','Ada','Pontotoc',34.783663,-96.685873),('74821','OK','Ada','Pontotoc',34.7744,-96.678),('74824','OK','Agra','Lincoln',35.888673,-96.871192),('74825','OK','Allen','Pontotoc',34.838971,-96.399503),('74826','OK','Asher','Pottawatomie',35.01617,-96.895011),('74827','OK','Atwood','Hughes',34.955969,-96.343442),('74829','OK','Boley','Okfuskee',35.500448,-96.470512),('74830','OK','Bowlegs','Seminole',35.148119,-96.668416),('74831','OK','Byars','Mcclain',34.891248,-97.062973),('74832','OK','Carney','Lincoln',35.81665,-97.014575),('74833','OK','Castle','Okfuskee',35.575964,-96.40449),('74834','OK','Chandler','Lincoln',35.701792,-96.889503),('74836','OK','Connerville','Johnston',34.442188,-96.642267),('74837','OK','Cromwell','Seminole',35.347949,-96.458575),('74839','OK','Dustin','Hughes',35.264833,-96.034451),('74840','OK','Earlsboro','Pottawatomie',35.300954,-96.768247),('74842','OK','Fittstown','Pontotoc',34.621705,-96.61752),('74843','OK','Fitzhugh','Pontotoc',34.66567,-96.739797),('74844','OK','Francis','Pontotoc',34.873154,-96.591651),('74845','OK','Hanna','Mcintosh',35.252853,-95.906934),('74848','OK','Holdenville','Hughes',35.080691,-96.386941),('74849','OK','Konawa','Seminole',34.970428,-96.73973),('74850','OK','Lamar','Hughes',35.104018,-96.090517),('74851','OK','Mcloud','Pottawatomie',35.417945,-97.092257),('74852','OK','Macomb','Pottawatomie',35.123537,-97.010982),('74854','OK','Maud','Pottawatomie',35.115502,-96.775716),('74855','OK','Meeker','Lincoln',35.507784,-96.912332),('74856','OK','Mill Creek','Johnston',34.381957,-96.820726),('74857','OK','Newalla','Cleveland',35.35034,-97.194366),('74859','OK','Okemah','Okfuskee',35.449218,-96.317528),('74860','OK','Paden','Okfuskee',35.548232,-96.556827),('74864','OK','Prague','Lincoln',35.490674,-96.691401),('74865','OK','Roff','Pontotoc',34.623728,-96.815561),('74866','OK','Saint Louis','Pottawatomie',35.062235,-96.835508),('74867','OK','Sasakwa','Seminole',34.950191,-96.553486),('74868','OK','Seminole','Seminole',35.247597,-96.658822),('74869','OK','Sparks','Lincoln',35.60117,-96.760192),('74871','OK','Stonewall','Pontotoc',34.628579,-96.557053),('74872','OK','Stratford','Garvin',34.792826,-96.977992),('74873','OK','Tecumseh','Pottawatomie',35.238566,-96.957198),('74875','OK','Tryon','Lincoln',35.868653,-96.954572),('74878','OK','Wanette','Pottawatomie',35.004995,-97.066611),('74880','OK','Weleetka','Okfuskee',35.365518,-96.123995),('74881','OK','Wellston','Lincoln',35.69427,-97.070605),('74883','OK','Wetumka','Hughes',35.242746,-96.232787),('74884','OK','Wewoka','Seminole',35.171762,-96.507041),('74901','OK','Arkoma','Le Flore',35.352167,-94.440171),('74902','OK','Pocola','Le Flore',35.259892,-94.469034),('74930','OK','Bokoshe','Le Flore',35.187051,-94.776689),('74931','OK','Bunch','Adair',35.676146,-94.75652),('74932','OK','Cameron','Le Flore',35.151595,-94.537988),('74935','OK','Fanshawe','Le Flore',34.95115,-94.9011),('74936','OK','Gans','Sequoyah',35.390994,-94.707006),('74937','OK','Heavener','Le Flore',34.860571,-94.594136),('74939','OK','Hodgen','Le Flore',34.729814,-94.632659),('74940','OK','Howe','Le Flore',34.95533,-94.629455),('74941','OK','Keota','Haskell',35.274452,-94.878136),('74942','OK','Leflore','Le Flore',34.899427,-94.981359),('74943','OK','Lequire','Haskell',35.103615,-95.090271),('74944','OK','Mccurtain','Haskell',35.128852,-95.006011),('74945','OK','Marble City','Sequoyah',35.583884,-94.817394),('74946','OK','Moffett','Sequoyah',35.395469,-94.445251),('74947','OK','Monroe','Le Flore',34.991767,-94.517631),('74948','OK','Muldrow','Sequoyah',35.431779,-94.565544),('74949','OK','Muse','Le Flore',34.66831,-94.774381),('74951','OK','Panama','Le Flore',35.169268,-94.661882),('74953','OK','Poteau','Le Flore',35.055157,-94.620507),('74954','OK','Roland','Sequoyah',35.419218,-94.503652),('74955','OK','Sallisaw','Sequoyah',35.464158,-94.788432),('74956','OK','Shady Point','Le Flore',35.121215,-94.697131),('74957','OK','Smithville','Mccurtain',34.510657,-94.668887),('74959','OK','Spiro','Le Flore',35.248675,-94.61564),('74960','OK','Stilwell','Adair',35.815696,-94.650318),('74962','OK','Vian','Sequoyah',35.530627,-94.974604),('74963','OK','Watson','Mccurtain',34.400652,-94.578336),('74964','OK','Watts','Adair',36.12387,-94.641315),('74965','OK','Westville','Adair',35.993153,-94.609406),('74966','OK','Wister','Le Flore',34.943611,-94.814109),('75001','TX','Addison','Dallas',32.959183,-96.838534),('75002','TX','Allen','Collin',33.096557,-96.630053),('75006','TX','Carrollton','Dallas',32.964531,-96.890636),('75007','TX','Carrollton','Denton',33.005208,-96.89477),('75009','TX','Celina','Collin',33.33285,-96.757771),('75010','TX','Carrollton','Denton',33.029222,-96.887159),('75011','TX','Carrollton','Dallas',32.9536,-96.89),('75013','TX','Allen','Collin',33.110551,-96.691553),('75014','TX','Irving','Dallas',32.842,-96.9719),('75015','TX','Irving','Dallas',32.8297,-96.9815),('75016','TX','Irving','Dallas',32.8138,-96.9486),('75017','TX','Irving','Dallas',32.8118,-96.9473),('75019','TX','Coppell','Dallas',32.969452,-96.984776),('75020','TX','Denison','Grayson',33.756525,-96.580658),('75021','TX','Denison','Grayson',33.736289,-96.510786),('75022','TX','Flower Mound','Denton',33.025753,-97.103545),('75023','TX','Plano','Collin',33.056295,-96.733254),('75024','TX','Plano','Collin',33.079254,-96.805232),('75025','TX','Plano','Collin',33.090656,-96.743522),('75026','TX','Plano','Collin',33.0378,-96.7334),('75027','TX','Flower Mound','Denton',33.0423,-97.0234),('75028','TX','Flower Mound','Denton',33.035321,-97.059404),('75029','TX','Lewisville','Denton',33.0461,-96.9938),('75030','TX','Rowlett','Dallas',32.9027,-96.5636),('75032','TX','Rockwall','Rockwall',32.870998,-96.436311),('75034','TX','Frisco','Denton',33.139178,-96.852839),('75035','TX','Frisco','Collin',33.148387,-96.77696),('75037','TX','Irving','Dallas',32.7833,-96.8),('75038','TX','Irving','Dallas',32.870561,-96.9855),('75039','TX','Irving','Dallas',32.88983,-96.945933),('75040','TX','Garland','Dallas',32.924144,-96.627747),('75041','TX','Garland','Dallas',32.882919,-96.647483),('75042','TX','Garland','Dallas',32.917038,-96.676056),('75043','TX','Garland','Dallas',32.858954,-96.59995),('75044','TX','Garland','Dallas',32.961517,-96.661079),('75045','TX','Garland','Dallas',32.945,-96.6822),('75046','TX','Garland','Dallas',32.9158,-96.6419),('75047','TX','Garland','Dallas',32.8766,-96.6477),('75048','TX','Sachse','Dallas',32.977273,-96.584471),('75049','TX','Garland','Dallas',32.8565,-96.6031),('75050','TX','Grand Prairie','Dallas',32.766027,-97.01713),('75051','TX','Grand Prairie','Dallas',32.729387,-97.004223),('75052','TX','Grand Prairie','Dallas',32.673116,-97.027366),('75053','TX','Grand Prairie','Dallas',32.7361,-97.014),('75054','TX','Grand Prairie','Tarrant',32.59257,-97.045814),('75056','TX','The Colony','Denton',33.071554,-96.895254),('75057','TX','Lewisville','Denton',33.045228,-96.993485),('75058','TX','Gunter','Grayson',33.449112,-96.737121),('75060','TX','Irving','Dallas',32.802795,-96.95495),('75061','TX','Irving','Dallas',32.826633,-96.971212),('75062','TX','Irving','Dallas',32.846884,-96.96049),('75063','TX','Irving','Dallas',32.92177,-96.976995),('75065','TX','Lake Dallas','Denton',33.118654,-97.026555),('75067','TX','Lewisville','Denton',33.014042,-97.001384),('75068','TX','Little Elm','Denton',33.176531,-96.928717),('75069','TX','Mckinney','Collin',33.18603,-96.61404),('75070','TX','Mckinney','Collin',33.173946,-96.698254),('75071','TX','Mckinney','Collin',33.223071,-96.658394),('75074','TX','Plano','Collin',33.028505,-96.677532),('75075','TX','Plano','Collin',33.022974,-96.739381),('75076','TX','Pottsboro','Grayson',33.814248,-96.689896),('75077','TX','Lewisville','Denton',33.073569,-97.047772),('75078','TX','Prosper','Collin',33.240461,-96.800029),('75080','TX','Richardson','Dallas',32.972546,-96.741545),('75081','TX','Richardson','Dallas',32.946624,-96.712047),('75082','TX','Richardson','Collin',32.991271,-96.6661),('75083','TX','Richardson','Dallas',32.9582,-96.7314),('75085','TX','Richardson','Dallas',32.948,-96.7294),('75086','TX','Plano','Collin',33.0234,-96.6986),('75087','TX','Rockwall','Rockwall',32.937792,-96.450677),('75088','TX','Rowlett','Dallas',32.897846,-96.550385),('75089','TX','Rowlett','Dallas',32.923866,-96.546237),('75090','TX','Sherman','Grayson',33.63376,-96.588606),('75091','TX','Sherman','Grayson',33.6355,-96.6086),('75092','TX','Sherman','Grayson',33.652387,-96.661631),('75093','TX','Plano','Collin',33.036298,-96.806104),('75094','TX','Plano','Collin',33.019831,-96.613463),('75097','TX','Weston','Collin',33.3488,-96.6691),('75098','TX','Wylie','Collin',33.01365,-96.542392),('75099','TX','Coppell','Dallas',32.9544,-97.0147),('75101','TX','Bardwell','Ellis',32.266745,-96.696362),('75102','TX','Barry','Navarro',32.055253,-96.645342),('75103','TX','Canton','Van Zandt',32.529982,-95.86971),('75104','TX','Cedar Hill','Dallas',32.586888,-96.949599),('75105','TX','Chatfield','Navarro',32.267126,-96.367988),('75106','TX','Cedar Hill','Dallas',32.5883,-96.9558),('75109','TX','Corsicana','Navarro',32.043684,-96.361167),('75110','TX','Corsicana','Navarro',32.087452,-96.484626),('75114','TX','Crandall','Kaufman',32.62807,-96.447819),('75115','TX','Desoto','Dallas',32.599331,-96.859231),('75116','TX','Duncanville','Dallas',32.658458,-96.912731),('75117','TX','Edgewood','Van Zandt',32.696508,-95.868402),('75118','TX','Elmo','Kaufman',32.7219,-96.1647),('75119','TX','Ennis','Ellis',32.329004,-96.615637),('75120','TX','Ennis','Ellis',32.3291,-96.625),('75121','TX','Copeville','Collin',33.079946,-96.417885),('75123','TX','Desoto','Dallas',32.5868,-96.8566),('75124','TX','Eustace','Henderson',32.313538,-96.000742),('75125','TX','Ferris','Ellis',32.529051,-96.658958),('75126','TX','Forney','Kaufman',32.743811,-96.45135),('75127','TX','Fruitvale','Van Zandt',32.683213,-95.794731),('75132','TX','Fate','Rockwall',32.939857,-96.377137),('75134','TX','Lancaster','Dallas',32.619251,-96.784193),('75135','TX','Caddo Mills','Hunt',33.06581,-96.227235),('75137','TX','Duncanville','Dallas',32.637209,-96.909616),('75138','TX','Duncanville','Dallas',32.6516,-96.908),('75140','TX','Grand Saline','Van Zandt',32.653866,-95.701252),('75141','TX','Hutchins','Dallas',32.644889,-96.705802),('75142','TX','Kaufman','Kaufman',32.580495,-96.292686),('75143','TX','Kemp','Henderson',32.363962,-96.213033),('75144','TX','Kerens','Navarro',32.108245,-96.215555),('75146','TX','Lancaster','Dallas',32.588313,-96.762463),('75147','TX','Mabank','Kaufman',32.39098,-96.091877),('75148','TX','Malakoff','Henderson',32.183815,-96.018178),('75149','TX','Mesquite','Dallas',32.76775,-96.61073),('75150','TX','Mesquite','Dallas',32.817309,-96.630277),('75151','TX','Corsicana','Navarro',32.0905,-96.4629),('75152','TX','Palmer','Ellis',32.430025,-96.676162),('75153','TX','Powell','Navarro',32.127365,-96.338597),('75154','TX','Red Oak','Ellis',32.530339,-96.810964),('75155','TX','Rice','Navarro',32.230652,-96.489381),('75156','TX','Mabank','Henderson',32.292827,-96.111552),('75157','TX','Rosser','Kaufman',32.460979,-96.450969),('75158','TX','Scurry','Kaufman',32.469226,-96.380662),('75159','TX','Seagoville','Dallas',32.621037,-96.546776),('75160','TX','Terrell','Kaufman',32.748555,-96.295553),('75161','TX','Terrell','Kaufman',32.730874,-96.185586),('75163','TX','Trinidad','Henderson',32.174567,-96.105531),('75164','TX','Josephine','Collin',33.065118,-96.310062),('75165','TX','Waxahachie','Ellis',32.402573,-96.82065),('75166','TX','Lavon','Collin',33.022982,-96.447124),('75167','TX','Waxahachie','Ellis',32.385318,-96.899902),('75168','TX','Waxahachie','Ellis',32.3048,-96.7722),('75169','TX','Wills Point','Van Zandt',32.730987,-96.000402),('75172','TX','Wilmer','Dallas',32.597567,-96.680228),('75173','TX','Nevada','Collin',33.052058,-96.393823),('75180','TX','Mesquite','Dallas',32.718052,-96.617262),('75181','TX','Mesquite','Dallas',32.735968,-96.558874),('75182','TX','Sunnyvale','Dallas',32.797737,-96.567617),('75185','TX','Mesquite','Dallas',32.7666,-96.5988),('75187','TX','Mesquite','Dallas',32.7666,-96.5988),('75189','TX','Royse City','Rockwall',32.95578,-96.306226),('75201','TX','Dallas','Dallas',32.787651,-96.799286),('75202','TX','Dallas','Dallas',32.780085,-96.80374),('75203','TX','Dallas','Dallas',32.745928,-96.806866),('75204','TX','Dallas','Dallas',32.800808,-96.78867),('75205','TX','Dallas','Dallas',32.835893,-96.795514),('75206','TX','Dallas','Dallas',32.827785,-96.771217),('75207','TX','Dallas','Dallas',32.7877,-96.820656),('75208','TX','Dallas','Dallas',32.751135,-96.838686),('75209','TX','Dallas','Dallas',32.846072,-96.825509),('75210','TX','Dallas','Dallas',32.770537,-96.748275),('75211','TX','Dallas','Dallas',32.736713,-96.885634),('75212','TX','Dallas','Dallas',32.780194,-96.875351),('75214','TX','Dallas','Dallas',32.826159,-96.748713),('75215','TX','Dallas','Dallas',32.758497,-96.767505),('75216','TX','Dallas','Dallas',32.710094,-96.797339),('75217','TX','Dallas','Dallas',32.720998,-96.676408),('75218','TX','Dallas','Dallas',32.842773,-96.701979),('75219','TX','Dallas','Dallas',32.811727,-96.811487),('75220','TX','Dallas','Dallas',32.868764,-96.864733),('75221','TX','Dallas','Dallas',32.7836,-96.7986),('75222','TX','Dallas','Dallas',32.7833,-96.8),('75223','TX','Dallas','Dallas',32.791949,-96.750359),('75224','TX','Dallas','Dallas',32.714334,-96.84006),('75225','TX','Dallas','Dallas',32.863875,-96.790331),('75226','TX','Dallas','Dallas',32.782292,-96.776403),('75227','TX','Dallas','Dallas',32.767748,-96.687143),('75228','TX','Dallas','Dallas',32.824925,-96.679442),('75229','TX','Dallas','Dallas',32.894583,-96.859858),('75230','TX','Dallas','Dallas',32.902679,-96.793393),('75231','TX','Dallas','Dallas',32.877627,-96.751902),('75232','TX','Dallas','Dallas',32.664065,-96.839076),('75233','TX','Dallas','Dallas',32.705442,-96.871101),('75234','TX','Dallas','Dallas',32.924489,-96.886005),('75235','TX','Dallas','Dallas',32.82836,-96.846157),('75236','TX','Dallas','Dallas',32.682009,-96.922664),('75237','TX','Dallas','Dallas',32.662255,-96.876283),('75238','TX','Dallas','Dallas',32.877359,-96.707622),('75240','TX','Dallas','Dallas',32.932014,-96.786205),('75241','TX','Dallas','Dallas',32.667599,-96.774505),('75242','TX','Dallas','Dallas',32.7833,-96.8),('75243','TX','Dallas','Dallas',32.911927,-96.736885),('75244','TX','Dallas','Dallas',32.92342,-96.836687),('75245','TX','Dallas','Dallas',32.8207,-96.8398),('75246','TX','Dallas','Dallas',32.792497,-96.772763),('75247','TX','Dallas','Dallas',32.819495,-96.878076),('75248','TX','Dallas','Dallas',32.968694,-96.7947),('75249','TX','Dallas','Dallas',32.639638,-96.954958),('75250','TX','Dallas','Dallas',32.7801,-96.8014),('75251','TX','Dallas','Dallas',32.919776,-96.770934),('75252','TX','Dallas','Collin',32.998166,-96.791375),('75253','TX','Dallas','Dallas',32.68369,-96.600661),('75254','TX','Dallas','Dallas',32.944116,-96.80009),('75258','TX','Dallas','Dallas',32.8092,-96.8894),('75260','TX','Dallas','Dallas',32.7833,-96.8),('75261','TX','Dallas','Dallas',32.8932,-97.039694),('75262','TX','Dallas','Dallas',32.7833,-96.8),('75263','TX','Dallas','Dallas',32.7833,-96.8),('75264','TX','Dallas','Dallas',32.7833,-96.8),('75265','TX','Dallas','Dallas',32.7833,-96.8),('75266','TX','Dallas','Dallas',32.7833,-96.8),('75267','TX','Dallas','Dallas',32.7833,-96.8),('75270','TX','Dallas','Dallas',32.78133,-96.801988),('75275','TX','Dallas','Dallas',32.8351,-96.7848),('75277','TX','Dallas','Dallas',32.7833,-96.8),('75283','TX','Dallas','Dallas',32.8366,-96.7963),('75284','TX','Dallas','Dallas',32.8366,-96.7963),('75285','TX','Dallas','Dallas',32.7833,-96.8),('75286','TX','Dallas','Dallas',32.7833,-96.8),('75287','TX','Dallas','Denton',33.001874,-96.841028),('75301','TX','Dallas','Dallas',32.7833,-96.8),('75303','TX','Dallas','Dallas',32.7833,-96.8),('75310','TX','Dallas','Dallas',32.7833,-96.8),('75312','TX','Dallas','Dallas',32.7833,-96.8),('75313','TX','Dallas','Dallas',32.7833,-96.8),('75315','TX','Dallas','Dallas',32.7739,-96.7689),('75320','TX','Dallas','Dallas',32.7833,-96.8),('75323','TX','Dallas','Dallas',32.9698,-96.8001),('75326','TX','Dallas','Dallas',32.8633,-96.9804),('75334','TX','Dallas','Dallas',32.6746,-96.6198),('75336','TX','Dallas','Dallas',32.6713,-96.6193),('75339','TX','Dallas','Dallas',32.7144,-96.7835),('75340','TX','Dallas','Dallas',32.7699,-96.8641),('75342','TX','Dallas','Dallas',32.809,-96.8894),('75343','TX','Dallas','Dallas',32.7699,-96.8641),('75344','TX','Dallas','Dallas',32.7825,-96.7986),('75353','TX','Dallas','Dallas',32.7833,-96.8),('75354','TX','Dallas','Dallas',32.8601,-96.8869),('75355','TX','Dallas','Dallas',32.8791,-96.708),('75356','TX','Dallas','Dallas',32.8092,-96.8894),('75357','TX','Dallas','Dallas',32.7833,-96.8),('75358','TX','Dallas','Dallas',32.9378,-96.7908),('75359','TX','Dallas','Dallas',32.8136,-96.7559),('75360','TX','Dallas','Dallas',32.8282,-96.7456),('75363','TX','Dallas','Dallas',32.9382,-96.7932),('75364','TX','Dallas','Dallas',32.7833,-96.8),('75367','TX','Dallas','Dallas',32.9022,-96.7921),('75368','TX','Dallas','Dallas',32.9207,-96.9762),('75370','TX','Dallas','Dallas',32.9899,-96.831),('75371','TX','Dallas','Dallas',32.7739,-96.7689),('75372','TX','Dallas','Dallas',32.8417,-96.7723),('75373','TX','Dallas','Dallas',32.7833,-96.8),('75374','TX','Dallas','Dallas',32.9133,-96.7439),('75376','TX','Dallas','Dallas',32.7107,-96.8388),('75378','TX','Dallas','Dallas',32.894,-96.8697),('75379','TX','Dallas','Dallas',32.9382,-96.7932),('75380','TX','Dallas','Dallas',32.9335,-96.8172),('75381','TX','Dallas','Dallas',32.9439,-96.8899),('75382','TX','Dallas','Dallas',32.8775,-96.7492),('75386','TX','Dallas','Dallas',32.7815,-96.8779),('75387','TX','Dallas','Dallas',32.7833,-96.8),('75388','TX','Dallas','Dallas',32.7833,-96.8),('75389','TX','Dallas','Dallas',32.7833,-96.8),('75390','TX','Dallas','Dallas',32.8126,-96.8384),('75391','TX','Dallas','Dallas',32.8366,-96.7963),('75392','TX','Dallas','Dallas',32.7833,-96.8),('75393','TX','Dallas','Dallas',32.7833,-96.8),('75394','TX','Dallas','Dallas',32.7833,-96.8),('75395','TX','Dallas','Dallas',32.7107,-96.8388),('75396','TX','Dallas','Dallas',32.7833,-96.8),('75397','TX','Dallas','Dallas',32.7833,-96.8),('75398','TX','Dallas','Dallas',32.7833,-96.8),('75401','TX','Greenville','Hunt',33.150197,-96.113132),('75402','TX','Greenville','Hunt',33.087367,-96.104393),('75403','TX','Greenville','Hunt',33.1919,-96.1016),('75404','TX','Greenville','Hunt',33.1919,-96.1016),('75407','TX','Princeton','Collin',33.154197,-96.496005),('75409','TX','Anna','Collin',33.348708,-96.542941),('75410','TX','Alba','Wood',32.798348,-95.62298),('75411','TX','Arthur City','Lamar',33.857077,-95.621527),('75412','TX','Bagwell','Red River',33.800831,-95.134941),('75413','TX','Bailey','Fannin',33.434811,-96.167724),('75414','TX','Bells','Grayson',33.618542,-96.417344),('75415','TX','Ben Franklin','Delta',33.472819,-95.768239),('75416','TX','Blossom','Lamar',33.686117,-95.371501),('75417','TX','Bogata','Red River',33.448324,-95.188469),('75418','TX','Bonham','Fannin',33.58788,-96.181412),('75420','TX','Brashear','Hopkins',33.063428,-95.73316),('75421','TX','Brookston','Lamar',33.63791,-95.703749),('75422','TX','Campbell','Hunt',33.147616,-95.942012),('75423','TX','Celeste','Hunt',33.291158,-96.20827),('75424','TX','Blue Ridge','Collin',33.305249,-96.383633),('75425','TX','Chicota','Lamar',33.8688,-95.5708),('75426','TX','Clarksville','Red River',33.62649,-95.035258),('75428','TX','Commerce','Hunt',33.253301,-95.908041),('75429','TX','Commerce','Hunt',33.3006,-95.9344),('75431','TX','Como','Hopkins',33.014188,-95.461008),('75432','TX','Cooper','Delta',33.384396,-95.686021),('75433','TX','Cumby','Hopkins',33.135356,-95.804965),('75434','TX','Cunningham','Lamar',33.423626,-95.356708),('75435','TX','Deport','Lamar',33.49627,-95.323538),('75436','TX','Detroit','Red River',33.667709,-95.257377),('75437','TX','Dike','Hopkins',33.253248,-95.469978),('75438','TX','Dodd City','Fannin',33.596952,-96.071929),('75439','TX','Ector','Fannin',33.57258,-96.270205),('75440','TX','Emory','Rains',32.892878,-95.732703),('75441','TX','Enloe','Delta',33.433752,-95.65784),('75442','TX','Farmersville','Collin',33.176507,-96.351932),('75443','TX','Gober','Fannin',33.4688,-96.0883),('75444','TX','Golden','Wood',32.730279,-95.562864),('75446','TX','Honey Grove','Fannin',33.59937,-95.895744),('75447','TX','Ivanhoe','Fannin',33.773826,-96.120493),('75448','TX','Klondike','Delta',33.324396,-95.77926),('75449','TX','Ladonia','Fannin',33.422719,-95.946765),('75450','TX','Lake Creek','Delta',33.412001,-95.48784),('75451','TX','Leesburg','Camp',32.97825,-95.12867),('75452','TX','Leonard','Fannin',33.387733,-96.252724),('75453','TX','Lone Oak','Hunt',32.982555,-95.952618),('75454','TX','Melissa','Collin',33.284296,-96.571389),('75455','TX','Mount Pleasant','Titus',33.176021,-94.978638),('75456','TX','Mount Pleasant','Titus',33.2157,-94.9502),('75457','TX','Mount Vernon','Franklin',33.150042,-95.219227),('75458','TX','Merit','Hunt',33.2166,-96.2872),('75459','TX','Howe','Grayson',33.516744,-96.649219),('75460','TX','Paris','Lamar',33.662491,-95.562313),('75461','TX','Paris','Lamar',33.5604,-95.554),('75462','TX','Paris','Lamar',33.637891,-95.498118),('75468','TX','Pattonville','Lamar',33.48088,-95.391066),('75469','TX','Pecan Gap','Delta',33.430487,-95.82789),('75470','TX','Petty','Lamar',33.5976,-95.810958),('75471','TX','Pickton','Hopkins',33.026574,-95.391803),('75472','TX','Point','Rains',32.891298,-95.903879),('75473','TX','Powderly','Lamar',33.802968,-95.524013),('75474','TX','Quinlan','Hunt',32.909107,-96.088102),('75475','TX','Randolph','Fannin',33.484786,-96.252883),('75476','TX','Ravenna','Fannin',33.694464,-96.233971),('75477','TX','Roxton','Lamar',33.538638,-95.724273),('75478','TX','Saltillo','Hopkins',33.166365,-95.3676),('75479','TX','Savoy','Fannin',33.601985,-96.349896),('75480','TX','Scroggins','Franklin',33.043708,-95.193943),('75481','TX','Sulphur Bluff','Hopkins',33.330664,-95.384451),('75482','TX','Sulphur Springs','Hopkins',33.160597,-95.605779),('75483','TX','Sulphur Springs','Hopkins',33.1391,-95.6004),('75485','TX','Westminster','Collin',33.362227,-96.462997),('75486','TX','Sumner','Lamar',33.733984,-95.721758),('75487','TX','Talco','Titus',33.350983,-95.14658),('75488','TX','Telephone','Fannin',33.757103,-95.992985),('75489','TX','Tom Bean','Grayson',33.51986,-96.48292),('75490','TX','Trenton','Fannin',33.433441,-96.330658),('75491','TX','Whitewright','Grayson',33.497198,-96.405999),('75492','TX','Windom','Fannin',33.570465,-96.001181),('75493','TX','Winfield','Titus',33.153995,-95.112627),('75494','TX','Winnsboro','Wood',32.921856,-95.282526),('75495','TX','Van Alstyne','Grayson',33.42984,-96.570399),('75496','TX','Wolfe City','Hunt',33.360019,-96.066905),('75497','TX','Yantis','Wood',32.908223,-95.564876),('75501','TX','Texarkana','Bowie',33.412474,-94.09239),('75503','TX','Texarkana','Bowie',33.478934,-94.098838),('75504','TX','Texarkana','Bowie',33.3549,-94.2202),('75505','TX','Texarkana','Bowie',33.425,-94.0475),('75507','TX','Texarkana','Bowie',33.3549,-94.2202),('75550','TX','Annona','Red River',33.528768,-94.890747),('75551','TX','Atlanta','Cass',33.118875,-94.184194),('75554','TX','Avery','Red River',33.563881,-94.780344),('75555','TX','Bivins','Cass',32.936254,-94.134538),('75556','TX','Bloomburg','Cass',33.144905,-94.057316),('75558','TX','Cookville','Titus',33.241094,-94.84855),('75559','TX','De Kalb','Bowie',33.513841,-94.613078),('75560','TX','Douglassville','Cass',33.18956,-94.375459),('75561','TX','Hooks','Bowie',33.490651,-94.266599),('75562','TX','Kildare','Cass',32.91525,-94.24467),('75563','TX','Linden','Cass',33.01274,-94.374626),('75564','TX','Lodi','Marion',32.880182,-94.277257),('75565','TX','Mc Leod','Cass',32.944391,-94.077456),('75566','TX','Marietta','Cass',33.159764,-94.506135),('75567','TX','Maud','Bowie',33.337291,-94.325263),('75568','TX','Naples','Morris',33.197795,-94.60801),('75569','TX','Nash','Bowie',33.440204,-94.125569),('75570','TX','New Boston','Bowie',33.466973,-94.422351),('75571','TX','Omaha','Morris',33.19946,-94.748877),('75572','TX','Queen City','Cass',33.210577,-94.136128),('75573','TX','Redwater','Bowie',33.351379,-94.251301),('75574','TX','Simms','Bowie',33.33617,-94.531088),('75599','TX','Texarkana','Bowie',33.4425,-94.0776),('75601','TX','Longview','Gregg',32.505611,-94.730684),('75602','TX','Longview','Gregg',32.471735,-94.709285),('75603','TX','Longview','Gregg',32.407711,-94.719762),('75604','TX','Longview','Gregg',32.519138,-94.820589),('75605','TX','Longview','Gregg',32.568574,-94.749511),('75606','TX','Longview','Gregg',32.4955,-94.7377),('75607','TX','Longview','Gregg',32.4628,-94.7305),('75608','TX','Longview','Gregg',32.5005,-94.7402),('75615','TX','Longview','Gregg',32.4628,-94.7305),('75630','TX','Avinger','Marion',32.853132,-94.572425),('75631','TX','Beckville','Panola',32.248663,-94.457718),('75633','TX','Carthage','Panola',32.144409,-94.312058),('75636','TX','Cason','Morris',33.035716,-94.815893),('75637','TX','Clayton','Panola',32.098,-94.4747),('75638','TX','Daingerfield','Morris',33.020678,-94.725188),('75639','TX','De Berry','Panola',32.293824,-94.169679),('75640','TX','Diana','Upshur',32.720432,-94.701325),('75641','TX','Easton','Gregg',32.384592,-94.583812),('75642','TX','Elysian Fields','Harrison',32.368842,-94.18142),('75643','TX','Gary','Panola',32.025379,-94.358114),('75644','TX','Gilmer','Upshur',32.752481,-94.989899),('75645','TX','Gilmer','Upshur',32.665224,-94.884317),('75647','TX','Gladewater','Gregg',32.530274,-94.938927),('75650','TX','Hallsville','Harrison',32.499755,-94.556065),('75651','TX','Harleton','Harrison',32.677144,-94.548789),('75652','TX','Henderson','Rusk',32.193239,-94.770224),('75653','TX','Henderson','Rusk',32.1493,-94.7991),('75654','TX','Henderson','Rusk',32.101642,-94.843579),('75656','TX','Hughes Springs','Cass',32.998086,-94.615155),('75657','TX','Jefferson','Marion',32.770711,-94.349741),('75658','TX','Joinerville','Rusk',32.1777,-94.9005),('75659','TX','Jonesville','Harrison',32.4977,-94.1108),('75660','TX','Judson','Gregg',32.5825,-94.7533),('75661','TX','Karnack','Harrison',32.650981,-94.168288),('75662','TX','Kilgore','Gregg',32.397839,-94.871533),('75663','TX','Kilgore','Gregg',32.3861,-94.8755),('75666','TX','Laird Hill','Rusk',32.353,-94.9052),('75667','TX','Laneville','Rusk',31.988175,-94.844274),('75668','TX','Lone Star','Morris',32.921433,-94.697516),('75669','TX','Long Branch','Panola',32.0388,-94.57588),('75670','TX','Marshall','Harrison',32.549743,-94.384662),('75671','TX','Marshall','Harrison',32.5447,-94.3672),('75672','TX','Marshall','Harrison',32.510524,-94.317077),('75680','TX','Minden','Rusk',32.00923,-94.717666),('75681','TX','Mount Enterprise','Rusk',31.932755,-94.688993),('75682','TX','New London','Rusk',32.246052,-94.942191),('75683','TX','Ore City','Upshur',32.816125,-94.7028),('75684','TX','Overton','Rusk',32.27075,-94.949061),('75685','TX','Panola','Panola',32.3577,-94.0911),('75686','TX','Pittsburg','Camp',32.988088,-94.973331),('75687','TX','Price','Rusk',32.1018,-94.942),('75688','TX','Scottsville','Harrison',32.5402,-94.238),('75689','TX','Selman City','Rusk',32.1657,-94.9453),('75691','TX','Tatum','Rusk',32.295551,-94.551138),('75692','TX','Waskom','Harrison',32.476185,-94.093447),('75693','TX','White Oak','Gregg',32.53357,-94.862853),('75694','TX','Woodlawn','Harrison',32.668,-94.3455),('75701','TX','Tyler','Smith',32.325338,-95.294641),('75702','TX','Tyler','Smith',32.359614,-95.308255),('75703','TX','Tyler','Smith',32.261206,-95.314441),('75704','TX','Tyler','Smith',32.391869,-95.41896),('75705','TX','Tyler','Smith',32.367166,-95.127657),('75706','TX','Tyler','Smith',32.455775,-95.331264),('75707','TX','Tyler','Smith',32.293278,-95.207704),('75708','TX','Tyler','Smith',32.413344,-95.21949),('75709','TX','Tyler','Smith',32.321781,-95.38849),('75710','TX','Tyler','Smith',32.3511,-95.3008),('75711','TX','Tyler','Smith',32.3511,-95.3008),('75712','TX','Tyler','Smith',32.3511,-95.3008),('75713','TX','Tyler','Smith',32.3511,-95.3008),('75750','TX','Arp','Smith',32.246758,-95.069611),('75751','TX','Athens','Henderson',32.159274,-95.87622),('75752','TX','Athens','Henderson',32.230041,-95.801859),('75754','TX','Ben Wheeler','Van Zandt',32.427978,-95.661983),('75755','TX','Big Sandy','Upshur',32.621879,-95.080069),('75756','TX','Brownsboro','Henderson',32.304127,-95.604842),('75757','TX','Bullard','Smith',32.118478,-95.369293),('75758','TX','Chandler','Henderson',32.268958,-95.502063),('75759','TX','Cuney','Cherokee',32.033452,-95.417846),('75760','TX','Cushing','Nacogdoches',31.80991,-94.863209),('75762','TX','Flint','Smith',32.199915,-95.411372),('75763','TX','Frankston','Anderson',32.071001,-95.501237),('75764','TX','Gallatin','Cherokee',31.89237,-95.145217),('75765','TX','Hawkins','Wood',32.634189,-95.225865),('75766','TX','Jacksonville','Cherokee',31.954939,-95.254186),('75770','TX','Larue','Henderson',32.131611,-95.645165),('75771','TX','Lindale','Smith',32.529018,-95.427302),('75772','TX','Maydelle','Cherokee',31.8581,-95.3281),('75773','TX','Mineola','Wood',32.671276,-95.46781),('75778','TX','Murchison','Henderson',32.322224,-95.713025),('75779','TX','Neches','Anderson',31.86633,-95.494972),('75780','TX','New Summerfield','Cherokee',31.986463,-95.091389),('75782','TX','Poynor','Henderson',32.075703,-95.599198),('75783','TX','Quitman','Wood',32.811099,-95.440978),('75784','TX','Reklaw','Cherokee',31.879426,-94.970086),('75785','TX','Rusk','Cherokee',31.795114,-95.170321),('75788','TX','Sacul','Nacogdoches',31.823738,-94.920471),('75789','TX','Troup','Smith',32.12062,-95.117784),('75790','TX','Van','Van Zandt',32.531164,-95.638924),('75791','TX','Whitehouse','Smith',32.225851,-95.216692),('75792','TX','Winona','Smith',32.475848,-95.109783),('75797','TX','Big Sandy','Upshur',32.5872,-95.1147),('75798','TX','Tyler','Smith',32.3325,-95.2848),('75799','TX','Tyler','Smith',32.3132,-95.2457),('75801','TX','Palestine','Anderson',31.743447,-95.603366),('75802','TX','Palestine','Anderson',31.7619,-95.6305),('75803','TX','Palestine','Anderson',31.841266,-95.661744),('75831','TX','Buffalo','Leon',31.454742,-96.038276),('75832','TX','Cayuga','Anderson',31.935511,-96.000828),('75833','TX','Centerville','Leon',31.27705,-95.872586),('75834','TX','Centralia','Trinity',31.2577,-95.0397),('75835','TX','Crockett','Houston',31.311466,-95.465641),('75838','TX','Donie','Freestone',31.4774,-96.224616),('75839','TX','Elkhart','Anderson',31.621232,-95.561949),('75840','TX','Fairfield','Freestone',31.769114,-96.119179),('75844','TX','Grapeland','Houston',31.512827,-95.449854),('75845','TX','Groveton','Trinity',31.090567,-95.080996),('75846','TX','Jewett','Leon',31.352198,-96.170079),('75847','TX','Kennard','Houston',31.356209,-95.152898),('75848','TX','Kirvin','Freestone',31.765925,-96.331116),('75849','TX','Latexo','Houston',31.418602,-95.48112),('75850','TX','Leona','Leon',31.145712,-95.956603),('75851','TX','Lovelady','Houston',31.08006,-95.510825),('75852','TX','Midway','Madison',30.978895,-95.700545),('75853','TX','Montalba','Anderson',31.946003,-95.813468),('75855','TX','Oakwood','Leon',31.580361,-95.856314),('75856','TX','Pennington','Trinity',31.18883,-95.245133),('75858','TX','Ratcliff','Houston',31.39143,-95.134874),('75859','TX','Streetman','Freestone',31.887924,-96.254291),('75860','TX','Teague','Freestone',31.625296,-96.260962),('75861','TX','Tennessee Colony','Anderson',31.82411,-95.885294),('75862','TX','Trinity','Trinity',30.937906,-95.341864),('75865','TX','Woodlake','Trinity',31.0286,-95.0327),('75880','TX','Tennessee Colony','Anderson',31.8352,-95.8386),('75882','TX','Palestine','Anderson',31.7619,-95.6305),('75884','TX','Tennessee Colony','Anderson',31.8352,-95.8386),('75886','TX','Tennessee Colony','Anderson',31.8352,-95.8386),('75901','TX','Lufkin','Angelina',31.324725,-94.690231),('75902','TX','Lufkin','Angelina',31.338,-94.7288),('75903','TX','Lufkin','Angelina',31.338,-94.7288),('75904','TX','Lufkin','Angelina',31.343228,-94.768081),('75915','TX','Lufkin','Angelina',31.338,-94.7288),('75925','TX','Alto','Cherokee',31.614231,-95.060108),('75926','TX','Apple Springs','Trinity',31.244746,-94.96054),('75928','TX','Bon Wier','Newton',30.681712,-93.685943),('75929','TX','Broaddus','San Augustine',31.232799,-94.190852),('75930','TX','Bronson','Sabine',31.330136,-94.020871),('75931','TX','Brookeland','Jasper',31.106019,-93.99896),('75932','TX','Burkeville','Newton',31.067793,-93.610118),('75933','TX','Call','Newton',30.572655,-93.828387),('75934','TX','Camden','Polk',30.907095,-94.731014),('75935','TX','Center','Shelby',31.748597,-94.203859),('75936','TX','Chester','Tyler',30.942108,-94.584496),('75937','TX','Chireno','Nacogdoches',31.483607,-94.351212),('75938','TX','Colmesneil','Tyler',30.917063,-94.350584),('75939','TX','Corrigan','Polk',31.005906,-94.797568),('75941','TX','Diboll','Angelina',31.190814,-94.779843),('75942','TX','Doucette','Tyler',30.817723,-94.428603),('75943','TX','Douglass','Nacogdoches',31.673123,-94.882639),('75944','TX','Etoile','Nacogdoches',31.364208,-94.419299),('75946','TX','Garrison','Nacogdoches',31.811477,-94.535223),('75948','TX','Hemphill','Sabine',31.306206,-93.795931),('75949','TX','Huntington','Angelina',31.240036,-94.527954),('75951','TX','Jasper','Jasper',30.935109,-94.034422),('75954','TX','Joaquin','Shelby',31.950703,-94.058393),('75956','TX','Kirbyville','Jasper',30.669047,-93.939491),('75958','TX','Martinsville','Nacogdoches',31.6425,-94.4138),('75959','TX','Milam','Sabine',31.504442,-93.835825),('75960','TX','Moscow','Polk',30.930387,-94.85955),('75961','TX','Nacogdoches','Nacogdoches',31.577269,-94.579804),('75962','TX','Nacogdoches','Nacogdoches',31.619048,-94.649031),('75963','TX','Nacogdoches','Nacogdoches',31.6331,-94.6402),('75964','TX','Nacogdoches','Nacogdoches',31.611771,-94.705397),('75965','TX','Nacogdoches','Nacogdoches',31.68707,-94.645233),('75966','TX','Newton','Newton',30.838996,-93.743535),('75968','TX','Pineland','Sabine',31.246242,-93.962279),('75969','TX','Pollok','Angelina',31.436502,-94.882293),('75972','TX','San Augustine','San Augustine',31.501638,-94.129347),('75973','TX','Shelbyville','Shelby',31.742386,-93.906338),('75974','TX','Tenaha','Shelby',31.947007,-94.245312),('75975','TX','Timpson','Shelby',31.899739,-94.409789),('75976','TX','Wells','Cherokee',31.501001,-94.942411),('75977','TX','Wiergate','Newton',31.062458,-93.774073),('75978','TX','Woden','Nacogdoches',31.509348,-94.526425),('75979','TX','Woodville','Tyler',30.76607,-94.41114),('75980','TX','Zavalla','Angelina',31.138382,-94.375214),('75990','TX','Woodville','Tyler',30.775,-94.4152),('76001','TX','Arlington','Tarrant',32.63447,-97.146189),('76002','TX','Arlington','Tarrant',32.622321,-97.093204),('76003','TX','Arlington','Tarrant',32.6578,-97.1723),('76004','TX','Arlington','Tarrant',32.7344,-97.1043),('76005','TX','Arlington','Tarrant',32.7531,-97.0591),('76006','TX','Arlington','Tarrant',32.776885,-97.084165),('76007','TX','Arlington','Tarrant',32.7204,-97.0822),('76008','TX','Aledo','Parker',32.696273,-97.637553),('76009','TX','Alvarado','Johnson',32.415022,-97.213831),('76010','TX','Arlington','Tarrant',32.722177,-97.084365),('76011','TX','Arlington','Tarrant',32.756694,-97.082982),('76012','TX','Arlington','Tarrant',32.754983,-97.136141),('76013','TX','Arlington','Tarrant',32.718087,-97.150684),('76014','TX','Arlington','Tarrant',32.69426,-97.087945),('76015','TX','Arlington','Tarrant',32.691459,-97.133389),('76016','TX','Arlington','Tarrant',32.687444,-97.192096),('76017','TX','Arlington','Tarrant',32.662513,-97.164024),('76018','TX','Arlington','Tarrant',32.658046,-97.088148),('76019','TX','Arlington','Tarrant',32.7286,-97.1159),('76020','TX','Azle','Tarrant',32.907997,-97.548959),('76021','TX','Bedford','Tarrant',32.852042,-97.133157),('76022','TX','Bedford','Tarrant',32.831235,-97.14625),('76023','TX','Boyd','Wise',33.059655,-97.580089),('76028','TX','Burleson','Johnson',32.533144,-97.310985),('76031','TX','Cleburne','Johnson',32.366682,-97.354669),('76033','TX','Cleburne','Johnson',32.317785,-97.443913),('76034','TX','Colleyville','Tarrant',32.890064,-97.147489),('76035','TX','Cresson','Parker',32.552688,-97.627433),('76036','TX','Crowley','Tarrant',32.57698,-97.380894),('76039','TX','Euless','Tarrant',32.858711,-97.081999),('76040','TX','Euless','Tarrant',32.825031,-97.102497),('76041','TX','Forreston','Ellis',32.254238,-96.854804),('76043','TX','Glen Rose','Somervell',32.219692,-97.802217),('76044','TX','Godley','Johnson',32.443696,-97.528815),('76048','TX','Granbury','Hood',32.431262,-97.793009),('76049','TX','Granbury','Hood',32.447211,-97.709978),('76050','TX','Grandview','Johnson',32.275474,-97.175564),('76051','TX','Grapevine','Tarrant',32.923522,-97.07612),('76052','TX','Haslet','Tarrant',32.976957,-97.383632),('76053','TX','Hurst','Tarrant',32.820647,-97.180882),('76054','TX','Hurst','Tarrant',32.859379,-97.177031),('76055','TX','Itasca','Hill',32.160232,-97.147638),('76058','TX','Joshua','Johnson',32.463493,-97.403474),('76059','TX','Keene','Johnson',32.392588,-97.32754),('76060','TX','Kennedale','Tarrant',32.64259,-97.212662),('76061','TX','Lillian','Johnson',32.503175,-97.188025),('76063','TX','Mansfield','Tarrant',32.578089,-97.127713),('76064','TX','Maypearl','Ellis',32.310397,-97.020447),('76065','TX','Midlothian','Ellis',32.477022,-96.985735),('76066','TX','Millsap','Parker',32.709303,-98.006767),('76067','TX','Mineral Wells','Palo Pinto',32.809535,-98.107125),('76068','TX','Mineral Wells','Palo Pinto',32.8083,-98.1125),('76070','TX','Nemo','Somervell',32.283294,-97.666476),('76071','TX','Newark','Wise',33.004262,-97.488601),('76073','TX','Paradise','Wise',33.105273,-97.715041),('76077','TX','Rainbow','Somervell',32.279715,-97.70534),('76078','TX','Rhome','Wise',33.077481,-97.472058),('76082','TX','Springtown','Parker',32.96779,-97.693253),('76084','TX','Venus','Johnson',32.435551,-97.095772),('76085','TX','Weatherford','Parker',32.843029,-97.709937),('76086','TX','Weatherford','Parker',32.756885,-97.794927),('76087','TX','Weatherford','Parker',32.708132,-97.740333),('76088','TX','Weatherford','Parker',32.827654,-97.888924),('76092','TX','Southlake','Tarrant',32.952066,-97.147786),('76093','TX','Rio Vista','Johnson',32.215221,-97.384062),('76094','TX','Arlington','Tarrant',32.7234,-97.1487),('76095','TX','Bedford','Tarrant',32.8408,-97.1325),('76096','TX','Arlington','Tarrant',32.621,-97.0718),('76097','TX','Burleson','Johnson',32.5419,-97.3205),('76098','TX','Azle','Parker',32.8995,-97.5399),('76099','TX','Grapevine','Tarrant',32.9341,-97.0777),('76101','TX','Fort Worth','Tarrant',32.7469,-97.3268),('76102','TX','Fort Worth','Tarrant',32.75542,-97.330178),('76103','TX','Fort Worth','Tarrant',32.744147,-97.266773),('76104','TX','Fort Worth','Tarrant',32.730634,-97.319674),('76105','TX','Fort Worth','Tarrant',32.723957,-97.27199),('76106','TX','Fort Worth','Tarrant',32.807455,-97.353233),('76107','TX','Fort Worth','Tarrant',32.740421,-97.381795),('76108','TX','Fort Worth','Tarrant',32.761416,-97.488329),('76109','TX','Fort Worth','Tarrant',32.699012,-97.382473),('76110','TX','Fort Worth','Tarrant',32.706677,-97.337984),('76111','TX','Fort Worth','Tarrant',32.778509,-97.302913),('76112','TX','Fort Worth','Tarrant',32.747404,-97.219908),('76113','TX','Fort Worth','Tarrant',32.7469,-97.3268),('76114','TX','Fort Worth','Tarrant',32.778167,-97.402227),('76115','TX','Fort Worth','Tarrant',32.67851,-97.333343),('76116','TX','Fort Worth','Tarrant',32.72205,-97.445636),('76117','TX','Haltom City','Tarrant',32.808181,-97.27171),('76118','TX','Fort Worth','Tarrant',32.804838,-97.218789),('76119','TX','Fort Worth','Tarrant',32.689201,-97.265091),('76120','TX','Fort Worth','Tarrant',32.760158,-97.181273),('76121','TX','Fort Worth','Tarrant',32.7314,-97.4503),('76122','TX','Fort Worth','Tarrant',32.6824,-97.3469),('76123','TX','Fort Worth','Tarrant',32.620983,-97.382698),('76124','TX','Fort Worth','Tarrant',32.7471,-97.2159),('76126','TX','Fort Worth','Tarrant',32.659535,-97.487686),('76127','TX','Naval Air Station/ Jrb','Tarrant',32.778248,-97.42359),('76129','TX','Fort Worth','Tarrant',32.709458,-97.364221),('76130','TX','Fort Worth','Tarrant',32.7252,-97.3205),('76131','TX','Fort Worth','Tarrant',32.878182,-97.341314),('76132','TX','Fort Worth','Tarrant',32.673048,-97.412697),('76133','TX','Fort Worth','Tarrant',32.653916,-97.376809),('76134','TX','Fort Worth','Tarrant',32.64738,-97.333015),('76135','TX','Fort Worth','Tarrant',32.824281,-97.450909),('76136','TX','Fort Worth','Tarrant',32.8967,-97.457),('76137','TX','Fort Worth','Tarrant',32.864047,-97.288603),('76140','TX','Fort Worth','Tarrant',32.631524,-97.28149),('76147','TX','Fort Worth','Tarrant',32.751,-97.364),('76148','TX','Fort Worth','Tarrant',32.868421,-97.252133),('76150','TX','Fort Worth','Tarrant',32.7252,-97.3205),('76155','TX','Fort Worth','Tarrant',32.825554,-97.052203),('76161','TX','Fort Worth','Tarrant',32.8245,-97.3208),('76162','TX','Fort Worth','Tarrant',32.6504,-97.3765),('76163','TX','Fort Worth','Tarrant',32.6504,-97.3765),('76164','TX','Fort Worth','Tarrant',32.781016,-97.355925),('76166','TX','Fort Worth','Tarrant',20.616699,-100.316704),('76177','TX','Fort Worth','Tarrant',32.971271,-97.309191),('76179','TX','Fort Worth','Tarrant',32.882345,-97.407313),('76180','TX','North Richland Hills','Tarrant',32.840005,-97.220833),('76181','TX','Fort Worth','Tarrant',32.8548,-97.2117),('76182','TX','North Richland Hills','Tarrant',32.881127,-97.212984),('76185','TX','Fort Worth','Tarrant',32.8647,-97.2151),('76191','TX','Fort Worth','Tarrant',32.8068,-97.3515),('76192','TX','Fort Worth','Tarrant',32.9295,-97.4351),('76193','TX','Fort Worth','Tarrant',32.7252,-97.3205),('76195','TX','Fort Worth','Tarrant',32.7252,-97.3205),('76196','TX','Fort Worth','Tarrant',32.7252,-97.3205),('76197','TX','Fort Worth','Tarrant',32.7789,-97.2995),('76198','TX','Fort Worth','Tarrant',32.7252,-97.3205),('76199','TX','Fort Worth','Tarrant',32.7252,-97.3205),('76201','TX','Denton','Denton',33.219937,-97.144018),('76202','TX','Denton','Denton',33.2147,-97.1327),('76203','TX','Denton','Denton',33.2147,-97.1327),('76204','TX','Denton','Denton',33.2147,-97.1327),('76205','TX','Denton','Denton',33.192771,-97.127349),('76206','TX','Denton','Denton',33.2566,-97.1536),('76207','TX','Denton','Denton',33.234862,-97.173333),('76208','TX','Denton','Denton',33.193613,-97.063234),('76209','TX','Denton','Denton',33.233928,-97.111961),('76210','TX','Denton','Denton',33.15113,-97.092294),('76225','TX','Alvord','Wise',33.354834,-97.682816),('76226','TX','Argyle','Denton',33.116412,-97.158162),('76227','TX','Aubrey','Denton',33.259502,-96.974279),('76228','TX','Bellevue','Clay',33.590169,-98.077743),('76230','TX','Bowie','Montague',33.540204,-97.885965),('76233','TX','Collinsville','Grayson',33.543244,-96.911568),('76234','TX','Decatur','Wise',33.250106,-97.547985),('76238','TX','Era','Cooke',33.501197,-97.329498),('76239','TX','Forestburg','Montague',33.51784,-97.508497),('76240','TX','Gainesville','Cooke',33.638157,-97.135434),('76241','TX','Gainesville','Cooke',33.6243,-97.1499),('76244','TX','Keller','Tarrant',32.933939,-97.282548),('76245','TX','Gordonville','Grayson',33.83704,-96.829535),('76246','TX','Greenwood','Wise',33.41798,-97.464574),('76247','TX','Justin','Denton',33.088014,-97.308051),('76248','TX','Keller','Tarrant',32.920133,-97.23253),('76249','TX','Krum','Denton',33.269446,-97.264235),('76250','TX','Lindsay','Cooke',33.635434,-97.222524),('76251','TX','Montague','Montague',33.641931,-97.714986),('76252','TX','Muenster','Cooke',33.662363,-97.384008),('76253','TX','Myra','Cooke',33.624481,-97.315155),('76255','TX','Nocona','Montague',33.825281,-97.709769),('76258','TX','Pilot Point','Denton',33.370682,-96.946018),('76259','TX','Ponder','Denton',33.193485,-97.310969),('76261','TX','Ringgold','Montague',33.80756,-97.946182),('76262','TX','Roanoke','Denton',32.998165,-97.224063),('76263','TX','Rosston','Cooke',33.48098,-97.445339),('76264','TX','Sadler','Grayson',33.72667,-96.831744),('76265','TX','Saint Jo','Montague',33.701585,-97.530062),('76266','TX','Sanger','Denton',33.358603,-97.189024),('76267','TX','Slidell','Wise',33.3597,-97.3913),('76268','TX','Southmayd','Grayson',33.629687,-96.769148),('76270','TX','Sunset','Montague',33.444264,-97.771371),('76271','TX','Tioga','Grayson',33.46837,-96.909475),('76272','TX','Valley View','Cooke',33.477214,-97.139803),('76273','TX','Whitesboro','Grayson',33.706014,-96.918291),('76299','TX','Roanoke','Denton',32.9947,-97.2311),('76301','TX','Wichita Falls','Wichita',33.903975,-98.489703),('76302','TX','Wichita Falls','Wichita',33.869204,-98.491904),('76305','TX','Wichita Falls','Wichita',33.969286,-98.446215),('76306','TX','Wichita Falls','Wichita',33.942304,-98.522997),('76307','TX','Wichita Falls','Wichita',33.9091,-98.4913),('76308','TX','Wichita Falls','Wichita',33.864592,-98.533127),('76309','TX','Wichita Falls','Wichita',33.891588,-98.533107),('76310','TX','Wichita Falls','Wichita',33.828908,-98.525269),('76311','TX','Sheppard Afb','Wichita',33.973106,-98.511079),('76351','TX','Archer City','Archer',33.569269,-98.657608),('76352','TX','Bluegrove','Clay',33.8098,-98.2389),('76354','TX','Burkburnett','Wichita',34.085125,-98.583542),('76357','TX','Byers','Clay',34.073219,-98.196319),('76360','TX','Electra','Wichita',33.983498,-98.925569),('76363','TX','Goree','Knox',33.483929,-99.531817),('76364','TX','Harrold','Wilbarger',34.085142,-99.020357),('76365','TX','Henrietta','Clay',33.753991,-98.216038),('76366','TX','Holliday','Archer',33.750245,-98.737251),('76367','TX','Iowa Park','Wichita',33.960345,-98.702426),('76369','TX','Kamay','Wichita',33.9607,-98.9328),('76370','TX','Megargel','Archer',33.499642,-98.881989),('76371','TX','Munday','Knox',33.463275,-99.638395),('76372','TX','Newcastle','Young',33.234609,-98.854183),('76373','TX','Oklaunion','Wilbarger',34.127675,-99.13349),('76374','TX','Olney','Young',33.365336,-98.723219),('76377','TX','Petrolia','Clay',34.013832,-98.234587),('76379','TX','Scotland','Archer',33.660328,-98.466109),('76380','TX','Seymour','Baylor',33.595033,-99.285128),('76384','TX','Vernon','Wilbarger',34.155859,-99.304205),('76385','TX','Vernon','Wilbarger',34.1544,-99.2647),('76388','TX','Weinert','Haskell',33.322836,-99.642127),('76389','TX','Windthorst','Archer',33.512628,-98.457627),('76401','TX','Stephenville','Erath',32.252776,-98.192131),('76402','TX','Stephenville','Erath',32.215613,-98.216276),('76424','TX','Breckenridge','Stephens',32.782203,-98.905008),('76426','TX','Bridgeport','Wise',33.187027,-97.824655),('76427','TX','Bryson','Jack',33.166031,-98.385021),('76429','TX','Caddo','Stephens',32.737079,-98.666648),('76430','TX','Albany','Shackelford',32.765006,-99.278492),('76431','TX','Chico','Wise',33.295536,-97.841078),('76432','TX','Blanket','Brown',31.817426,-98.803846),('76433','TX','Bluff Dale','Erath',32.320734,-98.012427),('76435','TX','Carbon','Eastland',32.268913,-98.85382),('76436','TX','Carlton','Hamilton',31.887068,-98.21299),('76437','TX','Cisco','Eastland',32.392953,-99.001034),('76439','TX','Dennis','Parker',32.6186,-97.9263),('76442','TX','Comanche','Comanche',31.905139,-98.60087),('76443','TX','Cross Plains','Callahan',32.122084,-99.175385),('76444','TX','De Leon','Comanche',32.116584,-98.54277),('76445','TX','Desdemona','Eastland',32.282332,-98.545764),('76446','TX','Dublin','Erath',32.082593,-98.350898),('76448','TX','Eastland','Eastland',32.394224,-98.795071),('76449','TX','Graford','Palo Pinto',32.917116,-98.354704),('76450','TX','Graham','Young',33.070949,-98.606432),('76452','TX','Energy','Comanche',31.747542,-98.364392),('76453','TX','Gordon','Palo Pinto',32.575283,-98.349876),('76454','TX','Gorman','Eastland',32.214517,-98.702595),('76455','TX','Gustine','Comanche',31.833468,-98.38567),('76457','TX','Hico','Hamilton',31.975107,-98.028575),('76458','TX','Jacksboro','Jack',33.207933,-98.179838),('76459','TX','Jermyn','Jack',33.279051,-98.394555),('76460','TX','Loving','Young',33.329859,-98.484741),('76461','TX','Lingleville','Erath',32.2444,-98.3772),('76462','TX','Lipan','Hood',32.521712,-98.028155),('76463','TX','Mingus','Palo Pinto',32.48644,-98.42216),('76464','TX','Moran','Shackelford',32.551095,-99.162933),('76465','TX','Morgan Mill','Erath',32.388,-98.1669),('76466','TX','Olden','Eastland',32.423897,-98.74295),('76467','TX','Paluxy','Hood',32.3562,-97.8925),('76468','TX','Proctor','Comanche',31.989197,-98.425296),('76469','TX','Putnam','Callahan',32.36485,-99.19512),('76470','TX','Ranger','Eastland',32.493672,-98.684878),('76471','TX','Rising Star','Eastland',32.097517,-98.979946),('76472','TX','Santo','Palo Pinto',32.599139,-98.15397),('76474','TX','Sidney','Comanche',31.96656,-98.790816),('76475','TX','Strawn','Palo Pinto',32.636086,-98.490896),('76476','TX','Tolar','Hood',32.37585,-97.925417),('76481','TX','South Bend','Young',32.975084,-98.72764),('76483','TX','Throckmorton','Throckmorton',33.152264,-99.24228),('76484','TX','Palo Pinto','Palo Pinto',32.736348,-98.299141),('76485','TX','Peaster','Parker',32.8719,-97.8663),('76486','TX','Perrin','Jack',33.032204,-98.064511),('76487','TX','Poolville','Parker',32.988799,-97.868624),('76490','TX','Whitt','Parker',32.955612,-98.020709),('76491','TX','Woodson','Throckmorton',33.030652,-99.040072),('76501','TX','Temple','Bell',31.101207,-97.31174),('76502','TX','Temple','Bell',31.095722,-97.406009),('76503','TX','Temple','Bell',31.1006,-97.3391),('76504','TX','Temple','Bell',31.09834,-97.36161),('76505','TX','Temple','Bell',31.0183,-97.3279),('76508','TX','Temple','Bell',31.077549,-97.363834),('76511','TX','Bartlett','Williamson',30.795815,-97.423592),('76513','TX','Belton','Bell',31.070837,-97.487115),('76518','TX','Buckholts','Milam',30.851957,-97.138013),('76519','TX','Burlington','Bell',31.014141,-97.042047),('76520','TX','Cameron','Milam',30.859454,-96.956918),('76522','TX','Copperas Cove','Coryell',31.137305,-97.921831),('76523','TX','Davilla','Milam',30.785114,-97.280589),('76524','TX','Eddy','Mclennan',31.278735,-97.225936),('76525','TX','Evant','Coryell',31.487744,-98.147666),('76526','TX','Flat','Coryell',31.3005,-97.5345),('76527','TX','Florence','Williamson',30.848929,-97.812006),('76528','TX','Gatesville','Coryell',31.401002,-97.722229),('76530','TX','Granger','Williamson',30.71223,-97.424823),('76531','TX','Hamilton','Hamilton',31.695385,-98.149133),('76533','TX','Heidenheimer','Bell',31.018,-97.3025),('76534','TX','Holland','Bell',30.884326,-97.37881),('76537','TX','Jarrell','Williamson',30.816391,-97.607659),('76538','TX','Jonesboro','Coryell',31.617999,-97.888054),('76539','TX','Kempner','Lampasas',31.068687,-97.965119),('76540','TX','Killeen','Bell',31.117,-97.7261),('76541','TX','Killeen','Bell',31.117825,-97.729229),('76542','TX','Killeen','Bell',31.048086,-97.721738),('76543','TX','Killeen','Bell',31.118894,-97.685728),('76544','TX','Killeen','Bell',31.153496,-97.776779),('76545','TX','Killeen','Bell',31.1169,-97.7275),('76546','TX','Killeen','Bell',31.1169,-97.7275),('76547','TX','Killeen','Bell',31.1169,-97.7275),('76548','TX','Harker Heights','Bell',31.0623,-97.654133),('76549','TX','Killeen','Bell',31.079915,-97.79348),('76550','TX','Lampasas','Lampasas',31.06255,-98.197852),('76554','TX','Little River Academy','Bell',30.982525,-97.359929),('76556','TX','Milano','Milam',30.701439,-96.844223),('76557','TX','Moody','Mclennan',31.293783,-97.40019),('76558','TX','Mound','Coryell',31.3516,-97.6372),('76559','TX','Nolanville','Bell',31.077682,-97.609385),('76561','TX','Oglesby','Coryell',31.419858,-97.517512),('76564','TX','Pendleton','Bell',31.1233,-97.2321),('76565','TX','Pottsville','Hamilton',31.659105,-98.358466),('76566','TX','Purmela','Coryell',31.518181,-97.994647),('76567','TX','Rockdale','Milam',30.651889,-97.008587),('76569','TX','Rogers','Bell',30.936271,-97.227525),('76570','TX','Rosebud','Falls',31.084443,-96.964456),('76571','TX','Salado','Bell',30.954231,-97.567467),('76573','TX','Schwertner','Williamson',30.815467,-97.512795),('76574','TX','Taylor','Williamson',30.579032,-97.408211),('76577','TX','Thorndale','Milam',30.602205,-97.153931),('76578','TX','Thrall','Williamson',30.551167,-97.248836),('76579','TX','Troy','Bell',31.203169,-97.285697),('76596','TX','Gatesville','Coryell',31.47658,-97.728745),('76597','TX','Gatesville','Coryell',31.487862,-97.703938),('76598','TX','Gatesville','Coryell',31.474448,-97.736179),('76599','TX','Gatesville','Coryell',31.470345,-97.736816),('76621','TX','Abbott','Hill',31.882153,-97.080099),('76622','TX','Aquilla','Hill',31.816191,-97.243292),('76623','TX','Avalon','Ellis',32.209817,-96.789408),('76624','TX','Axtell','Mclennan',31.645944,-96.955112),('76626','TX','Blooming Grove','Navarro',32.100578,-96.714704),('76627','TX','Blum','Hill',32.130561,-97.392076),('76628','TX','Brandon','Hill',32.030464,-96.94885),('76629','TX','Bremond','Robertson',31.14868,-96.685484),('76630','TX','Bruceville','Mclennan',31.339327,-97.22596),('76631','TX','Bynum','Hill',31.975524,-96.977168),('76632','TX','Chilton','Falls',31.300135,-97.046604),('76633','TX','China Spring','Mclennan',31.671415,-97.29995),('76634','TX','Clifton','Bosque',31.806827,-97.548173),('76635','TX','Coolidge','Limestone',31.74059,-96.654046),('76636','TX','Covington','Hill',32.173253,-97.276301),('76637','TX','Cranfills Gap','Bosque',31.777184,-97.800306),('76638','TX','Crawford','Mclennan',31.556294,-97.411017),('76639','TX','Dawson','Navarro',31.895945,-96.699646),('76640','TX','Elm Mott','Mclennan',31.678907,-97.092175),('76641','TX','Frost','Navarro',32.032378,-96.781452),('76642','TX','Groesbeck','Limestone',31.511384,-96.511489),('76643','TX','Hewitt','Mclennan',31.454486,-97.196805),('76644','TX','Laguna Park','Bosque',31.8057,-97.4829),('76645','TX','Hillsboro','Hill',32.015567,-97.122638),('76648','TX','Hubbard','Hill',31.857183,-96.80047),('76649','TX','Iredell','Bosque',32.025641,-97.86609),('76650','TX','Irene','Hill',31.99148,-96.858468),('76651','TX','Italy','Ellis',32.183314,-96.884317),('76652','TX','Kopperl','Bosque',32.114234,-97.550641),('76653','TX','Kosse','Limestone',31.304769,-96.612531),('76654','TX','Leroy','Mclennan',31.73037,-97.016203),('76655','TX','Lorena','Mclennan',31.392436,-97.174161),('76656','TX','Lott','Falls',31.185096,-97.043667),('76657','TX','Mc Gregor','Mclennan',31.442722,-97.394777),('76660','TX','Malone','Hill',31.916936,-96.912181),('76661','TX','Marlin','Falls',31.310171,-96.881305),('76664','TX','Mart','Mclennan',31.547063,-96.827863),('76665','TX','Meridian','Bosque',31.929374,-97.696596),('76666','TX','Mertens','Hill',32.061862,-96.90748),('76667','TX','Mexia','Limestone',31.673023,-96.491401),('76670','TX','Milford','Ellis',32.126114,-96.97406),('76671','TX','Morgan','Bosque',31.988989,-97.52976),('76673','TX','Mount Calm','Hill',31.75226,-96.895536),('76676','TX','Penelope','Hill',31.860998,-96.939794),('76678','TX','Prairie Hill','Limestone',31.654254,-96.782865),('76679','TX','Purdon','Navarro',31.94694,-96.629865),('76680','TX','Reagan','Falls',31.186723,-96.820934),('76681','TX','Richland','Navarro',31.904407,-96.429434),('76682','TX','Riesel','Mclennan',31.463425,-96.917655),('76684','TX','Ross','Mclennan',31.7183,-97.1188),('76685','TX','Satin','Falls',31.351715,-97.027517),('76686','TX','Tehuacana','Limestone',31.748988,-96.551799),('76687','TX','Thornton','Limestone',31.385201,-96.506614),('76689','TX','Valley Mills','Bosque',31.662159,-97.506079),('76690','TX','Walnut Springs','Bosque',32.068613,-97.743296),('76691','TX','West','Mclennan',31.789552,-97.095999),('76692','TX','Whitney','Hill',31.969112,-97.341425),('76693','TX','Wortham','Freestone',31.78739,-96.448896),('76701','TX','Waco','Mclennan',31.552011,-97.1382),('76702','TX','Waco','Mclennan',31.4721,-97.2468),('76703','TX','Waco','Mclennan',31.5517,-97.1384),('76704','TX','Waco','Mclennan',31.57128,-97.121987),('76705','TX','Waco','Mclennan',31.608525,-97.092219),('76706','TX','Waco','Mclennan',31.513031,-97.118111),('76707','TX','Waco','Mclennan',31.55228,-97.159497),('76708','TX','Waco','Mclennan',31.593071,-97.192172),('76710','TX','Waco','Mclennan',31.533567,-97.186237),('76711','TX','Waco','Mclennan',31.518925,-97.149533),('76712','TX','Woodway','Mclennan',31.508632,-97.227747),('76714','TX','Waco','Mclennan',31.5283,-97.1917),('76715','TX','Waco','Mclennan',31.6032,-97.0796),('76716','TX','Waco','Mclennan',31.4535,-97.0983),('76795','TX','Waco','Mclennan',31.4721,-97.2468),('76797','TX','Waco','Mclennan',31.5359,-97.1918),('76798','TX','Waco','Mclennan',31.545346,-97.122638),('76799','TX','Waco','Mclennan',31.5359,-97.1918),('76801','TX','Brownwood','Brown',31.73436,-99.004135),('76802','TX','Early','Brown',31.747823,-98.924685),('76803','TX','Brownwood','Brown',31.605,-99.0146),('76804','TX','Brownwood','Brown',31.605,-99.0146),('76820','TX','Art','Mason',30.757558,-99.049557),('76821','TX','Ballinger','Runnels',31.743225,-99.944914),('76823','TX','Bangs','Brown',31.708344,-99.156837),('76824','TX','Bend','Lampasas',31.086845,-98.518179),('76825','TX','Brady','Mcculloch',31.111158,-99.35088),('76827','TX','Brookesmith','Brown',31.542923,-99.134703),('76828','TX','Burkett','Coleman',32.013237,-99.273688),('76831','TX','Castell','Llano',30.631204,-98.94243),('76832','TX','Cherokee','San Saba',30.972818,-98.682852),('76834','TX','Coleman','Coleman',31.852331,-99.453142),('76836','TX','Doole','Mcculloch',31.443363,-99.549127),('76837','TX','Eden','Concho',31.223946,-99.895457),('76841','TX','Fort Mc Kavett','Menard',30.967103,-100.107935),('76842','TX','Fredonia','Mason',30.945325,-99.087197),('76844','TX','Goldthwaite','Mills',31.450898,-98.502148),('76845','TX','Gouldbusk','Coleman',31.548127,-99.477109),('76848','TX','Hext','Menard',30.823119,-99.54704),('76849','TX','Junction','Kimble',30.508639,-99.793756),('76852','TX','Lohn','Mcculloch',31.390575,-99.441675),('76853','TX','Lometa','Lampasas',31.228376,-98.402945),('76854','TX','London','Kimble',30.669926,-99.555904),('76855','TX','Lowake','Concho',31.5661,-100.0755),('76856','TX','Mason','Mason',30.725872,-99.241262),('76857','TX','May','Brown',31.91978,-98.951393),('76858','TX','Melvin','Mcculloch',31.190643,-99.583147),('76859','TX','Menard','Menard',30.951937,-99.800146),('76861','TX','Miles','Runnels',31.587434,-100.194615),('76862','TX','Millersview','Concho',31.422075,-99.725484),('76864','TX','Mullin','Mills',31.553602,-98.730168),('76865','TX','Norton','Runnels',31.858516,-100.165338),('76866','TX','Paint Rock','Concho',31.472652,-99.922204),('76869','TX','Pontotoc','Mason',30.917198,-98.995188),('76870','TX','Priddy','Mills',31.655372,-98.527465),('76871','TX','Richland Springs','San Saba',31.284158,-98.974775),('76872','TX','Rochelle','Mcculloch',31.295714,-99.1827),('76873','TX','Rockwood','Coleman',31.508314,-99.376477),('76874','TX','Roosevelt','Kimble',30.466871,-100.086182),('76875','TX','Rowena','Runnels',31.612368,-100.015601),('76877','TX','San Saba','San Saba',31.190823,-98.741344),('76878','TX','Santa Anna','Coleman',31.71382,-99.302291),('76880','TX','Star','Mills',31.467,-98.4075),('76882','TX','Talpa','Coleman',31.816904,-99.702274),('76883','TX','Telegraph','Edwards',30.3377,-99.9592),('76884','TX','Valera','Coleman',31.737871,-99.547722),('76885','TX','Valley Spring','Llano',30.890275,-98.862295),('76886','TX','Veribest','Tom Green',31.3896,-100.2764),('76887','TX','Voca','Mcculloch',31.002217,-99.16292),('76888','TX','Voss','Coleman',31.607413,-99.649948),('76890','TX','Zephyr','Brown',31.687472,-98.771625),('76901','TX','San Angelo','Tom Green',31.500693,-100.50169),('76902','TX','San Angelo','Tom Green',31.5571,-100.5506),('76903','TX','San Angelo','Tom Green',31.468443,-100.438347),('76904','TX','San Angelo','Tom Green',31.34996,-100.444271),('76905','TX','San Angelo','Tom Green',31.511635,-100.362963),('76906','TX','San Angelo','Tom Green',31.4636,-100.4366),('76908','TX','Goodfellow Afb','Tom Green',31.432208,-100.410122),('76909','TX','San Angelo','Tom Green',31.4432,-100.4661),('76930','TX','Barnhart','Irion',31.281127,-101.175103),('76932','TX','Big Lake','Reagan',31.317562,-101.515916),('76933','TX','Bronte','Coke',31.872684,-100.286707),('76934','TX','Carlsbad','Tom Green',31.601693,-100.654319),('76935','TX','Christoval','Tom Green',31.151201,-100.464535),('76936','TX','Eldorado','Schleicher',30.855931,-100.521405),('76937','TX','Eola','Tom Green',31.384789,-100.149699),('76939','TX','Knickerbocker','Tom Green',31.26668,-100.563258),('76940','TX','Mereta','Tom Green',31.454575,-100.137608),('76941','TX','Mertzon','Irion',31.275673,-100.862048),('76943','TX','Ozona','Crockett',30.580407,-101.272286),('76945','TX','Robert Lee','Coke',31.898031,-100.593398),('76949','TX','Silver','Coke',32.047729,-100.69452),('76950','TX','Sonora','Sutton',30.462295,-100.593924),('76951','TX','Sterling City','Sterling',31.81849,-101.043012),('76953','TX','Tennyson','Coke',31.718304,-100.32882),('76955','TX','Vancourt','Tom Green',31.305402,-100.128714),('76957','TX','Wall','Tom Green',31.3702,-100.2379),('76958','TX','Water Valley','Tom Green',31.619337,-100.774757),('77001','TX','Houston','Harris',29.7652,-95.3657),('77002','TX','Houston','Harris',29.755357,-95.366838),('77003','TX','Houston','Harris',29.748008,-95.347333),('77004','TX','Houston','Harris',29.728442,-95.363445),('77005','TX','Houston','Harris',29.717692,-95.426158),('77006','TX','Houston','Harris',29.741858,-95.390561),('77007','TX','Houston','Harris',29.772478,-95.403122),('77008','TX','Houston','Harris',29.798765,-95.413644),('77009','TX','Houston','Harris',29.795344,-95.36759),('77010','TX','Houston','Harris',29.754543,-95.359888),('77011','TX','Houston','Harris',29.743217,-95.30911),('77012','TX','Houston','Harris',29.718767,-95.277071),('77013','TX','Houston','Harris',29.79868,-95.238946),('77014','TX','Houston','Harris',29.980772,-95.470606),('77015','TX','Houston','Harris',29.769822,-95.181408),('77016','TX','Houston','Harris',29.855184,-95.307218),('77017','TX','Houston','Harris',29.689824,-95.252393),('77018','TX','Houston','Harris',29.826197,-95.422567),('77019','TX','Houston','Harris',29.754232,-95.400747),('77020','TX','Houston','Harris',29.774313,-95.316511),('77021','TX','Houston','Harris',29.696647,-95.359184),('77022','TX','Houston','Harris',29.827785,-95.378447),('77023','TX','Houston','Harris',29.723745,-95.321465),('77024','TX','Houston','Harris',29.776612,-95.516067),('77025','TX','Houston','Harris',29.686755,-95.4336),('77026','TX','Houston','Harris',29.7971,-95.333521),('77027','TX','Houston','Harris',29.737758,-95.446365),('77028','TX','Houston','Harris',29.82354,-95.28559),('77029','TX','Houston','Harris',29.757201,-95.265145),('77030','TX','Houston','Harris',29.704849,-95.404429),('77031','TX','Houston','Harris',29.655414,-95.548884),('77032','TX','Houston','Harris',29.950846,-95.34203),('77033','TX','Houston','Harris',29.67141,-95.337869),('77034','TX','Houston','Harris',29.623127,-95.20615),('77035','TX','Houston','Harris',29.652387,-95.481222),('77036','TX','Houston','Harris',29.701847,-95.534537),('77037','TX','Houston','Harris',29.892552,-95.399227),('77038','TX','Houston','Harris',29.918595,-95.441194),('77039','TX','Houston','Harris',29.910899,-95.336684),('77040','TX','Houston','Harris',29.870107,-95.532776),('77041','TX','Houston','Harris',29.858766,-95.572519),('77042','TX','Houston','Harris',29.738944,-95.560453),('77043','TX','Houston','Harris',29.802097,-95.563331),('77044','TX','Houston','Harris',29.879412,-95.171718),('77045','TX','Houston','Harris',29.630605,-95.435323),('77046','TX','Houston','Harris',29.733074,-95.434992),('77047','TX','Houston','Harris',29.612332,-95.386465),('77048','TX','Houston','Harris',29.626045,-95.331783),('77049','TX','Houston','Harris',29.836459,-95.146224),('77050','TX','Houston','Harris',29.903069,-95.278375),('77051','TX','Houston','Harris',29.663117,-95.369863),('77052','TX','Houston','Harris',29.7577,-95.361),('77053','TX','Houston','Fort Bend',29.5954,-95.457142),('77054','TX','Houston','Harris',29.683776,-95.40158),('77055','TX','Houston','Harris',29.795703,-95.496254),('77056','TX','Houston','Harris',29.744802,-95.468723),('77057','TX','Houston','Harris',29.744068,-95.48921),('77058','TX','Houston','Harris',29.553588,-95.09835),('77059','TX','Houston','Harris',29.601244,-95.120192),('77060','TX','Houston','Harris',29.940217,-95.398683),('77061','TX','Houston','Harris',29.655966,-95.282676),('77062','TX','Houston','Harris',29.57445,-95.131004),('77063','TX','Houston','Harris',29.736299,-95.523302),('77064','TX','Houston','Harris',29.925589,-95.550601),('77065','TX','Houston','Harris',29.922581,-95.605616),('77066','TX','Houston','Harris',29.962363,-95.501223),('77067','TX','Houston','Harris',29.950765,-95.447163),('77068','TX','Houston','Harris',30.005116,-95.48433),('77069','TX','Houston','Harris',29.985533,-95.521553),('77070','TX','Houston','Harris',29.974517,-95.569928),('77071','TX','Houston','Harris',29.651739,-95.519939),('77072','TX','Houston','Harris',29.700441,-95.585023),('77073','TX','Houston','Harris',30.001914,-95.408008),('77074','TX','Houston','Harris',29.687447,-95.518215),('77075','TX','Houston','Harris',29.624859,-95.260241),('77076','TX','Houston','Harris',29.858739,-95.381799),('77077','TX','Houston','Harris',29.748717,-95.609085),('77078','TX','Houston','Harris',29.845365,-95.251267),('77079','TX','Houston','Harris',29.7777,-95.605558),('77080','TX','Houston','Harris',29.816644,-95.525389),('77081','TX','Houston','Harris',29.712562,-95.48233),('77082','TX','Houston','Harris',29.721221,-95.625567),('77083','TX','Houston','Harris',29.693649,-95.645084),('77084','TX','Houston','Harris',29.837373,-95.663136),('77085','TX','Houston','Harris',29.626369,-95.487926),('77086','TX','Houston','Harris',29.921924,-95.49588),('77087','TX','Houston','Harris',29.688286,-95.303726),('77088','TX','Houston','Harris',29.879491,-95.450114),('77089','TX','Houston','Harris',29.592066,-95.22153),('77090','TX','Houston','Harris',30.003753,-95.437458),('77091','TX','Houston','Harris',29.853086,-95.444011),('77092','TX','Houston','Harris',29.830024,-95.474409),('77093','TX','Houston','Harris',29.860639,-95.339453),('77094','TX','Houston','Harris',29.775147,-95.695216),('77095','TX','Houston','Harris',29.905716,-95.647822),('77096','TX','Houston','Harris',29.675339,-95.479372),('77097','TX','Houston','Harris',29.7652,-95.3657),('77098','TX','Houston','Harris',29.735595,-95.414022),('77099','TX','Houston','Harris',29.670758,-95.582525),('77201','TX','Houston','Harris',29.7652,-95.3657),('77202','TX','Houston','Harris',29.763,-95.363),('77203','TX','Houston','Harris',29.763,-95.363),('77204','TX','Houston','Harris',29.763,-95.363),('77205','TX','Houston','Harris',29.982,-95.3427),('77206','TX','Houston','Harris',29.8267,-95.4259),('77207','TX','Houston','Harris',29.6858,-95.3031),('77208','TX','Houston','Harris',29.763,-95.363),('77209','TX','Houston','Harris',29.6198,-95.1882),('77210','TX','Houston','Harris',29.7652,-95.3657),('77212','TX','Houston','Harris',29.763,-95.363),('77213','TX','Houston','Harris',29.7857,-95.2183),('77215','TX','Houston','Harris',29.7351,-95.5202),('77216','TX','Houston','Harris',29.763,-95.363),('77217','TX','Houston','Harris',29.6761,-95.2478),('77218','TX','Houston','Harris',29.7848,-95.6749),('77219','TX','Houston','Harris',29.7526,-95.4042),('77220','TX','Houston','Harris',29.7728,-95.312),('77221','TX','Houston','Harris',29.7037,-95.355),('77222','TX','Houston','Harris',29.8299,-95.3763),('77223','TX','Houston','Harris',29.7273,-95.3206),('77224','TX','Houston','Harris',29.763,-95.363),('77225','TX','Houston','Harris',29.6925,-95.4174),('77226','TX','Houston','Harris',29.7939,-95.3415),('77227','TX','Houston','Harris',29.7392,-95.4365),('77228','TX','Houston','Harris',29.8247,-95.2863),('77229','TX','Houston','Harris',29.7857,-95.2183),('77230','TX','Houston','Harris',29.6958,-95.3873),('77231','TX','Houston','Harris',29.6536,-95.4825),('77233','TX','Houston','Harris',29.6545,-95.3553),('77234','TX','Houston','Harris',29.6256,-95.2205),('77235','TX','Houston','Harris',29.6536,-95.4825),('77236','TX','Houston','Harris',29.7066,-95.4967),('77237','TX','Houston','Harris',29.7337,-95.499),('77238','TX','Houston','Harris',29.9207,-95.4425),('77240','TX','Houston','Harris',29.8573,-95.5374),('77241','TX','Houston','Harris',29.8573,-95.5374),('77242','TX','Houston','Harris',29.7316,-95.5596),('77243','TX','Houston','Harris',29.8157,-95.5204),('77244','TX','Houston','Harris',29.7459,-95.6096),('77245','TX','Houston','Harris',29.6135,-95.4213),('77246','TX','Houston','Harris',29.6403,-95.4359),('77247','TX','Houston','Harris',29.6403,-95.4359),('77248','TX','Houston','Harris',29.763,-95.363),('77249','TX','Houston','Harris',29.8033,-95.3727),('77250','TX','Houston','Harris',29.7026,-95.5389),('77251','TX','Houston','Harris',29.7005,-95.5363),('77252','TX','Houston','Harris',29.7652,-95.3657),('77253','TX','Houston','Harris',29.7652,-95.3657),('77254','TX','Houston','Harris',29.6797,-95.4055),('77255','TX','Houston','Harris',29.8014,-95.4928),('77256','TX','Houston','Harris',29.7392,-95.4365),('77257','TX','Houston','Harris',29.7337,-95.499),('77258','TX','Houston','Harris',29.5481,-95.0887),('77259','TX','Houston','Harris',29.5768,-95.1407),('77260','TX','Houston','Harris',29.6757,-95.2444),('77261','TX','Houston','Harris',29.674,-95.2464),('77262','TX','Houston','Harris',29.7233,-95.2784),('77263','TX','Houston','Harris',29.7298,-95.5174),('77265','TX','Houston','Harris',29.7247,-95.4413),('77266','TX','Houston','Harris',29.7469,-95.3935),('77267','TX','Houston','Harris',29.953,-95.4444),('77268','TX','Houston','Harris',30.0062,-95.4876),('77269','TX','Houston','Harris',29.9774,-95.5723),('77270','TX','Houston','Harris',29.763,-95.363),('77271','TX','Houston','Harris',29.7562,-95.3653),('77272','TX','Houston','Harris',29.6883,-95.5847),('77273','TX','Houston','Harris',30.0174,-95.4453),('77274','TX','Houston','Harris',29.7066,-95.4967),('77275','TX','Houston','Harris',29.7562,-95.3653),('77276','TX','Houston','Harris',29.7575,-95.3668),('77277','TX','Houston','Harris',29.7247,-95.4413),('77278','TX','Houston','Harris',29.7699,-95.5113),('77279','TX','Houston','Harris',29.763,-95.363),('77280','TX','Houston','Harris',29.8157,-95.5204),('77282','TX','Houston','Harris',29.7459,-95.6096),('77284','TX','Houston','Harris',29.763,-95.363),('77285','TX','Houston','Harris',29.7554,-95.3678),('77286','TX','Houston','Harris',29.6745,-95.3679),('77287','TX','Houston','Harris',29.6761,-95.2478),('77288','TX','Houston','Harris',29.7317,-95.3767),('77289','TX','Houston','Harris',29.5768,-95.1407),('77290','TX','Houston','Harris',30.0174,-95.4453),('77291','TX','Houston','Harris',29.9207,-95.4425),('77292','TX','Houston','Harris',29.8268,-95.426),('77293','TX','Houston','Harris',29.8692,-95.3265),('77294','TX','Houston','Harris',29.8615,-95.2476),('77296','TX','Houston','Harris',29.7626,-95.3641),('77297','TX','Houston','Harris',29.763,-95.363),('77298','TX','Houston','Harris',29.763,-95.363),('77299','TX','Houston','Harris',29.763,-95.363),('77301','TX','Conroe','Montgomery',30.310716,-95.450732),('77302','TX','Conroe','Montgomery',30.239676,-95.38925),('77303','TX','Conroe','Montgomery',30.372284,-95.401062),('77304','TX','Conroe','Montgomery',30.333092,-95.505494),('77305','TX','Conroe','Montgomery',30.3116,-95.4558),('77306','TX','Conroe','Montgomery',30.287919,-95.32561),('77315','TX','North Houston','Harris',29.9252,-95.515),('77316','TX','Montgomery','Montgomery',30.33106,-95.650211),('77318','TX','Willis','Montgomery',30.437182,-95.555474),('77320','TX','Huntsville','Walker',30.80276,-95.492077),('77325','TX','Kingwood','Harris',30.0683,-95.2163),('77326','TX','Ace','Polk',30.519883,-94.818695),('77327','TX','Cleveland','Liberty',30.343105,-94.990213),('77328','TX','Cleveland','San Jacinto',30.369924,-95.180096),('77331','TX','Coldspring','San Jacinto',30.612037,-95.128253),('77332','TX','Dallardsville','Polk',30.6283,-94.6316),('77333','TX','Dobbin','Montgomery',30.353346,-95.77833),('77334','TX','Dodge','Walker',30.770721,-95.374797),('77335','TX','Goodrich','Polk',30.59322,-94.924331),('77336','TX','Huffman','Harris',30.045501,-95.108067),('77337','TX','Hufsmith','Harris',30.1219,-95.5963),('77338','TX','Humble','Harris',30.007205,-95.293502),('77339','TX','Kingwood','Harris',30.052758,-95.221246),('77340','TX','Huntsville','Walker',30.673694,-95.537395),('77341','TX','Huntsville','Walker',30.714476,-95.54977),('77342','TX','Huntsville','Walker',30.739972,-95.550916),('77343','TX','Huntsville','Walker',30.7233,-95.5505),('77344','TX','Huntsville','Walker',30.7233,-95.5505),('77345','TX','Kingwood','Harris',30.05867,-95.167996),('77346','TX','Humble','Harris',29.998145,-95.174424),('77347','TX','Humble','Harris',29.9987,-95.2537),('77348','TX','Huntsville','Walker',30.7233,-95.5505),('77349','TX','Huntsville','Walker',30.7233,-95.5505),('77350','TX','Leggett','Polk',30.846339,-94.865168),('77351','TX','Livingston','Polk',30.704289,-94.85512),('77353','TX','Magnolia','Montgomery',30.1857,-95.6772),('77354','TX','Magnolia','Montgomery',30.194062,-95.640414),('77355','TX','Magnolia','Montgomery',30.158703,-95.746423),('77356','TX','Montgomery','Montgomery',30.403616,-95.65043),('77357','TX','New Caney','Montgomery',30.170614,-95.17832),('77358','TX','New Waverly','Walker',30.545612,-95.468443),('77359','TX','Oakhurst','San Jacinto',30.753304,-95.300221),('77360','TX','Onalaska','Polk',30.82378,-95.114291),('77362','TX','Pinehurst','Montgomery',30.156942,-95.668306),('77363','TX','Plantersville','Grimes',30.289121,-95.856814),('77364','TX','Pointblank','San Jacinto',30.759029,-95.199769),('77365','TX','Porter','Montgomery',30.105159,-95.25707),('77367','TX','Riverside','Walker',30.85466,-95.394677),('77368','TX','Romayor','Liberty',30.442958,-94.828461),('77369','TX','Rye','Liberty',30.46952,-94.75007),('77371','TX','Shepherd','San Jacinto',30.493589,-94.992093),('77372','TX','Splendora','Montgomery',30.229045,-95.151627),('77373','TX','Spring','Harris',30.062446,-95.391767),('77374','TX','Thicket','Hardin',30.41555,-94.615127),('77375','TX','Tomball','Harris',30.087062,-95.601363),('77376','TX','Votaw','Hardin',30.451572,-94.67982),('77377','TX','Tomball','Harris',30.045682,-95.635424),('77378','TX','Willis','Montgomery',30.442147,-95.422732),('77379','TX','Spring','Harris',30.030898,-95.533987),('77380','TX','Spring','Montgomery',30.144162,-95.472377),('77381','TX','Spring','Montgomery',30.175449,-95.499441),('77382','TX','Spring','Montgomery',30.195607,-95.542486),('77383','TX','Spring','Harris',30.0136,-95.5177),('77384','TX','Conroe','Montgomery',30.223026,-95.480372),('77385','TX','Conroe','Montgomery',30.187321,-95.439264),('77386','TX','Spring','Montgomery',30.121273,-95.399752),('77387','TX','Spring','Montgomery',30.1356,-95.4151),('77388','TX','Spring','Harris',30.056881,-95.461771),('77389','TX','Spring','Harris',30.119344,-95.515523),('77391','TX','Spring','Harris',30.0234,-95.5685),('77393','TX','Spring','Montgomery',30.1474,-95.5086),('77396','TX','Humble','Harris',29.94792,-95.26775),('77399','TX','Livingston','Polk',30.6444,-94.8731),('77401','TX','Bellaire','Harris',29.705132,-95.460959),('77402','TX','Bellaire','Harris',29.7055,-95.4731),('77404','TX','Bay City','Matagorda',28.9825,-95.9691),('77406','TX','Richmond','Fort Bend',29.632444,-95.768816),('77407','TX','Richmond','Fort Bend',29.679499,-95.717012),('77410','TX','Cypress','Harris',29.9762,-95.6747),('77411','TX','Alief','Harris',29.7108,-95.5961),('77412','TX','Altair','Colorado',29.568332,-96.427618),('77413','TX','Barker','Harris',29.8398,-95.7771),('77414','TX','Bay City','Matagorda',28.922632,-95.914961),('77415','TX','Cedar Lane','Matagorda',28.932605,-95.735425),('77417','TX','Beasley','Fort Bend',29.479001,-95.957444),('77418','TX','Bellville','Austin',29.967916,-96.237859),('77419','TX','Blessing','Matagorda',28.868016,-96.229239),('77420','TX','Boling','Wharton',29.25459,-95.928455),('77422','TX','Brazoria','Brazoria',29.006197,-95.558148),('77423','TX','Brookshire','Waller',29.802183,-95.971186),('77426','TX','Chappell Hill','Washington',30.1223,-96.258442),('77428','TX','Collegeport','Matagorda',28.718954,-96.169694),('77429','TX','Cypress','Harris',29.976591,-95.654451),('77430','TX','Damon','Brazoria',29.287348,-95.678348),('77431','TX','Danciger','Brazoria',29.1713,-95.8186),('77432','TX','Danevang','Wharton',29.057299,-96.205642),('77433','TX','Cypress','Harris',29.953885,-95.724015),('77434','TX','Eagle Lake','Colorado',29.542163,-96.314983),('77435','TX','East Bernard','Wharton',29.520831,-96.08944),('77436','TX','Egypt','Wharton',29.4047,-96.2366),('77437','TX','El Campo','Wharton',29.192488,-96.245076),('77440','TX','Elmaton','Matagorda',28.887522,-96.148264),('77441','TX','Fulshear','Fort Bend',29.674968,-95.917293),('77442','TX','Garwood','Colorado',29.43402,-96.471382),('77443','TX','Glen Flora','Wharton',29.347057,-96.19398),('77444','TX','Guy','Fort Bend',29.300414,-95.787024),('77445','TX','Hempstead','Waller',30.102111,-96.068324),('77446','TX','Prairie View','Waller',30.078824,-95.989551),('77447','TX','Hockley','Harris',30.066129,-95.814339),('77448','TX','Hungerford','Wharton',29.406802,-96.077248),('77449','TX','Katy','Harris',29.830239,-95.729596),('77450','TX','Katy','Harris',29.75511,-95.744484),('77451','TX','Kendleton','Fort Bend',29.444846,-95.99989),('77452','TX','Kenney','Austin',30.0475,-96.3266),('77453','TX','Lane City','Wharton',29.21483,-96.022675),('77454','TX','Lissie','Wharton',29.536343,-96.226256),('77455','TX','Louise','Wharton',29.119356,-96.406478),('77456','TX','Markham','Matagorda',28.964261,-96.073613),('77457','TX','Matagorda','Matagorda',28.694667,-95.957342),('77458','TX','Midfield','Matagorda',28.941252,-96.217003),('77459','TX','Missouri City','Fort Bend',29.546443,-95.542778),('77460','TX','Nada','Colorado',29.401321,-96.3854),('77461','TX','Needville','Fort Bend',29.389767,-95.814211),('77463','TX','Old Ocean','Brazoria',29.135066,-95.783351),('77464','TX','Orchard','Fort Bend',29.600391,-95.967949),('77465','TX','Palacios','Matagorda',28.737323,-96.235597),('77466','TX','Pattison','Waller',29.819759,-95.998546),('77467','TX','Pierce','Wharton',29.211068,-96.151959),('77468','TX','Pledger','Matagorda',29.168191,-95.914985),('77469','TX','Richmond','Fort Bend',29.526596,-95.711376),('77470','TX','Rock Island','Colorado',29.528605,-96.570168),('77471','TX','Rosenberg','Fort Bend',29.549922,-95.821386),('77473','TX','San Felipe','Austin',29.795024,-96.107435),('77474','TX','Sealy','Austin',29.777,-96.155847),('77475','TX','Sheridan','Colorado',29.497745,-96.664191),('77476','TX','Simonton','Fort Bend',29.675323,-95.98107),('77477','TX','Stafford','Fort Bend',29.62431,-95.567968),('77478','TX','Sugar Land','Fort Bend',29.61445,-95.605918),('77479','TX','Sugar Land','Fort Bend',29.570306,-95.638347),('77480','TX','Sweeny','Brazoria',29.069806,-95.734875),('77481','TX','Thompsons','Fort Bend',29.472385,-95.563476),('77482','TX','Van Vleck','Matagorda',29.066085,-95.876781),('77483','TX','Wadsworth','Matagorda',28.788077,-95.848867),('77484','TX','Waller','Waller',30.078141,-95.918633),('77485','TX','Wallis','Austin',29.647342,-96.049223),('77486','TX','West Columbia','Brazoria',29.146035,-95.646944),('77487','TX','Sugar Land','Fort Bend',29.6194,-95.6347),('77488','TX','Wharton','Wharton',29.309141,-96.092471),('77489','TX','Missouri City','Fort Bend',29.602237,-95.520132),('77491','TX','Katy','Harris',29.8398,-95.7771),('77492','TX','Katy','Harris',29.8398,-95.7771),('77493','TX','Katy','Harris',29.812381,-95.815788),('77494','TX','Katy','Fort Bend',29.740406,-95.806844),('77496','TX','Sugar Land','Fort Bend',29.6348,-95.6352),('77497','TX','Stafford','Fort Bend',29.6158,-95.5575),('77498','TX','Sugar Land','Fort Bend',29.641973,-95.646331),('77501','TX','Pasadena','Harris',29.692,-95.2005),('77502','TX','Pasadena','Harris',29.680339,-95.200001),('77503','TX','Pasadena','Harris',29.697334,-95.158582),('77504','TX','Pasadena','Harris',29.651193,-95.1872),('77505','TX','Pasadena','Harris',29.651861,-95.145118),('77506','TX','Pasadena','Harris',29.711023,-95.201597),('77507','TX','Pasadena','Harris',29.624686,-95.061114),('77508','TX','Pasadena','Harris',29.6653,-95.1482),('77510','TX','Santa Fe','Galveston',29.367867,-95.084797),('77511','TX','Alvin','Brazoria',29.414902,-95.249834),('77512','TX','Alvin','Brazoria',29.3458,-95.2813),('77514','TX','Anahuac','Chambers',29.710951,-94.624175),('77515','TX','Angleton','Brazoria',29.16462,-95.449047),('77516','TX','Angleton','Brazoria',29.1691,-95.4316),('77517','TX','Santa Fe','Galveston',29.386113,-95.129194),('77518','TX','Bacliff','Galveston',29.507162,-94.987247),('77519','TX','Batson','Hardin',30.24534,-94.607905),('77520','TX','Baytown','Harris',29.739146,-94.986542),('77521','TX','Baytown','Harris',29.785024,-94.973811),('77522','TX','Baytown','Harris',29.7696,-94.9726),('77523','TX','Baytown','Chambers',29.780556,-94.874835),('77530','TX','Channelview','Harris',29.785907,-95.117207),('77531','TX','Clute','Brazoria',29.039941,-95.397889),('77532','TX','Crosby','Harris',29.918806,-95.067319),('77533','TX','Daisetta','Liberty',30.112907,-94.639881),('77534','TX','Danbury','Brazoria',29.236878,-95.333772),('77535','TX','Dayton','Liberty',30.034337,-94.893843),('77536','TX','Deer Park','Harris',29.697557,-95.124189),('77538','TX','Devers','Liberty',29.991445,-94.54547),('77539','TX','Dickinson','Galveston',29.466022,-95.03117),('77541','TX','Freeport','Brazoria',28.987133,-95.333795),('77542','TX','Freeport','Brazoria',28.9723,-95.3699),('77545','TX','Fresno','Fort Bend',29.534036,-95.464563),('77546','TX','Friendswood','Galveston',29.524259,-95.189581),('77547','TX','Galena Park','Harris',29.735876,-95.238178),('77549','TX','Friendswood','Galveston',29.5312,-95.2005),('77550','TX','Galveston','Galveston',29.297693,-94.794362),('77551','TX','Galveston','Galveston',29.280569,-94.827134),('77552','TX','Galveston','Galveston',29.2821,-94.8147),('77553','TX','Galveston','Galveston',29.328547,-94.79422),('77554','TX','Galveston','Galveston',29.238328,-94.929017),('77555','TX','Galveston','Galveston',29.3026,-94.7954),('77560','TX','Hankamer','Chambers',29.868546,-94.603021),('77561','TX','Hardin','Liberty',30.166506,-94.735446),('77562','TX','Highlands','Harris',29.825528,-95.060476),('77563','TX','Hitchcock','Galveston',29.337557,-95.003701),('77564','TX','Hull','Liberty',30.196402,-94.656433),('77565','TX','Kemah','Galveston',29.541143,-95.030808),('77566','TX','Lake Jackson','Brazoria',29.042309,-95.448333),('77568','TX','La Marque','Galveston',29.364206,-94.97362),('77571','TX','La Porte','Harris',29.672324,-95.033842),('77572','TX','La Porte','Harris',29.6655,-95.0191),('77573','TX','League City','Galveston',29.504376,-95.090713),('77574','TX','League City','Galveston',29.4344,-95.1183),('77575','TX','Liberty','Liberty',30.066255,-94.754544),('77577','TX','Liverpool','Brazoria',29.282655,-95.278912),('77578','TX','Manvel','Brazoria',29.490336,-95.370656),('77580','TX','Mont Belvieu','Chambers',29.862825,-94.869067),('77581','TX','Pearland','Brazoria',29.561914,-95.269892),('77582','TX','Raywood','Liberty',30.023932,-94.666787),('77583','TX','Rosharon','Brazoria',29.409991,-95.453743),('77584','TX','Pearland','Brazoria',29.550022,-95.357664),('77585','TX','Saratoga','Hardin',30.287973,-94.527534),('77586','TX','Seabrook','Harris',29.578318,-95.031754),('77587','TX','South Houston','Harris',29.661992,-95.229642),('77588','TX','Pearland','Brazoria',29.5595,-95.2802),('77590','TX','Texas City','Galveston',29.389004,-94.917487),('77591','TX','Texas City','Galveston',29.395172,-94.998784),('77592','TX','Texas City','Galveston',29.3941,-94.9143),('77597','TX','Wallisville','Chambers',29.836219,-94.701987),('77598','TX','Webster','Harris',29.542784,-95.143585),('77611','TX','Bridge City','Orange',30.028527,-93.823512),('77612','TX','Buna','Jasper',30.421848,-93.95009),('77613','TX','China','Jefferson',30.04703,-94.349035),('77614','TX','Deweyville','Newton',30.290497,-93.756934),('77615','TX','Evadale','Jasper',30.329529,-94.073225),('77616','TX','Fred','Tyler',30.570781,-94.197521),('77617','TX','Gilchrist','Galveston',29.501943,-94.520328),('77619','TX','Groves','Jefferson',29.947516,-93.918571),('77622','TX','Hamshire','Jefferson',29.860437,-94.303627),('77623','TX','High Island','Galveston',29.569322,-94.405233),('77624','TX','Hillister','Tyler',30.677882,-94.29584),('77625','TX','Kountze','Hardin',30.387472,-94.354756),('77626','TX','Mauriceville','Orange',30.2033,-93.8661),('77627','TX','Nederland','Jefferson',29.97629,-94.00138),('77629','TX','Nome','Jefferson',30.017043,-94.41236),('77630','TX','Orange','Orange',30.081506,-93.807365),('77631','TX','Orange','Orange',30.0939,-93.7331),('77632','TX','Orange','Orange',30.178665,-93.795644),('77639','TX','Orangefield','Orange',30.0747,-93.8555),('77640','TX','Port Arthur','Jefferson',29.883694,-93.954491),('77641','TX','Port Arthur','Jefferson',29.848,-93.9628),('77642','TX','Port Arthur','Jefferson',29.927759,-93.928862),('77643','TX','Port Arthur','Jefferson',29.8986,-93.9286),('77650','TX','Port Bolivar','Galveston',29.428826,-94.678315),('77651','TX','Port Neches','Jefferson',29.986671,-93.960054),('77655','TX','Sabine Pass','Jefferson',29.733173,-93.908803),('77656','TX','Silsbee','Hardin',30.372684,-94.180549),('77657','TX','Lumberton','Hardin',30.237729,-94.199427),('77659','TX','Sour Lake','Hardin',30.152014,-94.419811),('77660','TX','Spurger','Tyler',30.639903,-94.161362),('77661','TX','Stowell','Chambers',29.74254,-94.402649),('77662','TX','Vidor','Orange',30.143431,-94.016906),('77663','TX','Village Mills','Hardin',30.517144,-94.418204),('77664','TX','Warren','Tyler',30.600064,-94.40547),('77665','TX','Winnie','Chambers',29.823613,-94.40483),('77670','TX','Vidor','Orange',30.1243,-94.0139),('77701','TX','Beaumont','Jefferson',30.074506,-94.103288),('77702','TX','Beaumont','Jefferson',30.086147,-94.128505),('77703','TX','Beaumont','Jefferson',30.111595,-94.118685),('77704','TX','Beaumont','Jefferson',30.0839,-94.1014),('77705','TX','Beaumont','Jefferson',29.980006,-94.114684),('77706','TX','Beaumont','Jefferson',30.095185,-94.163669),('77707','TX','Beaumont','Jefferson',30.063506,-94.172593),('77708','TX','Beaumont','Jefferson',30.142652,-94.168317),('77709','TX','Beaumont','Jefferson',30.175,-94.2016),('77710','TX','Beaumont','Jefferson',30.0471,-94.0758),('77713','TX','Beaumont','Jefferson',30.094463,-94.233228),('77720','TX','Beaumont','Jefferson',30.0382,-94.158),('77725','TX','Beaumont','Jefferson',30.0976,-94.1665),('77726','TX','Beaumont','Jefferson',30.0932,-94.1463),('77801','TX','Bryan','Brazos',30.63821,-96.360446),('77802','TX','Bryan','Brazos',30.653972,-96.338926),('77803','TX','Bryan','Brazos',30.679195,-96.377096),('77805','TX','Bryan','Brazos',30.7546,-96.3317),('77806','TX','Bryan','Brazos',30.7546,-96.3317),('77807','TX','Bryan','Brazos',30.673743,-96.455099),('77808','TX','Bryan','Brazos',30.761974,-96.329888),('77830','TX','Anderson','Grimes',30.529813,-96.023167),('77831','TX','Bedias','Grimes',30.726866,-95.9196),('77833','TX','Brenham','Washington',30.186637,-96.412273),('77834','TX','Brenham','Washington',30.2361,-96.4089),('77835','TX','Burton','Washington',30.19364,-96.588048),('77836','TX','Caldwell','Burleson',30.537999,-96.672395),('77837','TX','Calvert','Robertson',30.985064,-96.684823),('77838','TX','Chriesman','Burleson',30.5991,-96.7705),('77840','TX','College Station','Brazos',30.612694,-96.32707),('77841','TX','College Station','Brazos',30.6277,-96.3341),('77842','TX','College Station','Brazos',30.6277,-96.3341),('77843','TX','College Station','Brazos',30.6108,-96.3493),('77844','TX','College Station','Brazos',30.6277,-96.3341),('77845','TX','College Station','Brazos',30.571369,-96.293081),('77850','TX','Concord','Leon',31.2649,-96.1195),('77852','TX','Deanville','Burleson',30.4319,-96.7558),('77853','TX','Dime Box','Lee',30.354852,-96.840141),('77855','TX','Flynn','Leon',31.132442,-96.13919),('77856','TX','Franklin','Robertson',31.062373,-96.436654),('77857','TX','Gause','Milam',30.789664,-96.716839),('77859','TX','Hearne','Robertson',30.874187,-96.581992),('77861','TX','Iola','Grimes',30.72798,-96.109843),('77862','TX','Kurten','Brazos',30.7869,-96.2638),('77863','TX','Lyons','Burleson',30.3861,-96.563),('77864','TX','Madisonville','Madison',30.953787,-95.909981),('77865','TX','Marquez','Leon',31.236238,-96.224378),('77866','TX','Millican','Brazos',30.466986,-96.204088),('77867','TX','Mumford','Robertson',30.734191,-96.562011),('77868','TX','Navasota','Grimes',30.376676,-96.083552),('77869','TX','Navasota','Brazos',30.3547,-96.0602),('77870','TX','New Baden','Robertson',31.050207,-96.429821),('77871','TX','Normangee','Leon',31.059948,-96.156172),('77872','TX','North Zulch','Madison',30.896968,-96.105248),('77873','TX','Richards','Grimes',30.588019,-95.839626),('77875','TX','Roans Prairie','Grimes',30.5841,-95.9436),('77876','TX','Shiro','Grimes',30.599232,-95.874704),('77878','TX','Snook','Burleson',30.489092,-96.453855),('77879','TX','Somerville','Burleson',30.364938,-96.529413),('77880','TX','Washington','Washington',30.297219,-96.178184),('77881','TX','Wellborn','Brazos',30.535,-96.3013),('77882','TX','Wheelock','Robertson',30.896204,-96.409592),('77901','TX','Victoria','Victoria',28.806136,-96.992596),('77902','TX','Victoria','Victoria',28.7963,-97.0066),('77903','TX','Victoria','Victoria',28.9511,-96.9844),('77904','TX','Victoria','Victoria',28.871966,-97.00571),('77905','TX','Victoria','Victoria',28.73334,-97.016262),('77950','TX','Austwell','Refugio',28.333446,-96.840092),('77951','TX','Bloomington','Victoria',28.643794,-96.896691),('77954','TX','Cuero','Dewitt',29.095351,-97.284725),('77957','TX','Edna','Jackson',28.986652,-96.662074),('77960','TX','Fannin','Goliad',28.694847,-97.241827),('77961','TX','Francitas','Jackson',28.863708,-96.349156),('77962','TX','Ganado','Jackson',29.015978,-96.502437),('77963','TX','Goliad','Goliad',28.680424,-97.397254),('77964','TX','Hallettsville','Lavaca',29.380587,-96.883477),('77967','TX','Hochheim','De Witt',29.3122,-97.2913),('77968','TX','Inez','Victoria',28.883909,-96.829148),('77969','TX','La Salle','Jackson',28.775164,-96.658931),('77970','TX','La Ward','Jackson',28.847248,-96.45961),('77971','TX','Lolita','Jackson',28.826074,-96.535538),('77973','TX','Mcfaddin','Victoria',28.53706,-96.982639),('77974','TX','Meyersville','Victoria',28.900888,-97.293438),('77975','TX','Moulton','Lavaca',29.575302,-97.115997),('77976','TX','Nursery','Victoria',28.951378,-97.121842),('77977','TX','Placedo','Victoria',28.691567,-96.821529),('77978','TX','Point Comfort','Calhoun',28.674721,-96.557979),('77979','TX','Port Lavaca','Calhoun',28.609082,-96.641279),('77982','TX','Port O Connor','Calhoun',28.446953,-96.415622),('77983','TX','Seadrift','Calhoun',28.405471,-96.671951),('77984','TX','Shiner','Lavaca',29.441522,-97.180003),('77986','TX','Sublime','Lavaca',29.4786,-96.7972),('77987','TX','Sweet Home','Lavaca',29.344458,-97.072827),('77988','TX','Telferner','Victoria',28.84687,-96.889456),('77989','TX','Thomaston','De Witt',28.9972,-97.1547),('77990','TX','Tivoli','Refugio',28.47679,-96.862345),('77991','TX','Vanderbilt','Jackson',28.801021,-96.617996),('77993','TX','Weesatche','Goliad',28.862141,-97.438714),('77994','TX','Westhoff','Dewitt',29.190453,-97.471349),('77995','TX','Yoakum','Lavaca',29.261463,-97.123667),('78001','TX','Artesia Wells','La Salle',28.265415,-99.282105),('78002','TX','Atascosa','Bexar',29.285087,-98.730116),('78003','TX','Bandera','Bandera',29.718468,-99.066404),('78004','TX','Bergheim','Kendall',29.904446,-98.558645),('78005','TX','Bigfoot','Frio',28.958668,-98.850138),('78006','TX','Boerne','Kendall',29.807524,-98.720119),('78007','TX','Calliham','Mcmullen',28.515416,-98.37317),('78008','TX','Campbellton','Atascosa',28.731004,-98.28797),('78009','TX','Castroville','Medina',29.355021,-98.884107),('78010','TX','Center Point','Kerr',29.921561,-99.058974),('78011','TX','Charlotte','Atascosa',28.788835,-98.723208),('78012','TX','Christine','Atascosa',28.779144,-98.478139),('78013','TX','Comfort','Kendall',29.967908,-98.904095),('78014','TX','Cotulla','La Salle',28.382155,-99.188426),('78015','TX','Boerne','Bexar',29.734239,-98.653086),('78016','TX','Devine','Medina',29.161058,-98.941338),('78017','TX','Dilley','Frio',28.711959,-99.190084),('78019','TX','Encinal','La Salle',28.066524,-99.392507),('78021','TX','Fowlerton','La Salle',28.481816,-98.83349),('78022','TX','George West','Live Oak',28.264613,-98.132713),('78023','TX','Helotes','Bexar',29.597345,-98.714713),('78024','TX','Hunt','Kerr',30.032925,-99.402496),('78025','TX','Ingram','Kerr',30.094271,-99.259917),('78026','TX','Jourdanton','Atascosa',28.885733,-98.563686),('78027','TX','Kendalia','Kendall',29.98722,-98.560817),('78028','TX','Kerrville','Kerr',30.035834,-99.149201),('78029','TX','Kerrville','Kerr',30.0472,-99.14),('78039','TX','La Coste','Medina',29.314705,-98.816751),('78040','TX','Laredo','Webb',27.514716,-99.500203),('78041','TX','Laredo','Webb',27.545092,-99.48844),('78042','TX','Laredo','Webb',27.5063,-99.508),('78043','TX','Laredo','Webb',27.522889,-99.431117),('78044','TX','Laredo','Webb',27.752747,-99.104319),('78045','TX','Laredo','Webb',27.664164,-99.53882),('78046','TX','Laredo','Webb',27.432249,-99.43491),('78049','TX','Laredo','Webb',27.9133,-99.438),('78050','TX','Leming','Atascosa',29.071358,-98.484439),('78052','TX','Lytle','Atascosa',29.225197,-98.793695),('78054','TX','Macdona','Bexar',29.4164,-98.6306),('78055','TX','Medina','Bandera',29.830327,-99.331413),('78056','TX','Mico','Medina',29.542908,-98.923368),('78057','TX','Moore','Frio',29.043921,-98.997545),('78058','TX','Mountain Home','Kerr',30.113613,-99.582834),('78059','TX','Natalia','Medina',29.186338,-98.846094),('78060','TX','Oakville','Live Oak',28.4603,-98.053),('78061','TX','Pearsall','Frio',28.917469,-99.132414),('78062','TX','Peggy','Atascosa',28.7913,-98.2452),('78063','TX','Pipe Creek','Bandera',29.661672,-98.924693),('78064','TX','Pleasanton','Atascosa',28.96346,-98.468562),('78065','TX','Poteet','Atascosa',29.075144,-98.593991),('78066','TX','Rio Medina','Medina',29.487629,-98.899279),('78067','TX','San Ygnacio','Zapata',27.084178,-99.379766),('78069','TX','Somerset','Atascosa',29.198766,-98.672921),('78070','TX','Spring Branch','Comal',29.89476,-98.390967),('78071','TX','Three Rivers','Live Oak',28.463484,-98.208702),('78072','TX','Tilden','Mcmullen',28.298596,-98.560202),('78073','TX','Von Ormy','Bexar',29.243073,-98.618057),('78074','TX','Waring','Kendall',29.950969,-98.79093),('78075','TX','Whitsett','Live Oak',28.606729,-98.334343),('78076','TX','Zapata','Zapata',26.897663,-99.214391),('78101','TX','Adkins','Bexar',29.329947,-98.234526),('78102','TX','Beeville','Bee',28.400034,-97.735895),('78104','TX','Beeville','Bee',28.513279,-97.77476),('78107','TX','Berclair','Goliad',28.53235,-97.591375),('78108','TX','Cibolo','Guadalupe',29.590134,-98.239476),('78109','TX','Converse','Bexar',29.501458,-98.306378),('78111','TX','Ecleto','Karnes',29.039,-97.7542),('78112','TX','Elmendorf','Bexar',29.228306,-98.353845),('78113','TX','Falls City','Karnes',28.962134,-98.082173),('78114','TX','Floresville','Wilson',29.147655,-98.18084),('78115','TX','Geronimo','Guadalupe',29.5731,-97.9443),('78116','TX','Gillett','Karnes',29.124972,-97.758337),('78117','TX','Hobson','Karnes',28.942838,-97.967804),('78118','TX','Karnes City','Karnes',28.890281,-97.91061),('78119','TX','Kenedy','Karnes',28.766637,-97.861665),('78121','TX','La Vernia','Wilson',29.342907,-98.124519),('78122','TX','Leesville','Gonzales',29.427688,-97.752555),('78123','TX','Mc Queeney','Guadalupe',29.598503,-98.043515),('78124','TX','Marion','Guadalupe',29.567228,-98.155108),('78125','TX','Mineral','Bee',28.547291,-97.955372),('78130','TX','New Braunfels','Comal',29.698749,-98.105564),('78131','TX','New Braunfels','Comal',29.6974,-98.1157),('78132','TX','New Braunfels','Comal',29.746693,-98.172162),('78133','TX','Canyon Lake','Comal',29.883877,-98.252229),('78135','TX','New Braunfels','Comal',29.6973,-98.1154),('78140','TX','Nixon','Gonzales',29.292017,-97.76469),('78141','TX','Nordheim','Dewitt',28.919085,-97.617091),('78142','TX','Normanna','Bee',28.533011,-97.788599),('78143','TX','Pandora','Wilson',29.250748,-97.842119),('78144','TX','Panna Maria','Karnes',28.952237,-97.887161),('78145','TX','Pawnee','Bee',28.649359,-98.00162),('78146','TX','Pettus','Bee',28.597086,-97.828396),('78147','TX','Poth','Wilson',29.072803,-98.081281),('78148','TX','Universal City','Bexar',29.543285,-98.294519),('78150','TX','Universal City','Bexar',29.536958,-98.281926),('78151','TX','Runge','Karnes',28.877172,-97.711415),('78152','TX','Saint Hedwig','Bexar',29.429237,-98.204532),('78154','TX','Schertz','Guadalupe',29.566448,-98.283459),('78155','TX','Seguin','Guadalupe',29.566312,-97.964159),('78156','TX','Seguin','Guadalupe',29.5686,-97.9644),('78159','TX','Smiley','Gonzales',29.244369,-97.608111),('78160','TX','Stockdale','Wilson',29.256892,-97.951311),('78161','TX','Sutherland Springs','Wilson',29.280263,-98.059281),('78162','TX','Tuleta','Bee',28.579816,-97.783919),('78163','TX','Bulverde','Comal',29.766078,-98.450263),('78164','TX','Yorktown','Dewitt',28.98256,-97.520734),('78201','TX','San Antonio','Bexar',29.46681,-98.525154),('78202','TX','San Antonio','Bexar',29.428285,-98.462706),('78203','TX','San Antonio','Bexar',29.415079,-98.462351),('78204','TX','San Antonio','Bexar',29.402972,-98.504446),('78205','TX','San Antonio','Bexar',29.425613,-98.488229),('78206','TX','San Antonio','Bexar',29.4153,-98.4823),('78207','TX','San Antonio','Bexar',29.425219,-98.524425),('78208','TX','San Antonio','Bexar',29.43993,-98.458718),('78209','TX','San Antonio','Bexar',29.488906,-98.456235),('78210','TX','San Antonio','Bexar',29.397938,-98.466615),('78211','TX','San Antonio','Bexar',29.360879,-98.548433),('78212','TX','San Antonio','Bexar',29.460514,-98.493658),('78213','TX','San Antonio','Bexar',29.510668,-98.522701),('78214','TX','San Antonio','Bexar',29.360184,-98.489112),('78215','TX','San Antonio','Bexar',29.438398,-98.482585),('78216','TX','San Antonio','Bexar',29.532298,-98.491834),('78217','TX','San Antonio','Bexar',29.539974,-98.42005),('78218','TX','San Antonio','Bexar',29.494415,-98.403678),('78219','TX','San Antonio','Bexar',29.447677,-98.398234),('78220','TX','San Antonio','Bexar',29.41308,-98.413452),('78221','TX','San Antonio','Bexar',29.324965,-98.499365),('78222','TX','San Antonio','Bexar',29.383899,-98.38765),('78223','TX','San Antonio','Bexar',29.347576,-98.426902),('78224','TX','San Antonio','Bexar',29.329051,-98.540269),('78225','TX','San Antonio','Bexar',29.387708,-98.524826),('78226','TX','San Antonio','Bexar',29.384379,-98.559939),('78227','TX','San Antonio','Bexar',29.40554,-98.635293),('78228','TX','San Antonio','Bexar',29.459495,-98.566658),('78229','TX','San Antonio','Bexar',29.501708,-98.569451),('78230','TX','San Antonio','Bexar',29.539632,-98.55271),('78231','TX','San Antonio','Bexar',29.575846,-98.538616),('78232','TX','San Antonio','Bexar',29.588081,-98.470866),('78233','TX','San Antonio','Bexar',29.552699,-98.364261),('78234','TX','San Antonio','Bexar',29.456112,-98.44605),('78235','TX','San Antonio','Bexar',29.345416,-98.445695),('78236','TX','San Antonio','Bexar',29.389435,-98.634872),('78237','TX','San Antonio','Bexar',29.420924,-98.566465),('78238','TX','San Antonio','Bexar',29.480402,-98.613464),('78239','TX','San Antonio','Bexar',29.517276,-98.364229),('78240','TX','San Antonio','Bexar',29.518406,-98.60838),('78241','TX','San Antonio','Bexar',29.395,-98.5758),('78242','TX','San Antonio','Bexar',29.352913,-98.614139),('78243','TX','San Antonio','Bexar',29.371562,-98.596927),('78244','TX','San Antonio','Bexar',29.473457,-98.352004),('78245','TX','San Antonio','Bexar',29.409221,-98.697974),('78246','TX','San Antonio','Bexar',29.5362,-98.4881),('78247','TX','San Antonio','Bexar',29.580505,-98.407494),('78248','TX','San Antonio','Bexar',29.590028,-98.525262),('78249','TX','San Antonio','Bexar',29.57022,-98.613338),('78250','TX','San Antonio','Bexar',29.507091,-98.666382),('78251','TX','San Antonio','Bexar',29.459853,-98.674404),('78252','TX','San Antonio','Bexar',29.352625,-98.698745),('78253','TX','San Antonio','Bexar',29.460542,-98.755162),('78254','TX','San Antonio','Bexar',29.52478,-98.702131),('78255','TX','San Antonio','Bexar',29.645424,-98.659507),('78256','TX','San Antonio','Bexar',29.624635,-98.625029),('78257','TX','San Antonio','Bexar',29.660488,-98.606916),('78258','TX','San Antonio','Bexar',29.636818,-98.492042),('78259','TX','San Antonio','Bexar',29.634362,-98.43697),('78260','TX','San Antonio','Bexar',29.688268,-98.493737),('78261','TX','San Antonio','Bexar',29.676387,-98.426025),('78262','TX','San Antonio','Bexar',29.4238,-98.4933),('78263','TX','San Antonio','Bexar',29.353592,-98.31747),('78264','TX','San Antonio','Bexar',29.186279,-98.510134),('78265','TX','San Antonio','Bexar',29.5391,-98.4216),('78266','TX','San Antonio','Comal',29.63425,-98.318198),('78268','TX','San Antonio','Bexar',29.497,-98.6248),('78269','TX','San Antonio','Bexar',29.563,-98.5915),('78270','TX','San Antonio','Bexar',29.5827,-98.4538),('78275','TX','San Antonio','Bexar',29.5391,-98.4216),('78278','TX','San Antonio','Bexar',29.5612,-98.5607),('78279','TX','San Antonio','Bexar',29.5334,-98.4929),('78280','TX','San Antonio','Bexar',29.5629,-98.3579),('78283','TX','San Antonio','Bexar',29.5391,-98.4216),('78284','TX','San Antonio','Bexar',29.4238,-98.4933),('78285','TX','San Antonio','Bexar',29.4238,-98.4933),('78286','TX','San Antonio','Bexar',29.4238,-98.4933),('78287','TX','San Antonio','Bexar',29.4892,-98.4566),('78288','TX','San Antonio','Bexar',29.5238,-98.6061),('78289','TX','San Antonio','Bexar',29.4238,-98.4933),('78291','TX','San Antonio','Bexar',29.4262,-98.4865),('78292','TX','San Antonio','Bexar',29.4262,-98.4865),('78293','TX','San Antonio','Bexar',29.4262,-98.4865),('78294','TX','San Antonio','Bexar',29.4262,-98.4865),('78295','TX','San Antonio','Bexar',29.4262,-98.4865),('78296','TX','San Antonio','Bexar',29.4262,-98.4865),('78297','TX','San Antonio','Bexar',29.4262,-98.4865),('78298','TX','San Antonio','Bexar',29.4262,-98.4865),('78299','TX','San Antonio','Bexar',29.4262,-98.4865),('78330','TX','Agua Dulce','Nueces',27.779759,-97.91227),('78332','TX','Alice','Jim Wells',27.747221,-98.110051),('78333','TX','Alice','Jim Wells',27.679,-98.1049),('78335','TX','Aransas Pass','San Patricio',27.9092,-97.1497),('78336','TX','Aransas Pass','San Patricio',27.914341,-97.155977),('78338','TX','Armstrong','Kenedy',26.870238,-97.774339),('78339','TX','Banquete','Nueces',27.805206,-97.794942),('78340','TX','Bayside','Refugio',28.110429,-97.210987),('78341','TX','Benavides','Duval',27.633098,-98.476137),('78342','TX','Ben Bolt','Jim Wells',27.649471,-98.080581),('78343','TX','Bishop','Nueces',27.612547,-97.772134),('78344','TX','Bruni','Webb',27.471342,-98.851693),('78347','TX','Chapman Ranch','Nueces',27.593816,-97.462144),('78349','TX','Concepcion','Duval',27.385725,-98.304914),('78350','TX','Dinero','Live Oak',28.2261,-97.9613),('78351','TX','Driscoll','Nueces',27.672801,-97.751956),('78352','TX','Edroy','San Patricio',27.971688,-97.676636),('78353','TX','Encino','Brooks',26.884918,-98.19452),('78355','TX','Falfurrias','Brooks',27.21226,-98.176777),('78357','TX','Freer','Duval',27.870325,-98.613056),('78358','TX','Fulton','Aransas',28.06695,-97.042804),('78359','TX','Gregory','San Patricio',27.920038,-97.29276),('78360','TX','Guerra','Jim Hogg',26.9533,-98.9014),('78361','TX','Hebbronville','Jim Hogg',27.168541,-98.777465),('78362','TX','Ingleside','San Patricio',27.863588,-97.208003),('78363','TX','Kingsville','Kleberg',27.494953,-97.859617),('78364','TX','Kingsville','Kleberg',27.342872,-97.703558),('78368','TX','Mathis','San Patricio',28.10157,-97.826805),('78369','TX','Mirando City','Webb',27.378236,-98.995905),('78370','TX','Odem','San Patricio',27.952917,-97.605302),('78371','TX','Oilton','Webb',27.599414,-98.956402),('78372','TX','Orange Grove','Jim Wells',27.979372,-98.036715),('78373','TX','Port Aransas','Nueces',27.809438,-97.078501),('78374','TX','Portland','San Patricio',27.887753,-97.323478),('78375','TX','Premont','Jim Wells',27.38059,-98.120089),('78376','TX','Realitos','Duval',27.421353,-98.514272),('78377','TX','Refugio','Refugio',28.336238,-97.211555),('78379','TX','Riviera','Kleberg',27.299796,-97.785042),('78380','TX','Robstown','Nueces',27.788869,-97.709576),('78381','TX','Rockport','Aransas',28.2333,-97.0189),('78382','TX','Rockport','Aransas',28.057675,-97.048987),('78383','TX','Sandia','Jim Wells',28.080169,-97.938555),('78384','TX','San Diego','Duval',27.813633,-98.331284),('78385','TX','Sarita','Kenedy',27.177515,-97.849275),('78387','TX','Sinton','San Patricio',28.062369,-97.519244),('78389','TX','Skidmore','Bee',28.249271,-97.675978),('78390','TX','Taft','San Patricio',27.993079,-97.349406),('78391','TX','Tynan','Bee',28.168169,-97.751844),('78393','TX','Woodsboro','Refugio',28.209599,-97.331576),('78401','TX','Corpus Christi','Nueces',27.796839,-97.400199),('78402','TX','Corpus Christi','Nueces',27.82341,-97.390504),('78403','TX','Corpus Christi','Nueces',27.8002,-97.3961),('78404','TX','Corpus Christi','Nueces',27.770255,-97.400245),('78405','TX','Corpus Christi','Nueces',27.777467,-97.42796),('78406','TX','Corpus Christi','Nueces',27.775865,-97.502855),('78407','TX','Corpus Christi','Nueces',27.806638,-97.434545),('78408','TX','Corpus Christi','Nueces',27.795919,-97.437689),('78409','TX','Corpus Christi','Nueces',27.814852,-97.520589),('78410','TX','Corpus Christi','Nueces',27.848957,-97.599618),('78411','TX','Corpus Christi','Nueces',27.733388,-97.385788),('78412','TX','Corpus Christi','Nueces',27.709322,-97.351314),('78413','TX','Corpus Christi','Nueces',27.687716,-97.403784),('78414','TX','Corpus Christi','Nueces',27.662541,-97.371356),('78415','TX','Corpus Christi','Nueces',27.718829,-97.433271),('78416','TX','Corpus Christi','Nueces',27.7524,-97.434897),('78417','TX','Corpus Christi','Nueces',27.733067,-97.449478),('78418','TX','Corpus Christi','Nueces',27.642393,-97.261943),('78419','TX','Corpus Christi','Nueces',27.693242,-97.266863),('78426','TX','Corpus Christi','Nueces',27.8415,-97.573),('78427','TX','Corpus Christi','Nueces',27.7961,-97.4002),('78460','TX','Corpus Christi','Nueces',27.8415,-97.573),('78461','TX','Corpus Christi','Nueces',27.7977,-97.4264),('78463','TX','Corpus Christi','Nueces',27.7739,-97.3983),('78465','TX','Corpus Christi','Nueces',27.7765,-97.4198),('78466','TX','Corpus Christi','Nueces',27.7438,-97.3804),('78467','TX','Corpus Christi','Nueces',27.6574,-97.4676),('78468','TX','Corpus Christi','Nueces',27.705,-97.3589),('78469','TX','Corpus Christi','Nueces',27.7977,-97.4264),('78470','TX','Corpus Christi','Nueces',27.8002,-97.3961),('78471','TX','Corpus Christi','Nueces',27.8002,-97.3961),('78472','TX','Corpus Christi','Nueces',27.6953,-97.4145),('78473','TX','Corpus Christi','Nueces',27.7961,-97.3965),('78474','TX','Corpus Christi','Nueces',27.8002,-97.3961),('78475','TX','Corpus Christi','Nueces',27.7964,-97.3976),('78476','TX','Corpus Christi','Nueces',27.8002,-97.3961),('78477','TX','Corpus Christi','Nueces',27.8002,-97.3961),('78478','TX','Corpus Christi','Nueces',27.7952,-97.3974),('78480','TX','Corpus Christi','Nueces',27.6437,-97.3006),('78501','TX','Mcallen','Hidalgo',26.214021,-98.235576),('78502','TX','Mcallen','Hidalgo',26.2154,-98.2102),('78503','TX','Mcallen','Hidalgo',26.170387,-98.244125),('78504','TX','Mcallen','Hidalgo',26.265623,-98.231715),('78505','TX','Mcallen','Hidalgo',26.1996,-98.2325),('78516','TX','Alamo','Hidalgo',26.177232,-98.117184),('78520','TX','Brownsville','Cameron',25.934056,-97.518977),('78521','TX','Brownsville','Cameron',25.91976,-97.428075),('78522','TX','Brownsville','Cameron',26.0011,-97.5725),('78523','TX','Brownsville','Cameron',26.0011,-97.5725),('78526','TX','Brownsville','Cameron',25.972952,-97.459747),('78535','TX','Combes','Cameron',26.250502,-97.735538),('78536','TX','Delmita','Starr',26.655362,-98.457086),('78537','TX','Donna','Hidalgo',26.164017,-98.055977),('78538','TX','Edcouch','Hidalgo',26.345954,-97.968792),('78539','TX','Edinburg','Hidalgo',26.283821,-98.175864),('78540','TX','Edinburg','Hidalgo',26.3018,-98.1595),('78541','TX','Edinburg','Hidalgo',26.387421,-98.227643),('78542','TX','Edinburg','Hidalgo',26.363956,-98.105377),('78543','TX','Elsa','Hidalgo',26.297029,-97.995598),('78545','TX','Falcon Heights','Starr',26.587174,-99.119871),('78547','TX','Garciasville','Starr',26.321652,-98.695256),('78548','TX','Grulla','Starr',26.266597,-98.652539),('78549','TX','Hargill','Hidalgo',26.448359,-98.017149),('78550','TX','Harlingen','Cameron',26.206654,-97.684519),('78551','TX','Harlingen','Cameron',26.2081,-97.6984),('78552','TX','Harlingen','Cameron',26.190988,-97.745892),('78553','TX','Harlingen','Cameron',26.2081,-97.6984),('78557','TX','Hidalgo','Hidalgo',26.104614,-98.245789),('78558','TX','La Blanca','Hidalgo',26.294725,-98.027564),('78559','TX','La Feria','Cameron',26.152905,-97.829634),('78560','TX','La Joya','Hidalgo',26.247914,-98.494687),('78561','TX','Lasara','Willacy',26.468275,-97.913796),('78562','TX','La Villa','Hidalgo',26.296276,-97.910981),('78563','TX','Linn','Hidalgo',26.620175,-98.218534),('78564','TX','Lopeno','Zapata',26.683042,-99.118083),('78565','TX','Los Ebanos','Hidalgo',26.248134,-98.556936),('78566','TX','Los Fresnos','Cameron',26.112264,-97.423591),('78567','TX','Los Indios','Cameron',26.049796,-97.739924),('78568','TX','Lozano','Cameron',26.1016,-97.4795),('78569','TX','Lyford','Willacy',26.388185,-97.766376),('78570','TX','Mercedes','Hidalgo',26.165022,-97.91457),('78572','TX','Mission','Hidalgo',26.210943,-98.339099),('78573','TX','Mission','Hidalgo',26.284145,-98.309124),('78574','TX','Mission','Hidalgo',26.281751,-98.351502),('78575','TX','Olmito','Cameron',26.022168,-97.536326),('78576','TX','Penitas','Hidalgo',26.288348,-98.472273),('78577','TX','Pharr','Hidalgo',26.18074,-98.186949),('78578','TX','Port Isabel','Cameron',26.072757,-97.260085),('78579','TX','Progreso','Hidalgo',26.09184,-97.961464),('78580','TX','Raymondville','Willacy',26.485932,-97.783027),('78582','TX','Rio Grande City','Starr',26.423669,-98.750755),('78583','TX','Rio Hondo','Cameron',26.261867,-97.507769),('78584','TX','Roma','Starr',26.450326,-99.00799),('78585','TX','Salineno','Starr',26.527855,-99.116358),('78586','TX','San Benito','Cameron',26.11114,-97.635281),('78588','TX','San Isidro','Starr',26.728754,-98.421608),('78589','TX','San Juan','Hidalgo',26.188424,-98.153257),('78590','TX','San Perlita','Willacy',26.502463,-97.644193),('78591','TX','Santa Elena','Starr',26.582929,-98.521632),('78592','TX','Santa Maria','Cameron',26.074606,-97.846154),('78593','TX','Santa Rosa','Cameron',26.261186,-97.822306),('78594','TX','Sebastian','Willacy',26.34425,-97.792029),('78595','TX','Sullivan City','Hidalgo',26.280419,-98.559678),('78596','TX','Weslaco','Hidalgo',26.158727,-97.986162),('78597','TX','South Padre Island','Cameron',26.11914,-97.171597),('78598','TX','Port Mansfield','Willacy',26.55129,-97.430284),('78599','TX','Weslaco','Hidalgo',26.1591,-97.9905),('78602','TX','Bastrop','Bastrop',30.124363,-97.313274),('78604','TX','Belmont','Gonzales',29.523,-97.6836),('78605','TX','Bertram','Burnet',30.769827,-98.04588),('78606','TX','Blanco','Blanco',30.100095,-98.441337),('78607','TX','Bluffton','Llano',30.827514,-98.468102),('78608','TX','Briggs','Burnet',30.936006,-97.934579),('78609','TX','Buchanan Dam','Llano',30.764816,-98.451309),('78610','TX','Buda','Hays',30.077786,-97.82494),('78611','TX','Burnet','Burnet',30.768677,-98.291109),('78612','TX','Cedar Creek','Bastrop',30.119181,-97.481542),('78613','TX','Cedar Park','Williamson',30.500288,-97.826359),('78614','TX','Cost','Gonzales',29.408047,-97.596165),('78615','TX','Coupland','Williamson',30.464728,-97.401483),('78616','TX','Dale','Caldwell',29.948445,-97.56883),('78617','TX','Del Valle','Travis',30.168488,-97.616932),('78618','TX','Doss','Gillespie',30.485511,-99.157482),('78619','TX','Driftwood','Hays',30.120997,-98.045053),('78620','TX','Dripping Springs','Hays',30.236049,-98.101122),('78621','TX','Elgin','Bastrop',30.336226,-97.369243),('78622','TX','Fentress','Caldwell',29.755403,-97.778012),('78623','TX','Fischer','Comal',29.952292,-98.215969),('78624','TX','Fredericksburg','Gillespie',30.277603,-98.886739),('78626','TX','Georgetown','Williamson',30.641062,-97.646676),('78627','TX','Georgetown','Williamson',30.6325,-97.6769),('78628','TX','Georgetown','Williamson',30.650933,-97.717113),('78629','TX','Gonzales','Gonzales',29.495634,-97.455029),('78630','TX','Cedar Park','Williamson',30.505,-97.82),('78631','TX','Harper','Gillespie',30.33977,-99.30658),('78632','TX','Harwood','Gonzales',29.668943,-97.466085),('78633','TX','Georgetown','Williamson',30.718965,-97.733723),('78634','TX','Hutto','Williamson',30.541795,-97.552605),('78635','TX','Hye','Blanco',30.230262,-98.552229),('78636','TX','Johnson City','Blanco',30.279789,-98.40044),('78638','TX','Kingsbury','Guadalupe',29.654863,-97.77104),('78639','TX','Kingsland','Llano',30.663154,-98.441437),('78640','TX','Kyle','Hays',29.997516,-97.839644),('78641','TX','Leander','Williamson',30.553174,-97.86199),('78642','TX','Liberty Hill','Williamson',30.687233,-97.926586),('78643','TX','Llano','Llano',30.699346,-98.660317),('78644','TX','Lockhart','Caldwell',29.868248,-97.679131),('78645','TX','Leander','Travis',30.453338,-97.974134),('78646','TX','Leander','Williamson',30.5786,-97.8527),('78648','TX','Luling','Caldwell',29.690245,-97.65426),('78650','TX','Mc Dade','Bastrop',30.281632,-97.228805),('78651','TX','Mc Neil','Travis',30.4554,-97.7166),('78652','TX','Manchaca','Travis',30.132975,-97.846491),('78653','TX','Manor','Travis',30.344272,-97.543269),('78654','TX','Marble Falls','Burnet',30.575797,-98.281483),('78655','TX','Martindale','Caldwell',29.833964,-97.840598),('78656','TX','Maxwell','Caldwell',29.885257,-97.816305),('78657','TX','Horsesho','Llano',30.543758,-98.374635),('78658','TX','Ottine','Gonzales',29.592212,-97.589223),('78659','TX','Paige','Bastrop',30.207701,-97.124638),('78660','TX','Pflugerville','Travis',30.45125,-97.617262),('78661','TX','Prairie Lea','Caldwell',29.725332,-97.749826),('78662','TX','Red Rock','Bastrop',29.935088,-97.443433),('78663','TX','Round Mountain','Blanco',30.427444,-98.328343),('78664','TX','Round Rock','Williamson',30.505354,-97.651435),('78665','TX','Sandy','Williamson',30.542976,-97.645455),('78666','TX','San Marcos','Hays',29.872465,-97.94217),('78667','TX','San Marcos','Hays',29.883,-97.9411),('78669','TX','Spicewood','Travis',30.436932,-98.089574),('78670','TX','Staples','Guadalupe',29.772089,-97.829412),('78671','TX','Stonewall','Gillespie',30.219091,-98.629253),('78672','TX','Tow','Llano',30.860135,-98.454779),('78673','TX','Walburg','Williamson',30.7366,-97.58),('78674','TX','Weir','Williamson',30.7553,-97.5986),('78675','TX','Willow City','Gillespie',30.466147,-98.709963),('78676','TX','Wimberley','Hays',30.01606,-98.124783),('78677','TX','Wrightsboro','Gonzales',29.341648,-97.592239),('78680','TX','Round Rock','Williamson',30.517,-97.6987),('78681','TX','Round Rock','Williamson',30.523575,-97.717405),('78682','TX','Round Rock','Williamson',30.5172,-97.6901),('78683','TX','Round Rock','Williamson',30.4961,-97.646),('78691','TX','Pflugerville','Travis',30.4383,-97.6206),('78701','TX','Austin','Travis',30.270569,-97.742589),('78702','TX','Austin','Travis',30.263959,-97.717427),('78703','TX','Austin','Travis',30.290371,-97.764669),('78704','TX','Austin','Travis',30.244668,-97.762623),('78705','TX','Austin','Travis',30.292632,-97.738614),('78708','TX','Austin','Travis',30.3911,-97.705),('78709','TX','Austin','Travis',30.2342,-97.8497),('78710','TX','Austin','Travis',30.3545,-97.655),('78711','TX','Austin','Travis',30.2782,-97.7376),('78712','TX','Austin','Travis',30.286316,-97.733752),('78713','TX','Austin','Travis',30.2847,-97.7414),('78714','TX','Austin','Travis',30.2669,-97.7427),('78715','TX','Austin','Travis',30.2065,-97.7966),('78716','TX','Austin','Travis',30.2735,-97.7992),('78717','TX','Austin','Williamson',30.496877,-97.760823),('78718','TX','Austin','Travis',30.3612,-97.7166),('78719','TX','Austin','Travis',30.174559,-97.679327),('78720','TX','Austin','Travis',30.4241,-97.7569),('78721','TX','Austin','Travis',30.270441,-97.685354),('78722','TX','Austin','Travis',30.289,-97.716386),('78723','TX','Austin','Travis',30.307098,-97.688201),('78724','TX','Austin','Travis',30.300048,-97.629376),('78725','TX','Austin','Travis',30.24312,-97.616655),('78726','TX','Austin','Travis',30.435378,-97.838218),('78727','TX','Austin','Travis',30.427761,-97.714407),('78728','TX','Austin','Travis',30.450395,-97.681242),('78729','TX','Austin','Williamson',30.452712,-97.76468),('78730','TX','Austin','Travis',30.356228,-97.831411),('78731','TX','Austin','Travis',30.346173,-97.76348),('78732','TX','Austin','Travis',30.375661,-97.89946),('78733','TX','Austin','Travis',30.332909,-97.869811),('78734','TX','Austin','Travis',30.377285,-97.956445),('78735','TX','Austin','Travis',30.248175,-97.844145),('78736','TX','Austin','Travis',30.245717,-97.920225),('78737','TX','Austin','Hays',30.190321,-97.956989),('78738','TX','Austin','Travis',30.323444,-97.964496),('78739','TX','Austin','Travis',30.178018,-97.88615),('78741','TX','Austin','Travis',30.230813,-97.713478),('78742','TX','Austin','Travis',30.239436,-97.67142),('78744','TX','Austin','Travis',30.186967,-97.744447),('78745','TX','Austin','Travis',30.206941,-97.797799),('78746','TX','Austin','Travis',30.289054,-97.806743),('78747','TX','Austin','Travis',30.137849,-97.753585),('78748','TX','Austin','Travis',30.165689,-97.826479),('78749','TX','Austin','Travis',30.215924,-97.857989),('78750','TX','Austin','Travis',30.438748,-97.803387),('78751','TX','Austin','Travis',30.310099,-97.722025),('78752','TX','Austin','Travis',30.33263,-97.704024),('78753','TX','Austin','Travis',30.375908,-97.677075),('78754','TX','Austin','Travis',30.36105,-97.643111),('78755','TX','Austin','Travis',30.3574,-97.7607),('78756','TX','Austin','Travis',30.320038,-97.741594),('78757','TX','Austin','Travis',30.350578,-97.732292),('78758','TX','Austin','Travis',30.383655,-97.703943),('78759','TX','Austin','Travis',30.403096,-97.755197),('78760','TX','Austin','Travis',30.2139,-97.7339),('78761','TX','Austin','Travis',30.3332,-97.6984),('78762','TX','Austin','Travis',30.2615,-97.7218),('78763','TX','Austin','Travis',30.2969,-97.7668),('78764','TX','Austin','Travis',30.2669,-97.7427),('78765','TX','Austin','Travis',30.3065,-97.7296),('78766','TX','Austin','Travis',30.3514,-97.7318),('78767','TX','Austin','Travis',30.2669,-97.7427),('78768','TX','Austin','Travis',30.2669,-97.7427),('78769','TX','Austin','Travis',30.2669,-97.7427),('78772','TX','Austin','Travis',30.2669,-97.7427),('78773','TX','Austin','Travis',30.3306,-97.7036),('78774','TX','Austin','Travis',30.2669,-97.7427),('78778','TX','Austin','Travis',30.2669,-97.7427),('78779','TX','Austin','Travis',30.3458,-97.7674),('78780','TX','Austin','Travis',30.2669,-97.7427),('78781','TX','Austin','Travis',30.2669,-97.7427),('78783','TX','Austin','Travis',30.2669,-97.7427),('78785','TX','Austin','Travis',30.2669,-97.7427),('78786','TX','Austin','Travis',30.3545,-97.655),('78788','TX','Austin','Travis',30.2669,-97.7427),('78789','TX','Austin','Travis',30.2669,-97.7427),('78798','TX','Austin','Williamson',30.3718,-97.6826),('78799','TX','Austin','Travis',30.2667,-97.7428),('78801','TX','Uvalde','Uvalde',29.27618,-99.847159),('78802','TX','Uvalde','Uvalde',29.16869,-99.836142),('78827','TX','Asherton','Dimmit',28.442737,-99.752986),('78828','TX','Barksdale','Edwards',29.829751,-100.003335),('78829','TX','Batesville','Zavala',28.887596,-99.548758),('78830','TX','Big Wells','Dimmit',28.545918,-99.522776),('78832','TX','Brackettville','Kinney',29.316079,-100.430821),('78833','TX','Camp Wood','Real',29.688874,-99.987956),('78834','TX','Carrizo Springs','Dimmit',28.516015,-99.893565),('78836','TX','Catarina','Dimmit',28.300147,-99.673273),('78837','TX','Comstock','Val Verde',29.795632,-101.247759),('78838','TX','Concan','Uvalde',29.546178,-99.730026),('78839','TX','Crystal City','Zavala',28.71832,-99.823476),('78840','TX','Del Rio','Val Verde',29.417396,-100.906514),('78841','TX','Del Rio','Val Verde',29.895,-101.1479),('78842','TX','Del Rio','Val Verde',29.895,-101.1479),('78843','TX','Laughlin A F B','Val Verde',29.353191,-100.782588),('78847','TX','Del Rio','Val Verde',29.8508,-100.8827),('78850','TX','D Hanis','Medina',29.254033,-99.297815),('78851','TX','Dryden','Terrell',29.982032,-101.935816),('78852','TX','Eagle Pass','Maverick',28.715738,-100.387629),('78853','TX','Eagle Pass','Maverick',28.5849,-100.2542),('78860','TX','El Indio','Maverick',28.498017,-100.309522),('78861','TX','Hondo','Medina',29.356003,-99.137185),('78870','TX','Knippa','Uvalde',29.303817,-99.630829),('78871','TX','Langtry','Val Verde',29.975591,-101.606588),('78872','TX','La Pryor','Zavala',28.941978,-99.860413),('78873','TX','Leakey','Real',29.744944,-99.761127),('78877','TX','Quemado','Maverick',28.936948,-100.606633),('78879','TX','Rio Frio','Real',29.628369,-99.702882),('78880','TX','Rocksprings','Edwards',30.02391,-100.204375),('78881','TX','Sabinal','Uvalde',29.347957,-99.498538),('78883','TX','Tarpley','Bandera',29.686668,-99.328615),('78884','TX','Utopia','Uvalde',29.612728,-99.509534),('78885','TX','Vanderpool','Bandera',29.785564,-99.552636),('78886','TX','Yancey','Medina',29.128792,-99.177938),('78931','TX','Bleiblerville','Austin',30.024253,-96.451051),('78932','TX','Carmine','Fayette',30.150076,-96.70795),('78933','TX','Cat Spring','Colorado',29.821675,-96.352252),('78934','TX','Columbus','Colorado',29.718437,-96.561844),('78935','TX','Alleyton','Colorado',29.681633,-96.444546),('78938','TX','Ellinger','Fayette',29.81377,-96.698803),('78940','TX','Fayetteville','Fayette',29.921048,-96.665991),('78941','TX','Flatonia','Fayette',29.722688,-97.127071),('78942','TX','Giddings','Lee',30.170233,-96.929618),('78943','TX','Glidden','Colorado',29.701668,-96.593056),('78944','TX','Industry','Austin',29.985632,-96.501566),('78945','TX','La Grange','Fayette',29.922032,-96.879197),('78946','TX','Ledbetter','Lee',30.17425,-96.773353),('78947','TX','Lexington','Lee',30.414729,-97.030573),('78948','TX','Lincoln','Lee',30.304728,-96.955522),('78949','TX','Muldoon','Fayette',29.830176,-97.076856),('78950','TX','New Ulm','Austin',29.895289,-96.483777),('78951','TX','Oakland','Colorado',29.599325,-96.830482),('78952','TX','Plum','Fayette',29.9347,-96.9672),('78953','TX','Rosanky','Bastrop',29.842148,-97.338371),('78954','TX','Round Top','Fayette',30.043881,-96.708652),('78956','TX','Schulenburg','Fayette',29.688667,-96.925674),('78957','TX','Smithville','Bastrop',30.010796,-97.158893),('78959','TX','Waelder','Gonzales',29.700745,-97.301328),('78960','TX','Warda','Fayette',30.070257,-96.919394),('78961','TX','Warrento','Fayette',30.0071,-96.7036),('78962','TX','Weimar','Colorado',29.696601,-96.758493),('78963','TX','West Point','Fayette',29.9342,-97.030229),('79001','TX','Adrian','Oldham',35.272284,-102.752209),('79002','TX','Alanreed','Gray',35.201105,-100.749392),('79003','TX','Allison','Wheeler',35.570039,-100.097042),('79005','TX','Booker','Lipscomb',36.412571,-100.510898),('79007','TX','Borger','Hutchinson',35.675894,-101.40038),('79008','TX','Borger','Hutchinson',35.7202,-101.2447),('79009','TX','Bovina','Parmer',34.512442,-102.884749),('79010','TX','Boys Ranch','Oldham',35.459748,-102.147794),('79011','TX','Briscoe','Wheeler',35.655346,-100.227765),('79012','TX','Bushland','Potter',35.20964,-102.088127),('79013','TX','Cactus','Moore',36.041901,-102.000846),('79014','TX','Canadian','Hemphill',35.873616,-100.30709),('79015','TX','Canyon','Randall',34.972625,-101.92194),('79016','TX','Canyon','Randall',34.983868,-101.918783),('79018','TX','Channing','Hartley',35.711067,-102.360318),('79019','TX','Claude','Armstrong',35.064447,-101.41335),('79021','TX','Cotton Center','Hale',33.982355,-102.032626),('79022','TX','Dalhart','Dallam',36.073654,-102.600413),('79024','TX','Darrouzett','Lipscomb',36.446741,-100.330387),('79025','TX','Dawn','Deaf Smith',34.911017,-102.198197),('79027','TX','Dimmitt','Castro',34.515893,-102.333112),('79029','TX','Dumas','Moore',35.891635,-101.980673),('79031','TX','Earth','Lamb',34.259065,-102.436748),('79032','TX','Edmonson','Hale',34.291142,-101.929441),('79033','TX','Farnsworth','Ochiltree',36.317616,-100.972645),('79034','TX','Follett','Lipscomb',36.397506,-100.158607),('79035','TX','Friona','Parmer',34.638977,-102.724197),('79036','TX','Fritch','Hutchinson',35.635359,-101.581813),('79039','TX','Groom','Carson',35.246626,-101.106445),('79040','TX','Gruver','Hansford',36.291799,-101.492977),('79041','TX','Hale Center','Hale',34.043135,-101.896953),('79042','TX','Happy','Swisher',34.734872,-101.868646),('79043','TX','Hart','Castro',34.383971,-102.132027),('79044','TX','Hartley','Hartley',35.877754,-102.391858),('79045','TX','Hereford','Deaf Smith',34.839643,-102.467218),('79046','TX','Higgins','Lipscomb',36.14095,-100.082817),('79051','TX','Kerrick','Dallam',36.483086,-102.259356),('79052','TX','Kress','Swisher',34.360686,-101.750577),('79053','TX','Lazbuddie','Parmer',34.413162,-102.573878),('79054','TX','Lefors','Gray',35.440618,-100.800043),('79056','TX','Lipscomb','Lipscomb',36.221657,-100.256581),('79057','TX','Mclean','Gray',35.249298,-100.634582),('79058','TX','Masterson','Moore',35.5992,-101.851),('79059','TX','Miami','Roberts',35.799469,-100.733891),('79061','TX','Mobeetie','Wheeler',35.515039,-100.436482),('79062','TX','Morse','Hansford',36.050785,-101.504982),('79063','TX','Nazareth','Castro',34.530998,-102.09654),('79064','TX','Olton','Lamb',34.19489,-102.132347),('79065','TX','Pampa','Gray',35.532925,-100.952502),('79066','TX','Pampa','Gray',35.4223,-100.8385),('79068','TX','Panhandle','Carson',35.343423,-101.414016),('79070','TX','Perryton','Ochiltree',36.358154,-100.802465),('79072','TX','Plainview','Hale',34.19109,-101.725128),('79073','TX','Plainview','Hale',34.1874,-101.7013),('79077','TX','Sam Norwood','Collingsworth',35.0522,-100.2802),('79078','TX','Sanford','Hutchinson',35.701079,-101.545413),('79079','TX','Shamrock','Wheeler',35.229549,-100.264448),('79080','TX','Skellytown','Carson',35.679663,-101.248914),('79081','TX','Spearman','Hansford',36.271633,-101.214944),('79082','TX','Springlake','Lamb',34.238731,-102.279664),('79083','TX','Stinnett','Hutchinson',35.847854,-101.488088),('79084','TX','Stratford','Sherman',36.307883,-102.023902),('79085','TX','Summerfield','Castro',34.73864,-102.509363),('79086','TX','Sunray','Moore',36.031238,-101.789878),('79087','TX','Texline','Dallam',36.33763,-102.969039),('79088','TX','Tulia','Swisher',34.552676,-101.733604),('79091','TX','Umbarger','Randall',34.925777,-102.122529),('79092','TX','Vega','Oldham',35.244861,-102.437961),('79093','TX','Waka','Ochiltree',36.282313,-101.045384),('79094','TX','Wayside','Armstrong',34.861614,-101.524364),('79095','TX','Wellington','Collingsworth',34.878434,-100.202706),('79096','TX','Wheeler','Wheeler',35.459143,-100.227792),('79097','TX','White Deer','Carson',35.433256,-101.178793),('79098','TX','Wildorado','Oldham',35.165399,-102.214883),('79101','TX','Amarillo','Potter',35.206476,-101.840411),('79102','TX','Amarillo','Potter',35.197234,-101.846102),('79103','TX','Amarillo','Potter',35.186079,-101.807287),('79104','TX','Amarillo','Potter',35.199639,-101.794785),('79105','TX','Amarillo','Potter',35.2219,-101.8308),('79106','TX','Amarillo','Potter',35.204637,-101.883502),('79107','TX','Amarillo','Potter',35.226184,-101.818253),('79108','TX','Amarillo','Potter',35.298242,-101.78616),('79109','TX','Amarillo','Randall',35.171996,-101.876748),('79110','TX','Amarillo','Randall',35.156278,-101.865159),('79111','TX','Amarillo','Potter',35.225409,-101.681064),('79114','TX','Amarillo','Randall',35.1637,-101.882),('79116','TX','Amarillo','Potter',35.2138,-101.8834),('79117','TX','Amarillo','Potter',35.2224,-101.8118),('79118','TX','Amarillo','Randall',35.122378,-101.800383),('79119','TX','Amarillo','Randall',35.111194,-101.953801),('79120','TX','Amarillo','Potter',35.1886,-101.8165),('79121','TX','Amarillo','Randall',35.175671,-101.927907),('79124','TX','Amarillo','Potter',35.248426,-101.949745),('79159','TX','Amarillo','Potter',35.2219,-101.8308),('79166','TX','Amarillo','Potter',35.1886,-101.8165),('79168','TX','Amarillo','Potter',35.1886,-101.8165),('79172','TX','Amarillo','Potter',35.1886,-101.8165),('79174','TX','Amarillo','Potter',35.1886,-101.8165),('79178','TX','Amarillo','Potter',35.1886,-101.8469),('79185','TX','Amarillo','Potter',35.1886,-101.8165),('79187','TX','Amarillo','Potter',35.2662,-101.7196),('79189','TX','Amarillo','Potter',35.1886,-101.8165),('79201','TX','Childress','Childress',34.443663,-100.247299),('79220','TX','Afton','Dickens',33.762541,-100.787648),('79221','TX','Aiken','Floyd',34.1422,-101.5252),('79223','TX','Cee Vee','Cottle',34.216509,-100.471984),('79225','TX','Chillicothe','Hardeman',34.2646,-99.510596),('79226','TX','Clarendon','Donley',34.941693,-100.955063),('79227','TX','Crowell','Foard',33.912331,-99.761451),('79229','TX','Dickens','Dickens',33.648865,-100.730011),('79230','TX','Dodson','Collingsworth',34.739698,-100.038243),('79231','TX','Dougherty','Floyd',33.923236,-101.086253),('79233','TX','Estelline','Hall',34.548595,-100.489721),('79234','TX','Flomot','Motley',34.237643,-100.937199),('79235','TX','Floydada','Floyd',33.956424,-101.272101),('79236','TX','Guthrie','King',33.631749,-100.225039),('79237','TX','Hedley','Donley',34.90574,-100.654533),('79239','TX','Lakeview','Hall',34.655759,-100.746242),('79240','TX','Lelia Lake','Donley',34.894493,-100.763686),('79241','TX','Lockney','Floyd',34.178223,-101.424082),('79243','TX','Mcadoo','Dickens',33.771853,-101.013854),('79244','TX','Matador','Motley',34.039125,-100.829206),('79245','TX','Memphis','Hall',34.775705,-100.522453),('79247','TX','Odell','Wilbarger',34.343369,-99.419217),('79248','TX','Paducah','Cottle',34.010072,-100.286211),('79250','TX','Petersburg','Hale',33.872831,-101.597238),('79251','TX','Quail','Collingsworth',34.943421,-100.451566),('79252','TX','Quanah','Hardeman',34.295761,-99.783267),('79255','TX','Quitaque','Briscoe',34.334499,-101.050954),('79256','TX','Roaring Springs','Motley',33.906472,-100.779159),('79257','TX','Silverton','Briscoe',34.456791,-101.321487),('79258','TX','South Plains','Floyd',34.237147,-101.292986),('79259','TX','Tell','Childress',34.398492,-100.472927),('79261','TX','Turkey','Hall',34.421917,-100.833061),('79311','TX','Abernathy','Hale',33.850507,-101.875207),('79312','TX','Amherst','Lamb',34.030366,-102.387457),('79313','TX','Anton','Hockley',33.805963,-102.160218),('79314','TX','Bledsoe','Cochran',33.618278,-103.020828),('79316','TX','Brownfield','Terry',33.158595,-102.294295),('79320','TX','Bula','Bailey',33.861914,-102.673559),('79322','TX','Crosbyton','Crosby',33.667709,-101.228017),('79323','TX','Denver City','Yoakum',32.967479,-102.852571),('79324','TX','Enochs','Bailey',33.872782,-102.68462),('79325','TX','Farwell','Parmer',34.410465,-102.951873),('79326','TX','Fieldton','Lamb',34.04877,-102.209585),('79329','TX','Idalou','Lubbock',33.701848,-101.690951),('79330','TX','Justiceburg','Garza',33.046803,-101.161467),('79331','TX','Lamesa','Dawson',32.704879,-101.965711),('79336','TX','Levelland','Hockley',33.603176,-102.421114),('79338','TX','Levelland','Hockley',33.652,-102.3839),('79339','TX','Littlefield','Lamb',33.90358,-102.334542),('79342','TX','Loop','Gaines',32.907968,-102.338852),('79343','TX','Lorenzo','Crosby',33.66554,-101.531032),('79344','TX','Maple','Bailey',33.835876,-102.920759),('79345','TX','Meadow','Terry',33.337181,-102.288778),('79346','TX','Morton','Cochran',33.688429,-102.769069),('79347','TX','Muleshoe','Bailey',34.219225,-102.736477),('79350','TX','New Deal','Lubbock',33.737908,-101.837743),('79351','TX','Odonnell','Lynn',32.942132,-101.809228),('79353','TX','Pep','Hockley',33.775951,-102.591636),('79355','TX','Plains','Yoakum',33.138506,-102.854398),('79356','TX','Post','Garza',33.225236,-101.36147),('79357','TX','Ralls','Crosby',33.643997,-101.382681),('79358','TX','Ropesville','Hockley',33.434852,-102.181817),('79359','TX','Seagraves','Gaines',32.961294,-102.581331),('79360','TX','Seminole','Gaines',32.700366,-102.729746),('79363','TX','Shallowater','Lubbock',33.699973,-102.019687),('79364','TX','Slaton','Lubbock',33.441097,-101.648072),('79366','TX','Ransom Canyon','Lubbock',33.531425,-101.681658),('79367','TX','Smyer','Hockley',33.595746,-102.168629),('79369','TX','Spade','Lamb',33.957754,-102.148048),('79370','TX','Spur','Dickens',33.500925,-100.896538),('79371','TX','Sudan','Lamb',34.00701,-102.613047),('79372','TX','Sundown','Hockley',33.44773,-102.488741),('79373','TX','Tahoka','Lynn',33.170613,-101.813982),('79376','TX','Tokio','Yoakum',33.217256,-102.651229),('79377','TX','Welch','Dawson',32.929648,-102.133506),('79378','TX','Wellman','Terry',33.058133,-102.474677),('79379','TX','Whiteface','Cochran',33.552744,-102.635806),('79380','TX','Whitharral','Hockley',33.731844,-102.355534),('79381','TX','Wilson','Lynn',33.329832,-101.768734),('79382','TX','Wolfforth','Lubbock',33.493811,-102.013684),('79383','TX','New Home','Lynn',33.330983,-101.910656),('79401','TX','Lubbock','Lubbock',33.585973,-101.849639),('79402','TX','Lubbock','Lubbock',33.5579,-101.843),('79403','TX','Lubbock','Lubbock',33.617864,-101.807782),('79404','TX','Lubbock','Lubbock',33.549421,-101.813674),('79405','TX','Lubbock','Lubbock',33.570035,-101.849846),('79406','TX','Lubbock','Lubbock',33.5825,-101.883409),('79407','TX','Lubbock','Lubbock',33.565989,-102.000434),('79408','TX','Lubbock','Lubbock',33.5916,-101.848),('79409','TX','Lubbock','Lubbock',33.5837,-101.8809),('79410','TX','Lubbock','Lubbock',33.569081,-101.887914),('79411','TX','Lubbock','Lubbock',33.569576,-101.856434),('79412','TX','Lubbock','Lubbock',33.546383,-101.856516),('79413','TX','Lubbock','Lubbock',33.547402,-101.885644),('79414','TX','Lubbock','Lubbock',33.551088,-101.918068),('79415','TX','Lubbock','Lubbock',33.62584,-101.87948),('79416','TX','Lubbock','Lubbock',33.594209,-101.946135),('79423','TX','Lubbock','Lubbock',33.495887,-101.871601),('79424','TX','Lubbock','Lubbock',33.511169,-101.934853),('79430','TX','Lubbock','Lubbock',33.5579,-101.843),('79452','TX','Lubbock','Lubbock',33.5483,-101.8481),('79453','TX','Lubbock','Lubbock',33.5026,-101.8742),('79457','TX','Lubbock','Lubbock',33.5579,-101.843),('79464','TX','Lubbock','Lubbock',33.5579,-101.843),('79490','TX','Lubbock','Lubbock',33.5777,-101.8547),('79491','TX','Lubbock','Lubbock',33.5026,-101.8742),('79493','TX','Lubbock','Lubbock',33.5482,-101.8831),('79499','TX','Lubbock','Lubbock',33.5921,-102.018),('79501','TX','Anson','Jones',32.753529,-99.898624),('79502','TX','Aspermont','Stonewall',33.153147,-100.22749),('79503','TX','Avoca','Jones',32.879434,-99.678343),('79504','TX','Baird','Callahan',32.367222,-99.369865),('79505','TX','Benjamin','Knox',33.586271,-99.801625),('79506','TX','Blackwell','Nolan',32.092216,-100.313555),('79508','TX','Buffalo Gap','Taylor',32.280151,-99.829522),('79510','TX','Clyde','Callahan',32.333859,-99.516843),('79511','TX','Coahoma','Howard',32.379747,-101.271402),('79512','TX','Colorado City','Mitchell',32.372081,-100.91327),('79516','TX','Dunn','Scurry',32.5669,-100.885),('79517','TX','Fluvanna','Scurry',32.883317,-101.206054),('79518','TX','Girard','Kent',33.339002,-100.704474),('79519','TX','Goldsboro','Coleman',32.065529,-99.684563),('79520','TX','Hamlin','Jones',32.875314,-100.142357),('79521','TX','Haskell','Haskell',33.128589,-99.679343),('79525','TX','Hawley','Jones',32.621163,-99.827216),('79526','TX','Hermleigh','Scurry',32.624744,-100.73765),('79527','TX','Ira','Scurry',32.604153,-101.125229),('79528','TX','Jayton','Kent',33.244782,-100.727571),('79529','TX','Knox City','Knox',33.423202,-99.820325),('79530','TX','Lawn','Taylor',32.120249,-99.753027),('79532','TX','Loraine','Mitchell',32.415776,-100.714482),('79533','TX','Lueders','Jones',32.850125,-99.574164),('79534','TX','Mc Caulley','Fisher',32.769977,-100.214126),('79535','TX','Maryneal','Nolan',32.236042,-100.468543),('79536','TX','Merkel','Taylor',32.474276,-100.029498),('79537','TX','Nolan','Nolan',32.289835,-100.210983),('79538','TX','Novice','Coleman',31.981654,-99.669772),('79539','TX','O Brien','Haskell',33.378546,-99.895731),('79540','TX','Old Glory','Stonewall',33.169164,-100.040999),('79541','TX','Ovalo','Taylor',32.157311,-99.861178),('79543','TX','Roby','Fisher',32.732445,-100.38105),('79544','TX','Rochester','Haskell',33.310742,-99.862932),('79545','TX','Roscoe','Nolan',32.436808,-100.562211),('79546','TX','Rotan','Fisher',32.870167,-100.486327),('79547','TX','Rule','Haskell',33.197744,-99.905443),('79548','TX','Rule','Haskell',33.05873,-99.911207),('79549','TX','Snyder','Scurry',32.795371,-100.90897),('79550','TX','Snyder','Scurry',32.7196,-100.9172),('79553','TX','Stamford','Jones',32.941303,-99.8108),('79556','TX','Sweetwater','Nolan',32.459148,-100.387291),('79560','TX','Sylvester','Fisher',32.687007,-100.232793),('79561','TX','Trent','Taylor',32.501932,-100.173458),('79562','TX','Tuscola','Taylor',32.237194,-99.869803),('79563','TX','Tye','Taylor',32.441454,-99.872822),('79565','TX','Westbrook','Mitchell',32.377394,-101.044755),('79566','TX','Wingate','Taylor',32.096705,-100.120644),('79567','TX','Winters','Runnels',31.967876,-99.956356),('79601','TX','Abilene','Taylor',32.51191,-99.698506),('79602','TX','Abilene','Taylor',32.405248,-99.714346),('79603','TX','Abilene','Taylor',32.462313,-99.774903),('79604','TX','Abilene','Taylor',32.3783,-99.6907),('79605','TX','Abilene','Taylor',32.434082,-99.770835),('79606','TX','Abilene','Taylor',32.381548,-99.802587),('79607','TX','Dyess Afb','Taylor',32.426243,-99.824337),('79608','TX','Abilene','Taylor',32.4189,-99.7492),('79697','TX','Abilene','Taylor',32.4308,-99.749),('79698','TX','Abilene','Taylor',32.4486,-99.7327),('79699','TX','Abilene','Taylor',32.462235,-99.715894),('79701','TX','Midland','Midland',31.995825,-102.081125),('79702','TX','Midland','Midland',31.8691,-101.9227),('79703','TX','Midland','Midland',31.982992,-102.132316),('79704','TX','Midland','Midland',31.9972,-102.0775),('79705','TX','Midland','Midland',32.031868,-102.089078),('79706','TX','Midland','Midland',31.912308,-102.017521),('79707','TX','Midland','Midland',32.020011,-102.163853),('79708','TX','Midland','Midland',32.0196,-102.1253),('79710','TX','Midland','Midland',32.0593,-102.021),('79711','TX','Midland','Midland',31.7945,-102.1687),('79712','TX','Midland','Midland',31.7945,-102.1687),('79713','TX','Ackerly','Martin',32.520455,-101.740282),('79714','TX','Andrews','Andrews',32.324012,-102.592445),('79718','TX','Balmorhea','Reeves',30.987748,-103.735795),('79719','TX','Barstow','Ward',31.462137,-103.396274),('79720','TX','Big Spring','Howard',32.243544,-101.469592),('79721','TX','Big Spring','Howard',32.2502,-101.4783),('79730','TX','Coyanosa','Pecos',31.19731,-103.080653),('79731','TX','Crane','Crane',31.408821,-102.397907),('79733','TX','Forsan','Howard',32.107196,-101.366777),('79734','TX','Fort Davis','Jeff Davis',30.62503,-103.975946),('79735','TX','Fort Stockton','Pecos',30.854979,-102.860043),('79738','TX','Gail','Borden',32.745917,-101.529854),('79739','TX','Garden City','Glasscock',31.782008,-101.561955),('79740','TX','Girvin','Pecos',31.019602,-102.47675),('79741','TX','Goldsmith','Ector',31.955209,-102.626293),('79742','TX','Grandfalls','Ward',31.354397,-102.876836),('79743','TX','Imperial','Pecos',31.217316,-102.672564),('79744','TX','Iraan','Pecos',30.902591,-101.972734),('79745','TX','Kermit','Winkler',31.865006,-103.106056),('79748','TX','Knott','Howard',32.411429,-101.635262),('79749','TX','Lenorah','Martin',32.303581,-101.881111),('79752','TX','Mc Camey','Upton',31.154699,-102.230575),('79754','TX','Mentone','Loving',31.735462,-103.589698),('79755','TX','Midkiff','Upton',31.531005,-101.871762),('79756','TX','Monahans','Ward',31.555058,-102.901275),('79758','TX','Gardendale','Ector',32.020337,-102.347168),('79759','TX','Notrees','Ector',31.840191,-102.747099),('79760','TX','Odessa','Ector',31.8465,-102.3663),('79761','TX','Odessa','Ector',31.855197,-102.35644),('79762','TX','Odessa','Ector',31.891713,-102.348754),('79763','TX','Odessa','Ector',31.826327,-102.42859),('79764','TX','Odessa','Ector',31.865869,-102.453582),('79765','TX','Odessa','Ector',31.908196,-102.301024),('79766','TX','Odessa','Ector',31.737524,-102.371413),('79768','TX','Odessa','Ector',31.9037,-102.3324),('79769','TX','Odessa','Ector',31.8465,-102.3663),('79770','TX','Orla','Reeves',31.8288,-103.9138),('79772','TX','Pecos','Reeves',31.404938,-103.537865),('79776','TX','Penwell','Ector',31.730204,-102.628313),('79777','TX','Pyote','Ward',31.525818,-103.138763),('79778','TX','Rankin','Upton',31.218289,-101.938258),('79780','TX','Saragosa','Reeves',31.070615,-103.619702),('79781','TX','Sheffield','Pecos',30.604288,-101.811631),('79782','TX','Stanton','Martin',32.131458,-101.825929),('79783','TX','Tarzan','Martin',32.341647,-102.040039),('79785','TX','Toyah','Reeves',31.31912,-103.83806),('79786','TX','Toyahvale','Reeves',30.9441,-103.7888),('79788','TX','Wickett','Ward',31.568344,-103.002185),('79789','TX','Wink','Winkler',31.756988,-103.15922),('79821','TX','Anthony','El Paso',31.983849,-106.596163),('79830','TX','Alpine','Brewster',30.047266,-103.484973),('79831','TX','Alpine','Brewster',30.466104,-103.394618),('79832','TX','Alpine','Brewster',30.363,-103.6536),('79834','TX','Big Bend National Park','Brewster',29.318888,-103.210849),('79835','TX','Canutillo','El Paso',31.931476,-106.592618),('79836','TX','Clint','El Paso',31.581344,-106.215735),('79837','TX','Dell City','Hudspeth',32.10852,-105.324878),('79838','TX','Fabens','El Paso',31.503015,-106.162868),('79839','TX','Fort Hancock','Hudspeth',31.182685,-105.721958),('79842','TX','Marathon','Brewster',30.141194,-103.226016),('79843','TX','Marfa','Presidio',30.203886,-104.122861),('79845','TX','Presidio','Presidio',29.632752,-104.395497),('79846','TX','Redford','Presidio',29.455369,-104.039028),('79847','TX','Salt Flat','Hudspeth',31.819874,-105.121397),('79848','TX','Sanderson','Terrell',30.241032,-102.313225),('79849','TX','San Elizario','El Paso',31.569723,-106.255633),('79851','TX','Sierra Blanca','Hudspeth',31.229464,-105.322531),('79852','TX','Terlingua','Brewster',29.421883,-103.585944),('79853','TX','Tornillo','El Paso',31.441962,-106.083474),('79854','TX','Valentine','Jeff Davis',30.60837,-104.591502),('79855','TX','Van Horn','Culberson',31.064745,-104.729968),('79901','TX','El Paso','El Paso',31.759398,-106.480128),('79902','TX','El Paso','El Paso',31.77597,-106.494951),('79903','TX','El Paso','El Paso',31.786187,-106.444228),('79904','TX','El Paso','El Paso',31.849932,-106.441316),('79905','TX','El Paso','El Paso',31.769375,-106.432227),('79906','TX','El Paso','El Paso',31.814538,-106.422385),('79907','TX','El Paso','El Paso',31.708129,-106.327854),('79908','TX','El Paso','El Paso',31.827225,-106.389389),('79910','TX','El Paso','El Paso',31.7691,-106.4264),('79911','TX','El Paso','El Paso',31.880885,-106.55962),('79912','TX','El Paso','El Paso',31.84891,-106.542503),('79913','TX','El Paso','El Paso',31.8405,-106.5659),('79914','TX','El Paso','El Paso',31.8816,-106.4195),('79915','TX','El Paso','El Paso',31.746041,-106.371426),('79916','TX','El Paso','El Paso',31.809583,-106.418485),('79917','TX','El Paso','El Paso',31.6927,-106.327),('79918','TX','El Paso','El Paso',31.8289,-106.3859),('79920','TX','El Paso','El Paso',31.825535,-106.451138),('79922','TX','El Paso','El Paso',31.81579,-106.568282),('79923','TX','El Paso','El Paso',31.7818,-106.4591),('79924','TX','El Paso','El Paso',31.901293,-106.41411),('79925','TX','El Paso','El Paso',31.781254,-106.368098),('79926','TX','El Paso','El Paso',31.7649,-106.3659),('79927','TX','El Paso','El Paso',31.646578,-106.278472),('79928','TX','El Paso','El Paso',31.671343,-106.178222),('79929','TX','El Paso','El Paso',31.692,-106.1575),('79930','TX','El Paso','El Paso',31.805428,-106.45607),('79931','TX','El Paso','El Paso',31.81,-106.47),('79932','TX','El Paso','El Paso',31.871383,-106.600245),('79934','TX','El Paso','El Paso',31.937217,-106.415674),('79935','TX','El Paso','El Paso',31.773432,-106.331011),('79936','TX','El Paso','El Paso',31.766296,-106.295673),('79937','TX','El Paso','El Paso',31.7847,-106.3363),('79938','TX','El Paso','El Paso',31.826695,-106.143248),('79940','TX','El Paso','El Paso',31.7598,-106.4871),('79941','TX','El Paso','El Paso',31.7598,-106.4871),('79942','TX','El Paso','El Paso',31.7598,-106.4871),('79943','TX','El Paso','El Paso',31.7598,-106.4871),('79944','TX','El Paso','El Paso',31.7598,-106.4871),('79945','TX','El Paso','El Paso',31.7598,-106.4871),('79946','TX','El Paso','El Paso',31.7598,-106.4871),('79947','TX','El Paso','El Paso',31.7598,-106.4871),('79948','TX','El Paso','El Paso',31.7598,-106.4871),('79949','TX','El Paso','El Paso',31.7598,-106.4871),('79950','TX','El Paso','El Paso',31.7598,-106.4871),('79951','TX','El Paso','El Paso',31.7598,-106.4871),('79952','TX','El Paso','El Paso',31.7598,-106.4871),('79953','TX','El Paso','El Paso',31.7598,-106.4871),('79954','TX','El Paso','El Paso',31.7598,-106.4871),('79955','TX','El Paso','El Paso',31.7598,-106.4871),('79958','TX','El Paso','El Paso',31.7598,-106.4871),('79960','TX','El Paso','El Paso',31.7598,-106.4871),('79961','TX','El Paso','El Paso',31.7598,-106.4871),('79968','TX','El Paso','El Paso',31.7707,-106.5037),('79976','TX','El Paso','El Paso',31.7598,-106.4871),('79978','TX','El Paso','El Paso',31.7598,-106.4871),('79980','TX','El Paso','El Paso',31.7598,-106.4871),('79990','TX','El Paso','El Paso',31.7691,-106.4264),('79995','TX','El Paso','El Paso',31.7691,-106.4264),('79996','TX','El Paso','El Paso',31.7691,-106.4264),('79997','TX','El Paso','El Paso',31.7691,-106.4264),('79998','TX','El Paso','El Paso',31.7691,-106.4264),('79999','TX','El Paso','El Paso',31.7691,-106.4264),('80001','CO','Arvada','Jefferson',39.8039,-105.0859),('80002','CO','Arvada','Jefferson',39.795956,-105.093095),('80003','CO','Arvada','Jefferson',39.82538,-105.064418),('80004','CO','Arvada','Jefferson',39.813779,-105.12217),('80005','CO','Arvada','Jefferson',39.843861,-105.12474),('80006','CO','Arvada','Jefferson',39.8467,-105.0815),('80007','CO','Arvada','Jefferson',39.83837,-105.185291),('80010','CO','Aurora','Arapahoe',39.739249,-104.864054),('80011','CO','Aurora','Arapahoe',39.743135,-104.806821),('80012','CO','Aurora','Arapahoe',39.700204,-104.837528),('80013','CO','Aurora','Arapahoe',39.659591,-104.775014),('80014','CO','Aurora','Arapahoe',39.663753,-104.837496),('80015','CO','Aurora','Arapahoe',39.62446,-104.77393),('80016','CO','Aurora','Arapahoe',39.596829,-104.73294),('80017','CO','Aurora','Arapahoe',39.694894,-104.786573),('80018','CO','Aurora','Arapahoe',39.704166,-104.710842),('80019','CO','Aurora','Adams',39.783722,-104.725539),('80020','CO','Broomfield','Broomfield',39.924384,-105.06807),('80021','CO','Broomfield','Jefferson',39.890713,-105.105708),('80022','CO','Commerce City','Adams',39.862866,-104.874466),('80023','CO','Broomfie','Broomfield',39.970697,-105.017826),('80024','CO','Dupont','Adams',39.844523,-104.91846),('80025','CO','Eldorado Springs','Boulder',39.933657,-105.285262),('80026','CO','Lafayette','Boulder',40.00078,-105.098824),('80027','CO','Louisville','Boulder',39.963507,-105.148264),('80028','CO','Louisville','Boulder',39.9531,-105.1466),('80030','CO','Westminster','Adams',39.83079,-105.035993),('80031','CO','Westminster','Adams',39.873122,-105.039129),('80033','CO','Wheat Ridge','Jefferson',39.774083,-105.097354),('80034','CO','Wheat Ridge','Jefferson',39.7744,-105.0808),('80035','CO','Westminster','Adams',39.8613,-105.0381),('80036','CO','Westminster','Adams',39.8613,-105.0381),('80037','CO','Commerce City','Adams',39.8222,-104.9333),('80038','CO','Broomfield','Boulder',39.9205,-105.0861),('80040','CO','Aurora','Adams',39.7412,-104.8749),('80041','CO','Aurora','Arapahoe',39.6986,-104.8371),('80042','CO','Aurora','Adams',39.7404,-104.8089),('80044','CO','Aurora','Arapahoe',39.6609,-104.8351),('80045','CO','Aurora','Adams',39.749996,-104.838595),('80046','CO','Aurora','Arapahoe',39.6283,-104.7966),('80047','CO','Aurora','Arapahoe',39.7007,-104.767),('80101','CO','Agate','Elbert',39.395184,-103.965852),('80102','CO','Bennett','Adams',39.765284,-104.430158),('80103','CO','Byers','Arapahoe',39.724905,-104.162592),('80104','CO','Castle Rock','Douglas',39.357414,-104.837026),('80105','CO','Deer Trail','Arapahoe',39.654322,-104.034182),('80106','CO','Elbert','El Paso',39.12896,-104.556009),('80107','CO','Elizabeth','Elbert',39.397237,-104.587152),('80108','CO','Castle Rock','Douglas',39.445319,-104.865741),('80109','CO','Castle Rock','Douglas',39.386427,-104.887996),('80110','CO','Englewood','Arapahoe',39.644953,-105.006881),('80111','CO','Englewood','Arapahoe',39.613005,-104.877957),('80112','CO','Englewood','Arapahoe',39.578034,-104.87126),('80113','CO','Englewood','Arapahoe',39.648732,-104.974912),('80116','CO','Franktown','Douglas',39.306275,-104.707968),('80117','CO','Kiowa','Elbert',39.364272,-104.408299),('80118','CO','Larkspur','Douglas',39.208186,-104.893164),('80120','CO','Littleton','Arapahoe',39.599613,-105.007532),('80121','CO','Littleton','Arapahoe',39.608537,-104.958271),('80122','CO','Littleton','Arapahoe',39.583163,-104.958286),('80123','CO','Littleton','Jefferson',39.615449,-105.070068),('80124','CO','Lone Tree','Douglas',39.541443,-104.89065),('80125','CO','Littleton','Douglas',39.485069,-105.052316),('80126','CO','Littleton','Douglas',39.542898,-104.959067),('80127','CO','Littleton','Jefferson',39.594743,-105.132274),('80128','CO','Littleton','Jefferson',39.574525,-105.078591),('80129','CO','Littleton','Douglas',39.541929,-105.011404),('80130','CO','Littleton','Douglas',39.535911,-104.922666),('80131','CO','Louviers','Douglas',39.47675,-105.007922),('80132','CO','Monument','El Paso',39.091513,-104.860155),('80133','CO','Palmer Lake','El Paso',39.113448,-104.915502),('80134','CO','Parker','Douglas',39.507621,-104.787155),('80135','CO','Sedalia','Douglas',39.299321,-105.078036),('80136','CO','Strasburg','Adams',39.767869,-104.32294),('80137','CO','Watkins','Arapahoe',39.770398,-104.597586),('80138','CO','Parker','Douglas',39.522241,-104.714877),('80150','CO','Englewood','Arapahoe',39.6478,-104.998),('80151','CO','Englewood','Arapahoe',39.6478,-104.998),('80155','CO','Englewood','Arapahoe',39.5932,-104.8754),('80160','CO','Littleton','Arapahoe',39.6128,-105.0156),('80161','CO','Littleton','Arapahoe',39.5953,-104.9622),('80162','CO','Littleton','Jefferson',39.5999,-105.1073),('80163','CO','Littleton','Douglas',39.5427,-104.9365),('80165','CO','Littleton','Arapahoe',39.6133,-105.0161),('80166','CO','Littleton','Arapahoe',39.6133,-105.0161),('80201','CO','Denver','Denver',39.7507,-104.989),('80202','CO','Denver','Denver',39.749837,-104.997032),('80203','CO','Denver','Denver',39.731235,-104.982538),('80204','CO','Denver','Denver',39.734263,-105.020441),('80205','CO','Denver','Denver',39.758864,-104.966567),('80206','CO','Denver','Denver',39.729815,-104.952309),('80207','CO','Denver','Denver',39.759274,-104.919346),('80208','CO','Denver','Denver',39.6777,-104.9611),('80209','CO','Denver','Denver',39.70658,-104.966904),('80210','CO','Denver','Denver',39.679395,-104.964646),('80211','CO','Denver','Denver',39.767444,-105.019736),('80212','CO','Denver','Denver',39.770252,-105.048024),('80214','CO','Denver','Jefferson',39.743621,-105.069237),('80215','CO','Denver','Jefferson',39.744764,-105.114847),('80216','CO','Denver','Denver',39.782852,-104.961873),('80217','CO','Denver','Denver',39.7391,-104.9841),('80218','CO','Denver','Denver',39.731259,-104.971215),('80219','CO','Denver','Denver',39.697868,-105.034982),('80220','CO','Denver','Denver',39.734382,-104.916701),('80221','CO','Denver','Adams',39.817022,-105.011114),('80222','CO','Denver','Denver',39.669666,-104.927966),('80223','CO','Denver','Denver',39.698479,-105.002455),('80224','CO','Denver','Denver',39.691142,-104.911632),('80225','CO','Denver','Jefferson',39.7204,-105.1201),('80226','CO','Denver','Jefferson',39.712427,-105.088878),('80227','CO','Denver','Jefferson',39.668804,-105.086754),('80228','CO','Denver','Jefferson',39.689919,-105.145672),('80229','CO','Denver','Adams',39.858007,-104.960643),('80230','CO','Denver','Denver',39.720511,-104.89604),('80231','CO','Denver','Denver',39.670068,-104.893075),('80232','CO','Denver','Jefferson',39.689043,-105.087556),('80233','CO','Denver','Adams',39.899224,-104.950957),('80234','CO','Denver','Adams',39.908413,-105.008419),('80235','CO','Denver','Jefferson',39.647086,-105.086851),('80236','CO','Denver','Denver',39.652353,-105.040034),('80237','CO','Denver','Denver',39.637806,-104.901478),('80238','CO','Denver','Denver',39.761842,-104.881222),('80239','CO','Denver','Denver',39.787679,-104.829451),('80241','CO','Thornton','Adams',39.929772,-104.948427),('80243','CO','Denver','Denver',39.6875,-104.9613),('80244','CO','Denver','Denver',39.7391,-104.9841),('80246','CO','Denver','Denver',39.706721,-104.930601),('80247','CO','Denver','Arapahoe',39.697659,-104.885403),('80248','CO','Denver','Denver',39.7516,-105.0008),('80249','CO','Denver','Denver',39.797485,-104.735977),('80250','CO','Denver','Denver',39.68,-104.9433),('80251','CO','Denver','Denver',39.7391,-104.9841),('80252','CO','Denver','Denver',39.7391,-104.9841),('80256','CO','Denver','Denver',39.7391,-104.9841),('80257','CO','Denver','Denver',39.7391,-104.9841),('80259','CO','Denver','Denver',39.7391,-104.9841),('80260','CO','Denver','Adams',39.868047,-105.007322),('80261','CO','Denver','Denver',39.7391,-104.9841),('80262','CO','Denver','Denver',39.7328,-104.9366),('80263','CO','Denver','Denver',39.6522,-104.9129),('80264','CO','Denver','Denver',39.742486,-104.985635),('80265','CO','Denver','Denver',39.7391,-104.9841),('80266','CO','Denver','Denver',39.7983,-104.8999),('80271','CO','Denver','Denver',39.7391,-104.9841),('80273','CO','Denver','Denver',39.7391,-104.9841),('80274','CO','Denver','Denver',39.7391,-104.9841),('80279','CO','Denver','Denver',39.7391,-104.9841),('80280','CO','Denver','Denver',39.7193,-104.8989),('80281','CO','Denver','Denver',39.7391,-104.9841),('80290','CO','Denver','Denver',39.744086,-104.98696),('80291','CO','Denver','Denver',39.7391,-104.9841),('80293','CO','Denver','Denver',39.746286,-104.990086),('80294','CO','Denver','Denver',39.749436,-104.989485),('80295','CO','Denver','Denver',39.7454,-104.9859),('80299','CO','Denver','Denver',39.7472,-104.9912),('80301','CO','Boulder','Boulder',40.044262,-105.220223),('80302','CO','Boulder','Boulder',40.020648,-105.299251),('80303','CO','Boulder','Boulder',39.995435,-105.214514),('80304','CO','Boulder','Boulder',40.040578,-105.279979),('80305','CO','Boulder','Boulder',39.980601,-105.249864),('80306','CO','Boulder','Boulder',40.0178,-105.2752),('80307','CO','Boulder','Boulder',39.9858,-105.2371),('80308','CO','Boulder','Boulder',40.015,-105.27),('80309','CO','Boulder','Boulder',40.0054,-105.2649),('80310','CO','Boulder','Boulder',40.002148,-105.263655),('80314','CO','Boulder','Boulder',40.015,-105.27),('80321','CO','Boulder','Boulder',40.015,-105.27),('80322','CO','Boulder','Boulder',40.015,-105.27),('80323','CO','Boulder','Boulder',40.015,-105.27),('80328','CO','Boulder','Boulder',40.015,-105.27),('80329','CO','Boulder','Boulder',40.015,-105.27),('80401','CO','Golden','Jefferson',39.735665,-105.196842),('80402','CO','Golden','Jefferson',39.7563,-105.2188),('80403','CO','Golden','Jefferson',39.823083,-105.263253),('80419','CO','Golden','Jefferson',39.727796,-105.200917),('80420','CO','Alma','Park',39.290427,-106.077619),('80421','CO','Bailey','Park',39.450098,-105.478729),('80422','CO','Black Hawk','Gilpin',39.868416,-105.498408),('80423','CO','Bond','Eagle',39.881079,-106.627155),('80424','CO','Breckenridge','Summit',39.483147,-106.029563),('80425','CO','Buffalo Creek','Jefferson',39.360748,-105.240797),('80426','CO','Burns','Eagle',39.886193,-106.929025),('80427','CO','Central City','Gilpin',39.790377,-105.507082),('80428','CO','Clark','Routt',40.841445,-106.951194),('80429','CO','Climax','Lake',39.3269,-106.2301),('80430','CO','Coalmont','Jackson',40.436948,-106.494246),('80432','CO','Como','Park',39.222376,-105.796908),('80433','CO','Conifer','Jefferson',39.509232,-105.297896),('80434','CO','Cowdrey','Jackson',40.845309,-106.292953),('80435','CO','Dillon','Summit',39.603665,-105.97254),('80436','CO','Dumont','Clear Creek',39.767787,-105.627014),('80437','CO','Evergreen','Jefferson',39.6513,-105.3442),('80438','CO','Empire','Clear Creek',39.762875,-105.710076),('80439','CO','Evergreen','Jefferson',39.646517,-105.379131),('80440','CO','Fairplay','Park',39.228822,-105.98927),('80442','CO','Fraser','Grand',39.939128,-105.850294),('80443','CO','Frisco','Summit',39.548937,-106.104544),('80444','CO','Georgetown','Clear Creek',39.694023,-105.705702),('80446','CO','Granby','Grand',40.14355,-105.953128),('80447','CO','Grand Lake','Grand',40.246501,-105.843552),('80448','CO','Grant','Park',39.457237,-105.714803),('80449','CO','Hartsel','Park',38.972336,-105.816561),('80451','CO','Hot Sulphur Springs','Grand',40.076299,-106.087417),('80452','CO','Idaho Springs','Clear Creek',39.740991,-105.563432),('80453','CO','Idledale','Jefferson',39.665049,-105.242668),('80454','CO','Indian Hills','Jefferson',39.630935,-105.260238),('80455','CO','Jamestown','Boulder',40.110603,-105.388269),('80456','CO','Jefferson','Park',39.297162,-105.724334),('80457','CO','Kittredge','Jefferson',39.650824,-105.294613),('80459','CO','Kremmling','Grand',40.146605,-106.439429),('80461','CO','Leadville','Lake',39.242116,-106.307506),('80463','CO','Mc Coy','Routt',39.9541,-106.736571),('80465','CO','Morrison','Jefferson',39.625293,-105.184587),('80466','CO','Nederland','Boulder',39.96412,-105.505806),('80467','CO','Oak Creek','Routt',40.289661,-106.930918),('80468','CO','Parshall','Grand',39.98489,-106.128683),('80469','CO','Phippsburg','Routt',40.213328,-106.952931),('80470','CO','Pine','Jefferson',39.439558,-105.36273),('80471','CO','Pinecliffe','Boulder',39.9586,-105.3643),('80473','CO','Rand','Jackson',40.441699,-106.155738),('80474','CO','Rollinsville','Gilpin',39.908923,-105.570575),('80475','CO','Shawnee','Park',39.431023,-105.567172),('80476','CO','Silver Plume','Clear Creek',39.692643,-105.803877),('80477','CO','Steamboat Springs','Routt',40.486627,-106.829349),('80478','CO','Tabernash','Grand',40.007366,-105.871771),('80479','CO','Toponas','Routt',40.059801,-106.80298),('80480','CO','Walden','Jackson',40.694354,-106.300284),('80481','CO','Ward','Boulder',40.094732,-105.487213),('80482','CO','Winter Park','Grand',39.913613,-105.781047),('80483','CO','Yampa','Routt',40.138133,-106.90915),('80487','CO','Steamboat Springs','Routt',40.470083,-106.882038),('80488','CO','Steamboat Springs','Routt',40.449195,-106.81814),('80497','CO','Silverthorne','Summit',39.653395,-106.006194),('80498','CO','Silverthorne','Summit',39.723619,-106.148137),('80501','CO','Longmont','Boulder',40.169859,-105.107689),('80502','CO','Longmont','Boulder',40.1619,-105.1031),('80503','CO','Longmont','Boulder',40.158781,-105.176582),('80504','CO','Longmont','Boulder',40.160667,-105.022251),('80510','CO','Allenspark','Boulder',40.216104,-105.528292),('80511','CO','Estes Park','Larimer',40.339143,-105.572626),('80512','CO','Bellvue','Larimer',40.639923,-105.480833),('80513','CO','Berthoud','Larimer',40.300519,-105.086676),('80514','CO','Dacono','Weld',40.076334,-104.944663),('80515','CO','Drake','Larimer',40.40926,-105.40459),('80516','CO','Erie','Weld',40.051046,-105.027633),('80517','CO','Estes Park','Larimer',40.368539,-105.535178),('80520','CO','Firestone','Weld',40.112716,-104.93426),('80521','CO','Fort Collins','Larimer',40.586068,-105.104952),('80522','CO','Fort Collins','Larimer',40.584,-105.0804),('80523','CO','Fort Collins','Larimer',40.5731,-105.086),('80524','CO','Fort Collins','Larimer',40.609383,-105.043265),('80525','CO','Fort Collins','Larimer',40.532967,-105.047318),('80526','CO','Fort Collins','Larimer',40.536821,-105.114214),('80527','CO','Fort Collins','Larimer',40.532,-105.0731),('80528','CO','Fort Collins','Larimer',40.501878,-105.006635),('80530','CO','Frederick','Weld',40.10024,-104.932732),('80532','CO','Glen Haven','Larimer',40.475727,-105.460399),('80533','CO','Hygiene','Boulder',40.1886,-105.1802),('80534','CO','Johnstown','Weld',40.348663,-104.940626),('80535','CO','Laporte','Larimer',40.665936,-105.167486),('80536','CO','Livermore','Larimer',40.886359,-105.374804),('80537','CO','Loveland','Larimer',40.384816,-105.106919),('80538','CO','Loveland','Larimer',40.438296,-105.098467),('80539','CO','Loveland','Larimer',40.3977,-105.0744),('80540','CO','Lyons','Boulder',40.237521,-105.334602),('80541','CO','Masonville','Larimer',40.4875,-105.2102),('80542','CO','Mead','Weld',40.233769,-104.996634),('80543','CO','Milliken','Weld',40.334397,-104.850625),('80544','CO','Niwot','Boulder',40.1028,-105.1736),('80545','CO','Red Feather Lakes','Larimer',40.848645,-105.659158),('80546','CO','Severance','Weld',40.52389,-104.849172),('80547','CO','Timnath','Larimer',40.527095,-104.973326),('80549','CO','Wellington','Larimer',40.766055,-105.01457),('80550','CO','Windsor','Weld',40.480273,-104.902668),('80551','CO','Windsor','Weld',40.4836,-104.9051),('80553','CO','Fort Collins','Larimer',40.5675,-105.0453),('80601','CO','Brighton','Adams',39.973974,-104.801354),('80602','CO','Brighton','Adams',39.954201,-104.916987),('80603','CO','Brighton','Weld',39.958789,-104.767196),('80610','CO','Ault','Weld',40.61833,-104.686659),('80611','CO','Briggsdale','Weld',40.624924,-104.287276),('80612','CO','Carr','Weld',40.877476,-104.896602),('80614','CO','Eastlake','Adams',39.9238,-104.9608),('80615','CO','Eaton','Weld',40.530852,-104.718754),('80620','CO','Evans','Weld',40.377458,-104.710425),('80621','CO','Fort Lupton','Weld',40.091567,-104.801319),('80622','CO','Galeton','Weld',40.537083,-104.479737),('80623','CO','Gilcrest','Weld',40.285182,-104.776452),('80624','CO','Gill','Weld',40.480591,-104.519927),('80631','CO','Greeley','Weld',40.421855,-104.691748),('80632','CO','Greeley','Weld',40.4236,-104.6959),('80633','CO','Greeley','Weld',40.4236,-104.6959),('80634','CO','Greeley','Weld',40.407494,-104.763271),('80638','CO','Greeley','Weld',40.4233,-104.7086),('80639','CO','Greeley','Weld',40.4044,-104.6983),('80640','CO','Henderson','Adams',39.885223,-104.881922),('80642','CO','Hudson','Weld',40.051752,-104.640067),('80643','CO','Keenesburg','Weld',40.080395,-104.499303),('80644','CO','Kersey','Weld',40.372513,-104.535445),('80645','CO','La Salle','Weld',40.333855,-104.705569),('80646','CO','Lucerne','Weld',40.4737,-104.6963),('80648','CO','Nunn','Weld',40.732348,-104.762733),('80649','CO','Orchard','Morgan',40.342494,-104.165128),('80650','CO','Pierce','Weld',40.635688,-104.758553),('80651','CO','Platteville','Weld',40.235731,-104.842382),('80652','CO','Roggen','Weld',40.109348,-104.310057),('80653','CO','Weldona','Morgan',40.355254,-104.016085),('80654','CO','Wiggins','Morgan',40.187255,-104.073883),('80701','CO','Fort Morgan','Morgan',40.23698,-103.807123),('80705','CO','Log Lane Village','Morgan',40.269415,-103.828406),('80720','CO','Akron','Washington',40.111114,-103.199847),('80721','CO','Amherst','Phillips',40.684022,-102.16164),('80722','CO','Atwood','Logan',40.534605,-103.270486),('80723','CO','Brush','Morgan',40.222539,-103.614339),('80726','CO','Crook','Logan',40.88254,-102.785059),('80727','CO','Eckley','Yuma',40.097622,-102.48731),('80728','CO','Fleming','Logan',40.620912,-102.848138),('80729','CO','Grover','Weld',40.876288,-104.226608),('80731','CO','Haxtun','Phillips',40.605857,-102.598665),('80732','CO','Hereford','Weld',40.9747,-104.3047),('80733','CO','Hillrose','Morgan',40.357168,-103.474672),('80734','CO','Holyoke','Phillips',40.571336,-102.300642),('80735','CO','Idalia','Yuma',39.709821,-102.273171),('80736','CO','Iliff','Logan',40.786838,-103.048596),('80737','CO','Julesburg','Sedgwick',40.938016,-102.223888),('80740','CO','Lindon','Washington',39.682705,-103.377693),('80741','CO','Merino','Logan',40.510706,-103.42496),('80742','CO','New Raymer','Weld',40.685298,-103.835704),('80743','CO','Otis','Washington',40.200435,-102.956062),('80744','CO','Ovid','Sedgwick',40.925316,-102.386383),('80745','CO','Padroni','Logan',40.825835,-103.276797),('80746','CO','Paoli','Phillips',40.61013,-102.471691),('80747','CO','Peetz','Logan',40.956925,-103.086507),('80749','CO','Sedgwick','Sedgwick',40.894521,-102.545717),('80750','CO','Snyder','Morgan',40.37043,-103.577756),('80751','CO','Sterling','Logan',40.634703,-103.211359),('80754','CO','Stoneham','Weld',40.67661,-103.634151),('80755','CO','Vernon','Yuma',39.916594,-102.354731),('80757','CO','Woodrow','Washington',39.840062,-103.589706),('80758','CO','Wray','Yuma',40.071727,-102.209135),('80759','CO','Yuma','Yuma',40.176732,-102.685923),('80801','CO','Anton','Washington',39.732346,-103.101475),('80802','CO','Arapahoe','Cheyenne',38.849052,-102.160345),('80804','CO','Arriba','Lincoln',39.388245,-103.285305),('80805','CO','Bethune','Kit Carson',39.305514,-102.439241),('80807','CO','Burlington','Kit Carson',39.322944,-102.25083),('80808','CO','Calhan','El Paso',38.966814,-104.315371),('80809','CO','Cascade','El Paso',38.883572,-104.991577),('80810','CO','Cheyenne Wells','Cheyenne',38.820715,-102.379328),('80812','CO','Cope','Washington',39.648315,-102.877993),('80813','CO','Cripple Creek','Teller',38.755857,-105.149832),('80814','CO','Divide','Teller',38.936788,-105.185123),('80815','CO','Flagler','Kit Carson',39.389191,-103.061847),('80816','CO','Florissant','Teller',38.891446,-105.308899),('80817','CO','Fountain','El Paso',38.670084,-104.695414),('80818','CO','Genoa','Lincoln',39.385913,-103.480409),('80819','CO','Green Mountain Falls','El Paso',38.947607,-105.022804),('80820','CO','Guffey','Park',38.788559,-105.592949),('80821','CO','Hugo','Lincoln',38.997757,-103.447032),('80822','CO','Joes','Yuma',39.655219,-102.686232),('80823','CO','Karval','Lincoln',38.719615,-103.459965),('80824','CO','Kirk','Yuma',39.632401,-102.535294),('80825','CO','Kit Carson','Cheyenne',38.764112,-102.828429),('80826','CO','Limon','Lincoln',39.3649,-103.6361),('80827','CO','Lake George','Park',39.037131,-105.436947),('80828','CO','Limon','Lincoln',39.281634,-103.691541),('80829','CO','Manitou Springs','El Paso',38.850982,-104.915421),('80830','CO','Matheson','Elbert',39.128261,-103.884141),('80831','CO','Peyton','El Paso',38.968756,-104.554945),('80832','CO','Ramah','El Paso',39.02776,-104.043787),('80833','CO','Rush','El Paso',38.763233,-103.96509),('80834','CO','Seibert','Kit Carson',39.315792,-102.892421),('80835','CO','Simla','Elbert',39.166807,-104.092195),('80836','CO','Stratton','Kit Carson',39.301848,-102.585414),('80840','CO','U S A F Academy','El Paso',38.991798,-104.846759),('80841','CO','U S A F Academy','El Paso',39.0108,-104.87),('80860','CO','Victor','Teller',38.716258,-105.126832),('80861','CO','Vona','Kit Carson',39.367174,-102.75234),('80862','CO','Wild Horse','Cheyenne',38.83656,-103.081107),('80863','CO','Woodland Park','Teller',39.003641,-105.07253),('80864','CO','Yoder','El Paso',38.723581,-104.172923),('80866','CO','Woodland Park','Teller',39.085706,-105.236599),('80901','CO','Colorado Springs','El Paso',38.8335,-104.8206),('80902','CO','Colorado Springs','El Paso',38.737657,-104.795889),('80903','CO','Colorado Springs','El Paso',38.833104,-104.815484),('80904','CO','Colorado Springs','El Paso',38.853709,-104.86274),('80905','CO','Colorado Springs','El Paso',38.817763,-104.832543),('80906','CO','Colorado Springs','El Paso',38.785666,-104.819583),('80907','CO','Colorado Springs','El Paso',38.876805,-104.823523),('80908','CO','Colorado Springs','El Paso',39.024683,-104.695846),('80909','CO','Colorado Springs','El Paso',38.850919,-104.778724),('80910','CO','Colorado Springs','El Paso',38.812066,-104.77458),('80911','CO','Colorado Springs','El Paso',38.749834,-104.726054),('80912','CO','Colorado Springs','El Paso',39.0475,-104.6901),('80913','CO','Colorado Springs','El Paso',38.740924,-104.783786),('80914','CO','Colorado Springs','El Paso',38.825093,-104.704171),('80915','CO','Colorado Springs','El Paso',38.85408,-104.715542),('80916','CO','Colorado Springs','El Paso',38.805843,-104.736485),('80917','CO','Colorado Springs','El Paso',38.887267,-104.741829),('80918','CO','Colorado Springs','El Paso',38.912683,-104.776596),('80919','CO','Colorado Springs','El Paso',38.9236,-104.851724),('80920','CO','Colorado Springs','El Paso',38.95629,-104.770617),('80921','CO','Colorado Springs','El Paso',39.027691,-104.831199),('80922','CO','Colorado Springs','El Paso',38.891581,-104.702431),('80923','CO','Colorado Springs','El Paso',38.922892,-104.71599),('80924','CO','Colorado Springs','El Paso',38.95966,-104.72226),('80925','CO','Colorado Springs','El Paso',38.741776,-104.652258),('80926','CO','Colorado Springs','El Paso',38.668505,-104.863731),('80927','CO','Colorado Springs','El Paso',38.930069,-104.671683),('80928','CO','Colorado Springs','El Paso',38.668963,-104.468756),('80929','CO','Colorado Springs','El Paso',38.829125,-104.64735),('80930','CO','Colorado Springs','El Paso',38.823416,-104.511699),('80931','CO','Colorado Springs','El Paso',38.7513,-104.7322),('80932','CO','Colorado Springs','El Paso',38.8487,-104.7788),('80933','CO','Colorado Springs','El Paso',38.8729,-104.8105),('80934','CO','Colorado Springs','El Paso',38.8459,-104.8632),('80935','CO','Colorado Springs','El Paso',38.8139,-104.7586),('80936','CO','Colorado Springs','El Paso',38.9037,-104.754),('80937','CO','Colorado Springs','El Paso',38.808,-104.8185),('80938','CO','Colorado Springs','El Paso',38.905667,-104.679397),('80939','CO','Colorado Springs','Mohave',38.7986,-104.8362),('80940','CO','Colorado Springs','El Paso',38.8864,-104.6716),('80941','CO','Colorado Springs','El Paso',38.9594,-104.7536),('80942','CO','Colorado Springs','El Paso',38.8338,-104.8208),('80943','CO','Colorado Springs','El Paso',38.8338,-104.8208),('80944','CO','Colorado Springs','El Paso',38.8338,-104.8208),('80945','CO','Colorado Springs','El Paso',38.8335,-104.8206),('80946','CO','Colorado Springs','El Paso',38.8466,-104.8238),('80947','CO','Colorado Springs','El Paso',38.8338,-104.8208),('80949','CO','Colorado Springs','El Paso',38.9043,-104.86),('80950','CO','Colorado Springs','El Paso',38.8487,-104.7788),('80951','CO','Colorado Springs','El Paso',38.868049,-104.670952),('80960','CO','Colorado Springs','El Paso',38.808,-104.8185),('80962','CO','Colorado Springs','El Paso',38.9043,-104.86),('80970','CO','Colorado Springs','El Paso',38.8338,-104.8208),('80977','CO','Colorado Springs','El Paso',38.8139,-104.7586),('80995','CO','Colorado Springs','El Paso',38.8139,-104.7586),('80997','CO','Colorado Springs','El Paso',38.9037,-104.754),('81001','CO','Pueblo','Pueblo',38.280958,-104.576269),('81002','CO','Pueblo','Pueblo',38.2544,-104.6086),('81003','CO','Pueblo','Pueblo',38.280993,-104.624538),('81004','CO','Pueblo','Pueblo',38.220429,-104.640107),('81005','CO','Pueblo','Pueblo',38.234791,-104.687529),('81006','CO','Pueblo','Pueblo',38.241724,-104.535548),('81007','CO','Pueblo','Pueblo',38.330234,-104.745059),('81008','CO','Pueblo','Pueblo',38.377835,-104.61979),('81009','CO','Pueblo','Pueblo',38.2544,-104.6086),('81010','CO','Pueblo','Pueblo',38.2544,-104.6086),('81011','CO','Pueblo','Pueblo',38.2544,-104.6086),('81012','CO','Pueblo','Pueblo',38.2544,-104.6086),('81019','CO','Colorado City','Pueblo',37.944052,-104.843761),('81020','CO','Aguilar','Las Animas',37.412581,-104.650284),('81021','CO','Arlington','Kiowa',38.419198,-103.376492),('81022','CO','Avondale','Pueblo',38.106475,-104.428732),('81023','CO','Beulah','Pueblo',38.068795,-104.957717),('81024','CO','Boncarbo','Las Animas',37.240421,-104.741561),('81025','CO','Boone','Pueblo',38.286542,-104.28848),('81027','CO','Branson','Las Animas',37.142568,-103.867339),('81029','CO','Campo','Baca',37.112529,-102.533921),('81030','CO','Cheraw','Otero',38.106282,-103.512353),('81033','CO','Crowley','Crowley',38.193565,-103.857939),('81034','CO','Crowley','Crowley',38.347,-103.7858),('81036','CO','Eads','Kiowa',38.447522,-102.721296),('81038','CO','Fort Lyon','Bent',38.081155,-103.139963),('81039','CO','Fowler','Otero',38.026141,-104.031512),('81040','CO','Gardner','Huerfano',37.783849,-105.228065),('81041','CO','Granada','Prowers',37.967331,-102.326573),('81043','CO','Hartman','Prowers',38.122196,-102.220873),('81044','CO','Hasty','Bent',38.061197,-102.933897),('81045','CO','Haswell','Kiowa',38.447793,-103.181382),('81046','CO','Hoehne','Las Animas',37.2811,-104.3805),('81047','CO','Holly','Prowers',38.066114,-102.196651),('81049','CO','Kim','Las Animas',37.278002,-103.354867),('81050','CO','La Junta','Otero',37.998056,-103.533569),('81052','CO','Lamar','Prowers',38.070694,-102.617634),('81054','CO','Las Animas','Bent',38.051856,-103.205692),('81055','CO','La Veta','Huerfano',37.481181,-105.059508),('81057','CO','Mc Clave','Bent',38.12181,-102.879317),('81058','CO','Manzanola','Otero',38.105582,-103.875826),('81059','CO','Model','Las Animas',37.452849,-104.071454),('81062','CO','Olney Springs','Crowley',38.192281,-103.923566),('81063','CO','Ordway','Crowley',38.2999,-103.7699),('81064','CO','Pritchett','Baca',37.264521,-102.923831),('81067','CO','Rocky Ford','Otero',38.041111,-103.723388),('81069','CO','Rye','Pueblo',37.914723,-104.905212),('81071','CO','Sheridan Lake','Kiowa',38.4646,-102.297284),('81073','CO','Springfield','Baca',37.407996,-102.638532),('81075','CO','Stonington','Baca',37.04488,35.313374),('81076','CO','Sugar City','Crowley',38.248969,-103.647195),('81077','CO','Swink','Otero',38.01527,-103.628366),('81081','CO','Trinchera','Las Animas',37.064149,-104.150798),('81082','CO','Trinidad','Las Animas',37.181606,-104.518466),('81084','CO','Two Buttes','Baca',37.585812,-102.428252),('81087','CO','Vilas','Baca',37.374242,-102.417881),('81089','CO','Walsenburg','Huerfano',37.619789,-104.803722),('81090','CO','Walsh','Baca',37.35336,-102.267947),('81091','CO','Weston','Las Animas',37.173131,-104.93222),('81092','CO','Wiley','Prowers',38.178196,-102.736649),('81101','CO','Alamosa','Alamosa',37.476233,-105.819179),('81102','CO','Alamosa','Alamosa',37.471,-105.8786),('81120','CO','Antonito','Conejos',37.126883,-106.195985),('81121','CO','Arboles','Archuleta',37.036635,-107.42045),('81122','CO','Bayfield','La Plata',37.268167,-107.559549),('81123','CO','Blanca','Costilla',37.397663,-105.573157),('81124','CO','Capulin','Conejos',37.295648,-106.133996),('81125','CO','Center','Saguache',37.770193,-106.08954),('81126','CO','Chama','Costilla',37.172119,-105.349556),('81127','CO','Chimney Rock','Archuleta',37.218131,-107.344525),('81128','CO','Chromo','Archuleta',37.060075,-106.692173),('81129','CO','Conejos','Conejos',37.095242,-106.014391),('81130','CO','Creede','Mineral',37.748646,-107.016797),('81131','CO','Crestone','Saguache',37.93552,-105.674089),('81132','CO','Del Norte','Rio Grande',37.712056,-106.379849),('81133','CO','Fort Garland','Costilla',37.392957,-105.345276),('81134','CO','Garcia','Costilla',37.0041,-105.5366),('81135','CO','Homelake','Rio Grande',37.5799,-106.1475),('81136','CO','Hooper','Alamosa',37.742375,-105.881042),('81137','CO','Ignacio','La Plata',37.072233,-107.609595),('81138','CO','Jaroso','Costilla',37.037704,-105.627556),('81140','CO','La Jara','Conejos',37.287439,-106.029119),('81141','CO','Manassa','Conejos',37.163172,-105.917803),('81143','CO','Moffat','Saguache',38.08501,-105.900471),('81144','CO','Monte Vista','Rio Grande',37.572148,-106.146421),('81146','CO','Mosca','Alamosa',37.645917,-105.748671),('81147','CO','Pagosa Springs','Archuleta',37.25266,-107.092109),('81148','CO','Romeo','Conejos',37.17266,-105.984601),('81149','CO','Saguache','Saguache',38.094678,-106.314633),('81151','CO','Sanford','Conejos',37.201657,-105.680782),('81152','CO','San Luis','Costilla',37.105891,-105.539033),('81153','CO','San Pablo','Costilla',37.127132,-105.3675),('81154','CO','South Fork','Rio Grande',37.669107,-106.631934),('81155','CO','Villa Grove','Saguache',38.285501,-106.060336),('81157','CO','Pagosa Springs','Archuleta',37.2694,-107.0091),('81201','CO','Salida','Chaffee',38.543803,-106.041043),('81210','CO','Almont','Gunnison',38.793056,-106.62966),('81211','CO','Buena Vista','Chaffee',38.872528,-106.162785),('81212','CO','Canon City','Fremont',38.469691,-105.257085),('81215','CO','Canon City','Fremont',38.536,-105.306),('81220','CO','Cimarron','Gunnison',38.364471,-107.498939),('81221','CO','Coal Creek','Fremont',38.36142,-105.146376),('81222','CO','Coaldale','Fremont',38.360623,-105.764377),('81223','CO','Cotopaxi','Fremont',38.381042,-105.562262),('81224','CO','Crested Butte','Gunnison',38.857982,-106.959355),('81225','CO','Crested Butte','Gunnison',38.919381,-106.965349),('81226','CO','Florence','Fremont',38.380763,-105.12172),('81227','CO','Monarch','Chaffee',38.5331,-105.9911),('81228','CO','Granite','Chaffee',39.0619,-106.2699),('81230','CO','Gunnison','Gunnison',38.483789,-106.972296),('81231','CO','Gunnison','Gunnison',38.550014,-106.919723),('81232','CO','Hillside','Fremont',38.279589,-105.60896),('81233','CO','Howard','Fremont',38.432395,-105.830391),('81235','CO','Lake City','Hinsdale',38.008522,-107.281915),('81236','CO','Nathrop','Chaffee',38.723825,-106.175069),('81237','CO','Ohio City','Gunnison',38.598806,-106.603134),('81239','CO','Parlin','Gunnison',38.510902,-106.681308),('81240','CO','Penrose','Fremont',38.448418,-105.018731),('81241','CO','Pitkin','Gunnison',38.610972,-106.514535),('81242','CO','Poncha Springs','Chaffee',38.509259,-106.076455),('81243','CO','Powderhorn','Gunnison',38.29687,-107.222299),('81244','CO','Rockvale','Fremont',38.365346,-105.166771),('81247','CO','Gunnison','Gunnison',38.5387,-106.9274),('81248','CO','Sargents','Saguache',38.47214,-106.409342),('81251','CO','Twin Lakes','Lake',39.094661,-106.350766),('81252','CO','Westcliffe','Custer',38.13243,-105.439423),('81253','CO','Wetmore','Custer',38.190728,-105.102736),('81290','CO','Florence','Fremont',38.3287,-105.1545),('81301','CO','Durango','La Plata',37.337285,-107.845032),('81302','CO','Durango','La Plata',37.3464,-107.8728),('81303','CO','Durango','La Plata',37.159033,-107.860938),('81320','CO','Cahone','Dolores',37.738779,-108.763921),('81321','CO','Cortez','Montezuma',37.346641,-108.615862),('81323','CO','Dolores','Montezuma',37.570258,-108.408413),('81324','CO','Dove Creek','Dolores',37.672052,-109.027396),('81325','CO','Egnar','San Miguel',37.945347,-108.786398),('81326','CO','Hesperus','La Plata',37.173436,-108.130307),('81327','CO','Lewis','Montezuma',37.517036,-108.656297),('81328','CO','Mancos','Montezuma',37.368068,-108.332026),('81329','CO','Marvel','La Plata',37.1125,-108.1261),('81330','CO','Mesa Verde National Park','Montezuma',37.224317,-108.470462),('81331','CO','Pleasant View','Montezuma',37.58086,-108.783015),('81332','CO','Rico','Dolores',37.69881,-108.01689),('81334','CO','Towaoc','Montezuma',37.188436,-108.687433),('81335','CO','Yellow Jacket','Montezuma',37.540236,-108.729348),('81401','CO','Montrose','Montrose',38.479749,-107.837888),('81402','CO','Montrose','Montrose',38.3841,-107.8931),('81403','CO','Montrose','Montrose',38.384512,-107.903044),('81410','CO','Austin','Delta',38.793134,-107.97241),('81411','CO','Bedrock','Montrose',38.316219,-108.955288),('81413','CO','Cedaredge','Delta',38.933084,-107.932695),('81414','CO','Cory','Delta',38.788,-107.9866),('81415','CO','Crawford','Delta',38.626842,-107.587669),('81416','CO','Delta','Delta',38.73383,-108.072406),('81418','CO','Eckert','Delta',38.84826,-107.962565),('81419','CO','Hotchkiss','Delta',38.81501,-107.742463),('81420','CO','Lazear','Delta',38.78,-107.7811),('81422','CO','Naturita','Montrose',38.292428,-108.65895),('81423','CO','Norwood','San Miguel',38.055353,-108.336129),('81424','CO','Nucla','Montrose',38.256945,-108.500762),('81425','CO','Olathe','Montrose',38.599244,-108.054443),('81426','CO','Ophir','San Miguel',37.858241,-107.834262),('81427','CO','Ouray','Ouray',38.003356,-107.663334),('81428','CO','Paonia','Delta',38.880938,-107.591427),('81429','CO','Paradox','Montrose',38.342536,-108.91486),('81430','CO','Placerville','San Miguel',38.015222,-108.051983),('81431','CO','Redvale','Montrose',38.111346,-108.544271),('81432','CO','Ridgway','Ouray',38.149952,-107.75922),('81433','CO','Silverton','San Juan',37.823843,-107.635436),('81434','CO','Somerset','Gunnison',38.938631,-107.370595),('81435','CO','Telluride','San Miguel',37.926918,-107.85302),('81501','CO','Grand Junction','Mesa',39.072868,-108.551563),('81502','CO','Grand Junction','Mesa',39.0687,-108.5656),('81503','CO','Grand Junction','Mesa',39.038285,-108.522084),('81504','CO','Grand Junction','Mesa',39.081279,-108.488823),('81505','CO','Grand Junction','Mesa',39.114113,-108.606903),('81506','CO','Grand Junction','Mesa',39.10572,-108.543738),('81507','CO','Grand Junction','Mesa',39.078721,-108.639319),('81520','CO','Clifton','Mesa',39.089473,-108.437085),('81521','CO','Fruita','Mesa',39.158007,-108.727253),('81522','CO','Gateway','Mesa',38.715101,-109.010875),('81523','CO','Glade Park','Mesa',38.959189,-108.851157),('81524','CO','Loma','Mesa',39.229849,-108.810236),('81525','CO','Mack','Mesa',39.271036,-108.91774),('81526','CO','Palisade','Mesa',39.107928,-108.356186),('81527','CO','Whitewater','Mesa',38.806426,-108.510789),('81601','CO','Glenwood Springs','Garfield',39.535052,-107.320975),('81602','CO','Glenwood Springs','Garfield',39.5454,-107.3258),('81610','CO','Dinosaur','Moffat',40.284839,-108.870176),('81611','CO','Aspen','Pitkin',39.19386,-106.831439),('81612','CO','Aspen','Pitkin',39.1929,-106.8188),('81615','CO','Snowmass Village','Pitkin',39.216866,-106.943974),('81620','CO','Avon','Eagle',39.626483,-106.513082),('81621','CO','Basalt','Eagle',39.381054,-106.919097),('81623','CO','Carbondale','Garfield',39.358814,-107.184514),('81624','CO','Collbran','Mesa',39.23841,-107.868163),('81625','CO','Craig','Moffat',40.582646,-107.599376),('81626','CO','Craig','Moffat',40.5778,-107.6654),('81630','CO','De Beque','Mesa',39.450648,-108.400193),('81631','CO','Eagle','Eagle',39.623835,-106.775878),('81632','CO','Edwards','Eagle',39.638901,-106.609725),('81633','CO','Dinosaur','Moffat',40.3352,-108.3706),('81635','CO','Parachute','Garfield',39.460445,-108.05139),('81636','CO','Battlement Mesa','Garfield',39.4443,-108.0221),('81637','CO','Gypsum','Eagle',39.662305,-106.996828),('81638','CO','Hamilton','Moffat',40.323264,-107.565443),('81639','CO','Hayden','Routt',40.483182,-107.254396),('81640','CO','Maybell','Moffat',40.701641,-108.441248),('81641','CO','Meeker','Rio Blanco',40.057656,-107.844714),('81642','CO','Meredith','Pitkin',39.3319,-106.657333),('81643','CO','Mesa','Mesa',39.108178,-108.147132),('81645','CO','Minturn','Eagle',39.45505,-106.382378),('81646','CO','Molina','Mesa',39.097235,-108.002603),('81647','CO','New Castle','Garfield',39.566223,-107.544557),('81648','CO','Rangely','Rio Blanco',40.063435,-108.768164),('81649','CO','Red Cliff','Eagle',39.499438,-106.338722),('81650','CO','Rifle','Garfield',39.608822,-107.898982),('81652','CO','Silt','Garfield',39.520771,-107.658275),('81653','CO','Slater','Moffat',40.973949,-107.296383),('81654','CO','Snowmass','Pitkin',39.270168,-106.969218),('81655','CO','Wolcott','Eagle',39.718941,-106.546889),('81656','CO','Woody Creek','Pitkin',39.281707,-106.894444),('81657','CO','Vail','Eagle',39.638573,-106.357621),('81658','CO','Vail','Eagle',39.5341,-106.3723),('82001','WY','Cheyenne','Laramie',41.141471,-104.802181),('82002','WY','Cheyenne','Laramie',41.1371,-104.818),('82003','WY','Cheyenne','Laramie',41.1371,-104.818),('82005','WY','Ft Warren Afb','Laramie',41.151865,-104.861825),('82006','WY','Cheyenne','Laramie',41.4052,-104.8606),('82007','WY','Cheyenne','Laramie',41.099807,-104.802906),('82008','WY','Cheyenne','Laramie',41.1371,-104.818),('82009','WY','Cheyenne','Laramie',41.276473,-104.876158),('82010','WY','Cheyenne','Laramie',41.1371,-104.818),('82050','WY','Albin','Laramie',41.440226,-104.160286),('82051','WY','Bosler','Albany',41.605652,-105.62704),('82052','WY','Buford','Albany',41.105595,-105.354901),('82053','WY','Burns','Laramie',41.200976,-104.369918),('82054','WY','Carpenter','Laramie',41.050111,-104.351576),('82055','WY','Centennial','Albany',41.316573,-106.145583),('82058','WY','Garrett','Albany',42.038885,-105.581438),('82059','WY','Granite Canyon','Laramie',41.051097,-105.192164),('82060','WY','Hillsdale','Laramie',41.19475,-104.502826),('82061','WY','Horse Creek','Laramie',41.415438,-105.165528),('82063','WY','Jelm','Albany',40.927361,-106.001708),('82070','WY','Laramie','Albany',41.231947,-105.706763),('82071','WY','Laramie','Albany',41.3133,-105.5782),('82072','WY','Laramie','Albany',41.338448,-105.584571),('82073','WY','Laramie','Albany',41.356764,-105.587542),('82081','WY','Meriden','Laramie',41.552531,-104.391183),('82082','WY','Pine Bluffs','Laramie',41.224631,-104.094959),('82083','WY','Rock River','Albany',41.615598,-106.109476),('82084','WY','Tie Siding','Albany',41.024827,-105.461882),('82190','WY','Yellowstone National Park','Park',44.494995,-110.628476),('82201','WY','Wheatland','Platte',42.052964,-105.030874),('82210','WY','Chugwater','Platte',41.747463,-104.842993),('82212','WY','Fort Laramie','Goshen',42.282908,-104.542111),('82213','WY','Glendo','Platte',42.494896,-104.970531),('82214','WY','Guernsey','Platte',42.268198,-104.750751),('82215','WY','Hartville','Platte',42.379478,-104.758993),('82217','WY','Hawk Springs','Goshen',41.76963,-104.225391),('82218','WY','Huntley','Goshen',41.865935,-104.114518),('82219','WY','Jay Em','Goshen',42.48975,-104.531291),('82221','WY','Lagrange','Goshen',41.641711,-104.235727),('82222','WY','Lance Creek','Niobrara',43.11639,-104.666811),('82223','WY','Lingle','Goshen',42.127557,-104.364208),('82224','WY','Lost Springs','Niobrara',43.027385,-104.808849),('82225','WY','Lusk','Niobrara',42.904291,-104.377224),('82227','WY','Manville','Niobrara',42.778034,-104.739496),('82229','WY','Shawnee','Converse',42.814489,-104.947696),('82240','WY','Torrington','Goshen',42.088016,-104.186017),('82242','WY','Van Tassell','Niobrara',42.664473,-104.103769),('82243','WY','Veteran','Goshen',41.98036,-104.391741),('82244','WY','Yoder','Goshen',41.885857,-104.353516),('82301','WY','Rawlins','Carbon',41.823143,-107.309527),('82310','WY','Jeffrey City','Fremont',42.444748,-107.764605),('82321','WY','Baggs','Carbon',41.049804,-107.660374),('82322','WY','Bairoil','Sweetwater',42.237363,-107.562379),('82323','WY','Dixon','Carbon',41.033188,-107.514808),('82324','WY','Elk Mountain','Carbon',41.659034,-106.452654),('82325','WY','Encampment','Carbon',41.193619,-106.830858),('82327','WY','Hanna','Carbon',42.12854,-106.714675),('82329','WY','Medicine Bow','Carbon',42.032764,-106.142209),('82331','WY','Saratoga','Carbon',41.430147,-106.801625),('82332','WY','Savery','Carbon',41.057681,-107.302298),('82334','WY','Sinclair','Carbon',41.900041,-107.020967),('82335','WY','Walcott','Carbon',41.804594,-106.780635),('82336','WY','Wamsutter','Sweetwater',41.710036,-108.112725),('82401','WY','Worland','Washakie',44.010756,-108.057979),('82410','WY','Basin','Big Horn',44.38146,-108.060251),('82411','WY','Burlington','Big Horn',44.433409,-108.450117),('82412','WY','Byron','Big Horn',44.794149,-108.535932),('82414','WY','Cody','Park',44.508807,-109.169103),('82420','WY','Cowley','Big Horn',44.905008,-108.444709),('82421','WY','Deaver','Big Horn',44.902402,-108.601858),('82422','WY','Emblem','Big Horn',44.493574,-108.398625),('82423','WY','Frannie','Big Horn',44.977711,-108.608976),('82426','WY','Greybull','Big Horn',44.518194,-107.906197),('82428','WY','Hyattville','Big Horn',44.300367,-107.548564),('82430','WY','Kirby','Hot Springs',43.806207,-108.182612),('82431','WY','Lovell','Big Horn',44.852653,-108.27943),('82432','WY','Manderson','Big Horn',44.240515,-107.910883),('82433','WY','Meeteetse','Park',44.138456,-108.930862),('82434','WY','Otto','Big Horn',44.382801,-108.295966),('82435','WY','Powell','Park',44.812387,-108.825992),('82440','WY','Ralston','Park',44.717433,-108.865875),('82441','WY','Shell','Big Horn',44.637847,-107.772046),('82442','WY','Ten Sleep','Washakie',43.96866,-107.33713),('82443','WY','Thermopolis','Hot Springs',43.704227,-108.345909),('82450','WY','Wapiti','Park',44.469537,-109.439287),('82501','WY','Riverton','Fremont',43.060352,-108.38775),('82510','WY','Arapahoe','Fremont',42.981146,-108.583644),('82512','WY','Crowheart','Fremont',43.355511,-109.22453),('82513','WY','Dubois','Fremont',43.554366,-109.686115),('82514','WY','Fort Washakie','Fremont',43.053171,-108.931828),('82515','WY','Hudson','Fremont',42.910416,-108.570684),('82516','WY','Kinnear','Fremont',43.177687,-108.838914),('82520','WY','Lander','Fremont',42.721697,-108.64898),('82523','WY','Pavillion','Fremont',43.357323,-108.757216),('82524','WY','Saint Stephens','Fremont',42.9838,-108.4158),('82601','WY','Casper','Natrona',42.862962,-106.323166),('82602','WY','Casper','Natrona',43.1414,-106.36),('82604','WY','Casper','Natrona',42.826421,-106.506061),('82605','WY','Casper','Natrona',42.8666,-106.3125),('82609','WY','Casper','Natrona',42.839188,-106.260396),('82615','WY','Shirley Basin','Carbon',42.0299,-106.5458),('82620','WY','Alcova','Natrona',42.482209,-107.031626),('82630','WY','Arminto','Natrona',42.91,-106.9369),('82633','WY','Douglas','Converse',42.831988,-105.429755),('82635','WY','Edgerton','Natrona',43.404978,-106.237221),('82636','WY','Evansville','Natrona',42.879065,-106.210168),('82637','WY','Glenrock','Converse',42.821726,-105.888486),('82638','WY','Hiland','Natrona',43.1152,-107.3483),('82639','WY','Kaycee','Johnson',43.704976,-106.551933),('82640','WY','Linch','Johnson',43.55742,-106.174393),('82642','WY','Lysite','Fremont',43.290694,-107.620731),('82643','WY','Midwest','Natrona',43.412014,-106.277841),('82644','WY','Mills','Natrona',42.843626,-106.371765),('82646','WY','Natrona','Natrona',43.1414,-106.36),('82648','WY','Powder River','Natrona',43.190282,-107.112925),('82649','WY','Shoshoni','Fremont',43.251166,-108.19313),('82701','WY','Newcastle','Weston',43.749309,-104.379358),('82710','WY','Aladdin','Crook',44.69258,-104.307472),('82711','WY','Alva','Crook',44.714752,-104.459522),('82712','WY','Beulah','Crook',44.494013,-104.125319),('82714','WY','Devils Tower','Crook',44.561401,-104.699198),('82715','WY','Four Corners','Weston',44.1384,-104.1358),('82716','WY','Gillette','Campbell',44.339233,-105.55011),('82717','WY','Gillette','Campbell',44.374954,-105.386247),('82718','WY','Gillette','Campbell',44.017751,-105.542254),('82720','WY','Hulett','Crook',44.777216,-104.675727),('82721','WY','Moorcroft','Crook',44.455642,-104.898384),('82723','WY','Osage','Weston',43.977398,-104.441075),('82725','WY','Recluse','Campbell',44.854759,-105.723677),('82727','WY','Rozet','Campbell',44.29313,-105.198645),('82729','WY','Sundance','Crook',44.3945,-104.379999),('82730','WY','Upton','Weston',44.054461,-104.644304),('82731','WY','Weston','Campbell',44.812821,-105.266954),('82732','WY','Wright','Campbell',43.734435,-105.552395),('82801','WY','Sheridan','Sheridan',44.809683,-106.949822),('82831','WY','Arvada','Sheridan',44.621542,-106.072176),('82832','WY','Banner','Sheridan',44.597599,-106.851835),('82833','WY','Big Horn','Sheridan',44.615994,-107.091489),('82834','WY','Buffalo','Johnson',44.270151,-106.615503),('82835','WY','Clearmont','Sheridan',44.713596,-106.377891),('82836','WY','Dayton','Sheridan',44.793125,-107.442524),('82837','WY','Leiter','Sheridan',44.741859,-106.252456),('82838','WY','Parkman','Sheridan',44.970004,-107.458714),('82839','WY','Ranchester','Sheridan',44.916049,-107.147568),('82840','WY','Saddlestring','Johnson',44.3448,-106.6974),('82842','WY','Story','Sheridan',44.573802,-106.903167),('82844','WY','Wolf','Sheridan',44.786231,-107.223549),('82845','WY','Wyarno','Sheridan',44.744897,-106.675517),('82901','WY','Rock Springs','Sweetwater',41.575851,-109.203923),('82902','WY','Rock Springs','Sweetwater',41.5875,-109.2022),('82922','WY','Bondurant','Sublette',43.159452,-110.358669),('82923','WY','Boulder','Sublette',42.671985,-109.549318),('82925','WY','Cora','Sublette',43.202668,-109.980974),('82929','WY','Little America','Sweetwater',41.546324,-109.860493),('82930','WY','Evanston','Uinta',41.051901,-110.746911),('82931','WY','Evanston','Uinta',41.2683,-110.9625),('82932','WY','Farson','Sweetwater',42.205267,-109.343095),('82933','WY','Fort Bridger','Uinta',41.301255,-110.43243),('82934','WY','Granger','Sweetwater',41.600061,-109.98287),('82935','WY','Green River','Sweetwater',41.573413,-109.538743),('82936','WY','Lonetree','Uinta',41.055041,-110.178734),('82937','WY','Lyman','Uinta',41.349957,-110.29999),('82938','WY','Mc Kinnon','Sweetwater',41.066009,-109.831227),('82939','WY','Mountain View','Uinta',41.246306,-110.337929),('82941','WY','Pinedale','Sublette',42.89331,-109.852782),('82942','WY','Point Of Rocks','Sweetwater',41.69536,-108.81422),('82943','WY','Reliance','Sweetwater',41.690962,-109.205554),('82944','WY','Robertson','Uinta',41.100762,-110.529624),('82945','WY','Superior','Sweetwater',41.770024,-108.986688),('83001','WY','Jackson','Teton',43.473116,-110.688608),('83002','WY','Jackson','Teton',43.48,-110.7616),('83011','WY','Kelly','Teton',43.619886,-110.475467),('83012','WY','Moose','Teton',43.72561,-110.675482),('83013','WY','Moran','Teton',43.885204,-110.474373),('83014','WY','Wilson','Teton',43.490873,-110.865005),('83025','WY','Teton Village','Teton',43.59596,-110.80629),('83101','WY','Kemmerer','Lincoln',41.871317,-110.5155),('83110','WY','Afton','Lincoln',42.719969,-110.937122),('83111','WY','Auburn','Lincoln',42.734102,-111.085801),('83112','WY','Bedford','Lincoln',42.874872,-110.849069),('83113','WY','Big Piney','Sublette',42.516657,-110.214255),('83114','WY','Cokeville','Lincoln',42.106755,-110.954519),('83115','WY','Daniel','Sublette',42.921328,-110.205913),('83116','WY','Diamondville','Lincoln',41.773365,-110.53738),('83118','WY','Etna','Lincoln',43.057358,-111.009685),('83119','WY','Fairview','Lincoln',42.675864,-110.987192),('83120','WY','Freedom','Lincoln',43.000522,-111.127244),('83121','WY','Frontier','Lincoln',41.814858,-110.534755),('83122','WY','Grover','Lincoln',42.808263,-110.943461),('83123','WY','La Barge','Lincoln',42.254537,-110.234205),('83124','WY','Opal','Lincoln',41.759613,-110.258549),('83126','WY','Smoot','Lincoln',42.592897,-110.901929),('83127','WY','Thayne','Lincoln',42.944452,-110.972971),('83128','WY','Alpine','Lincoln',43.145691,-110.981156),('83201','ID','Pocatello','Bannock',42.883251,-112.43729),('83202','ID','Pocatello','Bannock',42.957827,-112.451344),('83203','ID','Fort Hall','Bingham',43.035339,-112.475007),('83204','ID','Pocatello','Bannock',42.844577,-112.506121),('83205','ID','Pocatello','Bannock',42.8683,-112.4422),('83206','ID','Pocatello','Bannock',42.8683,-112.4422),('83209','ID','Pocatello','Bannock',42.863139,-112.431185),('83210','ID','Aberdeen','Bingham',42.970512,-112.833588),('83211','ID','American Falls','Power',42.747595,-112.923681),('83212','ID','Arbon','Power',42.560762,-112.51568),('83213','ID','Arco','Butte',43.620858,-113.299517),('83214','ID','Arimo','Bannock',42.556617,-112.249504),('83215','ID','Atomic City','Bingham',43.442694,-112.81312),('83217','ID','Bancroft','Caribou',42.757845,-111.901983),('83218','ID','Basalt','Bingham',43.316053,-112.166098),('83220','ID','Bern','Bear Lake',42.352168,-111.37663),('83221','ID','Blackfoot','Bingham',43.232924,-112.410288),('83223','ID','Bloomington','Bear Lake',42.19099,-111.402756),('83226','ID','Challis','Custer',44.633573,-114.273583),('83227','ID','Clayton','Custer',44.250285,-114.4765),('83228','ID','Clifton','Franklin',42.199736,-112.019387),('83229','ID','Cobalt','Lemhi',45.093,-114.2308),('83230','ID','Conda','Caribou',42.7295,-111.5258),('83232','ID','Dayton','Franklin',42.134299,-111.976045),('83233','ID','Dingle','Bear Lake',42.183781,-111.237589),('83234','ID','Downey','Bannock',42.430643,-112.121516),('83235','ID','Ellis','Custer',44.640748,-113.922538),('83236','ID','Firth','Bingham',43.281787,-111.989692),('83237','ID','Franklin','Franklin',42.024342,-111.792146),('83238','ID','Geneva','Bear Lake',42.321599,-111.090662),('83239','ID','Georgetown','Bear Lake',42.487499,-111.348772),('83241','ID','Grace','Caribou',42.540478,-111.750548),('83243','ID','Holbrook','Oneida',42.165796,-112.658303),('83244','ID','Howe','Butte',43.899052,-113.10026),('83245','ID','Inkom','Bannock',42.79751,-112.231426),('83246','ID','Lava Hot Springs','Bannock',42.611948,-112.020473),('83250','ID','Mccammon','Bannock',42.660424,-112.202127),('83251','ID','Mackay','Custer',43.956382,-113.80027),('83252','ID','Malad City','Oneida',42.183693,-112.35507),('83253','ID','May','Lemhi',44.446833,-113.74472),('83254','ID','Montpelier','Bear Lake',42.321698,-111.285483),('83255','ID','Moore','Butte',43.763351,-113.465929),('83256','ID','Moreland','Bingham',43.2227,-112.4416),('83261','ID','Paris','Bear Lake',42.222018,-111.410757),('83262','ID','Pingree','Bingham',43.131882,-112.608965),('83263','ID','Preston','Franklin',42.153799,-111.824342),('83271','ID','Rockland','Power',42.525428,-112.854334),('83272','ID','Saint Charles','Bear Lake',42.129456,-111.363),('83274','ID','Shelley','Bingham',43.360541,-112.109968),('83276','ID','Soda Springs','Caribou',42.709451,-111.558651),('83277','ID','Springfield','Bingham',43.070736,-112.682492),('83278','ID','Stanley','Custer',44.289125,-114.913776),('83281','ID','Swanlake','Bannock',42.303739,-111.965183),('83283','ID','Thatcher','Franklin',42.354136,-111.690701),('83285','ID','Wayan','Bonneville',43.072445,-111.326986),('83286','ID','Weston','Franklin',42.055038,-111.972862),('83287','ID','Fish Haven','Bear Lake',42.03201,-111.424139),('83301','ID','Twin Falls','Twin Falls',42.534554,-114.480333),('83302','ID','Rogerson','Twin Falls',42.166725,-114.974434),('83303','ID','Twin Falls','Twin Falls',42.2504,-114.6534),('83311','ID','Albion','Cassia',42.391451,-113.563933),('83312','ID','Almo','Cassia',42.001433,-113.664479),('83313','ID','Bellevue','Blaine',43.38874,-114.254038),('83314','ID','Bliss','Gooding',42.94243,-114.930357),('83316','ID','Buhl','Twin Falls',42.599201,-114.813473),('83318','ID','Burley','Cassia',42.503371,-113.798057),('83320','ID','Carey','Blaine',43.407148,-113.918328),('83321','ID','Castleford','Twin Falls',42.476143,-114.907253),('83322','ID','Corral','Camas',43.340789,-114.965525),('83323','ID','Declo','Cassia',42.503464,-113.514713),('83324','ID','Dietrich','Lincoln',42.888268,-114.26501),('83325','ID','Eden','Jerome',42.587877,-114.240846),('83327','ID','Fairfield','Camas',43.383135,-114.798876),('83328','ID','Filer','Twin Falls',42.563867,-114.611167),('83330','ID','Gooding','Gooding',42.940096,-114.714477),('83332','ID','Hagerman','Gooding',42.80097,-114.891069),('83333','ID','Hailey','Blaine',43.522376,-114.32418),('83334','ID','Hansen','Twin Falls',42.470528,-114.297401),('83335','ID','Hazelton','Jerome',42.584064,-114.06561),('83336','ID','Heyburn','Minidoka',42.563054,-113.791519),('83337','ID','Hill City','Camas',43.265838,-115.107169),('83338','ID','Jerome','Jerome',42.723789,-114.47716),('83340','ID','Ketchum','Blaine',43.748541,-114.51526),('83341','ID','Kimberly','Twin Falls',42.519837,-114.370824),('83342','ID','Malta','Cassia',42.182543,-113.293204),('83343','ID','Minidoka','Minidoka',42.9223,-113.6172),('83344','ID','Murtaugh','Twin Falls',42.478673,-114.115571),('83346','ID','Oakley','Cassia',42.229261,-113.901595),('83347','ID','Paul','Minidoka',42.679463,-113.857671),('83348','ID','Picabo','Blaine',43.249581,-114.108014),('83349','ID','Richfield','Lincoln',43.076665,-114.187316),('83350','ID','Rupert','Minidoka',42.667045,-113.623826),('83352','ID','Shoshone','Lincoln',43.035514,-114.42553),('83353','ID','Sun Valley','Blaine',43.680689,-114.335593),('83354','ID','Sun Valley','Blaine',43.670188,-114.322264),('83355','ID','Wendell','Gooding',42.753394,-114.713527),('83401','ID','Idaho Falls','Bonneville',43.532372,-111.972433),('83402','ID','Idaho Falls','Bonneville',43.501869,-112.079914),('83403','ID','Idaho Falls','Bonneville',43.4941,-112.0205),('83404','ID','Idaho Falls','Bonneville',43.461455,-112.010516),('83405','ID','Idaho Falls','Bonneville',43.4941,-112.0205),('83406','ID','Idaho Falls','Bonneville',43.457154,-111.944735),('83414','WY','Alta','Teton',43.913353,-111.01523),('83415','ID','Idaho Falls','Bonneville',43.4666,-112.0333),('83420','ID','Ashton','Fremont',44.047845,-111.363391),('83421','ID','Chester','Fremont',44.011614,-111.557681),('83422','ID','Driggs','Teton',43.721151,-111.17575),('83423','ID','Dubois','Clark',44.242104,-112.249244),('83424','ID','Felt','Teton',43.911337,-111.166278),('83425','ID','Hamer','Jefferson',43.91318,-112.249715),('83427','ID','Iona','Bonneville',43.524702,-111.931386),('83428','ID','Irwin','Bonneville',43.355726,-111.217712),('83429','ID','Island Park','Fremont',44.458074,-111.401852),('83431','ID','Lewisville','Jefferson',43.694685,-112.017457),('83433','ID','Macks Inn','Fremont',44.496509,-111.332233),('83434','ID','Menan','Jefferson',43.747423,-111.993462),('83435','ID','Monteview','Jefferson',43.98994,-112.558856),('83436','ID','Newdale','Fremont',43.869131,-111.489374),('83438','ID','Parker','Fremont',43.9594,-111.7569),('83440','ID','Rexburg','Madison',43.812025,-111.812505),('83441','ID','Rexburg','Madison',43.7634,-111.609),('83442','ID','Rigby','Jefferson',43.677442,-111.874133),('83443','ID','Ririe','Jefferson',43.558919,-111.639281),('83444','ID','Roberts','Jefferson',43.698327,-112.142509),('83445','ID','Saint Anthony','Fremont',43.955461,-111.704266),('83446','ID','Spencer','Clark',44.440432,-112.210503),('83448','ID','Sugar City','Madison',43.86359,-111.724729),('83449','ID','Swan Valley','Bonneville',43.346882,-111.435931),('83450','ID','Terreton','Jefferson',43.854219,-112.436325),('83451','ID','Teton','Fremont',43.876562,-111.648392),('83452','ID','Tetonia','Teton',43.81788,-111.195696),('83454','ID','Ucon','Bonneville',43.591068,-111.959266),('83455','ID','Victor','Teton',43.614761,-111.129286),('83460','ID','Rexburg','Madison',43.817106,-111.782347),('83462','ID','Carmen','Lemhi',45.284246,-113.840616),('83463','ID','Gibbonsville','Lemhi',45.554471,-113.970274),('83464','ID','Leadore','Lemhi',44.568471,-113.287818),('83465','ID','Lemhi','Lemhi',44.803347,-113.662083),('83466','ID','North Fork','Lemhi',45.417294,-114.074549),('83467','ID','Salmon','Lemhi',45.079987,-113.87718),('83468','ID','Tendoy','Lemhi',44.972175,-113.566174),('83469','ID','Shoup','Lemhi',45.333913,-114.270467),('83501','ID','Lewiston','Nez Perce',46.375801,-116.975219),('83520','ID','Ahsahka','Clearwater',46.514369,-116.324818),('83522','ID','Cottonwood','Idaho',45.981797,-116.410657),('83523','ID','Craigmont','Lewis',46.2393,-116.460709),('83524','ID','Culdesac','Nez Perce',46.356667,-116.674589),('83525','ID','Elk City','Idaho',45.787032,-115.506327),('83526','ID','Ferdinand','Idaho',46.151571,-116.400487),('83530','ID','Grangeville','Idaho',45.918522,-116.092553),('83531','ID','Fenn','Idaho',45.9268,-116.1227),('83533','ID','Greencreek','Idaho',46.11194,-116.232154),('83535','ID','Juliaetta','Latah',46.542657,-116.722138),('83536','ID','Kamiah','Idaho',46.219671,-115.997452),('83537','ID','Kendrick','Latah',46.631799,-116.577138),('83539','ID','Kooskia','Idaho',46.227982,-115.424254),('83540','ID','Lapwai','Nez Perce',46.383745,-116.796682),('83541','ID','Lenore','Clearwater',46.509325,-116.482398),('83542','ID','Lucile','Idaho',45.539661,-116.336251),('83543','ID','Nezperce','Lewis',46.259457,-116.242959),('83544','ID','Orofino','Clearwater',46.493977,-116.214732),('83545','ID','Peck','Nez Perce',46.46257,-116.437805),('83546','ID','Pierce','Clearwater',46.543873,-115.81604),('83547','ID','Pollock','Idaho',45.181964,-116.301049),('83548','ID','Reubens','Lewis',46.343871,-116.541918),('83549','ID','Riggins','Idaho',45.414063,-116.250272),('83552','ID','Stites','Idaho',46.023615,-115.936467),('83553','ID','Weippe','Clearwater',46.366266,-115.920749),('83554','ID','White Bird','Idaho',45.699199,-116.308572),('83555','ID','Winchester','Lewis',46.156937,-116.679404),('83601','ID','Atlanta','Elmore',43.823442,-115.236656),('83602','ID','Banks','Boise',44.072227,-116.120644),('83604','ID','Bruneau','Owyhee',42.616037,-115.839234),('83605','ID','Caldwell','Canyon',43.656858,-116.670427),('83606','ID','Caldwell','Canyon',43.7184,-116.74),('83607','ID','Caldwell','Canyon',43.688182,-116.737755),('83610','ID','Cambridge','Washington',44.651687,-116.698177),('83611','ID','Cascade','Valley',44.481155,-115.864713),('83612','ID','Council','Adams',44.839565,-116.522312),('83615','ID','Donnelly','Valley',44.710615,-116.052698),('83616','ID','Eagle','Ada',43.704741,-116.37364),('83617','ID','Emmett','Gem',43.891886,-116.519447),('83619','ID','Fruitland','Payette',43.994475,-116.91383),('83622','ID','Garden Valley','Boise',44.101001,-115.939813),('83623','ID','Glenns Ferry','Elmore',42.95323,-115.333269),('83624','ID','Grand View','Owyhee',42.998271,-116.091132),('83626','ID','Greenleaf','Canyon',43.668777,-116.828806),('83627','ID','Hammett','Elmore',42.942951,-115.50179),('83628','ID','Homedale','Owyhee',43.60269,-116.955228),('83629','ID','Horseshoe Bend','Boise',43.916364,-116.184202),('83630','ID','Huston','Canyon',43.5548,-116.7559),('83631','ID','Idaho City','Boise',43.846299,-115.844643),('83632','ID','Indian Valley','Adams',44.546021,-116.435357),('83633','ID','King Hill','Elmore',42.967213,-115.214616),('83634','ID','Kuna','Ada',43.475603,-116.398751),('83635','ID','Lake Fork','Valley',44.8327,-116.0838),('83636','ID','Letha','Gem',43.901818,-116.654267),('83637','ID','Lowman','Boise',44.109342,-115.43859),('83638','ID','Mccall','Valley',44.913276,-116.079868),('83639','ID','Marsing','Owyhee',43.498154,-116.861672),('83641','ID','Melba','Canyon',43.376399,-116.601307),('83642','ID','Meridian','Ada',43.588523,-116.39094),('83643','ID','Mesa','Adams',44.629786,-116.43741),('83644','ID','Middleton','Canyon',43.720781,-116.601794),('83645','ID','Midvale','Washington',44.403694,-116.619111),('83646','ID','Meridian','Ada',43.639965,-116.406181),('83647','ID','Mountain Home','Elmore',43.266842,-115.612849),('83648','ID','Mountain Home A F B','Elmore',43.053159,-115.859647),('83650','ID','Murphy','Owyhee',42.938091,-116.553951),('83651','ID','Nampa','Canyon',43.586938,-116.597189),('83652','ID','Nampa','Canyon',43.5677,-116.5735),('83653','ID','Nampa','Canyon',43.5677,-116.5735),('83654','ID','New Meadows','Adams',45.041309,-116.319447),('83655','ID','New Plymouth','Payette',43.95717,-116.80656),('83656','ID','Notus','Canyon',43.726469,-116.799128),('83657','ID','Ola','Gem',44.218334,-116.270291),('83660','ID','Parma','Canyon',43.794093,-116.929562),('83661','ID','Payette','Payette',44.072845,-116.884124),('83666','ID','Placerville','Boise',43.949679,-115.951377),('83669','ID','Star','Ada',43.700566,-116.495435),('83670','ID','Sweet','Gem',43.997456,-116.312009),('83671','ID','Warren','Idaho',45.273532,-115.691945),('83672','ID','Weiser','Washington',44.272412,-116.941934),('83676','ID','Wilder','Canyon',43.653147,-116.907583),('83677','ID','Yellow Pine','Valley',45.080689,-115.481385),('83680','ID','Meridian','Ada',43.6185,-116.3903),('83686','ID','Nampa','Canyon',43.529977,-116.577701),('83687','ID','Nampa','Canyon',43.601593,-116.539321),('83701','ID','Boise','Ada',43.6154,-116.2161),('83702','ID','Boise','Ada',43.63329,-116.203954),('83703','ID','Boise','Ada',43.651415,-116.238548),('83704','ID','Boise','Ada',43.629599,-116.285848),('83705','ID','Boise','Ada',43.584429,-116.225485),('83706','ID','Boise','Ada',43.593939,-116.200476);
INSERT INTO `zipcode` VALUES ('83707','ID','Boise','Ada',43.6154,-116.2161),('83708','ID','Boise','Ada',43.6136,-116.2025),('83709','ID','Boise','Ada',43.569724,-116.299014),('83711','ID','Boise','Ada',43.6154,-116.2161),('83712','ID','Boise','Ada',43.605658,-116.170689),('83713','ID','Boise','Ada',43.637523,-116.332571),('83714','ID','Garden City','Ada',43.678662,-116.278456),('83715','ID','Boise','Ada',43.5665,-116.2119),('83716','ID','Boise','Ada',43.573193,-116.04414),('83717','ID','Boise','Ada',43.5544,-116.1472),('83719','ID','Boise','Ada',43.5476,-116.2836),('83720','ID','Boise','Ada',43.6154,-116.2161),('83721','ID','Boise','Ada',43.6136,-116.2025),('83722','ID','Boise','Ada',43.6136,-116.2025),('83724','ID','Boise','Ada',43.6136,-116.2025),('83725','ID','Boise','Ada',43.605,-116.2054),('83726','ID','Boise','Ada',43.4343,-116.0029),('83727','ID','Boise','Ada',43.6136,-116.2025),('83728','ID','Boise','Ada',43.6136,-116.2025),('83729','ID','Boise','Ada',43.6136,-116.2025),('83730','ID','Boise','Ada',43.6136,-116.2025),('83731','ID','Boise','Ada',43.7435,-116.2024),('83732','ID','Boise','Ada',43.5476,-116.2836),('83733','ID','Boise','Ada',43.6136,-116.2025),('83735','ID','Boise','Ada',43.6136,-116.2025),('83756','ID','Boise','Ada',43.6136,-116.2025),('83757','ID','Boise','Ada',43.6136,-116.2025),('83799','ID','Boise','Ada',43.6142,-116.2161),('83801','ID','Athol','Kootenai',47.942864,-116.66724),('83802','ID','Avery','Shoshone',47.139411,-115.665556),('83803','ID','Bayview','Kootenai',47.992729,-116.502709),('83804','ID','Blanchard','Bonner',48.016885,-116.982053),('83805','ID','Bonners Ferry','Boundary',48.809207,-116.365739),('83806','ID','Bovill','Latah',46.867329,-116.39734),('83808','ID','Calder','Shoshone',47.279649,-116.08025),('83809','ID','Careywood','Bonner',48.055282,-116.598299),('83810','ID','Cataldo','Kootenai',47.538837,-116.472363),('83811','ID','Clark Fork','Bonner',48.12122,-116.161045),('83812','ID','Clarkia','Shoshone',47.009599,-116.246343),('83813','ID','Cocolalla','Bonner',48.094841,-116.622449),('83814','ID','Coeur D Alene','Kootenai',47.667689,-116.771399),('83815','ID','Coeur D Alene','Kootenai',47.721429,-116.79253),('83816','ID','Coeur D Alene','Kootenai',47.67,-116.78),('83821','ID','Coolin','Bonner',48.579914,-116.843422),('83822','ID','Oldtown','Bonner',48.176148,-117.020317),('83823','ID','Deary','Latah',46.800184,-116.527029),('83824','ID','Desmet','Benewah',47.111765,-116.909304),('83825','ID','Dover','Bonner',48.248573,-116.609711),('83826','ID','Eastport','Boundary',48.980503,-116.182562),('83827','ID','Elk River','Clearwater',46.779919,-116.179576),('83830','ID','Fernwood','Benewah',47.093531,-116.360019),('83832','ID','Genesee','Latah',46.55506,-116.919059),('83833','ID','Harrison','Kootenai',47.50104,-116.744831),('83834','ID','Harvard','Latah',46.965973,-116.669396),('83835','ID','Hayden','Kootenai',47.771004,-116.737228),('83836','ID','Hope','Bonner',48.242014,-116.285832),('83837','ID','Kellogg','Shoshone',47.528927,-116.107644),('83839','ID','Kingston','Shoshone',47.605455,-116.207713),('83840','ID','Kootenai','Bonner',48.310718,-116.515879),('83841','ID','Laclede','Bonner',48.183321,-116.754241),('83842','ID','Medimont','Kootenai',47.445735,-116.560958),('83843','ID','Moscow','Latah',46.728692,-116.974002),('83844','ID','Moscow','Latah',46.727387,-117.011422),('83845','ID','Moyie Springs','Boundary',48.722333,-116.136203),('83846','ID','Mullan','Shoshone',47.468129,-115.781452),('83847','ID','Naples','Boundary',48.570005,-116.419932),('83848','ID','Nordman','Bonner',48.672404,-116.891564),('83849','ID','Osburn','Shoshone',47.509323,-116.006435),('83850','ID','Pinehurst','Shoshone',47.50889,-116.243102),('83851','ID','Plummer','Benewah',47.314108,-116.893683),('83852','ID','Ponderay','Bonner',48.306239,-116.536444),('83853','ID','Porthill','Boundary',48.953737,-116.530789),('83854','ID','Post Falls','Kootenai',47.722257,-116.945727),('83855','ID','Potlatch','Latah',46.953775,-116.918405),('83856','ID','Priest River','Bonner',48.276443,-116.893433),('83857','ID','Princeton','Latah',46.886608,-116.810767),('83858','ID','Rathdrum','Kootenai',47.816772,-116.896599),('83860','ID','Sagle','Bonner',48.203208,-116.564086),('83861','ID','Saint Maries','Benewah',47.278335,-116.583481),('83864','ID','Sandpoint','Bonner',48.365933,-116.550437),('83865','ID','Colburn','Bonner',48.3972,-116.5341),('83866','ID','Santa','Benewah',47.160713,-116.424007),('83867','ID','Silverton','Shoshone',47.495812,-115.955491),('83868','ID','Smelterville','Shoshone',47.543692,-116.177258),('83869','ID','Spirit Lake','Kootenai',47.970156,-116.87076),('83870','ID','Tensed','Benewah',47.128393,-116.83306),('83871','ID','Troy','Latah',46.741943,-116.742676),('83872','ID','Viola','Latah',46.867496,-116.976959),('83873','ID','Wallace','Shoshone',47.54839,-115.909283),('83874','ID','Murray','Shoshone',47.63251,-115.784587),('83876','ID','Worley','Kootenai',47.44897,-116.902985),('83877','ID','Post Falls','Kootenai',47.7379,-116.9533),('84001','UT','Altamont','Duchesne',40.355683,-110.279929),('84002','UT','Altonah','Duchesne',40.448691,-110.30681),('84003','UT','American Fork','Utah',40.411439,-111.780649),('84004','UT','Alpine','Utah',40.467331,-111.771049),('84005','UT','Eagle Mountain','Utah',40.337907,-111.987741),('84006','UT','Bingham Canyon','Salt Lake',40.580776,-112.094459),('84007','UT','Bluebell','Duchesne',40.303381,-110.214428),('84008','UT','Bonanza','Uintah',40.1021,-109.4991),('84010','UT','Bountiful','Davis',40.876502,-111.873144),('84011','UT','Bountiful','Davis',40.8817,-111.8793),('84013','UT','Cedar Valley','Utah',40.296101,-112.090963),('84014','UT','Centerville','Davis',40.92546,-111.880774),('84015','UT','Clearfield','Davis',41.12027,-112.04297),('84016','UT','Clearfield','Davis',41.0892,-112.0202),('84017','UT','Coalville','Summit',40.913768,-111.277051),('84018','UT','Croydon','Morgan',41.195923,-111.479516),('84020','UT','Draper','Salt Lake',40.507034,-111.868992),('84021','UT','Duchesne','Duchesne',40.184094,-110.416675),('84022','UT','Dugway','Tooele',40.223266,-112.768447),('84023','UT','Dutch John','Daggett',40.858207,-109.257829),('84024','UT','Echo','Summit',40.983776,-111.440826),('84025','UT','Farmington','Davis',40.985937,-111.900592),('84026','UT','Fort Duchesne','Uintah',40.28915,-109.853121),('84027','UT','Fruitland','Duchesne',40.207775,-110.814297),('84028','UT','Garden City','Rich',41.914521,-111.405886),('84029','UT','Grantsville','Tooele',40.631238,-112.53401),('84031','UT','Hanna','Duchesne',40.564876,-110.808566),('84032','UT','Heber City','Wasatch',40.464828,-111.346897),('84033','UT','Henefer','Summit',41.010019,-111.490889),('84034','UT','Ibapah','Tooele',40.019506,-113.932658),('84035','UT','Jensen','Uintah',40.285197,-109.288656),('84036','UT','Kamas','Summit',40.641696,-111.199776),('84037','UT','Kaysville','Davis',41.03237,-111.932933),('84038','UT','Laketown','Rich',41.835769,-111.326171),('84039','UT','Lapoint','Uintah',40.440155,-109.812795),('84040','UT','Layton','Davis',41.090254,-111.927306),('84041','UT','Layton','Davis',41.074681,-111.977988),('84042','UT','Lindon','Utah',40.341024,-111.708381),('84043','UT','Lehi','Utah',40.409136,-111.866708),('84044','UT','Magna','Salt Lake',40.701629,-112.102561),('84045','UT','Saratoga Springs','Utah',40.334819,-111.909609),('84046','UT','Manila','Daggett',40.972211,-109.755897),('84047','UT','Midvale','Salt Lake',40.615473,-111.887094),('84049','UT','Midway','Wasatch',40.527477,-111.496563),('84050','UT','Morgan','Morgan',41.038274,-111.690182),('84051','UT','Mountain Home','Duchesne',40.366491,-110.407503),('84052','UT','Myton','Duchesne',40.189696,-110.045729),('84053','UT','Neola','Duchesne',40.440223,-110.025291),('84054','UT','North Salt Lake','Davis',40.843993,-111.914369),('84055','UT','Oakley','Summit',40.775571,-111.159062),('84056','UT','Hill Afb','Davis',41.12536,-111.996877),('84057','UT','Orem','Utah',40.314792,-111.707567),('84058','UT','Orem','Utah',40.281111,-111.711182),('84059','UT','Orem','Utah',40.2969,-111.703),('84060','UT','Park City','Summit',40.651886,-111.494691),('84061','UT','Peoa','Summit',40.753515,-111.343092),('84062','UT','Pleasant Grove','Utah',40.385366,-111.726005),('84063','UT','Randlett','Uintah',40.107166,-109.691098),('84064','UT','Randolph','Rich',41.67036,-111.113627),('84065','UT','Riverton','Salt Lake',40.504612,-111.947099),('84066','UT','Roosevelt','Duchesne',40.313248,-110.015473),('84067','UT','Roy','Weber',41.171039,-112.049071),('84068','UT','Park City','Summit',40.7215,-111.5323),('84069','UT','Rush Valley','Tooele',40.378608,-112.485071),('84070','UT','Sandy','Salt Lake',40.581808,-111.888699),('84071','UT','Stockton','Tooele',40.437505,-112.357444),('84072','UT','Tabiona','Duchesne',40.351224,-110.719719),('84073','UT','Talmage','Duchesne',40.351156,-110.435744),('84074','UT','Tooele','Tooele',40.557665,-112.296676),('84075','UT','Syracuse','Davis',41.085116,-112.066851),('84076','UT','Tridell','Uintah',40.461864,-109.839366),('84078','UT','Vernal','Uintah',40.569402,-109.44906),('84079','UT','Vernal','Uintah',40.1021,-109.4991),('84080','UT','Vernon','Tooele',40.126113,-112.425716),('84081','UT','West Jordan','Salt Lake',40.606051,-112.027511),('84082','UT','Wallsburg','Wasatch',40.373728,-111.421346),('84083','UT','Wendover','Tooele',40.696817,-114.031093),('84084','UT','West Jordan','Salt Lake',40.625028,-111.964531),('84085','UT','Whiterocks','Uintah',40.547705,-109.92484),('84086','UT','Woodruff','Rich',41.49598,-111.195366),('84087','UT','Woods Cross','Davis',40.883257,-111.916311),('84088','UT','West Jordan','Salt Lake',40.595431,-111.968418),('84089','UT','Clearfield','Davis',41.1152,-112.0249),('84090','UT','Sandy','Salt Lake',40.583,-111.8332),('84091','UT','Sandy','Salt Lake',40.5897,-111.8713),('84092','UT','Sandy','Salt Lake',40.561992,-111.80887),('84093','UT','Sandy','Salt Lake',40.595698,-111.833033),('84094','UT','Sandy','Salt Lake',40.572003,-111.862127),('84095','UT','South Jordan','Salt Lake',40.557688,-111.967725),('84096','UT','Herriman','Salt Lake',40.505658,-112.031702),('84097','UT','Orem','Utah',40.306376,-111.672505),('84098','UT','Park City','Summit',40.730052,-111.527284),('84101','UT','Salt Lake City','Salt Lake',40.755207,-111.901097),('84102','UT','Salt Lake City','Salt Lake',40.759552,-111.863954),('84103','UT','Salt Lake City','Salt Lake',40.77794,-111.876808),('84104','UT','Salt Lake City','Salt Lake',40.750847,-111.940857),('84105','UT','Salt Lake City','Salt Lake',40.73761,-111.860432),('84106','UT','Salt Lake City','Salt Lake',40.707503,-111.856615),('84107','UT','Salt Lake City','Salt Lake',40.657701,-111.882493),('84108','UT','Salt Lake City','Salt Lake',40.746803,-111.807818),('84109','UT','Salt Lake City','Salt Lake',40.706081,-111.796437),('84110','UT','Salt Lake City','Salt Lake',40.7648,-111.8967),('84111','UT','Salt Lake City','Salt Lake',40.755218,-111.883927),('84112','UT','Salt Lake City','Salt Lake',40.762955,-111.836896),('84113','UT','Salt Lake City','Salt Lake',40.763145,-111.83535),('84114','UT','Salt Lake City','Salt Lake',40.7755,-111.8874),('84115','UT','Salt Lake City','Salt Lake',40.718054,-111.889516),('84116','UT','Salt Lake City','Salt Lake',40.790102,-111.940969),('84117','UT','Salt Lake City','Salt Lake',40.662935,-111.838527),('84118','UT','Salt Lake City','Salt Lake',40.653855,-111.99692),('84119','UT','Salt Lake City','Salt Lake',40.697454,-111.949688),('84120','UT','Salt Lake City','Salt Lake',40.691371,-112.000526),('84121','UT','Salt Lake City','Salt Lake',40.624739,-111.799731),('84122','UT','Salt Lake City','Salt Lake',40.7608,-111.8902),('84123','UT','Salt Lake City','Salt Lake',40.657137,-111.919446),('84124','UT','Salt Lake City','Salt Lake',40.679629,-111.819376),('84125','UT','Salt Lake City','Salt Lake',40.7,-111.9443),('84126','UT','Salt Lake City','Salt Lake',40.7001,-111.9446),('84127','UT','Salt Lake City','Salt Lake',40.7001,-111.9446),('84128','UT','Salt Lake City','Salt Lake',40.694116,-112.045828),('84130','UT','Salt Lake City','Salt Lake',40.7001,-111.9446),('84131','UT','Salt Lake City','Salt Lake',40.7001,-111.9446),('84132','UT','Salt Lake City','Salt Lake',40.7608,-111.8902),('84133','UT','Salt Lake City','Salt Lake',40.7648,-111.8967),('84134','UT','Salt Lake City','Salt Lake',40.7608,-111.8902),('84136','UT','Salt Lake City','Salt Lake',40.7608,-111.8902),('84138','UT','Salt Lake City','Salt Lake',40.7648,-111.8967),('84139','UT','Salt Lake City','Salt Lake',40.7608,-111.8902),('84141','UT','Salt Lake City','Salt Lake',40.7608,-111.8902),('84143','UT','Salt Lake City','Salt Lake',40.7785,-111.8789),('84144','UT','Salt Lake City','Salt Lake',40.768261,-111.892525),('84145','UT','Salt Lake City','Salt Lake',40.7648,-111.8967),('84147','UT','Salt Lake City','Salt Lake',40.7682,-111.8872),('84148','UT','Salt Lake City','Salt Lake',40.7582,-111.8397),('84150','UT','Salt Lake City','Salt Lake',40.7693,-111.8886),('84151','UT','Salt Lake City','Salt Lake',40.7648,-111.8967),('84152','UT','Salt Lake City','Salt Lake',40.7288,-111.8586),('84157','UT','Salt Lake City','Salt Lake',40.6628,-111.8867),('84158','UT','Salt Lake City','Salt Lake',40.7502,-111.8255),('84165','UT','Salt Lake City','Salt Lake',40.7138,-111.8913),('84170','UT','Salt Lake City','Salt Lake',40.6972,-111.9945),('84171','UT','Salt Lake City','Salt Lake',40.6257,-111.8237),('84180','UT','Salt Lake City','Salt Lake',40.770248,-111.900772),('84184','UT','Salt Lake City','Salt Lake',40.7001,-111.9446),('84189','UT','Salt Lake City','Salt Lake',40.7608,-111.8902),('84190','UT','Salt Lake City','Salt Lake',40.7608,-111.8902),('84199','UT','Salt Lake City','Salt Lake',40.7001,-111.9446),('84201','UT','Ogden','Weber',41.2443,-112.0072),('84244','UT','Ogden','Weber',41.2839,-112.1235),('84301','UT','Bear River City','Box Elder',41.615537,-112.128388),('84302','UT','Brigham City','Box Elder',41.519281,-112.029529),('84304','UT','Cache Junction','Cache',41.830423,-112.000904),('84305','UT','Clarkston','Cache',41.932467,-112.052673),('84306','UT','Collinston','Box Elder',41.798949,-112.070108),('84307','UT','Corinne','Box Elder',41.539903,-112.210053),('84308','UT','Cornish','Cache',41.965467,-111.974192),('84309','UT','Deweyville','Box Elder',41.713821,-112.094731),('84310','UT','Eden','Weber',41.32929,-111.85558),('84311','UT','Fielding','Box Elder',41.815317,-112.117237),('84312','UT','Garland','Box Elder',41.759373,-112.158252),('84313','UT','Grouse Creek','Box Elder',41.622628,-113.963893),('84314','UT','Honeyville','Box Elder',41.635354,-112.087858),('84315','UT','Hooper','Weber',41.168417,-112.120624),('84316','UT','Howell','Box Elder',41.744208,-112.443998),('84317','UT','Huntsville','Weber',41.314982,-111.66536),('84318','UT','Hyde Park','Cache',41.80213,-111.812503),('84319','UT','Hyrum','Cache',41.621341,-111.800158),('84320','UT','Lewiston','Cache',41.966627,-111.846831),('84321','UT','Logan','Cache',41.73777,-111.811851),('84322','UT','Logan','Cache',41.7436,-111.809),('84323','UT','Logan','Cache',41.6843,-111.6473),('84324','UT','Mantua','Box Elder',41.502894,-111.950926),('84325','UT','Mendon','Cache',41.722324,-111.979126),('84326','UT','Millville','Cache',41.678884,-111.819499),('84327','UT','Newton','Cache',41.863779,-111.995965),('84328','UT','Paradise','Cache',41.553422,-111.825394),('84329','UT','Park Valley','Box Elder',41.794923,-113.491578),('84330','UT','Plymouth','Box Elder',41.894411,-112.159606),('84331','UT','Portage','Box Elder',41.972806,-112.220069),('84332','UT','Providence','Cache',41.701845,-111.813152),('84333','UT','Richmond','Cache',41.920221,-111.817239),('84334','UT','Riverside','Box Elder',41.78791,-112.150342),('84335','UT','Smithfield','Cache',41.831493,-111.851704),('84336','UT','Snowville','Box Elder',41.961917,-112.723977),('84337','UT','Tremonton','Box Elder',41.706344,-112.196329),('84338','UT','Trenton','Cache',41.913948,-111.94064),('84339','UT','Wellsville','Cache',41.639743,-111.930109),('84340','UT','Willard','Box Elder',41.386673,-112.040319),('84341','UT','Logan','Cache',41.766997,-111.816),('84401','UT','Ogden','Weber',41.217241,-112.001474),('84402','UT','Ogden','Weber',41.1976,-111.9844),('84403','UT','Ogden','Weber',41.187639,-111.94612),('84404','UT','Ogden','Weber',41.271291,-112.018663),('84405','UT','Ogden','Weber',41.164498,-111.967787),('84407','UT','Ogden','Weber',41.2839,-112.1235),('84408','UT','Ogden','Weber',41.192,-111.9465),('84409','UT','Ogden','Weber',41.1976,-111.9844),('84412','UT','Ogden','Weber',41.2639,-111.9686),('84414','UT','Ogden','Weber',41.315004,-111.969219),('84415','UT','Ogden','Weber',41.1796,-111.9496),('84501','UT','Price','Carbon',39.579652,-110.786546),('84510','UT','Aneth','San Juan',37.198216,-109.11245),('84511','UT','Blanding','San Juan',37.539817,-109.41682),('84512','UT','Bluff','San Juan',37.149754,-109.549572),('84513','UT','Castle Dale','Emery',39.221305,-111.019097),('84515','UT','Cisco','Grand',39.152,-109.2695),('84516','UT','Clawson','Emery',39.145655,-111.089976),('84518','UT','Cleveland','Emery',39.403149,-110.886722),('84520','UT','East Carbon','Carbon',39.542439,-110.412824),('84521','UT','Elmo','Emery',39.39013,-110.807677),('84522','UT','Emery','Emery',38.930514,-111.211988),('84523','UT','Ferron','Emery',39.097533,-111.147281),('84525','UT','Green River','Emery',38.972749,-110.211517),('84526','UT','Helper','Carbon',39.718468,-110.962983),('84528','UT','Huntington','Emery',39.362066,-111.034046),('84529','UT','Kenilworth','Carbon',39.680599,-110.810676),('84530','UT','La Sal','San Juan',38.28004,-109.1993),('84531','UT','Mexican Hat','San Juan',37.109125,-109.916293),('84532','UT','Moab','Grand',38.538613,-109.483392),('84533','UT','Lake Powell','Kane',37.578389,-110.363193),('84534','UT','Montezuma Creek','San Juan',37.240396,-109.24044),('84535','UT','Monticello','San Juan',38.008632,-109.442881),('84536','UT','Monument Valley','San Juan',37.078293,-110.240616),('84537','UT','Orangeville','Emery',39.281486,-111.176629),('84539','UT','Sunnyside','Carbon',39.595427,-110.335766),('84540','UT','Thompson','Grand',39.271331,-109.330133),('84542','UT','Wellington','Carbon',39.54069,-110.726807),('84601','UT','Provo','Utah',40.233803,-111.684191),('84602','UT','Provo','Utah',40.2483,-111.6484),('84603','UT','Provo','Utah',40.232,-111.6589),('84604','UT','Provo','Utah',40.302439,-111.635371),('84605','UT','Provo','Utah',40.2338,-111.6577),('84606','UT','Provo','Utah',40.225435,-111.637058),('84620','UT','Aurora','Sevier',38.919369,-111.930404),('84621','UT','Axtell','Sanpete',39.044764,-111.823161),('84622','UT','Centerfield','Sanpete',39.12,-111.815833),('84623','UT','Chester','Sanpete',39.460826,-111.569911),('84624','UT','Delta','Millard',39.34913,-112.604128),('84626','UT','Elberta','Utah',39.934141,-111.980489),('84627','UT','Ephraim','Sanpete',39.360698,-111.580635),('84628','UT','Eureka','Juab',39.939234,-112.147953),('84629','UT','Fairview','Sanpete',39.736431,-111.448463),('84630','UT','Fayette','Sanpete',39.239704,-111.822836),('84631','UT','Fillmore','Millard',38.967471,-112.352944),('84632','UT','Fountain Green','Sanpete',39.62617,-111.637228),('84633','UT','Goshen','Utah',39.94671,-111.907178),('84634','UT','Gunnison','Sanpete',39.155817,-111.809961),('84635','UT','Hinckley','Millard',39.371237,-112.722829),('84636','UT','Holden','Millard',39.123894,-112.294344),('84637','UT','Kanosh','Millard',38.787309,-112.466532),('84638','UT','Leamington','Millard',39.525993,-112.281665),('84639','UT','Levan','Juab',39.507174,-111.900101),('84640','UT','Lynndyl','Millard',39.496884,-112.388634),('84642','UT','Manti','Sanpete',39.272527,-111.631608),('84643','UT','Mayfield','Sanpete',39.116775,-111.713398),('84644','UT','Meadow','Millard',38.8886,-112.4106),('84645','UT','Mona','Juab',39.847225,-111.855847),('84646','UT','Moroni','Sanpete',39.530793,-111.586642),('84647','UT','Mount Pleasant','Sanpete',39.542855,-111.440822),('84648','UT','Nephi','Juab',39.697906,-111.842788),('84649','UT','Oak City','Millard',39.320708,-112.362121),('84651','UT','Payson','Utah',40.013345,-111.730903),('84652','UT','Redmond','Sevier',39.011575,-111.86934),('84653','UT','Salem','Utah',40.040984,-111.654683),('84654','UT','Salina','Sevier',38.916585,-111.730696),('84655','UT','Santaquin','Utah',39.97859,-111.800568),('84656','UT','Scipio','Millard',39.202972,-112.095418),('84657','UT','Sigurd','Sevier',38.8346,-111.962619),('84660','UT','Spanish Fork','Utah',40.095312,-111.639949),('84662','UT','Spring City','Sanpete',39.464565,-111.484519),('84663','UT','Springville','Utah',40.167522,-111.579405),('84664','UT','Mapleton','Utah',40.117253,-111.577212),('84665','UT','Sterling','Sanpete',39.199609,-111.683201),('84667','UT','Wales','Sanpete',39.487702,-111.634155),('84701','UT','Richfield','Sevier',38.758015,-112.020158),('84710','UT','Alton','Kane',37.449835,-112.495029),('84711','UT','Annabella','Sevier',38.70091,-112.047148),('84712','UT','Antimony','Garfield',38.066903,-111.964799),('84713','UT','Beaver','Beaver',38.29679,-112.617252),('84714','UT','Beryl','Iron',37.792934,-113.699602),('84715','UT','Bicknell','Wayne',38.332065,-111.543661),('84716','UT','Boulder','Garfield',37.941646,-111.432559),('84717','UT','Bryce Canyon','Garfield',37.62,-112.17),('84718','UT','Cannonville','Garfield',37.558403,-112.065849),('84719','UT','Brian Head','Iron',37.694658,-112.830906),('84720','UT','Cedar City','Iron',37.631986,-113.141109),('84721','UT','Cedar City','Iron',37.767629,-113.108282),('84722','UT','Central','Washington',37.419065,-113.626793),('84723','UT','Circleville','Piute',38.180067,-112.252464),('84724','UT','Elsinore','Sevier',38.680093,-112.147585),('84725','UT','Enterprise','Washington',37.552243,-113.750497),('84726','UT','Escalante','Garfield',37.758132,-111.624247),('84728','UT','Garrison','Millard',39.098552,-113.972498),('84729','UT','Glendale','Kane',37.344633,-112.600804),('84730','UT','Glenwood','Sevier',38.747832,-111.996028),('84731','UT','Greenville','Beaver',38.26478,-112.803926),('84732','UT','Greenwich','Piute',38.435703,-111.909374),('84733','UT','Gunlock','Washington',37.301394,-113.841698),('84734','UT','Hanksville','Wayne',38.348324,-110.688211),('84735','UT','Hatch','Garfield',37.646412,-112.448943),('84736','UT','Henrieville','Garfield',37.561873,-111.995405),('84737','UT','Hurricane','Washington',37.14376,-113.299573),('84738','UT','Ivins','Washington',37.167456,-113.680726),('84739','UT','Joseph','Sevier',38.620167,-112.219401),('84740','UT','Junction','Piute',38.263077,-112.219085),('84741','UT','Kanab','Kane',37.158274,-112.32889),('84742','UT','Kanarraville','Iron',37.541256,-113.201862),('84743','UT','Kingston','Piute',38.207706,-112.178543),('84744','UT','Koosharem','Sevier',38.532955,-111.878786),('84745','UT','La Verkin','Washington',37.214243,-113.264843),('84746','UT','Leeds','Washington',37.241576,-113.35983),('84747','UT','Loa','Wayne',38.425352,-111.635604),('84749','UT','Lyman','Wayne',38.394292,-111.580298),('84750','UT','Marysvale','Piute',38.456166,-112.21888),('84751','UT','Milford','Beaver',38.390674,-112.996674),('84752','UT','Minersville','Beaver',38.216185,-112.919178),('84753','UT','Modena','Iron',37.975483,-113.888997),('84754','UT','Monroe','Sevier',38.649444,-112.120104),('84755','UT','Mount Carmel','Kane',37.241233,-112.761668),('84756','UT','Newcastle','Iron',37.616449,-113.515679),('84757','UT','New Harmony','Washington',37.466164,-113.257898),('84758','UT','Orderville','Kane',37.288217,-112.702755),('84759','UT','Panguitch','Garfield',37.826889,-112.453082),('84760','UT','Paragonah','Iron',37.936831,-112.728722),('84761','UT','Parowan','Iron',37.854786,-112.840862),('84762','UT','Duck Creek Village','Kane',37.502988,-112.686287),('84763','UT','Rockville','Washington',37.159555,-113.062999),('84764','UT','Bryce','Garfield',37.667549,-112.157845),('84765','UT','Santa Clara','Washington',37.132861,-113.65042),('84766','UT','Sevier','Sevier',38.582873,-112.287669),('84767','UT','Springdale','Washington',37.284234,-112.97676),('84770','UT','Saint George','Washington',37.123874,-113.60226),('84771','UT','Saint George','Washington',37.105,-113.5766),('84772','UT','Summit','Iron',37.79973,-112.939356),('84773','UT','Teasdale','Wayne',38.250115,-111.393785),('84774','UT','Toquerville','Washington',37.274895,-113.282063),('84775','UT','Torrey','Wayne',38.285066,-111.247472),('84776','UT','Tropic','Garfield',37.626165,-112.080809),('84779','UT','Virgin','Washington',37.342316,-113.108079),('84780','UT','Washington','Washington',37.125257,-113.501195),('84781','UT','Pine Valley','Washington',37.397464,-113.500168),('84782','UT','Veyo','Washington',37.349566,-113.674934),('84783','UT','Dammeron Valley','Washington',37.287382,-113.662363),('84784','UT','Hildale','Washington',37.002754,-112.985909),('84790','UT','Saint George','Washington',37.074138,-113.558792),('84791','UT','Saint George','Washington',37.0892,-113.5564),('85001','AZ','Phoenix','Maricopa',33.451,-112.0685),('85002','AZ','Phoenix','Maricopa',33.451,-112.0685),('85003','AZ','Phoenix','Maricopa',33.450893,-112.078331),('85004','AZ','Phoenix','Maricopa',33.450881,-112.070618),('85005','AZ','Phoenix','Maricopa',33.4483,-112.0733),('85006','AZ','Phoenix','Maricopa',33.465234,-112.048771),('85007','AZ','Phoenix','Maricopa',33.449698,-112.090341),('85008','AZ','Phoenix','Maricopa',33.464796,-111.995164),('85009','AZ','Phoenix','Maricopa',33.456046,-112.123822),('85010','AZ','Phoenix','Maricopa',33.4659,-112.0236),('85011','AZ','Phoenix','Maricopa',33.5054,-112.0634),('85012','AZ','Phoenix','Maricopa',33.505299,-112.070862),('85013','AZ','Phoenix','Maricopa',33.507153,-112.084558),('85014','AZ','Phoenix','Maricopa',33.510589,-112.058171),('85015','AZ','Phoenix','Maricopa',33.50679,-112.102076),('85016','AZ','Phoenix','Maricopa',33.50778,-112.032731),('85017','AZ','Phoenix','Maricopa',33.508782,-112.123068),('85018','AZ','Phoenix','Maricopa',33.498821,-111.985541),('85019','AZ','Phoenix','Maricopa',33.511534,-112.143319),('85020','AZ','Phoenix','Maricopa',33.563095,-112.055235),('85021','AZ','Phoenix','Maricopa',33.559421,-112.092875),('85022','AZ','Phoenix','Maricopa',33.629796,-112.053397),('85023','AZ','Phoenix','Maricopa',33.635109,-112.093768),('85024','AZ','Phoenix','Maricopa',33.690398,-112.042316),('85025','AZ','Phoenix','Maricopa',33.4506,-112.0773),('85026','AZ','Phoenix','Maricopa',33.4509,-111.974),('85027','AZ','Phoenix','Maricopa',33.673176,-112.106301),('85028','AZ','Phoenix','Maricopa',33.581921,-112.008618),('85029','AZ','Phoenix','Maricopa',33.598338,-112.120431),('85030','AZ','Phoenix','Maricopa',33.4519,-112.0775),('85031','AZ','Phoenix','Maricopa',33.495801,-112.172157),('85032','AZ','Phoenix','Maricopa',33.624449,-112.003485),('85033','AZ','Phoenix','Maricopa',33.495244,-112.212695),('85034','AZ','Phoenix','Maricopa',33.436855,-112.02253),('85035','AZ','Phoenix','Maricopa',33.471065,-112.189693),('85036','AZ','Phoenix','Maricopa',33.4367,-112.05),('85037','AZ','Phoenix','Maricopa',33.492054,-112.263543),('85038','AZ','Phoenix','Maricopa',33.4509,-111.974),('85039','AZ','Phoenix','Maricopa',33.448099,-112.076409),('85040','AZ','Phoenix','Maricopa',33.40376,-112.022646),('85041','AZ','Phoenix','Maricopa',33.385685,-112.106863),('85042','AZ','Phoenix','Maricopa',33.377816,-112.034448),('85043','AZ','Phoenix','Maricopa',33.432968,-112.201544),('85044','AZ','Phoenix','Maricopa',33.333906,-111.988869),('85045','AZ','Phoenix','Maricopa',33.299181,-112.096547),('85046','AZ','Phoenix','Maricopa',33.6259,-112.0185),('85048','AZ','Phoenix','Maricopa',33.302517,-112.022528),('85050','AZ','Phoenix','Maricopa',33.677838,-112.000419),('85051','AZ','Phoenix','Maricopa',33.557802,-112.133928),('85053','AZ','Phoenix','Maricopa',33.629939,-112.131344),('85054','AZ','Phoenix','Maricopa',33.678527,-111.941099),('85055','AZ','Phoenix','Maricopa',33.4483,-112.0733),('85060','AZ','Phoenix','Maricopa',33.4805,-111.9963),('85061','AZ','Phoenix','Maricopa',33.5094,-112.118),('85062','AZ','Phoenix','Maricopa',33.4509,-111.974),('85063','AZ','Phoenix','Maricopa',33.5014,-112.1723),('85064','AZ','Phoenix','Maricopa',33.5098,-112.0378),('85065','AZ','Phoenix','Maricopa',33.4483,-112.0733),('85066','AZ','Phoenix','Maricopa',33.3924,-112.0675),('85067','AZ','Phoenix','Maricopa',33.4934,-112.0823),('85068','AZ','Phoenix','Maricopa',33.5742,-112.0644),('85069','AZ','Phoenix','Maricopa',33.5562,-112.1113),('85070','AZ','Phoenix','Maricopa',33.561,-112.0935),('85071','AZ','Phoenix','Maricopa',33.597,-112.0987),('85072','AZ','Phoenix','Maricopa',33.4509,-111.974),('85073','AZ','Phoenix','Maricopa',33.451,-112.0685),('85074','AZ','Phoenix','Maricopa',33.4367,-112.05),('85075','AZ','Phoenix','Maricopa',33.4483,-112.0733),('85076','AZ','Phoenix','Maricopa',33.3475,-111.9742),('85077','AZ','Phoenix','Maricopa',33.4509,-111.974),('85078','AZ','Phoenix','Maricopa',33.6259,-112.0185),('85079','AZ','Phoenix','Maricopa',33.5094,-112.118),('85080','AZ','Phoenix','Maricopa',33.6548,-112.1043),('85082','AZ','Phoenix','Maricopa',33.4509,-111.974),('85083','AZ','Phoenix','Maricopa',33.727079,-112.1686),('85085','AZ','Phoenix','Maricopa',33.739864,-112.093782),('85086','AZ','Phoenix','Maricopa',33.837641,-112.11531),('85087','AZ','New River','Maricopa',33.907972,-112.12672),('85096','AZ','Phoenix','Maricopa',33.449995,-112.090249),('85097','AZ','Phoenix','Maricopa',33.437136,-112.156441),('85098','AZ','Phoenix','Maricopa',33.4368,-112.1416),('85099','AZ','Phoenix','Maricopa',33.4509,-111.974),('85117','AZ','Apache Junction','Maricopa',33.3277,-111.3259),('85118','AZ','Apache Junction','Pinal',33.333548,-111.416273),('85119','AZ','Apache Junction','Pinal',33.412356,-111.51851),('85120','AZ','Apache Junction','Pinal',33.416526,-111.569858),('85121','AZ','Bapchule','Pinal',33.124994,-111.896757),('85122','AZ','Casa Grande','Pinal',32.90564,-111.743399),('85123','AZ','Arizona City','Pinal',32.746666,-111.681005),('85127','AZ','Chandler Heights','Maricopa',33.3412,-111.6305),('85128','AZ','Coolidge','Pinal',32.971906,-111.523733),('85130','AZ','Casa Grande','Pinal',32.87941,-111.75032),('85131','AZ','Eloy','Pinal',32.723285,-111.572423),('85132','AZ','Florence','Pinal',33.007689,-111.344355),('85135','AZ','Hayden','Gila',33.004682,-110.788264),('85137','AZ','Kearny','Pinal',33.099801,-110.964575),('85138','AZ','Maricopa','Pinal',33.035517,-112.00648),('85139','AZ','Maricopa','Pinal',32.972868,-112.113066),('85140','AZ','San Tan Valley','Pinal',33.239057,-111.54371),('85141','AZ','Picacho','Pinal',32.687355,-111.453579),('85142','AZ','Queen Creek','Maricopa',33.217804,-111.638786),('85143','AZ','Queen Creek','Pinal',33.160691,-111.547488),('85145','AZ','Red Rock','Pinal',32.568638,-111.364196),('85147','AZ','Sacaton','Pinal',33.098599,-111.741273),('85172','AZ','Stanfield','Pinal',32.882258,-111.960018),('85173','AZ','Superior','Pinal',33.281148,-111.118602),('85178','AZ','Apache Junction','Maricopa',33.415,-111.5488),('85190','AZ','Tortilla Flat','Maricopa',33.452,-111.6365),('85191','AZ','Valley Farms','Pinal',32.9976,-111.4423),('85192','AZ','Winkelman','Pinal',32.970377,-110.729859),('85193','AZ','Casa Grande','Pinal',32.813854,-111.801313),('85194','AZ','Casa Grande','Pinal',32.901494,-111.638536),('85201','AZ','Mesa','Maricopa',33.431262,-111.850385),('85202','AZ','Mesa','Maricopa',33.383166,-111.875043),('85203','AZ','Mesa','Maricopa',33.438405,-111.804399),('85204','AZ','Mesa','Maricopa',33.398544,-111.783823),('85205','AZ','Mesa','Maricopa',33.427139,-111.71683),('85206','AZ','Mesa','Maricopa',33.402026,-111.721192),('85207','AZ','Mesa','Maricopa',33.436681,-111.642402),('85208','AZ','Mesa','Maricopa',33.404449,-111.625908),('85209','AZ','Mesa','Maricopa',33.378533,-111.641349),('85210','AZ','Mesa','Maricopa',33.389733,-111.843505),('85211','AZ','Mesa','Maricopa',33.4181,-111.8304),('85212','AZ','Mesa','Maricopa',33.327662,-111.635693),('85213','AZ','Mesa','Maricopa',33.435525,-111.768682),('85214','AZ','Mesa','Maricopa',33.4222,-111.8219),('85215','AZ','Mesa','Maricopa',33.4791,-111.682967),('85216','AZ','Mesa','Maricopa',33.4085,-111.6853),('85217','AZ','Apache Junction','Pinal',33.3277,-111.3259),('85218','AZ','Apache Junction','Pinal',33.3518,-111.4176),('85219','AZ','Apache Junction','Pinal',33.402969,-111.463379),('85220','AZ','Apache Junction','Pinal',33.416083,-111.576204),('85221','AZ','Bapchule','Pinal',33.126134,-111.905451),('85222','AZ','Casa Grande','Pinal',32.878138,-111.734993),('85223','AZ','Arizona City','Pinal',32.749664,-111.680225),('85224','AZ','Chandler','Maricopa',33.326503,-111.874068),('85225','AZ','Chandler','Maricopa',33.316311,-111.830895),('85226','AZ','Chandler','Maricopa',33.301214,-111.939764),('85227','AZ','Chandler Heights','Maricopa',33.3412,-111.6305),('85228','AZ','Coolidge','Pinal',32.967829,-111.526175),('85230','AZ','Casa Grande','Pinal',32.87941,-111.75032),('85231','AZ','Eloy','Pinal',32.712323,-111.576736),('85232','AZ','Florence','Pinal',32.961615,-111.316296),('85233','AZ','Gilbert','Maricopa',33.347866,-111.807926),('85234','AZ','Gilbert','Maricopa',33.364055,-111.742059),('85235','AZ','Hayden','Gila',32.995762,-110.780406),('85236','AZ','Higley','Maricopa',33.305783,-111.708355),('85237','AZ','Kearny','Pinal',33.09977,-110.972029),('85238','AZ','Maricopa','Pinal',33.0073,-111.9324),('85239','AZ','Maricopa','Pinal',33.022089,-112.047839),('85240','AZ','Queen Creek','Pinal',33.2286,-111.5322),('85241','AZ','Picacho','Pinal',32.712136,-111.499492),('85242','AZ','Queen Creek','Maricopa',33.227266,-111.610876),('85243','AZ','Queen Creek','Maricopa',33.1588,-111.5454),('85244','AZ','Chandler','Maricopa',33.3047,-111.8378),('85245','AZ','Red Rock','Pinal',32.623115,-111.376725),('85246','AZ','Chandler','Maricopa',33.3061,-111.8405),('85247','AZ','Sacaton','Pinal',33.107581,-111.751281),('85248','AZ','Chandler','Maricopa',33.224066,-111.863854),('85249','AZ','Chandler','Maricopa',33.224956,-111.795717),('85250','AZ','Scottsdale','Maricopa',33.522613,-111.90417),('85251','AZ','Scottsdale','Maricopa',33.494474,-111.922806),('85252','AZ','Scottsdale','Maricopa',33.4873,-111.9247),('85253','AZ','Paradise Valley','Maricopa',33.544829,-111.955813),('85254','AZ','Scottsdale','Maricopa',33.617756,-111.951184),('85255','AZ','Scottsdale','Maricopa',33.677113,-111.874316),('85256','AZ','Scottsdale','Maricopa',33.489686,-111.852393),('85257','AZ','Scottsdale','Maricopa',33.467365,-111.91715),('85258','AZ','Scottsdale','Maricopa',33.566249,-111.892307),('85259','AZ','Scottsdale','Maricopa',33.586333,-111.820821),('85260','AZ','Scottsdale','Maricopa',33.608829,-111.884984),('85261','AZ','Scottsdale','Maricopa',33.4946,-111.9204),('85262','AZ','Scottsdale','Maricopa',33.788355,-111.820157),('85263','AZ','Rio Verde','Maricopa',33.81585,-111.636484),('85264','AZ','Fort Mcdowell','Maricopa',33.605646,-111.595353),('85266','AZ','Scottsdale','Maricopa',33.772103,-111.926949),('85267','AZ','Scottsdale','Maricopa',33.6105,-111.8902),('85268','AZ','Fountain Hills','Maricopa',33.604688,-111.729734),('85269','AZ','Fountain Hills','Maricopa',33.6876,-111.8175),('85271','AZ','Scottsdale','Maricopa',33.4657,-111.92),('85272','AZ','Stanfield','Pinal',32.852769,-111.975644),('85273','AZ','Superior','Pinal',33.28591,-111.110159),('85274','AZ','Mesa','Maricopa',33.4073,-111.8829),('85275','AZ','Mesa','Maricopa',33.4222,-111.8219),('85277','AZ','Mesa','Maricopa',33.4591,-111.7199),('85278','AZ','Apache Junction','Pinal',33.415,-111.5488),('85279','AZ','Florence','Pinal',32.7996,-111.2141),('85280','AZ','Tempe','Maricopa',33.4273,-111.9307),('85281','AZ','Tempe','Maricopa',33.426663,-111.927773),('85282','AZ','Tempe','Maricopa',33.39139,-111.928247),('85283','AZ','Tempe','Maricopa',33.366196,-111.93161),('85284','AZ','Tempe','Maricopa',33.338294,-111.929498),('85285','AZ','Tempe','Maricopa',33.3926,-111.9352),('85286','AZ','Chandler','Maricopa',33.275822,-111.835743),('85287','AZ','Tempe','Maricopa',33.418,-111.9334),('85289','AZ','Tempe','Maricopa',33.4001,-111.9652),('85290','AZ','Tortilla Flat','Maricopa',33.452,-111.6365),('85291','AZ','Valley Farms','Pinal',32.9976,-111.4423),('85292','AZ','Winkelman','Gila',32.945838,-110.721984),('85293','AZ','Casa Grande','Pinal',32.8554,-111.7973),('85294','AZ','Casa Grande','Pinal',32.922,-111.619),('85295','AZ','Gilbert','Maricopa',33.309707,-111.73773),('85296','AZ','Gilbert','Maricopa',33.333921,-111.740128),('85297','AZ','Gilbert','Maricopa',33.278822,-111.726178),('85298','AZ','Gilbert','Maricopa',33.240303,-111.722121),('85299','AZ','Gilbert','Maricopa',33.3496,-111.7914),('85301','AZ','Glendale','Maricopa',33.531323,-112.17738),('85302','AZ','Glendale','Maricopa',33.568082,-112.177074),('85303','AZ','Glendale','Maricopa',33.531747,-112.218434),('85304','AZ','Glendale','Maricopa',33.595158,-112.175241),('85305','AZ','Glendale','Maricopa',33.533104,-112.253478),('85306','AZ','Glendale','Maricopa',33.624556,-112.17659),('85307','AZ','Glendale','Maricopa',33.534215,-112.316315),('85308','AZ','Glendale','Maricopa',33.660346,-112.183298),('85309','AZ','Glendale Luke Afb','Maricopa',33.536398,-112.363896),('85310','AZ','Glendale','Maricopa',33.699822,-112.176209),('85311','AZ','Glendale','Maricopa',33.532,-112.1764),('85312','AZ','Glendale','Maricopa',33.6252,-112.1839),('85313','AZ','Glendale','Maricopa',33.6086,-112.1611),('85318','AZ','Glendale','Maricopa',33.6821,-112.1862),('85320','AZ','Aguila','Maricopa',33.948172,-113.198336),('85321','AZ','Ajo','Pima',32.314192,-112.695674),('85322','AZ','Arlington','Maricopa',33.254168,-112.794079),('85323','AZ','Avondale','Maricopa',33.429339,-112.323154),('85324','AZ','Black Canyon City','Yavapai',34.092443,-112.12312),('85325','AZ','Bouse','La Paz',33.936666,-113.916081),('85326','AZ','Buckeye','Maricopa',33.363922,-112.579059),('85327','AZ','Cave Creek','Maricopa',33.8326,-111.9316),('85328','AZ','Cibola','La Paz',33.311571,-114.667744),('85329','AZ','Cashion','Maricopa',33.431242,-112.295885),('85331','AZ','Cave Creek','Maricopa',33.793887,-111.971045),('85332','AZ','Congress','Yavapai',34.161484,-112.863492),('85333','AZ','Dateland','Yuma',32.938572,-113.404886),('85334','AZ','Ehrenberg','La Paz',33.569841,-114.535304),('85335','AZ','El Mirage','Maricopa',33.602665,-112.323623),('85336','AZ','Gadsden','Yuma',32.553528,-114.786336),('85337','AZ','Gila Bend','Maricopa',32.977987,-112.789948),('85338','AZ','Goodyear','Maricopa',33.406237,-112.41273),('85339','AZ','Laveen','Maricopa',33.352014,-112.169199),('85340','AZ','Litchfield Park','Maricopa',33.509186,-112.385065),('85341','AZ','Lukeville','Pima',31.865946,-112.763977),('85342','AZ','Morristown','Maricopa',33.863007,-112.492219),('85343','AZ','Palo Verde','Maricopa',33.337531,-112.698685),('85344','AZ','Parker','La Paz',34.130248,-114.279768),('85345','AZ','Peoria','Maricopa',33.574565,-112.243889),('85346','AZ','Quartzsite','La Paz',33.651855,-114.217081),('85347','AZ','Roll','Yuma',32.779898,-113.84419),('85348','AZ','Salome','La Paz',33.720666,-113.683076),('85349','AZ','San Luis','Yuma',32.496543,-114.765691),('85350','AZ','Somerton','Yuma',32.584294,-114.703598),('85351','AZ','Sun City','Maricopa',33.602932,-112.281757),('85352','AZ','Tacna','Yuma',32.715516,-113.872556),('85353','AZ','Tolleson','Maricopa',33.427425,-112.26491),('85354','AZ','Tonopah','Maricopa',33.442226,-112.999055),('85355','AZ','Waddell','Maricopa',33.572395,-112.44828),('85356','AZ','Wellton','Yuma',32.673193,-114.13523),('85357','AZ','Wenden','La Paz',33.928947,-113.517477),('85358','AZ','Wickenburg','Maricopa',33.8041,-112.8875),('85359','AZ','Quartzsite','La Paz',33.6668,-114.22),('85360','AZ','Wikieup','Mohave',34.654766,-113.546032),('85361','AZ','Wittmann','Maricopa',33.752956,-112.602425),('85362','AZ','Yarnell','Yavapai',34.239825,-112.776332),('85363','AZ','Youngtown','Maricopa',33.585175,-112.304069),('85364','AZ','Yuma','Yuma',32.70078,-114.644755),('85365','AZ','Yuma','Yuma',32.715606,-114.508701),('85366','AZ','Yuma','Yuma',32.687,-114.6239),('85367','AZ','Yuma','Yuma',32.659862,-114.409517),('85369','AZ','Yuma','Yuma',32.7252,-114.6236),('85371','AZ','Poston','La Paz',33.809294,-114.390846),('85372','AZ','Sun City','Maricopa',33.638,-112.2723),('85373','AZ','Sun City','Maricopa',33.66443,-112.291286),('85374','AZ','Surprise','Maricopa',33.643513,-112.380397),('85375','AZ','Sun City West','Maricopa',33.672893,-112.360043),('85376','AZ','Sun City West','Maricopa',33.638,-112.2723),('85377','AZ','Carefree','Maricopa',33.823088,-111.913622),('85378','AZ','Surprise','Maricopa',33.6053,-112.2819),('85379','AZ','Surprise','Maricopa',33.606765,-112.378668),('85380','AZ','Peoria','Maricopa',33.5822,-112.2414),('85381','AZ','Peoria','Maricopa',33.6092,-112.230308),('85382','AZ','Peoria','Maricopa',33.65361,-112.245942),('85383','AZ','Peoria','Maricopa',33.737261,-112.272025),('85385','AZ','Peoria','Maricopa',33.6099,-112.2261),('85387','AZ','Surprise','Maricopa',33.705079,-112.424608),('85388','AZ','Surprise','Maricopa',33.621216,-112.436266),('85390','AZ','Wickenburg','Maricopa',33.953888,-112.818859),('85392','AZ','Avondale','Maricopa',33.47758,-112.308889),('85395','AZ','Goodyear','Maricopa',33.479983,-112.387619),('85396','AZ','Buckeye','Maricopa',33.486469,-112.587644),('85501','AZ','Globe','Gila',33.417144,-110.791731),('85502','AZ','Globe','Gila',33.5667,-110.7221),('85530','AZ','Bylas','Graham',33.138657,-110.164018),('85531','AZ','Central','Graham',32.870291,-109.789632),('85532','AZ','Claypool','Gila',33.4111,-110.8419),('85533','AZ','Clifton','Greenlee',33.155843,-109.30449),('85534','AZ','Duncan','Greenlee',32.754393,-109.135358),('85535','AZ','Eden','Graham',32.986305,-109.91267),('85536','AZ','Fort Thomas','Graham',33.045086,-109.986027),('85539','AZ','Miami','Gila',33.394997,-110.881568),('85540','AZ','Morenci','Greenlee',33.030982,-109.329379),('85541','AZ','Payson','Gila',34.224755,-111.295104),('85542','AZ','Peridot','Graham',33.269514,-110.456012),('85543','AZ','Pima','Graham',32.927992,-109.884241),('85544','AZ','Pine','Gila',34.38444,-111.477063),('85545','AZ','Roosevelt','Gila',33.58747,-111.063738),('85546','AZ','Safford','Graham',32.789512,-109.69778),('85547','AZ','Payson','Gila',34.0422,-111.0771),('85548','AZ','Safford','Graham',32.7042,-109.4719),('85550','AZ','San Carlos','Gila',33.449596,-110.514953),('85551','AZ','Solomon','Graham',32.801836,-109.623484),('85552','AZ','Thatcher','Graham',32.829672,-109.760468),('85553','AZ','Tonto Basin','Gila',33.795063,-111.247902),('85554','AZ','Young','Gila',34.082029,-110.920041),('85601','AZ','Arivaca','Pima',31.584303,-111.31191),('85602','AZ','Benson','Cochise',32.015674,-110.356783),('85603','AZ','Bisbee','Cochise',31.413565,-109.900664),('85605','AZ','Bowie','Cochise',32.322074,-109.485058),('85606','AZ','Cochise','Cochise',32.010508,-109.911233),('85607','AZ','Douglas','Cochise',31.404716,-109.529799),('85608','AZ','Douglas','Cochise',31.459758,-109.594727),('85609','AZ','Dragoon','Cochise',32.042289,-110.059379),('85610','AZ','Elfrida','Cochise',31.722007,-109.678547),('85611','AZ','Elgin','Santa Cruz',31.656193,-110.522003),('85613','AZ','Fort Huachuca','Cochise',31.560438,-110.358261),('85614','AZ','Green Valley','Pima',31.87338,-110.980066),('85615','AZ','Hereford','Cochise',31.407196,-110.19831),('85616','AZ','Huachuca City','Cochise',31.679161,-110.332917),('85617','AZ','Mc Neal','Cochise',31.561681,-109.682424),('85618','AZ','Mammoth','Pinal',32.708064,-110.644107),('85619','AZ','Mount Lemmon','Pima',32.420393,-110.732551),('85620','AZ','Naco','Cochise',31.337371,-109.94798),('85621','AZ','Nogales','Santa Cruz',31.385024,-110.929637),('85622','AZ','Green Valley','Pima',31.819386,-111.035398),('85623','AZ','Oracle','Pinal',32.626859,-110.773471),('85624','AZ','Patagonia','Santa Cruz',31.501674,-110.70668),('85625','AZ','Pearce','Cochise',31.920018,-109.767345),('85626','AZ','Pirtleville','Cochise',31.358994,-109.564598),('85627','AZ','Pomerene','Cochise',31.998455,-110.275637),('85628','AZ','Nogales','Santa Cruz',31.4437,-111.0206),('85629','AZ','Sahuarita','Pima',31.943224,-110.993022),('85630','AZ','Saint David','Cochise',31.894996,-110.209492),('85631','AZ','San Manuel','Pinal',32.600217,-110.603554),('85632','AZ','San Simon','Cochise',32.032892,-109.18534),('85633','AZ','Sasabe','Pima',31.58507,-111.505172),('85634','AZ','Sells','Pima',31.998935,-111.936597),('85635','AZ','Sierra Vista','Cochise',31.552695,-110.259147),('85636','AZ','Sierra Vista','Cochise',31.5544,-110.303),('85637','AZ','Sonoita','Santa Cruz',31.695605,-110.676378),('85638','AZ','Tombstone','Cochise',31.703943,-110.072231),('85639','AZ','Topawa','Pima',31.773676,-111.764943),('85640','AZ','Tumacacori','Santa Cruz',31.565303,-111.051099),('85641','AZ','Vail','Pima',31.988641,-110.689368),('85643','AZ','Willcox','Cochise',32.304208,-109.866004),('85644','AZ','Willcox','Cochise',32.2527,-109.8313),('85645','AZ','Amado','Pima',31.715777,-111.099993),('85646','AZ','Tubac','Santa Cruz',31.619922,-111.030512),('85648','AZ','Rio Rico','Santa Cruz',31.496709,-110.990827),('85650','AZ','Sierra Vista','Cochise',31.495145,-110.250781),('85652','AZ','Cortaro','Pima',32.3561,-111.0877),('85653','AZ','Marana','Pima',32.413816,-111.298931),('85654','AZ','Rillito','Pima',32.415175,-111.155142),('85655','AZ','Douglas','Cochise',31.4298,-109.3637),('85658','AZ','Marana','Pima',32.528369,-111.159601),('85662','AZ','Nogales','Santa Cruz',31.4388,-111.0029),('85670','AZ','Fort Huachuca','Cochise',31.5505,-110.2299),('85671','AZ','Sierra Vista','Cochise',31.3441,-109.5519),('85701','AZ','Tucson','Pima',32.21661,-110.969821),('85702','AZ','Tucson','Pima',32.2216,-110.9258),('85703','AZ','Tucson','Pima',32.2465,-110.9786),('85704','AZ','Tucson','Pima',32.330711,-110.986617),('85705','AZ','Tucson','Pima',32.260173,-110.98552),('85706','AZ','Tucson','Pima',32.148985,-110.939017),('85707','AZ','Tucson','Pima',32.181726,-110.885731),('85708','AZ','Tucson','Pima',32.181643,-110.865862),('85709','AZ','Tucson','Pima',32.2251,-111.0167),('85710','AZ','Tucson','Pima',32.21347,-110.825592),('85711','AZ','Tucson','Pima',32.215781,-110.885364),('85712','AZ','Tucson','Pima',32.249265,-110.886847),('85713','AZ','Tucson','Pima',32.194226,-110.975557),('85714','AZ','Tucson','Pima',32.170224,-110.95555),('85715','AZ','Tucson','Pima',32.249528,-110.82922),('85716','AZ','Tucson','Pima',32.241985,-110.923577),('85717','AZ','Tucson','Pima',32.2356,-110.9398),('85718','AZ','Tucson','Pima',32.313142,-110.921969),('85719','AZ','Tucson','Pima',32.240621,-110.948278),('85720','AZ','Tucson','Pima',32.2033,-110.9451),('85721','AZ','Tucson','Pima',32.2335,-110.9521),('85722','AZ','Tucson','Pima',32.2317,-110.9567),('85723','AZ','Tucson','Pima',32.1812,-110.9683),('85724','AZ','Tucson','Pima',32.2033,-110.9451),('85725','AZ','Tucson','Pima',32.2216,-110.9258),('85726','AZ','Tucson','Pima',32.2033,-110.9451),('85728','AZ','Tucson','Pima',32.2885,-110.9435),('85730','AZ','Tucson','Pima',32.179491,-110.810383),('85731','AZ','Tucson','Pima',32.2216,-110.9258),('85732','AZ','Tucson','Pima',32.225,-110.8833),('85733','AZ','Tucson','Pima',32.2356,-110.9398),('85734','AZ','Tucson','Pima',32.1336,-110.9741),('85735','AZ','Tucson','Pima',32.135324,-111.239928),('85736','AZ','Tucson','Pima',31.982841,-111.301601),('85737','AZ','Tucson','Pima',32.405729,-110.976952),('85738','AZ','Catalina','Pima',32.3298,-110.9848),('85739','AZ','Tucson','Pinal',32.556212,-110.933563),('85740','AZ','Tucson','Pima',32.3203,-110.9742),('85741','AZ','Tucson','Pima',32.334861,-111.041246),('85742','AZ','Tucson','Pima',32.381084,-111.053392),('85743','AZ','Tucson','Pima',32.336591,-111.152154),('85744','AZ','Tucson','Pima',32.0916,-110.8046),('85745','AZ','Tucson','Pima',32.244861,-111.024692),('85746','AZ','Tucson','Pima',32.13511,-111.021771),('85747','AZ','Tucson','Pima',32.107391,-110.776147),('85748','AZ','Tucson','Pima',32.215477,-110.77072),('85749','AZ','Tucson','Pima',32.276083,-110.766286),('85750','AZ','Tucson','Pima',32.294515,-110.838542),('85751','AZ','Tucson','Pima',32.2501,-110.8527),('85752','AZ','Tucson','Pima',32.3506,-111.0467),('85754','AZ','Tucson','Pima',32.2345,-111.0024),('85755','AZ','Tucson','Pima',32.453042,-110.975136),('85756','AZ','Tucson','Pima',32.105798,-110.900753),('85757','AZ','Tucson','Pima',32.13494,-111.100235),('85775','AZ','Tucson','Pima',32.2033,-110.9451),('85777','AZ','Tucson','Pima',32.0907,-110.9103),('85901','AZ','Show Low','Navajo',34.27457,-110.025361),('85902','AZ','Show Low','Navajo',34.249,-110.0441),('85911','AZ','Cibecue','Navajo',34.091219,-110.420857),('85912','AZ','White Mountain Lake','Navajo',34.404362,-109.959681),('85920','AZ','Alpine','Apache',33.844083,-109.137161),('85922','AZ','Blue','Greenlee',33.584843,-109.167578),('85923','AZ','Clay Springs','Navajo',34.340878,-110.334348),('85924','AZ','Concho','Apache',34.450343,-109.719375),('85925','AZ','Eagar','Apache',34.104946,-109.294863),('85926','AZ','Fort Apache','Navajo',33.79016,-109.985001),('85927','AZ','Greer','Apache',34.024798,-109.465955),('85928','AZ','Heber','Navajo',34.572072,-110.572497),('85929','AZ','Lakeside','Navajo',34.165156,-109.985871),('85930','AZ','Mcnary','Navajo',34.049485,-109.747605),('85931','AZ','Forest Lakes','Coconino',34.437027,-110.87148),('85932','AZ','Nutrioso','Apache',33.971681,-109.201341),('85933','AZ','Overgaard','Navajo',34.398196,-110.533542),('85934','AZ','Pinedale','Navajo',34.30054,-110.245695),('85935','AZ','Pinetop','Navajo',34.112836,-109.911739),('85936','AZ','Saint Johns','Apache',34.56993,-109.318775),('85937','AZ','Snowflake','Navajo',34.548182,-110.01932),('85938','AZ','Springerville','Apache',34.140034,-109.299084),('85939','AZ','Taylor','Navajo',34.454409,-110.098147),('85940','AZ','Vernon','Apache',34.270918,-109.734013),('85941','AZ','Whiteriver','Navajo',33.846252,-109.943866),('85942','AZ','Woodruff','Navajo',34.778649,-109.966975),('86001','AZ','Flagstaff','Coconino',35.186246,-111.65058),('86002','AZ','Flagstaff','Coconino',35.4861,-111.7438),('86003','AZ','Flagstaff','Coconino',35.203409,-111.220113),('86004','AZ','Flagstaff','Coconino',35.262536,-111.489203),('86011','AZ','Flagstaff','Coconino',35.183957,-111.655623),('86015','AZ','Bellemont','Coconino',35.231582,-111.827907),('86016','AZ','Gray Mountain','Coconino',35.754467,-111.5955),('86017','AZ','Munds Park','Coconino',34.914121,-111.643917),('86018','AZ','Parks','Coconino',35.256603,-111.955317),('86020','AZ','Cameron','Coconino',36.150922,-111.590884),('86021','AZ','Colorado City','Mohave',36.984112,-112.981949),('86022','AZ','Fredonia','Coconino',36.859024,-112.620287),('86023','AZ','Grand Canyon','Coconino',36.029701,-112.123884),('86024','AZ','Happy Jack','Coconino',34.672856,-111.256617),('86025','AZ','Holbrook','Navajo',34.909429,-110.138755),('86028','AZ','Petrified Forest Natl Pk','Apache',34.7914,-109.8788),('86029','AZ','Sun Valley','Navajo',34.982932,-110.031968),('86030','AZ','Hotevilla','Navajo',36.002625,-110.686781),('86031','AZ','Indian Wells','Navajo',35.458948,-110.075051),('86032','AZ','Joseph City','Navajo',34.967867,-110.32541),('86033','AZ','Kayenta','Navajo',36.614742,-110.206557),('86034','AZ','Keams Canyon','Navajo',35.761456,-110.104589),('86035','AZ','Leupp','Coconino',35.361472,-110.984173),('86036','AZ','Marble Canyon','Coconino',36.627867,-111.775441),('86038','AZ','Mormon Lake','Coconino',34.912121,-111.450233),('86039','AZ','Kykotsmovi Village','Navajo',36.066624,-110.509491),('86040','AZ','Page','Coconino',36.734699,-111.433537),('86042','AZ','Polacca','Navajo',35.83464,-110.384898),('86043','AZ','Second Mesa','Navajo',35.804028,-110.517851),('86044','AZ','Tonalea','Coconino',36.644182,-110.85919),('86045','AZ','Tuba City','Coconino',36.096336,-111.173732),('86046','AZ','Williams','Coconino',35.386928,-112.152802),('86047','AZ','Winslow','Navajo',35.221806,-110.602192),('86052','AZ','North Rim','Coconino',36.344653,-112.063649),('86053','AZ','Kaibeto','Coconino',36.592253,-111.095104),('86054','AZ','Shonto','Navajo',36.606118,-110.649684),('86301','AZ','Prescott','Yavapai',34.583352,-112.441408),('86302','AZ','Prescott','Yavapai',34.754,-112.8314),('86303','AZ','Prescott','Yavapai',34.51677,-112.453955),('86304','AZ','Prescott','Yavapai',34.7363,-112.9576),('86305','AZ','Prescott','Yavapai',34.676254,-112.629266),('86312','AZ','Prescott Valley','Yavapai',34.5878,-112.3218),('86313','AZ','Prescott','Yavapai',34.553923,-112.453215),('86314','AZ','Prescott Valley','Yavapai',34.603194,-112.329923),('86315','AZ','Prescott','Yavapai',34.688712,-112.304775),('86320','AZ','Ash Fork','Yavapai',35.252993,-112.531951),('86321','AZ','Bagdad','Yavapai',34.516414,-113.080271),('86322','AZ','Camp Verde','Yavapai',34.557003,-111.843708),('86323','AZ','Chino Valley','Yavapai',34.764933,-112.45018),('86324','AZ','Clarkdale','Yavapai',34.778063,-112.07501),('86325','AZ','Cornville','Yavapai',34.720473,-111.915136),('86326','AZ','Cottonwood','Yavapai',34.714633,-112.003142),('86327','AZ','Dewey','Yavapai',34.55517,-112.230844),('86329','AZ','Humboldt','Yavapai',34.485081,-112.251046),('86330','AZ','Iron Springs','Yavapai',34.673,-112.5211),('86331','AZ','Jerome','Yavapai',34.746766,-112.113703),('86332','AZ','Kirkland','Yavapai',34.3675,-112.682608),('86333','AZ','Mayer','Yavapai',34.349544,-112.156198),('86334','AZ','Paulden','Yavapai',34.915632,-112.507242),('86335','AZ','Rimrock','Yavapai',34.654718,-111.769178),('86336','AZ','Sedona','Yavapai',34.869957,-111.802856),('86337','AZ','Seligman','Yavapai',35.321383,-113.029628),('86338','AZ','Skull Valley','Yavapai',34.539789,-112.695257),('86339','AZ','Sedona','Coconino',34.8697,-111.7602),('86340','AZ','Sedona','Yavapai',34.858,-111.7867),('86341','AZ','Sedona','Yavapai',34.7775,-111.7625),('86342','AZ','Lake Montezuma','Yavapai',34.6322,-111.7772),('86343','AZ','Crown King','Yavapai',34.17306,-112.289776),('86351','AZ','Sedona','Yavapai',34.786055,-111.766647),('86401','AZ','Kingman','Mohave',35.219511,-113.911278),('86402','AZ','Kingman','Mohave',35.5711,-114.0964),('86403','AZ','Lake Havasu City','Mohave',34.482418,-114.336952),('86404','AZ','Lake Havasu City','Mohave',34.54637,-114.328185),('86405','AZ','Lake Havasu City','Mohave',34.4838,-114.3216),('86406','AZ','Lake Havasu City','Mohave',34.462356,-114.267176),('86409','AZ','Kingman','Mohave',35.298033,-114.028914),('86411','AZ','Hackberry','Mohave',35.321514,-113.665694),('86412','AZ','Hualapai','Mohave',35.5043,-113.8826),('86413','AZ','Golden Valley','Mohave',35.183765,-114.249206),('86426','AZ','Fort Mohave','Mohave',35.009116,-114.585515),('86427','AZ','Fort Mohave','Mohave',35.0081,-114.5628),('86429','AZ','Bullhead City','Mohave',35.183136,-114.528785),('86430','AZ','Bullhead City','Mohave',35.256802,-114.494519),('86431','AZ','Chloride','Mohave',35.39938,-114.214321),('86432','AZ','Littlefield','Mohave',36.671228,-113.737463),('86433','AZ','Oatman','Mohave',34.96246,-114.403234),('86434','AZ','Peach Springs','Mohave',35.567516,-113.493732),('86435','AZ','Supai','Coconino',36.165335,-112.627113),('86436','AZ','Topock','Mohave',34.75149,-114.444544),('86437','AZ','Valentine','Mohave',35.400621,-113.649562),('86438','AZ','Yucca','Mohave',34.754938,-114.045321),('86439','AZ','Bullhead City','Mohave',34.9237,-114.1302),('86440','AZ','Mohave Valley','Mohave',34.89516,-114.580017),('86441','AZ','Dolan Springs','Mohave',35.578887,-114.317169),('86442','AZ','Bullhead City','Mohave',35.09824,-114.597247),('86443','AZ','Temple Bar Marina','Mohave',36.023,-114.2943),('86444','AZ','Meadview','Mohave',35.921812,-114.082878),('86445','AZ','Willow Beach','Mohave',35.74384,-114.419206),('86446','AZ','Mohave Valley','Mohave',34.9237,-114.1302),('86502','AZ','Chambers','Apache',35.335836,-109.49172),('86503','AZ','Chinle','Apache',36.176802,-109.633763),('86504','AZ','Fort Defiance','Apache',35.864862,-109.121243),('86505','AZ','Ganado','Apache',35.6527,-109.671937),('86506','AZ','Houck','Apache',35.316146,-109.246864),('86507','AZ','Lukachukai','Apache',36.408345,-109.269357),('86508','AZ','Lupton','Apache',35.328981,-109.074109),('86510','AZ','Pinon','Navajo',36.114114,-110.193817),('86511','AZ','Saint Michaels','Apache',35.662092,-109.238147),('86512','AZ','Sanders','Apache',35.192785,-109.317388),('86514','AZ','Teec Nos Pos','Apache',36.912504,-109.31949),('86515','AZ','Window Rock','Apache',35.665394,-108.966527),('86520','AZ','Blue Gap','Apache',36.081065,-109.964736),('86535','AZ','Dennehotso','Apache',36.752622,-109.84723),('86538','AZ','Many Farms','Apache',36.38718,-109.593979),('86540','AZ','Nazlini','Apache',35.941004,-109.456809),('86544','AZ','Red Valley','Apache',36.605401,-109.119308),('86545','AZ','Rock Point','Apache',36.696616,-109.605798),('86547','AZ','Round Rock','Apache',36.502941,-109.464374),('86555','AZ','Douglas','Cochise',31.382775,-109.550354),('86556','AZ','Tsaile','Apache',36.277664,-109.213716),('87001','NM','Algodones','Sandoval',35.399425,-106.430872),('87002','NM','Belen','Valencia',34.64056,-106.744937),('87004','NM','Bernalillo','Sandoval',35.323364,-106.559549),('87005','NM','Bluewater','Cibola',35.262211,-107.96941),('87006','NM','Bosque','Socorro',34.495987,-106.812092),('87007','NM','Casa Blanca','Cibola',35.044957,-107.494992),('87008','NM','Cedar Crest','Bernalillo',35.134129,-106.371174),('87009','NM','Cedarvale','Torrance',34.4157,-105.6152),('87010','NM','Cerrillos','Santa Fe',35.415114,-106.136823),('87011','NM','Claunch','Lincoln',34.063892,-105.939289),('87012','NM','Coyote','Rio Arriba',36.11351,-106.657206),('87013','NM','Cuba','Sandoval',35.90306,-107.398854),('87014','NM','Cubero','Cibola',35.191031,-107.384875),('87015','NM','Edgewood','Santa Fe',35.081411,-106.192453),('87016','NM','Estancia','Torrance',34.816203,-106.083124),('87017','NM','Gallina','Rio Arriba',36.293164,-106.768368),('87018','NM','Counselor','Sandoval',36.121134,-107.474965),('87020','NM','Grants','Cibola',35.124617,-107.896842),('87021','NM','Milan','Cibola',35.180245,-107.892749),('87022','NM','Isleta','Bernalillo',34.903906,-106.699156),('87023','NM','Jarales','Valencia',34.600805,-106.756303),('87024','NM','Jemez Pueblo','Sandoval',35.633141,-106.727546),('87025','NM','Jemez Springs','Sandoval',35.856424,-106.643861),('87026','NM','Laguna','Cibola',34.971534,-107.255407),('87027','NM','La Jara','Sandoval',36.113854,-106.958827),('87028','NM','La Joya','Socorro',34.3664,-106.835528),('87029','NM','Lindrith','Rio Arriba',36.352991,-107.053587),('87031','NM','Los Lunas','Valencia',34.77974,-106.711787),('87032','NM','Mcintosh','Torrance',34.862981,-106.013281),('87034','NM','Pueblo Of Acoma','Cibola',34.842494,-107.603647),('87035','NM','Moriarty','Torrance',34.982092,-106.03271),('87036','NM','Mountainair','Torrance',34.469221,-106.254897),('87037','NM','Nageezi','San Juan',36.181096,-107.764656),('87038','NM','New Laguna','Cibola',35.074803,-107.439066),('87040','NM','Paguate','Cibola',35.134799,-107.379227),('87041','NM','Pena Blanca','Sandoval',35.614462,-106.328353),('87042','NM','Peralta','Valencia',34.82667,-106.687201),('87043','NM','Placitas','Sandoval',35.311944,-106.466793),('87044','NM','Ponderosa','Sandoval',35.661575,-106.664693),('87045','NM','Prewitt','Mckinley',35.382997,-108.040159),('87046','NM','Regina','Sandoval',36.255155,-106.911087),('87047','NM','Sandia Park','Bernalillo',35.220267,-106.285266),('87048','NM','Corrales','Sandoval',35.234071,-106.622332),('87049','NM','San Fidel','Cibola',35.09327,-107.603834),('87051','NM','San Rafael','Cibola',35.102865,-107.882967),('87052','NM','Santo Domingo Pueblo','Sandoval',35.515689,-106.344664),('87053','NM','San Ysidro','Sandoval',35.561246,-106.834552),('87056','NM','Stanley','Santa Fe',35.1945,-105.880761),('87059','NM','Tijeras','Bernalillo',35.038551,-106.318522),('87060','NM','Tome','Valencia',34.740708,-106.733629),('87061','NM','Torreon','Torrance',34.733612,-106.34948),('87062','NM','Veguita','Socorro',34.463958,-106.706127),('87063','NM','Willard','Torrance',34.540576,-105.993367),('87064','NM','Youngsville','Rio Arriba',36.179477,-106.555647),('87068','NM','Bosque Farms','Valencia',34.863042,-106.672235),('87070','NM','Clines Corners','Torrance',35.026895,-105.80485),('87072','NM','Cochiti Pueblo','Sandoval',35.616058,-106.351021),('87083','NM','Cochiti Lake','Sandoval',35.65245,-106.340131),('87101','NM','Albuquerque','Bernalillo',35.0936,-106.6423),('87102','NM','Albuquerque','Bernalillo',35.08417,-106.647822),('87103','NM','Albuquerque','Bernalillo',35.0826,-106.6526),('87104','NM','Albuquerque','Bernalillo',35.101785,-106.672431),('87105','NM','Albuquerque','Bernalillo',35.024115,-106.684424),('87106','NM','Albuquerque','Bernalillo',35.078194,-106.617654),('87107','NM','Albuquerque','Bernalillo',35.133546,-106.64071),('87108','NM','Albuquerque','Bernalillo',35.071895,-106.581369),('87109','NM','Albuquerque','Bernalillo',35.154608,-106.567669),('87110','NM','Albuquerque','Bernalillo',35.106392,-106.579287),('87111','NM','Albuquerque','Bernalillo',35.136685,-106.519753),('87112','NM','Albuquerque','Bernalillo',35.100667,-106.519419),('87113','NM','Albuquerque','Bernalillo',35.180965,-106.593631),('87114','NM','Albuquerque','Bernalillo',35.199592,-106.688648),('87115','NM','Albuquerque','Bernalillo',34.9241,-106.5088),('87116','NM','Albuquerque','Bernalillo',35.056047,-106.56142),('87117','NM','Kirtland Afb','Bernalillo',35.044186,-106.568445),('87119','NM','Albuquerque','Bernalillo',35.0844,-106.6505),('87120','NM','Albuquerque','Bernalillo',35.135503,-106.711152),('87121','NM','Albuquerque','Bernalillo',35.049336,-106.749599),('87122','NM','Albuquerque','Bernalillo',35.179272,-106.51819),('87123','NM','Albuquerque','Bernalillo',35.06765,-106.506557),('87124','NM','Rio Rancho','Sandoval',35.249863,-106.735375),('87125','NM','Albuquerque','Bernalillo',35.0936,-106.6423),('87131','NM','Albuquerque','Bernalillo',35.0862,-106.6213),('87144','NM','Rio Rancho','Sandoval',35.323641,-106.690582),('87151','NM','Albuquerque','Sandoval',35.0844,-106.6508),('87153','NM','Albuquerque','Bernalillo',35.0992,-106.5174),('87154','NM','Albuquerque','Bernalillo',35.1304,-106.5302),('87158','NM','Albuquerque','Bernalillo',35.0936,-106.6423),('87165','NM','Albuquerque','Sandoval',35.0859,-106.6453),('87174','NM','Rio Rancho','Bernalillo',35.2437,-106.6669),('87176','NM','Albuquerque','Bernalillo',35.1076,-106.5963),('87181','NM','Albuquerque','Bernalillo',35.101,-106.5153),('87184','NM','Albuquerque','Bernalillo',35.1849,-106.6202),('87185','NM','Albuquerque','Bernalillo',34.9821,-106.5156),('87187','NM','Albuquerque','Bernalillo',35.084021,-106.648646),('87190','NM','Albuquerque','Bernalillo',35.1076,-106.5963),('87191','NM','Albuquerque','Bernalillo',35.1304,-106.5302),('87192','NM','Albuquerque','Bernalillo',35.0992,-106.5174),('87193','NM','Albuquerque','Bernalillo',35.1881,-106.6826),('87194','NM','Albuquerque','Bernalillo',35.0844,-106.6505),('87195','NM','Albuquerque','Bernalillo',35.001,-106.6511),('87196','NM','Albuquerque','Bernalillo',35.0806,-106.6189),('87197','NM','Albuquerque','Bernalillo',35.1211,-106.6446),('87198','NM','Albuquerque','Bernalillo',35.0844,-106.6505),('87199','NM','Albuquerque','Bernalillo',35.1595,-106.5782),('87301','NM','Gallup','Mckinley',35.492966,-108.788071),('87302','NM','Gallup','Mckinley',35.4313,-108.7262),('87305','NM','Gallup','Mckinley',35.392041,-108.804682),('87310','NM','Brimhall','Mckinley',35.773274,-108.586157),('87311','NM','Church Rock','Mckinley',35.599875,-108.523996),('87312','NM','Continental Divide','Mckinley',35.444052,-108.313408),('87313','NM','Crownpoint','Mckinley',35.79835,-108.092948),('87315','NM','Fence Lake','Cibola',34.73675,-108.638781),('87316','NM','Fort Wingate','Mckinley',35.504912,-108.520967),('87317','NM','Gamerco','Mckinley',35.593514,-108.768845),('87319','NM','Mentmore','Mckinley',35.470437,-108.949504),('87320','NM','Mexican Springs','Mckinley',35.780557,-108.864336),('87321','NM','Ramah','Cibola',34.97687,-108.4219),('87322','NM','Rehoboth','Mckinley',35.527836,-108.644001),('87323','NM','Thoreau','Mckinley',35.460739,-108.194896),('87325','NM','Tohatchi','Mckinley',35.987252,-108.72485),('87326','NM','Vanderwagen','Mckinley',35.285122,-108.833901),('87327','NM','Zuni','Mckinley',35.000531,-108.775432),('87328','NM','Navajo','Mckinley',35.975528,-108.993354),('87347','NM','Jamestown','Mckinley',35.461297,-108.445235),('87357','NM','Pinehill','Cibola',34.92375,-108.366943),('87364','NM','Sheep Springs','San Juan',36.127312,-108.741427),('87365','NM','Smith Lake','Mckinley',35.7733,-107.9882),('87375','NM','Yatahey','Mckinley',35.655341,-108.777084),('87401','NM','Farmington','San Juan',36.736829,-108.1955),('87402','NM','Farmington','San Juan',36.770961,-108.146398),('87410','NM','Aztec','San Juan',36.835378,-107.948728),('87412','NM','Blanco','San Juan',36.696221,-107.690132),('87413','NM','Bloomfield','San Juan',36.554503,-107.981331),('87415','NM','Flora Vista','San Juan',36.811276,-108.091935),('87416','NM','Fruitland','San Juan',36.726418,-108.416238),('87417','NM','Kirtland','San Juan',36.74205,-108.347514),('87418','NM','La Plata','San Juan',36.937752,-108.162261),('87419','NM','Navajo Dam','San Juan',36.849838,-107.621847),('87420','NM','Shiprock','San Juan',36.747854,-108.820514),('87421','NM','Waterflow','San Juan',36.752603,-108.517799),('87455','NM','Newcomb','San Juan',36.291752,-108.72052),('87461','NM','Sanostee','San Juan',36.315461,-108.928884),('87499','NM','Farmington','San Juan',36.369618,-108.204492),('87501','NM','Santa Fe','Santa Fe',35.700921,-105.931913),('87502','NM','Santa Fe','Santa Fe',35.8099,-105.985),('87503','NM','Santa Fe','Santa Fe',35.7946,-105.9929),('87504','NM','Santa Fe','Santa Fe',35.8099,-105.985),('87505','NM','Santa Fe','Santa Fe',35.649517,-105.940886),('87506','NM','Santa Fe','Santa Fe',35.826601,-106.011505),('87507','NM','Santa Fe','Santa Fe',35.632207,-106.045046),('87508','NM','Santa Fe','Santa Fe',35.556656,-105.965378),('87509','NM','Santa Fe','Santa Fe',35.7946,-105.9929),('87510','NM','Abiquiu','Rio Arriba',36.269984,-106.38588),('87511','NM','Alcalde','Rio Arriba',36.112035,-106.026051),('87512','NM','Amalia','Taos',36.957022,-105.428064),('87513','NM','Arroyo Hondo','Taos',36.539491,-105.681451),('87514','NM','Arroyo Seco','Taos',36.528633,-105.573251),('87515','NM','Canjilon','Rio Arriba',36.476937,-106.407569),('87516','NM','Canones','Rio Arriba',36.17145,-106.443257),('87517','NM','Carson','Taos',36.432781,-105.796952),('87518','NM','Cebolla','Rio Arriba',36.500827,-106.54996),('87519','NM','Cerro','Taos',36.76256,-105.626121),('87520','NM','Chama','Rio Arriba',36.871058,-106.594532),('87521','NM','Chamisal','Taos',36.122588,-105.754417),('87522','NM','Chimayo','Rio Arriba',35.989228,-105.915584),('87523','NM','Cordova','Rio Arriba',36.006846,-105.855927),('87524','NM','Costilla','Taos',36.955239,-105.589022),('87525','NM','Taos Ski Valley','Taos',36.595871,-105.446728),('87527','NM','Dixon','Rio Arriba',36.184193,-105.857011),('87528','NM','Dulce','Rio Arriba',36.723401,-107.017734),('87529','NM','El Prado','Taos',36.45818,-105.609602),('87530','NM','El Rito','Rio Arriba',36.350196,-106.202757),('87531','NM','Embudo','Rio Arriba',36.223806,-105.866163),('87532','NM','Espanola','Rio Arriba',35.993323,-106.073792),('87533','NM','Espanola','Rio Arriba',36.024348,-106.065596),('87535','NM','Glorieta','Santa Fe',35.541056,-105.751832),('87537','NM','Hernandez','Rio Arriba',36.083102,-106.138323),('87538','NM','Ilfeld','San Miguel',35.472528,-105.558413),('87539','NM','La Madera','Rio Arriba',36.396913,-106.039367),('87540','NM','Lamy','Santa Fe',35.44914,-105.908741),('87543','NM','Llano','Taos',36.136494,-105.680012),('87544','NM','Los Alamos','Los Alamos',35.868037,-106.287322),('87545','NM','Los Alamos','Los Alamos',35.888,-106.3063),('87548','NM','Medanales','Rio Arriba',36.175026,-106.18915),('87549','NM','Ojo Caliente','Rio Arriba',36.188774,-106.064294),('87551','NM','Los Ojos','Rio Arriba',36.695876,-106.661926),('87552','NM','Pecos','San Miguel',35.612482,-105.642715),('87553','NM','Penasco','Taos',36.18184,-105.705922),('87554','NM','Petaca','Rio Arriba',36.491214,-106.009118),('87556','NM','Questa','Taos',36.73893,-105.578286),('87557','NM','Ranchos De Taos','Taos',36.347815,-105.636064),('87558','NM','Red River','Taos',36.694822,-105.368747),('87560','NM','Ribera','San Miguel',35.266005,-105.514727),('87562','NM','Rowe','San Miguel',35.426364,-105.680934),('87564','NM','San Cristobal','Taos',36.61156,-105.644961),('87565','NM','San Jose','San Miguel',35.424594,-105.510895),('87566','NM','Ohkay Owingeh','Rio Arriba',36.069365,-106.080558),('87567','NM','Santa Cruz','Santa Fe',35.991271,-106.030192),('87569','NM','Serafina','San Miguel',35.365887,-105.316666),('87571','NM','Taos','Taos',36.406972,-105.577808),('87573','NM','Tererro','San Miguel',35.795217,-105.657999),('87574','NM','Tesuque','Santa Fe',35.823444,-105.894585),('87575','NM','Tierra Amarilla','Rio Arriba',36.711173,-106.493758),('87576','NM','Trampas','Taos',36.1311,-105.7583),('87577','NM','Tres Piedras','Taos',36.62615,-105.912958),('87578','NM','Truchas','Rio Arriba',36.047784,-105.77073),('87579','NM','Vadito','Taos',36.162694,-105.597926),('87580','NM','Valdez','Taos',36.553167,-105.594708),('87581','NM','Vallecitos','Rio Arriba',36.51348,-106.139632),('87582','NM','Velarde','Rio Arriba',36.149772,-105.992602),('87583','NM','Villanueva','San Miguel',35.245135,-105.354066),('87592','NM','Santa Fe','Santa Fe',35.7946,-105.9929),('87594','NM','Santa Fe','Santa Fe',35.7946,-105.9929),('87701','NM','Las Vegas','San Miguel',35.563907,-105.165729),('87710','NM','Angel Fire','Colfax',36.387587,-105.271014),('87711','NM','Anton Chico','Guadalupe',35.216714,-105.128674),('87712','NM','Buena Vista','Mora',35.891133,-105.18562),('87713','NM','Chacon','Mora',36.150205,-105.356166),('87714','NM','Cimarron','Colfax',36.514658,-104.954822),('87715','NM','Cleveland','Mora',36.00602,-105.398192),('87718','NM','Eagle Nest','Colfax',36.588778,-105.271948),('87722','NM','Guadalupita','Mora',36.163667,-105.234353),('87723','NM','Holman','Mora',36.048352,-105.3834),('87724','NM','La Loma','Guadalupe',35.173408,-104.982722),('87728','NM','Maxwell','Colfax',36.571119,-104.583443),('87729','NM','Miami','Colfax',36.350205,-104.793958),('87730','NM','Mills','Harding',36.145782,-104.214519),('87731','NM','Montezuma','San Miguel',35.700866,-105.39903),('87732','NM','Mora','Mora',35.944221,-105.34382),('87733','NM','Mosquero','Harding',35.795009,-103.889345),('87734','NM','Ocate','Mora',36.196744,-105.083519),('87735','NM','Ojo Feliz','Mora',36.068636,-105.126697),('87736','NM','Rainsville','Mora',35.964139,-105.178975),('87740','NM','Raton','Colfax',36.801909,-104.405796),('87742','NM','Rociada','San Miguel',35.854782,-105.424992),('87743','NM','Roy','Harding',36.001901,-104.039519),('87745','NM','Sapello','San Miguel',35.786772,-105.260979),('87746','NM','Solano','San Miguel',35.67522,-104.189944),('87747','NM','Springer','Colfax',36.355961,-104.491046),('87749','NM','Ute Park','Colfax',36.558862,-105.117771),('87750','NM','Valmora','Mora',35.827845,-104.936139),('87752','NM','Wagon Mound','Mora',36.025144,-104.649009),('87753','NM','Watrous','Mora',35.832472,-104.960657),('87801','NM','Socorro','Socorro',34.062217,-106.888774),('87820','NM','Aragon','Catron',33.876988,-108.570825),('87821','NM','Datil','Catron',33.999744,-107.983596),('87823','NM','Lemitar','Socorro',34.181791,-106.912369),('87824','NM','Luna','Catron',33.849025,-108.973566),('87825','NM','Magdalena','Socorro',34.05732,-107.539799),('87827','NM','Pie Town','Catron',34.382144,-108.133599),('87828','NM','Polvadera','Socorro',34.204936,-106.921001),('87829','NM','Quemado','Catron',34.323461,-108.634873),('87830','NM','Reserve','Catron',33.722402,-108.760525),('87831','NM','San Acacia','Socorro',34.238556,-106.917929),('87832','NM','San Antonio','Socorro',33.856552,-106.856546),('87901','NM','Truth Or Consequences','Sierra',33.164677,-107.259062),('87930','NM','Arrey','Sierra',32.846954,-107.325582),('87931','NM','Caballo','Sierra',32.97013,-107.345667),('87933','NM','Derry','Sierra',32.789578,-107.280301),('87935','NM','Elephant Butte','Sierra',33.211102,-107.220581),('87936','NM','Garfield','Dona Ana',32.761182,-107.275135),('87937','NM','Hatch','Dona Ana',32.65862,-107.177769),('87939','NM','Monticello','Sierra',33.401664,-107.455756),('87940','NM','Rincon','Dona Ana',32.629936,-107.033573),('87941','NM','Salem','Dona Ana',32.705451,-107.219946),('87942','NM','Williamsburg','Sierra',33.112619,-107.37063),('87943','NM','Winston','Sierra',33.338539,-107.681986),('88001','NM','Las Cruces','Dona Ana',32.300428,-106.76012),('88002','NM','White Sands Missile Range','Dona Ana',32.405142,-106.450066),('88003','NM','Las Cruces','Dona Ana',32.284248,-106.748533),('88004','NM','Las Cruces','Dona Ana',32.223096,-106.987431),('88005','NM','Las Cruces','Dona Ana',32.291991,-106.789912),('88006','NM','Las Cruces','Dona Ana',32.3113,-106.7771),('88007','NM','Las Cruces','Dona Ana',32.346679,-106.883812),('88008','NM','Santa Teresa','Dona Ana',31.847388,-106.654507),('88009','NM','Playas','Hidalgo',31.949678,-108.545375),('88011','NM','Las Cruces','Dona Ana',32.327691,-106.712017),('88012','NM','Las Cruces','Dona Ana',32.433895,-106.727622),('88013','NM','Las Cruces','Dona Ana',32.3132,-106.7775),('88020','NM','Animas','Hidalgo',31.860293,-108.838082),('88021','NM','Anthony','Dona Ana',31.98101,-106.716145),('88022','NM','Arenas Valley','Grant',32.778414,-108.177093),('88023','NM','Bayard','Grant',32.764605,-108.128384),('88024','NM','Berino','Dona Ana',32.067365,-106.634164),('88025','NM','Buckhorn','Grant',33.046807,-108.743434),('88026','NM','Santa Clara','Grant',32.773483,-108.153511),('88027','NM','Chamberino','Dona Ana',32.037006,-106.691355),('88028','NM','Cliff','Grant',32.947605,-108.624411),('88029','NM','Columbus','Luna',31.833892,-107.649276),('88030','NM','Deming','Luna',32.191897,-107.712297),('88031','NM','Deming','Luna',32.4106,-107.7429),('88032','NM','Dona Ana','Dona Ana',32.390652,-106.808795),('88033','NM','Fairacres','Dona Ana',32.298914,-107.001636),('88034','NM','Faywood','Grant',32.616525,-107.901811),('88036','NM','Fort Bayard','Grant',32.815317,-108.150868),('88038','NM','Gila','Grant',32.970161,-108.494954),('88039','NM','Glenwood','Catron',33.330362,-108.862076),('88040','NM','Hachita','Grant',31.684653,-108.460174),('88041','NM','Hanover','Grant',32.781282,-108.041017),('88042','NM','Hillsboro','Sierra',32.82191,-107.542957),('88043','NM','Hurley','Grant',32.683667,-108.126795),('88044','NM','La Mesa','Dona Ana',32.134283,-106.717561),('88045','NM','Lordsburg','Hidalgo',32.351933,-108.733928),('88046','NM','Mesilla','Dona Ana',32.26372,-106.800522),('88047','NM','Mesilla Park','Dona Ana',32.210992,-106.715652),('88048','NM','Mesquite','Dona Ana',32.151506,-106.663997),('88049','NM','Mimbres','Grant',32.930697,-108.012438),('88051','NM','Mule Creek','Grant',32.999155,-108.920335),('88052','NM','Organ','Dona Ana',32.425626,-106.602349),('88053','NM','Pinos Altos','Grant',32.874009,-108.216675),('88054','NM','Radium Springs','Dona Ana',32.6413,-107.0679),('88055','NM','Redrock','Grant',32.735566,-108.706565),('88056','NM','Rodeo','Hidalgo',31.877239,-109.012856),('88058','NM','San Miguel','Dona Ana',31.9715,-106.9649),('88061','NM','Silver City','Grant',32.719737,-108.285867),('88062','NM','Silver City','Grant',33.0196,-108.2766),('88063','NM','Sunland Park','Dona Ana',31.807585,-106.579312),('88065','NM','Tyrone','Grant',32.708574,-108.30497),('88072','NM','Vado','Dona Ana',32.129933,-106.635837),('88081','NM','Chaparral','Otero',32.061634,-106.40345),('88101','NM','Clovis','Curry',34.4413,-103.222824),('88102','NM','Clovis','Curry',34.5182,-103.2534),('88103','NM','Cannon Afb','Curry',34.391046,-103.30979),('88112','NM','Broadview','Curry',34.848601,-103.16437),('88113','NM','Causey','Roosevelt',33.835134,-103.098543),('88114','NM','Crossroads','Lea',33.537845,-103.266349),('88115','NM','Dora','Roosevelt',33.925856,-103.33851),('88116','NM','Elida','Roosevelt',33.917686,-103.99353),('88118','NM','Floyd','Roosevelt',34.226834,-103.636275),('88119','NM','Fort Sumner','Debaca',34.334994,-104.277947),('88120','NM','Grady','Curry',34.872599,-103.398091),('88121','NM','House','Quay',34.706942,-103.974594),('88122','NM','Kenna','Roosevelt',33.8956,-103.6191),('88123','NM','Lingo','Roosevelt',33.6721,-103.1647),('88124','NM','Melrose','Curry',34.558091,-103.617002),('88125','NM','Milnesand','Roosevelt',33.647718,-103.268512),('88126','NM','Pep','Roosevelt',33.843479,-103.370725),('88130','NM','Portales','Roosevelt',34.173509,-103.339189),('88132','NM','Rogers','Roosevelt',33.914861,-103.195648),('88133','NM','Saint Vrain','Curry',34.3907,-103.4482),('88134','NM','Taiban','Debaca',34.313231,-104.015473),('88135','NM','Texico','Curry',34.510828,-103.068678),('88136','NM','Yeso','Debaca',34.529623,-104.745274),('88201','NM','Roswell','Chaves',33.557946,-104.472106),('88202','NM','Roswell','Chaves',33.3967,-104.5255),('88203','NM','Roswell','Chaves',33.304266,-104.434509),('88210','NM','Artesia','Eddy',32.80029,-104.332165),('88211','NM','Artesia','Eddy',32.7502,-104.2752),('88213','NM','Caprock','Lea',33.455761,-103.638431),('88220','NM','Carlsbad','Eddy',32.375588,-104.267557),('88221','NM','Carlsbad','Eddy',32.3237,-104.4355),('88230','NM','Dexter','Chaves',33.208658,-104.396941),('88231','NM','Eunice','Lea',32.453799,-103.220199),('88232','NM','Hagerman','Chaves',33.095955,-104.414552),('88240','NM','Hobbs','Lea',32.716835,-103.310832),('88241','NM','Hobbs','Lea',32.6261,-103.3305),('88242','NM','Hobbs','Lea',32.787092,-103.15247),('88244','NM','Hobbs','Lea',32.6261,-103.3305),('88250','NM','Hope','Eddy',32.735852,-104.888064),('88252','NM','Jal','Lea',32.188307,-103.26865),('88253','NM','Lake Arthur','Chaves',33.015566,-104.399341),('88254','NM','Lakewood','Eddy',32.605072,-104.438607),('88255','NM','Loco Hills','Eddy',32.816563,-103.988608),('88256','NM','Loving','Eddy',32.23763,-103.976121),('88260','NM','Lovington','Lea',32.961619,-103.366654),('88262','NM','Mc Donald','Lea',33.143421,-103.416472),('88263','NM','Malaga','Eddy',32.177161,-104.060202),('88264','NM','Maljamar','Lea',32.878526,-103.713994),('88265','NM','Monument','Lea',32.616622,-103.29426),('88267','NM','Tatum','Lea',33.302947,-103.466124),('88268','NM','Whites City','Eddy',32.188634,-104.361534),('88301','NM','Carrizozo','Lincoln',33.816236,-105.787545),('88310','NM','Alamogordo','Otero',32.877203,-105.971272),('88311','NM','Alamogordo','Otero',32.807706,-105.985984),('88312','NM','Alto','Lincoln',33.424,-105.638743),('88314','NM','Bent','Otero',33.14559,-105.854067),('88316','NM','Capitan','Lincoln',33.72116,-105.412025),('88317','NM','Cloudcroft','Otero',32.942848,-105.686344),('88318','NM','Corona','Lincoln',34.206649,-105.397596),('88321','NM','Encino','Torrance',34.822679,-105.440908),('88323','NM','Fort Stanton','Lincoln',33.493231,-105.528526),('88324','NM','Glencoe','Lincoln',33.413857,-105.440241),('88325','NM','High Rolls Mountain Park','Otero',32.919893,-105.827322),('88330','NM','Holloman Air Force Base','Otero',32.835488,-106.07952),('88336','NM','Hondo','Lincoln',33.365932,-105.324475),('88337','NM','La Luz','Otero',32.988236,-105.915754),('88338','NM','Lincoln','Lincoln',33.493261,-105.386238),('88339','NM','Mayhill','Otero',32.916021,-105.338757),('88340','NM','Mescalero','Otero',33.185453,-105.708193),('88341','NM','Nogal','Lincoln',33.52065,-105.721774),('88342','NM','Orogrande','Otero',32.378807,-106.093796),('88343','NM','Picacho','Lincoln',33.264871,-105.108766),('88344','NM','Pinon','Otero',32.558694,-105.292323),('88345','NM','Ruidoso','Lincoln',33.345489,-105.665857),('88346','NM','Ruidoso Downs','Lincoln',33.340876,-105.573377),('88347','NM','Sacramento','Otero',32.786046,-105.618983),('88348','NM','San Patricio','Lincoln',33.410013,-105.349551),('88349','NM','Sunspot','Otero',32.779277,-105.802258),('88350','NM','Timberon','Otero',32.62711,-105.692078),('88351','NM','Tinnie','Lincoln',33.496206,-105.075263),('88352','NM','Tularosa','Otero',33.022755,-106.050001),('88353','NM','Vaughn','Guadalupe',34.572326,-105.146652),('88354','NM','Weed','Otero',32.755149,-105.494343),('88355','NM','Ruidoso','Lincoln',33.3881,-105.6454),('88401','NM','Tucumcari','Quay',35.153484,-103.750661),('88410','NM','Amistad','Union',35.874994,-103.319646),('88411','NM','Bard','Quay',35.153869,-103.1622),('88414','NM','Capulin','Union',36.746547,-104.002206),('88415','NM','Clayton','Union',36.362813,-103.225185),('88416','NM','Conchas Dam','San Miguel',35.379519,-104.205285),('88417','NM','Cuervo','Guadalupe',35.047525,-104.376304),('88418','NM','Des Moines','Union',36.734657,-103.687569),('88419','NM','Folsom','Union',36.883924,-103.571965),('88421','NM','Garita','San Miguel',35.313786,-104.475675),('88422','NM','Gladstone','Union',36.34661,-104.033575),('88424','NM','Grenville','Union',36.459783,-103.641428),('88426','NM','Logan','Quay',35.429646,-103.465602),('88427','NM','Mc Alister','Quay',34.77237,-103.784983),('88430','NM','Nara Visa','Quay',35.627125,-103.174954),('88431','NM','Newkirk','Guadalupe',35.122446,-104.266956),('88433','NM','Quay','Quay',34.968,-103.8131),('88434','NM','San Jon','Quay',35.128803,-103.3326),('88435','NM','Santa Rosa','Guadalupe',34.9223,-104.704409),('88436','NM','Sedan','Union',36.129801,-103.123411),('88439','NM','Trementina','San Miguel',35.6068,-104.59),('88510','TX','El Paso','El Paso',31.7691,-106.4264),('88511','TX','El Paso','El Paso',31.7691,-106.4264),('88512','TX','El Paso','El Paso',31.7691,-106.4264),('88513','TX','El Paso','El Paso',31.7691,-106.4264),('88514','TX','El Paso','El Paso',31.7691,-106.4264),('88515','TX','El Paso','El Paso',31.7691,-106.4264),('88516','TX','El Paso','El Paso',31.7691,-106.4264),('88517','TX','El Paso','El Paso',31.7691,-106.4264),('88518','TX','El Paso','El Paso',31.7691,-106.4264),('88519','TX','El Paso','El Paso',31.7691,-106.4264),('88520','TX','El Paso','El Paso',31.7691,-106.4264),('88521','TX','El Paso','El Paso',31.7691,-106.4264),('88523','TX','El Paso','El Paso',31.7691,-106.4264),('88524','TX','El Paso','El Paso',31.7691,-106.4264),('88525','TX','El Paso','El Paso',31.7691,-106.4264),('88526','TX','El Paso','El Paso',31.7691,-106.4264),('88527','TX','El Paso','El Paso',31.7691,-106.4264),('88528','TX','El Paso','El Paso',31.7691,-106.4264),('88529','TX','El Paso','El Paso',31.7691,-106.4264),('88530','TX','El Paso','El Paso',31.7691,-106.4264),('88531','TX','El Paso','El Paso',31.7691,-106.4264),('88532','TX','El Paso','El Paso',31.7691,-106.4264),('88533','TX','El Paso','El Paso',31.7691,-106.4264),('88534','TX','El Paso','El Paso',31.7691,-106.4264),('88535','TX','El Paso','El Paso',31.7691,-106.4264),('88536','TX','El Paso','El Paso',31.7691,-106.4264),('88538','TX','El Paso','El Paso',31.7691,-106.4264),('88539','TX','El Paso','El Paso',31.7691,-106.4264),('88540','TX','El Paso','El Paso',31.7691,-106.4264),('88541','TX','El Paso','El Paso',31.7691,-106.4264),('88542','TX','El Paso','El Paso',31.7691,-106.4264),('88543','TX','El Paso','El Paso',31.7691,-106.4264),('88544','TX','El Paso','El Paso',31.7691,-106.4264),('88545','TX','El Paso','El Paso',31.7691,-106.4264),('88546','TX','El Paso','El Paso',31.7691,-106.4264),('88547','TX','El Paso','El Paso',31.7691,-106.4264),('88548','TX','El Paso','El Paso',31.7691,-106.4264),('88549','TX','El Paso','El Paso',31.7691,-106.4264),('88550','TX','El Paso','El Paso',31.7691,-106.4264),('88553','TX','El Paso','El Paso',31.7691,-106.4264),('88554','TX','El Paso','El Paso',31.7691,-106.4264),('88555','TX','El Paso','El Paso',31.7691,-106.4264),('88556','TX','El Paso','El Paso',31.7691,-106.4264),('88557','TX','El Paso','El Paso',31.7691,-106.4264),('88558','TX','El Paso','El Paso',31.7691,-106.4264),('88559','TX','El Paso','El Paso',31.7691,-106.4264),('88560','TX','El Paso','El Paso',31.7691,-106.4264),('88561','TX','El Paso','El Paso',31.7691,-106.4264),('88562','TX','El Paso','El Paso',31.7691,-106.4264),('88563','TX','El Paso','El Paso',31.7691,-106.4264),('88565','TX','El Paso','El Paso',31.7691,-106.4264),('88566','TX','El Paso','El Paso',31.7691,-106.4264),('88567','TX','El Paso','El Paso',31.7691,-106.4264),('88568','TX','El Paso','El Paso',31.7691,-106.4264),('88569','TX','El Paso','El Paso',31.7691,-106.4264),('88570','TX','El Paso','El Paso',31.7691,-106.4264),('88571','TX','El Paso','El Paso',31.7691,-106.4264),('88572','TX','El Paso','El Paso',31.7691,-106.4264),('88573','TX','El Paso','El Paso',31.7691,-106.4264),('88574','TX','El Paso','El Paso',31.7691,-106.4264),('88575','TX','El Paso','El Paso',31.7691,-106.4264),('88576','TX','El Paso','El Paso',31.7691,-106.4264),('88577','TX','El Paso','El Paso',31.7691,-106.4264),('88578','TX','El Paso','El Paso',31.7691,-106.4264),('88579','TX','El Paso','El Paso',31.7691,-106.4264),('88580','TX','El Paso','El Paso',31.7691,-106.4264),('88581','TX','El Paso','El Paso',31.7691,-106.4264),('88582','TX','El Paso','El Paso',31.7691,-106.4264),('88583','TX','El Paso','El Paso',31.7691,-106.4264),('88584','TX','El Paso','El Paso',31.7691,-106.4264),('88585','TX','El Paso','El Paso',31.7691,-106.4264),('88586','TX','El Paso','El Paso',31.7691,-106.4264),('88587','TX','El Paso','El Paso',31.7691,-106.4264),('88588','TX','El Paso','El Paso',31.7691,-106.4264),('88589','TX','El Paso','El Paso',31.8102,-106.4167),('88590','TX','El Paso','El Paso',31.7691,-106.4264),('88595','TX','El Paso','El Paso',31.7691,-106.4264),('88901','NV','The Lakes','Clark',36.175,-115.1363),('88905','NV','The Lakes','Clark',36.175,-115.1363),('89001','NV','Alamo','Lincoln',37.388995,-115.278318),('89002','NV','Henderson','Clark',36.001138,-114.955696),('89003','NV','Beatty','Nye',36.983171,-116.757403),('89004','NV','Blue Diamond','Clark',36.051125,-115.410435),('89005','NV','Boulder City','Clark',35.986984,-114.839563),('89006','NV','Boulder City','Clark',35.9191,-114.8177),('89007','NV','Bunkerville','Clark',36.716901,-114.15805),('89008','NV','Caliente','Lincoln',37.469936,-114.479808),('89009','NV','Henderson','Clark',36.0938,-114.9445),('89010','NV','Dyer','Esmeralda',37.716862,-118.06293),('89011','NV','Henderson','Clark',36.071879,-114.994792),('89012','NV','Henderson','Clark',36.017226,-115.052489),('89013','NV','Goldfield','Esmeralda',37.679456,-117.282122),('89014','NV','Henderson','Clark',36.060164,-115.064239),('89015','NV','Henderson','Clark',36.034913,-114.967979),('89016','NV','Henderson','Clark',36.0698,-115.0811),('89017','NV','Hiko','Lincoln',37.613147,-115.221132),('89018','NV','Indian Springs','Clark',36.570882,-115.671348),('89019','NV','Jean','Clark',35.776489,-115.644023),('89020','NV','Amargosa Valley','Nye',36.532633,-116.447705),('89021','NV','Logandale','Clark',36.599477,-114.471055),('89022','NV','Manhattan','Nye',38.541598,-116.949085),('89023','NV','Mercury','Nye',37.1603,-116.2327),('89024','NV','Mesquite','Clark',36.789432,-114.010425),('89025','NV','Moapa','Clark',36.678947,-114.676883),('89026','NV','Jean','Clark',35.777376,-115.272406),('89027','NV','Mesquite','Clark',36.811155,-114.087016),('89028','NV','Laughlin','Clark',35.013978,-114.644707),('89029','NV','Laughlin','Clark',35.134496,-114.619594),('89030','NV','North Las Vegas','Clark',36.205395,-115.122084),('89031','NV','North Las Vegas','Clark',36.26072,-115.171555),('89032','NV','North Las Vegas','Clark',36.225622,-115.172502),('89033','NV','North Las Vegas','Clark',36.3231,-115.1214),('89034','NV','Mesquite','Clark',36.809,-114.0591),('89036','NV','North Las Vegas','Clark',36.3709,-114.8819),('89037','NV','Moapa','Clark',36.6761,-114.6198),('89039','NV','Cal Nev Ari','Clark',35.283745,-114.873364),('89040','NV','Overton','Clark',36.480413,-114.478781),('89041','NV','Pahrump','Nye',36.3118,-116.0631),('89042','NV','Panaca','Lincoln',37.787666,-114.383993),('89043','NV','Pioche','Lincoln',38.149095,-114.471396),('89044','NV','Henderson','Clark',35.941545,-115.122274),('89045','NV','Round Mountain','Nye',38.829883,-117.093764),('89046','NV','Searchlight','Clark',35.486109,-114.879801),('89047','NV','Silverpeak','Esmeralda',37.756686,-117.6356),('89048','NV','Pahrump','Nye',36.181297,-116.009165),('89049','NV','Tonopah','Nye',38.056029,-116.895386),('89052','NV','Henderson','Clark',35.979222,-115.103967),('89053','NV','Henderson','Clark',36.0865,-114.9434),('89054','NV','Sloan','Clark',35.932596,-115.200366),('89060','NV','Pahrump','Nye',36.293469,-116.036465),('89061','NV','Pahrump','Nye',36.107402,-115.916588),('89067','NV','Moapa','Clark',36.6591,-114.6656),('89070','NV','Indian Springs','Clark',36.1989,-115.5422),('89074','NV','Henderson','Clark',36.038875,-115.084964),('89077','NV','Henderson','Clark',36.030726,-114.981214),('89081','NV','North Las Vegas','Clark',36.263165,-115.109116),('89084','NV','North Las Vegas','Clark',36.285535,-115.178879),('89085','NV','North Las Vegas','Clark',36.309681,-115.200355),('89086','NV','North Las Vegas','Clark',36.28,-115.119191),('89087','NV','North Las Vegas','Clark',36.1989,-115.1175),('89101','NV','Las Vegas','Clark',36.17014,-115.127623),('89102','NV','Las Vegas','Clark',36.145539,-115.183957),('89103','NV','Las Vegas','Clark',36.114302,-115.217099),('89104','NV','Las Vegas','Clark',36.150314,-115.107697),('89105','NV','Las Vegas','Clark',35.9854,-115.0941),('89106','NV','Las Vegas','Clark',36.184032,-115.162742),('89107','NV','Las Vegas','Clark',36.171839,-115.216244),('89108','NV','Las Vegas','Clark',36.205348,-115.22261),('89109','NV','Las Vegas','Clark',36.125757,-115.167805),('89110','NV','Las Vegas','Clark',36.173322,-115.060404),('89111','NV','Las Vegas','Clark',36.0856,-115.1458),('89112','NV','Las Vegas','Clark',36.0994,-115.0721),('89113','NV','Las Vegas','Clark',36.062052,-115.264984),('89114','NV','Las Vegas','Clark',36.1328,-115.171),('89115','NV','Las Vegas','Clark',36.231699,-115.072118),('89116','NV','Las Vegas','Clark',36.1554,-115.1041),('89117','NV','Las Vegas','Clark',36.140961,-115.281091),('89118','NV','Las Vegas','Clark',36.080703,-115.21108),('89119','NV','Las Vegas','Clark',36.084157,-115.142685),('89120','NV','Las Vegas','Clark',36.084678,-115.090068),('89121','NV','Las Vegas','Clark',36.123004,-115.090333),('89122','NV','Las Vegas','Clark',36.106826,-115.045697),('89123','NV','Las Vegas','Clark',36.034901,-115.148399),('89124','NV','Las Vegas','Clark',36.281436,-115.587479),('89125','NV','Las Vegas','Clark',36.1725,-115.1402),('89126','NV','Las Vegas','Clark',36.1507,-115.2075),('89127','NV','Las Vegas','Clark',36.1771,-115.1532),('89128','NV','Las Vegas','Clark',36.194563,-115.265259),('89129','NV','Las Vegas','Clark',36.231902,-115.290862),('89130','NV','Las Vegas','Clark',36.256269,-115.227805),('89131','NV','Las Vegas','Clark',36.298945,-115.243525),('89132','NV','Las Vegas','Clark',36.0998,-115.145),('89133','NV','Las Vegas','Clark',36.175,-115.1363),('89134','NV','Las Vegas','Clark',36.203607,-115.30979),('89135','NV','Las Vegas','Clark',36.123898,-115.33371),('89136','NV','Las Vegas','Clark',36.175,-115.1364),('89137','NV','Las Vegas','Clark',36.175,-115.1363),('89138','NV','Las Vegas','Clark',36.169327,-115.349586),('89139','NV','Las Vegas','Clark',36.042218,-115.212162),('89140','NV','Las Vegas','Clark',35.9854,-115.0941),('89141','NV','Las Vegas','Clark',35.993945,-115.204555),('89142','NV','Las Vegas','Clark',36.148193,-115.045191),('89143','NV','Las Vegas','Clark',36.318391,-115.290141),('89144','NV','Las Vegas','Clark',36.181139,-115.325834),('89145','NV','Las Vegas','Clark',36.168164,-115.269234),('89146','NV','Las Vegas','Clark',36.141426,-115.224143),('89147','NV','Las Vegas','Clark',36.113082,-115.277268),('89148','NV','Las Vegas','Clark',36.057535,-115.294859),('89149','NV','Las Vegas','Clark',36.276397,-115.291278),('89150','NV','Las Vegas','Clark',36.175,-115.1363),('89151','NV','Las Vegas','Clark',36.175,-115.1363),('89152','NV','Las Vegas','Clark',36.175,-115.1363),('89153','NV','Las Vegas','Clark',36.175,-115.1363),('89154','NV','Las Vegas','Clark',36.1065,-115.1372),('89155','NV','Las Vegas','Clark',36.1907,-115.1876),('89156','NV','Las Vegas','Clark',36.197783,-115.029509),('89157','NV','Las Vegas','Clark',36.175,-115.1372),('89158','NV','Las Vegas','Clark',36.175,-115.136),('89159','NV','Las Vegas','Clark',36.0717,-115.14),('89160','NV','Las Vegas','Clark',36.0994,-115.0721),('89161','NV','Las Vegas','Clark',36.01709,-115.355557),('89162','NV','Las Vegas','Clark',36.175,-115.136),('89163','NV','The Lakes','Clark',36.175,-115.1363),('89164','NV','Las Vegas','Clark',36.175,-115.1363),('89165','NV','Las Vegas','Clark',35.9854,-115.0941),('89166','NV','Las Vegas','Clark',36.31397,-115.330822),('89169','NV','Las Vegas','Clark',36.125287,-115.135167),('89170','NV','Las Vegas','Clark',36.1059,-115.1362),('89173','NV','Las Vegas','Clark',36.1062,-115.1374),('89177','NV','Las Vegas','Clark',36.0853,-115.1459),('89178','NV','Las Vegas','Clark',36.011389,-115.281333),('89179','NV','Las Vegas','Clark',35.961661,-115.262391),('89180','NV','Las Vegas','Clark',36.1276,-115.2421),('89183','NV','Las Vegas','Clark',35.997642,-115.152584),('89185','NV','Las Vegas','Clark',36.1554,-115.1041),('89191','NV','Nellis Afb','Clark',36.235939,-115.032325),('89193','NV','Las Vegas','Clark',36.0853,-115.1459),('89195','NV','Las Vegas','Clark',36.0853,-115.1459),('89199','NV','Las Vegas','Clark',36.175,-115.1363),('89301','NV','Ely','White Pine',39.32864,-114.860268),('89310','NV','Austin','Lander',39.271568,-117.249964),('89311','NV','Baker','White Pine',39.005413,-114.149059),('89314','NV','Duckwater','Nye',38.938388,-115.710501),('89315','NV','Ely','White Pine',39.2474,-114.8919),('89316','NV','Eureka','Eureka',39.643524,-116.030253),('89317','NV','Lund','White Pine',38.851566,-115.052698),('89318','NV','Mc Gill','White Pine',39.404673,-114.781303),('89319','NV','Ruth','White Pine',39.280894,-114.987863),('89402','NV','Crystal Bay','Washoe',39.1721,-119.9275),('89403','NV','Dayton','Lyon',39.258004,-119.544522),('89404','NV','Denio','Humboldt',41.826461,-118.712952),('89405','NV','Empire','Washoe',40.471164,-119.364862),('89406','NV','Fallon','Churchill',39.476935,-118.759209),('89407','NV','Fallon','Churchill',39.581,-118.3352),('89408','NV','Fernley','Lyon',39.583131,-119.19493),('89409','NV','Gabbs','Nye',38.864014,-118.007774),('89410','NV','Gardnerville','Douglas',38.873507,-119.633552),('89411','NV','Genoa','Douglas',39.020727,-119.837089),('89412','NV','Gerlach','Washoe',41.092508,-119.632789),('89413','NV','Glenbrook','Douglas',39.067213,-119.940524),('89414','NV','Golconda','Humboldt',41.002073,-117.360165),('89415','NV','Hawthorne','Mineral',38.522539,-118.639492),('89418','NV','Imlay','Pershing',40.600218,-118.068742),('89419','NV','Lovelock','Pershing',40.227355,-118.392962),('89420','NV','Luning','Mineral',38.499321,-118.179767),('89421','NV','Mc Dermitt','Humboldt',42.0081,-117.842517),('89422','NV','Mina','Mineral',38.345259,-118.100832),('89423','NV','Minden','Douglas',39.018776,-119.755652),('89424','NV','Nixon','Washoe',39.814189,-119.362166),('89425','NV','Orovada','Humboldt',41.629667,-117.914911),('89426','NV','Paradise Valley','Humboldt',41.441594,-117.52078),('89427','NV','Schurz','Mineral',38.958239,-118.802839),('89428','NV','Silver City','Lyon',39.262644,-119.637631),('89429','NV','Silver Springs','Lyon',39.377261,-119.273168),('89430','NV','Smith','Lyon',38.785759,-119.299308),('89431','NV','Sparks','Washoe',39.543429,-119.75493),('89432','NV','Sparks','Washoe',39.5407,-119.7466),('89433','NV','Sun Valley','Washoe',39.595505,-119.776133),('89434','NV','Sparks','Washoe',39.548517,-119.659698),('89435','NV','Sparks','Washoe',39.535,-119.7516),('89436','NV','Sparks','Washoe',39.601582,-119.711113),('89438','NV','Valmy','Humboldt',40.7377,-117.2009),('89439','NV','Verdi','Washoe',39.534656,-120.007034),('89440','NV','Virginia City','Storey',39.298026,-119.653741),('89441','NV','Sparks','Washoe',39.663661,-119.691088),('89442','NV','Wadsworth','Washoe',39.624654,-119.361963),('89444','NV','Wellington','Douglas',38.734429,-119.40155),('89445','NV','Winnemucca','Humboldt',41.013731,-117.856003),('89446','NV','Winnemucca','Humboldt',41.215363,-117.862284),('89447','NV','Yerington','Lyon',38.964572,-119.165929),('89448','NV','Zephyr Cove','Douglas',38.998587,-119.945982),('89449','NV','Stateline','Douglas',38.96971,-119.914676),('89450','NV','Incline Village','Washoe',39.240574,-119.93961),('89451','NV','Incline Village','Washoe',39.248655,-119.949618),('89452','NV','Incline Village','Washoe',39.3024,-119.9176),('89460','NV','Gardnerville','Douglas',38.900627,-119.76575),('89496','NV','Fallon','Churchill',39.581,-118.3352),('89501','NV','Reno','Washoe',39.525735,-119.812227),('89502','NV','Reno','Washoe',39.499851,-119.77497),('89503','NV','Reno','Washoe',39.537965,-119.837062),('89504','NV','Reno','Washoe',39.5297,-119.8127),('89505','NV','Reno','Washoe',39.5297,-119.8127),('89506','NV','Reno','Washoe',39.638121,-119.850397),('89507','NV','Reno','Washoe',39.5385,-119.8179),('89508','NV','Reno, Nv','Washoe',39.718918,-119.940703),('89509','NV','Reno','Washoe',39.50186,-119.826989),('89510','NV','Reno','Washoe',39.989245,-119.732195),('89511','NV','Reno','Washoe',39.416309,-119.804075),('89512','NV','Reno','Washoe',39.548802,-119.795721),('89513','NV','Reno','Washoe',39.5297,-119.8127),('89515','NV','Reno','Washoe',39.5132,-119.7806),('89519','NV','Reno','Washoe',39.481458,-119.851789),('89520','NV','Reno','Washoe',39.5132,-119.7806),('89521','NV','Reno','Washoe',39.402672,-119.719632),('89523','NV','Reno','Washoe',39.523161,-119.901149),('89533','NV','Reno','Washoe',39.5297,-119.8127),('89555','NV','Reno','Washoe',39.5297,-119.8129),('89557','NV','Reno','Washoe',39.5452,-119.8201),('89570','NV','Reno','Washoe',39.5297,-119.8127),('89595','NV','Reno','Washoe',39.5132,-119.7806),('89599','NV','Reno','Washoe',39.5297,-119.8127),('89701','NV','Carson City','Carson City',39.145738,-119.74387),('89702','NV','Carson City','Carson City',39.159097,-119.73581),('89703','NV','Carson City','Carson City',39.166112,-119.78132),('89704','NV','Washoe Valley','Washoe',39.278131,-119.798642),('89705','NV','Carson City','Douglas',39.098983,-119.827433),('89706','NV','Carson City','Carson City',39.20238,-119.724163),('89711','NV','Carson City','Carson City',39.1638,-119.7663),('89712','NV','Carson City','Carson City',39.1638,-119.7663),('89713','NV','Carson City','Carson City',39.1638,-119.7663),('89714','NV','Carson City','Carson City',39.1638,-119.7663),('89721','NV','Carson City','Carson City',39.1638,-119.7663),('89801','NV','Elko','Elko',40.93108,-115.722961),('89802','NV','Elko','Elko',40.8325,-115.7622),('89803','NV','Elko','Elko',40.81488,-115.792418),('89815','NV','Spring Creek','Elko',40.654132,-115.660205),('89820','NV','Battle Mountain','Lander',40.51069,-116.909693),('89821','NV','Crescent Valley','Eureka',40.457563,-116.540815),('89822','NV','Carlin','Elko',40.684314,-116.150577),('89823','NV','Deeth','Elko',40.984788,-115.297531),('89824','NV','Halleck','Elko',41.029538,-115.411306),('89825','NV','Jackpot','Elko',41.957169,-114.679899),('89826','NV','Jarbidge','Elko',41.922159,-115.40132),('89828','NV','Lamoille','Elko',40.780316,-115.40376),('89830','NV','Montello','Elko',41.237689,-114.220424),('89831','NV','Mountain City','Elko',41.787054,-116.01439),('89832','NV','Owyhee','Elko',41.988959,-116.145846),('89833','NV','Ruby Valley','Elko',40.489262,-115.34583),('89834','NV','Tuscarora','Elko',41.367091,-116.121785),('89835','NV','Wells','Elko',41.104448,-114.897524),('89883','NV','West Wendover','Elko',40.771741,-114.104142),('90001','CA','Los Angeles','Los Angeles',33.972159,-118.247923),('90002','CA','Los Angeles','Los Angeles',33.951171,-118.246825),('90003','CA','Los Angeles','Los Angeles',33.961948,-118.276079),('90004','CA','Los Angeles','Los Angeles',34.076939,-118.30742),('90005','CA','Los Angeles','Los Angeles',34.05878,-118.308425),('90006','CA','Los Angeles','Los Angeles',34.048171,-118.294218),('90007','CA','Los Angeles','Los Angeles',34.027803,-118.282691),('90008','CA','Los Angeles','Los Angeles',34.009754,-118.337246),('90009','CA','Los Angeles','Los Angeles',33.9452,-118.3832),('90010','CA','Los Angeles','Los Angeles',34.061219,-118.315639),('90011','CA','Los Angeles','Los Angeles',34.00709,-118.258681),('90012','CA','Los Angeles','Los Angeles',34.063387,-118.238504),('90013','CA','Los Angeles','Los Angeles',34.044203,-118.241529),('90014','CA','Los Angeles','Los Angeles',34.042936,-118.251818),('90015','CA','Los Angeles','Los Angeles',34.037876,-118.267081),('90016','CA','Los Angeles','Los Angeles',34.030055,-118.353657),('90017','CA','Los Angeles','Los Angeles',34.052376,-118.264289),('90018','CA','Los Angeles','Los Angeles',34.028652,-118.316398),('90019','CA','Los Angeles','Los Angeles',34.048636,-118.341478),('90020','CA','Los Angeles','Los Angeles',34.066244,-118.308478),('90021','CA','Los Angeles','Los Angeles',34.029871,-118.240253),('90022','CA','Los Angeles','Los Angeles',34.023218,-118.153736),('90023','CA','Los Angeles','Los Angeles',34.023834,-118.201867),('90024','CA','Los Angeles','Los Angeles',34.062852,-118.437733),('90025','CA','Los Angeles','Los Angeles',34.04536,-118.445818),('90026','CA','Los Angeles','Los Angeles',34.078041,-118.264374),('90027','CA','Los Angeles','Los Angeles',34.113646,-118.286934),('90028','CA','Los Angeles','Los Angeles',34.100701,-118.327415),('90029','CA','Los Angeles','Los Angeles',34.090149,-118.293334),('90030','CA','Los Angeles','Los Angeles',34.0629,-118.2381),('90031','CA','Los Angeles','Los Angeles',34.077626,-118.21488),('90032','CA','Los Angeles','Los Angeles',34.079734,-118.174812),('90033','CA','Los Angeles','Los Angeles',34.05038,-118.211991),('90034','CA','Los Angeles','Los Angeles',34.030437,-118.396814),('90035','CA','Los Angeles','Los Angeles',34.051302,-118.383643),('90036','CA','Los Angeles','Los Angeles',34.070291,-118.349191),('90037','CA','Los Angeles','Los Angeles',34.002143,-118.28745),('90038','CA','Los Angeles','Los Angeles',34.089379,-118.328276),('90039','CA','Los Angeles','Los Angeles',34.108793,-118.258932),('90040','CA','Los Angeles','Los Angeles',33.997281,-118.152893),('90041','CA','Los Angeles','Los Angeles',34.137412,-118.207607),('90042','CA','Los Angeles','Los Angeles',34.114708,-118.192098),('90043','CA','Los Angeles','Los Angeles',33.988505,-118.336358),('90044','CA','Los Angeles','Los Angeles',33.952757,-118.29171),('90045','CA','Los Angeles','Los Angeles',33.958718,-118.39504),('90046','CA','Los Angeles','Los Angeles',34.09626,-118.360945),('90047','CA','Los Angeles','Los Angeles',33.95543,-118.309569),('90048','CA','Los Angeles','Los Angeles',34.072737,-118.374844),('90049','CA','Los Angeles','Los Angeles',34.065658,-118.475561),('90050','CA','Los Angeles','Los Angeles',34.1208,-118.2033),('90051','CA','Los Angeles','Los Angeles',34.0629,-118.2381),('90052','CA','Los Angeles','Los Angeles',33.9818,-118.2579),('90053','CA','Los Angeles','Los Angeles',34.0535,-118.2397),('90054','CA','Los Angeles','Los Angeles',34.0629,-118.2381),('90055','CA','Los Angeles','Los Angeles',34.0449,-118.2579),('90056','CA','Los Angeles','Los Angeles',33.986575,-118.370409),('90057','CA','Los Angeles','Los Angeles',34.061735,-118.276757),('90058','CA','Los Angeles','Los Angeles',34.00103,-118.216304),('90059','CA','Los Angeles','Los Angeles',33.927469,-118.248796),('90060','CA','Los Angeles','Los Angeles',34.064,-118.2377),('90061','CA','Los Angeles','Los Angeles',33.922973,-118.275978),('90062','CA','Los Angeles','Los Angeles',34.004901,-118.308354),('90063','CA','Los Angeles','Los Angeles',34.04524,-118.185302),('90064','CA','Los Angeles','Los Angeles',34.034696,-118.428401),('90065','CA','Los Angeles','Los Angeles',34.109595,-118.228689),('90066','CA','Los Angeles','Los Angeles',34.000349,-118.429901),('90067','CA','Los Angeles','Los Angeles',34.05682,-118.413338),('90068','CA','Los Angeles','Los Angeles',34.12122,-118.336537),('90069','CA','West Hollywood','Los Angeles',34.089964,-118.380338),('90070','CA','Los Angeles','Los Angeles',34.0601,-118.3091),('90071','CA','Los Angeles','Los Angeles',34.052709,-118.255908),('90072','CA','Los Angeles','Los Angeles',34.0961,-118.3086),('90073','CA','Los Angeles','Los Angeles',34.054799,-118.452098),('90074','CA','Los Angeles','Los Angeles',34.0531,-118.2639),('90075','CA','Los Angeles','Los Angeles',34.0601,-118.3091),('90076','CA','Los Angeles','Los Angeles',34.0601,-118.3091),('90077','CA','Los Angeles','Los Angeles',34.107186,-118.452263),('90078','CA','Los Angeles','Los Angeles',34.0996,-118.3261),('90079','CA','Los Angeles','Los Angeles',34.0522,-118.2427),('90080','CA','Los Angeles','Los Angeles',33.9452,-118.3832),('90081','CA','Los Angeles','Los Angeles',33.9542,-118.3972),('90082','CA','Los Angeles','Los Angeles',34.0008,-118.2772),('90083','CA','Los Angeles','Los Angeles',33.9537,-118.398),('90084','CA','Los Angeles','Los Angeles',34.0531,-118.2639),('90086','CA','Los Angeles','Los Angeles',34.0629,-118.2381),('90087','CA','Los Angeles','Los Angeles',34.064,-118.2377),('90088','CA','Los Angeles','Los Angeles',34.0531,-118.2639),('90089','CA','Los Angeles','Los Angeles',34.021315,-118.282052),('90090','CA','Dodgertown','Los Angeles',34.072755,-118.243784),('90091','CA','Los Angeles','Los Angeles',33.9923,-118.1505),('90093','CA','Los Angeles','Los Angeles',34.0967,-118.3346),('90094','CA','Los Angeles','Los Angeles',33.973834,-118.42089),('90095','CA','Los Angeles','Los Angeles',34.0699,-118.4429),('90096','CA','Los Angeles','Los Angeles',33.9681,-118.1696),('90099','CA','Los Angeles','Los Angeles',34.0629,-118.2381),('90101','CA','Los Angeles','Los Angeles',33.974,-118.2488),('90102','CA','Los Angeles','Los Angeles',34.0184,-118.1987),('90103','CA','Los Angeles','Los Angeles',34.0184,-118.1996),('90189','CA','Los Angeles','Los Angeles',34.0583,-118.2476),('90201','CA','Bell','Los Angeles',33.970343,-118.171368),('90202','CA','Bell Gardens','Los Angeles',33.9683,-118.1491),('90209','CA','Beverly Hills','Los Angeles',34.0732,-118.3927),('90210','CA','Beverly Hills','Los Angeles',34.084764,-118.406287),('90211','CA','Beverly Hills','Los Angeles',34.065713,-118.384864),('90212','CA','Beverly Hills','Los Angeles',34.061205,-118.400447),('90213','CA','Beverly Hills','Los Angeles',34.0722,-118.4002),('90220','CA','Compton','Los Angeles',33.887959,-118.2379),('90221','CA','Compton','Los Angeles',33.893297,-118.201911),('90222','CA','Compton','Los Angeles',33.910791,-118.236235),('90223','CA','Compton','Los Angeles',33.8957,-118.2235),('90224','CA','Compton','Los Angeles',33.8903,-118.2154),('90230','CA','Culver City','Los Angeles',33.995775,-118.398457),('90231','CA','Culver City','Los Angeles',33.9974,-118.3946),('90232','CA','Culver City','Los Angeles',34.021423,-118.390681),('90233','CA','Culver City','Los Angeles',33.9841,-118.3888),('90239','CA','Downey','Los Angeles',33.9313,-118.1148),('90240','CA','Downey','Los Angeles',33.958138,-118.119996),('90241','CA','Downey','Los Angeles',33.940445,-118.129022),('90242','CA','Downey','Los Angeles',33.918677,-118.14343),('90245','CA','El Segundo','Los Angeles',33.92154,-118.408323),('90247','CA','Gardena','Los Angeles',33.89101,-118.296651),('90248','CA','Gardena','Los Angeles',33.87233,-118.287111),('90249','CA','Gardena','Los Angeles',33.899459,-118.318273),('90250','CA','Hawthorne','Los Angeles',33.915865,-118.350646),('90251','CA','Hawthorne','Los Angeles',33.9171,-118.36),('90254','CA','Hermosa Beach','Los Angeles',33.867079,-118.398147),('90255','CA','Huntington Park','Los Angeles',33.980442,-118.219584),('90260','CA','Lawndale','Los Angeles',33.887389,-118.352536),('90261','CA','Lawndale','Los Angeles',33.895363,-118.376895),('90262','CA','Lynwood','Los Angeles',33.924151,-118.199682),('90263','CA','Malibu','Los Angeles',34.038849,-118.706972),('90264','CA','Malibu','Los Angeles',34.0215,-118.8081),('90265','CA','Malibu','Los Angeles',34.052203,-118.816053),('90266','CA','Manhattan Beach','Los Angeles',33.8896,-118.403824),('90267','CA','Manhattan Beach','Los Angeles',33.8766,-118.3953),('90270','CA','Maywood','Los Angeles',33.987729,-118.186597),('90272','CA','Pacific Palisades','Los Angeles',34.050037,-118.529756),('90274','CA','Palos Verdes Peninsula','Los Angeles',33.787247,-118.386084),('90275','CA','Rancho Palos Verdes','Los Angeles',33.761814,-118.369963),('90277','CA','Redondo Beach','Los Angeles',33.828116,-118.383944),('90278','CA','Redondo Beach','Los Angeles',33.870475,-118.371663),('90280','CA','South Gate','Los Angeles',33.942521,-118.19223),('90290','CA','Topanga','Los Angeles',34.102236,-118.607916),('90291','CA','Venice','Los Angeles',33.992112,-118.465415),('90292','CA','Marina Del Rey','Los Angeles',33.976582,-118.455223),('90293','CA','Playa Del Rey','Los Angeles',33.956464,-118.441593),('90294','CA','Venice','Los Angeles',33.988,-118.47),('90295','CA','Marina Del Rey','Los Angeles',33.9786,-118.4381),('90296','CA','Playa Del Rey','Los Angeles',33.959,-118.4474),('90301','CA','Inglewood','Los Angeles',33.957261,-118.358343),('90302','CA','Inglewood','Los Angeles',33.975528,-118.353713),('90303','CA','Inglewood','Los Angeles',33.935333,-118.328759),('90304','CA','Inglewood','Los Angeles',33.936678,-118.357791),('90305','CA','Inglewood','Los Angeles',33.961458,-118.330007),('90306','CA','Inglewood','Los Angeles',33.9591,-118.3503),('90307','CA','Inglewood','Los Angeles',33.9591,-118.3503),('90308','CA','Inglewood','Los Angeles',33.9591,-118.3503),('90309','CA','Inglewood','Los Angeles',33.9726,-118.3567),('90310','CA','Inglewood','Los Angeles',33.9306,-118.3218),('90311','CA','Inglewood','Los Angeles',33.9616,-118.3522),('90312','CA','Inglewood','Los Angeles',33.9616,-118.3522),('90313','CA','Inglewood','Los Angeles',33.9616,-118.3522),('90397','CA','Inglewood','Los Angeles',33.9616,-118.3522),('90398','CA','Inglewood','Los Angeles',33.9616,-118.3522),('90401','CA','Santa Monica','Los Angeles',34.015388,-118.491613),('90402','CA','Santa Monica','Los Angeles',34.035697,-118.50249),('90403','CA','Santa Monica','Los Angeles',34.030565,-118.48911),('90404','CA','Santa Monica','Los Angeles',34.027127,-118.472291),('90405','CA','Santa Monica','Los Angeles',34.010291,-118.471458),('90406','CA','Santa Monica','Los Angeles',34.0192,-118.4956),('90407','CA','Santa Monica','Los Angeles',34.0192,-118.4956),('90408','CA','Santa Monica','Los Angeles',34.0259,-118.489),('90409','CA','Santa Monica','Los Angeles',34.0003,-118.482),('90410','CA','Santa Monica','Los Angeles',34.0192,-118.4956),('90411','CA','Santa Monica','Los Angeles',34.0192,-118.4956),('90501','CA','Torrance','Los Angeles',33.830251,-118.315246),('90502','CA','Torrance','Los Angeles',33.831918,-118.291115),('90503','CA','Torrance','Los Angeles',33.839057,-118.351585),('90504','CA','Torrance','Los Angeles',33.870063,-118.331377),('90505','CA','Torrance','Los Angeles',33.809963,-118.350879),('90506','CA','Torrance','Los Angeles',33.8846,-118.3305),('90507','CA','Torrance','Los Angeles',33.8339,-118.3145),('90508','CA','Torrance','Los Angeles',33.8339,-118.3145),('90509','CA','Torrance','Los Angeles',33.8293,-118.3281),('90510','CA','Torrance','Los Angeles',33.8293,-118.3281),('90601','CA','Whittier','Los Angeles',34.005937,-118.038313),('90602','CA','Whittier','Los Angeles',33.967736,-118.033825),('90603','CA','Whittier','Los Angeles',33.943224,-117.994989),('90604','CA','Whittier','Los Angeles',33.930888,-118.011758),('90605','CA','Whittier','Los Angeles',33.944565,-118.032535),('90606','CA','Whittier','Los Angeles',33.979137,-118.066333),('90607','CA','Whittier','Los Angeles',33.96,-118.0249),('90608','CA','Whittier','Los Angeles',33.9804,-118.0342),('90609','CA','Whittier','Los Angeles',33.9791,-118.0319),('90610','CA','Whittier','Los Angeles',33.9686,-118.0702),('90612','CA','Whittier','Los Angeles',33.96,-118.0249),('90620','CA','Buena Park','Orange',33.844925,-118.011072),('90621','CA','Buena Park','Orange',33.874432,-117.994341),('90622','CA','Buena Park','Orange',33.8464,-118.0041),('90623','CA','La Palma','Orange',33.851126,-118.039934),('90624','CA','Buena Park','Orange',33.8464,-118.0041),('90630','CA','Cypress','Orange',33.817758,-118.039938),('90631','CA','La Habra','Orange',33.935262,-117.951853),('90632','CA','La Habra','Orange',33.9169,-117.9528),('90633','CA','La Habra','Orange',33.9323,-117.945),('90637','CA','La Mirada','Los Angeles',33.8953,-118.0024),('90638','CA','La Mirada','Los Angeles',33.902045,-118.008961),('90639','CA','La Mirada','Los Angeles',33.9073,-118.0188),('90640','CA','Montebello','Los Angeles',34.01606,-118.113904),('90650','CA','Norwalk','Los Angeles',33.9076,-118.083453),('90651','CA','Norwalk','Los Angeles',33.9042,-118.0773),('90652','CA','Norwalk','Los Angeles',33.9188,-118.0719),('90659','CA','Norwalk','Los Angeles',33.9042,-118.0773),('90660','CA','Pico Rivera','Los Angeles',33.991077,-118.088284),('90661','CA','Pico Rivera','Los Angeles',34.0003,-118.0809),('90662','CA','Pico Rivera','Los Angeles',33.9694,-118.099),('90670','CA','Santa Fe Springs','Los Angeles',33.935334,-118.070542),('90671','CA','Santa Fe Springs','Los Angeles',33.9472,-118.0844),('90680','CA','Stanton','Orange',33.801866,-117.997402),('90701','CA','Artesia','Los Angeles',33.867113,-118.080346),('90702','CA','Artesia','Los Angeles',33.8659,-118.0831),('90703','CA','Cerritos','Los Angeles',33.867743,-118.069472),('90704','CA','Avalon','Los Angeles',33.364029,-118.401571),('90706','CA','Bellflower','Los Angeles',33.888894,-118.128099),('90707','CA','Bellflower','Los Angeles',33.8821,-118.1234),('90710','CA','Harbor City','Los Angeles',33.796306,-118.299525),('90711','CA','Lakewood','Los Angeles',33.8517,-118.1328),('90712','CA','Lakewood','Los Angeles',33.852077,-118.145743),('90713','CA','Lakewood','Los Angeles',33.847548,-118.113147),('90714','CA','Lakewood','Los Angeles',33.8517,-118.1328),('90715','CA','Lakewood','Los Angeles',33.839455,-118.080977),('90716','CA','Hawaiian Gardens','Los Angeles',33.828613,-118.07265),('90717','CA','Lomita','Los Angeles',33.795048,-118.31616),('90720','CA','Los Alamitos','Orange',33.79714,-118.068885),('90721','CA','Los Alamitos','Orange',33.8038,-118.0695),('90723','CA','Paramount','Los Angeles',33.896399,-118.164082),('90731','CA','San Pedro','Los Angeles',33.732865,-118.28904),('90732','CA','San Pedro','Los Angeles',33.740574,-118.310202),('90733','CA','San Pedro','Los Angeles',33.736,-118.2798),('90734','CA','San Pedro','Los Angeles',33.7556,-118.3078),('90740','CA','Seal Beach','Orange',33.759729,-118.086305),('90742','CA','Sunset Beach','Orange',33.718852,-118.071842),('90743','CA','Surfside','Orange',33.729162,-118.084981),('90744','CA','Wilmington','Los Angeles',33.783945,-118.260368),('90745','CA','Carson','Los Angeles',33.823666,-118.266775),('90746','CA','Carson','Los Angeles',33.861132,-118.256111),('90747','CA','Carson','Los Angeles',33.867,-118.2581),('90748','CA','Wilmington','Los Angeles',33.7844,-118.2617),('90749','CA','Carson','Los Angeles',33.8348,-118.2626),('90755','CA','Signal Hill','Los Angeles',33.803431,-118.16977),('90801','CA','Long Beach','Los Angeles',33.7705,-118.1885),('90802','CA','Long Beach','Los Angeles',33.766624,-118.192579),('90803','CA','Long Beach','Los Angeles',33.759576,-118.129567),('90804','CA','Long Beach','Los Angeles',33.782478,-118.150784),('90805','CA','Long Beach','Los Angeles',33.864604,-118.183512),('90806','CA','Long Beach','Los Angeles',33.803473,-118.192089),('90807','CA','Long Beach','Los Angeles',33.828283,-118.181186),('90808','CA','Long Beach','Los Angeles',33.823247,-118.111337),('90809','CA','Long Beach','Los Angeles',33.7706,-118.1884),('90810','CA','Long Beach','Los Angeles',33.817998,-118.218255),('90813','CA','Long Beach','Los Angeles',33.781697,-118.191933),('90814','CA','Long Beach','Los Angeles',33.771249,-118.144806),('90815','CA','Long Beach','Los Angeles',33.794595,-118.117482),('90822','CA','Long Beach','Los Angeles',33.778673,-118.120293),('90831','CA','Long Beach','Los Angeles',33.7677,-118.1986),('90832','CA','Long Beach','Los Angeles',33.7677,-118.1986),('90833','CA','Long Beach','Los Angeles',33.7677,-118.1986),('90834','CA','Long Beach','Los Angeles',33.7677,-118.1986),('90835','CA','Long Beach','Los Angeles',33.7677,-118.1986),('90840','CA','Long Beach','Los Angeles',33.7828,-118.1153),('90842','CA','Long Beach','Los Angeles',33.8298,-118.1819),('90844','CA','Long Beach','Los Angeles',33.7744,-118.1923),('90845','CA','Long Beach','Los Angeles',33.7706,-118.1884),('90846','CA','Long Beach','Los Angeles',33.8281,-118.1427),('90847','CA','Long Beach','Los Angeles',33.8298,-118.1819),('90848','CA','Long Beach','Los Angeles',33.8298,-118.1819),('90853','CA','Long Beach','Los Angeles',33.759,-118.1306),('90888','CA','Long Beach','Los Angeles',33.7706,-118.1884),('90895','CA','Carson','Los Angeles',33.8159,-118.2158),('90899','CA','Long Beach','Los Angeles',33.7668,-118.1886),('91001','CA','Altadena','Los Angeles',34.190511,-118.137327),('91003','CA','Altadena','Los Angeles',34.1848,-118.1307),('91006','CA','Arcadia','Los Angeles',34.131924,-118.024267),('91007','CA','Arcadia','Los Angeles',34.127176,-118.052274),('91008','CA','Duarte','Los Angeles',34.150932,-117.970483),('91009','CA','Duarte','Los Angeles',34.139459,-117.971488),('91010','CA','Duarte','Los Angeles',34.136295,-117.965435),('91011','CA','La Canada Flintridge','Los Angeles',34.207094,-118.201651),('91012','CA','La Canada Flintridge','Los Angeles',34.2007,-118.1906),('91016','CA','Monrovia','Los Angeles',34.141004,-118.000829),('91017','CA','Monrovia','Los Angeles',34.1504,-117.9976),('91020','CA','Montrose','Los Angeles',34.210419,-118.229395),('91021','CA','Montrose','Los Angeles',34.2071,-118.2243),('91023','CA','Mount Wilson','Los Angeles',34.2204,-118.0509),('91024','CA','Sierra Madre','Los Angeles',34.16495,-118.050867),('91025','CA','Sierra Madre','Los Angeles',34.1602,-118.052),('91030','CA','South Pasadena','Los Angeles',34.111467,-118.154701),('91031','CA','South Pasadena','Los Angeles',34.1147,-118.1523),('91040','CA','Sunland','Los Angeles',34.260761,-118.321952),('91041','CA','Sunland','Los Angeles',34.262,-118.319),('91042','CA','Tujunga','Los Angeles',34.263753,-118.279371),('91043','CA','Tujunga','Los Angeles',34.2517,-118.2901),('91046','CA','Verdugo City','Los Angeles',34.211452,-118.241036),('91066','CA','Arcadia','Los Angeles',34.1411,-118.0291),('91077','CA','Arcadia','Los Angeles',34.126,-118.0546),('91101','CA','Pasadena','Los Angeles',34.146538,-118.139067),('91102','CA','Pasadena','Los Angeles',34.146,-118.1438),('91103','CA','Pasadena','Los Angeles',34.166923,-118.161359),('91104','CA','Pasadena','Los Angeles',34.169368,-118.123762),('91105','CA','Pasadena','Los Angeles',34.137786,-118.163296),('91106','CA','Pasadena','Los Angeles',34.142386,-118.127037),('91107','CA','Pasadena','Los Angeles',34.151509,-118.089893),('91108','CA','San Marino','Los Angeles',34.122671,-118.112911),('91109','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91110','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91114','CA','Pasadena','Los Angeles',34.1692,-118.1302),('91115','CA','Pasadena','Los Angeles',34.1359,-118.1532),('91116','CA','Pasadena','Los Angeles',34.1461,-118.1295),('91117','CA','Pasadena','Los Angeles',34.1463,-118.0956),('91118','CA','San Marino','Los Angeles',34.1264,-118.091),('91121','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91123','CA','Pasadena','Los Angeles',34.1445,-118.1566),('91124','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91125','CA','Pasadena','Los Angeles',34.1359,-118.1262),('91126','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91129','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91131','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91182','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91184','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91185','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91188','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91189','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91191','CA','Pasadena','Los Angeles',34.1553,-118.1533),('91199','CA','Pasadena','Los Angeles',34.1478,-118.1436),('91201','CA','Glendale','Los Angeles',34.170251,-118.291015),('91202','CA','Glendale','Los Angeles',34.166617,-118.270111),('91203','CA','Glendale','Los Angeles',34.153338,-118.262974),('91204','CA','Glendale','Los Angeles',34.13417,-118.259545),('91205','CA','Glendale','Los Angeles',34.137625,-118.245044),('91206','CA','Glendale','Los Angeles',34.154694,-118.233287),('91207','CA','Glendale','Los Angeles',34.166608,-118.24766),('91208','CA','Glendale','Los Angeles',34.18961,-118.228549),('91209','CA','Glendale','Los Angeles',34.1463,-118.2515),('91210','CA','Glendale','Los Angeles',34.142999,-118.255693),('91214','CA','La Crescenta','Los Angeles',34.232044,-118.247523),('91221','CA','Glendale','Los Angeles',34.1647,-118.2885),('91222','CA','Glendale','Los Angeles',34.16,-118.2635),('91224','CA','La Crescenta','Los Angeles',34.2308,-118.2501),('91225','CA','Glendale','Los Angeles',34.1425,-118.2541),('91226','CA','Glendale','Los Angeles',34.1425,-118.2541),('91301','CA','Agoura Hills','Los Angeles',34.140048,-118.758014),('91302','CA','Calabasas','Los Angeles',34.133974,-118.669216),('91303','CA','Canoga Park','Los Angeles',34.19829,-118.602204),('91304','CA','Canoga Park','Los Angeles',34.221741,-118.621913),('91305','CA','Canoga Park','Los Angeles',34.2011,-118.6019),('91306','CA','Winnetka','Los Angeles',34.209532,-118.577563),('91307','CA','West Hills','Los Angeles',34.196838,-118.641393),('91308','CA','West Hills','Los Angeles',34.2003,-118.6284),('91309','CA','Canoga Park','Los Angeles',34.2182,-118.596),('91310','CA','Castaic','Los Angeles',34.4938,-118.6189),('91311','CA','Chatsworth','Los Angeles',34.259588,-118.600858),('91313','CA','Chatsworth','Los Angeles',34.2382,-118.5894),('91316','CA','Encino','Los Angeles',34.169157,-118.516226),('91319','CA','Newbury Park','Ventura',34.1837,-118.9141),('91320','CA','Newbury Park','Ventura',34.178556,-118.938554),('91321','CA','Newhall','Los Angeles',34.375147,-118.508758),('91322','CA','Newhall','Los Angeles',34.3847,-118.53),('91324','CA','Northridge','Los Angeles',34.238552,-118.548092),('91325','CA','Northridge','Los Angeles',34.234955,-118.518937),('91326','CA','Porter R','Los Angeles',34.275065,-118.550841),('91327','CA','Northridge','Los Angeles',34.2748,-118.5542),('91328','CA','Northridge','Los Angeles',34.2432,-118.535),('91329','CA','Northridge','Los Angeles',34.2224,-118.5024),('91330','CA','Northridge','Los Angeles',34.245552,-118.525571),('91331','CA','Pacoima','Los Angeles',34.254701,-118.424118),('91333','CA','Pacoima','Los Angeles',34.2624,-118.4266),('91334','CA','Pacoima','Los Angeles',34.2414,-118.4241),('91335','CA','Reseda','Los Angeles',34.201115,-118.540046),('91337','CA','Reseda','Los Angeles',34.2032,-118.5349),('91340','CA','San Fernando','Los Angeles',34.285756,-118.438812),('91341','CA','San Fernando','Los Angeles',34.282,-118.4418),('91342','CA','Sylmar','Los Angeles',34.304487,-118.426161),('91343','CA','North Hills','Los Angeles',34.238802,-118.482296),('91344','CA','Granada Hills','Los Angeles',34.278728,-118.499716),('91345','CA','Mission Hills','Los Angeles',34.265038,-118.459657),('91346','CA','Mission Hills','Los Angeles',34.268,-118.4663),('91350','CA','Santa Clarita','Los Angeles',34.4352,-118.509533),('91351','CA','Canyon Country','Los Angeles',34.425065,-118.47152),('91352','CA','Sun Valley','Los Angeles',34.225789,-118.378199),('91353','CA','Sun Valley','Los Angeles',34.2171,-118.3678),('91354','CA','Valencia','Los Angeles',34.449793,-118.551034),('91355','CA','Valencia','Los Angeles',34.414097,-118.570263),('91356','CA','Tarzana','Los Angeles',34.164432,-118.544708),('91357','CA','Tarzana','Los Angeles',34.1726,-118.5399),('91358','CA','Thousand Oaks','Ventura',34.1809,-118.8752),('91359','CA','Westlake Village','Ventura',34.1656,-118.8307),('91360','CA','Thousand Oaks','Ventura',34.208067,-118.875034),('91361','CA','Westlake Village','Ventura',34.14338,-118.854133),('91362','CA','Thousand Oaks','Ventura',34.182584,-118.821583),('91363','CA','Westlake Village','Los Angeles',34.1462,-118.8013),('91364','CA','Woodland Hills','Los Angeles',34.15853,-118.601086),('91365','CA','Woodland Hills','Los Angeles',34.1697,-118.6076),('91367','CA','Woodland Hills','Los Angeles',34.177136,-118.617311),('91371','CA','Woodland Hills','Los Angeles',34.1829,-118.5711),('91372','CA','Calabasas','Los Angeles',34.1542,-118.6415),('91376','CA','Agoura Hills','Los Angeles',34.1472,-118.7537),('91377','CA','Oak Park','Ventura',34.177717,-118.768356),('91380','CA','Santa Clarita','Los Angeles',34.4988,-118.3964),('91381','CA','Stevenson Ranch','Los Angeles',34.389617,-118.587908),('91382','CA','Santa Clarita','Los Angeles',34.3916,-118.5416),('91383','CA','Santa Clarita','Los Angeles',34.4272,-118.6367),('91384','CA','Castaic','Los Angeles',34.489506,-118.644049),('91385','CA','Valencia','Los Angeles',34.3908,-118.5623),('91386','CA','Canyon Country','Los Angeles',34.4162,-118.4525),('91387','CA','Canyon Country','Los Angeles',34.416619,-118.422748),('91388','CA','Van Nuys','Los Angeles',34.2012,-118.4742),('91390','CA','Santa Clarita','Los Angeles',34.49373,-118.386554),('91392','CA','Sylmar','Los Angeles',34.3084,-118.4309),('91393','CA','North Hills','Los Angeles',34.2296,-118.4669),('91394','CA','Granada Hills','Los Angeles',34.2648,-118.5246),('91395','CA','Mission Hills','Los Angeles',34.2572,-118.4642),('91396','CA','Winnetka','Los Angeles',34.2089,-118.57),('91399','CA','Woodland Hills','Los Angeles',34.1697,-118.6076),('91401','CA','Van Nuys','Los Angeles',34.176659,-118.433972),('91402','CA','Panorama City','Los Angeles',34.223764,-118.443106),('91403','CA','Sherman Oaks','Los Angeles',34.15401,-118.462849),('91404','CA','Van Nuys','Los Angeles',34.1827,-118.4478),('91405','CA','Van Nuys','Los Angeles',34.200612,-118.449516),('91406','CA','Van Nuys','Los Angeles',34.201162,-118.493485),('91407','CA','Van Nuys','Los Angeles',34.194,-118.4489),('91408','CA','Van Nuys','Los Angeles',34.1827,-118.4478),('91409','CA','Van Nuys','Los Angeles',34.2012,-118.4742),('91410','CA','Van Nuys','Los Angeles',34.2012,-118.4742),('91411','CA','Van Nuys','Los Angeles',34.178469,-118.458533),('91412','CA','Panorama City','Los Angeles',34.2244,-118.4464),('91413','CA','Sherman Oaks','Los Angeles',34.1645,-118.4567),('91416','CA','Encino','Los Angeles',34.1761,-118.5177),('91423','CA','Sherman Oaks','Los Angeles',34.153665,-118.431952),('91426','CA','Encino','Los Angeles',34.1599,-118.5),('91436','CA','Encino','Los Angeles',34.156057,-118.485867),('91470','CA','Van Nuys','Los Angeles',34.2012,-118.4742),('91482','CA','Van Nuys','Los Angeles',34.2012,-118.4742),('91495','CA','Sherman Oaks','Los Angeles',34.2012,-118.4742),('91496','CA','Van Nuys','Los Angeles',34.2012,-118.4742),('91497','CA','Van Nuys','Los Angeles',34.2012,-118.4742),('91499','CA','Van Nuys','Los Angeles',34.2012,-118.4742),('91501','CA','Burbank','Los Angeles',34.188979,-118.30151),('91502','CA','Burbank','Los Angeles',34.175162,-118.307943),('91503','CA','Burbank','Los Angeles',34.1804,-118.3084),('91504','CA','Burbank','Los Angeles',34.199986,-118.330865),('91505','CA','Burbank','Los Angeles',34.168493,-118.344338),('91506','CA','Burbank','Los Angeles',34.172575,-118.326124),('91507','CA','Burbank','Los Angeles',34.1672,-118.3472),('91508','CA','Burbank','Los Angeles',34.1914,-118.3259),('91510','CA','Burbank','Los Angeles',34.187,-118.348),('91521','CA','Burbank','Los Angeles',34.1559,-118.3268),('91522','CA','Burbank','Los Angeles',34.1491,-118.3427),('91523','CA','Burbank','Los Angeles',34.1563,-118.3333),('91526','CA','Burbank','Los Angeles',34.1745,-118.3462),('91601','CA','North Hollywood','Los Angeles',34.168253,-118.372513),('91602','CA','North Hollywood','Los Angeles',34.151772,-118.368467),('91603','CA','North Hollywood','Los Angeles',34.1681,-118.3778),('91604','CA','Studio City','Los Angeles',34.144148,-118.394676),('91605','CA','North Hollywood','Los Angeles',34.207341,-118.400973),('91606','CA','North Hollywood','Los Angeles',34.185767,-118.389415),('91607','CA','Valley Village','Los Angeles',34.164415,-118.399695),('91608','CA','Universal City','Los Angeles',34.139397,-118.350349),('91609','CA','North Hollywood','Los Angeles',34.1891,-118.387),('91610','CA','Toluca Lake','Los Angeles',34.1578,-118.3794),('91611','CA','North Hollywood','Los Angeles',34.1867,-118.3976),('91612','CA','North Hollywood','Los Angeles',34.1985,-118.3957),('91614','CA','Studio City','Los Angeles',34.1423,-118.3937),('91615','CA','North Hollywood','Los Angeles',34.1985,-118.3957),('91616','CA','North Hollywood','Los Angeles',34.184,-118.3964),('91617','CA','Valley Village','Los Angeles',34.1646,-118.4037),('91618','CA','North Hollywood','Los Angeles',34.1388,-118.3525),('91701','CA','Rancho Cucamonga','San Bernardino',34.131734,-117.594414),('91702','CA','Azusa','Los Angeles',34.139912,-117.904251),('91706','CA','Baldwin Park','Los Angeles',34.08718,-117.970773),('91708','CA','Chino','San Bernardino',33.951728,-117.639501),('91709','CA','Chino Hills','San Bernardino',33.975233,-117.724204),('91710','CA','Chino','San Bernardino',34.016422,-117.689932),('91711','CA','Claremont','Los Angeles',34.110008,-117.719803),('91714','CA','City Of Industry','Los Angeles',34.0197,-117.9577),('91715','CA','City Of Industry','Los Angeles',34.0197,-117.9577),('91716','CA','City Of Industry','Los Angeles',34.0197,-117.9577),('91722','CA','Covina','Los Angeles',34.095272,-117.90579),('91723','CA','Covina','Los Angeles',34.085339,-117.886845),('91724','CA','Covina','Los Angeles',34.086802,-117.855885),('91729','CA','Rancho Cucamonga','San Bernardino',34.0988,-117.5661),('91730','CA','Rancho Cucamonga','San Bernardino',34.103887,-117.588475),('91731','CA','El Monte','Los Angeles',34.076182,-118.040447),('91732','CA','El Monte','Los Angeles',34.07165,-118.015004),('91733','CA','South El Monte','Los Angeles',34.048492,-118.05071),('91734','CA','El Monte','Los Angeles',34.0735,-118.0319),('91735','CA','El Monte','Los Angeles',34.0735,-118.0319),('91737','CA','Rancho Cucamonga','San Bernardino',34.1478,-117.581442),('91739','CA','Rancho Cucamonga','San Bernardino',34.133684,-117.526663),('91740','CA','Glendora','Los Angeles',34.119365,-117.855605),('91741','CA','Glendora','Los Angeles',34.141044,-117.857167),('91743','CA','Guasti','San Bernardino',34.066655,-117.588313),('91744','CA','La Puente','Los Angeles',34.029604,-117.938353),('91745','CA','Hacienda Heights','Los Angeles',33.99939,-117.966963),('91746','CA','La Puente','Los Angeles',34.047173,-117.989187),('91747','CA','La Puente','Los Angeles',34.02,-117.9486),('91748','CA','Rowland Heights','Los Angeles',33.986347,-117.899352),('91749','CA','La Puente','Los Angeles',34.02,-117.9486),('91750','CA','La Verne','Los Angeles',34.116139,-117.769558),('91752','CA','Mira Loma','Riverside',33.992612,-117.533527),('91754','CA','Monterey Park','Los Angeles',34.05,-118.141713),('91755','CA','Monterey Park','Los Angeles',34.050965,-118.114394),('91756','CA','Monterey Park','Los Angeles',34.0625,-118.1249),('91758','CA','Ontario','San Bernardino',34.0631,-117.6197),('91759','CA','Mt Baldy','San Bernardino',34.237152,-117.658662),('91761','CA','Ontario','San Bernardino',34.037034,-117.605967),('91762','CA','Ontario','San Bernardino',34.055437,-117.663569),('91763','CA','Montclair','San Bernardino',34.073312,-117.69907),('91764','CA','Ontario','San Bernardino',34.075421,-117.617572),('91765','CA','Diamond Bar','Los Angeles',34.002501,-117.817663),('91766','CA','Pomona','Los Angeles',34.044975,-117.75513),('91767','CA','Pomona','Los Angeles',34.080806,-117.739166),('91768','CA','Pomona','Los Angeles',34.061538,-117.787282),('91769','CA','Pomona','Los Angeles',34.0601,-117.7575),('91770','CA','Rosemead','Los Angeles',34.065108,-118.082791),('91771','CA','Rosemead','Los Angeles',34.0807,-118.0757),('91772','CA','Rosemead','Los Angeles',34.0807,-118.0757),('91773','CA','San Dimas','Los Angeles',34.10299,-117.81401),('91775','CA','San Gabriel','Los Angeles',34.112787,-118.091071),('91776','CA','San Gabriel','Los Angeles',34.088952,-118.094468),('91778','CA','San Gabriel','Los Angeles',34.1024,-118.0987),('91780','CA','Temple City','Los Angeles',34.102077,-118.057754),('91784','CA','Upland','San Bernardino',34.13788,-117.661299),('91785','CA','Upland','San Bernardino',34.0996,-117.6461),('91786','CA','Upland','San Bernardino',34.103946,-117.654947),('91788','CA','Walnut','Los Angeles',34.0176,-117.8636),('91789','CA','Walnut','Los Angeles',34.018195,-117.854821),('91790','CA','West Covina','Los Angeles',34.068474,-117.937978),('91791','CA','West Covina','Los Angeles',34.06394,-117.896065),('91792','CA','West Covina','Los Angeles',34.021406,-117.899405),('91793','CA','West Covina','Los Angeles',34.0691,-117.9297),('91795','CA','Walnut','Los Angeles',34.0176,-117.8636),('91797','CA','Pomona','Los Angeles',34.0852,-117.96),('91798','CA','Ontario','San Bernardino',34.0631,-117.6197),('91799','CA','Pomona','Los Angeles',34.0552,-117.7513),('91801','CA','Alhambra','Los Angeles',34.08919,-118.127663),('91802','CA','Alhambra','Los Angeles',34.0931,-118.1257),('91803','CA','Alhambra','Los Angeles',34.072928,-118.144868),('91804','CA','Alhambra','Los Angeles',34.0952,-118.1261),('91841','CA','Alhambra','Los Angeles',34.093,-118.1248),('91896','CA','Alhambra','Los Angeles',34.093,-118.1248),('91899','CA','Alhambra','Los Angeles',34.093,-118.1248),('91901','CA','Alpine','San Diego',32.821891,-116.732986),('91902','CA','Bonita','San Diego',32.664727,-117.025211),('91903','CA','Alpine','San Diego',32.835,-116.7655),('91905','CA','Boulevard','San Diego',32.679711,-116.321215),('91906','CA','Campo','San Diego',32.658052,-116.476042),('91908','CA','Bonita','San Diego',32.6577,-117.0291),('91909','CA','Chula Vista','San Diego',32.64,-117.0833),('91910','CA','Chula Vista','San Diego',32.638967,-117.06426),('91911','CA','Chula Vista','San Diego',32.607965,-117.059459),('91912','CA','Chula Vista','San Diego',32.64,-117.0833),('91913','CA','Chula Vista','San Diego',32.63039,-116.984283),('91914','CA','Chula Vista','San Diego',32.660499,-116.955481),('91915','CA','Chula Vista','San Diego',32.629025,-116.951396),('91916','CA','Descanso','San Diego',32.888353,-116.622206),('91917','CA','Dulzura','San Diego',32.61704,-116.72255),('91921','CA','Chula Vista','San Diego',32.6248,-117.0142),('91931','CA','Guatay','San Diego',32.847072,-116.555925),('91932','CA','Imperial Beach','San Diego',32.579594,-117.117087),('91933','CA','Imperial Beach','San Diego',32.5838,-117.1122),('91934','CA','Jacumba','San Diego',32.637984,-116.175519),('91935','CA','Jamul','San Diego',32.7163,-116.814412),('91941','CA','La Mesa','San Diego',32.762215,-117.00003),('91942','CA','La Mesa','San Diego',32.776333,-117.023316),('91943','CA','La Mesa','San Diego',32.7677,-117.0222),('91944','CA','La Mesa','San Diego',32.7677,-117.0222),('91945','CA','Lemon Grove','San Diego',32.734022,-117.031184),('91946','CA','Lemon Grove','San Diego',32.7425,-117.0305),('91947','CA','Lincoln Acres','San Diego',32.6677,-117.0719),('91948','CA','Mount Laguna','San Diego',32.879386,-116.440794),('91950','CA','National City','San Diego',32.670647,-117.094668),('91951','CA','National City','San Diego',32.678,-117.0983),('91962','CA','Pine Valley','San Diego',32.764405,-116.487886),('91963','CA','Potrero','San Diego',32.620462,-116.605823),('91976','CA','Spring Valley','San Diego',32.7447,-116.998),('91977','CA','Spring Valley','San Diego',32.721152,-116.996165),('91978','CA','Spring Valley','San Diego',32.728665,-116.952455),('91979','CA','Spring Valley','San Diego',32.7447,-116.998),('91980','CA','Tecate','San Diego',32.590003,-116.622376),('91987','CA','Tecate','San Diego',32.5772,-116.6266),('91990','CA','Potrero','San Diego',32.6047,-116.6122),('92003','CA','Bonsall','San Diego',33.288739,-117.201068),('92004','CA','Borrego Springs','San Diego',33.194796,-116.258987),('92007','CA','Cardiff By The Sea','San Diego',33.022928,-117.276784),('92008','CA','Carlsbad','San Diego',33.15543,-117.333112),('92009','CA','Carlsbad','San Diego',33.096169,-117.247807),('92010','CA','Carlsbad','San Diego',33.163695,-117.296738),('92011','CA','Carlsbad','San Diego',33.105385,-117.300203),('92013','CA','Carlsbad','San Diego',33.0986,-117.2788),('92014','CA','Del Mar','San Diego',32.962171,-117.256326),('92018','CA','Carlsbad','San Diego',33.1626,-117.3489),('92019','CA','El Cajon','San Diego',32.782273,-116.902596),('92020','CA','El Cajon','San Diego',32.793831,-116.969941),('92021','CA','El Cajon','San Diego',32.823483,-116.906405),('92022','CA','El Cajon','San Diego',32.7922,-116.9678),('92023','CA','Encinitas','San Diego',33.0376,-117.2933),('92024','CA','Encinitas','San Diego',33.053784,-117.268482),('92025','CA','Escondido','San Diego',33.105611,-117.066551),('92026','CA','Escondido','San Diego',33.190278,-117.110933),('92027','CA','Escondido','San Diego',33.14227,-117.03055),('92028','CA','Fallbrook','San Diego',33.380101,-117.205587),('92029','CA','Escondido','San Diego',33.090524,-117.125953),('92030','CA','Escondido','San Diego',33.1362,-117.0543),('92033','CA','Escondido','San Diego',33.1236,-117.086),('92036','CA','Julian','San Diego',33.040345,-116.543594),('92037','CA','La Jolla','San Diego',32.840097,-117.262737),('92038','CA','La Jolla','San Diego',32.8473,-117.2719),('92039','CA','La Jolla','San Diego',32.8473,-117.2719),('92040','CA','Lakeside','San Diego',32.874006,-116.909531),('92046','CA','Escondido','San Diego',33.1249,-117.1016),('92049','CA','Oceanside','San Diego',33.1951,-117.3776),('92051','CA','Oceanside','San Diego',33.199,-117.3668),('92052','CA','Oceanside','San Diego',33.199,-117.3668),('92054','CA','Oceanside','San Diego',33.196617,-117.369942),('92055','CA','Camp Pendleton','San Diego',33.351059,-117.420557),('92056','CA','Oceanside','San Diego',33.195006,-117.284735),('92057','CA','Oceanside','San Diego',33.243051,-117.296856),('92058','CA','Oceanside','San Diego',33.239145,-117.354207),('92059','CA','Pala','San Diego',33.36909,-117.072635),('92060','CA','Palomar Mountain','San Diego',33.309029,-116.822334),('92061','CA','Pauma Valley','San Diego',33.314381,-116.95713),('92064','CA','Poway','San Diego',32.972929,-117.037578),('92065','CA','Ramona','San Diego',33.034799,-116.853546),('92066','CA','Ranchita','San Diego',33.216172,-116.520987),('92067','CA','Rancho Santa Fe','San Diego',33.020908,-117.190346),('92068','CA','San Luis Rey','San Diego',33.2289,-117.3267),('92069','CA','San Marcos','San Diego',33.155979,-117.155643),('92070','CA','Santa Ysabel','San Diego',33.156764,-116.70698),('92071','CA','Santee','San Diego',32.845334,-116.992178),('92072','CA','Santee','San Diego',32.8312,-117.038),('92074','CA','Poway','San Diego',32.9567,-117.0361),('92075','CA','Solana Beach','San Diego',32.997249,-117.26058),('92078','CA','San Marcos','San Diego',33.12516,-117.190495),('92079','CA','San Marcos','San Diego',33.1433,-117.1652),('92081','CA','Vista','San Diego',33.168972,-117.242555),('92082','CA','Valley Center','San Diego',33.260681,-117.035046),('92083','CA','Vista','San Diego',33.195806,-117.24968),('92084','CA','Vista','San Diego',33.215284,-117.214193),('92085','CA','Vista','San Diego',33.192,-117.2322),('92086','CA','Warner Springs','San Diego',33.324101,-116.695363),('92088','CA','Fallbrook','San Diego',33.3667,-117.2496),('92090','CA','El Cajon','San Diego',32.7947,-116.9616),('92091','CA','Rancho Santa Fe','San Diego',32.993953,-117.212617),('92092','CA','La Jolla','San Diego',32.8763,-117.2358),('92093','CA','La Jolla','San Diego',32.8789,-117.2315),('92096','CA','San Marcos','San Diego',33.1315,-117.1643),('92101','CA','San Diego','San Diego',32.720405,-117.164303),('92102','CA','San Diego','San Diego',32.714779,-117.122132),('92103','CA','San Diego','San Diego',32.747853,-117.165842),('92104','CA','San Diego','San Diego',32.744693,-117.127957),('92105','CA','San Diego','San Diego',32.741178,-117.097184),('92106','CA','San Diego','San Diego',32.722027,-117.232152),('92107','CA','San Diego','San Diego',32.740174,-117.244899),('92108','CA','San Diego','San Diego',32.773662,-117.137176),('92109','CA','San Diego','San Diego',32.791951,-117.241871),('92110','CA','San Diego','San Diego',32.765244,-117.200391),('92111','CA','San Diego','San Diego',32.804892,-117.168876),('92112','CA','San Diego','San Diego',32.7246,-117.1648),('92113','CA','San Diego','San Diego',32.695388,-117.121988),('92114','CA','San Diego','San Diego',32.707148,-117.054237),('92115','CA','San Diego','San Diego',32.75909,-117.069984),('92116','CA','San Diego','San Diego',32.763138,-117.124449),('92117','CA','San Diego','San Diego',32.824826,-117.197571),('92118','CA','Coronado','San Diego',32.683125,-117.177716),('92119','CA','San Diego','San Diego',32.802273,-117.023708),('92120','CA','San Diego','San Diego',32.793845,-117.073651),('92121','CA','San Diego','San Diego',32.899925,-117.206261),('92122','CA','San Diego','San Diego',32.856552,-117.191668),('92123','CA','San Diego','San Diego',32.805619,-117.137853),('92124','CA','San Diego','San Diego',32.823029,-117.098033),('92126','CA','San Diego','San Diego',32.908825,-117.139997),('92127','CA','San Diego','San Diego',33.014061,-117.122883),('92128','CA','San Diego','San Diego',32.999383,-117.071377),('92129','CA','San Diego','San Diego',32.962041,-117.128589),('92130','CA','San Diego','San Diego',32.946592,-117.213184),('92131','CA','San Diego','San Diego',32.910742,-117.092118),('92132','CA','San Diego','San Diego',32.7152,-117.1563),('92133','CA','San Diego','San Diego',32.7256,-117.2177),('92134','CA','San Diego','San Diego',32.724925,-117.146385),('92135','CA','San Diego','San Diego',32.699673,-117.19103),('92136','CA','San Diego','San Diego',32.6814,-117.1211),('92137','CA','San Diego','San Diego',32.7481,-117.203),('92138','CA','San Diego','San Diego',32.7481,-117.203),('92139','CA','San Diego','San Diego',32.677543,-117.052731),('92140','CA','San Diego','San Diego',32.741279,-117.197714),('92142','CA','San Diego','San Diego',32.8398,-117.0973),('92143','CA','San Ysidro','San Diego',32.5519,-117.0422),('92145','CA','San Diego','San Diego',32.925191,-117.018854),('92147','CA','San Diego','San Diego',32.723987,-117.220431),('92149','CA','San Diego','San Diego',32.6759,-117.0643),('92150','CA','San Diego','San Diego',32.9847,-117.0786),('92152','CA','San Diego','San Diego',32.7023,-117.2448),('92153','CA','San Diego','San Diego',32.5656,-117.0805),('92154','CA','San Diego','San Diego',32.574305,-117.051422),('92155','CA','San Diego','San Diego',32.674692,-117.162487),('92158','CA','San Diego','San Diego',32.5666,-116.9716),('92159','CA','San Diego','San Diego',32.8015,-117.0136),('92160','CA','San Diego','San Diego',32.7822,-117.0946),('92161','CA','San Diego','San Diego',32.8717,-117.2319),('92162','CA','San Diego','San Diego',32.7171,-117.1354),('92163','CA','San Diego','San Diego',32.7476,-117.1665),('92164','CA','San Diego','San Diego',32.7474,-117.1273),('92165','CA','San Diego','San Diego',32.7496,-117.1039),('92166','CA','San Diego','San Diego',32.7211,-117.2305),('92167','CA','San Diego','San Diego',32.7458,-117.2468),('92168','CA','San Diego','San Diego',32.7654,-117.1546),('92169','CA','San Diego','San Diego',32.799,-117.2518),('92170','CA','San Diego','San Diego',32.697,-117.1335),('92171','CA','San Diego','San Diego',32.783,-117.1702),('92172','CA','San Diego','San Diego',32.9627,-117.1329),('92173','CA','San Ysidro','San Diego',32.556562,-117.050456),('92174','CA','San Diego','San Diego',32.7063,-117.0844),('92175','CA','San Diego','San Diego',32.7651,-117.0598),('92176','CA','San Diego','San Diego',32.7636,-117.1225),('92177','CA','San Diego','San Diego',32.8334,-117.2009),('92178','CA','Coronado','San Diego',32.6839,-117.1772),('92179','CA','San Diego','San Diego',32.5666,-116.9716),('92182','CA','San Diego','San Diego',32.7768,-117.0702),('92184','CA','San Diego','San Diego',32.7152,-117.1563),('92186','CA','San Diego','San Diego',32.7481,-117.203),('92187','CA','San Diego','San Diego',32.7481,-117.203),('92190','CA','San Diego','San Diego',32.7822,-117.0946),('92191','CA','San Diego','San Diego',32.9025,-117.218),('92192','CA','San Diego','San Diego',32.8508,-117.2133),('92193','CA','San Diego','San Diego',32.8014,-117.139),('92194','CA','San Diego','San Diego',32.8014,-117.139),('92195','CA','San Diego','San Diego',32.7442,-117.0525),('92196','CA','San Diego','San Diego',32.9163,-117.1292),('92197','CA','San Diego','San Diego',32.8334,-117.2009),('92198','CA','San Diego','San Diego',33.0222,-117.0739),('92199','CA','San Diego','San Diego',32.9954,-117.0722),('92201','CA','Indio','Riverside',33.71394,-116.226901),('92202','CA','Indio','Riverside',33.7274,-116.2085),('92203','CA','Indio','Riverside',33.752102,-116.24527),('92210','CA','Indian Wells','Riverside',33.71583,-116.336877),('92211','CA','Palm Desert','Riverside',33.763452,-116.317995),('92220','CA','Banning','Riverside',33.920828,-116.873439),('92222','CA','Bard','Imperial',32.7891,-114.5552),('92223','CA','Beaumont','Riverside',33.943518,-116.980555),('92225','CA','Blythe','Riverside',33.634471,-114.607847),('92226','CA','Blythe','Riverside',33.612,-114.5985),('92227','CA','Brawley','Imperial',32.989728,-115.496377),('92230','CA','Cabazon','Riverside',33.912559,-116.767752),('92231','CA','Calexico','Imperial',32.682681,-115.506359),('92232','CA','Calexico','Imperial',32.6792,-115.5011),('92233','CA','Calipatria','Imperial',33.136696,-115.517148),('92234','CA','Cathedral City','Riverside',33.810503,-116.464979),('92235','CA','Cathedral City','Riverside',33.7799,-116.4615),('92236','CA','Coachella','Riverside',33.684077,-116.179992),('92239','CA','Desert Center','Riverside',33.78949,-115.453191),('92240','CA','Desert Hot Springs','Riverside',33.954621,-116.508497),('92241','CA','Desert Hot Springs','Riverside',33.900337,-116.392753),('92242','CA','Earp','San Bernardino',34.137103,-114.34616),('92243','CA','El Centro','Imperial',32.782755,-115.579984),('92244','CA','El Centro','Imperial',32.7926,-115.5769),('92247','CA','La Quinta','Riverside',33.677978,-116.297229),('92248','CA','La Quinta','Riverside',33.677978,-116.297229),('92249','CA','Heber','Imperial',32.727378,-115.500065),('92250','CA','Holtville','Imperial',32.807443,-115.341724),('92251','CA','Imperial','Imperial',32.850982,-115.599297),('92252','CA','Joshua Tree','San Bernardino',34.180188,-116.289156),('92253','CA','La Quinta','Riverside',33.674994,-116.291559),('92254','CA','Mecca','Riverside',33.550401,-115.993267),('92255','CA','Palm Desert','Riverside',33.7222,-116.3736),('92256','CA','Morongo Valley','San Bernardino',34.06794,-116.556386),('92257','CA','Niland','Imperial',33.291935,-115.518606),('92258','CA','North Palm Springs','Riverside',33.923044,-116.568677),('92259','CA','Ocotillo','Imperial',32.720971,-115.96534),('92260','CA','Palm Desert','Riverside',33.718797,-116.386004),('92261','CA','Palm Desert','Riverside',33.7222,-116.3736),('92262','CA','Palm Springs','Riverside',33.84671,-116.543407),('92263','CA','Palm Springs','Riverside',33.8266,-116.5438),('92264','CA','Palm Springs','Riverside',33.798701,-116.518819),('92266','CA','Palo Verde','Imperial',33.369717,-114.76964),('92267','CA','Parker Dam','San Bernardino',34.26293,-114.171335),('92268','CA','Pioneertown','San Bernardino',34.194463,-116.547143),('92270','CA','Rancho Mirage','Riverside',33.77167,-116.424801),('92273','CA','Seeley','Imperial',32.803754,-115.690553),('92274','CA','Thermal','Riverside',33.445189,-116.061122),('92275','CA','Salton City','Imperial',33.285367,-115.951682),('92276','CA','Thousand Palms','Riverside',33.813894,-116.380378),('92277','CA','Twentynine Palms','San Bernardino',34.184031,-115.989799),('92278','CA','Twentynine Palms','San Bernardino',34.231517,-116.056046),('92280','CA','Vidal','San Bernardino',34.143497,-114.624113),('92281','CA','Westmorland','Imperial',33.044729,-115.617267),('92282','CA','White Water','Riverside',33.936213,-116.642481),('92283','CA','Winterhaven','Imperial',32.798116,-114.681182),('92284','CA','Yucca Valley','San Bernardino',34.161977,-116.415868),('92285','CA','Landers','San Bernardino',34.306984,-116.444869),('92286','CA','Yucca Valley','San Bernardino',34.3806,-116.4705),('92292','CA','Palm Springs','Riverside',33.8302,-116.5444),('92301','CA','Adelanto','San Bernardino',34.598616,-117.484777),('92304','CA','Amboy','San Bernardino',34.550585,-115.693406),('92305','CA','Angelus Oaks','San Bernardino',34.162316,-116.881729),('92307','CA','Apple Valley','San Bernardino',34.554416,-117.184743),('92308','CA','Apple Valley','San Bernardino',34.44601,-117.178126),('92309','CA','Baker','San Bernardino',35.256181,-116.085964),('92310','CA','Fort Irwin','San Bernardino',35.260283,-116.690409),('92311','CA','Barstow','San Bernardino',34.890341,-117.033919),('92312','CA','Barstow','San Bernardino',35.0298,-117.2244),('92313','CA','Grand Terrace','San Bernardino',34.031258,-117.314994),('92314','CA','Big Bear City','San Bernardino',34.259185,-116.824653),('92315','CA','Big Bear Lake','San Bernardino',34.241698,-116.901303),('92316','CA','Bloomington','San Bernardino',34.06191,-117.394038),('92317','CA','Blue Jay','San Bernardino',34.245607,-117.230005),('92318','CA','Bryn Mawr','San Bernardino',34.048544,-117.23274),('92320','CA','Calimesa','Riverside',33.982559,-117.041531),('92321','CA','Cedar Glen','San Bernardino',34.254192,-117.162017),('92322','CA','Cedarpines Park','San Bernardino',34.248482,-117.322648),('92323','CA','Cima','San Bernardino',35.187237,-115.397274),('92324','CA','Colton','San Bernardino',34.058066,-117.313582),('92325','CA','Crestline','San Bernardino',34.241421,-117.281668),('92326','CA','Crest Park','San Bernardino',34.2338,-117.1955),('92327','CA','Daggett','San Bernardino',34.860225,-116.855604),('92328','CA','Death Valley','Inyo',36.503543,-116.872288),('92329','CA','Phelan','San Bernardino',34.4261,-117.5713),('92331','CA','Fontana','San Bernardino',34.0922,-117.4612),('92332','CA','Essex','San Bernardino',35.012857,-115.277623),('92333','CA','Fawnskin','San Bernardino',34.269633,-116.947492),('92334','CA','Fontana','San Bernardino',34.1034,-117.4352),('92335','CA','Fontana','San Bernardino',34.089124,-117.451774),('92336','CA','Fontana','San Bernardino',34.131771,-117.460937),('92337','CA','Fontana','San Bernardino',34.047139,-117.477093),('92338','CA','Ludlow','San Bernardino',34.720285,-116.1982),('92339','CA','Forest Falls','San Bernardino',34.08765,-116.923301),('92340','CA','Hesperia','San Bernardino',34.4157,-117.287),('92341','CA','Green Valley Lake','San Bernardino',34.238519,-117.073259),('92342','CA','Helendale','San Bernardino',34.765804,-117.325809),('92344','CA','Hesperia','San Bernardino',34.39643,-117.403154),('92345','CA','Hesperia','San Bernardino',34.407931,-117.306768),('92346','CA','Highland','San Bernardino',34.12591,-117.197395),('92347','CA','Hinkley','San Bernardino',34.935754,-117.205115),('92350','CA','Loma Linda','San Bernardino',34.0524,-117.2618),('92352','CA','Lake Arrowhead','San Bernardino',34.259454,-117.203658),('92354','CA','Loma Linda','San Bernardino',34.05145,-117.248816),('92356','CA','Lucerne Valley','San Bernardino',34.469607,-116.923711),('92357','CA','Loma Linda','San Bernardino',34.0508,-117.2602),('92358','CA','Lytle Creek','San Bernardino',34.259049,-117.500622),('92359','CA','Mentone','San Bernardino',34.077115,-117.098657),('92363','CA','Needles','San Bernardino',34.769319,-114.585032),('92364','CA','Nipton','San Bernardino',35.38426,-115.467698),('92365','CA','Newberry Springs','San Bernardino',34.892663,-116.658138),('92366','CA','Mountain Pass','San Bernardino',35.6225,-115.6108),('92368','CA','Oro Grande','San Bernardino',34.633017,-117.33135),('92369','CA','Patton','San Bernardino',34.1358,-117.223),('92371','CA','Phelan','San Bernardino',34.453987,-117.534459),('92372','CA','Pinon Hills','San Bernardino',34.45254,-117.626448),('92373','CA','Redlands','San Bernardino',34.034527,-117.173499),('92374','CA','Redlands','San Bernardino',34.06451,-117.170543),('92375','CA','Redlands','San Bernardino',34.0595,-117.1947),('92376','CA','Rialto','San Bernardino',34.107906,-117.37256),('92377','CA','Rialto','San Bernardino',34.149759,-117.398864),('92378','CA','Rimforest','San Bernardino',34.228778,-117.227344),('92382','CA','Running Springs','San Bernardino',34.20779,-117.108405),('92384','CA','Shoshone','Inyo',35.996465,-116.25453),('92385','CA','Skyforest','San Bernardino',34.234794,-117.177732),('92386','CA','Sugarloaf','San Bernardino',34.243411,-116.829416),('92389','CA','Tecopa','Inyo',35.854702,-116.192226),('92391','CA','Twin Peaks','San Bernardino',34.23825,-117.237251),('92392','CA','Victorville','San Bernardino',34.480405,-117.396609),('92393','CA','Victorville','San Bernardino',34.5361,-117.2902),('92394','CA','Victorville','San Bernardino',34.549442,-117.35408),('92395','CA','Victorville','San Bernardino',34.504828,-117.298991),('92397','CA','Wrightwood','San Bernardino',34.358832,-117.627516),('92398','CA','Yermo','San Bernardino',34.908189,-116.852775),('92399','CA','Yucaipa','San Bernardino',34.03441,-117.031186),('92401','CA','San Bernardino','San Bernardino',34.10505,-117.290794),('92402','CA','San Bernardino','San Bernardino',34.1085,-117.2904),('92403','CA','San Bernardino','San Bernardino',34.1083,-117.2888),('92404','CA','San Bernardino','San Bernardino',34.149959,-117.262972),('92405','CA','San Bernardino','San Bernardino',34.141757,-117.297115),('92406','CA','San Bernardino','San Bernardino',34.1351,-117.2891),('92407','CA','San Bernardino','San Bernardino',34.192046,-117.36277),('92408','CA','San Bernardino','San Bernardino',34.080537,-117.271882),('92410','CA','San Bernardino','San Bernardino',34.105967,-117.300219),('92411','CA','San Bernardino','San Bernardino',34.123179,-117.317151),('92412','CA','San Bernardino','San Bernardino',34.1083,-117.2888),('92413','CA','San Bernardino','San Bernardino',34.141,-117.2504),('92414','CA','San Bernardino','San Bernardino',34.1083,-117.2888),('92415','CA','San Bernardino','San Bernardino',34.1083,-117.2862),('92418','CA','San Bernardino','San Bernardino',34.1083,-117.2888),('92423','CA','San Bernardino','San Bernardino',34.1083,-117.2888),('92424','CA','San Bernardino','San Bernardino',34.1083,-117.2888),('92427','CA','San Bernardino','San Bernardino',34.1982,-117.3405),('92501','CA','Riverside','Riverside',33.992042,-117.372932),('92502','CA','Riverside','Riverside',33.9805,-117.3727),('92503','CA','Riverside','Riverside',33.905253,-117.458782),('92504','CA','Riverside','Riverside',33.922155,-117.407238),('92505','CA','Riverside','Riverside',33.920148,-117.48876),('92506','CA','Riverside','Riverside',33.944876,-117.373171),('92507','CA','Riverside','Riverside',33.977128,-117.338282),('92508','CA','Riverside','Riverside',33.894351,-117.322416),('92509','CA','Riverside','Riverside',33.998417,-117.447133),('92513','CA','Riverside','Riverside',33.9151,-117.4626),('92514','CA','Riverside','Riverside',33.946,-117.415),('92515','CA','Riverside','Riverside',33.9187,-117.4887),('92516','CA','Riverside','Riverside',33.9547,-117.3936),('92517','CA','Riverside','Riverside',33.9723,-117.3474),('92518','CA','March Air Reserve Base','Riverside',33.891701,-117.273779),('92519','CA','Riverside','Riverside',33.9957,-117.4128),('92521','CA','Riverside','Riverside',33.9693,-117.3332),('92522','CA','Riverside','Riverside',33.9723,-117.3474),('92530','CA','Lake Elsinore','Riverside',33.676166,-117.349407),('92531','CA','Lake Elsinore','Riverside',33.6074,-117.3905),('92532','CA','Lake Elsinore','Riverside',33.685412,-117.303788),('92536','CA','Aguanga','Riverside',33.49293,-116.847803),('92539','CA','Anza','Riverside',33.544292,-116.685747),('92543','CA','Hemet','Riverside',33.734385,-116.974103),('92544','CA','Hemet','Riverside',33.70693,-116.909191),('92545','CA','Hemet','Riverside',33.741928,-117.021078),('92546','CA','Hemet','Riverside',33.7475,-116.9711),('92548','CA','Homeland','Riverside',33.747163,-117.113561),('92549','CA','Idyllwild','Riverside',33.752267,-116.725969),('92551','CA','Moreno Valley','Riverside',33.885772,-117.222514),('92552','CA','Moreno Valley','Riverside',33.9175,-117.1569),('92553','CA','Moreno Valley','Riverside',33.923157,-117.245326),('92554','CA','Moreno Valley','Riverside',33.9175,-117.1569),('92555','CA','Moreno Valley','Riverside',33.911939,-117.158847),('92556','CA','Moreno Valley','Riverside',33.9175,-117.1569),('92557','CA','Moreno Valley','Riverside',33.959763,-117.249313),('92561','CA','Mountain Center','Riverside',33.629255,-116.584444),('92562','CA','Murrieta','Riverside',33.566589,-117.248655),('92563','CA','Murrieta','Riverside',33.569638,-117.147968),('92564','CA','Murrieta','Riverside',33.552,-117.2106),('92567','CA','Nuevo','Riverside',33.811046,-117.119771),('92570','CA','Perris','Riverside',33.784523,-117.298096),('92571','CA','Perris','Riverside',33.826545,-117.215134),('92572','CA','Perris','Riverside',33.7825,-117.2277),('92581','CA','San Jacinto','Riverside',33.7838,-116.9577),('92582','CA','San Jacinto','Riverside',33.791814,-117.000361),('92583','CA','San Jacinto','Riverside',33.789632,-116.951278),('92584','CA','Menifee','Riverside',33.666756,-117.179644),('92585','CA','Sun City','Riverside',33.739394,-117.173913),('92586','CA','Sun City','Riverside',33.706718,-117.1985),('92587','CA','Sun City','Riverside',33.694796,-117.25013),('92589','CA','Temecula','Riverside',33.4936,-117.1475),('92590','CA','Temecula','Riverside',33.47971,-117.209374),('92591','CA','Temecula','Riverside',33.530349,-117.123503),('92592','CA','Temecula','Riverside',33.500353,-117.068017),('92593','CA','Temecula','Riverside',33.4936,-117.1475),('92595','CA','Wildomar','Riverside',33.612792,-117.258206),('92596','CA','Winchester','Riverside',33.649085,-117.091527),('92599','CA','Perris','Riverside',33.7825,-117.2277),('92602','CA','Irvine','Orange',33.740915,-117.76697),('92603','CA','Irvine','Orange',33.632027,-117.807345),('92604','CA','Irvine','Orange',33.688361,-117.789413),('92605','CA','Huntington Beach','Orange',33.7152,-118.0088),('92606','CA','Irvine','Orange',33.698247,-117.815118),('92607','CA','Laguna Niguel','Orange',33.5252,-117.7086),('92609','CA','El Toro','Orange',33.5955,-117.7077),('92610','CA','Foothill Ranch','Orange',33.682629,-117.666044),('92612','CA','Irvine','Orange',33.661639,-117.828952),('92614','CA','Irvine','Orange',33.678822,-117.827487),('92615','CA','Huntington Beach','Orange',33.6574,-117.968),('92616','CA','Irvine','Orange',33.6699,-117.7646),('92617','CA','Irvine','Orange',33.64359,-117.841528),('92618','CA','Irvine','Orange',33.663083,-117.744313),('92619','CA','Irvine','Orange',33.6699,-117.7646),('92620','CA','Irvine','Orange',33.711022,-117.758519),('92623','CA','Irvine','Orange',33.6699,-117.7646),('92624','CA','Capistrano Beach','Orange',33.46042,-117.665026),('92625','CA','Corona Del Mar','Orange',33.600277,-117.869206),('92626','CA','Costa Mesa','Orange',33.678801,-117.906828),('92627','CA','Costa Mesa','Orange',33.644829,-117.917098),('92628','CA','Costa Mesa','Orange',33.6411,-117.9177),('92629','CA','Dana Point','Orange',33.475573,-117.703455),('92630','CA','Lake Forest','Orange',33.640861,-117.691914),('92637','CA','Laguna W','Orange',33.608473,-117.732779),('92646','CA','Huntington Beach','Orange',33.668615,-117.96645),('92647','CA','Huntington Beach','Orange',33.723579,-118.005441),('92648','CA','Huntington Beach','Orange',33.675514,-118.001638),('92649','CA','Huntington Beach','Orange',33.722257,-118.047357),('92650','CA','East Irvine','Orange',33.6766,-117.758),('92651','CA','Laguna Beach','Orange',33.538685,-117.77364),('92652','CA','Laguna Beach','Orange',33.5434,-117.7817),('92653','CA','Laguna Hills','Orange',33.595043,-117.701247),('92654','CA','Laguna Hills','Orange',33.6125,-117.7119),('92655','CA','Midway City','Orange',33.744648,-117.985738),('92656','CA','Aliso Viejo','Orange',33.580573,-117.725166),('92657','CA','Newport Coast','Orange',33.597592,-117.832348),('92658','CA','Newport Beach','Orange',33.6398,-117.8643),('92659','CA','Newport Beach','Orange',33.6208,-117.923),('92660','CA','Newport Beach','Orange',33.634626,-117.874882),('92661','CA','Newport Beach','Orange',33.602743,-117.902398),('92662','CA','Newport Beach','Orange',33.606336,-117.893042),('92663','CA','Newport Beach','Orange',33.619057,-117.930257),('92672','CA','San Clemente','Orange',33.428844,-117.614231),('92673','CA','San Clemente','Orange',33.459808,-117.616691),('92674','CA','San Clemente','Orange',33.4384,-117.6219),('92675','CA','San Juan Capistrano','Orange',33.501227,-117.651621),('92676','CA','Silverado','Orange',33.744271,-117.652841),('92677','CA','Laguna Niguel','Orange',33.535132,-117.699991),('92678','CA','Trabuco Canyon','Orange',33.673422,-117.551489),('92679','CA','Trabuco Canyon','Orange',33.631434,-117.594027),('92683','CA','Westminster','Orange',33.752504,-117.991878),('92684','CA','Westminster','Orange',33.7436,-117.9991),('92685','CA','Westminster','Orange',33.7522,-117.9933),('92688','CA','Rancho Santa Margarita','Orange',33.632388,-117.605105),('92690','CA','Mission Viejo','Orange',33.6,-117.6711),('92691','CA','Mission Viejo','Orange',33.609503,-117.665911),('92692','CA','Mission Viejo','Orange',33.61289,-117.64489),('92693','CA','San Juan Capistrano','Orange',33.5685,-117.5527),('92694','CA','Ladera Ranch','Orange',33.55214,-117.638644),('92697','CA','Irvine','Orange',33.648,-117.841),('92698','CA','Aliso Viejo','Orange',33.6699,-117.7646),('92701','CA','Santa Ana','Orange',33.746723,-117.859792),('92702','CA','Santa Ana','Orange',33.75,-117.8665),('92703','CA','Santa Ana','Orange',33.747,-117.903803),('92704','CA','Santa Ana','Orange',33.722364,-117.907948),('92705','CA','Santa Ana','Orange',33.753747,-117.831573),('92706','CA','Santa Ana','Orange',33.765301,-117.881976),('92707','CA','Santa Ana','Orange',33.716894,-117.870755),('92708','CA','Fountain Valley','Orange',33.710792,-117.95294),('92709','CA','Irvine','Orange',33.6782,-117.7301),('92710','CA','Irvine','Orange',33.7072,-117.8188),('92711','CA','Santa Ana','Orange',33.7655,-117.8506),('92712','CA','Santa Ana','Orange',33.7455,-117.8669),('92725','CA','Santa Ana','Orange',33.7484,-117.8593),('92728','CA','Fountain Valley','Orange',33.7128,-117.9278),('92735','CA','Santa Ana','Orange',33.7455,-117.8669),('92780','CA','Tustin','Orange',33.734777,-117.821477),('92781','CA','Tustin','Orange',33.7303,-117.7971),('92782','CA','Tustin','Orange',33.73389,-117.790352),('92799','CA','Santa Ana','Orange',33.7655,-117.8506),('92801','CA','Anaheim','Orange',33.846367,-117.95347),('92802','CA','Anaheim','Orange',33.807952,-117.926216),('92803','CA','Anaheim','Orange',33.8415,-117.9364),('92804','CA','Anaheim','Orange',33.819183,-117.976356),('92805','CA','Anaheim','Orange',33.833786,-117.909943),('92806','CA','Anaheim','Orange',33.836722,-117.87533),('92807','CA','Anaheim','Orange',33.851872,-117.794208),('92808','CA','Anaheim','Orange',33.859456,-117.739503),('92809','CA','Anaheim','Orange',33.8444,-117.9519),('92811','CA','Atwood','Orange',33.881,-117.8561),('92812','CA','Anaheim','Orange',33.8178,-117.9272),('92814','CA','Anaheim','Orange',33.8177,-117.9604),('92815','CA','Anaheim','Orange',33.8333,-117.9126),('92816','CA','Anaheim','Orange',33.8391,-117.8832),('92817','CA','Anaheim','Orange',33.852,-117.7924),('92821','CA','Brea','Orange',33.924955,-117.892843),('92822','CA','Brea','Orange',33.9174,-117.8895),('92823','CA','Brea','Orange',33.926541,-117.829327),('92825','CA','Anaheim','Orange',33.8352,-117.9136),('92831','CA','Fullerton','Orange',33.879562,-117.89282),('92832','CA','Fullerton','Orange',33.869542,-117.927564),('92833','CA','Fullerton','Orange',33.87477,-117.963695),('92834','CA','Fullerton','Orange',33.8784,-117.8964),('92835','CA','Fullerton','Orange',33.902288,-117.907882),('92836','CA','Fullerton','Orange',33.8784,-117.8964),('92837','CA','Fullerton','Orange',33.8697,-117.963),('92838','CA','Fullerton','Orange',33.8784,-117.8964),('92840','CA','Garden Grove','Orange',33.786675,-117.933973),('92841','CA','Garden Grove','Orange',33.786997,-117.979268),('92842','CA','Garden Grove','Orange',33.7777,-117.9495),('92843','CA','Garden Grove','Orange',33.763316,-117.931948),('92844','CA','Garden Grove','Orange',33.765718,-117.972339),('92845','CA','Garden Grove','Orange',33.783969,-118.026181),('92846','CA','Garden Grove','Orange',33.7777,-117.9495),('92850','CA','Anaheim','Orange',33.8415,-117.9364),('92856','CA','Orange','Orange',33.7877,-117.8755),('92857','CA','Orange','Orange',33.7877,-117.8755),('92859','CA','Orange','Orange',33.7877,-117.8755),('92860','CA','Norco','Riverside',33.925395,-117.555315),('92861','CA','Villa Park','Orange',33.817441,-117.808396),('92862','CA','Orange','Orange',33.813,-117.7143),('92863','CA','Orange','Orange',33.7877,-117.8755),('92864','CA','Orange','Orange',33.8146,-117.8271),('92865','CA','Orange','Orange',33.829148,-117.846346),('92866','CA','Orange','Orange',33.784896,-117.847665),('92867','CA','Orange','Orange',33.812744,-117.829074),('92868','CA','Orange','Orange',33.788145,-117.87655),('92869','CA','Orange','Orange',33.793487,-117.791625),('92870','CA','Placentia','Orange',33.882061,-117.855584),('92871','CA','Placentia','Orange',33.8788,-117.8548),('92877','CA','Corona','Riverside',33.8815,-117.6078),('92878','CA','Corona','Riverside',33.8774,-117.5739),('92879','CA','Corona','Riverside',33.880737,-117.541293),('92880','CA','Corona','Riverside',33.931223,-117.596395),('92881','CA','Corona','Riverside',33.835289,-117.535854),('92882','CA','Corona','Riverside',33.865618,-117.592531),('92883','CA','Corona','Riverside',33.763138,-117.471681),('92885','CA','Yorba Linda','Orange',33.8913,-117.8191),('92886','CA','Yorba Linda','Orange',33.891291,-117.80487),('92887','CA','Yorba Linda','Orange',33.878015,-117.747593),('92899','CA','Anaheim','Orange',33.8415,-117.9364),('93001','CA','Ventura','Ventura',34.314076,-119.316784),('93002','CA','Ventura','Ventura',34.3557,-119.3011),('93003','CA','Ventura','Ventura',34.269236,-119.224055),('93004','CA','Ventura','Ventura',34.278697,-119.167798),('93005','CA','Ventura','Ventura',34.2509,-119.2058),('93006','CA','Ventura','Ventura',34.2783,-119.2922),('93007','CA','Ventura','Ventura',34.2918,-119.1569),('93009','CA','Ventura','Ventura',34.27,-119.2123),('93010','CA','Camarillo','Ventura',34.230241,-119.051972),('93011','CA','Camarillo','Ventura',34.2163,-119.0366),('93012','CA','Camarillo','Ventura',34.215539,-118.993683),('93013','CA','Carpinteria','Santa Barbara',34.401743,-119.518641),('93014','CA','Carpinteria','Santa Barbara',34.3947,-119.5127),('93015','CA','Fillmore','Ventura',34.395884,-118.909083),('93016','CA','Fillmore','Ventura',34.3999,-118.9128),('93020','CA','Moorpark','Ventura',34.2855,-118.8811),('93021','CA','Moorpark','Ventura',34.289849,-118.880725),('93022','CA','Oak View','Ventura',34.401936,-119.298169),('93023','CA','Ojai','Ventura',34.453562,-119.253148),('93024','CA','Ojai','Ventura',34.4417,-119.2593),('93030','CA','Oxnard','Ventura',34.205714,-119.174854),('93031','CA','Oxnard','Ventura',34.2199,-119.18),('93032','CA','Oxnard','Ventura',34.1981,-119.1777),('93033','CA','Oxnard','Ventura',34.16833,-119.166943),('93034','CA','Oxnard','Ventura',34.176,-119.1765),('93035','CA','Oxnard','Ventura',34.182366,-119.221957),('93036','CA','Oxnard','Ventura',34.234493,-119.177477),('93040','CA','Piru','Ventura',34.438399,-118.76051),('93041','CA','Port Hueneme','Ventura',34.146691,-119.176697),('93042','CA','Point Mugu Nawc','Ventura',33.25568,-119.503192),('93043','CA','Port Hueneme Cbc Base','Ventura',34.1627,-119.2046),('93044','CA','Port Hueneme','Ventura',34.1545,-119.1916),('93060','CA','Santa Paula','Ventura',34.360313,-119.067349),('93061','CA','Santa Paula','Ventura',34.3541,-119.0583),('93062','CA','Simi Valley','Ventura',34.2694,-118.7805),('93063','CA','Simi Valley','Ventura',34.282219,-118.695805),('93064','CA','Brandeis','Ventura',34.3216,-118.7027),('93065','CA','Simi Valley','Ventura',34.267163,-118.77184),('93066','CA','Somis','Ventura',34.293941,-119.002361),('93067','CA','Summerland','Santa Barbara',34.421365,-119.597731),('93093','CA','Simi Valley','Ventura',34.2718,-118.7123),('93094','CA','Simi Valley','Ventura',34.279,-118.7021),('93099','CA','Simi Valley','Ventura',34.2694,-118.7805),('93101','CA','Santa Barbara','Santa Barbara',34.420228,-119.706641),('93102','CA','Santa Barbara','Santa Barbara',34.4212,-119.6975),('93103','CA','Santa Barbara','Santa Barbara',34.428372,-119.684305),('93105','CA','Santa Barbara','Santa Barbara',34.463938,-119.768417),('93106','CA','Santa Barbara','Santa Barbara',34.4173,-119.8459),('93107','CA','Santa Barbara','Santa Barbara',34.4208,-119.6972),('93108','CA','Santa Barbara','Santa Barbara',34.435073,-119.633617),('93109','CA','Santa Barbara','Santa Barbara',34.403366,-119.720748),('93110','CA','Santa Barbara','Santa Barbara',34.43948,-119.767794),('93111','CA','Santa Barbara','Santa Barbara',34.442702,-119.805471),('93116','CA','Goleta','Santa Barbara',34.4901,-120.0384),('93117','CA','Goleta','Santa Barbara',34.449439,-119.962557),('93118','CA','Goleta','Santa Barbara',34.4358,-119.8266),('93120','CA','Santa Barbara','Santa Barbara',34.4212,-119.6975),('93121','CA','Santa Barbara','Santa Barbara',34.4212,-119.6975),('93130','CA','Santa Barbara','Santa Barbara',34.5283,-119.8192),('93140','CA','Santa Barbara','Santa Barbara',34.4209,-119.6767),('93150','CA','Santa Barbara','Santa Barbara',34.4369,-119.6326),('93160','CA','Santa Barbara','Santa Barbara',34.4348,-119.803),('93190','CA','Santa Barbara','Santa Barbara',34.4234,-119.7037),('93199','CA','Goleta','Santa Barbara',34.4901,-120.0384),('93201','CA','Alpaugh','Tulare',35.882309,-119.485129),('93202','CA','Armona','Kings',36.312223,-119.708024),('93203','CA','Arvin','Kern',35.16197,-118.837462),('93204','CA','Avenal','Kings',35.97506,-120.113441),('93205','CA','Bodfish','Kern',35.579156,-118.457606),('93206','CA','Buttonwillow','Kern',35.424652,-119.468173),('93207','CA','California Hot Springs','Tulare',35.870003,-118.638135),('93208','CA','Camp Nelson','Tulare',36.071525,-118.558952),('93210','CA','Coalinga','Fresno',36.196186,-120.347869),('93212','CA','Corcoran','Kings',36.083378,-119.557718),('93215','CA','Delano','Kern',35.772244,-119.209689),('93216','CA','Delano','Kern',35.771876,-119.269847),('93218','CA','Ducor','Tulare',35.869445,-119.053553),('93219','CA','Earlimart','Tulare',35.881292,-119.26195),('93220','CA','Edison','Kern',35.374941,-118.815455),('93221','CA','Exeter','Tulare',36.302306,-119.115292),('93222','CA','Frazier Park','Kern',34.850958,-119.170747),('93223','CA','Farmersville','Tulare',36.303425,-119.207119),('93224','CA','Fellows','Kern',35.213792,-119.565291),('93225','CA','Frazier Park','Kern',34.807477,-119.012118),('93226','CA','Glennville','Kern',35.718211,-118.72576),('93227','CA','Goshen','Tulare',36.3511,-119.4191),('93230','CA','Hanford','Kings',36.328949,-119.646859),('93232','CA','Hanford','Kings',36.2936,-119.6205),('93234','CA','Huron','Fresno',36.188602,-120.094404),('93235','CA','Ivanhoe','Tulare',36.388263,-119.218937),('93237','CA','Kaweah','Tulare',36.4697,-118.9175),('93238','CA','Kernville','Kern',35.754263,-118.424565),('93239','CA','Kettleman City','Kings',36.011308,-119.969258),('93240','CA','Lake Isabella','Kern',35.645726,-118.444905),('93241','CA','Lamont','Kern',35.256976,-118.914958),('93242','CA','Laton','Fresno',36.434588,-119.717582),('93243','CA','Lebec','Kern',34.791286,-118.833959),('93244','CA','Lemon Cove','Tulare',36.409206,-119.012056),('93245','CA','Lemoore','Kings',36.307595,-119.821269),('93246','CA','Lemoore','Kings',36.3009,-119.7825),('93247','CA','Lindsay','Tulare',36.201516,-119.085477),('93249','CA','Lost Hills','Kern',35.639412,-119.841708),('93250','CA','Mc Farland','Kern',35.663625,-119.201371),('93251','CA','Mc Kittrick','Kern',35.380752,-119.691901),('93252','CA','Maricopa','Kern',34.979189,-119.390129),('93254','CA','New Cuyama','Santa Barbara',34.979584,-119.759445),('93255','CA','Onyx','Kern',35.69388,-118.162498),('93256','CA','Pixley','Tulare',35.960636,-119.312992),('93257','CA','Porterville','Tulare',36.051519,-119.003082),('93258','CA','Porterville','Tulare',36.053996,-119.146163),('93260','CA','Posey','Tulare',35.817836,-118.646181),('93261','CA','Richgrove','Tulare',35.801755,-119.116729),('93262','CA','Sequoia National Park','Tulare',36.586721,-118.758266),('93263','CA','Shafter','Kern',35.490628,-119.27245),('93265','CA','Springville','Tulare',36.152666,-118.747997),('93266','CA','Stratford','Kings',36.172279,-119.84588),('93267','CA','Strathmore','Tulare',36.141932,-119.078189),('93268','CA','Taft','Kern',35.1522,-119.44827),('93270','CA','Terra Bella','Tulare',35.95604,-119.05154),('93271','CA','Three Rivers','Tulare',36.449065,-118.864358),('93272','CA','Tipton','Tulare',36.054352,-119.3181),('93274','CA','Tulare','Tulare',36.201704,-119.348216),('93275','CA','Tulare','Tulare',36.2084,-119.3433),('93276','CA','Tupman','Kern',35.298898,-119.360014),('93277','CA','Visalia','Tulare',36.307769,-119.327713),('93278','CA','Visalia','Tulare',36.3093,-119.3142),('93279','CA','Visalia','Tulare',36.3289,-119.2922),('93280','CA','Wasco','Kern',35.605166,-119.371455),('93282','CA','Waukena','Tulare',36.12763,-119.522026),('93283','CA','Weldon','Kern',35.612622,-118.29617),('93285','CA','Wofford Heights','Kern',35.712626,-118.479706),('93286','CA','Woodlake','Tulare',36.426888,-119.103303),('93287','CA','Woody','Kern',35.731673,-118.918809),('93290','CA','Visalia','Tulare',36.33,-119.291),('93291','CA','Visalia','Tulare',36.34926,-119.334822),('93292','CA','Visalia','Tulare',36.354215,-119.242911),('93301','CA','Bakersfield','Kern',35.38147,-119.019389),('93302','CA','Bakersfield','Kern',35.5522,-118.9188),('93303','CA','Bakersfield','Kern',35.5522,-118.9188),('93304','CA','Bakersfield','Kern',35.343561,-119.02417),('93305','CA','Bakersfield','Kern',35.38726,-118.986649),('93306','CA','Bakersfield','Kern',35.40082,-118.909133),('93307','CA','Bakersfield','Kern',35.30641,-118.952191),('93308','CA','Bakersfield','Kern',35.458007,-119.030264),('93309','CA','Bakersfield','Kern',35.34226,-119.062185),('93311','CA','Bakersfield','Kern',35.233736,-119.156581),('93312','CA','Bakersfield','Kern',35.393355,-119.120874),('93313','CA','Bakersfield','Kern',35.230584,-119.047954),('93314','CA','Bakersfield','Kern',35.397133,-119.204238),('93380','CA','Bakersfield','Kern',35.5522,-118.9188),('93381','CA','Bakersfield','Kern',35.3733,-119.0177),('93382','CA','Bakersfield','Kern',35.2596,-119.0019),('93383','CA','Bakersfield','Kern',35.3329,-119.0859),('93384','CA','Bakersfield','Kern',35.3733,-119.0177),('93385','CA','Bakersfield','Kern',35.3785,-118.9907),('93386','CA','Bakersfield','Kern',35.3764,-118.9537),('93387','CA','Bakersfield','Kern',35.2908,-118.9665),('93388','CA','Bakersfield','Kern',35.4714,-118.9667),('93389','CA','Bakersfield','Kern',35.3538,-119.0615),('93390','CA','Bakersfield','Kern',35.3431,-119.0635),('93401','CA','San Luis Obispo','San Luis Obispo',35.259161,-120.647295),('93402','CA','Los Osos','San Luis Obispo',35.313153,-120.834749),('93403','CA','San Luis Obispo','San Luis Obispo',35.2827,-120.6586),('93405','CA','San Luis Obispo','San Luis Obispo',35.289238,-120.710871),('93406','CA','San Luis Obispo','San Luis Obispo',35.2794,-120.6606),('93407','CA','San Luis Obispo','San Luis Obispo',35.3011,-120.6607),('93408','CA','San Luis Obispo','San Luis Obispo',35.2847,-120.6606),('93409','CA','San Luis Obispo','San Luis Obispo',35.221,-120.6364),('93410','CA','San Luis Obispo','San Luis Obispo',35.2996,-120.6555),('93412','CA','Los Osos','San Luis Obispo',35.3117,-120.8348),('93420','CA','Arroyo Grande','San Luis Obispo',35.125593,-120.546473),('93421','CA','Arroyo Grande','San Luis Obispo',35.1213,-120.5765),('93422','CA','Atascadero','San Luis Obispo',35.47953,-120.674952),('93423','CA','Atascadero','San Luis Obispo',35.4894,-120.6697),('93424','CA','Avila Beach','San Luis Obispo',35.181351,-120.734249),('93426','CA','Bradley','Monterey',35.820872,-120.911259),('93427','CA','Buellton','Santa Barbara',34.614246,-120.203691),('93428','CA','Cambria','San Luis Obispo',35.563893,-121.080003),('93429','CA','Casmalia','Santa Barbara',34.850231,-120.539739),('93430','CA','Cayucos','San Luis Obispo',35.453435,-120.90586),('93432','CA','Creston','San Luis Obispo',35.480896,-120.469476),('93433','CA','Grover Beach','San Luis Obispo',35.119936,-120.620978),('93434','CA','Guadalupe','Santa Barbara',34.9476,-120.588052),('93435','CA','Harmony','San Luis Obispo',35.508282,-121.035514),('93436','CA','Lompoc','Santa Barbara',34.643412,-120.451237),('93437','CA','Lompoc','Santa Barbara',34.735489,-120.538283),('93438','CA','Lompoc','Santa Barbara',34.6392,-120.4675),('93440','CA','Los Alamos','Santa Barbara',34.747358,-120.244862),('93441','CA','Los Olivos','Santa Barbara',34.707862,-120.106008),('93442','CA','Morro Bay','San Luis Obispo',35.383044,-120.842925),('93443','CA','Morro Bay','San Luis Obispo',35.3667,-120.8466),('93444','CA','Nipomo','San Luis Obispo',35.031507,-120.502515),('93445','CA','Oceano','San Luis Obispo',35.092188,-120.616077),('93446','CA','Paso Robles','San Luis Obispo',35.644511,-120.69511),('93447','CA','Paso Robles','San Luis Obispo',35.664837,-120.645422),('93448','CA','Pismo Beach','San Luis Obispo',35.1427,-120.6402),('93449','CA','Pismo Beach','San Luis Obispo',35.147174,-120.648967),('93450','CA','San Ardo','Monterey',35.987619,-120.866791),('93451','CA','San Miguel','San Luis Obispo',35.786362,-120.660451),('93452','CA','San Simeon','San Luis Obispo',35.678786,-121.20014),('93453','CA','Santa Margarita','San Luis Obispo',35.354344,-120.208273),('93454','CA','Santa Maria','Santa Barbara',34.917831,-120.338982),('93455','CA','Santa Maria','Santa Barbara',34.877529,-120.433083),('93456','CA','Santa Maria','Santa Barbara',34.953,-120.4347),('93457','CA','Santa Maria','Santa Barbara',34.8648,-120.4448),('93458','CA','Santa Maria','Santa Barbara',34.955069,-120.452029),('93460','CA','Santa Ynez','Santa Barbara',34.641964,-120.061204),('93461','CA','Shandon','San Luis Obispo',35.607588,-120.28955),('93463','CA','Solvang','Santa Barbara',34.608913,-120.138068),('93464','CA','Solvang','Santa Barbara',34.5958,-120.1366),('93465','CA','Templeton','San Luis Obispo',35.549712,-120.720456),('93475','CA','Oceano','San Luis Obispo',35.0989,-120.6124),('93483','CA','Grover Beach','San Luis Obispo',35.1217,-120.6203),('93501','CA','Mojave','Kern',35.027658,-118.180859),('93502','CA','Mojave','Kern',35.0563,-118.1731),('93504','CA','California City','Kern',35.1276,-117.9591),('93505','CA','California City','Kern',35.130575,-117.950439),('93510','CA','Acton','Los Angeles',34.486228,-118.201427),('93512','CA','Benton','Mono',37.836214,-118.508339),('93513','CA','Big Pine','Inyo',37.11589,-118.258562),('93514','CA','Bishop','Inyo',37.367339,-118.455777),('93515','CA','Bishop','Inyo',37.3612,-118.3997),('93516','CA','Boron','Kern',35.00513,-117.638786),('93517','CA','Bridgeport','Mono',38.268342,-119.294518),('93518','CA','Caliente','Kern',35.400042,-118.485619),('93519','CA','Cantil','Kern',35.296781,-117.966417),('93522','CA','Darwin','Inyo',36.270782,-117.594001),('93523','CA','Edwards','Kern',34.953109,-117.886899),('93524','CA','Edwards','Kern',34.924509,-117.903788),('93526','CA','Independence','Inyo',36.831409,-118.223748),('93527','CA','Inyokern','Kern',35.715179,-117.868478),('93528','CA','Johannesburg','Kern',35.370061,-117.638011),('93529','CA','June Lake','Mono',37.78353,-119.087132),('93530','CA','Keeler','Inyo',36.488446,-117.874534),('93531','CA','Keene','Kern',35.221906,-118.582566),('93532','CA','Lake Hughes','Los Angeles',34.682178,-118.480746),('93534','CA','Lancaster','Los Angeles',34.697098,-118.149033),('93535','CA','Lancaster','Los Angeles',34.697459,-117.947457),('93536','CA','Lancaster','Los Angeles',34.72458,-118.311329),('93539','CA','Lancaster','Los Angeles',34.698,-118.1358),('93541','CA','Lee Vining','Mono',38.009844,-119.154791),('93542','CA','Little Lake','Inyo',35.9453,-117.9166),('93543','CA','Littlerock','Los Angeles',34.525565,-117.955933),('93544','CA','Llano','Los Angeles',34.480487,-117.762898),('93545','CA','Lone Pine','Inyo',36.577911,-118.056279),('93546','CA','Mammoth Lakes','Mono',37.621575,-118.889),('93549','CA','Olancha','Inyo',36.185623,-117.962508),('93550','CA','Palmdale','Los Angeles',34.543601,-118.095286),('93551','CA','Palmdale','Los Angeles',34.600117,-118.191322),('93552','CA','Palmdale','Los Angeles',34.559882,-118.030535),('93553','CA','Pearblossom','Los Angeles',34.481188,-117.898542),('93554','CA','Randsburg','Kern',35.38707,-117.713561),('93555','CA','Ridgecrest','Kern',35.622083,-117.678941),('93556','CA','Ridgecrest','Kern',35.6225,-117.67),('93558','CA','Red Mountain','San Bernardino',35.352741,-117.622412),('93560','CA','Rosamond','Kern',34.867179,-118.304345),('93561','CA','Tehachapi','Kern',35.130705,-118.500406),('93562','CA','Trona','San Bernardino',35.759363,-117.38106),('93563','CA','Valyermo','Los Angeles',34.415239,-117.784008),('93581','CA','Tehachapi','Kern',35.1311,-118.4463),('93584','CA','Lancaster','Los Angeles',34.698,-118.1358),('93586','CA','Lancaster','Los Angeles',34.6475,-118.2175),('93590','CA','Palmdale','Los Angeles',34.5009,-118.0586),('93591','CA','Palmdale','Los Angeles',34.59995,-117.844034),('93592','CA','Trona','Inyo',35.86839,-117.343114),('93596','CA','Boron','Kern',35.002,-117.6494),('93599','CA','Palmdale','Los Angeles',34.5009,-118.0586),('93601','CA','Ahwahnee','Madera',37.395382,-119.727999),('93602','CA','Auberry','Fresno',37.079507,-119.414859),('93603','CA','Badger','Tulare',36.642425,-118.979322),('93604','CA','Bass Lake','Madera',37.347895,-119.529814),('93605','CA','Big Creek','Fresno',37.203789,-119.244819),('93606','CA','Biola','Fresno',36.803522,-120.017356),('93607','CA','Burrel','Fresno',36.5027,-119.9797),('93608','CA','Cantua Creek','Fresno',36.494034,-120.375004),('93609','CA','Caruthers','Fresno',36.534504,-119.84064),('93610','CA','Chowchilla','Madera',37.093913,-120.278608),('93611','CA','Clovis','Fresno',36.821846,-119.680245),('93612','CA','Clovis','Fresno',36.816769,-119.710037),('93613','CA','Clovis','Fresno',36.8228,-119.7073),('93614','CA','Coarsegold','Madera',37.203399,-119.728346),('93615','CA','Cutler','Tulare',36.512524,-119.286655),('93616','CA','Del Rey','Fresno',36.656429,-119.593258),('93618','CA','Dinuba','Tulare',36.53745,-119.39121),('93619','CA','Clovis','Fresno',36.865357,-119.634803),('93620','CA','Dos Palos','Merced',37.013301,-120.640226),('93621','CA','Dunlap','Fresno',36.790656,-119.141653),('93622','CA','Firebaugh','Fresno',36.799916,-120.557453),('93623','CA','Fish Camp','Mariposa',37.474624,-119.64315),('93624','CA','Five Points','Fresno',36.378434,-120.116591),('93625','CA','Fowler','Fresno',36.627672,-119.676668),('93626','CA','Friant','Fresno',37.021403,-119.684304),('93627','CA','Helm','Fresno',36.523726,-120.106697),('93628','CA','Hume','Fresno',36.772023,-118.935193),('93630','CA','Kerman','Fresno',36.72369,-120.101045),('93631','CA','Kingsburg','Fresno',36.500098,-119.544744),('93633','CA','Kings Canyon National Pk','Tulare',36.718899,-118.925378),('93634','CA','Lakeshore','Fresno',37.223,-119.001021),('93635','CA','Los Banos','Merced',37.061082,-120.846846),('93636','CA','Madera','Madera',36.967254,-119.876469),('93637','CA','Madera','Madera',36.930973,-120.135466),('93638','CA','Madera','Madera',37.000008,-120.051794),('93639','CA','Madera','Madera',36.9064,-120.1402),('93640','CA','Mendota','Fresno',36.709182,-120.42803),('93641','CA','Miramonte','Fresno',36.692468,-119.029344),('93642','CA','Mono Hot Springs','Fresno',37.168,-119.2095),('93643','CA','North Fork','Madera',37.23548,-119.493815),('93644','CA','Oakhurst','Madera',37.363771,-119.632654),('93645','CA','O Neals','Madera',37.164448,-119.645658),('93646','CA','Orange Cove','Fresno',36.62665,-119.307682),('93647','CA','Orosi','Tulare',36.566748,-119.245489),('93648','CA','Parlier','Fresno',36.613706,-119.528733),('93649','CA','Piedra','Fresno',36.8264,-119.3485),('93650','CA','Fresno','Fresno',36.839632,-119.798914),('93651','CA','Prather','Fresno',37.003941,-119.528325),('93652','CA','Raisin City','Fresno',36.600552,-119.902763),('93653','CA','Raymond','Madera',37.236433,-119.916746),('93654','CA','Reedley','Fresno',36.610611,-119.435003),('93656','CA','Riverdale','Fresno',36.440258,-119.91549),('93657','CA','Sanger','Fresno',36.731164,-119.526779),('93660','CA','San Joaquin','Fresno',36.584974,-120.163211),('93661','CA','Santa Rita Park','Merced',37.0475,-120.5941),('93662','CA','Selma','Fresno',36.56823,-119.621102),('93664','CA','Shaver Lake','Fresno',37.104215,-119.280834),('93665','CA','South Dos Palos','Merced',36.961568,-120.652126),('93666','CA','Sultana','Tulare',36.546785,-119.337676),('93667','CA','Tollhouse','Fresno',36.975045,-119.351614),('93668','CA','Tranquillity','Fresno',36.650285,-120.270326),('93669','CA','Wishon','Madera',37.286015,-119.535205),('93670','CA','Yettem','Tulare',36.4863,-119.2586),('93673','CA','Traver','Tulare',36.453988,-119.485021),('93675','CA','Squaw Valley','Fresno',36.717386,-119.192979),('93701','CA','Fresno','Fresno',36.7495,-119.788826),('93702','CA','Fresno','Fresno',36.741241,-119.755339),('93703','CA','Fresno','Fresno',36.76717,-119.764106),('93704','CA','Fresno','Fresno',36.794885,-119.800945),('93705','CA','Fresno','Fresno',36.786106,-119.827584),('93706','CA','Fresno','Fresno',36.689791,-119.833655),('93707','CA','Fresno','Fresno',36.7329,-119.7828),('93708','CA','Fresno','Fresno',36.7329,-119.7828),('93709','CA','Fresno','Fresno',36.7329,-119.7828),('93710','CA','Fresno','Fresno',36.825227,-119.763639),('93711','CA','Fresno','Fresno',36.8318,-119.833096),('93712','CA','Fresno','Fresno',36.7329,-119.7828),('93714','CA','Fresno','Fresno',36.7329,-119.7828),('93715','CA','Fresno','Fresno',36.7329,-119.7828),('93716','CA','Fresno','Fresno',36.7329,-119.7828),('93717','CA','Fresno','Fresno',36.7329,-119.7828),('93718','CA','Fresno','Fresno',36.7329,-119.7828),('93720','CA','Fresno','Fresno',36.859023,-119.758709),('93721','CA','Fresno','Fresno',36.732734,-119.784297),('93722','CA','Fresno','Fresno',36.80287,-119.875392),('93723','CA','Fresno','Fresno',36.797039,-119.938995),('93724','CA','Fresno','Fresno',36.7387,-119.8046),('93725','CA','Fresno','Fresno',36.667058,-119.741223),('93726','CA','Fresno','Fresno',36.793004,-119.765678),('93727','CA','Fresno','Fresno',36.750282,-119.696916),('93728','CA','Fresno','Fresno',36.758498,-119.812537),('93729','CA','Fresno','Fresno',36.8518,-119.7669),('93730','CA','Fresno','Fresno',36.890489,-119.754553),('93737','NV','City Center','Clark',36.175,-115.136),('93740','CA','Fresno','Fresno',36.8142,-119.7461),('93741','CA','Fresno','Fresno',36.7656,-119.7956),('93744','CA','Fresno','Fresno',36.7585,-119.7995),('93745','CA','Fresno','Fresno',36.6275,-119.7378),('93747','CA','Fresno','Fresno',36.7432,-119.7012),('93750','CA','Fresno','Fresno',36.7387,-119.8046),('93755','CA','Fresno','Fresno',36.79,-119.7905),('93760','CA','Fresno','Fresno',36.7387,-119.8046),('93761','CA','Fresno','Fresno',36.7387,-119.8046),('93764','CA','Fresno','Fresno',36.7387,-119.8046),('93765','CA','Fresno','Fresno',36.8349,-119.8301),('93771','CA','Fresno','Fresno',36.7387,-119.8046),('93772','CA','Fresno','Fresno',36.7387,-119.8046),('93773','CA','Fresno','Fresno',36.7387,-119.8046),('93774','CA','Fresno','Fresno',36.7387,-119.8046),('93775','CA','Fresno','Fresno',36.7387,-119.8046),('93776','CA','Fresno','Fresno',36.7387,-119.8046),('93777','CA','Fresno','Fresno',36.7387,-119.8046),('93778','CA','Fresno','Fresno',36.7387,-119.8046),('93779','CA','Fresno','Fresno',36.7387,-119.8046),('93780','CA','Fresno','Fresno',36.7387,-119.8046),('93784','CA','Fresno','Fresno',36.8243,-119.7615),('93786','CA','Fresno','Fresno',36.740191,-119.786175),('93790','CA','Fresno','Fresno',36.785,-119.8345),('93791','CA','Fresno','Fresno',36.785,-119.8345),('93792','CA','Fresno','Fresno',36.785,-119.8345),('93793','CA','Fresno','Fresno',36.785,-119.8345),('93794','CA','Fresno','Fresno',36.785,-119.8345),('93844','CA','Fresno','Fresno',36.7387,-119.8046),('93888','CA','Fresno','Fresno',36.7387,-119.8046),('93901','CA','Salinas','Monterey',36.666374,-121.652478),('93902','CA','Salinas','Monterey',36.7758,-121.6562),('93905','CA','Salinas','Monterey',36.680308,-121.614374),('93906','CA','Salinas','Monterey',36.712018,-121.638456),('93907','CA','Salinas','Monterey',36.75452,-121.664882),('93908','CA','Salinas','Monterey',36.641852,-121.607308),('93912','CA','Salinas','Monterey',36.6964,-121.6688),('93915','CA','Salinas','Monterey',36.6665,-121.6269),('93920','CA','Big Sur','Monterey',36.150353,-121.627991),('93921','CA','Carmel By The Sea','Monterey',36.554453,-121.922231),('93922','CA','Carmel','Monterey',36.4478,-121.8395),('93923','CA','Carmel','Monterey',36.499731,-121.871267),('93924','CA','Carmel Valley','Monterey',36.446795,-121.684724),('93925','CA','Chualar','Monterey',36.589737,-121.474644),('93926','CA','Gonzales','Monterey',36.516886,-121.435472),('93927','CA','Greenfield','Monterey',36.287332,-121.292278),('93928','CA','Jolon','Monterey',36.016834,-121.238196),('93930','CA','King City','Monterey',36.213149,-121.084745),('93932','CA','Lockwood','Monterey',36.015145,-121.042988),('93933','CA','Marina','Monterey',36.67863,-121.792675),('93940','CA','Monterey','Monterey',36.596933,-121.879019),('93942','CA','Monterey','Monterey',36.6149,-121.8989),('93943','CA','Monterey','Monterey',36.595791,-121.874128),('93944','CA','Monterey','Monterey',36.6054,-121.9098),('93950','CA','Pacific Grove','Monterey',36.618852,-121.920803),('93953','CA','Pebble Beach','Monterey',36.59049,-121.946007),('93954','CA','San Lucas','Monterey',36.122858,-120.979394),('93955','CA','Seaside','Monterey',36.620943,-121.820094),('93960','CA','Soledad','Monterey',36.412557,-121.321749),('93962','CA','Spreckels','Monterey',36.624711,-121.646958),('94002','CA','Belmont','San Mateo',37.517963,-122.292747),('94005','CA','Brisbane','San Mateo',37.684291,-122.403074),('94010','CA','Burlingame','San Mateo',37.574982,-122.362481),('94011','CA','Burlingame','San Mateo',37.5776,-122.3454),('94013','CA','Daly City','San Mateo',37.7074,-122.4587),('94014','CA','Daly City','San Mateo',37.698645,-122.452938),('94015','CA','Daly City','San Mateo',37.683004,-122.478743),('94016','CA','Daly City','San Mateo',37.7075,-122.4543),('94017','CA','Daly City','San Mateo',37.6921,-122.471),('94018','CA','El Granada','San Mateo',37.5018,-122.4701),('94019','CA','Half Moon Bay','San Mateo',37.468572,-122.444532),('94020','CA','La Honda','San Mateo',37.285889,-122.223965),('94021','CA','Loma Mar','San Mateo',37.270859,-122.295515),('94022','CA','Los Altos','Santa Clara',37.376365,-122.126884),('94023','CA','Los Altos','Santa Clara',37.38,-122.1185),('94024','CA','Los Altos','Santa Clara',37.352791,-122.087034),('94025','CA','Menlo Park','San Mateo',37.452746,-122.182757),('94026','CA','Menlo Park','San Mateo',37.4156,-122.2001),('94027','CA','Atherton','San Mateo',37.457075,-122.201057),('94028','CA','Portola Valley','San Mateo',37.382296,-122.209116),('94030','CA','Millbrae','San Mateo',37.600716,-122.401152),('94035','CA','Mountain View','Santa Clara',37.4121,-122.0536),('94037','CA','Montara','San Mateo',37.542846,-122.505988),('94038','CA','Moss Beach','San Mateo',37.523049,-122.510599),('94039','CA','Mountain View','Santa Clara',37.3931,-122.077),('94040','CA','Mountain View','Santa Clara',37.383539,-122.087028),('94041','CA','Mountain View','Santa Clara',37.388527,-122.075102),('94042','CA','Mountain View','Santa Clara',37.3931,-122.077),('94043','CA','Mountain View','Santa Clara',37.408648,-122.072403),('94044','CA','Pacifica','San Mateo',37.620899,-122.486233),('94060','CA','Pescadero','San Mateo',37.221214,-122.338089),('94061','CA','Redwood City','San Mateo',37.463225,-122.234732),('94062','CA','Redwood City','San Mateo',37.450236,-122.265421),('94063','CA','Redwood City','San Mateo',37.484507,-122.214668),('94064','CA','Redwood City','San Mateo',37.4634,-122.255),('94065','CA','Redwood City','San Mateo',37.532288,-122.246038),('94066','CA','San Bruno','San Mateo',37.626979,-122.426908),('94070','CA','San Carlos','San Mateo',37.499034,-122.267572),('94074','CA','San Gregorio','San Mateo',37.320577,-122.340937),('94080','CA','South San Francisco','San Mateo',37.655606,-122.428308),('94083','CA','South San Francisco','San Mateo',37.6425,-122.4123),('94085','CA','Sunnyvale','Santa Clara',37.387984,-122.016567),('94086','CA','Sunnyvale','Santa Clara',37.373085,-122.025618),('94087','CA','Sunnyvale','Santa Clara',37.350289,-122.036029),('94088','CA','Sunnyvale','Santa Clara',37.3932,-122.0371),('94089','CA','Sunnyvale','Santa Clara',37.404439,-122.00858),('94101','CA','San Francisco','San Francisco',37.775,-122.4183),('94102','CA','San Francisco','San Francisco',37.779164,-122.420066),('94103','CA','San Francisco','San Francisco',37.771967,-122.412352),('94104','CA','San Francisco','San Francisco',37.791733,-122.401945),('94105','CA','San Francisco','San Francisco',37.788526,-122.395147),('94106','CA','San Francisco','San Francisco',37.775,-122.4183),('94107','CA','San Francisco','San Francisco',37.765838,-122.395865),('94108','CA','San Francisco','San Francisco',37.792661,-122.408041),('94109','CA','San Francisco','San Francisco',37.793603,-122.422093),('94110','CA','San Francisco','San Francisco',37.748748,-122.415402),('94111','CA','San Francisco','San Francisco',37.798193,-122.400369),('94112','CA','San Francisco','San Francisco',37.721336,-122.442535),('94114','CA','San Francisco','San Francisco',37.758455,-122.435329),('94115','CA','San Francisco','San Francisco',37.785099,-122.437287),('94116','CA','San Francisco','San Francisco',37.743536,-122.485936),('94117','CA','San Francisco','San Francisco',37.769853,-122.444404),('94118','CA','San Francisco','San Francisco',37.781139,-122.461601),('94119','CA','San Francisco','San Francisco',37.74,-122.3817),('94120','CA','San Francisco','San Francisco',37.793,-122.4012),('94121','CA','San Francisco','San Francisco',37.77873,-122.492696),('94122','CA','San Francisco','San Francisco',37.760412,-122.484967),('94123','CA','San Francisco','San Francisco',37.800934,-122.438366),('94124','CA','San Francisco','San Francisco',37.733108,-122.390182),('94125','CA','San Francisco','San Francisco',37.775,-122.4183),('94126','CA','San Francisco','San Francisco',37.795,-122.3933),('94127','CA','San Francisco','San Francisco',37.735161,-122.461539),('94128','CA','San Francisco','San Mateo',37.621835,-122.396716),('94129','CA','San Francisco','San Francisco',37.799109,-122.463854),('94130','CA','San Francisco','San Francisco',37.819411,-122.369628),('94131','CA','San Francisco','San Francisco',37.741492,-122.438599),('94132','CA','San Francisco','San Francisco',37.724114,-122.479746),('94133','CA','San Francisco','San Francisco',37.801736,-122.410288),('94134','CA','San Francisco','San Francisco',37.7215,-122.409263),('94135','CA','San Francisco','San Francisco',37.775,-122.4183),('94136','CA','San Francisco','San Francisco',37.775,-122.4183),('94137','CA','San Francisco','San Francisco',37.7915,-122.4007),('94138','CA','San Francisco','San Francisco',37.7917,-122.4007),('94139','CA','San Francisco','San Francisco',37.775,-122.4183),('94140','CA','San Francisco','San Francisco',37.7555,-122.4153),('94141','CA','San Francisco','San Francisco',37.7667,-122.4097),('94142','CA','San Francisco','San Francisco',37.7819,-122.4146),('94143','CA','San Francisco','San Francisco',37.7631,-122.4591),('94144','CA','San Francisco','San Francisco',37.775,-122.4183),('94145','CA','San Francisco','San Francisco',37.7915,-122.4007),('94146','CA','San Francisco','San Francisco',37.775,-122.4183),('94147','CA','San Francisco','San Francisco',37.775,-122.4183),('94150','CA','San Francisco','San Francisco',37.775,-122.4183),('94151','CA','San Francisco','San Francisco',37.775,-122.4183),('94152','CA','San Francisco','San Francisco',37.775,-122.4183),('94153','CA','San Francisco','San Francisco',37.775,-122.4183),('94154','CA','San Francisco','San Francisco',37.775,-122.4183),('94155','CA','San Francisco','San Francisco',37.775,-122.4183),('94156','CA','San Francisco','San Francisco',37.775,-122.4183),('94158','CA','San Francisco','San Francisco',37.770631,-122.392691),('94159','CA','San Francisco','San Francisco',37.7814,-122.4524),('94160','CA','San Francisco','San Francisco',37.775,-122.4183),('94161','CA','San Francisco','San Francisco',37.775,-122.4183),('94162','CA','San Francisco','San Francisco',37.775,-122.4183),('94163','CA','San Francisco','San Francisco',37.775,-122.4183),('94164','CA','San Francisco','San Francisco',37.789,-122.4206),('94171','CA','San Francisco','San Francisco',37.775,-122.4183),('94172','CA','San Francisco','San Francisco',37.775,-122.4183),('94175','CA','San Francisco','San Francisco',37.775,-122.4183),('94177','CA','San Francisco','San Francisco',37.775,-122.4183),('94188','CA','San Francisco','San Francisco',37.74,-122.3817),('94199','CA','San Francisco','San Mateo',37.775,-122.4183),('94203','CA','Sacramento','Sacramento',38.5816,-121.4933),('94204','CA','Sacramento','Sacramento',38.6026,-121.4475),('94205','CA','Sacramento','Sacramento',38.475,-121.4421),('94206','CA','Sacramento','Sacramento',38.475,-121.4421),('94207','CA','Sacramento','Sacramento',38.6026,-121.4475),('94208','CA','Sacramento','Sacramento',38.5816,-121.4933),('94209','CA','Sacramento','Sacramento',38.5822,-121.4943),('94211','CA','Sacramento','Sacramento',38.5822,-121.4943),('94229','CA','Sacramento','Sacramento',38.5822,-121.4943),('94230','CA','Sacramento','Sacramento',38.475,-121.4421),('94232','CA','Sacramento','Sacramento',38.5816,-121.4933),('94234','CA','Sacramento','Sacramento',38.5822,-121.4943),('94235','CA','Sacramento','Sacramento',38.5822,-121.4943),('94236','CA','Sacramento','Sacramento',38.5822,-121.4943),('94237','CA','Sacramento','Sacramento',38.5822,-121.4943),('94239','CA','Sacramento','Sacramento',38.5816,-121.4933),('94240','CA','Sacramento','Sacramento',38.5816,-121.4933),('94244','CA','Sacramento','Sacramento',38.5816,-121.4933),('94245','CA','Sacramento','Sacramento',38.5599,-121.4841),('94246','CA','Sacramento','Sacramento',38.5816,-121.4933),('94247','CA','Sacramento','Sacramento',38.5816,-121.4933),('94248','CA','Sacramento','Sacramento',38.5822,-121.4943),('94249','CA','Sacramento','Sacramento',38.5822,-121.4943),('94250','CA','Sacramento','Sacramento',38.5658,-121.4671),('94252','CA','Sacramento','Sacramento',38.5822,-121.4943),('94254','CA','Sacramento','Sacramento',38.5816,-121.4933),('94256','CA','Sacramento','Sacramento',38.5816,-121.4933),('94257','CA','Sacramento','Sacramento',38.5816,-121.4933),('94258','CA','Sacramento','Sacramento',38.6026,-121.4475),('94259','CA','Sacramento','Sacramento',38.5816,-121.4933),('94261','CA','Sacramento','Sacramento',38.5816,-121.4933),('94262','CA','Sacramento','Sacramento',38.5816,-121.4933),('94263','CA','Sacramento','Sacramento',38.5816,-121.4933),('94267','CA','Sacramento','Sacramento',38.5816,-121.4933),('94268','CA','Sacramento','Sacramento',38.5822,-121.4943),('94269','CA','Sacramento','Sacramento',38.5816,-121.4933),('94271','CA','Sacramento','Sacramento',38.5822,-121.4943),('94273','CA','Sacramento','Sacramento',38.5822,-121.4943),('94274','CA','Sacramento','Sacramento',38.5822,-121.4943),('94277','CA','Sacramento','Sacramento',38.5822,-121.4943),('94278','CA','Sacramento','Sacramento',38.5816,-121.4933),('94279','CA','Sacramento','Sacramento',38.5822,-121.4943),('94280','CA','Sacramento','Sacramento',38.5816,-121.4933),('94282','CA','Sacramento','Sacramento',38.5816,-121.4933),('94283','CA','Sacramento','Sacramento',38.475,-121.4421),('94284','CA','Sacramento','Sacramento',38.5816,-121.4933),('94285','CA','Sacramento','Sacramento',38.5816,-121.4933),('94286','CA','Sacramento','Sacramento',38.5822,-121.4943),('94287','CA','Sacramento','Sacramento',38.5816,-121.4933),('94288','CA','Sacramento','Sacramento',38.5822,-121.4943),('94289','CA','Sacramento','Sacramento',38.5816,-121.4933),('94290','CA','Sacramento','Sacramento',38.5816,-121.4933),('94291','CA','Sacramento','Sacramento',38.5816,-121.4933),('94293','CA','Sacramento','Sacramento',38.5816,-121.4933),('94294','CA','Sacramento','Sacramento',38.5816,-121.4933),('94295','CA','Sacramento','Sacramento',38.5822,-121.4943),('94296','CA','Sacramento','Sacramento',38.5822,-121.4943),('94297','CA','Sacramento','Sacramento',38.5816,-121.4933),('94298','CA','Sacramento','Sacramento',38.5822,-121.4943),('94299','CA','Sacramento','Sacramento',38.5816,-121.4933),('94301','CA','Palo Alto','Santa Clara',37.443798,-122.150487),('94302','CA','Palo Alto','Santa Clara',37.4459,-122.1583),('94303','CA','Palo Alto','San Mateo',37.449992,-122.127113),('94304','CA','Palo Alto','Santa Clara',37.407871,-122.154602),('94305','CA','Stanford','Santa Clara',37.425603,-122.166887),('94306','CA','Palo Alto','Santa Clara',37.418151,-122.131965),('94309','CA','Palo Alto','Santa Clara',37.4419,-122.1419),('94401','CA','San Mateo','San Mateo',37.570619,-122.319895),('94402','CA','San Mateo','San Mateo',37.549068,-122.326593),('94403','CA','San Mateo','San Mateo',37.539399,-122.302405),('94404','CA','San Mateo','San Mateo',37.552882,-122.26989),('94497','CA','San Mateo','San Mateo',37.563,-122.3244),('94501','CA','Alameda','Alameda',37.770168,-122.260412),('94502','CA','Alameda','Alameda',37.736269,-122.242814),('94503','CA','American Canyon','Napa',38.170501,-122.252497),('94505','CA','Discover','Contra Costa',37.891116,-121.603117),('94506','CA','Danville','Contra Costa',37.803412,-121.911566),('94507','CA','Alamo','Contra Costa',37.853392,-122.018836),('94508','CA','Angwin','Napa',38.577875,-122.451222),('94509','CA','Antioch','Contra Costa',37.999076,-121.814407),('94510','CA','Benicia','Solano',38.069638,-122.143603),('94511','CA','Bethel Island','Contra Costa',38.029617,-121.640526),('94512','CA','Birds Landing','Solano',38.137408,-121.831502),('94513','CA','Brentwood','Contra Costa',37.933629,-121.69447),('94514','CA','Byron','Contra Costa',37.830103,-121.619321),('94515','CA','Calistoga','Napa',38.598214,-122.609516),('94516','CA','Canyon','Contra Costa',37.837961,-122.167372),('94517','CA','Clayton','Contra Costa',37.916112,-121.908949),('94518','CA','Concord','Contra Costa',37.952347,-122.024498),('94519','CA','Concord','Contra Costa',37.98431,-122.013836),('94520','CA','Concord','Contra Costa',37.990571,-122.036607),('94521','CA','Concord','Contra Costa',37.953898,-121.973499),('94522','CA','Concord','Contra Costa',37.9857,-122.0357),('94523','CA','Pleasant Hill','Contra Costa',37.954085,-122.073893),('94524','CA','Concord','Contra Costa',37.9769,-122.0561),('94525','CA','Crockett','Contra Costa',38.052044,-122.225008),('94526','CA','Danville','Contra Costa',37.814585,-121.988259),('94527','CA','Concord','Contra Costa',37.978,-122.0557),('94528','CA','Diablo','Contra Costa',37.840946,-121.95892),('94529','CA','Concord','Contra Costa',37.978,-122.03),('94530','CA','El Cerrito','Contra Costa',37.917925,-122.304178),('94531','CA','Antioch','Contra Costa',37.969458,-121.772355),('94533','CA','Fairfield','Solano',38.268524,-122.023318),('94534','CA','Fairfield','Solano',38.241776,-122.112703),('94535','CA','Travis Afb','Solano',38.27427,-121.940395),('94536','CA','Fremont','Alameda',37.561801,-121.998001),('94537','CA','Fremont','Alameda',37.5564,-122.0137),('94538','CA','Fremont','Alameda',37.527326,-121.969818),('94539','CA','Fremont','Alameda',37.51582,-121.928973),('94540','CA','Hayward','Alameda',37.6564,-122.0957),('94541','CA','Hayward','Alameda',37.675428,-122.088574),('94542','CA','Hayward','Alameda',37.65806,-122.044411),('94543','CA','Hayward','Alameda',37.6707,-122.0827),('94544','CA','Hayward','Alameda',37.635095,-122.065363),('94545','CA','Hayward','Alameda',37.635726,-122.10524),('94546','CA','Castro Valley','Alameda',37.698708,-122.079698),('94547','CA','Hercules','Contra Costa',38.007695,-122.263636),('94548','CA','Knightsen','Contra Costa',37.974297,-121.651437),('94549','CA','Lafayette','Contra Costa',37.899847,-122.112657),('94550','CA','Livermore','Alameda',37.653452,-121.725605),('94551','CA','Livermore','Alameda',37.713434,-121.762161),('94552','CA','Castro Valley','Alameda',37.700594,-122.031006),('94553','CA','Martinez','Contra Costa',37.999029,-122.116707),('94555','CA','Fremont','Alameda',37.570456,-122.051026),('94556','CA','Moraga','Contra Costa',37.839273,-122.120909),('94557','CA','Hayward','Alameda',37.6335,-122.0961),('94558','CA','Napa','Napa',38.362764,-122.287923),('94559','CA','Napa','Napa',38.286998,-122.287891),('94560','CA','Newark','Alameda',37.535777,-122.031542),('94561','CA','Oakley','Contra Costa',37.992679,-121.702489),('94562','CA','Oakville','Napa',38.5132,-122.4366),('94563','CA','Orinda','Contra Costa',37.881292,-122.181093),('94564','CA','Pinole','Contra Costa',37.996963,-122.28827),('94565','CA','Pittsburg','Contra Costa',38.018667,-121.912266),('94566','CA','Pleasanton','Alameda',37.659344,-121.869093),('94567','CA','Pope Valley','Napa',38.702102,-122.386288),('94568','CA','Dublin','Alameda',37.713887,-121.909289),('94569','CA','Port Costa','Contra Costa',38.041531,-122.186459),('94570','CA','Moraga','Contra Costa',37.8603,-122.1238),('94571','CA','Rio Vista','Solano',38.18647,-121.716362),('94572','CA','Rodeo','Contra Costa',38.030225,-122.254796),('94573','CA','Rutherford','Napa',38.458864,-122.428831),('94574','CA','Saint Helena','Napa',38.514152,-122.4422),('94575','CA','Moraga','Contra Costa',37.840961,-122.109502),('94576','CA','Deer Park','Napa',38.547615,-122.474184),('94577','CA','San Leandro','Alameda',37.721442,-122.158964),('94578','CA','San Leandro','Alameda',37.704039,-122.126816),('94579','CA','San Leandro','Alameda',37.688903,-122.152422),('94580','CA','San Lorenzo','Alameda',37.678827,-122.1321),('94581','CA','Napa','Napa',38.2225,-122.3428),('94582','CA','San Ramon','Contra Costa',37.765665,-121.916942),('94583','CA','San Ramon','Contra Costa',37.752978,-121.962133),('94585','CA','Suisun City','Solano',38.231102,-121.981831),('94586','CA','Sunol','Alameda',37.58792,-121.871611),('94587','CA','Union City','Alameda',37.593824,-122.048368),('94588','CA','Pleasanton','Alameda',37.694352,-121.89233),('94589','CA','Vallejo','Solano',38.141767,-122.246948),('94590','CA','Vallejo','Solano',38.104705,-122.247387),('94591','CA','Vallejo','Solano',38.107003,-122.210024),('94592','CA','Vallejo','Solano',38.096983,-122.274168),('94595','CA','Walnut Creek','Contra Costa',37.879203,-122.070785),('94596','CA','Walnut Creek','Contra Costa',37.891163,-122.04555),('94597','CA','Walnut Creek','Contra Costa',37.918377,-122.067629),('94598','CA','Walnut Creek','Contra Costa',37.917456,-122.022645),('94599','CA','Yountville','Napa',38.402727,-122.361818),('94601','CA','Oakland','Alameda',37.778198,-122.219112),('94602','CA','Oakland','Alameda',37.800255,-122.211841),('94603','CA','Oakland','Alameda',37.739757,-122.174045),('94604','CA','Oakland','Alameda',37.8018,-122.2652),('94605','CA','Oakland','Alameda',37.763129,-122.161273),('94606','CA','Oakland','Alameda',37.792863,-122.243942),('94607','CA','Oakland','Alameda',37.807967,-122.286142),('94608','CA','Emeryville','Alameda',37.835978,-122.281499),('94609','CA','Oakland','Alameda',37.834172,-122.264417),('94610','CA','Oakland','Alameda',37.812194,-122.241849),('94611','CA','Oakland','Alameda',37.827884,-122.22506),('94612','CA','Oakland','Alameda',37.809377,-122.270491),('94613','CA','Oakland','Alameda',37.779681,-122.182579),('94614','CA','Oakland','Alameda',37.7209,-122.2154),('94615','CA','Oakland','Alameda',37.8044,-122.2697),('94617','CA','Oakland','Alameda',37.8044,-122.2697),('94618','CA','Oakland','Alameda',37.843862,-122.24351),('94619','CA','Oakland','Alameda',37.788293,-122.185171),('94620','CA','Piedmont','Alameda',37.8276,-122.2507),('94621','CA','Oakland','Alameda',37.753348,-122.191588),('94622','CA','Oakland','Alameda',37.7417,-122.192),('94623','CA','Oakland','Alameda',37.8044,-122.2697),('94624','CA','Oakland','Alameda',37.7478,-122.1725),('94625','CA','Oakland','Alameda',37.8045,-122.3198),('94649','CA','Oakland','Alameda',37.827,-122.2998),('94659','CA','Oakland','Alameda',37.8044,-122.2697),('94660','CA','Oakland','Alameda',37.8044,-122.2697),('94661','CA','Oakland','Alameda',37.8285,-122.2094),('94662','CA','Emeryville','Alameda',37.8426,-122.2912),('94666','CA','Oakland','Alameda',37.8044,-122.2697),('94701','CA','Berkeley','Alameda',37.8691,-122.2696),('94702','CA','Berkeley','Alameda',37.86601,-122.2873),('94703','CA','Berkeley','Alameda',37.862494,-122.275336),('94704','CA','Berkeley','Alameda',37.86685,-122.26274),('94705','CA','Berkeley','Alameda',37.858267,-122.249622),('94706','CA','Albany','Alameda',37.88905,-122.293593),('94707','CA','Berkeley','Alameda',37.894485,-122.278733),('94708','CA','Berkeley','Alameda',37.895265,-122.263696),('94709','CA','Berkeley','Alameda',37.878582,-122.267443),('94710','CA','Berkeley','Alameda',37.868578,-122.298524),('94712','CA','Berkeley','Alameda',37.8693,-122.268),('94720','CA','Berkeley','Alameda',37.872643,-122.258403),('94801','CA','Richmond','Contra Costa',37.943739,-122.370551),('94802','CA','Richmond','Contra Costa',37.9372,-122.3585),('94803','CA','El Sobrante','Contra Costa',37.966175,-122.291072),('94804','CA','Richmond','Contra Costa',37.924963,-122.341039),('94805','CA','Richmond','Contra Costa',37.942366,-122.324532),('94806','CA','San Pablo','Contra Costa',37.971276,-122.337288),('94807','CA','Richmond','Contra Costa',37.9271,-122.384),('94808','CA','Richmond','Contra Costa',37.9338,-122.3432),('94820','CA','El Sobrante','Contra Costa',37.9799,-122.2956),('94850','CA','Richmond','Contra Costa',37.9372,-122.3585),('94901','CA','San Rafael','Marin',37.972897,-122.511329),('94903','CA','San Rafael','Marin',38.017318,-122.545103),('94904','CA','Greenbrae','Marin',37.947393,-122.53576),('94912','CA','San Rafael','Marin',37.9578,-122.5064),('94913','CA','San Rafael','Marin',38.0232,-122.5457),('94914','CA','Kentfield','Marin',37.9578,-122.5064),('94915','CA','San Rafael','Marin',38.0232,-122.5457),('94920','CA','Belvedere Tiburon','Marin',37.894317,-122.473434),('94922','CA','Bodega','Sonoma',38.345756,-122.962511),('94923','CA','Bodega Bay','Sonoma',38.340745,-123.051003),('94924','CA','Bolinas','Marin',37.914808,-122.701086),('94925','CA','Corte Madera','Marin',37.924399,-122.516369),('94926','CA','Rohnert','Sonoma',38.3269,-122.7061),('94927','CA','Rohnert Park','Sonoma',38.3397,-122.7),('94928','CA','Rohnert Park','Sonoma',38.346128,-122.696212),('94929','CA','Dillon Beach','Marin',38.24771,-122.961403),('94930','CA','Fairfax','Marin',37.980245,-122.597589),('94931','CA','Cotati','Sonoma',38.325216,-122.711269),('94933','CA','Forest Knolls','Marin',38.014136,-122.686776),('94937','CA','Inverness','Marin',38.104764,-122.889636),('94938','CA','Lagunitas','Marin',38.021035,-122.713537),('94939','CA','Larkspur','Marin',37.938426,-122.532483),('94940','CA','Marshall','Marin',38.17857,-122.88319),('94941','CA','Mill Valley','Marin',37.899317,-122.539854),('94942','CA','Mill Valley','Marin',37.9026,-122.5232),('94945','CA','Novato','Marin',38.11676,-122.561875),('94946','CA','Nicasio','Marin',38.072246,-122.681416),('94947','CA','Novato','Marin',38.102356,-122.58948),('94948','CA','Novato','Marin',38.1009,-122.5708),('94949','CA','Novato','Marin',38.061957,-122.535232),('94950','CA','Olema','Marin',38.02081,-122.774635),('94951','CA','Penngrove','Sonoma',38.309662,-122.658183),('94952','CA','Petaluma','Sonoma',38.237974,-122.685704),('94953','CA','Petaluma','Sonoma',38.3221,-122.6441),('94954','CA','Petaluma','Sonoma',38.244171,-122.605258),('94955','CA','Petaluma','Sonoma',38.2325,-122.6355),('94956','CA','Point Reyes Station','Marin',38.05685,-122.819552),('94957','CA','Ross','Marin',37.963573,-122.564144),('94960','CA','San Anselmo','Marin',37.983832,-122.569077),('94963','CA','San Geronimo','Marin',38.014641,-122.670915),('94964','CA','San Quentin','Marin',37.943661,-122.490708),('94965','CA','Sausalito','Marin',37.855334,-122.498573),('94966','CA','Sausalito','Marin',37.8679,-122.4989),('94970','CA','Stinson Beach','Marin',37.90698,-122.650618),('94971','CA','Tomales','Marin',38.245981,-122.908562),('94972','CA','Valley Ford','Marin',38.293353,-122.946993),('94973','CA','Woodacre','Marin',38.009776,-122.638665),('94974','CA','San Quentin','Marin',37.9589,-122.4928),('94975','CA','Petaluma','Sonoma',38.3221,-122.6441),('94976','CA','Corte Madera','Marin',37.9256,-122.5258),('94977','CA','Larkspur','Marin',37.9362,-122.535),('94978','CA','Fairfax','Marin',37.9857,-122.582),('94979','CA','San Anselmo','Marin',37.9706,-122.5605),('94998','CA','Novato','Marin',38.1009,-122.5708),('94999','CA','Petaluma','Sonoma',38.3221,-122.6441),('95001','CA','Aptos','Santa Cruz',36.979,-121.898),('95002','CA','Alviso','Santa Clara',37.42772,-121.978239),('95003','CA','Aptos','Santa Cruz',36.977745,-121.895557),('95004','CA','Aromas','Monterey',36.874755,-121.630732),('95005','CA','Ben Lomond','Santa Cruz',37.089755,-122.086705),('95006','CA','Boulder Creek','Santa Cruz',37.158801,-122.136541),('95007','CA','Brookdale','Santa Cruz',37.105094,-122.104581),('95008','CA','Campbell','Santa Clara',37.283092,-121.955941),('95009','CA','Campbell','Santa Clara',37.2872,-121.9488),('95010','CA','Capitola','Santa Cruz',36.976355,-121.954723),('95011','CA','Campbell','Santa Clara',37.294,-121.9571),('95012','CA','Castroville','Monterey',36.770681,-121.749577),('95013','CA','Coyote','Santa Clara',37.2116,-121.7422),('95014','CA','Cupertino','Santa Clara',37.319639,-122.041766),('95015','CA','Cupertino','Santa Clara',37.323,-122.0527),('95017','CA','Davenport','Santa Cruz',37.084113,-122.222272),('95018','CA','Felton','Santa Cruz',37.065621,-122.065272),('95019','CA','Freedom','Santa Cruz',36.936352,-121.779061),('95020','CA','Gilroy','Santa Clara',37.011385,-121.574531),('95021','CA','Gilroy','Santa Clara',37.0095,-121.5705),('95023','CA','Hollister','San Benito',36.849521,-121.382129),('95024','CA','Hollister','San Benito',36.8586,-121.3982),('95026','CA','Holy City','Santa Clara',37.1584,-121.986),('95030','CA','Los Gatos','Santa Clara',37.229041,-121.983792),('95031','CA','Los Gatos','Santa Clara',37.1574,-121.9676),('95032','CA','Los Gatos','Santa Clara',37.241389,-121.953271),('95033','CA','Los Gatos','Santa Cruz',37.159142,-121.988625),('95035','CA','Milpitas','Santa Clara',37.436476,-121.890732),('95036','CA','Milpitas','Santa Clara',37.424,-121.906),('95037','CA','Morgan Hill','Santa Clara',37.137046,-121.66013),('95038','CA','Morgan Hill','Santa Clara',37.1525,-121.6722),('95039','CA','Moss Landing','Monterey',36.82138,-121.784316),('95041','CA','Mount Hermon','Santa Cruz',37.050674,-122.056725),('95042','CA','New Almaden','Santa Clara',37.1771,-121.8207),('95043','CA','Paicines','San Benito',36.550143,-121.03197),('95044','CA','Redwood Estates','Santa Clara',37.1584,-121.986),('95045','CA','San Juan Bautista','San Benito',36.845169,-121.535547),('95046','CA','San Martin','Santa Clara',37.087212,-121.604733),('95050','CA','Santa Clara','Santa Clara',37.347717,-121.95189),('95051','CA','Santa Clara','Santa Clara',37.348616,-121.984533),('95052','CA','Santa Clara','Santa Clara',37.3522,-121.9583),('95053','CA','Santa Clara','Santa Clara',37.349821,-121.939867),('95054','CA','Santa Clara','Santa Clara',37.393527,-121.964138),('95055','CA','Santa Clara','Santa Clara',37.3451,-121.9769),('95056','CA','Santa Clara','Santa Clara',37.3997,-121.9608),('95060','CA','Santa Cruz','Santa Cruz',36.981023,-122.060919),('95061','CA','Santa Cruz','Santa Cruz',37.063,-122.162),('95062','CA','Santa Cruz','Santa Cruz',36.970804,-121.990755),('95063','CA','Santa Cruz','Santa Cruz',36.9792,-122.0088),('95064','CA','Santa Cruz','Santa Cruz',36.991667,-122.057021),('95065','CA','Santa Cruz','Santa Cruz',37.00533,-121.988717),('95066','CA','Scotts Valley','Santa Cruz',37.059883,-122.017574),('95067','CA','Scotts Valley','Santa Cruz',37.0511,-122.0136),('95070','CA','Saratoga','Santa Clara',37.270472,-122.022796),('95071','CA','Saratoga','Santa Clara',37.2593,-122.0302),('95073','CA','Soquel','Santa Cruz',37.012411,-121.949762),('95075','CA','Tres Pinos','San Benito',36.774886,-121.225359),('95076','CA','Watsonville','Santa Cruz',36.928236,-121.772573),('95077','CA','Watsonville','Santa Cruz',36.9116,-121.7575),('95101','CA','San Jose','Santa Clara',37.3894,-121.8868),('95103','CA','San Jose','Santa Clara',37.3378,-121.8908),('95106','CA','San Jose','Santa Clara',37.3378,-121.8908),('95108','CA','San Jose','Santa Clara',37.3378,-121.8908),('95109','CA','San Jose','Santa Clara',37.3378,-121.8908),('95110','CA','San Jose','Santa Clara',37.337171,-121.899245),('95111','CA','San Jose','Santa Clara',37.283111,-121.826245),('95112','CA','San Jose','Santa Clara',37.346381,-121.88456),('95113','CA','San Jose','Santa Clara',37.334464,-121.890299),('95115','CA','San Jose','Santa Clara',37.3378,-121.8908),('95116','CA','San Jose','Santa Clara',37.349696,-121.854113),('95117','CA','San Jose','Santa Clara',37.311842,-121.961774),('95118','CA','San Jose','Santa Clara',37.257473,-121.89058),('95119','CA','San Jose','Santa Clara',37.230075,-121.788311),('95120','CA','San Jose','Santa Clara',37.209068,-121.851408),('95121','CA','San Jose','Santa Clara',37.304394,-121.810908),('95122','CA','San Jose','Santa Clara',37.329408,-121.833487),('95123','CA','San Jose','Santa Clara',37.244238,-121.831604),('95124','CA','San Jose','Santa Clara',37.256939,-121.923081),('95125','CA','San Jose','Santa Clara',37.294005,-121.896217),('95126','CA','San Jose','Santa Clara',37.326466,-121.917668),('95127','CA','San Jose','Santa Clara',37.368802,-121.821763),('95128','CA','San Jose','Santa Clara',37.318895,-121.935197),('95129','CA','San Jose','Santa Clara',37.307083,-122.000677),('95130','CA','San Jose','Santa Clara',37.287963,-121.98236),('95131','CA','San Jose','Santa Clara',37.387398,-121.889969),('95132','CA','San Jose','Santa Clara',37.409627,-121.847921),('95133','CA','San Jose','Santa Clara',37.373493,-121.857173),('95134','CA','San Jose','Santa Clara',37.412632,-121.94373),('95135','CA','San Jose','Santa Clara',37.29872,-121.751298),('95136','CA','San Jose','Santa Clara',37.272131,-121.848275),('95138','CA','San Jose','Santa Clara',37.253178,-121.767853),('95139','CA','San Jose','Santa Clara',37.223047,-121.765264),('95140','CA','Mount Hamilton','Santa Clara',37.382909,-121.634151),('95141','CA','San Jose','Santa Clara',37.1771,-121.754),('95148','CA','San Jose','Santa Clara',37.331651,-121.788767),('95150','CA','San Jose','Santa Clara',37.3866,-121.897),('95151','CA','San Jose','Santa Clara',37.3198,-121.8262),('95152','CA','San Jose','Santa Clara',37.4022,-121.847),('95153','CA','San Jose','Santa Clara',37.2488,-121.8459),('95154','CA','San Jose','Santa Clara',37.2649,-121.9139),('95155','CA','San Jose','Santa Clara',37.31,-121.9011),('95156','CA','San Jose','Santa Clara',37.3576,-121.8416),('95157','CA','San Jose','Santa Clara',37.3008,-121.9777),('95158','CA','San Jose','Santa Clara',37.2625,-121.8779),('95159','CA','San Jose','Santa Clara',37.3179,-121.9349),('95160','CA','San Jose','Santa Clara',37.2187,-121.8601),('95161','CA','San Jose','Santa Clara',37.3894,-121.8868),('95164','CA','San Jose','Santa Clara',37.3916,-121.9203),('95170','CA','San Jose','Santa Clara',37.3103,-122.0093),('95172','CA','San Jose','Santa Clara',37.334,-121.8847),('95173','CA','San Jose','Santa Clara',37.3352,-121.8938),('95190','CA','San Jose','Santa Clara',37.3894,-121.8868),('95191','CA','San Jose','Santa Clara',37.3262,-121.9158),('95192','CA','San Jose','Santa Clara',37.3383,-121.8801),('95193','CA','San Jose','Santa Clara',37.2441,-121.8287),('95194','CA','San Jose','Santa Clara',37.3894,-121.8868),('95196','CA','San Jose','Santa Clara',37.3338,-121.8894),('95201','CA','Stockton','San Joaquin',37.958,-121.2876),('95202','CA','Stockton','San Joaquin',37.958758,-121.288023),('95203','CA','Stockton','San Joaquin',37.95439,-121.319604),('95204','CA','Stockton','San Joaquin',37.974209,-121.315089),('95205','CA','Stockton','San Joaquin',37.96327,-121.263117),('95206','CA','Stockton','San Joaquin',37.923713,-121.307257),('95207','CA','Stockton','San Joaquin',38.004121,-121.323811),('95208','CA','Stockton','San Joaquin',37.9304,-121.436),('95209','CA','Stockton','San Joaquin',38.039944,-121.342456),('95210','CA','Stockton','San Joaquin',38.024174,-121.299289),('95211','CA','Stockton','San Joaquin',37.979651,-121.31232),('95212','CA','Stockton','San Joaquin',38.03492,-121.25412),('95213','CA','Stockton','San Joaquin',37.9054,-121.2222),('95215','CA','Stockton','San Joaquin',37.94884,-121.20298),('95219','CA','Stockton','San Joaquin',38.028309,-121.424627),('95220','CA','Acampo','San Joaquin',38.196404,-121.247621),('95221','CA','Altaville','Calaveras',38.077,-120.554017),('95222','CA','Angels Camp','Calaveras',38.075378,-120.567391),('95223','CA','Arnold','Calaveras',38.314199,-120.230091),('95224','CA','Avery','Calaveras',38.212542,-120.334389),('95225','CA','Burson','Calaveras',38.20313,-120.88411),('95226','CA','Campo Seco','Calaveras',38.224021,-120.870256),('95227','CA','Clements','San Joaquin',38.199903,-121.0492),('95228','CA','Copperopolis','Calaveras',37.934749,-120.639447),('95229','CA','Douglas Flat','Calaveras',38.1144,-120.4538),('95230','CA','Farmington','San Joaquin',37.965581,-120.860746),('95231','CA','French Camp','San Joaquin',37.878491,-121.278338),('95232','CA','Glencoe','Calaveras',38.347153,-120.585434),('95233','CA','Hathaway Pines','Calaveras',38.178329,-120.370044),('95234','CA','Holt','San Joaquin',37.936054,-121.530127),('95236','CA','Linden','San Joaquin',38.030767,-121.049015),('95237','CA','Lockeford','San Joaquin',38.16188,-121.149837),('95240','CA','Lodi','San Joaquin',38.12452,-121.260481),('95241','CA','Lodi','San Joaquin',38.1327,-121.2724),('95242','CA','Lodi','San Joaquin',38.123381,-121.330011),('95245','CA','Mokelumne Hill','Calaveras',38.28485,-120.665424),('95246','CA','Mountain Ranch','Calaveras',38.253927,-120.500218),('95247','CA','Murphys','Calaveras',38.151791,-120.430238),('95248','CA','Rail Road Flat','Calaveras',38.338385,-120.469124),('95249','CA','San Andreas','Calaveras',38.179814,-120.630411),('95250','CA','Sheep Ranch','Calaveras',38.239402,-120.427558),('95251','CA','Vallecito','Calaveras',38.094954,-120.466855),('95252','CA','Valley Springs','Calaveras',38.151425,-120.854699),('95253','CA','Victor','San Joaquin',38.138,-121.205),('95254','CA','Wallace','Calaveras',38.194826,-120.958756),('95255','CA','West Point','Calaveras',38.415071,-120.4738),('95257','CA','Wilseyville','Calaveras',38.381972,-120.449587),('95258','CA','Woodbridge','San Joaquin',38.156998,-121.30731),('95267','CA','Stockton','San Joaquin',38.0003,-121.3174),('95269','CA','Stockton','San Joaquin',38.0187,-121.3225),('95296','CA','Stockton','San Joaquin',38.0282,-121.2984),('95297','CA','Stockton','San Joaquin',38.0025,-121.324),('95301','CA','Atwater','Merced',37.348774,-120.600053),('95303','CA','Ballico','Merced',37.470288,-120.671088),('95304','CA','Tracy','San Joaquin',37.717127,-121.391799),('95305','CA','Big Oak Flat','Tuolumne',37.815371,-120.28386),('95306','CA','Catheys Valley','Mariposa',37.400553,-120.134713),('95307','CA','Ceres','Stanislaus',37.582025,-120.948214),('95309','CA','Chinese Camp','Tuolumne',37.8594,-120.4069),('95310','CA','Columbia','Tuolumne',38.058299,-120.388529),('95311','CA','Coulterville','Mariposa',37.719118,-120.117201),('95312','CA','Cressey','Merced',37.420494,-120.665055),('95313','CA','Crows Landing','Stanislaus',37.417959,-121.051042),('95314','CA','Dardanelle','Tuolumne',38.3411,-119.8327),('95315','CA','Delhi','Merced',37.427418,-120.773882),('95316','CA','Denair','Stanislaus',37.545286,-120.785222),('95317','CA','El Nido','Merced',37.132362,-120.523861),('95318','CA','El Portal','Mariposa',37.666363,-119.805892),('95319','CA','Empire','Stanislaus',37.63886,-120.904313),('95320','CA','Escalon','San Joaquin',37.798556,-121.004759),('95321','CA','Groveland','Tuolumne',37.828125,-120.081939),('95322','CA','Gustine','Merced',37.165562,-121.015646),('95323','CA','Hickman','Stanislaus',37.613176,-120.71225),('95324','CA','Hilmar','Merced',37.394589,-120.882315),('95325','CA','Hornitos','Mariposa',37.500477,-120.258766),('95326','CA','Hughson','Stanislaus',37.593926,-120.860309),('95327','CA','Jamestown','Tuolumne',37.874607,-120.479825),('95328','CA','Keyes','Stanislaus',37.556387,-120.91052),('95329','CA','La Grange','Tuolumne',37.68756,-120.389297),('95330','CA','Lathrop','San Joaquin',37.814608,-121.290684),('95333','CA','Le Grand','Merced',37.24201,-120.265497),('95334','CA','Livingston','Merced',37.3785,-120.726325),('95335','CA','Long Barn','Tuolumne',38.098292,-120.112616),('95336','CA','Manteca','San Joaquin',37.816876,-121.212758),('95337','CA','Manteca','San Joaquin',37.778403,-121.233288),('95338','CA','Mariposa','Mariposa',37.499975,-119.97332),('95340','CA','Merced','Merced',37.315078,-120.45526),('95341','CA','Merced','Merced',37.269674,-120.492382),('95343','CA','Merced','Merced',37.3082,-120.48),('95344','CA','Merced','Merced',37.3082,-120.48),('95345','CA','Midpines','Mariposa',37.576889,-119.956993),('95346','CA','Mi Wuk Village','Tuolumne',38.067516,-120.181604),('95347','CA','Moccasin','Tuolumne',37.8108,-120.2988),('95348','CA','Merced','Merced',37.344582,-120.501287),('95350','CA','Modesto','Stanislaus',37.670436,-121.006493),('95351','CA','Modesto','Stanislaus',37.623929,-120.997904),('95352','CA','Modesto','Stanislaus',37.6566,-121.0191),('95353','CA','Modesto','Stanislaus',37.6424,-120.9999),('95354','CA','Modesto','Stanislaus',37.641356,-120.977225),('95355','CA','Modesto','Stanislaus',37.671599,-120.948889),('95356','CA','Modesto','Stanislaus',37.702857,-121.023791),('95357','CA','Modesto','Stanislaus',37.665092,-120.908131),('95358','CA','Modesto','Stanislaus',37.622714,-121.050191),('95360','CA','Newman','Stanislaus',37.313472,-121.032673),('95361','CA','Oakdale','Stanislaus',37.774531,-120.830592),('95363','CA','Patterson','Stanislaus',37.476221,-121.149822),('95364','CA','Pinecrest','Tuolumne',38.275328,-119.896198),('95365','CA','Planada','Merced',37.29907,-120.322286),('95366','CA','Ripon','San Joaquin',37.74577,-121.128018),('95367','CA','Riverbank','Stanislaus',37.729282,-120.942905),('95368','CA','Salida','Stanislaus',37.708891,-121.086289),('95369','CA','Snelling','Merced',37.531889,-120.437413),('95370','CA','Sonora','Tuolumne',37.989869,-120.338377),('95372','CA','Soulsbyville','Tuolumne',37.989757,-120.260602),('95373','CA','Standard','Tuolumne',37.9666,-120.3108),('95374','CA','Stevinson','Merced',37.316895,-120.869385),('95375','CA','Strawberry','Tuolumne',38.193074,-120.015632),('95376','CA','Tracy','San Joaquin',37.737908,-121.433181),('95377','CA','Tracy','San Joaquin',37.71725,-121.471819),('95378','CA','Tracy','San Joaquin',37.6761,-121.433),('95379','CA','Tuolumne','Tuolumne',37.95904,-120.232171),('95380','CA','Turlock','Stanislaus',37.486242,-120.850831),('95381','CA','Turlock','Stanislaus',37.4994,-120.8428),('95382','CA','Turlock','Stanislaus',37.52642,-120.847771),('95383','CA','Twain Harte','Tuolumne',38.058348,-120.225772),('95385','CA','Vernalis','Stanislaus',37.611475,-121.26685),('95386','CA','Waterford','Stanislaus',37.650209,-120.715637),('95387','CA','Westley','Stanislaus',37.539671,-121.263193),('95388','CA','Winton','Merced',37.405704,-120.605978),('95389','CA','Yosemite National Park','Mariposa',37.738062,-119.603669),('95391','CA','Tracy','San Joaquin',37.766816,-121.567174),('95397','CA','Modesto','Stanislaus',37.6566,-121.0191),('95401','CA','Santa Rosa','Sonoma',38.440911,-122.753125),('95402','CA','Santa Rosa','Sonoma',38.4399,-122.7096),('95403','CA','Santa Rosa','Sonoma',38.481395,-122.748044),('95404','CA','Santa Rosa','Sonoma',38.453145,-122.691336),('95405','CA','Santa Rosa','Sonoma',38.438549,-122.671872),('95406','CA','Santa Rosa','Sonoma',38.4399,-122.7096),('95407','CA','Santa Rosa','Sonoma',38.408041,-122.736235),('95409','CA','Santa Rosa','Sonoma',38.459086,-122.639084),('95410','CA','Albion','Mendocino',39.210273,-123.711721),('95412','CA','Annapolis','Sonoma',38.717022,-123.341275),('95415','CA','Boonville','Mendocino',39.022008,-123.379275),('95416','CA','Boyes Hot Springs','Sonoma',38.3141,-122.4843),('95417','CA','Branscomb','Mendocino',39.675367,-123.61637),('95418','CA','Calpella','Mendocino',39.2214,-123.2154),('95419','CA','Camp Meeker','Sonoma',38.424554,-122.96067),('95420','CA','Caspar','Mendocino',39.366146,-123.804985),('95421','CA','Cazadero','Sonoma',38.578012,-123.175599),('95422','CA','Clearlake','Lake',38.95761,-122.632593),('95423','CA','Clearlake Oaks','Lake',39.037999,-122.638135),('95424','CA','Clearlake Park','Lake',38.971518,-122.664237),('95425','CA','Cloverdale','Sonoma',38.810055,-123.000972),('95426','CA','Cobb','Lake',38.839547,-122.742563),('95427','CA','Comptche','Mendocino',39.246102,-123.549303),('95428','CA','Covelo','Mendocino',39.823602,-123.213864),('95429','CA','Dos Rios','Mendocino',39.720542,-123.300585),('95430','CA','Duncans Mills','Sonoma',38.449265,-123.054955),('95431','CA','Eldridge','Sonoma',38.347934,-122.517647),('95432','CA','Elk','Mendocino',39.103978,-123.646169),('95433','CA','El Verano','Sonoma',38.2993,-122.4867),('95435','CA','Finley','Lake',39.003314,-122.874691),('95436','CA','Forestville','Sonoma',38.49585,-122.906526),('95437','CA','Fort Bragg','Mendocino',39.439926,-123.77367),('95439','CA','Fulton','Sonoma',38.495375,-122.77253),('95441','CA','Geyserville','Sonoma',38.715853,-122.902475),('95442','CA','Glen Ellen','Sonoma',38.368744,-122.522642),('95443','CA','Glenhaven','Lake',39.04205,-122.73177),('95444','CA','Graton','Sonoma',38.434727,-122.867691),('95445','CA','Gualala','Mendocino',38.817542,-123.549991),('95446','CA','Guerneville','Sonoma',38.506408,-122.998055),('95448','CA','Healdsburg','Sonoma',38.615754,-122.878782),('95449','CA','Hopland','Mendocino',38.938726,-123.070587),('95450','CA','Jenner','Sonoma',38.485529,-123.171051),('95451','CA','Kelseyville','Lake',38.936339,-122.80988),('95452','CA','Kenwood','Sonoma',38.417836,-122.550853),('95453','CA','Lakeport','Lake',39.044368,-122.923724),('95454','CA','Laytonville','Mendocino',39.745276,-123.511982),('95456','CA','Little R','Mendocino',39.267668,-123.755015),('95457','CA','Lower Lake','Lake',38.883425,-122.565759),('95458','CA','Lucerne','Lake',39.09872,-122.787679),('95459','CA','Manchester','Mendocino',38.973082,-123.647921),('95460','CA','Mendocino','Mendocino',39.308898,-123.777108),('95461','CA','Middletown','Lake',38.767935,-122.614516),('95462','CA','Monte Rio','Sonoma',38.470402,-123.013951),('95463','CA','Navarro','Mendocino',39.173321,-123.550811),('95464','CA','Nice','Lake',39.128098,-122.853188),('95465','CA','Occidental','Sonoma',38.415032,-122.998639),('95466','CA','Philo','Mendocino',39.090174,-123.505568),('95467','CA','Hidden Valley Lake','Lake',38.802551,-122.548941),('95468','CA','Point Arena','Mendocino',38.913071,-123.639506),('95469','CA','Potter Valley','Mendocino',39.382985,-123.064269),('95470','CA','Redwood Valley','Mendocino',39.285852,-123.217544),('95471','CA','Rio Nido','Sonoma',38.522061,-122.97615),('95472','CA','Sebastopol','Sonoma',38.398381,-122.84341),('95473','CA','Sebastopol','Sonoma',38.4022,-122.8227),('95476','CA','Sonoma','Sonoma',38.277258,-122.465914),('95480','CA','Stewarts Point','Sonoma',38.654705,-123.399906),('95481','CA','Talmage','Mendocino',39.131856,-123.162213),('95482','CA','Ukiah','Mendocino',39.162802,-123.20991),('95485','CA','Upper Lake','Lake',39.185265,-122.919206),('95486','CA','Villa Grande','Sonoma',38.474456,-123.024808),('95487','CA','Vineburg','Sonoma',38.2725,-122.4375),('95488','CA','Westport','Mendocino',39.708638,-123.765966),('95490','CA','Willits','Mendocino',39.449879,-123.372498),('95492','CA','Windsor','Sonoma',38.539153,-122.808301),('95493','CA','Witter Springs','Lake',39.187599,-122.967299),('95494','CA','Yorkville','Mendocino',38.908141,-123.336464),('95497','CA','The Sea Ranch','Sonoma',38.72302,-123.465013),('95501','CA','Eureka','Humboldt',40.793948,-124.15977),('95502','CA','Eureka','Humboldt',40.814595,-124.080527),('95503','CA','Eureka','Humboldt',40.75957,-124.155417),('95511','CA','Alderpoint','Humboldt',40.175994,-123.609393),('95514','CA','Blocksburg','Humboldt',40.308185,-123.666957),('95518','CA','Arcata','Humboldt',40.8685,-124.0856),('95519','CA','Mckinleyville','Humboldt',40.952265,-124.074902),('95521','CA','Arcata','Humboldt',40.870434,-124.083088),('95524','CA','Bayside','Humboldt',40.826271,-124.066982),('95525','CA','Blue Lake','Humboldt',40.920248,-123.897039),('95526','CA','Bridgeville','Humboldt',40.459063,-123.673165),('95527','CA','Burnt Ranch','Trinity',40.843937,-123.484035),('95528','CA','Carlotta','Humboldt',40.498392,-123.964495),('95531','CA','Crescent City','Del Norte',41.780015,-124.146742),('95532','CA','Crescent City','Del Norte',41.7561,-124.2005),('95534','CA','Cutten','Humboldt',40.7965,-124.1737),('95536','CA','Ferndale','Humboldt',40.561297,-124.257554),('95537','CA','Fields Landing','Humboldt',40.726317,-124.216695),('95538','CA','Fort Dick','Del Norte',41.8382,-124.166),('95540','CA','Fortuna','Humboldt',40.582092,-124.146778),('95542','CA','Garberville','Humboldt',40.085488,-123.810867),('95543','CA','Gasquet','Del Norte',41.867218,-123.877148),('95545','CA','Honeydew','Humboldt',40.286224,-124.070525),('95546','CA','Hoopa','Humboldt',41.143352,-123.723576),('95547','CA','Hydesville','Humboldt',40.556552,-124.083915),('95548','CA','Klamath','Del Norte',41.550207,-124.039327),('95549','CA','Kneeland','Humboldt',40.687124,-123.923853),('95550','CA','Korbel','Humboldt',40.768442,-123.848735),('95551','CA','Loleta','Humboldt',40.660081,-124.222423),('95552','CA','Mad River','Trinity',40.302769,-123.34569),('95553','CA','Miranda','Humboldt',40.228148,-123.848893),('95554','CA','Myers Flat','Humboldt',40.282838,-123.828449),('95555','CA','Orick','Humboldt',41.305115,-124.020243),('95556','CA','Orleans','Humboldt',41.305835,-123.55469),('95558','CA','Petrolia','Humboldt',40.272947,-124.224784),('95559','CA','Phillipsville','Humboldt',40.204661,-123.781027),('95560','CA','Redway','Humboldt',40.134889,-123.838988),('95562','CA','Rio Dell','Humboldt',40.496521,-124.106927),('95563','CA','Salyer','Trinity',40.881019,-123.541078),('95564','CA','Samoa','Humboldt',40.800323,-124.197966),('95565','CA','Scotia','Humboldt',40.461103,-124.055242),('95567','CA','Smith River','Del Norte',41.938247,-124.155346),('95568','CA','Somes Bar','Siskiyou',41.449188,-123.490238),('95569','CA','Redcrest','Humboldt',40.352968,-123.891476),('95570','CA','Trinidad','Humboldt',41.096613,-124.143444),('95571','CA','Weott','Humboldt',40.323039,-123.921444),('95573','CA','Willow Creek','Humboldt',40.931307,-123.644866),('95585','CA','Leggett','Mendocino',39.849752,-123.68957),('95587','CA','Piercy','Mendocino',39.959162,-123.780967),('95589','CA','Whitethorn','Humboldt',40.046396,-123.962099),('95595','CA','Zenia','Trinity',40.094059,-123.464974),('95601','CA','Amador City','Amador',38.423131,-120.82458),('95602','CA','Auburn','Placer',38.979909,-121.088069),('95603','CA','Auburn','Placer',38.913176,-121.076456),('95604','CA','Auburn','Placer',38.9029,-121.067),('95605','CA','West Sacramento','Yolo',38.592911,-121.53291),('95606','CA','Brooks','Yolo',38.764184,-122.16317),('95607','CA','Capay','Yolo',38.733156,-122.127782),('95608','CA','Carmichael','Sacramento',38.628252,-121.33061),('95609','CA','Carmichael','Sacramento',38.6257,-121.3272),('95610','CA','Citrus Heights','Sacramento',38.695458,-121.268502),('95611','CA','Citrus Heights','Sacramento',38.7072,-121.28),('95612','CA','Clarksburg','Yolo',38.388036,-121.563374),('95613','CA','Coloma','El Dorado',38.79829,-120.885787),('95614','CA','Cool','El Dorado',38.886152,-120.979751),('95615','CA','Courtland','Sacramento',38.318625,-121.554752),('95616','CA','Davis','Yolo',38.552916,-121.763667),('95617','CA','Davis','Yolo',38.5494,-121.7253),('95618','CA','Davis, C','Yolo',38.54207,-121.714494),('95619','CA','Diamond Springs','El Dorado',38.68432,-120.818153),('95620','CA','Dixon','Solano',38.41279,-121.81136),('95621','CA','Citrus Heights','Sacramento',38.695546,-121.308965),('95623','CA','El Dorado','El Dorado',38.644428,-120.852145),('95624','CA','Elk Grove','Sacramento',38.42086,-121.361345),('95625','CA','Elmira','Solano',38.354749,-121.91124),('95626','CA','Elverta','Sacramento',38.727385,-121.454407),('95627','CA','Esparto','Yolo',38.706954,-122.011317),('95628','CA','Fair Oaks','Sacramento',38.6547,-121.263583),('95629','CA','Fiddletown','Amador',38.509618,-120.690468),('95630','CA','Folsom','Sacramento',38.671372,-121.153604),('95631','CA','Foresthill','Placer',39.052114,-120.808779),('95632','CA','Galt','Sacramento',38.270447,-121.30235),('95633','CA','Garden Valley','El Dorado',38.840042,-120.829849),('95634','CA','Georgetown','El Dorado',38.923352,-120.789949),('95635','CA','Greenwood','El Dorado',38.909951,-120.897013),('95636','CA','Grizzly Flats','El Dorado',38.631279,-120.443674),('95637','CA','Guinda','Yolo',38.837067,-122.206692),('95638','CA','Herald','Sacramento',38.306089,-121.179067),('95639','CA','Hood','Sacramento',38.392771,-121.506204),('95640','CA','Ione','Amador',38.34156,-120.940253),('95641','CA','Isleton','Sacramento',38.152814,-121.596425),('95642','CA','Jackson','Amador',38.359542,-120.75486),('95644','CA','Kit Carson','Amador',38.456,-120.5294),('95645','CA','Knights Landing','Yolo',38.876579,-121.736944),('95646','CA','Kirkwood','Alpine',38.694466,-120.069765),('95648','CA','Lincoln','Placer',38.893811,-121.292219),('95650','CA','Loomis','Placer',38.815701,-121.180899),('95651','CA','Lotus','El Dorado',38.817752,-120.922691),('95652','CA','Mcclellan','Sacramento',38.654928,-121.392546),('95653','CA','Madison','Yolo',38.686222,-121.975815),('95654','CA','Martell','Amador',38.3515,-120.7752),('95655','CA','Mather','Sacramento',38.555084,-121.289214),('95656','CA','Mount Aukum','El Dorado',38.55,-120.7304),('95658','CA','Newcastle','Placer',38.874086,-121.142489),('95659','CA','Nicolaus','Sutter',38.85845,-121.567073),('95660','CA','North Highlands','Sacramento',38.675069,-121.37673),('95661','CA','Roseville','Placer',38.737677,-121.252452),('95662','CA','Orangevale','Sacramento',38.682755,-121.223217),('95663','CA','Penryn','Placer',38.85292,-121.1788),('95664','CA','Pilot Hill','El Dorado',38.811511,-121.024665),('95665','CA','Pine Grove','Amador',38.399739,-120.654561),('95666','CA','Pioneer','Amador',38.511246,-120.472531),('95667','CA','Placerville','El Dorado',38.728678,-120.801164),('95668','CA','Pleasant Grove','Sutter',38.833554,-121.498102),('95669','CA','Plymouth','Amador',38.485466,-120.877963),('95670','CA','Rancho Cordova','Sacramento',38.602282,-121.281618),('95671','CA','Represa','Sacramento',38.7065,-121.1694),('95672','CA','Rescue','El Dorado',38.711365,-121.00048),('95673','CA','Rio Linda','Sacramento',38.688381,-121.450516),('95674','CA','Rio Oso','Sutter',38.961993,-121.481595),('95675','CA','River Pines','Amador',38.545178,-120.742016),('95676','CA','Robbins','Sutter',38.909351,-121.718438),('95677','CA','Rocklin','Placer',38.790124,-121.236402),('95678','CA','Roseville','Placer',38.758222,-121.287274),('95679','CA','Rumsey','Yolo',38.908612,-122.309376),('95680','CA','Ryde','Sacramento',38.240419,-121.587535),('95681','CA','Sheridan','Placer',39.008261,-121.370024),('95682','CA','Shingle Springs','El Dorado',38.656626,-120.962126),('95683','CA','Sloughhouse','Sacramento',38.506099,-121.096102),('95684','CA','Somerset','El Dorado',38.607426,-120.611102),('95685','CA','Sutter Creek','Amador',38.403765,-120.777366),('95686','CA','Thornton','San Joaquin',38.215956,-121.436946),('95687','CA','Vacaville','Solano',38.347557,-121.948126),('95688','CA','Vacaville','Solano',38.393417,-121.997952),('95689','CA','Volcano','Amador',38.472177,-120.595907),('95690','CA','Walnut Grove','Sacramento',38.246059,-121.562139),('95691','CA','West Sacramento','Yolo',38.565844,-121.547086),('95692','CA','Wheatland','Yuba',39.028732,-121.428657),('95693','CA','Wilton','Sacramento',38.397097,-121.245274),('95694','CA','Winters','Yolo',38.525659,-121.973157),('95695','CA','Woodland','Yolo',38.684912,-121.807143),('95696','CA','Vacaville','Solano',38.43,-122.0168),('95697','CA','Yolo','Yolo',38.732225,-121.810374),('95698','CA','Zamora','Yolo',38.816357,-121.910774),('95699','CA','Drytown','Amador',38.440532,-120.855184),('95701','CA','Alta','Placer',39.228522,-120.770721),('95703','CA','Applegate','Placer',38.999963,-120.99605),('95709','CA','Camino','El Dorado',38.750132,-120.675412),('95712','CA','Chicago Park','Nevada',39.143,-120.9666),('95713','CA','Colfax','Placer',39.092082,-120.940853),('95714','CA','Dutch Flat','Placer',39.201159,-120.836798),('95715','CA','Emigrant Gap','Placer',39.297896,-120.642481),('95717','CA','Gold Run','Placer',39.153242,-120.852408),('95720','CA','Kyburz','El Dorado',38.779745,-120.254037),('95721','CA','Echo Lake','El Dorado',38.820549,-120.074459),('95722','CA','Meadow Vista','Placer',39.003358,-121.022539),('95724','CA','Norden','Nevada',39.2983,-120.4325),('95726','CA','Pollock Pines','El Dorado',38.762707,-120.546299),('95728','CA','Soda Springs','Placer',39.316807,-120.430957),('95735','CA','Twin Bridges','El Dorado',38.805088,-120.140167),('95736','CA','Weimar','Placer',39.03746,-120.976432),('95741','CA','Rancho Cordova','Sacramento',38.5891,-121.3016),('95742','CA','Rancho Cordova','Sacramento',38.589728,-121.210194),('95746','CA','Granite Bay','Placer',38.746538,-121.186343),('95747','CA','Roseville','Placer',38.77299,-121.344806),('95757','CA','Elk Grove','Sacramento',38.380752,-121.442643),('95758','CA','Elk Grove','Sacramento',38.426805,-121.439946),('95759','CA','Elk Grove','Sacramento',38.407,-121.3752),('95762','CA','El Dorado Hills','El Dorado',38.677235,-121.064826),('95763','CA','Folsom','Sacramento',38.678,-121.175),('95765','CA','Rocklin','Placer',38.814154,-121.270728),('95776','CA','Woodland','Yolo',38.67074,-121.733352),('95798','CA','West Sacramento','Yolo',38.5805,-121.5291),('95799','CA','West Sacramento','Yolo',38.5713,-121.5715),('95811','CA','Sacramento','Sacramento',38.576007,-121.485381),('95812','CA','Sacramento','Sacramento',38.5822,-121.4943),('95813','CA','Sacramento','Sacramento',38.6026,-121.4475),('95814','CA','Sacramento','Sacramento',38.580214,-121.494258),('95815','CA','Sacramento','Sacramento',38.609981,-121.447625),('95816','CA','Sacramento','Sacramento',38.572018,-121.469255),('95817','CA','Sacramento','Sacramento',38.552355,-121.461351),('95818','CA','Sacramento','Sacramento',38.558159,-121.493093),('95819','CA','Sacramento','Sacramento',38.567927,-121.442636),('95820','CA','Sacramento','Sacramento',38.53529,-121.446645),('95821','CA','Sacramento','Sacramento',38.625693,-121.384916),('95822','CA','Sacramento','Sacramento',38.512787,-121.493618),('95823','CA','Sacramento','Sacramento',38.477768,-121.443227),('95824','CA','Sacramento','Sacramento',38.518382,-121.443969),('95825','CA','Sacramento','Sacramento',38.593004,-121.40466),('95826','CA','Sacramento','Sacramento',38.552411,-121.376248),('95827','CA','Sacramento','Sacramento',38.568166,-121.328362),('95828','CA','Sacramento','Sacramento',38.485856,-121.401083),('95829','CA','Sacramento','Sacramento',38.466283,-121.345523),('95830','CA','Sacramento','Sacramento',38.489841,-121.266324),('95831','CA','Sacramento','Sacramento',38.49548,-121.527719),('95832','CA','Sacramento','Sacramento',38.471238,-121.490945),('95833','CA','Sacramento','Sacramento',38.616876,-121.503377),('95834','CA','Sacramento','Sacramento',38.641302,-121.514645),('95835','CA','Sacramento','Sacramento',38.672268,-121.521241),('95836','CA','Sacramento','Sacramento',38.707236,-121.54983),('95837','CA','Sacramento','Sacramento',38.691681,-121.592346),('95838','CA','Sacramento','Sacramento',38.6404,-121.439567),('95840','CA','Sacramento','Sacramento',38.5816,-121.4933),('95841','CA','Sacramento','Sacramento',38.663817,-121.345111),('95842','CA','Sacramento','Sacramento',38.688032,-121.348683),('95843','CA','Antelope','Sacramento',38.714715,-121.366415),('95851','CA','Sacramento','Sacramento',38.6026,-121.4475),('95852','CA','Sacramento','Sacramento',38.6026,-121.4475),('95853','CA','Sacramento','Sacramento',38.6026,-121.4475),('95860','CA','Sacramento','Sacramento',38.6105,-121.3799),('95864','CA','Sacramento','Sacramento',38.58813,-121.379094),('95865','CA','Sacramento','Sacramento',38.596,-121.3978),('95866','CA','Sacramento','Sacramento',38.596,-121.3978),('95867','CA','Sacramento','Sacramento',38.5816,-121.4933),('95887','CA','Sacramento','Sacramento',38.5816,-121.4933),('95894','CA','Sacramento','Sacramento',38.5816,-121.4933),('95899','CA','Sacramento','Sacramento',38.5383,-121.5549),('95901','CA','Marysville','Yuba',39.160317,-121.53246),('95903','CA','Beale Afb','Yuba',39.094856,-121.360776),('95910','CA','Alleghany','Sierra',39.471021,-120.838327),('95912','CA','Arbuckle','Colusa',39.018876,-122.051815),('95913','CA','Artois','Glenn',39.633265,-122.21009),('95914','CA','Bangor','Butte',39.43012,-121.356173),('95915','CA','Belden','Plumas',40.004999,-121.242263),('95916','CA','Berry Creek','Butte',39.639158,-121.395188),('95917','CA','Biggs','Butte',39.41545,-121.707561),('95918','CA','Browns Valley','Yuba',39.275856,-121.334824),('95919','CA','Brownsville','Yuba',39.444303,-121.266666),('95920','CA','Butte City','Glenn',39.442185,-121.948739),('95922','CA','Camptonville','Yuba',39.493558,-121.057054),('95923','CA','Canyon Dam','Plumas',40.195814,-121.114666),('95924','CA','Cedar Ridge','Nevada',39.1988,-121.02),('95925','CA','Challenge','Yuba',39.486482,-121.192801),('95926','CA','Chico','Butte',39.744653,-121.847415),('95927','CA','Chico','Butte',39.8117,-121.9398),('95928','CA','Chico','Butte',39.719993,-121.818755),('95929','CA','Chico','Butte',39.7301,-121.8414),('95930','CA','Clipper Mills','Butte',39.563522,-121.131914),('95932','CA','Colusa','Colusa',39.226149,-122.001935),('95934','CA','Crescent Mills','Plumas',40.075793,-120.937713),('95935','CA','Dobbins','Yuba',39.37826,-121.202552),('95936','CA','Downieville','Sierra',39.567305,-120.812565),('95937','CA','Dunnigan','Yolo',38.884535,-121.982601),('95938','CA','Durham','Butte',39.629358,-121.790771),('95939','CA','Elk Creek','Glenn',39.584213,-122.593595),('95940','CA','Feather Falls','Butte',39.622,-121.2669),('95941','CA','Forbestown','Butte',39.521048,-121.220096),('95942','CA','Forest Ranch','Butte',40.039441,-121.570548),('95943','CA','Glenn','Glenn',39.605233,-122.032221),('95944','CA','Goodyears Bar','Sierra',39.494342,-120.926208),('95945','CA','Grass Valley','Nevada',39.200468,-121.0146),('95946','CA','Penn Valley','Nevada',39.215497,-121.194299),('95947','CA','Greenville','Plumas',40.170384,-120.848075),('95948','CA','Gridley','Butte',39.351932,-121.717057),('95949','CA','Grass Valley','Nevada',39.13468,-121.097652),('95950','CA','Grimes','Colusa',39.0591,-121.90996),('95951','CA','Hamilton City','Glenn',39.734664,-122.00939),('95953','CA','Live Oak','Sutter',39.263664,-121.696395),('95954','CA','Magalia','Butte',39.85499,-121.595775),('95955','CA','Maxwell','Colusa',39.303345,-122.191437),('95956','CA','Meadow Valley','Plumas',39.888813,-121.11553),('95957','CA','Meridian','Sutter',39.08154,-121.832924),('95958','CA','Nelson','Butte',39.5522,-121.7644),('95959','CA','Nevada City','Nevada',39.303865,-120.959383),('95960','CA','North San Juan','Nevada',39.39872,-121.062685),('95961','CA','Olivehurst','Yuba',39.054314,-121.556523),('95962','CA','Oregon House','Yuba',39.347178,-121.263578),('95963','CA','Orland','Glenn',39.750753,-122.206328),('95965','CA','Oroville','Butte',39.562525,-121.59275),('95966','CA','Oroville','Butte',39.489837,-121.485519),('95967','CA','Paradise','Butte',39.7155,-121.6551),('95968','CA','Palermo','Butte',39.434639,-121.550517),('95969','CA','Paradise','Butte',39.745937,-121.616927),('95970','CA','Princeton','Colusa',39.410269,-122.05203),('95971','CA','Quincy','Plumas',39.945193,-120.911918),('95972','CA','Rackerby','Yuba',39.441356,-121.313541),('95973','CA','Chico','Butte',39.808659,-121.868159),('95974','CA','Richvale','Butte',39.496465,-121.747123),('95975','CA','Rough And Ready','Nevada',39.228268,-121.151525),('95976','CA','Chico','Butte',39.7346,-121.8331),('95977','CA','Smartville','Nevada',39.193704,-121.291393),('95978','CA','Stirling City','Butte',39.881751,-121.523924),('95979','CA','Stonyford','Colusa',39.305106,-122.576816),('95980','CA','Storrie','Plumas',39.9175,-121.3222),('95981','CA','Strawberry Valley','Yuba',39.623349,-121.035383),('95982','CA','Sutter','Sutter',39.166773,-121.779552),('95983','CA','Taylorsville','Plumas',40.085778,-120.764514),('95984','CA','Twain','Plumas',40.028794,-121.091972),('95986','CA','Washington','Nevada',39.342368,-120.782624),('95987','CA','Williams','Colusa',39.139608,-122.204831),('95988','CA','Willows','Glenn',39.513401,-122.209466),('95991','CA','Yuba City','Sutter',39.114176,-121.621861),('95992','CA','Yuba City','Sutter',39.023,-121.6116),('95993','CA','Yuba City','Sutter',39.128826,-121.668186),('96001','CA','Redding','Shasta',40.573822,-122.407916),('96002','CA','Redding','Shasta',40.539434,-122.333293),('96003','CA','Redding','Shasta',40.652216,-122.332526),('96006','CA','Adin','Modoc',41.195635,-120.895769),('96007','CA','Anderson','Shasta',40.456879,-122.303502),('96008','CA','Bella Vista','Shasta',40.689267,-122.119623),('96009','CA','Bieber','Lassen',41.058951,-121.081603),('96010','CA','Big Bar','Trinity',40.773179,-123.290608),('96011','CA','Big Bend','Shasta',41.062297,-121.925643),('96013','CA','Burney','Shasta',40.976848,-121.659607),('96014','CA','Callahan','Siskiyou',41.304861,-122.815742),('96015','CA','Canby','Modoc',41.486953,-120.913975),('96016','CA','Cassel','Shasta',40.923971,-121.548663),('96017','CA','Castella','Shasta',41.150961,-122.292098),('96019','CA','Shasta Lake','Shasta',40.677995,-122.371485),('96020','CA','Chester','Plumas',40.314721,-121.243857),('96021','CA','Corning','Tehama',39.926169,-122.205626),('96022','CA','Cottonwood','Tehama',40.360656,-122.321833),('96023','CA','Dorris','Siskiyou',41.943253,-121.874881),('96024','CA','Douglas City','Trinity',40.598956,-122.90301),('96025','CA','Dunsmuir','Siskiyou',41.222174,-122.275405),('96027','CA','Etna','Siskiyou',41.409995,-122.976249),('96028','CA','Fall River Mills','Shasta',41.056565,-121.491819),('96029','CA','Flournoy','Tehama',39.924388,-122.482571),('96031','CA','Forks Of Salmon','Siskiyou',41.193404,-123.197681),('96032','CA','Fort Jones','Siskiyou',41.620733,-122.934052),('96033','CA','French Gulch','Shasta',40.724385,-122.602355),('96034','CA','Gazelle','Siskiyou',41.468269,-122.582607),('96035','CA','Gerber','Tehama',40.0456,-122.172862),('96037','CA','Greenview','Siskiyou',41.548866,-122.933125),('96038','CA','Grenada','Siskiyou',41.621991,-122.527451),('96039','CA','Happy Camp','Siskiyou',41.754291,-123.449381),('96040','CA','Hat Creek','Shasta',40.793535,-121.438607),('96041','CA','Hayfork','Trinity',40.525305,-123.183773),('96044','CA','Hornbrook','Siskiyou',41.947752,-122.510571),('96046','CA','Hyampom','Trinity',40.619159,-123.441575),('96047','CA','Igo','Shasta',40.473048,-122.648709),('96048','CA','Junction City','Trinity',40.743618,-123.058661),('96049','CA','Redding','Siskiyou',41.771354,-123.346136),('96050','CA','Klamath River','Siskiyou',41.89517,-122.88458),('96051','CA','Lakehead','Shasta',40.927357,-122.378676),('96052','CA','Lewiston','Trinity',40.725892,-122.822859),('96054','CA','Lookout','Modoc',41.253187,-121.137116),('96055','CA','Los Molinos','Tehama',40.054857,-122.071224),('96056','CA','Mcarthur','Shasta',41.055714,-121.310243),('96057','CA','Mccloud','Siskiyou',41.264001,-121.998115),('96058','CA','Macdoel','Siskiyou',41.759216,-121.984398),('96059','CA','Manton','Tehama',40.437109,-121.813294),('96061','CA','Mill Creek','Tehama',40.338325,-121.469957),('96062','CA','Millville','Shasta',40.563945,-122.120613),('96063','CA','Mineral','Tehama',40.347448,-121.60989),('96064','CA','Montague','Siskiyou',41.728289,-122.391472),('96065','CA','Montgomery Creek','Shasta',40.887544,-121.911909),('96067','CA','Mount Shasta','Siskiyou',41.313668,-122.315615),('96068','CA','Nubieber','Lassen',41.11022,-121.198351),('96069','CA','Oak Run','Shasta',40.683201,-122.029122),('96070','CA','Obrien','Shasta',40.9564,-122.1835),('96071','CA','Old Station','Shasta',40.662401,-121.45284),('96073','CA','Palo Cedro','Shasta',40.563254,-122.227254),('96074','CA','Paskenta','Tehama',39.865494,-122.586115),('96075','CA','Paynes Creek','Tehama',40.346134,-121.863722),('96076','CA','Platina','Trinity',40.35968,-122.932766),('96078','CA','Proberta','Tehama',40.0816,-122.1694),('96079','CA','Shasta Lake','Shasta',40.6767,-122.352),('96080','CA','Red Bluff','Tehama',40.18336,-122.247305),('96084','CA','Round Mountain','Shasta',40.819015,-121.949288),('96085','CA','Scott Bar','Siskiyou',41.731775,-123.011226),('96086','CA','Seiad Valley','Siskiyou',41.845096,-123.205851),('96087','CA','Shasta','Shasta',40.632149,-122.587057),('96088','CA','Shingletown','Shasta',40.504505,-121.840413),('96089','CA','Shasta Lake','Shasta',40.6861,-122.4005),('96090','CA','Tehama','Tehama',40.024299,-122.124972),('96091','CA','Trinity Center','Trinity',41.021997,-122.748204),('96092','CA','Vina','Tehama',39.944027,-122.040378),('96093','CA','Weaverville','Trinity',40.735951,-122.940222),('96094','CA','Weed','Siskiyou',41.481939,-122.351487),('96095','CA','Whiskeytown','Shasta',40.607134,-122.546261),('96096','CA','Whitmore','Shasta',40.651991,-121.846791),('96097','CA','Yreka','Siskiyou',41.744868,-122.647784),('96099','CA','Redding','Shasta',40.5255,-122.7139),('96101','CA','Alturas','Modoc',41.436408,-120.585855),('96103','CA','Blairsden-graeagle','Plumas',39.794993,-120.649474),('96104','CA','Cedarville','Modoc',41.537401,-120.14923),('96105','CA','Chilcoot','Plumas',39.804002,-120.139932),('96106','CA','Clio','Plumas',39.736845,-120.550857),('96107','CA','Coleville','Mono',38.46735,-119.489682),('96108','CA','Davis Creek','Modoc',41.763967,-120.417954),('96109','CA','Doyle','Lassen',40.024073,-120.105087),('96110','CA','Eagleville','Modoc',41.275073,-120.094081),('96111','CA','Floriston','Sierra',39.483355,-120.037576),('96112','CA','Fort Bidwell','Modoc',41.862213,-120.142323),('96113','CA','Herlong','Lassen',40.141678,-120.152581),('96114','CA','Janesville','Lassen',40.292431,-120.507129),('96115','CA','Lake City','Modoc',41.63502,-120.13489),('96116','CA','Likely','Modoc',41.269094,-120.426951),('96117','CA','Litchfield','Lassen',40.471036,-120.304571),('96118','CA','Loyalton','Sierra',39.640766,-120.224689),('96119','CA','Madeline','Lassen',41.022722,-120.523987),('96120','CA','Markleeville','Alpine',38.767929,-119.841099),('96121','CA','Milford','Lassen',40.166024,-120.367619),('96122','CA','Portola','Plumas',39.815826,-120.476084),('96123','CA','Ravendale','Lassen',40.801509,-120.289486),('96124','CA','Calpine','Sierra',39.647723,-120.448606),('96125','CA','Sierra City','Sierra',39.602124,-120.635732),('96126','CA','Sierraville','Sierra',39.53552,-120.447507),('96127','CA','Susanville','Lassen',40.4842,-120.6385),('96128','CA','Standish','Lassen',40.347214,-120.410909),('96129','CA','Beckwourth','Plumas',39.772789,-120.352433),('96130','CA','Susanville','Lassen',40.468405,-120.708349),('96132','CA','Termo','Lassen',40.875735,-120.497247),('96133','CA','Topaz','Mono',38.650947,-119.518709),('96134','CA','Tulelake','Siskiyou',41.880538,-121.409398),('96135','CA','Vinton','Plumas',39.819347,-120.19163),('96136','CA','Wendel','Lassen',40.29218,-120.108321),('96137','CA','Westwood','Lassen',40.286984,-121.050641),('96140','CA','Carnelian Bay','Placer',39.222553,-120.086133),('96141','CA','Homewood','Placer',39.084858,-120.159371),('96142','CA','Tahoma','El Dorado',39.032816,-120.121514),('96143','CA','Kings Beach','Placer',39.242893,-120.025742),('96145','CA','Tahoe City','Placer',39.16775,-120.144777),('96146','CA','Olympic Valley','Placer',39.200705,-120.224581),('96148','CA','Tahoe Vista','Placer',39.24399,-120.055097),('96150','CA','South Lake Tahoe','El Dorado',38.905771,-119.997993),('96151','CA','South Lake Tahoe','El Dorado',38.9333,-119.9833),('96152','CA','South Lake Tahoe','El Dorado',38.9333,-119.9833),('96154','CA','South Lake Tahoe','El Dorado',38.9333,-119.9833),('96155','CA','South Lake Tahoe','El Dorado',39.0166,-120.1229),('96156','CA','South Lake Tahoe','El Dorado',38.9333,-119.9833),('96157','CA','South Lake Tahoe','El Dorado',38.9333,-119.9833),('96158','CA','South Lake Tahoe','El Dorado',38.9333,-119.9833),('96160','CA','Truckee','Nevada',39.328,-120.1822),('96161','CA','Truckee','Nevada',39.330934,-120.20183),('96162','CA','Truckee','Nevada',39.3238,-120.3473),('96201','AP','Apo','',0,0),('96202','AP','Apo','',0,0),('96203','AP','Apo','',0,0),('96204','AP','Apo','',0,0),('96205','AP','Apo','',0,0),('96206','AP','Apo','',0,0),('96207','AP','Apo','',0,0),('96209','AP','Dpo','',0,0),('96212','AP','Apo','',0,0),('96213','AP','Apo','',0,0),('96214','AP','Apo','',0,0),('96215','AP','Apo','',0,0),('96217','AP','Apo','',0,0),('96218','AP','Apo','',0,0),('96219','AP','Apo','',0,0),('96220','AP','Apo','',0,0),('96221','AP','Apo','',0,0),('96224','AP','Apo','',0,0),('96257','AP','Apo','',0,0),('96258','AP','Apo','',0,0),('96259','AP','Apo','',0,0),('96260','AP','Apo','',0,0),('96262','AP','Apo','',0,0),('96264','AP','Apo','',0,0),('96266','AP','Apo','',0,0),('96267','AP','Apo','',0,0),('96269','AP','Fpo','',0,0),('96271','AP','Apo','',0,0),('96275','AP','Apo','',0,0),('96276','AP','Apo','',0,0),('96278','AP','Apo','',0,0),('96283','AP','Apo','',0,0),('96284','AP','Apo','',0,0),('96297','AP','Apo','',0,0),('96303','AP','Dpo','',0,0),('96306','AP','Fpo','',0,0),('96309','AP','Fpo','',0,0),('96310','AP','Fpo','',0,0),('96311','AP','Fpo','',0,0),('96313','AP','Fpo','',0,0),('96319','AP','Apo','',0,0),('96321','AP','Fpo','',0,0),('96322','AP','Fpo','',0,0),('96323','AP','Apo','',0,0),('96326','AP','Apo','',0,0),('96328','AP','Apo','',0,0),('96330','AP','Apo','',0,0),('96336','AP','Apo','',0,0),('96337','AP','Apo','',0,0),('96338','AP','Apo','',0,0),('96339','AP','Fpo','',0,0),('96343','AP','Apo','',0,0),('96346','AP','Fpo','',0,0),('96347','AP','Fpo','',0,0),('96348','AP','Fpo','',0,0),('96349','AP','Fpo','',0,0),('96350','AP','Fpo','',0,0),('96351','AP','Fpo','',0,0),('96362','AP','Fpo','',0,0),('96365','AP','Apo','',0,0),('96367','AP','Apo','',0,0),('96368','AP','Apo','',0,0),('96370','AP','Fpo','',0,0),('96372','AP','Fpo','',0,0),('96373','AP','Fpo','',0,0),('96374','AP','Fpo','',0,0),('96375','AP','Fpo','',0,0),('96376','AP','Apo','',0,0),('96377','AP','Fpo','',0,0),('96378','AP','Apo','',0,0),('96379','AP','Fpo','',0,0),('96384','AP','Apo','',0,0),('96386','AP','Apo','',0,0),('96387','AP','Fpo','',0,0),('96388','AP','Fpo','',0,0),('96401','AP','Apo','',0,0),('96426','AP','Fpo','',0,0),('96427','AP','Fpo','',0,0),('96444','AP','Apo','',0,0),('96447','AP','Apo','',0,0),('96501','AP','Fpo','',0,0),('96502','AP','Fpo','',0,0),('96503','AP','Fpo','',0,0),('96507','AP','Fpo','',0,0),('96510','AP','Fpo','',0,0),('96511','AP','Fpo','',0,0),('96515','AP','Fpo','',0,0),('96516','AP','Fpo','',0,0),('96517','AP','Fpo','',0,0),('96518','AP','Fpo','',0,0),('96520','AP','Fpo','',0,0),('96521','AP','Fpo','',0,0),('96522','AP','Fpo','',0,0),('96530','AP','Apo','',0,0),('96531','AP','Fpo','',0,0),('96532','AP','Dpo','',0,0),('96534','AP','Fpo','',0,0),('96535','AP','Apo','',0,0),('96536','AP','Fpo','',0,0),('96537','AP','Fpo','',0,0),('96538','AP','Fpo','',0,0),('96540','AP','Fpo','',0,0),('96541','AP','Apo','',0,0),('96542','AP','Apo','',0,0),('96543','AP','Apo','',0,0),('96544','AP','Fpo','',0,0),('96546','AP','Apo','',0,0),('96548','AP','Apo','',0,0),('96549','AP','Apo','',0,0),('96550','AP','Apo','',0,0),('96551','AP','Apo','',0,0),('96552','AA','Fpo','',0,0),('96553','AP','Apo','',0,0),('96554','AP','Apo','',0,0),('96555','AP','Apo','',0,0),('96557','AP','Apo','',0,0),('96562','AP','Apo','',0,0),('96577','AP','Apo','',0,0),('96595','AP','Fpo','',0,0),('96598','AP','Fpo','',0,0),('96599','AP','Fpo','',0,0),('96601','AP','Fpo','',0,0),('96602','AP','Fpo','',0,0),('96603','AP','Fpo','',0,0),('96604','AP','Fpo','',0,0),('96605','AP','Fpo','',0,0),('96606','AP','Fpo','',0,0),('96607','AP','Fpo','',0,0),('96608','AP','Fpo','',0,0),('96609','AP','Fpo','',0,0),('96610','AP','Fpo','',0,0),('96611','AP','Fpo','',0,0),('96612','AP','Fpo','',0,0),('96613','AP','Fpo','',0,0),('96614','AP','Fpo','',0,0),('96615','AP','Fpo','',0,0),('96616','AP','Fpo','',0,0),('96617','AP','Fpo','',0,0),('96619','AP','Fpo','',0,0),('96620','AP','Fpo','',0,0),('96621','AP','Fpo','',0,0),('96622','AP','Fpo','',0,0),('96624','AP','Fpo','',0,0),('96628','AP','Fpo','',0,0),('96629','AP','Fpo','',0,0),('96634','AP','Fpo','',0,0),('96643','AP','Fpo','',0,0),('96650','AA','Fpo','',0,0),('96657','AP','Fpo','',0,0),('96660','AP','Fpo','',0,0),('96661','AP','Fpo','',0,0),('96662','AP','Fpo','',0,0),('96663','AP','Fpo','',0,0),('96664','AP','Fpo','',0,0),('96665','AP','Fpo','',0,0),('96666','AP','Fpo','',0,0),('96667','AP','Fpo','',0,0),('96668','AP','Fpo','',0,0),('96669','AP','Fpo','',0,0),('96670','AP','Fpo','',0,0),('96671','AP','Fpo','',0,0),('96672','AP','Fpo','',0,0),('96673','AP','Fpo','',0,0),('96674','AP','Fpo','',0,0),('96675','AP','Fpo','',0,0),('96677','AP','Fpo','',0,0),('96678','AP','Fpo','',0,0),('96679','AP','Fpo','',0,0),('96681','AP','Fpo','',0,0),('96682','AP','Fpo','',0,0),('96683','AP','Fpo','',0,0),('96686','AP','Fpo','',0,0),('96687','AP','Fpo','',0,0),('96698','AP','Fpo','',0,0),('96701','HI','Aiea','Honolulu',21.385262,-157.92475),('96703','HI','Anahola','Kauai',22.146668,-159.315768),('96704','HI','Captain Cook','Hawaii',19.313321,-155.870768),('96705','HI','Eleele','Kauai',21.901908,-159.576445),('96706','HI','Ewa Beach','Honolulu',21.335701,-158.014278),('96707','HI','Kapolei','Honolulu',21.339152,-158.076542),('96708','HI','Haiku','Maui',20.902399,-156.259762),('96709','HI','Kapolei','Honolulu',21.3139,-158.0213),('96710','HI','Hakalau','Hawaii',19.887011,-155.158371),('96712','HI','Haleiwa','Honolulu',21.624715,-158.075907),('96713','HI','Hana','Maui',20.756124,-156.005894),('96714','HI','Hanalei','Kauai',22.205945,-159.525193),('96715','HI','Hanamaulu','Kauai',21.9975,-159.3572),('96716','HI','Hanapepe','Kauai',21.937399,-159.602309),('96717','HI','Hauula','Honolulu',21.595976,-157.900003),('96718','HI','Hawaii National Park','Hawaii',19.435739,-155.266484),('96719','HI','Hawi','Hawaii',20.217022,-155.828883),('96720','HI','Hilo','Hawaii',19.70833,-155.096493),('96721','HI','Hilo','Hawaii',19.6709,-155.3111),('96722','HI','Princeville','Kauai',22.216524,-159.478041),('96725','HI','Holualoa','Hawaii',19.606291,-155.94088),('96726','HI','Honaunau','Hawaii',19.427856,-155.844724),('96727','HI','Honokaa','Hawaii',20.089043,-155.514784),('96728','HI','Honomu','Hawaii',19.857967,-155.12939),('96729','HI','Hoolehua','Maui',21.15988,-157.084749),('96730','HI','Kaaawa','Honolulu',21.550975,-157.84835),('96731','HI','Kahuku','Honolulu',21.678337,-157.954859),('96732','HI','Kahului','Maui',20.880104,-156.468605),('96733','HI','Kahului','Maui',20.8909,-156.4685),('96734','HI','Kailua','Honolulu',21.406908,-157.74376),('96737','HI','Ocean View','Hawaii',19.103564,-155.768033),('96738','HI','Waikoloa','Hawaii',19.924978,-155.799261),('96739','HI','Keauhou','Hawaii',19.5872,-155.9477),('96740','HI','Kailua Kona','Hawaii',19.676139,-155.98231),('96741','HI','Kalaheo','Kauai',21.926219,-159.521853),('96742','HI','Kalaupapa','Kalawao',21.190875,-156.978362),('96743','HI','Kamuela','Hawaii',19.973663,-155.705595),('96744','HI','Kaneohe','Honolulu',21.430774,-157.812046),('96745','HI','Kailua Kona','Hawaii',19.9221,-155.7319),('96746','HI','Kapaa','Kauai',22.086808,-159.343819),('96747','HI','Kaumakani','Kauai',21.922299,-159.620342),('96748','HI','Kaunakakai','Maui',21.110732,-156.953661),('96749','HI','Keaau','Hawaii',19.622631,-155.008739),('96750','HI','Kealakekua','Hawaii',19.509264,-155.917669),('96751','HI','Kealia','Kauai',22.106428,-159.304863),('96752','HI','Kekaha','Kauai',21.972636,-159.720664),('96753','HI','Kihei','Maui',20.738057,-156.446837),('96754','HI','Kilauea','Kauai',22.205318,-159.398529),('96755','HI','Kapaau','Hawaii',20.221494,-155.798869),('96756','HI','Koloa','Kauai',21.905394,-159.461717),('96757','HI','Kualapuu','Maui',21.156025,-157.01514),('96759','HI','Kunia','Honolulu',21.460945,-158.062127),('96760','HI','Kurtistown','Hawaii',19.564292,-155.058196),('96761','HI','Lahaina','Maui',20.891548,-156.659743),('96762','HI','Laie','Honolulu',21.644352,-157.927106),('96763','HI','Lanai City','Maui',20.812148,-156.922002),('96764','HI','Laupahoehoe','Hawaii',19.969062,-155.239827),('96765','HI','Lawai','Kauai',21.922636,-159.496227),('96766','HI','Lihue','Kauai',21.984773,-159.389704),('96767','HI','Lahaina','Maui',20.8783,-156.6825),('96768','HI','Makawao','Maui',20.850903,-156.325538),('96769','HI','Makaweli','Kauai',21.946194,-159.657424),('96770','HI','Maunaloa','Maui',21.136783,-157.211623),('96771','HI','Mountain View','Hawaii',19.524822,-155.121921),('96772','HI','Naalehu','Hawaii',19.091222,-155.600188),('96773','HI','Ninole','Hawaii',19.928536,-155.186432),('96774','HI','Ookala','Hawaii',20.002583,-155.306988),('96776','HI','Paauilo','Hawaii',20.02393,-155.369371),('96777','HI','Pahala','Hawaii',19.234475,-155.484149),('96778','HI','Pahoa','Hawaii',19.491178,-154.923169),('96779','HI','Paia','Maui',20.906109,-156.376706),('96780','HI','Papaaloa','Hawaii',19.968322,-155.21487),('96781','HI','Papaikou','Hawaii',19.795193,-155.117735),('96782','HI','Pearl City','Honolulu',21.401713,-157.966521),('96783','HI','Pepeekeo','Hawaii',19.843069,-155.108903),('96784','HI','Puunene','Maui',20.8636,-156.453),('96785','HI','Volcano','Hawaii',19.432899,-155.263516),('96786','HI','Wahiawa','Honolulu',21.503218,-158.041667),('96788','HI','Pukalani','Maui',20.8366,-156.3366),('96789','HI','Mililani','Honolulu',21.46432,-158.007482),('96790','HI','Kula','Maui',20.724134,-156.338073),('96791','HI','Waialua','Honolulu',21.568896,-158.132011),('96792','HI','Waianae','Honolulu',21.43586,-158.168307),('96793','HI','Wailuku','Maui',20.886942,-156.50664),('96795','HI','Waimanalo','Honolulu',21.337441,-157.702655),('96796','HI','Waimea','Kauai',22.007084,-159.669694),('96797','HI','Waipahu','Honolulu',21.392789,-158.006475),('96799','AS','Pago Pago','American Samoa',-14.2702,170.7003),('96801','HI','Honolulu','Honolulu',21.3095,-157.863),('96802','HI','Honolulu','Honolulu',21.3095,-157.863),('96803','HI','Honolulu','Honolulu',21.3095,-157.863),('96804','HI','Honolulu','Honolulu',21.3095,-157.863),('96805','HI','Honolulu','Honolulu',21.3095,-157.863),('96806','HI','Honolulu','Honolulu',21.3095,-157.863),('96807','HI','Honolulu','Honolulu',21.3095,-157.863),('96808','HI','Honolulu','Honolulu',21.3095,-157.863),('96809','HI','Honolulu','Honolulu',21.3095,-157.863),('96810','HI','Honolulu','Honolulu',21.3095,-157.863),('96811','HI','Honolulu','Honolulu',21.3095,-157.863),('96812','HI','Honolulu','Honolulu',21.3095,-157.863),('96813','HI','Honolulu','Honolulu',21.309577,-157.852433),('96814','HI','Honolulu','Honolulu',21.295688,-157.844824),('96815','HI','Honolulu','Honolulu',21.277365,-157.821821),('96816','HI','Honolulu','Honolulu',21.281015,-157.796663),('96817','HI','Honolulu','Honolulu',21.32726,-157.858964),('96818','HI','Honolulu','Honolulu',21.348991,-157.936512),('96819','HI','Honolulu','Honolulu',21.340587,-157.882055),('96820','HI','Honolulu','Honolulu',21.3069,-157.8583),('96821','HI','Honolulu','Honolulu',21.285368,-157.751927),('96822','HI','Honolulu','Honolulu',21.308154,-157.821937),('96823','HI','Honolulu','Honolulu',21.3072,-157.8465),('96824','HI','Honolulu','Honolulu',21.2808,-157.7552),('96825','HI','Honolulu','Honolulu',21.292852,-157.692266),('96826','HI','Honolulu','Honolulu',21.292309,-157.827062),('96827','HI','Honolulu','Honolulu',21.3172,-157.8643),('96828','HI','Honolulu','Honolulu',21.294,-157.8226),('96830','HI','Honolulu','Honolulu',21.2841,-157.8341),('96835','HI','Honolulu','Honolulu',21.3509,-157.8794),('96836','HI','Honolulu','Honolulu',21.2899,-157.8384),('96837','HI','Honolulu','Honolulu',21.315,-157.8633),('96838','HI','Honolulu','Honolulu',21.3069,-157.8583),('96839','HI','Honolulu','Honolulu',21.3107,-157.812),('96840','HI','Honolulu','Honolulu',21.3095,-157.863),('96841','HI','Honolulu','Honolulu',21.3095,-157.863),('96843','HI','Honolulu','Honolulu',21.3095,-157.863),('96844','HI','Honolulu','Honolulu',21.2981,-157.8189),('96846','HI','Honolulu','Honolulu',21.3095,-157.863),('96847','HI','Honolulu','Honolulu',21.3095,-157.863),('96848','HI','Honolulu','Honolulu',21.3072,-157.8465),('96849','HI','Honolulu','Honolulu',21.3069,-157.8583),('96850','HI','Honolulu','Honolulu',21.3095,-157.863),('96853','HI','Hickam Afb','Honolulu',21.333723,-157.937928),('96854','HI','Wheeler Army Airfield','Honolulu',21.5009,-158.0294),('96857','HI','Schofield Barracks','Honolulu',21.487451,-158.051398),('96858','HI','Fort Shafter','Honolulu',21.3392,-157.8885),('96859','HI','Tripler Medical Center','Honolulu',21.359,-157.8886),('96860','HI','Pearl Harbor','Honolulu',21.354175,-157.940926),('96861','HI','Camp H M Smith','Honolulu',21.386,-157.9078),('96863','HI','M C B H Kaneohe Bay','Honolulu',21.448665,-157.761641),('96898','HI','Wake Island','Honolulu',21.312,-157.8628),('96910','GU','Hagatna','Guam',13.4744,144.7478),('96912','GU','Dededo','Guam',13.5156,144.8364),('96913','GU','Barrigada','Guam',13.462,144.794),('96915','GU','Santa Rita','Guam',13.3862,144.6689),('96916','GU','Merizo','Guam',13.2635,144.6697),('96917','GU','Inarajan','Guam',13.2756,144.7436),('96919','GU','Agana Heights','Guam',13.4627,144.7438),('96921','GU','Barrigada','Guam',13.4615,144.7946),('96923','GU','Mangilao','Guam',13.4391,144.7976),('96928','GU','Agat','Guam',13.3815,144.6544),('96929','GU','Yigo','Guam',13.5346,144.8858),('96931','GU','Tamuning','Guam',13.4936,144.7767),('96932','GU','Hagatna','Guam',13.4751,144.7484),('96939','PW','Palau','Palau',7.3333,-134.4833),('96940','PW','Palau','Palau',17.56284,-93.960732),('96941','FM','Pohnpei','Federated States Of Micr',17.56284,-93.960732),('96942','FM','Chuuk','Federated States Of Micr',17.56284,-93.960732),('96943','FM','Yap','Federated States Of Micr',17.56284,-93.960732),('96944','FM','Kosrae','Federated States Of Micr',17.56284,-93.960732),('96950','MP','Saipan','Northern Mariana Islands',15.182,145.755),('96951','MP','Rota','Northern Mariana Islands',14.17,145.25),('96952','MP','Tinian','Northern Mariana Islands',15.084,145.652),('96960','MH','Majuro','Marshall Islands',7.0833,171.3833),('96970','MH','Ebeye','Marshall Islands',8.7167,167.7333),('97001','OR','Antelope','Wasco',44.889536,-120.64825),('97002','OR','Aurora','Marion',45.240464,-122.793823),('97004','OR','Beavercreek','Clackamas',45.262241,-122.470244),('97005','OR','Beaverton','Washington',45.492235,-122.804428),('97006','OR','Beaverton','Washington',45.517674,-122.863508),('97007','OR','Beaverton','Washington',45.46797,-122.858584),('97008','OR','Beaverton','Washington',45.462372,-122.804313),('97009','OR','Boring','Clackamas',45.421821,-122.348992),('97010','OR','Bridal Veil','Multnomah',45.5785,-122.1196),('97011','OR','Brightwood','Clackamas',45.377774,-122.013097),('97013','OR','Canby','Clackamas',45.250118,-122.682773),('97014','OR','Cascade Locks','Hood River',45.633652,-121.952433),('97015','OR','Clackamas','Clackamas',45.415637,-122.539404),('97016','OR','Clatskanie','Columbia',46.090523,-123.262478),('97017','OR','Colton','Clackamas',45.175127,-122.397966),('97018','OR','Columbia City','Columbia',45.893375,-122.813081),('97019','OR','Corbett','Multnomah',45.505889,-122.224192),('97020','OR','Donald','Marion',45.222831,-122.839669),('97021','OR','Dufur','Wasco',45.398188,-121.14762),('97022','OR','Eagle Creek','Clackamas',45.348571,-122.335895),('97023','OR','Estacada','Clackamas',45.270629,-122.292565),('97024','OR','Fairview','Multnomah',45.543175,-122.443302),('97026','OR','Gervais','Marion',45.105449,-122.915641),('97027','OR','Gladstone','Clackamas',45.38565,-122.592827),('97028','OR','Government Camp','Clackamas',45.291936,-121.738504),('97029','OR','Grass Valley','Sherman',45.308529,-120.799327),('97030','OR','Gresham','Multnomah',45.506863,-122.432674),('97031','OR','Hood River','Hood River',45.667247,-121.538197),('97032','OR','Hubbard','Marion',45.183225,-122.801064),('97033','OR','Kent','Sherman',45.206835,-120.591343),('97034','OR','Lake Oswego','Clackamas',45.410097,-122.679667),('97035','OR','Lake Oswego','Clackamas',45.410359,-122.728546),('97036','OR','Marylhurst','Clackamas',45.3962,-122.6491),('97037','OR','Maupin','Wasco',45.087355,-121.1237),('97038','OR','Molalla','Clackamas',45.106754,-122.565017),('97039','OR','Moro','Sherman',45.479484,-120.654053),('97040','OR','Mosier','Wasco',45.648471,-121.375242),('97041','OR','Mount Hood Parkdale','Hood River',45.48236,-121.594233),('97042','OR','Mulino','Clackamas',45.207523,-122.545575),('97044','OR','Odell','Hood River',45.5607,-121.4682),('97045','OR','Oregon City','Clackamas',45.34026,-122.578499),('97048','OR','Rainier','Columbia',46.065219,-122.964646),('97049','OR','Rhododendron','Clackamas',45.372842,-121.90204),('97050','OR','Rufus','Sherman',45.694617,-120.739912),('97051','OR','Saint Helens','Columbia',45.860956,-122.84422),('97053','OR','Warren','Columbia',45.824373,-122.862997),('97054','OR','Deer Island','Columbia',45.943283,-122.915778),('97055','OR','Sandy','Clackamas',45.392796,-122.225246),('97056','OR','Scappoose','Columbia',45.775045,-122.917856),('97057','OR','Shaniko','Wasco',45.002993,-120.751943),('97058','OR','The Dalles','Wasco',45.591516,-121.192722),('97060','OR','Troutdale','Multnomah',45.529944,-122.389011),('97062','OR','Tualatin','Washington',45.370964,-122.767816),('97063','OR','Tygh Valley','Wasco',45.241543,-121.262727),('97064','OR','Vernonia','Columbia',45.871532,-123.210121),('97065','OR','Wasco','Sherman',45.598715,-120.739407),('97067','OR','Welches','Clackamas',45.340633,-121.974389),('97068','OR','West Linn','Clackamas',45.362283,-122.645924),('97070','OR','Wilsonville','Clackamas',45.306108,-122.773066),('97071','OR','Woodburn','Marion',45.14431,-122.849667),('97075','OR','Beaverton','Washington',45.4861,-122.8004),('97076','OR','Beaverton','Washington',45.4872,-122.8025),('97077','OR','Beaverton','Washington',45.4872,-122.8025),('97078','OR','Beaverton','Washington',45.4872,-122.8025),('97080','OR','Gresham','Multnomah',45.480978,-122.413987),('97086','OR','Happy Valley','Clackamas',45.4449,-122.534901),('97089','OR','Damascus','Clackamas',45.417648,-122.458481),('97101','OR','Amity','Yamhill',45.101513,-123.207285),('97102','OR','Arch Cape','Clatsop',45.803103,-123.959575),('97103','OR','Astoria','Clatsop',46.163522,-123.746403),('97106','OR','Banks','Washington',45.63683,-123.124786),('97107','OR','Bay City','Tillamook',45.54333,-123.87847),('97108','OR','Beaver','Tillamook',45.277803,-123.706477),('97109','OR','Buxton','Washington',45.725131,-123.199103),('97110','OR','Cannon Beach','Clatsop',45.895319,-123.957812),('97111','OR','Carlton','Yamhill',45.284549,-123.195186),('97112','OR','Cloverdale','Tillamook',45.25527,-123.865187),('97113','OR','Cornelius','Washington',45.515126,-123.050887),('97114','OR','Dayton','Yamhill',45.206248,-123.081727),('97115','OR','Dundee','Yamhill',45.272643,-123.018366),('97116','OR','Forest Grove','Washington',45.54078,-123.127998),('97117','OR','Gales Creek','Washington',45.612264,-123.261805),('97118','OR','Garibaldi','Tillamook',45.560451,-123.912394),('97119','OR','Gaston','Washington',45.445587,-123.178015),('97121','OR','Hammond','Clatsop',46.195122,-123.954725),('97122','OR','Hebo','Tillamook',45.183151,-123.81938),('97123','OR','Hillsboro','Washington',45.485409,-122.968162),('97124','OR','Hillsboro','Washington',45.541235,-122.949897),('97125','OR','Manning','Washington',45.663043,-123.216945),('97127','OR','Lafayette','Yamhill',45.245974,-123.111537),('97128','OR','Mcminnville','Yamhill',45.21156,-123.211079),('97130','OR','Manzanita','Tillamook',45.71459,-123.93334),('97131','OR','Nehalem','Tillamook',45.723874,-123.868948),('97132','OR','Newberg','Yamhill',45.310432,-122.971976),('97133','OR','North Plains','Washington',45.640591,-123.010768),('97134','OR','Oceanside','Tillamook',45.46131,-123.969384),('97135','OR','Pacific City','Tillamook',45.206212,-123.963437),('97136','OR','Rockaway Beach','Tillamook',45.613523,-123.935174),('97137','OR','Saint Paul','Marion',45.224795,-122.964789),('97138','OR','Seaside','Clatsop',45.920113,-123.833033),('97140','OR','Sherwood','Washington',45.349221,-122.855273),('97141','OR','Tillamook','Tillamook',45.458008,-123.804963),('97143','OR','Netarts','Tillamook',45.438112,-123.948306),('97144','OR','Timber','Washington',45.746788,-123.303325),('97145','OR','Tolovana Park','Clatsop',45.867506,-123.959308),('97146','OR','Warrenton','Clatsop',46.139202,-123.922003),('97147','OR','Wheeler','Tillamook',45.689909,-123.882519),('97148','OR','Yamhill','Yamhill',45.347154,-123.2436),('97149','OR','Neskowin','Tillamook',45.112668,-123.970865),('97201','OR','Portland','Multnomah',45.509241,-122.685716),('97202','OR','Portland','Multnomah',45.484516,-122.642073),('97203','OR','Portland','Multnomah',45.592572,-122.740755),('97204','OR','Portland','Multnomah',45.518455,-122.674864),('97205','OR','Portland','Multnomah',45.51987,-122.692393),('97206','OR','Portland','Multnomah',45.483453,-122.600857),('97207','OR','Portland','Multnomah',45.5136,-122.6801),('97208','OR','Portland','Multnomah',45.5273,-122.6786),('97209','OR','Portland','Multnomah',45.529685,-122.684893),('97210','OR','Portland','Multnomah',45.539982,-122.713474),('97211','OR','Portland','Multnomah',45.566713,-122.645287),('97212','OR','Portland','Multnomah',45.544391,-122.643688),('97213','OR','Portland','Multnomah',45.537095,-122.600032),('97214','OR','Portland','Multnomah',45.514685,-122.647077),('97215','OR','Portland','Multnomah',45.516375,-122.60004),('97216','OR','Portland','Multnomah',45.515769,-122.559976),('97217','OR','Portland','Multnomah',45.576285,-122.687508),('97218','OR','Portland','Multnomah',45.564306,-122.599572),('97219','OR','Portland','Multnomah',45.456163,-122.706068),('97220','OR','Portland','Multnomah',45.545078,-122.561462),('97221','OR','Portland','Multnomah',45.498261,-122.728853),('97222','OR','Portland','Clackamas',45.442671,-122.618234),('97223','OR','Portland','Washington',45.443521,-122.780041),('97224','OR','Portland','Washington',45.406652,-122.792975),('97225','OR','Portland','Washington',45.501125,-122.76918),('97227','OR','Portland','Multnomah',45.544075,-122.674838),('97228','OR','Portland','Multnomah',45.5275,-122.6764),('97229','OR','Portland','Washington',45.545625,-122.813724),('97230','OR','Portland','Multnomah',45.544216,-122.507019),('97231','OR','Portland','Multnomah',45.659141,-122.818311),('97232','OR','Portland','Multnomah',45.528931,-122.644943),('97233','OR','Portland','Multnomah',45.512976,-122.498135),('97236','OR','Portland','Multnomah',45.492929,-122.50526),('97238','OR','Portland','Multnomah',45.5849,-122.5804),('97239','OR','Portland','Multnomah',45.492278,-122.6857),('97240','OR','Portland','Multnomah',45.522,-122.6741),('97242','OR','Portland','Multnomah',45.5003,-122.6495),('97251','OR','Portland','Multnomah',45.5236,-122.675),('97253','OR','Portland','Multnomah',45.5236,-122.675),('97254','OR','Portland','Multnomah',45.5236,-122.675),('97255','OR','Portland','Multnomah',45.5236,-122.675),('97256','OR','Portland','Multnomah',45.5236,-122.675),('97258','OR','Portland','Multnomah',45.5236,-122.675),('97259','OR','Portland','Multnomah',45.5236,-122.675),('97266','OR','Portland','Multnomah',45.482302,-122.56253),('97267','OR','Portland','Clackamas',45.407979,-122.61618),('97268','OR','Portland','Clackamas',45.4012,-122.6203),('97269','OR','Portland','Clackamas',45.4416,-122.6392),('97271','OR','Portland','Multnomah',45.5236,-122.675),('97272','OR','Portland','Multnomah',45.5236,-122.675),('97280','OR','Portland','Multnomah',45.4685,-122.7164),('97281','OR','Portland','Washington',45.431,-122.769),('97282','OR','Portland','Multnomah',45.474,-122.6488),('97283','OR','Portland','Multnomah',45.5888,-122.7525),('97286','OR','Portland','Multnomah',45.4966,-122.6091),('97290','OR','Portland','Multnomah',45.5761,-122.6436),('97291','OR','Portland','Washington',45.5623,-122.8316),('97292','OR','Portland','Multnomah',45.5164,-122.5359),('97293','OR','Portland','Multnomah',45.5155,-122.6569),('97294','OR','Portland','Multnomah',45.5519,-122.5357),('97296','OR','Portland','Multnomah',45.5359,-122.6559),('97298','OR','Portland','Washington',45.4968,-122.7658),('97299','OR','Portland','Multnomah',45.5402,-122.6106),('97301','OR','Salem','Marion',44.947061,-123.010037),('97302','OR','Salem','Marion',44.909327,-123.049292),('97303','OR','Salem','Marion',45.007487,-123.021448),('97304','OR','Salem','Polk',44.964184,-123.082543),('97305','OR','Salem','Marion',44.991681,-122.961461),('97306','OR','Salem','Marion',44.859155,-123.052785),('97307','OR','Keizer','Marion',45.0041,-123.0242),('97308','OR','Salem','Marion',44.943,-123.0338),('97309','OR','Salem','Marion',44.9253,-123.0091),('97310','OR','Salem','Marion',44.9406,-123.0054),('97311','OR','Salem','Marion',44.943,-123.0338),('97312','OR','Salem','Marion',44.9371,-123.0385),('97313','OR','Salem','Marion',45.0306,-123.0256),('97314','OR','Salem','Marion',45.0306,-123.0256),('97317','OR','Salem','Marion',44.902639,-122.945767),('97321','OR','Albany','Linn',44.643163,-123.109994),('97322','OR','Albany','Linn',44.628586,-123.054542),('97324','OR','Alsea','Benton',44.3517,-123.61089),('97325','OR','Aumsville','Marion',44.832316,-122.859003),('97326','OR','Blodgett','Benton',44.604952,-123.60989),('97327','OR','Brownsville','Linn',44.392423,-122.965396),('97329','OR','Cascadia','Linn',44.401965,-122.385915),('97330','OR','Corvallis','Benton',44.605193,-123.27185),('97331','OR','Corvallis','Benton',44.564045,-123.280583),('97333','OR','Corvallis','Benton',44.526877,-123.278471),('97335','OR','Crabtree','Linn',44.6339,-122.8911),('97336','OR','Crawfordsville','Linn',44.3565,-122.8554),('97338','OR','Dallas','Polk',44.920955,-123.334918),('97339','OR','Corvallis','Benton',44.4592,-123.3134),('97341','OR','Depoe Bay','Lincoln',44.819942,-124.054767),('97342','OR','Detroit','Marion',44.712225,-122.110564),('97343','OR','Eddyville','Lincoln',44.600626,-123.744711),('97344','OR','Falls City','Polk',44.862998,-123.44825),('97345','OR','Foster','Linn',44.417974,-122.587761),('97346','OR','Gates','Marion',44.752618,-122.392956),('97347','OR','Grand Ronde','Polk',45.068714,-123.64326),('97348','OR','Halsey','Linn',44.383294,-123.122261),('97350','OR','Idanha','Marion',44.687322,-122.032196),('97351','OR','Independence','Polk',44.848465,-123.186748),('97352','OR','Jefferson','Marion',44.735755,-123.023813),('97355','OR','Lebanon','Linn',44.526967,-122.857256),('97357','OR','Logsden','Lincoln',44.745473,-123.817219),('97358','OR','Lyons','Linn',44.784153,-122.548628),('97360','OR','Mill City','Linn',44.755795,-122.476755),('97361','OR','Monmouth','Polk',44.780581,-123.270832),('97362','OR','Mount Angel','Marion',45.067286,-122.789544),('97364','OR','Neotsu','Lincoln',44.998869,-123.986368),('97365','OR','Newport','Lincoln',44.651285,-124.043989),('97366','OR','South Beach','Lincoln',44.582035,-124.055655),('97367','OR','Lincoln City','Lincoln',44.949726,-124.000734),('97368','OR','Otis','Lincoln',45.008731,-123.914206),('97369','OR','Otter Rock','Lincoln',44.753011,-124.056475),('97370','OR','Philomath','Benton',44.564615,-123.416418),('97371','OR','Rickreall','Polk',44.976554,-123.211),('97372','OR','Rose Lodge','Lincoln',45.0105,-123.8791),('97373','OR','Saint Benedict','Marion',45.057827,-122.776791),('97374','OR','Scio','Linn',44.697899,-122.813829),('97375','OR','Scotts Mills','Marion',44.99619,-122.624192),('97376','OR','Seal Rock','Lincoln',44.507047,-124.017808),('97377','OR','Shedd','Linn',44.469654,-123.112514),('97378','OR','Sheridan','Yamhill',45.081844,-123.405353),('97380','OR','Siletz','Lincoln',44.752954,-123.93589),('97381','OR','Silverton','Marion',44.998645,-122.774278),('97383','OR','Stayton','Marion',44.79851,-122.75982),('97384','OR','Mehama','Marion',44.7902,-122.618),('97385','OR','Sublimity','Marion',44.852534,-122.749427),('97386','OR','Sweet Home','Linn',44.38853,-122.726521),('97388','OR','Gleneden Beach','Lincoln',44.88761,-124.030509),('97389','OR','Tangent','Linn',44.542193,-123.101528),('97390','OR','Tidewater','Lincoln',44.315814,-123.854235),('97391','OR','Toledo','Lincoln',44.627194,-123.914553),('97392','OR','Turner','Marion',44.810321,-122.946972),('97394','OR','Waldport','Lincoln',44.423413,-124.044395),('97396','OR','Willamina','Yamhill',45.098085,-123.506964),('97401','OR','Eugene','Lane',44.05731,-123.08591),('97402','OR','Eugene','Lane',44.062552,-123.168482),('97403','OR','Eugene','Lane',44.038865,-123.054645),('97404','OR','Eugene','Lane',44.10126,-123.136141),('97405','OR','Eugene','Lane',44.003162,-123.120639),('97406','OR','Agness','Curry',42.590606,-124.062608),('97407','OR','Allegany','Coos',43.4261,-124.0311),('97408','OR','Eugene','Lane',44.124126,-123.064094),('97409','OR','Alvadore','Lane',44.1269,-123.2633),('97410','OR','Azalea','Douglas',42.794513,-123.165084),('97411','OR','Bandon','Coos',43.099589,-124.39323),('97412','OR','Blachly','Lane',44.2054,-123.538316),('97413','OR','Blue River','Lane',44.14886,-122.147012),('97414','OR','Broadbent','Coos',42.977763,-124.165524),('97415','OR','Brookings','Curry',42.077864,-124.25777),('97416','OR','Camas Valley','Douglas',43.041761,-123.683142),('97417','OR','Canyonville','Douglas',42.937691,-123.261195),('97419','OR','Cheshire','Lane',44.180931,-123.385962),('97420','OR','Coos Bay','Coos',43.351441,-124.215844),('97423','OR','Coquille','Coos',43.182793,-124.182019),('97424','OR','Cottage Grove','Lane',43.773374,-123.076639),('97425','OR','Crescent Lake','Klamath',43.472276,-121.927689),('97426','OR','Creswell','Lane',43.910207,-123.034861),('97427','OR','Culp Creek','Lane',43.685176,-122.798271),('97428','OR','Curtin','Douglas',43.745797,-123.181912),('97429','OR','Days Creek','Douglas',42.96654,-123.107507),('97430','OR','Deadwood','Lane',44.16872,-123.703765),('97431','OR','Dexter','Lane',43.900489,-122.823846),('97432','OR','Dillard','Douglas',43.103,-123.4266),('97434','OR','Dorena','Lane',43.6998,-122.821103),('97435','OR','Drain','Douglas',43.682896,-123.313028),('97436','OR','Elkton','Douglas',43.624564,-123.578642),('97437','OR','Elmira','Lane',44.099083,-123.38707),('97438','OR','Fall Creek','Lane',43.955418,-122.735696),('97439','OR','Florence','Lane',44.0103,-124.0858),('97440','OR','Eugene','Lane',44.0541,-123.092),('97441','OR','Gardiner','Douglas',43.753311,-124.135496),('97442','OR','Glendale','Douglas',42.754734,-123.404107),('97443','OR','Glide','Douglas',43.266528,-123.048675),('97444','OR','Gold Beach','Curry',42.430881,-124.384539),('97446','OR','Harrisburg','Linn',44.269012,-123.118257),('97447','OR','Idleyld Park','Douglas',43.296795,-122.593048),('97448','OR','Junction City','Lane',44.204716,-123.246056),('97449','OR','Lakeside','Coos',43.577633,-124.153725),('97450','OR','Langlois','Curry',42.922496,-124.427918),('97451','OR','Lorane','Lane',43.798999,-123.249732),('97452','OR','Lowell','Lane',43.891077,-122.738701),('97453','OR','Mapleton','Lane',43.983446,-123.887463),('97454','OR','Marcola','Lane',44.220593,-122.842136),('97455','OR','Pleasant Hill','Lane',43.975904,-122.913868),('97456','OR','Monroe','Benton',44.332159,-123.346656),('97457','OR','Myrtle Creek','Douglas',43.037691,-123.265551),('97458','OR','Myrtle Point','Coos',43.075235,-124.05649),('97459','OR','North Bend','Coos',43.436039,-124.208793),('97461','OR','Noti','Lane',44.090369,-123.467771),('97462','OR','Oakland','Douglas',43.474586,-123.36863),('97463','OR','Oakridge','Lane',43.747305,-122.457757),('97464','OR','Ophir','Curry',42.5014,-124.4132),('97465','OR','Port Orford','Curry',42.740754,-124.464043),('97466','OR','Powers','Coos',42.877696,-124.067401),('97467','OR','Reedsport','Douglas',43.696346,-124.034392),('97469','OR','Riddle','Douglas',42.934516,-123.380689),('97470','OR','Roseburg','Douglas',43.230515,-123.295268),('97471','OR','Roseburg','Douglas',43.227355,-123.419408),('97472','OR','Saginaw','Lane',43.796,-123.0619),('97473','OR','Scottsburg','Douglas',43.652561,-123.829998),('97476','OR','Sixes','Curry',42.815513,-124.446001),('97477','OR','Springfield','Lane',44.061144,-123.016788),('97478','OR','Springfield','Lane',44.063851,-122.896052),('97479','OR','Sutherlin','Douglas',43.395469,-123.282863),('97480','OR','Swisshome','Lane',44.10844,-123.795076),('97481','OR','Tenmile','Douglas',43.104483,-123.553198),('97482','OR','Thurston','Lane',44.0533,-122.9152),('97484','OR','Tiller','Douglas',42.94563,-122.86255),('97486','OR','Umpqua','Douglas',43.389756,-123.528875),('97487','OR','Veneta','Lane',44.017806,-123.384679),('97488','OR','Vida','Lane',44.128948,-122.476946),('97489','OR','Walterville','Lane',44.133207,-122.635409),('97490','OR','Walton','Lane',44.006974,-123.606182),('97491','OR','Wedderburn','Curry',42.4297,-124.4138),('97492','OR','Westfir','Lane',43.756843,-122.503935),('97493','OR','Westlake','Lane',43.89697,-124.040827),('97494','OR','Wilbur','Douglas',43.3211,-123.3394),('97495','OR','Winchester','Douglas',43.295293,-123.314971),('97496','OR','Winston','Douglas',43.094653,-123.436196),('97497','OR','Wolf Creek','Josephine',42.671573,-123.38086),('97498','OR','Yachats','Lincoln',44.298436,-124.053217),('97499','OR','Yoncalla','Douglas',43.600957,-123.246887),('97501','OR','Medford','Jackson',42.313339,-122.883928),('97502','OR','Central Point','Jackson',42.392174,-122.923992),('97503','OR','White City','Jackson',42.492778,-122.88207),('97504','OR','Medford','Jackson',42.337138,-122.837139),('97520','OR','Ashland','Jackson',42.172205,-122.6419),('97522','OR','Butte Falls','Jackson',42.574821,-122.530553),('97523','OR','Cave Junction','Josephine',42.13683,-123.596991),('97524','OR','Eagle Point','Jackson',42.477518,-122.751209),('97525','OR','Gold Hill','Jackson',42.436065,-123.074853),('97526','OR','Grants Pass','Josephine',42.465832,-123.330198),('97527','OR','Grants Pass','Josephine',42.399549,-123.352518),('97528','OR','Grants Pass','Josephine',42.5805,-123.5723),('97530','OR','Jacksonville','Jackson',42.1861,-123.045841),('97531','OR','Kerby','Josephine',42.199839,-123.645664),('97532','OR','Merlin','Josephine',42.544896,-123.495055),('97533','OR','Murphy','Josephine',42.3477,-123.3322),('97534','OR','O Brien','Josephine',42.056871,-123.739405),('97535','OR','Phoenix','Jackson',42.273855,-122.816319),('97536','OR','Prospect','Jackson',42.781908,-122.494698),('97537','OR','Rogue River','Jackson',42.509622,-123.139555),('97538','OR','Selma','Josephine',42.266465,-123.561164),('97539','OR','Shady Cove','Jackson',42.616984,-122.814044),('97540','OR','Talent','Jackson',42.235589,-122.790576),('97541','OR','Trail','Jackson',42.716272,-122.756122),('97543','OR','Wilderville','Josephine',42.361832,-123.542611),('97544','OR','Williams','Josephine',42.175092,-123.277913),('97601','OR','Klamath Falls','Klamath',42.270311,-121.872076),('97602','OR','Klamath Falls','Klamath',42.1134,-121.6954),('97603','OR','Klamath Falls','Klamath',42.154399,-121.7154),('97604','OR','Crater Lake','Klamath',42.920354,-122.162621),('97620','OR','Adel','Lake',42.198742,-119.855122),('97621','OR','Beatty','Klamath',42.455401,-121.2659),('97622','OR','Bly','Klamath',42.444907,-121.038101),('97623','OR','Bonanza','Klamath',42.207862,-121.35725),('97624','OR','Chiloquin','Klamath',42.590029,-121.816302),('97625','OR','Dairy','Klamath',42.285006,-121.562989),('97626','OR','Fort Klamath','Klamath',42.688266,-122.021852),('97627','OR','Keno','Klamath',42.134125,-121.984705),('97630','OR','Lakeview','Lake',42.189904,-120.444384),('97632','OR','Malin','Klamath',42.022184,-121.417152),('97633','OR','Merrill','Klamath',42.025815,-121.574543),('97634','OR','Midland','Klamath',42.130884,-121.817796),('97635','CA','New Pine Creek','Modoc',41.950945,-120.313392),('97636','OR','Paisley','Lake',42.655119,-120.538955),('97637','OR','Plush','Lake',42.452847,-119.914698),('97638','OR','Silver Lake','Lake',43.149777,-120.97663),('97639','OR','Sprague River','Klamath',42.45366,-121.468473),('97640','OR','Summer Lake','Lake',42.889819,-120.793622),('97641','OR','Christmas Valley','Lake',43.289839,-120.608194),('97701','OR','Bend','Deschutes',44.078309,-121.291623),('97702','OR','Bend','Deschutes',44.025067,-121.308701),('97707','OR','Bend','Deschutes',43.85485,-121.456943),('97708','OR','Bend','Deschutes',44.0722,-121.2999),('97709','OR','Bend','Deschutes',44.1402,-121.2983),('97710','OR','Fields','Harney',42.225844,-118.418762),('97711','OR','Ashwood','Jefferson',44.707176,-120.667174),('97712','OR','Brothers','Deschutes',43.805008,-120.469855),('97720','OR','Burns','Harney',43.62214,-118.939975),('97721','OR','Princeton','Harney',43.071627,-118.604702),('97722','OR','Diamond','Harney',42.98891,-118.721208),('97730','OR','Camp Sherman','Jefferson',44.47803,-121.652816),('97731','OR','Chemult','Klamath',43.146568,-121.817573),('97732','OR','Crane','Harney',43.412436,-118.495255),('97733','OR','Crescent','Klamath',43.433252,-121.880161),('97734','OR','Culver','Jefferson',44.514007,-121.261106),('97735','OR','Fort Rock','Lake',43.377779,-121.014028),('97736','OR','Frenchglen','Harney',42.764336,-118.977147),('97737','OR','Gilchrist','Klamath',43.515888,-121.661337),('97738','OR','Hines','Harney',43.558509,-119.091897),('97739','OR','La Pine','Deschutes',43.669009,-121.53553),('97741','OR','Madras','Jefferson',44.636804,-121.105426),('97750','OR','Mitchell','Wheeler',44.651651,-120.154671),('97751','OR','Paulina','Crook',44.118008,-119.818332),('97752','OR','Post','Crook',44.121979,-120.271257),('97753','OR','Powell Butte','Crook',44.21565,-121.026757),('97754','OR','Prineville','Crook',44.238118,-120.757117),('97756','OR','Redmond','Deschutes',44.272248,-121.194918),('97758','OR','Riley','Harney',43.486838,-119.697124),('97759','OR','Sisters','Deschutes',44.331695,-121.646225),('97760','OR','Terrebonne','Jefferson',44.392495,-121.214302),('97761','OR','Warm Springs','Jefferson',44.80392,-121.305556),('97801','OR','Pendleton','Umatilla',45.656364,-118.787292),('97810','OR','Adams','Umatilla',45.733209,-118.495986),('97812','OR','Arlington','Gilliam',45.60274,-120.242003),('97813','OR','Athena','Umatilla',45.821783,-118.49659),('97814','OR','Baker City','Baker',44.81708,-117.783394),('97817','OR','Bates','Grant',44.675817,-118.661679),('97818','OR','Boardman','Morrow',45.812526,-119.777549),('97819','OR','Bridgeport','Baker',44.479645,-117.748324),('97820','OR','Canyon City','Grant',44.225676,-119.124297),('97823','OR','Condon','Gilliam',45.22903,-120.15801),('97824','OR','Cove','Union',45.348919,-117.808133),('97825','OR','Dayville','Grant',44.378696,-119.539705),('97826','OR','Echo','Umatilla',45.681923,-119.231961),('97827','OR','Elgin','Union',45.565241,-117.875352),('97828','OR','Enterprise','Wallowa',45.624102,-117.261581),('97830','OR','Fossil','Wheeler',44.975717,-120.147903),('97833','OR','Haines','Baker',44.929175,-117.98401),('97834','OR','Halfway','Baker',44.947612,-117.183498),('97835','OR','Helix','Umatilla',45.906633,-118.747387),('97836','OR','Heppner','Morrow',45.236377,-119.503827),('97837','OR','Hereford','Baker',44.49194,-117.976969),('97838','OR','Hermiston','Umatilla',45.84361,-119.296532),('97839','OR','Lexington','Morrow',45.553643,-119.621069),('97840','OR','Oxbow','Baker',44.972912,-116.858913),('97841','OR','Imbler','Union',45.457592,-117.936271),('97842','OR','Imnaha','Wallowa',45.317451,-116.882735),('97843','OR','Ione','Morrow',45.553903,-119.920006),('97844','OR','Irrigon','Morrow',45.886392,-119.516938),('97845','OR','John Day','Grant',44.410231,-118.942585),('97846','OR','Joseph','Wallowa',45.411816,-117.103576),('97848','OR','Kimberly','Grant',44.669248,-119.561023),('97850','OR','La Grande','Union',45.32033,-118.082178),('97856','OR','Long Creek','Grant',44.815063,-119.123595),('97857','OR','Lostine','Wallowa',45.475139,-117.465433),('97859','OR','Meacham','Umatilla',45.520698,-118.439198),('97861','OR','Mikkalo','Gilliam',45.6107,-120.204),('97862','OR','Milton Freewater','Umatilla',45.945222,-118.352814),('97864','OR','Monument','Grant',44.896061,-119.482545),('97865','OR','Mount Vernon','Grant',44.428183,-119.167106),('97867','OR','North Powder','Union',45.044438,-117.998291),('97868','OR','Pilot Rock','Umatilla',45.424775,-118.83661),('97869','OR','Prairie City','Grant',44.44863,-118.648092),('97870','OR','Richland','Baker',44.787315,-117.192948),('97873','OR','Seneca','Grant',44.137742,-118.97667),('97874','OR','Spray','Wheeler',44.778741,-119.86162),('97875','OR','Stanfield','Umatilla',45.796674,-119.203272),('97876','OR','Summerville','Union',45.509649,-118.027276),('97877','OR','Sumpter','Baker',44.774063,-118.375968),('97880','OR','Ukiah','Umatilla',45.069576,-118.86295),('97882','OR','Umatilla','Umatilla',45.917258,-119.328198),('97883','OR','Union','Union',45.164808,-117.763715),('97884','OR','Unity','Baker',44.451724,-118.199247),('97885','OR','Wallowa','Wallowa',45.62337,-117.533505),('97886','OR','Weston','Umatilla',45.793401,-118.216217),('97901','OR','Adrian','Malheur',43.672692,-117.075454),('97902','OR','Arock','Malheur',42.9153,-117.525),('97903','OR','Brogan','Malheur',44.288413,-117.568564),('97904','OR','Drewsey','Harney',43.86913,-118.512855),('97905','OR','Durkee','Baker',44.569707,-117.446398),('97906','OR','Harper','Malheur',43.606887,-117.783529),('97907','OR','Huntington','Baker',44.389668,-117.316728),('97908','OR','Ironside','Malheur',44.305441,-117.915579),('97909','OR','Jamieson','Malheur',44.204466,-117.451432),('97910','OR','Jordan Valley','Malheur',42.802714,-117.448364),('97911','OR','Juntura','Malheur',43.786427,-118.080495),('97913','OR','Nyssa','Malheur',43.811273,-117.113367),('97914','OR','Ontario','Malheur',44.054325,-117.001864),('97917','OR','Riverside','Malheur',43.4104,-117.9018),('97918','OR','Vale','Malheur',44.019369,-117.287506),('97920','OR','Westfall','Malheur',44.075989,-117.831087),('98001','WA','Auburn','King',47.30641,-122.264434),('98002','WA','Auburn','King',47.305265,-122.216849),('98003','WA','Federal Way','King',47.311137,-122.312623),('98004','WA','Bellevue','King',47.615635,-122.204344),('98005','WA','Bellevue','King',47.608571,-122.168466),('98006','WA','Bellevue','King',47.561705,-122.154018),('98007','WA','Bellevue','King',47.610351,-122.142292),('98008','WA','Bellevue','King',47.612207,-122.11591),('98009','WA','Bellevue','King',47.6105,-122.1994),('98010','WA','Black Diamond','King',47.315979,-122.005358),('98011','WA','Bothell','King',47.751401,-122.201694),('98012','WA','Bothell','Snohomish',47.844361,-122.204972),('98013','WA','Burton','King',47.3891,-122.4594),('98014','WA','Carnation','King',47.650739,-121.901579),('98015','WA','Bellevue','King',47.6122,-122.1862),('98019','WA','Duvall','King',47.737925,-121.945281),('98020','WA','Edmonds','Snohomish',47.802374,-122.371548),('98021','WA','Bothell','Snohomish',47.792005,-122.216094),('98022','WA','Enumclaw','King',47.180886,-121.888833),('98023','WA','Federal Way','King',47.30861,-122.36229),('98024','WA','Fall City','King',47.570237,-121.899871),('98025','WA','Hobart','King',47.430704,-121.884969),('98026','WA','Edmonds','Snohomish',47.823268,-122.336943),('98027','WA','Issaquah','King',47.520272,-122.024743),('98028','WA','Kenmore','King',47.755665,-122.248061),('98029','WA','Issaquah','King',47.557623,-122.01152),('98030','WA','Kent','King',47.370313,-122.199369),('98031','WA','Kent','King',47.404532,-122.192517),('98032','WA','Kent','King',47.388373,-122.259),('98033','WA','Kirkland','King',47.677861,-122.19379),('98034','WA','Kirkland','King',47.716743,-122.199813),('98035','WA','Kent','King',47.3808,-122.2346),('98036','WA','Lynnwood','Snohomish',47.812332,-122.282484),('98037','WA','Lynnwood','Snohomish',47.837732,-122.290681),('98038','WA','Maple Valley','King',47.389649,-122.01787),('98039','WA','Medina','King',47.626095,-122.232702),('98040','WA','Mercer Island','King',47.565819,-122.229838),('98041','WA','Bothell','King',47.7606,-122.1997),('98042','WA','Kent','King',47.367737,-122.117029),('98043','WA','Mountlake Terrace','Snohomish',47.791131,-122.30653),('98045','WA','North Bend','King',47.471267,-121.733288),('98046','WA','Lynnwood','Snohomish',47.8104,-122.3242),('98047','WA','Pacific','King',47.262577,-122.248752),('98050','WA','Preston','King',47.545269,-121.939288),('98051','WA','Ravensdale','King',47.337882,-121.905301),('98052','WA','Redmond','King',47.677595,-122.12359),('98053','WA','Redmond','King',47.675841,-122.03227),('98054','WA','Redondo','King',47.3486,-122.3222),('98055','WA','Renton','King',47.451573,-122.201455),('98056','WA','Renton','King',47.509686,-122.184691),('98057','WA','Renton','King',47.478735,-122.212017),('98058','WA','Renton','King',47.446512,-122.140431),('98059','WA','Renton','King',47.49295,-122.136432),('98061','WA','Rollingbay','Kitsap',47.6647,-122.5088),('98062','WA','Seahurst','King',47.4694,-122.3608),('98063','WA','Federal Way','King',47.308,-122.3117),('98064','WA','Kent','King',47.3873,-122.1983),('98065','WA','Snoqualmie','King',47.544887,-121.821657),('98068','WA','Snoqualmie Pass','Kittitas',47.410336,-121.44498),('98070','WA','Vashon','King',47.425646,-122.465886),('98071','WA','Auburn','King',47.3106,-122.2286),('98072','WA','Woodinville','King',47.753926,-122.138593),('98073','WA','Redmond','King',47.6783,-122.1243),('98074','WA','Sammamish','King',47.623208,-122.038291),('98075','WA','Sammamish','King',47.585658,-122.032059),('98077','WA','Woodinville','King',47.74587,-122.062459),('98082','WA','Mill Cre','Snohomish',47.8563,-122.2152),('98083','WA','Kirkland','King',47.6816,-122.2075),('98087','WA','Lynnwood','Snohomish',47.862995,-122.269098),('98089','WA','Kent','King',47.3811,-122.2336),('98092','WA','Auburn','King',47.290338,-122.162037),('98093','WA','Federal Way','King',47.3225,-122.3113),('98101','WA','Seattle','King',47.610412,-122.334567),('98102','WA','Seattle','King',47.633547,-122.321926),('98103','WA','Seattle','King',47.672202,-122.345375),('98104','WA','Seattle','King',47.602394,-122.32877),('98105','WA','Seattle','King',47.662297,-122.300399),('98106','WA','Seattle','King',47.537344,-122.356117),('98107','WA','Seattle','King',47.667525,-122.374946),('98108','WA','Seattle','King',47.543767,-122.314574),('98109','WA','Seattle','King',47.630583,-122.345596),('98110','WA','Bainbridge Island','Kitsap',47.644308,-122.527669),('98111','WA','Seattle','King',47.609,-122.3351),('98112','WA','Seattle','King',47.631601,-122.296721),('98113','WA','Seattle','Kitsap',47.6064,-122.3308),('98114','WA','Seattle','King',47.6036,-122.3258),('98115','WA','Seattle','King',47.684862,-122.298373),('98116','WA','Seattle','King',47.574785,-122.394048),('98117','WA','Seattle','King',47.687793,-122.379484),('98118','WA','Seattle','King',47.541571,-122.275917),('98119','WA','Seattle','King',47.638675,-122.367974),('98121','WA','Seattle','King',47.615431,-122.34702),('98122','WA','Seattle','King',47.60952,-122.30324),('98124','WA','Seattle','King',47.6063,-122.3308),('98125','WA','Seattle','King',47.716611,-122.303166),('98126','WA','Seattle','King',47.549221,-122.374341),('98127','WA','Seattle','Kitsap',47.6064,-122.3308),('98129','WA','Seattle','King',47.6063,-122.3308),('98131','WA','Seattle','King',47.6063,-122.3308),('98132','WA','Seattle','King',47.6063,-122.3308),('98133','WA','Seattle','King',47.736605,-122.343736),('98134','WA','Seattle','King',47.578768,-122.334666),('98136','WA','Seattle','King',47.537068,-122.389185),('98138','WA','Seattle','King',47.4572,-122.2529),('98139','WA','Seattle','Kitsap',47.6064,-122.3308),('98141','WA','Seattle','Kitsap',47.6064,-122.3308),('98144','WA','Seattle','King',47.585896,-122.299666),('98145','WA','Seattle','King',47.6591,-122.3115),('98146','WA','Seattle','King',47.501835,-122.356951),('98148','WA','Seattle','King',47.443316,-122.325018),('98151','WA','Seattle','King',47.6063,-122.3308),('98154','WA','Seattle','King',47.60632,-122.333579),('98155','WA','Seattle','King',47.754413,-122.300477),('98158','WA','Seattle','King',47.4491,-122.3033),('98160','WA','Seattle','King',47.7654,-122.3614),('98161','WA','Seattle','King',47.609,-122.3351),('98164','WA','Seattle','King',47.605962,-122.332029),('98165','WA','Seattle','Kitsap',47.6064,-122.3308),('98166','WA','Seattle','King',47.458807,-122.348829),('98168','WA','Seattle','King',47.489587,-122.302768),('98170','WA','Seattle','King',47.6064,-122.3308),('98171','WA','Seattle','King',47.609,-122.3351),('98174','WA','Seattle','King',47.604569,-122.33536),('98175','WA','Seattle','Kitsap',47.6064,-122.3308),('98177','WA','Seattle','King',47.742088,-122.371177),('98178','WA','Seattle','King',47.497884,-122.246673),('98181','WA','Seattle','King',47.6063,-122.3308),('98184','WA','Seattle','King',47.6063,-122.3308),('98185','WA','Seattle','King',47.6641,-122.2941),('98188','WA','Seattle','King',47.448905,-122.274236),('98189','WA','Seattle','King',47.61,-122.342),('98190','WA','Seattle','King',47.6064,-122.3308),('98191','WA','Seattle','King',47.6063,-122.3308),('98194','WA','Seattle','Kitsap',47.6064,-122.3308),('98195','WA','Seattle','King',47.650452,-122.309251),('98198','WA','Seattle','King',47.395772,-122.315962),('98199','WA','Seattle','King',47.647735,-122.39958),('98201','WA','Everett','Snohomish',47.987825,-122.204888),('98203','WA','Everett','Snohomish',47.944668,-122.220524),('98204','WA','Everett','Snohomish',47.899367,-122.252897),('98205','WA','Everett','Snohomish',48.000424,-122.144968),('98206','WA','Everett','Snohomish',47.9763,-122.2088),('98207','WA','Everett','Snohomish',47.987043,-122.2244),('98208','WA','Everett','Snohomish',47.895465,-122.196664),('98213','WA','Everett','Snohomish',47.9792,-122.2008),('98220','WA','Acme','Whatcom',48.681419,-122.197586),('98221','WA','Anacortes','Skagit',48.491293,-122.627681),('98222','WA','Blakely Island','San Juan',48.558717,-122.796665),('98223','WA','Arlington','Snohomish',48.197796,-122.068024),('98224','WA','Baring','King',47.70247,-121.496081),('98225','WA','Bellingham','Whatcom',48.750955,-122.488669),('98226','WA','Bellingham','Whatcom',48.794557,-122.466774),('98227','WA','Bellingham','Whatcom',48.7543,-122.4795),('98228','WA','Bellingham','Whatcom',48.7727,-122.4557),('98229','WA','Bellingham','Whatcom',48.725634,-122.424548),('98230','WA','Blaine','Whatcom',48.954764,-122.737977),('98231','WA','Blaine','Whatcom',48.9934,-122.7448),('98232','WA','Bow','Skagit',48.565027,-122.424547),('98233','WA','Burlington','Skagit',48.489524,-122.334513),('98235','WA','Clearlake','Skagit',48.463908,-122.233354),('98236','WA','Clinton','Island',47.961677,-122.401167),('98237','WA','Concrete','Skagit',48.592095,-121.710726),('98238','WA','Conway','Skagit',48.340858,-122.343295),('98239','WA','Coupeville','Island',48.206964,-122.673643),('98240','WA','Custer','Whatcom',48.933479,-122.640693),('98241','WA','Darrington','Snohomish',48.216423,-121.553811),('98243','WA','Deer Harbor','San Juan',48.613869,-123.006955),('98244','WA','Deming','Whatcom',48.850646,-122.069839),('98245','WA','Eastsound','San Juan',48.691457,-122.901696),('98247','WA','Everson','Whatcom',48.900045,-122.320804),('98248','WA','Ferndale','Whatcom',48.855884,-122.6064),('98249','WA','Freeland','Island',48.017944,-122.544032),('98250','WA','Friday Harbor','San Juan',48.571344,-123.076172),('98251','WA','Gold Bar','Snohomish',47.852687,-121.607762),('98252','WA','Granite Falls','Snohomish',48.109622,-121.861041),('98253','WA','Greenbank','Island',48.09353,-122.570212),('98255','WA','Hamilton','Skagit',48.522474,-121.98989),('98256','WA','Index','Snohomish',47.832023,-121.51322),('98257','WA','La Conner','Skagit',48.406025,-122.512147),('98258','WA','Lake Stevens','Snohomish',48.020196,-122.080452),('98259','WA','North Lakewood','Snohomish',48.1522,-122.2061),('98260','WA','Langley','Island',48.033141,-122.440068),('98261','WA','Lopez Island','San Juan',48.482492,-122.883959),('98262','WA','Lummi Island','Whatcom',48.687123,-122.646825),('98263','WA','Lyman','Skagit',48.523789,-122.065596),('98264','WA','Lynden','Whatcom',48.9436,-122.455934),('98266','WA','Maple Falls','Whatcom',48.940666,-122.118177),('98267','WA','Marblemount','Skagit',48.514452,-121.367436),('98270','WA','Marysville','Snohomish',48.059589,-122.154829),('98271','WA','Marysville','Snohomish',48.095445,-122.223394),('98272','WA','Monroe','Snohomish',47.862426,-121.94426),('98273','WA','Mount Vernon','Skagit',48.416343,-122.352553),('98274','WA','Mount Vernon','Skagit',48.379193,-122.250617),('98275','WA','Mukilteo','Snohomish',47.912992,-122.302205),('98276','WA','Nooksack','Whatcom',48.926743,-122.325315),('98277','WA','Oak Harbor','Island',48.304447,-122.647496),('98278','WA','Oak Harbor','Island',48.339579,-122.677418),('98279','WA','Olga','San Juan',48.6192,-122.811214),('98280','WA','Orcas','San Juan',48.602894,-122.91627),('98281','WA','Point Roberts','Whatcom',48.986733,-123.048892),('98282','WA','Camano Island','Island',48.192332,-122.483837),('98283','WA','Rockport','Skagit',48.69084,-121.240283),('98284','WA','Sedro Woolley','Skagit',48.535416,-122.187783),('98286','WA','Shaw Island','San Juan',48.56818,-122.957821),('98287','WA','Silvana','Snohomish',48.2025,-122.2525),('98288','WA','Skykomish','King',47.68302,-121.264073),('98290','WA','Snohomish','Snohomish',47.948496,-122.029064),('98291','WA','Snohomish','Snohomish',47.913,-122.0969),('98292','WA','Stanwood','Snohomish',48.228488,-122.323323),('98293','WA','Startup','Snohomish',47.868,-121.7391),('98294','WA','Sultan','Snohomish',47.872898,-121.789788),('98295','WA','Sumas','Whatcom',48.989748,-122.254882),('98296','WA','Snohomish','Snohomish',47.852188,-122.125275),('98297','WA','Waldron','San Juan',48.703682,-123.02657),('98303','WA','Anderson Island','Pierce',47.160945,-122.695947),('98304','WA','Ashford','Pierce',46.828495,-121.911277),('98305','WA','Beaver','Clallam',48.062509,-124.379136),('98310','WA','Bremerton','Kitsap',47.586393,-122.622716),('98311','WA','Bremerton','Kitsap',47.6293,-122.635688),('98312','WA','Bremerton','Kitsap',47.565189,-122.70827),('98314','WA','Bremerton','Kitsap',47.559926,-122.642097),('98315','WA','Silverdale','Kitsap',47.719599,-122.716539),('98320','WA','Brinnon','Jefferson',47.696899,-122.929626),('98321','WA','Buckley','Pierce',47.155439,-122.052328),('98322','WA','Burley','Kitsap',47.418,-122.6297),('98323','WA','Carbonado','Pierce',46.994676,-121.925675),('98324','WA','Carlsborg','Clallam',48.0908,-123.1708),('98325','WA','Chimacum','Jefferson',47.983631,-122.783471),('98326','WA','Clallam Bay','Clallam',48.176776,-124.37812),('98327','WA','Dupont','Pierce',47.095531,-122.65439),('98328','WA','Eatonville','Pierce',46.876868,-122.274818),('98329','WA','Gig Harbor','Pierce',47.377951,-122.721272),('98330','WA','Elbe','Pierce',46.762778,-122.169912),('98331','WA','Forks','Clallam',47.81367,-124.248332),('98332','WA','Gig Harbor','Pierce',47.361992,-122.604675),('98333','WA','Fox Island','Pierce',47.252115,-122.628574),('98335','WA','Gig Harbor','Pierce',47.301936,-122.610049),('98336','WA','Glenoma','Lewis',46.557385,-122.142874),('98337','WA','Bremerton','Kitsap',47.569225,-122.634926),('98338','WA','Graham','Pierce',47.030284,-122.291623),('98339','WA','Port Hadlock','Jefferson',48.034911,-122.763157),('98340','WA','Hansville','Kitsap',47.909,-122.575571),('98342','WA','Indianola','Kitsap',47.749157,-122.526813),('98343','WA','Joyce','Clallam',48.1366,-123.7327),('98344','WA','Kapowsin','Pierce',46.9858,-122.2244),('98345','WA','Keyport','Kitsap',47.699761,-122.621766),('98346','WA','Kingston','Kitsap',47.807803,-122.52303),('98348','WA','La Grande','Pierce',46.8356,-122.3182),('98349','WA','Lakebay','Pierce',47.270431,-122.769344),('98350','WA','La Push','Clallam',47.903977,-124.630677),('98351','WA','Longbranch','Pierce',47.185873,-122.767573),('98352','WA','Sumner','Pierce',47.2166,-122.1996),('98353','WA','Manchester','Kitsap',47.553289,-122.545357),('98354','WA','Milton','Pierce',47.248912,-122.317706),('98355','WA','Mineral','Lewis',46.693806,-122.118267),('98356','WA','Morton','Lewis',46.561326,-122.284726),('98357','WA','Neah Bay','Clallam',48.352864,-124.64085),('98358','WA','Nordland','Jefferson',48.053303,-122.720594),('98359','WA','Olalla','Kitsap',47.430434,-122.570233),('98360','WA','Orting','Pierce',47.078251,-122.185498),('98361','WA','Packwood','Lewis',46.637931,-121.653972),('98362','WA','Port Angeles','Clallam',48.095154,-123.396722),('98363','WA','Port Angeles','Clallam',48.096561,-123.682144),('98364','WA','Port Gamble','Kitsap',47.854503,-122.591221),('98365','WA','Port Ludlow','Jefferson',47.899872,-122.693562),('98366','WA','Port Orchard','Kitsap',47.534735,-122.599914),('98367','WA','Port Orchard','Kitsap',47.482034,-122.666834),('98368','WA','Port Townsend','Jefferson',48.097984,-122.797112),('98370','WA','Poulsbo','Kitsap',47.747033,-122.629449),('98371','WA','Puyallup','Pierce',47.195825,-122.316729),('98372','WA','Puyallup','Pierce',47.198659,-122.269974),('98373','WA','Puyallup','Pierce',47.152672,-122.319676),('98374','WA','Puyallup','Pierce',47.135013,-122.262873),('98375','WA','Puyallup','Pierce',47.099323,-122.317686),('98376','WA','Quilcene','Jefferson',47.846122,-122.866157),('98377','WA','Randle','Lewis',46.496992,-121.919932),('98378','WA','Retsil','Kitsap',47.5461,-122.61),('98380','WA','Seabeck','Kitsap',47.601744,-122.89052),('98381','WA','Sekiu','Clallam',48.269773,-124.354399),('98382','WA','Sequim','Clallam',48.070854,-123.096483),('98383','WA','Silverdale','Kitsap',47.66941,-122.698244),('98384','WA','South Colby','Kitsap',47.4646,-122.6893),('98385','WA','South Prairie','Pierce',47.137939,-122.095041),('98386','WA','Southworth','Kitsap',47.513,-122.501),('98387','WA','Spanaway','Pierce',47.079539,-122.397112),('98388','WA','Steilacoom','Pierce',47.172081,-122.600913),('98390','WA','Sumner','Pierce',47.20606,-122.234348),('98391','WA','Bonney Lake','Pierce',47.18131,-122.171516),('98392','WA','Suquamish','Kitsap',47.733754,-122.559623),('98393','WA','Tracyton','Kitsap',47.6091,-122.6538),('98394','WA','Vaughn','Pierce',47.335694,-122.783648),('98395','WA','Wauna','Pierce',47.3791,-122.6413),('98396','WA','Wilkeson','Pierce',47.102549,-122.044205),('98397','WA','Longmire','Pierce',46.9776,-121.7992),('98398','WA','Paradise Inn','Pierce',46.7183,-121.6706),('98401','WA','Tacoma','Pierce',47.255031,-122.441631),('98402','WA','Tacoma','Pierce',47.248044,-122.439288),('98403','WA','Tacoma','Pierce',47.264106,-122.458991),('98404','WA','Tacoma','Pierce',47.214389,-122.413446),('98405','WA','Tacoma','Pierce',47.248756,-122.467257),('98406','WA','Tacoma','Pierce',47.263169,-122.496927),('98407','WA','Tacoma','Pierce',47.284211,-122.503941),('98408','WA','Tacoma','Pierce',47.201186,-122.445191),('98409','WA','Tacoma','Pierce',47.211277,-122.478406),('98411','WA','Tacoma','Pierce',47.2215,-122.4717),('98412','WA','Tacoma','Pierce',47.1826,-122.4402),('98413','WA','Tacoma','Pierce',47.253,-122.443),('98415','WA','Tacoma','Pierce',47.253,-122.443),('98416','WA','Tacoma','Pierce',47.262662,-122.481473),('98417','WA','Tacoma','Pierce',47.2061,-122.4822),('98418','WA','Tacoma','Pierce',47.222451,-122.447025),('98419','WA','Tacoma','Pierce',47.2061,-122.4822),('98421','WA','Tacoma','Pierce',47.250024,-122.413269),('98422','WA','Tacoma','Pierce',47.2922,-122.399526),('98424','WA','Tacoma','Pierce',47.235341,-122.354192),('98430','WA','Camp Murray','Pierce',47.117,-122.5663),('98431','WA','Tacoma','Pierce',47.0631,-122.5536),('98433','WA','Tacoma','Pierce',47.103056,-122.596277),('98438','WA','Mcchord Afb','Pierce',47.131315,-122.495883),('98439','WA','Lakewood','Pierce',47.123268,-122.513835),('98442','WA','Tacoma','Pierce',47.1461,-122.4347),('98443','WA','Tacoma','Pierce',47.205004,-122.372661),('98444','WA','Tacoma','Pierce',47.153728,-122.446205),('98445','WA','Tacoma','Pierce',47.143651,-122.409674),('98446','WA','Tacoma','Pierce',47.132871,-122.370667),('98447','WA','Tacoma','Pierce',47.14462,-122.444259),('98448','WA','Tacoma','Pierce',47.2061,-122.4822),('98450','WA','Tacoma','Pierce',47.253,-122.443),('98455','WA','Tacoma','Pierce',47.253,-122.443),('98460','WA','Tacoma','Pierce',47.253,-122.443),('98464','WA','Tacoma','Pierce',47.253,-122.443),('98465','WA','Tacoma','Pierce',47.250854,-122.530655),('98466','WA','Tacoma','Pierce',47.230304,-122.532946),('98467','WA','University Place','Pierce',47.203586,-122.537901),('98471','WA','Tacoma','Pierce',47.2551,-122.4733),('98477','WA','Tacoma','Pierce',47.253,-122.443),('98481','WA','Tacoma','Pierce',47.2208,-122.4732),('98490','WA','Tacoma','Pierce',47.2061,-122.4822),('98492','WA','Lakewood','Pierce',47.1265,-122.5542),('98493','WA','Tacoma','Pierce',47.0631,-122.5536),('98496','WA','Lakewood','Pierce',47.1666,-122.5089),('98497','WA','Lakewood','Pierce',47.1805,-122.5465),('98498','WA','Lakewood','Pierce',47.159792,-122.557823),('98499','WA','Lakewood','Pierce',47.166182,-122.508463),('98501','WA','Olympia','Thurston',47.010051,-122.880951),('98502','WA','Olympia','Thurston',47.072436,-122.962622),('98503','WA','Lacey','Thurston',47.025596,-122.803258),('98504','WA','Olympia','Thurston',47.0409,-122.8945),('98505','WA','Olympia','Thurston',47.0704,-122.9604),('98506','WA','Olympia','Thurston',47.069368,-122.872724),('98507','WA','Olympia','Thurston',47.0409,-122.8945),('98508','WA','Olympia','Thurston',47.0352,-122.9369),('98509','WA','Lacey','Thurston',47.0366,-122.8048),('98511','WA','Tumwater','Thurston',46.9542,-123.025),('98512','WA','Olympia','Thurston',46.978675,-122.990263),('98513','WA','Olympia','Thurston',47.002126,-122.760794),('98516','WA','Olympia','Thurston',47.091892,-122.775781),('98520','WA','Aberdeen','Grays Harbor',46.988316,-123.818173),('98522','WA','Adna','Lewis',46.6291,-123.06),('98524','WA','Allyn','Mason',47.373164,-122.839978),('98526','WA','Amanda Park','Grays Harbor',47.4639,-123.951343),('98527','WA','Bay Center','Pacific',46.616755,-123.949459),('98528','WA','Belfair','Mason',47.440244,-122.87414),('98530','WA','Bucoda','Thurston',46.796523,-122.862954),('98531','WA','Centralia','Lewis',46.73012,-122.961998),('98532','WA','Chehalis','Lewis',46.630956,-122.987626),('98533','WA','Cinebar','Lewis',46.602711,-122.482046),('98535','WA','Copalis Beach','Grays Harbor',47.115202,-124.154587),('98536','WA','Copalis Crossing','Grays Harbor',47.194976,-124.104372),('98537','WA','Cosmopolis','Grays Harbor',46.887737,-123.704861),('98538','WA','Curtis','Lewis',46.499638,-123.119785),('98539','WA','Doty','Lewis',46.637787,-123.279807),('98540','WA','East Olympia','Thurston',46.9677,-122.8344),('98541','WA','Elma','Grays Harbor',47.023062,-123.402578),('98542','WA','Ethel','Lewis',46.534124,-122.728056),('98544','WA','Galvin','Lewis',46.7425,-123.0258),('98546','WA','Grapeview','Mason',47.321272,-122.914006),('98547','WA','Grayland','Grays Harbor',46.797827,-124.060468),('98548','WA','Hoodsport','Mason',47.436239,-123.218203),('98550','WA','Hoquiam','Grays Harbor',47.026074,-123.935868),('98552','WA','Humptulips','Grays Harbor',47.295501,-123.951689),('98554','WA','Lebam','Pacific',46.5591,-123.5477),('98555','WA','Lilliwaup','Mason',47.543373,-123.041095),('98556','WA','Littlerock','Thurston',46.9019,-123.0166),('98557','WA','Mccleary','Grays Harbor',47.051283,-123.277734),('98558','WA','Mckenna','Pierce',46.933941,-122.557218),('98559','WA','Malone','Grays Harbor',46.959091,-123.325954),('98560','WA','Matlock','Mason',47.30235,-123.425806),('98561','WA','Menlo','Pacific',46.6216,-123.6458),('98562','WA','Moclips','Grays Harbor',47.236186,-124.213116),('98563','WA','Montesano','Grays Harbor',47.039892,-123.611563),('98564','WA','Mossyrock','Lewis',46.495238,-122.500846),('98565','WA','Napavine','Lewis',46.576778,-122.907205),('98566','WA','Neilton','Grays Harbor',47.413,-123.8791),('98568','WA','Oakville','Grays Harbor',46.856756,-123.25843),('98569','WA','Ocean Shores','Grays Harbor',46.980384,-124.153423),('98570','WA','Onalaska','Lewis',46.597796,-122.670509),('98571','WA','Pacific Beach','Grays Harbor',47.207283,-124.199093),('98572','WA','Pe Ell','Lewis',46.56553,-123.308481),('98575','WA','Quinault','Grays Harbor',47.418658,-123.815036),('98576','WA','Rainier','Thurston',46.872046,-122.67706),('98577','WA','Raymond','Pacific',46.66376,-123.684795),('98579','WA','Rochester','Thurston',46.818202,-123.070622),('98580','WA','Roy','Pierce',46.982004,-122.523185),('98581','WA','Ryderwood','Cowlitz',46.372073,-123.045379),('98582','WA','Salkum','Lewis',46.526187,-122.634609),('98583','WA','Satsop','Grays Harbor',47.000882,-123.486664),('98584','WA','Shelton','Mason',47.220634,-123.093564),('98585','WA','Silver Creek','Lewis',46.547512,-122.526439),('98586','WA','South Bend','Pacific',46.594698,-123.843433),('98587','WA','Taholah','Grays Harbor',47.307316,-124.254191),('98588','WA','Tahuya','Mason',47.439447,-123.023602),('98589','WA','Tenino','Thurston',46.853536,-122.822578),('98590','WA','Tokeland','Pacific',46.709987,-124.003895),('98591','WA','Toledo','Lewis',46.447063,-122.799409),('98592','WA','Union','Mason',47.3411,-123.083524),('98593','WA','Vader','Lewis',46.403701,-122.973547),('98595','WA','Westport','Grays Harbor',46.88722,-124.109727),('98596','WA','Winlock','Lewis',46.497031,-122.934932),('98597','WA','Yelm','Thurston',46.897958,-122.564079),('98599','WA','Olympia','Thurston',47.0409,-122.8945),('98601','WA','Amboy','Clark',45.938373,-122.437855),('98602','WA','Appleton','Klickitat',45.86726,-121.27098),('98603','WA','Ariel','Cowlitz',45.988703,-122.452616),('98604','WA','Battle Ground','Clark',45.790064,-122.532078),('98605','WA','Bingen','Klickitat',45.766673,-121.603657),('98606','WA','Brush Prairie','Clark',45.736298,-122.475251),('98607','WA','Camas','Clark',45.60826,-122.419028),('98609','WA','Carrolls','Cowlitz',46.0714,-122.864),('98610','WA','Carson','Skamania',45.786137,-121.928653),('98611','WA','Castle Rock','Cowlitz',46.287994,-122.900505),('98612','WA','Cathlamet','Wahkiakum',46.212049,-123.353351),('98613','WA','Centerville','Klickitat',45.730519,-120.937238),('98614','WA','Chinook','Pacific',46.289942,-123.932002),('98616','WA','Cougar','Cowlitz',46.118265,-122.128891),('98617','WA','Dallesport','Klickitat',45.631549,-121.169),('98619','WA','Glenwood','Klickitat',45.973555,-121.268936),('98620','WA','Goldendale','Klickitat',45.843504,-120.797635),('98621','WA','Grays River','Wahkiakum',46.358224,-123.563906),('98622','WA','Heisson','Clark',45.825,-122.49),('98623','WA','Husum','Klickitat',45.7994,-121.4858),('98624','WA','Ilwaco','Pacific',46.320467,-124.011618),('98625','WA','Kalama','Cowlitz',46.015997,-122.797623),('98626','WA','Kelso','Cowlitz',46.153418,-122.88349),('98628','WA','Klickitat','Klickitat',45.818671,-121.117982),('98629','WA','La Center','Clark',45.871403,-122.627513),('98631','WA','Long Beach','Pacific',46.369837,-124.050096),('98632','WA','Longview','Cowlitz',46.157367,-122.982721),('98635','WA','Lyle','Klickitat',45.740004,-121.229526),('98637','WA','Nahcotta','Pacific',46.4986,-124.0322),('98638','WA','Naselle','Pacific',46.373945,-123.745086),('98639','WA','North Bonneville','Skamania',45.642669,-121.973967),('98640','WA','Ocean Park','Pacific',46.505288,-124.046347),('98641','WA','Oysterville','Pacific',46.554,-124.026261),('98642','WA','Ridgefield','Clark',45.798644,-122.693733),('98643','WA','Rosburg','Wahkiakum',46.31796,-123.626096),('98644','WA','Seaview','Pacific',46.331064,-124.054413),('98645','WA','Silverlake','Cowlitz',46.318599,-122.77582),('98647','WA','Skamokawa','Wahkiakum',46.297641,-123.445113),('98648','WA','Stevenson','Skamania',45.684068,-121.924397),('98649','WA','Toutle','Cowlitz',46.34509,-122.639064),('98650','WA','Trout Lake','Klickitat',45.982923,-121.524328),('98651','WA','Underwood','Skamania',45.739924,-121.583462),('98660','WA','Vancouver','Clark',45.650161,-122.688353),('98661','WA','Vancouver','Clark',45.638556,-122.629203),('98662','WA','Vancouver','Clark',45.674139,-122.577655),('98663','WA','Vancouver','Clark',45.648417,-122.66346),('98664','WA','Vancouver','Clark',45.621044,-122.577971),('98665','WA','Vancouver','Clark',45.682941,-122.660168),('98666','WA','Vancouver','Clark',45.6307,-122.6733),('98667','WA','Vancouver','Clark',45.6388,-122.6602),('98668','WA','Vancouver','Clark',45.6408,-122.6221),('98670','WA','Wahkiacus','Klickitat',45.84352,-121.13246),('98671','WA','Washougal','Clark',45.594797,-122.287099),('98672','WA','White Salmon','Klickitat',45.767074,-121.474041),('98673','WA','Wishram','Klickitat',45.654622,-121.039765),('98674','WA','Woodland','Cowlitz',45.927124,-122.692738),('98675','WA','Yacolt','Clark',45.840795,-122.389531),('98682','WA','Vancouver','Clark',45.670759,-122.509558),('98683','WA','Vancouver','Clark',45.603287,-122.51017),('98684','WA','Vancouver','Clark',45.629876,-122.5178),('98685','WA','Vancouver','Clark',45.709629,-122.685249),('98686','WA','Vancouver','Clark',45.71268,-122.633781),('98687','WA','Vancouver','Clark',45.6311,-122.518),('98801','WA','Wenatchee','Chelan',47.420991,-120.330951),('98802','WA','East Wenatchee','Douglas',47.433017,-120.258655),('98807','WA','Wenatchee','Chelan',47.4217,-120.3096),('98811','WA','Ardenvoir','Chelan',47.733396,-120.367696),('98812','WA','Brewster','Okanogan',48.127029,-119.758375),('98813','WA','Bridgeport','Douglas',48.008739,-119.669029),('98814','WA','Carlton','Okanogan',48.227169,-120.116276),('98815','WA','Cashmere','Chelan',47.519227,-120.486573),('98816','WA','Chelan','Chelan',47.879185,-120.081751),('98817','WA','Chelan Falls','Chelan',47.798153,-119.98887),('98819','WA','Conconully','Okanogan',48.6023,-119.779377),('98821','WA','Dryden','Chelan',47.546501,-120.558345),('98822','WA','Entiat','Chelan',47.745858,-120.347317),('98823','WA','Ephrata','Grant',47.318263,-119.576724),('98824','WA','George','Grant',47.08013,-119.859522),('98826','WA','Leavenworth','Chelan',47.701867,-120.721654),('98827','WA','Loomis','Okanogan',48.844558,-119.706521),('98828','WA','Malaga','Chelan',47.317162,-120.173048),('98829','WA','Malott','Okanogan',48.273367,-119.764649),('98830','WA','Mansfield','Douglas',47.851596,-119.588257),('98831','WA','Manson','Chelan',47.908457,-120.140341),('98832','WA','Marlin','Grant',47.366914,-118.991871),('98833','WA','Mazama','Okanogan',48.655621,-120.566591),('98834','WA','Methow','Okanogan',48.142333,-120.043156),('98836','WA','Monitor','Chelan',47.486296,-120.420601),('98837','WA','Moses Lake','Grant',47.137763,-119.296658),('98840','WA','Okanogan','Okanogan',48.341937,-119.575162),('98841','WA','Omak','Okanogan',48.381049,-119.411337),('98843','WA','Orondo','Douglas',47.756156,-120.070638),('98844','WA','Oroville','Okanogan',48.904225,-119.35438),('98845','WA','Palisades','Douglas',47.430359,-119.94154),('98846','WA','Pateros','Okanogan',48.045106,-119.944186),('98847','WA','Peshastin','Chelan',47.503666,-120.633758),('98848','WA','Quincy','Grant',47.182276,-119.858793),('98849','WA','Riverside','Okanogan',48.517687,-119.462287),('98850','WA','Rock Island','Douglas',47.361862,-120.111774),('98851','WA','Soap Lake','Grant',47.394634,-119.453844),('98852','WA','Stehekin','Chelan',48.320298,-120.676981),('98853','WA','Stratford','Grant',47.441367,-119.258102),('98855','WA','Tonasket','Okanogan',48.671231,-119.315934),('98856','WA','Twisp','Okanogan',48.363775,-120.132189),('98857','WA','Warden','Grant',46.97183,-119.058659),('98858','WA','Waterville','Douglas',47.663492,-119.963709),('98859','WA','Wauconda','Okanogan',48.815237,-118.909772),('98860','WA','Wilson Creek','Grant',47.441669,-119.166606),('98862','WA','Winthrop','Okanogan',48.530984,-120.240744),('98901','WA','Yakima','Yakima',46.617339,-120.463438),('98902','WA','Yakima','Yakima',46.59526,-120.531041),('98903','WA','Yakima','Yakima',46.551892,-120.624495),('98904','WA','Yakima','Yakima',46.6022,-120.5047),('98907','WA','Yakima','Yakima',46.666,-120.3543),('98908','WA','Yakima','Yakima',46.608452,-120.623497),('98909','WA','Yakima','Yakima',46.5708,-120.5069),('98920','WA','Brownstown','Yakima',46.4044,-120.6058),('98921','WA','Buena','Yakima',46.428757,-120.314771),('98922','WA','Cle Elum','Kittitas',47.215332,-120.897434),('98923','WA','Cowiche','Yakima',46.668334,-120.715626),('98925','WA','Easton','Kittitas',47.264298,-121.234926),('98926','WA','Ellensburg','Kittitas',47.006862,-120.515304),('98929','WA','Goose Prairie','Yakima',46.7438,-121.1449),('98930','WA','Grandview','Yakima',46.261682,-119.908453),('98932','WA','Granger','Yakima',46.344148,-120.180625),('98933','WA','Harrah','Yakima',46.404446,-120.614511),('98934','WA','Kittitas','Kittitas',46.983753,-120.418329),('98935','WA','Mabton','Yakima',46.194866,-120.028969),('98936','WA','Moxee','Yakima',46.546694,-120.322822),('98937','WA','Naches','Yakima',46.747783,-120.928423),('98938','WA','Outlook','Yakima',46.353074,-120.088497),('98939','WA','Parker','Yakima',46.501749,-120.467414),('98940','WA','Ronald','Kittitas',47.28567,-121.079774),('98941','WA','Roslyn','Kittitas',47.222869,-120.994098),('98942','WA','Selah','Yakima',46.693396,-120.562917),('98943','WA','South Cle Elum','Kittitas',47.187568,-120.949151),('98944','WA','Sunnyside','Yakima',46.353757,-119.921423),('98946','WA','Thorp','Kittitas',47.083244,-120.707062),('98947','WA','Tieton','Yakima',46.700608,-120.76274),('98948','WA','Toppenish','Yakima',46.356828,-120.334739),('98950','WA','Vantage','Kittitas',46.88018,-119.989194),('98951','WA','Wapato','Yakima',46.455203,-120.469526),('98952','WA','White Swan','Yakima',46.375301,-120.727301),('98953','WA','Zillah','Yakima',46.421309,-120.269412),('99001','WA','Airway Heights','Spokane',47.643655,-117.588035),('99003','WA','Chattaroy','Spokane',47.921395,-117.307904),('99004','WA','Cheney','Spokane',47.472472,-117.596839),('99005','WA','Colbert','Spokane',47.833346,-117.37205),('99006','WA','Deer Park','Spokane',47.951818,-117.484144),('99008','WA','Edwall','Lincoln',47.518256,-117.928244),('99009','WA','Elk','Spokane',48.023173,-117.274446),('99011','WA','Fairchild Air Force Base','Spokane',47.626674,-117.652731),('99012','WA','Fairfield','Spokane',47.383853,-117.185484),('99013','WA','Ford','Stevens',47.869367,-117.844041),('99014','WA','Four Lakes','Spokane',47.5613,-117.593),('99016','WA','Greenacres','Spokane',47.655083,-117.156308),('99017','WA','Lamont','Whitman',47.183947,-117.886317),('99018','WA','Latah','Spokane',47.286152,-117.152451),('99019','WA','Liberty Lake','Spokane',47.664248,-117.085766),('99020','WA','Marshall','Spokane',47.564778,-117.495376),('99021','WA','Mead','Spokane',47.816932,-117.266651),('99022','WA','Medical Lake','Spokane',47.592789,-117.682126),('99023','WA','Mica','Spokane',47.557546,-117.195816),('99025','WA','Newman Lake','Spokane',47.748914,-117.071865),('99026','WA','Nine Mile Falls','Stevens',47.810406,-117.599278),('99027','WA','Otis Orchards','Spokane',47.697043,-117.114529),('99029','WA','Reardan','Lincoln',47.694475,-117.830958),('99030','WA','Rockford','Spokane',47.47946,-117.118916),('99031','WA','Spangle','Spokane',47.436213,-117.381124),('99032','WA','Sprague','Lincoln',47.299664,-117.989769),('99033','WA','Tekoa','Whitman',47.226888,-117.078833),('99034','WA','Tumtum','Stevens',47.885072,-117.748245),('99036','WA','Valleyford','Spokane',47.527273,-117.270627),('99037','WA','Veradale','Spokane',47.640812,-117.200934),('99039','WA','Waverly','Spokane',47.339514,-117.236655),('99040','WA','Wellpinit','Stevens',47.919319,-117.99628),('99101','WA','Addy','Stevens',48.323096,-117.906367),('99102','WA','Albion','Whitman',46.792415,-117.250774),('99103','WA','Almira','Lincoln',47.750858,-118.948007),('99104','WA','Belmont','Whitman',47.0881,-117.1614),('99105','WA','Benge','Adams',46.899686,-118.123404),('99107','WA','Boyds','Ferry',48.6705,-118.3139),('99109','WA','Chewelah','Stevens',48.281265,-117.724611),('99110','WA','Clayton','Stevens',48.007164,-117.561744),('99111','WA','Colfax','Whitman',46.875494,-117.398254),('99113','WA','Colton','Whitman',46.593945,-117.194095),('99114','WA','Colville','Stevens',48.6285,-117.804941),('99115','WA','Coulee City','Grant',47.638434,-119.363059),('99116','WA','Coulee Dam','Okanogan',47.985843,-118.96106),('99117','WA','Creston','Lincoln',47.763506,-118.496347),('99118','WA','Curlew','Ferry',48.894767,-118.630363),('99119','WA','Cusick','Pend Oreille',48.472175,-117.321265),('99121','WA','Danville','Ferry',48.962456,-118.51678),('99122','WA','Davenport','Lincoln',47.711782,-118.1768),('99123','WA','Electric City','Grant',47.906998,-119.065731),('99124','WA','Elmer City','Okanogan',47.998887,-118.953366),('99125','WA','Endicott','Whitman',46.935959,-117.719592),('99126','WA','Evans','Stevens',48.724341,-118.001603),('99128','WA','Farmington','Whitman',47.094502,-117.061589),('99129','WA','Fruitland','Stevens',48.000987,-118.198601),('99130','WA','Garfield','Whitman',46.995476,-117.16287),('99131','WA','Gifford','Stevens',48.276118,-118.128865),('99133','WA','Grand Coulee','Grant',47.956504,-119.009552),('99134','WA','Harrington','Lincoln',47.451613,-118.295656),('99135','WA','Hartline','Grant',47.677411,-119.095019),('99136','WA','Hay','Whitman',46.668986,-117.961361),('99137','WA','Hunters','Stevens',48.166733,-118.127495),('99138','WA','Inchelium','Ferry',48.256439,-118.331151),('99139','WA','Ione','Pend Oreille',48.739817,-117.422058),('99140','WA','Keller','Ferry',48.119653,-118.693953),('99141','WA','Kettle Falls','Stevens',48.666125,-118.128347),('99143','WA','Lacrosse','Whitman',46.765309,-117.848283),('99144','WA','Lamona','Lincoln',47.358991,-118.490137),('99146','WA','Laurier','Ferry',48.956012,-118.283399),('99147','WA','Lincoln','Lincoln',47.827104,-118.447526),('99148','WA','Loon Lake','Stevens',48.080485,-117.615567),('99149','WA','Malden','Whitman',47.227332,-117.470862),('99150','WA','Malo','Ferry',48.806822,-118.602018),('99151','WA','Marcus','Stevens',48.664739,-118.064571),('99152','WA','Metaline','Pend Oreille',48.85204,-117.388816),('99153','WA','Metaline Falls','Pend Oreille',48.853879,-117.290931),('99154','WA','Mohler','Lincoln',47.391423,-118.361886),('99155','WA','Nespelem','Okanogan',48.213569,-118.974265),('99156','WA','Newport','Pend Oreille',48.178703,-117.160832),('99157','WA','Northport','Stevens',48.902407,-117.804556),('99158','WA','Oakesdale','Whitman',47.133774,-117.248651),('99159','WA','Odessa','Lincoln',47.337735,-118.730473),('99160','WA','Orient','Ferry',48.867995,-118.3016),('99161','WA','Palouse','Whitman',46.910932,-117.087432),('99163','WA','Pullman','Whitman',46.735196,-117.1855),('99164','WA','Pullman','Whitman',46.730909,-117.152747),('99165','WA','Pullman','Whitman',46.7313,-117.1786),('99166','WA','Republic','Ferry',48.646582,-118.688013),('99167','WA','Rice','Stevens',48.412107,-118.129032),('99169','WA','Ritzville','Adams',47.122464,-118.386754),('99170','WA','Rosalia','Whitman',47.236054,-117.395328),('99171','WA','Saint John','Whitman',47.098256,-117.65389),('99173','WA','Springdale','Stevens',48.049947,-117.79582),('99174','WA','Steptoe','Whitman',47.008386,-117.356813),('99176','WA','Thornton','Whitman',47.093101,-117.421337),('99179','WA','Uniontown','Whitman',46.500323,-117.089471),('99180','WA','Usk','Pend Oreille',48.295004,-117.292268),('99181','WA','Valley','Stevens',48.157408,-117.749014),('99185','WA','Wilbur','Lincoln',47.768217,-118.710401),('99201','WA','Spokane','Spokane',47.66303,-117.432909),('99202','WA','Spokane','Spokane',47.657938,-117.380464),('99203','WA','Spokane','Spokane',47.630894,-117.406593),('99204','WA','Spokane','Spokane',47.647028,-117.427533),('99205','WA','Spokane','Spokane',47.694001,-117.437436),('99206','WA','Spokane','Spokane',47.644153,-117.257123),('99207','WA','Spokane','Spokane',47.689851,-117.391078),('99208','WA','Spokane','Spokane',47.735644,-117.428963),('99209','WA','Spokane','Spokane',47.6934,-117.4382),('99210','WA','Spokane','Spokane',47.6581,-117.424),('99211','WA','Spokane','Spokane',47.6588,-117.425),('99212','WA','Spokane','Spokane',47.669163,-117.307106),('99213','WA','Spokane','Spokane',47.6588,-117.425),('99214','WA','Spokane','Spokane',47.6588,-117.425),('99215','WA','Spokane','Spokane',47.6953,-117.2105),('99216','WA','Spokane','Spokane',47.668406,-117.216048),('99217','WA','Spokane','Spokane',47.707713,-117.343995),('99218','WA','Spokane','Spokane',47.757964,-117.414788),('99219','WA','Spokane','Spokane',47.6588,-117.425),('99220','WA','Spokane','Spokane',47.657,-117.3859),('99223','WA','Spokane','Spokane',47.614444,-117.358497),('99224','WA','Spokane','Spokane',47.634159,-117.487142),('99228','WA','Spokane','Spokane',47.7155,-117.4245),('99251','WA','Spokane','Spokane',47.7511,-117.4176),('99252','WA','Spokane','Spokane',47.6717,-117.3897),('99256','WA','Spokane','Spokane',47.657,-117.3859),('99258','WA','Spokane','Spokane',47.6683,-117.4028),('99260','WA','Spokane','Spokane',47.657,-117.3859),('99299','WA','Spokane','Spokane',47.6588,-117.425),('99301','WA','Pasco','Franklin',46.281535,-119.116021),('99302','WA','Pasco','Franklin',46.4057,-118.9568),('99320','WA','Benton City','Benton',46.263744,-119.478881),('99321','WA','Beverly','Grant',46.860104,-119.932739),('99322','WA','Bickleton','Klickitat',45.984527,-120.263797),('99323','WA','Burbank','Walla Walla',46.197356,-118.942432),('99324','WA','College Place','Walla Walla',46.04523,-118.382501),('99326','WA','Connell','Franklin',46.661749,-118.874831),('99328','WA','Dayton','Columbia',46.306177,-117.944021),('99329','WA','Dixie','Walla Walla',46.141558,-118.152447),('99330','WA','Eltopia','Franklin',46.46746,-119.081317),('99333','WA','Hooper','Whitman',46.750937,-118.157831),('99335','WA','Kahlotus','Franklin',46.649776,-118.549391),('99336','WA','Kennewick','Benton',46.210963,-119.167648),('99337','WA','Kennewick','Benton',46.16008,-119.110173),('99338','WA','Kennewick','Benton',46.189312,-119.241642),('99341','WA','Lind','Adams',46.925872,-118.640529),('99343','WA','Mesa','Franklin',46.575052,-119.112053),('99344','WA','Othello','Adams',46.825917,-119.161245),('99345','WA','Paterson','Benton',45.912784,-119.681432),('99346','WA','Plymouth','Benton',45.966861,-119.306436),('99347','WA','Pomeroy','Garfield',46.471539,-117.590815),('99348','WA','Prescott','Walla Walla',46.409566,-118.448609),('99349','WA','Mattawa','Grant',46.730701,-119.842506),('99350','WA','Prosser','Benton',46.206853,-119.745986),('99352','WA','Richland','Benton',46.248248,-119.282778),('99353','WA','West Richland','Benton',46.293327,-119.360268),('99354','WA','Richland','Benton',46.30716,-119.286601),('99356','WA','Roosevelt','Klickitat',45.808626,-120.293082),('99357','WA','Royal City','Grant',46.906934,-119.652031),('99359','WA','Starbuck','Columbia',46.539633,-118.156807),('99360','WA','Touchet','Walla Walla',46.065079,-118.644997),('99361','WA','Waitsburg','Walla Walla',46.229583,-118.135423),('99362','WA','Walla Walla','Walla Walla',46.056358,-118.313853),('99363','WA','Wallula','Walla Walla',46.059013,-118.884683),('99371','WA','Washtucna','Adams',46.787487,-118.329036),('99401','WA','Anatone','Asotin',46.068264,-117.244434),('99402','WA','Asotin','Asotin',46.277911,-117.08237),('99403','WA','Clarkston','Asotin',46.398545,-117.08777),('99501','AK','Anchorage','Anchorage Borough',61.215101,-149.876125),('99502','AK','Anchorage','Anchorage Borough',61.156383,-149.955839),('99503','AK','Anchorage','Anchorage Borough',61.187416,-149.913604),('99504','AK','Anchorage','Anchorage Borough',61.2046,-149.746095),('99505','AK','Fort Richardson','Anchorage Borough',61.261063,-149.681135),('99506','AK','Elmendorf Afb','Anchorage Borough',61.244462,-149.810698),('99507','AK','Anchorage','Anchorage Borough',61.152865,-149.814098),('99508','AK','Anchorage','Anchorage Borough',61.204297,-149.814372),('99509','AK','Anchorage','Anchorage',61.1897,-149.9063),('99510','AK','Anchorage','North Slope Borough',70.441108,-150.292407),('99511','AK','Anchorage','Anchorage',61.1104,-149.8577),('99513','AK','Anchorage','Anchorage',61.214877,-149.886177),('99514','AK','Anchorage','Anchorage',61.218,-149.9002),('99515','AK','Anchorage','Anchorage Borough',61.123492,-149.883625),('99516','AK','Anchorage','Anchorage Borough',61.091074,-149.780635),('99517','AK','Anchorage','Anchorage Borough',61.190017,-149.933771),('99518','AK','Anchorage','Anchorage Borough',61.160919,-149.880344),('99519','AK','Anchorage','North Slope Borough',69.910468,-147.537657),('99520','AK','Anchorage','Anchorage',61.2147,-149.8649),('99521','AK','Anchorage','Anchorage',61.1996,-149.7314),('99522','AK','Anchorage','Anchorage',61.1521,-149.9198),('99523','AK','Anchorage','Anchorage',61.1682,-149.8356),('99524','AK','Anchorage','Anchorage',61.218,-149.9002),('99529','AK','Anchorage','Anchorage',61.2175,-149.9025),('99530','AK','Anchorage','Anchorage',61.2175,-149.9025),('99540','AK','Indian','Anchorage Borough',60.975873,-149.457409),('99545','AK','Kongiganak','Bethel',59.9599,162.8919),('99546','AK','Adak','Aleutians West Census Area',51.869734,-176.638613),('99547','AK','Atka','Aleutians West Census Area',52.196636,-174.196741),('99548','AK','Chignik Lake','Lake And Peninsula Borough',56.237423,-158.751724),('99549','AK','Port Heiden','Lake And Peninsula Borough',56.944257,-158.6607),('99550','AK','Port Lions','Kodiak Island Borough',57.867301,-152.881795),('99551','AK','Akiachak','Bethel Census Area',60.909459,-161.422739),('99552','AK','Akiak','Bethel Census Area',60.909943,-161.221777),('99553','AK','Akutan','Aleutians East Borough',54.139255,-165.779716),('99554','AK','Alakanuk','Wade Hampton Census Area',62.683414,-164.653993),('99555','AK','Aleknagik','Dillingham Census Area',59.271055,-158.62397),('99556','AK','Anchor Point','Kenai Peninsula Borough',59.805866,-151.727532),('99557','AK','Aniak','Bethel Census Area',61.021703,-157.501463),('99558','AK','Anvik','Yukon-koyukuk Census Area',62.655404,-160.205783),('99559','AK','Bethel','Bethel Census Area',60.785067,-161.890778),('99561','AK','Chefornak','Bethel Census Area',60.157985,-164.274128),('99563','AK','Chevak','Wade Hampton Census Area',61.527426,-165.583084),('99564','AK','Chignik','Lake And Peninsula Borough',56.298149,-158.408704),('99565','AK','Chignik Lagoon','Lake And Peninsula Borough',56.308979,-158.534714),('99566','AK','Chitina','Valdez-cordova Census Area',61.37227,-143.355705),('99567','AK','Chugiak','Anchorage Borough',61.443702,-149.274586),('99568','AK','Clam Gulch','Kenai Peninsula Borough',60.23481,-151.389402),('99569','AK','Clarks Point','Dillingham Census Area',58.83254,-158.549792),('99571','AK','Cold Bay','Aleutians East Borough',55.204649,-162.704548),('99572','AK','Cooper Landing','Kenai Peninsula Borough',60.493337,-149.823637),('99573','AK','Copper Center','Valdez-cordova Census Area',61.829814,-145.229193),('99574','AK','Cordova','Valdez-cordova Census Area',60.377609,-146.466285),('99575','AK','Crooked Creek','Bethel Census Area',61.862595,-158.129017),('99576','AK','Dillingham','Dillingham Census Area',59.065557,-158.466602),('99577','AK','Eagle River','Anchorage Borough',61.30801,-149.506012),('99578','AK','Eek','Bethel Census Area',60.218818,-162.027374),('99579','AK','Egegik','Lake And Peninsula Borough',58.211265,-157.35738),('99580','AK','Ekwok','Dillingham Census Area',59.353444,-157.481731),('99581','AK','Emmonak','Wade Hampton Census Area',62.779275,-164.539148),('99583','AK','False Pass','Aleutians East Borough',54.85538,-163.410943),('99585','AK','Marshall','Wade Hampton Census Area',61.913389,-162.151797),('99586','AK','Gakona','Valdez-cordova Census Area',62.691006,-144.237298),('99587','AK','Girdwood','Anchorage Borough',60.897956,-149.069137),('99588','AK','Glennallen','Valdez-cordova Census Area',62.232698,-146.524264),('99589','AK','Goodnews Bay','Bethel Census Area',59.119673,-161.580921),('99590','AK','Grayling','Yukon-koyukuk Census Area',62.910466,-160.067258),('99591','AK','Saint George Island','Aleutians West Census Area',56.605619,-169.559808),('99599','AK','Anchorage','Anchorage',61.218,-149.9002),('99602','AK','Holy Cross','Yukon-koyukuk Census Area',62.198383,-159.773484),('99603','AK','Homer','Kenai Peninsula Borough',59.608024,-151.431231),('99604','AK','Hooper Bay','Wade Hampton Census Area',61.52787,-166.099131),('99605','AK','Hope','Kenai Peninsula Borough',60.787309,-149.55487),('99606','AK','Iliamna','Lake And Peninsula Borough',59.731521,-154.872214),('99607','AK','Kalskag','Bethel Census Area',61.536546,-160.307074),('99608','AK','Karluk','Kodiak Island',57.578081,-154.362557),('99609','AK','Kasigluk','Bethel Census Area',60.89091,-162.517016),('99610','AK','Kasilof','Kenai Peninsula Borough',60.328908,-151.201037),('99611','AK','Kenai','Kenai Peninsula Borough',60.637013,-151.17298),('99612','AK','King Cove','Aleutians East Borough',55.063191,-162.311613),('99613','AK','King Salmon','Bristol Bay Borough',58.732423,-156.412137),('99614','AK','Kipnuk','Bethel Census Area',59.93687,-164.03918),('99615','AK','Kodiak','Kodiak Island Borough',57.761747,-152.83064),('99619','AK','Kodiak','Kodiak Island',57.794455,-152.395316),('99620','AK','Kotlik','Wade Hampton Census Area',63.033069,-163.552392),('99621','AK','Kwethluk','Bethel Census Area',60.808007,-161.42139),('99622','AK','Kwigillingok','Bethel Census Area',59.87171,-163.166049),('99624','AK','Larsen Bay','Kodiak Island Borough',57.53718,-153.974251),('99625','AK','Levelock','Lake And Peninsula Borough',59.116734,-156.851556),('99626','AK','Lower Kalskag','Bethel Census Area',61.514141,-160.360668),('99627','AK','Mc Grath','Yukon-koyukuk Census Area',62.966127,-155.742948),('99628','AK','Manokotak','Dillingham Census Area',58.995076,-159.086061),('99629','AK','Wasilla','Matanuska Susitna',61.5814,-149.4394),('99630','AK','Mekoryuk','Bethel Census Area',60.370819,-166.266794),('99631','AK','Moose Pass','Kenai Peninsula Borough',60.509105,-149.449053),('99632','AK','Mountain Village','Wade Hampton Census Area',62.092144,-163.691175),('99633','AK','Naknek','Bristol Bay Borough',58.741615,-156.966992),('99634','AK','Napakiak','Bethel Census Area',60.694208,-161.969472),('99635','AK','Nikiski','Kenai Peninsula',60.784804,-151.064731),('99636','AK','New Stuyahok','Dillingham Census Area',59.452375,-157.313584),('99637','AK','Toksook Bay','Bethel Census Area',60.533127,-165.110761),('99638','AK','Nikolski','Aleutians West Census Area',52.94077,-168.862296),('99639','AK','Ninilchik','Kenai Peninsula Borough',60.009084,-151.547599),('99640','AK','Nondalton','Lake And Peninsula Borough',59.981021,-154.82842),('99641','AK','Nunapitchuk','Bethel Census Area',60.897617,-162.458569),('99643','AK','Old Harbor','Kodiak Island Borough',57.201455,-153.311394),('99644','AK','Ouzinkie','Kodiak Island Borough',57.924942,-152.462786),('99645','AK','Palmer','Matanuska-susitna Borough',61.596745,-149.126092),('99647','AK','Pedro Bay','Lake And Peninsula Borough',59.789331,-154.12552),('99648','AK','Perryville','Lake And Peninsula Borough',55.909742,-159.155644),('99649','AK','Pilot Point','Lake And Peninsula Borough',57.562681,-157.563582),('99650','AK','Pilot Station','Wade Hampton Census Area',61.93799,-162.880745),('99651','AK','Platinum','Bethel Census Area',59.00771,-161.81497),('99652','AK','Big Lake','Matanuska-susitna Borough',61.549816,-149.867051),('99653','AK','Port Alsworth','Lake And Peninsula Borough',60.202966,-154.315465),('99654','AK','Wasilla','Matanuska-susitna Borough',61.563994,-149.547704),('99655','AK','Quinhagak','Bethel Census Area',59.74943,-161.902966),('99656','AK','Red Devil','Bethel Census Area',61.78633,-157.344468),('99657','AK','Russian Mission','Wade Hampton Census Area',61.668444,-161.427689),('99658','AK','Saint Marys','Wade Hampton Census Area',62.044903,-163.221959),('99659','AK','Saint Michael','Nome Census Area',63.473431,-162.05212),('99660','AK','Saint Paul Island','Aleutians West Census Area',57.136342,-170.268406),('99661','AK','Sand Point','Aleutians East Borough',55.336163,-160.498714),('99662','AK','Scammon Bay','Wade Hampton Census Area',61.842002,-165.592698),('99663','AK','Seldovia','Kenai Peninsula Borough',59.433541,-151.69384),('99664','AK','Seward','Kenai Peninsula Borough',60.076367,-149.492517),('99665','AK','Shageluk','Yukon-koyukuk Census Area',62.655469,-159.524608),('99666','AK','Nunam Iqua','Wade Hampton Census Area',62.506549,-164.900326),('99667','AK','Skwentna','Matanuska-susitna Borough',61.881549,-151.391992),('99668','AK','Sleetmute','Bethel Census Area',61.701413,-157.169266),('99669','AK','Soldotna','Kenai Peninsula Borough',60.487292,-151.028372),('99670','AK','South Naknek','Bristol Bay Borough',58.712415,-156.993571),('99671','AK','Stebbins','Nome Census Area',63.52002,-162.280229),('99672','AK','Sterling','Kenai Peninsula Borough',60.57878,-150.75856),('99674','AK','Sutton','Matanuska-susitna Borough',61.795416,-148.24746),('99675','AK','Takotna','Yukon Koyukuk',62.969642,-156.102642),('99676','AK','Talkeetna','Matanuska-susitna Borough',62.346616,-150.012367),('99677','AK','Tatitlek','Valdez-cordova Census Area',60.878524,-146.693659),('99678','AK','Togiak','Dillingham Census Area',59.076308,-160.281952),('99679','AK','Tuluksak','Bethel Census Area',61.099226,-160.961993),('99680','AK','Tuntutuliak','Bethel Census Area',60.343865,-162.664524),('99681','AK','Tununak','Bethel Census Area',60.584406,-165.25164),('99682','AK','Tyonek','Kenai Peninsula Borough',61.015487,-152.637521),('99683','AK','Trapper Creek','Matanuska-susitna Borough',62.408729,-150.440934),('99684','AK','Unalakleet','Nome Census Area',63.88292,-160.734867),('99685','AK','Unalaska','Aleutians West Census Area',53.888239,-166.497962),('99686','AK','Valdez','Valdez-cordova Census Area',61.15008,-146.810141),('99687','AK','Wasilla','Matanuska Susitna',61.391728,-149.990023),('99688','AK','Willow','Matanuska-susitna Borough',61.90527,-150.06488),('99689','AK','Yakutat','Yakutat Borough',59.549344,-139.664469),('99690','AK','Nightmute','Bethel Census Area',60.478172,-164.724785),('99691','AK','Nikolai','Yukon-koyukuk Census Area',63.021365,-154.313559),('99692','AK','Dutch Harbor','Aleutians West Census Area',53.883353,-166.53906),('99693','AK','Whittier','Valdez-cordova Census Area',60.793618,-148.482235),('99694','AK','Houston','Matanuska-susitna Borough',61.614369,-149.785856),('99695','AK','Anchorage','Anchorage',61.402544,-150.574859),('99697','AK','Kodiak','Kodiak Island',57.564289,-153.407559),('99701','AK','Fairbanks','Fairbanks North Star Borough',64.848527,-147.777975),('99702','AK','Eielson Afb','Fairbanks North Star Borough',64.668842,-147.078271),('99703','AK','Fort Wainwright','Fairbanks North Star Borough',64.832563,-147.636633),('99704','AK','Clear','Denali Borough',64.297692,-149.174196),('99705','AK','North Pole','Fairbanks North Star Borough',64.761539,-147.347269),('99706','AK','Fairbanks','Fairbanks North Star',64.8377,-147.7163),('99707','AK','Fairbanks','Fairbanks North Star',64.8419,-147.7227),('99708','AK','Fairbanks','Fairbanks North Star',64.8377,-147.7163),('99709','AK','Fairbanks','Fairbanks North Star Borough',64.841724,-147.888294),('99710','AK','Fairbanks','Fairbanks North Star',64.8377,-147.7163),('99711','AK','Fairbanks','Fairbanks North Star',64.8377,-147.7163),('99712','AK','Fairbanks','Fairbanks North Star Borough',64.975239,-147.329085),('99714','AK','Salcha','Fairbanks North Star Borough',64.423219,-146.893865),('99716','AK','Two Rivers','Fairbanks North Star',65.0991,-146.7471),('99720','AK','Allakaket','Yukon-koyukuk Census Area',66.552424,-152.660653),('99721','AK','Anaktuvuk Pass','North Slope Borough',68.146362,-151.732712),('99722','AK','Arctic Village','Yukon-koyukuk Census Area',68.095845,-145.612834),('99723','AK','Barrow','North Slope Borough',71.301803,-156.724611),('99724','AK','Beaver','Yukon-koyukuk Census Area',66.390584,-147.337916),('99725','AK','Ester','Fairbanks North Star',64.842326,-148.021973),('99726','AK','Bettles Field','Yukon-koyukuk Census Area',66.915216,-151.590772),('99727','AK','Buckland','Northwest Arctic Borough',65.9788,-161.124189),('99729','AK','Cantwell','Denali Borough',63.361602,-148.659156),('99730','AK','Central','Yukon-koyukuk Census Area',65.570903,-144.977021),('99731','AK','Fort Greely','Southeast Fairbanks',63.0374,-145.7345),('99732','AK','Chicken','Southeast Fairbanks',64.070738,-141.874894),('99733','AK','Circle','Yukon-koyukuk Census Area',65.838956,-144.179638),('99734','AK','Prudhoe Bay','North Slope Borough',70.42037,-148.910501),('99736','AK','Deering','Northwest Arctic Borough',66.075352,-162.720947),('99737','AK','Delta Junction','Southeast Fairbanks Census Area',63.994021,-145.598932),('99738','AK','Eagle','Southeast Fairbanks Census Area',64.804945,-141.275028),('99739','AK','Elim','Nome Census Area',64.714042,-162.400141),('99740','AK','Fort Yukon','Yukon-koyukuk Census Area',66.577455,-145.20298),('99741','AK','Galena','Yukon-koyukuk Census Area',64.738992,-156.894356),('99742','AK','Gambell','Nome Census Area',63.778035,-171.723828),('99743','AK','Healy','Denali Borough',63.895681,-149.37685),('99744','AK','Anderson','Denali Borough',64.290706,-149.183483),('99745','AK','Hughes','Yukon-koyukuk Census Area',66.044635,-154.258301),('99746','AK','Huslia','Yukon-koyukuk Census Area',65.45423,-157.007402),('99747','AK','Kaktovik','North Slope Borough',70.127107,-143.623644),('99748','AK','Kaltag','Yukon-koyukuk Census Area',64.324994,-158.731977),('99749','AK','Kiana','Northwest Arctic Borough',66.972331,-160.430293),('99750','AK','Kivalina','Northwest Arctic Borough',67.727941,-164.539755),('99751','AK','Kobuk','Northwest Arctic Borough',66.909347,-156.88514),('99752','AK','Kotzebue','Northwest Arctic Borough',67.028108,-162.47203),('99753','AK','Koyuk','Nome Census Area',64.932393,-161.155415),('99754','AK','Koyukuk','Yukon-koyukuk Census Area',64.883049,-157.711241),('99755','AK','Denali National Park','Denali Borough',63.691356,-148.85155),('99756','AK','Manley Hot Springs','Yukon-koyukuk Census Area',64.949448,-150.370868),('99757','AK','Lake Minchumina','Yukon-koyukuk Census Area',63.806222,-152.692241),('99758','AK','Minto','Yukon-koyukuk Census Area',65.147981,-149.354664),('99759','AK','Point Lay','North Slope Borough',69.741271,-163.008549),('99760','AK','Nenana','Yukon-koyukuk Census Area',64.503879,-149.040214),('99761','AK','Noatak','Northwest Arctic Borough',67.572176,-162.975607),('99762','AK','Nome','Nome Census Area',64.566265,-165.246626),('99763','AK','Noorvik','Northwest Arctic Borough',66.835197,-161.044297),('99764','AK','Northway','Southeast Fairbanks Census Area',62.90812,-141.759702),('99765','AK','Nulato','Yukon-koyukuk Census Area',64.730009,-158.114101),('99766','AK','Point Hope','North Slope Borough',68.389671,-166.568806),('99767','AK','Rampart','Yukon-koyukuk Census Area',65.508445,-150.150151),('99768','AK','Ruby','Yukon-koyukuk Census Area',64.800617,-155.376844),('99769','AK','Savoonga','Nome Census Area',63.680702,-170.482859),('99770','AK','Selawik','Northwest Arctic Borough',66.601653,-159.991368),('99771','AK','Shaktoolik','Nome Census Area',64.338553,-161.164658),('99772','AK','Shishmaref','Nome Census Area',65.883386,-166.180508),('99773','AK','Shungnak','Northwest Arctic Borough',66.887401,-157.142869),('99774','AK','Stevens Village','Yukon-koyukuk Census Area',66.006068,-149.087433),('99775','AK','Fairbanks','Fairbanks North Star Borough',64.858353,-147.824532),('99776','AK','Tanacross','Southeast Fairbanks Census Area',63.390491,-143.362765),('99777','AK','Tanana','Yukon-koyukuk Census Area',65.171853,-152.077462),('99778','AK','Teller','Nome Census Area',65.264608,-166.36621),('99779','AK','Tok','Southeast Fairbanks',63.135294,-142.532306),('99780','AK','Tok','Southeast Fairbanks Census Area',63.193621,-142.833359),('99781','AK','Venetie','Yukon-koyukuk Census Area',67.046509,-146.335344),('99782','AK','Wainwright','North Slope Borough',70.646042,-160.018442),('99783','AK','Wales','Nome Census Area',65.620542,-168.07032),('99784','AK','White Mountain','Nome Census Area',64.680074,-163.405574),('99785','AK','Brevig Mission','Nome Census Area',65.33405,-166.488089),('99786','AK','Ambler','Northwest Arctic Borough',66.989594,-157.313044),('99788','AK','Chalkyitsik','Yukon-koyukuk Census Area',66.650913,-143.729382),('99789','AK','Nuiqsut','North Slope Borough',70.215209,-151.027488),('99790','AK','Fairbanks','Yukon-koyukuk Census Area',65.533078,-148.523835),('99791','AK','Atqasuk','North Slope Borough',70.46841,-156.795574),('99801','AK','Juneau','Juneau Borough',58.358418,-134.488132),('99802','AK','Juneau','Juneau',58.2997,-134.4149),('99803','AK','Juneau','Juneau',58.3722,-134.5868),('99811','AK','Juneau','Juneau',58.4773,-134.1549),('99812','AK','Juneau','Juneau',58.4755,-134.1499),('99820','AK','Angoon','Hoonah-angoon Census Area',57.40931,-134.178295),('99821','AK','Auke Bay','Juneau',58.3833,-134.6597),('99824','AK','Douglas','Juneau Borough',58.27662,-134.397591),('99825','AK','Elfin Cove','Hoonah-angoon Census Area',58.149775,-135.906712),('99826','AK','Gustavus','Hoonah-angoon Census Area',58.772609,-136.463111),('99827','AK','Haines','Haines Borough',59.363174,-135.812078),('99829','AK','Hoonah','Hoonah-angoon Census Area',58.10633,-135.434636),('99830','AK','Kake','Petersburg Census Area',56.905399,-134.052125),('99832','AK','Pelican','Hoonah-angoon Census Area',57.961013,-136.232041),('99833','AK','Petersburg','Petersburg Census Area',56.840476,-133.187512),('99835','AK','Sitka','Sitka Borough',57.008443,-135.163006),('99836','AK','Port Alexander','Petersburg Census Area',56.249954,-134.646617),('99840','AK','Skagway','Skagway Municipality',59.465673,-135.313241),('99841','AK','Tenakee Springs','Hoonah-angoon Census Area',57.77892,-135.21035),('99850','AK','Juneau','Juneau',58.367814,-134.579312),('99901','AK','Ketchikan','Ketchikan Gateway Borough',55.352276,-131.655657),('99903','AK','Meyers Chuck','Wrangell City And Borough',55.740465,-132.252156),('99918','AK','Coffman Cove','Prince Of Wales-hyder Census Area',55.994457,-132.801177),('99919','AK','Thorne Bay','Prince Of Wales-hyder Census Area',55.660957,-132.517148),('99921','AK','Craig','Prince Of Wales-hyder Census Area',55.563473,-132.889554),('99922','AK','Hydaburg','Prince Of Wales-hyder Census Area',55.21387,-132.82735),('99923','AK','Hyder','Prince Of Wales-hyder Census Area',55.929531,-130.041222),('99925','AK','Klawock','Prince Of Wales-hyder Census Area',55.556707,-133.072064),('99926','AK','Metlakatla','Prince Of Wales-hyder Census Area',55.114699,-131.555726),('99927','AK','Point Baker','Prince Of Wales-hyder Census Area',56.290791,-133.58948),('99928','AK','Ward Cove','Ketchikan Gateway',55.4119,-131.7227),('99929','AK','Wrangell','Wrangell City And Borough',56.394933,-132.342253),('99950','AK','Ketchikan','Ketchikan Gateway',55.875767,-131.466339);
/*!40000 ALTER TABLE `zipcode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Temporary table structure for view `zipcodeall`
--

DROP TABLE IF EXISTS `zipcodeall`;
/*!50001 DROP VIEW IF EXISTS `zipcodeall`*/;
/*!50001 CREATE TABLE `zipcodeall` (
  `zip` char(10),
  `city` varchar(50),
  `county` varchar(50),
  `state` char(10)
) ENGINE=MyISAM */;

--
-- Table structure for table `zipcodealt`
--

DROP TABLE IF EXISTS `zipcodealt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zipcodealt` (
  `id` int(11) NOT NULL auto_increment,
  `zip` char(10) NOT NULL default '',
  `city` varchar(50) NOT NULL default '',
  `county` varchar(50) NOT NULL default '',
  `state` char(2) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `zip` (`zip`),
  KEY `citystate` (`city`,`state`)
) ENGINE=MyISAM AUTO_INCREMENT=24191 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zipcodealt`
--

LOCK TABLES `zipcodealt` WRITE;
/*!40000 ALTER TABLE `zipcodealt` DISABLE KEYS */;
INSERT INTO `zipcodealt` VALUES (1,'02861','','','MA'),(2,'03579','','','ME'),(3,'20135','','','WV'),(4,'21912','','','DE'),(5,'24604','','','WV'),(6,'30165','','','AL'),(7,'31905','','','AL'),(8,'38079','','','KY'),(9,'38326','','','MS'),(10,'38769','','','AR'),(11,'38852','','','AL'),(12,'42223','','','TN'),(13,'42602','','','TN'),(14,'45053','','','IN'),(15,'51001','','','SD'),(16,'51023','','','SD'),(17,'51360','','','MN'),(18,'51557','','','NE'),(19,'51640','','','MO'),(20,'52542','','','MO'),(21,'52573','','','MO'),(22,'52626','','','MO'),(23,'54540','','','MI'),(24,'54554','','','MI'),(25,'56027','','','IA'),(26,'56144','','','SD'),(27,'56164','','','SD'),(28,'56219','','','SD'),(29,'56744','','','ND'),(30,'57026','','','MN'),(31,'57030','','','MN'),(32,'57068','','','MN'),(33,'57078','','','NE'),(34,'57638','','','ND'),(35,'57641','','','ND'),(36,'57642','','','ND'),(37,'57645','','','ND'),(38,'57648','','','ND'),(39,'57660','','','ND'),(40,'57717','','','WY'),(41,'57724','','','MT'),(42,'58225','','','MN'),(43,'58439','','','ND'),(44,'58623','','','SD'),(45,'58649','','','SD'),(46,'58653','','','SD'),(47,'59221','','','ND'),(48,'59270','','','ND'),(49,'59275','','','ND'),(50,'59847','','','ID'),(51,'63673','','','IL'),(52,'65729','','','AR'),(53,'65733','','','AR'),(54,'65761','','','AR'),(55,'66541','','','NE'),(56,'67950','','','OK'),(57,'68325','','','KS'),(58,'68719','','','SD'),(59,'68978','','','KS'),(60,'69201','','','SD'),(61,'69212','','','SD'),(62,'69216','','','SD'),(63,'71749','','','LA'),(64,'72338','','','TN'),(65,'72644','','','MO'),(66,'73949','','','TX'),(67,'75556','','','AR'),(68,'79837','','','NM'),(69,'80758','','','NE'),(70,'81137','','','NM'),(71,'81324','','','UT'),(72,'82063','','','CO'),(73,'82082','','','NE'),(74,'82701','','','SD'),(75,'82930','','','UT'),(76,'83111','','','ID'),(77,'83120','','','ID'),(78,'83312','','','UT'),(79,'83342','','','UT'),(80,'84034','','','NV'),(81,'84531','','','AZ'),(82,'84536','','','AZ'),(83,'86044','','','UT'),(84,'86504','','','NM'),(85,'86514','','','UT'),(86,'86515','','','NM'),(87,'87328','','','AZ'),(88,'88063','','','TX'),(89,'88430','','','TX'),(90,'89010','','','CA'),(91,'89019','','','CA'),(92,'89060','','','CA'),(93,'89061','','','CA'),(94,'89421','','','OR'),(95,'89439','','','CA'),(96,'89832','','','ID'),(97,'97635','','','OR'),(98,'97910','','','ID'),(99,'97913','','','ID'),(100,'99128','','','ID'),(101,'99362','','','OR'),(102,'01002','','Franklin',''),(103,'01011','','Hampshire',''),(104,'01039','','Franklin',''),(105,'01050','','Hampden',''),(106,'01082','','Worcester',''),(107,'01434','','Middlesex',''),(108,'01940','','Middlesex',''),(109,'02149','','Suffolk',''),(110,'02215','','Norfolk',''),(111,'02467','','Middlesex',''),(112,'02467','','Suffolk',''),(113,'02532','','Plymouth',''),(114,'02543','','Dukes',''),(115,'02816','','Providence',''),(116,'02831','','Kent',''),(117,'02861','','Bristol',''),(118,'03103','','Rockingham',''),(119,'03104','','Merrimack',''),(120,'03220','','Merrimack',''),(121,'03225','','Strafford',''),(122,'03254','','Belknap',''),(123,'03276','','Belknap',''),(124,'03458','','Cheshire',''),(125,'03579','','Oxford',''),(126,'03602','','Sullivan',''),(127,'03748','','Sullivan',''),(128,'03887','','Carroll',''),(129,'04040','','Oxford',''),(130,'04224','','Franklin',''),(131,'04345','','Sagadahoc',''),(132,'04424','','Aroostook',''),(133,'04429','','Hancock',''),(134,'04451','','Aroostook',''),(135,'04459','','Aroostook',''),(136,'04460','','Aroostook',''),(137,'04462','','Piscataquis',''),(138,'04497','','Penobscot',''),(139,'04622','','Hancock',''),(140,'04732','','Piscataquis',''),(141,'04733','','Penobscot',''),(142,'04765','','Aroostook',''),(143,'04930','','Somerset',''),(144,'04942','','Piscataquis',''),(145,'04964','','Oxford',''),(146,'04988','','Kennebec',''),(147,'05060','','Washington',''),(148,'05060','','Windsor',''),(149,'05068','','Orange',''),(150,'05069','','Orange',''),(151,'05143','','Windham',''),(152,'05148','','Bennington',''),(153,'05148','','Windsor',''),(154,'05155','','Bennington',''),(155,'05253','','Rutland',''),(156,'05363','','Bennington',''),(157,'05444','','Lamoille',''),(158,'05461','','Addison',''),(159,'05464','','Franklin',''),(160,'05468','','Franklin',''),(161,'05471','','Orleans',''),(162,'05487','','Chittenden',''),(163,'05641','','Orange',''),(164,'05649','','Washington',''),(165,'05654','','Orange',''),(166,'05663','','Orange',''),(167,'05669','','Addison',''),(168,'05669','','Orange',''),(169,'05676','','Chittenden',''),(170,'05733','','Addison',''),(171,'05760','','Rutland',''),(172,'05767','','Rutland',''),(173,'05778','','Rutland',''),(174,'05824','','Caledonia',''),(175,'05837','','Caledonia',''),(176,'05842','','Caledonia',''),(177,'05843','','Washington',''),(178,'06059','','Litchfield',''),(179,'06065','','Litchfield',''),(180,'06226','','Tolland',''),(181,'06242','','Tolland',''),(182,'06250','','Windham',''),(183,'06330','','Windham',''),(184,'06384','','Windham',''),(185,'06415','','Middlesex',''),(186,'06420','','Middlesex',''),(187,'06451','','Hartford',''),(188,'06708','','Litchfield',''),(189,'06776','','Fairfield',''),(190,'06784','','Litchfield',''),(191,'07043','','Passaic',''),(192,'07060','','Somerset',''),(193,'07062','','Somerset',''),(194,'07063','','Somerset',''),(195,'07083','','Essex',''),(196,'07110','','Passaic',''),(197,'07421','','Sussex',''),(198,'07435','','Morris',''),(199,'07438','','Passaic',''),(200,'07460','','Morris',''),(201,'07460','','Passaic',''),(202,'07721','','Middlesex',''),(203,'07735','','Middlesex',''),(204,'07747','','Middlesex',''),(205,'07821','','Warren',''),(206,'07830','','Morris',''),(207,'07840','','Morris',''),(208,'07849','','Sussex',''),(209,'07860','','Warren',''),(210,'07865','','Hunterdon',''),(211,'07865','','Morris',''),(212,'07874','','Warren',''),(213,'07882','','Hunterdon',''),(214,'07920','','Morris',''),(215,'07931','','Morris',''),(216,'07979','','Somerset',''),(217,'08012','','Gloucester',''),(218,'08037','','Camden',''),(219,'08081','','Gloucester',''),(220,'08085','','Salem',''),(221,'08087','','Burlington',''),(222,'08094','','Atlantic',''),(223,'08215','','Burlington',''),(224,'08270','','Atlantic',''),(225,'08302','','Salem',''),(226,'08318','','Cumberland',''),(227,'08340','','Cumberland',''),(228,'08343','','Salem',''),(229,'08344','','Atlantic',''),(230,'08344','','Cumberland',''),(231,'08344','','Salem',''),(232,'08360','','Atlantic',''),(233,'08360','','Gloucester',''),(234,'08501','','Burlington',''),(235,'08501','','Mercer',''),(236,'08512','','Middlesex',''),(237,'08514','','Ocean',''),(238,'08525','','Hunterdon',''),(239,'08528','','Middlesex',''),(240,'08530','','Mercer',''),(241,'08540','','Middlesex',''),(242,'08540','','Somerset',''),(243,'08558','','Mercer',''),(244,'08610','','Burlington',''),(245,'08620','','Burlington',''),(246,'08691','','Monmouth',''),(247,'08724','','Monmouth',''),(248,'08802','','Warren',''),(249,'08804','','Warren',''),(250,'08812','','Somerset',''),(251,'08812','','Union',''),(252,'08827','','Warren',''),(253,'08853','','Hunterdon',''),(254,'08876','','Hunterdon',''),(255,'10463','','New York',''),(256,'10509','','Westchester',''),(257,'10537','','Westchester',''),(258,'10541','','Westchester',''),(259,'10588','','Putnam',''),(260,'10911','','Orange',''),(261,'10940','','Sullivan',''),(262,'11001','','Queens',''),(263,'11003','','Queens',''),(264,'11040','','Queens',''),(265,'11370','','Bronx',''),(266,'11425','','Kings',''),(267,'11735','','Suffolk',''),(268,'12010','','Fulton',''),(269,'12010','','Saratoga',''),(270,'12010','','Schenectady',''),(271,'12019','','Schenectady',''),(272,'12023','','Schoharie',''),(273,'12025','','Saratoga',''),(274,'12027','','Schenectady',''),(275,'12028','','Washington',''),(276,'12032','','Hamilton',''),(277,'12036','','Otsego',''),(278,'12043','','Otsego',''),(279,'12046','','Greene',''),(280,'12053','','Albany',''),(281,'12053','','Montgomery',''),(282,'12053','','Schoharie',''),(283,'12057','','Rensselaer',''),(284,'12062','','Columbia',''),(285,'12064','','Schoharie',''),(286,'12066','','Montgomery',''),(287,'12066','','Schenectady',''),(288,'12068','','Fulton',''),(289,'12070','','Fulton',''),(290,'12083','','Albany',''),(291,'12086','','Fulton',''),(292,'12086','','Saratoga',''),(293,'12087','','Albany',''),(294,'12093','','Delaware',''),(295,'12094','','Washington',''),(296,'12095','','Montgomery',''),(297,'12118','','Rensselaer',''),(298,'12120','','Greene',''),(299,'12122','','Albany',''),(300,'12134','','Hamilton',''),(301,'12134','','Saratoga',''),(302,'12137','','Montgomery',''),(303,'12143','','Greene',''),(304,'12154','','Washington',''),(305,'12155','','Delaware',''),(306,'12156','','Columbia',''),(307,'12157','','Albany',''),(308,'12157','','Schenectady',''),(309,'12166','','Schoharie',''),(310,'12167','','Schoharie',''),(311,'12184','','Rensselaer',''),(312,'12185','','Washington',''),(313,'12302','','Saratoga',''),(314,'12303','','Albany',''),(315,'12304','','Albany',''),(316,'12306','','Albany',''),(317,'12309','','Albany',''),(318,'12406','','Ulster',''),(319,'12430','','Greene',''),(320,'12441','','Delaware',''),(321,'12455','','Ulster',''),(322,'12458','','Sullivan',''),(323,'12465','','Delaware',''),(324,'12468','','Delaware',''),(325,'12469','','Greene',''),(326,'12469','','Schoharie',''),(327,'12480','','Greene',''),(328,'12483','','Sullivan',''),(329,'12531','','Putnam',''),(330,'12533','','Putnam',''),(331,'12542','','Orange',''),(332,'12546','','Columbia',''),(333,'12566','','Orange',''),(334,'12566','','Sullivan',''),(335,'12567','','Columbia',''),(336,'12571','','Columbia',''),(337,'12582','','Putnam',''),(338,'12583','','Columbia',''),(339,'12586','','Ulster',''),(340,'12589','','Orange',''),(341,'12721','','Orange',''),(342,'12725','','Sullivan',''),(343,'12729','','Sullivan',''),(344,'12740','','Ulster',''),(345,'12758','','Delaware',''),(346,'12758','','Ulster',''),(347,'12760','','Sullivan',''),(348,'12776','','Delaware',''),(349,'12780','','Sullivan',''),(350,'12785','','Orange',''),(351,'12804','','Washington',''),(352,'12808','','Essex',''),(353,'12828','','Saratoga',''),(354,'12835','','Warren',''),(355,'12836','','Essex',''),(356,'12844','','Warren',''),(357,'12847','','St. Lawrence',''),(358,'12853','','Essex',''),(359,'12857','','Warren',''),(360,'12870','','Warren',''),(361,'12912','','Essex',''),(362,'12912','','Franklin',''),(363,'12913','','Franklin',''),(364,'12914','','St. Lawrence',''),(365,'12920','','Clinton',''),(366,'12930','','St. Lawrence',''),(367,'12944','','Clinton',''),(368,'12955','','Franklin',''),(369,'12972','','Essex',''),(370,'12980','','St. Lawrence',''),(371,'12981','','Franklin',''),(372,'12983','','Essex',''),(373,'12986','','St. Lawrence',''),(374,'13021','','Onondaga',''),(375,'13027','','Cayuga',''),(376,'13030','','Onondaga',''),(377,'13035','','Onondaga',''),(378,'13037','','Onondaga',''),(379,'13040','','Chenango',''),(380,'13042','','Oneida',''),(381,'13045','','Cayuga',''),(382,'13045','','Tompkins',''),(383,'13052','','Chenango',''),(384,'13052','','Cortland',''),(385,'13052','','Onondaga',''),(386,'13053','','Cortland',''),(387,'13072','','Chenango',''),(388,'13073','','Cayuga',''),(389,'13074','','Cayuga',''),(390,'13077','','Cayuga',''),(391,'13077','','Onondaga',''),(392,'13080','','Cayuga',''),(393,'13082','','Onondaga',''),(394,'13083','','Jefferson',''),(395,'13092','','Tompkins',''),(396,'13104','','Madison',''),(397,'13111','','Oswego',''),(398,'13122','','Onondaga',''),(399,'13126','','Cayuga',''),(400,'13135','','Onondaga',''),(401,'13141','','Onondaga',''),(402,'13143','','Cayuga',''),(403,'13146','','Seneca',''),(404,'13152','','Cayuga',''),(405,'13156','','Oswego',''),(406,'13156','','Wayne',''),(407,'13158','','Onondaga',''),(408,'13159','','Cortland',''),(409,'13166','','Onondaga',''),(410,'13304','','Herkimer',''),(411,'13309','','Lewis',''),(412,'13316','','Lewis',''),(413,'13316','','Oswego',''),(414,'13317','','Otsego',''),(415,'13320','','Montgomery',''),(416,'13322','','Herkimer',''),(417,'13329','','Fulton',''),(418,'13332','','Chenango',''),(419,'13338','','Herkimer',''),(420,'13339','','Fulton',''),(421,'13339','','Herkimer',''),(422,'13357','','Otsego',''),(423,'13361','','Otsego',''),(424,'13367','','Herkimer',''),(425,'13402','','Oneida',''),(426,'13411','','Otsego',''),(427,'13413','','Herkimer',''),(428,'13421','','Oneida',''),(429,'13425','','Madison',''),(430,'13431','','Oneida',''),(431,'13437','','Lewis',''),(432,'13438','','Herkimer',''),(433,'13439','','Herkimer',''),(434,'13452','','Fulton',''),(435,'13456','','Herkimer',''),(436,'13459','','Montgomery',''),(437,'13459','','Otsego',''),(438,'13460','','Madison',''),(439,'13470','','Herkimer',''),(440,'13471','','Lewis',''),(441,'13480','','Madison',''),(442,'13485','','Chenango',''),(443,'13485','','Otsego',''),(444,'13489','','Oneida',''),(445,'13491','','Madison',''),(446,'13491','','Otsego',''),(447,'13502','','Herkimer',''),(448,'13601','','Lewis',''),(449,'13608','','St. Lawrence',''),(450,'13619','','Lewis',''),(451,'13626','','Jefferson',''),(452,'13642','','Jefferson',''),(453,'13646','','Jefferson',''),(454,'13648','','St. Lawrence',''),(455,'13655','','St. Lawrence',''),(456,'13661','','Oswego',''),(457,'13665','','Lewis',''),(458,'13679','','St. Lawrence',''),(459,'13682','','Lewis',''),(460,'13730','','Broome',''),(461,'13733','','Delaware',''),(462,'13733','','Otsego',''),(463,'13736','','Broome',''),(464,'13736','','Tompkins',''),(465,'13746','','Chenango',''),(466,'13754','','Delaware',''),(467,'13760','','Tioga',''),(468,'13778','','Broome',''),(469,'13787','','Chenango',''),(470,'13803','','Broome',''),(471,'13809','','Otsego',''),(472,'13811','','Broome',''),(473,'13813','','Chenango',''),(474,'13820','','Delaware',''),(475,'13825','','Delaware',''),(476,'13835','','Broome',''),(477,'13835','','Cortland',''),(478,'13838','','Otsego',''),(479,'13841','','Cortland',''),(480,'13843','','Otsego',''),(481,'13849','','Delaware',''),(482,'13862','','Cortland',''),(483,'13864','','Tompkins',''),(484,'14001','','Genesee',''),(485,'14001','','Niagara',''),(486,'14004','','Genesee',''),(487,'14004','','Wyoming',''),(488,'14009','','Cattaraugus',''),(489,'14011','','Genesee',''),(490,'14013','','Erie',''),(491,'14024','','Allegany',''),(492,'14030','','Cattaraugus',''),(493,'14030','','Wyoming',''),(494,'14037','','Erie',''),(495,'14040','','Wyoming',''),(496,'14054','','Wyoming',''),(497,'14058','','Orleans',''),(498,'14060','','Allegany',''),(499,'14065','','Allegany',''),(500,'14070','','Cattaraugus',''),(501,'14081','','Cattaraugus',''),(502,'14081','','Chautauqua',''),(503,'14105','','Genesee',''),(504,'14105','','Orleans',''),(505,'14125','','Orleans',''),(506,'14138','','Chautauqua',''),(507,'14141','','Cattaraugus',''),(508,'14145','','Erie',''),(509,'14414','','Monroe',''),(510,'14416','','Monroe',''),(511,'14418','','Steuben',''),(512,'14420','','Orleans',''),(513,'14422','','Orleans',''),(514,'14433','','Seneca',''),(515,'14437','','Steuben',''),(516,'14450','','Wayne',''),(517,'14456','','Seneca',''),(518,'14456','','Yates',''),(519,'14464','','Orleans',''),(520,'14466','','Livingston',''),(521,'14470','','Monroe',''),(522,'14471','','Livingston',''),(523,'14472','','Livingston',''),(524,'14472','','Ontario',''),(525,'14476','','Monroe',''),(526,'14482','','Livingston',''),(527,'14482','','Monroe',''),(528,'14485','','Ontario',''),(529,'14487','','Ontario',''),(530,'14489','','Ontario',''),(531,'14489','','Seneca',''),(532,'14502','','Monroe',''),(533,'14512','','Steuben',''),(534,'14512','','Yates',''),(535,'14513','','Ontario',''),(536,'14519','','Monroe',''),(537,'14522','','Ontario',''),(538,'14525','','Livingston',''),(539,'14525','','Wyoming',''),(540,'14532','','Seneca',''),(541,'14533','','Wyoming',''),(542,'14534','','Ontario',''),(543,'14536','','Allegany',''),(544,'14544','','Ontario',''),(545,'14560','','Ontario',''),(546,'14561','','Yates',''),(547,'14564','','Monroe',''),(548,'14572','','Livingston',''),(549,'14580','','Wayne',''),(550,'14591','','Genesee',''),(551,'14726','','Chautauqua',''),(552,'14727','','Cattaraugus',''),(553,'14735','','Wyoming',''),(554,'14738','','Cattaraugus',''),(555,'14747','','Cattaraugus',''),(556,'14770','','Allegany',''),(557,'14803','','Steuben',''),(558,'14804','','Steuben',''),(559,'14806','','Steuben',''),(560,'14807','','Allegany',''),(561,'14812','','Chemung',''),(562,'14812','','Steuben',''),(563,'14814','','Steuben',''),(564,'14815','','Steuben',''),(565,'14817','','Tioga',''),(566,'14822','','Livingston',''),(567,'14824','','Chemung',''),(568,'14830','','Chemung',''),(569,'14836','','Allegany',''),(570,'14837','','Schuyler',''),(571,'14837','','Steuben',''),(572,'14840','','Schuyler',''),(573,'14841','','Seneca',''),(574,'14843','','Allegany',''),(575,'14846','','Allegany',''),(576,'14859','','Chemung',''),(577,'14864','','Schuyler',''),(578,'14870','','Schuyler',''),(579,'14871','','Steuben',''),(580,'14877','','Allegany',''),(581,'14878','','Yates',''),(582,'14883','','Tompkins',''),(583,'14886','','Schuyler',''),(584,'14886','','Seneca',''),(585,'14889','','Schuyler',''),(586,'14889','','Tioga',''),(587,'14892','','Chemung',''),(588,'14897','','Steuben',''),(589,'15003','','Allegheny',''),(590,'15005','','Allegheny',''),(591,'15012','','Fayette',''),(592,'15012','','Washington',''),(593,'15017','','Washington',''),(594,'15025','','Washington',''),(595,'15026','','Allegheny',''),(596,'15026','','Washington',''),(597,'15044','','Butler',''),(598,'15057','','Allegheny',''),(599,'15063','','Allegheny',''),(600,'15068','','Allegheny',''),(601,'15085','','Allegheny',''),(602,'15086','','Butler',''),(603,'15089','','Allegheny',''),(604,'15126','','Washington',''),(605,'15129','','Washington',''),(606,'15131','','Westmoreland',''),(607,'15137','','Westmoreland',''),(608,'15143','','Beaver',''),(609,'15146','','Westmoreland',''),(610,'15241','','Washington',''),(611,'15322','','Washington',''),(612,'15329','','Greene',''),(613,'15332','','Allegheny',''),(614,'15345','','Greene',''),(615,'15370','','Washington',''),(616,'15377','','Greene',''),(617,'15417','','Washington',''),(618,'15424','','Fayette',''),(619,'15501','','Westmoreland',''),(620,'15531','','Westmoreland',''),(621,'15533','','Fulton',''),(622,'15534','','Somerset',''),(623,'15545','','Somerset',''),(624,'15557','','Fayette',''),(625,'15559','','Somerset',''),(626,'15610','','Fayette',''),(627,'15613','','Armstrong',''),(628,'15618','','Armstrong',''),(629,'15618','','Indiana',''),(630,'15622','','Somerset',''),(631,'15622','','Westmoreland',''),(632,'15642','','Allegheny',''),(633,'15656','','Armstrong',''),(634,'15666','','Fayette',''),(635,'15668','','Allegheny',''),(636,'15681','','Westmoreland',''),(637,'15683','','Fayette',''),(638,'15690','','Armstrong',''),(639,'15714','','Indiana',''),(640,'15717','','Westmoreland',''),(641,'15724','','Cambria',''),(642,'15724','','Clearfield',''),(643,'15732','','Armstrong',''),(644,'15742','','Clearfield',''),(645,'15757','','Indiana',''),(646,'15767','','Clearfield',''),(647,'15767','','Indiana',''),(648,'15774','','Armstrong',''),(649,'15823','','Jefferson',''),(650,'15824','','Clearfield',''),(651,'15828','','Forest',''),(652,'15829','','Clarion',''),(653,'15832','','Elk',''),(654,'15840','','Clearfield',''),(655,'15853','','Jefferson',''),(656,'15860','','Clarion',''),(657,'15860','','Elk',''),(658,'15864','','Clarion',''),(659,'15870','','Mc Kean',''),(660,'15905','','Somerset',''),(661,'15944','','Indiana',''),(662,'15946','','Bedford',''),(663,'15946','','Blair',''),(664,'15954','','Westmoreland',''),(665,'15957','','Cambria',''),(666,'15961','','Cambria',''),(667,'15963','','Cambria',''),(668,'16025','','Armstrong',''),(669,'16028','','Armstrong',''),(670,'16037','','Beaver',''),(671,'16037','','Lawrence',''),(672,'16038','','Venango',''),(673,'16041','','Armstrong',''),(674,'16046','','Allegheny',''),(675,'16049','','Armstrong',''),(676,'16049','','Butler',''),(677,'16051','','Lawrence',''),(678,'16055','','Allegheny',''),(679,'16055','','Armstrong',''),(680,'16057','','Lawrence',''),(681,'16057','','Mercer',''),(682,'16059','','Allegheny',''),(683,'16063','','Beaver',''),(684,'16110','','Mercer',''),(685,'16117','','Beaver',''),(686,'16120','','Beaver',''),(687,'16123','','Lawrence',''),(688,'16125','','Crawford',''),(689,'16127','','Butler',''),(690,'16127','','Lawrence',''),(691,'16127','','Venango',''),(692,'16134','','Mercer',''),(693,'16141','','Beaver',''),(694,'16142','','Mercer',''),(695,'16143','','Mercer',''),(696,'16153','','Venango',''),(697,'16156','','Mercer',''),(698,'16157','','Beaver',''),(699,'16159','','Lawrence',''),(700,'16217','','Jefferson',''),(701,'16222','','Indiana',''),(702,'16222','','Jefferson',''),(703,'16224','','Armstrong',''),(704,'16229','','Butler',''),(705,'16229','','Westmoreland',''),(706,'16232','','Venango',''),(707,'16240','','Armstrong',''),(708,'16240','','Jefferson',''),(709,'16242','','Armstrong',''),(710,'16311','','Venango',''),(711,'16314','','Mercer',''),(712,'16314','','Venango',''),(713,'16317','','Crawford',''),(714,'16319','','Clarion',''),(715,'16341','','Forest',''),(716,'16342','','Mercer',''),(717,'16347','','Forest',''),(718,'16351','','Forest',''),(719,'16353','','Clarion',''),(720,'16353','','Venango',''),(721,'16354','','Venango',''),(722,'16354','','Warren',''),(723,'16362','','Mercer',''),(724,'16364','','Clarion',''),(725,'16373','','Butler',''),(726,'16373','','Clarion',''),(727,'16401','','Crawford',''),(728,'16403','','Erie',''),(729,'16407','','Crawford',''),(730,'16407','','Warren',''),(731,'16412','','Crawford',''),(732,'16434','','Warren',''),(733,'16435','','Erie',''),(734,'16438','','Crawford',''),(735,'16441','','Crawford',''),(736,'16613','','Blair',''),(737,'16625','','Bedford',''),(738,'16627','','Cambria',''),(739,'16636','','Blair',''),(740,'16639','','Clearfield',''),(741,'16641','','Blair',''),(742,'16646','','Clearfield',''),(743,'16655','','Blair',''),(744,'16657','','Bedford',''),(745,'16662','','Bedford',''),(746,'16666','','Centre',''),(747,'16673','','Bedford',''),(748,'16674','','Fulton',''),(749,'16678','','Huntingdon',''),(750,'16686','','Centre',''),(751,'16686','','Huntingdon',''),(752,'16694','','Fulton',''),(753,'16694','','Huntingdon',''),(754,'16701','','Warren',''),(755,'16720','','Cameron',''),(756,'16720','','Mc Kean',''),(757,'16735','','Elk',''),(758,'16743','','Potter',''),(759,'16748','','Mc Kean',''),(760,'16822','','Centre',''),(761,'16841','','Clinton',''),(762,'16845','','Centre',''),(763,'16860','','Centre',''),(764,'16865','','Huntingdon',''),(765,'16866','','Clearfield',''),(766,'16871','','Clinton',''),(767,'16872','','Clinton',''),(768,'16877','','Centre',''),(769,'16914','','Tioga',''),(770,'16930','','Lycoming',''),(771,'16936','','Bradford',''),(772,'16938','','Lycoming',''),(773,'16943','','Potter',''),(774,'16947','','Tioga',''),(775,'16950','','Potter',''),(776,'17002','','Huntingdon',''),(777,'17011','','York',''),(778,'17017','','Dauphin',''),(779,'17019','','Adams',''),(780,'17019','','Cumberland',''),(781,'17020','','Dauphin',''),(782,'17021','','Franklin',''),(783,'17021','','Perry',''),(784,'17022','','Dauphin',''),(785,'17026','','Berks',''),(786,'17028','','Lebanon',''),(787,'17033','','Lebanon',''),(788,'17035','','Perry',''),(789,'17045','','Juniata',''),(790,'17045','','Snyder',''),(791,'17053','','Cumberland',''),(792,'17055','','York',''),(793,'17062','','Juniata',''),(794,'17063','','Snyder',''),(795,'17066','','Mifflin',''),(796,'17067','','Berks',''),(797,'17070','','York',''),(798,'17073','','Lancaster',''),(799,'17078','','Dauphin',''),(800,'17086','','Snyder',''),(801,'17087','','Berks',''),(802,'17215','','Huntingdon',''),(803,'17222','','Adams',''),(804,'17224','','Fulton',''),(805,'17229','','Huntingdon',''),(806,'17236','','Fulton',''),(807,'17240','','Franklin',''),(808,'17243','','Juniata',''),(809,'17257','','Franklin',''),(810,'17264','','Fulton',''),(811,'17301','','York',''),(812,'17307','','Cumberland',''),(813,'17316','','York',''),(814,'17324','','Adams',''),(815,'17331','','Adams',''),(816,'17372','','York',''),(817,'17527','','Chester',''),(818,'17545','','Lebanon',''),(819,'17555','','Berks',''),(820,'17569','','Berks',''),(821,'17701','','Sullivan',''),(822,'17724','','Lycoming',''),(823,'17724','','Tioga',''),(824,'17727','','Tioga',''),(825,'17729','','Potter',''),(826,'17737','','Sullivan',''),(827,'17740','','Clinton',''),(828,'17745','','Lycoming',''),(829,'17756','','Columbia',''),(830,'17756','','Montour',''),(831,'17756','','Northumberland',''),(832,'17758','','Lycoming',''),(833,'17765','','Lycoming',''),(834,'17772','','Montour',''),(835,'17774','','Columbia',''),(836,'17774','','Sullivan',''),(837,'17777','','Montour',''),(838,'17810','','Lycoming',''),(839,'17814','','Luzerne',''),(840,'17814','','Lycoming',''),(841,'17814','','Sullivan',''),(842,'17815','','Luzerne',''),(843,'17815','','Montour',''),(844,'17820','','Montour',''),(845,'17821','','Columbia',''),(846,'17821','','Northumberland',''),(847,'17824','','Columbia',''),(848,'17841','','Snyder',''),(849,'17846','','Lycoming',''),(850,'17847','','Montour',''),(851,'17853','','Juniata',''),(852,'17870','','Union',''),(853,'17878','','Luzerne',''),(854,'17889','','Snyder',''),(855,'17921','','Columbia',''),(856,'17941','','Northumberland',''),(857,'17945','','Schuylkill',''),(858,'17963','','Lebanon',''),(859,'17964','','Northumberland',''),(860,'17980','','Dauphin',''),(861,'17985','','Columbia',''),(862,'18011','','Berks',''),(863,'18015','','Lehigh',''),(864,'18016','','Lehigh',''),(865,'18017','','Lehigh',''),(866,'18018','','Northampton',''),(867,'18031','','Berks',''),(868,'18032','','Northampton',''),(869,'18036','','Bucks',''),(870,'18041','','Berks',''),(871,'18041','','Bucks',''),(872,'18041','','Lehigh',''),(873,'18054','','Bucks',''),(874,'18055','','Bucks',''),(875,'18058','','Carbon',''),(876,'18062','','Berks',''),(877,'18070','','Berks',''),(878,'18071','','Monroe',''),(879,'18073','','Bucks',''),(880,'18077','','Northampton',''),(881,'18092','','Berks',''),(882,'18109','','Northampton',''),(883,'18201','','Carbon',''),(884,'18201','','Schuylkill',''),(885,'18202','','Schuylkill',''),(886,'18210','','Monroe',''),(887,'18211','','Carbon',''),(888,'18216','','Luzerne',''),(889,'18237','','Carbon',''),(890,'18240','','Schuylkill',''),(891,'18241','','Luzerne',''),(892,'18244','','Luzerne',''),(893,'18255','','Luzerne',''),(894,'18302','','Pike',''),(895,'18324','','Monroe',''),(896,'18325','','Pike',''),(897,'18405','','Pike',''),(898,'18407','','Susquehanna',''),(899,'18414','','Wyoming',''),(900,'18419','','Lackawanna',''),(901,'18419','','Susquehanna',''),(902,'18421','','Lackawanna',''),(903,'18421','','Wayne',''),(904,'18424','','Luzerne',''),(905,'18424','','Monroe',''),(906,'18424','','Wayne',''),(907,'18428','','Wayne',''),(908,'18436','','Lackawanna',''),(909,'18444','','Wayne',''),(910,'18445','','Pike',''),(911,'18446','','Lackawanna',''),(912,'18446','','Susquehanna',''),(913,'18460','','Pike',''),(914,'18465','','Wayne',''),(915,'18470','','Wayne',''),(916,'18603','','Luzerne',''),(917,'18610','','Carbon',''),(918,'18610','','Luzerne',''),(919,'18612','','Wyoming',''),(920,'18614','','Wyoming',''),(921,'18615','','Lackawanna',''),(922,'18615','','Luzerne',''),(923,'18618','','Wyoming',''),(924,'18623','','Bradford',''),(925,'18623','','Susquehanna',''),(926,'18630','','Susquehanna',''),(927,'18635','','Columbia',''),(928,'18636','','Luzerne',''),(929,'18641','','Lackawanna',''),(930,'18655','','Columbia',''),(931,'18661','','Carbon',''),(932,'18830','','Bradford',''),(933,'18833','','Sullivan',''),(934,'18844','','Wyoming',''),(935,'18847','','Wayne',''),(936,'18951','','Lehigh',''),(937,'18964','','Bucks',''),(938,'18969','','Bucks',''),(939,'19003','','Delaware',''),(940,'19006','','Bucks',''),(941,'19010','','Montgomery',''),(942,'19040','','Bucks',''),(943,'19041','','Montgomery',''),(944,'19073','','Chester',''),(945,'19083','','Montgomery',''),(946,'19085','','Montgomery',''),(947,'19087','','Delaware',''),(948,'19087','','Montgomery',''),(949,'19096','','Delaware',''),(950,'19118','','Montgomery',''),(951,'19150','','Montgomery',''),(952,'19310','','Lancaster',''),(953,'19312','','Delaware',''),(954,'19317','','Chester',''),(955,'19319','','Chester',''),(956,'19342','','Chester',''),(957,'19344','','Lancaster',''),(958,'19362','','Lancaster',''),(959,'19363','','Lancaster',''),(960,'19382','','Delaware',''),(961,'19440','','Bucks',''),(962,'19460','','Montgomery',''),(963,'19464','','Berks',''),(964,'19504','','Montgomery',''),(965,'19505','','Montgomery',''),(966,'19512','','Montgomery',''),(967,'19520','','Berks',''),(968,'19529','','Lehigh',''),(969,'19530','','Lehigh',''),(970,'19539','','Lehigh',''),(971,'19540','','Lancaster',''),(972,'19543','','Chester',''),(973,'19543','','Lancaster',''),(974,'19551','','Lancaster',''),(975,'19551','','Lebanon',''),(976,'19938','','New Castle',''),(977,'19950','','Kent',''),(978,'19952','','Sussex',''),(979,'19963','','Kent',''),(980,'19977','','New Castle',''),(981,'20106','','Fauquier',''),(982,'20106','','Rappahannock',''),(983,'20109','','Manassas City',''),(984,'20110','','Prince William',''),(985,'20117','','Fauquier',''),(986,'20120','','Loudoun',''),(987,'20130','','Fauquier',''),(988,'20135','','Loudoun',''),(989,'20135','','Jefferson',''),(990,'20137','','Prince William',''),(991,'20181','','Fauquier',''),(992,'20184','','Loudoun',''),(993,'20186','','Culpeper',''),(994,'20601','','Prince Georges',''),(995,'20607','','Charles',''),(996,'20613','','Charles',''),(997,'20622','','St. Marys',''),(998,'20659','','Charles',''),(999,'20701','','Anne Arundel',''),(1000,'20705','','Montgomery',''),(1001,'20707','','Montgomery',''),(1002,'20714','','Anne Arundel',''),(1003,'20736','','Anne Arundel',''),(1004,'20754','','Anne Arundel',''),(1005,'20777','','Montgomery',''),(1006,'20794','','Anne Arundel',''),(1007,'20833','','Howard',''),(1008,'20842','','Frederick',''),(1009,'20871','','Frederick',''),(1010,'20903','','Prince Georges',''),(1011,'20904','','Prince Georges',''),(1012,'20912','','Prince Georges',''),(1013,'21013','','Harford',''),(1014,'21043','','Baltimore',''),(1015,'21074','','Baltimore',''),(1016,'21076','','Howard',''),(1017,'21082','','Harford',''),(1018,'21085','','Baltimore',''),(1019,'21087','','Harford',''),(1020,'21102','','Baltimore',''),(1021,'21104','','Baltimore',''),(1022,'21104','','Howard',''),(1023,'21111','','Harford',''),(1024,'21136','','Carroll',''),(1025,'21155','','Carroll',''),(1026,'21161','','Baltimore',''),(1027,'21163','','Baltimore',''),(1028,'21206','','Baltimore',''),(1029,'21207','','Baltimore City',''),(1030,'21208','','Baltimore City',''),(1031,'21209','','Baltimore City',''),(1032,'21210','','Baltimore',''),(1033,'21212','','Baltimore',''),(1034,'21215','','Baltimore',''),(1035,'21222','','Baltimore City',''),(1036,'21224','','Baltimore',''),(1037,'21225','','Anne Arundel',''),(1038,'21226','','Baltimore City',''),(1039,'21227','','Baltimore City',''),(1040,'21228','','Baltimore City',''),(1041,'21229','','Baltimore',''),(1042,'21234','','Baltimore City',''),(1043,'21236','','Baltimore City',''),(1044,'21237','','Baltimore City',''),(1045,'21239','','Baltimore',''),(1046,'21521','','Garrett',''),(1047,'21532','','Garrett',''),(1048,'21539','','Garrett',''),(1049,'21562','','Garrett',''),(1050,'21620','','Queen Annes',''),(1051,'21632','','Dorchester',''),(1052,'21640','','Queen Annes',''),(1053,'21649','','Queen Annes',''),(1054,'21651','','Queen Annes',''),(1055,'21657','','Talbot',''),(1056,'21719','','Frederick',''),(1057,'21757','','Carroll',''),(1058,'21758','','Washington',''),(1059,'21769','','Washington',''),(1060,'21771','','Carroll',''),(1061,'21771','','Howard',''),(1062,'21771','','Montgomery',''),(1063,'21776','','Frederick',''),(1064,'21780','','Washington',''),(1065,'21783','','Frederick',''),(1066,'21784','','Howard',''),(1067,'21787','','Frederick',''),(1068,'21791','','Frederick',''),(1069,'21797','','Carroll',''),(1070,'21804','','Worcester',''),(1071,'21822','','Wicomico',''),(1072,'21822','','Worcester',''),(1073,'21851','','Somerset',''),(1074,'21912','','New Castle',''),(1075,'22042','','Falls Church City',''),(1076,'22044','','Falls Church City',''),(1077,'22046','','Fairfax',''),(1078,'22066','','Loudoun',''),(1079,'22101','','Arlington',''),(1080,'22134','','Stafford',''),(1081,'22205','','Falls Church City',''),(1082,'22206','','Alexandria City',''),(1083,'22207','','Fairfax',''),(1084,'22302','','Fairfax',''),(1085,'22304','','Fairfax',''),(1086,'22311','','Fairfax',''),(1087,'22312','','Alexandria City',''),(1088,'22406','','Fauquier',''),(1089,'22408','','Caroline',''),(1090,'22435','','Richmond',''),(1091,'22435','','Westmoreland',''),(1092,'22437','','King And Queen',''),(1093,'22473','','Lancaster',''),(1094,'22482','','Northumberland',''),(1095,'22485','','Westmoreland',''),(1096,'22504','','Middlesex',''),(1097,'22508','','Spotsylvania',''),(1098,'22514','','King And Queen',''),(1099,'22546','','Hanover',''),(1100,'22560','','King And Queen',''),(1101,'22572','','Westmoreland',''),(1102,'22580','','Spotsylvania',''),(1103,'22601','','Frederick',''),(1104,'22623','','Warren',''),(1105,'22630','','Clarke',''),(1106,'22630','','Fauquier',''),(1107,'22630','','Frederick',''),(1108,'22642','','Fauquier',''),(1109,'22645','','Warren',''),(1110,'22654','','Shenandoah',''),(1111,'22655','','Warren',''),(1112,'22657','','Warren',''),(1113,'22663','','Clarke',''),(1114,'22701','','Madison',''),(1115,'22701','','Orange',''),(1116,'22713','','Rappahannock',''),(1117,'22733','','Madison',''),(1118,'22733','','Orange',''),(1119,'22734','','Culpeper',''),(1120,'22735','','Madison',''),(1121,'22740','','Culpeper',''),(1122,'22740','','Madison',''),(1123,'22801','','Rockingham',''),(1124,'22802','','Rockingham',''),(1125,'22812','','Augusta',''),(1126,'22815','','Shenandoah',''),(1127,'22827','','Page',''),(1128,'22835','','Madison',''),(1129,'22841','','Augusta',''),(1130,'22844','','Rockingham',''),(1131,'22849','','Rockingham',''),(1132,'22853','','Shenandoah',''),(1133,'22901','','Charlottesville City',''),(1134,'22902','','Albemarle',''),(1135,'22903','','Albemarle',''),(1136,'22904','','Charlottesville City',''),(1137,'22920','','Albemarle',''),(1138,'22920','','Augusta',''),(1139,'22922','','Amherst',''),(1140,'22923','','Albemarle',''),(1141,'22923','','Orange',''),(1142,'22935','','Albemarle',''),(1143,'22938','','Albemarle',''),(1144,'22940','','Greene',''),(1145,'22942','','Albemarle',''),(1146,'22942','','Orange',''),(1147,'22947','','Fluvanna',''),(1148,'22947','','Louisa',''),(1149,'22958','','Augusta',''),(1150,'22960','','Madison',''),(1151,'22960','','Spotsylvania',''),(1152,'22967','','Amherst',''),(1153,'22968','','Albemarle',''),(1154,'22969','','Albemarle',''),(1155,'22973','','Madison',''),(1156,'22974','','Albemarle',''),(1157,'22974','','Louisa',''),(1158,'22980','','Augusta',''),(1159,'23002','','Nottoway',''),(1160,'23015','','Caroline',''),(1161,'23015','','Louisa',''),(1162,'23015','','Spotsylvania',''),(1163,'23024','','Hanover',''),(1164,'23024','','Spotsylvania',''),(1165,'23030','','Henrico',''),(1166,'23038','','Cumberland',''),(1167,'23038','','Fluvanna',''),(1168,'23040','','Buckingham',''),(1169,'23047','','Caroline',''),(1170,'23050','','Gloucester',''),(1171,'23059','','Hanover',''),(1172,'23065','','Louisa',''),(1173,'23069','','Caroline',''),(1174,'23069','','King William',''),(1175,'23083','','Nottoway',''),(1176,'23084','','Goochland',''),(1177,'23084','','Louisa',''),(1178,'23089','','James City',''),(1179,'23093','','Fluvanna',''),(1180,'23093','','Goochland',''),(1181,'23102','','Hanover',''),(1182,'23102','','Louisa',''),(1183,'23113','','Powhatan',''),(1184,'23117','','Goochland',''),(1185,'23117','','Spotsylvania',''),(1186,'23120','','Powhatan',''),(1187,'23123','','Cumberland',''),(1188,'23128','','Gloucester',''),(1189,'23139','','Cumberland',''),(1190,'23140','','Charles City',''),(1191,'23146','','Goochland',''),(1192,'23148','','Essex',''),(1193,'23149','','Gloucester',''),(1194,'23149','','King And Queen',''),(1195,'23160','','Goochland',''),(1196,'23177','','King William',''),(1197,'23181','','New Kent',''),(1198,'23185','','Charles City',''),(1199,'23185','','York',''),(1200,'23185','','Williamsburg City',''),(1201,'23188','','York',''),(1202,'23188','','Williamsburg City',''),(1203,'23192','','Louisa',''),(1204,'23222','','Henrico',''),(1205,'23223','','Richmond City',''),(1206,'23224','','Chesterfield',''),(1207,'23225','','Chesterfield',''),(1208,'23226','','Henrico',''),(1209,'23227','','Richmond City',''),(1210,'23230','','Richmond City',''),(1211,'23231','','Charles City',''),(1212,'23231','','Richmond City',''),(1213,'23233','','Goochland',''),(1214,'23234','','Richmond City',''),(1215,'23235','','Richmond City',''),(1216,'23238','','Goochland',''),(1217,'23321','','Suffolk City',''),(1218,'23602','','York',''),(1219,'23603','','York',''),(1220,'23605','','Hampton City',''),(1221,'23665','','Hampton City',''),(1222,'23803','','Chesterfield',''),(1223,'23803','','Dinwiddie',''),(1224,'23805','','Dinwiddie',''),(1225,'23805','','Prince George',''),(1226,'23824','','Brunswick',''),(1227,'23824','','Dinwiddie',''),(1228,'23824','','Lunenburg',''),(1229,'23830','','Dinwiddie',''),(1230,'23830','','Sussex',''),(1231,'23833','','Amelia',''),(1232,'23834','','Chesterfield',''),(1233,'23837','','Sussex',''),(1234,'23842','','Surry',''),(1235,'23842','','Sussex',''),(1236,'23847','','Brunswick',''),(1237,'23847','','Southampton',''),(1238,'23847','','Sussex',''),(1239,'23850','','Amelia',''),(1240,'23851','','Isle Of Wight',''),(1241,'23851','','Southampton',''),(1242,'23856','','Greensville',''),(1243,'23860','','Prince George',''),(1244,'23866','','Isle Of Wight',''),(1245,'23867','','Sussex',''),(1246,'23881','','Prince George',''),(1247,'23882','','Dinwiddie',''),(1248,'23888','','Southampton',''),(1249,'23888','','Surry',''),(1250,'23890','','Surry',''),(1251,'23898','','Southampton',''),(1252,'23901','','Buckingham',''),(1253,'23901','','Cumberland',''),(1254,'23919','','Brunswick',''),(1255,'23920','','Lunenburg',''),(1256,'23920','','Mecklenburg',''),(1257,'23922','','Prince Edward',''),(1258,'23923','','Prince Edward',''),(1259,'23924','','Charlotte',''),(1260,'23924','','Lunenburg',''),(1261,'23934','','Prince Edward',''),(1262,'23936','','Cumberland',''),(1263,'23937','','Lunenburg',''),(1264,'23938','','Lunenburg',''),(1265,'23942','','Lunenburg',''),(1266,'23947','','Lunenburg',''),(1267,'23947','','Prince Edward',''),(1268,'23950','','Brunswick',''),(1269,'23954','','Lunenburg',''),(1270,'23958','','Charlotte',''),(1271,'23958','','Prince Edward',''),(1272,'23960','','Appomattox',''),(1273,'23962','','Halifax',''),(1274,'23963','','Appomattox',''),(1275,'23963','','Campbell',''),(1276,'23964','','Mecklenburg',''),(1277,'23966','','Amelia',''),(1278,'23970','','Lunenburg',''),(1279,'24012','','Botetourt',''),(1280,'24012','','Roanoke',''),(1281,'24014','','Roanoke',''),(1282,'24015','','Roanoke',''),(1283,'24018','','Roanoke City',''),(1284,'24018','','Salem City',''),(1285,'24019','','Botetourt',''),(1286,'24019','','Roanoke City',''),(1287,'24053','','Carroll',''),(1288,'24054','','Pittsylvania',''),(1289,'24055','','Franklin',''),(1290,'24055','','Patrick',''),(1291,'24059','','Franklin',''),(1292,'24064','','Bedford',''),(1293,'24065','','Roanoke',''),(1294,'24066','','Rockbridge',''),(1295,'24070','','Craig',''),(1296,'24070','','Montgomery',''),(1297,'24079','','Franklin',''),(1298,'24084','','Bland',''),(1299,'24085','','Alleghany',''),(1300,'24087','','Roanoke',''),(1301,'24088','','Patrick',''),(1302,'24091','','Franklin',''),(1303,'24091','','Patrick',''),(1304,'24101','','Bedford',''),(1305,'24102','','Henry',''),(1306,'24105','','Carroll',''),(1307,'24112','','Franklin',''),(1308,'24120','','Carroll',''),(1309,'24120','','Floyd',''),(1310,'24121','','Franklin',''),(1311,'24124','','Bland',''),(1312,'24128','','Craig',''),(1313,'24137','','Pittsylvania',''),(1314,'24138','','Floyd',''),(1315,'24139','','Bedford',''),(1316,'24141','','Floyd',''),(1317,'24141','','Montgomery',''),(1318,'24141','','Pulaski',''),(1319,'24149','','Floyd',''),(1320,'24153','','Botetourt',''),(1321,'24153','','Roanoke',''),(1322,'24162','','Floyd',''),(1323,'24165','','Patrick',''),(1324,'24175','','Roanoke',''),(1325,'24179','','Bedford',''),(1326,'24202','','Scott',''),(1327,'24202','','Bristol City',''),(1328,'24217','','Buchanan',''),(1329,'24219','','Lee',''),(1330,'24221','','Scott',''),(1331,'24230','','Dickenson',''),(1332,'24230','','Scott',''),(1333,'24237','','Russell',''),(1334,'24244','','Lee',''),(1335,'24256','','Buchanan',''),(1336,'24258','','Washington',''),(1337,'24260','','Buchanan',''),(1338,'24273','','Wise',''),(1339,'24283','','Dickenson',''),(1340,'24283','','Russell',''),(1341,'24312','','Wythe',''),(1342,'24313','','Pulaski',''),(1343,'24314','','Tazewell',''),(1344,'24315','','Giles',''),(1345,'24318','','Smyth',''),(1346,'24319','','Washington',''),(1347,'24324','','Wythe',''),(1348,'24330','','Carroll',''),(1349,'24333','','Carroll',''),(1350,'24333','','Grayson',''),(1351,'24343','','Patrick',''),(1352,'24343','','Wythe',''),(1353,'24347','','Carroll',''),(1354,'24347','','Montgomery',''),(1355,'24350','','Carroll',''),(1356,'24350','','Grayson',''),(1357,'24352','','Floyd',''),(1358,'24368','','Smyth',''),(1359,'24370','','Washington',''),(1360,'24378','','Smyth',''),(1361,'24380','','Carroll',''),(1362,'24401','','Augusta',''),(1363,'24416','','Rockbridge',''),(1364,'24422','','Botetourt',''),(1365,'24432','','Bath',''),(1366,'24439','','Augusta',''),(1367,'24441','','Augusta',''),(1368,'24445','','Alleghany',''),(1369,'24459','','Rockbridge',''),(1370,'24472','','Augusta',''),(1371,'24482','','Staunton City',''),(1372,'24483','','Amherst',''),(1373,'24484','','Highland',''),(1374,'24486','','Rockingham',''),(1375,'24487','','Highland',''),(1376,'24501','','Campbell',''),(1377,'24502','','Bedford',''),(1378,'24502','','Campbell',''),(1379,'24503','','Bedford',''),(1380,'24504','','Appomattox',''),(1381,'24504','','Campbell',''),(1382,'24521','','Nelson',''),(1383,'24522','','Buckingham',''),(1384,'24526','','Amherst',''),(1385,'24528','','Charlotte',''),(1386,'24530','','Henry',''),(1387,'24538','','Appomattox',''),(1388,'24540','','Pittsylvania',''),(1389,'24541','','Pittsylvania',''),(1390,'24550','','Bedford',''),(1391,'24551','','Campbell',''),(1392,'24551','','Lynchburg City',''),(1393,'24553','','Amherst',''),(1394,'24553','','Appomattox',''),(1395,'24553','','Buckingham',''),(1396,'24557','','Halifax',''),(1397,'24562','','Albemarle',''),(1398,'24562','','Nelson',''),(1399,'24565','','Halifax',''),(1400,'24569','','Campbell',''),(1401,'24569','','Halifax',''),(1402,'24571','','Bedford',''),(1403,'24590','','Buckingham',''),(1404,'24590','','Fluvanna',''),(1405,'24594','','Halifax',''),(1406,'24597','','Pittsylvania',''),(1407,'24598','','Mecklenburg',''),(1408,'24599','','Nelson',''),(1409,'24604','','Mcdowell',''),(1410,'24607','','Dickenson',''),(1411,'24609','','Russell',''),(1412,'24622','','Tazewell',''),(1413,'24639','','Buchanan',''),(1414,'24639','','Russell',''),(1415,'24649','','Buchanan',''),(1416,'24736','','Wyoming',''),(1417,'24801','','Wyoming',''),(1418,'24828','','Wyoming',''),(1419,'24846','','Mcdowell',''),(1420,'24851','','Wyoming',''),(1421,'24910','','Monroe',''),(1422,'24910','','Summers',''),(1423,'24918','','Summers',''),(1424,'24925','','Monroe',''),(1425,'24963','','Summers',''),(1426,'24970','','Monroe',''),(1427,'24976','','Greenbrier',''),(1428,'24981','','Monroe',''),(1429,'24986','','Pocahontas',''),(1430,'25003','','Kanawha',''),(1431,'25036','','Kanawha',''),(1432,'25043','','Nicholas',''),(1433,'25045','','Clay',''),(1434,'25045','','Roane',''),(1435,'25047','','Boone',''),(1436,'25059','','Nicholas',''),(1437,'25063','','Clay',''),(1438,'25063','','Nicholas',''),(1439,'25071','','Roane',''),(1440,'25082','','Mason',''),(1441,'25083','','Fayette',''),(1442,'25108','','Logan',''),(1443,'25111','','Nicholas',''),(1444,'25123','','Putnam',''),(1445,'25124','','Jackson',''),(1446,'25124','','Kanawha',''),(1447,'25125','','Nicholas',''),(1448,'25136','','Kanawha',''),(1449,'25143','','Putnam',''),(1450,'25164','','Roane',''),(1451,'25177','','Putnam',''),(1452,'25202','','Lincoln',''),(1453,'25209','','Raleigh',''),(1454,'25235','','Clay',''),(1455,'25239','','Mason',''),(1456,'25241','','Mason',''),(1457,'25244','','Roane',''),(1458,'25245','','Putnam',''),(1459,'25248','','Kanawha',''),(1460,'25252','','Roane',''),(1461,'25252','','Wirt',''),(1462,'25264','','Mason',''),(1463,'25267','','Calhoun',''),(1464,'25422','','Hampshire',''),(1465,'25427','','Morgan',''),(1466,'25430','','Berkeley',''),(1467,'25434','','Morgan',''),(1468,'25443','','Berkeley',''),(1469,'25504','','Wayne',''),(1470,'25505','','Lincoln',''),(1471,'25506','','Cabell',''),(1472,'25508','','Boone',''),(1473,'25510','','Lincoln',''),(1474,'25510','','Putnam',''),(1475,'25520','','Cabell',''),(1476,'25523','','Putnam',''),(1477,'25524','','Logan',''),(1478,'25526','','Mason',''),(1479,'25529','','Lincoln',''),(1480,'25534','','Lincoln',''),(1481,'25541','','Mason',''),(1482,'25565','','Boone',''),(1483,'25650','','Logan',''),(1484,'25674','','Wayne',''),(1485,'25701','','Wayne',''),(1486,'25704','','Cabell',''),(1487,'25811','','Raleigh',''),(1488,'25825','','Summers',''),(1489,'25841','','Summers',''),(1490,'25864','','Raleigh',''),(1491,'25880','','Fayette',''),(1492,'25902','','Mercer',''),(1493,'25951','','Raleigh',''),(1494,'25962','','Fayette',''),(1495,'25976','','Greenbrier',''),(1496,'25976','','Summers',''),(1497,'25979','','Mercer',''),(1498,'25981','','Nicholas',''),(1499,'26003','','Brooke',''),(1500,'26003','','Marshall',''),(1501,'26055','','Wetzel',''),(1502,'26062','','Brooke',''),(1503,'26137','','Gilmer',''),(1504,'26137','','Ritchie',''),(1505,'26141','','Wirt',''),(1506,'26143','','Calhoun',''),(1507,'26143','','Jackson',''),(1508,'26143','','Ritchie',''),(1509,'26143','','Wood',''),(1510,'26146','','Pleasants',''),(1511,'26155','','Marshall',''),(1512,'26155','','Tyler',''),(1513,'26159','','Tyler',''),(1514,'26161','','Wirt',''),(1515,'26164','','Wood',''),(1516,'26170','','Ritchie',''),(1517,'26180','','Wirt',''),(1518,'26184','','Pleasants',''),(1519,'26201','','Barbour',''),(1520,'26201','','Lewis',''),(1521,'26208','','Nicholas',''),(1522,'26224','','Upshur',''),(1523,'26238','','Upshur',''),(1524,'26250','','Randolph',''),(1525,'26261','','Greenbrier',''),(1526,'26263','','Tucker',''),(1527,'26267','','Barbour',''),(1528,'26267','','Upshur',''),(1529,'26276','','Tucker',''),(1530,'26283','','Barbour',''),(1531,'26283','','Tucker',''),(1532,'26330','','Barbour',''),(1533,'26330','','Taylor',''),(1534,'26335','','Gilmer',''),(1535,'26343','','Upshur',''),(1536,'26346','','Pleasants',''),(1537,'26347','','Barbour',''),(1538,'26354','','Marion',''),(1539,'26374','','Monongalia',''),(1540,'26374','','Taylor',''),(1541,'26376','','Braxton',''),(1542,'26377','','Tyler',''),(1543,'26378','','Harrison',''),(1544,'26384','','Lewis',''),(1545,'26405','','Preston',''),(1546,'26412','','Braxton',''),(1547,'26412','','Gilmer',''),(1548,'26415','','Doddridge',''),(1549,'26415','','Tyler',''),(1550,'26426','','Doddridge',''),(1551,'26431','','Taylor',''),(1552,'26437','','Marion',''),(1553,'26440','','Barbour',''),(1554,'26440','','Preston',''),(1555,'26443','','Doddridge',''),(1556,'26448','','Doddridge',''),(1557,'26448','','Marion',''),(1558,'26456','','Ritchie',''),(1559,'26456','','Tyler',''),(1560,'26542','','Monongalia',''),(1561,'26554','','Harrison',''),(1562,'26554','','Monongalia',''),(1563,'26554','','Taylor',''),(1564,'26562','','Monongalia',''),(1565,'26570','','Marion',''),(1566,'26582','','Harrison',''),(1567,'26585','','Wetzel',''),(1568,'26588','','Monongalia',''),(1569,'26591','','Harrison',''),(1570,'26610','','Webster',''),(1571,'26617','','Nicholas',''),(1572,'26636','','Braxton',''),(1573,'26636','','Calhoun',''),(1574,'26638','','Calhoun',''),(1575,'26656','','Fayette',''),(1576,'26680','','Greenbrier',''),(1577,'26680','','Nicholas',''),(1578,'26690','','Nicholas',''),(1579,'26691','','Webster',''),(1580,'26710','','Grant',''),(1581,'26710','','Hampshire',''),(1582,'26717','','Grant',''),(1583,'26726','','Grant',''),(1584,'26743','','Grant',''),(1585,'26755','','Hardy',''),(1586,'26763','','Mineral',''),(1587,'26847','','Pendleton',''),(1588,'26851','','Hampshire',''),(1589,'26852','','Hardy',''),(1590,'26855','','Pendleton',''),(1591,'27009','','Stokes',''),(1592,'27012','','Davidson',''),(1593,'27013','','Iredell',''),(1594,'27019','','Forsyth',''),(1595,'27020','','Iredell',''),(1596,'27020','','Wilkes',''),(1597,'27021','','Forsyth',''),(1598,'27025','','Stokes',''),(1599,'27028','','Iredell',''),(1600,'27030','','Stokes',''),(1601,'27041','','Stokes',''),(1602,'27043','','Forsyth',''),(1603,'27043','','Surry',''),(1604,'27045','','Stokes',''),(1605,'27050','','Stokes',''),(1606,'27052','','Forsyth',''),(1607,'27053','','Surry',''),(1608,'27055','','Davie',''),(1609,'27055','','Iredell',''),(1610,'27107','','Davidson',''),(1611,'27127','','Davidson',''),(1612,'27208','','Moore',''),(1613,'27208','','Randolph',''),(1614,'27209','','Moore',''),(1615,'27214','','Rockingham',''),(1616,'27215','','Guilford',''),(1617,'27217','','Caswell',''),(1618,'27233','','Guilford',''),(1619,'27239','','Randolph',''),(1620,'27244','','Caswell',''),(1621,'27244','','Guilford',''),(1622,'27249','','Alamance',''),(1623,'27249','','Caswell',''),(1624,'27249','','Rockingham',''),(1625,'27260','','Randolph',''),(1626,'27262','','Davidson',''),(1627,'27263','','Guilford',''),(1628,'27265','','Davidson',''),(1629,'27265','','Forsyth',''),(1630,'27278','','Durham',''),(1631,'27281','','Montgomery',''),(1632,'27283','','Randolph',''),(1633,'27284','','Davidson',''),(1634,'27284','','Guilford',''),(1635,'27291','','Person',''),(1636,'27292','','Randolph',''),(1637,'27298','','Alamance',''),(1638,'27298','','Chatham',''),(1639,'27298','','Guilford',''),(1640,'27302','','Caswell',''),(1641,'27302','','Orange',''),(1642,'27305','','Person',''),(1643,'27306','','Richmond',''),(1644,'27311','','Rockingham',''),(1645,'27312','','Alamance',''),(1646,'27313','','Randolph',''),(1647,'27317','','Guilford',''),(1648,'27320','','Caswell',''),(1649,'27320','','Guilford',''),(1650,'27325','','Randolph',''),(1651,'27326','','Caswell',''),(1652,'27330','','Chatham',''),(1653,'27330','','Harnett',''),(1654,'27330','','Moore',''),(1655,'27332','','Harnett',''),(1656,'27341','','Montgomery',''),(1657,'27341','','Moore',''),(1658,'27343','','Caswell',''),(1659,'27344','','Randolph',''),(1660,'27349','','Chatham',''),(1661,'27355','','Chatham',''),(1662,'27356','','Moore',''),(1663,'27357','','Guilford',''),(1664,'27357','','Stokes',''),(1665,'27358','','Rockingham',''),(1666,'27360','','Randolph',''),(1667,'27371','','Randolph',''),(1668,'27501','','Johnston',''),(1669,'27501','','Wake',''),(1670,'27502','','Chatham',''),(1671,'27504','','Harnett',''),(1672,'27505','','Lee',''),(1673,'27507','','Vance',''),(1674,'27516','','Chatham',''),(1675,'27517','','Chatham',''),(1676,'27517','','Durham',''),(1677,'27519','','Chatham',''),(1678,'27520','','Wake',''),(1679,'27522','','Wake',''),(1680,'27523','','Chatham',''),(1681,'27524','','Wayne',''),(1682,'27525','','Granville',''),(1683,'27526','','Harnett',''),(1684,'27529','','Johnston',''),(1685,'27537','','Franklin',''),(1686,'27537','','Warren',''),(1687,'27540','','Chatham',''),(1688,'27540','','Harnett',''),(1689,'27541','','Caswell',''),(1690,'27541','','Orange',''),(1691,'27542','','Wayne',''),(1692,'27542','','Wilson',''),(1693,'27544','','Franklin',''),(1694,'27544','','Granville',''),(1695,'27553','','Vance',''),(1696,'27557','','Johnston',''),(1697,'27557','','Wilson',''),(1698,'27560','','Durham',''),(1699,'27562','','Wake',''),(1700,'27563','','Vance',''),(1701,'27565','','Person',''),(1702,'27565','','Vance',''),(1703,'27569','','Wayne',''),(1704,'27572','','Durham',''),(1705,'27572','','Granville',''),(1706,'27572','','Orange',''),(1707,'27583','','Orange',''),(1708,'27587','','Franklin',''),(1709,'27587','','Granville',''),(1710,'27589','','Franklin',''),(1711,'27591','','Johnston',''),(1712,'27592','','Harnett',''),(1713,'27592','','Johnston',''),(1714,'27596','','Granville',''),(1715,'27596','','Wake',''),(1716,'27597','','Franklin',''),(1717,'27597','','Johnston',''),(1718,'27597','','Nash',''),(1719,'27603','','Johnston',''),(1720,'27613','','Durham',''),(1721,'27617','','Durham',''),(1722,'27703','','Wake',''),(1723,'27705','','Orange',''),(1724,'27707','','Orange',''),(1725,'27713','','Chatham',''),(1726,'27803','','Edgecombe',''),(1727,'27803','','Wilson',''),(1728,'27805','','Bertie',''),(1729,'27807','','Wilson',''),(1730,'27809','','Edgecombe',''),(1731,'27810','','Hyde',''),(1732,'27812','','Edgecombe',''),(1733,'27812','','Martin',''),(1734,'27816','','Franklin',''),(1735,'27822','','Edgecombe',''),(1736,'27822','','Nash',''),(1737,'27826','','Tyrrell',''),(1738,'27828','','Greene',''),(1739,'27829','','Edgecombe',''),(1740,'27829','','Wilson',''),(1741,'27830','','Wilson',''),(1742,'27834','','Beaufort',''),(1743,'27834','','Edgecombe',''),(1744,'27837','','Beaufort',''),(1745,'27842','','Warren',''),(1746,'27843','','Edgecombe',''),(1747,'27843','','Martin',''),(1748,'27844','','Warren',''),(1749,'27850','','Warren',''),(1750,'27852','','Pitt',''),(1751,'27852','','Wilson',''),(1752,'27855','','Northampton',''),(1753,'27860','','Hyde',''),(1754,'27860','','Washington',''),(1755,'27863','','Greene',''),(1756,'27871','','Beaufort',''),(1757,'27871','','Pitt',''),(1758,'27878','','Edgecombe',''),(1759,'27878','','Wilson',''),(1760,'27880','','Nash',''),(1761,'27882','','Franklin',''),(1762,'27883','','Greene',''),(1763,'27883','','Wayne',''),(1764,'27886','','Pitt',''),(1765,'27888','','Pitt',''),(1766,'27888','','Wilson',''),(1767,'27889','','Pitt',''),(1768,'27891','','Edgecombe',''),(1769,'27891','','Halifax',''),(1770,'27892','','Beaufort',''),(1771,'27896','','Nash',''),(1772,'27897','','Hertford',''),(1773,'27909','','Camden',''),(1774,'27910','','Bertie',''),(1775,'27919','','Chowan',''),(1776,'27924','','Hertford',''),(1777,'27928','','Tyrrell',''),(1778,'27946','','Chowan',''),(1779,'27973','','Camden',''),(1780,'27980','','Perquimans',''),(1781,'28006','','Lincoln',''),(1782,'28020','','Rutherford',''),(1783,'28021','','Cleveland',''),(1784,'28021','','Lincoln',''),(1785,'28033','','Gaston',''),(1786,'28036','','Cabarrus',''),(1787,'28036','','Iredell',''),(1788,'28037','','Catawba',''),(1789,'28040','','Cleveland',''),(1790,'28071','','Cabarrus',''),(1791,'28071','','Stanly',''),(1792,'28078','','Cabarrus',''),(1793,'28081','','Rowan',''),(1794,'28083','','Rowan',''),(1795,'28086','','Gaston',''),(1796,'28090','','Burke',''),(1797,'28090','','Catawba',''),(1798,'28090','','Lincoln',''),(1799,'28092','','Catawba',''),(1800,'28092','','Gaston',''),(1801,'28097','','Cabarrus',''),(1802,'28103','','Anson',''),(1803,'28104','','Mecklenburg',''),(1804,'28105','','Union',''),(1805,'28107','','Mecklenburg',''),(1806,'28107','','Stanly',''),(1807,'28107','','Union',''),(1808,'28114','','Cleveland',''),(1809,'28115','','Rowan',''),(1810,'28124','','Stanly',''),(1811,'28125','','Iredell',''),(1812,'28127','','Davidson',''),(1813,'28127','','Montgomery',''),(1814,'28133','','Union',''),(1815,'28137','','Rowan',''),(1816,'28138','','Cabarrus',''),(1817,'28139','','Polk',''),(1818,'28150','','Rutherford',''),(1819,'28164','','Lincoln',''),(1820,'28167','','Mcdowell',''),(1821,'28168','','Catawba',''),(1822,'28213','','Cabarrus',''),(1823,'28215','','Cabarrus',''),(1824,'28227','','Union',''),(1825,'28262','','Cabarrus',''),(1826,'28269','','Cabarrus',''),(1827,'28304','','Hoke',''),(1828,'28306','','Bladen',''),(1829,'28306','','Hoke',''),(1830,'28312','','Bladen',''),(1831,'28315','','Hoke',''),(1832,'28318','','Cumberland',''),(1833,'28320','','Columbus',''),(1834,'28326','','Lee',''),(1835,'28326','','Moore',''),(1836,'28334','','Cumberland',''),(1837,'28334','','Johnston',''),(1838,'28334','','Sampson',''),(1839,'28341','','Sampson',''),(1840,'28344','','Cumberland',''),(1841,'28345','','Scotland',''),(1842,'28347','','Moore',''),(1843,'28356','','Harnett',''),(1844,'28357','','Hoke',''),(1845,'28363','','Richmond',''),(1846,'28364','','Hoke',''),(1847,'28364','','Scotland',''),(1848,'28365','','Duplin',''),(1849,'28365','','Sampson',''),(1850,'28366','','Johnston',''),(1851,'28371','','Cumberland',''),(1852,'28371','','Hoke',''),(1853,'28377','','Hoke',''),(1854,'28382','','Cumberland',''),(1855,'28384','','Bladen',''),(1856,'28384','','Cumberland',''),(1857,'28386','','Hoke',''),(1858,'28390','','Cumberland',''),(1859,'28393','','Duplin',''),(1860,'28411','','Pender',''),(1861,'28423','','Bladen',''),(1862,'28433','','Columbus',''),(1863,'28436','','Brunswick',''),(1864,'28438','','Bladen',''),(1865,'28441','','Bladen',''),(1866,'28444','','Bladen',''),(1867,'28444','','Duplin',''),(1868,'28445','','Pender',''),(1869,'28447','','Bladen',''),(1870,'28447','','Pender',''),(1871,'28448','','Pender',''),(1872,'28453','','Sampson',''),(1873,'28454','','Pender',''),(1874,'28456','','Bladen',''),(1875,'28456','','Brunswick',''),(1876,'28458','','Sampson',''),(1877,'28466','','Pender',''),(1878,'28478','','Duplin',''),(1879,'28478','','Sampson',''),(1880,'28501','','Jones',''),(1881,'28504','','Jones',''),(1882,'28513','','Greene',''),(1883,'28518','','Onslow',''),(1884,'28521','','Onslow',''),(1885,'28525','','Duplin',''),(1886,'28526','','Jones',''),(1887,'28526','','Lenoir',''),(1888,'28530','','Craven',''),(1889,'28530','','Greene',''),(1890,'28530','','Lenoir',''),(1891,'28538','','Lenoir',''),(1892,'28551','','Greene',''),(1893,'28551','','Wayne',''),(1894,'28555','','Jones',''),(1895,'28560','','Pamlico',''),(1896,'28562','','Jones',''),(1897,'28572','','Jones',''),(1898,'28572','','Lenoir',''),(1899,'28572','','Onslow',''),(1900,'28573','','Craven',''),(1901,'28574','','Duplin',''),(1902,'28574','','Jones',''),(1903,'28578','','Duplin',''),(1904,'28578','','Lenoir',''),(1905,'28580','','Lenoir',''),(1906,'28582','','Carteret',''),(1907,'28584','','Onslow',''),(1908,'28586','','Beaufort',''),(1909,'28586','','Pitt',''),(1910,'28601','','Alexander',''),(1911,'28601','','Burke',''),(1912,'28601','','Caldwell',''),(1913,'28602','','Burke',''),(1914,'28604','','Avery',''),(1915,'28605','','Avery',''),(1916,'28605','','Caldwell',''),(1917,'28606','','Caldwell',''),(1918,'28611','','Avery',''),(1919,'28612','','Catawba',''),(1920,'28618','','Wilkes',''),(1921,'28621','','Wilkes',''),(1922,'28625','','Alexander',''),(1923,'28630','','Alexander',''),(1924,'28631','','Alleghany',''),(1925,'28634','','Davie',''),(1926,'28636','','Iredell',''),(1927,'28642','','Wilkes',''),(1928,'28644','','Ashe',''),(1929,'28644','','Wilkes',''),(1930,'28645','','Burke',''),(1931,'28645','','Watauga',''),(1932,'28650','','Lincoln',''),(1933,'28654','','Alexander',''),(1934,'28655','','Mcdowell',''),(1935,'28657','','Burke',''),(1936,'28657','','Mcdowell',''),(1937,'28667','','Burke',''),(1938,'28673','','Lincoln',''),(1939,'28676','','Wilkes',''),(1940,'28678','','Iredell',''),(1941,'28679','','Avery',''),(1942,'28683','','Wilkes',''),(1943,'28684','','Watauga',''),(1944,'28689','','Alexander',''),(1945,'28689','','Wilkes',''),(1946,'28689','','Yadkin',''),(1947,'28694','','Wilkes',''),(1948,'28698','','Ashe',''),(1949,'28702','','Swain',''),(1950,'28704','','Henderson',''),(1951,'28711','','Henderson',''),(1952,'28711','','Mcdowell',''),(1953,'28711','','Rutherford',''),(1954,'28719','','Jackson',''),(1955,'28732','','Buncombe',''),(1956,'28739','','Transylvania',''),(1957,'28740','','Mitchell',''),(1958,'28741','','Jackson',''),(1959,'28742','','Transylvania',''),(1960,'28743','','Haywood',''),(1961,'28747','','Jackson',''),(1962,'28748','','Madison',''),(1963,'28749','','Mitchell',''),(1964,'28751','','Jackson',''),(1965,'28753','','Buncombe',''),(1966,'28754','','Yancey',''),(1967,'28756','','Rutherford',''),(1968,'28759','','Buncombe',''),(1969,'28761','','Burke',''),(1970,'28766','','Henderson',''),(1971,'28771','','Swain',''),(1972,'28773','','Henderson',''),(1973,'28774','','Jackson',''),(1974,'28777','','Avery',''),(1975,'28777','','Mcdowell',''),(1976,'28777','','Yancey',''),(1977,'28781','','Cherokee',''),(1978,'28786','','Jackson',''),(1979,'28787','','Madison',''),(1980,'28789','','Swain',''),(1981,'28792','','Polk',''),(1982,'28902','','Cherokee',''),(1983,'29001','','Sumter',''),(1984,'29006','','Aiken',''),(1985,'29006','','Saluda',''),(1986,'29009','','Chesterfield',''),(1987,'29009','','Lee',''),(1988,'29010','','Kershaw',''),(1989,'29014','','Fairfield',''),(1990,'29016','','Fairfield',''),(1991,'29018','','Dorchester',''),(1992,'29020','','Lee',''),(1993,'29030','','Orangeburg',''),(1994,'29031','','Chester',''),(1995,'29031','','Fairfield',''),(1996,'29032','','Lee',''),(1997,'29036','','Newberry',''),(1998,'29036','','Richland',''),(1999,'29037','','Saluda',''),(2000,'29040','','Lee',''),(2001,'29045','','Richland',''),(2002,'29047','','Calhoun',''),(2003,'29051','','Clarendon',''),(2004,'29053','','Calhoun',''),(2005,'29055','','Fairfield',''),(2006,'29056','','Clarendon',''),(2007,'29058','','Kershaw',''),(2008,'29059','','Berkeley',''),(2009,'29063','','Lexington',''),(2010,'29067','','Kershaw',''),(2011,'29069','','Lee',''),(2012,'29070','','Saluda',''),(2013,'29075','','Lexington',''),(2014,'29075','','Richland',''),(2015,'29078','','Richland',''),(2016,'29080','','Sumter',''),(2017,'29081','','Colleton',''),(2018,'29082','','Bamberg',''),(2019,'29101','','Darlington',''),(2020,'29104','','Lee',''),(2021,'29105','','Saluda',''),(2022,'29111','','Williamsburg',''),(2023,'29112','','Calhoun',''),(2024,'29112','','Lexington',''),(2025,'29114','','Clarendon',''),(2026,'29114','','Sumter',''),(2027,'29118','','Calhoun',''),(2028,'29125','','Clarendon',''),(2029,'29127','','Saluda',''),(2030,'29128','','Kershaw',''),(2031,'29128','','Lee',''),(2032,'29129','','Edgefield',''),(2033,'29129','','Saluda',''),(2034,'29130','','Kershaw',''),(2035,'29130','','Richland',''),(2036,'29135','','Orangeburg',''),(2037,'29137','','Orangeburg',''),(2038,'29138','','Edgefield',''),(2039,'29138','','Greenwood',''),(2040,'29146','','Aiken',''),(2041,'29153','','Lee',''),(2042,'29160','','Calhoun',''),(2043,'29161','','Darlington',''),(2044,'29162','','Sumter',''),(2045,'29178','','Laurens',''),(2046,'29178','','Union',''),(2047,'29180','','Richland',''),(2048,'29210','','Lexington',''),(2049,'29212','','Richland',''),(2050,'29307','','Cherokee',''),(2051,'29322','','Greenville',''),(2052,'29323','','Cherokee',''),(2053,'29330','','Cherokee',''),(2054,'29332','','Newberry',''),(2055,'29335','','Laurens',''),(2056,'29335','','Union',''),(2057,'29355','','Newberry',''),(2058,'29356','','Greenville',''),(2059,'29372','','Cherokee',''),(2060,'29372','','Union',''),(2061,'29374','','Union',''),(2062,'29388','','Laurens',''),(2063,'29406','','Berkeley',''),(2064,'29414','','Dorchester',''),(2065,'29418','','Dorchester',''),(2066,'29420','','Charleston',''),(2067,'29426','','Dorchester',''),(2068,'29432','','Bamberg',''),(2069,'29432','','Dorchester',''),(2070,'29436','','Orangeburg',''),(2071,'29438','','Colleton',''),(2072,'29450','','Charleston',''),(2073,'29456','','Berkeley',''),(2074,'29456','','Charleston',''),(2075,'29470','','Dorchester',''),(2076,'29472','','Berkeley',''),(2077,'29472','','Colleton',''),(2078,'29481','','Bamberg',''),(2079,'29483','','Berkeley',''),(2080,'29483','','Charleston',''),(2081,'29485','','Charleston',''),(2082,'29501','','Darlington',''),(2083,'29506','','Darlington',''),(2084,'29510','','Williamsburg',''),(2085,'29550','','Chesterfield',''),(2086,'29550','','Lee',''),(2087,'29554','','Florence',''),(2088,'29554','','Georgetown',''),(2089,'29555','','Williamsburg',''),(2090,'29560','','Clarendon',''),(2091,'29560','','Williamsburg',''),(2092,'29565','','Marion',''),(2093,'29565','','Marlboro',''),(2094,'29574','','Dillon',''),(2095,'29576','','Georgetown',''),(2096,'29581','','Dillon',''),(2097,'29581','','Marion',''),(2098,'29592','','Marion',''),(2099,'29593','','Chesterfield',''),(2100,'29611','','Anderson',''),(2101,'29611','','Pickens',''),(2102,'29620','','Mccormick',''),(2103,'29627','','Abbeville',''),(2104,'29627','','Greenville',''),(2105,'29628','','Mccormick',''),(2106,'29630','','Anderson',''),(2107,'29631','','Anderson',''),(2108,'29635','','Pickens',''),(2109,'29638','','Greenwood',''),(2110,'29642','','Anderson',''),(2111,'29643','','Anderson',''),(2112,'29644','','Laurens',''),(2113,'29646','','Abbeville',''),(2114,'29649','','Abbeville',''),(2115,'29650','','Spartanburg',''),(2116,'29651','','Spartanburg',''),(2117,'29653','','Abbeville',''),(2118,'29654','','Abbeville',''),(2119,'29654','','Greenville',''),(2120,'29654','','Laurens',''),(2121,'29655','','Abbeville',''),(2122,'29657','','Anderson',''),(2123,'29661','','Pickens',''),(2124,'29666','','Saluda',''),(2125,'29669','','Greenville',''),(2126,'29670','','Pickens',''),(2127,'29673','','Anderson',''),(2128,'29678','','Pickens',''),(2129,'29689','','Oconee',''),(2130,'29692','','Abbeville',''),(2131,'29692','','Greenwood',''),(2132,'29702','','York',''),(2133,'29704','','Chester',''),(2134,'29706','','York',''),(2135,'29707','','York',''),(2136,'29712','','York',''),(2137,'29718','','Kershaw',''),(2138,'29730','','Chester',''),(2139,'29742','','Chester',''),(2140,'29812','','Allendale',''),(2141,'29817','','Bamberg',''),(2142,'29819','','Abbeville',''),(2143,'29819','','Mccormick',''),(2144,'29821','','Edgefield',''),(2145,'29824','','Saluda',''),(2146,'29832','','Saluda',''),(2147,'29835','','Edgefield',''),(2148,'29836','','Barnwell',''),(2149,'29838','','Mccormick',''),(2150,'29843','','Barnwell',''),(2151,'29845','','Edgefield',''),(2152,'29847','','Aiken',''),(2153,'29848','','Mccormick',''),(2154,'29848','','Saluda',''),(2155,'29849','','Barnwell',''),(2156,'29853','','Aiken',''),(2157,'29860','','Aiken',''),(2158,'29909','','Jasper',''),(2159,'29916','','Jasper',''),(2160,'29922','','Jasper',''),(2161,'29927','','Beaufort',''),(2162,'29932','','Allendale',''),(2163,'29934','','Hampton',''),(2164,'29944','','Jasper',''),(2165,'29945','','Beaufort',''),(2166,'29945','','Colleton',''),(2167,'29945','','Jasper',''),(2168,'30004','','Cherokee',''),(2169,'30004','','Forsyth',''),(2170,'30005','','Forsyth',''),(2171,'30011','','Gwinnett',''),(2172,'30012','','Dekalb',''),(2173,'30012','','Walton',''),(2174,'30013','','Newton',''),(2175,'30014','','Jasper',''),(2176,'30014','','Walton',''),(2177,'30016','','Rockdale',''),(2178,'30019','','Walton',''),(2179,'30024','','Forsyth',''),(2180,'30024','','Fulton',''),(2181,'30025','','Newton',''),(2182,'30028','','Cherokee',''),(2183,'30039','','Dekalb',''),(2184,'30040','','Cherokee',''),(2185,'30052','','Gwinnett',''),(2186,'30052','','Newton',''),(2187,'30052','','Rockdale',''),(2188,'30054','','Walton',''),(2189,'30055','','Morgan',''),(2190,'30055','','Newton',''),(2191,'30056','','Morgan',''),(2192,'30056','','Newton',''),(2193,'30058','','Rockdale',''),(2194,'30075','','Cherokee',''),(2195,'30075','','Cobb',''),(2196,'30084','','Gwinnett',''),(2197,'30087','','Gwinnett',''),(2198,'30092','','Fulton',''),(2199,'30094','','Dekalb',''),(2200,'30097','','Forsyth',''),(2201,'30097','','Gwinnett',''),(2202,'30101','','Bartow',''),(2203,'30101','','Cherokee',''),(2204,'30101','','Paulding',''),(2205,'30102','','Bartow',''),(2206,'30102','','Cobb',''),(2207,'30103','','Floyd',''),(2208,'30103','','Gordon',''),(2209,'30104','','Bartow',''),(2210,'30104','','Floyd',''),(2211,'30105','','Chattooga',''),(2212,'30106','','Douglas',''),(2213,'30107','','Forsyth',''),(2214,'30107','','Pickens',''),(2215,'30108','','Heard',''),(2216,'30110','','Carroll',''),(2217,'30113','','Polk',''),(2218,'30125','','Floyd',''),(2219,'30127','','Paulding',''),(2220,'30134','','Paulding',''),(2221,'30139','','Bartow',''),(2222,'30139','','Pickens',''),(2223,'30141','','Cobb',''),(2224,'30143','','Cherokee',''),(2225,'30143','','Dawson',''),(2226,'30145','','Floyd',''),(2227,'30147','','Polk',''),(2228,'30148','','Dawson',''),(2229,'30153','','Haralson',''),(2230,'30153','','Paulding',''),(2231,'30157','','Cobb',''),(2232,'30161','','Bartow',''),(2233,'30164','','Newton',''),(2234,'30165','','Cherokee',''),(2235,'30165','','Chattooga',''),(2236,'30168','','Douglas',''),(2237,'30170','','Heard',''),(2238,'30171','','Gordon',''),(2239,'30173','','Polk',''),(2240,'30175','','Gilmer',''),(2241,'30178','','Paulding',''),(2242,'30178','','Polk',''),(2243,'30179','','Haralson',''),(2244,'30179','','Paulding',''),(2245,'30180','','Douglas',''),(2246,'30180','','Paulding',''),(2247,'30182','','Haralson',''),(2248,'30183','','Bartow',''),(2249,'30183','','Pickens',''),(2250,'30184','','Cherokee',''),(2251,'30185','','Douglas',''),(2252,'30188','','Cobb',''),(2253,'30204','','Monroe',''),(2254,'30204','','Upson',''),(2255,'30205','','Spalding',''),(2256,'30215','','Clayton',''),(2257,'30217','','Troup',''),(2258,'30220','','Meriwether',''),(2259,'30224','','Lamar',''),(2260,'30224','','Pike',''),(2261,'30228','','Clayton',''),(2262,'30228','','Spalding',''),(2263,'30230','','Coweta',''),(2264,'30230','','Heard',''),(2265,'30230','','Meriwether',''),(2266,'30233','','Henry',''),(2267,'30233','','Lamar',''),(2268,'30233','','Monroe',''),(2269,'30233','','Newton',''),(2270,'30234','','Henry',''),(2271,'30236','','Henry',''),(2272,'30238','','Fayette',''),(2273,'30248','','Butts',''),(2274,'30248','','Spalding',''),(2275,'30252','','Rockdale',''),(2276,'30256','','Upson',''),(2277,'30257','','Pike',''),(2278,'30258','','Upson',''),(2279,'30263','','Heard',''),(2280,'30268','','Coweta',''),(2281,'30273','','Henry',''),(2282,'30276','','Fayette',''),(2283,'30276','','Meriwether',''),(2284,'30281','','Clayton',''),(2285,'30281','','Rockdale',''),(2286,'30285','','Lamar',''),(2287,'30285','','Pike',''),(2288,'30288','','Dekalb',''),(2289,'30292','','Spalding',''),(2290,'30294','','Clayton',''),(2291,'30294','','Henry',''),(2292,'30294','','Rockdale',''),(2293,'30295','','Lamar',''),(2294,'30296','','Fulton',''),(2295,'30306','','Dekalb',''),(2296,'30307','','Fulton',''),(2297,'30315','','Dekalb',''),(2298,'30316','','Fulton',''),(2299,'30317','','Fulton',''),(2300,'30319','','Fulton',''),(2301,'30324','','Dekalb',''),(2302,'30337','','Clayton',''),(2303,'30338','','Fulton',''),(2304,'30339','','Fulton',''),(2305,'30340','','Gwinnett',''),(2306,'30349','','Clayton',''),(2307,'30350','','Dekalb',''),(2308,'30354','','Clayton',''),(2309,'30360','','Gwinnett',''),(2310,'30411','','Laurens',''),(2311,'30411','','Telfair',''),(2312,'30413','','Johnson',''),(2313,'30413','','Washington',''),(2314,'30417','','Bulloch',''),(2315,'30417','','Tattnall',''),(2316,'30420','','Candler',''),(2317,'30425','','Bulloch',''),(2318,'30425','','Jenkins',''),(2319,'30426','','Screven',''),(2320,'30427','','Evans',''),(2321,'30427','','Long',''),(2322,'30428','','Laurens',''),(2323,'30434','','Burke',''),(2324,'30436','','Emanuel',''),(2325,'30436','','Tattnall',''),(2326,'30439','','Emanuel',''),(2327,'30441','','Burke',''),(2328,'30441','','Jenkins',''),(2329,'30442','','Burke',''),(2330,'30446','','Effingham',''),(2331,'30457','','Emanuel',''),(2332,'30457','','Laurens',''),(2333,'30457','','Montgomery',''),(2334,'30470','','Treutlen',''),(2335,'30471','','Bulloch',''),(2336,'30473','','Toombs',''),(2337,'30474','','Emanuel',''),(2338,'30474','','Montgomery',''),(2339,'30474','','Treutlen',''),(2340,'30506','','Forsyth',''),(2341,'30510','','Banks',''),(2342,'30510','','Hall',''),(2343,'30511','','Habersham',''),(2344,'30511','','Stephens',''),(2345,'30512','','Fannin',''),(2346,'30513','','Gilmer',''),(2347,'30517','','Barrow',''),(2348,'30517','','Gwinnett',''),(2349,'30517','','Hall',''),(2350,'30518','','Hall',''),(2351,'30519','','Hall',''),(2352,'30520','','Hart',''),(2353,'30521','','Banks',''),(2354,'30522','','Fannin',''),(2355,'30523','','Rabun',''),(2356,'30528','','Lumpkin',''),(2357,'30529','','Banks',''),(2358,'30530','','Franklin',''),(2359,'30530','','Jackson',''),(2360,'30530','','Madison',''),(2361,'30531','','Hall',''),(2362,'30533','','Dawson',''),(2363,'30533','','Hall',''),(2364,'30533','','White',''),(2365,'30534','','Cherokee',''),(2366,'30534','','Forsyth',''),(2367,'30534','','Lumpkin',''),(2368,'30534','','Pickens',''),(2369,'30536','','Dawson',''),(2370,'30538','','Franklin',''),(2371,'30543','','Banks',''),(2372,'30543','','Jackson',''),(2373,'30548','','Barrow',''),(2374,'30548','','Gwinnett',''),(2375,'30548','','Hall',''),(2376,'30553','','Hart',''),(2377,'30554','','Banks',''),(2378,'30557','','Franklin',''),(2379,'30558','','Banks',''),(2380,'30560','','Union',''),(2381,'30564','','Lumpkin',''),(2382,'30564','','White',''),(2383,'30565','','Madison',''),(2384,'30567','','Hall',''),(2385,'30572','','Fannin',''),(2386,'30573','','Habersham',''),(2387,'30575','','Hall',''),(2388,'30577','','Banks',''),(2389,'30577','','Franklin',''),(2390,'30577','','Habersham',''),(2391,'30582','','Union',''),(2392,'30601','','Jackson',''),(2393,'30601','','Madison',''),(2394,'30605','','Oconee',''),(2395,'30606','','Oconee',''),(2396,'30607','','Jackson',''),(2397,'30619','','Oconee',''),(2398,'30620','','Gwinnett',''),(2399,'30620','','Walton',''),(2400,'30621','','Morgan',''),(2401,'30622','','Barrow',''),(2402,'30622','','Clarke',''),(2403,'30622','','Jackson',''),(2404,'30624','','Hart',''),(2405,'30624','','Madison',''),(2406,'30625','','Putnam',''),(2407,'30627','','Madison',''),(2408,'30628','','Oglethorpe',''),(2409,'30629','','Oglethorpe',''),(2410,'30631','','Wilkes',''),(2411,'30633','','Banks',''),(2412,'30633','','Franklin',''),(2413,'30634','','Hart',''),(2414,'30635','','Hart',''),(2415,'30641','','Morgan',''),(2416,'30646','','Clarke',''),(2417,'30650','','Greene',''),(2418,'30650','','Walton',''),(2419,'30656','','Barrow',''),(2420,'30660','','Oglethorpe',''),(2421,'30662','','Elbert',''),(2422,'30662','','Hart',''),(2423,'30662','','Madison',''),(2424,'30666','','Jackson',''),(2425,'30666','','Oconee',''),(2426,'30668','','Lincoln',''),(2427,'30669','','Oglethorpe',''),(2428,'30669','','Taliaferro',''),(2429,'30677','','Greene',''),(2430,'30678','','Hancock',''),(2431,'30678','','Taliaferro',''),(2432,'30680','','Jackson',''),(2433,'30680','','Oconee',''),(2434,'30683','','Oglethorpe',''),(2435,'30701','','Floyd',''),(2436,'30707','','Catoosa',''),(2437,'30710','','Catoosa',''),(2438,'30721','','Murray',''),(2439,'30731','','Dade',''),(2440,'30731','','Walker',''),(2441,'30733','','Floyd',''),(2442,'30734','','Pickens',''),(2443,'30735','','Murray',''),(2444,'30735','','Whitfield',''),(2445,'30736','','Walker',''),(2446,'30736','','Whitfield',''),(2447,'30738','','Walker',''),(2448,'30739','','Catoosa',''),(2449,'30740','','Walker',''),(2450,'30741','','Catoosa',''),(2451,'30742','','Walker',''),(2452,'30747','','Walker',''),(2453,'30750','','Dade',''),(2454,'30753','','Walker',''),(2455,'30755','','Catoosa',''),(2456,'30802','','Mcduffie',''),(2457,'30805','','Burke',''),(2458,'30810','','Jefferson',''),(2459,'30810','','Warren',''),(2460,'30813','','Richmond',''),(2461,'30814','','Mcduffie',''),(2462,'30815','','Burke',''),(2463,'30816','','Jefferson',''),(2464,'30817','','Wilkes',''),(2465,'30820','','Warren',''),(2466,'30820','','Washington',''),(2467,'30823','','Glascock',''),(2468,'30823','','Warren',''),(2469,'30824','','Warren',''),(2470,'30828','','Glascock',''),(2471,'30907','','Richmond',''),(2472,'30909','','Columbia',''),(2473,'31002','','Johnson',''),(2474,'31002','','Laurens',''),(2475,'31002','','Treutlen',''),(2476,'31008','','Crawford',''),(2477,'31008','','Houston',''),(2478,'31012','','Bleckley',''),(2479,'31014','','Dodge',''),(2480,'31014','','Twiggs',''),(2481,'31015','','Wilcox',''),(2482,'31016','','Crawford',''),(2483,'31016','','Lamar',''),(2484,'31016','','Upson',''),(2485,'31017','','Bleckley',''),(2486,'31017','','Wilkinson',''),(2487,'31020','','Bibb',''),(2488,'31022','','Bleckley',''),(2489,'31023','','Pulaski',''),(2490,'31029','','Butts',''),(2491,'31030','','Crawford',''),(2492,'31030','','Houston',''),(2493,'31030','','Macon',''),(2494,'31031','','Baldwin',''),(2495,'31031','','Jones',''),(2496,'31031','','Twiggs',''),(2497,'31033','','Baldwin',''),(2498,'31036','','Houston',''),(2499,'31037','','Dodge',''),(2500,'31037','','Wheeler',''),(2501,'31038','','Jones',''),(2502,'31044','','Wilkinson',''),(2503,'31045','','Hancock',''),(2504,'31046','','Jones',''),(2505,'31049','','Emanuel',''),(2506,'31052','','Crawford',''),(2507,'31058','','Taylor',''),(2508,'31060','','Dodge',''),(2509,'31061','','Hancock',''),(2510,'31061','','Jones',''),(2511,'31061','','Putnam',''),(2512,'31061','','Wilkinson',''),(2513,'31063','','Dooly',''),(2514,'31065','','Bleckley',''),(2515,'31066','','Bibb',''),(2516,'31066','','Monroe',''),(2517,'31069','','Peach',''),(2518,'31071','','Pulaski',''),(2519,'31072','','Crisp',''),(2520,'31076','','Macon',''),(2521,'31077','','Telfair',''),(2522,'31079','','Ben Hill',''),(2523,'31082','','Baldwin',''),(2524,'31083','','Wheeler',''),(2525,'31087','','Baldwin',''),(2526,'31087','','Washington',''),(2527,'31089','','Johnson',''),(2528,'31091','','Houston',''),(2529,'31091','','Pulaski',''),(2530,'31092','','Crisp',''),(2531,'31096','','Washington',''),(2532,'31097','','Lamar',''),(2533,'31097','','Monroe',''),(2534,'31210','','Monroe',''),(2535,'31211','','Jones',''),(2536,'31217','','Jones',''),(2537,'31217','','Twiggs',''),(2538,'31220','','Monroe',''),(2539,'31301','','Long',''),(2540,'31302','','Chatham',''),(2541,'31308','','Bulloch',''),(2542,'31313','','Long',''),(2543,'31321','','Bulloch',''),(2544,'31323','','Long',''),(2545,'31323','','Mcintosh',''),(2546,'31503','','Brantley',''),(2547,'31510','','Jeff Davis',''),(2548,'31510','','Pierce',''),(2549,'31513','','Jeff Davis',''),(2550,'31518','','Pierce',''),(2551,'31518','','Wayne',''),(2552,'31519','','Jeff Davis',''),(2553,'31537','','Camden',''),(2554,'31539','','Appling',''),(2555,'31543','','Glynn',''),(2556,'31543','','Wayne',''),(2557,'31549','','Wheeler',''),(2558,'31551','','Bacon',''),(2559,'31552','','Atkinson',''),(2560,'31552','','Coffee',''),(2561,'31553','','Charlton',''),(2562,'31554','','Bacon',''),(2563,'31554','','Ware',''),(2564,'31555','','Appling',''),(2565,'31557','','Brantley',''),(2566,'31566','','Glynn',''),(2567,'31602','','Brooks',''),(2568,'31624','','Coffee',''),(2569,'31624','','Ware',''),(2570,'31626','','Brooks',''),(2571,'31630','','Echols',''),(2572,'31631','','Charlton',''),(2573,'31631','','Echols',''),(2574,'31631','','Ware',''),(2575,'31632','','Cook',''),(2576,'31635','','Atkinson',''),(2577,'31635','','Clinch',''),(2578,'31636','','Echols',''),(2579,'31637','','Berrien',''),(2580,'31637','','Colquitt',''),(2581,'31637','','Tift',''),(2582,'31639','','Lanier',''),(2583,'31641','','Lanier',''),(2584,'31642','','Clinch',''),(2585,'31645','','Lanier',''),(2586,'31645','','Lowndes',''),(2587,'31650','','Coffee',''),(2588,'31701','','Lee',''),(2589,'31705','','Mitchell',''),(2590,'31705','','Worth',''),(2591,'31707','','Lee',''),(2592,'31711','','Macon',''),(2593,'31714','','Worth',''),(2594,'31720','','Brooks',''),(2595,'31721','','Baker',''),(2596,'31721','','Lee',''),(2597,'31721','','Terrell',''),(2598,'31730','','Decatur',''),(2599,'31733','','Irwin',''),(2600,'31733','','Turner',''),(2601,'31738','','Colquitt',''),(2602,'31743','','Lee',''),(2603,'31744','','Mitchell',''),(2604,'31744','','Worth',''),(2605,'31749','','Irwin',''),(2606,'31749','','Tift',''),(2607,'31750','','Irwin',''),(2608,'31750','','Wilcox',''),(2609,'31763','','Dougherty',''),(2610,'31764','','Lee',''),(2611,'31765','','Colquitt',''),(2612,'31765','','Mitchell',''),(2613,'31771','','Worth',''),(2614,'31773','','Grady',''),(2615,'31775','','Colquitt',''),(2616,'31775','','Worth',''),(2617,'31778','','Brooks',''),(2618,'31778','','Colquitt',''),(2619,'31779','','Grady',''),(2620,'31780','','Webster',''),(2621,'31783','','Ben Hill',''),(2622,'31783','','Irwin',''),(2623,'31787','','Sumter',''),(2624,'31791','','Dougherty',''),(2625,'31792','','Grady',''),(2626,'31794','','Berrien',''),(2627,'31795','','Worth',''),(2628,'31798','','Ben Hill',''),(2629,'31798','','Coffee',''),(2630,'31801','','Muscogee',''),(2631,'31801','','Talbot',''),(2632,'31803','','Schley',''),(2633,'31803','','Webster',''),(2634,'31805','','Stewart',''),(2635,'31806','','Macon',''),(2636,'31808','','Muscogee',''),(2637,'31812','','Taylor',''),(2638,'31816','','Talbot',''),(2639,'31820','','Harris',''),(2640,'31822','','Meriwether',''),(2641,'31822','','Troup',''),(2642,'31825','','Webster',''),(2643,'31826','','Talbot',''),(2644,'31829','','Harris',''),(2645,'31830','','Harris',''),(2646,'31831','','Talbot',''),(2647,'31833','','Harris',''),(2648,'31905','','Russell',''),(2649,'31905','','Muscogee',''),(2650,'32008','','Dixie',''),(2651,'32008','','Gilchrist',''),(2652,'32008','','Lafayette',''),(2653,'32024','','Suwannee',''),(2654,'32043','','Putnam',''),(2655,'32054','','Bradford',''),(2656,'32058','','Clay',''),(2657,'32058','','Union',''),(2658,'32073','','Duval',''),(2659,'32083','','Bradford',''),(2660,'32091','','Clay',''),(2661,'32094','','Columbia',''),(2662,'32096','','Columbia',''),(2663,'32096','','Suwannee',''),(2664,'32102','','Volusia',''),(2665,'32134','','Lake',''),(2666,'32134','','Putnam',''),(2667,'32136','','Volusia',''),(2668,'32159','','Sumter',''),(2669,'32162','','Marion',''),(2670,'32174','','Flagler',''),(2671,'32180','','Flagler',''),(2672,'32195','','Lake',''),(2673,'32224','','St. Johns',''),(2674,'32234','','Baker',''),(2675,'32234','','Clay',''),(2676,'32234','','Nassau',''),(2677,'32321','','Franklin',''),(2678,'32327','','Leon',''),(2679,'32331','','Jefferson',''),(2680,'32331','','Taylor',''),(2681,'32336','','Madison',''),(2682,'32336','','Taylor',''),(2683,'32346','','Franklin',''),(2684,'32358','','Franklin',''),(2685,'32359','','Dixie',''),(2686,'32413','','Walton',''),(2687,'32420','','Washington',''),(2688,'32425','','Washington',''),(2689,'32431','','Washington',''),(2690,'32437','','Bay',''),(2691,'32438','','Calhoun',''),(2692,'32438','','Washington',''),(2693,'32440','','Holmes',''),(2694,'32442','','Calhoun',''),(2695,'32455','','Holmes',''),(2696,'32456','','Bay',''),(2697,'32462','','Bay',''),(2698,'32462','','Walton',''),(2699,'32464','','Walton',''),(2700,'32466','','Washington',''),(2701,'32531','','Santa Rosa',''),(2702,'32539','','Walton',''),(2703,'32561','','Escambia',''),(2704,'32564','','Santa Rosa',''),(2705,'32567','','Walton',''),(2706,'32578','','Walton',''),(2707,'32618','','Levy',''),(2708,'32622','','Alachua',''),(2709,'32640','','Alachua',''),(2710,'32643','','Columbia',''),(2711,'32643','','Gilchrist',''),(2712,'32656','','Bradford',''),(2713,'32666','','Alachua',''),(2714,'32666','','Bradford',''),(2715,'32666','','Clay',''),(2716,'32667','','Marion',''),(2717,'32668','','Marion',''),(2718,'32669','','Gilchrist',''),(2719,'32669','','Levy',''),(2720,'32693','','Levy',''),(2721,'32696','','Marion',''),(2722,'32702','','Marion',''),(2723,'32703','','Seminole',''),(2724,'32720','','Lake',''),(2725,'32751','','Seminole',''),(2726,'32754','','Volusia',''),(2727,'32757','','Orange',''),(2728,'32776','','Orange',''),(2729,'32784','','Marion',''),(2730,'32792','','Seminole',''),(2731,'32948','','Brevard',''),(2732,'33034','','Monroe',''),(2733,'33101','','Miami-dade',''),(2734,'33122','','Miami-dade',''),(2735,'33438','','Martin',''),(2736,'33440','','Palm Beach',''),(2737,'33458','','Martin',''),(2738,'33469','','Martin',''),(2739,'33478','','Martin',''),(2740,'33523','','Hernando',''),(2741,'33540','','Hillsborough',''),(2742,'33548','','Pasco',''),(2743,'33549','','Pasco',''),(2744,'33556','','Pasco',''),(2745,'33558','','Pasco',''),(2746,'33559','','Pasco',''),(2747,'33597','','Hernando',''),(2748,'33597','','Pasco',''),(2749,'33598','','Manatee',''),(2750,'33810','','Hillsborough',''),(2751,'33825','','Hardee',''),(2752,'33825','','Polk',''),(2753,'33834','','Manatee',''),(2754,'33834','','Polk',''),(2755,'33896','','Osceola',''),(2756,'33917','','Charlotte',''),(2757,'33921','','Charlotte',''),(2758,'33935','','Glades',''),(2759,'33936','','Hendry',''),(2760,'33955','','Lee',''),(2761,'33960','','Glades',''),(2762,'34110','','Lee',''),(2763,'34119','','Lee',''),(2764,'34134','','Collier',''),(2765,'34141','','Monroe',''),(2766,'34142','','Hendry',''),(2767,'34223','','Charlotte',''),(2768,'34224','','Sarasota',''),(2769,'34228','','Manatee',''),(2770,'34243','','Sarasota',''),(2771,'34251','','Sarasota',''),(2772,'34266','','Sarasota',''),(2773,'34431','','Levy',''),(2774,'34449','','Citrus',''),(2775,'34714','','Polk',''),(2776,'34747','','Orange',''),(2777,'34759','','Osceola',''),(2778,'34787','','Lake',''),(2779,'34957','','St. Lucie',''),(2780,'34972','','Osceola',''),(2781,'34972','','St. Lucie',''),(2782,'34974','','Glades',''),(2783,'34974','','Highlands',''),(2784,'34974','','Martin',''),(2785,'34990','','St. Lucie',''),(2786,'34994','','St. Lucie',''),(2787,'35006','','Tuscaloosa',''),(2788,'35006','','Walker',''),(2789,'35010','','Coosa',''),(2790,'35010','','Elmore',''),(2791,'35016','','Blount',''),(2792,'35016','','Cullman',''),(2793,'35019','','Morgan',''),(2794,'35022','','Shelby',''),(2795,'35033','','Walker',''),(2796,'35034','','Perry',''),(2797,'35035','','Shelby',''),(2798,'35040','','Chilton',''),(2799,'35046','','Coosa',''),(2800,'35053','','Winston',''),(2801,'35062','','Walker',''),(2802,'35063','','Blount',''),(2803,'35063','','Jefferson',''),(2804,'35072','','Clay',''),(2805,'35072','','Talladega',''),(2806,'35072','','Tallapoosa',''),(2807,'35079','','Jefferson',''),(2808,'35080','','Jefferson',''),(2809,'35087','','Marshall',''),(2810,'35087','','Morgan',''),(2811,'35089','','Tallapoosa',''),(2812,'35094','','St. Clair',''),(2813,'35094','','Shelby',''),(2814,'35096','','Calhoun',''),(2815,'35098','','Winston',''),(2816,'35111','','Bibb',''),(2817,'35111','','Jefferson',''),(2818,'35115','','Bibb',''),(2819,'35115','','Chilton',''),(2820,'35121','','St. Clair',''),(2821,'35126','','Blount',''),(2822,'35130','','Jefferson',''),(2823,'35133','','St. Clair',''),(2824,'35146','','Blount',''),(2825,'35146','','Jefferson',''),(2826,'35148','','Jefferson',''),(2827,'35150','','Clay',''),(2828,'35150','','Coosa',''),(2829,'35151','','Coosa',''),(2830,'35160','','Clay',''),(2831,'35172','','Jefferson',''),(2832,'35173','','St. Clair',''),(2833,'35175','','Morgan',''),(2834,'35178','','St. Clair',''),(2835,'35179','','Morgan',''),(2836,'35179','','Winston',''),(2837,'35180','','Blount',''),(2838,'35188','','Tuscaloosa',''),(2839,'35216','','Shelby',''),(2840,'35242','','Jefferson',''),(2841,'35243','','Shelby',''),(2842,'35244','','Shelby',''),(2843,'35442','','Greene',''),(2844,'35442','','Sumter',''),(2845,'35444','','Jefferson',''),(2846,'35456','','Bibb',''),(2847,'35463','','Greene',''),(2848,'35464','','Greene',''),(2849,'35466','','Tuscaloosa',''),(2850,'35469','','Tuscaloosa',''),(2851,'35474','','Tuscaloosa',''),(2852,'35480','','Greene',''),(2853,'35503','','Winston',''),(2854,'35540','','Cullman',''),(2855,'35541','','Cullman',''),(2856,'35546','','Tuscaloosa',''),(2857,'35546','','Walker',''),(2858,'35549','','Fayette',''),(2859,'35552','','Marion',''),(2860,'35554','','Marion',''),(2861,'35554','','Walker',''),(2862,'35555','','Lamar',''),(2863,'35555','','Pickens',''),(2864,'35555','','Tuscaloosa',''),(2865,'35563','','Fayette',''),(2866,'35563','','Lamar',''),(2867,'35564','','Franklin',''),(2868,'35565','','Franklin',''),(2869,'35565','','Lawrence',''),(2870,'35565','','Marion',''),(2871,'35570','','Lamar',''),(2872,'35571','','Marion',''),(2873,'35574','','Fayette',''),(2874,'35574','','Pickens',''),(2875,'35574','','Tuscaloosa',''),(2876,'35576','','Pickens',''),(2877,'35578','','Winston',''),(2878,'35579','','Tuscaloosa',''),(2879,'35581','','Marion',''),(2880,'35593','','Marion',''),(2881,'35594','','Fayette',''),(2882,'35603','','Lawrence',''),(2883,'35610','','Limestone',''),(2884,'35614','','Lauderdale',''),(2885,'35619','','Cullman',''),(2886,'35619','','Lawrence',''),(2887,'35621','','Cullman',''),(2888,'35622','','Cullman',''),(2889,'35652','','Limestone',''),(2890,'35653','','Colbert',''),(2891,'35654','','Colbert',''),(2892,'35654','','Lawrence',''),(2893,'35672','','Colbert',''),(2894,'35673','','Morgan',''),(2895,'35739','','Madison',''),(2896,'35748','','Jackson',''),(2897,'35749','','Limestone',''),(2898,'35754','','Marshall',''),(2899,'35755','','Jackson',''),(2900,'35756','','Madison',''),(2901,'35757','','Limestone',''),(2902,'35760','','Marshall',''),(2903,'35765','','Dekalb',''),(2904,'35769','','Marshall',''),(2905,'35771','','Dekalb',''),(2906,'35773','','Limestone',''),(2907,'35776','','Madison',''),(2908,'35776','','Marshall',''),(2909,'35901','','Cherokee',''),(2910,'35903','','Cherokee',''),(2911,'35905','','Calhoun',''),(2912,'35951','','Dekalb',''),(2913,'35952','','Blount',''),(2914,'35954','','Dekalb',''),(2915,'35957','','Blount',''),(2916,'35957','','Dekalb',''),(2917,'35961','','Cherokee',''),(2918,'35961','','Etowah',''),(2919,'35962','','Marshall',''),(2920,'35966','','Dekalb',''),(2921,'35967','','Cherokee',''),(2922,'35972','','St. Clair',''),(2923,'35975','','Marshall',''),(2924,'35976','','Blount',''),(2925,'35976','','Cullman',''),(2926,'35978','','Jackson',''),(2927,'35979','','Jackson',''),(2928,'35980','','Blount',''),(2929,'35984','','Cherokee',''),(2930,'36005','','Barbour',''),(2931,'36005','','Bullock',''),(2932,'36006','','Chilton',''),(2933,'36009','','Coffee',''),(2934,'36010','','Coffee',''),(2935,'36010','','Dale',''),(2936,'36022','','Autauga',''),(2937,'36026','','Elmore',''),(2938,'36027','','Henry',''),(2939,'36027','','Russell',''),(2940,'36028','','Crenshaw',''),(2941,'36029','','Macon',''),(2942,'36032','','Butler',''),(2943,'36033','','Conecuh',''),(2944,'36033','','Monroe',''),(2945,'36034','','Coffee',''),(2946,'36034','','Crenshaw',''),(2947,'36035','','Crenshaw',''),(2948,'36036','','Crenshaw',''),(2949,'36037','','Crenshaw',''),(2950,'36041','','Montgomery',''),(2951,'36042','','Butler',''),(2952,'36043','','Lowndes',''),(2953,'36046','','Montgomery',''),(2954,'36047','','Montgomery',''),(2955,'36049','','Pike',''),(2956,'36051','','Chilton',''),(2957,'36051','','Elmore',''),(2958,'36052','','Bullock',''),(2959,'36053','','Barbour',''),(2960,'36066','','Elmore',''),(2961,'36069','','Pike',''),(2962,'36071','','Butler',''),(2963,'36078','','Tallapoosa',''),(2964,'36079','','Coffee',''),(2965,'36080','','Coosa',''),(2966,'36081','','Bullock',''),(2967,'36089','','Macon',''),(2968,'36091','','Autauga',''),(2969,'36091','','Coosa',''),(2970,'36203','','Talladega',''),(2971,'36207','','Cleburne',''),(2972,'36255','','Tallapoosa',''),(2973,'36256','','Clay',''),(2974,'36258','','Cleburne',''),(2975,'36258','','Randolph',''),(2976,'36260','','Talladega',''),(2977,'36264','','Randolph',''),(2978,'36266','','Randolph',''),(2979,'36268','','Clay',''),(2980,'36272','','Cherokee',''),(2981,'36272','','Cleburne',''),(2982,'36272','','Etowah',''),(2983,'36274','','Chambers',''),(2984,'36276','','Chambers',''),(2985,'36276','','Clay',''),(2986,'36276','','Tallapoosa',''),(2987,'36301','','Geneva',''),(2988,'36303','','Dale',''),(2989,'36303','','Henry',''),(2990,'36305','','Geneva',''),(2991,'36311','','Barbour',''),(2992,'36311','','Coffee',''),(2993,'36316','','Coffee',''),(2994,'36317','','Barbour',''),(2995,'36317','','Dale',''),(2996,'36318','','Coffee',''),(2997,'36319','','Henry',''),(2998,'36322','','Coffee',''),(2999,'36322','','Geneva',''),(3000,'36330','','Dale',''),(3001,'36345','','Dale',''),(3002,'36345','','Houston',''),(3003,'36350','','Houston',''),(3004,'36352','','Dale',''),(3005,'36352','','Geneva',''),(3006,'36353','','Dale',''),(3007,'36360','','Coffee',''),(3008,'36374','','Barbour',''),(3009,'36375','','Houston',''),(3010,'36401','','Monroe',''),(3011,'36420','','Escambia',''),(3012,'36421','','Conecuh',''),(3013,'36426','','Conecuh',''),(3014,'36432','','Escambia',''),(3015,'36442','','Geneva',''),(3016,'36453','','Covington',''),(3017,'36453','','Geneva',''),(3018,'36456','','Conecuh',''),(3019,'36456','','Covington',''),(3020,'36460','','Conecuh',''),(3021,'36467','','Coffee',''),(3022,'36471','','Conecuh',''),(3023,'36474','','Butler',''),(3024,'36474','','Conecuh',''),(3025,'36475','','Monroe',''),(3026,'36477','','Coffee',''),(3027,'36480','','Baldwin',''),(3028,'36481','','Wilcox',''),(3029,'36483','','Escambia',''),(3030,'36502','','Baldwin',''),(3031,'36502','','Conecuh',''),(3032,'36502','','Monroe',''),(3033,'36513','','Mobile',''),(3034,'36522','','Washington',''),(3035,'36558','','Choctaw',''),(3036,'36562','','Escambia',''),(3037,'36701','','Perry',''),(3038,'36703','','Autauga',''),(3039,'36722','','Marengo',''),(3040,'36728','','Marengo',''),(3041,'36738','','Hale',''),(3042,'36742','','Hale',''),(3043,'36744','','Perry',''),(3044,'36749','','Dallas',''),(3045,'36750','','Bibb',''),(3046,'36751','','Clarke',''),(3047,'36751','','Wilcox',''),(3048,'36753','','Wilcox',''),(3049,'36758','','Autauga',''),(3050,'36758','','Chilton',''),(3051,'36759','','Perry',''),(3052,'36761','','Lowndes',''),(3053,'36761','','Wilcox',''),(3054,'36765','','Perry',''),(3055,'36768','','Monroe',''),(3056,'36769','','Marengo',''),(3057,'36773','','Marengo',''),(3058,'36783','','Wilcox',''),(3059,'36784','','Marengo',''),(3060,'36784','','Wilcox',''),(3061,'36785','','Dallas',''),(3062,'36786','','Marengo',''),(3063,'36792','','Chilton',''),(3064,'36793','','Chilton',''),(3065,'36793','','Perry',''),(3066,'36801','','Chambers',''),(3067,'36804','','Macon',''),(3068,'36804','','Russell',''),(3069,'36830','','Macon',''),(3070,'36832','','Macon',''),(3071,'36850','','Chambers',''),(3072,'36850','','Lee',''),(3073,'36852','','Chambers',''),(3074,'36854','','Lee',''),(3075,'36860','','Bullock',''),(3076,'36860','','Macon',''),(3077,'36866','','Lee',''),(3078,'36866','','Tallapoosa',''),(3079,'36867','','Lee',''),(3080,'36870','','Russell',''),(3081,'36874','','Russell',''),(3082,'36879','','Chambers',''),(3083,'36879','','Tallapoosa',''),(3084,'36919','','Washington',''),(3085,'36922','','Sumter',''),(3086,'37010','','Robertson',''),(3087,'37012','','Smith',''),(3088,'37012','','Wilson',''),(3089,'37014','','Rutherford',''),(3090,'37015','','Davidson',''),(3091,'37015','','Dickson',''),(3092,'37015','','Montgomery',''),(3093,'37016','','Wilson',''),(3094,'37018','','Bedford',''),(3095,'37020','','Rutherford',''),(3096,'37022','','Macon',''),(3097,'37022','','Trousdale',''),(3098,'37025','','Dickson',''),(3099,'37025','','Williamson',''),(3100,'37027','','Davidson',''),(3101,'37031','','Trousdale',''),(3102,'37032','','Cheatham',''),(3103,'37034','','Bedford',''),(3104,'37036','','Cheatham',''),(3105,'37043','','Cheatham',''),(3106,'37046','','Marshall',''),(3107,'37046','','Rutherford',''),(3108,'37047','','Giles',''),(3109,'37047','','Lincoln',''),(3110,'37048','','Robertson',''),(3111,'37050','','Houston',''),(3112,'37050','','Montgomery',''),(3113,'37051','','Houston',''),(3114,'37051','','Montgomery',''),(3115,'37055','','Hickman',''),(3116,'37057','','Macon',''),(3117,'37057','','Trousdale',''),(3118,'37060','','Bedford',''),(3119,'37060','','Williamson',''),(3120,'37062','','Dickson',''),(3121,'37064','','Davidson',''),(3122,'37072','','Robertson',''),(3123,'37072','','Sumner',''),(3124,'37074','','Macon',''),(3125,'37076','','Wilson',''),(3126,'37078','','Hickman',''),(3127,'37079','','Montgomery',''),(3128,'37080','','Cheatham',''),(3129,'37085','','Wilson',''),(3130,'37086','','Davidson',''),(3131,'37087','','Smith',''),(3132,'37087','','Trousdale',''),(3133,'37090','','Smith',''),(3134,'37091','','Bedford',''),(3135,'37091','','Maury',''),(3136,'37095','','Cannon',''),(3137,'37095','','Wilson',''),(3138,'37096','','Wayne',''),(3139,'37101','','Hickman',''),(3140,'37101','','Houston',''),(3141,'37110','','Cannon',''),(3142,'37110','','Grundy',''),(3143,'37110','','Van Buren',''),(3144,'37118','','Cannon',''),(3145,'37118','','Wilson',''),(3146,'37122','','Davidson',''),(3147,'37122','','Rutherford',''),(3148,'37135','','Davidson',''),(3149,'37135','','Rutherford',''),(3150,'37138','','Wilson',''),(3151,'37143','','Davidson',''),(3152,'37144','','Bedford',''),(3153,'37144','','Giles',''),(3154,'37144','','Marshall',''),(3155,'37144','','Moore',''),(3156,'37145','','Jackson',''),(3157,'37145','','Macon',''),(3158,'37146','','Robertson',''),(3159,'37148','','Robertson',''),(3160,'37149','','Rutherford',''),(3161,'37150','','Clay',''),(3162,'37153','','Bedford',''),(3163,'37160','','Moore',''),(3164,'37166','','Cannon',''),(3165,'37166','','Warren',''),(3166,'37174','','Maury',''),(3167,'37175','','Stewart',''),(3168,'37178','','Stewart',''),(3169,'37181','','Houston',''),(3170,'37183','','Coffee',''),(3171,'37183','','Moore',''),(3172,'37184','','Smith',''),(3173,'37185','','Houston',''),(3174,'37186','','Macon',''),(3175,'37187','','Cheatham',''),(3176,'37188','','Sumner',''),(3177,'37190','','Warren',''),(3178,'37215','','Williamson',''),(3179,'37221','','Williamson',''),(3180,'37306','','Moore',''),(3181,'37308','','Meigs',''),(3182,'37309','','Polk',''),(3183,'37310','','Polk',''),(3184,'37311','','Hamilton',''),(3185,'37321','','Bledsoe',''),(3186,'37322','','Mcminn',''),(3187,'37323','','Polk',''),(3188,'37324','','Grundy',''),(3189,'37325','','Mcminn',''),(3190,'37327','','Bledsoe',''),(3191,'37328','','Franklin',''),(3192,'37329','','Monroe',''),(3193,'37330','','Coffee',''),(3194,'37332','','Bledsoe',''),(3195,'37334','','Bedford',''),(3196,'37334','','Moore',''),(3197,'37335','','Franklin',''),(3198,'37336','','Hamilton',''),(3199,'37336','','Meigs',''),(3200,'37337','','Bledsoe',''),(3201,'37337','','Cumberland',''),(3202,'37338','','Bledsoe',''),(3203,'37338','','Hamilton',''),(3204,'37338','','Sequatchie',''),(3205,'37353','','Hamilton',''),(3206,'37354','','Mcminn',''),(3207,'37356','','Marion',''),(3208,'37357','','Cannon',''),(3209,'37357','','Coffee',''),(3210,'37357','','Grundy',''),(3211,'37359','','Moore',''),(3212,'37360','','Bedford',''),(3213,'37360','','Moore',''),(3214,'37362','','Bradley',''),(3215,'37365','','Sequatchie',''),(3216,'37367','','Cumberland',''),(3217,'37367','','Van Buren',''),(3218,'37369','','Monroe',''),(3219,'37375','','Marion',''),(3220,'37377','','Sequatchie',''),(3221,'37379','','Bledsoe',''),(3222,'37379','','Sequatchie',''),(3223,'37381','','Bledsoe',''),(3224,'37388','','Bedford',''),(3225,'37388','','Franklin',''),(3226,'37388','','Moore',''),(3227,'37397','','Sequatchie',''),(3228,'37398','','Moore',''),(3229,'37405','','Marion',''),(3230,'37419','','Marion',''),(3231,'37601','','Carter',''),(3232,'37601','','Unicoi',''),(3233,'37604','','Carter',''),(3234,'37640','','Carter',''),(3235,'37641','','Washington',''),(3236,'37650','','Washington',''),(3237,'37656','','Greene',''),(3238,'37656','','Sullivan',''),(3239,'37659','','Sullivan',''),(3240,'37660','','Hawkins',''),(3241,'37663','','Washington',''),(3242,'37681','','Greene',''),(3243,'37686','','Washington',''),(3244,'37694','','Sullivan',''),(3245,'37694','','Washington',''),(3246,'37705','','Union',''),(3247,'37709','','Knox',''),(3248,'37711','','Greene',''),(3249,'37711','','Hamblen',''),(3250,'37715','','Campbell',''),(3251,'37721','','Union',''),(3252,'37722','','Sevier',''),(3253,'37725','','Sevier',''),(3254,'37726','','Fentress',''),(3255,'37731','','Hancock',''),(3256,'37737','','Loudon',''),(3257,'37742','','Blount',''),(3258,'37743','','Cocke',''),(3259,'37748','','Morgan',''),(3260,'37752','','Hancock',''),(3261,'37754','','Knox',''),(3262,'37754','','Union',''),(3263,'37764','','Knox',''),(3264,'37769','','Campbell',''),(3265,'37771','','Roane',''),(3266,'37772','','Knox',''),(3267,'37774','','Monroe',''),(3268,'37774','','Roane',''),(3269,'37779','','Knox',''),(3270,'37801','','Monroe',''),(3271,'37807','','Knox',''),(3272,'37811','','Grainger',''),(3273,'37813','','Jefferson',''),(3274,'37825','','Union',''),(3275,'37826','','Meigs',''),(3276,'37830','','Knox',''),(3277,'37830','','Roane',''),(3278,'37840','','Anderson',''),(3279,'37840','','Morgan',''),(3280,'37846','','Mcminn',''),(3281,'37846','','Monroe',''),(3282,'37846','','Roane',''),(3283,'37847','','Campbell',''),(3284,'37848','','Union',''),(3285,'37849','','Anderson',''),(3286,'37852','','Morgan',''),(3287,'37853','','Knox',''),(3288,'37854','','Cumberland',''),(3289,'37854','','Morgan',''),(3290,'37857','','Sullivan',''),(3291,'37865','','Blount',''),(3292,'37869','','Claiborne',''),(3293,'37869','','Hawkins',''),(3294,'37870','','Campbell',''),(3295,'37870','','Union',''),(3296,'37871','','Knox',''),(3297,'37871','','Sevier',''),(3298,'37872','','Scott',''),(3299,'37874','','Loudon',''),(3300,'37874','','Mcminn',''),(3301,'37876','','Jefferson',''),(3302,'37877','','Jefferson',''),(3303,'37879','','Hancock',''),(3304,'37880','','Roane',''),(3305,'37881','','Hancock',''),(3306,'37881','','Hawkins',''),(3307,'37885','','Loudon',''),(3308,'37888','','Union',''),(3309,'37890','','Hamblen',''),(3310,'37891','','Hawkins',''),(3311,'37920','','Blount',''),(3312,'37931','','Anderson',''),(3313,'38002','','Fayette',''),(3314,'38004','','Shelby',''),(3315,'38006','','Haywood',''),(3316,'38006','','Madison',''),(3317,'38011','','Shelby',''),(3318,'38017','','Fayette',''),(3319,'38028','','Shelby',''),(3320,'38034','','Dyer',''),(3321,'38037','','Haywood',''),(3322,'38039','','Fayette',''),(3323,'38040','','Crockett',''),(3324,'38040','','Dyer',''),(3325,'38042','','Fayette',''),(3326,'38044','','Chester',''),(3327,'38044','','Mcnairy',''),(3328,'38049','','Fayette',''),(3329,'38053','','Tipton',''),(3330,'38059','','Gibson',''),(3331,'38061','','Mcnairy',''),(3332,'38063','','Haywood',''),(3333,'38069','','Tipton',''),(3334,'38075','','Fayette',''),(3335,'38075','','Haywood',''),(3336,'38079','','Fulton',''),(3337,'38080','','Dyer',''),(3338,'38080','','Obion',''),(3339,'38201','','Henry',''),(3340,'38201','','Weakley',''),(3341,'38220','','Gibson',''),(3342,'38224','','Weakley',''),(3343,'38233','','Obion',''),(3344,'38240','','Dyer',''),(3345,'38242','','Weakley',''),(3346,'38257','','Weakley',''),(3347,'38259','','Gibson',''),(3348,'38259','','Obion',''),(3349,'38305','','Carroll',''),(3350,'38310','','Hardin',''),(3351,'38313','','Chester',''),(3352,'38313','','Henderson',''),(3353,'38315','','Chester',''),(3354,'38317','','Benton',''),(3355,'38321','','Henderson',''),(3356,'38326','','Tishomingo',''),(3357,'38329','','Henderson',''),(3358,'38332','','Mcnairy',''),(3359,'38334','','Chester',''),(3360,'38340','','Hardeman',''),(3361,'38341','','Carroll',''),(3362,'38341','','Decatur',''),(3363,'38343','','Crockett',''),(3364,'38343','','Madison',''),(3365,'38351','','Madison',''),(3366,'38352','','Henderson',''),(3367,'38355','','Madison',''),(3368,'38356','','Chester',''),(3369,'38356','','Hardeman',''),(3370,'38357','','Hardin',''),(3371,'38359','','Chester',''),(3372,'38359','','Hardin',''),(3373,'38361','','Mcnairy',''),(3374,'38363','','Henderson',''),(3375,'38366','','Chester',''),(3376,'38368','','Chester',''),(3377,'38371','','Hardin',''),(3378,'38374','','Decatur',''),(3379,'38376','','Mcnairy',''),(3380,'38380','','Benton',''),(3381,'38390','','Henderson',''),(3382,'38392','','Hardeman',''),(3383,'38401','','Marshall',''),(3384,'38401','','Williamson',''),(3385,'38425','','Hardin',''),(3386,'38425','','Perry',''),(3387,'38449','','Lincoln',''),(3388,'38451','','Giles',''),(3389,'38451','','Marshall',''),(3390,'38453','','Giles',''),(3391,'38456','','Giles',''),(3392,'38459','','Giles',''),(3393,'38461','','Lewis',''),(3394,'38462','','Hickman',''),(3395,'38463','','Lawrence',''),(3396,'38464','','Giles',''),(3397,'38464','','Wayne',''),(3398,'38468','','Giles',''),(3399,'38472','','Marshall',''),(3400,'38474','','Giles',''),(3401,'38474','','Lawrence',''),(3402,'38474','','Lewis',''),(3403,'38475','','Wayne',''),(3404,'38476','','Hickman',''),(3405,'38476','','Maury',''),(3406,'38483','','Giles',''),(3407,'38483','','Lewis',''),(3408,'38483','','Maury',''),(3409,'38485','','Lewis',''),(3410,'38486','','Wayne',''),(3411,'38487','','Hickman',''),(3412,'38501','','Jackson',''),(3413,'38501','','Overton',''),(3414,'38504','','Scott',''),(3415,'38506','','Overton',''),(3416,'38506','','White',''),(3417,'38541','','Clay',''),(3418,'38543','','Pickett',''),(3419,'38544','','Dekalb',''),(3420,'38545','','Putnam',''),(3421,'38548','','Smith',''),(3422,'38549','','Fentress',''),(3423,'38551','','Jackson',''),(3424,'38556','','Pickett',''),(3425,'38559','','Van Buren',''),(3426,'38564','','Putnam',''),(3427,'38567','','Dekalb',''),(3428,'38568','','Clay',''),(3429,'38568','','Jackson',''),(3430,'38569','','Dekalb',''),(3431,'38572','','Bledsoe',''),(3432,'38573','','Pickett',''),(3433,'38574','','Cumberland',''),(3434,'38574','','Fentress',''),(3435,'38574','','Overton',''),(3436,'38577','','Fentress',''),(3437,'38581','','Dekalb',''),(3438,'38581','','Van Buren',''),(3439,'38582','','Dekalb',''),(3440,'38583','','Cumberland',''),(3441,'38583','','Dekalb',''),(3442,'38583','','Putnam',''),(3443,'38583','','Van Buren',''),(3444,'38588','','Clay',''),(3445,'38589','','Fentress',''),(3446,'38603','','Tippah',''),(3447,'38606','','Lafayette',''),(3448,'38606','','Quitman',''),(3449,'38610','','Benton',''),(3450,'38610','','Union',''),(3451,'38611','','Desoto',''),(3452,'38614','','Bolivar',''),(3453,'38618','','Desoto',''),(3454,'38618','','Marshall',''),(3455,'38619','','Lafayette',''),(3456,'38619','','Tate',''),(3457,'38621','','Quitman',''),(3458,'38622','','Panola',''),(3459,'38625','','Union',''),(3460,'38626','','Coahoma',''),(3461,'38627','','Lafayette',''),(3462,'38629','','Benton',''),(3463,'38633','','Union',''),(3464,'38635','','Benton',''),(3465,'38635','','Tate',''),(3466,'38642','','Marshall',''),(3467,'38643','','Tallahatchie',''),(3468,'38645','','Quitman',''),(3469,'38650','','Benton',''),(3470,'38654','','Marshall',''),(3471,'38659','','Benton',''),(3472,'38663','','Benton',''),(3473,'38665','','Panola',''),(3474,'38670','','Tunica',''),(3475,'38683','','Alcorn',''),(3476,'38683','','Benton',''),(3477,'38685','','Lafayette',''),(3478,'38702','','Bolivar',''),(3479,'38703','','Bolivar',''),(3480,'38720','','Bolivar',''),(3481,'38732','','Sunflower',''),(3482,'38736','','Leflore',''),(3483,'38737','','Tallahatchie',''),(3484,'38744','','Issaquena',''),(3485,'38748','','Sharkey',''),(3486,'38753','','Humphreys',''),(3487,'38754','','Sunflower',''),(3488,'38759','','Sunflower',''),(3489,'38761','','Leflore',''),(3490,'38762','','Sunflower',''),(3491,'38769','','Desha',''),(3492,'38773','','Sunflower',''),(3493,'38801','','Pontotoc',''),(3494,'38804','','Itawamba',''),(3495,'38824','','Itawamba',''),(3496,'38824','','Lee',''),(3497,'38824','','Tippah',''),(3498,'38824','','Union',''),(3499,'38826','','Pontotoc',''),(3500,'38828','','Lee',''),(3501,'38828','','Pontotoc',''),(3502,'38829','','Tippah',''),(3503,'38833','','Alcorn',''),(3504,'38833','','Prentiss',''),(3505,'38841','','Union',''),(3506,'38843','','Lee',''),(3507,'38846','','Tishomingo',''),(3508,'38847','','Tishomingo',''),(3509,'38849','','Itawamba',''),(3510,'38849','','Union',''),(3511,'38850','','Calhoun',''),(3512,'38850','','Pontotoc',''),(3513,'38852','','Colbert',''),(3514,'38856','','Prentiss',''),(3515,'38858','','Itawamba',''),(3516,'38858','','Lee',''),(3517,'38860','','Lee',''),(3518,'38860','','Monroe',''),(3519,'38863','','Lafayette',''),(3520,'38864','','Calhoun',''),(3521,'38865','','Prentiss',''),(3522,'38868','','Chickasaw',''),(3523,'38868','','Monroe',''),(3524,'38868','','Pontotoc',''),(3525,'38870','','Itawamba',''),(3526,'38871','','Lafayette',''),(3527,'38871','','Union',''),(3528,'38873','','Prentiss',''),(3529,'38878','','Chickasaw',''),(3530,'38901','','Carroll',''),(3531,'38901','','Tallahatchie',''),(3532,'38914','','Grenada',''),(3533,'38916','','Webster',''),(3534,'38922','','Grenada',''),(3535,'38924','','Carroll',''),(3536,'38924','','Humphreys',''),(3537,'38924','','Leflore',''),(3538,'38925','','Grenada',''),(3539,'38925','','Webster',''),(3540,'38927','','Panola',''),(3541,'38927','','Yalobusha',''),(3542,'38929','','Calhoun',''),(3543,'38929','','Webster',''),(3544,'38930','','Carroll',''),(3545,'38940','','Carroll',''),(3546,'38940','','Tallahatchie',''),(3547,'38948','','Tallahatchie',''),(3548,'38953','','Grenada',''),(3549,'38953','','Yalobusha',''),(3550,'38954','','Carroll',''),(3551,'38961','','Tallahatchie',''),(3552,'38963','','Coahoma',''),(3553,'38963','','Sunflower',''),(3554,'38964','','Tallahatchie',''),(3555,'38965','','Calhoun',''),(3556,'38965','','Lafayette',''),(3557,'38965','','Panola',''),(3558,'38967','','Carroll',''),(3559,'39038','','Holmes',''),(3560,'39038','','Leflore',''),(3561,'39042','','Smith',''),(3562,'39044','','Rankin',''),(3563,'39051','','Attala',''),(3564,'39051','','Madison',''),(3565,'39051','','Neshoba',''),(3566,'39057','','Scott',''),(3567,'39059','','Hinds',''),(3568,'39071','','Hinds',''),(3569,'39073','','Simpson',''),(3570,'39074','','Smith',''),(3571,'39079','','Attala',''),(3572,'39079','','Madison',''),(3573,'39086','','Copiah',''),(3574,'39088','','Sharkey',''),(3575,'39090','','Leake',''),(3576,'39092','','Newton',''),(3577,'39092','','Smith',''),(3578,'39094','','Rankin',''),(3579,'39094','','Scott',''),(3580,'39095','','Carroll',''),(3581,'39095','','Yazoo',''),(3582,'39096','','Jefferson',''),(3583,'39108','','Choctaw',''),(3584,'39108','','Winston',''),(3585,'39111','','Smith',''),(3586,'39114','','Rankin',''),(3587,'39114','','Smith',''),(3588,'39117','','Rankin',''),(3589,'39117','','Smith',''),(3590,'39119','','Jefferson Davis',''),(3591,'39119','','Simpson',''),(3592,'39119','','Smith',''),(3593,'39120','','Jefferson',''),(3594,'39140','','Jefferson Davis',''),(3595,'39140','','Simpson',''),(3596,'39144','','Copiah',''),(3597,'39144','','Jefferson',''),(3598,'39145','','Scott',''),(3599,'39146','','Madison',''),(3600,'39146','','Yazoo',''),(3601,'39152','','Scott',''),(3602,'39159','','Issaquena',''),(3603,'39160','','Leake',''),(3604,'39168','','Covington',''),(3605,'39168','','Jones',''),(3606,'39170','','Copiah',''),(3607,'39174','','Hinds',''),(3608,'39175','','Claiborne',''),(3609,'39175','','Copiah',''),(3610,'39176','','Attala',''),(3611,'39176','','Montgomery',''),(3612,'39183','','Issaquena',''),(3613,'39189','','Scott',''),(3614,'39191','','Lawrence',''),(3615,'39191','','Lincoln',''),(3616,'39192','','Carroll',''),(3617,'39192','','Holmes',''),(3618,'39194','','Humphreys',''),(3619,'39209','','Madison',''),(3620,'39213','','Madison',''),(3621,'39301','','Clarke',''),(3622,'39320','','Kemper',''),(3623,'39323','','Lauderdale',''),(3624,'39325','','Kemper',''),(3625,'39325','','Neshoba',''),(3626,'39325','','Newton',''),(3627,'39326','','Kemper',''),(3628,'39330','','Jasper',''),(3629,'39330','','Lauderdale',''),(3630,'39330','','Newton',''),(3631,'39332','','Jasper',''),(3632,'39335','','Kemper',''),(3633,'39336','','Jasper',''),(3634,'39336','','Smith',''),(3635,'39337','','Neshoba',''),(3636,'39338','','Smith',''),(3637,'39341','','Winston',''),(3638,'39345','','Jasper',''),(3639,'39346','','Neshoba',''),(3640,'39347','','Clarke',''),(3641,'39350','','Kemper',''),(3642,'39350','','Leake',''),(3643,'39350','','Winston',''),(3644,'39354','','Neshoba',''),(3645,'39354','','Noxubee',''),(3646,'39354','','Winston',''),(3647,'39358','','Noxubee',''),(3648,'39360','','Wayne',''),(3649,'39361','','Kemper',''),(3650,'39362','','Greene',''),(3651,'39365','','Kemper',''),(3652,'39365','','Leake',''),(3653,'39365','','Newton',''),(3654,'39366','','Clarke',''),(3655,'39367','','Clarke',''),(3656,'39401','','Covington',''),(3657,'39401','','Jones',''),(3658,'39401','','Lamar',''),(3659,'39402','','Covington',''),(3660,'39402','','Forrest',''),(3661,'39421','','Marion',''),(3662,'39422','','Smith',''),(3663,'39425','','Perry',''),(3664,'39426','','Hancock',''),(3665,'39429','','Jefferson Davis',''),(3666,'39429','','Lamar',''),(3667,'39439','','Clarke',''),(3668,'39439','','Jones',''),(3669,'39439','','Wayne',''),(3670,'39443','','Jasper',''),(3671,'39443','','Wayne',''),(3672,'39452','','Greene',''),(3673,'39452','','Jackson',''),(3674,'39455','','Forrest',''),(3675,'39455','','Marion',''),(3676,'39455','','Pearl River',''),(3677,'39455','','Stone',''),(3678,'39456','','Perry',''),(3679,'39464','','Perry',''),(3680,'39465','','Jones',''),(3681,'39465','','Perry',''),(3682,'39466','','Hancock',''),(3683,'39470','','Hancock',''),(3684,'39474','','Covington',''),(3685,'39475','','Forrest',''),(3686,'39476','','Greene',''),(3687,'39476','','Jones',''),(3688,'39476','','Wayne',''),(3689,'39478','','Walthall',''),(3690,'39479','','Jones',''),(3691,'39480','','Jasper',''),(3692,'39482','','Covington',''),(3693,'39482','','Jefferson Davis',''),(3694,'39482','','Marion',''),(3695,'39483','','Walthall',''),(3696,'39532','','Jackson',''),(3697,'39565','','Harrison',''),(3698,'39571','','Hancock',''),(3699,'39573','','George',''),(3700,'39573','','Hancock',''),(3701,'39573','','Harrison',''),(3702,'39573','','Jackson',''),(3703,'39573','','Pearl River',''),(3704,'39574','','Stone',''),(3705,'39577','','Forrest',''),(3706,'39577','','Perry',''),(3707,'39601','','Franklin',''),(3708,'39631','','Amite',''),(3709,'39633','','Amite',''),(3710,'39638','','Wilkinson',''),(3711,'39641','','Lawrence',''),(3712,'39641','','Lincoln',''),(3713,'39641','','Pike',''),(3714,'39643','','Walthall',''),(3715,'39647','','Lincoln',''),(3716,'39652','','Amite',''),(3717,'39653','','Amite',''),(3718,'39653','','Jefferson',''),(3719,'39656','','Lawrence',''),(3720,'39657','','Amite',''),(3721,'39661','','Adams',''),(3722,'39662','','Lawrence',''),(3723,'39662','','Pike',''),(3724,'39663','','Jefferson Davis',''),(3725,'39664','','Franklin',''),(3726,'39664','','Lincoln',''),(3727,'39665','','Lincoln',''),(3728,'39666','','Amite',''),(3729,'39666','','Lincoln',''),(3730,'39667','','Marion',''),(3731,'39667','','Pike',''),(3732,'39668','','Franklin',''),(3733,'39668','','Lincoln',''),(3734,'39740','','Monroe',''),(3735,'39743','','Noxubee',''),(3736,'39743','','Oktibbeha',''),(3737,'39744','','Calhoun',''),(3738,'39744','','Choctaw',''),(3739,'39745','','Attala',''),(3740,'39745','','Montgomery',''),(3741,'39750','','Choctaw',''),(3742,'39750','','Clay',''),(3743,'39750','','Oktibbeha',''),(3744,'39751','','Chickasaw',''),(3745,'39751','','Clay',''),(3746,'39752','','Choctaw',''),(3747,'39755','','Oktibbeha',''),(3748,'39756','','Chickasaw',''),(3749,'39756','','Monroe',''),(3750,'39759','','Lowndes',''),(3751,'39767','','Choctaw',''),(3752,'39767','','Montgomery',''),(3753,'39769','','Choctaw',''),(3754,'39769','','Winston',''),(3755,'39773','','Monroe',''),(3756,'39776','','Clay',''),(3757,'39813','','Baker',''),(3758,'39813','','Early',''),(3759,'39823','','Miller',''),(3760,'39824','','Early',''),(3761,'39825','','Seminole',''),(3762,'39836','','Clay',''),(3763,'39837','','Baker',''),(3764,'39837','','Decatur',''),(3765,'39837','','Early',''),(3766,'39841','','Baker',''),(3767,'39841','','Miller',''),(3768,'39842','','Calhoun',''),(3769,'39845','','Early',''),(3770,'39845','','Miller',''),(3771,'39846','','Clay',''),(3772,'39854','','Clay',''),(3773,'39859','','Miller',''),(3774,'39861','','Seminole',''),(3775,'39862','','Baker',''),(3776,'39867','','Quitman',''),(3777,'39867','','Randolph',''),(3778,'39877','','Webster',''),(3779,'39886','','Calhoun',''),(3780,'39886','','Terrell',''),(3781,'39897','','Decatur',''),(3782,'40003','','Franklin',''),(3783,'40006','','Carroll',''),(3784,'40008','','Spencer',''),(3785,'40009','','Taylor',''),(3786,'40011','','Carroll',''),(3787,'40011','','Trimble',''),(3788,'40013','','Bullitt',''),(3789,'40013','','Spencer',''),(3790,'40019','','Shelby',''),(3791,'40023','','Shelby',''),(3792,'40023','','Spencer',''),(3793,'40031','','Henry',''),(3794,'40033','','Washington',''),(3795,'40037','','Nelson',''),(3796,'40045','','Carroll',''),(3797,'40046','','Anderson',''),(3798,'40046','','Shelby',''),(3799,'40047','','Spencer',''),(3800,'40051','','Hardin',''),(3801,'40051','','Larue',''),(3802,'40052','','Larue',''),(3803,'40052','','Marion',''),(3804,'40055','','Oldham',''),(3805,'40055','','Trimble',''),(3806,'40057','','Shelby',''),(3807,'40059','','Oldham',''),(3808,'40065','','Spencer',''),(3809,'40068','','Oldham',''),(3810,'40068','','Shelby',''),(3811,'40069','','Marion',''),(3812,'40071','','Bullitt',''),(3813,'40071','','Shelby',''),(3814,'40075','','Carroll',''),(3815,'40076','','Anderson',''),(3816,'40076','','Franklin',''),(3817,'40119','','Breckinridge',''),(3818,'40119','','Ohio',''),(3819,'40121','','Meade',''),(3820,'40142','','Breckinridge',''),(3821,'40150','','Hardin',''),(3822,'40157','','Breckinridge',''),(3823,'40175','','Breckinridge',''),(3824,'40175','','Meade',''),(3825,'40176','','Meade',''),(3826,'40177','','Bullitt',''),(3827,'40177','','Jefferson',''),(3828,'40229','','Bullitt',''),(3829,'40241','','Oldham',''),(3830,'40245','','Shelby',''),(3831,'40272','','Bullitt',''),(3832,'40299','','Bullitt',''),(3833,'40311','','Bourbon',''),(3834,'40311','','Robertson',''),(3835,'40324','','Bourbon',''),(3836,'40328','','Boyle',''),(3837,'40328','','Casey',''),(3838,'40330','','Washington',''),(3839,'40334','','Bath',''),(3840,'40336','','Lee',''),(3841,'40346','','Bath',''),(3842,'40346','','Montgomery',''),(3843,'40347','','Franklin',''),(3844,'40347','','Scott',''),(3845,'40351','','Carter',''),(3846,'40351','','Elliott',''),(3847,'40353','','Bath',''),(3848,'40353','','Clark',''),(3849,'40360','','Montgomery',''),(3850,'40361','','Fayette',''),(3851,'40361','','Montgomery',''),(3852,'40370','','Harrison',''),(3853,'40371','','Menifee',''),(3854,'40372','','Anderson',''),(3855,'40374','','Bourbon',''),(3856,'40374','','Nicholas',''),(3857,'40379','','Franklin',''),(3858,'40379','','Owen',''),(3859,'40380','','Menifee',''),(3860,'40383','','Jessamine',''),(3861,'40387','','Morgan',''),(3862,'40390','','Woodford',''),(3863,'40403','','Garrard',''),(3864,'40403','','Rockcastle',''),(3865,'40409','','Lincoln',''),(3866,'40409','','Pulaski',''),(3867,'40419','','Garrard',''),(3868,'40419','','Pulaski',''),(3869,'40419','','Rockcastle',''),(3870,'40422','','Lincoln',''),(3871,'40437','','Casey',''),(3872,'40440','','Lincoln',''),(3873,'40442','','Casey',''),(3874,'40444','','Lincoln',''),(3875,'40445','','Jackson',''),(3876,'40447','','Lee',''),(3877,'40447','','Owsley',''),(3878,'40447','','Rockcastle',''),(3879,'40461','','Garrard',''),(3880,'40464','','Casey',''),(3881,'40468','','Mercer',''),(3882,'40468','','Washington',''),(3883,'40484','','Garrard',''),(3884,'40486','','Clay',''),(3885,'40486','','Owsley',''),(3886,'40489','','Casey',''),(3887,'40511','','Bourbon',''),(3888,'40511','','Scott',''),(3889,'40515','','Clark',''),(3890,'40515','','Jessamine',''),(3891,'40516','','Bourbon',''),(3892,'40601','','Henry',''),(3893,'40601','','Shelby',''),(3894,'40601','','Woodford',''),(3895,'40701','','Knox',''),(3896,'40701','','Laurel',''),(3897,'40734','','Laurel',''),(3898,'40741','','Clay',''),(3899,'40744','','Clay',''),(3900,'40759','','Knox',''),(3901,'40763','','Knox',''),(3902,'40769','','Mccreary',''),(3903,'40771','','Whitley',''),(3904,'40808','','Leslie',''),(3905,'40810','','Leslie',''),(3906,'40823','','Letcher',''),(3907,'40840','','Harlan',''),(3908,'40874','','Clay',''),(3909,'40906','','Whitley',''),(3910,'40913','','Bell',''),(3911,'40940','','Bell',''),(3912,'40962','','Laurel',''),(3913,'40972','','Perry',''),(3914,'40983','','Owsley',''),(3915,'40988','','Harlan',''),(3916,'41003','','Grant',''),(3917,'41003','','Pendleton',''),(3918,'41004','','Pendleton',''),(3919,'41004','','Robertson',''),(3920,'41006','','Campbell',''),(3921,'41007','','Pendleton',''),(3922,'41010','','Harrison',''),(3923,'41010','','Owen',''),(3924,'41010','','Scott',''),(3925,'41018','','Boone',''),(3926,'41030','','Boone',''),(3927,'41030','','Kenton',''),(3928,'41030','','Pendleton',''),(3929,'41031','','Bourbon',''),(3930,'41031','','Nicholas',''),(3931,'41033','','Kenton',''),(3932,'41035','','Pendleton',''),(3933,'41039','','Nicholas',''),(3934,'41040','','Bracken',''),(3935,'41042','','Kenton',''),(3936,'41043','','Pendleton',''),(3937,'41044','','Mason',''),(3938,'41044','','Robertson',''),(3939,'41045','','Gallatin',''),(3940,'41046','','Grant',''),(3941,'41046','','Owen',''),(3942,'41055','','Fleming',''),(3943,'41064','','Bracken',''),(3944,'41083','','Gallatin',''),(3945,'41083','','Owen',''),(3946,'41086','','Owen',''),(3947,'41092','','Gallatin',''),(3948,'41093','','Lewis',''),(3949,'41094','','Kenton',''),(3950,'41097','','Pendleton',''),(3951,'41098','','Carroll',''),(3952,'41101','','Greenup',''),(3953,'41102','','Greenup',''),(3954,'41129','','Lawrence',''),(3955,'41132','','Lawrence',''),(3956,'41141','','Greenup',''),(3957,'41143','','Greenup',''),(3958,'41164','','Elliott',''),(3959,'41164','','Lewis',''),(3960,'41168','','Carter',''),(3961,'41174','','Lewis',''),(3962,'41180','','Carter',''),(3963,'41180','','Elliott',''),(3964,'41216','','Johnson',''),(3965,'41230','','Martin',''),(3966,'41232','','Johnson',''),(3967,'41254','','Lawrence',''),(3968,'41265','','Floyd',''),(3969,'41301','','Breathitt',''),(3970,'41301','','Lee',''),(3971,'41311','','Breathitt',''),(3972,'41314','','Breathitt',''),(3973,'41332','','Morgan',''),(3974,'41339','','Knott',''),(3975,'41339','','Lee',''),(3976,'41360','','Powell',''),(3977,'41472','','Elliott',''),(3978,'41537','','Pike',''),(3979,'41630','','Knott',''),(3980,'41640','','Knott',''),(3981,'41640','','Magoffin',''),(3982,'41643','','Floyd',''),(3983,'41701','','Knott',''),(3984,'41714','','Clay',''),(3985,'41721','','Owsley',''),(3986,'41722','','Knott',''),(3987,'41723','','Leslie',''),(3988,'41731','','Letcher',''),(3989,'41739','','Knott',''),(3990,'41759','','Perry',''),(3991,'41773','','Knott',''),(3992,'42021','','Hickman',''),(3993,'42025','','Calloway',''),(3994,'42025','','Graves',''),(3995,'42027','','Mccracken',''),(3996,'42035','','Graves',''),(3997,'42038','','Caldwell',''),(3998,'42039','','Carlisle',''),(3999,'42039','','Hickman',''),(4000,'42040','','Calloway',''),(4001,'42041','','Graves',''),(4002,'42041','','Hickman',''),(4003,'42048','','Calloway',''),(4004,'42049','','Graves',''),(4005,'42053','','Ballard',''),(4006,'42054','','Graves',''),(4007,'42054','','Marshall',''),(4008,'42064','','Caldwell',''),(4009,'42066','','Marshall',''),(4010,'42069','','Mccracken',''),(4011,'42071','','Graves',''),(4012,'42078','','Crittenden',''),(4013,'42082','','Mccracken',''),(4014,'42082','','Marshall',''),(4015,'42085','','Hickman',''),(4016,'42088','','Hickman',''),(4017,'42101','','Butler',''),(4018,'42101','','Edmonson',''),(4019,'42104','','Simpson',''),(4020,'42122','','Allen',''),(4021,'42127','','Hart',''),(4022,'42129','','Adair',''),(4023,'42129','','Cumberland',''),(4024,'42133','','Allen',''),(4025,'42133','','Barren',''),(4026,'42134','','Allen',''),(4027,'42134','','Logan',''),(4028,'42154','','Barren',''),(4029,'42160','','Edmonson',''),(4030,'42166','','Barren',''),(4031,'42166','','Monroe',''),(4032,'42167','','Cumberland',''),(4033,'42170','','Simpson',''),(4034,'42171','','Barren',''),(4035,'42171','','Edmonson',''),(4036,'42202','','Simpson',''),(4037,'42204','','Logan',''),(4038,'42206','','Simpson',''),(4039,'42206','','Warren',''),(4040,'42207','','Grayson',''),(4041,'42214','','Green',''),(4042,'42215','','Trigg',''),(4043,'42223','','Montgomery',''),(4044,'42232','','Trigg',''),(4045,'42236','','Trigg',''),(4046,'42256','','Butler',''),(4047,'42256','','Muhlenberg',''),(4048,'42256','','Todd',''),(4049,'42265','','Todd',''),(4050,'42266','','Todd',''),(4051,'42274','','Logan',''),(4052,'42275','','Edmonson',''),(4053,'42301','','Henderson',''),(4054,'42320','','Butler',''),(4055,'42327','','Daviess',''),(4056,'42333','','Butler',''),(4057,'42339','','Butler',''),(4058,'42343','','Hancock',''),(4059,'42345','','Todd',''),(4060,'42348','','Daviess',''),(4061,'42349','','Grayson',''),(4062,'42351','','Daviess',''),(4063,'42352','','Ohio',''),(4064,'42361','','Grayson',''),(4065,'42366','','Hancock',''),(4066,'42366','','Ohio',''),(4067,'42368','','Hancock',''),(4068,'42372','','Muhlenberg',''),(4069,'42376','','Mclean',''),(4070,'42376','','Ohio',''),(4071,'42378','','Ohio',''),(4072,'42404','','Union',''),(4073,'42406','','Webster',''),(4074,'42408','','Caldwell',''),(4075,'42408','','Christian',''),(4076,'42411','','Crittenden',''),(4077,'42411','','Lyon',''),(4078,'42437','','Webster',''),(4079,'42441','','Webster',''),(4080,'42442','','Christian',''),(4081,'42445','','Hopkins',''),(4082,'42445','','Lyon',''),(4083,'42450','','Crittenden',''),(4084,'42450','','Hopkins',''),(4085,'42452','','Webster',''),(4086,'42453','','Christian',''),(4087,'42456','','Hopkins',''),(4088,'42459','','Crittenden',''),(4089,'42462','','Henderson',''),(4090,'42464','','Christian',''),(4091,'42464','','Muhlenberg',''),(4092,'42518','','Wayne',''),(4093,'42528','','Adair',''),(4094,'42528','','Russell',''),(4095,'42539','','Adair',''),(4096,'42544','','Russell',''),(4097,'42544','','Wayne',''),(4098,'42567','','Lincoln',''),(4099,'42602','','Russell',''),(4100,'42602','','Wayne',''),(4101,'42602','','Pickett',''),(4102,'42633','','Clinton',''),(4103,'42642','','Adair',''),(4104,'42642','','Casey',''),(4105,'42642','','Pulaski',''),(4106,'42712','','Hardin',''),(4107,'42716','','Green',''),(4108,'42716','','Taylor',''),(4109,'42717','','Clinton',''),(4110,'42718','','Green',''),(4111,'42718','','Larue',''),(4112,'42718','','Marion',''),(4113,'42721','','Butler',''),(4114,'42721','','Edmonson',''),(4115,'42728','','Taylor',''),(4116,'42729','','Edmonson',''),(4117,'42731','','Metcalfe',''),(4118,'42733','','Adair',''),(4119,'42733','','Casey',''),(4120,'42743','','Adair',''),(4121,'42746','','Green',''),(4122,'42746','','Metcalfe',''),(4123,'42749','','Barren',''),(4124,'42749','','Metcalfe',''),(4125,'42754','','Breckinridge',''),(4126,'42754','','Edmonson',''),(4127,'42757','','Green',''),(4128,'42757','','Larue',''),(4129,'42764','','Larue',''),(4130,'42776','','Larue',''),(4131,'42782','','Hart',''),(4132,'42784','','Hart',''),(4133,'42784','','Larue',''),(4134,'43003','','Morrow',''),(4135,'43006','','Coshocton',''),(4136,'43006','','Knox',''),(4137,'43011','','Delaware',''),(4138,'43011','','Licking',''),(4139,'43011','','Morrow',''),(4140,'43015','','Union',''),(4141,'43016','','Delaware',''),(4142,'43016','','Union',''),(4143,'43017','','Delaware',''),(4144,'43017','','Union',''),(4145,'43019','','Morrow',''),(4146,'43019','','Richland',''),(4147,'43026','','Madison',''),(4148,'43029','','Union',''),(4149,'43031','','Delaware',''),(4150,'43040','','Delaware',''),(4151,'43044','','Clark',''),(4152,'43044','','Madison',''),(4153,'43045','','Champaign',''),(4154,'43046','','Licking',''),(4155,'43050','','Morrow',''),(4156,'43060','','Logan',''),(4157,'43060','','Union',''),(4158,'43061','','Union',''),(4159,'43062','','Fairfield',''),(4160,'43064','','Franklin',''),(4161,'43064','','Union',''),(4162,'43065','','Franklin',''),(4163,'43068','','Fairfield',''),(4164,'43068','','Licking',''),(4165,'43074','','Licking',''),(4166,'43076','','Fairfield',''),(4167,'43076','','Licking',''),(4168,'43078','','Clark',''),(4169,'43080','','Knox',''),(4170,'43084','','Union',''),(4171,'43102','','Hocking',''),(4172,'43102','','Pickaway',''),(4173,'43107','','Hocking',''),(4174,'43107','','Perry',''),(4175,'43110','','Fairfield',''),(4176,'43110','','Pickaway',''),(4177,'43113','','Fairfield',''),(4178,'43115','','Pickaway',''),(4179,'43119','','Madison',''),(4180,'43125','','Pickaway',''),(4181,'43135','','Pickaway',''),(4182,'43135','','Ross',''),(4183,'43135','','Vinton',''),(4184,'43137','','Franklin',''),(4185,'43138','','Perry',''),(4186,'43138','','Vinton',''),(4187,'43140','','Clark',''),(4188,'43140','','Franklin',''),(4189,'43143','','Fayette',''),(4190,'43143','','Pickaway',''),(4191,'43145','','Fayette',''),(4192,'43146','','Franklin',''),(4193,'43146','','Madison',''),(4194,'43147','','Franklin',''),(4195,'43147','','Licking',''),(4196,'43148','','Perry',''),(4197,'43150','','Perry',''),(4198,'43152','','Vinton',''),(4199,'43153','','Clark',''),(4200,'43153','','Fayette',''),(4201,'43153','','Greene',''),(4202,'43154','','Pickaway',''),(4203,'43155','','Hocking',''),(4204,'43160','','Ross',''),(4205,'43164','','Ross',''),(4206,'43302','','Crawford',''),(4207,'43302','','Union',''),(4208,'43310','','Hardin',''),(4209,'43314','','Crawford',''),(4210,'43314','','Morrow',''),(4211,'43315','','Marion',''),(4212,'43316','','Hancock',''),(4213,'43316','','Seneca',''),(4214,'43318','','Champaign',''),(4215,'43319','','Union',''),(4216,'43331','','Auglaize',''),(4217,'43331','','Hardin',''),(4218,'43332','','Hardin',''),(4219,'43332','','Wyandot',''),(4220,'43334','','Delaware',''),(4221,'43337','','Wyandot',''),(4222,'43340','','Union',''),(4223,'43342','','Delaware',''),(4224,'43342','','Union',''),(4225,'43343','','Champaign',''),(4226,'43344','','Delaware',''),(4227,'43344','','Marion',''),(4228,'43345','','Logan',''),(4229,'43347','','Hardin',''),(4230,'43356','','Delaware',''),(4231,'43356','','Morrow',''),(4232,'43357','','Champaign',''),(4233,'43358','','Union',''),(4234,'43406','','Sandusky',''),(4235,'43410','','Seneca',''),(4236,'43412','','Ottawa',''),(4237,'43416','','Sandusky',''),(4238,'43430','','Sandusky',''),(4239,'43430','','Wood',''),(4240,'43445','','Lucas',''),(4241,'43447','','Ottawa',''),(4242,'43449','','Sandusky',''),(4243,'43457','','Sandusky',''),(4244,'43457','','Seneca',''),(4245,'43464','','Erie',''),(4246,'43469','','Ottawa',''),(4247,'43502','','Henry',''),(4248,'43502','','Williams',''),(4249,'43506','','Defiance',''),(4250,'43511','','Henry',''),(4251,'43512','','Henry',''),(4252,'43512','','Paulding',''),(4253,'43516','','Hancock',''),(4254,'43516','','Wood',''),(4255,'43517','','Defiance',''),(4256,'43521','','Williams',''),(4257,'43522','','Henry',''),(4258,'43522','','Lucas',''),(4259,'43526','','Paulding',''),(4260,'43527','','Defiance',''),(4261,'43532','','Fulton',''),(4262,'43532','','Lucas',''),(4263,'43545','','Defiance',''),(4264,'43548','','Defiance',''),(4265,'43548','','Putnam',''),(4266,'43557','','Fulton',''),(4267,'43557','','Henry',''),(4268,'43558','','Lucas',''),(4269,'43567','','Henry',''),(4270,'43570','','Fulton',''),(4271,'43605','','Wood',''),(4272,'43716','','Belmont',''),(4273,'43724','','Morgan',''),(4274,'43728','','Athens',''),(4275,'43731','','Morgan',''),(4276,'43732','','Muskingum',''),(4277,'43732','','Noble',''),(4278,'43739','','Licking',''),(4279,'43740','','Muskingum',''),(4280,'43746','','Licking',''),(4281,'43747','','Belmont',''),(4282,'43749','','Coshocton',''),(4283,'43749','','Tuscarawas',''),(4284,'43760','','Licking',''),(4285,'43760','','Muskingum',''),(4286,'43762','','Guernsey',''),(4287,'43766','','Hocking',''),(4288,'43772','','Noble',''),(4289,'43773','','Monroe',''),(4290,'43773','','Noble',''),(4291,'43777','','Perry',''),(4292,'43778','','Noble',''),(4293,'43780','','Noble',''),(4294,'43787','','Washington',''),(4295,'43788','','Monroe',''),(4296,'43804','','Coshocton',''),(4297,'43804','','Tuscarawas',''),(4298,'43812','','Muskingum',''),(4299,'43821','','Coshocton',''),(4300,'43822','','Coshocton',''),(4301,'43822','','Knox',''),(4302,'43822','','Licking',''),(4303,'43824','','Tuscarawas',''),(4304,'43830','','Licking',''),(4305,'43832','','Coshocton',''),(4306,'43832','','Guernsey',''),(4307,'43837','','Guernsey',''),(4308,'43840','','Coshocton',''),(4309,'43843','','Knox',''),(4310,'43901','','Belmont',''),(4311,'43901','','Harrison',''),(4312,'43903','','Carroll',''),(4313,'43907','','Jefferson',''),(4314,'43908','','Carroll',''),(4315,'43910','','Harrison',''),(4316,'43917','','Belmont',''),(4317,'43930','','Columbiana',''),(4318,'43942','','Monroe',''),(4319,'43943','','Belmont',''),(4320,'43945','','Carroll',''),(4321,'43945','','Jefferson',''),(4322,'43950','','Harrison',''),(4323,'43971','','Belmont',''),(4324,'43973','','Guernsey',''),(4325,'43977','','Harrison',''),(4326,'43983','','Guernsey',''),(4327,'43983','','Harrison',''),(4328,'43986','','Carroll',''),(4329,'43988','','Carroll',''),(4330,'44022','','Geauga',''),(4331,'44024','','Lake',''),(4332,'44041','','Lake',''),(4333,'44057','','Ashtabula',''),(4334,'44057','','Geauga',''),(4335,'44060','','Geauga',''),(4336,'44062','','Ashtabula',''),(4337,'44062','','Trumbull',''),(4338,'44064','','Ashtabula',''),(4339,'44076','','Trumbull',''),(4340,'44086','','Ashtabula',''),(4341,'44086','','Lake',''),(4342,'44089','','Lorain',''),(4343,'44099','','Geauga',''),(4344,'44136','','Medina',''),(4345,'44141','','Summit',''),(4346,'44201','','Stark',''),(4347,'44202','','Geauga',''),(4348,'44202','','Summit',''),(4349,'44203','','Medina',''),(4350,'44214','','Medina',''),(4351,'44216','','Stark',''),(4352,'44217','','Medina',''),(4353,'44224','','Portage',''),(4354,'44230','','Medina',''),(4355,'44231','','Geauga',''),(4356,'44234','','Geauga',''),(4357,'44235','','Ashland',''),(4358,'44236','','Portage',''),(4359,'44240','','Summit',''),(4360,'44253','','Lorain',''),(4361,'44256','','Lorain',''),(4362,'44256','','Summit',''),(4363,'44260','','Stark',''),(4364,'44260','','Summit',''),(4365,'44270','','Medina',''),(4366,'44273','','Wayne',''),(4367,'44275','','Lorain',''),(4368,'44278','','Portage',''),(4369,'44280','','Lorain',''),(4370,'44281','','Summit',''),(4371,'44287','','Ashland',''),(4372,'44287','','Medina',''),(4373,'44312','','Portage',''),(4374,'44321','','Medina',''),(4375,'44333','','Medina',''),(4376,'44408','','Mahoning',''),(4377,'44412','','Mahoning',''),(4378,'44425','','Mahoning',''),(4379,'44427','','Carroll',''),(4380,'44428','','Ashtabula',''),(4381,'44429','','Portage',''),(4382,'44437','','Mahoning',''),(4383,'44440','','Mahoning',''),(4384,'44443','','Columbiana',''),(4385,'44444','','Mahoning',''),(4386,'44444','','Portage',''),(4387,'44449','','Portage',''),(4388,'44454','','Columbiana',''),(4389,'44460','','Mahoning',''),(4390,'44481','','Mahoning',''),(4391,'44490','','Mahoning',''),(4392,'44491','','Geauga',''),(4393,'44491','','Portage',''),(4394,'44504','','Trumbull',''),(4395,'44505','','Trumbull',''),(4396,'44601','','Columbiana',''),(4397,'44601','','Mahoning',''),(4398,'44608','','Tuscarawas',''),(4399,'44609','','Columbiana',''),(4400,'44611','','Wayne',''),(4401,'44612','','Stark',''),(4402,'44614','','Summit',''),(4403,'44618','','Stark',''),(4404,'44621','','Carroll',''),(4405,'44621','','Harrison',''),(4406,'44624','','Tuscarawas',''),(4407,'44624','','Wayne',''),(4408,'44625','','Carroll',''),(4409,'44626','','Tuscarawas',''),(4410,'44627','','Holmes',''),(4411,'44628','','Knox',''),(4412,'44632','','Portage',''),(4413,'44634','','Stark',''),(4414,'44637','','Coshocton',''),(4415,'44638','','Ashland',''),(4416,'44638','','Wayne',''),(4417,'44643','','Carroll',''),(4418,'44643','','Tuscarawas',''),(4419,'44654','','Coshocton',''),(4420,'44656','','Carroll',''),(4421,'44657','','Carroll',''),(4422,'44657','','Columbiana',''),(4423,'44662','','Wayne',''),(4424,'44666','','Wayne',''),(4425,'44675','','Tuscarawas',''),(4426,'44676','','Holmes',''),(4427,'44681','','Holmes',''),(4428,'44683','','Harrison',''),(4429,'44685','','Stark',''),(4430,'44688','','Carroll',''),(4431,'44689','','Holmes',''),(4432,'44691','','Ashland',''),(4433,'44695','','Harrison',''),(4434,'44699','','Guernsey',''),(4435,'44699','','Tuscarawas',''),(4436,'44720','','Summit',''),(4437,'44730','','Carroll',''),(4438,'44802','','Hancock',''),(4439,'44805','','Richland',''),(4440,'44807','','Huron',''),(4441,'44811','','Erie',''),(4442,'44811','','Huron',''),(4443,'44811','','Seneca',''),(4444,'44813','','Knox',''),(4445,'44813','','Morrow',''),(4446,'44817','','Hancock',''),(4447,'44818','','Crawford',''),(4448,'44822','','Knox',''),(4449,'44824','','Sandusky',''),(4450,'44826','','Erie',''),(4451,'44827','','Richland',''),(4452,'44830','','Hancock',''),(4453,'44830','','Wood',''),(4454,'44833','','Marion',''),(4455,'44833','','Morrow',''),(4456,'44833','','Richland',''),(4457,'44836','','Sandusky',''),(4458,'44837','','Ashland',''),(4459,'44837','','Richland',''),(4460,'44840','','Wayne',''),(4461,'44841','','Sandusky',''),(4462,'44842','','Holmes',''),(4463,'44843','','Ashland',''),(4464,'44844','','Seneca',''),(4465,'44846','','Huron',''),(4466,'44847','','Erie',''),(4467,'44849','','Crawford',''),(4468,'44849','','Marion',''),(4469,'44851','','Ashland',''),(4470,'44851','','Lorain',''),(4471,'44857','','Erie',''),(4472,'44859','','Lorain',''),(4473,'44864','','Richland',''),(4474,'44865','','Crawford',''),(4475,'44865','','Richland',''),(4476,'44875','','Crawford',''),(4477,'44878','','Ashland',''),(4478,'44878','','Huron',''),(4479,'44880','','Lorain',''),(4480,'44880','','Medina',''),(4481,'44882','','Crawford',''),(4482,'44882','','Seneca',''),(4483,'44889','','Erie',''),(4484,'44889','','Lorain',''),(4485,'44903','','Ashland',''),(4486,'44903','','Morrow',''),(4487,'44904','','Morrow',''),(4488,'45003','','Butler',''),(4489,'45005','','Montgomery',''),(4490,'45013','','Hamilton',''),(4491,'45042','','Preble',''),(4492,'45042','','Warren',''),(4493,'45044','','Warren',''),(4494,'45050','','Warren',''),(4495,'45053','','Franklin',''),(4496,'45064','','Preble',''),(4497,'45066','','Montgomery',''),(4498,'45068','','Clinton',''),(4499,'45068','','Greene',''),(4500,'45106','','Brown',''),(4501,'45107','','Brown',''),(4502,'45107','','Clermont',''),(4503,'45107','','Warren',''),(4504,'45113','','Warren',''),(4505,'45118','','Clermont',''),(4506,'45118','','Highland',''),(4507,'45120','','Brown',''),(4508,'45121','','Clermont',''),(4509,'45122','','Warren',''),(4510,'45123','','Fayette',''),(4511,'45123','','Ross',''),(4512,'45130','','Clermont',''),(4513,'45133','','Brown',''),(4514,'45133','','Pike',''),(4515,'45135','','Clinton',''),(4516,'45135','','Fayette',''),(4517,'45140','','Hamilton',''),(4518,'45140','','Warren',''),(4519,'45142','','Brown',''),(4520,'45142','','Clinton',''),(4521,'45144','','Brown',''),(4522,'45147','','Hamilton',''),(4523,'45148','','Brown',''),(4524,'45150','','Hamilton',''),(4525,'45154','','Highland',''),(4526,'45159','','Highland',''),(4527,'45162','','Clermont',''),(4528,'45169','','Fayette',''),(4529,'45169','','Greene',''),(4530,'45171','','Highland',''),(4531,'45176','','Brown',''),(4532,'45241','','Butler',''),(4533,'45241','','Warren',''),(4534,'45244','','Clermont',''),(4535,'45246','','Butler',''),(4536,'45249','','Warren',''),(4537,'45255','','Clermont',''),(4538,'45304','','Miami',''),(4539,'45304','','Preble',''),(4540,'45306','','Auglaize',''),(4541,'45308','','Miami',''),(4542,'45309','','Darke',''),(4543,'45309','','Preble',''),(4544,'45310','','Darke',''),(4545,'45312','','Champaign',''),(4546,'45314','','Clark',''),(4547,'45316','','Clark',''),(4548,'45317','','Miami',''),(4549,'45317','','Shelby',''),(4550,'45318','','Darke',''),(4551,'45322','','Miami',''),(4552,'45324','','Clark',''),(4553,'45327','','Butler',''),(4554,'45327','','Preble',''),(4555,'45334','','Auglaize',''),(4556,'45334','','Logan',''),(4557,'45335','','Clinton',''),(4558,'45335','','Fayette',''),(4559,'45337','','Darke',''),(4560,'45342','','Warren',''),(4561,'45344','','Champaign',''),(4562,'45344','','Miami',''),(4563,'45344','','Montgomery',''),(4564,'45347','','Darke',''),(4565,'45356','','Shelby',''),(4566,'45365','','Champaign',''),(4567,'45368','','Greene',''),(4568,'45369','','Madison',''),(4569,'45371','','Montgomery',''),(4570,'45381','','Montgomery',''),(4571,'45382','','Darke',''),(4572,'45387','','Clark',''),(4573,'45424','','Greene',''),(4574,'45424','','Miami',''),(4575,'45431','','Greene',''),(4576,'45432','','Montgomery',''),(4577,'45433','','Montgomery',''),(4578,'45440','','Greene',''),(4579,'45458','','Greene',''),(4580,'45458','','Warren',''),(4581,'45459','','Greene',''),(4582,'45502','','Champaign',''),(4583,'45601','','Jackson',''),(4584,'45601','','Pike',''),(4585,'45612','','Highland',''),(4586,'45612','','Pike',''),(4587,'45613','','Jackson',''),(4588,'45613','','Scioto',''),(4589,'45616','','Scioto',''),(4590,'45620','','Meigs',''),(4591,'45622','','Hocking',''),(4592,'45623','','Lawrence',''),(4593,'45634','','Jackson',''),(4594,'45638','','Scioto',''),(4595,'45644','','Pickaway',''),(4596,'45647','','Vinton',''),(4597,'45648','','Pike',''),(4598,'45654','','Hocking',''),(4599,'45656','','Gallia',''),(4600,'45656','','Lawrence',''),(4601,'45657','','Adams',''),(4602,'45660','','Highland',''),(4603,'45660','','Pike',''),(4604,'45660','','Scioto',''),(4605,'45661','','Scioto',''),(4606,'45671','','Pike',''),(4607,'45672','','Vinton',''),(4608,'45678','','Gallia',''),(4609,'45679','','Highland',''),(4610,'45682','','Lawrence',''),(4611,'45684','','Adams',''),(4612,'45685','','Jackson',''),(4613,'45686','','Meigs',''),(4614,'45686','','Vinton',''),(4615,'45688','','Gallia',''),(4616,'45690','','Ross',''),(4617,'45697','','Brown',''),(4618,'45697','','Highland',''),(4619,'45710','','Meigs',''),(4620,'45710','','Vinton',''),(4621,'45711','','Morgan',''),(4622,'45711','','Washington',''),(4623,'45715','','Morgan',''),(4624,'45715','','Noble',''),(4625,'45723','','Meigs',''),(4626,'45723','','Washington',''),(4627,'45732','','Morgan',''),(4628,'45732','','Perry',''),(4629,'45742','','Athens',''),(4630,'45744','','Noble',''),(4631,'45745','','Monroe',''),(4632,'45745','','Noble',''),(4633,'45746','','Noble',''),(4634,'45764','','Hocking',''),(4635,'45766','','Vinton',''),(4636,'45767','','Monroe',''),(4637,'45776','','Athens',''),(4638,'45786','','Morgan',''),(4639,'45789','','Monroe',''),(4640,'45806','','Auglaize',''),(4641,'45810','','Allen',''),(4642,'45810','','Hancock',''),(4643,'45813','','Defiance',''),(4644,'45817','','Hancock',''),(4645,'45817','','Putnam',''),(4646,'45821','','Defiance',''),(4647,'45827','','Paulding',''),(4648,'45830','','Allen',''),(4649,'45831','','Defiance',''),(4650,'45832','','Paulding',''),(4651,'45833','','Putnam',''),(4652,'45833','','Van Wert',''),(4653,'45843','','Hancock',''),(4654,'45843','','Wyandot',''),(4655,'45844','','Allen',''),(4656,'45844','','Van Wert',''),(4657,'45845','','Auglaize',''),(4658,'45846','','Darke',''),(4659,'45849','','Putnam',''),(4660,'45849','','Van Wert',''),(4661,'45850','','Auglaize',''),(4662,'45850','','Hardin',''),(4663,'45856','','Hancock',''),(4664,'45856','','Henry',''),(4665,'45862','','Auglaize',''),(4666,'45865','','Shelby',''),(4667,'45867','','Wyandot',''),(4668,'45869','','Mercer',''),(4669,'45869','','Shelby',''),(4670,'45871','','Shelby',''),(4671,'45872','','Hancock',''),(4672,'45877','','Allen',''),(4673,'45877','','Hancock',''),(4674,'45882','','Van Wert',''),(4675,'45885','','Mercer',''),(4676,'45886','','Paulding',''),(4677,'45887','','Auglaize',''),(4678,'45887','','Mercer',''),(4679,'45887','','Van Wert',''),(4680,'45895','','Logan',''),(4681,'45896','','Allen',''),(4682,'45896','','Hardin',''),(4683,'45898','','Mercer',''),(4684,'46001','','Delaware',''),(4685,'46012','','Delaware',''),(4686,'46017','','Delaware',''),(4687,'46031','','Tipton',''),(4688,'46035','','Boone',''),(4689,'46035','','Montgomery',''),(4690,'46036','','Grant',''),(4691,'46036','','Tipton',''),(4692,'46040','','Hamilton',''),(4693,'46040','','Madison',''),(4694,'46041','','Carroll',''),(4695,'46049','','Clinton',''),(4696,'46050','','Boone',''),(4697,'46050','','Tipton',''),(4698,'46055','','Hamilton',''),(4699,'46056','','Hancock',''),(4700,'46058','','Tippecanoe',''),(4701,'46060','','Madison',''),(4702,'46064','','Hancock',''),(4703,'46065','','Carroll',''),(4704,'46069','','Boone',''),(4705,'46069','','Clinton',''),(4706,'46076','','Howard',''),(4707,'46077','','Hamilton',''),(4708,'46077','','Marion',''),(4709,'46106','','Morgan',''),(4710,'46112','','Boone',''),(4711,'46113','','Hendricks',''),(4712,'46113','','Morgan',''),(4713,'46115','','Hancock',''),(4714,'46117','','Henry',''),(4715,'46118','','Morgan',''),(4716,'46120','','Morgan',''),(4717,'46120','','Owen',''),(4718,'46121','','Hendricks',''),(4719,'46124','','Bartholomew',''),(4720,'46124','','Shelby',''),(4721,'46127','','Fayette',''),(4722,'46130','','Hancock',''),(4723,'46131','','Shelby',''),(4724,'46133','','Rush',''),(4725,'46135','','Parke',''),(4726,'46140','','Rush',''),(4727,'46147','','Hendricks',''),(4728,'46148','','Rush',''),(4729,'46150','','Shelby',''),(4730,'46151','','Johnson',''),(4731,'46151','','Monroe',''),(4732,'46156','','Decatur',''),(4733,'46158','','Hendricks',''),(4734,'46160','','Johnson',''),(4735,'46160','','Morgan',''),(4736,'46161','','Hancock',''),(4737,'46161','','Rush',''),(4738,'46162','','Shelby',''),(4739,'46163','','Shelby',''),(4740,'46164','','Brown',''),(4741,'46166','','Owen',''),(4742,'46173','','Decatur',''),(4743,'46173','','Franklin',''),(4744,'46175','','Parke',''),(4745,'46180','','Morgan',''),(4746,'46181','','Brown',''),(4747,'46182','','Rush',''),(4748,'46186','','Henry',''),(4749,'46229','','Hancock',''),(4750,'46231','','Hendricks',''),(4751,'46234','','Hendricks',''),(4752,'46239','','Hancock',''),(4753,'46240','','Hamilton',''),(4754,'46250','','Hamilton',''),(4755,'46256','','Hamilton',''),(4756,'46259','','Johnson',''),(4757,'46259','','Shelby',''),(4758,'46260','','Hamilton',''),(4759,'46268','','Boone',''),(4760,'46278','','Hendricks',''),(4761,'46307','','Porter',''),(4762,'46310','','Newton',''),(4763,'46341','','Lake',''),(4764,'46342','','Porter',''),(4765,'46348','','Porter',''),(4766,'46360','','Porter',''),(4767,'46366','','Pulaski',''),(4768,'46374','','Jasper',''),(4769,'46374','','Pulaski',''),(4770,'46390','','Porter',''),(4771,'46391','','Porter',''),(4772,'46504','','Kosciusko',''),(4773,'46506','','St. Joseph',''),(4774,'46511','','Fulton',''),(4775,'46511','','Pulaski',''),(4776,'46511','','Starke',''),(4777,'46530','','Elkhart',''),(4778,'46532','','La Porte',''),(4779,'46536','','Marshall',''),(4780,'46539','','Fulton',''),(4781,'46539','','Marshall',''),(4782,'46540','','Lagrange',''),(4783,'46542','','Elkhart',''),(4784,'46543','','Lagrange',''),(4785,'46550','','Kosciusko',''),(4786,'46550','','Marshall',''),(4787,'46550','','St. Joseph',''),(4788,'46552','','La Porte',''),(4789,'46554','','La Porte',''),(4790,'46561','','Elkhart',''),(4791,'46562','','Noble',''),(4792,'46562','','Whitley',''),(4793,'46563','','Starke',''),(4794,'46567','','Elkhart',''),(4795,'46570','','Fulton',''),(4796,'46571','','Noble',''),(4797,'46573','','St. Joseph',''),(4798,'46574','','La Porte',''),(4799,'46574','','Marshall',''),(4800,'46574','','Starke',''),(4801,'46702','','Wabash',''),(4802,'46705','','Steuben',''),(4803,'46706','','Allen',''),(4804,'46710','','De Kalb',''),(4805,'46714','','Adams',''),(4806,'46723','','Allen',''),(4807,'46723','','Noble',''),(4808,'46725','','Noble',''),(4809,'46732','','Kosciusko',''),(4810,'46733','','Allen',''),(4811,'46740','','Wells',''),(4812,'46742','','De Kalb',''),(4813,'46747','','De Kalb',''),(4814,'46747','','Lagrange',''),(4815,'46748','','De Kalb',''),(4816,'46748','','Noble',''),(4817,'46750','','Whitley',''),(4818,'46755','','De Kalb',''),(4819,'46761','','Steuben',''),(4820,'46763','','De Kalb',''),(4821,'46764','','Noble',''),(4822,'46767','','Elkhart',''),(4823,'46767','','Lagrange',''),(4824,'46770','','Huntington',''),(4825,'46773','','Adams',''),(4826,'46776','','Lagrange',''),(4827,'46777','','Adams',''),(4828,'46777','','Allen',''),(4829,'46783','','Allen',''),(4830,'46783','','Wells',''),(4831,'46783','','Whitley',''),(4832,'46787','','Kosciusko',''),(4833,'46788','','De Kalb',''),(4834,'46792','','Wells',''),(4835,'46793','','Steuben',''),(4836,'46795','','Noble',''),(4837,'46798','','Wells',''),(4838,'46818','','Whitley',''),(4839,'46901','','Miami',''),(4840,'46902','','Tipton',''),(4841,'46910','','Kosciusko',''),(4842,'46910','','Miami',''),(4843,'46911','','Wabash',''),(4844,'46919','','Grant',''),(4845,'46919','','Howard',''),(4846,'46919','','Wabash',''),(4847,'46923','','Tippecanoe',''),(4848,'46926','','Cass',''),(4849,'46928','','Madison',''),(4850,'46929','','Howard',''),(4851,'46932','','Howard',''),(4852,'46932','','Miami',''),(4853,'46939','','Pulaski',''),(4854,'46940','','Grant',''),(4855,'46940','','Huntington',''),(4856,'46947','','Carroll',''),(4857,'46951','','Fulton',''),(4858,'46952','','Blackford',''),(4859,'46952','','Huntington',''),(4860,'46952','','Wells',''),(4861,'46960','','Fulton',''),(4862,'46960','','Starke',''),(4863,'46962','','Kosciusko',''),(4864,'46962','','Whitley',''),(4865,'46968','','Pulaski',''),(4866,'46970','','Cass',''),(4867,'46970','','Wabash',''),(4868,'46974','','Miami',''),(4869,'46978','','Pulaski',''),(4870,'46978','','White',''),(4871,'46979','','Clinton',''),(4872,'46982','','Fulton',''),(4873,'46982','','Wabash',''),(4874,'46985','','White',''),(4875,'46989','','Delaware',''),(4876,'46991','','Huntington',''),(4877,'46996','','Starke',''),(4878,'46996','','White',''),(4879,'47001','','Ohio',''),(4880,'47006','','Decatur',''),(4881,'47006','','Franklin',''),(4882,'47010','','Union',''),(4883,'47011','','Ohio',''),(4884,'47012','','Dearborn',''),(4885,'47017','','Ohio',''),(4886,'47018','','Ohio',''),(4887,'47018','','Ripley',''),(4888,'47031','','Dearborn',''),(4889,'47040','','Switzerland',''),(4890,'47041','','Dearborn',''),(4891,'47043','','Jefferson',''),(4892,'47060','','Franklin',''),(4893,'47102','','Jackson',''),(4894,'47106','','Floyd',''),(4895,'47106','','Washington',''),(4896,'47108','','Orange',''),(4897,'47117','','Floyd',''),(4898,'47118','','Orange',''),(4899,'47118','','Perry',''),(4900,'47119','','Clark',''),(4901,'47122','','Harrison',''),(4902,'47124','','Harrison',''),(4903,'47125','','Orange',''),(4904,'47126','','Washington',''),(4905,'47136','','Floyd',''),(4906,'47137','','Perry',''),(4907,'47138','','Jefferson',''),(4908,'47140','','Orange',''),(4909,'47147','','Jefferson',''),(4910,'47147','','Scott',''),(4911,'47150','','Clark',''),(4912,'47164','','Washington',''),(4913,'47165','','Floyd',''),(4914,'47170','','Washington',''),(4915,'47172','','Floyd',''),(4916,'47175','','Orange',''),(4917,'47177','','Scott',''),(4918,'47201','','Brown',''),(4919,'47224','','Jefferson',''),(4920,'47224','','Ripley',''),(4921,'47227','','Jefferson',''),(4922,'47229','','Jennings',''),(4923,'47230','','Jennings',''),(4924,'47230','','Scott',''),(4925,'47231','','Jennings',''),(4926,'47232','','Jennings',''),(4927,'47235','','Brown',''),(4928,'47240','','Franklin',''),(4929,'47240','','Ripley',''),(4930,'47240','','Rush',''),(4931,'47240','','Shelby',''),(4932,'47244','','Decatur',''),(4933,'47250','','Ripley',''),(4934,'47250','','Switzerland',''),(4935,'47264','','Lawrence',''),(4936,'47264','','Monroe',''),(4937,'47270','','Jefferson',''),(4938,'47272','','Shelby',''),(4939,'47274','','Bartholomew',''),(4940,'47274','','Brown',''),(4941,'47274','','Jennings',''),(4942,'47281','','Washington',''),(4943,'47283','','Bartholomew',''),(4944,'47283','','Jennings',''),(4945,'47302','','Henry',''),(4946,'47320','','Jay',''),(4947,'47320','','Randolph',''),(4948,'47325','','Fayette',''),(4949,'47326','','Adams',''),(4950,'47327','','Henry',''),(4951,'47331','','Franklin',''),(4952,'47331','','Union',''),(4953,'47334','','Henry',''),(4954,'47336','','Blackford',''),(4955,'47336','','Delaware',''),(4956,'47346','','Henry',''),(4957,'47352','','Rush',''),(4958,'47353','','Franklin',''),(4959,'47354','','Delaware',''),(4960,'47354','','Henry',''),(4961,'47354','','Wayne',''),(4962,'47356','','Delaware',''),(4963,'47356','','Madison',''),(4964,'47357','','Fayette',''),(4965,'47358','','Wayne',''),(4966,'47359','','Wells',''),(4967,'47360','','Randolph',''),(4968,'47360','','Wayne',''),(4969,'47368','','Delaware',''),(4970,'47371','','Randolph',''),(4971,'47373','','Randolph',''),(4972,'47374','','Union',''),(4973,'47380','','Jay',''),(4974,'47384','','Hancock',''),(4975,'47390','','Jay',''),(4976,'47393','','Randolph',''),(4977,'47401','','Brown',''),(4978,'47403','','Greene',''),(4979,'47404','','Owen',''),(4980,'47427','','Clay',''),(4981,'47432','','Dubois',''),(4982,'47432','','Martin',''),(4983,'47433','','Monroe',''),(4984,'47433','','Morgan',''),(4985,'47436','','Monroe',''),(4986,'47438','','Clay',''),(4987,'47438','','Sullivan',''),(4988,'47446','','Martin',''),(4989,'47448','','Monroe',''),(4990,'47452','','Lawrence',''),(4991,'47456','','Morgan',''),(4992,'47456','','Putnam',''),(4993,'47459','','Owen',''),(4994,'47460','','Greene',''),(4995,'47460','','Monroe',''),(4996,'47462','','Greene',''),(4997,'47462','','Monroe',''),(4998,'47468','','Brown',''),(4999,'47470','','Martin',''),(5000,'47471','','Owen',''),(5001,'47513','','Crawford',''),(5002,'47513','','Perry',''),(5003,'47523','','Warrick',''),(5004,'47527','','Orange',''),(5005,'47529','','Greene',''),(5006,'47532','','Perry',''),(5007,'47532','','Spencer',''),(5008,'47537','','Warrick',''),(5009,'47541','','Spencer',''),(5010,'47541','','Warrick',''),(5011,'47542','','Pike',''),(5012,'47553','','Daviess',''),(5013,'47561','','Sullivan',''),(5014,'47562','','Martin',''),(5015,'47564','','Dubois',''),(5016,'47577','','Perry',''),(5017,'47578','','Greene',''),(5018,'47588','','Spencer',''),(5019,'47590','','Dubois',''),(5020,'47601','','Spencer',''),(5021,'47612','','Gibson',''),(5022,'47613','','Gibson',''),(5023,'47616','','Gibson',''),(5024,'47619','','Gibson',''),(5025,'47619','','Pike',''),(5026,'47633','','Gibson',''),(5027,'47633','','Vanderburgh',''),(5028,'47637','','Spencer',''),(5029,'47639','','Vanderburgh',''),(5030,'47640','','Pike',''),(5031,'47660','','Pike',''),(5032,'47660','','Warrick',''),(5033,'47712','','Posey',''),(5034,'47725','','Gibson',''),(5035,'47725','','Warrick',''),(5036,'47802','','Clay',''),(5037,'47833','','Clay',''),(5038,'47834','','Parke',''),(5039,'47834','','Vigo',''),(5040,'47837','','Parke',''),(5041,'47840','','Putnam',''),(5042,'47841','','Owen',''),(5043,'47842','','Vigo',''),(5044,'47848','','Greene',''),(5045,'47850','','Vigo',''),(5046,'47858','','Sullivan',''),(5047,'47858','','Vigo',''),(5048,'47868','','Clay',''),(5049,'47868','','Putnam',''),(5050,'47872','','Putnam',''),(5051,'47874','','Clay',''),(5052,'47874','','Vigo',''),(5053,'47906','','Warren',''),(5054,'47906','','White',''),(5055,'47917','','Warren',''),(5056,'47918','','Tippecanoe',''),(5057,'47918','','Warren',''),(5058,'47920','','Carroll',''),(5059,'47920','','White',''),(5060,'47921','','Warren',''),(5061,'47922','','Jasper',''),(5062,'47923','','Carroll',''),(5063,'47926','','Carroll',''),(5064,'47930','','Montgomery',''),(5065,'47932','','Vermillion',''),(5066,'47932','','Warren',''),(5067,'47933','','Boone',''),(5068,'47943','','Newton',''),(5069,'47946','','Jasper',''),(5070,'47948','','Benton',''),(5071,'47948','','Jasper',''),(5072,'47950','','Carroll',''),(5073,'47952','','Parke',''),(5074,'47954','','Putnam',''),(5075,'47955','','Tippecanoe',''),(5076,'47957','','Jasper',''),(5077,'47959','','Jasper',''),(5078,'47960','','Carroll',''),(5079,'47967','','Tippecanoe',''),(5080,'47968','','Boone',''),(5081,'47970','','Tippecanoe',''),(5082,'47970','','Warren',''),(5083,'47975','','Benton',''),(5084,'47977','','Benton',''),(5085,'47978','','Newton',''),(5086,'47978','','White',''),(5087,'47981','','Montgomery',''),(5088,'47989','','Parke',''),(5089,'47989','','Putnam',''),(5090,'47995','','Jasper',''),(5091,'48014','','Lapeer',''),(5092,'48032','','Sanilac',''),(5093,'48041','','Macomb',''),(5094,'48097','','Sanilac',''),(5095,'48111','','Monroe',''),(5096,'48111','','Washtenaw',''),(5097,'48134','','Monroe',''),(5098,'48137','','Washtenaw',''),(5099,'48158','','Jackson',''),(5100,'48160','','Monroe',''),(5101,'48164','','Monroe',''),(5102,'48167','','Washtenaw',''),(5103,'48167','','Wayne',''),(5104,'48168','','Washtenaw',''),(5105,'48169','','Washtenaw',''),(5106,'48170','','Washtenaw',''),(5107,'48176','','Lenawee',''),(5108,'48178','','Livingston',''),(5109,'48178','','Washtenaw',''),(5110,'48189','','Livingston',''),(5111,'48191','','Monroe',''),(5112,'48236','','Macomb',''),(5113,'48306','','Macomb',''),(5114,'48371','','Lapeer',''),(5115,'48380','','Livingston',''),(5116,'48415','','Genesee',''),(5117,'48415','','Tuscola',''),(5118,'48416','','Lapeer',''),(5119,'48416','','St. Clair',''),(5120,'48418','','Genesee',''),(5121,'48418','','Livingston',''),(5122,'48420','','Saginaw',''),(5123,'48420','','Tuscola',''),(5124,'48421','','Genesee',''),(5125,'48423','','Lapeer',''),(5126,'48428','','Oakland',''),(5127,'48429','','Genesee',''),(5128,'48430','','Livingston',''),(5129,'48430','','Oakland',''),(5130,'48433','','Shiawassee',''),(5131,'48435','','Lapeer',''),(5132,'48436','','Shiawassee',''),(5133,'48438','','Lapeer',''),(5134,'48439','','Oakland',''),(5135,'48441','','Sanilac',''),(5136,'48442','','Genesee',''),(5137,'48442','','Livingston',''),(5138,'48444','','St. Clair',''),(5139,'48449','','Genesee',''),(5140,'48451','','Livingston',''),(5141,'48453','','Lapeer',''),(5142,'48453','','Tuscola',''),(5143,'48456','','Huron',''),(5144,'48457','','Saginaw',''),(5145,'48460','','Saginaw',''),(5146,'48462','','Genesee',''),(5147,'48462','','Lapeer',''),(5148,'48464','','Genesee',''),(5149,'48464','','Tuscola',''),(5150,'48475','','Sanilac',''),(5151,'48604','','Bay',''),(5152,'48610','','Gladwin',''),(5153,'48610','','Ogemaw',''),(5154,'48612','','Midland',''),(5155,'48613','','Gladwin',''),(5156,'48614','','Gratiot',''),(5157,'48615','','Midland',''),(5158,'48616','','Shiawassee',''),(5159,'48617','','Isabella',''),(5160,'48618','','Gladwin',''),(5161,'48618','','Isabella',''),(5162,'48619','','Montmorency',''),(5163,'48622','','Isabella',''),(5164,'48623','','Bay',''),(5165,'48623','','Midland',''),(5166,'48624','','Clare',''),(5167,'48624','','Ogemaw',''),(5168,'48624','','Roscommon',''),(5169,'48626','','Midland',''),(5170,'48628','','Gladwin',''),(5171,'48632','','Isabella',''),(5172,'48632','','Osceola',''),(5173,'48637','','Gratiot',''),(5174,'48637','','Midland',''),(5175,'48642','','Bay',''),(5176,'48647','','Alcona',''),(5177,'48649','','Shiawassee',''),(5178,'48650','','Arenac',''),(5179,'48652','','Bay',''),(5180,'48652','','Midland',''),(5181,'48653','','Crawford',''),(5182,'48654','','Oscoda',''),(5183,'48658','','Bay',''),(5184,'48659','','Bay',''),(5185,'48662','','Midland',''),(5186,'48708','','Saginaw',''),(5187,'48726','','Huron',''),(5188,'48726','','Sanilac',''),(5189,'48727','','Tuscola',''),(5190,'48728','','Oscoda',''),(5191,'48734','','Tuscola',''),(5192,'48735','','Huron',''),(5193,'48737','','Iosco',''),(5194,'48738','','Iosco',''),(5195,'48739','','Ogemaw',''),(5196,'48744','','Lapeer',''),(5197,'48745','','Iosco',''),(5198,'48746','','Genesee',''),(5199,'48747','','Saginaw',''),(5200,'48750','','Alcona',''),(5201,'48757','','Bay',''),(5202,'48757','','Saginaw',''),(5203,'48759','','Tuscola',''),(5204,'48760','','Lapeer',''),(5205,'48761','','Alcona',''),(5206,'48761','','Ogemaw',''),(5207,'48761','','Oscoda',''),(5208,'48762','','Alpena',''),(5209,'48763','','Arenac',''),(5210,'48765','','Iosco',''),(5211,'48767','','Huron',''),(5212,'48807','','Saginaw',''),(5213,'48809','','Kent',''),(5214,'48809','','Montcalm',''),(5215,'48811','','Gratiot',''),(5216,'48813','','Calhoun',''),(5217,'48815','','Kent',''),(5218,'48821','','Ingham',''),(5219,'48823','','Clinton',''),(5220,'48827','','Ingham',''),(5221,'48827','','Jackson',''),(5222,'48829','','Isabella',''),(5223,'48831','','Gratiot',''),(5224,'48831','','Saginaw',''),(5225,'48831','','Shiawassee',''),(5226,'48834','','Ionia',''),(5227,'48835','','Gratiot',''),(5228,'48837','','Clinton',''),(5229,'48837','','Ionia',''),(5230,'48838','','Ionia',''),(5231,'48838','','Kent',''),(5232,'48840','','Clinton',''),(5233,'48840','','Shiawassee',''),(5234,'48841','','Saginaw',''),(5235,'48845','','Clinton',''),(5236,'48845','','Gratiot',''),(5237,'48845','','Montcalm',''),(5238,'48848','','Clinton',''),(5239,'48849','','Barry',''),(5240,'48849','','Eaton',''),(5241,'48850','','Mecosta',''),(5242,'48858','','Midland',''),(5243,'48861','','Ionia',''),(5244,'48866','','Shiawassee',''),(5245,'48872','','Ingham',''),(5246,'48872','','Livingston',''),(5247,'48873','','Clinton',''),(5248,'48875','','Clinton',''),(5249,'48877','','Isabella',''),(5250,'48877','','Montcalm',''),(5251,'48879','','Gratiot',''),(5252,'48880','','Isabella',''),(5253,'48880','','Midland',''),(5254,'48883','','Midland',''),(5255,'48886','','Mecosta',''),(5256,'48890','','Ionia',''),(5257,'48892','','Livingston',''),(5258,'48897','','Eaton',''),(5259,'48906','','Clinton',''),(5260,'48906','','Eaton',''),(5261,'48911','','Eaton',''),(5262,'48917','','Ingham',''),(5263,'49009','','Van Buren',''),(5264,'49010','','Van Buren',''),(5265,'49011','','Branch',''),(5266,'49011','','St. Joseph',''),(5267,'49012','','Calhoun',''),(5268,'49017','','Barry',''),(5269,'49021','','Barry',''),(5270,'49021','','Calhoun',''),(5271,'49022','','Van Buren',''),(5272,'49026','','Allegan',''),(5273,'49030','','Branch',''),(5274,'49034','','Calhoun',''),(5275,'49038','','Van Buren',''),(5276,'49040','','Branch',''),(5277,'49042','','Cass',''),(5278,'49045','','Cass',''),(5279,'49047','','Berrien',''),(5280,'49047','','Van Buren',''),(5281,'49052','','Calhoun',''),(5282,'49055','','Allegan',''),(5283,'49056','','Allegan',''),(5284,'49060','','Kalamazoo',''),(5285,'49067','','St. Joseph',''),(5286,'49067','','Van Buren',''),(5287,'49071','','Kalamazoo',''),(5288,'49073','','Eaton',''),(5289,'49076','','Calhoun',''),(5290,'49078','','Kalamazoo',''),(5291,'49078','','Van Buren',''),(5292,'49080','','Barry',''),(5293,'49080','','Kalamazoo',''),(5294,'49082','','Hillsdale',''),(5295,'49083','','Barry',''),(5296,'49087','','Van Buren',''),(5297,'49090','','Allegan',''),(5298,'49092','','Branch',''),(5299,'49093','','Cass',''),(5300,'49094','','Calhoun',''),(5301,'49097','','St. Joseph',''),(5302,'49098','','Van Buren',''),(5303,'49099','','Cass',''),(5304,'49102','','Cass',''),(5305,'49111','','Cass',''),(5306,'49120','','Cass',''),(5307,'49220','','Hillsdale',''),(5308,'49224','','Jackson',''),(5309,'49229','','Monroe',''),(5310,'49230','','Lenawee',''),(5311,'49233','','Jackson',''),(5312,'49233','','Lenawee',''),(5313,'49236','','Washtenaw',''),(5314,'49237','','Calhoun',''),(5315,'49238','','Monroe',''),(5316,'49240','','Washtenaw',''),(5317,'49245','','Branch',''),(5318,'49245','','Jackson',''),(5319,'49246','','Hillsdale',''),(5320,'49247','','Hillsdale',''),(5321,'49249','','Jackson',''),(5322,'49250','','Jackson',''),(5323,'49251','','Jackson',''),(5324,'49252','','Branch',''),(5325,'49252','','Calhoun',''),(5326,'49252','','Jackson',''),(5327,'49255','','Hillsdale',''),(5328,'49264','','Jackson',''),(5329,'49267','','Lenawee',''),(5330,'49274','','Branch',''),(5331,'49276','','Monroe',''),(5332,'49284','','Calhoun',''),(5333,'49284','','Eaton',''),(5334,'49285','','Jackson',''),(5335,'49285','','Livingston',''),(5336,'49285','','Washtenaw',''),(5337,'49287','','Washtenaw',''),(5338,'49288','','Lenawee',''),(5339,'49303','','Newaygo',''),(5340,'49305','','Isabella',''),(5341,'49307','','Newaygo',''),(5342,'49309','','Lake',''),(5343,'49310','','Mecosta',''),(5344,'49310','','Montcalm',''),(5345,'49315','','Allegan',''),(5346,'49315','','Ottawa',''),(5347,'49316','','Allegan',''),(5348,'49316','','Barry',''),(5349,'49318','','Kent',''),(5350,'49318','','Ottawa',''),(5351,'49325','','Ionia',''),(5352,'49325','','Kent',''),(5353,'49326','','Montcalm',''),(5354,'49327','','Kent',''),(5355,'49329','','Newaygo',''),(5356,'49330','','Muskegon',''),(5357,'49330','','Newaygo',''),(5358,'49330','','Ottawa',''),(5359,'49331','','Ionia',''),(5360,'49333','','Allegan',''),(5361,'49333','','Kent',''),(5362,'49336','','Montcalm',''),(5363,'49336','','Newaygo',''),(5364,'49337','','Mecosta',''),(5365,'49337','','Montcalm',''),(5366,'49338','','Newaygo',''),(5367,'49338','','Osceola',''),(5368,'49340','','Isabella',''),(5369,'49343','','Montcalm',''),(5370,'49343','','Newaygo',''),(5371,'49344','','Barry',''),(5372,'49346','','Newaygo',''),(5373,'49347','','Kent',''),(5374,'49348','','Barry',''),(5375,'49348','','Kent',''),(5376,'49402','','Lake',''),(5377,'49402','','Oceana',''),(5378,'49403','','Kent',''),(5379,'49403','','Muskegon',''),(5380,'49404','','Muskegon',''),(5381,'49412','','Muskegon',''),(5382,'49412','','Oceana',''),(5383,'49415','','Ottawa',''),(5384,'49418','','Ottawa',''),(5385,'49421','','Newaygo',''),(5386,'49423','','Allegan',''),(5387,'49425','','Newaygo',''),(5388,'49425','','Oceana',''),(5389,'49426','','Allegan',''),(5390,'49434','','Allegan',''),(5391,'49437','','Oceana',''),(5392,'49448','','Muskegon',''),(5393,'49449','','Mason',''),(5394,'49451','','Ottawa',''),(5395,'49456','','Muskegon',''),(5396,'49457','','Newaygo',''),(5397,'49459','','Newaygo',''),(5398,'49464','','Allegan',''),(5399,'49534','','Ottawa',''),(5400,'49544','','Ottawa',''),(5401,'49601','','Missaukee',''),(5402,'49612','','Kalkaska',''),(5403,'49613','','Benzie',''),(5404,'49620','','Grand Traverse',''),(5405,'49625','','Wexford',''),(5406,'49630','','Benzie',''),(5407,'49631','','Mecosta',''),(5408,'49633','','Grand Traverse',''),(5409,'49633','','Missaukee',''),(5410,'49633','','Wexford',''),(5411,'49638','','Manistee',''),(5412,'49639','','Mecosta',''),(5413,'49643','','Benzie',''),(5414,'49644','','Manistee',''),(5415,'49644','','Mason',''),(5416,'49649','','Wexford',''),(5417,'49655','','Lake',''),(5418,'49659','','Kalkaska',''),(5419,'49660','','Mason',''),(5420,'49663','','Missaukee',''),(5421,'49665','','Clare',''),(5422,'49665','','Missaukee',''),(5423,'49668','','Manistee',''),(5424,'49676','','Antrim',''),(5425,'49677','','Lake',''),(5426,'49677','','Newaygo',''),(5427,'49679','','Mecosta',''),(5428,'49680','','Grand Traverse',''),(5429,'49683','','Grand Traverse',''),(5430,'49683','','Manistee',''),(5431,'49684','','Benzie',''),(5432,'49684','','Leelanau',''),(5433,'49688','','Lake',''),(5434,'49688','','Wexford',''),(5435,'49689','','Wexford',''),(5436,'49690','','Antrim',''),(5437,'49690','','Kalkaska',''),(5438,'49701','','Cheboygan',''),(5439,'49706','','Cheboygan',''),(5440,'49707','','Presque Isle',''),(5441,'49712','','Antrim',''),(5442,'49713','','Antrim',''),(5443,'49713','','Emmet',''),(5444,'49716','','Cheboygan',''),(5445,'49718','','Cheboygan',''),(5446,'49720','','Antrim',''),(5447,'49727','','Antrim',''),(5448,'49729','','Charlevoix',''),(5449,'49730','','Charlevoix',''),(5450,'49730','','Otsego',''),(5451,'49733','','Otsego',''),(5452,'49738','','Kalkaska',''),(5453,'49738','','Otsego',''),(5454,'49746','','Alpena',''),(5455,'49747','','Alcona',''),(5456,'49748','','Luce',''),(5457,'49751','','Montmorency',''),(5458,'49755','','Cheboygan',''),(5459,'49756','','Crawford',''),(5460,'49756','','Oscoda',''),(5461,'49756','','Otsego',''),(5462,'49765','','Cheboygan',''),(5463,'49769','','Cheboygan',''),(5464,'49770','','Charlevoix',''),(5465,'49774','','Mackinac',''),(5466,'49776','','Alpena',''),(5467,'49780','','Mackinac',''),(5468,'49793','','Mackinac',''),(5469,'49795','','Charlevoix',''),(5470,'49795','','Cheboygan',''),(5471,'49805','','Houghton',''),(5472,'49807','','Dickinson',''),(5473,'49807','','Menominee',''),(5474,'49817','','Delta',''),(5475,'49818','','Marquette',''),(5476,'49822','','Marquette',''),(5477,'49831','','Marquette',''),(5478,'49836','','Mackinac',''),(5479,'49853','','Mackinac',''),(5480,'49854','','Delta',''),(5481,'49855','','Alger',''),(5482,'49861','','Baraga',''),(5483,'49873','','Dickinson',''),(5484,'49878','','Alger',''),(5485,'49879','','Iron',''),(5486,'49880','','Marquette',''),(5487,'49883','','Alger',''),(5488,'49884','','Schoolcraft',''),(5489,'49885','','Alger',''),(5490,'49892','','Menominee',''),(5491,'49895','','Delta',''),(5492,'49895','','Schoolcraft',''),(5493,'49913','','Keweenaw',''),(5494,'49945','','Keweenaw',''),(5495,'49947','','Ontonagon',''),(5496,'49952','','Ontonagon',''),(5497,'49958','','Baraga',''),(5498,'49965','','Ontonagon',''),(5499,'49967','','Houghton',''),(5500,'49967','','Iron',''),(5501,'50002','','Guthrie',''),(5502,'50006','','Franklin',''),(5503,'50014','','Boone',''),(5504,'50020','','Adair',''),(5505,'50020','','Audubon',''),(5506,'50022','','Audubon',''),(5507,'50022','','Shelby',''),(5508,'50026','','Greene',''),(5509,'50027','','Poweshiek',''),(5510,'50029','','Greene',''),(5511,'50034','','Wright',''),(5512,'50044','','Mahaska',''),(5513,'50044','','Monroe',''),(5514,'50046','','Polk',''),(5515,'50047','','Polk',''),(5516,'50048','','Adair',''),(5517,'50049','','Wayne',''),(5518,'50055','','Jasper',''),(5519,'50058','','Audubon',''),(5520,'50058','','Greene',''),(5521,'50058','','Guthrie',''),(5522,'50061','','Dallas',''),(5523,'50061','','Madison',''),(5524,'50061','','Polk',''),(5525,'50068','','Wayne',''),(5526,'50070','','Adair',''),(5527,'50070','','Guthrie',''),(5528,'50070','','Madison',''),(5529,'50071','','Franklin',''),(5530,'50072','','Dallas',''),(5531,'50074','','Union',''),(5532,'50104','','Mahaska',''),(5533,'50106','','Jasper',''),(5534,'50106','','Poweshiek',''),(5535,'50106','','Tama',''),(5536,'50107','','Boone',''),(5537,'50108','','Clarke',''),(5538,'50109','','Polk',''),(5539,'50111','','Dallas',''),(5540,'50112','','Jasper',''),(5541,'50123','','Decatur',''),(5542,'50123','','Lucas',''),(5543,'50124','','Polk',''),(5544,'50126','','Franklin',''),(5545,'50128','','Dallas',''),(5546,'50128','','Greene',''),(5547,'50133','','Decatur',''),(5548,'50134','','Boone',''),(5549,'50136','','Iowa',''),(5550,'50139','','Lucas',''),(5551,'50139','','Marion',''),(5552,'50140','','Ringgold',''),(5553,'50141','','Jasper',''),(5554,'50147','','Decatur',''),(5555,'50149','','Madison',''),(5556,'50151','','Warren',''),(5557,'50153','','Mahaska',''),(5558,'50153','','Poweshiek',''),(5559,'50154','','Hardin',''),(5560,'50155','','Adair',''),(5561,'50156','','Dallas',''),(5562,'50156','','Polk',''),(5563,'50158','','Tama',''),(5564,'50161','','Polk',''),(5565,'50164','','Adair',''),(5566,'50169','','Jasper',''),(5567,'50170','','Marion',''),(5568,'50174','','Union',''),(5569,'50206','','Marshall',''),(5570,'50206','','Story',''),(5571,'50207','','Poweshiek',''),(5572,'50210','','Clarke',''),(5573,'50210','','Madison',''),(5574,'50211','','Madison',''),(5575,'50217','','Boone',''),(5576,'50219','','Mahaska',''),(5577,'50220','','Boone',''),(5578,'50220','','Greene',''),(5579,'50225','','Warren',''),(5580,'50226','','Story',''),(5581,'50228','','Marion',''),(5582,'50229','','Madison',''),(5583,'50230','','Hamilton',''),(5584,'50233','','Guthrie',''),(5585,'50234','','Jasper',''),(5586,'50235','','Boone',''),(5587,'50235','','Dallas',''),(5588,'50237','','Jasper',''),(5589,'50237','','Marion',''),(5590,'50238','','Wayne',''),(5591,'50240','','Warren',''),(5592,'50243','','Polk',''),(5593,'50244','','Boone',''),(5594,'50244','','Polk',''),(5595,'50247','','Story',''),(5596,'50248','','Boone',''),(5597,'50248','','Hamilton',''),(5598,'50249','','Boone',''),(5599,'50249','','Webster',''),(5600,'50250','','Adair',''),(5601,'50256','','Mahaska',''),(5602,'50257','','Clarke',''),(5603,'50257','','Warren',''),(5604,'50258','','Marshall',''),(5605,'50261','','Madison',''),(5606,'50264','','Clarke',''),(5607,'50266','','Dallas',''),(5608,'50268','','Mahaska',''),(5609,'50271','','Wright',''),(5610,'50276','','Boone',''),(5611,'50277','','Dallas',''),(5612,'50320','','Warren',''),(5613,'50323','','Polk',''),(5614,'50325','','Dallas',''),(5615,'50420','','Wright',''),(5616,'50424','','Kossuth',''),(5617,'50430','','Kossuth',''),(5618,'50433','','Butler',''),(5619,'50433','','Floyd',''),(5620,'50433','','Franklin',''),(5621,'50434','','Cerro Gordo',''),(5622,'50436','','Hancock',''),(5623,'50444','','Cerro Gordo',''),(5624,'50446','','Winnebago',''),(5625,'50447','','Wright',''),(5626,'50449','','Cerro Gordo',''),(5627,'50450','','Worth',''),(5628,'50457','','Franklin',''),(5629,'50457','','Hancock',''),(5630,'50457','','Wright',''),(5631,'50458','','Cerro Gordo',''),(5632,'50458','','Mitchell',''),(5633,'50460','','Floyd',''),(5634,'50461','','Floyd',''),(5635,'50464','','Worth',''),(5636,'50466','','Howard',''),(5637,'50468','','Cerro Gordo',''),(5638,'50471','','Mitchell',''),(5639,'50472','','Worth',''),(5640,'50475','','Cerro Gordo',''),(5641,'50479','','Franklin',''),(5642,'50480','','Hancock',''),(5643,'50482','','Hancock',''),(5644,'50483','','Hancock',''),(5645,'50484','','Kossuth',''),(5646,'50484','','Winnebago',''),(5647,'50510','','Pocahontas',''),(5648,'50514','','Kossuth',''),(5649,'50515','','Clay',''),(5650,'50516','','Humboldt',''),(5651,'50519','','Kossuth',''),(5652,'50520','','Pocahontas',''),(5653,'50524','','Pocahontas',''),(5654,'50530','','Boone',''),(5655,'50532','','Hamilton',''),(5656,'50533','','Humboldt',''),(5657,'50533','','Webster',''),(5658,'50538','','Webster',''),(5659,'50539','','Palo Alto',''),(5660,'50540','','Calhoun',''),(5661,'50541','','Pocahontas',''),(5662,'50542','','Humboldt',''),(5663,'50548','','Webster',''),(5664,'50554','','Buena Vista',''),(5665,'50554','','Palo Alto',''),(5666,'50558','','Kossuth',''),(5667,'50560','','Humboldt',''),(5668,'50561','','Calhoun',''),(5669,'50562','','Pocahontas',''),(5670,'50563','','Pocahontas',''),(5671,'50563','','Webster',''),(5672,'50568','','Sac',''),(5673,'50570','','Kossuth',''),(5674,'50575','','Pocahontas',''),(5675,'50577','','Wright',''),(5676,'50578','','Palo Alto',''),(5677,'50581','','Palo Alto',''),(5678,'50585','','Clay',''),(5679,'50586','','Webster',''),(5680,'50591','','Webster',''),(5681,'50597','','Kossuth',''),(5682,'50598','','Palo Alto',''),(5683,'50599','','Hamilton',''),(5684,'50601','','Butler',''),(5685,'50601','','Franklin',''),(5686,'50601','','Grundy',''),(5687,'50603','','Howard',''),(5688,'50604','','Grundy',''),(5689,'50605','','Franklin',''),(5690,'50606','','Clayton',''),(5691,'50607','','Fayette',''),(5692,'50609','','Marshall',''),(5693,'50609','','Tama',''),(5694,'50612','','Black Hawk',''),(5695,'50613','','Butler',''),(5696,'50613','','Grundy',''),(5697,'50616','','Chickasaw',''),(5698,'50621','','Marshall',''),(5699,'50625','','Franklin',''),(5700,'50627','','Grundy',''),(5701,'50628','','Mitchell',''),(5702,'50629','','Black Hawk',''),(5703,'50629','','Bremer',''),(5704,'50629','','Fayette',''),(5705,'50630','','Bremer',''),(5706,'50632','','Marshall',''),(5707,'50635','','Marshall',''),(5708,'50636','','Floyd',''),(5709,'50643','','Grundy',''),(5710,'50645','','Bremer',''),(5711,'50645','','Floyd',''),(5712,'50647','','Black Hawk',''),(5713,'50648','','Black Hawk',''),(5714,'50650','','Fayette',''),(5715,'50651','','Benton',''),(5716,'50654','','Buchanan',''),(5717,'50658','','Floyd',''),(5718,'50660','','Grundy',''),(5719,'50662','','Buchanan',''),(5720,'50665','','Grundy',''),(5721,'50666','','Butler',''),(5722,'50669','','Black Hawk',''),(5723,'50669','','Tama',''),(5724,'50670','','Bremer',''),(5725,'50671','','Fayette',''),(5726,'50672','','Grundy',''),(5727,'50674','','Chickasaw',''),(5728,'50674','','Fayette',''),(5729,'50675','','Black Hawk',''),(5730,'50801','','Adair',''),(5731,'50801','','Adams',''),(5732,'50836','','Ringgold',''),(5733,'50837','','Adams',''),(5734,'50837','','Cass',''),(5735,'50840','','Ringgold',''),(5736,'50841','','Taylor',''),(5737,'50843','','Adams',''),(5738,'50845','','Union',''),(5739,'50851','','Adams',''),(5740,'50851','','Ringgold',''),(5741,'50851','','Union',''),(5742,'50853','','Adams',''),(5743,'50857','','Taylor',''),(5744,'50859','','Adair',''),(5745,'50861','','Ringgold',''),(5746,'50864','','Adams',''),(5747,'50864','','Cass',''),(5748,'50864','','Page',''),(5749,'50864','','Taylor',''),(5750,'51001','','Union',''),(5751,'51002','','Cherokee',''),(5752,'51005','','Buena Vista',''),(5753,'51006','','Woodbury',''),(5754,'51016','','Ida',''),(5755,'51018','','Ida',''),(5756,'51019','','Crawford',''),(5757,'51019','','Ida',''),(5758,'51020','','Cherokee',''),(5759,'51020','','Sac',''),(5760,'51022','','Obrien',''),(5761,'51022','','Plymouth',''),(5762,'51023','','Union',''),(5763,'51025','','Cherokee',''),(5764,'51026','','Monona',''),(5765,'51027','','Plymouth',''),(5766,'51028','','Woodbury',''),(5767,'51033','','Clay',''),(5768,'51034','','Crawford',''),(5769,'51034','','Woodbury',''),(5770,'51046','','Cherokee',''),(5771,'51047','','Buena Vista',''),(5772,'51047','','Cherokee',''),(5773,'51047','','Obrien',''),(5774,'51048','','Cherokee',''),(5775,'51053','','Ida',''),(5776,'51055','','Monona',''),(5777,'51056','','Monona',''),(5778,'51058','','Cherokee',''),(5779,'51058','','Clay',''),(5780,'51060','','Crawford',''),(5781,'51061','','Ida',''),(5782,'51108','','Plymouth',''),(5783,'51109','','Plymouth',''),(5784,'51201','','Lyon',''),(5785,'51201','','Sioux',''),(5786,'51232','','Lyon',''),(5787,'51235','','Sioux',''),(5788,'51238','','Obrien',''),(5789,'51239','','Lyon',''),(5790,'51240','','Sioux',''),(5791,'51243','','Osceola',''),(5792,'51247','','Lyon',''),(5793,'51248','','Osceola',''),(5794,'51334','','Dickinson',''),(5795,'51338','','Dickinson',''),(5796,'51342','','Emmet',''),(5797,'51345','','Dickinson',''),(5798,'51346','','Clay',''),(5799,'51346','','Osceola',''),(5800,'51358','','Clay',''),(5801,'51360','','Jackson',''),(5802,'51364','','Clay',''),(5803,'51364','','Emmet',''),(5804,'51366','','Buena Vista',''),(5805,'51431','','Sac',''),(5806,'51433','','Calhoun',''),(5807,'51436','','Crawford',''),(5808,'51436','','Sac',''),(5809,'51448','','Ida',''),(5810,'51448','','Sac',''),(5811,'51449','','Carroll',''),(5812,'51453','','Carroll',''),(5813,'51454','','Shelby',''),(5814,'51455','','Audubon',''),(5815,'51455','','Crawford',''),(5816,'51455','','Shelby',''),(5817,'51467','','Carroll',''),(5818,'51503','','Mills',''),(5819,'51521','','Shelby',''),(5820,'51523','','Harrison',''),(5821,'51527','','Crawford',''),(5822,'51529','','Crawford',''),(5823,'51529','','Monona',''),(5824,'51529','','Shelby',''),(5825,'51531','','Audubon',''),(5826,'51532','','Cass',''),(5827,'51532','','Pottawattamie',''),(5828,'51533','','Montgomery',''),(5829,'51535','','Pottawattamie',''),(5830,'51541','','Montgomery',''),(5831,'51541','','Pottawattamie',''),(5832,'51543','','Shelby',''),(5833,'51544','','Pottawattamie',''),(5834,'51545','','Monona',''),(5835,'51552','','Shelby',''),(5836,'51555','','Pottawattamie',''),(5837,'51557','','Burt',''),(5838,'51558','','Harrison',''),(5839,'51559','','Harrison',''),(5840,'51565','','Harrison',''),(5841,'51566','','Page',''),(5842,'51566','','Pottawattamie',''),(5843,'51570','','Harrison',''),(5844,'51570','','Pottawattamie',''),(5845,'51571','','Pottawattamie',''),(5846,'51577','','Shelby',''),(5847,'51601','','Fremont',''),(5848,'51632','','Taylor',''),(5849,'51638','','Montgomery',''),(5850,'51640','','Atchison',''),(5851,'51645','','Mills',''),(5852,'51653','','Mills',''),(5853,'52031','','Dubuque',''),(5854,'52032','','Jackson',''),(5855,'52032','','Jones',''),(5856,'52033','','Jones',''),(5857,'52035','','Clayton',''),(5858,'52037','','Jackson',''),(5859,'52040','','Delaware',''),(5860,'52042','','Delaware',''),(5861,'52050','','Clayton',''),(5862,'52052','','Dubuque',''),(5863,'52053','','Clayton',''),(5864,'52054','','Dubuque',''),(5865,'52060','','Clinton',''),(5866,'52064','','Clinton',''),(5867,'52065','','Delaware',''),(5868,'52069','','Clinton',''),(5869,'52070','','Clinton',''),(5870,'52073','','Clayton',''),(5871,'52076','','Delaware',''),(5872,'52076','','Fayette',''),(5873,'52078','','Delaware',''),(5874,'52079','','Dubuque',''),(5875,'52101','','Allamakee',''),(5876,'52132','','Howard',''),(5877,'52133','','Fayette',''),(5878,'52136','','Winneshiek',''),(5879,'52140','','Winneshiek',''),(5880,'52141','','Clayton',''),(5881,'52144','','Fayette',''),(5882,'52154','','Howard',''),(5883,'52156','','Allamakee',''),(5884,'52159','','Allamakee',''),(5885,'52161','','Fayette',''),(5886,'52162','','Clayton',''),(5887,'52162','','Fayette',''),(5888,'52162','','Winneshiek',''),(5889,'52171','','Chickasaw',''),(5890,'52171','','Winneshiek',''),(5891,'52172','','Winneshiek',''),(5892,'52203','','Johnson',''),(5893,'52205','','Linn',''),(5894,'52207','','Clinton',''),(5895,'52208','','Iowa',''),(5896,'52208','','Poweshiek',''),(5897,'52208','','Tama',''),(5898,'52213','','Benton',''),(5899,'52215','','Poweshiek',''),(5900,'52216','','Jones',''),(5901,'52218','','Buchanan',''),(5902,'52218','','Delaware',''),(5903,'52221','','Iowa',''),(5904,'52222','','Iowa',''),(5905,'52224','','Benton',''),(5906,'52225','','Benton',''),(5907,'52228','','Benton',''),(5908,'52228','','Johnson',''),(5909,'52237','','Dubuque',''),(5910,'52247','','Johnson',''),(5911,'52248','','Washington',''),(5912,'52253','','Cedar',''),(5913,'52253','','Johnson',''),(5914,'52253','','Jones',''),(5915,'52301','','Benton',''),(5916,'52305','','Linn',''),(5917,'52306','','Jones',''),(5918,'52309','','Jones',''),(5919,'52310','','Delaware',''),(5920,'52310','','Linn',''),(5921,'52316','','Keokuk',''),(5922,'52318','','Iowa',''),(5923,'52320','','Cedar',''),(5924,'52323','','Cedar',''),(5925,'52323','','Clinton',''),(5926,'52324','','Benton',''),(5927,'52325','','Johnson',''),(5928,'52327','','Johnson',''),(5929,'52332','','Linn',''),(5930,'52333','','Cedar',''),(5931,'52338','','Linn',''),(5932,'52339','','Poweshiek',''),(5933,'52347','','Poweshiek',''),(5934,'52351','','Linn',''),(5935,'52352','','Benton',''),(5936,'52352','','Buchanan',''),(5937,'52355','','Iowa',''),(5938,'52356','','Iowa',''),(5939,'52356','','Johnson',''),(5940,'52358','','Johnson',''),(5941,'52404','','Johnson',''),(5942,'52533','','Wapello',''),(5943,'52535','','Jefferson',''),(5944,'52536','','Monroe',''),(5945,'52537','','Wapello',''),(5946,'52540','','Jefferson',''),(5947,'52542','','Scotland',''),(5948,'52552','','Wapello',''),(5949,'52553','','Mahaska',''),(5950,'52553','','Monroe',''),(5951,'52554','','Davis',''),(5952,'52554','','Jefferson',''),(5953,'52554','','Van Buren',''),(5954,'52561','','Keokuk',''),(5955,'52563','','Jefferson',''),(5956,'52563','','Wapello',''),(5957,'52567','','Van Buren',''),(5958,'52569','','Appanoose',''),(5959,'52569','','Wayne',''),(5960,'52570','','Davis',''),(5961,'52571','','Monroe',''),(5962,'52572','','Davis',''),(5963,'52573','','Scotland',''),(5964,'52581','','Wayne',''),(5965,'52585','','Jefferson',''),(5966,'52585','','Washington',''),(5967,'52588','','Davis',''),(5968,'52590','','Appanoose',''),(5969,'52594','','Davis',''),(5970,'52621','','Louisa',''),(5971,'52623','','Henry',''),(5972,'52626','','Lee',''),(5973,'52626','','Clark',''),(5974,'52630','','Lee',''),(5975,'52630','','Van Buren',''),(5976,'52635','','Henry',''),(5977,'52640','','Des Moines',''),(5978,'52641','','Jefferson',''),(5979,'52641','','Washington',''),(5980,'52644','','Des Moines',''),(5981,'52645','','Des Moines',''),(5982,'52646','','Des Moines',''),(5983,'52649','','Lee',''),(5984,'52651','','Jefferson',''),(5985,'52654','','Washington',''),(5986,'52656','','Henry',''),(5987,'52658','','Des Moines',''),(5988,'52659','','Louisa',''),(5989,'52720','','Cedar',''),(5990,'52726','','Muscatine',''),(5991,'52731','','Jackson',''),(5992,'52739','','Louisa',''),(5993,'52747','','Muscatine',''),(5994,'52747','','Scott',''),(5995,'52754','','Muscatine',''),(5996,'52755','','Louisa',''),(5997,'52760','','Cedar',''),(5998,'52761','','Louisa',''),(5999,'52765','','Cedar',''),(6000,'52769','','Scott',''),(6001,'52773','','Muscatine',''),(6002,'52776','','Cedar',''),(6003,'52777','','Cedar',''),(6004,'52778','','Cedar',''),(6005,'53006','','Fond Du Lac',''),(6006,'53010','','Washington',''),(6007,'53011','','Fond Du Lac',''),(6008,'53012','','Washington',''),(6009,'53013','','Ozaukee',''),(6010,'53014','','Fond Du Lac',''),(6011,'53014','','Manitowoc',''),(6012,'53015','','Sheboygan',''),(6013,'53017','','Waukesha',''),(6014,'53020','','Calumet',''),(6015,'53020','','Manitowoc',''),(6016,'53021','','Washington',''),(6017,'53027','','Dodge',''),(6018,'53029','','Washington',''),(6019,'53036','','Dodge',''),(6020,'53036','','Waukesha',''),(6021,'53040','','Fond Du Lac',''),(6022,'53040','','Sheboygan',''),(6023,'53042','','Calumet',''),(6024,'53048','','Fond Du Lac',''),(6025,'53049','','Calumet',''),(6026,'53061','','Fond Du Lac',''),(6027,'53061','','Manitowoc',''),(6028,'53065','','Dodge',''),(6029,'53066','','Dodge',''),(6030,'53066','','Jefferson',''),(6031,'53075','','Ozaukee',''),(6032,'53079','','Sheboygan',''),(6033,'53090','','Ozaukee',''),(6034,'53091','','Washington',''),(6035,'53095','','Ozaukee',''),(6036,'53105','','Kenosha',''),(6037,'53105','','Walworth',''),(6038,'53114','','Rock',''),(6039,'53118','','Jefferson',''),(6040,'53119','','Walworth',''),(6041,'53120','','Racine',''),(6042,'53128','','Kenosha',''),(6043,'53139','','Kenosha',''),(6044,'53149','','Racine',''),(6045,'53149','','Walworth',''),(6046,'53150','','Racine',''),(6047,'53177','','Kenosha',''),(6048,'53182','','Kenosha',''),(6049,'53190','','Jefferson',''),(6050,'53190','','Rock',''),(6051,'53217','','Ozaukee',''),(6052,'53225','','Waukesha',''),(6053,'53403','','Kenosha',''),(6054,'53504','','Green',''),(6055,'53508','','Green',''),(6056,'53516','','Dane',''),(6057,'53516','','Green',''),(6058,'53516','','Iowa',''),(6059,'53517','','Iowa',''),(6060,'53518','','Crawford',''),(6061,'53518','','Grant',''),(6062,'53520','','Rock',''),(6063,'53521','','Green',''),(6064,'53521','','Rock',''),(6065,'53522','','Lafayette',''),(6066,'53523','','Jefferson',''),(6067,'53532','','Columbia',''),(6068,'53534','','Dane',''),(6069,'53534','','Jefferson',''),(6070,'53538','','Rock',''),(6071,'53543','','Grant',''),(6072,'53544','','Dane',''),(6073,'53554','','Iowa',''),(6074,'53555','','Dane',''),(6075,'53556','','Sauk',''),(6076,'53559','','Jefferson',''),(6077,'53560','','Iowa',''),(6078,'53561','','Columbia',''),(6079,'53563','','Jefferson',''),(6080,'53565','','Lafayette',''),(6081,'53569','','Iowa',''),(6082,'53572','','Green',''),(6083,'53573','','Iowa',''),(6084,'53573','','Richland',''),(6085,'53574','','Dane',''),(6086,'53578','','Columbia',''),(6087,'53583','','Columbia',''),(6088,'53583','','Dane',''),(6089,'53585','','Rock',''),(6090,'53588','','Iowa',''),(6091,'53589','','Rock',''),(6092,'53594','','Dane',''),(6093,'53594','','Dodge',''),(6094,'53805','','Crawford',''),(6095,'53807','','Lafayette',''),(6096,'53811','','Lafayette',''),(6097,'53818','','Iowa',''),(6098,'53818','','Lafayette',''),(6099,'53821','','Grant',''),(6100,'53901','','Marquette',''),(6101,'53911','','Dane',''),(6102,'53913','','Columbia',''),(6103,'53920','','Adams',''),(6104,'53923','','Green Lake',''),(6105,'53924','','Sauk',''),(6106,'53925','','Dane',''),(6107,'53925','','Dodge',''),(6108,'53926','','Columbia',''),(6109,'53926','','Marquette',''),(6110,'53929','','Monroe',''),(6111,'53929','','Vernon',''),(6112,'53932','','Dodge',''),(6113,'53937','','Richland',''),(6114,'53941','','Juneau',''),(6115,'53944','','Sauk',''),(6116,'53946','','Dodge',''),(6117,'53946','','Fond Du Lac',''),(6118,'53946','','Marquette',''),(6119,'53949','','Green Lake',''),(6120,'53952','','Marquette',''),(6121,'53954','','Marquette',''),(6122,'53956','','Columbia',''),(6123,'53956','','Green Lake',''),(6124,'53963','','Fond Du Lac',''),(6125,'53964','','Adams',''),(6126,'53964','','Waushara',''),(6127,'53965','','Adams',''),(6128,'53965','','Columbia',''),(6129,'53965','','Juneau',''),(6130,'53968','','Sauk',''),(6131,'53968','','Vernon',''),(6132,'54004','','Barron',''),(6133,'54005','','Barron',''),(6134,'54005','','Dunn',''),(6135,'54005','','St. Croix',''),(6136,'54007','','Polk',''),(6137,'54013','','Dunn',''),(6138,'54017','','Polk',''),(6139,'54020','','St. Croix',''),(6140,'54022','','St. Croix',''),(6141,'54026','','St. Croix',''),(6142,'54103','','Marinette',''),(6143,'54104','','Forest',''),(6144,'54107','','Outagamie',''),(6145,'54110','','Brown',''),(6146,'54110','','Manitowoc',''),(6147,'54111','','Oconto',''),(6148,'54112','','Oconto',''),(6149,'54114','','Oconto',''),(6150,'54115','','Outagamie',''),(6151,'54120','','Marinette',''),(6152,'54124','','Menominee',''),(6153,'54124','','Shawano',''),(6154,'54125','','Forest',''),(6155,'54126','','Manitowoc',''),(6156,'54130','','Brown',''),(6157,'54130','','Calumet',''),(6158,'54137','','Oconto',''),(6159,'54139','','Marinette',''),(6160,'54150','','Shawano',''),(6161,'54151','','Florence',''),(6162,'54154','','Shawano',''),(6163,'54155','','Outagamie',''),(6164,'54157','','Oconto',''),(6165,'54161','','Oconto',''),(6166,'54162','','Oconto',''),(6167,'54162','','Shawano',''),(6168,'54165','','Brown',''),(6169,'54165','','Shawano',''),(6170,'54170','','Shawano',''),(6171,'54170','','Waupaca',''),(6172,'54174','','Menominee',''),(6173,'54175','','Langlade',''),(6174,'54180','','Outagamie',''),(6175,'54201','','Door',''),(6176,'54205','','Door',''),(6177,'54208','','Kewaunee',''),(6178,'54208','','Manitowoc',''),(6179,'54213','','Kewaunee',''),(6180,'54217','','Brown',''),(6181,'54217','','Door',''),(6182,'54313','','Outagamie',''),(6183,'54405','','Marathon',''),(6184,'54408','','Langlade',''),(6185,'54408','','Shawano',''),(6186,'54409','','Marathon',''),(6187,'54409','','Shawano',''),(6188,'54411','','Taylor',''),(6189,'54412','','Marathon',''),(6190,'54414','','Marathon',''),(6191,'54420','','Wood',''),(6192,'54421','','Marathon',''),(6193,'54422','','Taylor',''),(6194,'54425','','Marathon',''),(6195,'54425','','Taylor',''),(6196,'54427','','Shawano',''),(6197,'54428','','Oneida',''),(6198,'54433','','Chippewa',''),(6199,'54435','','Langlade',''),(6200,'54443','','Marathon',''),(6201,'54443','','Wood',''),(6202,'54449','','Clark',''),(6203,'54449','','Marathon',''),(6204,'54451','','Marathon',''),(6205,'54452','','Marathon',''),(6206,'54454','','Marathon',''),(6207,'54454','','Portage',''),(6208,'54455','','Portage',''),(6209,'54457','','Adams',''),(6210,'54457','','Juneau',''),(6211,'54460','','Taylor',''),(6212,'54465','','Forest',''),(6213,'54466','','Clark',''),(6214,'54466','','Jackson',''),(6215,'54470','','Price',''),(6216,'54473','','Marathon',''),(6217,'54475','','Portage',''),(6218,'54479','','Clark',''),(6219,'54480','','Marathon',''),(6220,'54486','','Waupaca',''),(6221,'54487','','Oneida',''),(6222,'54488','','Marathon',''),(6223,'54490','','Price',''),(6224,'54491','','Oconto',''),(6225,'54494','','Adams',''),(6226,'54494','','Portage',''),(6227,'54498','','Taylor',''),(6228,'54499','','Marathon',''),(6229,'54499','','Portage',''),(6230,'54501','','Lincoln',''),(6231,'54514','','Iron',''),(6232,'54514','','Price',''),(6233,'54517','','Bayfield',''),(6234,'54517','','Sawyer',''),(6235,'54521','','Forest',''),(6236,'54521','','Oneida',''),(6237,'54530','','Price',''),(6238,'54530','','Sawyer',''),(6239,'54538','','Iron',''),(6240,'54538','','Oneida',''),(6241,'54538','','Price',''),(6242,'54540','','Gogebic',''),(6243,'54542','','Forest',''),(6244,'54545','','Iron',''),(6245,'54548','','Vilas',''),(6246,'54552','','Iron',''),(6247,'54552','','Sawyer',''),(6248,'54554','','Iron',''),(6249,'54558','','Oneida',''),(6250,'54559','','Ashland',''),(6251,'54562','','Forest',''),(6252,'54564','','Lincoln',''),(6253,'54568','','Oneida',''),(6254,'54612','','Buffalo',''),(6255,'54615','','Monroe',''),(6256,'54616','','Jackson',''),(6257,'54618','','Monroe',''),(6258,'54619','','La Crosse',''),(6259,'54619','','Vernon',''),(6260,'54623','','La Crosse',''),(6261,'54624','','Crawford',''),(6262,'54627','','Jackson',''),(6263,'54628','','Vernon',''),(6264,'54634','','Juneau',''),(6265,'54634','','Richland',''),(6266,'54638','','Juneau',''),(6267,'54638','','Vernon',''),(6268,'54639','','Richland',''),(6269,'54641','','Jackson',''),(6270,'54642','','La Crosse',''),(6271,'54642','','Trempealeau',''),(6272,'54644','','Jackson',''),(6273,'54651','','Monroe',''),(6274,'54653','','Monroe',''),(6275,'54655','','Richland',''),(6276,'54655','','Vernon',''),(6277,'54656','','La Crosse',''),(6278,'54658','','La Crosse',''),(6279,'54659','','Trempealeau',''),(6280,'54661','','La Crosse',''),(6281,'54664','','Vernon',''),(6282,'54666','','Jackson',''),(6283,'54666','','Juneau',''),(6284,'54667','','La Crosse',''),(6285,'54701','','Dunn',''),(6286,'54703','','Chippewa',''),(6287,'54703','','Dunn',''),(6288,'54721','','Dunn',''),(6289,'54724','','Dunn',''),(6290,'54726','','Eau Claire',''),(6291,'54727','','Eau Claire',''),(6292,'54728','','Rusk',''),(6293,'54729','','Eau Claire',''),(6294,'54730','','Chippewa',''),(6295,'54734','','St. Croix',''),(6296,'54736','','Buffalo',''),(6297,'54736','','Dunn',''),(6298,'54737','','Pepin',''),(6299,'54738','','Trempealeau',''),(6300,'54739','','Chippewa',''),(6301,'54739','','Eau Claire',''),(6302,'54740','','Dunn',''),(6303,'54741','','Clark',''),(6304,'54741','','Jackson',''),(6305,'54745','','Rusk',''),(6306,'54746','','Jackson',''),(6307,'54747','','Buffalo',''),(6308,'54749','','St. Croix',''),(6309,'54754','','Clark',''),(6310,'54755','','Dunn',''),(6311,'54755','','Eau Claire',''),(6312,'54755','','Pepin',''),(6313,'54757','','Barron',''),(6314,'54757','','Dunn',''),(6315,'54757','','Rusk',''),(6316,'54758','','Eau Claire',''),(6317,'54758','','Jackson',''),(6318,'54762','','Dunn',''),(6319,'54763','','Barron',''),(6320,'54766','','Chippewa',''),(6321,'54766','','Taylor',''),(6322,'54767','','Dunn',''),(6323,'54767','','St. Croix',''),(6324,'54768','','Clark',''),(6325,'54768','','Eau Claire',''),(6326,'54768','','Taylor',''),(6327,'54769','','Pierce',''),(6328,'54770','','Eau Claire',''),(6329,'54771','','Taylor',''),(6330,'54801','','Burnett',''),(6331,'54806','','Bayfield',''),(6332,'54813','','Burnett',''),(6333,'54813','','Washburn',''),(6334,'54817','','Barron',''),(6335,'54817','','Rusk',''),(6336,'54817','','Sawyer',''),(6337,'54820','','Bayfield',''),(6338,'54821','','Sawyer',''),(6339,'54826','','Polk',''),(6340,'54829','','Polk',''),(6341,'54830','','Douglas',''),(6342,'54830','','Washburn',''),(6343,'54835','','Rusk',''),(6344,'54837','','Burnett',''),(6345,'54838','','Bayfield',''),(6346,'54840','','Polk',''),(6347,'54843','','Washburn',''),(6348,'54853','','Burnett',''),(6349,'54856','','Ashland',''),(6350,'54859','','Douglas',''),(6351,'54868','','Rusk',''),(6352,'54868','','Washburn',''),(6353,'54870','','Barron',''),(6354,'54871','','Burnett',''),(6355,'54872','','Polk',''),(6356,'54873','','Bayfield',''),(6357,'54876','','Washburn',''),(6358,'54889','','Polk',''),(6359,'54896','','Rusk',''),(6360,'54909','','Waushara',''),(6361,'54914','','Winnebago',''),(6362,'54915','','Calumet',''),(6363,'54915','','Winnebago',''),(6364,'54921','','Adams',''),(6365,'54922','','Waupaca',''),(6366,'54923','','Waushara',''),(6367,'54923','','Winnebago',''),(6368,'54929','','Outagamie',''),(6369,'54929','','Shawano',''),(6370,'54930','','Adams',''),(6371,'54930','','Marquette',''),(6372,'54940','','Outagamie',''),(6373,'54940','','Waushara',''),(6374,'54940','','Winnebago',''),(6375,'54943','','Adams',''),(6376,'54945','','Portage',''),(6377,'54950','','Shawano',''),(6378,'54952','','Calumet',''),(6379,'54956','','Outagamie',''),(6380,'54960','','Green Lake',''),(6381,'54960','','Waushara',''),(6382,'54961','','Outagamie',''),(6383,'54964','','Fond Du Lac',''),(6384,'54965','','Waupaca',''),(6385,'54966','','Adams',''),(6386,'54966','','Portage',''),(6387,'54968','','Marquette',''),(6388,'54971','','Green Lake',''),(6389,'54971','','Winnebago',''),(6390,'54977','','Portage',''),(6391,'54979','','Winnebago',''),(6392,'54981','','Portage',''),(6393,'54981','','Waushara',''),(6394,'54982','','Marquette',''),(6395,'54983','','Waushara',''),(6396,'54984','','Portage',''),(6397,'54986','','Waushara',''),(6398,'55006','','Chisago',''),(6399,'55006','','Kanabec',''),(6400,'55006','','Pine',''),(6401,'55007','','Pine',''),(6402,'55008','','Chisago',''),(6403,'55009','','Dakota',''),(6404,'55018','','Rice',''),(6405,'55025','','Anoka',''),(6406,'55025','','Chisago',''),(6407,'55027','','Wabasha',''),(6408,'55030','','Kanabec',''),(6409,'55033','','Goodhue',''),(6410,'55033','','Washington',''),(6411,'55037','','Kanabec',''),(6412,'55038','','Anoka',''),(6413,'55038','','Ramsey',''),(6414,'55041','','Goodhue',''),(6415,'55044','','Scott',''),(6416,'55049','','Rice',''),(6417,'55052','','Steele',''),(6418,'55052','','Waseca',''),(6419,'55053','','Goodhue',''),(6420,'55056','','Isanti',''),(6421,'55057','','Dakota',''),(6422,'55065','','Goodhue',''),(6423,'55069','','Pine',''),(6424,'55070','','Isanti',''),(6425,'55072','','Kanabec',''),(6426,'55073','','Chisago',''),(6427,'55079','','Anoka',''),(6428,'55079','','Isanti',''),(6429,'55080','','Chisago',''),(6430,'55088','','Scott',''),(6431,'55089','','Dakota',''),(6432,'55092','','Anoka',''),(6433,'55110','','Anoka',''),(6434,'55110','','Washington',''),(6435,'55118','','Ramsey',''),(6436,'55126','','Anoka',''),(6437,'55314','','Sibley',''),(6438,'55320','','Stearns',''),(6439,'55327','','Wright',''),(6440,'55328','','Carver',''),(6441,'55328','','Hennepin',''),(6442,'55329','','Meeker',''),(6443,'55330','','Anoka',''),(6444,'55330','','Wright',''),(6445,'55331','','Carver',''),(6446,'55332','','Nicollet',''),(6447,'55333','','Brown',''),(6448,'55333','','Redwood',''),(6449,'55334','','Nicollet',''),(6450,'55335','','Nicollet',''),(6451,'55336','','Sibley',''),(6452,'55339','','Sibley',''),(6453,'55341','','Hennepin',''),(6454,'55350','','Meeker',''),(6455,'55350','','Renville',''),(6456,'55353','','Meeker',''),(6457,'55371','','Benton',''),(6458,'55371','','Isanti',''),(6459,'55371','','Sherburne',''),(6460,'55373','','Hennepin',''),(6461,'55374','','Wright',''),(6462,'55375','','Carver',''),(6463,'55382','','Meeker',''),(6464,'55382','','Wright',''),(6465,'55385','','Renville',''),(6466,'55385','','Sibley',''),(6467,'55387','','Hennepin',''),(6468,'55388','','Hennepin',''),(6469,'55388','','Wright',''),(6470,'55389','','Stearns',''),(6471,'55395','','Carver',''),(6472,'55397','','Mcleod',''),(6473,'55398','','Isanti',''),(6474,'55418','','Ramsey',''),(6475,'55421','','Hennepin',''),(6476,'55421','','Ramsey',''),(6477,'55432','','Ramsey',''),(6478,'55449','','Ramsey',''),(6479,'55616','','St. Louis',''),(6480,'55720','','St. Louis',''),(6481,'55723','','Itasca',''),(6482,'55731','','Lake',''),(6483,'55735','','Aitkin',''),(6484,'55736','','Itasca',''),(6485,'55746','','Itasca',''),(6486,'55748','','Itasca',''),(6487,'55749','','Pine',''),(6488,'55752','','Itasca',''),(6489,'55756','','Carlton',''),(6490,'55767','','Pine',''),(6491,'55771','','Koochiching',''),(6492,'55781','','Itasca',''),(6493,'55783','','Aitkin',''),(6494,'55783','','Carlton',''),(6495,'55785','','Cass',''),(6496,'55787','','Carlton',''),(6497,'55798','','Aitkin',''),(6498,'55798','','St. Louis',''),(6499,'55810','','Carlton',''),(6500,'55906','','Wabasha',''),(6501,'55910','','Wabasha',''),(6502,'55912','','Freeborn',''),(6503,'55917','','Dodge',''),(6504,'55917','','Freeborn',''),(6505,'55917','','Mower',''),(6506,'55923','','Olmsted',''),(6507,'55923','','Winona',''),(6508,'55924','','Steele',''),(6509,'55932','','Olmsted',''),(6510,'55940','','Olmsted',''),(6511,'55943','','Winona',''),(6512,'55944','','Olmsted',''),(6513,'55946','','Rice',''),(6514,'55947','','Winona',''),(6515,'55951','','Fillmore',''),(6516,'55953','','Freeborn',''),(6517,'55954','','Houston',''),(6518,'55956','','Goodhue',''),(6519,'55956','','Olmsted',''),(6520,'55960','','Wabasha',''),(6521,'55961','','Mower',''),(6522,'55962','','Winona',''),(6523,'55963','','Dodge',''),(6524,'55963','','Olmsted',''),(6525,'55964','','Olmsted',''),(6526,'55964','','Winona',''),(6527,'55971','','Houston',''),(6528,'55971','','Winona',''),(6529,'55972','','Olmsted',''),(6530,'55974','','Fillmore',''),(6531,'55975','','Mower',''),(6532,'55976','','Fillmore',''),(6533,'55979','','Fillmore',''),(6534,'55985','','Goodhue',''),(6535,'55985','','Steele',''),(6536,'55991','','Olmsted',''),(6537,'56011','','Carver',''),(6538,'56011','','Le Sueur',''),(6539,'56011','','Sibley',''),(6540,'56013','','Martin',''),(6541,'56019','','Cottonwood',''),(6542,'56019','','Watonwan',''),(6543,'56026','','Freeborn',''),(6544,'56026','','Waseca',''),(6545,'56027','','Kossuth',''),(6546,'56027','','Martin',''),(6547,'56028','','Waseca',''),(6548,'56044','','Le Sueur',''),(6549,'56048','','Blue Earth',''),(6550,'56052','','Rice',''),(6551,'56054','','Sibley',''),(6552,'56058','','Nicollet',''),(6553,'56058','','Sibley',''),(6554,'56062','','Blue Earth',''),(6555,'56062','','Brown',''),(6556,'56063','','Le Sueur',''),(6557,'56063','','Waseca',''),(6558,'56068','','Blue Earth',''),(6559,'56068','','Waseca',''),(6560,'56069','','Rice',''),(6561,'56071','','Le Sueur',''),(6562,'56071','','Rice',''),(6563,'56072','','Freeborn',''),(6564,'56072','','Steele',''),(6565,'56073','','Blue Earth',''),(6566,'56073','','Nicollet',''),(6567,'56078','','Waseca',''),(6568,'56081','','Brown',''),(6569,'56082','','Le Sueur',''),(6570,'56083','','Brown',''),(6571,'56083','','Cottonwood',''),(6572,'56085','','Redwood',''),(6573,'56087','','Redwood',''),(6574,'56088','','Blue Earth',''),(6575,'56088','','Watonwan',''),(6576,'56093','','Rice',''),(6577,'56093','','Steele',''),(6578,'56096','','Rice',''),(6579,'56096','','Waseca',''),(6580,'56097','','Freeborn',''),(6581,'56097','','Waseca',''),(6582,'56098','','Martin',''),(6583,'56101','','Jackson',''),(6584,'56115','','Murray',''),(6585,'56118','','Jackson',''),(6586,'56119','','Jackson',''),(6587,'56122','','Nobles',''),(6588,'56128','','Murray',''),(6589,'56128','','Nobles',''),(6590,'56128','','Rock',''),(6591,'56129','','Rock',''),(6592,'56131','','Cottonwood',''),(6593,'56131','','Nobles',''),(6594,'56132','','Murray',''),(6595,'56137','','Cottonwood',''),(6596,'56141','','Nobles',''),(6597,'56144','','Rock',''),(6598,'56144','','Moody',''),(6599,'56147','','Nobles',''),(6600,'56149','','Pipestone',''),(6601,'56152','','Cottonwood',''),(6602,'56158','','Nobles',''),(6603,'56159','','Jackson',''),(6604,'56160','','Jackson',''),(6605,'56160','','Martin',''),(6606,'56162','','Watonwan',''),(6607,'56164','','Lincoln',''),(6608,'56164','','Moody',''),(6609,'56166','','Cottonwood',''),(6610,'56167','','Jackson',''),(6611,'56170','','Lyon',''),(6612,'56170','','Murray',''),(6613,'56175','','Murray',''),(6614,'56175','','Redwood',''),(6615,'56178','','Lyon',''),(6616,'56180','','Cottonwood',''),(6617,'56180','','Murray',''),(6618,'56183','','Murray',''),(6619,'56186','','Murray',''),(6620,'56187','','Jackson',''),(6621,'56207','','Swift',''),(6622,'56208','','Chippewa',''),(6623,'56208','','Lac Qui Parle',''),(6624,'56209','','Meeker',''),(6625,'56211','','Traverse',''),(6626,'56214','','Yellow Medicine',''),(6627,'56215','','Pope',''),(6628,'56218','','Yellow Medicine',''),(6629,'56219','','Roberts',''),(6630,'56220','','Lac Qui Parle',''),(6631,'56220','','Lincoln',''),(6632,'56221','','Big Stone',''),(6633,'56221','','Traverse',''),(6634,'56226','','Pope',''),(6635,'56228','','Renville',''),(6636,'56229','','Yellow Medicine',''),(6637,'56236','','Big Stone',''),(6638,'56240','','Traverse',''),(6639,'56241','','Chippewa',''),(6640,'56241','','Renville',''),(6641,'56244','','Pope',''),(6642,'56244','','Swift',''),(6643,'56248','','Stevens',''),(6644,'56248','','Traverse',''),(6645,'56252','','Chippewa',''),(6646,'56252','','Kandiyohi',''),(6647,'56258','','Redwood',''),(6648,'56260','','Renville',''),(6649,'56262','','Swift',''),(6650,'56263','','Lyon',''),(6651,'56264','','Lincoln',''),(6652,'56264','','Yellow Medicine',''),(6653,'56265','','Lac Qui Parle',''),(6654,'56265','','Yellow Medicine',''),(6655,'56266','','Brown',''),(6656,'56270','','Redwood',''),(6657,'56271','','Chippewa',''),(6658,'56274','','Traverse',''),(6659,'56276','','Lac Qui Parle',''),(6660,'56278','','Lac Qui Parle',''),(6661,'56280','','Lincoln',''),(6662,'56282','','Chippewa',''),(6663,'56283','','Renville',''),(6664,'56284','','Kandiyohi',''),(6665,'56284','','Redwood',''),(6666,'56289','','Swift',''),(6667,'56291','','Lincoln',''),(6668,'56291','','Yellow Medicine',''),(6669,'56304','','Benton',''),(6670,'56308','','Pope',''),(6671,'56309','','Otter Tail',''),(6672,'56312','','Kandiyohi',''),(6673,'56314','','Stearns',''),(6674,'56315','','Otter Tail',''),(6675,'56316','','Kandiyohi',''),(6676,'56316','','Pope',''),(6677,'56318','','Morrison',''),(6678,'56319','','Todd',''),(6679,'56323','','Stevens',''),(6680,'56326','','Otter Tail',''),(6681,'56327','','Pope',''),(6682,'56329','','Morrison',''),(6683,'56330','','Benton',''),(6684,'56331','','Todd',''),(6685,'56334','','Douglas',''),(6686,'56336','','Stearns',''),(6687,'56338','','Crow Wing',''),(6688,'56339','','Douglas',''),(6689,'56340','','Morrison',''),(6690,'56342','','Aitkin',''),(6691,'56342','','Kanabec',''),(6692,'56343','','Grant',''),(6693,'56343','','Pope',''),(6694,'56343','','Stevens',''),(6695,'56349','','Douglas',''),(6696,'56353','','Isanti',''),(6697,'56353','','Kanabec',''),(6698,'56357','','Mille Lacs',''),(6699,'56358','','Isanti',''),(6700,'56358','','Mille Lacs',''),(6701,'56360','','Todd',''),(6702,'56361','','Douglas',''),(6703,'56362','','Kandiyohi',''),(6704,'56362','','Meeker',''),(6705,'56364','','Crow Wing',''),(6706,'56367','','Stearns',''),(6707,'56373','','Benton',''),(6708,'56377','','Benton',''),(6709,'56378','','Todd',''),(6710,'56382','','Todd',''),(6711,'56385','','Douglas',''),(6712,'56401','','Cass',''),(6713,'56431','','Crow Wing',''),(6714,'56433','','Cass',''),(6715,'56434','','Wadena',''),(6716,'56435','','Crow Wing',''),(6717,'56437','','Otter Tail',''),(6718,'56443','','Todd',''),(6719,'56446','','Douglas',''),(6720,'56446','','Otter Tail',''),(6721,'56448','','Cass',''),(6722,'56449','','Morrison',''),(6723,'56450','','Mille Lacs',''),(6724,'56453','','Otter Tail',''),(6725,'56461','','Cass',''),(6726,'56464','','Becker',''),(6727,'56464','','Hubbard',''),(6728,'56464','','Otter Tail',''),(6729,'56466','','Morrison',''),(6730,'56466','','Todd',''),(6731,'56468','','Cass',''),(6732,'56470','','Becker',''),(6733,'56470','','Clearwater',''),(6734,'56470','','Wadena',''),(6735,'56472','','Cass',''),(6736,'56473','','Morrison',''),(6737,'56474','','Crow Wing',''),(6738,'56477','','Cass',''),(6739,'56477','','Otter Tail',''),(6740,'56479','','Cass',''),(6741,'56479','','Wadena',''),(6742,'56481','','Cass',''),(6743,'56481','','Todd',''),(6744,'56482','','Otter Tail',''),(6745,'56482','','Todd',''),(6746,'56501','','Otter Tail',''),(6747,'56514','','Otter Tail',''),(6748,'56514','','Wilkin',''),(6749,'56516','','Norman',''),(6750,'56519','','Clay',''),(6751,'56522','','Otter Tail',''),(6752,'56535','','Red Lake',''),(6753,'56540','','Norman',''),(6754,'56542','','Mahnomen',''),(6755,'56544','','Otter Tail',''),(6756,'56552','','Becker',''),(6757,'56554','','Clay',''),(6758,'56557','','Clearwater',''),(6759,'56557','','Norman',''),(6760,'56560','','Wilkin',''),(6761,'56565','','Grant',''),(6762,'56572','','Becker',''),(6763,'56579','','Otter Tail',''),(6764,'56583','','Wilkin',''),(6765,'56585','','Becker',''),(6766,'56589','','Becker',''),(6767,'56589','','Clearwater',''),(6768,'56592','','Mahnomen',''),(6769,'56601','','Hubbard',''),(6770,'56621','','Mahnomen',''),(6771,'56621','','Polk',''),(6772,'56623','','Koochiching',''),(6773,'56630','','Itasca',''),(6774,'56633','','Beltrami',''),(6775,'56633','','Hubbard',''),(6776,'56634','','Polk',''),(6777,'56636','','Cass',''),(6778,'56639','','Koochiching',''),(6779,'56644','','Polk',''),(6780,'56649','','St. Louis',''),(6781,'56651','','Polk',''),(6782,'56652','','Beltrami',''),(6783,'56661','','Beltrami',''),(6784,'56661','','Itasca',''),(6785,'56669','','St. Louis',''),(6786,'56671','','Clearwater',''),(6787,'56673','','Lake Of The Woods',''),(6788,'56676','','Beltrami',''),(6789,'56678','','Clearwater',''),(6790,'56678','','Hubbard',''),(6791,'56684','','Pennington',''),(6792,'56701','','Marshall',''),(6793,'56710','','Polk',''),(6794,'56715','','Polk',''),(6795,'56716','','Red Lake',''),(6796,'56725','','Marshall',''),(6797,'56727','','Beltrami',''),(6798,'56732','','Marshall',''),(6799,'56732','','Roseau',''),(6800,'56735','','Roseau',''),(6801,'56736','','Red Lake',''),(6802,'56742','','Pennington',''),(6803,'56742','','Polk',''),(6804,'56744','','Polk',''),(6805,'56744','','Grand Forks',''),(6806,'56744','','Walsh',''),(6807,'56748','','Pennington',''),(6808,'56750','','Pennington',''),(6809,'56750','','Polk',''),(6810,'56759','','Marshall',''),(6811,'56762','','Polk',''),(6812,'57001','','Lincoln',''),(6813,'57004','','Clay',''),(6814,'57004','','Lincoln',''),(6815,'57006','','Moody',''),(6816,'57010','','Union',''),(6817,'57014','','Clay',''),(6818,'57014','','Lincoln',''),(6819,'57022','','Lake',''),(6820,'57022','','Moody',''),(6821,'57026','','Lincoln',''),(6822,'57026','','Moody',''),(6823,'57029','','Turner',''),(6824,'57030','','Rock',''),(6825,'57031','','Clay',''),(6826,'57034','','Union',''),(6827,'57035','','Mccook',''),(6828,'57037','','Clay',''),(6829,'57037','','Turner',''),(6830,'57039','','Turner',''),(6831,'57043','','Hutchinson',''),(6832,'57043','','Mccook',''),(6833,'57045','','Yankton',''),(6834,'57047','','Mccook',''),(6835,'57048','','Minnehaha',''),(6836,'57053','','Mccook',''),(6837,'57059','','Hutchinson',''),(6838,'57063','','Yankton',''),(6839,'57064','','Turner',''),(6840,'57068','','Rock',''),(6841,'57070','','Yankton',''),(6842,'57071','','Lake',''),(6843,'57072','','Clay',''),(6844,'57073','','Turner',''),(6845,'57076','','Miner',''),(6846,'57078','','Cedar',''),(6847,'57106','','Lincoln',''),(6848,'57108','','Minnehaha',''),(6849,'57212','','Brookings',''),(6850,'57212','','Hamlin',''),(6851,'57213','','Brookings',''),(6852,'57216','','Roberts',''),(6853,'57221','','Clark',''),(6854,'57223','','Deuel',''),(6855,'57226','','Hamlin',''),(6856,'57227','','Grant',''),(6857,'57234','','Deuel',''),(6858,'57235','','Day',''),(6859,'57238','','Codington',''),(6860,'57238','','Hamlin',''),(6861,'57242','','Codington',''),(6862,'57243','','Clark',''),(6863,'57248','','Kingsbury',''),(6864,'57252','','Roberts',''),(6865,'57256','','Grant',''),(6866,'57258','','Spink',''),(6867,'57259','','Deuel',''),(6868,'57262','','Marshall',''),(6869,'57263','','Grant',''),(6870,'57265','','Deuel',''),(6871,'57266','','Grant',''),(6872,'57268','','Brookings',''),(6873,'57270','','Roberts',''),(6874,'57271','','Hamlin',''),(6875,'57272','','Clark',''),(6876,'57273','','Roberts',''),(6877,'57274','','Clark',''),(6878,'57301','','Hanson',''),(6879,'57311','','Hutchinson',''),(6880,'57312','','Beadle',''),(6881,'57313','','Charles Mix',''),(6882,'57319','','Hutchinson',''),(6883,'57319','','Turner',''),(6884,'57321','','Hanson',''),(6885,'57321','','Mccook',''),(6886,'57322','','Clark',''),(6887,'57322','','Spink',''),(6888,'57325','','Buffalo',''),(6889,'57330','','Charles Mix',''),(6890,'57330','','Hutchinson',''),(6891,'57331','','Davison',''),(6892,'57331','','Douglas',''),(6893,'57332','','Hutchinson',''),(6894,'57332','','Mccook',''),(6895,'57334','','Hanson',''),(6896,'57334','','Hutchinson',''),(6897,'57340','','Miner',''),(6898,'57348','','Spink',''),(6899,'57353','','Beadle',''),(6900,'57355','','Buffalo',''),(6901,'57355','','Jerauld',''),(6902,'57359','','Aurora',''),(6903,'57359','','Davison',''),(6904,'57363','','Sanborn',''),(6905,'57366','','Douglas',''),(6906,'57369','','Brule',''),(6907,'57369','','Douglas',''),(6908,'57370','','Buffalo',''),(6909,'57374','','Hanson',''),(6910,'57376','','Bon Homme',''),(6911,'57381','','Hand',''),(6912,'57382','','Aurora',''),(6913,'57382','','Beadle',''),(6914,'57383','','Brule',''),(6915,'57385','','Aurora',''),(6916,'57385','','Jerauld',''),(6917,'57424','','Faulk',''),(6918,'57428','','Walworth',''),(6919,'57432','','Marshall',''),(6920,'57434','','Brown',''),(6921,'57434','','Clark',''),(6922,'57434','','Day',''),(6923,'57435','','Edmunds',''),(6924,'57437','','Campbell',''),(6925,'57442','','Dewey',''),(6926,'57442','','Sully',''),(6927,'57448','','Mcpherson',''),(6928,'57450','','Walworth',''),(6929,'57451','','Brown',''),(6930,'57452','','Campbell',''),(6931,'57454','','Day',''),(6932,'57456','','Edmunds',''),(6933,'57460','','Edmunds',''),(6934,'57460','','Faulk',''),(6935,'57460','','Spink',''),(6936,'57465','','Faulk',''),(6937,'57466','','Edmunds',''),(6938,'57467','','Faulk',''),(6939,'57469','','Faulk',''),(6940,'57469','','Hand',''),(6941,'57470','','Hand',''),(6942,'57473','','Potter',''),(6943,'57475','','Edmunds',''),(6944,'57476','','Hand',''),(6945,'57481','','Edmunds',''),(6946,'57481','','Mcpherson',''),(6947,'57501','','Sully',''),(6948,'57521','','Mellette',''),(6949,'57529','','Tripp',''),(6950,'57532','','Lyman',''),(6951,'57533','','Lyman',''),(6952,'57536','','Sully',''),(6953,'57552','','Jackson',''),(6954,'57552','','Jones',''),(6955,'57552','','Stanley',''),(6956,'57560','','Bennett',''),(6957,'57564','','Hyde',''),(6958,'57566','','Mellette',''),(6959,'57567','','Jackson',''),(6960,'57576','','Jones',''),(6961,'57577','','Bennett',''),(6962,'57580','','Mellette',''),(6963,'57580','','Todd',''),(6964,'57601','','Corson',''),(6965,'57601','','Dewey',''),(6966,'57625','','Ziebach',''),(6967,'57626','','Perkins',''),(6968,'57626','','Ziebach',''),(6969,'57631','','Campbell',''),(6970,'57633','','Corson',''),(6971,'57633','','Ziebach',''),(6972,'57638','','Adams',''),(6973,'57638','','Grant',''),(6974,'57638','','Sioux',''),(6975,'57638','','Corson',''),(6976,'57641','','Sioux',''),(6977,'57642','','Sioux',''),(6978,'57644','','Corson',''),(6979,'57644','','Ziebach',''),(6980,'57645','','Grant',''),(6981,'57645','','Sioux',''),(6982,'57648','','Emmons',''),(6983,'57649','','Harding',''),(6984,'57656','','Corson',''),(6985,'57657','','Dewey',''),(6986,'57660','','Grant',''),(6987,'57660','','Sioux',''),(6988,'57701','','Meade',''),(6989,'57702','','Meade',''),(6990,'57706','','Pennington',''),(6991,'57716','','Bennett',''),(6992,'57717','','Harding',''),(6993,'57717','','Lawrence',''),(6994,'57717','','Crook',''),(6995,'57718','','Pennington',''),(6996,'57719','','Meade',''),(6997,'57722','','Fall River',''),(6998,'57722','','Shannon',''),(6999,'57724','','Carter',''),(7000,'57730','','Pennington',''),(7001,'57735','','Custer',''),(7002,'57744','','Pennington',''),(7003,'57744','','Shannon',''),(7004,'57747','','Custer',''),(7005,'57748','','Meade',''),(7006,'57751','','Custer',''),(7007,'57752','','Bennett',''),(7008,'57752','','Jackson',''),(7009,'57758','','Perkins',''),(7010,'57760','','Harding',''),(7011,'57761','','Meade',''),(7012,'57767','','Meade',''),(7013,'57775','','Haakon',''),(7014,'57775','','Jackson',''),(7015,'57783','','Butte',''),(7016,'57785','','Lawrence',''),(7017,'57788','','Meade',''),(7018,'57791','','Meade',''),(7019,'57793','','Butte',''),(7020,'57793','','Meade',''),(7021,'58016','','Steele',''),(7022,'58027','','Barnes',''),(7023,'58027','','Cass',''),(7024,'58031','','Cass',''),(7025,'58035','','Cass',''),(7026,'58035','','Steele',''),(7027,'58038','','Traill',''),(7028,'58046','','Barnes',''),(7029,'58046','','Cass',''),(7030,'58047','','Richland',''),(7031,'58048','','Traill',''),(7032,'58049','','Lamoure',''),(7033,'58049','','Ransom',''),(7034,'58051','','Richland',''),(7035,'58052','','Ransom',''),(7036,'58052','','Richland',''),(7037,'58053','','Sargent',''),(7038,'58056','','Barnes',''),(7039,'58056','','Griggs',''),(7040,'58057','','Ransom',''),(7041,'58060','','Ransom',''),(7042,'58062','','Ransom',''),(7043,'58064','','Barnes',''),(7044,'58064','','Steele',''),(7045,'58069','','Ransom',''),(7046,'58071','','Barnes',''),(7047,'58212','','Grand Forks',''),(7048,'58212','','Griggs',''),(7049,'58212','','Steele',''),(7050,'58225','','Kittson',''),(7051,'58225','','Walsh',''),(7052,'58227','','Cavalier',''),(7053,'58227','','Pembina',''),(7054,'58229','','Cavalier',''),(7055,'58229','','Ramsey',''),(7056,'58231','','Grand Forks',''),(7057,'58233','','Grand Forks',''),(7058,'58240','','Grand Forks',''),(7059,'58240','','Steele',''),(7060,'58243','','Pembina',''),(7061,'58261','','Grand Forks',''),(7062,'58266','','Nelson',''),(7063,'58267','','Steele',''),(7064,'58274','','Steele',''),(7065,'58275','','Traill',''),(7066,'58282','','Cavalier',''),(7067,'58301','','Benson',''),(7068,'58321','','Nelson',''),(7069,'58321','','Walsh',''),(7070,'58325','','Benson',''),(7071,'58329','','Bottineau',''),(7072,'58332','','Pierce',''),(7073,'58338','','Cavalier',''),(7074,'58341','','Benson',''),(7075,'58341','','Pierce',''),(7076,'58341','','Sheridan',''),(7077,'58344','','Ramsey',''),(7078,'58345','','Walsh',''),(7079,'58346','','Towner',''),(7080,'58348','','Wells',''),(7081,'58351','','Ramsey',''),(7082,'58352','','Towner',''),(7083,'58356','','Foster',''),(7084,'58356','','Wells',''),(7085,'58363','','Rolette',''),(7086,'58367','','Towner',''),(7087,'58368','','Benson',''),(7088,'58368','','Mchenry',''),(7089,'58372','','Towner',''),(7090,'58374','','Benson',''),(7091,'58374','','Wells',''),(7092,'58377','','Cavalier',''),(7093,'58377','','Towner',''),(7094,'58380','','Benson',''),(7095,'58380','','Eddy',''),(7096,'58381','','Eddy',''),(7097,'58384','','Mchenry',''),(7098,'58384','','Pierce',''),(7099,'58384','','Rolette',''),(7100,'58385','','Rolette',''),(7101,'58386','','Pierce',''),(7102,'58413','','Dickey',''),(7103,'58418','','Kidder',''),(7104,'58421','','Eddy',''),(7105,'58421','','Stutsman',''),(7106,'58421','','Wells',''),(7107,'58423','','Kidder',''),(7108,'58429','','Griggs',''),(7109,'58433','','Dickey',''),(7110,'58439','','Dickey',''),(7111,'58440','','Mcintosh',''),(7112,'58442','','Stutsman',''),(7113,'58445','','Eddy',''),(7114,'58454','','Stutsman',''),(7115,'58455','','Foster',''),(7116,'58456','','Dickey',''),(7117,'58456','','Mcintosh',''),(7118,'58458','','Dickey',''),(7119,'58460','','Logan',''),(7120,'58461','','Lamoure',''),(7121,'58464','','Eddy',''),(7122,'58464','','Griggs',''),(7123,'58466','','Barnes',''),(7124,'58466','','Stutsman',''),(7125,'58467','','Kidder',''),(7126,'58472','','Lamoure',''),(7127,'58474','','Sargent',''),(7128,'58475','','Stutsman',''),(7129,'58481','','Stutsman',''),(7130,'58483','','Kidder',''),(7131,'58483','','Logan',''),(7132,'58484','','Foster',''),(7133,'58486','','Stutsman',''),(7134,'58490','','Ransom',''),(7135,'58492','','Griggs',''),(7136,'58492','','Stutsman',''),(7137,'58495','','Logan',''),(7138,'58497','','Barnes',''),(7139,'58520','','Grant',''),(7140,'58523','','Oliver',''),(7141,'58524','','Kidder',''),(7142,'58532','','Kidder',''),(7143,'58535','','Grant',''),(7144,'58545','','Oliver',''),(7145,'58549','','Kidder',''),(7146,'58549','','Logan',''),(7147,'58554','','Oliver',''),(7148,'58559','','Sheridan',''),(7149,'58562','','Adams',''),(7150,'58562','','Hettinger',''),(7151,'58563','','Oliver',''),(7152,'58570','','Sioux',''),(7153,'58571','','Oliver',''),(7154,'58579','','Burleigh',''),(7155,'58601','','Dunn',''),(7156,'58620','','Billings',''),(7157,'58622','','Billings',''),(7158,'58623','','Slope',''),(7159,'58623','','Harding',''),(7160,'58625','','Mercer',''),(7161,'58630','','Dunn',''),(7162,'58631','','Grant',''),(7163,'58631','','Mercer',''),(7164,'58634','','Billings',''),(7165,'58636','','Mercer',''),(7166,'58638','','Dunn',''),(7167,'58638','','Grant',''),(7168,'58638','','Mercer',''),(7169,'58638','','Stark',''),(7170,'58642','','Billings',''),(7171,'58643','','Bowman',''),(7172,'58645','','Golden Valley',''),(7173,'58646','','Adams',''),(7174,'58647','','Slope',''),(7175,'58647','','Stark',''),(7176,'58649','','Bowman',''),(7177,'58649','','Hettinger',''),(7178,'58649','','Harding',''),(7179,'58650','','Adams',''),(7180,'58651','','Slope',''),(7181,'58652','','Dunn',''),(7182,'58653','','Slope',''),(7183,'58653','','Harding',''),(7184,'58654','','Slope',''),(7185,'58656','','Dunn',''),(7186,'58710','','Pierce',''),(7187,'58710','','Sheridan',''),(7188,'58716','','Ward',''),(7189,'58718','','Mountrail',''),(7190,'58718','','Renville',''),(7191,'58721','','Ward',''),(7192,'58723','','Mchenry',''),(7193,'58723','','Sheridan',''),(7194,'58725','','Renville',''),(7195,'58731','','Ward',''),(7196,'58734','','Mountrail',''),(7197,'58734','','Renville',''),(7198,'58735','','Mclean',''),(7199,'58736','','Sheridan',''),(7200,'58740','','Bottineau',''),(7201,'58740','','Ward',''),(7202,'58746','','Burke',''),(7203,'58746','','Renville',''),(7204,'58748','','Mchenry',''),(7205,'58750','','Renville',''),(7206,'58755','','Burke',''),(7207,'58755','','Divide',''),(7208,'58756','','Mountrail',''),(7209,'58757','','Dunn',''),(7210,'58758','','Pierce',''),(7211,'58758','','Wells',''),(7212,'58759','','Ward',''),(7213,'58761','','Bottineau',''),(7214,'58762','','Mchenry',''),(7215,'58763','','Mckenzie',''),(7216,'58763','','Mclean',''),(7217,'58768','','Ward',''),(7218,'58770','','Mclean',''),(7219,'58771','','Mclean',''),(7220,'58771','','Ward',''),(7221,'58773','','Mountrail',''),(7222,'58778','','Mchenry',''),(7223,'58779','','Mclean',''),(7224,'58782','','Bottineau',''),(7225,'58784','','Burke',''),(7226,'58788','','Pierce',''),(7227,'58789','','Bottineau',''),(7228,'58790','','Ward',''),(7229,'58795','','Divide',''),(7230,'58801','','Mckenzie',''),(7231,'58830','','Divide',''),(7232,'58845','','Divide',''),(7233,'58852','','Mountrail',''),(7234,'58854','','Dunn',''),(7235,'58856','','Divide',''),(7236,'59001','','Carbon',''),(7237,'59003','','Powder River',''),(7238,'59010','','Big Horn',''),(7239,'59015','','Musselshell',''),(7240,'59015','','Stillwater',''),(7241,'59019','','Carbon',''),(7242,'59024','','Big Horn',''),(7243,'59032','','Petroleum',''),(7244,'59038','','Big Horn',''),(7245,'59041','','Yellowstone',''),(7246,'59043','','Big Horn',''),(7247,'59044','','Carbon',''),(7248,'59046','','Musselshell',''),(7249,'59052','','Park',''),(7250,'59053','','Wheatland',''),(7251,'59054','','Rosebud',''),(7252,'59057','','Stillwater',''),(7253,'59064','','Big Horn',''),(7254,'59069','','Sweet Grass',''),(7255,'59072','','Petroleum',''),(7256,'59078','','Golden Valley',''),(7257,'59086','','Gallatin',''),(7258,'59086','','Meagher',''),(7259,'59101','','Big Horn',''),(7260,'59201','','Mccone',''),(7261,'59201','','Valley',''),(7262,'59213','','Richland',''),(7263,'59215','','Dawson',''),(7264,'59218','','Richland',''),(7265,'59221','','Mckenzie',''),(7266,'59223','','Mccone',''),(7267,'59255','','Richland',''),(7268,'59258','','Roosevelt',''),(7269,'59259','','Richland',''),(7270,'59260','','Daniels',''),(7271,'59261','','Valley',''),(7272,'59262','','Dawson',''),(7273,'59270','','Mckenzie',''),(7274,'59275','','Divide',''),(7275,'59301','','Garfield',''),(7276,'59301','','Powder River',''),(7277,'59301','','Rosebud',''),(7278,'59326','','Dawson',''),(7279,'59330','','Prairie',''),(7280,'59336','','Fallon',''),(7281,'59347','','Custer',''),(7282,'59349','','Custer',''),(7283,'59351','','Custer',''),(7284,'59404','','Chouteau',''),(7285,'59410','','Teton',''),(7286,'59416','','Chouteau',''),(7287,'59418','','Fergus',''),(7288,'59421','','Lewis And Clark',''),(7289,'59424','','Judith Basin',''),(7290,'59425','','Teton',''),(7291,'59430','','Judith Basin',''),(7292,'59440','','Cascade',''),(7293,'59443','','Teton',''),(7294,'59444','','Toole',''),(7295,'59453','','Fergus',''),(7296,'59453','','Judith Basin',''),(7297,'59456','','Liberty',''),(7298,'59456','','Pondera',''),(7299,'59463','','Judith Basin',''),(7300,'59464','','Judith Basin',''),(7301,'59468','','Cascade',''),(7302,'59487','','Teton',''),(7303,'59521','','Chouteau',''),(7304,'59524','','Blaine',''),(7305,'59531','','Hill',''),(7306,'59601','','Jefferson',''),(7307,'59635','','Broadwater',''),(7308,'59635','','Jefferson',''),(7309,'59701','','Jefferson',''),(7310,'59711','','Granite',''),(7311,'59711','','Silver Bow',''),(7312,'59715','','Park',''),(7313,'59716','','Madison',''),(7314,'59721','','Jefferson',''),(7315,'59722','','Deer Lodge',''),(7316,'59725','','Madison',''),(7317,'59727','','Beaverhead',''),(7318,'59732','','Madison',''),(7319,'59743','','Beaverhead',''),(7320,'59752','','Broadwater',''),(7321,'59752','','Jefferson',''),(7322,'59759','','Madison',''),(7323,'59759','','Silver Bow',''),(7324,'59762','','Deer Lodge',''),(7325,'59820','','Missoula',''),(7326,'59821','','Missoula',''),(7327,'59821','','Sanders',''),(7328,'59825','','Granite',''),(7329,'59833','','Missoula',''),(7330,'59845','','Flathead',''),(7331,'59845','','Lake',''),(7332,'59847','','Idaho',''),(7333,'59868','','Powell',''),(7334,'59911','','Lake',''),(7335,'59922','','Lake',''),(7336,'60007','','Dupage',''),(7337,'60010','','Cook',''),(7338,'60010','','Kane',''),(7339,'60010','','Mchenry',''),(7340,'60013','','Lake',''),(7341,'60015','','Cook',''),(7342,'60021','','Lake',''),(7343,'60033','','Boone',''),(7344,'60042','','Lake',''),(7345,'60050','','Lake',''),(7346,'60051','','Lake',''),(7347,'60074','','Lake',''),(7348,'60081','','Lake',''),(7349,'60089','','Cook',''),(7350,'60102','','Kane',''),(7351,'60103','','Cook',''),(7352,'60120','','Cook',''),(7353,'60126','','Cook',''),(7354,'60129','','Ogle',''),(7355,'60133','','Dupage',''),(7356,'60135','','Boone',''),(7357,'60135','','Mchenry',''),(7358,'60140','','Dekalb',''),(7359,'60142','','Kane',''),(7360,'60145','','Boone',''),(7361,'60146','','Boone',''),(7362,'60146','','Ogle',''),(7363,'60146','','Winnebago',''),(7364,'60151','','Dekalb',''),(7365,'60152','','Dekalb',''),(7366,'60172','','Cook',''),(7367,'60174','','Dupage',''),(7368,'60178','','Kane',''),(7369,'60184','','Kane',''),(7370,'60185','','Kane',''),(7371,'60401','','Kankakee',''),(7372,'60407','','Will',''),(7373,'60410','','Grundy',''),(7374,'60416','','Will',''),(7375,'60420','','Grundy',''),(7376,'60423','','Cook',''),(7377,'60424','','Kankakee',''),(7378,'60431','','Kendall',''),(7379,'60439','','Dupage',''),(7380,'60439','','Will',''),(7381,'60440','','Dupage',''),(7382,'60447','','Kendall',''),(7383,'60447','','Will',''),(7384,'60450','','Kendall',''),(7385,'60466','','Will',''),(7386,'60467','','Will',''),(7387,'60468','','Kankakee',''),(7388,'60470','','Grundy',''),(7389,'60471','','Will',''),(7390,'60475','','Cook',''),(7391,'60477','','Will',''),(7392,'60481','','Grundy',''),(7393,'60481','','Kankakee',''),(7394,'60487','','Will',''),(7395,'60502','','Kane',''),(7396,'60503','','Kendall',''),(7397,'60504','','Kane',''),(7398,'60504','','Kendall',''),(7399,'60510','','Dupage',''),(7400,'60511','','Dekalb',''),(7401,'60518','','Dekalb',''),(7402,'60518','','Lee',''),(7403,'60521','','Cook',''),(7404,'60527','','Cook',''),(7405,'60530','','Dekalb',''),(7406,'60531','','Dekalb',''),(7407,'60537','','Kendall',''),(7408,'60538','','Kane',''),(7409,'60541','','Grundy',''),(7410,'60541','','La Salle',''),(7411,'60543','','Kane',''),(7412,'60543','','Will',''),(7413,'60544','','Kendall',''),(7414,'60548','','Kendall',''),(7415,'60548','','La Salle',''),(7416,'60552','','Dekalb',''),(7417,'60554','','Kendall',''),(7418,'60564','','Dupage',''),(7419,'60565','','Will',''),(7420,'60585','','Kendall',''),(7421,'60586','','Kendall',''),(7422,'60917','','Ford',''),(7423,'60917','','Livingston',''),(7424,'60919','','Kankakee',''),(7425,'60919','','Livingston',''),(7426,'60921','','Ford',''),(7427,'60922','','Iroquois',''),(7428,'60929','','Ford',''),(7429,'60936','','Champaign',''),(7430,'60936','','Mclean',''),(7431,'60940','','Will',''),(7432,'60941','','Iroquois',''),(7433,'60942','','Iroquois',''),(7434,'60946','','Livingston',''),(7435,'60948','','Ford',''),(7436,'60949','','Ford',''),(7437,'60950','','Will',''),(7438,'60952','','Livingston',''),(7439,'60957','','Champaign',''),(7440,'60959','','Livingston',''),(7441,'60960','','Champaign',''),(7442,'60960','','Ford',''),(7443,'60960','','Iroquois',''),(7444,'60961','','Grundy',''),(7445,'60961','','Livingston',''),(7446,'60964','','Iroquois',''),(7447,'60968','','Ford',''),(7448,'61006','','Ogle',''),(7449,'61007','','Stephenson',''),(7450,'61008','','Winnebago',''),(7451,'61011','','Winnebago',''),(7452,'61014','','Whiteside',''),(7453,'61016','','Boone',''),(7454,'61019','','Winnebago',''),(7455,'61020','','Winnebago',''),(7456,'61021','','Ogle',''),(7457,'61031','','Ogle',''),(7458,'61038','','Mchenry',''),(7459,'61039','','Ogle',''),(7460,'61044','','Jo Daviess',''),(7461,'61047','','Stephenson',''),(7462,'61047','','Winnebago',''),(7463,'61048','','Jo Daviess',''),(7464,'61051','','Ogle',''),(7465,'61053','','Jo Daviess',''),(7466,'61062','','Carroll',''),(7467,'61062','','Jo Daviess',''),(7468,'61063','','Stephenson',''),(7469,'61064','','Lee',''),(7470,'61064','','Whiteside',''),(7471,'61068','','Dekalb',''),(7472,'61068','','Lee',''),(7473,'61071','','Lee',''),(7474,'61073','','Boone',''),(7475,'61074','','Jo Daviess',''),(7476,'61078','','Ogle',''),(7477,'61078','','Stephenson',''),(7478,'61080','','Boone',''),(7479,'61081','','Lee',''),(7480,'61084','','Winnebago',''),(7481,'61087','','Stephenson',''),(7482,'61102','','Ogle',''),(7483,'61107','','Boone',''),(7484,'61109','','Ogle',''),(7485,'61111','','Boone',''),(7486,'61114','','Boone',''),(7487,'61240','','Henry',''),(7488,'61250','','Henry',''),(7489,'61252','','Carroll',''),(7490,'61260','','Rock Island',''),(7491,'61262','','Mercer',''),(7492,'61264','','Mercer',''),(7493,'61272','','Rock Island',''),(7494,'61273','','Rock Island',''),(7495,'61277','','Henry',''),(7496,'61279','','Mercer',''),(7497,'61281','','Rock Island',''),(7498,'61283','','Bureau',''),(7499,'61330','','Lee',''),(7500,'61334','','Putnam',''),(7501,'61336','','Marshall',''),(7502,'61342','','Bureau',''),(7503,'61342','','Lee',''),(7504,'61344','','Henry',''),(7505,'61345','','Stark',''),(7506,'61349','','Lee',''),(7507,'61354','','Bureau',''),(7508,'61354','','Putnam',''),(7509,'61358','','Marshall',''),(7510,'61360','','Grundy',''),(7511,'61361','','Henry',''),(7512,'61364','','Livingston',''),(7513,'61376','','Lee',''),(7514,'61377','','La Salle',''),(7515,'61401','','Warren',''),(7516,'61410','','Warren',''),(7517,'61412','','Mercer',''),(7518,'61414','','Henry',''),(7519,'61415','','Warren',''),(7520,'61420','','Hancock',''),(7521,'61420','','Henderson',''),(7522,'61421','','Bureau',''),(7523,'61421','','Marshall',''),(7524,'61434','','Knox',''),(7525,'61434','','Stark',''),(7526,'61440','','Schuyler',''),(7527,'61442','','Henderson',''),(7528,'61443','','Bureau',''),(7529,'61443','','Stark',''),(7530,'61447','','Henderson',''),(7531,'61449','','Knox',''),(7532,'61450','','Henderson',''),(7533,'61450','','Mcdonough',''),(7534,'61451','','Stark',''),(7535,'61453','','Henderson',''),(7536,'61459','','Mcdonough',''),(7537,'61462','','Henderson',''),(7538,'61465','','Henry',''),(7539,'61474','','Warren',''),(7540,'61475','','Warren',''),(7541,'61476','','Henderson',''),(7542,'61478','','Henderson',''),(7543,'61479','','Marshall',''),(7544,'61482','','Mcdonough',''),(7545,'61484','','Mcdonough',''),(7546,'61484','','Schuyler',''),(7547,'61489','','Peoria',''),(7548,'61490','','Knox',''),(7549,'61491','','Marshall',''),(7550,'61523','','Marshall',''),(7551,'61526','','Marshall',''),(7552,'61529','','Knox',''),(7553,'61530','','Tazewell',''),(7554,'61531','','Knox',''),(7555,'61531','','Peoria',''),(7556,'61533','','Fulton',''),(7557,'61537','','Bureau',''),(7558,'61544','','Knox',''),(7559,'61546','','Tazewell',''),(7560,'61559','','Stark',''),(7561,'61560','','Bureau',''),(7562,'61565','','Peoria',''),(7563,'61569','','Fulton',''),(7564,'61570','','Marshall',''),(7565,'61611','','Woodford',''),(7566,'61721','','Logan',''),(7567,'61723','','Mclean',''),(7568,'61725','','Woodford',''),(7569,'61726','','Livingston',''),(7570,'61729','','Mclean',''),(7571,'61731','','Ford',''),(7572,'61731','','Livingston',''),(7573,'61732','','Tazewell',''),(7574,'61733','','Woodford',''),(7575,'61738','','Mclean',''),(7576,'61739','','Mclean',''),(7577,'61742','','Tazewell',''),(7578,'61744','','Livingston',''),(7579,'61744','','Woodford',''),(7580,'61745','','De Witt',''),(7581,'61748','','Woodford',''),(7582,'61749','','Logan',''),(7583,'61749','','Macon',''),(7584,'61752','','De Witt',''),(7585,'61754','','De Witt',''),(7586,'61754','','Logan',''),(7587,'61756','','De Witt',''),(7588,'61760','','Marshall',''),(7589,'61810','','Champaign',''),(7590,'61810','','Edgar',''),(7591,'61818','','Macon',''),(7592,'61830','','Macon',''),(7593,'61842','','Mclean',''),(7594,'61842','','Piatt',''),(7595,'61843','','Mclean',''),(7596,'61845','','Ford',''),(7597,'61849','','Vermilion',''),(7598,'61851','','Piatt',''),(7599,'61852','','Douglas',''),(7600,'61853','','Piatt',''),(7601,'61859','','Vermilion',''),(7602,'61862','','Vermilion',''),(7603,'61870','','Edgar',''),(7604,'61872','','Douglas',''),(7605,'61876','','Edgar',''),(7606,'61882','','Macon',''),(7607,'61884','','Champaign',''),(7608,'61910','','Coles',''),(7609,'61911','','Coles',''),(7610,'61911','','Moultrie',''),(7611,'61913','','Piatt',''),(7612,'61914','','Shelby',''),(7613,'61917','','Douglas',''),(7614,'61925','','Macon',''),(7615,'61928','','Coles',''),(7616,'61928','','Shelby',''),(7617,'61930','','Coles',''),(7618,'61933','','Clark',''),(7619,'61933','','Coles',''),(7620,'61937','','Macon',''),(7621,'61942','','Edgar',''),(7622,'61943','','Douglas',''),(7623,'61943','','Edgar',''),(7624,'61944','','Clark',''),(7625,'61951','','Coles',''),(7626,'61956','','Champaign',''),(7627,'61957','','Moultrie',''),(7628,'62002','','Macoupin',''),(7629,'62012','','Jersey',''),(7630,'62012','','Madison',''),(7631,'62019','','Bond',''),(7632,'62032','','Fayette',''),(7633,'62035','','Jersey',''),(7634,'62044','','Macoupin',''),(7635,'62054','','Jersey',''),(7636,'62056','','Macoupin',''),(7637,'62060','','St. Clair',''),(7638,'62063','','Jersey',''),(7639,'62069','','Montgomery',''),(7640,'62074','','Bond',''),(7641,'62074','','Macoupin',''),(7642,'62074','','Montgomery',''),(7643,'62075','','Christian',''),(7644,'62075','','Fayette',''),(7645,'62077','','Bond',''),(7646,'62079','','Jersey',''),(7647,'62080','','Montgomery',''),(7648,'62082','','Scott',''),(7649,'62083','','Montgomery',''),(7650,'62086','','Montgomery',''),(7651,'62088','','Madison',''),(7652,'62201','','Madison',''),(7653,'62234','','St. Clair',''),(7654,'62236','','St. Clair',''),(7655,'62237','','Perry',''),(7656,'62237','','Washington',''),(7657,'62249','','Clinton',''),(7658,'62253','','Clinton',''),(7659,'62253','','Fayette',''),(7660,'62257','','Randolph',''),(7661,'62257','','Washington',''),(7662,'62262','','Fayette',''),(7663,'62263','','Perry',''),(7664,'62264','','Monroe',''),(7665,'62265','','St. Clair',''),(7666,'62268','','Perry',''),(7667,'62272','','Perry',''),(7668,'62275','','Clinton',''),(7669,'62275','','Madison',''),(7670,'62277','','Monroe',''),(7671,'62278','','Monroe',''),(7672,'62280','','Jackson',''),(7673,'62293','','Madison',''),(7674,'62293','','St. Clair',''),(7675,'62294','','St. Clair',''),(7676,'62298','','St. Clair',''),(7677,'62311','','Adams',''),(7678,'62311','','Schuyler',''),(7679,'62312','','Adams',''),(7680,'62314','','Adams',''),(7681,'62316','','Adams',''),(7682,'62323','','Brown',''),(7683,'62324','','Brown',''),(7684,'62326','','Hancock',''),(7685,'62330','','Henderson',''),(7686,'62343','','Adams',''),(7687,'62346','','Schuyler',''),(7688,'62349','','Hancock',''),(7689,'62351','','Hancock',''),(7690,'62353','','Schuyler',''),(7691,'62355','','Calhoun',''),(7692,'62366','','Calhoun',''),(7693,'62367','','Mcdonough',''),(7694,'62367','','Schuyler',''),(7695,'62374','','Hancock',''),(7696,'62379','','Adams',''),(7697,'62401','','Shelby',''),(7698,'62411','','Fayette',''),(7699,'62413','','Clark',''),(7700,'62414','','Effingham',''),(7701,'62414','','Shelby',''),(7702,'62420','','Coles',''),(7703,'62420','','Cumberland',''),(7704,'62420','','Jasper',''),(7705,'62421','','Crawford',''),(7706,'62422','','Fayette',''),(7707,'62423','','Edgar',''),(7708,'62424','','Jasper',''),(7709,'62425','','Jasper',''),(7710,'62426','','Clay',''),(7711,'62426','','Fayette',''),(7712,'62427','','Lawrence',''),(7713,'62431','','Fayette',''),(7714,'62434','','Jasper',''),(7715,'62436','','Jasper',''),(7716,'62440','','Cumberland',''),(7717,'62441','','Edgar',''),(7718,'62442','','Crawford',''),(7719,'62443','','Clay',''),(7720,'62445','','Effingham',''),(7721,'62445','','Jasper',''),(7722,'62447','','Coles',''),(7723,'62447','','Shelby',''),(7724,'62448','','Clay',''),(7725,'62448','','Richland',''),(7726,'62449','','Clark',''),(7727,'62449','','Jasper',''),(7728,'62450','','Wayne',''),(7729,'62458','','Effingham',''),(7730,'62460','','Wabash',''),(7731,'62461','','Shelby',''),(7732,'62462','','Cumberland',''),(7733,'62466','','Crawford',''),(7734,'62466','','Richland',''),(7735,'62467','','Cumberland',''),(7736,'62467','','Jasper',''),(7737,'62469','','Coles',''),(7738,'62474','','Coles',''),(7739,'62476','','Wabash',''),(7740,'62478','','Clark',''),(7741,'62481','','Cumberland',''),(7742,'62510','','Shelby',''),(7743,'62512','','De Witt',''),(7744,'62513','','Christian',''),(7745,'62534','','Moultrie',''),(7746,'62538','','Christian',''),(7747,'62539','','Macon',''),(7748,'62543','','Macon',''),(7749,'62545','','Christian',''),(7750,'62546','','Montgomery',''),(7751,'62547','','Macon',''),(7752,'62548','','Sangamon',''),(7753,'62550','','Christian',''),(7754,'62550','','Macon',''),(7755,'62553','','Montgomery',''),(7756,'62557','','Montgomery',''),(7757,'62557','','Shelby',''),(7758,'62558','','Christian',''),(7759,'62558','','Montgomery',''),(7760,'62560','','Macoupin',''),(7761,'62563','','Christian',''),(7762,'62572','','Macoupin',''),(7763,'62611','','Morgan',''),(7764,'62612','','Morgan',''),(7765,'62613','','Logan',''),(7766,'62613','','Sangamon',''),(7767,'62621','','Morgan',''),(7768,'62627','','Mason',''),(7769,'62628','','Scott',''),(7770,'62630','','Greene',''),(7771,'62635','','Tazewell',''),(7772,'62638','','Macoupin',''),(7773,'62640','','Montgomery',''),(7774,'62644','','Fulton',''),(7775,'62650','','Scott',''),(7776,'62665','','Scott',''),(7777,'62666','','Menard',''),(7778,'62667','','Morgan',''),(7779,'62668','','Scott',''),(7780,'62670','','Morgan',''),(7781,'62671','','Mason',''),(7782,'62673','','Cass',''),(7783,'62677','','Menard',''),(7784,'62682','','Logan',''),(7785,'62682','','Tazewell',''),(7786,'62690','','Montgomery',''),(7787,'62690','','Sangamon',''),(7788,'62692','','Sangamon',''),(7789,'62693','','Logan',''),(7790,'62694','','Morgan',''),(7791,'62801','','Clinton',''),(7792,'62801','','Jefferson',''),(7793,'62801','','Washington',''),(7794,'62808','','Jefferson',''),(7795,'62810','','Hamilton',''),(7796,'62810','','Wayne',''),(7797,'62814','','Wayne',''),(7798,'62818','','Wabash',''),(7799,'62820','','Wayne',''),(7800,'62824','','Wayne',''),(7801,'62830','','Marion',''),(7802,'62831','','Perry',''),(7803,'62832','','Jackson',''),(7804,'62833','','Edwards',''),(7805,'62835','','Hamilton',''),(7806,'62838','','Clay',''),(7807,'62838','','Effingham',''),(7808,'62838','','Marion',''),(7809,'62844','','Edwards',''),(7810,'62851','','Jefferson',''),(7811,'62851','','Marion',''),(7812,'62854','','Clay',''),(7813,'62858','','Effingham',''),(7814,'62860','','Hamilton',''),(7815,'62867','','White',''),(7816,'62868','','Clay',''),(7817,'62868','','Wayne',''),(7818,'62869','','Gallatin',''),(7819,'62869','','Hamilton',''),(7820,'62869','','Saline',''),(7821,'62875','','Clinton',''),(7822,'62875','','Fayette',''),(7823,'62877','','Jefferson',''),(7824,'62882','','Clinton',''),(7825,'62883','','Franklin',''),(7826,'62883','','Perry',''),(7827,'62887','','Hamilton',''),(7828,'62889','','Marion',''),(7829,'62890','','Hamilton',''),(7830,'62890','','Saline',''),(7831,'62890','','Williamson',''),(7832,'62892','','Fayette',''),(7833,'62893','','Jefferson',''),(7834,'62895','','Hamilton',''),(7835,'62896','','Williamson',''),(7836,'62899','','Wayne',''),(7837,'62901','','Williamson',''),(7838,'62902','','Union',''),(7839,'62902','','Williamson',''),(7840,'62905','','Jackson',''),(7841,'62907','','Randolph',''),(7842,'62908','','Johnson',''),(7843,'62910','','Pope',''),(7844,'62912','','Union',''),(7845,'62916','','Perry',''),(7846,'62916','','Randolph',''),(7847,'62917','','Williamson',''),(7848,'62922','','Johnson',''),(7849,'62923','','Pulaski',''),(7850,'62923','','Union',''),(7851,'62924','','Williamson',''),(7852,'62926','','Pulaski',''),(7853,'62930','','Gallatin',''),(7854,'62931','','Gallatin',''),(7855,'62934','','Saline',''),(7856,'62935','','Hamilton',''),(7857,'62938','','Hardin',''),(7858,'62939','','Union',''),(7859,'62939','','Williamson',''),(7860,'62941','','Massac',''),(7861,'62943','','Massac',''),(7862,'62943','','Pope',''),(7863,'62946','','Pope',''),(7864,'62947','','Pope',''),(7865,'62947','','Saline',''),(7866,'62952','','Alexander',''),(7867,'62956','','Massac',''),(7868,'62957','','Union',''),(7869,'62958','','Union',''),(7870,'62958','','Williamson',''),(7871,'62960','','Pope',''),(7872,'62972','','Pope',''),(7873,'62985','','Pope',''),(7874,'62987','','Pope',''),(7875,'62987','','Williamson',''),(7876,'62992','','Alexander',''),(7877,'63014','','Gasconade',''),(7878,'63015','','Jefferson',''),(7879,'63020','','Washington',''),(7880,'63025','','Jefferson',''),(7881,'63026','','Jefferson',''),(7882,'63028','','Ste. Genevieve',''),(7883,'63036','','Ste. Genevieve',''),(7884,'63041','','Jefferson',''),(7885,'63045','','St. Louis',''),(7886,'63049','','St. Louis',''),(7887,'63068','','Gasconade',''),(7888,'63069','','Jefferson',''),(7889,'63069','','St. Louis',''),(7890,'63072','','Jefferson',''),(7891,'63080','','Crawford',''),(7892,'63080','','Washington',''),(7893,'63087','','Jefferson',''),(7894,'63091','','Franklin',''),(7895,'63105','','St. Louis City',''),(7896,'63117','','St. Louis City',''),(7897,'63119','','St. Louis City',''),(7898,'63120','','St. Louis',''),(7899,'63123','','St. Louis City',''),(7900,'63125','','St. Louis City',''),(7901,'63130','','St. Louis City',''),(7902,'63133','','St. Louis City',''),(7903,'63136','','St. Louis City',''),(7904,'63137','','St. Louis City',''),(7905,'63143','','St. Louis City',''),(7906,'63155','','St. Louis City',''),(7907,'63333','','Lincoln',''),(7908,'63334','','Lincoln',''),(7909,'63343','','Pike',''),(7910,'63344','','Lincoln',''),(7911,'63348','','Lincoln',''),(7912,'63348','','Warren',''),(7913,'63349','','Warren',''),(7914,'63351','','Warren',''),(7915,'63352','','Ralls',''),(7916,'63357','','St. Charles',''),(7917,'63359','','Audrain',''),(7918,'63359','','Lincoln',''),(7919,'63359','','Pike',''),(7920,'63361','','Callaway',''),(7921,'63363','','Warren',''),(7922,'63381','','Lincoln',''),(7923,'63381','','Montgomery',''),(7924,'63382','','Pike',''),(7925,'63382','','Ralls',''),(7926,'63383','','Lincoln',''),(7927,'63384','','Audrain',''),(7928,'63384','','Callaway',''),(7929,'63390','','Lincoln',''),(7930,'63401','','Ralls',''),(7931,'63432','','Clark',''),(7932,'63435','','Clark',''),(7933,'63437','','Macon',''),(7934,'63437','','Monroe',''),(7935,'63438','','Marion',''),(7936,'63439','','Marion',''),(7937,'63440','','Marion',''),(7938,'63440','','Shelby',''),(7939,'63441','','Ralls',''),(7940,'63443','','Marion',''),(7941,'63443','','Monroe',''),(7942,'63446','','Lewis',''),(7943,'63450','','Monroe',''),(7944,'63454','','Lewis',''),(7945,'63456','','Marion',''),(7946,'63456','','Ralls',''),(7947,'63459','','Pike',''),(7948,'63462','','Monroe',''),(7949,'63468','','Monroe',''),(7950,'63469','','Knox',''),(7951,'63471','','Lewis',''),(7952,'63473','','Clark',''),(7953,'63474','','Scotland',''),(7954,'63531','','Scotland',''),(7955,'63533','','Knox',''),(7956,'63535','','Putnam',''),(7957,'63536','','Scotland',''),(7958,'63544','','Adair',''),(7959,'63544','','Putnam',''),(7960,'63546','','Schuyler',''),(7961,'63547','','Adair',''),(7962,'63549','','Adair',''),(7963,'63557','','Adair',''),(7964,'63557','','Macon',''),(7965,'63558','','Chariton',''),(7966,'63559','','Putnam',''),(7967,'63560','','Putnam',''),(7968,'63563','','Knox',''),(7969,'63566','','Linn',''),(7970,'63620','','Madison',''),(7971,'63620','','Reynolds',''),(7972,'63621','','Madison',''),(7973,'63624','','Iron',''),(7974,'63624','','Washington',''),(7975,'63625','','Iron',''),(7976,'63626','','St. Francois',''),(7977,'63627','','Jefferson',''),(7978,'63628','','Jefferson',''),(7979,'63628','','Ste. Genevieve',''),(7980,'63628','','Washington',''),(7981,'63629','','Dent',''),(7982,'63629','','Shannon',''),(7983,'63630','','St. Francois',''),(7984,'63631','','Iron',''),(7985,'63636','','Madison',''),(7986,'63636','','Wayne',''),(7987,'63638','','Shannon',''),(7988,'63640','','Ste. Genevieve',''),(7989,'63645','','Ste. Genevieve',''),(7990,'63645','','St. Francois',''),(7991,'63648','','St. Francois',''),(7992,'63650','','Madison',''),(7993,'63650','','St. Francois',''),(7994,'63654','','Iron',''),(7995,'63655','','Bollinger',''),(7996,'63655','','Wayne',''),(7997,'63656','','Reynolds',''),(7998,'63673','','Randolph',''),(7999,'63673','','Perry',''),(8000,'63730','','Bollinger',''),(8001,'63730','','Cape Girardeau',''),(8002,'63732','','Cape Girardeau',''),(8003,'63735','','Scott',''),(8004,'63740','','Cape Girardeau',''),(8005,'63764','','Cape Girardeau',''),(8006,'63766','','Bollinger',''),(8007,'63770','','Perry',''),(8008,'63771','','Cape Girardeau',''),(8009,'63771','','Stoddard',''),(8010,'63775','','Cape Girardeau',''),(8011,'63780','','Cape Girardeau',''),(8012,'63785','','Bollinger',''),(8013,'63801','','New Madrid',''),(8014,'63801','','Stoddard',''),(8015,'63823','','Scott',''),(8016,'63833','','Stoddard',''),(8017,'63834','','Scott',''),(8018,'63845','','New Madrid',''),(8019,'63848','','Pemiscot',''),(8020,'63849','','Pemiscot',''),(8021,'63852','','Pemiscot',''),(8022,'63863','','New Madrid',''),(8023,'63870','','Stoddard',''),(8024,'63873','','Pemiscot',''),(8025,'63877','','Dunklin',''),(8026,'63901','','Ripley',''),(8027,'63935','','Carter',''),(8028,'63935','','Oregon',''),(8029,'63937','','Butler',''),(8030,'63937','','Wayne',''),(8031,'63941','','Oregon',''),(8032,'63942','','Oregon',''),(8033,'63943','','Ripley',''),(8034,'63953','','Butler',''),(8035,'63954','','Ripley',''),(8036,'63957','','Reynolds',''),(8037,'63960','','Bollinger',''),(8038,'63965','','Reynolds',''),(8039,'63966','','Butler',''),(8040,'63967','','Butler',''),(8041,'64011','','Johnson',''),(8042,'64017','','Lafayette',''),(8043,'64020','','Johnson',''),(8044,'64020','','Saline',''),(8045,'64024','','Ray',''),(8046,'64034','','Cass',''),(8047,'64035','','Carroll',''),(8048,'64048','','Clinton',''),(8049,'64061','','Cass',''),(8050,'64062','','Clay',''),(8051,'64062','','Clinton',''),(8052,'64070','','Johnson',''),(8053,'64075','','Lafayette',''),(8054,'64076','','Johnson',''),(8055,'64077','','Clay',''),(8056,'64080','','Jackson',''),(8057,'64082','','Cass',''),(8058,'64089','','Platte',''),(8059,'64093','','Lafayette',''),(8060,'64118','','Platte',''),(8061,'64147','','Cass',''),(8062,'64427','','Nodaway',''),(8063,'64428','','Atchison',''),(8064,'64429','','Caldwell',''),(8065,'64429','','Daviess',''),(8066,'64429','','Dekalb',''),(8067,'64430','','Andrew',''),(8068,'64439','','Buchanan',''),(8069,'64440','','Platte',''),(8070,'64441','','Gentry',''),(8071,'64444','','Buchanan',''),(8072,'64446','','Holt',''),(8073,'64454','','Buchanan',''),(8074,'64455','','Andrew',''),(8075,'64456','','Harrison',''),(8076,'64457','','Andrew',''),(8077,'64463','','Andrew',''),(8078,'64463','','Dekalb',''),(8079,'64465','','Caldwell',''),(8080,'64471','','Gentry',''),(8081,'64474','','Clinton',''),(8082,'64475','','Worth',''),(8083,'64479','','Gentry',''),(8084,'64484','','Platte',''),(8085,'64486','','Nodaway',''),(8086,'64487','','Atchison',''),(8087,'64487','','Holt',''),(8088,'64489','','Nodaway',''),(8089,'64490','','Buchanan',''),(8090,'64490','','Clinton',''),(8091,'64492','','Clay',''),(8092,'64494','','Andrew',''),(8093,'64497','','Daviess',''),(8094,'64499','','Gentry',''),(8095,'64505','','Andrew',''),(8096,'64506','','Andrew',''),(8097,'64624','','Carroll',''),(8098,'64624','','Livingston',''),(8099,'64624','','Ray',''),(8100,'64625','','Daviess',''),(8101,'64625','','Livingston',''),(8102,'64628','','Chariton',''),(8103,'64630','','Sullivan',''),(8104,'64631','','Macon',''),(8105,'64632','','Mercer',''),(8106,'64635','','Grundy',''),(8107,'64635','','Linn',''),(8108,'64636','','Harrison',''),(8109,'64637','','Ray',''),(8110,'64638','','Carroll',''),(8111,'64641','','Sullivan',''),(8112,'64642','','Daviess',''),(8113,'64642','','Grundy',''),(8114,'64643','','Livingston',''),(8115,'64644','','Daviess',''),(8116,'64645','','Mercer',''),(8117,'64646','','Linn',''),(8118,'64648','','Grundy',''),(8119,'64648','','Livingston',''),(8120,'64649','','Daviess',''),(8121,'64657','','Daviess',''),(8122,'64657','','Harrison',''),(8123,'64658','','Chariton',''),(8124,'64667','','Mercer',''),(8125,'64667','','Putnam',''),(8126,'64668','','Ray',''),(8127,'64670','','Dekalb',''),(8128,'64670','','Gentry',''),(8129,'64670','','Harrison',''),(8130,'64671','','Ray',''),(8131,'64679','','Mercer',''),(8132,'64683','','Livingston',''),(8133,'64688','','Linn',''),(8134,'64724','','Bates',''),(8135,'64725','','Bates',''),(8136,'64726','','Johnson',''),(8137,'64733','','Henry',''),(8138,'64735','','Benton',''),(8139,'64739','','Henry',''),(8140,'64740','','St. Clair',''),(8141,'64742','','Bates',''),(8142,'64744','','St. Clair',''),(8143,'64744','','Vernon',''),(8144,'64747','','Johnson',''),(8145,'64748','','Dade',''),(8146,'64748','','Jasper',''),(8147,'64748','','Lawrence',''),(8148,'64752','','Vernon',''),(8149,'64755','','Barton',''),(8150,'64756','','Dade',''),(8151,'64759','','Dade',''),(8152,'64761','','Henry',''),(8153,'64770','','Bates',''),(8154,'64770','','St. Clair',''),(8155,'64776','','Benton',''),(8156,'64779','','Vernon',''),(8157,'64780','','St. Clair',''),(8158,'64783','','St. Clair',''),(8159,'64784','','Barton',''),(8160,'64784','','Cedar',''),(8161,'64788','','Bates',''),(8162,'64804','','Newton',''),(8163,'64832','','Barton',''),(8164,'64840','','Jasper',''),(8165,'64842','','Barry',''),(8166,'64843','','Newton',''),(8167,'64848','','Jasper',''),(8168,'64850','','Mcdonald',''),(8169,'64855','','Barton',''),(8170,'64861','','Newton',''),(8171,'64862','','Lawrence',''),(8172,'64862','','Newton',''),(8173,'64865','','Mcdonald',''),(8174,'64867','','Newton',''),(8175,'64873','','Newton',''),(8176,'65001','','Maries',''),(8177,'65011','','Moniteau',''),(8178,'65013','','Osage',''),(8179,'65014','','Maries',''),(8180,'65014','','Osage',''),(8181,'65017','','Camden',''),(8182,'65018','','Cooper',''),(8183,'65023','','Moniteau',''),(8184,'65025','','Cooper',''),(8185,'65026','','Morgan',''),(8186,'65032','','Cole',''),(8187,'65034','','Moniteau',''),(8188,'65037','','Camden',''),(8189,'65039','','Callaway',''),(8190,'65040','','Miller',''),(8191,'65041','','Montgomery',''),(8192,'65041','','Warren',''),(8193,'65047','','Camden',''),(8194,'65049','','Miller',''),(8195,'65051','','Gasconade',''),(8196,'65058','','Cole',''),(8197,'65058','','Miller',''),(8198,'65058','','Osage',''),(8199,'65061','','Osage',''),(8200,'65062','','Osage',''),(8201,'65065','','Miller',''),(8202,'65066','','Crawford',''),(8203,'65069','','Callaway',''),(8204,'65072','','Miller',''),(8205,'65074','','Moniteau',''),(8206,'65076','','Osage',''),(8207,'65078','','Benton',''),(8208,'65079','','Miller',''),(8209,'65079','','Morgan',''),(8210,'65081','','Cooper',''),(8211,'65081','','Morgan',''),(8212,'65084','','Moniteau',''),(8213,'65101','','Callaway',''),(8214,'65101','','Osage',''),(8215,'65201','','Callaway',''),(8216,'65202','','Callaway',''),(8217,'65230','','Randolph',''),(8218,'65240','','Audrain',''),(8219,'65240','','Callaway',''),(8220,'65240','','Monroe',''),(8221,'65243','','Audrain',''),(8222,'65243','','Boone',''),(8223,'65243','','Howard',''),(8224,'65243','','Monroe',''),(8225,'65254','','Chariton',''),(8226,'65256','','Howard',''),(8227,'65257','','Howard',''),(8228,'65260','','Macon',''),(8229,'65260','','Monroe',''),(8230,'65263','','Randolph',''),(8231,'65264','','Callaway',''),(8232,'65265','','Monroe',''),(8233,'65270','','Monroe',''),(8234,'65279','','Howard',''),(8235,'65284','','Audrain',''),(8236,'65287','','Moniteau',''),(8237,'65321','','Lafayette',''),(8238,'65326','','Camden',''),(8239,'65327','','Lafayette',''),(8240,'65332','','Johnson',''),(8241,'65333','','Saline',''),(8242,'65335','','Pettis',''),(8243,'65336','','Pettis',''),(8244,'65340','','Pettis',''),(8245,'65345','','Benton',''),(8246,'65345','','Morgan',''),(8247,'65347','','Cooper',''),(8248,'65347','','Pettis',''),(8249,'65348','','Morgan',''),(8250,'65350','','Morgan',''),(8251,'65351','','Johnson',''),(8252,'65351','','Pettis',''),(8253,'65354','','Cooper',''),(8254,'65355','','Hickory',''),(8255,'65360','','Benton',''),(8256,'65360','','Johnson',''),(8257,'65360','','Pettis',''),(8258,'65401','','Dent',''),(8259,'65401','','Maries',''),(8260,'65438','','Oregon',''),(8261,'65440','','Reynolds',''),(8262,'65441','','Franklin',''),(8263,'65441','','Washington',''),(8264,'65449','','Phelps',''),(8265,'65452','','Miller',''),(8266,'65453','','Gasconade',''),(8267,'65459','','Maries',''),(8268,'65459','','Miller',''),(8269,'65459','','Phelps',''),(8270,'65461','','Pulaski',''),(8271,'65462','','Dent',''),(8272,'65463','','Camden',''),(8273,'65463','','Dallas',''),(8274,'65470','','Wright',''),(8275,'65479','','Shannon',''),(8276,'65534','','Laclede',''),(8277,'65536','','Camden',''),(8278,'65536','','Dallas',''),(8279,'65542','','Dent',''),(8280,'65543','','Wright',''),(8281,'65548','','Shannon',''),(8282,'65548','','Texas',''),(8283,'65550','','Pulaski',''),(8284,'65552','','Laclede',''),(8285,'65552','','Pulaski',''),(8286,'65556','','Camden',''),(8287,'65556','','Laclede',''),(8288,'65559','','Crawford',''),(8289,'65559','','Gasconade',''),(8290,'65559','','Maries',''),(8291,'65560','','Crawford',''),(8292,'65560','','Phelps',''),(8293,'65560','','Shannon',''),(8294,'65565','','Iron',''),(8295,'65565','','Washington',''),(8296,'65567','','Laclede',''),(8297,'65571','','Shannon',''),(8298,'65588','','Oregon',''),(8299,'65601','','Cedar',''),(8300,'65601','','Dade',''),(8301,'65604','','Dade',''),(8302,'65604','','Lawrence',''),(8303,'65605','','Barry',''),(8304,'65608','','Ozark',''),(8305,'65608','','Taney',''),(8306,'65609','','Howell',''),(8307,'65610','','Greene',''),(8308,'65610','','Lawrence',''),(8309,'65610','','Stone',''),(8310,'65611','','Taney',''),(8311,'65612','','Lawrence',''),(8312,'65614','','Christian',''),(8313,'65616','','Stone',''),(8314,'65617','','Greene',''),(8315,'65619','','Christian',''),(8316,'65622','','Polk',''),(8317,'65624','','Barry',''),(8318,'65626','','Howell',''),(8319,'65631','','Stone',''),(8320,'65632','','Dallas',''),(8321,'65632','','Webster',''),(8322,'65633','','Barry',''),(8323,'65634','','Benton',''),(8324,'65634','','Camden',''),(8325,'65635','','Cedar',''),(8326,'65637','','Douglas',''),(8327,'65637','','Howell',''),(8328,'65638','','Ozark',''),(8329,'65640','','Cedar',''),(8330,'65644','','Webster',''),(8331,'65646','','Lawrence',''),(8332,'65647','','Mcdonald',''),(8333,'65648','','Dallas',''),(8334,'65648','','Polk',''),(8335,'65648','','Webster',''),(8336,'65649','','Cedar',''),(8337,'65650','','Polk',''),(8338,'65652','','Christian',''),(8339,'65652','','Douglas',''),(8340,'65653','','Christian',''),(8341,'65656','','Barry',''),(8342,'65656','','Christian',''),(8343,'65660','','Texas',''),(8344,'65662','','Laclede',''),(8345,'65669','','Stone',''),(8346,'65674','','Cedar',''),(8347,'65674','','Hickory',''),(8348,'65674','','St. Clair',''),(8349,'65682','','Lawrence',''),(8350,'65685','','Polk',''),(8351,'65689','','Douglas',''),(8352,'65689','','Howell',''),(8353,'65692','','Howell',''),(8354,'65702','','Douglas',''),(8355,'65704','','Douglas',''),(8356,'65705','','Stone',''),(8357,'65708','','Lawrence',''),(8358,'65711','','Douglas',''),(8359,'65711','','Texas',''),(8360,'65713','','Wright',''),(8361,'65714','','Stone',''),(8362,'65717','','Douglas',''),(8363,'65720','','Douglas',''),(8364,'65721','','Greene',''),(8365,'65722','','Dallas',''),(8366,'65723','','Barry',''),(8367,'65723','','Newton',''),(8368,'65725','','Greene',''),(8369,'65729','','Marion',''),(8370,'65733','','Boone',''),(8371,'65733','','Marion',''),(8372,'65733','','Ozark',''),(8373,'65735','','Benton',''),(8374,'65737','','Christian',''),(8375,'65737','','Taney',''),(8376,'65738','','Christian',''),(8377,'65738','','Lawrence',''),(8378,'65742','','Christian',''),(8379,'65742','','Greene',''),(8380,'65745','','Mcdonald',''),(8381,'65746','','Douglas',''),(8382,'65746','','Wright',''),(8383,'65747','','Stone',''),(8384,'65752','','Lawrence',''),(8385,'65755','','Ozark',''),(8386,'65757','','Webster',''),(8387,'65761','','Marion',''),(8388,'65761','','Taney',''),(8389,'65767','','Hickory',''),(8390,'65767','','Polk',''),(8391,'65769','','Barry',''),(8392,'65770','','Dade',''),(8393,'65770','','Polk',''),(8394,'65772','','Mcdonald',''),(8395,'65774','','St. Clair',''),(8396,'65775','','Douglas',''),(8397,'65775','','Oregon',''),(8398,'65779','','Benton',''),(8399,'65781','','Polk',''),(8400,'65785','','Dade',''),(8401,'65785','','St. Clair',''),(8402,'65786','','Dallas',''),(8403,'65788','','Oregon',''),(8404,'65790','','Ozark',''),(8405,'65793','','Douglas',''),(8406,'65793','','Texas',''),(8407,'66002','','Doniphan',''),(8408,'66002','','Jefferson',''),(8409,'66002','','Leavenworth',''),(8410,'66006','','Franklin',''),(8411,'66010','','Bourbon',''),(8412,'66012','','Leavenworth',''),(8413,'66013','','Johnson',''),(8414,'66014','','Anderson',''),(8415,'66015','','Allen',''),(8416,'66021','','Douglas',''),(8417,'66021','','Miami',''),(8418,'66025','','Johnson',''),(8419,'66026','','Linn',''),(8420,'66033','','Franklin',''),(8421,'66033','','Linn',''),(8422,'66039','','Allen',''),(8423,'66040','','Miami',''),(8424,'66041','','Doniphan',''),(8425,'66042','','Miami',''),(8426,'66044','','Jefferson',''),(8427,'66044','','Leavenworth',''),(8428,'66050','','Shawnee',''),(8429,'66054','','Leavenworth',''),(8430,'66060','','Atchison',''),(8431,'66064','','Franklin',''),(8432,'66072','','Miami',''),(8433,'66080','','Anderson',''),(8434,'66083','','Miami',''),(8435,'66086','','Jefferson',''),(8436,'66088','','Atchison',''),(8437,'66092','','Douglas',''),(8438,'66092','','Miami',''),(8439,'66093','','Coffey',''),(8440,'66094','','Brown',''),(8441,'66095','','Anderson',''),(8442,'66097','','Leavenworth',''),(8443,'66109','','Leavenworth',''),(8444,'66217','','Wyandotte',''),(8445,'66403','','Nemaha',''),(8446,'66407','','Wabaunsee',''),(8447,'66409','','Douglas',''),(8448,'66411','','Riley',''),(8449,'66412','','Washington',''),(8450,'66413','','Lyon',''),(8451,'66413','','Wabaunsee',''),(8452,'66416','','Nemaha',''),(8453,'66419','','Jefferson',''),(8454,'66422','','Jackson',''),(8455,'66424','','Atchison',''),(8456,'66427','','Pottawatomie',''),(8457,'66431','','Shawnee',''),(8458,'66432','','Jackson',''),(8459,'66436','','Atchison',''),(8460,'66436','','Jefferson',''),(8461,'66439','','Atchison',''),(8462,'66439','','Jackson',''),(8463,'66441','','Dickinson',''),(8464,'66441','','Riley',''),(8465,'66442','','Geary',''),(8466,'66502','','Geary',''),(8467,'66502','','Pottawatomie',''),(8468,'66502','','Wabaunsee',''),(8469,'66512','','Jackson',''),(8470,'66512','','Shawnee',''),(8471,'66516','','Brown',''),(8472,'66521','','Nemaha',''),(8473,'66523','','Lyon',''),(8474,'66524','','Douglas',''),(8475,'66524','','Shawnee',''),(8476,'66528','','Franklin',''),(8477,'66532','','Doniphan',''),(8478,'66534','','Brown',''),(8479,'66536','','Jackson',''),(8480,'66536','','Shawnee',''),(8481,'66536','','Wabaunsee',''),(8482,'66540','','Nemaha',''),(8483,'66541','','Pawnee',''),(8484,'66544','','Nemaha',''),(8485,'66546','','Osage',''),(8486,'66547','','Wabaunsee',''),(8487,'66548','','Washington',''),(8488,'66550','','Brown',''),(8489,'66550','','Jackson',''),(8490,'66614','','Wabaunsee',''),(8491,'66615','','Wabaunsee',''),(8492,'66617','','Jackson',''),(8493,'66617','','Jefferson',''),(8494,'66701','','Crawford',''),(8495,'66711','','Bourbon',''),(8496,'66716','','Allen',''),(8497,'66720','','Allen',''),(8498,'66720','','Wilson',''),(8499,'66724','','Cherokee',''),(8500,'66736','','Elk',''),(8501,'66736','','Montgomery',''),(8502,'66738','','Linn',''),(8503,'66746','','Bourbon',''),(8504,'66748','','Neosho',''),(8505,'66748','','Woodson',''),(8506,'66753','','Cherokee',''),(8507,'66753','','Labette',''),(8508,'66754','','Linn',''),(8509,'66755','','Bourbon',''),(8510,'66757','','Montgomery',''),(8511,'66758','','Anderson',''),(8512,'66758','','Coffey',''),(8513,'66762','','Cherokee',''),(8514,'66776','','Labette',''),(8515,'66776','','Wilson',''),(8516,'66777','','Greenwood',''),(8517,'66777','','Wilson',''),(8518,'66780','','Bourbon',''),(8519,'66780','','Neosho',''),(8520,'66781','','Crawford',''),(8521,'66801','','Chase',''),(8522,'66834','','Geary',''),(8523,'66834','','Morris',''),(8524,'66838','','Chase',''),(8525,'66840','','Chase',''),(8526,'66840','','Marion',''),(8527,'66846','','Chase',''),(8528,'66846','','Lyon',''),(8529,'66849','','Geary',''),(8530,'66852','','Greenwood',''),(8531,'66852','','Woodson',''),(8532,'66854','','Coffey',''),(8533,'66856','','Osage',''),(8534,'66859','','Morris',''),(8535,'66860','','Lyon',''),(8536,'66864','','Coffey',''),(8537,'66865','','Chase',''),(8538,'66866','','Harvey',''),(8539,'66868','','Coffey',''),(8540,'66868','','Osage',''),(8541,'66871','','Osage',''),(8542,'66872','','Geary',''),(8543,'66901','','Republic',''),(8544,'66933','','Riley',''),(8545,'66937','','Clay',''),(8546,'66938','','Washington',''),(8547,'66939','','Jewell',''),(8548,'66948','','Republic',''),(8549,'66951','','Phillips',''),(8550,'66952','','Jewell',''),(8551,'66962','','Clay',''),(8552,'67004','','Harper',''),(8553,'67008','','Butler',''),(8554,'67017','','Sedgwick',''),(8555,'67018','','Sumner',''),(8556,'67020','','Reno',''),(8557,'67020','','Sedgwick',''),(8558,'67024','','Cowley',''),(8559,'67025','','Kingman',''),(8560,'67025','','Reno',''),(8561,'67026','','Sumner',''),(8562,'67028','','Barber',''),(8563,'67028','','Kiowa',''),(8564,'67029','','Kiowa',''),(8565,'67031','','Sedgwick',''),(8566,'67035','','Pratt',''),(8567,'67035','','Reno',''),(8568,'67039','','Cowley',''),(8569,'67047','','Elk',''),(8570,'67047','','Wilson',''),(8571,'67049','','Sumner',''),(8572,'67051','','Cowley',''),(8573,'67058','','Kingman',''),(8574,'67059','','Edwards',''),(8575,'67059','','Pratt',''),(8576,'67061','','Harper',''),(8577,'67062','','Mcpherson',''),(8578,'67065','','Pratt',''),(8579,'67068','','Reno',''),(8580,'67072','','Cowley',''),(8581,'67106','','Sedgwick',''),(8582,'67107','','Harvey',''),(8583,'67108','','Reno',''),(8584,'67110','','Cowley',''),(8585,'67110','','Sumner',''),(8586,'67114','','Butler',''),(8587,'67114','','Mcpherson',''),(8588,'67114','','Marion',''),(8589,'67118','','Sedgwick',''),(8590,'67118','','Sumner',''),(8591,'67119','','Cowley',''),(8592,'67120','','Sedgwick',''),(8593,'67122','','Elk',''),(8594,'67127','','Clark',''),(8595,'67134','','Barber',''),(8596,'67135','','Sedgwick',''),(8597,'67137','','Elk',''),(8598,'67146','','Sumner',''),(8599,'67147','','Harvey',''),(8600,'67151','','Marion',''),(8601,'67154','','Harvey',''),(8602,'67155','','Kiowa',''),(8603,'67159','','Harper',''),(8604,'67335','','Labette',''),(8605,'67336','','Cherokee',''),(8606,'67337','','Labette',''),(8607,'67344','','Chautauqua',''),(8608,'67344','','Elk',''),(8609,'67346','','Chautauqua',''),(8610,'67347','','Chautauqua',''),(8611,'67351','','Labette',''),(8612,'67352','','Chautauqua',''),(8613,'67353','','Chautauqua',''),(8614,'67356','','Cherokee',''),(8615,'67357','','Neosho',''),(8616,'67401','','Ottawa',''),(8617,'67410','','Clay',''),(8618,'67418','','Mitchell',''),(8619,'67420','','Cloud',''),(8620,'67425','','Ellsworth',''),(8621,'67427','','Ellsworth',''),(8622,'67428','','Marion',''),(8623,'67430','','Jewell',''),(8624,'67432','','Ottawa',''),(8625,'67432','','Riley',''),(8626,'67436','','Cloud',''),(8627,'67437','','Smith',''),(8628,'67439','','Lincoln',''),(8629,'67444','','Ellsworth',''),(8630,'67445','','Ottawa',''),(8631,'67446','','Jewell',''),(8632,'67447','','Riley',''),(8633,'67448','','Dickinson',''),(8634,'67448','','Mcpherson',''),(8635,'67449','','Marion',''),(8636,'67449','','Morris',''),(8637,'67450','','Barton',''),(8638,'67452','','Lincoln',''),(8639,'67456','','Saline',''),(8640,'67458','','Ottawa',''),(8641,'67464','','Ellsworth',''),(8642,'67466','','Clay',''),(8643,'67466','','Ottawa',''),(8644,'67470','','Ottawa',''),(8645,'67474','','Smith',''),(8646,'67475','','Dickinson',''),(8647,'67480','','Ottawa',''),(8648,'67480','','Saline',''),(8649,'67481','','Russell',''),(8650,'67484','','Lincoln',''),(8651,'67484','','Saline',''),(8652,'67485','','Osborne',''),(8653,'67487','','Dickinson',''),(8654,'67487','','Geary',''),(8655,'67490','','Lincoln',''),(8656,'67490','','Russell',''),(8657,'67491','','Rice',''),(8658,'67502','','Rice',''),(8659,'67511','','Rush',''),(8660,'67518','','Lane',''),(8661,'67519','','Pawnee',''),(8662,'67521','','Trego',''),(8663,'67522','','Harvey',''),(8664,'67523','','Hodgeman',''),(8665,'67525','','Rice',''),(8666,'67526','','Rice',''),(8667,'67526','','Stafford',''),(8668,'67530','','Stafford',''),(8669,'67546','','Reno',''),(8670,'67546','','Rice',''),(8671,'67547','','Hodgeman',''),(8672,'67550','','Stafford',''),(8673,'67556','','Ellis',''),(8674,'67556','','Ness',''),(8675,'67557','','Edwards',''),(8676,'67557','','Pawnee',''),(8677,'67557','','Pratt',''),(8678,'67559','','Pawnee',''),(8679,'67563','','Ford',''),(8680,'67563','','Hodgeman',''),(8681,'67565','','Barton',''),(8682,'67567','','Pawnee',''),(8683,'67567','','Rush',''),(8684,'67567','','Stafford',''),(8685,'67570','','Kingman',''),(8686,'67572','','Trego',''),(8687,'67575','','Pawnee',''),(8688,'67579','','Reno',''),(8689,'67583','','Pratt',''),(8690,'67583','','Stafford',''),(8691,'67584','','Gove',''),(8692,'67584','','Lane',''),(8693,'67584','','Trego',''),(8694,'67629','','Decatur',''),(8695,'67631','','Graham',''),(8696,'67632','','Graham',''),(8697,'67635','','Sheridan',''),(8698,'67637','','Trego',''),(8699,'67640','','Ellis',''),(8700,'67645','','Graham',''),(8701,'67646','','Graham',''),(8702,'67646','','Norton',''),(8703,'67646','','Rooks',''),(8704,'67647','','Norton',''),(8705,'67648','','Lincoln',''),(8706,'67648','','Osborne',''),(8707,'67649','','Osborne',''),(8708,'67651','','Ellis',''),(8709,'67651','','Rooks',''),(8710,'67651','','Russell',''),(8711,'67653','','Norton',''),(8712,'67656','','Graham',''),(8713,'67657','','Graham',''),(8714,'67657','','Trego',''),(8715,'67658','','Osborne',''),(8716,'67663','','Ellis',''),(8717,'67664','','Norton',''),(8718,'67665','','Barton',''),(8719,'67672','','Graham',''),(8720,'67673','','Russell',''),(8721,'67701','','Rawlins',''),(8722,'67732','','Rawlins',''),(8723,'67732','','Sherman',''),(8724,'67734','','Rawlins',''),(8725,'67737','','Sheridan',''),(8726,'67738','','Sheridan',''),(8727,'67739','','Decatur',''),(8728,'67741','','Cheyenne',''),(8729,'67743','','Rawlins',''),(8730,'67745','','Cheyenne',''),(8731,'67748','','Gove',''),(8732,'67748','','Thomas',''),(8733,'67749','','Rawlins',''),(8734,'67751','','Sheridan',''),(8735,'67752','','Sheridan',''),(8736,'67753','','Rawlins',''),(8737,'67753','','Sheridan',''),(8738,'67757','','Decatur',''),(8739,'67761','','Logan',''),(8740,'67764','','Thomas',''),(8741,'67834','','Clark',''),(8742,'67835','','Finney',''),(8743,'67837','','Haskell',''),(8744,'67837','','Meade',''),(8745,'67838','','Finney',''),(8746,'67839','','Gove',''),(8747,'67841','','Ford',''),(8748,'67842','','Clark',''),(8749,'67844','','Ford',''),(8750,'67844','','Gray',''),(8751,'67846','','Gray',''),(8752,'67846','','Lane',''),(8753,'67853','','Finney',''),(8754,'67855','','Grant',''),(8755,'67855','','Morton',''),(8756,'67857','','Kearny',''),(8757,'67861','','Logan',''),(8758,'67862','','Morton',''),(8759,'67863','','Scott',''),(8760,'67865','','Ford',''),(8761,'67867','','Meade',''),(8762,'67869','','Seward',''),(8763,'67870','','Seward',''),(8764,'67871','','Finney',''),(8765,'67871','','Gove',''),(8766,'67871','','Logan',''),(8767,'67871','','Wichita',''),(8768,'67876','','Hodgeman',''),(8769,'67877','','Seward',''),(8770,'67878','','Stanton',''),(8771,'67880','','Kearny',''),(8772,'67901','','Stevens',''),(8773,'67950','','Texas',''),(8774,'67952','','Seward',''),(8775,'67954','','Stevens',''),(8776,'68003','','Cass',''),(8777,'68007','','Washington',''),(8778,'68017','','Lancaster',''),(8779,'68020','','Thurston',''),(8780,'68025','','Saunders',''),(8781,'68029','','Burt',''),(8782,'68031','','Washington',''),(8783,'68036','','Saunders',''),(8784,'68044','','Washington',''),(8785,'68045','','Cuming',''),(8786,'68047','','Cuming',''),(8787,'68047','','Wayne',''),(8788,'68064','','Saunders',''),(8789,'68064','','Washington',''),(8790,'68065','','Lancaster',''),(8791,'68065','','Seward',''),(8792,'68069','','Sarpy',''),(8793,'68112','','Washington',''),(8794,'68122','','Washington',''),(8795,'68142','','Washington',''),(8796,'68147','','Douglas',''),(8797,'68152','','Washington',''),(8798,'68157','','Douglas',''),(8799,'68301','','Lancaster',''),(8800,'68301','','Otoe',''),(8801,'68307','','Otoe',''),(8802,'68316','','Polk',''),(8803,'68317','','Otoe',''),(8804,'68322','','Fillmore',''),(8805,'68325','','Republic',''),(8806,'68329','','Otoe',''),(8807,'68333','','Lancaster',''),(8808,'68335','','Nuckolls',''),(8809,'68339','','Seward',''),(8810,'68341','','Gage',''),(8811,'68341','','Jefferson',''),(8812,'68342','','Gage',''),(8813,'68343','','Seward',''),(8814,'68345','','Richardson',''),(8815,'68347','','Lancaster',''),(8816,'68347','','Otoe',''),(8817,'68351','','York',''),(8818,'68354','','York',''),(8819,'68358','','Gage',''),(8820,'68359','','Seward',''),(8821,'68366','','Lancaster',''),(8822,'68367','','Polk',''),(8823,'68367','','Seward',''),(8824,'68371','','Hamilton',''),(8825,'68376','','Nemaha',''),(8826,'68376','','Pawnee',''),(8827,'68378','','Johnson',''),(8828,'68381','','Pawnee',''),(8829,'68406','','Saline',''),(8830,'68413','','Otoe',''),(8831,'68428','','Seward',''),(8832,'68442','','Nemaha',''),(8833,'68447','','Johnson',''),(8834,'68453','','Fillmore',''),(8835,'68462','','Cass',''),(8836,'68465','','Gage',''),(8837,'68601','','Butler',''),(8838,'68601','','Colfax',''),(8839,'68601','','Polk',''),(8840,'68628','','Hamilton',''),(8841,'68628','','Polk',''),(8842,'68629','','Stanton',''),(8843,'68631','','Stanton',''),(8844,'68633','','Colfax',''),(8845,'68633','','Cuming',''),(8846,'68636','','Wheeler',''),(8847,'68640','','Platte',''),(8848,'68641','','Cuming',''),(8849,'68641','','Stanton',''),(8850,'68642','','Madison',''),(8851,'68643','','Platte',''),(8852,'68643','','Stanton',''),(8853,'68644','','Madison',''),(8854,'68654','','Hamilton',''),(8855,'68654','','York',''),(8856,'68660','','Nance',''),(8857,'68660','','Platte',''),(8858,'68662','','Butler',''),(8859,'68663','','Nance',''),(8860,'68663','','Polk',''),(8861,'68665','','Wheeler',''),(8862,'68701','','Pierce',''),(8863,'68701','','Stanton',''),(8864,'68719','','Gregory',''),(8865,'68726','','Holt',''),(8866,'68729','','Antelope',''),(8867,'68730','','Cedar',''),(8868,'68733','','Dakota',''),(8869,'68733','','Thurston',''),(8870,'68735','','Antelope',''),(8871,'68735','','Wheeler',''),(8872,'68740','','Stanton',''),(8873,'68745','','Wayne',''),(8874,'68746','','Holt',''),(8875,'68748','','Stanton',''),(8876,'68752','','Pierce',''),(8877,'68757','','Cedar',''),(8878,'68758','','Boone',''),(8879,'68758','','Platte',''),(8880,'68759','','Keya Paha',''),(8881,'68764','','Holt',''),(8882,'68764','','Knox',''),(8883,'68769','','Antelope',''),(8884,'68770','','Dakota',''),(8885,'68771','','Pierce',''),(8886,'68771','','Wayne',''),(8887,'68777','','Holt',''),(8888,'68781','','Antelope',''),(8889,'68784','','Wayne',''),(8890,'68785','','Dakota',''),(8891,'68786','','Cedar',''),(8892,'68787','','Dixon',''),(8893,'68791','','Wayne',''),(8894,'68801','','Merrick',''),(8895,'68813','','Blaine',''),(8896,'68815','','Custer',''),(8897,'68815','','Sherman',''),(8898,'68817','','Howard',''),(8899,'68818','','Clay',''),(8900,'68823','','Loup',''),(8901,'68823','','Rock',''),(8902,'68823','','Valley',''),(8903,'68824','','Howard',''),(8904,'68828','','Valley',''),(8905,'68832','','Hamilton',''),(8906,'68833','','Logan',''),(8907,'68834','','Custer',''),(8908,'68836','','Dawson',''),(8909,'68836','','Phelps',''),(8910,'68840','','Kearney',''),(8911,'68844','','Buffalo',''),(8912,'68845','','Kearney',''),(8913,'68847','','Kearney',''),(8914,'68850','','Gosper',''),(8915,'68863','','Phelps',''),(8916,'68864','','Howard',''),(8917,'68864','','Nance',''),(8918,'68866','','Custer',''),(8919,'68869','','Sherman',''),(8920,'68872','','Merrick',''),(8921,'68876','','Hall',''),(8922,'68878','','Custer',''),(8923,'68882','','Howard',''),(8924,'68883','','Adams',''),(8925,'68901','','Clay',''),(8926,'68922','','Gosper',''),(8927,'68924','','Phelps',''),(8928,'68927','','Gosper',''),(8929,'68928','','Adams',''),(8930,'68930','','Adams',''),(8931,'68932','','Adams',''),(8932,'68932','','Webster',''),(8933,'68934','','Nuckolls',''),(8934,'68935','','Nuckolls',''),(8935,'68936','','Gosper',''),(8936,'68937','','Dawson',''),(8937,'68941','','Adams',''),(8938,'68942','','Nuckolls',''),(8939,'68944','','Hamilton',''),(8940,'68948','','Gosper',''),(8941,'68949','','Harlan',''),(8942,'68956','','Hall',''),(8943,'68956','','Kearney',''),(8944,'68957','','Webster',''),(8945,'68967','','Harlan',''),(8946,'68977','','Furnas',''),(8947,'68978','','Jewell',''),(8948,'68979','','Fillmore',''),(8949,'68980','','Adams',''),(8950,'68980','','Hamilton',''),(8951,'68982','','Franklin',''),(8952,'68982','','Harlan',''),(8953,'68982','','Phelps',''),(8954,'69001','','Frontier',''),(8955,'69022','','Frontier',''),(8956,'69022','','Red Willow',''),(8957,'69024','','Hayes',''),(8958,'69024','','Red Willow',''),(8959,'69025','','Lincoln',''),(8960,'69028','','Dawson',''),(8961,'69028','','Gosper',''),(8962,'69029','','Frontier',''),(8963,'69029','','Lincoln',''),(8964,'69030','','Chase',''),(8965,'69034','','Frontier',''),(8966,'69038','','Hayes',''),(8967,'69039','','Lincoln',''),(8968,'69040','','Hayes',''),(8969,'69045','','Dundy',''),(8970,'69045','','Hayes',''),(8971,'69101','','Mcpherson',''),(8972,'69120','','Lincoln',''),(8973,'69120','','Logan',''),(8974,'69122','','Keith',''),(8975,'69128','','Banner',''),(8976,'69131','','Morrill',''),(8977,'69134','','Hayes',''),(8978,'69138','','Custer',''),(8979,'69138','','Lincoln',''),(8980,'69145','','Banner',''),(8981,'69146','','Arthur',''),(8982,'69147','','Keith',''),(8983,'69148','','Morrill',''),(8984,'69149','','Garden',''),(8985,'69152','','Cherry',''),(8986,'69156','','Banner',''),(8987,'69161','','Cherry',''),(8988,'69163','','Lincoln',''),(8989,'69163','','Thomas',''),(8990,'69165','','Mcpherson',''),(8991,'69166','','Cherry',''),(8992,'69168','','Chase',''),(8993,'69169','','Hayes',''),(8994,'69169','','Perkins',''),(8995,'69201','','Keya Paha',''),(8996,'69201','','Todd',''),(8997,'69210','','Keya Paha',''),(8998,'69212','','Todd',''),(8999,'69216','','Todd',''),(9000,'69217','','Rock',''),(9001,'69220','','Keya Paha',''),(9002,'69301','','Morrill',''),(9003,'69301','','Sheridan',''),(9004,'69333','','Cherry',''),(9005,'69333','','Garden',''),(9006,'69334','','Banner',''),(9007,'69334','','Scotts Bluff',''),(9008,'69337','','Sheridan',''),(9009,'69339','','Sioux',''),(9010,'69341','','Banner',''),(9011,'69343','','Cherry',''),(9012,'69347','','Dawes',''),(9013,'69348','','Dawes',''),(9014,'69348','','Sioux',''),(9015,'69350','','Arthur',''),(9016,'69350','','Cherry',''),(9017,'69351','','Garden',''),(9018,'69354','','Sioux',''),(9019,'69357','','Sioux',''),(9020,'69358','','Sioux',''),(9021,'69361','','Sioux',''),(9022,'69366','','Arthur',''),(9023,'69366','','Cherry',''),(9024,'70030','','Lafourche Parish',''),(9025,'70068','','St. Charles Parish',''),(9026,'70090','','St. John The Baptist Parish',''),(9027,'70139','','Orleans Parish',''),(9028,'70163','','Orleans Parish',''),(9029,'70301','','Assumption Parish',''),(9030,'70301','','Terrebonne Parish',''),(9031,'70339','','St. Martin Parish',''),(9032,'70343','','Lafourche Parish',''),(9033,'70359','','Lafourche Parish',''),(9034,'70364','','Lafourche Parish',''),(9035,'70377','','Lafourche Parish',''),(9036,'70380','','Assumption Parish',''),(9037,'70380','','St. Martin Parish',''),(9038,'70392','','St. Martin Parish',''),(9039,'70403','','Livingston Parish',''),(9040,'70422','','St. Helena Parish',''),(9041,'70427','','St. Tammany Parish',''),(9042,'70431','','Washington Parish',''),(9043,'70433','','Tangipahoa Parish',''),(9044,'70435','','Tangipahoa Parish',''),(9045,'70437','','Tangipahoa Parish',''),(9046,'70443','','Livingston Parish',''),(9047,'70443','','St. Helena Parish',''),(9048,'70444','','St. Helena Parish',''),(9049,'70453','','Livingston Parish',''),(9050,'70462','','Tangipahoa Parish',''),(9051,'70466','','Livingston Parish',''),(9052,'70512','','St. Martin Parish',''),(9053,'70515','','Acadia Parish',''),(9054,'70517','','Lafayette Parish',''),(9055,'70518','','Iberia Parish',''),(9056,'70518','','St. Martin Parish',''),(9057,'70520','','St. Landry Parish',''),(9058,'70525','','St. Landry Parish',''),(9059,'70526','','Vermilion Parish',''),(9060,'70528','','Iberia Parish',''),(9061,'70529','','Acadia Parish',''),(9062,'70532','','Allen Parish',''),(9063,'70533','','Iberia Parish',''),(9064,'70535','','Acadia Parish',''),(9065,'70535','','Evangeline Parish',''),(9066,'70542','','Cameron Parish',''),(9067,'70544','','St. Mary Parish',''),(9068,'70546','','Acadia Parish',''),(9069,'70549','','Cameron Parish',''),(9070,'70555','','Lafayette Parish',''),(9071,'70560','','Vermilion Parish',''),(9072,'70578','','Lafayette Parish',''),(9073,'70578','','Vermilion Parish',''),(9074,'70582','','Iberia Parish',''),(9075,'70583','','Acadia Parish',''),(9076,'70586','','St. Landry Parish',''),(9077,'70592','','Iberia Parish',''),(9078,'70592','','Vermilion Parish',''),(9079,'70607','','Cameron Parish',''),(9080,'70630','','Cameron Parish',''),(9081,'70633','','Beauregard Parish',''),(9082,'70634','','Vernon Parish',''),(9083,'70637','','Beauregard Parish',''),(9084,'70647','','Jefferson Davis Parish',''),(9085,'70648','','Jefferson Davis Parish',''),(9086,'70656','','Allen Parish',''),(9087,'70656','','Rapides Parish',''),(9088,'70657','','Allen Parish',''),(9089,'70657','','Calcasieu Parish',''),(9090,'70657','','Jefferson Davis Parish',''),(9091,'70661','','Beauregard Parish',''),(9092,'70706','','St. Helena Parish',''),(9093,'70722','','East Baton Rouge Parish',''),(9094,'70729','','Pointe Coupee Parish',''),(9095,'70739','','Livingston Parish',''),(9096,'70744','','St. Helena Parish',''),(9097,'70748','','East Baton Rouge Parish',''),(9098,'70750','','Pointe Coupee Parish',''),(9099,'70757','','Pointe Coupee Parish',''),(9100,'70757','','St. Martin Parish',''),(9101,'70764','','West Baton Rouge Parish',''),(9102,'70774','','Livingston Parish',''),(9103,'70777','','East Baton Rouge Parish',''),(9104,'70791','','East Feliciana Parish',''),(9105,'70836','','East Baton Rouge Parish',''),(9106,'71001','','Claiborne Parish',''),(9107,'71001','','Lincoln Parish',''),(9108,'71018','','Bossier Parish',''),(9109,'71019','','Natchitoches Parish',''),(9110,'71023','','Bossier Parish',''),(9111,'71024','','Bienville Parish',''),(9112,'71031','','Winn Parish',''),(9113,'71038','','Webster Parish',''),(9114,'71039','','Bienville Parish',''),(9115,'71046','','Caddo Parish',''),(9116,'71051','','Caddo Parish',''),(9117,'71052','','Red River Parish',''),(9118,'71055','','Bienville Parish',''),(9119,'71055','','Claiborne Parish',''),(9120,'71065','','Natchitoches Parish',''),(9121,'71067','','Webster Parish',''),(9122,'71068','','Red River Parish',''),(9123,'71070','','Bienville Parish',''),(9124,'71071','','Bossier Parish',''),(9125,'71075','','Bossier Parish',''),(9126,'71104','','Bossier Parish',''),(9127,'71105','','Bossier Parish',''),(9128,'71107','','Bossier Parish',''),(9129,'71115','','Red River Parish',''),(9130,'71222','','Claiborne Parish',''),(9131,'71227','','Jackson Parish',''),(9132,'71227','','Ouachita Parish',''),(9133,'71229','','Ouachita Parish',''),(9134,'71232','','Franklin Parish',''),(9135,'71232','','Madison Parish',''),(9136,'71234','','Lincoln Parish',''),(9137,'71234','','Ouachita Parish',''),(9138,'71235','','Claiborne Parish',''),(9139,'71237','','East Carroll Parish',''),(9140,'71237','','Richland Parish',''),(9141,'71238','','Jackson Parish',''),(9142,'71251','','Bienville Parish',''),(9143,'71256','','Claiborne Parish',''),(9144,'71264','','Morehouse Parish',''),(9145,'71268','','Bienville Parish',''),(9146,'71270','','Jackson Parish',''),(9147,'71275','','Bienville Parish',''),(9148,'71280','','Morehouse Parish',''),(9149,'71280','','Union Parish',''),(9150,'71322','','St. Landry Parish',''),(9151,'71325','','Evangeline Parish',''),(9152,'71326','','Catahoula Parish',''),(9153,'71328','','Avoyelles Parish',''),(9154,'71328','','La Salle Parish',''),(9155,'71343','','Concordia Parish',''),(9156,'71343','','La Salle Parish',''),(9157,'71351','','Rapides Parish',''),(9158,'71356','','Avoyelles Parish',''),(9159,'71360','','Avoyelles Parish',''),(9160,'71360','','Grant Parish',''),(9161,'71362','','St. Landry Parish',''),(9162,'71367','','Rapides Parish',''),(9163,'71401','','Catahoula Parish',''),(9164,'71403','','Sabine Parish',''),(9165,'71404','','Grant Parish',''),(9166,'71418','','Catahoula Parish',''),(9167,'71418','','Ouachita Parish',''),(9168,'71418','','Richland Parish',''),(9169,'71419','','De Soto Parish',''),(9170,'71423','','Rapides Parish',''),(9171,'71427','','Natchitoches Parish',''),(9172,'71435','','Catahoula Parish',''),(9173,'71438','','Vernon Parish',''),(9174,'71439','','Sabine Parish',''),(9175,'71441','','La Salle Parish',''),(9176,'71447','','Natchitoches Parish',''),(9177,'71447','','Vernon Parish',''),(9178,'71450','','Sabine Parish',''),(9179,'71454','','Winn Parish',''),(9180,'71455','','Natchitoches Parish',''),(9181,'71457','','Winn Parish',''),(9182,'71463','','Evangeline Parish',''),(9183,'71463','','Rapides Parish',''),(9184,'71465','','Caldwell Parish',''),(9185,'71465','','Catahoula Parish',''),(9186,'71465','','Winn Parish',''),(9187,'71467','','Rapides Parish',''),(9188,'71469','','Sabine Parish',''),(9189,'71479','','Winn Parish',''),(9190,'71602','','Grant',''),(9191,'71603','','Cleveland',''),(9192,'71603','','Grant',''),(9193,'71603','','Lincoln',''),(9194,'71638','','Desha',''),(9195,'71638','','Drew',''),(9196,'71639','','Lincoln',''),(9197,'71642','','Drew',''),(9198,'71644','','Jefferson',''),(9199,'71646','','Drew',''),(9200,'71655','','Lincoln',''),(9201,'71660','','Bradley',''),(9202,'71661','','Chicot',''),(9203,'71663','','Chicot',''),(9204,'71667','','Cleveland',''),(9205,'71670','','Drew',''),(9206,'71671','','Cleveland',''),(9207,'71671','','Drew',''),(9208,'71675','','Bradley',''),(9209,'71676','','Chicot',''),(9210,'71701','','Calhoun',''),(9211,'71720','','Calhoun',''),(9212,'71720','','Dallas',''),(9213,'71742','','Calhoun',''),(9214,'71749','','Claiborne Parish',''),(9215,'71749','','Union Parish',''),(9216,'71753','','Union',''),(9217,'71762','','Ouachita',''),(9218,'71763','','Ouachita',''),(9219,'71764','','Columbia',''),(9220,'71764','','Nevada',''),(9221,'71770','','Nevada',''),(9222,'71827','','Nevada',''),(9223,'71833','','Sevier',''),(9224,'71835','','Hempstead',''),(9225,'71841','','Polk',''),(9226,'71846','','Little River',''),(9227,'71852','','Hempstead',''),(9228,'71852','','Pike',''),(9229,'71857','','Hempstead',''),(9230,'71859','','Howard',''),(9231,'71860','','Columbia',''),(9232,'71860','','Nevada',''),(9233,'71861','','Lafayette',''),(9234,'71901','','Hot Spring',''),(9235,'71909','','Saline',''),(9236,'71913','','Hot Spring',''),(9237,'71921','','Hot Spring',''),(9238,'71921','','Pike',''),(9239,'71923','','Dallas',''),(9240,'71923','','Hot Spring',''),(9241,'71933','','Hot Spring',''),(9242,'71933','','Montgomery',''),(9243,'71943','','Hot Spring',''),(9244,'71943','','Montgomery',''),(9245,'71953','','Scott',''),(9246,'71959','','Howard',''),(9247,'71964','','Hot Spring',''),(9248,'71971','','Pike',''),(9249,'71973','','Howard',''),(9250,'72001','','Conway',''),(9251,'72002','','Pulaski',''),(9252,'72013','','Conway',''),(9253,'72015','','Grant',''),(9254,'72016','','Pulaski',''),(9255,'72020','','Independence',''),(9256,'72020','','Jackson',''),(9257,'72021','','Woodruff',''),(9258,'72023','','Faulkner',''),(9259,'72023','','Pulaski',''),(9260,'72024','','Prairie',''),(9261,'72025','','Conway',''),(9262,'72025','','Yell',''),(9263,'72030','','Van Buren',''),(9264,'72031','','Conway',''),(9265,'72031','','Stone',''),(9266,'72036','','Monroe',''),(9267,'72039','','Van Buren',''),(9268,'72044','','Stone',''),(9269,'72046','','Jefferson',''),(9270,'72046','','Pulaski',''),(9271,'72060','','Prairie',''),(9272,'72063','','Pope',''),(9273,'72065','','Grant',''),(9274,'72065','','Pulaski',''),(9275,'72067','','Van Buren',''),(9276,'72069','','Phillips',''),(9277,'72073','','Jefferson',''),(9278,'72076','','Faulkner',''),(9279,'72076','','Lonoke',''),(9280,'72079','','Grant',''),(9281,'72080','','Pope',''),(9282,'72080','','Van Buren',''),(9283,'72084','','Dallas',''),(9284,'72084','','Hot Spring',''),(9285,'72087','','Garland',''),(9286,'72088','','Cleburne',''),(9287,'72101','','Jackson',''),(9288,'72103','','Pulaski',''),(9289,'72104','','Saline',''),(9290,'72111','','White',''),(9291,'72112','','Independence',''),(9292,'72112','','Woodruff',''),(9293,'72120','','Faulkner',''),(9294,'72121','','Cleburne',''),(9295,'72122','','Pulaski',''),(9296,'72125','','Conway',''),(9297,'72126','','Pulaski',''),(9298,'72131','','Faulkner',''),(9299,'72131','','Van Buren',''),(9300,'72132','','Grant',''),(9301,'72137','','Cleburne',''),(9302,'72142','','Pulaski',''),(9303,'72143','','Cleburne',''),(9304,'72150','','Jefferson',''),(9305,'72153','','Cleburne',''),(9306,'72153','','Stone',''),(9307,'72160','','Jefferson',''),(9308,'72160','','Lonoke',''),(9309,'72160','','Prairie',''),(9310,'72167','','Grant',''),(9311,'72167','','Hot Spring',''),(9312,'72173','','White',''),(9313,'72176','','Prairie',''),(9314,'72206','','Saline',''),(9315,'72210','','Saline',''),(9316,'72324','','Poinsett',''),(9317,'72326','','Cross',''),(9318,'72328','','Desha',''),(9319,'72331','','Cross',''),(9320,'72335','','Lee',''),(9321,'72338','','Tipton',''),(9322,'72346','','Cross',''),(9323,'72347','','Jackson',''),(9324,'72348','','Crittenden',''),(9325,'72348','','Lee',''),(9326,'72354','','Mississippi',''),(9327,'72355','','Lee',''),(9328,'72366','','Monroe',''),(9329,'72368','','Monroe',''),(9330,'72372','','Lee',''),(9331,'72386','','Crittenden',''),(9332,'72386','','Mississippi',''),(9333,'72392','','Monroe',''),(9334,'72392','','Woodruff',''),(9335,'72396','','St. Francis',''),(9336,'72401','','Greene',''),(9337,'72416','','Greene',''),(9338,'72425','','Randolph',''),(9339,'72434','','Randolph',''),(9340,'72436','','Clay',''),(9341,'72450','','Craighead',''),(9342,'72459','','Randolph',''),(9343,'72459','','Sharp',''),(9344,'72461','','Greene',''),(9345,'72466','','Sharp',''),(9346,'72469','','Sharp',''),(9347,'72476','','Randolph',''),(9348,'72479','','Craighead',''),(9349,'72479','','Jackson',''),(9350,'72512','','Fulton',''),(9351,'72513','','Fulton',''),(9352,'72513','','Izard',''),(9353,'72519','','Baxter',''),(9354,'72519','','Stone',''),(9355,'72521','','Independence',''),(9356,'72523','','Independence',''),(9357,'72529','','Fulton',''),(9358,'72530','','Stone',''),(9359,'72531','','Baxter',''),(9360,'72532','','Izard',''),(9361,'72534','','Cleburne',''),(9362,'72538','','Baxter',''),(9363,'72542','','Fulton',''),(9364,'72550','','Cleburne',''),(9365,'72550','','Stone',''),(9366,'72554','','Sharp',''),(9367,'72560','','Izard',''),(9368,'72572','','Independence',''),(9369,'72577','','Sharp',''),(9370,'72579','','Sharp',''),(9371,'72601','','Marion',''),(9372,'72601','','Newton',''),(9373,'72611','','Boone',''),(9374,'72624','','Carroll',''),(9375,'72632','','Madison',''),(9376,'72633','','Marion',''),(9377,'72633','','Searcy',''),(9378,'72638','','Newton',''),(9379,'72644','','Marion',''),(9380,'72644','','Taney',''),(9381,'72645','','Stone',''),(9382,'72645','','Van Buren',''),(9383,'72650','','Stone',''),(9384,'72653','','Marion',''),(9385,'72675','','Marion',''),(9386,'72679','','Searcy',''),(9387,'72685','','Boone',''),(9388,'72685','','Searcy',''),(9389,'72687','','Boone',''),(9390,'72703','','Madison',''),(9391,'72727','','Madison',''),(9392,'72738','','Benton',''),(9393,'72738','','Washington',''),(9394,'72740','','Carroll',''),(9395,'72740','','Newton',''),(9396,'72742','','Newton',''),(9397,'72752','','Johnson',''),(9398,'72752','','Newton',''),(9399,'72756','','Madison',''),(9400,'72761','','Washington',''),(9401,'72762','','Benton',''),(9402,'72764','','Benton',''),(9403,'72773','','Washington',''),(9404,'72821','','Johnson',''),(9405,'72823','','Conway',''),(9406,'72833','','Scott',''),(9407,'72834','','Logan',''),(9408,'72839','','Newton',''),(9409,'72839','','Pope',''),(9410,'72846','','Pope',''),(9411,'72847','','Johnson',''),(9412,'72852','','Newton',''),(9413,'72853','','Perry',''),(9414,'72854','','Newton',''),(9415,'72855','','Franklin',''),(9416,'72856','','Pope',''),(9417,'72857','','Perry',''),(9418,'72927','','Scott',''),(9419,'72927','','Sebastian',''),(9420,'72933','','Logan',''),(9421,'72933','','Sebastian',''),(9422,'72943','','Yell',''),(9423,'72944','','Scott',''),(9424,'72947','','Franklin',''),(9425,'72949','','Johnson',''),(9426,'72949','','Logan',''),(9427,'72951','','Franklin',''),(9428,'72959','','Crawford',''),(9429,'72959','','Franklin',''),(9430,'73006','','Comanche',''),(9431,'73007','','Logan',''),(9432,'73010','','Grady',''),(9433,'73015','','Kiowa',''),(9434,'73015','','Washita',''),(9435,'73016','','Logan',''),(9436,'73017','','Comanche',''),(9437,'73017','','Grady',''),(9438,'73020','','Cleveland',''),(9439,'73021','','Caddo',''),(9440,'73025','','Logan',''),(9441,'73027','','Payne',''),(9442,'73028','','Kingfisher',''),(9443,'73030','','Garvin',''),(9444,'73034','','Logan',''),(9445,'73040','','Canadian',''),(9446,'73041','','Washita',''),(9447,'73045','','Lincoln',''),(9448,'73045','','Pottawatomie',''),(9449,'73047','','Canadian',''),(9450,'73048','','Blaine',''),(9451,'73048','','Custer',''),(9452,'73052','','Grady',''),(9453,'73052','','Mcclain',''),(9454,'73054','','Lincoln',''),(9455,'73054','','Logan',''),(9456,'73055','','Comanche',''),(9457,'73055','','Grady',''),(9458,'73056','','Garfield',''),(9459,'73056','','Kingfisher',''),(9460,'73057','','Mcclain',''),(9461,'73059','','Caddo',''),(9462,'73059','','Canadian',''),(9463,'73061','','Pawnee',''),(9464,'73062','','Washita',''),(9465,'73063','','Payne',''),(9466,'73072','','Mcclain',''),(9467,'73073','','Garfield',''),(9468,'73073','','Noble',''),(9469,'73073','','Payne',''),(9470,'73074','','Mcclain',''),(9471,'73078','','Oklahoma',''),(9472,'73079','','Caddo',''),(9473,'73082','','Comanche',''),(9474,'73092','','Caddo',''),(9475,'73096','','Washita',''),(9476,'73098','','Murray',''),(9477,'73127','','Canadian',''),(9478,'73128','','Oklahoma',''),(9479,'73135','','Cleveland',''),(9480,'73139','','Cleveland',''),(9481,'73149','','Cleveland',''),(9482,'73150','','Cleveland',''),(9483,'73159','','Cleveland',''),(9484,'73169','','Cleveland',''),(9485,'73179','','Canadian',''),(9486,'73401','','Johnston',''),(9487,'73401','','Love',''),(9488,'73425','','Stephens',''),(9489,'73432','','Atoka',''),(9490,'73434','','Garvin',''),(9491,'73438','','Stephens',''),(9492,'73442','','Jefferson',''),(9493,'73444','','Carter',''),(9494,'73456','','Carter',''),(9495,'73456','','Love',''),(9496,'73461','','Atoka',''),(9497,'73463','','Love',''),(9498,'73481','','Garvin',''),(9499,'73481','','Stephens',''),(9500,'73526','','Greer',''),(9501,'73528','','Cotton',''),(9502,'73528','','Tillman',''),(9503,'73529','','Jefferson',''),(9504,'73532','','Harmon',''),(9505,'73533','','Cotton',''),(9506,'73537','','Harmon',''),(9507,'73540','','Cotton',''),(9508,'73543','','Cotton',''),(9509,'73548','','Cotton',''),(9510,'73548','','Jefferson',''),(9511,'73554','','Harmon',''),(9512,'73559','','Comanche',''),(9513,'73564','','Comanche',''),(9514,'73566','','Tillman',''),(9515,'73572','','Comanche',''),(9516,'73601','','Washita',''),(9517,'73626','','Custer',''),(9518,'73644','','Custer',''),(9519,'73644','','Roger Mills',''),(9520,'73644','','Washita',''),(9521,'73646','','Custer',''),(9522,'73646','','Dewey',''),(9523,'73647','','Custer',''),(9524,'73650','','Custer',''),(9525,'73654','','Custer',''),(9526,'73654','','Roger Mills',''),(9527,'73662','','Greer',''),(9528,'73662','','Roger Mills',''),(9529,'73663','','Major',''),(9530,'73669','','Blaine',''),(9531,'73673','','Beckham',''),(9532,'73716','','Major',''),(9533,'73716','','Woods',''),(9534,'73717','','Alfalfa',''),(9535,'73718','','Garfield',''),(9536,'73724','','Dewey',''),(9537,'73726','','Woods',''),(9538,'73729','','Woods',''),(9539,'73739','','Garfield',''),(9540,'73754','','Major',''),(9541,'73755','','Dewey',''),(9542,'73755','','Major',''),(9543,'73757','','Garfield',''),(9544,'73758','','Alfalfa',''),(9545,'73761','','Garfield',''),(9546,'73762','','Canadian',''),(9547,'73763','','Kingfisher',''),(9548,'73763','','Major',''),(9549,'73764','','Blaine',''),(9550,'73801','','Harper',''),(9551,'73838','','Woodward',''),(9552,'73840','','Woodward',''),(9553,'73841','','Ellis',''),(9554,'73842','','Harper',''),(9555,'73842','','Woodward',''),(9556,'73844','','Harper',''),(9557,'73848','','Beaver',''),(9558,'73848','','Ellis',''),(9559,'73851','','Ellis',''),(9560,'73859','','Ellis',''),(9561,'73859','','Woodward',''),(9562,'73860','','Major',''),(9563,'73949','','Cimarron',''),(9564,'73949','','Sherman',''),(9565,'73950','','Texas',''),(9566,'74003','','Osage',''),(9567,'74008','','Wagoner',''),(9568,'74010','','Okfuskee',''),(9569,'74014','','Tulsa',''),(9570,'74015','','Tulsa',''),(9571,'74015','','Wagoner',''),(9572,'74016','','Craig',''),(9573,'74016','','Mayes',''),(9574,'74016','','Nowata',''),(9575,'74021','','Rogers',''),(9576,'74021','','Washington',''),(9577,'74022','','Osage',''),(9578,'74023','','Lincoln',''),(9579,'74030','','Payne',''),(9580,'74032','','Noble',''),(9581,'74032','','Pawnee',''),(9582,'74036','','Mayes',''),(9583,'74036','','Wagoner',''),(9584,'74038','','Creek',''),(9585,'74044','','Pawnee',''),(9586,'74045','','Payne',''),(9587,'74047','','Creek',''),(9588,'74047','','Tulsa',''),(9589,'74050','','Tulsa',''),(9590,'74051','','Osage',''),(9591,'74055','','Rogers',''),(9592,'74059','','Lincoln',''),(9593,'74059','','Logan',''),(9594,'74063','','Creek',''),(9595,'74063','','Osage',''),(9596,'74066','','Tulsa',''),(9597,'74070','','Tulsa',''),(9598,'74070','','Washington',''),(9599,'74072','','Craig',''),(9600,'74073','','Osage',''),(9601,'74075','','Noble',''),(9602,'74079','','Creek',''),(9603,'74080','','Washington',''),(9604,'74081','','Creek',''),(9605,'74083','','Washington',''),(9606,'74085','','Creek',''),(9607,'74085','','Pawnee',''),(9608,'74106','','Osage',''),(9609,'74108','','Wagoner',''),(9610,'74116','','Rogers',''),(9611,'74126','','Osage',''),(9612,'74127','','Osage',''),(9613,'74131','','Tulsa',''),(9614,'74132','','Creek',''),(9615,'74301','','Mayes',''),(9616,'74301','','Nowata',''),(9617,'74331','','Craig',''),(9618,'74331','','Ottawa',''),(9619,'74332','','Mayes',''),(9620,'74332','','Rogers',''),(9621,'74333','','Ottawa',''),(9622,'74337','','Wagoner',''),(9623,'74338','','Adair',''),(9624,'74344','','Ottawa',''),(9625,'74347','','Adair',''),(9626,'74347','','Cherokee',''),(9627,'74349','','Mayes',''),(9628,'74352','','Cherokee',''),(9629,'74352','','Wagoner',''),(9630,'74354','','Craig',''),(9631,'74364','','Cherokee',''),(9632,'74364','','Mayes',''),(9633,'74365','','Delaware',''),(9634,'74366','','Delaware',''),(9635,'74370','','Delaware',''),(9636,'74403','','Wagoner',''),(9637,'74422','','Okmulgee',''),(9638,'74428','','Muskogee',''),(9639,'74432','','Pittsburg',''),(9640,'74434','','Cherokee',''),(9641,'74434','','Wagoner',''),(9642,'74435','','Muskogee',''),(9643,'74436','','Okmulgee',''),(9644,'74436','','Wagoner',''),(9645,'74437','','Mcintosh',''),(9646,'74437','','Okfuskee',''),(9647,'74445','','Mcintosh',''),(9648,'74452','','Mayes',''),(9649,'74455','','Mcintosh',''),(9650,'74457','','Cherokee',''),(9651,'74462','','Pittsburg',''),(9652,'74469','','Mcintosh',''),(9653,'74523','','Choctaw',''),(9654,'74530','','Coal',''),(9655,'74536','','Latimer',''),(9656,'74536','','Pittsburg',''),(9657,'74540','','Pushmataha',''),(9658,'74547','','Latimer',''),(9659,'74549','','Le Flore',''),(9660,'74553','','Atoka',''),(9661,'74560','','Atoka',''),(9662,'74561','','Haskell',''),(9663,'74563','','Le Flore',''),(9664,'74570','','Pittsburg',''),(9665,'74571','','Latimer',''),(9666,'74571','','Pushmataha',''),(9667,'74572','','Pontotoc',''),(9668,'74574','','Latimer',''),(9669,'74576','','Pittsburg',''),(9670,'74601','','Noble',''),(9671,'74604','','Osage',''),(9672,'74630','','Garfield',''),(9673,'74646','','Grant',''),(9674,'74650','','Osage',''),(9675,'74651','','Pawnee',''),(9676,'74652','','Kay',''),(9677,'74653','','Noble',''),(9678,'74727','','Atoka',''),(9679,'74727','','Bryan',''),(9680,'74728','','Pushmataha',''),(9681,'74729','','Atoka',''),(9682,'74735','','Pushmataha',''),(9683,'74748','','Atoka',''),(9684,'74748','','Bryan',''),(9685,'74754','','Pushmataha',''),(9686,'74760','','Pushmataha',''),(9687,'74764','','Choctaw',''),(9688,'74820','','Johnston',''),(9689,'74824','','Payne',''),(9690,'74825','','Coal',''),(9691,'74825','','Hughes',''),(9692,'74831','','Garvin',''),(9693,'74831','','Pontotoc',''),(9694,'74839','','Mcintosh',''),(9695,'74839','','Okfuskee',''),(9696,'74840','','Seminole',''),(9697,'74848','','Seminole',''),(9698,'74849','','Pottawatomie',''),(9699,'74851','','Cleveland',''),(9700,'74851','','Lincoln',''),(9701,'74852','','Cleveland',''),(9702,'74854','','Seminole',''),(9703,'74855','','Pottawatomie',''),(9704,'74856','','Murray',''),(9705,'74857','','Oklahoma',''),(9706,'74857','','Pottawatomie',''),(9707,'74859','','Seminole',''),(9708,'74864','','Pottawatomie',''),(9709,'74865','','Garvin',''),(9710,'74865','','Murray',''),(9711,'74867','','Hughes',''),(9712,'74871','','Coal',''),(9713,'74871','','Johnston',''),(9714,'74872','','Mcclain',''),(9715,'74872','','Pontotoc',''),(9716,'74878','','Cleveland',''),(9717,'74880','','Okmulgee',''),(9718,'74881','','Logan',''),(9719,'74883','','Okfuskee',''),(9720,'74884','','Hughes',''),(9721,'74931','','Cherokee',''),(9722,'74931','','Sequoyah',''),(9723,'74941','','Le Flore',''),(9724,'74944','','Le Flore',''),(9725,'74948','','Adair',''),(9726,'74957','','Le Flore',''),(9727,'74960','','Cherokee',''),(9728,'74962','','Cherokee',''),(9729,'74964','','Delaware',''),(9730,'74966','','Latimer',''),(9731,'75007','','Dallas',''),(9732,'75009','','Denton',''),(9733,'75019','','Denton',''),(9734,'75022','','Tarrant',''),(9735,'75024','','Denton',''),(9736,'75028','','Tarrant',''),(9737,'75034','','Collin',''),(9738,'75044','','Collin',''),(9739,'75048','','Collin',''),(9740,'75050','','Tarrant',''),(9741,'75051','','Tarrant',''),(9742,'75052','','Tarrant',''),(9743,'75054','','Dallas',''),(9744,'75067','','Dallas',''),(9745,'75078','','Denton',''),(9746,'75080','','Collin',''),(9747,'75082','','Dallas',''),(9748,'75087','','Collin',''),(9749,'75088','','Rockwall',''),(9750,'75089','','Rockwall',''),(9751,'75093','','Denton',''),(9752,'75098','','Dallas',''),(9753,'75098','','Rockwall',''),(9754,'75104','','Ellis',''),(9755,'75119','','Navarro',''),(9756,'75124','','Van Zandt',''),(9757,'75125','','Dallas',''),(9758,'75143','','Kaufman',''),(9759,'75146','','Ellis',''),(9760,'75147','','Henderson',''),(9761,'75147','','Van Zandt',''),(9762,'75154','','Dallas',''),(9763,'75159','','Kaufman',''),(9764,'75160','','Hunt',''),(9765,'75160','','Rockwall',''),(9766,'75169','','Hunt',''),(9767,'75169','','Kaufman',''),(9768,'75189','','Collin',''),(9769,'75189','','Hunt',''),(9770,'75248','','Collin',''),(9771,'75252','','Dallas',''),(9772,'75287','','Collin',''),(9773,'75287','','Dallas',''),(9774,'75410','','Rains',''),(9775,'75423','','Fannin',''),(9776,'75424','','Fannin',''),(9777,'75428','','Delta',''),(9778,'75431','','Wood',''),(9779,'75435','','Red River',''),(9780,'75436','','Lamar',''),(9781,'75440','','Wood',''),(9782,'75442','','Hunt',''),(9783,'75446','','Lamar',''),(9784,'75449','','Hunt',''),(9785,'75451','','Wood',''),(9786,'75452','','Collin',''),(9787,'75452','','Hunt',''),(9788,'75453','','Hopkins',''),(9789,'75453','','Rains',''),(9790,'75455','','Franklin',''),(9791,'75469','','Fannin',''),(9792,'75471','','Wood',''),(9793,'75472','','Hopkins',''),(9794,'75474','','Kaufman',''),(9795,'75478','','Franklin',''),(9796,'75481','','Franklin',''),(9797,'75487','','Franklin',''),(9798,'75490','','Grayson',''),(9799,'75491','','Collin',''),(9800,'75491','','Fannin',''),(9801,'75494','','Franklin',''),(9802,'75494','','Hopkins',''),(9803,'75494','','Upshur',''),(9804,'75495','','Collin',''),(9805,'75496','','Fannin',''),(9806,'75497','','Hopkins',''),(9807,'75554','','Bowie',''),(9808,'75555','','Marion',''),(9809,'75556','','Miller',''),(9810,'75568','','Cass',''),(9811,'75571','','Titus',''),(9812,'75601','','Harrison',''),(9813,'75602','','Harrison',''),(9814,'75603','','Rusk',''),(9815,'75604','','Upshur',''),(9816,'75605','','Harrison',''),(9817,'75605','','Upshur',''),(9818,'75630','','Cass',''),(9819,'75638','','Cass',''),(9820,'75640','','Harrison',''),(9821,'75640','','Marion',''),(9822,'75641','','Rusk',''),(9823,'75643','','Shelby',''),(9824,'75645','','Gregg',''),(9825,'75647','','Smith',''),(9826,'75647','','Upshur',''),(9827,'75651','','Marion',''),(9828,'75654','','Cherokee',''),(9829,'75656','','Morris',''),(9830,'75657','','Cass',''),(9831,'75657','','Harrison',''),(9832,'75662','','Rusk',''),(9833,'75662','','Smith',''),(9834,'75668','','Marion',''),(9835,'75669','','Rusk',''),(9836,'75683','','Marion',''),(9837,'75684','','Smith',''),(9838,'75686','','Morris',''),(9839,'75686','','Titus',''),(9840,'75686','','Upshur',''),(9841,'75691','','Panola',''),(9842,'75751','','Anderson',''),(9843,'75752','','Van Zandt',''),(9844,'75755','','Wood',''),(9845,'75756','','Van Zandt',''),(9846,'75757','','Cherokee',''),(9847,'75758','','Van Zandt',''),(9848,'75760','','Rusk',''),(9849,'75763','','Henderson',''),(9850,'75765','','Upshur',''),(9851,'75773','','Smith',''),(9852,'75778','','Van Zandt',''),(9853,'75784','','Rusk',''),(9854,'75789','','Cherokee',''),(9855,'75789','','Rusk',''),(9856,'75790','','Smith',''),(9857,'75831','','Freestone',''),(9858,'75838','','Limestone',''),(9859,'75839','','Houston',''),(9860,'75844','','Anderson',''),(9861,'75846','','Limestone',''),(9862,'75847','','Trinity',''),(9863,'75851','','Trinity',''),(9864,'75852','','Walker',''),(9865,'75855','','Freestone',''),(9866,'75856','','Houston',''),(9867,'75859','','Navarro',''),(9868,'75862','','Walker',''),(9869,'75904','','Trinity',''),(9870,'75930','','San Augustine',''),(9871,'75931','','Sabine',''),(9872,'75933','','Jasper',''),(9873,'75935','','San Augustine',''),(9874,'75936','','Polk',''),(9875,'75946','','Rusk',''),(9876,'75948','','Newton',''),(9877,'75951','','Newton',''),(9878,'75954','','Panola',''),(9879,'75956','','Newton',''),(9880,'75968','','San Augustine',''),(9881,'75969','','Cherokee',''),(9882,'75972','','Sabine',''),(9883,'75972','','Shelby',''),(9884,'75974','','Panola',''),(9885,'75975','','Panola',''),(9886,'75975','','Rusk',''),(9887,'75980','','Jasper',''),(9888,'76008','','Tarrant',''),(9889,'76020','','Parker',''),(9890,'76020','','Wise',''),(9891,'76023','','Parker',''),(9892,'76028','','Tarrant',''),(9893,'76033','','Hood',''),(9894,'76035','','Hood',''),(9895,'76035','','Johnson',''),(9896,'76036','','Johnson',''),(9897,'76043','','Bosque',''),(9898,'76048','','Somervell',''),(9899,'76049','','Johnson',''),(9900,'76049','','Parker',''),(9901,'76050','','Ellis',''),(9902,'76050','','Hill',''),(9903,'76051','','Dallas',''),(9904,'76052','','Denton',''),(9905,'76052','','Wise',''),(9906,'76063','','Johnson',''),(9907,'76066','','Palo Pinto',''),(9908,'76067','','Parker',''),(9909,'76070','','Johnson',''),(9910,'76071','','Tarrant',''),(9911,'76078','','Denton',''),(9912,'76082','','Wise',''),(9913,'76084','','Ellis',''),(9914,'76087','','Hood',''),(9915,'76092','','Denton',''),(9916,'76093','','Hill',''),(9917,'76108','','Parker',''),(9918,'76126','','Parker',''),(9919,'76177','','Denton',''),(9920,'76228','','Montague',''),(9921,'76230','','Clay',''),(9922,'76230','','Jack',''),(9923,'76233','','Cooke',''),(9924,'76234','','Cooke',''),(9925,'76234','','Denton',''),(9926,'76239','','Cooke',''),(9927,'76249','','Wise',''),(9928,'76258','','Grayson',''),(9929,'76259','','Wise',''),(9930,'76261','','Clay',''),(9931,'76262','','Tarrant',''),(9932,'76265','','Cooke',''),(9933,'76266','','Cooke',''),(9934,'76270','','Wise',''),(9935,'76271','','Cooke',''),(9936,'76272','','Denton',''),(9937,'76273','','Cooke',''),(9938,'76305','','Clay',''),(9939,'76308','','Archer',''),(9940,'76310','','Archer',''),(9941,'76310','','Clay',''),(9942,'76360','','Archer',''),(9943,'76360','','Wilbarger',''),(9944,'76365','','Jack',''),(9945,'76372','','Throckmorton',''),(9946,'76374','','Archer',''),(9947,'76380','','Knox',''),(9948,'76384','','Foard',''),(9949,'76389','','Clay',''),(9950,'76389','','Jack',''),(9951,'76424','','Young',''),(9952,'76426','','Jack',''),(9953,'76429','','Palo Pinto',''),(9954,'76430','','Throckmorton',''),(9955,'76431','','Jack',''),(9956,'76432','','Comanche',''),(9957,'76433','','Hood',''),(9958,'76433','','Somervell',''),(9959,'76436','','Comanche',''),(9960,'76437','','Callahan',''),(9961,'76437','','Stephens',''),(9962,'76442','','Mills',''),(9963,'76443','','Brown',''),(9964,'76443','','Coleman',''),(9965,'76445','','Comanche',''),(9966,'76445','','Erath',''),(9967,'76446','','Comanche',''),(9968,'76450','','Palo Pinto',''),(9969,'76450','','Stephens',''),(9970,'76453','','Erath',''),(9971,'76454','','Comanche',''),(9972,'76457','','Bosque',''),(9973,'76457','','Erath',''),(9974,'76462','','Erath',''),(9975,'76462','','Palo Pinto',''),(9976,'76462','','Parker',''),(9977,'76463','','Erath',''),(9978,'76464','','Callahan',''),(9979,'76464','','Stephens',''),(9980,'76470','','Stephens',''),(9981,'76471','','Brown',''),(9982,'76471','','Comanche',''),(9983,'76474','','Brown',''),(9984,'76475','','Eastland',''),(9985,'76475','','Stephens',''),(9986,'76481','','Stephens',''),(9987,'76486','','Palo Pinto',''),(9988,'76486','','Parker',''),(9989,'76487','','Jack',''),(9990,'76487','','Wise',''),(9991,'76511','','Bell',''),(9992,'76511','','Milam',''),(9993,'76519','','Falls',''),(9994,'76519','','Milam',''),(9995,'76522','','Lampasas',''),(9996,'76524','','Falls',''),(9997,'76525','','Hamilton',''),(9998,'76525','','Lampasas',''),(9999,'76527','','Bell',''),(10000,'76527','','Burnet',''),(10001,'76528','','Bell',''),(10002,'76531','','Mills',''),(10003,'76534','','Milam',''),(10004,'76538','','Hamilton',''),(10005,'76539','','Bell',''),(10006,'76539','','Burnet',''),(10007,'76539','','Coryell',''),(10008,'76544','','Coryell',''),(10009,'76549','','Burnet',''),(10010,'76549','','Coryell',''),(10011,'76550','','Burnet',''),(10012,'76557','','Bell',''),(10013,'76557','','Coryell',''),(10014,'76566','','Hamilton',''),(10015,'76567','','Burleson',''),(10016,'76569','','Milam',''),(10017,'76570','','Milam',''),(10018,'76577','','Williamson',''),(10019,'76579','','Falls',''),(10020,'76629','','Falls',''),(10021,'76630','','Falls',''),(10022,'76633','','Bosque',''),(10023,'76634','','Coryell',''),(10024,'76637','','Hamilton',''),(10025,'76648','','Limestone',''),(10026,'76648','','Navarro',''),(10027,'76649','','Erath',''),(10028,'76653','','Falls',''),(10029,'76653','','Robertson',''),(10030,'76655','','Falls',''),(10031,'76657','','Coryell',''),(10032,'76664','','Falls',''),(10033,'76664','','Limestone',''),(10034,'76667','','Freestone',''),(10035,'76670','','Hill',''),(10036,'76673','','Limestone',''),(10037,'76673','','Mclennan',''),(10038,'76682','','Falls',''),(10039,'76687','','Falls',''),(10040,'76687','','Robertson',''),(10041,'76689','','Coryell',''),(10042,'76689','','Mclennan',''),(10043,'76691','','Hill',''),(10044,'76693','','Limestone',''),(10045,'76706','','Falls',''),(10046,'76801','','Coleman',''),(10047,'76801','','Mills',''),(10048,'76823','','Coleman',''),(10049,'76824','','San Saba',''),(10050,'76825','','Mason',''),(10051,'76841','','Schleicher',''),(10052,'76842','','Mcculloch',''),(10053,'76842','','San Saba',''),(10054,'76844','','Hamilton',''),(10055,'76844','','Lampasas',''),(10056,'76853','','Mills',''),(10057,'76854','','Menard',''),(10058,'76857','','Comanche',''),(10059,'76858','','Concho',''),(10060,'76861','','Tom Green',''),(10061,'76869','','San Saba',''),(10062,'76871','','Mcculloch',''),(10063,'76872','','San Saba',''),(10064,'76875','','Concho',''),(10065,'76882','','Runnels',''),(10066,'76890','','Comanche',''),(10067,'76890','','Mills',''),(10068,'76901','','Irion',''),(10069,'76904','','Irion',''),(10070,'76932','','Crockett',''),(10071,'76933','','Runnels',''),(10072,'76935','','Schleicher',''),(10073,'76943','','Val Verde',''),(10074,'76945','','Sterling',''),(10075,'76950','','Edwards',''),(10076,'76950','','Val Verde',''),(10077,'77053','','Harris',''),(10078,'77083','','Fort Bend',''),(10079,'77085','','Fort Bend',''),(10080,'77099','','Fort Bend',''),(10081,'77320','','San Jacinto',''),(10082,'77328','','Liberty',''),(10083,'77328','','Montgomery',''),(10084,'77339','','Montgomery',''),(10085,'77355','','Waller',''),(10086,'77356','','Grimes',''),(10087,'77357','','Harris',''),(10088,'77358','','Montgomery',''),(10089,'77358','','San Jacinto',''),(10090,'77363','','Waller',''),(10091,'77365','','Harris',''),(10092,'77369','','Hardin',''),(10093,'77371','','Liberty',''),(10094,'77372','','Liberty',''),(10095,'77378','','San Jacinto',''),(10096,'77423','','Fort Bend',''),(10097,'77426','','Austin',''),(10098,'77430','','Fort Bend',''),(10099,'77434','','Wharton',''),(10100,'77435','','Colorado',''),(10101,'77435','','Fort Bend',''),(10102,'77444','','Brazoria',''),(10103,'77447','','Montgomery',''),(10104,'77447','','Waller',''),(10105,'77450','','Fort Bend',''),(10106,'77455','','Jackson',''),(10107,'77465','','Calhoun',''),(10108,'77465','','Jackson',''),(10109,'77477','','Harris',''),(10110,'77480','','Matagorda',''),(10111,'77484','','Grimes',''),(10112,'77484','','Harris',''),(10113,'77485','','Fort Bend',''),(10114,'77485','','Wharton',''),(10115,'77489','','Harris',''),(10116,'77493','','Fort Bend',''),(10117,'77493','','Waller',''),(10118,'77494','','Harris',''),(10119,'77494','','Waller',''),(10120,'77511','','Galveston',''),(10121,'77521','','Chambers',''),(10122,'77535','','Chambers',''),(10123,'77546','','Harris',''),(10124,'77560','','Liberty',''),(10125,'77564','','Hardin',''),(10126,'77575','','Chambers',''),(10127,'77581','','Harris',''),(10128,'77583','','Fort Bend',''),(10129,'77584','','Fort Bend',''),(10130,'77612','','Newton',''),(10131,'77632','','Newton',''),(10132,'77656','','Tyler',''),(10133,'77662','','Jasper',''),(10134,'77663','','Tyler',''),(10135,'77665','','Jefferson',''),(10136,'77807','','Robertson',''),(10137,'77808','','Robertson',''),(10138,'77831','','Walker',''),(10139,'77833','','Austin',''),(10140,'77835','','Austin',''),(10141,'77836','','Milam',''),(10142,'77859','','Brazos',''),(10143,'77868','','Brazos',''),(10144,'77868','','Waller',''),(10145,'77868','','Washington',''),(10146,'77871','','Madison',''),(10147,'77873','','Montgomery',''),(10148,'77873','','Walker',''),(10149,'77905','','Goliad',''),(10150,'77950','','Aransas',''),(10151,'77954','','Gonzales',''),(10152,'77964','','Colorado',''),(10153,'77974','','Dewitt',''),(10154,'77979','','Jackson',''),(10155,'77979','','Victoria',''),(10156,'77984','','Gonzales',''),(10157,'77990','','Calhoun',''),(10158,'77995','','Dewitt',''),(10159,'77995','','Victoria',''),(10160,'78003','','Medina',''),(10161,'78005','','Atascosa',''),(10162,'78006','','Bexar',''),(10163,'78006','','Comal',''),(10164,'78008','','Live Oak',''),(10165,'78013','','Kerr',''),(10166,'78014','','Dimmit',''),(10167,'78015','','Kendall',''),(10168,'78017','','La Salle',''),(10169,'78019','','Webb',''),(10170,'78021','','Mcmullen',''),(10171,'78023','','Bandera',''),(10172,'78023','','Medina',''),(10173,'78024','','Real',''),(10174,'78028','','Gillespie',''),(10175,'78039','','Bexar',''),(10176,'78052','','Bexar',''),(10177,'78052','','Medina',''),(10178,'78055','','Kerr',''),(10179,'78057','','Medina',''),(10180,'78058','','Gillespie',''),(10181,'78058','','Real',''),(10182,'78064','','Wilson',''),(10183,'78069','','Bexar',''),(10184,'78070','','Blanco',''),(10185,'78070','','Kendall',''),(10186,'78071','','Mcmullen',''),(10187,'78073','','Atascosa',''),(10188,'78075','','Mcmullen',''),(10189,'78101','','Wilson',''),(10190,'78102','','Live Oak',''),(10191,'78108','','Bexar',''),(10192,'78108','','Comal',''),(10193,'78112','','Wilson',''),(10194,'78113','','Atascosa',''),(10195,'78113','','Wilson',''),(10196,'78114','','Atascosa',''),(10197,'78118','','Live Oak',''),(10198,'78119','','Bee',''),(10199,'78119','','Live Oak',''),(10200,'78121','','Guadalupe',''),(10201,'78124','','Bexar',''),(10202,'78130','','Guadalupe',''),(10203,'78140','','Guadalupe',''),(10204,'78140','','Wilson',''),(10205,'78141','','Karnes',''),(10206,'78154','','Bexar',''),(10207,'78154','','Comal',''),(10208,'78164','','Goliad',''),(10209,'78223','','Wilson',''),(10210,'78253','','Medina',''),(10211,'78264','','Atascosa',''),(10212,'78266','','Bexar',''),(10213,'78332','','Duval',''),(10214,'78335','','Nueces',''),(10215,'78336','','Aransas',''),(10216,'78336','','Nueces',''),(10217,'78355','','Jim Wells',''),(10218,'78355','','Kleberg',''),(10219,'78361','','Duval',''),(10220,'78361','','Zapata',''),(10221,'78368','','Live Oak',''),(10222,'78372','','Live Oak',''),(10223,'78380','','Jim Wells',''),(10224,'78383','','Live Oak',''),(10225,'78383','','Nueces',''),(10226,'78384','','Jim Wells',''),(10227,'78387','','Bee',''),(10228,'78390','','Aransas',''),(10229,'78418','','Kleberg',''),(10230,'78545','','Zapata',''),(10231,'78569','','Cameron',''),(10232,'78569','','Hidalgo',''),(10233,'78580','','Kenedy',''),(10234,'78606','','Comal',''),(10235,'78606','','Kendall',''),(10236,'78610','','Caldwell',''),(10237,'78610','','Travis',''),(10238,'78612','','Travis',''),(10239,'78613','','Travis',''),(10240,'78615','','Travis',''),(10241,'78616','','Bastrop',''),(10242,'78617','','Bastrop',''),(10243,'78618','','Mason',''),(10244,'78620','','Blanco',''),(10245,'78620','','Travis',''),(10246,'78621','','Lee',''),(10247,'78621','','Travis',''),(10248,'78621','','Williamson',''),(10249,'78623','','Hays',''),(10250,'78624','','Kendall',''),(10251,'78629','','Dewitt',''),(10252,'78631','','Kerr',''),(10253,'78631','','Kimble',''),(10254,'78632','','Caldwell',''),(10255,'78634','','Travis',''),(10256,'78639','','Burnet',''),(10257,'78640','','Caldwell',''),(10258,'78641','','Travis',''),(10259,'78642','','Burnet',''),(10260,'78643','','Blanco',''),(10261,'78648','','Gonzales',''),(10262,'78648','','Guadalupe',''),(10263,'78650','','Lee',''),(10264,'78652','','Hays',''),(10265,'78654','','Travis',''),(10266,'78655','','Guadalupe',''),(10267,'78656','','Hays',''),(10268,'78657','','Burnet',''),(10269,'78659','','Lee',''),(10270,'78662','','Caldwell',''),(10271,'78663','','Hays',''),(10272,'78663','','Travis',''),(10273,'78664','','Travis',''),(10274,'78666','','Caldwell',''),(10275,'78666','','Comal',''),(10276,'78666','','Guadalupe',''),(10277,'78669','','Blanco',''),(10278,'78669','','Burnet',''),(10279,'78671','','Blanco',''),(10280,'78676','','Blanco',''),(10281,'78726','','Williamson',''),(10282,'78727','','Williamson',''),(10283,'78728','','Williamson',''),(10284,'78729','','Travis',''),(10285,'78737','','Travis',''),(10286,'78750','','Williamson',''),(10287,'78759','','Williamson',''),(10288,'78828','','Real',''),(10289,'78833','','Edwards',''),(10290,'78833','','Uvalde',''),(10291,'78839','','Dimmit',''),(10292,'78879','','Uvalde',''),(10293,'78880','','Real',''),(10294,'78884','','Bandera',''),(10295,'78884','','Medina',''),(10296,'78885','','Real',''),(10297,'78886','','Frio',''),(10298,'78932','','Washington',''),(10299,'78933','','Austin',''),(10300,'78938','','Colorado',''),(10301,'78940','','Austin',''),(10302,'78940','','Colorado',''),(10303,'78941','','Bastrop',''),(10304,'78941','','Gonzales',''),(10305,'78942','','Bastrop',''),(10306,'78942','','Fayette',''),(10307,'78945','','Bastrop',''),(10308,'78946','','Fayette',''),(10309,'78946','','Washington',''),(10310,'78950','','Colorado',''),(10311,'78953','','Caldwell',''),(10312,'78954','','Austin',''),(10313,'78956','','Lavaca',''),(10314,'78957','','Fayette',''),(10315,'78959','','Caldwell',''),(10316,'78959','','Fayette',''),(10317,'78962','','Fayette',''),(10318,'79001','','Deaf Smith',''),(10319,'79005','','Ochiltree',''),(10320,'79010','','Potter',''),(10321,'79011','','Hemphill',''),(10322,'79012','','Randall',''),(10323,'79014','','Lipscomb',''),(10324,'79018','','Moore',''),(10325,'79018','','Oldham',''),(10326,'79022','','Hartley',''),(10327,'79031','','Castro',''),(10328,'79035','','Deaf Smith',''),(10329,'79036','','Carson',''),(10330,'79036','','Moore',''),(10331,'79036','','Potter',''),(10332,'79039','','Donley',''),(10333,'79039','','Gray',''),(10334,'79040','','Sherman',''),(10335,'79041','','Lamb',''),(10336,'79042','','Armstrong',''),(10337,'79042','','Castro',''),(10338,'79042','','Randall',''),(10339,'79043','','Lamb',''),(10340,'79045','','Castro',''),(10341,'79052','','Castro',''),(10342,'79052','','Hale',''),(10343,'79057','','Donley',''),(10344,'79057','','Wheeler',''),(10345,'79058','','Potter',''),(10346,'79059','','Gray',''),(10347,'79062','','Hutchinson',''),(10348,'79064','','Hale',''),(10349,'79065','','Roberts',''),(10350,'79072','','Swisher',''),(10351,'79079','','Collingsworth',''),(10352,'79080','','Hutchinson',''),(10353,'79081','','Hutchinson',''),(10354,'79081','','Ochiltree',''),(10355,'79083','','Moore',''),(10356,'79086','','Sherman',''),(10357,'79088','','Briscoe',''),(10358,'79088','','Castro',''),(10359,'79092','','Deaf Smith',''),(10360,'79098','','Deaf Smith',''),(10361,'79098','','Potter',''),(10362,'79098','','Randall',''),(10363,'79103','','Randall',''),(10364,'79105','','Moore',''),(10365,'79106','','Randall',''),(10366,'79108','','Carson',''),(10367,'79109','','Potter',''),(10368,'79118','','Potter',''),(10369,'79121','','Potter',''),(10370,'79124','','Randall',''),(10371,'79201','','Cottle',''),(10372,'79201','','Motley',''),(10373,'79225','','Wilbarger',''),(10374,'79226','','Armstrong',''),(10375,'79226','','Briscoe',''),(10376,'79226','','Hall',''),(10377,'79227','','Knox',''),(10378,'79230','','Childress',''),(10379,'79235','','Crosby',''),(10380,'79235','','Motley',''),(10381,'79245','','Collingsworth',''),(10382,'79245','','Donley',''),(10383,'79248','','King',''),(10384,'79250','','Crosby',''),(10385,'79250','','Floyd',''),(10386,'79250','','Lubbock',''),(10387,'79252','','Cottle',''),(10388,'79255','','Floyd',''),(10389,'79255','','Motley',''),(10390,'79259','','Hall',''),(10391,'79311','','Lubbock',''),(10392,'79313','','Lamb',''),(10393,'79323','','Gaines',''),(10394,'79325','','Bailey',''),(10395,'79331','','Gaines',''),(10396,'79331','','Martin',''),(10397,'79339','','Hockley',''),(10398,'79343','','Lubbock',''),(10399,'79345','','Lynn',''),(10400,'79346','','Bailey',''),(10401,'79347','','Castro',''),(10402,'79347','','Lamb',''),(10403,'79347','','Parmer',''),(10404,'79351','','Borden',''),(10405,'79351','','Dawson',''),(10406,'79356','','Crosby',''),(10407,'79356','','Lynn',''),(10408,'79358','','Lubbock',''),(10409,'79359','','Terry',''),(10410,'79359','','Yoakum',''),(10411,'79363','','Hockley',''),(10412,'79364','','Garza',''),(10413,'79364','','Lynn',''),(10414,'79370','','Crosby',''),(10415,'79371','','Bailey',''),(10416,'79407','','Hockley',''),(10417,'79423','','Lynn',''),(10418,'79504','','Shackelford',''),(10419,'79506','','Coke',''),(10420,'79510','','Coleman',''),(10421,'79511','','Borden',''),(10422,'79512','','Scurry',''),(10423,'79517','','Borden',''),(10424,'79519','','Runnels',''),(10425,'79520','','Fisher',''),(10426,'79526','','Fisher',''),(10427,'79527','','Borden',''),(10428,'79528','','Stonewall',''),(10429,'79529','','Haskell',''),(10430,'79532','','Nolan',''),(10431,'79532','','Scurry',''),(10432,'79533','','Haskell',''),(10433,'79533','','Shackelford',''),(10434,'79533','','Throckmorton',''),(10435,'79536','','Jones',''),(10436,'79536','','Nolan',''),(10437,'79538','','Runnels',''),(10438,'79541','','Callahan',''),(10439,'79545','','Fisher',''),(10440,'79545','','Scurry',''),(10441,'79546','','Scurry',''),(10442,'79546','','Stonewall',''),(10443,'79549','','Kent',''),(10444,'79553','','Haskell',''),(10445,'79556','','Fisher',''),(10446,'79560','','Jones',''),(10447,'79561','','Fisher',''),(10448,'79561','','Nolan',''),(10449,'79566','','Runnels',''),(10450,'79567','','Taylor',''),(10451,'79601','','Callahan',''),(10452,'79601','','Jones',''),(10453,'79601','','Shackelford',''),(10454,'79602','','Callahan',''),(10455,'79713','','Borden',''),(10456,'79713','','Dawson',''),(10457,'79713','','Howard',''),(10458,'79720','','Borden',''),(10459,'79720','','Glasscock',''),(10460,'79731','','Upton',''),(10461,'79735','','Brewster',''),(10462,'79739','','Reagan',''),(10463,'79744','','Crockett',''),(10464,'79748','','Martin',''),(10465,'79756','','Crane',''),(10466,'79756','','Winkler',''),(10467,'79765','','Midland',''),(10468,'79766','','Crane',''),(10469,'79766','','Midland',''),(10470,'79772','','Culberson',''),(10471,'79772','','Ward',''),(10472,'79781','','Crockett',''),(10473,'79781','','Terrell',''),(10474,'79782','','Glasscock',''),(10475,'79837','','Otero',''),(10476,'79847','','Culberson',''),(10477,'79848','','Pecos',''),(10478,'79854','','Presidio',''),(10479,'79855','','Hudspeth',''),(10480,'79855','','Jeff Davis',''),(10481,'79938','','Hudspeth',''),(10482,'79942','','Crockett',''),(10483,'80002','','Adams',''),(10484,'80003','','Adams',''),(10485,'80010','','Adams',''),(10486,'80011','','Adams',''),(10487,'80012','','Denver',''),(10488,'80014','','Denver',''),(10489,'80016','','Douglas',''),(10490,'80020','','Adams',''),(10491,'80020','','Boulder',''),(10492,'80020','','Jefferson',''),(10493,'80023','','Adams',''),(10494,'80031','','Jefferson',''),(10495,'80102','','Arapahoe',''),(10496,'80102','','Elbert',''),(10497,'80103','','Adams',''),(10498,'80105','','Adams',''),(10499,'80105','','Elbert',''),(10500,'80106','','Douglas',''),(10501,'80106','','Elbert',''),(10502,'80110','','Denver',''),(10503,'80111','','Denver',''),(10504,'80112','','Douglas',''),(10505,'80120','','Douglas',''),(10506,'80123','','Arapahoe',''),(10507,'80123','','Denver',''),(10508,'80128','','Arapahoe',''),(10509,'80129','','Arapahoe',''),(10510,'80133','','Douglas',''),(10511,'80135','','Jefferson',''),(10512,'80136','','Arapahoe',''),(10513,'80137','','Adams',''),(10514,'80138','','Elbert',''),(10515,'80212','','Adams',''),(10516,'80212','','Jefferson',''),(10517,'80214','','Denver',''),(10518,'80216','','Adams',''),(10519,'80220','','Arapahoe',''),(10520,'80221','','Denver',''),(10521,'80222','','Arapahoe',''),(10522,'80224','','Arapahoe',''),(10523,'80226','','Denver',''),(10524,'80227','','Denver',''),(10525,'80231','','Arapahoe',''),(10526,'80232','','Denver',''),(10527,'80235','','Denver',''),(10528,'80236','','Arapahoe',''),(10529,'80237','','Arapahoe',''),(10530,'80239','','Adams',''),(10531,'80246','','Arapahoe',''),(10532,'80247','','Denver',''),(10533,'80403','','Boulder',''),(10534,'80403','','Gilpin',''),(10535,'80421','','Jefferson',''),(10536,'80422','','Boulder',''),(10537,'80423','','Grand',''),(10538,'80426','','Routt',''),(10539,'80439','','Clear Creek',''),(10540,'80449','','Chaffee',''),(10541,'80463','','Eagle',''),(10542,'80470','','Park',''),(10543,'80503','','Larimer',''),(10544,'80504','','Larimer',''),(10545,'80504','','Weld',''),(10546,'80513','','Weld',''),(10547,'80516','','Boulder',''),(10548,'80524','','Weld',''),(10549,'80534','','Larimer',''),(10550,'80537','','Weld',''),(10551,'80540','','Larimer',''),(10552,'80549','','Weld',''),(10553,'80550','','Larimer',''),(10554,'80603','','Adams',''),(10555,'80612','','Larimer',''),(10556,'80642','','Adams',''),(10557,'80643','','Adams',''),(10558,'80649','','Weld',''),(10559,'80654','','Adams',''),(10560,'80654','','Weld',''),(10561,'80701','','Adams',''),(10562,'80723','','Washington',''),(10563,'80731','','Logan',''),(10564,'80731','','Sedgwick',''),(10565,'80731','','Yuma',''),(10566,'80733','','Washington',''),(10567,'80734','','Yuma',''),(10568,'80741','','Morgan',''),(10569,'80741','','Washington',''),(10570,'80758','','Dundy',''),(10571,'80759','','Washington',''),(10572,'80807','','Yuma',''),(10573,'80808','','Elbert',''),(10574,'80815','','Washington',''),(10575,'80816','','Park',''),(10576,'80818','','Washington',''),(10577,'80819','','Teller',''),(10578,'80821','','Cheyenne',''),(10579,'80827','','Teller',''),(10580,'80828','','Elbert',''),(10581,'80831','','Elbert',''),(10582,'80832','','Elbert',''),(10583,'80832','','Lincoln',''),(10584,'80833','','Elbert',''),(10585,'80833','','Lincoln',''),(10586,'80926','','Fremont',''),(10587,'80939','','El Paso',''),(10588,'81008','','El Paso',''),(10589,'81039','','Crowley',''),(10590,'81039','','Pueblo',''),(10591,'81050','','Bent',''),(10592,'81052','','Bent',''),(10593,'81054','','Baca',''),(10594,'81058','','Crowley',''),(10595,'81059','','Otero',''),(10596,'81063','','Lincoln',''),(10597,'81064','','Las Animas',''),(10598,'81069','','Custer',''),(10599,'81069','','Huerfano',''),(10600,'81084','','Prowers',''),(10601,'81092','','Bent',''),(10602,'81101','','Conejos',''),(10603,'81122','','Archuleta',''),(10604,'81125','','Alamosa',''),(10605,'81125','','Rio Grande',''),(10606,'81130','','Hinsdale',''),(10607,'81132','','Saguache',''),(10608,'81136','','Saguache',''),(10609,'81137','','Archuleta',''),(10610,'81137','','San Juan',''),(10611,'81144','','Alamosa',''),(10612,'81147','','Hinsdale',''),(10613,'81147','','Mineral',''),(10614,'81151','','Costilla',''),(10615,'81154','','Mineral',''),(10616,'81201','','Fremont',''),(10617,'81220','','Montrose',''),(10618,'81230','','Saguache',''),(10619,'81248','','Gunnison',''),(10620,'81253','','Fremont',''),(10621,'81301','','San Juan',''),(10622,'81323','','Dolores',''),(10623,'81324','','San Juan',''),(10624,'81325','','Dolores',''),(10625,'81328','','La Plata',''),(10626,'81403','','Ouray',''),(10627,'81415','','Montrose',''),(10628,'81416','','Montrose',''),(10629,'81423','','Montrose',''),(10630,'81431','','San Miguel',''),(10631,'81432','','San Miguel',''),(10632,'81434','','Delta',''),(10633,'81621','','Pitkin',''),(10634,'81623','','Eagle',''),(10635,'81623','','Gunnison',''),(10636,'81623','','Pitkin',''),(10637,'81625','','Routt',''),(10638,'81630','','Garfield',''),(10639,'81637','','Garfield',''),(10640,'81641','','Moffat',''),(10641,'81650','','Rio Blanco',''),(10642,'81653','','Routt',''),(10643,'82063','','Larimer',''),(10644,'82082','','Banner',''),(10645,'82083','','Carbon',''),(10646,'82190','','Teton',''),(10647,'82201','','Albany',''),(10648,'82210','','Goshen',''),(10649,'82225','','Goshen',''),(10650,'82301','','Fremont',''),(10651,'82301','','Sweetwater',''),(10652,'82329','','Albany',''),(10653,'82401','','Big Horn',''),(10654,'82401','','Hot Springs',''),(10655,'82421','','Park',''),(10656,'82423','','Park',''),(10657,'82435','','Big Horn',''),(10658,'82604','','Carbon',''),(10659,'82620','','Carbon',''),(10660,'82633','','Niobrara',''),(10661,'82636','','Converse',''),(10662,'82637','','Albany',''),(10663,'82639','','Natrona',''),(10664,'82642','','Natrona',''),(10665,'82701','','Custer',''),(10666,'82701','','Pennington',''),(10667,'82701','','Niobrara',''),(10668,'82729','','Weston',''),(10669,'82730','','Crook',''),(10670,'82801','','Big Horn',''),(10671,'82831','','Campbell',''),(10672,'82831','','Johnson',''),(10673,'82832','','Johnson',''),(10674,'82925','','Teton',''),(10675,'82930','','Summit',''),(10676,'82932','','Sublette',''),(10677,'83001','','Sublette',''),(10678,'83111','','Caribou',''),(10679,'83120','','Caribou',''),(10680,'83202','','Bingham',''),(10681,'83204','','Power',''),(10682,'83211','','Cassia',''),(10683,'83212','','Oneida',''),(10684,'83226','','Lemhi',''),(10685,'83235','','Lemhi',''),(10686,'83236','','Bonneville',''),(10687,'83241','','Franklin',''),(10688,'83253','','Custer',''),(10689,'83254','','Caribou',''),(10690,'83255','','Custer',''),(10691,'83274','','Bonneville',''),(10692,'83276','','Bear Lake',''),(10693,'83285','','Caribou',''),(10694,'83301','','Jerome',''),(10695,'83302','','Owyhee',''),(10696,'83312','','Box Elder',''),(10697,'83314','','Twin Falls',''),(10698,'83316','','Gooding',''),(10699,'83316','','Owyhee',''),(10700,'83318','','Minidoka',''),(10701,'83332','','Twin Falls',''),(10702,'83337','','Elmore',''),(10703,'83338','','Gooding',''),(10704,'83338','','Lincoln',''),(10705,'83342','','Oneida',''),(10706,'83342','','Box Elder',''),(10707,'83344','','Cassia',''),(10708,'83347','','Jerome',''),(10709,'83347','','Lincoln',''),(10710,'83350','','Blaine',''),(10711,'83350','','Cassia',''),(10712,'83352','','Blaine',''),(10713,'83352','','Camas',''),(10714,'83401','','Jefferson',''),(10715,'83402','','Bingham',''),(10716,'83402','','Jefferson',''),(10717,'83434','','Madison',''),(10718,'83435','','Clark',''),(10719,'83436','','Madison',''),(10720,'83436','','Teton',''),(10721,'83440','','Fremont',''),(10722,'83443','','Bonneville',''),(10723,'83443','','Madison',''),(10724,'83445','','Madison',''),(10725,'83448','','Fremont',''),(10726,'83451','','Madison',''),(10727,'83464','','Clark',''),(10728,'83524','','Lewis',''),(10729,'83535','','Nez Perce',''),(10730,'83536','','Lewis',''),(10731,'83537','','Clearwater',''),(10732,'83537','','Nez Perce',''),(10733,'83541','','Nez Perce',''),(10734,'83544','','Lewis',''),(10735,'83548','','Nez Perce',''),(10736,'83555','','Nez Perce',''),(10737,'83607','','Gem',''),(10738,'83607','','Payette',''),(10739,'83616','','Gem',''),(10740,'83624','','Elmore',''),(10741,'83627','','Owyhee',''),(10742,'83629','','Gem',''),(10743,'83634','','Canyon',''),(10744,'83638','','Adams',''),(10745,'83638','','Idaho',''),(10746,'83641','','Ada',''),(10747,'83641','','Owyhee',''),(10748,'83654','','Idaho',''),(10749,'83657','','Valley',''),(10750,'83660','','Payette',''),(10751,'83661','','Washington',''),(10752,'83669','','Canyon',''),(10753,'83670','','Boise',''),(10754,'83687','','Ada',''),(10755,'83702','','Boise',''),(10756,'83716','','Boise',''),(10757,'83716','','Elmore',''),(10758,'83801','','Bonner',''),(10759,'83803','','Bonner',''),(10760,'83810','','Shoshone',''),(10761,'83823','','Clearwater',''),(10762,'83830','','Shoshone',''),(10763,'83832','','Nez Perce',''),(10764,'83833','','Benewah',''),(10765,'83861','','Kootenai',''),(10766,'83861','','Shoshone',''),(10767,'83864','','Boundary',''),(10768,'83869','','Bonner',''),(10769,'84020','','Utah',''),(10770,'84022','','Juab',''),(10771,'84034','','White Pine',''),(10772,'84034','','Juab',''),(10773,'84036','','Wasatch',''),(10774,'84052','','Uintah',''),(10775,'84053','','Uintah',''),(10776,'84060','','Wasatch',''),(10777,'84066','','Uintah',''),(10778,'84078','','Daggett',''),(10779,'84083','','Box Elder',''),(10780,'84083','','Juab',''),(10781,'84315','','Davis',''),(10782,'84405','','Davis',''),(10783,'84525','','Grand',''),(10784,'84526','','Duchesne',''),(10785,'84526','','Utah',''),(10786,'84531','','Apache',''),(10787,'84532','','San Juan',''),(10788,'84533','','Garfield',''),(10789,'84533','','San Juan',''),(10790,'84536','','Navajo',''),(10791,'84540','','Uintah',''),(10792,'84604','','Wasatch',''),(10793,'84628','','Tooele',''),(10794,'84629','','Utah',''),(10795,'84656','','Juab',''),(10796,'84712','','Piute',''),(10797,'84713','','Millard',''),(10798,'84718','','Kane',''),(10799,'84744','','Piute',''),(10800,'84751','','Millard',''),(10801,'84753','','Beaver',''),(10802,'84756','','Washington',''),(10803,'84757','','Iron',''),(10804,'84762','','Garfield',''),(10805,'84775','','Garfield',''),(10806,'85120','','Maricopa',''),(10807,'85139','','Maricopa',''),(10808,'85142','','Pinal',''),(10809,'85192','','Gila',''),(10810,'85248','','Pinal',''),(10811,'85320','','Yavapai',''),(10812,'85321','','Maricopa',''),(10813,'85333','','Maricopa',''),(10814,'85339','','Pinal',''),(10815,'85342','','Yavapai',''),(10816,'85390','','Yavapai',''),(10817,'85533','','Graham',''),(10818,'85539','','Pinal',''),(10819,'85542','','Gila',''),(10820,'85545','','Maricopa',''),(10821,'85602','','Pima',''),(10822,'85611','','Cochise',''),(10823,'85611','','Pima',''),(10824,'85634','','Pinal',''),(10825,'85637','','Pima',''),(10826,'85643','','Graham',''),(10827,'85645','','Santa Cruz',''),(10828,'85653','','Pinal',''),(10829,'85658','','Pinal',''),(10830,'85739','','Pima',''),(10831,'85901','','Apache',''),(10832,'85930','','Apache',''),(10833,'85941','','Apache',''),(10834,'85941','','Gila',''),(10835,'86022','','Mohave',''),(10836,'86030','','Coconino',''),(10837,'86033','','Apache',''),(10838,'86034','','Apache',''),(10839,'86044','','Navajo',''),(10840,'86044','','San Juan',''),(10841,'86047','','Coconino',''),(10842,'86054','','Coconino',''),(10843,'86320','','Coconino',''),(10844,'86336','','Coconino',''),(10845,'86337','','Coconino',''),(10846,'86434','','Yavapai',''),(10847,'86504','','Mckinley',''),(10848,'86505','','Navajo',''),(10849,'86510','','Apache',''),(10850,'86514','','San Juan',''),(10851,'86515','','Mckinley',''),(10852,'86520','','Navajo',''),(10853,'87006','','Valencia',''),(10854,'87011','','Socorro',''),(10855,'87013','','Mckinley',''),(10856,'87013','','Rio Arriba',''),(10857,'87013','','San Juan',''),(10858,'87014','','Sandoval',''),(10859,'87015','','Bernalillo',''),(10860,'87015','','Torrance',''),(10861,'87026','','Bernalillo',''),(10862,'87026','','Valencia',''),(10863,'87035','','Santa Fe',''),(10864,'87036','','Socorro',''),(10865,'87045','','Cibola',''),(10866,'87046','','Rio Arriba',''),(10867,'87047','','Sandoval',''),(10868,'87047','','Santa Fe',''),(10869,'87048','','Bernalillo',''),(10870,'87056','','San Miguel',''),(10871,'87313','','San Juan',''),(10872,'87321','','Mckinley',''),(10873,'87323','','Cibola',''),(10874,'87325','','San Juan',''),(10875,'87327','','Cibola',''),(10876,'87328','','Apache',''),(10877,'87328','','San Juan',''),(10878,'87412','','Rio Arriba',''),(10879,'87419','','Rio Arriba',''),(10880,'87521','','Rio Arriba',''),(10881,'87522','','Santa Fe',''),(10882,'87531','','Taos',''),(10883,'87532','','Santa Fe',''),(10884,'87535','','San Miguel',''),(10885,'87549','','Taos',''),(10886,'87573','','Santa Fe',''),(10887,'87577','','Rio Arriba',''),(10888,'87711','','San Miguel',''),(10889,'87734','','Colfax',''),(10890,'87742','','Mora',''),(10891,'87745','','Mora',''),(10892,'87746','','Harding',''),(10893,'87825','','Catron',''),(10894,'87829','','Cibola',''),(10895,'87936','','Sierra',''),(10896,'87943','','Catron',''),(10897,'87943','','Socorro',''),(10898,'88040','','Hidalgo',''),(10899,'88045','','Grant',''),(10900,'88063','','El Paso',''),(10901,'88081','','Dona Ana',''),(10902,'88116','','Chaves',''),(10903,'88120','','Quay',''),(10904,'88124','','Quay',''),(10905,'88124','','Roosevelt',''),(10906,'88135','','Roosevelt',''),(10907,'88220','','Culberson',''),(10908,'88250','','Chaves',''),(10909,'88253','','Eddy',''),(10910,'88301','','Torrance',''),(10911,'88318','','Torrance',''),(10912,'88321','','Guadalupe',''),(10913,'88339','','Chaves',''),(10914,'88344','','Chaves',''),(10915,'88401','','San Miguel',''),(10916,'88410','','Harding',''),(10917,'88415','','Harding',''),(10918,'88419','','Colfax',''),(10919,'88422','','Colfax',''),(10920,'88426','','Harding',''),(10921,'88430','','Oldham',''),(10922,'88431','','San Miguel',''),(10923,'89001','','Nye',''),(10924,'89010','','Mono',''),(10925,'89010','','Mineral',''),(10926,'89019','','Inyo',''),(10927,'89019','','San Bernardino',''),(10928,'89049','','Esmeralda',''),(10929,'89060','','Inyo',''),(10930,'89061','','Inyo',''),(10931,'89124','','Nye',''),(10932,'89310','','Nye',''),(10933,'89316','','Nye',''),(10934,'89316','','White Pine',''),(10935,'89317','','Nye',''),(10936,'89403','','Storey',''),(10937,'89405','','Pershing',''),(10938,'89406','','Lyon',''),(10939,'89408','','Churchill',''),(10940,'89409','','Mineral',''),(10941,'89412','','Humboldt',''),(10942,'89414','','Elko',''),(10943,'89421','','Malheur',''),(10944,'89434','','Storey',''),(10945,'89439','','Sierra',''),(10946,'89442','','Storey',''),(10947,'89444','','Lyon',''),(10948,'89445','','Pershing',''),(10949,'89521','','Storey',''),(10950,'89705','','Carson City',''),(10951,'89706','','Lyon',''),(10952,'89820','','Eureka',''),(10953,'89822','','Eureka',''),(10954,'89832','','Owyhee',''),(10955,'90265','','Ventura',''),(10956,'90623','','Los Angeles',''),(10957,'90630','','Los Angeles',''),(10958,'90631','','Los Angeles',''),(10959,'90638','','Orange',''),(10960,'90740','','Los Angeles',''),(10961,'90815','','Orange',''),(10962,'91304','','Ventura',''),(10963,'91307','','Ventura',''),(10964,'91311','','Ventura',''),(10965,'91361','','Los Angeles',''),(10966,'91362','','Los Angeles',''),(10967,'91759','','Los Angeles',''),(10968,'91766','','San Bernardino',''),(10969,'92004','','Imperial',''),(10970,'92028','','Riverside',''),(10971,'92225','','Imperial',''),(10972,'92274','','Imperial',''),(10973,'92277','','Riverside',''),(10974,'92324','','Riverside',''),(10975,'92373','','Riverside',''),(10976,'92397','','Los Angeles',''),(10977,'92399','','Riverside',''),(10978,'92509','','San Bernardino',''),(10979,'92530','','Orange',''),(10980,'92672','','San Diego',''),(10981,'92880','','San Bernardino',''),(10982,'93001','','Santa Barbara',''),(10983,'93013','','Ventura',''),(10984,'93201','','Kings',''),(10985,'93210','','Monterey',''),(10986,'93210','','San Benito',''),(10987,'93212','','Tulare',''),(10988,'93215','','Tulare',''),(10989,'93225','','Ventura',''),(10990,'93238','','Tulare',''),(10991,'93242','','Kings',''),(10992,'93243','','Los Angeles',''),(10993,'93252','','San Luis Obispo',''),(10994,'93252','','Santa Barbara',''),(10995,'93252','','Ventura',''),(10996,'93254','','San Luis Obispo',''),(10997,'93426','','San Luis Obispo',''),(10998,'93451','','Monterey',''),(10999,'93454','','San Luis Obispo',''),(11000,'93458','','San Luis Obispo',''),(11001,'93461','','Kern',''),(11002,'93461','','Monterey',''),(11003,'93514','','Mono',''),(11004,'93516','','San Bernardino',''),(11005,'93527','','Inyo',''),(11006,'93527','','Tulare',''),(11007,'93555','','San Bernardino',''),(11008,'93560','','Los Angeles',''),(11009,'93601','','Mariposa',''),(11010,'93610','','Merced',''),(11011,'93618','','Fresno',''),(11012,'93619','','Tulare',''),(11013,'93620','','Fresno',''),(11014,'93622','','Madera',''),(11015,'93622','','Merced',''),(11016,'93623','','Madera',''),(11017,'93626','','Madera',''),(11018,'93631','','Kings',''),(11019,'93631','','Tulare',''),(11020,'93633','','Fresno',''),(11021,'93646','','Tulare',''),(11022,'93653','','Mariposa',''),(11023,'93654','','Tulare',''),(11024,'93656','','Kings',''),(11025,'93930','','San Benito',''),(11026,'94028','','Santa Clara',''),(11027,'94303','','Santa Clara',''),(11028,'94505','','Alameda',''),(11029,'94514','','Alameda',''),(11030,'94515','','Sonoma',''),(11031,'94550','','Santa Clara',''),(11032,'94551','','Contra Costa',''),(11033,'94571','','Sacramento',''),(11034,'94588','','Contra Costa',''),(11035,'94589','','Napa',''),(11036,'94611','','Contra Costa',''),(11037,'94706','','Contra Costa',''),(11038,'94707','','Contra Costa',''),(11039,'94708','','Contra Costa',''),(11040,'94952','','Marin',''),(11041,'95004','','San Benito',''),(11042,'95023','','Santa Clara',''),(11043,'95033','','Santa Clara',''),(11044,'95076','','Monterey',''),(11045,'95076','','Santa Clara',''),(11046,'95219','','Contra Costa',''),(11047,'95223','','Alpine',''),(11048,'95223','','Tuolumne',''),(11049,'95230','','Calaveras',''),(11050,'95230','','Stanislaus',''),(11051,'95311','','Tuolumne',''),(11052,'95321','','Mariposa',''),(11053,'95329','','Mariposa',''),(11054,'95329','','Stanislaus',''),(11055,'95360','','Merced',''),(11056,'95361','','San Joaquin',''),(11057,'95369','','Mariposa',''),(11058,'95377','','Alameda',''),(11059,'95380','','Merced',''),(11060,'95385','','San Joaquin',''),(11061,'95389','','Tuolumne',''),(11062,'95391','','Alameda',''),(11063,'95425','','Mendocino',''),(11064,'95469','','Lake',''),(11065,'95589','','Mendocino',''),(11066,'95602','','Nevada',''),(11067,'95612','','Solano',''),(11068,'95615','','Yolo',''),(11069,'95618','','Solano',''),(11070,'95620','','Yolo',''),(11071,'95626','','Placer',''),(11072,'95626','','Sutter',''),(11073,'95629','','El Dorado',''),(11074,'95632','','San Joaquin',''),(11075,'95641','','San Joaquin',''),(11076,'95645','','Colusa',''),(11077,'95645','','Sutter',''),(11078,'95646','','Amador',''),(11079,'95668','','Placer',''),(11080,'95690','','Solano',''),(11081,'95692','','Sutter',''),(11082,'95694','','Solano',''),(11083,'95715','','Nevada',''),(11084,'95724','','Placer',''),(11085,'95728','','Nevada',''),(11086,'95837','','Sutter',''),(11087,'95901','','Butte',''),(11088,'95912','','Yolo',''),(11089,'95914','','Yuba',''),(11090,'95922','','Sierra',''),(11091,'95930','','Yuba',''),(11092,'95941','','Yuba',''),(11093,'95948','','Sutter',''),(11094,'95960','','Sierra',''),(11095,'95960','','Yuba',''),(11096,'95963','','Tehama',''),(11097,'95966','','Yuba',''),(11098,'95970','','Glenn',''),(11099,'95973','','Tehama',''),(11100,'95977','','Yuba',''),(11101,'95981','','Plumas',''),(11102,'96006','','Lassen',''),(11103,'96022','','Shasta',''),(11104,'96025','','Shasta',''),(11105,'96056','','Lassen',''),(11106,'96056','','Modoc',''),(11107,'96059','','Shasta',''),(11108,'96075','','Shasta',''),(11109,'96076','','Shasta',''),(11110,'96076','','Tehama',''),(11111,'96105','','Lassen',''),(11112,'96105','','Sierra',''),(11113,'96110','','Lassen',''),(11114,'96111','','Nevada',''),(11115,'96118','','Plumas',''),(11116,'96134','','Modoc',''),(11117,'96137','','Plumas',''),(11118,'96142','','Placer',''),(11119,'96161','','Placer',''),(11120,'97002','','Clackamas',''),(11121,'97009','','Multnomah',''),(11122,'97014','','Multnomah',''),(11123,'97016','','Clatsop',''),(11124,'97019','','Clackamas',''),(11125,'97032','','Clackamas',''),(11126,'97034','','Multnomah',''),(11127,'97035','','Multnomah',''),(11128,'97035','','Washington',''),(11129,'97056','','Multnomah',''),(11130,'97056','','Washington',''),(11131,'97062','','Clackamas',''),(11132,'97064','','Washington',''),(11133,'97070','','Washington',''),(11134,'97071','','Clackamas',''),(11135,'97080','','Clackamas',''),(11136,'97101','','Polk',''),(11137,'97102','','Tillamook',''),(11138,'97119','','Yamhill',''),(11139,'97123','','Yamhill',''),(11140,'97131','','Clatsop',''),(11141,'97132','','Clackamas',''),(11142,'97132','','Washington',''),(11143,'97133','','Multnomah',''),(11144,'97140','','Clackamas',''),(11145,'97140','','Yamhill',''),(11146,'97202','','Clackamas',''),(11147,'97206','','Clackamas',''),(11148,'97210','','Washington',''),(11149,'97219','','Clackamas',''),(11150,'97221','','Washington',''),(11151,'97222','','Multnomah',''),(11152,'97225','','Multnomah',''),(11153,'97229','','Multnomah',''),(11154,'97231','','Columbia',''),(11155,'97231','','Washington',''),(11156,'97304','','Yamhill',''),(11157,'97321','','Benton',''),(11158,'97324','','Lane',''),(11159,'97324','','Lincoln',''),(11160,'97326','','Lincoln',''),(11161,'97333','','Linn',''),(11162,'97346','','Linn',''),(11163,'97347','','Tillamook',''),(11164,'97347','','Yamhill',''),(11165,'97350','','Linn',''),(11166,'97352','','Linn',''),(11167,'97358','','Marion',''),(11168,'97360','','Marion',''),(11169,'97361','','Benton',''),(11170,'97362','','Clackamas',''),(11171,'97368','','Tillamook',''),(11172,'97370','','Polk',''),(11173,'97375','','Clackamas',''),(11174,'97378','','Polk',''),(11175,'97383','','Linn',''),(11176,'97390','','Lane',''),(11177,'97396','','Polk',''),(11178,'97413','','Linn',''),(11179,'97424','','Douglas',''),(11180,'97446','','Lane',''),(11181,'97448','','Benton',''),(11182,'97450','','Coos',''),(11183,'97456','','Lane',''),(11184,'97459','','Douglas',''),(11185,'97493','','Douglas',''),(11186,'97497','','Jackson',''),(11187,'97498','','Lane',''),(11188,'97526','','Jackson',''),(11189,'97527','','Jackson',''),(11190,'97635','','Lake',''),(11191,'97701','','Crook',''),(11192,'97710','','Malheur',''),(11193,'97731','','Douglas',''),(11194,'97739','','Klamath',''),(11195,'97751','','Harney',''),(11196,'97754','','Jefferson',''),(11197,'97756','','Crook',''),(11198,'97758','','Lake',''),(11199,'97759','','Jefferson',''),(11200,'97759','','Linn',''),(11201,'97760','','Crook',''),(11202,'97760','','Deschutes',''),(11203,'97761','','Wasco',''),(11204,'97814','','Union',''),(11205,'97826','','Morrow',''),(11206,'97830','','Gilliam',''),(11207,'97838','','Morrow',''),(11208,'97843','','Gilliam',''),(11209,'97848','','Wheeler',''),(11210,'97867','','Baker',''),(11211,'97869','','Baker',''),(11212,'97877','','Grant',''),(11213,'97880','','Grant',''),(11214,'97907','','Malheur',''),(11215,'97910','','Owyhee',''),(11216,'97913','','Payette',''),(11217,'98022','','Pierce',''),(11218,'98047','','Pierce',''),(11219,'98068','','King',''),(11220,'98072','','Snohomish',''),(11221,'98077','','Snohomish',''),(11222,'98092','','Pierce',''),(11223,'98221','','San Juan',''),(11224,'98229','','Skagit',''),(11225,'98237','','Whatcom',''),(11226,'98241','','Skagit',''),(11227,'98283','','Whatcom',''),(11228,'98284','','Whatcom',''),(11229,'98292','','Skagit',''),(11230,'98304','','Lewis',''),(11231,'98329','','Kitsap',''),(11232,'98331','','Jefferson',''),(11233,'98354','','King',''),(11234,'98382','','Jefferson',''),(11235,'98528','','Kitsap',''),(11236,'98531','','Thurston',''),(11237,'98537','','Pacific',''),(11238,'98541','','Mason',''),(11239,'98547','','Pacific',''),(11240,'98557','','Mason',''),(11241,'98568','','Lewis',''),(11242,'98579','','Lewis',''),(11243,'98601','','Cowlitz',''),(11244,'98605','','Skamania',''),(11245,'98616','','Skamania',''),(11246,'98621','','Pacific',''),(11247,'98632','','Wahkiakum',''),(11248,'98638','','Wahkiakum',''),(11249,'98671','','Skamania',''),(11250,'98672','','Skamania',''),(11251,'98674','','Clark',''),(11252,'98812','','Douglas',''),(11253,'98813','','Okanogan',''),(11254,'98816','','Douglas',''),(11255,'98823','','Douglas',''),(11256,'98828','','Kittitas',''),(11257,'98832','','Lincoln',''),(11258,'98848','','Douglas',''),(11259,'98857','','Adams',''),(11260,'98862','','Whatcom',''),(11261,'98901','','Kittitas',''),(11262,'98930','','Benton',''),(11263,'98937','','Kittitas',''),(11264,'98944','','Benton',''),(11265,'99004','','Whitman',''),(11266,'99006','','Pend Oreille',''),(11267,'99006','','Stevens',''),(11268,'99008','','Spokane',''),(11269,'99009','','Pend Oreille',''),(11270,'99013','','Lincoln',''),(11271,'99013','','Spokane',''),(11272,'99026','','Spokane',''),(11273,'99029','','Spokane',''),(11274,'99032','','Adams',''),(11275,'99033','','Spokane',''),(11276,'99103','','Grant',''),(11277,'99110','','Spokane',''),(11278,'99115','','Douglas',''),(11279,'99116','','Douglas',''),(11280,'99116','','Grant',''),(11281,'99122','','Stevens',''),(11282,'99128','','Latah',''),(11283,'99133','','Douglas',''),(11284,'99133','','Lincoln',''),(11285,'99141','','Ferry',''),(11286,'99155','','Ferry',''),(11287,'99156','','Spokane',''),(11288,'99159','','Adams',''),(11289,'99166','','Okanogan',''),(11290,'99169','','Lincoln',''),(11291,'99170','','Spokane',''),(11292,'99326','','Adams',''),(11293,'99333','','Adams',''),(11294,'99344','','Franklin',''),(11295,'99344','','Grant',''),(11296,'99347','','Columbia',''),(11297,'99347','','Whitman',''),(11298,'99348','','Columbia',''),(11299,'99350','','Klickitat',''),(11300,'99350','','Yakima',''),(11301,'99359','','Franklin',''),(11302,'99361','','Columbia',''),(11303,'99362','','Umatilla',''),(11304,'99371','','Franklin',''),(11305,'99403','','Garfield',''),(11306,'99503','','Bethel Census Area',''),(11307,'99513','','Anchorage Borough',''),(11308,'99588','','Matanuska-susitna Borough',''),(11309,'99613','','Lake And Peninsula Borough',''),(11310,'99693','','Matanuska-susitna Borough',''),(11311,'99695','','Lake And Peninsula Borough',''),(11312,'99701','','Yukon-koyukuk Census Area',''),(11313,'99706','','Southeast Fairbanks Census Area',''),(11314,'99729','','Matanuska-susitna Borough',''),(11315,'99732','','Southeast Fairbanks Census Area',''),(11316,'99737','','Valdez-cordova Census Area',''),(11317,'99738','','Yukon-koyukuk Census Area',''),(11318,'99760','','Denali Borough',''),(11319,'99760','','Fairbanks North Star Borough',''),(11320,'99780','','Valdez-cordova Census Area',''),(11321,'01001','Agawam Town','',''),(11322,'01002','Amherst Center','',''),(11323,'01003','Amherst Center','',''),(11324,'01009','Palmer Town','',''),(11325,'01013','Springfield','',''),(11326,'01020','Springfield','',''),(11327,'01027','Easthampton Town','',''),(11328,'01030','Agawam Town','',''),(11329,'01053','Northampton','',''),(11330,'01057','Palmer Town','',''),(11331,'01062','Northampton','',''),(11332,'01069','Palmer Town','',''),(11333,'01079','Palmer Town','',''),(11334,'01080','Palmer Town','',''),(11335,'01089','West Springfield Town','',''),(11336,'01095','Palmer Town','',''),(11337,'01106','Springfield','',''),(11338,'01151','Springfield','',''),(11339,'01301','Greenfield Town','',''),(11340,'01344','Millers Falls','',''),(11341,'01349','Millers Falls','',''),(11342,'01420','Leominster','',''),(11343,'01432','Devens','',''),(11344,'01464','Devens','',''),(11345,'01468','Baldwinville','',''),(11346,'01523','South Lancaster','',''),(11347,'01534','Whitinsville','',''),(11348,'01545','Worcester','',''),(11349,'01550','Southbridge Town','',''),(11350,'01566','Fiskdale','',''),(11351,'01583','Worcester','',''),(11352,'01730','Burlington','',''),(11353,'01760','Cochituate','',''),(11354,'01778','Cochituate','',''),(11355,'01801','Reading','',''),(11356,'01841','Methuen Town','',''),(11357,'01844','Methuen Town','',''),(11358,'01890','Woburn','',''),(11359,'01906','Lynn','',''),(11360,'01907','Lynn','',''),(11361,'01907','Salem','',''),(11362,'01913','Amesbury Town','',''),(11363,'01937','Danvers','',''),(11364,'01940','Lynn','',''),(11365,'01940','Peabody','',''),(11366,'01940','Wakefield','',''),(11367,'01951','Newburyport','',''),(11368,'02038','Franklin Town','',''),(11369,'02054','Millis-clicquot','',''),(11370,'02090','Dedham','',''),(11371,'02090','Norwood','',''),(11372,'02126','Boston','',''),(11373,'02128','Winthrop Town','',''),(11374,'02129','Boston','',''),(11375,'02130','Boston','',''),(11376,'02131','Boston','',''),(11377,'02132','Boston','',''),(11378,'02134','Boston','',''),(11379,'02135','Boston','',''),(11380,'02136','Boston','',''),(11381,'02138','Belmont','',''),(11382,'02138','Somerville','',''),(11383,'02140','Somerville','',''),(11384,'02145','Medford','',''),(11385,'02148','Everett','',''),(11386,'02149','Chelsea','',''),(11387,'02151','Boston','',''),(11388,'02151','Chelsea','',''),(11389,'02152','Boston','',''),(11390,'02152','Winthrop Town','',''),(11391,'02155','Malden','',''),(11392,'02155','Somerville','',''),(11393,'02184','Braintree Town','',''),(11394,'02186','Quincy','',''),(11395,'02188','Weymouth Town','',''),(11396,'02189','Weymouth Town','',''),(11397,'02190','Weymouth Town','',''),(11398,'02191','Weymouth Town','',''),(11399,'02215','Brookline','',''),(11400,'02351','Brockton','',''),(11401,'02368','Holbrook','',''),(11402,'02457','Wellesley','',''),(11403,'02459','Newton','',''),(11404,'02460','Newton','',''),(11405,'02461','Newton','',''),(11406,'02462','Newton','',''),(11407,'02464','Newton','',''),(11408,'02465','Newton','',''),(11409,'02466','Newton','',''),(11410,'02467','Boston','',''),(11411,'02467','Brookline','',''),(11412,'02467','Newton','',''),(11413,'02468','Newton','',''),(11414,'02472','Belmont','',''),(11415,'02472','Cambridge','',''),(11416,'02472','Newton','',''),(11417,'02472','Waltham','',''),(11418,'02472','Watertown Town','',''),(11419,'02481','Wellesley','',''),(11420,'02492','Wellesley','',''),(11421,'02494','Needham','',''),(11422,'02532','Monument Beach','',''),(11423,'02532','Sagamore','',''),(11424,'02534','Pocasset','',''),(11425,'02538','Onset','',''),(11426,'02538','White Island Shores','',''),(11427,'02540','North Falmouth','',''),(11428,'02540','Woods Hole','',''),(11429,'02559','Monument Beach','',''),(11430,'02562','Sagamore','',''),(11431,'02563','East Sandwich','',''),(11432,'02563','Forestdale','',''),(11433,'02563','Sagamore','',''),(11434,'02571','West Wareham','',''),(11435,'02601','Barnstable Town','',''),(11436,'02601','West Yarmouth','',''),(11437,'02630','Barnstable Town','',''),(11438,'02632','Barnstable Town','',''),(11439,'02633','West Chatham','',''),(11440,'02635','Barnstable Town','',''),(11441,'02637','Barnstable Town','',''),(11442,'02638','East Dennis','',''),(11443,'02639','Northwest Harwich','',''),(11444,'02639','West Dennis','',''),(11445,'02642','North Eastham','',''),(11446,'02645','East Harwich','',''),(11447,'02645','Harwich Port','',''),(11448,'02645','Northwest Harwich','',''),(11449,'02646','Northwest Harwich','',''),(11450,'02647','Barnstable Town','',''),(11451,'02648','Barnstable Town','',''),(11452,'02655','Barnstable Town','',''),(11453,'02660','Dennis Port','',''),(11454,'02660','East Dennis','',''),(11455,'02660','West Dennis','',''),(11456,'02667','North Eastham','',''),(11457,'02668','Barnstable Town','',''),(11458,'02671','Dennis Port','',''),(11459,'02671','Northwest Harwich','',''),(11460,'02672','Barnstable Town','',''),(11461,'02673','Barnstable Town','',''),(11462,'02673','South Yarmouth','',''),(11463,'02675','Barnstable Town','',''),(11464,'02718','Taunton','',''),(11465,'02743','New Bedford','',''),(11466,'02747','Fall River','',''),(11467,'02747','New Bedford','',''),(11468,'02748','New Bedford','',''),(11469,'02767','Taunton','',''),(11470,'02790','Fall River','',''),(11471,'02818','Warwick','',''),(11472,'02830','Pascoag','',''),(11473,'02831','Cranston','',''),(11474,'02840','Newport East','',''),(11475,'02842','Newport East','',''),(11476,'02860','East Providence','',''),(11477,'02860','Providence','',''),(11478,'02861','Attleboro','',''),(11479,'02863','Pawtucket','',''),(11480,'02879','Kingston','',''),(11481,'02893','Warwick','',''),(11482,'02905','Cranston','',''),(11483,'02907','Cranston','',''),(11484,'02909','Cranston','',''),(11485,'02910','Providence','',''),(11486,'02911','Providence','',''),(11487,'02915','East Providence','',''),(11488,'02916','East Providence','',''),(11489,'02917','Greenville','',''),(11490,'02919','Providence','',''),(11491,'02920','Providence','',''),(11492,'03031','Milford','',''),(11493,'03036','Derry','',''),(11494,'03104','South Hooksett','',''),(11495,'03106','South Hooksett','',''),(11496,'03253','Laconia','',''),(11497,'03755','Lebanon','',''),(11498,'03784','Lebanon','',''),(11499,'03813','North Conway','',''),(11500,'03845','North Conway','',''),(11501,'03847','North Conway','',''),(11502,'03903','South Eliot','',''),(11503,'03909','Cape Neddick','',''),(11504,'03909','York Harbor','',''),(11505,'03910','Cape Neddick','',''),(11506,'04006','Biddeford','',''),(11507,'04019','Portland','',''),(11508,'04048','Lake Arrowhead','',''),(11509,'04050','Portland','',''),(11510,'04057','Bridgton','',''),(11511,'04061','Lake Arrowhead','',''),(11512,'04063','Old Orchard Beach','',''),(11513,'04083','Sanford','',''),(11514,'04084','Steep Falls','',''),(11515,'04107','South Portland','',''),(11516,'04108','Portland','',''),(11517,'04258','Auburn','',''),(11518,'04276','Mexico','',''),(11519,'04344','Hallowell','',''),(11520,'04345','Farmingdale','',''),(11521,'04359','Gardiner','',''),(11522,'04401','Old Town','',''),(11523,'04426','Dover-foxcroft','',''),(11524,'04444','Bangor','',''),(11525,'04489','Old Town','',''),(11526,'04671','Calais','',''),(11527,'04992','Farmington','',''),(11528,'05001','Quechee','',''),(11529,'05048','North Hartland','',''),(11530,'05101','Saxtons River','',''),(11531,'05142','Proctorsville','',''),(11532,'05156','North Springfield','',''),(11533,'05255','Manchester','',''),(11534,'05401','South Burlington','',''),(11535,'05446','Winooski','',''),(11536,'05482','South Burlington','',''),(11537,'05641','Websterville','',''),(11538,'05678','Graniteville','',''),(11539,'05736','Rutland','',''),(11540,'05736','West Rutland','',''),(11541,'05819','St. Johnsbury','',''),(11542,'05903','Beecher Falls','',''),(11543,'06013','Bristol','',''),(11544,'06042','East Hartford','',''),(11545,'06057','New Hartford Center','',''),(11546,'06061','New Hartford Center','',''),(11547,'06062','Bristol','',''),(11548,'06070','Weatogue','',''),(11549,'06095','Hartford','',''),(11550,'06095','Windsor Locks','',''),(11551,'06098','New Hartford Center','',''),(11552,'06105','West Hartford','',''),(11553,'06110','Hartford','',''),(11554,'06117','Hartford','',''),(11555,'06226','South Windham','',''),(11556,'06239','Wauregan','',''),(11557,'06255','Quinebaug','',''),(11558,'06268','Storrs','',''),(11559,'06269','Storrs','',''),(11560,'06277','Putnam','',''),(11561,'06334','Norwich','',''),(11562,'06353','Oxoboxo River','',''),(11563,'06354','Wauregan','',''),(11564,'06374','Wauregan','',''),(11565,'06375','New London','',''),(11566,'06380','Norwich','',''),(11567,'06382','Oxoboxo River','',''),(11568,'06389','Norwich','',''),(11569,'06409','Essex Village','',''),(11570,'06417','Deep River Center','',''),(11571,'06418','Ansonia','',''),(11572,'06426','Essex Village','',''),(11573,'06460','Milford City (balance), Ct','',''),(11574,'06461','Milford City (balance), Ct','',''),(11575,'06473','East Haven','',''),(11576,'06512','New Haven','',''),(11577,'06513','East Haven','',''),(11578,'06517','New Haven','',''),(11579,'06607','Stratford','',''),(11580,'06611','Bridgeport','',''),(11581,'06611','Stratford','',''),(11582,'06708','Oakville','',''),(11583,'06716','Waterbury','',''),(11584,'06751','Bethlehem Village','',''),(11585,'06759','Bantam','',''),(11586,'06759','Torrington','',''),(11587,'06770','Waterbury','',''),(11588,'06777','New Preston','',''),(11589,'06791','Northwest Harwinton','',''),(11590,'06794','New Preston','',''),(11591,'06795','Oakville','',''),(11592,'06804','Danbury','',''),(11593,'06810','Bethel','',''),(11594,'06830','Cos Cob','',''),(11595,'06831','Stamford','',''),(11596,'06870','Riverside','',''),(11597,'06878','Old Greenwich','',''),(11598,'06880','Norwalk','',''),(11599,'06902','Old Greenwich','',''),(11600,'07001','Port Reading','',''),(11601,'07002','Jersey City','',''),(11602,'07003','Upper Montclair','',''),(11603,'07006','Essex Fells','',''),(11604,'07008','Avenel','',''),(11605,'07008','Port Reading','',''),(11606,'07014','Passaic','',''),(11607,'07017','Newark','',''),(11608,'07024','Palisades Park','',''),(11609,'07035','Kinnelon','',''),(11610,'07039','Short Hills','',''),(11611,'07041','Short Hills','',''),(11612,'07042','Upper Montclair','',''),(11613,'07043','Clifton','',''),(11614,'07043','Upper Montclair','',''),(11615,'07055','Clifton','',''),(11616,'07064','Woodbridge','',''),(11617,'07067','Iselin','',''),(11618,'07075','Wood-ridge','',''),(11619,'07076','Plainfield','',''),(11620,'07077','Port Reading','',''),(11621,'07083','Elizabeth','',''),(11622,'07086','Hoboken','',''),(11623,'07087','Jersey City','',''),(11624,'07092','Westfield','',''),(11625,'07095','Avenel','',''),(11626,'07095','Fords','',''),(11627,'07107','East Orange','',''),(11628,'07110','Clifton','',''),(11629,'07111','Newark','',''),(11630,'07405','Kinnelon','',''),(11631,'07418','Vernon Valley','',''),(11632,'07420','Bloomingdale','',''),(11633,'07420','Wanaque','',''),(11634,'07422','Highland Lake','',''),(11635,'07423','Ho-ho-kus','',''),(11636,'07424','Woodland Park','',''),(11637,'07430','Ramsey','',''),(11638,'07446','Allendale','',''),(11639,'07458','Upper Saddle River','',''),(11640,'07461','Vernon Valley','',''),(11641,'07462','Highland Lake','',''),(11642,'07465','Bloomingdale','',''),(11643,'07465','Ringwood','',''),(11644,'07470','Totowa','',''),(11645,'07481','Franklin Lakes','',''),(11646,'07481','Waldwick','',''),(11647,'07508','Hawthorne','',''),(11648,'07508','North Haledon','',''),(11649,'07601','River Edge','',''),(11650,'07604','Teterboro','',''),(11651,'07605','Fort Lee','',''),(11652,'07608','Moonachie','',''),(11653,'07621','Dumont','',''),(11654,'07632','Englewood','',''),(11655,'07644','Maywood','',''),(11656,'07648','Northvale','',''),(11657,'07656','Hillsdale','',''),(11658,'07656','Montvale','',''),(11659,'07670','Bergenfield','',''),(11660,'07670','Cresskill','',''),(11661,'07675','Emerson','',''),(11662,'07703','Eatontown','',''),(11663,'07703','Oceanport','',''),(11664,'07704','Little Silver','',''),(11665,'07717','Avon-by-the-sea','',''),(11666,'07718','Port Monmouth','',''),(11667,'07719','Allenwood','',''),(11668,'07748','Keansburg','',''),(11669,'07748','Lincroft','',''),(11670,'07748','Port Monmouth','',''),(11671,'07762','Spring Lake Heights','',''),(11672,'07801','Wharton','',''),(11673,'07821','Hopatcong','',''),(11674,'07821','Johnsonburg','',''),(11675,'07825','Johnsonburg','',''),(11676,'07828','Netcong','',''),(11677,'07834','White Meadow Lake','',''),(11678,'07836','Budd Lake','',''),(11679,'07836','Succasunna','',''),(11680,'07838','Vienna','',''),(11681,'07840','Vienna','',''),(11682,'07849','Hopatcong','',''),(11683,'07850','Mount Arlington','',''),(11684,'07852','Kenvil','',''),(11685,'07866','Dover','',''),(11686,'07866','White Meadow Lake','',''),(11687,'07874','Hopatcong','',''),(11688,'07876','Kenvil','',''),(11689,'07882','Broadway','',''),(11690,'07885','White Meadow Lake','',''),(11691,'07901','New Providence','',''),(11692,'07920','Martinsville','',''),(11693,'07922','New Providence','',''),(11694,'07931','Bernardsville','',''),(11695,'07931','Peapack And Gladstone','',''),(11696,'07934','Peapack And Gladstone','',''),(11697,'07940','Florham Park','',''),(11698,'07960','Florham Park','',''),(11699,'07961','Florham Park','',''),(11700,'07977','Peapack And Gladstone','',''),(11701,'08002','Cherry Hill Mall','',''),(11702,'08003','Lawnside','',''),(11703,'08003','Springdale','',''),(11704,'08005','Ocean Acres','',''),(11705,'08007','Haddon Heights','',''),(11706,'08007','Runnemede','',''),(11707,'08008','Barnegat Light','',''),(11708,'08008','North Beach Haven','',''),(11709,'08012','Glendora','',''),(11710,'08016','Roebling','',''),(11711,'08021','Lindenwold','',''),(11712,'08022','Juliustown','',''),(11713,'08023','Carneys Point','',''),(11714,'08023','Pennsville','',''),(11715,'08028','Clayton','',''),(11716,'08028','Richwood','',''),(11717,'08033','Barrington','',''),(11718,'08033','Haddon Heights','',''),(11719,'08034','Cherry Hill Mall','',''),(11720,'08034','Kingston Estates','',''),(11721,'08034','Springdale','',''),(11722,'08035','Barrington','',''),(11723,'08037','Elwood','',''),(11724,'08049','Somerdale','',''),(11725,'08050','Ocean Acres','',''),(11726,'08054','Moorestown-lenola','',''),(11727,'08057','Moorestown-lenola','',''),(11728,'08062','Richwood','',''),(11729,'08069','Carneys Point','',''),(11730,'08070','Carneys Point','',''),(11731,'08071','Glassboro','',''),(11732,'08071','Richwood','',''),(11733,'08079','Alloway','',''),(11734,'08079','Hancocks Bridge','',''),(11735,'08079','Quinton','',''),(11736,'08080','Richwood','',''),(11737,'08090','Oak Valley','',''),(11738,'08094','Clayton','',''),(11739,'08096','Woodbury Heights','',''),(11740,'08098','Alloway','',''),(11741,'08103','Collingswood','',''),(11742,'08104','Gloucester City','',''),(11743,'08107','Collingswood','',''),(11744,'08109','Camden','',''),(11745,'08109','Cherry Hill Mall','',''),(11746,'08110','Camden','',''),(11747,'08201','Pleasantville','',''),(11748,'08203','Atlantic City','',''),(11749,'08204','Cape May Point','',''),(11750,'08204','Villas','',''),(11751,'08205','Port Republic','',''),(11752,'08215','Elwood','',''),(11753,'08221','Somers Point','',''),(11754,'08270','Estell Manor','',''),(11755,'08302','Alloway','',''),(11756,'08302','Hancocks Bridge','',''),(11757,'08302','Rosenhayn','',''),(11758,'08317','Estell Manor','',''),(11759,'08326','Buena','',''),(11760,'08330','Estell Manor','',''),(11761,'08332','Vineland','',''),(11762,'08341','Buena','',''),(11763,'08343','Richwood','',''),(11764,'08344','Vineland','',''),(11765,'08360','Buena','',''),(11766,'08360','Millville','',''),(11767,'08406','Atlantic City','',''),(11768,'08505','Florence','',''),(11769,'08512','Princeton Meadows','',''),(11770,'08518','Roebling','',''),(11771,'08535','Roosevelt','',''),(11772,'08536','Princeton Meadows','',''),(11773,'08540','Kendall Park','',''),(11774,'08540','Kingston','',''),(11775,'08562','Fort Dix','',''),(11776,'08562','Mcguire Afb','',''),(11777,'08610','Yardville','',''),(11778,'08619','Hamilton Square','',''),(11779,'08619','Mercerville','',''),(11780,'08620','Yardville','',''),(11781,'08641','Fort Dix','',''),(11782,'08641','Mcguire Afb','',''),(11783,'08690','Hamilton Square','',''),(11784,'08690','Mercerville','',''),(11785,'08691','Hamilton Square','',''),(11786,'08691','Yardville','',''),(11787,'08721','Ocean Gate','',''),(11788,'08721','Pine Beach','',''),(11789,'08724','Allenwood','',''),(11790,'08724','Point Pleasant','',''),(11791,'08742','Point Pleasant','',''),(11792,'08753','Island Heights','',''),(11793,'08757','Holiday City-berkeley','',''),(11794,'08805','Martinsville','',''),(11795,'08807','Bradley Gardens','',''),(11796,'08807','Martinsville','',''),(11797,'08807','Somerville','',''),(11798,'08812','Plainfield','',''),(11799,'08820','South Plainfield','',''),(11800,'08830','Colonia','',''),(11801,'08830','Fords','',''),(11802,'08830','Woodbridge','',''),(11803,'08840','Fords','',''),(11804,'08844','Somerville','',''),(11805,'08852','Dayton','',''),(11806,'08852','Kendall Park','',''),(11807,'08857','Sayreville','',''),(11808,'08859','Sayreville','',''),(11809,'08861','Woodbridge','',''),(11810,'08863','Woodbridge','',''),(11811,'08873','Franklin Park','',''),(11812,'08879','Sayreville','',''),(11813,'08886','Greenwich','',''),(11814,'10301','New York','',''),(11815,'10302','New York','',''),(11816,'10303','New York','',''),(11817,'10304','New York','',''),(11818,'10305','New York','',''),(11819,'10306','New York','',''),(11820,'10307','New York','',''),(11821,'10308','New York','',''),(11822,'10309','New York','',''),(11823,'10310','New York','',''),(11824,'10311','New York','',''),(11825,'10312','New York','',''),(11826,'10314','New York','',''),(11827,'10451','New York','',''),(11828,'10452','New York','',''),(11829,'10453','New York','',''),(11830,'10454','New York','',''),(11831,'10455','New York','',''),(11832,'10456','New York','',''),(11833,'10457','New York','',''),(11834,'10458','New York','',''),(11835,'10459','New York','',''),(11836,'10460','New York','',''),(11837,'10461','New York','',''),(11838,'10462','New York','',''),(11839,'10463','New York','',''),(11840,'10464','New York','',''),(11841,'10465','New York','',''),(11842,'10466','New York','',''),(11843,'10467','New York','',''),(11844,'10468','New York','',''),(11845,'10469','New York','',''),(11846,'10470','New York','',''),(11847,'10471','New York','',''),(11848,'10472','New York','',''),(11849,'10473','New York','',''),(11850,'10474','New York','',''),(11851,'10475','New York','',''),(11852,'10503','Irvington','',''),(11853,'10510','Ossining','',''),(11854,'10510','Pleasantville','',''),(11855,'10520','Croton-on-hudson','',''),(11856,'10520','Montrose','',''),(11857,'10528','Mamaroneck','',''),(11858,'10528','Rye','',''),(11859,'10532','Thornwood','',''),(11860,'10533','Tarrytown','',''),(11861,'10535','Jefferson Valley-yorktown','',''),(11862,'10536','Goldens Bridge','',''),(11863,'10538','Mamaroneck','',''),(11864,'10538','New Rochelle','',''),(11865,'10547','Lake Mohegan','',''),(11866,'10547','Shrub Oak','',''),(11867,'10548','Verplanck','',''),(11868,'10562','Briarcliff Manor','',''),(11869,'10567','Peekskill','',''),(11870,'10570','Thornwood','',''),(11871,'10573','Rye','',''),(11872,'10577','Harrison','',''),(11873,'10580','Harrison','',''),(11874,'10580','Mamaroneck','',''),(11875,'10583','Ardsley','',''),(11876,'10583','Eastchester','',''),(11877,'10583','New Rochelle','',''),(11878,'10583','Yonkers','',''),(11879,'10588','Jefferson Valley-yorktown','',''),(11880,'10588','Lake Mohegan','',''),(11881,'10591','Irvington','',''),(11882,'10598','Jefferson Valley-yorktown','',''),(11883,'10604','Harrison','',''),(11884,'10604','White Plains','',''),(11885,'10607','Elmsford','',''),(11886,'10701','Hastings-on-hudson','',''),(11887,'10706','Hastings-on-hudson','',''),(11888,'10706','Yonkers','',''),(11889,'10707','Eastchester','',''),(11890,'10707','Yonkers','',''),(11891,'10708','Eastchester','',''),(11892,'10708','Mount Vernon','',''),(11893,'10708','Tuckahoe','',''),(11894,'10708','Yonkers','',''),(11895,'10709','Tuckahoe','',''),(11896,'10803','New Rochelle','',''),(11897,'10917','Woodbury','',''),(11898,'10920','New City','',''),(11899,'10920','Valley Cottage','',''),(11900,'10923','Haverstraw','',''),(11901,'10923','Mount Ivy','',''),(11902,'10923','Thiells','',''),(11903,'10923','West Haverstraw','',''),(11904,'10926','Woodbury','',''),(11905,'10928','Fort Montgomery','',''),(11906,'10928','West Point','',''),(11907,'10930','Woodbury','',''),(11908,'10941','Scotchtown','',''),(11909,'10950','Harriman','',''),(11910,'10950','Kiryas Joel','',''),(11911,'10950','Woodbury','',''),(11912,'10952','Spring Valley','',''),(11913,'10954','New City','',''),(11914,'10954','Pearl River','',''),(11915,'10954','Spring Valley','',''),(11916,'10956','Nanuet','',''),(11917,'10960','Blauvelt','',''),(11918,'10960','Orangeburg','',''),(11919,'10960','Piermont','',''),(11920,'10960','Valley Cottage','',''),(11921,'10962','Blauvelt','',''),(11922,'10962','Pearl River','',''),(11923,'10962','Tappan','',''),(11924,'10964','Tappan','',''),(11925,'10965','Nanuet','',''),(11926,'10970','Mount Ivy','',''),(11927,'10976','Orangeburg','',''),(11928,'10976','Piermont','',''),(11929,'10977','Monsey','',''),(11930,'10977','Nanuet','',''),(11931,'10984','Mount Ivy','',''),(11932,'10989','Congers','',''),(11933,'10989','Nyack','',''),(11934,'10994','Nanuet','',''),(11935,'10994','Pearl River','',''),(11936,'10994','Valley Cottage','',''),(11937,'10996','Highland Falls','',''),(11938,'11001','Elmont','',''),(11939,'11001','Franklin Square','',''),(11940,'11001','New York','',''),(11941,'11001','North New Hyde Park','',''),(11942,'11003','Franklin Square','',''),(11943,'11003','New York','',''),(11944,'11004','New York','',''),(11945,'11005','New York','',''),(11946,'11020','Lake Success','',''),(11947,'11020','Manhasset','',''),(11948,'11020','University Gardens','',''),(11949,'11021','Great Neck Plaza','',''),(11950,'11021','Lake Success','',''),(11951,'11021','Manhasset','',''),(11952,'11021','University Gardens','',''),(11953,'11023','Kings Point','',''),(11954,'11024','Kings Point','',''),(11955,'11040','Garden City','',''),(11956,'11040','New York','',''),(11957,'11040','North New Hyde Park','',''),(11958,'11042','Lake Success','',''),(11959,'11042','North New Hyde Park','',''),(11960,'11096','Lawrence','',''),(11961,'11101','New York','',''),(11962,'11102','New York','',''),(11963,'11103','New York','',''),(11964,'11104','New York','',''),(11965,'11105','New York','',''),(11966,'11106','New York','',''),(11967,'11109','New York','',''),(11968,'11201','New York','',''),(11969,'11203','New York','',''),(11970,'11204','New York','',''),(11971,'11205','New York','',''),(11972,'11206','New York','',''),(11973,'11207','New York','',''),(11974,'11208','New York','',''),(11975,'11209','New York','',''),(11976,'11210','New York','',''),(11977,'11211','New York','',''),(11978,'11212','New York','',''),(11979,'11213','New York','',''),(11980,'11214','New York','',''),(11981,'11215','New York','',''),(11982,'11216','New York','',''),(11983,'11217','New York','',''),(11984,'11218','New York','',''),(11985,'11219','New York','',''),(11986,'11220','New York','',''),(11987,'11221','New York','',''),(11988,'11222','New York','',''),(11989,'11223','New York','',''),(11990,'11224','New York','',''),(11991,'11225','New York','',''),(11992,'11226','New York','',''),(11993,'11228','New York','',''),(11994,'11229','New York','',''),(11995,'11230','New York','',''),(11996,'11231','New York','',''),(11997,'11232','New York','',''),(11998,'11233','New York','',''),(11999,'11234','New York','',''),(12000,'11235','New York','',''),(12001,'11236','New York','',''),(12002,'11237','New York','',''),(12003,'11238','New York','',''),(12004,'11239','New York','',''),(12005,'11351','New York','',''),(12006,'11354','New York','',''),(12007,'11355','New York','',''),(12008,'11356','New York','',''),(12009,'11357','New York','',''),(12010,'11358','New York','',''),(12011,'11359','New York','',''),(12012,'11360','New York','',''),(12013,'11361','New York','',''),(12014,'11362','New York','',''),(12015,'11363','New York','',''),(12016,'11364','New York','',''),(12017,'11365','New York','',''),(12018,'11366','New York','',''),(12019,'11367','New York','',''),(12020,'11368','New York','',''),(12021,'11369','New York','',''),(12022,'11370','New York','',''),(12023,'11371','New York','',''),(12024,'11372','New York','',''),(12025,'11373','New York','',''),(12026,'11374','New York','',''),(12027,'11375','New York','',''),(12028,'11377','New York','',''),(12029,'11378','New York','',''),(12030,'11379','New York','',''),(12031,'11385','New York','',''),(12032,'11411','New York','',''),(12033,'11412','New York','',''),(12034,'11413','New York','',''),(12035,'11414','New York','',''),(12036,'11415','New York','',''),(12037,'11416','New York','',''),(12038,'11417','New York','',''),(12039,'11418','New York','',''),(12040,'11419','New York','',''),(12041,'11420','New York','',''),(12042,'11421','New York','',''),(12043,'11422','New York','',''),(12044,'11423','New York','',''),(12045,'11424','New York','',''),(12046,'11425','New York','',''),(12047,'11426','New York','',''),(12048,'11427','New York','',''),(12049,'11428','New York','',''),(12050,'11429','New York','',''),(12051,'11430','New York','',''),(12052,'11432','New York','',''),(12053,'11433','New York','',''),(12054,'11434','New York','',''),(12055,'11435','New York','',''),(12056,'11436','New York','',''),(12057,'11451','New York','',''),(12058,'11501','Garden City','',''),(12059,'11501','Williston Park','',''),(12060,'11507','Roslyn Heights','',''),(12061,'11510','Freeport','',''),(12062,'11510','Oceanside','',''),(12063,'11510','Rockville Centre','',''),(12064,'11516','Woodmere','',''),(12065,'11520','Merrick','',''),(12066,'11520','Roosevelt','',''),(12067,'11530','East Garden City','',''),(12068,'11530','East Meadow','',''),(12069,'11530','Mineola','',''),(12070,'11542','Glen Head','',''),(12071,'11545','Brookville','',''),(12072,'11545','Glenwood Landing','',''),(12073,'11548','Brookville','',''),(12074,'11548','East Hills','',''),(12075,'11548','Glenwood Landing','',''),(12076,'11548','Old Westbury','',''),(12077,'11549','East Garden City','',''),(12078,'11550','East Garden City','',''),(12079,'11550','Garden City','',''),(12080,'11550','West Hempstead','',''),(12081,'11552','Garden City','',''),(12082,'11552','Hempstead','',''),(12083,'11553','East Garden City','',''),(12084,'11553','Hempstead','',''),(12085,'11557','East Rockaway','',''),(12086,'11557','Valley Stream','',''),(12087,'11557','Woodmere','',''),(12088,'11559','Cedarhurst','',''),(12089,'11559','Inwood','',''),(12090,'11559','Woodmere','',''),(12091,'11560','Glen Cove','',''),(12092,'11560','Mill Neck','',''),(12093,'11563','East Rockaway','',''),(12094,'11563','Hewlett','',''),(12095,'11563','Malverne','',''),(12096,'11563','Rockville Centre','',''),(12097,'11565','Lynbrook','',''),(12098,'11566','North Bellmore','',''),(12099,'11568','Brookville','',''),(12100,'11570','Baldwin','',''),(12101,'11570','Oceanside','',''),(12102,'11575','Baldwin','',''),(12103,'11576','East Hills','',''),(12104,'11576','Glenwood Landing','',''),(12105,'11577','Albertson','',''),(12106,'11577','East Hills','',''),(12107,'11579','Glen Head','',''),(12108,'11580','Franklin Square','',''),(12109,'11580','Lynbrook','',''),(12110,'11580','Malverne','',''),(12111,'11581','Woodmere','',''),(12112,'11590','Carle Place','',''),(12113,'11590','East Garden City','',''),(12114,'11590','Hicksville','',''),(12115,'11590','Jericho','',''),(12116,'11596','Mineola','',''),(12117,'11598','Hewlett','',''),(12118,'11691','New York','',''),(12119,'11692','New York','',''),(12120,'11693','New York','',''),(12121,'11694','New York','',''),(12122,'11697','New York','',''),(12123,'11701','Copiague','',''),(12124,'11701','North Amityville','',''),(12125,'11702','North Babylon','',''),(12126,'11702','West Babylon','',''),(12127,'11703','Deer Park','',''),(12128,'11704','Babylon','',''),(12129,'11704','North Babylon','',''),(12130,'11704','Wyandanch','',''),(12131,'11706','Brightwaters','',''),(12132,'11706','Islip','',''),(12133,'11706','West Islip','',''),(12134,'11710','North Bellmore','',''),(12135,'11710','Wantagh','',''),(12136,'11713','Brookhaven','',''),(12137,'11713','East Patchogue','',''),(12138,'11713','North Bellport','',''),(12139,'11714','Levittown','',''),(12140,'11714','Plainview','',''),(12141,'11715','Bayport','',''),(12142,'11716','Sayville','',''),(12143,'11717','Central Islip','',''),(12144,'11719','North Bellport','',''),(12145,'11719','Yaphank','',''),(12146,'11720','Selden','',''),(12147,'11720','Terryville','',''),(12148,'11721','Greenlawn','',''),(12149,'11721','Huntington','',''),(12150,'11722','Hauppauge','',''),(12151,'11722','Islip','',''),(12152,'11724','Huntington','',''),(12153,'11725','Smithtown','',''),(12154,'11726','North Amityville','',''),(12155,'11729','Wyandanch','',''),(12156,'11730','Great River','',''),(12157,'11731','Commack','',''),(12158,'11731','Fort Salonga','',''),(12159,'11732','Oyster Bay','',''),(12160,'11733','Setauket-east Setauket','',''),(12161,'11733','Stony Brook','',''),(12162,'11733','Stony Brook University','',''),(12163,'11735','Bethpage','',''),(12164,'11735','Old Bethpage','',''),(12165,'11735','South Farmingdale','',''),(12166,'11738','Centereach','',''),(12167,'11738','Coram','',''),(12168,'11738','Holtsville','',''),(12169,'11738','Medford','',''),(12170,'11738','Selden','',''),(12171,'11740','East Northport','',''),(12172,'11740','Huntington','',''),(12173,'11741','Bohemia','',''),(12174,'11741','Holtsville','',''),(12175,'11743','Cold Spring Harbor','',''),(12176,'11743','Greenlawn','',''),(12177,'11743','Huntington Station','',''),(12178,'11746','Deer Park','',''),(12179,'11746','Melville','',''),(12180,'11749','Central Islip','',''),(12181,'11749','Hauppauge','',''),(12182,'11752','Central Islip','',''),(12183,'11753','Old Westbury','',''),(12184,'11753','Syosset','',''),(12185,'11754','Commack','',''),(12186,'11754','Fort Salonga','',''),(12187,'11754','Smithtown','',''),(12188,'11755','Centereach','',''),(12189,'11755','St. James','',''),(12190,'11756','Hicksville','',''),(12191,'11757','Copiague','',''),(12192,'11757','West Babylon','',''),(12193,'11758','South Farmingdale','',''),(12194,'11763','Coram','',''),(12195,'11763','Holtsville','',''),(12196,'11763','Middle Island','',''),(12197,'11763','North Bellport','',''),(12198,'11763','Yaphank','',''),(12199,'11764','Rocky Point','',''),(12200,'11766','Coram','',''),(12201,'11766','Miller Place','',''),(12202,'11766','Terryville','',''),(12203,'11767','Ronkonkoma','',''),(12204,'11768','Centerport','',''),(12205,'11768','East Northport','',''),(12206,'11768','Fort Salonga','',''),(12207,'11769','Great River','',''),(12208,'11769','Sayville','',''),(12209,'11769','West Sayville','',''),(12210,'11771','East Norwich','',''),(12211,'11771','Mill Neck','',''),(12212,'11772','Bayport','',''),(12213,'11772','Blue Point','',''),(12214,'11772','East Patchogue','',''),(12215,'11772','Holtsville','',''),(12216,'11772','Medford','',''),(12217,'11772','North Bellport','',''),(12218,'11776','Centereach','',''),(12219,'11776','Coram','',''),(12220,'11776','Mount Sinai','',''),(12221,'11776','Selden','',''),(12222,'11776','Setauket-east Setauket','',''),(12223,'11776','Terryville','',''),(12224,'11777','Mount Sinai','',''),(12225,'11777','Setauket-east Setauket','',''),(12226,'11779','Centereach','',''),(12227,'11779','Farmingville','',''),(12228,'11779','Hauppauge','',''),(12229,'11779','Holbrook','',''),(12230,'11779','Holtsville','',''),(12231,'11779','Islandia','',''),(12232,'11780','Nesconset','',''),(12233,'11780','St. James','',''),(12234,'11780','Smithtown','',''),(12235,'11780','Stony Brook','',''),(12236,'11783','Levittown','',''),(12237,'11784','Centereach','',''),(12238,'11784','Coram','',''),(12239,'11784','Farmingville','',''),(12240,'11786','East Shoreham','',''),(12241,'11786','Ridge','',''),(12242,'11787','Commack','',''),(12243,'11787','Hauppauge','',''),(12244,'11787','Nesconset','',''),(12245,'11787','St. James','',''),(12246,'11788','Brentwood','',''),(12247,'11788','Commack','',''),(12248,'11788','Islandia','',''),(12249,'11789','Rocky Point','',''),(12250,'11790','Setauket-east Setauket','',''),(12251,'11790','Stony Brook University','',''),(12252,'11791','Hicksville','',''),(12253,'11791','Woodbury','',''),(12254,'11792','East Shoreham','',''),(12255,'11792','Ridge','',''),(12256,'11793','Levittown','',''),(12257,'11793','North Bellmore','',''),(12258,'11793','Seaford','',''),(12259,'11794','Stony Brook University','',''),(12260,'11796','Sayville','',''),(12261,'11797','Plainview','',''),(12262,'11798','Deer Park','',''),(12263,'11798','West Babylon','',''),(12264,'11801','Bethpage','',''),(12265,'11801','Jericho','',''),(12266,'11803','Bethpage','',''),(12267,'11803','Old Bethpage','',''),(12268,'11901','Aquebogue','',''),(12269,'11901','Calverton','',''),(12270,'11901','East Quogue','',''),(12271,'11901','Hampton Bays','',''),(12272,'11901','Jamesport','',''),(12273,'11932','Sagaponack','',''),(12274,'11933','Eastport','',''),(12275,'11933','Wading River','',''),(12276,'11934','East Moriches','',''),(12277,'11934','Moriches','',''),(12278,'11935','Mattituck','',''),(12279,'11937','Amagansett','',''),(12280,'11937','Springs','',''),(12281,'11937','Wainscott','',''),(12282,'11940','Eastport','',''),(12283,'11941','East Moriches','',''),(12284,'11941','Remsenburg-speonk','',''),(12285,'11942','Quogue','',''),(12286,'11944','Southold','',''),(12287,'11946','East Quogue','',''),(12288,'11948','Jamesport','',''),(12289,'11949','Calverton','',''),(12290,'11949','Mastic','',''),(12291,'11949','Shirley','',''),(12292,'11950','Mastic Beach','',''),(12293,'11950','Shirley','',''),(12294,'11951','Shirley','',''),(12295,'11952','Cutchogue','',''),(12296,'11952','Laurel','',''),(12297,'11953','Coram','',''),(12298,'11953','Miller Place','',''),(12299,'11953','Yaphank','',''),(12300,'11955','Center Moriches','',''),(12301,'11955','Manorville','',''),(12302,'11956','Cutchogue','',''),(12303,'11958','Southold','',''),(12304,'11959','East Quogue','',''),(12305,'11960','Remsenburg-speonk','',''),(12306,'11961','East Shoreham','',''),(12307,'11961','Rocky Point','',''),(12308,'11962','Bridgehampton','',''),(12309,'11963','Bridgehampton','',''),(12310,'11963','Noyack','',''),(12311,'11964','Shelter Island Heights','',''),(12312,'11965','Shelter Island','',''),(12313,'11967','Manorville','',''),(12314,'11967','Mastic','',''),(12315,'11967','Mastic Beach','',''),(12316,'11968','North Sea','',''),(12317,'11968','Noyack','',''),(12318,'11968','Water Mill','',''),(12319,'11970','Aquebogue','',''),(12320,'11970','Jamesport','',''),(12321,'11971','Peconic','',''),(12322,'11972','Eastport','',''),(12323,'11972','Remsenburg-speonk','',''),(12324,'11972','Westhampton','',''),(12325,'11976','Bridgehampton','',''),(12326,'11976','North Sea','',''),(12327,'11977','Remsenburg-speonk','',''),(12328,'11978','East Quogue','',''),(12329,'11978','Quogue','',''),(12330,'11978','Westhampton','',''),(12331,'11980','North Bellport','',''),(12332,'12008','East Glenville','',''),(12333,'12010','Hagaman','',''),(12334,'12018','West Sand Lake','',''),(12335,'12020','Saratoga Springs','',''),(12336,'12027','East Glenville','',''),(12337,'12068','Tribes Hill','',''),(12338,'12070','Tribes Hill','',''),(12339,'12078','Johnstown','',''),(12340,'12095','Gloversville','',''),(12341,'12108','Speculator','',''),(12342,'12118','Round Lake','',''),(12343,'12158','Ravena','',''),(12344,'12180','Poestenkill','',''),(12345,'12183','Green Island','',''),(12346,'12184','Niverville','',''),(12347,'12187','Cobleskill','',''),(12348,'12198','West Sand Lake','',''),(12349,'12204','Menands','',''),(12350,'12211','Menands','',''),(12351,'12302','East Glenville','',''),(12352,'12303','Rotterdam','',''),(12353,'12304','Rotterdam','',''),(12354,'12306','Rotterdam','',''),(12355,'12401','Hurley','',''),(12356,'12401','Port Ewen','',''),(12357,'12401','Rosendale Hamlet','',''),(12358,'12401','West Hurley','',''),(12359,'12409','Woodstock','',''),(12360,'12410','Pine Hill','',''),(12361,'12417','Port Ewen','',''),(12362,'12420','Ellenville','',''),(12363,'12433','West Hurley','',''),(12364,'12441','Pine Hill','',''),(12365,'12453','Malden-on-hudson','',''),(12366,'12469','Preston-potter Hollow','',''),(12367,'12472','Rosendale Hamlet','',''),(12368,'12472','Tillson','',''),(12369,'12477','Glasco','',''),(12370,'12477','Lake Katrine','',''),(12371,'12477','Malden-on-hudson','',''),(12372,'12486','Rosendale Hamlet','',''),(12373,'12487','Port Ewen','',''),(12374,'12487','Rifton','',''),(12375,'12498','West Hurley','',''),(12376,'12513','Claverack-red Mills','',''),(12377,'12518','Cornwall-on-hudson','',''),(12378,'12518','Firthcliffe','',''),(12379,'12520','Cornwall-on-hudson','',''),(12380,'12520','Firthcliffe','',''),(12381,'12534','Claverack-red Mills','',''),(12382,'12534','Philmont','',''),(12383,'12534','Stottville','',''),(12384,'12553','Beaver Dam Lake','',''),(12385,'12553','Firthcliffe','',''),(12386,'12561','Rifton','',''),(12387,'12561','Tillson','',''),(12388,'12566','Cragsmoor','',''),(12389,'12572','Rhinecliff','',''),(12390,'12577','Beaver Dam Lake','',''),(12391,'12577','Washingtonville','',''),(12392,'12723','Hortonville','',''),(12393,'12733','South Fallsburg','',''),(12394,'12734','Liberty','',''),(12395,'12747','South Fallsburg','',''),(12396,'12762','Smallwood','',''),(12397,'12786','Smallwood','',''),(12398,'12804','Glens Falls','',''),(12399,'12833','Saratoga Springs','',''),(12400,'12845','Warrensburg','',''),(12401,'12871','Victory','',''),(12402,'12884','Victory','',''),(12403,'12914','Fort Covington Hamlet','',''),(12404,'12918','Dannemora','',''),(12405,'12926','Fort Covington Hamlet','',''),(12406,'12935','Lyon Mountain','',''),(12407,'12937','Fort Covington Hamlet','',''),(12408,'12974','Mineville','',''),(12409,'12981','Redford','',''),(12410,'12998','Mineville','',''),(12411,'13031','Fairmount','',''),(12412,'13032','Oneida','',''),(12413,'13032','Wampsville','',''),(12414,'13033','Meridian','',''),(12415,'13034','Union Springs','',''),(12416,'13057','Minoa','',''),(12417,'13069','Minetto','',''),(12418,'13120','Syracuse','',''),(12419,'13126','Minetto','',''),(12420,'13156','Fair Haven','',''),(12421,'13204','Solvay','',''),(12422,'13205','Nedrow','',''),(12423,'13209','Fairmount','',''),(12424,'13209','Solvay','',''),(12425,'13211','Mattydale','',''),(12426,'13219','Fairmount','',''),(12427,'13219','Solvay','',''),(12428,'13308','Rome','',''),(12429,'13308','Sylvan Beach','',''),(12430,'13317','Palatine Bridge','',''),(12431,'13323','Clark Mills','',''),(12432,'13339','Nelliston','',''),(12433,'13409','Oneida','',''),(12434,'13413','Chadwicks','',''),(12435,'13413','New York Mills','',''),(12436,'13413','Utica','',''),(12437,'13416','Middleville','',''),(12438,'13421','Sherrill','',''),(12439,'13421','Wampsville','',''),(12440,'13428','Nelliston','',''),(12441,'13438','Prospect','',''),(12442,'13456','Chadwicks','',''),(12443,'13471','Rome','',''),(12444,'13478','Rome','',''),(12445,'13492','Clark Mills','',''),(12446,'13495','New York Mills','',''),(12447,'13495','Utica','',''),(12448,'13502','Yorkville','',''),(12449,'13603','Fort Drum','',''),(12450,'13605','Pierrepont Manor','',''),(12451,'13612','Felts Mills','',''),(12452,'13612','Fort Drum','',''),(12453,'13616','Fort Drum','',''),(12454,'13619','Deferiet','',''),(12455,'13619','Great Bend','',''),(12456,'13624','Fishers Landing','',''),(12457,'13625','Hannawa Falls','',''),(12458,'13637','Calcium','',''),(12459,'13640','Thousand Island Park','',''),(12460,'13656','Plessis','',''),(12461,'13661','Ellisburg','',''),(12462,'13661','Pierrepont Manor','',''),(12463,'13666','Cranberry Lake','',''),(12464,'13669','Morristown','',''),(12465,'13676','Hannawa Falls','',''),(12466,'13676','Parishville','',''),(12467,'13691','Plessis','',''),(12468,'13757','Davenport Center','',''),(12469,'13820','Davenport Center','',''),(12470,'13850','Binghamton University','',''),(12471,'13862','Glen Aubrey','',''),(12472,'13902','Binghamton University','',''),(12473,'14006','Lake Erie Beach','',''),(12474,'14009','Yorkshire','',''),(12475,'14024','Pike','',''),(12476,'14028','Newfane','',''),(12477,'14028','Olcott','',''),(12478,'14030','Yorkshire','',''),(12479,'14042','Yorkshire','',''),(12480,'14043','Cheektowaga','',''),(12481,'14066','Pike','',''),(12482,'14081','Farnham','',''),(12483,'14206','Cheektowaga','',''),(12484,'14206','West Seneca','',''),(12485,'14207','Tonawanda','',''),(12486,'14210','West Seneca','',''),(12487,'14211','Cheektowaga','',''),(12488,'14215','Cheektowaga','',''),(12489,'14217','Kenmore','',''),(12490,'14217','Tonawanda','',''),(12491,'14218','Lackawanna','',''),(12492,'14218','West Seneca','',''),(12493,'14219','Lackawanna','',''),(12494,'14220','West Seneca','',''),(12495,'14221','Cheektowaga','',''),(12496,'14223','Tonawanda','',''),(12497,'14224','Cheektowaga','',''),(12498,'14224','West Seneca','',''),(12499,'14225','Cheektowaga','',''),(12500,'14225','Depew','',''),(12501,'14226','Cheektowaga','',''),(12502,'14226','Eggertsville','',''),(12503,'14227','Cheektowaga','',''),(12504,'14228','University At Buffalo','',''),(12505,'14261','University At Buffalo','',''),(12506,'14432','Port Gibson','',''),(12507,'14454','Lakeville','',''),(12508,'14462','Scottsburg','',''),(12509,'14468','Hamlin','',''),(12510,'14487','Lakeville','',''),(12511,'14522','Port Gibson','',''),(12512,'14527','Dresden','',''),(12513,'14527','Keuka Park','',''),(12514,'14533','Retsof','',''),(12515,'14533','York Hamlet','',''),(12516,'14548','Manchester','',''),(12517,'14592','York Hamlet','',''),(12518,'14609','Brighton','',''),(12519,'14609','Irondequoit','',''),(12520,'14610','Brighton','',''),(12521,'14617','Irondequoit','',''),(12522,'14618','Brighton','',''),(12523,'14620','Brighton','',''),(12524,'14621','Irondequoit','',''),(12525,'14622','Irondequoit','',''),(12526,'14623','Brighton','',''),(12527,'14625','Brighton','',''),(12528,'14701','Celoron','',''),(12529,'14701','Falconer','',''),(12530,'14706','St. Bonaventure','',''),(12531,'14715','Richburg','',''),(12532,'14748','Salamanca','',''),(12533,'14757','Chautauqua','',''),(12534,'14760','St. Bonaventure','',''),(12535,'14760','Weston Mills','',''),(12536,'14770','Weston Mills','',''),(12537,'14778','St. Bonaventure','',''),(12538,'14788','Weston Mills','',''),(12539,'14803','Alfred','',''),(12540,'14813','Angelica','',''),(12541,'14838','Breesport','',''),(12542,'14845','Big Flats','',''),(12543,'14845','Pine Valley','',''),(12544,'14864','Pine Valley','',''),(12545,'14870','Coopers Plains','',''),(12546,'14870','Gang Mills','',''),(12547,'14891','Montour Falls','',''),(12548,'14903','Big Flats','',''),(12549,'14903','Elmira Heights','',''),(12550,'14903','West Elmira','',''),(12551,'14905','West Elmira','',''),(12552,'15001','Shippingport','',''),(12553,'15001','South Heights','',''),(12554,'15003','Leetsdale','',''),(12555,'15005','Conway','',''),(12556,'15009','Ohioville','',''),(12557,'15010','Ohioville','',''),(12558,'15012','Lynnwood-pricedale','',''),(12559,'15012','Webster','',''),(12560,'15015','Bradford Woods','',''),(12561,'15019','Joffre','',''),(12562,'15021','Atlasburg','',''),(12563,'15021','Joffre','',''),(12564,'15021','Langeloth','',''),(12565,'15021','Slovan','',''),(12566,'15024','Harwick','',''),(12567,'15024','Russellton','',''),(12568,'15025','Jefferson Hills','',''),(12569,'15025','West Mifflin','',''),(12570,'15035','East Mckeesport','',''),(12571,'15043','Shippingport','',''),(12572,'15044','Allison Park','',''),(12573,'15044','Bairdford','',''),(12574,'15044','Bakerstown','',''),(12575,'15050','Shippingport','',''),(12576,'15052','Midland','',''),(12577,'15052','Ohioville','',''),(12578,'15057','Cecil-bishop','',''),(12579,'15057','Midway','',''),(12580,'15057','Muse','',''),(12581,'15057','Southview','',''),(12582,'15057','Sturgeon','',''),(12583,'15059','Ohioville','',''),(12584,'15061','Shippingport','',''),(12585,'15063','Van Voorhis','',''),(12586,'15068','Murrysville','',''),(12587,'15068','Plum','',''),(12588,'15071','Sturgeon','',''),(12589,'15072','Lynnwood-pricedale','',''),(12590,'15084','Brackenridge','',''),(12591,'15085','Level Green','',''),(12592,'15085','Monroeville','',''),(12593,'15086','Fernway','',''),(12594,'15088','Jefferson Hills','',''),(12595,'15089','Wyano','',''),(12596,'15090','Bradford Woods','',''),(12597,'15101','Glenshaw','',''),(12598,'15104','North Braddock','',''),(12599,'15104','Swissvale','',''),(12600,'15106','Pittsburgh','',''),(12601,'15112','North Braddock','',''),(12602,'15116','Allison Park','',''),(12603,'15120','Munhall','',''),(12604,'15120','Pittsburgh','',''),(12605,'15122','Munhall','',''),(12606,'15129','Bethel Park','',''),(12607,'15129','Jefferson Hills','',''),(12608,'15129','South Park Township','',''),(12609,'15131','White Oak','',''),(12610,'15132','Port Vue','',''),(12611,'15132','White Oak','',''),(12612,'15133','Port Vue','',''),(12613,'15137','East Mckeesport','',''),(12614,'15137','White Oak','',''),(12615,'15139','Plum','',''),(12616,'15144','Harwick','',''),(12617,'15145','Monroeville','',''),(12618,'15146','Murrysville','',''),(12619,'15147','Plum','',''),(12620,'15148','Monroeville','',''),(12621,'15202','Bellevue','',''),(12622,'15207','West Mifflin','',''),(12623,'15210','Baldwin','',''),(12624,'15218','Swissvale','',''),(12625,'15218','Wilkinsburg','',''),(12626,'15221','Swissvale','',''),(12627,'15221','Wilkinsburg','',''),(12628,'15223','Glenshaw','',''),(12629,'15227','Baldwin','',''),(12630,'15227','Brentwood','',''),(12631,'15228','Bethel Park','',''),(12632,'15228','Upper St. Clair','',''),(12633,'15234','Bethel Park','',''),(12634,'15234','Castle Shannon','',''),(12635,'15235','Plum','',''),(12636,'15235','Wilkinsburg','',''),(12637,'15236','Baldwin','',''),(12638,'15236','Bethel Park','',''),(12639,'15236','Brentwood','',''),(12640,'15236','Jefferson Hills','',''),(12641,'15236','South Park Township','',''),(12642,'15236','West Mifflin','',''),(12643,'15237','Allison Park','',''),(12644,'15237','Glenshaw','',''),(12645,'15239','Plum','',''),(12646,'15241','Bethel Park','',''),(12647,'15241','Upper St. Clair','',''),(12648,'15243','Upper St. Clair','',''),(12649,'15301','Mcgovern','',''),(12650,'15301','Meadowlands','',''),(12651,'15312','West Middletown','',''),(12652,'15317','Cecil-bishop','',''),(12653,'15317','Muse','',''),(12654,'15320','Crucible','',''),(12655,'15320','Nemacolin','',''),(12656,'15321','Cecil-bishop','',''),(12657,'15322','Deemston','',''),(12658,'15332','Jefferson Hills','',''),(12659,'15333','Beallsville','',''),(12660,'15333','Centerville','',''),(12661,'15333','Deemston','',''),(12662,'15333','Millsboro','',''),(12663,'15342','Mcgovern','',''),(12664,'15342','Meadowlands','',''),(12665,'15344','Dry Tavern','',''),(12666,'15344','Mather','',''),(12667,'15345','Deemston','',''),(12668,'15347','Meadowlands','',''),(12669,'15352','Brave','',''),(12670,'15357','Crucible','',''),(12671,'15357','Dry Tavern','',''),(12672,'15358','Centerville','',''),(12673,'15360','Beallsville','',''),(12674,'15360','Cokeburg','',''),(12675,'15360','Deemston','',''),(12676,'15364','Rogersville','',''),(12677,'15368','Centerville','',''),(12678,'15370','Rogersville','',''),(12679,'15401','Fairchance','',''),(12680,'15401','Hopwood','',''),(12681,'15401','Oliver','',''),(12682,'15412','Stockdale','',''),(12683,'15417','Allison','',''),(12684,'15417','California','',''),(12685,'15417','Centerville','',''),(12686,'15417','Hiller','',''),(12687,'15417','Republic','',''),(12688,'15421','Deer Lake','',''),(12689,'15423','Allenport','',''),(12690,'15423','Bentleyville','',''),(12691,'15423','California','',''),(12692,'15423','Centerville','',''),(12693,'15423','Elco','',''),(12694,'15427','California','',''),(12695,'15429','Centerville','',''),(12696,'15432','Allenport','',''),(12697,'15437','Deer Lake','',''),(12698,'15438','Newell','',''),(12699,'15461','Ronco','',''),(12700,'15470','Deer Lake','',''),(12701,'15473','Star Junction','',''),(12702,'15477','Allenport','',''),(12703,'15477','Stockdale','',''),(12704,'15478','Fairchance','',''),(12705,'15483','Allenport','',''),(12706,'15531','Jennerstown','',''),(12707,'15541','Shanksville','',''),(12708,'15545','Wellersburg','',''),(12709,'15563','Jennerstown','',''),(12710,'15563','Shanksville','',''),(12711,'15601','Calumet','',''),(12712,'15601','Youngwood','',''),(12713,'15613','North Apollo','',''),(12714,'15620','Loyalhanna','',''),(12715,'15626','Murrysville','',''),(12716,'15627','Bradenville','',''),(12717,'15629','Vandergrift','',''),(12718,'15632','Delmont','',''),(12719,'15632','Murrysville','',''),(12720,'15636','Manor','',''),(12721,'15639','New Stanton','',''),(12722,'15642','Manor','',''),(12723,'15642','White Oak','',''),(12724,'15644','Grapeville','',''),(12725,'15644','Murrysville','',''),(12726,'15650','Hostetter','',''),(12727,'15650','Loyalhanna','',''),(12728,'15666','Calumet','',''),(12729,'15668','Plum','',''),(12730,'15672','Arona','',''),(12731,'15679','Wyano','',''),(12732,'15679','Yukon','',''),(12733,'15689','Calumet','',''),(12734,'15698','Wyano','',''),(12735,'15710','Heilwood','',''),(12736,'15714','Heilwood','',''),(12737,'15717','Black Lick','',''),(12738,'15717','Jacksonville','',''),(12739,'15725','Jacksonville','',''),(12740,'15727','Jacksonville','',''),(12741,'15728','Dicksonville','',''),(12742,'15728','Heilwood','',''),(12743,'15734','Dicksonville','',''),(12744,'15747','Plumville','',''),(12745,'15748','Coral','',''),(12746,'15748','Jacksonville','',''),(12747,'15748','Lucerne Mines','',''),(12748,'15750','Black Lick','',''),(12749,'15752','Jacksonville','',''),(12750,'15754','Lucerne Mines','',''),(12751,'15756','Jacksonville','',''),(12752,'15761','Heilwood','',''),(12753,'15767','Big Run','',''),(12754,'15767','Timblin','',''),(12755,'15774','Elderton','',''),(12756,'15774','Jacksonville','',''),(12757,'15775','Northern Cambria','',''),(12758,'15801','Dubois','',''),(12759,'15857','St. Marys','',''),(12760,'15864','Worthville','',''),(12761,'15868','Byrnedale','',''),(12762,'15868','Force','',''),(12763,'15931','Revloc','',''),(12764,'15935','Jerome','',''),(12765,'15943','Nanty-glo','',''),(12766,'15946','Wilmore','',''),(12767,'15951','St. Michael','',''),(12768,'15955','Beaverdale','',''),(12769,'15955','Dunlo','',''),(12770,'15955','St. Michael','',''),(12771,'15955','Salix','',''),(12772,'15956','St. Michael','',''),(12773,'15958','Wilmore','',''),(12774,'15963','Dunlo','',''),(12775,'15963','Salix','',''),(12776,'16001','East Butler','',''),(12777,'16001','Homeacre-lyndora','',''),(12778,'16002','East Butler','',''),(12779,'16033','Callery','',''),(12780,'16033','Connoquenessing','',''),(12781,'16038','Clintonville','',''),(12782,'16045','Butler','',''),(12783,'16045','Homeacre-lyndora','',''),(12784,'16049','Bruin','',''),(12785,'16049','Callensburg','',''),(12786,'16049','Eau Claire','',''),(12787,'16050','Bruin','',''),(12788,'16054','St. Petersburg','',''),(12789,'16066','Fernway','',''),(12790,'16102','Bessemer','',''),(12791,'16115','Ohioville','',''),(12792,'16121','Hermitage','',''),(12793,'16121','Sharon','',''),(12794,'16130','Sheakleyville','',''),(12795,'16141','New Beaver','',''),(12796,'16143','New Bedford','',''),(12797,'16146','Farrell','',''),(12798,'16146','Hermitage','',''),(12799,'16148','Farrell','',''),(12800,'16150','Clark','',''),(12801,'16150','Hermitage','',''),(12802,'16157','Koppel','',''),(12803,'16157','New Beaver','',''),(12804,'16159','Hermitage','',''),(12805,'16159','New Bedford','',''),(12806,'16161','Farrell','',''),(12807,'16201','Manorville','',''),(12808,'16240','Timblin','',''),(12809,'16301','Rouseville','',''),(12810,'16301','Sugarcreek','',''),(12811,'16316','Conneaut Lakeshore','',''),(12812,'16323','Sugarcreek','',''),(12813,'16343','Sugarcreek','',''),(12814,'16354','Hydetown','',''),(12815,'16374','Clintonville','',''),(12816,'16441','Mill Village','',''),(12817,'16510','Lawrence Park','',''),(12818,'16510','Penn State Erie (behrend)','',''),(12819,'16511','Lawrence Park','',''),(12820,'16563','Penn State Erie (behrend)','',''),(12821,'16621','Broad Top City','',''),(12822,'16621','Dudley','',''),(12823,'16635','Newry','',''),(12824,'16639','Blandburg','',''),(12825,'16651','Brisbin','',''),(12826,'16661','Glen Hope','',''),(12827,'16668','Chest Springs','',''),(12828,'16679','Defiance','',''),(12829,'16682','Claysburg','',''),(12830,'16733','Mount Jewett','',''),(12831,'16735','Mount Jewett','',''),(12832,'16801','Boalsburg','',''),(12833,'16801','Lemont','',''),(12834,'16801','Pine Grove Mills','',''),(12835,'16802','State College','',''),(12836,'16823','Milesburg','',''),(12837,'16830','Hyde','',''),(12838,'16835','Unionville','',''),(12839,'16841','Blanchard','',''),(12840,'16841','Lamar','',''),(12841,'16844','Unionville','',''),(12842,'16858','Allport','',''),(12843,'16858','Grassflat','',''),(12844,'16858','Kylertown','',''),(12845,'16865','Pine Grove Mills','',''),(12846,'16865','Ramblewood','',''),(12847,'16866','Hawk Run','',''),(12848,'16874','Clarence','',''),(12849,'16878','Bigler','',''),(12850,'16878','Wallaceton','',''),(12851,'16881','Bigler','',''),(12852,'17011','Lemoyne','',''),(12853,'17015','Plainfield','',''),(12854,'17020','New Buffalo','',''),(12855,'17022','Rheems','',''),(12856,'17023','Berrysburg','',''),(12857,'17027','Messiah College','',''),(12858,'17036','Hershey','',''),(12859,'17042','Cornwall','',''),(12860,'17042','Quentin','',''),(12861,'17044','Burnham','',''),(12862,'17044','Granville','',''),(12863,'17048','Gratz','',''),(12864,'17048','Pillow','',''),(12865,'17050','New Kingstown','',''),(12866,'17055','Messiah College','',''),(12867,'17059','Mexico','',''),(12868,'17064','Mount Gretna Heights','',''),(12869,'17066','Newton Hamilton','',''),(12870,'17067','Mount Aetna','',''),(12871,'17073','Richland','',''),(12872,'17073','Schaefferstown','',''),(12873,'17078','Hershey','',''),(12874,'17097','Wiconsico','',''),(12875,'17109','Colonial Park','',''),(12876,'17112','Colonial Park','',''),(12877,'17113','Steelton','',''),(12878,'17202','Marion','',''),(12879,'17202','Scotland','',''),(12880,'17225','State Line','',''),(12881,'17249','Rockhill','',''),(12882,'17264','Saltillo','',''),(12883,'17268','State Line','',''),(12884,'17304','Bendersville','',''),(12885,'17307','Mcknightstown','',''),(12886,'17311','Jefferson','',''),(12887,'17320','Carroll Valley','',''),(12888,'17343','Mcknightstown','',''),(12889,'17344','Mcsherrystown','',''),(12890,'17349','Railroad','',''),(12891,'17360','Jacobus','',''),(12892,'17362','Jefferson','',''),(12893,'17368','East Prospect','',''),(12894,'17371','New Salem','',''),(12895,'17402','Emigsville','',''),(12896,'17403','Jacobus','',''),(12897,'17404','Shiloh','',''),(12898,'17406','Emigsville','',''),(12899,'17407','Jacobus','',''),(12900,'17408','New Salem','',''),(12901,'17408','Shiloh','',''),(12902,'17505','Leola','',''),(12903,'17505','Smoketown','',''),(12904,'17517','Adamstown','',''),(12905,'17517','Bowmansville','',''),(12906,'17517','Reamstown','',''),(12907,'17519','Terre Hill','',''),(12908,'17522','Brownstown','',''),(12909,'17522','Reamstown','',''),(12910,'17538','Salunga','',''),(12911,'17540','Brownstown','',''),(12912,'17545','Cornwall','',''),(12913,'17545','East Petersburg','',''),(12914,'17547','Maytown','',''),(12915,'17552','Rheems','',''),(12916,'17552','Salunga','',''),(12917,'17555','Bowmansville','',''),(12918,'17569','Adamstown','',''),(12919,'17578','Reamstown','',''),(12920,'17601','Leola','',''),(12921,'17602','Smoketown','',''),(12922,'17602','Willow Street','',''),(12923,'17603','Millersville','',''),(12924,'17702','South Williamsport','',''),(12925,'17737','Picture Rocks','',''),(12926,'17740','Avis','',''),(12927,'17745','Avis','',''),(12928,'17745','Mcelhattan','',''),(12929,'17748','Mcelhattan','',''),(12930,'17749','Mcewensville','',''),(12931,'17751','Lamar','',''),(12932,'17777','Dewart','',''),(12933,'17777','Mcewensville','',''),(12934,'17821','Riverside','',''),(12935,'17837','West Milton','',''),(12936,'17842','Freeburg','',''),(12937,'17842','Paxtonville','',''),(12938,'17842','Penns Creek','',''),(12939,'17845','Hartleton','',''),(12940,'17845','Laurelton','',''),(12941,'17847','Montandon','',''),(12942,'17870','Shamokin Dam','',''),(12943,'17872','Trevorton','',''),(12944,'17888','Wilburton Number One','',''),(12945,'17901','Marlin','',''),(12946,'17901','Port Carbon','',''),(12947,'17901','St. Clair','',''),(12948,'17901','Seltzer','',''),(12949,'17921','Lavelle','',''),(12950,'17922','Lake Wynonah','',''),(12951,'17925','Tuscarora','',''),(12952,'17931','Gilberton','',''),(12953,'17938','Valley View','',''),(12954,'17948','Delano','',''),(12955,'17949','Gilberton','',''),(12956,'17951','Marlin','',''),(12957,'17952','Tuscarora','',''),(12958,'17970','St. Clair','',''),(12959,'17972','Cressona','',''),(12960,'17972','Friedensburg','',''),(12961,'17972','Summit Station','',''),(12962,'17980','Muir','',''),(12963,'18013','Martins Creek','',''),(12964,'18031','Trexlertown','',''),(12965,'18040','Martins Creek','',''),(12966,'18040','Stockertown','',''),(12967,'18045','Tatamy','',''),(12968,'18052','Allentown','',''),(12969,'18052','Fullerton','',''),(12970,'18055','Bethlehem','',''),(12971,'18067','Cherryville','',''),(12972,'18071','Bowmanstown','',''),(12973,'18071','Parryville','',''),(12974,'18080','Laurys Station','',''),(12975,'18080','Slatedale','',''),(12976,'18088','Cherryville','',''),(12977,'18106','Trexlertown','',''),(12978,'18201','Harleigh','',''),(12979,'18201','Tresckow','',''),(12980,'18202','Harleigh','',''),(12981,'18202','Lattimer','',''),(12982,'18210','Indian Mountain Lake','',''),(12983,'18223','Harleigh','',''),(12984,'18234','Harleigh','',''),(12985,'18234','Lattimer','',''),(12986,'18235','Jim Thorpe','',''),(12987,'18235','Parryville','',''),(12988,'18239','Harleigh','',''),(12989,'18249','Conyngham','',''),(12990,'18302','Saw Creek','',''),(12991,'18324','Saw Creek','',''),(12992,'18330','Indian Mountain Lake','',''),(12993,'18330','Sierra View','',''),(12994,'18334','Emerald Lakes','',''),(12995,'18343','Portland','',''),(12996,'18346','Mount Pocono','',''),(12997,'18347','Pocono Pines','',''),(12998,'18353','Brodheadsville','',''),(12999,'18353','Sierra View','',''),(13000,'18360','Delaware Water Gap','',''),(13001,'18403','Jessup','',''),(13002,'18405','Masthope','',''),(13003,'18411','Scranton','',''),(13004,'18411','Waverly','',''),(13005,'18414','Waverly','',''),(13006,'18419','Lake Winola','',''),(13007,'18428','Masthope','',''),(13008,'18428','White Mills','',''),(13009,'18431','Prompton','',''),(13010,'18431','White Mills','',''),(13011,'18433','Archbald','',''),(13012,'18434','Olyphant','',''),(13013,'18435','Masthope','',''),(13014,'18444','Dunmore','',''),(13015,'18447','Archbald','',''),(13016,'18447','Blakely','',''),(13017,'18447','Dickson City','',''),(13018,'18452','Blakely','',''),(13019,'18504','Taylor','',''),(13020,'18505','Dunmore','',''),(13021,'18505','Moosic','',''),(13022,'18507','Scranton','',''),(13023,'18508','Dickson City','',''),(13024,'18509','Dunmore','',''),(13025,'18510','Dunmore','',''),(13026,'18512','Dunmore','',''),(13027,'18512','Olyphant','',''),(13028,'18518','Taylor','',''),(13029,'18519','Scranton','',''),(13030,'18602','Bear Creek Village','',''),(13031,'18610','Indian Mountain Lake','',''),(13032,'18610','Sierra View','',''),(13033,'18612','Harveys Lake','',''),(13034,'18615','Lake Winola','',''),(13035,'18626','Eagles Mere','',''),(13036,'18640','Dupont','',''),(13037,'18640','Duryea','',''),(13038,'18641','Dupont','',''),(13039,'18641','Duryea','',''),(13040,'18641','Moosic','',''),(13041,'18643','Exeter','',''),(13042,'18701','Wilkes-barre','',''),(13043,'18702','Wilkes-barre','',''),(13044,'18704','Wilkes-barre','',''),(13045,'18705','Wilkes-barre','',''),(13046,'18848','Burlington','',''),(13047,'18944','Silverdale','',''),(13048,'18951','Milford Square','',''),(13049,'18951','Trumbauersville','',''),(13050,'18960','Silverdale','',''),(13051,'19001','Willow Grove','',''),(13052,'19002','Fort Washington','',''),(13053,'19002','Spring House','',''),(13054,'19006','Bryn Athyn','',''),(13055,'19006','Willow Grove','',''),(13056,'19007','Croydon','',''),(13057,'19014','Chester Heights','',''),(13058,'19015','Chester','',''),(13059,'19022','Eddystone','',''),(13060,'19022','Ridley Park','',''),(13061,'19022','Woodlyn','',''),(13062,'19023','Yeadon','',''),(13063,'19025','Fort Washington','',''),(13064,'19025','Oreland','',''),(13065,'19030','Levittown','',''),(13066,'19033','Woodlyn','',''),(13067,'19038','Flourtown','',''),(13068,'19038','Oreland','',''),(13069,'19040','Horsham','',''),(13070,'19040','Willow Grove','',''),(13071,'19047','Fairless Hills','',''),(13072,'19050','Darby','',''),(13073,'19050','Yeadon','',''),(13074,'19056','Fairless Hills','',''),(13075,'19060','Chester Heights','',''),(13076,'19063','Chester Heights','',''),(13077,'19064','Swarthmore','',''),(13078,'19076','Ridley Park','',''),(13079,'19078','Folsom','',''),(13080,'19079','Folcroft','',''),(13081,'19081','Folsom','',''),(13082,'19081','Woodlyn','',''),(13083,'19083','Ardmore','',''),(13084,'19087','King Of Prussia','',''),(13085,'19096','Ardmore','',''),(13086,'19311','Toughkenamon','',''),(13087,'19319','Cheyney University','',''),(13088,'19320','Modena','',''),(13089,'19320','Pomeroy','',''),(13090,'19335','Thorndale','',''),(13091,'19341','Lionville','',''),(13092,'19342','Chester Heights','',''),(13093,'19348','Toughkenamon','',''),(13094,'19355','Paoli','',''),(13095,'19365','Pomeroy','',''),(13096,'19382','Cheyney University','',''),(13097,'19406','Bridgeport','',''),(13098,'19426','Skippack','',''),(13099,'19438','Skippack','',''),(13100,'19462','Norristown','',''),(13101,'19473','Skippack','',''),(13102,'19504','Bally','',''),(13103,'19504','Hereford','',''),(13104,'19505','New Berlinville','',''),(13105,'19506','Shartlesville','',''),(13106,'19512','New Berlinville','',''),(13107,'19522','Blandon','',''),(13108,'19526','Shartlesville','',''),(13109,'19526','Virginville','',''),(13110,'19530','Bowers','',''),(13111,'19530','Virginville','',''),(13112,'19536','Lyons','',''),(13113,'19539','Bowers','',''),(13114,'19540','Bowmansville','',''),(13115,'19605','Blandon','',''),(13116,'19607','Wyomissing','',''),(13117,'19609','West Wyomissing','',''),(13118,'19609','Wyomissing','',''),(13119,'19610','West Wyomissing','',''),(13120,'19610','Wyomissing','',''),(13121,'19709','Odessa','',''),(13122,'19713','Brookside','',''),(13123,'19734','Middletown','',''),(13124,'19736','Hockessin','',''),(13125,'19807','Hockessin','',''),(13126,'19808','Hockessin','',''),(13127,'19809','Claymont','',''),(13128,'19901','Cheswold','',''),(13129,'19902','Dover','',''),(13130,'19904','Cheswold','',''),(13131,'19934','Dover','',''),(13132,'19938','Kenton','',''),(13133,'19945','Millville','',''),(13134,'19960','Milford','',''),(13135,'19970','Millville','',''),(13136,'20105','Stone Ridge','',''),(13137,'20109','Linton Hall','',''),(13138,'20109','Sudley','',''),(13139,'20110','Sudley','',''),(13140,'20111','Manassas Park','',''),(13141,'20112','Dale City','',''),(13142,'20119','New Baltimore','',''),(13143,'20120','Chantilly','',''),(13144,'20124','Centreville','',''),(13145,'20136','Linton Hall','',''),(13146,'20137','New Baltimore','',''),(13147,'20147','Broadlands','',''),(13148,'20148','Broadlands','',''),(13149,'20151','Centreville','',''),(13150,'20152','South Riding','',''),(13151,'20155','Linton Hall','',''),(13152,'20164','Cascades','',''),(13153,'20164','Dulles Town Center','',''),(13154,'20165','Cascades','',''),(13155,'20166','Ashburn','',''),(13156,'20166','Dulles Town Center','',''),(13157,'20166','Stone Ridge','',''),(13158,'20170','Mcnair','',''),(13159,'20170','Reston','',''),(13160,'20171','Mcnair','',''),(13161,'20176','Ashburn','',''),(13162,'20181','Linton Hall','',''),(13163,'20181','New Baltimore','',''),(13164,'20187','New Baltimore','',''),(13165,'20194','Great Falls','',''),(13166,'20601','Accokeek','',''),(13167,'20601','Bryantown','',''),(13168,'20603','Bensville','',''),(13169,'20613','Accokeek','',''),(13170,'20613','Aquasco','',''),(13171,'20613','Rosaryville','',''),(13172,'20623','Rosaryville','',''),(13173,'20629','Solomons','',''),(13174,'20634','California','',''),(13175,'20640','Bryans Road','',''),(13176,'20646','Bryans Road','',''),(13177,'20646','Waldorf','',''),(13178,'20653','California','',''),(13179,'20657','Chesapeake Ranch Estates','',''),(13180,'20657','Solomons','',''),(13181,'20664','Cobb Island','',''),(13182,'20670','Lexington Park','',''),(13183,'20675','Bensville','',''),(13184,'20689','Chesapeake Beach','',''),(13185,'20690','Piney Point','',''),(13186,'20692','Tall Timbers','',''),(13187,'20695','Bensville','',''),(13188,'20695','Waldorf','',''),(13189,'20701','Jessup','',''),(13190,'20705','South Laurel','',''),(13191,'20706','East Riverdale','',''),(13192,'20706','Glenn Dale','',''),(13193,'20706','Greenbelt','',''),(13194,'20706','Landover','',''),(13195,'20706','New Carrollton','',''),(13196,'20706','Seabrook','',''),(13197,'20707','Burtonsville','',''),(13198,'20707','South Laurel','',''),(13199,'20708','Bowie','',''),(13200,'20708','South Laurel','',''),(13201,'20712','Brentwood','',''),(13202,'20712','Chillum','',''),(13203,'20712','Hyattsville','',''),(13204,'20714','Chesapeake Beach','',''),(13205,'20715','Glenn Dale','',''),(13206,'20720','Glenn Dale','',''),(13207,'20721','Lake Arbor','',''),(13208,'20723','Fulton','',''),(13209,'20723','Scaggsville','',''),(13210,'20724','Fort Meade','',''),(13211,'20724','Maryland City','',''),(13212,'20733','Deale','',''),(13213,'20733','Shady Side','',''),(13214,'20735','Accokeek','',''),(13215,'20735','Andrews Afb','',''),(13216,'20736','Chesapeake Beach','',''),(13217,'20737','College Park','',''),(13218,'20737','East Riverdale','',''),(13219,'20737','Greenbelt','',''),(13220,'20737','Hyattsville','',''),(13221,'20740','Beltsville','',''),(13222,'20740','Greenbelt','',''),(13223,'20743','Coral Hills','',''),(13224,'20743','Forestville','',''),(13225,'20744','Clinton','',''),(13226,'20744','Glassmanor','',''),(13227,'20745','Glassmanor','',''),(13228,'20745','Hillcrest Heights','',''),(13229,'20746','Andrews Afb','',''),(13230,'20746','Forestville','',''),(13231,'20747','Coral Hills','',''),(13232,'20747','Forestville','',''),(13233,'20747','Suitland','',''),(13234,'20748','Clinton','',''),(13235,'20748','Hillcrest Heights','',''),(13236,'20754','Friendship','',''),(13237,'20755','Fort Meade','',''),(13238,'20759','Scaggsville','',''),(13239,'20762','Andrews Afb','',''),(13240,'20769','Seabrook','',''),(13241,'20770','Seabrook','',''),(13242,'20772','Marlboro Village','',''),(13243,'20772','Rosaryville','',''),(13244,'20774','Bowie','',''),(13245,'20774','Kettering','',''),(13246,'20774','Lake Arbor','',''),(13247,'20774','Marlboro Village','',''),(13248,'20777','Ashton-sandy Spring','',''),(13249,'20778','Galesville','',''),(13250,'20778','Shady Side','',''),(13251,'20779','Deale','',''),(13252,'20781','Bladensburg','',''),(13253,'20781','East Riverdale','',''),(13254,'20782','Chillum','',''),(13255,'20782','College Park','',''),(13256,'20782','Mount Rainier','',''),(13257,'20783','Beltsville','',''),(13258,'20783','Chillum','',''),(13259,'20783','College Park','',''),(13260,'20783','Langley Park','',''),(13261,'20784','Bladensburg','',''),(13262,'20784','Landover','',''),(13263,'20784','New Carrollton','',''),(13264,'20784','Seabrook','',''),(13265,'20785','Landover','',''),(13266,'20794','Elkridge','',''),(13267,'20794','Fort Meade','',''),(13268,'20794','Savage','',''),(13269,'20794','Severn','',''),(13270,'20814','Chevy Chase','',''),(13271,'20814','Garrett Park','',''),(13272,'20814','North Bethesda','',''),(13273,'20814','South Kensington','',''),(13274,'20815','Bethesda','',''),(13275,'20815','Silver Spring','',''),(13276,'20817','Cabin John','',''),(13277,'20817','North Bethesda','',''),(13278,'20817','Potomac','',''),(13279,'20833','Ashton-sandy Spring','',''),(13280,'20833','Olney','',''),(13281,'20841','Clarksburg','',''),(13282,'20841','Germantown','',''),(13283,'20850','Gaithersburg','',''),(13284,'20851','Aspen Hill','',''),(13285,'20851','North Bethesda','',''),(13286,'20852','North Bethesda','',''),(13287,'20852','Potomac','',''),(13288,'20853','Aspen Hill','',''),(13289,'20853','Olney','',''),(13290,'20853','Wheaton','',''),(13291,'20854','Rockville','',''),(13292,'20855','Olney','',''),(13293,'20855','Redland','',''),(13294,'20855','Rockville','',''),(13295,'20860','Ashton-sandy Spring','',''),(13296,'20860','Olney','',''),(13297,'20861','Ashton-sandy Spring','',''),(13298,'20866','Cloverly','',''),(13299,'20866','Fairland','',''),(13300,'20868','Burtonsville','',''),(13301,'20868','Cloverly','',''),(13302,'20872','Clarksburg','',''),(13303,'20876','Clarksburg','',''),(13304,'20877','Montgomery Village','',''),(13305,'20877','Redland','',''),(13306,'20877','Rockville','',''),(13307,'20877','Washington Grove','',''),(13308,'20879','Germantown','',''),(13309,'20879','Montgomery Village','',''),(13310,'20879','Redland','',''),(13311,'20880','Redland','',''),(13312,'20882','Damascus','',''),(13313,'20886','Gaithersburg','',''),(13314,'20895','Bethesda','',''),(13315,'20895','North Bethesda','',''),(13316,'20895','South Kensington','',''),(13317,'20895','Wheaton','',''),(13318,'20896','South Kensington','',''),(13319,'20902','Wheaton','',''),(13320,'20903','Langley Park','',''),(13321,'20903','Takoma Park','',''),(13322,'20904','Cloverly','',''),(13323,'20904','Fairland','',''),(13324,'20905','Ashton-sandy Spring','',''),(13325,'20905','Burtonsville','',''),(13326,'20905','Cloverly','',''),(13327,'20905','Fairland','',''),(13328,'20906','Aspen Hill','',''),(13329,'20906','Cloverly','',''),(13330,'20906','Olney','',''),(13331,'20906','Wheaton','',''),(13332,'20910','South Kensington','',''),(13333,'20910','Takoma Park','',''),(13334,'20910','Wheaton','',''),(13335,'20912','Chillum','',''),(13336,'20912','Langley Park','',''),(13337,'20912','Silver Spring','',''),(13338,'21001','Perryman','',''),(13339,'21001','Riverside','',''),(13340,'21009','Bel Air South','',''),(13341,'21009','Edgewood','',''),(13342,'21009','Riverside','',''),(13343,'21010','Edgewood','',''),(13344,'21012','Severna Park','',''),(13345,'21013','Fallston','',''),(13346,'21014','Bel Air North','',''),(13347,'21014','Bel Air South','',''),(13348,'21015','Bel Air North','',''),(13349,'21015','Bel Air South','',''),(13350,'21015','Riverside','',''),(13351,'21017','Riverside','',''),(13352,'21029','Columbia','',''),(13353,'21029','Fulton','',''),(13354,'21031','Cockeysville','',''),(13355,'21032','Crofton','',''),(13356,'21032','Herald Harbor','',''),(13357,'21035','Riva','',''),(13358,'21037','Riva','',''),(13359,'21042','Columbia','',''),(13360,'21043','Catonsville','',''),(13361,'21043','Columbia','',''),(13362,'21045','Ellicott City','',''),(13363,'21047','Bel Air North','',''),(13364,'21048','Eldersburg','',''),(13365,'21050','Bel Air North','',''),(13366,'21050','Fallston','',''),(13367,'21052','Edgemere','',''),(13368,'21054','Crofton','',''),(13369,'21054','Odenton','',''),(13370,'21060','Pasadena','',''),(13371,'21060','Riviera Beach','',''),(13372,'21061','Linthicum','',''),(13373,'21061','Severn','',''),(13374,'21075','Columbia','',''),(13375,'21076','Elkridge','',''),(13376,'21076','Fort Meade','',''),(13377,'21076','Severn','',''),(13378,'21077','Severn','',''),(13379,'21078','Aberdeen','',''),(13380,'21085','Edgewood','',''),(13381,'21085','Joppatowne','',''),(13382,'21090','Linthicum','',''),(13383,'21093','Cockeysville','',''),(13384,'21093','Mays Chapel','',''),(13385,'21093','Pikesville','',''),(13386,'21093','Towson','',''),(13387,'21104','Eldersburg','',''),(13388,'21104','Ellicott City','',''),(13389,'21108','Glen Burnie','',''),(13390,'21108','Severna Park','',''),(13391,'21113','Severn','',''),(13392,'21117','Randallstown','',''),(13393,'21117','Reisterstown','',''),(13394,'21122','Glen Burnie','',''),(13395,'21122','Riviera Beach','',''),(13396,'21122','Severna Park','',''),(13397,'21131','Cockeysville','',''),(13398,'21133','Milford Mill','',''),(13399,'21144','Fort Meade','',''),(13400,'21144','Odenton','',''),(13401,'21146','Arnold','',''),(13402,'21153','Pikesville','',''),(13403,'21156','Kingsville','',''),(13404,'21163','Ellicott City','',''),(13405,'21163','Randallstown','',''),(13406,'21206','Rosedale','',''),(13407,'21207','Baltimore','',''),(13408,'21207','Lochearn','',''),(13409,'21208','Baltimore','',''),(13410,'21208','Lochearn','',''),(13411,'21208','Milford Mill','',''),(13412,'21208','Owings Mills','',''),(13413,'21208','Randallstown','',''),(13414,'21209','Pikesville','',''),(13415,'21209','Towson','',''),(13416,'21210','Towson','',''),(13417,'21212','Towson','',''),(13418,'21215','Lochearn','',''),(13419,'21215','Pikesville','',''),(13420,'21219','Dundalk','',''),(13421,'21219','Edgemere','',''),(13422,'21220','Essex','',''),(13423,'21221','Middle River','',''),(13424,'21221','Rosedale','',''),(13425,'21222','Baltimore','',''),(13426,'21222','Edgemere','',''),(13427,'21224','Dundalk','',''),(13428,'21225','Baltimore','',''),(13429,'21225','Linthicum','',''),(13430,'21226','Baltimore','',''),(13431,'21226','Glen Burnie','',''),(13432,'21226','Pasadena','',''),(13433,'21226','Riviera Beach','',''),(13434,'21227','Arbutus','',''),(13435,'21227','Baltimore','',''),(13436,'21227','Catonsville','',''),(13437,'21228','Arbutus','',''),(13438,'21228','Baltimore','',''),(13439,'21229','Arbutus','',''),(13440,'21229','Catonsville','',''),(13441,'21234','Baltimore','',''),(13442,'21234','Perry Hall','',''),(13443,'21236','Baltimore','',''),(13444,'21236','Perry Hall','',''),(13445,'21236','Rosedale','',''),(13446,'21237','Baltimore','',''),(13447,'21237','Middle River','',''),(13448,'21237','Perry Hall','',''),(13449,'21239','Towson','',''),(13450,'21244','Milford Mill','',''),(13451,'21244','Randallstown','',''),(13452,'21250','Catonsville','',''),(13453,'21252','Towson','',''),(13454,'21286','Parkville','',''),(13455,'21401','Naval Academy','',''),(13456,'21402','Naval Academy','',''),(13457,'21409','Arnold','',''),(13458,'21502','Corriganville','',''),(13459,'21502','Ellerslie','',''),(13460,'21532','Midlothian','',''),(13461,'21561','Bloomington','',''),(13462,'21629','Hillsboro','',''),(13463,'21658','Grasonville','',''),(13464,'21665','Tilghman Island','',''),(13465,'21666','Chester','',''),(13466,'21671','Tilghman Island','',''),(13467,'21677','Madison','',''),(13468,'21701','Ballenger Creek','',''),(13469,'21701','Libertytown','',''),(13470,'21701','Linganore','',''),(13471,'21702','Braddock Heights','',''),(13472,'21703','Ballenger Creek','',''),(13473,'21703','Braddock Heights','',''),(13474,'21704','Ballenger Creek','',''),(13475,'21704','Urbana','',''),(13476,'21719','Highfield-cascade','',''),(13477,'21733','St. James','',''),(13478,'21740','Funkstown','',''),(13479,'21740','Maugansville','',''),(13480,'21740','St. James','',''),(13481,'21754','Linganore','',''),(13482,'21754','Urbana','',''),(13483,'21755','Braddock Heights','',''),(13484,'21755','Burkittsville','',''),(13485,'21758','Brunswick','',''),(13486,'21769','Braddock Heights','',''),(13487,'21774','Linganore','',''),(13488,'21781','St. James','',''),(13489,'21784','Eldersburg','',''),(13490,'21791','Libertytown','',''),(13491,'21797','Eldersburg','',''),(13492,'21801','Fruitland','',''),(13493,'21804','Fruitland','',''),(13494,'21811','Ocean Pines','',''),(13495,'21824','Smith Island','',''),(13496,'21865','Bivalve','',''),(13497,'21866','Smith Island','',''),(13498,'21867','Fairmount','',''),(13499,'21871','Fairmount','',''),(13500,'21874','Pittsville','',''),(13501,'21875','Salisbury','',''),(13502,'21901','Charlestown','',''),(13503,'21904','Perryville','',''),(13504,'21912','Cecilton','',''),(13505,'22003','Lincolnia','',''),(13506,'22015','Kings Park West','',''),(13507,'22025','Montclair','',''),(13508,'22026','Cherry Hill','',''),(13509,'22026','Triangle','',''),(13510,'22030','Centreville','',''),(13511,'22030','Fair Oaks','',''),(13512,'22030','Oakton','',''),(13513,'22031','Merrifield','',''),(13514,'22031','Oakton','',''),(13515,'22031','Vienna','',''),(13516,'22032','Burke','',''),(13517,'22032','Kings Park West','',''),(13518,'22033','Chantilly','',''),(13519,'22033','Fair Oaks','',''),(13520,'22035','Fair Oaks','',''),(13521,'22039','Crosspointe','',''),(13522,'22041','Baileys Crossroads','',''),(13523,'22041','Lincolnia','',''),(13524,'22041','Seven Corners','',''),(13525,'22042','Annandale','',''),(13526,'22042','Idylwood','',''),(13527,'22042','Merrifield','',''),(13528,'22042','West Falls Church','',''),(13529,'22043','Idylwood','',''),(13530,'22043','Mclean','',''),(13531,'22043','Merrifield','',''),(13532,'22044','Seven Corners','',''),(13533,'22044','West Falls Church','',''),(13534,'22046','Idylwood','',''),(13535,'22046','Mclean','',''),(13536,'22060','Lorton','',''),(13537,'22066','Mclean','',''),(13538,'22079','Crosspointe','',''),(13539,'22079','Newington Forest','',''),(13540,'22079','Occoquan','',''),(13541,'22079','Springfield','',''),(13542,'22101','Arlington','',''),(13543,'22101','Mclean','',''),(13544,'22102','Great Falls','',''),(13545,'22102','Mclean','',''),(13546,'22102','Tysons Corner','',''),(13547,'22124','Fair Oaks','',''),(13548,'22124','Reston','',''),(13549,'22134','Quantico Base','',''),(13550,'22150','Lincolnia','',''),(13551,'22151','North Springfield','',''),(13552,'22152','Burke','',''),(13553,'22152','West Springfield','',''),(13554,'22153','Burke','',''),(13555,'22153','Newington Forest','',''),(13556,'22153','West Springfield','',''),(13557,'22180','Dunn Loring','',''),(13558,'22180','Merrifield','',''),(13559,'22180','Oakton','',''),(13560,'22180','Wolf Trap','',''),(13561,'22181','Oakton','',''),(13562,'22181','Wolf Trap','',''),(13563,'22182','Dunn Loring','',''),(13564,'22182','Reston','',''),(13565,'22182','Tysons Corner','',''),(13566,'22182','Wolf Trap','',''),(13567,'22185','Oakton','',''),(13568,'22191','Cherry Hill','',''),(13569,'22191','Dale City','',''),(13570,'22191','Marumsco','',''),(13571,'22192','Dale City','',''),(13572,'22192','Lake Ridge','',''),(13573,'22192','Marumsco','',''),(13574,'22192','Occoquan','',''),(13575,'22193','Dale City','',''),(13576,'22193','Montclair','',''),(13577,'22205','Falls Church','',''),(13578,'22206','Alexandria','',''),(13579,'22207','Mclean','',''),(13580,'22211','Arlington','',''),(13581,'22302','Baileys Crossroads','',''),(13582,'22303','Belle Haven','',''),(13583,'22303','Huntington','',''),(13584,'22303','Rose Hill','',''),(13585,'22304','Lincolnia','',''),(13586,'22306','Belle Haven','',''),(13587,'22306','Fort Hunt','',''),(13588,'22306','Hybla Valley','',''),(13589,'22306','Rose Hill','',''),(13590,'22307','Belle Haven','',''),(13591,'22307','Fort Hunt','',''),(13592,'22308','Fort Hunt','',''),(13593,'22308','Hybla Valley','',''),(13594,'22309','Woodlawn','',''),(13595,'22310','Huntington','',''),(13596,'22310','Kingstowne','',''),(13597,'22310','Rose Hill','',''),(13598,'22311','Baileys Crossroads','',''),(13599,'22312','Annandale','',''),(13600,'22312','Lincolnia','',''),(13601,'22312','Springfield','',''),(13602,'22315','Kingstowne','',''),(13603,'22315','Rose Hill','',''),(13604,'22448','Dahlgren Center','',''),(13605,'22508','Lake Of The Woods','',''),(13606,'22625','Lake Holiday','',''),(13607,'22630','Chester Gap','',''),(13608,'22637','Lake Holiday','',''),(13609,'22640','Chester Gap','',''),(13610,'22727','Brightwood','',''),(13611,'22735','Brightwood','',''),(13612,'22801','Bridgewater','',''),(13613,'22821','Bridgewater','',''),(13614,'22824','Basye','',''),(13615,'22827','Massanutten','',''),(13616,'22832','Massanutten','',''),(13617,'22840','Massanutten','',''),(13618,'22841','Bridgewater','',''),(13619,'22842','Basye','',''),(13620,'22901','Crozet','',''),(13621,'22903','Crozet','',''),(13622,'22903','University Of Virginia','',''),(13623,'22904','University Of Virginia','',''),(13624,'22911','Hollymead','',''),(13625,'22936','Hollymead','',''),(13626,'22963','Lake Monticello','',''),(13627,'22980','Crimora','',''),(13628,'22980','Fishersville','',''),(13629,'22980','Lyndhurst','',''),(13630,'22980','Stuarts Draft','',''),(13631,'23059','Short Pump','',''),(13632,'23060','Laurel','',''),(13633,'23060','Short Pump','',''),(13634,'23064','Gwynn','',''),(13635,'23072','Gloucester Point','',''),(13636,'23113','Bon Air','',''),(13637,'23150','Highland Springs','',''),(13638,'23173','Richmond','',''),(13639,'23223','Highland Springs','',''),(13640,'23225','Bon Air','',''),(13641,'23226','Tuckahoe','',''),(13642,'23228','Laurel','',''),(13643,'23229','Tuckahoe','',''),(13644,'23233','Short Pump','',''),(13645,'23233','Tuckahoe','',''),(13646,'23234','Meadowbrook','',''),(13647,'23235','Bon Air','',''),(13648,'23237','Chester','',''),(13649,'23237','Meadowbrook','',''),(13650,'23238','Tuckahoe','',''),(13651,'23294','Laurel','',''),(13652,'23301','Tasley','',''),(13653,'23303','Wattsville','',''),(13654,'23308','Nelsonia','',''),(13655,'23310','Cheriton','',''),(13656,'23321','Suffolk','',''),(13657,'23336','Chincoteague','',''),(13658,'23337','Wattsville','',''),(13659,'23350','Nassawadox','',''),(13660,'23356','Captains Cove','',''),(13661,'23357','Chase Crossing','',''),(13662,'23357','Tasley','',''),(13663,'23359','Sanford','',''),(13664,'23401','Pungoteague','',''),(13665,'23407','Nelsonia','',''),(13666,'23415','Wattsville','',''),(13667,'23416','Atlantic','',''),(13668,'23416','Wattsville','',''),(13669,'23417','Tasley','',''),(13670,'23420','Keller','',''),(13671,'23420','Pungoteague','',''),(13672,'23442','Atlantic','',''),(13673,'23442','Sanford','',''),(13674,'23604','Newport News','',''),(13675,'23605','Hampton','',''),(13676,'23651','Hampton','',''),(13677,'23665','Bethel Manor','',''),(13678,'23693','Bethel Manor','',''),(13679,'23803','Ettrick','',''),(13680,'23806','Ettrick','',''),(13681,'23834','Chester','',''),(13682,'23834','Ettrick','',''),(13683,'23860','Fort Lee','',''),(13684,'23875','Fort Lee','',''),(13685,'23881','Claremont','',''),(13686,'23882','Sussex','',''),(13687,'23887','Gasburg','',''),(13688,'23890','Sussex','',''),(13689,'23901','Hampden-sydney','',''),(13690,'23920','South Hill','',''),(13691,'23943','Hampden-sydney','',''),(13692,'23947','Lunenburg','',''),(13693,'23950','Bracey','',''),(13694,'23950','South Hill','',''),(13695,'23974','Lunenburg','',''),(13696,'24012','Blue Ridge','',''),(13697,'24012','Hollins','',''),(13698,'24015','Cave Spring','',''),(13699,'24018','Cave Spring','',''),(13700,'24018','Salem','',''),(13701,'24019','Cloverdale','',''),(13702,'24019','Hollins','',''),(13703,'24020','Hollins','',''),(13704,'24055','Collinsville','',''),(13705,'24055','Stanleytown','',''),(13706,'24060','Christiansburg','',''),(13707,'24073','Blacksburg','',''),(13708,'24084','Belspring','',''),(13709,'24089','Collinsville','',''),(13710,'24112','Collinsville','',''),(13711,'24124','Rich Creek','',''),(13712,'24137','Union Hall','',''),(13713,'24141','Belspring','',''),(13714,'24175','Daleville','',''),(13715,'24184','Union Hall','',''),(13716,'24251','Weber City','',''),(13717,'24277','Dryden','',''),(13718,'24354','Atkins','',''),(13719,'24368','Atkins','',''),(13720,'24401','Fishersville','',''),(13721,'24401','Stuarts Draft','',''),(13722,'24401','Verona','',''),(13723,'24422','Iron Gate','',''),(13724,'24426','Low Moor','',''),(13725,'24430','Augusta Springs','',''),(13726,'24467','Weyers Cave','',''),(13727,'24474','Clifton Forge','',''),(13728,'24477','Lyndhurst','',''),(13729,'24482','Staunton','',''),(13730,'24551','Lynchburg','',''),(13731,'24558','South Boston','',''),(13732,'24609','Raven','',''),(13733,'24609','Richlands','',''),(13734,'24612','Raven','',''),(13735,'24612','Richlands','',''),(13736,'24630','Tazewell','',''),(13737,'24639','Richlands','',''),(13738,'24641','Raven','',''),(13739,'24649','Raven','',''),(13740,'24701','Bramwell','',''),(13741,'24701','Montcalm','',''),(13742,'24724','Bramwell','',''),(13743,'24726','Bud','',''),(13744,'24726','Covel','',''),(13745,'24747','Montcalm','',''),(13746,'24817','Raysal','',''),(13747,'24830','Gary','',''),(13748,'24844','Big Sandy','',''),(13749,'24846','Gilbert Creek','',''),(13750,'24849','Glen Fork','',''),(13751,'24849','Matheny','',''),(13752,'24853','Welch','',''),(13753,'24866','Cucumber','',''),(13754,'24870','Kopperston','',''),(13755,'24871','Gary','',''),(13756,'24878','Welch','',''),(13757,'24881','Big Sandy','',''),(13758,'24888','Gary','',''),(13759,'24894','War','',''),(13760,'25002','Falls View','',''),(13761,'25015','Cedar Grove','',''),(13762,'25015','Chesapeake','',''),(13763,'25035','Chelyan','',''),(13764,'25036','Smithers','',''),(13765,'25040','Falls View','',''),(13766,'25053','Madison','',''),(13767,'25064','South Charleston','',''),(13768,'25082','Buffalo','',''),(13769,'25086','Cedar Grove','',''),(13770,'25103','Pratt','',''),(13771,'25110','Glasgow','',''),(13772,'25110','Montgomery','',''),(13773,'25110','Smithers','',''),(13774,'25118','Deep Water','',''),(13775,'25118','Mount Carbon','',''),(13776,'25118','Powellton','',''),(13777,'25143','Cross Lanes','',''),(13778,'25152','Kincaid','',''),(13779,'25156','Handley','',''),(13780,'25156','Montgomery','',''),(13781,'25168','Eleanor','',''),(13782,'25168','Hometown','',''),(13783,'25177','Nitro','',''),(13784,'25177','St. Albans','',''),(13785,'25177','South Charleston','',''),(13786,'25177','Teays Valley','',''),(13787,'25177','Upper Falls','',''),(13788,'25202','Alum Creek','',''),(13789,'25202','Upper Falls','',''),(13790,'25213','Nitro','',''),(13791,'25214','Chesapeake','',''),(13792,'25247','Hartford City','',''),(13793,'25253','Hartford City','',''),(13794,'25253','New Haven','',''),(13795,'25303','South Charleston','',''),(13796,'25309','South Charleston','',''),(13797,'25309','Upper Falls','',''),(13798,'25312','Dunbar','',''),(13799,'25312','Sissonville','',''),(13800,'25312','South Charleston','',''),(13801,'25313','Cross Lanes','',''),(13802,'25313','Dunbar','',''),(13803,'25313','Nitro','',''),(13804,'25314','South Charleston','',''),(13805,'25315','Chesapeake','',''),(13806,'25320','Sissonville','',''),(13807,'25414','Ranson','',''),(13808,'25430','Ranson','',''),(13809,'25526','Culloden','',''),(13810,'25526','Teays Valley','',''),(13811,'25530','Ceredo','',''),(13812,'25541','Culloden','',''),(13813,'25560','Nitro','',''),(13814,'25560','Teays Valley','',''),(13815,'25601','Holden','',''),(13816,'25601','Mount Gay-shamrock','',''),(13817,'25606','Man','',''),(13818,'25607','Accoville','',''),(13819,'25607','Robinette','',''),(13820,'25608','Gilbert Creek','',''),(13821,'25617','Mallory','',''),(13822,'25621','Gilbert Creek','',''),(13823,'25621','Justice','',''),(13824,'25625','Mount Gay-shamrock','',''),(13825,'25628','Accoville','',''),(13826,'25628','Man','',''),(13827,'25632','Man','',''),(13828,'25634','Man','',''),(13829,'25635','Kistler','',''),(13830,'25637','Mount Gay-shamrock','',''),(13831,'25646','Mcconnell','',''),(13832,'25649','Mount Gay-shamrock','',''),(13833,'25652','Holden','',''),(13834,'25653','Mount Gay-shamrock','',''),(13835,'25688','Red Jacket','',''),(13836,'25702','Lesage','',''),(13837,'25704','Ceredo','',''),(13838,'25704','Kenova','',''),(13839,'25801','Crab Orchard','',''),(13840,'25801','Eccles','',''),(13841,'25801','Mabscott','',''),(13842,'25801','Macarthur','',''),(13843,'25801','Piney View','',''),(13844,'25810','Corinne','',''),(13845,'25813','Coal City','',''),(13846,'25825','Ghent','',''),(13847,'25827','Sophia','',''),(13848,'25832','Shady Spring','',''),(13849,'25840','Kincaid','',''),(13850,'25840','Oak Hill','',''),(13851,'25855','Glen Jean','',''),(13852,'25871','Beckley','',''),(13853,'25871','Macarthur','',''),(13854,'25873','Macarthur','',''),(13855,'25878','Sophia','',''),(13856,'25880','Bradley','',''),(13857,'25880','Piney View','',''),(13858,'25882','Bud','',''),(13859,'25882','Corinne','',''),(13860,'25901','Glen Jean','',''),(13861,'25901','Hilltop','',''),(13862,'25901','Minden','',''),(13863,'25908','Coal City','',''),(13864,'25917','Oak Hill','',''),(13865,'25921','Helen','',''),(13866,'25928','Bud','',''),(13867,'25989','Shady Spring','',''),(13868,'26003','West Liberty','',''),(13869,'26035','Follansbee','',''),(13870,'26035','Weirton','',''),(13871,'26038','Mcmechen','',''),(13872,'26038','Moundsville','',''),(13873,'26070','Beech Bottom','',''),(13874,'26070','Bethany','',''),(13875,'26070','Windsor Heights','',''),(13876,'26075','Beech Bottom','',''),(13877,'26101','Vienna','',''),(13878,'26104','Vienna','',''),(13879,'26105','Parkersburg','',''),(13880,'26150','Parkersburg','',''),(13881,'26155','Paden City','',''),(13882,'26170','Belmont','',''),(13883,'26250','Junior','',''),(13884,'26260','Thomas','',''),(13885,'26269','Hendricks','',''),(13886,'26288','Bergoo','',''),(13887,'26301','Anmoore','',''),(13888,'26301','Bridgeport','',''),(13889,'26323','Clarksburg','',''),(13890,'26330','Anmoore','',''),(13891,'26330','Clarksburg','',''),(13892,'26347','Galloway','',''),(13893,'26404','Spelter','',''),(13894,'26431','Bridgeport','',''),(13895,'26431','Enterprise','',''),(13896,'26431','Gypsy','',''),(13897,'26501','Granville','',''),(13898,'26534','Morgantown','',''),(13899,'26541','Morgantown','',''),(13900,'26543','Granville','',''),(13901,'26554','Barrackville','',''),(13902,'26571','Idamay','',''),(13903,'26582','Rachel','',''),(13904,'26588','Grant Town','',''),(13905,'26591','Carolina','',''),(13906,'26591','Enterprise','',''),(13907,'26753','Wiley Ford','',''),(13908,'27012','Lewisville','',''),(13909,'27012','Winston-salem','',''),(13910,'27013','Statesville','',''),(13911,'27023','Winston-salem','',''),(13912,'27025','Mayodan','',''),(13913,'27028','Cooleemee','',''),(13914,'27040','Lewisville','',''),(13915,'27040','Winston-salem','',''),(13916,'27045','Winston-salem','',''),(13917,'27048','Mayodan','',''),(13918,'27101','Winston-salem','',''),(13919,'27103','Clemmons','',''),(13920,'27103','Winston-salem','',''),(13921,'27104','Winston-salem','',''),(13922,'27105','Winston-salem','',''),(13923,'27106','Lewisville','',''),(13924,'27106','Winston-salem','',''),(13925,'27107','Kernersville','',''),(13926,'27107','Winston-salem','',''),(13927,'27109','Winston-salem','',''),(13928,'27110','Winston-salem','',''),(13929,'27127','Winston-salem','',''),(13930,'27214','Greensboro','',''),(13931,'27215','Alamance','',''),(13932,'27215','Elon','',''),(13933,'27217','Elon','',''),(13934,'27217','Graham','',''),(13935,'27235','Greensboro','',''),(13936,'27235','High Point','',''),(13937,'27235','Kernersville','',''),(13938,'27239','Asheboro','',''),(13939,'27244','Burlington','',''),(13940,'27244','Elon','',''),(13941,'27249','Burlington','',''),(13942,'27249','Elon','',''),(13943,'27253','Burlington','',''),(13944,'27253','Saxapahaw','',''),(13945,'27258','Graham','',''),(13946,'27263','Archdale','',''),(13947,'27282','Greensboro','',''),(13948,'27282','High Point','',''),(13949,'27284','High Point','',''),(13950,'27284','Oak Ridge','',''),(13951,'27284','Winston-salem','',''),(13952,'27301','Greensboro','',''),(13953,'27313','Greensboro','',''),(13954,'27317','Asheboro','',''),(13955,'27350','Asheboro','',''),(13956,'27358','Greensboro','',''),(13957,'27358','Oak Ridge','',''),(13958,'27360','High Point','',''),(13959,'27370','Archdale','',''),(13960,'27376','Pinehurst','',''),(13961,'27376','Seven Lakes','',''),(13962,'27376','Southern Pines','',''),(13963,'27377','Burlington','',''),(13964,'27406','Pleasant Garden','',''),(13965,'27407','High Point','',''),(13966,'27409','High Point','',''),(13967,'27409','Oak Ridge','',''),(13968,'27410','High Point','',''),(13969,'27410','Summerfield','',''),(13970,'27455','Summerfield','',''),(13971,'27502','Cary','',''),(13972,'27502','Holly Springs','',''),(13973,'27503','Durham','',''),(13974,'27510','Chapel Hill','',''),(13975,'27511','Apex','',''),(13976,'27511','Raleigh','',''),(13977,'27513','Apex','',''),(13978,'27513','Morrisville','',''),(13979,'27516','Carrboro','',''),(13980,'27517','Durham','',''),(13981,'27518','Raleigh','',''),(13982,'27519','Apex','',''),(13983,'27519','Morrisville','',''),(13984,'27523','Cary','',''),(13985,'27529','Raleigh','',''),(13986,'27539','Cary','',''),(13987,'27539','Holly Springs','',''),(13988,'27545','Raleigh','',''),(13989,'27560','Cary','',''),(13990,'27560','Durham','',''),(13991,'27560','Raleigh','',''),(13992,'27562','Apex','',''),(13993,'27565','Stovall','',''),(13994,'27569','Pine Level','',''),(13995,'27576','Pine Level','',''),(13996,'27577','Pine Level','',''),(13997,'27587','Raleigh','',''),(13998,'27587','Rolesville','',''),(13999,'27591','Raleigh','',''),(14000,'27596','Wake Forest','',''),(14001,'27603','Garner','',''),(14002,'27606','Cary','',''),(14003,'27607','Cary','',''),(14004,'27610','Garner','',''),(14005,'27614','Wake Forest','',''),(14006,'27617','Cary','',''),(14007,'27703','Morrisville','',''),(14008,'27703','Raleigh','',''),(14009,'27707','Chapel Hill','',''),(14010,'27713','Cary','',''),(14011,'27803','Sharpsburg','',''),(14012,'27809','Rocky Mount','',''),(14013,'27822','Wilson','',''),(14014,'27829','Falkland','',''),(14015,'27834','Falkland','',''),(14016,'27837','Simpson','',''),(14017,'27839','Weldon','',''),(14018,'27857','Hamilton','',''),(14019,'27858','Simpson','',''),(14020,'27871','Hassell','',''),(14021,'27871','Parmele','',''),(14022,'27880','Wilson','',''),(14023,'27883','Saratoga','',''),(14024,'27886','Conetoe','',''),(14025,'27886','Speed','',''),(14026,'27890','Roanoke Rapids','',''),(14027,'27892','Everetts','',''),(14028,'27893','Black Creek','',''),(14029,'27924','Powellsville','',''),(14030,'27944','Winfall','',''),(14031,'27949','Kill Devil Hills','',''),(14032,'27968','Waves','',''),(14033,'27972','Waves','',''),(14034,'28001','Badin','',''),(14035,'28012','Cramerton','',''),(14036,'28012','Mcadenville','',''),(14037,'28012','Mount Holly','',''),(14038,'28016','Gastonia','',''),(14039,'28021','Waco','',''),(14040,'28023','Kannapolis','',''),(14041,'28023','Landis','',''),(14042,'28025','Harrisburg','',''),(14043,'28025','Kannapolis','',''),(14044,'28025','Locust','',''),(14045,'28027','Harrisburg','',''),(14046,'28027','Kannapolis','',''),(14047,'28031','Davidson','',''),(14048,'28031','Huntersville','',''),(14049,'28034','Gastonia','',''),(14050,'28034','High Shoals','',''),(14051,'28036','Cornelius','',''),(14052,'28036','Kannapolis','',''),(14053,'28037','Lake Norman Of Catawba','',''),(14054,'28040','Caroleen','',''),(14055,'28043','Caroleen','',''),(14056,'28043','Spindale','',''),(14057,'28054','Lowell','',''),(14058,'28056','Belmont','',''),(14059,'28056','Cramerton','',''),(14060,'28056','Lowell','',''),(14061,'28056','Mcadenville','',''),(14062,'28071','Misenheimer','',''),(14063,'28075','Concord','',''),(14064,'28076','Caroleen','',''),(14065,'28078','Charlotte','',''),(14066,'28078','Concord','',''),(14067,'28078','Cornelius','',''),(14068,'28078','Kannapolis','',''),(14069,'28079','Monroe','',''),(14070,'28079','Stallings','',''),(14071,'28081','Landis','',''),(14072,'28083','Concord','',''),(14073,'28083','Landis','',''),(14074,'28086','Gastonia','',''),(14075,'28086','Shelby','',''),(14076,'28092','High Shoals','',''),(14077,'28098','Gastonia','',''),(14078,'28098','Mcadenville','',''),(14079,'28101','Lowell','',''),(14080,'28101','Mcadenville','',''),(14081,'28102','Mcfarlan','',''),(14082,'28104','Indian Trail','',''),(14083,'28104','Stallings','',''),(14084,'28105','Charlotte','',''),(14085,'28105','Indian Trail','',''),(14086,'28105','Stallings','',''),(14087,'28107','Locust','',''),(14088,'28110','Indian Trail','',''),(14089,'28112','Mineral Springs','',''),(14090,'28114','Caroleen','',''),(14091,'28114','Henrietta','',''),(14092,'28115','Davidson','',''),(14093,'28119','Mcfarlan','',''),(14094,'28124','Concord','',''),(14095,'28124','Locust','',''),(14096,'28127','Albemarle','',''),(14097,'28127','Badin','',''),(14098,'28134','Charlotte','',''),(14099,'28137','Misenheimer','',''),(14100,'28139','Spindale','',''),(14101,'28144','East Spencer','',''),(14102,'28144','Spencer','',''),(14103,'28146','East Spencer','',''),(14104,'28146','Granite Quarry','',''),(14105,'28146','Spencer','',''),(14106,'28150','Lattimore','',''),(14107,'28150','Waco','',''),(14108,'28152','Boiling Springs','',''),(14109,'28163','Locust','',''),(14110,'28164','Mount Holly','',''),(14111,'28166','Statesville','',''),(14112,'28170','Ansonville','',''),(14113,'28173','Mineral Springs','',''),(14114,'28210','Pineville','',''),(14115,'28213','Harrisburg','',''),(14116,'28215','Harrisburg','',''),(14117,'28216','Huntersville','',''),(14118,'28226','Pineville','',''),(14119,'28262','Concord','',''),(14120,'28269','Concord','',''),(14121,'28270','Matthews','',''),(14122,'28307','Fayetteville','',''),(14123,'28307','Spring Lake','',''),(14124,'28308','Fayetteville','',''),(14125,'28308','Spring Lake','',''),(14126,'28310','Fayetteville','',''),(14127,'28315','Pinebluff','',''),(14128,'28315','Pinehurst','',''),(14129,'28315','Southern Pines','',''),(14130,'28327','Southern Pines','',''),(14131,'28333','Goldsboro','',''),(14132,'28334','Erwin','',''),(14133,'28337','Dublin','',''),(14134,'28338','Norman','',''),(14135,'28344','Falcon','',''),(14136,'28365','Calypso','',''),(14137,'28369','Proctorville','',''),(14138,'28374','Southern Pines','',''),(14139,'28379','Cordova','',''),(14140,'28387','Aberdeen','',''),(14141,'28387','Pinehurst','',''),(14142,'28390','Fayetteville','',''),(14143,'28395','Fayetteville','',''),(14144,'28401','Wrightsboro','',''),(14145,'28403','Wrightsville Beach','',''),(14146,'28405','Murraysville','',''),(14147,'28405','Wrightsboro','',''),(14148,'28405','Wrightsville Beach','',''),(14149,'28411','Murraysville','',''),(14150,'28422','Boiling Spring Lakes','',''),(14151,'28422','Oak Island','',''),(14152,'28428','Kure Beach','',''),(14153,'28429','Wrightsboro','',''),(14154,'28442','Lake Waccamaw','',''),(14155,'28461','Boiling Spring Lakes','',''),(14156,'28461','Oak Island','',''),(14157,'28467','Sunset Beach','',''),(14158,'28469','Sunset Beach','',''),(14159,'28472','Brunswick','',''),(14160,'28479','Boiling Spring Lakes','',''),(14161,'28479','Leland','',''),(14162,'28512','Morehead City','',''),(14163,'28513','Winterville','',''),(14164,'28516','Morehead City','',''),(14165,'28533','Havelock','',''),(14166,'28543','Jacksonville','',''),(14167,'28544','Jacksonville','',''),(14168,'28544','Piney Green','',''),(14169,'28546','Piney Green','',''),(14170,'28547','Jacksonville','',''),(14171,'28560','Bridgeton','',''),(14172,'28560','Havelock','',''),(14173,'28570','Morehead City','',''),(14174,'28580','Maury','',''),(14175,'28589','Davis','',''),(14176,'28590','Greenville','',''),(14177,'28601','Hildebran','',''),(14178,'28601','Rhodhiss','',''),(14179,'28602','Icard','',''),(14180,'28609','Lake Norman Of Catawba','',''),(14181,'28612','Hildebran','',''),(14182,'28612','Icard','',''),(14183,'28612','Rhodhiss','',''),(14184,'28612','Rutherford College','',''),(14185,'28613','Hickory','',''),(14186,'28630','Rhodhiss','',''),(14187,'28655','Drexel','',''),(14188,'28655','Glen Alpine','',''),(14189,'28658','Hickory','',''),(14190,'28673','Lake Norman Of Catawba','',''),(14191,'28682','Lake Norman Of Catawba','',''),(14192,'28690','Drexel','',''),(14193,'28690','Rutherford College','',''),(14194,'28704','Asheville','',''),(14195,'28704','Mills River','',''),(14196,'28711','Montreat','',''),(14197,'28715','Asheville','',''),(14198,'28720','Chimney Rock Village','',''),(14199,'28721','Lake Junaluska','',''),(14200,'28731','East Flat Rock','',''),(14201,'28732','Asheville','',''),(14202,'28732','Mills River','',''),(14203,'28739','Etowah','',''),(14204,'28739','Horse Shoe','',''),(14205,'28742','Etowah','',''),(14206,'28742','Mills River','',''),(14207,'28746','Chimney Rock Village','',''),(14208,'28756','Chimney Rock Village','',''),(14209,'28759','Etowah','',''),(14210,'28759','Horse Shoe','',''),(14211,'28778','Black Mountain','',''),(14212,'28779','Cullowhee','',''),(14213,'28779','Dillsboro','',''),(14214,'28785','Lake Junaluska','',''),(14215,'28786','Lake Junaluska','',''),(14216,'28791','Horse Shoe','',''),(14217,'28792','East Flat Rock','',''),(14218,'28792','Gerton','',''),(14219,'29033','West Columbia','',''),(14220,'29040','Sumter','',''),(14221,'29044','Columbia','',''),(14222,'29045','Columbia','',''),(14223,'29061','Columbia','',''),(14224,'29061','Gadsden','',''),(14225,'29063','Columbia','',''),(14226,'29063','St. Andrews','',''),(14227,'29069','Lydia','',''),(14228,'29073','West Columbia','',''),(14229,'29075','Peak','',''),(14230,'29147','Columbia','',''),(14231,'29152','Sumter','',''),(14232,'29169','Cayce','',''),(14233,'29170','Cayce','',''),(14234,'29172','Cayce','',''),(14235,'29201','Cayce','',''),(14236,'29204','Forest Acres','',''),(14237,'29206','Forest Acres','',''),(14238,'29209','Cayce','',''),(14239,'29210','St. Andrews','',''),(14240,'29212','St. Andrews','',''),(14241,'29223','Forest Acres','',''),(14242,'29301','Arcadia','',''),(14243,'29301','Saxon','',''),(14244,'29307','Clifton','',''),(14245,'29307','Converse','',''),(14246,'29307','Pacolet','',''),(14247,'29323','Mayo','',''),(14248,'29330','Mayo','',''),(14249,'29334','Reidville','',''),(14250,'29334','Startex','',''),(14251,'29335','Cross Anchor','',''),(14252,'29349','Fingerville','',''),(14253,'29355','Joanna','',''),(14254,'29369','Reidville','',''),(14255,'29369','Spartanburg','',''),(14256,'29373','Pacolet','',''),(14257,'29376','Spartanburg','',''),(14258,'29378','Saxon','',''),(14259,'29379','Lockhart','',''),(14260,'29385','Startex','',''),(14261,'29388','Reidville','',''),(14262,'29404','North Charleston','',''),(14263,'29405','Charleston','',''),(14264,'29406','Goose Creek','',''),(14265,'29406','Hanahan','',''),(14266,'29406','North Charleston','',''),(14267,'29410','Goose Creek','',''),(14268,'29410','Hanahan','',''),(14269,'29412','Folly Beach','',''),(14270,'29423','North Charleston','',''),(14271,'29429','Mount Pleasant','',''),(14272,'29445','Charleston','',''),(14273,'29445','Hanahan','',''),(14274,'29449','Ravenel','',''),(14275,'29450','Charleston','',''),(14276,'29455','Charleston','',''),(14277,'29455','Hollywood','',''),(14278,'29456','Goose Creek','',''),(14279,'29456','North Charleston','',''),(14280,'29461','Goose Creek','',''),(14281,'29461','Pinopolis','',''),(14282,'29464','Charleston','',''),(14283,'29470','Hollywood','',''),(14284,'29474','Jacksonboro','',''),(14285,'29483','Goose Creek','',''),(14286,'29483','Ladson','',''),(14287,'29483','North Charleston','',''),(14288,'29485','North Charleston','',''),(14289,'29487','Charleston','',''),(14290,'29526','North Myrtle Beach','',''),(14291,'29541','Florence','',''),(14292,'29550','Lydia','',''),(14293,'29566','North Myrtle Beach','',''),(14294,'29568','Myrtle Beach','',''),(14295,'29568','North Myrtle Beach','',''),(14296,'29570','Mccoll','',''),(14297,'29572','North Myrtle Beach','',''),(14298,'29577','Socastee','',''),(14299,'29579','North Myrtle Beach','',''),(14300,'29588','Socastee','',''),(14301,'29590','Lane','',''),(14302,'29605','Gantt','',''),(14303,'29607','Gantt','',''),(14304,'29607','Mauldin','',''),(14305,'29607','Wade Hampton','',''),(14306,'29609','Taylors','',''),(14307,'29609','Wade Hampton','',''),(14308,'29611','Berea','',''),(14309,'29611','Parker','',''),(14310,'29615','Taylors','',''),(14311,'29615','Wade Hampton','',''),(14312,'29617','Berea','',''),(14313,'29617','Parker','',''),(14314,'29630','Clemson','',''),(14315,'29630','Norris','',''),(14316,'29650','Taylors','',''),(14317,'29655','Lowndesville','',''),(14318,'29657','Norris','',''),(14319,'29661','Slater-marietta','',''),(14320,'29670','Clemson','',''),(14321,'29672','Newry','',''),(14322,'29673','Gantt','',''),(14323,'29680','Mauldin','',''),(14324,'29681','Mauldin','',''),(14325,'29683','Slater-marietta','',''),(14326,'29687','Wade Hampton','',''),(14327,'29803','New Ellenton','',''),(14328,'29828','Langley','',''),(14329,'29834','Gloverville','',''),(14330,'29835','Mccormick','',''),(14331,'29842','North Augusta','',''),(14332,'29847','Edgefield','',''),(14333,'29848','Mount Carmel','',''),(14334,'29851','Gloverville','',''),(14335,'29851','Langley','',''),(14336,'29853','Elko','',''),(14337,'29899','Mccormick','',''),(14338,'29902','Burton','',''),(14339,'29902','Port Royal','',''),(14340,'29905','Port Royal','',''),(14341,'29906','Burton','',''),(14342,'29906','Port Royal','',''),(14343,'29907','Beaufort','',''),(14344,'29907','Port Royal','',''),(14345,'29909','Port Royal','',''),(14346,'29918','Furman','',''),(14347,'29918','Scotia','',''),(14348,'29935','Beaufort','',''),(14349,'29940','Beaufort','',''),(14350,'29941','Beaufort','',''),(14351,'29944','Hampton','',''),(14352,'30002','Scottdale','',''),(14353,'30004','Milton','',''),(14354,'30004','Roswell','',''),(14355,'30005','Johns Creek','',''),(14356,'30009','Milton','',''),(14357,'30009','Roswell','',''),(14358,'30014','Porterdale','',''),(14359,'30016','Porterdale','',''),(14360,'30021','Scottdale','',''),(14361,'30021','Tucker','',''),(14362,'30022','Johns Creek','',''),(14363,'30022','Roswell','',''),(14364,'30024','Johns Creek','',''),(14365,'30024','Sugar Hill','',''),(14366,'30030','Avondale Estates','',''),(14367,'30030','Druid Hills','',''),(14368,'30030','North Decatur','',''),(14369,'30030','Scottdale','',''),(14370,'30032','Atlanta','',''),(14371,'30032','Avondale Estates','',''),(14372,'30032','Candler-mcafee','',''),(14373,'30033','Druid Hills','',''),(14374,'30033','North Decatur','',''),(14375,'30033','North Druid Hills','',''),(14376,'30033','Scottdale','',''),(14377,'30035','Redan','',''),(14378,'30058','Redan','',''),(14379,'30060','Smyrna','',''),(14380,'30075','Alpharetta','',''),(14381,'30075','Milton','',''),(14382,'30076','Alpharetta','',''),(14383,'30076','Johns Creek','',''),(14384,'30080','Vinings','',''),(14385,'30082','Mableton','',''),(14386,'30083','Pine Lake','',''),(14387,'30083','Scottdale','',''),(14388,'30088','Redan','',''),(14389,'30092','Sandy Springs','',''),(14390,'30097','Johns Creek','',''),(14391,'30106','Lithia Springs','',''),(14392,'30106','Mableton','',''),(14393,'30107','Nelson','',''),(14394,'30120','Emerson','',''),(14395,'30121','Emerson','',''),(14396,'30126','Smyrna','',''),(14397,'30134','Lithia Springs','',''),(14398,'30143','Nelson','',''),(14399,'30149','Rome','',''),(14400,'30161','Lindale','',''),(14401,'30168','Lithia Springs','',''),(14402,'30168','Mableton','',''),(14403,'30173','Lindale','',''),(14404,'30177','Nelson','',''),(14405,'30213','Palmetto','',''),(14406,'30213','Union City','',''),(14407,'30214','Peachtree City','',''),(14408,'30214','Tyrone','',''),(14409,'30215','Peachtree City','',''),(14410,'30223','Sunny Side','',''),(14411,'30228','Lovejoy','',''),(14412,'30228','Sunny Side','',''),(14413,'30236','Lovejoy','',''),(14414,'30259','Grantville','',''),(14415,'30260','Forest Park','',''),(14416,'30269','Tyrone','',''),(14417,'30276','Peachtree City','',''),(14418,'30276','Turin','',''),(14419,'30277','Turin','',''),(14420,'30290','Peachtree City','',''),(14421,'30294','Conley','',''),(14422,'30294','Forest Park','',''),(14423,'30297','Conley','',''),(14424,'30306','Druid Hills','',''),(14425,'30306','North Druid Hills','',''),(14426,'30307','Decatur','',''),(14427,'30307','Druid Hills','',''),(14428,'30315','East Point','',''),(14429,'30317','Candler-mcafee','',''),(14430,'30319','Dunwoody','',''),(14431,'30319','North Atlanta','',''),(14432,'30319','Sandy Springs','',''),(14433,'30322','Druid Hills','',''),(14434,'30324','North Atlanta','',''),(14435,'30324','North Druid Hills','',''),(14436,'30327','Sandy Springs','',''),(14437,'30328','Sandy Springs','',''),(14438,'30329','Druid Hills','',''),(14439,'30329','North Atlanta','',''),(14440,'30329','North Druid Hills','',''),(14441,'30337','College Park','',''),(14442,'30337','East Point','',''),(14443,'30338','Dunwoody','',''),(14444,'30338','Sandy Springs','',''),(14445,'30339','Sandy Springs','',''),(14446,'30339','Smyrna','',''),(14447,'30339','Vinings','',''),(14448,'30340','Tucker','',''),(14449,'30341','Dunwoody','',''),(14450,'30341','North Atlanta','',''),(14451,'30341','Tucker','',''),(14452,'30342','Sandy Springs','',''),(14453,'30344','College Park','',''),(14454,'30344','East Point','',''),(14455,'30346','Dunwoody','',''),(14456,'30349','College Park','',''),(14457,'30349','East Point','',''),(14458,'30349','Forest Park','',''),(14459,'30349','Union City','',''),(14460,'30350','Dunwoody','',''),(14461,'30350','Roswell','',''),(14462,'30350','Sandy Springs','',''),(14463,'30354','College Park','',''),(14464,'30354','East Point','',''),(14465,'30360','Dunwoody','',''),(14466,'30401','Nunez','',''),(14467,'30410','Alston','',''),(14468,'30417','Daisy','',''),(14469,'30417','Manassas','',''),(14470,'30421','Manassas','',''),(14471,'30421','Reidsville','',''),(14472,'30436','Vidalia','',''),(14473,'30439','Pulaski','',''),(14474,'30446','Oliver','',''),(14475,'30471','Stillmore','',''),(14476,'30473','Alston','',''),(14477,'30510','Baldwin','',''),(14478,'30518','Sugar Hill','',''),(14479,'30519','Braselton','',''),(14480,'30523','Tallulah Falls','',''),(14481,'30525','Mountain City','',''),(14482,'30531','Baldwin','',''),(14483,'30542','Braselton','',''),(14484,'30548','Braselton','',''),(14485,'30552','Tallulah Falls','',''),(14486,'30558','Commerce','',''),(14487,'30566','Gainesville','',''),(14488,'30571','Helen','',''),(14489,'30601','Athens-clarke County Unified Government (balance),','',''),(14490,'30602','Athens-clarke County Unified Government (balance),','',''),(14491,'30605','Athens-clarke County Unified Government (balance),','',''),(14492,'30606','Athens-clarke County Unified Government (balance),','',''),(14493,'30607','Athens-clarke County Unified Government (balance),','',''),(14494,'30609','Athens-clarke County Unified Government (balance),','',''),(14495,'30622','Athens-clarke County Unified Government (balance),','',''),(14496,'30631','Sharon','',''),(14497,'30642','Siloam','',''),(14498,'30646','Athens-clarke County Unified Government (balance),','',''),(14499,'30683','Athens-clarke County Unified Government (balance),','',''),(14500,'30707','Fort Oglethorpe','',''),(14501,'30710','Varnell','',''),(14502,'30720','Varnell','',''),(14503,'30721','Varnell','',''),(14504,'30736','Fort Oglethorpe','',''),(14505,'30740','Dalton','',''),(14506,'30741','Fort Oglethorpe','',''),(14507,'30755','Dalton','',''),(14508,'30755','Varnell','',''),(14509,'30805','Augusta-richmond County Consolidated Government (b','',''),(14510,'30809','Martinez','',''),(14511,'30812','Augusta-richmond County Consolidated Government (b','',''),(14512,'30813','Augusta-richmond County Consolidated Government (b','',''),(14513,'30815','Augusta-richmond County Consolidated Government (b','',''),(14514,'30828','Camak','',''),(14515,'30901','Augusta-richmond County Consolidated Government (b','',''),(14516,'30904','Augusta-richmond County Consolidated Government (b','',''),(14517,'30905','Augusta-richmond County Consolidated Government (b','',''),(14518,'30906','Augusta-richmond County Consolidated Government (b','',''),(14519,'30907','Augusta-richmond County Consolidated Government (b','',''),(14520,'30907','Evans','',''),(14521,'30907','Martinez','',''),(14522,'30909','Augusta-richmond County Consolidated Government (b','',''),(14523,'30912','Augusta-richmond County Consolidated Government (b','',''),(14524,'31005','Warner Robins','',''),(14525,'31008','Centerville','',''),(14526,'31008','Fort Valley','',''),(14527,'31008','Warner Robins','',''),(14528,'31017','Allentown','',''),(14529,'31028','Warner Robins','',''),(14530,'31030','Perry','',''),(14531,'31030','Warner Robins','',''),(14532,'31037','Mcrae','',''),(14533,'31037','Scotland','',''),(14534,'31047','Perry','',''),(14535,'31047','Warner Robins','',''),(14536,'31055','Helena','',''),(14537,'31055','Mcrae','',''),(14538,'31055','Scotland','',''),(14539,'31065','Allentown','',''),(14540,'31068','Ideal','',''),(14541,'31068','Montezuma','',''),(14542,'31072','Seville','',''),(14543,'31089','Oconee','',''),(14544,'31092','Lilly','',''),(14545,'31093','Centerville','',''),(14546,'31301','Walthourville','',''),(14547,'31302','Pooler','',''),(14548,'31302','Savannah','',''),(14549,'31313','Fort Stewart','',''),(14550,'31313','Walthourville','',''),(14551,'31314','Hinesville','',''),(14552,'31322','Port Wentworth','',''),(14553,'31322','Savannah','',''),(14554,'31405','Garden City','',''),(14555,'31405','Pooler','',''),(14556,'31407','Garden City','',''),(14557,'31407','Port Wentworth','',''),(14558,'31408','Garden City','',''),(14559,'31408','Pooler','',''),(14560,'31410','Wilmington Island','',''),(14561,'31411','Skidaway Island','',''),(14562,'31415','Garden City','',''),(14563,'31419','Pooler','',''),(14564,'31516','Waycross','',''),(14565,'31522','St. Simons','',''),(14566,'31537','Kingsland','',''),(14567,'31547','Kings Bay Base','',''),(14568,'31547','St. Marys','',''),(14569,'31548','St. Marys','',''),(14570,'31557','Offerman','',''),(14571,'31558','Kings Bay Base','',''),(14572,'31558','Kingsland','',''),(14573,'31558','St. Marys','',''),(14574,'31569','Kingsland','',''),(14575,'31620','Cecil','',''),(14576,'31620','Sparks','',''),(14577,'31632','Cecil','',''),(14578,'31634','Argyle','',''),(14579,'31647','Adel','',''),(14580,'31750','Ocilla','',''),(14581,'31771','Moultrie','',''),(14582,'31778','Barwick','',''),(14583,'31780','Webster County Unified','',''),(14584,'31788','Berlin','',''),(14585,'31790','Ashburn','',''),(14586,'31801','Columbus','',''),(14587,'31803','Webster County Unified','',''),(14588,'31805','Cusseta-chattahoochee County Unified','',''),(14589,'31808','Columbus','',''),(14590,'31820','Columbus','',''),(14591,'31824','Webster County Unified','',''),(14592,'31825','Webster County Unified','',''),(14593,'31826','Manchester','',''),(14594,'31829','Columbus','',''),(14595,'31830','Manchester','',''),(14596,'31832','Webster County Unified','',''),(14597,'31833','Lagrange','',''),(14598,'31905','Columbus','',''),(14599,'31905','Cusseta-chattahoochee County Unified','',''),(14600,'32003','Fleming Island','',''),(14601,'32034','Yulee','',''),(14602,'32043','Penney Farms','',''),(14603,'32065','Lakeside','',''),(14604,'32068','Lakeside','',''),(14605,'32073','Bellair-meadowbrook Terrace','',''),(14606,'32073','Fleming Island','',''),(14607,'32073','Jacksonville','',''),(14608,'32073','Lakeside','',''),(14609,'32080','St. Augustine Beach','',''),(14610,'32081','Nocatee','',''),(14611,'32082','Palm Valley','',''),(14612,'32095','Nocatee','',''),(14613,'32110','Palm Coast','',''),(14614,'32112','Welaka','',''),(14615,'32117','Holly Hill','',''),(14616,'32117','Ormond Beach','',''),(14617,'32118','Port Orange','',''),(14618,'32118','South Daytona','',''),(14619,'32119','Port Orange','',''),(14620,'32119','South Daytona','',''),(14621,'32127','New Smyrna Beach','',''),(14622,'32128','New Smyrna Beach','',''),(14623,'32129','Daytona Beach','',''),(14624,'32129','South Daytona','',''),(14625,'32136','Palm Coast','',''),(14626,'32141','Oak Hill','',''),(14627,'32145','Flagler Estates','',''),(14628,'32159','The Villages','',''),(14629,'32162','The Villages','',''),(14630,'32168','Edgewater','',''),(14631,'32168','Port Orange','',''),(14632,'32174','Daytona Beach','',''),(14633,'32174','Holly Hill','',''),(14634,'32176','Ormond-by-the-sea','',''),(14635,'32189','Welaka','',''),(14636,'32195','Lady Lake','',''),(14637,'32233','Jacksonville','',''),(14638,'32250','Jacksonville','',''),(14639,'32259','Fruit Cove','',''),(14640,'32328','Carrabelle','',''),(14641,'32333','Midway','',''),(14642,'32344','Wacissa','',''),(14643,'32351','Gretna','',''),(14644,'32352','Gretna','',''),(14645,'32355','St. Marks','',''),(14646,'32403','Tyndall Afb','',''),(14647,'32404','Callaway','',''),(14648,'32404','Lynn Haven','',''),(14649,'32405','Lynn Haven','',''),(14650,'32407','Upper Grand Lagoon','',''),(14651,'32408','Panama City Beach','',''),(14652,'32408','Upper Grand Lagoon','',''),(14653,'32409','Lynn Haven','',''),(14654,'32428','Wausau','',''),(14655,'32444','Panama City','',''),(14656,'32456','Mexico Beach','',''),(14657,'32456','Port St. Joe','',''),(14658,'32459','Miramar Beach','',''),(14659,'32501','West Pensacola','',''),(14660,'32502','Warrington','',''),(14661,'32503','Ferry Pass','',''),(14662,'32504','Ferry Pass','',''),(14663,'32505','Bellview','',''),(14664,'32505','Warrington','',''),(14665,'32505','West Pensacola','',''),(14666,'32506','Myrtle Grove','',''),(14667,'32506','Warrington','',''),(14668,'32506','West Pensacola','',''),(14669,'32507','Myrtle Grove','',''),(14670,'32507','Warrington','',''),(14671,'32507','West Pensacola','',''),(14672,'32508','Warrington','',''),(14673,'32509','Bellview','',''),(14674,'32511','Myrtle Grove','',''),(14675,'32514','Ensley','',''),(14676,'32514','Ferry Pass','',''),(14677,'32526','Bellview','',''),(14678,'32533','Ensley','',''),(14679,'32534','Ensley','',''),(14680,'32542','Valparaiso','',''),(14681,'32544','Fort Walton Beach','',''),(14682,'32547','Wright','',''),(14683,'32548','Wright','',''),(14684,'32550','Miramar Beach','',''),(14685,'32563','Midway','',''),(14686,'32566','Midway','',''),(14687,'32571','Pace','',''),(14688,'32578','Valparaiso','',''),(14689,'32579','Eglin Afb','',''),(14690,'32579','Lake Lorraine','',''),(14691,'32583','Bagdad','',''),(14692,'32583','East Milton','',''),(14693,'32609','La Crosse','',''),(14694,'32615','High Springs','',''),(14695,'32615','La Crosse','',''),(14696,'32622','La Crosse','',''),(14697,'32626','Otter Creek','',''),(14698,'32643','Alachua','',''),(14699,'32653','Alachua','',''),(14700,'32664','Mcintosh','',''),(14701,'32667','Mcintosh','',''),(14702,'32701','Casselberry','',''),(14703,'32701','Fern Park','',''),(14704,'32703','Lockhart','',''),(14705,'32703','Ocoee','',''),(14706,'32703','Zellwood','',''),(14707,'32707','Altamonte Springs','',''),(14708,'32707','Fern Park','',''),(14709,'32707','Longwood','',''),(14710,'32707','Winter Springs','',''),(14711,'32708','Casselberry','',''),(14712,'32708','Longwood','',''),(14713,'32708','Oviedo','',''),(14714,'32712','Zellwood','',''),(14715,'32713','Deltona','',''),(14716,'32726','Mount Dora','',''),(14717,'32726','Tavares','',''),(14718,'32730','Altamonte Springs','',''),(14719,'32730','Fern Park','',''),(14720,'32735','Eustis','',''),(14721,'32736','Mount Dora','',''),(14722,'32738','Lake Helen','',''),(14723,'32744','Deltona','',''),(14724,'32746','Sanford','',''),(14725,'32750','Winter Springs','',''),(14726,'32751','Altamonte Springs','',''),(14727,'32751','Casselberry','',''),(14728,'32751','Fern Park','',''),(14729,'32751','Winter Park','',''),(14730,'32754','Titusville','',''),(14731,'32757','Eustis','',''),(14732,'32757','Tavares','',''),(14733,'32757','Zellwood','',''),(14734,'32759','Edgewater','',''),(14735,'32763','Debary','',''),(14736,'32764','Deltona','',''),(14737,'32765','Winter Springs','',''),(14738,'32767','Lake Kathryn','',''),(14739,'32776','Apopka','',''),(14740,'32778','Astatula','',''),(14741,'32778','Eustis','',''),(14742,'32778','Leesburg','',''),(14743,'32778','Mount Dora','',''),(14744,'32779','Wekiwa Springs','',''),(14745,'32784','Eustis','',''),(14746,'32789','Maitland','',''),(14747,'32789','Orlando','',''),(14748,'32792','Casselberry','',''),(14749,'32796','Mims','',''),(14750,'32798','Apopka','',''),(14751,'32803','Winter Park','',''),(14752,'32808','Pine Hills','',''),(14753,'32809','Pine Castle','',''),(14754,'32810','Lockhart','',''),(14755,'32810','Maitland','',''),(14756,'32810','Pine Hills','',''),(14757,'32814','Winter Park','',''),(14758,'32817','Alafaya','',''),(14759,'32817','University','',''),(14760,'32818','Ocoee','',''),(14761,'32818','Pine Hills','',''),(14762,'32819','Lake Butler','',''),(14763,'32820','Bithlo','',''),(14764,'32824','Meadow Woods','',''),(14765,'32825','Alafaya','',''),(14766,'32826','Alafaya','',''),(14767,'32826','University','',''),(14768,'32828','Alafaya','',''),(14769,'32829','Alafaya','',''),(14770,'32830','Bay Lake','',''),(14771,'32831','Alafaya','',''),(14772,'32833','Bithlo','',''),(14773,'32833','Wedgefield','',''),(14774,'32836','Bay Lake','',''),(14775,'32839','Pine Castle','',''),(14776,'32901','West Melbourne','',''),(14777,'32903','Melbourne','',''),(14778,'32904','West Melbourne','',''),(14779,'32905','Melbourne','',''),(14780,'32909','Grant-valkaria','',''),(14781,'32926','Rockledge','',''),(14782,'32931','Cape Canaveral','',''),(14783,'32934','West Melbourne','',''),(14784,'32937','Melbourne','',''),(14785,'32948','Palm Bay','',''),(14786,'32949','Grant-valkaria','',''),(14787,'32949','Malabar','',''),(14788,'32949','Micco','',''),(14789,'32950','Grant-valkaria','',''),(14790,'32950','Palm Bay','',''),(14791,'32952','Melbourne','',''),(14792,'32958','Fellsmere','',''),(14793,'32960','Vero Beach South','',''),(14794,'32962','Florida Ridge','',''),(14795,'32962','Vero Beach South','',''),(14796,'32966','Fellsmere','',''),(14797,'32966','Vero Beach South','',''),(14798,'32966','West Vero Corridor','',''),(14799,'32967','Fellsmere','',''),(14800,'32967','Sebastian','',''),(14801,'32968','Florida Ridge','',''),(14802,'32968','Vero Beach South','',''),(14803,'32970','Sebastian','',''),(14804,'32976','Grant-valkaria','',''),(14805,'32976','Micco','',''),(14806,'33001','Layton','',''),(14807,'33004','Dania Beach','',''),(14808,'33004','Fort Lauderdale','',''),(14809,'33004','Hollywood','',''),(14810,'33009','Hallandale Beach','',''),(14811,'33009','Hollywood','',''),(14812,'33013','Opa-locka','',''),(14813,'33013','Westview','',''),(14814,'33014','Country Club','',''),(14815,'33014','Miami Gardens','',''),(14816,'33014','Opa-locka','',''),(14817,'33015','Country Club','',''),(14818,'33019','Hallandale Beach','',''),(14819,'33023','Miramar','',''),(14820,'33023','Pembroke Pines','',''),(14821,'33024','Cooper City','',''),(14822,'33024','Davie','',''),(14823,'33024','Pembroke Pines','',''),(14824,'33025','Miramar','',''),(14825,'33025','Pembroke Pines','',''),(14826,'33026','Cooper City','',''),(14827,'33026','Pembroke Pines','',''),(14828,'33027','Miramar','',''),(14829,'33027','Pembroke Pines','',''),(14830,'33028','Pembroke Pines','',''),(14831,'33029','Miramar','',''),(14832,'33029','Pembroke Pines','',''),(14833,'33032','Leisure City','',''),(14834,'33032','Princeton','',''),(14835,'33033','Leisure City','',''),(14836,'33034','Florida City','',''),(14837,'33035','Florida City','',''),(14838,'33036','Islamorada, Village Of Islands','',''),(14839,'33050','Key Colony Beach','',''),(14840,'33054','Miami Gardens','',''),(14841,'33054','Opa-locka','',''),(14842,'33055','Miami Gardens','',''),(14843,'33056','Miami Gardens','',''),(14844,'33063','Coconut Creek','',''),(14845,'33063','Coral Springs','',''),(14846,'33063','Margate','',''),(14847,'33064','Deerfield Beach','',''),(14848,'33065','Coral Springs','',''),(14849,'33066','Coconut Creek','',''),(14850,'33067','Coconut Creek','',''),(14851,'33067','Coral Springs','',''),(14852,'33068','Margate','',''),(14853,'33068','North Lauderdale','',''),(14854,'33068','Tamarac','',''),(14855,'33070','Islamorada, Village Of Islands','',''),(14856,'33070','Key Largo','',''),(14857,'33071','Coral Springs','',''),(14858,'33073','Coconut Creek','',''),(14859,'33073','Coral Springs','',''),(14860,'33073','Deerfield Beach','',''),(14861,'33076','Coral Springs','',''),(14862,'33109','Miami','',''),(14863,'33122','Doral','',''),(14864,'33126','Doral','',''),(14865,'33126','Fountainebleau','',''),(14866,'33132','Miami Beach','',''),(14867,'33133','Coral Gables','',''),(14868,'33134','Coral Gables','',''),(14869,'33135','Coral Gables','',''),(14870,'33139','Miami','',''),(14871,'33142','Hialeah','',''),(14872,'33142','Miami Springs','',''),(14873,'33143','Coral Gables','',''),(14874,'33143','Glenvar Heights','',''),(14875,'33143','Kendall','',''),(14876,'33143','Pinecrest','',''),(14877,'33144','Coral Terrace','',''),(14878,'33144','Fountainebleau','',''),(14879,'33146','Coral Gables','',''),(14880,'33147','Hialeah','',''),(14881,'33147','West Little River','',''),(14882,'33147','Westview','',''),(14883,'33149','Miami','',''),(14884,'33150','West Little River','',''),(14885,'33154','Surfside','',''),(14886,'33155','Coral Gables','',''),(14887,'33155','Coral Terrace','',''),(14888,'33155','Glenvar Heights','',''),(14889,'33156','Coral Gables','',''),(14890,'33156','Kendall','',''),(14891,'33156','Pinecrest','',''),(14892,'33157','Coral Gables','',''),(14893,'33157','Cutler Bay','',''),(14894,'33157','Kendall','',''),(14895,'33157','Palmetto Bay','',''),(14896,'33157','South Miami Heights','',''),(14897,'33158','Coral Gables','',''),(14898,'33158','Palmetto Bay','',''),(14899,'33160','Aventura','',''),(14900,'33160','North Miami','',''),(14901,'33160','Sunny Isles Beach','',''),(14902,'33161','North Miami','',''),(14903,'33162','North Miami','',''),(14904,'33162','North Miami Beach','',''),(14905,'33165','University Park','',''),(14906,'33166','Doral','',''),(14907,'33166','Miami Springs','',''),(14908,'33167','North Miami','',''),(14909,'33167','Opa-locka','',''),(14910,'33167','Westview','',''),(14911,'33168','North Miami','',''),(14912,'33169','Miami Gardens','',''),(14913,'33169','North Miami Beach','',''),(14914,'33170','Goulds','',''),(14915,'33170','Princeton','',''),(14916,'33172','Doral','',''),(14917,'33172','Fountainebleau','',''),(14918,'33172','Sweetwater','',''),(14919,'33173','Kendall','',''),(14920,'33174','Fountainebleau','',''),(14921,'33174','Sweetwater','',''),(14922,'33174','University Park','',''),(14923,'33175','Kendale Lakes','',''),(14924,'33175','Tamiami','',''),(14925,'33175','University Park','',''),(14926,'33176','Kendall','',''),(14927,'33176','Palmetto Bay','',''),(14928,'33177','Goulds','',''),(14929,'33177','Richmond West','',''),(14930,'33177','South Miami Heights','',''),(14931,'33178','Doral','',''),(14932,'33179','Ives Estates','',''),(14933,'33179','Miami Gardens','',''),(14934,'33179','North Miami Beach','',''),(14935,'33180','Aventura','',''),(14936,'33181','North Miami','',''),(14937,'33181','North Miami Beach','',''),(14938,'33182','Tamiami','',''),(14939,'33183','Kendale Lakes','',''),(14940,'33183','Kendall','',''),(14941,'33184','Tamiami','',''),(14942,'33185','Kendall West','',''),(14943,'33186','Kendale Lakes','',''),(14944,'33186','Kendall','',''),(14945,'33186','The Crossings','',''),(14946,'33186','The Hammocks','',''),(14947,'33187','Richmond West','',''),(14948,'33189','Cutler Bay','',''),(14949,'33189','Goulds','',''),(14950,'33189','South Miami Heights','',''),(14951,'33190','Cutler Bay','',''),(14952,'33190','Goulds','',''),(14953,'33190','Princeton','',''),(14954,'33193','Kendale Lakes','',''),(14955,'33193','Kendall West','',''),(14956,'33196','Kendall West','',''),(14957,'33196','The Hammocks','',''),(14958,'33306','Oakland Park','',''),(14959,'33308','Oakland Park','',''),(14960,'33309','North Lauderdale','',''),(14961,'33309','Oakland Park','',''),(14962,'33309','Tamarac','',''),(14963,'33311','Lauderhill','',''),(14964,'33311','Oakland Park','',''),(14965,'33311','Plantation','',''),(14966,'33312','Dania Beach','',''),(14967,'33312','Davie','',''),(14968,'33312','Hollywood','',''),(14969,'33312','Lauderhill','',''),(14970,'33312','Plantation','',''),(14971,'33313','Lauderhill','',''),(14972,'33313','Plantation','',''),(14973,'33313','Sunrise','',''),(14974,'33314','Dania Beach','',''),(14975,'33314','Davie','',''),(14976,'33314','Hollywood','',''),(14977,'33315','Dania Beach','',''),(14978,'33316','Dania Beach','',''),(14979,'33316','Hollywood','',''),(14980,'33317','Davie','',''),(14981,'33317','Lauderhill','',''),(14982,'33317','Plantation','',''),(14983,'33319','Lauderhill','',''),(14984,'33319','North Lauderdale','',''),(14985,'33319','Sunrise','',''),(14986,'33319','Tamarac','',''),(14987,'33321','Tamarac','',''),(14988,'33322','Plantation','',''),(14989,'33322','Sunrise','',''),(14990,'33323','Plantation','',''),(14991,'33323','Sunrise','',''),(14992,'33324','Davie','',''),(14993,'33324','Plantation','',''),(14994,'33325','Davie','',''),(14995,'33325','Plantation','',''),(14996,'33325','Sunrise','',''),(14997,'33326','Davie','',''),(14998,'33326','Sunrise','',''),(14999,'33326','Weston','',''),(15000,'33327','Weston','',''),(15001,'33328','Cooper City','',''),(15002,'33328','Davie','',''),(15003,'33330','Cooper City','',''),(15004,'33330','Davie','',''),(15005,'33330','Pembroke Pines','',''),(15006,'33331','Davie','',''),(15007,'33331','Pembroke Pines','',''),(15008,'33331','Weston','',''),(15009,'33332','Pembroke Pines','',''),(15010,'33332','Weston','',''),(15011,'33334','Oakland Park','',''),(15012,'33351','Lauderhill','',''),(15013,'33351','Sunrise','',''),(15014,'33351','Tamarac','',''),(15015,'33403','Lake Park','',''),(15016,'33403','North Palm Beach','',''),(15017,'33403','Palm Beach Gardens','',''),(15018,'33403','Riviera Beach','',''),(15019,'33404','Lake Park','',''),(15020,'33404','Palm Beach Gardens','',''),(15021,'33404','Riviera Beach','',''),(15022,'33407','Riviera Beach','',''),(15023,'33408','Jupiter','',''),(15024,'33408','Lake Park','',''),(15025,'33408','Palm Beach Gardens','',''),(15026,'33410','Jupiter','',''),(15027,'33410','North Palm Beach','',''),(15028,'33410','Riviera Beach','',''),(15029,'33411','Royal Palm Beach','',''),(15030,'33411','The Acreage','',''),(15031,'33411','Wellington','',''),(15032,'33412','Palm Beach Gardens','',''),(15033,'33412','The Acreage','',''),(15034,'33413','Greenacres','',''),(15035,'33414','Royal Palm Beach','',''),(15036,'33414','Wellington','',''),(15037,'33415','Greenacres','',''),(15038,'33418','Jupiter','',''),(15039,'33418','Riviera Beach','',''),(15040,'33430','South Bay','',''),(15041,'33441','Pompano Beach','',''),(15042,'33444','Boca Raton','',''),(15043,'33445','Boca Raton','',''),(15044,'33445','Boynton Beach','',''),(15045,'33449','Wellington','',''),(15046,'33460','Lantana','',''),(15047,'33461','Lantana','',''),(15048,'33462','Boynton Beach','',''),(15049,'33462','Lantana','',''),(15050,'33463','Greenacres','',''),(15051,'33467','Greenacres','',''),(15052,'33467','Wellington','',''),(15053,'33470','Royal Palm Beach','',''),(15054,'33470','The Acreage','',''),(15055,'33470','Wellington','',''),(15056,'33476','Canal Point','',''),(15057,'33478','Jupiter Farms','',''),(15058,'33480','Lake Worth','',''),(15059,'33480','Lantana','',''),(15060,'33483','Boynton Beach','',''),(15061,'33503','Riverview','',''),(15062,'33511','Bloomingdale','',''),(15063,'33511','Riverview','',''),(15064,'33527','Brandon','',''),(15065,'33527','Thonotosassa','',''),(15066,'33527','Valrico','',''),(15067,'33534','Apollo Beach','',''),(15068,'33534','Riverview','',''),(15069,'33538','Coleman','',''),(15070,'33543','Wesley Chapel','',''),(15071,'33544','Wesley Chapel','',''),(15072,'33547','Fish Hawk','',''),(15073,'33548','Cheval','',''),(15074,'33548','Land O Lakes','',''),(15075,'33549','Land O Lakes','',''),(15076,'33549','University','',''),(15077,'33556','Citrus Park','',''),(15078,'33556','Keystone','',''),(15079,'33558','Cheval','',''),(15080,'33558','Keystone','',''),(15081,'33558','Land O Lakes','',''),(15082,'33559','Land O Lakes','',''),(15083,'33559','University','',''),(15084,'33559','Wesley Chapel','',''),(15085,'33569','Fish Hawk','',''),(15086,'33570','Apollo Beach','',''),(15087,'33570','Sun City Center','',''),(15088,'33572','Gibsonton','',''),(15089,'33572','Ruskin','',''),(15090,'33573','Apollo Beach','',''),(15091,'33573','Riverview','',''),(15092,'33578','Apollo Beach','',''),(15093,'33578','Brandon','',''),(15094,'33578','Gibsonton','',''),(15095,'33578','Palm River-clair Mel','',''),(15096,'33579','Balm','',''),(15097,'33584','Brandon','',''),(15098,'33584','Thonotosassa','',''),(15099,'33585','Coleman','',''),(15100,'33594','Brandon','',''),(15101,'33596','Bloomingdale','',''),(15102,'33596','Brandon','',''),(15103,'33598','Balm','',''),(15104,'33598','Riverview','',''),(15105,'33598','Ruskin','',''),(15106,'33598','Sun City Center','',''),(15107,'33604','Egypt Lake-leto','',''),(15108,'33607','Town N Country','',''),(15109,'33612','Carrollwood','',''),(15110,'33612','University','',''),(15111,'33613','University','',''),(15112,'33614','Egypt Lake-leto','',''),(15113,'33615','Town N Country','',''),(15114,'33617','Temple Terrace','',''),(15115,'33618','Carrollwood','',''),(15116,'33618','Egypt Lake-leto','',''),(15117,'33619','Brandon','',''),(15118,'33619','Palm River-clair Mel','',''),(15119,'33624','Carrollwood','',''),(15120,'33625','Citrus Park','',''),(15121,'33626','Keystone','',''),(15122,'33626','Westchase','',''),(15123,'33634','Town N Country','',''),(15124,'33635','Town N Country','',''),(15125,'33637','Temple Terrace','',''),(15126,'33647','Lutz','',''),(15127,'33647','University','',''),(15128,'33701','St. Petersburg','',''),(15129,'33702','Lealman','',''),(15130,'33702','Pinellas Park','',''),(15131,'33702','St. Petersburg','',''),(15132,'33703','St. Petersburg','',''),(15133,'33704','St. Petersburg','',''),(15134,'33705','St. Petersburg','',''),(15135,'33706','St. Pete Beach','',''),(15136,'33707','Gulfport','',''),(15137,'33707','St. Pete Beach','',''),(15138,'33707','St. Petersburg','',''),(15139,'33708','Bay Pines','',''),(15140,'33708','Madeira Beach','',''),(15141,'33709','Lealman','',''),(15142,'33709','Pinellas Park','',''),(15143,'33709','St. Petersburg','',''),(15144,'33709','West Lealman','',''),(15145,'33710','St. Petersburg','',''),(15146,'33711','Gulfport','',''),(15147,'33711','St. Petersburg','',''),(15148,'33712','St. Petersburg','',''),(15149,'33713','St. Petersburg','',''),(15150,'33714','Lealman','',''),(15151,'33714','Pinellas Park','',''),(15152,'33714','St. Petersburg','',''),(15153,'33715','St. Petersburg','',''),(15154,'33715','Tierra Verde','',''),(15155,'33716','Pinellas Park','',''),(15156,'33716','St. Petersburg','',''),(15157,'33755','Dunedin','',''),(15158,'33756','Largo','',''),(15159,'33759','Safety Harbor','',''),(15160,'33760','Largo','',''),(15161,'33760','Pinellas Park','',''),(15162,'33761','Dunedin','',''),(15163,'33761','Oldsmar','',''),(15164,'33761','Safety Harbor','',''),(15165,'33762','Feather Sound','',''),(15166,'33762','Largo','',''),(15167,'33762','Pinellas Park','',''),(15168,'33762','St. Petersburg','',''),(15169,'33763','Dunedin','',''),(15170,'33764','Largo','',''),(15171,'33764','Pinellas Park','',''),(15172,'33767','Clearwater','',''),(15173,'33771','Pinellas Park','',''),(15174,'33772','Bay Pines','',''),(15175,'33773','Pinellas Park','',''),(15176,'33777','Bardmoor','',''),(15177,'33777','Pinellas Park','',''),(15178,'33781','Lealman','',''),(15179,'33781','West Lealman','',''),(15180,'33782','St. Petersburg','',''),(15181,'33812','Highland City','',''),(15182,'33813','Fuller Heights','',''),(15183,'33813','Highland City','',''),(15184,'33813','Lakeland Highlands','',''),(15185,'33823','Lakeland','',''),(15186,'33823','Winter Haven','',''),(15187,'33830','Eagle Lake','',''),(15188,'33830','Highland City','',''),(15189,'33830','Homeland','',''),(15190,'33830','Winter Haven','',''),(15191,'33837','Haines City','',''),(15192,'33837','Poinciana','',''),(15193,'33838','Lake Hamilton','',''),(15194,'33839','Winter Haven','',''),(15195,'33844','Dundee','',''),(15196,'33844','Lake Alfred','',''),(15197,'33844','Lake Hamilton','',''),(15198,'33844','Poinciana','',''),(15199,'33844','Winter Haven','',''),(15200,'33847','Fort Meade','',''),(15201,'33850','Auburndale','',''),(15202,'33850','Winter Haven','',''),(15203,'33859','Dundee','',''),(15204,'33859','Waverly','',''),(15205,'33859','Winter Haven','',''),(15206,'33860','Fuller Heights','',''),(15207,'33868','Auburndale','',''),(15208,'33868','Lakeland','',''),(15209,'33877','Dundee','',''),(15210,'33877','Lake Wales','',''),(15211,'33880','Auburndale','',''),(15212,'33880','Bartow','',''),(15213,'33880','Eagle Lake','',''),(15214,'33881','Auburndale','',''),(15215,'33881','Lake Alfred','',''),(15216,'33881','Lake Hamilton','',''),(15217,'33884','Dundee','',''),(15218,'33884','Lake Wales','',''),(15219,'33896','Four Corners','',''),(15220,'33897','Four Corners','',''),(15221,'33898','Dundee','',''),(15222,'33903','Cape Coral','',''),(15223,'33903','Fort Myers','',''),(15224,'33905','Lehigh Acres','',''),(15225,'33907','Villas','',''),(15226,'33908','Fort Myers Beach','',''),(15227,'33908','San Carlos Park','',''),(15228,'33909','North Fort Myers','',''),(15229,'33912','San Carlos Park','',''),(15230,'33912','Villas','',''),(15231,'33913','Estero','',''),(15232,'33913','Gateway','',''),(15233,'33913','Lehigh Acres','',''),(15234,'33917','Fort Myers','',''),(15235,'33919','Cypress Lake','',''),(15236,'33920','Lehigh Acres','',''),(15237,'33922','Pine Island Center','',''),(15238,'33922','St. James City','',''),(15239,'33924','Sanibel','',''),(15240,'33928','Bonita Springs','',''),(15241,'33931','Bonita Springs','',''),(15242,'33946','Rotonda','',''),(15243,'33947','Rotonda','',''),(15244,'33955','Cape Coral','',''),(15245,'33956','St. James City','',''),(15246,'33965','Estero','',''),(15247,'33966','Villas','',''),(15248,'33967','Estero','',''),(15249,'33967','San Carlos Park','',''),(15250,'33971','Fort Myers','',''),(15251,'33990','Fort Myers','',''),(15252,'34108','Pelican Bay','',''),(15253,'34110','Bonita Springs','',''),(15254,'34113','Naples Manor','',''),(15255,'34114','Everglades','',''),(15256,'34116','Golden Gate','',''),(15257,'34119','Bonita Springs','',''),(15258,'34120','Immokalee','',''),(15259,'34134','Estero','',''),(15260,'34135','Estero','',''),(15261,'34139','Everglades','',''),(15262,'34140','Marco Island','',''),(15263,'34141','Everglades','',''),(15264,'34145','Goodland','',''),(15265,'34203','Bayshore Gardens','',''),(15266,'34207','Bayshore Gardens','',''),(15267,'34210','Bayshore Gardens','',''),(15268,'34210','Cortez','',''),(15269,'34210','Longboat Key','',''),(15270,'34217','Holmes Beach','',''),(15271,'34223','North Port','',''),(15272,'34223','South Venice','',''),(15273,'34224','North Port','',''),(15274,'34224','Rotonda','',''),(15275,'34229','Laurel','',''),(15276,'34231','Gulf Gate Estates','',''),(15277,'34231','Siesta Key','',''),(15278,'34232','Sarasota Springs','',''),(15279,'34233','Bee Ridge','',''),(15280,'34233','Sarasota Springs','',''),(15281,'34235','The Meadows','',''),(15282,'34238','Gulf Gate Estates','',''),(15283,'34242','Siesta Key','',''),(15284,'34266','North Port','',''),(15285,'34275','Laurel','',''),(15286,'34275','Venice','',''),(15287,'34285','South Venice','',''),(15288,'34291','North Port','',''),(15289,'34292','North Port','',''),(15290,'34293','North Port','',''),(15291,'34293','South Venice','',''),(15292,'34429','Homosassa Springs','',''),(15293,'34429','Lecanto','',''),(15294,'34433','Citrus Springs','',''),(15295,'34434','Citrus Springs','',''),(15296,'34434','Hernando','',''),(15297,'34442','Lecanto','',''),(15298,'34445','Citrus Springs','',''),(15299,'34446','Homosassa Springs','',''),(15300,'34446','Lecanto','',''),(15301,'34446','Sugarmill Woods','',''),(15302,'34448','Homosassa Springs','',''),(15303,'34448','Lecanto','',''),(15304,'34449','Yankeetown','',''),(15305,'34450','Inverness Highlands South','',''),(15306,'34452','Inverness Highlands South','',''),(15307,'34453','Hernando','',''),(15308,'34461','Homosassa Springs','',''),(15309,'34461','Sugarmill Woods','',''),(15310,'34465','Citrus Springs','',''),(15311,'34484','The Villages','',''),(15312,'34491','The Villages','',''),(15313,'34601','Spring Hill','',''),(15314,'34604','Spring Hill','',''),(15315,'34607','Aripeka','',''),(15316,'34607','North Weeki Wachee','',''),(15317,'34610','Shady Hills','',''),(15318,'34613','North Weeki Wachee','',''),(15319,'34613','Spring Hill','',''),(15320,'34614','North Weeki Wachee','',''),(15321,'34652','Elfers','',''),(15322,'34653','Elfers','',''),(15323,'34654','Jasmine Estates','',''),(15324,'34667','Aripeka','',''),(15325,'34667','Shady Hills','',''),(15326,'34668','Jasmine Estates','',''),(15327,'34669','Shady Hills','',''),(15328,'34677','East Lake','',''),(15329,'34681','Palm Harbor','',''),(15330,'34683','Dunedin','',''),(15331,'34683','Tarpon Springs','',''),(15332,'34684','Dunedin','',''),(15333,'34684','East Lake','',''),(15334,'34684','Oldsmar','',''),(15335,'34684','Tarpon Springs','',''),(15336,'34685','East Lake','',''),(15337,'34685','Oldsmar','',''),(15338,'34688','East Lake','',''),(15339,'34689','East Lake','',''),(15340,'34689','Palm Harbor','',''),(15341,'34690','Elfers','',''),(15342,'34691','Elfers','',''),(15343,'34695','Clearwater','',''),(15344,'34695','Oldsmar','',''),(15345,'34698','Palm Harbor','',''),(15346,'34711','Groveland','',''),(15347,'34711','Minneola','',''),(15348,'34714','Four Corners','',''),(15349,'34715','Astatula','',''),(15350,'34715','Groveland','',''),(15351,'34715','Minneola','',''),(15352,'34731','Lady Lake','',''),(15353,'34731','Leesburg','',''),(15354,'34734','Ocoee','',''),(15355,'34736','Clermont','',''),(15356,'34736','Leesburg','',''),(15357,'34736','Mascotte','',''),(15358,'34737','Groveland','',''),(15359,'34737','Yalaha','',''),(15360,'34743','Buenaventura Lakes','',''),(15361,'34744','Buenaventura Lakes','',''),(15362,'34744','St. Cloud','',''),(15363,'34747','Bay Lake','',''),(15364,'34747','Celebration','',''),(15365,'34747','Four Corners','',''),(15366,'34748','Mascotte','',''),(15367,'34756','Minneola','',''),(15368,'34758','Poinciana','',''),(15369,'34759','Poinciana','',''),(15370,'34761','Lake Butler','',''),(15371,'34761','Winter Garden','',''),(15372,'34762','Leesburg','',''),(15373,'34762','Yalaha','',''),(15374,'34769','St. Cloud','',''),(15375,'34771','St. Cloud','',''),(15376,'34772','St. Cloud','',''),(15377,'34785','Coleman','',''),(15378,'34785','The Villages','',''),(15379,'34786','Lake Butler','',''),(15380,'34786','Ocoee','',''),(15381,'34787','Bay Lake','',''),(15382,'34787','Four Corners','',''),(15383,'34787','Lake Butler','',''),(15384,'34787','Oakland','',''),(15385,'34787','Ocoee','',''),(15386,'34797','Leesburg','',''),(15387,'34945','Port St. Lucie','',''),(15388,'34946','Fort Pierce North','',''),(15389,'34946','Lakewood Park','',''),(15390,'34947','Fort Pierce North','',''),(15391,'34950','Fort Pierce North','',''),(15392,'34951','Lakewood Park','',''),(15393,'34952','Port St. Lucie','',''),(15394,'34953','Port St. Lucie','',''),(15395,'34957','Port St. Lucie','',''),(15396,'34957','Stuart','',''),(15397,'34982','Port St. Lucie','',''),(15398,'34983','Port St. Lucie','',''),(15399,'34984','Port St. Lucie','',''),(15400,'34986','Port St. Lucie','',''),(15401,'34987','Port St. Lucie','',''),(15402,'34990','Port St. Lucie','',''),(15403,'34994','Jensen Beach','',''),(15404,'34994','Port St. Lucie','',''),(15405,'34996','Jensen Beach','',''),(15406,'35004','Leeds','',''),(15407,'35004','Margaret','',''),(15408,'35004','Trussville','',''),(15409,'35005','Birmingham','',''),(15410,'35005','Forestdale','',''),(15411,'35005','Graysville','',''),(15412,'35005','Sylvan Springs','',''),(15413,'35006','Hueytown','',''),(15414,'35007','Calera','',''),(15415,'35007','Helena','',''),(15416,'35007','Pelham','',''),(15417,'35010','New Site','',''),(15418,'35014','Childersburg','',''),(15419,'35014','Sylacauga','',''),(15420,'35014','Talladega','',''),(15421,'35014','Vincent','',''),(15422,'35020','Birmingham','',''),(15423,'35020','Midfield','',''),(15424,'35022','Birmingham','',''),(15425,'35022','Helena','',''),(15426,'35022','Hoover','',''),(15427,'35023','Birmingham','',''),(15428,'35023','Hueytown','',''),(15429,'35023','Pleasant Grove','',''),(15430,'35034','Centreville','',''),(15431,'35035','Wilton','',''),(15432,'35040','Alabaster','',''),(15433,'35042','Brent','',''),(15434,'35043','Pelham','',''),(15435,'35044','Bon Air','',''),(15436,'35045','Thorsby','',''),(15437,'35049','Locust Fork','',''),(15438,'35051','Calera','',''),(15439,'35051','Chelsea','',''),(15440,'35051','Pelham','',''),(15441,'35054','Pell City','',''),(15442,'35060','Adamsville','',''),(15443,'35061','Birmingham','',''),(15444,'35061','Hueytown','',''),(15445,'35062','Adamsville','',''),(15446,'35062','Sumiton','',''),(15447,'35063','Sipsey','',''),(15448,'35064','Birmingham','',''),(15449,'35064','Midfield','',''),(15450,'35068','Birmingham','',''),(15451,'35068','Gardendale','',''),(15452,'35071','Fultondale','',''),(15453,'35071','Kimberly','',''),(15454,'35071','Mount Olive','',''),(15455,'35072','Millerville','',''),(15456,'35073','Adamsville','',''),(15457,'35073','Brookside','',''),(15458,'35077','Cullman','',''),(15459,'35077','Garden City','',''),(15460,'35078','Vincent','',''),(15461,'35079','Garden City','',''),(15462,'35080','Alabaster','',''),(15463,'35080','Hoover','',''),(15464,'35080','Pelham','',''),(15465,'35085','Thorsby','',''),(15466,'35089','Alexander City','',''),(15467,'35094','Birmingham','',''),(15468,'35094','Irondale','',''),(15469,'35094','Moody','',''),(15470,'35094','Vandiver','',''),(15471,'35111','Bessemer','',''),(15472,'35111','Woodstock','',''),(15473,'35114','Alabaster','',''),(15474,'35114','Helena','',''),(15475,'35115','Alabaster','',''),(15476,'35115','Calera','',''),(15477,'35115','Wilton','',''),(15478,'35116','Fultondale','',''),(15479,'35116','Gardendale','',''),(15480,'35116','Kimberly','',''),(15481,'35117','Birmingham','',''),(15482,'35117','Brookside','',''),(15483,'35117','Gardendale','',''),(15484,'35117','Graysville','',''),(15485,'35118','Adamsville','',''),(15486,'35118','Birmingham','',''),(15487,'35118','Pleasant Grove','',''),(15488,'35118','Sylvan Springs','',''),(15489,'35119','Fultondale','',''),(15490,'35119','Gardendale','',''),(15491,'35120','Margaret','',''),(15492,'35120','Moody','',''),(15493,'35121','Allgood','',''),(15494,'35124','Alabaster','',''),(15495,'35124','Chelsea','',''),(15496,'35124','Helena','',''),(15497,'35124','Hoover','',''),(15498,'35125','Riverside','',''),(15499,'35126','Birmingham','',''),(15500,'35126','Trussville','',''),(15501,'35127','Birmingham','',''),(15502,'35127','Hueytown','',''),(15503,'35130','Adamsville','',''),(15504,'35130','Birmingham','',''),(15505,'35133','Locust Fork','',''),(15506,'35135','Pell City','',''),(15507,'35147','Chelsea','',''),(15508,'35147','Harpersville','',''),(15509,'35147','Vandiver','',''),(15510,'35149','Sylacauga','',''),(15511,'35150','Bon Air','',''),(15512,'35150','Childersburg','',''),(15513,'35151','Childersburg','',''),(15514,'35160','Lincoln','',''),(15515,'35160','Sylacauga','',''),(15516,'35172','Locust Fork','',''),(15517,'35173','Birmingham','',''),(15518,'35173','Irondale','',''),(15519,'35173','Leeds','',''),(15520,'35173','Moody','',''),(15521,'35179','Cullman','',''),(15522,'35180','Kimberly','',''),(15523,'35184','Woodstock','',''),(15524,'35186','Chelsea','',''),(15525,'35186','Harpersville','',''),(15526,'35206','Irondale','',''),(15527,'35207','Fultondale','',''),(15528,'35209','Homewood','',''),(15529,'35209','Vestavia Hills','',''),(15530,'35210','Irondale','',''),(15531,'35210','Leeds','',''),(15532,'35210','Mountain Brook','',''),(15533,'35210','Trussville','',''),(15534,'35210','Vestavia Hills','',''),(15535,'35211','Bessemer','',''),(15536,'35213','Irondale','',''),(15537,'35213','Mountain Brook','',''),(15538,'35214','Adamsville','',''),(15539,'35214','Brookside','',''),(15540,'35214','Forestdale','',''),(15541,'35214','Graysville','',''),(15542,'35215','Fultondale','',''),(15543,'35215','Gardendale','',''),(15544,'35216','Homewood','',''),(15545,'35216','Hoover','',''),(15546,'35216','Mountain Brook','',''),(15547,'35216','Vestavia Hills','',''),(15548,'35217','Fultondale','',''),(15549,'35217','Gardendale','',''),(15550,'35217','Tarrant','',''),(15551,'35221','Midfield','',''),(15552,'35223','Homewood','',''),(15553,'35223','Irondale','',''),(15554,'35223','Mountain Brook','',''),(15555,'35223','Vestavia Hills','',''),(15556,'35224','Adamsville','',''),(15557,'35224','Fairfield','',''),(15558,'35224','Pleasant Grove','',''),(15559,'35226','Bessemer','',''),(15560,'35226','Homewood','',''),(15561,'35226','Hoover','',''),(15562,'35226','Vestavia Hills','',''),(15563,'35228','Fairfield','',''),(15564,'35228','Midfield','',''),(15565,'35229','Homewood','',''),(15566,'35235','Irondale','',''),(15567,'35235','Trussville','',''),(15568,'35242','Chelsea','',''),(15569,'35242','Hoover','',''),(15570,'35242','Irondale','',''),(15571,'35242','Pelham','',''),(15572,'35242','Vestavia Hills','',''),(15573,'35243','Mountain Brook','',''),(15574,'35243','Vestavia Hills','',''),(15575,'35244','Bessemer','',''),(15576,'35244','Hoover','',''),(15577,'35244','Pelham','',''),(15578,'35401','Northport','',''),(15579,'35406','Northport','',''),(15580,'35444','Tuscaloosa','',''),(15581,'35446','Tuscaloosa','',''),(15582,'35447','Aliceville','',''),(15583,'35452','Northport','',''),(15584,'35452','Tuscaloosa','',''),(15585,'35453','Tuscaloosa','',''),(15586,'35456','Tuscaloosa','',''),(15587,'35470','Bellamy','',''),(15588,'35473','Tuscaloosa','',''),(15589,'35475','Tuscaloosa','',''),(15590,'35476','Tuscaloosa','',''),(15591,'35490','Tuscaloosa','',''),(15592,'35490','Woodstock','',''),(15593,'35548','Winfield','',''),(15594,'35554','Glen Allen','',''),(15595,'35555','Belk','',''),(15596,'35555','Glen Allen','',''),(15597,'35563','Brilliant','',''),(15598,'35563','Hamilton','',''),(15599,'35563','Winfield','',''),(15600,'35564','Bear Creek','',''),(15601,'35565','Bear Creek','',''),(15602,'35565','Lynn','',''),(15603,'35574','Belk','',''),(15604,'35575','Natural Bridge','',''),(15605,'35578','Lynn','',''),(15606,'35581','Bear Creek','',''),(15607,'35594','Brilliant','',''),(15608,'35594','Glen Allen','',''),(15609,'35613','Huntsville','',''),(15610,'35618','North Courtland','',''),(15611,'35622','Hartselle','',''),(15612,'35640','Decatur','',''),(15613,'35646','Muscle Shoals','',''),(15614,'35649','Huntsville','',''),(15615,'35660','Muscle Shoals','',''),(15616,'35661','Sheffield','',''),(15617,'35671','Athens','',''),(15618,'35671','Decatur','',''),(15619,'35671','Huntsville','',''),(15620,'35673','Decatur','',''),(15621,'35674','Muscle Shoals','',''),(15622,'35741','Huntsville','',''),(15623,'35744','Scottsboro','',''),(15624,'35748','Huntsville','',''),(15625,'35749','Huntsville','',''),(15626,'35750','Meridianville','',''),(15627,'35756','Athens','',''),(15628,'35756','Huntsville','',''),(15629,'35757','Huntsville','',''),(15630,'35758','Huntsville','',''),(15631,'35759','Huntsville','',''),(15632,'35763','Huntsville','',''),(15633,'35765','Sylvania','',''),(15634,'35771','Scottsboro','',''),(15635,'35772','Bridgeport','',''),(15636,'35773','Huntsville','',''),(15637,'35773','Meridianville','',''),(15638,'35776','Scottsboro','',''),(15639,'35808','Madison','',''),(15640,'35808','Redstone Arsenal','',''),(15641,'35901','Rainbow City','',''),(15642,'35903','Glencoe','',''),(15643,'35904','Attalla','',''),(15644,'35905','Glencoe','',''),(15645,'35905','Southside','',''),(15646,'35906','Gadsden','',''),(15647,'35907','Glencoe','',''),(15648,'35907','Southside','',''),(15649,'35950','Boaz','',''),(15650,'35952','Walnut Grove','',''),(15651,'35954','Gadsden','',''),(15652,'35954','Rainbow City','',''),(15653,'35954','Whitesboro','',''),(15654,'35956','Whitesboro','',''),(15655,'35957','Albertville','',''),(15656,'35962','Geraldine','',''),(15657,'35968','Rainsville','',''),(15658,'35968','Sylvania','',''),(15659,'35971','Geraldine','',''),(15660,'35976','Albertville','',''),(15661,'35978','Sylvania','',''),(15662,'35984','Fort Payne','',''),(15663,'35986','Sylvania','',''),(15664,'36013','Pike Road','',''),(15665,'36016','Eufaula','',''),(15666,'36020','Millbrook','',''),(15667,'36022','Millbrook','',''),(15668,'36025','Coosada','',''),(15669,'36025','Millbrook','',''),(15670,'36043','Montgomery','',''),(15671,'36052','Pike Road','',''),(15672,'36054','Coosada','',''),(15673,'36054','Prattville','',''),(15674,'36064','Montgomery','',''),(15675,'36066','Millbrook','',''),(15676,'36088','Tuskegee','',''),(15677,'36091','Clanton','',''),(15678,'36093','Redland','',''),(15679,'36116','Pike Road','',''),(15680,'36117','Pike Road','',''),(15681,'36201','Oxford','',''),(15682,'36201','Saks','',''),(15683,'36203','Anniston','',''),(15684,'36206','Saks','',''),(15685,'36206','Weaver','',''),(15686,'36207','Oxford','',''),(15687,'36250','Saks','',''),(15688,'36251','Millerville','',''),(15689,'36256','New Site','',''),(15690,'36260','Lincoln','',''),(15691,'36260','Oxford','',''),(15692,'36265','Alexandria','',''),(15693,'36265','Weaver','',''),(15694,'36268','Oxford','',''),(15695,'36271','Southside','',''),(15696,'36277','Saks','',''),(15697,'36279','Alexandria','',''),(15698,'36279','Glencoe','',''),(15699,'36301','Cowarts','',''),(15700,'36303','Cowarts','',''),(15701,'36303','Headland','',''),(15702,'36303','Webb','',''),(15703,'36312','Cowarts','',''),(15704,'36312','Dothan','',''),(15705,'36321','Dothan','',''),(15706,'36321','Webb','',''),(15707,'36330','Daleville','',''),(15708,'36344','Geneva','',''),(15709,'36345','Dothan','',''),(15710,'36350','Dothan','',''),(15711,'36350','Pinckard','',''),(15712,'36352','Daleville','',''),(15713,'36362','Ozark','',''),(15714,'36421','River Falls','',''),(15715,'36436','Fulton','',''),(15716,'36442','Lockhart','',''),(15717,'36445','Excel','',''),(15718,'36451','Fulton','',''),(15719,'36451','Thomasville','',''),(15720,'36460','Excel','',''),(15721,'36474','River Falls','',''),(15722,'36477','Geneva','',''),(15723,'36505','Creola','',''),(15724,'36507','Spanish Fort','',''),(15725,'36521','Saraland','',''),(15726,'36523','Bayou La Batre','',''),(15727,'36523','Dauphin Island','',''),(15728,'36525','Axis','',''),(15729,'36525','Satsuma','',''),(15730,'36526','Fairhope','',''),(15731,'36527','Daphne','',''),(15732,'36530','Foley','',''),(15733,'36530','Orange Beach','',''),(15734,'36532','Daphne','',''),(15735,'36532','Point Clear','',''),(15736,'36535','Magnolia Springs','',''),(15737,'36541','Bayou La Batre','',''),(15738,'36542','Foley','',''),(15739,'36542','Orange Beach','',''),(15740,'36544','Bayou La Batre','',''),(15741,'36553','Malcolm','',''),(15742,'36559','Fairhope','',''),(15743,'36560','Bucks','',''),(15744,'36561','Gulf Shores','',''),(15745,'36569','St. Stephens','',''),(15746,'36571','Chickasaw','',''),(15747,'36571','Mobile','',''),(15748,'36571','Prichard','',''),(15749,'36571','Satsuma','',''),(15750,'36572','Saraland','',''),(15751,'36575','Mobile','',''),(15752,'36578','Spanish Fort','',''),(15753,'36580','Foley','',''),(15754,'36582','Bayou La Batre','',''),(15755,'36582','Mobile','',''),(15756,'36582','Tillmans Corner','',''),(15757,'36610','Chickasaw','',''),(15758,'36610','Prichard','',''),(15759,'36611','Chickasaw','',''),(15760,'36611','Prichard','',''),(15761,'36611','Saraland','',''),(15762,'36612','Prichard','',''),(15763,'36613','Mobile','',''),(15764,'36613','Prichard','',''),(15765,'36616','Prichard','',''),(15766,'36617','Prichard','',''),(15767,'36618','Prichard','',''),(15768,'36619','Tillmans Corner','',''),(15769,'36720','Boykin','',''),(15770,'36742','Demopolis','',''),(15771,'36768','Oak Hill','',''),(15772,'36782','Myrtlewood','',''),(15773,'36801','Auburn','',''),(15774,'36804','Auburn','',''),(15775,'36830','Opelika','',''),(15776,'36832','Loachapoka','',''),(15777,'36849','Auburn','',''),(15778,'36852','Lanett','',''),(15779,'36852','Opelika','',''),(15780,'36852','Valley','',''),(15781,'36861','Alexander City','',''),(15782,'36863','Valley','',''),(15783,'36866','Tuskegee','',''),(15784,'36875','Phenix City','',''),(15785,'36877','Phenix City','',''),(15786,'36879','Auburn','',''),(15787,'37013','Nashville-davidson Metropolitan Government (balanc','',''),(15788,'37015','Nashville-davidson Metropolitan Government (balanc','',''),(15789,'37015','Pleasant View','',''),(15790,'37019','Lewisburg','',''),(15791,'37022','Hartsville/trousdale','',''),(15792,'37027','Franklin','',''),(15793,'37027','Nashville-davidson Metropolitan Government (balanc','',''),(15794,'37027','Nolensville','',''),(15795,'37029','Dickson','',''),(15796,'37031','Hartsville/trousdale','',''),(15797,'37035','Pleasant View','',''),(15798,'37048','Cross Plains','',''),(15799,'37048','White House','',''),(15800,'37049','Orlinda','',''),(15801,'37051','Slayden','',''),(15802,'37057','Hartsville/trousdale','',''),(15803,'37064','Nashville-davidson Metropolitan Government (balanc','',''),(15804,'37066','Hendersonville','',''),(15805,'37067','Brentwood','',''),(15806,'37069','Brentwood','',''),(15807,'37072','Nashville-davidson Metropolitan Government (balanc','',''),(15808,'37073','White House','',''),(15809,'37074','Hartsville/trousdale','',''),(15810,'37075','Gallatin','',''),(15811,'37075','Goodlettsville','',''),(15812,'37076','Nashville-davidson Metropolitan Government (balanc','',''),(15813,'37080','Nashville-davidson Metropolitan Government (balanc','',''),(15814,'37082','Pegram','',''),(15815,'37086','Nashville-davidson Metropolitan Government (balanc','',''),(15816,'37086','Smyrna','',''),(15817,'37087','Hartsville/trousdale','',''),(15818,'37115','Goodlettsville','',''),(15819,'37115','Nashville-davidson Metropolitan Government (balanc','',''),(15820,'37122','Lebanon','',''),(15821,'37122','Nashville-davidson Metropolitan Government (balanc','',''),(15822,'37129','Smyrna','',''),(15823,'37135','La Vergne','',''),(15824,'37135','Nashville-davidson Metropolitan Government (balanc','',''),(15825,'37135','Smyrna','',''),(15826,'37138','Nashville-davidson Metropolitan Government (balanc','',''),(15827,'37143','Nashville-davidson Metropolitan Government (balanc','',''),(15828,'37144','Lynchburg, Moore County Metropolitan','',''),(15829,'37148','Orlinda','',''),(15830,'37153','Murfreesboro','',''),(15831,'37160','Lynchburg, Moore County Metropolitan','',''),(15832,'37167','La Vergne','',''),(15833,'37167','Murfreesboro','',''),(15834,'37172','Orlinda','',''),(15835,'37174','Columbia','',''),(15836,'37179','Spring Hill','',''),(15837,'37183','Lynchburg, Moore County Metropolitan','',''),(15838,'37183','Shelbyville','',''),(15839,'37188','Cross Plains','',''),(15840,'37189','Nashville-davidson Metropolitan Government (balanc','',''),(15841,'37201','Nashville-davidson Metropolitan Government (balanc','',''),(15842,'37203','Nashville-davidson Metropolitan Government (balanc','',''),(15843,'37204','Nashville-davidson Metropolitan Government (balanc','',''),(15844,'37205','Nashville-davidson Metropolitan Government (balanc','',''),(15845,'37206','Nashville-davidson Metropolitan Government (balanc','',''),(15846,'37207','Nashville-davidson Metropolitan Government (balanc','',''),(15847,'37208','Nashville-davidson Metropolitan Government (balanc','',''),(15848,'37209','Nashville-davidson Metropolitan Government (balanc','',''),(15849,'37210','Nashville-davidson Metropolitan Government (balanc','',''),(15850,'37211','Nashville-davidson Metropolitan Government (balanc','',''),(15851,'37212','Nashville-davidson Metropolitan Government (balanc','',''),(15852,'37213','Nashville-davidson Metropolitan Government (balanc','',''),(15853,'37214','Nashville-davidson Metropolitan Government (balanc','',''),(15854,'37215','Nashville-davidson Metropolitan Government (balanc','',''),(15855,'37216','Nashville-davidson Metropolitan Government (balanc','',''),(15856,'37217','Nashville-davidson Metropolitan Government (balanc','',''),(15857,'37218','Nashville-davidson Metropolitan Government (balanc','',''),(15858,'37219','Nashville-davidson Metropolitan Government (balanc','',''),(15859,'37220','Nashville-davidson Metropolitan Government (balanc','',''),(15860,'37221','Nashville-davidson Metropolitan Government (balanc','',''),(15861,'37228','Nashville-davidson Metropolitan Government (balanc','',''),(15862,'37240','Nashville-davidson Metropolitan Government (balanc','',''),(15863,'37243','Nashville-davidson Metropolitan Government (balanc','',''),(15864,'37246','Nashville-davidson Metropolitan Government (balanc','',''),(15865,'37301','Beersheba Springs','',''),(15866,'37302','Collegedale','',''),(15867,'37305','Altamont','',''),(15868,'37306','Lynchburg, Moore County Metropolitan','',''),(15869,'37311','Apison','',''),(15870,'37313','Altamont','',''),(15871,'37313','Gruetli-laager','',''),(15872,'37317','Ducktown','',''),(15873,'37318','Winchester','',''),(15874,'37324','Winchester','',''),(15875,'37334','Lynchburg, Moore County Metropolitan','',''),(15876,'37339','Gruetli-laager','',''),(15877,'37341','Chattanooga','',''),(15878,'37343','Chattanooga','',''),(15879,'37350','Chattanooga','',''),(15880,'37351','Chattanooga','',''),(15881,'37352','Lynchburg, Moore County Metropolitan','',''),(15882,'37353','Apison','',''),(15883,'37353','Cleveland','',''),(15884,'37353','Collegedale','',''),(15885,'37355','Tullahoma','',''),(15886,'37357','Viola','',''),(15887,'37359','Lynchburg, Moore County Metropolitan','',''),(15888,'37360','Lynchburg, Moore County Metropolitan','',''),(15889,'37360','Tullahoma','',''),(15890,'37363','Apison','',''),(15891,'37363','Chattanooga','',''),(15892,'37363','Collegedale','',''),(15893,'37365','Gruetli-laager','',''),(15894,'37377','Chattanooga','',''),(15895,'37379','Chattanooga','',''),(15896,'37379','Sale Creek','',''),(15897,'37387','Coalmont','',''),(15898,'37388','Lynchburg, Moore County Metropolitan','',''),(15899,'37391','Ducktown','',''),(15900,'37398','Cowan','',''),(15901,'37398','Lynchburg, Moore County Metropolitan','',''),(15902,'37404','East Ridge','',''),(15903,'37405','Signal Mountain','',''),(15904,'37411','East Ridge','',''),(15905,'37412','East Ridge','',''),(15906,'37601','Elizabethton','',''),(15907,'37601','Unicoi','',''),(15908,'37616','Greeneville','',''),(15909,'37617','Bristol','',''),(15910,'37617','Kingsport','',''),(15911,'37618','Bristol','',''),(15912,'37641','Greeneville','',''),(15913,'37642','Mount Carmel','',''),(15914,'37650','Unicoi','',''),(15915,'37659','Johnson City','',''),(15916,'37659','Kingsport','',''),(15917,'37660','Mount Carmel','',''),(15918,'37663','Colonial Heights','',''),(15919,'37682','Elizabethton','',''),(15920,'37686','Johnson City','',''),(15921,'37694','Johnson City','',''),(15922,'37705','Norris','',''),(15923,'37716','Norris','',''),(15924,'37716','Oak Ridge','',''),(15925,'37723','Fairfield Glade','',''),(15926,'37724','Harrogate','',''),(15927,'37729','Jellico','',''),(15928,'37737','Maryville','',''),(15929,'37748','Coalfield','',''),(15930,'37748','Oak Ridge','',''),(15931,'37763','Oak Ridge','',''),(15932,'37764','Sevierville','',''),(15933,'37766','Jellico','',''),(15934,'37771','Oak Ridge','',''),(15935,'37772','Farragut','',''),(15936,'37777','Alcoa','',''),(15937,'37801','Alcoa','',''),(15938,'37804','Alcoa','',''),(15939,'37819','Jellico','',''),(15940,'37820','Jefferson City','',''),(15941,'37840','Coalfield','',''),(15942,'37840','Oak Ridge','',''),(15943,'37840','Petros','',''),(15944,'37847','Jellico','',''),(15945,'37849','Knoxville','',''),(15946,'37852','Elgin','',''),(15947,'37853','Alcoa','',''),(15948,'37857','Kingsport','',''),(15949,'37860','Morristown','',''),(15950,'37862','Pigeon Forge','',''),(15951,'37871','Knoxville','',''),(15952,'37872','Elgin','',''),(15953,'37876','Pigeon Forge','',''),(15954,'37877','Jefferson City','',''),(15955,'37877','Morristown','',''),(15956,'37920','Alcoa','',''),(15957,'37920','Seymour','',''),(15958,'37924','Mascot','',''),(15959,'37932','Farragut','',''),(15960,'37934','Farragut','',''),(15961,'38001','Maury City','',''),(15962,'38002','Bartlett','',''),(15963,'38002','Gallaway','',''),(15964,'38002','Lakeland','',''),(15965,'38002','Memphis','',''),(15966,'38004','Munford','',''),(15967,'38011','Atoka','',''),(15968,'38011','Covington','',''),(15969,'38016','Lakeland','',''),(15970,'38016','Memphis','',''),(15971,'38018','Memphis','',''),(15972,'38028','Memphis','',''),(15973,'38028','Oakland','',''),(15974,'38029','Bartlett','',''),(15975,'38034','Maury City','',''),(15976,'38039','La Grange','',''),(15977,'38049','Gallaway','',''),(15978,'38053','Atoka','',''),(15979,'38053','Bartlett','',''),(15980,'38053','Munford','',''),(15981,'38057','La Grange','',''),(15982,'38068','Oakland','',''),(15983,'38120','Germantown','',''),(15984,'38125','Collierville','',''),(15985,'38125','Germantown','',''),(15986,'38133','Bartlett','',''),(15987,'38134','Bartlett','',''),(15988,'38135','Bartlett','',''),(15989,'38138','Memphis','',''),(15990,'38139','Collierville','',''),(15991,'38201','Mckenzie','',''),(15992,'38232','Samburg','',''),(15993,'38235','Mclemoresville','',''),(15994,'38258','Mclemoresville','',''),(15995,'38310','Crump','',''),(15996,'38332','Milledgeville','',''),(15997,'38342','Bruceton','',''),(15998,'38343','Jackson','',''),(15999,'38344','Mclemoresville','',''),(16000,'38357','Guys','',''),(16001,'38358','Medina','',''),(16002,'38367','Guys','',''),(16003,'38401','Mount Pleasant','',''),(16004,'38401','Spring Hill','',''),(16005,'38449','Elkton','',''),(16006,'38463','St. Joseph','',''),(16007,'38469','St. Joseph','',''),(16008,'38477','Elkton','',''),(16009,'38481','St. Joseph','',''),(16010,'38547','Gordonsville','',''),(16011,'38555','Crab Orchard','',''),(16012,'38556','Grimsley','',''),(16013,'38558','Fairfield Glade','',''),(16014,'38567','Gordonsville','',''),(16015,'38571','Fairfield Glade','',''),(16016,'38571','Pleasant Hill','',''),(16017,'38572','Pleasant Hill','',''),(16018,'38583','Pleasant Hill','',''),(16019,'38614','Farrell','',''),(16020,'38617','Lula','',''),(16021,'38637','Southaven','',''),(16022,'38641','Horn Lake','',''),(16023,'38643','Crowder','',''),(16024,'38645','Clarksdale','',''),(16025,'38645','Jonestown','',''),(16026,'38651','Hernando','',''),(16027,'38651','Horn Lake','',''),(16028,'38651','Southaven','',''),(16029,'38654','Southaven','',''),(16030,'38655','University','',''),(16031,'38664','Tunica Resorts','',''),(16032,'38671','Horn Lake','',''),(16033,'38677','Oxford','',''),(16034,'38680','Horn Lake','',''),(16035,'38680','Southaven','',''),(16036,'38703','Metcalfe','',''),(16037,'38762','Winstonville','',''),(16038,'38774','Duncan','',''),(16039,'38774','Winstonville','',''),(16040,'38801','Verona','',''),(16041,'38804','Sherman','',''),(16042,'38826','Sherman','',''),(16043,'38826','Tupelo','',''),(16044,'38828','Sherman','',''),(16045,'38838','Belmont','',''),(16046,'38847','Belmont','',''),(16047,'38866','Tupelo','',''),(16048,'38917','North Carrollton','',''),(16049,'38941','Greenwood','',''),(16050,'38954','Greenwood','',''),(16051,'38957','Tutwiler','',''),(16052,'39041','Clinton','',''),(16053,'39042','Flowood','',''),(16054,'39042','Pearl','',''),(16055,'39044','Dlo','',''),(16056,'39047','Flowood','',''),(16057,'39056','Jackson','',''),(16058,'39062','Dlo','',''),(16059,'39073','Richland','',''),(16060,'39110','Ridgeland','',''),(16061,'39154','Clinton','',''),(16062,'39157','Jackson','',''),(16063,'39157','Madison','',''),(16064,'39159','Cary','',''),(16065,'39159','Mayersville','',''),(16066,'39170','Byram','',''),(16067,'39174','Jackson','',''),(16068,'39189','Sebastopol','',''),(16069,'39208','Brandon','',''),(16070,'39208','Flowood','',''),(16071,'39208','Jackson','',''),(16072,'39208','Richland','',''),(16073,'39209','Clinton','',''),(16074,'39212','Byram','',''),(16075,'39213','Clinton','',''),(16076,'39213','Ridgeland','',''),(16077,'39232','Jackson','',''),(16078,'39232','Pearl','',''),(16079,'39232','Richland','',''),(16080,'39272','Jackson','',''),(16081,'39301','Marion','',''),(16082,'39305','Marion','',''),(16083,'39305','Meridian Station','',''),(16084,'39309','Meridian Station','',''),(16085,'39330','Stonewall','',''),(16086,'39335','Meridian Station','',''),(16087,'39342','Meridian','',''),(16088,'39423','New Augusta','',''),(16089,'39439','Sandersville','',''),(16090,'39443','Sandersville','',''),(16091,'39501','Long Beach','',''),(16092,'39503','Biloxi','',''),(16093,'39507','Biloxi','',''),(16094,'39520','Bay St. Louis','',''),(16095,'39520','Waveland','',''),(16096,'39532','Diberville','',''),(16097,'39532','Gulfport','',''),(16098,'39540','Biloxi','',''),(16099,'39556','Bay St. Louis','',''),(16100,'39556','Diamondhead','',''),(16101,'39560','Gulfport','',''),(16102,'39562','Pascagoula','',''),(16103,'39563','Pascagoula','',''),(16104,'39564','Gautier','',''),(16105,'39565','Gautier','',''),(16106,'39567','Moss Point','',''),(16107,'39571','Diamondhead','',''),(16108,'39576','Bay St. Louis','',''),(16109,'39629','Brookhaven','',''),(16110,'39653','Bude','',''),(16111,'39666','Mccomb','',''),(16112,'39701','Artesia','',''),(16113,'39744','Walthall','',''),(16114,'39759','Mississippi State','',''),(16115,'39762','Starkville','',''),(16116,'39834','Bainbridge','',''),(16117,'39842','Sasser','',''),(16118,'39854','Georgetown-quitman County Unified','',''),(16119,'39867','Georgetown-quitman County Unified','',''),(16120,'39877','Webster County Unified','',''),(16121,'40008','Chaplin','',''),(16122,'40013','Fairfield','',''),(16123,'40014','Buckner','',''),(16124,'40023','Louisville/jefferson County Metro Government (bala','',''),(16125,'40031','Buckner','',''),(16126,'40041','Louisville/jefferson County Metro Government (bala','',''),(16127,'40041','St. Matthews','',''),(16128,'40058','New Castle','',''),(16129,'40059','Louisville/jefferson County Metro Government (bala','',''),(16130,'40118','Louisville/jefferson County Metro Government (bala','',''),(16131,'40121','Muldraugh','',''),(16132,'40143','Cloverport','',''),(16133,'40162','Radcliff','',''),(16134,'40165','Brooks','',''),(16135,'40175','Radcliff','',''),(16136,'40177','Louisville/jefferson County Metro Government (bala','',''),(16137,'40202','Louisville/jefferson County Metro Government (bala','',''),(16138,'40203','Louisville/jefferson County Metro Government (bala','',''),(16139,'40204','Louisville/jefferson County Metro Government (bala','',''),(16140,'40205','Louisville/jefferson County Metro Government (bala','',''),(16141,'40205','St. Matthews','',''),(16142,'40206','Louisville/jefferson County Metro Government (bala','',''),(16143,'40207','Louisville/jefferson County Metro Government (bala','',''),(16144,'40207','St. Matthews','',''),(16145,'40208','Louisville/jefferson County Metro Government (bala','',''),(16146,'40209','Louisville/jefferson County Metro Government (bala','',''),(16147,'40210','Louisville/jefferson County Metro Government (bala','',''),(16148,'40211','Louisville/jefferson County Metro Government (bala','',''),(16149,'40212','Louisville/jefferson County Metro Government (bala','',''),(16150,'40213','Louisville/jefferson County Metro Government (bala','',''),(16151,'40214','Louisville/jefferson County Metro Government (bala','',''),(16152,'40215','Louisville/jefferson County Metro Government (bala','',''),(16153,'40216','Louisville/jefferson County Metro Government (bala','',''),(16154,'40217','Louisville/jefferson County Metro Government (bala','',''),(16155,'40218','Louisville/jefferson County Metro Government (bala','',''),(16156,'40219','Louisville/jefferson County Metro Government (bala','',''),(16157,'40220','Louisville/jefferson County Metro Government (bala','',''),(16158,'40222','Glenview','',''),(16159,'40222','Louisville/jefferson County Metro Government (bala','',''),(16160,'40222','Lyndon','',''),(16161,'40222','St. Matthews','',''),(16162,'40223','Louisville/jefferson County Metro Government (bala','',''),(16163,'40223','Lyndon','',''),(16164,'40223','Middletown','',''),(16165,'40228','Louisville/jefferson County Metro Government (bala','',''),(16166,'40229','Brooks','',''),(16167,'40229','Louisville/jefferson County Metro Government (bala','',''),(16168,'40231','Louisville/jefferson County Metro Government (bala','',''),(16169,'40241','Louisville/jefferson County Metro Government (bala','',''),(16170,'40242','Louisville/jefferson County Metro Government (bala','',''),(16171,'40242','Lyndon','',''),(16172,'40243','Louisville/jefferson County Metro Government (bala','',''),(16173,'40243','Middletown','',''),(16174,'40245','Louisville/jefferson County Metro Government (bala','',''),(16175,'40245','Middletown','',''),(16176,'40258','Louisville/jefferson County Metro Government (bala','',''),(16177,'40272','Louisville/jefferson County Metro Government (bala','',''),(16178,'40280','Louisville/jefferson County Metro Government (bala','',''),(16179,'40291','Louisville/jefferson County Metro Government (bala','',''),(16180,'40299','Louisville/jefferson County Metro Government (bala','',''),(16181,'40299','Middletown','',''),(16182,'40311','Millersburg','',''),(16183,'40330','Burgin','',''),(16184,'40361','Lexington-fayette Urban','',''),(16185,'40403','Richmond','',''),(16186,'40422','Junction City','',''),(16187,'40461','Berea','',''),(16188,'40502','Lexington-fayette Urban','',''),(16189,'40503','Lexington-fayette Urban','',''),(16190,'40504','Lexington-fayette Urban','',''),(16191,'40505','Lexington-fayette Urban','',''),(16192,'40506','Lexington-fayette Urban','',''),(16193,'40507','Lexington-fayette Urban','',''),(16194,'40508','Lexington-fayette Urban','',''),(16195,'40509','Lexington-fayette Urban','',''),(16196,'40510','Lexington-fayette Urban','',''),(16197,'40511','Lexington-fayette Urban','',''),(16198,'40513','Lexington-fayette Urban','',''),(16199,'40514','Lexington-fayette Urban','',''),(16200,'40515','Lexington-fayette Urban','',''),(16201,'40516','Lexington-fayette Urban','',''),(16202,'40517','Lexington-fayette Urban','',''),(16203,'40806','Loyall','',''),(16204,'40823','Benham','',''),(16205,'40828','Kenvir','',''),(16206,'40831','Loyall','',''),(16207,'40855','Benham','',''),(16208,'40906','Artemus','',''),(16209,'40965','Middlesborough','',''),(16210,'41011','Ludlow','',''),(16211,'41015','Covington','',''),(16212,'41015','Independence','',''),(16213,'41016','Ludlow','',''),(16214,'41017','Covington','',''),(16215,'41017','Edgewood','',''),(16216,'41017','Erlanger','',''),(16217,'41017','Ludlow','',''),(16218,'41018','Edgewood','',''),(16219,'41018','Florence','',''),(16220,'41018','Independence','',''),(16221,'41035','Crittenden','',''),(16222,'41035','Williamstown','',''),(16223,'41042','Burlington','',''),(16224,'41042','Independence','',''),(16225,'41048','Francisville','',''),(16226,'41051','Covington','',''),(16227,'41051','Edgewood','',''),(16228,'41051','Erlanger','',''),(16229,'41059','Silver Grove','',''),(16230,'41071','Bellevue','',''),(16231,'41071','Fort Thomas','',''),(16232,'41073','Newport','',''),(16233,'41074','Fort Thomas','',''),(16234,'41075','Dayton','',''),(16235,'41075','Highland Heights','',''),(16236,'41075','Newport','',''),(16237,'41076','Alexandria','',''),(16238,'41076','Cold Spring','',''),(16239,'41076','Fort Thomas','',''),(16240,'41076','Highland Heights','',''),(16241,'41076','Silver Grove','',''),(16242,'41091','Florence','',''),(16243,'41094','Florence','',''),(16244,'41094','Independence','',''),(16245,'41099','Highland Heights','',''),(16246,'41101','Flatwoods','',''),(16247,'41101','Russell','',''),(16248,'41129','Ashland','',''),(16249,'41139','Russell','',''),(16250,'41144','Worthington','',''),(16251,'41169','Flatwoods','',''),(16252,'41169','Worthington','',''),(16253,'41514','South Williamson','',''),(16254,'41517','Jenkins','',''),(16255,'41635','Betsy Layne','',''),(16256,'41774','Jeff','',''),(16257,'41810','Fleming-neon','',''),(16258,'41835','Fleming-neon','',''),(16259,'41835','Mcroberts','',''),(16260,'41840','Fleming-neon','',''),(16261,'42020','Murray','',''),(16262,'42031','Columbus','',''),(16263,'42035','Lowes','',''),(16264,'42051','Lowes','',''),(16265,'42053','Bandana','',''),(16266,'42053','Lovelaceville','',''),(16267,'42056','Bandana','',''),(16268,'42064','Tolu','',''),(16269,'42069','Lowes','',''),(16270,'42122','Bowling Green','',''),(16271,'42223','Fort Campbell North','',''),(16272,'42223','Oak Grove','',''),(16273,'42223','Clarksville','',''),(16274,'42236','Lafayette','',''),(16275,'42254','Lafayette','',''),(16276,'42262','Hopkinsville','',''),(16277,'42266','Hopkinsville','',''),(16278,'42266','Oak Grove','',''),(16279,'42320','Mchenry','',''),(16280,'42320','Rockport','',''),(16281,'42320','Rosine','',''),(16282,'42321','Beechmont','',''),(16283,'42330','Powderly','',''),(16284,'42345','Powderly','',''),(16285,'42349','Rosine','',''),(16286,'42354','Mchenry','',''),(16287,'42374','Central City','',''),(16288,'42404','Wheatcroft','',''),(16289,'42431','Earlington','',''),(16290,'42431','Mortons Gap','',''),(16291,'42442','Mortons Gap','',''),(16292,'42464','Mortons Gap','',''),(16293,'42501','Ferguson','',''),(16294,'42701','Radcliff','',''),(16295,'42724','Elizabethtown','',''),(16296,'43002','Columbus','',''),(16297,'43002','Dublin','',''),(16298,'43002','Hilliard','',''),(16299,'43004','Columbus','',''),(16300,'43004','Gahanna','',''),(16301,'43004','Reynoldsburg','',''),(16302,'43015','Kilbourne','',''),(16303,'43016','Columbus','',''),(16304,'43016','Hilliard','',''),(16305,'43017','Columbus','',''),(16306,'43022','Bladensburg','',''),(16307,'43023','Heath','',''),(16308,'43023','Newark','',''),(16309,'43025','Buckeye Lake','',''),(16310,'43025','Heath','',''),(16311,'43025','Kirkersville','',''),(16312,'43026','Columbus','',''),(16313,'43028','Apple Valley','',''),(16314,'43035','Columbus','',''),(16315,'43035','Delaware','',''),(16316,'43040','Magnetic Springs','',''),(16317,'43040','Unionville Center','',''),(16318,'43046','Buckeye Lake','',''),(16319,'43046','Kirkersville','',''),(16320,'43050','Gambier','',''),(16321,'43054','Columbus','',''),(16322,'43054','Gahanna','',''),(16323,'43055','Heath','',''),(16324,'43056','Newark','',''),(16325,'43062','Kirkersville','',''),(16326,'43062','Reynoldsburg','',''),(16327,'43064','Dublin','',''),(16328,'43065','Columbus','',''),(16329,'43065','Dublin','',''),(16330,'43068','Brice','',''),(16331,'43068','Columbus','',''),(16332,'43068','Pataskala','',''),(16333,'43068','Pickerington','',''),(16334,'43072','Christiansburg','',''),(16335,'43080','Bladensburg','',''),(16336,'43081','Columbus','',''),(16337,'43082','Columbus','',''),(16338,'43085','Worthington','',''),(16339,'43103','Commercial Point','',''),(16340,'43109','Columbus','',''),(16341,'43110','Brice','',''),(16342,'43110','Columbus','',''),(16343,'43110','Groveport','',''),(16344,'43110','Lithopolis','',''),(16345,'43110','Pickerington','',''),(16346,'43113','Tarlton','',''),(16347,'43119','Columbus','',''),(16348,'43123','Columbus','',''),(16349,'43125','Columbus','',''),(16350,'43128','Milledgeville','',''),(16351,'43135','Adelphi','',''),(16352,'43137','Columbus','',''),(16353,'43137','Grove City','',''),(16354,'43138','Haydenville','',''),(16355,'43140','West Jefferson','',''),(16356,'43146','Commercial Point','',''),(16357,'43146','Grove City','',''),(16358,'43146','Harrisburg','',''),(16359,'43147','Columbus','',''),(16360,'43151','Midway','',''),(16361,'43154','Tarlton','',''),(16362,'43160','Bloomingburg','',''),(16363,'43160','Jeffersonville','',''),(16364,'43160','Milledgeville','',''),(16365,'43207','Groveport','',''),(16366,'43212','Upper Arlington','',''),(16367,'43213','Gahanna','',''),(16368,'43213','Reynoldsburg','',''),(16369,'43213','Whitehall','',''),(16370,'43214','Worthington','',''),(16371,'43219','Gahanna','',''),(16372,'43219','Whitehall','',''),(16373,'43220','Upper Arlington','',''),(16374,'43221','Hilliard','',''),(16375,'43221','Upper Arlington','',''),(16376,'43227','Whitehall','',''),(16377,'43228','Hilliard','',''),(16378,'43229','Worthington','',''),(16379,'43230','Gahanna','',''),(16380,'43231','Westerville','',''),(16381,'43232','Brice','',''),(16382,'43232','Reynoldsburg','',''),(16383,'43235','Dublin','',''),(16384,'43235','Worthington','',''),(16385,'43240','Westerville','',''),(16386,'43302','Green Camp','',''),(16387,'43318','Rosewood','',''),(16388,'43331','Russells Point','',''),(16389,'43333','Russells Point','',''),(16390,'43338','Chesterville','',''),(16391,'43402','Haskins','',''),(16392,'43402','Tontogany','',''),(16393,'43412','Clay Center','',''),(16394,'43412','Williston','',''),(16395,'43430','Clay Center','',''),(16396,'43435','Gibsonburg','',''),(16397,'43445','Clay Center','',''),(16398,'43447','Clay Center','',''),(16399,'43449','Rocky Ridge','',''),(16400,'43460','Northwood','',''),(16401,'43465','Northwood','',''),(16402,'43501','Kunkle','',''),(16403,'43502','Pettisville','',''),(16404,'43502','Ridgeville Corners','',''),(16405,'43511','Hoytville','',''),(16406,'43511','Milton Center','',''),(16407,'43518','Blakeslee','',''),(16408,'43522','Neapolis','',''),(16409,'43532','Neapolis','',''),(16410,'43537','Toledo','',''),(16411,'43542','Whitehouse','',''),(16412,'43545','Ridgeville Corners','',''),(16413,'43551','Rossford','',''),(16414,'43554','Kunkle','',''),(16415,'43566','Maumee','',''),(16416,'43566','Whitehouse','',''),(16417,'43567','Pettisville','',''),(16418,'43605','Northwood','',''),(16419,'43605','Oregon','',''),(16420,'43611','Oregon','',''),(16421,'43614','Maumee','',''),(16422,'43616','Harbor View','',''),(16423,'43616','Toledo','',''),(16424,'43617','Sylvania','',''),(16425,'43619','Rossford','',''),(16426,'43623','Sylvania','',''),(16427,'43701','Zanesville','',''),(16428,'43713','Fairview','',''),(16429,'43718','Glencoe','',''),(16430,'43718','Morristown','',''),(16431,'43719','Morristown','',''),(16432,'43723','Cambridge','',''),(16433,'43724','Belle Valley','',''),(16434,'43739','Brownsville','',''),(16435,'43754','Stafford','',''),(16436,'43755','Old Washington','',''),(16437,'43760','Brownsville','',''),(16438,'43773','Fairview','',''),(16439,'43777','East Fultonham','',''),(16440,'43777','Fultonham','',''),(16441,'43780','Buffalo','',''),(16442,'43812','Plainfield','',''),(16443,'43821','Trinway','',''),(16444,'43901','Harrisville','',''),(16445,'43906','Neffs','',''),(16446,'43907','Harrisville','',''),(16447,'43907','Hopedale','',''),(16448,'43912','Lansing','',''),(16449,'43912','Martins Ferry','',''),(16450,'43915','Hannibal','',''),(16451,'43917','Mount Pleasant','',''),(16452,'43933','Glencoe','',''),(16453,'43935','Yorkville','',''),(16454,'43938','Steubenville','',''),(16455,'43943','Smithfield','',''),(16456,'43943','Tiltonsville','',''),(16457,'43945','Summitville','',''),(16458,'43946','Hannibal','',''),(16459,'43947','Bellaire','',''),(16460,'43950','Bannock','',''),(16461,'43950','Glencoe','',''),(16462,'43950','Lafferty','',''),(16463,'43963','Yorkville','',''),(16464,'43964','Empire','',''),(16465,'43964','Stratton','',''),(16466,'43971','Martins Ferry','',''),(16467,'43971','Tiltonsville','',''),(16468,'43977','Holloway','',''),(16469,'43977','Lafferty','',''),(16470,'44001','Lorain','',''),(16471,'44001','Vermilion','',''),(16472,'44022','Solon','',''),(16473,'44048','Conneaut','',''),(16474,'44053','Amherst','',''),(16475,'44054','Lorain','',''),(16476,'44056','Twinsburg','',''),(16477,'44057','North Madison','',''),(16478,'44067','Macedonia','',''),(16479,'44074','Kipton','',''),(16480,'44077','Grand River','',''),(16481,'44094','Mentor','',''),(16482,'44095','Wickliffe','',''),(16483,'44102','Brooklyn','',''),(16484,'44105','Garfield Heights','',''),(16485,'44106','Cleveland Heights','',''),(16486,'44106','East Cleveland','',''),(16487,'44107','Cleveland','',''),(16488,'44108','East Cleveland','',''),(16489,'44109','Parma','',''),(16490,'44110','East Cleveland','',''),(16491,'44111','Lakewood','',''),(16492,'44112','Cleveland Heights','',''),(16493,'44112','East Cleveland','',''),(16494,'44116','Fairview Park','',''),(16495,'44117','Cleveland','',''),(16496,'44118','Cleveland Heights','',''),(16497,'44118','East Cleveland','',''),(16498,'44118','Shaker Heights','',''),(16499,'44118','South Euclid','',''),(16500,'44119','Euclid','',''),(16501,'44120','Shaker Heights','',''),(16502,'44121','Cleveland Heights','',''),(16503,'44121','South Euclid','',''),(16504,'44122','Cleveland','',''),(16505,'44122','Shaker Heights','',''),(16506,'44122','South Euclid','',''),(16507,'44124','Mayfield Heights','',''),(16508,'44124','South Euclid','',''),(16509,'44125','Garfield Heights','',''),(16510,'44125','Maple Heights','',''),(16511,'44126','Fairview Park','',''),(16512,'44128','Garfield Heights','',''),(16513,'44128','Maple Heights','',''),(16514,'44129','Brooklyn','',''),(16515,'44129','Parma','',''),(16516,'44130','Brooklyn','',''),(16517,'44130','Brook Park','',''),(16518,'44130','Parma','',''),(16519,'44130','Parma Heights','',''),(16520,'44131','Seven Hills','',''),(16521,'44133','Broadview Heights','',''),(16522,'44133','Parma','',''),(16523,'44134','Parma','',''),(16524,'44135','Brook Park','',''),(16525,'44137','Garfield Heights','',''),(16526,'44138','North Olmsted','',''),(16527,'44141','Broadview Heights','',''),(16528,'44141','Richfield','',''),(16529,'44142','Brook Park','',''),(16530,'44142','Cleveland','',''),(16531,'44142','Parma','',''),(16532,'44143','Euclid','',''),(16533,'44143','Mayfield Heights','',''),(16534,'44143','Richmond Heights','',''),(16535,'44143','South Euclid','',''),(16536,'44144','Brooklyn','',''),(16537,'44147','Brecksville','',''),(16538,'44147','North Royalton','',''),(16539,'44202','Twinsburg','',''),(16540,'44203','Akron','',''),(16541,'44203','New Franklin','',''),(16542,'44216','Green','',''),(16543,'44216','New Franklin','',''),(16544,'44221','Akron','',''),(16545,'44221','Stow','',''),(16546,'44223','Akron','',''),(16547,'44224','Cuyahoga Falls','',''),(16548,'44224','Hudson','',''),(16549,'44236','Macedonia','',''),(16550,'44236','Streetsboro','',''),(16551,'44240','Stow','',''),(16552,'44240','Streetsboro','',''),(16553,'44240','Tallmadge','',''),(16554,'44255','Streetsboro','',''),(16555,'44260','Akron','',''),(16556,'44262','Cuyahoga Falls','',''),(16557,'44264','Cuyahoga Falls','',''),(16558,'44266','Streetsboro','',''),(16559,'44273','Rittman','',''),(16560,'44273','Westfield Center','',''),(16561,'44276','Rittman','',''),(16562,'44278','Akron','',''),(16563,'44278','Munroe Falls','',''),(16564,'44310','Tallmadge','',''),(16565,'44312','Green','',''),(16566,'44312','Lakemore','',''),(16567,'44313','Cuyahoga Falls','',''),(16568,'44313','Fairlawn','',''),(16569,'44314','Barberton','',''),(16570,'44319','Green','',''),(16571,'44319','New Franklin','',''),(16572,'44321','Fairlawn','',''),(16573,'44333','Cuyahoga Falls','',''),(16574,'44333','Fairlawn','',''),(16575,'44406','Austintown','',''),(16576,'44420','Youngstown','',''),(16577,'44427','Summitville','',''),(16578,'44430','Warren','',''),(16579,'44431','Washingtonville','',''),(16580,'44436','Campbell','',''),(16581,'44436','Struthers','',''),(16582,'44436','Youngstown','',''),(16583,'44437','Mcdonald','',''),(16584,'44438','West Hill','',''),(16585,'44440','Niles','',''),(16586,'44446','Girard','',''),(16587,'44446','Mineral Ridge','',''),(16588,'44460','Washingtonville','',''),(16589,'44481','Leavittsburg','',''),(16590,'44484','Niles','',''),(16591,'44485','Leavittsburg','',''),(16592,'44505','Campbell','',''),(16593,'44505','Girard','',''),(16594,'44509','Austintown','',''),(16595,'44511','Austintown','',''),(16596,'44511','Boardman','',''),(16597,'44512','Boardman','',''),(16598,'44514','Boardman','',''),(16599,'44515','Austintown','',''),(16600,'44515','Mineral Ridge','',''),(16601,'44601','Limaville','',''),(16602,'44601','Sebring','',''),(16603,'44606','Mount Eaton','',''),(16604,'44609','Sebring','',''),(16605,'44611','Nashville','',''),(16606,'44612','Zoar','',''),(16607,'44614','New Franklin','',''),(16608,'44618','Massillon','',''),(16609,'44618','Mount Eaton','',''),(16610,'44621','Midvale','',''),(16611,'44622','New Philadelphia','',''),(16612,'44622','Strasburg','',''),(16613,'44624','Winesburg','',''),(16614,'44626','Sandyville','',''),(16615,'44629','Tuscarawas','',''),(16616,'44638','Nashville','',''),(16617,'44641','Canton','',''),(16618,'44654','Berlin','',''),(16619,'44654','Walnut Creek','',''),(16620,'44662','Brewster','',''),(16621,'44662','Massillon','',''),(16622,'44662','Mount Eaton','',''),(16623,'44663','Dover','',''),(16624,'44663','Midvale','',''),(16625,'44663','Tuscarawas','',''),(16626,'44666','Massillon','',''),(16627,'44669','Robertsville','',''),(16628,'44681','Walnut Creek','',''),(16629,'44683','Dennison','',''),(16630,'44683','Tuscarawas','',''),(16631,'44685','Green','',''),(16632,'44706','Massillon','',''),(16633,'44720','Canton','',''),(16634,'44720','Green','',''),(16635,'44730','Canton','',''),(16636,'44730','Robertsville','',''),(16637,'44805','Hayesville','',''),(16638,'44805','Savannah','',''),(16639,'44811','Flat Rock','',''),(16640,'44817','West Millgrove','',''),(16641,'44818','Chatfield','',''),(16642,'44820','Sulphur Springs','',''),(16643,'44827','Galion','',''),(16644,'44827','North Robinson','',''),(16645,'44830','Bascom','',''),(16646,'44833','Crestline','',''),(16647,'44839','Sandusky','',''),(16648,'44840','Hayesville','',''),(16649,'44844','Mccutchenville','',''),(16650,'44859','Savannah','',''),(16651,'44865','New Haven','',''),(16652,'44883','Bascom','',''),(16653,'44883','Bettsville','',''),(16654,'44883','Old Fort','',''),(16655,'44890','New Haven','',''),(16656,'45002','Addyston','',''),(16657,'45002','Hooven','',''),(16658,'45002','Miami Heights','',''),(16659,'45005','Middletown','',''),(16660,'45005','Springboro','',''),(16661,'45011','Fairfield','',''),(16662,'45011','Monroe','',''),(16663,'45011','Seven Mile','',''),(16664,'45014','Hamilton','',''),(16665,'45036','Mason','',''),(16666,'45036','Monroe','',''),(16667,'45036','South Lebanon','',''),(16668,'45039','Mason','',''),(16669,'45039','South Lebanon','',''),(16670,'45040','Kings Mills','',''),(16671,'45040','Lebanon','',''),(16672,'45042','Trenton','',''),(16673,'45044','Monroe','',''),(16674,'45052','Addyston','',''),(16675,'45052','Mack','',''),(16676,'45052','Miami Heights','',''),(16677,'45064','West Elkton','',''),(16678,'45066','Franklin','',''),(16679,'45068','Harveysburg','',''),(16680,'45103','Newtonsville','',''),(16681,'45103','Owensville','',''),(16682,'45120','Chilo','',''),(16683,'45120','Neville','',''),(16684,'45121','Higginsport','',''),(16685,'45133','Sinking Spring','',''),(16686,'45140','Miamiville','',''),(16687,'45152','South Lebanon','',''),(16688,'45171','Mowrystown','',''),(16689,'45209','Norwood','',''),(16690,'45211','Bridgetown','',''),(16691,'45212','Norwood','',''),(16692,'45215','Reading','',''),(16693,'45217','St. Bernard','',''),(16694,'45218','Greenhills','',''),(16695,'45227','Madeira','',''),(16696,'45229','St. Bernard','',''),(16697,'45230','Forestville','',''),(16698,'45231','Forest Park','',''),(16699,'45231','Northbrook','',''),(16700,'45233','Addyston','',''),(16701,'45233','Bridgetown','',''),(16702,'45233','Mack','',''),(16703,'45236','Blue Ash','',''),(16704,'45236','Deer Park','',''),(16705,'45236','Madeira','',''),(16706,'45236','Reading','',''),(16707,'45237','Reading','',''),(16708,'45238','Bridgetown','',''),(16709,'45239','White Oak','',''),(16710,'45240','Fairfield','',''),(16711,'45240','Forest Park','',''),(16712,'45240','Greenhills','',''),(16713,'45240','Springdale','',''),(16714,'45241','Blue Ash','',''),(16715,'45241','Sharonville','',''),(16716,'45242','Blue Ash','',''),(16717,'45243','Madeira','',''),(16718,'45244','Dry Run','',''),(16719,'45246','Fairfield','',''),(16720,'45246','Forest Park','',''),(16721,'45246','Sharonville','',''),(16722,'45246','Springdale','',''),(16723,'45247','Dry Ridge','',''),(16724,'45247','White Oak','',''),(16725,'45248','Bridgetown','',''),(16726,'45248','Mack','',''),(16727,'45248','Miami Heights','',''),(16728,'45249','Blue Ash','',''),(16729,'45249','Sharonville','',''),(16730,'45251','Northbrook','',''),(16731,'45252','Dry Ridge','',''),(16732,'45255','Forestville','',''),(16733,'45301','Beavercreek','',''),(16734,'45302','Botkins','',''),(16735,'45302','Kettlersville','',''),(16736,'45304','Pitsburg','',''),(16737,'45308','Gettysburg','',''),(16738,'45309','Clayton','',''),(16739,'45309','Phillipsburg','',''),(16740,'45309','Trotwood','',''),(16741,'45309','Verona','',''),(16742,'45311','Gratis','',''),(16743,'45314','Clifton','',''),(16744,'45315','Englewood','',''),(16745,'45315','Trotwood','',''),(16746,'45317','Rosewood','',''),(16747,'45320','Gratis','',''),(16748,'45322','Clayton','',''),(16749,'45324','Beavercreek','',''),(16750,'45324','Wright-patterson Afb','',''),(16751,'45338','Verona','',''),(16752,'45339','West Milton','',''),(16753,'45342','Germantown','',''),(16754,'45342','Moraine','',''),(16755,'45342','Springboro','',''),(16756,'45342','West Carrollton','',''),(16757,'45344','Donnelsville','',''),(16758,'45344','Huber Heights','',''),(16759,'45345','Trotwood','',''),(16760,'45346','Palestine','',''),(16761,'45348','Burkettsville','',''),(16762,'45348','North Star','',''),(16763,'45362','North Star','',''),(16764,'45365','Port Jefferson','',''),(16765,'45371','Huber Heights','',''),(16766,'45371','Vandalia','',''),(16767,'45373','Tipp City','',''),(16768,'45377','Dayton','',''),(16769,'45381','Gratis','',''),(16770,'45385','Fairborn','',''),(16771,'45385','Wilberforce','',''),(16772,'45387','Clifton','',''),(16773,'45388','Osgood','',''),(16774,'45406','Trotwood','',''),(16775,'45409','Kettering','',''),(16776,'45409','Moraine','',''),(16777,'45409','Oakwood','',''),(16778,'45414','Huber Heights','',''),(16779,'45414','Vandalia','',''),(16780,'45415','Clayton','',''),(16781,'45415','Englewood','',''),(16782,'45415','Trotwood','',''),(16783,'45416','Trotwood','',''),(16784,'45417','Moraine','',''),(16785,'45417','Trotwood','',''),(16786,'45418','Moraine','',''),(16787,'45418','West Carrollton','',''),(16788,'45419','Kettering','',''),(16789,'45419','Oakwood','',''),(16790,'45420','Kettering','',''),(16791,'45424','Huber Heights','',''),(16792,'45426','Trotwood','',''),(16793,'45429','Kettering','',''),(16794,'45430','Beavercreek','',''),(16795,'45431','Beavercreek','',''),(16796,'45432','Beavercreek','',''),(16797,'45432','Kettering','',''),(16798,'45433','Fairborn','',''),(16799,'45433','Wright-patterson Afb','',''),(16800,'45434','Beavercreek','',''),(16801,'45439','Kettering','',''),(16802,'45439','Moraine','',''),(16803,'45439','West Carrollton','',''),(16804,'45440','Beavercreek','',''),(16805,'45440','Bellbrook','',''),(16806,'45440','Kettering','',''),(16807,'45449','Miamisburg','',''),(16808,'45449','West Carrollton','',''),(16809,'45459','Bellbrook','',''),(16810,'45459','Kettering','',''),(16811,'45459','Miamisburg','',''),(16812,'45502','Clifton','',''),(16813,'45502','North Hampton','',''),(16814,'45601','Richmond Dale','',''),(16815,'45612','Cynthiana','',''),(16816,'45614','Rio Grande','',''),(16817,'45631','Rio Grande','',''),(16818,'45636','Franklin Furnace','',''),(16819,'45638','Franklin Furnace','',''),(16820,'45663','Friendship','',''),(16821,'45681','Bourneville','',''),(16822,'45684','Friendship','',''),(16823,'45685','Rio Grande','',''),(16824,'45692','Coalton','',''),(16825,'45697','Cherry Fork','',''),(16826,'45701','The Plains','',''),(16827,'45732','Buchtel','',''),(16828,'45732','Jacksonville','',''),(16829,'45732','Trimble','',''),(16830,'45761','Chauncey','',''),(16831,'45764','Buchtel','',''),(16832,'45764','Carbon Hill','',''),(16833,'45764','Haydenville','',''),(16834,'45771','Syracuse','',''),(16835,'45807','Cairo','',''),(16836,'45812','Mcguffey','',''),(16837,'45822','Chickasaw','',''),(16838,'45822','Montezuma','',''),(16839,'45827','Kalida','',''),(16840,'45830','Beaverdam','',''),(16841,'45830','Kalida','',''),(16842,'45840','Arlington','',''),(16843,'45840','Benton Ridge','',''),(16844,'45844','Kalida','',''),(16845,'45844','Ottoville','',''),(16846,'45850','Lafayette','',''),(16847,'45856','Miller City','',''),(16848,'45858','Mccomb','',''),(16849,'45859','Mcguffey','',''),(16850,'45865','New Bremen','',''),(16851,'45873','Melrose','',''),(16852,'45875','Kalida','',''),(16853,'45879','Latty','',''),(16854,'45883','St. Henry','',''),(16855,'45884','St Johns','',''),(16856,'45885','St. Marys','',''),(16857,'45894','Elgin','',''),(16858,'45895','New Hampshire','',''),(16859,'45895','St Johns','',''),(16860,'45895','Uniopolis','',''),(16861,'46001','Orestes','',''),(16862,'46017','Daleville','',''),(16863,'46032','Westfield','',''),(16864,'46033','Westfield','',''),(16865,'46038','Noblesville','',''),(16866,'46040','Fishers','',''),(16867,'46040','Ingalls','',''),(16868,'46052','Whitestown','',''),(16869,'46055','Fishers','',''),(16870,'46055','Fortville','',''),(16871,'46055','Mccordsville','',''),(16872,'46060','Fishers','',''),(16873,'46062','Carmel','',''),(16874,'46062','Westfield','',''),(16875,'46064','Anderson','',''),(16876,'46064','Ingalls','',''),(16877,'46069','Westfield','',''),(16878,'46074','Carmel','',''),(16879,'46075','Lebanon','',''),(16880,'46077','Carmel','',''),(16881,'46077','Indianapolis City (balance), In','',''),(16882,'46077','Westfield','',''),(16883,'46077','Whitestown','',''),(16884,'46107','Indianapolis City (balance), In','',''),(16885,'46112','Whitestown','',''),(16886,'46113','Indianapolis City (balance), In','',''),(16887,'46121','Amo','',''),(16888,'46121','Heritage Lake','',''),(16889,'46123','Danville','',''),(16890,'46123','Plainfield','',''),(16891,'46124','Taylorsville','',''),(16892,'46128','Heritage Lake','',''),(16893,'46131','Bargersville','',''),(16894,'46131','New Whiteland','',''),(16895,'46143','Bargersville','',''),(16896,'46158','Brooklyn','',''),(16897,'46167','Brownsburg','',''),(16898,'46183','Indianapolis City (balance), In','',''),(16899,'46184','Greenwood','',''),(16900,'46184','New Whiteland','',''),(16901,'46201','Indianapolis City (balance), In','',''),(16902,'46202','Indianapolis City (balance), In','',''),(16903,'46203','Beech Grove','',''),(16904,'46203','Indianapolis City (balance), In','',''),(16905,'46204','Indianapolis City (balance), In','',''),(16906,'46205','Indianapolis City (balance), In','',''),(16907,'46208','Indianapolis City (balance), In','',''),(16908,'46214','Indianapolis City (balance), In','',''),(16909,'46216','Lawrence','',''),(16910,'46217','Indianapolis City (balance), In','',''),(16911,'46218','Indianapolis City (balance), In','',''),(16912,'46219','Indianapolis City (balance), In','',''),(16913,'46220','Indianapolis City (balance), In','',''),(16914,'46221','Indianapolis City (balance), In','',''),(16915,'46222','Indianapolis City (balance), In','',''),(16916,'46224','Indianapolis City (balance), In','',''),(16917,'46225','Indianapolis City (balance), In','',''),(16918,'46226','Indianapolis City (balance), In','',''),(16919,'46226','Lawrence','',''),(16920,'46227','Indianapolis City (balance), In','',''),(16921,'46228','Indianapolis City (balance), In','',''),(16922,'46229','Indianapolis City (balance), In','',''),(16923,'46231','Indianapolis City (balance), In','',''),(16924,'46231','Plainfield','',''),(16925,'46234','Brownsburg','',''),(16926,'46234','Indianapolis City (balance), In','',''),(16927,'46235','Indianapolis City (balance), In','',''),(16928,'46235','Lawrence','',''),(16929,'46236','Indianapolis City (balance), In','',''),(16930,'46236','Lawrence','',''),(16931,'46237','Beech Grove','',''),(16932,'46237','Indianapolis City (balance), In','',''),(16933,'46239','Indianapolis City (balance), In','',''),(16934,'46240','Carmel','',''),(16935,'46240','Indianapolis City (balance), In','',''),(16936,'46241','Indianapolis City (balance), In','',''),(16937,'46250','Fishers','',''),(16938,'46250','Indianapolis City (balance), In','',''),(16939,'46254','Indianapolis City (balance), In','',''),(16940,'46256','Fishers','',''),(16941,'46256','Indianapolis City (balance), In','',''),(16942,'46256','Lawrence','',''),(16943,'46259','Indianapolis City (balance), In','',''),(16944,'46260','Carmel','',''),(16945,'46260','Indianapolis City (balance), In','',''),(16946,'46268','Indianapolis City (balance), In','',''),(16947,'46268','Zionsville','',''),(16948,'46278','Indianapolis City (balance), In','',''),(16949,'46280','Carmel','',''),(16950,'46290','Carmel','',''),(16951,'46304','Beverly Shores','',''),(16952,'46304','Portage','',''),(16953,'46307','Cedar Lake','',''),(16954,'46307','Merrillville','',''),(16955,'46307','St. John','',''),(16956,'46307','Schererville','',''),(16957,'46311','St. John','',''),(16958,'46311','Schererville','',''),(16959,'46319','Schererville','',''),(16960,'46320','East Chicago','',''),(16961,'46323','Highland','',''),(16962,'46342','Lake Station','',''),(16963,'46342','Merrillville','',''),(16964,'46342','Portage','',''),(16965,'46342','Wheeler','',''),(16966,'46350','Kingsbury','',''),(16967,'46356','Cedar Lake','',''),(16968,'46356','Shelby','',''),(16969,'46360','Beverly Shores','',''),(16970,'46368','Chesterton','',''),(16971,'46373','St. John','',''),(16972,'46373','Schererville','',''),(16973,'46375','Dyer','',''),(16974,'46375','Griffith','',''),(16975,'46375','St. John','',''),(16976,'46385','Chesterton','',''),(16977,'46385','Portage','',''),(16978,'46394','Hammond','',''),(16979,'46403','Lake Station','',''),(16980,'46405','Gary','',''),(16981,'46408','Griffith','',''),(16982,'46409','Lake Station','',''),(16983,'46410','Gary','',''),(16984,'46410','Hobart','',''),(16985,'46517','Goshen','',''),(16986,'46530','Mishawaka','',''),(16987,'46532','Kingsford Heights','',''),(16988,'46537','La Paz','',''),(16989,'46544','South Bend','',''),(16990,'46545','Granger','',''),(16991,'46545','South Bend','',''),(16992,'46556','South Bend','',''),(16993,'46561','Granger','',''),(16994,'46561','Mishawaka','',''),(16995,'46563','La Paz','',''),(16996,'46580','Winona Lake','',''),(16997,'46590','Warsaw','',''),(16998,'46613','Mishawaka','',''),(16999,'46614','Mishawaka','',''),(17000,'46617','Notre Dame','',''),(17001,'46635','Granger','',''),(17002,'46635','Mishawaka','',''),(17003,'46637','Notre Dame','',''),(17004,'46706','Garrett','',''),(17005,'46741','Harlan','',''),(17006,'46741','Leo-cedarville','',''),(17007,'46755','Rome City','',''),(17008,'46765','Leo-cedarville','',''),(17009,'46770','Zanesville','',''),(17010,'46774','Fort Wayne','',''),(17011,'46788','Leo-cedarville','',''),(17012,'46798','Zanesville','',''),(17013,'46803','New Haven','',''),(17014,'46806','New Haven','',''),(17015,'46815','New Haven','',''),(17016,'46816','New Haven','',''),(17017,'46845','Leo-cedarville','',''),(17018,'46913','Flora','',''),(17019,'46914','Grissom Afb','',''),(17020,'46919','Sweetser','',''),(17021,'46920','Burlington','',''),(17022,'46928','Matthews','',''),(17023,'46932','Grissom Afb','',''),(17024,'46933','Jonesboro','',''),(17025,'46938','Fowlerton','',''),(17026,'46938','Marion','',''),(17027,'46940','Somerset','',''),(17028,'46952','Sweetser','',''),(17029,'46953','Gas City','',''),(17030,'46953','Jonesboro','',''),(17031,'46962','Laketon','',''),(17032,'46970','Grissom Afb','',''),(17033,'46970','Mexico','',''),(17034,'46975','Fulton','',''),(17035,'46986','Sweetser','',''),(17036,'46994','Onward','',''),(17037,'47006','Napoleon','',''),(17038,'47025','Hidden Valley','',''),(17039,'47037','Napoleon','',''),(17040,'47060','New Trenton','',''),(17041,'47111','Jeffersonville','',''),(17042,'47119','New Albany','',''),(17043,'47129','Jeffersonville','',''),(17044,'47130','Charlestown','',''),(17045,'47130','Clarksville','',''),(17046,'47163','Charlestown','',''),(17047,'47170','Austin','',''),(17048,'47172','Clarksville','',''),(17049,'47172','Jeffersonville','',''),(17050,'47201','Jonesville','',''),(17051,'47203','Clifford','',''),(17052,'47240','New Point','',''),(17053,'47243','Madison','',''),(17054,'47265','Vernon','',''),(17055,'47272','St. Paul','',''),(17056,'47303','Eaton','',''),(17057,'47304','Yorktown','',''),(17058,'47327','Dublin','',''),(17059,'47330','Richmond','',''),(17060,'47356','Sulphur Springs','',''),(17061,'47357','Connersville','',''),(17062,'47362','Greensboro','',''),(17063,'47362','Mount Summit','',''),(17064,'47371','Salamonia','',''),(17065,'47394','Saratoga','',''),(17066,'47403','Harrodsburg','',''),(17067,'47404','Ellettsville','',''),(17068,'47421','Avoca','',''),(17069,'47421','Oolitic','',''),(17070,'47462','Avoca','',''),(17071,'47462','Harrodsburg','',''),(17072,'47512','Freelandville','',''),(17073,'47523','Santa Claus','',''),(17074,'47532','Santa Claus','',''),(17075,'47550','Santa Claus','',''),(17076,'47552','Santa Claus','',''),(17077,'47577','St. Meinrad','',''),(17078,'47601','Chandler','',''),(17079,'47619','Spurgeon','',''),(17080,'47660','Mackey','',''),(17081,'47660','Somerville','',''),(17082,'47660','Spurgeon','',''),(17083,'47670','Patoka','',''),(17084,'47802','Riley','',''),(17085,'47834','Harmony','',''),(17086,'47834','Knightsville','',''),(17087,'47834','Staunton','',''),(17088,'47842','Shepardsville','',''),(17089,'47842','Universal','',''),(17090,'47854','Newport','',''),(17091,'47862','Mecca','',''),(17092,'47872','Mecca','',''),(17093,'47876','St. Mary Of The Woods','',''),(17094,'47879','Hymera','',''),(17095,'47885','New Goshen','',''),(17096,'47885','St. Mary Of The Woods','',''),(17097,'47885','Shepardsville','',''),(17098,'47905','Buck Creek','',''),(17099,'47905','Dayton','',''),(17100,'47906','Otterbein','',''),(17101,'47909','Stockwell','',''),(17102,'47918','Newtown','',''),(17103,'47928','Newport','',''),(17104,'47933','Alamo','',''),(17105,'47933','New Market','',''),(17106,'47960','Buffalo','',''),(17107,'47982','State Line City','',''),(17108,'47987','Newtown','',''),(17109,'47993','West Lebanon','',''),(17110,'48017','Royal Oak','',''),(17111,'48025','Beverly Hills','',''),(17112,'48025','Farmington Hills','',''),(17113,'48035','St. Clair Shores','',''),(17114,'48036','Mount Clemens','',''),(17115,'48045','St. Clair Shores','',''),(17116,'48059','Port Huron','',''),(17117,'48063','Richmond','',''),(17118,'48064','Richmond','',''),(17119,'48066','Eastpointe','',''),(17120,'48067','Pleasant Ridge','',''),(17121,'48070','Oak Park','',''),(17122,'48070','Pleasant Ridge','',''),(17123,'48070','Royal Oak','',''),(17124,'48071','Royal Oak','',''),(17125,'48073','Berkley','',''),(17126,'48073','Clawson','',''),(17127,'48073','Troy','',''),(17128,'48074','Marysville','',''),(17129,'48079','Marysville','',''),(17130,'48080','St. Clair Shores','',''),(17131,'48081','St. Clair Shores','',''),(17132,'48082','St. Clair Shores','',''),(17133,'48084','Royal Oak','',''),(17134,'48091','Center Line','',''),(17135,'48101','Dearborn','',''),(17136,'48101','Lincoln Park','',''),(17137,'48122','Allen Park','',''),(17138,'48124','Allen Park','',''),(17139,'48126','Detroit','',''),(17140,'48126','Melvindale','',''),(17141,'48133','Luna Pier','',''),(17142,'48167','Farmington Hills','',''),(17143,'48167','Novi','',''),(17144,'48173','Gibraltar','',''),(17145,'48182','Lambertville','',''),(17146,'48183','Gibraltar','',''),(17147,'48183','Riverview','',''),(17148,'48184','Romulus','',''),(17149,'48185','Garden City','',''),(17150,'48186','Inkster','',''),(17151,'48192','Lincoln Park','',''),(17152,'48192','Southgate','',''),(17153,'48203','Detroit','',''),(17154,'48211','Hamtramck','',''),(17155,'48212','Detroit','',''),(17156,'48217','Lincoln Park','',''),(17157,'48225','Detroit','',''),(17158,'48225','Grosse Pointe Woods','',''),(17159,'48229','Lincoln Park','',''),(17160,'48230','Grosse Pointe Park','',''),(17161,'48236','Detroit','',''),(17162,'48236','Grosse Pointe Woods','',''),(17163,'48236','Harper Woods','',''),(17164,'48236','St. Clair Shores','',''),(17165,'48237','Huntington Woods','',''),(17166,'48239','Detroit','',''),(17167,'48240','Detroit','',''),(17168,'48242','Romulus','',''),(17169,'48302','Pontiac','',''),(17170,'48306','Rochester Hills','',''),(17171,'48307','Rochester Hills','',''),(17172,'48309','Auburn Hills','',''),(17173,'48309','Rochester Hills','',''),(17174,'48317','Sterling Heights','',''),(17175,'48322','Farmington Hills','',''),(17176,'48326','Pontiac','',''),(17177,'48328','Keego Harbor','',''),(17178,'48331','Farmington Hills','',''),(17179,'48334','Farmington Hills','',''),(17180,'48335','Farmington Hills','',''),(17181,'48336','Farmington Hills','',''),(17182,'48359','Auburn Hills','',''),(17183,'48381','Wixom','',''),(17184,'48393','Novi','',''),(17185,'48429','Vernon','',''),(17186,'48439','Burton','',''),(17187,'48465','Forestville','',''),(17188,'48506','Burton','',''),(17189,'48529','Flint','',''),(17190,'48601','Bridgeport','',''),(17191,'48609','Shields','',''),(17192,'48610','Skidway Lake','',''),(17193,'48623','Midland','',''),(17194,'48630','Houghton Lake','',''),(17195,'48651','Houghton Lake','',''),(17196,'48656','St. Helen','',''),(17197,'48748','Sand Lake','',''),(17198,'48756','Skidway Lake','',''),(17199,'48763','Sand Lake','',''),(17200,'48801','St. Louis','',''),(17201,'48808','East Lansing','',''),(17202,'48813','Potterville','',''),(17203,'48823','Haslett','',''),(17204,'48823','Lansing','',''),(17205,'48823','Okemos','',''),(17206,'48829','Mcbride','',''),(17207,'48835','Maple Rapids','',''),(17208,'48837','Lansing','',''),(17209,'48842','Lansing','',''),(17210,'48852','Mcbride','',''),(17211,'48854','Holt','',''),(17212,'48854','Lansing','',''),(17213,'48854','Okemos','',''),(17214,'48864','Haslett','',''),(17215,'48864','Lansing','',''),(17216,'48867','Corunna','',''),(17217,'48880','St. Louis','',''),(17218,'48895','Haslett','',''),(17219,'48895','Okemos','',''),(17220,'48906','East Lansing','',''),(17221,'48906','Waverly','',''),(17222,'48910','East Lansing','',''),(17223,'48911','Holt','',''),(17224,'48912','East Lansing','',''),(17225,'48917','Waverly','',''),(17226,'49002','Kalamazoo','',''),(17227,'49024','Kalamazoo','',''),(17228,'49034','Battle Creek','',''),(17229,'49056','Breedsville','',''),(17230,'49074','Kalamazoo','',''),(17231,'49087','Portage','',''),(17232,'49107','New Troy','',''),(17233,'49115','Shorewood-tower Hills-harbert','',''),(17234,'49116','Shorewood-tower Hills-harbert','',''),(17235,'49125','New Troy','',''),(17236,'49125','Shorewood-tower Hills-harbert','',''),(17237,'49128','New Troy','',''),(17238,'49128','Shorewood-tower Hills-harbert','',''),(17239,'49201','Michigan Center','',''),(17240,'49201','Napoleon','',''),(17241,'49203','Michigan Center','',''),(17242,'49220','Manitou Beach-devils Lake','',''),(17243,'49250','Hillsdale','',''),(17244,'49253','Manitou Beach-devils Lake','',''),(17245,'49301','Forest Hills','',''),(17246,'49306','Northview','',''),(17247,'49321','Northview','',''),(17248,'49321','Walker','',''),(17249,'49331','Forest Hills','',''),(17250,'49332','Canadian Lakes','',''),(17251,'49346','Canadian Lakes','',''),(17252,'49408','Douglas','',''),(17253,'49417','Allendale','',''),(17254,'49418','Wyoming','',''),(17255,'49441','Norton Shores','',''),(17256,'49444','Muskegon Heights','',''),(17257,'49444','Norton Shores','',''),(17258,'49453','Douglas','',''),(17259,'49456','Norton Shores','',''),(17260,'49460','Allendale','',''),(17261,'49503','Wyoming','',''),(17262,'49504','Walker','',''),(17263,'49507','Wyoming','',''),(17264,'49508','Kentwood','',''),(17265,'49508','Wyoming','',''),(17266,'49509','Grand Rapids','',''),(17267,'49509','Wyoming','',''),(17268,'49512','Forest Hills','',''),(17269,'49512','Kentwood','',''),(17270,'49525','Forest Hills','',''),(17271,'49525','Northview','',''),(17272,'49534','Walker','',''),(17273,'49544','Walker','',''),(17274,'49546','Forest Hills','',''),(17275,'49546','Kentwood','',''),(17276,'49548','Kentwood','',''),(17277,'49548','Wyoming','',''),(17278,'49622','Eastport','',''),(17279,'49635','Elberta','',''),(17280,'49660','Eastlake','',''),(17281,'49660','Filer City','',''),(17282,'49670','Omena','',''),(17283,'49690','Elk Rapids','',''),(17284,'49706','Conway','',''),(17285,'49706','Oden','',''),(17286,'49713','Walloon Lake','',''),(17287,'49730','Alba','',''),(17288,'49770','Conway','',''),(17289,'49781','St. Ignace','',''),(17290,'49783','Sault Ste. Marie','',''),(17291,'49802','Iron Mountain','',''),(17292,'49841','K. I. Sawyer','',''),(17293,'49849','Negaunee','',''),(17294,'49855','Big Bay','',''),(17295,'49866','Ishpeming','',''),(17296,'49866','Palmer','',''),(17297,'49892','Norway','',''),(17298,'49894','Escanaba','',''),(17299,'49905','Houghton','',''),(17300,'49913','Hubbell','',''),(17301,'49920','Alpha','',''),(17302,'49920','Amasa','',''),(17303,'49930','Dollar Bay','',''),(17304,'49935','Caspian','',''),(17305,'49945','Hubbell','',''),(17306,'50003','De Soto','',''),(17307,'50003','Waukee','',''),(17308,'50006','Popejoy','',''),(17309,'50009','Bondurant','',''),(17310,'50009','Des Moines','',''),(17311,'50035','Altoona','',''),(17312,'50046','Huxley','',''),(17313,'50047','Des Moines','',''),(17314,'50047','Hartford','',''),(17315,'50049','Williamson','',''),(17316,'50061','Norwalk','',''),(17317,'50061','West Des Moines','',''),(17318,'50062','Melcher-dallas','',''),(17319,'50067','Decatur City','',''),(17320,'50072','Dexter','',''),(17321,'50074','Sun Valley Lake','',''),(17322,'50109','Johnston','',''),(17323,'50111','Johnston','',''),(17324,'50111','Urbandale','',''),(17325,'50115','Lake Panorama','',''),(17326,'50126','Bradford','',''),(17327,'50130','Jewell Junction','',''),(17328,'50131','Grimes','',''),(17329,'50131','Urbandale','',''),(17330,'50136','Thornburg','',''),(17331,'50144','Decatur City','',''),(17332,'50154','Mccallsburg','',''),(17333,'50158','Le Grand','',''),(17334,'50163','Melcher-dallas','',''),(17335,'50171','Barnes City','',''),(17336,'50211','Des Moines','',''),(17337,'50216','Lake Panorama','',''),(17338,'50226','Ankeny','',''),(17339,'50226','Sheldahl','',''),(17340,'50229','Bevington','',''),(17341,'50229','Patterson','',''),(17342,'50230','Garden City','',''),(17343,'50240','Bevington','',''),(17344,'50240','Martensdale','',''),(17345,'50243','Slater','',''),(17346,'50244','Alleman','',''),(17347,'50244','Sheldahl','',''),(17348,'50261','De Soto','',''),(17349,'50263','Clive','',''),(17350,'50263','Urbandale','',''),(17351,'50263','West Des Moines','',''),(17352,'50277','Lake Panorama','',''),(17353,'50310','Urbandale','',''),(17354,'50313','Ankeny','',''),(17355,'50317','Altoona','',''),(17356,'50321','Norwalk','',''),(17357,'50321','West Des Moines','',''),(17358,'50322','Clive','',''),(17359,'50322','Des Moines','',''),(17360,'50322','Johnston','',''),(17361,'50323','Clive','',''),(17362,'50324','Clive','',''),(17363,'50325','Urbandale','',''),(17364,'50325','Waukee','',''),(17365,'50325','Windsor Heights','',''),(17366,'50327','Altoona','',''),(17367,'50327','Pleasant Hill','',''),(17368,'50401','Plymouth','',''),(17369,'50401','Rock Falls','',''),(17370,'50428','Ventura','',''),(17371,'50436','Crystal Lake','',''),(17372,'50441','Bradford','',''),(17373,'50441','Coulter','',''),(17374,'50452','Coulter','',''),(17375,'50472','Carpenter','',''),(17376,'50533','Goldfield','',''),(17377,'50540','Varina','',''),(17378,'50541','Bradgate','',''),(17379,'50543','Farnhamville','',''),(17380,'50548','Dakota City','',''),(17381,'50581','Plover','',''),(17382,'50613','Hudson','',''),(17383,'50613','Waterloo','',''),(17384,'50616','Colwell','',''),(17385,'50635','Lincoln','',''),(17386,'50644','Quasqueton','',''),(17387,'50644','Winthrop','',''),(17388,'50648','Gilbertville','',''),(17389,'50648','Raymond','',''),(17390,'50665','Stout','',''),(17391,'50682','Quasqueton','',''),(17392,'50701','Hudson','',''),(17393,'50703','Evansdale','',''),(17394,'50707','Waterloo','',''),(17395,'50801','Cromwell','',''),(17396,'50864','Grant','',''),(17397,'51003','Orange City','',''),(17398,'51024','Sioux City','',''),(17399,'51031','Brunsville','',''),(17400,'51054','Sioux City','',''),(17401,'51058','Calumet','',''),(17402,'51201','Matlock','',''),(17403,'51241','Lester','',''),(17404,'51246','Lester','',''),(17405,'51333','Gillett Grove','',''),(17406,'51351','Arnolds Park','',''),(17407,'51355','Spirit Lake','',''),(17408,'51366','Gillett Grove','',''),(17409,'51401','Halbur','',''),(17410,'51443','Lanesboro','',''),(17411,'51443','Ralston','',''),(17412,'51453','Lanesboro','',''),(17413,'51462','Ralston','',''),(17414,'51530','Westphalia','',''),(17415,'51532','Grant','',''),(17416,'51537','Westphalia','',''),(17417,'51546','Magnolia','',''),(17418,'51630','College Springs','',''),(17419,'51632','Yorktown','',''),(17420,'52037','Maquoketa','',''),(17421,'52037','Welton','',''),(17422,'52040','Farley','',''),(17423,'52041','Dyersville','',''),(17424,'52053','North Buena Vista','',''),(17425,'52068','Dubuque','',''),(17426,'52073','North Buena Vista','',''),(17427,'52078','Dyersville','',''),(17428,'52132','Spillville','',''),(17429,'52157','Marquette','',''),(17430,'52166','St. Lucas','',''),(17431,'52171','Protivin','',''),(17432,'52171','St. Lucas','',''),(17433,'52203','Middle Amana','',''),(17434,'52213','Urbana','',''),(17435,'52225','Vining','',''),(17436,'52227','Cedar Rapids','',''),(17437,'52228','Cedar Rapids','',''),(17438,'52228','Walford','',''),(17439,'52233','Cedar Rapids','',''),(17440,'52240','Coralville','',''),(17441,'52240','Hills','',''),(17442,'52240','Tiffin','',''),(17443,'52246','Coralville','',''),(17444,'52255','Clarence','',''),(17445,'52301','Conroy','',''),(17446,'52302','Cedar Rapids','',''),(17447,'52302','Robins','',''),(17448,'52314','Lisbon','',''),(17449,'52316','Millersburg','',''),(17450,'52318','Walford','',''),(17451,'52322','Tiffin','',''),(17452,'52324','Cedar Rapids','',''),(17453,'52327','Hills','',''),(17454,'52328','Cedar Rapids','',''),(17455,'52328','Hiawatha','',''),(17456,'52329','Quasqueton','',''),(17457,'52335','North English','',''),(17458,'52338','Cedar Rapids','',''),(17459,'52340','North Liberty','',''),(17460,'52341','Robins','',''),(17461,'52361','Conroy','',''),(17462,'52402','Hiawatha','',''),(17463,'52402','Marion','',''),(17464,'52402','Robins','',''),(17465,'52403','Marion','',''),(17466,'52404','Fairfax','',''),(17467,'52411','Hiawatha','',''),(17468,'52411','Robins','',''),(17469,'52577','Beacon','',''),(17470,'52577','Eddyville','',''),(17471,'52577','University Park','',''),(17472,'52601','West Burlington','',''),(17473,'52627','Denmark','',''),(17474,'52639','Fort Madison','',''),(17475,'52655','Burlington','',''),(17476,'52656','Denmark','',''),(17477,'52656','St. Paul','',''),(17478,'52657','St. Paul','',''),(17479,'52658','Denmark','',''),(17480,'52658','Fort Madison','',''),(17481,'52659','Olds','',''),(17482,'52722','Le Claire','',''),(17483,'52726','Buffalo','',''),(17484,'52730','Clinton','',''),(17485,'52730','Low Moor','',''),(17486,'52732','Camanche','',''),(17487,'52738','Columbus City','',''),(17488,'52742','Welton','',''),(17489,'52753','Bettendorf','',''),(17490,'52753','Princeton','',''),(17491,'52754','Grandview','',''),(17492,'52756','Mccausland','',''),(17493,'52758','Mccausland','',''),(17494,'52761','Fruitland','',''),(17495,'52767','Bettendorf','',''),(17496,'52778','Durant','',''),(17497,'52802','Buffalo','',''),(17498,'52803','Bettendorf','',''),(17499,'52804','Buffalo','',''),(17500,'52807','Eldridge','',''),(17501,'53004','Fredonia','',''),(17502,'53005','Elm Grove','',''),(17503,'53012','Grafton','',''),(17504,'53012','Mequon','',''),(17505,'53014','Stockbridge','',''),(17506,'53017','Germantown','',''),(17507,'53017','Richfield','',''),(17508,'53018','Nashotah','',''),(17509,'53018','Wales','',''),(17510,'53022','Milwaukee','',''),(17511,'53022','Richfield','',''),(17512,'53024','Port Washington','',''),(17513,'53024','Saukville','',''),(17514,'53027','Richfield','',''),(17515,'53027','Slinger','',''),(17516,'53029','Delafield','',''),(17517,'53033','Richfield','',''),(17518,'53036','Ashippun','',''),(17519,'53037','Germantown','',''),(17520,'53039','Clyman','',''),(17521,'53042','St. Nazianz','',''),(17522,'53044','Sheboygan Falls','',''),(17523,'53046','Menomonee Falls','',''),(17524,'53051','Butler','',''),(17525,'53051','Lannon','',''),(17526,'53051','Milwaukee','',''),(17527,'53058','Delafield','',''),(17528,'53058','Okauchee Lake','',''),(17529,'53059','Hustisford','',''),(17530,'53066','Ashippun','',''),(17531,'53066','Delafield','',''),(17532,'53066','Okauchee Lake','',''),(17533,'53066','Wales','',''),(17534,'53069','Okauchee Lake','',''),(17535,'53072','Brookfield','',''),(17536,'53072','Hartland','',''),(17537,'53072','Sussex','',''),(17538,'53072','Waukesha','',''),(17539,'53074','Saukville','',''),(17540,'53076','Germantown','',''),(17541,'53078','Hartford','',''),(17542,'53081','Kohler','',''),(17543,'53085','Hingham','',''),(17544,'53086','Hartford','',''),(17545,'53089','Hartland','',''),(17546,'53092','Mequon','',''),(17547,'53093','Hingham','',''),(17548,'53094','Johnson Creek','',''),(17549,'53098','Lebanon','',''),(17550,'53103','Muskego','',''),(17551,'53104','Kenosha','',''),(17552,'53105','Rochester','',''),(17553,'53105','Twin Lakes','',''),(17554,'53105','Waterford','',''),(17555,'53105','Wilmot','',''),(17556,'53110','St. Francis','',''),(17557,'53121','Delavan','',''),(17558,'53122','Brookfield','',''),(17559,'53125','Fontana-on-geneva Lake','',''),(17560,'53125','Walworth','',''),(17561,'53125','Williams Bay','',''),(17562,'53126','Caledonia','',''),(17563,'53126','Mount Pleasant','',''),(17564,'53126','Racine','',''),(17565,'53128','Pell Lake','',''),(17566,'53128','Twin Lakes','',''),(17567,'53129','Greenfield','',''),(17568,'53130','Greendale','',''),(17569,'53132','Greendale','',''),(17570,'53132','Hales Corners','',''),(17571,'53142','Pleasant Prairie','',''),(17572,'53143','Pleasant Prairie','',''),(17573,'53146','Muskego','',''),(17574,'53147','Pell Lake','',''),(17575,'53147','Williams Bay','',''),(17576,'53149','North Prairie','',''),(17577,'53150','New Berlin','',''),(17578,'53154','Milwaukee','',''),(17579,'53158','Kenosha','',''),(17580,'53168','Bristol','',''),(17581,'53168','Silver Lake','',''),(17582,'53177','Mount Pleasant','',''),(17583,'53181','Wilmot','',''),(17584,'53184','Fontana-on-geneva Lake','',''),(17585,'53185','Rochester','',''),(17586,'53186','Brookfield','',''),(17587,'53186','Pewaukee','',''),(17588,'53188','Delafield','',''),(17589,'53188','Pewaukee','',''),(17590,'53188','Wales','',''),(17591,'53207','St. Francis','',''),(17592,'53208','Wauwatosa','',''),(17593,'53210','Wauwatosa','',''),(17594,'53211','Whitefish Bay','',''),(17595,'53213','Wauwatosa','',''),(17596,'53214','West Allis','',''),(17597,'53217','Whitefish Bay','',''),(17598,'53219','Greenfield','',''),(17599,'53219','West Allis','',''),(17600,'53220','Greendale','',''),(17601,'53220','Greenfield','',''),(17602,'53221','Franklin','',''),(17603,'53221','Greenfield','',''),(17604,'53222','Wauwatosa','',''),(17605,'53225','Menomonee Falls','',''),(17606,'53225','Wauwatosa','',''),(17607,'53226','Wauwatosa','',''),(17608,'53226','West Allis','',''),(17609,'53227','Greenfield','',''),(17610,'53227','West Allis','',''),(17611,'53228','Greenfield','',''),(17612,'53228','West Allis','',''),(17613,'53235','St. Francis','',''),(17614,'53402','Caledonia','',''),(17615,'53403','Mount Pleasant','',''),(17616,'53403','Sturtevant','',''),(17617,'53404','Caledonia','',''),(17618,'53404','Mount Pleasant','',''),(17619,'53405','Caledonia','',''),(17620,'53405','Mount Pleasant','',''),(17621,'53406','Caledonia','',''),(17622,'53406','Mount Pleasant','',''),(17623,'53406','Sturtevant','',''),(17624,'53523','Lake Ripley','',''),(17625,'53525','Beloit','',''),(17626,'53532','Deforest','',''),(17627,'53532','Madison','',''),(17628,'53532','Windsor','',''),(17629,'53548','Footville','',''),(17630,'53549','Fort Atkinson','',''),(17631,'53556','Gotham','',''),(17632,'53558','Mcfarland','',''),(17633,'53558','Madison','',''),(17634,'53562','Madison','',''),(17635,'53563','Janesville','',''),(17636,'53579','Lowell','',''),(17637,'53590','Madison','',''),(17638,'53593','Madison','',''),(17639,'53597','Madison','',''),(17640,'53597','Middleton','',''),(17641,'53598','Deforest','',''),(17642,'53702','Pewaukee','',''),(17643,'53705','Middleton','',''),(17644,'53717','Middleton','',''),(17645,'53718','Mcfarland','',''),(17646,'53718','Sun Prairie','',''),(17647,'53804','Patch Grove','',''),(17648,'53807','Dickeyville','',''),(17649,'53818','Belmont','',''),(17650,'53919','Fairwater','',''),(17651,'53923','Friesland','',''),(17652,'53925','Doylestown','',''),(17653,'53926','Kingston','',''),(17654,'53934','Adams','',''),(17655,'53946','Kingston','',''),(17656,'53946','Marquette','',''),(17657,'53949','Packwaukee','',''),(17658,'53954','Portage','',''),(17659,'53954','Wyocena','',''),(17660,'53960','Doylestown','',''),(17661,'53960','Wyocena','',''),(17662,'54002','Hammond','',''),(17663,'54010','Ellsworth','',''),(17664,'54110','Forest Junction','',''),(17665,'54110','Potter','',''),(17666,'54115','Hobart','',''),(17667,'54115','Wrightstown','',''),(17668,'54124','Legend Lake','',''),(17669,'54126','Wrightstown','',''),(17670,'54129','Forest Junction','',''),(17671,'54129','Sherwood','',''),(17672,'54129','Stockbridge','',''),(17673,'54130','Combined Locks','',''),(17674,'54130','Little Chute','',''),(17675,'54130','Wrightstown','',''),(17676,'54135','Legend Lake','',''),(17677,'54136','Appleton','',''),(17678,'54137','Green Valley','',''),(17679,'54154','Green Valley','',''),(17680,'54155','Green Bay','',''),(17681,'54155','Hobart','',''),(17682,'54220','Francis Creek','',''),(17683,'54220','Two Rivers','',''),(17684,'54229','Green Bay','',''),(17685,'54232','St. Nazianz','',''),(17686,'54234','Ephraim','',''),(17687,'54241','Mishicot','',''),(17688,'54247','Francis Creek','',''),(17689,'54301','Allouez','',''),(17690,'54303','Howard','',''),(17691,'54307','Allouez','',''),(17692,'54313','Hobart','',''),(17693,'54313','Howard','',''),(17694,'54313','Suamico','',''),(17695,'54401','Brokaw','',''),(17696,'54401','Rothschild','',''),(17697,'54403','Brokaw','',''),(17698,'54403','Weston','',''),(17699,'54407','Nelsonville','',''),(17700,'54409','Mattoon','',''),(17701,'54421','Abbotsford','',''),(17702,'54452','Brokaw','',''),(17703,'54455','Kronenwetter','',''),(17704,'54455','Rothschild','',''),(17705,'54457','Port Edwards','',''),(17706,'54467','Stevens Point','',''),(17707,'54471','Weston','',''),(17708,'54474','Kronenwetter','',''),(17709,'54476','Rothschild','',''),(17710,'54476','Wausau','',''),(17711,'54476','Weston','',''),(17712,'54481','Plover','',''),(17713,'54482','Plover','',''),(17714,'54494','Port Edwards','',''),(17715,'54495','Port Edwards','',''),(17716,'54525','Montreal','',''),(17717,'54534','Iron Belt','',''),(17718,'54534','Montreal','',''),(17719,'54548','Lac Du Flambeau','',''),(17720,'54601','Onalaska','',''),(17721,'54603','Onalaska','',''),(17722,'54614','Rockland','',''),(17723,'54615','Millston','',''),(17724,'54618','Hustler','',''),(17725,'54622','Buffalo City','',''),(17726,'54631','Mount Sterling','',''),(17727,'54650','Holmen','',''),(17728,'54650','La Crosse','',''),(17729,'54701','Altoona','',''),(17730,'54720','Eau Claire','',''),(17731,'54729','Eau Claire','',''),(17732,'54758','Pigeon Falls','',''),(17733,'54773','Pigeon Falls','',''),(17734,'54806','New Odanah','',''),(17735,'54822','Rice Lake','',''),(17736,'54828','New Post','',''),(17737,'54843','New Post','',''),(17738,'54853','Milltown','',''),(17739,'54861','New Odanah','',''),(17740,'54868','Haugen','',''),(17741,'54874','Superior','',''),(17742,'54904','Butte Des Morts','',''),(17743,'54911','Little Chute','',''),(17744,'54913','Little Chute','',''),(17745,'54915','Combined Locks','',''),(17746,'54915','Kimberly','',''),(17747,'54915','Menasha','',''),(17748,'54929','Embarrass','',''),(17749,'54944','Dale','',''),(17750,'54952','Appleton','',''),(17751,'54952','Sherwood','',''),(17752,'54963','Eureka','',''),(17753,'54963','Waukau','',''),(17754,'54964','Waukau','',''),(17755,'54981','King','',''),(17756,'54985','Oshkosh','',''),(17757,'54986','Butte Des Morts','',''),(17758,'55005','East Bethel','',''),(17759,'55005','St. Francis','',''),(17760,'55011','East Bethel','',''),(17761,'55013','Lindstrom','',''),(17762,'55013','Wyoming','',''),(17763,'55014','Blaine','',''),(17764,'55014','Lino Lakes','',''),(17765,'55019','Northfield','',''),(17766,'55020','Elko New Market','',''),(17767,'55021','Warsaw','',''),(17768,'55024','Lakeville','',''),(17769,'55025','Chisago City','',''),(17770,'55025','Lino Lakes','',''),(17771,'55025','Scandia','',''),(17772,'55025','Wyoming','',''),(17773,'55030','Henriette','',''),(17774,'55032','North Branch','',''),(17775,'55033','Cottage Grove','',''),(17776,'55033','Vermillion','',''),(17777,'55038','Lino Lakes','',''),(17778,'55040','Cambridge','',''),(17779,'55040','St. Francis','',''),(17780,'55042','Oakdale','',''),(17781,'55043','Afton','',''),(17782,'55044','Burnsville','',''),(17783,'55044','Farmington','',''),(17784,'55047','Scandia','',''),(17785,'55052','Warsaw','',''),(17786,'55054','Elko New Market','',''),(17787,'55057','Dundas','',''),(17788,'55068','Apple Valley','',''),(17789,'55068','Lakeville','',''),(17790,'55070','St. Francis','',''),(17791,'55071','Cottage Grove','',''),(17792,'55071','St. Paul Park','',''),(17793,'55073','Chisago City','',''),(17794,'55073','Forest Lake','',''),(17795,'55074','Taylors Falls','',''),(17796,'55075','Inver Grove Heights','',''),(17797,'55075','South St. Paul','',''),(17798,'55076','South St. Paul','',''),(17799,'55079','Chisago City','',''),(17800,'55079','Wyoming','',''),(17801,'55082','Bayport','',''),(17802,'55082','Lake Elmo','',''),(17803,'55089','Red Wing','',''),(17804,'55090','Mahtomedi','',''),(17805,'55092','East Bethel','',''),(17806,'55101','St. Paul','',''),(17807,'55102','St. Paul','',''),(17808,'55103','St. Paul','',''),(17809,'55104','St. Paul','',''),(17810,'55105','St. Paul','',''),(17811,'55106','Maplewood','',''),(17812,'55106','St. Paul','',''),(17813,'55107','St. Paul','',''),(17814,'55108','St. Paul','',''),(17815,'55109','Maplewood','',''),(17816,'55109','Vadnais Heights','',''),(17817,'55109','White Bear Lake','',''),(17818,'55110','Hugo','',''),(17819,'55110','Lino Lakes','',''),(17820,'55110','Mahtomedi','',''),(17821,'55110','Vadnais Heights','',''),(17822,'55110','White Bear Lake','',''),(17823,'55112','New Brighton','',''),(17824,'55112','Roseville','',''),(17825,'55113','Maplewood','',''),(17826,'55113','Roseville','',''),(17827,'55113','St. Paul','',''),(17828,'55114','St. Paul','',''),(17829,'55115','Mahtomedi','',''),(17830,'55115','White Bear Lake','',''),(17831,'55115','Willernie','',''),(17832,'55116','St. Paul','',''),(17833,'55117','Maplewood','',''),(17834,'55117','St. Paul','',''),(17835,'55117','Shoreview','',''),(17836,'55117','Vadnais Heights','',''),(17837,'55118','Inver Grove Heights','',''),(17838,'55118','Mendota','',''),(17839,'55118','Mendota Heights','',''),(17840,'55118','St. Paul','',''),(17841,'55118','West St. Paul','',''),(17842,'55119','Maplewood','',''),(17843,'55119','St. Paul','',''),(17844,'55120','Eagan','',''),(17845,'55120','Mendota','',''),(17846,'55120','Mendota Heights','',''),(17847,'55121','Eagan','',''),(17848,'55121','Inver Grove Heights','',''),(17849,'55121','Mendota Heights','',''),(17850,'55122','Eagan','',''),(17851,'55123','Eagan','',''),(17852,'55123','Inver Grove Heights','',''),(17853,'55124','Apple Valley','',''),(17854,'55125','Woodbury','',''),(17855,'55126','Lino Lakes','',''),(17856,'55126','Shoreview','',''),(17857,'55126','Vadnais Heights','',''),(17858,'55127','Shoreview','',''),(17859,'55127','Vadnais Heights','',''),(17860,'55127','White Bear Lake','',''),(17861,'55128','Lake Elmo','',''),(17862,'55128','Mahtomedi','',''),(17863,'55128','Oakdale','',''),(17864,'55129','Newport','',''),(17865,'55129','Woodbury','',''),(17866,'55130','St. Paul','',''),(17867,'55150','Mendota Heights','',''),(17868,'55155','St. Paul','',''),(17869,'55301','St. Michael','',''),(17870,'55303','Andover','',''),(17871,'55303','Ramsey','',''),(17872,'55304','Coon Rapids','',''),(17873,'55305','Minnetonka','',''),(17874,'55309','Becker','',''),(17875,'55311','Corcoran','',''),(17876,'55311','Maple Grove','',''),(17877,'55311','Rogers','',''),(17878,'55313','Hanover','',''),(17879,'55313','Rockford','',''),(17880,'55313','St. Michael','',''),(17881,'55318','Chanhassen','',''),(17882,'55318','Victoria','',''),(17883,'55320','St. Cloud','',''),(17884,'55322','Waconia','',''),(17885,'55328','Independence','',''),(17886,'55330','Big Lake','',''),(17887,'55330','St. Francis','',''),(17888,'55331','Chanhassen','',''),(17889,'55331','Orono','',''),(17890,'55331','Shorewood','',''),(17891,'55331','Victoria','',''),(17892,'55336','New Auburn','',''),(17893,'55340','Corcoran','',''),(17894,'55343','Edina','',''),(17895,'55343','Minnetonka','',''),(17896,'55343','St. Louis Park','',''),(17897,'55346','Chanhassen','',''),(17898,'55346','Minnetonka','',''),(17899,'55352','Prior Lake','',''),(17900,'55353','Rockville','',''),(17901,'55356','Orono','',''),(17902,'55357','Corcoran','',''),(17903,'55357','Greenfield','',''),(17904,'55357','Hanover','',''),(17905,'55357','Independence','',''),(17906,'55359','Independence','',''),(17907,'55359','Orono','',''),(17908,'55363','Waverly','',''),(17909,'55364','Orono','',''),(17910,'55364','Shorewood','',''),(17911,'55368','Norwood Young America','',''),(17912,'55369','Dayton','',''),(17913,'55369','Maple Grove','',''),(17914,'55369','Rogers','',''),(17915,'55372','Savage','',''),(17916,'55373','Greenfield','',''),(17917,'55373','Independence','',''),(17918,'55374','Corcoran','',''),(17919,'55374','Dayton','',''),(17920,'55375','St. Bonifacius','',''),(17921,'55376','Hanover','',''),(17922,'55376','St. Michael','',''),(17923,'55378','Prior Lake','',''),(17924,'55378','Shakopee','',''),(17925,'55379','Prior Lake','',''),(17926,'55379','Savage','',''),(17927,'55384','Orono','',''),(17928,'55390','Montrose','',''),(17929,'55391','Minnetonka','',''),(17930,'55391','Orono','',''),(17931,'55391','Shorewood','',''),(17932,'55391','Spring Park','',''),(17933,'55397','Norwood Young America','',''),(17934,'55410','Edina','',''),(17935,'55411','Golden Valley','',''),(17936,'55416','Edina','',''),(17937,'55416','Golden Valley','',''),(17938,'55416','St. Louis Park','',''),(17939,'55418','Roseville','',''),(17940,'55420','Bloomington','',''),(17941,'55421','Columbia Heights','',''),(17942,'55421','Fridley','',''),(17943,'55422','Brooklyn Center','',''),(17944,'55422','Golden Valley','',''),(17945,'55422','Robbinsdale','',''),(17946,'55423','Edina','',''),(17947,'55423','Richfield','',''),(17948,'55424','Edina','',''),(17949,'55424','St. Louis Park','',''),(17950,'55425','Bloomington','',''),(17951,'55426','Golden Valley','',''),(17952,'55426','Hopkins','',''),(17953,'55426','Minnetonka','',''),(17954,'55426','St. Louis Park','',''),(17955,'55427','Golden Valley','',''),(17956,'55427','New Hope','',''),(17957,'55428','Brooklyn Park','',''),(17958,'55428','New Hope','',''),(17959,'55429','Brooklyn Center','',''),(17960,'55429','Brooklyn Park','',''),(17961,'55430','Brooklyn Center','',''),(17962,'55430','Brooklyn Park','',''),(17963,'55431','Bloomington','',''),(17964,'55432','Fridley','',''),(17965,'55433','Coon Rapids','',''),(17966,'55434','Blaine','',''),(17967,'55435','Bloomington','',''),(17968,'55435','Edina','',''),(17969,'55436','Edina','',''),(17970,'55436','St. Louis Park','',''),(17971,'55437','Bloomington','',''),(17972,'55438','Bloomington','',''),(17973,'55439','Bloomington','',''),(17974,'55439','Eden Prairie','',''),(17975,'55439','Edina','',''),(17976,'55441','Plymouth','',''),(17977,'55441','St. Louis Park','',''),(17978,'55442','Maple Grove','',''),(17979,'55442','Plymouth','',''),(17980,'55443','Brooklyn Park','',''),(17981,'55444','Brooklyn Center','',''),(17982,'55444','Brooklyn Park','',''),(17983,'55445','Brooklyn Park','',''),(17984,'55446','Plymouth','',''),(17985,'55447','Plymouth','',''),(17986,'55448','Blaine','',''),(17987,'55448','Coon Rapids','',''),(17988,'55449','Blaine','',''),(17989,'55601','Silver Bay','',''),(17990,'55614','Beaver Bay','',''),(17991,'55705','Biwabik','',''),(17992,'55709','Calumet','',''),(17993,'55709','Coleraine','',''),(17994,'55709','Marble','',''),(17995,'55709','Taconite','',''),(17996,'55710','Buhl','',''),(17997,'55710','Kinney','',''),(17998,'55710','Mountain Iron','',''),(17999,'55716','Marble','',''),(18000,'55732','Babbitt','',''),(18001,'55734','Gilbert','',''),(18002,'55734','Mountain Iron','',''),(18003,'55734','Virginia','',''),(18004,'55741','Biwabik','',''),(18005,'55744','Cohasset','',''),(18006,'55744','Coleraine','',''),(18007,'55744','Taconite','',''),(18008,'55746','Keewatin','',''),(18009,'55751','Mountain Iron','',''),(18010,'55758','Buhl','',''),(18011,'55764','Calumet','',''),(18012,'55764','Taconite','',''),(18013,'55768','Buhl','',''),(18014,'55768','Kinney','',''),(18015,'55768','Virginia','',''),(18016,'55769','Keewatin','',''),(18017,'55771','Nett Lake','',''),(18018,'55775','Marble','',''),(18019,'55786','Coleraine','',''),(18020,'55792','Eveleth','',''),(18021,'55792','Gilbert','',''),(18022,'55792','Mountain Iron','',''),(18023,'55807','Proctor','',''),(18024,'55810','Hermantown','',''),(18025,'55810','Proctor','',''),(18026,'55811','Hermantown','',''),(18027,'55814','Hermantown','',''),(18028,'55912','Lansing','',''),(18029,'55920','Rochester','',''),(18030,'55947','Hokah','',''),(18031,'55955','Kasson','',''),(18032,'55956','Pine Island','',''),(18033,'55959','Rollingstone','',''),(18034,'55959','Winona','',''),(18035,'55960','Pine Island','',''),(18036,'55960','Rochester','',''),(18037,'55972','Dover','',''),(18038,'55972','St. Charles','',''),(18039,'55975','Ostrander','',''),(18040,'55976','Rochester','',''),(18041,'56001','Eagle Lake','',''),(18042,'56001','North Mankato','',''),(18043,'56001','St. Clair','',''),(18044,'56003','North Mankato','',''),(18045,'56009','Conger','',''),(18046,'56026','Geneva','',''),(18047,'56031','Northrop','',''),(18048,'56048','St. Clair','',''),(18049,'56050','Mankato','',''),(18050,'56063','Mankato','',''),(18051,'56080','St. Clair','',''),(18052,'56081','St. James','',''),(18053,'56082','Le Sueur','',''),(18054,'56082','St. Peter','',''),(18055,'56097','Freeborn','',''),(18056,'56119','Worthington','',''),(18057,'56120','Darfur','',''),(18058,'56128','Leota','',''),(18059,'56128','Trosky','',''),(18060,'56144','Ihlen','',''),(18061,'56144','Trosky','',''),(18062,'56164','Trosky','',''),(18063,'56215','Clontarf','',''),(18064,'56240','Barry','',''),(18065,'56260','Clara City','',''),(18066,'56279','Willmar','',''),(18067,'56284','Prinsburg','',''),(18068,'56293','Seaforth','',''),(18069,'56301','Rockville','',''),(18070,'56301','St. Cloud','',''),(18071,'56301','St. Joseph','',''),(18072,'56301','Waite Park','',''),(18073,'56303','St. Cloud','',''),(18074,'56303','Sartell','',''),(18075,'56304','St. Cloud','',''),(18076,'56304','Sauk Rapids','',''),(18077,'56312','Elrosa','',''),(18078,'56318','Upsala','',''),(18079,'56320','Rockville','',''),(18080,'56331','New Munich','',''),(18081,'56340','Upsala','',''),(18082,'56345','Flensburg','',''),(18083,'56352','Greenwald','',''),(18084,'56352','New Munich','',''),(18085,'56353','Pease','',''),(18086,'56360','West Union','',''),(18087,'56362','Roscoe','',''),(18088,'56362','St. Martin','',''),(18089,'56367','St. Stephen','',''),(18090,'56374','St. Cloud','',''),(18091,'56374','St. Joseph','',''),(18092,'56374','St. Stephen','',''),(18093,'56375','St. Stephen','',''),(18094,'56376','St. Martin','',''),(18095,'56378','Melrose','',''),(18096,'56379','St. Cloud','',''),(18097,'56379','Sartell','',''),(18098,'56382','Flensburg','',''),(18099,'56382','Upsala','',''),(18100,'56387','St. Cloud','',''),(18101,'56401','Baxter','',''),(18102,'56441','Crosslake','',''),(18103,'56442','Fifty Lakes','',''),(18104,'56447','Fifty Lakes','',''),(18105,'56448','Emily','',''),(18106,'56464','Wolf Lake','',''),(18107,'56472','Crosslake','',''),(18108,'56472','Jenkins','',''),(18109,'56472','Nisswa','',''),(18110,'56474','Jenkins','',''),(18111,'56529','Moorhead','',''),(18112,'56537','Elizabeth','',''),(18113,'56544','Wolf Lake','',''),(18114,'56547','Dilworth','',''),(18115,'56547','Moorhead','',''),(18116,'56548','Shelly','',''),(18117,'56560','Dilworth','',''),(18118,'56569','White Earth','',''),(18119,'56589','White Earth','',''),(18120,'56601','Wilton','',''),(18121,'56649','Ranier','',''),(18122,'56671','Redby','',''),(18123,'56671','Red Lake','',''),(18124,'56728','St. Vincent','',''),(18125,'56754','St. Hilaire','',''),(18126,'56755','St. Vincent','',''),(18127,'57005','Sioux Falls','',''),(18128,'57013','Fairview','',''),(18129,'57042','Lake Madison','',''),(18130,'57049','Dakota Dunes','',''),(18131,'57068','Brandon','',''),(18132,'57071','Sinai','',''),(18133,'57075','Lake Madison','',''),(18134,'57201','Kranzburg','',''),(18135,'57212','Badger','',''),(18136,'57212','Sinai','',''),(18137,'57238','Kranzburg','',''),(18138,'57328','New Holland','',''),(18139,'57356','Pickstown','',''),(18140,'57380','Marty','',''),(18141,'57382','Lane','',''),(18142,'57385','Lane','',''),(18143,'57472','Akaska','',''),(18144,'57555','Okreek','',''),(18145,'57571','St. Charles','',''),(18146,'57580','Okreek','',''),(18147,'57584','New Witten','',''),(18148,'57601','Whitehorse','',''),(18149,'57625','North Eagle Butte','',''),(18150,'57641','Mcintosh','',''),(18151,'57642','Little Eagle','',''),(18152,'57656','Whitehorse','',''),(18153,'57701','Box Elder','',''),(18154,'57702','Blackhawk','',''),(18155,'57703','Box Elder','',''),(18156,'57703','Rapid Valley','',''),(18157,'57706','Box Elder','',''),(18158,'57717','Spearfish','',''),(18159,'57718','Blackhawk','',''),(18160,'57730','Pringle','',''),(18161,'57732','Lead','',''),(18162,'57752','Porcupine','',''),(18163,'57754','Deadwood','',''),(18164,'57756','Manderson-white Horse Creek','',''),(18165,'57770','Oglala','',''),(18166,'57779','St. Onge','',''),(18167,'57785','Deadwood','',''),(18168,'57793','Spearfish','',''),(18169,'58021','Horace','',''),(18170,'58041','Mantador','',''),(18171,'58045','Caledonia','',''),(18172,'58047','Fargo','',''),(18173,'58069','Gwinner','',''),(18174,'58075','Abercrombie','',''),(18175,'58078','Fargo','',''),(18176,'58078','Horace','',''),(18177,'58257','Portland','',''),(18178,'58259','Michigan City','',''),(18179,'58274','Mayville','',''),(18180,'58276','St. Thomas','',''),(18181,'58338','Alsen','',''),(18182,'58352','Alsen','',''),(18183,'58374','Fort Totten','',''),(18184,'58531','Riverdale','',''),(18185,'58538','Cannon Ball','',''),(18186,'58540','White Shield','',''),(18187,'58570','Cannon Ball','',''),(18188,'58601','South Heart','',''),(18189,'58703','Minot Afb','',''),(18190,'58737','Portal','',''),(18191,'58775','White Shield','',''),(18192,'58790','Sawyer','',''),(18193,'59003','Lame Deer','',''),(18194,'59007','Red Lodge','',''),(18195,'59030','Cooke City','',''),(18196,'59030','Silver Gate','',''),(18197,'59035','Fort Smith','',''),(18198,'59043','Birney','',''),(18199,'59047','Emigrant','',''),(18200,'59047','Springdale','',''),(18201,'59065','Emigrant','',''),(18202,'59101','Pryor','',''),(18203,'59230','St. Marie','',''),(18204,'59231','St. Marie','',''),(18205,'59248','Fort Peck','',''),(18206,'59262','Crane','',''),(18207,'59327','Colstrip','',''),(18208,'59349','Fallon','',''),(18209,'59401','Black Eagle','',''),(18210,'59404','Black Eagle','',''),(18211,'59404','Ulm','',''),(18212,'59404','Vaughn','',''),(18213,'59405','Black Eagle','',''),(18214,'59414','Great Falls','',''),(18215,'59417','North Browning','',''),(18216,'59434','East Glacier Park Village','',''),(18217,'59463','Neihart','',''),(18218,'59486','Dupuyer','',''),(18219,'59521','Rocky Boy West','',''),(18220,'59524','Hays','',''),(18221,'59526','Fort Belknap Agency','',''),(18222,'59601','Helena Valley Southeast','',''),(18223,'59601','Helena West Side','',''),(18224,'59602','Helena Valley Southeast','',''),(18225,'59602','Helena Valley West Central','',''),(18226,'59602','Helena West Side','',''),(18227,'59632','Basin','',''),(18228,'59633','Marysville','',''),(18229,'59634','Jefferson City','',''),(18230,'59634','Montana City','',''),(18231,'59635','Helena','',''),(18232,'59635','Helena Valley Southeast','',''),(18233,'59635','Montana City','',''),(18234,'59636','Helena West Side','',''),(18235,'59701','Butte-silver Bow (balance), Mt','',''),(18236,'59701','Walkerville','',''),(18237,'59703','Butte-silver Bow (balance), Mt','',''),(18238,'59703','Walkerville','',''),(18239,'59711','Anaconda-deer Lodge','',''),(18240,'59711','Butte-silver Bow (balance), Mt','',''),(18241,'59713','Elliston','',''),(18242,'59722','Anaconda-deer Lodge','',''),(18243,'59727','Butte-silver Bow (balance), Mt','',''),(18244,'59730','Big Sky','',''),(18245,'59735','Pony','',''),(18246,'59743','Butte-silver Bow (balance), Mt','',''),(18247,'59748','Butte-silver Bow (balance), Mt','',''),(18248,'59750','Butte-silver Bow (balance), Mt','',''),(18249,'59752','Willow Creek','',''),(18250,'59756','Anaconda-deer Lodge','',''),(18251,'59759','Butte-silver Bow (balance), Mt','',''),(18252,'59762','Anaconda-deer Lodge','',''),(18253,'59802','Bonner-west Riverside','',''),(18254,'59804','Orchard Homes','',''),(18255,'59808','Bonner-west Riverside','',''),(18256,'59808','Frenchtown','',''),(18257,'59823','Bonner-west Riverside','',''),(18258,'59845','Lonepine','',''),(18259,'59851','Bonner-west Riverside','',''),(18260,'59860','Pablo','',''),(18261,'59864','Pablo','',''),(18262,'59901','Bigfork','',''),(18263,'59901','Somers','',''),(18264,'59917','Fortine','',''),(18265,'59918','Trego','',''),(18266,'59920','Marion','',''),(18267,'59922','Bigfork','',''),(18268,'59932','Lakeside','',''),(18269,'59933','Trego','',''),(18270,'59934','Fortine','',''),(18271,'60002','Fox Lake','',''),(18272,'60002','Wadsworth','',''),(18273,'60004','Buffalo Grove','',''),(18274,'60004','Mount Prospect','',''),(18275,'60004','Palatine','',''),(18276,'60004','Prospect Heights','',''),(18277,'60005','Elk Grove Village','',''),(18278,'60005','Mount Prospect','',''),(18279,'60005','Rolling Meadows','',''),(18280,'60007','Arlington Heights','',''),(18281,'60007','Bensenville','',''),(18282,'60007','Chicago','',''),(18283,'60007','Des Plaines','',''),(18284,'60007','Mount Prospect','',''),(18285,'60007','Roselle','',''),(18286,'60007','Schaumburg','',''),(18287,'60008','Arlington Heights','',''),(18288,'60008','Palatine','',''),(18289,'60008','Schaumburg','',''),(18290,'60010','Fox River Grove','',''),(18291,'60010','Hoffman Estates','',''),(18292,'60010','Lake Zurich','',''),(18293,'60010','Palatine','',''),(18294,'60013','Algonquin','',''),(18295,'60013','Lake In The Hills','',''),(18296,'60014','Cary','',''),(18297,'60014','Lake In The Hills','',''),(18298,'60015','Buffalo Grove','',''),(18299,'60015','Highland Park','',''),(18300,'60015','Lincolnshire','',''),(18301,'60015','Northbrook','',''),(18302,'60016','Glenview','',''),(18303,'60016','Niles','',''),(18304,'60016','Park Ridge','',''),(18305,'60018','Chicago','',''),(18306,'60018','Elk Grove Village','',''),(18307,'60018','Schiller Park','',''),(18308,'60022','Northbrook','',''),(18309,'60025','Golf','',''),(18310,'60025','Morton Grove','',''),(18311,'60025','Niles','',''),(18312,'60025','Wilmette','',''),(18313,'60026','Northbrook','',''),(18314,'60030','Gurnee','',''),(18315,'60030','Libertyville','',''),(18316,'60030','Round Lake Beach','',''),(18317,'60030','Wauconda','',''),(18318,'60031','Wadsworth','',''),(18319,'60031','Waukegan','',''),(18320,'60035','Highwood','',''),(18321,'60035','Lake Forest','',''),(18322,'60040','Highland Park','',''),(18323,'60041','Fox Lake','',''),(18324,'60043','Winnetka','',''),(18325,'60044','North Chicago','',''),(18326,'60045','Lincolnshire','',''),(18327,'60046','Grayslake','',''),(18328,'60046','Gurnee','',''),(18329,'60046','Lindenhurst','',''),(18330,'60046','Round Lake Beach','',''),(18331,'60047','Arlington Heights','',''),(18332,'60047','Buffalo Grove','',''),(18333,'60048','Grayslake','',''),(18334,'60048','Gurnee','',''),(18335,'60048','Mundelein','',''),(18336,'60048','North Chicago','',''),(18337,'60048','Vernon Hills','',''),(18338,'60048','Waukegan','',''),(18339,'60050','Fox Lake','',''),(18340,'60051','Island Lake','',''),(18341,'60051','Ringwood','',''),(18342,'60051','Spring Grove','',''),(18343,'60053','Niles','',''),(18344,'60056','Arlington Heights','',''),(18345,'60056','Des Plaines','',''),(18346,'60056','Prospect Heights','',''),(18347,'60060','Grayslake','',''),(18348,'60060','Libertyville','',''),(18349,'60060','Vernon Hills','',''),(18350,'60060','Wauconda','',''),(18351,'60061','Buffalo Grove','',''),(18352,'60061','Lincolnshire','',''),(18353,'60061','Mundelein','',''),(18354,'60062','Deerfield','',''),(18355,'60062','Glencoe','',''),(18356,'60062','Glenview','',''),(18357,'60062','Prospect Heights','',''),(18358,'60067','Hoffman Estates','',''),(18359,'60067','Rolling Meadows','',''),(18360,'60067','Schaumburg','',''),(18361,'60068','Chicago','',''),(18362,'60068','Des Plaines','',''),(18363,'60068','Niles','',''),(18364,'60069','Buffalo Grove','',''),(18365,'60069','Vernon Hills','',''),(18366,'60070','Arlington Heights','',''),(18367,'60070','Mount Prospect','',''),(18368,'60070','Wheeling','',''),(18369,'60071','Spring Grove','',''),(18370,'60072','Spring Grove','',''),(18371,'60073','Grayslake','',''),(18372,'60073','Round Lake Beach','',''),(18373,'60073','Wauconda','',''),(18374,'60074','Arlington Heights','',''),(18375,'60074','Rolling Meadows','',''),(18376,'60077','Morton Grove','',''),(18377,'60081','Fox Lake','',''),(18378,'60083','Gurnee','',''),(18379,'60083','Lindenhurst','',''),(18380,'60083','Waukegan','',''),(18381,'60083','Zion','',''),(18382,'60084','Island Lake','',''),(18383,'60085','Gurnee','',''),(18384,'60085','North Chicago','',''),(18385,'60088','Lake Bluff','',''),(18386,'60088','North Chicago','',''),(18387,'60089','Arlington Heights','',''),(18388,'60089','Lincolnshire','',''),(18389,'60089','Vernon Hills','',''),(18390,'60089','Wheeling','',''),(18391,'60090','Arlington Heights','',''),(18392,'60090','Buffalo Grove','',''),(18393,'60090','Prospect Heights','',''),(18394,'60093','Glencoe','',''),(18395,'60093','Glenview','',''),(18396,'60093','Kenilworth','',''),(18397,'60093','Northbrook','',''),(18398,'60093','Wilmette','',''),(18399,'60097','Ringwood','',''),(18400,'60098','Crystal Lake','',''),(18401,'60098','Mchenry','',''),(18402,'60099','Wadsworth','',''),(18403,'60099','Waukegan','',''),(18404,'60099','Winthrop Harbor','',''),(18405,'60101','Bloomingdale','',''),(18406,'60101','Glendale Heights','',''),(18407,'60101','Wood Dale','',''),(18408,'60102','Lake In The Hills','',''),(18409,'60103','Carol Stream','',''),(18410,'60103','Elgin','',''),(18411,'60103','Hanover Park','',''),(18412,'60103','Streamwood','',''),(18413,'60104','Berkeley','',''),(18414,'60106','Addison','',''),(18415,'60106','Chicago','',''),(18416,'60106','Elk Grove Village','',''),(18417,'60107','Bartlett','',''),(18418,'60107','Hanover Park','',''),(18419,'60107','Hoffman Estates','',''),(18420,'60107','Schaumburg','',''),(18421,'60108','Addison','',''),(18422,'60108','Carol Stream','',''),(18423,'60108','Glendale Heights','',''),(18424,'60108','Hanover Park','',''),(18425,'60108','Roselle','',''),(18426,'60112','Dekalb','',''),(18427,'60115','Cortland','',''),(18428,'60115','Sycamore','',''),(18429,'60118','Algonquin','',''),(18430,'60118','Carpentersville','',''),(18431,'60118','Elgin','',''),(18432,'60118','Gilberts','',''),(18433,'60118','Hoffman Estates','',''),(18434,'60118','West Dundee','',''),(18435,'60119','Campton Hills','',''),(18436,'60119','Geneva','',''),(18437,'60119','Kaneville','',''),(18438,'60120','Bartlett','',''),(18439,'60120','Hoffman Estates','',''),(18440,'60120','South Elgin','',''),(18441,'60120','Streamwood','',''),(18442,'60120','Wayne','',''),(18443,'60123','South Elgin','',''),(18444,'60124','Campton Hills','',''),(18445,'60124','Gilberts','',''),(18446,'60124','South Elgin','',''),(18447,'60126','Addison','',''),(18448,'60126','Hillside','',''),(18449,'60126','Oak Brook','',''),(18450,'60126','Villa Park','',''),(18451,'60130','Berwyn','',''),(18452,'60131','Bensenville','',''),(18453,'60131','Chicago','',''),(18454,'60131','Melrose Park','',''),(18455,'60131','Northlake','',''),(18456,'60131','River Grove','',''),(18457,'60133','Bartlett','',''),(18458,'60133','Bloomingdale','',''),(18459,'60133','Carol Stream','',''),(18460,'60133','Roselle','',''),(18461,'60133','Schaumburg','',''),(18462,'60133','Streamwood','',''),(18463,'60134','Batavia','',''),(18464,'60136','Elgin','',''),(18465,'60137','Downers Grove','',''),(18466,'60137','Glendale Heights','',''),(18467,'60137','Lombard','',''),(18468,'60137','Wheaton','',''),(18469,'60139','Bloomingdale','',''),(18470,'60139','Carol Stream','',''),(18471,'60140','Burlington','',''),(18472,'60140','Elgin','',''),(18473,'60140','Huntley','',''),(18474,'60142','Algonquin','',''),(18475,'60142','Gilberts','',''),(18476,'60142','Lake In The Hills','',''),(18477,'60143','Addison','',''),(18478,'60143','Wood Dale','',''),(18479,'60145','Genoa','',''),(18480,'60145','Kirkland','',''),(18481,'60148','Addison','',''),(18482,'60148','Downers Grove','',''),(18483,'60148','Glen Ellyn','',''),(18484,'60148','Villa Park','',''),(18485,'60151','Cortland','',''),(18486,'60151','Elburn','',''),(18487,'60153','Bellwood','',''),(18488,'60153','Broadview','',''),(18489,'60153','Forest Park','',''),(18490,'60154','Hillside','',''),(18491,'60154','Oak Brook','',''),(18492,'60155','Maywood','',''),(18493,'60155','Westchester','',''),(18494,'60156','Algonquin','',''),(18495,'60156','Cary','',''),(18496,'60156','Crystal Lake','',''),(18497,'60156','Huntley','',''),(18498,'60157','Bloomingdale','',''),(18499,'60157','Itasca','',''),(18500,'60157','Roselle','',''),(18501,'60160','Bellwood','',''),(18502,'60160','Franklin Park','',''),(18503,'60160','River Grove','',''),(18504,'60160','Stone Park','',''),(18505,'60163','Elmhurst','',''),(18506,'60163','Hillside','',''),(18507,'60163','Melrose Park','',''),(18508,'60164','Berkeley','',''),(18509,'60164','Franklin Park','',''),(18510,'60164','Northlake','',''),(18511,'60164','Stone Park','',''),(18512,'60169','Schaumburg','',''),(18513,'60171','Franklin Park','',''),(18514,'60172','Bloomingdale','',''),(18515,'60172','Hanover Park','',''),(18516,'60172','Itasca','',''),(18517,'60172','Schaumburg','',''),(18518,'60173','Hoffman Estates','',''),(18519,'60173','Rolling Meadows','',''),(18520,'60174','St. Charles','',''),(18521,'60174','Wayne','',''),(18522,'60175','Campton Hills','',''),(18523,'60175','Elgin','',''),(18524,'60175','St. Charles','',''),(18525,'60175','South Elgin','',''),(18526,'60176','Chicago','',''),(18527,'60176','Franklin Park','',''),(18528,'60177','Bartlett','',''),(18529,'60177','Elgin','',''),(18530,'60177','Wayne','',''),(18531,'60178','Burlington','',''),(18532,'60178','Cortland','',''),(18533,'60178','Dekalb','',''),(18534,'60180','Marengo','',''),(18535,'60181','Addison','',''),(18536,'60181','Lombard','',''),(18537,'60181','Oak Brook','',''),(18538,'60184','Bartlett','',''),(18539,'60185','Bartlett','',''),(18540,'60185','Batavia','',''),(18541,'60185','Carol Stream','',''),(18542,'60185','Geneva','',''),(18543,'60185','St. Charles','',''),(18544,'60185','Warrenville','',''),(18545,'60185','Wayne','',''),(18546,'60185','Winfield','',''),(18547,'60187','Carol Stream','',''),(18548,'60187','Glen Ellyn','',''),(18549,'60187','Winfield','',''),(18550,'60188','Glendale Heights','',''),(18551,'60188','Wheaton','',''),(18552,'60188','Winfield','',''),(18553,'60189','Glen Ellyn','',''),(18554,'60189','Lisle','',''),(18555,'60189','Warrenville','',''),(18556,'60189','Winfield','',''),(18557,'60191','Addison','',''),(18558,'60191','Bensenville','',''),(18559,'60191','Elk Grove Village','',''),(18560,'60191','Itasca','',''),(18561,'60192','Elgin','',''),(18562,'60192','Hoffman Estates','',''),(18563,'60193','Hanover Park','',''),(18564,'60193','Roselle','',''),(18565,'60193','Streamwood','',''),(18566,'60194','Hoffman Estates','',''),(18567,'60194','Streamwood','',''),(18568,'60195','Hoffman Estates','',''),(18569,'60195','Palatine','',''),(18570,'60202','Skokie','',''),(18571,'60203','Skokie','',''),(18572,'60401','Crete','',''),(18573,'60403','Joliet','',''),(18574,'60403','Romeoville','',''),(18575,'60404','Channahon','',''),(18576,'60404','Joliet','',''),(18577,'60406','Alsip','',''),(18578,'60406','Posen','',''),(18579,'60406','Riverdale','',''),(18580,'60406','Robbins','',''),(18581,'60407','Braidwood','',''),(18582,'60407','Coal City','',''),(18583,'60407','Gardner','',''),(18584,'60408','Braceville','',''),(18585,'60409','Dolton','',''),(18586,'60409','Lansing','',''),(18587,'60409','South Holland','',''),(18588,'60410','Joliet','',''),(18589,'60410','Minooka','',''),(18590,'60411','Flossmoor','',''),(18591,'60411','Glenwood','',''),(18592,'60411','Lansing','',''),(18593,'60411','Steger','',''),(18594,'60415','Oak Lawn','',''),(18595,'60415','Worth','',''),(18596,'60417','Park Forest','',''),(18597,'60417','Steger','',''),(18598,'60417','University Park','',''),(18599,'60419','Harvey','',''),(18600,'60419','South Holland','',''),(18601,'60421','Joliet','',''),(18602,'60422','Chicago Heights','',''),(18603,'60422','Homewood','',''),(18604,'60422','Olympia Fields','',''),(18605,'60423','Matteson','',''),(18606,'60423','Mokena','',''),(18607,'60423','Tinley Park','',''),(18608,'60425','Chicago Heights','',''),(18609,'60425','Homewood','',''),(18610,'60425','Thornton','',''),(18611,'60426','Markham','',''),(18612,'60426','Posen','',''),(18613,'60426','South Holland','',''),(18614,'60428','Country Club Hills','',''),(18615,'60428','Harvey','',''),(18616,'60429','Country Club Hills','',''),(18617,'60429','Homewood','',''),(18618,'60429','Markham','',''),(18619,'60430','Chicago Heights','',''),(18620,'60430','Country Club Hills','',''),(18621,'60430','Flossmoor','',''),(18622,'60430','Hazel Crest','',''),(18623,'60430','Thornton','',''),(18624,'60431','Shorewood','',''),(18625,'60432','Lockport','',''),(18626,'60432','New Lenox','',''),(18627,'60433','New Lenox','',''),(18628,'60435','Crest Hill','',''),(18629,'60436','Channahon','',''),(18630,'60439','Bolingbrook','',''),(18631,'60439','Darien','',''),(18632,'60439','Homer Glen','',''),(18633,'60439','Lockport','',''),(18634,'60439','Palos Park','',''),(18635,'60439','Romeoville','',''),(18636,'60439','Woodridge','',''),(18637,'60440','Naperville','',''),(18638,'60440','Romeoville','',''),(18639,'60440','Woodridge','',''),(18640,'60441','Crest Hill','',''),(18641,'60441','Homer Glen','',''),(18642,'60441','Joliet','',''),(18643,'60441','Lemont','',''),(18644,'60441','New Lenox','',''),(18645,'60441','Romeoville','',''),(18646,'60442','Joliet','',''),(18647,'60442','New Lenox','',''),(18648,'60443','Frankfort','',''),(18649,'60443','Olympia Fields','',''),(18650,'60443','Park Forest','',''),(18651,'60443','Richton Park','',''),(18652,'60445','Oak Forest','',''),(18653,'60445','Robbins','',''),(18654,'60446','Bolingbrook','',''),(18655,'60446','Crest Hill','',''),(18656,'60446','Woodridge','',''),(18657,'60447','Channahon','',''),(18658,'60447','Joliet','',''),(18659,'60448','Frankfort','',''),(18660,'60448','Homer Glen','',''),(18661,'60448','New Lenox','',''),(18662,'60448','Orland Park','',''),(18663,'60448','Tinley Park','',''),(18664,'60449','Frankfort','',''),(18665,'60449','University Park','',''),(18666,'60450','Channahon','',''),(18667,'60450','Minooka','',''),(18668,'60450','Seneca','',''),(18669,'60451','Frankfort','',''),(18670,'60451','Joliet','',''),(18671,'60451','Mokena','',''),(18672,'60452','Midlothian','',''),(18673,'60452','Orland Park','',''),(18674,'60452','Tinley Park','',''),(18675,'60453','Chicago Ridge','',''),(18676,'60455','Burbank','',''),(18677,'60455','Hickory Hills','',''),(18678,'60455','Justice','',''),(18679,'60455','Oak Lawn','',''),(18680,'60457','Bridgeview','',''),(18681,'60457','Justice','',''),(18682,'60458','Hickory Hills','',''),(18683,'60458','Willow Springs','',''),(18684,'60459','Bridgeview','',''),(18685,'60462','Oak Forest','',''),(18686,'60462','Palos Heights','',''),(18687,'60462','Palos Park','',''),(18688,'60463','Palos Park','',''),(18689,'60463','Worth','',''),(18690,'60464','Orland Park','',''),(18691,'60464','Palos Heights','',''),(18692,'60464','Palos Hills','',''),(18693,'60466','Chicago Heights','',''),(18694,'60466','University Park','',''),(18695,'60467','Homer Glen','',''),(18696,'60467','Mokena','',''),(18697,'60467','Palos Park','',''),(18698,'60469','Markham','',''),(18699,'60471','Matteson','',''),(18700,'60471','Park Forest','',''),(18701,'60471','University Park','',''),(18702,'60472','Blue Island','',''),(18703,'60472','Midlothian','',''),(18704,'60473','Calumet City','',''),(18705,'60473','Dolton','',''),(18706,'60473','Harvey','',''),(18707,'60473','Lansing','',''),(18708,'60473','Thornton','',''),(18709,'60475','Crete','',''),(18710,'60476','South Holland','',''),(18711,'60477','Country Club Hills','',''),(18712,'60477','Matteson','',''),(18713,'60477','Oak Forest','',''),(18714,'60478','Markham','',''),(18715,'60478','Oak Forest','',''),(18716,'60481','Braidwood','',''),(18717,'60481','Channahon','',''),(18718,'60482','Alsip','',''),(18719,'60482','Chicago Ridge','',''),(18720,'60482','Palos Heights','',''),(18721,'60484','Crete','',''),(18722,'60484','Monee','',''),(18723,'60487','Frankfort','',''),(18724,'60487','Mokena','',''),(18725,'60487','Orland Park','',''),(18726,'60490','Plainfield','',''),(18727,'60490','Romeoville','',''),(18728,'60491','Lockport','',''),(18729,'60491','New Lenox','',''),(18730,'60501','Bridgeview','',''),(18731,'60501','Justice','',''),(18732,'60501','Lyons','',''),(18733,'60501','Summit','',''),(18734,'60501','Willow Springs','',''),(18735,'60502','Batavia','',''),(18736,'60502','North Aurora','',''),(18737,'60503','Montgomery','',''),(18738,'60503','Oswego','',''),(18739,'60504','Naperville','',''),(18740,'60505','Montgomery','',''),(18741,'60505','North Aurora','',''),(18742,'60506','Montgomery','',''),(18743,'60506','North Aurora','',''),(18744,'60506','Sugar Grove','',''),(18745,'60510','Aurora','',''),(18746,'60510','Geneva','',''),(18747,'60510','North Aurora','',''),(18748,'60511','Sugar Grove','',''),(18749,'60512','Montgomery','',''),(18750,'60512','Oswego','',''),(18751,'60512','Yorkville','',''),(18752,'60513','La Grange','',''),(18753,'60513','Lyons','',''),(18754,'60514','Westmont','',''),(18755,'60515','Lisle','',''),(18756,'60515','Westmont','',''),(18757,'60516','Darien','',''),(18758,'60516','Westmont','',''),(18759,'60516','Woodridge','',''),(18760,'60517','Bolingbrook','',''),(18761,'60517','Darien','',''),(18762,'60517','Downers Grove','',''),(18763,'60517','Lisle','',''),(18764,'60519','Aurora','',''),(18765,'60521','Burr Ridge','',''),(18766,'60521','Clarendon Hills','',''),(18767,'60521','Oak Brook','',''),(18768,'60521','Westmont','',''),(18769,'60523','Downers Grove','',''),(18770,'60523','Elmhurst','',''),(18771,'60523','Hinsdale','',''),(18772,'60523','Westmont','',''),(18773,'60525','Burr Ridge','',''),(18774,'60525','Hinsdale','',''),(18775,'60525','La Grange Park','',''),(18776,'60525','Lyons','',''),(18777,'60525','Western Springs','',''),(18778,'60525','Willow Springs','',''),(18779,'60526','La Grange','',''),(18780,'60527','Burr Ridge','',''),(18781,'60527','Darien','',''),(18782,'60527','Hinsdale','',''),(18783,'60527','Westmont','',''),(18784,'60527','Willow Springs','',''),(18785,'60532','Naperville','',''),(18786,'60532','Woodridge','',''),(18787,'60538','Aurora','',''),(18788,'60538','Oswego','',''),(18789,'60539','Batavia','',''),(18790,'60539','North Aurora','',''),(18791,'60540','Lisle','',''),(18792,'60540','Woodridge','',''),(18793,'60541','Millbrook','',''),(18794,'60541','Millington','',''),(18795,'60541','Yorkville','',''),(18796,'60542','Aurora','',''),(18797,'60543','Aurora','',''),(18798,'60543','Montgomery','',''),(18799,'60543','Plainfield','',''),(18800,'60544','Bolingbrook','',''),(18801,'60544','Joliet','',''),(18802,'60544','Romeoville','',''),(18803,'60545','Sandwich','',''),(18804,'60545','Yorkville','',''),(18805,'60546','Brookfield','',''),(18806,'60546','Forest Park','',''),(18807,'60546','Lyons','',''),(18808,'60548','Lake Holiday','',''),(18809,'60551','Millington','',''),(18810,'60552','Lake Holiday','',''),(18811,'60552','Sandwich','',''),(18812,'60554','Aurora','',''),(18813,'60554','Big Rock','',''),(18814,'60558','Hinsdale','',''),(18815,'60559','Downers Grove','',''),(18816,'60560','Joliet','',''),(18817,'60560','Millbrook','',''),(18818,'60560','Montgomery','',''),(18819,'60560','Oswego','',''),(18820,'60561','Downers Grove','',''),(18821,'60561','Woodridge','',''),(18822,'60563','Aurora','',''),(18823,'60563','Lisle','',''),(18824,'60563','Warrenville','',''),(18825,'60563','Wheaton','',''),(18826,'60564','Aurora','',''),(18827,'60564','Plainfield','',''),(18828,'60565','Bolingbrook','',''),(18829,'60565','Woodridge','',''),(18830,'60585','Aurora','',''),(18831,'60585','Bolingbrook','',''),(18832,'60585','Naperville','',''),(18833,'60586','Joliet','',''),(18834,'60586','Shorewood','',''),(18835,'60634','Norridge','',''),(18836,'60638','Bridgeview','',''),(18837,'60638','Burbank','',''),(18838,'60645','Lincolnwood','',''),(18839,'60646','Skokie','',''),(18840,'60655','Oak Lawn','',''),(18841,'60656','Norridge','',''),(18842,'60706','Chicago','',''),(18843,'60706','Norridge','',''),(18844,'60707','Chicago','',''),(18845,'60707','River Grove','',''),(18846,'60714','Chicago','',''),(18847,'60714','Glenview','',''),(18848,'60714','Morton Grove','',''),(18849,'60803','Chicago Ridge','',''),(18850,'60803','Oak Lawn','',''),(18851,'60803','Palos Heights','',''),(18852,'60804','Berwyn','',''),(18853,'60804','Chicago','',''),(18854,'60827','Blue Island','',''),(18855,'60827','Chicago','',''),(18856,'60827','Dolton','',''),(18857,'60901','Aroma Park','',''),(18858,'60901','Bradley','',''),(18859,'60911','Clifton','',''),(18860,'60914','Bradley','',''),(18861,'60915','Bourbonnais','',''),(18862,'60915','Kankakee','',''),(18863,'60922','Kankakee','',''),(18864,'60931','Iroquois','',''),(18865,'60942','Rossville','',''),(18866,'60950','Bourbonnais','',''),(18867,'60950','Bradley','',''),(18868,'60953','Woodland','',''),(18869,'60964','Aroma Park','',''),(18870,'60970','Iroquois','',''),(18871,'61001','Apple Canyon Lake','',''),(18872,'61008','Cherry Valley','',''),(18873,'61008','Rockford','',''),(18874,'61011','Loves Park','',''),(18875,'61011','Machesney Park','',''),(18876,'61011','Roscoe','',''),(18877,'61016','Belvidere','',''),(18878,'61019','Lake Summerset','',''),(18879,'61020','Rockford','',''),(18880,'61021','Amboy','',''),(18881,'61032','Cedarville','',''),(18882,'61037','Sterling','',''),(18883,'61068','Creston','',''),(18884,'61072','Roscoe','',''),(18885,'61072','South Beloit','',''),(18886,'61073','Machesney Park','',''),(18887,'61073','South Beloit','',''),(18888,'61075','Apple Canyon Lake','',''),(18889,'61080','Rockton','',''),(18890,'61080','Roscoe','',''),(18891,'61087','Nora','',''),(18892,'61088','Rockford','',''),(18893,'61103','Machesney Park','',''),(18894,'61108','Cherry Valley','',''),(18895,'61109','Cherry Valley','',''),(18896,'61111','Machesney Park','',''),(18897,'61111','Rockford','',''),(18898,'61112','Cherry Valley','',''),(18899,'61114','Loves Park','',''),(18900,'61115','Loves Park','',''),(18901,'61201','Milan','',''),(18902,'61231','Matherville','',''),(18903,'61236','East Moline','',''),(18904,'61239','Silvis','',''),(18905,'61240','Colona','',''),(18906,'61240','Moline','',''),(18907,'61244','Carbon Cliff','',''),(18908,'61244','Hampton','',''),(18909,'61244','Moline','',''),(18910,'61244','Silvis','',''),(18911,'61256','East Moline','',''),(18912,'61257','East Moline','',''),(18913,'61264','Andalusia','',''),(18914,'61264','Moline','',''),(18915,'61264','Reynolds','',''),(18916,'61264','Rock Island','',''),(18917,'61265','East Moline','',''),(18918,'61265','Milan','',''),(18919,'61265','Rock Island','',''),(18920,'61265','Silvis','',''),(18921,'61275','East Moline','',''),(18922,'61275','Rapids City','',''),(18923,'61277','Lyndon','',''),(18924,'61282','Carbon Cliff','',''),(18925,'61282','East Moline','',''),(18926,'61284','Andalusia','',''),(18927,'61301','Lasalle','',''),(18928,'61301','North Utica','',''),(18929,'61301','Peru','',''),(18930,'61312','Cherry','',''),(18931,'61312','Ladd','',''),(18932,'61315','Bureau Junction','',''),(18933,'61322','De Pue','',''),(18934,'61326','Mark','',''),(18935,'61326','Standard','',''),(18936,'61327','Mark','',''),(18937,'61335','Mcnabb','',''),(18938,'61341','Ottawa','',''),(18939,'61341','Seneca','',''),(18940,'61342','Troy Grove','',''),(18941,'61344','Annawan','',''),(18942,'61348','Lasalle','',''),(18943,'61348','North Utica','',''),(18944,'61348','Peru','',''),(18945,'61354','Cedar Point','',''),(18946,'61354','Dalzell','',''),(18947,'61354','Lasalle','',''),(18948,'61354','Spring Valley','',''),(18949,'61356','Bureau Junction','',''),(18950,'61356','De Pue','',''),(18951,'61356','Dover','',''),(18952,'61358','Wenona','',''),(18953,'61362','Dalzell','',''),(18954,'61362','De Pue','',''),(18955,'61362','Ladd','',''),(18956,'61362','Seatonville','',''),(18957,'61373','Lasalle','',''),(18958,'61373','North Utica','',''),(18959,'61373','Troy Grove','',''),(18960,'61375','La Rose','',''),(18961,'61376','Manlius','',''),(18962,'61379','Manlius','',''),(18963,'61401','East Galesburg','',''),(18964,'61401','Knoxville','',''),(18965,'61428','Oak Run','',''),(18966,'61428','Williamsfield','',''),(18967,'61430','Galesburg','',''),(18968,'61448','East Galesburg','',''),(18969,'61455','Bardolph','',''),(18970,'61465','Windsor','',''),(18971,'61485','Oak Run','',''),(18972,'61488','Henderson','',''),(18973,'61520','Dunfermline','',''),(18974,'61520','Norris','',''),(18975,'61520','St. David','',''),(18976,'61523','Rome','',''),(18977,'61525','Peoria','',''),(18978,'61528','Peoria','',''),(18979,'61529','Farmington','',''),(18980,'61533','Kingston Mines','',''),(18981,'61535','Morton','',''),(18982,'61544','Fairview','',''),(18983,'61546','Pekin','',''),(18984,'61547','Kingston Mines','',''),(18985,'61554','Creve Coeur','',''),(18986,'61554','East Peoria','',''),(18987,'61554','South Pekin','',''),(18988,'61563','St. David','',''),(18989,'61568','Morton','',''),(18990,'61570','La Rose','',''),(18991,'61571','East Peoria','',''),(18992,'61571','Morton','',''),(18993,'61605','Bartonville','',''),(18994,'61607','Bartonville','',''),(18995,'61607','Pekin','',''),(18996,'61610','East Peoria','',''),(18997,'61611','Creve Coeur','',''),(18998,'61611','Morton','',''),(18999,'61611','Peoria Heights','',''),(19000,'61614','Peoria Heights','',''),(19001,'61616','Peoria','',''),(19002,'61701','Normal','',''),(19003,'61704','Normal','',''),(19004,'61705','Downs','',''),(19005,'61705','Normal','',''),(19006,'61729','Goodfield','',''),(19007,'61733','Goodfield','',''),(19008,'61748','Normal','',''),(19009,'61754','Mclean','',''),(19010,'61761','Bloomington','',''),(19011,'61776','Normal','',''),(19012,'61801','Champaign','',''),(19013,'61811','Henning','',''),(19014,'61813','Ivesdale','',''),(19015,'61818','Laplace','',''),(19016,'61820','Savoy','',''),(19017,'61820','Urbana','',''),(19018,'61822','Bondville','',''),(19019,'61822','Mahomet','',''),(19020,'61822','Savoy','',''),(19021,'61832','Tilton','',''),(19022,'61833','Danville','',''),(19023,'61834','Catlin','',''),(19024,'61834','Tilton','',''),(19025,'61840','Mahomet','',''),(19026,'61856','Ivesdale','',''),(19027,'61859','Royal','',''),(19028,'61865','Henning','',''),(19029,'61873','Royal','',''),(19030,'61873','St. Joseph','',''),(19031,'61875','Mahomet','',''),(19032,'61880','Savoy','',''),(19033,'61925','Mount Zion','',''),(19034,'61929','Laplace','',''),(19035,'61936','Laplace','',''),(19036,'61938','Charleston','',''),(19037,'61944','Vermilion','',''),(19038,'62002','Bethalto','',''),(19039,'62002','East Alton','',''),(19040,'62002','Godfrey','',''),(19041,'62009','Sawyerville','',''),(19042,'62010','Alton','',''),(19043,'62010','Wood River','',''),(19044,'62012','Godfrey','',''),(19045,'62015','Litchfield','',''),(19046,'62018','Alton','',''),(19047,'62018','Bethalto','',''),(19048,'62018','East Alton','',''),(19049,'62024','Alton','',''),(19050,'62024','Bethalto','',''),(19051,'62024','Hartford','',''),(19052,'62024','Wood River','',''),(19053,'62025','Glen Carbon','',''),(19054,'62025','Hamel','',''),(19055,'62025','Roxana','',''),(19056,'62025','South Roxana','',''),(19057,'62025','Wood River','',''),(19058,'62033','Wilsonville','',''),(19059,'62034','Edwardsville','',''),(19060,'62034','Troy','',''),(19061,'62035','Alton','',''),(19062,'62040','Edwardsville','',''),(19063,'62040','Glen Carbon','',''),(19064,'62040','Hartford','',''),(19065,'62040','Madison','',''),(19066,'62048','Edwardsville','',''),(19067,'62048','Granite City','',''),(19068,'62048','Roxana','',''),(19069,'62048','Wood River','',''),(19070,'62049','Taylor Springs','',''),(19071,'62051','Hillsboro','',''),(19072,'62059','Brooklyn','',''),(19073,'62060','Granite City','',''),(19074,'62060','Venice','',''),(19075,'62062','Glen Carbon','',''),(19076,'62062','Troy','',''),(19077,'62067','Bethalto','',''),(19078,'62069','Eagarville','',''),(19079,'62074','Livingston','',''),(19080,'62078','Wilmington','',''),(19081,'62082','Alsey','',''),(19082,'62082','Manchester','',''),(19083,'62082','Wilmington','',''),(19084,'62084','Hartford','',''),(19085,'62084','South Roxana','',''),(19086,'62084','Wood River','',''),(19087,'62086','Panama','',''),(19088,'62087','Hartford','',''),(19089,'62087','Roxana','',''),(19090,'62088','Livingston','',''),(19091,'62088','Sawyerville','',''),(19092,'62090','Madison','',''),(19093,'62095','Bethalto','',''),(19094,'62095','East Alton','',''),(19095,'62095','Roxana','',''),(19096,'62097','Hamel','',''),(19097,'62097','Livingston','',''),(19098,'62201','Brooklyn','',''),(19099,'62201','East St. Louis','',''),(19100,'62201','Granite City','',''),(19101,'62201','Madison','',''),(19102,'62203','Caseyville','',''),(19103,'62203','East St. Louis','',''),(19104,'62203','Fairview Heights','',''),(19105,'62204','Caseyville','',''),(19106,'62204','East St. Louis','',''),(19107,'62205','East St. Louis','',''),(19108,'62206','Cahokia','',''),(19109,'62207','East St. Louis','',''),(19110,'62208','Belleville','',''),(19111,'62208','Caseyville','',''),(19112,'62208','East St. Louis','',''),(19113,'62208','Ofallon','',''),(19114,'62208','Swansea','',''),(19115,'62220','Smithton','',''),(19116,'62221','Freeburg','',''),(19117,'62221','Mascoutah','',''),(19118,'62221','Scott Afb','',''),(19119,'62221','Swansea','',''),(19120,'62223','East St. Louis','',''),(19121,'62223','Fairview Heights','',''),(19122,'62223','Millstadt','',''),(19123,'62223','Swansea','',''),(19124,'62225','Ofallon','',''),(19125,'62225','Scott Afb','',''),(19126,'62226','Fairview Heights','',''),(19127,'62226','Swansea','',''),(19128,'62231','Beckemeyer','',''),(19129,'62231','Keyesport','',''),(19130,'62232','Collinsville','',''),(19131,'62232','Fairview Heights','',''),(19132,'62232','Ofallon','',''),(19133,'62234','Caseyville','',''),(19134,'62234','Maryville','',''),(19135,'62234','Troy','',''),(19136,'62236','Dupo','',''),(19137,'62239','Cahokia','',''),(19138,'62240','Cahokia','',''),(19139,'62240','Dupo','',''),(19140,'62243','Belleville','',''),(19141,'62243','Mascoutah','',''),(19142,'62243','Smithton','',''),(19143,'62245','Albers','',''),(19144,'62254','Mascoutah','',''),(19145,'62254','Ofallon','',''),(19146,'62257','Lenzburg','',''),(19147,'62257','St. Libory','',''),(19148,'62258','New Baden','',''),(19149,'62260','Cahokia','',''),(19150,'62264','Hecker','',''),(19151,'62265','Albers','',''),(19152,'62269','Ofallon','',''),(19153,'62269','Swansea','',''),(19154,'62272','Willisville','',''),(19155,'62275','Pierron','',''),(19156,'62278','Hecker','',''),(19157,'62282','St. Libory','',''),(19158,'62293','Summerfield','',''),(19159,'62298','Hecker','',''),(19160,'62298','Valmeyer','',''),(19161,'62321','Ferris','',''),(19162,'62340','Perry','',''),(19163,'62340','Pittsfield','',''),(19164,'62341','Elvaston','',''),(19165,'62376','Lima','',''),(19166,'62379','Elvaston','',''),(19167,'62379','Hamilton','',''),(19168,'62401','Watson','',''),(19169,'62458','St. Elmo','',''),(19170,'62459','Ste. Marie','',''),(19171,'62460','St. Francisville','',''),(19172,'62467','Effingham','',''),(19173,'62475','Ste. Marie','',''),(19174,'62480','Ste. Marie','',''),(19175,'62501','Decatur','',''),(19176,'62521','Mount Zion','',''),(19177,'62522','Harristown','',''),(19178,'62526','Forsyth','',''),(19179,'62530','Auburn','',''),(19180,'62535','Decatur','',''),(19181,'62536','Chatham','',''),(19182,'62544','Boody','',''),(19183,'62549','Mount Zion','',''),(19184,'62551','Harristown','',''),(19185,'62554','Decatur','',''),(19186,'62555','Taylorville','',''),(19187,'62558','Tovey','',''),(19188,'62563','Springfield','',''),(19189,'62568','Kincaid','',''),(19190,'62571','Pana','',''),(19191,'62615','Chatham','',''),(19192,'62615','Thayer','',''),(19193,'62626','Nilwood','',''),(19194,'62628','Concord','',''),(19195,'62629','Springfield','',''),(19196,'62650','Woodson','',''),(19197,'62670','Springfield','',''),(19198,'62684','Williamsville','',''),(19199,'62694','Alsey','',''),(19200,'62707','Riverton','',''),(19201,'62707','Sherman','',''),(19202,'62712','Rochester','',''),(19203,'62801','Hoffman','',''),(19204,'62801','Irvington','',''),(19205,'62809','Mill Shoals','',''),(19206,'62812','Buckner','',''),(19207,'62812','North City','',''),(19208,'62812','Orient','',''),(19209,'62812','Valier','',''),(19210,'62816','Ina','',''),(19211,'62821','Maunie','',''),(19212,'62822','North City','',''),(19213,'62824','Sailor Springs','',''),(19214,'62825','North City','',''),(19215,'62832','Pinckneyville','',''),(19216,'62837','Mill Shoals','',''),(19217,'62856','Hanaford','',''),(19218,'62859','Mcleansboro','',''),(19219,'62863','Bellmont','',''),(19220,'62863','Keensburg','',''),(19221,'62865','Christopher','',''),(19222,'62865','North City','',''),(19223,'62865','Zeigler','',''),(19224,'62880','St. Peter','',''),(19225,'62890','Hanaford','',''),(19226,'62896','Freeman Spur','',''),(19227,'62897','Benton','',''),(19228,'62901','Carterville','',''),(19229,'62906','Jonesboro','',''),(19230,'62910','Metropolis','',''),(19231,'62918','Cambria','',''),(19232,'62918','Colp','',''),(19233,'62918','Herrin','',''),(19234,'62918','Marion','',''),(19235,'62920','Alto Pass','',''),(19236,'62922','Marion','',''),(19237,'62922','New Burnside','',''),(19238,'62924','Hurst','',''),(19239,'62926','Mill Creek','',''),(19240,'62932','Dowell','',''),(19241,'62933','Herrin','',''),(19242,'62941','Karnak','',''),(19243,'62946','Muddy','',''),(19244,'62946','Raleigh','',''),(19245,'62948','Energy','',''),(19246,'62957','Mcclure','',''),(19247,'62959','Herrin','',''),(19248,'62961','Mill Creek','',''),(19249,'62965','Harrisburg','',''),(19250,'62966','Carbondale','',''),(19251,'62988','Olive Branch','',''),(19252,'62990','Olive Branch','',''),(19253,'63005','Ballwin','',''),(19254,'63005','Wildwood','',''),(19255,'63011','Chesterfield','',''),(19256,'63011','Wildwood','',''),(19257,'63012','Pevely','',''),(19258,'63017','Ballwin','',''),(19259,'63017','Maryland Heights','',''),(19260,'63019','Herculaneum','',''),(19261,'63021','Des Peres','',''),(19262,'63021','Valley Park','',''),(19263,'63021','Wildwood','',''),(19264,'63025','Wildwood','',''),(19265,'63026','Valley Park','',''),(19266,'63028','Crystal City','',''),(19267,'63028','Herculaneum','',''),(19268,'63031','Ferguson','',''),(19269,'63031','Hazelwood','',''),(19270,'63031','Old Jamestown','',''),(19271,'63033','Old Jamestown','',''),(19272,'63034','Old Jamestown','',''),(19273,'63038','Wildwood','',''),(19274,'63040','Wildwood','',''),(19275,'63042','Berkeley','',''),(19276,'63042','Bridgeton','',''),(19277,'63042','Florissant','',''),(19278,'63043','Bridgeton','',''),(19279,'63044','Hazelwood','',''),(19280,'63044','Maryland Heights','',''),(19281,'63044','St. Ann','',''),(19282,'63045','Bridgeton','',''),(19283,'63048','Pevely','',''),(19284,'63052','Kimmswick','',''),(19285,'63055','Gray Summit','',''),(19286,'63057','Barnhart','',''),(19287,'63069','Eureka','',''),(19288,'63069','Gray Summit','',''),(19289,'63069','Wildwood','',''),(19290,'63070','Herculaneum','',''),(19291,'63074','Bridgeton','',''),(19292,'63074','St. Ann','',''),(19293,'63089','Gray Summit','',''),(19294,'63101','St. Louis','',''),(19295,'63102','St. Louis','',''),(19296,'63103','St. Louis','',''),(19297,'63104','St. Louis','',''),(19298,'63105','Clayton','',''),(19299,'63105','St. Louis','',''),(19300,'63105','University City','',''),(19301,'63106','St. Louis','',''),(19302,'63107','St. Louis','',''),(19303,'63108','St. Louis','',''),(19304,'63109','St. Louis','',''),(19305,'63110','St. Louis','',''),(19306,'63111','St. Louis','',''),(19307,'63112','St. Louis','',''),(19308,'63113','St. Louis','',''),(19309,'63114','Berkeley','',''),(19310,'63114','Olivette','',''),(19311,'63114','Overland','',''),(19312,'63114','St. Ann','',''),(19313,'63115','St. Louis','',''),(19314,'63116','St. Louis','',''),(19315,'63117','Brentwood','',''),(19316,'63117','Clayton','',''),(19317,'63117','Maplewood','',''),(19318,'63117','Richmond Heights','',''),(19319,'63117','St. Louis','',''),(19320,'63118','St. Louis','',''),(19321,'63119','Brentwood','',''),(19322,'63119','Ladue','',''),(19323,'63119','St. Louis','',''),(19324,'63119','Webster Groves','',''),(19325,'63120','St. Louis','',''),(19326,'63121','Berkeley','',''),(19327,'63121','Ferguson','',''),(19328,'63121','Jennings','',''),(19329,'63121','Northwoods','',''),(19330,'63121','Pagedale','',''),(19331,'63122','Crestwood','',''),(19332,'63122','Des Peres','',''),(19333,'63122','Kirkwood','',''),(19334,'63122','Sunset Hills','',''),(19335,'63122','Valley Park','',''),(19336,'63123','Affton','',''),(19337,'63123','Concord','',''),(19338,'63123','Crestwood','',''),(19339,'63123','Lemay','',''),(19340,'63123','St. Louis','',''),(19341,'63124','Clayton','',''),(19342,'63124','Ladue','',''),(19343,'63124','Olivette','',''),(19344,'63124','Richmond Heights','',''),(19345,'63124','University City','',''),(19346,'63125','Affton','',''),(19347,'63125','Lemay','',''),(19348,'63125','St. Louis','',''),(19349,'63126','Crestwood','',''),(19350,'63126','Sunset Hills','',''),(19351,'63126','Webster Groves','',''),(19352,'63127','Crestwood','',''),(19353,'63127','Kirkwood','',''),(19354,'63127','Sunset Hills','',''),(19355,'63128','Concord','',''),(19356,'63128','Sunset Hills','',''),(19357,'63129','Concord','',''),(19358,'63129','Oakville','',''),(19359,'63130','Clayton','',''),(19360,'63130','Pagedale','',''),(19361,'63130','St. Louis','',''),(19362,'63130','University City','',''),(19363,'63131','Creve Coeur','',''),(19364,'63131','Des Peres','',''),(19365,'63131','Kirkwood','',''),(19366,'63131','Ladue','',''),(19367,'63132','Creve Coeur','',''),(19368,'63132','Olivette','',''),(19369,'63132','Overland','',''),(19370,'63132','University City','',''),(19371,'63133','Pagedale','',''),(19372,'63133','St. Louis','',''),(19373,'63133','University City','',''),(19374,'63134','Berkeley','',''),(19375,'63134','Bridgeton','',''),(19376,'63134','Ferguson','',''),(19377,'63134','Hazelwood','',''),(19378,'63134','Kinloch','',''),(19379,'63134','St. Ann','',''),(19380,'63135','Ferguson','',''),(19381,'63135','Hazelwood','',''),(19382,'63136','Bellefontaine Neighbors','',''),(19383,'63136','Ferguson','',''),(19384,'63136','Jennings','',''),(19385,'63136','Northwoods','',''),(19386,'63136','St. Louis','',''),(19387,'63137','Bellefontaine Neighbors','',''),(19388,'63137','Jennings','',''),(19389,'63137','St. Louis','',''),(19390,'63138','Bellefontaine Neighbors','',''),(19391,'63138','Spanish Lake','',''),(19392,'63139','St. Louis','',''),(19393,'63140','Kinloch','',''),(19394,'63141','Chesterfield','',''),(19395,'63141','Creve Coeur','',''),(19396,'63141','Ladue','',''),(19397,'63143','Maplewood','',''),(19398,'63143','Richmond Heights','',''),(19399,'63143','St. Louis','',''),(19400,'63144','Brentwood','',''),(19401,'63144','Maplewood','',''),(19402,'63144','Richmond Heights','',''),(19403,'63144','Webster Groves','',''),(19404,'63146','Chesterfield','',''),(19405,'63146','Creve Coeur','',''),(19406,'63146','Maryland Heights','',''),(19407,'63147','St. Louis','',''),(19408,'63155','St. Louis','',''),(19409,'63301','St. Charles','',''),(19410,'63301','St. Peters','',''),(19411,'63301','West Alton','',''),(19412,'63303','St. Charles','',''),(19413,'63303','St. Peters','',''),(19414,'63304','Ofallon','',''),(19415,'63304','St. Peters','',''),(19416,'63341','Ofallon','',''),(19417,'63348','Wentzville','',''),(19418,'63366','Lake St. Louis','',''),(19419,'63366','Ofallon','',''),(19420,'63366','St. Peters','',''),(19421,'63366','Wentzville','',''),(19422,'63367','Lake St. Louis','',''),(19423,'63367','Ofallon','',''),(19424,'63367','Wentzville','',''),(19425,'63368','Lake St. Louis','',''),(19426,'63368','Ofallon','',''),(19427,'63376','Ofallon','',''),(19428,'63376','St. Charles','',''),(19429,'63376','St. Peters','',''),(19430,'63377','Whiteside','',''),(19431,'63385','Lake St. Louis','',''),(19432,'63385','Ofallon','',''),(19433,'63390','Warrenton','',''),(19434,'63430','Wayland','',''),(19435,'63549','Gibbs','',''),(19436,'63601','Doe Run','',''),(19437,'63601','Leadwood','',''),(19438,'63628','Leadwood','',''),(19439,'63637','Park Hills','',''),(19440,'63640','Park Hills','',''),(19441,'63650','Pilot Knob','',''),(19442,'63701','Dutchtown','',''),(19443,'63701','Jackson','',''),(19444,'63703','Scott City','',''),(19445,'63736','Morley','',''),(19446,'63740','Delta','',''),(19447,'63755','Cape Girardeau','',''),(19448,'63771','Morley','',''),(19449,'63780','Cape Girardeau','',''),(19450,'63780','Commerce','',''),(19451,'63780','Kelso','',''),(19452,'63801','Blodgett','',''),(19453,'63801','Morehouse','',''),(19454,'63834','Anniston','',''),(19455,'63834','Wyatt','',''),(19456,'63848','Tallapoosa','',''),(19457,'63867','Canalou','',''),(19458,'63873','Marston','',''),(19459,'64001','Blackburn','',''),(19460,'64011','Oak Grove','',''),(19461,'64012','Kansas City','',''),(19462,'64012','Peculiar','',''),(19463,'64014','Grain Valley','',''),(19464,'64015','Independence','',''),(19465,'64015','Lees Summit','',''),(19466,'64016','Independence','',''),(19467,'64020','Emma','',''),(19468,'64020','Sweet Springs','',''),(19469,'64024','Kearney','',''),(19470,'64029','Blue Springs','',''),(19471,'64030','Kansas City','',''),(19472,'64034','Pleasant Hill','',''),(19473,'64048','Kearney','',''),(19474,'64050','Sugar Creek','',''),(19475,'64052','Kansas City','',''),(19476,'64053','Kansas City','',''),(19477,'64053','Sugar Creek','',''),(19478,'64054','Sugar Creek','',''),(19479,'64055','Kansas City','',''),(19480,'64057','Blue Springs','',''),(19481,'64058','Sugar Creek','',''),(19482,'64060','Liberty','',''),(19483,'64064','Blue Springs','',''),(19484,'64064','Kansas City','',''),(19485,'64065','Unity Village','',''),(19486,'64068','Kansas City','',''),(19487,'64068','Kearney','',''),(19488,'64068','Missouri City','',''),(19489,'64068','Sugar Creek','',''),(19490,'64074','Oak Grove','',''),(19491,'64075','Grain Valley','',''),(19492,'64079','Kansas City','',''),(19493,'64080','East Lynne','',''),(19494,'64080','Strasburg','',''),(19495,'64081','Kansas City','',''),(19496,'64081','Unity Village','',''),(19497,'64082','Kansas City','',''),(19498,'64083','Lees Summit','',''),(19499,'64085','Henrietta','',''),(19500,'64086','Blue Springs','',''),(19501,'64086','Unity Village','',''),(19502,'64088','Levasy','',''),(19503,'64120','Independence','',''),(19504,'64129','Raytown','',''),(19505,'64133','Independence','',''),(19506,'64133','Raytown','',''),(19507,'64134','Lees Summit','',''),(19508,'64136','Independence','',''),(19509,'64137','Grandview','',''),(19510,'64138','Raytown','',''),(19511,'64139','Lees Summit','',''),(19512,'64139','Unity Village','',''),(19513,'64149','Lees Summit','',''),(19514,'64150','Kansas City','',''),(19515,'64151','Riverside','',''),(19516,'64157','Liberty','',''),(19517,'64161','Birmingham','',''),(19518,'64161','Independence','',''),(19519,'64161','Sugar Creek','',''),(19520,'64163','Ferrelview','',''),(19521,'64164','Smithville','',''),(19522,'64437','Mound City','',''),(19523,'64446','Rock Port','',''),(19524,'64473','Forest City','',''),(19525,'64489','Clyde','',''),(19526,'64501','St. Joseph','',''),(19527,'64503','St. Joseph','',''),(19528,'64504','St. Joseph','',''),(19529,'64505','St. Joseph','',''),(19530,'64506','St. Joseph','',''),(19531,'64507','St. Joseph','',''),(19532,'64640','Altamont','',''),(19533,'64648','Lock Springs','',''),(19534,'64664','Chillicothe','',''),(19535,'64670','Coffey','',''),(19536,'64701','East Lynne','',''),(19537,'64755','Purcell','',''),(19538,'64776','Roscoe','',''),(19539,'64779','Foster','',''),(19540,'64779','Metz','',''),(19541,'64801','Carl Junction','',''),(19542,'64801','Carterville','',''),(19543,'64801','Duenweg','',''),(19544,'64801','Webb City','',''),(19545,'64831','Lanagan','',''),(19546,'64835','Webb City','',''),(19547,'64854','Lanagan','',''),(19548,'64863','Southwest City','',''),(19549,'64870','Carl Junction','',''),(19550,'64870','Carterville','',''),(19551,'64870','Joplin','',''),(19552,'64870','Oronogo','',''),(19553,'65043','Jefferson City','',''),(19554,'65047','Osage Beach','',''),(19555,'65049','Osage Beach','',''),(19556,'65052','Osage Beach','',''),(19557,'65201','Ashland','',''),(19558,'65270','Huntsville','',''),(19559,'65270','Renick','',''),(19560,'65305','Whiteman Afb','',''),(19561,'65336','Whiteman Afb','',''),(19562,'65351','Emma','',''),(19563,'65439','Viburnum','',''),(19564,'65441','Sullivan','',''),(19565,'65461','Fort Leonard Wood','',''),(19566,'65534','Fort Leonard Wood','',''),(19567,'65550','Fort Leonard Wood','',''),(19568,'65552','Fort Leonard Wood','',''),(19569,'65559','Rolla','',''),(19570,'65583','Fort Leonard Wood','',''),(19571,'65604','Halltown','',''),(19572,'65610','Republic','',''),(19573,'65612','Halltown','',''),(19574,'65619','Battlefield','',''),(19575,'65619','Republic','',''),(19576,'65619','Springfield','',''),(19577,'65625','Butterfield','',''),(19578,'65653','Kissee Mills','',''),(19579,'65708','Freistatt','',''),(19580,'65714','Ozark','',''),(19581,'65714','Springfield','',''),(19582,'65721','Springfield','',''),(19583,'65723','Monett','',''),(19584,'65734','Butterfield','',''),(19585,'65734','Wheaton','',''),(19586,'65740','Merriam Woods','',''),(19587,'65742','Springfield','',''),(19588,'65757','Springfield','',''),(19589,'65759','Kissee Mills','',''),(19590,'65769','Aurora','',''),(19591,'65771','Merriam Woods','',''),(19592,'65802','Republic','',''),(19593,'65802','Willard','',''),(19594,'65803','Willard','',''),(19595,'65807','Battlefield','',''),(19596,'65810','Battlefield','',''),(19597,'66012','Basehor','',''),(19598,'66012','Kansas City','',''),(19599,'66013','Overland Park','',''),(19600,'66018','Lenexa','',''),(19601,'66018','Olathe','',''),(19602,'66019','De Soto','',''),(19603,'66025','De Soto','',''),(19604,'66027','Leavenworth','',''),(19605,'66043','Leavenworth','',''),(19606,'66048','Lansing','',''),(19607,'66061','Gardner','',''),(19608,'66061','Lenexa','',''),(19609,'66062','Lenexa','',''),(19610,'66062','Overland Park','',''),(19611,'66062','Spring Hill','',''),(19612,'66071','Osawatomie','',''),(19613,'66083','Overland Park','',''),(19614,'66085','Overland Park','',''),(19615,'66086','Basehor','',''),(19616,'66090','Elwood','',''),(19617,'66111','Bonner Springs','',''),(19618,'66202','Overland Park','',''),(19619,'66202','Prairie Village','',''),(19620,'66202','Roeland Park','',''),(19621,'66203','Mission','',''),(19622,'66203','Overland Park','',''),(19623,'66204','Prairie Village','',''),(19624,'66205','Roeland Park','',''),(19625,'66206','Overland Park','',''),(19626,'66206','Prairie Village','',''),(19627,'66207','Prairie Village','',''),(19628,'66208','Leawood','',''),(19629,'66209','Overland Park','',''),(19630,'66210','Lenexa','',''),(19631,'66211','Overland Park','',''),(19632,'66214','Lenexa','',''),(19633,'66214','Shawnee','',''),(19634,'66215','Olathe','',''),(19635,'66215','Overland Park','',''),(19636,'66216','Lenexa','',''),(19637,'66217','Kansas City','',''),(19638,'66217','Lenexa','',''),(19639,'66219','Olathe','',''),(19640,'66224','Leawood','',''),(19641,'66226','Bonner Springs','',''),(19642,'66227','Olathe','',''),(19643,'66227','Shawnee','',''),(19644,'66401','Mcfarland','',''),(19645,'66409','Topeka','',''),(19646,'66451','Vassar','',''),(19647,'66501','Mcfarland','',''),(19648,'66502','Ogden','',''),(19649,'66503','Ogden','',''),(19650,'66508','Home','',''),(19651,'66514','Junction City','',''),(19652,'66526','Mcfarland','',''),(19653,'66534','Oneida','',''),(19654,'66536','St. Marys','',''),(19655,'66538','Oneida','',''),(19656,'66546','Topeka','',''),(19657,'66753','West Mineral','',''),(19658,'66762','Frontenac','',''),(19659,'66771','St. Paul','',''),(19660,'66773','West Mineral','',''),(19661,'66857','Leroy','',''),(19662,'66872','Herington','',''),(19663,'67002','Augusta','',''),(19664,'67019','Winfield','',''),(19665,'67028','Sun City','',''),(19666,'67037','Mulvane','',''),(19667,'67037','Wichita','',''),(19668,'67042','Towanda','',''),(19669,'67052','Wichita','',''),(19670,'67056','Newton','',''),(19671,'67066','Pratt','',''),(19672,'67067','Wichita','',''),(19673,'67101','Wichita','',''),(19674,'67103','Wellington','',''),(19675,'67106','Wichita','',''),(19676,'67114','Elbing','',''),(19677,'67114','Goessel','',''),(19678,'67114','North Newton','',''),(19679,'67117','Newton','',''),(19680,'67120','Mulvane','',''),(19681,'67133','Andover','',''),(19682,'67147','Kechi','',''),(19683,'67147','Park City','',''),(19684,'67204','Park City','',''),(19685,'67204','Valley Center','',''),(19686,'67205','Maize','',''),(19687,'67216','Haysville','',''),(19688,'67217','Haysville','',''),(19689,'67219','Kechi','',''),(19690,'67219','Park City','',''),(19691,'67219','Valley Center','',''),(19692,'67223','Maize','',''),(19693,'67230','Andover','',''),(19694,'67333','Tyro','',''),(19695,'67335','Parsons','',''),(19696,'67337','Dearing','',''),(19697,'67344','Longton','',''),(19698,'67361','Chautauqua','',''),(19699,'67420','Simpson','',''),(19700,'67439','Kanopolis','',''),(19701,'67455','Lincoln Center','',''),(19702,'67470','Salina','',''),(19703,'67501','South Hutchinson','',''),(19704,'67548','Liebenthal','',''),(19705,'67556','Mccracken','',''),(19706,'67576','St. John','',''),(19707,'67601','Schoenchen','',''),(19708,'67669','Plainville','',''),(19709,'67756','St. Francis','',''),(19710,'67801','Fort Dodge','',''),(19711,'67855','Johnson City','',''),(19712,'67882','Dodge City','',''),(19713,'68003','Mead','',''),(19714,'68005','Offutt Afb','',''),(19715,'68007','Omaha','',''),(19716,'68007','Washington','',''),(19717,'68010','Omaha','',''),(19718,'68014','Abie','',''),(19719,'68022','Omaha','',''),(19720,'68031','Winslow','',''),(19721,'68046','La Vista','',''),(19722,'68057','Snyder','',''),(19723,'68069','Valley','',''),(19724,'68113','Bellevue','',''),(19725,'68113','Offutt Afb','',''),(19726,'68123','Offutt Afb','',''),(19727,'68128','Chalco','',''),(19728,'68133','Bellevue','',''),(19729,'68138','Chalco','',''),(19730,'68138','La Vista','',''),(19731,'68147','Omaha','',''),(19732,'68157','Bellevue','',''),(19733,'68157','Papillion','',''),(19734,'68321','Nemaha','',''),(19735,'68336','Lincoln','',''),(19736,'68401','Mccool Junction','',''),(19737,'68404','Sprague','',''),(19738,'68430','Lincoln','',''),(19739,'68434','Goehner','',''),(19740,'68463','Manley','',''),(19741,'68466','Barneston','',''),(19742,'68466','Blue Springs','',''),(19743,'68601','Duncan','',''),(19744,'68660','St. Edward','',''),(19745,'68701','Battle Creek','',''),(19746,'68731','South Sioux City','',''),(19747,'68757','Maskell','',''),(19748,'68776','Dakota City','',''),(19749,'68789','Center','',''),(19750,'68833','Halsey','',''),(19751,'68836','Odessa','',''),(19752,'68842','Greeley Center','',''),(19753,'68845','Odessa','',''),(19754,'68873','St. Paul','',''),(19755,'68924','Minden','',''),(19756,'68939','Bloomington','',''),(19757,'68944','Sutton','',''),(19758,'68955','Hastings','',''),(19759,'68970','Inavale','',''),(19760,'69001','Mccook','',''),(19761,'69022','Bartley','',''),(19762,'69025','Stockville','',''),(19763,'69039','Stockville','',''),(19764,'69143','Sutherland','',''),(19765,'69334','Mcgrew','',''),(19766,'69341','Melbeta','',''),(19767,'70003','Kenner','',''),(19768,'70030','Paradis','',''),(19769,'70032','Chalmette','',''),(19770,'70039','Luling','',''),(19771,'70041','Boothville','',''),(19772,'70041','Empire','',''),(19773,'70043','Arabi','',''),(19774,'70047','Norco','',''),(19775,'70047','St. Rose','',''),(19776,'70056','Terrytown','',''),(19777,'70057','Luling','',''),(19778,'70058','Marrero','',''),(19779,'70062','Metairie','',''),(19780,'70062','River Ridge','',''),(19781,'70065','Metairie','',''),(19782,'70067','Jean Lafitte','',''),(19783,'70068','Laplace','',''),(19784,'70068','Reserve','',''),(19785,'70070','Boutte','',''),(19786,'70072','Harvey','',''),(19787,'70075','Chalmette','',''),(19788,'70076','Garyville','',''),(19789,'70080','Boutte','',''),(19790,'70080','Des Allemands','',''),(19791,'70083','Empire','',''),(19792,'70084','Garyville','',''),(19793,'70086','St. James','',''),(19794,'70087','St. Rose','',''),(19795,'70090','South Vacherie','',''),(19796,'70091','Boothville','',''),(19797,'70092','Meraux','',''),(19798,'70094','Waggaman','',''),(19799,'70121','Jefferson','',''),(19800,'70123','River Ridge','',''),(19801,'70301','Labadieville','',''),(19802,'70301','Schriever','',''),(19803,'70339','Morgan City','',''),(19804,'70345','Galliano','',''),(19805,'70345','Larose','',''),(19806,'70360','Bayou Cane','',''),(19807,'70360','Gray','',''),(19808,'70363','Dulac','',''),(19809,'70364','Bayou Cane','',''),(19810,'70364','Gray','',''),(19811,'70374','Larose','',''),(19812,'70374','Mathews','',''),(19813,'70380','Amelia','',''),(19814,'70380','Berwick','',''),(19815,'70390','Paincourtville','',''),(19816,'70394','Mathews','',''),(19817,'70401','Natalbany','',''),(19818,'70427','Sun','',''),(19819,'70444','Tangipahoa','',''),(19820,'70445','Slidell','',''),(19821,'70454','Hammond','',''),(19822,'70460','Lacombe','',''),(19823,'70466','Natalbany','',''),(19824,'70508','Broussard','',''),(19825,'70508','Milton','',''),(19826,'70512','Grand Coteau','',''),(19827,'70514','Charenton','',''),(19828,'70517','Broussard','',''),(19829,'70518','Cade','',''),(19830,'70518','Lafayette','',''),(19831,'70526','Estherwood','',''),(19832,'70533','Delcambre','',''),(19833,'70538','Baldwin','',''),(19834,'70538','Charenton','',''),(19835,'70544','Charenton','',''),(19836,'70554','Reddell','',''),(19837,'70559','Mermentau','',''),(19838,'70570','Lawtell','',''),(19839,'70582','Cade','',''),(19840,'70583','Lafayette','',''),(19841,'70584','Grand Coteau','',''),(19842,'70586','Chataignier','',''),(19843,'70586','Pine Prairie','',''),(19844,'70586','Turkey Creek','',''),(19845,'70591','Fenton','',''),(19846,'70591','Roanoke','',''),(19847,'70592','Broussard','',''),(19848,'70592','Milton','',''),(19849,'70611','Moss Bluff','',''),(19850,'70630','Hayes','',''),(19851,'70634','Rosepine','',''),(19852,'70647','Lacassine','',''),(19853,'70648','Oberlin','',''),(19854,'70656','Fort Polk South','',''),(19855,'70669','Lake Charles','',''),(19856,'70669','Sulphur','',''),(19857,'70714','Baton Rouge','',''),(19858,'70714','Central','',''),(19859,'70719','Addis','',''),(19860,'70721','St. Gabriel','',''),(19861,'70723','Union','',''),(19862,'70737','Prairieville','',''),(19863,'70737','Sorrento','',''),(19864,'70739','Central','',''),(19865,'70740','Rosedale','',''),(19866,'70748','Wilson','',''),(19867,'70754','French Settlement','',''),(19868,'70757','Livonia','',''),(19869,'70759','New Roads','',''),(19870,'70763','Grand Point','',''),(19871,'70763','Hester','',''),(19872,'70767','Brusly','',''),(19873,'70770','Central','',''),(19874,'70774','Sorrento','',''),(19875,'70776','St. Gabriel','',''),(19876,'70777','Zachary','',''),(19877,'70780','St. Gabriel','',''),(19878,'70791','Central','',''),(19879,'70807','Baker','',''),(19880,'70811','Baker','',''),(19881,'70811','Brownfields','',''),(19882,'70811','Merrydale','',''),(19883,'70812','Merrydale','',''),(19884,'70814','Merrydale','',''),(19885,'70816','Shenandoah','',''),(19886,'70817','Shenandoah','',''),(19887,'70818','Central','',''),(19888,'70819','Central','',''),(19889,'71006','Bossier City','',''),(19890,'71007','Greenwood','',''),(19891,'71033','Shreveport','',''),(19892,'71037','Bossier City','',''),(19893,'71037','Red Chute','',''),(19894,'71040','Lisbon','',''),(19895,'71047','Shreveport','',''),(19896,'71065','Belmont','',''),(19897,'71071','Cullen','',''),(19898,'71073','Minden','',''),(19899,'71075','Cullen','',''),(19900,'71082','Oil City','',''),(19901,'71110','Bossier City','',''),(19902,'71111','Shreveport','',''),(19903,'71112','Shreveport','',''),(19904,'71119','Greenwood','',''),(19905,'71129','Greenwood','',''),(19906,'71245','Ruston','',''),(19907,'71263','Kilbourne','',''),(19908,'71264','Start','',''),(19909,'71268','Hodge','',''),(19910,'71269','Start','',''),(19911,'71270','Grambling','',''),(19912,'71282','Delta','',''),(19913,'71286','Lake Providence','',''),(19914,'71291','Claiborne','',''),(19915,'71325','Turkey Creek','',''),(19916,'71334','Clayton','',''),(19917,'71346','Woodworth','',''),(19918,'71350','Marksville','',''),(19919,'71353','Krotz Springs','',''),(19920,'71360','Ball','',''),(19921,'71366','St. Joseph','',''),(19922,'71409','Alexandria','',''),(19923,'71429','Fisher','',''),(19924,'71430','Woodworth','',''),(19925,'71446','Fort Polk South','',''),(19926,'71446','New Llano','',''),(19927,'71446','Simpson','',''),(19928,'71449','Fisher','',''),(19929,'71450','Belmont','',''),(19930,'71457','Clarence','',''),(19931,'71459','Fort Polk South','',''),(19932,'71461','New Llano','',''),(19933,'71465','Urania','',''),(19934,'71469','Natchitoches','',''),(19935,'71469','Provencal','',''),(19936,'71483','Calvin','',''),(19937,'71486','Belmont','',''),(19938,'71602','Pine Bluff','',''),(19939,'71654','Mcgehee','',''),(19940,'71662','Dumas','',''),(19941,'71670','Mcgehee','',''),(19942,'71730','Calion','',''),(19943,'71730','Norphlet','',''),(19944,'71743','Whelen Springs','',''),(19945,'71744','Harrell','',''),(19946,'71822','Wilton','',''),(19947,'71839','Garland','',''),(19948,'71841','Grannis','',''),(19949,'71846','Ben Lomond','',''),(19950,'71852','Mineral Springs','',''),(19951,'71854','Garland','',''),(19952,'71857','Bluff City','',''),(19953,'71901','Hot Springs','',''),(19954,'71901','Hot Springs Village','',''),(19955,'71913','Hot Springs','',''),(19956,'71949','Hot Springs Village','',''),(19957,'71973','Grannis','',''),(19958,'72002','Benton','',''),(19959,'72002','Bryant','',''),(19960,'72002','Little Rock','',''),(19961,'72006','Patterson','',''),(19962,'72007','Cabot','',''),(19963,'72010','Russell','',''),(19964,'72011','Benton','',''),(19965,'72011','Bryant','',''),(19966,'72015','Bryant','',''),(19967,'72017','Fredonia (biscoe)','',''),(19968,'72019','Bryant','',''),(19969,'72022','Benton','',''),(19970,'72023','Jacksonville','',''),(19971,'72024','Hazen','',''),(19972,'72039','Guy','',''),(19973,'72041','Hazen','',''),(19974,'72042','Dewitt','',''),(19975,'72042','Gillett','',''),(19976,'72044','Fairfield Bay','',''),(19977,'72046','Coy','',''),(19978,'72046','Keo','',''),(19979,'72058','Guy','',''),(19980,'72065','East End','',''),(19981,'72076','Sherwood','',''),(19982,'72081','Searcy','',''),(19983,'72082','Searcy','',''),(19984,'72084','Carthage','',''),(19985,'72087','Hot Springs Village','',''),(19986,'72099','Jacksonville','',''),(19987,'72101','Beedeville','',''),(19988,'72101','Mccrory','',''),(19989,'72101','Patterson','',''),(19990,'72103','East End','',''),(19991,'72103','Little Rock','',''),(19992,'72106','Conway','',''),(19993,'72112','Grubbs','',''),(19994,'72113','North Little Rock','',''),(19995,'72116','Sherwood','',''),(19996,'72117','Jacksonville','',''),(19997,'72117','Sherwood','',''),(19998,'72120','Jacksonville','',''),(19999,'72120','North Little Rock','',''),(20000,'72127','Menifee','',''),(20001,'72134','Clarendon','',''),(20002,'72135','Little Rock','',''),(20003,'72140','St. Charles','',''),(20004,'72142','North Little Rock','',''),(20005,'72143','Higginson','',''),(20006,'72143','Kensett','',''),(20007,'72143','Letona','',''),(20008,'72153','Fairfield Bay','',''),(20009,'72160','Ulm','',''),(20010,'72176','Cabot','',''),(20011,'72206','East End','',''),(20012,'72315','Burdette','',''),(20013,'72315','Dell','',''),(20014,'72326','Caldwell','',''),(20015,'72327','Clarkedale','',''),(20016,'72327','Marion','',''),(20017,'72327','West Memphis','',''),(20018,'72335','Caldwell','',''),(20019,'72335','Madison','',''),(20020,'72342','Helena-west Helena','',''),(20021,'72355','Helena-west Helena','',''),(20022,'72358','Burdette','',''),(20023,'72360','Aubrey','',''),(20024,'72364','Clarkedale','',''),(20025,'72364','West Memphis','',''),(20026,'72370','Etowah','',''),(20027,'72376','Edmondson','',''),(20028,'72376','West Memphis','',''),(20029,'72384','Clarkedale','',''),(20030,'72389','Elaine','',''),(20031,'72390','Helena-west Helena','',''),(20032,'72394','Madison','',''),(20033,'72411','Jonesboro','',''),(20034,'72413','Reyno','',''),(20035,'72414','Monette','',''),(20036,'72416','Jonesboro','',''),(20037,'72422','Datto','',''),(20038,'72422','Mcdougal','',''),(20039,'72430','Piggott','',''),(20040,'72433','Minturn','',''),(20041,'72433','Portia','',''),(20042,'72433','Walnut Ridge','',''),(20043,'72435','Peach Orchard','',''),(20044,'72437','Monette','',''),(20045,'72441','Mcdougal','',''),(20046,'72442','Etowah','',''),(20047,'72449','Okean','',''),(20048,'72454','St. Francis','',''),(20049,'72456','Mcdougal','',''),(20050,'72464','St. Francis','',''),(20051,'72466','Lynn','',''),(20052,'72467','Jonesboro','',''),(20053,'72469','Lynn','',''),(20054,'72472','Marked Tree','',''),(20055,'72476','Hoxie','',''),(20056,'72476','Okean','',''),(20057,'72476','Portia','',''),(20058,'72501','Cushman','',''),(20059,'72501','Magness','',''),(20060,'72513','Cherokee Village','',''),(20061,'72513','Horseshoe Bend','',''),(20062,'72517','Oxford','',''),(20063,'72542','Cherokee Village','',''),(20064,'72546','Tumbling Shoals','',''),(20065,'72556','Guion','',''),(20066,'72562','Magness','',''),(20067,'72566','Calico Rock','',''),(20068,'72573','Melbourne','',''),(20069,'72601','Pyatt','',''),(20070,'72631','Holiday Island','',''),(20071,'72634','Bull Shoals','',''),(20072,'72635','Cotter','',''),(20073,'72635','Midway','',''),(20074,'72639','Big Flat','',''),(20075,'72644','Diamond City','',''),(20076,'72645','Dennard','',''),(20077,'72653','Midway','',''),(20078,'72675','Gilbert','',''),(20079,'72675','Pindall','',''),(20080,'72687','Pyatt','',''),(20081,'72687','Summit','',''),(20082,'72701','Farmington','',''),(20083,'72703','Springdale','',''),(20084,'72704','Farmington','',''),(20085,'72712','Bella Vista','',''),(20086,'72712','Cave Springs','',''),(20087,'72712','Centerton','',''),(20088,'72712','Hiwasse','',''),(20089,'72712','Rogers','',''),(20090,'72714','Bentonville','',''),(20091,'72718','Rogers','',''),(20092,'72727','Fayetteville','',''),(20093,'72730','Fayetteville','',''),(20094,'72730','Prairie Grove','',''),(20095,'72736','Bella Vista','',''),(20096,'72736','Centerton','',''),(20097,'72736','Hiwasse','',''),(20098,'72745','Cave Springs','',''),(20099,'72745','Rogers','',''),(20100,'72745','Springdale','',''),(20101,'72751','Bella Vista','',''),(20102,'72753','Farmington','',''),(20103,'72756','Bentonville','',''),(20104,'72756','Pea Ridge','',''),(20105,'72758','Bentonville','',''),(20106,'72758','Cave Springs','',''),(20107,'72758','Lowell','',''),(20108,'72762','Cave Springs','',''),(20109,'72764','Fayetteville','',''),(20110,'72768','Bella Vista','',''),(20111,'72774','Fayetteville','',''),(20112,'72802','Pottsville','',''),(20113,'72821','Coal Hill','',''),(20114,'72823','Pottsville','',''),(20115,'72824','Danville','',''),(20116,'72833','Ola','',''),(20117,'72837','Russellville','',''),(20118,'72840','Coal Hill','',''),(20119,'72846','Knoxville','',''),(20120,'72858','Russellville','',''),(20121,'72921','Dyer','',''),(20122,'72923','Fort Smith','',''),(20123,'72937','Midland','',''),(20124,'72941','Barling','',''),(20125,'72941','Fort Smith','',''),(20126,'72943','Blue Mountain','',''),(20127,'72947','Dyer','',''),(20128,'72952','Cedarville','',''),(20129,'72956','Cedarville','',''),(20130,'73004','Chickasha','',''),(20131,'73007','Edmond','',''),(20132,'73007','Guthrie','',''),(20133,'73008','Oklahoma City','',''),(20134,'73008','Warr Acres','',''),(20135,'73010','Newcastle','',''),(20136,'73012','Oklahoma City','',''),(20137,'73013','Oklahoma City','',''),(20138,'73014','El Reno','',''),(20139,'73014','Geary','',''),(20140,'73020','Jones','',''),(20141,'73020','Midwest City','',''),(20142,'73020','Nicoma Park','',''),(20143,'73020','Oklahoma City','',''),(20144,'73025','Guthrie','',''),(20145,'73026','Oklahoma City','',''),(20146,'73027','Langston','',''),(20147,'73028','Guthrie','',''),(20148,'73030','Dougherty','',''),(20149,'73034','Guthrie','',''),(20150,'73036','Oklahoma City','',''),(20151,'73036','Union City','',''),(20152,'73038','Carnegie','',''),(20153,'73044','Langston','',''),(20154,'73048','Eakly','',''),(20155,'73049','Edmond','',''),(20156,'73049','Oklahoma City','',''),(20157,'73051','Purcell','',''),(20158,'73054','Oklahoma City','',''),(20159,'73055','Duncan','',''),(20160,'73064','Oklahoma City','',''),(20161,'73067','Chickasha','',''),(20162,'73068','Norman','',''),(20163,'73069','Moore','',''),(20164,'73071','Moore','',''),(20165,'73071','Oklahoma City','',''),(20166,'73072','Goldsby','',''),(20167,'73072','Newcastle','',''),(20168,'73072','Noble','',''),(20169,'73078','Oklahoma City','',''),(20170,'73080','Goldsby','',''),(20171,'73084','Midwest City','',''),(20172,'73084','Nicoma Park','',''),(20173,'73084','Oklahoma City','',''),(20174,'73086','Dougherty','',''),(20175,'73093','Goldsby','',''),(20176,'73093','Newcastle','',''),(20177,'73093','Purcell','',''),(20178,'73095','Maysville','',''),(20179,'73097','Oklahoma City','',''),(20180,'73098','Pauls Valley','',''),(20181,'73099','Oklahoma City','',''),(20182,'73099','Piedmont','',''),(20183,'73110','Del City','',''),(20184,'73110','Midwest City','',''),(20185,'73115','Del City','',''),(20186,'73117','Del City','',''),(20187,'73117','Midwest City','',''),(20188,'73121','Midwest City','',''),(20189,'73122','Bethany','',''),(20190,'73122','Warr Acres','',''),(20191,'73127','Bethany','',''),(20192,'73130','Midwest City','',''),(20193,'73130','Nicoma Park','',''),(20194,'73132','Bethany','',''),(20195,'73132','Warr Acres','',''),(20196,'73135','Del City','',''),(20197,'73141','Midwest City','',''),(20198,'73141','Nicoma Park','',''),(20199,'73141','Spencer','',''),(20200,'73145','Midwest City','',''),(20201,'73150','Midwest City','',''),(20202,'73160','Moore','',''),(20203,'73160','Norman','',''),(20204,'73165','Moore','',''),(20205,'73170','Moore','',''),(20206,'73401','Lone Grove','',''),(20207,'73401','Mannsville','',''),(20208,'73434','Duncan','',''),(20209,'73439','Madill','',''),(20210,'73446','Lebanon','',''),(20211,'73449','Durant','',''),(20212,'73458','Ardmore','',''),(20213,'73460','Ravia','',''),(20214,'73463','Lone Grove','',''),(20215,'73481','Tatums','',''),(20216,'73503','Lawton','',''),(20217,'73503','Medicine Park','',''),(20218,'73507','Medicine Park','',''),(20219,'73527','Lawton','',''),(20220,'73529','Duncan','',''),(20221,'73532','East Duke','',''),(20222,'73533','Marlow','',''),(20223,'73533','Velma','',''),(20224,'73541','Sterling','',''),(20225,'73559','Snyder','',''),(20226,'73620','Butler','',''),(20227,'73632','New Cordell','',''),(20228,'73647','Butler','',''),(20229,'73662','Elk City','',''),(20230,'73703','Hillsdale','',''),(20231,'73762','El Reno','',''),(20232,'73762','Piedmont','',''),(20233,'74002','Skiatook','',''),(20234,'74006','Dewey','',''),(20235,'74008','Broken Arrow','',''),(20236,'74008','Glenpool','',''),(20237,'74008','Jenks','',''),(20238,'74008','Tulsa','',''),(20239,'74010','Slick','',''),(20240,'74011','Bixby','',''),(20241,'74012','Tulsa','',''),(20242,'74014','Coweta','',''),(20243,'74014','Tulsa','',''),(20244,'74015','Owasso','',''),(20245,'74015','Tulsa','',''),(20246,'74019','Catoosa','',''),(20247,'74019','Owasso','',''),(20248,'74021','Owasso','',''),(20249,'74021','Tulsa','',''),(20250,'74021','Vera','',''),(20251,'74028','Stroud','',''),(20252,'74030','Shamrock','',''),(20253,'74033','Jenks','',''),(20254,'74035','Skiatook','',''),(20255,'74036','Claremore','',''),(20256,'74037','Glenpool','',''),(20257,'74037','Tulsa','',''),(20258,'74039','Sapulpa','',''),(20259,'74041','Sapulpa','',''),(20260,'74047','Bixby','',''),(20261,'74047','Glenpool','',''),(20262,'74050','Sapulpa','',''),(20263,'74051','Bartlesville','',''),(20264,'74055','Tulsa','',''),(20265,'74060','Sand Springs','',''),(20266,'74060','Skiatook','',''),(20267,'74061','Vera','',''),(20268,'74063','Sapulpa','',''),(20269,'74066','Jenks','',''),(20270,'74066','Kiefer','',''),(20271,'74066','Sand Springs','',''),(20272,'74070','Avant','',''),(20273,'74070','Sand Springs','',''),(20274,'74070','Vera','',''),(20275,'74073','Sand Springs','',''),(20276,'74073','Skiatook','',''),(20277,'74073','Tulsa','',''),(20278,'74073','Turley','',''),(20279,'74080','Vera','',''),(20280,'74107','Oakhurst','',''),(20281,'74107','Sand Springs','',''),(20282,'74107','Sapulpa','',''),(20283,'74108','Catoosa','',''),(20284,'74116','Catoosa','',''),(20285,'74117','Owasso','',''),(20286,'74126','Sand Springs','',''),(20287,'74126','Turley','',''),(20288,'74127','Sand Springs','',''),(20289,'74130','Turley','',''),(20290,'74131','Oakhurst','',''),(20291,'74131','Sapulpa','',''),(20292,'74132','Jenks','',''),(20293,'74132','Oakhurst','',''),(20294,'74132','Sapulpa','',''),(20295,'74133','Bixby','',''),(20296,'74133','Broken Arrow','',''),(20297,'74134','Broken Arrow','',''),(20298,'74137','Jenks','',''),(20299,'74146','Broken Arrow','',''),(20300,'74301','Ketchum','',''),(20301,'74301','Langley','',''),(20302,'74331','Ketchum','',''),(20303,'74339','Miami','',''),(20304,'74354','North Miami','',''),(20305,'74361','Pryor Creek','',''),(20306,'74363','Picher','',''),(20307,'74366','Disney','',''),(20308,'74423','Sand Hill','',''),(20309,'74426','Rentiesville','',''),(20310,'74429','Broken Arrow','',''),(20311,'74431','Henryetta','',''),(20312,'74434','Muskogee','',''),(20313,'74436','Bixby','',''),(20314,'74436','Coweta','',''),(20315,'74437','Dewar','',''),(20316,'74437','Hitchita','',''),(20317,'74437','Schulter','',''),(20318,'74442','Crowder','',''),(20319,'74445','Okmulgee','',''),(20320,'74447','Schulter','',''),(20321,'74454','Coweta','',''),(20322,'74454','Redbird','',''),(20323,'74464','Welling','',''),(20324,'74467','Okay','',''),(20325,'74501','Alderson','',''),(20326,'74501','Crowder','',''),(20327,'74501','Krebs','',''),(20328,'74501','Savanna','',''),(20329,'74538','Lehigh','',''),(20330,'74546','Hartshorne','',''),(20331,'74547','Haileyville','',''),(20332,'74554','Mcalester','',''),(20333,'74563','Fanshawe','',''),(20334,'74701','Calera','',''),(20335,'74728','Idabel','',''),(20336,'74729','Durant','',''),(20337,'74730','Achille','',''),(20338,'74730','Durant','',''),(20339,'74736','Millerton','',''),(20340,'74741','Kemp','',''),(20341,'74743','Grant','',''),(20342,'74764','Millerton','',''),(20343,'74764','Swink','',''),(20344,'74801','Tecumseh','',''),(20345,'74820','Francis','',''),(20346,'74840','Shawnee','',''),(20347,'74842','Ada','',''),(20348,'74843','Ada','',''),(20349,'74848','Lamar','',''),(20350,'74851','Oklahoma City','',''),(20351,'74851','Shawnee','',''),(20352,'74857','Norman','',''),(20353,'74857','Oklahoma City','',''),(20354,'74859','Cromwell','',''),(20355,'74865','Ada','',''),(20356,'74865','Fitzhugh','',''),(20357,'74868','Bowlegs','',''),(20358,'74871','Ada','',''),(20359,'74873','Shawnee','',''),(20360,'74884','Cromwell','',''),(20361,'74884','Seminole','',''),(20362,'74930','Panama','',''),(20363,'74931','Welling','',''),(20364,'74932','Pocola','',''),(20365,'74932','Poteau','',''),(20366,'74940','Poteau','',''),(20367,'74942','Le Flore','',''),(20368,'74948','Moffett','',''),(20369,'74948','Roland','',''),(20370,'74949','Whitesboro','',''),(20371,'74951','Poteau','',''),(20372,'74954','Moffett','',''),(20373,'74956','Poteau','',''),(20374,'74959','Poteau','',''),(20375,'74960','Welling','',''),(20376,'74966','Fanshawe','',''),(20377,'74966','Le Flore','',''),(20378,'74966','Poteau','',''),(20379,'75001','Carrollton','',''),(20380,'75001','Dallas','',''),(20381,'75002','Wylie','',''),(20382,'75006','Addison','',''),(20383,'75006','Dallas','',''),(20384,'75006','Farmers Branch','',''),(20385,'75007','Dallas','',''),(20386,'75009','Anna','',''),(20387,'75009','Prosper','',''),(20388,'75010','Lewisville','',''),(20389,'75010','Plano','',''),(20390,'75010','The Colony','',''),(20391,'75013','Plano','',''),(20392,'75019','Carrollton','',''),(20393,'75019','Dallas','',''),(20394,'75019','Grapevine','',''),(20395,'75019','Lewisville','',''),(20396,'75020','Sherman','',''),(20397,'75022','Grapevine','',''),(20398,'75024','Frisco','',''),(20399,'75024','The Colony','',''),(20400,'75025','Allen','',''),(20401,'75028','Lewisville','',''),(20402,'75032','Dallas','',''),(20403,'75032','Fate','',''),(20404,'75034','Little Elm','',''),(20405,'75034','The Colony','',''),(20406,'75035','Mckinney','',''),(20407,'75039','Dallas','',''),(20408,'75040','Sachse','',''),(20409,'75041','Dallas','',''),(20410,'75043','Dallas','',''),(20411,'75043','Mesquite','',''),(20412,'75044','Richardson','',''),(20413,'75048','Garland','',''),(20414,'75048','Murphy','',''),(20415,'75048','Wylie','',''),(20416,'75050','Arlington','',''),(20417,'75050','Dallas','',''),(20418,'75050','Irving','',''),(20419,'75051','Arlington','',''),(20420,'75051','Dallas','',''),(20421,'75052','Arlington','',''),(20422,'75052','Dallas','',''),(20423,'75056','Carrollton','',''),(20424,'75056','Frisco','',''),(20425,'75056','Lewisville','',''),(20426,'75060','Dallas','',''),(20427,'75060','Grand Prairie','',''),(20428,'75061','Dallas','',''),(20429,'75062','Dallas','',''),(20430,'75063','Coppell','',''),(20431,'75063','Dallas','',''),(20432,'75065','Lewisville','',''),(20433,'75067','Carrollton','',''),(20434,'75067','Coppell','',''),(20435,'75067','Flower Mound','',''),(20436,'75067','Grapevine','',''),(20437,'75068','Frisco','',''),(20438,'75070','Frisco','',''),(20439,'75071','Celina','',''),(20440,'75071','Frisco','',''),(20441,'75071','Melissa','',''),(20442,'75074','Richardson','',''),(20443,'75075','Dallas','',''),(20444,'75075','Richardson','',''),(20445,'75076','Denison','',''),(20446,'75077','Flower Mound','',''),(20447,'75078','Celina','',''),(20448,'75078','Frisco','',''),(20449,'75080','Dallas','',''),(20450,'75081','Dallas','',''),(20451,'75081','Garland','',''),(20452,'75082','Garland','',''),(20453,'75082','Murphy','',''),(20454,'75082','Plano','',''),(20455,'75087','Dallas','',''),(20456,'75087','Fate','',''),(20457,'75087','Rowlett','',''),(20458,'75088','Dallas','',''),(20459,'75089','Dallas','',''),(20460,'75089','Garland','',''),(20461,'75090','Howe','',''),(20462,'75090','Tom Bean','',''),(20463,'75092','Howe','',''),(20464,'75092','Southmayd','',''),(20465,'75093','Carrollton','',''),(20466,'75093','Dallas','',''),(20467,'75093','The Colony','',''),(20468,'75094','Murphy','',''),(20469,'75098','Dallas','',''),(20470,'75098','Garland','',''),(20471,'75098','Murphy','',''),(20472,'75098','Rowlett','',''),(20473,'75098','Sachse','',''),(20474,'75104','Dallas','',''),(20475,'75104','Duncanville','',''),(20476,'75104','Grand Prairie','',''),(20477,'75104','Mansfield','',''),(20478,'75115','Cedar Hill','',''),(20479,'75115','Dallas','',''),(20480,'75115','Duncanville','',''),(20481,'75116','Dallas','',''),(20482,'75119','Bardwell','',''),(20483,'75125','Wilmer','',''),(20484,'75126','Dallas','',''),(20485,'75126','Mesquite','',''),(20486,'75134','Dallas','',''),(20487,'75134','Hutchins','',''),(20488,'75135','Greenville','',''),(20489,'75135','Josephine','',''),(20490,'75137','Cedar Hill','',''),(20491,'75141','Dallas','',''),(20492,'75141','Lancaster','',''),(20493,'75141','Wilmer','',''),(20494,'75146','Wilmer','',''),(20495,'75149','Balch Springs','',''),(20496,'75149','Dallas','',''),(20497,'75149','Sunnyvale','',''),(20498,'75150','Dallas','',''),(20499,'75150','Garland','',''),(20500,'75150','Sunnyvale','',''),(20501,'75152','Ennis','',''),(20502,'75154','Cedar Hill','',''),(20503,'75154','Desoto','',''),(20504,'75154','Glenn Heights','',''),(20505,'75158','Rosser','',''),(20506,'75159','Dallas','',''),(20507,'75159','Mesquite','',''),(20508,'75165','Ennis','',''),(20509,'75166','Dallas','',''),(20510,'75166','Wylie','',''),(20511,'75167','Midlothian','',''),(20512,'75172','Hutchins','',''),(20513,'75173','Josephine','',''),(20514,'75173','Wylie','',''),(20515,'75180','Balch Springs','',''),(20516,'75181','Balch Springs','',''),(20517,'75181','Sunnyvale','',''),(20518,'75182','Dallas','',''),(20519,'75182','Mesquite','',''),(20520,'75189','Fate','',''),(20521,'75189','Josephine','',''),(20522,'75189','Rockwall','',''),(20523,'75205','University Park','',''),(20524,'75206','University Park','',''),(20525,'75211','Grand Prairie','',''),(20526,'75217','Balch Springs','',''),(20527,'75218','Garland','',''),(20528,'75220','Irving','',''),(20529,'75225','University Park','',''),(20530,'75227','Mesquite','',''),(20531,'75228','Garland','',''),(20532,'75228','Mesquite','',''),(20533,'75229','Farmers Branch','',''),(20534,'75234','Farmers Branch','',''),(20535,'75234','Irving','',''),(20536,'75236','Duncanville','',''),(20537,'75237','Desoto','',''),(20538,'75237','Duncanville','',''),(20539,'75238','Garland','',''),(20540,'75240','Farmers Branch','',''),(20541,'75241','Hutchins','',''),(20542,'75241','Lancaster','',''),(20543,'75243','Garland','',''),(20544,'75244','Addison','',''),(20545,'75244','Farmers Branch','',''),(20546,'75247','Irving','',''),(20547,'75248','Addison','',''),(20548,'75249','Cedar Hill','',''),(20549,'75252','Plano','',''),(20550,'75253','Balch Springs','',''),(20551,'75253','Mesquite','',''),(20552,'75253','Seagoville','',''),(20553,'75254','Addison','',''),(20554,'75254','Farmers Branch','',''),(20555,'75287','Carrollton','',''),(20556,'75287','Plano','',''),(20557,'75407','Wylie','',''),(20558,'75409','Melissa','',''),(20559,'75438','Bonham','',''),(20560,'75446','Ladonia','',''),(20561,'75449','Pecan Gap','',''),(20562,'75452','Bailey','',''),(20563,'75454','Anna','',''),(20564,'75454','Mckinney','',''),(20565,'75455','Winfield','',''),(20566,'75459','Gunter','',''),(20567,'75459','Sherman','',''),(20568,'75459','Southmayd','',''),(20569,'75473','Paris','',''),(20570,'75491','Tom Bean','',''),(20571,'75492','Honey Grove','',''),(20572,'75495','Howe','',''),(20573,'75496','Bailey','',''),(20574,'75501','Nash','',''),(20575,'75501','Redwater','',''),(20576,'75567','Redwater','',''),(20577,'75569','Texarkana','',''),(20578,'75572','Atlanta','',''),(20579,'75603','Easton','',''),(20580,'75604','White Oak','',''),(20581,'75684','New London','',''),(20582,'75693','Longview','',''),(20583,'75757','Cuney','',''),(20584,'75762','Tyler','',''),(20585,'75766','Gallatin','',''),(20586,'75766','New Summerfield','',''),(20587,'75785','Gallatin','',''),(20588,'75789','New Summerfield','',''),(20589,'75791','Tyler','',''),(20590,'75835','Latexo','',''),(20591,'75859','Kirvin','',''),(20592,'75925','Wells','',''),(20593,'75941','Lufkin','',''),(20594,'76001','Mansfield','',''),(20595,'76002','Grand Prairie','',''),(20596,'76002','Mansfield','',''),(20597,'76006','Fort Worth','',''),(20598,'76006','Grand Prairie','',''),(20599,'76008','Fort Worth','',''),(20600,'76008','Weatherford','',''),(20601,'76009','Burleson','',''),(20602,'76009','Keene','',''),(20603,'76010','Grand Prairie','',''),(20604,'76011','Grand Prairie','',''),(20605,'76012','Fort Worth','',''),(20606,'76013','Fort Worth','',''),(20607,'76017','Kennedale','',''),(20608,'76018','Grand Prairie','',''),(20609,'76020','Fort Worth','',''),(20610,'76020','Pecan Acres','',''),(20611,'76020','Weatherford','',''),(20612,'76021','Colleyville','',''),(20613,'76021','Euless','',''),(20614,'76022','Hurst','',''),(20615,'76028','Fort Worth','',''),(20616,'76031','Burleson','',''),(20617,'76031','Keene','',''),(20618,'76034','Euless','',''),(20619,'76034','North Richland Hills','',''),(20620,'76035','Weatherford','',''),(20621,'76036','Burleson','',''),(20622,'76036','Fort Worth','',''),(20623,'76039','Bedford','',''),(20624,'76039','Fort Worth','',''),(20625,'76040','Arlington','',''),(20626,'76040','Bedford','',''),(20627,'76040','Fort Worth','',''),(20628,'76040','Hurst','',''),(20629,'76051','Euless','',''),(20630,'76051','Flower Mound','',''),(20631,'76051','Fort Worth','',''),(20632,'76051','Southlake','',''),(20633,'76052','Fort Worth','',''),(20634,'76053','Bedford','',''),(20635,'76053','Fort Worth','',''),(20636,'76053','North Richland Hills','',''),(20637,'76053','Richland Hills','',''),(20638,'76054','Bedford','',''),(20639,'76054','Colleyville','',''),(20640,'76054','North Richland Hills','',''),(20641,'76058','Burleson','',''),(20642,'76058','Cleburne','',''),(20643,'76060','Arlington','',''),(20644,'76060','Fort Worth','',''),(20645,'76063','Arlington','',''),(20646,'76063','Grand Prairie','',''),(20647,'76065','Cedar Hill','',''),(20648,'76065','Grand Prairie','',''),(20649,'76065','Mansfield','',''),(20650,'76065','Waxahachie','',''),(20651,'76071','Pecan Acres','',''),(20652,'76078','Pecan Acres','',''),(20653,'76084','Grand Prairie','',''),(20654,'76084','Mansfield','',''),(20655,'76084','Midlothian','',''),(20656,'76088','Mineral Wells','',''),(20657,'76092','Colleyville','',''),(20658,'76092','Grapevine','',''),(20659,'76109','Benbrook','',''),(20660,'76111','Haltom City','',''),(20661,'76112','Arlington','',''),(20662,'76116','Benbrook','',''),(20663,'76117','Fort Worth','',''),(20664,'76117','North Richland Hills','',''),(20665,'76117','Richland Hills','',''),(20666,'76118','Haltom City','',''),(20667,'76118','Richland Hills','',''),(20668,'76119','Arlington','',''),(20669,'76120','Arlington','',''),(20670,'76126','Benbrook','',''),(20671,'76127','Fort Worth','',''),(20672,'76132','Benbrook','',''),(20673,'76137','Haltom City','',''),(20674,'76137','Watauga','',''),(20675,'76140','Kennedale','',''),(20676,'76148','Haltom City','',''),(20677,'76148','Keller','',''),(20678,'76148','Watauga','',''),(20679,'76155','Euless','',''),(20680,'76179','Pecan Acres','',''),(20681,'76180','Haltom City','',''),(20682,'76180','Hurst','',''),(20683,'76180','Richland Hills','',''),(20684,'76226','Denton','',''),(20685,'76226','Flower Mound','',''),(20686,'76226','Lantana','',''),(20687,'76227','Denton','',''),(20688,'76227','Little Elm','',''),(20689,'76227','Prosper','',''),(20690,'76233','Gunter','',''),(20691,'76240','Lindsay','',''),(20692,'76244','Fort Worth','',''),(20693,'76245','Sherwood Shores','',''),(20694,'76247','Flower Mound','',''),(20695,'76247','Fort Worth','',''),(20696,'76248','Fort Worth','',''),(20697,'76248','North Richland Hills','',''),(20698,'76248','Southlake','',''),(20699,'76248','Watauga','',''),(20700,'76249','Denton','',''),(20701,'76250','Gainesville','',''),(20702,'76258','Celina','',''),(20703,'76258','Denton','',''),(20704,'76258','Gunter','',''),(20705,'76259','Denton','',''),(20706,'76262','Flower Mound','',''),(20707,'76262','Fort Worth','',''),(20708,'76262','Keller','',''),(20709,'76262','Southlake','',''),(20710,'76262','Trophy Club','',''),(20711,'76265','St. Jo','',''),(20712,'76266','Denton','',''),(20713,'76271','Gunter','',''),(20714,'76273','Southmayd','',''),(20715,'76305','Burkburnett','',''),(20716,'76310','Holliday','',''),(20717,'76311','Wichita Falls','',''),(20718,'76363','Munday','',''),(20719,'76367','Burkburnett','',''),(20720,'76367','Wichita Falls','',''),(20721,'76377','Byers','',''),(20722,'76431','Bridgeport','',''),(20723,'76432','Early','',''),(20724,'76437','Putnam','',''),(20725,'76502','Belton','',''),(20726,'76502','Little River-academy','',''),(20727,'76513','Harker Heights','',''),(20728,'76513','Nolanville','',''),(20729,'76513','Temple','',''),(20730,'76542','Copperas Cove','',''),(20731,'76542','Harker Heights','',''),(20732,'76543','Harker Heights','',''),(20733,'76543','Nolanville','',''),(20734,'76544','Copperas Cove','',''),(20735,'76544','Fort Hood','',''),(20736,'76548','Killeen','',''),(20737,'76548','Nolanville','',''),(20738,'76549','Copperas Cove','',''),(20739,'76549','Fort Hood','',''),(20740,'76554','Little River-academy','',''),(20741,'76557','Temple','',''),(20742,'76559','Harker Heights','',''),(20743,'76561','Mcgregor','',''),(20744,'76571','Belton','',''),(20745,'76571','Killeen','',''),(20746,'76579','Temple','',''),(20747,'76633','Waco','',''),(20748,'76634','Meridian','',''),(20749,'76638','Waco','',''),(20750,'76640','Leroy','',''),(20751,'76640','Waco','',''),(20752,'76643','Waco','',''),(20753,'76655','Hewitt','',''),(20754,'76655','Waco','',''),(20755,'76657','Mcgregor','',''),(20756,'76657','Waco','',''),(20757,'76691','Leroy','',''),(20758,'76693','Kirvin','',''),(20759,'76705','Bellmead','',''),(20760,'76706','Hewitt','',''),(20761,'76712','Hewitt','',''),(20762,'76712','Waco','',''),(20763,'76802','Brownwood','',''),(20764,'76825','Melvin','',''),(20765,'76858','Brady','',''),(20766,'76901','Carlsbad','',''),(20767,'76908','San Angelo','',''),(20768,'77005','West University Place','',''),(20769,'77015','Channelview','',''),(20770,'77015','Cloverleaf','',''),(20771,'77015','Galena Park','',''),(20772,'77015','Jacinto City','',''),(20773,'77025','West University Place','',''),(20774,'77029','Galena Park','',''),(20775,'77029','Jacinto City','',''),(20776,'77035','Missouri City','',''),(20777,'77044','Atascocita','',''),(20778,'77047','Pearland','',''),(20779,'77049','Channelview','',''),(20780,'77049','Cloverleaf','',''),(20781,'77058','Pasadena','',''),(20782,'77059','Pasadena','',''),(20783,'77071','Missouri City','',''),(20784,'77082','Mission Bend','',''),(20785,'77083','Mission Bend','',''),(20786,'77085','Missouri City','',''),(20787,'77089','Friendswood','',''),(20788,'77089','Pearland','',''),(20789,'77318','Conroe','',''),(20790,'77320','Riverside','',''),(20791,'77336','Houston','',''),(20792,'77338','Atascocita','',''),(20793,'77338','Houston','',''),(20794,'77339','Houston','',''),(20795,'77345','Houston','',''),(20796,'77346','Atascocita','',''),(20797,'77346','Houston','',''),(20798,'77354','The Woodlands','',''),(20799,'77356','Conroe','',''),(20800,'77357','Houston','',''),(20801,'77365','Houston','',''),(20802,'77373','Houston','',''),(20803,'77375','Houston','',''),(20804,'77375','The Woodlands','',''),(20805,'77377','Houston','',''),(20806,'77378','Conroe','',''),(20807,'77379','Houston','',''),(20808,'77380','The Woodlands','',''),(20809,'77381','The Woodlands','',''),(20810,'77382','Conroe','',''),(20811,'77382','The Woodlands','',''),(20812,'77384','The Woodlands','',''),(20813,'77385','The Woodlands','',''),(20814,'77386','Houston','',''),(20815,'77388','Houston','',''),(20816,'77389','The Woodlands','',''),(20817,'77396','Atascocita','',''),(20818,'77396','Houston','',''),(20819,'77401','Houston','',''),(20820,'77406','Houston','',''),(20821,'77407','Houston','',''),(20822,'77407','Mission Bend','',''),(20823,'77414','Van Vleck','',''),(20824,'77417','Kendleton','',''),(20825,'77417','Rosenberg','',''),(20826,'77422','Lake Jackson','',''),(20827,'77428','Palacios','',''),(20828,'77429','Houston','',''),(20829,'77433','Houston','',''),(20830,'77441','Orchard','',''),(20831,'77441','Weston Lakes','',''),(20832,'77445','Prairie View','',''),(20833,'77447','Houston','',''),(20834,'77449','Houston','',''),(20835,'77450','Houston','',''),(20836,'77459','Fresno','',''),(20837,'77459','Sugar Land','',''),(20838,'77461','Rosenberg','',''),(20839,'77469','Missouri City','',''),(20840,'77469','Rosenberg','',''),(20841,'77469','Sugar Land','',''),(20842,'77469','Thompsons','',''),(20843,'77471','Orchard','',''),(20844,'77474','San Felipe','',''),(20845,'77477','Houston','',''),(20846,'77477','Missouri City','',''),(20847,'77477','Sugar Land','',''),(20848,'77478','Houston','',''),(20849,'77478','Stafford','',''),(20850,'77479','Missouri City','',''),(20851,'77484','Houston','',''),(20852,'77484','Prairie View','',''),(20853,'77485','Orchard','',''),(20854,'77488','Hungerford','',''),(20855,'77489','Houston','',''),(20856,'77489','Stafford','',''),(20857,'77493','Houston','',''),(20858,'77494','Houston','',''),(20859,'77498','Houston','',''),(20860,'77502','South Houston','',''),(20861,'77503','Deer Park','',''),(20862,'77503','Houston','',''),(20863,'77504','Houston','',''),(20864,'77504','South Houston','',''),(20865,'77505','Deer Park','',''),(20866,'77505','La Porte','',''),(20867,'77506','Houston','',''),(20868,'77507','La Porte','',''),(20869,'77510','Dickinson','',''),(20870,'77510','Hitchcock','',''),(20871,'77510','La Marque','',''),(20872,'77510','Texas City','',''),(20873,'77511','League City','',''),(20874,'77511','Pearland','',''),(20875,'77511','Santa Fe','',''),(20876,'77515','Alvin','',''),(20877,'77515','Lake Jackson','',''),(20878,'77517','Hitchcock','',''),(20879,'77517','League City','',''),(20880,'77518','Texas City','',''),(20881,'77520','Houston','',''),(20882,'77521','Highlands','',''),(20883,'77523','Mont Belvieu','',''),(20884,'77530','Houston','',''),(20885,'77531','Lake Jackson','',''),(20886,'77532','Houston','',''),(20887,'77534','Alvin','',''),(20888,'77535','Liberty','',''),(20889,'77535','Mont Belvieu','',''),(20890,'77536','Houston','',''),(20891,'77536','La Porte','',''),(20892,'77536','Pasadena','',''),(20893,'77539','League City','',''),(20894,'77539','Santa Fe','',''),(20895,'77539','Texas City','',''),(20896,'77541','Alvin','',''),(20897,'77541','Clute','',''),(20898,'77545','Missouri City','',''),(20899,'77545','Pearland','',''),(20900,'77546','Houston','',''),(20901,'77546','League City','',''),(20902,'77547','Houston','',''),(20903,'77554','Texas City','',''),(20904,'77562','Baytown','',''),(20905,'77563','La Marque','',''),(20906,'77565','Bacliff','',''),(20907,'77565','League City','',''),(20908,'77565','Seabrook','',''),(20909,'77566','Clute','',''),(20910,'77568','Hitchcock','',''),(20911,'77568','Texas City','',''),(20912,'77571','Deer Park','',''),(20913,'77571','Houston','',''),(20914,'77571','Pasadena','',''),(20915,'77573','Friendswood','',''),(20916,'77573','Texas City','',''),(20917,'77575','Hardin','',''),(20918,'77577','Alvin','',''),(20919,'77578','Alvin','',''),(20920,'77578','Pearland','',''),(20921,'77583','Alvin','',''),(20922,'77583','Fresno','',''),(20923,'77583','Missouri City','',''),(20924,'77583','Pearland','',''),(20925,'77584','Alvin','',''),(20926,'77586','Pasadena','',''),(20927,'77587','Houston','',''),(20928,'77591','La Marque','',''),(20929,'77598','Friendswood','',''),(20930,'77598','Houston','',''),(20931,'77598','League City','',''),(20932,'77611','Port Arthur','',''),(20933,'77612','Deweyville','',''),(20934,'77612','Evadale','',''),(20935,'77613','Nome','',''),(20936,'77617','Bolivar Peninsula','',''),(20937,'77619','Port Arthur','',''),(20938,'77619','Port Neches','',''),(20939,'77623','Bolivar Peninsula','',''),(20940,'77625','Lumberton','',''),(20941,'77625','Wildwood','',''),(20942,'77627','Beaumont','',''),(20943,'77627','Port Arthur','',''),(20944,'77630','Bridge City','',''),(20945,'77630','Port Arthur','',''),(20946,'77632','Deweyville','',''),(20947,'77642','Groves','',''),(20948,'77642','Nederland','',''),(20949,'77642','Port Neches','',''),(20950,'77650','Bolivar Peninsula','',''),(20951,'77651','Nederland','',''),(20952,'77651','Port Arthur','',''),(20953,'77655','Port Arthur','',''),(20954,'77663','Wildwood','',''),(20955,'77665','Stowell','',''),(20956,'77705','Nederland','',''),(20957,'77705','Port Arthur','',''),(20958,'77713','China','',''),(20959,'77801','College Station','',''),(20960,'77802','College Station','',''),(20961,'77807','College Station','',''),(20962,'77840','Bryan','',''),(20963,'77845','Bryan','',''),(20964,'77879','Snook','',''),(20965,'77905','Bloomington','',''),(20966,'77905','Placedo','',''),(20967,'77957','Vanderbilt','',''),(20968,'77968','Victoria','',''),(20969,'77982','Port Oconnor','',''),(20970,'78015','Fair Oaks Ranch','',''),(20971,'78023','San Antonio','',''),(20972,'78026','Christine','',''),(20973,'78026','Pleasanton','',''),(20974,'78039','Lacoste','',''),(20975,'78044','Colorado Acres','',''),(20976,'78056','San Antonio','',''),(20977,'78057','Bigfoot','',''),(20978,'78063','Lakehills','',''),(20979,'78064','Christine','',''),(20980,'78064','Leming','',''),(20981,'78070','Canyon Lake','',''),(20982,'78073','San Antonio','',''),(20983,'78101','St. Hedwig','',''),(20984,'78104','Normanna','',''),(20985,'78108','Randolph Afb','',''),(20986,'78108','Schertz','',''),(20987,'78108','Universal City','',''),(20988,'78109','San Antonio','',''),(20989,'78109','Universal City','',''),(20990,'78112','San Antonio','',''),(20991,'78119','Pawnee','',''),(20992,'78123','Mcqueeney','',''),(20993,'78123','Seguin','',''),(20994,'78124','Schertz','',''),(20995,'78130','Mcqueeney','',''),(20996,'78132','Canyon Lake','',''),(20997,'78132','Garden Ridge','',''),(20998,'78132','Schertz','',''),(20999,'78146','Tuleta','',''),(21000,'78148','Converse','',''),(21001,'78148','Randolph Afb','',''),(21002,'78148','Schertz','',''),(21003,'78150','Randolph Afb','',''),(21004,'78152','St. Hedwig','',''),(21005,'78154','Cibolo','',''),(21006,'78154','Garden Ridge','',''),(21007,'78154','Randolph Afb','',''),(21008,'78154','San Antonio','',''),(21009,'78154','Universal City','',''),(21010,'78155','Mcqueeney','',''),(21011,'78162','Pettus','',''),(21012,'78163','Fair Oaks Ranch','',''),(21013,'78219','Kirby','',''),(21014,'78233','Converse','',''),(21015,'78233','Universal City','',''),(21016,'78236','Lackland Afb','',''),(21017,'78239','Converse','',''),(21018,'78244','Converse','',''),(21019,'78244','Kirby','',''),(21020,'78258','Timberwood Park','',''),(21021,'78260','Timberwood Park','',''),(21022,'78266','Garden Ridge','',''),(21023,'78266','Schertz','',''),(21024,'78332','Benavides','',''),(21025,'78336','Gregory','',''),(21026,'78336','Ingleside','',''),(21027,'78362','Aransas Pass','',''),(21028,'78362','Corpus Christi','',''),(21029,'78370','Corpus Christi','',''),(21030,'78370','Edroy','',''),(21031,'78373','Corpus Christi','',''),(21032,'78374','Corpus Christi','',''),(21033,'78374','Gregory','',''),(21034,'78374','Ingleside','',''),(21035,'78380','Banquete','',''),(21036,'78380','Corpus Christi','',''),(21037,'78380','Driscoll','',''),(21038,'78382','Fulton','',''),(21039,'78389','Tynan','',''),(21040,'78390','Portland','',''),(21041,'78501','Pharr','',''),(21042,'78503','Hidalgo','',''),(21043,'78504','Edinburg','',''),(21044,'78516','San Juan','',''),(21045,'78536','San Isidro','',''),(21046,'78538','La Blanca','',''),(21047,'78539','Mcallen','',''),(21048,'78541','Mcallen','',''),(21049,'78542','La Blanca','',''),(21050,'78543','La Blanca','',''),(21051,'78545','New Falcon','',''),(21052,'78548','La Grulla','',''),(21053,'78550','Combes','',''),(21054,'78550','San Benito','',''),(21055,'78552','Combes','',''),(21056,'78564','Lopeño','',''),(21057,'78566','Brownsville','',''),(21058,'78566','Port Isabel','',''),(21059,'78569','Sebastian','',''),(21060,'78570','Weslaco','',''),(21061,'78572','Mcallen','',''),(21062,'78573','Alton','',''),(21063,'78573','Mcallen','',''),(21064,'78575','Brownsville','',''),(21065,'78576','La Joya','',''),(21066,'78578','Brownsville','',''),(21067,'78580','Lasara','',''),(21068,'78580','Lyford','',''),(21069,'78580','San Perlita','',''),(21070,'78582','La Grulla','',''),(21071,'78583','Brownsville','',''),(21072,'78585','Salineño','',''),(21073,'78586','Brownsville','',''),(21074,'78586','Harlingen','',''),(21075,'78586','Los Indios','',''),(21076,'78596','Mercedes','',''),(21077,'78596','Progreso','',''),(21078,'78597','Port Isabel','',''),(21079,'78607','Buchanan Dam','',''),(21080,'78610','Austin','',''),(21081,'78610','Kyle','',''),(21082,'78613','Austin','',''),(21083,'78613','Leander','',''),(21084,'78617','Austin','',''),(21085,'78623','Canyon Lake','',''),(21086,'78626','Round Rock','',''),(21087,'78628','Leander','',''),(21088,'78628','Round Rock','',''),(21089,'78634','Pflugerville','',''),(21090,'78634','Round Rock','',''),(21091,'78634','Taylor','',''),(21092,'78638','Staples','',''),(21093,'78641','Austin','',''),(21094,'78641','Cedar Park','',''),(21095,'78645','Lago Vista','',''),(21096,'78652','Austin','',''),(21097,'78653','Austin','',''),(21098,'78653','Pflugerville','',''),(21099,'78655','San Marcos','',''),(21100,'78655','Staples','',''),(21101,'78656','San Marcos','',''),(21102,'78657','Horseshoe Bay','',''),(21103,'78657','Marble Falls','',''),(21104,'78660','Austin','',''),(21105,'78660','Round Rock','',''),(21106,'78664','Austin','',''),(21107,'78664','Pflugerville','',''),(21108,'78665','Georgetown','',''),(21109,'78665','Round Rock','',''),(21110,'78669','Lago Vista','',''),(21111,'78669','Lakeway','',''),(21112,'78672','Buchanan Lake Village','',''),(21113,'78681','Austin','',''),(21114,'78681','Cedar Park','',''),(21115,'78717','Cedar Park','',''),(21116,'78717','Round Rock','',''),(21117,'78724','Hornsby Bend','',''),(21118,'78725','Hornsby Bend','',''),(21119,'78726','Cedar Park','',''),(21120,'78728','Round Rock','',''),(21121,'78728','Wells Branch','',''),(21122,'78729','Jollyville','',''),(21123,'78734','Lakeway','',''),(21124,'78738','Bee Cave','',''),(21125,'78738','Lakeway','',''),(21126,'78750','Cedar Park','',''),(21127,'78801','Uvalde Estates','',''),(21128,'78802','Uvalde Estates','',''),(21129,'78840','Laughlin Afb','',''),(21130,'78843','Laughlin Afb','',''),(21131,'78850','Dhanis','',''),(21132,'78861','Dhanis','',''),(21133,'78934','Glidden','',''),(21134,'78943','Columbus','',''),(21135,'79052','Edmonson','',''),(21136,'79316','Wellman','',''),(21137,'79336','Sundown','',''),(21138,'79382','Lubbock','',''),(21139,'79403','New Deal','',''),(21140,'79415','New Deal','',''),(21141,'79521','Stamford','',''),(21142,'79536','Tye','',''),(21143,'79539','Obrien','',''),(21144,'79563','Abilene','',''),(21145,'79603','Tye','',''),(21146,'79607','Abilene','',''),(21147,'79706','Odessa','',''),(21148,'79707','Odessa','',''),(21149,'79752','Mccamey','',''),(21150,'79763','West Odessa','',''),(21151,'79764','West Odessa','',''),(21152,'79765','Midland','',''),(21153,'79772','Toyah','',''),(21154,'79777','Monahans','',''),(21155,'79782','Midland','',''),(21156,'79821','Canutillo','',''),(21157,'79821','El Paso','',''),(21158,'79835','El Paso','',''),(21159,'79836','San Elizario','',''),(21160,'79836','Socorro','',''),(21161,'79849','Socorro','',''),(21162,'79906','Fort Bliss','',''),(21163,'79908','Fort Bliss','',''),(21164,'79916','Fort Bliss','',''),(21165,'79927','San Elizario','',''),(21166,'79927','Socorro','',''),(21167,'79928','Socorro','',''),(21168,'79932','Canutillo','',''),(21169,'80002','Fairmount','',''),(21170,'80002','Wheat Ridge','',''),(21171,'80003','Westminster','',''),(21172,'80004','Fairmount','',''),(21173,'80005','Westminster','',''),(21174,'80012','Denver','',''),(21175,'80014','Denver','',''),(21176,'80015','Centennial','',''),(21177,'80016','Centennial','',''),(21178,'80020','Lafayette','',''),(21179,'80020','Louisville','',''),(21180,'80020','Westminster','',''),(21181,'80021','Arvada','',''),(21182,'80021','Westminster','',''),(21183,'80022','Derby','',''),(21184,'80023','Broomfield','',''),(21185,'80023','Thornton','',''),(21186,'80023','Westminster','',''),(21187,'80024','Derby','',''),(21188,'80025','Boulder','',''),(21189,'80026','Erie','',''),(21190,'80026','Louisville','',''),(21191,'80027','Broomfield','',''),(21192,'80027','Lafayette','',''),(21193,'80030','Arvada','',''),(21194,'80031','Sherrelwood','',''),(21195,'80033','Arvada','',''),(21196,'80102','Aurora','',''),(21197,'80102','Watkins','',''),(21198,'80106','Black Forest','',''),(21199,'80108','Castle Pines North','',''),(21200,'80108','Parker','',''),(21201,'80110','Denver','',''),(21202,'80110','Littleton','',''),(21203,'80111','Centennial','',''),(21204,'80111','Cherry Creek','',''),(21205,'80111','Denver','',''),(21206,'80112','Aurora','',''),(21207,'80112','Centennial','',''),(21208,'80112','Lone Tree','',''),(21209,'80112','Parker','',''),(21210,'80116','Castle Rock','',''),(21211,'80120','Englewood','',''),(21212,'80120','Highlands Ranch','',''),(21213,'80121','Centennial','',''),(21214,'80121','Englewood','',''),(21215,'80122','Centennial','',''),(21216,'80123','Denver','',''),(21217,'80123','Ken Caryl','',''),(21218,'80123','Lakewood','',''),(21219,'80124','Highlands Ranch','',''),(21220,'80125','Highlands Ranch','',''),(21221,'80125','Louviers','',''),(21222,'80125','Roxborough Park','',''),(21223,'80126','Highlands Ranch','',''),(21224,'80127','Dakota Ridge','',''),(21225,'80127','Ken Caryl','',''),(21226,'80127','Lakewood','',''),(21227,'80128','Ken Caryl','',''),(21228,'80129','Highlands Ranch','',''),(21229,'80130','Highlands Ranch','',''),(21230,'80130','Lone Tree','',''),(21231,'80132','Palmer Lake','',''),(21232,'80132','Woodmoor','',''),(21233,'80134','Castle Pines North','',''),(21234,'80134','Castle Rock','',''),(21235,'80134','Lone Tree','',''),(21236,'80135','Louviers','',''),(21237,'80135','Roxborough Park','',''),(21238,'80137','Aurora','',''),(21239,'80138','Aurora','',''),(21240,'80212','Wheat Ridge','',''),(21241,'80214','Lakewood','',''),(21242,'80214','Wheat Ridge','',''),(21243,'80215','Lakewood','',''),(21244,'80215','Wheat Ridge','',''),(21245,'80216','Commerce City','',''),(21246,'80220','Aurora','',''),(21247,'80221','Sherrelwood','',''),(21248,'80221','Thornton','',''),(21249,'80221','Westminster','',''),(21250,'80226','Lakewood','',''),(21251,'80227','Lakewood','',''),(21252,'80228','Lakewood','',''),(21253,'80229','Commerce City','',''),(21254,'80229','Northglenn','',''),(21255,'80229','Thornton','',''),(21256,'80231','Aurora','',''),(21257,'80232','Lakewood','',''),(21258,'80233','Northglenn','',''),(21259,'80233','Thornton','',''),(21260,'80234','Broomfield','',''),(21261,'80234','Northglenn','',''),(21262,'80234','Westminster','',''),(21263,'80235','Dakota Ridge','',''),(21264,'80235','Lakewood','',''),(21265,'80241','Northglenn','',''),(21266,'80247','Aurora','',''),(21267,'80260','Northglenn','',''),(21268,'80260','Sherrelwood','',''),(21269,'80260','Thornton','',''),(21270,'80260','Westminster','',''),(21271,'80301','Lafayette','',''),(21272,'80303','Eldorado Springs','',''),(21273,'80303','Lafayette','',''),(21274,'80303','Louisville','',''),(21275,'80305','Eldorado Springs','',''),(21276,'80401','Idledale','',''),(21277,'80401','Lakewood','',''),(21278,'80401','Wheat Ridge','',''),(21279,'80403','Arvada','',''),(21280,'80403','Fairmount','',''),(21281,'80403','Wheat Ridge','',''),(21282,'80422','Central City','',''),(21283,'80435','Silverthorne','',''),(21284,'80436','Downieville-lawson-dumont','',''),(21285,'80439','Idaho Springs','',''),(21286,'80439','Kittredge','',''),(21287,'80442','Winter Park','',''),(21288,'80452','Central City','',''),(21289,'80452','Downieville-lawson-dumont','',''),(21290,'80452','Empire','',''),(21291,'80465','Dakota Ridge','',''),(21292,'80465','Golden','',''),(21293,'80465','Indian Hills','',''),(21294,'80465','Lakewood','',''),(21295,'80476','Georgetown','',''),(21296,'80481','Bark Ranch','',''),(21297,'80482','Fraser','',''),(21298,'80503','Boulder','',''),(21299,'80504','Erie','',''),(21300,'80504','Firestone','',''),(21301,'80504','Frederick','',''),(21302,'80504','Mead','',''),(21303,'80513','Johnstown','',''),(21304,'80513','Mead','',''),(21305,'80514','Frederick','',''),(21306,'80515','Estes Park','',''),(21307,'80516','Broomfield','',''),(21308,'80516','Dacono','',''),(21309,'80516','Frederick','',''),(21310,'80516','Lafayette','',''),(21311,'80524','Laporte','',''),(21312,'80524','Severance','',''),(21313,'80524','Timnath','',''),(21314,'80525','Loveland','',''),(21315,'80525','Timnath','',''),(21316,'80526','Loveland','',''),(21317,'80528','Loveland','',''),(21318,'80528','Timnath','',''),(21319,'80528','Windsor','',''),(21320,'80534','Loveland','',''),(21321,'80534','Mead','',''),(21322,'80534','Milliken','',''),(21323,'80534','Windsor','',''),(21324,'80537','Johnstown','',''),(21325,'80538','Johnstown','',''),(21326,'80538','Windsor','',''),(21327,'80540','Allenspark','',''),(21328,'80543','Evans','',''),(21329,'80543','Greeley','',''),(21330,'80543','Johnstown','',''),(21331,'80550','Greeley','',''),(21332,'80550','Severance','',''),(21333,'80550','Timnath','',''),(21334,'80601','Commerce City','',''),(21335,'80601','Thornton','',''),(21336,'80602','Commerce City','',''),(21337,'80602','Thornton','',''),(21338,'80603','Commerce City','',''),(21339,'80603','Dacono','',''),(21340,'80603','Fort Lupton','',''),(21341,'80603','Northglenn','',''),(21342,'80603','Thornton','',''),(21343,'80610','Severance','',''),(21344,'80615','Severance','',''),(21345,'80620','Greeley','',''),(21346,'80621','Brighton','',''),(21347,'80621','Dacono','',''),(21348,'80621','Firestone','',''),(21349,'80621','Frederick','',''),(21350,'80621','Hudson','',''),(21351,'80631','Evans','',''),(21352,'80631','Windsor','',''),(21353,'80634','Evans','',''),(21354,'80634','Milliken','',''),(21355,'80634','Windsor','',''),(21356,'80640','Brighton','',''),(21357,'80640','Commerce City','',''),(21358,'80640','Derby','',''),(21359,'80640','Thornton','',''),(21360,'80643','Hudson','',''),(21361,'80645','Evans','',''),(21362,'80651','Gilcrest','',''),(21363,'80651','Mead','',''),(21364,'80651','Milliken','',''),(21365,'80701','Log Lane Village','',''),(21366,'80731','Paoli','',''),(21367,'80809','Cascade-chipita Park','',''),(21368,'80809','Colorado Springs','',''),(21369,'80809','Green Mountain Falls','',''),(21370,'80816','Cripple Creek','',''),(21371,'80817','Security-widefield','',''),(21372,'80819','Cascade-chipita Park','',''),(21373,'80829','Colorado Springs','',''),(21374,'80831','Colorado Springs','',''),(21375,'80840','Air Force Academy','',''),(21376,'80902','Fort Carson','',''),(21377,'80904','Manitou Springs','',''),(21378,'80908','Black Forest','',''),(21379,'80911','Fountain','',''),(21380,'80911','Security-widefield','',''),(21381,'80913','Fort Carson','',''),(21382,'80915','Cimarron Hills','',''),(21383,'80916','Cimarron Hills','',''),(21384,'80921','Black Forest','',''),(21385,'80922','Cimarron Hills','',''),(21386,'80925','Fountain','',''),(21387,'80925','Security-widefield','',''),(21388,'80928','Fountain','',''),(21389,'80929','Cimarron Hills','',''),(21390,'80938','Cimarron Hills','',''),(21391,'81004','Colorado City','',''),(21392,'81007','Pueblo West','',''),(21393,'81008','Fountain','',''),(21394,'81025','Pueblo','',''),(21395,'81047','Hartman','',''),(21396,'81050','Cheraw','',''),(21397,'81050','Swink','',''),(21398,'81063','Crowley','',''),(21399,'81069','Colorado City','',''),(21400,'81137','Arboles','',''),(21401,'81140','Capulin','',''),(21402,'81147','Arboles','',''),(21403,'81201','Poncha Springs','',''),(21404,'81212','Cañon City','',''),(21405,'81223','Coaldale','',''),(21406,'81225','Mount Crested Butte','',''),(21407,'81226','Coal Creek','',''),(21408,'81226','Rockvale','',''),(21409,'81233','Coaldale','',''),(21410,'81321','Towaoc','',''),(21411,'81410','Orchard City','',''),(21412,'81413','Orchard City','',''),(21413,'81418','Orchard City','',''),(21414,'81419','Orchard City','',''),(21415,'81424','Naturita','',''),(21416,'81435','Ophir','',''),(21417,'81504','Clifton','',''),(21418,'81507','Fruita','',''),(21419,'81507','Redlands','',''),(21420,'81521','Redlands','',''),(21421,'81524','Fruita','',''),(21422,'81611','Snowmass Village','',''),(21423,'81611','Woody Creek','',''),(21424,'81615','Woody Creek','',''),(21425,'81620','Edwards','',''),(21426,'81620','Minturn','',''),(21427,'81623','Basalt','',''),(21428,'81631','Gypsum','',''),(21429,'81632','Avon','',''),(21430,'81635','Battlement Mesa','',''),(21431,'81645','Red Cliff','',''),(21432,'81647','Silt','',''),(21433,'81649','Minturn','',''),(21434,'81654','Snowmass Village','',''),(21435,'81655','Avon','',''),(21436,'81657','Minturn','',''),(21437,'82001','Warren Afb','',''),(21438,'82005','Warren Afb','',''),(21439,'82063','Woods Landing-jelm','',''),(21440,'82070','Woods Landing-jelm','',''),(21441,'82190','Mammoth','',''),(21442,'82221','La Grange','',''),(21443,'82301','Sinclair','',''),(21444,'82334','Rawlins','',''),(21445,'82421','Frannie','',''),(21446,'82431','Byron','',''),(21447,'82435','Ralston','',''),(21448,'82443','Kirby','',''),(21449,'82501','Arapahoe','',''),(21450,'82501','Shoshoni','',''),(21451,'82520','Fort Washakie','',''),(21452,'82520','Hudson','',''),(21453,'82601','Evansville','',''),(21454,'82601','Mills','',''),(21455,'82604','Mills','',''),(21456,'82604','Powder River','',''),(21457,'82609','Evansville','',''),(21458,'82636','Casper','',''),(21459,'82718','Wright','',''),(21460,'82832','Story','',''),(21461,'82839','Parkman','',''),(21462,'82901','Reliance','',''),(21463,'83014','Moose Wilson Road','',''),(21464,'83014','Teton Village','',''),(21465,'83101','Diamondville','',''),(21466,'83110','Smoot','',''),(21467,'83116','Kemmerer','',''),(21468,'83118','Freedom','',''),(21469,'83118','Nordic','',''),(21470,'83121','Kemmerer','',''),(21471,'83127','Star Valley Ranch','',''),(21472,'83128','Nordic','',''),(21473,'83201','Chubbuck','',''),(21474,'83202','Chubbuck','',''),(21475,'83202','Fort Hall','',''),(21476,'83221','Atomic City','',''),(21477,'83221','Fort Hall','',''),(21478,'83236','Basalt','',''),(21479,'83254','Paris','',''),(21480,'83261','Bloomington','',''),(21481,'83263','Franklin','',''),(21482,'83272','Bloomington','',''),(21483,'83272','St. Charles','',''),(21484,'83286','Dayton','',''),(21485,'83333','Bellevue','',''),(21486,'83336','Burley','',''),(21487,'83340','Sun Valley','',''),(21488,'83341','Twin Falls','',''),(21489,'83401','Ammon','',''),(21490,'83401','Iona','',''),(21491,'83401','Ucon','',''),(21492,'83406','Ammon','',''),(21493,'83428','Swan Valley','',''),(21494,'83433','Island Park','',''),(21495,'83440','Sugar City','',''),(21496,'83442','Ririe','',''),(21497,'83443','Swan Valley','',''),(21498,'83448','Teton','',''),(21499,'83449','Irwin','',''),(21500,'83605','Middleton','',''),(21501,'83607','Notus','',''),(21502,'83616','Boise City','',''),(21503,'83631','Placerville','',''),(21504,'83634','Boise City','',''),(21505,'83642','Boise City','',''),(21506,'83642','Kuna','',''),(21507,'83644','Star','',''),(21508,'83646','Boise City','',''),(21509,'83646','Eagle','',''),(21510,'83648','Mountain Home Afb','',''),(21511,'83651','Caldwell','',''),(21512,'83661','Fruitland','',''),(21513,'83687','Caldwell','',''),(21514,'83687','Kuna','',''),(21515,'83702','Boise City','',''),(21516,'83703','Boise City','',''),(21517,'83703','Garden City','',''),(21518,'83704','Boise City','',''),(21519,'83704','Garden City','',''),(21520,'83705','Boise City','',''),(21521,'83706','Boise City','',''),(21522,'83706','Garden City','',''),(21523,'83709','Boise City','',''),(21524,'83712','Boise City','',''),(21525,'83713','Boise City','',''),(21526,'83714','Boise City','',''),(21527,'83714','Eagle','',''),(21528,'83716','Boise City','',''),(21529,'83814','Coeur Dalene','',''),(21530,'83815','Coeur Dalene','',''),(21531,'83815','Hayden','',''),(21532,'83823','Bovill','',''),(21533,'83824','De Smet','',''),(21534,'83837','Smelterville','',''),(21535,'83864','Dover','',''),(21536,'83864','Kootenai','',''),(21537,'83864','Ponderay','',''),(21538,'83867','Osburn','',''),(21539,'83868','Kellogg','',''),(21540,'83873','Osburn','',''),(21541,'84003','Alpine','',''),(21542,'84003','Draper','',''),(21543,'84003','Lehi','',''),(21544,'84003','Lindon','',''),(21545,'84003','Pleasant Grove','',''),(21546,'84004','Draper','',''),(21547,'84005','Saratoga Springs','',''),(21548,'84006','Copperton','',''),(21549,'84006','West Jordan','',''),(21550,'84010','Centerville','',''),(21551,'84010','North Salt Lake','',''),(21552,'84010','Woods Cross','',''),(21553,'84013','Eagle Mountain','',''),(21554,'84014','Bountiful','',''),(21555,'84014','Farmington','',''),(21556,'84015','Layton','',''),(21557,'84015','Syracuse','',''),(21558,'84020','Sandy','',''),(21559,'84025','Centerville','',''),(21560,'84025','Kaysville','',''),(21561,'84032','Heber','',''),(21562,'84036','Oakley','',''),(21563,'84037','Farmington','',''),(21564,'84037','Layton','',''),(21565,'84041','Clearfield','',''),(21566,'84041','Kaysville','',''),(21567,'84041','Syracuse','',''),(21568,'84042','Pleasant Grove','',''),(21569,'84043','American Fork','',''),(21570,'84043','Draper','',''),(21571,'84043','Saratoga Springs','',''),(21572,'84044','Salt Lake City','',''),(21573,'84044','West Valley City','',''),(21574,'84045','Eagle Mountain','',''),(21575,'84045','Lehi','',''),(21576,'84047','Cottonwood Heights','',''),(21577,'84047','Murray','',''),(21578,'84047','Sandy','',''),(21579,'84054','Bountiful','',''),(21580,'84054','Woods Cross','',''),(21581,'84056','Clearfield','',''),(21582,'84058','Provo','',''),(21583,'84061','Oakley','',''),(21584,'84062','American Fork','',''),(21585,'84062','Lindon','',''),(21586,'84065','Draper','',''),(21587,'84065','Herriman','',''),(21588,'84067','Hooper','',''),(21589,'84067','Ogden','',''),(21590,'84070','Midvale','',''),(21591,'84070','South Jordan','',''),(21592,'84075','Clearfield','',''),(21593,'84081','West Valley City','',''),(21594,'84084','Murray','',''),(21595,'84084','Taylorsville','',''),(21596,'84087','Bountiful','',''),(21597,'84087','Centerville','',''),(21598,'84087','North Salt Lake','',''),(21599,'84088','South Jordan','',''),(21600,'84092','Cottonwood Heights','',''),(21601,'84092','Draper','',''),(21602,'84093','Cottonwood Heights','',''),(21603,'84095','Riverton','',''),(21604,'84095','West Jordan','',''),(21605,'84096','Copperton','',''),(21606,'84096','Riverton','',''),(21607,'84096','South Jordan','',''),(21608,'84097','Provo','',''),(21609,'84098','Summit Park','',''),(21610,'84104','West Valley City','',''),(21611,'84106','Millcreek','',''),(21612,'84106','South Salt Lake','',''),(21613,'84107','Midvale','',''),(21614,'84107','Millcreek','',''),(21615,'84107','Murray','',''),(21616,'84107','South Salt Lake','',''),(21617,'84109','Millcreek','',''),(21618,'84115','South Salt Lake','',''),(21619,'84117','Holladay','',''),(21620,'84117','Millcreek','',''),(21621,'84117','Murray','',''),(21622,'84118','Kearns','',''),(21623,'84118','Taylorsville','',''),(21624,'84118','West Jordan','',''),(21625,'84118','West Valley City','',''),(21626,'84119','South Salt Lake','',''),(21627,'84119','Taylorsville','',''),(21628,'84119','West Valley City','',''),(21629,'84120','Kearns','',''),(21630,'84120','West Valley City','',''),(21631,'84121','Cottonwood Heights','',''),(21632,'84121','Holladay','',''),(21633,'84121','Murray','',''),(21634,'84123','Millcreek','',''),(21635,'84123','Murray','',''),(21636,'84123','Taylorsville','',''),(21637,'84123','West Jordan','',''),(21638,'84123','West Valley City','',''),(21639,'84124','Holladay','',''),(21640,'84124','Millcreek','',''),(21641,'84128','West Valley City','',''),(21642,'84302','Honeyville','',''),(21643,'84304','Cache','',''),(21644,'84310','North Ogden','',''),(21645,'84310','Ogden','',''),(21646,'84310','Wolf Creek','',''),(21647,'84311','Riverside','',''),(21648,'84312','Fielding','',''),(21649,'84312','Riverside','',''),(21650,'84314','Deweyville','',''),(21651,'84315','Roy','',''),(21652,'84321','Hyrum','',''),(21653,'84321','Millville','',''),(21654,'84321','Providence','',''),(21655,'84321','Wellsville','',''),(21656,'84326','Providence','',''),(21657,'84327','Cache','',''),(21658,'84332','Millville','',''),(21659,'84333','Lewiston','',''),(21660,'84333','Trenton','',''),(21661,'84335','Logan','',''),(21662,'84337','Garland','',''),(21663,'84337','Howell','',''),(21664,'84339','Hyrum','',''),(21665,'84339','Logan','',''),(21666,'84341','Hyde Park','',''),(21667,'84401','Hooper','',''),(21668,'84401','Roy','',''),(21669,'84404','Hooper','',''),(21670,'84404','North Ogden','',''),(21671,'84405','Roy','',''),(21672,'84405','Washington Terrace','',''),(21673,'84414','North Ogden','',''),(21674,'84501','Wellington','',''),(21675,'84520','Sunnyside','',''),(21676,'84521','Cleveland','',''),(21677,'84523','Clawson','',''),(21678,'84531','Oljato-monument Valley','',''),(21679,'84532','La Sal','',''),(21680,'84535','La Sal','',''),(21681,'84536','Oljato-monument Valley','',''),(21682,'84537','Castle Dale','',''),(21683,'84540','Thompson Springs','',''),(21684,'84601','Orem','',''),(21685,'84601','Springville','',''),(21686,'84604','Lindon','',''),(21687,'84604','Orem','',''),(21688,'84606','Springville','',''),(21689,'84620','Salina','',''),(21690,'84620','Sigurd','',''),(21691,'84624','Hinckley','',''),(21692,'84633','Elberta','',''),(21693,'84645','Santaquin','',''),(21694,'84648','Mona','',''),(21695,'84651','Salem','',''),(21696,'84651','Santaquin','',''),(21697,'84654','Redmond','',''),(21698,'84655','Payson','',''),(21699,'84660','Mapleton','',''),(21700,'84660','Payson','',''),(21701,'84660','Salem','',''),(21702,'84660','Springville','',''),(21703,'84663','Mapleton','',''),(21704,'84663','Provo','',''),(21705,'84663','Spanish Fork','',''),(21706,'84664','Spanish Fork','',''),(21707,'84664','Springville','',''),(21708,'84701','Annabella','',''),(21709,'84701','Glenwood','',''),(21710,'84719','Parowan','',''),(21711,'84720','Kanarraville','',''),(21712,'84723','Junction','',''),(21713,'84723','Kingston','',''),(21714,'84729','Orderville','',''),(21715,'84737','Leeds','',''),(21716,'84737','Virgin','',''),(21717,'84737','Washington','',''),(21718,'84738','St. George','',''),(21719,'84738','Santa Clara','',''),(21720,'84743','Circleville','',''),(21721,'84745','Toquerville','',''),(21722,'84745','Virgin','',''),(21723,'84746','Hurricane','',''),(21724,'84746','Toquerville','',''),(21725,'84747','Lyman','',''),(21726,'84754','Richfield','',''),(21727,'84755','Orderville','',''),(21728,'84761','Paragonah','',''),(21729,'84761','Summit','',''),(21730,'84764','Bryce Canyon City','',''),(21731,'84765','Ivins','',''),(21732,'84765','St. George','',''),(21733,'84767','Rockville','',''),(21734,'84770','Ivins','',''),(21735,'84770','St. George','',''),(21736,'84770','Santa Clara','',''),(21737,'84770','Washington','',''),(21738,'84774','Hurricane','',''),(21739,'84774','La Verkin','',''),(21740,'84776','Cannonville','',''),(21741,'84779','Hurricane','',''),(21742,'84780','St. George','',''),(21743,'84783','Ivins','',''),(21744,'84790','St. George','',''),(21745,'84790','Washington','',''),(21746,'85008','Scottsdale','',''),(21747,'85008','Tempe','',''),(21748,'85016','Paradise Valley','',''),(21749,'85018','Paradise Valley','',''),(21750,'85018','Scottsdale','',''),(21751,'85028','Paradise Valley','',''),(21752,'85031','Glendale','',''),(21753,'85033','Glendale','',''),(21754,'85034','Tempe','',''),(21755,'85037','Avondale','',''),(21756,'85037','Glendale','',''),(21757,'85040','Tempe','',''),(21758,'85044','Chandler','',''),(21759,'85044','Tempe','',''),(21760,'85054','Scottsdale','',''),(21761,'85085','New River','',''),(21762,'85086','Anthem','',''),(21763,'85086','New River','',''),(21764,'85087','Phoenix','',''),(21765,'85118','Gold Canyon','',''),(21766,'85119','Gold Canyon','',''),(21767,'85120','Mesa','',''),(21768,'85121','Casa Blanca','',''),(21769,'85123','Eloy','',''),(21770,'85128','Florence','',''),(21771,'85131','Casa Grande','',''),(21772,'85131','Picacho','',''),(21773,'85131','Red Rock','',''),(21774,'85132','Coolidge','',''),(21775,'85137','Hayden','',''),(21776,'85139','Goodyear','',''),(21777,'85140','Queen Creek','',''),(21778,'85141','Eloy','',''),(21779,'85142','Gilbert','',''),(21780,'85142','Mesa','',''),(21781,'85142','San Tan Valley','',''),(21782,'85143','San Tan Valley','',''),(21783,'85172','Casa Grande','',''),(21784,'85192','Dudleyville','',''),(21785,'85192','Hayden','',''),(21786,'85193','Arizona City','',''),(21787,'85193','Eloy','',''),(21788,'85194','Coolidge','',''),(21789,'85194','Eloy','',''),(21790,'85201','Tempe','',''),(21791,'85202','Tempe','',''),(21792,'85204','Gilbert','',''),(21793,'85206','Gilbert','',''),(21794,'85209','Gilbert','',''),(21795,'85212','Gilbert','',''),(21796,'85225','Gilbert','',''),(21797,'85226','Phoenix','',''),(21798,'85226','Tempe','',''),(21799,'85233','Chandler','',''),(21800,'85233','Mesa','',''),(21801,'85234','Mesa','',''),(21802,'85249','Gilbert','',''),(21803,'85250','Paradise Valley','',''),(21804,'85251','Phoenix','',''),(21805,'85253','Phoenix','',''),(21806,'85253','Scottsdale','',''),(21807,'85254','Phoenix','',''),(21808,'85255','Phoenix','',''),(21809,'85255','Rio Verde','',''),(21810,'85259','Fountain Hills','',''),(21811,'85262','Carefree','',''),(21812,'85266','Carefree','',''),(21813,'85268','Scottsdale','',''),(21814,'85281','Mesa','',''),(21815,'85281','Phoenix','',''),(21816,'85281','Scottsdale','',''),(21817,'85282','Phoenix','',''),(21818,'85283','Chandler','',''),(21819,'85283','Mesa','',''),(21820,'85283','Phoenix','',''),(21821,'85284','Chandler','',''),(21822,'85286','Gilbert','',''),(21823,'85295','Chandler','',''),(21824,'85297','Chandler','',''),(21825,'85298','Chandler','',''),(21826,'85298','Queen Creek','',''),(21827,'85301','Phoenix','',''),(21828,'85302','Peoria','',''),(21829,'85302','Phoenix','',''),(21830,'85303','Peoria','',''),(21831,'85304','Phoenix','',''),(21832,'85305','Peoria','',''),(21833,'85305','Phoenix','',''),(21834,'85306','Peoria','',''),(21835,'85306','Phoenix','',''),(21836,'85307','El Mirage','',''),(21837,'85307','Peoria','',''),(21838,'85307','Phoenix','',''),(21839,'85308','Peoria','',''),(21840,'85308','Phoenix','',''),(21841,'85309','Glendale','',''),(21842,'85310','Peoria','',''),(21843,'85310','Phoenix','',''),(21844,'85322','Buckeye','',''),(21845,'85322','Gila Bend','',''),(21846,'85323','Goodyear','',''),(21847,'85325','Parker','',''),(21848,'85326','Gila Bend','',''),(21849,'85326','Goodyear','',''),(21850,'85331','Carefree','',''),(21851,'85331','New River','',''),(21852,'85331','Phoenix','',''),(21853,'85331','Scottsdale','',''),(21854,'85334','Cibola','',''),(21855,'85335','Glendale','',''),(21856,'85337','Buckeye','',''),(21857,'85338','Avondale','',''),(21858,'85338','Buckeye','',''),(21859,'85339','Phoenix','',''),(21860,'85340','Avondale','',''),(21861,'85340','Buckeye','',''),(21862,'85340','Glendale','',''),(21863,'85340','Goodyear','',''),(21864,'85340','Phoenix','',''),(21865,'85342','Buckeye','',''),(21866,'85342','Peoria','',''),(21867,'85342','Surprise','',''),(21868,'85342','Wickenburg','',''),(21869,'85343','Buckeye','',''),(21870,'85345','Glendale','',''),(21871,'85345','Sun City','',''),(21872,'85346','Ehrenberg','',''),(21873,'85346','Parker','',''),(21874,'85347','Dateland','',''),(21875,'85347','Tacna','',''),(21876,'85348','Bouse','',''),(21877,'85350','Gadsden','',''),(21878,'85350','San Luis','',''),(21879,'85350','Yuma','',''),(21880,'85351','Peoria','',''),(21881,'85351','Youngtown','',''),(21882,'85353','Avondale','',''),(21883,'85353','Phoenix','',''),(21884,'85354','Buckeye','',''),(21885,'85355','Glendale','',''),(21886,'85355','Surprise','',''),(21887,'85356','Tacna','',''),(21888,'85357','Salome','',''),(21889,'85361','Buckeye','',''),(21890,'85361','Peoria','',''),(21891,'85361','Surprise','',''),(21892,'85363','El Mirage','',''),(21893,'85365','Fortuna Foothills','',''),(21894,'85365','Somerton','',''),(21895,'85367','Fortuna Foothills','',''),(21896,'85373','Peoria','',''),(21897,'85373','Surprise','',''),(21898,'85374','Sun City','',''),(21899,'85374','Sun City West','',''),(21900,'85375','Surprise','',''),(21901,'85379','El Mirage','',''),(21902,'85381','Glendale','',''),(21903,'85381','Sun City','',''),(21904,'85382','Glendale','',''),(21905,'85383','Glendale','',''),(21906,'85383','Phoenix','',''),(21907,'85383','Surprise','',''),(21908,'85387','Peoria','',''),(21909,'85390','Buckeye','',''),(21910,'85392','Goodyear','',''),(21911,'85392','Phoenix','',''),(21912,'85395','Avondale','',''),(21913,'85396','Surprise','',''),(21914,'85531','Thatcher','',''),(21915,'85539','Globe','',''),(21916,'85540','Clifton','',''),(21917,'85543','Central','',''),(21918,'85546','Solomon','',''),(21919,'85546','Thatcher','',''),(21920,'85552','Safford','',''),(21921,'85603','Naco','',''),(21922,'85607','Pirtleville','',''),(21923,'85611','Sierra Vista','',''),(21924,'85613','Sierra Vista','',''),(21925,'85614','Sahuarita','',''),(21926,'85615','Sierra Vista Southeast','',''),(21927,'85616','Sierra Vista','',''),(21928,'85616','Whetstone','',''),(21929,'85619','Summerhaven','',''),(21930,'85621','Rio Rico','',''),(21931,'85623','Mammoth','',''),(21932,'85623','Saddlebrooke','',''),(21933,'85627','Benson','',''),(21934,'85629','Tucson','',''),(21935,'85630','Benson','',''),(21936,'85630','St. David','',''),(21937,'85631','Oracle','',''),(21938,'85635','Sierra Vista Southeast','',''),(21939,'85640','Rio Rico','',''),(21940,'85640','Tubac','',''),(21941,'85640','Tumacacori-carmen','',''),(21942,'85641','Tucson','',''),(21943,'85645','Arivaca Junction','',''),(21944,'85645','Green Valley','',''),(21945,'85646','Rio Rico','',''),(21946,'85646','Tumacacori-carmen','',''),(21947,'85648','Tumacacori-carmen','',''),(21948,'85650','Sierra Vista Southeast','',''),(21949,'85653','Rillito','',''),(21950,'85658','Red Rock','',''),(21951,'85704','Casas Adobes','',''),(21952,'85704','Catalina Foothills','',''),(21953,'85704','Oro Valley','',''),(21954,'85712','Catalina Foothills','',''),(21955,'85713','Tucson Estates','',''),(21956,'85715','Catalina Foothills','',''),(21957,'85716','Catalina Foothills','',''),(21958,'85718','Casas Adobes','',''),(21959,'85718','Catalina Foothills','',''),(21960,'85718','Oro Valley','',''),(21961,'85735','Three Points','',''),(21962,'85735','Tucson Estates','',''),(21963,'85736','Three Points','',''),(21964,'85737','Casas Adobes','',''),(21965,'85737','Oro Valley','',''),(21966,'85739','Oro Valley','',''),(21967,'85739','Saddlebrooke','',''),(21968,'85741','Casas Adobes','',''),(21969,'85741','Marana','',''),(21970,'85742','Casas Adobes','',''),(21971,'85742','Marana','',''),(21972,'85742','Oro Valley','',''),(21973,'85743','Marana','',''),(21974,'85746','Drexel Heights','',''),(21975,'85747','Vail','',''),(21976,'85748','Tanque Verde','',''),(21977,'85749','Catalina Foothills','',''),(21978,'85749','Tanque Verde','',''),(21979,'85750','Catalina Foothills','',''),(21980,'85755','Marana','',''),(21981,'85755','Oro Valley','',''),(21982,'85757','Drexel Heights','',''),(21983,'85757','Valencia West','',''),(21984,'85901','Taylor','',''),(21985,'85923','Pinedale','',''),(21986,'85925','Springerville','',''),(21987,'85928','Heber-overgaard','',''),(21988,'85929','Lake Of The Woods','',''),(21989,'85929','Pinetop-lakeside','',''),(21990,'85929','Show Low','',''),(21991,'85933','Heber-overgaard','',''),(21992,'85935','Mcnary','',''),(21993,'85935','Pinetop-lakeside','',''),(21994,'85936','St. Johns','',''),(21995,'85937','Taylor','',''),(21996,'85938','Eagar','',''),(21997,'86001','Parks','',''),(21998,'86004','Leupp','',''),(21999,'86023','Grand Canyon Village','',''),(22000,'86025','Sun Valley','',''),(22001,'86030','Hotevilla-bacavi','',''),(22002,'86032','Holbrook','',''),(22003,'86033','Dennehotso','',''),(22004,'86039','Second Mesa','',''),(22005,'86042','First Mesa','',''),(22006,'86042','Second Mesa','',''),(22007,'86046','Parks','',''),(22008,'86053','Kaibito','',''),(22009,'86303','Dewey-humboldt','',''),(22010,'86303','Prescott Valley','',''),(22011,'86305','Bagdad','',''),(22012,'86305','Paulden','',''),(22013,'86314','Chino Valley','',''),(22014,'86314','Prescott','',''),(22015,'86315','Chino Valley','',''),(22016,'86315','Prescott Valley','',''),(22017,'86323','Paulden','',''),(22018,'86323','Prescott','',''),(22019,'86325','Verde Village','',''),(22020,'86326','Camp Verde','',''),(22021,'86326','Clarkdale','',''),(22022,'86326','Verde Village','',''),(22023,'86327','Camp Verde','',''),(22024,'86327','Dewey-humboldt','',''),(22025,'86327','Prescott Valley','',''),(22026,'86329','Dewey-humboldt','',''),(22027,'86332','Wilhoit','',''),(22028,'86333','Cordes Lakes','',''),(22029,'86334','Chino Valley','',''),(22030,'86335','Lake Montezuma','',''),(22031,'86336','Munds Park','',''),(22032,'86351','Village Of Oak Creek (big Park)','',''),(22033,'86401','New Kingman-butler','',''),(22034,'86409','New Kingman-butler','',''),(22035,'86413','Oatman','',''),(22036,'86426','Bullhead City','',''),(22037,'86432','Beaver Dam','',''),(22038,'86436','Golden Shores','',''),(22039,'86440','Fort Mohave','',''),(22040,'86440','Golden Shores','',''),(22041,'86441','White Hills','',''),(22042,'86442','Fort Mohave','',''),(22043,'86445','White Hills','',''),(22044,'86507','Tsaile','',''),(22045,'86511','Window Rock','',''),(22046,'86512','Houck','',''),(22047,'87001','Placitas','',''),(22048,'87001','San Felipe Pueblo','',''),(22049,'87002','Jarales','',''),(22050,'87004','Rio Rancho','',''),(22051,'87005','Bluewater Village','',''),(22052,'87007','Paraje','',''),(22053,'87013','La Jara','',''),(22054,'87016','Torreon','',''),(22055,'87020','Bluewater Village','',''),(22056,'87020','Milan','',''),(22057,'87021','Grants','',''),(22058,'87022','Isleta Village Proper','',''),(22059,'87024','Ponderosa','',''),(22060,'87031','Belen','',''),(22061,'87031','Peralta','',''),(22062,'87034','Acomita Lake','',''),(22063,'87034','Skyline-ganipa','',''),(22064,'87036','Willard','',''),(22065,'87038','Laguna','',''),(22066,'87038','Paraje','',''),(22067,'87041','Peña Blanca','',''),(22068,'87042','Bosque Farms','',''),(22069,'87043','Bernalillo','',''),(22070,'87048','Albuquerque','',''),(22071,'87048','Rio Rancho','',''),(22072,'87049','Acomita Lake','',''),(22073,'87049','Cubero','',''),(22074,'87052','Peña Blanca','',''),(22075,'87053','Zia Pueblo','',''),(22076,'87072','Cochiti','',''),(22077,'87102','South Valley','',''),(22078,'87105','South Valley','',''),(22079,'87114','Rio Rancho','',''),(22080,'87117','Albuquerque','',''),(22081,'87121','Rio Rancho','',''),(22082,'87121','South Valley','',''),(22083,'87144','Bernalillo','',''),(22084,'87144','Corrales','',''),(22085,'87311','Gallup','',''),(22086,'87320','Nakaibito','',''),(22087,'87322','Gallup','',''),(22088,'87325','Nakaibito','',''),(22089,'87327','Zuni Pueblo','',''),(22090,'87401','Kirtland','',''),(22091,'87401','Upper Fruitland','',''),(22092,'87402','Flora Vista','',''),(22093,'87410','Farmington','',''),(22094,'87410','Flora Vista','',''),(22095,'87412','Navajo Dam','',''),(22096,'87415','Farmington','',''),(22097,'87416','Kirtland','',''),(22098,'87416','Upper Fruitland','',''),(22099,'87416','Waterflow','',''),(22100,'87506','Rio En Medio','',''),(22101,'87511','La Villita','',''),(22102,'87516','Cañones','',''),(22103,'87519','Questa','',''),(22104,'87529','Arroyo Seco','',''),(22105,'87531','Dixon','',''),(22106,'87553','Peñasco','',''),(22107,'87557','Taos','',''),(22108,'87560','Villanueva','',''),(22109,'87565','Rowe','',''),(22110,'87565','Soham','',''),(22111,'87566','Espanola','',''),(22112,'87567','Espanola','',''),(22113,'87571','Arroyo Seco','',''),(22114,'87574','Rio En Medio','',''),(22115,'87578','Cordova','',''),(22116,'87710','Eagle Nest','',''),(22117,'87711','Tecolotito','',''),(22118,'87740','Maxwell','',''),(22119,'87746','Mosquero','',''),(22120,'87823','Alamillo','',''),(22121,'87825','Alamo','',''),(22122,'87831','Alamillo','',''),(22123,'87901','Elephant Butte','',''),(22124,'87930','Hillsboro','',''),(22125,'87935','Truth Or Consequences','',''),(22126,'87942','Truth Or Consequences','',''),(22127,'88001','University Park','',''),(22128,'88002','White Sands','',''),(22129,'88003','University Park','',''),(22130,'88005','Mesilla','',''),(22131,'88005','University Park','',''),(22132,'88007','Doña Ana','',''),(22133,'88007','Mesilla','',''),(22134,'88008','Sunland Park','',''),(22135,'88012','Organ','',''),(22136,'88020','Cotton City','',''),(22137,'88021','Chamberino','',''),(22138,'88022','Santa Clara','',''),(22139,'88023','Santa Clara','',''),(22140,'88028','Gila','',''),(22141,'88032','Doña Ana','',''),(22142,'88033','Las Cruces','',''),(22143,'88041','Bayard','',''),(22144,'88041','Mimbres','',''),(22145,'88041','Santa Clara','',''),(22146,'88043','Bayard','',''),(22147,'88044','Chamberino','',''),(22148,'88048','Vado','',''),(22149,'88061','Arenas Valley','',''),(22150,'88061','Gila','',''),(22151,'88061','Pinos Altos','',''),(22152,'88061','Tyrone','',''),(22153,'88063','El Paso','',''),(22154,'88101','Cannon Afb','',''),(22155,'88130','Dora','',''),(22156,'88132','Causey','',''),(22157,'88240','North Hobbs','',''),(22158,'88242','North Hobbs','',''),(22159,'88310','Boles Acres','',''),(22160,'88310','Holloman Afb','',''),(22161,'88310','La Luz','',''),(22162,'88311','Boles Acres','',''),(22163,'88312','Ruidoso','',''),(22164,'88317','High Rolls','',''),(22165,'88325','High Rolls','',''),(22166,'88330','Holloman Afb','',''),(22167,'88338','Ruidoso','',''),(22168,'88339','Sacramento','',''),(22169,'88339','Weed','',''),(22170,'88340','Bent','',''),(22171,'88345','Ruidoso Downs','',''),(22172,'88346','Ruidoso','',''),(22173,'88352','Holloman Afb','',''),(22174,'88418','Capulin','',''),(22175,'89001','Hiko','',''),(22176,'89005','Henderson','',''),(22177,'89007','Mesquite','',''),(22178,'89011','Whitney','',''),(22179,'89014','Paradise','',''),(22180,'89019','Sandy Valley','',''),(22181,'89021','Moapa Valley','',''),(22182,'89025','Moapa Town','',''),(22183,'89030','Las Vegas','',''),(22184,'89039','Cal-nev-ari','',''),(22185,'89040','Moapa Valley','',''),(22186,'89044','Enterprise','',''),(22187,'89046','Boulder City','',''),(22188,'89047','Silver Peak','',''),(22189,'89052','Enterprise','',''),(22190,'89052','Paradise','',''),(22191,'89054','Enterprise','',''),(22192,'89074','Paradise','',''),(22193,'89101','Sunrise Manor','',''),(22194,'89102','Paradise','',''),(22195,'89102','Spring Valley','',''),(22196,'89103','Paradise','',''),(22197,'89103','Spring Valley','',''),(22198,'89104','Sunrise Manor','',''),(22199,'89104','Winchester','',''),(22200,'89106','North Las Vegas','',''),(22201,'89109','Paradise','',''),(22202,'89109','Winchester','',''),(22203,'89110','Sunrise Manor','',''),(22204,'89113','Enterprise','',''),(22205,'89113','Spring Valley','',''),(22206,'89115','Nellis Afb','',''),(22207,'89115','North Las Vegas','',''),(22208,'89115','Sunrise Manor','',''),(22209,'89117','Spring Valley','',''),(22210,'89118','Enterprise','',''),(22211,'89118','Paradise','',''),(22212,'89118','Spring Valley','',''),(22213,'89119','Enterprise','',''),(22214,'89119','Paradise','',''),(22215,'89120','Henderson','',''),(22216,'89120','Paradise','',''),(22217,'89121','Paradise','',''),(22218,'89121','Sunrise Manor','',''),(22219,'89121','Whitney','',''),(22220,'89121','Winchester','',''),(22221,'89122','Henderson','',''),(22222,'89122','Sunrise Manor','',''),(22223,'89122','Whitney','',''),(22224,'89123','Enterprise','',''),(22225,'89123','Henderson','',''),(22226,'89123','Paradise','',''),(22227,'89124','Indian Springs','',''),(22228,'89130','North Las Vegas','',''),(22229,'89135','Summerlin South','',''),(22230,'89139','Enterprise','',''),(22231,'89141','Enterprise','',''),(22232,'89142','Sunrise Manor','',''),(22233,'89146','Spring Valley','',''),(22234,'89147','Spring Valley','',''),(22235,'89147','Summerlin South','',''),(22236,'89148','Enterprise','',''),(22237,'89148','Spring Valley','',''),(22238,'89156','Sunrise Manor','',''),(22239,'89161','Enterprise','',''),(22240,'89169','Paradise','',''),(22241,'89169','Winchester','',''),(22242,'89178','Enterprise','',''),(22243,'89179','Enterprise','',''),(22244,'89183','Enterprise','',''),(22245,'89183','Henderson','',''),(22246,'89183','Paradise','',''),(22247,'89191','North Las Vegas','',''),(22248,'89301','Mcgill','',''),(22249,'89318','Mcgill','',''),(22250,'89405','Gerlach','',''),(22251,'89410','Gardnerville Ranchos','',''),(22252,'89411','Kingsbury','',''),(22253,'89413','Lakeridge','',''),(22254,'89421','Fort Mcdermitt','',''),(22255,'89423','Gardnerville','',''),(22256,'89423','Genoa','',''),(22257,'89423','Indian Hills','',''),(22258,'89423','Johnson Lane','',''),(22259,'89428','Dayton','',''),(22260,'89430','Smith Valley','',''),(22261,'89431','Reno','',''),(22262,'89433','Reno','',''),(22263,'89433','Sparks','',''),(22264,'89436','Spanish Springs','',''),(22265,'89439','Reno','',''),(22266,'89441','Spanish Springs','',''),(22267,'89442','Sparks','',''),(22268,'89444','Smith Valley','',''),(22269,'89444','Topaz Ranch Estates','',''),(22270,'89448','Round Hill Village','',''),(22271,'89449','Kingsbury','',''),(22272,'89460','Gardnerville Ranchos','',''),(22273,'89508','Cold Springs','',''),(22274,'89508','Reno','',''),(22275,'89510','Nixon','',''),(22276,'89510','Spanish Springs','',''),(22277,'89511','Incline Village','',''),(22278,'89512','Sparks','',''),(22279,'89523','Verdi','',''),(22280,'89701','Carson','',''),(22281,'89702','Carson','',''),(22282,'89703','Carson','',''),(22283,'89705','Carson','',''),(22284,'89705','Indian Hills','',''),(22285,'89706','Carson','',''),(22286,'89831','Owyhee','',''),(22287,'90001','Florence-graham','',''),(22288,'90001','Huntington Park','',''),(22289,'90002','Florence-graham','',''),(22290,'90002','Lynwood','',''),(22291,'90008','Ladera Heights','',''),(22292,'90016','Culver City','',''),(22293,'90022','Commerce','',''),(22294,'90022','East Los Angeles','',''),(22295,'90022','Montebello','',''),(22296,'90022','Monterey Park','',''),(22297,'90023','Commerce','',''),(22298,'90023','East Los Angeles','',''),(22299,'90032','East Los Angeles','',''),(22300,'90035','Beverly Hills','',''),(22301,'90038','West Hollywood','',''),(22302,'90039','Glendale','',''),(22303,'90040','Bell Gardens','',''),(22304,'90040','Commerce','',''),(22305,'90040','East Los Angeles','',''),(22306,'90042','Pasadena','',''),(22307,'90042','South Pasadena','',''),(22308,'90045','Inglewood','',''),(22309,'90045','Ladera Heights','',''),(22310,'90046','West Hollywood','',''),(22311,'90048','West Hollywood','',''),(22312,'90056','Ladera Heights','',''),(22313,'90058','Commerce','',''),(22314,'90058','Florence-graham','',''),(22315,'90058','Huntington Park','',''),(22316,'90058','Maywood','',''),(22317,'90059','Compton','',''),(22318,'90059','Lynwood','',''),(22319,'90059','Willowbrook','',''),(22320,'90061','Willowbrook','',''),(22321,'90063','East Los Angeles','',''),(22322,'90066','Culver City','',''),(22323,'90069','Los Angeles','',''),(22324,'90090','Los Angeles','',''),(22325,'90201','Bell Gardens','',''),(22326,'90210','Los Angeles','',''),(22327,'90210','West Hollywood','',''),(22328,'90212','Los Angeles','',''),(22329,'90220','Carson','',''),(22330,'90221','Paramount','',''),(22331,'90222','Lynwood','',''),(22332,'90222','Willowbrook','',''),(22333,'90230','Ladera Heights','',''),(22334,'90230','Los Angeles','',''),(22335,'90232','Los Angeles','',''),(22336,'90241','Santa Fe Springs','',''),(22337,'90247','Los Angeles','',''),(22338,'90247','Torrance','',''),(22339,'90248','Carson','',''),(22340,'90248','Los Angeles','',''),(22341,'90248','Torrance','',''),(22342,'90249','Hawthorne','',''),(22343,'90250','Inglewood','',''),(22344,'90250','Lawndale','',''),(22345,'90254','Manhattan Beach','',''),(22346,'90255','Florence-graham','',''),(22347,'90255','Maywood','',''),(22348,'90260','Hawthorne','',''),(22349,'90262','Compton','',''),(22350,'90262','Paramount','',''),(22351,'90265','Topanga','',''),(22352,'90270','Commerce','',''),(22353,'90272','Los Angeles','',''),(22354,'90274','Palos Verdes Estates','',''),(22355,'90274','Rancho Palos Verdes','',''),(22356,'90275','Los Angeles','',''),(22357,'90277','Torrance','',''),(22358,'90278','Torrance','',''),(22359,'90280','Lynwood','',''),(22360,'90290','Calabasas','',''),(22361,'90290','Los Angeles','',''),(22362,'90290','Malibu','',''),(22363,'90291','Los Angeles','',''),(22364,'90291','Santa Monica','',''),(22365,'90292','Culver City','',''),(22366,'90292','Los Angeles','',''),(22367,'90293','Los Angeles','',''),(22368,'90303','Hawthorne','',''),(22369,'90304','Hawthorne','',''),(22370,'90304','Lennox','',''),(22371,'90402','Los Angeles','',''),(22372,'90405','Los Angeles','',''),(22373,'90501','Lomita','',''),(22374,'90501','Los Angeles','',''),(22375,'90501','West Carson','',''),(22376,'90502','Los Angeles','',''),(22377,'90502','West Carson','',''),(22378,'90504','Lawndale','',''),(22379,'90601','Pico Rivera','',''),(22380,'90601','West Whittier-los Nietos','',''),(22381,'90602','South Whittier','',''),(22382,'90604','La Mirada','',''),(22383,'90604','South Whittier','',''),(22384,'90605','Santa Fe Springs','',''),(22385,'90605','South Whittier','',''),(22386,'90606','Pico Rivera','',''),(22387,'90606','Santa Fe Springs','',''),(22388,'90606','West Whittier-los Nietos','',''),(22389,'90620','Anaheim','',''),(22390,'90620','Cypress','',''),(22391,'90621','Anaheim','',''),(22392,'90621','Fullerton','',''),(22393,'90623','Buena Park','',''),(22394,'90623','Cerritos','',''),(22395,'90630','Buena Park','',''),(22396,'90630','Hawaiian Gardens','',''),(22397,'90630','La Palma','',''),(22398,'90630','Los Alamitos','',''),(22399,'90631','Brea','',''),(22400,'90631','Fullerton','',''),(22401,'90631','Hacienda Heights','',''),(22402,'90631','Rowland Heights','',''),(22403,'90631','Whittier','',''),(22404,'90638','South Whittier','',''),(22405,'90640','Commerce','',''),(22406,'90640','East Los Angeles','',''),(22407,'90640','Pico Rivera','',''),(22408,'90640','Rosemead','',''),(22409,'90650','Downey','',''),(22410,'90650','Santa Fe Springs','',''),(22411,'90670','Downey','',''),(22412,'90670','Norwalk','',''),(22413,'90670','Whittier','',''),(22414,'90680','Cypress','',''),(22415,'90680','Garden Grove','',''),(22416,'90701','Cerritos','',''),(22417,'90703','Lakewood','',''),(22418,'90703','Norwalk','',''),(22419,'90703','Santa Fe Springs','',''),(22420,'90710','Lomita','',''),(22421,'90710','Los Angeles','',''),(22422,'90710','West Carson','',''),(22423,'90713','Long Beach','',''),(22424,'90717','Los Angeles','',''),(22425,'90717','Torrance','',''),(22426,'90720','Cypress','',''),(22427,'90720','Seal Beach','',''),(22428,'90723','Bellflower','',''),(22429,'90731','Long Beach','',''),(22430,'90731','Los Angeles','',''),(22431,'90732','Lomita','',''),(22432,'90732','Los Angeles','',''),(22433,'90740','Huntington Beach','',''),(22434,'90740','Long Beach','',''),(22435,'90740','Los Alamitos','',''),(22436,'90740','Westminster','',''),(22437,'90743','Seal Beach','',''),(22438,'90744','Carson','',''),(22439,'90744','Los Angeles','',''),(22440,'90745','Los Angeles','',''),(22441,'90755','Long Beach','',''),(22442,'90804','Signal Hill','',''),(22443,'90805','Compton','',''),(22444,'90805','Lakewood','',''),(22445,'90806','Signal Hill','',''),(22446,'90807','Lakewood','',''),(22447,'90810','Carson','',''),(22448,'90810','Los Angeles','',''),(22449,'90813','Los Angeles','',''),(22450,'90815','Los Alamitos','',''),(22451,'91001','Pasadena','',''),(22452,'91006','El Monte','',''),(22453,'91006','Monrovia','',''),(22454,'91007','East San Gabriel','',''),(22455,'91007','Temple City','',''),(22456,'91008','Bradbury','',''),(22457,'91010','Azusa','',''),(22458,'91011','Glendale','',''),(22459,'91011','La Cañada Flintridge','',''),(22460,'91011','La Crescenta-montrose','',''),(22461,'91011','Pasadena','',''),(22462,'91016','Duarte','',''),(22463,'91020','Glendale','',''),(22464,'91020','La Cañada Flintridge','',''),(22465,'91020','La Crescenta-montrose','',''),(22466,'91030','Alhambra','',''),(22467,'91030','Los Angeles','',''),(22468,'91040','Los Angeles','',''),(22469,'91042','Los Angeles','',''),(22470,'91046','Glendale','',''),(22471,'91103','La Cañada Flintridge','',''),(22472,'91104','Altadena','',''),(22473,'91105','Los Angeles','',''),(22474,'91107','Altadena','',''),(22475,'91108','Pasadena','',''),(22476,'91206','La Cañada Flintridge','',''),(22477,'91214','Glendale','',''),(22478,'91214','La Cañada Flintridge','',''),(22479,'91214','La Crescenta-montrose','',''),(22480,'91214','Los Angeles','',''),(22481,'91301','Calabasas','',''),(22482,'91302','Topanga','',''),(22483,'91303','Los Angeles','',''),(22484,'91304','Los Angeles','',''),(22485,'91306','Los Angeles','',''),(22486,'91307','Los Angeles','',''),(22487,'91311','Los Angeles','',''),(22488,'91316','Los Angeles','',''),(22489,'91320','Thousand Oaks','',''),(22490,'91321','Santa Clarita','',''),(22491,'91324','Los Angeles','',''),(22492,'91325','Los Angeles','',''),(22493,'91326','Los Angeles','',''),(22494,'91330','Los Angeles','',''),(22495,'91331','Los Angeles','',''),(22496,'91335','Los Angeles','',''),(22497,'91340','Los Angeles','',''),(22498,'91342','Los Angeles','',''),(22499,'91342','San Fernando','',''),(22500,'91343','Los Angeles','',''),(22501,'91344','Los Angeles','',''),(22502,'91345','Los Angeles','',''),(22503,'91351','Santa Clarita','',''),(22504,'91352','Los Angeles','',''),(22505,'91354','Santa Clarita','',''),(22506,'91355','Santa Clarita','',''),(22507,'91356','Los Angeles','',''),(22508,'91361','Thousand Oaks','',''),(22509,'91362','Simi Valley','',''),(22510,'91364','Los Angeles','',''),(22511,'91364','Topanga','',''),(22512,'91367','Los Angeles','',''),(22513,'91371','Los Angeles','',''),(22514,'91381','Santa Clarita','',''),(22515,'91387','Santa Clarita','',''),(22516,'91390','Acton','',''),(22517,'91390','Palmdale','',''),(22518,'91401','Los Angeles','',''),(22519,'91402','Los Angeles','',''),(22520,'91403','Los Angeles','',''),(22521,'91405','Los Angeles','',''),(22522,'91406','Los Angeles','',''),(22523,'91411','Los Angeles','',''),(22524,'91423','Los Angeles','',''),(22525,'91436','Los Angeles','',''),(22526,'91504','Los Angeles','',''),(22527,'91505','Los Angeles','',''),(22528,'91601','Los Angeles','',''),(22529,'91602','Los Angeles','',''),(22530,'91604','Los Angeles','',''),(22531,'91605','Burbank','',''),(22532,'91605','Los Angeles','',''),(22533,'91606','Los Angeles','',''),(22534,'91607','Los Angeles','',''),(22535,'91608','Los Angeles','',''),(22536,'91701','Upland','',''),(22537,'91702','Glendora','',''),(22538,'91706','West Covina','',''),(22539,'91706','West Puente Valley','',''),(22540,'91709','Chino','',''),(22541,'91710','Chino Hills','',''),(22542,'91710','Montclair','',''),(22543,'91710','Ontario','',''),(22544,'91711','Pomona','',''),(22545,'91722','West Covina','',''),(22546,'91723','West Covina','',''),(22547,'91724','San Dimas','',''),(22548,'91724','Walnut','',''),(22549,'91724','West Covina','',''),(22550,'91731','Temple City','',''),(22551,'91732','Arcadia','',''),(22552,'91733','El Monte','',''),(22553,'91733','Pico Rivera','',''),(22554,'91733','Rosemead','',''),(22555,'91733','Whittier','',''),(22556,'91739','Fontana','',''),(22557,'91740','San Dimas','',''),(22558,'91744','West Covina','',''),(22559,'91744','West Puente Valley','',''),(22560,'91745','Whittier','',''),(22561,'91746','Baldwin Park','',''),(22562,'91746','Hacienda Heights','',''),(22563,'91746','West Covina','',''),(22564,'91746','West Puente Valley','',''),(22565,'91748','Hacienda Heights','',''),(22566,'91750','Claremont','',''),(22567,'91750','Pomona','',''),(22568,'91750','San Dimas','',''),(22569,'91752','Eastvale','',''),(22570,'91752','Norco','',''),(22571,'91754','East Los Angeles','',''),(22572,'91762','Chino','',''),(22573,'91762','Montclair','',''),(22574,'91765','Pomona','',''),(22575,'91767','La Verne','',''),(22576,'91768','Diamond Bar','',''),(22577,'91768','San Dimas','',''),(22578,'91768','Walnut','',''),(22579,'91770','El Monte','',''),(22580,'91770','Montebello','',''),(22581,'91773','Covina','',''),(22582,'91773','Glendora','',''),(22583,'91773','La Verne','',''),(22584,'91773','Pomona','',''),(22585,'91775','East San Gabriel','',''),(22586,'91775','Temple City','',''),(22587,'91776','Alhambra','',''),(22588,'91776','Rosemead','',''),(22589,'91776','Temple City','',''),(22590,'91780','Arcadia','',''),(22591,'91780','East San Gabriel','',''),(22592,'91780','El Monte','',''),(22593,'91789','Diamond Bar','',''),(22594,'91789','Pomona','',''),(22595,'91789','Rowland Heights','',''),(22596,'91789','West Covina','',''),(22597,'91791','Covina','',''),(22598,'91801','San Gabriel','',''),(22599,'91803','Monterey Park','',''),(22600,'91901','Descanso','',''),(22601,'91902','Chula Vista','',''),(22602,'91902','La Presa','',''),(22603,'91902','National City','',''),(22604,'91910','Bonita','',''),(22605,'91911','San Diego','',''),(22606,'91914','San Diego','',''),(22607,'91915','San Diego','',''),(22608,'91932','Coronado','',''),(22609,'91932','San Diego','',''),(22610,'91941','El Cajon','',''),(22611,'91941','Lemon Grove','',''),(22612,'91941','Rancho San Diego','',''),(22613,'91941','Spring Valley','',''),(22614,'91942','San Diego','',''),(22615,'91945','La Presa','',''),(22616,'91945','San Diego','',''),(22617,'91945','Spring Valley','',''),(22618,'91948','Pine Valley','',''),(22619,'91950','Chula Vista','',''),(22620,'91950','San Diego','',''),(22621,'91977','La Presa','',''),(22622,'91977','Lemon Grove','',''),(22623,'91978','Jamul','',''),(22624,'92003','Oceanside','',''),(22625,'92007','Encinitas','',''),(22626,'92008','Oceanside','',''),(22627,'92009','Encinitas','',''),(22628,'92009','San Marcos','',''),(22629,'92010','Oceanside','',''),(22630,'92014','San Diego','',''),(22631,'92014','Solana Beach','',''),(22632,'92019','Alpine','',''),(22633,'92019','Jamul','',''),(22634,'92019','Rancho San Diego','',''),(22635,'92020','La Mesa','',''),(22636,'92020','Rancho San Diego','',''),(22637,'92020','Santee','',''),(22638,'92021','Lakeside','',''),(22639,'92021','Santee','',''),(22640,'92024','Carlsbad','',''),(22641,'92024','San Marcos','',''),(22642,'92025','Poway','',''),(22643,'92025','San Diego','',''),(22644,'92026','Bonsall','',''),(22645,'92027','San Diego','',''),(22646,'92028','Oceanside','',''),(22647,'92029','San Diego','',''),(22648,'92029','San Marcos','',''),(22649,'92037','San Diego','',''),(22650,'92040','Santee','',''),(22651,'92056','Carlsbad','',''),(22652,'92056','Vista','',''),(22653,'92064','San Diego','',''),(22654,'92065','Poway','',''),(22655,'92065','San Diego','',''),(22656,'92067','Encinitas','',''),(22657,'92067','Fairbanks Ranch','',''),(22658,'92067','San Diego','',''),(22659,'92069','Escondido','',''),(22660,'92071','El Cajon','',''),(22661,'92071','San Diego','',''),(22662,'92075','Encinitas','',''),(22663,'92075','San Diego','',''),(22664,'92078','Carlsbad','',''),(22665,'92078','Escondido','',''),(22666,'92078','Vista','',''),(22667,'92081','Carlsbad','',''),(22668,'92081','Oceanside','',''),(22669,'92082','Escondido','',''),(22670,'92083','Oceanside','',''),(22671,'92084','Bonsall','',''),(22672,'92084','San Marcos','',''),(22673,'92091','Encinitas','',''),(22674,'92091','Fairbanks Ranch','',''),(22675,'92115','Lemon Grove','',''),(22676,'92118','San Diego','',''),(22677,'92120','La Mesa','',''),(22678,'92127','Fairbanks Ranch','',''),(22679,'92128','Poway','',''),(22680,'92130','Fairbanks Ranch','',''),(22681,'92131','Poway','',''),(22682,'92135','Coronado','',''),(22683,'92139','Bonita','',''),(22684,'92139','La Presa','',''),(22685,'92139','National City','',''),(22686,'92154','Chula Vista','',''),(22687,'92154','Imperial Beach','',''),(22688,'92155','Coronado','',''),(22689,'92173','San Diego','',''),(22690,'92201','La Quinta','',''),(22691,'92203','La Quinta','',''),(22692,'92203','Palm Desert','',''),(22693,'92210','La Quinta','',''),(22694,'92210','Palm Desert','',''),(22695,'92211','Indian Wells','',''),(22696,'92211','Indio','',''),(22697,'92211','Thousand Palms','',''),(22698,'92223','Banning','',''),(22699,'92223','Calimesa','',''),(22700,'92230','Banning','',''),(22701,'92230','Whitewater','',''),(22702,'92234','Palm Springs','',''),(22703,'92234','Rancho Mirage','',''),(22704,'92236','Indio','',''),(22705,'92240','Palm Springs','',''),(22706,'92241','Cathedral City','',''),(22707,'92241','Desert Edge','',''),(22708,'92241','Indio','',''),(22709,'92241','Palm Springs','',''),(22710,'92241','Thousand Palms','',''),(22711,'92242','Big River','',''),(22712,'92243','Imperial','',''),(22713,'92243','Seeley','',''),(22714,'92249','Calexico','',''),(22715,'92251','El Centro','',''),(22716,'92252','Yucca Valley','',''),(22717,'92253','Indio','',''),(22718,'92258','Palm Springs','',''),(22719,'92264','Cathedral City','',''),(22720,'92270','Cathedral City','',''),(22721,'92270','Palm Desert','',''),(22722,'92274','Coachella','',''),(22723,'92274','La Quinta','',''),(22724,'92274','Mecca','',''),(22725,'92274','Oasis','',''),(22726,'92274','Salton City','',''),(22727,'92276','Cathedral City','',''),(22728,'92282','Desert Hot Springs','',''),(22729,'92282','Palm Springs','',''),(22730,'92282','Whitewater','',''),(22731,'92284','Homestead Valley','',''),(22732,'92284','Joshua Tree','',''),(22733,'92285','Homestead Valley','',''),(22734,'92301','Victorville','',''),(22735,'92307','Lucerne Valley','',''),(22736,'92307','Victorville','',''),(22737,'92308','Hesperia','',''),(22738,'92308','Lucerne Valley','',''),(22739,'92313','Colton','',''),(22740,'92315','Big Bear City','',''),(22741,'92316','Colton','',''),(22742,'92316','Fontana','',''),(22743,'92316','Rialto','',''),(22744,'92320','Beaumont','',''),(22745,'92321','Lake Arrowhead','',''),(22746,'92322','Crestline','',''),(22747,'92324','Grand Terrace','',''),(22748,'92324','Loma Linda','',''),(22749,'92324','San Bernardino','',''),(22750,'92327','Barstow','',''),(22751,'92335','Bloomington','',''),(22752,'92335','Rialto','',''),(22753,'92336','Rancho Cucamonga','',''),(22754,'92336','Rialto','',''),(22755,'92342','Silver Lakes','',''),(22756,'92344','Phelan','',''),(22757,'92344','Victorville','',''),(22758,'92345','Apple Valley','',''),(22759,'92346','Redlands','',''),(22760,'92346','San Bernardino','',''),(22761,'92347','Barstow','',''),(22762,'92354','Redlands','',''),(22763,'92354','San Bernardino','',''),(22764,'92359','Highland','',''),(22765,'92359','Redlands','',''),(22766,'92359','Yucaipa','',''),(22767,'92368','Adelanto','',''),(22768,'92368','Victorville','',''),(22769,'92371','Adelanto','',''),(22770,'92371','Piñon Hills','',''),(22771,'92371','Wrightwood','',''),(22772,'92372','Piñon Hills','',''),(22773,'92373','Calimesa','',''),(22774,'92373','Loma Linda','',''),(22775,'92373','Yucaipa','',''),(22776,'92374','Loma Linda','',''),(22777,'92374','Mentone','',''),(22778,'92374','Yucaipa','',''),(22779,'92376','Colton','',''),(22780,'92376','San Bernardino','',''),(22781,'92377','Fontana','',''),(22782,'92378','Lake Arrowhead','',''),(22783,'92385','Lake Arrowhead','',''),(22784,'92386','Big Bear City','',''),(22785,'92389','Shoshone','',''),(22786,'92391','Crestline','',''),(22787,'92391','Lake Arrowhead','',''),(22788,'92392','Hesperia','',''),(22789,'92392','Phelan','',''),(22790,'92394','Adelanto','',''),(22791,'92395','Apple Valley','',''),(22792,'92397','Piñon Hills','',''),(22793,'92399','Redlands','',''),(22794,'92404','Crestline','',''),(22795,'92404','Highland','',''),(22796,'92408','Colton','',''),(22797,'92408','Loma Linda','',''),(22798,'92410','Colton','',''),(22799,'92410','Highland','',''),(22800,'92410','Rialto','',''),(22801,'92503','Corona','',''),(22802,'92504','Rubidoux','',''),(22803,'92505','Norco','',''),(22804,'92507','Moreno Valley','',''),(22805,'92508','Mead Valley','',''),(22806,'92508','Moreno Valley','',''),(22807,'92509','Mira Loma','',''),(22808,'92509','Rialto','',''),(22809,'92509','Rubidoux','',''),(22810,'92518','March Arb','',''),(22811,'92518','Moreno Valley','',''),(22812,'92518','Riverside','',''),(22813,'92530','Wildomar','',''),(22814,'92532','Canyon Lake','',''),(22815,'92532','Menifee','',''),(22816,'92543','East Hemet','',''),(22817,'92543','San Jacinto','',''),(22818,'92544','East Hemet','',''),(22819,'92544','San Jacinto','',''),(22820,'92545','Homeland','',''),(22821,'92549','Idyllwild-pine Cove','',''),(22822,'92553','March Arb','',''),(22823,'92553','Riverside','',''),(22824,'92557','Riverside','',''),(22825,'92561','Anza','',''),(22826,'92561','Idyllwild-pine Cove','',''),(22827,'92562','Temecula','',''),(22828,'92562','Wildomar','',''),(22829,'92563','French Valley','',''),(22830,'92563','Temecula','',''),(22831,'92567','San Jacinto','',''),(22832,'92570','Canyon Lake','',''),(22833,'92570','Lake Elsinore','',''),(22834,'92570','Mead Valley','',''),(22835,'92570','Menifee','',''),(22836,'92571','Mead Valley','',''),(22837,'92571','Moreno Valley','',''),(22838,'92582','Hemet','',''),(22839,'92583','Beaumont','',''),(22840,'92583','Hemet','',''),(22841,'92584','Lake Elsinore','',''),(22842,'92584','Murrieta','',''),(22843,'92584','Wildomar','',''),(22844,'92585','Menifee','',''),(22845,'92585','Nuevo','',''),(22846,'92585','Perris','',''),(22847,'92586','Menifee','',''),(22848,'92586','Perris','',''),(22849,'92587','Canyon Lake','',''),(22850,'92587','Lake Elsinore','',''),(22851,'92587','Menifee','',''),(22852,'92587','Perris','',''),(22853,'92590','Murrieta','',''),(22854,'92595','Lake Elsinore','',''),(22855,'92595','Murrieta','',''),(22856,'92596','French Valley','',''),(22857,'92596','Menifee','',''),(22858,'92596','Temecula','',''),(22859,'92602','Orange','',''),(22860,'92603','Laguna Beach','',''),(22861,'92606','Santa Ana','',''),(22862,'92606','Tustin','',''),(22863,'92610','Irvine','',''),(22864,'92610','Lake Forest','',''),(22865,'92612','Newport Beach','',''),(22866,'92614','Costa Mesa','',''),(22867,'92614','Santa Ana','',''),(22868,'92617','Newport Beach','',''),(22869,'92618','Lake Forest','',''),(22870,'92624','Dana Point','',''),(22871,'92624','San Clemente','',''),(22872,'92624','San Juan Capistrano','',''),(22873,'92625','Newport Beach','',''),(22874,'92627','Newport Beach','',''),(22875,'92629','Laguna Beach','',''),(22876,'92630','Irvine','',''),(22877,'92630','Mission Viejo','',''),(22878,'92637','Laguna Beach','',''),(22879,'92637','Laguna Hills','',''),(22880,'92637','Laguna Woods','',''),(22881,'92646','Costa Mesa','',''),(22882,'92647','Midway City','',''),(22883,'92647','Westminster','',''),(22884,'92649','Seal Beach','',''),(22885,'92649','Sunset Beach','',''),(22886,'92651','Aliso Viejo','',''),(22887,'92651','Dana Point','',''),(22888,'92651','Newport Beach','',''),(22889,'92653','Aliso Viejo','',''),(22890,'92653','Laguna Niguel','',''),(22891,'92653','Laguna Woods','',''),(22892,'92653','Mission Viejo','',''),(22893,'92655','Westminster','',''),(22894,'92656','Laguna Hills','',''),(22895,'92656','Laguna Niguel','',''),(22896,'92656','Laguna Woods','',''),(22897,'92657','Newport Beach','',''),(22898,'92660','Costa Mesa','',''),(22899,'92660','Irvine','',''),(22900,'92672','Dana Point','',''),(22901,'92673','San Juan Capistrano','',''),(22902,'92675','Dana Point','',''),(22903,'92675','Ladera Ranch','',''),(22904,'92675','Laguna Niguel','',''),(22905,'92675','Mission Viejo','',''),(22906,'92675','San Clemente','',''),(22907,'92676','Irvine','',''),(22908,'92676','Lake Forest','',''),(22909,'92676','Orange','',''),(22910,'92677','Aliso Viejo','',''),(22911,'92677','Dana Point','',''),(22912,'92677','Laguna Beach','',''),(22913,'92677','Laguna Hills','',''),(22914,'92677','Mission Viejo','',''),(22915,'92677','San Juan Capistrano','',''),(22916,'92678','Rancho Santa Margarita','',''),(22917,'92679','Coto De Caza','',''),(22918,'92679','Lake Forest','',''),(22919,'92679','Mission Viejo','',''),(22920,'92679','Rancho Santa Margarita','',''),(22921,'92683','Garden Grove','',''),(22922,'92683','Huntington Beach','',''),(22923,'92683','Midway City','',''),(22924,'92688','Coto De Caza','',''),(22925,'92688','Ladera Ranch','',''),(22926,'92688','Mission Viejo','',''),(22927,'92691','Laguna Hills','',''),(22928,'92691','Lake Forest','',''),(22929,'92692','Ladera Ranch','',''),(22930,'92692','Rancho Santa Margarita','',''),(22931,'92694','Mission Viejo','',''),(22932,'92701','Tustin','',''),(22933,'92703','Garden Grove','',''),(22934,'92704','Fountain Valley','',''),(22935,'92705','Orange','',''),(22936,'92705','Tustin','',''),(22937,'92706','Garden Grove','',''),(22938,'92708','Westminster','',''),(22939,'92780','Irvine','',''),(22940,'92780','Santa Ana','',''),(22941,'92782','Irvine','',''),(22942,'92782','Orange','',''),(22943,'92801','Buena Park','',''),(22944,'92801','Fullerton','',''),(22945,'92802','Garden Grove','',''),(22946,'92804','Buena Park','',''),(22947,'92804','Garden Grove','',''),(22948,'92804','Stanton','',''),(22949,'92805','Fullerton','',''),(22950,'92806','Fullerton','',''),(22951,'92806','Orange','',''),(22952,'92806','Placentia','',''),(22953,'92807','Orange','',''),(22954,'92807','Placentia','',''),(22955,'92807','Yorba Linda','',''),(22956,'92808','Yorba Linda','',''),(22957,'92821','Fullerton','',''),(22958,'92833','Buena Park','',''),(22959,'92835','Brea','',''),(22960,'92835','La Habra','',''),(22961,'92840','Orange','',''),(22962,'92841','Stanton','',''),(22963,'92841','Westminster','',''),(22964,'92844','Stanton','',''),(22965,'92844','Westminster','',''),(22966,'92860','Corona','',''),(22967,'92861','Orange','',''),(22968,'92866','Santa Ana','',''),(22969,'92867','Anaheim','',''),(22970,'92867','Villa Park','',''),(22971,'92868','Anaheim','',''),(22972,'92868','Garden Grove','',''),(22973,'92868','Santa Ana','',''),(22974,'92869','Villa Park','',''),(22975,'92870','Anaheim','',''),(22976,'92870','Brea','',''),(22977,'92870','Fullerton','',''),(22978,'92870','Yorba Linda','',''),(22979,'92879','Norco','',''),(22980,'92879','Riverside','',''),(22981,'92880','Chino','',''),(22982,'92880','Eastvale','',''),(22983,'92880','Norco','',''),(22984,'92881','Temescal Valley','',''),(22985,'92883','Lake Elsinore','',''),(22986,'92883','Temescal Valley','',''),(22987,'92886','Anaheim','',''),(22988,'92886','Brea','',''),(22989,'92886','Placentia','',''),(22990,'92887','Anaheim','',''),(22991,'93001','Oxnard','',''),(22992,'93001','San Buenaventura (ventura)','',''),(22993,'93003','Oxnard','',''),(22994,'93003','San Buenaventura (ventura)','',''),(22995,'93004','San Buenaventura (ventura)','',''),(22996,'93012','Thousand Oaks','',''),(22997,'93013','Summerland','',''),(22998,'93015','Piru','',''),(22999,'93021','Simi Valley','',''),(23000,'93021','Thousand Oaks','',''),(23001,'93023','Oak View','',''),(23002,'93041','Oxnard','',''),(23003,'93043','Oxnard','',''),(23004,'93043','Port Hueneme','',''),(23005,'93060','San Buenaventura (ventura)','',''),(23006,'93065','Thousand Oaks','',''),(23007,'93103','Montecito','',''),(23008,'93108','Montecito','',''),(23009,'93108','Summerland','',''),(23010,'93111','Goleta','',''),(23011,'93117','Buellton','',''),(23012,'93117','Santa Barbara','',''),(23013,'93203','Bakersfield','',''),(23014,'93205','Lake Isabella','',''),(23015,'93206','Shafter','',''),(23016,'93207','Pine Flat','',''),(23017,'93220','Bakersfield','',''),(23018,'93222','Pine Mountain Club','',''),(23019,'93224','Derby Acres','',''),(23020,'93225','Lebec','',''),(23021,'93225','Pine Mountain Club','',''),(23022,'93230','Armona','',''),(23023,'93239','Avenal','',''),(23024,'93240','Weldon','',''),(23025,'93245','Armona','',''),(23026,'93250','Delano','',''),(23027,'93250','Mcfarland','',''),(23028,'93252','Taft','',''),(23029,'93257','Poplar-cotton Center','',''),(23030,'93258','Poplar-cotton Center','',''),(23031,'93265','Camp Nelson','',''),(23032,'93280','Delano','',''),(23033,'93283','Onyx','',''),(23034,'93285','Kernville','',''),(23035,'93285','Lake Isabella','',''),(23036,'93286','Lemon Cove','',''),(23037,'93292','Farmersville','',''),(23038,'93307','Lamont','',''),(23039,'93308','Oildale','',''),(23040,'93308','Shafter','',''),(23041,'93312','Rosedale','',''),(23042,'93314','Rosedale','',''),(23043,'93314','Shafter','',''),(23044,'93402','Morro Bay','',''),(23045,'93405','Avilla Beach','',''),(23046,'93405','Los Osos','',''),(23047,'93405','Morro Bay','',''),(23048,'93420','Nipomo','',''),(23049,'93420','Oceano','',''),(23050,'93424','Avilla Beach','',''),(23051,'93426','Lockwood','',''),(23052,'93433','Arroyo Grande','',''),(23053,'93433','Pismo Beach','',''),(23054,'93436','Vandenberg Afb','',''),(23055,'93437','Vandenberg Afb','',''),(23056,'93445','Grover Beach','',''),(23057,'93446','El Paso De Robles (paso Robles)','',''),(23058,'93446','Templeton','',''),(23059,'93449','Avilla Beach','',''),(23060,'93455','Guadalupe','',''),(23061,'93455','Los Alamos','',''),(23062,'93455','Orcutt','',''),(23063,'93463','Buellton','',''),(23064,'93463','Los Olivos','',''),(23065,'93463','Santa Ynez','',''),(23066,'93465','Atascadero','',''),(23067,'93501','California City','',''),(23068,'93501','Rosamond','',''),(23069,'93514','Benton','',''),(23070,'93514','Big Pine','',''),(23071,'93518','Keene','',''),(23072,'93523','Edwards Afb','',''),(23073,'93524','Edwards Afb','',''),(23074,'93528','Randsburg','',''),(23075,'93532','Elizabeth Lake','',''),(23076,'93535','Lake Los Angeles','',''),(23077,'93535','Palmdale','',''),(23078,'93543','Palmdale','',''),(23079,'93543','Sun Village','',''),(23080,'93545','Keeler','',''),(23081,'93550','Acton','',''),(23082,'93551','Acton','',''),(23083,'93551','Elizabeth Lake','',''),(23084,'93551','Lancaster','',''),(23085,'93552','Sun Village','',''),(23086,'93554','Johannesburg','',''),(23087,'93561','Keene','',''),(23088,'93562','Searles Valley','',''),(23089,'93591','Lake Los Angeles','',''),(23090,'93591','Sun Village','',''),(23091,'93592','Homewood Canyon','',''),(23092,'93602','Shaver Lake','',''),(23093,'93611','Fresno','',''),(23094,'93612','Fresno','',''),(23095,'93614','Yosemite Lakes','',''),(23096,'93615','Orosi','',''),(23097,'93618','Sultana','',''),(23098,'93619','Earlimart','',''),(23099,'93619','Fresno','',''),(23100,'93620','South Dos Palos','',''),(23101,'93626','Clovis','',''),(23102,'93630','Biola','',''),(23103,'93631','Traver','',''),(23104,'93634','Big Creek','',''),(23105,'93636','Bonadelle Ranchos-madera Ranchos','',''),(23106,'93641','Squaw Valley','',''),(23107,'93644','Ahwahnee','',''),(23108,'93646','Squaw Valley','',''),(23109,'93647','Cutler','',''),(23110,'93651','Auberry','',''),(23111,'93662','Parlier','',''),(23112,'93706','Raisin City','',''),(23113,'93723','Biola','',''),(23114,'93727','Clovis','',''),(23115,'93906','Prunedale','',''),(23116,'93907','Prunedale','',''),(23117,'93908','Chualar','',''),(23118,'93908','Gonzales','',''),(23119,'93908','Prunedale','',''),(23120,'93921','Carmel-by-the-sea','',''),(23121,'93923','Carmel-by-the-sea','',''),(23122,'93923','Carmel Valley Village','',''),(23123,'93923','Monterey','',''),(23124,'93924','Carmel Valley Village','',''),(23125,'93940','Seaside','',''),(23126,'93950','Del Monte Forest','',''),(23127,'93950','Monterey','',''),(23128,'93953','Del Monte Forest','',''),(23129,'93953','Pacific Grove','',''),(23130,'93955','Marina','',''),(23131,'93955','Monterey','',''),(23132,'94002','Redwood City','',''),(23133,'94005','South San Francisco','',''),(23134,'94010','Millbrae','',''),(23135,'94019','Moss Beach','',''),(23136,'94022','Palo Alto','',''),(23137,'94024','Cupertino','',''),(23138,'94024','Mountain View','',''),(23139,'94024','Sunnyvale','',''),(23140,'94028','Menlo Park','',''),(23141,'94030','San Bruno','',''),(23142,'94038','Montara','',''),(23143,'94040','Los Altos','',''),(23144,'94040','Palo Alto','',''),(23145,'94043','Palo Alto','',''),(23146,'94043','Sunnyvale','',''),(23147,'94060','Loma Mar','',''),(23148,'94065','San Carlos','',''),(23149,'94070','Belmont','',''),(23150,'94070','Redwood City','',''),(23151,'94080','San Bruno','',''),(23152,'94085','Mountain View','',''),(23153,'94086','Mountain View','',''),(23154,'94086','Santa Clara','',''),(23155,'94087','Cupertino','',''),(23156,'94087','Mountain View','',''),(23157,'94087','Santa Clara','',''),(23158,'94089','San Jose','',''),(23159,'94128','San Bruno','',''),(23160,'94128','South San Francisco','',''),(23161,'94303','East Palo Alto','',''),(23162,'94303','Menlo Park','',''),(23163,'94303','Mountain View','',''),(23164,'94304','Stanford','',''),(23165,'94305','Palo Alto','',''),(23166,'94306','Los Altos','',''),(23167,'94306','Mountain View','',''),(23168,'94404','Foster City','',''),(23169,'94505','Discovery Bay','',''),(23170,'94506','Diablo','',''),(23171,'94506','San Ramon','',''),(23172,'94507','Danville','',''),(23173,'94507','Walnut Creek','',''),(23174,'94508','Deer Park','',''),(23175,'94509','Pittsburg','',''),(23176,'94513','Antioch','',''),(23177,'94513','Byron','',''),(23178,'94513','Discovery Bay','',''),(23179,'94513','Knightsen','',''),(23180,'94517','Concord','',''),(23181,'94518','Pleasant Hill','',''),(23182,'94518','Walnut Creek','',''),(23183,'94520','Pleasant Hill','',''),(23184,'94521','Clayton','',''),(23185,'94521','Walnut Creek','',''),(23186,'94523','Concord','',''),(23187,'94523','Martinez','',''),(23188,'94525','Rodeo','',''),(23189,'94526','Alamo','',''),(23190,'94528','Alamo','',''),(23191,'94528','Danville','',''),(23192,'94530','Richmond','',''),(23193,'94533','Suisun City','',''),(23194,'94533','Vacaville','',''),(23195,'94534','Suisun City','',''),(23196,'94534','Vacaville','',''),(23197,'94534','Vallejo','',''),(23198,'94535','Fairfield','',''),(23199,'94539','Sunol','',''),(23200,'94541','Castro Valley','',''),(23201,'94541','San Lorenzo','',''),(23202,'94544','Union City','',''),(23203,'94546','Hayward','',''),(23204,'94547','Pinole','',''),(23205,'94549','Martinez','',''),(23206,'94549','Moraga','',''),(23207,'94549','Orinda','',''),(23208,'94549','Pleasant Hill','',''),(23209,'94549','Walnut Creek','',''),(23210,'94551','Dublin','',''),(23211,'94552','Hayward','',''),(23212,'94552','Sunol','',''),(23213,'94552','Union City','',''),(23214,'94553','Hercules','',''),(23215,'94556','Lafayette','',''),(23216,'94556','Orinda','',''),(23217,'94558','American Canyon','',''),(23218,'94558','Rutherford','',''),(23219,'94561','Antioch','',''),(23220,'94561','Knightsen','',''),(23221,'94563','Lafayette','',''),(23222,'94563','Moraga','',''),(23223,'94564','Richmond','',''),(23224,'94565','Antioch','',''),(23225,'94566','Sunol','',''),(23226,'94568','Pleasanton','',''),(23227,'94572','Hercules','',''),(23228,'94574','Deer Park','',''),(23229,'94574','Rutherford','',''),(23230,'94574','St. Helena','',''),(23231,'94577','Castro Valley','',''),(23232,'94577','Oakland','',''),(23233,'94578','Castro Valley','',''),(23234,'94580','Hayward','',''),(23235,'94580','San Leandro','',''),(23236,'94582','Danville','',''),(23237,'94583','Danville','',''),(23238,'94585','Fairfield','',''),(23239,'94586','Hayward','',''),(23240,'94586','Pleasanton','',''),(23241,'94587','Hayward','',''),(23242,'94588','Hayward','',''),(23243,'94588','Livermore','',''),(23244,'94588','Sunol','',''),(23245,'94589','American Canyon','',''),(23246,'94591','Benicia','',''),(23247,'94591','Fairfield','',''),(23248,'94595','Lafayette','',''),(23249,'94596','Alamo','',''),(23250,'94597','Concord','',''),(23251,'94597','Lafayette','',''),(23252,'94597','Pleasant Hill','',''),(23253,'94598','Concord','',''),(23254,'94608','Berkeley','',''),(23255,'94608','Oakland','',''),(23256,'94609','Berkeley','',''),(23257,'94611','Orinda','',''),(23258,'94618','Berkeley','',''),(23259,'94704','Oakland','',''),(23260,'94705','Oakland','',''),(23261,'94706','Berkeley','',''),(23262,'94707','Albany','',''),(23263,'94710','Albany','',''),(23264,'94803','Pinole','',''),(23265,'94803','Richmond','',''),(23266,'94803','San Pablo','',''),(23267,'94804','El Cerrito','',''),(23268,'94804','San Pablo','',''),(23269,'94805','San Pablo','',''),(23270,'94806','Pinole','',''),(23271,'94806','Richmond','',''),(23272,'94901','Larkspur','',''),(23273,'94901','San Anselmo','',''),(23274,'94904','Kentfield','',''),(23275,'94904','Larkspur','',''),(23276,'94904','Mill Valley','',''),(23277,'94904','Ross','',''),(23278,'94920','Tiburon','',''),(23279,'94924','Stinson Beach','',''),(23280,'94928','Cotati','',''),(23281,'94930','Ross','',''),(23282,'94931','Penngrove','',''),(23283,'94931','Rohnert Park','',''),(23284,'94933','Lagunitas-forest Knolls','',''),(23285,'94938','Lagunitas-forest Knolls','',''),(23286,'94939','Kentfield','',''),(23287,'94941','Larkspur','',''),(23288,'94951','Petaluma','',''),(23289,'94954','Penngrove','',''),(23290,'94956','Inverness','',''),(23291,'94960','Fairfax','',''),(23292,'94960','Ross','',''),(23293,'94963','Lagunitas-forest Knolls','',''),(23294,'94964','San Rafael','',''),(23295,'94971','Dillon Beach','',''),(23296,'94973','San Geronimo','',''),(23297,'95002','San Jose','',''),(23298,'95002','Sunnyvale','',''),(23299,'95003','Capitola','',''),(23300,'95003','Rio Del Mar','',''),(23301,'95003','Soquel','',''),(23302,'95004','Prunedale','',''),(23303,'95005','Brookdale','',''),(23304,'95006','Brookdale','',''),(23305,'95008','Los Gatos','',''),(23306,'95008','San Jose','',''),(23307,'95012','Prunedale','',''),(23308,'95013','San Jose','',''),(23309,'95014','Los Altos','',''),(23310,'95014','Palo Alto','',''),(23311,'95014','San Jose','',''),(23312,'95014','Sunnyvale','',''),(23313,'95018','Ben Lomond','',''),(23314,'95018','Mount Hermon','',''),(23315,'95019','Watsonville','',''),(23316,'95020','San Martin','',''),(23317,'95023','Tres Pinos','',''),(23318,'95030','Saratoga','',''),(23319,'95032','Campbell','',''),(23320,'95032','San Jose','',''),(23321,'95033','Palo Alto','',''),(23322,'95035','San Jose','',''),(23323,'95037','San Jose','',''),(23324,'95037','San Martin','',''),(23325,'95045','Hollister','',''),(23326,'95046','Morgan Hill','',''),(23327,'95050','San Jose','',''),(23328,'95051','Cupertino','',''),(23329,'95051','Sunnyvale','',''),(23330,'95054','San Jose','',''),(23331,'95060','Ben Lomond','',''),(23332,'95060','Felton','',''),(23333,'95060','Scotts Valley','',''),(23334,'95062','Capitola','',''),(23335,'95062','Live Oak','',''),(23336,'95065','Live Oak','',''),(23337,'95065','Scotts Valley','',''),(23338,'95066','Mount Hermon','',''),(23339,'95070','Cupertino','',''),(23340,'95070','Los Gatos','',''),(23341,'95070','San Jose','',''),(23342,'95073','Capitola','',''),(23343,'95076','Prunedale','',''),(23344,'95076','Rio Del Mar','',''),(23345,'95110','Santa Clara','',''),(23346,'95117','Campbell','',''),(23347,'95117','Santa Clara','',''),(23348,'95125','Campbell','',''),(23349,'95126','Santa Clara','',''),(23350,'95128','Campbell','',''),(23351,'95129','Saratoga','',''),(23352,'95140','San Jose','',''),(23353,'95206','French Camp','',''),(23354,'95222','Angels','',''),(23355,'95222','Vallecito','',''),(23356,'95224','Arnold','',''),(23357,'95231','Lathrop','',''),(23358,'95231','Stockton','',''),(23359,'95233','Avery','',''),(23360,'95240','Lockeford','',''),(23361,'95242','Stockton','',''),(23362,'95242','Woodbridge','',''),(23363,'95245','Mountain Ranch','',''),(23364,'95245','Rail Road Flat','',''),(23365,'95246','Rail Road Flat','',''),(23366,'95247','Avery','',''),(23367,'95250','Mountain Ranch','',''),(23368,'95252','Rancho Calaveras','',''),(23369,'95252','Wallace','',''),(23370,'95303','Cressey','',''),(23371,'95304','Lathrop','',''),(23372,'95304','Mountain House','',''),(23373,'95305','Groveland','',''),(23374,'95307','Keyes','',''),(23375,'95316','Turlock','',''),(23376,'95319','Modesto','',''),(23377,'95321','Pine Mountain Lake','',''),(23378,'95324','Hilmar-irwin','',''),(23379,'95326','Ceres','',''),(23380,'95326','Keyes','',''),(23381,'95330','Manteca','',''),(23382,'95333','Planada','',''),(23383,'95334','Cressey','',''),(23384,'95335','Cold Springs','',''),(23385,'95336','Stockton','',''),(23386,'95338','Hornitos','',''),(23387,'95338','Midpines','',''),(23388,'95346','Mi-wuk Village','',''),(23389,'95351','Ceres','',''),(23390,'95356','Salida','',''),(23391,'95357','Empire','',''),(23392,'95357','Riverbank','',''),(23393,'95358','Ceres','',''),(23394,'95358','Salida','',''),(23395,'95361','Riverbank','',''),(23396,'95363','Westley','',''),(23397,'95368','Modesto','',''),(23398,'95370','Columbia','',''),(23399,'95370','Soulsbyville','',''),(23400,'95379','Soulsbyville','',''),(23401,'95380','Delhi','',''),(23402,'95382','Keyes','',''),(23403,'95383','Mi-wuk Village','',''),(23404,'95383','Soulsbyville','',''),(23405,'95388','Atwater','',''),(23406,'95388','Cressey','',''),(23407,'95389','El Portal','',''),(23408,'95389','Yosemite Valley','',''),(23409,'95391','Mountain House','',''),(23410,'95403','Fulton','',''),(23411,'95403','Windsor','',''),(23412,'95407','Rohnert Park','',''),(23413,'95421','Timber Cove','',''),(23414,'95436','Guerneville','',''),(23415,'95436','Windsor','',''),(23416,'95442','Kenwood','',''),(23417,'95448','Windsor','',''),(23418,'95450','Timber Cove','',''),(23419,'95460','Caspar','',''),(23420,'95461','Cobb','',''),(23421,'95461','Hidden Valley Lake','',''),(23422,'95465','Bodega','',''),(23423,'95471','Guerneville','',''),(23424,'95472','Graton','',''),(23425,'95472','Santa Rosa','',''),(23426,'95485','Nice','',''),(23427,'95486','Monte Rio','',''),(23428,'95497','Sea Ranch','',''),(23429,'95503','Fields Landing','',''),(23430,'95519','Arcata','',''),(23431,'95519','Westhaven-moonstone','',''),(23432,'95521','Blue Lake','',''),(23433,'95521','Eureka','',''),(23434,'95521','Samoa','',''),(23435,'95524','Arcata','',''),(23436,'95524','Eureka','',''),(23437,'95540','Hydesville','',''),(23438,'95540','Rio Dell','',''),(23439,'95549','Arcata','',''),(23440,'95551','Fields Landing','',''),(23441,'95554','Weott','',''),(23442,'95569','Weott','',''),(23443,'95570','Mckinleyville','',''),(23444,'95570','Westhaven-moonstone','',''),(23445,'95607','Esparto','',''),(23446,'95608','Arden-arcade','',''),(23447,'95610','Orangevale','',''),(23448,'95614','Auburn Lake Trails','',''),(23449,'95618','Davis','',''),(23450,'95618','West Sacramento','',''),(23451,'95620','Vacaville','',''),(23452,'95620','West Sacramento','',''),(23453,'95621','Antelope','',''),(23454,'95621','Carmichael','',''),(23455,'95621','Foothill Farms','',''),(23456,'95623','Diamond Springs','',''),(23457,'95624','Florin','',''),(23458,'95625','Vacaville','',''),(23459,'95627','Madison','',''),(23460,'95628','Carmichael','',''),(23461,'95628','Citrus Heights','',''),(23462,'95628','Orangevale','',''),(23463,'95632','Thornton','',''),(23464,'95633','Georgetown','',''),(23465,'95635','Georgetown','',''),(23466,'95638','Clay','',''),(23467,'95642','Pine Grove','',''),(23468,'95648','Sheridan','',''),(23469,'95650','Granite Bay','',''),(23470,'95650','Lincoln','',''),(23471,'95650','Rocklin','',''),(23472,'95652','Mcclellan Park','',''),(23473,'95652','North Highlands','',''),(23474,'95652','Sacramento','',''),(23475,'95653','Esparto','',''),(23476,'95655','Rancho Cordova','',''),(23477,'95658','Auburn','',''),(23478,'95660','Foothill Farms','',''),(23479,'95660','Mcclellan Park','',''),(23480,'95660','Sacramento','',''),(23481,'95661','Granite Bay','',''),(23482,'95662','Folsom','',''),(23483,'95663','Loomis','',''),(23484,'95663','Rocklin','',''),(23485,'95666','Buckhorn','',''),(23486,'95666','Kirkwood','',''),(23487,'95667','Diamond Springs','',''),(23488,'95670','Folsom','',''),(23489,'95672','Cameron Park','',''),(23490,'95672','El Dorado Hills','',''),(23491,'95673','Elverta','',''),(23492,'95673','Sacramento','',''),(23493,'95677','Loomis','',''),(23494,'95677','Roseville','',''),(23495,'95678','Rocklin','',''),(23496,'95680','Walnut Grove','',''),(23497,'95682','Cameron Park','',''),(23498,'95682','Diamond Springs','',''),(23499,'95682','El Dorado Hills','',''),(23500,'95683','Rancho Cordova','',''),(23501,'95683','Rancho Murieta','',''),(23502,'95685','Amador City','',''),(23503,'95685','Drytown','',''),(23504,'95687','Elmira','',''),(23505,'95687','Fairfield','',''),(23506,'95695','Yolo','',''),(23507,'95709','Pollock Pines','',''),(23508,'95714','Alta','',''),(23509,'95742','Folsom','',''),(23510,'95746','Roseville','',''),(23511,'95758','Sacramento','',''),(23512,'95765','Roseville','',''),(23513,'95776','Davis','',''),(23514,'95776','Knights Landing','',''),(23515,'95821','Arden-arcade','',''),(23516,'95821','North Highlands','',''),(23517,'95823','Florin','',''),(23518,'95825','Arden-arcade','',''),(23519,'95826','Rosemont','',''),(23520,'95827','Mather','',''),(23521,'95827','Rancho Cordova','',''),(23522,'95827','Rosemont','',''),(23523,'95828','Florin','',''),(23524,'95829','Elk Grove','',''),(23525,'95829','Vineyard','',''),(23526,'95830','Elk Grove','',''),(23527,'95830','Mather','',''),(23528,'95830','Vineyard','',''),(23529,'95838','Mcclellan Park','',''),(23530,'95841','Arden-arcade','',''),(23531,'95841','Carmichael','',''),(23532,'95841','Citrus Heights','',''),(23533,'95841','Foothill Farms','',''),(23534,'95841','North Highlands','',''),(23535,'95842','Antelope','',''),(23536,'95842','Citrus Heights','',''),(23537,'95842','Foothill Farms','',''),(23538,'95842','North Highlands','',''),(23539,'95843','North Highlands','',''),(23540,'95864','Arden-arcade','',''),(23541,'95901','Linda','',''),(23542,'95901','Olivehurst','',''),(23543,'95912','Dunnigan','',''),(23544,'95919','Challenge-brownsville','',''),(23545,'95923','Prattville','',''),(23546,'95925','Challenge-brownsville','',''),(23547,'95928','Durham','',''),(23548,'95936','Goodyears Bar','',''),(23549,'95946','Lake Wildwood','',''),(23550,'95948','Biggs','',''),(23551,'95954','Paradise','',''),(23552,'95954','Stirling City','',''),(23553,'95959','Washington','',''),(23554,'95961','Linda','',''),(23555,'95962','Dobbins','',''),(23556,'95965','Durham','',''),(23557,'95965','Oroville East','',''),(23558,'95965','Palermo','',''),(23559,'95965','Paradise','',''),(23560,'95966','Berry Creek','',''),(23561,'95966','Challenge-brownsville','',''),(23562,'95966','Oroville East','',''),(23563,'95966','Palermo','',''),(23564,'95968','Oroville','',''),(23565,'95969','Magalia','',''),(23566,'95971','East Quincy','',''),(23567,'95971','Meadow Valley','',''),(23568,'95983','Crescent Mills','',''),(23569,'95993','Sutter','',''),(23570,'96001','Shasta','',''),(23571,'96003','Bella Vista','',''),(23572,'96003','Shasta Lake','',''),(23573,'96007','Redding','',''),(23574,'96016','Hat Creek','',''),(23575,'96019','Redding','',''),(23576,'96021','Flournoy','',''),(23577,'96024','Lewiston','',''),(23578,'96032','Greenview','',''),(23579,'96049','Happy Camp','',''),(23580,'96058','Dorris','',''),(23581,'96061','Mineral','',''),(23582,'96064','Grenada','',''),(23583,'96064','Yreka','',''),(23584,'96067','Dunsmuir','',''),(23585,'96069','Millville','',''),(23586,'96073','Millville','',''),(23587,'96093','Douglas City','',''),(23588,'96093','Junction City','',''),(23589,'96103','Graeagle','',''),(23590,'96105','Chilcoot-vinton','',''),(23591,'96106','Whitehawk','',''),(23592,'96107','Walker','',''),(23593,'96109','Patton Village','',''),(23594,'96111','Verdi','',''),(23595,'96113','Patton Village','',''),(23596,'96117','Susanville','',''),(23597,'96118','Sierraville','',''),(23598,'96120','Kirkwood','',''),(23599,'96135','Chilcoot-vinton','',''),(23600,'96140','Tahoe Vista','',''),(23601,'96141','Tahoma','',''),(23602,'96143','Tahoe Vista','',''),(23603,'96145','Sunnyside-tahoe City','',''),(23604,'96701','Pearl City','',''),(23605,'96701','Waimalu','',''),(23606,'96704','Honaunau-napoopoo','',''),(23607,'96706','Ewa Gentry','',''),(23608,'96706','Waipahu','',''),(23609,'96707','Makakilo','',''),(23610,'96708','Haiku-pauwela','',''),(23611,'96712','Pupukea','',''),(23612,'96714','Princeville','',''),(23613,'96716','Eleele','',''),(23614,'96716','Kaumakani','',''),(23615,'96716','Pakala Village','',''),(23616,'96722','Hanalei','',''),(23617,'96725','Honalo','',''),(23618,'96725','Kailua','',''),(23619,'96726','Honaunau-napoopoo','',''),(23620,'96729','Kualapuu','',''),(23621,'96731','Laie','',''),(23622,'96732','Wailuku','',''),(23623,'96734','Kaneohe Station','',''),(23624,'96737','Hawaiian Ocean View','',''),(23625,'96738','Waikoloa Village','',''),(23626,'96740','Honalo','',''),(23627,'96740','Kailua','',''),(23628,'96741','Lawai','',''),(23629,'96743','Waimea','',''),(23630,'96744','Kaneohe Station','',''),(23631,'96746','Anahola','',''),(23632,'96747','Pakala Village','',''),(23633,'96749','Hawaiian Beaches','',''),(23634,'96749','Hawaiian Paradise Park','',''),(23635,'96750','Captain Cook','',''),(23636,'96750','Honalo','',''),(23637,'96755','Hawi','',''),(23638,'96756','Lawai','',''),(23639,'96760','Hawaiian Acres','',''),(23640,'96762','Hauula','',''),(23641,'96768','Haiku-pauwela','',''),(23642,'96768','Kula','',''),(23643,'96768','Pukalani','',''),(23644,'96769','Pakala Village','',''),(23645,'96770','Kualapuu','',''),(23646,'96771','Hawaiian Acres','',''),(23647,'96772','Discovery Harbour','',''),(23648,'96778','Hawaiian Acres','',''),(23649,'96778','Hawaiian Beaches','',''),(23650,'96785','Mountain View','',''),(23651,'96786','Schofield Barracks','',''),(23652,'96789','Mililani Town','',''),(23653,'96793','Kahului','',''),(23654,'96795','Kailua','',''),(23655,'96813','Urban Honolulu','',''),(23656,'96814','Urban Honolulu','',''),(23657,'96815','Urban Honolulu','',''),(23658,'96816','East Honolulu','',''),(23659,'96816','Urban Honolulu','',''),(23660,'96817','Urban Honolulu','',''),(23661,'96818','Hickam Housing','',''),(23662,'96818','Urban Honolulu','',''),(23663,'96819','Urban Honolulu','',''),(23664,'96821','East Honolulu','',''),(23665,'96821','Urban Honolulu','',''),(23666,'96822','Urban Honolulu','',''),(23667,'96825','East Honolulu','',''),(23668,'96826','Urban Honolulu','',''),(23669,'96850','Urban Honolulu','',''),(23670,'96853','Hickam Housing','',''),(23671,'96853','Urban Honolulu','',''),(23672,'96859','Urban Honolulu','',''),(23673,'96863','Kaneohe Station','',''),(23674,'97002','Donald','',''),(23675,'97002','Hubbard','',''),(23676,'97002','Wilsonville','',''),(23677,'97004','Mulino','',''),(23678,'97006','Aloha','',''),(23679,'97006','Hillsboro','',''),(23680,'97007','Aloha','',''),(23681,'97007','Hillsboro','',''),(23682,'97009','Damascus','',''),(23683,'97011','Mount Hood Village','',''),(23684,'97013','Mulino','',''),(23685,'97015','Gladstone','',''),(23686,'97024','Gresham','',''),(23687,'97030','Troutdale','',''),(23688,'97032','Donald','',''),(23689,'97034','Oak Grove','',''),(23690,'97034','Portland','',''),(23691,'97034','West Linn','',''),(23692,'97035','Portland','',''),(23693,'97035','Tualatin','',''),(23694,'97039','Grass Valley','',''),(23695,'97045','Gladstone','',''),(23696,'97045','Mulino','',''),(23697,'97049','Mount Hood Village','',''),(23698,'97051','Columbia City','',''),(23699,'97051','St. Helens','',''),(23700,'97053','St. Helens','',''),(23701,'97055','Mount Hood Village','',''),(23702,'97060','Gresham','',''),(23703,'97062','Wilsonville','',''),(23704,'97063','Pine Hollow','',''),(23705,'97067','Mount Hood Village','',''),(23706,'97068','Lake Oswego','',''),(23707,'97080','Portland','',''),(23708,'97086','Portland','',''),(23709,'97103','Warrenton','',''),(23710,'97107','Garibaldi','',''),(23711,'97112','Pacific City','',''),(23712,'97121','Warrenton','',''),(23713,'97123','Aloha','',''),(23714,'97123','Cornelius','',''),(23715,'97128','Lafayette','',''),(23716,'97131','Manzanita','',''),(23717,'97136','Wheeler','',''),(23718,'97140','Tualatin','',''),(23719,'97140','Wilsonville','',''),(23720,'97141','Bay City','',''),(23721,'97141','Oceanside','',''),(23722,'97145','Cannon Beach','',''),(23723,'97202','Milwaukie','',''),(23724,'97206','Milwaukie','',''),(23725,'97210','West Haven-sylvan','',''),(23726,'97219','Lake Oswego','',''),(23727,'97221','West Haven-sylvan','',''),(23728,'97222','Milwaukie','',''),(23729,'97222','Oak Grove','',''),(23730,'97223','Beaverton','',''),(23731,'97223','Tigard','',''),(23732,'97224','Tigard','',''),(23733,'97224','Tualatin','',''),(23734,'97225','Beaverton','',''),(23735,'97225','West Haven-sylvan','',''),(23736,'97229','Beaverton','',''),(23737,'97229','Bethany','',''),(23738,'97229','Hillsboro','',''),(23739,'97229','West Haven-sylvan','',''),(23740,'97230','Fairview','',''),(23741,'97230','Gresham','',''),(23742,'97231','Bethany','',''),(23743,'97233','Gresham','',''),(23744,'97236','Gresham','',''),(23745,'97267','Gladstone','',''),(23746,'97267','Oak Grove','',''),(23747,'97301','Four Corners','',''),(23748,'97303','Keizer','',''),(23749,'97305','Four Corners','',''),(23750,'97305','Hayesville','',''),(23751,'97317','Four Corners','',''),(23752,'97325','Stayton','',''),(23753,'97338','Falls City','',''),(23754,'97341','Lincoln Beach','',''),(23755,'97342','Idanha','',''),(23756,'97345','Sweet Home','',''),(23757,'97351','Monmouth','',''),(23758,'97364','Lincoln City','',''),(23759,'97365','Toledo','',''),(23760,'97366','Newport','',''),(23761,'97367','Lincoln Beach','',''),(23762,'97368','Lincoln City','',''),(23763,'97368','Rose Lodge','',''),(23764,'97378','Willamina','',''),(23765,'97388','Lincoln Beach','',''),(23766,'97389','Albany','',''),(23767,'97392','Salem','',''),(23768,'97396','Grand Ronde','',''),(23769,'97403','Springfield','',''),(23770,'97405','Springfield','',''),(23771,'97420','North Bend','',''),(23772,'97438','Lowell','',''),(23773,'97447','Glide','',''),(23774,'97457','Tri-city','',''),(23775,'97459','Coos Bay','',''),(23776,'97462','Sutherlin','',''),(23777,'97470','Glide','',''),(23778,'97470','Roseburg North','',''),(23779,'97471','Winston','',''),(23780,'97492','Oakridge','',''),(23781,'97495','Roseburg North','',''),(23782,'97501','Phoenix','',''),(23783,'97502','Medford','',''),(23784,'97504','Central Point','',''),(23785,'97523','Kerby','',''),(23786,'97524','Butte Falls','',''),(23787,'97526','Merlin','',''),(23788,'97534','Obrien','',''),(23789,'97603','Altamont','',''),(23790,'97620','Plush','',''),(23791,'97707','Three Rivers','',''),(23792,'97720','Crane','',''),(23793,'97814','Sumpter','',''),(23794,'97838','Umatilla','',''),(23795,'97843','Arlington','',''),(23796,'97845','Canyon City','',''),(23797,'97862','Milton-freewater','',''),(23798,'98001','Federal Way','',''),(23799,'98001','Lakeland North','',''),(23800,'98001','Milton','',''),(23801,'98001','Pacific','',''),(23802,'98002','Pacific','',''),(23803,'98003','Milton','',''),(23804,'98007','Redmond','',''),(23805,'98008','Redmond','',''),(23806,'98011','Kenmore','',''),(23807,'98011','Woodinville','',''),(23808,'98012','Mill Creek','',''),(23809,'98012','Silver Firs','',''),(23810,'98019','Cottage Lake','',''),(23811,'98019','Union Hill-novelty Hill','',''),(23812,'98022','Black Diamond','',''),(23813,'98023','Des Moines','',''),(23814,'98024','Sammamish','',''),(23815,'98024','Snoqualmie','',''),(23816,'98026','Lynnwood','',''),(23817,'98026','Mukilteo','',''),(23818,'98026','North Lynnwood','',''),(23819,'98027','Bellevue','',''),(23820,'98028','Bothell','',''),(23821,'98030','Auburn','',''),(23822,'98031','East Hill-meridian','',''),(23823,'98031','Renton','',''),(23824,'98032','Lakeland North','',''),(23825,'98032','Renton','',''),(23826,'98032','Seatac','',''),(23827,'98032','Tukwila','',''),(23828,'98033','Bellevue','',''),(23829,'98034','Kenmore','',''),(23830,'98034','Redmond','',''),(23831,'98034','Woodinville','',''),(23832,'98036','Mountlake Terrace','',''),(23833,'98036','North Lynnwood','',''),(23834,'98037','Edmonds','',''),(23835,'98037','North Lynnwood','',''),(23836,'98038','Covington','',''),(23837,'98038','Kent','',''),(23838,'98039','Bellevue','',''),(23839,'98042','Auburn','',''),(23840,'98042','Covington','',''),(23841,'98042','East Hill-meridian','',''),(23842,'98042','Maple Valley','',''),(23843,'98043','Edmonds','',''),(23844,'98043','Lynnwood','',''),(23845,'98045','Snoqualmie','',''),(23846,'98047','Sumner','',''),(23847,'98051','Kent','',''),(23848,'98052','Bellevue','',''),(23849,'98052','Cottage Lake','',''),(23850,'98052','Kirkland','',''),(23851,'98052','Union Hill-novelty Hill','',''),(23852,'98052','Woodinville','',''),(23853,'98053','Union Hill-novelty Hill','',''),(23854,'98055','East Hill-meridian','',''),(23855,'98055','Kent','',''),(23856,'98057','Bryn Mawr-skyway','',''),(23857,'98057','Tukwila','',''),(23858,'98058','East Hill-meridian','',''),(23859,'98058','Fairwood','',''),(23860,'98059','Bellevue','',''),(23861,'98068','Roslyn','',''),(23862,'98072','Bothell','',''),(23863,'98072','Cottage Lake','',''),(23864,'98077','Cottage Lake','',''),(23865,'98077','Union Hill-novelty Hill','',''),(23866,'98087','North Lynnwood','',''),(23867,'98092','Black Diamond','',''),(23868,'98092','Kent','',''),(23869,'98106','White Center','',''),(23870,'98108','Tukwila','',''),(23871,'98108','White Center','',''),(23872,'98126','White Center','',''),(23873,'98133','Shoreline','',''),(23874,'98146','Burien','',''),(23875,'98146','White Center','',''),(23876,'98148','Burien','',''),(23877,'98148','Des Moines','',''),(23878,'98148','Seatac','',''),(23879,'98155','Shoreline','',''),(23880,'98158','Seatac','',''),(23881,'98166','Burien','',''),(23882,'98168','Burien','',''),(23883,'98168','Seatac','',''),(23884,'98168','Tukwila','',''),(23885,'98168','White Center','',''),(23886,'98177','Shoreline','',''),(23887,'98178','Bryn Mawr-skyway','',''),(23888,'98178','Renton','',''),(23889,'98178','Tukwila','',''),(23890,'98188','Kent','',''),(23891,'98188','Renton','',''),(23892,'98188','Seatac','',''),(23893,'98188','Tukwila','',''),(23894,'98198','Des Moines','',''),(23895,'98198','Kent','',''),(23896,'98198','Seatac','',''),(23897,'98204','Mukilteo','',''),(23898,'98205','Lake Stevens','',''),(23899,'98205','Marysville','',''),(23900,'98208','Mill Creek','',''),(23901,'98208','Silver Firs','',''),(23902,'98223','Marysville','',''),(23903,'98226','Ferndale','',''),(23904,'98230','Birch Bay','',''),(23905,'98235','Clear Lake','',''),(23906,'98244','Peaceful Valley','',''),(23907,'98247','Lynden','',''),(23908,'98247','Nooksack','',''),(23909,'98248','Birch Bay','',''),(23910,'98266','Peaceful Valley','',''),(23911,'98272','Everett','',''),(23912,'98272','Sultan','',''),(23913,'98273','Clear Lake','',''),(23914,'98273','Conway','',''),(23915,'98275','Everett','',''),(23916,'98277','Whidbey Island Station','',''),(23917,'98278','Whidbey Island Station','',''),(23918,'98284','Clear Lake','',''),(23919,'98284','Hamilton','',''),(23920,'98284','Lyman','',''),(23921,'98290','Everett','',''),(23922,'98290','Monroe','',''),(23923,'98292','Marysville','',''),(23924,'98294','Everett','',''),(23925,'98294','Gold Bar','',''),(23926,'98295','Peaceful Valley','',''),(23927,'98296','Mill Creek','',''),(23928,'98296','Silver Firs','',''),(23929,'98311','Silverdale','',''),(23930,'98312','Port Orchard','',''),(23931,'98312','Silverdale','',''),(23932,'98315','Bangor Base','',''),(23933,'98321','Bonney Lake','',''),(23934,'98321','Enumclaw','',''),(23935,'98321','South Prairie','',''),(23936,'98321','Wilkeson','',''),(23937,'98323','Wilkeson','',''),(23938,'98325','Port Hadlock-irondale','',''),(23939,'98329','Key Center','',''),(23940,'98329','Wauna','',''),(23941,'98332','Maplewood','',''),(23942,'98335','Artondale','',''),(23943,'98338','South Hill','',''),(23944,'98339','Port Hadlock-irondale','',''),(23945,'98346','Hansville','',''),(23946,'98346','Indianola','',''),(23947,'98349','Key Center','',''),(23948,'98349','Longbranch','',''),(23949,'98358','Marrowstone','',''),(23950,'98360','Graham','',''),(23951,'98360','South Hill','',''),(23952,'98366','Bainbridge Island','',''),(23953,'98366','Bremerton','',''),(23954,'98367','Bremerton','',''),(23955,'98368','Port Hadlock-irondale','',''),(23956,'98370','Indianola','',''),(23957,'98370','Keyport','',''),(23958,'98370','Silverdale','',''),(23959,'98370','Suquamish','',''),(23960,'98371','Waller','',''),(23961,'98372','Sumner','',''),(23962,'98373','South Hill','',''),(23963,'98374','Graham','',''),(23964,'98374','South Hill','',''),(23965,'98375','Frederickson','',''),(23966,'98375','South Hill','',''),(23967,'98387','Frederickson','',''),(23968,'98387','Graham','',''),(23969,'98387','Parkland','',''),(23970,'98387','South Hill','',''),(23971,'98390','Auburn','',''),(23972,'98390','Pacific','',''),(23973,'98391','Auburn','',''),(23974,'98391','Orting','',''),(23975,'98391','Sumner','',''),(23976,'98394','Key Center','',''),(23977,'98396','Carbonado','',''),(23978,'98404','Waller','',''),(23979,'98421','Fife','',''),(23980,'98424','Fife','',''),(23981,'98424','Milton','',''),(23982,'98433','Dupont','',''),(23983,'98433','Fort Lewis','',''),(23984,'98433','Lakewood','',''),(23985,'98439','Fort Lewis','',''),(23986,'98439','Mcchord Afb','',''),(23987,'98443','Waller','',''),(23988,'98444','Lakewood','',''),(23989,'98444','Parkland','',''),(23990,'98444','Spanaway','',''),(23991,'98445','Frederickson','',''),(23992,'98445','Parkland','',''),(23993,'98445','Spanaway','',''),(23994,'98446','Frederickson','',''),(23995,'98447','Parkland','',''),(23996,'98466','University Place','',''),(23997,'98467','Steilacoom','',''),(23998,'98467','Tacoma','',''),(23999,'98498','Steilacoom','',''),(24000,'98499','Mcchord Afb','',''),(24001,'98499','Parkland','',''),(24002,'98499','Tacoma','',''),(24003,'98501','Lacey','',''),(24004,'98503','Olympia','',''),(24005,'98513','Lacey','',''),(24006,'98516','Lacey','',''),(24007,'98520','Cosmopolis','',''),(24008,'98528','Allyn','',''),(24009,'98532','Centralia','',''),(24010,'98532','Napavine','',''),(24011,'98532','Pe Ell','',''),(24012,'98536','Copalis Beach','',''),(24013,'98541','Satsop','',''),(24014,'98550','Aberdeen','',''),(24015,'98552','Neilton','',''),(24016,'98562','Pacific Beach','',''),(24017,'98563','Aberdeen','',''),(24018,'98563','Cosmopolis','',''),(24019,'98571','Moclips','',''),(24020,'98575','Neilton','',''),(24021,'98577','South Bend','',''),(24022,'98580','Fort Lewis','',''),(24023,'98580','Mckenna','',''),(24024,'98595','Grayland','',''),(24025,'98596','Napavine','',''),(24026,'98596','Vader','',''),(24027,'98604','Hockinson','',''),(24028,'98606','Hockinson','',''),(24029,'98607','Vancouver','',''),(24030,'98607','Washougal','',''),(24031,'98612','Puget Island','',''),(24032,'98612','Skamokawa Valley','',''),(24033,'98621','Rosburg','',''),(24034,'98624','Chinook','',''),(24035,'98626','Longview','',''),(24036,'98632','Kelso','',''),(24037,'98635','Dallesport','',''),(24038,'98635','Klickitat','',''),(24039,'98638','Grays River','',''),(24040,'98638','Rosburg','',''),(24041,'98643','Grays River','',''),(24042,'98643','Skamokawa Valley','',''),(24043,'98647','Grays River','',''),(24044,'98647','Skamokawa Valley','',''),(24045,'98648','Carson','',''),(24046,'98648','North Bonneville','',''),(24047,'98662','Five Corners','',''),(24048,'98663','Hazel Dell','',''),(24049,'98665','Five Corners','',''),(24050,'98665','Hazel Dell','',''),(24051,'98665','Salmon Creek','',''),(24052,'98671','Camas','',''),(24053,'98682','Camas','',''),(24054,'98682','Hockinson','',''),(24055,'98685','Salmon Creek','',''),(24056,'98686','Salmon Creek','',''),(24057,'98812','Pateros','',''),(24058,'98840','Malott','',''),(24059,'98848','George','',''),(24060,'98849','Omak','',''),(24061,'98901','Moxee','',''),(24062,'98901','Union Gap','',''),(24063,'98903','Union Gap','',''),(24064,'98922','Easton','',''),(24065,'98922','Roslyn','',''),(24066,'98922','South Cle Elum','',''),(24067,'98925','Roslyn','',''),(24068,'98926','Kittitas','',''),(24069,'98935','Grandview','',''),(24070,'98942','Yakima','',''),(24071,'98944','Richland','',''),(24072,'98951','Parker','',''),(24073,'98953','Buena','',''),(24074,'99011','Fairchild Afb','',''),(24075,'99012','Latah','',''),(24076,'99012','Waverly','',''),(24077,'99016','Liberty Lake','',''),(24078,'99016','Spokane Valley','',''),(24079,'99022','Airway Heights','',''),(24080,'99025','Otis Orchards-east Farms','',''),(24081,'99026','Spokane','',''),(24082,'99027','Otis Orchards-east Farms','',''),(24083,'99027','Spokane Valley','',''),(24084,'99037','Spokane Valley','',''),(24085,'99111','Steptoe','',''),(24086,'99116','Elmer City','',''),(24087,'99123','Grand Coulee','',''),(24088,'99126','Marcus','',''),(24089,'99133','Electric City','',''),(24090,'99163','Albion','',''),(24091,'99170','Malden','',''),(24092,'99171','St. John','',''),(24093,'99202','Spokane Valley','',''),(24094,'99206','Spokane Valley','',''),(24095,'99208','Fairwood','',''),(24096,'99208','Mead','',''),(24097,'99212','Spokane Valley','',''),(24098,'99216','Spokane Valley','',''),(24099,'99217','Mead','',''),(24100,'99218','Fairwood','',''),(24101,'99224','Airway Heights','',''),(24102,'99320','West Richland','',''),(24103,'99324','Walla Walla','',''),(24104,'99336','Richland','',''),(24105,'99338','Richland','',''),(24106,'99352','Kennewick','',''),(24107,'99352','West Richland','',''),(24108,'99353','Richland','',''),(24109,'99361','Dixie','',''),(24110,'99362','College Place','',''),(24111,'99403','Asotin','',''),(24112,'99505','Anchorage','',''),(24113,'99506','Anchorage','',''),(24114,'99510','Prudhoe Bay','',''),(24115,'99519','Prudhoe Bay','',''),(24116,'99540','Anchorage','',''),(24117,'99567','Anchorage','',''),(24118,'99568','Cohoe','',''),(24119,'99568','Ninilchik','',''),(24120,'99573','Kenny Lake','',''),(24121,'99576','Aleknagik','',''),(24122,'99577','Anchorage','',''),(24123,'99587','Anchorage','',''),(24124,'99591','St. George','',''),(24125,'99603','Anchor Point','',''),(24126,'99606','Newhalen','',''),(24127,'99607','Lower Kalskag','',''),(24128,'99607','Upper Kalskag','',''),(24129,'99610','Cohoe','',''),(24130,'99610','Kalifornsky','',''),(24131,'99611','Kalifornsky','',''),(24132,'99615','Larsen Bay','',''),(24133,'99627','Mcgrath','',''),(24134,'99633','King Salmon','',''),(24135,'99640','Newhalen','',''),(24136,'99645','Sutton-alpine','',''),(24137,'99652','Houston','',''),(24138,'99652','Willow','',''),(24139,'99654','Big Lake','',''),(24140,'99654','Houston','',''),(24141,'99654','Knik-fairview','',''),(24142,'99658','St. Marys','',''),(24143,'99659','St. Michael','',''),(24144,'99660','St. Paul','',''),(24145,'99664','Cooper Landing','',''),(24146,'99669','Cohoe','',''),(24147,'99669','Kalifornsky','',''),(24148,'99669','Sterling','',''),(24149,'99674','Sutton-alpine','',''),(24150,'99686','Whittier','',''),(24151,'99688','Big Lake','',''),(24152,'99688','Houston','',''),(24153,'99688','Trapper Creek','',''),(24154,'99692','Unalaska','',''),(24155,'99694','Willow','',''),(24156,'99703','Fairbanks','',''),(24157,'99704','Anderson','',''),(24158,'99705','Badger','',''),(24159,'99705','Eielson Afb','',''),(24160,'99705','Fairbanks','',''),(24161,'99705','Salcha','',''),(24162,'99709','College','',''),(24163,'99712','Badger','',''),(24164,'99712','Steele Creek','',''),(24165,'99714','Eielson Afb','',''),(24166,'99726','Evansville','',''),(24167,'99737','Deltana','',''),(24168,'99740','Arctic Village','',''),(24169,'99740','Chalkyitsik','',''),(24170,'99743','Anderson','',''),(24171,'99743','Cantwell','',''),(24172,'99743','Mckinley Park','',''),(24173,'99755','Cantwell','',''),(24174,'99755','Healy','',''),(24175,'99755','Mckinley Park','',''),(24176,'99760','Anderson','',''),(24177,'99760','Healy','',''),(24178,'99764','Northway Village','',''),(24179,'99775','College','',''),(24180,'99780','Tanacross','',''),(24181,'99781','Arctic Village','',''),(24182,'99790','Livengood','',''),(24183,'99801','Juneau City And','',''),(24184,'99824','Juneau City And','',''),(24185,'99825','Hoonah','',''),(24186,'99833','Kake','',''),(24187,'99835','Sitka City And','',''),(24188,'99903','Wrangell City And','',''),(24189,'99927','Port Protection','',''),(24190,'99929','Wrangell City And','','');
/*!40000 ALTER TABLE `zipcodealt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zones`
--

DROP TABLE IF EXISTS `zones`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `zones` (
  `zone_id` int(5) NOT NULL auto_increment,
  `zone_country_id` int(5) NOT NULL default '0',
  `zone_code` varchar(5) default NULL,
  `zone_name` varchar(32) default NULL,
  PRIMARY KEY  (`zone_id`)
) ENGINE=MyISAM AUTO_INCREMENT=79 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zones`
--

LOCK TABLES `zones` WRITE;
/*!40000 ALTER TABLE `zones` DISABLE KEYS */;
INSERT INTO `zones` VALUES (1,223,'AL','Alabama'),(2,223,'AK','Alaska'),(3,223,'AS','American Samoa'),(4,223,'AZ','Arizona'),(5,223,'AR','Arkansas'),(6,223,'AF','Armed Forces Africa'),(7,223,'AA','Armed Forces Americas'),(8,223,'AC','Armed Forces Canada'),(9,223,'AE','Armed Forces Europe'),(10,223,'AM','Armed Forces Middle East'),(11,223,'AP','Armed Forces Pacific'),(12,223,'CA','California'),(13,223,'CO','Colorado'),(14,223,'CT','Connecticut'),(15,223,'DE','Delaware'),(16,223,'DC','District of Columbia'),(17,223,'FM','Federated States Of Micronesia'),(18,223,'FL','Florida'),(19,223,'GA','Georgia'),(20,223,'GU','Guam'),(21,223,'HI','Hawaii'),(22,223,'ID','Idaho'),(23,223,'IL','Illinois'),(24,223,'IN','Indiana'),(25,223,'IA','Iowa'),(26,223,'KS','Kansas'),(27,223,'KY','Kentucky'),(28,223,'LA','Louisiana'),(29,223,'ME','Maine'),(30,223,'MH','Marshall Islands'),(31,223,'MD','Maryland'),(32,223,'MA','Massachusetts'),(33,223,'MI','Michigan'),(34,223,'MN','Minnesota'),(35,223,'MS','Mississippi'),(36,223,'MO','Missouri'),(37,223,'MT','Montana'),(38,223,'NE','Nebraska'),(39,223,'NV','Nevada'),(40,223,'NH','New Hampshire'),(41,223,'NJ','New Jersey'),(42,223,'NM','New Mexico'),(43,223,'NY','New York'),(44,223,'NC','North Carolina'),(45,223,'ND','North Dakota'),(46,223,'MP','Northern Mariana Islands'),(47,223,'OH','Ohio'),(48,223,'OK','Oklahoma'),(49,223,'OR','Oregon'),(50,223,'PW','Palau'),(51,223,'PA','Pennsylvania'),(52,223,'PR','Puerto Rico'),(53,223,'RI','Rhode Island'),(54,223,'SC','South Carolina'),(55,223,'SD','South Dakota'),(56,223,'TN','Tenessee'),(57,223,'TX','Texas'),(58,223,'UT','Utah'),(59,223,'VT','Vermont'),(60,223,'VI','Virgin Islands'),(61,223,'VA','Virginia'),(62,223,'WA','Washington'),(63,223,'WV','West Virginia'),(64,223,'WI','Wisconsin'),(65,223,'WY','Wyoming'),(66,38,'AB','Alberta'),(67,38,'BC','British Columbia'),(68,38,'MB','Manitoba'),(69,38,'NF','Newfoundland'),(70,38,'NB','New Brunswick'),(71,38,'NS','Nova Scotia'),(72,38,'NT','Northwest Territories'),(73,38,'NU','Nunavut'),(74,38,'ON','Ontario'),(75,38,'PE','Prince Edward Island'),(76,38,'QC','Quebec'),(77,38,'SK','Saskatchewan'),(78,38,'YT','Yukon Territory');
/*!40000 ALTER TABLE `zones` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Final view structure for view `zipcodeall`
--

/*!50001 DROP TABLE `zipcodeall`*/;
/*!50001 DROP VIEW IF EXISTS `zipcodeall`*/;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`ccf`@`localhost` SQL SECURITY DEFINER */
/*!50001 VIEW `zipcodeall` AS select `zipcode`.`zip` AS `zip`,`zipcode`.`city` AS `city`,`zipcode`.`county` AS `county`,`zipcode`.`state` AS `state` from `zipcode` union select distinct `za`.`zip` AS `zip`,`za`.`city` AS `city`,if(((`za`.`county` = _latin1'') and (`zc`.`zip` is not null)),`zc`.`county`,`za`.`county`) AS `county`,if(((`za`.`state` = _latin1'') and (`zc`.`zip` is not null)),`zc`.`state`,`za`.`state`) AS `state` from (`zipcodealt` `za` left join `zipcode` `zc` on((`za`.`zip` = `zc`.`zip`))) */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2019-08-19 12:15:43
